# !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
# This file is machine-generated by lib/unicore/mktables from the Unicode
# database, Version 12.1.0.  Any changes made here will be lost!

sub TODO_FAILING_BREAKS { 0 }

use strict;
use warnings;
no warnings 'experimental::uniprop_wildcards';

# Test qr/\X/ and the \p{} regular expression constructs.  This file is
# constructed by mktables from the tables it generates, so if mktables is
# buggy, this won't necessarily catch those bugs.  Tests are generated for all
# feasible properties; a few aren't currently feasible; see
# is_code_point_usable() in mktables for details.

# Standard test packages are not used because this manipulates SIG_WARN.  It
# exits 0 if every non-skipped test succeeded; -1 if any failed.

my $Tests = 0;
my $Fails = 0;

# loc_tools.pl requires this function to be defined
sub ok($@) {
    my ($pass, @msg) = @_;
    print "not " unless $pass;
    print "ok ";
    print ++$Tests;
    print " - ", join "", @msg if @msg;
    print "\n";
}

sub Expect($$$$) {
    my $expected = shift;
    my $ord = shift;
    my $regex  = shift;
    my $warning_type = shift;   # Type of warning message, like 'deprecated'
                                # or empty if none
    my $line   = (caller)[2];

    # Convert the code point to hex form
    my $string = sprintf "\"\\x{%04X}\"", $ord;

    my @tests = "";

    # The first time through, use all warnings.  If the input should generate
    # a warning, add another time through with them turned off
    push @tests, "no warnings '$warning_type';" if $warning_type;

    foreach my $no_warnings (@tests) {

        # Store any warning messages instead of outputting them
        local $SIG{__WARN__} = $SIG{__WARN__};
        my $warning_message;
        $SIG{__WARN__} = sub { $warning_message = $_[0] };

        $Tests++;

        # A string eval is needed because of the 'no warnings'.
        # Assumes no parentheses in the regular expression
        my $result = eval "$no_warnings
                            my \$RegObj = qr($regex);
                            $string =~ \$RegObj ? 1 : 0";
        if (not defined $result) {
            print "not ok $Tests - couldn't compile /$regex/; line $line: $@\n";
            $Fails++;
        }
        elsif ($result ^ $expected) {
            print "not ok $Tests - expected $expected but got $result for $string =~ qr/$regex/; line $line\n";
            $Fails++;
        }
        elsif ($warning_message) {
            if (! $warning_type || ($warning_type && $no_warnings)) {
                print "not ok $Tests - for qr/$regex/ did not expect warning message '$warning_message'; line $line\n";
                $Fails++;
            }
            else {
                print "ok $Tests - expected and got a warning message for qr/$regex/; line $line\n";
            }
        }
        elsif ($warning_type && ! $no_warnings) {
            print "not ok $Tests - for qr/$regex/ expected a $warning_type warning message, but got none; line $line\n";
            $Fails++;
        }
        else {
            print "ok $Tests - got $result for $string =~ qr/$regex/; line $line\n";
        }
    }
    return;
}

sub Error($) {
    my $regex  = shift;
    $Tests++;
    if (eval { 'x' =~ qr/$regex/; 1 }) {
        $Fails++;
        my $line = (caller)[2];
        print "not ok $Tests - re compiled ok, but expected error for qr/$regex/; line $line: $@\n";
    }
    else {
        my $line = (caller)[2];
        print "ok $Tests - got and expected error for qr/$regex/; line $line\n";
    }
    return;
}

# Break test files (e.g. GCBTest.txt) character that break allowed here
my $breakable_utf8 = my $breakable = chr(utf8::unicode_to_native(0xF7));
utf8::upgrade($breakable_utf8);

# Break test files (e.g. GCBTest.txt) character that indicates can't break
# here
my $nobreak_utf8 = my $nobreak = chr(utf8::unicode_to_native(0xD7));
utf8::upgrade($nobreak_utf8);

my $are_ctype_locales_available;
my $utf8_locale;
chdir 't' if -d 't';
eval { require "./loc_tools.pl" };
if (defined &locales_enabled) {
    $are_ctype_locales_available = locales_enabled('LC_CTYPE');
    if ($are_ctype_locales_available) {
        $utf8_locale = &find_utf8_ctype_locale;
    }
}

# Eval'd so can run on versions earlier than the property is available in
my $WB_Extend_or_Format_re = eval 'qr/[\p{WB=Extend}\p{WB=Format}\p{WB=ZWJ}]/';
if (! defined $WB_Extend_or_Format_re) {
    $WB_Extend_or_Format_re = eval 'qr/[\p{WB=Extend}\p{WB=Format}]/';
}

sub _test_break($$) {
    # Test various break property matches.  The 2nd parameter gives the
    # property name.  The input is a line from auxiliary/*Test.txt for the
    # given property.  Each such line is a sequence of Unicode (not native)
    # code points given by their hex numbers, separated by the two characters
    # defined just before this subroutine that indicate that either there can
    # or cannot be a break between the adjacent code points.  All these are
    # tested.
    #
    # For the gcb property extra tests are made.  if there isn't a break, that
    # means the sequence forms an extended grapheme cluster, which means that
    # \X should match the whole thing.  If there is a break, \X should stop
    # there.  This is all converted by this routine into a match: $string =~
    # /(\X)/, Each \X should match the next cluster; and that is what is
    # checked.

    my $template = shift;
    my $break_type = shift;

    my $line   = (caller 1)[2];   # Line number
    my $comment = "";

    if ($template =~ / ( .*? ) \s* \# (.*) /x) {
        $template = $1;
        $comment = $2;

        # Replace leading spaces with a single one.
        $comment =~ s/ ^ \s* / # /x;
    }

    # The line contains characters above the ASCII range, but in Latin1.  It
    # may or may not be in utf8, and if it is, it may or may not know it.  So,
    # convert these characters to 8 bits.  If knows is in utf8, simply
    # downgrade.
    if (utf8::is_utf8($template)) {
        utf8::downgrade($template);
    } else {

        # Otherwise, if it is in utf8, but doesn't know it, the next lines
        # convert the two problematic characters to their 8-bit equivalents.
        # If it isn't in utf8, they don't harm anything.
        use bytes;
        $template =~ s/$nobreak_utf8/$nobreak/g;
        $template =~ s/$breakable_utf8/$breakable/g;
    }

    # Perl customizes wb.  So change the official tests accordingly
    if ($break_type eq 'wb' && $WB_Extend_or_Format_re) {

        # Split into elements that alternate between code point and
        # break/no-break
        my @line = split / +/, $template;

        # Look at each code point and its following one
        for (my $i = 1; $i <  @line - 1 - 1; $i+=2) {

            # The customization only involves changing some breaks to
            # non-breaks.
            next if $line[$i+1] =~ /$nobreak/;

            my $lhs = chr utf8::unicode_to_native(hex $line[$i]);
            my $rhs = chr utf8::unicode_to_native(hex $line[$i+2]);

            # And it only affects adjacent space characters.
            next if $lhs !~ /\s/u;

            # But, we want to make sure to test spaces followed by a Extend
            # or Format.
            next if $rhs !~ /\s|$WB_Extend_or_Format_re/;

            # To test the customization, add some white-space before this to
            # create a span.  The $lhs white space may or may not be bound to
            # that span, and also with the $rhs.  If the $rhs is a binding
            # character, the $lhs is bound to it and not to the span, unless
            # $lhs is vertical space.  In all other cases, the $lhs is bound
            # to the span.  If the $rhs is white space, it is bound to the
            # $lhs
            my $bound;
            my $span;
            if ($rhs =~ /$WB_Extend_or_Format_re/) {
                if ($lhs =~ /\v/) {
                    $bound = $breakable;
                    $span = $nobreak;
                }
                else {
                    $bound = $nobreak;
                    $span = $breakable;
                }
            }
            else {
                $span = $nobreak;
                $bound = $nobreak;
            }

            splice @line, $i, 0, ( '0020', $nobreak, '0020', $span);
            $i += 4;
            $line[$i+1] = $bound;
        }
        $template = join " ", @line;
    }

    # The input is just the break/no-break symbols and sequences of Unicode
    # code points as hex digits separated by spaces for legibility. e.g.:
    # ÷ 0020 × 0308 ÷ 0020 ÷
    # Convert to native \x format
    $template =~ s/ \s* ( [[:xdigit:]]+ ) \s* /sprintf("\\x{%02X}", utf8::unicode_to_native(hex $1))/gex;
    $template =~ s/ \s* //gx;   # Probably the line above removed all spaces;
                                # but be sure

    # Make a copy of the input with the symbols replaced by \b{} and \B{} as
    # appropriate
    my $break_pattern = $template =~ s/ $breakable /\\b{$break_type}/grx;
    $break_pattern =~ s/ $nobreak /\\B{$break_type}/gx;

    my $display_string = $template =~ s/[$breakable$nobreak]//gr;
    my $string = eval "\"$display_string\"";

    # The remaining massaging of the input is for the \X tests.  Get rid of
    # the leading and trailing breakables
    $template =~ s/^ \s* $breakable \s* //x;
    $template =~ s/ \s* $breakable \s* $ //x;

    # Delete no-breaks
    $template =~ s/ \s* $nobreak \s* //xg;

    # Split the input into segments that are breakable between them.
    my @should_display = split /\s*$breakable\s*/, $template;
    my @should_match = map { eval "\"$_\"" } @should_display;

    # If a string can be represented in both non-ut8 and utf8, test both cases
    my $display_upgrade = "";
    UPGRADE:
    for my $to_upgrade (0 .. 1) {

        if ($to_upgrade) {

            # If already in utf8, would just be a repeat
            next UPGRADE if utf8::is_utf8($string);

            utf8::upgrade($string);
            $display_upgrade = " (utf8-upgraded)";
        }

        my @modifiers = qw(a aa d u i);
        if ($are_ctype_locales_available) {
            push @modifiers, "l$utf8_locale" if defined $utf8_locale;

            # The /l modifier has C after it to indicate the locale to try
            push @modifiers, "lC";
        }

        # Test for each of the regex modifiers.
        for my $modifier (@modifiers) {
            my $display_locale = "";

            # For /l, set the locale to what it says to.
            if ($modifier =~ / ^ l (.*) /x) {
                my $locale = $1;
                $display_locale = "(locale = $locale)";
                POSIX::setlocale(&POSIX::LC_CTYPE, $locale);
                $modifier = 'l';
            }

            no warnings qw(locale regexp surrogate);
            my $pattern = "(?$modifier:$break_pattern)";

            # Actually do the test
            my $matched_text;
            my $matched = $string =~ qr/$pattern/;
            if ($matched) {
                $matched_text = "matched";
            }
            else {
                $matched_text = "failed to match";
                print "not ";

                if (TODO_FAILING_BREAKS) {
                    $comment = " # $comment" unless $comment =~ / ^ \s* \# /x;
                    $comment =~ s/#/# TODO/;
                }
            }
            print "ok ", ++$Tests, " - \"$display_string\" $matched_text /$pattern/$display_upgrade; line $line $display_locale$comment\n";

            # Only print the comment on the first use of this line
            $comment = "";

            # Repeat with the first \B{} in the pattern.  This makes sure the
            # code in regexec.c:find_byclass() for \B gets executed
            if ($pattern =~ / ( .*? : ) .* ( \\B\{ .* ) /x) {
                my $B_pattern = "$1$2";
                $matched = $string =~ qr/$B_pattern/;
                print "not " unless $matched;
                $matched_text = ($matched) ? "matched" : "failed to match";
                print "ok ", ++$Tests, " - \"$display_string\" $matched_text /$B_pattern/$display_upgrade; line $line $display_locale";
                print " # TODO" if TODO_FAILING_BREAKS && ! $matched;
                print "\n";
            }
        }

        next if $break_type ne 'gcb';

        # Finally, do the \X match.
        my @matches = $string =~ /(\X)/g;

        # Look through each matched cluster to verify that it matches what we
        # expect.
        my $min = (@matches < @should_match) ? @matches : @should_match;
        for my $i (0 .. $min - 1) {
            $Tests++;
            if ($matches[$i] eq $should_match[$i]) {
                print "ok $Tests - ";
                if ($i == 0) {
                    print "In \"$display_string\" =~ /(\\X)/g, \\X #1";
                } else {
                    print "And \\X #", $i + 1,
                }
                print " correctly matched $should_display[$i]; line $line\n";
            } else {
                $matches[$i] = join("", map { sprintf "\\x{%04X}", ord $_ }
                                                    split "", $matches[$i]);
                print "not ok $Tests -";
                print " # TODO" if TODO_FAILING_BREAKS;
                print " In \"$display_string\" =~ /(\\X)/g, \\X #",
                    $i + 1,
                    " should have matched $should_display[$i]",
                    " but instead matched $matches[$i]",
                    ".  Abandoning rest of line $line\n";
                next UPGRADE;
            }
        }

        # And the number of matches should equal the number of expected matches.
        $Tests++;
        if (@matches == @should_match) {
            print "ok $Tests - Nothing was left over; line $line\n";
        } else {
            print "not ok $Tests - There were ", scalar @should_match, " \\X matches expected, but got ", scalar @matches, " instead; line $line";
            print " # TODO" if TODO_FAILING_BREAKS;
            print "\n";
        }
    }

    return;
}

sub Test_GCB($) {
    _test_break(shift, 'gcb');
}

sub Test_LB($) {
    _test_break(shift, 'lb');
}

sub Test_SB($) {
    _test_break(shift, 'sb');
}

sub Test_WB($) {
    _test_break(shift, 'wb');
}

sub Finished() {
    print "1..$Tests\n";
    exit($Fails ? -1 : 0);
}

if (!$::TESTCHUNK or $::TESTCHUNK == 1) {
    Error('\p{Script=InGreek}');    # Bug #69018
    Test_GCB("1100 $nobreak 1161");  # Bug #70940
    Expect(0, 0x2028, '\p{Print}', ""); # Bug # 71722
    Expect(0, 0x2029, '\p{Print}', ""); # Bug # 71722
    Expect(1, 0xFF10, '\p{XDigit}', ""); # Bug # 71726
    
    # Make sure this gets tested; it was not part of the official test suite at
    # the time this was added.  Note that this is as it would appear in the
    # official suite, and gets modified to check for the perl tailoring by
    # Test_WB()
    Test_WB("$breakable 0020 $breakable 0020 $breakable 0308 $breakable");
    Test_LB("$nobreak 200B $nobreak 0020 $nobreak 0020 $breakable 2060 $breakable");
    Error('\p{_perllb}');
    Error('\P{_perllb}');
    Error('\p{_perlscx}');
    Error('\P{_perlscx}');
    Error('\p{age}');
    Error('\P{age}');
    Error('\p{Age=_V1_1/a/}');
    Error('\P{Age=_V1_1/a/}');
    Expect(1, 65533, '\p{Age=:\AV1_1\z:}', "");;
    Expect(0, 65536, '\p{Age=:\AV1_1\z:}', "");;
    Expect(1, 65533, '\p{Age=v11}', "");
    Expect(0, 65533, '\p{^Age=v11}', "");
    Expect(0, 65533, '\P{Age=v11}', "");
    Expect(1, 65533, '\P{^Age=v11}', "");
    Expect(0, 65536, '\p{Age=v11}', "");
    Expect(1, 65536, '\p{^Age=v11}', "");
    Expect(1, 65536, '\P{Age=v11}', "");
    Expect(0, 65536, '\P{^Age=v11}', "");
    Expect(1, 65533, '\p{Age=:\Av11\z:}', "");;
    Expect(0, 65536, '\p{Age=:\Av11\z:}', "");;
    Expect(1, 65533, '\p{Age=	v1_1}', "");
    Expect(0, 65533, '\p{^Age=	v1_1}', "");
    Expect(0, 65533, '\P{Age=	v1_1}', "");
    Expect(1, 65533, '\P{^Age=	v1_1}', "");
    Expect(0, 65536, '\p{Age=	v1_1}', "");
    Expect(1, 65536, '\p{^Age=	v1_1}', "");
    Expect(1, 65536, '\P{Age=	v1_1}', "");
    Expect(0, 65536, '\P{^Age=	v1_1}', "");
    Error('\p{Is_Age=:=	 000000001.1}');
    Error('\P{Is_Age=:=	 000000001.1}');
    Expect(1, 65533, '\p{Is_Age=+0_1.1}', "");
    Expect(0, 65533, '\p{^Is_Age=+0_1.1}', "");
    Expect(0, 65533, '\P{Is_Age=+0_1.1}', "");
    Expect(1, 65533, '\P{^Is_Age=+0_1.1}', "");
    Expect(0, 65536, '\p{Is_Age=+0_1.1}', "");
    Expect(1, 65536, '\p{^Is_Age=+0_1.1}', "");
    Expect(1, 65536, '\P{Is_Age=+0_1.1}', "");
    Expect(0, 65536, '\P{^Is_Age=+0_1.1}', "");
    Error('\p{Age=		v10_0:=}');
    Error('\P{Age=		v10_0:=}');
    Expect(1, 191456, '\p{Age=:\AV10_0\z:}', "");;
    Expect(0, 191457, '\p{Age=:\AV10_0\z:}', "");;
    Expect(1, 191456, '\p{Age=v100}', "");
    Expect(0, 191456, '\p{^Age=v100}', "");
    Expect(0, 191456, '\P{Age=v100}', "");
    Expect(1, 191456, '\P{^Age=v100}', "");
    Expect(0, 191457, '\p{Age=v100}', "");
    Expect(1, 191457, '\p{^Age=v100}', "");
    Expect(1, 191457, '\P{Age=v100}', "");
    Expect(0, 191457, '\P{^Age=v100}', "");
    Expect(1, 191456, '\p{Age=:\Av100\z:}', "");;
    Expect(0, 191457, '\p{Age=:\Av100\z:}', "");;
    Expect(1, 191456, '\p{Age=	-V10_0}', "");
    Expect(0, 191456, '\p{^Age=	-V10_0}', "");
    Expect(0, 191456, '\P{Age=	-V10_0}', "");
    Expect(1, 191456, '\P{^Age=	-V10_0}', "");
    Expect(0, 191457, '\p{Age=	-V10_0}', "");
    Expect(1, 191457, '\p{^Age=	-V10_0}', "");
    Expect(1, 191457, '\P{Age=	-V10_0}', "");
    Expect(0, 191457, '\P{^Age=	-V10_0}', "");
    Error('\p{Is_Age:   __0_0_0_0_0_0_0010.0/a/}');
    Error('\P{Is_Age:   __0_0_0_0_0_0_0010.0/a/}');
    Expect(1, 191456, '\p{Is_Age=0000010.0}', "");
    Expect(0, 191456, '\p{^Is_Age=0000010.0}', "");
    Expect(0, 191456, '\P{Is_Age=0000010.0}', "");
    Expect(1, 191456, '\P{^Is_Age=0000010.0}', "");
    Expect(0, 191457, '\p{Is_Age=0000010.0}', "");
    Expect(1, 191457, '\p{^Is_Age=0000010.0}', "");
    Expect(1, 191457, '\P{Is_Age=0000010.0}', "");
    Expect(0, 191457, '\P{^Is_Age=0000010.0}', "");
    Error('\p{Age=/a/V11_0}');
    Error('\P{Age=/a/V11_0}');
    Expect(1, 129645, '\p{Age=:\AV11_0\z:}', "");;
    Expect(0, 129646, '\p{Age=:\AV11_0\z:}', "");;
    Expect(1, 129645, '\p{Age=v110}', "");
    Expect(0, 129645, '\p{^Age=v110}', "");
    Expect(0, 129645, '\P{Age=v110}', "");
    Expect(1, 129645, '\P{^Age=v110}', "");
    Expect(0, 129646, '\p{Age=v110}', "");
    Expect(1, 129646, '\p{^Age=v110}', "");
    Expect(1, 129646, '\P{Age=v110}', "");
    Expect(0, 129646, '\P{^Age=v110}', "");
    Expect(1, 129645, '\p{Age=:\Av110\z:}', "");;
    Expect(0, 129646, '\p{Age=:\Av110\z:}', "");;
    Expect(1, 129645, '\p{Age= _V11_0}', "");
    Expect(0, 129645, '\p{^Age= _V11_0}', "");
    Expect(0, 129645, '\P{Age= _V11_0}', "");
    Expect(1, 129645, '\P{^Age= _V11_0}', "");
    Expect(0, 129646, '\p{Age= _V11_0}', "");
    Expect(1, 129646, '\p{^Age= _V11_0}', "");
    Expect(1, 129646, '\P{Age= _V11_0}', "");
    Expect(0, 129646, '\P{^Age= _V11_0}', "");
    Error('\p{Is_Age=_ +0000011.0:=}');
    Error('\P{Is_Age=_ +0000011.0:=}');
    Expect(1, 129645, '\p{Is_Age=1_1.0}', "");
    Expect(0, 129645, '\p{^Is_Age=1_1.0}', "");
    Expect(0, 129645, '\P{Is_Age=1_1.0}', "");
    Expect(1, 129645, '\P{^Is_Age=1_1.0}', "");
    Expect(0, 129646, '\p{Is_Age=1_1.0}', "");
    Expect(1, 129646, '\p{^Is_Age=1_1.0}', "");
    Expect(1, 129646, '\P{Is_Age=1_1.0}', "");
    Expect(0, 129646, '\P{^Is_Age=1_1.0}', "");
    Error('\p{Age= V12_0:=}');
    Error('\P{Age= V12_0:=}');
    Expect(1, 129685, '\p{Age=:\AV12_0\z:}', "");;
    Expect(0, 129686, '\p{Age=:\AV12_0\z:}', "");;
    Expect(1, 129685, '\p{Age=v120}', "");
    Expect(0, 129685, '\p{^Age=v120}', "");
    Expect(0, 129685, '\P{Age=v120}', "");
    Expect(1, 129685, '\P{^Age=v120}', "");
    Expect(0, 129686, '\p{Age=v120}', "");
    Expect(1, 129686, '\p{^Age=v120}', "");
    Expect(1, 129686, '\P{Age=v120}', "");
    Expect(0, 129686, '\P{^Age=v120}', "");
    Expect(1, 129685, '\p{Age=:\Av120\z:}', "");;
    Expect(0, 129686, '\p{Age=:\Av120\z:}', "");;
    Expect(1, 129685, '\p{Age= _V12_0}', "");
    Expect(0, 129685, '\p{^Age= _V12_0}', "");
    Expect(0, 129685, '\P{Age= _V12_0}', "");
    Expect(1, 129685, '\P{^Age= _V12_0}', "");
    Expect(0, 129686, '\p{Age= _V12_0}', "");
    Expect(1, 129686, '\p{^Age= _V12_0}', "");
    Expect(1, 129686, '\P{Age= _V12_0}', "");
    Expect(0, 129686, '\P{^Age= _V12_0}', "");
    Error('\p{Is_Age=/a/		0000000012.0}');
    Error('\P{Is_Age=/a/		0000000012.0}');
    Expect(1, 129685, '\p{Is_Age=00_00_01_2.0}', "");
    Expect(0, 129685, '\p{^Is_Age=00_00_01_2.0}', "");
    Expect(0, 129685, '\P{Is_Age=00_00_01_2.0}', "");
    Expect(1, 129685, '\P{^Is_Age=00_00_01_2.0}', "");
    Expect(0, 129686, '\p{Is_Age=00_00_01_2.0}', "");
    Expect(1, 129686, '\p{^Is_Age=00_00_01_2.0}', "");
    Expect(1, 129686, '\P{Is_Age=00_00_01_2.0}', "");
    Expect(0, 129686, '\P{^Is_Age=00_00_01_2.0}', "");
    Error('\p{Age=_V12_1/a/}');
    Error('\P{Age=_V12_1/a/}');
    Expect(1, 13055, '\p{Age=:\AV12_1\z:}', "");;
    Expect(0, 13056, '\p{Age=:\AV12_1\z:}', "");;
    Expect(1, 13055, '\p{Age=v121}', "");
    Expect(0, 13055, '\p{^Age=v121}', "");
    Expect(0, 13055, '\P{Age=v121}', "");
    Expect(1, 13055, '\P{^Age=v121}', "");
    Expect(0, 13056, '\p{Age=v121}', "");
    Expect(1, 13056, '\p{^Age=v121}', "");
    Expect(1, 13056, '\P{Age=v121}', "");
    Expect(0, 13056, '\P{^Age=v121}', "");
    Expect(1, 13055, '\p{Age=:\Av121\z:}', "");;
    Expect(0, 13056, '\p{Age=:\Av121\z:}', "");;
    Expect(1, 13055, '\p{Age= 	V12_1}', "");
    Expect(0, 13055, '\p{^Age= 	V12_1}', "");
    Expect(0, 13055, '\P{Age= 	V12_1}', "");
    Expect(1, 13055, '\P{^Age= 	V12_1}', "");
    Expect(0, 13056, '\p{Age= 	V12_1}', "");
    Expect(1, 13056, '\p{^Age= 	V12_1}', "");
    Expect(1, 13056, '\P{Age= 	V12_1}', "");
    Expect(0, 13056, '\P{^Age= 	V12_1}', "");
    Error('\p{Is_Age=:=-+012.1}');
    Error('\P{Is_Age=:=-+012.1}');
    Expect(1, 13055, '\p{Is_Age=000000012.1}', "");
    Expect(0, 13055, '\p{^Is_Age=000000012.1}', "");
    Expect(0, 13055, '\P{Is_Age=000000012.1}', "");
    Expect(1, 13055, '\P{^Is_Age=000000012.1}', "");
    Expect(0, 13056, '\p{Is_Age=000000012.1}', "");
    Expect(1, 13056, '\p{^Is_Age=000000012.1}', "");
    Expect(1, 13056, '\P{Is_Age=000000012.1}', "");
    Expect(0, 13056, '\P{^Is_Age=000000012.1}', "");
    Error('\p{Age=--V2_0/a/}');
    Error('\P{Age=--V2_0/a/}');
    Expect(1, 983040, '\p{Age=:\AV2_0\z:}', "");;
    Expect(0, 983037, '\p{Age=:\AV2_0\z:}', "");;
    Expect(1, 983040, '\p{Age=v20}', "");
    Expect(0, 983040, '\p{^Age=v20}', "");
    Expect(0, 983040, '\P{Age=v20}', "");
    Expect(1, 983040, '\P{^Age=v20}', "");
    Expect(0, 983037, '\p{Age=v20}', "");
    Expect(1, 983037, '\p{^Age=v20}', "");
    Expect(1, 983037, '\P{Age=v20}', "");
    Expect(0, 983037, '\P{^Age=v20}', "");
    Expect(1, 983040, '\p{Age=:\Av20\z:}', "");;
    Expect(0, 983037, '\p{Age=:\Av20\z:}', "");;
    Expect(1, 983040, '\p{Age= V2_0}', "");
    Expect(0, 983040, '\p{^Age= V2_0}', "");
    Expect(0, 983040, '\P{Age= V2_0}', "");
    Expect(1, 983040, '\P{^Age= V2_0}', "");
    Expect(0, 983037, '\p{Age= V2_0}', "");
    Expect(1, 983037, '\p{^Age= V2_0}', "");
    Expect(1, 983037, '\P{Age= V2_0}', "");
    Expect(0, 983037, '\P{^Age= V2_0}', "");
    Error('\p{Is_Age=	0_2.0/a/}');
    Error('\P{Is_Age=	0_2.0/a/}');
    Expect(1, 983040, '\p{Is_Age=+0000002.0}', "");
    Expect(0, 983040, '\p{^Is_Age=+0000002.0}', "");
    Expect(0, 983040, '\P{Is_Age=+0000002.0}', "");
    Expect(1, 983040, '\P{^Is_Age=+0000002.0}', "");
    Expect(0, 983037, '\p{Is_Age=+0000002.0}', "");
    Expect(1, 983037, '\p{^Is_Age=+0000002.0}', "");
    Expect(1, 983037, '\P{Is_Age=+0000002.0}', "");
    Expect(0, 983037, '\P{^Is_Age=+0000002.0}', "");
    Error('\p{Age=	V2_1/a/}');
    Error('\P{Age=	V2_1/a/}');
    Expect(1, 65532, '\p{Age=:\AV2_1\z:}', "");;
    Expect(0, 65533, '\p{Age=:\AV2_1\z:}', "");;
    Expect(1, 65532, '\p{Age=v21}', "");
    Expect(0, 65532, '\p{^Age=v21}', "");
    Expect(0, 65532, '\P{Age=v21}', "");
    Expect(1, 65532, '\P{^Age=v21}', "");
    Expect(0, 65533, '\p{Age=v21}', "");
    Expect(1, 65533, '\p{^Age=v21}', "");
    Expect(1, 65533, '\P{Age=v21}', "");
    Expect(0, 65533, '\P{^Age=v21}', "");
    Expect(1, 65532, '\p{Age=:\Av21\z:}', "");;
    Expect(0, 65533, '\p{Age=:\Av21\z:}', "");;
    Expect(1, 65532, '\p{Age=  V2_1}', "");
    Expect(0, 65532, '\p{^Age=  V2_1}', "");
    Expect(0, 65532, '\P{Age=  V2_1}', "");
    Expect(1, 65532, '\P{^Age=  V2_1}', "");
    Expect(0, 65533, '\p{Age=  V2_1}', "");
    Expect(1, 65533, '\p{^Age=  V2_1}', "");
    Expect(1, 65533, '\P{Age=  V2_1}', "");
    Expect(0, 65533, '\P{^Age=  V2_1}', "");
    Error('\p{Is_Age=:=	-+0000002.1}');
    Error('\P{Is_Age=:=	-+0000002.1}');
    Expect(1, 65532, '\p{Is_Age=00_00_00_2.1}', "");
    Expect(0, 65532, '\p{^Is_Age=00_00_00_2.1}', "");
    Expect(0, 65532, '\P{Is_Age=00_00_00_2.1}', "");
    Expect(1, 65532, '\P{^Is_Age=00_00_00_2.1}', "");
    Expect(0, 65533, '\p{Is_Age=00_00_00_2.1}', "");
    Expect(1, 65533, '\p{^Is_Age=00_00_00_2.1}', "");
    Expect(1, 65533, '\P{Is_Age=00_00_00_2.1}', "");
    Expect(0, 65533, '\P{^Is_Age=00_00_00_2.1}', "");
    Error('\p{Age= :=V3_0}');
    Error('\P{Age= :=V3_0}');
    Expect(1, 65531, '\p{Age=:\AV3_0\z:}', "");;
    Expect(0, 65532, '\p{Age=:\AV3_0\z:}', "");;
    Expect(1, 65531, '\p{Age=v30}', "");
    Expect(0, 65531, '\p{^Age=v30}', "");
    Expect(0, 65531, '\P{Age=v30}', "");
    Expect(1, 65531, '\P{^Age=v30}', "");
    Expect(0, 65532, '\p{Age=v30}', "");
    Expect(1, 65532, '\p{^Age=v30}', "");
    Expect(1, 65532, '\P{Age=v30}', "");
    Expect(0, 65532, '\P{^Age=v30}', "");
    Expect(1, 65531, '\p{Age=:\Av30\z:}', "");;
    Expect(0, 65532, '\p{Age=:\Av30\z:}', "");;
    Expect(1, 65531, '\p{Age=V3_0}', "");
    Expect(0, 65531, '\p{^Age=V3_0}', "");
    Expect(0, 65531, '\P{Age=V3_0}', "");
    Expect(1, 65531, '\P{^Age=V3_0}', "");
    Expect(0, 65532, '\p{Age=V3_0}', "");
    Expect(1, 65532, '\p{^Age=V3_0}', "");
    Expect(1, 65532, '\P{Age=V3_0}', "");
    Expect(0, 65532, '\P{^Age=V3_0}', "");
    Error('\p{Is_Age=/a/ -+0000003.0}');
    Error('\P{Is_Age=/a/ -+0000003.0}');
    Expect(1, 65531, '\p{Is_Age=3.0}', "");
    Expect(0, 65531, '\p{^Is_Age=3.0}', "");
    Expect(0, 65531, '\P{Is_Age=3.0}', "");
    Expect(1, 65531, '\P{^Is_Age=3.0}', "");
    Expect(0, 65532, '\p{Is_Age=3.0}', "");
    Expect(1, 65532, '\p{^Is_Age=3.0}', "");
    Expect(1, 65532, '\P{Is_Age=3.0}', "");
    Expect(0, 65532, '\P{^Is_Age=3.0}', "");
    Error('\p{Age: := _V3_1}');
    Error('\P{Age: := _V3_1}');
    Expect(1, 917631, '\p{Age=:\AV3_1\z:}', "");;
    Expect(0, 917632, '\p{Age=:\AV3_1\z:}', "");;
    Expect(1, 917631, '\p{Age=v31}', "");
    Expect(0, 917631, '\p{^Age=v31}', "");
    Expect(0, 917631, '\P{Age=v31}', "");
    Expect(1, 917631, '\P{^Age=v31}', "");
    Expect(0, 917632, '\p{Age=v31}', "");
    Expect(1, 917632, '\p{^Age=v31}', "");
    Expect(1, 917632, '\P{Age=v31}', "");
    Expect(0, 917632, '\P{^Age=v31}', "");
    Expect(1, 917631, '\p{Age=:\Av31\z:}', "");;
    Expect(0, 917632, '\p{Age=:\Av31\z:}', "");;
    Expect(1, 917631, '\p{Age=	_V3_1}', "");
    Expect(0, 917631, '\p{^Age=	_V3_1}', "");
    Expect(0, 917631, '\P{Age=	_V3_1}', "");
    Expect(1, 917631, '\P{^Age=	_V3_1}', "");
    Expect(0, 917632, '\p{Age=	_V3_1}', "");
    Expect(1, 917632, '\p{^Age=	_V3_1}', "");
    Expect(1, 917632, '\P{Age=	_V3_1}', "");
    Expect(0, 917632, '\P{^Age=	_V3_1}', "");
    Error('\p{Is_Age=:=  003.1}');
    Error('\P{Is_Age=:=  003.1}');
    Expect(1, 917631, '\p{Is_Age=+003.1}', "");
    Expect(0, 917631, '\p{^Is_Age=+003.1}', "");
    Expect(0, 917631, '\P{Is_Age=+003.1}', "");
    Expect(1, 917631, '\P{^Is_Age=+003.1}', "");
    Expect(0, 917632, '\p{Is_Age=+003.1}', "");
    Expect(1, 917632, '\p{^Is_Age=+003.1}', "");
    Expect(1, 917632, '\P{Is_Age=+003.1}', "");
    Expect(0, 917632, '\P{^Is_Age=+003.1}', "");
    Error('\p{Age=-/a/v3_2}');
    Error('\P{Age=-/a/v3_2}');
    Expect(1, 65376, '\p{Age=:\AV3_2\z:}', "");;
    Expect(0, 65377, '\p{Age=:\AV3_2\z:}', "");;
    Expect(1, 65376, '\p{Age=v32}', "");
    Expect(0, 65376, '\p{^Age=v32}', "");
    Expect(0, 65376, '\P{Age=v32}', "");
    Expect(1, 65376, '\P{^Age=v32}', "");
    Expect(0, 65377, '\p{Age=v32}', "");
    Expect(1, 65377, '\p{^Age=v32}', "");
    Expect(1, 65377, '\P{Age=v32}', "");
    Expect(0, 65377, '\P{^Age=v32}', "");
    Expect(1, 65376, '\p{Age=:\Av32\z:}', "");;
    Expect(0, 65377, '\p{Age=:\Av32\z:}', "");;
    Expect(1, 65376, '\p{Age=	V3_2}', "");
    Expect(0, 65376, '\p{^Age=	V3_2}', "");
    Expect(0, 65376, '\P{Age=	V3_2}', "");
    Expect(1, 65376, '\P{^Age=	V3_2}', "");
    Expect(0, 65377, '\p{Age=	V3_2}', "");
    Expect(1, 65377, '\p{^Age=	V3_2}', "");
    Expect(1, 65377, '\P{Age=	V3_2}', "");
    Expect(0, 65377, '\P{^Age=	V3_2}', "");
    Error('\p{Is_Age=:= 3.2}');
    Error('\P{Is_Age=:= 3.2}');
    Expect(1, 65376, '\p{Is_Age=3.2}', "");
    Expect(0, 65376, '\p{^Is_Age=3.2}', "");
    Expect(0, 65376, '\P{Is_Age=3.2}', "");
    Expect(1, 65376, '\P{^Is_Age=3.2}', "");
    Expect(0, 65377, '\p{Is_Age=3.2}', "");
    Expect(1, 65377, '\p{^Is_Age=3.2}', "");
    Expect(1, 65377, '\P{Is_Age=3.2}', "");
    Expect(0, 65377, '\P{^Is_Age=3.2}', "");
    Error('\p{Age=-/a/V4_0}');
    Error('\P{Age=-/a/V4_0}');
    Expect(1, 917999, '\p{Age=:\AV4_0\z:}', "");;
    Expect(0, 918000, '\p{Age=:\AV4_0\z:}', "");;
    Expect(1, 917999, '\p{Age=v40}', "");
    Expect(0, 917999, '\p{^Age=v40}', "");
    Expect(0, 917999, '\P{Age=v40}', "");
    Expect(1, 917999, '\P{^Age=v40}', "");
    Expect(0, 918000, '\p{Age=v40}', "");
    Expect(1, 918000, '\p{^Age=v40}', "");
    Expect(1, 918000, '\P{Age=v40}', "");
    Expect(0, 918000, '\P{^Age=v40}', "");
    Expect(1, 917999, '\p{Age=:\Av40\z:}', "");;
    Expect(0, 918000, '\p{Age=:\Av40\z:}', "");;
    Expect(1, 917999, '\p{Age=		V4_0}', "");
    Expect(0, 917999, '\p{^Age=		V4_0}', "");
    Expect(0, 917999, '\P{Age=		V4_0}', "");
    Expect(1, 917999, '\P{^Age=		V4_0}', "");
    Expect(0, 918000, '\p{Age=		V4_0}', "");
    Expect(1, 918000, '\p{^Age=		V4_0}', "");
    Expect(1, 918000, '\P{Age=		V4_0}', "");
    Expect(0, 918000, '\P{^Age=		V4_0}', "");
    Error('\p{Is_Age=:=- 0004.0}');
    Error('\P{Is_Age=:=- 0004.0}');
    Expect(1, 917999, '\p{Is_Age=+000004.0}', "");
    Expect(0, 917999, '\p{^Is_Age=+000004.0}', "");
    Expect(0, 917999, '\P{Is_Age=+000004.0}', "");
    Expect(1, 917999, '\P{^Is_Age=+000004.0}', "");
    Expect(0, 918000, '\p{Is_Age=+000004.0}', "");
    Expect(1, 918000, '\p{^Is_Age=+000004.0}', "");
    Expect(1, 918000, '\P{Is_Age=+000004.0}', "");
    Expect(0, 918000, '\P{^Is_Age=+000004.0}', "");
    Error('\p{Age=/a/__V4_1}');
    Error('\P{Age=/a/__V4_1}');
    Expect(1, 120485, '\p{Age=:\AV4_1\z:}', "");;
    Expect(0, 120486, '\p{Age=:\AV4_1\z:}', "");;
    Expect(1, 120485, '\p{Age=v41}', "");
    Expect(0, 120485, '\p{^Age=v41}', "");
    Expect(0, 120485, '\P{Age=v41}', "");
    Expect(1, 120485, '\P{^Age=v41}', "");
    Expect(0, 120486, '\p{Age=v41}', "");
    Expect(1, 120486, '\p{^Age=v41}', "");
    Expect(1, 120486, '\P{Age=v41}', "");
    Expect(0, 120486, '\P{^Age=v41}', "");
    Expect(1, 120485, '\p{Age=:\Av41\z:}', "");;
    Expect(0, 120486, '\p{Age=:\Av41\z:}', "");;
    Expect(1, 120485, '\p{Age=_	v4_1}', "");
    Expect(0, 120485, '\p{^Age=_	v4_1}', "");
    Expect(0, 120485, '\P{Age=_	v4_1}', "");
    Expect(1, 120485, '\P{^Age=_	v4_1}', "");
    Expect(0, 120486, '\p{Age=_	v4_1}', "");
    Expect(1, 120486, '\p{^Age=_	v4_1}', "");
    Expect(1, 120486, '\P{Age=_	v4_1}', "");
    Expect(0, 120486, '\P{^Age=_	v4_1}', "");
    Error('\p{Is_Age=:=-	0_0_04.1}');
    Error('\P{Is_Age=:=-	0_0_04.1}');
    Expect(1, 120485, '\p{Is_Age=+0000_4.1}', "");
    Expect(0, 120485, '\p{^Is_Age=+0000_4.1}', "");
    Expect(0, 120485, '\P{Is_Age=+0000_4.1}', "");
    Expect(1, 120485, '\P{^Is_Age=+0000_4.1}', "");
    Expect(0, 120486, '\p{Is_Age=+0000_4.1}', "");
    Expect(1, 120486, '\p{^Is_Age=+0000_4.1}', "");
    Expect(1, 120486, '\P{Is_Age=+0000_4.1}', "");
    Expect(0, 120486, '\P{^Is_Age=+0000_4.1}', "");
    Error('\p{Age=:=V5_0}');
    Error('\P{Age=:=V5_0}');
    Expect(1, 120779, '\p{Age=:\AV5_0\z:}', "");;
    Expect(0, 120780, '\p{Age=:\AV5_0\z:}', "");;
    Expect(1, 120779, '\p{Age:	v50}', "");
    Expect(0, 120779, '\p{^Age:	v50}', "");
    Expect(0, 120779, '\P{Age:	v50}', "");
    Expect(1, 120779, '\P{^Age:	v50}', "");
    Expect(0, 120780, '\p{Age:	v50}', "");
    Expect(1, 120780, '\p{^Age:	v50}', "");
    Expect(1, 120780, '\P{Age:	v50}', "");
    Expect(0, 120780, '\P{^Age:	v50}', "");
    Expect(1, 120779, '\p{Age=:\Av50\z:}', "");;
    Expect(0, 120780, '\p{Age=:\Av50\z:}', "");;
    Expect(1, 120779, '\p{Age= -v5_0}', "");
    Expect(0, 120779, '\p{^Age= -v5_0}', "");
    Expect(0, 120779, '\P{Age= -v5_0}', "");
    Expect(1, 120779, '\P{^Age= -v5_0}', "");
    Expect(0, 120780, '\p{Age= -v5_0}', "");
    Expect(1, 120780, '\p{^Age= -v5_0}', "");
    Expect(1, 120780, '\P{Age= -v5_0}', "");
    Expect(0, 120780, '\P{^Age= -v5_0}', "");
    Error('\p{Is_Age=_0_5.0:=}');
    Error('\P{Is_Age=_0_5.0:=}');
    Expect(1, 120779, '\p{Is_Age=+00005.0}', "");
    Expect(0, 120779, '\p{^Is_Age=+00005.0}', "");
    Expect(0, 120779, '\P{Is_Age=+00005.0}', "");
    Expect(1, 120779, '\P{^Is_Age=+00005.0}', "");
    Expect(0, 120780, '\p{Is_Age=+00005.0}', "");
    Expect(1, 120780, '\p{^Is_Age=+00005.0}', "");
    Expect(1, 120780, '\P{Is_Age=+00005.0}', "");
    Expect(0, 120780, '\P{^Is_Age=+00005.0}', "");
    Error('\p{Age=:=_V5_1}');
    Error('\P{Age=:=_V5_1}');
    Expect(1, 127123, '\p{Age=:\AV5_1\z:}', "");;
    Expect(0, 127124, '\p{Age=:\AV5_1\z:}', "");;
    Expect(1, 127123, '\p{Age:	v51}', "");
    Expect(0, 127123, '\p{^Age:	v51}', "");
    Expect(0, 127123, '\P{Age:	v51}', "");
    Expect(1, 127123, '\P{^Age:	v51}', "");
    Expect(0, 127124, '\p{Age:	v51}', "");
    Expect(1, 127124, '\p{^Age:	v51}', "");
    Expect(1, 127124, '\P{Age:	v51}', "");
    Expect(0, 127124, '\P{^Age:	v51}', "");
    Expect(1, 127123, '\p{Age=:\Av51\z:}', "");;
    Expect(0, 127124, '\p{Age=:\Av51\z:}', "");;
    Expect(1, 127123, '\p{Age=		v5_1}', "");
    Expect(0, 127123, '\p{^Age=		v5_1}', "");
    Expect(0, 127123, '\P{Age=		v5_1}', "");
    Expect(1, 127123, '\P{^Age=		v5_1}', "");
    Expect(0, 127124, '\p{Age=		v5_1}', "");
    Expect(1, 127124, '\p{^Age=		v5_1}', "");
    Expect(1, 127124, '\P{Age=		v5_1}', "");
    Expect(0, 127124, '\P{^Age=		v5_1}', "");
    Error('\p{Is_Age=:=00_5.1}');
    Error('\P{Is_Age=:=00_5.1}');
    Expect(1, 127123, '\p{Is_Age=00_00_5.1}', "");
    Expect(0, 127123, '\p{^Is_Age=00_00_5.1}', "");
    Expect(0, 127123, '\P{Is_Age=00_00_5.1}', "");
    Expect(1, 127123, '\P{^Is_Age=00_00_5.1}', "");
    Expect(0, 127124, '\p{Is_Age=00_00_5.1}', "");
    Expect(1, 127124, '\p{^Is_Age=00_00_5.1}', "");
    Expect(1, 127124, '\P{Is_Age=00_00_5.1}', "");
    Expect(0, 127124, '\P{^Is_Age=00_00_5.1}', "");
    Error('\p{Age:/a/_V5_2}');
    Error('\P{Age:/a/_V5_2}');
    Expect(1, 177972, '\p{Age=:\AV5_2\z:}', "");;
    Expect(0, 177973, '\p{Age=:\AV5_2\z:}', "");;
    Expect(1, 177972, '\p{Age=v52}', "");
    Expect(0, 177972, '\p{^Age=v52}', "");
    Expect(0, 177972, '\P{Age=v52}', "");
    Expect(1, 177972, '\P{^Age=v52}', "");
    Expect(0, 177973, '\p{Age=v52}', "");
    Expect(1, 177973, '\p{^Age=v52}', "");
    Expect(1, 177973, '\P{Age=v52}', "");
    Expect(0, 177973, '\P{^Age=v52}', "");
    Expect(1, 177972, '\p{Age=:\Av52\z:}', "");;
    Expect(0, 177973, '\p{Age=:\Av52\z:}', "");;
    Expect(1, 177972, '\p{Age=	-V5_2}', "");
    Expect(0, 177972, '\p{^Age=	-V5_2}', "");
    Expect(0, 177972, '\P{Age=	-V5_2}', "");
    Expect(1, 177972, '\P{^Age=	-V5_2}', "");
    Expect(0, 177973, '\p{Age=	-V5_2}', "");
    Expect(1, 177973, '\p{^Age=	-V5_2}', "");
    Expect(1, 177973, '\P{Age=	-V5_2}', "");
    Expect(0, 177973, '\P{^Age=	-V5_2}', "");
    Error('\p{Is_Age=/a/-_+0_5.2}');
    Error('\P{Is_Age=/a/-_+0_5.2}');
    Expect(1, 177972, '\p{Is_Age=+00_00_00_005.2}', "");
    Expect(0, 177972, '\p{^Is_Age=+00_00_00_005.2}', "");
    Expect(0, 177972, '\P{Is_Age=+00_00_00_005.2}', "");
    Expect(1, 177972, '\P{^Is_Age=+00_00_00_005.2}', "");
    Expect(0, 177973, '\p{Is_Age=+00_00_00_005.2}', "");
    Expect(1, 177973, '\p{^Is_Age=+00_00_00_005.2}', "");
    Expect(1, 177973, '\P{Is_Age=+00_00_00_005.2}', "");
    Expect(0, 177973, '\P{^Is_Age=+00_00_00_005.2}', "");
    Error('\p{Age=V6_0:=}');
    Error('\P{Age=V6_0:=}');
    Expect(1, 178205, '\p{Age=:\AV6_0\z:}', "");;
    Expect(0, 178206, '\p{Age=:\AV6_0\z:}', "");;
    Expect(1, 178205, '\p{Age=v60}', "");
    Expect(0, 178205, '\p{^Age=v60}', "");
    Expect(0, 178205, '\P{Age=v60}', "");
    Expect(1, 178205, '\P{^Age=v60}', "");
    Expect(0, 178206, '\p{Age=v60}', "");
    Expect(1, 178206, '\p{^Age=v60}', "");
    Expect(1, 178206, '\P{Age=v60}', "");
    Expect(0, 178206, '\P{^Age=v60}', "");
    Expect(1, 178205, '\p{Age=:\Av60\z:}', "");;
    Expect(0, 178206, '\p{Age=:\Av60\z:}', "");;
    Expect(1, 178205, '\p{Age=	V6_0}', "");
    Expect(0, 178205, '\p{^Age=	V6_0}', "");
    Expect(0, 178205, '\P{Age=	V6_0}', "");
    Expect(1, 178205, '\P{^Age=	V6_0}', "");
    Expect(0, 178206, '\p{Age=	V6_0}', "");
    Expect(1, 178206, '\p{^Age=	V6_0}', "");
    Expect(1, 178206, '\P{Age=	V6_0}', "");
    Expect(0, 178206, '\P{^Age=	V6_0}', "");
    Error('\p{Is_Age=/a/		6.0}');
    Error('\P{Is_Age=/a/		6.0}');
    Expect(1, 178205, '\p{Is_Age=0_0_0_06.0}', "");
    Expect(0, 178205, '\p{^Is_Age=0_0_0_06.0}', "");
    Expect(0, 178205, '\P{Is_Age=0_0_0_06.0}', "");
    Expect(1, 178205, '\P{^Is_Age=0_0_0_06.0}', "");
    Expect(0, 178206, '\p{Is_Age=0_0_0_06.0}', "");
    Expect(1, 178206, '\p{^Is_Age=0_0_0_06.0}', "");
    Expect(1, 178206, '\P{Is_Age=0_0_0_06.0}', "");
    Expect(0, 178206, '\P{^Is_Age=0_0_0_06.0}', "");
    Error('\p{Age=	:=V6_1}');
    Error('\P{Age=	:=V6_1}');
    Expect(1, 128564, '\p{Age=:\AV6_1\z:}', "");;
    Expect(0, 128565, '\p{Age=:\AV6_1\z:}', "");;
    Expect(1, 128564, '\p{Age: v61}', "");
    Expect(0, 128564, '\p{^Age: v61}', "");
    Expect(0, 128564, '\P{Age: v61}', "");
    Expect(1, 128564, '\P{^Age: v61}', "");
    Expect(0, 128565, '\p{Age: v61}', "");
    Expect(1, 128565, '\p{^Age: v61}', "");
    Expect(1, 128565, '\P{Age: v61}', "");
    Expect(0, 128565, '\P{^Age: v61}', "");
    Expect(1, 128564, '\p{Age=:\Av61\z:}', "");;
    Expect(0, 128565, '\p{Age=:\Av61\z:}', "");;
    Expect(1, 128564, '\p{Age= _V6_1}', "");
    Expect(0, 128564, '\p{^Age= _V6_1}', "");
    Expect(0, 128564, '\P{Age= _V6_1}', "");
    Expect(1, 128564, '\P{^Age= _V6_1}', "");
    Expect(0, 128565, '\p{Age= _V6_1}', "");
    Expect(1, 128565, '\p{^Age= _V6_1}', "");
    Expect(1, 128565, '\P{Age= _V6_1}', "");
    Expect(0, 128565, '\P{^Age= _V6_1}', "");
    Error('\p{Is_Age=_+000006.1:=}');
    Error('\P{Is_Age=_+000006.1:=}');
    Expect(1, 128564, '\p{Is_Age=+0000000006.1}', "");
    Expect(0, 128564, '\p{^Is_Age=+0000000006.1}', "");
    Expect(0, 128564, '\P{Is_Age=+0000000006.1}', "");
    Expect(1, 128564, '\P{^Is_Age=+0000000006.1}', "");
    Expect(0, 128565, '\p{Is_Age=+0000000006.1}', "");
    Expect(1, 128565, '\p{^Is_Age=+0000000006.1}', "");
    Expect(1, 128565, '\P{Is_Age=+0000000006.1}', "");
    Expect(0, 128565, '\P{^Is_Age=+0000000006.1}', "");
    Error('\p{Age:		/a/V6_2}');
    Error('\P{Age:		/a/V6_2}');
    Expect(1, 8378, '\p{Age=:\AV6_2\z:}', "");;
    Expect(0, 8379, '\p{Age=:\AV6_2\z:}', "");;
    Expect(1, 8378, '\p{Age=v62}', "");
    Expect(0, 8378, '\p{^Age=v62}', "");
    Expect(0, 8378, '\P{Age=v62}', "");
    Expect(1, 8378, '\P{^Age=v62}', "");
    Expect(0, 8379, '\p{Age=v62}', "");
    Expect(1, 8379, '\p{^Age=v62}', "");
    Expect(1, 8379, '\P{Age=v62}', "");
    Expect(0, 8379, '\P{^Age=v62}', "");
    Expect(1, 8378, '\p{Age=:\Av62\z:}', "");;
    Expect(0, 8379, '\p{Age=:\Av62\z:}', "");;
    Expect(1, 8378, '\p{Age=_ v6_2}', "");
    Expect(0, 8378, '\p{^Age=_ v6_2}', "");
    Expect(0, 8378, '\P{Age=_ v6_2}', "");
    Expect(1, 8378, '\P{^Age=_ v6_2}', "");
    Expect(0, 8379, '\p{Age=_ v6_2}', "");
    Expect(1, 8379, '\p{^Age=_ v6_2}', "");
    Expect(1, 8379, '\P{Age=_ v6_2}', "");
    Expect(0, 8379, '\P{^Age=_ v6_2}', "");
    Error('\p{Is_Age=- +00_6.2:=}');
    Error('\P{Is_Age=- +00_6.2:=}');
    Expect(1, 8378, '\p{Is_Age:	0_6.2}', "");
    Expect(0, 8378, '\p{^Is_Age:	0_6.2}', "");
    Expect(0, 8378, '\P{Is_Age:	0_6.2}', "");
    Expect(1, 8378, '\P{^Is_Age:	0_6.2}', "");
    Expect(0, 8379, '\p{Is_Age:	0_6.2}', "");
    Expect(1, 8379, '\p{^Is_Age:	0_6.2}', "");
    Expect(1, 8379, '\P{Is_Age:	0_6.2}', "");
    Expect(0, 8379, '\P{^Is_Age:	0_6.2}', "");
    Error('\p{Age=/a/V6_3}');
    Error('\P{Age=/a/V6_3}');
    Expect(1, 8297, '\p{Age=:\AV6_3\z:}', "");;
    Expect(0, 8298, '\p{Age=:\AV6_3\z:}', "");;
    Expect(1, 8297, '\p{Age=v63}', "");
    Expect(0, 8297, '\p{^Age=v63}', "");
    Expect(0, 8297, '\P{Age=v63}', "");
    Expect(1, 8297, '\P{^Age=v63}', "");
    Expect(0, 8298, '\p{Age=v63}', "");
    Expect(1, 8298, '\p{^Age=v63}', "");
    Expect(1, 8298, '\P{Age=v63}', "");
    Expect(0, 8298, '\P{^Age=v63}', "");
    Expect(1, 8297, '\p{Age=:\Av63\z:}', "");;
    Expect(0, 8298, '\p{Age=:\Av63\z:}', "");;
    Expect(1, 8297, '\p{Age=_V6_3}', "");
    Expect(0, 8297, '\p{^Age=_V6_3}', "");
    Expect(0, 8297, '\P{Age=_V6_3}', "");
    Expect(1, 8297, '\P{^Age=_V6_3}', "");
    Expect(0, 8298, '\p{Age=_V6_3}', "");
    Expect(1, 8298, '\p{^Age=_V6_3}', "");
    Expect(1, 8298, '\P{Age=_V6_3}', "");
    Expect(0, 8298, '\P{^Age=_V6_3}', "");
    Error('\p{Is_Age= 00000000_6.3:=}');
    Error('\P{Is_Age= 00000000_6.3:=}');
    Expect(1, 8297, '\p{Is_Age=+0_6.3}', "");
    Expect(0, 8297, '\p{^Is_Age=+0_6.3}', "");
    Expect(0, 8297, '\P{Is_Age=+0_6.3}', "");
    Expect(1, 8297, '\P{^Is_Age=+0_6.3}', "");
    Expect(0, 8298, '\p{Is_Age=+0_6.3}', "");
    Expect(1, 8298, '\p{^Is_Age=+0_6.3}', "");
    Expect(1, 8298, '\P{Is_Age=+0_6.3}', "");
    Expect(0, 8298, '\P{^Is_Age=+0_6.3}', "");
    Error('\p{Age=:=_v7_0}');
    Error('\P{Age=:=_v7_0}');
    Expect(1, 129197, '\p{Age=:\AV7_0\z:}', "");;
    Expect(0, 129198, '\p{Age=:\AV7_0\z:}', "");;
    Expect(1, 129197, '\p{Age=v70}', "");
    Expect(0, 129197, '\p{^Age=v70}', "");
    Expect(0, 129197, '\P{Age=v70}', "");
    Expect(1, 129197, '\P{^Age=v70}', "");
    Expect(0, 129198, '\p{Age=v70}', "");
    Expect(1, 129198, '\p{^Age=v70}', "");
    Expect(1, 129198, '\P{Age=v70}', "");
    Expect(0, 129198, '\P{^Age=v70}', "");
    Expect(1, 129197, '\p{Age=:\Av70\z:}', "");;
    Expect(0, 129198, '\p{Age=:\Av70\z:}', "");;
    Expect(1, 129197, '\p{Age=-V7_0}', "");
    Expect(0, 129197, '\p{^Age=-V7_0}', "");
    Expect(0, 129197, '\P{Age=-V7_0}', "");
    Expect(1, 129197, '\P{^Age=-V7_0}', "");
    Expect(0, 129198, '\p{Age=-V7_0}', "");
    Expect(1, 129198, '\p{^Age=-V7_0}', "");
    Expect(1, 129198, '\P{Age=-V7_0}', "");
    Expect(0, 129198, '\P{^Age=-V7_0}', "");
    Error('\p{Is_Age=_	0_7.0/a/}');
    Error('\P{Is_Age=_	0_7.0/a/}');
    Expect(1, 129197, '\p{Is_Age=00_00_00_00_7.0}', "");
    Expect(0, 129197, '\p{^Is_Age=00_00_00_00_7.0}', "");
    Expect(0, 129197, '\P{Is_Age=00_00_00_00_7.0}', "");
    Expect(1, 129197, '\P{^Is_Age=00_00_00_00_7.0}', "");
    Expect(0, 129198, '\p{Is_Age=00_00_00_00_7.0}', "");
    Expect(1, 129198, '\p{^Is_Age=00_00_00_00_7.0}', "");
    Expect(1, 129198, '\P{Is_Age=00_00_00_00_7.0}', "");
    Expect(0, 129198, '\P{^Is_Age=00_00_00_00_7.0}', "");
    Error('\p{Age=-	v8_0/a/}');
    Error('\P{Age=-	v8_0/a/}');
    Expect(1, 183969, '\p{Age=:\AV8_0\z:}', "");;
    Expect(0, 183970, '\p{Age=:\AV8_0\z:}', "");;
    Expect(1, 183969, '\p{Age=v80}', "");
    Expect(0, 183969, '\p{^Age=v80}', "");
    Expect(0, 183969, '\P{Age=v80}', "");
    Expect(1, 183969, '\P{^Age=v80}', "");
    Expect(0, 183970, '\p{Age=v80}', "");
    Expect(1, 183970, '\p{^Age=v80}', "");
    Expect(1, 183970, '\P{Age=v80}', "");
    Expect(0, 183970, '\P{^Age=v80}', "");
    Expect(1, 183969, '\p{Age=:\Av80\z:}', "");;
    Expect(0, 183970, '\p{Age=:\Av80\z:}', "");;
    Expect(1, 183969, '\p{Age=  V8_0}', "");
    Expect(0, 183969, '\p{^Age=  V8_0}', "");
    Expect(0, 183969, '\P{Age=  V8_0}', "");
    Expect(1, 183969, '\P{^Age=  V8_0}', "");
    Expect(0, 183970, '\p{Age=  V8_0}', "");
    Expect(1, 183970, '\p{^Age=  V8_0}', "");
    Expect(1, 183970, '\P{Age=  V8_0}', "");
    Expect(0, 183970, '\P{^Age=  V8_0}', "");
    Error('\p{Is_Age=_/a/008.0}');
    Error('\P{Is_Age=_/a/008.0}');
    Expect(1, 183969, '\p{Is_Age=00000000_8.0}', "");
    Expect(0, 183969, '\p{^Is_Age=00000000_8.0}', "");
    Expect(0, 183969, '\P{Is_Age=00000000_8.0}', "");
    Expect(1, 183969, '\P{^Is_Age=00000000_8.0}', "");
    Expect(0, 183970, '\p{Is_Age=00000000_8.0}', "");
    Expect(1, 183970, '\p{^Is_Age=00000000_8.0}', "");
    Expect(1, 183970, '\P{Is_Age=00000000_8.0}', "");
    Expect(0, 183970, '\P{^Is_Age=00000000_8.0}', "");
    Error('\p{Age=/a/- V9_0}');
    Error('\P{Age=/a/- V9_0}');
    Expect(1, 129425, '\p{Age=:\AV9_0\z:}', "");;
    Expect(0, 129426, '\p{Age=:\AV9_0\z:}', "");;
    Expect(1, 129425, '\p{Age=v90}', "");
    Expect(0, 129425, '\p{^Age=v90}', "");
    Expect(0, 129425, '\P{Age=v90}', "");
    Expect(1, 129425, '\P{^Age=v90}', "");
    Expect(0, 129426, '\p{Age=v90}', "");
    Expect(1, 129426, '\p{^Age=v90}', "");
    Expect(1, 129426, '\P{Age=v90}', "");
    Expect(0, 129426, '\P{^Age=v90}', "");
    Expect(1, 129425, '\p{Age=:\Av90\z:}', "");;
    Expect(0, 129426, '\p{Age=:\Av90\z:}', "");;
    Expect(1, 129425, '\p{Age=_	v9_0}', "");
    Expect(0, 129425, '\p{^Age=_	v9_0}', "");
    Expect(0, 129425, '\P{Age=_	v9_0}', "");
    Expect(1, 129425, '\P{^Age=_	v9_0}', "");
    Expect(0, 129426, '\p{Age=_	v9_0}', "");
    Expect(1, 129426, '\p{^Age=_	v9_0}', "");
    Expect(1, 129426, '\P{Age=_	v9_0}', "");
    Expect(0, 129426, '\P{^Age=_	v9_0}', "");
    Error('\p{Is_Age=:= _0000009.0}');
    Error('\P{Is_Age=:= _0000009.0}');
    Expect(1, 129425, '\p{Is_Age=+0000_0000_09.0}', "");
    Expect(0, 129425, '\p{^Is_Age=+0000_0000_09.0}', "");
    Expect(0, 129425, '\P{Is_Age=+0000_0000_09.0}', "");
    Expect(1, 129425, '\P{^Is_Age=+0000_0000_09.0}', "");
    Expect(0, 129426, '\p{Is_Age=+0000_0000_09.0}', "");
    Expect(1, 129426, '\p{^Is_Age=+0000_0000_09.0}', "");
    Expect(1, 129426, '\P{Is_Age=+0000_0000_09.0}', "");
    Expect(0, 129426, '\P{^Is_Age=+0000_0000_09.0}', "");
    Error('\p{Age=/a/- unassigned}');
    Error('\P{Age=/a/- unassigned}');
    Expect(1, 983037, '\p{Age=:\AUnassigned\z:}', "");;
    Expect(0, 983040, '\p{Age=:\AUnassigned\z:}', "");;
    Expect(1, 983037, '\p{Age=unassigned}', "");
    Expect(0, 983037, '\p{^Age=unassigned}', "");
    Expect(0, 983037, '\P{Age=unassigned}', "");
    Expect(1, 983037, '\P{^Age=unassigned}', "");
    Expect(0, 983040, '\p{Age=unassigned}', "");
    Expect(1, 983040, '\p{^Age=unassigned}', "");
    Expect(1, 983040, '\P{Age=unassigned}', "");
    Expect(0, 983040, '\P{^Age=unassigned}', "");
    Expect(1, 983037, '\p{Age=:\Aunassigned\z:}', "");;
    Expect(0, 983040, '\p{Age=:\Aunassigned\z:}', "");;
    Expect(1, 983037, '\p{Age=  Unassigned}', "");
    Expect(0, 983037, '\p{^Age=  Unassigned}', "");
    Expect(0, 983037, '\P{Age=  Unassigned}', "");
    Expect(1, 983037, '\P{^Age=  Unassigned}', "");
    Expect(0, 983040, '\p{Age=  Unassigned}', "");
    Expect(1, 983040, '\p{^Age=  Unassigned}', "");
    Expect(1, 983040, '\P{Age=  Unassigned}', "");
    Expect(0, 983040, '\P{^Age=  Unassigned}', "");
    Error('\p{Is_Age=/a/	-na}');
    Error('\P{Is_Age=/a/	-na}');
    Expect(1, 983037, '\p{Is_Age=na}', "");
    Expect(0, 983037, '\p{^Is_Age=na}', "");
    Expect(0, 983037, '\P{Is_Age=na}', "");
    Expect(1, 983037, '\P{^Is_Age=na}', "");
    Expect(0, 983040, '\p{Is_Age=na}', "");
    Expect(1, 983040, '\p{^Is_Age=na}', "");
    Expect(1, 983040, '\P{Is_Age=na}', "");
    Expect(0, 983040, '\P{^Is_Age=na}', "");
    Expect(1, 983037, '\p{Is_Age=	NA}', "");
    Expect(0, 983037, '\p{^Is_Age=	NA}', "");
    Expect(0, 983037, '\P{Is_Age=	NA}', "");
    Expect(1, 983037, '\P{^Is_Age=	NA}', "");
    Expect(0, 983040, '\p{Is_Age=	NA}', "");
    Expect(1, 983040, '\p{^Is_Age=	NA}', "");
    Expect(1, 983040, '\P{Is_Age=	NA}', "");
    Expect(0, 983040, '\P{^Is_Age=	NA}', "");
    Error('\p{ASCII_Hex_Digit=_:=no}');
    Error('\P{ASCII_Hex_Digit=_:=no}');
    Expect(1, 103, '\p{ASCII_Hex_Digit=:\ANo\z:}', "");;
    Expect(0, 102, '\p{ASCII_Hex_Digit=:\ANo\z:}', "");;
    Expect(1, 103, '\p{ASCII_Hex_Digit=no}', "");
    Expect(0, 103, '\p{^ASCII_Hex_Digit=no}', "");
    Expect(0, 103, '\P{ASCII_Hex_Digit=no}', "");
    Expect(1, 103, '\P{^ASCII_Hex_Digit=no}', "");
    Expect(0, 102, '\p{ASCII_Hex_Digit=no}', "");
    Expect(1, 102, '\p{^ASCII_Hex_Digit=no}', "");
    Expect(1, 102, '\P{ASCII_Hex_Digit=no}', "");
    Expect(0, 102, '\P{^ASCII_Hex_Digit=no}', "");
    Expect(1, 103, '\p{ASCII_Hex_Digit=:\Ano\z:}', "");;
    Expect(0, 102, '\p{ASCII_Hex_Digit=:\Ano\z:}', "");;
    Expect(1, 103, '\p{ASCII_Hex_Digit=	-No}', "");
    Expect(0, 103, '\p{^ASCII_Hex_Digit=	-No}', "");
    Expect(0, 103, '\P{ASCII_Hex_Digit=	-No}', "");
    Expect(1, 103, '\P{^ASCII_Hex_Digit=	-No}', "");
    Expect(0, 102, '\p{ASCII_Hex_Digit=	-No}', "");
    Expect(1, 102, '\p{^ASCII_Hex_Digit=	-No}', "");
    Expect(1, 102, '\P{ASCII_Hex_Digit=	-No}', "");
    Expect(0, 102, '\P{^ASCII_Hex_Digit=	-No}', "");
    Error('\p{AHex=:=n}');
    Error('\P{AHex=:=n}');
    Expect(1, 103, '\p{AHex=:\AN\z:}', "");;
    Expect(0, 102, '\p{AHex=:\AN\z:}', "");;
    Expect(1, 103, '\p{AHex=n}', "");
    Expect(0, 103, '\p{^AHex=n}', "");
    Expect(0, 103, '\P{AHex=n}', "");
    Expect(1, 103, '\P{^AHex=n}', "");
    Expect(0, 102, '\p{AHex=n}', "");
    Expect(1, 102, '\p{^AHex=n}', "");
    Expect(1, 102, '\P{AHex=n}', "");
    Expect(0, 102, '\P{^AHex=n}', "");
    Expect(1, 103, '\p{AHex=:\An\z:}', "");;
    Expect(0, 102, '\p{AHex=:\An\z:}', "");;
    Expect(1, 103, '\p{AHex=-_N}', "");
    Expect(0, 103, '\p{^AHex=-_N}', "");
    Expect(0, 103, '\P{AHex=-_N}', "");
    Expect(1, 103, '\P{^AHex=-_N}', "");
    Expect(0, 102, '\p{AHex=-_N}', "");
    Expect(1, 102, '\p{^AHex=-_N}', "");
    Expect(1, 102, '\P{AHex=-_N}', "");
    Expect(0, 102, '\P{^AHex=-_N}', "");
    Error('\p{Is_ASCII_Hex_Digit=_	F:=}');
    Error('\P{Is_ASCII_Hex_Digit=_	F:=}');
    Expect(1, 103, '\p{Is_ASCII_Hex_Digit=f}', "");
    Expect(0, 103, '\p{^Is_ASCII_Hex_Digit=f}', "");
    Expect(0, 103, '\P{Is_ASCII_Hex_Digit=f}', "");
    Expect(1, 103, '\P{^Is_ASCII_Hex_Digit=f}', "");
    Expect(0, 102, '\p{Is_ASCII_Hex_Digit=f}', "");
    Expect(1, 102, '\p{^Is_ASCII_Hex_Digit=f}', "");
    Expect(1, 102, '\P{Is_ASCII_Hex_Digit=f}', "");
    Expect(0, 102, '\P{^Is_ASCII_Hex_Digit=f}', "");
    Expect(1, 103, '\p{Is_ASCII_Hex_Digit=-F}', "");
    Expect(0, 103, '\p{^Is_ASCII_Hex_Digit=-F}', "");
    Expect(0, 103, '\P{Is_ASCII_Hex_Digit=-F}', "");
    Expect(1, 103, '\P{^Is_ASCII_Hex_Digit=-F}', "");
    Expect(0, 102, '\p{Is_ASCII_Hex_Digit=-F}', "");
    Expect(1, 102, '\p{^Is_ASCII_Hex_Digit=-F}', "");
    Expect(1, 102, '\P{Is_ASCII_Hex_Digit=-F}', "");
    Expect(0, 102, '\P{^Is_ASCII_Hex_Digit=-F}', "");
    Error('\p{Is_AHex: -/a/False}');
    Error('\P{Is_AHex: -/a/False}');
    Expect(1, 103, '\p{Is_AHex=false}', "");
    Expect(0, 103, '\p{^Is_AHex=false}', "");
    Expect(0, 103, '\P{Is_AHex=false}', "");
    Expect(1, 103, '\P{^Is_AHex=false}', "");
    Expect(0, 102, '\p{Is_AHex=false}', "");
    Expect(1, 102, '\p{^Is_AHex=false}', "");
    Expect(1, 102, '\P{Is_AHex=false}', "");
    Expect(0, 102, '\P{^Is_AHex=false}', "");
    Expect(1, 103, '\p{Is_AHex= _false}', "");
    Expect(0, 103, '\p{^Is_AHex= _false}', "");
    Expect(0, 103, '\P{Is_AHex= _false}', "");
    Expect(1, 103, '\P{^Is_AHex= _false}', "");
    Expect(0, 102, '\p{Is_AHex= _false}', "");
    Expect(1, 102, '\p{^Is_AHex= _false}', "");
    Expect(1, 102, '\P{Is_AHex= _false}', "");
    Expect(0, 102, '\P{^Is_AHex= _false}', "");
    Error('\p{ASCII_Hex_Digit=:= -Yes}');
    Error('\P{ASCII_Hex_Digit=:= -Yes}');
    Expect(1, 102, '\p{ASCII_Hex_Digit=:\AYes\z:}', "");;
    Expect(0, 103, '\p{ASCII_Hex_Digit=:\AYes\z:}', "");;
    Expect(1, 102, '\p{ASCII_Hex_Digit=yes}', "");
    Expect(0, 102, '\p{^ASCII_Hex_Digit=yes}', "");
    Expect(0, 102, '\P{ASCII_Hex_Digit=yes}', "");
    Expect(1, 102, '\P{^ASCII_Hex_Digit=yes}', "");
    Expect(0, 103, '\p{ASCII_Hex_Digit=yes}', "");
    Expect(1, 103, '\p{^ASCII_Hex_Digit=yes}', "");
    Expect(1, 103, '\P{ASCII_Hex_Digit=yes}', "");
    Expect(0, 103, '\P{^ASCII_Hex_Digit=yes}', "");
    Expect(1, 102, '\p{ASCII_Hex_Digit=:\Ayes\z:}', "");;
    Expect(0, 103, '\p{ASCII_Hex_Digit=:\Ayes\z:}', "");;
    Expect(1, 102, '\p{ASCII_Hex_Digit=YES}', "");
    Expect(0, 102, '\p{^ASCII_Hex_Digit=YES}', "");
    Expect(0, 102, '\P{ASCII_Hex_Digit=YES}', "");
    Expect(1, 102, '\P{^ASCII_Hex_Digit=YES}', "");
    Expect(0, 103, '\p{ASCII_Hex_Digit=YES}', "");
    Expect(1, 103, '\p{^ASCII_Hex_Digit=YES}', "");
    Expect(1, 103, '\P{ASCII_Hex_Digit=YES}', "");
    Expect(0, 103, '\P{^ASCII_Hex_Digit=YES}', "");
    Error('\p{AHex=	-Y/a/}');
    Error('\P{AHex=	-Y/a/}');
    Expect(1, 102, '\p{AHex=:\AY\z:}', "");;
    Expect(0, 103, '\p{AHex=:\AY\z:}', "");;
    Expect(1, 102, '\p{AHex=y}', "");
    Expect(0, 102, '\p{^AHex=y}', "");
    Expect(0, 102, '\P{AHex=y}', "");
    Expect(1, 102, '\P{^AHex=y}', "");
    Expect(0, 103, '\p{AHex=y}', "");
    Expect(1, 103, '\p{^AHex=y}', "");
    Expect(1, 103, '\P{AHex=y}', "");
    Expect(0, 103, '\P{^AHex=y}', "");
    Expect(1, 102, '\p{AHex=:\Ay\z:}', "");;
    Expect(0, 103, '\p{AHex=:\Ay\z:}', "");;
    Expect(1, 102, '\p{AHex=	-y}', "");
    Expect(0, 102, '\p{^AHex=	-y}', "");
    Expect(0, 102, '\P{AHex=	-y}', "");
    Expect(1, 102, '\P{^AHex=	-y}', "");
    Expect(0, 103, '\p{AHex=	-y}', "");
    Expect(1, 103, '\p{^AHex=	-y}', "");
    Expect(1, 103, '\P{AHex=	-y}', "");
    Expect(0, 103, '\P{^AHex=	-y}', "");
    Error('\p{Is_ASCII_Hex_Digit=-	T:=}');
    Error('\P{Is_ASCII_Hex_Digit=-	T:=}');
    Expect(1, 102, '\p{Is_ASCII_Hex_Digit=t}', "");
    Expect(0, 102, '\p{^Is_ASCII_Hex_Digit=t}', "");
    Expect(0, 102, '\P{Is_ASCII_Hex_Digit=t}', "");
    Expect(1, 102, '\P{^Is_ASCII_Hex_Digit=t}', "");
    Expect(0, 103, '\p{Is_ASCII_Hex_Digit=t}', "");
    Expect(1, 103, '\p{^Is_ASCII_Hex_Digit=t}', "");
    Expect(1, 103, '\P{Is_ASCII_Hex_Digit=t}', "");
    Expect(0, 103, '\P{^Is_ASCII_Hex_Digit=t}', "");
    Expect(1, 102, '\p{Is_ASCII_Hex_Digit= 	T}', "");
    Expect(0, 102, '\p{^Is_ASCII_Hex_Digit= 	T}', "");
    Expect(0, 102, '\P{Is_ASCII_Hex_Digit= 	T}', "");
    Expect(1, 102, '\P{^Is_ASCII_Hex_Digit= 	T}', "");
    Expect(0, 103, '\p{Is_ASCII_Hex_Digit= 	T}', "");
    Expect(1, 103, '\p{^Is_ASCII_Hex_Digit= 	T}', "");
    Expect(1, 103, '\P{Is_ASCII_Hex_Digit= 	T}', "");
    Expect(0, 103, '\P{^Is_ASCII_Hex_Digit= 	T}', "");
    Error('\p{Is_AHex=_True:=}');
    Error('\P{Is_AHex=_True:=}');
    Expect(1, 102, '\p{Is_AHex=true}', "");
    Expect(0, 102, '\p{^Is_AHex=true}', "");
    Expect(0, 102, '\P{Is_AHex=true}', "");
    Expect(1, 102, '\P{^Is_AHex=true}', "");
    Expect(0, 103, '\p{Is_AHex=true}', "");
    Expect(1, 103, '\p{^Is_AHex=true}', "");
    Expect(1, 103, '\P{Is_AHex=true}', "");
    Expect(0, 103, '\P{^Is_AHex=true}', "");
    Expect(1, 102, '\p{Is_AHex=	 TRUE}', "");
    Expect(0, 102, '\p{^Is_AHex=	 TRUE}', "");
    Expect(0, 102, '\P{Is_AHex=	 TRUE}', "");
    Expect(1, 102, '\P{^Is_AHex=	 TRUE}', "");
    Expect(0, 103, '\p{Is_AHex=	 TRUE}', "");
    Expect(1, 103, '\p{^Is_AHex=	 TRUE}', "");
    Expect(1, 103, '\P{Is_AHex=	 TRUE}', "");
    Expect(0, 103, '\P{^Is_AHex=	 TRUE}', "");
    Error('\p{Alphabetic: _:=no}');
    Error('\P{Alphabetic: _:=no}');
    Expect(1, 195102, '\p{Alphabetic=:\ANo\z:}', "");;
    Expect(0, 195101, '\p{Alphabetic=:\ANo\z:}', "");;
    Expect(1, 195102, '\p{Alphabetic=no}', "");
    Expect(0, 195102, '\p{^Alphabetic=no}', "");
    Expect(0, 195102, '\P{Alphabetic=no}', "");
    Expect(1, 195102, '\P{^Alphabetic=no}', "");
    Expect(0, 195101, '\p{Alphabetic=no}', "");
    Expect(1, 195101, '\p{^Alphabetic=no}', "");
    Expect(1, 195101, '\P{Alphabetic=no}', "");
    Expect(0, 195101, '\P{^Alphabetic=no}', "");
    Expect(1, 195102, '\p{Alphabetic=:\Ano\z:}', "");;
    Expect(0, 195101, '\p{Alphabetic=:\Ano\z:}', "");;
    Expect(1, 195102, '\p{Alphabetic=_No}', "");
    Expect(0, 195102, '\p{^Alphabetic=_No}', "");
    Expect(0, 195102, '\P{Alphabetic=_No}', "");
    Expect(1, 195102, '\P{^Alphabetic=_No}', "");
    Expect(0, 195101, '\p{Alphabetic=_No}', "");
    Expect(1, 195101, '\p{^Alphabetic=_No}', "");
    Expect(1, 195101, '\P{Alphabetic=_No}', "");
    Expect(0, 195101, '\P{^Alphabetic=_No}', "");
    Error('\p{Alpha=-:=N}');
    Error('\P{Alpha=-:=N}');
    Expect(1, 195102, '\p{Alpha=:\AN\z:}', "");;
    Expect(0, 195101, '\p{Alpha=:\AN\z:}', "");;
    Expect(1, 195102, '\p{Alpha=n}', "");
    Expect(0, 195102, '\p{^Alpha=n}', "");
    Expect(0, 195102, '\P{Alpha=n}', "");
    Expect(1, 195102, '\P{^Alpha=n}', "");
    Expect(0, 195101, '\p{Alpha=n}', "");
    Expect(1, 195101, '\p{^Alpha=n}', "");
    Expect(1, 195101, '\P{Alpha=n}', "");
    Expect(0, 195101, '\P{^Alpha=n}', "");
    Expect(1, 195102, '\p{Alpha=:\An\z:}', "");;
    Expect(0, 195101, '\p{Alpha=:\An\z:}', "");;
    Expect(1, 195102, '\p{Alpha=		N}', "");
    Expect(0, 195102, '\p{^Alpha=		N}', "");
    Expect(0, 195102, '\P{Alpha=		N}', "");
    Expect(1, 195102, '\P{^Alpha=		N}', "");
    Expect(0, 195101, '\p{Alpha=		N}', "");
    Expect(1, 195101, '\p{^Alpha=		N}', "");
    Expect(1, 195101, '\P{Alpha=		N}', "");
    Expect(0, 195101, '\P{^Alpha=		N}', "");
    Error('\p{Is_Alphabetic:   _/a/F}');
    Error('\P{Is_Alphabetic:   _/a/F}');
    Expect(1, 195102, '\p{Is_Alphabetic:   f}', "");
    Expect(0, 195102, '\p{^Is_Alphabetic:   f}', "");
    Expect(0, 195102, '\P{Is_Alphabetic:   f}', "");
    Expect(1, 195102, '\P{^Is_Alphabetic:   f}', "");
    Expect(0, 195101, '\p{Is_Alphabetic:   f}', "");
    Expect(1, 195101, '\p{^Is_Alphabetic:   f}', "");
    Expect(1, 195101, '\P{Is_Alphabetic:   f}', "");
    Expect(0, 195101, '\P{^Is_Alphabetic:   f}', "");
    Expect(1, 195102, '\p{Is_Alphabetic=-F}', "");
    Expect(0, 195102, '\p{^Is_Alphabetic=-F}', "");
    Expect(0, 195102, '\P{Is_Alphabetic=-F}', "");
    Expect(1, 195102, '\P{^Is_Alphabetic=-F}', "");
    Expect(0, 195101, '\p{Is_Alphabetic=-F}', "");
    Expect(1, 195101, '\p{^Is_Alphabetic=-F}', "");
    Expect(1, 195101, '\P{Is_Alphabetic=-F}', "");
    Expect(0, 195101, '\P{^Is_Alphabetic=-F}', "");
    Error('\p{Is_Alpha=:=_ FALSE}');
    Error('\P{Is_Alpha=:=_ FALSE}');
    Expect(1, 195102, '\p{Is_Alpha=false}', "");
    Expect(0, 195102, '\p{^Is_Alpha=false}', "");
    Expect(0, 195102, '\P{Is_Alpha=false}', "");
    Expect(1, 195102, '\P{^Is_Alpha=false}', "");
    Expect(0, 195101, '\p{Is_Alpha=false}', "");
    Expect(1, 195101, '\p{^Is_Alpha=false}', "");
    Expect(1, 195101, '\P{Is_Alpha=false}', "");
    Expect(0, 195101, '\P{^Is_Alpha=false}', "");
    Expect(1, 195102, '\p{Is_Alpha=	False}', "");
    Expect(0, 195102, '\p{^Is_Alpha=	False}', "");
    Expect(0, 195102, '\P{Is_Alpha=	False}', "");
    Expect(1, 195102, '\P{^Is_Alpha=	False}', "");
    Expect(0, 195101, '\p{Is_Alpha=	False}', "");
    Expect(1, 195101, '\p{^Is_Alpha=	False}', "");
    Expect(1, 195101, '\P{Is_Alpha=	False}', "");
    Expect(0, 195101, '\P{^Is_Alpha=	False}', "");
    Error('\p{Alphabetic=	/a/YES}');
    Error('\P{Alphabetic=	/a/YES}');
    Expect(1, 195101, '\p{Alphabetic=:\AYes\z:}', "");;
    Expect(0, 195102, '\p{Alphabetic=:\AYes\z:}', "");;
    Expect(1, 195101, '\p{Alphabetic=yes}', "");
    Expect(0, 195101, '\p{^Alphabetic=yes}', "");
    Expect(0, 195101, '\P{Alphabetic=yes}', "");
    Expect(1, 195101, '\P{^Alphabetic=yes}', "");
    Expect(0, 195102, '\p{Alphabetic=yes}', "");
    Expect(1, 195102, '\p{^Alphabetic=yes}', "");
    Expect(1, 195102, '\P{Alphabetic=yes}', "");
    Expect(0, 195102, '\P{^Alphabetic=yes}', "");
    Expect(1, 195101, '\p{Alphabetic=:\Ayes\z:}', "");;
    Expect(0, 195102, '\p{Alphabetic=:\Ayes\z:}', "");;
    Expect(1, 195101, '\p{Alphabetic=		yes}', "");
    Expect(0, 195101, '\p{^Alphabetic=		yes}', "");
    Expect(0, 195101, '\P{Alphabetic=		yes}', "");
    Expect(1, 195101, '\P{^Alphabetic=		yes}', "");
    Expect(0, 195102, '\p{Alphabetic=		yes}', "");
    Expect(1, 195102, '\p{^Alphabetic=		yes}', "");
    Expect(1, 195102, '\P{Alphabetic=		yes}', "");
    Expect(0, 195102, '\P{^Alphabetic=		yes}', "");
    Error('\p{Alpha=:=__Y}');
    Error('\P{Alpha=:=__Y}');
    Expect(1, 195101, '\p{Alpha=:\AY\z:}', "");;
    Expect(0, 195102, '\p{Alpha=:\AY\z:}', "");;
    Expect(1, 195101, '\p{Alpha=y}', "");
    Expect(0, 195101, '\p{^Alpha=y}', "");
    Expect(0, 195101, '\P{Alpha=y}', "");
    Expect(1, 195101, '\P{^Alpha=y}', "");
    Expect(0, 195102, '\p{Alpha=y}', "");
    Expect(1, 195102, '\p{^Alpha=y}', "");
    Expect(1, 195102, '\P{Alpha=y}', "");
    Expect(0, 195102, '\P{^Alpha=y}', "");
    Expect(1, 195101, '\p{Alpha=:\Ay\z:}', "");;
    Expect(0, 195102, '\p{Alpha=:\Ay\z:}', "");;
    Expect(1, 195101, '\p{Alpha=-y}', "");
    Expect(0, 195101, '\p{^Alpha=-y}', "");
    Expect(0, 195101, '\P{Alpha=-y}', "");
    Expect(1, 195101, '\P{^Alpha=-y}', "");
    Expect(0, 195102, '\p{Alpha=-y}', "");
    Expect(1, 195102, '\p{^Alpha=-y}', "");
    Expect(1, 195102, '\P{Alpha=-y}', "");
    Expect(0, 195102, '\P{^Alpha=-y}', "");
    Error('\p{Is_Alphabetic=-	T:=}');
    Error('\P{Is_Alphabetic=-	T:=}');
    Expect(1, 195101, '\p{Is_Alphabetic=t}', "");
    Expect(0, 195101, '\p{^Is_Alphabetic=t}', "");
    Expect(0, 195101, '\P{Is_Alphabetic=t}', "");
    Expect(1, 195101, '\P{^Is_Alphabetic=t}', "");
    Expect(0, 195102, '\p{Is_Alphabetic=t}', "");
    Expect(1, 195102, '\p{^Is_Alphabetic=t}', "");
    Expect(1, 195102, '\P{Is_Alphabetic=t}', "");
    Expect(0, 195102, '\P{^Is_Alphabetic=t}', "");
    Expect(1, 195101, '\p{Is_Alphabetic=	-T}', "");
    Expect(0, 195101, '\p{^Is_Alphabetic=	-T}', "");
    Expect(0, 195101, '\P{Is_Alphabetic=	-T}', "");
    Expect(1, 195101, '\P{^Is_Alphabetic=	-T}', "");
    Expect(0, 195102, '\p{Is_Alphabetic=	-T}', "");
    Expect(1, 195102, '\p{^Is_Alphabetic=	-T}', "");
    Expect(1, 195102, '\P{Is_Alphabetic=	-T}', "");
    Expect(0, 195102, '\P{^Is_Alphabetic=	-T}', "");
    Error('\p{Is_Alpha=:= -TRUE}');
    Error('\P{Is_Alpha=:= -TRUE}');
    Expect(1, 195101, '\p{Is_Alpha=true}', "");
    Expect(0, 195101, '\p{^Is_Alpha=true}', "");
    Expect(0, 195101, '\P{Is_Alpha=true}', "");
    Expect(1, 195101, '\P{^Is_Alpha=true}', "");
    Expect(0, 195102, '\p{Is_Alpha=true}', "");
    Expect(1, 195102, '\p{^Is_Alpha=true}', "");
    Expect(1, 195102, '\P{Is_Alpha=true}', "");
    Expect(0, 195102, '\P{^Is_Alpha=true}', "");
    Expect(1, 195101, '\p{Is_Alpha=		True}', "");
    Expect(0, 195101, '\p{^Is_Alpha=		True}', "");
    Expect(0, 195101, '\P{Is_Alpha=		True}', "");
    Expect(1, 195101, '\P{^Is_Alpha=		True}', "");
    Expect(0, 195102, '\p{Is_Alpha=		True}', "");
    Expect(1, 195102, '\p{^Is_Alpha=		True}', "");
    Expect(1, 195102, '\P{Is_Alpha=		True}', "");
    Expect(0, 195102, '\P{^Is_Alpha=		True}', "");
    Error('\p{bidiclass}');
    Error('\P{bidiclass}');
    Error('\p{bc}');
    Error('\P{bc}');
    Error('\p{Bidi_Class:	 /a/Arabic_Letter}');
    Error('\P{Bidi_Class:	 /a/Arabic_Letter}');
    Expect(1, 126719, '\p{Bidi_Class=:\AArabic_Letter\z:}', "");;
    Expect(0, 126720, '\p{Bidi_Class=:\AArabic_Letter\z:}', "");;
    Expect(1, 126719, '\p{Bidi_Class=arabicletter}', "");
    Expect(0, 126719, '\p{^Bidi_Class=arabicletter}', "");
    Expect(0, 126719, '\P{Bidi_Class=arabicletter}', "");
    Expect(1, 126719, '\P{^Bidi_Class=arabicletter}', "");
    Expect(0, 126720, '\p{Bidi_Class=arabicletter}', "");
    Expect(1, 126720, '\p{^Bidi_Class=arabicletter}', "");
    Expect(1, 126720, '\P{Bidi_Class=arabicletter}', "");
    Expect(0, 126720, '\P{^Bidi_Class=arabicletter}', "");
    Expect(1, 126719, '\p{Bidi_Class=:\Aarabicletter\z:}', "");;
    Expect(0, 126720, '\p{Bidi_Class=:\Aarabicletter\z:}', "");;
    Expect(1, 126719, '\p{Bidi_Class=_-Arabic_Letter}', "");
    Expect(0, 126719, '\p{^Bidi_Class=_-Arabic_Letter}', "");
    Expect(0, 126719, '\P{Bidi_Class=_-Arabic_Letter}', "");
    Expect(1, 126719, '\P{^Bidi_Class=_-Arabic_Letter}', "");
    Expect(0, 126720, '\p{Bidi_Class=_-Arabic_Letter}', "");
    Expect(1, 126720, '\p{^Bidi_Class=_-Arabic_Letter}', "");
    Expect(1, 126720, '\P{Bidi_Class=_-Arabic_Letter}', "");
    Expect(0, 126720, '\P{^Bidi_Class=_-Arabic_Letter}', "");
    Error('\p{Bc=-AL/a/}');
    Error('\P{Bc=-AL/a/}');
    Expect(1, 126719, '\p{Bc=:\AAL\z:}', "");;
    Expect(0, 126720, '\p{Bc=:\AAL\z:}', "");;
    Expect(1, 126719, '\p{Bc=al}', "");
    Expect(0, 126719, '\p{^Bc=al}', "");
    Expect(0, 126719, '\P{Bc=al}', "");
    Expect(1, 126719, '\P{^Bc=al}', "");
    Expect(0, 126720, '\p{Bc=al}', "");
    Expect(1, 126720, '\p{^Bc=al}', "");
    Expect(1, 126720, '\P{Bc=al}', "");
    Expect(0, 126720, '\P{^Bc=al}', "");
    Expect(1, 126719, '\p{Bc=:\Aal\z:}', "");;
    Expect(0, 126720, '\p{Bc=:\Aal\z:}', "");;
    Expect(1, 126719, '\p{Bc=--al}', "");
    Expect(0, 126719, '\p{^Bc=--al}', "");
    Expect(0, 126719, '\P{Bc=--al}', "");
    Expect(1, 126719, '\P{^Bc=--al}', "");
    Expect(0, 126720, '\p{Bc=--al}', "");
    Expect(1, 126720, '\p{^Bc=--al}', "");
    Expect(1, 126720, '\P{Bc=--al}', "");
    Expect(0, 126720, '\P{^Bc=--al}', "");
    Error('\p{Is_Bidi_Class=/a/	arabic_Letter}');
    Error('\P{Is_Bidi_Class=/a/	arabic_Letter}');
    Expect(1, 126719, '\p{Is_Bidi_Class=arabicletter}', "");
    Expect(0, 126719, '\p{^Is_Bidi_Class=arabicletter}', "");
    Expect(0, 126719, '\P{Is_Bidi_Class=arabicletter}', "");
    Expect(1, 126719, '\P{^Is_Bidi_Class=arabicletter}', "");
    Expect(0, 126720, '\p{Is_Bidi_Class=arabicletter}', "");
    Expect(1, 126720, '\p{^Is_Bidi_Class=arabicletter}', "");
    Expect(1, 126720, '\P{Is_Bidi_Class=arabicletter}', "");
    Expect(0, 126720, '\P{^Is_Bidi_Class=arabicletter}', "");
    Expect(1, 126719, '\p{Is_Bidi_Class=-ARABIC_Letter}', "");
    Expect(0, 126719, '\p{^Is_Bidi_Class=-ARABIC_Letter}', "");
    Expect(0, 126719, '\P{Is_Bidi_Class=-ARABIC_Letter}', "");
    Expect(1, 126719, '\P{^Is_Bidi_Class=-ARABIC_Letter}', "");
    Expect(0, 126720, '\p{Is_Bidi_Class=-ARABIC_Letter}', "");
    Expect(1, 126720, '\p{^Is_Bidi_Class=-ARABIC_Letter}', "");
    Expect(1, 126720, '\P{Is_Bidi_Class=-ARABIC_Letter}', "");
    Expect(0, 126720, '\P{^Is_Bidi_Class=-ARABIC_Letter}', "");
    Error('\p{Is_Bc: -/a/AL}');
    Error('\P{Is_Bc: -/a/AL}');
    Expect(1, 126719, '\p{Is_Bc=al}', "");
    Expect(0, 126719, '\p{^Is_Bc=al}', "");
    Expect(0, 126719, '\P{Is_Bc=al}', "");
    Expect(1, 126719, '\P{^Is_Bc=al}', "");
    Expect(0, 126720, '\p{Is_Bc=al}', "");
    Expect(1, 126720, '\p{^Is_Bc=al}', "");
    Expect(1, 126720, '\P{Is_Bc=al}', "");
    Expect(0, 126720, '\P{^Is_Bc=al}', "");
    Expect(1, 126719, '\p{Is_Bc= _AL}', "");
    Expect(0, 126719, '\p{^Is_Bc= _AL}', "");
    Expect(0, 126719, '\P{Is_Bc= _AL}', "");
    Expect(1, 126719, '\P{^Is_Bc= _AL}', "");
    Expect(0, 126720, '\p{Is_Bc= _AL}', "");
    Expect(1, 126720, '\p{^Is_Bc= _AL}', "");
    Expect(1, 126720, '\P{Is_Bc= _AL}', "");
    Expect(0, 126720, '\P{^Is_Bc= _AL}', "");
    Error('\p{Bidi_Class=	 ARABIC_Number/a/}');
    Error('\P{Bidi_Class=	 ARABIC_Number/a/}');
    Expect(1, 69246, '\p{Bidi_Class=:\AArabic_Number\z:}', "");;
    Expect(0, 69247, '\p{Bidi_Class=:\AArabic_Number\z:}', "");;
    Expect(1, 69246, '\p{Bidi_Class=arabicnumber}', "");
    Expect(0, 69246, '\p{^Bidi_Class=arabicnumber}', "");
    Expect(0, 69246, '\P{Bidi_Class=arabicnumber}', "");
    Expect(1, 69246, '\P{^Bidi_Class=arabicnumber}', "");
    Expect(0, 69247, '\p{Bidi_Class=arabicnumber}', "");
    Expect(1, 69247, '\p{^Bidi_Class=arabicnumber}', "");
    Expect(1, 69247, '\P{Bidi_Class=arabicnumber}', "");
    Expect(0, 69247, '\P{^Bidi_Class=arabicnumber}', "");
    Expect(1, 69246, '\p{Bidi_Class=:\Aarabicnumber\z:}', "");;
    Expect(0, 69247, '\p{Bidi_Class=:\Aarabicnumber\z:}', "");;
    Expect(1, 69246, '\p{Bidi_Class=Arabic_NUMBER}', "");
    Expect(0, 69246, '\p{^Bidi_Class=Arabic_NUMBER}', "");
    Expect(0, 69246, '\P{Bidi_Class=Arabic_NUMBER}', "");
    Expect(1, 69246, '\P{^Bidi_Class=Arabic_NUMBER}', "");
    Expect(0, 69247, '\p{Bidi_Class=Arabic_NUMBER}', "");
    Expect(1, 69247, '\p{^Bidi_Class=Arabic_NUMBER}', "");
    Expect(1, 69247, '\P{Bidi_Class=Arabic_NUMBER}', "");
    Expect(0, 69247, '\P{^Bidi_Class=Arabic_NUMBER}', "");
    Error('\p{Bc=:= -AN}');
    Error('\P{Bc=:= -AN}');
    Expect(1, 69246, '\p{Bc=:\AAN\z:}', "");;
    Expect(0, 69247, '\p{Bc=:\AAN\z:}', "");;
    Expect(1, 69246, '\p{Bc=an}', "");
    Expect(0, 69246, '\p{^Bc=an}', "");
    Expect(0, 69246, '\P{Bc=an}', "");
    Expect(1, 69246, '\P{^Bc=an}', "");
    Expect(0, 69247, '\p{Bc=an}', "");
    Expect(1, 69247, '\p{^Bc=an}', "");
    Expect(1, 69247, '\P{Bc=an}', "");
    Expect(0, 69247, '\P{^Bc=an}', "");
    Expect(1, 69246, '\p{Bc=:\Aan\z:}', "");;
    Expect(0, 69247, '\p{Bc=:\Aan\z:}', "");;
    Expect(1, 69246, '\p{Bc=- an}', "");
    Expect(0, 69246, '\p{^Bc=- an}', "");
    Expect(0, 69246, '\P{Bc=- an}', "");
    Expect(1, 69246, '\P{^Bc=- an}', "");
    Expect(0, 69247, '\p{Bc=- an}', "");
    Expect(1, 69247, '\p{^Bc=- an}', "");
    Expect(1, 69247, '\P{Bc=- an}', "");
    Expect(0, 69247, '\P{^Bc=- an}', "");
    Error('\p{Is_Bidi_Class=_/a/arabic_number}');
    Error('\P{Is_Bidi_Class=_/a/arabic_number}');
    Expect(1, 69246, '\p{Is_Bidi_Class=arabicnumber}', "");
    Expect(0, 69246, '\p{^Is_Bidi_Class=arabicnumber}', "");
    Expect(0, 69246, '\P{Is_Bidi_Class=arabicnumber}', "");
    Expect(1, 69246, '\P{^Is_Bidi_Class=arabicnumber}', "");
    Expect(0, 69247, '\p{Is_Bidi_Class=arabicnumber}', "");
    Expect(1, 69247, '\p{^Is_Bidi_Class=arabicnumber}', "");
    Expect(1, 69247, '\P{Is_Bidi_Class=arabicnumber}', "");
    Expect(0, 69247, '\P{^Is_Bidi_Class=arabicnumber}', "");
    Expect(1, 69246, '\p{Is_Bidi_Class:  ARABIC_number}', "");
    Expect(0, 69246, '\p{^Is_Bidi_Class:  ARABIC_number}', "");
    Expect(0, 69246, '\P{Is_Bidi_Class:  ARABIC_number}', "");
    Expect(1, 69246, '\P{^Is_Bidi_Class:  ARABIC_number}', "");
    Expect(0, 69247, '\p{Is_Bidi_Class:  ARABIC_number}', "");
    Expect(1, 69247, '\p{^Is_Bidi_Class:  ARABIC_number}', "");
    Expect(1, 69247, '\P{Is_Bidi_Class:  ARABIC_number}', "");
    Expect(0, 69247, '\P{^Is_Bidi_Class:  ARABIC_number}', "");
    Error('\p{Is_Bc=:=-AN}');
    Error('\P{Is_Bc=:=-AN}');
    Expect(1, 69246, '\p{Is_Bc=an}', "");
    Expect(0, 69246, '\p{^Is_Bc=an}', "");
    Expect(0, 69246, '\P{Is_Bc=an}', "");
    Expect(1, 69246, '\P{^Is_Bc=an}', "");
    Expect(0, 69247, '\p{Is_Bc=an}', "");
    Expect(1, 69247, '\p{^Is_Bc=an}', "");
    Expect(1, 69247, '\P{Is_Bc=an}', "");
    Expect(0, 69247, '\P{^Is_Bc=an}', "");
    Expect(1, 69246, '\p{Is_Bc=-	AN}', "");
    Expect(0, 69246, '\p{^Is_Bc=-	AN}', "");
    Expect(0, 69246, '\P{Is_Bc=-	AN}', "");
    Expect(1, 69246, '\P{^Is_Bc=-	AN}', "");
    Expect(0, 69247, '\p{Is_Bc=-	AN}', "");
    Expect(1, 69247, '\p{^Is_Bc=-	AN}', "");
    Expect(1, 69247, '\P{Is_Bc=-	AN}', "");
    Expect(0, 69247, '\P{^Is_Bc=-	AN}', "");
    Error('\p{Bidi_Class=:= 	paragraph_Separator}');
    Error('\P{Bidi_Class=:= 	paragraph_Separator}');
    Expect(1, 8233, '\p{Bidi_Class=:\AParagraph_Separator\z:}', "");;
    Expect(0, 8234, '\p{Bidi_Class=:\AParagraph_Separator\z:}', "");;
    Expect(1, 8233, '\p{Bidi_Class=paragraphseparator}', "");
    Expect(0, 8233, '\p{^Bidi_Class=paragraphseparator}', "");
    Expect(0, 8233, '\P{Bidi_Class=paragraphseparator}', "");
    Expect(1, 8233, '\P{^Bidi_Class=paragraphseparator}', "");
    Expect(0, 8234, '\p{Bidi_Class=paragraphseparator}', "");
    Expect(1, 8234, '\p{^Bidi_Class=paragraphseparator}', "");
    Expect(1, 8234, '\P{Bidi_Class=paragraphseparator}', "");
    Expect(0, 8234, '\P{^Bidi_Class=paragraphseparator}', "");
    Expect(1, 8233, '\p{Bidi_Class=:\Aparagraphseparator\z:}', "");;
    Expect(0, 8234, '\p{Bidi_Class=:\Aparagraphseparator\z:}', "");;
    Expect(1, 8233, '\p{Bidi_Class:    	Paragraph_Separator}', "");
    Expect(0, 8233, '\p{^Bidi_Class:    	Paragraph_Separator}', "");
    Expect(0, 8233, '\P{Bidi_Class:    	Paragraph_Separator}', "");
    Expect(1, 8233, '\P{^Bidi_Class:    	Paragraph_Separator}', "");
    Expect(0, 8234, '\p{Bidi_Class:    	Paragraph_Separator}', "");
    Expect(1, 8234, '\p{^Bidi_Class:    	Paragraph_Separator}', "");
    Expect(1, 8234, '\P{Bidi_Class:    	Paragraph_Separator}', "");
    Expect(0, 8234, '\P{^Bidi_Class:    	Paragraph_Separator}', "");
    Error('\p{Bc=- B:=}');
    Error('\P{Bc=- B:=}');
    Expect(1, 8233, '\p{Bc=:\AB\z:}', "");;
    Expect(0, 8234, '\p{Bc=:\AB\z:}', "");;
    Expect(1, 8233, '\p{Bc=b}', "");
    Expect(0, 8233, '\p{^Bc=b}', "");
    Expect(0, 8233, '\P{Bc=b}', "");
    Expect(1, 8233, '\P{^Bc=b}', "");
    Expect(0, 8234, '\p{Bc=b}', "");
    Expect(1, 8234, '\p{^Bc=b}', "");
    Expect(1, 8234, '\P{Bc=b}', "");
    Expect(0, 8234, '\P{^Bc=b}', "");
    Expect(1, 8233, '\p{Bc=:\Ab\z:}', "");;
    Expect(0, 8234, '\p{Bc=:\Ab\z:}', "");;
    Expect(1, 8233, '\p{Bc=	 b}', "");
    Expect(0, 8233, '\p{^Bc=	 b}', "");
    Expect(0, 8233, '\P{Bc=	 b}', "");
    Expect(1, 8233, '\P{^Bc=	 b}', "");
    Expect(0, 8234, '\p{Bc=	 b}', "");
    Expect(1, 8234, '\p{^Bc=	 b}', "");
    Expect(1, 8234, '\P{Bc=	 b}', "");
    Expect(0, 8234, '\P{^Bc=	 b}', "");
    Error('\p{Is_Bidi_Class=:=__Paragraph_separator}');
    Error('\P{Is_Bidi_Class=:=__Paragraph_separator}');
    Expect(1, 8233, '\p{Is_Bidi_Class=paragraphseparator}', "");
    Expect(0, 8233, '\p{^Is_Bidi_Class=paragraphseparator}', "");
    Expect(0, 8233, '\P{Is_Bidi_Class=paragraphseparator}', "");
    Expect(1, 8233, '\P{^Is_Bidi_Class=paragraphseparator}', "");
    Expect(0, 8234, '\p{Is_Bidi_Class=paragraphseparator}', "");
    Expect(1, 8234, '\p{^Is_Bidi_Class=paragraphseparator}', "");
    Expect(1, 8234, '\P{Is_Bidi_Class=paragraphseparator}', "");
    Expect(0, 8234, '\P{^Is_Bidi_Class=paragraphseparator}', "");
    Expect(1, 8233, '\p{Is_Bidi_Class=		paragraph_SEPARATOR}', "");
    Expect(0, 8233, '\p{^Is_Bidi_Class=		paragraph_SEPARATOR}', "");
    Expect(0, 8233, '\P{Is_Bidi_Class=		paragraph_SEPARATOR}', "");
    Expect(1, 8233, '\P{^Is_Bidi_Class=		paragraph_SEPARATOR}', "");
    Expect(0, 8234, '\p{Is_Bidi_Class=		paragraph_SEPARATOR}', "");
    Expect(1, 8234, '\p{^Is_Bidi_Class=		paragraph_SEPARATOR}', "");
    Expect(1, 8234, '\P{Is_Bidi_Class=		paragraph_SEPARATOR}', "");
    Expect(0, 8234, '\P{^Is_Bidi_Class=		paragraph_SEPARATOR}', "");
    Error('\p{Is_Bc= b/a/}');
    Error('\P{Is_Bc= b/a/}');
    Expect(1, 8233, '\p{Is_Bc=b}', "");
    Expect(0, 8233, '\p{^Is_Bc=b}', "");
    Expect(0, 8233, '\P{Is_Bc=b}', "");
    Expect(1, 8233, '\P{^Is_Bc=b}', "");
    Expect(0, 8234, '\p{Is_Bc=b}', "");
    Expect(1, 8234, '\p{^Is_Bc=b}', "");
    Expect(1, 8234, '\P{Is_Bc=b}', "");
    Expect(0, 8234, '\P{^Is_Bc=b}', "");
    Expect(1, 8233, '\p{Is_Bc= 	B}', "");
    Expect(0, 8233, '\p{^Is_Bc= 	B}', "");
    Expect(0, 8233, '\P{Is_Bc= 	B}', "");
    Expect(1, 8233, '\P{^Is_Bc= 	B}', "");
    Expect(0, 8234, '\p{Is_Bc= 	B}', "");
    Expect(1, 8234, '\p{^Is_Bc= 	B}', "");
    Expect(1, 8234, '\P{Is_Bc= 	B}', "");
    Expect(0, 8234, '\P{^Is_Bc= 	B}', "");
    Error('\p{Bidi_Class= _Boundary_Neutral/a/}');
    Error('\P{Bidi_Class= _Boundary_Neutral/a/}');
    Expect(1, 921599, '\p{Bidi_Class=:\ABoundary_Neutral\z:}', "");;
    Expect(0, 1114109, '\p{Bidi_Class=:\ABoundary_Neutral\z:}', "");;
    Expect(1, 921599, '\p{Bidi_Class=boundaryneutral}', "");
    Expect(0, 921599, '\p{^Bidi_Class=boundaryneutral}', "");
    Expect(0, 921599, '\P{Bidi_Class=boundaryneutral}', "");
    Expect(1, 921599, '\P{^Bidi_Class=boundaryneutral}', "");
    Expect(0, 1114109, '\p{Bidi_Class=boundaryneutral}', "");
    Expect(1, 1114109, '\p{^Bidi_Class=boundaryneutral}', "");
    Expect(1, 1114109, '\P{Bidi_Class=boundaryneutral}', "");
    Expect(0, 1114109, '\P{^Bidi_Class=boundaryneutral}', "");
    Expect(1, 921599, '\p{Bidi_Class=:\Aboundaryneutral\z:}', "");;
    Expect(0, 1114109, '\p{Bidi_Class=:\Aboundaryneutral\z:}', "");;
    Expect(1, 921599, '\p{Bidi_Class=		Boundary_NEUTRAL}', "");
    Expect(0, 921599, '\p{^Bidi_Class=		Boundary_NEUTRAL}', "");
    Expect(0, 921599, '\P{Bidi_Class=		Boundary_NEUTRAL}', "");
    Expect(1, 921599, '\P{^Bidi_Class=		Boundary_NEUTRAL}', "");
    Expect(0, 1114109, '\p{Bidi_Class=		Boundary_NEUTRAL}', "");
    Expect(1, 1114109, '\p{^Bidi_Class=		Boundary_NEUTRAL}', "");
    Expect(1, 1114109, '\P{Bidi_Class=		Boundary_NEUTRAL}', "");
    Expect(0, 1114109, '\P{^Bidi_Class=		Boundary_NEUTRAL}', "");
    Error('\p{Bc=__BN:=}');
    Error('\P{Bc=__BN:=}');
    Expect(1, 921599, '\p{Bc=:\ABN\z:}', "");;
    Expect(0, 1114109, '\p{Bc=:\ABN\z:}', "");;
    Expect(1, 921599, '\p{Bc=bn}', "");
    Expect(0, 921599, '\p{^Bc=bn}', "");
    Expect(0, 921599, '\P{Bc=bn}', "");
    Expect(1, 921599, '\P{^Bc=bn}', "");
    Expect(0, 1114109, '\p{Bc=bn}', "");
    Expect(1, 1114109, '\p{^Bc=bn}', "");
    Expect(1, 1114109, '\P{Bc=bn}', "");
    Expect(0, 1114109, '\P{^Bc=bn}', "");
    Expect(1, 921599, '\p{Bc=:\Abn\z:}', "");;
    Expect(0, 1114109, '\p{Bc=:\Abn\z:}', "");;
    Expect(1, 921599, '\p{Bc:   _	BN}', "");
    Expect(0, 921599, '\p{^Bc:   _	BN}', "");
    Expect(0, 921599, '\P{Bc:   _	BN}', "");
    Expect(1, 921599, '\P{^Bc:   _	BN}', "");
    Expect(0, 1114109, '\p{Bc:   _	BN}', "");
    Expect(1, 1114109, '\p{^Bc:   _	BN}', "");
    Expect(1, 1114109, '\P{Bc:   _	BN}', "");
    Expect(0, 1114109, '\P{^Bc:   _	BN}', "");
    Error('\p{Is_Bidi_Class=/a/boundary_neutral}');
    Error('\P{Is_Bidi_Class=/a/boundary_neutral}');
    Expect(1, 921599, '\p{Is_Bidi_Class:boundaryneutral}', "");
    Expect(0, 921599, '\p{^Is_Bidi_Class:boundaryneutral}', "");
    Expect(0, 921599, '\P{Is_Bidi_Class:boundaryneutral}', "");
    Expect(1, 921599, '\P{^Is_Bidi_Class:boundaryneutral}', "");
    Expect(0, 1114109, '\p{Is_Bidi_Class:boundaryneutral}', "");
    Expect(1, 1114109, '\p{^Is_Bidi_Class:boundaryneutral}', "");
    Expect(1, 1114109, '\P{Is_Bidi_Class:boundaryneutral}', "");
    Expect(0, 1114109, '\P{^Is_Bidi_Class:boundaryneutral}', "");
    Expect(1, 921599, '\p{Is_Bidi_Class=_Boundary_NEUTRAL}', "");
    Expect(0, 921599, '\p{^Is_Bidi_Class=_Boundary_NEUTRAL}', "");
    Expect(0, 921599, '\P{Is_Bidi_Class=_Boundary_NEUTRAL}', "");
    Expect(1, 921599, '\P{^Is_Bidi_Class=_Boundary_NEUTRAL}', "");
    Expect(0, 1114109, '\p{Is_Bidi_Class=_Boundary_NEUTRAL}', "");
    Expect(1, 1114109, '\p{^Is_Bidi_Class=_Boundary_NEUTRAL}', "");
    Expect(1, 1114109, '\P{Is_Bidi_Class=_Boundary_NEUTRAL}', "");
    Expect(0, 1114109, '\P{^Is_Bidi_Class=_Boundary_NEUTRAL}', "");
    Error('\p{Is_Bc=_BN:=}');
    Error('\P{Is_Bc=_BN:=}');
    Expect(1, 921599, '\p{Is_Bc=bn}', "");
    Expect(0, 921599, '\p{^Is_Bc=bn}', "");
    Expect(0, 921599, '\P{Is_Bc=bn}', "");
    Expect(1, 921599, '\P{^Is_Bc=bn}', "");
    Expect(0, 1114109, '\p{Is_Bc=bn}', "");
    Expect(1, 1114109, '\p{^Is_Bc=bn}', "");
    Expect(1, 1114109, '\P{Is_Bc=bn}', "");
    Expect(0, 1114109, '\P{^Is_Bc=bn}', "");
    Expect(1, 921599, '\p{Is_Bc=- BN}', "");
    Expect(0, 921599, '\p{^Is_Bc=- BN}', "");
    Expect(0, 921599, '\P{Is_Bc=- BN}', "");
    Expect(1, 921599, '\P{^Is_Bc=- BN}', "");
    Expect(0, 1114109, '\p{Is_Bc=- BN}', "");
    Expect(1, 1114109, '\p{^Is_Bc=- BN}', "");
    Expect(1, 1114109, '\P{Is_Bc=- BN}', "");
    Expect(0, 1114109, '\P{^Is_Bc=- BN}', "");
    Error('\p{Bidi_Class=:=	common_separator}');
    Error('\P{Bidi_Class=:=	common_separator}');
    Expect(1, 65306, '\p{Bidi_Class=:\ACommon_Separator\z:}', "");;
    Expect(0, 65307, '\p{Bidi_Class=:\ACommon_Separator\z:}', "");;
    Expect(1, 65306, '\p{Bidi_Class:	commonseparator}', "");
    Expect(0, 65306, '\p{^Bidi_Class:	commonseparator}', "");
    Expect(0, 65306, '\P{Bidi_Class:	commonseparator}', "");
    Expect(1, 65306, '\P{^Bidi_Class:	commonseparator}', "");
    Expect(0, 65307, '\p{Bidi_Class:	commonseparator}', "");
    Expect(1, 65307, '\p{^Bidi_Class:	commonseparator}', "");
    Expect(1, 65307, '\P{Bidi_Class:	commonseparator}', "");
    Expect(0, 65307, '\P{^Bidi_Class:	commonseparator}', "");
    Expect(1, 65306, '\p{Bidi_Class=:\Acommonseparator\z:}', "");;
    Expect(0, 65307, '\p{Bidi_Class=:\Acommonseparator\z:}', "");;
    Expect(1, 65306, '\p{Bidi_Class=-_Common_Separator}', "");
    Expect(0, 65306, '\p{^Bidi_Class=-_Common_Separator}', "");
    Expect(0, 65306, '\P{Bidi_Class=-_Common_Separator}', "");
    Expect(1, 65306, '\P{^Bidi_Class=-_Common_Separator}', "");
    Expect(0, 65307, '\p{Bidi_Class=-_Common_Separator}', "");
    Expect(1, 65307, '\p{^Bidi_Class=-_Common_Separator}', "");
    Expect(1, 65307, '\P{Bidi_Class=-_Common_Separator}', "");
    Expect(0, 65307, '\P{^Bidi_Class=-_Common_Separator}', "");
    Error('\p{Bc= /a/CS}');
    Error('\P{Bc= /a/CS}');
    Expect(1, 65306, '\p{Bc=:\ACS\z:}', "");;
    Expect(0, 65307, '\p{Bc=:\ACS\z:}', "");;
    Expect(1, 65306, '\p{Bc=cs}', "");
    Expect(0, 65306, '\p{^Bc=cs}', "");
    Expect(0, 65306, '\P{Bc=cs}', "");
    Expect(1, 65306, '\P{^Bc=cs}', "");
    Expect(0, 65307, '\p{Bc=cs}', "");
    Expect(1, 65307, '\p{^Bc=cs}', "");
    Expect(1, 65307, '\P{Bc=cs}', "");
    Expect(0, 65307, '\P{^Bc=cs}', "");
    Expect(1, 65306, '\p{Bc=:\Acs\z:}', "");;
    Expect(0, 65307, '\p{Bc=:\Acs\z:}', "");;
    Expect(1, 65306, '\p{Bc:   _CS}', "");
    Expect(0, 65306, '\p{^Bc:   _CS}', "");
    Expect(0, 65306, '\P{Bc:   _CS}', "");
    Expect(1, 65306, '\P{^Bc:   _CS}', "");
    Expect(0, 65307, '\p{Bc:   _CS}', "");
    Expect(1, 65307, '\p{^Bc:   _CS}', "");
    Expect(1, 65307, '\P{Bc:   _CS}', "");
    Expect(0, 65307, '\P{^Bc:   _CS}', "");
    Error('\p{Is_Bidi_Class::=		Common_SEPARATOR}');
    Error('\P{Is_Bidi_Class::=		Common_SEPARATOR}');
    Expect(1, 65306, '\p{Is_Bidi_Class=commonseparator}', "");
    Expect(0, 65306, '\p{^Is_Bidi_Class=commonseparator}', "");
    Expect(0, 65306, '\P{Is_Bidi_Class=commonseparator}', "");
    Expect(1, 65306, '\P{^Is_Bidi_Class=commonseparator}', "");
    Expect(0, 65307, '\p{Is_Bidi_Class=commonseparator}', "");
    Expect(1, 65307, '\p{^Is_Bidi_Class=commonseparator}', "");
    Expect(1, 65307, '\P{Is_Bidi_Class=commonseparator}', "");
    Expect(0, 65307, '\P{^Is_Bidi_Class=commonseparator}', "");
    Expect(1, 65306, '\p{Is_Bidi_Class=	-common_Separator}', "");
    Expect(0, 65306, '\p{^Is_Bidi_Class=	-common_Separator}', "");
    Expect(0, 65306, '\P{Is_Bidi_Class=	-common_Separator}', "");
    Expect(1, 65306, '\P{^Is_Bidi_Class=	-common_Separator}', "");
    Expect(0, 65307, '\p{Is_Bidi_Class=	-common_Separator}', "");
    Expect(1, 65307, '\p{^Is_Bidi_Class=	-common_Separator}', "");
    Expect(1, 65307, '\P{Is_Bidi_Class=	-common_Separator}', "");
    Expect(0, 65307, '\P{^Is_Bidi_Class=	-common_Separator}', "");
    Error('\p{Is_Bc:   :=	CS}');
    Error('\P{Is_Bc:   :=	CS}');
    Expect(1, 65306, '\p{Is_Bc=cs}', "");
    Expect(0, 65306, '\p{^Is_Bc=cs}', "");
    Expect(0, 65306, '\P{Is_Bc=cs}', "");
    Expect(1, 65306, '\P{^Is_Bc=cs}', "");
    Expect(0, 65307, '\p{Is_Bc=cs}', "");
    Expect(1, 65307, '\p{^Is_Bc=cs}', "");
    Expect(1, 65307, '\P{Is_Bc=cs}', "");
    Expect(0, 65307, '\P{^Is_Bc=cs}', "");
    Expect(1, 65306, '\p{Is_Bc=-CS}', "");
    Expect(0, 65306, '\p{^Is_Bc=-CS}', "");
    Expect(0, 65306, '\P{Is_Bc=-CS}', "");
    Expect(1, 65306, '\P{^Is_Bc=-CS}', "");
    Expect(0, 65307, '\p{Is_Bc=-CS}', "");
    Expect(1, 65307, '\p{^Is_Bc=-CS}', "");
    Expect(1, 65307, '\P{Is_Bc=-CS}', "");
    Expect(0, 65307, '\P{^Is_Bc=-CS}', "");
    Error('\p{Bidi_Class=/a/ _European_number}');
    Error('\P{Bidi_Class=/a/ _European_number}');
    Expect(1, 127242, '\p{Bidi_Class=:\AEuropean_Number\z:}', "");;
    Expect(0, 127243, '\p{Bidi_Class=:\AEuropean_Number\z:}', "");;
    Expect(1, 127242, '\p{Bidi_Class=europeannumber}', "");
    Expect(0, 127242, '\p{^Bidi_Class=europeannumber}', "");
    Expect(0, 127242, '\P{Bidi_Class=europeannumber}', "");
    Expect(1, 127242, '\P{^Bidi_Class=europeannumber}', "");
    Expect(0, 127243, '\p{Bidi_Class=europeannumber}', "");
    Expect(1, 127243, '\p{^Bidi_Class=europeannumber}', "");
    Expect(1, 127243, '\P{Bidi_Class=europeannumber}', "");
    Expect(0, 127243, '\P{^Bidi_Class=europeannumber}', "");
    Expect(1, 127242, '\p{Bidi_Class=:\Aeuropeannumber\z:}', "");;
    Expect(0, 127243, '\p{Bidi_Class=:\Aeuropeannumber\z:}', "");;
    Expect(1, 127242, '\p{Bidi_Class=- European_number}', "");
    Expect(0, 127242, '\p{^Bidi_Class=- European_number}', "");
    Expect(0, 127242, '\P{Bidi_Class=- European_number}', "");
    Expect(1, 127242, '\P{^Bidi_Class=- European_number}', "");
    Expect(0, 127243, '\p{Bidi_Class=- European_number}', "");
    Expect(1, 127243, '\p{^Bidi_Class=- European_number}', "");
    Expect(1, 127243, '\P{Bidi_Class=- European_number}', "");
    Expect(0, 127243, '\P{^Bidi_Class=- European_number}', "");
    Error('\p{Bc=_EN:=}');
    Error('\P{Bc=_EN:=}');
    Expect(1, 127242, '\p{Bc=:\AEN\z:}', "");;
    Expect(0, 127243, '\p{Bc=:\AEN\z:}', "");;
    Expect(1, 127242, '\p{Bc=en}', "");
    Expect(0, 127242, '\p{^Bc=en}', "");
    Expect(0, 127242, '\P{Bc=en}', "");
    Expect(1, 127242, '\P{^Bc=en}', "");
    Expect(0, 127243, '\p{Bc=en}', "");
    Expect(1, 127243, '\p{^Bc=en}', "");
    Expect(1, 127243, '\P{Bc=en}', "");
    Expect(0, 127243, '\P{^Bc=en}', "");
    Expect(1, 127242, '\p{Bc=:\Aen\z:}', "");;
    Expect(0, 127243, '\p{Bc=:\Aen\z:}', "");;
    Expect(1, 127242, '\p{Bc=_en}', "");
    Expect(0, 127242, '\p{^Bc=_en}', "");
    Expect(0, 127242, '\P{Bc=_en}', "");
    Expect(1, 127242, '\P{^Bc=_en}', "");
    Expect(0, 127243, '\p{Bc=_en}', "");
    Expect(1, 127243, '\p{^Bc=_en}', "");
    Expect(1, 127243, '\P{Bc=_en}', "");
    Expect(0, 127243, '\P{^Bc=_en}', "");
    Error('\p{Is_Bidi_Class=-/a/European_NUMBER}');
    Error('\P{Is_Bidi_Class=-/a/European_NUMBER}');
    Expect(1, 127242, '\p{Is_Bidi_Class=europeannumber}', "");
    Expect(0, 127242, '\p{^Is_Bidi_Class=europeannumber}', "");
    Expect(0, 127242, '\P{Is_Bidi_Class=europeannumber}', "");
    Expect(1, 127242, '\P{^Is_Bidi_Class=europeannumber}', "");
    Expect(0, 127243, '\p{Is_Bidi_Class=europeannumber}', "");
    Expect(1, 127243, '\p{^Is_Bidi_Class=europeannumber}', "");
    Expect(1, 127243, '\P{Is_Bidi_Class=europeannumber}', "");
    Expect(0, 127243, '\P{^Is_Bidi_Class=europeannumber}', "");
    Expect(1, 127242, '\p{Is_Bidi_Class=_-EUROPEAN_Number}', "");
    Expect(0, 127242, '\p{^Is_Bidi_Class=_-EUROPEAN_Number}', "");
    Expect(0, 127242, '\P{Is_Bidi_Class=_-EUROPEAN_Number}', "");
    Expect(1, 127242, '\P{^Is_Bidi_Class=_-EUROPEAN_Number}', "");
    Expect(0, 127243, '\p{Is_Bidi_Class=_-EUROPEAN_Number}', "");
    Expect(1, 127243, '\p{^Is_Bidi_Class=_-EUROPEAN_Number}', "");
    Expect(1, 127243, '\P{Is_Bidi_Class=_-EUROPEAN_Number}', "");
    Expect(0, 127243, '\P{^Is_Bidi_Class=_-EUROPEAN_Number}', "");
    Error('\p{Is_Bc=--en/a/}');
    Error('\P{Is_Bc=--en/a/}');
    Expect(1, 127242, '\p{Is_Bc=en}', "");
    Expect(0, 127242, '\p{^Is_Bc=en}', "");
    Expect(0, 127242, '\P{Is_Bc=en}', "");
    Expect(1, 127242, '\P{^Is_Bc=en}', "");
    Expect(0, 127243, '\p{Is_Bc=en}', "");
    Expect(1, 127243, '\p{^Is_Bc=en}', "");
    Expect(1, 127243, '\P{Is_Bc=en}', "");
    Expect(0, 127243, '\P{^Is_Bc=en}', "");
    Expect(1, 127242, '\p{Is_Bc=	EN}', "");
    Expect(0, 127242, '\p{^Is_Bc=	EN}', "");
    Expect(0, 127242, '\P{Is_Bc=	EN}', "");
    Expect(1, 127242, '\P{^Is_Bc=	EN}', "");
    Expect(0, 127243, '\p{Is_Bc=	EN}', "");
    Expect(1, 127243, '\p{^Is_Bc=	EN}', "");
    Expect(1, 127243, '\P{Is_Bc=	EN}', "");
    Expect(0, 127243, '\P{^Is_Bc=	EN}', "");
    Error('\p{Bidi_Class=	-European_separator:=}');
    Error('\P{Bidi_Class=	-European_separator:=}');
    Expect(1, 65293, '\p{Bidi_Class=:\AEuropean_Separator\z:}', "");;
    Expect(0, 65294, '\p{Bidi_Class=:\AEuropean_Separator\z:}', "");;
    Expect(1, 65293, '\p{Bidi_Class:europeanseparator}', "");
    Expect(0, 65293, '\p{^Bidi_Class:europeanseparator}', "");
    Expect(0, 65293, '\P{Bidi_Class:europeanseparator}', "");
    Expect(1, 65293, '\P{^Bidi_Class:europeanseparator}', "");
    Expect(0, 65294, '\p{Bidi_Class:europeanseparator}', "");
    Expect(1, 65294, '\p{^Bidi_Class:europeanseparator}', "");
    Expect(1, 65294, '\P{Bidi_Class:europeanseparator}', "");
    Expect(0, 65294, '\P{^Bidi_Class:europeanseparator}', "");
    Expect(1, 65293, '\p{Bidi_Class=:\Aeuropeanseparator\z:}', "");;
    Expect(0, 65294, '\p{Bidi_Class=:\Aeuropeanseparator\z:}', "");;
    Expect(1, 65293, '\p{Bidi_Class=- European_Separator}', "");
    Expect(0, 65293, '\p{^Bidi_Class=- European_Separator}', "");
    Expect(0, 65293, '\P{Bidi_Class=- European_Separator}', "");
    Expect(1, 65293, '\P{^Bidi_Class=- European_Separator}', "");
    Expect(0, 65294, '\p{Bidi_Class=- European_Separator}', "");
    Expect(1, 65294, '\p{^Bidi_Class=- European_Separator}', "");
    Expect(1, 65294, '\P{Bidi_Class=- European_Separator}', "");
    Expect(0, 65294, '\P{^Bidi_Class=- European_Separator}', "");
    Error('\p{Bc=	/a/ES}');
    Error('\P{Bc=	/a/ES}');
    Expect(1, 65293, '\p{Bc=:\AES\z:}', "");;
    Expect(0, 65294, '\p{Bc=:\AES\z:}', "");;
    Expect(1, 65293, '\p{Bc=es}', "");
    Expect(0, 65293, '\p{^Bc=es}', "");
    Expect(0, 65293, '\P{Bc=es}', "");
    Expect(1, 65293, '\P{^Bc=es}', "");
    Expect(0, 65294, '\p{Bc=es}', "");
    Expect(1, 65294, '\p{^Bc=es}', "");
    Expect(1, 65294, '\P{Bc=es}', "");
    Expect(0, 65294, '\P{^Bc=es}', "");
    Expect(1, 65293, '\p{Bc=:\Aes\z:}', "");;
    Expect(0, 65294, '\p{Bc=:\Aes\z:}', "");;
    Expect(1, 65293, '\p{Bc=_-ES}', "");
    Expect(0, 65293, '\p{^Bc=_-ES}', "");
    Expect(0, 65293, '\P{Bc=_-ES}', "");
    Expect(1, 65293, '\P{^Bc=_-ES}', "");
    Expect(0, 65294, '\p{Bc=_-ES}', "");
    Expect(1, 65294, '\p{^Bc=_-ES}', "");
    Expect(1, 65294, '\P{Bc=_-ES}', "");
    Expect(0, 65294, '\P{^Bc=_-ES}', "");
    Error('\p{Is_Bidi_Class=/a/_-European_Separator}');
    Error('\P{Is_Bidi_Class=/a/_-European_Separator}');
    Expect(1, 65293, '\p{Is_Bidi_Class=europeanseparator}', "");
    Expect(0, 65293, '\p{^Is_Bidi_Class=europeanseparator}', "");
    Expect(0, 65293, '\P{Is_Bidi_Class=europeanseparator}', "");
    Expect(1, 65293, '\P{^Is_Bidi_Class=europeanseparator}', "");
    Expect(0, 65294, '\p{Is_Bidi_Class=europeanseparator}', "");
    Expect(1, 65294, '\p{^Is_Bidi_Class=europeanseparator}', "");
    Expect(1, 65294, '\P{Is_Bidi_Class=europeanseparator}', "");
    Expect(0, 65294, '\P{^Is_Bidi_Class=europeanseparator}', "");
    Expect(1, 65293, '\p{Is_Bidi_Class=	-european_separator}', "");
    Expect(0, 65293, '\p{^Is_Bidi_Class=	-european_separator}', "");
    Expect(0, 65293, '\P{Is_Bidi_Class=	-european_separator}', "");
    Expect(1, 65293, '\P{^Is_Bidi_Class=	-european_separator}', "");
    Expect(0, 65294, '\p{Is_Bidi_Class=	-european_separator}', "");
    Expect(1, 65294, '\p{^Is_Bidi_Class=	-european_separator}', "");
    Expect(1, 65294, '\P{Is_Bidi_Class=	-european_separator}', "");
    Expect(0, 65294, '\P{^Is_Bidi_Class=	-european_separator}', "");
    Error('\p{Is_Bc:-:=ES}');
    Error('\P{Is_Bc:-:=ES}');
    Expect(1, 65293, '\p{Is_Bc=es}', "");
    Expect(0, 65293, '\p{^Is_Bc=es}', "");
    Expect(0, 65293, '\P{Is_Bc=es}', "");
    Expect(1, 65293, '\P{^Is_Bc=es}', "");
    Expect(0, 65294, '\p{Is_Bc=es}', "");
    Expect(1, 65294, '\p{^Is_Bc=es}', "");
    Expect(1, 65294, '\P{Is_Bc=es}', "");
    Expect(0, 65294, '\P{^Is_Bc=es}', "");
    Expect(1, 65293, '\p{Is_Bc=	_ES}', "");
    Expect(0, 65293, '\p{^Is_Bc=	_ES}', "");
    Expect(0, 65293, '\P{Is_Bc=	_ES}', "");
    Expect(1, 65293, '\P{^Is_Bc=	_ES}', "");
    Expect(0, 65294, '\p{Is_Bc=	_ES}', "");
    Expect(1, 65294, '\p{^Is_Bc=	_ES}', "");
    Expect(1, 65294, '\P{Is_Bc=	_ES}', "");
    Expect(0, 65294, '\P{^Is_Bc=	_ES}', "");
    Error('\p{Bidi_Class=/a/__EUROPEAN_terminator}');
    Error('\P{Bidi_Class=/a/__EUROPEAN_terminator}');
    Expect(1, 123647, '\p{Bidi_Class=:\AEuropean_Terminator\z:}', "");;
    Expect(0, 123648, '\p{Bidi_Class=:\AEuropean_Terminator\z:}', "");;
    Expect(1, 123647, '\p{Bidi_Class=europeanterminator}', "");
    Expect(0, 123647, '\p{^Bidi_Class=europeanterminator}', "");
    Expect(0, 123647, '\P{Bidi_Class=europeanterminator}', "");
    Expect(1, 123647, '\P{^Bidi_Class=europeanterminator}', "");
    Expect(0, 123648, '\p{Bidi_Class=europeanterminator}', "");
    Expect(1, 123648, '\p{^Bidi_Class=europeanterminator}', "");
    Expect(1, 123648, '\P{Bidi_Class=europeanterminator}', "");
    Expect(0, 123648, '\P{^Bidi_Class=europeanterminator}', "");
    Expect(1, 123647, '\p{Bidi_Class=:\Aeuropeanterminator\z:}', "");;
    Expect(0, 123648, '\p{Bidi_Class=:\Aeuropeanterminator\z:}', "");;
    Expect(1, 123647, '\p{Bidi_Class=	 european_terminator}', "");
    Expect(0, 123647, '\p{^Bidi_Class=	 european_terminator}', "");
    Expect(0, 123647, '\P{Bidi_Class=	 european_terminator}', "");
    Expect(1, 123647, '\P{^Bidi_Class=	 european_terminator}', "");
    Expect(0, 123648, '\p{Bidi_Class=	 european_terminator}', "");
    Expect(1, 123648, '\p{^Bidi_Class=	 european_terminator}', "");
    Expect(1, 123648, '\P{Bidi_Class=	 european_terminator}', "");
    Expect(0, 123648, '\P{^Bidi_Class=	 european_terminator}', "");
    Error('\p{Bc=_:=ET}');
    Error('\P{Bc=_:=ET}');
    Expect(1, 123647, '\p{Bc=:\AET\z:}', "");;
    Expect(0, 123648, '\p{Bc=:\AET\z:}', "");;
    Expect(1, 123647, '\p{Bc:   et}', "");
    Expect(0, 123647, '\p{^Bc:   et}', "");
    Expect(0, 123647, '\P{Bc:   et}', "");
    Expect(1, 123647, '\P{^Bc:   et}', "");
    Expect(0, 123648, '\p{Bc:   et}', "");
    Expect(1, 123648, '\p{^Bc:   et}', "");
    Expect(1, 123648, '\P{Bc:   et}', "");
    Expect(0, 123648, '\P{^Bc:   et}', "");
    Expect(1, 123647, '\p{Bc=:\Aet\z:}', "");;
    Expect(0, 123648, '\p{Bc=:\Aet\z:}', "");;
    Expect(1, 123647, '\p{Bc= _ET}', "");
    Expect(0, 123647, '\p{^Bc= _ET}', "");
    Expect(0, 123647, '\P{Bc= _ET}', "");
    Expect(1, 123647, '\P{^Bc= _ET}', "");
    Expect(0, 123648, '\p{Bc= _ET}', "");
    Expect(1, 123648, '\p{^Bc= _ET}', "");
    Expect(1, 123648, '\P{Bc= _ET}', "");
    Expect(0, 123648, '\P{^Bc= _ET}', "");
    Error('\p{Is_Bidi_Class= :=European_terminator}');
    Error('\P{Is_Bidi_Class= :=European_terminator}');
    Expect(1, 123647, '\p{Is_Bidi_Class=europeanterminator}', "");
    Expect(0, 123647, '\p{^Is_Bidi_Class=europeanterminator}', "");
    Expect(0, 123647, '\P{Is_Bidi_Class=europeanterminator}', "");
    Expect(1, 123647, '\P{^Is_Bidi_Class=europeanterminator}', "");
    Expect(0, 123648, '\p{Is_Bidi_Class=europeanterminator}', "");
    Expect(1, 123648, '\p{^Is_Bidi_Class=europeanterminator}', "");
    Expect(1, 123648, '\P{Is_Bidi_Class=europeanterminator}', "");
    Expect(0, 123648, '\P{^Is_Bidi_Class=europeanterminator}', "");
    Expect(1, 123647, '\p{Is_Bidi_Class=-	European_Terminator}', "");
    Expect(0, 123647, '\p{^Is_Bidi_Class=-	European_Terminator}', "");
    Expect(0, 123647, '\P{Is_Bidi_Class=-	European_Terminator}', "");
    Expect(1, 123647, '\P{^Is_Bidi_Class=-	European_Terminator}', "");
    Expect(0, 123648, '\p{Is_Bidi_Class=-	European_Terminator}', "");
    Expect(1, 123648, '\p{^Is_Bidi_Class=-	European_Terminator}', "");
    Expect(1, 123648, '\P{Is_Bidi_Class=-	European_Terminator}', "");
    Expect(0, 123648, '\P{^Is_Bidi_Class=-	European_Terminator}', "");
    Error('\p{Is_Bc=	ET/a/}');
    Error('\P{Is_Bc=	ET/a/}');
    Expect(1, 123647, '\p{Is_Bc=et}', "");
    Expect(0, 123647, '\p{^Is_Bc=et}', "");
    Expect(0, 123647, '\P{Is_Bc=et}', "");
    Expect(1, 123647, '\P{^Is_Bc=et}', "");
    Expect(0, 123648, '\p{Is_Bc=et}', "");
    Expect(1, 123648, '\p{^Is_Bc=et}', "");
    Expect(1, 123648, '\P{Is_Bc=et}', "");
    Expect(0, 123648, '\P{^Is_Bc=et}', "");
    Expect(1, 123647, '\p{Is_Bc=  et}', "");
    Expect(0, 123647, '\p{^Is_Bc=  et}', "");
    Expect(0, 123647, '\P{Is_Bc=  et}', "");
    Expect(1, 123647, '\P{^Is_Bc=  et}', "");
    Expect(0, 123648, '\p{Is_Bc=  et}', "");
    Expect(1, 123648, '\p{^Is_Bc=  et}', "");
    Expect(1, 123648, '\P{Is_Bc=  et}', "");
    Expect(0, 123648, '\P{^Is_Bc=  et}', "");
    Error('\p{Bidi_Class=	:=first_Strong_Isolate}');
    Error('\P{Bidi_Class=	:=first_Strong_Isolate}');
    Expect(1, 8296, '\p{Bidi_Class=:\AFirst_Strong_Isolate\z:}', "");;
    Expect(0, 8297, '\p{Bidi_Class=:\AFirst_Strong_Isolate\z:}', "");;
    Expect(1, 8296, '\p{Bidi_Class=firststrongisolate}', "");
    Expect(0, 8296, '\p{^Bidi_Class=firststrongisolate}', "");
    Expect(0, 8296, '\P{Bidi_Class=firststrongisolate}', "");
    Expect(1, 8296, '\P{^Bidi_Class=firststrongisolate}', "");
    Expect(0, 8297, '\p{Bidi_Class=firststrongisolate}', "");
    Expect(1, 8297, '\p{^Bidi_Class=firststrongisolate}', "");
    Expect(1, 8297, '\P{Bidi_Class=firststrongisolate}', "");
    Expect(0, 8297, '\P{^Bidi_Class=firststrongisolate}', "");
    Expect(1, 8296, '\p{Bidi_Class=:\Afirststrongisolate\z:}', "");;
    Expect(0, 8297, '\p{Bidi_Class=:\Afirststrongisolate\z:}', "");;
    Expect(1, 8296, '\p{Bidi_Class= 	First_Strong_Isolate}', "");
    Expect(0, 8296, '\p{^Bidi_Class= 	First_Strong_Isolate}', "");
    Expect(0, 8296, '\P{Bidi_Class= 	First_Strong_Isolate}', "");
    Expect(1, 8296, '\P{^Bidi_Class= 	First_Strong_Isolate}', "");
    Expect(0, 8297, '\p{Bidi_Class= 	First_Strong_Isolate}', "");
    Expect(1, 8297, '\p{^Bidi_Class= 	First_Strong_Isolate}', "");
    Expect(1, 8297, '\P{Bidi_Class= 	First_Strong_Isolate}', "");
    Expect(0, 8297, '\P{^Bidi_Class= 	First_Strong_Isolate}', "");
    Error('\p{Bc=	/a/FSI}');
    Error('\P{Bc=	/a/FSI}');
    Expect(1, 8296, '\p{Bc=:\AFSI\z:}', "");;
    Expect(0, 8297, '\p{Bc=:\AFSI\z:}', "");;
    Expect(1, 8296, '\p{Bc=fsi}', "");
    Expect(0, 8296, '\p{^Bc=fsi}', "");
    Expect(0, 8296, '\P{Bc=fsi}', "");
    Expect(1, 8296, '\P{^Bc=fsi}', "");
    Expect(0, 8297, '\p{Bc=fsi}', "");
    Expect(1, 8297, '\p{^Bc=fsi}', "");
    Expect(1, 8297, '\P{Bc=fsi}', "");
    Expect(0, 8297, '\P{^Bc=fsi}', "");
    Expect(1, 8296, '\p{Bc=:\Afsi\z:}', "");;
    Expect(0, 8297, '\p{Bc=:\Afsi\z:}', "");;
    Expect(1, 8296, '\p{Bc=- FSI}', "");
    Expect(0, 8296, '\p{^Bc=- FSI}', "");
    Expect(0, 8296, '\P{Bc=- FSI}', "");
    Expect(1, 8296, '\P{^Bc=- FSI}', "");
    Expect(0, 8297, '\p{Bc=- FSI}', "");
    Expect(1, 8297, '\p{^Bc=- FSI}', "");
    Expect(1, 8297, '\P{Bc=- FSI}', "");
    Expect(0, 8297, '\P{^Bc=- FSI}', "");
    Error('\p{Is_Bidi_Class=-First_STRONG_Isolate:=}');
    Error('\P{Is_Bidi_Class=-First_STRONG_Isolate:=}');
    Expect(1, 8296, '\p{Is_Bidi_Class=firststrongisolate}', "");
    Expect(0, 8296, '\p{^Is_Bidi_Class=firststrongisolate}', "");
    Expect(0, 8296, '\P{Is_Bidi_Class=firststrongisolate}', "");
    Expect(1, 8296, '\P{^Is_Bidi_Class=firststrongisolate}', "");
    Expect(0, 8297, '\p{Is_Bidi_Class=firststrongisolate}', "");
    Expect(1, 8297, '\p{^Is_Bidi_Class=firststrongisolate}', "");
    Expect(1, 8297, '\P{Is_Bidi_Class=firststrongisolate}', "");
    Expect(0, 8297, '\P{^Is_Bidi_Class=firststrongisolate}', "");
    Expect(1, 8296, '\p{Is_Bidi_Class=_first_Strong_Isolate}', "");
    Expect(0, 8296, '\p{^Is_Bidi_Class=_first_Strong_Isolate}', "");
    Expect(0, 8296, '\P{Is_Bidi_Class=_first_Strong_Isolate}', "");
    Expect(1, 8296, '\P{^Is_Bidi_Class=_first_Strong_Isolate}', "");
    Expect(0, 8297, '\p{Is_Bidi_Class=_first_Strong_Isolate}', "");
    Expect(1, 8297, '\p{^Is_Bidi_Class=_first_Strong_Isolate}', "");
    Expect(1, 8297, '\P{Is_Bidi_Class=_first_Strong_Isolate}', "");
    Expect(0, 8297, '\P{^Is_Bidi_Class=_first_Strong_Isolate}', "");
    Error('\p{Is_Bc=	:=FSI}');
    Error('\P{Is_Bc=	:=FSI}');
    Expect(1, 8296, '\p{Is_Bc=fsi}', "");
    Expect(0, 8296, '\p{^Is_Bc=fsi}', "");
    Expect(0, 8296, '\P{Is_Bc=fsi}', "");
    Expect(1, 8296, '\P{^Is_Bc=fsi}', "");
    Expect(0, 8297, '\p{Is_Bc=fsi}', "");
    Expect(1, 8297, '\p{^Is_Bc=fsi}', "");
    Expect(1, 8297, '\P{Is_Bc=fsi}', "");
    Expect(0, 8297, '\P{^Is_Bc=fsi}', "");
    Expect(1, 8296, '\p{Is_Bc=_-FSI}', "");
    Expect(0, 8296, '\p{^Is_Bc=_-FSI}', "");
    Expect(0, 8296, '\P{Is_Bc=_-FSI}', "");
    Expect(1, 8296, '\P{^Is_Bc=_-FSI}', "");
    Expect(0, 8297, '\p{Is_Bc=_-FSI}', "");
    Expect(1, 8297, '\p{^Is_Bc=_-FSI}', "");
    Expect(1, 8297, '\P{Is_Bc=_-FSI}', "");
    Expect(0, 8297, '\P{^Is_Bc=_-FSI}', "");
    Error('\p{Bidi_Class= 	LEFT_To_Right/a/}');
    Error('\P{Bidi_Class= 	LEFT_To_Right/a/}');
    Expect(1, 1114109, '\p{Bidi_Class=:\ALeft_To_Right\z:}', "");;
    Expect(0, 921599, '\p{Bidi_Class=:\ALeft_To_Right\z:}', "");;
    Expect(1, 1114109, '\p{Bidi_Class=lefttoright}', "");
    Expect(0, 1114109, '\p{^Bidi_Class=lefttoright}', "");
    Expect(0, 1114109, '\P{Bidi_Class=lefttoright}', "");
    Expect(1, 1114109, '\P{^Bidi_Class=lefttoright}', "");
    Expect(0, 921599, '\p{Bidi_Class=lefttoright}', "");
    Expect(1, 921599, '\p{^Bidi_Class=lefttoright}', "");
    Expect(1, 921599, '\P{Bidi_Class=lefttoright}', "");
    Expect(0, 921599, '\P{^Bidi_Class=lefttoright}', "");
    Expect(1, 1114109, '\p{Bidi_Class=:\Alefttoright\z:}', "");;
    Expect(0, 921599, '\p{Bidi_Class=:\Alefttoright\z:}', "");;
    Expect(1, 1114109, '\p{Bidi_Class=- Left_To_Right}', "");
    Expect(0, 1114109, '\p{^Bidi_Class=- Left_To_Right}', "");
    Expect(0, 1114109, '\P{Bidi_Class=- Left_To_Right}', "");
    Expect(1, 1114109, '\P{^Bidi_Class=- Left_To_Right}', "");
    Expect(0, 921599, '\p{Bidi_Class=- Left_To_Right}', "");
    Expect(1, 921599, '\p{^Bidi_Class=- Left_To_Right}', "");
    Expect(1, 921599, '\P{Bidi_Class=- Left_To_Right}', "");
    Expect(0, 921599, '\P{^Bidi_Class=- Left_To_Right}', "");
    Error('\p{Bc=_ L:=}');
    Error('\P{Bc=_ L:=}');
    Expect(1, 1114109, '\p{Bc=:\AL\z:}', "");;
    Expect(0, 921599, '\p{Bc=:\AL\z:}', "");;
    Expect(1, 1114109, '\p{Bc=l}', "");
    Expect(0, 1114109, '\p{^Bc=l}', "");
    Expect(0, 1114109, '\P{Bc=l}', "");
    Expect(1, 1114109, '\P{^Bc=l}', "");
    Expect(0, 921599, '\p{Bc=l}', "");
    Expect(1, 921599, '\p{^Bc=l}', "");
    Expect(1, 921599, '\P{Bc=l}', "");
    Expect(0, 921599, '\P{^Bc=l}', "");
    Expect(1, 1114109, '\p{Bc=:\Al\z:}', "");;
    Expect(0, 921599, '\p{Bc=:\Al\z:}', "");;
    Expect(1, 1114109, '\p{Bc=	 L}', "");
    Expect(0, 1114109, '\p{^Bc=	 L}', "");
    Expect(0, 1114109, '\P{Bc=	 L}', "");
    Expect(1, 1114109, '\P{^Bc=	 L}', "");
    Expect(0, 921599, '\p{Bc=	 L}', "");
    Expect(1, 921599, '\p{^Bc=	 L}', "");
    Expect(1, 921599, '\P{Bc=	 L}', "");
    Expect(0, 921599, '\P{^Bc=	 L}', "");
    Error('\p{Is_Bidi_Class=/a/-_Left_to_Right}');
    Error('\P{Is_Bidi_Class=/a/-_Left_to_Right}');
    Expect(1, 1114109, '\p{Is_Bidi_Class=lefttoright}', "");
    Expect(0, 1114109, '\p{^Is_Bidi_Class=lefttoright}', "");
    Expect(0, 1114109, '\P{Is_Bidi_Class=lefttoright}', "");
    Expect(1, 1114109, '\P{^Is_Bidi_Class=lefttoright}', "");
    Expect(0, 921599, '\p{Is_Bidi_Class=lefttoright}', "");
    Expect(1, 921599, '\p{^Is_Bidi_Class=lefttoright}', "");
    Expect(1, 921599, '\P{Is_Bidi_Class=lefttoright}', "");
    Expect(0, 921599, '\P{^Is_Bidi_Class=lefttoright}', "");
    Expect(1, 1114109, '\p{Is_Bidi_Class: _-LEFT_To_right}', "");
    Expect(0, 1114109, '\p{^Is_Bidi_Class: _-LEFT_To_right}', "");
    Expect(0, 1114109, '\P{Is_Bidi_Class: _-LEFT_To_right}', "");
    Expect(1, 1114109, '\P{^Is_Bidi_Class: _-LEFT_To_right}', "");
    Expect(0, 921599, '\p{Is_Bidi_Class: _-LEFT_To_right}', "");
    Expect(1, 921599, '\p{^Is_Bidi_Class: _-LEFT_To_right}', "");
    Expect(1, 921599, '\P{Is_Bidi_Class: _-LEFT_To_right}', "");
    Expect(0, 921599, '\P{^Is_Bidi_Class: _-LEFT_To_right}', "");
    Error('\p{Is_Bc:_/a/l}');
    Error('\P{Is_Bc:_/a/l}');
    Expect(1, 1114109, '\p{Is_Bc=l}', "");
    Expect(0, 1114109, '\p{^Is_Bc=l}', "");
    Expect(0, 1114109, '\P{Is_Bc=l}', "");
    Expect(1, 1114109, '\P{^Is_Bc=l}', "");
    Expect(0, 921599, '\p{Is_Bc=l}', "");
    Expect(1, 921599, '\p{^Is_Bc=l}', "");
    Expect(1, 921599, '\P{Is_Bc=l}', "");
    Expect(0, 921599, '\P{^Is_Bc=l}', "");
    Expect(1, 1114109, '\p{Is_Bc= _L}', "");
    Expect(0, 1114109, '\p{^Is_Bc= _L}', "");
    Expect(0, 1114109, '\P{Is_Bc= _L}', "");
    Expect(1, 1114109, '\P{^Is_Bc= _L}', "");
    Expect(0, 921599, '\p{Is_Bc= _L}', "");
    Expect(1, 921599, '\p{^Is_Bc= _L}', "");
    Expect(1, 921599, '\P{Is_Bc= _L}', "");
    Expect(0, 921599, '\P{^Is_Bc= _L}', "");
    Error('\p{Bidi_Class= /a/left_to_right_EMBEDDING}');
    Error('\P{Bidi_Class= /a/left_to_right_EMBEDDING}');
    Expect(1, 8234, '\p{Bidi_Class=:\ALeft_To_Right_Embedding\z:}', "");;
    Expect(0, 8235, '\p{Bidi_Class=:\ALeft_To_Right_Embedding\z:}', "");;
    Expect(1, 8234, '\p{Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8234, '\p{^Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8234, '\P{Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8234, '\P{^Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8235, '\p{Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8235, '\p{^Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8235, '\P{Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8235, '\P{^Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8234, '\p{Bidi_Class=:\Alefttorightembedding\z:}', "");;
    Expect(0, 8235, '\p{Bidi_Class=:\Alefttorightembedding\z:}', "");;
    Expect(1, 8234, '\p{Bidi_Class=left_TO_RIGHT_embedding}', "");
    Expect(0, 8234, '\p{^Bidi_Class=left_TO_RIGHT_embedding}', "");
    Expect(0, 8234, '\P{Bidi_Class=left_TO_RIGHT_embedding}', "");
    Expect(1, 8234, '\P{^Bidi_Class=left_TO_RIGHT_embedding}', "");
    Expect(0, 8235, '\p{Bidi_Class=left_TO_RIGHT_embedding}', "");
    Expect(1, 8235, '\p{^Bidi_Class=left_TO_RIGHT_embedding}', "");
    Expect(1, 8235, '\P{Bidi_Class=left_TO_RIGHT_embedding}', "");
    Expect(0, 8235, '\P{^Bidi_Class=left_TO_RIGHT_embedding}', "");
    Error('\p{Bc=-	LRE/a/}');
    Error('\P{Bc=-	LRE/a/}');
    Expect(1, 8234, '\p{Bc=:\ALRE\z:}', "");;
    Expect(0, 8235, '\p{Bc=:\ALRE\z:}', "");;
    Expect(1, 8234, '\p{Bc=lre}', "");
    Expect(0, 8234, '\p{^Bc=lre}', "");
    Expect(0, 8234, '\P{Bc=lre}', "");
    Expect(1, 8234, '\P{^Bc=lre}', "");
    Expect(0, 8235, '\p{Bc=lre}', "");
    Expect(1, 8235, '\p{^Bc=lre}', "");
    Expect(1, 8235, '\P{Bc=lre}', "");
    Expect(0, 8235, '\P{^Bc=lre}', "");
    Expect(1, 8234, '\p{Bc=:\Alre\z:}', "");;
    Expect(0, 8235, '\p{Bc=:\Alre\z:}', "");;
    Expect(1, 8234, '\p{Bc=-LRE}', "");
    Expect(0, 8234, '\p{^Bc=-LRE}', "");
    Expect(0, 8234, '\P{Bc=-LRE}', "");
    Expect(1, 8234, '\P{^Bc=-LRE}', "");
    Expect(0, 8235, '\p{Bc=-LRE}', "");
    Expect(1, 8235, '\p{^Bc=-LRE}', "");
    Expect(1, 8235, '\P{Bc=-LRE}', "");
    Expect(0, 8235, '\P{^Bc=-LRE}', "");
    Error('\p{Is_Bidi_Class=:=	_left_to_Right_EMBEDDING}');
    Error('\P{Is_Bidi_Class=:=	_left_to_Right_EMBEDDING}');
    Expect(1, 8234, '\p{Is_Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8234, '\p{^Is_Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8234, '\P{Is_Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8234, '\P{^Is_Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8235, '\p{Is_Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8235, '\p{^Is_Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8235, '\P{Is_Bidi_Class=lefttorightembedding}', "");
    Expect(0, 8235, '\P{^Is_Bidi_Class=lefttorightembedding}', "");
    Expect(1, 8234, '\p{Is_Bidi_Class=- left_to_right_embedding}', "");
    Expect(0, 8234, '\p{^Is_Bidi_Class=- left_to_right_embedding}', "");
    Expect(0, 8234, '\P{Is_Bidi_Class=- left_to_right_embedding}', "");
    Expect(1, 8234, '\P{^Is_Bidi_Class=- left_to_right_embedding}', "");
    Expect(0, 8235, '\p{Is_Bidi_Class=- left_to_right_embedding}', "");
    Expect(1, 8235, '\p{^Is_Bidi_Class=- left_to_right_embedding}', "");
    Expect(1, 8235, '\P{Is_Bidi_Class=- left_to_right_embedding}', "");
    Expect(0, 8235, '\P{^Is_Bidi_Class=- left_to_right_embedding}', "");
    Error('\p{Is_Bc:   		LRE:=}');
    Error('\P{Is_Bc:   		LRE:=}');
    Expect(1, 8234, '\p{Is_Bc=lre}', "");
    Expect(0, 8234, '\p{^Is_Bc=lre}', "");
    Expect(0, 8234, '\P{Is_Bc=lre}', "");
    Expect(1, 8234, '\P{^Is_Bc=lre}', "");
    Expect(0, 8235, '\p{Is_Bc=lre}', "");
    Expect(1, 8235, '\p{^Is_Bc=lre}', "");
    Expect(1, 8235, '\P{Is_Bc=lre}', "");
    Expect(0, 8235, '\P{^Is_Bc=lre}', "");
    Expect(1, 8234, '\p{Is_Bc=-lre}', "");
    Expect(0, 8234, '\p{^Is_Bc=-lre}', "");
    Expect(0, 8234, '\P{Is_Bc=-lre}', "");
    Expect(1, 8234, '\P{^Is_Bc=-lre}', "");
    Expect(0, 8235, '\p{Is_Bc=-lre}', "");
    Expect(1, 8235, '\p{^Is_Bc=-lre}', "");
    Expect(1, 8235, '\P{Is_Bc=-lre}', "");
    Expect(0, 8235, '\P{^Is_Bc=-lre}', "");
    Error('\p{Bidi_Class=_	Left_To_RIGHT_ISOLATE/a/}');
    Error('\P{Bidi_Class=_	Left_To_RIGHT_ISOLATE/a/}');
    Expect(1, 8294, '\p{Bidi_Class=:\ALeft_To_Right_Isolate\z:}', "");;
    Expect(0, 8295, '\p{Bidi_Class=:\ALeft_To_Right_Isolate\z:}', "");;
    Expect(1, 8294, '\p{Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8294, '\p{^Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8294, '\P{Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8294, '\P{^Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8295, '\p{Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8295, '\p{^Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8295, '\P{Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8295, '\P{^Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8294, '\p{Bidi_Class=:\Alefttorightisolate\z:}', "");;
    Expect(0, 8295, '\p{Bidi_Class=:\Alefttorightisolate\z:}', "");;
    Expect(1, 8294, '\p{Bidi_Class= LEFT_to_Right_ISOLATE}', "");
    Expect(0, 8294, '\p{^Bidi_Class= LEFT_to_Right_ISOLATE}', "");
    Expect(0, 8294, '\P{Bidi_Class= LEFT_to_Right_ISOLATE}', "");
    Expect(1, 8294, '\P{^Bidi_Class= LEFT_to_Right_ISOLATE}', "");
    Expect(0, 8295, '\p{Bidi_Class= LEFT_to_Right_ISOLATE}', "");
    Expect(1, 8295, '\p{^Bidi_Class= LEFT_to_Right_ISOLATE}', "");
    Expect(1, 8295, '\P{Bidi_Class= LEFT_to_Right_ISOLATE}', "");
    Expect(0, 8295, '\P{^Bidi_Class= LEFT_to_Right_ISOLATE}', "");
    Error('\p{Bc=		lri/a/}');
    Error('\P{Bc=		lri/a/}');
    Expect(1, 8294, '\p{Bc=:\ALRI\z:}', "");;
    Expect(0, 8295, '\p{Bc=:\ALRI\z:}', "");;
    Expect(1, 8294, '\p{Bc=lri}', "");
    Expect(0, 8294, '\p{^Bc=lri}', "");
    Expect(0, 8294, '\P{Bc=lri}', "");
    Expect(1, 8294, '\P{^Bc=lri}', "");
    Expect(0, 8295, '\p{Bc=lri}', "");
    Expect(1, 8295, '\p{^Bc=lri}', "");
    Expect(1, 8295, '\P{Bc=lri}', "");
    Expect(0, 8295, '\P{^Bc=lri}', "");
    Expect(1, 8294, '\p{Bc=:\Alri\z:}', "");;
    Expect(0, 8295, '\p{Bc=:\Alri\z:}', "");;
    Expect(1, 8294, '\p{Bc=-lri}', "");
    Expect(0, 8294, '\p{^Bc=-lri}', "");
    Expect(0, 8294, '\P{Bc=-lri}', "");
    Expect(1, 8294, '\P{^Bc=-lri}', "");
    Expect(0, 8295, '\p{Bc=-lri}', "");
    Expect(1, 8295, '\p{^Bc=-lri}', "");
    Expect(1, 8295, '\P{Bc=-lri}', "");
    Expect(0, 8295, '\P{^Bc=-lri}', "");
    Error('\p{Is_Bidi_Class=/a/Left_TO_right_ISOLATE}');
    Error('\P{Is_Bidi_Class=/a/Left_TO_right_ISOLATE}');
    Expect(1, 8294, '\p{Is_Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8294, '\p{^Is_Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8294, '\P{Is_Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8294, '\P{^Is_Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8295, '\p{Is_Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8295, '\p{^Is_Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8295, '\P{Is_Bidi_Class=lefttorightisolate}', "");
    Expect(0, 8295, '\P{^Is_Bidi_Class=lefttorightisolate}', "");
    Expect(1, 8294, '\p{Is_Bidi_Class=		left_To_right_Isolate}', "");
    Expect(0, 8294, '\p{^Is_Bidi_Class=		left_To_right_Isolate}', "");
    Expect(0, 8294, '\P{Is_Bidi_Class=		left_To_right_Isolate}', "");
    Expect(1, 8294, '\P{^Is_Bidi_Class=		left_To_right_Isolate}', "");
    Expect(0, 8295, '\p{Is_Bidi_Class=		left_To_right_Isolate}', "");
    Expect(1, 8295, '\p{^Is_Bidi_Class=		left_To_right_Isolate}', "");
    Expect(1, 8295, '\P{Is_Bidi_Class=		left_To_right_Isolate}', "");
    Expect(0, 8295, '\P{^Is_Bidi_Class=		left_To_right_Isolate}', "");
    Error('\p{Is_Bc=/a/	-lri}');
    Error('\P{Is_Bc=/a/	-lri}');
    Expect(1, 8294, '\p{Is_Bc=lri}', "");
    Expect(0, 8294, '\p{^Is_Bc=lri}', "");
    Expect(0, 8294, '\P{Is_Bc=lri}', "");
    Expect(1, 8294, '\P{^Is_Bc=lri}', "");
    Expect(0, 8295, '\p{Is_Bc=lri}', "");
    Expect(1, 8295, '\p{^Is_Bc=lri}', "");
    Expect(1, 8295, '\P{Is_Bc=lri}', "");
    Expect(0, 8295, '\P{^Is_Bc=lri}', "");
    Expect(1, 8294, '\p{Is_Bc=__LRI}', "");
    Expect(0, 8294, '\p{^Is_Bc=__LRI}', "");
    Expect(0, 8294, '\P{Is_Bc=__LRI}', "");
    Expect(1, 8294, '\P{^Is_Bc=__LRI}', "");
    Expect(0, 8295, '\p{Is_Bc=__LRI}', "");
    Expect(1, 8295, '\p{^Is_Bc=__LRI}', "");
    Expect(1, 8295, '\P{Is_Bc=__LRI}', "");
    Expect(0, 8295, '\P{^Is_Bc=__LRI}', "");
    Error('\p{Bidi_Class=- Left_TO_Right_Override/a/}');
    Error('\P{Bidi_Class=- Left_TO_Right_Override/a/}');
    Expect(1, 8237, '\p{Bidi_Class=:\ALeft_To_Right_Override\z:}', "");;
    Expect(0, 8238, '\p{Bidi_Class=:\ALeft_To_Right_Override\z:}', "");;
    Expect(1, 8237, '\p{Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8237, '\p{^Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8237, '\P{Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8237, '\P{^Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8238, '\p{Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8238, '\p{^Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8238, '\P{Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8238, '\P{^Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8237, '\p{Bidi_Class=:\Alefttorightoverride\z:}', "");;
    Expect(0, 8238, '\p{Bidi_Class=:\Alefttorightoverride\z:}', "");;
    Expect(1, 8237, '\p{Bidi_Class: -_Left_To_right_override}', "");
    Expect(0, 8237, '\p{^Bidi_Class: -_Left_To_right_override}', "");
    Expect(0, 8237, '\P{Bidi_Class: -_Left_To_right_override}', "");
    Expect(1, 8237, '\P{^Bidi_Class: -_Left_To_right_override}', "");
    Expect(0, 8238, '\p{Bidi_Class: -_Left_To_right_override}', "");
    Expect(1, 8238, '\p{^Bidi_Class: -_Left_To_right_override}', "");
    Expect(1, 8238, '\P{Bidi_Class: -_Left_To_right_override}', "");
    Expect(0, 8238, '\P{^Bidi_Class: -_Left_To_right_override}', "");
    Error('\p{Bc=	LRO:=}');
    Error('\P{Bc=	LRO:=}');
    Expect(1, 8237, '\p{Bc=:\ALRO\z:}', "");;
    Expect(0, 8238, '\p{Bc=:\ALRO\z:}', "");;
    Expect(1, 8237, '\p{Bc=lro}', "");
    Expect(0, 8237, '\p{^Bc=lro}', "");
    Expect(0, 8237, '\P{Bc=lro}', "");
    Expect(1, 8237, '\P{^Bc=lro}', "");
    Expect(0, 8238, '\p{Bc=lro}', "");
    Expect(1, 8238, '\p{^Bc=lro}', "");
    Expect(1, 8238, '\P{Bc=lro}', "");
    Expect(0, 8238, '\P{^Bc=lro}', "");
    Expect(1, 8237, '\p{Bc=:\Alro\z:}', "");;
    Expect(0, 8238, '\p{Bc=:\Alro\z:}', "");;
    Expect(1, 8237, '\p{Bc= _lro}', "");
    Expect(0, 8237, '\p{^Bc= _lro}', "");
    Expect(0, 8237, '\P{Bc= _lro}', "");
    Expect(1, 8237, '\P{^Bc= _lro}', "");
    Expect(0, 8238, '\p{Bc= _lro}', "");
    Expect(1, 8238, '\p{^Bc= _lro}', "");
    Expect(1, 8238, '\P{Bc= _lro}', "");
    Expect(0, 8238, '\P{^Bc= _lro}', "");
    Error('\p{Is_Bidi_Class=/a/  Left_TO_right_Override}');
    Error('\P{Is_Bidi_Class=/a/  Left_TO_right_Override}');
    Expect(1, 8237, '\p{Is_Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8237, '\p{^Is_Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8237, '\P{Is_Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8237, '\P{^Is_Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8238, '\p{Is_Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8238, '\p{^Is_Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8238, '\P{Is_Bidi_Class=lefttorightoverride}', "");
    Expect(0, 8238, '\P{^Is_Bidi_Class=lefttorightoverride}', "");
    Expect(1, 8237, '\p{Is_Bidi_Class=--Left_To_RIGHT_OVERRIDE}', "");
    Expect(0, 8237, '\p{^Is_Bidi_Class=--Left_To_RIGHT_OVERRIDE}', "");
    Expect(0, 8237, '\P{Is_Bidi_Class=--Left_To_RIGHT_OVERRIDE}', "");
    Expect(1, 8237, '\P{^Is_Bidi_Class=--Left_To_RIGHT_OVERRIDE}', "");
    Expect(0, 8238, '\p{Is_Bidi_Class=--Left_To_RIGHT_OVERRIDE}', "");
    Expect(1, 8238, '\p{^Is_Bidi_Class=--Left_To_RIGHT_OVERRIDE}', "");
    Expect(1, 8238, '\P{Is_Bidi_Class=--Left_To_RIGHT_OVERRIDE}', "");
    Expect(0, 8238, '\P{^Is_Bidi_Class=--Left_To_RIGHT_OVERRIDE}', "");
    Error('\p{Is_Bc: _/a/LRO}');
    Error('\P{Is_Bc: _/a/LRO}');
    Expect(1, 8237, '\p{Is_Bc=lro}', "");
    Expect(0, 8237, '\p{^Is_Bc=lro}', "");
    Expect(0, 8237, '\P{Is_Bc=lro}', "");
    Expect(1, 8237, '\P{^Is_Bc=lro}', "");
    Expect(0, 8238, '\p{Is_Bc=lro}', "");
    Expect(1, 8238, '\p{^Is_Bc=lro}', "");
    Expect(1, 8238, '\P{Is_Bc=lro}', "");
    Expect(0, 8238, '\P{^Is_Bc=lro}', "");
    Expect(1, 8237, '\p{Is_Bc=_LRO}', "");
    Expect(0, 8237, '\p{^Is_Bc=_LRO}', "");
    Expect(0, 8237, '\P{Is_Bc=_LRO}', "");
    Expect(1, 8237, '\P{^Is_Bc=_LRO}', "");
    Expect(0, 8238, '\p{Is_Bc=_LRO}', "");
    Expect(1, 8238, '\p{^Is_Bc=_LRO}', "");
    Expect(1, 8238, '\P{Is_Bc=_LRO}', "");
    Expect(0, 8238, '\P{^Is_Bc=_LRO}', "");
    Error('\p{Bidi_Class:--NONSPACING_Mark:=}');
    Error('\P{Bidi_Class:--NONSPACING_Mark:=}');
    Expect(1, 917999, '\p{Bidi_Class=:\ANonspacing_Mark\z:}', "");;
    Expect(0, 918000, '\p{Bidi_Class=:\ANonspacing_Mark\z:}', "");;
    Expect(1, 917999, '\p{Bidi_Class=nonspacingmark}', "");
    Expect(0, 917999, '\p{^Bidi_Class=nonspacingmark}', "");
    Expect(0, 917999, '\P{Bidi_Class=nonspacingmark}', "");
    Expect(1, 917999, '\P{^Bidi_Class=nonspacingmark}', "");
    Expect(0, 918000, '\p{Bidi_Class=nonspacingmark}', "");
    Expect(1, 918000, '\p{^Bidi_Class=nonspacingmark}', "");
    Expect(1, 918000, '\P{Bidi_Class=nonspacingmark}', "");
    Expect(0, 918000, '\P{^Bidi_Class=nonspacingmark}', "");
    Expect(1, 917999, '\p{Bidi_Class=:\Anonspacingmark\z:}', "");;
    Expect(0, 918000, '\p{Bidi_Class=:\Anonspacingmark\z:}', "");;
    Expect(1, 917999, '\p{Bidi_Class=-nonspacing_Mark}', "");
    Expect(0, 917999, '\p{^Bidi_Class=-nonspacing_Mark}', "");
    Expect(0, 917999, '\P{Bidi_Class=-nonspacing_Mark}', "");
    Expect(1, 917999, '\P{^Bidi_Class=-nonspacing_Mark}', "");
    Expect(0, 918000, '\p{Bidi_Class=-nonspacing_Mark}', "");
    Expect(1, 918000, '\p{^Bidi_Class=-nonspacing_Mark}', "");
    Expect(1, 918000, '\P{Bidi_Class=-nonspacing_Mark}', "");
    Expect(0, 918000, '\P{^Bidi_Class=-nonspacing_Mark}', "");
    Error('\p{Bc=_NSM/a/}');
    Error('\P{Bc=_NSM/a/}');
    Expect(1, 917999, '\p{Bc=:\ANSM\z:}', "");;
    Expect(0, 918000, '\p{Bc=:\ANSM\z:}', "");;
    Expect(1, 917999, '\p{Bc=nsm}', "");
    Expect(0, 917999, '\p{^Bc=nsm}', "");
    Expect(0, 917999, '\P{Bc=nsm}', "");
    Expect(1, 917999, '\P{^Bc=nsm}', "");
    Expect(0, 918000, '\p{Bc=nsm}', "");
    Expect(1, 918000, '\p{^Bc=nsm}', "");
    Expect(1, 918000, '\P{Bc=nsm}', "");
    Expect(0, 918000, '\P{^Bc=nsm}', "");
    Expect(1, 917999, '\p{Bc=:\Ansm\z:}', "");;
    Expect(0, 918000, '\p{Bc=:\Ansm\z:}', "");;
    Expect(1, 917999, '\p{Bc:		-NSM}', "");
    Expect(0, 917999, '\p{^Bc:		-NSM}', "");
    Expect(0, 917999, '\P{Bc:		-NSM}', "");
    Expect(1, 917999, '\P{^Bc:		-NSM}', "");
    Expect(0, 918000, '\p{Bc:		-NSM}', "");
    Expect(1, 918000, '\p{^Bc:		-NSM}', "");
    Expect(1, 918000, '\P{Bc:		-NSM}', "");
    Expect(0, 918000, '\P{^Bc:		-NSM}', "");
    Error('\p{Is_Bidi_Class=_:=Nonspacing_Mark}');
    Error('\P{Is_Bidi_Class=_:=Nonspacing_Mark}');
    Expect(1, 917999, '\p{Is_Bidi_Class=nonspacingmark}', "");
    Expect(0, 917999, '\p{^Is_Bidi_Class=nonspacingmark}', "");
    Expect(0, 917999, '\P{Is_Bidi_Class=nonspacingmark}', "");
    Expect(1, 917999, '\P{^Is_Bidi_Class=nonspacingmark}', "");
    Expect(0, 918000, '\p{Is_Bidi_Class=nonspacingmark}', "");
    Expect(1, 918000, '\p{^Is_Bidi_Class=nonspacingmark}', "");
    Expect(1, 918000, '\P{Is_Bidi_Class=nonspacingmark}', "");
    Expect(0, 918000, '\P{^Is_Bidi_Class=nonspacingmark}', "");
    Expect(1, 917999, '\p{Is_Bidi_Class=  NONSPACING_Mark}', "");
    Expect(0, 917999, '\p{^Is_Bidi_Class=  NONSPACING_Mark}', "");
    Expect(0, 917999, '\P{Is_Bidi_Class=  NONSPACING_Mark}', "");
    Expect(1, 917999, '\P{^Is_Bidi_Class=  NONSPACING_Mark}', "");
    Expect(0, 918000, '\p{Is_Bidi_Class=  NONSPACING_Mark}', "");
    Expect(1, 918000, '\p{^Is_Bidi_Class=  NONSPACING_Mark}', "");
    Expect(1, 918000, '\P{Is_Bidi_Class=  NONSPACING_Mark}', "");
    Expect(0, 918000, '\P{^Is_Bidi_Class=  NONSPACING_Mark}', "");
    Error('\p{Is_Bc= NSM/a/}');
    Error('\P{Is_Bc= NSM/a/}');
    Expect(1, 917999, '\p{Is_Bc=nsm}', "");
    Expect(0, 917999, '\p{^Is_Bc=nsm}', "");
    Expect(0, 917999, '\P{Is_Bc=nsm}', "");
    Expect(1, 917999, '\P{^Is_Bc=nsm}', "");
    Expect(0, 918000, '\p{Is_Bc=nsm}', "");
    Expect(1, 918000, '\p{^Is_Bc=nsm}', "");
    Expect(1, 918000, '\P{Is_Bc=nsm}', "");
    Expect(0, 918000, '\P{^Is_Bc=nsm}', "");
    Expect(1, 917999, '\p{Is_Bc=_-NSM}', "");
    Expect(0, 917999, '\p{^Is_Bc=_-NSM}', "");
    Expect(0, 917999, '\P{Is_Bc=_-NSM}', "");
    Expect(1, 917999, '\P{^Is_Bc=_-NSM}', "");
    Expect(0, 918000, '\p{Is_Bc=_-NSM}', "");
    Expect(1, 918000, '\p{^Is_Bc=_-NSM}', "");
    Expect(1, 918000, '\P{Is_Bc=_-NSM}', "");
    Expect(0, 918000, '\P{^Is_Bc=_-NSM}', "");
    Error('\p{Bidi_Class=_:=other_neutral}');
    Error('\P{Bidi_Class=_:=other_neutral}');
    Expect(1, 129685, '\p{Bidi_Class=:\AOther_Neutral\z:}', "");;
    Expect(0, 129686, '\p{Bidi_Class=:\AOther_Neutral\z:}', "");;
    Expect(1, 129685, '\p{Bidi_Class=otherneutral}', "");
    Expect(0, 129685, '\p{^Bidi_Class=otherneutral}', "");
    Expect(0, 129685, '\P{Bidi_Class=otherneutral}', "");
    Expect(1, 129685, '\P{^Bidi_Class=otherneutral}', "");
    Expect(0, 129686, '\p{Bidi_Class=otherneutral}', "");
    Expect(1, 129686, '\p{^Bidi_Class=otherneutral}', "");
    Expect(1, 129686, '\P{Bidi_Class=otherneutral}', "");
    Expect(0, 129686, '\P{^Bidi_Class=otherneutral}', "");
    Expect(1, 129685, '\p{Bidi_Class=:\Aotherneutral\z:}', "");;
    Expect(0, 129686, '\p{Bidi_Class=:\Aotherneutral\z:}', "");;
    Expect(1, 129685, '\p{Bidi_Class=	-other_NEUTRAL}', "");
    Expect(0, 129685, '\p{^Bidi_Class=	-other_NEUTRAL}', "");
    Expect(0, 129685, '\P{Bidi_Class=	-other_NEUTRAL}', "");
    Expect(1, 129685, '\P{^Bidi_Class=	-other_NEUTRAL}', "");
    Expect(0, 129686, '\p{Bidi_Class=	-other_NEUTRAL}', "");
    Expect(1, 129686, '\p{^Bidi_Class=	-other_NEUTRAL}', "");
    Expect(1, 129686, '\P{Bidi_Class=	-other_NEUTRAL}', "");
    Expect(0, 129686, '\P{^Bidi_Class=	-other_NEUTRAL}', "");
    Error('\p{Bc:    on/a/}');
    Error('\P{Bc:    on/a/}');
    Expect(1, 129685, '\p{Bc=:\AON\z:}', "");;
    Expect(0, 129686, '\p{Bc=:\AON\z:}', "");;
    Expect(1, 129685, '\p{Bc:	on}', "");
    Expect(0, 129685, '\p{^Bc:	on}', "");
    Expect(0, 129685, '\P{Bc:	on}', "");
    Expect(1, 129685, '\P{^Bc:	on}', "");
    Expect(0, 129686, '\p{Bc:	on}', "");
    Expect(1, 129686, '\p{^Bc:	on}', "");
    Expect(1, 129686, '\P{Bc:	on}', "");
    Expect(0, 129686, '\P{^Bc:	on}', "");
    Expect(1, 129685, '\p{Bc=:\Aon\z:}', "");;
    Expect(0, 129686, '\p{Bc=:\Aon\z:}', "");;
    Expect(1, 129685, '\p{Bc=-on}', "");
    Expect(0, 129685, '\p{^Bc=-on}', "");
    Expect(0, 129685, '\P{Bc=-on}', "");
    Expect(1, 129685, '\P{^Bc=-on}', "");
    Expect(0, 129686, '\p{Bc=-on}', "");
    Expect(1, 129686, '\p{^Bc=-on}', "");
    Expect(1, 129686, '\P{Bc=-on}', "");
    Expect(0, 129686, '\P{^Bc=-on}', "");
    Error('\p{Is_Bidi_Class=:=	 Other_neutral}');
    Error('\P{Is_Bidi_Class=:=	 Other_neutral}');
    Expect(1, 129685, '\p{Is_Bidi_Class=otherneutral}', "");
    Expect(0, 129685, '\p{^Is_Bidi_Class=otherneutral}', "");
    Expect(0, 129685, '\P{Is_Bidi_Class=otherneutral}', "");
    Expect(1, 129685, '\P{^Is_Bidi_Class=otherneutral}', "");
    Expect(0, 129686, '\p{Is_Bidi_Class=otherneutral}', "");
    Expect(1, 129686, '\p{^Is_Bidi_Class=otherneutral}', "");
    Expect(1, 129686, '\P{Is_Bidi_Class=otherneutral}', "");
    Expect(0, 129686, '\P{^Is_Bidi_Class=otherneutral}', "");
    Expect(1, 129685, '\p{Is_Bidi_Class=_other_NEUTRAL}', "");
    Expect(0, 129685, '\p{^Is_Bidi_Class=_other_NEUTRAL}', "");
    Expect(0, 129685, '\P{Is_Bidi_Class=_other_NEUTRAL}', "");
    Expect(1, 129685, '\P{^Is_Bidi_Class=_other_NEUTRAL}', "");
    Expect(0, 129686, '\p{Is_Bidi_Class=_other_NEUTRAL}', "");
    Expect(1, 129686, '\p{^Is_Bidi_Class=_other_NEUTRAL}', "");
    Expect(1, 129686, '\P{Is_Bidi_Class=_other_NEUTRAL}', "");
    Expect(0, 129686, '\P{^Is_Bidi_Class=_other_NEUTRAL}', "");
    Error('\p{Is_Bc=/a/- ON}');
    Error('\P{Is_Bc=/a/- ON}');
    Expect(1, 129685, '\p{Is_Bc=on}', "");
    Expect(0, 129685, '\p{^Is_Bc=on}', "");
    Expect(0, 129685, '\P{Is_Bc=on}', "");
    Expect(1, 129685, '\P{^Is_Bc=on}', "");
    Expect(0, 129686, '\p{Is_Bc=on}', "");
    Expect(1, 129686, '\p{^Is_Bc=on}', "");
    Expect(1, 129686, '\P{Is_Bc=on}', "");
    Expect(0, 129686, '\P{^Is_Bc=on}', "");
    Expect(1, 129685, '\p{Is_Bc=-ON}', "");
    Expect(0, 129685, '\p{^Is_Bc=-ON}', "");
    Expect(0, 129685, '\P{Is_Bc=-ON}', "");
    Expect(1, 129685, '\P{^Is_Bc=-ON}', "");
    Expect(0, 129686, '\p{Is_Bc=-ON}', "");
    Expect(1, 129686, '\p{^Is_Bc=-ON}', "");
    Expect(1, 129686, '\P{Is_Bc=-ON}', "");
    Expect(0, 129686, '\P{^Is_Bc=-ON}', "");
    Error('\p{Bidi_Class:-:=Pop_Directional_Format}');
    Error('\P{Bidi_Class:-:=Pop_Directional_Format}');
    Expect(1, 8236, '\p{Bidi_Class=:\APop_Directional_Format\z:}', "");;
    Expect(0, 8237, '\p{Bidi_Class=:\APop_Directional_Format\z:}', "");;
    Expect(1, 8236, '\p{Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8236, '\p{^Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8236, '\P{Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8236, '\P{^Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8237, '\p{Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8237, '\p{^Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8237, '\P{Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8237, '\P{^Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8236, '\p{Bidi_Class=:\Apopdirectionalformat\z:}', "");;
    Expect(0, 8237, '\p{Bidi_Class=:\Apopdirectionalformat\z:}', "");;
    Expect(1, 8236, '\p{Bidi_Class:   	POP_Directional_Format}', "");
    Expect(0, 8236, '\p{^Bidi_Class:   	POP_Directional_Format}', "");
    Expect(0, 8236, '\P{Bidi_Class:   	POP_Directional_Format}', "");
    Expect(1, 8236, '\P{^Bidi_Class:   	POP_Directional_Format}', "");
    Expect(0, 8237, '\p{Bidi_Class:   	POP_Directional_Format}', "");
    Expect(1, 8237, '\p{^Bidi_Class:   	POP_Directional_Format}', "");
    Expect(1, 8237, '\P{Bidi_Class:   	POP_Directional_Format}', "");
    Expect(0, 8237, '\P{^Bidi_Class:   	POP_Directional_Format}', "");
    Error('\p{Bc=_/a/PDF}');
    Error('\P{Bc=_/a/PDF}');
    Expect(1, 8236, '\p{Bc=:\APDF\z:}', "");;
    Expect(0, 8237, '\p{Bc=:\APDF\z:}', "");;
    Expect(1, 8236, '\p{Bc=pdf}', "");
    Expect(0, 8236, '\p{^Bc=pdf}', "");
    Expect(0, 8236, '\P{Bc=pdf}', "");
    Expect(1, 8236, '\P{^Bc=pdf}', "");
    Expect(0, 8237, '\p{Bc=pdf}', "");
    Expect(1, 8237, '\p{^Bc=pdf}', "");
    Expect(1, 8237, '\P{Bc=pdf}', "");
    Expect(0, 8237, '\P{^Bc=pdf}', "");
    Expect(1, 8236, '\p{Bc=:\Apdf\z:}', "");;
    Expect(0, 8237, '\p{Bc=:\Apdf\z:}', "");;
    Expect(1, 8236, '\p{Bc= _PDF}', "");
    Expect(0, 8236, '\p{^Bc= _PDF}', "");
    Expect(0, 8236, '\P{Bc= _PDF}', "");
    Expect(1, 8236, '\P{^Bc= _PDF}', "");
    Expect(0, 8237, '\p{Bc= _PDF}', "");
    Expect(1, 8237, '\p{^Bc= _PDF}', "");
    Expect(1, 8237, '\P{Bc= _PDF}', "");
    Expect(0, 8237, '\P{^Bc= _PDF}', "");
    Error('\p{Is_Bidi_Class=	:=Pop_DIRECTIONAL_FORMAT}');
    Error('\P{Is_Bidi_Class=	:=Pop_DIRECTIONAL_FORMAT}');
    Expect(1, 8236, '\p{Is_Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8236, '\p{^Is_Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8236, '\P{Is_Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8236, '\P{^Is_Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8237, '\p{Is_Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8237, '\p{^Is_Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8237, '\P{Is_Bidi_Class=popdirectionalformat}', "");
    Expect(0, 8237, '\P{^Is_Bidi_Class=popdirectionalformat}', "");
    Expect(1, 8236, '\p{Is_Bidi_Class= -Pop_DIRECTIONAL_format}', "");
    Expect(0, 8236, '\p{^Is_Bidi_Class= -Pop_DIRECTIONAL_format}', "");
    Expect(0, 8236, '\P{Is_Bidi_Class= -Pop_DIRECTIONAL_format}', "");
    Expect(1, 8236, '\P{^Is_Bidi_Class= -Pop_DIRECTIONAL_format}', "");
    Expect(0, 8237, '\p{Is_Bidi_Class= -Pop_DIRECTIONAL_format}', "");
    Expect(1, 8237, '\p{^Is_Bidi_Class= -Pop_DIRECTIONAL_format}', "");
    Expect(1, 8237, '\P{Is_Bidi_Class= -Pop_DIRECTIONAL_format}', "");
    Expect(0, 8237, '\P{^Is_Bidi_Class= -Pop_DIRECTIONAL_format}', "");
    Error('\p{Is_Bc=-:=PDF}');
    Error('\P{Is_Bc=-:=PDF}');
    Expect(1, 8236, '\p{Is_Bc=pdf}', "");
    Expect(0, 8236, '\p{^Is_Bc=pdf}', "");
    Expect(0, 8236, '\P{Is_Bc=pdf}', "");
    Expect(1, 8236, '\P{^Is_Bc=pdf}', "");
    Expect(0, 8237, '\p{Is_Bc=pdf}', "");
    Expect(1, 8237, '\p{^Is_Bc=pdf}', "");
    Expect(1, 8237, '\P{Is_Bc=pdf}', "");
    Expect(0, 8237, '\P{^Is_Bc=pdf}', "");
    Expect(1, 8236, '\p{Is_Bc=	_PDF}', "");
    Expect(0, 8236, '\p{^Is_Bc=	_PDF}', "");
    Expect(0, 8236, '\P{Is_Bc=	_PDF}', "");
    Expect(1, 8236, '\P{^Is_Bc=	_PDF}', "");
    Expect(0, 8237, '\p{Is_Bc=	_PDF}', "");
    Expect(1, 8237, '\p{^Is_Bc=	_PDF}', "");
    Expect(1, 8237, '\P{Is_Bc=	_PDF}', "");
    Expect(0, 8237, '\P{^Is_Bc=	_PDF}', "");
    Error('\p{Bidi_Class=_ pop_directional_isolate/a/}');
    Error('\P{Bidi_Class=_ pop_directional_isolate/a/}');
    Expect(1, 8297, '\p{Bidi_Class=:\APop_Directional_Isolate\z:}', "");;
    Expect(0, 8298, '\p{Bidi_Class=:\APop_Directional_Isolate\z:}', "");;
    Expect(1, 8297, '\p{Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8297, '\p{^Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8297, '\P{Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8297, '\P{^Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8298, '\p{Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8298, '\p{^Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8298, '\P{Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8298, '\P{^Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8297, '\p{Bidi_Class=:\Apopdirectionalisolate\z:}', "");;
    Expect(0, 8298, '\p{Bidi_Class=:\Apopdirectionalisolate\z:}', "");;
    Expect(1, 8297, '\p{Bidi_Class:- Pop_DIRECTIONAL_Isolate}', "");
    Expect(0, 8297, '\p{^Bidi_Class:- Pop_DIRECTIONAL_Isolate}', "");
    Expect(0, 8297, '\P{Bidi_Class:- Pop_DIRECTIONAL_Isolate}', "");
    Expect(1, 8297, '\P{^Bidi_Class:- Pop_DIRECTIONAL_Isolate}', "");
    Expect(0, 8298, '\p{Bidi_Class:- Pop_DIRECTIONAL_Isolate}', "");
    Expect(1, 8298, '\p{^Bidi_Class:- Pop_DIRECTIONAL_Isolate}', "");
    Expect(1, 8298, '\P{Bidi_Class:- Pop_DIRECTIONAL_Isolate}', "");
    Expect(0, 8298, '\P{^Bidi_Class:- Pop_DIRECTIONAL_Isolate}', "");
    Error('\p{Bc=	pdi/a/}');
    Error('\P{Bc=	pdi/a/}');
    Expect(1, 8297, '\p{Bc=:\APDI\z:}', "");;
    Expect(0, 8298, '\p{Bc=:\APDI\z:}', "");;
    Expect(1, 8297, '\p{Bc=pdi}', "");
    Expect(0, 8297, '\p{^Bc=pdi}', "");
    Expect(0, 8297, '\P{Bc=pdi}', "");
    Expect(1, 8297, '\P{^Bc=pdi}', "");
    Expect(0, 8298, '\p{Bc=pdi}', "");
    Expect(1, 8298, '\p{^Bc=pdi}', "");
    Expect(1, 8298, '\P{Bc=pdi}', "");
    Expect(0, 8298, '\P{^Bc=pdi}', "");
    Expect(1, 8297, '\p{Bc=:\Apdi\z:}', "");;
    Expect(0, 8298, '\p{Bc=:\Apdi\z:}', "");;
    Expect(1, 8297, '\p{Bc=		PDI}', "");
    Expect(0, 8297, '\p{^Bc=		PDI}', "");
    Expect(0, 8297, '\P{Bc=		PDI}', "");
    Expect(1, 8297, '\P{^Bc=		PDI}', "");
    Expect(0, 8298, '\p{Bc=		PDI}', "");
    Expect(1, 8298, '\p{^Bc=		PDI}', "");
    Expect(1, 8298, '\P{Bc=		PDI}', "");
    Expect(0, 8298, '\P{^Bc=		PDI}', "");
    Error('\p{Is_Bidi_Class=- Pop_Directional_ISOLATE/a/}');
    Error('\P{Is_Bidi_Class=- Pop_Directional_ISOLATE/a/}');
    Expect(1, 8297, '\p{Is_Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8297, '\p{^Is_Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8297, '\P{Is_Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8297, '\P{^Is_Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8298, '\p{Is_Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8298, '\p{^Is_Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8298, '\P{Is_Bidi_Class=popdirectionalisolate}', "");
    Expect(0, 8298, '\P{^Is_Bidi_Class=popdirectionalisolate}', "");
    Expect(1, 8297, '\p{Is_Bidi_Class=		pop_Directional_isolate}', "");
    Expect(0, 8297, '\p{^Is_Bidi_Class=		pop_Directional_isolate}', "");
    Expect(0, 8297, '\P{Is_Bidi_Class=		pop_Directional_isolate}', "");
    Expect(1, 8297, '\P{^Is_Bidi_Class=		pop_Directional_isolate}', "");
    Expect(0, 8298, '\p{Is_Bidi_Class=		pop_Directional_isolate}', "");
    Expect(1, 8298, '\p{^Is_Bidi_Class=		pop_Directional_isolate}', "");
    Expect(1, 8298, '\P{Is_Bidi_Class=		pop_Directional_isolate}', "");
    Expect(0, 8298, '\P{^Is_Bidi_Class=		pop_Directional_isolate}', "");
    Error('\p{Is_Bc:   /a/- PDI}');
    Error('\P{Is_Bc:   /a/- PDI}');
    Expect(1, 8297, '\p{Is_Bc=pdi}', "");
    Expect(0, 8297, '\p{^Is_Bc=pdi}', "");
    Expect(0, 8297, '\P{Is_Bc=pdi}', "");
    Expect(1, 8297, '\P{^Is_Bc=pdi}', "");
    Expect(0, 8298, '\p{Is_Bc=pdi}', "");
    Expect(1, 8298, '\p{^Is_Bc=pdi}', "");
    Expect(1, 8298, '\P{Is_Bc=pdi}', "");
    Expect(0, 8298, '\P{^Is_Bc=pdi}', "");
    Expect(1, 8297, '\p{Is_Bc=_PDI}', "");
    Expect(0, 8297, '\p{^Is_Bc=_PDI}', "");
    Expect(0, 8297, '\P{Is_Bc=_PDI}', "");
    Expect(1, 8297, '\P{^Is_Bc=_PDI}', "");
    Expect(0, 8298, '\p{Is_Bc=_PDI}', "");
    Expect(1, 8298, '\p{^Is_Bc=_PDI}', "");
    Expect(1, 8298, '\P{Is_Bc=_PDI}', "");
    Expect(0, 8298, '\P{^Is_Bc=_PDI}', "");
    Error('\p{Bidi_Class=:=RIGHT_To_LEFT}');
    Error('\P{Bidi_Class=:=RIGHT_To_LEFT}');
    Expect(1, 126975, '\p{Bidi_Class=:\ARight_To_Left\z:}', "");;
    Expect(0, 126976, '\p{Bidi_Class=:\ARight_To_Left\z:}', "");;
    Expect(1, 126975, '\p{Bidi_Class=righttoleft}', "");
    Expect(0, 126975, '\p{^Bidi_Class=righttoleft}', "");
    Expect(0, 126975, '\P{Bidi_Class=righttoleft}', "");
    Expect(1, 126975, '\P{^Bidi_Class=righttoleft}', "");
    Expect(0, 126976, '\p{Bidi_Class=righttoleft}', "");
    Expect(1, 126976, '\p{^Bidi_Class=righttoleft}', "");
    Expect(1, 126976, '\P{Bidi_Class=righttoleft}', "");
    Expect(0, 126976, '\P{^Bidi_Class=righttoleft}', "");
    Expect(1, 126975, '\p{Bidi_Class=:\Arighttoleft\z:}', "");;
    Expect(0, 126976, '\p{Bidi_Class=:\Arighttoleft\z:}', "");;
    Expect(1, 126975, '\p{Bidi_Class=	-Right_To_left}', "");
    Expect(0, 126975, '\p{^Bidi_Class=	-Right_To_left}', "");
    Expect(0, 126975, '\P{Bidi_Class=	-Right_To_left}', "");
    Expect(1, 126975, '\P{^Bidi_Class=	-Right_To_left}', "");
    Expect(0, 126976, '\p{Bidi_Class=	-Right_To_left}', "");
    Expect(1, 126976, '\p{^Bidi_Class=	-Right_To_left}', "");
    Expect(1, 126976, '\P{Bidi_Class=	-Right_To_left}', "");
    Expect(0, 126976, '\P{^Bidi_Class=	-Right_To_left}', "");
    Error('\p{Bc=-R:=}');
    Error('\P{Bc=-R:=}');
    Expect(1, 126975, '\p{Bc=:\AR\z:}', "");;
    Expect(0, 126976, '\p{Bc=:\AR\z:}', "");;
    Expect(1, 126975, '\p{Bc=r}', "");
    Expect(0, 126975, '\p{^Bc=r}', "");
    Expect(0, 126975, '\P{Bc=r}', "");
    Expect(1, 126975, '\P{^Bc=r}', "");
    Expect(0, 126976, '\p{Bc=r}', "");
    Expect(1, 126976, '\p{^Bc=r}', "");
    Expect(1, 126976, '\P{Bc=r}', "");
    Expect(0, 126976, '\P{^Bc=r}', "");
    Expect(1, 126975, '\p{Bc=:\Ar\z:}', "");;
    Expect(0, 126976, '\p{Bc=:\Ar\z:}', "");;
    Expect(1, 126975, '\p{Bc=--R}', "");
    Expect(0, 126975, '\p{^Bc=--R}', "");
    Expect(0, 126975, '\P{Bc=--R}', "");
    Expect(1, 126975, '\P{^Bc=--R}', "");
    Expect(0, 126976, '\p{Bc=--R}', "");
    Expect(1, 126976, '\p{^Bc=--R}', "");
    Expect(1, 126976, '\P{Bc=--R}', "");
    Expect(0, 126976, '\P{^Bc=--R}', "");
    Error('\p{Is_Bidi_Class=:=  RIGHT_TO_left}');
    Error('\P{Is_Bidi_Class=:=  RIGHT_TO_left}');
    Expect(1, 126975, '\p{Is_Bidi_Class=righttoleft}', "");
    Expect(0, 126975, '\p{^Is_Bidi_Class=righttoleft}', "");
    Expect(0, 126975, '\P{Is_Bidi_Class=righttoleft}', "");
    Expect(1, 126975, '\P{^Is_Bidi_Class=righttoleft}', "");
    Expect(0, 126976, '\p{Is_Bidi_Class=righttoleft}', "");
    Expect(1, 126976, '\p{^Is_Bidi_Class=righttoleft}', "");
    Expect(1, 126976, '\P{Is_Bidi_Class=righttoleft}', "");
    Expect(0, 126976, '\P{^Is_Bidi_Class=righttoleft}', "");
    Expect(1, 126975, '\p{Is_Bidi_Class=  Right_To_LEFT}', "");
    Expect(0, 126975, '\p{^Is_Bidi_Class=  Right_To_LEFT}', "");
    Expect(0, 126975, '\P{Is_Bidi_Class=  Right_To_LEFT}', "");
    Expect(1, 126975, '\P{^Is_Bidi_Class=  Right_To_LEFT}', "");
    Expect(0, 126976, '\p{Is_Bidi_Class=  Right_To_LEFT}', "");
    Expect(1, 126976, '\p{^Is_Bidi_Class=  Right_To_LEFT}', "");
    Expect(1, 126976, '\P{Is_Bidi_Class=  Right_To_LEFT}', "");
    Expect(0, 126976, '\P{^Is_Bidi_Class=  Right_To_LEFT}', "");
    Error('\p{Is_Bc=:= R}');
    Error('\P{Is_Bc=:= R}');
    Expect(1, 126975, '\p{Is_Bc=r}', "");
    Expect(0, 126975, '\p{^Is_Bc=r}', "");
    Expect(0, 126975, '\P{Is_Bc=r}', "");
    Expect(1, 126975, '\P{^Is_Bc=r}', "");
    Expect(0, 126976, '\p{Is_Bc=r}', "");
    Expect(1, 126976, '\p{^Is_Bc=r}', "");
    Expect(1, 126976, '\P{Is_Bc=r}', "");
    Expect(0, 126976, '\P{^Is_Bc=r}', "");
    Expect(1, 126975, '\p{Is_Bc:	 R}', "");
    Expect(0, 126975, '\p{^Is_Bc:	 R}', "");
    Expect(0, 126975, '\P{Is_Bc:	 R}', "");
    Expect(1, 126975, '\P{^Is_Bc:	 R}', "");
    Expect(0, 126976, '\p{Is_Bc:	 R}', "");
    Expect(1, 126976, '\p{^Is_Bc:	 R}', "");
    Expect(1, 126976, '\P{Is_Bc:	 R}', "");
    Expect(0, 126976, '\P{^Is_Bc:	 R}', "");
    Error('\p{Bidi_Class=/a/ right_to_left_EMBEDDING}');
    Error('\P{Bidi_Class=/a/ right_to_left_EMBEDDING}');
    Expect(1, 8235, '\p{Bidi_Class=:\ARight_To_Left_Embedding\z:}', "");;
    Expect(0, 8236, '\p{Bidi_Class=:\ARight_To_Left_Embedding\z:}', "");;
    Expect(1, 8235, '\p{Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8235, '\p{^Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8235, '\P{Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8235, '\P{^Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8236, '\p{Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8236, '\p{^Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8236, '\P{Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8236, '\P{^Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8235, '\p{Bidi_Class=:\Arighttoleftembedding\z:}', "");;
    Expect(0, 8236, '\p{Bidi_Class=:\Arighttoleftembedding\z:}', "");;
    Expect(1, 8235, '\p{Bidi_Class= _RIGHT_to_LEFT_embedding}', "");
    Expect(0, 8235, '\p{^Bidi_Class= _RIGHT_to_LEFT_embedding}', "");
    Expect(0, 8235, '\P{Bidi_Class= _RIGHT_to_LEFT_embedding}', "");
    Expect(1, 8235, '\P{^Bidi_Class= _RIGHT_to_LEFT_embedding}', "");
    Expect(0, 8236, '\p{Bidi_Class= _RIGHT_to_LEFT_embedding}', "");
    Expect(1, 8236, '\p{^Bidi_Class= _RIGHT_to_LEFT_embedding}', "");
    Expect(1, 8236, '\P{Bidi_Class= _RIGHT_to_LEFT_embedding}', "");
    Expect(0, 8236, '\P{^Bidi_Class= _RIGHT_to_LEFT_embedding}', "");
    Error('\p{Bc= 	RLE/a/}');
    Error('\P{Bc= 	RLE/a/}');
    Expect(1, 8235, '\p{Bc=:\ARLE\z:}', "");;
    Expect(0, 8236, '\p{Bc=:\ARLE\z:}', "");;
    Expect(1, 8235, '\p{Bc=rle}', "");
    Expect(0, 8235, '\p{^Bc=rle}', "");
    Expect(0, 8235, '\P{Bc=rle}', "");
    Expect(1, 8235, '\P{^Bc=rle}', "");
    Expect(0, 8236, '\p{Bc=rle}', "");
    Expect(1, 8236, '\p{^Bc=rle}', "");
    Expect(1, 8236, '\P{Bc=rle}', "");
    Expect(0, 8236, '\P{^Bc=rle}', "");
    Expect(1, 8235, '\p{Bc=:\Arle\z:}', "");;
    Expect(0, 8236, '\p{Bc=:\Arle\z:}', "");;
    Expect(1, 8235, '\p{Bc=_-RLE}', "");
    Expect(0, 8235, '\p{^Bc=_-RLE}', "");
    Expect(0, 8235, '\P{Bc=_-RLE}', "");
    Expect(1, 8235, '\P{^Bc=_-RLE}', "");
    Expect(0, 8236, '\p{Bc=_-RLE}', "");
    Expect(1, 8236, '\p{^Bc=_-RLE}', "");
    Expect(1, 8236, '\P{Bc=_-RLE}', "");
    Expect(0, 8236, '\P{^Bc=_-RLE}', "");
    Error('\p{Is_Bidi_Class=  Right_to_left_Embedding:=}');
    Error('\P{Is_Bidi_Class=  Right_to_left_Embedding:=}');
    Expect(1, 8235, '\p{Is_Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8235, '\p{^Is_Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8235, '\P{Is_Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8235, '\P{^Is_Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8236, '\p{Is_Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8236, '\p{^Is_Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8236, '\P{Is_Bidi_Class=righttoleftembedding}', "");
    Expect(0, 8236, '\P{^Is_Bidi_Class=righttoleftembedding}', "");
    Expect(1, 8235, '\p{Is_Bidi_Class=	Right_TO_Left_EMBEDDING}', "");
    Expect(0, 8235, '\p{^Is_Bidi_Class=	Right_TO_Left_EMBEDDING}', "");
    Expect(0, 8235, '\P{Is_Bidi_Class=	Right_TO_Left_EMBEDDING}', "");
    Expect(1, 8235, '\P{^Is_Bidi_Class=	Right_TO_Left_EMBEDDING}', "");
    Expect(0, 8236, '\p{Is_Bidi_Class=	Right_TO_Left_EMBEDDING}', "");
    Expect(1, 8236, '\p{^Is_Bidi_Class=	Right_TO_Left_EMBEDDING}', "");
    Expect(1, 8236, '\P{Is_Bidi_Class=	Right_TO_Left_EMBEDDING}', "");
    Expect(0, 8236, '\P{^Is_Bidi_Class=	Right_TO_Left_EMBEDDING}', "");
    Error('\p{Is_Bc:	 	RLE:=}');
    Error('\P{Is_Bc:	 	RLE:=}');
    Expect(1, 8235, '\p{Is_Bc=rle}', "");
    Expect(0, 8235, '\p{^Is_Bc=rle}', "");
    Expect(0, 8235, '\P{Is_Bc=rle}', "");
    Expect(1, 8235, '\P{^Is_Bc=rle}', "");
    Expect(0, 8236, '\p{Is_Bc=rle}', "");
    Expect(1, 8236, '\p{^Is_Bc=rle}', "");
    Expect(1, 8236, '\P{Is_Bc=rle}', "");
    Expect(0, 8236, '\P{^Is_Bc=rle}', "");
    Expect(1, 8235, '\p{Is_Bc= _RLE}', "");
    Expect(0, 8235, '\p{^Is_Bc= _RLE}', "");
    Expect(0, 8235, '\P{Is_Bc= _RLE}', "");
    Expect(1, 8235, '\P{^Is_Bc= _RLE}', "");
    Expect(0, 8236, '\p{Is_Bc= _RLE}', "");
    Expect(1, 8236, '\p{^Is_Bc= _RLE}', "");
    Expect(1, 8236, '\P{Is_Bc= _RLE}', "");
    Expect(0, 8236, '\P{^Is_Bc= _RLE}', "");
    Error('\p{Bidi_Class=-/a/RIGHT_to_left_ISOLATE}');
    Error('\P{Bidi_Class=-/a/RIGHT_to_left_ISOLATE}');
    Expect(1, 8295, '\p{Bidi_Class=:\ARight_To_Left_Isolate\z:}', "");;
    Expect(0, 8296, '\p{Bidi_Class=:\ARight_To_Left_Isolate\z:}', "");;
    Expect(1, 8295, '\p{Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8295, '\p{^Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8295, '\P{Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8295, '\P{^Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8296, '\p{Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8296, '\p{^Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8296, '\P{Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8296, '\P{^Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8295, '\p{Bidi_Class=:\Arighttoleftisolate\z:}', "");;
    Expect(0, 8296, '\p{Bidi_Class=:\Arighttoleftisolate\z:}', "");;
    Expect(1, 8295, '\p{Bidi_Class=	_Right_TO_Left_isolate}', "");
    Expect(0, 8295, '\p{^Bidi_Class=	_Right_TO_Left_isolate}', "");
    Expect(0, 8295, '\P{Bidi_Class=	_Right_TO_Left_isolate}', "");
    Expect(1, 8295, '\P{^Bidi_Class=	_Right_TO_Left_isolate}', "");
    Expect(0, 8296, '\p{Bidi_Class=	_Right_TO_Left_isolate}', "");
    Expect(1, 8296, '\p{^Bidi_Class=	_Right_TO_Left_isolate}', "");
    Expect(1, 8296, '\P{Bidi_Class=	_Right_TO_Left_isolate}', "");
    Expect(0, 8296, '\P{^Bidi_Class=	_Right_TO_Left_isolate}', "");
    Error('\p{Bc=:=_ rli}');
    Error('\P{Bc=:=_ rli}');
    Expect(1, 8295, '\p{Bc=:\ARLI\z:}', "");;
    Expect(0, 8296, '\p{Bc=:\ARLI\z:}', "");;
    Expect(1, 8295, '\p{Bc:   rli}', "");
    Expect(0, 8295, '\p{^Bc:   rli}', "");
    Expect(0, 8295, '\P{Bc:   rli}', "");
    Expect(1, 8295, '\P{^Bc:   rli}', "");
    Expect(0, 8296, '\p{Bc:   rli}', "");
    Expect(1, 8296, '\p{^Bc:   rli}', "");
    Expect(1, 8296, '\P{Bc:   rli}', "");
    Expect(0, 8296, '\P{^Bc:   rli}', "");
    Expect(1, 8295, '\p{Bc=:\Arli\z:}', "");;
    Expect(0, 8296, '\p{Bc=:\Arli\z:}', "");;
    Expect(1, 8295, '\p{Bc=	_RLI}', "");
    Expect(0, 8295, '\p{^Bc=	_RLI}', "");
    Expect(0, 8295, '\P{Bc=	_RLI}', "");
    Expect(1, 8295, '\P{^Bc=	_RLI}', "");
    Expect(0, 8296, '\p{Bc=	_RLI}', "");
    Expect(1, 8296, '\p{^Bc=	_RLI}', "");
    Expect(1, 8296, '\P{Bc=	_RLI}', "");
    Expect(0, 8296, '\P{^Bc=	_RLI}', "");
    Error('\p{Is_Bidi_Class=	:=Right_To_Left_Isolate}');
    Error('\P{Is_Bidi_Class=	:=Right_To_Left_Isolate}');
    Expect(1, 8295, '\p{Is_Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8295, '\p{^Is_Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8295, '\P{Is_Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8295, '\P{^Is_Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8296, '\p{Is_Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8296, '\p{^Is_Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8296, '\P{Is_Bidi_Class=righttoleftisolate}', "");
    Expect(0, 8296, '\P{^Is_Bidi_Class=righttoleftisolate}', "");
    Expect(1, 8295, '\p{Is_Bidi_Class=Right_TO_Left_Isolate}', "");
    Expect(0, 8295, '\p{^Is_Bidi_Class=Right_TO_Left_Isolate}', "");
    Expect(0, 8295, '\P{Is_Bidi_Class=Right_TO_Left_Isolate}', "");
    Expect(1, 8295, '\P{^Is_Bidi_Class=Right_TO_Left_Isolate}', "");
    Expect(0, 8296, '\p{Is_Bidi_Class=Right_TO_Left_Isolate}', "");
    Expect(1, 8296, '\p{^Is_Bidi_Class=Right_TO_Left_Isolate}', "");
    Expect(1, 8296, '\P{Is_Bidi_Class=Right_TO_Left_Isolate}', "");
    Expect(0, 8296, '\P{^Is_Bidi_Class=Right_TO_Left_Isolate}', "");
    Error('\p{Is_Bc= 	RLI:=}');
    Error('\P{Is_Bc= 	RLI:=}');
    Expect(1, 8295, '\p{Is_Bc=rli}', "");
    Expect(0, 8295, '\p{^Is_Bc=rli}', "");
    Expect(0, 8295, '\P{Is_Bc=rli}', "");
    Expect(1, 8295, '\P{^Is_Bc=rli}', "");
    Expect(0, 8296, '\p{Is_Bc=rli}', "");
    Expect(1, 8296, '\p{^Is_Bc=rli}', "");
    Expect(1, 8296, '\P{Is_Bc=rli}', "");
    Expect(0, 8296, '\P{^Is_Bc=rli}', "");
    Expect(1, 8295, '\p{Is_Bc= RLI}', "");
    Expect(0, 8295, '\p{^Is_Bc= RLI}', "");
    Expect(0, 8295, '\P{Is_Bc= RLI}', "");
    Expect(1, 8295, '\P{^Is_Bc= RLI}', "");
    Expect(0, 8296, '\p{Is_Bc= RLI}', "");
    Expect(1, 8296, '\p{^Is_Bc= RLI}', "");
    Expect(1, 8296, '\P{Is_Bc= RLI}', "");
    Expect(0, 8296, '\P{^Is_Bc= RLI}', "");
    Error('\p{Bidi_Class=_	Right_TO_Left_OVERRIDE:=}');
    Error('\P{Bidi_Class=_	Right_TO_Left_OVERRIDE:=}');
    Expect(1, 8238, '\p{Bidi_Class=:\ARight_To_Left_Override\z:}', "");;
    Expect(0, 8239, '\p{Bidi_Class=:\ARight_To_Left_Override\z:}', "");;
    Expect(1, 8238, '\p{Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8238, '\p{^Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8238, '\P{Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8238, '\P{^Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8239, '\p{Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8239, '\p{^Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8239, '\P{Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8239, '\P{^Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8238, '\p{Bidi_Class=:\Arighttoleftoverride\z:}', "");;
    Expect(0, 8239, '\p{Bidi_Class=:\Arighttoleftoverride\z:}', "");;
    Expect(1, 8238, '\p{Bidi_Class=--right_to_LEFT_override}', "");
    Expect(0, 8238, '\p{^Bidi_Class=--right_to_LEFT_override}', "");
    Expect(0, 8238, '\P{Bidi_Class=--right_to_LEFT_override}', "");
    Expect(1, 8238, '\P{^Bidi_Class=--right_to_LEFT_override}', "");
    Expect(0, 8239, '\p{Bidi_Class=--right_to_LEFT_override}', "");
    Expect(1, 8239, '\p{^Bidi_Class=--right_to_LEFT_override}', "");
    Expect(1, 8239, '\P{Bidi_Class=--right_to_LEFT_override}', "");
    Expect(0, 8239, '\P{^Bidi_Class=--right_to_LEFT_override}', "");
    Error('\p{Bc=/a/rlo}');
    Error('\P{Bc=/a/rlo}');
    Expect(1, 8238, '\p{Bc=:\ARLO\z:}', "");;
    Expect(0, 8239, '\p{Bc=:\ARLO\z:}', "");;
    Expect(1, 8238, '\p{Bc=rlo}', "");
    Expect(0, 8238, '\p{^Bc=rlo}', "");
    Expect(0, 8238, '\P{Bc=rlo}', "");
    Expect(1, 8238, '\P{^Bc=rlo}', "");
    Expect(0, 8239, '\p{Bc=rlo}', "");
    Expect(1, 8239, '\p{^Bc=rlo}', "");
    Expect(1, 8239, '\P{Bc=rlo}', "");
    Expect(0, 8239, '\P{^Bc=rlo}', "");
    Expect(1, 8238, '\p{Bc=:\Arlo\z:}', "");;
    Expect(0, 8239, '\p{Bc=:\Arlo\z:}', "");;
    Expect(1, 8238, '\p{Bc= RLO}', "");
    Expect(0, 8238, '\p{^Bc= RLO}', "");
    Expect(0, 8238, '\P{Bc= RLO}', "");
    Expect(1, 8238, '\P{^Bc= RLO}', "");
    Expect(0, 8239, '\p{Bc= RLO}', "");
    Expect(1, 8239, '\p{^Bc= RLO}', "");
    Expect(1, 8239, '\P{Bc= RLO}', "");
    Expect(0, 8239, '\P{^Bc= RLO}', "");
    Error('\p{Is_Bidi_Class:   :=-_Right_To_left_Override}');
    Error('\P{Is_Bidi_Class:   :=-_Right_To_left_Override}');
    Expect(1, 8238, '\p{Is_Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8238, '\p{^Is_Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8238, '\P{Is_Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8238, '\P{^Is_Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8239, '\p{Is_Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8239, '\p{^Is_Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8239, '\P{Is_Bidi_Class=righttoleftoverride}', "");
    Expect(0, 8239, '\P{^Is_Bidi_Class=righttoleftoverride}', "");
    Expect(1, 8238, '\p{Is_Bidi_Class: __Right_To_Left_override}', "");
    Expect(0, 8238, '\p{^Is_Bidi_Class: __Right_To_Left_override}', "");
    Expect(0, 8238, '\P{Is_Bidi_Class: __Right_To_Left_override}', "");
    Expect(1, 8238, '\P{^Is_Bidi_Class: __Right_To_Left_override}', "");
    Expect(0, 8239, '\p{Is_Bidi_Class: __Right_To_Left_override}', "");
    Expect(1, 8239, '\p{^Is_Bidi_Class: __Right_To_Left_override}', "");
    Expect(1, 8239, '\P{Is_Bidi_Class: __Right_To_Left_override}', "");
    Expect(0, 8239, '\P{^Is_Bidi_Class: __Right_To_Left_override}', "");
    Error('\p{Is_Bc=	rlo/a/}');
    Error('\P{Is_Bc=	rlo/a/}');
    Expect(1, 8238, '\p{Is_Bc=rlo}', "");
    Expect(0, 8238, '\p{^Is_Bc=rlo}', "");
    Expect(0, 8238, '\P{Is_Bc=rlo}', "");
    Expect(1, 8238, '\P{^Is_Bc=rlo}', "");
    Expect(0, 8239, '\p{Is_Bc=rlo}', "");
    Expect(1, 8239, '\p{^Is_Bc=rlo}', "");
    Expect(1, 8239, '\P{Is_Bc=rlo}', "");
    Expect(0, 8239, '\P{^Is_Bc=rlo}', "");
    Expect(1, 8238, '\p{Is_Bc= 	RLO}', "");
    Expect(0, 8238, '\p{^Is_Bc= 	RLO}', "");
    Expect(0, 8238, '\P{Is_Bc= 	RLO}', "");
    Expect(1, 8238, '\P{^Is_Bc= 	RLO}', "");
    Expect(0, 8239, '\p{Is_Bc= 	RLO}', "");
    Expect(1, 8239, '\p{^Is_Bc= 	RLO}', "");
    Expect(1, 8239, '\P{Is_Bc= 	RLO}', "");
    Expect(0, 8239, '\P{^Is_Bc= 	RLO}', "");
    Error('\p{Bidi_Class:		/a/segment_Separator}');
    Error('\P{Bidi_Class:		/a/segment_Separator}');
    Expect(1, 31, '\p{Bidi_Class=:\ASegment_Separator\z:}', "");;
    Expect(0, 32, '\p{Bidi_Class=:\ASegment_Separator\z:}', "");;
    Expect(1, 31, '\p{Bidi_Class=segmentseparator}', "");
    Expect(0, 31, '\p{^Bidi_Class=segmentseparator}', "");
    Expect(0, 31, '\P{Bidi_Class=segmentseparator}', "");
    Expect(1, 31, '\P{^Bidi_Class=segmentseparator}', "");
    Expect(0, 32, '\p{Bidi_Class=segmentseparator}', "");
    Expect(1, 32, '\p{^Bidi_Class=segmentseparator}', "");
    Expect(1, 32, '\P{Bidi_Class=segmentseparator}', "");
    Expect(0, 32, '\P{^Bidi_Class=segmentseparator}', "");
    Expect(1, 31, '\p{Bidi_Class=:\Asegmentseparator\z:}', "");;
    Expect(0, 32, '\p{Bidi_Class=:\Asegmentseparator\z:}', "");;
    Expect(1, 31, '\p{Bidi_Class=	segment_separator}', "");
    Expect(0, 31, '\p{^Bidi_Class=	segment_separator}', "");
    Expect(0, 31, '\P{Bidi_Class=	segment_separator}', "");
    Expect(1, 31, '\P{^Bidi_Class=	segment_separator}', "");
    Expect(0, 32, '\p{Bidi_Class=	segment_separator}', "");
    Expect(1, 32, '\p{^Bidi_Class=	segment_separator}', "");
    Expect(1, 32, '\P{Bidi_Class=	segment_separator}', "");
    Expect(0, 32, '\P{^Bidi_Class=	segment_separator}', "");
    Error('\p{Bc=_/a/s}');
    Error('\P{Bc=_/a/s}');
    Expect(1, 31, '\p{Bc=:\AS\z:}', "");;
    Expect(0, 32, '\p{Bc=:\AS\z:}', "");;
    Expect(1, 31, '\p{Bc=s}', "");
    Expect(0, 31, '\p{^Bc=s}', "");
    Expect(0, 31, '\P{Bc=s}', "");
    Expect(1, 31, '\P{^Bc=s}', "");
    Expect(0, 32, '\p{Bc=s}', "");
    Expect(1, 32, '\p{^Bc=s}', "");
    Expect(1, 32, '\P{Bc=s}', "");
    Expect(0, 32, '\P{^Bc=s}', "");
    Expect(1, 31, '\p{Bc=:\As\z:}', "");;
    Expect(0, 32, '\p{Bc=:\As\z:}', "");;
    Expect(1, 31, '\p{Bc=	-S}', "");
    Expect(0, 31, '\p{^Bc=	-S}', "");
    Expect(0, 31, '\P{Bc=	-S}', "");
    Expect(1, 31, '\P{^Bc=	-S}', "");
    Expect(0, 32, '\p{Bc=	-S}', "");
    Expect(1, 32, '\p{^Bc=	-S}', "");
    Expect(1, 32, '\P{Bc=	-S}', "");
    Expect(0, 32, '\P{^Bc=	-S}', "");
    Error('\p{Is_Bidi_Class=:=_ Segment_Separator}');
    Error('\P{Is_Bidi_Class=:=_ Segment_Separator}');
    Expect(1, 31, '\p{Is_Bidi_Class=segmentseparator}', "");
    Expect(0, 31, '\p{^Is_Bidi_Class=segmentseparator}', "");
    Expect(0, 31, '\P{Is_Bidi_Class=segmentseparator}', "");
    Expect(1, 31, '\P{^Is_Bidi_Class=segmentseparator}', "");
    Expect(0, 32, '\p{Is_Bidi_Class=segmentseparator}', "");
    Expect(1, 32, '\p{^Is_Bidi_Class=segmentseparator}', "");
    Expect(1, 32, '\P{Is_Bidi_Class=segmentseparator}', "");
    Expect(0, 32, '\P{^Is_Bidi_Class=segmentseparator}', "");
    Expect(1, 31, '\p{Is_Bidi_Class=	SEGMENT_separator}', "");
    Expect(0, 31, '\p{^Is_Bidi_Class=	SEGMENT_separator}', "");
    Expect(0, 31, '\P{Is_Bidi_Class=	SEGMENT_separator}', "");
    Expect(1, 31, '\P{^Is_Bidi_Class=	SEGMENT_separator}', "");
    Expect(0, 32, '\p{Is_Bidi_Class=	SEGMENT_separator}', "");
    Expect(1, 32, '\p{^Is_Bidi_Class=	SEGMENT_separator}', "");
    Expect(1, 32, '\P{Is_Bidi_Class=	SEGMENT_separator}', "");
    Expect(0, 32, '\P{^Is_Bidi_Class=	SEGMENT_separator}', "");
    Error('\p{Is_Bc=  s/a/}');
    Error('\P{Is_Bc=  s/a/}');
    Expect(1, 31, '\p{Is_Bc:   s}', "");
    Expect(0, 31, '\p{^Is_Bc:   s}', "");
    Expect(0, 31, '\P{Is_Bc:   s}', "");
    Expect(1, 31, '\P{^Is_Bc:   s}', "");
    Expect(0, 32, '\p{Is_Bc:   s}', "");
    Expect(1, 32, '\p{^Is_Bc:   s}', "");
    Expect(1, 32, '\P{Is_Bc:   s}', "");
    Expect(0, 32, '\P{^Is_Bc:   s}', "");
    Expect(1, 31, '\p{Is_Bc=_	S}', "");
    Expect(0, 31, '\p{^Is_Bc=_	S}', "");
    Expect(0, 31, '\P{Is_Bc=_	S}', "");
    Expect(1, 31, '\P{^Is_Bc=_	S}', "");
    Expect(0, 32, '\p{Is_Bc=_	S}', "");
    Expect(1, 32, '\p{^Is_Bc=_	S}', "");
    Expect(1, 32, '\P{Is_Bc=_	S}', "");
    Expect(0, 32, '\P{^Is_Bc=_	S}', "");
    Error('\p{Bidi_Class=:=	-White_space}');
    Error('\P{Bidi_Class=:=	-White_space}');
    Expect(1, 12288, '\p{Bidi_Class=:\AWhite_Space\z:}', "");;
    Expect(0, 12289, '\p{Bidi_Class=:\AWhite_Space\z:}', "");;
    Expect(1, 12288, '\p{Bidi_Class=whitespace}', "");
    Expect(0, 12288, '\p{^Bidi_Class=whitespace}', "");
    Expect(0, 12288, '\P{Bidi_Class=whitespace}', "");
    Expect(1, 12288, '\P{^Bidi_Class=whitespace}', "");
    Expect(0, 12289, '\p{Bidi_Class=whitespace}', "");
    Expect(1, 12289, '\p{^Bidi_Class=whitespace}', "");
    Expect(1, 12289, '\P{Bidi_Class=whitespace}', "");
    Expect(0, 12289, '\P{^Bidi_Class=whitespace}', "");
    Expect(1, 12288, '\p{Bidi_Class=:\Awhitespace\z:}', "");;
    Expect(0, 12289, '\p{Bidi_Class=:\Awhitespace\z:}', "");;
    Expect(1, 12288, '\p{Bidi_Class:   _-WHITE_Space}', "");
    Expect(0, 12288, '\p{^Bidi_Class:   _-WHITE_Space}', "");
    Expect(0, 12288, '\P{Bidi_Class:   _-WHITE_Space}', "");
    Expect(1, 12288, '\P{^Bidi_Class:   _-WHITE_Space}', "");
    Expect(0, 12289, '\p{Bidi_Class:   _-WHITE_Space}', "");
    Expect(1, 12289, '\p{^Bidi_Class:   _-WHITE_Space}', "");
    Expect(1, 12289, '\P{Bidi_Class:   _-WHITE_Space}', "");
    Expect(0, 12289, '\P{^Bidi_Class:   _-WHITE_Space}', "");
    Error('\p{Bc= :=WS}');
    Error('\P{Bc= :=WS}');
    Expect(1, 12288, '\p{Bc=:\AWS\z:}', "");;
    Expect(0, 12289, '\p{Bc=:\AWS\z:}', "");;
    Expect(1, 12288, '\p{Bc=ws}', "");
    Expect(0, 12288, '\p{^Bc=ws}', "");
    Expect(0, 12288, '\P{Bc=ws}', "");
    Expect(1, 12288, '\P{^Bc=ws}', "");
    Expect(0, 12289, '\p{Bc=ws}', "");
    Expect(1, 12289, '\p{^Bc=ws}', "");
    Expect(1, 12289, '\P{Bc=ws}', "");
    Expect(0, 12289, '\P{^Bc=ws}', "");
    Expect(1, 12288, '\p{Bc=:\Aws\z:}', "");;
    Expect(0, 12289, '\p{Bc=:\Aws\z:}', "");;
    Expect(1, 12288, '\p{Bc=__WS}', "");
    Expect(0, 12288, '\p{^Bc=__WS}', "");
    Expect(0, 12288, '\P{Bc=__WS}', "");
    Expect(1, 12288, '\P{^Bc=__WS}', "");
    Expect(0, 12289, '\p{Bc=__WS}', "");
    Expect(1, 12289, '\p{^Bc=__WS}', "");
    Expect(1, 12289, '\P{Bc=__WS}', "");
    Expect(0, 12289, '\P{^Bc=__WS}', "");
    Error('\p{Is_Bidi_Class: :=-white_SPACE}');
    Error('\P{Is_Bidi_Class: :=-white_SPACE}');
    Expect(1, 12288, '\p{Is_Bidi_Class=whitespace}', "");
    Expect(0, 12288, '\p{^Is_Bidi_Class=whitespace}', "");
    Expect(0, 12288, '\P{Is_Bidi_Class=whitespace}', "");
    Expect(1, 12288, '\P{^Is_Bidi_Class=whitespace}', "");
    Expect(0, 12289, '\p{Is_Bidi_Class=whitespace}', "");
    Expect(1, 12289, '\p{^Is_Bidi_Class=whitespace}', "");
    Expect(1, 12289, '\P{Is_Bidi_Class=whitespace}', "");
    Expect(0, 12289, '\P{^Is_Bidi_Class=whitespace}', "");
    Expect(1, 12288, '\p{Is_Bidi_Class=	white_Space}', "");
    Expect(0, 12288, '\p{^Is_Bidi_Class=	white_Space}', "");
    Expect(0, 12288, '\P{Is_Bidi_Class=	white_Space}', "");
    Expect(1, 12288, '\P{^Is_Bidi_Class=	white_Space}', "");
    Expect(0, 12289, '\p{Is_Bidi_Class=	white_Space}', "");
    Expect(1, 12289, '\p{^Is_Bidi_Class=	white_Space}', "");
    Expect(1, 12289, '\P{Is_Bidi_Class=	white_Space}', "");
    Expect(0, 12289, '\P{^Is_Bidi_Class=	white_Space}', "");
    Error('\p{Is_Bc=	 WS/a/}');
    Error('\P{Is_Bc=	 WS/a/}');
    Expect(1, 12288, '\p{Is_Bc=ws}', "");
    Expect(0, 12288, '\p{^Is_Bc=ws}', "");
    Expect(0, 12288, '\P{Is_Bc=ws}', "");
    Expect(1, 12288, '\P{^Is_Bc=ws}', "");
    Expect(0, 12289, '\p{Is_Bc=ws}', "");
    Expect(1, 12289, '\p{^Is_Bc=ws}', "");
    Expect(1, 12289, '\P{Is_Bc=ws}', "");
    Expect(0, 12289, '\P{^Is_Bc=ws}', "");
    Expect(1, 12288, '\p{Is_Bc=WS}', "");
    Expect(0, 12288, '\p{^Is_Bc=WS}', "");
    Expect(0, 12288, '\P{Is_Bc=WS}', "");
    Expect(1, 12288, '\P{^Is_Bc=WS}', "");
    Expect(0, 12289, '\p{Is_Bc=WS}', "");
    Expect(1, 12289, '\p{^Is_Bc=WS}', "");
    Expect(1, 12289, '\P{Is_Bc=WS}', "");
    Expect(0, 12289, '\P{^Is_Bc=WS}', "");
    Error('\p{Bidi_Control=		No:=}');
    Error('\P{Bidi_Control=		No:=}');
    Expect(1, 8298, '\p{Bidi_Control=:\ANo\z:}', "");;
    Expect(0, 8297, '\p{Bidi_Control=:\ANo\z:}', "");;
    Expect(1, 8298, '\p{Bidi_Control=no}', "");
    Expect(0, 8298, '\p{^Bidi_Control=no}', "");
    Expect(0, 8298, '\P{Bidi_Control=no}', "");
    Expect(1, 8298, '\P{^Bidi_Control=no}', "");
    Expect(0, 8297, '\p{Bidi_Control=no}', "");
    Expect(1, 8297, '\p{^Bidi_Control=no}', "");
    Expect(1, 8297, '\P{Bidi_Control=no}', "");
    Expect(0, 8297, '\P{^Bidi_Control=no}', "");
    Expect(1, 8298, '\p{Bidi_Control=:\Ano\z:}', "");;
    Expect(0, 8297, '\p{Bidi_Control=:\Ano\z:}', "");;
    Expect(1, 8298, '\p{Bidi_Control=-No}', "");
    Expect(0, 8298, '\p{^Bidi_Control=-No}', "");
    Expect(0, 8298, '\P{Bidi_Control=-No}', "");
    Expect(1, 8298, '\P{^Bidi_Control=-No}', "");
    Expect(0, 8297, '\p{Bidi_Control=-No}', "");
    Expect(1, 8297, '\p{^Bidi_Control=-No}', "");
    Expect(1, 8297, '\P{Bidi_Control=-No}', "");
    Expect(0, 8297, '\P{^Bidi_Control=-No}', "");
    Error('\p{Bidi_C=-:=N}');
    Error('\P{Bidi_C=-:=N}');
    Expect(1, 8298, '\p{Bidi_C=:\AN\z:}', "");;
    Expect(0, 8297, '\p{Bidi_C=:\AN\z:}', "");;
    Expect(1, 8298, '\p{Bidi_C=n}', "");
    Expect(0, 8298, '\p{^Bidi_C=n}', "");
    Expect(0, 8298, '\P{Bidi_C=n}', "");
    Expect(1, 8298, '\P{^Bidi_C=n}', "");
    Expect(0, 8297, '\p{Bidi_C=n}', "");
    Expect(1, 8297, '\p{^Bidi_C=n}', "");
    Expect(1, 8297, '\P{Bidi_C=n}', "");
    Expect(0, 8297, '\P{^Bidi_C=n}', "");
    Expect(1, 8298, '\p{Bidi_C=:\An\z:}', "");;
    Expect(0, 8297, '\p{Bidi_C=:\An\z:}', "");;
    Expect(1, 8298, '\p{Bidi_C= N}', "");
    Expect(0, 8298, '\p{^Bidi_C= N}', "");
    Expect(0, 8298, '\P{Bidi_C= N}', "");
    Expect(1, 8298, '\P{^Bidi_C= N}', "");
    Expect(0, 8297, '\p{Bidi_C= N}', "");
    Expect(1, 8297, '\p{^Bidi_C= N}', "");
    Expect(1, 8297, '\P{Bidi_C= N}', "");
    Expect(0, 8297, '\P{^Bidi_C= N}', "");
    Error('\p{Is_Bidi_Control=:=--F}');
    Error('\P{Is_Bidi_Control=:=--F}');
    Expect(1, 8298, '\p{Is_Bidi_Control=f}', "");
    Expect(0, 8298, '\p{^Is_Bidi_Control=f}', "");
    Expect(0, 8298, '\P{Is_Bidi_Control=f}', "");
    Expect(1, 8298, '\P{^Is_Bidi_Control=f}', "");
    Expect(0, 8297, '\p{Is_Bidi_Control=f}', "");
    Expect(1, 8297, '\p{^Is_Bidi_Control=f}', "");
    Expect(1, 8297, '\P{Is_Bidi_Control=f}', "");
    Expect(0, 8297, '\P{^Is_Bidi_Control=f}', "");
    Expect(1, 8298, '\p{Is_Bidi_Control= F}', "");
    Expect(0, 8298, '\p{^Is_Bidi_Control= F}', "");
    Expect(0, 8298, '\P{Is_Bidi_Control= F}', "");
    Expect(1, 8298, '\P{^Is_Bidi_Control= F}', "");
    Expect(0, 8297, '\p{Is_Bidi_Control= F}', "");
    Expect(1, 8297, '\p{^Is_Bidi_Control= F}', "");
    Expect(1, 8297, '\P{Is_Bidi_Control= F}', "");
    Expect(0, 8297, '\P{^Is_Bidi_Control= F}', "");
    Error('\p{Is_Bidi_C= False:=}');
    Error('\P{Is_Bidi_C= False:=}');
    Expect(1, 8298, '\p{Is_Bidi_C:false}', "");
    Expect(0, 8298, '\p{^Is_Bidi_C:false}', "");
    Expect(0, 8298, '\P{Is_Bidi_C:false}', "");
    Expect(1, 8298, '\P{^Is_Bidi_C:false}', "");
    Expect(0, 8297, '\p{Is_Bidi_C:false}', "");
    Expect(1, 8297, '\p{^Is_Bidi_C:false}', "");
    Expect(1, 8297, '\P{Is_Bidi_C:false}', "");
    Expect(0, 8297, '\P{^Is_Bidi_C:false}', "");
    Expect(1, 8298, '\p{Is_Bidi_C=-_false}', "");
    Expect(0, 8298, '\p{^Is_Bidi_C=-_false}', "");
    Expect(0, 8298, '\P{Is_Bidi_C=-_false}', "");
    Expect(1, 8298, '\P{^Is_Bidi_C=-_false}', "");
    Expect(0, 8297, '\p{Is_Bidi_C=-_false}', "");
    Expect(1, 8297, '\p{^Is_Bidi_C=-_false}', "");
    Expect(1, 8297, '\P{Is_Bidi_C=-_false}', "");
    Expect(0, 8297, '\P{^Is_Bidi_C=-_false}', "");
    Error('\p{Bidi_Control= -Yes/a/}');
    Error('\P{Bidi_Control= -Yes/a/}');
    Expect(1, 8297, '\p{Bidi_Control=:\AYes\z:}', "");;
    Expect(0, 8298, '\p{Bidi_Control=:\AYes\z:}', "");;
    Expect(1, 8297, '\p{Bidi_Control=yes}', "");
    Expect(0, 8297, '\p{^Bidi_Control=yes}', "");
    Expect(0, 8297, '\P{Bidi_Control=yes}', "");
    Expect(1, 8297, '\P{^Bidi_Control=yes}', "");
    Expect(0, 8298, '\p{Bidi_Control=yes}', "");
    Expect(1, 8298, '\p{^Bidi_Control=yes}', "");
    Expect(1, 8298, '\P{Bidi_Control=yes}', "");
    Expect(0, 8298, '\P{^Bidi_Control=yes}', "");
    Expect(1, 8297, '\p{Bidi_Control=:\Ayes\z:}', "");;
    Expect(0, 8298, '\p{Bidi_Control=:\Ayes\z:}', "");;
    Expect(1, 8297, '\p{Bidi_Control=__yes}', "");
    Expect(0, 8297, '\p{^Bidi_Control=__yes}', "");
    Expect(0, 8297, '\P{Bidi_Control=__yes}', "");
    Expect(1, 8297, '\P{^Bidi_Control=__yes}', "");
    Expect(0, 8298, '\p{Bidi_Control=__yes}', "");
    Expect(1, 8298, '\p{^Bidi_Control=__yes}', "");
    Expect(1, 8298, '\P{Bidi_Control=__yes}', "");
    Expect(0, 8298, '\P{^Bidi_Control=__yes}', "");
    Error('\p{Bidi_C=  Y/a/}');
    Error('\P{Bidi_C=  Y/a/}');
    Expect(1, 8297, '\p{Bidi_C=:\AY\z:}', "");;
    Expect(0, 8298, '\p{Bidi_C=:\AY\z:}', "");;
    Expect(1, 8297, '\p{Bidi_C=y}', "");
    Expect(0, 8297, '\p{^Bidi_C=y}', "");
    Expect(0, 8297, '\P{Bidi_C=y}', "");
    Expect(1, 8297, '\P{^Bidi_C=y}', "");
    Expect(0, 8298, '\p{Bidi_C=y}', "");
    Expect(1, 8298, '\p{^Bidi_C=y}', "");
    Expect(1, 8298, '\P{Bidi_C=y}', "");
    Expect(0, 8298, '\P{^Bidi_C=y}', "");
    Expect(1, 8297, '\p{Bidi_C=:\Ay\z:}', "");;
    Expect(0, 8298, '\p{Bidi_C=:\Ay\z:}', "");;
    Expect(1, 8297, '\p{Bidi_C= -Y}', "");
    Expect(0, 8297, '\p{^Bidi_C= -Y}', "");
    Expect(0, 8297, '\P{Bidi_C= -Y}', "");
    Expect(1, 8297, '\P{^Bidi_C= -Y}', "");
    Expect(0, 8298, '\p{Bidi_C= -Y}', "");
    Expect(1, 8298, '\p{^Bidi_C= -Y}', "");
    Expect(1, 8298, '\P{Bidi_C= -Y}', "");
    Expect(0, 8298, '\P{^Bidi_C= -Y}', "");
    Error('\p{Is_Bidi_Control=/a/_-t}');
    Error('\P{Is_Bidi_Control=/a/_-t}');
    Expect(1, 8297, '\p{Is_Bidi_Control=t}', "");
    Expect(0, 8297, '\p{^Is_Bidi_Control=t}', "");
    Expect(0, 8297, '\P{Is_Bidi_Control=t}', "");
    Expect(1, 8297, '\P{^Is_Bidi_Control=t}', "");
    Expect(0, 8298, '\p{Is_Bidi_Control=t}', "");
    Expect(1, 8298, '\p{^Is_Bidi_Control=t}', "");
    Expect(1, 8298, '\P{Is_Bidi_Control=t}', "");
    Expect(0, 8298, '\P{^Is_Bidi_Control=t}', "");
    Expect(1, 8297, '\p{Is_Bidi_Control= T}', "");
    Expect(0, 8297, '\p{^Is_Bidi_Control= T}', "");
    Expect(0, 8297, '\P{Is_Bidi_Control= T}', "");
    Expect(1, 8297, '\P{^Is_Bidi_Control= T}', "");
    Expect(0, 8298, '\p{Is_Bidi_Control= T}', "");
    Expect(1, 8298, '\p{^Is_Bidi_Control= T}', "");
    Expect(1, 8298, '\P{Is_Bidi_Control= T}', "");
    Expect(0, 8298, '\P{^Is_Bidi_Control= T}', "");
    Error('\p{Is_Bidi_C=:=-True}');
    Error('\P{Is_Bidi_C=:=-True}');
    Expect(1, 8297, '\p{Is_Bidi_C:   true}', "");
    Expect(0, 8297, '\p{^Is_Bidi_C:   true}', "");
    Expect(0, 8297, '\P{Is_Bidi_C:   true}', "");
    Expect(1, 8297, '\P{^Is_Bidi_C:   true}', "");
    Expect(0, 8298, '\p{Is_Bidi_C:   true}', "");
    Expect(1, 8298, '\p{^Is_Bidi_C:   true}', "");
    Expect(1, 8298, '\P{Is_Bidi_C:   true}', "");
    Expect(0, 8298, '\P{^Is_Bidi_C:   true}', "");
    Expect(1, 8297, '\p{Is_Bidi_C=_-true}', "");
    Expect(0, 8297, '\p{^Is_Bidi_C=_-true}', "");
    Expect(0, 8297, '\P{Is_Bidi_C=_-true}', "");
    Expect(1, 8297, '\P{^Is_Bidi_C=_-true}', "");
    Expect(0, 8298, '\p{Is_Bidi_C=_-true}', "");
    Expect(1, 8298, '\p{^Is_Bidi_C=_-true}', "");
    Expect(1, 8298, '\P{Is_Bidi_C=_-true}', "");
    Expect(0, 8298, '\P{^Is_Bidi_C=_-true}', "");
    Error('\p{Bidi_Mirrored=-/a/NO}');
    Error('\P{Bidi_Mirrored=-/a/NO}');
    Expect(1, 120772, '\p{Bidi_Mirrored=:\ANo\z:}', "");;
    Expect(0, 120771, '\p{Bidi_Mirrored=:\ANo\z:}', "");;
    Expect(1, 120772, '\p{Bidi_Mirrored=no}', "");
    Expect(0, 120772, '\p{^Bidi_Mirrored=no}', "");
    Expect(0, 120772, '\P{Bidi_Mirrored=no}', "");
    Expect(1, 120772, '\P{^Bidi_Mirrored=no}', "");
    Expect(0, 120771, '\p{Bidi_Mirrored=no}', "");
    Expect(1, 120771, '\p{^Bidi_Mirrored=no}', "");
    Expect(1, 120771, '\P{Bidi_Mirrored=no}', "");
    Expect(0, 120771, '\P{^Bidi_Mirrored=no}', "");
    Expect(1, 120772, '\p{Bidi_Mirrored=:\Ano\z:}', "");;
    Expect(0, 120771, '\p{Bidi_Mirrored=:\Ano\z:}', "");;
    Expect(1, 120772, '\p{Bidi_Mirrored=_No}', "");
    Expect(0, 120772, '\p{^Bidi_Mirrored=_No}', "");
    Expect(0, 120772, '\P{Bidi_Mirrored=_No}', "");
    Expect(1, 120772, '\P{^Bidi_Mirrored=_No}', "");
    Expect(0, 120771, '\p{Bidi_Mirrored=_No}', "");
    Expect(1, 120771, '\p{^Bidi_Mirrored=_No}', "");
    Expect(1, 120771, '\P{Bidi_Mirrored=_No}', "");
    Expect(0, 120771, '\P{^Bidi_Mirrored=_No}', "");
    Error('\p{Bidi_M=	N/a/}');
    Error('\P{Bidi_M=	N/a/}');
    Expect(1, 120772, '\p{Bidi_M=:\AN\z:}', "");;
    Expect(0, 120771, '\p{Bidi_M=:\AN\z:}', "");;
    Expect(1, 120772, '\p{Bidi_M=n}', "");
    Expect(0, 120772, '\p{^Bidi_M=n}', "");
    Expect(0, 120772, '\P{Bidi_M=n}', "");
    Expect(1, 120772, '\P{^Bidi_M=n}', "");
    Expect(0, 120771, '\p{Bidi_M=n}', "");
    Expect(1, 120771, '\p{^Bidi_M=n}', "");
    Expect(1, 120771, '\P{Bidi_M=n}', "");
    Expect(0, 120771, '\P{^Bidi_M=n}', "");
    Expect(1, 120772, '\p{Bidi_M=:\An\z:}', "");;
    Expect(0, 120771, '\p{Bidi_M=:\An\z:}', "");;
    Expect(1, 120772, '\p{Bidi_M=	n}', "");
    Expect(0, 120772, '\p{^Bidi_M=	n}', "");
    Expect(0, 120772, '\P{Bidi_M=	n}', "");
    Expect(1, 120772, '\P{^Bidi_M=	n}', "");
    Expect(0, 120771, '\p{Bidi_M=	n}', "");
    Expect(1, 120771, '\p{^Bidi_M=	n}', "");
    Expect(1, 120771, '\P{Bidi_M=	n}', "");
    Expect(0, 120771, '\P{^Bidi_M=	n}', "");
    Error('\p{Is_Bidi_Mirrored=--F:=}');
    Error('\P{Is_Bidi_Mirrored=--F:=}');
    Expect(1, 120772, '\p{Is_Bidi_Mirrored:	f}', "");
    Expect(0, 120772, '\p{^Is_Bidi_Mirrored:	f}', "");
    Expect(0, 120772, '\P{Is_Bidi_Mirrored:	f}', "");
    Expect(1, 120772, '\P{^Is_Bidi_Mirrored:	f}', "");
    Expect(0, 120771, '\p{Is_Bidi_Mirrored:	f}', "");
    Expect(1, 120771, '\p{^Is_Bidi_Mirrored:	f}', "");
    Expect(1, 120771, '\P{Is_Bidi_Mirrored:	f}', "");
    Expect(0, 120771, '\P{^Is_Bidi_Mirrored:	f}', "");
    Expect(1, 120772, '\p{Is_Bidi_Mirrored=_ F}', "");
    Expect(0, 120772, '\p{^Is_Bidi_Mirrored=_ F}', "");
    Expect(0, 120772, '\P{Is_Bidi_Mirrored=_ F}', "");
    Expect(1, 120772, '\P{^Is_Bidi_Mirrored=_ F}', "");
    Expect(0, 120771, '\p{Is_Bidi_Mirrored=_ F}', "");
    Expect(1, 120771, '\p{^Is_Bidi_Mirrored=_ F}', "");
    Expect(1, 120771, '\P{Is_Bidi_Mirrored=_ F}', "");
    Expect(0, 120771, '\P{^Is_Bidi_Mirrored=_ F}', "");
    Error('\p{Is_Bidi_M=/a/-_False}');
    Error('\P{Is_Bidi_M=/a/-_False}');
    Expect(1, 120772, '\p{Is_Bidi_M=false}', "");
    Expect(0, 120772, '\p{^Is_Bidi_M=false}', "");
    Expect(0, 120772, '\P{Is_Bidi_M=false}', "");
    Expect(1, 120772, '\P{^Is_Bidi_M=false}', "");
    Expect(0, 120771, '\p{Is_Bidi_M=false}', "");
    Expect(1, 120771, '\p{^Is_Bidi_M=false}', "");
    Expect(1, 120771, '\P{Is_Bidi_M=false}', "");
    Expect(0, 120771, '\P{^Is_Bidi_M=false}', "");
    Expect(1, 120772, '\p{Is_Bidi_M=	 False}', "");
    Expect(0, 120772, '\p{^Is_Bidi_M=	 False}', "");
    Expect(0, 120772, '\P{Is_Bidi_M=	 False}', "");
    Expect(1, 120772, '\P{^Is_Bidi_M=	 False}', "");
    Expect(0, 120771, '\p{Is_Bidi_M=	 False}', "");
    Expect(1, 120771, '\p{^Is_Bidi_M=	 False}', "");
    Expect(1, 120771, '\P{Is_Bidi_M=	 False}', "");
    Expect(0, 120771, '\P{^Is_Bidi_M=	 False}', "");
    Error('\p{Bidi_Mirrored=/a/Yes}');
    Error('\P{Bidi_Mirrored=/a/Yes}');
    Expect(1, 120771, '\p{Bidi_Mirrored=:\AYes\z:}', "");;
    Expect(0, 120772, '\p{Bidi_Mirrored=:\AYes\z:}', "");;
    Expect(1, 120771, '\p{Bidi_Mirrored=yes}', "");
    Expect(0, 120771, '\p{^Bidi_Mirrored=yes}', "");
    Expect(0, 120771, '\P{Bidi_Mirrored=yes}', "");
    Expect(1, 120771, '\P{^Bidi_Mirrored=yes}', "");
    Expect(0, 120772, '\p{Bidi_Mirrored=yes}', "");
    Expect(1, 120772, '\p{^Bidi_Mirrored=yes}', "");
    Expect(1, 120772, '\P{Bidi_Mirrored=yes}', "");
    Expect(0, 120772, '\P{^Bidi_Mirrored=yes}', "");
    Expect(1, 120771, '\p{Bidi_Mirrored=:\Ayes\z:}', "");;
    Expect(0, 120772, '\p{Bidi_Mirrored=:\Ayes\z:}', "");;
    Expect(1, 120771, '\p{Bidi_Mirrored=__Yes}', "");
    Expect(0, 120771, '\p{^Bidi_Mirrored=__Yes}', "");
    Expect(0, 120771, '\P{Bidi_Mirrored=__Yes}', "");
    Expect(1, 120771, '\P{^Bidi_Mirrored=__Yes}', "");
    Expect(0, 120772, '\p{Bidi_Mirrored=__Yes}', "");
    Expect(1, 120772, '\p{^Bidi_Mirrored=__Yes}', "");
    Expect(1, 120772, '\P{Bidi_Mirrored=__Yes}', "");
    Expect(0, 120772, '\P{^Bidi_Mirrored=__Yes}', "");
    Error('\p{Bidi_M=:= Y}');
    Error('\P{Bidi_M=:= Y}');
    Expect(1, 120771, '\p{Bidi_M=:\AY\z:}', "");;
    Expect(0, 120772, '\p{Bidi_M=:\AY\z:}', "");;
    Expect(1, 120771, '\p{Bidi_M:y}', "");
    Expect(0, 120771, '\p{^Bidi_M:y}', "");
    Expect(0, 120771, '\P{Bidi_M:y}', "");
    Expect(1, 120771, '\P{^Bidi_M:y}', "");
    Expect(0, 120772, '\p{Bidi_M:y}', "");
    Expect(1, 120772, '\p{^Bidi_M:y}', "");
    Expect(1, 120772, '\P{Bidi_M:y}', "");
    Expect(0, 120772, '\P{^Bidi_M:y}', "");
    Expect(1, 120771, '\p{Bidi_M=:\Ay\z:}', "");;
    Expect(0, 120772, '\p{Bidi_M=:\Ay\z:}', "");;
    Expect(1, 120771, '\p{Bidi_M=_y}', "");
    Expect(0, 120771, '\p{^Bidi_M=_y}', "");
    Expect(0, 120771, '\P{Bidi_M=_y}', "");
    Expect(1, 120771, '\P{^Bidi_M=_y}', "");
    Expect(0, 120772, '\p{Bidi_M=_y}', "");
    Expect(1, 120772, '\p{^Bidi_M=_y}', "");
    Expect(1, 120772, '\P{Bidi_M=_y}', "");
    Expect(0, 120772, '\P{^Bidi_M=_y}', "");
    Error('\p{Is_Bidi_Mirrored=/a/ 	T}');
    Error('\P{Is_Bidi_Mirrored=/a/ 	T}');
    Expect(1, 120771, '\p{Is_Bidi_Mirrored=t}', "");
    Expect(0, 120771, '\p{^Is_Bidi_Mirrored=t}', "");
    Expect(0, 120771, '\P{Is_Bidi_Mirrored=t}', "");
    Expect(1, 120771, '\P{^Is_Bidi_Mirrored=t}', "");
    Expect(0, 120772, '\p{Is_Bidi_Mirrored=t}', "");
    Expect(1, 120772, '\p{^Is_Bidi_Mirrored=t}', "");
    Expect(1, 120772, '\P{Is_Bidi_Mirrored=t}', "");
    Expect(0, 120772, '\P{^Is_Bidi_Mirrored=t}', "");
    Expect(1, 120771, '\p{Is_Bidi_Mirrored=	T}', "");
    Expect(0, 120771, '\p{^Is_Bidi_Mirrored=	T}', "");
    Expect(0, 120771, '\P{Is_Bidi_Mirrored=	T}', "");
    Expect(1, 120771, '\P{^Is_Bidi_Mirrored=	T}', "");
    Expect(0, 120772, '\p{Is_Bidi_Mirrored=	T}', "");
    Expect(1, 120772, '\p{^Is_Bidi_Mirrored=	T}', "");
    Expect(1, 120772, '\P{Is_Bidi_Mirrored=	T}', "");
    Expect(0, 120772, '\P{^Is_Bidi_Mirrored=	T}', "");
    Error('\p{Is_Bidi_M:	-/a/true}');
    Error('\P{Is_Bidi_M:	-/a/true}');
    Expect(1, 120771, '\p{Is_Bidi_M=true}', "");
    Expect(0, 120771, '\p{^Is_Bidi_M=true}', "");
    Expect(0, 120771, '\P{Is_Bidi_M=true}', "");
    Expect(1, 120771, '\P{^Is_Bidi_M=true}', "");
    Expect(0, 120772, '\p{Is_Bidi_M=true}', "");
    Expect(1, 120772, '\p{^Is_Bidi_M=true}', "");
    Expect(1, 120772, '\P{Is_Bidi_M=true}', "");
    Expect(0, 120772, '\P{^Is_Bidi_M=true}', "");
    Expect(1, 120771, '\p{Is_Bidi_M=TRUE}', "");
    Expect(0, 120771, '\p{^Is_Bidi_M=TRUE}', "");
    Expect(0, 120771, '\P{Is_Bidi_M=TRUE}', "");
    Expect(1, 120771, '\P{^Is_Bidi_M=TRUE}', "");
    Expect(0, 120772, '\p{Is_Bidi_M=TRUE}', "");
    Expect(1, 120772, '\p{^Is_Bidi_M=TRUE}', "");
    Expect(1, 120772, '\P{Is_Bidi_M=TRUE}', "");
    Expect(0, 120772, '\P{^Is_Bidi_M=TRUE}', "");
    Error('\p{block}');
    Error('\P{block}');
    Error('\p{blk}');
    Error('\P{blk}');
    Error('\p{Block:	-_Adlam:=}');
    Error('\P{Block:	-_Adlam:=}');
    Expect(1, 125279, '\p{Block=:\AAdlam\z:}', "");;
    Expect(0, 125280, '\p{Block=:\AAdlam\z:}', "");;
    Expect(1, 125279, '\p{Block=adlam}', "");
    Expect(0, 125279, '\p{^Block=adlam}', "");
    Expect(0, 125279, '\P{Block=adlam}', "");
    Expect(1, 125279, '\P{^Block=adlam}', "");
    Expect(0, 125280, '\p{Block=adlam}', "");
    Expect(1, 125280, '\p{^Block=adlam}', "");
    Expect(1, 125280, '\P{Block=adlam}', "");
    Expect(0, 125280, '\P{^Block=adlam}', "");
    Expect(1, 125279, '\p{Block=:\Aadlam\z:}', "");;
    Expect(0, 125280, '\p{Block=:\Aadlam\z:}', "");;
    Expect(1, 125279, '\p{Block=_	Adlam}', "");
    Expect(0, 125279, '\p{^Block=_	Adlam}', "");
    Expect(0, 125279, '\P{Block=_	Adlam}', "");
    Expect(1, 125279, '\P{^Block=_	Adlam}', "");
    Expect(0, 125280, '\p{Block=_	Adlam}', "");
    Expect(1, 125280, '\p{^Block=_	Adlam}', "");
    Expect(1, 125280, '\P{Block=_	Adlam}', "");
    Expect(0, 125280, '\P{^Block=_	Adlam}', "");
    Error('\p{Blk=:=		adlam}');
    Error('\P{Blk=:=		adlam}');
    Expect(1, 125279, '\p{Blk=:\AAdlam\z:}', "");;
    Expect(0, 125280, '\p{Blk=:\AAdlam\z:}', "");;
    Expect(1, 125279, '\p{Blk=adlam}', "");
    Expect(0, 125279, '\p{^Blk=adlam}', "");
    Expect(0, 125279, '\P{Blk=adlam}', "");
    Expect(1, 125279, '\P{^Blk=adlam}', "");
    Expect(0, 125280, '\p{Blk=adlam}', "");
    Expect(1, 125280, '\p{^Blk=adlam}', "");
    Expect(1, 125280, '\P{Blk=adlam}', "");
    Expect(0, 125280, '\P{^Blk=adlam}', "");
    Expect(1, 125279, '\p{Blk=:\Aadlam\z:}', "");;
    Expect(0, 125280, '\p{Blk=:\Aadlam\z:}', "");;
    Expect(1, 125279, '\p{Blk=_	Adlam}', "");
    Expect(0, 125279, '\p{^Blk=_	Adlam}', "");
    Expect(0, 125279, '\P{Blk=_	Adlam}', "");
    Expect(1, 125279, '\P{^Blk=_	Adlam}', "");
    Expect(0, 125280, '\p{Blk=_	Adlam}', "");
    Expect(1, 125280, '\p{^Blk=_	Adlam}', "");
    Expect(1, 125280, '\P{Blk=_	Adlam}', "");
    Expect(0, 125280, '\P{^Blk=_	Adlam}', "");
    Error('\p{Is_Block:/a/		adlam}');
    Error('\P{Is_Block:/a/		adlam}');
    Expect(1, 125279, '\p{Is_Block:adlam}', "");
    Expect(0, 125279, '\p{^Is_Block:adlam}', "");
    Expect(0, 125279, '\P{Is_Block:adlam}', "");
    Expect(1, 125279, '\P{^Is_Block:adlam}', "");
    Expect(0, 125280, '\p{Is_Block:adlam}', "");
    Expect(1, 125280, '\p{^Is_Block:adlam}', "");
    Expect(1, 125280, '\P{Is_Block:adlam}', "");
    Expect(0, 125280, '\P{^Is_Block:adlam}', "");
    Expect(1, 125279, '\p{Is_Block=__Adlam}', "");
    Expect(0, 125279, '\p{^Is_Block=__Adlam}', "");
    Expect(0, 125279, '\P{Is_Block=__Adlam}', "");
    Expect(1, 125279, '\P{^Is_Block=__Adlam}', "");
    Expect(0, 125280, '\p{Is_Block=__Adlam}', "");
    Expect(1, 125280, '\p{^Is_Block=__Adlam}', "");
    Expect(1, 125280, '\P{Is_Block=__Adlam}', "");
    Expect(0, 125280, '\P{^Is_Block=__Adlam}', "");
    Error('\p{Is_Blk=:=_ adlam}');
    Error('\P{Is_Blk=:=_ adlam}');
    Expect(1, 125279, '\p{Is_Blk=adlam}', "");
    Expect(0, 125279, '\p{^Is_Blk=adlam}', "");
    Expect(0, 125279, '\P{Is_Blk=adlam}', "");
    Expect(1, 125279, '\P{^Is_Blk=adlam}', "");
    Expect(0, 125280, '\p{Is_Blk=adlam}', "");
    Expect(1, 125280, '\p{^Is_Blk=adlam}', "");
    Expect(1, 125280, '\P{Is_Blk=adlam}', "");
    Expect(0, 125280, '\P{^Is_Blk=adlam}', "");
    Expect(1, 125279, '\p{Is_Blk=	_ADLAM}', "");
    Expect(0, 125279, '\p{^Is_Blk=	_ADLAM}', "");
    Expect(0, 125279, '\P{Is_Blk=	_ADLAM}', "");
    Expect(1, 125279, '\P{^Is_Blk=	_ADLAM}', "");
    Expect(0, 125280, '\p{Is_Blk=	_ADLAM}', "");
    Expect(1, 125280, '\p{^Is_Blk=	_ADLAM}', "");
    Expect(1, 125280, '\P{Is_Blk=	_ADLAM}', "");
    Expect(0, 125280, '\P{^Is_Blk=	_ADLAM}', "");
    Error('\p{Block:   		aegean_Numbers/a/}');
    Error('\P{Block:   		aegean_Numbers/a/}');
    Expect(1, 65855, '\p{Block=:\AAegean_Numbers\z:}', "");;
    Expect(0, 65856, '\p{Block=:\AAegean_Numbers\z:}', "");;
    Expect(1, 65855, '\p{Block=aegeannumbers}', "");
    Expect(0, 65855, '\p{^Block=aegeannumbers}', "");
    Expect(0, 65855, '\P{Block=aegeannumbers}', "");
    Expect(1, 65855, '\P{^Block=aegeannumbers}', "");
    Expect(0, 65856, '\p{Block=aegeannumbers}', "");
    Expect(1, 65856, '\p{^Block=aegeannumbers}', "");
    Expect(1, 65856, '\P{Block=aegeannumbers}', "");
    Expect(0, 65856, '\P{^Block=aegeannumbers}', "");
    Expect(1, 65855, '\p{Block=:\Aaegeannumbers\z:}', "");;
    Expect(0, 65856, '\p{Block=:\Aaegeannumbers\z:}', "");;
    Expect(1, 65855, '\p{Block=	Aegean_Numbers}', "");
    Expect(0, 65855, '\p{^Block=	Aegean_Numbers}', "");
    Expect(0, 65855, '\P{Block=	Aegean_Numbers}', "");
    Expect(1, 65855, '\P{^Block=	Aegean_Numbers}', "");
    Expect(0, 65856, '\p{Block=	Aegean_Numbers}', "");
    Expect(1, 65856, '\p{^Block=	Aegean_Numbers}', "");
    Expect(1, 65856, '\P{Block=	Aegean_Numbers}', "");
    Expect(0, 65856, '\P{^Block=	Aegean_Numbers}', "");
    Error('\p{Blk:		_Aegean_Numbers/a/}');
    Error('\P{Blk:		_Aegean_Numbers/a/}');
    Expect(1, 65855, '\p{Blk=:\AAegean_Numbers\z:}', "");;
    Expect(0, 65856, '\p{Blk=:\AAegean_Numbers\z:}', "");;
    Expect(1, 65855, '\p{Blk=aegeannumbers}', "");
    Expect(0, 65855, '\p{^Blk=aegeannumbers}', "");
    Expect(0, 65855, '\P{Blk=aegeannumbers}', "");
    Expect(1, 65855, '\P{^Blk=aegeannumbers}', "");
    Expect(0, 65856, '\p{Blk=aegeannumbers}', "");
    Expect(1, 65856, '\p{^Blk=aegeannumbers}', "");
    Expect(1, 65856, '\P{Blk=aegeannumbers}', "");
    Expect(0, 65856, '\P{^Blk=aegeannumbers}', "");
    Expect(1, 65855, '\p{Blk=:\Aaegeannumbers\z:}', "");;
    Expect(0, 65856, '\p{Blk=:\Aaegeannumbers\z:}', "");;
    Expect(1, 65855, '\p{Blk= -Aegean_NUMBERS}', "");
    Expect(0, 65855, '\p{^Blk= -Aegean_NUMBERS}', "");
    Expect(0, 65855, '\P{Blk= -Aegean_NUMBERS}', "");
    Expect(1, 65855, '\P{^Blk= -Aegean_NUMBERS}', "");
    Expect(0, 65856, '\p{Blk= -Aegean_NUMBERS}', "");
    Expect(1, 65856, '\p{^Blk= -Aegean_NUMBERS}', "");
    Expect(1, 65856, '\P{Blk= -Aegean_NUMBERS}', "");
    Expect(0, 65856, '\P{^Blk= -Aegean_NUMBERS}', "");
    Error('\p{Is_Block=-:=Aegean_Numbers}');
    Error('\P{Is_Block=-:=Aegean_Numbers}');
    Expect(1, 65855, '\p{Is_Block=aegeannumbers}', "");
    Expect(0, 65855, '\p{^Is_Block=aegeannumbers}', "");
    Expect(0, 65855, '\P{Is_Block=aegeannumbers}', "");
    Expect(1, 65855, '\P{^Is_Block=aegeannumbers}', "");
    Expect(0, 65856, '\p{Is_Block=aegeannumbers}', "");
    Expect(1, 65856, '\p{^Is_Block=aegeannumbers}', "");
    Expect(1, 65856, '\P{Is_Block=aegeannumbers}', "");
    Expect(0, 65856, '\P{^Is_Block=aegeannumbers}', "");
    Expect(1, 65855, '\p{Is_Block=- AEGEAN_numbers}', "");
    Expect(0, 65855, '\p{^Is_Block=- AEGEAN_numbers}', "");
    Expect(0, 65855, '\P{Is_Block=- AEGEAN_numbers}', "");
    Expect(1, 65855, '\P{^Is_Block=- AEGEAN_numbers}', "");
    Expect(0, 65856, '\p{Is_Block=- AEGEAN_numbers}', "");
    Expect(1, 65856, '\p{^Is_Block=- AEGEAN_numbers}', "");
    Expect(1, 65856, '\P{Is_Block=- AEGEAN_numbers}', "");
    Expect(0, 65856, '\P{^Is_Block=- AEGEAN_numbers}', "");
    Error('\p{Is_Blk=:=_ aegean_numbers}');
    Error('\P{Is_Blk=:=_ aegean_numbers}');
    Expect(1, 65855, '\p{Is_Blk:	aegeannumbers}', "");
    Expect(0, 65855, '\p{^Is_Blk:	aegeannumbers}', "");
    Expect(0, 65855, '\P{Is_Blk:	aegeannumbers}', "");
    Expect(1, 65855, '\P{^Is_Blk:	aegeannumbers}', "");
    Expect(0, 65856, '\p{Is_Blk:	aegeannumbers}', "");
    Expect(1, 65856, '\p{^Is_Blk:	aegeannumbers}', "");
    Expect(1, 65856, '\P{Is_Blk:	aegeannumbers}', "");
    Expect(0, 65856, '\P{^Is_Blk:	aegeannumbers}', "");
    Expect(1, 65855, '\p{Is_Blk:   	_AEGEAN_NUMBERS}', "");
    Expect(0, 65855, '\p{^Is_Blk:   	_AEGEAN_NUMBERS}', "");
    Expect(0, 65855, '\P{Is_Blk:   	_AEGEAN_NUMBERS}', "");
    Expect(1, 65855, '\P{^Is_Blk:   	_AEGEAN_NUMBERS}', "");
    Expect(0, 65856, '\p{Is_Blk:   	_AEGEAN_NUMBERS}', "");
    Expect(1, 65856, '\p{^Is_Blk:   	_AEGEAN_NUMBERS}', "");
    Expect(1, 65856, '\P{Is_Blk:   	_AEGEAN_NUMBERS}', "");
    Expect(0, 65856, '\P{^Is_Blk:   	_AEGEAN_NUMBERS}', "");
    Error('\p{Block=-:=AHOM}');
    Error('\P{Block=-:=AHOM}');
    Expect(1, 71487, '\p{Block=:\AAhom\z:}', "");;
    Expect(0, 71488, '\p{Block=:\AAhom\z:}', "");;
    Expect(1, 71487, '\p{Block=ahom}', "");
    Expect(0, 71487, '\p{^Block=ahom}', "");
    Expect(0, 71487, '\P{Block=ahom}', "");
    Expect(1, 71487, '\P{^Block=ahom}', "");
    Expect(0, 71488, '\p{Block=ahom}', "");
    Expect(1, 71488, '\p{^Block=ahom}', "");
    Expect(1, 71488, '\P{Block=ahom}', "");
    Expect(0, 71488, '\P{^Block=ahom}', "");
    Expect(1, 71487, '\p{Block=:\Aahom\z:}', "");;
    Expect(0, 71488, '\p{Block=:\Aahom\z:}', "");;
    Expect(1, 71487, '\p{Block=_AHOM}', "");
    Expect(0, 71487, '\p{^Block=_AHOM}', "");
    Expect(0, 71487, '\P{Block=_AHOM}', "");
    Expect(1, 71487, '\P{^Block=_AHOM}', "");
    Expect(0, 71488, '\p{Block=_AHOM}', "");
    Expect(1, 71488, '\p{^Block=_AHOM}', "");
    Expect(1, 71488, '\P{Block=_AHOM}', "");
    Expect(0, 71488, '\P{^Block=_AHOM}', "");
    Error('\p{Blk=-_Ahom/a/}');
    Error('\P{Blk=-_Ahom/a/}');
    Expect(1, 71487, '\p{Blk=:\AAhom\z:}', "");;
    Expect(0, 71488, '\p{Blk=:\AAhom\z:}', "");;
    Expect(1, 71487, '\p{Blk=ahom}', "");
    Expect(0, 71487, '\p{^Blk=ahom}', "");
    Expect(0, 71487, '\P{Blk=ahom}', "");
    Expect(1, 71487, '\P{^Blk=ahom}', "");
    Expect(0, 71488, '\p{Blk=ahom}', "");
    Expect(1, 71488, '\p{^Blk=ahom}', "");
    Expect(1, 71488, '\P{Blk=ahom}', "");
    Expect(0, 71488, '\P{^Blk=ahom}', "");
    Expect(1, 71487, '\p{Blk=:\Aahom\z:}', "");;
    Expect(0, 71488, '\p{Blk=:\Aahom\z:}', "");;
    Expect(1, 71487, '\p{Blk=	 Ahom}', "");
    Expect(0, 71487, '\p{^Blk=	 Ahom}', "");
    Expect(0, 71487, '\P{Blk=	 Ahom}', "");
    Expect(1, 71487, '\P{^Blk=	 Ahom}', "");
    Expect(0, 71488, '\p{Blk=	 Ahom}', "");
    Expect(1, 71488, '\p{^Blk=	 Ahom}', "");
    Expect(1, 71488, '\P{Blk=	 Ahom}', "");
    Expect(0, 71488, '\P{^Blk=	 Ahom}', "");
    Error('\p{Is_Block=_/a/AHOM}');
    Error('\P{Is_Block=_/a/AHOM}');
    Expect(1, 71487, '\p{Is_Block=ahom}', "");
    Expect(0, 71487, '\p{^Is_Block=ahom}', "");
    Expect(0, 71487, '\P{Is_Block=ahom}', "");
    Expect(1, 71487, '\P{^Is_Block=ahom}', "");
    Expect(0, 71488, '\p{Is_Block=ahom}', "");
    Expect(1, 71488, '\p{^Is_Block=ahom}', "");
    Expect(1, 71488, '\P{Is_Block=ahom}', "");
    Expect(0, 71488, '\P{^Is_Block=ahom}', "");
    Expect(1, 71487, '\p{Is_Block=_-Ahom}', "");
    Expect(0, 71487, '\p{^Is_Block=_-Ahom}', "");
    Expect(0, 71487, '\P{Is_Block=_-Ahom}', "");
    Expect(1, 71487, '\P{^Is_Block=_-Ahom}', "");
    Expect(0, 71488, '\p{Is_Block=_-Ahom}', "");
    Expect(1, 71488, '\p{^Is_Block=_-Ahom}', "");
    Expect(1, 71488, '\P{Is_Block=_-Ahom}', "");
    Expect(0, 71488, '\P{^Is_Block=_-Ahom}', "");
    Error('\p{Is_Blk=-:=AHOM}');
    Error('\P{Is_Blk=-:=AHOM}');
    Expect(1, 71487, '\p{Is_Blk=ahom}', "");
    Expect(0, 71487, '\p{^Is_Blk=ahom}', "");
    Expect(0, 71487, '\P{Is_Blk=ahom}', "");
    Expect(1, 71487, '\P{^Is_Blk=ahom}', "");
    Expect(0, 71488, '\p{Is_Blk=ahom}', "");
    Expect(1, 71488, '\p{^Is_Blk=ahom}', "");
    Expect(1, 71488, '\P{Is_Blk=ahom}', "");
    Expect(0, 71488, '\P{^Is_Blk=ahom}', "");
    Expect(1, 71487, '\p{Is_Blk=-ahom}', "");
    Expect(0, 71487, '\p{^Is_Blk=-ahom}', "");
    Expect(0, 71487, '\P{Is_Blk=-ahom}', "");
    Expect(1, 71487, '\P{^Is_Blk=-ahom}', "");
    Expect(0, 71488, '\p{Is_Blk=-ahom}', "");
    Expect(1, 71488, '\p{^Is_Blk=-ahom}', "");
    Expect(1, 71488, '\P{Is_Blk=-ahom}', "");
    Expect(0, 71488, '\P{^Is_Blk=-ahom}', "");
    Error('\p{Block=:= 	Alchemical_symbols}');
    Error('\P{Block=:= 	Alchemical_symbols}');
    Expect(1, 128895, '\p{Block=:\AAlchemical_Symbols\z:}', "");;
    Expect(0, 128896, '\p{Block=:\AAlchemical_Symbols\z:}', "");;
    Expect(1, 128895, '\p{Block=alchemicalsymbols}', "");
    Expect(0, 128895, '\p{^Block=alchemicalsymbols}', "");
    Expect(0, 128895, '\P{Block=alchemicalsymbols}', "");
    Expect(1, 128895, '\P{^Block=alchemicalsymbols}', "");
    Expect(0, 128896, '\p{Block=alchemicalsymbols}', "");
    Expect(1, 128896, '\p{^Block=alchemicalsymbols}', "");
    Expect(1, 128896, '\P{Block=alchemicalsymbols}', "");
    Expect(0, 128896, '\P{^Block=alchemicalsymbols}', "");
    Expect(1, 128895, '\p{Block=:\Aalchemicalsymbols\z:}', "");;
    Expect(0, 128896, '\p{Block=:\Aalchemicalsymbols\z:}', "");;
    Expect(1, 128895, '\p{Block=-_ALCHEMICAL_SYMBOLS}', "");
    Expect(0, 128895, '\p{^Block=-_ALCHEMICAL_SYMBOLS}', "");
    Expect(0, 128895, '\P{Block=-_ALCHEMICAL_SYMBOLS}', "");
    Expect(1, 128895, '\P{^Block=-_ALCHEMICAL_SYMBOLS}', "");
    Expect(0, 128896, '\p{Block=-_ALCHEMICAL_SYMBOLS}', "");
    Expect(1, 128896, '\p{^Block=-_ALCHEMICAL_SYMBOLS}', "");
    Expect(1, 128896, '\P{Block=-_ALCHEMICAL_SYMBOLS}', "");
    Expect(0, 128896, '\P{^Block=-_ALCHEMICAL_SYMBOLS}', "");
    Error('\p{Blk=-:=Alchemical}');
    Error('\P{Blk=-:=Alchemical}');
    Expect(1, 128895, '\p{Blk=:\AAlchemical\z:}', "");;
    Expect(0, 128896, '\p{Blk=:\AAlchemical\z:}', "");;
    Expect(1, 128895, '\p{Blk=alchemical}', "");
    Expect(0, 128895, '\p{^Blk=alchemical}', "");
    Expect(0, 128895, '\P{Blk=alchemical}', "");
    Expect(1, 128895, '\P{^Blk=alchemical}', "");
    Expect(0, 128896, '\p{Blk=alchemical}', "");
    Expect(1, 128896, '\p{^Blk=alchemical}', "");
    Expect(1, 128896, '\P{Blk=alchemical}', "");
    Expect(0, 128896, '\P{^Blk=alchemical}', "");
    Expect(1, 128895, '\p{Blk=:\Aalchemical\z:}', "");;
    Expect(0, 128896, '\p{Blk=:\Aalchemical\z:}', "");;
    Expect(1, 128895, '\p{Blk=	-alchemical}', "");
    Expect(0, 128895, '\p{^Blk=	-alchemical}', "");
    Expect(0, 128895, '\P{Blk=	-alchemical}', "");
    Expect(1, 128895, '\P{^Blk=	-alchemical}', "");
    Expect(0, 128896, '\p{Blk=	-alchemical}', "");
    Expect(1, 128896, '\p{^Blk=	-alchemical}', "");
    Expect(1, 128896, '\P{Blk=	-alchemical}', "");
    Expect(0, 128896, '\P{^Blk=	-alchemical}', "");
    Error('\p{Is_Block=:=	_ALCHEMICAL_symbols}');
    Error('\P{Is_Block=:=	_ALCHEMICAL_symbols}');
    Expect(1, 128895, '\p{Is_Block=alchemicalsymbols}', "");
    Expect(0, 128895, '\p{^Is_Block=alchemicalsymbols}', "");
    Expect(0, 128895, '\P{Is_Block=alchemicalsymbols}', "");
    Expect(1, 128895, '\P{^Is_Block=alchemicalsymbols}', "");
    Expect(0, 128896, '\p{Is_Block=alchemicalsymbols}', "");
    Expect(1, 128896, '\p{^Is_Block=alchemicalsymbols}', "");
    Expect(1, 128896, '\P{Is_Block=alchemicalsymbols}', "");
    Expect(0, 128896, '\P{^Is_Block=alchemicalsymbols}', "");
    Expect(1, 128895, '\p{Is_Block= -ALCHEMICAL_Symbols}', "");
    Expect(0, 128895, '\p{^Is_Block= -ALCHEMICAL_Symbols}', "");
    Expect(0, 128895, '\P{Is_Block= -ALCHEMICAL_Symbols}', "");
    Expect(1, 128895, '\P{^Is_Block= -ALCHEMICAL_Symbols}', "");
    Expect(0, 128896, '\p{Is_Block= -ALCHEMICAL_Symbols}', "");
    Expect(1, 128896, '\p{^Is_Block= -ALCHEMICAL_Symbols}', "");
    Expect(1, 128896, '\P{Is_Block= -ALCHEMICAL_Symbols}', "");
    Expect(0, 128896, '\P{^Is_Block= -ALCHEMICAL_Symbols}', "");
    Error('\p{Is_Blk=-/a/Alchemical}');
    Error('\P{Is_Blk=-/a/Alchemical}');
    Expect(1, 128895, '\p{Is_Blk=alchemical}', "");
    Expect(0, 128895, '\p{^Is_Blk=alchemical}', "");
    Expect(0, 128895, '\P{Is_Blk=alchemical}', "");
    Expect(1, 128895, '\P{^Is_Blk=alchemical}', "");
    Expect(0, 128896, '\p{Is_Blk=alchemical}', "");
    Expect(1, 128896, '\p{^Is_Blk=alchemical}', "");
    Expect(1, 128896, '\P{Is_Blk=alchemical}', "");
    Expect(0, 128896, '\P{^Is_Blk=alchemical}', "");
    Expect(1, 128895, '\p{Is_Blk=  Alchemical}', "");
    Expect(0, 128895, '\p{^Is_Blk=  Alchemical}', "");
    Expect(0, 128895, '\P{Is_Blk=  Alchemical}', "");
    Expect(1, 128895, '\P{^Is_Blk=  Alchemical}', "");
    Expect(0, 128896, '\p{Is_Blk=  Alchemical}', "");
    Expect(1, 128896, '\p{^Is_Blk=  Alchemical}', "");
    Expect(1, 128896, '\P{Is_Blk=  Alchemical}', "");
    Expect(0, 128896, '\P{^Is_Blk=  Alchemical}', "");
    Error('\p{Block=/a/-Alphabetic_Presentation_Forms}');
    Error('\P{Block=/a/-Alphabetic_Presentation_Forms}');
    Expect(1, 64335, '\p{Block=:\AAlphabetic_Presentation_Forms\z:}', "");;
    Expect(0, 64336, '\p{Block=:\AAlphabetic_Presentation_Forms\z:}', "");;
    Expect(1, 64335, '\p{Block:alphabeticpresentationforms}', "");
    Expect(0, 64335, '\p{^Block:alphabeticpresentationforms}', "");
    Expect(0, 64335, '\P{Block:alphabeticpresentationforms}', "");
    Expect(1, 64335, '\P{^Block:alphabeticpresentationforms}', "");
    Expect(0, 64336, '\p{Block:alphabeticpresentationforms}', "");
    Expect(1, 64336, '\p{^Block:alphabeticpresentationforms}', "");
    Expect(1, 64336, '\P{Block:alphabeticpresentationforms}', "");
    Expect(0, 64336, '\P{^Block:alphabeticpresentationforms}', "");
    Expect(1, 64335, '\p{Block=:\Aalphabeticpresentationforms\z:}', "");;
    Expect(0, 64336, '\p{Block=:\Aalphabeticpresentationforms\z:}', "");;
    Expect(1, 64335, '\p{Block: _alphabetic_presentation_Forms}', "");
    Expect(0, 64335, '\p{^Block: _alphabetic_presentation_Forms}', "");
    Expect(0, 64335, '\P{Block: _alphabetic_presentation_Forms}', "");
    Expect(1, 64335, '\P{^Block: _alphabetic_presentation_Forms}', "");
    Expect(0, 64336, '\p{Block: _alphabetic_presentation_Forms}', "");
    Expect(1, 64336, '\p{^Block: _alphabetic_presentation_Forms}', "");
    Expect(1, 64336, '\P{Block: _alphabetic_presentation_Forms}', "");
    Expect(0, 64336, '\P{^Block: _alphabetic_presentation_Forms}', "");
    Error('\p{Blk= -ALPHABETIC_PF/a/}');
    Error('\P{Blk= -ALPHABETIC_PF/a/}');
    Expect(1, 64335, '\p{Blk=:\AAlphabetic_PF\z:}', "");;
    Expect(0, 64336, '\p{Blk=:\AAlphabetic_PF\z:}', "");;
    Expect(1, 64335, '\p{Blk=alphabeticpf}', "");
    Expect(0, 64335, '\p{^Blk=alphabeticpf}', "");
    Expect(0, 64335, '\P{Blk=alphabeticpf}', "");
    Expect(1, 64335, '\P{^Blk=alphabeticpf}', "");
    Expect(0, 64336, '\p{Blk=alphabeticpf}', "");
    Expect(1, 64336, '\p{^Blk=alphabeticpf}', "");
    Expect(1, 64336, '\P{Blk=alphabeticpf}', "");
    Expect(0, 64336, '\P{^Blk=alphabeticpf}', "");
    Expect(1, 64335, '\p{Blk=:\Aalphabeticpf\z:}', "");;
    Expect(0, 64336, '\p{Blk=:\Aalphabeticpf\z:}', "");;
    Expect(1, 64335, '\p{Blk=-ALPHABETIC_PF}', "");
    Expect(0, 64335, '\p{^Blk=-ALPHABETIC_PF}', "");
    Expect(0, 64335, '\P{Blk=-ALPHABETIC_PF}', "");
    Expect(1, 64335, '\P{^Blk=-ALPHABETIC_PF}', "");
    Expect(0, 64336, '\p{Blk=-ALPHABETIC_PF}', "");
    Expect(1, 64336, '\p{^Blk=-ALPHABETIC_PF}', "");
    Expect(1, 64336, '\P{Blk=-ALPHABETIC_PF}', "");
    Expect(0, 64336, '\P{^Blk=-ALPHABETIC_PF}', "");
    Error('\p{Is_Block=/a/--ALPHABETIC_presentation_Forms}');
    Error('\P{Is_Block=/a/--ALPHABETIC_presentation_Forms}');
    Expect(1, 64335, '\p{Is_Block=alphabeticpresentationforms}', "");
    Expect(0, 64335, '\p{^Is_Block=alphabeticpresentationforms}', "");
    Expect(0, 64335, '\P{Is_Block=alphabeticpresentationforms}', "");
    Expect(1, 64335, '\P{^Is_Block=alphabeticpresentationforms}', "");
    Expect(0, 64336, '\p{Is_Block=alphabeticpresentationforms}', "");
    Expect(1, 64336, '\p{^Is_Block=alphabeticpresentationforms}', "");
    Expect(1, 64336, '\P{Is_Block=alphabeticpresentationforms}', "");
    Expect(0, 64336, '\P{^Is_Block=alphabeticpresentationforms}', "");
    Expect(1, 64335, '\p{Is_Block=	_Alphabetic_Presentation_forms}', "");
    Expect(0, 64335, '\p{^Is_Block=	_Alphabetic_Presentation_forms}', "");
    Expect(0, 64335, '\P{Is_Block=	_Alphabetic_Presentation_forms}', "");
    Expect(1, 64335, '\P{^Is_Block=	_Alphabetic_Presentation_forms}', "");
    Expect(0, 64336, '\p{Is_Block=	_Alphabetic_Presentation_forms}', "");
    Expect(1, 64336, '\p{^Is_Block=	_Alphabetic_Presentation_forms}', "");
    Expect(1, 64336, '\P{Is_Block=	_Alphabetic_Presentation_forms}', "");
    Expect(0, 64336, '\P{^Is_Block=	_Alphabetic_Presentation_forms}', "");
    Error('\p{Is_Blk=/a/_	Alphabetic_PF}');
    Error('\P{Is_Blk=/a/_	Alphabetic_PF}');
    Expect(1, 64335, '\p{Is_Blk=alphabeticpf}', "");
    Expect(0, 64335, '\p{^Is_Blk=alphabeticpf}', "");
    Expect(0, 64335, '\P{Is_Blk=alphabeticpf}', "");
    Expect(1, 64335, '\P{^Is_Blk=alphabeticpf}', "");
    Expect(0, 64336, '\p{Is_Blk=alphabeticpf}', "");
    Expect(1, 64336, '\p{^Is_Blk=alphabeticpf}', "");
    Expect(1, 64336, '\P{Is_Blk=alphabeticpf}', "");
    Expect(0, 64336, '\P{^Is_Blk=alphabeticpf}', "");
    Expect(1, 64335, '\p{Is_Blk=-_ALPHABETIC_PF}', "");
    Expect(0, 64335, '\p{^Is_Blk=-_ALPHABETIC_PF}', "");
    Expect(0, 64335, '\P{Is_Blk=-_ALPHABETIC_PF}', "");
    Expect(1, 64335, '\P{^Is_Blk=-_ALPHABETIC_PF}', "");
    Expect(0, 64336, '\p{Is_Blk=-_ALPHABETIC_PF}', "");
    Expect(1, 64336, '\p{^Is_Blk=-_ALPHABETIC_PF}', "");
    Expect(1, 64336, '\P{Is_Blk=-_ALPHABETIC_PF}', "");
    Expect(0, 64336, '\P{^Is_Blk=-_ALPHABETIC_PF}', "");
    Error('\p{Block: --Anatolian_Hieroglyphs/a/}');
    Error('\P{Block: --Anatolian_Hieroglyphs/a/}');
    Expect(1, 83583, '\p{Block=:\AAnatolian_Hieroglyphs\z:}', "");;
    Expect(0, 83584, '\p{Block=:\AAnatolian_Hieroglyphs\z:}', "");;
    Expect(1, 83583, '\p{Block:anatolianhieroglyphs}', "");
    Expect(0, 83583, '\p{^Block:anatolianhieroglyphs}', "");
    Expect(0, 83583, '\P{Block:anatolianhieroglyphs}', "");
    Expect(1, 83583, '\P{^Block:anatolianhieroglyphs}', "");
    Expect(0, 83584, '\p{Block:anatolianhieroglyphs}', "");
    Expect(1, 83584, '\p{^Block:anatolianhieroglyphs}', "");
    Expect(1, 83584, '\P{Block:anatolianhieroglyphs}', "");
    Expect(0, 83584, '\P{^Block:anatolianhieroglyphs}', "");
    Expect(1, 83583, '\p{Block=:\Aanatolianhieroglyphs\z:}', "");;
    Expect(0, 83584, '\p{Block=:\Aanatolianhieroglyphs\z:}', "");;
    Expect(1, 83583, '\p{Block=_ANATOLIAN_HIEROGLYPHS}', "");
    Expect(0, 83583, '\p{^Block=_ANATOLIAN_HIEROGLYPHS}', "");
    Expect(0, 83583, '\P{Block=_ANATOLIAN_HIEROGLYPHS}', "");
    Expect(1, 83583, '\P{^Block=_ANATOLIAN_HIEROGLYPHS}', "");
    Expect(0, 83584, '\p{Block=_ANATOLIAN_HIEROGLYPHS}', "");
    Expect(1, 83584, '\p{^Block=_ANATOLIAN_HIEROGLYPHS}', "");
    Expect(1, 83584, '\P{Block=_ANATOLIAN_HIEROGLYPHS}', "");
    Expect(0, 83584, '\P{^Block=_ANATOLIAN_HIEROGLYPHS}', "");
    Error('\p{Blk=		anatolian_HIEROGLYPHS:=}');
    Error('\P{Blk=		anatolian_HIEROGLYPHS:=}');
    Expect(1, 83583, '\p{Blk=:\AAnatolian_Hieroglyphs\z:}', "");;
    Expect(0, 83584, '\p{Blk=:\AAnatolian_Hieroglyphs\z:}', "");;
    Expect(1, 83583, '\p{Blk=anatolianhieroglyphs}', "");
    Expect(0, 83583, '\p{^Blk=anatolianhieroglyphs}', "");
    Expect(0, 83583, '\P{Blk=anatolianhieroglyphs}', "");
    Expect(1, 83583, '\P{^Blk=anatolianhieroglyphs}', "");
    Expect(0, 83584, '\p{Blk=anatolianhieroglyphs}', "");
    Expect(1, 83584, '\p{^Blk=anatolianhieroglyphs}', "");
    Expect(1, 83584, '\P{Blk=anatolianhieroglyphs}', "");
    Expect(0, 83584, '\P{^Blk=anatolianhieroglyphs}', "");
    Expect(1, 83583, '\p{Blk=:\Aanatolianhieroglyphs\z:}', "");;
    Expect(0, 83584, '\p{Blk=:\Aanatolianhieroglyphs\z:}', "");;
    Expect(1, 83583, '\p{Blk=	anatolian_Hieroglyphs}', "");
    Expect(0, 83583, '\p{^Blk=	anatolian_Hieroglyphs}', "");
    Expect(0, 83583, '\P{Blk=	anatolian_Hieroglyphs}', "");
    Expect(1, 83583, '\P{^Blk=	anatolian_Hieroglyphs}', "");
    Expect(0, 83584, '\p{Blk=	anatolian_Hieroglyphs}', "");
    Expect(1, 83584, '\p{^Blk=	anatolian_Hieroglyphs}', "");
    Expect(1, 83584, '\P{Blk=	anatolian_Hieroglyphs}', "");
    Expect(0, 83584, '\P{^Blk=	anatolian_Hieroglyphs}', "");
    Error('\p{Is_Block=/a/-ANATOLIAN_Hieroglyphs}');
    Error('\P{Is_Block=/a/-ANATOLIAN_Hieroglyphs}');
    Expect(1, 83583, '\p{Is_Block=anatolianhieroglyphs}', "");
    Expect(0, 83583, '\p{^Is_Block=anatolianhieroglyphs}', "");
    Expect(0, 83583, '\P{Is_Block=anatolianhieroglyphs}', "");
    Expect(1, 83583, '\P{^Is_Block=anatolianhieroglyphs}', "");
    Expect(0, 83584, '\p{Is_Block=anatolianhieroglyphs}', "");
    Expect(1, 83584, '\p{^Is_Block=anatolianhieroglyphs}', "");
    Expect(1, 83584, '\P{Is_Block=anatolianhieroglyphs}', "");
    Expect(0, 83584, '\P{^Is_Block=anatolianhieroglyphs}', "");
    Expect(1, 83583, '\p{Is_Block=	_Anatolian_Hieroglyphs}', "");
    Expect(0, 83583, '\p{^Is_Block=	_Anatolian_Hieroglyphs}', "");
    Expect(0, 83583, '\P{Is_Block=	_Anatolian_Hieroglyphs}', "");
    Expect(1, 83583, '\P{^Is_Block=	_Anatolian_Hieroglyphs}', "");
    Expect(0, 83584, '\p{Is_Block=	_Anatolian_Hieroglyphs}', "");
    Expect(1, 83584, '\p{^Is_Block=	_Anatolian_Hieroglyphs}', "");
    Expect(1, 83584, '\P{Is_Block=	_Anatolian_Hieroglyphs}', "");
    Expect(0, 83584, '\P{^Is_Block=	_Anatolian_Hieroglyphs}', "");
    Error('\p{Is_Blk:	Anatolian_Hieroglyphs:=}');
    Error('\P{Is_Blk:	Anatolian_Hieroglyphs:=}');
    Expect(1, 83583, '\p{Is_Blk:   anatolianhieroglyphs}', "");
    Expect(0, 83583, '\p{^Is_Blk:   anatolianhieroglyphs}', "");
    Expect(0, 83583, '\P{Is_Blk:   anatolianhieroglyphs}', "");
    Expect(1, 83583, '\P{^Is_Blk:   anatolianhieroglyphs}', "");
    Expect(0, 83584, '\p{Is_Blk:   anatolianhieroglyphs}', "");
    Expect(1, 83584, '\p{^Is_Blk:   anatolianhieroglyphs}', "");
    Expect(1, 83584, '\P{Is_Blk:   anatolianhieroglyphs}', "");
    Expect(0, 83584, '\P{^Is_Blk:   anatolianhieroglyphs}', "");
    Expect(1, 83583, '\p{Is_Blk= -ANATOLIAN_HIEROGLYPHS}', "");
    Expect(0, 83583, '\p{^Is_Blk= -ANATOLIAN_HIEROGLYPHS}', "");
    Expect(0, 83583, '\P{Is_Blk= -ANATOLIAN_HIEROGLYPHS}', "");
    Expect(1, 83583, '\P{^Is_Blk= -ANATOLIAN_HIEROGLYPHS}', "");
    Expect(0, 83584, '\p{Is_Blk= -ANATOLIAN_HIEROGLYPHS}', "");
    Expect(1, 83584, '\p{^Is_Blk= -ANATOLIAN_HIEROGLYPHS}', "");
    Expect(1, 83584, '\P{Is_Blk= -ANATOLIAN_HIEROGLYPHS}', "");
    Expect(0, 83584, '\P{^Is_Blk= -ANATOLIAN_HIEROGLYPHS}', "");
    Error('\p{Block=	:=ancient_GREEK_MUSICAL_Notation}');
    Error('\P{Block=	:=ancient_GREEK_MUSICAL_Notation}');
    Expect(1, 119375, '\p{Block=:\AAncient_Greek_Musical_Notation\z:}', "");;
    Expect(0, 119376, '\p{Block=:\AAncient_Greek_Musical_Notation\z:}', "");;
    Expect(1, 119375, '\p{Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\p{^Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\P{Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\P{^Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\p{Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\p{^Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\P{Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\P{^Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\p{Block=:\Aancientgreekmusicalnotation\z:}', "");;
    Expect(0, 119376, '\p{Block=:\Aancientgreekmusicalnotation\z:}', "");;
    Expect(1, 119375, '\p{Block=	-Ancient_Greek_musical_Notation}', "");
    Expect(0, 119375, '\p{^Block=	-Ancient_Greek_musical_Notation}', "");
    Expect(0, 119375, '\P{Block=	-Ancient_Greek_musical_Notation}', "");
    Expect(1, 119375, '\P{^Block=	-Ancient_Greek_musical_Notation}', "");
    Expect(0, 119376, '\p{Block=	-Ancient_Greek_musical_Notation}', "");
    Expect(1, 119376, '\p{^Block=	-Ancient_Greek_musical_Notation}', "");
    Expect(1, 119376, '\P{Block=	-Ancient_Greek_musical_Notation}', "");
    Expect(0, 119376, '\P{^Block=	-Ancient_Greek_musical_Notation}', "");
    Error('\p{Blk=-	Ancient_Greek_Music:=}');
    Error('\P{Blk=-	Ancient_Greek_Music:=}');
    Expect(1, 119375, '\p{Blk=:\AAncient_Greek_Music\z:}', "");;
    Expect(0, 119376, '\p{Blk=:\AAncient_Greek_Music\z:}', "");;
    Expect(1, 119375, '\p{Blk=ancientgreekmusic}', "");
    Expect(0, 119375, '\p{^Blk=ancientgreekmusic}', "");
    Expect(0, 119375, '\P{Blk=ancientgreekmusic}', "");
    Expect(1, 119375, '\P{^Blk=ancientgreekmusic}', "");
    Expect(0, 119376, '\p{Blk=ancientgreekmusic}', "");
    Expect(1, 119376, '\p{^Blk=ancientgreekmusic}', "");
    Expect(1, 119376, '\P{Blk=ancientgreekmusic}', "");
    Expect(0, 119376, '\P{^Blk=ancientgreekmusic}', "");
    Expect(1, 119375, '\p{Blk=:\Aancientgreekmusic\z:}', "");;
    Expect(0, 119376, '\p{Blk=:\Aancientgreekmusic\z:}', "");;
    Expect(1, 119375, '\p{Blk= -ANCIENT_Greek_music}', "");
    Expect(0, 119375, '\p{^Blk= -ANCIENT_Greek_music}', "");
    Expect(0, 119375, '\P{Blk= -ANCIENT_Greek_music}', "");
    Expect(1, 119375, '\P{^Blk= -ANCIENT_Greek_music}', "");
    Expect(0, 119376, '\p{Blk= -ANCIENT_Greek_music}', "");
    Expect(1, 119376, '\p{^Blk= -ANCIENT_Greek_music}', "");
    Expect(1, 119376, '\P{Blk= -ANCIENT_Greek_music}', "");
    Expect(0, 119376, '\P{^Blk= -ANCIENT_Greek_music}', "");
    Error('\p{Is_Block=:= Ancient_greek_musical_NOTATION}');
    Error('\P{Is_Block=:= Ancient_greek_musical_NOTATION}');
    Expect(1, 119375, '\p{Is_Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\p{^Is_Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\P{Is_Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\P{^Is_Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\p{Is_Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\p{^Is_Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\P{Is_Block=ancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\P{^Is_Block=ancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\p{Is_Block= _ancient_greek_musical_NOTATION}', "");
    Expect(0, 119375, '\p{^Is_Block= _ancient_greek_musical_NOTATION}', "");
    Expect(0, 119375, '\P{Is_Block= _ancient_greek_musical_NOTATION}', "");
    Expect(1, 119375, '\P{^Is_Block= _ancient_greek_musical_NOTATION}', "");
    Expect(0, 119376, '\p{Is_Block= _ancient_greek_musical_NOTATION}', "");
    Expect(1, 119376, '\p{^Is_Block= _ancient_greek_musical_NOTATION}', "");
    Expect(1, 119376, '\P{Is_Block= _ancient_greek_musical_NOTATION}', "");
    Expect(0, 119376, '\P{^Is_Block= _ancient_greek_musical_NOTATION}', "");
    Error('\p{Is_Blk=:=	-ANCIENT_greek_Music}');
    Error('\P{Is_Blk=:=	-ANCIENT_greek_Music}');
    Expect(1, 119375, '\p{Is_Blk=ancientgreekmusic}', "");
    Expect(0, 119375, '\p{^Is_Blk=ancientgreekmusic}', "");
    Expect(0, 119375, '\P{Is_Blk=ancientgreekmusic}', "");
    Expect(1, 119375, '\P{^Is_Blk=ancientgreekmusic}', "");
    Expect(0, 119376, '\p{Is_Blk=ancientgreekmusic}', "");
    Expect(1, 119376, '\p{^Is_Blk=ancientgreekmusic}', "");
    Expect(1, 119376, '\P{Is_Blk=ancientgreekmusic}', "");
    Expect(0, 119376, '\P{^Is_Blk=ancientgreekmusic}', "");
    Expect(1, 119375, '\p{Is_Blk=	-ANCIENT_Greek_Music}', "");
    Expect(0, 119375, '\p{^Is_Blk=	-ANCIENT_Greek_Music}', "");
    Expect(0, 119375, '\P{Is_Blk=	-ANCIENT_Greek_Music}', "");
    Expect(1, 119375, '\P{^Is_Blk=	-ANCIENT_Greek_Music}', "");
    Expect(0, 119376, '\p{Is_Blk=	-ANCIENT_Greek_Music}', "");
    Expect(1, 119376, '\p{^Is_Blk=	-ANCIENT_Greek_Music}', "");
    Expect(1, 119376, '\P{Is_Blk=	-ANCIENT_Greek_Music}', "");
    Expect(0, 119376, '\P{^Is_Blk=	-ANCIENT_Greek_Music}', "");
    Error('\p{Block= /a/Ancient_Greek_NUMBERS}');
    Error('\P{Block= /a/Ancient_Greek_NUMBERS}');
    Expect(1, 65935, '\p{Block=:\AAncient_Greek_Numbers\z:}', "");;
    Expect(0, 65936, '\p{Block=:\AAncient_Greek_Numbers\z:}', "");;
    Expect(1, 65935, '\p{Block: ancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^Block: ancientgreeknumbers}', "");
    Expect(0, 65935, '\P{Block: ancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^Block: ancientgreeknumbers}', "");
    Expect(0, 65936, '\p{Block: ancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^Block: ancientgreeknumbers}', "");
    Expect(1, 65936, '\P{Block: ancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^Block: ancientgreeknumbers}', "");
    Expect(1, 65935, '\p{Block=:\Aancientgreeknumbers\z:}', "");;
    Expect(0, 65936, '\p{Block=:\Aancientgreeknumbers\z:}', "");;
    Expect(1, 65935, '\p{Block=_-ancient_Greek_numbers}', "");
    Expect(0, 65935, '\p{^Block=_-ancient_Greek_numbers}', "");
    Expect(0, 65935, '\P{Block=_-ancient_Greek_numbers}', "");
    Expect(1, 65935, '\P{^Block=_-ancient_Greek_numbers}', "");
    Expect(0, 65936, '\p{Block=_-ancient_Greek_numbers}', "");
    Expect(1, 65936, '\p{^Block=_-ancient_Greek_numbers}', "");
    Expect(1, 65936, '\P{Block=_-ancient_Greek_numbers}', "");
    Expect(0, 65936, '\P{^Block=_-ancient_Greek_numbers}', "");
    Error('\p{Blk=_/a/ANCIENT_Greek_numbers}');
    Error('\P{Blk=_/a/ANCIENT_Greek_numbers}');
    Expect(1, 65935, '\p{Blk=:\AAncient_Greek_Numbers\z:}', "");;
    Expect(0, 65936, '\p{Blk=:\AAncient_Greek_Numbers\z:}', "");;
    Expect(1, 65935, '\p{Blk=ancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^Blk=ancientgreeknumbers}', "");
    Expect(0, 65935, '\P{Blk=ancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^Blk=ancientgreeknumbers}', "");
    Expect(0, 65936, '\p{Blk=ancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^Blk=ancientgreeknumbers}', "");
    Expect(1, 65936, '\P{Blk=ancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^Blk=ancientgreeknumbers}', "");
    Expect(1, 65935, '\p{Blk=:\Aancientgreeknumbers\z:}', "");;
    Expect(0, 65936, '\p{Blk=:\Aancientgreeknumbers\z:}', "");;
    Expect(1, 65935, '\p{Blk=ANCIENT_Greek_NUMBERS}', "");
    Expect(0, 65935, '\p{^Blk=ANCIENT_Greek_NUMBERS}', "");
    Expect(0, 65935, '\P{Blk=ANCIENT_Greek_NUMBERS}', "");
    Expect(1, 65935, '\P{^Blk=ANCIENT_Greek_NUMBERS}', "");
    Expect(0, 65936, '\p{Blk=ANCIENT_Greek_NUMBERS}', "");
    Expect(1, 65936, '\p{^Blk=ANCIENT_Greek_NUMBERS}', "");
    Expect(1, 65936, '\P{Blk=ANCIENT_Greek_NUMBERS}', "");
    Expect(0, 65936, '\P{^Blk=ANCIENT_Greek_NUMBERS}', "");
    Error('\p{Is_Block=	_Ancient_greek_Numbers/a/}');
    Error('\P{Is_Block=	_Ancient_greek_Numbers/a/}');
    Expect(1, 65935, '\p{Is_Block=ancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^Is_Block=ancientgreeknumbers}', "");
    Expect(0, 65935, '\P{Is_Block=ancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^Is_Block=ancientgreeknumbers}', "");
    Expect(0, 65936, '\p{Is_Block=ancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^Is_Block=ancientgreeknumbers}', "");
    Expect(1, 65936, '\P{Is_Block=ancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^Is_Block=ancientgreeknumbers}', "");
    Expect(1, 65935, '\p{Is_Block=--Ancient_Greek_NUMBERS}', "");
    Expect(0, 65935, '\p{^Is_Block=--Ancient_Greek_NUMBERS}', "");
    Expect(0, 65935, '\P{Is_Block=--Ancient_Greek_NUMBERS}', "");
    Expect(1, 65935, '\P{^Is_Block=--Ancient_Greek_NUMBERS}', "");
    Expect(0, 65936, '\p{Is_Block=--Ancient_Greek_NUMBERS}', "");
    Expect(1, 65936, '\p{^Is_Block=--Ancient_Greek_NUMBERS}', "");
    Expect(1, 65936, '\P{Is_Block=--Ancient_Greek_NUMBERS}', "");
    Expect(0, 65936, '\P{^Is_Block=--Ancient_Greek_NUMBERS}', "");
    Error('\p{Is_Blk=:=	_ancient_GREEK_Numbers}');
    Error('\P{Is_Blk=:=	_ancient_GREEK_Numbers}');
    Expect(1, 65935, '\p{Is_Blk=ancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^Is_Blk=ancientgreeknumbers}', "");
    Expect(0, 65935, '\P{Is_Blk=ancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^Is_Blk=ancientgreeknumbers}', "");
    Expect(0, 65936, '\p{Is_Blk=ancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^Is_Blk=ancientgreeknumbers}', "");
    Expect(1, 65936, '\P{Is_Blk=ancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^Is_Blk=ancientgreeknumbers}', "");
    Expect(1, 65935, '\p{Is_Blk=_ Ancient_Greek_NUMBERS}', "");
    Expect(0, 65935, '\p{^Is_Blk=_ Ancient_Greek_NUMBERS}', "");
    Expect(0, 65935, '\P{Is_Blk=_ Ancient_Greek_NUMBERS}', "");
    Expect(1, 65935, '\P{^Is_Blk=_ Ancient_Greek_NUMBERS}', "");
    Expect(0, 65936, '\p{Is_Blk=_ Ancient_Greek_NUMBERS}', "");
    Expect(1, 65936, '\p{^Is_Blk=_ Ancient_Greek_NUMBERS}', "");
    Expect(1, 65936, '\P{Is_Blk=_ Ancient_Greek_NUMBERS}', "");
    Expect(0, 65936, '\P{^Is_Blk=_ Ancient_Greek_NUMBERS}', "");
    Error('\p{Block=	-Ancient_SYMBOLS:=}');
    Error('\P{Block=	-Ancient_SYMBOLS:=}');
    Expect(1, 65999, '\p{Block=:\AAncient_Symbols\z:}', "");;
    Expect(0, 66000, '\p{Block=:\AAncient_Symbols\z:}', "");;
    Expect(1, 65999, '\p{Block=ancientsymbols}', "");
    Expect(0, 65999, '\p{^Block=ancientsymbols}', "");
    Expect(0, 65999, '\P{Block=ancientsymbols}', "");
    Expect(1, 65999, '\P{^Block=ancientsymbols}', "");
    Expect(0, 66000, '\p{Block=ancientsymbols}', "");
    Expect(1, 66000, '\p{^Block=ancientsymbols}', "");
    Expect(1, 66000, '\P{Block=ancientsymbols}', "");
    Expect(0, 66000, '\P{^Block=ancientsymbols}', "");
    Expect(1, 65999, '\p{Block=:\Aancientsymbols\z:}', "");;
    Expect(0, 66000, '\p{Block=:\Aancientsymbols\z:}', "");;
    Expect(1, 65999, '\p{Block= -Ancient_symbols}', "");
    Expect(0, 65999, '\p{^Block= -Ancient_symbols}', "");
    Expect(0, 65999, '\P{Block= -Ancient_symbols}', "");
    Expect(1, 65999, '\P{^Block= -Ancient_symbols}', "");
    Expect(0, 66000, '\p{Block= -Ancient_symbols}', "");
    Expect(1, 66000, '\p{^Block= -Ancient_symbols}', "");
    Expect(1, 66000, '\P{Block= -Ancient_symbols}', "");
    Expect(0, 66000, '\P{^Block= -Ancient_symbols}', "");
    Error('\p{Blk=	-ancient_Symbols/a/}');
    Error('\P{Blk=	-ancient_Symbols/a/}');
    Expect(1, 65999, '\p{Blk=:\AAncient_Symbols\z:}', "");;
    Expect(0, 66000, '\p{Blk=:\AAncient_Symbols\z:}', "");;
    Expect(1, 65999, '\p{Blk=ancientsymbols}', "");
    Expect(0, 65999, '\p{^Blk=ancientsymbols}', "");
    Expect(0, 65999, '\P{Blk=ancientsymbols}', "");
    Expect(1, 65999, '\P{^Blk=ancientsymbols}', "");
    Expect(0, 66000, '\p{Blk=ancientsymbols}', "");
    Expect(1, 66000, '\p{^Blk=ancientsymbols}', "");
    Expect(1, 66000, '\P{Blk=ancientsymbols}', "");
    Expect(0, 66000, '\P{^Blk=ancientsymbols}', "");
    Expect(1, 65999, '\p{Blk=:\Aancientsymbols\z:}', "");;
    Expect(0, 66000, '\p{Blk=:\Aancientsymbols\z:}', "");;
    Expect(1, 65999, '\p{Blk=  Ancient_Symbols}', "");
    Expect(0, 65999, '\p{^Blk=  Ancient_Symbols}', "");
    Expect(0, 65999, '\P{Blk=  Ancient_Symbols}', "");
    Expect(1, 65999, '\P{^Blk=  Ancient_Symbols}', "");
    Expect(0, 66000, '\p{Blk=  Ancient_Symbols}', "");
    Expect(1, 66000, '\p{^Blk=  Ancient_Symbols}', "");
    Expect(1, 66000, '\P{Blk=  Ancient_Symbols}', "");
    Expect(0, 66000, '\P{^Blk=  Ancient_Symbols}', "");
    Error('\p{Is_Block=-ANCIENT_symbols:=}');
    Error('\P{Is_Block=-ANCIENT_symbols:=}');
    Expect(1, 65999, '\p{Is_Block=ancientsymbols}', "");
    Expect(0, 65999, '\p{^Is_Block=ancientsymbols}', "");
    Expect(0, 65999, '\P{Is_Block=ancientsymbols}', "");
    Expect(1, 65999, '\P{^Is_Block=ancientsymbols}', "");
    Expect(0, 66000, '\p{Is_Block=ancientsymbols}', "");
    Expect(1, 66000, '\p{^Is_Block=ancientsymbols}', "");
    Expect(1, 66000, '\P{Is_Block=ancientsymbols}', "");
    Expect(0, 66000, '\P{^Is_Block=ancientsymbols}', "");
    Expect(1, 65999, '\p{Is_Block=	-Ancient_Symbols}', "");
    Expect(0, 65999, '\p{^Is_Block=	-Ancient_Symbols}', "");
    Expect(0, 65999, '\P{Is_Block=	-Ancient_Symbols}', "");
    Expect(1, 65999, '\P{^Is_Block=	-Ancient_Symbols}', "");
    Expect(0, 66000, '\p{Is_Block=	-Ancient_Symbols}', "");
    Expect(1, 66000, '\p{^Is_Block=	-Ancient_Symbols}', "");
    Expect(1, 66000, '\P{Is_Block=	-Ancient_Symbols}', "");
    Expect(0, 66000, '\P{^Is_Block=	-Ancient_Symbols}', "");
    Error('\p{Is_Blk:   -_ancient_symbols:=}');
    Error('\P{Is_Blk:   -_ancient_symbols:=}');
    Expect(1, 65999, '\p{Is_Blk=ancientsymbols}', "");
    Expect(0, 65999, '\p{^Is_Blk=ancientsymbols}', "");
    Expect(0, 65999, '\P{Is_Blk=ancientsymbols}', "");
    Expect(1, 65999, '\P{^Is_Blk=ancientsymbols}', "");
    Expect(0, 66000, '\p{Is_Blk=ancientsymbols}', "");
    Expect(1, 66000, '\p{^Is_Blk=ancientsymbols}', "");
    Expect(1, 66000, '\P{Is_Blk=ancientsymbols}', "");
    Expect(0, 66000, '\P{^Is_Blk=ancientsymbols}', "");
    Expect(1, 65999, '\p{Is_Blk=_	Ancient_Symbols}', "");
    Expect(0, 65999, '\p{^Is_Blk=_	Ancient_Symbols}', "");
    Expect(0, 65999, '\P{Is_Blk=_	Ancient_Symbols}', "");
    Expect(1, 65999, '\P{^Is_Blk=_	Ancient_Symbols}', "");
    Expect(0, 66000, '\p{Is_Blk=_	Ancient_Symbols}', "");
    Expect(1, 66000, '\p{^Is_Blk=_	Ancient_Symbols}', "");
    Expect(1, 66000, '\P{Is_Blk=_	Ancient_Symbols}', "");
    Expect(0, 66000, '\P{^Is_Blk=_	Ancient_Symbols}', "");
    Error('\p{Block=_	Arabic/a/}');
    Error('\P{Block=_	Arabic/a/}');
    Expect(1, 1791, '\p{Block=:\AArabic\z:}', "");;
    Expect(0, 1792, '\p{Block=:\AArabic\z:}', "");;
    Expect(1, 1791, '\p{Block=arabic}', "");
    Expect(0, 1791, '\p{^Block=arabic}', "");
    Expect(0, 1791, '\P{Block=arabic}', "");
    Expect(1, 1791, '\P{^Block=arabic}', "");
    Expect(0, 1792, '\p{Block=arabic}', "");
    Expect(1, 1792, '\p{^Block=arabic}', "");
    Expect(1, 1792, '\P{Block=arabic}', "");
    Expect(0, 1792, '\P{^Block=arabic}', "");
    Expect(1, 1791, '\p{Block=:\Aarabic\z:}', "");;
    Expect(0, 1792, '\p{Block=:\Aarabic\z:}', "");;
    Expect(1, 1791, '\p{Block=	arabic}', "");
    Expect(0, 1791, '\p{^Block=	arabic}', "");
    Expect(0, 1791, '\P{Block=	arabic}', "");
    Expect(1, 1791, '\P{^Block=	arabic}', "");
    Expect(0, 1792, '\p{Block=	arabic}', "");
    Expect(1, 1792, '\p{^Block=	arabic}', "");
    Expect(1, 1792, '\P{Block=	arabic}', "");
    Expect(0, 1792, '\P{^Block=	arabic}', "");
    Error('\p{Blk=-:=Arabic}');
    Error('\P{Blk=-:=Arabic}');
    Expect(1, 1791, '\p{Blk=:\AArabic\z:}', "");;
    Expect(0, 1792, '\p{Blk=:\AArabic\z:}', "");;
    Expect(1, 1791, '\p{Blk=arabic}', "");
    Expect(0, 1791, '\p{^Blk=arabic}', "");
    Expect(0, 1791, '\P{Blk=arabic}', "");
    Expect(1, 1791, '\P{^Blk=arabic}', "");
    Expect(0, 1792, '\p{Blk=arabic}', "");
    Expect(1, 1792, '\p{^Blk=arabic}', "");
    Expect(1, 1792, '\P{Blk=arabic}', "");
    Expect(0, 1792, '\P{^Blk=arabic}', "");
    Expect(1, 1791, '\p{Blk=:\Aarabic\z:}', "");;
    Expect(0, 1792, '\p{Blk=:\Aarabic\z:}', "");;
    Expect(1, 1791, '\p{Blk=__arabic}', "");
    Expect(0, 1791, '\p{^Blk=__arabic}', "");
    Expect(0, 1791, '\P{Blk=__arabic}', "");
    Expect(1, 1791, '\P{^Blk=__arabic}', "");
    Expect(0, 1792, '\p{Blk=__arabic}', "");
    Expect(1, 1792, '\p{^Blk=__arabic}', "");
    Expect(1, 1792, '\P{Blk=__arabic}', "");
    Expect(0, 1792, '\P{^Blk=__arabic}', "");
    Error('\p{Is_Block: /a/Arabic}');
    Error('\P{Is_Block: /a/Arabic}');
    Expect(1, 1791, '\p{Is_Block=arabic}', "");
    Expect(0, 1791, '\p{^Is_Block=arabic}', "");
    Expect(0, 1791, '\P{Is_Block=arabic}', "");
    Expect(1, 1791, '\P{^Is_Block=arabic}', "");
    Expect(0, 1792, '\p{Is_Block=arabic}', "");
    Expect(1, 1792, '\p{^Is_Block=arabic}', "");
    Expect(1, 1792, '\P{Is_Block=arabic}', "");
    Expect(0, 1792, '\P{^Is_Block=arabic}', "");
    Expect(1, 1791, '\p{Is_Block=-	Arabic}', "");
    Expect(0, 1791, '\p{^Is_Block=-	Arabic}', "");
    Expect(0, 1791, '\P{Is_Block=-	Arabic}', "");
    Expect(1, 1791, '\P{^Is_Block=-	Arabic}', "");
    Expect(0, 1792, '\p{Is_Block=-	Arabic}', "");
    Expect(1, 1792, '\p{^Is_Block=-	Arabic}', "");
    Expect(1, 1792, '\P{Is_Block=-	Arabic}', "");
    Expect(0, 1792, '\P{^Is_Block=-	Arabic}', "");
    Error('\p{Is_Blk=:=__ARABIC}');
    Error('\P{Is_Blk=:=__ARABIC}');
    Expect(1, 1791, '\p{Is_Blk=arabic}', "");
    Expect(0, 1791, '\p{^Is_Blk=arabic}', "");
    Expect(0, 1791, '\P{Is_Blk=arabic}', "");
    Expect(1, 1791, '\P{^Is_Blk=arabic}', "");
    Expect(0, 1792, '\p{Is_Blk=arabic}', "");
    Expect(1, 1792, '\p{^Is_Blk=arabic}', "");
    Expect(1, 1792, '\P{Is_Blk=arabic}', "");
    Expect(0, 1792, '\P{^Is_Blk=arabic}', "");
    Expect(1, 1791, '\p{Is_Blk=		arabic}', "");
    Expect(0, 1791, '\p{^Is_Blk=		arabic}', "");
    Expect(0, 1791, '\P{Is_Blk=		arabic}', "");
    Expect(1, 1791, '\P{^Is_Blk=		arabic}', "");
    Expect(0, 1792, '\p{Is_Blk=		arabic}', "");
    Expect(1, 1792, '\p{^Is_Blk=		arabic}', "");
    Expect(1, 1792, '\P{Is_Blk=		arabic}', "");
    Expect(0, 1792, '\P{^Is_Blk=		arabic}', "");
    Error('\p{Block=:=Arabic_EXTENDED_A}');
    Error('\P{Block=:=Arabic_EXTENDED_A}');
    Expect(1, 2303, '\p{Block=:\AArabic_Extended_A\z:}', "");;
    Expect(0, 2304, '\p{Block=:\AArabic_Extended_A\z:}', "");;
    Expect(1, 2303, '\p{Block=arabicextendeda}', "");
    Expect(0, 2303, '\p{^Block=arabicextendeda}', "");
    Expect(0, 2303, '\P{Block=arabicextendeda}', "");
    Expect(1, 2303, '\P{^Block=arabicextendeda}', "");
    Expect(0, 2304, '\p{Block=arabicextendeda}', "");
    Expect(1, 2304, '\p{^Block=arabicextendeda}', "");
    Expect(1, 2304, '\P{Block=arabicextendeda}', "");
    Expect(0, 2304, '\P{^Block=arabicextendeda}', "");
    Expect(1, 2303, '\p{Block=:\Aarabicextendeda\z:}', "");;
    Expect(0, 2304, '\p{Block=:\Aarabicextendeda\z:}', "");;
    Expect(1, 2303, '\p{Block=_ ARABIC_Extended_A}', "");
    Expect(0, 2303, '\p{^Block=_ ARABIC_Extended_A}', "");
    Expect(0, 2303, '\P{Block=_ ARABIC_Extended_A}', "");
    Expect(1, 2303, '\P{^Block=_ ARABIC_Extended_A}', "");
    Expect(0, 2304, '\p{Block=_ ARABIC_Extended_A}', "");
    Expect(1, 2304, '\p{^Block=_ ARABIC_Extended_A}', "");
    Expect(1, 2304, '\P{Block=_ ARABIC_Extended_A}', "");
    Expect(0, 2304, '\P{^Block=_ ARABIC_Extended_A}', "");
    Error('\p{Blk:-:=Arabic_Ext_A}');
    Error('\P{Blk:-:=Arabic_Ext_A}');
    Expect(1, 2303, '\p{Blk=:\AArabic_Ext_A\z:}', "");;
    Expect(0, 2304, '\p{Blk=:\AArabic_Ext_A\z:}', "");;
    Expect(1, 2303, '\p{Blk=arabicexta}', "");
    Expect(0, 2303, '\p{^Blk=arabicexta}', "");
    Expect(0, 2303, '\P{Blk=arabicexta}', "");
    Expect(1, 2303, '\P{^Blk=arabicexta}', "");
    Expect(0, 2304, '\p{Blk=arabicexta}', "");
    Expect(1, 2304, '\p{^Blk=arabicexta}', "");
    Expect(1, 2304, '\P{Blk=arabicexta}', "");
    Expect(0, 2304, '\P{^Blk=arabicexta}', "");
    Expect(1, 2303, '\p{Blk=:\Aarabicexta\z:}', "");;
    Expect(0, 2304, '\p{Blk=:\Aarabicexta\z:}', "");;
    Expect(1, 2303, '\p{Blk=_Arabic_Ext_a}', "");
    Expect(0, 2303, '\p{^Blk=_Arabic_Ext_a}', "");
    Expect(0, 2303, '\P{Blk=_Arabic_Ext_a}', "");
    Expect(1, 2303, '\P{^Blk=_Arabic_Ext_a}', "");
    Expect(0, 2304, '\p{Blk=_Arabic_Ext_a}', "");
    Expect(1, 2304, '\p{^Blk=_Arabic_Ext_a}', "");
    Expect(1, 2304, '\P{Blk=_Arabic_Ext_a}', "");
    Expect(0, 2304, '\P{^Blk=_Arabic_Ext_a}', "");
    Error('\p{Is_Block=/a/	Arabic_EXTENDED_a}');
    Error('\P{Is_Block=/a/	Arabic_EXTENDED_a}');
    Expect(1, 2303, '\p{Is_Block=arabicextendeda}', "");
    Expect(0, 2303, '\p{^Is_Block=arabicextendeda}', "");
    Expect(0, 2303, '\P{Is_Block=arabicextendeda}', "");
    Expect(1, 2303, '\P{^Is_Block=arabicextendeda}', "");
    Expect(0, 2304, '\p{Is_Block=arabicextendeda}', "");
    Expect(1, 2304, '\p{^Is_Block=arabicextendeda}', "");
    Expect(1, 2304, '\P{Is_Block=arabicextendeda}', "");
    Expect(0, 2304, '\P{^Is_Block=arabicextendeda}', "");
    Expect(1, 2303, '\p{Is_Block=- arabic_extended_a}', "");
    Expect(0, 2303, '\p{^Is_Block=- arabic_extended_a}', "");
    Expect(0, 2303, '\P{Is_Block=- arabic_extended_a}', "");
    Expect(1, 2303, '\P{^Is_Block=- arabic_extended_a}', "");
    Expect(0, 2304, '\p{Is_Block=- arabic_extended_a}', "");
    Expect(1, 2304, '\p{^Is_Block=- arabic_extended_a}', "");
    Expect(1, 2304, '\P{Is_Block=- arabic_extended_a}', "");
    Expect(0, 2304, '\P{^Is_Block=- arabic_extended_a}', "");
    Error('\p{Is_Blk:	 _Arabic_Ext_A/a/}');
    Error('\P{Is_Blk:	 _Arabic_Ext_A/a/}');
    Expect(1, 2303, '\p{Is_Blk=arabicexta}', "");
    Expect(0, 2303, '\p{^Is_Blk=arabicexta}', "");
    Expect(0, 2303, '\P{Is_Blk=arabicexta}', "");
    Expect(1, 2303, '\P{^Is_Blk=arabicexta}', "");
    Expect(0, 2304, '\p{Is_Blk=arabicexta}', "");
    Expect(1, 2304, '\p{^Is_Blk=arabicexta}', "");
    Expect(1, 2304, '\P{Is_Blk=arabicexta}', "");
    Expect(0, 2304, '\P{^Is_Blk=arabicexta}', "");
    Expect(1, 2303, '\p{Is_Blk=_arabic_Ext_A}', "");
    Expect(0, 2303, '\p{^Is_Blk=_arabic_Ext_A}', "");
    Expect(0, 2303, '\P{Is_Blk=_arabic_Ext_A}', "");
    Expect(1, 2303, '\P{^Is_Blk=_arabic_Ext_A}', "");
    Expect(0, 2304, '\p{Is_Blk=_arabic_Ext_A}', "");
    Expect(1, 2304, '\p{^Is_Blk=_arabic_Ext_A}', "");
    Expect(1, 2304, '\P{Is_Blk=_arabic_Ext_A}', "");
    Expect(0, 2304, '\P{^Is_Blk=_arabic_Ext_A}', "");
    Error('\p{Block=:=Arabic_MATHEMATICAL_Alphabetic_symbols}');
    Error('\P{Block=:=Arabic_MATHEMATICAL_Alphabetic_symbols}');
    Expect(1, 126719, '\p{Block=:\AArabic_Mathematical_Alphabetic_Symbols\z:}', "");;
    Expect(0, 126720, '\p{Block=:\AArabic_Mathematical_Alphabetic_Symbols\z:}', "");;
    Expect(1, 126719, '\p{Block:   arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\p{^Block:   arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\P{Block:   arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\P{^Block:   arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\p{Block:   arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\p{^Block:   arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\P{Block:   arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\P{^Block:   arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\p{Block=:\Aarabicmathematicalalphabeticsymbols\z:}', "");;
    Expect(0, 126720, '\p{Block=:\Aarabicmathematicalalphabeticsymbols\z:}', "");;
    Expect(1, 126719, '\p{Block=-ARABIC_Mathematical_Alphabetic_symbols}', "");
    Expect(0, 126719, '\p{^Block=-ARABIC_Mathematical_Alphabetic_symbols}', "");
    Expect(0, 126719, '\P{Block=-ARABIC_Mathematical_Alphabetic_symbols}', "");
    Expect(1, 126719, '\P{^Block=-ARABIC_Mathematical_Alphabetic_symbols}', "");
    Expect(0, 126720, '\p{Block=-ARABIC_Mathematical_Alphabetic_symbols}', "");
    Expect(1, 126720, '\p{^Block=-ARABIC_Mathematical_Alphabetic_symbols}', "");
    Expect(1, 126720, '\P{Block=-ARABIC_Mathematical_Alphabetic_symbols}', "");
    Expect(0, 126720, '\P{^Block=-ARABIC_Mathematical_Alphabetic_symbols}', "");
    Error('\p{Blk=- arabic_Math:=}');
    Error('\P{Blk=- arabic_Math:=}');
    Expect(1, 126719, '\p{Blk=:\AArabic_Math\z:}', "");;
    Expect(0, 126720, '\p{Blk=:\AArabic_Math\z:}', "");;
    Expect(1, 126719, '\p{Blk=arabicmath}', "");
    Expect(0, 126719, '\p{^Blk=arabicmath}', "");
    Expect(0, 126719, '\P{Blk=arabicmath}', "");
    Expect(1, 126719, '\P{^Blk=arabicmath}', "");
    Expect(0, 126720, '\p{Blk=arabicmath}', "");
    Expect(1, 126720, '\p{^Blk=arabicmath}', "");
    Expect(1, 126720, '\P{Blk=arabicmath}', "");
    Expect(0, 126720, '\P{^Blk=arabicmath}', "");
    Expect(1, 126719, '\p{Blk=:\Aarabicmath\z:}', "");;
    Expect(0, 126720, '\p{Blk=:\Aarabicmath\z:}', "");;
    Expect(1, 126719, '\p{Blk=	_arabic_Math}', "");
    Expect(0, 126719, '\p{^Blk=	_arabic_Math}', "");
    Expect(0, 126719, '\P{Blk=	_arabic_Math}', "");
    Expect(1, 126719, '\P{^Blk=	_arabic_Math}', "");
    Expect(0, 126720, '\p{Blk=	_arabic_Math}', "");
    Expect(1, 126720, '\p{^Blk=	_arabic_Math}', "");
    Expect(1, 126720, '\P{Blk=	_arabic_Math}', "");
    Expect(0, 126720, '\P{^Blk=	_arabic_Math}', "");
    Error('\p{Is_Block=_:=ARABIC_MATHEMATICAL_Alphabetic_Symbols}');
    Error('\P{Is_Block=_:=ARABIC_MATHEMATICAL_Alphabetic_Symbols}');
    Expect(1, 126719, '\p{Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\p{^Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\P{Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\P{^Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\p{Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\p{^Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\P{Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\P{^Is_Block=arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\p{Is_Block=_ARABIC_MATHEMATICAL_ALPHABETIC_symbols}', "");
    Expect(0, 126719, '\p{^Is_Block=_ARABIC_MATHEMATICAL_ALPHABETIC_symbols}', "");
    Expect(0, 126719, '\P{Is_Block=_ARABIC_MATHEMATICAL_ALPHABETIC_symbols}', "");
    Expect(1, 126719, '\P{^Is_Block=_ARABIC_MATHEMATICAL_ALPHABETIC_symbols}', "");
    Expect(0, 126720, '\p{Is_Block=_ARABIC_MATHEMATICAL_ALPHABETIC_symbols}', "");
    Expect(1, 126720, '\p{^Is_Block=_ARABIC_MATHEMATICAL_ALPHABETIC_symbols}', "");
    Expect(1, 126720, '\P{Is_Block=_ARABIC_MATHEMATICAL_ALPHABETIC_symbols}', "");
    Expect(0, 126720, '\P{^Is_Block=_ARABIC_MATHEMATICAL_ALPHABETIC_symbols}', "");
    Error('\p{Is_Blk=:=-	Arabic_MATH}');
    Error('\P{Is_Blk=:=-	Arabic_MATH}');
    Expect(1, 126719, '\p{Is_Blk=arabicmath}', "");
    Expect(0, 126719, '\p{^Is_Blk=arabicmath}', "");
    Expect(0, 126719, '\P{Is_Blk=arabicmath}', "");
    Expect(1, 126719, '\P{^Is_Blk=arabicmath}', "");
    Expect(0, 126720, '\p{Is_Blk=arabicmath}', "");
    Expect(1, 126720, '\p{^Is_Blk=arabicmath}', "");
    Expect(1, 126720, '\P{Is_Blk=arabicmath}', "");
    Expect(0, 126720, '\P{^Is_Blk=arabicmath}', "");
    Expect(1, 126719, '\p{Is_Blk:		_Arabic_math}', "");
    Expect(0, 126719, '\p{^Is_Blk:		_Arabic_math}', "");
    Expect(0, 126719, '\P{Is_Blk:		_Arabic_math}', "");
    Expect(1, 126719, '\P{^Is_Blk:		_Arabic_math}', "");
    Expect(0, 126720, '\p{Is_Blk:		_Arabic_math}', "");
    Expect(1, 126720, '\p{^Is_Blk:		_Arabic_math}', "");
    Expect(1, 126720, '\P{Is_Blk:		_Arabic_math}', "");
    Expect(0, 126720, '\P{^Is_Blk:		_Arabic_math}', "");
    Error('\p{Block= 	arabic_PRESENTATION_forms_A:=}');
    Error('\P{Block= 	arabic_PRESENTATION_forms_A:=}');
    Expect(1, 65023, '\p{Block=:\AArabic_Presentation_Forms_A\z:}', "");;
    Expect(0, 65024, '\p{Block=:\AArabic_Presentation_Forms_A\z:}', "");;
    Expect(1, 65023, '\p{Block=arabicpresentationformsa}', "");
    Expect(0, 65023, '\p{^Block=arabicpresentationformsa}', "");
    Expect(0, 65023, '\P{Block=arabicpresentationformsa}', "");
    Expect(1, 65023, '\P{^Block=arabicpresentationformsa}', "");
    Expect(0, 65024, '\p{Block=arabicpresentationformsa}', "");
    Expect(1, 65024, '\p{^Block=arabicpresentationformsa}', "");
    Expect(1, 65024, '\P{Block=arabicpresentationformsa}', "");
    Expect(0, 65024, '\P{^Block=arabicpresentationformsa}', "");
    Expect(1, 65023, '\p{Block=:\Aarabicpresentationformsa\z:}', "");;
    Expect(0, 65024, '\p{Block=:\Aarabicpresentationformsa\z:}', "");;
    Expect(1, 65023, '\p{Block=  ARABIC_presentation_Forms_A}', "");
    Expect(0, 65023, '\p{^Block=  ARABIC_presentation_Forms_A}', "");
    Expect(0, 65023, '\P{Block=  ARABIC_presentation_Forms_A}', "");
    Expect(1, 65023, '\P{^Block=  ARABIC_presentation_Forms_A}', "");
    Expect(0, 65024, '\p{Block=  ARABIC_presentation_Forms_A}', "");
    Expect(1, 65024, '\p{^Block=  ARABIC_presentation_Forms_A}', "");
    Expect(1, 65024, '\P{Block=  ARABIC_presentation_Forms_A}', "");
    Expect(0, 65024, '\P{^Block=  ARABIC_presentation_Forms_A}', "");
    Error('\p{Blk=-:=arabic_PF_a}');
    Error('\P{Blk=-:=arabic_PF_a}');
    Expect(1, 65023, '\p{Blk=:\AArabic_PF_A\z:}', "");;
    Expect(0, 65024, '\p{Blk=:\AArabic_PF_A\z:}', "");;
    Expect(1, 65023, '\p{Blk=arabicpfa}', "");
    Expect(0, 65023, '\p{^Blk=arabicpfa}', "");
    Expect(0, 65023, '\P{Blk=arabicpfa}', "");
    Expect(1, 65023, '\P{^Blk=arabicpfa}', "");
    Expect(0, 65024, '\p{Blk=arabicpfa}', "");
    Expect(1, 65024, '\p{^Blk=arabicpfa}', "");
    Expect(1, 65024, '\P{Blk=arabicpfa}', "");
    Expect(0, 65024, '\P{^Blk=arabicpfa}', "");
    Expect(1, 65023, '\p{Blk=:\Aarabicpfa\z:}', "");;
    Expect(0, 65024, '\p{Blk=:\Aarabicpfa\z:}', "");;
    Expect(1, 65023, '\p{Blk=_ Arabic_pf_A}', "");
    Expect(0, 65023, '\p{^Blk=_ Arabic_pf_A}', "");
    Expect(0, 65023, '\P{Blk=_ Arabic_pf_A}', "");
    Expect(1, 65023, '\P{^Blk=_ Arabic_pf_A}', "");
    Expect(0, 65024, '\p{Blk=_ Arabic_pf_A}', "");
    Expect(1, 65024, '\p{^Blk=_ Arabic_pf_A}', "");
    Expect(1, 65024, '\P{Blk=_ Arabic_pf_A}', "");
    Expect(0, 65024, '\P{^Blk=_ Arabic_pf_A}', "");
    Error('\p{Is_Block=/a/-_arabic_PRESENTATION_Forms_A}');
    Error('\P{Is_Block=/a/-_arabic_PRESENTATION_Forms_A}');
    Expect(1, 65023, '\p{Is_Block:arabicpresentationformsa}', "");
    Expect(0, 65023, '\p{^Is_Block:arabicpresentationformsa}', "");
    Expect(0, 65023, '\P{Is_Block:arabicpresentationformsa}', "");
    Expect(1, 65023, '\P{^Is_Block:arabicpresentationformsa}', "");
    Expect(0, 65024, '\p{Is_Block:arabicpresentationformsa}', "");
    Expect(1, 65024, '\p{^Is_Block:arabicpresentationformsa}', "");
    Expect(1, 65024, '\P{Is_Block:arabicpresentationformsa}', "");
    Expect(0, 65024, '\P{^Is_Block:arabicpresentationformsa}', "");
    Expect(1, 65023, '\p{Is_Block=-_ARABIC_presentation_FORMS_A}', "");
    Expect(0, 65023, '\p{^Is_Block=-_ARABIC_presentation_FORMS_A}', "");
    Expect(0, 65023, '\P{Is_Block=-_ARABIC_presentation_FORMS_A}', "");
    Expect(1, 65023, '\P{^Is_Block=-_ARABIC_presentation_FORMS_A}', "");
    Expect(0, 65024, '\p{Is_Block=-_ARABIC_presentation_FORMS_A}', "");
    Expect(1, 65024, '\p{^Is_Block=-_ARABIC_presentation_FORMS_A}', "");
    Expect(1, 65024, '\P{Is_Block=-_ARABIC_presentation_FORMS_A}', "");
    Expect(0, 65024, '\P{^Is_Block=-_ARABIC_presentation_FORMS_A}', "");
    Error('\p{Is_Blk: /a/__Arabic_PF_a}');
    Error('\P{Is_Blk: /a/__Arabic_PF_a}');
    Expect(1, 65023, '\p{Is_Blk=arabicpfa}', "");
    Expect(0, 65023, '\p{^Is_Blk=arabicpfa}', "");
    Expect(0, 65023, '\P{Is_Blk=arabicpfa}', "");
    Expect(1, 65023, '\P{^Is_Blk=arabicpfa}', "");
    Expect(0, 65024, '\p{Is_Blk=arabicpfa}', "");
    Expect(1, 65024, '\p{^Is_Blk=arabicpfa}', "");
    Expect(1, 65024, '\P{Is_Blk=arabicpfa}', "");
    Expect(0, 65024, '\P{^Is_Blk=arabicpfa}', "");
    Expect(1, 65023, '\p{Is_Blk=_ARABIC_pf_A}', "");
    Expect(0, 65023, '\p{^Is_Blk=_ARABIC_pf_A}', "");
    Expect(0, 65023, '\P{Is_Blk=_ARABIC_pf_A}', "");
    Expect(1, 65023, '\P{^Is_Blk=_ARABIC_pf_A}', "");
    Expect(0, 65024, '\p{Is_Blk=_ARABIC_pf_A}', "");
    Expect(1, 65024, '\p{^Is_Blk=_ARABIC_pf_A}', "");
    Expect(1, 65024, '\P{Is_Blk=_ARABIC_pf_A}', "");
    Expect(0, 65024, '\P{^Is_Blk=_ARABIC_pf_A}', "");
    Error('\p{Block=  arabic_Presentation_forms_B:=}');
    Error('\P{Block=  arabic_Presentation_forms_B:=}');
    Expect(1, 65279, '\p{Block=:\AArabic_Presentation_Forms_B\z:}', "");;
    Expect(0, 65280, '\p{Block=:\AArabic_Presentation_Forms_B\z:}', "");;
    Expect(1, 65279, '\p{Block=arabicpresentationformsb}', "");
    Expect(0, 65279, '\p{^Block=arabicpresentationformsb}', "");
    Expect(0, 65279, '\P{Block=arabicpresentationformsb}', "");
    Expect(1, 65279, '\P{^Block=arabicpresentationformsb}', "");
    Expect(0, 65280, '\p{Block=arabicpresentationformsb}', "");
    Expect(1, 65280, '\p{^Block=arabicpresentationformsb}', "");
    Expect(1, 65280, '\P{Block=arabicpresentationformsb}', "");
    Expect(0, 65280, '\P{^Block=arabicpresentationformsb}', "");
    Expect(1, 65279, '\p{Block=:\Aarabicpresentationformsb\z:}', "");;
    Expect(0, 65280, '\p{Block=:\Aarabicpresentationformsb\z:}', "");;
    Expect(1, 65279, '\p{Block=-arabic_presentation_Forms_B}', "");
    Expect(0, 65279, '\p{^Block=-arabic_presentation_Forms_B}', "");
    Expect(0, 65279, '\P{Block=-arabic_presentation_Forms_B}', "");
    Expect(1, 65279, '\P{^Block=-arabic_presentation_Forms_B}', "");
    Expect(0, 65280, '\p{Block=-arabic_presentation_Forms_B}', "");
    Expect(1, 65280, '\p{^Block=-arabic_presentation_Forms_B}', "");
    Expect(1, 65280, '\P{Block=-arabic_presentation_Forms_B}', "");
    Expect(0, 65280, '\P{^Block=-arabic_presentation_Forms_B}', "");
    Error('\p{Blk=_:=Arabic_pf_B}');
    Error('\P{Blk=_:=Arabic_pf_B}');
    Expect(1, 65279, '\p{Blk=:\AArabic_PF_B\z:}', "");;
    Expect(0, 65280, '\p{Blk=:\AArabic_PF_B\z:}', "");;
    Expect(1, 65279, '\p{Blk=arabicpfb}', "");
    Expect(0, 65279, '\p{^Blk=arabicpfb}', "");
    Expect(0, 65279, '\P{Blk=arabicpfb}', "");
    Expect(1, 65279, '\P{^Blk=arabicpfb}', "");
    Expect(0, 65280, '\p{Blk=arabicpfb}', "");
    Expect(1, 65280, '\p{^Blk=arabicpfb}', "");
    Expect(1, 65280, '\P{Blk=arabicpfb}', "");
    Expect(0, 65280, '\P{^Blk=arabicpfb}', "");
    Expect(1, 65279, '\p{Blk=:\Aarabicpfb\z:}', "");;
    Expect(0, 65280, '\p{Blk=:\Aarabicpfb\z:}', "");;
    Expect(1, 65279, '\p{Blk=_arabic_pf_B}', "");
    Expect(0, 65279, '\p{^Blk=_arabic_pf_B}', "");
    Expect(0, 65279, '\P{Blk=_arabic_pf_B}', "");
    Expect(1, 65279, '\P{^Blk=_arabic_pf_B}', "");
    Expect(0, 65280, '\p{Blk=_arabic_pf_B}', "");
    Expect(1, 65280, '\p{^Blk=_arabic_pf_B}', "");
    Expect(1, 65280, '\P{Blk=_arabic_pf_B}', "");
    Expect(0, 65280, '\P{^Blk=_arabic_pf_B}', "");
    Error('\p{Is_Block= _arabic_Presentation_Forms_b:=}');
    Error('\P{Is_Block= _arabic_Presentation_Forms_b:=}');
    Expect(1, 65279, '\p{Is_Block=arabicpresentationformsb}', "");
    Expect(0, 65279, '\p{^Is_Block=arabicpresentationformsb}', "");
    Expect(0, 65279, '\P{Is_Block=arabicpresentationformsb}', "");
    Expect(1, 65279, '\P{^Is_Block=arabicpresentationformsb}', "");
    Expect(0, 65280, '\p{Is_Block=arabicpresentationformsb}', "");
    Expect(1, 65280, '\p{^Is_Block=arabicpresentationformsb}', "");
    Expect(1, 65280, '\P{Is_Block=arabicpresentationformsb}', "");
    Expect(0, 65280, '\P{^Is_Block=arabicpresentationformsb}', "");
    Expect(1, 65279, '\p{Is_Block= -Arabic_Presentation_Forms_B}', "");
    Expect(0, 65279, '\p{^Is_Block= -Arabic_Presentation_Forms_B}', "");
    Expect(0, 65279, '\P{Is_Block= -Arabic_Presentation_Forms_B}', "");
    Expect(1, 65279, '\P{^Is_Block= -Arabic_Presentation_Forms_B}', "");
    Expect(0, 65280, '\p{Is_Block= -Arabic_Presentation_Forms_B}', "");
    Expect(1, 65280, '\p{^Is_Block= -Arabic_Presentation_Forms_B}', "");
    Expect(1, 65280, '\P{Is_Block= -Arabic_Presentation_Forms_B}', "");
    Expect(0, 65280, '\P{^Is_Block= -Arabic_Presentation_Forms_B}', "");
    Error('\p{Is_Blk=-/a/ARABIC_pf_B}');
    Error('\P{Is_Blk=-/a/ARABIC_pf_B}');
    Expect(1, 65279, '\p{Is_Blk=arabicpfb}', "");
    Expect(0, 65279, '\p{^Is_Blk=arabicpfb}', "");
    Expect(0, 65279, '\P{Is_Blk=arabicpfb}', "");
    Expect(1, 65279, '\P{^Is_Blk=arabicpfb}', "");
    Expect(0, 65280, '\p{Is_Blk=arabicpfb}', "");
    Expect(1, 65280, '\p{^Is_Blk=arabicpfb}', "");
    Expect(1, 65280, '\P{Is_Blk=arabicpfb}', "");
    Expect(0, 65280, '\P{^Is_Blk=arabicpfb}', "");
    Expect(1, 65279, '\p{Is_Blk=Arabic_PF_B}', "");
    Expect(0, 65279, '\p{^Is_Blk=Arabic_PF_B}', "");
    Expect(0, 65279, '\P{Is_Blk=Arabic_PF_B}', "");
    Expect(1, 65279, '\P{^Is_Blk=Arabic_PF_B}', "");
    Expect(0, 65280, '\p{Is_Blk=Arabic_PF_B}', "");
    Expect(1, 65280, '\p{^Is_Blk=Arabic_PF_B}', "");
    Expect(1, 65280, '\P{Is_Blk=Arabic_PF_B}', "");
    Expect(0, 65280, '\P{^Is_Blk=Arabic_PF_B}', "");
    Error('\p{Block=/a/Arabic_supplement}');
    Error('\P{Block=/a/Arabic_supplement}');
    Expect(1, 1919, '\p{Block=:\AArabic_Supplement\z:}', "");;
    Expect(0, 1920, '\p{Block=:\AArabic_Supplement\z:}', "");;
    Expect(1, 1919, '\p{Block=arabicsupplement}', "");
    Expect(0, 1919, '\p{^Block=arabicsupplement}', "");
    Expect(0, 1919, '\P{Block=arabicsupplement}', "");
    Expect(1, 1919, '\P{^Block=arabicsupplement}', "");
    Expect(0, 1920, '\p{Block=arabicsupplement}', "");
    Expect(1, 1920, '\p{^Block=arabicsupplement}', "");
    Expect(1, 1920, '\P{Block=arabicsupplement}', "");
    Expect(0, 1920, '\P{^Block=arabicsupplement}', "");
    Expect(1, 1919, '\p{Block=:\Aarabicsupplement\z:}', "");;
    Expect(0, 1920, '\p{Block=:\Aarabicsupplement\z:}', "");;
    Expect(1, 1919, '\p{Block=-arabic_Supplement}', "");
    Expect(0, 1919, '\p{^Block=-arabic_Supplement}', "");
    Expect(0, 1919, '\P{Block=-arabic_Supplement}', "");
    Expect(1, 1919, '\P{^Block=-arabic_Supplement}', "");
    Expect(0, 1920, '\p{Block=-arabic_Supplement}', "");
    Expect(1, 1920, '\p{^Block=-arabic_Supplement}', "");
    Expect(1, 1920, '\P{Block=-arabic_Supplement}', "");
    Expect(0, 1920, '\P{^Block=-arabic_Supplement}', "");
    Error('\p{Blk=:= arabic_Sup}');
    Error('\P{Blk=:= arabic_Sup}');
    Expect(1, 1919, '\p{Blk=:\AArabic_Sup\z:}', "");;
    Expect(0, 1920, '\p{Blk=:\AArabic_Sup\z:}', "");;
    Expect(1, 1919, '\p{Blk=arabicsup}', "");
    Expect(0, 1919, '\p{^Blk=arabicsup}', "");
    Expect(0, 1919, '\P{Blk=arabicsup}', "");
    Expect(1, 1919, '\P{^Blk=arabicsup}', "");
    Expect(0, 1920, '\p{Blk=arabicsup}', "");
    Expect(1, 1920, '\p{^Blk=arabicsup}', "");
    Expect(1, 1920, '\P{Blk=arabicsup}', "");
    Expect(0, 1920, '\P{^Blk=arabicsup}', "");
    Expect(1, 1919, '\p{Blk=:\Aarabicsup\z:}', "");;
    Expect(0, 1920, '\p{Blk=:\Aarabicsup\z:}', "");;
    Expect(1, 1919, '\p{Blk= -Arabic_Sup}', "");
    Expect(0, 1919, '\p{^Blk= -Arabic_Sup}', "");
    Expect(0, 1919, '\P{Blk= -Arabic_Sup}', "");
    Expect(1, 1919, '\P{^Blk= -Arabic_Sup}', "");
    Expect(0, 1920, '\p{Blk= -Arabic_Sup}', "");
    Expect(1, 1920, '\p{^Blk= -Arabic_Sup}', "");
    Expect(1, 1920, '\P{Blk= -Arabic_Sup}', "");
    Expect(0, 1920, '\P{^Blk= -Arabic_Sup}', "");
    Error('\p{Is_Block=-arabic_Supplement/a/}');
    Error('\P{Is_Block=-arabic_Supplement/a/}');
    Expect(1, 1919, '\p{Is_Block=arabicsupplement}', "");
    Expect(0, 1919, '\p{^Is_Block=arabicsupplement}', "");
    Expect(0, 1919, '\P{Is_Block=arabicsupplement}', "");
    Expect(1, 1919, '\P{^Is_Block=arabicsupplement}', "");
    Expect(0, 1920, '\p{Is_Block=arabicsupplement}', "");
    Expect(1, 1920, '\p{^Is_Block=arabicsupplement}', "");
    Expect(1, 1920, '\P{Is_Block=arabicsupplement}', "");
    Expect(0, 1920, '\P{^Is_Block=arabicsupplement}', "");
    Expect(1, 1919, '\p{Is_Block=	Arabic_Supplement}', "");
    Expect(0, 1919, '\p{^Is_Block=	Arabic_Supplement}', "");
    Expect(0, 1919, '\P{Is_Block=	Arabic_Supplement}', "");
    Expect(1, 1919, '\P{^Is_Block=	Arabic_Supplement}', "");
    Expect(0, 1920, '\p{Is_Block=	Arabic_Supplement}', "");
    Expect(1, 1920, '\p{^Is_Block=	Arabic_Supplement}', "");
    Expect(1, 1920, '\P{Is_Block=	Arabic_Supplement}', "");
    Expect(0, 1920, '\P{^Is_Block=	Arabic_Supplement}', "");
    Error('\p{Is_Blk:_ ARABIC_Sup:=}');
    Error('\P{Is_Blk:_ ARABIC_Sup:=}');
    Expect(1, 1919, '\p{Is_Blk=arabicsup}', "");
    Expect(0, 1919, '\p{^Is_Blk=arabicsup}', "");
    Expect(0, 1919, '\P{Is_Blk=arabicsup}', "");
    Expect(1, 1919, '\P{^Is_Blk=arabicsup}', "");
    Expect(0, 1920, '\p{Is_Blk=arabicsup}', "");
    Expect(1, 1920, '\p{^Is_Blk=arabicsup}', "");
    Expect(1, 1920, '\P{Is_Blk=arabicsup}', "");
    Expect(0, 1920, '\P{^Is_Blk=arabicsup}', "");
    Expect(1, 1919, '\p{Is_Blk=-_Arabic_Sup}', "");
    Expect(0, 1919, '\p{^Is_Blk=-_Arabic_Sup}', "");
    Expect(0, 1919, '\P{Is_Blk=-_Arabic_Sup}', "");
    Expect(1, 1919, '\P{^Is_Blk=-_Arabic_Sup}', "");
    Expect(0, 1920, '\p{Is_Blk=-_Arabic_Sup}', "");
    Expect(1, 1920, '\p{^Is_Blk=-_Arabic_Sup}', "");
    Expect(1, 1920, '\P{Is_Blk=-_Arabic_Sup}', "");
    Expect(0, 1920, '\P{^Is_Blk=-_Arabic_Sup}', "");
    Error('\p{Block:    /a/armenian}');
    Error('\P{Block:    /a/armenian}');
    Expect(1, 1423, '\p{Block=:\AArmenian\z:}', "");;
    Expect(0, 1424, '\p{Block=:\AArmenian\z:}', "");;
    Expect(1, 1423, '\p{Block=armenian}', "");
    Expect(0, 1423, '\p{^Block=armenian}', "");
    Expect(0, 1423, '\P{Block=armenian}', "");
    Expect(1, 1423, '\P{^Block=armenian}', "");
    Expect(0, 1424, '\p{Block=armenian}', "");
    Expect(1, 1424, '\p{^Block=armenian}', "");
    Expect(1, 1424, '\P{Block=armenian}', "");
    Expect(0, 1424, '\P{^Block=armenian}', "");
    Expect(1, 1423, '\p{Block=:\Aarmenian\z:}', "");;
    Expect(0, 1424, '\p{Block=:\Aarmenian\z:}', "");;
    Expect(1, 1423, '\p{Block=  ARMENIAN}', "");
    Expect(0, 1423, '\p{^Block=  ARMENIAN}', "");
    Expect(0, 1423, '\P{Block=  ARMENIAN}', "");
    Expect(1, 1423, '\P{^Block=  ARMENIAN}', "");
    Expect(0, 1424, '\p{Block=  ARMENIAN}', "");
    Expect(1, 1424, '\p{^Block=  ARMENIAN}', "");
    Expect(1, 1424, '\P{Block=  ARMENIAN}', "");
    Expect(0, 1424, '\P{^Block=  ARMENIAN}', "");
    Error('\p{Blk=	/a/Armenian}');
    Error('\P{Blk=	/a/Armenian}');
    Expect(1, 1423, '\p{Blk=:\AArmenian\z:}', "");;
    Expect(0, 1424, '\p{Blk=:\AArmenian\z:}', "");;
    Expect(1, 1423, '\p{Blk:armenian}', "");
    Expect(0, 1423, '\p{^Blk:armenian}', "");
    Expect(0, 1423, '\P{Blk:armenian}', "");
    Expect(1, 1423, '\P{^Blk:armenian}', "");
    Expect(0, 1424, '\p{Blk:armenian}', "");
    Expect(1, 1424, '\p{^Blk:armenian}', "");
    Expect(1, 1424, '\P{Blk:armenian}', "");
    Expect(0, 1424, '\P{^Blk:armenian}', "");
    Expect(1, 1423, '\p{Blk=:\Aarmenian\z:}', "");;
    Expect(0, 1424, '\p{Blk=:\Aarmenian\z:}', "");;
    Expect(1, 1423, '\p{Blk= -Armenian}', "");
    Expect(0, 1423, '\p{^Blk= -Armenian}', "");
    Expect(0, 1423, '\P{Blk= -Armenian}', "");
    Expect(1, 1423, '\P{^Blk= -Armenian}', "");
    Expect(0, 1424, '\p{Blk= -Armenian}', "");
    Expect(1, 1424, '\p{^Blk= -Armenian}', "");
    Expect(1, 1424, '\P{Blk= -Armenian}', "");
    Expect(0, 1424, '\P{^Blk= -Armenian}', "");
    Error('\p{Is_Block:		_armenian/a/}');
    Error('\P{Is_Block:		_armenian/a/}');
    Expect(1, 1423, '\p{Is_Block=armenian}', "");
    Expect(0, 1423, '\p{^Is_Block=armenian}', "");
    Expect(0, 1423, '\P{Is_Block=armenian}', "");
    Expect(1, 1423, '\P{^Is_Block=armenian}', "");
    Expect(0, 1424, '\p{Is_Block=armenian}', "");
    Expect(1, 1424, '\p{^Is_Block=armenian}', "");
    Expect(1, 1424, '\P{Is_Block=armenian}', "");
    Expect(0, 1424, '\P{^Is_Block=armenian}', "");
    Expect(1, 1423, '\p{Is_Block:		ARMENIAN}', "");
    Expect(0, 1423, '\p{^Is_Block:		ARMENIAN}', "");
    Expect(0, 1423, '\P{Is_Block:		ARMENIAN}', "");
    Expect(1, 1423, '\P{^Is_Block:		ARMENIAN}', "");
    Expect(0, 1424, '\p{Is_Block:		ARMENIAN}', "");
    Expect(1, 1424, '\p{^Is_Block:		ARMENIAN}', "");
    Expect(1, 1424, '\P{Is_Block:		ARMENIAN}', "");
    Expect(0, 1424, '\P{^Is_Block:		ARMENIAN}', "");
    Error('\p{Is_Blk=:=		Armenian}');
    Error('\P{Is_Blk=:=		Armenian}');
    Expect(1, 1423, '\p{Is_Blk=armenian}', "");
    Expect(0, 1423, '\p{^Is_Blk=armenian}', "");
    Expect(0, 1423, '\P{Is_Blk=armenian}', "");
    Expect(1, 1423, '\P{^Is_Blk=armenian}', "");
    Expect(0, 1424, '\p{Is_Blk=armenian}', "");
    Expect(1, 1424, '\p{^Is_Blk=armenian}', "");
    Expect(1, 1424, '\P{Is_Blk=armenian}', "");
    Expect(0, 1424, '\P{^Is_Blk=armenian}', "");
    Expect(1, 1423, '\p{Is_Blk=-ARMENIAN}', "");
    Expect(0, 1423, '\p{^Is_Blk=-ARMENIAN}', "");
    Expect(0, 1423, '\P{Is_Blk=-ARMENIAN}', "");
    Expect(1, 1423, '\P{^Is_Blk=-ARMENIAN}', "");
    Expect(0, 1424, '\p{Is_Blk=-ARMENIAN}', "");
    Expect(1, 1424, '\p{^Is_Blk=-ARMENIAN}', "");
    Expect(1, 1424, '\P{Is_Blk=-ARMENIAN}', "");
    Expect(0, 1424, '\P{^Is_Blk=-ARMENIAN}', "");
    Error('\p{Block=-:=Arrows}');
    Error('\P{Block=-:=Arrows}');
    Expect(1, 8703, '\p{Block=:\AArrows\z:}', "");;
    Expect(0, 8704, '\p{Block=:\AArrows\z:}', "");;
    Expect(1, 8703, '\p{Block:arrows}', "");
    Expect(0, 8703, '\p{^Block:arrows}', "");
    Expect(0, 8703, '\P{Block:arrows}', "");
    Expect(1, 8703, '\P{^Block:arrows}', "");
    Expect(0, 8704, '\p{Block:arrows}', "");
    Expect(1, 8704, '\p{^Block:arrows}', "");
    Expect(1, 8704, '\P{Block:arrows}', "");
    Expect(0, 8704, '\P{^Block:arrows}', "");
    Expect(1, 8703, '\p{Block=:\Aarrows\z:}', "");;
    Expect(0, 8704, '\p{Block=:\Aarrows\z:}', "");;
    Expect(1, 8703, '\p{Block=	_ARROWS}', "");
    Expect(0, 8703, '\p{^Block=	_ARROWS}', "");
    Expect(0, 8703, '\P{Block=	_ARROWS}', "");
    Expect(1, 8703, '\P{^Block=	_ARROWS}', "");
    Expect(0, 8704, '\p{Block=	_ARROWS}', "");
    Expect(1, 8704, '\p{^Block=	_ARROWS}', "");
    Expect(1, 8704, '\P{Block=	_ARROWS}', "");
    Expect(0, 8704, '\P{^Block=	_ARROWS}', "");
    Error('\p{Blk:_:=Arrows}');
    Error('\P{Blk:_:=Arrows}');
    Expect(1, 8703, '\p{Blk=:\AArrows\z:}', "");;
    Expect(0, 8704, '\p{Blk=:\AArrows\z:}', "");;
    Expect(1, 8703, '\p{Blk=arrows}', "");
    Expect(0, 8703, '\p{^Blk=arrows}', "");
    Expect(0, 8703, '\P{Blk=arrows}', "");
    Expect(1, 8703, '\P{^Blk=arrows}', "");
    Expect(0, 8704, '\p{Blk=arrows}', "");
    Expect(1, 8704, '\p{^Blk=arrows}', "");
    Expect(1, 8704, '\P{Blk=arrows}', "");
    Expect(0, 8704, '\P{^Blk=arrows}', "");
    Expect(1, 8703, '\p{Blk=:\Aarrows\z:}', "");;
    Expect(0, 8704, '\p{Blk=:\Aarrows\z:}', "");;
    Expect(1, 8703, '\p{Blk:    arrows}', "");
    Expect(0, 8703, '\p{^Blk:    arrows}', "");
    Expect(0, 8703, '\P{Blk:    arrows}', "");
    Expect(1, 8703, '\P{^Blk:    arrows}', "");
    Expect(0, 8704, '\p{Blk:    arrows}', "");
    Expect(1, 8704, '\p{^Blk:    arrows}', "");
    Expect(1, 8704, '\P{Blk:    arrows}', "");
    Expect(0, 8704, '\P{^Blk:    arrows}', "");
    Error('\p{Is_Block=	_Arrows/a/}');
    Error('\P{Is_Block=	_Arrows/a/}');
    Expect(1, 8703, '\p{Is_Block=arrows}', "");
    Expect(0, 8703, '\p{^Is_Block=arrows}', "");
    Expect(0, 8703, '\P{Is_Block=arrows}', "");
    Expect(1, 8703, '\P{^Is_Block=arrows}', "");
    Expect(0, 8704, '\p{Is_Block=arrows}', "");
    Expect(1, 8704, '\p{^Is_Block=arrows}', "");
    Expect(1, 8704, '\P{Is_Block=arrows}', "");
    Expect(0, 8704, '\P{^Is_Block=arrows}', "");
    Expect(1, 8703, '\p{Is_Block=--ARROWS}', "");
    Expect(0, 8703, '\p{^Is_Block=--ARROWS}', "");
    Expect(0, 8703, '\P{Is_Block=--ARROWS}', "");
    Expect(1, 8703, '\P{^Is_Block=--ARROWS}', "");
    Expect(0, 8704, '\p{Is_Block=--ARROWS}', "");
    Expect(1, 8704, '\p{^Is_Block=--ARROWS}', "");
    Expect(1, 8704, '\P{Is_Block=--ARROWS}', "");
    Expect(0, 8704, '\P{^Is_Block=--ARROWS}', "");
    Error('\p{Is_Blk= Arrows:=}');
    Error('\P{Is_Blk= Arrows:=}');
    Expect(1, 8703, '\p{Is_Blk=arrows}', "");
    Expect(0, 8703, '\p{^Is_Blk=arrows}', "");
    Expect(0, 8703, '\P{Is_Blk=arrows}', "");
    Expect(1, 8703, '\P{^Is_Blk=arrows}', "");
    Expect(0, 8704, '\p{Is_Blk=arrows}', "");
    Expect(1, 8704, '\p{^Is_Blk=arrows}', "");
    Expect(1, 8704, '\P{Is_Blk=arrows}', "");
    Expect(0, 8704, '\P{^Is_Blk=arrows}', "");
    Expect(1, 8703, '\p{Is_Blk:	-_arrows}', "");
    Expect(0, 8703, '\p{^Is_Blk:	-_arrows}', "");
    Expect(0, 8703, '\P{Is_Blk:	-_arrows}', "");
    Expect(1, 8703, '\P{^Is_Blk:	-_arrows}', "");
    Expect(0, 8704, '\p{Is_Blk:	-_arrows}', "");
    Expect(1, 8704, '\p{^Is_Blk:	-_arrows}', "");
    Expect(1, 8704, '\P{Is_Blk:	-_arrows}', "");
    Expect(0, 8704, '\P{^Is_Blk:	-_arrows}', "");
    Error('\p{Block= 	BASIC_Latin:=}');
    Error('\P{Block= 	BASIC_Latin:=}');
    Expect(1, 127, '\p{Block=:\ABasic_Latin\z:}', "");;
    Expect(0, 128, '\p{Block=:\ABasic_Latin\z:}', "");;
    Expect(1, 127, '\p{Block: basiclatin}', "");
    Expect(0, 127, '\p{^Block: basiclatin}', "");
    Expect(0, 127, '\P{Block: basiclatin}', "");
    Expect(1, 127, '\P{^Block: basiclatin}', "");
    Expect(0, 128, '\p{Block: basiclatin}', "");
    Expect(1, 128, '\p{^Block: basiclatin}', "");
    Expect(1, 128, '\P{Block: basiclatin}', "");
    Expect(0, 128, '\P{^Block: basiclatin}', "");
    Expect(1, 127, '\p{Block=:\Abasiclatin\z:}', "");;
    Expect(0, 128, '\p{Block=:\Abasiclatin\z:}', "");;
    Expect(1, 127, '\p{Block=	basic_LATIN}', "");
    Expect(0, 127, '\p{^Block=	basic_LATIN}', "");
    Expect(0, 127, '\P{Block=	basic_LATIN}', "");
    Expect(1, 127, '\P{^Block=	basic_LATIN}', "");
    Expect(0, 128, '\p{Block=	basic_LATIN}', "");
    Expect(1, 128, '\p{^Block=	basic_LATIN}', "");
    Expect(1, 128, '\P{Block=	basic_LATIN}', "");
    Expect(0, 128, '\P{^Block=	basic_LATIN}', "");
    Error('\p{Blk=:= -ASCII}');
    Error('\P{Blk=:= -ASCII}');
    Expect(1, 127, '\p{Blk=:\AASCII\z:}', "");;
    Expect(0, 128, '\p{Blk=:\AASCII\z:}', "");;
    Expect(1, 127, '\p{Blk=ascii}', "");
    Expect(0, 127, '\p{^Blk=ascii}', "");
    Expect(0, 127, '\P{Blk=ascii}', "");
    Expect(1, 127, '\P{^Blk=ascii}', "");
    Expect(0, 128, '\p{Blk=ascii}', "");
    Expect(1, 128, '\p{^Blk=ascii}', "");
    Expect(1, 128, '\P{Blk=ascii}', "");
    Expect(0, 128, '\P{^Blk=ascii}', "");
    Expect(1, 127, '\p{Blk=:\Aascii\z:}', "");;
    Expect(0, 128, '\p{Blk=:\Aascii\z:}', "");;
    Expect(1, 127, '\p{Blk: _	ASCII}', "");
    Expect(0, 127, '\p{^Blk: _	ASCII}', "");
    Expect(0, 127, '\P{Blk: _	ASCII}', "");
    Expect(1, 127, '\P{^Blk: _	ASCII}', "");
    Expect(0, 128, '\p{Blk: _	ASCII}', "");
    Expect(1, 128, '\p{^Blk: _	ASCII}', "");
    Expect(1, 128, '\P{Blk: _	ASCII}', "");
    Expect(0, 128, '\P{^Blk: _	ASCII}', "");
    Error('\p{Is_Block=:=		Basic_latin}');
    Error('\P{Is_Block=:=		Basic_latin}');
    Expect(1, 127, '\p{Is_Block=basiclatin}', "");
    Expect(0, 127, '\p{^Is_Block=basiclatin}', "");
    Expect(0, 127, '\P{Is_Block=basiclatin}', "");
    Expect(1, 127, '\P{^Is_Block=basiclatin}', "");
    Expect(0, 128, '\p{Is_Block=basiclatin}', "");
    Expect(1, 128, '\p{^Is_Block=basiclatin}', "");
    Expect(1, 128, '\P{Is_Block=basiclatin}', "");
    Expect(0, 128, '\P{^Is_Block=basiclatin}', "");
    Expect(1, 127, '\p{Is_Block=_	BASIC_Latin}', "");
    Expect(0, 127, '\p{^Is_Block=_	BASIC_Latin}', "");
    Expect(0, 127, '\P{Is_Block=_	BASIC_Latin}', "");
    Expect(1, 127, '\P{^Is_Block=_	BASIC_Latin}', "");
    Expect(0, 128, '\p{Is_Block=_	BASIC_Latin}', "");
    Expect(1, 128, '\p{^Is_Block=_	BASIC_Latin}', "");
    Expect(1, 128, '\P{Is_Block=_	BASIC_Latin}', "");
    Expect(0, 128, '\P{^Is_Block=_	BASIC_Latin}', "");
    Error('\p{Is_Blk=_ ASCII:=}');
    Error('\P{Is_Blk=_ ASCII:=}');
    Expect(1, 127, '\p{Is_Blk=ascii}', "");
    Expect(0, 127, '\p{^Is_Blk=ascii}', "");
    Expect(0, 127, '\P{Is_Blk=ascii}', "");
    Expect(1, 127, '\P{^Is_Blk=ascii}', "");
    Expect(0, 128, '\p{Is_Blk=ascii}', "");
    Expect(1, 128, '\p{^Is_Blk=ascii}', "");
    Expect(1, 128, '\P{Is_Blk=ascii}', "");
    Expect(0, 128, '\P{^Is_Blk=ascii}', "");
    Expect(1, 127, '\p{Is_Blk= -ascii}', "");
    Expect(0, 127, '\p{^Is_Blk= -ascii}', "");
    Expect(0, 127, '\P{Is_Blk= -ascii}', "");
    Expect(1, 127, '\P{^Is_Blk= -ascii}', "");
    Expect(0, 128, '\p{Is_Blk= -ascii}', "");
    Expect(1, 128, '\p{^Is_Blk= -ascii}', "");
    Expect(1, 128, '\P{Is_Blk= -ascii}', "");
    Expect(0, 128, '\P{^Is_Blk= -ascii}', "");
    Error('\p{Block= 	AVESTAN:=}');
    Error('\P{Block= 	AVESTAN:=}');
    Expect(1, 68415, '\p{Block=:\AAvestan\z:}', "");;
    Expect(0, 68416, '\p{Block=:\AAvestan\z:}', "");;
    Expect(1, 68415, '\p{Block=avestan}', "");
    Expect(0, 68415, '\p{^Block=avestan}', "");
    Expect(0, 68415, '\P{Block=avestan}', "");
    Expect(1, 68415, '\P{^Block=avestan}', "");
    Expect(0, 68416, '\p{Block=avestan}', "");
    Expect(1, 68416, '\p{^Block=avestan}', "");
    Expect(1, 68416, '\P{Block=avestan}', "");
    Expect(0, 68416, '\P{^Block=avestan}', "");
    Expect(1, 68415, '\p{Block=:\Aavestan\z:}', "");;
    Expect(0, 68416, '\p{Block=:\Aavestan\z:}', "");;
    Expect(1, 68415, '\p{Block=-_Avestan}', "");
    Expect(0, 68415, '\p{^Block=-_Avestan}', "");
    Expect(0, 68415, '\P{Block=-_Avestan}', "");
    Expect(1, 68415, '\P{^Block=-_Avestan}', "");
    Expect(0, 68416, '\p{Block=-_Avestan}', "");
    Expect(1, 68416, '\p{^Block=-_Avestan}', "");
    Expect(1, 68416, '\P{Block=-_Avestan}', "");
    Expect(0, 68416, '\P{^Block=-_Avestan}', "");
    Error('\p{Blk=_/a/Avestan}');
    Error('\P{Blk=_/a/Avestan}');
    Expect(1, 68415, '\p{Blk=:\AAvestan\z:}', "");;
    Expect(0, 68416, '\p{Blk=:\AAvestan\z:}', "");;
    Expect(1, 68415, '\p{Blk=avestan}', "");
    Expect(0, 68415, '\p{^Blk=avestan}', "");
    Expect(0, 68415, '\P{Blk=avestan}', "");
    Expect(1, 68415, '\P{^Blk=avestan}', "");
    Expect(0, 68416, '\p{Blk=avestan}', "");
    Expect(1, 68416, '\p{^Blk=avestan}', "");
    Expect(1, 68416, '\P{Blk=avestan}', "");
    Expect(0, 68416, '\P{^Blk=avestan}', "");
    Expect(1, 68415, '\p{Blk=:\Aavestan\z:}', "");;
    Expect(0, 68416, '\p{Blk=:\Aavestan\z:}', "");;
    Expect(1, 68415, '\p{Blk=	_Avestan}', "");
    Expect(0, 68415, '\p{^Blk=	_Avestan}', "");
    Expect(0, 68415, '\P{Blk=	_Avestan}', "");
    Expect(1, 68415, '\P{^Blk=	_Avestan}', "");
    Expect(0, 68416, '\p{Blk=	_Avestan}', "");
    Expect(1, 68416, '\p{^Blk=	_Avestan}', "");
    Expect(1, 68416, '\P{Blk=	_Avestan}', "");
    Expect(0, 68416, '\P{^Blk=	_Avestan}', "");
    Error('\p{Is_Block=--avestan/a/}');
    Error('\P{Is_Block=--avestan/a/}');
    Expect(1, 68415, '\p{Is_Block=avestan}', "");
    Expect(0, 68415, '\p{^Is_Block=avestan}', "");
    Expect(0, 68415, '\P{Is_Block=avestan}', "");
    Expect(1, 68415, '\P{^Is_Block=avestan}', "");
    Expect(0, 68416, '\p{Is_Block=avestan}', "");
    Expect(1, 68416, '\p{^Is_Block=avestan}', "");
    Expect(1, 68416, '\P{Is_Block=avestan}', "");
    Expect(0, 68416, '\P{^Is_Block=avestan}', "");
    Expect(1, 68415, '\p{Is_Block=-avestan}', "");
    Expect(0, 68415, '\p{^Is_Block=-avestan}', "");
    Expect(0, 68415, '\P{Is_Block=-avestan}', "");
    Expect(1, 68415, '\P{^Is_Block=-avestan}', "");
    Expect(0, 68416, '\p{Is_Block=-avestan}', "");
    Expect(1, 68416, '\p{^Is_Block=-avestan}', "");
    Expect(1, 68416, '\P{Is_Block=-avestan}', "");
    Expect(0, 68416, '\P{^Is_Block=-avestan}', "");
    Error('\p{Is_Blk=-Avestan/a/}');
    Error('\P{Is_Blk=-Avestan/a/}');
    Expect(1, 68415, '\p{Is_Blk=avestan}', "");
    Expect(0, 68415, '\p{^Is_Blk=avestan}', "");
    Expect(0, 68415, '\P{Is_Blk=avestan}', "");
    Expect(1, 68415, '\P{^Is_Blk=avestan}', "");
    Expect(0, 68416, '\p{Is_Blk=avestan}', "");
    Expect(1, 68416, '\p{^Is_Blk=avestan}', "");
    Expect(1, 68416, '\P{Is_Blk=avestan}', "");
    Expect(0, 68416, '\P{^Is_Blk=avestan}', "");
    Expect(1, 68415, '\p{Is_Blk:    Avestan}', "");
    Expect(0, 68415, '\p{^Is_Blk:    Avestan}', "");
    Expect(0, 68415, '\P{Is_Blk:    Avestan}', "");
    Expect(1, 68415, '\P{^Is_Blk:    Avestan}', "");
    Expect(0, 68416, '\p{Is_Blk:    Avestan}', "");
    Expect(1, 68416, '\p{^Is_Blk:    Avestan}', "");
    Expect(1, 68416, '\P{Is_Blk:    Avestan}', "");
    Expect(0, 68416, '\P{^Is_Blk:    Avestan}', "");
    Error('\p{Block= -BALINESE:=}');
    Error('\P{Block= -BALINESE:=}');
    Expect(1, 7039, '\p{Block=:\ABalinese\z:}', "");;
    Expect(0, 7040, '\p{Block=:\ABalinese\z:}', "");;
    Expect(1, 7039, '\p{Block:	balinese}', "");
    Expect(0, 7039, '\p{^Block:	balinese}', "");
    Expect(0, 7039, '\P{Block:	balinese}', "");
    Expect(1, 7039, '\P{^Block:	balinese}', "");
    Expect(0, 7040, '\p{Block:	balinese}', "");
    Expect(1, 7040, '\p{^Block:	balinese}', "");
    Expect(1, 7040, '\P{Block:	balinese}', "");
    Expect(0, 7040, '\P{^Block:	balinese}', "");
    Expect(1, 7039, '\p{Block=:\Abalinese\z:}', "");;
    Expect(0, 7040, '\p{Block=:\Abalinese\z:}', "");;
    Expect(1, 7039, '\p{Block=_ Balinese}', "");
    Expect(0, 7039, '\p{^Block=_ Balinese}', "");
    Expect(0, 7039, '\P{Block=_ Balinese}', "");
    Expect(1, 7039, '\P{^Block=_ Balinese}', "");
    Expect(0, 7040, '\p{Block=_ Balinese}', "");
    Expect(1, 7040, '\p{^Block=_ Balinese}', "");
    Expect(1, 7040, '\P{Block=_ Balinese}', "");
    Expect(0, 7040, '\P{^Block=_ Balinese}', "");
    Error('\p{Blk::=_BALINESE}');
    Error('\P{Blk::=_BALINESE}');
    Expect(1, 7039, '\p{Blk=:\ABalinese\z:}', "");;
    Expect(0, 7040, '\p{Blk=:\ABalinese\z:}', "");;
    Expect(1, 7039, '\p{Blk=balinese}', "");
    Expect(0, 7039, '\p{^Blk=balinese}', "");
    Expect(0, 7039, '\P{Blk=balinese}', "");
    Expect(1, 7039, '\P{^Blk=balinese}', "");
    Expect(0, 7040, '\p{Blk=balinese}', "");
    Expect(1, 7040, '\p{^Blk=balinese}', "");
    Expect(1, 7040, '\P{Blk=balinese}', "");
    Expect(0, 7040, '\P{^Blk=balinese}', "");
    Expect(1, 7039, '\p{Blk=:\Abalinese\z:}', "");;
    Expect(0, 7040, '\p{Blk=:\Abalinese\z:}', "");;
    Expect(1, 7039, '\p{Blk:_balinese}', "");
    Expect(0, 7039, '\p{^Blk:_balinese}', "");
    Expect(0, 7039, '\P{Blk:_balinese}', "");
    Expect(1, 7039, '\P{^Blk:_balinese}', "");
    Expect(0, 7040, '\p{Blk:_balinese}', "");
    Expect(1, 7040, '\p{^Blk:_balinese}', "");
    Expect(1, 7040, '\P{Blk:_balinese}', "");
    Expect(0, 7040, '\P{^Blk:_balinese}', "");
    Error('\p{Is_Block=_	Balinese:=}');
    Error('\P{Is_Block=_	Balinese:=}');
    Expect(1, 7039, '\p{Is_Block=balinese}', "");
    Expect(0, 7039, '\p{^Is_Block=balinese}', "");
    Expect(0, 7039, '\P{Is_Block=balinese}', "");
    Expect(1, 7039, '\P{^Is_Block=balinese}', "");
    Expect(0, 7040, '\p{Is_Block=balinese}', "");
    Expect(1, 7040, '\p{^Is_Block=balinese}', "");
    Expect(1, 7040, '\P{Is_Block=balinese}', "");
    Expect(0, 7040, '\P{^Is_Block=balinese}', "");
    Expect(1, 7039, '\p{Is_Block=_balinese}', "");
    Expect(0, 7039, '\p{^Is_Block=_balinese}', "");
    Expect(0, 7039, '\P{Is_Block=_balinese}', "");
    Expect(1, 7039, '\P{^Is_Block=_balinese}', "");
    Expect(0, 7040, '\p{Is_Block=_balinese}', "");
    Expect(1, 7040, '\p{^Is_Block=_balinese}', "");
    Expect(1, 7040, '\P{Is_Block=_balinese}', "");
    Expect(0, 7040, '\P{^Is_Block=_balinese}', "");
    Error('\p{Is_Blk::=-	Balinese}');
    Error('\P{Is_Blk::=-	Balinese}');
    Expect(1, 7039, '\p{Is_Blk=balinese}', "");
    Expect(0, 7039, '\p{^Is_Blk=balinese}', "");
    Expect(0, 7039, '\P{Is_Blk=balinese}', "");
    Expect(1, 7039, '\P{^Is_Blk=balinese}', "");
    Expect(0, 7040, '\p{Is_Blk=balinese}', "");
    Expect(1, 7040, '\p{^Is_Blk=balinese}', "");
    Expect(1, 7040, '\P{Is_Blk=balinese}', "");
    Expect(0, 7040, '\P{^Is_Blk=balinese}', "");
    Expect(1, 7039, '\p{Is_Blk=- Balinese}', "");
    Expect(0, 7039, '\p{^Is_Blk=- Balinese}', "");
    Expect(0, 7039, '\P{Is_Blk=- Balinese}', "");
    Expect(1, 7039, '\P{^Is_Blk=- Balinese}', "");
    Expect(0, 7040, '\p{Is_Blk=- Balinese}', "");
    Expect(1, 7040, '\p{^Is_Blk=- Balinese}', "");
    Expect(1, 7040, '\P{Is_Blk=- Balinese}', "");
    Expect(0, 7040, '\P{^Is_Blk=- Balinese}', "");
    Error('\p{Block=/a/	_Bamum}');
    Error('\P{Block=/a/	_Bamum}');
    Expect(1, 42751, '\p{Block=:\ABamum\z:}', "");;
    Expect(0, 42752, '\p{Block=:\ABamum\z:}', "");;
    Expect(1, 42751, '\p{Block=bamum}', "");
    Expect(0, 42751, '\p{^Block=bamum}', "");
    Expect(0, 42751, '\P{Block=bamum}', "");
    Expect(1, 42751, '\P{^Block=bamum}', "");
    Expect(0, 42752, '\p{Block=bamum}', "");
    Expect(1, 42752, '\p{^Block=bamum}', "");
    Expect(1, 42752, '\P{Block=bamum}', "");
    Expect(0, 42752, '\P{^Block=bamum}', "");
    Expect(1, 42751, '\p{Block=:\Abamum\z:}', "");;
    Expect(0, 42752, '\p{Block=:\Abamum\z:}', "");;
    Expect(1, 42751, '\p{Block=__BAMUM}', "");
    Expect(0, 42751, '\p{^Block=__BAMUM}', "");
    Expect(0, 42751, '\P{Block=__BAMUM}', "");
    Expect(1, 42751, '\P{^Block=__BAMUM}', "");
    Expect(0, 42752, '\p{Block=__BAMUM}', "");
    Expect(1, 42752, '\p{^Block=__BAMUM}', "");
    Expect(1, 42752, '\P{Block=__BAMUM}', "");
    Expect(0, 42752, '\P{^Block=__BAMUM}', "");
    Error('\p{Blk=		bamum:=}');
    Error('\P{Blk=		bamum:=}');
    Expect(1, 42751, '\p{Blk=:\ABamum\z:}', "");;
    Expect(0, 42752, '\p{Blk=:\ABamum\z:}', "");;
    Expect(1, 42751, '\p{Blk=bamum}', "");
    Expect(0, 42751, '\p{^Blk=bamum}', "");
    Expect(0, 42751, '\P{Blk=bamum}', "");
    Expect(1, 42751, '\P{^Blk=bamum}', "");
    Expect(0, 42752, '\p{Blk=bamum}', "");
    Expect(1, 42752, '\p{^Blk=bamum}', "");
    Expect(1, 42752, '\P{Blk=bamum}', "");
    Expect(0, 42752, '\P{^Blk=bamum}', "");
    Expect(1, 42751, '\p{Blk=:\Abamum\z:}', "");;
    Expect(0, 42752, '\p{Blk=:\Abamum\z:}', "");;
    Expect(1, 42751, '\p{Blk=	 Bamum}', "");
    Expect(0, 42751, '\p{^Blk=	 Bamum}', "");
    Expect(0, 42751, '\P{Blk=	 Bamum}', "");
    Expect(1, 42751, '\P{^Blk=	 Bamum}', "");
    Expect(0, 42752, '\p{Blk=	 Bamum}', "");
    Expect(1, 42752, '\p{^Blk=	 Bamum}', "");
    Expect(1, 42752, '\P{Blk=	 Bamum}', "");
    Expect(0, 42752, '\P{^Blk=	 Bamum}', "");
    Error('\p{Is_Block=/a/	 Bamum}');
    Error('\P{Is_Block=/a/	 Bamum}');
    Expect(1, 42751, '\p{Is_Block=bamum}', "");
    Expect(0, 42751, '\p{^Is_Block=bamum}', "");
    Expect(0, 42751, '\P{Is_Block=bamum}', "");
    Expect(1, 42751, '\P{^Is_Block=bamum}', "");
    Expect(0, 42752, '\p{Is_Block=bamum}', "");
    Expect(1, 42752, '\p{^Is_Block=bamum}', "");
    Expect(1, 42752, '\P{Is_Block=bamum}', "");
    Expect(0, 42752, '\P{^Is_Block=bamum}', "");
    Expect(1, 42751, '\p{Is_Block=__Bamum}', "");
    Expect(0, 42751, '\p{^Is_Block=__Bamum}', "");
    Expect(0, 42751, '\P{Is_Block=__Bamum}', "");
    Expect(1, 42751, '\P{^Is_Block=__Bamum}', "");
    Expect(0, 42752, '\p{Is_Block=__Bamum}', "");
    Expect(1, 42752, '\p{^Is_Block=__Bamum}', "");
    Expect(1, 42752, '\P{Is_Block=__Bamum}', "");
    Expect(0, 42752, '\P{^Is_Block=__Bamum}', "");
    Error('\p{Is_Blk=/a/-Bamum}');
    Error('\P{Is_Blk=/a/-Bamum}');
    Expect(1, 42751, '\p{Is_Blk=bamum}', "");
    Expect(0, 42751, '\p{^Is_Blk=bamum}', "");
    Expect(0, 42751, '\P{Is_Blk=bamum}', "");
    Expect(1, 42751, '\P{^Is_Blk=bamum}', "");
    Expect(0, 42752, '\p{Is_Blk=bamum}', "");
    Expect(1, 42752, '\p{^Is_Blk=bamum}', "");
    Expect(1, 42752, '\P{Is_Blk=bamum}', "");
    Expect(0, 42752, '\P{^Is_Blk=bamum}', "");
    Expect(1, 42751, '\p{Is_Blk=		BAMUM}', "");
    Expect(0, 42751, '\p{^Is_Blk=		BAMUM}', "");
    Expect(0, 42751, '\P{Is_Blk=		BAMUM}', "");
    Expect(1, 42751, '\P{^Is_Blk=		BAMUM}', "");
    Expect(0, 42752, '\p{Is_Blk=		BAMUM}', "");
    Expect(1, 42752, '\p{^Is_Blk=		BAMUM}', "");
    Expect(1, 42752, '\P{Is_Blk=		BAMUM}', "");
    Expect(0, 42752, '\P{^Is_Blk=		BAMUM}', "");
    Error('\p{Block= 	Bamum_Supplement:=}');
    Error('\P{Block= 	Bamum_Supplement:=}');
    Expect(1, 92735, '\p{Block=:\ABamum_Supplement\z:}', "");;
    Expect(0, 92736, '\p{Block=:\ABamum_Supplement\z:}', "");;
    Expect(1, 92735, '\p{Block=bamumsupplement}', "");
    Expect(0, 92735, '\p{^Block=bamumsupplement}', "");
    Expect(0, 92735, '\P{Block=bamumsupplement}', "");
    Expect(1, 92735, '\P{^Block=bamumsupplement}', "");
    Expect(0, 92736, '\p{Block=bamumsupplement}', "");
    Expect(1, 92736, '\p{^Block=bamumsupplement}', "");
    Expect(1, 92736, '\P{Block=bamumsupplement}', "");
    Expect(0, 92736, '\P{^Block=bamumsupplement}', "");
    Expect(1, 92735, '\p{Block=:\Abamumsupplement\z:}', "");;
    Expect(0, 92736, '\p{Block=:\Abamumsupplement\z:}', "");;
    Expect(1, 92735, '\p{Block=--Bamum_Supplement}', "");
    Expect(0, 92735, '\p{^Block=--Bamum_Supplement}', "");
    Expect(0, 92735, '\P{Block=--Bamum_Supplement}', "");
    Expect(1, 92735, '\P{^Block=--Bamum_Supplement}', "");
    Expect(0, 92736, '\p{Block=--Bamum_Supplement}', "");
    Expect(1, 92736, '\p{^Block=--Bamum_Supplement}', "");
    Expect(1, 92736, '\P{Block=--Bamum_Supplement}', "");
    Expect(0, 92736, '\P{^Block=--Bamum_Supplement}', "");
    Error('\p{Blk=:=_bamum_SUP}');
    Error('\P{Blk=:=_bamum_SUP}');
    Expect(1, 92735, '\p{Blk=:\ABamum_Sup\z:}', "");;
    Expect(0, 92736, '\p{Blk=:\ABamum_Sup\z:}', "");;
    Expect(1, 92735, '\p{Blk=bamumsup}', "");
    Expect(0, 92735, '\p{^Blk=bamumsup}', "");
    Expect(0, 92735, '\P{Blk=bamumsup}', "");
    Expect(1, 92735, '\P{^Blk=bamumsup}', "");
    Expect(0, 92736, '\p{Blk=bamumsup}', "");
    Expect(1, 92736, '\p{^Blk=bamumsup}', "");
    Expect(1, 92736, '\P{Blk=bamumsup}', "");
    Expect(0, 92736, '\P{^Blk=bamumsup}', "");
    Expect(1, 92735, '\p{Blk=:\Abamumsup\z:}', "");;
    Expect(0, 92736, '\p{Blk=:\Abamumsup\z:}', "");;
    Expect(1, 92735, '\p{Blk=-Bamum_Sup}', "");
    Expect(0, 92735, '\p{^Blk=-Bamum_Sup}', "");
    Expect(0, 92735, '\P{Blk=-Bamum_Sup}', "");
    Expect(1, 92735, '\P{^Blk=-Bamum_Sup}', "");
    Expect(0, 92736, '\p{Blk=-Bamum_Sup}', "");
    Expect(1, 92736, '\p{^Blk=-Bamum_Sup}', "");
    Expect(1, 92736, '\P{Blk=-Bamum_Sup}', "");
    Expect(0, 92736, '\P{^Blk=-Bamum_Sup}', "");
    Error('\p{Is_Block=_:=Bamum_SUPPLEMENT}');
    Error('\P{Is_Block=_:=Bamum_SUPPLEMENT}');
    Expect(1, 92735, '\p{Is_Block=bamumsupplement}', "");
    Expect(0, 92735, '\p{^Is_Block=bamumsupplement}', "");
    Expect(0, 92735, '\P{Is_Block=bamumsupplement}', "");
    Expect(1, 92735, '\P{^Is_Block=bamumsupplement}', "");
    Expect(0, 92736, '\p{Is_Block=bamumsupplement}', "");
    Expect(1, 92736, '\p{^Is_Block=bamumsupplement}', "");
    Expect(1, 92736, '\P{Is_Block=bamumsupplement}', "");
    Expect(0, 92736, '\P{^Is_Block=bamumsupplement}', "");
    Expect(1, 92735, '\p{Is_Block=	_Bamum_SUPPLEMENT}', "");
    Expect(0, 92735, '\p{^Is_Block=	_Bamum_SUPPLEMENT}', "");
    Expect(0, 92735, '\P{Is_Block=	_Bamum_SUPPLEMENT}', "");
    Expect(1, 92735, '\P{^Is_Block=	_Bamum_SUPPLEMENT}', "");
    Expect(0, 92736, '\p{Is_Block=	_Bamum_SUPPLEMENT}', "");
    Expect(1, 92736, '\p{^Is_Block=	_Bamum_SUPPLEMENT}', "");
    Expect(1, 92736, '\P{Is_Block=	_Bamum_SUPPLEMENT}', "");
    Expect(0, 92736, '\P{^Is_Block=	_Bamum_SUPPLEMENT}', "");
    Error('\p{Is_Blk=-/a/Bamum_Sup}');
    Error('\P{Is_Blk=-/a/Bamum_Sup}');
    Expect(1, 92735, '\p{Is_Blk:bamumsup}', "");
    Expect(0, 92735, '\p{^Is_Blk:bamumsup}', "");
    Expect(0, 92735, '\P{Is_Blk:bamumsup}', "");
    Expect(1, 92735, '\P{^Is_Blk:bamumsup}', "");
    Expect(0, 92736, '\p{Is_Blk:bamumsup}', "");
    Expect(1, 92736, '\p{^Is_Blk:bamumsup}', "");
    Expect(1, 92736, '\P{Is_Blk:bamumsup}', "");
    Expect(0, 92736, '\P{^Is_Blk:bamumsup}', "");
    Expect(1, 92735, '\p{Is_Blk= Bamum_Sup}', "");
    Expect(0, 92735, '\p{^Is_Blk= Bamum_Sup}', "");
    Expect(0, 92735, '\P{Is_Blk= Bamum_Sup}', "");
    Expect(1, 92735, '\P{^Is_Blk= Bamum_Sup}', "");
    Expect(0, 92736, '\p{Is_Blk= Bamum_Sup}', "");
    Expect(1, 92736, '\p{^Is_Blk= Bamum_Sup}', "");
    Expect(1, 92736, '\P{Is_Blk= Bamum_Sup}', "");
    Expect(0, 92736, '\P{^Is_Blk= Bamum_Sup}', "");
    Error('\p{Block=-/a/bassa_Vah}');
    Error('\P{Block=-/a/bassa_Vah}');
    Expect(1, 92927, '\p{Block=:\ABassa_Vah\z:}', "");;
    Expect(0, 92928, '\p{Block=:\ABassa_Vah\z:}', "");;
    Expect(1, 92927, '\p{Block:   bassavah}', "");
    Expect(0, 92927, '\p{^Block:   bassavah}', "");
    Expect(0, 92927, '\P{Block:   bassavah}', "");
    Expect(1, 92927, '\P{^Block:   bassavah}', "");
    Expect(0, 92928, '\p{Block:   bassavah}', "");
    Expect(1, 92928, '\p{^Block:   bassavah}', "");
    Expect(1, 92928, '\P{Block:   bassavah}', "");
    Expect(0, 92928, '\P{^Block:   bassavah}', "");
    Expect(1, 92927, '\p{Block=:\Abassavah\z:}', "");;
    Expect(0, 92928, '\p{Block=:\Abassavah\z:}', "");;
    Expect(1, 92927, '\p{Block=-_BASSA_Vah}', "");
    Expect(0, 92927, '\p{^Block=-_BASSA_Vah}', "");
    Expect(0, 92927, '\P{Block=-_BASSA_Vah}', "");
    Expect(1, 92927, '\P{^Block=-_BASSA_Vah}', "");
    Expect(0, 92928, '\p{Block=-_BASSA_Vah}', "");
    Expect(1, 92928, '\p{^Block=-_BASSA_Vah}', "");
    Expect(1, 92928, '\P{Block=-_BASSA_Vah}', "");
    Expect(0, 92928, '\P{^Block=-_BASSA_Vah}', "");
    Error('\p{Blk=-/a/Bassa_vah}');
    Error('\P{Blk=-/a/Bassa_vah}');
    Expect(1, 92927, '\p{Blk=:\ABassa_Vah\z:}', "");;
    Expect(0, 92928, '\p{Blk=:\ABassa_Vah\z:}', "");;
    Expect(1, 92927, '\p{Blk=bassavah}', "");
    Expect(0, 92927, '\p{^Blk=bassavah}', "");
    Expect(0, 92927, '\P{Blk=bassavah}', "");
    Expect(1, 92927, '\P{^Blk=bassavah}', "");
    Expect(0, 92928, '\p{Blk=bassavah}', "");
    Expect(1, 92928, '\p{^Blk=bassavah}', "");
    Expect(1, 92928, '\P{Blk=bassavah}', "");
    Expect(0, 92928, '\P{^Blk=bassavah}', "");
    Expect(1, 92927, '\p{Blk=:\Abassavah\z:}', "");;
    Expect(0, 92928, '\p{Blk=:\Abassavah\z:}', "");;
    Expect(1, 92927, '\p{Blk:	_BASSA_VAH}', "");
    Expect(0, 92927, '\p{^Blk:	_BASSA_VAH}', "");
    Expect(0, 92927, '\P{Blk:	_BASSA_VAH}', "");
    Expect(1, 92927, '\P{^Blk:	_BASSA_VAH}', "");
    Expect(0, 92928, '\p{Blk:	_BASSA_VAH}', "");
    Expect(1, 92928, '\p{^Blk:	_BASSA_VAH}', "");
    Expect(1, 92928, '\P{Blk:	_BASSA_VAH}', "");
    Expect(0, 92928, '\P{^Blk:	_BASSA_VAH}', "");
    Error('\p{Is_Block=	bassa_Vah/a/}');
    Error('\P{Is_Block=	bassa_Vah/a/}');
    Expect(1, 92927, '\p{Is_Block:bassavah}', "");
    Expect(0, 92927, '\p{^Is_Block:bassavah}', "");
    Expect(0, 92927, '\P{Is_Block:bassavah}', "");
    Expect(1, 92927, '\P{^Is_Block:bassavah}', "");
    Expect(0, 92928, '\p{Is_Block:bassavah}', "");
    Expect(1, 92928, '\p{^Is_Block:bassavah}', "");
    Expect(1, 92928, '\P{Is_Block:bassavah}', "");
    Expect(0, 92928, '\P{^Is_Block:bassavah}', "");
    Expect(1, 92927, '\p{Is_Block=_-Bassa_Vah}', "");
    Expect(0, 92927, '\p{^Is_Block=_-Bassa_Vah}', "");
    Expect(0, 92927, '\P{Is_Block=_-Bassa_Vah}', "");
    Expect(1, 92927, '\P{^Is_Block=_-Bassa_Vah}', "");
    Expect(0, 92928, '\p{Is_Block=_-Bassa_Vah}', "");
    Expect(1, 92928, '\p{^Is_Block=_-Bassa_Vah}', "");
    Expect(1, 92928, '\P{Is_Block=_-Bassa_Vah}', "");
    Expect(0, 92928, '\P{^Is_Block=_-Bassa_Vah}', "");
    Error('\p{Is_Blk=-:=bassa_Vah}');
    Error('\P{Is_Blk=-:=bassa_Vah}');
    Expect(1, 92927, '\p{Is_Blk=bassavah}', "");
    Expect(0, 92927, '\p{^Is_Blk=bassavah}', "");
    Expect(0, 92927, '\P{Is_Blk=bassavah}', "");
    Expect(1, 92927, '\P{^Is_Blk=bassavah}', "");
    Expect(0, 92928, '\p{Is_Blk=bassavah}', "");
    Expect(1, 92928, '\p{^Is_Blk=bassavah}', "");
    Expect(1, 92928, '\P{Is_Blk=bassavah}', "");
    Expect(0, 92928, '\P{^Is_Blk=bassavah}', "");
    Expect(1, 92927, '\p{Is_Blk:   -BASSA_Vah}', "");
    Expect(0, 92927, '\p{^Is_Blk:   -BASSA_Vah}', "");
    Expect(0, 92927, '\P{Is_Blk:   -BASSA_Vah}', "");
    Expect(1, 92927, '\P{^Is_Blk:   -BASSA_Vah}', "");
    Expect(0, 92928, '\p{Is_Blk:   -BASSA_Vah}', "");
    Expect(1, 92928, '\p{^Is_Blk:   -BASSA_Vah}', "");
    Expect(1, 92928, '\P{Is_Blk:   -BASSA_Vah}', "");
    Expect(0, 92928, '\P{^Is_Blk:   -BASSA_Vah}', "");
    Error('\p{Block:-batak:=}');
    Error('\P{Block:-batak:=}');
    Expect(1, 7167, '\p{Block=:\ABatak\z:}', "");;
    Expect(0, 7168, '\p{Block=:\ABatak\z:}', "");;
    Expect(1, 7167, '\p{Block=batak}', "");
    Expect(0, 7167, '\p{^Block=batak}', "");
    Expect(0, 7167, '\P{Block=batak}', "");
    Expect(1, 7167, '\P{^Block=batak}', "");
    Expect(0, 7168, '\p{Block=batak}', "");
    Expect(1, 7168, '\p{^Block=batak}', "");
    Expect(1, 7168, '\P{Block=batak}', "");
    Expect(0, 7168, '\P{^Block=batak}', "");
    Expect(1, 7167, '\p{Block=:\Abatak\z:}', "");;
    Expect(0, 7168, '\p{Block=:\Abatak\z:}', "");;
    Expect(1, 7167, '\p{Block=--batak}', "");
    Expect(0, 7167, '\p{^Block=--batak}', "");
    Expect(0, 7167, '\P{Block=--batak}', "");
    Expect(1, 7167, '\P{^Block=--batak}', "");
    Expect(0, 7168, '\p{Block=--batak}', "");
    Expect(1, 7168, '\p{^Block=--batak}', "");
    Expect(1, 7168, '\P{Block=--batak}', "");
    Expect(0, 7168, '\P{^Block=--batak}', "");
    Error('\p{Blk=	 Batak/a/}');
    Error('\P{Blk=	 Batak/a/}');
    Expect(1, 7167, '\p{Blk=:\ABatak\z:}', "");;
    Expect(0, 7168, '\p{Blk=:\ABatak\z:}', "");;
    Expect(1, 7167, '\p{Blk=batak}', "");
    Expect(0, 7167, '\p{^Blk=batak}', "");
    Expect(0, 7167, '\P{Blk=batak}', "");
    Expect(1, 7167, '\P{^Blk=batak}', "");
    Expect(0, 7168, '\p{Blk=batak}', "");
    Expect(1, 7168, '\p{^Blk=batak}', "");
    Expect(1, 7168, '\P{Blk=batak}', "");
    Expect(0, 7168, '\P{^Blk=batak}', "");
    Expect(1, 7167, '\p{Blk=:\Abatak\z:}', "");;
    Expect(0, 7168, '\p{Blk=:\Abatak\z:}', "");;
    Expect(1, 7167, '\p{Blk= Batak}', "");
    Expect(0, 7167, '\p{^Blk= Batak}', "");
    Expect(0, 7167, '\P{Blk= Batak}', "");
    Expect(1, 7167, '\P{^Blk= Batak}', "");
    Expect(0, 7168, '\p{Blk= Batak}', "");
    Expect(1, 7168, '\p{^Blk= Batak}', "");
    Expect(1, 7168, '\P{Blk= Batak}', "");
    Expect(0, 7168, '\P{^Blk= Batak}', "");
    Error('\p{Is_Block=-:=batak}');
    Error('\P{Is_Block=-:=batak}');
    Expect(1, 7167, '\p{Is_Block=batak}', "");
    Expect(0, 7167, '\p{^Is_Block=batak}', "");
    Expect(0, 7167, '\P{Is_Block=batak}', "");
    Expect(1, 7167, '\P{^Is_Block=batak}', "");
    Expect(0, 7168, '\p{Is_Block=batak}', "");
    Expect(1, 7168, '\p{^Is_Block=batak}', "");
    Expect(1, 7168, '\P{Is_Block=batak}', "");
    Expect(0, 7168, '\P{^Is_Block=batak}', "");
    Expect(1, 7167, '\p{Is_Block=	-Batak}', "");
    Expect(0, 7167, '\p{^Is_Block=	-Batak}', "");
    Expect(0, 7167, '\P{Is_Block=	-Batak}', "");
    Expect(1, 7167, '\P{^Is_Block=	-Batak}', "");
    Expect(0, 7168, '\p{Is_Block=	-Batak}', "");
    Expect(1, 7168, '\p{^Is_Block=	-Batak}', "");
    Expect(1, 7168, '\P{Is_Block=	-Batak}', "");
    Expect(0, 7168, '\P{^Is_Block=	-Batak}', "");
    Error('\p{Is_Blk=	/a/Batak}');
    Error('\P{Is_Blk=	/a/Batak}');
    Expect(1, 7167, '\p{Is_Blk=batak}', "");
    Expect(0, 7167, '\p{^Is_Blk=batak}', "");
    Expect(0, 7167, '\P{Is_Blk=batak}', "");
    Expect(1, 7167, '\P{^Is_Blk=batak}', "");
    Expect(0, 7168, '\p{Is_Blk=batak}', "");
    Expect(1, 7168, '\p{^Is_Blk=batak}', "");
    Expect(1, 7168, '\P{Is_Blk=batak}', "");
    Expect(0, 7168, '\P{^Is_Blk=batak}', "");
    Expect(1, 7167, '\p{Is_Blk=	 Batak}', "");
    Expect(0, 7167, '\p{^Is_Blk=	 Batak}', "");
    Expect(0, 7167, '\P{Is_Blk=	 Batak}', "");
    Expect(1, 7167, '\P{^Is_Blk=	 Batak}', "");
    Expect(0, 7168, '\p{Is_Blk=	 Batak}', "");
    Expect(1, 7168, '\p{^Is_Blk=	 Batak}', "");
    Expect(1, 7168, '\P{Is_Blk=	 Batak}', "");
    Expect(0, 7168, '\P{^Is_Blk=	 Batak}', "");
    Error('\p{Block=:= BENGALI}');
    Error('\P{Block=:= BENGALI}');
    Expect(1, 2559, '\p{Block=:\ABengali\z:}', "");;
    Expect(0, 2560, '\p{Block=:\ABengali\z:}', "");;
    Expect(1, 2559, '\p{Block:   bengali}', "");
    Expect(0, 2559, '\p{^Block:   bengali}', "");
    Expect(0, 2559, '\P{Block:   bengali}', "");
    Expect(1, 2559, '\P{^Block:   bengali}', "");
    Expect(0, 2560, '\p{Block:   bengali}', "");
    Expect(1, 2560, '\p{^Block:   bengali}', "");
    Expect(1, 2560, '\P{Block:   bengali}', "");
    Expect(0, 2560, '\P{^Block:   bengali}', "");
    Expect(1, 2559, '\p{Block=:\Abengali\z:}', "");;
    Expect(0, 2560, '\p{Block=:\Abengali\z:}', "");;
    Expect(1, 2559, '\p{Block=-bengali}', "");
    Expect(0, 2559, '\p{^Block=-bengali}', "");
    Expect(0, 2559, '\P{Block=-bengali}', "");
    Expect(1, 2559, '\P{^Block=-bengali}', "");
    Expect(0, 2560, '\p{Block=-bengali}', "");
    Expect(1, 2560, '\p{^Block=-bengali}', "");
    Expect(1, 2560, '\P{Block=-bengali}', "");
    Expect(0, 2560, '\P{^Block=-bengali}', "");
    Error('\p{Blk=:=Bengali}');
    Error('\P{Blk=:=Bengali}');
    Expect(1, 2559, '\p{Blk=:\ABengali\z:}', "");;
    Expect(0, 2560, '\p{Blk=:\ABengali\z:}', "");;
    Expect(1, 2559, '\p{Blk=bengali}', "");
    Expect(0, 2559, '\p{^Blk=bengali}', "");
    Expect(0, 2559, '\P{Blk=bengali}', "");
    Expect(1, 2559, '\P{^Blk=bengali}', "");
    Expect(0, 2560, '\p{Blk=bengali}', "");
    Expect(1, 2560, '\p{^Blk=bengali}', "");
    Expect(1, 2560, '\P{Blk=bengali}', "");
    Expect(0, 2560, '\P{^Blk=bengali}', "");
    Expect(1, 2559, '\p{Blk=:\Abengali\z:}', "");;
    Expect(0, 2560, '\p{Blk=:\Abengali\z:}', "");;
    Expect(1, 2559, '\p{Blk= 	BENGALI}', "");
    Expect(0, 2559, '\p{^Blk= 	BENGALI}', "");
    Expect(0, 2559, '\P{Blk= 	BENGALI}', "");
    Expect(1, 2559, '\P{^Blk= 	BENGALI}', "");
    Expect(0, 2560, '\p{Blk= 	BENGALI}', "");
    Expect(1, 2560, '\p{^Blk= 	BENGALI}', "");
    Expect(1, 2560, '\P{Blk= 	BENGALI}', "");
    Expect(0, 2560, '\P{^Blk= 	BENGALI}', "");
    Error('\p{Is_Block=	:=bengali}');
    Error('\P{Is_Block=	:=bengali}');
    Expect(1, 2559, '\p{Is_Block=bengali}', "");
    Expect(0, 2559, '\p{^Is_Block=bengali}', "");
    Expect(0, 2559, '\P{Is_Block=bengali}', "");
    Expect(1, 2559, '\P{^Is_Block=bengali}', "");
    Expect(0, 2560, '\p{Is_Block=bengali}', "");
    Expect(1, 2560, '\p{^Is_Block=bengali}', "");
    Expect(1, 2560, '\P{Is_Block=bengali}', "");
    Expect(0, 2560, '\P{^Is_Block=bengali}', "");
    Expect(1, 2559, '\p{Is_Block=-bengali}', "");
    Expect(0, 2559, '\p{^Is_Block=-bengali}', "");
    Expect(0, 2559, '\P{Is_Block=-bengali}', "");
    Expect(1, 2559, '\P{^Is_Block=-bengali}', "");
    Expect(0, 2560, '\p{Is_Block=-bengali}', "");
    Expect(1, 2560, '\p{^Is_Block=-bengali}', "");
    Expect(1, 2560, '\P{Is_Block=-bengali}', "");
    Expect(0, 2560, '\P{^Is_Block=-bengali}', "");
    Error('\p{Is_Blk=/a/_BENGALI}');
    Error('\P{Is_Blk=/a/_BENGALI}');
    Expect(1, 2559, '\p{Is_Blk=bengali}', "");
    Expect(0, 2559, '\p{^Is_Blk=bengali}', "");
    Expect(0, 2559, '\P{Is_Blk=bengali}', "");
    Expect(1, 2559, '\P{^Is_Blk=bengali}', "");
    Expect(0, 2560, '\p{Is_Blk=bengali}', "");
    Expect(1, 2560, '\p{^Is_Blk=bengali}', "");
    Expect(1, 2560, '\P{Is_Blk=bengali}', "");
    Expect(0, 2560, '\P{^Is_Blk=bengali}', "");
    Expect(1, 2559, '\p{Is_Blk=- BENGALI}', "");
    Expect(0, 2559, '\p{^Is_Blk=- BENGALI}', "");
    Expect(0, 2559, '\P{Is_Blk=- BENGALI}', "");
    Expect(1, 2559, '\P{^Is_Blk=- BENGALI}', "");
    Expect(0, 2560, '\p{Is_Blk=- BENGALI}', "");
    Expect(1, 2560, '\p{^Is_Blk=- BENGALI}', "");
    Expect(1, 2560, '\P{Is_Blk=- BENGALI}', "");
    Expect(0, 2560, '\P{^Is_Blk=- BENGALI}', "");
    Error('\p{Block=  Bhaiksuki/a/}');
    Error('\P{Block=  Bhaiksuki/a/}');
    Expect(1, 72815, '\p{Block=:\ABhaiksuki\z:}', "");;
    Expect(0, 72816, '\p{Block=:\ABhaiksuki\z:}', "");;
    Expect(1, 72815, '\p{Block=bhaiksuki}', "");
    Expect(0, 72815, '\p{^Block=bhaiksuki}', "");
    Expect(0, 72815, '\P{Block=bhaiksuki}', "");
    Expect(1, 72815, '\P{^Block=bhaiksuki}', "");
    Expect(0, 72816, '\p{Block=bhaiksuki}', "");
    Expect(1, 72816, '\p{^Block=bhaiksuki}', "");
    Expect(1, 72816, '\P{Block=bhaiksuki}', "");
    Expect(0, 72816, '\P{^Block=bhaiksuki}', "");
    Expect(1, 72815, '\p{Block=:\Abhaiksuki\z:}', "");;
    Expect(0, 72816, '\p{Block=:\Abhaiksuki\z:}', "");;
    Expect(1, 72815, '\p{Block=-	Bhaiksuki}', "");
    Expect(0, 72815, '\p{^Block=-	Bhaiksuki}', "");
    Expect(0, 72815, '\P{Block=-	Bhaiksuki}', "");
    Expect(1, 72815, '\P{^Block=-	Bhaiksuki}', "");
    Expect(0, 72816, '\p{Block=-	Bhaiksuki}', "");
    Expect(1, 72816, '\p{^Block=-	Bhaiksuki}', "");
    Expect(1, 72816, '\P{Block=-	Bhaiksuki}', "");
    Expect(0, 72816, '\P{^Block=-	Bhaiksuki}', "");
    Error('\p{Blk= _BHAIKSUKI:=}');
    Error('\P{Blk= _BHAIKSUKI:=}');
    Expect(1, 72815, '\p{Blk=:\ABhaiksuki\z:}', "");;
    Expect(0, 72816, '\p{Blk=:\ABhaiksuki\z:}', "");;
    Expect(1, 72815, '\p{Blk=bhaiksuki}', "");
    Expect(0, 72815, '\p{^Blk=bhaiksuki}', "");
    Expect(0, 72815, '\P{Blk=bhaiksuki}', "");
    Expect(1, 72815, '\P{^Blk=bhaiksuki}', "");
    Expect(0, 72816, '\p{Blk=bhaiksuki}', "");
    Expect(1, 72816, '\p{^Blk=bhaiksuki}', "");
    Expect(1, 72816, '\P{Blk=bhaiksuki}', "");
    Expect(0, 72816, '\P{^Blk=bhaiksuki}', "");
    Expect(1, 72815, '\p{Blk=:\Abhaiksuki\z:}', "");;
    Expect(0, 72816, '\p{Blk=:\Abhaiksuki\z:}', "");;
    Expect(1, 72815, '\p{Blk=-	Bhaiksuki}', "");
    Expect(0, 72815, '\p{^Blk=-	Bhaiksuki}', "");
    Expect(0, 72815, '\P{Blk=-	Bhaiksuki}', "");
    Expect(1, 72815, '\P{^Blk=-	Bhaiksuki}', "");
    Expect(0, 72816, '\p{Blk=-	Bhaiksuki}', "");
    Expect(1, 72816, '\p{^Blk=-	Bhaiksuki}', "");
    Expect(1, 72816, '\P{Blk=-	Bhaiksuki}', "");
    Expect(0, 72816, '\P{^Blk=-	Bhaiksuki}', "");
    Error('\p{Is_Block= 	BHAIKSUKI/a/}');
    Error('\P{Is_Block= 	BHAIKSUKI/a/}');
    Expect(1, 72815, '\p{Is_Block=bhaiksuki}', "");
    Expect(0, 72815, '\p{^Is_Block=bhaiksuki}', "");
    Expect(0, 72815, '\P{Is_Block=bhaiksuki}', "");
    Expect(1, 72815, '\P{^Is_Block=bhaiksuki}', "");
    Expect(0, 72816, '\p{Is_Block=bhaiksuki}', "");
    Expect(1, 72816, '\p{^Is_Block=bhaiksuki}', "");
    Expect(1, 72816, '\P{Is_Block=bhaiksuki}', "");
    Expect(0, 72816, '\P{^Is_Block=bhaiksuki}', "");
    Expect(1, 72815, '\p{Is_Block=	 Bhaiksuki}', "");
    Expect(0, 72815, '\p{^Is_Block=	 Bhaiksuki}', "");
    Expect(0, 72815, '\P{Is_Block=	 Bhaiksuki}', "");
    Expect(1, 72815, '\P{^Is_Block=	 Bhaiksuki}', "");
    Expect(0, 72816, '\p{Is_Block=	 Bhaiksuki}', "");
    Expect(1, 72816, '\p{^Is_Block=	 Bhaiksuki}', "");
    Expect(1, 72816, '\P{Is_Block=	 Bhaiksuki}', "");
    Expect(0, 72816, '\P{^Is_Block=	 Bhaiksuki}', "");
    Error('\p{Is_Blk=	-Bhaiksuki/a/}');
    Error('\P{Is_Blk=	-Bhaiksuki/a/}');
    Expect(1, 72815, '\p{Is_Blk:	bhaiksuki}', "");
    Expect(0, 72815, '\p{^Is_Blk:	bhaiksuki}', "");
    Expect(0, 72815, '\P{Is_Blk:	bhaiksuki}', "");
    Expect(1, 72815, '\P{^Is_Blk:	bhaiksuki}', "");
    Expect(0, 72816, '\p{Is_Blk:	bhaiksuki}', "");
    Expect(1, 72816, '\p{^Is_Blk:	bhaiksuki}', "");
    Expect(1, 72816, '\P{Is_Blk:	bhaiksuki}', "");
    Expect(0, 72816, '\P{^Is_Blk:	bhaiksuki}', "");
    Expect(1, 72815, '\p{Is_Blk=-bhaiksuki}', "");
    Expect(0, 72815, '\p{^Is_Blk=-bhaiksuki}', "");
    Expect(0, 72815, '\P{Is_Blk=-bhaiksuki}', "");
    Expect(1, 72815, '\P{^Is_Blk=-bhaiksuki}', "");
    Expect(0, 72816, '\p{Is_Blk=-bhaiksuki}', "");
    Expect(1, 72816, '\p{^Is_Blk=-bhaiksuki}', "");
    Expect(1, 72816, '\P{Is_Blk=-bhaiksuki}', "");
    Expect(0, 72816, '\P{^Is_Blk=-bhaiksuki}', "");
    Error('\p{Block=-BLOCK_Elements:=}');
    Error('\P{Block=-BLOCK_Elements:=}');
    Expect(1, 9631, '\p{Block=:\ABlock_Elements\z:}', "");;
    Expect(0, 9632, '\p{Block=:\ABlock_Elements\z:}', "");;
    Expect(1, 9631, '\p{Block=blockelements}', "");
    Expect(0, 9631, '\p{^Block=blockelements}', "");
    Expect(0, 9631, '\P{Block=blockelements}', "");
    Expect(1, 9631, '\P{^Block=blockelements}', "");
    Expect(0, 9632, '\p{Block=blockelements}', "");
    Expect(1, 9632, '\p{^Block=blockelements}', "");
    Expect(1, 9632, '\P{Block=blockelements}', "");
    Expect(0, 9632, '\P{^Block=blockelements}', "");
    Expect(1, 9631, '\p{Block=:\Ablockelements\z:}', "");;
    Expect(0, 9632, '\p{Block=:\Ablockelements\z:}', "");;
    Expect(1, 9631, '\p{Block= -Block_elements}', "");
    Expect(0, 9631, '\p{^Block= -Block_elements}', "");
    Expect(0, 9631, '\P{Block= -Block_elements}', "");
    Expect(1, 9631, '\P{^Block= -Block_elements}', "");
    Expect(0, 9632, '\p{Block= -Block_elements}', "");
    Expect(1, 9632, '\p{^Block= -Block_elements}', "");
    Expect(1, 9632, '\P{Block= -Block_elements}', "");
    Expect(0, 9632, '\P{^Block= -Block_elements}', "");
    Error('\p{Blk: 	Block_elements/a/}');
    Error('\P{Blk: 	Block_elements/a/}');
    Expect(1, 9631, '\p{Blk=:\ABlock_Elements\z:}', "");;
    Expect(0, 9632, '\p{Blk=:\ABlock_Elements\z:}', "");;
    Expect(1, 9631, '\p{Blk=blockelements}', "");
    Expect(0, 9631, '\p{^Blk=blockelements}', "");
    Expect(0, 9631, '\P{Blk=blockelements}', "");
    Expect(1, 9631, '\P{^Blk=blockelements}', "");
    Expect(0, 9632, '\p{Blk=blockelements}', "");
    Expect(1, 9632, '\p{^Blk=blockelements}', "");
    Expect(1, 9632, '\P{Blk=blockelements}', "");
    Expect(0, 9632, '\P{^Blk=blockelements}', "");
    Expect(1, 9631, '\p{Blk=:\Ablockelements\z:}', "");;
    Expect(0, 9632, '\p{Blk=:\Ablockelements\z:}', "");;
    Expect(1, 9631, '\p{Blk:	_ Block_ELEMENTS}', "");
    Expect(0, 9631, '\p{^Blk:	_ Block_ELEMENTS}', "");
    Expect(0, 9631, '\P{Blk:	_ Block_ELEMENTS}', "");
    Expect(1, 9631, '\P{^Blk:	_ Block_ELEMENTS}', "");
    Expect(0, 9632, '\p{Blk:	_ Block_ELEMENTS}', "");
    Expect(1, 9632, '\p{^Blk:	_ Block_ELEMENTS}', "");
    Expect(1, 9632, '\P{Blk:	_ Block_ELEMENTS}', "");
    Expect(0, 9632, '\P{^Blk:	_ Block_ELEMENTS}', "");
    Error('\p{Is_Block=_BLOCK_Elements:=}');
    Error('\P{Is_Block=_BLOCK_Elements:=}');
    Expect(1, 9631, '\p{Is_Block=blockelements}', "");
    Expect(0, 9631, '\p{^Is_Block=blockelements}', "");
    Expect(0, 9631, '\P{Is_Block=blockelements}', "");
    Expect(1, 9631, '\P{^Is_Block=blockelements}', "");
    Expect(0, 9632, '\p{Is_Block=blockelements}', "");
    Expect(1, 9632, '\p{^Is_Block=blockelements}', "");
    Expect(1, 9632, '\P{Is_Block=blockelements}', "");
    Expect(0, 9632, '\P{^Is_Block=blockelements}', "");
    Expect(1, 9631, '\p{Is_Block=  Block_Elements}', "");
    Expect(0, 9631, '\p{^Is_Block=  Block_Elements}', "");
    Expect(0, 9631, '\P{Is_Block=  Block_Elements}', "");
    Expect(1, 9631, '\P{^Is_Block=  Block_Elements}', "");
    Expect(0, 9632, '\p{Is_Block=  Block_Elements}', "");
    Expect(1, 9632, '\p{^Is_Block=  Block_Elements}', "");
    Expect(1, 9632, '\P{Is_Block=  Block_Elements}', "");
    Expect(0, 9632, '\P{^Is_Block=  Block_Elements}', "");
    Error('\p{Is_Blk=-BLOCK_ELEMENTS/a/}');
    Error('\P{Is_Blk=-BLOCK_ELEMENTS/a/}');
    Expect(1, 9631, '\p{Is_Blk=blockelements}', "");
    Expect(0, 9631, '\p{^Is_Blk=blockelements}', "");
    Expect(0, 9631, '\P{Is_Blk=blockelements}', "");
    Expect(1, 9631, '\P{^Is_Blk=blockelements}', "");
    Expect(0, 9632, '\p{Is_Blk=blockelements}', "");
    Expect(1, 9632, '\p{^Is_Blk=blockelements}', "");
    Expect(1, 9632, '\P{Is_Blk=blockelements}', "");
    Expect(0, 9632, '\P{^Is_Blk=blockelements}', "");
    Expect(1, 9631, '\p{Is_Blk=	 Block_Elements}', "");
    Expect(0, 9631, '\p{^Is_Blk=	 Block_Elements}', "");
    Expect(0, 9631, '\P{Is_Blk=	 Block_Elements}', "");
    Expect(1, 9631, '\P{^Is_Blk=	 Block_Elements}', "");
    Expect(0, 9632, '\p{Is_Blk=	 Block_Elements}', "");
    Expect(1, 9632, '\p{^Is_Blk=	 Block_Elements}', "");
    Expect(1, 9632, '\P{Is_Blk=	 Block_Elements}', "");
    Expect(0, 9632, '\P{^Is_Blk=	 Block_Elements}', "");
    Error('\p{Block=:= 	Bopomofo}');
    Error('\P{Block=:= 	Bopomofo}');
    Expect(1, 12591, '\p{Block=:\ABopomofo\z:}', "");;
    Expect(0, 12592, '\p{Block=:\ABopomofo\z:}', "");;
    Expect(1, 12591, '\p{Block=bopomofo}', "");
    Expect(0, 12591, '\p{^Block=bopomofo}', "");
    Expect(0, 12591, '\P{Block=bopomofo}', "");
    Expect(1, 12591, '\P{^Block=bopomofo}', "");
    Expect(0, 12592, '\p{Block=bopomofo}', "");
    Expect(1, 12592, '\p{^Block=bopomofo}', "");
    Expect(1, 12592, '\P{Block=bopomofo}', "");
    Expect(0, 12592, '\P{^Block=bopomofo}', "");
    Expect(1, 12591, '\p{Block=:\Abopomofo\z:}', "");;
    Expect(0, 12592, '\p{Block=:\Abopomofo\z:}', "");;
    Expect(1, 12591, '\p{Block=-bopomofo}', "");
    Expect(0, 12591, '\p{^Block=-bopomofo}', "");
    Expect(0, 12591, '\P{Block=-bopomofo}', "");
    Expect(1, 12591, '\P{^Block=-bopomofo}', "");
    Expect(0, 12592, '\p{Block=-bopomofo}', "");
    Expect(1, 12592, '\p{^Block=-bopomofo}', "");
    Expect(1, 12592, '\P{Block=-bopomofo}', "");
    Expect(0, 12592, '\P{^Block=-bopomofo}', "");
    Error('\p{Blk=/a/--bopomofo}');
    Error('\P{Blk=/a/--bopomofo}');
    Expect(1, 12591, '\p{Blk=:\ABopomofo\z:}', "");;
    Expect(0, 12592, '\p{Blk=:\ABopomofo\z:}', "");;
    Expect(1, 12591, '\p{Blk=bopomofo}', "");
    Expect(0, 12591, '\p{^Blk=bopomofo}', "");
    Expect(0, 12591, '\P{Blk=bopomofo}', "");
    Expect(1, 12591, '\P{^Blk=bopomofo}', "");
    Expect(0, 12592, '\p{Blk=bopomofo}', "");
    Expect(1, 12592, '\p{^Blk=bopomofo}', "");
    Expect(1, 12592, '\P{Blk=bopomofo}', "");
    Expect(0, 12592, '\P{^Blk=bopomofo}', "");
    Expect(1, 12591, '\p{Blk=:\Abopomofo\z:}', "");;
    Expect(0, 12592, '\p{Blk=:\Abopomofo\z:}', "");;
    Expect(1, 12591, '\p{Blk=BOPOMOFO}', "");
    Expect(0, 12591, '\p{^Blk=BOPOMOFO}', "");
    Expect(0, 12591, '\P{Blk=BOPOMOFO}', "");
    Expect(1, 12591, '\P{^Blk=BOPOMOFO}', "");
    Expect(0, 12592, '\p{Blk=BOPOMOFO}', "");
    Expect(1, 12592, '\p{^Blk=BOPOMOFO}', "");
    Expect(1, 12592, '\P{Blk=BOPOMOFO}', "");
    Expect(0, 12592, '\P{^Blk=BOPOMOFO}', "");
    Error('\p{Is_Block=__Bopomofo:=}');
    Error('\P{Is_Block=__Bopomofo:=}');
    Expect(1, 12591, '\p{Is_Block=bopomofo}', "");
    Expect(0, 12591, '\p{^Is_Block=bopomofo}', "");
    Expect(0, 12591, '\P{Is_Block=bopomofo}', "");
    Expect(1, 12591, '\P{^Is_Block=bopomofo}', "");
    Expect(0, 12592, '\p{Is_Block=bopomofo}', "");
    Expect(1, 12592, '\p{^Is_Block=bopomofo}', "");
    Expect(1, 12592, '\P{Is_Block=bopomofo}', "");
    Expect(0, 12592, '\P{^Is_Block=bopomofo}', "");
    Expect(1, 12591, '\p{Is_Block=	-Bopomofo}', "");
    Expect(0, 12591, '\p{^Is_Block=	-Bopomofo}', "");
    Expect(0, 12591, '\P{Is_Block=	-Bopomofo}', "");
    Expect(1, 12591, '\P{^Is_Block=	-Bopomofo}', "");
    Expect(0, 12592, '\p{Is_Block=	-Bopomofo}', "");
    Expect(1, 12592, '\p{^Is_Block=	-Bopomofo}', "");
    Expect(1, 12592, '\P{Is_Block=	-Bopomofo}', "");
    Expect(0, 12592, '\P{^Is_Block=	-Bopomofo}', "");
    Error('\p{Is_Blk=/a/ 	Bopomofo}');
    Error('\P{Is_Blk=/a/ 	Bopomofo}');
    Expect(1, 12591, '\p{Is_Blk=bopomofo}', "");
    Expect(0, 12591, '\p{^Is_Blk=bopomofo}', "");
    Expect(0, 12591, '\P{Is_Blk=bopomofo}', "");
    Expect(1, 12591, '\P{^Is_Blk=bopomofo}', "");
    Expect(0, 12592, '\p{Is_Blk=bopomofo}', "");
    Expect(1, 12592, '\p{^Is_Blk=bopomofo}', "");
    Expect(1, 12592, '\P{Is_Blk=bopomofo}', "");
    Expect(0, 12592, '\P{^Is_Blk=bopomofo}', "");
    Expect(1, 12591, '\p{Is_Blk=	Bopomofo}', "");
    Expect(0, 12591, '\p{^Is_Blk=	Bopomofo}', "");
    Expect(0, 12591, '\P{Is_Blk=	Bopomofo}', "");
    Expect(1, 12591, '\P{^Is_Blk=	Bopomofo}', "");
    Expect(0, 12592, '\p{Is_Blk=	Bopomofo}', "");
    Expect(1, 12592, '\p{^Is_Blk=	Bopomofo}', "");
    Expect(1, 12592, '\P{Is_Blk=	Bopomofo}', "");
    Expect(0, 12592, '\P{^Is_Blk=	Bopomofo}', "");
    Error('\p{Block=/a/_Bopomofo_EXTENDED}');
    Error('\P{Block=/a/_Bopomofo_EXTENDED}');
    Expect(1, 12735, '\p{Block=:\ABopomofo_Extended\z:}', "");;
    Expect(0, 12736, '\p{Block=:\ABopomofo_Extended\z:}', "");;
    Expect(1, 12735, '\p{Block=bopomofoextended}', "");
    Expect(0, 12735, '\p{^Block=bopomofoextended}', "");
    Expect(0, 12735, '\P{Block=bopomofoextended}', "");
    Expect(1, 12735, '\P{^Block=bopomofoextended}', "");
    Expect(0, 12736, '\p{Block=bopomofoextended}', "");
    Expect(1, 12736, '\p{^Block=bopomofoextended}', "");
    Expect(1, 12736, '\P{Block=bopomofoextended}', "");
    Expect(0, 12736, '\P{^Block=bopomofoextended}', "");
    Expect(1, 12735, '\p{Block=:\Abopomofoextended\z:}', "");;
    Expect(0, 12736, '\p{Block=:\Abopomofoextended\z:}', "");;
    Expect(1, 12735, '\p{Block= Bopomofo_Extended}', "");
    Expect(0, 12735, '\p{^Block= Bopomofo_Extended}', "");
    Expect(0, 12735, '\P{Block= Bopomofo_Extended}', "");
    Expect(1, 12735, '\P{^Block= Bopomofo_Extended}', "");
    Expect(0, 12736, '\p{Block= Bopomofo_Extended}', "");
    Expect(1, 12736, '\p{^Block= Bopomofo_Extended}', "");
    Expect(1, 12736, '\P{Block= Bopomofo_Extended}', "");
    Expect(0, 12736, '\P{^Block= Bopomofo_Extended}', "");
    Error('\p{Blk=_bopomofo_EXT:=}');
    Error('\P{Blk=_bopomofo_EXT:=}');
    Expect(1, 12735, '\p{Blk=:\ABopomofo_Ext\z:}', "");;
    Expect(0, 12736, '\p{Blk=:\ABopomofo_Ext\z:}', "");;
    Expect(1, 12735, '\p{Blk=bopomofoext}', "");
    Expect(0, 12735, '\p{^Blk=bopomofoext}', "");
    Expect(0, 12735, '\P{Blk=bopomofoext}', "");
    Expect(1, 12735, '\P{^Blk=bopomofoext}', "");
    Expect(0, 12736, '\p{Blk=bopomofoext}', "");
    Expect(1, 12736, '\p{^Blk=bopomofoext}', "");
    Expect(1, 12736, '\P{Blk=bopomofoext}', "");
    Expect(0, 12736, '\P{^Blk=bopomofoext}', "");
    Expect(1, 12735, '\p{Blk=:\Abopomofoext\z:}', "");;
    Expect(0, 12736, '\p{Blk=:\Abopomofoext\z:}', "");;
    Expect(1, 12735, '\p{Blk=-	bopomofo_Ext}', "");
    Expect(0, 12735, '\p{^Blk=-	bopomofo_Ext}', "");
    Expect(0, 12735, '\P{Blk=-	bopomofo_Ext}', "");
    Expect(1, 12735, '\P{^Blk=-	bopomofo_Ext}', "");
    Expect(0, 12736, '\p{Blk=-	bopomofo_Ext}', "");
    Expect(1, 12736, '\p{^Blk=-	bopomofo_Ext}', "");
    Expect(1, 12736, '\P{Blk=-	bopomofo_Ext}', "");
    Expect(0, 12736, '\P{^Blk=-	bopomofo_Ext}', "");
    Error('\p{Is_Block=:= 	Bopomofo_extended}');
    Error('\P{Is_Block=:= 	Bopomofo_extended}');
    Expect(1, 12735, '\p{Is_Block=bopomofoextended}', "");
    Expect(0, 12735, '\p{^Is_Block=bopomofoextended}', "");
    Expect(0, 12735, '\P{Is_Block=bopomofoextended}', "");
    Expect(1, 12735, '\P{^Is_Block=bopomofoextended}', "");
    Expect(0, 12736, '\p{Is_Block=bopomofoextended}', "");
    Expect(1, 12736, '\p{^Is_Block=bopomofoextended}', "");
    Expect(1, 12736, '\P{Is_Block=bopomofoextended}', "");
    Expect(0, 12736, '\P{^Is_Block=bopomofoextended}', "");
    Expect(1, 12735, '\p{Is_Block= bopomofo_Extended}', "");
    Expect(0, 12735, '\p{^Is_Block= bopomofo_Extended}', "");
    Expect(0, 12735, '\P{Is_Block= bopomofo_Extended}', "");
    Expect(1, 12735, '\P{^Is_Block= bopomofo_Extended}', "");
    Expect(0, 12736, '\p{Is_Block= bopomofo_Extended}', "");
    Expect(1, 12736, '\p{^Is_Block= bopomofo_Extended}', "");
    Expect(1, 12736, '\P{Is_Block= bopomofo_Extended}', "");
    Expect(0, 12736, '\P{^Is_Block= bopomofo_Extended}', "");
    Error('\p{Is_Blk=/a/_-Bopomofo_EXT}');
    Error('\P{Is_Blk=/a/_-Bopomofo_EXT}');
    Expect(1, 12735, '\p{Is_Blk=bopomofoext}', "");
    Expect(0, 12735, '\p{^Is_Blk=bopomofoext}', "");
    Expect(0, 12735, '\P{Is_Blk=bopomofoext}', "");
    Expect(1, 12735, '\P{^Is_Blk=bopomofoext}', "");
    Expect(0, 12736, '\p{Is_Blk=bopomofoext}', "");
    Expect(1, 12736, '\p{^Is_Blk=bopomofoext}', "");
    Expect(1, 12736, '\P{Is_Blk=bopomofoext}', "");
    Expect(0, 12736, '\P{^Is_Blk=bopomofoext}', "");
    Expect(1, 12735, '\p{Is_Blk=	Bopomofo_Ext}', "");
    Expect(0, 12735, '\p{^Is_Blk=	Bopomofo_Ext}', "");
    Expect(0, 12735, '\P{Is_Blk=	Bopomofo_Ext}', "");
    Expect(1, 12735, '\P{^Is_Blk=	Bopomofo_Ext}', "");
    Expect(0, 12736, '\p{Is_Blk=	Bopomofo_Ext}', "");
    Expect(1, 12736, '\p{^Is_Blk=	Bopomofo_Ext}', "");
    Expect(1, 12736, '\P{Is_Blk=	Bopomofo_Ext}', "");
    Expect(0, 12736, '\P{^Is_Blk=	Bopomofo_Ext}', "");
    Error('\p{Block= /a/BOX_Drawing}');
    Error('\P{Block= /a/BOX_Drawing}');
    Expect(1, 9599, '\p{Block=:\ABox_Drawing\z:}', "");;
    Expect(0, 9600, '\p{Block=:\ABox_Drawing\z:}', "");;
    Expect(1, 9599, '\p{Block=boxdrawing}', "");
    Expect(0, 9599, '\p{^Block=boxdrawing}', "");
    Expect(0, 9599, '\P{Block=boxdrawing}', "");
    Expect(1, 9599, '\P{^Block=boxdrawing}', "");
    Expect(0, 9600, '\p{Block=boxdrawing}', "");
    Expect(1, 9600, '\p{^Block=boxdrawing}', "");
    Expect(1, 9600, '\P{Block=boxdrawing}', "");
    Expect(0, 9600, '\P{^Block=boxdrawing}', "");
    Expect(1, 9599, '\p{Block=:\Aboxdrawing\z:}', "");;
    Expect(0, 9600, '\p{Block=:\Aboxdrawing\z:}', "");;
    Expect(1, 9599, '\p{Block= 	Box_drawing}', "");
    Expect(0, 9599, '\p{^Block= 	Box_drawing}', "");
    Expect(0, 9599, '\P{Block= 	Box_drawing}', "");
    Expect(1, 9599, '\P{^Block= 	Box_drawing}', "");
    Expect(0, 9600, '\p{Block= 	Box_drawing}', "");
    Expect(1, 9600, '\p{^Block= 	Box_drawing}', "");
    Expect(1, 9600, '\P{Block= 	Box_drawing}', "");
    Expect(0, 9600, '\P{^Block= 	Box_drawing}', "");
    Error('\p{Blk::=	 box_DRAWING}');
    Error('\P{Blk::=	 box_DRAWING}');
    Expect(1, 9599, '\p{Blk=:\ABox_Drawing\z:}', "");;
    Expect(0, 9600, '\p{Blk=:\ABox_Drawing\z:}', "");;
    Expect(1, 9599, '\p{Blk=boxdrawing}', "");
    Expect(0, 9599, '\p{^Blk=boxdrawing}', "");
    Expect(0, 9599, '\P{Blk=boxdrawing}', "");
    Expect(1, 9599, '\P{^Blk=boxdrawing}', "");
    Expect(0, 9600, '\p{Blk=boxdrawing}', "");
    Expect(1, 9600, '\p{^Blk=boxdrawing}', "");
    Expect(1, 9600, '\P{Blk=boxdrawing}', "");
    Expect(0, 9600, '\P{^Blk=boxdrawing}', "");
    Expect(1, 9599, '\p{Blk=:\Aboxdrawing\z:}', "");;
    Expect(0, 9600, '\p{Blk=:\Aboxdrawing\z:}', "");;
    Expect(1, 9599, '\p{Blk=	-box_Drawing}', "");
    Expect(0, 9599, '\p{^Blk=	-box_Drawing}', "");
    Expect(0, 9599, '\P{Blk=	-box_Drawing}', "");
    Expect(1, 9599, '\P{^Blk=	-box_Drawing}', "");
    Expect(0, 9600, '\p{Blk=	-box_Drawing}', "");
    Expect(1, 9600, '\p{^Blk=	-box_Drawing}', "");
    Expect(1, 9600, '\P{Blk=	-box_Drawing}', "");
    Expect(0, 9600, '\P{^Blk=	-box_Drawing}', "");
    Error('\p{Is_Block=/a/	Box_Drawing}');
    Error('\P{Is_Block=/a/	Box_Drawing}');
    Expect(1, 9599, '\p{Is_Block:   boxdrawing}', "");
    Expect(0, 9599, '\p{^Is_Block:   boxdrawing}', "");
    Expect(0, 9599, '\P{Is_Block:   boxdrawing}', "");
    Expect(1, 9599, '\P{^Is_Block:   boxdrawing}', "");
    Expect(0, 9600, '\p{Is_Block:   boxdrawing}', "");
    Expect(1, 9600, '\p{^Is_Block:   boxdrawing}', "");
    Expect(1, 9600, '\P{Is_Block:   boxdrawing}', "");
    Expect(0, 9600, '\P{^Is_Block:   boxdrawing}', "");
    Expect(1, 9599, '\p{Is_Block=	-BOX_DRAWING}', "");
    Expect(0, 9599, '\p{^Is_Block=	-BOX_DRAWING}', "");
    Expect(0, 9599, '\P{Is_Block=	-BOX_DRAWING}', "");
    Expect(1, 9599, '\P{^Is_Block=	-BOX_DRAWING}', "");
    Expect(0, 9600, '\p{Is_Block=	-BOX_DRAWING}', "");
    Expect(1, 9600, '\p{^Is_Block=	-BOX_DRAWING}', "");
    Expect(1, 9600, '\P{Is_Block=	-BOX_DRAWING}', "");
    Expect(0, 9600, '\P{^Is_Block=	-BOX_DRAWING}', "");
    Error('\p{Is_Blk=-:=Box_DRAWING}');
    Error('\P{Is_Blk=-:=Box_DRAWING}');
    Expect(1, 9599, '\p{Is_Blk=boxdrawing}', "");
    Expect(0, 9599, '\p{^Is_Blk=boxdrawing}', "");
    Expect(0, 9599, '\P{Is_Blk=boxdrawing}', "");
    Expect(1, 9599, '\P{^Is_Blk=boxdrawing}', "");
    Expect(0, 9600, '\p{Is_Blk=boxdrawing}', "");
    Expect(1, 9600, '\p{^Is_Blk=boxdrawing}', "");
    Expect(1, 9600, '\P{Is_Blk=boxdrawing}', "");
    Expect(0, 9600, '\P{^Is_Blk=boxdrawing}', "");
    Expect(1, 9599, '\p{Is_Blk: _Box_drawing}', "");
    Expect(0, 9599, '\p{^Is_Blk: _Box_drawing}', "");
    Expect(0, 9599, '\P{Is_Blk: _Box_drawing}', "");
    Expect(1, 9599, '\P{^Is_Blk: _Box_drawing}', "");
    Expect(0, 9600, '\p{Is_Blk: _Box_drawing}', "");
    Expect(1, 9600, '\p{^Is_Blk: _Box_drawing}', "");
    Expect(1, 9600, '\P{Is_Blk: _Box_drawing}', "");
    Expect(0, 9600, '\P{^Is_Blk: _Box_drawing}', "");
    Error('\p{Block= /a/Brahmi}');
    Error('\P{Block= /a/Brahmi}');
    Expect(1, 69759, '\p{Block=:\ABrahmi\z:}', "");;
    Expect(0, 69760, '\p{Block=:\ABrahmi\z:}', "");;
    Expect(1, 69759, '\p{Block=brahmi}', "");
    Expect(0, 69759, '\p{^Block=brahmi}', "");
    Expect(0, 69759, '\P{Block=brahmi}', "");
    Expect(1, 69759, '\P{^Block=brahmi}', "");
    Expect(0, 69760, '\p{Block=brahmi}', "");
    Expect(1, 69760, '\p{^Block=brahmi}', "");
    Expect(1, 69760, '\P{Block=brahmi}', "");
    Expect(0, 69760, '\P{^Block=brahmi}', "");
    Expect(1, 69759, '\p{Block=:\Abrahmi\z:}', "");;
    Expect(0, 69760, '\p{Block=:\Abrahmi\z:}', "");;
    Expect(1, 69759, '\p{Block=-Brahmi}', "");
    Expect(0, 69759, '\p{^Block=-Brahmi}', "");
    Expect(0, 69759, '\P{Block=-Brahmi}', "");
    Expect(1, 69759, '\P{^Block=-Brahmi}', "");
    Expect(0, 69760, '\p{Block=-Brahmi}', "");
    Expect(1, 69760, '\p{^Block=-Brahmi}', "");
    Expect(1, 69760, '\P{Block=-Brahmi}', "");
    Expect(0, 69760, '\P{^Block=-Brahmi}', "");
    Error('\p{Blk=:=		Brahmi}');
    Error('\P{Blk=:=		Brahmi}');
    Expect(1, 69759, '\p{Blk=:\ABrahmi\z:}', "");;
    Expect(0, 69760, '\p{Blk=:\ABrahmi\z:}', "");;
    Expect(1, 69759, '\p{Blk=brahmi}', "");
    Expect(0, 69759, '\p{^Blk=brahmi}', "");
    Expect(0, 69759, '\P{Blk=brahmi}', "");
    Expect(1, 69759, '\P{^Blk=brahmi}', "");
    Expect(0, 69760, '\p{Blk=brahmi}', "");
    Expect(1, 69760, '\p{^Blk=brahmi}', "");
    Expect(1, 69760, '\P{Blk=brahmi}', "");
    Expect(0, 69760, '\P{^Blk=brahmi}', "");
    Expect(1, 69759, '\p{Blk=:\Abrahmi\z:}', "");;
    Expect(0, 69760, '\p{Blk=:\Abrahmi\z:}', "");;
    Expect(1, 69759, '\p{Blk:	- BRAHMI}', "");
    Expect(0, 69759, '\p{^Blk:	- BRAHMI}', "");
    Expect(0, 69759, '\P{Blk:	- BRAHMI}', "");
    Expect(1, 69759, '\P{^Blk:	- BRAHMI}', "");
    Expect(0, 69760, '\p{Blk:	- BRAHMI}', "");
    Expect(1, 69760, '\p{^Blk:	- BRAHMI}', "");
    Expect(1, 69760, '\P{Blk:	- BRAHMI}', "");
    Expect(0, 69760, '\P{^Blk:	- BRAHMI}', "");
    Error('\p{Is_Block=	/a/Brahmi}');
    Error('\P{Is_Block=	/a/Brahmi}');
    Expect(1, 69759, '\p{Is_Block=brahmi}', "");
    Expect(0, 69759, '\p{^Is_Block=brahmi}', "");
    Expect(0, 69759, '\P{Is_Block=brahmi}', "");
    Expect(1, 69759, '\P{^Is_Block=brahmi}', "");
    Expect(0, 69760, '\p{Is_Block=brahmi}', "");
    Expect(1, 69760, '\p{^Is_Block=brahmi}', "");
    Expect(1, 69760, '\P{Is_Block=brahmi}', "");
    Expect(0, 69760, '\P{^Is_Block=brahmi}', "");
    Expect(1, 69759, '\p{Is_Block=Brahmi}', "");
    Expect(0, 69759, '\p{^Is_Block=Brahmi}', "");
    Expect(0, 69759, '\P{Is_Block=Brahmi}', "");
    Expect(1, 69759, '\P{^Is_Block=Brahmi}', "");
    Expect(0, 69760, '\p{Is_Block=Brahmi}', "");
    Expect(1, 69760, '\p{^Is_Block=Brahmi}', "");
    Expect(1, 69760, '\P{Is_Block=Brahmi}', "");
    Expect(0, 69760, '\P{^Is_Block=Brahmi}', "");
    Error('\p{Is_Blk=:=		Brahmi}');
    Error('\P{Is_Blk=:=		Brahmi}');
    Expect(1, 69759, '\p{Is_Blk=brahmi}', "");
    Expect(0, 69759, '\p{^Is_Blk=brahmi}', "");
    Expect(0, 69759, '\P{Is_Blk=brahmi}', "");
    Expect(1, 69759, '\P{^Is_Blk=brahmi}', "");
    Expect(0, 69760, '\p{Is_Blk=brahmi}', "");
    Expect(1, 69760, '\p{^Is_Blk=brahmi}', "");
    Expect(1, 69760, '\P{Is_Blk=brahmi}', "");
    Expect(0, 69760, '\P{^Is_Blk=brahmi}', "");
    Expect(1, 69759, '\p{Is_Blk=	Brahmi}', "");
    Expect(0, 69759, '\p{^Is_Blk=	Brahmi}', "");
    Expect(0, 69759, '\P{Is_Blk=	Brahmi}', "");
    Expect(1, 69759, '\P{^Is_Blk=	Brahmi}', "");
    Expect(0, 69760, '\p{Is_Blk=	Brahmi}', "");
    Expect(1, 69760, '\p{^Is_Blk=	Brahmi}', "");
    Expect(1, 69760, '\P{Is_Blk=	Brahmi}', "");
    Expect(0, 69760, '\P{^Is_Blk=	Brahmi}', "");
    Error('\p{Block=  braille_Patterns:=}');
    Error('\P{Block=  braille_Patterns:=}');
    Expect(1, 10495, '\p{Block=:\ABraille_Patterns\z:}', "");;
    Expect(0, 10496, '\p{Block=:\ABraille_Patterns\z:}', "");;
    Expect(1, 10495, '\p{Block:	braillepatterns}', "");
    Expect(0, 10495, '\p{^Block:	braillepatterns}', "");
    Expect(0, 10495, '\P{Block:	braillepatterns}', "");
    Expect(1, 10495, '\P{^Block:	braillepatterns}', "");
    Expect(0, 10496, '\p{Block:	braillepatterns}', "");
    Expect(1, 10496, '\p{^Block:	braillepatterns}', "");
    Expect(1, 10496, '\P{Block:	braillepatterns}', "");
    Expect(0, 10496, '\P{^Block:	braillepatterns}', "");
    Expect(1, 10495, '\p{Block=:\Abraillepatterns\z:}', "");;
    Expect(0, 10496, '\p{Block=:\Abraillepatterns\z:}', "");;
    Expect(1, 10495, '\p{Block= BRAILLE_patterns}', "");
    Expect(0, 10495, '\p{^Block= BRAILLE_patterns}', "");
    Expect(0, 10495, '\P{Block= BRAILLE_patterns}', "");
    Expect(1, 10495, '\P{^Block= BRAILLE_patterns}', "");
    Expect(0, 10496, '\p{Block= BRAILLE_patterns}', "");
    Expect(1, 10496, '\p{^Block= BRAILLE_patterns}', "");
    Expect(1, 10496, '\P{Block= BRAILLE_patterns}', "");
    Expect(0, 10496, '\P{^Block= BRAILLE_patterns}', "");
    Error('\p{Blk: -	braille:=}');
    Error('\P{Blk: -	braille:=}');
    Expect(1, 10495, '\p{Blk=:\ABraille\z:}', "");;
    Expect(0, 10496, '\p{Blk=:\ABraille\z:}', "");;
    Expect(1, 10495, '\p{Blk=braille}', "");
    Expect(0, 10495, '\p{^Blk=braille}', "");
    Expect(0, 10495, '\P{Blk=braille}', "");
    Expect(1, 10495, '\P{^Blk=braille}', "");
    Expect(0, 10496, '\p{Blk=braille}', "");
    Expect(1, 10496, '\p{^Blk=braille}', "");
    Expect(1, 10496, '\P{Blk=braille}', "");
    Expect(0, 10496, '\P{^Blk=braille}', "");
    Expect(1, 10495, '\p{Blk=:\Abraille\z:}', "");;
    Expect(0, 10496, '\p{Blk=:\Abraille\z:}', "");;
    Expect(1, 10495, '\p{Blk=	 braille}', "");
    Expect(0, 10495, '\p{^Blk=	 braille}', "");
    Expect(0, 10495, '\P{Blk=	 braille}', "");
    Expect(1, 10495, '\P{^Blk=	 braille}', "");
    Expect(0, 10496, '\p{Blk=	 braille}', "");
    Expect(1, 10496, '\p{^Blk=	 braille}', "");
    Expect(1, 10496, '\P{Blk=	 braille}', "");
    Expect(0, 10496, '\P{^Blk=	 braille}', "");
    Error('\p{Is_Block=:=		BRAILLE_Patterns}');
    Error('\P{Is_Block=:=		BRAILLE_Patterns}');
    Expect(1, 10495, '\p{Is_Block=braillepatterns}', "");
    Expect(0, 10495, '\p{^Is_Block=braillepatterns}', "");
    Expect(0, 10495, '\P{Is_Block=braillepatterns}', "");
    Expect(1, 10495, '\P{^Is_Block=braillepatterns}', "");
    Expect(0, 10496, '\p{Is_Block=braillepatterns}', "");
    Expect(1, 10496, '\p{^Is_Block=braillepatterns}', "");
    Expect(1, 10496, '\P{Is_Block=braillepatterns}', "");
    Expect(0, 10496, '\P{^Is_Block=braillepatterns}', "");
    Expect(1, 10495, '\p{Is_Block=	_BRAILLE_patterns}', "");
    Expect(0, 10495, '\p{^Is_Block=	_BRAILLE_patterns}', "");
    Expect(0, 10495, '\P{Is_Block=	_BRAILLE_patterns}', "");
    Expect(1, 10495, '\P{^Is_Block=	_BRAILLE_patterns}', "");
    Expect(0, 10496, '\p{Is_Block=	_BRAILLE_patterns}', "");
    Expect(1, 10496, '\p{^Is_Block=	_BRAILLE_patterns}', "");
    Expect(1, 10496, '\P{Is_Block=	_BRAILLE_patterns}', "");
    Expect(0, 10496, '\P{^Is_Block=	_BRAILLE_patterns}', "");
    Error('\p{Is_Blk=:=	_braille}');
    Error('\P{Is_Blk=:=	_braille}');
    Expect(1, 10495, '\p{Is_Blk=braille}', "");
    Expect(0, 10495, '\p{^Is_Blk=braille}', "");
    Expect(0, 10495, '\P{Is_Blk=braille}', "");
    Expect(1, 10495, '\P{^Is_Blk=braille}', "");
    Expect(0, 10496, '\p{Is_Blk=braille}', "");
    Expect(1, 10496, '\p{^Is_Blk=braille}', "");
    Expect(1, 10496, '\P{Is_Blk=braille}', "");
    Expect(0, 10496, '\P{^Is_Blk=braille}', "");
    Expect(1, 10495, '\p{Is_Blk=	braille}', "");
    Expect(0, 10495, '\p{^Is_Blk=	braille}', "");
    Expect(0, 10495, '\P{Is_Blk=	braille}', "");
    Expect(1, 10495, '\P{^Is_Blk=	braille}', "");
    Expect(0, 10496, '\p{Is_Blk=	braille}', "");
    Expect(1, 10496, '\p{^Is_Blk=	braille}', "");
    Expect(1, 10496, '\P{Is_Blk=	braille}', "");
    Expect(0, 10496, '\P{^Is_Blk=	braille}', "");
    Error('\p{Block=_Buginese/a/}');
    Error('\P{Block=_Buginese/a/}');
    Expect(1, 6687, '\p{Block=:\ABuginese\z:}', "");;
    Expect(0, 6688, '\p{Block=:\ABuginese\z:}', "");;
    Expect(1, 6687, '\p{Block=buginese}', "");
    Expect(0, 6687, '\p{^Block=buginese}', "");
    Expect(0, 6687, '\P{Block=buginese}', "");
    Expect(1, 6687, '\P{^Block=buginese}', "");
    Expect(0, 6688, '\p{Block=buginese}', "");
    Expect(1, 6688, '\p{^Block=buginese}', "");
    Expect(1, 6688, '\P{Block=buginese}', "");
    Expect(0, 6688, '\P{^Block=buginese}', "");
    Expect(1, 6687, '\p{Block=:\Abuginese\z:}', "");;
    Expect(0, 6688, '\p{Block=:\Abuginese\z:}', "");;
    Expect(1, 6687, '\p{Block=BUGINESE}', "");
    Expect(0, 6687, '\p{^Block=BUGINESE}', "");
    Expect(0, 6687, '\P{Block=BUGINESE}', "");
    Expect(1, 6687, '\P{^Block=BUGINESE}', "");
    Expect(0, 6688, '\p{Block=BUGINESE}', "");
    Expect(1, 6688, '\p{^Block=BUGINESE}', "");
    Expect(1, 6688, '\P{Block=BUGINESE}', "");
    Expect(0, 6688, '\P{^Block=BUGINESE}', "");
    Error('\p{Blk=:=_Buginese}');
    Error('\P{Blk=:=_Buginese}');
    Expect(1, 6687, '\p{Blk=:\ABuginese\z:}', "");;
    Expect(0, 6688, '\p{Blk=:\ABuginese\z:}', "");;
    Expect(1, 6687, '\p{Blk=buginese}', "");
    Expect(0, 6687, '\p{^Blk=buginese}', "");
    Expect(0, 6687, '\P{Blk=buginese}', "");
    Expect(1, 6687, '\P{^Blk=buginese}', "");
    Expect(0, 6688, '\p{Blk=buginese}', "");
    Expect(1, 6688, '\p{^Blk=buginese}', "");
    Expect(1, 6688, '\P{Blk=buginese}', "");
    Expect(0, 6688, '\P{^Blk=buginese}', "");
    Expect(1, 6687, '\p{Blk=:\Abuginese\z:}', "");;
    Expect(0, 6688, '\p{Blk=:\Abuginese\z:}', "");;
    Expect(1, 6687, '\p{Blk=- Buginese}', "");
    Expect(0, 6687, '\p{^Blk=- Buginese}', "");
    Expect(0, 6687, '\P{Blk=- Buginese}', "");
    Expect(1, 6687, '\P{^Blk=- Buginese}', "");
    Expect(0, 6688, '\p{Blk=- Buginese}', "");
    Expect(1, 6688, '\p{^Blk=- Buginese}', "");
    Expect(1, 6688, '\P{Blk=- Buginese}', "");
    Expect(0, 6688, '\P{^Blk=- Buginese}', "");
    Error('\p{Is_Block=/a/_ BUGINESE}');
    Error('\P{Is_Block=/a/_ BUGINESE}');
    Expect(1, 6687, '\p{Is_Block=buginese}', "");
    Expect(0, 6687, '\p{^Is_Block=buginese}', "");
    Expect(0, 6687, '\P{Is_Block=buginese}', "");
    Expect(1, 6687, '\P{^Is_Block=buginese}', "");
    Expect(0, 6688, '\p{Is_Block=buginese}', "");
    Expect(1, 6688, '\p{^Is_Block=buginese}', "");
    Expect(1, 6688, '\P{Is_Block=buginese}', "");
    Expect(0, 6688, '\P{^Is_Block=buginese}', "");
    Expect(1, 6687, '\p{Is_Block= Buginese}', "");
    Expect(0, 6687, '\p{^Is_Block= Buginese}', "");
    Expect(0, 6687, '\P{Is_Block= Buginese}', "");
    Expect(1, 6687, '\P{^Is_Block= Buginese}', "");
    Expect(0, 6688, '\p{Is_Block= Buginese}', "");
    Expect(1, 6688, '\p{^Is_Block= Buginese}', "");
    Expect(1, 6688, '\P{Is_Block= Buginese}', "");
    Expect(0, 6688, '\P{^Is_Block= Buginese}', "");
    Error('\p{Is_Blk=/a/-BUGINESE}');
    Error('\P{Is_Blk=/a/-BUGINESE}');
    Expect(1, 6687, '\p{Is_Blk=buginese}', "");
    Expect(0, 6687, '\p{^Is_Blk=buginese}', "");
    Expect(0, 6687, '\P{Is_Blk=buginese}', "");
    Expect(1, 6687, '\P{^Is_Blk=buginese}', "");
    Expect(0, 6688, '\p{Is_Blk=buginese}', "");
    Expect(1, 6688, '\p{^Is_Blk=buginese}', "");
    Expect(1, 6688, '\P{Is_Blk=buginese}', "");
    Expect(0, 6688, '\P{^Is_Blk=buginese}', "");
    Expect(1, 6687, '\p{Is_Blk=_Buginese}', "");
    Expect(0, 6687, '\p{^Is_Blk=_Buginese}', "");
    Expect(0, 6687, '\P{Is_Blk=_Buginese}', "");
    Expect(1, 6687, '\P{^Is_Blk=_Buginese}', "");
    Expect(0, 6688, '\p{Is_Blk=_Buginese}', "");
    Expect(1, 6688, '\p{^Is_Blk=_Buginese}', "");
    Expect(1, 6688, '\P{Is_Blk=_Buginese}', "");
    Expect(0, 6688, '\P{^Is_Blk=_Buginese}', "");
    Error('\p{Block=/a/	-buhid}');
    Error('\P{Block=/a/	-buhid}');
    Expect(1, 5983, '\p{Block=:\ABuhid\z:}', "");;
    Expect(0, 5984, '\p{Block=:\ABuhid\z:}', "");;
    Expect(1, 5983, '\p{Block=buhid}', "");
    Expect(0, 5983, '\p{^Block=buhid}', "");
    Expect(0, 5983, '\P{Block=buhid}', "");
    Expect(1, 5983, '\P{^Block=buhid}', "");
    Expect(0, 5984, '\p{Block=buhid}', "");
    Expect(1, 5984, '\p{^Block=buhid}', "");
    Expect(1, 5984, '\P{Block=buhid}', "");
    Expect(0, 5984, '\P{^Block=buhid}', "");
    Expect(1, 5983, '\p{Block=:\Abuhid\z:}', "");;
    Expect(0, 5984, '\p{Block=:\Abuhid\z:}', "");;
    Expect(1, 5983, '\p{Block=		Buhid}', "");
    Expect(0, 5983, '\p{^Block=		Buhid}', "");
    Expect(0, 5983, '\P{Block=		Buhid}', "");
    Expect(1, 5983, '\P{^Block=		Buhid}', "");
    Expect(0, 5984, '\p{Block=		Buhid}', "");
    Expect(1, 5984, '\p{^Block=		Buhid}', "");
    Expect(1, 5984, '\P{Block=		Buhid}', "");
    Expect(0, 5984, '\P{^Block=		Buhid}', "");
    Error('\p{Blk=--Buhid:=}');
    Error('\P{Blk=--Buhid:=}');
    Expect(1, 5983, '\p{Blk=:\ABuhid\z:}', "");;
    Expect(0, 5984, '\p{Blk=:\ABuhid\z:}', "");;
    Expect(1, 5983, '\p{Blk=buhid}', "");
    Expect(0, 5983, '\p{^Blk=buhid}', "");
    Expect(0, 5983, '\P{Blk=buhid}', "");
    Expect(1, 5983, '\P{^Blk=buhid}', "");
    Expect(0, 5984, '\p{Blk=buhid}', "");
    Expect(1, 5984, '\p{^Blk=buhid}', "");
    Expect(1, 5984, '\P{Blk=buhid}', "");
    Expect(0, 5984, '\P{^Blk=buhid}', "");
    Expect(1, 5983, '\p{Blk=:\Abuhid\z:}', "");;
    Expect(0, 5984, '\p{Blk=:\Abuhid\z:}', "");;
    Expect(1, 5983, '\p{Blk=_	Buhid}', "");
    Expect(0, 5983, '\p{^Blk=_	Buhid}', "");
    Expect(0, 5983, '\P{Blk=_	Buhid}', "");
    Expect(1, 5983, '\P{^Blk=_	Buhid}', "");
    Expect(0, 5984, '\p{Blk=_	Buhid}', "");
    Expect(1, 5984, '\p{^Blk=_	Buhid}', "");
    Expect(1, 5984, '\P{Blk=_	Buhid}', "");
    Expect(0, 5984, '\P{^Blk=_	Buhid}', "");
    Error('\p{Is_Block= :=Buhid}');
    Error('\P{Is_Block= :=Buhid}');
    Expect(1, 5983, '\p{Is_Block=buhid}', "");
    Expect(0, 5983, '\p{^Is_Block=buhid}', "");
    Expect(0, 5983, '\P{Is_Block=buhid}', "");
    Expect(1, 5983, '\P{^Is_Block=buhid}', "");
    Expect(0, 5984, '\p{Is_Block=buhid}', "");
    Expect(1, 5984, '\p{^Is_Block=buhid}', "");
    Expect(1, 5984, '\P{Is_Block=buhid}', "");
    Expect(0, 5984, '\P{^Is_Block=buhid}', "");
    Expect(1, 5983, '\p{Is_Block= 	Buhid}', "");
    Expect(0, 5983, '\p{^Is_Block= 	Buhid}', "");
    Expect(0, 5983, '\P{Is_Block= 	Buhid}', "");
    Expect(1, 5983, '\P{^Is_Block= 	Buhid}', "");
    Expect(0, 5984, '\p{Is_Block= 	Buhid}', "");
    Expect(1, 5984, '\p{^Is_Block= 	Buhid}', "");
    Expect(1, 5984, '\P{Is_Block= 	Buhid}', "");
    Expect(0, 5984, '\P{^Is_Block= 	Buhid}', "");
    Error('\p{Is_Blk=:=	BUHID}');
    Error('\P{Is_Blk=:=	BUHID}');
    Expect(1, 5983, '\p{Is_Blk=buhid}', "");
    Expect(0, 5983, '\p{^Is_Blk=buhid}', "");
    Expect(0, 5983, '\P{Is_Blk=buhid}', "");
    Expect(1, 5983, '\P{^Is_Blk=buhid}', "");
    Expect(0, 5984, '\p{Is_Blk=buhid}', "");
    Expect(1, 5984, '\p{^Is_Blk=buhid}', "");
    Expect(1, 5984, '\P{Is_Blk=buhid}', "");
    Expect(0, 5984, '\P{^Is_Blk=buhid}', "");
    Expect(1, 5983, '\p{Is_Blk=	_buhid}', "");
    Expect(0, 5983, '\p{^Is_Blk=	_buhid}', "");
    Expect(0, 5983, '\P{Is_Blk=	_buhid}', "");
    Expect(1, 5983, '\P{^Is_Blk=	_buhid}', "");
    Expect(0, 5984, '\p{Is_Blk=	_buhid}', "");
    Expect(1, 5984, '\p{^Is_Blk=	_buhid}', "");
    Expect(1, 5984, '\P{Is_Blk=	_buhid}', "");
    Expect(0, 5984, '\P{^Is_Blk=	_buhid}', "");
    Error('\p{Block=-Byzantine_Musical_Symbols/a/}');
    Error('\P{Block=-Byzantine_Musical_Symbols/a/}');
    Expect(1, 119039, '\p{Block=:\AByzantine_Musical_Symbols\z:}', "");;
    Expect(0, 119040, '\p{Block=:\AByzantine_Musical_Symbols\z:}', "");;
    Expect(1, 119039, '\p{Block=byzantinemusicalsymbols}', "");
    Expect(0, 119039, '\p{^Block=byzantinemusicalsymbols}', "");
    Expect(0, 119039, '\P{Block=byzantinemusicalsymbols}', "");
    Expect(1, 119039, '\P{^Block=byzantinemusicalsymbols}', "");
    Expect(0, 119040, '\p{Block=byzantinemusicalsymbols}', "");
    Expect(1, 119040, '\p{^Block=byzantinemusicalsymbols}', "");
    Expect(1, 119040, '\P{Block=byzantinemusicalsymbols}', "");
    Expect(0, 119040, '\P{^Block=byzantinemusicalsymbols}', "");
    Expect(1, 119039, '\p{Block=:\Abyzantinemusicalsymbols\z:}', "");;
    Expect(0, 119040, '\p{Block=:\Abyzantinemusicalsymbols\z:}', "");;
    Expect(1, 119039, '\p{Block:    _BYZANTINE_Musical_SYMBOLS}', "");
    Expect(0, 119039, '\p{^Block:    _BYZANTINE_Musical_SYMBOLS}', "");
    Expect(0, 119039, '\P{Block:    _BYZANTINE_Musical_SYMBOLS}', "");
    Expect(1, 119039, '\P{^Block:    _BYZANTINE_Musical_SYMBOLS}', "");
    Expect(0, 119040, '\p{Block:    _BYZANTINE_Musical_SYMBOLS}', "");
    Expect(1, 119040, '\p{^Block:    _BYZANTINE_Musical_SYMBOLS}', "");
    Expect(1, 119040, '\P{Block:    _BYZANTINE_Musical_SYMBOLS}', "");
    Expect(0, 119040, '\P{^Block:    _BYZANTINE_Musical_SYMBOLS}', "");
    Error('\p{Blk=:=Byzantine_Music}');
    Error('\P{Blk=:=Byzantine_Music}');
    Expect(1, 119039, '\p{Blk=:\AByzantine_Music\z:}', "");;
    Expect(0, 119040, '\p{Blk=:\AByzantine_Music\z:}', "");;
    Expect(1, 119039, '\p{Blk=byzantinemusic}', "");
    Expect(0, 119039, '\p{^Blk=byzantinemusic}', "");
    Expect(0, 119039, '\P{Blk=byzantinemusic}', "");
    Expect(1, 119039, '\P{^Blk=byzantinemusic}', "");
    Expect(0, 119040, '\p{Blk=byzantinemusic}', "");
    Expect(1, 119040, '\p{^Blk=byzantinemusic}', "");
    Expect(1, 119040, '\P{Blk=byzantinemusic}', "");
    Expect(0, 119040, '\P{^Blk=byzantinemusic}', "");
    Expect(1, 119039, '\p{Blk=:\Abyzantinemusic\z:}', "");;
    Expect(0, 119040, '\p{Blk=:\Abyzantinemusic\z:}', "");;
    Expect(1, 119039, '\p{Blk=  byzantine_Music}', "");
    Expect(0, 119039, '\p{^Blk=  byzantine_Music}', "");
    Expect(0, 119039, '\P{Blk=  byzantine_Music}', "");
    Expect(1, 119039, '\P{^Blk=  byzantine_Music}', "");
    Expect(0, 119040, '\p{Blk=  byzantine_Music}', "");
    Expect(1, 119040, '\p{^Blk=  byzantine_Music}', "");
    Expect(1, 119040, '\P{Blk=  byzantine_Music}', "");
    Expect(0, 119040, '\P{^Blk=  byzantine_Music}', "");
    Error('\p{Is_Block=_:=Byzantine_musical_SYMBOLS}');
    Error('\P{Is_Block=_:=Byzantine_musical_SYMBOLS}');
    Expect(1, 119039, '\p{Is_Block=byzantinemusicalsymbols}', "");
    Expect(0, 119039, '\p{^Is_Block=byzantinemusicalsymbols}', "");
    Expect(0, 119039, '\P{Is_Block=byzantinemusicalsymbols}', "");
    Expect(1, 119039, '\P{^Is_Block=byzantinemusicalsymbols}', "");
    Expect(0, 119040, '\p{Is_Block=byzantinemusicalsymbols}', "");
    Expect(1, 119040, '\p{^Is_Block=byzantinemusicalsymbols}', "");
    Expect(1, 119040, '\P{Is_Block=byzantinemusicalsymbols}', "");
    Expect(0, 119040, '\P{^Is_Block=byzantinemusicalsymbols}', "");
    Expect(1, 119039, '\p{Is_Block=	Byzantine_Musical_Symbols}', "");
    Expect(0, 119039, '\p{^Is_Block=	Byzantine_Musical_Symbols}', "");
    Expect(0, 119039, '\P{Is_Block=	Byzantine_Musical_Symbols}', "");
    Expect(1, 119039, '\P{^Is_Block=	Byzantine_Musical_Symbols}', "");
    Expect(0, 119040, '\p{Is_Block=	Byzantine_Musical_Symbols}', "");
    Expect(1, 119040, '\p{^Is_Block=	Byzantine_Musical_Symbols}', "");
    Expect(1, 119040, '\P{Is_Block=	Byzantine_Musical_Symbols}', "");
    Expect(0, 119040, '\P{^Is_Block=	Byzantine_Musical_Symbols}', "");
    Error('\p{Is_Blk=-	byzantine_music:=}');
    Error('\P{Is_Blk=-	byzantine_music:=}');
    Expect(1, 119039, '\p{Is_Blk=byzantinemusic}', "");
    Expect(0, 119039, '\p{^Is_Blk=byzantinemusic}', "");
    Expect(0, 119039, '\P{Is_Blk=byzantinemusic}', "");
    Expect(1, 119039, '\P{^Is_Blk=byzantinemusic}', "");
    Expect(0, 119040, '\p{Is_Blk=byzantinemusic}', "");
    Expect(1, 119040, '\p{^Is_Blk=byzantinemusic}', "");
    Expect(1, 119040, '\P{Is_Blk=byzantinemusic}', "");
    Expect(0, 119040, '\P{^Is_Blk=byzantinemusic}', "");
    Expect(1, 119039, '\p{Is_Blk=- byzantine_Music}', "");
    Expect(0, 119039, '\p{^Is_Blk=- byzantine_Music}', "");
    Expect(0, 119039, '\P{Is_Blk=- byzantine_Music}', "");
    Expect(1, 119039, '\P{^Is_Blk=- byzantine_Music}', "");
    Expect(0, 119040, '\p{Is_Blk=- byzantine_Music}', "");
    Expect(1, 119040, '\p{^Is_Blk=- byzantine_Music}', "");
    Expect(1, 119040, '\P{Is_Blk=- byzantine_Music}', "");
    Expect(0, 119040, '\P{^Is_Blk=- byzantine_Music}', "");
    Error('\p{Block=CARIAN:=}');
    Error('\P{Block=CARIAN:=}');
    Expect(1, 66271, '\p{Block=:\ACarian\z:}', "");;
    Expect(0, 66272, '\p{Block=:\ACarian\z:}', "");;
    Expect(1, 66271, '\p{Block=carian}', "");
    Expect(0, 66271, '\p{^Block=carian}', "");
    Expect(0, 66271, '\P{Block=carian}', "");
    Expect(1, 66271, '\P{^Block=carian}', "");
    Expect(0, 66272, '\p{Block=carian}', "");
    Expect(1, 66272, '\p{^Block=carian}', "");
    Expect(1, 66272, '\P{Block=carian}', "");
    Expect(0, 66272, '\P{^Block=carian}', "");
    Expect(1, 66271, '\p{Block=:\Acarian\z:}', "");;
    Expect(0, 66272, '\p{Block=:\Acarian\z:}', "");;
    Expect(1, 66271, '\p{Block=	_carian}', "");
    Expect(0, 66271, '\p{^Block=	_carian}', "");
    Expect(0, 66271, '\P{Block=	_carian}', "");
    Expect(1, 66271, '\P{^Block=	_carian}', "");
    Expect(0, 66272, '\p{Block=	_carian}', "");
    Expect(1, 66272, '\p{^Block=	_carian}', "");
    Expect(1, 66272, '\P{Block=	_carian}', "");
    Expect(0, 66272, '\P{^Block=	_carian}', "");
    Error('\p{Blk=	-CARIAN:=}');
    Error('\P{Blk=	-CARIAN:=}');
    Expect(1, 66271, '\p{Blk=:\ACarian\z:}', "");;
    Expect(0, 66272, '\p{Blk=:\ACarian\z:}', "");;
    Expect(1, 66271, '\p{Blk=carian}', "");
    Expect(0, 66271, '\p{^Blk=carian}', "");
    Expect(0, 66271, '\P{Blk=carian}', "");
    Expect(1, 66271, '\P{^Blk=carian}', "");
    Expect(0, 66272, '\p{Blk=carian}', "");
    Expect(1, 66272, '\p{^Blk=carian}', "");
    Expect(1, 66272, '\P{Blk=carian}', "");
    Expect(0, 66272, '\P{^Blk=carian}', "");
    Expect(1, 66271, '\p{Blk=:\Acarian\z:}', "");;
    Expect(0, 66272, '\p{Blk=:\Acarian\z:}', "");;
    Expect(1, 66271, '\p{Blk=__carian}', "");
    Expect(0, 66271, '\p{^Blk=__carian}', "");
    Expect(0, 66271, '\P{Blk=__carian}', "");
    Expect(1, 66271, '\P{^Blk=__carian}', "");
    Expect(0, 66272, '\p{Blk=__carian}', "");
    Expect(1, 66272, '\p{^Blk=__carian}', "");
    Expect(1, 66272, '\P{Blk=__carian}', "");
    Expect(0, 66272, '\P{^Blk=__carian}', "");
    Error('\p{Is_Block=:=_Carian}');
    Error('\P{Is_Block=:=_Carian}');
    Expect(1, 66271, '\p{Is_Block=carian}', "");
    Expect(0, 66271, '\p{^Is_Block=carian}', "");
    Expect(0, 66271, '\P{Is_Block=carian}', "");
    Expect(1, 66271, '\P{^Is_Block=carian}', "");
    Expect(0, 66272, '\p{Is_Block=carian}', "");
    Expect(1, 66272, '\p{^Is_Block=carian}', "");
    Expect(1, 66272, '\P{Is_Block=carian}', "");
    Expect(0, 66272, '\P{^Is_Block=carian}', "");
    Expect(1, 66271, '\p{Is_Block=-_CARIAN}', "");
    Expect(0, 66271, '\p{^Is_Block=-_CARIAN}', "");
    Expect(0, 66271, '\P{Is_Block=-_CARIAN}', "");
    Expect(1, 66271, '\P{^Is_Block=-_CARIAN}', "");
    Expect(0, 66272, '\p{Is_Block=-_CARIAN}', "");
    Expect(1, 66272, '\p{^Is_Block=-_CARIAN}', "");
    Expect(1, 66272, '\P{Is_Block=-_CARIAN}', "");
    Expect(0, 66272, '\P{^Is_Block=-_CARIAN}', "");
    Error('\p{Is_Blk=	:=carian}');
    Error('\P{Is_Blk=	:=carian}');
    Expect(1, 66271, '\p{Is_Blk=carian}', "");
    Expect(0, 66271, '\p{^Is_Blk=carian}', "");
    Expect(0, 66271, '\P{Is_Blk=carian}', "");
    Expect(1, 66271, '\P{^Is_Blk=carian}', "");
    Expect(0, 66272, '\p{Is_Blk=carian}', "");
    Expect(1, 66272, '\p{^Is_Blk=carian}', "");
    Expect(1, 66272, '\P{Is_Blk=carian}', "");
    Expect(0, 66272, '\P{^Is_Blk=carian}', "");
    Expect(1, 66271, '\p{Is_Blk= CARIAN}', "");
    Expect(0, 66271, '\p{^Is_Blk= CARIAN}', "");
    Expect(0, 66271, '\P{Is_Blk= CARIAN}', "");
    Expect(1, 66271, '\P{^Is_Blk= CARIAN}', "");
    Expect(0, 66272, '\p{Is_Blk= CARIAN}', "");
    Expect(1, 66272, '\p{^Is_Blk= CARIAN}', "");
    Expect(1, 66272, '\P{Is_Blk= CARIAN}', "");
    Expect(0, 66272, '\P{^Is_Blk= CARIAN}', "");
    Error('\p{Block=:=_ Caucasian_Albanian}');
    Error('\P{Block=:=_ Caucasian_Albanian}');
    Expect(1, 66927, '\p{Block=:\ACaucasian_Albanian\z:}', "");;
    Expect(0, 66928, '\p{Block=:\ACaucasian_Albanian\z:}', "");;
    Expect(1, 66927, '\p{Block=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Block=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Block=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Block=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Block=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Block=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Block=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Block=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Block=:\Acaucasianalbanian\z:}', "");;
    Expect(0, 66928, '\p{Block=:\Acaucasianalbanian\z:}', "");;
    Expect(1, 66927, '\p{Block=-	CAUCASIAN_ALBANIAN}', "");
    Expect(0, 66927, '\p{^Block=-	CAUCASIAN_ALBANIAN}', "");
    Expect(0, 66927, '\P{Block=-	CAUCASIAN_ALBANIAN}', "");
    Expect(1, 66927, '\P{^Block=-	CAUCASIAN_ALBANIAN}', "");
    Expect(0, 66928, '\p{Block=-	CAUCASIAN_ALBANIAN}', "");
    Expect(1, 66928, '\p{^Block=-	CAUCASIAN_ALBANIAN}', "");
    Expect(1, 66928, '\P{Block=-	CAUCASIAN_ALBANIAN}', "");
    Expect(0, 66928, '\P{^Block=-	CAUCASIAN_ALBANIAN}', "");
    Error('\p{Blk=-_CAUCASIAN_ALBANIAN:=}');
    Error('\P{Blk=-_CAUCASIAN_ALBANIAN:=}');
    Expect(1, 66927, '\p{Blk=:\ACaucasian_Albanian\z:}', "");;
    Expect(0, 66928, '\p{Blk=:\ACaucasian_Albanian\z:}', "");;
    Expect(1, 66927, '\p{Blk:	caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Blk:	caucasianalbanian}', "");
    Expect(0, 66927, '\P{Blk:	caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Blk:	caucasianalbanian}', "");
    Expect(0, 66928, '\p{Blk:	caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Blk:	caucasianalbanian}', "");
    Expect(1, 66928, '\P{Blk:	caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Blk:	caucasianalbanian}', "");
    Expect(1, 66927, '\p{Blk=:\Acaucasianalbanian\z:}', "");;
    Expect(0, 66928, '\p{Blk=:\Acaucasianalbanian\z:}', "");;
    Expect(1, 66927, '\p{Blk: _Caucasian_Albanian}', "");
    Expect(0, 66927, '\p{^Blk: _Caucasian_Albanian}', "");
    Expect(0, 66927, '\P{Blk: _Caucasian_Albanian}', "");
    Expect(1, 66927, '\P{^Blk: _Caucasian_Albanian}', "");
    Expect(0, 66928, '\p{Blk: _Caucasian_Albanian}', "");
    Expect(1, 66928, '\p{^Blk: _Caucasian_Albanian}', "");
    Expect(1, 66928, '\P{Blk: _Caucasian_Albanian}', "");
    Expect(0, 66928, '\P{^Blk: _Caucasian_Albanian}', "");
    Error('\p{Is_Block=/a/	-Caucasian_Albanian}');
    Error('\P{Is_Block=/a/	-Caucasian_Albanian}');
    Expect(1, 66927, '\p{Is_Block=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Is_Block=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Is_Block=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Is_Block=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Is_Block=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Is_Block=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Is_Block=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Is_Block=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Is_Block=_CAUCASIAN_Albanian}', "");
    Expect(0, 66927, '\p{^Is_Block=_CAUCASIAN_Albanian}', "");
    Expect(0, 66927, '\P{Is_Block=_CAUCASIAN_Albanian}', "");
    Expect(1, 66927, '\P{^Is_Block=_CAUCASIAN_Albanian}', "");
    Expect(0, 66928, '\p{Is_Block=_CAUCASIAN_Albanian}', "");
    Expect(1, 66928, '\p{^Is_Block=_CAUCASIAN_Albanian}', "");
    Expect(1, 66928, '\P{Is_Block=_CAUCASIAN_Albanian}', "");
    Expect(0, 66928, '\P{^Is_Block=_CAUCASIAN_Albanian}', "");
    Error('\p{Is_Blk=:=_Caucasian_Albanian}');
    Error('\P{Is_Blk=:=_Caucasian_Albanian}');
    Expect(1, 66927, '\p{Is_Blk=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Is_Blk=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Is_Blk=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Is_Blk=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Is_Blk=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Is_Blk=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Is_Blk=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Is_Blk=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Is_Blk:	-caucasian_albanian}', "");
    Expect(0, 66927, '\p{^Is_Blk:	-caucasian_albanian}', "");
    Expect(0, 66927, '\P{Is_Blk:	-caucasian_albanian}', "");
    Expect(1, 66927, '\P{^Is_Blk:	-caucasian_albanian}', "");
    Expect(0, 66928, '\p{Is_Blk:	-caucasian_albanian}', "");
    Expect(1, 66928, '\p{^Is_Blk:	-caucasian_albanian}', "");
    Expect(1, 66928, '\P{Is_Blk:	-caucasian_albanian}', "");
    Expect(0, 66928, '\P{^Is_Blk:	-caucasian_albanian}', "");
    Error('\p{Block=:=  CHAKMA}');
    Error('\P{Block=:=  CHAKMA}');
    Expect(1, 69967, '\p{Block=:\AChakma\z:}', "");;
    Expect(0, 69968, '\p{Block=:\AChakma\z:}', "");;
    Expect(1, 69967, '\p{Block: chakma}', "");
    Expect(0, 69967, '\p{^Block: chakma}', "");
    Expect(0, 69967, '\P{Block: chakma}', "");
    Expect(1, 69967, '\P{^Block: chakma}', "");
    Expect(0, 69968, '\p{Block: chakma}', "");
    Expect(1, 69968, '\p{^Block: chakma}', "");
    Expect(1, 69968, '\P{Block: chakma}', "");
    Expect(0, 69968, '\P{^Block: chakma}', "");
    Expect(1, 69967, '\p{Block=:\Achakma\z:}', "");;
    Expect(0, 69968, '\p{Block=:\Achakma\z:}', "");;
    Expect(1, 69967, '\p{Block=_	chakma}', "");
    Expect(0, 69967, '\p{^Block=_	chakma}', "");
    Expect(0, 69967, '\P{Block=_	chakma}', "");
    Expect(1, 69967, '\P{^Block=_	chakma}', "");
    Expect(0, 69968, '\p{Block=_	chakma}', "");
    Expect(1, 69968, '\p{^Block=_	chakma}', "");
    Expect(1, 69968, '\P{Block=_	chakma}', "");
    Expect(0, 69968, '\P{^Block=_	chakma}', "");
    Error('\p{Blk=__Chakma/a/}');
    Error('\P{Blk=__Chakma/a/}');
    Expect(1, 69967, '\p{Blk=:\AChakma\z:}', "");;
    Expect(0, 69968, '\p{Blk=:\AChakma\z:}', "");;
    Expect(1, 69967, '\p{Blk=chakma}', "");
    Expect(0, 69967, '\p{^Blk=chakma}', "");
    Expect(0, 69967, '\P{Blk=chakma}', "");
    Expect(1, 69967, '\P{^Blk=chakma}', "");
    Expect(0, 69968, '\p{Blk=chakma}', "");
    Expect(1, 69968, '\p{^Blk=chakma}', "");
    Expect(1, 69968, '\P{Blk=chakma}', "");
    Expect(0, 69968, '\P{^Blk=chakma}', "");
    Expect(1, 69967, '\p{Blk=:\Achakma\z:}', "");;
    Expect(0, 69968, '\p{Blk=:\Achakma\z:}', "");;
    Expect(1, 69967, '\p{Blk=CHAKMA}', "");
    Expect(0, 69967, '\p{^Blk=CHAKMA}', "");
    Expect(0, 69967, '\P{Blk=CHAKMA}', "");
    Expect(1, 69967, '\P{^Blk=CHAKMA}', "");
    Expect(0, 69968, '\p{Blk=CHAKMA}', "");
    Expect(1, 69968, '\p{^Blk=CHAKMA}', "");
    Expect(1, 69968, '\P{Blk=CHAKMA}', "");
    Expect(0, 69968, '\P{^Blk=CHAKMA}', "");
    Error('\p{Is_Block=/a/_ CHAKMA}');
    Error('\P{Is_Block=/a/_ CHAKMA}');
    Expect(1, 69967, '\p{Is_Block=chakma}', "");
    Expect(0, 69967, '\p{^Is_Block=chakma}', "");
    Expect(0, 69967, '\P{Is_Block=chakma}', "");
    Expect(1, 69967, '\P{^Is_Block=chakma}', "");
    Expect(0, 69968, '\p{Is_Block=chakma}', "");
    Expect(1, 69968, '\p{^Is_Block=chakma}', "");
    Expect(1, 69968, '\P{Is_Block=chakma}', "");
    Expect(0, 69968, '\P{^Is_Block=chakma}', "");
    Expect(1, 69967, '\p{Is_Block= 	chakma}', "");
    Expect(0, 69967, '\p{^Is_Block= 	chakma}', "");
    Expect(0, 69967, '\P{Is_Block= 	chakma}', "");
    Expect(1, 69967, '\P{^Is_Block= 	chakma}', "");
    Expect(0, 69968, '\p{Is_Block= 	chakma}', "");
    Expect(1, 69968, '\p{^Is_Block= 	chakma}', "");
    Expect(1, 69968, '\P{Is_Block= 	chakma}', "");
    Expect(0, 69968, '\P{^Is_Block= 	chakma}', "");
    Error('\p{Is_Blk=_/a/chakma}');
    Error('\P{Is_Blk=_/a/chakma}');
    Expect(1, 69967, '\p{Is_Blk=chakma}', "");
    Expect(0, 69967, '\p{^Is_Blk=chakma}', "");
    Expect(0, 69967, '\P{Is_Blk=chakma}', "");
    Expect(1, 69967, '\P{^Is_Blk=chakma}', "");
    Expect(0, 69968, '\p{Is_Blk=chakma}', "");
    Expect(1, 69968, '\p{^Is_Blk=chakma}', "");
    Expect(1, 69968, '\P{Is_Blk=chakma}', "");
    Expect(0, 69968, '\P{^Is_Blk=chakma}', "");
    Expect(1, 69967, '\p{Is_Blk:   Chakma}', "");
    Expect(0, 69967, '\p{^Is_Blk:   Chakma}', "");
    Expect(0, 69967, '\P{Is_Blk:   Chakma}', "");
    Expect(1, 69967, '\P{^Is_Blk:   Chakma}', "");
    Expect(0, 69968, '\p{Is_Blk:   Chakma}', "");
    Expect(1, 69968, '\p{^Is_Blk:   Chakma}', "");
    Expect(1, 69968, '\P{Is_Blk:   Chakma}', "");
    Expect(0, 69968, '\P{^Is_Blk:   Chakma}', "");
    Error('\p{Block=-/a/CHAM}');
    Error('\P{Block=-/a/CHAM}');
    Expect(1, 43615, '\p{Block=:\ACham\z:}', "");;
    Expect(0, 43616, '\p{Block=:\ACham\z:}', "");;
    Expect(1, 43615, '\p{Block=cham}', "");
    Expect(0, 43615, '\p{^Block=cham}', "");
    Expect(0, 43615, '\P{Block=cham}', "");
    Expect(1, 43615, '\P{^Block=cham}', "");
    Expect(0, 43616, '\p{Block=cham}', "");
    Expect(1, 43616, '\p{^Block=cham}', "");
    Expect(1, 43616, '\P{Block=cham}', "");
    Expect(0, 43616, '\P{^Block=cham}', "");
    Expect(1, 43615, '\p{Block=:\Acham\z:}', "");;
    Expect(0, 43616, '\p{Block=:\Acham\z:}', "");;
    Expect(1, 43615, '\p{Block=_cham}', "");
    Expect(0, 43615, '\p{^Block=_cham}', "");
    Expect(0, 43615, '\P{Block=_cham}', "");
    Expect(1, 43615, '\P{^Block=_cham}', "");
    Expect(0, 43616, '\p{Block=_cham}', "");
    Expect(1, 43616, '\p{^Block=_cham}', "");
    Expect(1, 43616, '\P{Block=_cham}', "");
    Expect(0, 43616, '\P{^Block=_cham}', "");
    Error('\p{Blk= /a/CHAM}');
    Error('\P{Blk= /a/CHAM}');
    Expect(1, 43615, '\p{Blk=:\ACham\z:}', "");;
    Expect(0, 43616, '\p{Blk=:\ACham\z:}', "");;
    Expect(1, 43615, '\p{Blk=cham}', "");
    Expect(0, 43615, '\p{^Blk=cham}', "");
    Expect(0, 43615, '\P{Blk=cham}', "");
    Expect(1, 43615, '\P{^Blk=cham}', "");
    Expect(0, 43616, '\p{Blk=cham}', "");
    Expect(1, 43616, '\p{^Blk=cham}', "");
    Expect(1, 43616, '\P{Blk=cham}', "");
    Expect(0, 43616, '\P{^Blk=cham}', "");
    Expect(1, 43615, '\p{Blk=:\Acham\z:}', "");;
    Expect(0, 43616, '\p{Blk=:\Acham\z:}', "");;
    Expect(1, 43615, '\p{Blk= -Cham}', "");
    Expect(0, 43615, '\p{^Blk= -Cham}', "");
    Expect(0, 43615, '\P{Blk= -Cham}', "");
    Expect(1, 43615, '\P{^Blk= -Cham}', "");
    Expect(0, 43616, '\p{Blk= -Cham}', "");
    Expect(1, 43616, '\p{^Blk= -Cham}', "");
    Expect(1, 43616, '\P{Blk= -Cham}', "");
    Expect(0, 43616, '\P{^Blk= -Cham}', "");
    Error('\p{Is_Block=-/a/Cham}');
    Error('\P{Is_Block=-/a/Cham}');
    Expect(1, 43615, '\p{Is_Block=cham}', "");
    Expect(0, 43615, '\p{^Is_Block=cham}', "");
    Expect(0, 43615, '\P{Is_Block=cham}', "");
    Expect(1, 43615, '\P{^Is_Block=cham}', "");
    Expect(0, 43616, '\p{Is_Block=cham}', "");
    Expect(1, 43616, '\p{^Is_Block=cham}', "");
    Expect(1, 43616, '\P{Is_Block=cham}', "");
    Expect(0, 43616, '\P{^Is_Block=cham}', "");
    Expect(1, 43615, '\p{Is_Block=-	CHAM}', "");
    Expect(0, 43615, '\p{^Is_Block=-	CHAM}', "");
    Expect(0, 43615, '\P{Is_Block=-	CHAM}', "");
    Expect(1, 43615, '\P{^Is_Block=-	CHAM}', "");
    Expect(0, 43616, '\p{Is_Block=-	CHAM}', "");
    Expect(1, 43616, '\p{^Is_Block=-	CHAM}', "");
    Expect(1, 43616, '\P{Is_Block=-	CHAM}', "");
    Expect(0, 43616, '\P{^Is_Block=-	CHAM}', "");
    Error('\p{Is_Blk=/a/-Cham}');
    Error('\P{Is_Blk=/a/-Cham}');
    Expect(1, 43615, '\p{Is_Blk=cham}', "");
    Expect(0, 43615, '\p{^Is_Blk=cham}', "");
    Expect(0, 43615, '\P{Is_Blk=cham}', "");
    Expect(1, 43615, '\P{^Is_Blk=cham}', "");
    Expect(0, 43616, '\p{Is_Blk=cham}', "");
    Expect(1, 43616, '\p{^Is_Blk=cham}', "");
    Expect(1, 43616, '\P{Is_Blk=cham}', "");
    Expect(0, 43616, '\P{^Is_Blk=cham}', "");
    Expect(1, 43615, '\p{Is_Blk= cham}', "");
    Expect(0, 43615, '\p{^Is_Blk= cham}', "");
    Expect(0, 43615, '\P{Is_Blk= cham}', "");
    Expect(1, 43615, '\P{^Is_Blk= cham}', "");
    Expect(0, 43616, '\p{Is_Blk= cham}', "");
    Expect(1, 43616, '\p{^Is_Blk= cham}', "");
    Expect(1, 43616, '\P{Is_Blk= cham}', "");
    Expect(0, 43616, '\P{^Is_Blk= cham}', "");
    Error('\p{Block=/a/ -Cherokee}');
    Error('\P{Block=/a/ -Cherokee}');
    Expect(1, 5119, '\p{Block=:\ACherokee\z:}', "");;
    Expect(0, 5120, '\p{Block=:\ACherokee\z:}', "");;
    Expect(1, 5119, '\p{Block=cherokee}', "");
    Expect(0, 5119, '\p{^Block=cherokee}', "");
    Expect(0, 5119, '\P{Block=cherokee}', "");
    Expect(1, 5119, '\P{^Block=cherokee}', "");
    Expect(0, 5120, '\p{Block=cherokee}', "");
    Expect(1, 5120, '\p{^Block=cherokee}', "");
    Expect(1, 5120, '\P{Block=cherokee}', "");
    Expect(0, 5120, '\P{^Block=cherokee}', "");
    Expect(1, 5119, '\p{Block=:\Acherokee\z:}', "");;
    Expect(0, 5120, '\p{Block=:\Acherokee\z:}', "");;
    Expect(1, 5119, '\p{Block=  CHEROKEE}', "");
    Expect(0, 5119, '\p{^Block=  CHEROKEE}', "");
    Expect(0, 5119, '\P{Block=  CHEROKEE}', "");
    Expect(1, 5119, '\P{^Block=  CHEROKEE}', "");
    Expect(0, 5120, '\p{Block=  CHEROKEE}', "");
    Expect(1, 5120, '\p{^Block=  CHEROKEE}', "");
    Expect(1, 5120, '\P{Block=  CHEROKEE}', "");
    Expect(0, 5120, '\P{^Block=  CHEROKEE}', "");
    Error('\p{Blk=-CHEROKEE/a/}');
    Error('\P{Blk=-CHEROKEE/a/}');
    Expect(1, 5119, '\p{Blk=:\ACherokee\z:}', "");;
    Expect(0, 5120, '\p{Blk=:\ACherokee\z:}', "");;
    Expect(1, 5119, '\p{Blk=cherokee}', "");
    Expect(0, 5119, '\p{^Blk=cherokee}', "");
    Expect(0, 5119, '\P{Blk=cherokee}', "");
    Expect(1, 5119, '\P{^Blk=cherokee}', "");
    Expect(0, 5120, '\p{Blk=cherokee}', "");
    Expect(1, 5120, '\p{^Blk=cherokee}', "");
    Expect(1, 5120, '\P{Blk=cherokee}', "");
    Expect(0, 5120, '\P{^Blk=cherokee}', "");
    Expect(1, 5119, '\p{Blk=:\Acherokee\z:}', "");;
    Expect(0, 5120, '\p{Blk=:\Acherokee\z:}', "");;
    Expect(1, 5119, '\p{Blk=--cherokee}', "");
    Expect(0, 5119, '\p{^Blk=--cherokee}', "");
    Expect(0, 5119, '\P{Blk=--cherokee}', "");
    Expect(1, 5119, '\P{^Blk=--cherokee}', "");
    Expect(0, 5120, '\p{Blk=--cherokee}', "");
    Expect(1, 5120, '\p{^Blk=--cherokee}', "");
    Expect(1, 5120, '\P{Blk=--cherokee}', "");
    Expect(0, 5120, '\P{^Blk=--cherokee}', "");
    Error('\p{Is_Block=CHEROKEE:=}');
    Error('\P{Is_Block=CHEROKEE:=}');
    Expect(1, 5119, '\p{Is_Block=cherokee}', "");
    Expect(0, 5119, '\p{^Is_Block=cherokee}', "");
    Expect(0, 5119, '\P{Is_Block=cherokee}', "");
    Expect(1, 5119, '\P{^Is_Block=cherokee}', "");
    Expect(0, 5120, '\p{Is_Block=cherokee}', "");
    Expect(1, 5120, '\p{^Is_Block=cherokee}', "");
    Expect(1, 5120, '\P{Is_Block=cherokee}', "");
    Expect(0, 5120, '\P{^Is_Block=cherokee}', "");
    Expect(1, 5119, '\p{Is_Block=  Cherokee}', "");
    Expect(0, 5119, '\p{^Is_Block=  Cherokee}', "");
    Expect(0, 5119, '\P{Is_Block=  Cherokee}', "");
    Expect(1, 5119, '\P{^Is_Block=  Cherokee}', "");
    Expect(0, 5120, '\p{Is_Block=  Cherokee}', "");
    Expect(1, 5120, '\p{^Is_Block=  Cherokee}', "");
    Expect(1, 5120, '\P{Is_Block=  Cherokee}', "");
    Expect(0, 5120, '\P{^Is_Block=  Cherokee}', "");
    Error('\p{Is_Blk=/a/Cherokee}');
    Error('\P{Is_Blk=/a/Cherokee}');
    Expect(1, 5119, '\p{Is_Blk=cherokee}', "");
    Expect(0, 5119, '\p{^Is_Blk=cherokee}', "");
    Expect(0, 5119, '\P{Is_Blk=cherokee}', "");
    Expect(1, 5119, '\P{^Is_Blk=cherokee}', "");
    Expect(0, 5120, '\p{Is_Blk=cherokee}', "");
    Expect(1, 5120, '\p{^Is_Blk=cherokee}', "");
    Expect(1, 5120, '\P{Is_Blk=cherokee}', "");
    Expect(0, 5120, '\P{^Is_Blk=cherokee}', "");
    Expect(1, 5119, '\p{Is_Blk= -Cherokee}', "");
    Expect(0, 5119, '\p{^Is_Blk= -Cherokee}', "");
    Expect(0, 5119, '\P{Is_Blk= -Cherokee}', "");
    Expect(1, 5119, '\P{^Is_Blk= -Cherokee}', "");
    Expect(0, 5120, '\p{Is_Blk= -Cherokee}', "");
    Expect(1, 5120, '\p{^Is_Blk= -Cherokee}', "");
    Expect(1, 5120, '\P{Is_Blk= -Cherokee}', "");
    Expect(0, 5120, '\P{^Is_Blk= -Cherokee}', "");
    Error('\p{Block=_Cherokee_Supplement:=}');
    Error('\P{Block=_Cherokee_Supplement:=}');
    Expect(1, 43967, '\p{Block=:\ACherokee_Supplement\z:}', "");;
    Expect(0, 43968, '\p{Block=:\ACherokee_Supplement\z:}', "");;
    Expect(1, 43967, '\p{Block=cherokeesupplement}', "");
    Expect(0, 43967, '\p{^Block=cherokeesupplement}', "");
    Expect(0, 43967, '\P{Block=cherokeesupplement}', "");
    Expect(1, 43967, '\P{^Block=cherokeesupplement}', "");
    Expect(0, 43968, '\p{Block=cherokeesupplement}', "");
    Expect(1, 43968, '\p{^Block=cherokeesupplement}', "");
    Expect(1, 43968, '\P{Block=cherokeesupplement}', "");
    Expect(0, 43968, '\P{^Block=cherokeesupplement}', "");
    Expect(1, 43967, '\p{Block=:\Acherokeesupplement\z:}', "");;
    Expect(0, 43968, '\p{Block=:\Acherokeesupplement\z:}', "");;
    Expect(1, 43967, '\p{Block=-Cherokee_supplement}', "");
    Expect(0, 43967, '\p{^Block=-Cherokee_supplement}', "");
    Expect(0, 43967, '\P{Block=-Cherokee_supplement}', "");
    Expect(1, 43967, '\P{^Block=-Cherokee_supplement}', "");
    Expect(0, 43968, '\p{Block=-Cherokee_supplement}', "");
    Expect(1, 43968, '\p{^Block=-Cherokee_supplement}', "");
    Expect(1, 43968, '\P{Block=-Cherokee_supplement}', "");
    Expect(0, 43968, '\P{^Block=-Cherokee_supplement}', "");
    Error('\p{Blk=/a/_Cherokee_Sup}');
    Error('\P{Blk=/a/_Cherokee_Sup}');
    Expect(1, 43967, '\p{Blk=:\ACherokee_Sup\z:}', "");;
    Expect(0, 43968, '\p{Blk=:\ACherokee_Sup\z:}', "");;
    Expect(1, 43967, '\p{Blk=cherokeesup}', "");
    Expect(0, 43967, '\p{^Blk=cherokeesup}', "");
    Expect(0, 43967, '\P{Blk=cherokeesup}', "");
    Expect(1, 43967, '\P{^Blk=cherokeesup}', "");
    Expect(0, 43968, '\p{Blk=cherokeesup}', "");
    Expect(1, 43968, '\p{^Blk=cherokeesup}', "");
    Expect(1, 43968, '\P{Blk=cherokeesup}', "");
    Expect(0, 43968, '\P{^Blk=cherokeesup}', "");
    Expect(1, 43967, '\p{Blk=:\Acherokeesup\z:}', "");;
    Expect(0, 43968, '\p{Blk=:\Acherokeesup\z:}', "");;
    Expect(1, 43967, '\p{Blk=- Cherokee_Sup}', "");
    Expect(0, 43967, '\p{^Blk=- Cherokee_Sup}', "");
    Expect(0, 43967, '\P{Blk=- Cherokee_Sup}', "");
    Expect(1, 43967, '\P{^Blk=- Cherokee_Sup}', "");
    Expect(0, 43968, '\p{Blk=- Cherokee_Sup}', "");
    Expect(1, 43968, '\p{^Blk=- Cherokee_Sup}', "");
    Expect(1, 43968, '\P{Blk=- Cherokee_Sup}', "");
    Expect(0, 43968, '\P{^Blk=- Cherokee_Sup}', "");
    Error('\p{Is_Block= 	cherokee_supplement/a/}');
    Error('\P{Is_Block= 	cherokee_supplement/a/}');
    Expect(1, 43967, '\p{Is_Block=cherokeesupplement}', "");
    Expect(0, 43967, '\p{^Is_Block=cherokeesupplement}', "");
    Expect(0, 43967, '\P{Is_Block=cherokeesupplement}', "");
    Expect(1, 43967, '\P{^Is_Block=cherokeesupplement}', "");
    Expect(0, 43968, '\p{Is_Block=cherokeesupplement}', "");
    Expect(1, 43968, '\p{^Is_Block=cherokeesupplement}', "");
    Expect(1, 43968, '\P{Is_Block=cherokeesupplement}', "");
    Expect(0, 43968, '\P{^Is_Block=cherokeesupplement}', "");
    Expect(1, 43967, '\p{Is_Block=--Cherokee_supplement}', "");
    Expect(0, 43967, '\p{^Is_Block=--Cherokee_supplement}', "");
    Expect(0, 43967, '\P{Is_Block=--Cherokee_supplement}', "");
    Expect(1, 43967, '\P{^Is_Block=--Cherokee_supplement}', "");
    Expect(0, 43968, '\p{Is_Block=--Cherokee_supplement}', "");
    Expect(1, 43968, '\p{^Is_Block=--Cherokee_supplement}', "");
    Expect(1, 43968, '\P{Is_Block=--Cherokee_supplement}', "");
    Expect(0, 43968, '\P{^Is_Block=--Cherokee_supplement}', "");
    Error('\p{Is_Blk=/a/_ CHEROKEE_sup}');
    Error('\P{Is_Blk=/a/_ CHEROKEE_sup}');
    Expect(1, 43967, '\p{Is_Blk=cherokeesup}', "");
    Expect(0, 43967, '\p{^Is_Blk=cherokeesup}', "");
    Expect(0, 43967, '\P{Is_Blk=cherokeesup}', "");
    Expect(1, 43967, '\P{^Is_Blk=cherokeesup}', "");
    Expect(0, 43968, '\p{Is_Blk=cherokeesup}', "");
    Expect(1, 43968, '\p{^Is_Blk=cherokeesup}', "");
    Expect(1, 43968, '\P{Is_Blk=cherokeesup}', "");
    Expect(0, 43968, '\P{^Is_Blk=cherokeesup}', "");
    Expect(1, 43967, '\p{Is_Blk:   _cherokee_Sup}', "");
    Expect(0, 43967, '\p{^Is_Blk:   _cherokee_Sup}', "");
    Expect(0, 43967, '\P{Is_Blk:   _cherokee_Sup}', "");
    Expect(1, 43967, '\P{^Is_Blk:   _cherokee_Sup}', "");
    Expect(0, 43968, '\p{Is_Blk:   _cherokee_Sup}', "");
    Expect(1, 43968, '\p{^Is_Blk:   _cherokee_Sup}', "");
    Expect(1, 43968, '\P{Is_Blk:   _cherokee_Sup}', "");
    Expect(0, 43968, '\P{^Is_Blk:   _cherokee_Sup}', "");
    Error('\p{Block=/a/  Chess_SYMBOLS}');
    Error('\P{Block=/a/  Chess_SYMBOLS}');
    Expect(1, 129647, '\p{Block=:\AChess_Symbols\z:}', "");;
    Expect(0, 129648, '\p{Block=:\AChess_Symbols\z:}', "");;
    Expect(1, 129647, '\p{Block=chesssymbols}', "");
    Expect(0, 129647, '\p{^Block=chesssymbols}', "");
    Expect(0, 129647, '\P{Block=chesssymbols}', "");
    Expect(1, 129647, '\P{^Block=chesssymbols}', "");
    Expect(0, 129648, '\p{Block=chesssymbols}', "");
    Expect(1, 129648, '\p{^Block=chesssymbols}', "");
    Expect(1, 129648, '\P{Block=chesssymbols}', "");
    Expect(0, 129648, '\P{^Block=chesssymbols}', "");
    Expect(1, 129647, '\p{Block=:\Achesssymbols\z:}', "");;
    Expect(0, 129648, '\p{Block=:\Achesssymbols\z:}', "");;
    Expect(1, 129647, '\p{Block= Chess_symbols}', "");
    Expect(0, 129647, '\p{^Block= Chess_symbols}', "");
    Expect(0, 129647, '\P{Block= Chess_symbols}', "");
    Expect(1, 129647, '\P{^Block= Chess_symbols}', "");
    Expect(0, 129648, '\p{Block= Chess_symbols}', "");
    Expect(1, 129648, '\p{^Block= Chess_symbols}', "");
    Expect(1, 129648, '\P{Block= Chess_symbols}', "");
    Expect(0, 129648, '\P{^Block= Chess_symbols}', "");
    Error('\p{Blk=	Chess_Symbols/a/}');
    Error('\P{Blk=	Chess_Symbols/a/}');
    Expect(1, 129647, '\p{Blk=:\AChess_Symbols\z:}', "");;
    Expect(0, 129648, '\p{Blk=:\AChess_Symbols\z:}', "");;
    Expect(1, 129647, '\p{Blk=chesssymbols}', "");
    Expect(0, 129647, '\p{^Blk=chesssymbols}', "");
    Expect(0, 129647, '\P{Blk=chesssymbols}', "");
    Expect(1, 129647, '\P{^Blk=chesssymbols}', "");
    Expect(0, 129648, '\p{Blk=chesssymbols}', "");
    Expect(1, 129648, '\p{^Blk=chesssymbols}', "");
    Expect(1, 129648, '\P{Blk=chesssymbols}', "");
    Expect(0, 129648, '\P{^Blk=chesssymbols}', "");
    Expect(1, 129647, '\p{Blk=:\Achesssymbols\z:}', "");;
    Expect(0, 129648, '\p{Blk=:\Achesssymbols\z:}', "");;
    Expect(1, 129647, '\p{Blk=-	Chess_symbols}', "");
    Expect(0, 129647, '\p{^Blk=-	Chess_symbols}', "");
    Expect(0, 129647, '\P{Blk=-	Chess_symbols}', "");
    Expect(1, 129647, '\P{^Blk=-	Chess_symbols}', "");
    Expect(0, 129648, '\p{Blk=-	Chess_symbols}', "");
    Expect(1, 129648, '\p{^Blk=-	Chess_symbols}', "");
    Expect(1, 129648, '\P{Blk=-	Chess_symbols}', "");
    Expect(0, 129648, '\P{^Blk=-	Chess_symbols}', "");
    Error('\p{Is_Block= -Chess_SYMBOLS:=}');
    Error('\P{Is_Block= -Chess_SYMBOLS:=}');
    Expect(1, 129647, '\p{Is_Block=chesssymbols}', "");
    Expect(0, 129647, '\p{^Is_Block=chesssymbols}', "");
    Expect(0, 129647, '\P{Is_Block=chesssymbols}', "");
    Expect(1, 129647, '\P{^Is_Block=chesssymbols}', "");
    Expect(0, 129648, '\p{Is_Block=chesssymbols}', "");
    Expect(1, 129648, '\p{^Is_Block=chesssymbols}', "");
    Expect(1, 129648, '\P{Is_Block=chesssymbols}', "");
    Expect(0, 129648, '\P{^Is_Block=chesssymbols}', "");
    Expect(1, 129647, '\p{Is_Block=_-CHESS_SYMBOLS}', "");
    Expect(0, 129647, '\p{^Is_Block=_-CHESS_SYMBOLS}', "");
    Expect(0, 129647, '\P{Is_Block=_-CHESS_SYMBOLS}', "");
    Expect(1, 129647, '\P{^Is_Block=_-CHESS_SYMBOLS}', "");
    Expect(0, 129648, '\p{Is_Block=_-CHESS_SYMBOLS}', "");
    Expect(1, 129648, '\p{^Is_Block=_-CHESS_SYMBOLS}', "");
    Expect(1, 129648, '\P{Is_Block=_-CHESS_SYMBOLS}', "");
    Expect(0, 129648, '\P{^Is_Block=_-CHESS_SYMBOLS}', "");
    Error('\p{Is_Blk=/a/ _Chess_symbols}');
    Error('\P{Is_Blk=/a/ _Chess_symbols}');
    Expect(1, 129647, '\p{Is_Blk=chesssymbols}', "");
    Expect(0, 129647, '\p{^Is_Blk=chesssymbols}', "");
    Expect(0, 129647, '\P{Is_Blk=chesssymbols}', "");
    Expect(1, 129647, '\P{^Is_Blk=chesssymbols}', "");
    Expect(0, 129648, '\p{Is_Blk=chesssymbols}', "");
    Expect(1, 129648, '\p{^Is_Blk=chesssymbols}', "");
    Expect(1, 129648, '\P{Is_Blk=chesssymbols}', "");
    Expect(0, 129648, '\P{^Is_Blk=chesssymbols}', "");
    Expect(1, 129647, '\p{Is_Blk=	-Chess_SYMBOLS}', "");
    Expect(0, 129647, '\p{^Is_Blk=	-Chess_SYMBOLS}', "");
    Expect(0, 129647, '\P{Is_Blk=	-Chess_SYMBOLS}', "");
    Expect(1, 129647, '\P{^Is_Blk=	-Chess_SYMBOLS}', "");
    Expect(0, 129648, '\p{Is_Blk=	-Chess_SYMBOLS}', "");
    Expect(1, 129648, '\p{^Is_Blk=	-Chess_SYMBOLS}', "");
    Expect(1, 129648, '\P{Is_Blk=	-Chess_SYMBOLS}', "");
    Expect(0, 129648, '\P{^Is_Blk=	-Chess_SYMBOLS}', "");
    Error('\p{Block=/a/	CJK_Unified_Ideographs}');
    Error('\P{Block=/a/	CJK_Unified_Ideographs}');
    Expect(1, 40959, '\p{Block=:\ACJK_Unified_Ideographs\z:}', "");;
    Expect(0, 40960, '\p{Block=:\ACJK_Unified_Ideographs\z:}', "");;
    Expect(1, 40959, '\p{Block=cjkunifiedideographs}', "");
    Expect(0, 40959, '\p{^Block=cjkunifiedideographs}', "");
    Expect(0, 40959, '\P{Block=cjkunifiedideographs}', "");
    Expect(1, 40959, '\P{^Block=cjkunifiedideographs}', "");
    Expect(0, 40960, '\p{Block=cjkunifiedideographs}', "");
    Expect(1, 40960, '\p{^Block=cjkunifiedideographs}', "");
    Expect(1, 40960, '\P{Block=cjkunifiedideographs}', "");
    Expect(0, 40960, '\P{^Block=cjkunifiedideographs}', "");
    Expect(1, 40959, '\p{Block=:\Acjkunifiedideographs\z:}', "");;
    Expect(0, 40960, '\p{Block=:\Acjkunifiedideographs\z:}', "");;
    Expect(1, 40959, '\p{Block=	CJK_Unified_IDEOGRAPHS}', "");
    Expect(0, 40959, '\p{^Block=	CJK_Unified_IDEOGRAPHS}', "");
    Expect(0, 40959, '\P{Block=	CJK_Unified_IDEOGRAPHS}', "");
    Expect(1, 40959, '\P{^Block=	CJK_Unified_IDEOGRAPHS}', "");
    Expect(0, 40960, '\p{Block=	CJK_Unified_IDEOGRAPHS}', "");
    Expect(1, 40960, '\p{^Block=	CJK_Unified_IDEOGRAPHS}', "");
    Expect(1, 40960, '\P{Block=	CJK_Unified_IDEOGRAPHS}', "");
    Expect(0, 40960, '\P{^Block=	CJK_Unified_IDEOGRAPHS}', "");
    Error('\p{Blk: := 	CJK}');
    Error('\P{Blk: := 	CJK}');
    Expect(1, 40959, '\p{Blk=:\ACJK\z:}', "");;
    Expect(0, 40960, '\p{Blk=:\ACJK\z:}', "");;
    Expect(1, 40959, '\p{Blk=cjk}', "");
    Expect(0, 40959, '\p{^Blk=cjk}', "");
    Expect(0, 40959, '\P{Blk=cjk}', "");
    Expect(1, 40959, '\P{^Blk=cjk}', "");
    Expect(0, 40960, '\p{Blk=cjk}', "");
    Expect(1, 40960, '\p{^Blk=cjk}', "");
    Expect(1, 40960, '\P{Blk=cjk}', "");
    Expect(0, 40960, '\P{^Blk=cjk}', "");
    Expect(1, 40959, '\p{Blk=:\Acjk\z:}', "");;
    Expect(0, 40960, '\p{Blk=:\Acjk\z:}', "");;
    Expect(1, 40959, '\p{Blk=CJK}', "");
    Expect(0, 40959, '\p{^Blk=CJK}', "");
    Expect(0, 40959, '\P{Blk=CJK}', "");
    Expect(1, 40959, '\P{^Blk=CJK}', "");
    Expect(0, 40960, '\p{Blk=CJK}', "");
    Expect(1, 40960, '\p{^Blk=CJK}', "");
    Expect(1, 40960, '\P{Blk=CJK}', "");
    Expect(0, 40960, '\P{^Blk=CJK}', "");
    Error('\p{Is_Block=:=_ cjk_UNIFIED_Ideographs}');
    Error('\P{Is_Block=:=_ cjk_UNIFIED_Ideographs}');
    Expect(1, 40959, '\p{Is_Block=cjkunifiedideographs}', "");
    Expect(0, 40959, '\p{^Is_Block=cjkunifiedideographs}', "");
    Expect(0, 40959, '\P{Is_Block=cjkunifiedideographs}', "");
    Expect(1, 40959, '\P{^Is_Block=cjkunifiedideographs}', "");
    Expect(0, 40960, '\p{Is_Block=cjkunifiedideographs}', "");
    Expect(1, 40960, '\p{^Is_Block=cjkunifiedideographs}', "");
    Expect(1, 40960, '\P{Is_Block=cjkunifiedideographs}', "");
    Expect(0, 40960, '\P{^Is_Block=cjkunifiedideographs}', "");
    Expect(1, 40959, '\p{Is_Block=_	CJK_unified_ideographs}', "");
    Expect(0, 40959, '\p{^Is_Block=_	CJK_unified_ideographs}', "");
    Expect(0, 40959, '\P{Is_Block=_	CJK_unified_ideographs}', "");
    Expect(1, 40959, '\P{^Is_Block=_	CJK_unified_ideographs}', "");
    Expect(0, 40960, '\p{Is_Block=_	CJK_unified_ideographs}', "");
    Expect(1, 40960, '\p{^Is_Block=_	CJK_unified_ideographs}', "");
    Expect(1, 40960, '\P{Is_Block=_	CJK_unified_ideographs}', "");
    Expect(0, 40960, '\P{^Is_Block=_	CJK_unified_ideographs}', "");
    Error('\p{Is_Blk=_/a/CJK}');
    Error('\P{Is_Blk=_/a/CJK}');
    Expect(1, 40959, '\p{Is_Blk=cjk}', "");
    Expect(0, 40959, '\p{^Is_Blk=cjk}', "");
    Expect(0, 40959, '\P{Is_Blk=cjk}', "");
    Expect(1, 40959, '\P{^Is_Blk=cjk}', "");
    Expect(0, 40960, '\p{Is_Blk=cjk}', "");
    Expect(1, 40960, '\p{^Is_Blk=cjk}', "");
    Expect(1, 40960, '\P{Is_Blk=cjk}', "");
    Expect(0, 40960, '\P{^Is_Blk=cjk}', "");
    Expect(1, 40959, '\p{Is_Blk=	cjk}', "");
    Expect(0, 40959, '\p{^Is_Blk=	cjk}', "");
    Expect(0, 40959, '\P{Is_Blk=	cjk}', "");
    Expect(1, 40959, '\P{^Is_Blk=	cjk}', "");
    Expect(0, 40960, '\p{Is_Blk=	cjk}', "");
    Expect(1, 40960, '\p{^Is_Blk=	cjk}', "");
    Expect(1, 40960, '\P{Is_Blk=	cjk}', "");
    Expect(0, 40960, '\P{^Is_Blk=	cjk}', "");
    Error('\p{Block=	/a/cjk_Compatibility}');
    Error('\P{Block=	/a/cjk_Compatibility}');
    Expect(1, 13311, '\p{Block=:\ACJK_Compatibility\z:}', "");;
    Expect(0, 13312, '\p{Block=:\ACJK_Compatibility\z:}', "");;
    Expect(1, 13311, '\p{Block=cjkcompatibility}', "");
    Expect(0, 13311, '\p{^Block=cjkcompatibility}', "");
    Expect(0, 13311, '\P{Block=cjkcompatibility}', "");
    Expect(1, 13311, '\P{^Block=cjkcompatibility}', "");
    Expect(0, 13312, '\p{Block=cjkcompatibility}', "");
    Expect(1, 13312, '\p{^Block=cjkcompatibility}', "");
    Expect(1, 13312, '\P{Block=cjkcompatibility}', "");
    Expect(0, 13312, '\P{^Block=cjkcompatibility}', "");
    Expect(1, 13311, '\p{Block=:\Acjkcompatibility\z:}', "");;
    Expect(0, 13312, '\p{Block=:\Acjkcompatibility\z:}', "");;
    Expect(1, 13311, '\p{Block=cjk_Compatibility}', "");
    Expect(0, 13311, '\p{^Block=cjk_Compatibility}', "");
    Expect(0, 13311, '\P{Block=cjk_Compatibility}', "");
    Expect(1, 13311, '\P{^Block=cjk_Compatibility}', "");
    Expect(0, 13312, '\p{Block=cjk_Compatibility}', "");
    Expect(1, 13312, '\p{^Block=cjk_Compatibility}', "");
    Expect(1, 13312, '\P{Block=cjk_Compatibility}', "");
    Expect(0, 13312, '\P{^Block=cjk_Compatibility}', "");
    Error('\p{Blk= :=CJK_Compat}');
    Error('\P{Blk= :=CJK_Compat}');
    Expect(1, 13311, '\p{Blk=:\ACJK_Compat\z:}', "");;
    Expect(0, 13312, '\p{Blk=:\ACJK_Compat\z:}', "");;
    Expect(1, 13311, '\p{Blk=cjkcompat}', "");
    Expect(0, 13311, '\p{^Blk=cjkcompat}', "");
    Expect(0, 13311, '\P{Blk=cjkcompat}', "");
    Expect(1, 13311, '\P{^Blk=cjkcompat}', "");
    Expect(0, 13312, '\p{Blk=cjkcompat}', "");
    Expect(1, 13312, '\p{^Blk=cjkcompat}', "");
    Expect(1, 13312, '\P{Blk=cjkcompat}', "");
    Expect(0, 13312, '\P{^Blk=cjkcompat}', "");
    Expect(1, 13311, '\p{Blk=:\Acjkcompat\z:}', "");;
    Expect(0, 13312, '\p{Blk=:\Acjkcompat\z:}', "");;
    Expect(1, 13311, '\p{Blk=		CJK_Compat}', "");
    Expect(0, 13311, '\p{^Blk=		CJK_Compat}', "");
    Expect(0, 13311, '\P{Blk=		CJK_Compat}', "");
    Expect(1, 13311, '\P{^Blk=		CJK_Compat}', "");
    Expect(0, 13312, '\p{Blk=		CJK_Compat}', "");
    Expect(1, 13312, '\p{^Blk=		CJK_Compat}', "");
    Expect(1, 13312, '\P{Blk=		CJK_Compat}', "");
    Expect(0, 13312, '\P{^Blk=		CJK_Compat}', "");
    Error('\p{Is_Block=/a/cjk_COMPATIBILITY}');
    Error('\P{Is_Block=/a/cjk_COMPATIBILITY}');
    Expect(1, 13311, '\p{Is_Block=cjkcompatibility}', "");
    Expect(0, 13311, '\p{^Is_Block=cjkcompatibility}', "");
    Expect(0, 13311, '\P{Is_Block=cjkcompatibility}', "");
    Expect(1, 13311, '\P{^Is_Block=cjkcompatibility}', "");
    Expect(0, 13312, '\p{Is_Block=cjkcompatibility}', "");
    Expect(1, 13312, '\p{^Is_Block=cjkcompatibility}', "");
    Expect(1, 13312, '\P{Is_Block=cjkcompatibility}', "");
    Expect(0, 13312, '\P{^Is_Block=cjkcompatibility}', "");
    Expect(1, 13311, '\p{Is_Block=__CJK_COMPATIBILITY}', "");
    Expect(0, 13311, '\p{^Is_Block=__CJK_COMPATIBILITY}', "");
    Expect(0, 13311, '\P{Is_Block=__CJK_COMPATIBILITY}', "");
    Expect(1, 13311, '\P{^Is_Block=__CJK_COMPATIBILITY}', "");
    Expect(0, 13312, '\p{Is_Block=__CJK_COMPATIBILITY}', "");
    Expect(1, 13312, '\p{^Is_Block=__CJK_COMPATIBILITY}', "");
    Expect(1, 13312, '\P{Is_Block=__CJK_COMPATIBILITY}', "");
    Expect(0, 13312, '\P{^Is_Block=__CJK_COMPATIBILITY}', "");
    Error('\p{Is_Blk=:=_ CJK_Compat}');
    Error('\P{Is_Blk=:=_ CJK_Compat}');
    Expect(1, 13311, '\p{Is_Blk=cjkcompat}', "");
    Expect(0, 13311, '\p{^Is_Blk=cjkcompat}', "");
    Expect(0, 13311, '\P{Is_Blk=cjkcompat}', "");
    Expect(1, 13311, '\P{^Is_Blk=cjkcompat}', "");
    Expect(0, 13312, '\p{Is_Blk=cjkcompat}', "");
    Expect(1, 13312, '\p{^Is_Blk=cjkcompat}', "");
    Expect(1, 13312, '\P{Is_Blk=cjkcompat}', "");
    Expect(0, 13312, '\P{^Is_Blk=cjkcompat}', "");
    Expect(1, 13311, '\p{Is_Blk: -_CJK_compat}', "");
    Expect(0, 13311, '\p{^Is_Blk: -_CJK_compat}', "");
    Expect(0, 13311, '\P{Is_Blk: -_CJK_compat}', "");
    Expect(1, 13311, '\P{^Is_Blk: -_CJK_compat}', "");
    Expect(0, 13312, '\p{Is_Blk: -_CJK_compat}', "");
    Expect(1, 13312, '\p{^Is_Blk: -_CJK_compat}', "");
    Expect(1, 13312, '\P{Is_Blk: -_CJK_compat}', "");
    Expect(0, 13312, '\P{^Is_Blk: -_CJK_compat}', "");
    Error('\p{Block::=_-cjk_Compatibility_forms}');
    Error('\P{Block::=_-cjk_Compatibility_forms}');
    Expect(1, 65103, '\p{Block=:\ACJK_Compatibility_Forms\z:}', "");;
    Expect(0, 65104, '\p{Block=:\ACJK_Compatibility_Forms\z:}', "");;
    Expect(1, 65103, '\p{Block=cjkcompatibilityforms}', "");
    Expect(0, 65103, '\p{^Block=cjkcompatibilityforms}', "");
    Expect(0, 65103, '\P{Block=cjkcompatibilityforms}', "");
    Expect(1, 65103, '\P{^Block=cjkcompatibilityforms}', "");
    Expect(0, 65104, '\p{Block=cjkcompatibilityforms}', "");
    Expect(1, 65104, '\p{^Block=cjkcompatibilityforms}', "");
    Expect(1, 65104, '\P{Block=cjkcompatibilityforms}', "");
    Expect(0, 65104, '\P{^Block=cjkcompatibilityforms}', "");
    Expect(1, 65103, '\p{Block=:\Acjkcompatibilityforms\z:}', "");;
    Expect(0, 65104, '\p{Block=:\Acjkcompatibilityforms\z:}', "");;
    Expect(1, 65103, '\p{Block=_ CJK_Compatibility_forms}', "");
    Expect(0, 65103, '\p{^Block=_ CJK_Compatibility_forms}', "");
    Expect(0, 65103, '\P{Block=_ CJK_Compatibility_forms}', "");
    Expect(1, 65103, '\P{^Block=_ CJK_Compatibility_forms}', "");
    Expect(0, 65104, '\p{Block=_ CJK_Compatibility_forms}', "");
    Expect(1, 65104, '\p{^Block=_ CJK_Compatibility_forms}', "");
    Expect(1, 65104, '\P{Block=_ CJK_Compatibility_forms}', "");
    Expect(0, 65104, '\P{^Block=_ CJK_Compatibility_forms}', "");
    Error('\p{Blk=:=- CJK_compat_FORMS}');
    Error('\P{Blk=:=- CJK_compat_FORMS}');
    Expect(1, 65103, '\p{Blk=:\ACJK_Compat_Forms\z:}', "");;
    Expect(0, 65104, '\p{Blk=:\ACJK_Compat_Forms\z:}', "");;
    Expect(1, 65103, '\p{Blk=cjkcompatforms}', "");
    Expect(0, 65103, '\p{^Blk=cjkcompatforms}', "");
    Expect(0, 65103, '\P{Blk=cjkcompatforms}', "");
    Expect(1, 65103, '\P{^Blk=cjkcompatforms}', "");
    Expect(0, 65104, '\p{Blk=cjkcompatforms}', "");
    Expect(1, 65104, '\p{^Blk=cjkcompatforms}', "");
    Expect(1, 65104, '\P{Blk=cjkcompatforms}', "");
    Expect(0, 65104, '\P{^Blk=cjkcompatforms}', "");
    Expect(1, 65103, '\p{Blk=:\Acjkcompatforms\z:}', "");;
    Expect(0, 65104, '\p{Blk=:\Acjkcompatforms\z:}', "");;
    Expect(1, 65103, '\p{Blk=_ CJK_Compat_FORMS}', "");
    Expect(0, 65103, '\p{^Blk=_ CJK_Compat_FORMS}', "");
    Expect(0, 65103, '\P{Blk=_ CJK_Compat_FORMS}', "");
    Expect(1, 65103, '\P{^Blk=_ CJK_Compat_FORMS}', "");
    Expect(0, 65104, '\p{Blk=_ CJK_Compat_FORMS}', "");
    Expect(1, 65104, '\p{^Blk=_ CJK_Compat_FORMS}', "");
    Expect(1, 65104, '\P{Blk=_ CJK_Compat_FORMS}', "");
    Expect(0, 65104, '\P{^Blk=_ CJK_Compat_FORMS}', "");
    Error('\p{Is_Block=:= _CJK_COMPATIBILITY_Forms}');
    Error('\P{Is_Block=:= _CJK_COMPATIBILITY_Forms}');
    Expect(1, 65103, '\p{Is_Block=cjkcompatibilityforms}', "");
    Expect(0, 65103, '\p{^Is_Block=cjkcompatibilityforms}', "");
    Expect(0, 65103, '\P{Is_Block=cjkcompatibilityforms}', "");
    Expect(1, 65103, '\P{^Is_Block=cjkcompatibilityforms}', "");
    Expect(0, 65104, '\p{Is_Block=cjkcompatibilityforms}', "");
    Expect(1, 65104, '\p{^Is_Block=cjkcompatibilityforms}', "");
    Expect(1, 65104, '\P{Is_Block=cjkcompatibilityforms}', "");
    Expect(0, 65104, '\P{^Is_Block=cjkcompatibilityforms}', "");
    Expect(1, 65103, '\p{Is_Block=	cjk_Compatibility_forms}', "");
    Expect(0, 65103, '\p{^Is_Block=	cjk_Compatibility_forms}', "");
    Expect(0, 65103, '\P{Is_Block=	cjk_Compatibility_forms}', "");
    Expect(1, 65103, '\P{^Is_Block=	cjk_Compatibility_forms}', "");
    Expect(0, 65104, '\p{Is_Block=	cjk_Compatibility_forms}', "");
    Expect(1, 65104, '\p{^Is_Block=	cjk_Compatibility_forms}', "");
    Expect(1, 65104, '\P{Is_Block=	cjk_Compatibility_forms}', "");
    Expect(0, 65104, '\P{^Is_Block=	cjk_Compatibility_forms}', "");
    Error('\p{Is_Blk:   CJK_COMPAT_forms/a/}');
    Error('\P{Is_Blk:   CJK_COMPAT_forms/a/}');
    Expect(1, 65103, '\p{Is_Blk=cjkcompatforms}', "");
    Expect(0, 65103, '\p{^Is_Blk=cjkcompatforms}', "");
    Expect(0, 65103, '\P{Is_Blk=cjkcompatforms}', "");
    Expect(1, 65103, '\P{^Is_Blk=cjkcompatforms}', "");
    Expect(0, 65104, '\p{Is_Blk=cjkcompatforms}', "");
    Expect(1, 65104, '\p{^Is_Blk=cjkcompatforms}', "");
    Expect(1, 65104, '\P{Is_Blk=cjkcompatforms}', "");
    Expect(0, 65104, '\P{^Is_Blk=cjkcompatforms}', "");
    Expect(1, 65103, '\p{Is_Blk=_ CJK_compat_FORMS}', "");
    Expect(0, 65103, '\p{^Is_Blk=_ CJK_compat_FORMS}', "");
    Expect(0, 65103, '\P{Is_Blk=_ CJK_compat_FORMS}', "");
    Expect(1, 65103, '\P{^Is_Blk=_ CJK_compat_FORMS}', "");
    Expect(0, 65104, '\p{Is_Blk=_ CJK_compat_FORMS}', "");
    Expect(1, 65104, '\p{^Is_Blk=_ CJK_compat_FORMS}', "");
    Expect(1, 65104, '\P{Is_Blk=_ CJK_compat_FORMS}', "");
    Expect(0, 65104, '\P{^Is_Blk=_ CJK_compat_FORMS}', "");
    Error('\p{Block=	/a/CJK_COMPATIBILITY_ideographs}');
    Error('\P{Block=	/a/CJK_COMPATIBILITY_ideographs}');
    Expect(1, 64255, '\p{Block=:\ACJK_Compatibility_Ideographs\z:}', "");;
    Expect(0, 64256, '\p{Block=:\ACJK_Compatibility_Ideographs\z:}', "");;
    Expect(1, 64255, '\p{Block:cjkcompatibilityideographs}', "");
    Expect(0, 64255, '\p{^Block:cjkcompatibilityideographs}', "");
    Expect(0, 64255, '\P{Block:cjkcompatibilityideographs}', "");
    Expect(1, 64255, '\P{^Block:cjkcompatibilityideographs}', "");
    Expect(0, 64256, '\p{Block:cjkcompatibilityideographs}', "");
    Expect(1, 64256, '\p{^Block:cjkcompatibilityideographs}', "");
    Expect(1, 64256, '\P{Block:cjkcompatibilityideographs}', "");
    Expect(0, 64256, '\P{^Block:cjkcompatibilityideographs}', "");
    Expect(1, 64255, '\p{Block=:\Acjkcompatibilityideographs\z:}', "");;
    Expect(0, 64256, '\p{Block=:\Acjkcompatibilityideographs\z:}', "");;
    Expect(1, 64255, '\p{Block=_ cjk_Compatibility_Ideographs}', "");
    Expect(0, 64255, '\p{^Block=_ cjk_Compatibility_Ideographs}', "");
    Expect(0, 64255, '\P{Block=_ cjk_Compatibility_Ideographs}', "");
    Expect(1, 64255, '\P{^Block=_ cjk_Compatibility_Ideographs}', "");
    Expect(0, 64256, '\p{Block=_ cjk_Compatibility_Ideographs}', "");
    Expect(1, 64256, '\p{^Block=_ cjk_Compatibility_Ideographs}', "");
    Expect(1, 64256, '\P{Block=_ cjk_Compatibility_Ideographs}', "");
    Expect(0, 64256, '\P{^Block=_ cjk_Compatibility_Ideographs}', "");
    Error('\p{Blk=	/a/CJK_Compat_Ideographs}');
    Error('\P{Blk=	/a/CJK_Compat_Ideographs}');
    Expect(1, 64255, '\p{Blk=:\ACJK_Compat_Ideographs\z:}', "");;
    Expect(0, 64256, '\p{Blk=:\ACJK_Compat_Ideographs\z:}', "");;
    Expect(1, 64255, '\p{Blk=cjkcompatideographs}', "");
    Expect(0, 64255, '\p{^Blk=cjkcompatideographs}', "");
    Expect(0, 64255, '\P{Blk=cjkcompatideographs}', "");
    Expect(1, 64255, '\P{^Blk=cjkcompatideographs}', "");
    Expect(0, 64256, '\p{Blk=cjkcompatideographs}', "");
    Expect(1, 64256, '\p{^Blk=cjkcompatideographs}', "");
    Expect(1, 64256, '\P{Blk=cjkcompatideographs}', "");
    Expect(0, 64256, '\P{^Blk=cjkcompatideographs}', "");
    Expect(1, 64255, '\p{Blk=:\Acjkcompatideographs\z:}', "");;
    Expect(0, 64256, '\p{Blk=:\Acjkcompatideographs\z:}', "");;
    Expect(1, 64255, '\p{Blk=CJK_Compat_ideographs}', "");
    Expect(0, 64255, '\p{^Blk=CJK_Compat_ideographs}', "");
    Expect(0, 64255, '\P{Blk=CJK_Compat_ideographs}', "");
    Expect(1, 64255, '\P{^Blk=CJK_Compat_ideographs}', "");
    Expect(0, 64256, '\p{Blk=CJK_Compat_ideographs}', "");
    Expect(1, 64256, '\p{^Blk=CJK_Compat_ideographs}', "");
    Expect(1, 64256, '\P{Blk=CJK_Compat_ideographs}', "");
    Expect(0, 64256, '\P{^Blk=CJK_Compat_ideographs}', "");
    Error('\p{Is_Block=/a/		CJK_COMPATIBILITY_Ideographs}');
    Error('\P{Is_Block=/a/		CJK_COMPATIBILITY_Ideographs}');
    Expect(1, 64255, '\p{Is_Block=cjkcompatibilityideographs}', "");
    Expect(0, 64255, '\p{^Is_Block=cjkcompatibilityideographs}', "");
    Expect(0, 64255, '\P{Is_Block=cjkcompatibilityideographs}', "");
    Expect(1, 64255, '\P{^Is_Block=cjkcompatibilityideographs}', "");
    Expect(0, 64256, '\p{Is_Block=cjkcompatibilityideographs}', "");
    Expect(1, 64256, '\p{^Is_Block=cjkcompatibilityideographs}', "");
    Expect(1, 64256, '\P{Is_Block=cjkcompatibilityideographs}', "");
    Expect(0, 64256, '\P{^Is_Block=cjkcompatibilityideographs}', "");
    Expect(1, 64255, '\p{Is_Block=-_CJK_Compatibility_Ideographs}', "");
    Expect(0, 64255, '\p{^Is_Block=-_CJK_Compatibility_Ideographs}', "");
    Expect(0, 64255, '\P{Is_Block=-_CJK_Compatibility_Ideographs}', "");
    Expect(1, 64255, '\P{^Is_Block=-_CJK_Compatibility_Ideographs}', "");
    Expect(0, 64256, '\p{Is_Block=-_CJK_Compatibility_Ideographs}', "");
    Expect(1, 64256, '\p{^Is_Block=-_CJK_Compatibility_Ideographs}', "");
    Expect(1, 64256, '\P{Is_Block=-_CJK_Compatibility_Ideographs}', "");
    Expect(0, 64256, '\P{^Is_Block=-_CJK_Compatibility_Ideographs}', "");
    Error('\p{Is_Blk=:= _cjk_Compat_IDEOGRAPHS}');
    Error('\P{Is_Blk=:= _cjk_Compat_IDEOGRAPHS}');
    Expect(1, 64255, '\p{Is_Blk=cjkcompatideographs}', "");
    Expect(0, 64255, '\p{^Is_Blk=cjkcompatideographs}', "");
    Expect(0, 64255, '\P{Is_Blk=cjkcompatideographs}', "");
    Expect(1, 64255, '\P{^Is_Blk=cjkcompatideographs}', "");
    Expect(0, 64256, '\p{Is_Blk=cjkcompatideographs}', "");
    Expect(1, 64256, '\p{^Is_Blk=cjkcompatideographs}', "");
    Expect(1, 64256, '\P{Is_Blk=cjkcompatideographs}', "");
    Expect(0, 64256, '\P{^Is_Blk=cjkcompatideographs}', "");
    Expect(1, 64255, '\p{Is_Blk= 	cjk_Compat_ideographs}', "");
    Expect(0, 64255, '\p{^Is_Blk= 	cjk_Compat_ideographs}', "");
    Expect(0, 64255, '\P{Is_Blk= 	cjk_Compat_ideographs}', "");
    Expect(1, 64255, '\P{^Is_Blk= 	cjk_Compat_ideographs}', "");
    Expect(0, 64256, '\p{Is_Blk= 	cjk_Compat_ideographs}', "");
    Expect(1, 64256, '\p{^Is_Blk= 	cjk_Compat_ideographs}', "");
    Expect(1, 64256, '\P{Is_Blk= 	cjk_Compat_ideographs}', "");
    Expect(0, 64256, '\P{^Is_Blk= 	cjk_Compat_ideographs}', "");
    Error('\p{Block=	 CJK_compatibility_IDEOGRAPHS_supplement:=}');
    Error('\P{Block=	 CJK_compatibility_IDEOGRAPHS_supplement:=}');
    Expect(1, 195103, '\p{Block=:\ACJK_Compatibility_Ideographs_Supplement\z:}', "");;
    Expect(0, 195104, '\p{Block=:\ACJK_Compatibility_Ideographs_Supplement\z:}', "");;
    Expect(1, 195103, '\p{Block: cjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\p{^Block: cjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\P{Block: cjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\P{^Block: cjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\p{Block: cjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\p{^Block: cjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\P{Block: cjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\P{^Block: cjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\p{Block=:\Acjkcompatibilityideographssupplement\z:}', "");;
    Expect(0, 195104, '\p{Block=:\Acjkcompatibilityideographssupplement\z:}', "");;
    Expect(1, 195103, '\p{Block=	CJK_COMPATIBILITY_ideographs_SUPPLEMENT}', "");
    Expect(0, 195103, '\p{^Block=	CJK_COMPATIBILITY_ideographs_SUPPLEMENT}', "");
    Expect(0, 195103, '\P{Block=	CJK_COMPATIBILITY_ideographs_SUPPLEMENT}', "");
    Expect(1, 195103, '\P{^Block=	CJK_COMPATIBILITY_ideographs_SUPPLEMENT}', "");
    Expect(0, 195104, '\p{Block=	CJK_COMPATIBILITY_ideographs_SUPPLEMENT}', "");
    Expect(1, 195104, '\p{^Block=	CJK_COMPATIBILITY_ideographs_SUPPLEMENT}', "");
    Expect(1, 195104, '\P{Block=	CJK_COMPATIBILITY_ideographs_SUPPLEMENT}', "");
    Expect(0, 195104, '\P{^Block=	CJK_COMPATIBILITY_ideographs_SUPPLEMENT}', "");
    Error('\p{Blk=:=_	CJK_COMPAT_Ideographs_Sup}');
    Error('\P{Blk=:=_	CJK_COMPAT_Ideographs_Sup}');
    Expect(1, 195103, '\p{Blk=:\ACJK_Compat_Ideographs_Sup\z:}', "");;
    Expect(0, 195104, '\p{Blk=:\ACJK_Compat_Ideographs_Sup\z:}', "");;
    Expect(1, 195103, '\p{Blk=cjkcompatideographssup}', "");
    Expect(0, 195103, '\p{^Blk=cjkcompatideographssup}', "");
    Expect(0, 195103, '\P{Blk=cjkcompatideographssup}', "");
    Expect(1, 195103, '\P{^Blk=cjkcompatideographssup}', "");
    Expect(0, 195104, '\p{Blk=cjkcompatideographssup}', "");
    Expect(1, 195104, '\p{^Blk=cjkcompatideographssup}', "");
    Expect(1, 195104, '\P{Blk=cjkcompatideographssup}', "");
    Expect(0, 195104, '\P{^Blk=cjkcompatideographssup}', "");
    Expect(1, 195103, '\p{Blk=:\Acjkcompatideographssup\z:}', "");;
    Expect(0, 195104, '\p{Blk=:\Acjkcompatideographssup\z:}', "");;
    Expect(1, 195103, '\p{Blk: --CJK_Compat_ideographs_Sup}', "");
    Expect(0, 195103, '\p{^Blk: --CJK_Compat_ideographs_Sup}', "");
    Expect(0, 195103, '\P{Blk: --CJK_Compat_ideographs_Sup}', "");
    Expect(1, 195103, '\P{^Blk: --CJK_Compat_ideographs_Sup}', "");
    Expect(0, 195104, '\p{Blk: --CJK_Compat_ideographs_Sup}', "");
    Expect(1, 195104, '\p{^Blk: --CJK_Compat_ideographs_Sup}', "");
    Expect(1, 195104, '\P{Blk: --CJK_Compat_ideographs_Sup}', "");
    Expect(0, 195104, '\P{^Blk: --CJK_Compat_ideographs_Sup}', "");
    Error('\p{Is_Block=:=CJK_compatibility_Ideographs_Supplement}');
    Error('\P{Is_Block=:=CJK_compatibility_Ideographs_Supplement}');
    Expect(1, 195103, '\p{Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\p{^Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\P{Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\P{^Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\p{Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\p{^Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\P{Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\P{^Is_Block=cjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\p{Is_Block=	CJK_Compatibility_Ideographs_SUPPLEMENT}', "");
    Expect(0, 195103, '\p{^Is_Block=	CJK_Compatibility_Ideographs_SUPPLEMENT}', "");
    Expect(0, 195103, '\P{Is_Block=	CJK_Compatibility_Ideographs_SUPPLEMENT}', "");
    Expect(1, 195103, '\P{^Is_Block=	CJK_Compatibility_Ideographs_SUPPLEMENT}', "");
    Expect(0, 195104, '\p{Is_Block=	CJK_Compatibility_Ideographs_SUPPLEMENT}', "");
    Expect(1, 195104, '\p{^Is_Block=	CJK_Compatibility_Ideographs_SUPPLEMENT}', "");
    Expect(1, 195104, '\P{Is_Block=	CJK_Compatibility_Ideographs_SUPPLEMENT}', "");
    Expect(0, 195104, '\P{^Is_Block=	CJK_Compatibility_Ideographs_SUPPLEMENT}', "");
    Error('\p{Is_Blk:   	 CJK_compat_ideographs_Sup/a/}');
    Error('\P{Is_Blk:   	 CJK_compat_ideographs_Sup/a/}');
    Expect(1, 195103, '\p{Is_Blk=cjkcompatideographssup}', "");
    Expect(0, 195103, '\p{^Is_Blk=cjkcompatideographssup}', "");
    Expect(0, 195103, '\P{Is_Blk=cjkcompatideographssup}', "");
    Expect(1, 195103, '\P{^Is_Blk=cjkcompatideographssup}', "");
    Expect(0, 195104, '\p{Is_Blk=cjkcompatideographssup}', "");
    Expect(1, 195104, '\p{^Is_Blk=cjkcompatideographssup}', "");
    Expect(1, 195104, '\P{Is_Blk=cjkcompatideographssup}', "");
    Expect(0, 195104, '\P{^Is_Blk=cjkcompatideographssup}', "");
    Expect(1, 195103, '\p{Is_Blk=CJK_compat_ideographs_SUP}', "");
    Expect(0, 195103, '\p{^Is_Blk=CJK_compat_ideographs_SUP}', "");
    Expect(0, 195103, '\P{Is_Blk=CJK_compat_ideographs_SUP}', "");
    Expect(1, 195103, '\P{^Is_Blk=CJK_compat_ideographs_SUP}', "");
    Expect(0, 195104, '\p{Is_Blk=CJK_compat_ideographs_SUP}', "");
    Expect(1, 195104, '\p{^Is_Blk=CJK_compat_ideographs_SUP}', "");
    Expect(1, 195104, '\P{Is_Blk=CJK_compat_ideographs_SUP}', "");
    Expect(0, 195104, '\P{^Is_Blk=CJK_compat_ideographs_SUP}', "");
    Error('\p{Block=:=  cjk_unified_Ideographs_Extension_A}');
    Error('\P{Block=:=  cjk_unified_Ideographs_Extension_A}');
    Expect(1, 19903, '\p{Block=:\ACJK_Unified_Ideographs_Extension_A\z:}', "");;
    Expect(0, 19904, '\p{Block=:\ACJK_Unified_Ideographs_Extension_A\z:}', "");;
    Expect(1, 19903, '\p{Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\p{^Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\P{Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\P{^Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\p{Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\p{^Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\P{Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\P{^Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\p{Block=:\Acjkunifiedideographsextensiona\z:}', "");;
    Expect(0, 19904, '\p{Block=:\Acjkunifiedideographsextensiona\z:}', "");;
    Expect(1, 19903, '\p{Block=_	CJK_Unified_IDEOGRAPHS_Extension_A}', "");
    Expect(0, 19903, '\p{^Block=_	CJK_Unified_IDEOGRAPHS_Extension_A}', "");
    Expect(0, 19903, '\P{Block=_	CJK_Unified_IDEOGRAPHS_Extension_A}', "");
    Expect(1, 19903, '\P{^Block=_	CJK_Unified_IDEOGRAPHS_Extension_A}', "");
    Expect(0, 19904, '\p{Block=_	CJK_Unified_IDEOGRAPHS_Extension_A}', "");
    Expect(1, 19904, '\p{^Block=_	CJK_Unified_IDEOGRAPHS_Extension_A}', "");
    Expect(1, 19904, '\P{Block=_	CJK_Unified_IDEOGRAPHS_Extension_A}', "");
    Expect(0, 19904, '\P{^Block=_	CJK_Unified_IDEOGRAPHS_Extension_A}', "");
    Error('\p{Blk=:=	 CJK_EXT_A}');
    Error('\P{Blk=:=	 CJK_EXT_A}');
    Expect(1, 19903, '\p{Blk=:\ACJK_Ext_A\z:}', "");;
    Expect(0, 19904, '\p{Blk=:\ACJK_Ext_A\z:}', "");;
    Expect(1, 19903, '\p{Blk=cjkexta}', "");
    Expect(0, 19903, '\p{^Blk=cjkexta}', "");
    Expect(0, 19903, '\P{Blk=cjkexta}', "");
    Expect(1, 19903, '\P{^Blk=cjkexta}', "");
    Expect(0, 19904, '\p{Blk=cjkexta}', "");
    Expect(1, 19904, '\p{^Blk=cjkexta}', "");
    Expect(1, 19904, '\P{Blk=cjkexta}', "");
    Expect(0, 19904, '\P{^Blk=cjkexta}', "");
    Expect(1, 19903, '\p{Blk=:\Acjkexta\z:}', "");;
    Expect(0, 19904, '\p{Blk=:\Acjkexta\z:}', "");;
    Expect(1, 19903, '\p{Blk=		CJK_Ext_A}', "");
    Expect(0, 19903, '\p{^Blk=		CJK_Ext_A}', "");
    Expect(0, 19903, '\P{Blk=		CJK_Ext_A}', "");
    Expect(1, 19903, '\P{^Blk=		CJK_Ext_A}', "");
    Expect(0, 19904, '\p{Blk=		CJK_Ext_A}', "");
    Expect(1, 19904, '\p{^Blk=		CJK_Ext_A}', "");
    Expect(1, 19904, '\P{Blk=		CJK_Ext_A}', "");
    Expect(0, 19904, '\P{^Blk=		CJK_Ext_A}', "");
    Error('\p{Is_Block=:=		cjk_Unified_Ideographs_Extension_A}');
    Error('\P{Is_Block=:=		cjk_Unified_Ideographs_Extension_A}');
    Expect(1, 19903, '\p{Is_Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\p{^Is_Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\P{Is_Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\P{^Is_Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\p{Is_Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\p{^Is_Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\P{Is_Block=cjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\P{^Is_Block=cjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\p{Is_Block= -CJK_Unified_IDEOGRAPHS_Extension_A}', "");
    Expect(0, 19903, '\p{^Is_Block= -CJK_Unified_IDEOGRAPHS_Extension_A}', "");
    Expect(0, 19903, '\P{Is_Block= -CJK_Unified_IDEOGRAPHS_Extension_A}', "");
    Expect(1, 19903, '\P{^Is_Block= -CJK_Unified_IDEOGRAPHS_Extension_A}', "");
    Expect(0, 19904, '\p{Is_Block= -CJK_Unified_IDEOGRAPHS_Extension_A}', "");
    Expect(1, 19904, '\p{^Is_Block= -CJK_Unified_IDEOGRAPHS_Extension_A}', "");
    Expect(1, 19904, '\P{Is_Block= -CJK_Unified_IDEOGRAPHS_Extension_A}', "");
    Expect(0, 19904, '\P{^Is_Block= -CJK_Unified_IDEOGRAPHS_Extension_A}', "");
    Error('\p{Is_Blk=-/a/cjk_Ext_A}');
    Error('\P{Is_Blk=-/a/cjk_Ext_A}');
    Expect(1, 19903, '\p{Is_Blk=cjkexta}', "");
    Expect(0, 19903, '\p{^Is_Blk=cjkexta}', "");
    Expect(0, 19903, '\P{Is_Blk=cjkexta}', "");
    Expect(1, 19903, '\P{^Is_Blk=cjkexta}', "");
    Expect(0, 19904, '\p{Is_Blk=cjkexta}', "");
    Expect(1, 19904, '\p{^Is_Blk=cjkexta}', "");
    Expect(1, 19904, '\P{Is_Blk=cjkexta}', "");
    Expect(0, 19904, '\P{^Is_Blk=cjkexta}', "");
    Expect(1, 19903, '\p{Is_Blk=_CJK_EXT_A}', "");
    Expect(0, 19903, '\p{^Is_Blk=_CJK_EXT_A}', "");
    Expect(0, 19903, '\P{Is_Blk=_CJK_EXT_A}', "");
    Expect(1, 19903, '\P{^Is_Blk=_CJK_EXT_A}', "");
    Expect(0, 19904, '\p{Is_Blk=_CJK_EXT_A}', "");
    Expect(1, 19904, '\p{^Is_Blk=_CJK_EXT_A}', "");
    Expect(1, 19904, '\P{Is_Blk=_CJK_EXT_A}', "");
    Expect(0, 19904, '\P{^Is_Blk=_CJK_EXT_A}', "");
    Error('\p{Block=/a/ -cjk_Unified_Ideographs_EXTENSION_B}');
    Error('\P{Block=/a/ -cjk_Unified_Ideographs_EXTENSION_B}');
    Expect(1, 173791, '\p{Block=:\ACJK_Unified_Ideographs_Extension_B\z:}', "");;
    Expect(0, 173792, '\p{Block=:\ACJK_Unified_Ideographs_Extension_B\z:}', "");;
    Expect(1, 173791, '\p{Block=cjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\p{^Block=cjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\P{Block=cjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\P{^Block=cjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\p{Block=cjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\p{^Block=cjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\P{Block=cjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\P{^Block=cjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\p{Block=:\Acjkunifiedideographsextensionb\z:}', "");;
    Expect(0, 173792, '\p{Block=:\Acjkunifiedideographsextensionb\z:}', "");;
    Expect(1, 173791, '\p{Block=-	CJK_Unified_Ideographs_EXTENSION_B}', "");
    Expect(0, 173791, '\p{^Block=-	CJK_Unified_Ideographs_EXTENSION_B}', "");
    Expect(0, 173791, '\P{Block=-	CJK_Unified_Ideographs_EXTENSION_B}', "");
    Expect(1, 173791, '\P{^Block=-	CJK_Unified_Ideographs_EXTENSION_B}', "");
    Expect(0, 173792, '\p{Block=-	CJK_Unified_Ideographs_EXTENSION_B}', "");
    Expect(1, 173792, '\p{^Block=-	CJK_Unified_Ideographs_EXTENSION_B}', "");
    Expect(1, 173792, '\P{Block=-	CJK_Unified_Ideographs_EXTENSION_B}', "");
    Expect(0, 173792, '\P{^Block=-	CJK_Unified_Ideographs_EXTENSION_B}', "");
    Error('\p{Blk=	-CJK_EXT_B/a/}');
    Error('\P{Blk=	-CJK_EXT_B/a/}');
    Expect(1, 173791, '\p{Blk=:\ACJK_Ext_B\z:}', "");;
    Expect(0, 173792, '\p{Blk=:\ACJK_Ext_B\z:}', "");;
    Expect(1, 173791, '\p{Blk=cjkextb}', "");
    Expect(0, 173791, '\p{^Blk=cjkextb}', "");
    Expect(0, 173791, '\P{Blk=cjkextb}', "");
    Expect(1, 173791, '\P{^Blk=cjkextb}', "");
    Expect(0, 173792, '\p{Blk=cjkextb}', "");
    Expect(1, 173792, '\p{^Blk=cjkextb}', "");
    Expect(1, 173792, '\P{Blk=cjkextb}', "");
    Expect(0, 173792, '\P{^Blk=cjkextb}', "");
    Expect(1, 173791, '\p{Blk=:\Acjkextb\z:}', "");;
    Expect(0, 173792, '\p{Blk=:\Acjkextb\z:}', "");;
    Expect(1, 173791, '\p{Blk=--CJK_ext_B}', "");
    Expect(0, 173791, '\p{^Blk=--CJK_ext_B}', "");
    Expect(0, 173791, '\P{Blk=--CJK_ext_B}', "");
    Expect(1, 173791, '\P{^Blk=--CJK_ext_B}', "");
    Expect(0, 173792, '\p{Blk=--CJK_ext_B}', "");
    Expect(1, 173792, '\p{^Blk=--CJK_ext_B}', "");
    Expect(1, 173792, '\P{Blk=--CJK_ext_B}', "");
    Expect(0, 173792, '\P{^Blk=--CJK_ext_B}', "");
    Error('\p{Is_Block=:=CJK_UNIFIED_Ideographs_Extension_B}');
    Error('\P{Is_Block=:=CJK_UNIFIED_Ideographs_Extension_B}');
    Expect(1, 173791, '\p{Is_Block:	cjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\p{^Is_Block:	cjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\P{Is_Block:	cjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\P{^Is_Block:	cjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\p{Is_Block:	cjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\p{^Is_Block:	cjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\P{Is_Block:	cjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\P{^Is_Block:	cjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\p{Is_Block:-CJK_UNIFIED_Ideographs_EXTENSION_b}', "");
    Expect(0, 173791, '\p{^Is_Block:-CJK_UNIFIED_Ideographs_EXTENSION_b}', "");
    Expect(0, 173791, '\P{Is_Block:-CJK_UNIFIED_Ideographs_EXTENSION_b}', "");
    Expect(1, 173791, '\P{^Is_Block:-CJK_UNIFIED_Ideographs_EXTENSION_b}', "");
    Expect(0, 173792, '\p{Is_Block:-CJK_UNIFIED_Ideographs_EXTENSION_b}', "");
    Expect(1, 173792, '\p{^Is_Block:-CJK_UNIFIED_Ideographs_EXTENSION_b}', "");
    Expect(1, 173792, '\P{Is_Block:-CJK_UNIFIED_Ideographs_EXTENSION_b}', "");
    Expect(0, 173792, '\P{^Is_Block:-CJK_UNIFIED_Ideographs_EXTENSION_b}', "");
    Error('\p{Is_Blk= /a/CJK_ext_B}');
    Error('\P{Is_Blk= /a/CJK_ext_B}');
    Expect(1, 173791, '\p{Is_Blk=cjkextb}', "");
    Expect(0, 173791, '\p{^Is_Blk=cjkextb}', "");
    Expect(0, 173791, '\P{Is_Blk=cjkextb}', "");
    Expect(1, 173791, '\P{^Is_Blk=cjkextb}', "");
    Expect(0, 173792, '\p{Is_Blk=cjkextb}', "");
    Expect(1, 173792, '\p{^Is_Blk=cjkextb}', "");
    Expect(1, 173792, '\P{Is_Blk=cjkextb}', "");
    Expect(0, 173792, '\P{^Is_Blk=cjkextb}', "");
    Expect(1, 173791, '\p{Is_Blk:	CJK_EXT_B}', "");
    Expect(0, 173791, '\p{^Is_Blk:	CJK_EXT_B}', "");
    Expect(0, 173791, '\P{Is_Blk:	CJK_EXT_B}', "");
    Expect(1, 173791, '\P{^Is_Blk:	CJK_EXT_B}', "");
    Expect(0, 173792, '\p{Is_Blk:	CJK_EXT_B}', "");
    Expect(1, 173792, '\p{^Is_Blk:	CJK_EXT_B}', "");
    Expect(1, 173792, '\P{Is_Blk:	CJK_EXT_B}', "");
    Expect(0, 173792, '\P{^Is_Blk:	CJK_EXT_B}', "");
    Error('\p{Block=:=-	cjk_unified_Ideographs_Extension_c}');
    Error('\P{Block=:=-	cjk_unified_Ideographs_Extension_c}');
    Expect(1, 177983, '\p{Block=:\ACJK_Unified_Ideographs_Extension_C\z:}', "");;
    Expect(0, 177984, '\p{Block=:\ACJK_Unified_Ideographs_Extension_C\z:}', "");;
    Expect(1, 177983, '\p{Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\p{^Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\P{Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\P{^Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\p{Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\p{^Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\P{Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\P{^Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\p{Block=:\Acjkunifiedideographsextensionc\z:}', "");;
    Expect(0, 177984, '\p{Block=:\Acjkunifiedideographsextensionc\z:}', "");;
    Expect(1, 177983, '\p{Block=-_CJK_unified_ideographs_EXTENSION_C}', "");
    Expect(0, 177983, '\p{^Block=-_CJK_unified_ideographs_EXTENSION_C}', "");
    Expect(0, 177983, '\P{Block=-_CJK_unified_ideographs_EXTENSION_C}', "");
    Expect(1, 177983, '\P{^Block=-_CJK_unified_ideographs_EXTENSION_C}', "");
    Expect(0, 177984, '\p{Block=-_CJK_unified_ideographs_EXTENSION_C}', "");
    Expect(1, 177984, '\p{^Block=-_CJK_unified_ideographs_EXTENSION_C}', "");
    Expect(1, 177984, '\P{Block=-_CJK_unified_ideographs_EXTENSION_C}', "");
    Expect(0, 177984, '\P{^Block=-_CJK_unified_ideographs_EXTENSION_C}', "");
    Error('\p{Blk= :=CJK_Ext_C}');
    Error('\P{Blk= :=CJK_Ext_C}');
    Expect(1, 177983, '\p{Blk=:\ACJK_Ext_C\z:}', "");;
    Expect(0, 177984, '\p{Blk=:\ACJK_Ext_C\z:}', "");;
    Expect(1, 177983, '\p{Blk=cjkextc}', "");
    Expect(0, 177983, '\p{^Blk=cjkextc}', "");
    Expect(0, 177983, '\P{Blk=cjkextc}', "");
    Expect(1, 177983, '\P{^Blk=cjkextc}', "");
    Expect(0, 177984, '\p{Blk=cjkextc}', "");
    Expect(1, 177984, '\p{^Blk=cjkextc}', "");
    Expect(1, 177984, '\P{Blk=cjkextc}', "");
    Expect(0, 177984, '\P{^Blk=cjkextc}', "");
    Expect(1, 177983, '\p{Blk=:\Acjkextc\z:}', "");;
    Expect(0, 177984, '\p{Blk=:\Acjkextc\z:}', "");;
    Expect(1, 177983, '\p{Blk:  CJK_ext_C}', "");
    Expect(0, 177983, '\p{^Blk:  CJK_ext_C}', "");
    Expect(0, 177983, '\P{Blk:  CJK_ext_C}', "");
    Expect(1, 177983, '\P{^Blk:  CJK_ext_C}', "");
    Expect(0, 177984, '\p{Blk:  CJK_ext_C}', "");
    Expect(1, 177984, '\p{^Blk:  CJK_ext_C}', "");
    Expect(1, 177984, '\P{Blk:  CJK_ext_C}', "");
    Expect(0, 177984, '\P{^Blk:  CJK_ext_C}', "");
    Error('\p{Is_Block=_-CJK_Unified_IDEOGRAPHS_Extension_c:=}');
    Error('\P{Is_Block=_-CJK_Unified_IDEOGRAPHS_Extension_c:=}');
    Expect(1, 177983, '\p{Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\p{^Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\P{Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\P{^Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\p{Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\p{^Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\P{Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\P{^Is_Block=cjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\p{Is_Block=  cjk_Unified_IDEOGRAPHS_extension_c}', "");
    Expect(0, 177983, '\p{^Is_Block=  cjk_Unified_IDEOGRAPHS_extension_c}', "");
    Expect(0, 177983, '\P{Is_Block=  cjk_Unified_IDEOGRAPHS_extension_c}', "");
    Expect(1, 177983, '\P{^Is_Block=  cjk_Unified_IDEOGRAPHS_extension_c}', "");
    Expect(0, 177984, '\p{Is_Block=  cjk_Unified_IDEOGRAPHS_extension_c}', "");
    Expect(1, 177984, '\p{^Is_Block=  cjk_Unified_IDEOGRAPHS_extension_c}', "");
    Expect(1, 177984, '\P{Is_Block=  cjk_Unified_IDEOGRAPHS_extension_c}', "");
    Expect(0, 177984, '\P{^Is_Block=  cjk_Unified_IDEOGRAPHS_extension_c}', "");
    Error('\p{Is_Blk=- cjk_ext_c/a/}');
    Error('\P{Is_Blk=- cjk_ext_c/a/}');
    Expect(1, 177983, '\p{Is_Blk=cjkextc}', "");
    Expect(0, 177983, '\p{^Is_Blk=cjkextc}', "");
    Expect(0, 177983, '\P{Is_Blk=cjkextc}', "");
    Expect(1, 177983, '\P{^Is_Blk=cjkextc}', "");
    Expect(0, 177984, '\p{Is_Blk=cjkextc}', "");
    Expect(1, 177984, '\p{^Is_Blk=cjkextc}', "");
    Expect(1, 177984, '\P{Is_Blk=cjkextc}', "");
    Expect(0, 177984, '\P{^Is_Blk=cjkextc}', "");
    Expect(1, 177983, '\p{Is_Blk=-cjk_EXT_C}', "");
    Expect(0, 177983, '\p{^Is_Blk=-cjk_EXT_C}', "");
    Expect(0, 177983, '\P{Is_Blk=-cjk_EXT_C}', "");
    Expect(1, 177983, '\P{^Is_Blk=-cjk_EXT_C}', "");
    Expect(0, 177984, '\p{Is_Blk=-cjk_EXT_C}', "");
    Expect(1, 177984, '\p{^Is_Blk=-cjk_EXT_C}', "");
    Expect(1, 177984, '\P{Is_Blk=-cjk_EXT_C}', "");
    Expect(0, 177984, '\P{^Is_Blk=-cjk_EXT_C}', "");
    Error('\p{Block=	CJK_UNIFIED_Ideographs_Extension_d:=}');
    Error('\P{Block=	CJK_UNIFIED_Ideographs_Extension_d:=}');
    Expect(1, 178207, '\p{Block=:\ACJK_Unified_Ideographs_Extension_D\z:}', "");;
    Expect(0, 178208, '\p{Block=:\ACJK_Unified_Ideographs_Extension_D\z:}', "");;
    Expect(1, 178207, '\p{Block:	cjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\p{^Block:	cjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\P{Block:	cjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\P{^Block:	cjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\p{Block:	cjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\p{^Block:	cjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\P{Block:	cjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\P{^Block:	cjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\p{Block=:\Acjkunifiedideographsextensiond\z:}', "");;
    Expect(0, 178208, '\p{Block=:\Acjkunifiedideographsextensiond\z:}', "");;
    Expect(1, 178207, '\p{Block= -CJK_Unified_Ideographs_Extension_D}', "");
    Expect(0, 178207, '\p{^Block= -CJK_Unified_Ideographs_Extension_D}', "");
    Expect(0, 178207, '\P{Block= -CJK_Unified_Ideographs_Extension_D}', "");
    Expect(1, 178207, '\P{^Block= -CJK_Unified_Ideographs_Extension_D}', "");
    Expect(0, 178208, '\p{Block= -CJK_Unified_Ideographs_Extension_D}', "");
    Expect(1, 178208, '\p{^Block= -CJK_Unified_Ideographs_Extension_D}', "");
    Expect(1, 178208, '\P{Block= -CJK_Unified_Ideographs_Extension_D}', "");
    Expect(0, 178208, '\P{^Block= -CJK_Unified_Ideographs_Extension_D}', "");
    Error('\p{Blk:-:=cjk_Ext_D}');
    Error('\P{Blk:-:=cjk_Ext_D}');
    Expect(1, 178207, '\p{Blk=:\ACJK_Ext_D\z:}', "");;
    Expect(0, 178208, '\p{Blk=:\ACJK_Ext_D\z:}', "");;
    Expect(1, 178207, '\p{Blk=cjkextd}', "");
    Expect(0, 178207, '\p{^Blk=cjkextd}', "");
    Expect(0, 178207, '\P{Blk=cjkextd}', "");
    Expect(1, 178207, '\P{^Blk=cjkextd}', "");
    Expect(0, 178208, '\p{Blk=cjkextd}', "");
    Expect(1, 178208, '\p{^Blk=cjkextd}', "");
    Expect(1, 178208, '\P{Blk=cjkextd}', "");
    Expect(0, 178208, '\P{^Blk=cjkextd}', "");
    Expect(1, 178207, '\p{Blk=:\Acjkextd\z:}', "");;
    Expect(0, 178208, '\p{Blk=:\Acjkextd\z:}', "");;
    Expect(1, 178207, '\p{Blk=--CJK_Ext_d}', "");
    Expect(0, 178207, '\p{^Blk=--CJK_Ext_d}', "");
    Expect(0, 178207, '\P{Blk=--CJK_Ext_d}', "");
    Expect(1, 178207, '\P{^Blk=--CJK_Ext_d}', "");
    Expect(0, 178208, '\p{Blk=--CJK_Ext_d}', "");
    Expect(1, 178208, '\p{^Blk=--CJK_Ext_d}', "");
    Expect(1, 178208, '\P{Blk=--CJK_Ext_d}', "");
    Expect(0, 178208, '\P{^Blk=--CJK_Ext_d}', "");
    Error('\p{Is_Block=:= 	cjk_Unified_IDEOGRAPHS_EXTENSION_d}');
    Error('\P{Is_Block=:= 	cjk_Unified_IDEOGRAPHS_EXTENSION_d}');
    Expect(1, 178207, '\p{Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\p{^Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\P{Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\P{^Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\p{Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\p{^Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\P{Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\P{^Is_Block=cjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\p{Is_Block=__CJK_Unified_Ideographs_EXTENSION_D}', "");
    Expect(0, 178207, '\p{^Is_Block=__CJK_Unified_Ideographs_EXTENSION_D}', "");
    Expect(0, 178207, '\P{Is_Block=__CJK_Unified_Ideographs_EXTENSION_D}', "");
    Expect(1, 178207, '\P{^Is_Block=__CJK_Unified_Ideographs_EXTENSION_D}', "");
    Expect(0, 178208, '\p{Is_Block=__CJK_Unified_Ideographs_EXTENSION_D}', "");
    Expect(1, 178208, '\p{^Is_Block=__CJK_Unified_Ideographs_EXTENSION_D}', "");
    Expect(1, 178208, '\P{Is_Block=__CJK_Unified_Ideographs_EXTENSION_D}', "");
    Expect(0, 178208, '\P{^Is_Block=__CJK_Unified_Ideographs_EXTENSION_D}', "");
    Error('\p{Is_Blk:_CJK_EXT_D/a/}');
    Error('\P{Is_Blk:_CJK_EXT_D/a/}');
    Expect(1, 178207, '\p{Is_Blk=cjkextd}', "");
    Expect(0, 178207, '\p{^Is_Blk=cjkextd}', "");
    Expect(0, 178207, '\P{Is_Blk=cjkextd}', "");
    Expect(1, 178207, '\P{^Is_Blk=cjkextd}', "");
    Expect(0, 178208, '\p{Is_Blk=cjkextd}', "");
    Expect(1, 178208, '\p{^Is_Blk=cjkextd}', "");
    Expect(1, 178208, '\P{Is_Blk=cjkextd}', "");
    Expect(0, 178208, '\P{^Is_Blk=cjkextd}', "");
    Expect(1, 178207, '\p{Is_Blk=_CJK_Ext_D}', "");
    Expect(0, 178207, '\p{^Is_Blk=_CJK_Ext_D}', "");
    Expect(0, 178207, '\P{Is_Blk=_CJK_Ext_D}', "");
    Expect(1, 178207, '\P{^Is_Blk=_CJK_Ext_D}', "");
    Expect(0, 178208, '\p{Is_Blk=_CJK_Ext_D}', "");
    Expect(1, 178208, '\p{^Is_Blk=_CJK_Ext_D}', "");
    Expect(1, 178208, '\P{Is_Blk=_CJK_Ext_D}', "");
    Expect(0, 178208, '\P{^Is_Blk=_CJK_Ext_D}', "");
    Error('\p{Block:   	_CJK_Unified_ideographs_EXTENSION_E/a/}');
    Error('\P{Block:   	_CJK_Unified_ideographs_EXTENSION_E/a/}');
    Expect(1, 183983, '\p{Block=:\ACJK_Unified_Ideographs_Extension_E\z:}', "");;
    Expect(0, 183984, '\p{Block=:\ACJK_Unified_Ideographs_Extension_E\z:}', "");;
    Expect(1, 183983, '\p{Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\p{^Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\P{Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\P{^Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\p{Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\p{^Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\P{Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\P{^Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\p{Block=:\Acjkunifiedideographsextensione\z:}', "");;
    Expect(0, 183984, '\p{Block=:\Acjkunifiedideographsextensione\z:}', "");;
    Expect(1, 183983, '\p{Block=	CJK_Unified_Ideographs_Extension_E}', "");
    Expect(0, 183983, '\p{^Block=	CJK_Unified_Ideographs_Extension_E}', "");
    Expect(0, 183983, '\P{Block=	CJK_Unified_Ideographs_Extension_E}', "");
    Expect(1, 183983, '\P{^Block=	CJK_Unified_Ideographs_Extension_E}', "");
    Expect(0, 183984, '\p{Block=	CJK_Unified_Ideographs_Extension_E}', "");
    Expect(1, 183984, '\p{^Block=	CJK_Unified_Ideographs_Extension_E}', "");
    Expect(1, 183984, '\P{Block=	CJK_Unified_Ideographs_Extension_E}', "");
    Expect(0, 183984, '\P{^Block=	CJK_Unified_Ideographs_Extension_E}', "");
    Error('\p{Blk=CJK_ext_E:=}');
    Error('\P{Blk=CJK_ext_E:=}');
    Expect(1, 183983, '\p{Blk=:\ACJK_Ext_E\z:}', "");;
    Expect(0, 183984, '\p{Blk=:\ACJK_Ext_E\z:}', "");;
    Expect(1, 183983, '\p{Blk:cjkexte}', "");
    Expect(0, 183983, '\p{^Blk:cjkexte}', "");
    Expect(0, 183983, '\P{Blk:cjkexte}', "");
    Expect(1, 183983, '\P{^Blk:cjkexte}', "");
    Expect(0, 183984, '\p{Blk:cjkexte}', "");
    Expect(1, 183984, '\p{^Blk:cjkexte}', "");
    Expect(1, 183984, '\P{Blk:cjkexte}', "");
    Expect(0, 183984, '\P{^Blk:cjkexte}', "");
    Expect(1, 183983, '\p{Blk=:\Acjkexte\z:}', "");;
    Expect(0, 183984, '\p{Blk=:\Acjkexte\z:}', "");;
    Expect(1, 183983, '\p{Blk= _cjk_ext_E}', "");
    Expect(0, 183983, '\p{^Blk= _cjk_ext_E}', "");
    Expect(0, 183983, '\P{Blk= _cjk_ext_E}', "");
    Expect(1, 183983, '\P{^Blk= _cjk_ext_E}', "");
    Expect(0, 183984, '\p{Blk= _cjk_ext_E}', "");
    Expect(1, 183984, '\p{^Blk= _cjk_ext_E}', "");
    Expect(1, 183984, '\P{Blk= _cjk_ext_E}', "");
    Expect(0, 183984, '\P{^Blk= _cjk_ext_E}', "");
    Error('\p{Is_Block=_CJK_unified_IDEOGRAPHS_extension_e:=}');
    Error('\P{Is_Block=_CJK_unified_IDEOGRAPHS_extension_e:=}');
    Expect(1, 183983, '\p{Is_Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\p{^Is_Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\P{Is_Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\P{^Is_Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\p{Is_Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\p{^Is_Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\P{Is_Block=cjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\P{^Is_Block=cjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\p{Is_Block=CJK_Unified_ideographs_Extension_E}', "");
    Expect(0, 183983, '\p{^Is_Block=CJK_Unified_ideographs_Extension_E}', "");
    Expect(0, 183983, '\P{Is_Block=CJK_Unified_ideographs_Extension_E}', "");
    Expect(1, 183983, '\P{^Is_Block=CJK_Unified_ideographs_Extension_E}', "");
    Expect(0, 183984, '\p{Is_Block=CJK_Unified_ideographs_Extension_E}', "");
    Expect(1, 183984, '\p{^Is_Block=CJK_Unified_ideographs_Extension_E}', "");
    Expect(1, 183984, '\P{Is_Block=CJK_Unified_ideographs_Extension_E}', "");
    Expect(0, 183984, '\P{^Is_Block=CJK_Unified_ideographs_Extension_E}', "");
    Error('\p{Is_Blk= -CJK_Ext_E/a/}');
    Error('\P{Is_Blk= -CJK_Ext_E/a/}');
    Expect(1, 183983, '\p{Is_Blk=cjkexte}', "");
    Expect(0, 183983, '\p{^Is_Blk=cjkexte}', "");
    Expect(0, 183983, '\P{Is_Blk=cjkexte}', "");
    Expect(1, 183983, '\P{^Is_Blk=cjkexte}', "");
    Expect(0, 183984, '\p{Is_Blk=cjkexte}', "");
    Expect(1, 183984, '\p{^Is_Blk=cjkexte}', "");
    Expect(1, 183984, '\P{Is_Blk=cjkexte}', "");
    Expect(0, 183984, '\P{^Is_Blk=cjkexte}', "");
    Expect(1, 183983, '\p{Is_Blk:    CJK_Ext_E}', "");
    Expect(0, 183983, '\p{^Is_Blk:    CJK_Ext_E}', "");
    Expect(0, 183983, '\P{Is_Blk:    CJK_Ext_E}', "");
    Expect(1, 183983, '\P{^Is_Blk:    CJK_Ext_E}', "");
    Expect(0, 183984, '\p{Is_Blk:    CJK_Ext_E}', "");
    Expect(1, 183984, '\p{^Is_Blk:    CJK_Ext_E}', "");
    Expect(1, 183984, '\P{Is_Blk:    CJK_Ext_E}', "");
    Expect(0, 183984, '\P{^Is_Blk:    CJK_Ext_E}', "");
    Error('\p{Block=:=__CJK_Unified_Ideographs_Extension_f}');
    Error('\P{Block=:=__CJK_Unified_Ideographs_Extension_f}');
    Expect(1, 191471, '\p{Block=:\ACJK_Unified_Ideographs_Extension_F\z:}', "");;
    Expect(0, 191472, '\p{Block=:\ACJK_Unified_Ideographs_Extension_F\z:}', "");;
    Expect(1, 191471, '\p{Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\p{^Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\P{Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\P{^Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\p{Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\p{^Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\P{Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\P{^Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\p{Block=:\Acjkunifiedideographsextensionf\z:}', "");;
    Expect(0, 191472, '\p{Block=:\Acjkunifiedideographsextensionf\z:}', "");;
    Expect(1, 191471, '\p{Block:	cjk_unified_IDEOGRAPHS_Extension_F}', "");
    Expect(0, 191471, '\p{^Block:	cjk_unified_IDEOGRAPHS_Extension_F}', "");
    Expect(0, 191471, '\P{Block:	cjk_unified_IDEOGRAPHS_Extension_F}', "");
    Expect(1, 191471, '\P{^Block:	cjk_unified_IDEOGRAPHS_Extension_F}', "");
    Expect(0, 191472, '\p{Block:	cjk_unified_IDEOGRAPHS_Extension_F}', "");
    Expect(1, 191472, '\p{^Block:	cjk_unified_IDEOGRAPHS_Extension_F}', "");
    Expect(1, 191472, '\P{Block:	cjk_unified_IDEOGRAPHS_Extension_F}', "");
    Expect(0, 191472, '\P{^Block:	cjk_unified_IDEOGRAPHS_Extension_F}', "");
    Error('\p{Blk=	_CJK_Ext_F/a/}');
    Error('\P{Blk=	_CJK_Ext_F/a/}');
    Expect(1, 191471, '\p{Blk=:\ACJK_Ext_F\z:}', "");;
    Expect(0, 191472, '\p{Blk=:\ACJK_Ext_F\z:}', "");;
    Expect(1, 191471, '\p{Blk: cjkextf}', "");
    Expect(0, 191471, '\p{^Blk: cjkextf}', "");
    Expect(0, 191471, '\P{Blk: cjkextf}', "");
    Expect(1, 191471, '\P{^Blk: cjkextf}', "");
    Expect(0, 191472, '\p{Blk: cjkextf}', "");
    Expect(1, 191472, '\p{^Blk: cjkextf}', "");
    Expect(1, 191472, '\P{Blk: cjkextf}', "");
    Expect(0, 191472, '\P{^Blk: cjkextf}', "");
    Expect(1, 191471, '\p{Blk=:\Acjkextf\z:}', "");;
    Expect(0, 191472, '\p{Blk=:\Acjkextf\z:}', "");;
    Expect(1, 191471, '\p{Blk=_	CJK_Ext_F}', "");
    Expect(0, 191471, '\p{^Blk=_	CJK_Ext_F}', "");
    Expect(0, 191471, '\P{Blk=_	CJK_Ext_F}', "");
    Expect(1, 191471, '\P{^Blk=_	CJK_Ext_F}', "");
    Expect(0, 191472, '\p{Blk=_	CJK_Ext_F}', "");
    Expect(1, 191472, '\p{^Blk=_	CJK_Ext_F}', "");
    Expect(1, 191472, '\P{Blk=_	CJK_Ext_F}', "");
    Expect(0, 191472, '\P{^Blk=_	CJK_Ext_F}', "");
    Error('\p{Is_Block=:=	_CJK_Unified_Ideographs_Extension_F}');
    Error('\P{Is_Block=:=	_CJK_Unified_Ideographs_Extension_F}');
    Expect(1, 191471, '\p{Is_Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\p{^Is_Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\P{Is_Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\P{^Is_Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\p{Is_Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\p{^Is_Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\P{Is_Block=cjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\P{^Is_Block=cjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\p{Is_Block=	 CJK_unified_ideographs_Extension_F}', "");
    Expect(0, 191471, '\p{^Is_Block=	 CJK_unified_ideographs_Extension_F}', "");
    Expect(0, 191471, '\P{Is_Block=	 CJK_unified_ideographs_Extension_F}', "");
    Expect(1, 191471, '\P{^Is_Block=	 CJK_unified_ideographs_Extension_F}', "");
    Expect(0, 191472, '\p{Is_Block=	 CJK_unified_ideographs_Extension_F}', "");
    Expect(1, 191472, '\p{^Is_Block=	 CJK_unified_ideographs_Extension_F}', "");
    Expect(1, 191472, '\P{Is_Block=	 CJK_unified_ideographs_Extension_F}', "");
    Expect(0, 191472, '\P{^Is_Block=	 CJK_unified_ideographs_Extension_F}', "");
    Error('\p{Is_Blk= :=CJK_EXT_F}');
    Error('\P{Is_Blk= :=CJK_EXT_F}');
    Expect(1, 191471, '\p{Is_Blk: cjkextf}', "");
    Expect(0, 191471, '\p{^Is_Blk: cjkextf}', "");
    Expect(0, 191471, '\P{Is_Blk: cjkextf}', "");
    Expect(1, 191471, '\P{^Is_Blk: cjkextf}', "");
    Expect(0, 191472, '\p{Is_Blk: cjkextf}', "");
    Expect(1, 191472, '\p{^Is_Blk: cjkextf}', "");
    Expect(1, 191472, '\P{Is_Blk: cjkextf}', "");
    Expect(0, 191472, '\P{^Is_Blk: cjkextf}', "");
    Expect(1, 191471, '\p{Is_Blk=-_CJK_ext_F}', "");
    Expect(0, 191471, '\p{^Is_Blk=-_CJK_ext_F}', "");
    Expect(0, 191471, '\P{Is_Blk=-_CJK_ext_F}', "");
    Expect(1, 191471, '\P{^Is_Blk=-_CJK_ext_F}', "");
    Expect(0, 191472, '\p{Is_Blk=-_CJK_ext_F}', "");
    Expect(1, 191472, '\p{^Is_Blk=-_CJK_ext_F}', "");
    Expect(1, 191472, '\P{Is_Blk=-_CJK_ext_F}', "");
    Expect(0, 191472, '\P{^Is_Blk=-_CJK_ext_F}', "");
    Error('\p{Block=	 cjk_Radicals_SUPPLEMENT/a/}');
    Error('\P{Block=	 cjk_Radicals_SUPPLEMENT/a/}');
    Expect(1, 12031, '\p{Block=:\ACJK_Radicals_Supplement\z:}', "");;
    Expect(0, 12032, '\p{Block=:\ACJK_Radicals_Supplement\z:}', "");;
    Expect(1, 12031, '\p{Block:cjkradicalssupplement}', "");
    Expect(0, 12031, '\p{^Block:cjkradicalssupplement}', "");
    Expect(0, 12031, '\P{Block:cjkradicalssupplement}', "");
    Expect(1, 12031, '\P{^Block:cjkradicalssupplement}', "");
    Expect(0, 12032, '\p{Block:cjkradicalssupplement}', "");
    Expect(1, 12032, '\p{^Block:cjkradicalssupplement}', "");
    Expect(1, 12032, '\P{Block:cjkradicalssupplement}', "");
    Expect(0, 12032, '\P{^Block:cjkradicalssupplement}', "");
    Expect(1, 12031, '\p{Block=:\Acjkradicalssupplement\z:}', "");;
    Expect(0, 12032, '\p{Block=:\Acjkradicalssupplement\z:}', "");;
    Expect(1, 12031, '\p{Block=_ cjk_Radicals_supplement}', "");
    Expect(0, 12031, '\p{^Block=_ cjk_Radicals_supplement}', "");
    Expect(0, 12031, '\P{Block=_ cjk_Radicals_supplement}', "");
    Expect(1, 12031, '\P{^Block=_ cjk_Radicals_supplement}', "");
    Expect(0, 12032, '\p{Block=_ cjk_Radicals_supplement}', "");
    Expect(1, 12032, '\p{^Block=_ cjk_Radicals_supplement}', "");
    Expect(1, 12032, '\P{Block=_ cjk_Radicals_supplement}', "");
    Expect(0, 12032, '\P{^Block=_ cjk_Radicals_supplement}', "");
    Error('\p{Blk=/a/__CJK_Radicals_Sup}');
    Error('\P{Blk=/a/__CJK_Radicals_Sup}');
    Expect(1, 12031, '\p{Blk=:\ACJK_Radicals_Sup\z:}', "");;
    Expect(0, 12032, '\p{Blk=:\ACJK_Radicals_Sup\z:}', "");;
    Expect(1, 12031, '\p{Blk=cjkradicalssup}', "");
    Expect(0, 12031, '\p{^Blk=cjkradicalssup}', "");
    Expect(0, 12031, '\P{Blk=cjkradicalssup}', "");
    Expect(1, 12031, '\P{^Blk=cjkradicalssup}', "");
    Expect(0, 12032, '\p{Blk=cjkradicalssup}', "");
    Expect(1, 12032, '\p{^Blk=cjkradicalssup}', "");
    Expect(1, 12032, '\P{Blk=cjkradicalssup}', "");
    Expect(0, 12032, '\P{^Blk=cjkradicalssup}', "");
    Expect(1, 12031, '\p{Blk=:\Acjkradicalssup\z:}', "");;
    Expect(0, 12032, '\p{Blk=:\Acjkradicalssup\z:}', "");;
    Expect(1, 12031, '\p{Blk=	CJK_RADICALS_sup}', "");
    Expect(0, 12031, '\p{^Blk=	CJK_RADICALS_sup}', "");
    Expect(0, 12031, '\P{Blk=	CJK_RADICALS_sup}', "");
    Expect(1, 12031, '\P{^Blk=	CJK_RADICALS_sup}', "");
    Expect(0, 12032, '\p{Blk=	CJK_RADICALS_sup}', "");
    Expect(1, 12032, '\p{^Blk=	CJK_RADICALS_sup}', "");
    Expect(1, 12032, '\P{Blk=	CJK_RADICALS_sup}', "");
    Expect(0, 12032, '\P{^Blk=	CJK_RADICALS_sup}', "");
    Error('\p{Is_Block=	-CJK_RADICALS_supplement:=}');
    Error('\P{Is_Block=	-CJK_RADICALS_supplement:=}');
    Expect(1, 12031, '\p{Is_Block=cjkradicalssupplement}', "");
    Expect(0, 12031, '\p{^Is_Block=cjkradicalssupplement}', "");
    Expect(0, 12031, '\P{Is_Block=cjkradicalssupplement}', "");
    Expect(1, 12031, '\P{^Is_Block=cjkradicalssupplement}', "");
    Expect(0, 12032, '\p{Is_Block=cjkradicalssupplement}', "");
    Expect(1, 12032, '\p{^Is_Block=cjkradicalssupplement}', "");
    Expect(1, 12032, '\P{Is_Block=cjkradicalssupplement}', "");
    Expect(0, 12032, '\P{^Is_Block=cjkradicalssupplement}', "");
    Expect(1, 12031, '\p{Is_Block=_CJK_Radicals_Supplement}', "");
    Expect(0, 12031, '\p{^Is_Block=_CJK_Radicals_Supplement}', "");
    Expect(0, 12031, '\P{Is_Block=_CJK_Radicals_Supplement}', "");
    Expect(1, 12031, '\P{^Is_Block=_CJK_Radicals_Supplement}', "");
    Expect(0, 12032, '\p{Is_Block=_CJK_Radicals_Supplement}', "");
    Expect(1, 12032, '\p{^Is_Block=_CJK_Radicals_Supplement}', "");
    Expect(1, 12032, '\P{Is_Block=_CJK_Radicals_Supplement}', "");
    Expect(0, 12032, '\P{^Is_Block=_CJK_Radicals_Supplement}', "");
    Error('\p{Is_Blk=/a/_CJK_Radicals_Sup}');
    Error('\P{Is_Blk=/a/_CJK_Radicals_Sup}');
    Expect(1, 12031, '\p{Is_Blk=cjkradicalssup}', "");
    Expect(0, 12031, '\p{^Is_Blk=cjkradicalssup}', "");
    Expect(0, 12031, '\P{Is_Blk=cjkradicalssup}', "");
    Expect(1, 12031, '\P{^Is_Blk=cjkradicalssup}', "");
    Expect(0, 12032, '\p{Is_Blk=cjkradicalssup}', "");
    Expect(1, 12032, '\p{^Is_Blk=cjkradicalssup}', "");
    Expect(1, 12032, '\P{Is_Blk=cjkradicalssup}', "");
    Expect(0, 12032, '\P{^Is_Blk=cjkradicalssup}', "");
    Expect(1, 12031, '\p{Is_Blk=_	CJK_radicals_SUP}', "");
    Expect(0, 12031, '\p{^Is_Blk=_	CJK_radicals_SUP}', "");
    Expect(0, 12031, '\P{Is_Blk=_	CJK_radicals_SUP}', "");
    Expect(1, 12031, '\P{^Is_Blk=_	CJK_radicals_SUP}', "");
    Expect(0, 12032, '\p{Is_Blk=_	CJK_radicals_SUP}', "");
    Expect(1, 12032, '\p{^Is_Blk=_	CJK_radicals_SUP}', "");
    Expect(1, 12032, '\P{Is_Blk=_	CJK_radicals_SUP}', "");
    Expect(0, 12032, '\P{^Is_Blk=_	CJK_radicals_SUP}', "");
    Error('\p{Block= :=CJK_Strokes}');
    Error('\P{Block= :=CJK_Strokes}');
    Expect(1, 12783, '\p{Block=:\ACJK_Strokes\z:}', "");;
    Expect(0, 12784, '\p{Block=:\ACJK_Strokes\z:}', "");;
    Expect(1, 12783, '\p{Block=cjkstrokes}', "");
    Expect(0, 12783, '\p{^Block=cjkstrokes}', "");
    Expect(0, 12783, '\P{Block=cjkstrokes}', "");
    Expect(1, 12783, '\P{^Block=cjkstrokes}', "");
    Expect(0, 12784, '\p{Block=cjkstrokes}', "");
    Expect(1, 12784, '\p{^Block=cjkstrokes}', "");
    Expect(1, 12784, '\P{Block=cjkstrokes}', "");
    Expect(0, 12784, '\P{^Block=cjkstrokes}', "");
    Expect(1, 12783, '\p{Block=:\Acjkstrokes\z:}', "");;
    Expect(0, 12784, '\p{Block=:\Acjkstrokes\z:}', "");;
    Expect(1, 12783, '\p{Block=--CJK_STROKES}', "");
    Expect(0, 12783, '\p{^Block=--CJK_STROKES}', "");
    Expect(0, 12783, '\P{Block=--CJK_STROKES}', "");
    Expect(1, 12783, '\P{^Block=--CJK_STROKES}', "");
    Expect(0, 12784, '\p{Block=--CJK_STROKES}', "");
    Expect(1, 12784, '\p{^Block=--CJK_STROKES}', "");
    Expect(1, 12784, '\P{Block=--CJK_STROKES}', "");
    Expect(0, 12784, '\P{^Block=--CJK_STROKES}', "");
    Error('\p{Blk=:=CJK_Strokes}');
    Error('\P{Blk=:=CJK_Strokes}');
    Expect(1, 12783, '\p{Blk=:\ACJK_Strokes\z:}', "");;
    Expect(0, 12784, '\p{Blk=:\ACJK_Strokes\z:}', "");;
    Expect(1, 12783, '\p{Blk=cjkstrokes}', "");
    Expect(0, 12783, '\p{^Blk=cjkstrokes}', "");
    Expect(0, 12783, '\P{Blk=cjkstrokes}', "");
    Expect(1, 12783, '\P{^Blk=cjkstrokes}', "");
    Expect(0, 12784, '\p{Blk=cjkstrokes}', "");
    Expect(1, 12784, '\p{^Blk=cjkstrokes}', "");
    Expect(1, 12784, '\P{Blk=cjkstrokes}', "");
    Expect(0, 12784, '\P{^Blk=cjkstrokes}', "");
    Expect(1, 12783, '\p{Blk=:\Acjkstrokes\z:}', "");;
    Expect(0, 12784, '\p{Blk=:\Acjkstrokes\z:}', "");;
    Expect(1, 12783, '\p{Blk=_-CJK_Strokes}', "");
    Expect(0, 12783, '\p{^Blk=_-CJK_Strokes}', "");
    Expect(0, 12783, '\P{Blk=_-CJK_Strokes}', "");
    Expect(1, 12783, '\P{^Blk=_-CJK_Strokes}', "");
    Expect(0, 12784, '\p{Blk=_-CJK_Strokes}', "");
    Expect(1, 12784, '\p{^Blk=_-CJK_Strokes}', "");
    Expect(1, 12784, '\P{Blk=_-CJK_Strokes}', "");
    Expect(0, 12784, '\P{^Blk=_-CJK_Strokes}', "");
    Error('\p{Is_Block=:=	-cjk_STROKES}');
    Error('\P{Is_Block=:=	-cjk_STROKES}');
    Expect(1, 12783, '\p{Is_Block=cjkstrokes}', "");
    Expect(0, 12783, '\p{^Is_Block=cjkstrokes}', "");
    Expect(0, 12783, '\P{Is_Block=cjkstrokes}', "");
    Expect(1, 12783, '\P{^Is_Block=cjkstrokes}', "");
    Expect(0, 12784, '\p{Is_Block=cjkstrokes}', "");
    Expect(1, 12784, '\p{^Is_Block=cjkstrokes}', "");
    Expect(1, 12784, '\P{Is_Block=cjkstrokes}', "");
    Expect(0, 12784, '\P{^Is_Block=cjkstrokes}', "");
    Expect(1, 12783, '\p{Is_Block= CJK_strokes}', "");
    Expect(0, 12783, '\p{^Is_Block= CJK_strokes}', "");
    Expect(0, 12783, '\P{Is_Block= CJK_strokes}', "");
    Expect(1, 12783, '\P{^Is_Block= CJK_strokes}', "");
    Expect(0, 12784, '\p{Is_Block= CJK_strokes}', "");
    Expect(1, 12784, '\p{^Is_Block= CJK_strokes}', "");
    Expect(1, 12784, '\P{Is_Block= CJK_strokes}', "");
    Expect(0, 12784, '\P{^Is_Block= CJK_strokes}', "");
    Error('\p{Is_Blk=	:=CJK_Strokes}');
    Error('\P{Is_Blk=	:=CJK_Strokes}');
    Expect(1, 12783, '\p{Is_Blk=cjkstrokes}', "");
    Expect(0, 12783, '\p{^Is_Blk=cjkstrokes}', "");
    Expect(0, 12783, '\P{Is_Blk=cjkstrokes}', "");
    Expect(1, 12783, '\P{^Is_Blk=cjkstrokes}', "");
    Expect(0, 12784, '\p{Is_Blk=cjkstrokes}', "");
    Expect(1, 12784, '\p{^Is_Blk=cjkstrokes}', "");
    Expect(1, 12784, '\P{Is_Blk=cjkstrokes}', "");
    Expect(0, 12784, '\P{^Is_Blk=cjkstrokes}', "");
    Expect(1, 12783, '\p{Is_Blk=_ CJK_strokes}', "");
    Expect(0, 12783, '\p{^Is_Blk=_ CJK_strokes}', "");
    Expect(0, 12783, '\P{Is_Blk=_ CJK_strokes}', "");
    Expect(1, 12783, '\P{^Is_Blk=_ CJK_strokes}', "");
    Expect(0, 12784, '\p{Is_Blk=_ CJK_strokes}', "");
    Expect(1, 12784, '\p{^Is_Blk=_ CJK_strokes}', "");
    Expect(1, 12784, '\P{Is_Blk=_ CJK_strokes}', "");
    Expect(0, 12784, '\P{^Is_Blk=_ CJK_strokes}', "");
    Error('\p{Block=	/a/CJK_Symbols_And_Punctuation}');
    Error('\P{Block=	/a/CJK_Symbols_And_Punctuation}');
    Expect(1, 12351, '\p{Block=:\ACJK_Symbols_And_Punctuation\z:}', "");;
    Expect(0, 12352, '\p{Block=:\ACJK_Symbols_And_Punctuation\z:}', "");;
    Expect(1, 12351, '\p{Block=cjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\p{^Block=cjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\P{Block=cjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\P{^Block=cjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\p{Block=cjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\p{^Block=cjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\P{Block=cjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\P{^Block=cjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\p{Block=:\Acjksymbolsandpunctuation\z:}', "");;
    Expect(0, 12352, '\p{Block=:\Acjksymbolsandpunctuation\z:}', "");;
    Expect(1, 12351, '\p{Block:    _CJK_Symbols_And_Punctuation}', "");
    Expect(0, 12351, '\p{^Block:    _CJK_Symbols_And_Punctuation}', "");
    Expect(0, 12351, '\P{Block:    _CJK_Symbols_And_Punctuation}', "");
    Expect(1, 12351, '\P{^Block:    _CJK_Symbols_And_Punctuation}', "");
    Expect(0, 12352, '\p{Block:    _CJK_Symbols_And_Punctuation}', "");
    Expect(1, 12352, '\p{^Block:    _CJK_Symbols_And_Punctuation}', "");
    Expect(1, 12352, '\P{Block:    _CJK_Symbols_And_Punctuation}', "");
    Expect(0, 12352, '\P{^Block:    _CJK_Symbols_And_Punctuation}', "");
    Error('\p{Blk=:= CJK_SYMBOLS}');
    Error('\P{Blk=:= CJK_SYMBOLS}');
    Expect(1, 12351, '\p{Blk=:\ACJK_Symbols\z:}', "");;
    Expect(0, 12352, '\p{Blk=:\ACJK_Symbols\z:}', "");;
    Expect(1, 12351, '\p{Blk=cjksymbols}', "");
    Expect(0, 12351, '\p{^Blk=cjksymbols}', "");
    Expect(0, 12351, '\P{Blk=cjksymbols}', "");
    Expect(1, 12351, '\P{^Blk=cjksymbols}', "");
    Expect(0, 12352, '\p{Blk=cjksymbols}', "");
    Expect(1, 12352, '\p{^Blk=cjksymbols}', "");
    Expect(1, 12352, '\P{Blk=cjksymbols}', "");
    Expect(0, 12352, '\P{^Blk=cjksymbols}', "");
    Expect(1, 12351, '\p{Blk=:\Acjksymbols\z:}', "");;
    Expect(0, 12352, '\p{Blk=:\Acjksymbols\z:}', "");;
    Expect(1, 12351, '\p{Blk=-CJK_Symbols}', "");
    Expect(0, 12351, '\p{^Blk=-CJK_Symbols}', "");
    Expect(0, 12351, '\P{Blk=-CJK_Symbols}', "");
    Expect(1, 12351, '\P{^Blk=-CJK_Symbols}', "");
    Expect(0, 12352, '\p{Blk=-CJK_Symbols}', "");
    Expect(1, 12352, '\p{^Blk=-CJK_Symbols}', "");
    Expect(1, 12352, '\P{Blk=-CJK_Symbols}', "");
    Expect(0, 12352, '\P{^Blk=-CJK_Symbols}', "");
    Error('\p{Is_Block=_-CJK_Symbols_And_Punctuation/a/}');
    Error('\P{Is_Block=_-CJK_Symbols_And_Punctuation/a/}');
    Expect(1, 12351, '\p{Is_Block=cjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\p{^Is_Block=cjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\P{Is_Block=cjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\P{^Is_Block=cjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\p{Is_Block=cjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\p{^Is_Block=cjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\P{Is_Block=cjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\P{^Is_Block=cjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\p{Is_Block=_CJK_symbols_and_punctuation}', "");
    Expect(0, 12351, '\p{^Is_Block=_CJK_symbols_and_punctuation}', "");
    Expect(0, 12351, '\P{Is_Block=_CJK_symbols_and_punctuation}', "");
    Expect(1, 12351, '\P{^Is_Block=_CJK_symbols_and_punctuation}', "");
    Expect(0, 12352, '\p{Is_Block=_CJK_symbols_and_punctuation}', "");
    Expect(1, 12352, '\p{^Is_Block=_CJK_symbols_and_punctuation}', "");
    Expect(1, 12352, '\P{Is_Block=_CJK_symbols_and_punctuation}', "");
    Expect(0, 12352, '\P{^Is_Block=_CJK_symbols_and_punctuation}', "");
    Error('\p{Is_Blk=	 CJK_symbols/a/}');
    Error('\P{Is_Blk=	 CJK_symbols/a/}');
    Expect(1, 12351, '\p{Is_Blk=cjksymbols}', "");
    Expect(0, 12351, '\p{^Is_Blk=cjksymbols}', "");
    Expect(0, 12351, '\P{Is_Blk=cjksymbols}', "");
    Expect(1, 12351, '\P{^Is_Blk=cjksymbols}', "");
    Expect(0, 12352, '\p{Is_Blk=cjksymbols}', "");
    Expect(1, 12352, '\p{^Is_Blk=cjksymbols}', "");
    Expect(1, 12352, '\P{Is_Blk=cjksymbols}', "");
    Expect(0, 12352, '\P{^Is_Blk=cjksymbols}', "");
    Expect(1, 12351, '\p{Is_Blk= CJK_symbols}', "");
    Expect(0, 12351, '\p{^Is_Blk= CJK_symbols}', "");
    Expect(0, 12351, '\P{Is_Blk= CJK_symbols}', "");
    Expect(1, 12351, '\P{^Is_Blk= CJK_symbols}', "");
    Expect(0, 12352, '\p{Is_Blk= CJK_symbols}', "");
    Expect(1, 12352, '\p{^Is_Blk= CJK_symbols}', "");
    Expect(1, 12352, '\P{Is_Blk= CJK_symbols}', "");
    Expect(0, 12352, '\P{^Is_Blk= CJK_symbols}', "");
    Error('\p{Block=/a/  Hangul_compatibility_jamo}');
    Error('\P{Block=/a/  Hangul_compatibility_jamo}');
    Expect(1, 12687, '\p{Block=:\AHangul_Compatibility_Jamo\z:}', "");;
    Expect(0, 12688, '\p{Block=:\AHangul_Compatibility_Jamo\z:}', "");;
    Expect(1, 12687, '\p{Block=hangulcompatibilityjamo}', "");
    Expect(0, 12687, '\p{^Block=hangulcompatibilityjamo}', "");
    Expect(0, 12687, '\P{Block=hangulcompatibilityjamo}', "");
    Expect(1, 12687, '\P{^Block=hangulcompatibilityjamo}', "");
    Expect(0, 12688, '\p{Block=hangulcompatibilityjamo}', "");
    Expect(1, 12688, '\p{^Block=hangulcompatibilityjamo}', "");
    Expect(1, 12688, '\P{Block=hangulcompatibilityjamo}', "");
    Expect(0, 12688, '\P{^Block=hangulcompatibilityjamo}', "");
    Expect(1, 12687, '\p{Block=:\Ahangulcompatibilityjamo\z:}', "");;
    Expect(0, 12688, '\p{Block=:\Ahangulcompatibilityjamo\z:}', "");;
    Expect(1, 12687, '\p{Block=-Hangul_Compatibility_jamo}', "");
    Expect(0, 12687, '\p{^Block=-Hangul_Compatibility_jamo}', "");
    Expect(0, 12687, '\P{Block=-Hangul_Compatibility_jamo}', "");
    Expect(1, 12687, '\P{^Block=-Hangul_Compatibility_jamo}', "");
    Expect(0, 12688, '\p{Block=-Hangul_Compatibility_jamo}', "");
    Expect(1, 12688, '\p{^Block=-Hangul_Compatibility_jamo}', "");
    Expect(1, 12688, '\P{Block=-Hangul_Compatibility_jamo}', "");
    Expect(0, 12688, '\P{^Block=-Hangul_Compatibility_jamo}', "");
    Error('\p{Blk=:=Compat_Jamo}');
    Error('\P{Blk=:=Compat_Jamo}');
    Expect(1, 12687, '\p{Blk=:\ACompat_Jamo\z:}', "");;
    Expect(0, 12688, '\p{Blk=:\ACompat_Jamo\z:}', "");;
    Expect(1, 12687, '\p{Blk=compatjamo}', "");
    Expect(0, 12687, '\p{^Blk=compatjamo}', "");
    Expect(0, 12687, '\P{Blk=compatjamo}', "");
    Expect(1, 12687, '\P{^Blk=compatjamo}', "");
    Expect(0, 12688, '\p{Blk=compatjamo}', "");
    Expect(1, 12688, '\p{^Blk=compatjamo}', "");
    Expect(1, 12688, '\P{Blk=compatjamo}', "");
    Expect(0, 12688, '\P{^Blk=compatjamo}', "");
    Expect(1, 12687, '\p{Blk=:\Acompatjamo\z:}', "");;
    Expect(0, 12688, '\p{Blk=:\Acompatjamo\z:}', "");;
    Expect(1, 12687, '\p{Blk=--COMPAT_Jamo}', "");
    Expect(0, 12687, '\p{^Blk=--COMPAT_Jamo}', "");
    Expect(0, 12687, '\P{Blk=--COMPAT_Jamo}', "");
    Expect(1, 12687, '\P{^Blk=--COMPAT_Jamo}', "");
    Expect(0, 12688, '\p{Blk=--COMPAT_Jamo}', "");
    Expect(1, 12688, '\p{^Blk=--COMPAT_Jamo}', "");
    Expect(1, 12688, '\P{Blk=--COMPAT_Jamo}', "");
    Expect(0, 12688, '\P{^Blk=--COMPAT_Jamo}', "");
    Error('\p{Is_Block=/a/hangul_COMPATIBILITY_Jamo}');
    Error('\P{Is_Block=/a/hangul_COMPATIBILITY_Jamo}');
    Expect(1, 12687, '\p{Is_Block=hangulcompatibilityjamo}', "");
    Expect(0, 12687, '\p{^Is_Block=hangulcompatibilityjamo}', "");
    Expect(0, 12687, '\P{Is_Block=hangulcompatibilityjamo}', "");
    Expect(1, 12687, '\P{^Is_Block=hangulcompatibilityjamo}', "");
    Expect(0, 12688, '\p{Is_Block=hangulcompatibilityjamo}', "");
    Expect(1, 12688, '\p{^Is_Block=hangulcompatibilityjamo}', "");
    Expect(1, 12688, '\P{Is_Block=hangulcompatibilityjamo}', "");
    Expect(0, 12688, '\P{^Is_Block=hangulcompatibilityjamo}', "");
    Expect(1, 12687, '\p{Is_Block= _HANGUL_compatibility_JAMO}', "");
    Expect(0, 12687, '\p{^Is_Block= _HANGUL_compatibility_JAMO}', "");
    Expect(0, 12687, '\P{Is_Block= _HANGUL_compatibility_JAMO}', "");
    Expect(1, 12687, '\P{^Is_Block= _HANGUL_compatibility_JAMO}', "");
    Expect(0, 12688, '\p{Is_Block= _HANGUL_compatibility_JAMO}', "");
    Expect(1, 12688, '\p{^Is_Block= _HANGUL_compatibility_JAMO}', "");
    Expect(1, 12688, '\P{Is_Block= _HANGUL_compatibility_JAMO}', "");
    Expect(0, 12688, '\P{^Is_Block= _HANGUL_compatibility_JAMO}', "");
    Error('\p{Is_Blk=	 Compat_Jamo/a/}');
    Error('\P{Is_Blk=	 Compat_Jamo/a/}');
    Expect(1, 12687, '\p{Is_Blk=compatjamo}', "");
    Expect(0, 12687, '\p{^Is_Blk=compatjamo}', "");
    Expect(0, 12687, '\P{Is_Blk=compatjamo}', "");
    Expect(1, 12687, '\P{^Is_Blk=compatjamo}', "");
    Expect(0, 12688, '\p{Is_Blk=compatjamo}', "");
    Expect(1, 12688, '\p{^Is_Blk=compatjamo}', "");
    Expect(1, 12688, '\P{Is_Blk=compatjamo}', "");
    Expect(0, 12688, '\P{^Is_Blk=compatjamo}', "");
    Expect(1, 12687, '\p{Is_Blk=--Compat_jamo}', "");
    Expect(0, 12687, '\p{^Is_Blk=--Compat_jamo}', "");
    Expect(0, 12687, '\P{Is_Blk=--Compat_jamo}', "");
    Expect(1, 12687, '\P{^Is_Blk=--Compat_jamo}', "");
    Expect(0, 12688, '\p{Is_Blk=--Compat_jamo}', "");
    Expect(1, 12688, '\p{^Is_Blk=--Compat_jamo}', "");
    Expect(1, 12688, '\P{Is_Blk=--Compat_jamo}', "");
    Expect(0, 12688, '\P{^Is_Blk=--Compat_jamo}', "");
    Error('\p{Block=/a/Control_Pictures}');
    Error('\P{Block=/a/Control_Pictures}');
    Expect(1, 9279, '\p{Block=:\AControl_Pictures\z:}', "");;
    Expect(0, 9280, '\p{Block=:\AControl_Pictures\z:}', "");;
    Expect(1, 9279, '\p{Block=controlpictures}', "");
    Expect(0, 9279, '\p{^Block=controlpictures}', "");
    Expect(0, 9279, '\P{Block=controlpictures}', "");
    Expect(1, 9279, '\P{^Block=controlpictures}', "");
    Expect(0, 9280, '\p{Block=controlpictures}', "");
    Expect(1, 9280, '\p{^Block=controlpictures}', "");
    Expect(1, 9280, '\P{Block=controlpictures}', "");
    Expect(0, 9280, '\P{^Block=controlpictures}', "");
    Expect(1, 9279, '\p{Block=:\Acontrolpictures\z:}', "");;
    Expect(0, 9280, '\p{Block=:\Acontrolpictures\z:}', "");;
    Expect(1, 9279, '\p{Block=CONTROL_PICTURES}', "");
    Expect(0, 9279, '\p{^Block=CONTROL_PICTURES}', "");
    Expect(0, 9279, '\P{Block=CONTROL_PICTURES}', "");
    Expect(1, 9279, '\P{^Block=CONTROL_PICTURES}', "");
    Expect(0, 9280, '\p{Block=CONTROL_PICTURES}', "");
    Expect(1, 9280, '\p{^Block=CONTROL_PICTURES}', "");
    Expect(1, 9280, '\P{Block=CONTROL_PICTURES}', "");
    Expect(0, 9280, '\P{^Block=CONTROL_PICTURES}', "");
    Error('\p{Blk=:=-CONTROL_Pictures}');
    Error('\P{Blk=:=-CONTROL_Pictures}');
    Expect(1, 9279, '\p{Blk=:\AControl_Pictures\z:}', "");;
    Expect(0, 9280, '\p{Blk=:\AControl_Pictures\z:}', "");;
    Expect(1, 9279, '\p{Blk=controlpictures}', "");
    Expect(0, 9279, '\p{^Blk=controlpictures}', "");
    Expect(0, 9279, '\P{Blk=controlpictures}', "");
    Expect(1, 9279, '\P{^Blk=controlpictures}', "");
    Expect(0, 9280, '\p{Blk=controlpictures}', "");
    Expect(1, 9280, '\p{^Blk=controlpictures}', "");
    Expect(1, 9280, '\P{Blk=controlpictures}', "");
    Expect(0, 9280, '\P{^Blk=controlpictures}', "");
    Expect(1, 9279, '\p{Blk=:\Acontrolpictures\z:}', "");;
    Expect(0, 9280, '\p{Blk=:\Acontrolpictures\z:}', "");;
    Expect(1, 9279, '\p{Blk=	-Control_Pictures}', "");
    Expect(0, 9279, '\p{^Blk=	-Control_Pictures}', "");
    Expect(0, 9279, '\P{Blk=	-Control_Pictures}', "");
    Expect(1, 9279, '\P{^Blk=	-Control_Pictures}', "");
    Expect(0, 9280, '\p{Blk=	-Control_Pictures}', "");
    Expect(1, 9280, '\p{^Blk=	-Control_Pictures}', "");
    Expect(1, 9280, '\P{Blk=	-Control_Pictures}', "");
    Expect(0, 9280, '\P{^Blk=	-Control_Pictures}', "");
    Error('\p{Is_Block=	:=Control_Pictures}');
    Error('\P{Is_Block=	:=Control_Pictures}');
    Expect(1, 9279, '\p{Is_Block=controlpictures}', "");
    Expect(0, 9279, '\p{^Is_Block=controlpictures}', "");
    Expect(0, 9279, '\P{Is_Block=controlpictures}', "");
    Expect(1, 9279, '\P{^Is_Block=controlpictures}', "");
    Expect(0, 9280, '\p{Is_Block=controlpictures}', "");
    Expect(1, 9280, '\p{^Is_Block=controlpictures}', "");
    Expect(1, 9280, '\P{Is_Block=controlpictures}', "");
    Expect(0, 9280, '\P{^Is_Block=controlpictures}', "");
    Expect(1, 9279, '\p{Is_Block=- control_Pictures}', "");
    Expect(0, 9279, '\p{^Is_Block=- control_Pictures}', "");
    Expect(0, 9279, '\P{Is_Block=- control_Pictures}', "");
    Expect(1, 9279, '\P{^Is_Block=- control_Pictures}', "");
    Expect(0, 9280, '\p{Is_Block=- control_Pictures}', "");
    Expect(1, 9280, '\p{^Is_Block=- control_Pictures}', "");
    Expect(1, 9280, '\P{Is_Block=- control_Pictures}', "");
    Expect(0, 9280, '\P{^Is_Block=- control_Pictures}', "");
    Error('\p{Is_Blk:_Control_Pictures/a/}');
    Error('\P{Is_Blk:_Control_Pictures/a/}');
    Expect(1, 9279, '\p{Is_Blk=controlpictures}', "");
    Expect(0, 9279, '\p{^Is_Blk=controlpictures}', "");
    Expect(0, 9279, '\P{Is_Blk=controlpictures}', "");
    Expect(1, 9279, '\P{^Is_Blk=controlpictures}', "");
    Expect(0, 9280, '\p{Is_Blk=controlpictures}', "");
    Expect(1, 9280, '\p{^Is_Blk=controlpictures}', "");
    Expect(1, 9280, '\P{Is_Blk=controlpictures}', "");
    Expect(0, 9280, '\P{^Is_Blk=controlpictures}', "");
    Expect(1, 9279, '\p{Is_Blk=	control_pictures}', "");
    Expect(0, 9279, '\p{^Is_Blk=	control_pictures}', "");
    Expect(0, 9279, '\P{Is_Blk=	control_pictures}', "");
    Expect(1, 9279, '\P{^Is_Blk=	control_pictures}', "");
    Expect(0, 9280, '\p{Is_Blk=	control_pictures}', "");
    Expect(1, 9280, '\p{^Is_Blk=	control_pictures}', "");
    Expect(1, 9280, '\P{Is_Blk=	control_pictures}', "");
    Expect(0, 9280, '\P{^Is_Blk=	control_pictures}', "");
    Error('\p{Block=_:=Coptic}');
    Error('\P{Block=_:=Coptic}');
    Expect(1, 11519, '\p{Block=:\ACoptic\z:}', "");;
    Expect(0, 11520, '\p{Block=:\ACoptic\z:}', "");;
    Expect(1, 11519, '\p{Block=coptic}', "");
    Expect(0, 11519, '\p{^Block=coptic}', "");
    Expect(0, 11519, '\P{Block=coptic}', "");
    Expect(1, 11519, '\P{^Block=coptic}', "");
    Expect(0, 11520, '\p{Block=coptic}', "");
    Expect(1, 11520, '\p{^Block=coptic}', "");
    Expect(1, 11520, '\P{Block=coptic}', "");
    Expect(0, 11520, '\P{^Block=coptic}', "");
    Expect(1, 11519, '\p{Block=:\Acoptic\z:}', "");;
    Expect(0, 11520, '\p{Block=:\Acoptic\z:}', "");;
    Expect(1, 11519, '\p{Block=	Coptic}', "");
    Expect(0, 11519, '\p{^Block=	Coptic}', "");
    Expect(0, 11519, '\P{Block=	Coptic}', "");
    Expect(1, 11519, '\P{^Block=	Coptic}', "");
    Expect(0, 11520, '\p{Block=	Coptic}', "");
    Expect(1, 11520, '\p{^Block=	Coptic}', "");
    Expect(1, 11520, '\P{Block=	Coptic}', "");
    Expect(0, 11520, '\P{^Block=	Coptic}', "");
    Error('\p{Blk= COPTIC:=}');
    Error('\P{Blk= COPTIC:=}');
    Expect(1, 11519, '\p{Blk=:\ACoptic\z:}', "");;
    Expect(0, 11520, '\p{Blk=:\ACoptic\z:}', "");;
    Expect(1, 11519, '\p{Blk=coptic}', "");
    Expect(0, 11519, '\p{^Blk=coptic}', "");
    Expect(0, 11519, '\P{Blk=coptic}', "");
    Expect(1, 11519, '\P{^Blk=coptic}', "");
    Expect(0, 11520, '\p{Blk=coptic}', "");
    Expect(1, 11520, '\p{^Blk=coptic}', "");
    Expect(1, 11520, '\P{Blk=coptic}', "");
    Expect(0, 11520, '\P{^Blk=coptic}', "");
    Expect(1, 11519, '\p{Blk=:\Acoptic\z:}', "");;
    Expect(0, 11520, '\p{Blk=:\Acoptic\z:}', "");;
    Expect(1, 11519, '\p{Blk=	Coptic}', "");
    Expect(0, 11519, '\p{^Blk=	Coptic}', "");
    Expect(0, 11519, '\P{Blk=	Coptic}', "");
    Expect(1, 11519, '\P{^Blk=	Coptic}', "");
    Expect(0, 11520, '\p{Blk=	Coptic}', "");
    Expect(1, 11520, '\p{^Blk=	Coptic}', "");
    Expect(1, 11520, '\P{Blk=	Coptic}', "");
    Expect(0, 11520, '\P{^Blk=	Coptic}', "");
    Error('\p{Is_Block=/a/		Coptic}');
    Error('\P{Is_Block=/a/		Coptic}');
    Expect(1, 11519, '\p{Is_Block=coptic}', "");
    Expect(0, 11519, '\p{^Is_Block=coptic}', "");
    Expect(0, 11519, '\P{Is_Block=coptic}', "");
    Expect(1, 11519, '\P{^Is_Block=coptic}', "");
    Expect(0, 11520, '\p{Is_Block=coptic}', "");
    Expect(1, 11520, '\p{^Is_Block=coptic}', "");
    Expect(1, 11520, '\P{Is_Block=coptic}', "");
    Expect(0, 11520, '\P{^Is_Block=coptic}', "");
    Expect(1, 11519, '\p{Is_Block: 	Coptic}', "");
    Expect(0, 11519, '\p{^Is_Block: 	Coptic}', "");
    Expect(0, 11519, '\P{Is_Block: 	Coptic}', "");
    Expect(1, 11519, '\P{^Is_Block: 	Coptic}', "");
    Expect(0, 11520, '\p{Is_Block: 	Coptic}', "");
    Expect(1, 11520, '\p{^Is_Block: 	Coptic}', "");
    Expect(1, 11520, '\P{Is_Block: 	Coptic}', "");
    Expect(0, 11520, '\P{^Is_Block: 	Coptic}', "");
    Error('\p{Is_Blk=_-Coptic:=}');
    Error('\P{Is_Blk=_-Coptic:=}');
    Expect(1, 11519, '\p{Is_Blk=coptic}', "");
    Expect(0, 11519, '\p{^Is_Blk=coptic}', "");
    Expect(0, 11519, '\P{Is_Blk=coptic}', "");
    Expect(1, 11519, '\P{^Is_Blk=coptic}', "");
    Expect(0, 11520, '\p{Is_Blk=coptic}', "");
    Expect(1, 11520, '\p{^Is_Blk=coptic}', "");
    Expect(1, 11520, '\P{Is_Blk=coptic}', "");
    Expect(0, 11520, '\P{^Is_Blk=coptic}', "");
    Expect(1, 11519, '\p{Is_Blk=_	Coptic}', "");
    Expect(0, 11519, '\p{^Is_Blk=_	Coptic}', "");
    Expect(0, 11519, '\P{Is_Blk=_	Coptic}', "");
    Expect(1, 11519, '\P{^Is_Blk=_	Coptic}', "");
    Expect(0, 11520, '\p{Is_Blk=_	Coptic}', "");
    Expect(1, 11520, '\p{^Is_Blk=_	Coptic}', "");
    Expect(1, 11520, '\P{Is_Blk=_	Coptic}', "");
    Expect(0, 11520, '\P{^Is_Blk=_	Coptic}', "");
    Error('\p{Block=	:=COPTIC_Epact_Numbers}');
    Error('\P{Block=	:=COPTIC_Epact_Numbers}');
    Expect(1, 66303, '\p{Block=:\ACoptic_Epact_Numbers\z:}', "");;
    Expect(0, 66304, '\p{Block=:\ACoptic_Epact_Numbers\z:}', "");;
    Expect(1, 66303, '\p{Block=copticepactnumbers}', "");
    Expect(0, 66303, '\p{^Block=copticepactnumbers}', "");
    Expect(0, 66303, '\P{Block=copticepactnumbers}', "");
    Expect(1, 66303, '\P{^Block=copticepactnumbers}', "");
    Expect(0, 66304, '\p{Block=copticepactnumbers}', "");
    Expect(1, 66304, '\p{^Block=copticepactnumbers}', "");
    Expect(1, 66304, '\P{Block=copticepactnumbers}', "");
    Expect(0, 66304, '\P{^Block=copticepactnumbers}', "");
    Expect(1, 66303, '\p{Block=:\Acopticepactnumbers\z:}', "");;
    Expect(0, 66304, '\p{Block=:\Acopticepactnumbers\z:}', "");;
    Expect(1, 66303, '\p{Block=_	COPTIC_EPACT_NUMBERS}', "");
    Expect(0, 66303, '\p{^Block=_	COPTIC_EPACT_NUMBERS}', "");
    Expect(0, 66303, '\P{Block=_	COPTIC_EPACT_NUMBERS}', "");
    Expect(1, 66303, '\P{^Block=_	COPTIC_EPACT_NUMBERS}', "");
    Expect(0, 66304, '\p{Block=_	COPTIC_EPACT_NUMBERS}', "");
    Expect(1, 66304, '\p{^Block=_	COPTIC_EPACT_NUMBERS}', "");
    Expect(1, 66304, '\P{Block=_	COPTIC_EPACT_NUMBERS}', "");
    Expect(0, 66304, '\P{^Block=_	COPTIC_EPACT_NUMBERS}', "");
    Error('\p{Blk=-/a/Coptic_epact_Numbers}');
    Error('\P{Blk=-/a/Coptic_epact_Numbers}');
    Expect(1, 66303, '\p{Blk=:\ACoptic_Epact_Numbers\z:}', "");;
    Expect(0, 66304, '\p{Blk=:\ACoptic_Epact_Numbers\z:}', "");;
    Expect(1, 66303, '\p{Blk=copticepactnumbers}', "");
    Expect(0, 66303, '\p{^Blk=copticepactnumbers}', "");
    Expect(0, 66303, '\P{Blk=copticepactnumbers}', "");
    Expect(1, 66303, '\P{^Blk=copticepactnumbers}', "");
    Expect(0, 66304, '\p{Blk=copticepactnumbers}', "");
    Expect(1, 66304, '\p{^Blk=copticepactnumbers}', "");
    Expect(1, 66304, '\P{Blk=copticepactnumbers}', "");
    Expect(0, 66304, '\P{^Blk=copticepactnumbers}', "");
    Expect(1, 66303, '\p{Blk=:\Acopticepactnumbers\z:}', "");;
    Expect(0, 66304, '\p{Blk=:\Acopticepactnumbers\z:}', "");;
    Expect(1, 66303, '\p{Blk=		coptic_Epact_Numbers}', "");
    Expect(0, 66303, '\p{^Blk=		coptic_Epact_Numbers}', "");
    Expect(0, 66303, '\P{Blk=		coptic_Epact_Numbers}', "");
    Expect(1, 66303, '\P{^Blk=		coptic_Epact_Numbers}', "");
    Expect(0, 66304, '\p{Blk=		coptic_Epact_Numbers}', "");
    Expect(1, 66304, '\p{^Blk=		coptic_Epact_Numbers}', "");
    Expect(1, 66304, '\P{Blk=		coptic_Epact_Numbers}', "");
    Expect(0, 66304, '\P{^Blk=		coptic_Epact_Numbers}', "");
    Error('\p{Is_Block=	_Coptic_Epact_NUMBERS:=}');
    Error('\P{Is_Block=	_Coptic_Epact_NUMBERS:=}');
    Expect(1, 66303, '\p{Is_Block=copticepactnumbers}', "");
    Expect(0, 66303, '\p{^Is_Block=copticepactnumbers}', "");
    Expect(0, 66303, '\P{Is_Block=copticepactnumbers}', "");
    Expect(1, 66303, '\P{^Is_Block=copticepactnumbers}', "");
    Expect(0, 66304, '\p{Is_Block=copticepactnumbers}', "");
    Expect(1, 66304, '\p{^Is_Block=copticepactnumbers}', "");
    Expect(1, 66304, '\P{Is_Block=copticepactnumbers}', "");
    Expect(0, 66304, '\P{^Is_Block=copticepactnumbers}', "");
    Expect(1, 66303, '\p{Is_Block=_coptic_EPACT_NUMBERS}', "");
    Expect(0, 66303, '\p{^Is_Block=_coptic_EPACT_NUMBERS}', "");
    Expect(0, 66303, '\P{Is_Block=_coptic_EPACT_NUMBERS}', "");
    Expect(1, 66303, '\P{^Is_Block=_coptic_EPACT_NUMBERS}', "");
    Expect(0, 66304, '\p{Is_Block=_coptic_EPACT_NUMBERS}', "");
    Expect(1, 66304, '\p{^Is_Block=_coptic_EPACT_NUMBERS}', "");
    Expect(1, 66304, '\P{Is_Block=_coptic_EPACT_NUMBERS}', "");
    Expect(0, 66304, '\P{^Is_Block=_coptic_EPACT_NUMBERS}', "");
    Error('\p{Is_Blk=_-COPTIC_Epact_NUMBERS:=}');
    Error('\P{Is_Blk=_-COPTIC_Epact_NUMBERS:=}');
    Expect(1, 66303, '\p{Is_Blk: copticepactnumbers}', "");
    Expect(0, 66303, '\p{^Is_Blk: copticepactnumbers}', "");
    Expect(0, 66303, '\P{Is_Blk: copticepactnumbers}', "");
    Expect(1, 66303, '\P{^Is_Blk: copticepactnumbers}', "");
    Expect(0, 66304, '\p{Is_Blk: copticepactnumbers}', "");
    Expect(1, 66304, '\p{^Is_Blk: copticepactnumbers}', "");
    Expect(1, 66304, '\P{Is_Blk: copticepactnumbers}', "");
    Expect(0, 66304, '\P{^Is_Blk: copticepactnumbers}', "");
    Expect(1, 66303, '\p{Is_Blk=__Coptic_epact_Numbers}', "");
    Expect(0, 66303, '\p{^Is_Blk=__Coptic_epact_Numbers}', "");
    Expect(0, 66303, '\P{Is_Blk=__Coptic_epact_Numbers}', "");
    Expect(1, 66303, '\P{^Is_Blk=__Coptic_epact_Numbers}', "");
    Expect(0, 66304, '\p{Is_Blk=__Coptic_epact_Numbers}', "");
    Expect(1, 66304, '\p{^Is_Blk=__Coptic_epact_Numbers}', "");
    Expect(1, 66304, '\P{Is_Blk=__Coptic_epact_Numbers}', "");
    Expect(0, 66304, '\P{^Is_Blk=__Coptic_epact_Numbers}', "");
    Error('\p{Block=_:=COUNTING_ROD_Numerals}');
    Error('\P{Block=_:=COUNTING_ROD_Numerals}');
    Expect(1, 119679, '\p{Block=:\ACounting_Rod_Numerals\z:}', "");;
    Expect(0, 119680, '\p{Block=:\ACounting_Rod_Numerals\z:}', "");;
    Expect(1, 119679, '\p{Block=countingrodnumerals}', "");
    Expect(0, 119679, '\p{^Block=countingrodnumerals}', "");
    Expect(0, 119679, '\P{Block=countingrodnumerals}', "");
    Expect(1, 119679, '\P{^Block=countingrodnumerals}', "");
    Expect(0, 119680, '\p{Block=countingrodnumerals}', "");
    Expect(1, 119680, '\p{^Block=countingrodnumerals}', "");
    Expect(1, 119680, '\P{Block=countingrodnumerals}', "");
    Expect(0, 119680, '\P{^Block=countingrodnumerals}', "");
    Expect(1, 119679, '\p{Block=:\Acountingrodnumerals\z:}', "");;
    Expect(0, 119680, '\p{Block=:\Acountingrodnumerals\z:}', "");;
    Expect(1, 119679, '\p{Block=	-Counting_ROD_Numerals}', "");
    Expect(0, 119679, '\p{^Block=	-Counting_ROD_Numerals}', "");
    Expect(0, 119679, '\P{Block=	-Counting_ROD_Numerals}', "");
    Expect(1, 119679, '\P{^Block=	-Counting_ROD_Numerals}', "");
    Expect(0, 119680, '\p{Block=	-Counting_ROD_Numerals}', "");
    Expect(1, 119680, '\p{^Block=	-Counting_ROD_Numerals}', "");
    Expect(1, 119680, '\P{Block=	-Counting_ROD_Numerals}', "");
    Expect(0, 119680, '\P{^Block=	-Counting_ROD_Numerals}', "");
    Error('\p{Blk=-Counting_rod:=}');
    Error('\P{Blk=-Counting_rod:=}');
    Expect(1, 119679, '\p{Blk=:\ACounting_Rod\z:}', "");;
    Expect(0, 119680, '\p{Blk=:\ACounting_Rod\z:}', "");;
    Expect(1, 119679, '\p{Blk=countingrod}', "");
    Expect(0, 119679, '\p{^Blk=countingrod}', "");
    Expect(0, 119679, '\P{Blk=countingrod}', "");
    Expect(1, 119679, '\P{^Blk=countingrod}', "");
    Expect(0, 119680, '\p{Blk=countingrod}', "");
    Expect(1, 119680, '\p{^Blk=countingrod}', "");
    Expect(1, 119680, '\P{Blk=countingrod}', "");
    Expect(0, 119680, '\P{^Blk=countingrod}', "");
    Expect(1, 119679, '\p{Blk=:\Acountingrod\z:}', "");;
    Expect(0, 119680, '\p{Blk=:\Acountingrod\z:}', "");;
    Expect(1, 119679, '\p{Blk=_Counting_Rod}', "");
    Expect(0, 119679, '\p{^Blk=_Counting_Rod}', "");
    Expect(0, 119679, '\P{Blk=_Counting_Rod}', "");
    Expect(1, 119679, '\P{^Blk=_Counting_Rod}', "");
    Expect(0, 119680, '\p{Blk=_Counting_Rod}', "");
    Expect(1, 119680, '\p{^Blk=_Counting_Rod}', "");
    Expect(1, 119680, '\P{Blk=_Counting_Rod}', "");
    Expect(0, 119680, '\P{^Blk=_Counting_Rod}', "");
    Error('\p{Is_Block=	_Counting_rod_numerals:=}');
    Error('\P{Is_Block=	_Counting_rod_numerals:=}');
    Expect(1, 119679, '\p{Is_Block=countingrodnumerals}', "");
    Expect(0, 119679, '\p{^Is_Block=countingrodnumerals}', "");
    Expect(0, 119679, '\P{Is_Block=countingrodnumerals}', "");
    Expect(1, 119679, '\P{^Is_Block=countingrodnumerals}', "");
    Expect(0, 119680, '\p{Is_Block=countingrodnumerals}', "");
    Expect(1, 119680, '\p{^Is_Block=countingrodnumerals}', "");
    Expect(1, 119680, '\P{Is_Block=countingrodnumerals}', "");
    Expect(0, 119680, '\P{^Is_Block=countingrodnumerals}', "");
    Expect(1, 119679, '\p{Is_Block=--Counting_Rod_Numerals}', "");
    Expect(0, 119679, '\p{^Is_Block=--Counting_Rod_Numerals}', "");
    Expect(0, 119679, '\P{Is_Block=--Counting_Rod_Numerals}', "");
    Expect(1, 119679, '\P{^Is_Block=--Counting_Rod_Numerals}', "");
    Expect(0, 119680, '\p{Is_Block=--Counting_Rod_Numerals}', "");
    Expect(1, 119680, '\p{^Is_Block=--Counting_Rod_Numerals}', "");
    Expect(1, 119680, '\P{Is_Block=--Counting_Rod_Numerals}', "");
    Expect(0, 119680, '\P{^Is_Block=--Counting_Rod_Numerals}', "");
    Error('\p{Is_Blk=	COUNTING_Rod/a/}');
    Error('\P{Is_Blk=	COUNTING_Rod/a/}');
    Expect(1, 119679, '\p{Is_Blk=countingrod}', "");
    Expect(0, 119679, '\p{^Is_Blk=countingrod}', "");
    Expect(0, 119679, '\P{Is_Blk=countingrod}', "");
    Expect(1, 119679, '\P{^Is_Blk=countingrod}', "");
    Expect(0, 119680, '\p{Is_Blk=countingrod}', "");
    Expect(1, 119680, '\p{^Is_Blk=countingrod}', "");
    Expect(1, 119680, '\P{Is_Blk=countingrod}', "");
    Expect(0, 119680, '\P{^Is_Blk=countingrod}', "");
    Expect(1, 119679, '\p{Is_Blk= Counting_Rod}', "");
    Expect(0, 119679, '\p{^Is_Blk= Counting_Rod}', "");
    Expect(0, 119679, '\P{Is_Blk= Counting_Rod}', "");
    Expect(1, 119679, '\P{^Is_Blk= Counting_Rod}', "");
    Expect(0, 119680, '\p{Is_Blk= Counting_Rod}', "");
    Expect(1, 119680, '\p{^Is_Blk= Counting_Rod}', "");
    Expect(1, 119680, '\P{Is_Blk= Counting_Rod}', "");
    Expect(0, 119680, '\P{^Is_Blk= Counting_Rod}', "");
    Error('\p{Block=/a/- CUNEIFORM}');
    Error('\P{Block=/a/- CUNEIFORM}');
    Expect(1, 74751, '\p{Block=:\ACuneiform\z:}', "");;
    Expect(0, 74752, '\p{Block=:\ACuneiform\z:}', "");;
    Expect(1, 74751, '\p{Block=cuneiform}', "");
    Expect(0, 74751, '\p{^Block=cuneiform}', "");
    Expect(0, 74751, '\P{Block=cuneiform}', "");
    Expect(1, 74751, '\P{^Block=cuneiform}', "");
    Expect(0, 74752, '\p{Block=cuneiform}', "");
    Expect(1, 74752, '\p{^Block=cuneiform}', "");
    Expect(1, 74752, '\P{Block=cuneiform}', "");
    Expect(0, 74752, '\P{^Block=cuneiform}', "");
    Expect(1, 74751, '\p{Block=:\Acuneiform\z:}', "");;
    Expect(0, 74752, '\p{Block=:\Acuneiform\z:}', "");;
    Expect(1, 74751, '\p{Block= 	cuneiform}', "");
    Expect(0, 74751, '\p{^Block= 	cuneiform}', "");
    Expect(0, 74751, '\P{Block= 	cuneiform}', "");
    Expect(1, 74751, '\P{^Block= 	cuneiform}', "");
    Expect(0, 74752, '\p{Block= 	cuneiform}', "");
    Expect(1, 74752, '\p{^Block= 	cuneiform}', "");
    Expect(1, 74752, '\P{Block= 	cuneiform}', "");
    Expect(0, 74752, '\P{^Block= 	cuneiform}', "");
    Error('\p{Blk=:=Cuneiform}');
    Error('\P{Blk=:=Cuneiform}');
    Expect(1, 74751, '\p{Blk=:\ACuneiform\z:}', "");;
    Expect(0, 74752, '\p{Blk=:\ACuneiform\z:}', "");;
    Expect(1, 74751, '\p{Blk=cuneiform}', "");
    Expect(0, 74751, '\p{^Blk=cuneiform}', "");
    Expect(0, 74751, '\P{Blk=cuneiform}', "");
    Expect(1, 74751, '\P{^Blk=cuneiform}', "");
    Expect(0, 74752, '\p{Blk=cuneiform}', "");
    Expect(1, 74752, '\p{^Blk=cuneiform}', "");
    Expect(1, 74752, '\P{Blk=cuneiform}', "");
    Expect(0, 74752, '\P{^Blk=cuneiform}', "");
    Expect(1, 74751, '\p{Blk=:\Acuneiform\z:}', "");;
    Expect(0, 74752, '\p{Blk=:\Acuneiform\z:}', "");;
    Expect(1, 74751, '\p{Blk=-CUNEIFORM}', "");
    Expect(0, 74751, '\p{^Blk=-CUNEIFORM}', "");
    Expect(0, 74751, '\P{Blk=-CUNEIFORM}', "");
    Expect(1, 74751, '\P{^Blk=-CUNEIFORM}', "");
    Expect(0, 74752, '\p{Blk=-CUNEIFORM}', "");
    Expect(1, 74752, '\p{^Blk=-CUNEIFORM}', "");
    Expect(1, 74752, '\P{Blk=-CUNEIFORM}', "");
    Expect(0, 74752, '\P{^Blk=-CUNEIFORM}', "");
    Error('\p{Is_Block= :=CUNEIFORM}');
    Error('\P{Is_Block= :=CUNEIFORM}');
    Expect(1, 74751, '\p{Is_Block=cuneiform}', "");
    Expect(0, 74751, '\p{^Is_Block=cuneiform}', "");
    Expect(0, 74751, '\P{Is_Block=cuneiform}', "");
    Expect(1, 74751, '\P{^Is_Block=cuneiform}', "");
    Expect(0, 74752, '\p{Is_Block=cuneiform}', "");
    Expect(1, 74752, '\p{^Is_Block=cuneiform}', "");
    Expect(1, 74752, '\P{Is_Block=cuneiform}', "");
    Expect(0, 74752, '\P{^Is_Block=cuneiform}', "");
    Expect(1, 74751, '\p{Is_Block= Cuneiform}', "");
    Expect(0, 74751, '\p{^Is_Block= Cuneiform}', "");
    Expect(0, 74751, '\P{Is_Block= Cuneiform}', "");
    Expect(1, 74751, '\P{^Is_Block= Cuneiform}', "");
    Expect(0, 74752, '\p{Is_Block= Cuneiform}', "");
    Expect(1, 74752, '\p{^Is_Block= Cuneiform}', "");
    Expect(1, 74752, '\P{Is_Block= Cuneiform}', "");
    Expect(0, 74752, '\P{^Is_Block= Cuneiform}', "");
    Error('\p{Is_Blk:   	_Cuneiform:=}');
    Error('\P{Is_Blk:   	_Cuneiform:=}');
    Expect(1, 74751, '\p{Is_Blk=cuneiform}', "");
    Expect(0, 74751, '\p{^Is_Blk=cuneiform}', "");
    Expect(0, 74751, '\P{Is_Blk=cuneiform}', "");
    Expect(1, 74751, '\P{^Is_Blk=cuneiform}', "");
    Expect(0, 74752, '\p{Is_Blk=cuneiform}', "");
    Expect(1, 74752, '\p{^Is_Blk=cuneiform}', "");
    Expect(1, 74752, '\P{Is_Blk=cuneiform}', "");
    Expect(0, 74752, '\P{^Is_Blk=cuneiform}', "");
    Expect(1, 74751, '\p{Is_Blk= CUNEIFORM}', "");
    Expect(0, 74751, '\p{^Is_Blk= CUNEIFORM}', "");
    Expect(0, 74751, '\P{Is_Blk= CUNEIFORM}', "");
    Expect(1, 74751, '\P{^Is_Blk= CUNEIFORM}', "");
    Expect(0, 74752, '\p{Is_Blk= CUNEIFORM}', "");
    Expect(1, 74752, '\p{^Is_Blk= CUNEIFORM}', "");
    Expect(1, 74752, '\P{Is_Blk= CUNEIFORM}', "");
    Expect(0, 74752, '\P{^Is_Blk= CUNEIFORM}', "");
    Error('\p{Block=_/a/cuneiform_numbers_AND_punctuation}');
    Error('\P{Block=_/a/cuneiform_numbers_AND_punctuation}');
    Expect(1, 74879, '\p{Block=:\ACuneiform_Numbers_And_Punctuation\z:}', "");;
    Expect(0, 74880, '\p{Block=:\ACuneiform_Numbers_And_Punctuation\z:}', "");;
    Expect(1, 74879, '\p{Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\p{^Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\P{Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\P{^Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\p{Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\p{^Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\P{Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\P{^Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\p{Block=:\Acuneiformnumbersandpunctuation\z:}', "");;
    Expect(0, 74880, '\p{Block=:\Acuneiformnumbersandpunctuation\z:}', "");;
    Expect(1, 74879, '\p{Block=	-CUNEIFORM_Numbers_And_PUNCTUATION}', "");
    Expect(0, 74879, '\p{^Block=	-CUNEIFORM_Numbers_And_PUNCTUATION}', "");
    Expect(0, 74879, '\P{Block=	-CUNEIFORM_Numbers_And_PUNCTUATION}', "");
    Expect(1, 74879, '\P{^Block=	-CUNEIFORM_Numbers_And_PUNCTUATION}', "");
    Expect(0, 74880, '\p{Block=	-CUNEIFORM_Numbers_And_PUNCTUATION}', "");
    Expect(1, 74880, '\p{^Block=	-CUNEIFORM_Numbers_And_PUNCTUATION}', "");
    Expect(1, 74880, '\P{Block=	-CUNEIFORM_Numbers_And_PUNCTUATION}', "");
    Expect(0, 74880, '\P{^Block=	-CUNEIFORM_Numbers_And_PUNCTUATION}', "");
    Error('\p{Blk=- CUNEIFORM_Numbers/a/}');
    Error('\P{Blk=- CUNEIFORM_Numbers/a/}');
    Expect(1, 74879, '\p{Blk=:\ACuneiform_Numbers\z:}', "");;
    Expect(0, 74880, '\p{Blk=:\ACuneiform_Numbers\z:}', "");;
    Expect(1, 74879, '\p{Blk=cuneiformnumbers}', "");
    Expect(0, 74879, '\p{^Blk=cuneiformnumbers}', "");
    Expect(0, 74879, '\P{Blk=cuneiformnumbers}', "");
    Expect(1, 74879, '\P{^Blk=cuneiformnumbers}', "");
    Expect(0, 74880, '\p{Blk=cuneiformnumbers}', "");
    Expect(1, 74880, '\p{^Blk=cuneiformnumbers}', "");
    Expect(1, 74880, '\P{Blk=cuneiformnumbers}', "");
    Expect(0, 74880, '\P{^Blk=cuneiformnumbers}', "");
    Expect(1, 74879, '\p{Blk=:\Acuneiformnumbers\z:}', "");;
    Expect(0, 74880, '\p{Blk=:\Acuneiformnumbers\z:}', "");;
    Expect(1, 74879, '\p{Blk=	 cuneiform_NUMBERS}', "");
    Expect(0, 74879, '\p{^Blk=	 cuneiform_NUMBERS}', "");
    Expect(0, 74879, '\P{Blk=	 cuneiform_NUMBERS}', "");
    Expect(1, 74879, '\P{^Blk=	 cuneiform_NUMBERS}', "");
    Expect(0, 74880, '\p{Blk=	 cuneiform_NUMBERS}', "");
    Expect(1, 74880, '\p{^Blk=	 cuneiform_NUMBERS}', "");
    Expect(1, 74880, '\P{Blk=	 cuneiform_NUMBERS}', "");
    Expect(0, 74880, '\P{^Blk=	 cuneiform_NUMBERS}', "");
    Error('\p{Is_Block=	:=cuneiform_numbers_And_punctuation}');
    Error('\P{Is_Block=	:=cuneiform_numbers_And_punctuation}');
    Expect(1, 74879, '\p{Is_Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\p{^Is_Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\P{Is_Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\P{^Is_Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\p{Is_Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\p{^Is_Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\P{Is_Block=cuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\P{^Is_Block=cuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\p{Is_Block=_CUNEIFORM_numbers_And_PUNCTUATION}', "");
    Expect(0, 74879, '\p{^Is_Block=_CUNEIFORM_numbers_And_PUNCTUATION}', "");
    Expect(0, 74879, '\P{Is_Block=_CUNEIFORM_numbers_And_PUNCTUATION}', "");
    Expect(1, 74879, '\P{^Is_Block=_CUNEIFORM_numbers_And_PUNCTUATION}', "");
    Expect(0, 74880, '\p{Is_Block=_CUNEIFORM_numbers_And_PUNCTUATION}', "");
    Expect(1, 74880, '\p{^Is_Block=_CUNEIFORM_numbers_And_PUNCTUATION}', "");
    Expect(1, 74880, '\P{Is_Block=_CUNEIFORM_numbers_And_PUNCTUATION}', "");
    Expect(0, 74880, '\P{^Is_Block=_CUNEIFORM_numbers_And_PUNCTUATION}', "");
    Error('\p{Is_Blk=__Cuneiform_Numbers:=}');
    Error('\P{Is_Blk=__Cuneiform_Numbers:=}');
    Expect(1, 74879, '\p{Is_Blk=cuneiformnumbers}', "");
    Expect(0, 74879, '\p{^Is_Blk=cuneiformnumbers}', "");
    Expect(0, 74879, '\P{Is_Blk=cuneiformnumbers}', "");
    Expect(1, 74879, '\P{^Is_Blk=cuneiformnumbers}', "");
    Expect(0, 74880, '\p{Is_Blk=cuneiformnumbers}', "");
    Expect(1, 74880, '\p{^Is_Blk=cuneiformnumbers}', "");
    Expect(1, 74880, '\P{Is_Blk=cuneiformnumbers}', "");
    Expect(0, 74880, '\P{^Is_Blk=cuneiformnumbers}', "");
    Expect(1, 74879, '\p{Is_Blk= 	cuneiform_numbers}', "");
    Expect(0, 74879, '\p{^Is_Blk= 	cuneiform_numbers}', "");
    Expect(0, 74879, '\P{Is_Blk= 	cuneiform_numbers}', "");
    Expect(1, 74879, '\P{^Is_Blk= 	cuneiform_numbers}', "");
    Expect(0, 74880, '\p{Is_Blk= 	cuneiform_numbers}', "");
    Expect(1, 74880, '\p{^Is_Blk= 	cuneiform_numbers}', "");
    Expect(1, 74880, '\P{Is_Blk= 	cuneiform_numbers}', "");
    Expect(0, 74880, '\P{^Is_Blk= 	cuneiform_numbers}', "");
    Error('\p{Block= CURRENCY_SYMBOLS:=}');
    Error('\P{Block= CURRENCY_SYMBOLS:=}');
    Expect(1, 8399, '\p{Block=:\ACurrency_Symbols\z:}', "");;
    Expect(0, 8400, '\p{Block=:\ACurrency_Symbols\z:}', "");;
    Expect(1, 8399, '\p{Block=currencysymbols}', "");
    Expect(0, 8399, '\p{^Block=currencysymbols}', "");
    Expect(0, 8399, '\P{Block=currencysymbols}', "");
    Expect(1, 8399, '\P{^Block=currencysymbols}', "");
    Expect(0, 8400, '\p{Block=currencysymbols}', "");
    Expect(1, 8400, '\p{^Block=currencysymbols}', "");
    Expect(1, 8400, '\P{Block=currencysymbols}', "");
    Expect(0, 8400, '\P{^Block=currencysymbols}', "");
    Expect(1, 8399, '\p{Block=:\Acurrencysymbols\z:}', "");;
    Expect(0, 8400, '\p{Block=:\Acurrencysymbols\z:}', "");;
    Expect(1, 8399, '\p{Block=--CURRENCY_symbols}', "");
    Expect(0, 8399, '\p{^Block=--CURRENCY_symbols}', "");
    Expect(0, 8399, '\P{Block=--CURRENCY_symbols}', "");
    Expect(1, 8399, '\P{^Block=--CURRENCY_symbols}', "");
    Expect(0, 8400, '\p{Block=--CURRENCY_symbols}', "");
    Expect(1, 8400, '\p{^Block=--CURRENCY_symbols}', "");
    Expect(1, 8400, '\P{Block=--CURRENCY_symbols}', "");
    Expect(0, 8400, '\P{^Block=--CURRENCY_symbols}', "");
    Error('\p{Blk:   _currency_symbols/a/}');
    Error('\P{Blk:   _currency_symbols/a/}');
    Expect(1, 8399, '\p{Blk=:\ACurrency_Symbols\z:}', "");;
    Expect(0, 8400, '\p{Blk=:\ACurrency_Symbols\z:}', "");;
    Expect(1, 8399, '\p{Blk=currencysymbols}', "");
    Expect(0, 8399, '\p{^Blk=currencysymbols}', "");
    Expect(0, 8399, '\P{Blk=currencysymbols}', "");
    Expect(1, 8399, '\P{^Blk=currencysymbols}', "");
    Expect(0, 8400, '\p{Blk=currencysymbols}', "");
    Expect(1, 8400, '\p{^Blk=currencysymbols}', "");
    Expect(1, 8400, '\P{Blk=currencysymbols}', "");
    Expect(0, 8400, '\P{^Blk=currencysymbols}', "");
    Expect(1, 8399, '\p{Blk=:\Acurrencysymbols\z:}', "");;
    Expect(0, 8400, '\p{Blk=:\Acurrencysymbols\z:}', "");;
    Expect(1, 8399, '\p{Blk=__Currency_Symbols}', "");
    Expect(0, 8399, '\p{^Blk=__Currency_Symbols}', "");
    Expect(0, 8399, '\P{Blk=__Currency_Symbols}', "");
    Expect(1, 8399, '\P{^Blk=__Currency_Symbols}', "");
    Expect(0, 8400, '\p{Blk=__Currency_Symbols}', "");
    Expect(1, 8400, '\p{^Blk=__Currency_Symbols}', "");
    Expect(1, 8400, '\P{Blk=__Currency_Symbols}', "");
    Expect(0, 8400, '\P{^Blk=__Currency_Symbols}', "");
    Error('\p{Is_Block= :=Currency_Symbols}');
    Error('\P{Is_Block= :=Currency_Symbols}');
    Expect(1, 8399, '\p{Is_Block=currencysymbols}', "");
    Expect(0, 8399, '\p{^Is_Block=currencysymbols}', "");
    Expect(0, 8399, '\P{Is_Block=currencysymbols}', "");
    Expect(1, 8399, '\P{^Is_Block=currencysymbols}', "");
    Expect(0, 8400, '\p{Is_Block=currencysymbols}', "");
    Expect(1, 8400, '\p{^Is_Block=currencysymbols}', "");
    Expect(1, 8400, '\P{Is_Block=currencysymbols}', "");
    Expect(0, 8400, '\P{^Is_Block=currencysymbols}', "");
    Expect(1, 8399, '\p{Is_Block=_currency_Symbols}', "");
    Expect(0, 8399, '\p{^Is_Block=_currency_Symbols}', "");
    Expect(0, 8399, '\P{Is_Block=_currency_Symbols}', "");
    Expect(1, 8399, '\P{^Is_Block=_currency_Symbols}', "");
    Expect(0, 8400, '\p{Is_Block=_currency_Symbols}', "");
    Expect(1, 8400, '\p{^Is_Block=_currency_Symbols}', "");
    Expect(1, 8400, '\P{Is_Block=_currency_Symbols}', "");
    Expect(0, 8400, '\P{^Is_Block=_currency_Symbols}', "");
    Error('\p{Is_Blk=/a/ 	currency_symbols}');
    Error('\P{Is_Blk=/a/ 	currency_symbols}');
    Expect(1, 8399, '\p{Is_Blk=currencysymbols}', "");
    Expect(0, 8399, '\p{^Is_Blk=currencysymbols}', "");
    Expect(0, 8399, '\P{Is_Blk=currencysymbols}', "");
    Expect(1, 8399, '\P{^Is_Blk=currencysymbols}', "");
    Expect(0, 8400, '\p{Is_Blk=currencysymbols}', "");
    Expect(1, 8400, '\p{^Is_Blk=currencysymbols}', "");
    Expect(1, 8400, '\P{Is_Blk=currencysymbols}', "");
    Expect(0, 8400, '\P{^Is_Blk=currencysymbols}', "");
    Expect(1, 8399, '\p{Is_Blk= _Currency_Symbols}', "");
    Expect(0, 8399, '\p{^Is_Blk= _Currency_Symbols}', "");
    Expect(0, 8399, '\P{Is_Blk= _Currency_Symbols}', "");
    Expect(1, 8399, '\P{^Is_Blk= _Currency_Symbols}', "");
    Expect(0, 8400, '\p{Is_Blk= _Currency_Symbols}', "");
    Expect(1, 8400, '\p{^Is_Blk= _Currency_Symbols}', "");
    Expect(1, 8400, '\P{Is_Blk= _Currency_Symbols}', "");
    Expect(0, 8400, '\P{^Is_Blk= _Currency_Symbols}', "");
    Error('\p{Block=/a/	 CYPRIOT_syllabary}');
    Error('\P{Block=/a/	 CYPRIOT_syllabary}');
    Expect(1, 67647, '\p{Block=:\ACypriot_Syllabary\z:}', "");;
    Expect(0, 67648, '\p{Block=:\ACypriot_Syllabary\z:}', "");;
    Expect(1, 67647, '\p{Block=cypriotsyllabary}', "");
    Expect(0, 67647, '\p{^Block=cypriotsyllabary}', "");
    Expect(0, 67647, '\P{Block=cypriotsyllabary}', "");
    Expect(1, 67647, '\P{^Block=cypriotsyllabary}', "");
    Expect(0, 67648, '\p{Block=cypriotsyllabary}', "");
    Expect(1, 67648, '\p{^Block=cypriotsyllabary}', "");
    Expect(1, 67648, '\P{Block=cypriotsyllabary}', "");
    Expect(0, 67648, '\P{^Block=cypriotsyllabary}', "");
    Expect(1, 67647, '\p{Block=:\Acypriotsyllabary\z:}', "");;
    Expect(0, 67648, '\p{Block=:\Acypriotsyllabary\z:}', "");;
    Expect(1, 67647, '\p{Block= cypriot_SYLLABARY}', "");
    Expect(0, 67647, '\p{^Block= cypriot_SYLLABARY}', "");
    Expect(0, 67647, '\P{Block= cypriot_SYLLABARY}', "");
    Expect(1, 67647, '\P{^Block= cypriot_SYLLABARY}', "");
    Expect(0, 67648, '\p{Block= cypriot_SYLLABARY}', "");
    Expect(1, 67648, '\p{^Block= cypriot_SYLLABARY}', "");
    Expect(1, 67648, '\P{Block= cypriot_SYLLABARY}', "");
    Expect(0, 67648, '\P{^Block= cypriot_SYLLABARY}', "");
    Error('\p{Blk=/a/-	Cypriot_syllabary}');
    Error('\P{Blk=/a/-	Cypriot_syllabary}');
    Expect(1, 67647, '\p{Blk=:\ACypriot_Syllabary\z:}', "");;
    Expect(0, 67648, '\p{Blk=:\ACypriot_Syllabary\z:}', "");;
    Expect(1, 67647, '\p{Blk=cypriotsyllabary}', "");
    Expect(0, 67647, '\p{^Blk=cypriotsyllabary}', "");
    Expect(0, 67647, '\P{Blk=cypriotsyllabary}', "");
    Expect(1, 67647, '\P{^Blk=cypriotsyllabary}', "");
    Expect(0, 67648, '\p{Blk=cypriotsyllabary}', "");
    Expect(1, 67648, '\p{^Blk=cypriotsyllabary}', "");
    Expect(1, 67648, '\P{Blk=cypriotsyllabary}', "");
    Expect(0, 67648, '\P{^Blk=cypriotsyllabary}', "");
    Expect(1, 67647, '\p{Blk=:\Acypriotsyllabary\z:}', "");;
    Expect(0, 67648, '\p{Blk=:\Acypriotsyllabary\z:}', "");;
    Expect(1, 67647, '\p{Blk= Cypriot_syllabary}', "");
    Expect(0, 67647, '\p{^Blk= Cypriot_syllabary}', "");
    Expect(0, 67647, '\P{Blk= Cypriot_syllabary}', "");
    Expect(1, 67647, '\P{^Blk= Cypriot_syllabary}', "");
    Expect(0, 67648, '\p{Blk= Cypriot_syllabary}', "");
    Expect(1, 67648, '\p{^Blk= Cypriot_syllabary}', "");
    Expect(1, 67648, '\P{Blk= Cypriot_syllabary}', "");
    Expect(0, 67648, '\P{^Blk= Cypriot_syllabary}', "");
    Error('\p{Is_Block=:= Cypriot_Syllabary}');
    Error('\P{Is_Block=:= Cypriot_Syllabary}');
    Expect(1, 67647, '\p{Is_Block=cypriotsyllabary}', "");
    Expect(0, 67647, '\p{^Is_Block=cypriotsyllabary}', "");
    Expect(0, 67647, '\P{Is_Block=cypriotsyllabary}', "");
    Expect(1, 67647, '\P{^Is_Block=cypriotsyllabary}', "");
    Expect(0, 67648, '\p{Is_Block=cypriotsyllabary}', "");
    Expect(1, 67648, '\p{^Is_Block=cypriotsyllabary}', "");
    Expect(1, 67648, '\P{Is_Block=cypriotsyllabary}', "");
    Expect(0, 67648, '\P{^Is_Block=cypriotsyllabary}', "");
    Expect(1, 67647, '\p{Is_Block=- Cypriot_syllabary}', "");
    Expect(0, 67647, '\p{^Is_Block=- Cypriot_syllabary}', "");
    Expect(0, 67647, '\P{Is_Block=- Cypriot_syllabary}', "");
    Expect(1, 67647, '\P{^Is_Block=- Cypriot_syllabary}', "");
    Expect(0, 67648, '\p{Is_Block=- Cypriot_syllabary}', "");
    Expect(1, 67648, '\p{^Is_Block=- Cypriot_syllabary}', "");
    Expect(1, 67648, '\P{Is_Block=- Cypriot_syllabary}', "");
    Expect(0, 67648, '\P{^Is_Block=- Cypriot_syllabary}', "");
    Error('\p{Is_Blk=:=	Cypriot_syllabary}');
    Error('\P{Is_Blk=:=	Cypriot_syllabary}');
    Expect(1, 67647, '\p{Is_Blk=cypriotsyllabary}', "");
    Expect(0, 67647, '\p{^Is_Blk=cypriotsyllabary}', "");
    Expect(0, 67647, '\P{Is_Blk=cypriotsyllabary}', "");
    Expect(1, 67647, '\P{^Is_Blk=cypriotsyllabary}', "");
    Expect(0, 67648, '\p{Is_Blk=cypriotsyllabary}', "");
    Expect(1, 67648, '\p{^Is_Blk=cypriotsyllabary}', "");
    Expect(1, 67648, '\P{Is_Blk=cypriotsyllabary}', "");
    Expect(0, 67648, '\P{^Is_Blk=cypriotsyllabary}', "");
    Expect(1, 67647, '\p{Is_Blk=_ CYPRIOT_Syllabary}', "");
    Expect(0, 67647, '\p{^Is_Blk=_ CYPRIOT_Syllabary}', "");
    Expect(0, 67647, '\P{Is_Blk=_ CYPRIOT_Syllabary}', "");
    Expect(1, 67647, '\P{^Is_Blk=_ CYPRIOT_Syllabary}', "");
    Expect(0, 67648, '\p{Is_Blk=_ CYPRIOT_Syllabary}', "");
    Expect(1, 67648, '\p{^Is_Blk=_ CYPRIOT_Syllabary}', "");
    Expect(1, 67648, '\P{Is_Blk=_ CYPRIOT_Syllabary}', "");
    Expect(0, 67648, '\P{^Is_Blk=_ CYPRIOT_Syllabary}', "");
    Error('\p{Block=:=	CYRILLIC}');
    Error('\P{Block=:=	CYRILLIC}');
    Expect(1, 1279, '\p{Block=:\ACyrillic\z:}', "");;
    Expect(0, 1280, '\p{Block=:\ACyrillic\z:}', "");;
    Expect(1, 1279, '\p{Block=cyrillic}', "");
    Expect(0, 1279, '\p{^Block=cyrillic}', "");
    Expect(0, 1279, '\P{Block=cyrillic}', "");
    Expect(1, 1279, '\P{^Block=cyrillic}', "");
    Expect(0, 1280, '\p{Block=cyrillic}', "");
    Expect(1, 1280, '\p{^Block=cyrillic}', "");
    Expect(1, 1280, '\P{Block=cyrillic}', "");
    Expect(0, 1280, '\P{^Block=cyrillic}', "");
    Expect(1, 1279, '\p{Block=:\Acyrillic\z:}', "");;
    Expect(0, 1280, '\p{Block=:\Acyrillic\z:}', "");;
    Expect(1, 1279, '\p{Block:   	 Cyrillic}', "");
    Expect(0, 1279, '\p{^Block:   	 Cyrillic}', "");
    Expect(0, 1279, '\P{Block:   	 Cyrillic}', "");
    Expect(1, 1279, '\P{^Block:   	 Cyrillic}', "");
    Expect(0, 1280, '\p{Block:   	 Cyrillic}', "");
    Expect(1, 1280, '\p{^Block:   	 Cyrillic}', "");
    Expect(1, 1280, '\P{Block:   	 Cyrillic}', "");
    Expect(0, 1280, '\P{^Block:   	 Cyrillic}', "");
    Error('\p{Blk: /a/	-cyrillic}');
    Error('\P{Blk: /a/	-cyrillic}');
    Expect(1, 1279, '\p{Blk=:\ACyrillic\z:}', "");;
    Expect(0, 1280, '\p{Blk=:\ACyrillic\z:}', "");;
    Expect(1, 1279, '\p{Blk=cyrillic}', "");
    Expect(0, 1279, '\p{^Blk=cyrillic}', "");
    Expect(0, 1279, '\P{Blk=cyrillic}', "");
    Expect(1, 1279, '\P{^Blk=cyrillic}', "");
    Expect(0, 1280, '\p{Blk=cyrillic}', "");
    Expect(1, 1280, '\p{^Blk=cyrillic}', "");
    Expect(1, 1280, '\P{Blk=cyrillic}', "");
    Expect(0, 1280, '\P{^Blk=cyrillic}', "");
    Expect(1, 1279, '\p{Blk=:\Acyrillic\z:}', "");;
    Expect(0, 1280, '\p{Blk=:\Acyrillic\z:}', "");;
    Expect(1, 1279, '\p{Blk= _cyrillic}', "");
    Expect(0, 1279, '\p{^Blk= _cyrillic}', "");
    Expect(0, 1279, '\P{Blk= _cyrillic}', "");
    Expect(1, 1279, '\P{^Blk= _cyrillic}', "");
    Expect(0, 1280, '\p{Blk= _cyrillic}', "");
    Expect(1, 1280, '\p{^Blk= _cyrillic}', "");
    Expect(1, 1280, '\P{Blk= _cyrillic}', "");
    Expect(0, 1280, '\P{^Blk= _cyrillic}', "");
    Error('\p{Is_Block=cyrillic/a/}');
    Error('\P{Is_Block=cyrillic/a/}');
    Expect(1, 1279, '\p{Is_Block=cyrillic}', "");
    Expect(0, 1279, '\p{^Is_Block=cyrillic}', "");
    Expect(0, 1279, '\P{Is_Block=cyrillic}', "");
    Expect(1, 1279, '\P{^Is_Block=cyrillic}', "");
    Expect(0, 1280, '\p{Is_Block=cyrillic}', "");
    Expect(1, 1280, '\p{^Is_Block=cyrillic}', "");
    Expect(1, 1280, '\P{Is_Block=cyrillic}', "");
    Expect(0, 1280, '\P{^Is_Block=cyrillic}', "");
    Expect(1, 1279, '\p{Is_Block=-Cyrillic}', "");
    Expect(0, 1279, '\p{^Is_Block=-Cyrillic}', "");
    Expect(0, 1279, '\P{Is_Block=-Cyrillic}', "");
    Expect(1, 1279, '\P{^Is_Block=-Cyrillic}', "");
    Expect(0, 1280, '\p{Is_Block=-Cyrillic}', "");
    Expect(1, 1280, '\p{^Is_Block=-Cyrillic}', "");
    Expect(1, 1280, '\P{Is_Block=-Cyrillic}', "");
    Expect(0, 1280, '\P{^Is_Block=-Cyrillic}', "");
    Error('\p{Is_Blk= Cyrillic/a/}');
    Error('\P{Is_Blk= Cyrillic/a/}');
    Expect(1, 1279, '\p{Is_Blk=cyrillic}', "");
    Expect(0, 1279, '\p{^Is_Blk=cyrillic}', "");
    Expect(0, 1279, '\P{Is_Blk=cyrillic}', "");
    Expect(1, 1279, '\P{^Is_Blk=cyrillic}', "");
    Expect(0, 1280, '\p{Is_Blk=cyrillic}', "");
    Expect(1, 1280, '\p{^Is_Blk=cyrillic}', "");
    Expect(1, 1280, '\P{Is_Blk=cyrillic}', "");
    Expect(0, 1280, '\P{^Is_Blk=cyrillic}', "");
    Expect(1, 1279, '\p{Is_Blk=	 CYRILLIC}', "");
    Expect(0, 1279, '\p{^Is_Blk=	 CYRILLIC}', "");
    Expect(0, 1279, '\P{Is_Blk=	 CYRILLIC}', "");
    Expect(1, 1279, '\P{^Is_Blk=	 CYRILLIC}', "");
    Expect(0, 1280, '\p{Is_Blk=	 CYRILLIC}', "");
    Expect(1, 1280, '\p{^Is_Blk=	 CYRILLIC}', "");
    Expect(1, 1280, '\P{Is_Blk=	 CYRILLIC}', "");
    Expect(0, 1280, '\P{^Is_Blk=	 CYRILLIC}', "");
    Error('\p{Block=-:=CYRILLIC_extended_A}');
    Error('\P{Block=-:=CYRILLIC_extended_A}');
    Expect(1, 11775, '\p{Block=:\ACyrillic_Extended_A\z:}', "");;
    Expect(0, 11776, '\p{Block=:\ACyrillic_Extended_A\z:}', "");;
    Expect(1, 11775, '\p{Block=cyrillicextendeda}', "");
    Expect(0, 11775, '\p{^Block=cyrillicextendeda}', "");
    Expect(0, 11775, '\P{Block=cyrillicextendeda}', "");
    Expect(1, 11775, '\P{^Block=cyrillicextendeda}', "");
    Expect(0, 11776, '\p{Block=cyrillicextendeda}', "");
    Expect(1, 11776, '\p{^Block=cyrillicextendeda}', "");
    Expect(1, 11776, '\P{Block=cyrillicextendeda}', "");
    Expect(0, 11776, '\P{^Block=cyrillicextendeda}', "");
    Expect(1, 11775, '\p{Block=:\Acyrillicextendeda\z:}', "");;
    Expect(0, 11776, '\p{Block=:\Acyrillicextendeda\z:}', "");;
    Expect(1, 11775, '\p{Block=	 Cyrillic_EXTENDED_A}', "");
    Expect(0, 11775, '\p{^Block=	 Cyrillic_EXTENDED_A}', "");
    Expect(0, 11775, '\P{Block=	 Cyrillic_EXTENDED_A}', "");
    Expect(1, 11775, '\P{^Block=	 Cyrillic_EXTENDED_A}', "");
    Expect(0, 11776, '\p{Block=	 Cyrillic_EXTENDED_A}', "");
    Expect(1, 11776, '\p{^Block=	 Cyrillic_EXTENDED_A}', "");
    Expect(1, 11776, '\P{Block=	 Cyrillic_EXTENDED_A}', "");
    Expect(0, 11776, '\P{^Block=	 Cyrillic_EXTENDED_A}', "");
    Error('\p{Blk=--cyrillic_ext_A/a/}');
    Error('\P{Blk=--cyrillic_ext_A/a/}');
    Expect(1, 11775, '\p{Blk=:\ACyrillic_Ext_A\z:}', "");;
    Expect(0, 11776, '\p{Blk=:\ACyrillic_Ext_A\z:}', "");;
    Expect(1, 11775, '\p{Blk=cyrillicexta}', "");
    Expect(0, 11775, '\p{^Blk=cyrillicexta}', "");
    Expect(0, 11775, '\P{Blk=cyrillicexta}', "");
    Expect(1, 11775, '\P{^Blk=cyrillicexta}', "");
    Expect(0, 11776, '\p{Blk=cyrillicexta}', "");
    Expect(1, 11776, '\p{^Blk=cyrillicexta}', "");
    Expect(1, 11776, '\P{Blk=cyrillicexta}', "");
    Expect(0, 11776, '\P{^Blk=cyrillicexta}', "");
    Expect(1, 11775, '\p{Blk=:\Acyrillicexta\z:}', "");;
    Expect(0, 11776, '\p{Blk=:\Acyrillicexta\z:}', "");;
    Expect(1, 11775, '\p{Blk=_ Cyrillic_Ext_A}', "");
    Expect(0, 11775, '\p{^Blk=_ Cyrillic_Ext_A}', "");
    Expect(0, 11775, '\P{Blk=_ Cyrillic_Ext_A}', "");
    Expect(1, 11775, '\P{^Blk=_ Cyrillic_Ext_A}', "");
    Expect(0, 11776, '\p{Blk=_ Cyrillic_Ext_A}', "");
    Expect(1, 11776, '\p{^Blk=_ Cyrillic_Ext_A}', "");
    Expect(1, 11776, '\P{Blk=_ Cyrillic_Ext_A}', "");
    Expect(0, 11776, '\P{^Blk=_ Cyrillic_Ext_A}', "");
    Error('\p{Is_Block:	:=-	CYRILLIC_Extended_A}');
    Error('\P{Is_Block:	:=-	CYRILLIC_Extended_A}');
    Expect(1, 11775, '\p{Is_Block=cyrillicextendeda}', "");
    Expect(0, 11775, '\p{^Is_Block=cyrillicextendeda}', "");
    Expect(0, 11775, '\P{Is_Block=cyrillicextendeda}', "");
    Expect(1, 11775, '\P{^Is_Block=cyrillicextendeda}', "");
    Expect(0, 11776, '\p{Is_Block=cyrillicextendeda}', "");
    Expect(1, 11776, '\p{^Is_Block=cyrillicextendeda}', "");
    Expect(1, 11776, '\P{Is_Block=cyrillicextendeda}', "");
    Expect(0, 11776, '\P{^Is_Block=cyrillicextendeda}', "");
    Expect(1, 11775, '\p{Is_Block= 	Cyrillic_extended_A}', "");
    Expect(0, 11775, '\p{^Is_Block= 	Cyrillic_extended_A}', "");
    Expect(0, 11775, '\P{Is_Block= 	Cyrillic_extended_A}', "");
    Expect(1, 11775, '\P{^Is_Block= 	Cyrillic_extended_A}', "");
    Expect(0, 11776, '\p{Is_Block= 	Cyrillic_extended_A}', "");
    Expect(1, 11776, '\p{^Is_Block= 	Cyrillic_extended_A}', "");
    Expect(1, 11776, '\P{Is_Block= 	Cyrillic_extended_A}', "");
    Expect(0, 11776, '\P{^Is_Block= 	Cyrillic_extended_A}', "");
    Error('\p{Is_Blk:/a/_cyrillic_Ext_A}');
    Error('\P{Is_Blk:/a/_cyrillic_Ext_A}');
    Expect(1, 11775, '\p{Is_Blk=cyrillicexta}', "");
    Expect(0, 11775, '\p{^Is_Blk=cyrillicexta}', "");
    Expect(0, 11775, '\P{Is_Blk=cyrillicexta}', "");
    Expect(1, 11775, '\P{^Is_Blk=cyrillicexta}', "");
    Expect(0, 11776, '\p{Is_Blk=cyrillicexta}', "");
    Expect(1, 11776, '\p{^Is_Blk=cyrillicexta}', "");
    Expect(1, 11776, '\P{Is_Blk=cyrillicexta}', "");
    Expect(0, 11776, '\P{^Is_Blk=cyrillicexta}', "");
    Expect(1, 11775, '\p{Is_Blk= cyrillic_ext_A}', "");
    Expect(0, 11775, '\p{^Is_Blk= cyrillic_ext_A}', "");
    Expect(0, 11775, '\P{Is_Blk= cyrillic_ext_A}', "");
    Expect(1, 11775, '\P{^Is_Blk= cyrillic_ext_A}', "");
    Expect(0, 11776, '\p{Is_Blk= cyrillic_ext_A}', "");
    Expect(1, 11776, '\p{^Is_Blk= cyrillic_ext_A}', "");
    Expect(1, 11776, '\P{Is_Blk= cyrillic_ext_A}', "");
    Expect(0, 11776, '\P{^Is_Blk= cyrillic_ext_A}', "");
    Error('\p{Block=	/a/cyrillic_Extended_b}');
    Error('\P{Block=	/a/cyrillic_Extended_b}');
    Expect(1, 42655, '\p{Block=:\ACyrillic_Extended_B\z:}', "");;
    Expect(0, 42656, '\p{Block=:\ACyrillic_Extended_B\z:}', "");;
    Expect(1, 42655, '\p{Block:cyrillicextendedb}', "");
    Expect(0, 42655, '\p{^Block:cyrillicextendedb}', "");
    Expect(0, 42655, '\P{Block:cyrillicextendedb}', "");
    Expect(1, 42655, '\P{^Block:cyrillicextendedb}', "");
    Expect(0, 42656, '\p{Block:cyrillicextendedb}', "");
    Expect(1, 42656, '\p{^Block:cyrillicextendedb}', "");
    Expect(1, 42656, '\P{Block:cyrillicextendedb}', "");
    Expect(0, 42656, '\P{^Block:cyrillicextendedb}', "");
    Expect(1, 42655, '\p{Block=:\Acyrillicextendedb\z:}', "");;
    Expect(0, 42656, '\p{Block=:\Acyrillicextendedb\z:}', "");;
    Expect(1, 42655, '\p{Block=__cyrillic_EXTENDED_B}', "");
    Expect(0, 42655, '\p{^Block=__cyrillic_EXTENDED_B}', "");
    Expect(0, 42655, '\P{Block=__cyrillic_EXTENDED_B}', "");
    Expect(1, 42655, '\P{^Block=__cyrillic_EXTENDED_B}', "");
    Expect(0, 42656, '\p{Block=__cyrillic_EXTENDED_B}', "");
    Expect(1, 42656, '\p{^Block=__cyrillic_EXTENDED_B}', "");
    Expect(1, 42656, '\P{Block=__cyrillic_EXTENDED_B}', "");
    Expect(0, 42656, '\P{^Block=__cyrillic_EXTENDED_B}', "");
    Error('\p{Blk=_:=Cyrillic_Ext_B}');
    Error('\P{Blk=_:=Cyrillic_Ext_B}');
    Expect(1, 42655, '\p{Blk=:\ACyrillic_Ext_B\z:}', "");;
    Expect(0, 42656, '\p{Blk=:\ACyrillic_Ext_B\z:}', "");;
    Expect(1, 42655, '\p{Blk=cyrillicextb}', "");
    Expect(0, 42655, '\p{^Blk=cyrillicextb}', "");
    Expect(0, 42655, '\P{Blk=cyrillicextb}', "");
    Expect(1, 42655, '\P{^Blk=cyrillicextb}', "");
    Expect(0, 42656, '\p{Blk=cyrillicextb}', "");
    Expect(1, 42656, '\p{^Blk=cyrillicextb}', "");
    Expect(1, 42656, '\P{Blk=cyrillicextb}', "");
    Expect(0, 42656, '\P{^Blk=cyrillicextb}', "");
    Expect(1, 42655, '\p{Blk=:\Acyrillicextb\z:}', "");;
    Expect(0, 42656, '\p{Blk=:\Acyrillicextb\z:}', "");;
    Expect(1, 42655, '\p{Blk= -cyrillic_EXT_B}', "");
    Expect(0, 42655, '\p{^Blk= -cyrillic_EXT_B}', "");
    Expect(0, 42655, '\P{Blk= -cyrillic_EXT_B}', "");
    Expect(1, 42655, '\P{^Blk= -cyrillic_EXT_B}', "");
    Expect(0, 42656, '\p{Blk= -cyrillic_EXT_B}', "");
    Expect(1, 42656, '\p{^Blk= -cyrillic_EXT_B}', "");
    Expect(1, 42656, '\P{Blk= -cyrillic_EXT_B}', "");
    Expect(0, 42656, '\P{^Blk= -cyrillic_EXT_B}', "");
    Error('\p{Is_Block= CYRILLIC_EXTENDED_B/a/}');
    Error('\P{Is_Block= CYRILLIC_EXTENDED_B/a/}');
    Expect(1, 42655, '\p{Is_Block=cyrillicextendedb}', "");
    Expect(0, 42655, '\p{^Is_Block=cyrillicextendedb}', "");
    Expect(0, 42655, '\P{Is_Block=cyrillicextendedb}', "");
    Expect(1, 42655, '\P{^Is_Block=cyrillicextendedb}', "");
    Expect(0, 42656, '\p{Is_Block=cyrillicextendedb}', "");
    Expect(1, 42656, '\p{^Is_Block=cyrillicextendedb}', "");
    Expect(1, 42656, '\P{Is_Block=cyrillicextendedb}', "");
    Expect(0, 42656, '\P{^Is_Block=cyrillicextendedb}', "");
    Expect(1, 42655, '\p{Is_Block:   _-Cyrillic_Extended_B}', "");
    Expect(0, 42655, '\p{^Is_Block:   _-Cyrillic_Extended_B}', "");
    Expect(0, 42655, '\P{Is_Block:   _-Cyrillic_Extended_B}', "");
    Expect(1, 42655, '\P{^Is_Block:   _-Cyrillic_Extended_B}', "");
    Expect(0, 42656, '\p{Is_Block:   _-Cyrillic_Extended_B}', "");
    Expect(1, 42656, '\p{^Is_Block:   _-Cyrillic_Extended_B}', "");
    Expect(1, 42656, '\P{Is_Block:   _-Cyrillic_Extended_B}', "");
    Expect(0, 42656, '\P{^Is_Block:   _-Cyrillic_Extended_B}', "");
    Error('\p{Is_Blk=--Cyrillic_ext_B/a/}');
    Error('\P{Is_Blk=--Cyrillic_ext_B/a/}');
    Expect(1, 42655, '\p{Is_Blk=cyrillicextb}', "");
    Expect(0, 42655, '\p{^Is_Blk=cyrillicextb}', "");
    Expect(0, 42655, '\P{Is_Blk=cyrillicextb}', "");
    Expect(1, 42655, '\P{^Is_Blk=cyrillicextb}', "");
    Expect(0, 42656, '\p{Is_Blk=cyrillicextb}', "");
    Expect(1, 42656, '\p{^Is_Blk=cyrillicextb}', "");
    Expect(1, 42656, '\P{Is_Blk=cyrillicextb}', "");
    Expect(0, 42656, '\P{^Is_Blk=cyrillicextb}', "");
    Expect(1, 42655, '\p{Is_Blk=__CYRILLIC_EXT_B}', "");
    Expect(0, 42655, '\p{^Is_Blk=__CYRILLIC_EXT_B}', "");
    Expect(0, 42655, '\P{Is_Blk=__CYRILLIC_EXT_B}', "");
    Expect(1, 42655, '\P{^Is_Blk=__CYRILLIC_EXT_B}', "");
    Expect(0, 42656, '\p{Is_Blk=__CYRILLIC_EXT_B}', "");
    Expect(1, 42656, '\p{^Is_Blk=__CYRILLIC_EXT_B}', "");
    Expect(1, 42656, '\P{Is_Blk=__CYRILLIC_EXT_B}', "");
    Expect(0, 42656, '\P{^Is_Blk=__CYRILLIC_EXT_B}', "");
    Error('\p{Block=/a/	 cyrillic_Extended_C}');
    Error('\P{Block=/a/	 cyrillic_Extended_C}');
    Expect(1, 7311, '\p{Block=:\ACyrillic_Extended_C\z:}', "");;
    Expect(0, 7312, '\p{Block=:\ACyrillic_Extended_C\z:}', "");;
    Expect(1, 7311, '\p{Block=cyrillicextendedc}', "");
    Expect(0, 7311, '\p{^Block=cyrillicextendedc}', "");
    Expect(0, 7311, '\P{Block=cyrillicextendedc}', "");
    Expect(1, 7311, '\P{^Block=cyrillicextendedc}', "");
    Expect(0, 7312, '\p{Block=cyrillicextendedc}', "");
    Expect(1, 7312, '\p{^Block=cyrillicextendedc}', "");
    Expect(1, 7312, '\P{Block=cyrillicextendedc}', "");
    Expect(0, 7312, '\P{^Block=cyrillicextendedc}', "");
    Expect(1, 7311, '\p{Block=:\Acyrillicextendedc\z:}', "");;
    Expect(0, 7312, '\p{Block=:\Acyrillicextendedc\z:}', "");;
    Expect(1, 7311, '\p{Block=_-CYRILLIC_Extended_C}', "");
    Expect(0, 7311, '\p{^Block=_-CYRILLIC_Extended_C}', "");
    Expect(0, 7311, '\P{Block=_-CYRILLIC_Extended_C}', "");
    Expect(1, 7311, '\P{^Block=_-CYRILLIC_Extended_C}', "");
    Expect(0, 7312, '\p{Block=_-CYRILLIC_Extended_C}', "");
    Expect(1, 7312, '\p{^Block=_-CYRILLIC_Extended_C}', "");
    Expect(1, 7312, '\P{Block=_-CYRILLIC_Extended_C}', "");
    Expect(0, 7312, '\P{^Block=_-CYRILLIC_Extended_C}', "");
    Error('\p{Blk=:=	 Cyrillic_EXT_C}');
    Error('\P{Blk=:=	 Cyrillic_EXT_C}');
    Expect(1, 7311, '\p{Blk=:\ACyrillic_Ext_C\z:}', "");;
    Expect(0, 7312, '\p{Blk=:\ACyrillic_Ext_C\z:}', "");;
    Expect(1, 7311, '\p{Blk=cyrillicextc}', "");
    Expect(0, 7311, '\p{^Blk=cyrillicextc}', "");
    Expect(0, 7311, '\P{Blk=cyrillicextc}', "");
    Expect(1, 7311, '\P{^Blk=cyrillicextc}', "");
    Expect(0, 7312, '\p{Blk=cyrillicextc}', "");
    Expect(1, 7312, '\p{^Blk=cyrillicextc}', "");
    Expect(1, 7312, '\P{Blk=cyrillicextc}', "");
    Expect(0, 7312, '\P{^Blk=cyrillicextc}', "");
    Expect(1, 7311, '\p{Blk=:\Acyrillicextc\z:}', "");;
    Expect(0, 7312, '\p{Blk=:\Acyrillicextc\z:}', "");;
    Expect(1, 7311, '\p{Blk:   - CYRILLIC_Ext_C}', "");
    Expect(0, 7311, '\p{^Blk:   - CYRILLIC_Ext_C}', "");
    Expect(0, 7311, '\P{Blk:   - CYRILLIC_Ext_C}', "");
    Expect(1, 7311, '\P{^Blk:   - CYRILLIC_Ext_C}', "");
    Expect(0, 7312, '\p{Blk:   - CYRILLIC_Ext_C}', "");
    Expect(1, 7312, '\p{^Blk:   - CYRILLIC_Ext_C}', "");
    Expect(1, 7312, '\P{Blk:   - CYRILLIC_Ext_C}', "");
    Expect(0, 7312, '\P{^Blk:   - CYRILLIC_Ext_C}', "");
    Error('\p{Is_Block=__CYRILLIC_Extended_C:=}');
    Error('\P{Is_Block=__CYRILLIC_Extended_C:=}');
    Expect(1, 7311, '\p{Is_Block=cyrillicextendedc}', "");
    Expect(0, 7311, '\p{^Is_Block=cyrillicextendedc}', "");
    Expect(0, 7311, '\P{Is_Block=cyrillicextendedc}', "");
    Expect(1, 7311, '\P{^Is_Block=cyrillicextendedc}', "");
    Expect(0, 7312, '\p{Is_Block=cyrillicextendedc}', "");
    Expect(1, 7312, '\p{^Is_Block=cyrillicextendedc}', "");
    Expect(1, 7312, '\P{Is_Block=cyrillicextendedc}', "");
    Expect(0, 7312, '\P{^Is_Block=cyrillicextendedc}', "");
    Expect(1, 7311, '\p{Is_Block=	-Cyrillic_extended_C}', "");
    Expect(0, 7311, '\p{^Is_Block=	-Cyrillic_extended_C}', "");
    Expect(0, 7311, '\P{Is_Block=	-Cyrillic_extended_C}', "");
    Expect(1, 7311, '\P{^Is_Block=	-Cyrillic_extended_C}', "");
    Expect(0, 7312, '\p{Is_Block=	-Cyrillic_extended_C}', "");
    Expect(1, 7312, '\p{^Is_Block=	-Cyrillic_extended_C}', "");
    Expect(1, 7312, '\P{Is_Block=	-Cyrillic_extended_C}', "");
    Expect(0, 7312, '\P{^Is_Block=	-Cyrillic_extended_C}', "");
    Error('\p{Is_Blk: /a/-Cyrillic_Ext_C}');
    Error('\P{Is_Blk: /a/-Cyrillic_Ext_C}');
    Expect(1, 7311, '\p{Is_Blk=cyrillicextc}', "");
    Expect(0, 7311, '\p{^Is_Blk=cyrillicextc}', "");
    Expect(0, 7311, '\P{Is_Blk=cyrillicextc}', "");
    Expect(1, 7311, '\P{^Is_Blk=cyrillicextc}', "");
    Expect(0, 7312, '\p{Is_Blk=cyrillicextc}', "");
    Expect(1, 7312, '\p{^Is_Blk=cyrillicextc}', "");
    Expect(1, 7312, '\P{Is_Blk=cyrillicextc}', "");
    Expect(0, 7312, '\P{^Is_Blk=cyrillicextc}', "");
    Expect(1, 7311, '\p{Is_Blk=-_cyrillic_Ext_C}', "");
    Expect(0, 7311, '\p{^Is_Blk=-_cyrillic_Ext_C}', "");
    Expect(0, 7311, '\P{Is_Blk=-_cyrillic_Ext_C}', "");
    Expect(1, 7311, '\P{^Is_Blk=-_cyrillic_Ext_C}', "");
    Expect(0, 7312, '\p{Is_Blk=-_cyrillic_Ext_C}', "");
    Expect(1, 7312, '\p{^Is_Blk=-_cyrillic_Ext_C}', "");
    Expect(1, 7312, '\P{Is_Blk=-_cyrillic_Ext_C}', "");
    Expect(0, 7312, '\P{^Is_Blk=-_cyrillic_Ext_C}', "");
    Error('\p{Block=:= cyrillic_supplement}');
    Error('\P{Block=:= cyrillic_supplement}');
    Expect(1, 1327, '\p{Block=:\ACyrillic_Supplement\z:}', "");;
    Expect(0, 1328, '\p{Block=:\ACyrillic_Supplement\z:}', "");;
    Expect(1, 1327, '\p{Block=cyrillicsupplement}', "");
    Expect(0, 1327, '\p{^Block=cyrillicsupplement}', "");
    Expect(0, 1327, '\P{Block=cyrillicsupplement}', "");
    Expect(1, 1327, '\P{^Block=cyrillicsupplement}', "");
    Expect(0, 1328, '\p{Block=cyrillicsupplement}', "");
    Expect(1, 1328, '\p{^Block=cyrillicsupplement}', "");
    Expect(1, 1328, '\P{Block=cyrillicsupplement}', "");
    Expect(0, 1328, '\P{^Block=cyrillicsupplement}', "");
    Expect(1, 1327, '\p{Block=:\Acyrillicsupplement\z:}', "");;
    Expect(0, 1328, '\p{Block=:\Acyrillicsupplement\z:}', "");;
    Expect(1, 1327, '\p{Block:_-Cyrillic_Supplement}', "");
    Expect(0, 1327, '\p{^Block:_-Cyrillic_Supplement}', "");
    Expect(0, 1327, '\P{Block:_-Cyrillic_Supplement}', "");
    Expect(1, 1327, '\P{^Block:_-Cyrillic_Supplement}', "");
    Expect(0, 1328, '\p{Block:_-Cyrillic_Supplement}', "");
    Expect(1, 1328, '\p{^Block:_-Cyrillic_Supplement}', "");
    Expect(1, 1328, '\P{Block:_-Cyrillic_Supplement}', "");
    Expect(0, 1328, '\P{^Block:_-Cyrillic_Supplement}', "");
    Error('\p{Blk=_CYRILLIC_Sup/a/}');
    Error('\P{Blk=_CYRILLIC_Sup/a/}');
    Expect(1, 1327, '\p{Blk=:\ACyrillic_Sup\z:}', "");;
    Expect(0, 1328, '\p{Blk=:\ACyrillic_Sup\z:}', "");;
    Expect(1, 1327, '\p{Blk=cyrillicsup}', "");
    Expect(0, 1327, '\p{^Blk=cyrillicsup}', "");
    Expect(0, 1327, '\P{Blk=cyrillicsup}', "");
    Expect(1, 1327, '\P{^Blk=cyrillicsup}', "");
    Expect(0, 1328, '\p{Blk=cyrillicsup}', "");
    Expect(1, 1328, '\p{^Blk=cyrillicsup}', "");
    Expect(1, 1328, '\P{Blk=cyrillicsup}', "");
    Expect(0, 1328, '\P{^Blk=cyrillicsup}', "");
    Expect(1, 1327, '\p{Blk=:\Acyrillicsup\z:}', "");;
    Expect(0, 1328, '\p{Blk=:\Acyrillicsup\z:}', "");;
    Expect(1, 1327, '\p{Blk=	_Cyrillic_Sup}', "");
    Expect(0, 1327, '\p{^Blk=	_Cyrillic_Sup}', "");
    Expect(0, 1327, '\P{Blk=	_Cyrillic_Sup}', "");
    Expect(1, 1327, '\P{^Blk=	_Cyrillic_Sup}', "");
    Expect(0, 1328, '\p{Blk=	_Cyrillic_Sup}', "");
    Expect(1, 1328, '\p{^Blk=	_Cyrillic_Sup}', "");
    Expect(1, 1328, '\P{Blk=	_Cyrillic_Sup}', "");
    Expect(0, 1328, '\P{^Blk=	_Cyrillic_Sup}', "");
    Error('\p{Is_Block: 	 cyrillic_Supplementary:=}');
    Error('\P{Is_Block: 	 cyrillic_Supplementary:=}');
    Expect(1, 1327, '\p{Is_Block=cyrillicsupplementary}', "");
    Expect(0, 1327, '\p{^Is_Block=cyrillicsupplementary}', "");
    Expect(0, 1327, '\P{Is_Block=cyrillicsupplementary}', "");
    Expect(1, 1327, '\P{^Is_Block=cyrillicsupplementary}', "");
    Expect(0, 1328, '\p{Is_Block=cyrillicsupplementary}', "");
    Expect(1, 1328, '\p{^Is_Block=cyrillicsupplementary}', "");
    Expect(1, 1328, '\P{Is_Block=cyrillicsupplementary}', "");
    Expect(0, 1328, '\P{^Is_Block=cyrillicsupplementary}', "");
    Expect(1, 1327, '\p{Is_Block:--Cyrillic_Supplementary}', "");
    Expect(0, 1327, '\p{^Is_Block:--Cyrillic_Supplementary}', "");
    Expect(0, 1327, '\P{Is_Block:--Cyrillic_Supplementary}', "");
    Expect(1, 1327, '\P{^Is_Block:--Cyrillic_Supplementary}', "");
    Expect(0, 1328, '\p{Is_Block:--Cyrillic_Supplementary}', "");
    Expect(1, 1328, '\p{^Is_Block:--Cyrillic_Supplementary}', "");
    Expect(1, 1328, '\P{Is_Block:--Cyrillic_Supplementary}', "");
    Expect(0, 1328, '\P{^Is_Block:--Cyrillic_Supplementary}', "");
    Error('\p{Is_Blk:   :=_Cyrillic_SUPPLEMENT}');
    Error('\P{Is_Blk:   :=_Cyrillic_SUPPLEMENT}');
    Expect(1, 1327, '\p{Is_Blk=cyrillicsupplement}', "");
    Expect(0, 1327, '\p{^Is_Blk=cyrillicsupplement}', "");
    Expect(0, 1327, '\P{Is_Blk=cyrillicsupplement}', "");
    Expect(1, 1327, '\P{^Is_Blk=cyrillicsupplement}', "");
    Expect(0, 1328, '\p{Is_Blk=cyrillicsupplement}', "");
    Expect(1, 1328, '\p{^Is_Blk=cyrillicsupplement}', "");
    Expect(1, 1328, '\P{Is_Blk=cyrillicsupplement}', "");
    Expect(0, 1328, '\P{^Is_Blk=cyrillicsupplement}', "");
    Expect(1, 1327, '\p{Is_Blk=	-cyrillic_Supplement}', "");
    Expect(0, 1327, '\p{^Is_Blk=	-cyrillic_Supplement}', "");
    Expect(0, 1327, '\P{Is_Blk=	-cyrillic_Supplement}', "");
    Expect(1, 1327, '\P{^Is_Blk=	-cyrillic_Supplement}', "");
    Expect(0, 1328, '\p{Is_Blk=	-cyrillic_Supplement}', "");
    Expect(1, 1328, '\p{^Is_Blk=	-cyrillic_Supplement}', "");
    Expect(1, 1328, '\P{Is_Blk=	-cyrillic_Supplement}', "");
    Expect(0, 1328, '\P{^Is_Blk=	-cyrillic_Supplement}', "");
    Error('\p{Block= _DESERET/a/}');
    Error('\P{Block= _DESERET/a/}');
    Expect(1, 66639, '\p{Block=:\ADeseret\z:}', "");;
    Expect(0, 66640, '\p{Block=:\ADeseret\z:}', "");;
    Expect(1, 66639, '\p{Block=deseret}', "");
    Expect(0, 66639, '\p{^Block=deseret}', "");
    Expect(0, 66639, '\P{Block=deseret}', "");
    Expect(1, 66639, '\P{^Block=deseret}', "");
    Expect(0, 66640, '\p{Block=deseret}', "");
    Expect(1, 66640, '\p{^Block=deseret}', "");
    Expect(1, 66640, '\P{Block=deseret}', "");
    Expect(0, 66640, '\P{^Block=deseret}', "");
    Expect(1, 66639, '\p{Block=:\Adeseret\z:}', "");;
    Expect(0, 66640, '\p{Block=:\Adeseret\z:}', "");;
    Expect(1, 66639, '\p{Block=		deseret}', "");
    Expect(0, 66639, '\p{^Block=		deseret}', "");
    Expect(0, 66639, '\P{Block=		deseret}', "");
    Expect(1, 66639, '\P{^Block=		deseret}', "");
    Expect(0, 66640, '\p{Block=		deseret}', "");
    Expect(1, 66640, '\p{^Block=		deseret}', "");
    Expect(1, 66640, '\P{Block=		deseret}', "");
    Expect(0, 66640, '\P{^Block=		deseret}', "");
    Error('\p{Blk= /a/Deseret}');
    Error('\P{Blk= /a/Deseret}');
    Expect(1, 66639, '\p{Blk=:\ADeseret\z:}', "");;
    Expect(0, 66640, '\p{Blk=:\ADeseret\z:}', "");;
    Expect(1, 66639, '\p{Blk=deseret}', "");
    Expect(0, 66639, '\p{^Blk=deseret}', "");
    Expect(0, 66639, '\P{Blk=deseret}', "");
    Expect(1, 66639, '\P{^Blk=deseret}', "");
    Expect(0, 66640, '\p{Blk=deseret}', "");
    Expect(1, 66640, '\p{^Blk=deseret}', "");
    Expect(1, 66640, '\P{Blk=deseret}', "");
    Expect(0, 66640, '\P{^Blk=deseret}', "");
    Expect(1, 66639, '\p{Blk=:\Adeseret\z:}', "");;
    Expect(0, 66640, '\p{Blk=:\Adeseret\z:}', "");;
    Expect(1, 66639, '\p{Blk=_	Deseret}', "");
    Expect(0, 66639, '\p{^Blk=_	Deseret}', "");
    Expect(0, 66639, '\P{Blk=_	Deseret}', "");
    Expect(1, 66639, '\P{^Blk=_	Deseret}', "");
    Expect(0, 66640, '\p{Blk=_	Deseret}', "");
    Expect(1, 66640, '\p{^Blk=_	Deseret}', "");
    Expect(1, 66640, '\P{Blk=_	Deseret}', "");
    Expect(0, 66640, '\P{^Blk=_	Deseret}', "");
    Error('\p{Is_Block=:=DESERET}');
    Error('\P{Is_Block=:=DESERET}');
    Expect(1, 66639, '\p{Is_Block=deseret}', "");
    Expect(0, 66639, '\p{^Is_Block=deseret}', "");
    Expect(0, 66639, '\P{Is_Block=deseret}', "");
    Expect(1, 66639, '\P{^Is_Block=deseret}', "");
    Expect(0, 66640, '\p{Is_Block=deseret}', "");
    Expect(1, 66640, '\p{^Is_Block=deseret}', "");
    Expect(1, 66640, '\P{Is_Block=deseret}', "");
    Expect(0, 66640, '\P{^Is_Block=deseret}', "");
    Expect(1, 66639, '\p{Is_Block=_	Deseret}', "");
    Expect(0, 66639, '\p{^Is_Block=_	Deseret}', "");
    Expect(0, 66639, '\P{Is_Block=_	Deseret}', "");
    Expect(1, 66639, '\P{^Is_Block=_	Deseret}', "");
    Expect(0, 66640, '\p{Is_Block=_	Deseret}', "");
    Expect(1, 66640, '\p{^Is_Block=_	Deseret}', "");
    Expect(1, 66640, '\P{Is_Block=_	Deseret}', "");
    Expect(0, 66640, '\P{^Is_Block=_	Deseret}', "");
    Error('\p{Is_Blk=/a/_ Deseret}');
    Error('\P{Is_Blk=/a/_ Deseret}');
    Expect(1, 66639, '\p{Is_Blk=deseret}', "");
    Expect(0, 66639, '\p{^Is_Blk=deseret}', "");
    Expect(0, 66639, '\P{Is_Blk=deseret}', "");
    Expect(1, 66639, '\P{^Is_Blk=deseret}', "");
    Expect(0, 66640, '\p{Is_Blk=deseret}', "");
    Expect(1, 66640, '\p{^Is_Blk=deseret}', "");
    Expect(1, 66640, '\P{Is_Blk=deseret}', "");
    Expect(0, 66640, '\P{^Is_Blk=deseret}', "");
    Expect(1, 66639, '\p{Is_Blk=__Deseret}', "");
    Expect(0, 66639, '\p{^Is_Blk=__Deseret}', "");
    Expect(0, 66639, '\P{Is_Blk=__Deseret}', "");
    Expect(1, 66639, '\P{^Is_Blk=__Deseret}', "");
    Expect(0, 66640, '\p{Is_Blk=__Deseret}', "");
    Expect(1, 66640, '\p{^Is_Blk=__Deseret}', "");
    Expect(1, 66640, '\P{Is_Blk=__Deseret}', "");
    Expect(0, 66640, '\P{^Is_Blk=__Deseret}', "");
    Error('\p{Block=/a/_Devanagari}');
    Error('\P{Block=/a/_Devanagari}');
    Expect(1, 2431, '\p{Block=:\ADevanagari\z:}', "");;
    Expect(0, 2432, '\p{Block=:\ADevanagari\z:}', "");;
    Expect(1, 2431, '\p{Block:devanagari}', "");
    Expect(0, 2431, '\p{^Block:devanagari}', "");
    Expect(0, 2431, '\P{Block:devanagari}', "");
    Expect(1, 2431, '\P{^Block:devanagari}', "");
    Expect(0, 2432, '\p{Block:devanagari}', "");
    Expect(1, 2432, '\p{^Block:devanagari}', "");
    Expect(1, 2432, '\P{Block:devanagari}', "");
    Expect(0, 2432, '\P{^Block:devanagari}', "");
    Expect(1, 2431, '\p{Block=:\Adevanagari\z:}', "");;
    Expect(0, 2432, '\p{Block=:\Adevanagari\z:}', "");;
    Expect(1, 2431, '\p{Block=_DEVANAGARI}', "");
    Expect(0, 2431, '\p{^Block=_DEVANAGARI}', "");
    Expect(0, 2431, '\P{Block=_DEVANAGARI}', "");
    Expect(1, 2431, '\P{^Block=_DEVANAGARI}', "");
    Expect(0, 2432, '\p{Block=_DEVANAGARI}', "");
    Expect(1, 2432, '\p{^Block=_DEVANAGARI}', "");
    Expect(1, 2432, '\P{Block=_DEVANAGARI}', "");
    Expect(0, 2432, '\P{^Block=_DEVANAGARI}', "");
    Error('\p{Blk=:=devanagari}');
    Error('\P{Blk=:=devanagari}');
    Expect(1, 2431, '\p{Blk=:\ADevanagari\z:}', "");;
    Expect(0, 2432, '\p{Blk=:\ADevanagari\z:}', "");;
    Expect(1, 2431, '\p{Blk=devanagari}', "");
    Expect(0, 2431, '\p{^Blk=devanagari}', "");
    Expect(0, 2431, '\P{Blk=devanagari}', "");
    Expect(1, 2431, '\P{^Blk=devanagari}', "");
    Expect(0, 2432, '\p{Blk=devanagari}', "");
    Expect(1, 2432, '\p{^Blk=devanagari}', "");
    Expect(1, 2432, '\P{Blk=devanagari}', "");
    Expect(0, 2432, '\P{^Blk=devanagari}', "");
    Expect(1, 2431, '\p{Blk=:\Adevanagari\z:}', "");;
    Expect(0, 2432, '\p{Blk=:\Adevanagari\z:}', "");;
    Expect(1, 2431, '\p{Blk=Devanagari}', "");
    Expect(0, 2431, '\p{^Blk=Devanagari}', "");
    Expect(0, 2431, '\P{Blk=Devanagari}', "");
    Expect(1, 2431, '\P{^Blk=Devanagari}', "");
    Expect(0, 2432, '\p{Blk=Devanagari}', "");
    Expect(1, 2432, '\p{^Blk=Devanagari}', "");
    Expect(1, 2432, '\P{Blk=Devanagari}', "");
    Expect(0, 2432, '\P{^Blk=Devanagari}', "");
    Error('\p{Is_Block=_	Devanagari:=}');
    Error('\P{Is_Block=_	Devanagari:=}');
    Expect(1, 2431, '\p{Is_Block=devanagari}', "");
    Expect(0, 2431, '\p{^Is_Block=devanagari}', "");
    Expect(0, 2431, '\P{Is_Block=devanagari}', "");
    Expect(1, 2431, '\P{^Is_Block=devanagari}', "");
    Expect(0, 2432, '\p{Is_Block=devanagari}', "");
    Expect(1, 2432, '\p{^Is_Block=devanagari}', "");
    Expect(1, 2432, '\P{Is_Block=devanagari}', "");
    Expect(0, 2432, '\P{^Is_Block=devanagari}', "");
    Expect(1, 2431, '\p{Is_Block=	 DEVANAGARI}', "");
    Expect(0, 2431, '\p{^Is_Block=	 DEVANAGARI}', "");
    Expect(0, 2431, '\P{Is_Block=	 DEVANAGARI}', "");
    Expect(1, 2431, '\P{^Is_Block=	 DEVANAGARI}', "");
    Expect(0, 2432, '\p{Is_Block=	 DEVANAGARI}', "");
    Expect(1, 2432, '\p{^Is_Block=	 DEVANAGARI}', "");
    Expect(1, 2432, '\P{Is_Block=	 DEVANAGARI}', "");
    Expect(0, 2432, '\P{^Is_Block=	 DEVANAGARI}', "");
    Error('\p{Is_Blk: :=Devanagari}');
    Error('\P{Is_Blk: :=Devanagari}');
    Expect(1, 2431, '\p{Is_Blk=devanagari}', "");
    Expect(0, 2431, '\p{^Is_Blk=devanagari}', "");
    Expect(0, 2431, '\P{Is_Blk=devanagari}', "");
    Expect(1, 2431, '\P{^Is_Blk=devanagari}', "");
    Expect(0, 2432, '\p{Is_Blk=devanagari}', "");
    Expect(1, 2432, '\p{^Is_Blk=devanagari}', "");
    Expect(1, 2432, '\P{Is_Blk=devanagari}', "");
    Expect(0, 2432, '\P{^Is_Blk=devanagari}', "");
    Expect(1, 2431, '\p{Is_Blk:	Devanagari}', "");
    Expect(0, 2431, '\p{^Is_Blk:	Devanagari}', "");
    Expect(0, 2431, '\P{Is_Blk:	Devanagari}', "");
    Expect(1, 2431, '\P{^Is_Blk:	Devanagari}', "");
    Expect(0, 2432, '\p{Is_Blk:	Devanagari}', "");
    Expect(1, 2432, '\p{^Is_Blk:	Devanagari}', "");
    Expect(1, 2432, '\P{Is_Blk:	Devanagari}', "");
    Expect(0, 2432, '\P{^Is_Blk:	Devanagari}', "");
    Error('\p{Block= :=DEVANAGARI_Extended}');
    Error('\P{Block= :=DEVANAGARI_Extended}');
    Expect(1, 43263, '\p{Block=:\ADevanagari_Extended\z:}', "");;
    Expect(0, 43264, '\p{Block=:\ADevanagari_Extended\z:}', "");;
    Expect(1, 43263, '\p{Block:   devanagariextended}', "");
    Expect(0, 43263, '\p{^Block:   devanagariextended}', "");
    Expect(0, 43263, '\P{Block:   devanagariextended}', "");
    Expect(1, 43263, '\P{^Block:   devanagariextended}', "");
    Expect(0, 43264, '\p{Block:   devanagariextended}', "");
    Expect(1, 43264, '\p{^Block:   devanagariextended}', "");
    Expect(1, 43264, '\P{Block:   devanagariextended}', "");
    Expect(0, 43264, '\P{^Block:   devanagariextended}', "");
    Expect(1, 43263, '\p{Block=:\Adevanagariextended\z:}', "");;
    Expect(0, 43264, '\p{Block=:\Adevanagariextended\z:}', "");;
    Expect(1, 43263, '\p{Block=-devanagari_Extended}', "");
    Expect(0, 43263, '\p{^Block=-devanagari_Extended}', "");
    Expect(0, 43263, '\P{Block=-devanagari_Extended}', "");
    Expect(1, 43263, '\P{^Block=-devanagari_Extended}', "");
    Expect(0, 43264, '\p{Block=-devanagari_Extended}', "");
    Expect(1, 43264, '\p{^Block=-devanagari_Extended}', "");
    Expect(1, 43264, '\P{Block=-devanagari_Extended}', "");
    Expect(0, 43264, '\P{^Block=-devanagari_Extended}', "");
    Error('\p{Blk=:= Devanagari_EXT}');
    Error('\P{Blk=:= Devanagari_EXT}');
    Expect(1, 43263, '\p{Blk=:\ADevanagari_Ext\z:}', "");;
    Expect(0, 43264, '\p{Blk=:\ADevanagari_Ext\z:}', "");;
    Expect(1, 43263, '\p{Blk:	devanagariext}', "");
    Expect(0, 43263, '\p{^Blk:	devanagariext}', "");
    Expect(0, 43263, '\P{Blk:	devanagariext}', "");
    Expect(1, 43263, '\P{^Blk:	devanagariext}', "");
    Expect(0, 43264, '\p{Blk:	devanagariext}', "");
    Expect(1, 43264, '\p{^Blk:	devanagariext}', "");
    Expect(1, 43264, '\P{Blk:	devanagariext}', "");
    Expect(0, 43264, '\P{^Blk:	devanagariext}', "");
    Expect(1, 43263, '\p{Blk=:\Adevanagariext\z:}', "");;
    Expect(0, 43264, '\p{Blk=:\Adevanagariext\z:}', "");;
    Expect(1, 43263, '\p{Blk=-devanagari_Ext}', "");
    Expect(0, 43263, '\p{^Blk=-devanagari_Ext}', "");
    Expect(0, 43263, '\P{Blk=-devanagari_Ext}', "");
    Expect(1, 43263, '\P{^Blk=-devanagari_Ext}', "");
    Expect(0, 43264, '\p{Blk=-devanagari_Ext}', "");
    Expect(1, 43264, '\p{^Blk=-devanagari_Ext}', "");
    Expect(1, 43264, '\P{Blk=-devanagari_Ext}', "");
    Expect(0, 43264, '\P{^Blk=-devanagari_Ext}', "");
    Error('\p{Is_Block=/a/-Devanagari_Extended}');
    Error('\P{Is_Block=/a/-Devanagari_Extended}');
    Expect(1, 43263, '\p{Is_Block=devanagariextended}', "");
    Expect(0, 43263, '\p{^Is_Block=devanagariextended}', "");
    Expect(0, 43263, '\P{Is_Block=devanagariextended}', "");
    Expect(1, 43263, '\P{^Is_Block=devanagariextended}', "");
    Expect(0, 43264, '\p{Is_Block=devanagariextended}', "");
    Expect(1, 43264, '\p{^Is_Block=devanagariextended}', "");
    Expect(1, 43264, '\P{Is_Block=devanagariextended}', "");
    Expect(0, 43264, '\P{^Is_Block=devanagariextended}', "");
    Expect(1, 43263, '\p{Is_Block=-_Devanagari_EXTENDED}', "");
    Expect(0, 43263, '\p{^Is_Block=-_Devanagari_EXTENDED}', "");
    Expect(0, 43263, '\P{Is_Block=-_Devanagari_EXTENDED}', "");
    Expect(1, 43263, '\P{^Is_Block=-_Devanagari_EXTENDED}', "");
    Expect(0, 43264, '\p{Is_Block=-_Devanagari_EXTENDED}', "");
    Expect(1, 43264, '\p{^Is_Block=-_Devanagari_EXTENDED}', "");
    Expect(1, 43264, '\P{Is_Block=-_Devanagari_EXTENDED}', "");
    Expect(0, 43264, '\P{^Is_Block=-_Devanagari_EXTENDED}', "");
    Error('\p{Is_Blk=/a/- Devanagari_EXT}');
    Error('\P{Is_Blk=/a/- Devanagari_EXT}');
    Expect(1, 43263, '\p{Is_Blk=devanagariext}', "");
    Expect(0, 43263, '\p{^Is_Blk=devanagariext}', "");
    Expect(0, 43263, '\P{Is_Blk=devanagariext}', "");
    Expect(1, 43263, '\P{^Is_Blk=devanagariext}', "");
    Expect(0, 43264, '\p{Is_Blk=devanagariext}', "");
    Expect(1, 43264, '\p{^Is_Blk=devanagariext}', "");
    Expect(1, 43264, '\P{Is_Blk=devanagariext}', "");
    Expect(0, 43264, '\P{^Is_Blk=devanagariext}', "");
    Expect(1, 43263, '\p{Is_Blk=-	devanagari_ext}', "");
    Expect(0, 43263, '\p{^Is_Blk=-	devanagari_ext}', "");
    Expect(0, 43263, '\P{Is_Blk=-	devanagari_ext}', "");
    Expect(1, 43263, '\P{^Is_Blk=-	devanagari_ext}', "");
    Expect(0, 43264, '\p{Is_Blk=-	devanagari_ext}', "");
    Expect(1, 43264, '\p{^Is_Blk=-	devanagari_ext}', "");
    Expect(1, 43264, '\P{Is_Blk=-	devanagari_ext}', "");
    Expect(0, 43264, '\P{^Is_Blk=-	devanagari_ext}', "");
    Error('\p{Block=:=Combining_DIACRITICAL_Marks}');
    Error('\P{Block=:=Combining_DIACRITICAL_Marks}');
    Expect(1, 879, '\p{Block=:\ACombining_Diacritical_Marks\z:}', "");;
    Expect(0, 880, '\p{Block=:\ACombining_Diacritical_Marks\z:}', "");;
    Expect(1, 879, '\p{Block=combiningdiacriticalmarks}', "");
    Expect(0, 879, '\p{^Block=combiningdiacriticalmarks}', "");
    Expect(0, 879, '\P{Block=combiningdiacriticalmarks}', "");
    Expect(1, 879, '\P{^Block=combiningdiacriticalmarks}', "");
    Expect(0, 880, '\p{Block=combiningdiacriticalmarks}', "");
    Expect(1, 880, '\p{^Block=combiningdiacriticalmarks}', "");
    Expect(1, 880, '\P{Block=combiningdiacriticalmarks}', "");
    Expect(0, 880, '\P{^Block=combiningdiacriticalmarks}', "");
    Expect(1, 879, '\p{Block=:\Acombiningdiacriticalmarks\z:}', "");;
    Expect(0, 880, '\p{Block=:\Acombiningdiacriticalmarks\z:}', "");;
    Expect(1, 879, '\p{Block=-_combining_Diacritical_marks}', "");
    Expect(0, 879, '\p{^Block=-_combining_Diacritical_marks}', "");
    Expect(0, 879, '\P{Block=-_combining_Diacritical_marks}', "");
    Expect(1, 879, '\P{^Block=-_combining_Diacritical_marks}', "");
    Expect(0, 880, '\p{Block=-_combining_Diacritical_marks}', "");
    Expect(1, 880, '\p{^Block=-_combining_Diacritical_marks}', "");
    Expect(1, 880, '\P{Block=-_combining_Diacritical_marks}', "");
    Expect(0, 880, '\P{^Block=-_combining_Diacritical_marks}', "");
    Error('\p{Blk=_/a/Diacriticals}');
    Error('\P{Blk=_/a/Diacriticals}');
    Expect(1, 879, '\p{Blk=:\ADiacriticals\z:}', "");;
    Expect(0, 880, '\p{Blk=:\ADiacriticals\z:}', "");;
    Expect(1, 879, '\p{Blk=diacriticals}', "");
    Expect(0, 879, '\p{^Blk=diacriticals}', "");
    Expect(0, 879, '\P{Blk=diacriticals}', "");
    Expect(1, 879, '\P{^Blk=diacriticals}', "");
    Expect(0, 880, '\p{Blk=diacriticals}', "");
    Expect(1, 880, '\p{^Blk=diacriticals}', "");
    Expect(1, 880, '\P{Blk=diacriticals}', "");
    Expect(0, 880, '\P{^Blk=diacriticals}', "");
    Expect(1, 879, '\p{Blk=:\Adiacriticals\z:}', "");;
    Expect(0, 880, '\p{Blk=:\Adiacriticals\z:}', "");;
    Expect(1, 879, '\p{Blk= DIACRITICALS}', "");
    Expect(0, 879, '\p{^Blk= DIACRITICALS}', "");
    Expect(0, 879, '\P{Blk= DIACRITICALS}', "");
    Expect(1, 879, '\P{^Blk= DIACRITICALS}', "");
    Expect(0, 880, '\p{Blk= DIACRITICALS}', "");
    Expect(1, 880, '\p{^Blk= DIACRITICALS}', "");
    Expect(1, 880, '\P{Blk= DIACRITICALS}', "");
    Expect(0, 880, '\P{^Blk= DIACRITICALS}', "");
    Error('\p{Is_Block=:=_combining_Diacritical_MARKS}');
    Error('\P{Is_Block=:=_combining_Diacritical_MARKS}');
    Expect(1, 879, '\p{Is_Block:combiningdiacriticalmarks}', "");
    Expect(0, 879, '\p{^Is_Block:combiningdiacriticalmarks}', "");
    Expect(0, 879, '\P{Is_Block:combiningdiacriticalmarks}', "");
    Expect(1, 879, '\P{^Is_Block:combiningdiacriticalmarks}', "");
    Expect(0, 880, '\p{Is_Block:combiningdiacriticalmarks}', "");
    Expect(1, 880, '\p{^Is_Block:combiningdiacriticalmarks}', "");
    Expect(1, 880, '\P{Is_Block:combiningdiacriticalmarks}', "");
    Expect(0, 880, '\P{^Is_Block:combiningdiacriticalmarks}', "");
    Expect(1, 879, '\p{Is_Block=--COMBINING_DIACRITICAL_Marks}', "");
    Expect(0, 879, '\p{^Is_Block=--COMBINING_DIACRITICAL_Marks}', "");
    Expect(0, 879, '\P{Is_Block=--COMBINING_DIACRITICAL_Marks}', "");
    Expect(1, 879, '\P{^Is_Block=--COMBINING_DIACRITICAL_Marks}', "");
    Expect(0, 880, '\p{Is_Block=--COMBINING_DIACRITICAL_Marks}', "");
    Expect(1, 880, '\p{^Is_Block=--COMBINING_DIACRITICAL_Marks}', "");
    Expect(1, 880, '\P{Is_Block=--COMBINING_DIACRITICAL_Marks}', "");
    Expect(0, 880, '\P{^Is_Block=--COMBINING_DIACRITICAL_Marks}', "");
    Error('\p{Is_Blk: :=_Diacriticals}');
    Error('\P{Is_Blk: :=_Diacriticals}');
    Expect(1, 879, '\p{Is_Blk=diacriticals}', "");
    Expect(0, 879, '\p{^Is_Blk=diacriticals}', "");
    Expect(0, 879, '\P{Is_Blk=diacriticals}', "");
    Expect(1, 879, '\P{^Is_Blk=diacriticals}', "");
    Expect(0, 880, '\p{Is_Blk=diacriticals}', "");
    Expect(1, 880, '\p{^Is_Blk=diacriticals}', "");
    Expect(1, 880, '\P{Is_Blk=diacriticals}', "");
    Expect(0, 880, '\P{^Is_Blk=diacriticals}', "");
    Expect(1, 879, '\p{Is_Blk=  Diacriticals}', "");
    Expect(0, 879, '\p{^Is_Blk=  Diacriticals}', "");
    Expect(0, 879, '\P{Is_Blk=  Diacriticals}', "");
    Expect(1, 879, '\P{^Is_Blk=  Diacriticals}', "");
    Expect(0, 880, '\p{Is_Blk=  Diacriticals}', "");
    Expect(1, 880, '\p{^Is_Blk=  Diacriticals}', "");
    Expect(1, 880, '\P{Is_Blk=  Diacriticals}', "");
    Expect(0, 880, '\P{^Is_Blk=  Diacriticals}', "");
    Error('\p{Block= Combining_diacritical_Marks_EXTENDED/a/}');
    Error('\P{Block= Combining_diacritical_Marks_EXTENDED/a/}');
    Expect(1, 6911, '\p{Block=:\ACombining_Diacritical_Marks_Extended\z:}', "");;
    Expect(0, 6912, '\p{Block=:\ACombining_Diacritical_Marks_Extended\z:}', "");;
    Expect(1, 6911, '\p{Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\p{^Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\P{Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\P{^Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\p{Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\p{^Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\P{Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\P{^Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\p{Block=:\Acombiningdiacriticalmarksextended\z:}', "");;
    Expect(0, 6912, '\p{Block=:\Acombiningdiacriticalmarksextended\z:}', "");;
    Expect(1, 6911, '\p{Block:   -	COMBINING_diacritical_Marks_EXTENDED}', "");
    Expect(0, 6911, '\p{^Block:   -	COMBINING_diacritical_Marks_EXTENDED}', "");
    Expect(0, 6911, '\P{Block:   -	COMBINING_diacritical_Marks_EXTENDED}', "");
    Expect(1, 6911, '\P{^Block:   -	COMBINING_diacritical_Marks_EXTENDED}', "");
    Expect(0, 6912, '\p{Block:   -	COMBINING_diacritical_Marks_EXTENDED}', "");
    Expect(1, 6912, '\p{^Block:   -	COMBINING_diacritical_Marks_EXTENDED}', "");
    Expect(1, 6912, '\P{Block:   -	COMBINING_diacritical_Marks_EXTENDED}', "");
    Expect(0, 6912, '\P{^Block:   -	COMBINING_diacritical_Marks_EXTENDED}', "");
    Error('\p{Blk=-Diacriticals_Ext/a/}');
    Error('\P{Blk=-Diacriticals_Ext/a/}');
    Expect(1, 6911, '\p{Blk=:\ADiacriticals_Ext\z:}', "");;
    Expect(0, 6912, '\p{Blk=:\ADiacriticals_Ext\z:}', "");;
    Expect(1, 6911, '\p{Blk:   diacriticalsext}', "");
    Expect(0, 6911, '\p{^Blk:   diacriticalsext}', "");
    Expect(0, 6911, '\P{Blk:   diacriticalsext}', "");
    Expect(1, 6911, '\P{^Blk:   diacriticalsext}', "");
    Expect(0, 6912, '\p{Blk:   diacriticalsext}', "");
    Expect(1, 6912, '\p{^Blk:   diacriticalsext}', "");
    Expect(1, 6912, '\P{Blk:   diacriticalsext}', "");
    Expect(0, 6912, '\P{^Blk:   diacriticalsext}', "");
    Expect(1, 6911, '\p{Blk=:\Adiacriticalsext\z:}', "");;
    Expect(0, 6912, '\p{Blk=:\Adiacriticalsext\z:}', "");;
    Expect(1, 6911, '\p{Blk=_Diacriticals_Ext}', "");
    Expect(0, 6911, '\p{^Blk=_Diacriticals_Ext}', "");
    Expect(0, 6911, '\P{Blk=_Diacriticals_Ext}', "");
    Expect(1, 6911, '\P{^Blk=_Diacriticals_Ext}', "");
    Expect(0, 6912, '\p{Blk=_Diacriticals_Ext}', "");
    Expect(1, 6912, '\p{^Blk=_Diacriticals_Ext}', "");
    Expect(1, 6912, '\P{Blk=_Diacriticals_Ext}', "");
    Expect(0, 6912, '\P{^Blk=_Diacriticals_Ext}', "");
    Error('\p{Is_Block=-:=COMBINING_diacritical_MARKS_extended}');
    Error('\P{Is_Block=-:=COMBINING_diacritical_MARKS_extended}');
    Expect(1, 6911, '\p{Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\p{^Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\P{Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\P{^Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\p{Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\p{^Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\P{Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\P{^Is_Block=combiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\p{Is_Block= 	combining_diacritical_MARKS_extended}', "");
    Expect(0, 6911, '\p{^Is_Block= 	combining_diacritical_MARKS_extended}', "");
    Expect(0, 6911, '\P{Is_Block= 	combining_diacritical_MARKS_extended}', "");
    Expect(1, 6911, '\P{^Is_Block= 	combining_diacritical_MARKS_extended}', "");
    Expect(0, 6912, '\p{Is_Block= 	combining_diacritical_MARKS_extended}', "");
    Expect(1, 6912, '\p{^Is_Block= 	combining_diacritical_MARKS_extended}', "");
    Expect(1, 6912, '\P{Is_Block= 	combining_diacritical_MARKS_extended}', "");
    Expect(0, 6912, '\P{^Is_Block= 	combining_diacritical_MARKS_extended}', "");
    Error('\p{Is_Blk=_-Diacriticals_EXT/a/}');
    Error('\P{Is_Blk=_-Diacriticals_EXT/a/}');
    Expect(1, 6911, '\p{Is_Blk=diacriticalsext}', "");
    Expect(0, 6911, '\p{^Is_Blk=diacriticalsext}', "");
    Expect(0, 6911, '\P{Is_Blk=diacriticalsext}', "");
    Expect(1, 6911, '\P{^Is_Blk=diacriticalsext}', "");
    Expect(0, 6912, '\p{Is_Blk=diacriticalsext}', "");
    Expect(1, 6912, '\p{^Is_Blk=diacriticalsext}', "");
    Expect(1, 6912, '\P{Is_Blk=diacriticalsext}', "");
    Expect(0, 6912, '\P{^Is_Blk=diacriticalsext}', "");
    Expect(1, 6911, '\p{Is_Blk= _DIACRITICALS_EXT}', "");
    Expect(0, 6911, '\p{^Is_Blk= _DIACRITICALS_EXT}', "");
    Expect(0, 6911, '\P{Is_Blk= _DIACRITICALS_EXT}', "");
    Expect(1, 6911, '\P{^Is_Blk= _DIACRITICALS_EXT}', "");
    Expect(0, 6912, '\p{Is_Blk= _DIACRITICALS_EXT}', "");
    Expect(1, 6912, '\p{^Is_Blk= _DIACRITICALS_EXT}', "");
    Expect(1, 6912, '\P{Is_Blk= _DIACRITICALS_EXT}', "");
    Expect(0, 6912, '\P{^Is_Blk= _DIACRITICALS_EXT}', "");
    Error('\p{Block:	:= _COMBINING_Diacritical_marks_FOR_Symbols}');
    Error('\P{Block:	:= _COMBINING_Diacritical_marks_FOR_Symbols}');
    Expect(1, 8447, '\p{Block=:\ACombining_Diacritical_Marks_For_Symbols\z:}', "");;
    Expect(0, 8448, '\p{Block=:\ACombining_Diacritical_Marks_For_Symbols\z:}', "");;
    Expect(1, 8447, '\p{Block=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\p{^Block=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\P{Block=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\P{^Block=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\p{Block=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\p{^Block=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\P{Block=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\P{^Block=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\p{Block=:\Acombiningdiacriticalmarksforsymbols\z:}', "");;
    Expect(0, 8448, '\p{Block=:\Acombiningdiacriticalmarksforsymbols\z:}', "");;
    Expect(1, 8447, '\p{Block=- combining_diacritical_Marks_FOR_SYMBOLS}', "");
    Expect(0, 8447, '\p{^Block=- combining_diacritical_Marks_FOR_SYMBOLS}', "");
    Expect(0, 8447, '\P{Block=- combining_diacritical_Marks_FOR_SYMBOLS}', "");
    Expect(1, 8447, '\P{^Block=- combining_diacritical_Marks_FOR_SYMBOLS}', "");
    Expect(0, 8448, '\p{Block=- combining_diacritical_Marks_FOR_SYMBOLS}', "");
    Expect(1, 8448, '\p{^Block=- combining_diacritical_Marks_FOR_SYMBOLS}', "");
    Expect(1, 8448, '\P{Block=- combining_diacritical_Marks_FOR_SYMBOLS}', "");
    Expect(0, 8448, '\P{^Block=- combining_diacritical_Marks_FOR_SYMBOLS}', "");
    Error('\p{Blk: /a/--Diacriticals_For_Symbols}');
    Error('\P{Blk: /a/--Diacriticals_For_Symbols}');
    Expect(1, 8447, '\p{Blk=:\ADiacriticals_For_Symbols\z:}', "");;
    Expect(0, 8448, '\p{Blk=:\ADiacriticals_For_Symbols\z:}', "");;
    Expect(1, 8447, '\p{Blk=diacriticalsforsymbols}', "");
    Expect(0, 8447, '\p{^Blk=diacriticalsforsymbols}', "");
    Expect(0, 8447, '\P{Blk=diacriticalsforsymbols}', "");
    Expect(1, 8447, '\P{^Blk=diacriticalsforsymbols}', "");
    Expect(0, 8448, '\p{Blk=diacriticalsforsymbols}', "");
    Expect(1, 8448, '\p{^Blk=diacriticalsforsymbols}', "");
    Expect(1, 8448, '\P{Blk=diacriticalsforsymbols}', "");
    Expect(0, 8448, '\P{^Blk=diacriticalsforsymbols}', "");
    Expect(1, 8447, '\p{Blk=:\Adiacriticalsforsymbols\z:}', "");;
    Expect(0, 8448, '\p{Blk=:\Adiacriticalsforsymbols\z:}', "");;
    Expect(1, 8447, '\p{Blk= 	Diacriticals_For_Symbols}', "");
    Expect(0, 8447, '\p{^Blk= 	Diacriticals_For_Symbols}', "");
    Expect(0, 8447, '\P{Blk= 	Diacriticals_For_Symbols}', "");
    Expect(1, 8447, '\P{^Blk= 	Diacriticals_For_Symbols}', "");
    Expect(0, 8448, '\p{Blk= 	Diacriticals_For_Symbols}', "");
    Expect(1, 8448, '\p{^Blk= 	Diacriticals_For_Symbols}', "");
    Expect(1, 8448, '\P{Blk= 	Diacriticals_For_Symbols}', "");
    Expect(0, 8448, '\P{^Blk= 	Diacriticals_For_Symbols}', "");
    Error('\p{Is_Block=_:=COMBINING_marks_For_Symbols}');
    Error('\P{Is_Block=_:=COMBINING_marks_For_Symbols}');
    Expect(1, 8447, '\p{Is_Block:combiningmarksforsymbols}', "");
    Expect(0, 8447, '\p{^Is_Block:combiningmarksforsymbols}', "");
    Expect(0, 8447, '\P{Is_Block:combiningmarksforsymbols}', "");
    Expect(1, 8447, '\P{^Is_Block:combiningmarksforsymbols}', "");
    Expect(0, 8448, '\p{Is_Block:combiningmarksforsymbols}', "");
    Expect(1, 8448, '\p{^Is_Block:combiningmarksforsymbols}', "");
    Expect(1, 8448, '\P{Is_Block:combiningmarksforsymbols}', "");
    Expect(0, 8448, '\P{^Is_Block:combiningmarksforsymbols}', "");
    Expect(1, 8447, '\p{Is_Block=-Combining_marks_FOR_symbols}', "");
    Expect(0, 8447, '\p{^Is_Block=-Combining_marks_FOR_symbols}', "");
    Expect(0, 8447, '\P{Is_Block=-Combining_marks_FOR_symbols}', "");
    Expect(1, 8447, '\P{^Is_Block=-Combining_marks_FOR_symbols}', "");
    Expect(0, 8448, '\p{Is_Block=-Combining_marks_FOR_symbols}', "");
    Expect(1, 8448, '\p{^Is_Block=-Combining_marks_FOR_symbols}', "");
    Expect(1, 8448, '\P{Is_Block=-Combining_marks_FOR_symbols}', "");
    Expect(0, 8448, '\P{^Is_Block=-Combining_marks_FOR_symbols}', "");
    Error('\p{Is_Blk=_combining_DIACRITICAL_Marks_For_Symbols:=}');
    Error('\P{Is_Blk=_combining_DIACRITICAL_Marks_For_Symbols:=}');
    Expect(1, 8447, '\p{Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\p{^Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\P{Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\P{^Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\p{Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\p{^Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\P{Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\P{^Is_Blk=combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\p{Is_Blk:			combining_Diacritical_MARKS_for_Symbols}', "");
    Expect(0, 8447, '\p{^Is_Blk:			combining_Diacritical_MARKS_for_Symbols}', "");
    Expect(0, 8447, '\P{Is_Blk:			combining_Diacritical_MARKS_for_Symbols}', "");
    Expect(1, 8447, '\P{^Is_Blk:			combining_Diacritical_MARKS_for_Symbols}', "");
    Expect(0, 8448, '\p{Is_Blk:			combining_Diacritical_MARKS_for_Symbols}', "");
    Expect(1, 8448, '\p{^Is_Blk:			combining_Diacritical_MARKS_for_Symbols}', "");
    Expect(1, 8448, '\P{Is_Blk:			combining_Diacritical_MARKS_for_Symbols}', "");
    Expect(0, 8448, '\P{^Is_Blk:			combining_Diacritical_MARKS_for_Symbols}', "");
    Error('\p{Block=/a/		Combining_DIACRITICAL_MARKS_Supplement}');
    Error('\P{Block=/a/		Combining_DIACRITICAL_MARKS_Supplement}');
    Expect(1, 7679, '\p{Block=:\ACombining_Diacritical_Marks_Supplement\z:}', "");;
    Expect(0, 7680, '\p{Block=:\ACombining_Diacritical_Marks_Supplement\z:}', "");;
    Expect(1, 7679, '\p{Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\p{^Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\P{Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\P{^Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\p{Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\p{^Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\P{Block=combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\P{^Block=combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\p{Block=:\Acombiningdiacriticalmarkssupplement\z:}', "");;
    Expect(0, 7680, '\p{Block=:\Acombiningdiacriticalmarkssupplement\z:}', "");;
    Expect(1, 7679, '\p{Block=__COMBINING_Diacritical_marks_Supplement}', "");
    Expect(0, 7679, '\p{^Block=__COMBINING_Diacritical_marks_Supplement}', "");
    Expect(0, 7679, '\P{Block=__COMBINING_Diacritical_marks_Supplement}', "");
    Expect(1, 7679, '\P{^Block=__COMBINING_Diacritical_marks_Supplement}', "");
    Expect(0, 7680, '\p{Block=__COMBINING_Diacritical_marks_Supplement}', "");
    Expect(1, 7680, '\p{^Block=__COMBINING_Diacritical_marks_Supplement}', "");
    Expect(1, 7680, '\P{Block=__COMBINING_Diacritical_marks_Supplement}', "");
    Expect(0, 7680, '\P{^Block=__COMBINING_Diacritical_marks_Supplement}', "");
    Error('\p{Blk:	/a/  DIACRITICALS_sup}');
    Error('\P{Blk:	/a/  DIACRITICALS_sup}');
    Expect(1, 7679, '\p{Blk=:\ADiacriticals_Sup\z:}', "");;
    Expect(0, 7680, '\p{Blk=:\ADiacriticals_Sup\z:}', "");;
    Expect(1, 7679, '\p{Blk=diacriticalssup}', "");
    Expect(0, 7679, '\p{^Blk=diacriticalssup}', "");
    Expect(0, 7679, '\P{Blk=diacriticalssup}', "");
    Expect(1, 7679, '\P{^Blk=diacriticalssup}', "");
    Expect(0, 7680, '\p{Blk=diacriticalssup}', "");
    Expect(1, 7680, '\p{^Blk=diacriticalssup}', "");
    Expect(1, 7680, '\P{Blk=diacriticalssup}', "");
    Expect(0, 7680, '\P{^Blk=diacriticalssup}', "");
    Expect(1, 7679, '\p{Blk=:\Adiacriticalssup\z:}', "");;
    Expect(0, 7680, '\p{Blk=:\Adiacriticalssup\z:}', "");;
    Expect(1, 7679, '\p{Blk=-	DIACRITICALS_Sup}', "");
    Expect(0, 7679, '\p{^Blk=-	DIACRITICALS_Sup}', "");
    Expect(0, 7679, '\P{Blk=-	DIACRITICALS_Sup}', "");
    Expect(1, 7679, '\P{^Blk=-	DIACRITICALS_Sup}', "");
    Expect(0, 7680, '\p{Blk=-	DIACRITICALS_Sup}', "");
    Expect(1, 7680, '\p{^Blk=-	DIACRITICALS_Sup}', "");
    Expect(1, 7680, '\P{Blk=-	DIACRITICALS_Sup}', "");
    Expect(0, 7680, '\P{^Blk=-	DIACRITICALS_Sup}', "");
    Error('\p{Is_Block: :=Combining_DIACRITICAL_MARKS_Supplement}');
    Error('\P{Is_Block: :=Combining_DIACRITICAL_MARKS_Supplement}');
    Expect(1, 7679, '\p{Is_Block:combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\p{^Is_Block:combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\P{Is_Block:combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\P{^Is_Block:combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\p{Is_Block:combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\p{^Is_Block:combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\P{Is_Block:combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\P{^Is_Block:combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\p{Is_Block=	 combining_DIACRITICAL_marks_supplement}', "");
    Expect(0, 7679, '\p{^Is_Block=	 combining_DIACRITICAL_marks_supplement}', "");
    Expect(0, 7679, '\P{Is_Block=	 combining_DIACRITICAL_marks_supplement}', "");
    Expect(1, 7679, '\P{^Is_Block=	 combining_DIACRITICAL_marks_supplement}', "");
    Expect(0, 7680, '\p{Is_Block=	 combining_DIACRITICAL_marks_supplement}', "");
    Expect(1, 7680, '\p{^Is_Block=	 combining_DIACRITICAL_marks_supplement}', "");
    Expect(1, 7680, '\P{Is_Block=	 combining_DIACRITICAL_marks_supplement}', "");
    Expect(0, 7680, '\P{^Is_Block=	 combining_DIACRITICAL_marks_supplement}', "");
    Error('\p{Is_Blk:	/a/ -diacriticals_SUP}');
    Error('\P{Is_Blk:	/a/ -diacriticals_SUP}');
    Expect(1, 7679, '\p{Is_Blk=diacriticalssup}', "");
    Expect(0, 7679, '\p{^Is_Blk=diacriticalssup}', "");
    Expect(0, 7679, '\P{Is_Blk=diacriticalssup}', "");
    Expect(1, 7679, '\P{^Is_Blk=diacriticalssup}', "");
    Expect(0, 7680, '\p{Is_Blk=diacriticalssup}', "");
    Expect(1, 7680, '\p{^Is_Blk=diacriticalssup}', "");
    Expect(1, 7680, '\P{Is_Blk=diacriticalssup}', "");
    Expect(0, 7680, '\P{^Is_Blk=diacriticalssup}', "");
    Expect(1, 7679, '\p{Is_Blk=	Diacriticals_sup}', "");
    Expect(0, 7679, '\p{^Is_Blk=	Diacriticals_sup}', "");
    Expect(0, 7679, '\P{Is_Blk=	Diacriticals_sup}', "");
    Expect(1, 7679, '\P{^Is_Blk=	Diacriticals_sup}', "");
    Expect(0, 7680, '\p{Is_Blk=	Diacriticals_sup}', "");
    Expect(1, 7680, '\p{^Is_Blk=	Diacriticals_sup}', "");
    Expect(1, 7680, '\P{Is_Blk=	Diacriticals_sup}', "");
    Expect(0, 7680, '\P{^Is_Blk=	Diacriticals_sup}', "");
    Error('\p{Block: :=DINGBATS}');
    Error('\P{Block: :=DINGBATS}');
    Expect(1, 10175, '\p{Block=:\ADingbats\z:}', "");;
    Expect(0, 10176, '\p{Block=:\ADingbats\z:}', "");;
    Expect(1, 10175, '\p{Block=dingbats}', "");
    Expect(0, 10175, '\p{^Block=dingbats}', "");
    Expect(0, 10175, '\P{Block=dingbats}', "");
    Expect(1, 10175, '\P{^Block=dingbats}', "");
    Expect(0, 10176, '\p{Block=dingbats}', "");
    Expect(1, 10176, '\p{^Block=dingbats}', "");
    Expect(1, 10176, '\P{Block=dingbats}', "");
    Expect(0, 10176, '\P{^Block=dingbats}', "");
    Expect(1, 10175, '\p{Block=:\Adingbats\z:}', "");;
    Expect(0, 10176, '\p{Block=:\Adingbats\z:}', "");;
    Expect(1, 10175, '\p{Block= DINGBATS}', "");
    Expect(0, 10175, '\p{^Block= DINGBATS}', "");
    Expect(0, 10175, '\P{Block= DINGBATS}', "");
    Expect(1, 10175, '\P{^Block= DINGBATS}', "");
    Expect(0, 10176, '\p{Block= DINGBATS}', "");
    Expect(1, 10176, '\p{^Block= DINGBATS}', "");
    Expect(1, 10176, '\P{Block= DINGBATS}', "");
    Expect(0, 10176, '\P{^Block= DINGBATS}', "");
    Error('\p{Blk=/a/dingbats}');
    Error('\P{Blk=/a/dingbats}');
    Expect(1, 10175, '\p{Blk=:\ADingbats\z:}', "");;
    Expect(0, 10176, '\p{Blk=:\ADingbats\z:}', "");;
    Expect(1, 10175, '\p{Blk=dingbats}', "");
    Expect(0, 10175, '\p{^Blk=dingbats}', "");
    Expect(0, 10175, '\P{Blk=dingbats}', "");
    Expect(1, 10175, '\P{^Blk=dingbats}', "");
    Expect(0, 10176, '\p{Blk=dingbats}', "");
    Expect(1, 10176, '\p{^Blk=dingbats}', "");
    Expect(1, 10176, '\P{Blk=dingbats}', "");
    Expect(0, 10176, '\P{^Blk=dingbats}', "");
    Expect(1, 10175, '\p{Blk=:\Adingbats\z:}', "");;
    Expect(0, 10176, '\p{Blk=:\Adingbats\z:}', "");;
    Expect(1, 10175, '\p{Blk:   Dingbats}', "");
    Expect(0, 10175, '\p{^Blk:   Dingbats}', "");
    Expect(0, 10175, '\P{Blk:   Dingbats}', "");
    Expect(1, 10175, '\P{^Blk:   Dingbats}', "");
    Expect(0, 10176, '\p{Blk:   Dingbats}', "");
    Expect(1, 10176, '\p{^Blk:   Dingbats}', "");
    Expect(1, 10176, '\P{Blk:   Dingbats}', "");
    Expect(0, 10176, '\P{^Blk:   Dingbats}', "");
    Error('\p{Is_Block=_/a/DINGBATS}');
    Error('\P{Is_Block=_/a/DINGBATS}');
    Expect(1, 10175, '\p{Is_Block:dingbats}', "");
    Expect(0, 10175, '\p{^Is_Block:dingbats}', "");
    Expect(0, 10175, '\P{Is_Block:dingbats}', "");
    Expect(1, 10175, '\P{^Is_Block:dingbats}', "");
    Expect(0, 10176, '\p{Is_Block:dingbats}', "");
    Expect(1, 10176, '\p{^Is_Block:dingbats}', "");
    Expect(1, 10176, '\P{Is_Block:dingbats}', "");
    Expect(0, 10176, '\P{^Is_Block:dingbats}', "");
    Expect(1, 10175, '\p{Is_Block=  DINGBATS}', "");
    Expect(0, 10175, '\p{^Is_Block=  DINGBATS}', "");
    Expect(0, 10175, '\P{Is_Block=  DINGBATS}', "");
    Expect(1, 10175, '\P{^Is_Block=  DINGBATS}', "");
    Expect(0, 10176, '\p{Is_Block=  DINGBATS}', "");
    Expect(1, 10176, '\p{^Is_Block=  DINGBATS}', "");
    Expect(1, 10176, '\P{Is_Block=  DINGBATS}', "");
    Expect(0, 10176, '\P{^Is_Block=  DINGBATS}', "");
    Error('\p{Is_Blk=:=Dingbats}');
    Error('\P{Is_Blk=:=Dingbats}');
    Expect(1, 10175, '\p{Is_Blk=dingbats}', "");
    Expect(0, 10175, '\p{^Is_Blk=dingbats}', "");
    Expect(0, 10175, '\P{Is_Blk=dingbats}', "");
    Expect(1, 10175, '\P{^Is_Blk=dingbats}', "");
    Expect(0, 10176, '\p{Is_Blk=dingbats}', "");
    Expect(1, 10176, '\p{^Is_Blk=dingbats}', "");
    Expect(1, 10176, '\P{Is_Blk=dingbats}', "");
    Expect(0, 10176, '\P{^Is_Blk=dingbats}', "");
    Expect(1, 10175, '\p{Is_Blk=_dingbats}', "");
    Expect(0, 10175, '\p{^Is_Blk=_dingbats}', "");
    Expect(0, 10175, '\P{Is_Blk=_dingbats}', "");
    Expect(1, 10175, '\P{^Is_Blk=_dingbats}', "");
    Expect(0, 10176, '\p{Is_Blk=_dingbats}', "");
    Expect(1, 10176, '\p{^Is_Blk=_dingbats}', "");
    Expect(1, 10176, '\P{Is_Blk=_dingbats}', "");
    Expect(0, 10176, '\P{^Is_Blk=_dingbats}', "");
    Error('\p{Block=-_Dogra:=}');
    Error('\P{Block=-_Dogra:=}');
    Expect(1, 71759, '\p{Block=:\ADogra\z:}', "");;
    Expect(0, 71760, '\p{Block=:\ADogra\z:}', "");;
    Expect(1, 71759, '\p{Block:dogra}', "");
    Expect(0, 71759, '\p{^Block:dogra}', "");
    Expect(0, 71759, '\P{Block:dogra}', "");
    Expect(1, 71759, '\P{^Block:dogra}', "");
    Expect(0, 71760, '\p{Block:dogra}', "");
    Expect(1, 71760, '\p{^Block:dogra}', "");
    Expect(1, 71760, '\P{Block:dogra}', "");
    Expect(0, 71760, '\P{^Block:dogra}', "");
    Expect(1, 71759, '\p{Block=:\Adogra\z:}', "");;
    Expect(0, 71760, '\p{Block=:\Adogra\z:}', "");;
    Expect(1, 71759, '\p{Block=  Dogra}', "");
    Expect(0, 71759, '\p{^Block=  Dogra}', "");
    Expect(0, 71759, '\P{Block=  Dogra}', "");
    Expect(1, 71759, '\P{^Block=  Dogra}', "");
    Expect(0, 71760, '\p{Block=  Dogra}', "");
    Expect(1, 71760, '\p{^Block=  Dogra}', "");
    Expect(1, 71760, '\P{Block=  Dogra}', "");
    Expect(0, 71760, '\P{^Block=  Dogra}', "");
    Error('\p{Blk=/a/ 	DOGRA}');
    Error('\P{Blk=/a/ 	DOGRA}');
    Expect(1, 71759, '\p{Blk=:\ADogra\z:}', "");;
    Expect(0, 71760, '\p{Blk=:\ADogra\z:}', "");;
    Expect(1, 71759, '\p{Blk=dogra}', "");
    Expect(0, 71759, '\p{^Blk=dogra}', "");
    Expect(0, 71759, '\P{Blk=dogra}', "");
    Expect(1, 71759, '\P{^Blk=dogra}', "");
    Expect(0, 71760, '\p{Blk=dogra}', "");
    Expect(1, 71760, '\p{^Blk=dogra}', "");
    Expect(1, 71760, '\P{Blk=dogra}', "");
    Expect(0, 71760, '\P{^Blk=dogra}', "");
    Expect(1, 71759, '\p{Blk=:\Adogra\z:}', "");;
    Expect(0, 71760, '\p{Blk=:\Adogra\z:}', "");;
    Expect(1, 71759, '\p{Blk= _DOGRA}', "");
    Expect(0, 71759, '\p{^Blk= _DOGRA}', "");
    Expect(0, 71759, '\P{Blk= _DOGRA}', "");
    Expect(1, 71759, '\P{^Blk= _DOGRA}', "");
    Expect(0, 71760, '\p{Blk= _DOGRA}', "");
    Expect(1, 71760, '\p{^Blk= _DOGRA}', "");
    Expect(1, 71760, '\P{Blk= _DOGRA}', "");
    Expect(0, 71760, '\P{^Blk= _DOGRA}', "");
    Error('\p{Is_Block=:= -Dogra}');
    Error('\P{Is_Block=:= -Dogra}');
    Expect(1, 71759, '\p{Is_Block=dogra}', "");
    Expect(0, 71759, '\p{^Is_Block=dogra}', "");
    Expect(0, 71759, '\P{Is_Block=dogra}', "");
    Expect(1, 71759, '\P{^Is_Block=dogra}', "");
    Expect(0, 71760, '\p{Is_Block=dogra}', "");
    Expect(1, 71760, '\p{^Is_Block=dogra}', "");
    Expect(1, 71760, '\P{Is_Block=dogra}', "");
    Expect(0, 71760, '\P{^Is_Block=dogra}', "");
    Expect(1, 71759, '\p{Is_Block=	_Dogra}', "");
    Expect(0, 71759, '\p{^Is_Block=	_Dogra}', "");
    Expect(0, 71759, '\P{Is_Block=	_Dogra}', "");
    Expect(1, 71759, '\P{^Is_Block=	_Dogra}', "");
    Expect(0, 71760, '\p{Is_Block=	_Dogra}', "");
    Expect(1, 71760, '\p{^Is_Block=	_Dogra}', "");
    Expect(1, 71760, '\P{Is_Block=	_Dogra}', "");
    Expect(0, 71760, '\P{^Is_Block=	_Dogra}', "");
    Error('\p{Is_Blk:   /a/-	dogra}');
    Error('\P{Is_Blk:   /a/-	dogra}');
    Expect(1, 71759, '\p{Is_Blk=dogra}', "");
    Expect(0, 71759, '\p{^Is_Blk=dogra}', "");
    Expect(0, 71759, '\P{Is_Blk=dogra}', "");
    Expect(1, 71759, '\P{^Is_Blk=dogra}', "");
    Expect(0, 71760, '\p{Is_Blk=dogra}', "");
    Expect(1, 71760, '\p{^Is_Blk=dogra}', "");
    Expect(1, 71760, '\P{Is_Blk=dogra}', "");
    Expect(0, 71760, '\P{^Is_Blk=dogra}', "");
    Expect(1, 71759, '\p{Is_Blk=	 Dogra}', "");
    Expect(0, 71759, '\p{^Is_Blk=	 Dogra}', "");
    Expect(0, 71759, '\P{Is_Blk=	 Dogra}', "");
    Expect(1, 71759, '\P{^Is_Blk=	 Dogra}', "");
    Expect(0, 71760, '\p{Is_Blk=	 Dogra}', "");
    Expect(1, 71760, '\p{^Is_Blk=	 Dogra}', "");
    Expect(1, 71760, '\P{Is_Blk=	 Dogra}', "");
    Expect(0, 71760, '\P{^Is_Blk=	 Dogra}', "");
    Error('\p{Block=/a/domino_Tiles}');
    Error('\P{Block=/a/domino_Tiles}');
    Expect(1, 127135, '\p{Block=:\ADomino_Tiles\z:}', "");;
    Expect(0, 127136, '\p{Block=:\ADomino_Tiles\z:}', "");;
    Expect(1, 127135, '\p{Block:   dominotiles}', "");
    Expect(0, 127135, '\p{^Block:   dominotiles}', "");
    Expect(0, 127135, '\P{Block:   dominotiles}', "");
    Expect(1, 127135, '\P{^Block:   dominotiles}', "");
    Expect(0, 127136, '\p{Block:   dominotiles}', "");
    Expect(1, 127136, '\p{^Block:   dominotiles}', "");
    Expect(1, 127136, '\P{Block:   dominotiles}', "");
    Expect(0, 127136, '\P{^Block:   dominotiles}', "");
    Expect(1, 127135, '\p{Block=:\Adominotiles\z:}', "");;
    Expect(0, 127136, '\p{Block=:\Adominotiles\z:}', "");;
    Expect(1, 127135, '\p{Block=  Domino_TILES}', "");
    Expect(0, 127135, '\p{^Block=  Domino_TILES}', "");
    Expect(0, 127135, '\P{Block=  Domino_TILES}', "");
    Expect(1, 127135, '\P{^Block=  Domino_TILES}', "");
    Expect(0, 127136, '\p{Block=  Domino_TILES}', "");
    Expect(1, 127136, '\p{^Block=  Domino_TILES}', "");
    Expect(1, 127136, '\P{Block=  Domino_TILES}', "");
    Expect(0, 127136, '\P{^Block=  Domino_TILES}', "");
    Error('\p{Blk= _Domino:=}');
    Error('\P{Blk= _Domino:=}');
    Expect(1, 127135, '\p{Blk=:\ADomino\z:}', "");;
    Expect(0, 127136, '\p{Blk=:\ADomino\z:}', "");;
    Expect(1, 127135, '\p{Blk=domino}', "");
    Expect(0, 127135, '\p{^Blk=domino}', "");
    Expect(0, 127135, '\P{Blk=domino}', "");
    Expect(1, 127135, '\P{^Blk=domino}', "");
    Expect(0, 127136, '\p{Blk=domino}', "");
    Expect(1, 127136, '\p{^Blk=domino}', "");
    Expect(1, 127136, '\P{Blk=domino}', "");
    Expect(0, 127136, '\P{^Blk=domino}', "");
    Expect(1, 127135, '\p{Blk=:\Adomino\z:}', "");;
    Expect(0, 127136, '\p{Blk=:\Adomino\z:}', "");;
    Expect(1, 127135, '\p{Blk= -domino}', "");
    Expect(0, 127135, '\p{^Blk= -domino}', "");
    Expect(0, 127135, '\P{Blk= -domino}', "");
    Expect(1, 127135, '\P{^Blk= -domino}', "");
    Expect(0, 127136, '\p{Blk= -domino}', "");
    Expect(1, 127136, '\p{^Blk= -domino}', "");
    Expect(1, 127136, '\P{Blk= -domino}', "");
    Expect(0, 127136, '\P{^Blk= -domino}', "");
    Error('\p{Is_Block=	/a/Domino_tiles}');
    Error('\P{Is_Block=	/a/Domino_tiles}');
    Expect(1, 127135, '\p{Is_Block=dominotiles}', "");
    Expect(0, 127135, '\p{^Is_Block=dominotiles}', "");
    Expect(0, 127135, '\P{Is_Block=dominotiles}', "");
    Expect(1, 127135, '\P{^Is_Block=dominotiles}', "");
    Expect(0, 127136, '\p{Is_Block=dominotiles}', "");
    Expect(1, 127136, '\p{^Is_Block=dominotiles}', "");
    Expect(1, 127136, '\P{Is_Block=dominotiles}', "");
    Expect(0, 127136, '\P{^Is_Block=dominotiles}', "");
    Expect(1, 127135, '\p{Is_Block=-domino_Tiles}', "");
    Expect(0, 127135, '\p{^Is_Block=-domino_Tiles}', "");
    Expect(0, 127135, '\P{Is_Block=-domino_Tiles}', "");
    Expect(1, 127135, '\P{^Is_Block=-domino_Tiles}', "");
    Expect(0, 127136, '\p{Is_Block=-domino_Tiles}', "");
    Expect(1, 127136, '\p{^Is_Block=-domino_Tiles}', "");
    Expect(1, 127136, '\P{Is_Block=-domino_Tiles}', "");
    Expect(0, 127136, '\P{^Is_Block=-domino_Tiles}', "");
    Error('\p{Is_Blk=	Domino:=}');
    Error('\P{Is_Blk=	Domino:=}');
    Expect(1, 127135, '\p{Is_Blk=domino}', "");
    Expect(0, 127135, '\p{^Is_Blk=domino}', "");
    Expect(0, 127135, '\P{Is_Blk=domino}', "");
    Expect(1, 127135, '\P{^Is_Blk=domino}', "");
    Expect(0, 127136, '\p{Is_Blk=domino}', "");
    Expect(1, 127136, '\p{^Is_Blk=domino}', "");
    Expect(1, 127136, '\P{Is_Blk=domino}', "");
    Expect(0, 127136, '\P{^Is_Blk=domino}', "");
    Expect(1, 127135, '\p{Is_Blk:   	-DOMINO}', "");
    Expect(0, 127135, '\p{^Is_Blk:   	-DOMINO}', "");
    Expect(0, 127135, '\P{Is_Blk:   	-DOMINO}', "");
    Expect(1, 127135, '\P{^Is_Blk:   	-DOMINO}', "");
    Expect(0, 127136, '\p{Is_Blk:   	-DOMINO}', "");
    Expect(1, 127136, '\p{^Is_Blk:   	-DOMINO}', "");
    Expect(1, 127136, '\P{Is_Blk:   	-DOMINO}', "");
    Expect(0, 127136, '\P{^Is_Blk:   	-DOMINO}', "");
    Error('\p{Block= 	Duployan/a/}');
    Error('\P{Block= 	Duployan/a/}');
    Expect(1, 113823, '\p{Block=:\ADuployan\z:}', "");;
    Expect(0, 113824, '\p{Block=:\ADuployan\z:}', "");;
    Expect(1, 113823, '\p{Block=duployan}', "");
    Expect(0, 113823, '\p{^Block=duployan}', "");
    Expect(0, 113823, '\P{Block=duployan}', "");
    Expect(1, 113823, '\P{^Block=duployan}', "");
    Expect(0, 113824, '\p{Block=duployan}', "");
    Expect(1, 113824, '\p{^Block=duployan}', "");
    Expect(1, 113824, '\P{Block=duployan}', "");
    Expect(0, 113824, '\P{^Block=duployan}', "");
    Expect(1, 113823, '\p{Block=:\Aduployan\z:}', "");;
    Expect(0, 113824, '\p{Block=:\Aduployan\z:}', "");;
    Expect(1, 113823, '\p{Block= Duployan}', "");
    Expect(0, 113823, '\p{^Block= Duployan}', "");
    Expect(0, 113823, '\P{Block= Duployan}', "");
    Expect(1, 113823, '\P{^Block= Duployan}', "");
    Expect(0, 113824, '\p{Block= Duployan}', "");
    Expect(1, 113824, '\p{^Block= Duployan}', "");
    Expect(1, 113824, '\P{Block= Duployan}', "");
    Expect(0, 113824, '\P{^Block= Duployan}', "");
    Error('\p{Blk=/a/duployan}');
    Error('\P{Blk=/a/duployan}');
    Expect(1, 113823, '\p{Blk=:\ADuployan\z:}', "");;
    Expect(0, 113824, '\p{Blk=:\ADuployan\z:}', "");;
    Expect(1, 113823, '\p{Blk=duployan}', "");
    Expect(0, 113823, '\p{^Blk=duployan}', "");
    Expect(0, 113823, '\P{Blk=duployan}', "");
    Expect(1, 113823, '\P{^Blk=duployan}', "");
    Expect(0, 113824, '\p{Blk=duployan}', "");
    Expect(1, 113824, '\p{^Blk=duployan}', "");
    Expect(1, 113824, '\P{Blk=duployan}', "");
    Expect(0, 113824, '\P{^Blk=duployan}', "");
    Expect(1, 113823, '\p{Blk=:\Aduployan\z:}', "");;
    Expect(0, 113824, '\p{Blk=:\Aduployan\z:}', "");;
    Expect(1, 113823, '\p{Blk=	duployan}', "");
    Expect(0, 113823, '\p{^Blk=	duployan}', "");
    Expect(0, 113823, '\P{Blk=	duployan}', "");
    Expect(1, 113823, '\P{^Blk=	duployan}', "");
    Expect(0, 113824, '\p{Blk=	duployan}', "");
    Expect(1, 113824, '\p{^Blk=	duployan}', "");
    Expect(1, 113824, '\P{Blk=	duployan}', "");
    Expect(0, 113824, '\P{^Blk=	duployan}', "");
    Error('\p{Is_Block:	:= 	DUPLOYAN}');
    Error('\P{Is_Block:	:= 	DUPLOYAN}');
    Expect(1, 113823, '\p{Is_Block=duployan}', "");
    Expect(0, 113823, '\p{^Is_Block=duployan}', "");
    Expect(0, 113823, '\P{Is_Block=duployan}', "");
    Expect(1, 113823, '\P{^Is_Block=duployan}', "");
    Expect(0, 113824, '\p{Is_Block=duployan}', "");
    Expect(1, 113824, '\p{^Is_Block=duployan}', "");
    Expect(1, 113824, '\P{Is_Block=duployan}', "");
    Expect(0, 113824, '\P{^Is_Block=duployan}', "");
    Expect(1, 113823, '\p{Is_Block=	Duployan}', "");
    Expect(0, 113823, '\p{^Is_Block=	Duployan}', "");
    Expect(0, 113823, '\P{Is_Block=	Duployan}', "");
    Expect(1, 113823, '\P{^Is_Block=	Duployan}', "");
    Expect(0, 113824, '\p{Is_Block=	Duployan}', "");
    Expect(1, 113824, '\p{^Is_Block=	Duployan}', "");
    Expect(1, 113824, '\P{Is_Block=	Duployan}', "");
    Expect(0, 113824, '\P{^Is_Block=	Duployan}', "");
    Error('\p{Is_Blk=:=	Duployan}');
    Error('\P{Is_Blk=:=	Duployan}');
    Expect(1, 113823, '\p{Is_Blk=duployan}', "");
    Expect(0, 113823, '\p{^Is_Blk=duployan}', "");
    Expect(0, 113823, '\P{Is_Blk=duployan}', "");
    Expect(1, 113823, '\P{^Is_Blk=duployan}', "");
    Expect(0, 113824, '\p{Is_Blk=duployan}', "");
    Expect(1, 113824, '\p{^Is_Blk=duployan}', "");
    Expect(1, 113824, '\P{Is_Blk=duployan}', "");
    Expect(0, 113824, '\P{^Is_Blk=duployan}', "");
    Expect(1, 113823, '\p{Is_Blk=	 Duployan}', "");
    Expect(0, 113823, '\p{^Is_Blk=	 Duployan}', "");
    Expect(0, 113823, '\P{Is_Blk=	 Duployan}', "");
    Expect(1, 113823, '\P{^Is_Blk=	 Duployan}', "");
    Expect(0, 113824, '\p{Is_Blk=	 Duployan}', "");
    Expect(1, 113824, '\p{^Is_Blk=	 Duployan}', "");
    Expect(1, 113824, '\P{Is_Blk=	 Duployan}', "");
    Expect(0, 113824, '\P{^Is_Blk=	 Duployan}', "");
    Error('\p{Block=_Early_dynastic_CUNEIFORM:=}');
    Error('\P{Block=_Early_dynastic_CUNEIFORM:=}');
    Expect(1, 75087, '\p{Block=:\AEarly_Dynastic_Cuneiform\z:}', "");;
    Expect(0, 75088, '\p{Block=:\AEarly_Dynastic_Cuneiform\z:}', "");;
    Expect(1, 75087, '\p{Block=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^Block=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{Block=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^Block=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{Block=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^Block=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{Block=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^Block=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{Block=:\Aearlydynasticcuneiform\z:}', "");;
    Expect(0, 75088, '\p{Block=:\Aearlydynasticcuneiform\z:}', "");;
    Expect(1, 75087, '\p{Block= 	early_Dynastic_Cuneiform}', "");
    Expect(0, 75087, '\p{^Block= 	early_Dynastic_Cuneiform}', "");
    Expect(0, 75087, '\P{Block= 	early_Dynastic_Cuneiform}', "");
    Expect(1, 75087, '\P{^Block= 	early_Dynastic_Cuneiform}', "");
    Expect(0, 75088, '\p{Block= 	early_Dynastic_Cuneiform}', "");
    Expect(1, 75088, '\p{^Block= 	early_Dynastic_Cuneiform}', "");
    Expect(1, 75088, '\P{Block= 	early_Dynastic_Cuneiform}', "");
    Expect(0, 75088, '\P{^Block= 	early_Dynastic_Cuneiform}', "");
    Error('\p{Blk=_:=early_Dynastic_cuneiform}');
    Error('\P{Blk=_:=early_Dynastic_cuneiform}');
    Expect(1, 75087, '\p{Blk=:\AEarly_Dynastic_Cuneiform\z:}', "");;
    Expect(0, 75088, '\p{Blk=:\AEarly_Dynastic_Cuneiform\z:}', "");;
    Expect(1, 75087, '\p{Blk=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^Blk=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{Blk=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^Blk=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{Blk=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^Blk=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{Blk=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^Blk=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{Blk=:\Aearlydynasticcuneiform\z:}', "");;
    Expect(0, 75088, '\p{Blk=:\Aearlydynasticcuneiform\z:}', "");;
    Expect(1, 75087, '\p{Blk=--Early_Dynastic_Cuneiform}', "");
    Expect(0, 75087, '\p{^Blk=--Early_Dynastic_Cuneiform}', "");
    Expect(0, 75087, '\P{Blk=--Early_Dynastic_Cuneiform}', "");
    Expect(1, 75087, '\P{^Blk=--Early_Dynastic_Cuneiform}', "");
    Expect(0, 75088, '\p{Blk=--Early_Dynastic_Cuneiform}', "");
    Expect(1, 75088, '\p{^Blk=--Early_Dynastic_Cuneiform}', "");
    Expect(1, 75088, '\P{Blk=--Early_Dynastic_Cuneiform}', "");
    Expect(0, 75088, '\P{^Blk=--Early_Dynastic_Cuneiform}', "");
    Error('\p{Is_Block= /a/EARLY_Dynastic_Cuneiform}');
    Error('\P{Is_Block= /a/EARLY_Dynastic_Cuneiform}');
    Expect(1, 75087, '\p{Is_Block=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^Is_Block=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{Is_Block=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^Is_Block=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{Is_Block=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^Is_Block=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{Is_Block=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^Is_Block=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{Is_Block= -Early_dynastic_Cuneiform}', "");
    Expect(0, 75087, '\p{^Is_Block= -Early_dynastic_Cuneiform}', "");
    Expect(0, 75087, '\P{Is_Block= -Early_dynastic_Cuneiform}', "");
    Expect(1, 75087, '\P{^Is_Block= -Early_dynastic_Cuneiform}', "");
    Expect(0, 75088, '\p{Is_Block= -Early_dynastic_Cuneiform}', "");
    Expect(1, 75088, '\p{^Is_Block= -Early_dynastic_Cuneiform}', "");
    Expect(1, 75088, '\P{Is_Block= -Early_dynastic_Cuneiform}', "");
    Expect(0, 75088, '\P{^Is_Block= -Early_dynastic_Cuneiform}', "");
    Error('\p{Is_Blk=/a/-Early_Dynastic_CUNEIFORM}');
    Error('\P{Is_Blk=/a/-Early_Dynastic_CUNEIFORM}');
    Expect(1, 75087, '\p{Is_Blk=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^Is_Blk=earlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{Is_Blk=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^Is_Blk=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{Is_Blk=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^Is_Blk=earlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{Is_Blk=earlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^Is_Blk=earlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{Is_Blk:		early_Dynastic_CUNEIFORM}', "");
    Expect(0, 75087, '\p{^Is_Blk:		early_Dynastic_CUNEIFORM}', "");
    Expect(0, 75087, '\P{Is_Blk:		early_Dynastic_CUNEIFORM}', "");
    Expect(1, 75087, '\P{^Is_Blk:		early_Dynastic_CUNEIFORM}', "");
    Expect(0, 75088, '\p{Is_Blk:		early_Dynastic_CUNEIFORM}', "");
    Expect(1, 75088, '\p{^Is_Blk:		early_Dynastic_CUNEIFORM}', "");
    Expect(1, 75088, '\P{Is_Blk:		early_Dynastic_CUNEIFORM}', "");
    Expect(0, 75088, '\P{^Is_Blk:		early_Dynastic_CUNEIFORM}', "");
    Error('\p{Block=/a/-Egyptian_Hieroglyph_Format_CONTROLS}');
    Error('\P{Block=/a/-Egyptian_Hieroglyph_Format_CONTROLS}');
    Expect(1, 78911, '\p{Block=:\AEgyptian_Hieroglyph_Format_Controls\z:}', "");;
    Expect(0, 78912, '\p{Block=:\AEgyptian_Hieroglyph_Format_Controls\z:}', "");;
    Expect(1, 78911, '\p{Block=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\p{^Block=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\P{Block=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\P{^Block=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\p{Block=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\p{^Block=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\P{Block=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\P{^Block=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\p{Block=:\Aegyptianhieroglyphformatcontrols\z:}', "");;
    Expect(0, 78912, '\p{Block=:\Aegyptianhieroglyphformatcontrols\z:}', "");;
    Expect(1, 78911, '\p{Block=--Egyptian_Hieroglyph_FORMAT_Controls}', "");
    Expect(0, 78911, '\p{^Block=--Egyptian_Hieroglyph_FORMAT_Controls}', "");
    Expect(0, 78911, '\P{Block=--Egyptian_Hieroglyph_FORMAT_Controls}', "");
    Expect(1, 78911, '\P{^Block=--Egyptian_Hieroglyph_FORMAT_Controls}', "");
    Expect(0, 78912, '\p{Block=--Egyptian_Hieroglyph_FORMAT_Controls}', "");
    Expect(1, 78912, '\p{^Block=--Egyptian_Hieroglyph_FORMAT_Controls}', "");
    Expect(1, 78912, '\P{Block=--Egyptian_Hieroglyph_FORMAT_Controls}', "");
    Expect(0, 78912, '\P{^Block=--Egyptian_Hieroglyph_FORMAT_Controls}', "");
    Error('\p{Blk=/a/--Egyptian_HIEROGLYPH_FORMAT_controls}');
    Error('\P{Blk=/a/--Egyptian_HIEROGLYPH_FORMAT_controls}');
    Expect(1, 78911, '\p{Blk=:\AEgyptian_Hieroglyph_Format_Controls\z:}', "");;
    Expect(0, 78912, '\p{Blk=:\AEgyptian_Hieroglyph_Format_Controls\z:}', "");;
    Expect(1, 78911, '\p{Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\p{^Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\P{Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\P{^Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\p{Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\p{^Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\P{Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\P{^Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\p{Blk=:\Aegyptianhieroglyphformatcontrols\z:}', "");;
    Expect(0, 78912, '\p{Blk=:\Aegyptianhieroglyphformatcontrols\z:}', "");;
    Expect(1, 78911, '\p{Blk=Egyptian_hieroglyph_format_Controls}', "");
    Expect(0, 78911, '\p{^Blk=Egyptian_hieroglyph_format_Controls}', "");
    Expect(0, 78911, '\P{Blk=Egyptian_hieroglyph_format_Controls}', "");
    Expect(1, 78911, '\P{^Blk=Egyptian_hieroglyph_format_Controls}', "");
    Expect(0, 78912, '\p{Blk=Egyptian_hieroglyph_format_Controls}', "");
    Expect(1, 78912, '\p{^Blk=Egyptian_hieroglyph_format_Controls}', "");
    Expect(1, 78912, '\P{Blk=Egyptian_hieroglyph_format_Controls}', "");
    Expect(0, 78912, '\P{^Blk=Egyptian_hieroglyph_format_Controls}', "");
    Error('\p{Is_Block=_	egyptian_Hieroglyph_Format_Controls:=}');
    Error('\P{Is_Block=_	egyptian_Hieroglyph_Format_Controls:=}');
    Expect(1, 78911, '\p{Is_Block=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\p{^Is_Block=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\P{Is_Block=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\P{^Is_Block=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\p{Is_Block=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\p{^Is_Block=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\P{Is_Block=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\P{^Is_Block=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\p{Is_Block:  	EGYPTIAN_Hieroglyph_Format_CONTROLS}', "");
    Expect(0, 78911, '\p{^Is_Block:  	EGYPTIAN_Hieroglyph_Format_CONTROLS}', "");
    Expect(0, 78911, '\P{Is_Block:  	EGYPTIAN_Hieroglyph_Format_CONTROLS}', "");
    Expect(1, 78911, '\P{^Is_Block:  	EGYPTIAN_Hieroglyph_Format_CONTROLS}', "");
    Expect(0, 78912, '\p{Is_Block:  	EGYPTIAN_Hieroglyph_Format_CONTROLS}', "");
    Expect(1, 78912, '\p{^Is_Block:  	EGYPTIAN_Hieroglyph_Format_CONTROLS}', "");
    Expect(1, 78912, '\P{Is_Block:  	EGYPTIAN_Hieroglyph_Format_CONTROLS}', "");
    Expect(0, 78912, '\P{^Is_Block:  	EGYPTIAN_Hieroglyph_Format_CONTROLS}', "");
    Error('\p{Is_Blk=_:=EGYPTIAN_Hieroglyph_Format_Controls}');
    Error('\P{Is_Blk=_:=EGYPTIAN_Hieroglyph_Format_Controls}');
    Expect(1, 78911, '\p{Is_Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\p{^Is_Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\P{Is_Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\P{^Is_Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\p{Is_Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\p{^Is_Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\P{Is_Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\P{^Is_Blk=egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\p{Is_Blk= egyptian_Hieroglyph_format_CONTROLS}', "");
    Expect(0, 78911, '\p{^Is_Blk= egyptian_Hieroglyph_format_CONTROLS}', "");
    Expect(0, 78911, '\P{Is_Blk= egyptian_Hieroglyph_format_CONTROLS}', "");
    Expect(1, 78911, '\P{^Is_Blk= egyptian_Hieroglyph_format_CONTROLS}', "");
    Expect(0, 78912, '\p{Is_Blk= egyptian_Hieroglyph_format_CONTROLS}', "");
    Expect(1, 78912, '\p{^Is_Blk= egyptian_Hieroglyph_format_CONTROLS}', "");
    Expect(1, 78912, '\P{Is_Blk= egyptian_Hieroglyph_format_CONTROLS}', "");
    Expect(0, 78912, '\P{^Is_Blk= egyptian_Hieroglyph_format_CONTROLS}', "");
    Error('\p{Block=-/a/Egyptian_HIEROGLYPHS}');
    Error('\P{Block=-/a/Egyptian_HIEROGLYPHS}');
    Expect(1, 78895, '\p{Block=:\AEgyptian_Hieroglyphs\z:}', "");;
    Expect(0, 78896, '\p{Block=:\AEgyptian_Hieroglyphs\z:}', "");;
    Expect(1, 78895, '\p{Block=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\p{^Block=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\P{Block=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\P{^Block=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\p{Block=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\p{^Block=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\P{Block=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\P{^Block=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\p{Block=:\Aegyptianhieroglyphs\z:}', "");;
    Expect(0, 78896, '\p{Block=:\Aegyptianhieroglyphs\z:}', "");;
    Expect(1, 78895, '\p{Block=-	egyptian_HIEROGLYPHS}', "");
    Expect(0, 78895, '\p{^Block=-	egyptian_HIEROGLYPHS}', "");
    Expect(0, 78895, '\P{Block=-	egyptian_HIEROGLYPHS}', "");
    Expect(1, 78895, '\P{^Block=-	egyptian_HIEROGLYPHS}', "");
    Expect(0, 78896, '\p{Block=-	egyptian_HIEROGLYPHS}', "");
    Expect(1, 78896, '\p{^Block=-	egyptian_HIEROGLYPHS}', "");
    Expect(1, 78896, '\P{Block=-	egyptian_HIEROGLYPHS}', "");
    Expect(0, 78896, '\P{^Block=-	egyptian_HIEROGLYPHS}', "");
    Error('\p{Blk=_/a/Egyptian_hieroglyphs}');
    Error('\P{Blk=_/a/Egyptian_hieroglyphs}');
    Expect(1, 78895, '\p{Blk=:\AEgyptian_Hieroglyphs\z:}', "");;
    Expect(0, 78896, '\p{Blk=:\AEgyptian_Hieroglyphs\z:}', "");;
    Expect(1, 78895, '\p{Blk=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\p{^Blk=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\P{Blk=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\P{^Blk=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\p{Blk=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\p{^Blk=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\P{Blk=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\P{^Blk=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\p{Blk=:\Aegyptianhieroglyphs\z:}', "");;
    Expect(0, 78896, '\p{Blk=:\Aegyptianhieroglyphs\z:}', "");;
    Expect(1, 78895, '\p{Blk= Egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\p{^Blk= Egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\P{Blk= Egyptian_Hieroglyphs}', "");
    Expect(1, 78895, '\P{^Blk= Egyptian_Hieroglyphs}', "");
    Expect(0, 78896, '\p{Blk= Egyptian_Hieroglyphs}', "");
    Expect(1, 78896, '\p{^Blk= Egyptian_Hieroglyphs}', "");
    Expect(1, 78896, '\P{Blk= Egyptian_Hieroglyphs}', "");
    Expect(0, 78896, '\P{^Blk= Egyptian_Hieroglyphs}', "");
    Error('\p{Is_Block=-/a/EGYPTIAN_hieroglyphs}');
    Error('\P{Is_Block=-/a/EGYPTIAN_hieroglyphs}');
    Expect(1, 78895, '\p{Is_Block=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\p{^Is_Block=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\P{Is_Block=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\P{^Is_Block=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\p{Is_Block=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\p{^Is_Block=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\P{Is_Block=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\P{^Is_Block=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\p{Is_Block=	Egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\p{^Is_Block=	Egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\P{Is_Block=	Egyptian_Hieroglyphs}', "");
    Expect(1, 78895, '\P{^Is_Block=	Egyptian_Hieroglyphs}', "");
    Expect(0, 78896, '\p{Is_Block=	Egyptian_Hieroglyphs}', "");
    Expect(1, 78896, '\p{^Is_Block=	Egyptian_Hieroglyphs}', "");
    Expect(1, 78896, '\P{Is_Block=	Egyptian_Hieroglyphs}', "");
    Expect(0, 78896, '\P{^Is_Block=	Egyptian_Hieroglyphs}', "");
    Error('\p{Is_Blk=:=_EGYPTIAN_Hieroglyphs}');
    Error('\P{Is_Blk=:=_EGYPTIAN_Hieroglyphs}');
    Expect(1, 78895, '\p{Is_Blk=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\p{^Is_Blk=egyptianhieroglyphs}', "");
    Expect(0, 78895, '\P{Is_Blk=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\P{^Is_Blk=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\p{Is_Blk=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\p{^Is_Blk=egyptianhieroglyphs}', "");
    Expect(1, 78896, '\P{Is_Blk=egyptianhieroglyphs}', "");
    Expect(0, 78896, '\P{^Is_Blk=egyptianhieroglyphs}', "");
    Expect(1, 78895, '\p{Is_Blk: EGYPTIAN_Hieroglyphs}', "");
    Expect(0, 78895, '\p{^Is_Blk: EGYPTIAN_Hieroglyphs}', "");
    Expect(0, 78895, '\P{Is_Blk: EGYPTIAN_Hieroglyphs}', "");
    Expect(1, 78895, '\P{^Is_Blk: EGYPTIAN_Hieroglyphs}', "");
    Expect(0, 78896, '\p{Is_Blk: EGYPTIAN_Hieroglyphs}', "");
    Expect(1, 78896, '\p{^Is_Blk: EGYPTIAN_Hieroglyphs}', "");
    Expect(1, 78896, '\P{Is_Blk: EGYPTIAN_Hieroglyphs}', "");
    Expect(0, 78896, '\P{^Is_Blk: EGYPTIAN_Hieroglyphs}', "");
    Error('\p{Block=:=  Elbasan}');
    Error('\P{Block=:=  Elbasan}');
    Expect(1, 66863, '\p{Block=:\AElbasan\z:}', "");;
    Expect(0, 66864, '\p{Block=:\AElbasan\z:}', "");;
    Expect(1, 66863, '\p{Block=elbasan}', "");
    Expect(0, 66863, '\p{^Block=elbasan}', "");
    Expect(0, 66863, '\P{Block=elbasan}', "");
    Expect(1, 66863, '\P{^Block=elbasan}', "");
    Expect(0, 66864, '\p{Block=elbasan}', "");
    Expect(1, 66864, '\p{^Block=elbasan}', "");
    Expect(1, 66864, '\P{Block=elbasan}', "");
    Expect(0, 66864, '\P{^Block=elbasan}', "");
    Expect(1, 66863, '\p{Block=:\Aelbasan\z:}', "");;
    Expect(0, 66864, '\p{Block=:\Aelbasan\z:}', "");;
    Expect(1, 66863, '\p{Block: _-ELBASAN}', "");
    Expect(0, 66863, '\p{^Block: _-ELBASAN}', "");
    Expect(0, 66863, '\P{Block: _-ELBASAN}', "");
    Expect(1, 66863, '\P{^Block: _-ELBASAN}', "");
    Expect(0, 66864, '\p{Block: _-ELBASAN}', "");
    Expect(1, 66864, '\p{^Block: _-ELBASAN}', "");
    Expect(1, 66864, '\P{Block: _-ELBASAN}', "");
    Expect(0, 66864, '\P{^Block: _-ELBASAN}', "");
    Error('\p{Blk=:=Elbasan}');
    Error('\P{Blk=:=Elbasan}');
    Expect(1, 66863, '\p{Blk=:\AElbasan\z:}', "");;
    Expect(0, 66864, '\p{Blk=:\AElbasan\z:}', "");;
    Expect(1, 66863, '\p{Blk=elbasan}', "");
    Expect(0, 66863, '\p{^Blk=elbasan}', "");
    Expect(0, 66863, '\P{Blk=elbasan}', "");
    Expect(1, 66863, '\P{^Blk=elbasan}', "");
    Expect(0, 66864, '\p{Blk=elbasan}', "");
    Expect(1, 66864, '\p{^Blk=elbasan}', "");
    Expect(1, 66864, '\P{Blk=elbasan}', "");
    Expect(0, 66864, '\P{^Blk=elbasan}', "");
    Expect(1, 66863, '\p{Blk=:\Aelbasan\z:}', "");;
    Expect(0, 66864, '\p{Blk=:\Aelbasan\z:}', "");;
    Expect(1, 66863, '\p{Blk=		Elbasan}', "");
    Expect(0, 66863, '\p{^Blk=		Elbasan}', "");
    Expect(0, 66863, '\P{Blk=		Elbasan}', "");
    Expect(1, 66863, '\P{^Blk=		Elbasan}', "");
    Expect(0, 66864, '\p{Blk=		Elbasan}', "");
    Expect(1, 66864, '\p{^Blk=		Elbasan}', "");
    Expect(1, 66864, '\P{Blk=		Elbasan}', "");
    Expect(0, 66864, '\P{^Blk=		Elbasan}', "");
    Error('\p{Is_Block= /a/Elbasan}');
    Error('\P{Is_Block= /a/Elbasan}');
    Expect(1, 66863, '\p{Is_Block=elbasan}', "");
    Expect(0, 66863, '\p{^Is_Block=elbasan}', "");
    Expect(0, 66863, '\P{Is_Block=elbasan}', "");
    Expect(1, 66863, '\P{^Is_Block=elbasan}', "");
    Expect(0, 66864, '\p{Is_Block=elbasan}', "");
    Expect(1, 66864, '\p{^Is_Block=elbasan}', "");
    Expect(1, 66864, '\P{Is_Block=elbasan}', "");
    Expect(0, 66864, '\P{^Is_Block=elbasan}', "");
    Expect(1, 66863, '\p{Is_Block=- Elbasan}', "");
    Expect(0, 66863, '\p{^Is_Block=- Elbasan}', "");
    Expect(0, 66863, '\P{Is_Block=- Elbasan}', "");
    Expect(1, 66863, '\P{^Is_Block=- Elbasan}', "");
    Expect(0, 66864, '\p{Is_Block=- Elbasan}', "");
    Expect(1, 66864, '\p{^Is_Block=- Elbasan}', "");
    Expect(1, 66864, '\P{Is_Block=- Elbasan}', "");
    Expect(0, 66864, '\P{^Is_Block=- Elbasan}', "");
    Error('\p{Is_Blk=	-ELBASAN:=}');
    Error('\P{Is_Blk=	-ELBASAN:=}');
    Expect(1, 66863, '\p{Is_Blk=elbasan}', "");
    Expect(0, 66863, '\p{^Is_Blk=elbasan}', "");
    Expect(0, 66863, '\P{Is_Blk=elbasan}', "");
    Expect(1, 66863, '\P{^Is_Blk=elbasan}', "");
    Expect(0, 66864, '\p{Is_Blk=elbasan}', "");
    Expect(1, 66864, '\p{^Is_Blk=elbasan}', "");
    Expect(1, 66864, '\P{Is_Blk=elbasan}', "");
    Expect(0, 66864, '\P{^Is_Blk=elbasan}', "");
    Expect(1, 66863, '\p{Is_Blk=_Elbasan}', "");
    Expect(0, 66863, '\p{^Is_Blk=_Elbasan}', "");
    Expect(0, 66863, '\P{Is_Blk=_Elbasan}', "");
    Expect(1, 66863, '\P{^Is_Blk=_Elbasan}', "");
    Expect(0, 66864, '\p{Is_Blk=_Elbasan}', "");
    Expect(1, 66864, '\p{^Is_Blk=_Elbasan}', "");
    Expect(1, 66864, '\P{Is_Blk=_Elbasan}', "");
    Expect(0, 66864, '\P{^Is_Blk=_Elbasan}', "");
    Error('\p{Block=_:=ELYMAIC}');
    Error('\P{Block=_:=ELYMAIC}');
    Expect(1, 69631, '\p{Block=:\AElymaic\z:}', "");;
    Expect(0, 69632, '\p{Block=:\AElymaic\z:}', "");;
    Expect(1, 69631, '\p{Block:elymaic}', "");
    Expect(0, 69631, '\p{^Block:elymaic}', "");
    Expect(0, 69631, '\P{Block:elymaic}', "");
    Expect(1, 69631, '\P{^Block:elymaic}', "");
    Expect(0, 69632, '\p{Block:elymaic}', "");
    Expect(1, 69632, '\p{^Block:elymaic}', "");
    Expect(1, 69632, '\P{Block:elymaic}', "");
    Expect(0, 69632, '\P{^Block:elymaic}', "");
    Expect(1, 69631, '\p{Block=:\Aelymaic\z:}', "");;
    Expect(0, 69632, '\p{Block=:\Aelymaic\z:}', "");;
    Expect(1, 69631, '\p{Block=		Elymaic}', "");
    Expect(0, 69631, '\p{^Block=		Elymaic}', "");
    Expect(0, 69631, '\P{Block=		Elymaic}', "");
    Expect(1, 69631, '\P{^Block=		Elymaic}', "");
    Expect(0, 69632, '\p{Block=		Elymaic}', "");
    Expect(1, 69632, '\p{^Block=		Elymaic}', "");
    Expect(1, 69632, '\P{Block=		Elymaic}', "");
    Expect(0, 69632, '\P{^Block=		Elymaic}', "");
    Error('\p{Blk=__ELYMAIC:=}');
    Error('\P{Blk=__ELYMAIC:=}');
    Expect(1, 69631, '\p{Blk=:\AElymaic\z:}', "");;
    Expect(0, 69632, '\p{Blk=:\AElymaic\z:}', "");;
    Expect(1, 69631, '\p{Blk=elymaic}', "");
    Expect(0, 69631, '\p{^Blk=elymaic}', "");
    Expect(0, 69631, '\P{Blk=elymaic}', "");
    Expect(1, 69631, '\P{^Blk=elymaic}', "");
    Expect(0, 69632, '\p{Blk=elymaic}', "");
    Expect(1, 69632, '\p{^Blk=elymaic}', "");
    Expect(1, 69632, '\P{Blk=elymaic}', "");
    Expect(0, 69632, '\P{^Blk=elymaic}', "");
    Expect(1, 69631, '\p{Blk=:\Aelymaic\z:}', "");;
    Expect(0, 69632, '\p{Blk=:\Aelymaic\z:}', "");;
    Expect(1, 69631, '\p{Blk= 	Elymaic}', "");
    Expect(0, 69631, '\p{^Blk= 	Elymaic}', "");
    Expect(0, 69631, '\P{Blk= 	Elymaic}', "");
    Expect(1, 69631, '\P{^Blk= 	Elymaic}', "");
    Expect(0, 69632, '\p{Blk= 	Elymaic}', "");
    Expect(1, 69632, '\p{^Blk= 	Elymaic}', "");
    Expect(1, 69632, '\P{Blk= 	Elymaic}', "");
    Expect(0, 69632, '\P{^Blk= 	Elymaic}', "");
    Error('\p{Is_Block= _ELYMAIC:=}');
    Error('\P{Is_Block= _ELYMAIC:=}');
    Expect(1, 69631, '\p{Is_Block=elymaic}', "");
    Expect(0, 69631, '\p{^Is_Block=elymaic}', "");
    Expect(0, 69631, '\P{Is_Block=elymaic}', "");
    Expect(1, 69631, '\P{^Is_Block=elymaic}', "");
    Expect(0, 69632, '\p{Is_Block=elymaic}', "");
    Expect(1, 69632, '\p{^Is_Block=elymaic}', "");
    Expect(1, 69632, '\P{Is_Block=elymaic}', "");
    Expect(0, 69632, '\P{^Is_Block=elymaic}', "");
    Expect(1, 69631, '\p{Is_Block=	_elymaic}', "");
    Expect(0, 69631, '\p{^Is_Block=	_elymaic}', "");
    Expect(0, 69631, '\P{Is_Block=	_elymaic}', "");
    Expect(1, 69631, '\P{^Is_Block=	_elymaic}', "");
    Expect(0, 69632, '\p{Is_Block=	_elymaic}', "");
    Expect(1, 69632, '\p{^Is_Block=	_elymaic}', "");
    Expect(1, 69632, '\P{Is_Block=	_elymaic}', "");
    Expect(0, 69632, '\P{^Is_Block=	_elymaic}', "");
    Error('\p{Is_Blk=/a/ELYMAIC}');
    Error('\P{Is_Blk=/a/ELYMAIC}');
    Expect(1, 69631, '\p{Is_Blk=elymaic}', "");
    Expect(0, 69631, '\p{^Is_Blk=elymaic}', "");
    Expect(0, 69631, '\P{Is_Blk=elymaic}', "");
    Expect(1, 69631, '\P{^Is_Blk=elymaic}', "");
    Expect(0, 69632, '\p{Is_Blk=elymaic}', "");
    Expect(1, 69632, '\p{^Is_Blk=elymaic}', "");
    Expect(1, 69632, '\P{Is_Blk=elymaic}', "");
    Expect(0, 69632, '\P{^Is_Blk=elymaic}', "");
    Expect(1, 69631, '\p{Is_Blk= -Elymaic}', "");
    Expect(0, 69631, '\p{^Is_Blk= -Elymaic}', "");
    Expect(0, 69631, '\P{Is_Blk= -Elymaic}', "");
    Expect(1, 69631, '\P{^Is_Blk= -Elymaic}', "");
    Expect(0, 69632, '\p{Is_Blk= -Elymaic}', "");
    Expect(1, 69632, '\p{^Is_Blk= -Elymaic}', "");
    Expect(1, 69632, '\P{Is_Blk= -Elymaic}', "");
    Expect(0, 69632, '\P{^Is_Blk= -Elymaic}', "");
    Error('\p{Block= 	Emoticons/a/}');
    Error('\P{Block= 	Emoticons/a/}');
    Expect(1, 128591, '\p{Block=:\AEmoticons\z:}', "");;
    Expect(0, 128592, '\p{Block=:\AEmoticons\z:}', "");;
    Expect(1, 128591, '\p{Block=emoticons}', "");
    Expect(0, 128591, '\p{^Block=emoticons}', "");
    Expect(0, 128591, '\P{Block=emoticons}', "");
    Expect(1, 128591, '\P{^Block=emoticons}', "");
    Expect(0, 128592, '\p{Block=emoticons}', "");
    Expect(1, 128592, '\p{^Block=emoticons}', "");
    Expect(1, 128592, '\P{Block=emoticons}', "");
    Expect(0, 128592, '\P{^Block=emoticons}', "");
    Expect(1, 128591, '\p{Block=:\Aemoticons\z:}', "");;
    Expect(0, 128592, '\p{Block=:\Aemoticons\z:}', "");;
    Expect(1, 128591, '\p{Block=	emoticons}', "");
    Expect(0, 128591, '\p{^Block=	emoticons}', "");
    Expect(0, 128591, '\P{Block=	emoticons}', "");
    Expect(1, 128591, '\P{^Block=	emoticons}', "");
    Expect(0, 128592, '\p{Block=	emoticons}', "");
    Expect(1, 128592, '\p{^Block=	emoticons}', "");
    Expect(1, 128592, '\P{Block=	emoticons}', "");
    Expect(0, 128592, '\P{^Block=	emoticons}', "");
    Error('\p{Blk=/a/-	Emoticons}');
    Error('\P{Blk=/a/-	Emoticons}');
    Expect(1, 128591, '\p{Blk=:\AEmoticons\z:}', "");;
    Expect(0, 128592, '\p{Blk=:\AEmoticons\z:}', "");;
    Expect(1, 128591, '\p{Blk=emoticons}', "");
    Expect(0, 128591, '\p{^Blk=emoticons}', "");
    Expect(0, 128591, '\P{Blk=emoticons}', "");
    Expect(1, 128591, '\P{^Blk=emoticons}', "");
    Expect(0, 128592, '\p{Blk=emoticons}', "");
    Expect(1, 128592, '\p{^Blk=emoticons}', "");
    Expect(1, 128592, '\P{Blk=emoticons}', "");
    Expect(0, 128592, '\P{^Blk=emoticons}', "");
    Expect(1, 128591, '\p{Blk=:\Aemoticons\z:}', "");;
    Expect(0, 128592, '\p{Blk=:\Aemoticons\z:}', "");;
    Expect(1, 128591, '\p{Blk=  emoticons}', "");
    Expect(0, 128591, '\p{^Blk=  emoticons}', "");
    Expect(0, 128591, '\P{Blk=  emoticons}', "");
    Expect(1, 128591, '\P{^Blk=  emoticons}', "");
    Expect(0, 128592, '\p{Blk=  emoticons}', "");
    Expect(1, 128592, '\p{^Blk=  emoticons}', "");
    Expect(1, 128592, '\P{Blk=  emoticons}', "");
    Expect(0, 128592, '\P{^Blk=  emoticons}', "");
    Error('\p{Is_Block: _Emoticons:=}');
    Error('\P{Is_Block: _Emoticons:=}');
    Expect(1, 128591, '\p{Is_Block=emoticons}', "");
    Expect(0, 128591, '\p{^Is_Block=emoticons}', "");
    Expect(0, 128591, '\P{Is_Block=emoticons}', "");
    Expect(1, 128591, '\P{^Is_Block=emoticons}', "");
    Expect(0, 128592, '\p{Is_Block=emoticons}', "");
    Expect(1, 128592, '\p{^Is_Block=emoticons}', "");
    Expect(1, 128592, '\P{Is_Block=emoticons}', "");
    Expect(0, 128592, '\P{^Is_Block=emoticons}', "");
    Expect(1, 128591, '\p{Is_Block: 		Emoticons}', "");
    Expect(0, 128591, '\p{^Is_Block: 		Emoticons}', "");
    Expect(0, 128591, '\P{Is_Block: 		Emoticons}', "");
    Expect(1, 128591, '\P{^Is_Block: 		Emoticons}', "");
    Expect(0, 128592, '\p{Is_Block: 		Emoticons}', "");
    Expect(1, 128592, '\p{^Is_Block: 		Emoticons}', "");
    Expect(1, 128592, '\P{Is_Block: 		Emoticons}', "");
    Expect(0, 128592, '\P{^Is_Block: 		Emoticons}', "");
    Error('\p{Is_Blk=/a/ 	emoticons}');
    Error('\P{Is_Blk=/a/ 	emoticons}');
    Expect(1, 128591, '\p{Is_Blk=emoticons}', "");
    Expect(0, 128591, '\p{^Is_Blk=emoticons}', "");
    Expect(0, 128591, '\P{Is_Blk=emoticons}', "");
    Expect(1, 128591, '\P{^Is_Blk=emoticons}', "");
    Expect(0, 128592, '\p{Is_Blk=emoticons}', "");
    Expect(1, 128592, '\p{^Is_Blk=emoticons}', "");
    Expect(1, 128592, '\P{Is_Blk=emoticons}', "");
    Expect(0, 128592, '\P{^Is_Blk=emoticons}', "");
    Expect(1, 128591, '\p{Is_Blk=		Emoticons}', "");
    Expect(0, 128591, '\p{^Is_Blk=		Emoticons}', "");
    Expect(0, 128591, '\P{Is_Blk=		Emoticons}', "");
    Expect(1, 128591, '\P{^Is_Blk=		Emoticons}', "");
    Expect(0, 128592, '\p{Is_Blk=		Emoticons}', "");
    Expect(1, 128592, '\p{^Is_Blk=		Emoticons}', "");
    Expect(1, 128592, '\P{Is_Blk=		Emoticons}', "");
    Expect(0, 128592, '\P{^Is_Blk=		Emoticons}', "");
    Error('\p{Block=:=		enclosed_ALPHANUMERICS}');
    Error('\P{Block=:=		enclosed_ALPHANUMERICS}');
    Expect(1, 9471, '\p{Block=:\AEnclosed_Alphanumerics\z:}', "");;
    Expect(0, 9472, '\p{Block=:\AEnclosed_Alphanumerics\z:}', "");;
    Expect(1, 9471, '\p{Block=enclosedalphanumerics}', "");
    Expect(0, 9471, '\p{^Block=enclosedalphanumerics}', "");
    Expect(0, 9471, '\P{Block=enclosedalphanumerics}', "");
    Expect(1, 9471, '\P{^Block=enclosedalphanumerics}', "");
    Expect(0, 9472, '\p{Block=enclosedalphanumerics}', "");
    Expect(1, 9472, '\p{^Block=enclosedalphanumerics}', "");
    Expect(1, 9472, '\P{Block=enclosedalphanumerics}', "");
    Expect(0, 9472, '\P{^Block=enclosedalphanumerics}', "");
    Expect(1, 9471, '\p{Block=:\Aenclosedalphanumerics\z:}', "");;
    Expect(0, 9472, '\p{Block=:\Aenclosedalphanumerics\z:}', "");;
    Expect(1, 9471, '\p{Block=	ENCLOSED_Alphanumerics}', "");
    Expect(0, 9471, '\p{^Block=	ENCLOSED_Alphanumerics}', "");
    Expect(0, 9471, '\P{Block=	ENCLOSED_Alphanumerics}', "");
    Expect(1, 9471, '\P{^Block=	ENCLOSED_Alphanumerics}', "");
    Expect(0, 9472, '\p{Block=	ENCLOSED_Alphanumerics}', "");
    Expect(1, 9472, '\p{^Block=	ENCLOSED_Alphanumerics}', "");
    Expect(1, 9472, '\P{Block=	ENCLOSED_Alphanumerics}', "");
    Expect(0, 9472, '\P{^Block=	ENCLOSED_Alphanumerics}', "");
    Error('\p{Blk=/a/ENCLOSED_ALPHANUM}');
    Error('\P{Blk=/a/ENCLOSED_ALPHANUM}');
    Expect(1, 9471, '\p{Blk=:\AEnclosed_Alphanum\z:}', "");;
    Expect(0, 9472, '\p{Blk=:\AEnclosed_Alphanum\z:}', "");;
    Expect(1, 9471, '\p{Blk=enclosedalphanum}', "");
    Expect(0, 9471, '\p{^Blk=enclosedalphanum}', "");
    Expect(0, 9471, '\P{Blk=enclosedalphanum}', "");
    Expect(1, 9471, '\P{^Blk=enclosedalphanum}', "");
    Expect(0, 9472, '\p{Blk=enclosedalphanum}', "");
    Expect(1, 9472, '\p{^Blk=enclosedalphanum}', "");
    Expect(1, 9472, '\P{Blk=enclosedalphanum}', "");
    Expect(0, 9472, '\P{^Blk=enclosedalphanum}', "");
    Expect(1, 9471, '\p{Blk=:\Aenclosedalphanum\z:}', "");;
    Expect(0, 9472, '\p{Blk=:\Aenclosedalphanum\z:}', "");;
    Expect(1, 9471, '\p{Blk=	Enclosed_Alphanum}', "");
    Expect(0, 9471, '\p{^Blk=	Enclosed_Alphanum}', "");
    Expect(0, 9471, '\P{Blk=	Enclosed_Alphanum}', "");
    Expect(1, 9471, '\P{^Blk=	Enclosed_Alphanum}', "");
    Expect(0, 9472, '\p{Blk=	Enclosed_Alphanum}', "");
    Expect(1, 9472, '\p{^Blk=	Enclosed_Alphanum}', "");
    Expect(1, 9472, '\P{Blk=	Enclosed_Alphanum}', "");
    Expect(0, 9472, '\P{^Blk=	Enclosed_Alphanum}', "");
    Error('\p{Is_Block= -Enclosed_Alphanumerics/a/}');
    Error('\P{Is_Block= -Enclosed_Alphanumerics/a/}');
    Expect(1, 9471, '\p{Is_Block=enclosedalphanumerics}', "");
    Expect(0, 9471, '\p{^Is_Block=enclosedalphanumerics}', "");
    Expect(0, 9471, '\P{Is_Block=enclosedalphanumerics}', "");
    Expect(1, 9471, '\P{^Is_Block=enclosedalphanumerics}', "");
    Expect(0, 9472, '\p{Is_Block=enclosedalphanumerics}', "");
    Expect(1, 9472, '\p{^Is_Block=enclosedalphanumerics}', "");
    Expect(1, 9472, '\P{Is_Block=enclosedalphanumerics}', "");
    Expect(0, 9472, '\P{^Is_Block=enclosedalphanumerics}', "");
    Expect(1, 9471, '\p{Is_Block:	- Enclosed_Alphanumerics}', "");
    Expect(0, 9471, '\p{^Is_Block:	- Enclosed_Alphanumerics}', "");
    Expect(0, 9471, '\P{Is_Block:	- Enclosed_Alphanumerics}', "");
    Expect(1, 9471, '\P{^Is_Block:	- Enclosed_Alphanumerics}', "");
    Expect(0, 9472, '\p{Is_Block:	- Enclosed_Alphanumerics}', "");
    Expect(1, 9472, '\p{^Is_Block:	- Enclosed_Alphanumerics}', "");
    Expect(1, 9472, '\P{Is_Block:	- Enclosed_Alphanumerics}', "");
    Expect(0, 9472, '\P{^Is_Block:	- Enclosed_Alphanumerics}', "");
    Error('\p{Is_Blk=--enclosed_Alphanum/a/}');
    Error('\P{Is_Blk=--enclosed_Alphanum/a/}');
    Expect(1, 9471, '\p{Is_Blk=enclosedalphanum}', "");
    Expect(0, 9471, '\p{^Is_Blk=enclosedalphanum}', "");
    Expect(0, 9471, '\P{Is_Blk=enclosedalphanum}', "");
    Expect(1, 9471, '\P{^Is_Blk=enclosedalphanum}', "");
    Expect(0, 9472, '\p{Is_Blk=enclosedalphanum}', "");
    Expect(1, 9472, '\p{^Is_Blk=enclosedalphanum}', "");
    Expect(1, 9472, '\P{Is_Blk=enclosedalphanum}', "");
    Expect(0, 9472, '\P{^Is_Blk=enclosedalphanum}', "");
    Expect(1, 9471, '\p{Is_Blk=	 ENCLOSED_Alphanum}', "");
    Expect(0, 9471, '\p{^Is_Blk=	 ENCLOSED_Alphanum}', "");
    Expect(0, 9471, '\P{Is_Blk=	 ENCLOSED_Alphanum}', "");
    Expect(1, 9471, '\P{^Is_Blk=	 ENCLOSED_Alphanum}', "");
    Expect(0, 9472, '\p{Is_Blk=	 ENCLOSED_Alphanum}', "");
    Expect(1, 9472, '\p{^Is_Blk=	 ENCLOSED_Alphanum}', "");
    Expect(1, 9472, '\P{Is_Blk=	 ENCLOSED_Alphanum}', "");
    Expect(0, 9472, '\P{^Is_Blk=	 ENCLOSED_Alphanum}', "");
    Error('\p{Block=-:=Enclosed_Alphanumeric_SUPPLEMENT}');
    Error('\P{Block=-:=Enclosed_Alphanumeric_SUPPLEMENT}');
    Expect(1, 127487, '\p{Block=:\AEnclosed_Alphanumeric_Supplement\z:}', "");;
    Expect(0, 127488, '\p{Block=:\AEnclosed_Alphanumeric_Supplement\z:}', "");;
    Expect(1, 127487, '\p{Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\p{^Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\P{Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\P{^Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\p{Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\p{^Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\P{Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\P{^Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\p{Block=:\Aenclosedalphanumericsupplement\z:}', "");;
    Expect(0, 127488, '\p{Block=:\Aenclosedalphanumericsupplement\z:}', "");;
    Expect(1, 127487, '\p{Block=-ENCLOSED_Alphanumeric_Supplement}', "");
    Expect(0, 127487, '\p{^Block=-ENCLOSED_Alphanumeric_Supplement}', "");
    Expect(0, 127487, '\P{Block=-ENCLOSED_Alphanumeric_Supplement}', "");
    Expect(1, 127487, '\P{^Block=-ENCLOSED_Alphanumeric_Supplement}', "");
    Expect(0, 127488, '\p{Block=-ENCLOSED_Alphanumeric_Supplement}', "");
    Expect(1, 127488, '\p{^Block=-ENCLOSED_Alphanumeric_Supplement}', "");
    Expect(1, 127488, '\P{Block=-ENCLOSED_Alphanumeric_Supplement}', "");
    Expect(0, 127488, '\P{^Block=-ENCLOSED_Alphanumeric_Supplement}', "");
    Error('\p{Blk: enclosed_ALPHANUM_SUP:=}');
    Error('\P{Blk: enclosed_ALPHANUM_SUP:=}');
    Expect(1, 127487, '\p{Blk=:\AEnclosed_Alphanum_Sup\z:}', "");;
    Expect(0, 127488, '\p{Blk=:\AEnclosed_Alphanum_Sup\z:}', "");;
    Expect(1, 127487, '\p{Blk=enclosedalphanumsup}', "");
    Expect(0, 127487, '\p{^Blk=enclosedalphanumsup}', "");
    Expect(0, 127487, '\P{Blk=enclosedalphanumsup}', "");
    Expect(1, 127487, '\P{^Blk=enclosedalphanumsup}', "");
    Expect(0, 127488, '\p{Blk=enclosedalphanumsup}', "");
    Expect(1, 127488, '\p{^Blk=enclosedalphanumsup}', "");
    Expect(1, 127488, '\P{Blk=enclosedalphanumsup}', "");
    Expect(0, 127488, '\P{^Blk=enclosedalphanumsup}', "");
    Expect(1, 127487, '\p{Blk=:\Aenclosedalphanumsup\z:}', "");;
    Expect(0, 127488, '\p{Blk=:\Aenclosedalphanumsup\z:}', "");;
    Expect(1, 127487, '\p{Blk=_ Enclosed_Alphanum_Sup}', "");
    Expect(0, 127487, '\p{^Blk=_ Enclosed_Alphanum_Sup}', "");
    Expect(0, 127487, '\P{Blk=_ Enclosed_Alphanum_Sup}', "");
    Expect(1, 127487, '\P{^Blk=_ Enclosed_Alphanum_Sup}', "");
    Expect(0, 127488, '\p{Blk=_ Enclosed_Alphanum_Sup}', "");
    Expect(1, 127488, '\p{^Blk=_ Enclosed_Alphanum_Sup}', "");
    Expect(1, 127488, '\P{Blk=_ Enclosed_Alphanum_Sup}', "");
    Expect(0, 127488, '\P{^Blk=_ Enclosed_Alphanum_Sup}', "");
    Error('\p{Is_Block=_	Enclosed_alphanumeric_supplement/a/}');
    Error('\P{Is_Block=_	Enclosed_alphanumeric_supplement/a/}');
    Expect(1, 127487, '\p{Is_Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\p{^Is_Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\P{Is_Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\P{^Is_Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\p{Is_Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\p{^Is_Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\P{Is_Block=enclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\P{^Is_Block=enclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\p{Is_Block=- enclosed_ALPHANUMERIC_Supplement}', "");
    Expect(0, 127487, '\p{^Is_Block=- enclosed_ALPHANUMERIC_Supplement}', "");
    Expect(0, 127487, '\P{Is_Block=- enclosed_ALPHANUMERIC_Supplement}', "");
    Expect(1, 127487, '\P{^Is_Block=- enclosed_ALPHANUMERIC_Supplement}', "");
    Expect(0, 127488, '\p{Is_Block=- enclosed_ALPHANUMERIC_Supplement}', "");
    Expect(1, 127488, '\p{^Is_Block=- enclosed_ALPHANUMERIC_Supplement}', "");
    Expect(1, 127488, '\P{Is_Block=- enclosed_ALPHANUMERIC_Supplement}', "");
    Expect(0, 127488, '\P{^Is_Block=- enclosed_ALPHANUMERIC_Supplement}', "");
    Error('\p{Is_Blk=	/a/Enclosed_alphanum_sup}');
    Error('\P{Is_Blk=	/a/Enclosed_alphanum_sup}');
    Expect(1, 127487, '\p{Is_Blk=enclosedalphanumsup}', "");
    Expect(0, 127487, '\p{^Is_Blk=enclosedalphanumsup}', "");
    Expect(0, 127487, '\P{Is_Blk=enclosedalphanumsup}', "");
    Expect(1, 127487, '\P{^Is_Blk=enclosedalphanumsup}', "");
    Expect(0, 127488, '\p{Is_Blk=enclosedalphanumsup}', "");
    Expect(1, 127488, '\p{^Is_Blk=enclosedalphanumsup}', "");
    Expect(1, 127488, '\P{Is_Blk=enclosedalphanumsup}', "");
    Expect(0, 127488, '\P{^Is_Blk=enclosedalphanumsup}', "");
    Expect(1, 127487, '\p{Is_Blk=	ENCLOSED_Alphanum_sup}', "");
    Expect(0, 127487, '\p{^Is_Blk=	ENCLOSED_Alphanum_sup}', "");
    Expect(0, 127487, '\P{Is_Blk=	ENCLOSED_Alphanum_sup}', "");
    Expect(1, 127487, '\P{^Is_Blk=	ENCLOSED_Alphanum_sup}', "");
    Expect(0, 127488, '\p{Is_Blk=	ENCLOSED_Alphanum_sup}', "");
    Expect(1, 127488, '\p{^Is_Blk=	ENCLOSED_Alphanum_sup}', "");
    Expect(1, 127488, '\P{Is_Blk=	ENCLOSED_Alphanum_sup}', "");
    Expect(0, 127488, '\P{^Is_Blk=	ENCLOSED_Alphanum_sup}', "");
    Error('\p{Block:	:=Enclosed_CJK_Letters_And_months}');
    Error('\P{Block:	:=Enclosed_CJK_Letters_And_months}');
    Expect(1, 13055, '\p{Block=:\AEnclosed_CJK_Letters_And_Months\z:}', "");;
    Expect(0, 13056, '\p{Block=:\AEnclosed_CJK_Letters_And_Months\z:}', "");;
    Expect(1, 13055, '\p{Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\p{^Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\P{Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\P{^Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\p{Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\p{^Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\P{Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\P{^Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\p{Block=:\Aenclosedcjklettersandmonths\z:}', "");;
    Expect(0, 13056, '\p{Block=:\Aenclosedcjklettersandmonths\z:}', "");;
    Expect(1, 13055, '\p{Block= _ENCLOSED_CJK_LETTERS_And_Months}', "");
    Expect(0, 13055, '\p{^Block= _ENCLOSED_CJK_LETTERS_And_Months}', "");
    Expect(0, 13055, '\P{Block= _ENCLOSED_CJK_LETTERS_And_Months}', "");
    Expect(1, 13055, '\P{^Block= _ENCLOSED_CJK_LETTERS_And_Months}', "");
    Expect(0, 13056, '\p{Block= _ENCLOSED_CJK_LETTERS_And_Months}', "");
    Expect(1, 13056, '\p{^Block= _ENCLOSED_CJK_LETTERS_And_Months}', "");
    Expect(1, 13056, '\P{Block= _ENCLOSED_CJK_LETTERS_And_Months}', "");
    Expect(0, 13056, '\P{^Block= _ENCLOSED_CJK_LETTERS_And_Months}', "");
    Error('\p{Blk: /a/_	Enclosed_CJK}');
    Error('\P{Blk: /a/_	Enclosed_CJK}');
    Expect(1, 13055, '\p{Blk=:\AEnclosed_CJK\z:}', "");;
    Expect(0, 13056, '\p{Blk=:\AEnclosed_CJK\z:}', "");;
    Expect(1, 13055, '\p{Blk=enclosedcjk}', "");
    Expect(0, 13055, '\p{^Blk=enclosedcjk}', "");
    Expect(0, 13055, '\P{Blk=enclosedcjk}', "");
    Expect(1, 13055, '\P{^Blk=enclosedcjk}', "");
    Expect(0, 13056, '\p{Blk=enclosedcjk}', "");
    Expect(1, 13056, '\p{^Blk=enclosedcjk}', "");
    Expect(1, 13056, '\P{Blk=enclosedcjk}', "");
    Expect(0, 13056, '\P{^Blk=enclosedcjk}', "");
    Expect(1, 13055, '\p{Blk=:\Aenclosedcjk\z:}', "");;
    Expect(0, 13056, '\p{Blk=:\Aenclosedcjk\z:}', "");;
    Expect(1, 13055, '\p{Blk=	enclosed_CJK}', "");
    Expect(0, 13055, '\p{^Blk=	enclosed_CJK}', "");
    Expect(0, 13055, '\P{Blk=	enclosed_CJK}', "");
    Expect(1, 13055, '\P{^Blk=	enclosed_CJK}', "");
    Expect(0, 13056, '\p{Blk=	enclosed_CJK}', "");
    Expect(1, 13056, '\p{^Blk=	enclosed_CJK}', "");
    Expect(1, 13056, '\P{Blk=	enclosed_CJK}', "");
    Expect(0, 13056, '\P{^Blk=	enclosed_CJK}', "");
    Error('\p{Is_Block=	_Enclosed_CJK_Letters_and_MONTHS:=}');
    Error('\P{Is_Block=	_Enclosed_CJK_Letters_and_MONTHS:=}');
    Expect(1, 13055, '\p{Is_Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\p{^Is_Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\P{Is_Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\P{^Is_Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\p{Is_Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\p{^Is_Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\P{Is_Block=enclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\P{^Is_Block=enclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\p{Is_Block=_	enclosed_CJK_letters_and_Months}', "");
    Expect(0, 13055, '\p{^Is_Block=_	enclosed_CJK_letters_and_Months}', "");
    Expect(0, 13055, '\P{Is_Block=_	enclosed_CJK_letters_and_Months}', "");
    Expect(1, 13055, '\P{^Is_Block=_	enclosed_CJK_letters_and_Months}', "");
    Expect(0, 13056, '\p{Is_Block=_	enclosed_CJK_letters_and_Months}', "");
    Expect(1, 13056, '\p{^Is_Block=_	enclosed_CJK_letters_and_Months}', "");
    Expect(1, 13056, '\P{Is_Block=_	enclosed_CJK_letters_and_Months}', "");
    Expect(0, 13056, '\P{^Is_Block=_	enclosed_CJK_letters_and_Months}', "");
    Error('\p{Is_Blk:	_:=Enclosed_CJK}');
    Error('\P{Is_Blk:	_:=Enclosed_CJK}');
    Expect(1, 13055, '\p{Is_Blk=enclosedcjk}', "");
    Expect(0, 13055, '\p{^Is_Blk=enclosedcjk}', "");
    Expect(0, 13055, '\P{Is_Blk=enclosedcjk}', "");
    Expect(1, 13055, '\P{^Is_Blk=enclosedcjk}', "");
    Expect(0, 13056, '\p{Is_Blk=enclosedcjk}', "");
    Expect(1, 13056, '\p{^Is_Blk=enclosedcjk}', "");
    Expect(1, 13056, '\P{Is_Blk=enclosedcjk}', "");
    Expect(0, 13056, '\P{^Is_Blk=enclosedcjk}', "");
    Expect(1, 13055, '\p{Is_Blk= ENCLOSED_CJK}', "");
    Expect(0, 13055, '\p{^Is_Blk= ENCLOSED_CJK}', "");
    Expect(0, 13055, '\P{Is_Blk= ENCLOSED_CJK}', "");
    Expect(1, 13055, '\P{^Is_Blk= ENCLOSED_CJK}', "");
    Expect(0, 13056, '\p{Is_Blk= ENCLOSED_CJK}', "");
    Expect(1, 13056, '\p{^Is_Blk= ENCLOSED_CJK}', "");
    Expect(1, 13056, '\P{Is_Blk= ENCLOSED_CJK}', "");
    Expect(0, 13056, '\P{^Is_Blk= ENCLOSED_CJK}', "");
    Error('\p{Block=:=-_enclosed_IDEOGRAPHIC_Supplement}');
    Error('\P{Block=:=-_enclosed_IDEOGRAPHIC_Supplement}');
    Expect(1, 127743, '\p{Block=:\AEnclosed_Ideographic_Supplement\z:}', "");;
    Expect(0, 127744, '\p{Block=:\AEnclosed_Ideographic_Supplement\z:}', "");;
    Expect(1, 127743, '\p{Block=enclosedideographicsupplement}', "");
    Expect(0, 127743, '\p{^Block=enclosedideographicsupplement}', "");
    Expect(0, 127743, '\P{Block=enclosedideographicsupplement}', "");
    Expect(1, 127743, '\P{^Block=enclosedideographicsupplement}', "");
    Expect(0, 127744, '\p{Block=enclosedideographicsupplement}', "");
    Expect(1, 127744, '\p{^Block=enclosedideographicsupplement}', "");
    Expect(1, 127744, '\P{Block=enclosedideographicsupplement}', "");
    Expect(0, 127744, '\P{^Block=enclosedideographicsupplement}', "");
    Expect(1, 127743, '\p{Block=:\Aenclosedideographicsupplement\z:}', "");;
    Expect(0, 127744, '\p{Block=:\Aenclosedideographicsupplement\z:}', "");;
    Expect(1, 127743, '\p{Block=	_Enclosed_IDEOGRAPHIC_supplement}', "");
    Expect(0, 127743, '\p{^Block=	_Enclosed_IDEOGRAPHIC_supplement}', "");
    Expect(0, 127743, '\P{Block=	_Enclosed_IDEOGRAPHIC_supplement}', "");
    Expect(1, 127743, '\P{^Block=	_Enclosed_IDEOGRAPHIC_supplement}', "");
    Expect(0, 127744, '\p{Block=	_Enclosed_IDEOGRAPHIC_supplement}', "");
    Expect(1, 127744, '\p{^Block=	_Enclosed_IDEOGRAPHIC_supplement}', "");
    Expect(1, 127744, '\P{Block=	_Enclosed_IDEOGRAPHIC_supplement}', "");
    Expect(0, 127744, '\P{^Block=	_Enclosed_IDEOGRAPHIC_supplement}', "");
    Error('\p{Blk= /a/Enclosed_Ideographic_SUP}');
    Error('\P{Blk= /a/Enclosed_Ideographic_SUP}');
    Expect(1, 127743, '\p{Blk=:\AEnclosed_Ideographic_Sup\z:}', "");;
    Expect(0, 127744, '\p{Blk=:\AEnclosed_Ideographic_Sup\z:}', "");;
    Expect(1, 127743, '\p{Blk=enclosedideographicsup}', "");
    Expect(0, 127743, '\p{^Blk=enclosedideographicsup}', "");
    Expect(0, 127743, '\P{Blk=enclosedideographicsup}', "");
    Expect(1, 127743, '\P{^Blk=enclosedideographicsup}', "");
    Expect(0, 127744, '\p{Blk=enclosedideographicsup}', "");
    Expect(1, 127744, '\p{^Blk=enclosedideographicsup}', "");
    Expect(1, 127744, '\P{Blk=enclosedideographicsup}', "");
    Expect(0, 127744, '\P{^Blk=enclosedideographicsup}', "");
    Expect(1, 127743, '\p{Blk=:\Aenclosedideographicsup\z:}', "");;
    Expect(0, 127744, '\p{Blk=:\Aenclosedideographicsup\z:}', "");;
    Expect(1, 127743, '\p{Blk= 	enclosed_Ideographic_Sup}', "");
    Expect(0, 127743, '\p{^Blk= 	enclosed_Ideographic_Sup}', "");
    Expect(0, 127743, '\P{Blk= 	enclosed_Ideographic_Sup}', "");
    Expect(1, 127743, '\P{^Blk= 	enclosed_Ideographic_Sup}', "");
    Expect(0, 127744, '\p{Blk= 	enclosed_Ideographic_Sup}', "");
    Expect(1, 127744, '\p{^Blk= 	enclosed_Ideographic_Sup}', "");
    Expect(1, 127744, '\P{Blk= 	enclosed_Ideographic_Sup}', "");
    Expect(0, 127744, '\P{^Blk= 	enclosed_Ideographic_Sup}', "");
    Error('\p{Is_Block=	 Enclosed_ideographic_Supplement/a/}');
    Error('\P{Is_Block=	 Enclosed_ideographic_Supplement/a/}');
    Expect(1, 127743, '\p{Is_Block=enclosedideographicsupplement}', "");
    Expect(0, 127743, '\p{^Is_Block=enclosedideographicsupplement}', "");
    Expect(0, 127743, '\P{Is_Block=enclosedideographicsupplement}', "");
    Expect(1, 127743, '\P{^Is_Block=enclosedideographicsupplement}', "");
    Expect(0, 127744, '\p{Is_Block=enclosedideographicsupplement}', "");
    Expect(1, 127744, '\p{^Is_Block=enclosedideographicsupplement}', "");
    Expect(1, 127744, '\P{Is_Block=enclosedideographicsupplement}', "");
    Expect(0, 127744, '\P{^Is_Block=enclosedideographicsupplement}', "");
    Expect(1, 127743, '\p{Is_Block=Enclosed_IDEOGRAPHIC_supplement}', "");
    Expect(0, 127743, '\p{^Is_Block=Enclosed_IDEOGRAPHIC_supplement}', "");
    Expect(0, 127743, '\P{Is_Block=Enclosed_IDEOGRAPHIC_supplement}', "");
    Expect(1, 127743, '\P{^Is_Block=Enclosed_IDEOGRAPHIC_supplement}', "");
    Expect(0, 127744, '\p{Is_Block=Enclosed_IDEOGRAPHIC_supplement}', "");
    Expect(1, 127744, '\p{^Is_Block=Enclosed_IDEOGRAPHIC_supplement}', "");
    Expect(1, 127744, '\P{Is_Block=Enclosed_IDEOGRAPHIC_supplement}', "");
    Expect(0, 127744, '\P{^Is_Block=Enclosed_IDEOGRAPHIC_supplement}', "");
    Error('\p{Is_Blk=:=	-enclosed_Ideographic_sup}');
    Error('\P{Is_Blk=:=	-enclosed_Ideographic_sup}');
    Expect(1, 127743, '\p{Is_Blk=enclosedideographicsup}', "");
    Expect(0, 127743, '\p{^Is_Blk=enclosedideographicsup}', "");
    Expect(0, 127743, '\P{Is_Blk=enclosedideographicsup}', "");
    Expect(1, 127743, '\P{^Is_Blk=enclosedideographicsup}', "");
    Expect(0, 127744, '\p{Is_Blk=enclosedideographicsup}', "");
    Expect(1, 127744, '\p{^Is_Blk=enclosedideographicsup}', "");
    Expect(1, 127744, '\P{Is_Blk=enclosedideographicsup}', "");
    Expect(0, 127744, '\P{^Is_Blk=enclosedideographicsup}', "");
    Expect(1, 127743, '\p{Is_Blk=_ ENCLOSED_IDEOGRAPHIC_Sup}', "");
    Expect(0, 127743, '\p{^Is_Blk=_ ENCLOSED_IDEOGRAPHIC_Sup}', "");
    Expect(0, 127743, '\P{Is_Blk=_ ENCLOSED_IDEOGRAPHIC_Sup}', "");
    Expect(1, 127743, '\P{^Is_Blk=_ ENCLOSED_IDEOGRAPHIC_Sup}', "");
    Expect(0, 127744, '\p{Is_Blk=_ ENCLOSED_IDEOGRAPHIC_Sup}', "");
    Expect(1, 127744, '\p{^Is_Blk=_ ENCLOSED_IDEOGRAPHIC_Sup}', "");
    Expect(1, 127744, '\P{Is_Blk=_ ENCLOSED_IDEOGRAPHIC_Sup}', "");
    Expect(0, 127744, '\P{^Is_Blk=_ ENCLOSED_IDEOGRAPHIC_Sup}', "");
    Error('\p{Block=-ethiopic:=}');
    Error('\P{Block=-ethiopic:=}');
    Expect(1, 4991, '\p{Block=:\AEthiopic\z:}', "");;
    Expect(0, 4992, '\p{Block=:\AEthiopic\z:}', "");;
    Expect(1, 4991, '\p{Block=ethiopic}', "");
    Expect(0, 4991, '\p{^Block=ethiopic}', "");
    Expect(0, 4991, '\P{Block=ethiopic}', "");
    Expect(1, 4991, '\P{^Block=ethiopic}', "");
    Expect(0, 4992, '\p{Block=ethiopic}', "");
    Expect(1, 4992, '\p{^Block=ethiopic}', "");
    Expect(1, 4992, '\P{Block=ethiopic}', "");
    Expect(0, 4992, '\P{^Block=ethiopic}', "");
    Expect(1, 4991, '\p{Block=:\Aethiopic\z:}', "");;
    Expect(0, 4992, '\p{Block=:\Aethiopic\z:}', "");;
    Expect(1, 4991, '\p{Block: Ethiopic}', "");
    Expect(0, 4991, '\p{^Block: Ethiopic}', "");
    Expect(0, 4991, '\P{Block: Ethiopic}', "");
    Expect(1, 4991, '\P{^Block: Ethiopic}', "");
    Expect(0, 4992, '\p{Block: Ethiopic}', "");
    Expect(1, 4992, '\p{^Block: Ethiopic}', "");
    Expect(1, 4992, '\P{Block: Ethiopic}', "");
    Expect(0, 4992, '\P{^Block: Ethiopic}', "");
    Error('\p{Blk=	 ETHIOPIC:=}');
    Error('\P{Blk=	 ETHIOPIC:=}');
    Expect(1, 4991, '\p{Blk=:\AEthiopic\z:}', "");;
    Expect(0, 4992, '\p{Blk=:\AEthiopic\z:}', "");;
    Expect(1, 4991, '\p{Blk=ethiopic}', "");
    Expect(0, 4991, '\p{^Blk=ethiopic}', "");
    Expect(0, 4991, '\P{Blk=ethiopic}', "");
    Expect(1, 4991, '\P{^Blk=ethiopic}', "");
    Expect(0, 4992, '\p{Blk=ethiopic}', "");
    Expect(1, 4992, '\p{^Blk=ethiopic}', "");
    Expect(1, 4992, '\P{Blk=ethiopic}', "");
    Expect(0, 4992, '\P{^Blk=ethiopic}', "");
    Expect(1, 4991, '\p{Blk=:\Aethiopic\z:}', "");;
    Expect(0, 4992, '\p{Blk=:\Aethiopic\z:}', "");;
    Expect(1, 4991, '\p{Blk=Ethiopic}', "");
    Expect(0, 4991, '\p{^Blk=Ethiopic}', "");
    Expect(0, 4991, '\P{Blk=Ethiopic}', "");
    Expect(1, 4991, '\P{^Blk=Ethiopic}', "");
    Expect(0, 4992, '\p{Blk=Ethiopic}', "");
    Expect(1, 4992, '\p{^Blk=Ethiopic}', "");
    Expect(1, 4992, '\P{Blk=Ethiopic}', "");
    Expect(0, 4992, '\P{^Blk=Ethiopic}', "");
    Error('\p{Is_Block= -Ethiopic:=}');
    Error('\P{Is_Block= -Ethiopic:=}');
    Expect(1, 4991, '\p{Is_Block=ethiopic}', "");
    Expect(0, 4991, '\p{^Is_Block=ethiopic}', "");
    Expect(0, 4991, '\P{Is_Block=ethiopic}', "");
    Expect(1, 4991, '\P{^Is_Block=ethiopic}', "");
    Expect(0, 4992, '\p{Is_Block=ethiopic}', "");
    Expect(1, 4992, '\p{^Is_Block=ethiopic}', "");
    Expect(1, 4992, '\P{Is_Block=ethiopic}', "");
    Expect(0, 4992, '\P{^Is_Block=ethiopic}', "");
    Expect(1, 4991, '\p{Is_Block=--Ethiopic}', "");
    Expect(0, 4991, '\p{^Is_Block=--Ethiopic}', "");
    Expect(0, 4991, '\P{Is_Block=--Ethiopic}', "");
    Expect(1, 4991, '\P{^Is_Block=--Ethiopic}', "");
    Expect(0, 4992, '\p{Is_Block=--Ethiopic}', "");
    Expect(1, 4992, '\p{^Is_Block=--Ethiopic}', "");
    Expect(1, 4992, '\P{Is_Block=--Ethiopic}', "");
    Expect(0, 4992, '\P{^Is_Block=--Ethiopic}', "");
    Error('\p{Is_Blk=:=	-Ethiopic}');
    Error('\P{Is_Blk=:=	-Ethiopic}');
    Expect(1, 4991, '\p{Is_Blk=ethiopic}', "");
    Expect(0, 4991, '\p{^Is_Blk=ethiopic}', "");
    Expect(0, 4991, '\P{Is_Blk=ethiopic}', "");
    Expect(1, 4991, '\P{^Is_Blk=ethiopic}', "");
    Expect(0, 4992, '\p{Is_Blk=ethiopic}', "");
    Expect(1, 4992, '\p{^Is_Blk=ethiopic}', "");
    Expect(1, 4992, '\P{Is_Blk=ethiopic}', "");
    Expect(0, 4992, '\P{^Is_Blk=ethiopic}', "");
    Expect(1, 4991, '\p{Is_Blk=	 Ethiopic}', "");
    Expect(0, 4991, '\p{^Is_Blk=	 Ethiopic}', "");
    Expect(0, 4991, '\P{Is_Blk=	 Ethiopic}', "");
    Expect(1, 4991, '\P{^Is_Blk=	 Ethiopic}', "");
    Expect(0, 4992, '\p{Is_Blk=	 Ethiopic}', "");
    Expect(1, 4992, '\p{^Is_Blk=	 Ethiopic}', "");
    Expect(1, 4992, '\P{Is_Blk=	 Ethiopic}', "");
    Expect(0, 4992, '\P{^Is_Blk=	 Ethiopic}', "");
    Error('\p{Block=:= -ETHIOPIC_Extended}');
    Error('\P{Block=:= -ETHIOPIC_Extended}');
    Expect(1, 11743, '\p{Block=:\AEthiopic_Extended\z:}', "");;
    Expect(0, 11744, '\p{Block=:\AEthiopic_Extended\z:}', "");;
    Expect(1, 11743, '\p{Block=ethiopicextended}', "");
    Expect(0, 11743, '\p{^Block=ethiopicextended}', "");
    Expect(0, 11743, '\P{Block=ethiopicextended}', "");
    Expect(1, 11743, '\P{^Block=ethiopicextended}', "");
    Expect(0, 11744, '\p{Block=ethiopicextended}', "");
    Expect(1, 11744, '\p{^Block=ethiopicextended}', "");
    Expect(1, 11744, '\P{Block=ethiopicextended}', "");
    Expect(0, 11744, '\P{^Block=ethiopicextended}', "");
    Expect(1, 11743, '\p{Block=:\Aethiopicextended\z:}', "");;
    Expect(0, 11744, '\p{Block=:\Aethiopicextended\z:}', "");;
    Expect(1, 11743, '\p{Block=-Ethiopic_extended}', "");
    Expect(0, 11743, '\p{^Block=-Ethiopic_extended}', "");
    Expect(0, 11743, '\P{Block=-Ethiopic_extended}', "");
    Expect(1, 11743, '\P{^Block=-Ethiopic_extended}', "");
    Expect(0, 11744, '\p{Block=-Ethiopic_extended}', "");
    Expect(1, 11744, '\p{^Block=-Ethiopic_extended}', "");
    Expect(1, 11744, '\P{Block=-Ethiopic_extended}', "");
    Expect(0, 11744, '\P{^Block=-Ethiopic_extended}', "");
    Error('\p{Blk=:=-	ethiopic_ext}');
    Error('\P{Blk=:=-	ethiopic_ext}');
    Expect(1, 11743, '\p{Blk=:\AEthiopic_Ext\z:}', "");;
    Expect(0, 11744, '\p{Blk=:\AEthiopic_Ext\z:}', "");;
    Expect(1, 11743, '\p{Blk=ethiopicext}', "");
    Expect(0, 11743, '\p{^Blk=ethiopicext}', "");
    Expect(0, 11743, '\P{Blk=ethiopicext}', "");
    Expect(1, 11743, '\P{^Blk=ethiopicext}', "");
    Expect(0, 11744, '\p{Blk=ethiopicext}', "");
    Expect(1, 11744, '\p{^Blk=ethiopicext}', "");
    Expect(1, 11744, '\P{Blk=ethiopicext}', "");
    Expect(0, 11744, '\P{^Blk=ethiopicext}', "");
    Expect(1, 11743, '\p{Blk=:\Aethiopicext\z:}', "");;
    Expect(0, 11744, '\p{Blk=:\Aethiopicext\z:}', "");;
    Expect(1, 11743, '\p{Blk=_Ethiopic_Ext}', "");
    Expect(0, 11743, '\p{^Blk=_Ethiopic_Ext}', "");
    Expect(0, 11743, '\P{Blk=_Ethiopic_Ext}', "");
    Expect(1, 11743, '\P{^Blk=_Ethiopic_Ext}', "");
    Expect(0, 11744, '\p{Blk=_Ethiopic_Ext}', "");
    Expect(1, 11744, '\p{^Blk=_Ethiopic_Ext}', "");
    Expect(1, 11744, '\P{Blk=_Ethiopic_Ext}', "");
    Expect(0, 11744, '\P{^Blk=_Ethiopic_Ext}', "");
    Error('\p{Is_Block=-/a/ethiopic_extended}');
    Error('\P{Is_Block=-/a/ethiopic_extended}');
    Expect(1, 11743, '\p{Is_Block: ethiopicextended}', "");
    Expect(0, 11743, '\p{^Is_Block: ethiopicextended}', "");
    Expect(0, 11743, '\P{Is_Block: ethiopicextended}', "");
    Expect(1, 11743, '\P{^Is_Block: ethiopicextended}', "");
    Expect(0, 11744, '\p{Is_Block: ethiopicextended}', "");
    Expect(1, 11744, '\p{^Is_Block: ethiopicextended}', "");
    Expect(1, 11744, '\P{Is_Block: ethiopicextended}', "");
    Expect(0, 11744, '\P{^Is_Block: ethiopicextended}', "");
    Expect(1, 11743, '\p{Is_Block=	ETHIOPIC_Extended}', "");
    Expect(0, 11743, '\p{^Is_Block=	ETHIOPIC_Extended}', "");
    Expect(0, 11743, '\P{Is_Block=	ETHIOPIC_Extended}', "");
    Expect(1, 11743, '\P{^Is_Block=	ETHIOPIC_Extended}', "");
    Expect(0, 11744, '\p{Is_Block=	ETHIOPIC_Extended}', "");
    Expect(1, 11744, '\p{^Is_Block=	ETHIOPIC_Extended}', "");
    Expect(1, 11744, '\P{Is_Block=	ETHIOPIC_Extended}', "");
    Expect(0, 11744, '\P{^Is_Block=	ETHIOPIC_Extended}', "");
    Error('\p{Is_Blk=:=	 Ethiopic_ext}');
    Error('\P{Is_Blk=:=	 Ethiopic_ext}');
    Expect(1, 11743, '\p{Is_Blk:	ethiopicext}', "");
    Expect(0, 11743, '\p{^Is_Blk:	ethiopicext}', "");
    Expect(0, 11743, '\P{Is_Blk:	ethiopicext}', "");
    Expect(1, 11743, '\P{^Is_Blk:	ethiopicext}', "");
    Expect(0, 11744, '\p{Is_Blk:	ethiopicext}', "");
    Expect(1, 11744, '\p{^Is_Blk:	ethiopicext}', "");
    Expect(1, 11744, '\P{Is_Blk:	ethiopicext}', "");
    Expect(0, 11744, '\P{^Is_Blk:	ethiopicext}', "");
    Expect(1, 11743, '\p{Is_Blk=  Ethiopic_Ext}', "");
    Expect(0, 11743, '\p{^Is_Blk=  Ethiopic_Ext}', "");
    Expect(0, 11743, '\P{Is_Blk=  Ethiopic_Ext}', "");
    Expect(1, 11743, '\P{^Is_Blk=  Ethiopic_Ext}', "");
    Expect(0, 11744, '\p{Is_Blk=  Ethiopic_Ext}', "");
    Expect(1, 11744, '\p{^Is_Blk=  Ethiopic_Ext}', "");
    Expect(1, 11744, '\P{Is_Blk=  Ethiopic_Ext}', "");
    Expect(0, 11744, '\P{^Is_Blk=  Ethiopic_Ext}', "");
    Error('\p{Block=/a/_-Ethiopic_Extended_a}');
    Error('\P{Block=/a/_-Ethiopic_Extended_a}');
    Expect(1, 43823, '\p{Block=:\AEthiopic_Extended_A\z:}', "");;
    Expect(0, 43824, '\p{Block=:\AEthiopic_Extended_A\z:}', "");;
    Expect(1, 43823, '\p{Block=ethiopicextendeda}', "");
    Expect(0, 43823, '\p{^Block=ethiopicextendeda}', "");
    Expect(0, 43823, '\P{Block=ethiopicextendeda}', "");
    Expect(1, 43823, '\P{^Block=ethiopicextendeda}', "");
    Expect(0, 43824, '\p{Block=ethiopicextendeda}', "");
    Expect(1, 43824, '\p{^Block=ethiopicextendeda}', "");
    Expect(1, 43824, '\P{Block=ethiopicextendeda}', "");
    Expect(0, 43824, '\P{^Block=ethiopicextendeda}', "");
    Expect(1, 43823, '\p{Block=:\Aethiopicextendeda\z:}', "");;
    Expect(0, 43824, '\p{Block=:\Aethiopicextendeda\z:}', "");;
    Expect(1, 43823, '\p{Block= ethiopic_Extended_A}', "");
    Expect(0, 43823, '\p{^Block= ethiopic_Extended_A}', "");
    Expect(0, 43823, '\P{Block= ethiopic_Extended_A}', "");
    Expect(1, 43823, '\P{^Block= ethiopic_Extended_A}', "");
    Expect(0, 43824, '\p{Block= ethiopic_Extended_A}', "");
    Expect(1, 43824, '\p{^Block= ethiopic_Extended_A}', "");
    Expect(1, 43824, '\P{Block= ethiopic_Extended_A}', "");
    Expect(0, 43824, '\P{^Block= ethiopic_Extended_A}', "");
    Error('\p{Blk=/a/_ Ethiopic_ext_a}');
    Error('\P{Blk=/a/_ Ethiopic_ext_a}');
    Expect(1, 43823, '\p{Blk=:\AEthiopic_Ext_A\z:}', "");;
    Expect(0, 43824, '\p{Blk=:\AEthiopic_Ext_A\z:}', "");;
    Expect(1, 43823, '\p{Blk=ethiopicexta}', "");
    Expect(0, 43823, '\p{^Blk=ethiopicexta}', "");
    Expect(0, 43823, '\P{Blk=ethiopicexta}', "");
    Expect(1, 43823, '\P{^Blk=ethiopicexta}', "");
    Expect(0, 43824, '\p{Blk=ethiopicexta}', "");
    Expect(1, 43824, '\p{^Blk=ethiopicexta}', "");
    Expect(1, 43824, '\P{Blk=ethiopicexta}', "");
    Expect(0, 43824, '\P{^Blk=ethiopicexta}', "");
    Expect(1, 43823, '\p{Blk=:\Aethiopicexta\z:}', "");;
    Expect(0, 43824, '\p{Blk=:\Aethiopicexta\z:}', "");;
    Expect(1, 43823, '\p{Blk=	ETHIOPIC_EXT_A}', "");
    Expect(0, 43823, '\p{^Blk=	ETHIOPIC_EXT_A}', "");
    Expect(0, 43823, '\P{Blk=	ETHIOPIC_EXT_A}', "");
    Expect(1, 43823, '\P{^Blk=	ETHIOPIC_EXT_A}', "");
    Expect(0, 43824, '\p{Blk=	ETHIOPIC_EXT_A}', "");
    Expect(1, 43824, '\p{^Blk=	ETHIOPIC_EXT_A}', "");
    Expect(1, 43824, '\P{Blk=	ETHIOPIC_EXT_A}', "");
    Expect(0, 43824, '\P{^Blk=	ETHIOPIC_EXT_A}', "");
    Error('\p{Is_Block= _ETHIOPIC_EXTENDED_A/a/}');
    Error('\P{Is_Block= _ETHIOPIC_EXTENDED_A/a/}');
    Expect(1, 43823, '\p{Is_Block=ethiopicextendeda}', "");
    Expect(0, 43823, '\p{^Is_Block=ethiopicextendeda}', "");
    Expect(0, 43823, '\P{Is_Block=ethiopicextendeda}', "");
    Expect(1, 43823, '\P{^Is_Block=ethiopicextendeda}', "");
    Expect(0, 43824, '\p{Is_Block=ethiopicextendeda}', "");
    Expect(1, 43824, '\p{^Is_Block=ethiopicextendeda}', "");
    Expect(1, 43824, '\P{Is_Block=ethiopicextendeda}', "");
    Expect(0, 43824, '\P{^Is_Block=ethiopicextendeda}', "");
    Expect(1, 43823, '\p{Is_Block=_	Ethiopic_extended_A}', "");
    Expect(0, 43823, '\p{^Is_Block=_	Ethiopic_extended_A}', "");
    Expect(0, 43823, '\P{Is_Block=_	Ethiopic_extended_A}', "");
    Expect(1, 43823, '\P{^Is_Block=_	Ethiopic_extended_A}', "");
    Expect(0, 43824, '\p{Is_Block=_	Ethiopic_extended_A}', "");
    Expect(1, 43824, '\p{^Is_Block=_	Ethiopic_extended_A}', "");
    Expect(1, 43824, '\P{Is_Block=_	Ethiopic_extended_A}', "");
    Expect(0, 43824, '\P{^Is_Block=_	Ethiopic_extended_A}', "");
    Error('\p{Is_Blk=:=ethiopic_Ext_a}');
    Error('\P{Is_Blk=:=ethiopic_Ext_a}');
    Expect(1, 43823, '\p{Is_Blk:   ethiopicexta}', "");
    Expect(0, 43823, '\p{^Is_Blk:   ethiopicexta}', "");
    Expect(0, 43823, '\P{Is_Blk:   ethiopicexta}', "");
    Expect(1, 43823, '\P{^Is_Blk:   ethiopicexta}', "");
    Expect(0, 43824, '\p{Is_Blk:   ethiopicexta}', "");
    Expect(1, 43824, '\p{^Is_Blk:   ethiopicexta}', "");
    Expect(1, 43824, '\P{Is_Blk:   ethiopicexta}', "");
    Expect(0, 43824, '\P{^Is_Blk:   ethiopicexta}', "");
    Expect(1, 43823, '\p{Is_Blk=-	Ethiopic_Ext_a}', "");
    Expect(0, 43823, '\p{^Is_Blk=-	Ethiopic_Ext_a}', "");
    Expect(0, 43823, '\P{Is_Blk=-	Ethiopic_Ext_a}', "");
    Expect(1, 43823, '\P{^Is_Blk=-	Ethiopic_Ext_a}', "");
    Expect(0, 43824, '\p{Is_Blk=-	Ethiopic_Ext_a}', "");
    Expect(1, 43824, '\p{^Is_Blk=-	Ethiopic_Ext_a}', "");
    Expect(1, 43824, '\P{Is_Blk=-	Ethiopic_Ext_a}', "");
    Expect(0, 43824, '\P{^Is_Blk=-	Ethiopic_Ext_a}', "");
    Error('\p{Block=/a/-	Ethiopic_Supplement}');
    Error('\P{Block=/a/-	Ethiopic_Supplement}');
    Expect(1, 5023, '\p{Block=:\AEthiopic_Supplement\z:}', "");;
    Expect(0, 5024, '\p{Block=:\AEthiopic_Supplement\z:}', "");;
    Expect(1, 5023, '\p{Block=ethiopicsupplement}', "");
    Expect(0, 5023, '\p{^Block=ethiopicsupplement}', "");
    Expect(0, 5023, '\P{Block=ethiopicsupplement}', "");
    Expect(1, 5023, '\P{^Block=ethiopicsupplement}', "");
    Expect(0, 5024, '\p{Block=ethiopicsupplement}', "");
    Expect(1, 5024, '\p{^Block=ethiopicsupplement}', "");
    Expect(1, 5024, '\P{Block=ethiopicsupplement}', "");
    Expect(0, 5024, '\P{^Block=ethiopicsupplement}', "");
    Expect(1, 5023, '\p{Block=:\Aethiopicsupplement\z:}', "");;
    Expect(0, 5024, '\p{Block=:\Aethiopicsupplement\z:}', "");;
    Expect(1, 5023, '\p{Block= ethiopic_supplement}', "");
    Expect(0, 5023, '\p{^Block= ethiopic_supplement}', "");
    Expect(0, 5023, '\P{Block= ethiopic_supplement}', "");
    Expect(1, 5023, '\P{^Block= ethiopic_supplement}', "");
    Expect(0, 5024, '\p{Block= ethiopic_supplement}', "");
    Expect(1, 5024, '\p{^Block= ethiopic_supplement}', "");
    Expect(1, 5024, '\P{Block= ethiopic_supplement}', "");
    Expect(0, 5024, '\P{^Block= ethiopic_supplement}', "");
    Error('\p{Blk=-_Ethiopic_SUP/a/}');
    Error('\P{Blk=-_Ethiopic_SUP/a/}');
    Expect(1, 5023, '\p{Blk=:\AEthiopic_Sup\z:}', "");;
    Expect(0, 5024, '\p{Blk=:\AEthiopic_Sup\z:}', "");;
    Expect(1, 5023, '\p{Blk=ethiopicsup}', "");
    Expect(0, 5023, '\p{^Blk=ethiopicsup}', "");
    Expect(0, 5023, '\P{Blk=ethiopicsup}', "");
    Expect(1, 5023, '\P{^Blk=ethiopicsup}', "");
    Expect(0, 5024, '\p{Blk=ethiopicsup}', "");
    Expect(1, 5024, '\p{^Blk=ethiopicsup}', "");
    Expect(1, 5024, '\P{Blk=ethiopicsup}', "");
    Expect(0, 5024, '\P{^Blk=ethiopicsup}', "");
    Expect(1, 5023, '\p{Blk=:\Aethiopicsup\z:}', "");;
    Expect(0, 5024, '\p{Blk=:\Aethiopicsup\z:}', "");;
    Expect(1, 5023, '\p{Blk= _ETHIOPIC_SUP}', "");
    Expect(0, 5023, '\p{^Blk= _ETHIOPIC_SUP}', "");
    Expect(0, 5023, '\P{Blk= _ETHIOPIC_SUP}', "");
    Expect(1, 5023, '\P{^Blk= _ETHIOPIC_SUP}', "");
    Expect(0, 5024, '\p{Blk= _ETHIOPIC_SUP}', "");
    Expect(1, 5024, '\p{^Blk= _ETHIOPIC_SUP}', "");
    Expect(1, 5024, '\P{Blk= _ETHIOPIC_SUP}', "");
    Expect(0, 5024, '\P{^Blk= _ETHIOPIC_SUP}', "");
    Error('\p{Is_Block: /a/--ethiopic_SUPPLEMENT}');
    Error('\P{Is_Block: /a/--ethiopic_SUPPLEMENT}');
    Expect(1, 5023, '\p{Is_Block=ethiopicsupplement}', "");
    Expect(0, 5023, '\p{^Is_Block=ethiopicsupplement}', "");
    Expect(0, 5023, '\P{Is_Block=ethiopicsupplement}', "");
    Expect(1, 5023, '\P{^Is_Block=ethiopicsupplement}', "");
    Expect(0, 5024, '\p{Is_Block=ethiopicsupplement}', "");
    Expect(1, 5024, '\p{^Is_Block=ethiopicsupplement}', "");
    Expect(1, 5024, '\P{Is_Block=ethiopicsupplement}', "");
    Expect(0, 5024, '\P{^Is_Block=ethiopicsupplement}', "");
    Expect(1, 5023, '\p{Is_Block=-_Ethiopic_supplement}', "");
    Expect(0, 5023, '\p{^Is_Block=-_Ethiopic_supplement}', "");
    Expect(0, 5023, '\P{Is_Block=-_Ethiopic_supplement}', "");
    Expect(1, 5023, '\P{^Is_Block=-_Ethiopic_supplement}', "");
    Expect(0, 5024, '\p{Is_Block=-_Ethiopic_supplement}', "");
    Expect(1, 5024, '\p{^Is_Block=-_Ethiopic_supplement}', "");
    Expect(1, 5024, '\P{Is_Block=-_Ethiopic_supplement}', "");
    Expect(0, 5024, '\P{^Is_Block=-_Ethiopic_supplement}', "");
    Error('\p{Is_Blk= :=Ethiopic_sup}');
    Error('\P{Is_Blk= :=Ethiopic_sup}');
    Expect(1, 5023, '\p{Is_Blk=ethiopicsup}', "");
    Expect(0, 5023, '\p{^Is_Blk=ethiopicsup}', "");
    Expect(0, 5023, '\P{Is_Blk=ethiopicsup}', "");
    Expect(1, 5023, '\P{^Is_Blk=ethiopicsup}', "");
    Expect(0, 5024, '\p{Is_Blk=ethiopicsup}', "");
    Expect(1, 5024, '\p{^Is_Blk=ethiopicsup}', "");
    Expect(1, 5024, '\P{Is_Blk=ethiopicsup}', "");
    Expect(0, 5024, '\P{^Is_Blk=ethiopicsup}', "");
    Expect(1, 5023, '\p{Is_Blk=  ethiopic_SUP}', "");
    Expect(0, 5023, '\p{^Is_Blk=  ethiopic_SUP}', "");
    Expect(0, 5023, '\P{Is_Blk=  ethiopic_SUP}', "");
    Expect(1, 5023, '\P{^Is_Blk=  ethiopic_SUP}', "");
    Expect(0, 5024, '\p{Is_Blk=  ethiopic_SUP}', "");
    Expect(1, 5024, '\p{^Is_Blk=  ethiopic_SUP}', "");
    Expect(1, 5024, '\P{Is_Blk=  ethiopic_SUP}', "");
    Expect(0, 5024, '\P{^Is_Blk=  ethiopic_SUP}', "");
    Error('\p{Block=-:=Geometric_shapes}');
    Error('\P{Block=-:=Geometric_shapes}');
    Expect(1, 9727, '\p{Block=:\AGeometric_Shapes\z:}', "");;
    Expect(0, 9728, '\p{Block=:\AGeometric_Shapes\z:}', "");;
    Expect(1, 9727, '\p{Block=geometricshapes}', "");
    Expect(0, 9727, '\p{^Block=geometricshapes}', "");
    Expect(0, 9727, '\P{Block=geometricshapes}', "");
    Expect(1, 9727, '\P{^Block=geometricshapes}', "");
    Expect(0, 9728, '\p{Block=geometricshapes}', "");
    Expect(1, 9728, '\p{^Block=geometricshapes}', "");
    Expect(1, 9728, '\P{Block=geometricshapes}', "");
    Expect(0, 9728, '\P{^Block=geometricshapes}', "");
    Expect(1, 9727, '\p{Block=:\Ageometricshapes\z:}', "");;
    Expect(0, 9728, '\p{Block=:\Ageometricshapes\z:}', "");;
    Expect(1, 9727, '\p{Block=_Geometric_SHAPES}', "");
    Expect(0, 9727, '\p{^Block=_Geometric_SHAPES}', "");
    Expect(0, 9727, '\P{Block=_Geometric_SHAPES}', "");
    Expect(1, 9727, '\P{^Block=_Geometric_SHAPES}', "");
    Expect(0, 9728, '\p{Block=_Geometric_SHAPES}', "");
    Expect(1, 9728, '\p{^Block=_Geometric_SHAPES}', "");
    Expect(1, 9728, '\P{Block=_Geometric_SHAPES}', "");
    Expect(0, 9728, '\P{^Block=_Geometric_SHAPES}', "");
    Error('\p{Blk=:=	_geometric_Shapes}');
    Error('\P{Blk=:=	_geometric_Shapes}');
    Expect(1, 9727, '\p{Blk=:\AGeometric_Shapes\z:}', "");;
    Expect(0, 9728, '\p{Blk=:\AGeometric_Shapes\z:}', "");;
    Expect(1, 9727, '\p{Blk=geometricshapes}', "");
    Expect(0, 9727, '\p{^Blk=geometricshapes}', "");
    Expect(0, 9727, '\P{Blk=geometricshapes}', "");
    Expect(1, 9727, '\P{^Blk=geometricshapes}', "");
    Expect(0, 9728, '\p{Blk=geometricshapes}', "");
    Expect(1, 9728, '\p{^Blk=geometricshapes}', "");
    Expect(1, 9728, '\P{Blk=geometricshapes}', "");
    Expect(0, 9728, '\P{^Blk=geometricshapes}', "");
    Expect(1, 9727, '\p{Blk=:\Ageometricshapes\z:}', "");;
    Expect(0, 9728, '\p{Blk=:\Ageometricshapes\z:}', "");;
    Expect(1, 9727, '\p{Blk:--GEOMETRIC_SHAPES}', "");
    Expect(0, 9727, '\p{^Blk:--GEOMETRIC_SHAPES}', "");
    Expect(0, 9727, '\P{Blk:--GEOMETRIC_SHAPES}', "");
    Expect(1, 9727, '\P{^Blk:--GEOMETRIC_SHAPES}', "");
    Expect(0, 9728, '\p{Blk:--GEOMETRIC_SHAPES}', "");
    Expect(1, 9728, '\p{^Blk:--GEOMETRIC_SHAPES}', "");
    Expect(1, 9728, '\P{Blk:--GEOMETRIC_SHAPES}', "");
    Expect(0, 9728, '\P{^Blk:--GEOMETRIC_SHAPES}', "");
    Error('\p{Is_Block=:=	-Geometric_SHAPES}');
    Error('\P{Is_Block=:=	-Geometric_SHAPES}');
    Expect(1, 9727, '\p{Is_Block=geometricshapes}', "");
    Expect(0, 9727, '\p{^Is_Block=geometricshapes}', "");
    Expect(0, 9727, '\P{Is_Block=geometricshapes}', "");
    Expect(1, 9727, '\P{^Is_Block=geometricshapes}', "");
    Expect(0, 9728, '\p{Is_Block=geometricshapes}', "");
    Expect(1, 9728, '\p{^Is_Block=geometricshapes}', "");
    Expect(1, 9728, '\P{Is_Block=geometricshapes}', "");
    Expect(0, 9728, '\P{^Is_Block=geometricshapes}', "");
    Expect(1, 9727, '\p{Is_Block=	geometric_SHAPES}', "");
    Expect(0, 9727, '\p{^Is_Block=	geometric_SHAPES}', "");
    Expect(0, 9727, '\P{Is_Block=	geometric_SHAPES}', "");
    Expect(1, 9727, '\P{^Is_Block=	geometric_SHAPES}', "");
    Expect(0, 9728, '\p{Is_Block=	geometric_SHAPES}', "");
    Expect(1, 9728, '\p{^Is_Block=	geometric_SHAPES}', "");
    Expect(1, 9728, '\P{Is_Block=	geometric_SHAPES}', "");
    Expect(0, 9728, '\P{^Is_Block=	geometric_SHAPES}', "");
    Error('\p{Is_Blk=_-Geometric_shapes/a/}');
    Error('\P{Is_Blk=_-Geometric_shapes/a/}');
    Expect(1, 9727, '\p{Is_Blk=geometricshapes}', "");
    Expect(0, 9727, '\p{^Is_Blk=geometricshapes}', "");
    Expect(0, 9727, '\P{Is_Blk=geometricshapes}', "");
    Expect(1, 9727, '\P{^Is_Blk=geometricshapes}', "");
    Expect(0, 9728, '\p{Is_Blk=geometricshapes}', "");
    Expect(1, 9728, '\p{^Is_Blk=geometricshapes}', "");
    Expect(1, 9728, '\P{Is_Blk=geometricshapes}', "");
    Expect(0, 9728, '\P{^Is_Blk=geometricshapes}', "");
    Expect(1, 9727, '\p{Is_Blk: Geometric_shapes}', "");
    Expect(0, 9727, '\p{^Is_Blk: Geometric_shapes}', "");
    Expect(0, 9727, '\P{Is_Blk: Geometric_shapes}', "");
    Expect(1, 9727, '\P{^Is_Blk: Geometric_shapes}', "");
    Expect(0, 9728, '\p{Is_Blk: Geometric_shapes}', "");
    Expect(1, 9728, '\p{^Is_Blk: Geometric_shapes}', "");
    Expect(1, 9728, '\P{Is_Blk: Geometric_shapes}', "");
    Expect(0, 9728, '\P{^Is_Blk: Geometric_shapes}', "");
    Error('\p{Block=geometric_shapes_Extended/a/}');
    Error('\P{Block=geometric_shapes_Extended/a/}');
    Expect(1, 129023, '\p{Block=:\AGeometric_Shapes_Extended\z:}', "");;
    Expect(0, 129024, '\p{Block=:\AGeometric_Shapes_Extended\z:}', "");;
    Expect(1, 129023, '\p{Block:   geometricshapesextended}', "");
    Expect(0, 129023, '\p{^Block:   geometricshapesextended}', "");
    Expect(0, 129023, '\P{Block:   geometricshapesextended}', "");
    Expect(1, 129023, '\P{^Block:   geometricshapesextended}', "");
    Expect(0, 129024, '\p{Block:   geometricshapesextended}', "");
    Expect(1, 129024, '\p{^Block:   geometricshapesextended}', "");
    Expect(1, 129024, '\P{Block:   geometricshapesextended}', "");
    Expect(0, 129024, '\P{^Block:   geometricshapesextended}', "");
    Expect(1, 129023, '\p{Block=:\Ageometricshapesextended\z:}', "");;
    Expect(0, 129024, '\p{Block=:\Ageometricshapesextended\z:}', "");;
    Expect(1, 129023, '\p{Block=	-geometric_shapes_EXTENDED}', "");
    Expect(0, 129023, '\p{^Block=	-geometric_shapes_EXTENDED}', "");
    Expect(0, 129023, '\P{Block=	-geometric_shapes_EXTENDED}', "");
    Expect(1, 129023, '\P{^Block=	-geometric_shapes_EXTENDED}', "");
    Expect(0, 129024, '\p{Block=	-geometric_shapes_EXTENDED}', "");
    Expect(1, 129024, '\p{^Block=	-geometric_shapes_EXTENDED}', "");
    Expect(1, 129024, '\P{Block=	-geometric_shapes_EXTENDED}', "");
    Expect(0, 129024, '\P{^Block=	-geometric_shapes_EXTENDED}', "");
    Error('\p{Blk=_Geometric_SHAPES_Ext/a/}');
    Error('\P{Blk=_Geometric_SHAPES_Ext/a/}');
    Expect(1, 129023, '\p{Blk=:\AGeometric_Shapes_Ext\z:}', "");;
    Expect(0, 129024, '\p{Blk=:\AGeometric_Shapes_Ext\z:}', "");;
    Expect(1, 129023, '\p{Blk=geometricshapesext}', "");
    Expect(0, 129023, '\p{^Blk=geometricshapesext}', "");
    Expect(0, 129023, '\P{Blk=geometricshapesext}', "");
    Expect(1, 129023, '\P{^Blk=geometricshapesext}', "");
    Expect(0, 129024, '\p{Blk=geometricshapesext}', "");
    Expect(1, 129024, '\p{^Blk=geometricshapesext}', "");
    Expect(1, 129024, '\P{Blk=geometricshapesext}', "");
    Expect(0, 129024, '\P{^Blk=geometricshapesext}', "");
    Expect(1, 129023, '\p{Blk=:\Ageometricshapesext\z:}', "");;
    Expect(0, 129024, '\p{Blk=:\Ageometricshapesext\z:}', "");;
    Expect(1, 129023, '\p{Blk:	_GEOMETRIC_Shapes_Ext}', "");
    Expect(0, 129023, '\p{^Blk:	_GEOMETRIC_Shapes_Ext}', "");
    Expect(0, 129023, '\P{Blk:	_GEOMETRIC_Shapes_Ext}', "");
    Expect(1, 129023, '\P{^Blk:	_GEOMETRIC_Shapes_Ext}', "");
    Expect(0, 129024, '\p{Blk:	_GEOMETRIC_Shapes_Ext}', "");
    Expect(1, 129024, '\p{^Blk:	_GEOMETRIC_Shapes_Ext}', "");
    Expect(1, 129024, '\P{Blk:	_GEOMETRIC_Shapes_Ext}', "");
    Expect(0, 129024, '\P{^Blk:	_GEOMETRIC_Shapes_Ext}', "");
    Error('\p{Is_Block:-	GEOMETRIC_Shapes_EXTENDED:=}');
    Error('\P{Is_Block:-	GEOMETRIC_Shapes_EXTENDED:=}');
    Expect(1, 129023, '\p{Is_Block=geometricshapesextended}', "");
    Expect(0, 129023, '\p{^Is_Block=geometricshapesextended}', "");
    Expect(0, 129023, '\P{Is_Block=geometricshapesextended}', "");
    Expect(1, 129023, '\P{^Is_Block=geometricshapesextended}', "");
    Expect(0, 129024, '\p{Is_Block=geometricshapesextended}', "");
    Expect(1, 129024, '\p{^Is_Block=geometricshapesextended}', "");
    Expect(1, 129024, '\P{Is_Block=geometricshapesextended}', "");
    Expect(0, 129024, '\P{^Is_Block=geometricshapesextended}', "");
    Expect(1, 129023, '\p{Is_Block=-	geometric_Shapes_EXTENDED}', "");
    Expect(0, 129023, '\p{^Is_Block=-	geometric_Shapes_EXTENDED}', "");
    Expect(0, 129023, '\P{Is_Block=-	geometric_Shapes_EXTENDED}', "");
    Expect(1, 129023, '\P{^Is_Block=-	geometric_Shapes_EXTENDED}', "");
    Expect(0, 129024, '\p{Is_Block=-	geometric_Shapes_EXTENDED}', "");
    Expect(1, 129024, '\p{^Is_Block=-	geometric_Shapes_EXTENDED}', "");
    Expect(1, 129024, '\P{Is_Block=-	geometric_Shapes_EXTENDED}', "");
    Expect(0, 129024, '\P{^Is_Block=-	geometric_Shapes_EXTENDED}', "");
    Error('\p{Is_Blk=/a/Geometric_Shapes_Ext}');
    Error('\P{Is_Blk=/a/Geometric_Shapes_Ext}');
    Expect(1, 129023, '\p{Is_Blk=geometricshapesext}', "");
    Expect(0, 129023, '\p{^Is_Blk=geometricshapesext}', "");
    Expect(0, 129023, '\P{Is_Blk=geometricshapesext}', "");
    Expect(1, 129023, '\P{^Is_Blk=geometricshapesext}', "");
    Expect(0, 129024, '\p{Is_Blk=geometricshapesext}', "");
    Expect(1, 129024, '\p{^Is_Blk=geometricshapesext}', "");
    Expect(1, 129024, '\P{Is_Blk=geometricshapesext}', "");
    Expect(0, 129024, '\P{^Is_Blk=geometricshapesext}', "");
    Expect(1, 129023, '\p{Is_Blk=_-Geometric_Shapes_ext}', "");
    Expect(0, 129023, '\p{^Is_Blk=_-Geometric_Shapes_ext}', "");
    Expect(0, 129023, '\P{Is_Blk=_-Geometric_Shapes_ext}', "");
    Expect(1, 129023, '\P{^Is_Blk=_-Geometric_Shapes_ext}', "");
    Expect(0, 129024, '\p{Is_Blk=_-Geometric_Shapes_ext}', "");
    Expect(1, 129024, '\p{^Is_Blk=_-Geometric_Shapes_ext}', "");
    Expect(1, 129024, '\P{Is_Blk=_-Geometric_Shapes_ext}', "");
    Expect(0, 129024, '\P{^Is_Blk=_-Geometric_Shapes_ext}', "");
    Error('\p{Block=	GEORGIAN/a/}');
    Error('\P{Block=	GEORGIAN/a/}');
    Expect(1, 4351, '\p{Block=:\AGeorgian\z:}', "");;
    Expect(0, 4352, '\p{Block=:\AGeorgian\z:}', "");;
    Expect(1, 4351, '\p{Block=georgian}', "");
    Expect(0, 4351, '\p{^Block=georgian}', "");
    Expect(0, 4351, '\P{Block=georgian}', "");
    Expect(1, 4351, '\P{^Block=georgian}', "");
    Expect(0, 4352, '\p{Block=georgian}', "");
    Expect(1, 4352, '\p{^Block=georgian}', "");
    Expect(1, 4352, '\P{Block=georgian}', "");
    Expect(0, 4352, '\P{^Block=georgian}', "");
    Expect(1, 4351, '\p{Block=:\Ageorgian\z:}', "");;
    Expect(0, 4352, '\p{Block=:\Ageorgian\z:}', "");;
    Expect(1, 4351, '\p{Block=-_Georgian}', "");
    Expect(0, 4351, '\p{^Block=-_Georgian}', "");
    Expect(0, 4351, '\P{Block=-_Georgian}', "");
    Expect(1, 4351, '\P{^Block=-_Georgian}', "");
    Expect(0, 4352, '\p{Block=-_Georgian}', "");
    Expect(1, 4352, '\p{^Block=-_Georgian}', "");
    Expect(1, 4352, '\P{Block=-_Georgian}', "");
    Expect(0, 4352, '\P{^Block=-_Georgian}', "");
    Error('\p{Blk= /a/GEORGIAN}');
    Error('\P{Blk= /a/GEORGIAN}');
    Expect(1, 4351, '\p{Blk=:\AGeorgian\z:}', "");;
    Expect(0, 4352, '\p{Blk=:\AGeorgian\z:}', "");;
    Expect(1, 4351, '\p{Blk=georgian}', "");
    Expect(0, 4351, '\p{^Blk=georgian}', "");
    Expect(0, 4351, '\P{Blk=georgian}', "");
    Expect(1, 4351, '\P{^Blk=georgian}', "");
    Expect(0, 4352, '\p{Blk=georgian}', "");
    Expect(1, 4352, '\p{^Blk=georgian}', "");
    Expect(1, 4352, '\P{Blk=georgian}', "");
    Expect(0, 4352, '\P{^Blk=georgian}', "");
    Expect(1, 4351, '\p{Blk=:\Ageorgian\z:}', "");;
    Expect(0, 4352, '\p{Blk=:\Ageorgian\z:}', "");;
    Expect(1, 4351, '\p{Blk=_Georgian}', "");
    Expect(0, 4351, '\p{^Blk=_Georgian}', "");
    Expect(0, 4351, '\P{Blk=_Georgian}', "");
    Expect(1, 4351, '\P{^Blk=_Georgian}', "");
    Expect(0, 4352, '\p{Blk=_Georgian}', "");
    Expect(1, 4352, '\p{^Blk=_Georgian}', "");
    Expect(1, 4352, '\P{Blk=_Georgian}', "");
    Expect(0, 4352, '\P{^Blk=_Georgian}', "");
    Error('\p{Is_Block=:=	GEORGIAN}');
    Error('\P{Is_Block=:=	GEORGIAN}');
    Expect(1, 4351, '\p{Is_Block: georgian}', "");
    Expect(0, 4351, '\p{^Is_Block: georgian}', "");
    Expect(0, 4351, '\P{Is_Block: georgian}', "");
    Expect(1, 4351, '\P{^Is_Block: georgian}', "");
    Expect(0, 4352, '\p{Is_Block: georgian}', "");
    Expect(1, 4352, '\p{^Is_Block: georgian}', "");
    Expect(1, 4352, '\P{Is_Block: georgian}', "");
    Expect(0, 4352, '\P{^Is_Block: georgian}', "");
    Expect(1, 4351, '\p{Is_Block=_Georgian}', "");
    Expect(0, 4351, '\p{^Is_Block=_Georgian}', "");
    Expect(0, 4351, '\P{Is_Block=_Georgian}', "");
    Expect(1, 4351, '\P{^Is_Block=_Georgian}', "");
    Expect(0, 4352, '\p{Is_Block=_Georgian}', "");
    Expect(1, 4352, '\p{^Is_Block=_Georgian}', "");
    Expect(1, 4352, '\P{Is_Block=_Georgian}', "");
    Expect(0, 4352, '\P{^Is_Block=_Georgian}', "");
    Error('\p{Is_Blk: /a/_-georgian}');
    Error('\P{Is_Blk: /a/_-georgian}');
    Expect(1, 4351, '\p{Is_Blk=georgian}', "");
    Expect(0, 4351, '\p{^Is_Blk=georgian}', "");
    Expect(0, 4351, '\P{Is_Blk=georgian}', "");
    Expect(1, 4351, '\P{^Is_Blk=georgian}', "");
    Expect(0, 4352, '\p{Is_Blk=georgian}', "");
    Expect(1, 4352, '\p{^Is_Blk=georgian}', "");
    Expect(1, 4352, '\P{Is_Blk=georgian}', "");
    Expect(0, 4352, '\P{^Is_Blk=georgian}', "");
    Expect(1, 4351, '\p{Is_Blk=--georgian}', "");
    Expect(0, 4351, '\p{^Is_Blk=--georgian}', "");
    Expect(0, 4351, '\P{Is_Blk=--georgian}', "");
    Expect(1, 4351, '\P{^Is_Blk=--georgian}', "");
    Expect(0, 4352, '\p{Is_Blk=--georgian}', "");
    Expect(1, 4352, '\p{^Is_Blk=--georgian}', "");
    Expect(1, 4352, '\P{Is_Blk=--georgian}', "");
    Expect(0, 4352, '\P{^Is_Blk=--georgian}', "");
    Error('\p{Block:	/a/Georgian_Extended}');
    Error('\P{Block:	/a/Georgian_Extended}');
    Expect(1, 7359, '\p{Block=:\AGeorgian_Extended\z:}', "");;
    Expect(0, 7360, '\p{Block=:\AGeorgian_Extended\z:}', "");;
    Expect(1, 7359, '\p{Block=georgianextended}', "");
    Expect(0, 7359, '\p{^Block=georgianextended}', "");
    Expect(0, 7359, '\P{Block=georgianextended}', "");
    Expect(1, 7359, '\P{^Block=georgianextended}', "");
    Expect(0, 7360, '\p{Block=georgianextended}', "");
    Expect(1, 7360, '\p{^Block=georgianextended}', "");
    Expect(1, 7360, '\P{Block=georgianextended}', "");
    Expect(0, 7360, '\P{^Block=georgianextended}', "");
    Expect(1, 7359, '\p{Block=:\Ageorgianextended\z:}', "");;
    Expect(0, 7360, '\p{Block=:\Ageorgianextended\z:}', "");;
    Expect(1, 7359, '\p{Block=- Georgian_EXTENDED}', "");
    Expect(0, 7359, '\p{^Block=- Georgian_EXTENDED}', "");
    Expect(0, 7359, '\P{Block=- Georgian_EXTENDED}', "");
    Expect(1, 7359, '\P{^Block=- Georgian_EXTENDED}', "");
    Expect(0, 7360, '\p{Block=- Georgian_EXTENDED}', "");
    Expect(1, 7360, '\p{^Block=- Georgian_EXTENDED}', "");
    Expect(1, 7360, '\P{Block=- Georgian_EXTENDED}', "");
    Expect(0, 7360, '\P{^Block=- Georgian_EXTENDED}', "");
    Error('\p{Blk=-_Georgian_EXT:=}');
    Error('\P{Blk=-_Georgian_EXT:=}');
    Expect(1, 7359, '\p{Blk=:\AGeorgian_Ext\z:}', "");;
    Expect(0, 7360, '\p{Blk=:\AGeorgian_Ext\z:}', "");;
    Expect(1, 7359, '\p{Blk=georgianext}', "");
    Expect(0, 7359, '\p{^Blk=georgianext}', "");
    Expect(0, 7359, '\P{Blk=georgianext}', "");
    Expect(1, 7359, '\P{^Blk=georgianext}', "");
    Expect(0, 7360, '\p{Blk=georgianext}', "");
    Expect(1, 7360, '\p{^Blk=georgianext}', "");
    Expect(1, 7360, '\P{Blk=georgianext}', "");
    Expect(0, 7360, '\P{^Blk=georgianext}', "");
    Expect(1, 7359, '\p{Blk=:\Ageorgianext\z:}', "");;
    Expect(0, 7360, '\p{Blk=:\Ageorgianext\z:}', "");;
    Expect(1, 7359, '\p{Blk=-	Georgian_Ext}', "");
    Expect(0, 7359, '\p{^Blk=-	Georgian_Ext}', "");
    Expect(0, 7359, '\P{Blk=-	Georgian_Ext}', "");
    Expect(1, 7359, '\P{^Blk=-	Georgian_Ext}', "");
    Expect(0, 7360, '\p{Blk=-	Georgian_Ext}', "");
    Expect(1, 7360, '\p{^Blk=-	Georgian_Ext}', "");
    Expect(1, 7360, '\P{Blk=-	Georgian_Ext}', "");
    Expect(0, 7360, '\P{^Blk=-	Georgian_Ext}', "");
    Error('\p{Is_Block=_	GEORGIAN_extended:=}');
    Error('\P{Is_Block=_	GEORGIAN_extended:=}');
    Expect(1, 7359, '\p{Is_Block:georgianextended}', "");
    Expect(0, 7359, '\p{^Is_Block:georgianextended}', "");
    Expect(0, 7359, '\P{Is_Block:georgianextended}', "");
    Expect(1, 7359, '\P{^Is_Block:georgianextended}', "");
    Expect(0, 7360, '\p{Is_Block:georgianextended}', "");
    Expect(1, 7360, '\p{^Is_Block:georgianextended}', "");
    Expect(1, 7360, '\P{Is_Block:georgianextended}', "");
    Expect(0, 7360, '\P{^Is_Block:georgianextended}', "");
    Expect(1, 7359, '\p{Is_Block=	_georgian_EXTENDED}', "");
    Expect(0, 7359, '\p{^Is_Block=	_georgian_EXTENDED}', "");
    Expect(0, 7359, '\P{Is_Block=	_georgian_EXTENDED}', "");
    Expect(1, 7359, '\P{^Is_Block=	_georgian_EXTENDED}', "");
    Expect(0, 7360, '\p{Is_Block=	_georgian_EXTENDED}', "");
    Expect(1, 7360, '\p{^Is_Block=	_georgian_EXTENDED}', "");
    Expect(1, 7360, '\P{Is_Block=	_georgian_EXTENDED}', "");
    Expect(0, 7360, '\P{^Is_Block=	_georgian_EXTENDED}', "");
    Error('\p{Is_Blk:   /a/-Georgian_Ext}');
    Error('\P{Is_Blk:   /a/-Georgian_Ext}');
    Expect(1, 7359, '\p{Is_Blk=georgianext}', "");
    Expect(0, 7359, '\p{^Is_Blk=georgianext}', "");
    Expect(0, 7359, '\P{Is_Blk=georgianext}', "");
    Expect(1, 7359, '\P{^Is_Blk=georgianext}', "");
    Expect(0, 7360, '\p{Is_Blk=georgianext}', "");
    Expect(1, 7360, '\p{^Is_Blk=georgianext}', "");
    Expect(1, 7360, '\P{Is_Blk=georgianext}', "");
    Expect(0, 7360, '\P{^Is_Blk=georgianext}', "");
    Expect(1, 7359, '\p{Is_Blk=  GEORGIAN_ext}', "");
    Expect(0, 7359, '\p{^Is_Blk=  GEORGIAN_ext}', "");
    Expect(0, 7359, '\P{Is_Blk=  GEORGIAN_ext}', "");
    Expect(1, 7359, '\P{^Is_Blk=  GEORGIAN_ext}', "");
    Expect(0, 7360, '\p{Is_Blk=  GEORGIAN_ext}', "");
    Expect(1, 7360, '\p{^Is_Blk=  GEORGIAN_ext}', "");
    Expect(1, 7360, '\P{Is_Blk=  GEORGIAN_ext}', "");
    Expect(0, 7360, '\P{^Is_Blk=  GEORGIAN_ext}', "");
    Error('\p{Block=_-Georgian_supplement:=}');
    Error('\P{Block=_-Georgian_supplement:=}');
    Expect(1, 11567, '\p{Block=:\AGeorgian_Supplement\z:}', "");;
    Expect(0, 11568, '\p{Block=:\AGeorgian_Supplement\z:}', "");;
    Expect(1, 11567, '\p{Block=georgiansupplement}', "");
    Expect(0, 11567, '\p{^Block=georgiansupplement}', "");
    Expect(0, 11567, '\P{Block=georgiansupplement}', "");
    Expect(1, 11567, '\P{^Block=georgiansupplement}', "");
    Expect(0, 11568, '\p{Block=georgiansupplement}', "");
    Expect(1, 11568, '\p{^Block=georgiansupplement}', "");
    Expect(1, 11568, '\P{Block=georgiansupplement}', "");
    Expect(0, 11568, '\P{^Block=georgiansupplement}', "");
    Expect(1, 11567, '\p{Block=:\Ageorgiansupplement\z:}', "");;
    Expect(0, 11568, '\p{Block=:\Ageorgiansupplement\z:}', "");;
    Expect(1, 11567, '\p{Block=	-georgian_SUPPLEMENT}', "");
    Expect(0, 11567, '\p{^Block=	-georgian_SUPPLEMENT}', "");
    Expect(0, 11567, '\P{Block=	-georgian_SUPPLEMENT}', "");
    Expect(1, 11567, '\P{^Block=	-georgian_SUPPLEMENT}', "");
    Expect(0, 11568, '\p{Block=	-georgian_SUPPLEMENT}', "");
    Expect(1, 11568, '\p{^Block=	-georgian_SUPPLEMENT}', "");
    Expect(1, 11568, '\P{Block=	-georgian_SUPPLEMENT}', "");
    Expect(0, 11568, '\P{^Block=	-georgian_SUPPLEMENT}', "");
    Error('\p{Blk=:= 	GEORGIAN_Sup}');
    Error('\P{Blk=:= 	GEORGIAN_Sup}');
    Expect(1, 11567, '\p{Blk=:\AGeorgian_Sup\z:}', "");;
    Expect(0, 11568, '\p{Blk=:\AGeorgian_Sup\z:}', "");;
    Expect(1, 11567, '\p{Blk=georgiansup}', "");
    Expect(0, 11567, '\p{^Blk=georgiansup}', "");
    Expect(0, 11567, '\P{Blk=georgiansup}', "");
    Expect(1, 11567, '\P{^Blk=georgiansup}', "");
    Expect(0, 11568, '\p{Blk=georgiansup}', "");
    Expect(1, 11568, '\p{^Blk=georgiansup}', "");
    Expect(1, 11568, '\P{Blk=georgiansup}', "");
    Expect(0, 11568, '\P{^Blk=georgiansup}', "");
    Expect(1, 11567, '\p{Blk=:\Ageorgiansup\z:}', "");;
    Expect(0, 11568, '\p{Blk=:\Ageorgiansup\z:}', "");;
    Expect(1, 11567, '\p{Blk=-georgian_sup}', "");
    Expect(0, 11567, '\p{^Blk=-georgian_sup}', "");
    Expect(0, 11567, '\P{Blk=-georgian_sup}', "");
    Expect(1, 11567, '\P{^Blk=-georgian_sup}', "");
    Expect(0, 11568, '\p{Blk=-georgian_sup}', "");
    Expect(1, 11568, '\p{^Blk=-georgian_sup}', "");
    Expect(1, 11568, '\P{Blk=-georgian_sup}', "");
    Expect(0, 11568, '\P{^Blk=-georgian_sup}', "");
    Error('\p{Is_Block=- GEORGIAN_SUPPLEMENT/a/}');
    Error('\P{Is_Block=- GEORGIAN_SUPPLEMENT/a/}');
    Expect(1, 11567, '\p{Is_Block=georgiansupplement}', "");
    Expect(0, 11567, '\p{^Is_Block=georgiansupplement}', "");
    Expect(0, 11567, '\P{Is_Block=georgiansupplement}', "");
    Expect(1, 11567, '\P{^Is_Block=georgiansupplement}', "");
    Expect(0, 11568, '\p{Is_Block=georgiansupplement}', "");
    Expect(1, 11568, '\p{^Is_Block=georgiansupplement}', "");
    Expect(1, 11568, '\P{Is_Block=georgiansupplement}', "");
    Expect(0, 11568, '\P{^Is_Block=georgiansupplement}', "");
    Expect(1, 11567, '\p{Is_Block=  GEORGIAN_Supplement}', "");
    Expect(0, 11567, '\p{^Is_Block=  GEORGIAN_Supplement}', "");
    Expect(0, 11567, '\P{Is_Block=  GEORGIAN_Supplement}', "");
    Expect(1, 11567, '\P{^Is_Block=  GEORGIAN_Supplement}', "");
    Expect(0, 11568, '\p{Is_Block=  GEORGIAN_Supplement}', "");
    Expect(1, 11568, '\p{^Is_Block=  GEORGIAN_Supplement}', "");
    Expect(1, 11568, '\P{Is_Block=  GEORGIAN_Supplement}', "");
    Expect(0, 11568, '\P{^Is_Block=  GEORGIAN_Supplement}', "");
    Error('\p{Is_Blk=_:=georgian_Sup}');
    Error('\P{Is_Blk=_:=georgian_Sup}');
    Expect(1, 11567, '\p{Is_Blk:   georgiansup}', "");
    Expect(0, 11567, '\p{^Is_Blk:   georgiansup}', "");
    Expect(0, 11567, '\P{Is_Blk:   georgiansup}', "");
    Expect(1, 11567, '\P{^Is_Blk:   georgiansup}', "");
    Expect(0, 11568, '\p{Is_Blk:   georgiansup}', "");
    Expect(1, 11568, '\p{^Is_Blk:   georgiansup}', "");
    Expect(1, 11568, '\P{Is_Blk:   georgiansup}', "");
    Expect(0, 11568, '\P{^Is_Blk:   georgiansup}', "");
    Expect(1, 11567, '\p{Is_Blk= _GEORGIAN_Sup}', "");
    Expect(0, 11567, '\p{^Is_Blk= _GEORGIAN_Sup}', "");
    Expect(0, 11567, '\P{Is_Blk= _GEORGIAN_Sup}', "");
    Expect(1, 11567, '\P{^Is_Blk= _GEORGIAN_Sup}', "");
    Expect(0, 11568, '\p{Is_Blk= _GEORGIAN_Sup}', "");
    Expect(1, 11568, '\p{^Is_Blk= _GEORGIAN_Sup}', "");
    Expect(1, 11568, '\P{Is_Blk= _GEORGIAN_Sup}', "");
    Expect(0, 11568, '\P{^Is_Blk= _GEORGIAN_Sup}', "");
    Error('\p{Block=-_Glagolitic:=}');
    Error('\P{Block=-_Glagolitic:=}');
    Expect(1, 11359, '\p{Block=:\AGlagolitic\z:}', "");;
    Expect(0, 11360, '\p{Block=:\AGlagolitic\z:}', "");;
    Expect(1, 11359, '\p{Block=glagolitic}', "");
    Expect(0, 11359, '\p{^Block=glagolitic}', "");
    Expect(0, 11359, '\P{Block=glagolitic}', "");
    Expect(1, 11359, '\P{^Block=glagolitic}', "");
    Expect(0, 11360, '\p{Block=glagolitic}', "");
    Expect(1, 11360, '\p{^Block=glagolitic}', "");
    Expect(1, 11360, '\P{Block=glagolitic}', "");
    Expect(0, 11360, '\P{^Block=glagolitic}', "");
    Expect(1, 11359, '\p{Block=:\Aglagolitic\z:}', "");;
    Expect(0, 11360, '\p{Block=:\Aglagolitic\z:}', "");;
    Expect(1, 11359, '\p{Block:   __Glagolitic}', "");
    Expect(0, 11359, '\p{^Block:   __Glagolitic}', "");
    Expect(0, 11359, '\P{Block:   __Glagolitic}', "");
    Expect(1, 11359, '\P{^Block:   __Glagolitic}', "");
    Expect(0, 11360, '\p{Block:   __Glagolitic}', "");
    Expect(1, 11360, '\p{^Block:   __Glagolitic}', "");
    Expect(1, 11360, '\P{Block:   __Glagolitic}', "");
    Expect(0, 11360, '\P{^Block:   __Glagolitic}', "");
    Error('\p{Blk=-	GLAGOLITIC/a/}');
    Error('\P{Blk=-	GLAGOLITIC/a/}');
    Expect(1, 11359, '\p{Blk=:\AGlagolitic\z:}', "");;
    Expect(0, 11360, '\p{Blk=:\AGlagolitic\z:}', "");;
    Expect(1, 11359, '\p{Blk=glagolitic}', "");
    Expect(0, 11359, '\p{^Blk=glagolitic}', "");
    Expect(0, 11359, '\P{Blk=glagolitic}', "");
    Expect(1, 11359, '\P{^Blk=glagolitic}', "");
    Expect(0, 11360, '\p{Blk=glagolitic}', "");
    Expect(1, 11360, '\p{^Blk=glagolitic}', "");
    Expect(1, 11360, '\P{Blk=glagolitic}', "");
    Expect(0, 11360, '\P{^Blk=glagolitic}', "");
    Expect(1, 11359, '\p{Blk=:\Aglagolitic\z:}', "");;
    Expect(0, 11360, '\p{Blk=:\Aglagolitic\z:}', "");;
    Expect(1, 11359, '\p{Blk=-Glagolitic}', "");
    Expect(0, 11359, '\p{^Blk=-Glagolitic}', "");
    Expect(0, 11359, '\P{Blk=-Glagolitic}', "");
    Expect(1, 11359, '\P{^Blk=-Glagolitic}', "");
    Expect(0, 11360, '\p{Blk=-Glagolitic}', "");
    Expect(1, 11360, '\p{^Blk=-Glagolitic}', "");
    Expect(1, 11360, '\P{Blk=-Glagolitic}', "");
    Expect(0, 11360, '\P{^Blk=-Glagolitic}', "");
    Error('\p{Is_Block=_/a/glagolitic}');
    Error('\P{Is_Block=_/a/glagolitic}');
    Expect(1, 11359, '\p{Is_Block:	glagolitic}', "");
    Expect(0, 11359, '\p{^Is_Block:	glagolitic}', "");
    Expect(0, 11359, '\P{Is_Block:	glagolitic}', "");
    Expect(1, 11359, '\P{^Is_Block:	glagolitic}', "");
    Expect(0, 11360, '\p{Is_Block:	glagolitic}', "");
    Expect(1, 11360, '\p{^Is_Block:	glagolitic}', "");
    Expect(1, 11360, '\P{Is_Block:	glagolitic}', "");
    Expect(0, 11360, '\P{^Is_Block:	glagolitic}', "");
    Expect(1, 11359, '\p{Is_Block= Glagolitic}', "");
    Expect(0, 11359, '\p{^Is_Block= Glagolitic}', "");
    Expect(0, 11359, '\P{Is_Block= Glagolitic}', "");
    Expect(1, 11359, '\P{^Is_Block= Glagolitic}', "");
    Expect(0, 11360, '\p{Is_Block= Glagolitic}', "");
    Expect(1, 11360, '\p{^Is_Block= Glagolitic}', "");
    Expect(1, 11360, '\P{Is_Block= Glagolitic}', "");
    Expect(0, 11360, '\P{^Is_Block= Glagolitic}', "");
    Error('\p{Is_Blk=	GLAGOLITIC:=}');
    Error('\P{Is_Blk=	GLAGOLITIC:=}');
    Expect(1, 11359, '\p{Is_Blk=glagolitic}', "");
    Expect(0, 11359, '\p{^Is_Blk=glagolitic}', "");
    Expect(0, 11359, '\P{Is_Blk=glagolitic}', "");
    Expect(1, 11359, '\P{^Is_Blk=glagolitic}', "");
    Expect(0, 11360, '\p{Is_Blk=glagolitic}', "");
    Expect(1, 11360, '\p{^Is_Blk=glagolitic}', "");
    Expect(1, 11360, '\P{Is_Blk=glagolitic}', "");
    Expect(0, 11360, '\P{^Is_Blk=glagolitic}', "");
    Expect(1, 11359, '\p{Is_Blk= Glagolitic}', "");
    Expect(0, 11359, '\p{^Is_Blk= Glagolitic}', "");
    Expect(0, 11359, '\P{Is_Blk= Glagolitic}', "");
    Expect(1, 11359, '\P{^Is_Blk= Glagolitic}', "");
    Expect(0, 11360, '\p{Is_Blk= Glagolitic}', "");
    Expect(1, 11360, '\p{^Is_Blk= Glagolitic}', "");
    Expect(1, 11360, '\P{Is_Blk= Glagolitic}', "");
    Expect(0, 11360, '\P{^Is_Blk= Glagolitic}', "");
    Error('\p{Block=Glagolitic_Supplement/a/}');
    Error('\P{Block=Glagolitic_Supplement/a/}');
    Expect(1, 122927, '\p{Block=:\AGlagolitic_Supplement\z:}', "");;
    Expect(0, 122928, '\p{Block=:\AGlagolitic_Supplement\z:}', "");;
    Expect(1, 122927, '\p{Block=glagoliticsupplement}', "");
    Expect(0, 122927, '\p{^Block=glagoliticsupplement}', "");
    Expect(0, 122927, '\P{Block=glagoliticsupplement}', "");
    Expect(1, 122927, '\P{^Block=glagoliticsupplement}', "");
    Expect(0, 122928, '\p{Block=glagoliticsupplement}', "");
    Expect(1, 122928, '\p{^Block=glagoliticsupplement}', "");
    Expect(1, 122928, '\P{Block=glagoliticsupplement}', "");
    Expect(0, 122928, '\P{^Block=glagoliticsupplement}', "");
    Expect(1, 122927, '\p{Block=:\Aglagoliticsupplement\z:}', "");;
    Expect(0, 122928, '\p{Block=:\Aglagoliticsupplement\z:}', "");;
    Expect(1, 122927, '\p{Block=__Glagolitic_Supplement}', "");
    Expect(0, 122927, '\p{^Block=__Glagolitic_Supplement}', "");
    Expect(0, 122927, '\P{Block=__Glagolitic_Supplement}', "");
    Expect(1, 122927, '\P{^Block=__Glagolitic_Supplement}', "");
    Expect(0, 122928, '\p{Block=__Glagolitic_Supplement}', "");
    Expect(1, 122928, '\p{^Block=__Glagolitic_Supplement}', "");
    Expect(1, 122928, '\P{Block=__Glagolitic_Supplement}', "");
    Expect(0, 122928, '\P{^Block=__Glagolitic_Supplement}', "");
    Error('\p{Blk=:=		Glagolitic_Sup}');
    Error('\P{Blk=:=		Glagolitic_Sup}');
    Expect(1, 122927, '\p{Blk=:\AGlagolitic_Sup\z:}', "");;
    Expect(0, 122928, '\p{Blk=:\AGlagolitic_Sup\z:}', "");;
    Expect(1, 122927, '\p{Blk=glagoliticsup}', "");
    Expect(0, 122927, '\p{^Blk=glagoliticsup}', "");
    Expect(0, 122927, '\P{Blk=glagoliticsup}', "");
    Expect(1, 122927, '\P{^Blk=glagoliticsup}', "");
    Expect(0, 122928, '\p{Blk=glagoliticsup}', "");
    Expect(1, 122928, '\p{^Blk=glagoliticsup}', "");
    Expect(1, 122928, '\P{Blk=glagoliticsup}', "");
    Expect(0, 122928, '\P{^Blk=glagoliticsup}', "");
    Expect(1, 122927, '\p{Blk=:\Aglagoliticsup\z:}', "");;
    Expect(0, 122928, '\p{Blk=:\Aglagoliticsup\z:}', "");;
    Expect(1, 122927, '\p{Blk=	Glagolitic_Sup}', "");
    Expect(0, 122927, '\p{^Blk=	Glagolitic_Sup}', "");
    Expect(0, 122927, '\P{Blk=	Glagolitic_Sup}', "");
    Expect(1, 122927, '\P{^Blk=	Glagolitic_Sup}', "");
    Expect(0, 122928, '\p{Blk=	Glagolitic_Sup}', "");
    Expect(1, 122928, '\p{^Blk=	Glagolitic_Sup}', "");
    Expect(1, 122928, '\P{Blk=	Glagolitic_Sup}', "");
    Expect(0, 122928, '\P{^Blk=	Glagolitic_Sup}', "");
    Error('\p{Is_Block=Glagolitic_SUPPLEMENT:=}');
    Error('\P{Is_Block=Glagolitic_SUPPLEMENT:=}');
    Expect(1, 122927, '\p{Is_Block=glagoliticsupplement}', "");
    Expect(0, 122927, '\p{^Is_Block=glagoliticsupplement}', "");
    Expect(0, 122927, '\P{Is_Block=glagoliticsupplement}', "");
    Expect(1, 122927, '\P{^Is_Block=glagoliticsupplement}', "");
    Expect(0, 122928, '\p{Is_Block=glagoliticsupplement}', "");
    Expect(1, 122928, '\p{^Is_Block=glagoliticsupplement}', "");
    Expect(1, 122928, '\P{Is_Block=glagoliticsupplement}', "");
    Expect(0, 122928, '\P{^Is_Block=glagoliticsupplement}', "");
    Expect(1, 122927, '\p{Is_Block:   -glagolitic_SUPPLEMENT}', "");
    Expect(0, 122927, '\p{^Is_Block:   -glagolitic_SUPPLEMENT}', "");
    Expect(0, 122927, '\P{Is_Block:   -glagolitic_SUPPLEMENT}', "");
    Expect(1, 122927, '\P{^Is_Block:   -glagolitic_SUPPLEMENT}', "");
    Expect(0, 122928, '\p{Is_Block:   -glagolitic_SUPPLEMENT}', "");
    Expect(1, 122928, '\p{^Is_Block:   -glagolitic_SUPPLEMENT}', "");
    Expect(1, 122928, '\P{Is_Block:   -glagolitic_SUPPLEMENT}', "");
    Expect(0, 122928, '\P{^Is_Block:   -glagolitic_SUPPLEMENT}', "");
    Error('\p{Is_Blk=/a/GLAGOLITIC_SUP}');
    Error('\P{Is_Blk=/a/GLAGOLITIC_SUP}');
    Expect(1, 122927, '\p{Is_Blk=glagoliticsup}', "");
    Expect(0, 122927, '\p{^Is_Blk=glagoliticsup}', "");
    Expect(0, 122927, '\P{Is_Blk=glagoliticsup}', "");
    Expect(1, 122927, '\P{^Is_Blk=glagoliticsup}', "");
    Expect(0, 122928, '\p{Is_Blk=glagoliticsup}', "");
    Expect(1, 122928, '\p{^Is_Blk=glagoliticsup}', "");
    Expect(1, 122928, '\P{Is_Blk=glagoliticsup}', "");
    Expect(0, 122928, '\P{^Is_Blk=glagoliticsup}', "");
    Expect(1, 122927, '\p{Is_Blk=-Glagolitic_sup}', "");
    Expect(0, 122927, '\p{^Is_Blk=-Glagolitic_sup}', "");
    Expect(0, 122927, '\P{Is_Blk=-Glagolitic_sup}', "");
    Expect(1, 122927, '\P{^Is_Blk=-Glagolitic_sup}', "");
    Expect(0, 122928, '\p{Is_Blk=-Glagolitic_sup}', "");
    Expect(1, 122928, '\p{^Is_Blk=-Glagolitic_sup}', "");
    Expect(1, 122928, '\P{Is_Blk=-Glagolitic_sup}', "");
    Expect(0, 122928, '\P{^Is_Blk=-Glagolitic_sup}', "");
    Error('\p{Block=		Gothic:=}');
    Error('\P{Block=		Gothic:=}');
    Expect(1, 66383, '\p{Block=:\AGothic\z:}', "");;
    Expect(0, 66384, '\p{Block=:\AGothic\z:}', "");;
    Expect(1, 66383, '\p{Block=gothic}', "");
    Expect(0, 66383, '\p{^Block=gothic}', "");
    Expect(0, 66383, '\P{Block=gothic}', "");
    Expect(1, 66383, '\P{^Block=gothic}', "");
    Expect(0, 66384, '\p{Block=gothic}', "");
    Expect(1, 66384, '\p{^Block=gothic}', "");
    Expect(1, 66384, '\P{Block=gothic}', "");
    Expect(0, 66384, '\P{^Block=gothic}', "");
    Expect(1, 66383, '\p{Block=:\Agothic\z:}', "");;
    Expect(0, 66384, '\p{Block=:\Agothic\z:}', "");;
    Expect(1, 66383, '\p{Block=_Gothic}', "");
    Expect(0, 66383, '\p{^Block=_Gothic}', "");
    Expect(0, 66383, '\P{Block=_Gothic}', "");
    Expect(1, 66383, '\P{^Block=_Gothic}', "");
    Expect(0, 66384, '\p{Block=_Gothic}', "");
    Expect(1, 66384, '\p{^Block=_Gothic}', "");
    Expect(1, 66384, '\P{Block=_Gothic}', "");
    Expect(0, 66384, '\P{^Block=_Gothic}', "");
    Error('\p{Blk=:=-Gothic}');
    Error('\P{Blk=:=-Gothic}');
    Expect(1, 66383, '\p{Blk=:\AGothic\z:}', "");;
    Expect(0, 66384, '\p{Blk=:\AGothic\z:}', "");;
    Expect(1, 66383, '\p{Blk=gothic}', "");
    Expect(0, 66383, '\p{^Blk=gothic}', "");
    Expect(0, 66383, '\P{Blk=gothic}', "");
    Expect(1, 66383, '\P{^Blk=gothic}', "");
    Expect(0, 66384, '\p{Blk=gothic}', "");
    Expect(1, 66384, '\p{^Blk=gothic}', "");
    Expect(1, 66384, '\P{Blk=gothic}', "");
    Expect(0, 66384, '\P{^Blk=gothic}', "");
    Expect(1, 66383, '\p{Blk=:\Agothic\z:}', "");;
    Expect(0, 66384, '\p{Blk=:\Agothic\z:}', "");;
    Expect(1, 66383, '\p{Blk=	Gothic}', "");
    Expect(0, 66383, '\p{^Blk=	Gothic}', "");
    Expect(0, 66383, '\P{Blk=	Gothic}', "");
    Expect(1, 66383, '\P{^Blk=	Gothic}', "");
    Expect(0, 66384, '\p{Blk=	Gothic}', "");
    Expect(1, 66384, '\p{^Blk=	Gothic}', "");
    Expect(1, 66384, '\P{Blk=	Gothic}', "");
    Expect(0, 66384, '\P{^Blk=	Gothic}', "");
    Error('\p{Is_Block=	_Gothic/a/}');
    Error('\P{Is_Block=	_Gothic/a/}');
    Expect(1, 66383, '\p{Is_Block: gothic}', "");
    Expect(0, 66383, '\p{^Is_Block: gothic}', "");
    Expect(0, 66383, '\P{Is_Block: gothic}', "");
    Expect(1, 66383, '\P{^Is_Block: gothic}', "");
    Expect(0, 66384, '\p{Is_Block: gothic}', "");
    Expect(1, 66384, '\p{^Is_Block: gothic}', "");
    Expect(1, 66384, '\P{Is_Block: gothic}', "");
    Expect(0, 66384, '\P{^Is_Block: gothic}', "");
    Expect(1, 66383, '\p{Is_Block=	 gothic}', "");
    Expect(0, 66383, '\p{^Is_Block=	 gothic}', "");
    Expect(0, 66383, '\P{Is_Block=	 gothic}', "");
    Expect(1, 66383, '\P{^Is_Block=	 gothic}', "");
    Expect(0, 66384, '\p{Is_Block=	 gothic}', "");
    Expect(1, 66384, '\p{^Is_Block=	 gothic}', "");
    Expect(1, 66384, '\P{Is_Block=	 gothic}', "");
    Expect(0, 66384, '\P{^Is_Block=	 gothic}', "");
    Error('\p{Is_Blk=:=-gothic}');
    Error('\P{Is_Blk=:=-gothic}');
    Expect(1, 66383, '\p{Is_Blk=gothic}', "");
    Expect(0, 66383, '\p{^Is_Blk=gothic}', "");
    Expect(0, 66383, '\P{Is_Blk=gothic}', "");
    Expect(1, 66383, '\P{^Is_Blk=gothic}', "");
    Expect(0, 66384, '\p{Is_Blk=gothic}', "");
    Expect(1, 66384, '\p{^Is_Blk=gothic}', "");
    Expect(1, 66384, '\P{Is_Blk=gothic}', "");
    Expect(0, 66384, '\P{^Is_Blk=gothic}', "");
    Expect(1, 66383, '\p{Is_Blk=		Gothic}', "");
    Expect(0, 66383, '\p{^Is_Blk=		Gothic}', "");
    Expect(0, 66383, '\P{Is_Blk=		Gothic}', "");
    Expect(1, 66383, '\P{^Is_Blk=		Gothic}', "");
    Expect(0, 66384, '\p{Is_Blk=		Gothic}', "");
    Expect(1, 66384, '\p{^Is_Blk=		Gothic}', "");
    Expect(1, 66384, '\P{Is_Blk=		Gothic}', "");
    Expect(0, 66384, '\P{^Is_Blk=		Gothic}', "");
    Error('\p{Block=/a/__GRANTHA}');
    Error('\P{Block=/a/__GRANTHA}');
    Expect(1, 70527, '\p{Block=:\AGrantha\z:}', "");;
    Expect(0, 70528, '\p{Block=:\AGrantha\z:}', "");;
    Expect(1, 70527, '\p{Block=grantha}', "");
    Expect(0, 70527, '\p{^Block=grantha}', "");
    Expect(0, 70527, '\P{Block=grantha}', "");
    Expect(1, 70527, '\P{^Block=grantha}', "");
    Expect(0, 70528, '\p{Block=grantha}', "");
    Expect(1, 70528, '\p{^Block=grantha}', "");
    Expect(1, 70528, '\P{Block=grantha}', "");
    Expect(0, 70528, '\P{^Block=grantha}', "");
    Expect(1, 70527, '\p{Block=:\Agrantha\z:}', "");;
    Expect(0, 70528, '\p{Block=:\Agrantha\z:}', "");;
    Expect(1, 70527, '\p{Block=_	Grantha}', "");
    Expect(0, 70527, '\p{^Block=_	Grantha}', "");
    Expect(0, 70527, '\P{Block=_	Grantha}', "");
    Expect(1, 70527, '\P{^Block=_	Grantha}', "");
    Expect(0, 70528, '\p{Block=_	Grantha}', "");
    Expect(1, 70528, '\p{^Block=_	Grantha}', "");
    Expect(1, 70528, '\P{Block=_	Grantha}', "");
    Expect(0, 70528, '\P{^Block=_	Grantha}', "");
    Error('\p{Blk=--Grantha/a/}');
    Error('\P{Blk=--Grantha/a/}');
    Expect(1, 70527, '\p{Blk=:\AGrantha\z:}', "");;
    Expect(0, 70528, '\p{Blk=:\AGrantha\z:}', "");;
    Expect(1, 70527, '\p{Blk: grantha}', "");
    Expect(0, 70527, '\p{^Blk: grantha}', "");
    Expect(0, 70527, '\P{Blk: grantha}', "");
    Expect(1, 70527, '\P{^Blk: grantha}', "");
    Expect(0, 70528, '\p{Blk: grantha}', "");
    Expect(1, 70528, '\p{^Blk: grantha}', "");
    Expect(1, 70528, '\P{Blk: grantha}', "");
    Expect(0, 70528, '\P{^Blk: grantha}', "");
    Expect(1, 70527, '\p{Blk=:\Agrantha\z:}', "");;
    Expect(0, 70528, '\p{Blk=:\Agrantha\z:}', "");;
    Expect(1, 70527, '\p{Blk=-_Grantha}', "");
    Expect(0, 70527, '\p{^Blk=-_Grantha}', "");
    Expect(0, 70527, '\P{Blk=-_Grantha}', "");
    Expect(1, 70527, '\P{^Blk=-_Grantha}', "");
    Expect(0, 70528, '\p{Blk=-_Grantha}', "");
    Expect(1, 70528, '\p{^Blk=-_Grantha}', "");
    Expect(1, 70528, '\P{Blk=-_Grantha}', "");
    Expect(0, 70528, '\P{^Blk=-_Grantha}', "");
    Error('\p{Is_Block:	/a/ 	Grantha}');
    Error('\P{Is_Block:	/a/ 	Grantha}');
    Expect(1, 70527, '\p{Is_Block=grantha}', "");
    Expect(0, 70527, '\p{^Is_Block=grantha}', "");
    Expect(0, 70527, '\P{Is_Block=grantha}', "");
    Expect(1, 70527, '\P{^Is_Block=grantha}', "");
    Expect(0, 70528, '\p{Is_Block=grantha}', "");
    Expect(1, 70528, '\p{^Is_Block=grantha}', "");
    Expect(1, 70528, '\P{Is_Block=grantha}', "");
    Expect(0, 70528, '\P{^Is_Block=grantha}', "");
    Expect(1, 70527, '\p{Is_Block=-	Grantha}', "");
    Expect(0, 70527, '\p{^Is_Block=-	Grantha}', "");
    Expect(0, 70527, '\P{Is_Block=-	Grantha}', "");
    Expect(1, 70527, '\P{^Is_Block=-	Grantha}', "");
    Expect(0, 70528, '\p{Is_Block=-	Grantha}', "");
    Expect(1, 70528, '\p{^Is_Block=-	Grantha}', "");
    Expect(1, 70528, '\P{Is_Block=-	Grantha}', "");
    Expect(0, 70528, '\P{^Is_Block=-	Grantha}', "");
    Error('\p{Is_Blk=  Grantha:=}');
    Error('\P{Is_Blk=  Grantha:=}');
    Expect(1, 70527, '\p{Is_Blk=grantha}', "");
    Expect(0, 70527, '\p{^Is_Blk=grantha}', "");
    Expect(0, 70527, '\P{Is_Blk=grantha}', "");
    Expect(1, 70527, '\P{^Is_Blk=grantha}', "");
    Expect(0, 70528, '\p{Is_Blk=grantha}', "");
    Expect(1, 70528, '\p{^Is_Blk=grantha}', "");
    Expect(1, 70528, '\P{Is_Blk=grantha}', "");
    Expect(0, 70528, '\P{^Is_Blk=grantha}', "");
    Expect(1, 70527, '\p{Is_Blk=	 GRANTHA}', "");
    Expect(0, 70527, '\p{^Is_Blk=	 GRANTHA}', "");
    Expect(0, 70527, '\P{Is_Blk=	 GRANTHA}', "");
    Expect(1, 70527, '\P{^Is_Blk=	 GRANTHA}', "");
    Expect(0, 70528, '\p{Is_Blk=	 GRANTHA}', "");
    Expect(1, 70528, '\p{^Is_Blk=	 GRANTHA}', "");
    Expect(1, 70528, '\P{Is_Blk=	 GRANTHA}', "");
    Expect(0, 70528, '\P{^Is_Blk=	 GRANTHA}', "");
    Error('\p{Block=_GREEK_And_coptic:=}');
    Error('\P{Block=_GREEK_And_coptic:=}');
    Expect(1, 1023, '\p{Block=:\AGreek_And_Coptic\z:}', "");;
    Expect(0, 1024, '\p{Block=:\AGreek_And_Coptic\z:}', "");;
    Expect(1, 1023, '\p{Block=greekandcoptic}', "");
    Expect(0, 1023, '\p{^Block=greekandcoptic}', "");
    Expect(0, 1023, '\P{Block=greekandcoptic}', "");
    Expect(1, 1023, '\P{^Block=greekandcoptic}', "");
    Expect(0, 1024, '\p{Block=greekandcoptic}', "");
    Expect(1, 1024, '\p{^Block=greekandcoptic}', "");
    Expect(1, 1024, '\P{Block=greekandcoptic}', "");
    Expect(0, 1024, '\P{^Block=greekandcoptic}', "");
    Expect(1, 1023, '\p{Block=:\Agreekandcoptic\z:}', "");;
    Expect(0, 1024, '\p{Block=:\Agreekandcoptic\z:}', "");;
    Expect(1, 1023, '\p{Block= Greek_And_coptic}', "");
    Expect(0, 1023, '\p{^Block= Greek_And_coptic}', "");
    Expect(0, 1023, '\P{Block= Greek_And_coptic}', "");
    Expect(1, 1023, '\P{^Block= Greek_And_coptic}', "");
    Expect(0, 1024, '\p{Block= Greek_And_coptic}', "");
    Expect(1, 1024, '\p{^Block= Greek_And_coptic}', "");
    Expect(1, 1024, '\P{Block= Greek_And_coptic}', "");
    Expect(0, 1024, '\P{^Block= Greek_And_coptic}', "");
    Error('\p{Blk=:=- Greek}');
    Error('\P{Blk=:=- Greek}');
    Expect(1, 1023, '\p{Blk=:\AGreek\z:}', "");;
    Expect(0, 1024, '\p{Blk=:\AGreek\z:}', "");;
    Expect(1, 1023, '\p{Blk=greek}', "");
    Expect(0, 1023, '\p{^Blk=greek}', "");
    Expect(0, 1023, '\P{Blk=greek}', "");
    Expect(1, 1023, '\P{^Blk=greek}', "");
    Expect(0, 1024, '\p{Blk=greek}', "");
    Expect(1, 1024, '\p{^Blk=greek}', "");
    Expect(1, 1024, '\P{Blk=greek}', "");
    Expect(0, 1024, '\P{^Blk=greek}', "");
    Expect(1, 1023, '\p{Blk=:\Agreek\z:}', "");;
    Expect(0, 1024, '\p{Blk=:\Agreek\z:}', "");;
    Expect(1, 1023, '\p{Blk= _GREEK}', "");
    Expect(0, 1023, '\p{^Blk= _GREEK}', "");
    Expect(0, 1023, '\P{Blk= _GREEK}', "");
    Expect(1, 1023, '\P{^Blk= _GREEK}', "");
    Expect(0, 1024, '\p{Blk= _GREEK}', "");
    Expect(1, 1024, '\p{^Blk= _GREEK}', "");
    Expect(1, 1024, '\P{Blk= _GREEK}', "");
    Expect(0, 1024, '\P{^Blk= _GREEK}', "");
    Error('\p{Is_Block: /a/greek_And_COPTIC}');
    Error('\P{Is_Block: /a/greek_And_COPTIC}');
    Expect(1, 1023, '\p{Is_Block=greekandcoptic}', "");
    Expect(0, 1023, '\p{^Is_Block=greekandcoptic}', "");
    Expect(0, 1023, '\P{Is_Block=greekandcoptic}', "");
    Expect(1, 1023, '\P{^Is_Block=greekandcoptic}', "");
    Expect(0, 1024, '\p{Is_Block=greekandcoptic}', "");
    Expect(1, 1024, '\p{^Is_Block=greekandcoptic}', "");
    Expect(1, 1024, '\P{Is_Block=greekandcoptic}', "");
    Expect(0, 1024, '\P{^Is_Block=greekandcoptic}', "");
    Expect(1, 1023, '\p{Is_Block=-	greek_And_Coptic}', "");
    Expect(0, 1023, '\p{^Is_Block=-	greek_And_Coptic}', "");
    Expect(0, 1023, '\P{Is_Block=-	greek_And_Coptic}', "");
    Expect(1, 1023, '\P{^Is_Block=-	greek_And_Coptic}', "");
    Expect(0, 1024, '\p{Is_Block=-	greek_And_Coptic}', "");
    Expect(1, 1024, '\p{^Is_Block=-	greek_And_Coptic}', "");
    Expect(1, 1024, '\P{Is_Block=-	greek_And_Coptic}', "");
    Expect(0, 1024, '\P{^Is_Block=-	greek_And_Coptic}', "");
    Error('\p{Is_Blk:		greek/a/}');
    Error('\P{Is_Blk:		greek/a/}');
    Expect(1, 1023, '\p{Is_Blk: greek}', "");
    Expect(0, 1023, '\p{^Is_Blk: greek}', "");
    Expect(0, 1023, '\P{Is_Blk: greek}', "");
    Expect(1, 1023, '\P{^Is_Blk: greek}', "");
    Expect(0, 1024, '\p{Is_Blk: greek}', "");
    Expect(1, 1024, '\p{^Is_Blk: greek}', "");
    Expect(1, 1024, '\P{Is_Blk: greek}', "");
    Expect(0, 1024, '\P{^Is_Blk: greek}', "");
    Expect(1, 1023, '\p{Is_Blk=  Greek}', "");
    Expect(0, 1023, '\p{^Is_Blk=  Greek}', "");
    Expect(0, 1023, '\P{Is_Blk=  Greek}', "");
    Expect(1, 1023, '\P{^Is_Blk=  Greek}', "");
    Expect(0, 1024, '\p{Is_Blk=  Greek}', "");
    Expect(1, 1024, '\p{^Is_Blk=  Greek}', "");
    Expect(1, 1024, '\P{Is_Blk=  Greek}', "");
    Expect(0, 1024, '\P{^Is_Blk=  Greek}', "");
    Error('\p{Block= :=Greek_EXTENDED}');
    Error('\P{Block= :=Greek_EXTENDED}');
    Expect(1, 8191, '\p{Block=:\AGreek_Extended\z:}', "");;
    Expect(0, 8192, '\p{Block=:\AGreek_Extended\z:}', "");;
    Expect(1, 8191, '\p{Block=greekextended}', "");
    Expect(0, 8191, '\p{^Block=greekextended}', "");
    Expect(0, 8191, '\P{Block=greekextended}', "");
    Expect(1, 8191, '\P{^Block=greekextended}', "");
    Expect(0, 8192, '\p{Block=greekextended}', "");
    Expect(1, 8192, '\p{^Block=greekextended}', "");
    Expect(1, 8192, '\P{Block=greekextended}', "");
    Expect(0, 8192, '\P{^Block=greekextended}', "");
    Expect(1, 8191, '\p{Block=:\Agreekextended\z:}', "");;
    Expect(0, 8192, '\p{Block=:\Agreekextended\z:}', "");;
    Expect(1, 8191, '\p{Block=	 greek_EXTENDED}', "");
    Expect(0, 8191, '\p{^Block=	 greek_EXTENDED}', "");
    Expect(0, 8191, '\P{Block=	 greek_EXTENDED}', "");
    Expect(1, 8191, '\P{^Block=	 greek_EXTENDED}', "");
    Expect(0, 8192, '\p{Block=	 greek_EXTENDED}', "");
    Expect(1, 8192, '\p{^Block=	 greek_EXTENDED}', "");
    Expect(1, 8192, '\P{Block=	 greek_EXTENDED}', "");
    Expect(0, 8192, '\P{^Block=	 greek_EXTENDED}', "");
    Error('\p{Blk= -Greek_Ext/a/}');
    Error('\P{Blk= -Greek_Ext/a/}');
    Expect(1, 8191, '\p{Blk=:\AGreek_Ext\z:}', "");;
    Expect(0, 8192, '\p{Blk=:\AGreek_Ext\z:}', "");;
    Expect(1, 8191, '\p{Blk=greekext}', "");
    Expect(0, 8191, '\p{^Blk=greekext}', "");
    Expect(0, 8191, '\P{Blk=greekext}', "");
    Expect(1, 8191, '\P{^Blk=greekext}', "");
    Expect(0, 8192, '\p{Blk=greekext}', "");
    Expect(1, 8192, '\p{^Blk=greekext}', "");
    Expect(1, 8192, '\P{Blk=greekext}', "");
    Expect(0, 8192, '\P{^Blk=greekext}', "");
    Expect(1, 8191, '\p{Blk=:\Agreekext\z:}', "");;
    Expect(0, 8192, '\p{Blk=:\Agreekext\z:}', "");;
    Expect(1, 8191, '\p{Blk=-_Greek_ext}', "");
    Expect(0, 8191, '\p{^Blk=-_Greek_ext}', "");
    Expect(0, 8191, '\P{Blk=-_Greek_ext}', "");
    Expect(1, 8191, '\P{^Blk=-_Greek_ext}', "");
    Expect(0, 8192, '\p{Blk=-_Greek_ext}', "");
    Expect(1, 8192, '\p{^Blk=-_Greek_ext}', "");
    Expect(1, 8192, '\P{Blk=-_Greek_ext}', "");
    Expect(0, 8192, '\P{^Blk=-_Greek_ext}', "");
    Error('\p{Is_Block=:= Greek_extended}');
    Error('\P{Is_Block=:= Greek_extended}');
    Expect(1, 8191, '\p{Is_Block=greekextended}', "");
    Expect(0, 8191, '\p{^Is_Block=greekextended}', "");
    Expect(0, 8191, '\P{Is_Block=greekextended}', "");
    Expect(1, 8191, '\P{^Is_Block=greekextended}', "");
    Expect(0, 8192, '\p{Is_Block=greekextended}', "");
    Expect(1, 8192, '\p{^Is_Block=greekextended}', "");
    Expect(1, 8192, '\P{Is_Block=greekextended}', "");
    Expect(0, 8192, '\P{^Is_Block=greekextended}', "");
    Expect(1, 8191, '\p{Is_Block=_Greek_extended}', "");
    Expect(0, 8191, '\p{^Is_Block=_Greek_extended}', "");
    Expect(0, 8191, '\P{Is_Block=_Greek_extended}', "");
    Expect(1, 8191, '\P{^Is_Block=_Greek_extended}', "");
    Expect(0, 8192, '\p{Is_Block=_Greek_extended}', "");
    Expect(1, 8192, '\p{^Is_Block=_Greek_extended}', "");
    Expect(1, 8192, '\P{Is_Block=_Greek_extended}', "");
    Expect(0, 8192, '\P{^Is_Block=_Greek_extended}', "");
    Error('\p{Is_Blk=/a/GREEK_Ext}');
    Error('\P{Is_Blk=/a/GREEK_Ext}');
    Expect(1, 8191, '\p{Is_Blk=greekext}', "");
    Expect(0, 8191, '\p{^Is_Blk=greekext}', "");
    Expect(0, 8191, '\P{Is_Blk=greekext}', "");
    Expect(1, 8191, '\P{^Is_Blk=greekext}', "");
    Expect(0, 8192, '\p{Is_Blk=greekext}', "");
    Expect(1, 8192, '\p{^Is_Blk=greekext}', "");
    Expect(1, 8192, '\P{Is_Blk=greekext}', "");
    Expect(0, 8192, '\P{^Is_Blk=greekext}', "");
    Expect(1, 8191, '\p{Is_Blk:   	GREEK_ext}', "");
    Expect(0, 8191, '\p{^Is_Blk:   	GREEK_ext}', "");
    Expect(0, 8191, '\P{Is_Blk:   	GREEK_ext}', "");
    Expect(1, 8191, '\P{^Is_Blk:   	GREEK_ext}', "");
    Expect(0, 8192, '\p{Is_Blk:   	GREEK_ext}', "");
    Expect(1, 8192, '\p{^Is_Blk:   	GREEK_ext}', "");
    Expect(1, 8192, '\P{Is_Blk:   	GREEK_ext}', "");
    Expect(0, 8192, '\P{^Is_Blk:   	GREEK_ext}', "");
    Error('\p{Block=:=	_Gujarati}');
    Error('\P{Block=:=	_Gujarati}');
    Expect(1, 2815, '\p{Block=:\AGujarati\z:}', "");;
    Expect(0, 2816, '\p{Block=:\AGujarati\z:}', "");;
    Expect(1, 2815, '\p{Block=gujarati}', "");
    Expect(0, 2815, '\p{^Block=gujarati}', "");
    Expect(0, 2815, '\P{Block=gujarati}', "");
    Expect(1, 2815, '\P{^Block=gujarati}', "");
    Expect(0, 2816, '\p{Block=gujarati}', "");
    Expect(1, 2816, '\p{^Block=gujarati}', "");
    Expect(1, 2816, '\P{Block=gujarati}', "");
    Expect(0, 2816, '\P{^Block=gujarati}', "");
    Expect(1, 2815, '\p{Block=:\Agujarati\z:}', "");;
    Expect(0, 2816, '\p{Block=:\Agujarati\z:}', "");;
    Expect(1, 2815, '\p{Block=- gujarati}', "");
    Expect(0, 2815, '\p{^Block=- gujarati}', "");
    Expect(0, 2815, '\P{Block=- gujarati}', "");
    Expect(1, 2815, '\P{^Block=- gujarati}', "");
    Expect(0, 2816, '\p{Block=- gujarati}', "");
    Expect(1, 2816, '\p{^Block=- gujarati}', "");
    Expect(1, 2816, '\P{Block=- gujarati}', "");
    Expect(0, 2816, '\P{^Block=- gujarati}', "");
    Error('\p{Blk=--gujarati/a/}');
    Error('\P{Blk=--gujarati/a/}');
    Expect(1, 2815, '\p{Blk=:\AGujarati\z:}', "");;
    Expect(0, 2816, '\p{Blk=:\AGujarati\z:}', "");;
    Expect(1, 2815, '\p{Blk=gujarati}', "");
    Expect(0, 2815, '\p{^Blk=gujarati}', "");
    Expect(0, 2815, '\P{Blk=gujarati}', "");
    Expect(1, 2815, '\P{^Blk=gujarati}', "");
    Expect(0, 2816, '\p{Blk=gujarati}', "");
    Expect(1, 2816, '\p{^Blk=gujarati}', "");
    Expect(1, 2816, '\P{Blk=gujarati}', "");
    Expect(0, 2816, '\P{^Blk=gujarati}', "");
    Expect(1, 2815, '\p{Blk=:\Agujarati\z:}', "");;
    Expect(0, 2816, '\p{Blk=:\Agujarati\z:}', "");;
    Expect(1, 2815, '\p{Blk=	-GUJARATI}', "");
    Expect(0, 2815, '\p{^Blk=	-GUJARATI}', "");
    Expect(0, 2815, '\P{Blk=	-GUJARATI}', "");
    Expect(1, 2815, '\P{^Blk=	-GUJARATI}', "");
    Expect(0, 2816, '\p{Blk=	-GUJARATI}', "");
    Expect(1, 2816, '\p{^Blk=	-GUJARATI}', "");
    Expect(1, 2816, '\P{Blk=	-GUJARATI}', "");
    Expect(0, 2816, '\P{^Blk=	-GUJARATI}', "");
    Error('\p{Is_Block=:=	Gujarati}');
    Error('\P{Is_Block=:=	Gujarati}');
    Expect(1, 2815, '\p{Is_Block=gujarati}', "");
    Expect(0, 2815, '\p{^Is_Block=gujarati}', "");
    Expect(0, 2815, '\P{Is_Block=gujarati}', "");
    Expect(1, 2815, '\P{^Is_Block=gujarati}', "");
    Expect(0, 2816, '\p{Is_Block=gujarati}', "");
    Expect(1, 2816, '\p{^Is_Block=gujarati}', "");
    Expect(1, 2816, '\P{Is_Block=gujarati}', "");
    Expect(0, 2816, '\P{^Is_Block=gujarati}', "");
    Error('\p{Is_Blk=:=	 GUJARATI}');
    Error('\P{Is_Blk=:=	 GUJARATI}');
    Expect(1, 2815, '\p{Is_Blk=gujarati}', "");
    Expect(0, 2815, '\p{^Is_Blk=gujarati}', "");
    Expect(0, 2815, '\P{Is_Blk=gujarati}', "");
    Expect(1, 2815, '\P{^Is_Blk=gujarati}', "");
    Expect(0, 2816, '\p{Is_Blk=gujarati}', "");
    Expect(1, 2816, '\p{^Is_Blk=gujarati}', "");
    Expect(1, 2816, '\P{Is_Blk=gujarati}', "");
    Expect(0, 2816, '\P{^Is_Blk=gujarati}', "");
    Expect(1, 2815, '\p{Is_Blk= Gujarati}', "");
    Expect(0, 2815, '\p{^Is_Blk= Gujarati}', "");
    Expect(0, 2815, '\P{Is_Blk= Gujarati}', "");
    Expect(1, 2815, '\P{^Is_Blk= Gujarati}', "");
    Expect(0, 2816, '\p{Is_Blk= Gujarati}', "");
    Expect(1, 2816, '\p{^Is_Blk= Gujarati}', "");
    Expect(1, 2816, '\P{Is_Blk= Gujarati}', "");
    Expect(0, 2816, '\P{^Is_Blk= Gujarati}', "");
    Error('\p{Block=/a/  Gunjala_gondi}');
    Error('\P{Block=/a/  Gunjala_gondi}');
    Expect(1, 73135, '\p{Block=:\AGunjala_Gondi\z:}', "");;
    Expect(0, 73136, '\p{Block=:\AGunjala_Gondi\z:}', "");;
    Expect(1, 73135, '\p{Block:	gunjalagondi}', "");
    Expect(0, 73135, '\p{^Block:	gunjalagondi}', "");
    Expect(0, 73135, '\P{Block:	gunjalagondi}', "");
    Expect(1, 73135, '\P{^Block:	gunjalagondi}', "");
    Expect(0, 73136, '\p{Block:	gunjalagondi}', "");
    Expect(1, 73136, '\p{^Block:	gunjalagondi}', "");
    Expect(1, 73136, '\P{Block:	gunjalagondi}', "");
    Expect(0, 73136, '\P{^Block:	gunjalagondi}', "");
    Expect(1, 73135, '\p{Block=:\Agunjalagondi\z:}', "");;
    Expect(0, 73136, '\p{Block=:\Agunjalagondi\z:}', "");;
    Expect(1, 73135, '\p{Block:    Gunjala_Gondi}', "");
    Expect(0, 73135, '\p{^Block:    Gunjala_Gondi}', "");
    Expect(0, 73135, '\P{Block:    Gunjala_Gondi}', "");
    Expect(1, 73135, '\P{^Block:    Gunjala_Gondi}', "");
    Expect(0, 73136, '\p{Block:    Gunjala_Gondi}', "");
    Expect(1, 73136, '\p{^Block:    Gunjala_Gondi}', "");
    Expect(1, 73136, '\P{Block:    Gunjala_Gondi}', "");
    Expect(0, 73136, '\P{^Block:    Gunjala_Gondi}', "");
    Error('\p{Blk=-	Gunjala_GONDI/a/}');
    Error('\P{Blk=-	Gunjala_GONDI/a/}');
    Expect(1, 73135, '\p{Blk=:\AGunjala_Gondi\z:}', "");;
    Expect(0, 73136, '\p{Blk=:\AGunjala_Gondi\z:}', "");;
    Expect(1, 73135, '\p{Blk=gunjalagondi}', "");
    Expect(0, 73135, '\p{^Blk=gunjalagondi}', "");
    Expect(0, 73135, '\P{Blk=gunjalagondi}', "");
    Expect(1, 73135, '\P{^Blk=gunjalagondi}', "");
    Expect(0, 73136, '\p{Blk=gunjalagondi}', "");
    Expect(1, 73136, '\p{^Blk=gunjalagondi}', "");
    Expect(1, 73136, '\P{Blk=gunjalagondi}', "");
    Expect(0, 73136, '\P{^Blk=gunjalagondi}', "");
    Expect(1, 73135, '\p{Blk=:\Agunjalagondi\z:}', "");;
    Expect(0, 73136, '\p{Blk=:\Agunjalagondi\z:}', "");;
    Expect(1, 73135, '\p{Blk=__gunjala_Gondi}', "");
    Expect(0, 73135, '\p{^Blk=__gunjala_Gondi}', "");
    Expect(0, 73135, '\P{Blk=__gunjala_Gondi}', "");
    Expect(1, 73135, '\P{^Blk=__gunjala_Gondi}', "");
    Expect(0, 73136, '\p{Blk=__gunjala_Gondi}', "");
    Expect(1, 73136, '\p{^Blk=__gunjala_Gondi}', "");
    Expect(1, 73136, '\P{Blk=__gunjala_Gondi}', "");
    Expect(0, 73136, '\P{^Blk=__gunjala_Gondi}', "");
    Error('\p{Is_Block=/a/  gunjala_Gondi}');
    Error('\P{Is_Block=/a/  gunjala_Gondi}');
    Expect(1, 73135, '\p{Is_Block=gunjalagondi}', "");
    Expect(0, 73135, '\p{^Is_Block=gunjalagondi}', "");
    Expect(0, 73135, '\P{Is_Block=gunjalagondi}', "");
    Expect(1, 73135, '\P{^Is_Block=gunjalagondi}', "");
    Expect(0, 73136, '\p{Is_Block=gunjalagondi}', "");
    Expect(1, 73136, '\p{^Is_Block=gunjalagondi}', "");
    Expect(1, 73136, '\P{Is_Block=gunjalagondi}', "");
    Expect(0, 73136, '\P{^Is_Block=gunjalagondi}', "");
    Expect(1, 73135, '\p{Is_Block=-gunjala_gondi}', "");
    Expect(0, 73135, '\p{^Is_Block=-gunjala_gondi}', "");
    Expect(0, 73135, '\P{Is_Block=-gunjala_gondi}', "");
    Expect(1, 73135, '\P{^Is_Block=-gunjala_gondi}', "");
    Expect(0, 73136, '\p{Is_Block=-gunjala_gondi}', "");
    Expect(1, 73136, '\p{^Is_Block=-gunjala_gondi}', "");
    Expect(1, 73136, '\P{Is_Block=-gunjala_gondi}', "");
    Expect(0, 73136, '\P{^Is_Block=-gunjala_gondi}', "");
    Error('\p{Is_Blk:	_/a/Gunjala_gondi}');
    Error('\P{Is_Blk:	_/a/Gunjala_gondi}');
    Expect(1, 73135, '\p{Is_Blk=gunjalagondi}', "");
    Expect(0, 73135, '\p{^Is_Blk=gunjalagondi}', "");
    Expect(0, 73135, '\P{Is_Blk=gunjalagondi}', "");
    Expect(1, 73135, '\P{^Is_Blk=gunjalagondi}', "");
    Expect(0, 73136, '\p{Is_Blk=gunjalagondi}', "");
    Expect(1, 73136, '\p{^Is_Blk=gunjalagondi}', "");
    Expect(1, 73136, '\P{Is_Blk=gunjalagondi}', "");
    Expect(0, 73136, '\P{^Is_Blk=gunjalagondi}', "");
    Expect(1, 73135, '\p{Is_Blk:-	GUNJALA_Gondi}', "");
    Expect(0, 73135, '\p{^Is_Blk:-	GUNJALA_Gondi}', "");
    Expect(0, 73135, '\P{Is_Blk:-	GUNJALA_Gondi}', "");
    Expect(1, 73135, '\P{^Is_Blk:-	GUNJALA_Gondi}', "");
    Expect(0, 73136, '\p{Is_Blk:-	GUNJALA_Gondi}', "");
    Expect(1, 73136, '\p{^Is_Blk:-	GUNJALA_Gondi}', "");
    Expect(1, 73136, '\P{Is_Blk:-	GUNJALA_Gondi}', "");
    Expect(0, 73136, '\P{^Is_Blk:-	GUNJALA_Gondi}', "");
    Error('\p{Block=/a/ Gurmukhi}');
    Error('\P{Block=/a/ Gurmukhi}');
    Expect(1, 2687, '\p{Block=:\AGurmukhi\z:}', "");;
    Expect(0, 2688, '\p{Block=:\AGurmukhi\z:}', "");;
    Expect(1, 2687, '\p{Block: gurmukhi}', "");
    Expect(0, 2687, '\p{^Block: gurmukhi}', "");
    Expect(0, 2687, '\P{Block: gurmukhi}', "");
    Expect(1, 2687, '\P{^Block: gurmukhi}', "");
    Expect(0, 2688, '\p{Block: gurmukhi}', "");
    Expect(1, 2688, '\p{^Block: gurmukhi}', "");
    Expect(1, 2688, '\P{Block: gurmukhi}', "");
    Expect(0, 2688, '\P{^Block: gurmukhi}', "");
    Expect(1, 2687, '\p{Block=:\Agurmukhi\z:}', "");;
    Expect(0, 2688, '\p{Block=:\Agurmukhi\z:}', "");;
    Expect(1, 2687, '\p{Block=_	GURMUKHI}', "");
    Expect(0, 2687, '\p{^Block=_	GURMUKHI}', "");
    Expect(0, 2687, '\P{Block=_	GURMUKHI}', "");
    Expect(1, 2687, '\P{^Block=_	GURMUKHI}', "");
    Expect(0, 2688, '\p{Block=_	GURMUKHI}', "");
    Expect(1, 2688, '\p{^Block=_	GURMUKHI}', "");
    Expect(1, 2688, '\P{Block=_	GURMUKHI}', "");
    Expect(0, 2688, '\P{^Block=_	GURMUKHI}', "");
    Error('\p{Blk=:=- GURMUKHI}');
    Error('\P{Blk=:=- GURMUKHI}');
    Expect(1, 2687, '\p{Blk=:\AGurmukhi\z:}', "");;
    Expect(0, 2688, '\p{Blk=:\AGurmukhi\z:}', "");;
    Expect(1, 2687, '\p{Blk=gurmukhi}', "");
    Expect(0, 2687, '\p{^Blk=gurmukhi}', "");
    Expect(0, 2687, '\P{Blk=gurmukhi}', "");
    Expect(1, 2687, '\P{^Blk=gurmukhi}', "");
    Expect(0, 2688, '\p{Blk=gurmukhi}', "");
    Expect(1, 2688, '\p{^Blk=gurmukhi}', "");
    Expect(1, 2688, '\P{Blk=gurmukhi}', "");
    Expect(0, 2688, '\P{^Blk=gurmukhi}', "");
    Expect(1, 2687, '\p{Blk=:\Agurmukhi\z:}', "");;
    Expect(0, 2688, '\p{Blk=:\Agurmukhi\z:}', "");;
    Expect(1, 2687, '\p{Blk=_Gurmukhi}', "");
    Expect(0, 2687, '\p{^Blk=_Gurmukhi}', "");
    Expect(0, 2687, '\P{Blk=_Gurmukhi}', "");
    Expect(1, 2687, '\P{^Blk=_Gurmukhi}', "");
    Expect(0, 2688, '\p{Blk=_Gurmukhi}', "");
    Expect(1, 2688, '\p{^Blk=_Gurmukhi}', "");
    Expect(1, 2688, '\P{Blk=_Gurmukhi}', "");
    Expect(0, 2688, '\P{^Blk=_Gurmukhi}', "");
    Error('\p{Is_Block= :=Gurmukhi}');
    Error('\P{Is_Block= :=Gurmukhi}');
    Expect(1, 2687, '\p{Is_Block=gurmukhi}', "");
    Expect(0, 2687, '\p{^Is_Block=gurmukhi}', "");
    Expect(0, 2687, '\P{Is_Block=gurmukhi}', "");
    Expect(1, 2687, '\P{^Is_Block=gurmukhi}', "");
    Expect(0, 2688, '\p{Is_Block=gurmukhi}', "");
    Expect(1, 2688, '\p{^Is_Block=gurmukhi}', "");
    Expect(1, 2688, '\P{Is_Block=gurmukhi}', "");
    Expect(0, 2688, '\P{^Is_Block=gurmukhi}', "");
    Expect(1, 2687, '\p{Is_Block=	Gurmukhi}', "");
    Expect(0, 2687, '\p{^Is_Block=	Gurmukhi}', "");
    Expect(0, 2687, '\P{Is_Block=	Gurmukhi}', "");
    Expect(1, 2687, '\P{^Is_Block=	Gurmukhi}', "");
    Expect(0, 2688, '\p{Is_Block=	Gurmukhi}', "");
    Expect(1, 2688, '\p{^Is_Block=	Gurmukhi}', "");
    Expect(1, 2688, '\P{Is_Block=	Gurmukhi}', "");
    Expect(0, 2688, '\P{^Is_Block=	Gurmukhi}', "");
    Error('\p{Is_Blk=:=gurmukhi}');
    Error('\P{Is_Blk=:=gurmukhi}');
    Expect(1, 2687, '\p{Is_Blk=gurmukhi}', "");
    Expect(0, 2687, '\p{^Is_Blk=gurmukhi}', "");
    Expect(0, 2687, '\P{Is_Blk=gurmukhi}', "");
    Expect(1, 2687, '\P{^Is_Blk=gurmukhi}', "");
    Expect(0, 2688, '\p{Is_Blk=gurmukhi}', "");
    Expect(1, 2688, '\p{^Is_Blk=gurmukhi}', "");
    Expect(1, 2688, '\P{Is_Blk=gurmukhi}', "");
    Expect(0, 2688, '\P{^Is_Blk=gurmukhi}', "");
    Expect(1, 2687, '\p{Is_Blk=		gurmukhi}', "");
    Expect(0, 2687, '\p{^Is_Blk=		gurmukhi}', "");
    Expect(0, 2687, '\P{Is_Blk=		gurmukhi}', "");
    Expect(1, 2687, '\P{^Is_Blk=		gurmukhi}', "");
    Expect(0, 2688, '\p{Is_Blk=		gurmukhi}', "");
    Expect(1, 2688, '\p{^Is_Blk=		gurmukhi}', "");
    Expect(1, 2688, '\P{Is_Blk=		gurmukhi}', "");
    Expect(0, 2688, '\P{^Is_Blk=		gurmukhi}', "");
    Error('\p{Block=/a/		Halfwidth_AND_FULLWIDTH_FORMS}');
    Error('\P{Block=/a/		Halfwidth_AND_FULLWIDTH_FORMS}');
    Expect(1, 65519, '\p{Block=:\AHalfwidth_And_Fullwidth_Forms\z:}', "");;
    Expect(0, 65520, '\p{Block=:\AHalfwidth_And_Fullwidth_Forms\z:}', "");;
    Expect(1, 65519, '\p{Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\p{^Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\P{Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\P{^Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\p{Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\p{^Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\P{Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\P{^Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\p{Block=:\Ahalfwidthandfullwidthforms\z:}', "");;
    Expect(0, 65520, '\p{Block=:\Ahalfwidthandfullwidthforms\z:}', "");;
    Expect(1, 65519, '\p{Block=	-Halfwidth_And_Fullwidth_Forms}', "");
    Expect(0, 65519, '\p{^Block=	-Halfwidth_And_Fullwidth_Forms}', "");
    Expect(0, 65519, '\P{Block=	-Halfwidth_And_Fullwidth_Forms}', "");
    Expect(1, 65519, '\P{^Block=	-Halfwidth_And_Fullwidth_Forms}', "");
    Expect(0, 65520, '\p{Block=	-Halfwidth_And_Fullwidth_Forms}', "");
    Expect(1, 65520, '\p{^Block=	-Halfwidth_And_Fullwidth_Forms}', "");
    Expect(1, 65520, '\P{Block=	-Halfwidth_And_Fullwidth_Forms}', "");
    Expect(0, 65520, '\P{^Block=	-Halfwidth_And_Fullwidth_Forms}', "");
    Error('\p{Blk=-Half_And_Full_FORMS:=}');
    Error('\P{Blk=-Half_And_Full_FORMS:=}');
    Expect(1, 65519, '\p{Blk=:\AHalf_And_Full_Forms\z:}', "");;
    Expect(0, 65520, '\p{Blk=:\AHalf_And_Full_Forms\z:}', "");;
    Expect(1, 65519, '\p{Blk=halfandfullforms}', "");
    Expect(0, 65519, '\p{^Blk=halfandfullforms}', "");
    Expect(0, 65519, '\P{Blk=halfandfullforms}', "");
    Expect(1, 65519, '\P{^Blk=halfandfullforms}', "");
    Expect(0, 65520, '\p{Blk=halfandfullforms}', "");
    Expect(1, 65520, '\p{^Blk=halfandfullforms}', "");
    Expect(1, 65520, '\P{Blk=halfandfullforms}', "");
    Expect(0, 65520, '\P{^Blk=halfandfullforms}', "");
    Expect(1, 65519, '\p{Blk=:\Ahalfandfullforms\z:}', "");;
    Expect(0, 65520, '\p{Blk=:\Ahalfandfullforms\z:}', "");;
    Expect(1, 65519, '\p{Blk= half_AND_Full_forms}', "");
    Expect(0, 65519, '\p{^Blk= half_AND_Full_forms}', "");
    Expect(0, 65519, '\P{Blk= half_AND_Full_forms}', "");
    Expect(1, 65519, '\P{^Blk= half_AND_Full_forms}', "");
    Expect(0, 65520, '\p{Blk= half_AND_Full_forms}', "");
    Expect(1, 65520, '\p{^Blk= half_AND_Full_forms}', "");
    Expect(1, 65520, '\P{Blk= half_AND_Full_forms}', "");
    Expect(0, 65520, '\P{^Blk= half_AND_Full_forms}', "");
    Error('\p{Is_Block=/a/-	Halfwidth_And_Fullwidth_Forms}');
    Error('\P{Is_Block=/a/-	Halfwidth_And_Fullwidth_Forms}');
    Expect(1, 65519, '\p{Is_Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\p{^Is_Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\P{Is_Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\P{^Is_Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\p{Is_Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\p{^Is_Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\P{Is_Block=halfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\P{^Is_Block=halfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\p{Is_Block=__halfwidth_And_FULLWIDTH_FORMS}', "");
    Expect(0, 65519, '\p{^Is_Block=__halfwidth_And_FULLWIDTH_FORMS}', "");
    Expect(0, 65519, '\P{Is_Block=__halfwidth_And_FULLWIDTH_FORMS}', "");
    Expect(1, 65519, '\P{^Is_Block=__halfwidth_And_FULLWIDTH_FORMS}', "");
    Expect(0, 65520, '\p{Is_Block=__halfwidth_And_FULLWIDTH_FORMS}', "");
    Expect(1, 65520, '\p{^Is_Block=__halfwidth_And_FULLWIDTH_FORMS}', "");
    Expect(1, 65520, '\P{Is_Block=__halfwidth_And_FULLWIDTH_FORMS}', "");
    Expect(0, 65520, '\P{^Is_Block=__halfwidth_And_FULLWIDTH_FORMS}', "");
    Error('\p{Is_Blk=-/a/Half_And_full_Forms}');
    Error('\P{Is_Blk=-/a/Half_And_full_Forms}');
    Expect(1, 65519, '\p{Is_Blk=halfandfullforms}', "");
    Expect(0, 65519, '\p{^Is_Blk=halfandfullforms}', "");
    Expect(0, 65519, '\P{Is_Blk=halfandfullforms}', "");
    Expect(1, 65519, '\P{^Is_Blk=halfandfullforms}', "");
    Expect(0, 65520, '\p{Is_Blk=halfandfullforms}', "");
    Expect(1, 65520, '\p{^Is_Blk=halfandfullforms}', "");
    Expect(1, 65520, '\P{Is_Blk=halfandfullforms}', "");
    Expect(0, 65520, '\P{^Is_Blk=halfandfullforms}', "");
    Expect(1, 65519, '\p{Is_Blk=_Half_And_full_Forms}', "");
    Expect(0, 65519, '\p{^Is_Blk=_Half_And_full_Forms}', "");
    Expect(0, 65519, '\P{Is_Blk=_Half_And_full_Forms}', "");
    Expect(1, 65519, '\P{^Is_Blk=_Half_And_full_Forms}', "");
    Expect(0, 65520, '\p{Is_Blk=_Half_And_full_Forms}', "");
    Expect(1, 65520, '\p{^Is_Blk=_Half_And_full_Forms}', "");
    Expect(1, 65520, '\P{Is_Blk=_Half_And_full_Forms}', "");
    Expect(0, 65520, '\P{^Is_Blk=_Half_And_full_Forms}', "");
    Error('\p{Block=:=_	Combining_half_MARKS}');
    Error('\P{Block=:=_	Combining_half_MARKS}');
    Expect(1, 65071, '\p{Block=:\ACombining_Half_Marks\z:}', "");;
    Expect(0, 65072, '\p{Block=:\ACombining_Half_Marks\z:}', "");;
    Expect(1, 65071, '\p{Block=combininghalfmarks}', "");
    Expect(0, 65071, '\p{^Block=combininghalfmarks}', "");
    Expect(0, 65071, '\P{Block=combininghalfmarks}', "");
    Expect(1, 65071, '\P{^Block=combininghalfmarks}', "");
    Expect(0, 65072, '\p{Block=combininghalfmarks}', "");
    Expect(1, 65072, '\p{^Block=combininghalfmarks}', "");
    Expect(1, 65072, '\P{Block=combininghalfmarks}', "");
    Expect(0, 65072, '\P{^Block=combininghalfmarks}', "");
    Expect(1, 65071, '\p{Block=:\Acombininghalfmarks\z:}', "");;
    Expect(0, 65072, '\p{Block=:\Acombininghalfmarks\z:}', "");;
    Expect(1, 65071, '\p{Block=-Combining_HALF_Marks}', "");
    Expect(0, 65071, '\p{^Block=-Combining_HALF_Marks}', "");
    Expect(0, 65071, '\P{Block=-Combining_HALF_Marks}', "");
    Expect(1, 65071, '\P{^Block=-Combining_HALF_Marks}', "");
    Expect(0, 65072, '\p{Block=-Combining_HALF_Marks}', "");
    Expect(1, 65072, '\p{^Block=-Combining_HALF_Marks}', "");
    Expect(1, 65072, '\P{Block=-Combining_HALF_Marks}', "");
    Expect(0, 65072, '\P{^Block=-Combining_HALF_Marks}', "");
    Error('\p{Blk=_/a/half_marks}');
    Error('\P{Blk=_/a/half_marks}');
    Expect(1, 65071, '\p{Blk=:\AHalf_Marks\z:}', "");;
    Expect(0, 65072, '\p{Blk=:\AHalf_Marks\z:}', "");;
    Expect(1, 65071, '\p{Blk=halfmarks}', "");
    Expect(0, 65071, '\p{^Blk=halfmarks}', "");
    Expect(0, 65071, '\P{Blk=halfmarks}', "");
    Expect(1, 65071, '\P{^Blk=halfmarks}', "");
    Expect(0, 65072, '\p{Blk=halfmarks}', "");
    Expect(1, 65072, '\p{^Blk=halfmarks}', "");
    Expect(1, 65072, '\P{Blk=halfmarks}', "");
    Expect(0, 65072, '\P{^Blk=halfmarks}', "");
    Expect(1, 65071, '\p{Blk=:\Ahalfmarks\z:}', "");;
    Expect(0, 65072, '\p{Blk=:\Ahalfmarks\z:}', "");;
    Expect(1, 65071, '\p{Blk=-Half_Marks}', "");
    Expect(0, 65071, '\p{^Blk=-Half_Marks}', "");
    Expect(0, 65071, '\P{Blk=-Half_Marks}', "");
    Expect(1, 65071, '\P{^Blk=-Half_Marks}', "");
    Expect(0, 65072, '\p{Blk=-Half_Marks}', "");
    Expect(1, 65072, '\p{^Blk=-Half_Marks}', "");
    Expect(1, 65072, '\P{Blk=-Half_Marks}', "");
    Expect(0, 65072, '\P{^Blk=-Half_Marks}', "");
    Error('\p{Is_Block= /a/COMBINING_HALF_Marks}');
    Error('\P{Is_Block= /a/COMBINING_HALF_Marks}');
    Expect(1, 65071, '\p{Is_Block:combininghalfmarks}', "");
    Expect(0, 65071, '\p{^Is_Block:combininghalfmarks}', "");
    Expect(0, 65071, '\P{Is_Block:combininghalfmarks}', "");
    Expect(1, 65071, '\P{^Is_Block:combininghalfmarks}', "");
    Expect(0, 65072, '\p{Is_Block:combininghalfmarks}', "");
    Expect(1, 65072, '\p{^Is_Block:combininghalfmarks}', "");
    Expect(1, 65072, '\P{Is_Block:combininghalfmarks}', "");
    Expect(0, 65072, '\P{^Is_Block:combininghalfmarks}', "");
    Expect(1, 65071, '\p{Is_Block= Combining_Half_Marks}', "");
    Expect(0, 65071, '\p{^Is_Block= Combining_Half_Marks}', "");
    Expect(0, 65071, '\P{Is_Block= Combining_Half_Marks}', "");
    Expect(1, 65071, '\P{^Is_Block= Combining_Half_Marks}', "");
    Expect(0, 65072, '\p{Is_Block= Combining_Half_Marks}', "");
    Expect(1, 65072, '\p{^Is_Block= Combining_Half_Marks}', "");
    Expect(1, 65072, '\P{Is_Block= Combining_Half_Marks}', "");
    Expect(0, 65072, '\P{^Is_Block= Combining_Half_Marks}', "");
    Error('\p{Is_Blk=	:=Half_Marks}');
    Error('\P{Is_Blk=	:=Half_Marks}');
    Expect(1, 65071, '\p{Is_Blk=halfmarks}', "");
    Expect(0, 65071, '\p{^Is_Blk=halfmarks}', "");
    Expect(0, 65071, '\P{Is_Blk=halfmarks}', "");
    Expect(1, 65071, '\P{^Is_Blk=halfmarks}', "");
    Expect(0, 65072, '\p{Is_Blk=halfmarks}', "");
    Expect(1, 65072, '\p{^Is_Blk=halfmarks}', "");
    Expect(1, 65072, '\P{Is_Blk=halfmarks}', "");
    Expect(0, 65072, '\P{^Is_Blk=halfmarks}', "");
    Expect(1, 65071, '\p{Is_Blk=-Half_MARKS}', "");
    Expect(0, 65071, '\p{^Is_Blk=-Half_MARKS}', "");
    Expect(0, 65071, '\P{Is_Blk=-Half_MARKS}', "");
    Expect(1, 65071, '\P{^Is_Blk=-Half_MARKS}', "");
    Expect(0, 65072, '\p{Is_Blk=-Half_MARKS}', "");
    Expect(1, 65072, '\p{^Is_Blk=-Half_MARKS}', "");
    Expect(1, 65072, '\P{Is_Blk=-Half_MARKS}', "");
    Expect(0, 65072, '\P{^Is_Blk=-Half_MARKS}', "");
    Error('\p{Block= :=Hangul_SYLLABLES}');
    Error('\P{Block= :=Hangul_SYLLABLES}');
    Expect(1, 55215, '\p{Block=:\AHangul_Syllables\z:}', "");;
    Expect(0, 55216, '\p{Block=:\AHangul_Syllables\z:}', "");;
    Expect(1, 55215, '\p{Block:	hangulsyllables}', "");
    Expect(0, 55215, '\p{^Block:	hangulsyllables}', "");
    Expect(0, 55215, '\P{Block:	hangulsyllables}', "");
    Expect(1, 55215, '\P{^Block:	hangulsyllables}', "");
    Expect(0, 55216, '\p{Block:	hangulsyllables}', "");
    Expect(1, 55216, '\p{^Block:	hangulsyllables}', "");
    Expect(1, 55216, '\P{Block:	hangulsyllables}', "");
    Expect(0, 55216, '\P{^Block:	hangulsyllables}', "");
    Expect(1, 55215, '\p{Block=:\Ahangulsyllables\z:}', "");;
    Expect(0, 55216, '\p{Block=:\Ahangulsyllables\z:}', "");;
    Expect(1, 55215, '\p{Block=  Hangul_syllables}', "");
    Expect(0, 55215, '\p{^Block=  Hangul_syllables}', "");
    Expect(0, 55215, '\P{Block=  Hangul_syllables}', "");
    Expect(1, 55215, '\P{^Block=  Hangul_syllables}', "");
    Expect(0, 55216, '\p{Block=  Hangul_syllables}', "");
    Expect(1, 55216, '\p{^Block=  Hangul_syllables}', "");
    Expect(1, 55216, '\P{Block=  Hangul_syllables}', "");
    Expect(0, 55216, '\P{^Block=  Hangul_syllables}', "");
    Error('\p{Blk=_:=Hangul}');
    Error('\P{Blk=_:=Hangul}');
    Expect(1, 55215, '\p{Blk=:\AHangul\z:}', "");;
    Expect(0, 55216, '\p{Blk=:\AHangul\z:}', "");;
    Expect(1, 55215, '\p{Blk=hangul}', "");
    Expect(0, 55215, '\p{^Blk=hangul}', "");
    Expect(0, 55215, '\P{Blk=hangul}', "");
    Expect(1, 55215, '\P{^Blk=hangul}', "");
    Expect(0, 55216, '\p{Blk=hangul}', "");
    Expect(1, 55216, '\p{^Blk=hangul}', "");
    Expect(1, 55216, '\P{Blk=hangul}', "");
    Expect(0, 55216, '\P{^Blk=hangul}', "");
    Expect(1, 55215, '\p{Blk=:\Ahangul\z:}', "");;
    Expect(0, 55216, '\p{Blk=:\Ahangul\z:}', "");;
    Expect(1, 55215, '\p{Blk=_-Hangul}', "");
    Expect(0, 55215, '\p{^Blk=_-Hangul}', "");
    Expect(0, 55215, '\P{Blk=_-Hangul}', "");
    Expect(1, 55215, '\P{^Blk=_-Hangul}', "");
    Expect(0, 55216, '\p{Blk=_-Hangul}', "");
    Expect(1, 55216, '\p{^Blk=_-Hangul}', "");
    Expect(1, 55216, '\P{Blk=_-Hangul}', "");
    Expect(0, 55216, '\P{^Blk=_-Hangul}', "");
    Error('\p{Is_Block=/a/__Hangul_Syllables}');
    Error('\P{Is_Block=/a/__Hangul_Syllables}');
    Expect(1, 55215, '\p{Is_Block=hangulsyllables}', "");
    Expect(0, 55215, '\p{^Is_Block=hangulsyllables}', "");
    Expect(0, 55215, '\P{Is_Block=hangulsyllables}', "");
    Expect(1, 55215, '\P{^Is_Block=hangulsyllables}', "");
    Expect(0, 55216, '\p{Is_Block=hangulsyllables}', "");
    Expect(1, 55216, '\p{^Is_Block=hangulsyllables}', "");
    Expect(1, 55216, '\P{Is_Block=hangulsyllables}', "");
    Expect(0, 55216, '\P{^Is_Block=hangulsyllables}', "");
    Expect(1, 55215, '\p{Is_Block=__HANGUL_Syllables}', "");
    Expect(0, 55215, '\p{^Is_Block=__HANGUL_Syllables}', "");
    Expect(0, 55215, '\P{Is_Block=__HANGUL_Syllables}', "");
    Expect(1, 55215, '\P{^Is_Block=__HANGUL_Syllables}', "");
    Expect(0, 55216, '\p{Is_Block=__HANGUL_Syllables}', "");
    Expect(1, 55216, '\p{^Is_Block=__HANGUL_Syllables}', "");
    Expect(1, 55216, '\P{Is_Block=__HANGUL_Syllables}', "");
    Expect(0, 55216, '\P{^Is_Block=__HANGUL_Syllables}', "");
    Error('\p{Is_Blk=_/a/Hangul}');
    Error('\P{Is_Blk=_/a/Hangul}');
    Expect(1, 55215, '\p{Is_Blk=hangul}', "");
    Expect(0, 55215, '\p{^Is_Blk=hangul}', "");
    Expect(0, 55215, '\P{Is_Blk=hangul}', "");
    Expect(1, 55215, '\P{^Is_Blk=hangul}', "");
    Expect(0, 55216, '\p{Is_Blk=hangul}', "");
    Expect(1, 55216, '\p{^Is_Blk=hangul}', "");
    Expect(1, 55216, '\P{Is_Blk=hangul}', "");
    Expect(0, 55216, '\P{^Is_Blk=hangul}', "");
    Expect(1, 55215, '\p{Is_Blk=_Hangul}', "");
    Expect(0, 55215, '\p{^Is_Blk=_Hangul}', "");
    Expect(0, 55215, '\P{Is_Blk=_Hangul}', "");
    Expect(1, 55215, '\P{^Is_Blk=_Hangul}', "");
    Expect(0, 55216, '\p{Is_Blk=_Hangul}', "");
    Expect(1, 55216, '\p{^Is_Blk=_Hangul}', "");
    Expect(1, 55216, '\P{Is_Blk=_Hangul}', "");
    Expect(0, 55216, '\P{^Is_Blk=_Hangul}', "");
    Error('\p{Block= _HANIFI_Rohingya/a/}');
    Error('\P{Block= _HANIFI_Rohingya/a/}');
    Expect(1, 68927, '\p{Block=:\AHanifi_Rohingya\z:}', "");;
    Expect(0, 68928, '\p{Block=:\AHanifi_Rohingya\z:}', "");;
    Expect(1, 68927, '\p{Block=hanifirohingya}', "");
    Expect(0, 68927, '\p{^Block=hanifirohingya}', "");
    Expect(0, 68927, '\P{Block=hanifirohingya}', "");
    Expect(1, 68927, '\P{^Block=hanifirohingya}', "");
    Expect(0, 68928, '\p{Block=hanifirohingya}', "");
    Expect(1, 68928, '\p{^Block=hanifirohingya}', "");
    Expect(1, 68928, '\P{Block=hanifirohingya}', "");
    Expect(0, 68928, '\P{^Block=hanifirohingya}', "");
    Expect(1, 68927, '\p{Block=:\Ahanifirohingya\z:}', "");;
    Expect(0, 68928, '\p{Block=:\Ahanifirohingya\z:}', "");;
    Expect(1, 68927, '\p{Block=	hanifi_ROHINGYA}', "");
    Expect(0, 68927, '\p{^Block=	hanifi_ROHINGYA}', "");
    Expect(0, 68927, '\P{Block=	hanifi_ROHINGYA}', "");
    Expect(1, 68927, '\P{^Block=	hanifi_ROHINGYA}', "");
    Expect(0, 68928, '\p{Block=	hanifi_ROHINGYA}', "");
    Expect(1, 68928, '\p{^Block=	hanifi_ROHINGYA}', "");
    Expect(1, 68928, '\P{Block=	hanifi_ROHINGYA}', "");
    Expect(0, 68928, '\P{^Block=	hanifi_ROHINGYA}', "");
    Error('\p{Blk=__Hanifi_rohingya/a/}');
    Error('\P{Blk=__Hanifi_rohingya/a/}');
    Expect(1, 68927, '\p{Blk=:\AHanifi_Rohingya\z:}', "");;
    Expect(0, 68928, '\p{Blk=:\AHanifi_Rohingya\z:}', "");;
    Expect(1, 68927, '\p{Blk=hanifirohingya}', "");
    Expect(0, 68927, '\p{^Blk=hanifirohingya}', "");
    Expect(0, 68927, '\P{Blk=hanifirohingya}', "");
    Expect(1, 68927, '\P{^Blk=hanifirohingya}', "");
    Expect(0, 68928, '\p{Blk=hanifirohingya}', "");
    Expect(1, 68928, '\p{^Blk=hanifirohingya}', "");
    Expect(1, 68928, '\P{Blk=hanifirohingya}', "");
    Expect(0, 68928, '\P{^Blk=hanifirohingya}', "");
    Expect(1, 68927, '\p{Blk=:\Ahanifirohingya\z:}', "");;
    Expect(0, 68928, '\p{Blk=:\Ahanifirohingya\z:}', "");;
    Expect(1, 68927, '\p{Blk=  hanifi_rohingya}', "");
    Expect(0, 68927, '\p{^Blk=  hanifi_rohingya}', "");
    Expect(0, 68927, '\P{Blk=  hanifi_rohingya}', "");
    Expect(1, 68927, '\P{^Blk=  hanifi_rohingya}', "");
    Expect(0, 68928, '\p{Blk=  hanifi_rohingya}', "");
    Expect(1, 68928, '\p{^Blk=  hanifi_rohingya}', "");
    Expect(1, 68928, '\P{Blk=  hanifi_rohingya}', "");
    Expect(0, 68928, '\P{^Blk=  hanifi_rohingya}', "");
    Error('\p{Is_Block=:=-	hanifi_ROHINGYA}');
    Error('\P{Is_Block=:=-	hanifi_ROHINGYA}');
    Expect(1, 68927, '\p{Is_Block=hanifirohingya}', "");
    Expect(0, 68927, '\p{^Is_Block=hanifirohingya}', "");
    Expect(0, 68927, '\P{Is_Block=hanifirohingya}', "");
    Expect(1, 68927, '\P{^Is_Block=hanifirohingya}', "");
    Expect(0, 68928, '\p{Is_Block=hanifirohingya}', "");
    Expect(1, 68928, '\p{^Is_Block=hanifirohingya}', "");
    Expect(1, 68928, '\P{Is_Block=hanifirohingya}', "");
    Expect(0, 68928, '\P{^Is_Block=hanifirohingya}', "");
    Expect(1, 68927, '\p{Is_Block=	_HANIFI_Rohingya}', "");
    Expect(0, 68927, '\p{^Is_Block=	_HANIFI_Rohingya}', "");
    Expect(0, 68927, '\P{Is_Block=	_HANIFI_Rohingya}', "");
    Expect(1, 68927, '\P{^Is_Block=	_HANIFI_Rohingya}', "");
    Expect(0, 68928, '\p{Is_Block=	_HANIFI_Rohingya}', "");
    Expect(1, 68928, '\p{^Is_Block=	_HANIFI_Rohingya}', "");
    Expect(1, 68928, '\P{Is_Block=	_HANIFI_Rohingya}', "");
    Expect(0, 68928, '\P{^Is_Block=	_HANIFI_Rohingya}', "");
    Error('\p{Is_Blk=/a/Hanifi_ROHINGYA}');
    Error('\P{Is_Blk=/a/Hanifi_ROHINGYA}');
    Expect(1, 68927, '\p{Is_Blk=hanifirohingya}', "");
    Expect(0, 68927, '\p{^Is_Blk=hanifirohingya}', "");
    Expect(0, 68927, '\P{Is_Blk=hanifirohingya}', "");
    Expect(1, 68927, '\P{^Is_Blk=hanifirohingya}', "");
    Expect(0, 68928, '\p{Is_Blk=hanifirohingya}', "");
    Expect(1, 68928, '\p{^Is_Blk=hanifirohingya}', "");
    Expect(1, 68928, '\P{Is_Blk=hanifirohingya}', "");
    Expect(0, 68928, '\P{^Is_Blk=hanifirohingya}', "");
    Expect(1, 68927, '\p{Is_Blk:   --Hanifi_Rohingya}', "");
    Expect(0, 68927, '\p{^Is_Blk:   --Hanifi_Rohingya}', "");
    Expect(0, 68927, '\P{Is_Blk:   --Hanifi_Rohingya}', "");
    Expect(1, 68927, '\P{^Is_Blk:   --Hanifi_Rohingya}', "");
    Expect(0, 68928, '\p{Is_Blk:   --Hanifi_Rohingya}', "");
    Expect(1, 68928, '\p{^Is_Blk:   --Hanifi_Rohingya}', "");
    Expect(1, 68928, '\P{Is_Blk:   --Hanifi_Rohingya}', "");
    Expect(0, 68928, '\P{^Is_Blk:   --Hanifi_Rohingya}', "");
    Error('\p{Block=__HANUNOO:=}');
    Error('\P{Block=__HANUNOO:=}');
    Expect(1, 5951, '\p{Block=:\AHanunoo\z:}', "");;
    Expect(0, 5952, '\p{Block=:\AHanunoo\z:}', "");;
    Expect(1, 5951, '\p{Block=hanunoo}', "");
    Expect(0, 5951, '\p{^Block=hanunoo}', "");
    Expect(0, 5951, '\P{Block=hanunoo}', "");
    Expect(1, 5951, '\P{^Block=hanunoo}', "");
    Expect(0, 5952, '\p{Block=hanunoo}', "");
    Expect(1, 5952, '\p{^Block=hanunoo}', "");
    Expect(1, 5952, '\P{Block=hanunoo}', "");
    Expect(0, 5952, '\P{^Block=hanunoo}', "");
    Expect(1, 5951, '\p{Block=:\Ahanunoo\z:}', "");;
    Expect(0, 5952, '\p{Block=:\Ahanunoo\z:}', "");;
    Expect(1, 5951, '\p{Block=__hanunoo}', "");
    Expect(0, 5951, '\p{^Block=__hanunoo}', "");
    Expect(0, 5951, '\P{Block=__hanunoo}', "");
    Expect(1, 5951, '\P{^Block=__hanunoo}', "");
    Expect(0, 5952, '\p{Block=__hanunoo}', "");
    Expect(1, 5952, '\p{^Block=__hanunoo}', "");
    Expect(1, 5952, '\P{Block=__hanunoo}', "");
    Expect(0, 5952, '\P{^Block=__hanunoo}', "");
    Error('\p{Blk=/a/- hanunoo}');
    Error('\P{Blk=/a/- hanunoo}');
    Expect(1, 5951, '\p{Blk=:\AHanunoo\z:}', "");;
    Expect(0, 5952, '\p{Blk=:\AHanunoo\z:}', "");;
    Expect(1, 5951, '\p{Blk=hanunoo}', "");
    Expect(0, 5951, '\p{^Blk=hanunoo}', "");
    Expect(0, 5951, '\P{Blk=hanunoo}', "");
    Expect(1, 5951, '\P{^Blk=hanunoo}', "");
    Expect(0, 5952, '\p{Blk=hanunoo}', "");
    Expect(1, 5952, '\p{^Blk=hanunoo}', "");
    Expect(1, 5952, '\P{Blk=hanunoo}', "");
    Expect(0, 5952, '\P{^Blk=hanunoo}', "");
    Expect(1, 5951, '\p{Blk=:\Ahanunoo\z:}', "");;
    Expect(0, 5952, '\p{Blk=:\Ahanunoo\z:}', "");;
    Expect(1, 5951, '\p{Blk=_hanunoo}', "");
    Expect(0, 5951, '\p{^Blk=_hanunoo}', "");
    Expect(0, 5951, '\P{Blk=_hanunoo}', "");
    Expect(1, 5951, '\P{^Blk=_hanunoo}', "");
    Expect(0, 5952, '\p{Blk=_hanunoo}', "");
    Expect(1, 5952, '\p{^Blk=_hanunoo}', "");
    Expect(1, 5952, '\P{Blk=_hanunoo}', "");
    Expect(0, 5952, '\P{^Blk=_hanunoo}', "");
    Error('\p{Is_Block=_HANUNOO:=}');
    Error('\P{Is_Block=_HANUNOO:=}');
    Expect(1, 5951, '\p{Is_Block=hanunoo}', "");
    Expect(0, 5951, '\p{^Is_Block=hanunoo}', "");
    Expect(0, 5951, '\P{Is_Block=hanunoo}', "");
    Expect(1, 5951, '\P{^Is_Block=hanunoo}', "");
    Expect(0, 5952, '\p{Is_Block=hanunoo}', "");
    Expect(1, 5952, '\p{^Is_Block=hanunoo}', "");
    Expect(1, 5952, '\P{Is_Block=hanunoo}', "");
    Expect(0, 5952, '\P{^Is_Block=hanunoo}', "");
    Expect(1, 5951, '\p{Is_Block:  hanunoo}', "");
    Expect(0, 5951, '\p{^Is_Block:  hanunoo}', "");
    Expect(0, 5951, '\P{Is_Block:  hanunoo}', "");
    Expect(1, 5951, '\P{^Is_Block:  hanunoo}', "");
    Expect(0, 5952, '\p{Is_Block:  hanunoo}', "");
    Expect(1, 5952, '\p{^Is_Block:  hanunoo}', "");
    Expect(1, 5952, '\P{Is_Block:  hanunoo}', "");
    Expect(0, 5952, '\P{^Is_Block:  hanunoo}', "");
    Error('\p{Is_Blk=-:=Hanunoo}');
    Error('\P{Is_Blk=-:=Hanunoo}');
    Expect(1, 5951, '\p{Is_Blk=hanunoo}', "");
    Expect(0, 5951, '\p{^Is_Blk=hanunoo}', "");
    Expect(0, 5951, '\P{Is_Blk=hanunoo}', "");
    Expect(1, 5951, '\P{^Is_Blk=hanunoo}', "");
    Expect(0, 5952, '\p{Is_Blk=hanunoo}', "");
    Expect(1, 5952, '\p{^Is_Blk=hanunoo}', "");
    Expect(1, 5952, '\P{Is_Blk=hanunoo}', "");
    Expect(0, 5952, '\P{^Is_Blk=hanunoo}', "");
    Expect(1, 5951, '\p{Is_Blk=Hanunoo}', "");
    Expect(0, 5951, '\p{^Is_Blk=Hanunoo}', "");
    Expect(0, 5951, '\P{Is_Blk=Hanunoo}', "");
    Expect(1, 5951, '\P{^Is_Blk=Hanunoo}', "");
    Expect(0, 5952, '\p{Is_Blk=Hanunoo}', "");
    Expect(1, 5952, '\p{^Is_Blk=Hanunoo}', "");
    Expect(1, 5952, '\P{Is_Blk=Hanunoo}', "");
    Expect(0, 5952, '\P{^Is_Blk=Hanunoo}', "");
    Error('\p{Block= /a/HATRAN}');
    Error('\P{Block= /a/HATRAN}');
    Expect(1, 67839, '\p{Block=:\AHatran\z:}', "");;
    Expect(0, 67840, '\p{Block=:\AHatran\z:}', "");;
    Expect(1, 67839, '\p{Block=hatran}', "");
    Expect(0, 67839, '\p{^Block=hatran}', "");
    Expect(0, 67839, '\P{Block=hatran}', "");
    Expect(1, 67839, '\P{^Block=hatran}', "");
    Expect(0, 67840, '\p{Block=hatran}', "");
    Expect(1, 67840, '\p{^Block=hatran}', "");
    Expect(1, 67840, '\P{Block=hatran}', "");
    Expect(0, 67840, '\P{^Block=hatran}', "");
    Expect(1, 67839, '\p{Block=:\Ahatran\z:}', "");;
    Expect(0, 67840, '\p{Block=:\Ahatran\z:}', "");;
    Expect(1, 67839, '\p{Block=  HATRAN}', "");
    Expect(0, 67839, '\p{^Block=  HATRAN}', "");
    Expect(0, 67839, '\P{Block=  HATRAN}', "");
    Expect(1, 67839, '\P{^Block=  HATRAN}', "");
    Expect(0, 67840, '\p{Block=  HATRAN}', "");
    Expect(1, 67840, '\p{^Block=  HATRAN}', "");
    Expect(1, 67840, '\P{Block=  HATRAN}', "");
    Expect(0, 67840, '\P{^Block=  HATRAN}', "");
    Error('\p{Blk=/a/-_HATRAN}');
    Error('\P{Blk=/a/-_HATRAN}');
    Expect(1, 67839, '\p{Blk=:\AHatran\z:}', "");;
    Expect(0, 67840, '\p{Blk=:\AHatran\z:}', "");;
    Expect(1, 67839, '\p{Blk=hatran}', "");
    Expect(0, 67839, '\p{^Blk=hatran}', "");
    Expect(0, 67839, '\P{Blk=hatran}', "");
    Expect(1, 67839, '\P{^Blk=hatran}', "");
    Expect(0, 67840, '\p{Blk=hatran}', "");
    Expect(1, 67840, '\p{^Blk=hatran}', "");
    Expect(1, 67840, '\P{Blk=hatran}', "");
    Expect(0, 67840, '\P{^Blk=hatran}', "");
    Expect(1, 67839, '\p{Blk=:\Ahatran\z:}', "");;
    Expect(0, 67840, '\p{Blk=:\Ahatran\z:}', "");;
    Expect(1, 67839, '\p{Blk:   --Hatran}', "");
    Expect(0, 67839, '\p{^Blk:   --Hatran}', "");
    Expect(0, 67839, '\P{Blk:   --Hatran}', "");
    Expect(1, 67839, '\P{^Blk:   --Hatran}', "");
    Expect(0, 67840, '\p{Blk:   --Hatran}', "");
    Expect(1, 67840, '\p{^Blk:   --Hatran}', "");
    Expect(1, 67840, '\P{Blk:   --Hatran}', "");
    Expect(0, 67840, '\P{^Blk:   --Hatran}', "");
    Error('\p{Is_Block=:=	-HATRAN}');
    Error('\P{Is_Block=:=	-HATRAN}');
    Expect(1, 67839, '\p{Is_Block=hatran}', "");
    Expect(0, 67839, '\p{^Is_Block=hatran}', "");
    Expect(0, 67839, '\P{Is_Block=hatran}', "");
    Expect(1, 67839, '\P{^Is_Block=hatran}', "");
    Expect(0, 67840, '\p{Is_Block=hatran}', "");
    Expect(1, 67840, '\p{^Is_Block=hatran}', "");
    Expect(1, 67840, '\P{Is_Block=hatran}', "");
    Expect(0, 67840, '\P{^Is_Block=hatran}', "");
    Expect(1, 67839, '\p{Is_Block=-Hatran}', "");
    Expect(0, 67839, '\p{^Is_Block=-Hatran}', "");
    Expect(0, 67839, '\P{Is_Block=-Hatran}', "");
    Expect(1, 67839, '\P{^Is_Block=-Hatran}', "");
    Expect(0, 67840, '\p{Is_Block=-Hatran}', "");
    Expect(1, 67840, '\p{^Is_Block=-Hatran}', "");
    Expect(1, 67840, '\P{Is_Block=-Hatran}', "");
    Expect(0, 67840, '\P{^Is_Block=-Hatran}', "");
    Error('\p{Is_Blk=:=hatran}');
    Error('\P{Is_Blk=:=hatran}');
    Expect(1, 67839, '\p{Is_Blk=hatran}', "");
    Expect(0, 67839, '\p{^Is_Blk=hatran}', "");
    Expect(0, 67839, '\P{Is_Blk=hatran}', "");
    Expect(1, 67839, '\P{^Is_Blk=hatran}', "");
    Expect(0, 67840, '\p{Is_Blk=hatran}', "");
    Expect(1, 67840, '\p{^Is_Blk=hatran}', "");
    Expect(1, 67840, '\P{Is_Blk=hatran}', "");
    Expect(0, 67840, '\P{^Is_Blk=hatran}', "");
    Expect(1, 67839, '\p{Is_Blk=Hatran}', "");
    Expect(0, 67839, '\p{^Is_Blk=Hatran}', "");
    Expect(0, 67839, '\P{Is_Blk=Hatran}', "");
    Expect(1, 67839, '\P{^Is_Blk=Hatran}', "");
    Expect(0, 67840, '\p{Is_Blk=Hatran}', "");
    Expect(1, 67840, '\p{^Is_Blk=Hatran}', "");
    Expect(1, 67840, '\P{Is_Blk=Hatran}', "");
    Expect(0, 67840, '\P{^Is_Blk=Hatran}', "");
    Error('\p{Block=/a/	-Hebrew}');
    Error('\P{Block=/a/	-Hebrew}');
    Expect(1, 1535, '\p{Block=:\AHebrew\z:}', "");;
    Expect(0, 1536, '\p{Block=:\AHebrew\z:}', "");;
    Expect(1, 1535, '\p{Block=hebrew}', "");
    Expect(0, 1535, '\p{^Block=hebrew}', "");
    Expect(0, 1535, '\P{Block=hebrew}', "");
    Expect(1, 1535, '\P{^Block=hebrew}', "");
    Expect(0, 1536, '\p{Block=hebrew}', "");
    Expect(1, 1536, '\p{^Block=hebrew}', "");
    Expect(1, 1536, '\P{Block=hebrew}', "");
    Expect(0, 1536, '\P{^Block=hebrew}', "");
    Expect(1, 1535, '\p{Block=:\Ahebrew\z:}', "");;
    Expect(0, 1536, '\p{Block=:\Ahebrew\z:}', "");;
    Expect(1, 1535, '\p{Block:   hebrew}', "");
    Expect(0, 1535, '\p{^Block:   hebrew}', "");
    Expect(0, 1535, '\P{Block:   hebrew}', "");
    Expect(1, 1535, '\P{^Block:   hebrew}', "");
    Expect(0, 1536, '\p{Block:   hebrew}', "");
    Expect(1, 1536, '\p{^Block:   hebrew}', "");
    Expect(1, 1536, '\P{Block:   hebrew}', "");
    Expect(0, 1536, '\P{^Block:   hebrew}', "");
    Error('\p{Blk: /a/  Hebrew}');
    Error('\P{Blk: /a/  Hebrew}');
    Expect(1, 1535, '\p{Blk=:\AHebrew\z:}', "");;
    Expect(0, 1536, '\p{Blk=:\AHebrew\z:}', "");;
    Expect(1, 1535, '\p{Blk=hebrew}', "");
    Expect(0, 1535, '\p{^Blk=hebrew}', "");
    Expect(0, 1535, '\P{Blk=hebrew}', "");
    Expect(1, 1535, '\P{^Blk=hebrew}', "");
    Expect(0, 1536, '\p{Blk=hebrew}', "");
    Expect(1, 1536, '\p{^Blk=hebrew}', "");
    Expect(1, 1536, '\P{Blk=hebrew}', "");
    Expect(0, 1536, '\P{^Blk=hebrew}', "");
    Expect(1, 1535, '\p{Blk=:\Ahebrew\z:}', "");;
    Expect(0, 1536, '\p{Blk=:\Ahebrew\z:}', "");;
    Expect(1, 1535, '\p{Blk= HEBREW}', "");
    Expect(0, 1535, '\p{^Blk= HEBREW}', "");
    Expect(0, 1535, '\P{Blk= HEBREW}', "");
    Expect(1, 1535, '\P{^Blk= HEBREW}', "");
    Expect(0, 1536, '\p{Blk= HEBREW}', "");
    Expect(1, 1536, '\p{^Blk= HEBREW}', "");
    Expect(1, 1536, '\P{Blk= HEBREW}', "");
    Expect(0, 1536, '\P{^Blk= HEBREW}', "");
    Error('\p{Is_Block=-HEBREW/a/}');
    Error('\P{Is_Block=-HEBREW/a/}');
    Expect(1, 1535, '\p{Is_Block=hebrew}', "");
    Expect(0, 1535, '\p{^Is_Block=hebrew}', "");
    Expect(0, 1535, '\P{Is_Block=hebrew}', "");
    Expect(1, 1535, '\P{^Is_Block=hebrew}', "");
    Expect(0, 1536, '\p{Is_Block=hebrew}', "");
    Expect(1, 1536, '\p{^Is_Block=hebrew}', "");
    Expect(1, 1536, '\P{Is_Block=hebrew}', "");
    Expect(0, 1536, '\P{^Is_Block=hebrew}', "");
    Expect(1, 1535, '\p{Is_Block=- Hebrew}', "");
    Expect(0, 1535, '\p{^Is_Block=- Hebrew}', "");
    Expect(0, 1535, '\P{Is_Block=- Hebrew}', "");
    Expect(1, 1535, '\P{^Is_Block=- Hebrew}', "");
    Expect(0, 1536, '\p{Is_Block=- Hebrew}', "");
    Expect(1, 1536, '\p{^Is_Block=- Hebrew}', "");
    Expect(1, 1536, '\P{Is_Block=- Hebrew}', "");
    Expect(0, 1536, '\P{^Is_Block=- Hebrew}', "");
    Error('\p{Is_Blk=:=  Hebrew}');
    Error('\P{Is_Blk=:=  Hebrew}');
    Expect(1, 1535, '\p{Is_Blk=hebrew}', "");
    Expect(0, 1535, '\p{^Is_Blk=hebrew}', "");
    Expect(0, 1535, '\P{Is_Blk=hebrew}', "");
    Expect(1, 1535, '\P{^Is_Blk=hebrew}', "");
    Expect(0, 1536, '\p{Is_Blk=hebrew}', "");
    Expect(1, 1536, '\p{^Is_Blk=hebrew}', "");
    Expect(1, 1536, '\P{Is_Blk=hebrew}', "");
    Expect(0, 1536, '\P{^Is_Blk=hebrew}', "");
    Expect(1, 1535, '\p{Is_Blk=--Hebrew}', "");
    Expect(0, 1535, '\p{^Is_Blk=--Hebrew}', "");
    Expect(0, 1535, '\P{Is_Blk=--Hebrew}', "");
    Expect(1, 1535, '\P{^Is_Blk=--Hebrew}', "");
    Expect(0, 1536, '\p{Is_Blk=--Hebrew}', "");
    Expect(1, 1536, '\p{^Is_Blk=--Hebrew}', "");
    Expect(1, 1536, '\P{Is_Blk=--Hebrew}', "");
    Expect(0, 1536, '\P{^Is_Blk=--Hebrew}', "");
    Error('\p{Block=/a/_ High_PRIVATE_use_SURROGATES}');
    Error('\P{Block=/a/_ High_PRIVATE_use_SURROGATES}');
    Expect(1, 56319, '\p{Block=:\AHigh_Private_Use_Surrogates\z:}', "");;
    Expect(0, 57344, '\p{Block=:\AHigh_Private_Use_Surrogates\z:}', "");;
    Expect(1, 56319, '\p{Block=highprivateusesurrogates}', "");
    Expect(0, 56319, '\p{^Block=highprivateusesurrogates}', "");
    Expect(0, 56319, '\P{Block=highprivateusesurrogates}', "");
    Expect(1, 56319, '\P{^Block=highprivateusesurrogates}', "");
    Expect(0, 57344, '\p{Block=highprivateusesurrogates}', "");
    Expect(1, 57344, '\p{^Block=highprivateusesurrogates}', "");
    Expect(1, 57344, '\P{Block=highprivateusesurrogates}', "");
    Expect(0, 57344, '\P{^Block=highprivateusesurrogates}', "");
    Expect(1, 56319, '\p{Block=:\Ahighprivateusesurrogates\z:}', "");;
    Expect(0, 57344, '\p{Block=:\Ahighprivateusesurrogates\z:}', "");;
    Expect(1, 56319, '\p{Block=	HIGH_PRIVATE_Use_surrogates}', "");
    Expect(0, 56319, '\p{^Block=	HIGH_PRIVATE_Use_surrogates}', "");
    Expect(0, 56319, '\P{Block=	HIGH_PRIVATE_Use_surrogates}', "");
    Expect(1, 56319, '\P{^Block=	HIGH_PRIVATE_Use_surrogates}', "");
    Expect(0, 57344, '\p{Block=	HIGH_PRIVATE_Use_surrogates}', "");
    Expect(1, 57344, '\p{^Block=	HIGH_PRIVATE_Use_surrogates}', "");
    Expect(1, 57344, '\P{Block=	HIGH_PRIVATE_Use_surrogates}', "");
    Expect(0, 57344, '\P{^Block=	HIGH_PRIVATE_Use_surrogates}', "");
    Error('\p{Blk=-_High_pu_SURROGATES/a/}');
    Error('\P{Blk=-_High_pu_SURROGATES/a/}');
    Expect(1, 56319, '\p{Blk=:\AHigh_PU_Surrogates\z:}', "");;
    Expect(0, 57344, '\p{Blk=:\AHigh_PU_Surrogates\z:}', "");;
    Expect(1, 56319, '\p{Blk=highpusurrogates}', "");
    Expect(0, 56319, '\p{^Blk=highpusurrogates}', "");
    Expect(0, 56319, '\P{Blk=highpusurrogates}', "");
    Expect(1, 56319, '\P{^Blk=highpusurrogates}', "");
    Expect(0, 57344, '\p{Blk=highpusurrogates}', "");
    Expect(1, 57344, '\p{^Blk=highpusurrogates}', "");
    Expect(1, 57344, '\P{Blk=highpusurrogates}', "");
    Expect(0, 57344, '\P{^Blk=highpusurrogates}', "");
    Expect(1, 56319, '\p{Blk=:\Ahighpusurrogates\z:}', "");;
    Expect(0, 57344, '\p{Blk=:\Ahighpusurrogates\z:}', "");;
    Expect(1, 56319, '\p{Blk= 	HIGH_PU_Surrogates}', "");
    Expect(0, 56319, '\p{^Blk= 	HIGH_PU_Surrogates}', "");
    Expect(0, 56319, '\P{Blk= 	HIGH_PU_Surrogates}', "");
    Expect(1, 56319, '\P{^Blk= 	HIGH_PU_Surrogates}', "");
    Expect(0, 57344, '\p{Blk= 	HIGH_PU_Surrogates}', "");
    Expect(1, 57344, '\p{^Blk= 	HIGH_PU_Surrogates}', "");
    Expect(1, 57344, '\P{Blk= 	HIGH_PU_Surrogates}', "");
    Expect(0, 57344, '\P{^Blk= 	HIGH_PU_Surrogates}', "");
    Error('\p{Is_Block: /a/-	High_Private_use_Surrogates}');
    Error('\P{Is_Block: /a/-	High_Private_use_Surrogates}');
    Expect(1, 56319, '\p{Is_Block=highprivateusesurrogates}', "");
    Expect(0, 56319, '\p{^Is_Block=highprivateusesurrogates}', "");
    Expect(0, 56319, '\P{Is_Block=highprivateusesurrogates}', "");
    Expect(1, 56319, '\P{^Is_Block=highprivateusesurrogates}', "");
    Expect(0, 57344, '\p{Is_Block=highprivateusesurrogates}', "");
    Expect(1, 57344, '\p{^Is_Block=highprivateusesurrogates}', "");
    Expect(1, 57344, '\P{Is_Block=highprivateusesurrogates}', "");
    Expect(0, 57344, '\P{^Is_Block=highprivateusesurrogates}', "");
    Expect(1, 56319, '\p{Is_Block=	 High_Private_Use_SURROGATES}', "");
    Expect(0, 56319, '\p{^Is_Block=	 High_Private_Use_SURROGATES}', "");
    Expect(0, 56319, '\P{Is_Block=	 High_Private_Use_SURROGATES}', "");
    Expect(1, 56319, '\P{^Is_Block=	 High_Private_Use_SURROGATES}', "");
    Expect(0, 57344, '\p{Is_Block=	 High_Private_Use_SURROGATES}', "");
    Expect(1, 57344, '\p{^Is_Block=	 High_Private_Use_SURROGATES}', "");
    Expect(1, 57344, '\P{Is_Block=	 High_Private_Use_SURROGATES}', "");
    Expect(0, 57344, '\P{^Is_Block=	 High_Private_Use_SURROGATES}', "");
    Error('\p{Is_Blk=	high_PU_Surrogates/a/}');
    Error('\P{Is_Blk=	high_PU_Surrogates/a/}');
    Expect(1, 56319, '\p{Is_Blk=highpusurrogates}', "");
    Expect(0, 56319, '\p{^Is_Blk=highpusurrogates}', "");
    Expect(0, 56319, '\P{Is_Blk=highpusurrogates}', "");
    Expect(1, 56319, '\P{^Is_Blk=highpusurrogates}', "");
    Expect(0, 57344, '\p{Is_Blk=highpusurrogates}', "");
    Expect(1, 57344, '\p{^Is_Blk=highpusurrogates}', "");
    Expect(1, 57344, '\P{Is_Blk=highpusurrogates}', "");
    Expect(0, 57344, '\P{^Is_Blk=highpusurrogates}', "");
    Expect(1, 56319, '\p{Is_Blk= HIGH_pu_Surrogates}', "");
    Expect(0, 56319, '\p{^Is_Blk= HIGH_pu_Surrogates}', "");
    Expect(0, 56319, '\P{Is_Blk= HIGH_pu_Surrogates}', "");
    Expect(1, 56319, '\P{^Is_Blk= HIGH_pu_Surrogates}', "");
    Expect(0, 57344, '\p{Is_Blk= HIGH_pu_Surrogates}', "");
    Expect(1, 57344, '\p{^Is_Blk= HIGH_pu_Surrogates}', "");
    Expect(1, 57344, '\P{Is_Blk= HIGH_pu_Surrogates}', "");
    Expect(0, 57344, '\P{^Is_Blk= HIGH_pu_Surrogates}', "");
    Error('\p{Block=:=_-High_Surrogates}');
    Error('\P{Block=:=_-High_Surrogates}');
    Expect(1, 56191, '\p{Block=:\AHigh_Surrogates\z:}', "");;
    Expect(0, 57344, '\p{Block=:\AHigh_Surrogates\z:}', "");;
    Expect(1, 56191, '\p{Block=highsurrogates}', "");
    Expect(0, 56191, '\p{^Block=highsurrogates}', "");
    Expect(0, 56191, '\P{Block=highsurrogates}', "");
    Expect(1, 56191, '\P{^Block=highsurrogates}', "");
    Expect(0, 57344, '\p{Block=highsurrogates}', "");
    Expect(1, 57344, '\p{^Block=highsurrogates}', "");
    Expect(1, 57344, '\P{Block=highsurrogates}', "");
    Expect(0, 57344, '\P{^Block=highsurrogates}', "");
    Expect(1, 56191, '\p{Block=:\Ahighsurrogates\z:}', "");;
    Expect(0, 57344, '\p{Block=:\Ahighsurrogates\z:}', "");;
    Expect(1, 56191, '\p{Block:	 High_surrogates}', "");
    Expect(0, 56191, '\p{^Block:	 High_surrogates}', "");
    Expect(0, 56191, '\P{Block:	 High_surrogates}', "");
    Expect(1, 56191, '\P{^Block:	 High_surrogates}', "");
    Expect(0, 57344, '\p{Block:	 High_surrogates}', "");
    Expect(1, 57344, '\p{^Block:	 High_surrogates}', "");
    Expect(1, 57344, '\P{Block:	 High_surrogates}', "");
    Expect(0, 57344, '\P{^Block:	 High_surrogates}', "");
    Error('\p{Blk= /a/high_SURROGATES}');
    Error('\P{Blk= /a/high_SURROGATES}');
    Expect(1, 56191, '\p{Blk=:\AHigh_Surrogates\z:}', "");;
    Expect(0, 57344, '\p{Blk=:\AHigh_Surrogates\z:}', "");;
    Expect(1, 56191, '\p{Blk=highsurrogates}', "");
    Expect(0, 56191, '\p{^Blk=highsurrogates}', "");
    Expect(0, 56191, '\P{Blk=highsurrogates}', "");
    Expect(1, 56191, '\P{^Blk=highsurrogates}', "");
    Expect(0, 57344, '\p{Blk=highsurrogates}', "");
    Expect(1, 57344, '\p{^Blk=highsurrogates}', "");
    Expect(1, 57344, '\P{Blk=highsurrogates}', "");
    Expect(0, 57344, '\P{^Blk=highsurrogates}', "");
    Expect(1, 56191, '\p{Blk=:\Ahighsurrogates\z:}', "");;
    Expect(0, 57344, '\p{Blk=:\Ahighsurrogates\z:}', "");;
    Expect(1, 56191, '\p{Blk=__HIGH_SURROGATES}', "");
    Expect(0, 56191, '\p{^Blk=__HIGH_SURROGATES}', "");
    Expect(0, 56191, '\P{Blk=__HIGH_SURROGATES}', "");
    Expect(1, 56191, '\P{^Blk=__HIGH_SURROGATES}', "");
    Expect(0, 57344, '\p{Blk=__HIGH_SURROGATES}', "");
    Expect(1, 57344, '\p{^Blk=__HIGH_SURROGATES}', "");
    Expect(1, 57344, '\P{Blk=__HIGH_SURROGATES}', "");
    Expect(0, 57344, '\P{^Blk=__HIGH_SURROGATES}', "");
    Error('\p{Is_Block=/a/  High_Surrogates}');
    Error('\P{Is_Block=/a/  High_Surrogates}');
    Expect(1, 56191, '\p{Is_Block=highsurrogates}', "");
    Expect(0, 56191, '\p{^Is_Block=highsurrogates}', "");
    Expect(0, 56191, '\P{Is_Block=highsurrogates}', "");
    Expect(1, 56191, '\P{^Is_Block=highsurrogates}', "");
    Expect(0, 57344, '\p{Is_Block=highsurrogates}', "");
    Expect(1, 57344, '\p{^Is_Block=highsurrogates}', "");
    Expect(1, 57344, '\P{Is_Block=highsurrogates}', "");
    Expect(0, 57344, '\P{^Is_Block=highsurrogates}', "");
    Expect(1, 56191, '\p{Is_Block=		high_Surrogates}', "");
    Expect(0, 56191, '\p{^Is_Block=		high_Surrogates}', "");
    Expect(0, 56191, '\P{Is_Block=		high_Surrogates}', "");
    Expect(1, 56191, '\P{^Is_Block=		high_Surrogates}', "");
    Expect(0, 57344, '\p{Is_Block=		high_Surrogates}', "");
    Expect(1, 57344, '\p{^Is_Block=		high_Surrogates}', "");
    Expect(1, 57344, '\P{Is_Block=		high_Surrogates}', "");
    Expect(0, 57344, '\P{^Is_Block=		high_Surrogates}', "");
    Error('\p{Is_Blk=:=__high_surrogates}');
    Error('\P{Is_Blk=:=__high_surrogates}');
    Expect(1, 56191, '\p{Is_Blk=highsurrogates}', "");
    Expect(0, 56191, '\p{^Is_Blk=highsurrogates}', "");
    Expect(0, 56191, '\P{Is_Blk=highsurrogates}', "");
    Expect(1, 56191, '\P{^Is_Blk=highsurrogates}', "");
    Expect(0, 57344, '\p{Is_Blk=highsurrogates}', "");
    Expect(1, 57344, '\p{^Is_Blk=highsurrogates}', "");
    Expect(1, 57344, '\P{Is_Blk=highsurrogates}', "");
    Expect(0, 57344, '\P{^Is_Blk=highsurrogates}', "");
    Expect(1, 56191, '\p{Is_Blk=High_Surrogates}', "");
    Expect(0, 56191, '\p{^Is_Blk=High_Surrogates}', "");
    Expect(0, 56191, '\P{Is_Blk=High_Surrogates}', "");
    Expect(1, 56191, '\P{^Is_Blk=High_Surrogates}', "");
    Expect(0, 57344, '\p{Is_Blk=High_Surrogates}', "");
    Expect(1, 57344, '\p{^Is_Blk=High_Surrogates}', "");
    Expect(1, 57344, '\P{Is_Blk=High_Surrogates}', "");
    Expect(0, 57344, '\P{^Is_Blk=High_Surrogates}', "");
    Error('\p{Block= _Hiragana:=}');
    Error('\P{Block= _Hiragana:=}');
    Expect(1, 12447, '\p{Block=:\AHiragana\z:}', "");;
    Expect(0, 12448, '\p{Block=:\AHiragana\z:}', "");;
    Expect(1, 12447, '\p{Block=hiragana}', "");
    Expect(0, 12447, '\p{^Block=hiragana}', "");
    Expect(0, 12447, '\P{Block=hiragana}', "");
    Expect(1, 12447, '\P{^Block=hiragana}', "");
    Expect(0, 12448, '\p{Block=hiragana}', "");
    Expect(1, 12448, '\p{^Block=hiragana}', "");
    Expect(1, 12448, '\P{Block=hiragana}', "");
    Expect(0, 12448, '\P{^Block=hiragana}', "");
    Expect(1, 12447, '\p{Block=:\Ahiragana\z:}', "");;
    Expect(0, 12448, '\p{Block=:\Ahiragana\z:}', "");;
    Expect(1, 12447, '\p{Block:	-	Hiragana}', "");
    Expect(0, 12447, '\p{^Block:	-	Hiragana}', "");
    Expect(0, 12447, '\P{Block:	-	Hiragana}', "");
    Expect(1, 12447, '\P{^Block:	-	Hiragana}', "");
    Expect(0, 12448, '\p{Block:	-	Hiragana}', "");
    Expect(1, 12448, '\p{^Block:	-	Hiragana}', "");
    Expect(1, 12448, '\P{Block:	-	Hiragana}', "");
    Expect(0, 12448, '\P{^Block:	-	Hiragana}', "");
    Error('\p{Blk=:=_Hiragana}');
    Error('\P{Blk=:=_Hiragana}');
    Expect(1, 12447, '\p{Blk=:\AHiragana\z:}', "");;
    Expect(0, 12448, '\p{Blk=:\AHiragana\z:}', "");;
    Expect(1, 12447, '\p{Blk=hiragana}', "");
    Expect(0, 12447, '\p{^Blk=hiragana}', "");
    Expect(0, 12447, '\P{Blk=hiragana}', "");
    Expect(1, 12447, '\P{^Blk=hiragana}', "");
    Expect(0, 12448, '\p{Blk=hiragana}', "");
    Expect(1, 12448, '\p{^Blk=hiragana}', "");
    Expect(1, 12448, '\P{Blk=hiragana}', "");
    Expect(0, 12448, '\P{^Blk=hiragana}', "");
    Expect(1, 12447, '\p{Blk=:\Ahiragana\z:}', "");;
    Expect(0, 12448, '\p{Blk=:\Ahiragana\z:}', "");;
    Expect(1, 12447, '\p{Blk=-_HIRAGANA}', "");
    Expect(0, 12447, '\p{^Blk=-_HIRAGANA}', "");
    Expect(0, 12447, '\P{Blk=-_HIRAGANA}', "");
    Expect(1, 12447, '\P{^Blk=-_HIRAGANA}', "");
    Expect(0, 12448, '\p{Blk=-_HIRAGANA}', "");
    Expect(1, 12448, '\p{^Blk=-_HIRAGANA}', "");
    Expect(1, 12448, '\P{Blk=-_HIRAGANA}', "");
    Expect(0, 12448, '\P{^Blk=-_HIRAGANA}', "");
    Error('\p{Is_Block=/a/ -Hiragana}');
    Error('\P{Is_Block=/a/ -Hiragana}');
    Expect(1, 12447, '\p{Is_Block=hiragana}', "");
    Expect(0, 12447, '\p{^Is_Block=hiragana}', "");
    Expect(0, 12447, '\P{Is_Block=hiragana}', "");
    Expect(1, 12447, '\P{^Is_Block=hiragana}', "");
    Expect(0, 12448, '\p{Is_Block=hiragana}', "");
    Expect(1, 12448, '\p{^Is_Block=hiragana}', "");
    Expect(1, 12448, '\P{Is_Block=hiragana}', "");
    Expect(0, 12448, '\P{^Is_Block=hiragana}', "");
    Expect(1, 12447, '\p{Is_Block=-	Hiragana}', "");
    Expect(0, 12447, '\p{^Is_Block=-	Hiragana}', "");
    Expect(0, 12447, '\P{Is_Block=-	Hiragana}', "");
    Expect(1, 12447, '\P{^Is_Block=-	Hiragana}', "");
    Expect(0, 12448, '\p{Is_Block=-	Hiragana}', "");
    Expect(1, 12448, '\p{^Is_Block=-	Hiragana}', "");
    Expect(1, 12448, '\P{Is_Block=-	Hiragana}', "");
    Expect(0, 12448, '\P{^Is_Block=-	Hiragana}', "");
    Error('\p{Is_Blk= /a/Hiragana}');
    Error('\P{Is_Blk= /a/Hiragana}');
    Expect(1, 12447, '\p{Is_Blk:hiragana}', "");
    Expect(0, 12447, '\p{^Is_Blk:hiragana}', "");
    Expect(0, 12447, '\P{Is_Blk:hiragana}', "");
    Expect(1, 12447, '\P{^Is_Blk:hiragana}', "");
    Expect(0, 12448, '\p{Is_Blk:hiragana}', "");
    Expect(1, 12448, '\p{^Is_Blk:hiragana}', "");
    Expect(1, 12448, '\P{Is_Blk:hiragana}', "");
    Expect(0, 12448, '\P{^Is_Blk:hiragana}', "");
    Expect(1, 12447, '\p{Is_Blk=	Hiragana}', "");
    Expect(0, 12447, '\p{^Is_Blk=	Hiragana}', "");
    Expect(0, 12447, '\P{Is_Blk=	Hiragana}', "");
    Expect(1, 12447, '\P{^Is_Blk=	Hiragana}', "");
    Expect(0, 12448, '\p{Is_Blk=	Hiragana}', "");
    Expect(1, 12448, '\p{^Is_Blk=	Hiragana}', "");
    Expect(1, 12448, '\P{Is_Blk=	Hiragana}', "");
    Expect(0, 12448, '\P{^Is_Blk=	Hiragana}', "");
    Error('\p{Block=_:=Ideographic_description_CHARACTERS}');
    Error('\P{Block=_:=Ideographic_description_CHARACTERS}');
    Expect(1, 12287, '\p{Block=:\AIdeographic_Description_Characters\z:}', "");;
    Expect(0, 12288, '\p{Block=:\AIdeographic_Description_Characters\z:}', "");;
    Expect(1, 12287, '\p{Block=ideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\p{^Block=ideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\P{Block=ideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\P{^Block=ideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\p{Block=ideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\p{^Block=ideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\P{Block=ideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\P{^Block=ideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\p{Block=:\Aideographicdescriptioncharacters\z:}', "");;
    Expect(0, 12288, '\p{Block=:\Aideographicdescriptioncharacters\z:}', "");;
    Expect(1, 12287, '\p{Block=	ideographic_DESCRIPTION_Characters}', "");
    Expect(0, 12287, '\p{^Block=	ideographic_DESCRIPTION_Characters}', "");
    Expect(0, 12287, '\P{Block=	ideographic_DESCRIPTION_Characters}', "");
    Expect(1, 12287, '\P{^Block=	ideographic_DESCRIPTION_Characters}', "");
    Expect(0, 12288, '\p{Block=	ideographic_DESCRIPTION_Characters}', "");
    Expect(1, 12288, '\p{^Block=	ideographic_DESCRIPTION_Characters}', "");
    Expect(1, 12288, '\P{Block=	ideographic_DESCRIPTION_Characters}', "");
    Expect(0, 12288, '\P{^Block=	ideographic_DESCRIPTION_Characters}', "");
    Error('\p{Blk=-/a/IDC}');
    Error('\P{Blk=-/a/IDC}');
    Expect(1, 12287, '\p{Blk=:\AIDC\z:}', "");;
    Expect(0, 12288, '\p{Blk=:\AIDC\z:}', "");;
    Expect(1, 12287, '\p{Blk=idc}', "");
    Expect(0, 12287, '\p{^Blk=idc}', "");
    Expect(0, 12287, '\P{Blk=idc}', "");
    Expect(1, 12287, '\P{^Blk=idc}', "");
    Expect(0, 12288, '\p{Blk=idc}', "");
    Expect(1, 12288, '\p{^Blk=idc}', "");
    Expect(1, 12288, '\P{Blk=idc}', "");
    Expect(0, 12288, '\P{^Blk=idc}', "");
    Expect(1, 12287, '\p{Blk=:\Aidc\z:}', "");;
    Expect(0, 12288, '\p{Blk=:\Aidc\z:}', "");;
    Expect(1, 12287, '\p{Blk=_IDC}', "");
    Expect(0, 12287, '\p{^Blk=_IDC}', "");
    Expect(0, 12287, '\P{Blk=_IDC}', "");
    Expect(1, 12287, '\P{^Blk=_IDC}', "");
    Expect(0, 12288, '\p{Blk=_IDC}', "");
    Expect(1, 12288, '\p{^Blk=_IDC}', "");
    Expect(1, 12288, '\P{Blk=_IDC}', "");
    Expect(0, 12288, '\P{^Blk=_IDC}', "");
    Error('\p{Is_Block:  :=Ideographic_Description_Characters}');
    Error('\P{Is_Block:  :=Ideographic_Description_Characters}');
    Expect(1, 12287, '\p{Is_Block:ideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\p{^Is_Block:ideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\P{Is_Block:ideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\P{^Is_Block:ideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\p{Is_Block:ideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\p{^Is_Block:ideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\P{Is_Block:ideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\P{^Is_Block:ideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\p{Is_Block=	-Ideographic_Description_Characters}', "");
    Expect(0, 12287, '\p{^Is_Block=	-Ideographic_Description_Characters}', "");
    Expect(0, 12287, '\P{Is_Block=	-Ideographic_Description_Characters}', "");
    Expect(1, 12287, '\P{^Is_Block=	-Ideographic_Description_Characters}', "");
    Expect(0, 12288, '\p{Is_Block=	-Ideographic_Description_Characters}', "");
    Expect(1, 12288, '\p{^Is_Block=	-Ideographic_Description_Characters}', "");
    Expect(1, 12288, '\P{Is_Block=	-Ideographic_Description_Characters}', "");
    Expect(0, 12288, '\P{^Is_Block=	-Ideographic_Description_Characters}', "");
    Error('\p{Is_Blk=_ IDC/a/}');
    Error('\P{Is_Blk=_ IDC/a/}');
    Expect(1, 12287, '\p{Is_Blk=idc}', "");
    Expect(0, 12287, '\p{^Is_Blk=idc}', "");
    Expect(0, 12287, '\P{Is_Blk=idc}', "");
    Expect(1, 12287, '\P{^Is_Blk=idc}', "");
    Expect(0, 12288, '\p{Is_Blk=idc}', "");
    Expect(1, 12288, '\p{^Is_Blk=idc}', "");
    Expect(1, 12288, '\P{Is_Blk=idc}', "");
    Expect(0, 12288, '\P{^Is_Blk=idc}', "");
    Expect(1, 12287, '\p{Is_Blk=-	IDC}', "");
    Expect(0, 12287, '\p{^Is_Blk=-	IDC}', "");
    Expect(0, 12287, '\P{Is_Blk=-	IDC}', "");
    Expect(1, 12287, '\P{^Is_Blk=-	IDC}', "");
    Expect(0, 12288, '\p{Is_Blk=-	IDC}', "");
    Expect(1, 12288, '\p{^Is_Blk=-	IDC}', "");
    Expect(1, 12288, '\P{Is_Blk=-	IDC}', "");
    Expect(0, 12288, '\P{^Is_Blk=-	IDC}', "");
    Error('\p{Block=:=ideographic_symbols_And_punctuation}');
    Error('\P{Block=:=ideographic_symbols_And_punctuation}');
    Expect(1, 94207, '\p{Block=:\AIdeographic_Symbols_And_Punctuation\z:}', "");;
    Expect(0, 94208, '\p{Block=:\AIdeographic_Symbols_And_Punctuation\z:}', "");;
    Expect(1, 94207, '\p{Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\p{^Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\P{Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\P{^Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\p{Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\p{^Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\P{Block=ideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\P{^Block=ideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\p{Block=:\Aideographicsymbolsandpunctuation\z:}', "");;
    Expect(0, 94208, '\p{Block=:\Aideographicsymbolsandpunctuation\z:}', "");;
    Expect(1, 94207, '\p{Block=_Ideographic_Symbols_And_PUNCTUATION}', "");
    Expect(0, 94207, '\p{^Block=_Ideographic_Symbols_And_PUNCTUATION}', "");
    Expect(0, 94207, '\P{Block=_Ideographic_Symbols_And_PUNCTUATION}', "");
    Expect(1, 94207, '\P{^Block=_Ideographic_Symbols_And_PUNCTUATION}', "");
    Expect(0, 94208, '\p{Block=_Ideographic_Symbols_And_PUNCTUATION}', "");
    Expect(1, 94208, '\p{^Block=_Ideographic_Symbols_And_PUNCTUATION}', "");
    Expect(1, 94208, '\P{Block=_Ideographic_Symbols_And_PUNCTUATION}', "");
    Expect(0, 94208, '\P{^Block=_Ideographic_Symbols_And_PUNCTUATION}', "");
    Error('\p{Blk=:= 	IDEOGRAPHIC_Symbols}');
    Error('\P{Blk=:= 	IDEOGRAPHIC_Symbols}');
    Expect(1, 94207, '\p{Blk=:\AIdeographic_Symbols\z:}', "");;
    Expect(0, 94208, '\p{Blk=:\AIdeographic_Symbols\z:}', "");;
    Expect(1, 94207, '\p{Blk=ideographicsymbols}', "");
    Expect(0, 94207, '\p{^Blk=ideographicsymbols}', "");
    Expect(0, 94207, '\P{Blk=ideographicsymbols}', "");
    Expect(1, 94207, '\P{^Blk=ideographicsymbols}', "");
    Expect(0, 94208, '\p{Blk=ideographicsymbols}', "");
    Expect(1, 94208, '\p{^Blk=ideographicsymbols}', "");
    Expect(1, 94208, '\P{Blk=ideographicsymbols}', "");
    Expect(0, 94208, '\P{^Blk=ideographicsymbols}', "");
    Expect(1, 94207, '\p{Blk=:\Aideographicsymbols\z:}', "");;
    Expect(0, 94208, '\p{Blk=:\Aideographicsymbols\z:}', "");;
    Expect(1, 94207, '\p{Blk=		ideographic_Symbols}', "");
    Expect(0, 94207, '\p{^Blk=		ideographic_Symbols}', "");
    Expect(0, 94207, '\P{Blk=		ideographic_Symbols}', "");
    Expect(1, 94207, '\P{^Blk=		ideographic_Symbols}', "");
    Expect(0, 94208, '\p{Blk=		ideographic_Symbols}', "");
    Expect(1, 94208, '\p{^Blk=		ideographic_Symbols}', "");
    Expect(1, 94208, '\P{Blk=		ideographic_Symbols}', "");
    Expect(0, 94208, '\P{^Blk=		ideographic_Symbols}', "");
    Error('\p{Is_Block=:=IDEOGRAPHIC_Symbols_and_punctuation}');
    Error('\P{Is_Block=:=IDEOGRAPHIC_Symbols_and_punctuation}');
    Expect(1, 94207, '\p{Is_Block: ideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\p{^Is_Block: ideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\P{Is_Block: ideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\P{^Is_Block: ideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\p{Is_Block: ideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\p{^Is_Block: ideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\P{Is_Block: ideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\P{^Is_Block: ideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\p{Is_Block=	ideographic_Symbols_And_PUNCTUATION}', "");
    Expect(0, 94207, '\p{^Is_Block=	ideographic_Symbols_And_PUNCTUATION}', "");
    Expect(0, 94207, '\P{Is_Block=	ideographic_Symbols_And_PUNCTUATION}', "");
    Expect(1, 94207, '\P{^Is_Block=	ideographic_Symbols_And_PUNCTUATION}', "");
    Expect(0, 94208, '\p{Is_Block=	ideographic_Symbols_And_PUNCTUATION}', "");
    Expect(1, 94208, '\p{^Is_Block=	ideographic_Symbols_And_PUNCTUATION}', "");
    Expect(1, 94208, '\P{Is_Block=	ideographic_Symbols_And_PUNCTUATION}', "");
    Expect(0, 94208, '\P{^Is_Block=	ideographic_Symbols_And_PUNCTUATION}', "");
    Error('\p{Is_Blk=	:=IDEOGRAPHIC_Symbols}');
    Error('\P{Is_Blk=	:=IDEOGRAPHIC_Symbols}');
    Expect(1, 94207, '\p{Is_Blk=ideographicsymbols}', "");
    Expect(0, 94207, '\p{^Is_Blk=ideographicsymbols}', "");
    Expect(0, 94207, '\P{Is_Blk=ideographicsymbols}', "");
    Expect(1, 94207, '\P{^Is_Blk=ideographicsymbols}', "");
    Expect(0, 94208, '\p{Is_Blk=ideographicsymbols}', "");
    Expect(1, 94208, '\p{^Is_Blk=ideographicsymbols}', "");
    Expect(1, 94208, '\P{Is_Blk=ideographicsymbols}', "");
    Expect(0, 94208, '\P{^Is_Blk=ideographicsymbols}', "");
    Expect(1, 94207, '\p{Is_Blk=IDEOGRAPHIC_Symbols}', "");
    Expect(0, 94207, '\p{^Is_Blk=IDEOGRAPHIC_Symbols}', "");
    Expect(0, 94207, '\P{Is_Blk=IDEOGRAPHIC_Symbols}', "");
    Expect(1, 94207, '\P{^Is_Blk=IDEOGRAPHIC_Symbols}', "");
    Expect(0, 94208, '\p{Is_Blk=IDEOGRAPHIC_Symbols}', "");
    Expect(1, 94208, '\p{^Is_Blk=IDEOGRAPHIC_Symbols}', "");
    Expect(1, 94208, '\P{Is_Blk=IDEOGRAPHIC_Symbols}', "");
    Expect(0, 94208, '\P{^Is_Blk=IDEOGRAPHIC_Symbols}', "");
    Error('\p{Block=- Imperial_Aramaic:=}');
    Error('\P{Block=- Imperial_Aramaic:=}');
    Expect(1, 67679, '\p{Block=:\AImperial_Aramaic\z:}', "");;
    Expect(0, 67680, '\p{Block=:\AImperial_Aramaic\z:}', "");;
    Expect(1, 67679, '\p{Block=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Block=imperialaramaic}', "");
    Expect(0, 67679, '\P{Block=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Block=imperialaramaic}', "");
    Expect(0, 67680, '\p{Block=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Block=imperialaramaic}', "");
    Expect(1, 67680, '\P{Block=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Block=imperialaramaic}', "");
    Expect(1, 67679, '\p{Block=:\Aimperialaramaic\z:}', "");;
    Expect(0, 67680, '\p{Block=:\Aimperialaramaic\z:}', "");;
    Expect(1, 67679, '\p{Block= Imperial_ARAMAIC}', "");
    Expect(0, 67679, '\p{^Block= Imperial_ARAMAIC}', "");
    Expect(0, 67679, '\P{Block= Imperial_ARAMAIC}', "");
    Expect(1, 67679, '\P{^Block= Imperial_ARAMAIC}', "");
    Expect(0, 67680, '\p{Block= Imperial_ARAMAIC}', "");
    Expect(1, 67680, '\p{^Block= Imperial_ARAMAIC}', "");
    Expect(1, 67680, '\P{Block= Imperial_ARAMAIC}', "");
    Expect(0, 67680, '\P{^Block= Imperial_ARAMAIC}', "");
    Error('\p{Blk=  Imperial_aramaic:=}');
    Error('\P{Blk=  Imperial_aramaic:=}');
    Expect(1, 67679, '\p{Blk=:\AImperial_Aramaic\z:}', "");;
    Expect(0, 67680, '\p{Blk=:\AImperial_Aramaic\z:}', "");;
    Expect(1, 67679, '\p{Blk=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Blk=imperialaramaic}', "");
    Expect(0, 67679, '\P{Blk=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Blk=imperialaramaic}', "");
    Expect(0, 67680, '\p{Blk=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Blk=imperialaramaic}', "");
    Expect(1, 67680, '\P{Blk=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Blk=imperialaramaic}', "");
    Expect(1, 67679, '\p{Blk=:\Aimperialaramaic\z:}', "");;
    Expect(0, 67680, '\p{Blk=:\Aimperialaramaic\z:}', "");;
    Expect(1, 67679, '\p{Blk=-Imperial_Aramaic}', "");
    Expect(0, 67679, '\p{^Blk=-Imperial_Aramaic}', "");
    Expect(0, 67679, '\P{Blk=-Imperial_Aramaic}', "");
    Expect(1, 67679, '\P{^Blk=-Imperial_Aramaic}', "");
    Expect(0, 67680, '\p{Blk=-Imperial_Aramaic}', "");
    Expect(1, 67680, '\p{^Blk=-Imperial_Aramaic}', "");
    Expect(1, 67680, '\P{Blk=-Imperial_Aramaic}', "");
    Expect(0, 67680, '\P{^Blk=-Imperial_Aramaic}', "");
    Error('\p{Is_Block=	:=Imperial_Aramaic}');
    Error('\P{Is_Block=	:=Imperial_Aramaic}');
    Expect(1, 67679, '\p{Is_Block=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Is_Block=imperialaramaic}', "");
    Expect(0, 67679, '\P{Is_Block=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Is_Block=imperialaramaic}', "");
    Expect(0, 67680, '\p{Is_Block=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Is_Block=imperialaramaic}', "");
    Expect(1, 67680, '\P{Is_Block=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Is_Block=imperialaramaic}', "");
    Expect(1, 67679, '\p{Is_Block=--imperial_Aramaic}', "");
    Expect(0, 67679, '\p{^Is_Block=--imperial_Aramaic}', "");
    Expect(0, 67679, '\P{Is_Block=--imperial_Aramaic}', "");
    Expect(1, 67679, '\P{^Is_Block=--imperial_Aramaic}', "");
    Expect(0, 67680, '\p{Is_Block=--imperial_Aramaic}', "");
    Expect(1, 67680, '\p{^Is_Block=--imperial_Aramaic}', "");
    Expect(1, 67680, '\P{Is_Block=--imperial_Aramaic}', "");
    Expect(0, 67680, '\P{^Is_Block=--imperial_Aramaic}', "");
    Error('\p{Is_Blk=:= Imperial_Aramaic}');
    Error('\P{Is_Blk=:= Imperial_Aramaic}');
    Expect(1, 67679, '\p{Is_Blk=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Is_Blk=imperialaramaic}', "");
    Expect(0, 67679, '\P{Is_Blk=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Is_Blk=imperialaramaic}', "");
    Expect(0, 67680, '\p{Is_Blk=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Is_Blk=imperialaramaic}', "");
    Expect(1, 67680, '\P{Is_Blk=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Is_Blk=imperialaramaic}', "");
    Expect(1, 67679, '\p{Is_Blk= -Imperial_Aramaic}', "");
    Expect(0, 67679, '\p{^Is_Blk= -Imperial_Aramaic}', "");
    Expect(0, 67679, '\P{Is_Blk= -Imperial_Aramaic}', "");
    Expect(1, 67679, '\P{^Is_Blk= -Imperial_Aramaic}', "");
    Expect(0, 67680, '\p{Is_Blk= -Imperial_Aramaic}', "");
    Expect(1, 67680, '\p{^Is_Blk= -Imperial_Aramaic}', "");
    Expect(1, 67680, '\P{Is_Blk= -Imperial_Aramaic}', "");
    Expect(0, 67680, '\P{^Is_Blk= -Imperial_Aramaic}', "");
    Error('\p{Block=:=- Common_indic_NUMBER_forms}');
    Error('\P{Block=:=- Common_indic_NUMBER_forms}');
    Expect(1, 43071, '\p{Block=:\ACommon_Indic_Number_Forms\z:}', "");;
    Expect(0, 43072, '\p{Block=:\ACommon_Indic_Number_Forms\z:}', "");;
    Expect(1, 43071, '\p{Block=commonindicnumberforms}', "");
    Expect(0, 43071, '\p{^Block=commonindicnumberforms}', "");
    Expect(0, 43071, '\P{Block=commonindicnumberforms}', "");
    Expect(1, 43071, '\P{^Block=commonindicnumberforms}', "");
    Expect(0, 43072, '\p{Block=commonindicnumberforms}', "");
    Expect(1, 43072, '\p{^Block=commonindicnumberforms}', "");
    Expect(1, 43072, '\P{Block=commonindicnumberforms}', "");
    Expect(0, 43072, '\P{^Block=commonindicnumberforms}', "");
    Expect(1, 43071, '\p{Block=:\Acommonindicnumberforms\z:}', "");;
    Expect(0, 43072, '\p{Block=:\Acommonindicnumberforms\z:}', "");;
    Expect(1, 43071, '\p{Block=- COMMON_Indic_NUMBER_FORMS}', "");
    Expect(0, 43071, '\p{^Block=- COMMON_Indic_NUMBER_FORMS}', "");
    Expect(0, 43071, '\P{Block=- COMMON_Indic_NUMBER_FORMS}', "");
    Expect(1, 43071, '\P{^Block=- COMMON_Indic_NUMBER_FORMS}', "");
    Expect(0, 43072, '\p{Block=- COMMON_Indic_NUMBER_FORMS}', "");
    Expect(1, 43072, '\p{^Block=- COMMON_Indic_NUMBER_FORMS}', "");
    Expect(1, 43072, '\P{Block=- COMMON_Indic_NUMBER_FORMS}', "");
    Expect(0, 43072, '\P{^Block=- COMMON_Indic_NUMBER_FORMS}', "");
    Error('\p{Blk:   -/a/Indic_Number_forms}');
    Error('\P{Blk:   -/a/Indic_Number_forms}');
    Expect(1, 43071, '\p{Blk=:\AIndic_Number_Forms\z:}', "");;
    Expect(0, 43072, '\p{Blk=:\AIndic_Number_Forms\z:}', "");;
    Expect(1, 43071, '\p{Blk=indicnumberforms}', "");
    Expect(0, 43071, '\p{^Blk=indicnumberforms}', "");
    Expect(0, 43071, '\P{Blk=indicnumberforms}', "");
    Expect(1, 43071, '\P{^Blk=indicnumberforms}', "");
    Expect(0, 43072, '\p{Blk=indicnumberforms}', "");
    Expect(1, 43072, '\p{^Blk=indicnumberforms}', "");
    Expect(1, 43072, '\P{Blk=indicnumberforms}', "");
    Expect(0, 43072, '\P{^Blk=indicnumberforms}', "");
    Expect(1, 43071, '\p{Blk=:\Aindicnumberforms\z:}', "");;
    Expect(0, 43072, '\p{Blk=:\Aindicnumberforms\z:}', "");;
    Expect(1, 43071, '\p{Blk=_Indic_number_Forms}', "");
    Expect(0, 43071, '\p{^Blk=_Indic_number_Forms}', "");
    Expect(0, 43071, '\P{Blk=_Indic_number_Forms}', "");
    Expect(1, 43071, '\P{^Blk=_Indic_number_Forms}', "");
    Expect(0, 43072, '\p{Blk=_Indic_number_Forms}', "");
    Expect(1, 43072, '\p{^Blk=_Indic_number_Forms}', "");
    Expect(1, 43072, '\P{Blk=_Indic_number_Forms}', "");
    Expect(0, 43072, '\P{^Blk=_Indic_number_Forms}', "");
    Error('\p{Is_Block=	_Common_Indic_Number_Forms/a/}');
    Error('\P{Is_Block=	_Common_Indic_Number_Forms/a/}');
    Expect(1, 43071, '\p{Is_Block=commonindicnumberforms}', "");
    Expect(0, 43071, '\p{^Is_Block=commonindicnumberforms}', "");
    Expect(0, 43071, '\P{Is_Block=commonindicnumberforms}', "");
    Expect(1, 43071, '\P{^Is_Block=commonindicnumberforms}', "");
    Expect(0, 43072, '\p{Is_Block=commonindicnumberforms}', "");
    Expect(1, 43072, '\p{^Is_Block=commonindicnumberforms}', "");
    Expect(1, 43072, '\P{Is_Block=commonindicnumberforms}', "");
    Expect(0, 43072, '\P{^Is_Block=commonindicnumberforms}', "");
    Expect(1, 43071, '\p{Is_Block=	Common_indic_NUMBER_Forms}', "");
    Expect(0, 43071, '\p{^Is_Block=	Common_indic_NUMBER_Forms}', "");
    Expect(0, 43071, '\P{Is_Block=	Common_indic_NUMBER_Forms}', "");
    Expect(1, 43071, '\P{^Is_Block=	Common_indic_NUMBER_Forms}', "");
    Expect(0, 43072, '\p{Is_Block=	Common_indic_NUMBER_Forms}', "");
    Expect(1, 43072, '\p{^Is_Block=	Common_indic_NUMBER_Forms}', "");
    Expect(1, 43072, '\P{Is_Block=	Common_indic_NUMBER_Forms}', "");
    Expect(0, 43072, '\P{^Is_Block=	Common_indic_NUMBER_Forms}', "");
    Error('\p{Is_Blk=/a/	INDIC_Number_Forms}');
    Error('\P{Is_Blk=/a/	INDIC_Number_Forms}');
    Expect(1, 43071, '\p{Is_Blk=indicnumberforms}', "");
    Expect(0, 43071, '\p{^Is_Blk=indicnumberforms}', "");
    Expect(0, 43071, '\P{Is_Blk=indicnumberforms}', "");
    Expect(1, 43071, '\P{^Is_Blk=indicnumberforms}', "");
    Expect(0, 43072, '\p{Is_Blk=indicnumberforms}', "");
    Expect(1, 43072, '\p{^Is_Blk=indicnumberforms}', "");
    Expect(1, 43072, '\P{Is_Blk=indicnumberforms}', "");
    Expect(0, 43072, '\P{^Is_Blk=indicnumberforms}', "");
    Expect(1, 43071, '\p{Is_Blk=Indic_number_FORMS}', "");
    Expect(0, 43071, '\p{^Is_Blk=Indic_number_FORMS}', "");
    Expect(0, 43071, '\P{Is_Blk=Indic_number_FORMS}', "");
    Expect(1, 43071, '\P{^Is_Blk=Indic_number_FORMS}', "");
    Expect(0, 43072, '\p{Is_Blk=Indic_number_FORMS}', "");
    Expect(1, 43072, '\p{^Is_Blk=Indic_number_FORMS}', "");
    Expect(1, 43072, '\P{Is_Blk=Indic_number_FORMS}', "");
    Expect(0, 43072, '\P{^Is_Blk=Indic_number_FORMS}', "");
    Error('\p{Block=	-INDIC_siyaq_NUMBERS/a/}');
    Error('\P{Block=	-INDIC_siyaq_NUMBERS/a/}');
    Expect(1, 126143, '\p{Block=:\AIndic_Siyaq_Numbers\z:}', "");;
    Expect(0, 126144, '\p{Block=:\AIndic_Siyaq_Numbers\z:}', "");;
    Expect(1, 126143, '\p{Block=indicsiyaqnumbers}', "");
    Expect(0, 126143, '\p{^Block=indicsiyaqnumbers}', "");
    Expect(0, 126143, '\P{Block=indicsiyaqnumbers}', "");
    Expect(1, 126143, '\P{^Block=indicsiyaqnumbers}', "");
    Expect(0, 126144, '\p{Block=indicsiyaqnumbers}', "");
    Expect(1, 126144, '\p{^Block=indicsiyaqnumbers}', "");
    Expect(1, 126144, '\P{Block=indicsiyaqnumbers}', "");
    Expect(0, 126144, '\P{^Block=indicsiyaqnumbers}', "");
    Expect(1, 126143, '\p{Block=:\Aindicsiyaqnumbers\z:}', "");;
    Expect(0, 126144, '\p{Block=:\Aindicsiyaqnumbers\z:}', "");;
    Expect(1, 126143, '\p{Block: 	_indic_siyaq_numbers}', "");
    Expect(0, 126143, '\p{^Block: 	_indic_siyaq_numbers}', "");
    Expect(0, 126143, '\P{Block: 	_indic_siyaq_numbers}', "");
    Expect(1, 126143, '\P{^Block: 	_indic_siyaq_numbers}', "");
    Expect(0, 126144, '\p{Block: 	_indic_siyaq_numbers}', "");
    Expect(1, 126144, '\p{^Block: 	_indic_siyaq_numbers}', "");
    Expect(1, 126144, '\P{Block: 	_indic_siyaq_numbers}', "");
    Expect(0, 126144, '\P{^Block: 	_indic_siyaq_numbers}', "");
    Error('\p{Blk= 	Indic_SIYAQ_Numbers:=}');
    Error('\P{Blk= 	Indic_SIYAQ_Numbers:=}');
    Expect(1, 126143, '\p{Blk=:\AIndic_Siyaq_Numbers\z:}', "");;
    Expect(0, 126144, '\p{Blk=:\AIndic_Siyaq_Numbers\z:}', "");;
    Expect(1, 126143, '\p{Blk=indicsiyaqnumbers}', "");
    Expect(0, 126143, '\p{^Blk=indicsiyaqnumbers}', "");
    Expect(0, 126143, '\P{Blk=indicsiyaqnumbers}', "");
    Expect(1, 126143, '\P{^Blk=indicsiyaqnumbers}', "");
    Expect(0, 126144, '\p{Blk=indicsiyaqnumbers}', "");
    Expect(1, 126144, '\p{^Blk=indicsiyaqnumbers}', "");
    Expect(1, 126144, '\P{Blk=indicsiyaqnumbers}', "");
    Expect(0, 126144, '\P{^Blk=indicsiyaqnumbers}', "");
    Expect(1, 126143, '\p{Blk=:\Aindicsiyaqnumbers\z:}', "");;
    Expect(0, 126144, '\p{Blk=:\Aindicsiyaqnumbers\z:}', "");;
    Expect(1, 126143, '\p{Blk:_	Indic_siyaq_numbers}', "");
    Expect(0, 126143, '\p{^Blk:_	Indic_siyaq_numbers}', "");
    Expect(0, 126143, '\P{Blk:_	Indic_siyaq_numbers}', "");
    Expect(1, 126143, '\P{^Blk:_	Indic_siyaq_numbers}', "");
    Expect(0, 126144, '\p{Blk:_	Indic_siyaq_numbers}', "");
    Expect(1, 126144, '\p{^Blk:_	Indic_siyaq_numbers}', "");
    Expect(1, 126144, '\P{Blk:_	Indic_siyaq_numbers}', "");
    Expect(0, 126144, '\P{^Blk:_	Indic_siyaq_numbers}', "");
    Error('\p{Is_Block=:= Indic_SIYAQ_Numbers}');
    Error('\P{Is_Block=:= Indic_SIYAQ_Numbers}');
    Expect(1, 126143, '\p{Is_Block=indicsiyaqnumbers}', "");
    Expect(0, 126143, '\p{^Is_Block=indicsiyaqnumbers}', "");
    Expect(0, 126143, '\P{Is_Block=indicsiyaqnumbers}', "");
    Expect(1, 126143, '\P{^Is_Block=indicsiyaqnumbers}', "");
    Expect(0, 126144, '\p{Is_Block=indicsiyaqnumbers}', "");
    Expect(1, 126144, '\p{^Is_Block=indicsiyaqnumbers}', "");
    Expect(1, 126144, '\P{Is_Block=indicsiyaqnumbers}', "");
    Expect(0, 126144, '\P{^Is_Block=indicsiyaqnumbers}', "");
    Expect(1, 126143, '\p{Is_Block=-_indic_Siyaq_Numbers}', "");
    Expect(0, 126143, '\p{^Is_Block=-_indic_Siyaq_Numbers}', "");
    Expect(0, 126143, '\P{Is_Block=-_indic_Siyaq_Numbers}', "");
    Expect(1, 126143, '\P{^Is_Block=-_indic_Siyaq_Numbers}', "");
    Expect(0, 126144, '\p{Is_Block=-_indic_Siyaq_Numbers}', "");
    Expect(1, 126144, '\p{^Is_Block=-_indic_Siyaq_Numbers}', "");
    Expect(1, 126144, '\P{Is_Block=-_indic_Siyaq_Numbers}', "");
    Expect(0, 126144, '\P{^Is_Block=-_indic_Siyaq_Numbers}', "");
    Error('\p{Is_Blk= INDIC_SIYAQ_numbers:=}');
    Error('\P{Is_Blk= INDIC_SIYAQ_numbers:=}');
    Expect(1, 126143, '\p{Is_Blk=indicsiyaqnumbers}', "");
    Expect(0, 126143, '\p{^Is_Blk=indicsiyaqnumbers}', "");
    Expect(0, 126143, '\P{Is_Blk=indicsiyaqnumbers}', "");
    Expect(1, 126143, '\P{^Is_Blk=indicsiyaqnumbers}', "");
    Expect(0, 126144, '\p{Is_Blk=indicsiyaqnumbers}', "");
    Expect(1, 126144, '\p{^Is_Blk=indicsiyaqnumbers}', "");
    Expect(1, 126144, '\P{Is_Blk=indicsiyaqnumbers}', "");
    Expect(0, 126144, '\P{^Is_Blk=indicsiyaqnumbers}', "");
    Expect(1, 126143, '\p{Is_Blk=-	INDIC_siyaq_NUMBERS}', "");
    Expect(0, 126143, '\p{^Is_Blk=-	INDIC_siyaq_NUMBERS}', "");
    Expect(0, 126143, '\P{Is_Blk=-	INDIC_siyaq_NUMBERS}', "");
    Expect(1, 126143, '\P{^Is_Blk=-	INDIC_siyaq_NUMBERS}', "");
    Expect(0, 126144, '\p{Is_Blk=-	INDIC_siyaq_NUMBERS}', "");
    Expect(1, 126144, '\p{^Is_Blk=-	INDIC_siyaq_NUMBERS}', "");
    Expect(1, 126144, '\P{Is_Blk=-	INDIC_siyaq_NUMBERS}', "");
    Expect(0, 126144, '\P{^Is_Blk=-	INDIC_siyaq_NUMBERS}', "");
    Error('\p{Block= _Inscriptional_PAHLAVI/a/}');
    Error('\P{Block= _Inscriptional_PAHLAVI/a/}');
    Expect(1, 68479, '\p{Block=:\AInscriptional_Pahlavi\z:}', "");;
    Expect(0, 68480, '\p{Block=:\AInscriptional_Pahlavi\z:}', "");;
    Expect(1, 68479, '\p{Block=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Block=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Block=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Block=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Block=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Block=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Block=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Block=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Block=:\Ainscriptionalpahlavi\z:}', "");;
    Expect(0, 68480, '\p{Block=:\Ainscriptionalpahlavi\z:}', "");;
    Expect(1, 68479, '\p{Block=  Inscriptional_PAHLAVI}', "");
    Expect(0, 68479, '\p{^Block=  Inscriptional_PAHLAVI}', "");
    Expect(0, 68479, '\P{Block=  Inscriptional_PAHLAVI}', "");
    Expect(1, 68479, '\P{^Block=  Inscriptional_PAHLAVI}', "");
    Expect(0, 68480, '\p{Block=  Inscriptional_PAHLAVI}', "");
    Expect(1, 68480, '\p{^Block=  Inscriptional_PAHLAVI}', "");
    Expect(1, 68480, '\P{Block=  Inscriptional_PAHLAVI}', "");
    Expect(0, 68480, '\P{^Block=  Inscriptional_PAHLAVI}', "");
    Error('\p{Blk= -Inscriptional_Pahlavi/a/}');
    Error('\P{Blk= -Inscriptional_Pahlavi/a/}');
    Expect(1, 68479, '\p{Blk=:\AInscriptional_Pahlavi\z:}', "");;
    Expect(0, 68480, '\p{Blk=:\AInscriptional_Pahlavi\z:}', "");;
    Expect(1, 68479, '\p{Blk=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Blk=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Blk=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Blk=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Blk=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Blk=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Blk=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Blk=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Blk=:\Ainscriptionalpahlavi\z:}', "");;
    Expect(0, 68480, '\p{Blk=:\Ainscriptionalpahlavi\z:}', "");;
    Expect(1, 68479, '\p{Blk=-Inscriptional_pahlavi}', "");
    Expect(0, 68479, '\p{^Blk=-Inscriptional_pahlavi}', "");
    Expect(0, 68479, '\P{Blk=-Inscriptional_pahlavi}', "");
    Expect(1, 68479, '\P{^Blk=-Inscriptional_pahlavi}', "");
    Expect(0, 68480, '\p{Blk=-Inscriptional_pahlavi}', "");
    Expect(1, 68480, '\p{^Blk=-Inscriptional_pahlavi}', "");
    Expect(1, 68480, '\P{Blk=-Inscriptional_pahlavi}', "");
    Expect(0, 68480, '\P{^Blk=-Inscriptional_pahlavi}', "");
    Error('\p{Is_Block=-	Inscriptional_pahlavi:=}');
    Error('\P{Is_Block=-	Inscriptional_pahlavi:=}');
    Expect(1, 68479, '\p{Is_Block=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Is_Block=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Is_Block=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Is_Block=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Is_Block=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Is_Block=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Is_Block=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Is_Block=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Is_Block=_ Inscriptional_pahlavi}', "");
    Expect(0, 68479, '\p{^Is_Block=_ Inscriptional_pahlavi}', "");
    Expect(0, 68479, '\P{Is_Block=_ Inscriptional_pahlavi}', "");
    Expect(1, 68479, '\P{^Is_Block=_ Inscriptional_pahlavi}', "");
    Expect(0, 68480, '\p{Is_Block=_ Inscriptional_pahlavi}', "");
    Expect(1, 68480, '\p{^Is_Block=_ Inscriptional_pahlavi}', "");
    Expect(1, 68480, '\P{Is_Block=_ Inscriptional_pahlavi}', "");
    Expect(0, 68480, '\P{^Is_Block=_ Inscriptional_pahlavi}', "");
    Error('\p{Is_Blk:   /a/_inscriptional_PAHLAVI}');
    Error('\P{Is_Blk:   /a/_inscriptional_PAHLAVI}');
    Expect(1, 68479, '\p{Is_Blk=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Is_Blk=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Is_Blk=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Is_Blk=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Is_Blk=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Is_Blk=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Is_Blk=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Is_Blk=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Is_Blk=__Inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\p{^Is_Blk=__Inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\P{Is_Blk=__Inscriptional_Pahlavi}', "");
    Expect(1, 68479, '\P{^Is_Blk=__Inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\p{Is_Blk=__Inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\p{^Is_Blk=__Inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\P{Is_Blk=__Inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\P{^Is_Blk=__Inscriptional_Pahlavi}', "");
    Error('\p{Block= INSCRIPTIONAL_Parthian/a/}');
    Error('\P{Block= INSCRIPTIONAL_Parthian/a/}');
    Expect(1, 68447, '\p{Block=:\AInscriptional_Parthian\z:}', "");;
    Expect(0, 68448, '\p{Block=:\AInscriptional_Parthian\z:}', "");;
    Expect(1, 68447, '\p{Block=inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Block=inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Block=inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Block=inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Block=inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Block=inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Block=inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Block=inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Block=:\Ainscriptionalparthian\z:}', "");;
    Expect(0, 68448, '\p{Block=:\Ainscriptionalparthian\z:}', "");;
    Expect(1, 68447, '\p{Block=		Inscriptional_Parthian}', "");
    Expect(0, 68447, '\p{^Block=		Inscriptional_Parthian}', "");
    Expect(0, 68447, '\P{Block=		Inscriptional_Parthian}', "");
    Expect(1, 68447, '\P{^Block=		Inscriptional_Parthian}', "");
    Expect(0, 68448, '\p{Block=		Inscriptional_Parthian}', "");
    Expect(1, 68448, '\p{^Block=		Inscriptional_Parthian}', "");
    Expect(1, 68448, '\P{Block=		Inscriptional_Parthian}', "");
    Expect(0, 68448, '\P{^Block=		Inscriptional_Parthian}', "");
    Error('\p{Blk=_ Inscriptional_PARTHIAN:=}');
    Error('\P{Blk=_ Inscriptional_PARTHIAN:=}');
    Expect(1, 68447, '\p{Blk=:\AInscriptional_Parthian\z:}', "");;
    Expect(0, 68448, '\p{Blk=:\AInscriptional_Parthian\z:}', "");;
    Expect(1, 68447, '\p{Blk=inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Blk=inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Blk=inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Blk=inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Blk=inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Blk=inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Blk=inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Blk=inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Blk=:\Ainscriptionalparthian\z:}', "");;
    Expect(0, 68448, '\p{Blk=:\Ainscriptionalparthian\z:}', "");;
    Expect(1, 68447, '\p{Blk=-Inscriptional_Parthian}', "");
    Expect(0, 68447, '\p{^Blk=-Inscriptional_Parthian}', "");
    Expect(0, 68447, '\P{Blk=-Inscriptional_Parthian}', "");
    Expect(1, 68447, '\P{^Blk=-Inscriptional_Parthian}', "");
    Expect(0, 68448, '\p{Blk=-Inscriptional_Parthian}', "");
    Expect(1, 68448, '\p{^Blk=-Inscriptional_Parthian}', "");
    Expect(1, 68448, '\P{Blk=-Inscriptional_Parthian}', "");
    Expect(0, 68448, '\P{^Blk=-Inscriptional_Parthian}', "");
    Error('\p{Is_Block:    inscriptional_Parthian:=}');
    Error('\P{Is_Block:    inscriptional_Parthian:=}');
    Expect(1, 68447, '\p{Is_Block:   inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Is_Block:   inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Is_Block:   inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Is_Block:   inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Is_Block:   inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Is_Block:   inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Is_Block:   inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Is_Block:   inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Is_Block=	_INSCRIPTIONAL_Parthian}', "");
    Expect(0, 68447, '\p{^Is_Block=	_INSCRIPTIONAL_Parthian}', "");
    Expect(0, 68447, '\P{Is_Block=	_INSCRIPTIONAL_Parthian}', "");
    Expect(1, 68447, '\P{^Is_Block=	_INSCRIPTIONAL_Parthian}', "");
    Expect(0, 68448, '\p{Is_Block=	_INSCRIPTIONAL_Parthian}', "");
    Expect(1, 68448, '\p{^Is_Block=	_INSCRIPTIONAL_Parthian}', "");
    Expect(1, 68448, '\P{Is_Block=	_INSCRIPTIONAL_Parthian}', "");
    Expect(0, 68448, '\P{^Is_Block=	_INSCRIPTIONAL_Parthian}', "");
    Error('\p{Is_Blk=-/a/INSCRIPTIONAL_parthian}');
    Error('\P{Is_Blk=-/a/INSCRIPTIONAL_parthian}');
    Expect(1, 68447, '\p{Is_Blk=inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Is_Blk=inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Is_Blk=inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Is_Blk=inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Is_Blk=inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Is_Blk=inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Is_Blk=inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Is_Blk=inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Is_Blk=-_Inscriptional_parthian}', "");
    Expect(0, 68447, '\p{^Is_Blk=-_Inscriptional_parthian}', "");
    Expect(0, 68447, '\P{Is_Blk=-_Inscriptional_parthian}', "");
    Expect(1, 68447, '\P{^Is_Blk=-_Inscriptional_parthian}', "");
    Expect(0, 68448, '\p{Is_Blk=-_Inscriptional_parthian}', "");
    Expect(1, 68448, '\p{^Is_Blk=-_Inscriptional_parthian}', "");
    Expect(1, 68448, '\P{Is_Blk=-_Inscriptional_parthian}', "");
    Expect(0, 68448, '\P{^Is_Blk=-_Inscriptional_parthian}', "");
    Error('\p{Block=	:=IPA_Extensions}');
    Error('\P{Block=	:=IPA_Extensions}');
    Expect(1, 687, '\p{Block=:\AIPA_Extensions\z:}', "");;
    Expect(0, 688, '\p{Block=:\AIPA_Extensions\z:}', "");;
    Expect(1, 687, '\p{Block:ipaextensions}', "");
    Expect(0, 687, '\p{^Block:ipaextensions}', "");
    Expect(0, 687, '\P{Block:ipaextensions}', "");
    Expect(1, 687, '\P{^Block:ipaextensions}', "");
    Expect(0, 688, '\p{Block:ipaextensions}', "");
    Expect(1, 688, '\p{^Block:ipaextensions}', "");
    Expect(1, 688, '\P{Block:ipaextensions}', "");
    Expect(0, 688, '\P{^Block:ipaextensions}', "");
    Expect(1, 687, '\p{Block=:\Aipaextensions\z:}', "");;
    Expect(0, 688, '\p{Block=:\Aipaextensions\z:}', "");;
    Expect(1, 687, '\p{Block= IPA_Extensions}', "");
    Expect(0, 687, '\p{^Block= IPA_Extensions}', "");
    Expect(0, 687, '\P{Block= IPA_Extensions}', "");
    Expect(1, 687, '\P{^Block= IPA_Extensions}', "");
    Expect(0, 688, '\p{Block= IPA_Extensions}', "");
    Expect(1, 688, '\p{^Block= IPA_Extensions}', "");
    Expect(1, 688, '\P{Block= IPA_Extensions}', "");
    Expect(0, 688, '\P{^Block= IPA_Extensions}', "");
    Error('\p{Blk=_:=ipa_EXT}');
    Error('\P{Blk=_:=ipa_EXT}');
    Expect(1, 687, '\p{Blk=:\AIPA_Ext\z:}', "");;
    Expect(0, 688, '\p{Blk=:\AIPA_Ext\z:}', "");;
    Expect(1, 687, '\p{Blk=ipaext}', "");
    Expect(0, 687, '\p{^Blk=ipaext}', "");
    Expect(0, 687, '\P{Blk=ipaext}', "");
    Expect(1, 687, '\P{^Blk=ipaext}', "");
    Expect(0, 688, '\p{Blk=ipaext}', "");
    Expect(1, 688, '\p{^Blk=ipaext}', "");
    Expect(1, 688, '\P{Blk=ipaext}', "");
    Expect(0, 688, '\P{^Blk=ipaext}', "");
    Expect(1, 687, '\p{Blk=:\Aipaext\z:}', "");;
    Expect(0, 688, '\p{Blk=:\Aipaext\z:}', "");;
    Expect(1, 687, '\p{Blk=	IPA_Ext}', "");
    Expect(0, 687, '\p{^Blk=	IPA_Ext}', "");
    Expect(0, 687, '\P{Blk=	IPA_Ext}', "");
    Expect(1, 687, '\P{^Blk=	IPA_Ext}', "");
    Expect(0, 688, '\p{Blk=	IPA_Ext}', "");
    Expect(1, 688, '\p{^Blk=	IPA_Ext}', "");
    Expect(1, 688, '\P{Blk=	IPA_Ext}', "");
    Expect(0, 688, '\P{^Blk=	IPA_Ext}', "");
    Error('\p{Is_Block=		IPA_extensions:=}');
    Error('\P{Is_Block=		IPA_extensions:=}');
    Expect(1, 687, '\p{Is_Block=ipaextensions}', "");
    Expect(0, 687, '\p{^Is_Block=ipaextensions}', "");
    Expect(0, 687, '\P{Is_Block=ipaextensions}', "");
    Expect(1, 687, '\P{^Is_Block=ipaextensions}', "");
    Expect(0, 688, '\p{Is_Block=ipaextensions}', "");
    Expect(1, 688, '\p{^Is_Block=ipaextensions}', "");
    Expect(1, 688, '\P{Is_Block=ipaextensions}', "");
    Expect(0, 688, '\P{^Is_Block=ipaextensions}', "");
    Expect(1, 687, '\p{Is_Block=-IPA_Extensions}', "");
    Expect(0, 687, '\p{^Is_Block=-IPA_Extensions}', "");
    Expect(0, 687, '\P{Is_Block=-IPA_Extensions}', "");
    Expect(1, 687, '\P{^Is_Block=-IPA_Extensions}', "");
    Expect(0, 688, '\p{Is_Block=-IPA_Extensions}', "");
    Expect(1, 688, '\p{^Is_Block=-IPA_Extensions}', "");
    Expect(1, 688, '\P{Is_Block=-IPA_Extensions}', "");
    Expect(0, 688, '\P{^Is_Block=-IPA_Extensions}', "");
    Error('\p{Is_Blk=-/a/ipa_Ext}');
    Error('\P{Is_Blk=-/a/ipa_Ext}');
    Expect(1, 687, '\p{Is_Blk=ipaext}', "");
    Expect(0, 687, '\p{^Is_Blk=ipaext}', "");
    Expect(0, 687, '\P{Is_Blk=ipaext}', "");
    Expect(1, 687, '\P{^Is_Blk=ipaext}', "");
    Expect(0, 688, '\p{Is_Blk=ipaext}', "");
    Expect(1, 688, '\p{^Is_Blk=ipaext}', "");
    Expect(1, 688, '\P{Is_Blk=ipaext}', "");
    Expect(0, 688, '\P{^Is_Blk=ipaext}', "");
    Expect(1, 687, '\p{Is_Blk:	-ipa_Ext}', "");
    Expect(0, 687, '\p{^Is_Blk:	-ipa_Ext}', "");
    Expect(0, 687, '\P{Is_Blk:	-ipa_Ext}', "");
    Expect(1, 687, '\P{^Is_Blk:	-ipa_Ext}', "");
    Expect(0, 688, '\p{Is_Blk:	-ipa_Ext}', "");
    Expect(1, 688, '\p{^Is_Blk:	-ipa_Ext}', "");
    Expect(1, 688, '\P{Is_Blk:	-ipa_Ext}', "");
    Expect(0, 688, '\P{^Is_Blk:	-ipa_Ext}', "");
    Error('\p{Block=:=HANGUL_Jamo}');
    Error('\P{Block=:=HANGUL_Jamo}');
    Expect(1, 4607, '\p{Block=:\AHangul_Jamo\z:}', "");;
    Expect(0, 4608, '\p{Block=:\AHangul_Jamo\z:}', "");;
    Expect(1, 4607, '\p{Block=hanguljamo}', "");
    Expect(0, 4607, '\p{^Block=hanguljamo}', "");
    Expect(0, 4607, '\P{Block=hanguljamo}', "");
    Expect(1, 4607, '\P{^Block=hanguljamo}', "");
    Expect(0, 4608, '\p{Block=hanguljamo}', "");
    Expect(1, 4608, '\p{^Block=hanguljamo}', "");
    Expect(1, 4608, '\P{Block=hanguljamo}', "");
    Expect(0, 4608, '\P{^Block=hanguljamo}', "");
    Expect(1, 4607, '\p{Block=:\Ahanguljamo\z:}', "");;
    Expect(0, 4608, '\p{Block=:\Ahanguljamo\z:}', "");;
    Expect(1, 4607, '\p{Block=	 Hangul_JAMO}', "");
    Expect(0, 4607, '\p{^Block=	 Hangul_JAMO}', "");
    Expect(0, 4607, '\P{Block=	 Hangul_JAMO}', "");
    Expect(1, 4607, '\P{^Block=	 Hangul_JAMO}', "");
    Expect(0, 4608, '\p{Block=	 Hangul_JAMO}', "");
    Expect(1, 4608, '\p{^Block=	 Hangul_JAMO}', "");
    Expect(1, 4608, '\P{Block=	 Hangul_JAMO}', "");
    Expect(0, 4608, '\P{^Block=	 Hangul_JAMO}', "");
    Error('\p{Blk=	JAMO/a/}');
    Error('\P{Blk=	JAMO/a/}');
    Expect(1, 4607, '\p{Blk=:\AJamo\z:}', "");;
    Expect(0, 4608, '\p{Blk=:\AJamo\z:}', "");;
    Expect(1, 4607, '\p{Blk=jamo}', "");
    Expect(0, 4607, '\p{^Blk=jamo}', "");
    Expect(0, 4607, '\P{Blk=jamo}', "");
    Expect(1, 4607, '\P{^Blk=jamo}', "");
    Expect(0, 4608, '\p{Blk=jamo}', "");
    Expect(1, 4608, '\p{^Blk=jamo}', "");
    Expect(1, 4608, '\P{Blk=jamo}', "");
    Expect(0, 4608, '\P{^Blk=jamo}', "");
    Expect(1, 4607, '\p{Blk=:\Ajamo\z:}', "");;
    Expect(0, 4608, '\p{Blk=:\Ajamo\z:}', "");;
    Expect(1, 4607, '\p{Blk=-_JAMO}', "");
    Expect(0, 4607, '\p{^Blk=-_JAMO}', "");
    Expect(0, 4607, '\P{Blk=-_JAMO}', "");
    Expect(1, 4607, '\P{^Blk=-_JAMO}', "");
    Expect(0, 4608, '\p{Blk=-_JAMO}', "");
    Expect(1, 4608, '\p{^Blk=-_JAMO}', "");
    Expect(1, 4608, '\P{Blk=-_JAMO}', "");
    Expect(0, 4608, '\P{^Blk=-_JAMO}', "");
    Error('\p{Is_Block=/a/ _hangul_jamo}');
    Error('\P{Is_Block=/a/ _hangul_jamo}');
    Expect(1, 4607, '\p{Is_Block=hanguljamo}', "");
    Expect(0, 4607, '\p{^Is_Block=hanguljamo}', "");
    Expect(0, 4607, '\P{Is_Block=hanguljamo}', "");
    Expect(1, 4607, '\P{^Is_Block=hanguljamo}', "");
    Expect(0, 4608, '\p{Is_Block=hanguljamo}', "");
    Expect(1, 4608, '\p{^Is_Block=hanguljamo}', "");
    Expect(1, 4608, '\P{Is_Block=hanguljamo}', "");
    Expect(0, 4608, '\P{^Is_Block=hanguljamo}', "");
    Expect(1, 4607, '\p{Is_Block:		Hangul_Jamo}', "");
    Expect(0, 4607, '\p{^Is_Block:		Hangul_Jamo}', "");
    Expect(0, 4607, '\P{Is_Block:		Hangul_Jamo}', "");
    Expect(1, 4607, '\P{^Is_Block:		Hangul_Jamo}', "");
    Expect(0, 4608, '\p{Is_Block:		Hangul_Jamo}', "");
    Expect(1, 4608, '\p{^Is_Block:		Hangul_Jamo}', "");
    Expect(1, 4608, '\P{Is_Block:		Hangul_Jamo}', "");
    Expect(0, 4608, '\P{^Is_Block:		Hangul_Jamo}', "");
    Error('\p{Is_Blk=  jamo/a/}');
    Error('\P{Is_Blk=  jamo/a/}');
    Expect(1, 4607, '\p{Is_Blk=jamo}', "");
    Expect(0, 4607, '\p{^Is_Blk=jamo}', "");
    Expect(0, 4607, '\P{Is_Blk=jamo}', "");
    Expect(1, 4607, '\P{^Is_Blk=jamo}', "");
    Expect(0, 4608, '\p{Is_Blk=jamo}', "");
    Expect(1, 4608, '\p{^Is_Blk=jamo}', "");
    Expect(1, 4608, '\P{Is_Blk=jamo}', "");
    Expect(0, 4608, '\P{^Is_Blk=jamo}', "");
    Expect(1, 4607, '\p{Is_Blk=JAMO}', "");
    Expect(0, 4607, '\p{^Is_Blk=JAMO}', "");
    Expect(0, 4607, '\P{Is_Blk=JAMO}', "");
    Expect(1, 4607, '\P{^Is_Blk=JAMO}', "");
    Expect(0, 4608, '\p{Is_Blk=JAMO}', "");
    Expect(1, 4608, '\p{^Is_Blk=JAMO}', "");
    Expect(1, 4608, '\P{Is_Blk=JAMO}', "");
    Expect(0, 4608, '\P{^Is_Blk=JAMO}', "");
    Error('\p{Block=  Hangul_JAMO_Extended_A/a/}');
    Error('\P{Block=  Hangul_JAMO_Extended_A/a/}');
    Expect(1, 43391, '\p{Block=:\AHangul_Jamo_Extended_A\z:}', "");;
    Expect(0, 43392, '\p{Block=:\AHangul_Jamo_Extended_A\z:}', "");;
    Expect(1, 43391, '\p{Block=hanguljamoextendeda}', "");
    Expect(0, 43391, '\p{^Block=hanguljamoextendeda}', "");
    Expect(0, 43391, '\P{Block=hanguljamoextendeda}', "");
    Expect(1, 43391, '\P{^Block=hanguljamoextendeda}', "");
    Expect(0, 43392, '\p{Block=hanguljamoextendeda}', "");
    Expect(1, 43392, '\p{^Block=hanguljamoextendeda}', "");
    Expect(1, 43392, '\P{Block=hanguljamoextendeda}', "");
    Expect(0, 43392, '\P{^Block=hanguljamoextendeda}', "");
    Expect(1, 43391, '\p{Block=:\Ahanguljamoextendeda\z:}', "");;
    Expect(0, 43392, '\p{Block=:\Ahanguljamoextendeda\z:}', "");;
    Expect(1, 43391, '\p{Block= 	Hangul_Jamo_Extended_a}', "");
    Expect(0, 43391, '\p{^Block= 	Hangul_Jamo_Extended_a}', "");
    Expect(0, 43391, '\P{Block= 	Hangul_Jamo_Extended_a}', "");
    Expect(1, 43391, '\P{^Block= 	Hangul_Jamo_Extended_a}', "");
    Expect(0, 43392, '\p{Block= 	Hangul_Jamo_Extended_a}', "");
    Expect(1, 43392, '\p{^Block= 	Hangul_Jamo_Extended_a}', "");
    Expect(1, 43392, '\P{Block= 	Hangul_Jamo_Extended_a}', "");
    Expect(0, 43392, '\P{^Block= 	Hangul_Jamo_Extended_a}', "");
    Error('\p{Blk= 	Jamo_ext_a:=}');
    Error('\P{Blk= 	Jamo_ext_a:=}');
    Expect(1, 43391, '\p{Blk=:\AJamo_Ext_A\z:}', "");;
    Expect(0, 43392, '\p{Blk=:\AJamo_Ext_A\z:}', "");;
    Expect(1, 43391, '\p{Blk=jamoexta}', "");
    Expect(0, 43391, '\p{^Blk=jamoexta}', "");
    Expect(0, 43391, '\P{Blk=jamoexta}', "");
    Expect(1, 43391, '\P{^Blk=jamoexta}', "");
    Expect(0, 43392, '\p{Blk=jamoexta}', "");
    Expect(1, 43392, '\p{^Blk=jamoexta}', "");
    Expect(1, 43392, '\P{Blk=jamoexta}', "");
    Expect(0, 43392, '\P{^Blk=jamoexta}', "");
    Expect(1, 43391, '\p{Blk=:\Ajamoexta\z:}', "");;
    Expect(0, 43392, '\p{Blk=:\Ajamoexta\z:}', "");;
    Expect(1, 43391, '\p{Blk=Jamo_ext_a}', "");
    Expect(0, 43391, '\p{^Blk=Jamo_ext_a}', "");
    Expect(0, 43391, '\P{Blk=Jamo_ext_a}', "");
    Expect(1, 43391, '\P{^Blk=Jamo_ext_a}', "");
    Expect(0, 43392, '\p{Blk=Jamo_ext_a}', "");
    Expect(1, 43392, '\p{^Blk=Jamo_ext_a}', "");
    Expect(1, 43392, '\P{Blk=Jamo_ext_a}', "");
    Expect(0, 43392, '\P{^Blk=Jamo_ext_a}', "");
    Error('\p{Is_Block=_	hangul_Jamo_extended_A/a/}');
    Error('\P{Is_Block=_	hangul_Jamo_extended_A/a/}');
    Expect(1, 43391, '\p{Is_Block:	hanguljamoextendeda}', "");
    Expect(0, 43391, '\p{^Is_Block:	hanguljamoextendeda}', "");
    Expect(0, 43391, '\P{Is_Block:	hanguljamoextendeda}', "");
    Expect(1, 43391, '\P{^Is_Block:	hanguljamoextendeda}', "");
    Expect(0, 43392, '\p{Is_Block:	hanguljamoextendeda}', "");
    Expect(1, 43392, '\p{^Is_Block:	hanguljamoextendeda}', "");
    Expect(1, 43392, '\P{Is_Block:	hanguljamoextendeda}', "");
    Expect(0, 43392, '\P{^Is_Block:	hanguljamoextendeda}', "");
    Expect(1, 43391, '\p{Is_Block=	 HANGUL_jamo_Extended_a}', "");
    Expect(0, 43391, '\p{^Is_Block=	 HANGUL_jamo_Extended_a}', "");
    Expect(0, 43391, '\P{Is_Block=	 HANGUL_jamo_Extended_a}', "");
    Expect(1, 43391, '\P{^Is_Block=	 HANGUL_jamo_Extended_a}', "");
    Expect(0, 43392, '\p{Is_Block=	 HANGUL_jamo_Extended_a}', "");
    Expect(1, 43392, '\p{^Is_Block=	 HANGUL_jamo_Extended_a}', "");
    Expect(1, 43392, '\P{Is_Block=	 HANGUL_jamo_Extended_a}', "");
    Expect(0, 43392, '\P{^Is_Block=	 HANGUL_jamo_Extended_a}', "");
    Error('\p{Is_Blk=_jamo_EXT_a/a/}');
    Error('\P{Is_Blk=_jamo_EXT_a/a/}');
    Expect(1, 43391, '\p{Is_Blk=jamoexta}', "");
    Expect(0, 43391, '\p{^Is_Blk=jamoexta}', "");
    Expect(0, 43391, '\P{Is_Blk=jamoexta}', "");
    Expect(1, 43391, '\P{^Is_Blk=jamoexta}', "");
    Expect(0, 43392, '\p{Is_Blk=jamoexta}', "");
    Expect(1, 43392, '\p{^Is_Blk=jamoexta}', "");
    Expect(1, 43392, '\P{Is_Blk=jamoexta}', "");
    Expect(0, 43392, '\P{^Is_Blk=jamoexta}', "");
    Expect(1, 43391, '\p{Is_Blk=- Jamo_Ext_a}', "");
    Expect(0, 43391, '\p{^Is_Blk=- Jamo_Ext_a}', "");
    Expect(0, 43391, '\P{Is_Blk=- Jamo_Ext_a}', "");
    Expect(1, 43391, '\P{^Is_Blk=- Jamo_Ext_a}', "");
    Expect(0, 43392, '\p{Is_Blk=- Jamo_Ext_a}', "");
    Expect(1, 43392, '\p{^Is_Blk=- Jamo_Ext_a}', "");
    Expect(1, 43392, '\P{Is_Blk=- Jamo_Ext_a}', "");
    Expect(0, 43392, '\P{^Is_Blk=- Jamo_Ext_a}', "");
    Error('\p{Block=/a/	_Hangul_jamo_EXTENDED_B}');
    Error('\P{Block=/a/	_Hangul_jamo_EXTENDED_B}');
    Expect(1, 55295, '\p{Block=:\AHangul_Jamo_Extended_B\z:}', "");;
    Expect(0, 57344, '\p{Block=:\AHangul_Jamo_Extended_B\z:}', "");;
    Expect(1, 55295, '\p{Block=hanguljamoextendedb}', "");
    Expect(0, 55295, '\p{^Block=hanguljamoextendedb}', "");
    Expect(0, 55295, '\P{Block=hanguljamoextendedb}', "");
    Expect(1, 55295, '\P{^Block=hanguljamoextendedb}', "");
    Expect(0, 57344, '\p{Block=hanguljamoextendedb}', "");
    Expect(1, 57344, '\p{^Block=hanguljamoextendedb}', "");
    Expect(1, 57344, '\P{Block=hanguljamoextendedb}', "");
    Expect(0, 57344, '\P{^Block=hanguljamoextendedb}', "");
    Expect(1, 55295, '\p{Block=:\Ahanguljamoextendedb\z:}', "");;
    Expect(0, 57344, '\p{Block=:\Ahanguljamoextendedb\z:}', "");;
    Expect(1, 55295, '\p{Block=	Hangul_JAMO_Extended_B}', "");
    Expect(0, 55295, '\p{^Block=	Hangul_JAMO_Extended_B}', "");
    Expect(0, 55295, '\P{Block=	Hangul_JAMO_Extended_B}', "");
    Expect(1, 55295, '\P{^Block=	Hangul_JAMO_Extended_B}', "");
    Expect(0, 57344, '\p{Block=	Hangul_JAMO_Extended_B}', "");
    Expect(1, 57344, '\p{^Block=	Hangul_JAMO_Extended_B}', "");
    Expect(1, 57344, '\P{Block=	Hangul_JAMO_Extended_B}', "");
    Expect(0, 57344, '\P{^Block=	Hangul_JAMO_Extended_B}', "");
    Error('\p{Blk: /a/_Jamo_Ext_B}');
    Error('\P{Blk: /a/_Jamo_Ext_B}');
    Expect(1, 55295, '\p{Blk=:\AJamo_Ext_B\z:}', "");;
    Expect(0, 57344, '\p{Blk=:\AJamo_Ext_B\z:}', "");;
    Expect(1, 55295, '\p{Blk=jamoextb}', "");
    Expect(0, 55295, '\p{^Blk=jamoextb}', "");
    Expect(0, 55295, '\P{Blk=jamoextb}', "");
    Expect(1, 55295, '\P{^Blk=jamoextb}', "");
    Expect(0, 57344, '\p{Blk=jamoextb}', "");
    Expect(1, 57344, '\p{^Blk=jamoextb}', "");
    Expect(1, 57344, '\P{Blk=jamoextb}', "");
    Expect(0, 57344, '\P{^Blk=jamoextb}', "");
    Expect(1, 55295, '\p{Blk=:\Ajamoextb\z:}', "");;
    Expect(0, 57344, '\p{Blk=:\Ajamoextb\z:}', "");;
    Expect(1, 55295, '\p{Blk=- JAMO_EXT_B}', "");
    Expect(0, 55295, '\p{^Blk=- JAMO_EXT_B}', "");
    Expect(0, 55295, '\P{Blk=- JAMO_EXT_B}', "");
    Expect(1, 55295, '\P{^Blk=- JAMO_EXT_B}', "");
    Expect(0, 57344, '\p{Blk=- JAMO_EXT_B}', "");
    Expect(1, 57344, '\p{^Blk=- JAMO_EXT_B}', "");
    Expect(1, 57344, '\P{Blk=- JAMO_EXT_B}', "");
    Expect(0, 57344, '\P{^Blk=- JAMO_EXT_B}', "");
    Error('\p{Is_Block=-Hangul_Jamo_Extended_B:=}');
    Error('\P{Is_Block=-Hangul_Jamo_Extended_B:=}');
    Expect(1, 55295, '\p{Is_Block=hanguljamoextendedb}', "");
    Expect(0, 55295, '\p{^Is_Block=hanguljamoextendedb}', "");
    Expect(0, 55295, '\P{Is_Block=hanguljamoextendedb}', "");
    Expect(1, 55295, '\P{^Is_Block=hanguljamoextendedb}', "");
    Expect(0, 57344, '\p{Is_Block=hanguljamoextendedb}', "");
    Expect(1, 57344, '\p{^Is_Block=hanguljamoextendedb}', "");
    Expect(1, 57344, '\P{Is_Block=hanguljamoextendedb}', "");
    Expect(0, 57344, '\P{^Is_Block=hanguljamoextendedb}', "");
    Expect(1, 55295, '\p{Is_Block=	_Hangul_Jamo_Extended_B}', "");
    Expect(0, 55295, '\p{^Is_Block=	_Hangul_Jamo_Extended_B}', "");
    Expect(0, 55295, '\P{Is_Block=	_Hangul_Jamo_Extended_B}', "");
    Expect(1, 55295, '\P{^Is_Block=	_Hangul_Jamo_Extended_B}', "");
    Expect(0, 57344, '\p{Is_Block=	_Hangul_Jamo_Extended_B}', "");
    Expect(1, 57344, '\p{^Is_Block=	_Hangul_Jamo_Extended_B}', "");
    Expect(1, 57344, '\P{Is_Block=	_Hangul_Jamo_Extended_B}', "");
    Expect(0, 57344, '\P{^Is_Block=	_Hangul_Jamo_Extended_B}', "");
    Error('\p{Is_Blk=_/a/jamo_Ext_B}');
    Error('\P{Is_Blk=_/a/jamo_Ext_B}');
    Expect(1, 55295, '\p{Is_Blk=jamoextb}', "");
    Expect(0, 55295, '\p{^Is_Blk=jamoextb}', "");
    Expect(0, 55295, '\P{Is_Blk=jamoextb}', "");
    Expect(1, 55295, '\P{^Is_Blk=jamoextb}', "");
    Expect(0, 57344, '\p{Is_Blk=jamoextb}', "");
    Expect(1, 57344, '\p{^Is_Blk=jamoextb}', "");
    Expect(1, 57344, '\P{Is_Blk=jamoextb}', "");
    Expect(0, 57344, '\P{^Is_Blk=jamoextb}', "");
    Expect(1, 55295, '\p{Is_Blk=_ JAMO_Ext_b}', "");
    Expect(0, 55295, '\p{^Is_Blk=_ JAMO_Ext_b}', "");
    Expect(0, 55295, '\P{Is_Blk=_ JAMO_Ext_b}', "");
    Expect(1, 55295, '\P{^Is_Blk=_ JAMO_Ext_b}', "");
    Expect(0, 57344, '\p{Is_Blk=_ JAMO_Ext_b}', "");
    Expect(1, 57344, '\p{^Is_Blk=_ JAMO_Ext_b}', "");
    Expect(1, 57344, '\P{Is_Blk=_ JAMO_Ext_b}', "");
    Expect(0, 57344, '\P{^Is_Blk=_ JAMO_Ext_b}', "");
    Error('\p{Block=-/a/JAVANESE}');
    Error('\P{Block=-/a/JAVANESE}');
    Expect(1, 43487, '\p{Block=:\AJavanese\z:}', "");;
    Expect(0, 43488, '\p{Block=:\AJavanese\z:}', "");;
    Expect(1, 43487, '\p{Block=javanese}', "");
    Expect(0, 43487, '\p{^Block=javanese}', "");
    Expect(0, 43487, '\P{Block=javanese}', "");
    Expect(1, 43487, '\P{^Block=javanese}', "");
    Expect(0, 43488, '\p{Block=javanese}', "");
    Expect(1, 43488, '\p{^Block=javanese}', "");
    Expect(1, 43488, '\P{Block=javanese}', "");
    Expect(0, 43488, '\P{^Block=javanese}', "");
    Expect(1, 43487, '\p{Block=:\Ajavanese\z:}', "");;
    Expect(0, 43488, '\p{Block=:\Ajavanese\z:}', "");;
    Expect(1, 43487, '\p{Block: - Javanese}', "");
    Expect(0, 43487, '\p{^Block: - Javanese}', "");
    Expect(0, 43487, '\P{Block: - Javanese}', "");
    Expect(1, 43487, '\P{^Block: - Javanese}', "");
    Expect(0, 43488, '\p{Block: - Javanese}', "");
    Expect(1, 43488, '\p{^Block: - Javanese}', "");
    Expect(1, 43488, '\P{Block: - Javanese}', "");
    Expect(0, 43488, '\P{^Block: - Javanese}', "");
    Error('\p{Blk= /a/javanese}');
    Error('\P{Blk= /a/javanese}');
    Expect(1, 43487, '\p{Blk=:\AJavanese\z:}', "");;
    Expect(0, 43488, '\p{Blk=:\AJavanese\z:}', "");;
    Expect(1, 43487, '\p{Blk=javanese}', "");
    Expect(0, 43487, '\p{^Blk=javanese}', "");
    Expect(0, 43487, '\P{Blk=javanese}', "");
    Expect(1, 43487, '\P{^Blk=javanese}', "");
    Expect(0, 43488, '\p{Blk=javanese}', "");
    Expect(1, 43488, '\p{^Blk=javanese}', "");
    Expect(1, 43488, '\P{Blk=javanese}', "");
    Expect(0, 43488, '\P{^Blk=javanese}', "");
    Expect(1, 43487, '\p{Blk=:\Ajavanese\z:}', "");;
    Expect(0, 43488, '\p{Blk=:\Ajavanese\z:}', "");;
    Expect(1, 43487, '\p{Blk:  Javanese}', "");
    Expect(0, 43487, '\p{^Blk:  Javanese}', "");
    Expect(0, 43487, '\P{Blk:  Javanese}', "");
    Expect(1, 43487, '\P{^Blk:  Javanese}', "");
    Expect(0, 43488, '\p{Blk:  Javanese}', "");
    Expect(1, 43488, '\p{^Blk:  Javanese}', "");
    Expect(1, 43488, '\P{Blk:  Javanese}', "");
    Expect(0, 43488, '\P{^Blk:  Javanese}', "");
    Error('\p{Is_Block: --javanese/a/}');
    Error('\P{Is_Block: --javanese/a/}');
    Expect(1, 43487, '\p{Is_Block=javanese}', "");
    Expect(0, 43487, '\p{^Is_Block=javanese}', "");
    Expect(0, 43487, '\P{Is_Block=javanese}', "");
    Expect(1, 43487, '\P{^Is_Block=javanese}', "");
    Expect(0, 43488, '\p{Is_Block=javanese}', "");
    Expect(1, 43488, '\p{^Is_Block=javanese}', "");
    Expect(1, 43488, '\P{Is_Block=javanese}', "");
    Expect(0, 43488, '\P{^Is_Block=javanese}', "");
    Expect(1, 43487, '\p{Is_Block: _Javanese}', "");
    Expect(0, 43487, '\p{^Is_Block: _Javanese}', "");
    Expect(0, 43487, '\P{Is_Block: _Javanese}', "");
    Expect(1, 43487, '\P{^Is_Block: _Javanese}', "");
    Expect(0, 43488, '\p{Is_Block: _Javanese}', "");
    Expect(1, 43488, '\p{^Is_Block: _Javanese}', "");
    Expect(1, 43488, '\P{Is_Block: _Javanese}', "");
    Expect(0, 43488, '\P{^Is_Block: _Javanese}', "");
    Error('\p{Is_Blk=/a/-	JAVANESE}');
    Error('\P{Is_Blk=/a/-	JAVANESE}');
    Expect(1, 43487, '\p{Is_Blk:javanese}', "");
    Expect(0, 43487, '\p{^Is_Blk:javanese}', "");
    Expect(0, 43487, '\P{Is_Blk:javanese}', "");
    Expect(1, 43487, '\P{^Is_Blk:javanese}', "");
    Expect(0, 43488, '\p{Is_Blk:javanese}', "");
    Expect(1, 43488, '\p{^Is_Blk:javanese}', "");
    Expect(1, 43488, '\P{Is_Blk:javanese}', "");
    Expect(0, 43488, '\P{^Is_Blk:javanese}', "");
    Expect(1, 43487, '\p{Is_Blk=-javanese}', "");
    Expect(0, 43487, '\p{^Is_Blk=-javanese}', "");
    Expect(0, 43487, '\P{Is_Blk=-javanese}', "");
    Expect(1, 43487, '\P{^Is_Blk=-javanese}', "");
    Expect(0, 43488, '\p{Is_Blk=-javanese}', "");
    Expect(1, 43488, '\p{^Is_Blk=-javanese}', "");
    Expect(1, 43488, '\P{Is_Blk=-javanese}', "");
    Expect(0, 43488, '\P{^Is_Blk=-javanese}', "");
    Error('\p{Block=:=Kaithi}');
    Error('\P{Block=:=Kaithi}');
    Expect(1, 69839, '\p{Block=:\AKaithi\z:}', "");;
    Expect(0, 69840, '\p{Block=:\AKaithi\z:}', "");;
    Expect(1, 69839, '\p{Block=kaithi}', "");
    Expect(0, 69839, '\p{^Block=kaithi}', "");
    Expect(0, 69839, '\P{Block=kaithi}', "");
    Expect(1, 69839, '\P{^Block=kaithi}', "");
    Expect(0, 69840, '\p{Block=kaithi}', "");
    Expect(1, 69840, '\p{^Block=kaithi}', "");
    Expect(1, 69840, '\P{Block=kaithi}', "");
    Expect(0, 69840, '\P{^Block=kaithi}', "");
    Expect(1, 69839, '\p{Block=:\Akaithi\z:}', "");;
    Expect(0, 69840, '\p{Block=:\Akaithi\z:}', "");;
    Expect(1, 69839, '\p{Block= KAITHI}', "");
    Expect(0, 69839, '\p{^Block= KAITHI}', "");
    Expect(0, 69839, '\P{Block= KAITHI}', "");
    Expect(1, 69839, '\P{^Block= KAITHI}', "");
    Expect(0, 69840, '\p{Block= KAITHI}', "");
    Expect(1, 69840, '\p{^Block= KAITHI}', "");
    Expect(1, 69840, '\P{Block= KAITHI}', "");
    Expect(0, 69840, '\P{^Block= KAITHI}', "");
    Error('\p{Blk=:=-Kaithi}');
    Error('\P{Blk=:=-Kaithi}');
    Expect(1, 69839, '\p{Blk=:\AKaithi\z:}', "");;
    Expect(0, 69840, '\p{Blk=:\AKaithi\z:}', "");;
    Expect(1, 69839, '\p{Blk=kaithi}', "");
    Expect(0, 69839, '\p{^Blk=kaithi}', "");
    Expect(0, 69839, '\P{Blk=kaithi}', "");
    Expect(1, 69839, '\P{^Blk=kaithi}', "");
    Expect(0, 69840, '\p{Blk=kaithi}', "");
    Expect(1, 69840, '\p{^Blk=kaithi}', "");
    Expect(1, 69840, '\P{Blk=kaithi}', "");
    Expect(0, 69840, '\P{^Blk=kaithi}', "");
    Expect(1, 69839, '\p{Blk=:\Akaithi\z:}', "");;
    Expect(0, 69840, '\p{Blk=:\Akaithi\z:}', "");;
    Expect(1, 69839, '\p{Blk= -kaithi}', "");
    Expect(0, 69839, '\p{^Blk= -kaithi}', "");
    Expect(0, 69839, '\P{Blk= -kaithi}', "");
    Expect(1, 69839, '\P{^Blk= -kaithi}', "");
    Expect(0, 69840, '\p{Blk= -kaithi}', "");
    Expect(1, 69840, '\p{^Blk= -kaithi}', "");
    Expect(1, 69840, '\P{Blk= -kaithi}', "");
    Expect(0, 69840, '\P{^Blk= -kaithi}', "");
    Error('\p{Is_Block= :=Kaithi}');
    Error('\P{Is_Block= :=Kaithi}');
    Expect(1, 69839, '\p{Is_Block=kaithi}', "");
    Expect(0, 69839, '\p{^Is_Block=kaithi}', "");
    Expect(0, 69839, '\P{Is_Block=kaithi}', "");
    Expect(1, 69839, '\P{^Is_Block=kaithi}', "");
    Expect(0, 69840, '\p{Is_Block=kaithi}', "");
    Expect(1, 69840, '\p{^Is_Block=kaithi}', "");
    Expect(1, 69840, '\P{Is_Block=kaithi}', "");
    Expect(0, 69840, '\P{^Is_Block=kaithi}', "");
    Expect(1, 69839, '\p{Is_Block=  Kaithi}', "");
    Expect(0, 69839, '\p{^Is_Block=  Kaithi}', "");
    Expect(0, 69839, '\P{Is_Block=  Kaithi}', "");
    Expect(1, 69839, '\P{^Is_Block=  Kaithi}', "");
    Expect(0, 69840, '\p{Is_Block=  Kaithi}', "");
    Expect(1, 69840, '\p{^Is_Block=  Kaithi}', "");
    Expect(1, 69840, '\P{Is_Block=  Kaithi}', "");
    Expect(0, 69840, '\P{^Is_Block=  Kaithi}', "");
    Error('\p{Is_Blk=/a/-	kaithi}');
    Error('\P{Is_Blk=/a/-	kaithi}');
    Expect(1, 69839, '\p{Is_Blk=kaithi}', "");
    Expect(0, 69839, '\p{^Is_Blk=kaithi}', "");
    Expect(0, 69839, '\P{Is_Blk=kaithi}', "");
    Expect(1, 69839, '\P{^Is_Blk=kaithi}', "");
    Expect(0, 69840, '\p{Is_Blk=kaithi}', "");
    Expect(1, 69840, '\p{^Is_Blk=kaithi}', "");
    Expect(1, 69840, '\P{Is_Blk=kaithi}', "");
    Expect(0, 69840, '\P{^Is_Blk=kaithi}', "");
    Expect(1, 69839, '\p{Is_Blk:_Kaithi}', "");
    Expect(0, 69839, '\p{^Is_Blk:_Kaithi}', "");
    Expect(0, 69839, '\P{Is_Blk:_Kaithi}', "");
    Expect(1, 69839, '\P{^Is_Blk:_Kaithi}', "");
    Expect(0, 69840, '\p{Is_Blk:_Kaithi}', "");
    Expect(1, 69840, '\p{^Is_Blk:_Kaithi}', "");
    Expect(1, 69840, '\P{Is_Blk:_Kaithi}', "");
    Expect(0, 69840, '\P{^Is_Blk:_Kaithi}', "");
    Error('\p{Block::=kana_extended_A}');
    Error('\P{Block::=kana_extended_A}');
    Expect(1, 110895, '\p{Block=:\AKana_Extended_A\z:}', "");;
    Expect(0, 110896, '\p{Block=:\AKana_Extended_A\z:}', "");;
    Expect(1, 110895, '\p{Block=kanaextendeda}', "");
    Expect(0, 110895, '\p{^Block=kanaextendeda}', "");
    Expect(0, 110895, '\P{Block=kanaextendeda}', "");
    Expect(1, 110895, '\P{^Block=kanaextendeda}', "");
    Expect(0, 110896, '\p{Block=kanaextendeda}', "");
    Expect(1, 110896, '\p{^Block=kanaextendeda}', "");
    Expect(1, 110896, '\P{Block=kanaextendeda}', "");
    Expect(0, 110896, '\P{^Block=kanaextendeda}', "");
    Expect(1, 110895, '\p{Block=:\Akanaextendeda\z:}', "");;
    Expect(0, 110896, '\p{Block=:\Akanaextendeda\z:}', "");;
    Expect(1, 110895, '\p{Block=_ kana_extended_A}', "");
    Expect(0, 110895, '\p{^Block=_ kana_extended_A}', "");
    Expect(0, 110895, '\P{Block=_ kana_extended_A}', "");
    Expect(1, 110895, '\P{^Block=_ kana_extended_A}', "");
    Expect(0, 110896, '\p{Block=_ kana_extended_A}', "");
    Expect(1, 110896, '\p{^Block=_ kana_extended_A}', "");
    Expect(1, 110896, '\P{Block=_ kana_extended_A}', "");
    Expect(0, 110896, '\P{^Block=_ kana_extended_A}', "");
    Error('\p{Blk=Kana_Ext_A/a/}');
    Error('\P{Blk=Kana_Ext_A/a/}');
    Expect(1, 110895, '\p{Blk=:\AKana_Ext_A\z:}', "");;
    Expect(0, 110896, '\p{Blk=:\AKana_Ext_A\z:}', "");;
    Expect(1, 110895, '\p{Blk=kanaexta}', "");
    Expect(0, 110895, '\p{^Blk=kanaexta}', "");
    Expect(0, 110895, '\P{Blk=kanaexta}', "");
    Expect(1, 110895, '\P{^Blk=kanaexta}', "");
    Expect(0, 110896, '\p{Blk=kanaexta}', "");
    Expect(1, 110896, '\p{^Blk=kanaexta}', "");
    Expect(1, 110896, '\P{Blk=kanaexta}', "");
    Expect(0, 110896, '\P{^Blk=kanaexta}', "");
    Expect(1, 110895, '\p{Blk=:\Akanaexta\z:}', "");;
    Expect(0, 110896, '\p{Blk=:\Akanaexta\z:}', "");;
    Expect(1, 110895, '\p{Blk=-	kana_Ext_a}', "");
    Expect(0, 110895, '\p{^Blk=-	kana_Ext_a}', "");
    Expect(0, 110895, '\P{Blk=-	kana_Ext_a}', "");
    Expect(1, 110895, '\P{^Blk=-	kana_Ext_a}', "");
    Expect(0, 110896, '\p{Blk=-	kana_Ext_a}', "");
    Expect(1, 110896, '\p{^Blk=-	kana_Ext_a}', "");
    Expect(1, 110896, '\P{Blk=-	kana_Ext_a}', "");
    Expect(0, 110896, '\P{^Blk=-	kana_Ext_a}', "");
    Error('\p{Is_Block=:=Kana_Extended_a}');
    Error('\P{Is_Block=:=Kana_Extended_a}');
    Expect(1, 110895, '\p{Is_Block=kanaextendeda}', "");
    Expect(0, 110895, '\p{^Is_Block=kanaextendeda}', "");
    Expect(0, 110895, '\P{Is_Block=kanaextendeda}', "");
    Expect(1, 110895, '\P{^Is_Block=kanaextendeda}', "");
    Expect(0, 110896, '\p{Is_Block=kanaextendeda}', "");
    Expect(1, 110896, '\p{^Is_Block=kanaextendeda}', "");
    Expect(1, 110896, '\P{Is_Block=kanaextendeda}', "");
    Expect(0, 110896, '\P{^Is_Block=kanaextendeda}', "");
    Expect(1, 110895, '\p{Is_Block=-KANA_Extended_A}', "");
    Expect(0, 110895, '\p{^Is_Block=-KANA_Extended_A}', "");
    Expect(0, 110895, '\P{Is_Block=-KANA_Extended_A}', "");
    Expect(1, 110895, '\P{^Is_Block=-KANA_Extended_A}', "");
    Expect(0, 110896, '\p{Is_Block=-KANA_Extended_A}', "");
    Expect(1, 110896, '\p{^Is_Block=-KANA_Extended_A}', "");
    Expect(1, 110896, '\P{Is_Block=-KANA_Extended_A}', "");
    Expect(0, 110896, '\P{^Is_Block=-KANA_Extended_A}', "");
    Error('\p{Is_Blk= /a/Kana_EXT_A}');
    Error('\P{Is_Blk= /a/Kana_EXT_A}');
    Expect(1, 110895, '\p{Is_Blk=kanaexta}', "");
    Expect(0, 110895, '\p{^Is_Blk=kanaexta}', "");
    Expect(0, 110895, '\P{Is_Blk=kanaexta}', "");
    Expect(1, 110895, '\P{^Is_Blk=kanaexta}', "");
    Expect(0, 110896, '\p{Is_Blk=kanaexta}', "");
    Expect(1, 110896, '\p{^Is_Blk=kanaexta}', "");
    Expect(1, 110896, '\P{Is_Blk=kanaexta}', "");
    Expect(0, 110896, '\P{^Is_Blk=kanaexta}', "");
    Expect(1, 110895, '\p{Is_Blk= KANA_EXT_A}', "");
    Expect(0, 110895, '\p{^Is_Blk= KANA_EXT_A}', "");
    Expect(0, 110895, '\P{Is_Blk= KANA_EXT_A}', "");
    Expect(1, 110895, '\P{^Is_Blk= KANA_EXT_A}', "");
    Expect(0, 110896, '\p{Is_Blk= KANA_EXT_A}', "");
    Expect(1, 110896, '\p{^Is_Blk= KANA_EXT_A}', "");
    Expect(1, 110896, '\P{Is_Blk= KANA_EXT_A}', "");
    Expect(0, 110896, '\P{^Is_Blk= KANA_EXT_A}', "");
    Error('\p{Block:   /a/-	kana_Supplement}');
    Error('\P{Block:   /a/-	kana_Supplement}');
    Expect(1, 110847, '\p{Block=:\AKana_Supplement\z:}', "");;
    Expect(0, 110848, '\p{Block=:\AKana_Supplement\z:}', "");;
    Expect(1, 110847, '\p{Block=kanasupplement}', "");
    Expect(0, 110847, '\p{^Block=kanasupplement}', "");
    Expect(0, 110847, '\P{Block=kanasupplement}', "");
    Expect(1, 110847, '\P{^Block=kanasupplement}', "");
    Expect(0, 110848, '\p{Block=kanasupplement}', "");
    Expect(1, 110848, '\p{^Block=kanasupplement}', "");
    Expect(1, 110848, '\P{Block=kanasupplement}', "");
    Expect(0, 110848, '\P{^Block=kanasupplement}', "");
    Expect(1, 110847, '\p{Block=:\Akanasupplement\z:}', "");;
    Expect(0, 110848, '\p{Block=:\Akanasupplement\z:}', "");;
    Expect(1, 110847, '\p{Block:-	Kana_supplement}', "");
    Expect(0, 110847, '\p{^Block:-	Kana_supplement}', "");
    Expect(0, 110847, '\P{Block:-	Kana_supplement}', "");
    Expect(1, 110847, '\P{^Block:-	Kana_supplement}', "");
    Expect(0, 110848, '\p{Block:-	Kana_supplement}', "");
    Expect(1, 110848, '\p{^Block:-	Kana_supplement}', "");
    Expect(1, 110848, '\P{Block:-	Kana_supplement}', "");
    Expect(0, 110848, '\P{^Block:-	Kana_supplement}', "");
    Error('\p{Blk::=kana_sup}');
    Error('\P{Blk::=kana_sup}');
    Expect(1, 110847, '\p{Blk=:\AKana_Sup\z:}', "");;
    Expect(0, 110848, '\p{Blk=:\AKana_Sup\z:}', "");;
    Expect(1, 110847, '\p{Blk=kanasup}', "");
    Expect(0, 110847, '\p{^Blk=kanasup}', "");
    Expect(0, 110847, '\P{Blk=kanasup}', "");
    Expect(1, 110847, '\P{^Blk=kanasup}', "");
    Expect(0, 110848, '\p{Blk=kanasup}', "");
    Expect(1, 110848, '\p{^Blk=kanasup}', "");
    Expect(1, 110848, '\P{Blk=kanasup}', "");
    Expect(0, 110848, '\P{^Blk=kanasup}', "");
    Expect(1, 110847, '\p{Blk=:\Akanasup\z:}', "");;
    Expect(0, 110848, '\p{Blk=:\Akanasup\z:}', "");;
    Expect(1, 110847, '\p{Blk= 	Kana_Sup}', "");
    Expect(0, 110847, '\p{^Blk= 	Kana_Sup}', "");
    Expect(0, 110847, '\P{Blk= 	Kana_Sup}', "");
    Expect(1, 110847, '\P{^Blk= 	Kana_Sup}', "");
    Expect(0, 110848, '\p{Blk= 	Kana_Sup}', "");
    Expect(1, 110848, '\p{^Blk= 	Kana_Sup}', "");
    Expect(1, 110848, '\P{Blk= 	Kana_Sup}', "");
    Expect(0, 110848, '\P{^Blk= 	Kana_Sup}', "");
    Error('\p{Is_Block=- Kana_SUPPLEMENT:=}');
    Error('\P{Is_Block=- Kana_SUPPLEMENT:=}');
    Expect(1, 110847, '\p{Is_Block=kanasupplement}', "");
    Expect(0, 110847, '\p{^Is_Block=kanasupplement}', "");
    Expect(0, 110847, '\P{Is_Block=kanasupplement}', "");
    Expect(1, 110847, '\P{^Is_Block=kanasupplement}', "");
    Expect(0, 110848, '\p{Is_Block=kanasupplement}', "");
    Expect(1, 110848, '\p{^Is_Block=kanasupplement}', "");
    Expect(1, 110848, '\P{Is_Block=kanasupplement}', "");
    Expect(0, 110848, '\P{^Is_Block=kanasupplement}', "");
    Expect(1, 110847, '\p{Is_Block=_-kana_SUPPLEMENT}', "");
    Expect(0, 110847, '\p{^Is_Block=_-kana_SUPPLEMENT}', "");
    Expect(0, 110847, '\P{Is_Block=_-kana_SUPPLEMENT}', "");
    Expect(1, 110847, '\P{^Is_Block=_-kana_SUPPLEMENT}', "");
    Expect(0, 110848, '\p{Is_Block=_-kana_SUPPLEMENT}', "");
    Expect(1, 110848, '\p{^Is_Block=_-kana_SUPPLEMENT}', "");
    Expect(1, 110848, '\P{Is_Block=_-kana_SUPPLEMENT}', "");
    Expect(0, 110848, '\P{^Is_Block=_-kana_SUPPLEMENT}', "");
    Error('\p{Is_Blk=-:=Kana_Sup}');
    Error('\P{Is_Blk=-:=Kana_Sup}');
    Expect(1, 110847, '\p{Is_Blk=kanasup}', "");
    Expect(0, 110847, '\p{^Is_Blk=kanasup}', "");
    Expect(0, 110847, '\P{Is_Blk=kanasup}', "");
    Expect(1, 110847, '\P{^Is_Blk=kanasup}', "");
    Expect(0, 110848, '\p{Is_Blk=kanasup}', "");
    Expect(1, 110848, '\p{^Is_Blk=kanasup}', "");
    Expect(1, 110848, '\P{Is_Blk=kanasup}', "");
    Expect(0, 110848, '\P{^Is_Blk=kanasup}', "");
    Expect(1, 110847, '\p{Is_Blk:   	_KANA_SUP}', "");
    Expect(0, 110847, '\p{^Is_Blk:   	_KANA_SUP}', "");
    Expect(0, 110847, '\P{Is_Blk:   	_KANA_SUP}', "");
    Expect(1, 110847, '\P{^Is_Blk:   	_KANA_SUP}', "");
    Expect(0, 110848, '\p{Is_Blk:   	_KANA_SUP}', "");
    Expect(1, 110848, '\p{^Is_Blk:   	_KANA_SUP}', "");
    Expect(1, 110848, '\P{Is_Blk:   	_KANA_SUP}', "");
    Expect(0, 110848, '\P{^Is_Blk:   	_KANA_SUP}', "");
    Error('\p{Block=	Kanbun/a/}');
    Error('\P{Block=	Kanbun/a/}');
    Expect(1, 12703, '\p{Block=:\AKanbun\z:}', "");;
    Expect(0, 12704, '\p{Block=:\AKanbun\z:}', "");;
    Expect(1, 12703, '\p{Block=kanbun}', "");
    Expect(0, 12703, '\p{^Block=kanbun}', "");
    Expect(0, 12703, '\P{Block=kanbun}', "");
    Expect(1, 12703, '\P{^Block=kanbun}', "");
    Expect(0, 12704, '\p{Block=kanbun}', "");
    Expect(1, 12704, '\p{^Block=kanbun}', "");
    Expect(1, 12704, '\P{Block=kanbun}', "");
    Expect(0, 12704, '\P{^Block=kanbun}', "");
    Expect(1, 12703, '\p{Block=:\Akanbun\z:}', "");;
    Expect(0, 12704, '\p{Block=:\Akanbun\z:}', "");;
    Expect(1, 12703, '\p{Block= Kanbun}', "");
    Expect(0, 12703, '\p{^Block= Kanbun}', "");
    Expect(0, 12703, '\P{Block= Kanbun}', "");
    Expect(1, 12703, '\P{^Block= Kanbun}', "");
    Expect(0, 12704, '\p{Block= Kanbun}', "");
    Expect(1, 12704, '\p{^Block= Kanbun}', "");
    Expect(1, 12704, '\P{Block= Kanbun}', "");
    Expect(0, 12704, '\P{^Block= Kanbun}', "");
    Error('\p{Blk=	:=Kanbun}');
    Error('\P{Blk=	:=Kanbun}');
    Expect(1, 12703, '\p{Blk=:\AKanbun\z:}', "");;
    Expect(0, 12704, '\p{Blk=:\AKanbun\z:}', "");;
    Expect(1, 12703, '\p{Blk=kanbun}', "");
    Expect(0, 12703, '\p{^Blk=kanbun}', "");
    Expect(0, 12703, '\P{Blk=kanbun}', "");
    Expect(1, 12703, '\P{^Blk=kanbun}', "");
    Expect(0, 12704, '\p{Blk=kanbun}', "");
    Expect(1, 12704, '\p{^Blk=kanbun}', "");
    Expect(1, 12704, '\P{Blk=kanbun}', "");
    Expect(0, 12704, '\P{^Blk=kanbun}', "");
    Expect(1, 12703, '\p{Blk=:\Akanbun\z:}', "");;
    Expect(0, 12704, '\p{Blk=:\Akanbun\z:}', "");;
    Expect(1, 12703, '\p{Blk=	_kanbun}', "");
    Expect(0, 12703, '\p{^Blk=	_kanbun}', "");
    Expect(0, 12703, '\P{Blk=	_kanbun}', "");
    Expect(1, 12703, '\P{^Blk=	_kanbun}', "");
    Expect(0, 12704, '\p{Blk=	_kanbun}', "");
    Expect(1, 12704, '\p{^Blk=	_kanbun}', "");
    Expect(1, 12704, '\P{Blk=	_kanbun}', "");
    Expect(0, 12704, '\P{^Blk=	_kanbun}', "");
    Error('\p{Is_Block=/a/-Kanbun}');
    Error('\P{Is_Block=/a/-Kanbun}');
    Expect(1, 12703, '\p{Is_Block: kanbun}', "");
    Expect(0, 12703, '\p{^Is_Block: kanbun}', "");
    Expect(0, 12703, '\P{Is_Block: kanbun}', "");
    Expect(1, 12703, '\P{^Is_Block: kanbun}', "");
    Expect(0, 12704, '\p{Is_Block: kanbun}', "");
    Expect(1, 12704, '\p{^Is_Block: kanbun}', "");
    Expect(1, 12704, '\P{Is_Block: kanbun}', "");
    Expect(0, 12704, '\P{^Is_Block: kanbun}', "");
    Expect(1, 12703, '\p{Is_Block=--Kanbun}', "");
    Expect(0, 12703, '\p{^Is_Block=--Kanbun}', "");
    Expect(0, 12703, '\P{Is_Block=--Kanbun}', "");
    Expect(1, 12703, '\P{^Is_Block=--Kanbun}', "");
    Expect(0, 12704, '\p{Is_Block=--Kanbun}', "");
    Expect(1, 12704, '\p{^Is_Block=--Kanbun}', "");
    Expect(1, 12704, '\P{Is_Block=--Kanbun}', "");
    Expect(0, 12704, '\P{^Is_Block=--Kanbun}', "");
    Error('\p{Is_Blk= Kanbun:=}');
    Error('\P{Is_Blk= Kanbun:=}');
    Expect(1, 12703, '\p{Is_Blk=kanbun}', "");
    Expect(0, 12703, '\p{^Is_Blk=kanbun}', "");
    Expect(0, 12703, '\P{Is_Blk=kanbun}', "");
    Expect(1, 12703, '\P{^Is_Blk=kanbun}', "");
    Expect(0, 12704, '\p{Is_Blk=kanbun}', "");
    Expect(1, 12704, '\p{^Is_Blk=kanbun}', "");
    Expect(1, 12704, '\P{Is_Blk=kanbun}', "");
    Expect(0, 12704, '\P{^Is_Blk=kanbun}', "");
    Expect(1, 12703, '\p{Is_Blk=_Kanbun}', "");
    Expect(0, 12703, '\p{^Is_Blk=_Kanbun}', "");
    Expect(0, 12703, '\P{Is_Blk=_Kanbun}', "");
    Expect(1, 12703, '\P{^Is_Blk=_Kanbun}', "");
    Expect(0, 12704, '\p{Is_Blk=_Kanbun}', "");
    Expect(1, 12704, '\p{^Is_Blk=_Kanbun}', "");
    Expect(1, 12704, '\P{Is_Blk=_Kanbun}', "");
    Expect(0, 12704, '\P{^Is_Blk=_Kanbun}', "");
    Error('\p{Block=__Kangxi_Radicals/a/}');
    Error('\P{Block=__Kangxi_Radicals/a/}');
    Expect(1, 12255, '\p{Block=:\AKangxi_Radicals\z:}', "");;
    Expect(0, 12256, '\p{Block=:\AKangxi_Radicals\z:}', "");;
    Expect(1, 12255, '\p{Block=kangxiradicals}', "");
    Expect(0, 12255, '\p{^Block=kangxiradicals}', "");
    Expect(0, 12255, '\P{Block=kangxiradicals}', "");
    Expect(1, 12255, '\P{^Block=kangxiradicals}', "");
    Expect(0, 12256, '\p{Block=kangxiradicals}', "");
    Expect(1, 12256, '\p{^Block=kangxiradicals}', "");
    Expect(1, 12256, '\P{Block=kangxiradicals}', "");
    Expect(0, 12256, '\P{^Block=kangxiradicals}', "");
    Expect(1, 12255, '\p{Block=:\Akangxiradicals\z:}', "");;
    Expect(0, 12256, '\p{Block=:\Akangxiradicals\z:}', "");;
    Expect(1, 12255, '\p{Block=_-Kangxi_Radicals}', "");
    Expect(0, 12255, '\p{^Block=_-Kangxi_Radicals}', "");
    Expect(0, 12255, '\P{Block=_-Kangxi_Radicals}', "");
    Expect(1, 12255, '\P{^Block=_-Kangxi_Radicals}', "");
    Expect(0, 12256, '\p{Block=_-Kangxi_Radicals}', "");
    Expect(1, 12256, '\p{^Block=_-Kangxi_Radicals}', "");
    Expect(1, 12256, '\P{Block=_-Kangxi_Radicals}', "");
    Expect(0, 12256, '\P{^Block=_-Kangxi_Radicals}', "");
    Error('\p{Blk=/a/kangxi}');
    Error('\P{Blk=/a/kangxi}');
    Expect(1, 12255, '\p{Blk=:\AKangxi\z:}', "");;
    Expect(0, 12256, '\p{Blk=:\AKangxi\z:}', "");;
    Expect(1, 12255, '\p{Blk=kangxi}', "");
    Expect(0, 12255, '\p{^Blk=kangxi}', "");
    Expect(0, 12255, '\P{Blk=kangxi}', "");
    Expect(1, 12255, '\P{^Blk=kangxi}', "");
    Expect(0, 12256, '\p{Blk=kangxi}', "");
    Expect(1, 12256, '\p{^Blk=kangxi}', "");
    Expect(1, 12256, '\P{Blk=kangxi}', "");
    Expect(0, 12256, '\P{^Blk=kangxi}', "");
    Expect(1, 12255, '\p{Blk=:\Akangxi\z:}', "");;
    Expect(0, 12256, '\p{Blk=:\Akangxi\z:}', "");;
    Expect(1, 12255, '\p{Blk=- kangxi}', "");
    Expect(0, 12255, '\p{^Blk=- kangxi}', "");
    Expect(0, 12255, '\P{Blk=- kangxi}', "");
    Expect(1, 12255, '\P{^Blk=- kangxi}', "");
    Expect(0, 12256, '\p{Blk=- kangxi}', "");
    Expect(1, 12256, '\p{^Blk=- kangxi}', "");
    Expect(1, 12256, '\P{Blk=- kangxi}', "");
    Expect(0, 12256, '\P{^Blk=- kangxi}', "");
    Error('\p{Is_Block=-kangxi_Radicals/a/}');
    Error('\P{Is_Block=-kangxi_Radicals/a/}');
    Expect(1, 12255, '\p{Is_Block=kangxiradicals}', "");
    Expect(0, 12255, '\p{^Is_Block=kangxiradicals}', "");
    Expect(0, 12255, '\P{Is_Block=kangxiradicals}', "");
    Expect(1, 12255, '\P{^Is_Block=kangxiradicals}', "");
    Expect(0, 12256, '\p{Is_Block=kangxiradicals}', "");
    Expect(1, 12256, '\p{^Is_Block=kangxiradicals}', "");
    Expect(1, 12256, '\P{Is_Block=kangxiradicals}', "");
    Expect(0, 12256, '\P{^Is_Block=kangxiradicals}', "");
    Expect(1, 12255, '\p{Is_Block:__Kangxi_Radicals}', "");
    Expect(0, 12255, '\p{^Is_Block:__Kangxi_Radicals}', "");
    Expect(0, 12255, '\P{Is_Block:__Kangxi_Radicals}', "");
    Expect(1, 12255, '\P{^Is_Block:__Kangxi_Radicals}', "");
    Expect(0, 12256, '\p{Is_Block:__Kangxi_Radicals}', "");
    Expect(1, 12256, '\p{^Is_Block:__Kangxi_Radicals}', "");
    Expect(1, 12256, '\P{Is_Block:__Kangxi_Radicals}', "");
    Expect(0, 12256, '\P{^Is_Block:__Kangxi_Radicals}', "");
    Error('\p{Is_Blk:/a/ 	Kangxi}');
    Error('\P{Is_Blk:/a/ 	Kangxi}');
    Expect(1, 12255, '\p{Is_Blk=kangxi}', "");
    Expect(0, 12255, '\p{^Is_Blk=kangxi}', "");
    Expect(0, 12255, '\P{Is_Blk=kangxi}', "");
    Expect(1, 12255, '\P{^Is_Blk=kangxi}', "");
    Expect(0, 12256, '\p{Is_Blk=kangxi}', "");
    Expect(1, 12256, '\p{^Is_Blk=kangxi}', "");
    Expect(1, 12256, '\P{Is_Blk=kangxi}', "");
    Expect(0, 12256, '\P{^Is_Blk=kangxi}', "");
    Expect(1, 12255, '\p{Is_Blk=	-kangxi}', "");
    Expect(0, 12255, '\p{^Is_Blk=	-kangxi}', "");
    Expect(0, 12255, '\P{Is_Blk=	-kangxi}', "");
    Expect(1, 12255, '\P{^Is_Blk=	-kangxi}', "");
    Expect(0, 12256, '\p{Is_Blk=	-kangxi}', "");
    Expect(1, 12256, '\p{^Is_Blk=	-kangxi}', "");
    Expect(1, 12256, '\P{Is_Blk=	-kangxi}', "");
    Expect(0, 12256, '\P{^Is_Blk=	-kangxi}', "");
    Error('\p{Block:   :=_KANNADA}');
    Error('\P{Block:   :=_KANNADA}');
    Expect(1, 3327, '\p{Block=:\AKannada\z:}', "");;
    Expect(0, 3328, '\p{Block=:\AKannada\z:}', "");;
    Expect(1, 3327, '\p{Block:kannada}', "");
    Expect(0, 3327, '\p{^Block:kannada}', "");
    Expect(0, 3327, '\P{Block:kannada}', "");
    Expect(1, 3327, '\P{^Block:kannada}', "");
    Expect(0, 3328, '\p{Block:kannada}', "");
    Expect(1, 3328, '\p{^Block:kannada}', "");
    Expect(1, 3328, '\P{Block:kannada}', "");
    Expect(0, 3328, '\P{^Block:kannada}', "");
    Expect(1, 3327, '\p{Block=:\Akannada\z:}', "");;
    Expect(0, 3328, '\p{Block=:\Akannada\z:}', "");;
    Expect(1, 3327, '\p{Block=-Kannada}', "");
    Expect(0, 3327, '\p{^Block=-Kannada}', "");
    Expect(0, 3327, '\P{Block=-Kannada}', "");
    Expect(1, 3327, '\P{^Block=-Kannada}', "");
    Expect(0, 3328, '\p{Block=-Kannada}', "");
    Expect(1, 3328, '\p{^Block=-Kannada}', "");
    Expect(1, 3328, '\P{Block=-Kannada}', "");
    Expect(0, 3328, '\P{^Block=-Kannada}', "");
    Error('\p{Blk:	_:=KANNADA}');
    Error('\P{Blk:	_:=KANNADA}');
    Expect(1, 3327, '\p{Blk=:\AKannada\z:}', "");;
    Expect(0, 3328, '\p{Blk=:\AKannada\z:}', "");;
    Expect(1, 3327, '\p{Blk=kannada}', "");
    Expect(0, 3327, '\p{^Blk=kannada}', "");
    Expect(0, 3327, '\P{Blk=kannada}', "");
    Expect(1, 3327, '\P{^Blk=kannada}', "");
    Expect(0, 3328, '\p{Blk=kannada}', "");
    Expect(1, 3328, '\p{^Blk=kannada}', "");
    Expect(1, 3328, '\P{Blk=kannada}', "");
    Expect(0, 3328, '\P{^Blk=kannada}', "");
    Expect(1, 3327, '\p{Blk=:\Akannada\z:}', "");;
    Expect(0, 3328, '\p{Blk=:\Akannada\z:}', "");;
    Expect(1, 3327, '\p{Blk:		_Kannada}', "");
    Expect(0, 3327, '\p{^Blk:		_Kannada}', "");
    Expect(0, 3327, '\P{Blk:		_Kannada}', "");
    Expect(1, 3327, '\P{^Blk:		_Kannada}', "");
    Expect(0, 3328, '\p{Blk:		_Kannada}', "");
    Expect(1, 3328, '\p{^Blk:		_Kannada}', "");
    Expect(1, 3328, '\P{Blk:		_Kannada}', "");
    Expect(0, 3328, '\P{^Blk:		_Kannada}', "");
    Error('\p{Is_Block=_	kannada/a/}');
    Error('\P{Is_Block=_	kannada/a/}');
    Expect(1, 3327, '\p{Is_Block=kannada}', "");
    Expect(0, 3327, '\p{^Is_Block=kannada}', "");
    Expect(0, 3327, '\P{Is_Block=kannada}', "");
    Expect(1, 3327, '\P{^Is_Block=kannada}', "");
    Expect(0, 3328, '\p{Is_Block=kannada}', "");
    Expect(1, 3328, '\p{^Is_Block=kannada}', "");
    Expect(1, 3328, '\P{Is_Block=kannada}', "");
    Expect(0, 3328, '\P{^Is_Block=kannada}', "");
    Expect(1, 3327, '\p{Is_Block=-Kannada}', "");
    Expect(0, 3327, '\p{^Is_Block=-Kannada}', "");
    Expect(0, 3327, '\P{Is_Block=-Kannada}', "");
    Expect(1, 3327, '\P{^Is_Block=-Kannada}', "");
    Expect(0, 3328, '\p{Is_Block=-Kannada}', "");
    Expect(1, 3328, '\p{^Is_Block=-Kannada}', "");
    Expect(1, 3328, '\P{Is_Block=-Kannada}', "");
    Expect(0, 3328, '\P{^Is_Block=-Kannada}', "");
    Error('\p{Is_Blk=/a/_kannada}');
    Error('\P{Is_Blk=/a/_kannada}');
    Expect(1, 3327, '\p{Is_Blk=kannada}', "");
    Expect(0, 3327, '\p{^Is_Blk=kannada}', "");
    Expect(0, 3327, '\P{Is_Blk=kannada}', "");
    Expect(1, 3327, '\P{^Is_Blk=kannada}', "");
    Expect(0, 3328, '\p{Is_Blk=kannada}', "");
    Expect(1, 3328, '\p{^Is_Blk=kannada}', "");
    Expect(1, 3328, '\P{Is_Blk=kannada}', "");
    Expect(0, 3328, '\P{^Is_Blk=kannada}', "");
    Expect(1, 3327, '\p{Is_Blk=		kannada}', "");
    Expect(0, 3327, '\p{^Is_Blk=		kannada}', "");
    Expect(0, 3327, '\P{Is_Blk=		kannada}', "");
    Expect(1, 3327, '\P{^Is_Blk=		kannada}', "");
    Expect(0, 3328, '\p{Is_Blk=		kannada}', "");
    Expect(1, 3328, '\p{^Is_Blk=		kannada}', "");
    Expect(1, 3328, '\P{Is_Blk=		kannada}', "");
    Expect(0, 3328, '\P{^Is_Blk=		kannada}', "");
    Error('\p{Block=_/a/Katakana}');
    Error('\P{Block=_/a/Katakana}');
    Expect(1, 12543, '\p{Block=:\AKatakana\z:}', "");;
    Expect(0, 12544, '\p{Block=:\AKatakana\z:}', "");;
    Expect(1, 12543, '\p{Block=katakana}', "");
    Expect(0, 12543, '\p{^Block=katakana}', "");
    Expect(0, 12543, '\P{Block=katakana}', "");
    Expect(1, 12543, '\P{^Block=katakana}', "");
    Expect(0, 12544, '\p{Block=katakana}', "");
    Expect(1, 12544, '\p{^Block=katakana}', "");
    Expect(1, 12544, '\P{Block=katakana}', "");
    Expect(0, 12544, '\P{^Block=katakana}', "");
    Expect(1, 12543, '\p{Block=:\Akatakana\z:}', "");;
    Expect(0, 12544, '\p{Block=:\Akatakana\z:}', "");;
    Expect(1, 12543, '\p{Block= katakana}', "");
    Expect(0, 12543, '\p{^Block= katakana}', "");
    Expect(0, 12543, '\P{Block= katakana}', "");
    Expect(1, 12543, '\P{^Block= katakana}', "");
    Expect(0, 12544, '\p{Block= katakana}', "");
    Expect(1, 12544, '\p{^Block= katakana}', "");
    Expect(1, 12544, '\P{Block= katakana}', "");
    Expect(0, 12544, '\P{^Block= katakana}', "");
    Error('\p{Blk=/a/_ katakana}');
    Error('\P{Blk=/a/_ katakana}');
    Expect(1, 12543, '\p{Blk=:\AKatakana\z:}', "");;
    Expect(0, 12544, '\p{Blk=:\AKatakana\z:}', "");;
    Expect(1, 12543, '\p{Blk:	katakana}', "");
    Expect(0, 12543, '\p{^Blk:	katakana}', "");
    Expect(0, 12543, '\P{Blk:	katakana}', "");
    Expect(1, 12543, '\P{^Blk:	katakana}', "");
    Expect(0, 12544, '\p{Blk:	katakana}', "");
    Expect(1, 12544, '\p{^Blk:	katakana}', "");
    Expect(1, 12544, '\P{Blk:	katakana}', "");
    Expect(0, 12544, '\P{^Blk:	katakana}', "");
    Expect(1, 12543, '\p{Blk=:\Akatakana\z:}', "");;
    Expect(0, 12544, '\p{Blk=:\Akatakana\z:}', "");;
    Expect(1, 12543, '\p{Blk=Katakana}', "");
    Expect(0, 12543, '\p{^Blk=Katakana}', "");
    Expect(0, 12543, '\P{Blk=Katakana}', "");
    Expect(1, 12543, '\P{^Blk=Katakana}', "");
    Expect(0, 12544, '\p{Blk=Katakana}', "");
    Expect(1, 12544, '\p{^Blk=Katakana}', "");
    Expect(1, 12544, '\P{Blk=Katakana}', "");
    Expect(0, 12544, '\P{^Blk=Katakana}', "");
    Error('\p{Is_Block=:=_-Katakana}');
    Error('\P{Is_Block=:=_-Katakana}');
    Expect(1, 12543, '\p{Is_Block=katakana}', "");
    Expect(0, 12543, '\p{^Is_Block=katakana}', "");
    Expect(0, 12543, '\P{Is_Block=katakana}', "");
    Expect(1, 12543, '\P{^Is_Block=katakana}', "");
    Expect(0, 12544, '\p{Is_Block=katakana}', "");
    Expect(1, 12544, '\p{^Is_Block=katakana}', "");
    Expect(1, 12544, '\P{Is_Block=katakana}', "");
    Expect(0, 12544, '\P{^Is_Block=katakana}', "");
    Expect(1, 12543, '\p{Is_Block=_Katakana}', "");
    Expect(0, 12543, '\p{^Is_Block=_Katakana}', "");
    Expect(0, 12543, '\P{Is_Block=_Katakana}', "");
    Expect(1, 12543, '\P{^Is_Block=_Katakana}', "");
    Expect(0, 12544, '\p{Is_Block=_Katakana}', "");
    Expect(1, 12544, '\p{^Is_Block=_Katakana}', "");
    Expect(1, 12544, '\P{Is_Block=_Katakana}', "");
    Expect(0, 12544, '\P{^Is_Block=_Katakana}', "");
    Error('\p{Is_Blk=/a/katakana}');
    Error('\P{Is_Blk=/a/katakana}');
    Expect(1, 12543, '\p{Is_Blk=katakana}', "");
    Expect(0, 12543, '\p{^Is_Blk=katakana}', "");
    Expect(0, 12543, '\P{Is_Blk=katakana}', "");
    Expect(1, 12543, '\P{^Is_Blk=katakana}', "");
    Expect(0, 12544, '\p{Is_Blk=katakana}', "");
    Expect(1, 12544, '\p{^Is_Blk=katakana}', "");
    Expect(1, 12544, '\P{Is_Blk=katakana}', "");
    Expect(0, 12544, '\P{^Is_Blk=katakana}', "");
    Expect(1, 12543, '\p{Is_Blk=		Katakana}', "");
    Expect(0, 12543, '\p{^Is_Blk=		Katakana}', "");
    Expect(0, 12543, '\P{Is_Blk=		Katakana}', "");
    Expect(1, 12543, '\P{^Is_Blk=		Katakana}', "");
    Expect(0, 12544, '\p{Is_Blk=		Katakana}', "");
    Expect(1, 12544, '\p{^Is_Blk=		Katakana}', "");
    Expect(1, 12544, '\P{Is_Blk=		Katakana}', "");
    Expect(0, 12544, '\P{^Is_Blk=		Katakana}', "");
    Error('\p{Block: /a/	katakana_Phonetic_Extensions}');
    Error('\P{Block: /a/	katakana_Phonetic_Extensions}');
    Expect(1, 12799, '\p{Block=:\AKatakana_Phonetic_Extensions\z:}', "");;
    Expect(0, 12800, '\p{Block=:\AKatakana_Phonetic_Extensions\z:}', "");;
    Expect(1, 12799, '\p{Block=katakanaphoneticextensions}', "");
    Expect(0, 12799, '\p{^Block=katakanaphoneticextensions}', "");
    Expect(0, 12799, '\P{Block=katakanaphoneticextensions}', "");
    Expect(1, 12799, '\P{^Block=katakanaphoneticextensions}', "");
    Expect(0, 12800, '\p{Block=katakanaphoneticextensions}', "");
    Expect(1, 12800, '\p{^Block=katakanaphoneticextensions}', "");
    Expect(1, 12800, '\P{Block=katakanaphoneticextensions}', "");
    Expect(0, 12800, '\P{^Block=katakanaphoneticextensions}', "");
    Expect(1, 12799, '\p{Block=:\Akatakanaphoneticextensions\z:}', "");;
    Expect(0, 12800, '\p{Block=:\Akatakanaphoneticextensions\z:}', "");;
    Expect(1, 12799, '\p{Block:	KATAKANA_phonetic_extensions}', "");
    Expect(0, 12799, '\p{^Block:	KATAKANA_phonetic_extensions}', "");
    Expect(0, 12799, '\P{Block:	KATAKANA_phonetic_extensions}', "");
    Expect(1, 12799, '\P{^Block:	KATAKANA_phonetic_extensions}', "");
    Expect(0, 12800, '\p{Block:	KATAKANA_phonetic_extensions}', "");
    Expect(1, 12800, '\p{^Block:	KATAKANA_phonetic_extensions}', "");
    Expect(1, 12800, '\P{Block:	KATAKANA_phonetic_extensions}', "");
    Expect(0, 12800, '\P{^Block:	KATAKANA_phonetic_extensions}', "");
    Error('\p{Blk=_/a/Katakana_Ext}');
    Error('\P{Blk=_/a/Katakana_Ext}');
    Expect(1, 12799, '\p{Blk=:\AKatakana_Ext\z:}', "");;
    Expect(0, 12800, '\p{Blk=:\AKatakana_Ext\z:}', "");;
    Expect(1, 12799, '\p{Blk=katakanaext}', "");
    Expect(0, 12799, '\p{^Blk=katakanaext}', "");
    Expect(0, 12799, '\P{Blk=katakanaext}', "");
    Expect(1, 12799, '\P{^Blk=katakanaext}', "");
    Expect(0, 12800, '\p{Blk=katakanaext}', "");
    Expect(1, 12800, '\p{^Blk=katakanaext}', "");
    Expect(1, 12800, '\P{Blk=katakanaext}', "");
    Expect(0, 12800, '\P{^Blk=katakanaext}', "");
    Expect(1, 12799, '\p{Blk=:\Akatakanaext\z:}', "");;
    Expect(0, 12800, '\p{Blk=:\Akatakanaext\z:}', "");;
    Expect(1, 12799, '\p{Blk=-_KATAKANA_ext}', "");
    Expect(0, 12799, '\p{^Blk=-_KATAKANA_ext}', "");
    Expect(0, 12799, '\P{Blk=-_KATAKANA_ext}', "");
    Expect(1, 12799, '\P{^Blk=-_KATAKANA_ext}', "");
    Expect(0, 12800, '\p{Blk=-_KATAKANA_ext}', "");
    Expect(1, 12800, '\p{^Blk=-_KATAKANA_ext}', "");
    Expect(1, 12800, '\P{Blk=-_KATAKANA_ext}', "");
    Expect(0, 12800, '\P{^Blk=-_KATAKANA_ext}', "");
    Error('\p{Is_Block=:=-	Katakana_Phonetic_Extensions}');
    Error('\P{Is_Block=:=-	Katakana_Phonetic_Extensions}');
    Expect(1, 12799, '\p{Is_Block=katakanaphoneticextensions}', "");
    Expect(0, 12799, '\p{^Is_Block=katakanaphoneticextensions}', "");
    Expect(0, 12799, '\P{Is_Block=katakanaphoneticextensions}', "");
    Expect(1, 12799, '\P{^Is_Block=katakanaphoneticextensions}', "");
    Expect(0, 12800, '\p{Is_Block=katakanaphoneticextensions}', "");
    Expect(1, 12800, '\p{^Is_Block=katakanaphoneticextensions}', "");
    Expect(1, 12800, '\P{Is_Block=katakanaphoneticextensions}', "");
    Expect(0, 12800, '\P{^Is_Block=katakanaphoneticextensions}', "");
    Expect(1, 12799, '\p{Is_Block=-katakana_PHONETIC_EXTENSIONS}', "");
    Expect(0, 12799, '\p{^Is_Block=-katakana_PHONETIC_EXTENSIONS}', "");
    Expect(0, 12799, '\P{Is_Block=-katakana_PHONETIC_EXTENSIONS}', "");
    Expect(1, 12799, '\P{^Is_Block=-katakana_PHONETIC_EXTENSIONS}', "");
    Expect(0, 12800, '\p{Is_Block=-katakana_PHONETIC_EXTENSIONS}', "");
    Expect(1, 12800, '\p{^Is_Block=-katakana_PHONETIC_EXTENSIONS}', "");
    Expect(1, 12800, '\P{Is_Block=-katakana_PHONETIC_EXTENSIONS}', "");
    Expect(0, 12800, '\P{^Is_Block=-katakana_PHONETIC_EXTENSIONS}', "");
    Error('\p{Is_Blk= /a/Katakana_Ext}');
    Error('\P{Is_Blk= /a/Katakana_Ext}');
    Expect(1, 12799, '\p{Is_Blk=katakanaext}', "");
    Expect(0, 12799, '\p{^Is_Blk=katakanaext}', "");
    Expect(0, 12799, '\P{Is_Blk=katakanaext}', "");
    Expect(1, 12799, '\P{^Is_Blk=katakanaext}', "");
    Expect(0, 12800, '\p{Is_Blk=katakanaext}', "");
    Expect(1, 12800, '\p{^Is_Blk=katakanaext}', "");
    Expect(1, 12800, '\P{Is_Blk=katakanaext}', "");
    Expect(0, 12800, '\P{^Is_Blk=katakanaext}', "");
    Expect(1, 12799, '\p{Is_Blk=	 KATAKANA_ext}', "");
    Expect(0, 12799, '\p{^Is_Blk=	 KATAKANA_ext}', "");
    Expect(0, 12799, '\P{Is_Blk=	 KATAKANA_ext}', "");
    Expect(1, 12799, '\P{^Is_Blk=	 KATAKANA_ext}', "");
    Expect(0, 12800, '\p{Is_Blk=	 KATAKANA_ext}', "");
    Expect(1, 12800, '\p{^Is_Blk=	 KATAKANA_ext}', "");
    Expect(1, 12800, '\P{Is_Blk=	 KATAKANA_ext}', "");
    Expect(0, 12800, '\P{^Is_Blk=	 KATAKANA_ext}', "");
    Error('\p{Block=  Kayah_li/a/}');
    Error('\P{Block=  Kayah_li/a/}');
    Expect(1, 43311, '\p{Block=:\AKayah_Li\z:}', "");;
    Expect(0, 43312, '\p{Block=:\AKayah_Li\z:}', "");;
    Expect(1, 43311, '\p{Block=kayahli}', "");
    Expect(0, 43311, '\p{^Block=kayahli}', "");
    Expect(0, 43311, '\P{Block=kayahli}', "");
    Expect(1, 43311, '\P{^Block=kayahli}', "");
    Expect(0, 43312, '\p{Block=kayahli}', "");
    Expect(1, 43312, '\p{^Block=kayahli}', "");
    Expect(1, 43312, '\P{Block=kayahli}', "");
    Expect(0, 43312, '\P{^Block=kayahli}', "");
    Expect(1, 43311, '\p{Block=:\Akayahli\z:}', "");;
    Expect(0, 43312, '\p{Block=:\Akayahli\z:}', "");;
    Expect(1, 43311, '\p{Block=	KAYAH_Li}', "");
    Expect(0, 43311, '\p{^Block=	KAYAH_Li}', "");
    Expect(0, 43311, '\P{Block=	KAYAH_Li}', "");
    Expect(1, 43311, '\P{^Block=	KAYAH_Li}', "");
    Expect(0, 43312, '\p{Block=	KAYAH_Li}', "");
    Expect(1, 43312, '\p{^Block=	KAYAH_Li}', "");
    Expect(1, 43312, '\P{Block=	KAYAH_Li}', "");
    Expect(0, 43312, '\P{^Block=	KAYAH_Li}', "");
    Error('\p{Blk=	 kayah_Li/a/}');
    Error('\P{Blk=	 kayah_Li/a/}');
    Expect(1, 43311, '\p{Blk=:\AKayah_Li\z:}', "");;
    Expect(0, 43312, '\p{Blk=:\AKayah_Li\z:}', "");;
    Expect(1, 43311, '\p{Blk=kayahli}', "");
    Expect(0, 43311, '\p{^Blk=kayahli}', "");
    Expect(0, 43311, '\P{Blk=kayahli}', "");
    Expect(1, 43311, '\P{^Blk=kayahli}', "");
    Expect(0, 43312, '\p{Blk=kayahli}', "");
    Expect(1, 43312, '\p{^Blk=kayahli}', "");
    Expect(1, 43312, '\P{Blk=kayahli}', "");
    Expect(0, 43312, '\P{^Blk=kayahli}', "");
    Expect(1, 43311, '\p{Blk=:\Akayahli\z:}', "");;
    Expect(0, 43312, '\p{Blk=:\Akayahli\z:}', "");;
    Expect(1, 43311, '\p{Blk=__kayah_Li}', "");
    Expect(0, 43311, '\p{^Blk=__kayah_Li}', "");
    Expect(0, 43311, '\P{Blk=__kayah_Li}', "");
    Expect(1, 43311, '\P{^Blk=__kayah_Li}', "");
    Expect(0, 43312, '\p{Blk=__kayah_Li}', "");
    Expect(1, 43312, '\p{^Blk=__kayah_Li}', "");
    Expect(1, 43312, '\P{Blk=__kayah_Li}', "");
    Expect(0, 43312, '\P{^Blk=__kayah_Li}', "");
    Error('\p{Is_Block=/a/	Kayah_LI}');
    Error('\P{Is_Block=/a/	Kayah_LI}');
    Expect(1, 43311, '\p{Is_Block=kayahli}', "");
    Expect(0, 43311, '\p{^Is_Block=kayahli}', "");
    Expect(0, 43311, '\P{Is_Block=kayahli}', "");
    Expect(1, 43311, '\P{^Is_Block=kayahli}', "");
    Expect(0, 43312, '\p{Is_Block=kayahli}', "");
    Expect(1, 43312, '\p{^Is_Block=kayahli}', "");
    Expect(1, 43312, '\P{Is_Block=kayahli}', "");
    Expect(0, 43312, '\P{^Is_Block=kayahli}', "");
    Expect(1, 43311, '\p{Is_Block=	Kayah_LI}', "");
    Expect(0, 43311, '\p{^Is_Block=	Kayah_LI}', "");
    Expect(0, 43311, '\P{Is_Block=	Kayah_LI}', "");
    Expect(1, 43311, '\P{^Is_Block=	Kayah_LI}', "");
    Expect(0, 43312, '\p{Is_Block=	Kayah_LI}', "");
    Expect(1, 43312, '\p{^Is_Block=	Kayah_LI}', "");
    Expect(1, 43312, '\P{Is_Block=	Kayah_LI}', "");
    Expect(0, 43312, '\P{^Is_Block=	Kayah_LI}', "");
    Error('\p{Is_Blk=:=-	Kayah_Li}');
    Error('\P{Is_Blk=:=-	Kayah_Li}');
    Expect(1, 43311, '\p{Is_Blk=kayahli}', "");
    Expect(0, 43311, '\p{^Is_Blk=kayahli}', "");
    Expect(0, 43311, '\P{Is_Blk=kayahli}', "");
    Expect(1, 43311, '\P{^Is_Blk=kayahli}', "");
    Expect(0, 43312, '\p{Is_Blk=kayahli}', "");
    Expect(1, 43312, '\p{^Is_Blk=kayahli}', "");
    Expect(1, 43312, '\P{Is_Blk=kayahli}', "");
    Expect(0, 43312, '\P{^Is_Blk=kayahli}', "");
    Expect(1, 43311, '\p{Is_Blk=-_Kayah_li}', "");
    Expect(0, 43311, '\p{^Is_Blk=-_Kayah_li}', "");
    Expect(0, 43311, '\P{Is_Blk=-_Kayah_li}', "");
    Expect(1, 43311, '\P{^Is_Blk=-_Kayah_li}', "");
    Expect(0, 43312, '\p{Is_Blk=-_Kayah_li}', "");
    Expect(1, 43312, '\p{^Is_Blk=-_Kayah_li}', "");
    Expect(1, 43312, '\P{Is_Blk=-_Kayah_li}', "");
    Expect(0, 43312, '\P{^Is_Blk=-_Kayah_li}', "");
    Error('\p{Block=:=	kharoshthi}');
    Error('\P{Block=:=	kharoshthi}');
    Expect(1, 68191, '\p{Block=:\AKharoshthi\z:}', "");;
    Expect(0, 68192, '\p{Block=:\AKharoshthi\z:}', "");;
    Expect(1, 68191, '\p{Block=kharoshthi}', "");
    Expect(0, 68191, '\p{^Block=kharoshthi}', "");
    Expect(0, 68191, '\P{Block=kharoshthi}', "");
    Expect(1, 68191, '\P{^Block=kharoshthi}', "");
    Expect(0, 68192, '\p{Block=kharoshthi}', "");
    Expect(1, 68192, '\p{^Block=kharoshthi}', "");
    Expect(1, 68192, '\P{Block=kharoshthi}', "");
    Expect(0, 68192, '\P{^Block=kharoshthi}', "");
    Expect(1, 68191, '\p{Block=:\Akharoshthi\z:}', "");;
    Expect(0, 68192, '\p{Block=:\Akharoshthi\z:}', "");;
    Expect(1, 68191, '\p{Block=--KHAROSHTHI}', "");
    Expect(0, 68191, '\p{^Block=--KHAROSHTHI}', "");
    Expect(0, 68191, '\P{Block=--KHAROSHTHI}', "");
    Expect(1, 68191, '\P{^Block=--KHAROSHTHI}', "");
    Expect(0, 68192, '\p{Block=--KHAROSHTHI}', "");
    Expect(1, 68192, '\p{^Block=--KHAROSHTHI}', "");
    Expect(1, 68192, '\P{Block=--KHAROSHTHI}', "");
    Expect(0, 68192, '\P{^Block=--KHAROSHTHI}', "");
    Error('\p{Blk=:=-KHAROSHTHI}');
    Error('\P{Blk=:=-KHAROSHTHI}');
    Expect(1, 68191, '\p{Blk=:\AKharoshthi\z:}', "");;
    Expect(0, 68192, '\p{Blk=:\AKharoshthi\z:}', "");;
    Expect(1, 68191, '\p{Blk=kharoshthi}', "");
    Expect(0, 68191, '\p{^Blk=kharoshthi}', "");
    Expect(0, 68191, '\P{Blk=kharoshthi}', "");
    Expect(1, 68191, '\P{^Blk=kharoshthi}', "");
    Expect(0, 68192, '\p{Blk=kharoshthi}', "");
    Expect(1, 68192, '\p{^Blk=kharoshthi}', "");
    Expect(1, 68192, '\P{Blk=kharoshthi}', "");
    Expect(0, 68192, '\P{^Blk=kharoshthi}', "");
    Expect(1, 68191, '\p{Blk=:\Akharoshthi\z:}', "");;
    Expect(0, 68192, '\p{Blk=:\Akharoshthi\z:}', "");;
    Expect(1, 68191, '\p{Blk=_ Kharoshthi}', "");
    Expect(0, 68191, '\p{^Blk=_ Kharoshthi}', "");
    Expect(0, 68191, '\P{Blk=_ Kharoshthi}', "");
    Expect(1, 68191, '\P{^Blk=_ Kharoshthi}', "");
    Expect(0, 68192, '\p{Blk=_ Kharoshthi}', "");
    Expect(1, 68192, '\p{^Blk=_ Kharoshthi}', "");
    Expect(1, 68192, '\P{Blk=_ Kharoshthi}', "");
    Expect(0, 68192, '\P{^Blk=_ Kharoshthi}', "");
    Error('\p{Is_Block=/a/ _Kharoshthi}');
    Error('\P{Is_Block=/a/ _Kharoshthi}');
    Expect(1, 68191, '\p{Is_Block:   kharoshthi}', "");
    Expect(0, 68191, '\p{^Is_Block:   kharoshthi}', "");
    Expect(0, 68191, '\P{Is_Block:   kharoshthi}', "");
    Expect(1, 68191, '\P{^Is_Block:   kharoshthi}', "");
    Expect(0, 68192, '\p{Is_Block:   kharoshthi}', "");
    Expect(1, 68192, '\p{^Is_Block:   kharoshthi}', "");
    Expect(1, 68192, '\P{Is_Block:   kharoshthi}', "");
    Expect(0, 68192, '\P{^Is_Block:   kharoshthi}', "");
    Expect(1, 68191, '\p{Is_Block=-KHAROSHTHI}', "");
    Expect(0, 68191, '\p{^Is_Block=-KHAROSHTHI}', "");
    Expect(0, 68191, '\P{Is_Block=-KHAROSHTHI}', "");
    Expect(1, 68191, '\P{^Is_Block=-KHAROSHTHI}', "");
    Expect(0, 68192, '\p{Is_Block=-KHAROSHTHI}', "");
    Expect(1, 68192, '\p{^Is_Block=-KHAROSHTHI}', "");
    Expect(1, 68192, '\P{Is_Block=-KHAROSHTHI}', "");
    Expect(0, 68192, '\P{^Is_Block=-KHAROSHTHI}', "");
    Error('\p{Is_Blk=-:=Kharoshthi}');
    Error('\P{Is_Blk=-:=Kharoshthi}');
    Expect(1, 68191, '\p{Is_Blk=kharoshthi}', "");
    Expect(0, 68191, '\p{^Is_Blk=kharoshthi}', "");
    Expect(0, 68191, '\P{Is_Blk=kharoshthi}', "");
    Expect(1, 68191, '\P{^Is_Blk=kharoshthi}', "");
    Expect(0, 68192, '\p{Is_Blk=kharoshthi}', "");
    Expect(1, 68192, '\p{^Is_Blk=kharoshthi}', "");
    Expect(1, 68192, '\P{Is_Blk=kharoshthi}', "");
    Expect(0, 68192, '\P{^Is_Blk=kharoshthi}', "");
    Expect(1, 68191, '\p{Is_Blk:	 _Kharoshthi}', "");
    Expect(0, 68191, '\p{^Is_Blk:	 _Kharoshthi}', "");
    Expect(0, 68191, '\P{Is_Blk:	 _Kharoshthi}', "");
    Expect(1, 68191, '\P{^Is_Blk:	 _Kharoshthi}', "");
    Expect(0, 68192, '\p{Is_Blk:	 _Kharoshthi}', "");
    Expect(1, 68192, '\p{^Is_Blk:	 _Kharoshthi}', "");
    Expect(1, 68192, '\P{Is_Blk:	 _Kharoshthi}', "");
    Expect(0, 68192, '\P{^Is_Blk:	 _Kharoshthi}', "");
    Error('\p{Block=:= khmer}');
    Error('\P{Block=:= khmer}');
    Expect(1, 6143, '\p{Block=:\AKhmer\z:}', "");;
    Expect(0, 6144, '\p{Block=:\AKhmer\z:}', "");;
    Expect(1, 6143, '\p{Block=khmer}', "");
    Expect(0, 6143, '\p{^Block=khmer}', "");
    Expect(0, 6143, '\P{Block=khmer}', "");
    Expect(1, 6143, '\P{^Block=khmer}', "");
    Expect(0, 6144, '\p{Block=khmer}', "");
    Expect(1, 6144, '\p{^Block=khmer}', "");
    Expect(1, 6144, '\P{Block=khmer}', "");
    Expect(0, 6144, '\P{^Block=khmer}', "");
    Expect(1, 6143, '\p{Block=:\Akhmer\z:}', "");;
    Expect(0, 6144, '\p{Block=:\Akhmer\z:}', "");;
    Error('\p{Blk=	/a/KHMER}');
    Error('\P{Blk=	/a/KHMER}');
    Expect(1, 6143, '\p{Blk=:\AKhmer\z:}', "");;
    Expect(0, 6144, '\p{Blk=:\AKhmer\z:}', "");;
    Expect(1, 6143, '\p{Blk=khmer}', "");
    Expect(0, 6143, '\p{^Blk=khmer}', "");
    Expect(0, 6143, '\P{Blk=khmer}', "");
    Expect(1, 6143, '\P{^Blk=khmer}', "");
    Expect(0, 6144, '\p{Blk=khmer}', "");
    Expect(1, 6144, '\p{^Blk=khmer}', "");
    Expect(1, 6144, '\P{Blk=khmer}', "");
    Expect(0, 6144, '\P{^Blk=khmer}', "");
    Expect(1, 6143, '\p{Blk=:\Akhmer\z:}', "");;
    Expect(0, 6144, '\p{Blk=:\Akhmer\z:}', "");;
    Expect(1, 6143, '\p{Blk:   khmer}', "");
    Expect(0, 6143, '\p{^Blk:   khmer}', "");
    Expect(0, 6143, '\P{Blk:   khmer}', "");
    Expect(1, 6143, '\P{^Blk:   khmer}', "");
    Expect(0, 6144, '\p{Blk:   khmer}', "");
    Expect(1, 6144, '\p{^Blk:   khmer}', "");
    Expect(1, 6144, '\P{Blk:   khmer}', "");
    Expect(0, 6144, '\P{^Blk:   khmer}', "");
    Error('\p{Is_Block=:=	_khmer}');
    Error('\P{Is_Block=:=	_khmer}');
    Expect(1, 6143, '\p{Is_Block=khmer}', "");
    Expect(0, 6143, '\p{^Is_Block=khmer}', "");
    Expect(0, 6143, '\P{Is_Block=khmer}', "");
    Expect(1, 6143, '\P{^Is_Block=khmer}', "");
    Expect(0, 6144, '\p{Is_Block=khmer}', "");
    Expect(1, 6144, '\p{^Is_Block=khmer}', "");
    Expect(1, 6144, '\P{Is_Block=khmer}', "");
    Expect(0, 6144, '\P{^Is_Block=khmer}', "");
    Expect(1, 6143, '\p{Is_Block= Khmer}', "");
    Expect(0, 6143, '\p{^Is_Block= Khmer}', "");
    Expect(0, 6143, '\P{Is_Block= Khmer}', "");
    Expect(1, 6143, '\P{^Is_Block= Khmer}', "");
    Expect(0, 6144, '\p{Is_Block= Khmer}', "");
    Expect(1, 6144, '\p{^Is_Block= Khmer}', "");
    Expect(1, 6144, '\P{Is_Block= Khmer}', "");
    Expect(0, 6144, '\P{^Is_Block= Khmer}', "");
    Error('\p{Is_Blk=_/a/Khmer}');
    Error('\P{Is_Blk=_/a/Khmer}');
    Expect(1, 6143, '\p{Is_Blk: khmer}', "");
    Expect(0, 6143, '\p{^Is_Blk: khmer}', "");
    Expect(0, 6143, '\P{Is_Blk: khmer}', "");
    Expect(1, 6143, '\P{^Is_Blk: khmer}', "");
    Expect(0, 6144, '\p{Is_Blk: khmer}', "");
    Expect(1, 6144, '\p{^Is_Blk: khmer}', "");
    Expect(1, 6144, '\P{Is_Blk: khmer}', "");
    Expect(0, 6144, '\P{^Is_Blk: khmer}', "");
    Expect(1, 6143, '\p{Is_Blk=	 KHMER}', "");
    Expect(0, 6143, '\p{^Is_Blk=	 KHMER}', "");
    Expect(0, 6143, '\P{Is_Blk=	 KHMER}', "");
    Expect(1, 6143, '\P{^Is_Blk=	 KHMER}', "");
    Expect(0, 6144, '\p{Is_Blk=	 KHMER}', "");
    Expect(1, 6144, '\p{^Is_Blk=	 KHMER}', "");
    Expect(1, 6144, '\P{Is_Blk=	 KHMER}', "");
    Expect(0, 6144, '\P{^Is_Blk=	 KHMER}', "");
    Error('\p{Block=-:=khmer_Symbols}');
    Error('\P{Block=-:=khmer_Symbols}');
    Expect(1, 6655, '\p{Block=:\AKhmer_Symbols\z:}', "");;
    Expect(0, 6656, '\p{Block=:\AKhmer_Symbols\z:}', "");;
    Expect(1, 6655, '\p{Block:	khmersymbols}', "");
    Expect(0, 6655, '\p{^Block:	khmersymbols}', "");
    Expect(0, 6655, '\P{Block:	khmersymbols}', "");
    Expect(1, 6655, '\P{^Block:	khmersymbols}', "");
    Expect(0, 6656, '\p{Block:	khmersymbols}', "");
    Expect(1, 6656, '\p{^Block:	khmersymbols}', "");
    Expect(1, 6656, '\P{Block:	khmersymbols}', "");
    Expect(0, 6656, '\P{^Block:	khmersymbols}', "");
    Expect(1, 6655, '\p{Block=:\Akhmersymbols\z:}', "");;
    Expect(0, 6656, '\p{Block=:\Akhmersymbols\z:}', "");;
    Expect(1, 6655, '\p{Block=Khmer_SYMBOLS}', "");
    Expect(0, 6655, '\p{^Block=Khmer_SYMBOLS}', "");
    Expect(0, 6655, '\P{Block=Khmer_SYMBOLS}', "");
    Expect(1, 6655, '\P{^Block=Khmer_SYMBOLS}', "");
    Expect(0, 6656, '\p{Block=Khmer_SYMBOLS}', "");
    Expect(1, 6656, '\p{^Block=Khmer_SYMBOLS}', "");
    Expect(1, 6656, '\P{Block=Khmer_SYMBOLS}', "");
    Expect(0, 6656, '\P{^Block=Khmer_SYMBOLS}', "");
    Error('\p{Blk=:=--KHMER_Symbols}');
    Error('\P{Blk=:=--KHMER_Symbols}');
    Expect(1, 6655, '\p{Blk=:\AKhmer_Symbols\z:}', "");;
    Expect(0, 6656, '\p{Blk=:\AKhmer_Symbols\z:}', "");;
    Expect(1, 6655, '\p{Blk=khmersymbols}', "");
    Expect(0, 6655, '\p{^Blk=khmersymbols}', "");
    Expect(0, 6655, '\P{Blk=khmersymbols}', "");
    Expect(1, 6655, '\P{^Blk=khmersymbols}', "");
    Expect(0, 6656, '\p{Blk=khmersymbols}', "");
    Expect(1, 6656, '\p{^Blk=khmersymbols}', "");
    Expect(1, 6656, '\P{Blk=khmersymbols}', "");
    Expect(0, 6656, '\P{^Blk=khmersymbols}', "");
    Expect(1, 6655, '\p{Blk=:\Akhmersymbols\z:}', "");;
    Expect(0, 6656, '\p{Blk=:\Akhmersymbols\z:}', "");;
    Expect(1, 6655, '\p{Blk=_khmer_symbols}', "");
    Expect(0, 6655, '\p{^Blk=_khmer_symbols}', "");
    Expect(0, 6655, '\P{Blk=_khmer_symbols}', "");
    Expect(1, 6655, '\P{^Blk=_khmer_symbols}', "");
    Expect(0, 6656, '\p{Blk=_khmer_symbols}', "");
    Expect(1, 6656, '\p{^Blk=_khmer_symbols}', "");
    Expect(1, 6656, '\P{Blk=_khmer_symbols}', "");
    Expect(0, 6656, '\P{^Blk=_khmer_symbols}', "");
    Error('\p{Is_Block=/a/_ KHMER_Symbols}');
    Error('\P{Is_Block=/a/_ KHMER_Symbols}');
    Expect(1, 6655, '\p{Is_Block=khmersymbols}', "");
    Expect(0, 6655, '\p{^Is_Block=khmersymbols}', "");
    Expect(0, 6655, '\P{Is_Block=khmersymbols}', "");
    Expect(1, 6655, '\P{^Is_Block=khmersymbols}', "");
    Expect(0, 6656, '\p{Is_Block=khmersymbols}', "");
    Expect(1, 6656, '\p{^Is_Block=khmersymbols}', "");
    Expect(1, 6656, '\P{Is_Block=khmersymbols}', "");
    Expect(0, 6656, '\P{^Is_Block=khmersymbols}', "");
    Expect(1, 6655, '\p{Is_Block=-khmer_Symbols}', "");
    Expect(0, 6655, '\p{^Is_Block=-khmer_Symbols}', "");
    Expect(0, 6655, '\P{Is_Block=-khmer_Symbols}', "");
    Expect(1, 6655, '\P{^Is_Block=-khmer_Symbols}', "");
    Expect(0, 6656, '\p{Is_Block=-khmer_Symbols}', "");
    Expect(1, 6656, '\p{^Is_Block=-khmer_Symbols}', "");
    Expect(1, 6656, '\P{Is_Block=-khmer_Symbols}', "");
    Expect(0, 6656, '\P{^Is_Block=-khmer_Symbols}', "");
    Error('\p{Is_Blk:-_Khmer_SYMBOLS/a/}');
    Error('\P{Is_Blk:-_Khmer_SYMBOLS/a/}');
    Expect(1, 6655, '\p{Is_Blk: khmersymbols}', "");
    Expect(0, 6655, '\p{^Is_Blk: khmersymbols}', "");
    Expect(0, 6655, '\P{Is_Blk: khmersymbols}', "");
    Expect(1, 6655, '\P{^Is_Blk: khmersymbols}', "");
    Expect(0, 6656, '\p{Is_Blk: khmersymbols}', "");
    Expect(1, 6656, '\p{^Is_Blk: khmersymbols}', "");
    Expect(1, 6656, '\P{Is_Blk: khmersymbols}', "");
    Expect(0, 6656, '\P{^Is_Blk: khmersymbols}', "");
    Expect(1, 6655, '\p{Is_Blk=-khmer_Symbols}', "");
    Expect(0, 6655, '\p{^Is_Blk=-khmer_Symbols}', "");
    Expect(0, 6655, '\P{Is_Blk=-khmer_Symbols}', "");
    Expect(1, 6655, '\P{^Is_Blk=-khmer_Symbols}', "");
    Expect(0, 6656, '\p{Is_Blk=-khmer_Symbols}', "");
    Expect(1, 6656, '\p{^Is_Blk=-khmer_Symbols}', "");
    Expect(1, 6656, '\P{Is_Blk=-khmer_Symbols}', "");
    Expect(0, 6656, '\P{^Is_Blk=-khmer_Symbols}', "");
    Error('\p{Block=-khojki:=}');
    Error('\P{Block=-khojki:=}');
    Expect(1, 70223, '\p{Block=:\AKhojki\z:}', "");;
    Expect(0, 70224, '\p{Block=:\AKhojki\z:}', "");;
    Expect(1, 70223, '\p{Block=khojki}', "");
    Expect(0, 70223, '\p{^Block=khojki}', "");
    Expect(0, 70223, '\P{Block=khojki}', "");
    Expect(1, 70223, '\P{^Block=khojki}', "");
    Expect(0, 70224, '\p{Block=khojki}', "");
    Expect(1, 70224, '\p{^Block=khojki}', "");
    Expect(1, 70224, '\P{Block=khojki}', "");
    Expect(0, 70224, '\P{^Block=khojki}', "");
    Expect(1, 70223, '\p{Block=:\Akhojki\z:}', "");;
    Expect(0, 70224, '\p{Block=:\Akhojki\z:}', "");;
    Expect(1, 70223, '\p{Block=-	KHOJKI}', "");
    Expect(0, 70223, '\p{^Block=-	KHOJKI}', "");
    Expect(0, 70223, '\P{Block=-	KHOJKI}', "");
    Expect(1, 70223, '\P{^Block=-	KHOJKI}', "");
    Expect(0, 70224, '\p{Block=-	KHOJKI}', "");
    Expect(1, 70224, '\p{^Block=-	KHOJKI}', "");
    Expect(1, 70224, '\P{Block=-	KHOJKI}', "");
    Expect(0, 70224, '\P{^Block=-	KHOJKI}', "");
    Error('\p{Blk=Khojki/a/}');
    Error('\P{Blk=Khojki/a/}');
    Expect(1, 70223, '\p{Blk=:\AKhojki\z:}', "");;
    Expect(0, 70224, '\p{Blk=:\AKhojki\z:}', "");;
    Expect(1, 70223, '\p{Blk=khojki}', "");
    Expect(0, 70223, '\p{^Blk=khojki}', "");
    Expect(0, 70223, '\P{Blk=khojki}', "");
    Expect(1, 70223, '\P{^Blk=khojki}', "");
    Expect(0, 70224, '\p{Blk=khojki}', "");
    Expect(1, 70224, '\p{^Blk=khojki}', "");
    Expect(1, 70224, '\P{Blk=khojki}', "");
    Expect(0, 70224, '\P{^Blk=khojki}', "");
    Expect(1, 70223, '\p{Blk=:\Akhojki\z:}', "");;
    Expect(0, 70224, '\p{Blk=:\Akhojki\z:}', "");;
    Expect(1, 70223, '\p{Blk:			Khojki}', "");
    Expect(0, 70223, '\p{^Blk:			Khojki}', "");
    Expect(0, 70223, '\P{Blk:			Khojki}', "");
    Expect(1, 70223, '\P{^Blk:			Khojki}', "");
    Expect(0, 70224, '\p{Blk:			Khojki}', "");
    Expect(1, 70224, '\p{^Blk:			Khojki}', "");
    Expect(1, 70224, '\P{Blk:			Khojki}', "");
    Expect(0, 70224, '\P{^Blk:			Khojki}', "");
    Error('\p{Is_Block=	:=KHOJKI}');
    Error('\P{Is_Block=	:=KHOJKI}');
    Expect(1, 70223, '\p{Is_Block:khojki}', "");
    Expect(0, 70223, '\p{^Is_Block:khojki}', "");
    Expect(0, 70223, '\P{Is_Block:khojki}', "");
    Expect(1, 70223, '\P{^Is_Block:khojki}', "");
    Expect(0, 70224, '\p{Is_Block:khojki}', "");
    Expect(1, 70224, '\p{^Is_Block:khojki}', "");
    Expect(1, 70224, '\P{Is_Block:khojki}', "");
    Expect(0, 70224, '\P{^Is_Block:khojki}', "");
    Expect(1, 70223, '\p{Is_Block=- khojki}', "");
    Expect(0, 70223, '\p{^Is_Block=- khojki}', "");
    Expect(0, 70223, '\P{Is_Block=- khojki}', "");
    Expect(1, 70223, '\P{^Is_Block=- khojki}', "");
    Expect(0, 70224, '\p{Is_Block=- khojki}', "");
    Expect(1, 70224, '\p{^Is_Block=- khojki}', "");
    Expect(1, 70224, '\P{Is_Block=- khojki}', "");
    Expect(0, 70224, '\P{^Is_Block=- khojki}', "");
    Error('\p{Is_Blk:	/a/Khojki}');
    Error('\P{Is_Blk:	/a/Khojki}');
    Expect(1, 70223, '\p{Is_Blk=khojki}', "");
    Expect(0, 70223, '\p{^Is_Blk=khojki}', "");
    Expect(0, 70223, '\P{Is_Blk=khojki}', "");
    Expect(1, 70223, '\P{^Is_Blk=khojki}', "");
    Expect(0, 70224, '\p{Is_Blk=khojki}', "");
    Expect(1, 70224, '\p{^Is_Blk=khojki}', "");
    Expect(1, 70224, '\P{Is_Blk=khojki}', "");
    Expect(0, 70224, '\P{^Is_Blk=khojki}', "");
    Expect(1, 70223, '\p{Is_Blk=		khojki}', "");
    Expect(0, 70223, '\p{^Is_Blk=		khojki}', "");
    Expect(0, 70223, '\P{Is_Blk=		khojki}', "");
    Expect(1, 70223, '\P{^Is_Blk=		khojki}', "");
    Expect(0, 70224, '\p{Is_Blk=		khojki}', "");
    Expect(1, 70224, '\p{^Is_Blk=		khojki}', "");
    Expect(1, 70224, '\P{Is_Blk=		khojki}', "");
    Expect(0, 70224, '\P{^Is_Blk=		khojki}', "");
    Error('\p{Block=:=_ Khudawadi}');
    Error('\P{Block=:=_ Khudawadi}');
    Expect(1, 70399, '\p{Block=:\AKhudawadi\z:}', "");;
    Expect(0, 70400, '\p{Block=:\AKhudawadi\z:}', "");;
    Expect(1, 70399, '\p{Block:khudawadi}', "");
    Expect(0, 70399, '\p{^Block:khudawadi}', "");
    Expect(0, 70399, '\P{Block:khudawadi}', "");
    Expect(1, 70399, '\P{^Block:khudawadi}', "");
    Expect(0, 70400, '\p{Block:khudawadi}', "");
    Expect(1, 70400, '\p{^Block:khudawadi}', "");
    Expect(1, 70400, '\P{Block:khudawadi}', "");
    Expect(0, 70400, '\P{^Block:khudawadi}', "");
    Expect(1, 70399, '\p{Block=:\Akhudawadi\z:}', "");;
    Expect(0, 70400, '\p{Block=:\Akhudawadi\z:}', "");;
    Expect(1, 70399, '\p{Block=_khudawadi}', "");
    Expect(0, 70399, '\p{^Block=_khudawadi}', "");
    Expect(0, 70399, '\P{Block=_khudawadi}', "");
    Expect(1, 70399, '\P{^Block=_khudawadi}', "");
    Expect(0, 70400, '\p{Block=_khudawadi}', "");
    Expect(1, 70400, '\p{^Block=_khudawadi}', "");
    Expect(1, 70400, '\P{Block=_khudawadi}', "");
    Expect(0, 70400, '\P{^Block=_khudawadi}', "");
    Error('\p{Blk:	/a/	Khudawadi}');
    Error('\P{Blk:	/a/	Khudawadi}');
    Expect(1, 70399, '\p{Blk=:\AKhudawadi\z:}', "");;
    Expect(0, 70400, '\p{Blk=:\AKhudawadi\z:}', "");;
    Expect(1, 70399, '\p{Blk=khudawadi}', "");
    Expect(0, 70399, '\p{^Blk=khudawadi}', "");
    Expect(0, 70399, '\P{Blk=khudawadi}', "");
    Expect(1, 70399, '\P{^Blk=khudawadi}', "");
    Expect(0, 70400, '\p{Blk=khudawadi}', "");
    Expect(1, 70400, '\p{^Blk=khudawadi}', "");
    Expect(1, 70400, '\P{Blk=khudawadi}', "");
    Expect(0, 70400, '\P{^Blk=khudawadi}', "");
    Expect(1, 70399, '\p{Blk=:\Akhudawadi\z:}', "");;
    Expect(0, 70400, '\p{Blk=:\Akhudawadi\z:}', "");;
    Expect(1, 70399, '\p{Blk:   _-KHUDAWADI}', "");
    Expect(0, 70399, '\p{^Blk:   _-KHUDAWADI}', "");
    Expect(0, 70399, '\P{Blk:   _-KHUDAWADI}', "");
    Expect(1, 70399, '\P{^Blk:   _-KHUDAWADI}', "");
    Expect(0, 70400, '\p{Blk:   _-KHUDAWADI}', "");
    Expect(1, 70400, '\p{^Blk:   _-KHUDAWADI}', "");
    Expect(1, 70400, '\P{Blk:   _-KHUDAWADI}', "");
    Expect(0, 70400, '\P{^Blk:   _-KHUDAWADI}', "");
    Error('\p{Is_Block=:=_KHUDAWADI}');
    Error('\P{Is_Block=:=_KHUDAWADI}');
    Expect(1, 70399, '\p{Is_Block=khudawadi}', "");
    Expect(0, 70399, '\p{^Is_Block=khudawadi}', "");
    Expect(0, 70399, '\P{Is_Block=khudawadi}', "");
    Expect(1, 70399, '\P{^Is_Block=khudawadi}', "");
    Expect(0, 70400, '\p{Is_Block=khudawadi}', "");
    Expect(1, 70400, '\p{^Is_Block=khudawadi}', "");
    Expect(1, 70400, '\P{Is_Block=khudawadi}', "");
    Expect(0, 70400, '\P{^Is_Block=khudawadi}', "");
    Expect(1, 70399, '\p{Is_Block= KHUDAWADI}', "");
    Expect(0, 70399, '\p{^Is_Block= KHUDAWADI}', "");
    Expect(0, 70399, '\P{Is_Block= KHUDAWADI}', "");
    Expect(1, 70399, '\P{^Is_Block= KHUDAWADI}', "");
    Expect(0, 70400, '\p{Is_Block= KHUDAWADI}', "");
    Expect(1, 70400, '\p{^Is_Block= KHUDAWADI}', "");
    Expect(1, 70400, '\P{Is_Block= KHUDAWADI}', "");
    Expect(0, 70400, '\P{^Is_Block= KHUDAWADI}', "");
    Error('\p{Is_Blk::=--Khudawadi}');
    Error('\P{Is_Blk::=--Khudawadi}');
    Expect(1, 70399, '\p{Is_Blk=khudawadi}', "");
    Expect(0, 70399, '\p{^Is_Blk=khudawadi}', "");
    Expect(0, 70399, '\P{Is_Blk=khudawadi}', "");
    Expect(1, 70399, '\P{^Is_Blk=khudawadi}', "");
    Expect(0, 70400, '\p{Is_Blk=khudawadi}', "");
    Expect(1, 70400, '\p{^Is_Blk=khudawadi}', "");
    Expect(1, 70400, '\P{Is_Blk=khudawadi}', "");
    Expect(0, 70400, '\P{^Is_Blk=khudawadi}', "");
    Expect(1, 70399, '\p{Is_Blk= -Khudawadi}', "");
    Expect(0, 70399, '\p{^Is_Blk= -Khudawadi}', "");
    Expect(0, 70399, '\P{Is_Blk= -Khudawadi}', "");
    Expect(1, 70399, '\P{^Is_Blk= -Khudawadi}', "");
    Expect(0, 70400, '\p{Is_Blk= -Khudawadi}', "");
    Expect(1, 70400, '\p{^Is_Blk= -Khudawadi}', "");
    Expect(1, 70400, '\P{Is_Blk= -Khudawadi}', "");
    Expect(0, 70400, '\P{^Is_Blk= -Khudawadi}', "");
    Error('\p{Block=		Lao/a/}');
    Error('\P{Block=		Lao/a/}');
    Expect(1, 3839, '\p{Block=:\ALao\z:}', "");;
    Expect(0, 3840, '\p{Block=:\ALao\z:}', "");;
    Expect(1, 3839, '\p{Block=lao}', "");
    Expect(0, 3839, '\p{^Block=lao}', "");
    Expect(0, 3839, '\P{Block=lao}', "");
    Expect(1, 3839, '\P{^Block=lao}', "");
    Expect(0, 3840, '\p{Block=lao}', "");
    Expect(1, 3840, '\p{^Block=lao}', "");
    Expect(1, 3840, '\P{Block=lao}', "");
    Expect(0, 3840, '\P{^Block=lao}', "");
    Expect(1, 3839, '\p{Block=:\Alao\z:}', "");;
    Expect(0, 3840, '\p{Block=:\Alao\z:}', "");;
    Expect(1, 3839, '\p{Block:	-Lao}', "");
    Expect(0, 3839, '\p{^Block:	-Lao}', "");
    Expect(0, 3839, '\P{Block:	-Lao}', "");
    Expect(1, 3839, '\P{^Block:	-Lao}', "");
    Expect(0, 3840, '\p{Block:	-Lao}', "");
    Expect(1, 3840, '\p{^Block:	-Lao}', "");
    Expect(1, 3840, '\P{Block:	-Lao}', "");
    Expect(0, 3840, '\P{^Block:	-Lao}', "");
    Error('\p{Blk=/a/_-Lao}');
    Error('\P{Blk=/a/_-Lao}');
    Expect(1, 3839, '\p{Blk=:\ALao\z:}', "");;
    Expect(0, 3840, '\p{Blk=:\ALao\z:}', "");;
    Expect(1, 3839, '\p{Blk:lao}', "");
    Expect(0, 3839, '\p{^Blk:lao}', "");
    Expect(0, 3839, '\P{Blk:lao}', "");
    Expect(1, 3839, '\P{^Blk:lao}', "");
    Expect(0, 3840, '\p{Blk:lao}', "");
    Expect(1, 3840, '\p{^Blk:lao}', "");
    Expect(1, 3840, '\P{Blk:lao}', "");
    Expect(0, 3840, '\P{^Blk:lao}', "");
    Expect(1, 3839, '\p{Blk=:\Alao\z:}', "");;
    Expect(0, 3840, '\p{Blk=:\Alao\z:}', "");;
    Expect(1, 3839, '\p{Blk=--lao}', "");
    Expect(0, 3839, '\p{^Blk=--lao}', "");
    Expect(0, 3839, '\P{Blk=--lao}', "");
    Expect(1, 3839, '\P{^Blk=--lao}', "");
    Expect(0, 3840, '\p{Blk=--lao}', "");
    Expect(1, 3840, '\p{^Blk=--lao}', "");
    Expect(1, 3840, '\P{Blk=--lao}', "");
    Expect(0, 3840, '\P{^Blk=--lao}', "");
    Error('\p{Is_Block=/a/lao}');
    Error('\P{Is_Block=/a/lao}');
    Expect(1, 3839, '\p{Is_Block=lao}', "");
    Expect(0, 3839, '\p{^Is_Block=lao}', "");
    Expect(0, 3839, '\P{Is_Block=lao}', "");
    Expect(1, 3839, '\P{^Is_Block=lao}', "");
    Expect(0, 3840, '\p{Is_Block=lao}', "");
    Expect(1, 3840, '\p{^Is_Block=lao}', "");
    Expect(1, 3840, '\P{Is_Block=lao}', "");
    Expect(0, 3840, '\P{^Is_Block=lao}', "");
    Expect(1, 3839, '\p{Is_Block= -Lao}', "");
    Expect(0, 3839, '\p{^Is_Block= -Lao}', "");
    Expect(0, 3839, '\P{Is_Block= -Lao}', "");
    Expect(1, 3839, '\P{^Is_Block= -Lao}', "");
    Expect(0, 3840, '\p{Is_Block= -Lao}', "");
    Expect(1, 3840, '\p{^Is_Block= -Lao}', "");
    Expect(1, 3840, '\P{Is_Block= -Lao}', "");
    Expect(0, 3840, '\P{^Is_Block= -Lao}', "");
    Error('\p{Is_Blk=_Lao:=}');
    Error('\P{Is_Blk=_Lao:=}');
    Expect(1, 3839, '\p{Is_Blk=lao}', "");
    Expect(0, 3839, '\p{^Is_Blk=lao}', "");
    Expect(0, 3839, '\P{Is_Blk=lao}', "");
    Expect(1, 3839, '\P{^Is_Blk=lao}', "");
    Expect(0, 3840, '\p{Is_Blk=lao}', "");
    Expect(1, 3840, '\p{^Is_Blk=lao}', "");
    Expect(1, 3840, '\P{Is_Blk=lao}', "");
    Expect(0, 3840, '\P{^Is_Blk=lao}', "");
    Expect(1, 3839, '\p{Is_Blk=-	lao}', "");
    Expect(0, 3839, '\p{^Is_Blk=-	lao}', "");
    Expect(0, 3839, '\P{Is_Blk=-	lao}', "");
    Expect(1, 3839, '\P{^Is_Blk=-	lao}', "");
    Expect(0, 3840, '\p{Is_Blk=-	lao}', "");
    Expect(1, 3840, '\p{^Is_Blk=-	lao}', "");
    Expect(1, 3840, '\P{Is_Blk=-	lao}', "");
    Expect(0, 3840, '\P{^Is_Blk=-	lao}', "");
    Error('\p{Block=  LATIN_1_supplement/a/}');
    Error('\P{Block=  LATIN_1_supplement/a/}');
    Expect(1, 255, '\p{Block=:\ALatin_1_Supplement\z:}', "");;
    Expect(0, 256, '\p{Block=:\ALatin_1_Supplement\z:}', "");;
    Expect(1, 255, '\p{Block=latin1supplement}', "");
    Expect(0, 255, '\p{^Block=latin1supplement}', "");
    Expect(0, 255, '\P{Block=latin1supplement}', "");
    Expect(1, 255, '\P{^Block=latin1supplement}', "");
    Expect(0, 256, '\p{Block=latin1supplement}', "");
    Expect(1, 256, '\p{^Block=latin1supplement}', "");
    Expect(1, 256, '\P{Block=latin1supplement}', "");
    Expect(0, 256, '\P{^Block=latin1supplement}', "");
    Expect(1, 255, '\p{Block=:\Alatin1supplement\z:}', "");;
    Expect(0, 256, '\p{Block=:\Alatin1supplement\z:}', "");;
    Expect(1, 255, '\p{Block=	LATIN_1_Supplement}', "");
    Expect(0, 255, '\p{^Block=	LATIN_1_Supplement}', "");
    Expect(0, 255, '\P{Block=	LATIN_1_Supplement}', "");
    Expect(1, 255, '\P{^Block=	LATIN_1_Supplement}', "");
    Expect(0, 256, '\p{Block=	LATIN_1_Supplement}', "");
    Expect(1, 256, '\p{^Block=	LATIN_1_Supplement}', "");
    Expect(1, 256, '\P{Block=	LATIN_1_Supplement}', "");
    Expect(0, 256, '\P{^Block=	LATIN_1_Supplement}', "");
    Error('\p{Blk=	Latin_1_SUP/a/}');
    Error('\P{Blk=	Latin_1_SUP/a/}');
    Expect(1, 255, '\p{Blk=:\ALatin_1_Sup\z:}', "");;
    Expect(0, 256, '\p{Blk=:\ALatin_1_Sup\z:}', "");;
    Expect(1, 255, '\p{Blk=latin1sup}', "");
    Expect(0, 255, '\p{^Blk=latin1sup}', "");
    Expect(0, 255, '\P{Blk=latin1sup}', "");
    Expect(1, 255, '\P{^Blk=latin1sup}', "");
    Expect(0, 256, '\p{Blk=latin1sup}', "");
    Expect(1, 256, '\p{^Blk=latin1sup}', "");
    Expect(1, 256, '\P{Blk=latin1sup}', "");
    Expect(0, 256, '\P{^Blk=latin1sup}', "");
    Expect(1, 255, '\p{Blk=:\Alatin1sup\z:}', "");;
    Expect(0, 256, '\p{Blk=:\Alatin1sup\z:}', "");;
    Expect(1, 255, '\p{Blk=	_latin_1_Sup}', "");
    Expect(0, 255, '\p{^Blk=	_latin_1_Sup}', "");
    Expect(0, 255, '\P{Blk=	_latin_1_Sup}', "");
    Expect(1, 255, '\P{^Blk=	_latin_1_Sup}', "");
    Expect(0, 256, '\p{Blk=	_latin_1_Sup}', "");
    Expect(1, 256, '\p{^Blk=	_latin_1_Sup}', "");
    Expect(1, 256, '\P{Blk=	_latin_1_Sup}', "");
    Expect(0, 256, '\P{^Blk=	_latin_1_Sup}', "");
    Error('\p{Is_Block=_latin_1/a/}');
    Error('\P{Is_Block=_latin_1/a/}');
    Expect(1, 255, '\p{Is_Block=latin1}', "");
    Expect(0, 255, '\p{^Is_Block=latin1}', "");
    Expect(0, 255, '\P{Is_Block=latin1}', "");
    Expect(1, 255, '\P{^Is_Block=latin1}', "");
    Expect(0, 256, '\p{Is_Block=latin1}', "");
    Expect(1, 256, '\p{^Is_Block=latin1}', "");
    Expect(1, 256, '\P{Is_Block=latin1}', "");
    Expect(0, 256, '\P{^Is_Block=latin1}', "");
    Expect(1, 255, '\p{Is_Block=	_Latin_1}', "");
    Expect(0, 255, '\p{^Is_Block=	_Latin_1}', "");
    Expect(0, 255, '\P{Is_Block=	_Latin_1}', "");
    Expect(1, 255, '\P{^Is_Block=	_Latin_1}', "");
    Expect(0, 256, '\p{Is_Block=	_Latin_1}', "");
    Expect(1, 256, '\p{^Is_Block=	_Latin_1}', "");
    Expect(1, 256, '\P{Is_Block=	_Latin_1}', "");
    Expect(0, 256, '\P{^Is_Block=	_Latin_1}', "");
    Error('\p{Is_Blk=/a/LATIN_1_Supplement}');
    Error('\P{Is_Blk=/a/LATIN_1_Supplement}');
    Expect(1, 255, '\p{Is_Blk=latin1supplement}', "");
    Expect(0, 255, '\p{^Is_Blk=latin1supplement}', "");
    Expect(0, 255, '\P{Is_Blk=latin1supplement}', "");
    Expect(1, 255, '\P{^Is_Blk=latin1supplement}', "");
    Expect(0, 256, '\p{Is_Blk=latin1supplement}', "");
    Expect(1, 256, '\p{^Is_Blk=latin1supplement}', "");
    Expect(1, 256, '\P{Is_Blk=latin1supplement}', "");
    Expect(0, 256, '\P{^Is_Blk=latin1supplement}', "");
    Expect(1, 255, '\p{Is_Blk=_ LATIN_1_supplement}', "");
    Expect(0, 255, '\p{^Is_Blk=_ LATIN_1_supplement}', "");
    Expect(0, 255, '\P{Is_Blk=_ LATIN_1_supplement}', "");
    Expect(1, 255, '\P{^Is_Blk=_ LATIN_1_supplement}', "");
    Expect(0, 256, '\p{Is_Blk=_ LATIN_1_supplement}', "");
    Expect(1, 256, '\p{^Is_Blk=_ LATIN_1_supplement}', "");
    Expect(1, 256, '\P{Is_Blk=_ LATIN_1_supplement}', "");
    Expect(0, 256, '\P{^Is_Blk=_ LATIN_1_supplement}', "");
    Error('\p{Block=latin_Extended_A/a/}');
    Error('\P{Block=latin_Extended_A/a/}');
    Expect(1, 383, '\p{Block=:\ALatin_Extended_A\z:}', "");;
    Expect(0, 384, '\p{Block=:\ALatin_Extended_A\z:}', "");;
    Expect(1, 383, '\p{Block=latinextendeda}', "");
    Expect(0, 383, '\p{^Block=latinextendeda}', "");
    Expect(0, 383, '\P{Block=latinextendeda}', "");
    Expect(1, 383, '\P{^Block=latinextendeda}', "");
    Expect(0, 384, '\p{Block=latinextendeda}', "");
    Expect(1, 384, '\p{^Block=latinextendeda}', "");
    Expect(1, 384, '\P{Block=latinextendeda}', "");
    Expect(0, 384, '\P{^Block=latinextendeda}', "");
    Expect(1, 383, '\p{Block=:\Alatinextendeda\z:}', "");;
    Expect(0, 384, '\p{Block=:\Alatinextendeda\z:}', "");;
    Expect(1, 383, '\p{Block=	Latin_EXTENDED_A}', "");
    Expect(0, 383, '\p{^Block=	Latin_EXTENDED_A}', "");
    Expect(0, 383, '\P{Block=	Latin_EXTENDED_A}', "");
    Expect(1, 383, '\P{^Block=	Latin_EXTENDED_A}', "");
    Expect(0, 384, '\p{Block=	Latin_EXTENDED_A}', "");
    Expect(1, 384, '\p{^Block=	Latin_EXTENDED_A}', "");
    Expect(1, 384, '\P{Block=	Latin_EXTENDED_A}', "");
    Expect(0, 384, '\P{^Block=	Latin_EXTENDED_A}', "");
    Error('\p{Blk=:=LATIN_ext_a}');
    Error('\P{Blk=:=LATIN_ext_a}');
    Expect(1, 383, '\p{Blk=:\ALatin_Ext_A\z:}', "");;
    Expect(0, 384, '\p{Blk=:\ALatin_Ext_A\z:}', "");;
    Expect(1, 383, '\p{Blk=latinexta}', "");
    Expect(0, 383, '\p{^Blk=latinexta}', "");
    Expect(0, 383, '\P{Blk=latinexta}', "");
    Expect(1, 383, '\P{^Blk=latinexta}', "");
    Expect(0, 384, '\p{Blk=latinexta}', "");
    Expect(1, 384, '\p{^Blk=latinexta}', "");
    Expect(1, 384, '\P{Blk=latinexta}', "");
    Expect(0, 384, '\P{^Blk=latinexta}', "");
    Expect(1, 383, '\p{Blk=:\Alatinexta\z:}', "");;
    Expect(0, 384, '\p{Blk=:\Alatinexta\z:}', "");;
    Expect(1, 383, '\p{Blk=_-Latin_Ext_A}', "");
    Expect(0, 383, '\p{^Blk=_-Latin_Ext_A}', "");
    Expect(0, 383, '\P{Blk=_-Latin_Ext_A}', "");
    Expect(1, 383, '\P{^Blk=_-Latin_Ext_A}', "");
    Expect(0, 384, '\p{Blk=_-Latin_Ext_A}', "");
    Expect(1, 384, '\p{^Blk=_-Latin_Ext_A}', "");
    Expect(1, 384, '\P{Blk=_-Latin_Ext_A}', "");
    Expect(0, 384, '\P{^Blk=_-Latin_Ext_A}', "");
    Error('\p{Is_Block=	:=Latin_extended_A}');
    Error('\P{Is_Block=	:=Latin_extended_A}');
    Expect(1, 383, '\p{Is_Block=latinextendeda}', "");
    Expect(0, 383, '\p{^Is_Block=latinextendeda}', "");
    Expect(0, 383, '\P{Is_Block=latinextendeda}', "");
    Expect(1, 383, '\P{^Is_Block=latinextendeda}', "");
    Expect(0, 384, '\p{Is_Block=latinextendeda}', "");
    Expect(1, 384, '\p{^Is_Block=latinextendeda}', "");
    Expect(1, 384, '\P{Is_Block=latinextendeda}', "");
    Expect(0, 384, '\P{^Is_Block=latinextendeda}', "");
    Expect(1, 383, '\p{Is_Block= _LATIN_Extended_A}', "");
    Expect(0, 383, '\p{^Is_Block= _LATIN_Extended_A}', "");
    Expect(0, 383, '\P{Is_Block= _LATIN_Extended_A}', "");
    Expect(1, 383, '\P{^Is_Block= _LATIN_Extended_A}', "");
    Expect(0, 384, '\p{Is_Block= _LATIN_Extended_A}', "");
    Expect(1, 384, '\p{^Is_Block= _LATIN_Extended_A}', "");
    Expect(1, 384, '\P{Is_Block= _LATIN_Extended_A}', "");
    Expect(0, 384, '\P{^Is_Block= _LATIN_Extended_A}', "");
    Error('\p{Is_Blk=/a/ LATIN_EXT_A}');
    Error('\P{Is_Blk=/a/ LATIN_EXT_A}');
    Expect(1, 383, '\p{Is_Blk=latinexta}', "");
    Expect(0, 383, '\p{^Is_Blk=latinexta}', "");
    Expect(0, 383, '\P{Is_Blk=latinexta}', "");
    Expect(1, 383, '\P{^Is_Blk=latinexta}', "");
    Expect(0, 384, '\p{Is_Blk=latinexta}', "");
    Expect(1, 384, '\p{^Is_Blk=latinexta}', "");
    Expect(1, 384, '\P{Is_Blk=latinexta}', "");
    Expect(0, 384, '\P{^Is_Blk=latinexta}', "");
    Expect(1, 383, '\p{Is_Blk:    _Latin_EXT_A}', "");
    Expect(0, 383, '\p{^Is_Blk:    _Latin_EXT_A}', "");
    Expect(0, 383, '\P{Is_Blk:    _Latin_EXT_A}', "");
    Expect(1, 383, '\P{^Is_Blk:    _Latin_EXT_A}', "");
    Expect(0, 384, '\p{Is_Blk:    _Latin_EXT_A}', "");
    Expect(1, 384, '\p{^Is_Blk:    _Latin_EXT_A}', "");
    Expect(1, 384, '\P{Is_Blk:    _Latin_EXT_A}', "");
    Expect(0, 384, '\P{^Is_Blk:    _Latin_EXT_A}', "");
    Error('\p{Block= :=Latin_extended_Additional}');
    Error('\P{Block= :=Latin_extended_Additional}');
    Expect(1, 7935, '\p{Block=:\ALatin_Extended_Additional\z:}', "");;
    Expect(0, 7936, '\p{Block=:\ALatin_Extended_Additional\z:}', "");;
    Expect(1, 7935, '\p{Block=latinextendedadditional}', "");
    Expect(0, 7935, '\p{^Block=latinextendedadditional}', "");
    Expect(0, 7935, '\P{Block=latinextendedadditional}', "");
    Expect(1, 7935, '\P{^Block=latinextendedadditional}', "");
    Expect(0, 7936, '\p{Block=latinextendedadditional}', "");
    Expect(1, 7936, '\p{^Block=latinextendedadditional}', "");
    Expect(1, 7936, '\P{Block=latinextendedadditional}', "");
    Expect(0, 7936, '\P{^Block=latinextendedadditional}', "");
    Expect(1, 7935, '\p{Block=:\Alatinextendedadditional\z:}', "");;
    Expect(0, 7936, '\p{Block=:\Alatinextendedadditional\z:}', "");;
    Expect(1, 7935, '\p{Block=	Latin_extended_Additional}', "");
    Expect(0, 7935, '\p{^Block=	Latin_extended_Additional}', "");
    Expect(0, 7935, '\P{Block=	Latin_extended_Additional}', "");
    Expect(1, 7935, '\P{^Block=	Latin_extended_Additional}', "");
    Expect(0, 7936, '\p{Block=	Latin_extended_Additional}', "");
    Expect(1, 7936, '\p{^Block=	Latin_extended_Additional}', "");
    Expect(1, 7936, '\P{Block=	Latin_extended_Additional}', "");
    Expect(0, 7936, '\P{^Block=	Latin_extended_Additional}', "");
    Error('\p{Blk= :=Latin_ext_Additional}');
    Error('\P{Blk= :=Latin_ext_Additional}');
    Expect(1, 7935, '\p{Blk=:\ALatin_Ext_Additional\z:}', "");;
    Expect(0, 7936, '\p{Blk=:\ALatin_Ext_Additional\z:}', "");;
    Expect(1, 7935, '\p{Blk=latinextadditional}', "");
    Expect(0, 7935, '\p{^Blk=latinextadditional}', "");
    Expect(0, 7935, '\P{Blk=latinextadditional}', "");
    Expect(1, 7935, '\P{^Blk=latinextadditional}', "");
    Expect(0, 7936, '\p{Blk=latinextadditional}', "");
    Expect(1, 7936, '\p{^Blk=latinextadditional}', "");
    Expect(1, 7936, '\P{Blk=latinextadditional}', "");
    Expect(0, 7936, '\P{^Blk=latinextadditional}', "");
    Expect(1, 7935, '\p{Blk=:\Alatinextadditional\z:}', "");;
    Expect(0, 7936, '\p{Blk=:\Alatinextadditional\z:}', "");;
    Expect(1, 7935, '\p{Blk=_Latin_ext_ADDITIONAL}', "");
    Expect(0, 7935, '\p{^Blk=_Latin_ext_ADDITIONAL}', "");
    Expect(0, 7935, '\P{Blk=_Latin_ext_ADDITIONAL}', "");
    Expect(1, 7935, '\P{^Blk=_Latin_ext_ADDITIONAL}', "");
    Expect(0, 7936, '\p{Blk=_Latin_ext_ADDITIONAL}', "");
    Expect(1, 7936, '\p{^Blk=_Latin_ext_ADDITIONAL}', "");
    Expect(1, 7936, '\P{Blk=_Latin_ext_ADDITIONAL}', "");
    Expect(0, 7936, '\P{^Blk=_Latin_ext_ADDITIONAL}', "");
    Error('\p{Is_Block=/a/__Latin_extended_Additional}');
    Error('\P{Is_Block=/a/__Latin_extended_Additional}');
    Expect(1, 7935, '\p{Is_Block=latinextendedadditional}', "");
    Expect(0, 7935, '\p{^Is_Block=latinextendedadditional}', "");
    Expect(0, 7935, '\P{Is_Block=latinextendedadditional}', "");
    Expect(1, 7935, '\P{^Is_Block=latinextendedadditional}', "");
    Expect(0, 7936, '\p{Is_Block=latinextendedadditional}', "");
    Expect(1, 7936, '\p{^Is_Block=latinextendedadditional}', "");
    Expect(1, 7936, '\P{Is_Block=latinextendedadditional}', "");
    Expect(0, 7936, '\P{^Is_Block=latinextendedadditional}', "");
    Expect(1, 7935, '\p{Is_Block=--latin_extended_Additional}', "");
    Expect(0, 7935, '\p{^Is_Block=--latin_extended_Additional}', "");
    Expect(0, 7935, '\P{Is_Block=--latin_extended_Additional}', "");
    Expect(1, 7935, '\P{^Is_Block=--latin_extended_Additional}', "");
    Expect(0, 7936, '\p{Is_Block=--latin_extended_Additional}', "");
    Expect(1, 7936, '\p{^Is_Block=--latin_extended_Additional}', "");
    Expect(1, 7936, '\P{Is_Block=--latin_extended_Additional}', "");
    Expect(0, 7936, '\P{^Is_Block=--latin_extended_Additional}', "");
    Error('\p{Is_Blk=:=	_LATIN_EXT_additional}');
    Error('\P{Is_Blk=:=	_LATIN_EXT_additional}');
    Expect(1, 7935, '\p{Is_Blk: latinextadditional}', "");
    Expect(0, 7935, '\p{^Is_Blk: latinextadditional}', "");
    Expect(0, 7935, '\P{Is_Blk: latinextadditional}', "");
    Expect(1, 7935, '\P{^Is_Blk: latinextadditional}', "");
    Expect(0, 7936, '\p{Is_Blk: latinextadditional}', "");
    Expect(1, 7936, '\p{^Is_Blk: latinextadditional}', "");
    Expect(1, 7936, '\P{Is_Blk: latinextadditional}', "");
    Expect(0, 7936, '\P{^Is_Blk: latinextadditional}', "");
    Expect(1, 7935, '\p{Is_Blk=_ Latin_EXT_Additional}', "");
    Expect(0, 7935, '\p{^Is_Blk=_ Latin_EXT_Additional}', "");
    Expect(0, 7935, '\P{Is_Blk=_ Latin_EXT_Additional}', "");
    Expect(1, 7935, '\P{^Is_Blk=_ Latin_EXT_Additional}', "");
    Expect(0, 7936, '\p{Is_Blk=_ Latin_EXT_Additional}', "");
    Expect(1, 7936, '\p{^Is_Blk=_ Latin_EXT_Additional}', "");
    Expect(1, 7936, '\P{Is_Blk=_ Latin_EXT_Additional}', "");
    Expect(0, 7936, '\P{^Is_Blk=_ Latin_EXT_Additional}', "");
    Error('\p{Block= /a/LATIN_Extended_B}');
    Error('\P{Block= /a/LATIN_Extended_B}');
    Expect(1, 591, '\p{Block=:\ALatin_Extended_B\z:}', "");;
    Expect(0, 592, '\p{Block=:\ALatin_Extended_B\z:}', "");;
    Expect(1, 591, '\p{Block=latinextendedb}', "");
    Expect(0, 591, '\p{^Block=latinextendedb}', "");
    Expect(0, 591, '\P{Block=latinextendedb}', "");
    Expect(1, 591, '\P{^Block=latinextendedb}', "");
    Expect(0, 592, '\p{Block=latinextendedb}', "");
    Expect(1, 592, '\p{^Block=latinextendedb}', "");
    Expect(1, 592, '\P{Block=latinextendedb}', "");
    Expect(0, 592, '\P{^Block=latinextendedb}', "");
    Expect(1, 591, '\p{Block=:\Alatinextendedb\z:}', "");;
    Expect(0, 592, '\p{Block=:\Alatinextendedb\z:}', "");;
    Expect(1, 591, '\p{Block=_	Latin_Extended_b}', "");
    Expect(0, 591, '\p{^Block=_	Latin_Extended_b}', "");
    Expect(0, 591, '\P{Block=_	Latin_Extended_b}', "");
    Expect(1, 591, '\P{^Block=_	Latin_Extended_b}', "");
    Expect(0, 592, '\p{Block=_	Latin_Extended_b}', "");
    Expect(1, 592, '\p{^Block=_	Latin_Extended_b}', "");
    Expect(1, 592, '\P{Block=_	Latin_Extended_b}', "");
    Expect(0, 592, '\P{^Block=_	Latin_Extended_b}', "");
    Error('\p{Blk=-latin_Ext_B/a/}');
    Error('\P{Blk=-latin_Ext_B/a/}');
    Expect(1, 591, '\p{Blk=:\ALatin_Ext_B\z:}', "");;
    Expect(0, 592, '\p{Blk=:\ALatin_Ext_B\z:}', "");;
    Expect(1, 591, '\p{Blk=latinextb}', "");
    Expect(0, 591, '\p{^Blk=latinextb}', "");
    Expect(0, 591, '\P{Blk=latinextb}', "");
    Expect(1, 591, '\P{^Blk=latinextb}', "");
    Expect(0, 592, '\p{Blk=latinextb}', "");
    Expect(1, 592, '\p{^Blk=latinextb}', "");
    Expect(1, 592, '\P{Blk=latinextb}', "");
    Expect(0, 592, '\P{^Blk=latinextb}', "");
    Expect(1, 591, '\p{Blk=:\Alatinextb\z:}', "");;
    Expect(0, 592, '\p{Blk=:\Alatinextb\z:}', "");;
    Expect(1, 591, '\p{Blk= 	Latin_ext_b}', "");
    Expect(0, 591, '\p{^Blk= 	Latin_ext_b}', "");
    Expect(0, 591, '\P{Blk= 	Latin_ext_b}', "");
    Expect(1, 591, '\P{^Blk= 	Latin_ext_b}', "");
    Expect(0, 592, '\p{Blk= 	Latin_ext_b}', "");
    Expect(1, 592, '\p{^Blk= 	Latin_ext_b}', "");
    Expect(1, 592, '\P{Blk= 	Latin_ext_b}', "");
    Expect(0, 592, '\P{^Blk= 	Latin_ext_b}', "");
    Error('\p{Is_Block=	:=Latin_extended_B}');
    Error('\P{Is_Block=	:=Latin_extended_B}');
    Expect(1, 591, '\p{Is_Block=latinextendedb}', "");
    Expect(0, 591, '\p{^Is_Block=latinextendedb}', "");
    Expect(0, 591, '\P{Is_Block=latinextendedb}', "");
    Expect(1, 591, '\P{^Is_Block=latinextendedb}', "");
    Expect(0, 592, '\p{Is_Block=latinextendedb}', "");
    Expect(1, 592, '\p{^Is_Block=latinextendedb}', "");
    Expect(1, 592, '\P{Is_Block=latinextendedb}', "");
    Expect(0, 592, '\P{^Is_Block=latinextendedb}', "");
    Expect(1, 591, '\p{Is_Block=	-latin_Extended_B}', "");
    Expect(0, 591, '\p{^Is_Block=	-latin_Extended_B}', "");
    Expect(0, 591, '\P{Is_Block=	-latin_Extended_B}', "");
    Expect(1, 591, '\P{^Is_Block=	-latin_Extended_B}', "");
    Expect(0, 592, '\p{Is_Block=	-latin_Extended_B}', "");
    Expect(1, 592, '\p{^Is_Block=	-latin_Extended_B}', "");
    Expect(1, 592, '\P{Is_Block=	-latin_Extended_B}', "");
    Expect(0, 592, '\P{^Is_Block=	-latin_Extended_B}', "");
    Error('\p{Is_Blk=:=_ Latin_ext_B}');
    Error('\P{Is_Blk=:=_ Latin_ext_B}');
    Expect(1, 591, '\p{Is_Blk=latinextb}', "");
    Expect(0, 591, '\p{^Is_Blk=latinextb}', "");
    Expect(0, 591, '\P{Is_Blk=latinextb}', "");
    Expect(1, 591, '\P{^Is_Blk=latinextb}', "");
    Expect(0, 592, '\p{Is_Blk=latinextb}', "");
    Expect(1, 592, '\p{^Is_Blk=latinextb}', "");
    Expect(1, 592, '\P{Is_Blk=latinextb}', "");
    Expect(0, 592, '\P{^Is_Blk=latinextb}', "");
    Expect(1, 591, '\p{Is_Blk=--LATIN_ext_B}', "");
    Expect(0, 591, '\p{^Is_Blk=--LATIN_ext_B}', "");
    Expect(0, 591, '\P{Is_Blk=--LATIN_ext_B}', "");
    Expect(1, 591, '\P{^Is_Blk=--LATIN_ext_B}', "");
    Expect(0, 592, '\p{Is_Blk=--LATIN_ext_B}', "");
    Expect(1, 592, '\p{^Is_Blk=--LATIN_ext_B}', "");
    Expect(1, 592, '\P{Is_Blk=--LATIN_ext_B}', "");
    Expect(0, 592, '\P{^Is_Blk=--LATIN_ext_B}', "");
    Error('\p{Block=_/a/latin_Extended_C}');
    Error('\P{Block=_/a/latin_Extended_C}');
    Expect(1, 11391, '\p{Block=:\ALatin_Extended_C\z:}', "");;
    Expect(0, 11392, '\p{Block=:\ALatin_Extended_C\z:}', "");;
    Expect(1, 11391, '\p{Block:	latinextendedc}', "");
    Expect(0, 11391, '\p{^Block:	latinextendedc}', "");
    Expect(0, 11391, '\P{Block:	latinextendedc}', "");
    Expect(1, 11391, '\P{^Block:	latinextendedc}', "");
    Expect(0, 11392, '\p{Block:	latinextendedc}', "");
    Expect(1, 11392, '\p{^Block:	latinextendedc}', "");
    Expect(1, 11392, '\P{Block:	latinextendedc}', "");
    Expect(0, 11392, '\P{^Block:	latinextendedc}', "");
    Expect(1, 11391, '\p{Block=:\Alatinextendedc\z:}', "");;
    Expect(0, 11392, '\p{Block=:\Alatinextendedc\z:}', "");;
    Expect(1, 11391, '\p{Block=	_latin_Extended_C}', "");
    Expect(0, 11391, '\p{^Block=	_latin_Extended_C}', "");
    Expect(0, 11391, '\P{Block=	_latin_Extended_C}', "");
    Expect(1, 11391, '\P{^Block=	_latin_Extended_C}', "");
    Expect(0, 11392, '\p{Block=	_latin_Extended_C}', "");
    Expect(1, 11392, '\p{^Block=	_latin_Extended_C}', "");
    Expect(1, 11392, '\P{Block=	_latin_Extended_C}', "");
    Expect(0, 11392, '\P{^Block=	_latin_Extended_C}', "");
    Error('\p{Blk=-latin_Ext_C/a/}');
    Error('\P{Blk=-latin_Ext_C/a/}');
    Expect(1, 11391, '\p{Blk=:\ALatin_Ext_C\z:}', "");;
    Expect(0, 11392, '\p{Blk=:\ALatin_Ext_C\z:}', "");;
    Expect(1, 11391, '\p{Blk=latinextc}', "");
    Expect(0, 11391, '\p{^Blk=latinextc}', "");
    Expect(0, 11391, '\P{Blk=latinextc}', "");
    Expect(1, 11391, '\P{^Blk=latinextc}', "");
    Expect(0, 11392, '\p{Blk=latinextc}', "");
    Expect(1, 11392, '\p{^Blk=latinextc}', "");
    Expect(1, 11392, '\P{Blk=latinextc}', "");
    Expect(0, 11392, '\P{^Blk=latinextc}', "");
    Expect(1, 11391, '\p{Blk=:\Alatinextc\z:}', "");;
    Expect(0, 11392, '\p{Blk=:\Alatinextc\z:}', "");;
    Expect(1, 11391, '\p{Blk: -Latin_Ext_C}', "");
    Expect(0, 11391, '\p{^Blk: -Latin_Ext_C}', "");
    Expect(0, 11391, '\P{Blk: -Latin_Ext_C}', "");
    Expect(1, 11391, '\P{^Blk: -Latin_Ext_C}', "");
    Expect(0, 11392, '\p{Blk: -Latin_Ext_C}', "");
    Expect(1, 11392, '\p{^Blk: -Latin_Ext_C}', "");
    Expect(1, 11392, '\P{Blk: -Latin_Ext_C}', "");
    Expect(0, 11392, '\P{^Blk: -Latin_Ext_C}', "");
    Error('\p{Is_Block=:=Latin_Extended_C}');
    Error('\P{Is_Block=:=Latin_Extended_C}');
    Expect(1, 11391, '\p{Is_Block=latinextendedc}', "");
    Expect(0, 11391, '\p{^Is_Block=latinextendedc}', "");
    Expect(0, 11391, '\P{Is_Block=latinextendedc}', "");
    Expect(1, 11391, '\P{^Is_Block=latinextendedc}', "");
    Expect(0, 11392, '\p{Is_Block=latinextendedc}', "");
    Expect(1, 11392, '\p{^Is_Block=latinextendedc}', "");
    Expect(1, 11392, '\P{Is_Block=latinextendedc}', "");
    Expect(0, 11392, '\P{^Is_Block=latinextendedc}', "");
    Expect(1, 11391, '\p{Is_Block:	-	Latin_Extended_C}', "");
    Expect(0, 11391, '\p{^Is_Block:	-	Latin_Extended_C}', "");
    Expect(0, 11391, '\P{Is_Block:	-	Latin_Extended_C}', "");
    Expect(1, 11391, '\P{^Is_Block:	-	Latin_Extended_C}', "");
    Expect(0, 11392, '\p{Is_Block:	-	Latin_Extended_C}', "");
    Expect(1, 11392, '\p{^Is_Block:	-	Latin_Extended_C}', "");
    Expect(1, 11392, '\P{Is_Block:	-	Latin_Extended_C}', "");
    Expect(0, 11392, '\P{^Is_Block:	-	Latin_Extended_C}', "");
    Error('\p{Is_Blk=/a/Latin_EXT_c}');
    Error('\P{Is_Blk=/a/Latin_EXT_c}');
    Expect(1, 11391, '\p{Is_Blk=latinextc}', "");
    Expect(0, 11391, '\p{^Is_Blk=latinextc}', "");
    Expect(0, 11391, '\P{Is_Blk=latinextc}', "");
    Expect(1, 11391, '\P{^Is_Blk=latinextc}', "");
    Expect(0, 11392, '\p{Is_Blk=latinextc}', "");
    Expect(1, 11392, '\p{^Is_Blk=latinextc}', "");
    Expect(1, 11392, '\P{Is_Blk=latinextc}', "");
    Expect(0, 11392, '\P{^Is_Blk=latinextc}', "");
    Expect(1, 11391, '\p{Is_Blk=  LATIN_Ext_c}', "");
    Expect(0, 11391, '\p{^Is_Blk=  LATIN_Ext_c}', "");
    Expect(0, 11391, '\P{Is_Blk=  LATIN_Ext_c}', "");
    Expect(1, 11391, '\P{^Is_Blk=  LATIN_Ext_c}', "");
    Expect(0, 11392, '\p{Is_Blk=  LATIN_Ext_c}', "");
    Expect(1, 11392, '\p{^Is_Blk=  LATIN_Ext_c}', "");
    Expect(1, 11392, '\P{Is_Blk=  LATIN_Ext_c}', "");
    Expect(0, 11392, '\P{^Is_Blk=  LATIN_Ext_c}', "");
    Error('\p{Block=	latin_Extended_D:=}');
    Error('\P{Block=	latin_Extended_D:=}');
    Expect(1, 43007, '\p{Block=:\ALatin_Extended_D\z:}', "");;
    Expect(0, 43008, '\p{Block=:\ALatin_Extended_D\z:}', "");;
    Expect(1, 43007, '\p{Block=latinextendedd}', "");
    Expect(0, 43007, '\p{^Block=latinextendedd}', "");
    Expect(0, 43007, '\P{Block=latinextendedd}', "");
    Expect(1, 43007, '\P{^Block=latinextendedd}', "");
    Expect(0, 43008, '\p{Block=latinextendedd}', "");
    Expect(1, 43008, '\p{^Block=latinextendedd}', "");
    Expect(1, 43008, '\P{Block=latinextendedd}', "");
    Expect(0, 43008, '\P{^Block=latinextendedd}', "");
    Expect(1, 43007, '\p{Block=:\Alatinextendedd\z:}', "");;
    Expect(0, 43008, '\p{Block=:\Alatinextendedd\z:}', "");;
    Expect(1, 43007, '\p{Block= -Latin_EXTENDED_D}', "");
    Expect(0, 43007, '\p{^Block= -Latin_EXTENDED_D}', "");
    Expect(0, 43007, '\P{Block= -Latin_EXTENDED_D}', "");
    Expect(1, 43007, '\P{^Block= -Latin_EXTENDED_D}', "");
    Expect(0, 43008, '\p{Block= -Latin_EXTENDED_D}', "");
    Expect(1, 43008, '\p{^Block= -Latin_EXTENDED_D}', "");
    Expect(1, 43008, '\P{Block= -Latin_EXTENDED_D}', "");
    Expect(0, 43008, '\P{^Block= -Latin_EXTENDED_D}', "");
    Error('\p{Blk=:= -LATIN_Ext_d}');
    Error('\P{Blk=:= -LATIN_Ext_d}');
    Expect(1, 43007, '\p{Blk=:\ALatin_Ext_D\z:}', "");;
    Expect(0, 43008, '\p{Blk=:\ALatin_Ext_D\z:}', "");;
    Expect(1, 43007, '\p{Blk=latinextd}', "");
    Expect(0, 43007, '\p{^Blk=latinextd}', "");
    Expect(0, 43007, '\P{Blk=latinextd}', "");
    Expect(1, 43007, '\P{^Blk=latinextd}', "");
    Expect(0, 43008, '\p{Blk=latinextd}', "");
    Expect(1, 43008, '\p{^Blk=latinextd}', "");
    Expect(1, 43008, '\P{Blk=latinextd}', "");
    Expect(0, 43008, '\P{^Blk=latinextd}', "");
    Expect(1, 43007, '\p{Blk=:\Alatinextd\z:}', "");;
    Expect(0, 43008, '\p{Blk=:\Alatinextd\z:}', "");;
    Expect(1, 43007, '\p{Blk=-	LATIN_EXT_D}', "");
    Expect(0, 43007, '\p{^Blk=-	LATIN_EXT_D}', "");
    Expect(0, 43007, '\P{Blk=-	LATIN_EXT_D}', "");
    Expect(1, 43007, '\P{^Blk=-	LATIN_EXT_D}', "");
    Expect(0, 43008, '\p{Blk=-	LATIN_EXT_D}', "");
    Expect(1, 43008, '\p{^Blk=-	LATIN_EXT_D}', "");
    Expect(1, 43008, '\P{Blk=-	LATIN_EXT_D}', "");
    Expect(0, 43008, '\P{^Blk=-	LATIN_EXT_D}', "");
    Error('\p{Is_Block=	/a/Latin_Extended_d}');
    Error('\P{Is_Block=	/a/Latin_Extended_d}');
    Expect(1, 43007, '\p{Is_Block=latinextendedd}', "");
    Expect(0, 43007, '\p{^Is_Block=latinextendedd}', "");
    Expect(0, 43007, '\P{Is_Block=latinextendedd}', "");
    Expect(1, 43007, '\P{^Is_Block=latinextendedd}', "");
    Expect(0, 43008, '\p{Is_Block=latinextendedd}', "");
    Expect(1, 43008, '\p{^Is_Block=latinextendedd}', "");
    Expect(1, 43008, '\P{Is_Block=latinextendedd}', "");
    Expect(0, 43008, '\P{^Is_Block=latinextendedd}', "");
    Expect(1, 43007, '\p{Is_Block=__Latin_EXTENDED_D}', "");
    Expect(0, 43007, '\p{^Is_Block=__Latin_EXTENDED_D}', "");
    Expect(0, 43007, '\P{Is_Block=__Latin_EXTENDED_D}', "");
    Expect(1, 43007, '\P{^Is_Block=__Latin_EXTENDED_D}', "");
    Expect(0, 43008, '\p{Is_Block=__Latin_EXTENDED_D}', "");
    Expect(1, 43008, '\p{^Is_Block=__Latin_EXTENDED_D}', "");
    Expect(1, 43008, '\P{Is_Block=__Latin_EXTENDED_D}', "");
    Expect(0, 43008, '\P{^Is_Block=__Latin_EXTENDED_D}', "");
    Error('\p{Is_Blk=:=_ LATIN_ext_D}');
    Error('\P{Is_Blk=:=_ LATIN_ext_D}');
    Expect(1, 43007, '\p{Is_Blk=latinextd}', "");
    Expect(0, 43007, '\p{^Is_Blk=latinextd}', "");
    Expect(0, 43007, '\P{Is_Blk=latinextd}', "");
    Expect(1, 43007, '\P{^Is_Blk=latinextd}', "");
    Expect(0, 43008, '\p{Is_Blk=latinextd}', "");
    Expect(1, 43008, '\p{^Is_Blk=latinextd}', "");
    Expect(1, 43008, '\P{Is_Blk=latinextd}', "");
    Expect(0, 43008, '\P{^Is_Blk=latinextd}', "");
    Expect(1, 43007, '\p{Is_Blk=- Latin_EXT_D}', "");
    Expect(0, 43007, '\p{^Is_Blk=- Latin_EXT_D}', "");
    Expect(0, 43007, '\P{Is_Blk=- Latin_EXT_D}', "");
    Expect(1, 43007, '\P{^Is_Blk=- Latin_EXT_D}', "");
    Expect(0, 43008, '\p{Is_Blk=- Latin_EXT_D}', "");
    Expect(1, 43008, '\p{^Is_Blk=- Latin_EXT_D}', "");
    Expect(1, 43008, '\P{Is_Blk=- Latin_EXT_D}', "");
    Expect(0, 43008, '\P{^Is_Blk=- Latin_EXT_D}', "");
    Error('\p{Block=:=Latin_Extended_e}');
    Error('\P{Block=:=Latin_Extended_e}');
    Expect(1, 43887, '\p{Block=:\ALatin_Extended_E\z:}', "");;
    Expect(0, 43888, '\p{Block=:\ALatin_Extended_E\z:}', "");;
    Expect(1, 43887, '\p{Block=latinextendede}', "");
    Expect(0, 43887, '\p{^Block=latinextendede}', "");
    Expect(0, 43887, '\P{Block=latinextendede}', "");
    Expect(1, 43887, '\P{^Block=latinextendede}', "");
    Expect(0, 43888, '\p{Block=latinextendede}', "");
    Expect(1, 43888, '\p{^Block=latinextendede}', "");
    Expect(1, 43888, '\P{Block=latinextendede}', "");
    Expect(0, 43888, '\P{^Block=latinextendede}', "");
    Expect(1, 43887, '\p{Block=:\Alatinextendede\z:}', "");;
    Expect(0, 43888, '\p{Block=:\Alatinextendede\z:}', "");;
    Expect(1, 43887, '\p{Block=  Latin_Extended_E}', "");
    Expect(0, 43887, '\p{^Block=  Latin_Extended_E}', "");
    Expect(0, 43887, '\P{Block=  Latin_Extended_E}', "");
    Expect(1, 43887, '\P{^Block=  Latin_Extended_E}', "");
    Expect(0, 43888, '\p{Block=  Latin_Extended_E}', "");
    Expect(1, 43888, '\p{^Block=  Latin_Extended_E}', "");
    Expect(1, 43888, '\P{Block=  Latin_Extended_E}', "");
    Expect(0, 43888, '\P{^Block=  Latin_Extended_E}', "");
    Error('\p{Blk:   /a/ -Latin_Ext_E}');
    Error('\P{Blk:   /a/ -Latin_Ext_E}');
    Expect(1, 43887, '\p{Blk=:\ALatin_Ext_E\z:}', "");;
    Expect(0, 43888, '\p{Blk=:\ALatin_Ext_E\z:}', "");;
    Expect(1, 43887, '\p{Blk=latinexte}', "");
    Expect(0, 43887, '\p{^Blk=latinexte}', "");
    Expect(0, 43887, '\P{Blk=latinexte}', "");
    Expect(1, 43887, '\P{^Blk=latinexte}', "");
    Expect(0, 43888, '\p{Blk=latinexte}', "");
    Expect(1, 43888, '\p{^Blk=latinexte}', "");
    Expect(1, 43888, '\P{Blk=latinexte}', "");
    Expect(0, 43888, '\P{^Blk=latinexte}', "");
    Expect(1, 43887, '\p{Blk=:\Alatinexte\z:}', "");;
    Expect(0, 43888, '\p{Blk=:\Alatinexte\z:}', "");;
    Expect(1, 43887, '\p{Blk=	 Latin_Ext_e}', "");
    Expect(0, 43887, '\p{^Blk=	 Latin_Ext_e}', "");
    Expect(0, 43887, '\P{Blk=	 Latin_Ext_e}', "");
    Expect(1, 43887, '\P{^Blk=	 Latin_Ext_e}', "");
    Expect(0, 43888, '\p{Blk=	 Latin_Ext_e}', "");
    Expect(1, 43888, '\p{^Blk=	 Latin_Ext_e}', "");
    Expect(1, 43888, '\P{Blk=	 Latin_Ext_e}', "");
    Expect(0, 43888, '\P{^Blk=	 Latin_Ext_e}', "");
    Error('\p{Is_Block=_	Latin_extended_e:=}');
    Error('\P{Is_Block=_	Latin_extended_e:=}');
    Expect(1, 43887, '\p{Is_Block=latinextendede}', "");
    Expect(0, 43887, '\p{^Is_Block=latinextendede}', "");
    Expect(0, 43887, '\P{Is_Block=latinextendede}', "");
    Expect(1, 43887, '\P{^Is_Block=latinextendede}', "");
    Expect(0, 43888, '\p{Is_Block=latinextendede}', "");
    Expect(1, 43888, '\p{^Is_Block=latinextendede}', "");
    Expect(1, 43888, '\P{Is_Block=latinextendede}', "");
    Expect(0, 43888, '\P{^Is_Block=latinextendede}', "");
    Expect(1, 43887, '\p{Is_Block: 	-Latin_extended_E}', "");
    Expect(0, 43887, '\p{^Is_Block: 	-Latin_extended_E}', "");
    Expect(0, 43887, '\P{Is_Block: 	-Latin_extended_E}', "");
    Expect(1, 43887, '\P{^Is_Block: 	-Latin_extended_E}', "");
    Expect(0, 43888, '\p{Is_Block: 	-Latin_extended_E}', "");
    Expect(1, 43888, '\p{^Is_Block: 	-Latin_extended_E}', "");
    Expect(1, 43888, '\P{Is_Block: 	-Latin_extended_E}', "");
    Expect(0, 43888, '\P{^Is_Block: 	-Latin_extended_E}', "");
    Error('\p{Is_Blk=:=Latin_EXT_e}');
    Error('\P{Is_Blk=:=Latin_EXT_e}');
    Expect(1, 43887, '\p{Is_Blk=latinexte}', "");
    Expect(0, 43887, '\p{^Is_Blk=latinexte}', "");
    Expect(0, 43887, '\P{Is_Blk=latinexte}', "");
    Expect(1, 43887, '\P{^Is_Blk=latinexte}', "");
    Expect(0, 43888, '\p{Is_Blk=latinexte}', "");
    Expect(1, 43888, '\p{^Is_Blk=latinexte}', "");
    Expect(1, 43888, '\P{Is_Blk=latinexte}', "");
    Expect(0, 43888, '\P{^Is_Blk=latinexte}', "");
    Expect(1, 43887, '\p{Is_Blk=- latin_Ext_E}', "");
    Expect(0, 43887, '\p{^Is_Blk=- latin_Ext_E}', "");
    Expect(0, 43887, '\P{Is_Blk=- latin_Ext_E}', "");
    Expect(1, 43887, '\P{^Is_Blk=- latin_Ext_E}', "");
    Expect(0, 43888, '\p{Is_Blk=- latin_Ext_E}', "");
    Expect(1, 43888, '\p{^Is_Blk=- latin_Ext_E}', "");
    Expect(1, 43888, '\P{Is_Blk=- latin_Ext_E}', "");
    Expect(0, 43888, '\P{^Is_Blk=- latin_Ext_E}', "");
    Error('\p{Block=:= Lepcha}');
    Error('\P{Block=:= Lepcha}');
    Expect(1, 7247, '\p{Block=:\ALepcha\z:}', "");;
    Expect(0, 7248, '\p{Block=:\ALepcha\z:}', "");;
    Expect(1, 7247, '\p{Block=lepcha}', "");
    Expect(0, 7247, '\p{^Block=lepcha}', "");
    Expect(0, 7247, '\P{Block=lepcha}', "");
    Expect(1, 7247, '\P{^Block=lepcha}', "");
    Expect(0, 7248, '\p{Block=lepcha}', "");
    Expect(1, 7248, '\p{^Block=lepcha}', "");
    Expect(1, 7248, '\P{Block=lepcha}', "");
    Expect(0, 7248, '\P{^Block=lepcha}', "");
    Expect(1, 7247, '\p{Block=:\Alepcha\z:}', "");;
    Expect(0, 7248, '\p{Block=:\Alepcha\z:}', "");;
    Expect(1, 7247, '\p{Block=	_LEPCHA}', "");
    Expect(0, 7247, '\p{^Block=	_LEPCHA}', "");
    Expect(0, 7247, '\P{Block=	_LEPCHA}', "");
    Expect(1, 7247, '\P{^Block=	_LEPCHA}', "");
    Expect(0, 7248, '\p{Block=	_LEPCHA}', "");
    Expect(1, 7248, '\p{^Block=	_LEPCHA}', "");
    Expect(1, 7248, '\P{Block=	_LEPCHA}', "");
    Expect(0, 7248, '\P{^Block=	_LEPCHA}', "");
    Error('\p{Blk=:=-LEPCHA}');
    Error('\P{Blk=:=-LEPCHA}');
    Expect(1, 7247, '\p{Blk=:\ALepcha\z:}', "");;
    Expect(0, 7248, '\p{Blk=:\ALepcha\z:}', "");;
    Expect(1, 7247, '\p{Blk=lepcha}', "");
    Expect(0, 7247, '\p{^Blk=lepcha}', "");
    Expect(0, 7247, '\P{Blk=lepcha}', "");
    Expect(1, 7247, '\P{^Blk=lepcha}', "");
    Expect(0, 7248, '\p{Blk=lepcha}', "");
    Expect(1, 7248, '\p{^Blk=lepcha}', "");
    Expect(1, 7248, '\P{Blk=lepcha}', "");
    Expect(0, 7248, '\P{^Blk=lepcha}', "");
    Expect(1, 7247, '\p{Blk=:\Alepcha\z:}', "");;
    Expect(0, 7248, '\p{Blk=:\Alepcha\z:}', "");;
    Expect(1, 7247, '\p{Blk= 	Lepcha}', "");
    Expect(0, 7247, '\p{^Blk= 	Lepcha}', "");
    Expect(0, 7247, '\P{Blk= 	Lepcha}', "");
    Expect(1, 7247, '\P{^Blk= 	Lepcha}', "");
    Expect(0, 7248, '\p{Blk= 	Lepcha}', "");
    Expect(1, 7248, '\p{^Blk= 	Lepcha}', "");
    Expect(1, 7248, '\P{Blk= 	Lepcha}', "");
    Expect(0, 7248, '\P{^Blk= 	Lepcha}', "");
    Error('\p{Is_Block= /a/lepcha}');
    Error('\P{Is_Block= /a/lepcha}');
    Expect(1, 7247, '\p{Is_Block=lepcha}', "");
    Expect(0, 7247, '\p{^Is_Block=lepcha}', "");
    Expect(0, 7247, '\P{Is_Block=lepcha}', "");
    Expect(1, 7247, '\P{^Is_Block=lepcha}', "");
    Expect(0, 7248, '\p{Is_Block=lepcha}', "");
    Expect(1, 7248, '\p{^Is_Block=lepcha}', "");
    Expect(1, 7248, '\P{Is_Block=lepcha}', "");
    Expect(0, 7248, '\P{^Is_Block=lepcha}', "");
    Expect(1, 7247, '\p{Is_Block=		LEPCHA}', "");
    Expect(0, 7247, '\p{^Is_Block=		LEPCHA}', "");
    Expect(0, 7247, '\P{Is_Block=		LEPCHA}', "");
    Expect(1, 7247, '\P{^Is_Block=		LEPCHA}', "");
    Expect(0, 7248, '\p{Is_Block=		LEPCHA}', "");
    Expect(1, 7248, '\p{^Is_Block=		LEPCHA}', "");
    Expect(1, 7248, '\P{Is_Block=		LEPCHA}', "");
    Expect(0, 7248, '\P{^Is_Block=		LEPCHA}', "");
    Error('\p{Is_Blk=:=		Lepcha}');
    Error('\P{Is_Blk=:=		Lepcha}');
    Expect(1, 7247, '\p{Is_Blk=lepcha}', "");
    Expect(0, 7247, '\p{^Is_Blk=lepcha}', "");
    Expect(0, 7247, '\P{Is_Blk=lepcha}', "");
    Expect(1, 7247, '\P{^Is_Blk=lepcha}', "");
    Expect(0, 7248, '\p{Is_Blk=lepcha}', "");
    Expect(1, 7248, '\p{^Is_Blk=lepcha}', "");
    Expect(1, 7248, '\P{Is_Blk=lepcha}', "");
    Expect(0, 7248, '\P{^Is_Blk=lepcha}', "");
    Expect(1, 7247, '\p{Is_Blk=_-Lepcha}', "");
    Expect(0, 7247, '\p{^Is_Blk=_-Lepcha}', "");
    Expect(0, 7247, '\P{Is_Blk=_-Lepcha}', "");
    Expect(1, 7247, '\P{^Is_Blk=_-Lepcha}', "");
    Expect(0, 7248, '\p{Is_Blk=_-Lepcha}', "");
    Expect(1, 7248, '\p{^Is_Blk=_-Lepcha}', "");
    Expect(1, 7248, '\P{Is_Blk=_-Lepcha}', "");
    Expect(0, 7248, '\P{^Is_Blk=_-Lepcha}', "");
    Error('\p{Block=_LETTERLIKE_Symbols:=}');
    Error('\P{Block=_LETTERLIKE_Symbols:=}');
    Expect(1, 8527, '\p{Block=:\ALetterlike_Symbols\z:}', "");;
    Expect(0, 8528, '\p{Block=:\ALetterlike_Symbols\z:}', "");;
    Expect(1, 8527, '\p{Block=letterlikesymbols}', "");
    Expect(0, 8527, '\p{^Block=letterlikesymbols}', "");
    Expect(0, 8527, '\P{Block=letterlikesymbols}', "");
    Expect(1, 8527, '\P{^Block=letterlikesymbols}', "");
    Expect(0, 8528, '\p{Block=letterlikesymbols}', "");
    Expect(1, 8528, '\p{^Block=letterlikesymbols}', "");
    Expect(1, 8528, '\P{Block=letterlikesymbols}', "");
    Expect(0, 8528, '\P{^Block=letterlikesymbols}', "");
    Expect(1, 8527, '\p{Block=:\Aletterlikesymbols\z:}', "");;
    Expect(0, 8528, '\p{Block=:\Aletterlikesymbols\z:}', "");;
    Expect(1, 8527, '\p{Block=_	letterlike_Symbols}', "");
    Expect(0, 8527, '\p{^Block=_	letterlike_Symbols}', "");
    Expect(0, 8527, '\P{Block=_	letterlike_Symbols}', "");
    Expect(1, 8527, '\P{^Block=_	letterlike_Symbols}', "");
    Expect(0, 8528, '\p{Block=_	letterlike_Symbols}', "");
    Expect(1, 8528, '\p{^Block=_	letterlike_Symbols}', "");
    Expect(1, 8528, '\P{Block=_	letterlike_Symbols}', "");
    Expect(0, 8528, '\P{^Block=_	letterlike_Symbols}', "");
    Error('\p{Blk=--LETTERLIKE_Symbols:=}');
    Error('\P{Blk=--LETTERLIKE_Symbols:=}');
    Expect(1, 8527, '\p{Blk=:\ALetterlike_Symbols\z:}', "");;
    Expect(0, 8528, '\p{Blk=:\ALetterlike_Symbols\z:}', "");;
    Expect(1, 8527, '\p{Blk=letterlikesymbols}', "");
    Expect(0, 8527, '\p{^Blk=letterlikesymbols}', "");
    Expect(0, 8527, '\P{Blk=letterlikesymbols}', "");
    Expect(1, 8527, '\P{^Blk=letterlikesymbols}', "");
    Expect(0, 8528, '\p{Blk=letterlikesymbols}', "");
    Expect(1, 8528, '\p{^Blk=letterlikesymbols}', "");
    Expect(1, 8528, '\P{Blk=letterlikesymbols}', "");
    Expect(0, 8528, '\P{^Blk=letterlikesymbols}', "");
    Expect(1, 8527, '\p{Blk=:\Aletterlikesymbols\z:}', "");;
    Expect(0, 8528, '\p{Blk=:\Aletterlikesymbols\z:}', "");;
    Expect(1, 8527, '\p{Blk=_	letterlike_Symbols}', "");
    Expect(0, 8527, '\p{^Blk=_	letterlike_Symbols}', "");
    Expect(0, 8527, '\P{Blk=_	letterlike_Symbols}', "");
    Expect(1, 8527, '\P{^Blk=_	letterlike_Symbols}', "");
    Expect(0, 8528, '\p{Blk=_	letterlike_Symbols}', "");
    Expect(1, 8528, '\p{^Blk=_	letterlike_Symbols}', "");
    Expect(1, 8528, '\P{Blk=_	letterlike_Symbols}', "");
    Expect(0, 8528, '\P{^Blk=_	letterlike_Symbols}', "");
    Error('\p{Is_Block:	/a/-Letterlike_SYMBOLS}');
    Error('\P{Is_Block:	/a/-Letterlike_SYMBOLS}');
    Expect(1, 8527, '\p{Is_Block=letterlikesymbols}', "");
    Expect(0, 8527, '\p{^Is_Block=letterlikesymbols}', "");
    Expect(0, 8527, '\P{Is_Block=letterlikesymbols}', "");
    Expect(1, 8527, '\P{^Is_Block=letterlikesymbols}', "");
    Expect(0, 8528, '\p{Is_Block=letterlikesymbols}', "");
    Expect(1, 8528, '\p{^Is_Block=letterlikesymbols}', "");
    Expect(1, 8528, '\P{Is_Block=letterlikesymbols}', "");
    Expect(0, 8528, '\P{^Is_Block=letterlikesymbols}', "");
    Expect(1, 8527, '\p{Is_Block=-LETTERLIKE_symbols}', "");
    Expect(0, 8527, '\p{^Is_Block=-LETTERLIKE_symbols}', "");
    Expect(0, 8527, '\P{Is_Block=-LETTERLIKE_symbols}', "");
    Expect(1, 8527, '\P{^Is_Block=-LETTERLIKE_symbols}', "");
    Expect(0, 8528, '\p{Is_Block=-LETTERLIKE_symbols}', "");
    Expect(1, 8528, '\p{^Is_Block=-LETTERLIKE_symbols}', "");
    Expect(1, 8528, '\P{Is_Block=-LETTERLIKE_symbols}', "");
    Expect(0, 8528, '\P{^Is_Block=-LETTERLIKE_symbols}', "");
    Error('\p{Is_Blk=-:=LETTERLIKE_symbols}');
    Error('\P{Is_Blk=-:=LETTERLIKE_symbols}');
    Expect(1, 8527, '\p{Is_Blk=letterlikesymbols}', "");
    Expect(0, 8527, '\p{^Is_Blk=letterlikesymbols}', "");
    Expect(0, 8527, '\P{Is_Blk=letterlikesymbols}', "");
    Expect(1, 8527, '\P{^Is_Blk=letterlikesymbols}', "");
    Expect(0, 8528, '\p{Is_Blk=letterlikesymbols}', "");
    Expect(1, 8528, '\p{^Is_Blk=letterlikesymbols}', "");
    Expect(1, 8528, '\P{Is_Blk=letterlikesymbols}', "");
    Expect(0, 8528, '\P{^Is_Blk=letterlikesymbols}', "");
    Expect(1, 8527, '\p{Is_Blk=-	LETTERLIKE_SYMBOLS}', "");
    Expect(0, 8527, '\p{^Is_Blk=-	LETTERLIKE_SYMBOLS}', "");
    Expect(0, 8527, '\P{Is_Blk=-	LETTERLIKE_SYMBOLS}', "");
    Expect(1, 8527, '\P{^Is_Blk=-	LETTERLIKE_SYMBOLS}', "");
    Expect(0, 8528, '\p{Is_Blk=-	LETTERLIKE_SYMBOLS}', "");
    Expect(1, 8528, '\p{^Is_Blk=-	LETTERLIKE_SYMBOLS}', "");
    Expect(1, 8528, '\P{Is_Blk=-	LETTERLIKE_SYMBOLS}', "");
    Expect(0, 8528, '\P{^Is_Blk=-	LETTERLIKE_SYMBOLS}', "");
    Error('\p{Block=_-Limbu/a/}');
    Error('\P{Block=_-Limbu/a/}');
    Expect(1, 6479, '\p{Block=:\ALimbu\z:}', "");;
    Expect(0, 6480, '\p{Block=:\ALimbu\z:}', "");;
    Expect(1, 6479, '\p{Block:   limbu}', "");
    Expect(0, 6479, '\p{^Block:   limbu}', "");
    Expect(0, 6479, '\P{Block:   limbu}', "");
    Expect(1, 6479, '\P{^Block:   limbu}', "");
    Expect(0, 6480, '\p{Block:   limbu}', "");
    Expect(1, 6480, '\p{^Block:   limbu}', "");
    Expect(1, 6480, '\P{Block:   limbu}', "");
    Expect(0, 6480, '\P{^Block:   limbu}', "");
    Expect(1, 6479, '\p{Block=:\Alimbu\z:}', "");;
    Expect(0, 6480, '\p{Block=:\Alimbu\z:}', "");;
    Expect(1, 6479, '\p{Block:    Limbu}', "");
    Expect(0, 6479, '\p{^Block:    Limbu}', "");
    Expect(0, 6479, '\P{Block:    Limbu}', "");
    Expect(1, 6479, '\P{^Block:    Limbu}', "");
    Expect(0, 6480, '\p{Block:    Limbu}', "");
    Expect(1, 6480, '\p{^Block:    Limbu}', "");
    Expect(1, 6480, '\P{Block:    Limbu}', "");
    Expect(0, 6480, '\P{^Block:    Limbu}', "");
    Error('\p{Blk=/a/	 limbu}');
    Error('\P{Blk=/a/	 limbu}');
    Expect(1, 6479, '\p{Blk=:\ALimbu\z:}', "");;
    Expect(0, 6480, '\p{Blk=:\ALimbu\z:}', "");;
    Expect(1, 6479, '\p{Blk=limbu}', "");
    Expect(0, 6479, '\p{^Blk=limbu}', "");
    Expect(0, 6479, '\P{Blk=limbu}', "");
    Expect(1, 6479, '\P{^Blk=limbu}', "");
    Expect(0, 6480, '\p{Blk=limbu}', "");
    Expect(1, 6480, '\p{^Blk=limbu}', "");
    Expect(1, 6480, '\P{Blk=limbu}', "");
    Expect(0, 6480, '\P{^Blk=limbu}', "");
    Expect(1, 6479, '\p{Blk=:\Alimbu\z:}', "");;
    Expect(0, 6480, '\p{Blk=:\Alimbu\z:}', "");;
    Expect(1, 6479, '\p{Blk=-Limbu}', "");
    Expect(0, 6479, '\p{^Blk=-Limbu}', "");
    Expect(0, 6479, '\P{Blk=-Limbu}', "");
    Expect(1, 6479, '\P{^Blk=-Limbu}', "");
    Expect(0, 6480, '\p{Blk=-Limbu}', "");
    Expect(1, 6480, '\p{^Blk=-Limbu}', "");
    Expect(1, 6480, '\P{Blk=-Limbu}', "");
    Expect(0, 6480, '\P{^Blk=-Limbu}', "");
    Error('\p{Is_Block=:=-	Limbu}');
    Error('\P{Is_Block=:=-	Limbu}');
    Expect(1, 6479, '\p{Is_Block=limbu}', "");
    Expect(0, 6479, '\p{^Is_Block=limbu}', "");
    Expect(0, 6479, '\P{Is_Block=limbu}', "");
    Expect(1, 6479, '\P{^Is_Block=limbu}', "");
    Expect(0, 6480, '\p{Is_Block=limbu}', "");
    Expect(1, 6480, '\p{^Is_Block=limbu}', "");
    Expect(1, 6480, '\P{Is_Block=limbu}', "");
    Expect(0, 6480, '\P{^Is_Block=limbu}', "");
    Expect(1, 6479, '\p{Is_Block=_LIMBU}', "");
    Expect(0, 6479, '\p{^Is_Block=_LIMBU}', "");
    Expect(0, 6479, '\P{Is_Block=_LIMBU}', "");
    Expect(1, 6479, '\P{^Is_Block=_LIMBU}', "");
    Expect(0, 6480, '\p{Is_Block=_LIMBU}', "");
    Expect(1, 6480, '\p{^Is_Block=_LIMBU}', "");
    Expect(1, 6480, '\P{Is_Block=_LIMBU}', "");
    Expect(0, 6480, '\P{^Is_Block=_LIMBU}', "");
    Error('\p{Is_Blk=_/a/limbu}');
    Error('\P{Is_Blk=_/a/limbu}');
    Expect(1, 6479, '\p{Is_Blk=limbu}', "");
    Expect(0, 6479, '\p{^Is_Blk=limbu}', "");
    Expect(0, 6479, '\P{Is_Blk=limbu}', "");
    Expect(1, 6479, '\P{^Is_Blk=limbu}', "");
    Expect(0, 6480, '\p{Is_Blk=limbu}', "");
    Expect(1, 6480, '\p{^Is_Blk=limbu}', "");
    Expect(1, 6480, '\P{Is_Blk=limbu}', "");
    Expect(0, 6480, '\P{^Is_Blk=limbu}', "");
    Expect(1, 6479, '\p{Is_Blk=	 Limbu}', "");
    Expect(0, 6479, '\p{^Is_Blk=	 Limbu}', "");
    Expect(0, 6479, '\P{Is_Blk=	 Limbu}', "");
    Expect(1, 6479, '\P{^Is_Blk=	 Limbu}', "");
    Expect(0, 6480, '\p{Is_Blk=	 Limbu}', "");
    Expect(1, 6480, '\p{^Is_Blk=	 Limbu}', "");
    Expect(1, 6480, '\P{Is_Blk=	 Limbu}', "");
    Expect(0, 6480, '\P{^Is_Blk=	 Limbu}', "");
    Error('\p{Block=	Linear_A:=}');
    Error('\P{Block=	Linear_A:=}');
    Expect(1, 67455, '\p{Block=:\ALinear_A\z:}', "");;
    Expect(0, 67456, '\p{Block=:\ALinear_A\z:}', "");;
    Expect(1, 67455, '\p{Block=lineara}', "");
    Expect(0, 67455, '\p{^Block=lineara}', "");
    Expect(0, 67455, '\P{Block=lineara}', "");
    Expect(1, 67455, '\P{^Block=lineara}', "");
    Expect(0, 67456, '\p{Block=lineara}', "");
    Expect(1, 67456, '\p{^Block=lineara}', "");
    Expect(1, 67456, '\P{Block=lineara}', "");
    Expect(0, 67456, '\P{^Block=lineara}', "");
    Expect(1, 67455, '\p{Block=:\Alineara\z:}', "");;
    Expect(0, 67456, '\p{Block=:\Alineara\z:}', "");;
    Expect(1, 67455, '\p{Block=Linear_A}', "");
    Expect(0, 67455, '\p{^Block=Linear_A}', "");
    Expect(0, 67455, '\P{Block=Linear_A}', "");
    Expect(1, 67455, '\P{^Block=Linear_A}', "");
    Expect(0, 67456, '\p{Block=Linear_A}', "");
    Expect(1, 67456, '\p{^Block=Linear_A}', "");
    Expect(1, 67456, '\P{Block=Linear_A}', "");
    Expect(0, 67456, '\P{^Block=Linear_A}', "");
    Error('\p{Blk= LINEAR_A:=}');
    Error('\P{Blk= LINEAR_A:=}');
    Expect(1, 67455, '\p{Blk=:\ALinear_A\z:}', "");;
    Expect(0, 67456, '\p{Blk=:\ALinear_A\z:}', "");;
    Expect(1, 67455, '\p{Blk=lineara}', "");
    Expect(0, 67455, '\p{^Blk=lineara}', "");
    Expect(0, 67455, '\P{Blk=lineara}', "");
    Expect(1, 67455, '\P{^Blk=lineara}', "");
    Expect(0, 67456, '\p{Blk=lineara}', "");
    Expect(1, 67456, '\p{^Blk=lineara}', "");
    Expect(1, 67456, '\P{Blk=lineara}', "");
    Expect(0, 67456, '\P{^Blk=lineara}', "");
    Expect(1, 67455, '\p{Blk=:\Alineara\z:}', "");;
    Expect(0, 67456, '\p{Blk=:\Alineara\z:}', "");;
    Expect(1, 67455, '\p{Blk: 	_Linear_A}', "");
    Expect(0, 67455, '\p{^Blk: 	_Linear_A}', "");
    Expect(0, 67455, '\P{Blk: 	_Linear_A}', "");
    Expect(1, 67455, '\P{^Blk: 	_Linear_A}', "");
    Expect(0, 67456, '\p{Blk: 	_Linear_A}', "");
    Expect(1, 67456, '\p{^Blk: 	_Linear_A}', "");
    Expect(1, 67456, '\P{Blk: 	_Linear_A}', "");
    Expect(0, 67456, '\P{^Blk: 	_Linear_A}', "");
    Error('\p{Is_Block=	/a/linear_A}');
    Error('\P{Is_Block=	/a/linear_A}');
    Expect(1, 67455, '\p{Is_Block=lineara}', "");
    Expect(0, 67455, '\p{^Is_Block=lineara}', "");
    Expect(0, 67455, '\P{Is_Block=lineara}', "");
    Expect(1, 67455, '\P{^Is_Block=lineara}', "");
    Expect(0, 67456, '\p{Is_Block=lineara}', "");
    Expect(1, 67456, '\p{^Is_Block=lineara}', "");
    Expect(1, 67456, '\P{Is_Block=lineara}', "");
    Expect(0, 67456, '\P{^Is_Block=lineara}', "");
    Expect(1, 67455, '\p{Is_Block=_Linear_A}', "");
    Expect(0, 67455, '\p{^Is_Block=_Linear_A}', "");
    Expect(0, 67455, '\P{Is_Block=_Linear_A}', "");
    Expect(1, 67455, '\P{^Is_Block=_Linear_A}', "");
    Expect(0, 67456, '\p{Is_Block=_Linear_A}', "");
    Expect(1, 67456, '\p{^Is_Block=_Linear_A}', "");
    Expect(1, 67456, '\P{Is_Block=_Linear_A}', "");
    Expect(0, 67456, '\P{^Is_Block=_Linear_A}', "");
    Error('\p{Is_Blk=_-LINEAR_A/a/}');
    Error('\P{Is_Blk=_-LINEAR_A/a/}');
    Expect(1, 67455, '\p{Is_Blk=lineara}', "");
    Expect(0, 67455, '\p{^Is_Blk=lineara}', "");
    Expect(0, 67455, '\P{Is_Blk=lineara}', "");
    Expect(1, 67455, '\P{^Is_Blk=lineara}', "");
    Expect(0, 67456, '\p{Is_Blk=lineara}', "");
    Expect(1, 67456, '\p{^Is_Blk=lineara}', "");
    Expect(1, 67456, '\P{Is_Blk=lineara}', "");
    Expect(0, 67456, '\P{^Is_Blk=lineara}', "");
    Expect(1, 67455, '\p{Is_Blk=-linear_A}', "");
    Expect(0, 67455, '\p{^Is_Blk=-linear_A}', "");
    Expect(0, 67455, '\P{Is_Blk=-linear_A}', "");
    Expect(1, 67455, '\P{^Is_Blk=-linear_A}', "");
    Expect(0, 67456, '\p{Is_Blk=-linear_A}', "");
    Expect(1, 67456, '\p{^Is_Blk=-linear_A}', "");
    Expect(1, 67456, '\P{Is_Blk=-linear_A}', "");
    Expect(0, 67456, '\P{^Is_Blk=-linear_A}', "");
    Error('\p{Block=		Linear_B_IDEOGRAMS/a/}');
    Error('\P{Block=		Linear_B_IDEOGRAMS/a/}');
    Expect(1, 65791, '\p{Block=:\ALinear_B_Ideograms\z:}', "");;
    Expect(0, 65792, '\p{Block=:\ALinear_B_Ideograms\z:}', "");;
    Expect(1, 65791, '\p{Block=linearbideograms}', "");
    Expect(0, 65791, '\p{^Block=linearbideograms}', "");
    Expect(0, 65791, '\P{Block=linearbideograms}', "");
    Expect(1, 65791, '\P{^Block=linearbideograms}', "");
    Expect(0, 65792, '\p{Block=linearbideograms}', "");
    Expect(1, 65792, '\p{^Block=linearbideograms}', "");
    Expect(1, 65792, '\P{Block=linearbideograms}', "");
    Expect(0, 65792, '\P{^Block=linearbideograms}', "");
    Expect(1, 65791, '\p{Block=:\Alinearbideograms\z:}', "");;
    Expect(0, 65792, '\p{Block=:\Alinearbideograms\z:}', "");;
    Expect(1, 65791, '\p{Block=-_LINEAR_B_IDEOGRAMS}', "");
    Expect(0, 65791, '\p{^Block=-_LINEAR_B_IDEOGRAMS}', "");
    Expect(0, 65791, '\P{Block=-_LINEAR_B_IDEOGRAMS}', "");
    Expect(1, 65791, '\P{^Block=-_LINEAR_B_IDEOGRAMS}', "");
    Expect(0, 65792, '\p{Block=-_LINEAR_B_IDEOGRAMS}', "");
    Expect(1, 65792, '\p{^Block=-_LINEAR_B_IDEOGRAMS}', "");
    Expect(1, 65792, '\P{Block=-_LINEAR_B_IDEOGRAMS}', "");
    Expect(0, 65792, '\P{^Block=-_LINEAR_B_IDEOGRAMS}', "");
    Error('\p{Blk=_:=Linear_B_IDEOGRAMS}');
    Error('\P{Blk=_:=Linear_B_IDEOGRAMS}');
    Expect(1, 65791, '\p{Blk=:\ALinear_B_Ideograms\z:}', "");;
    Expect(0, 65792, '\p{Blk=:\ALinear_B_Ideograms\z:}', "");;
    Expect(1, 65791, '\p{Blk=linearbideograms}', "");
    Expect(0, 65791, '\p{^Blk=linearbideograms}', "");
    Expect(0, 65791, '\P{Blk=linearbideograms}', "");
    Expect(1, 65791, '\P{^Blk=linearbideograms}', "");
    Expect(0, 65792, '\p{Blk=linearbideograms}', "");
    Expect(1, 65792, '\p{^Blk=linearbideograms}', "");
    Expect(1, 65792, '\P{Blk=linearbideograms}', "");
    Expect(0, 65792, '\P{^Blk=linearbideograms}', "");
    Expect(1, 65791, '\p{Blk=:\Alinearbideograms\z:}', "");;
    Expect(0, 65792, '\p{Blk=:\Alinearbideograms\z:}', "");;
    Expect(1, 65791, '\p{Blk=_Linear_B_IDEOGRAMS}', "");
    Expect(0, 65791, '\p{^Blk=_Linear_B_IDEOGRAMS}', "");
    Expect(0, 65791, '\P{Blk=_Linear_B_IDEOGRAMS}', "");
    Expect(1, 65791, '\P{^Blk=_Linear_B_IDEOGRAMS}', "");
    Expect(0, 65792, '\p{Blk=_Linear_B_IDEOGRAMS}', "");
    Expect(1, 65792, '\p{^Blk=_Linear_B_IDEOGRAMS}', "");
    Expect(1, 65792, '\P{Blk=_Linear_B_IDEOGRAMS}', "");
    Expect(0, 65792, '\P{^Blk=_Linear_B_IDEOGRAMS}', "");
    Error('\p{Is_Block=/a/  Linear_b_Ideograms}');
    Error('\P{Is_Block=/a/  Linear_b_Ideograms}');
    Expect(1, 65791, '\p{Is_Block=linearbideograms}', "");
    Expect(0, 65791, '\p{^Is_Block=linearbideograms}', "");
    Expect(0, 65791, '\P{Is_Block=linearbideograms}', "");
    Expect(1, 65791, '\P{^Is_Block=linearbideograms}', "");
    Expect(0, 65792, '\p{Is_Block=linearbideograms}', "");
    Expect(1, 65792, '\p{^Is_Block=linearbideograms}', "");
    Expect(1, 65792, '\P{Is_Block=linearbideograms}', "");
    Expect(0, 65792, '\P{^Is_Block=linearbideograms}', "");
    Expect(1, 65791, '\p{Is_Block=	-LINEAR_B_ideograms}', "");
    Expect(0, 65791, '\p{^Is_Block=	-LINEAR_B_ideograms}', "");
    Expect(0, 65791, '\P{Is_Block=	-LINEAR_B_ideograms}', "");
    Expect(1, 65791, '\P{^Is_Block=	-LINEAR_B_ideograms}', "");
    Expect(0, 65792, '\p{Is_Block=	-LINEAR_B_ideograms}', "");
    Expect(1, 65792, '\p{^Is_Block=	-LINEAR_B_ideograms}', "");
    Expect(1, 65792, '\P{Is_Block=	-LINEAR_B_ideograms}', "");
    Expect(0, 65792, '\P{^Is_Block=	-LINEAR_B_ideograms}', "");
    Error('\p{Is_Blk=/a/-_linear_B_ideograms}');
    Error('\P{Is_Blk=/a/-_linear_B_ideograms}');
    Expect(1, 65791, '\p{Is_Blk=linearbideograms}', "");
    Expect(0, 65791, '\p{^Is_Blk=linearbideograms}', "");
    Expect(0, 65791, '\P{Is_Blk=linearbideograms}', "");
    Expect(1, 65791, '\P{^Is_Blk=linearbideograms}', "");
    Expect(0, 65792, '\p{Is_Blk=linearbideograms}', "");
    Expect(1, 65792, '\p{^Is_Blk=linearbideograms}', "");
    Expect(1, 65792, '\P{Is_Blk=linearbideograms}', "");
    Expect(0, 65792, '\P{^Is_Blk=linearbideograms}', "");
    Expect(1, 65791, '\p{Is_Blk=--Linear_b_ideograms}', "");
    Expect(0, 65791, '\p{^Is_Blk=--Linear_b_ideograms}', "");
    Expect(0, 65791, '\P{Is_Blk=--Linear_b_ideograms}', "");
    Expect(1, 65791, '\P{^Is_Blk=--Linear_b_ideograms}', "");
    Expect(0, 65792, '\p{Is_Blk=--Linear_b_ideograms}', "");
    Expect(1, 65792, '\p{^Is_Blk=--Linear_b_ideograms}', "");
    Expect(1, 65792, '\P{Is_Blk=--Linear_b_ideograms}', "");
    Expect(0, 65792, '\P{^Is_Blk=--Linear_b_ideograms}', "");
    Error('\p{Block: -LINEAR_b_SYLLABARY/a/}');
    Error('\P{Block: -LINEAR_b_SYLLABARY/a/}');
    Expect(1, 65663, '\p{Block=:\ALinear_B_Syllabary\z:}', "");;
    Expect(0, 65664, '\p{Block=:\ALinear_B_Syllabary\z:}', "");;
    Expect(1, 65663, '\p{Block=linearbsyllabary}', "");
    Expect(0, 65663, '\p{^Block=linearbsyllabary}', "");
    Expect(0, 65663, '\P{Block=linearbsyllabary}', "");
    Expect(1, 65663, '\P{^Block=linearbsyllabary}', "");
    Expect(0, 65664, '\p{Block=linearbsyllabary}', "");
    Expect(1, 65664, '\p{^Block=linearbsyllabary}', "");
    Expect(1, 65664, '\P{Block=linearbsyllabary}', "");
    Expect(0, 65664, '\P{^Block=linearbsyllabary}', "");
    Expect(1, 65663, '\p{Block=:\Alinearbsyllabary\z:}', "");;
    Expect(0, 65664, '\p{Block=:\Alinearbsyllabary\z:}', "");;
    Expect(1, 65663, '\p{Block=_	Linear_B_Syllabary}', "");
    Expect(0, 65663, '\p{^Block=_	Linear_B_Syllabary}', "");
    Expect(0, 65663, '\P{Block=_	Linear_B_Syllabary}', "");
    Expect(1, 65663, '\P{^Block=_	Linear_B_Syllabary}', "");
    Expect(0, 65664, '\p{Block=_	Linear_B_Syllabary}', "");
    Expect(1, 65664, '\p{^Block=_	Linear_B_Syllabary}', "");
    Expect(1, 65664, '\P{Block=_	Linear_B_Syllabary}', "");
    Expect(0, 65664, '\P{^Block=_	Linear_B_Syllabary}', "");
    Error('\p{Blk=_:=Linear_B_Syllabary}');
    Error('\P{Blk=_:=Linear_B_Syllabary}');
    Expect(1, 65663, '\p{Blk=:\ALinear_B_Syllabary\z:}', "");;
    Expect(0, 65664, '\p{Blk=:\ALinear_B_Syllabary\z:}', "");;
    Expect(1, 65663, '\p{Blk=linearbsyllabary}', "");
    Expect(0, 65663, '\p{^Blk=linearbsyllabary}', "");
    Expect(0, 65663, '\P{Blk=linearbsyllabary}', "");
    Expect(1, 65663, '\P{^Blk=linearbsyllabary}', "");
    Expect(0, 65664, '\p{Blk=linearbsyllabary}', "");
    Expect(1, 65664, '\p{^Blk=linearbsyllabary}', "");
    Expect(1, 65664, '\P{Blk=linearbsyllabary}', "");
    Expect(0, 65664, '\P{^Blk=linearbsyllabary}', "");
    Expect(1, 65663, '\p{Blk=:\Alinearbsyllabary\z:}', "");;
    Expect(0, 65664, '\p{Blk=:\Alinearbsyllabary\z:}', "");;
    Expect(1, 65663, '\p{Blk= -LINEAR_B_Syllabary}', "");
    Expect(0, 65663, '\p{^Blk= -LINEAR_B_Syllabary}', "");
    Expect(0, 65663, '\P{Blk= -LINEAR_B_Syllabary}', "");
    Expect(1, 65663, '\P{^Blk= -LINEAR_B_Syllabary}', "");
    Expect(0, 65664, '\p{Blk= -LINEAR_B_Syllabary}', "");
    Expect(1, 65664, '\p{^Blk= -LINEAR_B_Syllabary}', "");
    Expect(1, 65664, '\P{Blk= -LINEAR_B_Syllabary}', "");
    Expect(0, 65664, '\P{^Blk= -LINEAR_B_Syllabary}', "");
    Error('\p{Is_Block=:=_	Linear_B_SYLLABARY}');
    Error('\P{Is_Block=:=_	Linear_B_SYLLABARY}');
    Expect(1, 65663, '\p{Is_Block=linearbsyllabary}', "");
    Expect(0, 65663, '\p{^Is_Block=linearbsyllabary}', "");
    Expect(0, 65663, '\P{Is_Block=linearbsyllabary}', "");
    Expect(1, 65663, '\P{^Is_Block=linearbsyllabary}', "");
    Expect(0, 65664, '\p{Is_Block=linearbsyllabary}', "");
    Expect(1, 65664, '\p{^Is_Block=linearbsyllabary}', "");
    Expect(1, 65664, '\P{Is_Block=linearbsyllabary}', "");
    Expect(0, 65664, '\P{^Is_Block=linearbsyllabary}', "");
    Expect(1, 65663, '\p{Is_Block=-_linear_B_Syllabary}', "");
    Expect(0, 65663, '\p{^Is_Block=-_linear_B_Syllabary}', "");
    Expect(0, 65663, '\P{Is_Block=-_linear_B_Syllabary}', "");
    Expect(1, 65663, '\P{^Is_Block=-_linear_B_Syllabary}', "");
    Expect(0, 65664, '\p{Is_Block=-_linear_B_Syllabary}', "");
    Expect(1, 65664, '\p{^Is_Block=-_linear_B_Syllabary}', "");
    Expect(1, 65664, '\P{Is_Block=-_linear_B_Syllabary}', "");
    Expect(0, 65664, '\P{^Is_Block=-_linear_B_Syllabary}', "");
    Error('\p{Is_Blk=-/a/LINEAR_B_Syllabary}');
    Error('\P{Is_Blk=-/a/LINEAR_B_Syllabary}');
    Expect(1, 65663, '\p{Is_Blk=linearbsyllabary}', "");
    Expect(0, 65663, '\p{^Is_Blk=linearbsyllabary}', "");
    Expect(0, 65663, '\P{Is_Blk=linearbsyllabary}', "");
    Expect(1, 65663, '\P{^Is_Blk=linearbsyllabary}', "");
    Expect(0, 65664, '\p{Is_Blk=linearbsyllabary}', "");
    Expect(1, 65664, '\p{^Is_Blk=linearbsyllabary}', "");
    Expect(1, 65664, '\P{Is_Blk=linearbsyllabary}', "");
    Expect(0, 65664, '\P{^Is_Blk=linearbsyllabary}', "");
    Expect(1, 65663, '\p{Is_Blk:LINEAR_B_SYLLABARY}', "");
    Expect(0, 65663, '\p{^Is_Blk:LINEAR_B_SYLLABARY}', "");
    Expect(0, 65663, '\P{Is_Blk:LINEAR_B_SYLLABARY}', "");
    Expect(1, 65663, '\P{^Is_Blk:LINEAR_B_SYLLABARY}', "");
    Expect(0, 65664, '\p{Is_Blk:LINEAR_B_SYLLABARY}', "");
    Expect(1, 65664, '\p{^Is_Blk:LINEAR_B_SYLLABARY}', "");
    Expect(1, 65664, '\P{Is_Blk:LINEAR_B_SYLLABARY}', "");
    Expect(0, 65664, '\P{^Is_Blk:LINEAR_B_SYLLABARY}', "");
    Error('\p{Block=-/a/Lisu}');
    Error('\P{Block=-/a/Lisu}');
    Expect(1, 42239, '\p{Block=:\ALisu\z:}', "");;
    Expect(0, 42240, '\p{Block=:\ALisu\z:}', "");;
    Expect(1, 42239, '\p{Block=lisu}', "");
    Expect(0, 42239, '\p{^Block=lisu}', "");
    Expect(0, 42239, '\P{Block=lisu}', "");
    Expect(1, 42239, '\P{^Block=lisu}', "");
    Expect(0, 42240, '\p{Block=lisu}', "");
    Expect(1, 42240, '\p{^Block=lisu}', "");
    Expect(1, 42240, '\P{Block=lisu}', "");
    Expect(0, 42240, '\P{^Block=lisu}', "");
    Expect(1, 42239, '\p{Block=:\Alisu\z:}', "");;
    Expect(0, 42240, '\p{Block=:\Alisu\z:}', "");;
    Expect(1, 42239, '\p{Block=_-Lisu}', "");
    Expect(0, 42239, '\p{^Block=_-Lisu}', "");
    Expect(0, 42239, '\P{Block=_-Lisu}', "");
    Expect(1, 42239, '\P{^Block=_-Lisu}', "");
    Expect(0, 42240, '\p{Block=_-Lisu}', "");
    Expect(1, 42240, '\p{^Block=_-Lisu}', "");
    Expect(1, 42240, '\P{Block=_-Lisu}', "");
    Expect(0, 42240, '\P{^Block=_-Lisu}', "");
    Error('\p{Blk=		Lisu:=}');
    Error('\P{Blk=		Lisu:=}');
    Expect(1, 42239, '\p{Blk=:\ALisu\z:}', "");;
    Expect(0, 42240, '\p{Blk=:\ALisu\z:}', "");;
    Expect(1, 42239, '\p{Blk:   lisu}', "");
    Expect(0, 42239, '\p{^Blk:   lisu}', "");
    Expect(0, 42239, '\P{Blk:   lisu}', "");
    Expect(1, 42239, '\P{^Blk:   lisu}', "");
    Expect(0, 42240, '\p{Blk:   lisu}', "");
    Expect(1, 42240, '\p{^Blk:   lisu}', "");
    Expect(1, 42240, '\P{Blk:   lisu}', "");
    Expect(0, 42240, '\P{^Blk:   lisu}', "");
    Expect(1, 42239, '\p{Blk=:\Alisu\z:}', "");;
    Expect(0, 42240, '\p{Blk=:\Alisu\z:}', "");;
    Expect(1, 42239, '\p{Blk= _Lisu}', "");
    Expect(0, 42239, '\p{^Blk= _Lisu}', "");
    Expect(0, 42239, '\P{Blk= _Lisu}', "");
    Expect(1, 42239, '\P{^Blk= _Lisu}', "");
    Expect(0, 42240, '\p{Blk= _Lisu}', "");
    Expect(1, 42240, '\p{^Blk= _Lisu}', "");
    Expect(1, 42240, '\P{Blk= _Lisu}', "");
    Expect(0, 42240, '\P{^Blk= _Lisu}', "");
    Error('\p{Is_Block=/a/	_LISU}');
    Error('\P{Is_Block=/a/	_LISU}');
    Expect(1, 42239, '\p{Is_Block: lisu}', "");
    Expect(0, 42239, '\p{^Is_Block: lisu}', "");
    Expect(0, 42239, '\P{Is_Block: lisu}', "");
    Expect(1, 42239, '\P{^Is_Block: lisu}', "");
    Expect(0, 42240, '\p{Is_Block: lisu}', "");
    Expect(1, 42240, '\p{^Is_Block: lisu}', "");
    Expect(1, 42240, '\P{Is_Block: lisu}', "");
    Expect(0, 42240, '\P{^Is_Block: lisu}', "");
    Expect(1, 42239, '\p{Is_Block=- LISU}', "");
    Expect(0, 42239, '\p{^Is_Block=- LISU}', "");
    Expect(0, 42239, '\P{Is_Block=- LISU}', "");
    Expect(1, 42239, '\P{^Is_Block=- LISU}', "");
    Expect(0, 42240, '\p{Is_Block=- LISU}', "");
    Expect(1, 42240, '\p{^Is_Block=- LISU}', "");
    Expect(1, 42240, '\P{Is_Block=- LISU}', "");
    Expect(0, 42240, '\P{^Is_Block=- LISU}', "");
    Error('\p{Is_Blk=:=	LISU}');
    Error('\P{Is_Blk=:=	LISU}');
    Expect(1, 42239, '\p{Is_Blk=lisu}', "");
    Expect(0, 42239, '\p{^Is_Blk=lisu}', "");
    Expect(0, 42239, '\P{Is_Blk=lisu}', "");
    Expect(1, 42239, '\P{^Is_Blk=lisu}', "");
    Expect(0, 42240, '\p{Is_Blk=lisu}', "");
    Expect(1, 42240, '\p{^Is_Blk=lisu}', "");
    Expect(1, 42240, '\P{Is_Blk=lisu}', "");
    Expect(0, 42240, '\P{^Is_Blk=lisu}', "");
    Expect(1, 42239, '\p{Is_Blk= Lisu}', "");
    Expect(0, 42239, '\p{^Is_Blk= Lisu}', "");
    Expect(0, 42239, '\P{Is_Blk= Lisu}', "");
    Expect(1, 42239, '\P{^Is_Blk= Lisu}', "");
    Expect(0, 42240, '\p{Is_Blk= Lisu}', "");
    Expect(1, 42240, '\p{^Is_Blk= Lisu}', "");
    Expect(1, 42240, '\P{Is_Blk= Lisu}', "");
    Expect(0, 42240, '\P{^Is_Blk= Lisu}', "");
    Error('\p{Block=	_low_surrogates:=}');
    Error('\P{Block=	_low_surrogates:=}');
    Expect(1, 57343, '\p{Block=:\ALow_Surrogates\z:}', "");;
    Expect(0, 57344, '\p{Block=:\ALow_Surrogates\z:}', "");;
    Expect(1, 57343, '\p{Block=lowsurrogates}', "");
    Expect(0, 57343, '\p{^Block=lowsurrogates}', "");
    Expect(0, 57343, '\P{Block=lowsurrogates}', "");
    Expect(1, 57343, '\P{^Block=lowsurrogates}', "");
    Expect(0, 57344, '\p{Block=lowsurrogates}', "");
    Expect(1, 57344, '\p{^Block=lowsurrogates}', "");
    Expect(1, 57344, '\P{Block=lowsurrogates}', "");
    Expect(0, 57344, '\P{^Block=lowsurrogates}', "");
    Expect(1, 57343, '\p{Block=:\Alowsurrogates\z:}', "");;
    Expect(0, 57344, '\p{Block=:\Alowsurrogates\z:}', "");;
    Expect(1, 57343, '\p{Block= 	Low_Surrogates}', "");
    Expect(0, 57343, '\p{^Block= 	Low_Surrogates}', "");
    Expect(0, 57343, '\P{Block= 	Low_Surrogates}', "");
    Expect(1, 57343, '\P{^Block= 	Low_Surrogates}', "");
    Expect(0, 57344, '\p{Block= 	Low_Surrogates}', "");
    Expect(1, 57344, '\p{^Block= 	Low_Surrogates}', "");
    Expect(1, 57344, '\P{Block= 	Low_Surrogates}', "");
    Expect(0, 57344, '\P{^Block= 	Low_Surrogates}', "");
    Error('\p{Blk=	Low_SURROGATES/a/}');
    Error('\P{Blk=	Low_SURROGATES/a/}');
    Expect(1, 57343, '\p{Blk=:\ALow_Surrogates\z:}', "");;
    Expect(0, 57344, '\p{Blk=:\ALow_Surrogates\z:}', "");;
    Expect(1, 57343, '\p{Blk=lowsurrogates}', "");
    Expect(0, 57343, '\p{^Blk=lowsurrogates}', "");
    Expect(0, 57343, '\P{Blk=lowsurrogates}', "");
    Expect(1, 57343, '\P{^Blk=lowsurrogates}', "");
    Expect(0, 57344, '\p{Blk=lowsurrogates}', "");
    Expect(1, 57344, '\p{^Blk=lowsurrogates}', "");
    Expect(1, 57344, '\P{Blk=lowsurrogates}', "");
    Expect(0, 57344, '\P{^Blk=lowsurrogates}', "");
    Expect(1, 57343, '\p{Blk=:\Alowsurrogates\z:}', "");;
    Expect(0, 57344, '\p{Blk=:\Alowsurrogates\z:}', "");;
    Expect(1, 57343, '\p{Blk=		low_Surrogates}', "");
    Expect(0, 57343, '\p{^Blk=		low_Surrogates}', "");
    Expect(0, 57343, '\P{Blk=		low_Surrogates}', "");
    Expect(1, 57343, '\P{^Blk=		low_Surrogates}', "");
    Expect(0, 57344, '\p{Blk=		low_Surrogates}', "");
    Expect(1, 57344, '\p{^Blk=		low_Surrogates}', "");
    Expect(1, 57344, '\P{Blk=		low_Surrogates}', "");
    Expect(0, 57344, '\P{^Blk=		low_Surrogates}', "");
    Error('\p{Is_Block= :=low_Surrogates}');
    Error('\P{Is_Block= :=low_Surrogates}');
    Expect(1, 57343, '\p{Is_Block=lowsurrogates}', "");
    Expect(0, 57343, '\p{^Is_Block=lowsurrogates}', "");
    Expect(0, 57343, '\P{Is_Block=lowsurrogates}', "");
    Expect(1, 57343, '\P{^Is_Block=lowsurrogates}', "");
    Expect(0, 57344, '\p{Is_Block=lowsurrogates}', "");
    Expect(1, 57344, '\p{^Is_Block=lowsurrogates}', "");
    Expect(1, 57344, '\P{Is_Block=lowsurrogates}', "");
    Expect(0, 57344, '\P{^Is_Block=lowsurrogates}', "");
    Expect(1, 57343, '\p{Is_Block=_ Low_Surrogates}', "");
    Expect(0, 57343, '\p{^Is_Block=_ Low_Surrogates}', "");
    Expect(0, 57343, '\P{Is_Block=_ Low_Surrogates}', "");
    Expect(1, 57343, '\P{^Is_Block=_ Low_Surrogates}', "");
    Expect(0, 57344, '\p{Is_Block=_ Low_Surrogates}', "");
    Expect(1, 57344, '\p{^Is_Block=_ Low_Surrogates}', "");
    Expect(1, 57344, '\P{Is_Block=_ Low_Surrogates}', "");
    Expect(0, 57344, '\P{^Is_Block=_ Low_Surrogates}', "");
    Error('\p{Is_Blk= :=Low_surrogates}');
    Error('\P{Is_Blk= :=Low_surrogates}');
    Expect(1, 57343, '\p{Is_Blk=lowsurrogates}', "");
    Expect(0, 57343, '\p{^Is_Blk=lowsurrogates}', "");
    Expect(0, 57343, '\P{Is_Blk=lowsurrogates}', "");
    Expect(1, 57343, '\P{^Is_Blk=lowsurrogates}', "");
    Expect(0, 57344, '\p{Is_Blk=lowsurrogates}', "");
    Expect(1, 57344, '\p{^Is_Blk=lowsurrogates}', "");
    Expect(1, 57344, '\P{Is_Blk=lowsurrogates}', "");
    Expect(0, 57344, '\P{^Is_Blk=lowsurrogates}', "");
    Expect(1, 57343, '\p{Is_Blk=	Low_surrogates}', "");
    Expect(0, 57343, '\p{^Is_Blk=	Low_surrogates}', "");
    Expect(0, 57343, '\P{Is_Blk=	Low_surrogates}', "");
    Expect(1, 57343, '\P{^Is_Blk=	Low_surrogates}', "");
    Expect(0, 57344, '\p{Is_Blk=	Low_surrogates}', "");
    Expect(1, 57344, '\p{^Is_Blk=	Low_surrogates}', "");
    Expect(1, 57344, '\P{Is_Blk=	Low_surrogates}', "");
    Expect(0, 57344, '\P{^Is_Blk=	Low_surrogates}', "");
    Error('\p{Block= :=LYCIAN}');
    Error('\P{Block= :=LYCIAN}');
    Expect(1, 66207, '\p{Block=:\ALycian\z:}', "");;
    Expect(0, 66208, '\p{Block=:\ALycian\z:}', "");;
    Expect(1, 66207, '\p{Block=lycian}', "");
    Expect(0, 66207, '\p{^Block=lycian}', "");
    Expect(0, 66207, '\P{Block=lycian}', "");
    Expect(1, 66207, '\P{^Block=lycian}', "");
    Expect(0, 66208, '\p{Block=lycian}', "");
    Expect(1, 66208, '\p{^Block=lycian}', "");
    Expect(1, 66208, '\P{Block=lycian}', "");
    Expect(0, 66208, '\P{^Block=lycian}', "");
    Expect(1, 66207, '\p{Block=:\Alycian\z:}', "");;
    Expect(0, 66208, '\p{Block=:\Alycian\z:}', "");;
    Expect(1, 66207, '\p{Block= _Lycian}', "");
    Expect(0, 66207, '\p{^Block= _Lycian}', "");
    Expect(0, 66207, '\P{Block= _Lycian}', "");
    Expect(1, 66207, '\P{^Block= _Lycian}', "");
    Expect(0, 66208, '\p{Block= _Lycian}', "");
    Expect(1, 66208, '\p{^Block= _Lycian}', "");
    Expect(1, 66208, '\P{Block= _Lycian}', "");
    Expect(0, 66208, '\P{^Block= _Lycian}', "");
    Error('\p{Blk=_-lycian/a/}');
    Error('\P{Blk=_-lycian/a/}');
    Expect(1, 66207, '\p{Blk=:\ALycian\z:}', "");;
    Expect(0, 66208, '\p{Blk=:\ALycian\z:}', "");;
    Expect(1, 66207, '\p{Blk=lycian}', "");
    Expect(0, 66207, '\p{^Blk=lycian}', "");
    Expect(0, 66207, '\P{Blk=lycian}', "");
    Expect(1, 66207, '\P{^Blk=lycian}', "");
    Expect(0, 66208, '\p{Blk=lycian}', "");
    Expect(1, 66208, '\p{^Blk=lycian}', "");
    Expect(1, 66208, '\P{Blk=lycian}', "");
    Expect(0, 66208, '\P{^Blk=lycian}', "");
    Expect(1, 66207, '\p{Blk=:\Alycian\z:}', "");;
    Expect(0, 66208, '\p{Blk=:\Alycian\z:}', "");;
    Expect(1, 66207, '\p{Blk= 	Lycian}', "");
    Expect(0, 66207, '\p{^Blk= 	Lycian}', "");
    Expect(0, 66207, '\P{Blk= 	Lycian}', "");
    Expect(1, 66207, '\P{^Blk= 	Lycian}', "");
    Expect(0, 66208, '\p{Blk= 	Lycian}', "");
    Expect(1, 66208, '\p{^Blk= 	Lycian}', "");
    Expect(1, 66208, '\P{Blk= 	Lycian}', "");
    Expect(0, 66208, '\P{^Blk= 	Lycian}', "");
    Error('\p{Is_Block=		Lycian/a/}');
    Error('\P{Is_Block=		Lycian/a/}');
    Expect(1, 66207, '\p{Is_Block=lycian}', "");
    Expect(0, 66207, '\p{^Is_Block=lycian}', "");
    Expect(0, 66207, '\P{Is_Block=lycian}', "");
    Expect(1, 66207, '\P{^Is_Block=lycian}', "");
    Expect(0, 66208, '\p{Is_Block=lycian}', "");
    Expect(1, 66208, '\p{^Is_Block=lycian}', "");
    Expect(1, 66208, '\P{Is_Block=lycian}', "");
    Expect(0, 66208, '\P{^Is_Block=lycian}', "");
    Expect(1, 66207, '\p{Is_Block=	-LYCIAN}', "");
    Expect(0, 66207, '\p{^Is_Block=	-LYCIAN}', "");
    Expect(0, 66207, '\P{Is_Block=	-LYCIAN}', "");
    Expect(1, 66207, '\P{^Is_Block=	-LYCIAN}', "");
    Expect(0, 66208, '\p{Is_Block=	-LYCIAN}', "");
    Expect(1, 66208, '\p{^Is_Block=	-LYCIAN}', "");
    Expect(1, 66208, '\P{Is_Block=	-LYCIAN}', "");
    Expect(0, 66208, '\P{^Is_Block=	-LYCIAN}', "");
    Error('\p{Is_Blk=:=	 lycian}');
    Error('\P{Is_Blk=:=	 lycian}');
    Expect(1, 66207, '\p{Is_Blk=lycian}', "");
    Expect(0, 66207, '\p{^Is_Blk=lycian}', "");
    Expect(0, 66207, '\P{Is_Blk=lycian}', "");
    Expect(1, 66207, '\P{^Is_Blk=lycian}', "");
    Expect(0, 66208, '\p{Is_Blk=lycian}', "");
    Expect(1, 66208, '\p{^Is_Blk=lycian}', "");
    Expect(1, 66208, '\P{Is_Blk=lycian}', "");
    Expect(0, 66208, '\P{^Is_Blk=lycian}', "");
    Expect(1, 66207, '\p{Is_Blk:		lycian}', "");
    Expect(0, 66207, '\p{^Is_Blk:		lycian}', "");
    Expect(0, 66207, '\P{Is_Blk:		lycian}', "");
    Expect(1, 66207, '\P{^Is_Blk:		lycian}', "");
    Expect(0, 66208, '\p{Is_Blk:		lycian}', "");
    Expect(1, 66208, '\p{^Is_Blk:		lycian}', "");
    Expect(1, 66208, '\P{Is_Blk:		lycian}', "");
    Expect(0, 66208, '\P{^Is_Blk:		lycian}', "");
    Error('\p{Block= /a/LYDIAN}');
    Error('\P{Block= /a/LYDIAN}');
    Expect(1, 67903, '\p{Block=:\ALydian\z:}', "");;
    Expect(0, 67904, '\p{Block=:\ALydian\z:}', "");;
    Expect(1, 67903, '\p{Block=lydian}', "");
    Expect(0, 67903, '\p{^Block=lydian}', "");
    Expect(0, 67903, '\P{Block=lydian}', "");
    Expect(1, 67903, '\P{^Block=lydian}', "");
    Expect(0, 67904, '\p{Block=lydian}', "");
    Expect(1, 67904, '\p{^Block=lydian}', "");
    Expect(1, 67904, '\P{Block=lydian}', "");
    Expect(0, 67904, '\P{^Block=lydian}', "");
    Expect(1, 67903, '\p{Block=:\Alydian\z:}', "");;
    Expect(0, 67904, '\p{Block=:\Alydian\z:}', "");;
    Expect(1, 67903, '\p{Block= -Lydian}', "");
    Expect(0, 67903, '\p{^Block= -Lydian}', "");
    Expect(0, 67903, '\P{Block= -Lydian}', "");
    Expect(1, 67903, '\P{^Block= -Lydian}', "");
    Expect(0, 67904, '\p{Block= -Lydian}', "");
    Expect(1, 67904, '\p{^Block= -Lydian}', "");
    Expect(1, 67904, '\P{Block= -Lydian}', "");
    Expect(0, 67904, '\P{^Block= -Lydian}', "");
    Error('\p{Blk=/a/Lydian}');
    Error('\P{Blk=/a/Lydian}');
    Expect(1, 67903, '\p{Blk=:\ALydian\z:}', "");;
    Expect(0, 67904, '\p{Blk=:\ALydian\z:}', "");;
    Expect(1, 67903, '\p{Blk=lydian}', "");
    Expect(0, 67903, '\p{^Blk=lydian}', "");
    Expect(0, 67903, '\P{Blk=lydian}', "");
    Expect(1, 67903, '\P{^Blk=lydian}', "");
    Expect(0, 67904, '\p{Blk=lydian}', "");
    Expect(1, 67904, '\p{^Blk=lydian}', "");
    Expect(1, 67904, '\P{Blk=lydian}', "");
    Expect(0, 67904, '\P{^Blk=lydian}', "");
    Expect(1, 67903, '\p{Blk=:\Alydian\z:}', "");;
    Expect(0, 67904, '\p{Blk=:\Alydian\z:}', "");;
    Expect(1, 67903, '\p{Blk=--LYDIAN}', "");
    Expect(0, 67903, '\p{^Blk=--LYDIAN}', "");
    Expect(0, 67903, '\P{Blk=--LYDIAN}', "");
    Expect(1, 67903, '\P{^Blk=--LYDIAN}', "");
    Expect(0, 67904, '\p{Blk=--LYDIAN}', "");
    Expect(1, 67904, '\p{^Blk=--LYDIAN}', "");
    Expect(1, 67904, '\P{Blk=--LYDIAN}', "");
    Expect(0, 67904, '\P{^Blk=--LYDIAN}', "");
    Error('\p{Is_Block=/a/ Lydian}');
    Error('\P{Is_Block=/a/ Lydian}');
    Expect(1, 67903, '\p{Is_Block=lydian}', "");
    Expect(0, 67903, '\p{^Is_Block=lydian}', "");
    Expect(0, 67903, '\P{Is_Block=lydian}', "");
    Expect(1, 67903, '\P{^Is_Block=lydian}', "");
    Expect(0, 67904, '\p{Is_Block=lydian}', "");
    Expect(1, 67904, '\p{^Is_Block=lydian}', "");
    Expect(1, 67904, '\P{Is_Block=lydian}', "");
    Expect(0, 67904, '\P{^Is_Block=lydian}', "");
    Expect(1, 67903, '\p{Is_Block=	-LYDIAN}', "");
    Expect(0, 67903, '\p{^Is_Block=	-LYDIAN}', "");
    Expect(0, 67903, '\P{Is_Block=	-LYDIAN}', "");
    Expect(1, 67903, '\P{^Is_Block=	-LYDIAN}', "");
    Expect(0, 67904, '\p{Is_Block=	-LYDIAN}', "");
    Expect(1, 67904, '\p{^Is_Block=	-LYDIAN}', "");
    Expect(1, 67904, '\P{Is_Block=	-LYDIAN}', "");
    Expect(0, 67904, '\P{^Is_Block=	-LYDIAN}', "");
    Error('\p{Is_Blk=:= 	Lydian}');
    Error('\P{Is_Blk=:= 	Lydian}');
    Expect(1, 67903, '\p{Is_Blk=lydian}', "");
    Expect(0, 67903, '\p{^Is_Blk=lydian}', "");
    Expect(0, 67903, '\P{Is_Blk=lydian}', "");
    Expect(1, 67903, '\P{^Is_Blk=lydian}', "");
    Expect(0, 67904, '\p{Is_Blk=lydian}', "");
    Expect(1, 67904, '\p{^Is_Blk=lydian}', "");
    Expect(1, 67904, '\P{Is_Blk=lydian}', "");
    Expect(0, 67904, '\P{^Is_Blk=lydian}', "");
    Expect(1, 67903, '\p{Is_Blk=-Lydian}', "");
    Expect(0, 67903, '\p{^Is_Blk=-Lydian}', "");
    Expect(0, 67903, '\P{Is_Blk=-Lydian}', "");
    Expect(1, 67903, '\P{^Is_Blk=-Lydian}', "");
    Expect(0, 67904, '\p{Is_Blk=-Lydian}', "");
    Expect(1, 67904, '\p{^Is_Blk=-Lydian}', "");
    Expect(1, 67904, '\P{Is_Blk=-Lydian}', "");
    Expect(0, 67904, '\P{^Is_Blk=-Lydian}', "");
    Error('\p{Block= -Mahajani/a/}');
    Error('\P{Block= -Mahajani/a/}');
    Expect(1, 70015, '\p{Block=:\AMahajani\z:}', "");;
    Expect(0, 70016, '\p{Block=:\AMahajani\z:}', "");;
    Expect(1, 70015, '\p{Block=mahajani}', "");
    Expect(0, 70015, '\p{^Block=mahajani}', "");
    Expect(0, 70015, '\P{Block=mahajani}', "");
    Expect(1, 70015, '\P{^Block=mahajani}', "");
    Expect(0, 70016, '\p{Block=mahajani}', "");
    Expect(1, 70016, '\p{^Block=mahajani}', "");
    Expect(1, 70016, '\P{Block=mahajani}', "");
    Expect(0, 70016, '\P{^Block=mahajani}', "");
    Expect(1, 70015, '\p{Block=:\Amahajani\z:}', "");;
    Expect(0, 70016, '\p{Block=:\Amahajani\z:}', "");;
    Expect(1, 70015, '\p{Block= Mahajani}', "");
    Expect(0, 70015, '\p{^Block= Mahajani}', "");
    Expect(0, 70015, '\P{Block= Mahajani}', "");
    Expect(1, 70015, '\P{^Block= Mahajani}', "");
    Expect(0, 70016, '\p{Block= Mahajani}', "");
    Expect(1, 70016, '\p{^Block= Mahajani}', "");
    Expect(1, 70016, '\P{Block= Mahajani}', "");
    Expect(0, 70016, '\P{^Block= Mahajani}', "");
    Error('\p{Blk=_:=Mahajani}');
    Error('\P{Blk=_:=Mahajani}');
    Expect(1, 70015, '\p{Blk=:\AMahajani\z:}', "");;
    Expect(0, 70016, '\p{Blk=:\AMahajani\z:}', "");;
    Expect(1, 70015, '\p{Blk=mahajani}', "");
    Expect(0, 70015, '\p{^Blk=mahajani}', "");
    Expect(0, 70015, '\P{Blk=mahajani}', "");
    Expect(1, 70015, '\P{^Blk=mahajani}', "");
    Expect(0, 70016, '\p{Blk=mahajani}', "");
    Expect(1, 70016, '\p{^Blk=mahajani}', "");
    Expect(1, 70016, '\P{Blk=mahajani}', "");
    Expect(0, 70016, '\P{^Blk=mahajani}', "");
    Expect(1, 70015, '\p{Blk=:\Amahajani\z:}', "");;
    Expect(0, 70016, '\p{Blk=:\Amahajani\z:}', "");;
    Expect(1, 70015, '\p{Blk=- MAHAJANI}', "");
    Expect(0, 70015, '\p{^Blk=- MAHAJANI}', "");
    Expect(0, 70015, '\P{Blk=- MAHAJANI}', "");
    Expect(1, 70015, '\P{^Blk=- MAHAJANI}', "");
    Expect(0, 70016, '\p{Blk=- MAHAJANI}', "");
    Expect(1, 70016, '\p{^Blk=- MAHAJANI}', "");
    Expect(1, 70016, '\P{Blk=- MAHAJANI}', "");
    Expect(0, 70016, '\P{^Blk=- MAHAJANI}', "");
    Error('\p{Is_Block=/a/ Mahajani}');
    Error('\P{Is_Block=/a/ Mahajani}');
    Expect(1, 70015, '\p{Is_Block=mahajani}', "");
    Expect(0, 70015, '\p{^Is_Block=mahajani}', "");
    Expect(0, 70015, '\P{Is_Block=mahajani}', "");
    Expect(1, 70015, '\P{^Is_Block=mahajani}', "");
    Expect(0, 70016, '\p{Is_Block=mahajani}', "");
    Expect(1, 70016, '\p{^Is_Block=mahajani}', "");
    Expect(1, 70016, '\P{Is_Block=mahajani}', "");
    Expect(0, 70016, '\P{^Is_Block=mahajani}', "");
    Expect(1, 70015, '\p{Is_Block=_ mahajani}', "");
    Expect(0, 70015, '\p{^Is_Block=_ mahajani}', "");
    Expect(0, 70015, '\P{Is_Block=_ mahajani}', "");
    Expect(1, 70015, '\P{^Is_Block=_ mahajani}', "");
    Expect(0, 70016, '\p{Is_Block=_ mahajani}', "");
    Expect(1, 70016, '\p{^Is_Block=_ mahajani}', "");
    Expect(1, 70016, '\P{Is_Block=_ mahajani}', "");
    Expect(0, 70016, '\P{^Is_Block=_ mahajani}', "");
    Error('\p{Is_Blk:    :=Mahajani}');
    Error('\P{Is_Blk:    :=Mahajani}');
    Expect(1, 70015, '\p{Is_Blk:	mahajani}', "");
    Expect(0, 70015, '\p{^Is_Blk:	mahajani}', "");
    Expect(0, 70015, '\P{Is_Blk:	mahajani}', "");
    Expect(1, 70015, '\P{^Is_Blk:	mahajani}', "");
    Expect(0, 70016, '\p{Is_Blk:	mahajani}', "");
    Expect(1, 70016, '\p{^Is_Blk:	mahajani}', "");
    Expect(1, 70016, '\P{Is_Blk:	mahajani}', "");
    Expect(0, 70016, '\P{^Is_Blk:	mahajani}', "");
    Expect(1, 70015, '\p{Is_Blk= -mahajani}', "");
    Expect(0, 70015, '\p{^Is_Blk= -mahajani}', "");
    Expect(0, 70015, '\P{Is_Blk= -mahajani}', "");
    Expect(1, 70015, '\P{^Is_Blk= -mahajani}', "");
    Expect(0, 70016, '\p{Is_Blk= -mahajani}', "");
    Expect(1, 70016, '\p{^Is_Blk= -mahajani}', "");
    Expect(1, 70016, '\P{Is_Blk= -mahajani}', "");
    Expect(0, 70016, '\P{^Is_Blk= -mahajani}', "");
    Error('\p{Block:   -mahjong_Tiles:=}');
    Error('\P{Block:   -mahjong_Tiles:=}');
    Expect(1, 127023, '\p{Block=:\AMahjong_Tiles\z:}', "");;
    Expect(0, 127024, '\p{Block=:\AMahjong_Tiles\z:}', "");;
    Expect(1, 127023, '\p{Block=mahjongtiles}', "");
    Expect(0, 127023, '\p{^Block=mahjongtiles}', "");
    Expect(0, 127023, '\P{Block=mahjongtiles}', "");
    Expect(1, 127023, '\P{^Block=mahjongtiles}', "");
    Expect(0, 127024, '\p{Block=mahjongtiles}', "");
    Expect(1, 127024, '\p{^Block=mahjongtiles}', "");
    Expect(1, 127024, '\P{Block=mahjongtiles}', "");
    Expect(0, 127024, '\P{^Block=mahjongtiles}', "");
    Expect(1, 127023, '\p{Block=:\Amahjongtiles\z:}', "");;
    Expect(0, 127024, '\p{Block=:\Amahjongtiles\z:}', "");;
    Expect(1, 127023, '\p{Block=	-mahjong_TILES}', "");
    Expect(0, 127023, '\p{^Block=	-mahjong_TILES}', "");
    Expect(0, 127023, '\P{Block=	-mahjong_TILES}', "");
    Expect(1, 127023, '\P{^Block=	-mahjong_TILES}', "");
    Expect(0, 127024, '\p{Block=	-mahjong_TILES}', "");
    Expect(1, 127024, '\p{^Block=	-mahjong_TILES}', "");
    Expect(1, 127024, '\P{Block=	-mahjong_TILES}', "");
    Expect(0, 127024, '\P{^Block=	-mahjong_TILES}', "");
    Error('\p{Blk=_:=mahjong}');
    Error('\P{Blk=_:=mahjong}');
    Expect(1, 127023, '\p{Blk=:\AMahjong\z:}', "");;
    Expect(0, 127024, '\p{Blk=:\AMahjong\z:}', "");;
    Expect(1, 127023, '\p{Blk=mahjong}', "");
    Expect(0, 127023, '\p{^Blk=mahjong}', "");
    Expect(0, 127023, '\P{Blk=mahjong}', "");
    Expect(1, 127023, '\P{^Blk=mahjong}', "");
    Expect(0, 127024, '\p{Blk=mahjong}', "");
    Expect(1, 127024, '\p{^Blk=mahjong}', "");
    Expect(1, 127024, '\P{Blk=mahjong}', "");
    Expect(0, 127024, '\P{^Blk=mahjong}', "");
    Expect(1, 127023, '\p{Blk=:\Amahjong\z:}', "");;
    Expect(0, 127024, '\p{Blk=:\Amahjong\z:}', "");;
    Expect(1, 127023, '\p{Blk=_Mahjong}', "");
    Expect(0, 127023, '\p{^Blk=_Mahjong}', "");
    Expect(0, 127023, '\P{Blk=_Mahjong}', "");
    Expect(1, 127023, '\P{^Blk=_Mahjong}', "");
    Expect(0, 127024, '\p{Blk=_Mahjong}', "");
    Expect(1, 127024, '\p{^Blk=_Mahjong}', "");
    Expect(1, 127024, '\P{Blk=_Mahjong}', "");
    Expect(0, 127024, '\P{^Blk=_Mahjong}', "");
    Error('\p{Is_Block=_ Mahjong_Tiles/a/}');
    Error('\P{Is_Block=_ Mahjong_Tiles/a/}');
    Expect(1, 127023, '\p{Is_Block=mahjongtiles}', "");
    Expect(0, 127023, '\p{^Is_Block=mahjongtiles}', "");
    Expect(0, 127023, '\P{Is_Block=mahjongtiles}', "");
    Expect(1, 127023, '\P{^Is_Block=mahjongtiles}', "");
    Expect(0, 127024, '\p{Is_Block=mahjongtiles}', "");
    Expect(1, 127024, '\p{^Is_Block=mahjongtiles}', "");
    Expect(1, 127024, '\P{Is_Block=mahjongtiles}', "");
    Expect(0, 127024, '\P{^Is_Block=mahjongtiles}', "");
    Expect(1, 127023, '\p{Is_Block=-_MAHJONG_Tiles}', "");
    Expect(0, 127023, '\p{^Is_Block=-_MAHJONG_Tiles}', "");
    Expect(0, 127023, '\P{Is_Block=-_MAHJONG_Tiles}', "");
    Expect(1, 127023, '\P{^Is_Block=-_MAHJONG_Tiles}', "");
    Expect(0, 127024, '\p{Is_Block=-_MAHJONG_Tiles}', "");
    Expect(1, 127024, '\p{^Is_Block=-_MAHJONG_Tiles}', "");
    Expect(1, 127024, '\P{Is_Block=-_MAHJONG_Tiles}', "");
    Expect(0, 127024, '\P{^Is_Block=-_MAHJONG_Tiles}', "");
    Error('\p{Is_Blk=/a/-	Mahjong}');
    Error('\P{Is_Blk=/a/-	Mahjong}');
    Expect(1, 127023, '\p{Is_Blk=mahjong}', "");
    Expect(0, 127023, '\p{^Is_Blk=mahjong}', "");
    Expect(0, 127023, '\P{Is_Blk=mahjong}', "");
    Expect(1, 127023, '\P{^Is_Blk=mahjong}', "");
    Expect(0, 127024, '\p{Is_Blk=mahjong}', "");
    Expect(1, 127024, '\p{^Is_Blk=mahjong}', "");
    Expect(1, 127024, '\P{Is_Blk=mahjong}', "");
    Expect(0, 127024, '\P{^Is_Blk=mahjong}', "");
    Expect(1, 127023, '\p{Is_Blk:-_Mahjong}', "");
    Expect(0, 127023, '\p{^Is_Blk:-_Mahjong}', "");
    Expect(0, 127023, '\P{Is_Blk:-_Mahjong}', "");
    Expect(1, 127023, '\P{^Is_Blk:-_Mahjong}', "");
    Expect(0, 127024, '\p{Is_Blk:-_Mahjong}', "");
    Expect(1, 127024, '\p{^Is_Blk:-_Mahjong}', "");
    Expect(1, 127024, '\P{Is_Blk:-_Mahjong}', "");
    Expect(0, 127024, '\P{^Is_Blk:-_Mahjong}', "");
    Error('\p{Block=:=-	makasar}');
    Error('\P{Block=:=-	makasar}');
    Expect(1, 73471, '\p{Block=:\AMakasar\z:}', "");;
    Expect(0, 73472, '\p{Block=:\AMakasar\z:}', "");;
    Expect(1, 73471, '\p{Block=makasar}', "");
    Expect(0, 73471, '\p{^Block=makasar}', "");
    Expect(0, 73471, '\P{Block=makasar}', "");
    Expect(1, 73471, '\P{^Block=makasar}', "");
    Expect(0, 73472, '\p{Block=makasar}', "");
    Expect(1, 73472, '\p{^Block=makasar}', "");
    Expect(1, 73472, '\P{Block=makasar}', "");
    Expect(0, 73472, '\P{^Block=makasar}', "");
    Expect(1, 73471, '\p{Block=:\Amakasar\z:}', "");;
    Expect(0, 73472, '\p{Block=:\Amakasar\z:}', "");;
    Expect(1, 73471, '\p{Block=	Makasar}', "");
    Expect(0, 73471, '\p{^Block=	Makasar}', "");
    Expect(0, 73471, '\P{Block=	Makasar}', "");
    Expect(1, 73471, '\P{^Block=	Makasar}', "");
    Expect(0, 73472, '\p{Block=	Makasar}', "");
    Expect(1, 73472, '\p{^Block=	Makasar}', "");
    Expect(1, 73472, '\P{Block=	Makasar}', "");
    Expect(0, 73472, '\P{^Block=	Makasar}', "");
    Error('\p{Blk=/a/ 	MAKASAR}');
    Error('\P{Blk=/a/ 	MAKASAR}');
    Expect(1, 73471, '\p{Blk=:\AMakasar\z:}', "");;
    Expect(0, 73472, '\p{Blk=:\AMakasar\z:}', "");;
    Expect(1, 73471, '\p{Blk:makasar}', "");
    Expect(0, 73471, '\p{^Blk:makasar}', "");
    Expect(0, 73471, '\P{Blk:makasar}', "");
    Expect(1, 73471, '\P{^Blk:makasar}', "");
    Expect(0, 73472, '\p{Blk:makasar}', "");
    Expect(1, 73472, '\p{^Blk:makasar}', "");
    Expect(1, 73472, '\P{Blk:makasar}', "");
    Expect(0, 73472, '\P{^Blk:makasar}', "");
    Expect(1, 73471, '\p{Blk=:\Amakasar\z:}', "");;
    Expect(0, 73472, '\p{Blk=:\Amakasar\z:}', "");;
    Expect(1, 73471, '\p{Blk=_ makasar}', "");
    Expect(0, 73471, '\p{^Blk=_ makasar}', "");
    Expect(0, 73471, '\P{Blk=_ makasar}', "");
    Expect(1, 73471, '\P{^Blk=_ makasar}', "");
    Expect(0, 73472, '\p{Blk=_ makasar}', "");
    Expect(1, 73472, '\p{^Blk=_ makasar}', "");
    Expect(1, 73472, '\P{Blk=_ makasar}', "");
    Expect(0, 73472, '\P{^Blk=_ makasar}', "");
    Error('\p{Is_Block=/a/_-MAKASAR}');
    Error('\P{Is_Block=/a/_-MAKASAR}');
    Expect(1, 73471, '\p{Is_Block=makasar}', "");
    Expect(0, 73471, '\p{^Is_Block=makasar}', "");
    Expect(0, 73471, '\P{Is_Block=makasar}', "");
    Expect(1, 73471, '\P{^Is_Block=makasar}', "");
    Expect(0, 73472, '\p{Is_Block=makasar}', "");
    Expect(1, 73472, '\p{^Is_Block=makasar}', "");
    Expect(1, 73472, '\P{Is_Block=makasar}', "");
    Expect(0, 73472, '\P{^Is_Block=makasar}', "");
    Expect(1, 73471, '\p{Is_Block=_-Makasar}', "");
    Expect(0, 73471, '\p{^Is_Block=_-Makasar}', "");
    Expect(0, 73471, '\P{Is_Block=_-Makasar}', "");
    Expect(1, 73471, '\P{^Is_Block=_-Makasar}', "");
    Expect(0, 73472, '\p{Is_Block=_-Makasar}', "");
    Expect(1, 73472, '\p{^Is_Block=_-Makasar}', "");
    Expect(1, 73472, '\P{Is_Block=_-Makasar}', "");
    Expect(0, 73472, '\P{^Is_Block=_-Makasar}', "");
    Error('\p{Is_Blk=_makasar:=}');
    Error('\P{Is_Blk=_makasar:=}');
    Expect(1, 73471, '\p{Is_Blk=makasar}', "");
    Expect(0, 73471, '\p{^Is_Blk=makasar}', "");
    Expect(0, 73471, '\P{Is_Blk=makasar}', "");
    Expect(1, 73471, '\P{^Is_Blk=makasar}', "");
    Expect(0, 73472, '\p{Is_Blk=makasar}', "");
    Expect(1, 73472, '\p{^Is_Blk=makasar}', "");
    Expect(1, 73472, '\P{Is_Blk=makasar}', "");
    Expect(0, 73472, '\P{^Is_Blk=makasar}', "");
    Expect(1, 73471, '\p{Is_Blk:   -_MAKASAR}', "");
    Expect(0, 73471, '\p{^Is_Blk:   -_MAKASAR}', "");
    Expect(0, 73471, '\P{Is_Blk:   -_MAKASAR}', "");
    Expect(1, 73471, '\P{^Is_Blk:   -_MAKASAR}', "");
    Expect(0, 73472, '\p{Is_Blk:   -_MAKASAR}', "");
    Expect(1, 73472, '\p{^Is_Blk:   -_MAKASAR}', "");
    Expect(1, 73472, '\P{Is_Blk:   -_MAKASAR}', "");
    Expect(0, 73472, '\P{^Is_Blk:   -_MAKASAR}', "");
    Error('\p{Block=_Malayalam/a/}');
    Error('\P{Block=_Malayalam/a/}');
    Expect(1, 3455, '\p{Block=:\AMalayalam\z:}', "");;
    Expect(0, 3456, '\p{Block=:\AMalayalam\z:}', "");;
    Expect(1, 3455, '\p{Block=malayalam}', "");
    Expect(0, 3455, '\p{^Block=malayalam}', "");
    Expect(0, 3455, '\P{Block=malayalam}', "");
    Expect(1, 3455, '\P{^Block=malayalam}', "");
    Expect(0, 3456, '\p{Block=malayalam}', "");
    Expect(1, 3456, '\p{^Block=malayalam}', "");
    Expect(1, 3456, '\P{Block=malayalam}', "");
    Expect(0, 3456, '\P{^Block=malayalam}', "");
    Expect(1, 3455, '\p{Block=:\Amalayalam\z:}', "");;
    Expect(0, 3456, '\p{Block=:\Amalayalam\z:}', "");;
    Expect(1, 3455, '\p{Block=- MALAYALAM}', "");
    Expect(0, 3455, '\p{^Block=- MALAYALAM}', "");
    Expect(0, 3455, '\P{Block=- MALAYALAM}', "");
    Expect(1, 3455, '\P{^Block=- MALAYALAM}', "");
    Expect(0, 3456, '\p{Block=- MALAYALAM}', "");
    Expect(1, 3456, '\p{^Block=- MALAYALAM}', "");
    Expect(1, 3456, '\P{Block=- MALAYALAM}', "");
    Expect(0, 3456, '\P{^Block=- MALAYALAM}', "");
    Error('\p{Blk=	_malayalam/a/}');
    Error('\P{Blk=	_malayalam/a/}');
    Expect(1, 3455, '\p{Blk=:\AMalayalam\z:}', "");;
    Expect(0, 3456, '\p{Blk=:\AMalayalam\z:}', "");;
    Expect(1, 3455, '\p{Blk=malayalam}', "");
    Expect(0, 3455, '\p{^Blk=malayalam}', "");
    Expect(0, 3455, '\P{Blk=malayalam}', "");
    Expect(1, 3455, '\P{^Blk=malayalam}', "");
    Expect(0, 3456, '\p{Blk=malayalam}', "");
    Expect(1, 3456, '\p{^Blk=malayalam}', "");
    Expect(1, 3456, '\P{Blk=malayalam}', "");
    Expect(0, 3456, '\P{^Blk=malayalam}', "");
    Expect(1, 3455, '\p{Blk=:\Amalayalam\z:}', "");;
    Expect(0, 3456, '\p{Blk=:\Amalayalam\z:}', "");;
    Expect(1, 3455, '\p{Blk=-	MALAYALAM}', "");
    Expect(0, 3455, '\p{^Blk=-	MALAYALAM}', "");
    Expect(0, 3455, '\P{Blk=-	MALAYALAM}', "");
    Expect(1, 3455, '\P{^Blk=-	MALAYALAM}', "");
    Expect(0, 3456, '\p{Blk=-	MALAYALAM}', "");
    Expect(1, 3456, '\p{^Blk=-	MALAYALAM}', "");
    Expect(1, 3456, '\P{Blk=-	MALAYALAM}', "");
    Expect(0, 3456, '\P{^Blk=-	MALAYALAM}', "");
    Error('\p{Is_Block=__malayalam/a/}');
    Error('\P{Is_Block=__malayalam/a/}');
    Expect(1, 3455, '\p{Is_Block: malayalam}', "");
    Expect(0, 3455, '\p{^Is_Block: malayalam}', "");
    Expect(0, 3455, '\P{Is_Block: malayalam}', "");
    Expect(1, 3455, '\P{^Is_Block: malayalam}', "");
    Expect(0, 3456, '\p{Is_Block: malayalam}', "");
    Expect(1, 3456, '\p{^Is_Block: malayalam}', "");
    Expect(1, 3456, '\P{Is_Block: malayalam}', "");
    Expect(0, 3456, '\P{^Is_Block: malayalam}', "");
    Expect(1, 3455, '\p{Is_Block=_Malayalam}', "");
    Expect(0, 3455, '\p{^Is_Block=_Malayalam}', "");
    Expect(0, 3455, '\P{Is_Block=_Malayalam}', "");
    Expect(1, 3455, '\P{^Is_Block=_Malayalam}', "");
    Expect(0, 3456, '\p{Is_Block=_Malayalam}', "");
    Expect(1, 3456, '\p{^Is_Block=_Malayalam}', "");
    Expect(1, 3456, '\P{Is_Block=_Malayalam}', "");
    Expect(0, 3456, '\P{^Is_Block=_Malayalam}', "");
    Error('\p{Is_Blk=	:=malayalam}');
    Error('\P{Is_Blk=	:=malayalam}');
    Expect(1, 3455, '\p{Is_Blk=malayalam}', "");
    Expect(0, 3455, '\p{^Is_Blk=malayalam}', "");
    Expect(0, 3455, '\P{Is_Blk=malayalam}', "");
    Expect(1, 3455, '\P{^Is_Blk=malayalam}', "");
    Expect(0, 3456, '\p{Is_Blk=malayalam}', "");
    Expect(1, 3456, '\p{^Is_Blk=malayalam}', "");
    Expect(1, 3456, '\P{Is_Blk=malayalam}', "");
    Expect(0, 3456, '\P{^Is_Blk=malayalam}', "");
    Expect(1, 3455, '\p{Is_Blk: Malayalam}', "");
    Expect(0, 3455, '\p{^Is_Blk: Malayalam}', "");
    Expect(0, 3455, '\P{Is_Blk: Malayalam}', "");
    Expect(1, 3455, '\P{^Is_Blk: Malayalam}', "");
    Expect(0, 3456, '\p{Is_Blk: Malayalam}', "");
    Expect(1, 3456, '\p{^Is_Blk: Malayalam}', "");
    Expect(1, 3456, '\P{Is_Blk: Malayalam}', "");
    Expect(0, 3456, '\P{^Is_Blk: Malayalam}', "");
    Error('\p{Block=:=-Mandaic}');
    Error('\P{Block=:=-Mandaic}');
    Expect(1, 2143, '\p{Block=:\AMandaic\z:}', "");;
    Expect(0, 2144, '\p{Block=:\AMandaic\z:}', "");;
    Expect(1, 2143, '\p{Block=mandaic}', "");
    Expect(0, 2143, '\p{^Block=mandaic}', "");
    Expect(0, 2143, '\P{Block=mandaic}', "");
    Expect(1, 2143, '\P{^Block=mandaic}', "");
    Expect(0, 2144, '\p{Block=mandaic}', "");
    Expect(1, 2144, '\p{^Block=mandaic}', "");
    Expect(1, 2144, '\P{Block=mandaic}', "");
    Expect(0, 2144, '\P{^Block=mandaic}', "");
    Expect(1, 2143, '\p{Block=:\Amandaic\z:}', "");;
    Expect(0, 2144, '\p{Block=:\Amandaic\z:}', "");;
    Expect(1, 2143, '\p{Block=-_Mandaic}', "");
    Expect(0, 2143, '\p{^Block=-_Mandaic}', "");
    Expect(0, 2143, '\P{Block=-_Mandaic}', "");
    Expect(1, 2143, '\P{^Block=-_Mandaic}', "");
    Expect(0, 2144, '\p{Block=-_Mandaic}', "");
    Expect(1, 2144, '\p{^Block=-_Mandaic}', "");
    Expect(1, 2144, '\P{Block=-_Mandaic}', "");
    Expect(0, 2144, '\P{^Block=-_Mandaic}', "");
    Error('\p{Blk=/a/__Mandaic}');
    Error('\P{Blk=/a/__Mandaic}');
    Expect(1, 2143, '\p{Blk=:\AMandaic\z:}', "");;
    Expect(0, 2144, '\p{Blk=:\AMandaic\z:}', "");;
    Expect(1, 2143, '\p{Blk=mandaic}', "");
    Expect(0, 2143, '\p{^Blk=mandaic}', "");
    Expect(0, 2143, '\P{Blk=mandaic}', "");
    Expect(1, 2143, '\P{^Blk=mandaic}', "");
    Expect(0, 2144, '\p{Blk=mandaic}', "");
    Expect(1, 2144, '\p{^Blk=mandaic}', "");
    Expect(1, 2144, '\P{Blk=mandaic}', "");
    Expect(0, 2144, '\P{^Blk=mandaic}', "");
    Expect(1, 2143, '\p{Blk=:\Amandaic\z:}', "");;
    Expect(0, 2144, '\p{Blk=:\Amandaic\z:}', "");;
    Expect(1, 2143, '\p{Blk=_MANDAIC}', "");
    Expect(0, 2143, '\p{^Blk=_MANDAIC}', "");
    Expect(0, 2143, '\P{Blk=_MANDAIC}', "");
    Expect(1, 2143, '\P{^Blk=_MANDAIC}', "");
    Expect(0, 2144, '\p{Blk=_MANDAIC}', "");
    Expect(1, 2144, '\p{^Blk=_MANDAIC}', "");
    Expect(1, 2144, '\P{Blk=_MANDAIC}', "");
    Expect(0, 2144, '\P{^Blk=_MANDAIC}', "");
    Error('\p{Is_Block:  /a/Mandaic}');
    Error('\P{Is_Block:  /a/Mandaic}');
    Expect(1, 2143, '\p{Is_Block=mandaic}', "");
    Expect(0, 2143, '\p{^Is_Block=mandaic}', "");
    Expect(0, 2143, '\P{Is_Block=mandaic}', "");
    Expect(1, 2143, '\P{^Is_Block=mandaic}', "");
    Expect(0, 2144, '\p{Is_Block=mandaic}', "");
    Expect(1, 2144, '\p{^Is_Block=mandaic}', "");
    Expect(1, 2144, '\P{Is_Block=mandaic}', "");
    Expect(0, 2144, '\P{^Is_Block=mandaic}', "");
    Expect(1, 2143, '\p{Is_Block:  Mandaic}', "");
    Expect(0, 2143, '\p{^Is_Block:  Mandaic}', "");
    Expect(0, 2143, '\P{Is_Block:  Mandaic}', "");
    Expect(1, 2143, '\P{^Is_Block:  Mandaic}', "");
    Expect(0, 2144, '\p{Is_Block:  Mandaic}', "");
    Expect(1, 2144, '\p{^Is_Block:  Mandaic}', "");
    Expect(1, 2144, '\P{Is_Block:  Mandaic}', "");
    Expect(0, 2144, '\P{^Is_Block:  Mandaic}', "");
    Error('\p{Is_Blk=		Mandaic:=}');
    Error('\P{Is_Blk=		Mandaic:=}');
    Expect(1, 2143, '\p{Is_Blk=mandaic}', "");
    Expect(0, 2143, '\p{^Is_Blk=mandaic}', "");
    Expect(0, 2143, '\P{Is_Blk=mandaic}', "");
    Expect(1, 2143, '\P{^Is_Blk=mandaic}', "");
    Expect(0, 2144, '\p{Is_Blk=mandaic}', "");
    Expect(1, 2144, '\p{^Is_Blk=mandaic}', "");
    Expect(1, 2144, '\P{Is_Blk=mandaic}', "");
    Expect(0, 2144, '\P{^Is_Blk=mandaic}', "");
    Expect(1, 2143, '\p{Is_Blk= Mandaic}', "");
    Expect(0, 2143, '\p{^Is_Blk= Mandaic}', "");
    Expect(0, 2143, '\P{Is_Blk= Mandaic}', "");
    Expect(1, 2143, '\P{^Is_Blk= Mandaic}', "");
    Expect(0, 2144, '\p{Is_Blk= Mandaic}', "");
    Expect(1, 2144, '\p{^Is_Blk= Mandaic}', "");
    Expect(1, 2144, '\P{Is_Blk= Mandaic}', "");
    Expect(0, 2144, '\P{^Is_Blk= Mandaic}', "");
    Error('\p{Block=/a/	_MANICHAEAN}');
    Error('\P{Block=/a/	_MANICHAEAN}');
    Expect(1, 68351, '\p{Block=:\AManichaean\z:}', "");;
    Expect(0, 68352, '\p{Block=:\AManichaean\z:}', "");;
    Expect(1, 68351, '\p{Block=manichaean}', "");
    Expect(0, 68351, '\p{^Block=manichaean}', "");
    Expect(0, 68351, '\P{Block=manichaean}', "");
    Expect(1, 68351, '\P{^Block=manichaean}', "");
    Expect(0, 68352, '\p{Block=manichaean}', "");
    Expect(1, 68352, '\p{^Block=manichaean}', "");
    Expect(1, 68352, '\P{Block=manichaean}', "");
    Expect(0, 68352, '\P{^Block=manichaean}', "");
    Expect(1, 68351, '\p{Block=:\Amanichaean\z:}', "");;
    Expect(0, 68352, '\p{Block=:\Amanichaean\z:}', "");;
    Expect(1, 68351, '\p{Block=_Manichaean}', "");
    Expect(0, 68351, '\p{^Block=_Manichaean}', "");
    Expect(0, 68351, '\P{Block=_Manichaean}', "");
    Expect(1, 68351, '\P{^Block=_Manichaean}', "");
    Expect(0, 68352, '\p{Block=_Manichaean}', "");
    Expect(1, 68352, '\p{^Block=_Manichaean}', "");
    Expect(1, 68352, '\P{Block=_Manichaean}', "");
    Expect(0, 68352, '\P{^Block=_Manichaean}', "");
    Error('\p{Blk=--Manichaean:=}');
    Error('\P{Blk=--Manichaean:=}');
    Expect(1, 68351, '\p{Blk=:\AManichaean\z:}', "");;
    Expect(0, 68352, '\p{Blk=:\AManichaean\z:}', "");;
    Expect(1, 68351, '\p{Blk=manichaean}', "");
    Expect(0, 68351, '\p{^Blk=manichaean}', "");
    Expect(0, 68351, '\P{Blk=manichaean}', "");
    Expect(1, 68351, '\P{^Blk=manichaean}', "");
    Expect(0, 68352, '\p{Blk=manichaean}', "");
    Expect(1, 68352, '\p{^Blk=manichaean}', "");
    Expect(1, 68352, '\P{Blk=manichaean}', "");
    Expect(0, 68352, '\P{^Blk=manichaean}', "");
    Expect(1, 68351, '\p{Blk=:\Amanichaean\z:}', "");;
    Expect(0, 68352, '\p{Blk=:\Amanichaean\z:}', "");;
    Expect(1, 68351, '\p{Blk=-	Manichaean}', "");
    Expect(0, 68351, '\p{^Blk=-	Manichaean}', "");
    Expect(0, 68351, '\P{Blk=-	Manichaean}', "");
    Expect(1, 68351, '\P{^Blk=-	Manichaean}', "");
    Expect(0, 68352, '\p{Blk=-	Manichaean}', "");
    Expect(1, 68352, '\p{^Blk=-	Manichaean}', "");
    Expect(1, 68352, '\P{Blk=-	Manichaean}', "");
    Expect(0, 68352, '\P{^Blk=-	Manichaean}', "");
    Error('\p{Is_Block=/a/manichaean}');
    Error('\P{Is_Block=/a/manichaean}');
    Expect(1, 68351, '\p{Is_Block=manichaean}', "");
    Expect(0, 68351, '\p{^Is_Block=manichaean}', "");
    Expect(0, 68351, '\P{Is_Block=manichaean}', "");
    Expect(1, 68351, '\P{^Is_Block=manichaean}', "");
    Expect(0, 68352, '\p{Is_Block=manichaean}', "");
    Expect(1, 68352, '\p{^Is_Block=manichaean}', "");
    Expect(1, 68352, '\P{Is_Block=manichaean}', "");
    Expect(0, 68352, '\P{^Is_Block=manichaean}', "");
    Expect(1, 68351, '\p{Is_Block=	manichaean}', "");
    Expect(0, 68351, '\p{^Is_Block=	manichaean}', "");
    Expect(0, 68351, '\P{Is_Block=	manichaean}', "");
    Expect(1, 68351, '\P{^Is_Block=	manichaean}', "");
    Expect(0, 68352, '\p{Is_Block=	manichaean}', "");
    Expect(1, 68352, '\p{^Is_Block=	manichaean}', "");
    Expect(1, 68352, '\P{Is_Block=	manichaean}', "");
    Expect(0, 68352, '\P{^Is_Block=	manichaean}', "");
    Error('\p{Is_Blk=:=	Manichaean}');
    Error('\P{Is_Blk=:=	Manichaean}');
    Expect(1, 68351, '\p{Is_Blk:   manichaean}', "");
    Expect(0, 68351, '\p{^Is_Blk:   manichaean}', "");
    Expect(0, 68351, '\P{Is_Blk:   manichaean}', "");
    Expect(1, 68351, '\P{^Is_Blk:   manichaean}', "");
    Expect(0, 68352, '\p{Is_Blk:   manichaean}', "");
    Expect(1, 68352, '\p{^Is_Blk:   manichaean}', "");
    Expect(1, 68352, '\P{Is_Blk:   manichaean}', "");
    Expect(0, 68352, '\P{^Is_Blk:   manichaean}', "");
    Expect(1, 68351, '\p{Is_Blk=	-Manichaean}', "");
    Expect(0, 68351, '\p{^Is_Blk=	-Manichaean}', "");
    Expect(0, 68351, '\P{Is_Blk=	-Manichaean}', "");
    Expect(1, 68351, '\P{^Is_Blk=	-Manichaean}', "");
    Expect(0, 68352, '\p{Is_Blk=	-Manichaean}', "");
    Expect(1, 68352, '\p{^Is_Blk=	-Manichaean}', "");
    Expect(1, 68352, '\P{Is_Blk=	-Manichaean}', "");
    Expect(0, 68352, '\P{^Is_Blk=	-Manichaean}', "");
    Error('\p{Block=--marchen/a/}');
    Error('\P{Block=--marchen/a/}');
    Expect(1, 72895, '\p{Block=:\AMarchen\z:}', "");;
    Expect(0, 72896, '\p{Block=:\AMarchen\z:}', "");;
    Expect(1, 72895, '\p{Block=marchen}', "");
    Expect(0, 72895, '\p{^Block=marchen}', "");
    Expect(0, 72895, '\P{Block=marchen}', "");
    Expect(1, 72895, '\P{^Block=marchen}', "");
    Expect(0, 72896, '\p{Block=marchen}', "");
    Expect(1, 72896, '\p{^Block=marchen}', "");
    Expect(1, 72896, '\P{Block=marchen}', "");
    Expect(0, 72896, '\P{^Block=marchen}', "");
    Expect(1, 72895, '\p{Block=:\Amarchen\z:}', "");;
    Expect(0, 72896, '\p{Block=:\Amarchen\z:}', "");;
    Expect(1, 72895, '\p{Block: _marchen}', "");
    Expect(0, 72895, '\p{^Block: _marchen}', "");
    Expect(0, 72895, '\P{Block: _marchen}', "");
    Expect(1, 72895, '\P{^Block: _marchen}', "");
    Expect(0, 72896, '\p{Block: _marchen}', "");
    Expect(1, 72896, '\p{^Block: _marchen}', "");
    Expect(1, 72896, '\P{Block: _marchen}', "");
    Expect(0, 72896, '\P{^Block: _marchen}', "");
    Error('\p{Blk=_:=marchen}');
    Error('\P{Blk=_:=marchen}');
    Expect(1, 72895, '\p{Blk=:\AMarchen\z:}', "");;
    Expect(0, 72896, '\p{Blk=:\AMarchen\z:}', "");;
    Expect(1, 72895, '\p{Blk=marchen}', "");
    Expect(0, 72895, '\p{^Blk=marchen}', "");
    Expect(0, 72895, '\P{Blk=marchen}', "");
    Expect(1, 72895, '\P{^Blk=marchen}', "");
    Expect(0, 72896, '\p{Blk=marchen}', "");
    Expect(1, 72896, '\p{^Blk=marchen}', "");
    Expect(1, 72896, '\P{Blk=marchen}', "");
    Expect(0, 72896, '\P{^Blk=marchen}', "");
    Expect(1, 72895, '\p{Blk=:\Amarchen\z:}', "");;
    Expect(0, 72896, '\p{Blk=:\Amarchen\z:}', "");;
    Expect(1, 72895, '\p{Blk=__Marchen}', "");
    Expect(0, 72895, '\p{^Blk=__Marchen}', "");
    Expect(0, 72895, '\P{Blk=__Marchen}', "");
    Expect(1, 72895, '\P{^Blk=__Marchen}', "");
    Expect(0, 72896, '\p{Blk=__Marchen}', "");
    Expect(1, 72896, '\p{^Blk=__Marchen}', "");
    Expect(1, 72896, '\P{Blk=__Marchen}', "");
    Expect(0, 72896, '\P{^Blk=__Marchen}', "");
    Error('\p{Is_Block= /a/MARCHEN}');
    Error('\P{Is_Block= /a/MARCHEN}');
    Expect(1, 72895, '\p{Is_Block=marchen}', "");
    Expect(0, 72895, '\p{^Is_Block=marchen}', "");
    Expect(0, 72895, '\P{Is_Block=marchen}', "");
    Expect(1, 72895, '\P{^Is_Block=marchen}', "");
    Expect(0, 72896, '\p{Is_Block=marchen}', "");
    Expect(1, 72896, '\p{^Is_Block=marchen}', "");
    Expect(1, 72896, '\P{Is_Block=marchen}', "");
    Expect(0, 72896, '\P{^Is_Block=marchen}', "");
    Expect(1, 72895, '\p{Is_Block=_	Marchen}', "");
    Expect(0, 72895, '\p{^Is_Block=_	Marchen}', "");
    Expect(0, 72895, '\P{Is_Block=_	Marchen}', "");
    Expect(1, 72895, '\P{^Is_Block=_	Marchen}', "");
    Expect(0, 72896, '\p{Is_Block=_	Marchen}', "");
    Expect(1, 72896, '\p{^Is_Block=_	Marchen}', "");
    Expect(1, 72896, '\P{Is_Block=_	Marchen}', "");
    Expect(0, 72896, '\P{^Is_Block=_	Marchen}', "");
    Error('\p{Is_Blk=/a/		marchen}');
    Error('\P{Is_Blk=/a/		marchen}');
    Expect(1, 72895, '\p{Is_Blk=marchen}', "");
    Expect(0, 72895, '\p{^Is_Blk=marchen}', "");
    Expect(0, 72895, '\P{Is_Blk=marchen}', "");
    Expect(1, 72895, '\P{^Is_Blk=marchen}', "");
    Expect(0, 72896, '\p{Is_Blk=marchen}', "");
    Expect(1, 72896, '\p{^Is_Blk=marchen}', "");
    Expect(1, 72896, '\P{Is_Blk=marchen}', "");
    Expect(0, 72896, '\P{^Is_Blk=marchen}', "");
    Expect(1, 72895, '\p{Is_Blk= Marchen}', "");
    Expect(0, 72895, '\p{^Is_Blk= Marchen}', "");
    Expect(0, 72895, '\P{Is_Blk= Marchen}', "");
    Expect(1, 72895, '\P{^Is_Blk= Marchen}', "");
    Expect(0, 72896, '\p{Is_Blk= Marchen}', "");
    Expect(1, 72896, '\p{^Is_Blk= Marchen}', "");
    Expect(1, 72896, '\P{Is_Blk= Marchen}', "");
    Expect(0, 72896, '\P{^Is_Blk= Marchen}', "");
    Error('\p{Block= /a/Masaram_gondi}');
    Error('\P{Block= /a/Masaram_gondi}');
    Expect(1, 73055, '\p{Block=:\AMasaram_Gondi\z:}', "");;
    Expect(0, 73056, '\p{Block=:\AMasaram_Gondi\z:}', "");;
    Expect(1, 73055, '\p{Block:	masaramgondi}', "");
    Expect(0, 73055, '\p{^Block:	masaramgondi}', "");
    Expect(0, 73055, '\P{Block:	masaramgondi}', "");
    Expect(1, 73055, '\P{^Block:	masaramgondi}', "");
    Expect(0, 73056, '\p{Block:	masaramgondi}', "");
    Expect(1, 73056, '\p{^Block:	masaramgondi}', "");
    Expect(1, 73056, '\P{Block:	masaramgondi}', "");
    Expect(0, 73056, '\P{^Block:	masaramgondi}', "");
    Expect(1, 73055, '\p{Block=:\Amasaramgondi\z:}', "");;
    Expect(0, 73056, '\p{Block=:\Amasaramgondi\z:}', "");;
    Expect(1, 73055, '\p{Block=- MASARAM_GONDI}', "");
    Expect(0, 73055, '\p{^Block=- MASARAM_GONDI}', "");
    Expect(0, 73055, '\P{Block=- MASARAM_GONDI}', "");
    Expect(1, 73055, '\P{^Block=- MASARAM_GONDI}', "");
    Expect(0, 73056, '\p{Block=- MASARAM_GONDI}', "");
    Expect(1, 73056, '\p{^Block=- MASARAM_GONDI}', "");
    Expect(1, 73056, '\P{Block=- MASARAM_GONDI}', "");
    Expect(0, 73056, '\P{^Block=- MASARAM_GONDI}', "");
    Error('\p{Blk=/a/MASARAM_GONDI}');
    Error('\P{Blk=/a/MASARAM_GONDI}');
    Expect(1, 73055, '\p{Blk=:\AMasaram_Gondi\z:}', "");;
    Expect(0, 73056, '\p{Blk=:\AMasaram_Gondi\z:}', "");;
    Expect(1, 73055, '\p{Blk:masaramgondi}', "");
    Expect(0, 73055, '\p{^Blk:masaramgondi}', "");
    Expect(0, 73055, '\P{Blk:masaramgondi}', "");
    Expect(1, 73055, '\P{^Blk:masaramgondi}', "");
    Expect(0, 73056, '\p{Blk:masaramgondi}', "");
    Expect(1, 73056, '\p{^Blk:masaramgondi}', "");
    Expect(1, 73056, '\P{Blk:masaramgondi}', "");
    Expect(0, 73056, '\P{^Blk:masaramgondi}', "");
    Expect(1, 73055, '\p{Blk=:\Amasaramgondi\z:}', "");;
    Expect(0, 73056, '\p{Blk=:\Amasaramgondi\z:}', "");;
    Expect(1, 73055, '\p{Blk=	 Masaram_Gondi}', "");
    Expect(0, 73055, '\p{^Blk=	 Masaram_Gondi}', "");
    Expect(0, 73055, '\P{Blk=	 Masaram_Gondi}', "");
    Expect(1, 73055, '\P{^Blk=	 Masaram_Gondi}', "");
    Expect(0, 73056, '\p{Blk=	 Masaram_Gondi}', "");
    Expect(1, 73056, '\p{^Blk=	 Masaram_Gondi}', "");
    Expect(1, 73056, '\P{Blk=	 Masaram_Gondi}', "");
    Expect(0, 73056, '\P{^Blk=	 Masaram_Gondi}', "");
    Error('\p{Is_Block=-	Masaram_GONDI/a/}');
    Error('\P{Is_Block=-	Masaram_GONDI/a/}');
    Expect(1, 73055, '\p{Is_Block=masaramgondi}', "");
    Expect(0, 73055, '\p{^Is_Block=masaramgondi}', "");
    Expect(0, 73055, '\P{Is_Block=masaramgondi}', "");
    Expect(1, 73055, '\P{^Is_Block=masaramgondi}', "");
    Expect(0, 73056, '\p{Is_Block=masaramgondi}', "");
    Expect(1, 73056, '\p{^Is_Block=masaramgondi}', "");
    Expect(1, 73056, '\P{Is_Block=masaramgondi}', "");
    Expect(0, 73056, '\P{^Is_Block=masaramgondi}', "");
    Expect(1, 73055, '\p{Is_Block= -MASARAM_GONDI}', "");
    Expect(0, 73055, '\p{^Is_Block= -MASARAM_GONDI}', "");
    Expect(0, 73055, '\P{Is_Block= -MASARAM_GONDI}', "");
    Expect(1, 73055, '\P{^Is_Block= -MASARAM_GONDI}', "");
    Expect(0, 73056, '\p{Is_Block= -MASARAM_GONDI}', "");
    Expect(1, 73056, '\p{^Is_Block= -MASARAM_GONDI}', "");
    Expect(1, 73056, '\P{Is_Block= -MASARAM_GONDI}', "");
    Expect(0, 73056, '\P{^Is_Block= -MASARAM_GONDI}', "");
    Error('\p{Is_Blk:	:=Masaram_GONDI}');
    Error('\P{Is_Blk:	:=Masaram_GONDI}');
    Expect(1, 73055, '\p{Is_Blk:   masaramgondi}', "");
    Expect(0, 73055, '\p{^Is_Blk:   masaramgondi}', "");
    Expect(0, 73055, '\P{Is_Blk:   masaramgondi}', "");
    Expect(1, 73055, '\P{^Is_Blk:   masaramgondi}', "");
    Expect(0, 73056, '\p{Is_Blk:   masaramgondi}', "");
    Expect(1, 73056, '\p{^Is_Blk:   masaramgondi}', "");
    Expect(1, 73056, '\P{Is_Blk:   masaramgondi}', "");
    Expect(0, 73056, '\P{^Is_Blk:   masaramgondi}', "");
    Expect(1, 73055, '\p{Is_Blk: 	Masaram_Gondi}', "");
    Expect(0, 73055, '\p{^Is_Blk: 	Masaram_Gondi}', "");
    Expect(0, 73055, '\P{Is_Blk: 	Masaram_Gondi}', "");
    Expect(1, 73055, '\P{^Is_Blk: 	Masaram_Gondi}', "");
    Expect(0, 73056, '\p{Is_Blk: 	Masaram_Gondi}', "");
    Expect(1, 73056, '\p{^Is_Blk: 	Masaram_Gondi}', "");
    Expect(1, 73056, '\P{Is_Blk: 	Masaram_Gondi}', "");
    Expect(0, 73056, '\P{^Is_Blk: 	Masaram_Gondi}', "");
    Error('\p{Block=/a/	 mathematical_alphanumeric_SYMBOLS}');
    Error('\P{Block=/a/	 mathematical_alphanumeric_SYMBOLS}');
    Expect(1, 120831, '\p{Block=:\AMathematical_Alphanumeric_Symbols\z:}', "");;
    Expect(0, 120832, '\p{Block=:\AMathematical_Alphanumeric_Symbols\z:}', "");;
    Expect(1, 120831, '\p{Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\p{^Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\P{Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\P{^Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\p{Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\p{^Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\P{Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\P{^Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\p{Block=:\Amathematicalalphanumericsymbols\z:}', "");;
    Expect(0, 120832, '\p{Block=:\Amathematicalalphanumericsymbols\z:}', "");;
    Expect(1, 120831, '\p{Block=__Mathematical_alphanumeric_Symbols}', "");
    Expect(0, 120831, '\p{^Block=__Mathematical_alphanumeric_Symbols}', "");
    Expect(0, 120831, '\P{Block=__Mathematical_alphanumeric_Symbols}', "");
    Expect(1, 120831, '\P{^Block=__Mathematical_alphanumeric_Symbols}', "");
    Expect(0, 120832, '\p{Block=__Mathematical_alphanumeric_Symbols}', "");
    Expect(1, 120832, '\p{^Block=__Mathematical_alphanumeric_Symbols}', "");
    Expect(1, 120832, '\P{Block=__Mathematical_alphanumeric_Symbols}', "");
    Expect(0, 120832, '\P{^Block=__Mathematical_alphanumeric_Symbols}', "");
    Error('\p{Blk= /a/Math_alphanum}');
    Error('\P{Blk= /a/Math_alphanum}');
    Expect(1, 120831, '\p{Blk=:\AMath_Alphanum\z:}', "");;
    Expect(0, 120832, '\p{Blk=:\AMath_Alphanum\z:}', "");;
    Expect(1, 120831, '\p{Blk=mathalphanum}', "");
    Expect(0, 120831, '\p{^Blk=mathalphanum}', "");
    Expect(0, 120831, '\P{Blk=mathalphanum}', "");
    Expect(1, 120831, '\P{^Blk=mathalphanum}', "");
    Expect(0, 120832, '\p{Blk=mathalphanum}', "");
    Expect(1, 120832, '\p{^Blk=mathalphanum}', "");
    Expect(1, 120832, '\P{Blk=mathalphanum}', "");
    Expect(0, 120832, '\P{^Blk=mathalphanum}', "");
    Expect(1, 120831, '\p{Blk=:\Amathalphanum\z:}', "");;
    Expect(0, 120832, '\p{Blk=:\Amathalphanum\z:}', "");;
    Expect(1, 120831, '\p{Blk= MATH_ALPHANUM}', "");
    Expect(0, 120831, '\p{^Blk= MATH_ALPHANUM}', "");
    Expect(0, 120831, '\P{Blk= MATH_ALPHANUM}', "");
    Expect(1, 120831, '\P{^Blk= MATH_ALPHANUM}', "");
    Expect(0, 120832, '\p{Blk= MATH_ALPHANUM}', "");
    Expect(1, 120832, '\p{^Blk= MATH_ALPHANUM}', "");
    Expect(1, 120832, '\P{Blk= MATH_ALPHANUM}', "");
    Expect(0, 120832, '\P{^Blk= MATH_ALPHANUM}', "");
    Error('\p{Is_Block= :=MATHEMATICAL_Alphanumeric_symbols}');
    Error('\P{Is_Block= :=MATHEMATICAL_Alphanumeric_symbols}');
    Expect(1, 120831, '\p{Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\p{^Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\P{Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\P{^Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\p{Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\p{^Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\P{Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\P{^Is_Block=mathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\p{Is_Block=	 MATHEMATICAL_alphanumeric_SYMBOLS}', "");
    Expect(0, 120831, '\p{^Is_Block=	 MATHEMATICAL_alphanumeric_SYMBOLS}', "");
    Expect(0, 120831, '\P{Is_Block=	 MATHEMATICAL_alphanumeric_SYMBOLS}', "");
    Expect(1, 120831, '\P{^Is_Block=	 MATHEMATICAL_alphanumeric_SYMBOLS}', "");
    Expect(0, 120832, '\p{Is_Block=	 MATHEMATICAL_alphanumeric_SYMBOLS}', "");
    Expect(1, 120832, '\p{^Is_Block=	 MATHEMATICAL_alphanumeric_SYMBOLS}', "");
    Expect(1, 120832, '\P{Is_Block=	 MATHEMATICAL_alphanumeric_SYMBOLS}', "");
    Expect(0, 120832, '\P{^Is_Block=	 MATHEMATICAL_alphanumeric_SYMBOLS}', "");
    Error('\p{Is_Blk=	Math_ALPHANUM/a/}');
    Error('\P{Is_Blk=	Math_ALPHANUM/a/}');
    Expect(1, 120831, '\p{Is_Blk=mathalphanum}', "");
    Expect(0, 120831, '\p{^Is_Blk=mathalphanum}', "");
    Expect(0, 120831, '\P{Is_Blk=mathalphanum}', "");
    Expect(1, 120831, '\P{^Is_Blk=mathalphanum}', "");
    Expect(0, 120832, '\p{Is_Blk=mathalphanum}', "");
    Expect(1, 120832, '\p{^Is_Blk=mathalphanum}', "");
    Expect(1, 120832, '\P{Is_Blk=mathalphanum}', "");
    Expect(0, 120832, '\P{^Is_Blk=mathalphanum}', "");
    Expect(1, 120831, '\p{Is_Blk=_Math_ALPHANUM}', "");
    Expect(0, 120831, '\p{^Is_Blk=_Math_ALPHANUM}', "");
    Expect(0, 120831, '\P{Is_Blk=_Math_ALPHANUM}', "");
    Expect(1, 120831, '\P{^Is_Blk=_Math_ALPHANUM}', "");
    Expect(0, 120832, '\p{Is_Blk=_Math_ALPHANUM}', "");
    Expect(1, 120832, '\p{^Is_Blk=_Math_ALPHANUM}', "");
    Expect(1, 120832, '\P{Is_Blk=_Math_ALPHANUM}', "");
    Expect(0, 120832, '\P{^Is_Blk=_Math_ALPHANUM}', "");
    Error('\p{Block=-/a/Mathematical_Operators}');
    Error('\P{Block=-/a/Mathematical_Operators}');
    Expect(1, 8959, '\p{Block=:\AMathematical_Operators\z:}', "");;
    Expect(0, 8960, '\p{Block=:\AMathematical_Operators\z:}', "");;
    Expect(1, 8959, '\p{Block=mathematicaloperators}', "");
    Expect(0, 8959, '\p{^Block=mathematicaloperators}', "");
    Expect(0, 8959, '\P{Block=mathematicaloperators}', "");
    Expect(1, 8959, '\P{^Block=mathematicaloperators}', "");
    Expect(0, 8960, '\p{Block=mathematicaloperators}', "");
    Expect(1, 8960, '\p{^Block=mathematicaloperators}', "");
    Expect(1, 8960, '\P{Block=mathematicaloperators}', "");
    Expect(0, 8960, '\P{^Block=mathematicaloperators}', "");
    Expect(1, 8959, '\p{Block=:\Amathematicaloperators\z:}', "");;
    Expect(0, 8960, '\p{Block=:\Amathematicaloperators\z:}', "");;
    Expect(1, 8959, '\p{Block=-Mathematical_Operators}', "");
    Expect(0, 8959, '\p{^Block=-Mathematical_Operators}', "");
    Expect(0, 8959, '\P{Block=-Mathematical_Operators}', "");
    Expect(1, 8959, '\P{^Block=-Mathematical_Operators}', "");
    Expect(0, 8960, '\p{Block=-Mathematical_Operators}', "");
    Expect(1, 8960, '\p{^Block=-Mathematical_Operators}', "");
    Expect(1, 8960, '\P{Block=-Mathematical_Operators}', "");
    Expect(0, 8960, '\P{^Block=-Mathematical_Operators}', "");
    Error('\p{Blk=/a/_ Math_Operators}');
    Error('\P{Blk=/a/_ Math_Operators}');
    Expect(1, 8959, '\p{Blk=:\AMath_Operators\z:}', "");;
    Expect(0, 8960, '\p{Blk=:\AMath_Operators\z:}', "");;
    Expect(1, 8959, '\p{Blk: mathoperators}', "");
    Expect(0, 8959, '\p{^Blk: mathoperators}', "");
    Expect(0, 8959, '\P{Blk: mathoperators}', "");
    Expect(1, 8959, '\P{^Blk: mathoperators}', "");
    Expect(0, 8960, '\p{Blk: mathoperators}', "");
    Expect(1, 8960, '\p{^Blk: mathoperators}', "");
    Expect(1, 8960, '\P{Blk: mathoperators}', "");
    Expect(0, 8960, '\P{^Blk: mathoperators}', "");
    Expect(1, 8959, '\p{Blk=:\Amathoperators\z:}', "");;
    Expect(0, 8960, '\p{Blk=:\Amathoperators\z:}', "");;
    Expect(1, 8959, '\p{Blk=-Math_Operators}', "");
    Expect(0, 8959, '\p{^Blk=-Math_Operators}', "");
    Expect(0, 8959, '\P{Blk=-Math_Operators}', "");
    Expect(1, 8959, '\P{^Blk=-Math_Operators}', "");
    Expect(0, 8960, '\p{Blk=-Math_Operators}', "");
    Expect(1, 8960, '\p{^Blk=-Math_Operators}', "");
    Expect(1, 8960, '\P{Blk=-Math_Operators}', "");
    Expect(0, 8960, '\P{^Blk=-Math_Operators}', "");
    Error('\p{Is_Block=/a/ Mathematical_Operators}');
    Error('\P{Is_Block=/a/ Mathematical_Operators}');
    Expect(1, 8959, '\p{Is_Block=mathematicaloperators}', "");
    Expect(0, 8959, '\p{^Is_Block=mathematicaloperators}', "");
    Expect(0, 8959, '\P{Is_Block=mathematicaloperators}', "");
    Expect(1, 8959, '\P{^Is_Block=mathematicaloperators}', "");
    Expect(0, 8960, '\p{Is_Block=mathematicaloperators}', "");
    Expect(1, 8960, '\p{^Is_Block=mathematicaloperators}', "");
    Expect(1, 8960, '\P{Is_Block=mathematicaloperators}', "");
    Expect(0, 8960, '\P{^Is_Block=mathematicaloperators}', "");
    Expect(1, 8959, '\p{Is_Block=__mathematical_Operators}', "");
    Expect(0, 8959, '\p{^Is_Block=__mathematical_Operators}', "");
    Expect(0, 8959, '\P{Is_Block=__mathematical_Operators}', "");
    Expect(1, 8959, '\P{^Is_Block=__mathematical_Operators}', "");
    Expect(0, 8960, '\p{Is_Block=__mathematical_Operators}', "");
    Expect(1, 8960, '\p{^Is_Block=__mathematical_Operators}', "");
    Expect(1, 8960, '\P{Is_Block=__mathematical_Operators}', "");
    Expect(0, 8960, '\P{^Is_Block=__mathematical_Operators}', "");
    Error('\p{Is_Blk:   /a/-MATH_operators}');
    Error('\P{Is_Blk:   /a/-MATH_operators}');
    Expect(1, 8959, '\p{Is_Blk:mathoperators}', "");
    Expect(0, 8959, '\p{^Is_Blk:mathoperators}', "");
    Expect(0, 8959, '\P{Is_Blk:mathoperators}', "");
    Expect(1, 8959, '\P{^Is_Blk:mathoperators}', "");
    Expect(0, 8960, '\p{Is_Blk:mathoperators}', "");
    Expect(1, 8960, '\p{^Is_Blk:mathoperators}', "");
    Expect(1, 8960, '\P{Is_Blk:mathoperators}', "");
    Expect(0, 8960, '\P{^Is_Blk:mathoperators}', "");
    Expect(1, 8959, '\p{Is_Blk=_MATH_operators}', "");
    Expect(0, 8959, '\p{^Is_Blk=_MATH_operators}', "");
    Expect(0, 8959, '\P{Is_Blk=_MATH_operators}', "");
    Expect(1, 8959, '\P{^Is_Blk=_MATH_operators}', "");
    Expect(0, 8960, '\p{Is_Blk=_MATH_operators}', "");
    Expect(1, 8960, '\p{^Is_Blk=_MATH_operators}', "");
    Expect(1, 8960, '\P{Is_Blk=_MATH_operators}', "");
    Expect(0, 8960, '\P{^Is_Blk=_MATH_operators}', "");
    Error('\p{Block= :=MAYAN_numerals}');
    Error('\P{Block= :=MAYAN_numerals}');
    Expect(1, 119551, '\p{Block=:\AMayan_Numerals\z:}', "");;
    Expect(0, 119552, '\p{Block=:\AMayan_Numerals\z:}', "");;
    Expect(1, 119551, '\p{Block=mayannumerals}', "");
    Expect(0, 119551, '\p{^Block=mayannumerals}', "");
    Expect(0, 119551, '\P{Block=mayannumerals}', "");
    Expect(1, 119551, '\P{^Block=mayannumerals}', "");
    Expect(0, 119552, '\p{Block=mayannumerals}', "");
    Expect(1, 119552, '\p{^Block=mayannumerals}', "");
    Expect(1, 119552, '\P{Block=mayannumerals}', "");
    Expect(0, 119552, '\P{^Block=mayannumerals}', "");
    Expect(1, 119551, '\p{Block=:\Amayannumerals\z:}', "");;
    Expect(0, 119552, '\p{Block=:\Amayannumerals\z:}', "");;
    Expect(1, 119551, '\p{Block= _mayan_Numerals}', "");
    Expect(0, 119551, '\p{^Block= _mayan_Numerals}', "");
    Expect(0, 119551, '\P{Block= _mayan_Numerals}', "");
    Expect(1, 119551, '\P{^Block= _mayan_Numerals}', "");
    Expect(0, 119552, '\p{Block= _mayan_Numerals}', "");
    Expect(1, 119552, '\p{^Block= _mayan_Numerals}', "");
    Expect(1, 119552, '\P{Block= _mayan_Numerals}', "");
    Expect(0, 119552, '\P{^Block= _mayan_Numerals}', "");
    Error('\p{Blk:	 mayan_numerals/a/}');
    Error('\P{Blk:	 mayan_numerals/a/}');
    Expect(1, 119551, '\p{Blk=:\AMayan_Numerals\z:}', "");;
    Expect(0, 119552, '\p{Blk=:\AMayan_Numerals\z:}', "");;
    Expect(1, 119551, '\p{Blk=mayannumerals}', "");
    Expect(0, 119551, '\p{^Blk=mayannumerals}', "");
    Expect(0, 119551, '\P{Blk=mayannumerals}', "");
    Expect(1, 119551, '\P{^Blk=mayannumerals}', "");
    Expect(0, 119552, '\p{Blk=mayannumerals}', "");
    Expect(1, 119552, '\p{^Blk=mayannumerals}', "");
    Expect(1, 119552, '\P{Blk=mayannumerals}', "");
    Expect(0, 119552, '\P{^Blk=mayannumerals}', "");
    Expect(1, 119551, '\p{Blk=:\Amayannumerals\z:}', "");;
    Expect(0, 119552, '\p{Blk=:\Amayannumerals\z:}', "");;
    Expect(1, 119551, '\p{Blk=_-Mayan_Numerals}', "");
    Expect(0, 119551, '\p{^Blk=_-Mayan_Numerals}', "");
    Expect(0, 119551, '\P{Blk=_-Mayan_Numerals}', "");
    Expect(1, 119551, '\P{^Blk=_-Mayan_Numerals}', "");
    Expect(0, 119552, '\p{Blk=_-Mayan_Numerals}', "");
    Expect(1, 119552, '\p{^Blk=_-Mayan_Numerals}', "");
    Expect(1, 119552, '\P{Blk=_-Mayan_Numerals}', "");
    Expect(0, 119552, '\P{^Blk=_-Mayan_Numerals}', "");
    Error('\p{Is_Block=-/a/MAYAN_Numerals}');
    Error('\P{Is_Block=-/a/MAYAN_Numerals}');
    Expect(1, 119551, '\p{Is_Block=mayannumerals}', "");
    Expect(0, 119551, '\p{^Is_Block=mayannumerals}', "");
    Expect(0, 119551, '\P{Is_Block=mayannumerals}', "");
    Expect(1, 119551, '\P{^Is_Block=mayannumerals}', "");
    Expect(0, 119552, '\p{Is_Block=mayannumerals}', "");
    Expect(1, 119552, '\p{^Is_Block=mayannumerals}', "");
    Expect(1, 119552, '\P{Is_Block=mayannumerals}', "");
    Expect(0, 119552, '\P{^Is_Block=mayannumerals}', "");
    Expect(1, 119551, '\p{Is_Block=__MAYAN_numerals}', "");
    Expect(0, 119551, '\p{^Is_Block=__MAYAN_numerals}', "");
    Expect(0, 119551, '\P{Is_Block=__MAYAN_numerals}', "");
    Expect(1, 119551, '\P{^Is_Block=__MAYAN_numerals}', "");
    Expect(0, 119552, '\p{Is_Block=__MAYAN_numerals}', "");
    Expect(1, 119552, '\p{^Is_Block=__MAYAN_numerals}', "");
    Expect(1, 119552, '\P{Is_Block=__MAYAN_numerals}', "");
    Expect(0, 119552, '\P{^Is_Block=__MAYAN_numerals}', "");
    Error('\p{Is_Blk=/a/mayan_Numerals}');
    Error('\P{Is_Blk=/a/mayan_Numerals}');
    Expect(1, 119551, '\p{Is_Blk=mayannumerals}', "");
    Expect(0, 119551, '\p{^Is_Blk=mayannumerals}', "");
    Expect(0, 119551, '\P{Is_Blk=mayannumerals}', "");
    Expect(1, 119551, '\P{^Is_Blk=mayannumerals}', "");
    Expect(0, 119552, '\p{Is_Blk=mayannumerals}', "");
    Expect(1, 119552, '\p{^Is_Blk=mayannumerals}', "");
    Expect(1, 119552, '\P{Is_Blk=mayannumerals}', "");
    Expect(0, 119552, '\P{^Is_Blk=mayannumerals}', "");
    Expect(1, 119551, '\p{Is_Blk=_mayan_Numerals}', "");
    Expect(0, 119551, '\p{^Is_Blk=_mayan_Numerals}', "");
    Expect(0, 119551, '\P{Is_Blk=_mayan_Numerals}', "");
    Expect(1, 119551, '\P{^Is_Blk=_mayan_Numerals}', "");
    Expect(0, 119552, '\p{Is_Blk=_mayan_Numerals}', "");
    Expect(1, 119552, '\p{^Is_Blk=_mayan_Numerals}', "");
    Expect(1, 119552, '\P{Is_Blk=_mayan_Numerals}', "");
    Expect(0, 119552, '\P{^Is_Blk=_mayan_Numerals}', "");
    Error('\p{Block::= Medefaidrin}');
    Error('\P{Block::= Medefaidrin}');
    Expect(1, 93855, '\p{Block=:\AMedefaidrin\z:}', "");;
    Expect(0, 93856, '\p{Block=:\AMedefaidrin\z:}', "");;
    Expect(1, 93855, '\p{Block=medefaidrin}', "");
    Expect(0, 93855, '\p{^Block=medefaidrin}', "");
    Expect(0, 93855, '\P{Block=medefaidrin}', "");
    Expect(1, 93855, '\P{^Block=medefaidrin}', "");
    Expect(0, 93856, '\p{Block=medefaidrin}', "");
    Expect(1, 93856, '\p{^Block=medefaidrin}', "");
    Expect(1, 93856, '\P{Block=medefaidrin}', "");
    Expect(0, 93856, '\P{^Block=medefaidrin}', "");
    Expect(1, 93855, '\p{Block=:\Amedefaidrin\z:}', "");;
    Expect(0, 93856, '\p{Block=:\Amedefaidrin\z:}', "");;
    Expect(1, 93855, '\p{Block= _MEDEFAIDRIN}', "");
    Expect(0, 93855, '\p{^Block= _MEDEFAIDRIN}', "");
    Expect(0, 93855, '\P{Block= _MEDEFAIDRIN}', "");
    Expect(1, 93855, '\P{^Block= _MEDEFAIDRIN}', "");
    Expect(0, 93856, '\p{Block= _MEDEFAIDRIN}', "");
    Expect(1, 93856, '\p{^Block= _MEDEFAIDRIN}', "");
    Expect(1, 93856, '\P{Block= _MEDEFAIDRIN}', "");
    Expect(0, 93856, '\P{^Block= _MEDEFAIDRIN}', "");
    Error('\p{Blk=	Medefaidrin:=}');
    Error('\P{Blk=	Medefaidrin:=}');
    Expect(1, 93855, '\p{Blk=:\AMedefaidrin\z:}', "");;
    Expect(0, 93856, '\p{Blk=:\AMedefaidrin\z:}', "");;
    Expect(1, 93855, '\p{Blk=medefaidrin}', "");
    Expect(0, 93855, '\p{^Blk=medefaidrin}', "");
    Expect(0, 93855, '\P{Blk=medefaidrin}', "");
    Expect(1, 93855, '\P{^Blk=medefaidrin}', "");
    Expect(0, 93856, '\p{Blk=medefaidrin}', "");
    Expect(1, 93856, '\p{^Blk=medefaidrin}', "");
    Expect(1, 93856, '\P{Blk=medefaidrin}', "");
    Expect(0, 93856, '\P{^Blk=medefaidrin}', "");
    Expect(1, 93855, '\p{Blk=:\Amedefaidrin\z:}', "");;
    Expect(0, 93856, '\p{Blk=:\Amedefaidrin\z:}', "");;
    Expect(1, 93855, '\p{Blk:   _ Medefaidrin}', "");
    Expect(0, 93855, '\p{^Blk:   _ Medefaidrin}', "");
    Expect(0, 93855, '\P{Blk:   _ Medefaidrin}', "");
    Expect(1, 93855, '\P{^Blk:   _ Medefaidrin}', "");
    Expect(0, 93856, '\p{Blk:   _ Medefaidrin}', "");
    Expect(1, 93856, '\p{^Blk:   _ Medefaidrin}', "");
    Expect(1, 93856, '\P{Blk:   _ Medefaidrin}', "");
    Expect(0, 93856, '\P{^Blk:   _ Medefaidrin}', "");
    Error('\p{Is_Block=_:=Medefaidrin}');
    Error('\P{Is_Block=_:=Medefaidrin}');
    Expect(1, 93855, '\p{Is_Block=medefaidrin}', "");
    Expect(0, 93855, '\p{^Is_Block=medefaidrin}', "");
    Expect(0, 93855, '\P{Is_Block=medefaidrin}', "");
    Expect(1, 93855, '\P{^Is_Block=medefaidrin}', "");
    Expect(0, 93856, '\p{Is_Block=medefaidrin}', "");
    Expect(1, 93856, '\p{^Is_Block=medefaidrin}', "");
    Expect(1, 93856, '\P{Is_Block=medefaidrin}', "");
    Expect(0, 93856, '\P{^Is_Block=medefaidrin}', "");
    Expect(1, 93855, '\p{Is_Block=	 Medefaidrin}', "");
    Expect(0, 93855, '\p{^Is_Block=	 Medefaidrin}', "");
    Expect(0, 93855, '\P{Is_Block=	 Medefaidrin}', "");
    Expect(1, 93855, '\P{^Is_Block=	 Medefaidrin}', "");
    Expect(0, 93856, '\p{Is_Block=	 Medefaidrin}', "");
    Expect(1, 93856, '\p{^Is_Block=	 Medefaidrin}', "");
    Expect(1, 93856, '\P{Is_Block=	 Medefaidrin}', "");
    Expect(0, 93856, '\P{^Is_Block=	 Medefaidrin}', "");
    Error('\p{Is_Blk=__Medefaidrin:=}');
    Error('\P{Is_Blk=__Medefaidrin:=}');
    Expect(1, 93855, '\p{Is_Blk=medefaidrin}', "");
    Expect(0, 93855, '\p{^Is_Blk=medefaidrin}', "");
    Expect(0, 93855, '\P{Is_Blk=medefaidrin}', "");
    Expect(1, 93855, '\P{^Is_Blk=medefaidrin}', "");
    Expect(0, 93856, '\p{Is_Blk=medefaidrin}', "");
    Expect(1, 93856, '\p{^Is_Blk=medefaidrin}', "");
    Expect(1, 93856, '\P{Is_Blk=medefaidrin}', "");
    Expect(0, 93856, '\P{^Is_Blk=medefaidrin}', "");
    Error('\p{Block=-_MEETEI_Mayek/a/}');
    Error('\P{Block=-_MEETEI_Mayek/a/}');
    Expect(1, 44031, '\p{Block=:\AMeetei_Mayek\z:}', "");;
    Expect(0, 44032, '\p{Block=:\AMeetei_Mayek\z:}', "");;
    Expect(1, 44031, '\p{Block=meeteimayek}', "");
    Expect(0, 44031, '\p{^Block=meeteimayek}', "");
    Expect(0, 44031, '\P{Block=meeteimayek}', "");
    Expect(1, 44031, '\P{^Block=meeteimayek}', "");
    Expect(0, 44032, '\p{Block=meeteimayek}', "");
    Expect(1, 44032, '\p{^Block=meeteimayek}', "");
    Expect(1, 44032, '\P{Block=meeteimayek}', "");
    Expect(0, 44032, '\P{^Block=meeteimayek}', "");
    Expect(1, 44031, '\p{Block=:\Ameeteimayek\z:}', "");;
    Expect(0, 44032, '\p{Block=:\Ameeteimayek\z:}', "");;
    Expect(1, 44031, '\p{Block=-Meetei_Mayek}', "");
    Expect(0, 44031, '\p{^Block=-Meetei_Mayek}', "");
    Expect(0, 44031, '\P{Block=-Meetei_Mayek}', "");
    Expect(1, 44031, '\P{^Block=-Meetei_Mayek}', "");
    Expect(0, 44032, '\p{Block=-Meetei_Mayek}', "");
    Expect(1, 44032, '\p{^Block=-Meetei_Mayek}', "");
    Expect(1, 44032, '\P{Block=-Meetei_Mayek}', "");
    Expect(0, 44032, '\P{^Block=-Meetei_Mayek}', "");
    Error('\p{Blk=_/a/MEETEI_MAYEK}');
    Error('\P{Blk=_/a/MEETEI_MAYEK}');
    Expect(1, 44031, '\p{Blk=:\AMeetei_Mayek\z:}', "");;
    Expect(0, 44032, '\p{Blk=:\AMeetei_Mayek\z:}', "");;
    Expect(1, 44031, '\p{Blk=meeteimayek}', "");
    Expect(0, 44031, '\p{^Blk=meeteimayek}', "");
    Expect(0, 44031, '\P{Blk=meeteimayek}', "");
    Expect(1, 44031, '\P{^Blk=meeteimayek}', "");
    Expect(0, 44032, '\p{Blk=meeteimayek}', "");
    Expect(1, 44032, '\p{^Blk=meeteimayek}', "");
    Expect(1, 44032, '\P{Blk=meeteimayek}', "");
    Expect(0, 44032, '\P{^Blk=meeteimayek}', "");
    Expect(1, 44031, '\p{Blk=:\Ameeteimayek\z:}', "");;
    Expect(0, 44032, '\p{Blk=:\Ameeteimayek\z:}', "");;
    Expect(1, 44031, '\p{Blk=--Meetei_Mayek}', "");
    Expect(0, 44031, '\p{^Blk=--Meetei_Mayek}', "");
    Expect(0, 44031, '\P{Blk=--Meetei_Mayek}', "");
    Expect(1, 44031, '\P{^Blk=--Meetei_Mayek}', "");
    Expect(0, 44032, '\p{Blk=--Meetei_Mayek}', "");
    Expect(1, 44032, '\p{^Blk=--Meetei_Mayek}', "");
    Expect(1, 44032, '\P{Blk=--Meetei_Mayek}', "");
    Expect(0, 44032, '\P{^Blk=--Meetei_Mayek}', "");
    Error('\p{Is_Block=  Meetei_mayek/a/}');
    Error('\P{Is_Block=  Meetei_mayek/a/}');
    Expect(1, 44031, '\p{Is_Block=meeteimayek}', "");
    Expect(0, 44031, '\p{^Is_Block=meeteimayek}', "");
    Expect(0, 44031, '\P{Is_Block=meeteimayek}', "");
    Expect(1, 44031, '\P{^Is_Block=meeteimayek}', "");
    Expect(0, 44032, '\p{Is_Block=meeteimayek}', "");
    Expect(1, 44032, '\p{^Is_Block=meeteimayek}', "");
    Expect(1, 44032, '\P{Is_Block=meeteimayek}', "");
    Expect(0, 44032, '\P{^Is_Block=meeteimayek}', "");
    Expect(1, 44031, '\p{Is_Block:   _	Meetei_Mayek}', "");
    Expect(0, 44031, '\p{^Is_Block:   _	Meetei_Mayek}', "");
    Expect(0, 44031, '\P{Is_Block:   _	Meetei_Mayek}', "");
    Expect(1, 44031, '\P{^Is_Block:   _	Meetei_Mayek}', "");
    Expect(0, 44032, '\p{Is_Block:   _	Meetei_Mayek}', "");
    Expect(1, 44032, '\p{^Is_Block:   _	Meetei_Mayek}', "");
    Expect(1, 44032, '\P{Is_Block:   _	Meetei_Mayek}', "");
    Expect(0, 44032, '\P{^Is_Block:   _	Meetei_Mayek}', "");
    Error('\p{Is_Blk::=_-meetei_Mayek}');
    Error('\P{Is_Blk::=_-meetei_Mayek}');
    Expect(1, 44031, '\p{Is_Blk=meeteimayek}', "");
    Expect(0, 44031, '\p{^Is_Blk=meeteimayek}', "");
    Expect(0, 44031, '\P{Is_Blk=meeteimayek}', "");
    Expect(1, 44031, '\P{^Is_Blk=meeteimayek}', "");
    Expect(0, 44032, '\p{Is_Blk=meeteimayek}', "");
    Expect(1, 44032, '\p{^Is_Blk=meeteimayek}', "");
    Expect(1, 44032, '\P{Is_Blk=meeteimayek}', "");
    Expect(0, 44032, '\P{^Is_Blk=meeteimayek}', "");
    Expect(1, 44031, '\p{Is_Blk=_-meetei_Mayek}', "");
    Expect(0, 44031, '\p{^Is_Blk=_-meetei_Mayek}', "");
    Expect(0, 44031, '\P{Is_Blk=_-meetei_Mayek}', "");
    Expect(1, 44031, '\P{^Is_Blk=_-meetei_Mayek}', "");
    Expect(0, 44032, '\p{Is_Blk=_-meetei_Mayek}', "");
    Expect(1, 44032, '\p{^Is_Blk=_-meetei_Mayek}', "");
    Expect(1, 44032, '\P{Is_Blk=_-meetei_Mayek}', "");
    Expect(0, 44032, '\P{^Is_Blk=_-meetei_Mayek}', "");
    Error('\p{Block=-Meetei_mayek_EXTENSIONS/a/}');
    Error('\P{Block=-Meetei_mayek_EXTENSIONS/a/}');
    Expect(1, 43775, '\p{Block=:\AMeetei_Mayek_Extensions\z:}', "");;
    Expect(0, 43776, '\p{Block=:\AMeetei_Mayek_Extensions\z:}', "");;
    Expect(1, 43775, '\p{Block=meeteimayekextensions}', "");
    Expect(0, 43775, '\p{^Block=meeteimayekextensions}', "");
    Expect(0, 43775, '\P{Block=meeteimayekextensions}', "");
    Expect(1, 43775, '\P{^Block=meeteimayekextensions}', "");
    Expect(0, 43776, '\p{Block=meeteimayekextensions}', "");
    Expect(1, 43776, '\p{^Block=meeteimayekextensions}', "");
    Expect(1, 43776, '\P{Block=meeteimayekextensions}', "");
    Expect(0, 43776, '\P{^Block=meeteimayekextensions}', "");
    Expect(1, 43775, '\p{Block=:\Ameeteimayekextensions\z:}', "");;
    Expect(0, 43776, '\p{Block=:\Ameeteimayekextensions\z:}', "");;
    Expect(1, 43775, '\p{Block= Meetei_Mayek_extensions}', "");
    Expect(0, 43775, '\p{^Block= Meetei_Mayek_extensions}', "");
    Expect(0, 43775, '\P{Block= Meetei_Mayek_extensions}', "");
    Expect(1, 43775, '\P{^Block= Meetei_Mayek_extensions}', "");
    Expect(0, 43776, '\p{Block= Meetei_Mayek_extensions}', "");
    Expect(1, 43776, '\p{^Block= Meetei_Mayek_extensions}', "");
    Expect(1, 43776, '\P{Block= Meetei_Mayek_extensions}', "");
    Expect(0, 43776, '\P{^Block= Meetei_Mayek_extensions}', "");
    Error('\p{Blk=/a/	MEETEI_Mayek_ext}');
    Error('\P{Blk=/a/	MEETEI_Mayek_ext}');
    Expect(1, 43775, '\p{Blk=:\AMeetei_Mayek_Ext\z:}', "");;
    Expect(0, 43776, '\p{Blk=:\AMeetei_Mayek_Ext\z:}', "");;
    Expect(1, 43775, '\p{Blk=meeteimayekext}', "");
    Expect(0, 43775, '\p{^Blk=meeteimayekext}', "");
    Expect(0, 43775, '\P{Blk=meeteimayekext}', "");
    Expect(1, 43775, '\P{^Blk=meeteimayekext}', "");
    Expect(0, 43776, '\p{Blk=meeteimayekext}', "");
    Expect(1, 43776, '\p{^Blk=meeteimayekext}', "");
    Expect(1, 43776, '\P{Blk=meeteimayekext}', "");
    Expect(0, 43776, '\P{^Blk=meeteimayekext}', "");
    Expect(1, 43775, '\p{Blk=:\Ameeteimayekext\z:}', "");;
    Expect(0, 43776, '\p{Blk=:\Ameeteimayekext\z:}', "");;
    Expect(1, 43775, '\p{Blk=_Meetei_mayek_EXT}', "");
    Expect(0, 43775, '\p{^Blk=_Meetei_mayek_EXT}', "");
    Expect(0, 43775, '\P{Blk=_Meetei_mayek_EXT}', "");
    Expect(1, 43775, '\P{^Blk=_Meetei_mayek_EXT}', "");
    Expect(0, 43776, '\p{Blk=_Meetei_mayek_EXT}', "");
    Expect(1, 43776, '\p{^Blk=_Meetei_mayek_EXT}', "");
    Expect(1, 43776, '\P{Blk=_Meetei_mayek_EXT}', "");
    Expect(0, 43776, '\P{^Blk=_Meetei_mayek_EXT}', "");
    Error('\p{Is_Block=_ Meetei_mayek_Extensions/a/}');
    Error('\P{Is_Block=_ Meetei_mayek_Extensions/a/}');
    Expect(1, 43775, '\p{Is_Block=meeteimayekextensions}', "");
    Expect(0, 43775, '\p{^Is_Block=meeteimayekextensions}', "");
    Expect(0, 43775, '\P{Is_Block=meeteimayekextensions}', "");
    Expect(1, 43775, '\P{^Is_Block=meeteimayekextensions}', "");
    Expect(0, 43776, '\p{Is_Block=meeteimayekextensions}', "");
    Expect(1, 43776, '\p{^Is_Block=meeteimayekextensions}', "");
    Expect(1, 43776, '\P{Is_Block=meeteimayekextensions}', "");
    Expect(0, 43776, '\P{^Is_Block=meeteimayekextensions}', "");
    Expect(1, 43775, '\p{Is_Block= _meetei_mayek_extensions}', "");
    Expect(0, 43775, '\p{^Is_Block= _meetei_mayek_extensions}', "");
    Expect(0, 43775, '\P{Is_Block= _meetei_mayek_extensions}', "");
    Expect(1, 43775, '\P{^Is_Block= _meetei_mayek_extensions}', "");
    Expect(0, 43776, '\p{Is_Block= _meetei_mayek_extensions}', "");
    Expect(1, 43776, '\p{^Is_Block= _meetei_mayek_extensions}', "");
    Expect(1, 43776, '\P{Is_Block= _meetei_mayek_extensions}', "");
    Expect(0, 43776, '\P{^Is_Block= _meetei_mayek_extensions}', "");
    Error('\p{Is_Blk=/a/_Meetei_Mayek_Ext}');
    Error('\P{Is_Blk=/a/_Meetei_Mayek_Ext}');
    Expect(1, 43775, '\p{Is_Blk=meeteimayekext}', "");
    Expect(0, 43775, '\p{^Is_Blk=meeteimayekext}', "");
    Expect(0, 43775, '\P{Is_Blk=meeteimayekext}', "");
    Expect(1, 43775, '\P{^Is_Blk=meeteimayekext}', "");
    Expect(0, 43776, '\p{Is_Blk=meeteimayekext}', "");
    Expect(1, 43776, '\p{^Is_Blk=meeteimayekext}', "");
    Expect(1, 43776, '\P{Is_Blk=meeteimayekext}', "");
    Expect(0, 43776, '\P{^Is_Blk=meeteimayekext}', "");
    Expect(1, 43775, '\p{Is_Blk=MEETEI_Mayek_ext}', "");
    Expect(0, 43775, '\p{^Is_Blk=MEETEI_Mayek_ext}', "");
    Expect(0, 43775, '\P{Is_Blk=MEETEI_Mayek_ext}', "");
    Expect(1, 43775, '\P{^Is_Blk=MEETEI_Mayek_ext}', "");
    Expect(0, 43776, '\p{Is_Blk=MEETEI_Mayek_ext}', "");
    Expect(1, 43776, '\p{^Is_Blk=MEETEI_Mayek_ext}', "");
    Expect(1, 43776, '\P{Is_Blk=MEETEI_Mayek_ext}', "");
    Expect(0, 43776, '\P{^Is_Blk=MEETEI_Mayek_ext}', "");
    Error('\p{Block=/a/ _Mende_Kikakui}');
    Error('\P{Block=/a/ _Mende_Kikakui}');
    Expect(1, 125151, '\p{Block=:\AMende_Kikakui\z:}', "");;
    Expect(0, 125152, '\p{Block=:\AMende_Kikakui\z:}', "");;
    Expect(1, 125151, '\p{Block=mendekikakui}', "");
    Expect(0, 125151, '\p{^Block=mendekikakui}', "");
    Expect(0, 125151, '\P{Block=mendekikakui}', "");
    Expect(1, 125151, '\P{^Block=mendekikakui}', "");
    Expect(0, 125152, '\p{Block=mendekikakui}', "");
    Expect(1, 125152, '\p{^Block=mendekikakui}', "");
    Expect(1, 125152, '\P{Block=mendekikakui}', "");
    Expect(0, 125152, '\P{^Block=mendekikakui}', "");
    Expect(1, 125151, '\p{Block=:\Amendekikakui\z:}', "");;
    Expect(0, 125152, '\p{Block=:\Amendekikakui\z:}', "");;
    Expect(1, 125151, '\p{Block=_	Mende_Kikakui}', "");
    Expect(0, 125151, '\p{^Block=_	Mende_Kikakui}', "");
    Expect(0, 125151, '\P{Block=_	Mende_Kikakui}', "");
    Expect(1, 125151, '\P{^Block=_	Mende_Kikakui}', "");
    Expect(0, 125152, '\p{Block=_	Mende_Kikakui}', "");
    Expect(1, 125152, '\p{^Block=_	Mende_Kikakui}', "");
    Expect(1, 125152, '\P{Block=_	Mende_Kikakui}', "");
    Expect(0, 125152, '\P{^Block=_	Mende_Kikakui}', "");
    Error('\p{Blk=/a/	-Mende_kikakui}');
    Error('\P{Blk=/a/	-Mende_kikakui}');
    Expect(1, 125151, '\p{Blk=:\AMende_Kikakui\z:}', "");;
    Expect(0, 125152, '\p{Blk=:\AMende_Kikakui\z:}', "");;
    Expect(1, 125151, '\p{Blk=mendekikakui}', "");
    Expect(0, 125151, '\p{^Blk=mendekikakui}', "");
    Expect(0, 125151, '\P{Blk=mendekikakui}', "");
    Expect(1, 125151, '\P{^Blk=mendekikakui}', "");
    Expect(0, 125152, '\p{Blk=mendekikakui}', "");
    Expect(1, 125152, '\p{^Blk=mendekikakui}', "");
    Expect(1, 125152, '\P{Blk=mendekikakui}', "");
    Expect(0, 125152, '\P{^Blk=mendekikakui}', "");
    Expect(1, 125151, '\p{Blk=:\Amendekikakui\z:}', "");;
    Expect(0, 125152, '\p{Blk=:\Amendekikakui\z:}', "");;
    Expect(1, 125151, '\p{Blk=_-Mende_Kikakui}', "");
    Expect(0, 125151, '\p{^Blk=_-Mende_Kikakui}', "");
    Expect(0, 125151, '\P{Blk=_-Mende_Kikakui}', "");
    Expect(1, 125151, '\P{^Blk=_-Mende_Kikakui}', "");
    Expect(0, 125152, '\p{Blk=_-Mende_Kikakui}', "");
    Expect(1, 125152, '\p{^Blk=_-Mende_Kikakui}', "");
    Expect(1, 125152, '\P{Blk=_-Mende_Kikakui}', "");
    Expect(0, 125152, '\P{^Blk=_-Mende_Kikakui}', "");
    Error('\p{Is_Block=_:=mende_Kikakui}');
    Error('\P{Is_Block=_:=mende_Kikakui}');
    Expect(1, 125151, '\p{Is_Block=mendekikakui}', "");
    Expect(0, 125151, '\p{^Is_Block=mendekikakui}', "");
    Expect(0, 125151, '\P{Is_Block=mendekikakui}', "");
    Expect(1, 125151, '\P{^Is_Block=mendekikakui}', "");
    Expect(0, 125152, '\p{Is_Block=mendekikakui}', "");
    Expect(1, 125152, '\p{^Is_Block=mendekikakui}', "");
    Expect(1, 125152, '\P{Is_Block=mendekikakui}', "");
    Expect(0, 125152, '\P{^Is_Block=mendekikakui}', "");
    Expect(1, 125151, '\p{Is_Block= Mende_KIKAKUI}', "");
    Expect(0, 125151, '\p{^Is_Block= Mende_KIKAKUI}', "");
    Expect(0, 125151, '\P{Is_Block= Mende_KIKAKUI}', "");
    Expect(1, 125151, '\P{^Is_Block= Mende_KIKAKUI}', "");
    Expect(0, 125152, '\p{Is_Block= Mende_KIKAKUI}', "");
    Expect(1, 125152, '\p{^Is_Block= Mende_KIKAKUI}', "");
    Expect(1, 125152, '\P{Is_Block= Mende_KIKAKUI}', "");
    Expect(0, 125152, '\P{^Is_Block= Mende_KIKAKUI}', "");
    Error('\p{Is_Blk=/a/MENDE_KIKAKUI}');
    Error('\P{Is_Blk=/a/MENDE_KIKAKUI}');
    Expect(1, 125151, '\p{Is_Blk=mendekikakui}', "");
    Expect(0, 125151, '\p{^Is_Blk=mendekikakui}', "");
    Expect(0, 125151, '\P{Is_Blk=mendekikakui}', "");
    Expect(1, 125151, '\P{^Is_Blk=mendekikakui}', "");
    Expect(0, 125152, '\p{Is_Blk=mendekikakui}', "");
    Expect(1, 125152, '\p{^Is_Blk=mendekikakui}', "");
    Expect(1, 125152, '\P{Is_Blk=mendekikakui}', "");
    Expect(0, 125152, '\P{^Is_Blk=mendekikakui}', "");
    Expect(1, 125151, '\p{Is_Blk= _mende_Kikakui}', "");
    Expect(0, 125151, '\p{^Is_Blk= _mende_Kikakui}', "");
    Expect(0, 125151, '\P{Is_Blk= _mende_Kikakui}', "");
    Expect(1, 125151, '\P{^Is_Blk= _mende_Kikakui}', "");
    Expect(0, 125152, '\p{Is_Blk= _mende_Kikakui}', "");
    Expect(1, 125152, '\p{^Is_Blk= _mende_Kikakui}', "");
    Expect(1, 125152, '\P{Is_Blk= _mende_Kikakui}', "");
    Expect(0, 125152, '\P{^Is_Blk= _mende_Kikakui}', "");
    Error('\p{Block=_/a/Meroitic_Cursive}');
    Error('\P{Block=_/a/Meroitic_Cursive}');
    Expect(1, 68095, '\p{Block=:\AMeroitic_Cursive\z:}', "");;
    Expect(0, 68096, '\p{Block=:\AMeroitic_Cursive\z:}', "");;
    Expect(1, 68095, '\p{Block=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Block=meroiticcursive}', "");
    Expect(0, 68095, '\P{Block=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Block=meroiticcursive}', "");
    Expect(0, 68096, '\p{Block=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Block=meroiticcursive}', "");
    Expect(1, 68096, '\P{Block=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Block=meroiticcursive}', "");
    Expect(1, 68095, '\p{Block=:\Ameroiticcursive\z:}', "");;
    Expect(0, 68096, '\p{Block=:\Ameroiticcursive\z:}', "");;
    Expect(1, 68095, '\p{Block=_meroitic_cursive}', "");
    Expect(0, 68095, '\p{^Block=_meroitic_cursive}', "");
    Expect(0, 68095, '\P{Block=_meroitic_cursive}', "");
    Expect(1, 68095, '\P{^Block=_meroitic_cursive}', "");
    Expect(0, 68096, '\p{Block=_meroitic_cursive}', "");
    Expect(1, 68096, '\p{^Block=_meroitic_cursive}', "");
    Expect(1, 68096, '\P{Block=_meroitic_cursive}', "");
    Expect(0, 68096, '\P{^Block=_meroitic_cursive}', "");
    Error('\p{Blk=_meroitic_Cursive/a/}');
    Error('\P{Blk=_meroitic_Cursive/a/}');
    Expect(1, 68095, '\p{Blk=:\AMeroitic_Cursive\z:}', "");;
    Expect(0, 68096, '\p{Blk=:\AMeroitic_Cursive\z:}', "");;
    Expect(1, 68095, '\p{Blk:   meroiticcursive}', "");
    Expect(0, 68095, '\p{^Blk:   meroiticcursive}', "");
    Expect(0, 68095, '\P{Blk:   meroiticcursive}', "");
    Expect(1, 68095, '\P{^Blk:   meroiticcursive}', "");
    Expect(0, 68096, '\p{Blk:   meroiticcursive}', "");
    Expect(1, 68096, '\p{^Blk:   meroiticcursive}', "");
    Expect(1, 68096, '\P{Blk:   meroiticcursive}', "");
    Expect(0, 68096, '\P{^Blk:   meroiticcursive}', "");
    Expect(1, 68095, '\p{Blk=:\Ameroiticcursive\z:}', "");;
    Expect(0, 68096, '\p{Blk=:\Ameroiticcursive\z:}', "");;
    Expect(1, 68095, '\p{Blk: _ meroitic_cursive}', "");
    Expect(0, 68095, '\p{^Blk: _ meroitic_cursive}', "");
    Expect(0, 68095, '\P{Blk: _ meroitic_cursive}', "");
    Expect(1, 68095, '\P{^Blk: _ meroitic_cursive}', "");
    Expect(0, 68096, '\p{Blk: _ meroitic_cursive}', "");
    Expect(1, 68096, '\p{^Blk: _ meroitic_cursive}', "");
    Expect(1, 68096, '\P{Blk: _ meroitic_cursive}', "");
    Expect(0, 68096, '\P{^Blk: _ meroitic_cursive}', "");
    Error('\p{Is_Block=-_Meroitic_cursive:=}');
    Error('\P{Is_Block=-_Meroitic_cursive:=}');
    Expect(1, 68095, '\p{Is_Block=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Is_Block=meroiticcursive}', "");
    Expect(0, 68095, '\P{Is_Block=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Is_Block=meroiticcursive}', "");
    Expect(0, 68096, '\p{Is_Block=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Is_Block=meroiticcursive}', "");
    Expect(1, 68096, '\P{Is_Block=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Is_Block=meroiticcursive}', "");
    Expect(1, 68095, '\p{Is_Block=--meroitic_CURSIVE}', "");
    Expect(0, 68095, '\p{^Is_Block=--meroitic_CURSIVE}', "");
    Expect(0, 68095, '\P{Is_Block=--meroitic_CURSIVE}', "");
    Expect(1, 68095, '\P{^Is_Block=--meroitic_CURSIVE}', "");
    Expect(0, 68096, '\p{Is_Block=--meroitic_CURSIVE}', "");
    Expect(1, 68096, '\p{^Is_Block=--meroitic_CURSIVE}', "");
    Expect(1, 68096, '\P{Is_Block=--meroitic_CURSIVE}', "");
    Expect(0, 68096, '\P{^Is_Block=--meroitic_CURSIVE}', "");
    Error('\p{Is_Blk= /a/Meroitic_cursive}');
    Error('\P{Is_Blk= /a/Meroitic_cursive}');
    Expect(1, 68095, '\p{Is_Blk=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Is_Blk=meroiticcursive}', "");
    Expect(0, 68095, '\P{Is_Blk=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Is_Blk=meroiticcursive}', "");
    Expect(0, 68096, '\p{Is_Blk=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Is_Blk=meroiticcursive}', "");
    Expect(1, 68096, '\P{Is_Blk=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Is_Blk=meroiticcursive}', "");
    Expect(1, 68095, '\p{Is_Blk=-_MEROITIC_cursive}', "");
    Expect(0, 68095, '\p{^Is_Blk=-_MEROITIC_cursive}', "");
    Expect(0, 68095, '\P{Is_Blk=-_MEROITIC_cursive}', "");
    Expect(1, 68095, '\P{^Is_Blk=-_MEROITIC_cursive}', "");
    Expect(0, 68096, '\p{Is_Blk=-_MEROITIC_cursive}', "");
    Expect(1, 68096, '\p{^Is_Blk=-_MEROITIC_cursive}', "");
    Expect(1, 68096, '\P{Is_Blk=-_MEROITIC_cursive}', "");
    Expect(0, 68096, '\P{^Is_Blk=-_MEROITIC_cursive}', "");
    Error('\p{Block=-:=MEROITIC_Hieroglyphs}');
    Error('\P{Block=-:=MEROITIC_Hieroglyphs}');
    Expect(1, 67999, '\p{Block=:\AMeroitic_Hieroglyphs\z:}', "");;
    Expect(0, 68000, '\p{Block=:\AMeroitic_Hieroglyphs\z:}', "");;
    Expect(1, 67999, '\p{Block:meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Block:meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Block:meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Block:meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Block:meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Block:meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Block:meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Block:meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Block=:\Ameroitichieroglyphs\z:}', "");;
    Expect(0, 68000, '\p{Block=:\Ameroitichieroglyphs\z:}', "");;
    Expect(1, 67999, '\p{Block:	-Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^Block:	-Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\P{Block:	-Meroitic_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^Block:	-Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\p{Block:	-Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^Block:	-Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\P{Block:	-Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^Block:	-Meroitic_Hieroglyphs}', "");
    Error('\p{Blk:    /a/Meroitic_HIEROGLYPHS}');
    Error('\P{Blk:    /a/Meroitic_HIEROGLYPHS}');
    Expect(1, 67999, '\p{Blk=:\AMeroitic_Hieroglyphs\z:}', "");;
    Expect(0, 68000, '\p{Blk=:\AMeroitic_Hieroglyphs\z:}', "");;
    Expect(1, 67999, '\p{Blk=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Blk=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Blk=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Blk=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Blk=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Blk=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Blk=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Blk=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Blk=:\Ameroitichieroglyphs\z:}', "");;
    Expect(0, 68000, '\p{Blk=:\Ameroitichieroglyphs\z:}', "");;
    Expect(1, 67999, '\p{Blk= Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^Blk= Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\P{Blk= Meroitic_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^Blk= Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\p{Blk= Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^Blk= Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\P{Blk= Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^Blk= Meroitic_Hieroglyphs}', "");
    Error('\p{Is_Block=_MEROITIC_Hieroglyphs/a/}');
    Error('\P{Is_Block=_MEROITIC_Hieroglyphs/a/}');
    Expect(1, 67999, '\p{Is_Block:   meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Block:   meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Block:   meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Block:   meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Block:   meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Block:   meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Block:   meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Block:   meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Is_Block= MEROITIC_hieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Block= MEROITIC_hieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Block= MEROITIC_hieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Block= MEROITIC_hieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Block= MEROITIC_hieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Block= MEROITIC_hieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Block= MEROITIC_hieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Block= MEROITIC_hieroglyphs}', "");
    Error('\p{Is_Blk=MEROITIC_HIEROGLYPHS:=}');
    Error('\P{Is_Blk=MEROITIC_HIEROGLYPHS:=}');
    Expect(1, 67999, '\p{Is_Blk=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Blk=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Blk=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Blk=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Blk=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Blk=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Blk=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Blk=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Is_Blk= Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Blk= Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Blk= Meroitic_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Blk= Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Blk= Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Blk= Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Blk= Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Blk= Meroitic_Hieroglyphs}', "");
    Error('\p{Block=_:=Miao}');
    Error('\P{Block=_:=Miao}');
    Expect(1, 94111, '\p{Block=:\AMiao\z:}', "");;
    Expect(0, 94112, '\p{Block=:\AMiao\z:}', "");;
    Expect(1, 94111, '\p{Block=miao}', "");
    Expect(0, 94111, '\p{^Block=miao}', "");
    Expect(0, 94111, '\P{Block=miao}', "");
    Expect(1, 94111, '\P{^Block=miao}', "");
    Expect(0, 94112, '\p{Block=miao}', "");
    Expect(1, 94112, '\p{^Block=miao}', "");
    Expect(1, 94112, '\P{Block=miao}', "");
    Expect(0, 94112, '\P{^Block=miao}', "");
    Expect(1, 94111, '\p{Block=:\Amiao\z:}', "");;
    Expect(0, 94112, '\p{Block=:\Amiao\z:}', "");;
    Expect(1, 94111, '\p{Block=	-Miao}', "");
    Expect(0, 94111, '\p{^Block=	-Miao}', "");
    Expect(0, 94111, '\P{Block=	-Miao}', "");
    Expect(1, 94111, '\P{^Block=	-Miao}', "");
    Expect(0, 94112, '\p{Block=	-Miao}', "");
    Expect(1, 94112, '\p{^Block=	-Miao}', "");
    Expect(1, 94112, '\P{Block=	-Miao}', "");
    Expect(0, 94112, '\P{^Block=	-Miao}', "");
    Error('\p{Blk= :=Miao}');
    Error('\P{Blk= :=Miao}');
    Expect(1, 94111, '\p{Blk=:\AMiao\z:}', "");;
    Expect(0, 94112, '\p{Blk=:\AMiao\z:}', "");;
    Expect(1, 94111, '\p{Blk=miao}', "");
    Expect(0, 94111, '\p{^Blk=miao}', "");
    Expect(0, 94111, '\P{Blk=miao}', "");
    Expect(1, 94111, '\P{^Blk=miao}', "");
    Expect(0, 94112, '\p{Blk=miao}', "");
    Expect(1, 94112, '\p{^Blk=miao}', "");
    Expect(1, 94112, '\P{Blk=miao}', "");
    Expect(0, 94112, '\P{^Blk=miao}', "");
    Expect(1, 94111, '\p{Blk=:\Amiao\z:}', "");;
    Expect(0, 94112, '\p{Blk=:\Amiao\z:}', "");;
    Expect(1, 94111, '\p{Blk=--Miao}', "");
    Expect(0, 94111, '\p{^Blk=--Miao}', "");
    Expect(0, 94111, '\P{Blk=--Miao}', "");
    Expect(1, 94111, '\P{^Blk=--Miao}', "");
    Expect(0, 94112, '\p{Blk=--Miao}', "");
    Expect(1, 94112, '\p{^Blk=--Miao}', "");
    Expect(1, 94112, '\P{Blk=--Miao}', "");
    Expect(0, 94112, '\P{^Blk=--Miao}', "");
    Error('\p{Is_Block=:=_	Miao}');
    Error('\P{Is_Block=:=_	Miao}');
    Expect(1, 94111, '\p{Is_Block=miao}', "");
    Expect(0, 94111, '\p{^Is_Block=miao}', "");
    Expect(0, 94111, '\P{Is_Block=miao}', "");
    Expect(1, 94111, '\P{^Is_Block=miao}', "");
    Expect(0, 94112, '\p{Is_Block=miao}', "");
    Expect(1, 94112, '\p{^Is_Block=miao}', "");
    Expect(1, 94112, '\P{Is_Block=miao}', "");
    Expect(0, 94112, '\P{^Is_Block=miao}', "");
    Expect(1, 94111, '\p{Is_Block=_Miao}', "");
    Expect(0, 94111, '\p{^Is_Block=_Miao}', "");
    Expect(0, 94111, '\P{Is_Block=_Miao}', "");
    Expect(1, 94111, '\P{^Is_Block=_Miao}', "");
    Expect(0, 94112, '\p{Is_Block=_Miao}', "");
    Expect(1, 94112, '\p{^Is_Block=_Miao}', "");
    Expect(1, 94112, '\P{Is_Block=_Miao}', "");
    Expect(0, 94112, '\P{^Is_Block=_Miao}', "");
    Error('\p{Is_Blk=:=Miao}');
    Error('\P{Is_Blk=:=Miao}');
    Expect(1, 94111, '\p{Is_Blk=miao}', "");
    Expect(0, 94111, '\p{^Is_Blk=miao}', "");
    Expect(0, 94111, '\P{Is_Blk=miao}', "");
    Expect(1, 94111, '\P{^Is_Blk=miao}', "");
    Expect(0, 94112, '\p{Is_Blk=miao}', "");
    Expect(1, 94112, '\p{^Is_Blk=miao}', "");
    Expect(1, 94112, '\P{Is_Blk=miao}', "");
    Expect(0, 94112, '\P{^Is_Blk=miao}', "");
    Expect(1, 94111, '\p{Is_Blk=	Miao}', "");
    Expect(0, 94111, '\p{^Is_Blk=	Miao}', "");
    Expect(0, 94111, '\P{Is_Blk=	Miao}', "");
    Expect(1, 94111, '\P{^Is_Blk=	Miao}', "");
    Expect(0, 94112, '\p{Is_Blk=	Miao}', "");
    Expect(1, 94112, '\p{^Is_Blk=	Miao}', "");
    Expect(1, 94112, '\P{Is_Blk=	Miao}', "");
    Expect(0, 94112, '\P{^Is_Blk=	Miao}', "");
    Error('\p{Block:	-:=miscellaneous_Symbols_AND_Arrows}');
    Error('\P{Block:	-:=miscellaneous_Symbols_AND_Arrows}');
    Expect(1, 11263, '\p{Block=:\AMiscellaneous_Symbols_And_Arrows\z:}', "");;
    Expect(0, 11264, '\p{Block=:\AMiscellaneous_Symbols_And_Arrows\z:}', "");;
    Expect(1, 11263, '\p{Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\p{^Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\P{Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\P{^Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\p{Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\p{^Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\P{Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\P{^Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\p{Block=:\Amiscellaneoussymbolsandarrows\z:}', "");;
    Expect(0, 11264, '\p{Block=:\Amiscellaneoussymbolsandarrows\z:}', "");;
    Expect(1, 11263, '\p{Block=_	MISCELLANEOUS_symbols_AND_ARROWS}', "");
    Expect(0, 11263, '\p{^Block=_	MISCELLANEOUS_symbols_AND_ARROWS}', "");
    Expect(0, 11263, '\P{Block=_	MISCELLANEOUS_symbols_AND_ARROWS}', "");
    Expect(1, 11263, '\P{^Block=_	MISCELLANEOUS_symbols_AND_ARROWS}', "");
    Expect(0, 11264, '\p{Block=_	MISCELLANEOUS_symbols_AND_ARROWS}', "");
    Expect(1, 11264, '\p{^Block=_	MISCELLANEOUS_symbols_AND_ARROWS}', "");
    Expect(1, 11264, '\P{Block=_	MISCELLANEOUS_symbols_AND_ARROWS}', "");
    Expect(0, 11264, '\P{^Block=_	MISCELLANEOUS_symbols_AND_ARROWS}', "");
    Error('\p{Blk=--Misc_ARROWS:=}');
    Error('\P{Blk=--Misc_ARROWS:=}');
    Expect(1, 11263, '\p{Blk=:\AMisc_Arrows\z:}', "");;
    Expect(0, 11264, '\p{Blk=:\AMisc_Arrows\z:}', "");;
    Expect(1, 11263, '\p{Blk=miscarrows}', "");
    Expect(0, 11263, '\p{^Blk=miscarrows}', "");
    Expect(0, 11263, '\P{Blk=miscarrows}', "");
    Expect(1, 11263, '\P{^Blk=miscarrows}', "");
    Expect(0, 11264, '\p{Blk=miscarrows}', "");
    Expect(1, 11264, '\p{^Blk=miscarrows}', "");
    Expect(1, 11264, '\P{Blk=miscarrows}', "");
    Expect(0, 11264, '\P{^Blk=miscarrows}', "");
    Expect(1, 11263, '\p{Blk=:\Amiscarrows\z:}', "");;
    Expect(0, 11264, '\p{Blk=:\Amiscarrows\z:}', "");;
    Expect(1, 11263, '\p{Blk=	 Misc_arrows}', "");
    Expect(0, 11263, '\p{^Blk=	 Misc_arrows}', "");
    Expect(0, 11263, '\P{Blk=	 Misc_arrows}', "");
    Expect(1, 11263, '\P{^Blk=	 Misc_arrows}', "");
    Expect(0, 11264, '\p{Blk=	 Misc_arrows}', "");
    Expect(1, 11264, '\p{^Blk=	 Misc_arrows}', "");
    Expect(1, 11264, '\P{Blk=	 Misc_arrows}', "");
    Expect(0, 11264, '\P{^Blk=	 Misc_arrows}', "");
    Error('\p{Is_Block= -MISCELLANEOUS_SYMBOLS_AND_arrows:=}');
    Error('\P{Is_Block= -MISCELLANEOUS_SYMBOLS_AND_arrows:=}');
    Expect(1, 11263, '\p{Is_Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\p{^Is_Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\P{Is_Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\P{^Is_Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\p{Is_Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\p{^Is_Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\P{Is_Block=miscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\P{^Is_Block=miscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\p{Is_Block=-Miscellaneous_symbols_And_Arrows}', "");
    Expect(0, 11263, '\p{^Is_Block=-Miscellaneous_symbols_And_Arrows}', "");
    Expect(0, 11263, '\P{Is_Block=-Miscellaneous_symbols_And_Arrows}', "");
    Expect(1, 11263, '\P{^Is_Block=-Miscellaneous_symbols_And_Arrows}', "");
    Expect(0, 11264, '\p{Is_Block=-Miscellaneous_symbols_And_Arrows}', "");
    Expect(1, 11264, '\p{^Is_Block=-Miscellaneous_symbols_And_Arrows}', "");
    Expect(1, 11264, '\P{Is_Block=-Miscellaneous_symbols_And_Arrows}', "");
    Expect(0, 11264, '\P{^Is_Block=-Miscellaneous_symbols_And_Arrows}', "");
    Error('\p{Is_Blk:	_MISC_arrows:=}');
    Error('\P{Is_Blk:	_MISC_arrows:=}');
    Expect(1, 11263, '\p{Is_Blk=miscarrows}', "");
    Expect(0, 11263, '\p{^Is_Blk=miscarrows}', "");
    Expect(0, 11263, '\P{Is_Blk=miscarrows}', "");
    Expect(1, 11263, '\P{^Is_Blk=miscarrows}', "");
    Expect(0, 11264, '\p{Is_Blk=miscarrows}', "");
    Expect(1, 11264, '\p{^Is_Blk=miscarrows}', "");
    Expect(1, 11264, '\P{Is_Blk=miscarrows}', "");
    Expect(0, 11264, '\P{^Is_Blk=miscarrows}', "");
    Expect(1, 11263, '\p{Is_Blk=  MISC_ARROWS}', "");
    Expect(0, 11263, '\p{^Is_Blk=  MISC_ARROWS}', "");
    Expect(0, 11263, '\P{Is_Blk=  MISC_ARROWS}', "");
    Expect(1, 11263, '\P{^Is_Blk=  MISC_ARROWS}', "");
    Expect(0, 11264, '\p{Is_Blk=  MISC_ARROWS}', "");
    Expect(1, 11264, '\p{^Is_Blk=  MISC_ARROWS}', "");
    Expect(1, 11264, '\P{Is_Blk=  MISC_ARROWS}', "");
    Expect(0, 11264, '\P{^Is_Blk=  MISC_ARROWS}', "");
    Error('\p{Block=		MISCELLANEOUS_MATHEMATICAL_SYMBOLS_a/a/}');
    Error('\P{Block=		MISCELLANEOUS_MATHEMATICAL_SYMBOLS_a/a/}');
    Expect(1, 10223, '\p{Block=:\AMiscellaneous_Mathematical_Symbols_A\z:}', "");;
    Expect(0, 10224, '\p{Block=:\AMiscellaneous_Mathematical_Symbols_A\z:}', "");;
    Expect(1, 10223, '\p{Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\p{^Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\P{Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\P{^Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\p{Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\p{^Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\P{Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\P{^Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\p{Block=:\Amiscellaneousmathematicalsymbolsa\z:}', "");;
    Expect(0, 10224, '\p{Block=:\Amiscellaneousmathematicalsymbolsa\z:}', "");;
    Expect(1, 10223, '\p{Block=_	miscellaneous_Mathematical_Symbols_a}', "");
    Expect(0, 10223, '\p{^Block=_	miscellaneous_Mathematical_Symbols_a}', "");
    Expect(0, 10223, '\P{Block=_	miscellaneous_Mathematical_Symbols_a}', "");
    Expect(1, 10223, '\P{^Block=_	miscellaneous_Mathematical_Symbols_a}', "");
    Expect(0, 10224, '\p{Block=_	miscellaneous_Mathematical_Symbols_a}', "");
    Expect(1, 10224, '\p{^Block=_	miscellaneous_Mathematical_Symbols_a}', "");
    Expect(1, 10224, '\P{Block=_	miscellaneous_Mathematical_Symbols_a}', "");
    Expect(0, 10224, '\P{^Block=_	miscellaneous_Mathematical_Symbols_a}', "");
    Error('\p{Blk=/a/_Misc_Math_Symbols_a}');
    Error('\P{Blk=/a/_Misc_Math_Symbols_a}');
    Expect(1, 10223, '\p{Blk=:\AMisc_Math_Symbols_A\z:}', "");;
    Expect(0, 10224, '\p{Blk=:\AMisc_Math_Symbols_A\z:}', "");;
    Expect(1, 10223, '\p{Blk=miscmathsymbolsa}', "");
    Expect(0, 10223, '\p{^Blk=miscmathsymbolsa}', "");
    Expect(0, 10223, '\P{Blk=miscmathsymbolsa}', "");
    Expect(1, 10223, '\P{^Blk=miscmathsymbolsa}', "");
    Expect(0, 10224, '\p{Blk=miscmathsymbolsa}', "");
    Expect(1, 10224, '\p{^Blk=miscmathsymbolsa}', "");
    Expect(1, 10224, '\P{Blk=miscmathsymbolsa}', "");
    Expect(0, 10224, '\P{^Blk=miscmathsymbolsa}', "");
    Expect(1, 10223, '\p{Blk=:\Amiscmathsymbolsa\z:}', "");;
    Expect(0, 10224, '\p{Blk=:\Amiscmathsymbolsa\z:}', "");;
    Expect(1, 10223, '\p{Blk=_Misc_Math_Symbols_A}', "");
    Expect(0, 10223, '\p{^Blk=_Misc_Math_Symbols_A}', "");
    Expect(0, 10223, '\P{Blk=_Misc_Math_Symbols_A}', "");
    Expect(1, 10223, '\P{^Blk=_Misc_Math_Symbols_A}', "");
    Expect(0, 10224, '\p{Blk=_Misc_Math_Symbols_A}', "");
    Expect(1, 10224, '\p{^Blk=_Misc_Math_Symbols_A}', "");
    Expect(1, 10224, '\P{Blk=_Misc_Math_Symbols_A}', "");
    Expect(0, 10224, '\P{^Blk=_Misc_Math_Symbols_A}', "");
    Error('\p{Is_Block=:=_	Miscellaneous_Mathematical_SYMBOLS_a}');
    Error('\P{Is_Block=:=_	Miscellaneous_Mathematical_SYMBOLS_a}');
    Expect(1, 10223, '\p{Is_Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\p{^Is_Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\P{Is_Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\P{^Is_Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\p{Is_Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\p{^Is_Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\P{Is_Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\P{^Is_Block=miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\p{Is_Block=	 miscellaneous_MATHEMATICAL_Symbols_A}', "");
    Expect(0, 10223, '\p{^Is_Block=	 miscellaneous_MATHEMATICAL_Symbols_A}', "");
    Expect(0, 10223, '\P{Is_Block=	 miscellaneous_MATHEMATICAL_Symbols_A}', "");
    Expect(1, 10223, '\P{^Is_Block=	 miscellaneous_MATHEMATICAL_Symbols_A}', "");
    Expect(0, 10224, '\p{Is_Block=	 miscellaneous_MATHEMATICAL_Symbols_A}', "");
    Expect(1, 10224, '\p{^Is_Block=	 miscellaneous_MATHEMATICAL_Symbols_A}', "");
    Expect(1, 10224, '\P{Is_Block=	 miscellaneous_MATHEMATICAL_Symbols_A}', "");
    Expect(0, 10224, '\P{^Is_Block=	 miscellaneous_MATHEMATICAL_Symbols_A}', "");
    Error('\p{Is_Blk=/a/	_Misc_MATH_SYMBOLS_a}');
    Error('\P{Is_Blk=/a/	_Misc_MATH_SYMBOLS_a}');
    Expect(1, 10223, '\p{Is_Blk=miscmathsymbolsa}', "");
    Expect(0, 10223, '\p{^Is_Blk=miscmathsymbolsa}', "");
    Expect(0, 10223, '\P{Is_Blk=miscmathsymbolsa}', "");
    Expect(1, 10223, '\P{^Is_Blk=miscmathsymbolsa}', "");
    Expect(0, 10224, '\p{Is_Blk=miscmathsymbolsa}', "");
    Expect(1, 10224, '\p{^Is_Blk=miscmathsymbolsa}', "");
    Expect(1, 10224, '\P{Is_Blk=miscmathsymbolsa}', "");
    Expect(0, 10224, '\P{^Is_Blk=miscmathsymbolsa}', "");
    Expect(1, 10223, '\p{Is_Blk= Misc_Math_symbols_A}', "");
    Expect(0, 10223, '\p{^Is_Blk= Misc_Math_symbols_A}', "");
    Expect(0, 10223, '\P{Is_Blk= Misc_Math_symbols_A}', "");
    Expect(1, 10223, '\P{^Is_Blk= Misc_Math_symbols_A}', "");
    Expect(0, 10224, '\p{Is_Blk= Misc_Math_symbols_A}', "");
    Expect(1, 10224, '\p{^Is_Blk= Misc_Math_symbols_A}', "");
    Expect(1, 10224, '\P{Is_Blk= Misc_Math_symbols_A}', "");
    Expect(0, 10224, '\P{^Is_Blk= Misc_Math_symbols_A}', "");
    Error('\p{Block=/a/-miscellaneous_Mathematical_Symbols_b}');
    Error('\P{Block=/a/-miscellaneous_Mathematical_Symbols_b}');
    Expect(1, 10751, '\p{Block=:\AMiscellaneous_Mathematical_Symbols_B\z:}', "");;
    Expect(0, 10752, '\p{Block=:\AMiscellaneous_Mathematical_Symbols_B\z:}', "");;
    Expect(1, 10751, '\p{Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\p{^Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\P{Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\P{^Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\p{Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\p{^Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\P{Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\P{^Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\p{Block=:\Amiscellaneousmathematicalsymbolsb\z:}', "");;
    Expect(0, 10752, '\p{Block=:\Amiscellaneousmathematicalsymbolsb\z:}', "");;
    Expect(1, 10751, '\p{Block=- miscellaneous_mathematical_Symbols_B}', "");
    Expect(0, 10751, '\p{^Block=- miscellaneous_mathematical_Symbols_B}', "");
    Expect(0, 10751, '\P{Block=- miscellaneous_mathematical_Symbols_B}', "");
    Expect(1, 10751, '\P{^Block=- miscellaneous_mathematical_Symbols_B}', "");
    Expect(0, 10752, '\p{Block=- miscellaneous_mathematical_Symbols_B}', "");
    Expect(1, 10752, '\p{^Block=- miscellaneous_mathematical_Symbols_B}', "");
    Expect(1, 10752, '\P{Block=- miscellaneous_mathematical_Symbols_B}', "");
    Expect(0, 10752, '\P{^Block=- miscellaneous_mathematical_Symbols_B}', "");
    Error('\p{Blk=:=MISC_Math_SYMBOLS_B}');
    Error('\P{Blk=:=MISC_Math_SYMBOLS_B}');
    Expect(1, 10751, '\p{Blk=:\AMisc_Math_Symbols_B\z:}', "");;
    Expect(0, 10752, '\p{Blk=:\AMisc_Math_Symbols_B\z:}', "");;
    Expect(1, 10751, '\p{Blk=miscmathsymbolsb}', "");
    Expect(0, 10751, '\p{^Blk=miscmathsymbolsb}', "");
    Expect(0, 10751, '\P{Blk=miscmathsymbolsb}', "");
    Expect(1, 10751, '\P{^Blk=miscmathsymbolsb}', "");
    Expect(0, 10752, '\p{Blk=miscmathsymbolsb}', "");
    Expect(1, 10752, '\p{^Blk=miscmathsymbolsb}', "");
    Expect(1, 10752, '\P{Blk=miscmathsymbolsb}', "");
    Expect(0, 10752, '\P{^Blk=miscmathsymbolsb}', "");
    Expect(1, 10751, '\p{Blk=:\Amiscmathsymbolsb\z:}', "");;
    Expect(0, 10752, '\p{Blk=:\Amiscmathsymbolsb\z:}', "");;
    Expect(1, 10751, '\p{Blk=_ Misc_Math_SYMBOLS_B}', "");
    Expect(0, 10751, '\p{^Blk=_ Misc_Math_SYMBOLS_B}', "");
    Expect(0, 10751, '\P{Blk=_ Misc_Math_SYMBOLS_B}', "");
    Expect(1, 10751, '\P{^Blk=_ Misc_Math_SYMBOLS_B}', "");
    Expect(0, 10752, '\p{Blk=_ Misc_Math_SYMBOLS_B}', "");
    Expect(1, 10752, '\p{^Blk=_ Misc_Math_SYMBOLS_B}', "");
    Expect(1, 10752, '\P{Blk=_ Misc_Math_SYMBOLS_B}', "");
    Expect(0, 10752, '\P{^Blk=_ Misc_Math_SYMBOLS_B}', "");
    Error('\p{Is_Block=- Miscellaneous_MATHEMATICAL_Symbols_b:=}');
    Error('\P{Is_Block=- Miscellaneous_MATHEMATICAL_Symbols_b:=}');
    Expect(1, 10751, '\p{Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\p{^Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\P{Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\P{^Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\p{Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\p{^Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\P{Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\P{^Is_Block=miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\p{Is_Block=_ Miscellaneous_MATHEMATICAL_Symbols_B}', "");
    Expect(0, 10751, '\p{^Is_Block=_ Miscellaneous_MATHEMATICAL_Symbols_B}', "");
    Expect(0, 10751, '\P{Is_Block=_ Miscellaneous_MATHEMATICAL_Symbols_B}', "");
    Expect(1, 10751, '\P{^Is_Block=_ Miscellaneous_MATHEMATICAL_Symbols_B}', "");
    Expect(0, 10752, '\p{Is_Block=_ Miscellaneous_MATHEMATICAL_Symbols_B}', "");
    Expect(1, 10752, '\p{^Is_Block=_ Miscellaneous_MATHEMATICAL_Symbols_B}', "");
    Expect(1, 10752, '\P{Is_Block=_ Miscellaneous_MATHEMATICAL_Symbols_B}', "");
    Expect(0, 10752, '\P{^Is_Block=_ Miscellaneous_MATHEMATICAL_Symbols_B}', "");
    Error('\p{Is_Blk=/a/Misc_math_SYMBOLS_b}');
    Error('\P{Is_Blk=/a/Misc_math_SYMBOLS_b}');
    Expect(1, 10751, '\p{Is_Blk=miscmathsymbolsb}', "");
    Expect(0, 10751, '\p{^Is_Blk=miscmathsymbolsb}', "");
    Expect(0, 10751, '\P{Is_Blk=miscmathsymbolsb}', "");
    Expect(1, 10751, '\P{^Is_Blk=miscmathsymbolsb}', "");
    Expect(0, 10752, '\p{Is_Blk=miscmathsymbolsb}', "");
    Expect(1, 10752, '\p{^Is_Blk=miscmathsymbolsb}', "");
    Expect(1, 10752, '\P{Is_Blk=miscmathsymbolsb}', "");
    Expect(0, 10752, '\P{^Is_Blk=miscmathsymbolsb}', "");
    Expect(1, 10751, '\p{Is_Blk=-_MISC_math_Symbols_B}', "");
    Expect(0, 10751, '\p{^Is_Blk=-_MISC_math_Symbols_B}', "");
    Expect(0, 10751, '\P{Is_Blk=-_MISC_math_Symbols_B}', "");
    Expect(1, 10751, '\P{^Is_Blk=-_MISC_math_Symbols_B}', "");
    Expect(0, 10752, '\p{Is_Blk=-_MISC_math_Symbols_B}', "");
    Expect(1, 10752, '\p{^Is_Blk=-_MISC_math_Symbols_B}', "");
    Expect(1, 10752, '\P{Is_Blk=-_MISC_math_Symbols_B}', "");
    Expect(0, 10752, '\P{^Is_Blk=-_MISC_math_Symbols_B}', "");
    Error('\p{Block=/a/  Miscellaneous_SYMBOLS_AND_pictographs}');
    Error('\P{Block=/a/  Miscellaneous_SYMBOLS_AND_pictographs}');
    Expect(1, 128511, '\p{Block=:\AMiscellaneous_Symbols_And_Pictographs\z:}', "");;
    Expect(0, 128512, '\p{Block=:\AMiscellaneous_Symbols_And_Pictographs\z:}', "");;
    Expect(1, 128511, '\p{Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\p{^Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\P{Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\P{^Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\p{Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\p{^Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\P{Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\P{^Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\p{Block=:\Amiscellaneoussymbolsandpictographs\z:}', "");;
    Expect(0, 128512, '\p{Block=:\Amiscellaneoussymbolsandpictographs\z:}', "");;
    Expect(1, 128511, '\p{Block=_miscellaneous_Symbols_AND_Pictographs}', "");
    Expect(0, 128511, '\p{^Block=_miscellaneous_Symbols_AND_Pictographs}', "");
    Expect(0, 128511, '\P{Block=_miscellaneous_Symbols_AND_Pictographs}', "");
    Expect(1, 128511, '\P{^Block=_miscellaneous_Symbols_AND_Pictographs}', "");
    Expect(0, 128512, '\p{Block=_miscellaneous_Symbols_AND_Pictographs}', "");
    Expect(1, 128512, '\p{^Block=_miscellaneous_Symbols_AND_Pictographs}', "");
    Expect(1, 128512, '\P{Block=_miscellaneous_Symbols_AND_Pictographs}', "");
    Expect(0, 128512, '\P{^Block=_miscellaneous_Symbols_AND_Pictographs}', "");
    Error('\p{Blk=	-Misc_Pictographs:=}');
    Error('\P{Blk=	-Misc_Pictographs:=}');
    Expect(1, 128511, '\p{Blk=:\AMisc_Pictographs\z:}', "");;
    Expect(0, 128512, '\p{Blk=:\AMisc_Pictographs\z:}', "");;
    Expect(1, 128511, '\p{Blk=miscpictographs}', "");
    Expect(0, 128511, '\p{^Blk=miscpictographs}', "");
    Expect(0, 128511, '\P{Blk=miscpictographs}', "");
    Expect(1, 128511, '\P{^Blk=miscpictographs}', "");
    Expect(0, 128512, '\p{Blk=miscpictographs}', "");
    Expect(1, 128512, '\p{^Blk=miscpictographs}', "");
    Expect(1, 128512, '\P{Blk=miscpictographs}', "");
    Expect(0, 128512, '\P{^Blk=miscpictographs}', "");
    Expect(1, 128511, '\p{Blk=:\Amiscpictographs\z:}', "");;
    Expect(0, 128512, '\p{Blk=:\Amiscpictographs\z:}', "");;
    Expect(1, 128511, '\p{Blk:	_	misc_Pictographs}', "");
    Expect(0, 128511, '\p{^Blk:	_	misc_Pictographs}', "");
    Expect(0, 128511, '\P{Blk:	_	misc_Pictographs}', "");
    Expect(1, 128511, '\P{^Blk:	_	misc_Pictographs}', "");
    Expect(0, 128512, '\p{Blk:	_	misc_Pictographs}', "");
    Expect(1, 128512, '\p{^Blk:	_	misc_Pictographs}', "");
    Expect(1, 128512, '\P{Blk:	_	misc_Pictographs}', "");
    Expect(0, 128512, '\P{^Blk:	_	misc_Pictographs}', "");
    Error('\p{Is_Block=miscellaneous_SYMBOLS_and_PICTOGRAPHS:=}');
    Error('\P{Is_Block=miscellaneous_SYMBOLS_and_PICTOGRAPHS:=}');
    Expect(1, 128511, '\p{Is_Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\p{^Is_Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\P{Is_Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\P{^Is_Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\p{Is_Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\p{^Is_Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\P{Is_Block=miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\P{^Is_Block=miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\p{Is_Block=	_MISCELLANEOUS_symbols_And_pictographs}', "");
    Expect(0, 128511, '\p{^Is_Block=	_MISCELLANEOUS_symbols_And_pictographs}', "");
    Expect(0, 128511, '\P{Is_Block=	_MISCELLANEOUS_symbols_And_pictographs}', "");
    Expect(1, 128511, '\P{^Is_Block=	_MISCELLANEOUS_symbols_And_pictographs}', "");
    Expect(0, 128512, '\p{Is_Block=	_MISCELLANEOUS_symbols_And_pictographs}', "");
    Expect(1, 128512, '\p{^Is_Block=	_MISCELLANEOUS_symbols_And_pictographs}', "");
    Expect(1, 128512, '\P{Is_Block=	_MISCELLANEOUS_symbols_And_pictographs}', "");
    Expect(0, 128512, '\P{^Is_Block=	_MISCELLANEOUS_symbols_And_pictographs}', "");
    Error('\p{Is_Blk= 	Misc_PICTOGRAPHS/a/}');
    Error('\P{Is_Blk= 	Misc_PICTOGRAPHS/a/}');
    Expect(1, 128511, '\p{Is_Blk=miscpictographs}', "");
    Expect(0, 128511, '\p{^Is_Blk=miscpictographs}', "");
    Expect(0, 128511, '\P{Is_Blk=miscpictographs}', "");
    Expect(1, 128511, '\P{^Is_Blk=miscpictographs}', "");
    Expect(0, 128512, '\p{Is_Blk=miscpictographs}', "");
    Expect(1, 128512, '\p{^Is_Blk=miscpictographs}', "");
    Expect(1, 128512, '\P{Is_Blk=miscpictographs}', "");
    Expect(0, 128512, '\P{^Is_Blk=miscpictographs}', "");
    Expect(1, 128511, '\p{Is_Blk=	-Misc_PICTOGRAPHS}', "");
    Expect(0, 128511, '\p{^Is_Blk=	-Misc_PICTOGRAPHS}', "");
    Expect(0, 128511, '\P{Is_Blk=	-Misc_PICTOGRAPHS}', "");
    Expect(1, 128511, '\P{^Is_Blk=	-Misc_PICTOGRAPHS}', "");
    Expect(0, 128512, '\p{Is_Blk=	-Misc_PICTOGRAPHS}', "");
    Expect(1, 128512, '\p{^Is_Blk=	-Misc_PICTOGRAPHS}', "");
    Expect(1, 128512, '\P{Is_Blk=	-Misc_PICTOGRAPHS}', "");
    Expect(0, 128512, '\P{^Is_Blk=	-Misc_PICTOGRAPHS}', "");
    Error('\p{Block=	 Miscellaneous_SYMBOLS/a/}');
    Error('\P{Block=	 Miscellaneous_SYMBOLS/a/}');
    Expect(1, 9983, '\p{Block=:\AMiscellaneous_Symbols\z:}', "");;
    Expect(0, 9984, '\p{Block=:\AMiscellaneous_Symbols\z:}', "");;
    Expect(1, 9983, '\p{Block=miscellaneoussymbols}', "");
    Expect(0, 9983, '\p{^Block=miscellaneoussymbols}', "");
    Expect(0, 9983, '\P{Block=miscellaneoussymbols}', "");
    Expect(1, 9983, '\P{^Block=miscellaneoussymbols}', "");
    Expect(0, 9984, '\p{Block=miscellaneoussymbols}', "");
    Expect(1, 9984, '\p{^Block=miscellaneoussymbols}', "");
    Expect(1, 9984, '\P{Block=miscellaneoussymbols}', "");
    Expect(0, 9984, '\P{^Block=miscellaneoussymbols}', "");
    Expect(1, 9983, '\p{Block=:\Amiscellaneoussymbols\z:}', "");;
    Expect(0, 9984, '\p{Block=:\Amiscellaneoussymbols\z:}', "");;
    Expect(1, 9983, '\p{Block=	_Miscellaneous_Symbols}', "");
    Expect(0, 9983, '\p{^Block=	_Miscellaneous_Symbols}', "");
    Expect(0, 9983, '\P{Block=	_Miscellaneous_Symbols}', "");
    Expect(1, 9983, '\P{^Block=	_Miscellaneous_Symbols}', "");
    Expect(0, 9984, '\p{Block=	_Miscellaneous_Symbols}', "");
    Expect(1, 9984, '\p{^Block=	_Miscellaneous_Symbols}', "");
    Expect(1, 9984, '\P{Block=	_Miscellaneous_Symbols}', "");
    Expect(0, 9984, '\P{^Block=	_Miscellaneous_Symbols}', "");
    Error('\p{Blk=/a/Misc_Symbols}');
    Error('\P{Blk=/a/Misc_Symbols}');
    Expect(1, 9983, '\p{Blk=:\AMisc_Symbols\z:}', "");;
    Expect(0, 9984, '\p{Blk=:\AMisc_Symbols\z:}', "");;
    Expect(1, 9983, '\p{Blk=miscsymbols}', "");
    Expect(0, 9983, '\p{^Blk=miscsymbols}', "");
    Expect(0, 9983, '\P{Blk=miscsymbols}', "");
    Expect(1, 9983, '\P{^Blk=miscsymbols}', "");
    Expect(0, 9984, '\p{Blk=miscsymbols}', "");
    Expect(1, 9984, '\p{^Blk=miscsymbols}', "");
    Expect(1, 9984, '\P{Blk=miscsymbols}', "");
    Expect(0, 9984, '\P{^Blk=miscsymbols}', "");
    Expect(1, 9983, '\p{Blk=:\Amiscsymbols\z:}', "");;
    Expect(0, 9984, '\p{Blk=:\Amiscsymbols\z:}', "");;
    Expect(1, 9983, '\p{Blk=_Misc_symbols}', "");
    Expect(0, 9983, '\p{^Blk=_Misc_symbols}', "");
    Expect(0, 9983, '\P{Blk=_Misc_symbols}', "");
    Expect(1, 9983, '\P{^Blk=_Misc_symbols}', "");
    Expect(0, 9984, '\p{Blk=_Misc_symbols}', "");
    Expect(1, 9984, '\p{^Blk=_Misc_symbols}', "");
    Expect(1, 9984, '\P{Blk=_Misc_symbols}', "");
    Expect(0, 9984, '\P{^Blk=_Misc_symbols}', "");
    Error('\p{Is_Block=:=_	Miscellaneous_symbols}');
    Error('\P{Is_Block=:=_	Miscellaneous_symbols}');
    Expect(1, 9983, '\p{Is_Block=miscellaneoussymbols}', "");
    Expect(0, 9983, '\p{^Is_Block=miscellaneoussymbols}', "");
    Expect(0, 9983, '\P{Is_Block=miscellaneoussymbols}', "");
    Expect(1, 9983, '\P{^Is_Block=miscellaneoussymbols}', "");
    Expect(0, 9984, '\p{Is_Block=miscellaneoussymbols}', "");
    Expect(1, 9984, '\p{^Is_Block=miscellaneoussymbols}', "");
    Expect(1, 9984, '\P{Is_Block=miscellaneoussymbols}', "");
    Expect(0, 9984, '\P{^Is_Block=miscellaneoussymbols}', "");
    Expect(1, 9983, '\p{Is_Block= -MISCELLANEOUS_Symbols}', "");
    Expect(0, 9983, '\p{^Is_Block= -MISCELLANEOUS_Symbols}', "");
    Expect(0, 9983, '\P{Is_Block= -MISCELLANEOUS_Symbols}', "");
    Expect(1, 9983, '\P{^Is_Block= -MISCELLANEOUS_Symbols}', "");
    Expect(0, 9984, '\p{Is_Block= -MISCELLANEOUS_Symbols}', "");
    Expect(1, 9984, '\p{^Is_Block= -MISCELLANEOUS_Symbols}', "");
    Expect(1, 9984, '\P{Is_Block= -MISCELLANEOUS_Symbols}', "");
    Expect(0, 9984, '\P{^Is_Block= -MISCELLANEOUS_Symbols}', "");
    Error('\p{Is_Blk=:= misc_Symbols}');
    Error('\P{Is_Blk=:= misc_Symbols}');
    Expect(1, 9983, '\p{Is_Blk=miscsymbols}', "");
    Expect(0, 9983, '\p{^Is_Blk=miscsymbols}', "");
    Expect(0, 9983, '\P{Is_Blk=miscsymbols}', "");
    Expect(1, 9983, '\P{^Is_Blk=miscsymbols}', "");
    Expect(0, 9984, '\p{Is_Blk=miscsymbols}', "");
    Expect(1, 9984, '\p{^Is_Blk=miscsymbols}', "");
    Expect(1, 9984, '\P{Is_Blk=miscsymbols}', "");
    Expect(0, 9984, '\P{^Is_Blk=miscsymbols}', "");
    Expect(1, 9983, '\p{Is_Blk:-	Misc_symbols}', "");
    Expect(0, 9983, '\p{^Is_Blk:-	Misc_symbols}', "");
    Expect(0, 9983, '\P{Is_Blk:-	Misc_symbols}', "");
    Expect(1, 9983, '\P{^Is_Blk:-	Misc_symbols}', "");
    Expect(0, 9984, '\p{Is_Blk:-	Misc_symbols}', "");
    Expect(1, 9984, '\p{^Is_Blk:-	Misc_symbols}', "");
    Expect(1, 9984, '\P{Is_Blk:-	Misc_symbols}', "");
    Expect(0, 9984, '\P{^Is_Blk:-	Misc_symbols}', "");
    Error('\p{Block=:=-MISCELLANEOUS_Technical}');
    Error('\P{Block=:=-MISCELLANEOUS_Technical}');
    Expect(1, 9215, '\p{Block=:\AMiscellaneous_Technical\z:}', "");;
    Expect(0, 9216, '\p{Block=:\AMiscellaneous_Technical\z:}', "");;
    Expect(1, 9215, '\p{Block=miscellaneoustechnical}', "");
    Expect(0, 9215, '\p{^Block=miscellaneoustechnical}', "");
    Expect(0, 9215, '\P{Block=miscellaneoustechnical}', "");
    Expect(1, 9215, '\P{^Block=miscellaneoustechnical}', "");
    Expect(0, 9216, '\p{Block=miscellaneoustechnical}', "");
    Expect(1, 9216, '\p{^Block=miscellaneoustechnical}', "");
    Expect(1, 9216, '\P{Block=miscellaneoustechnical}', "");
    Expect(0, 9216, '\P{^Block=miscellaneoustechnical}', "");
    Expect(1, 9215, '\p{Block=:\Amiscellaneoustechnical\z:}', "");;
    Expect(0, 9216, '\p{Block=:\Amiscellaneoustechnical\z:}', "");;
    Expect(1, 9215, '\p{Block:	_	MISCELLANEOUS_Technical}', "");
    Expect(0, 9215, '\p{^Block:	_	MISCELLANEOUS_Technical}', "");
    Expect(0, 9215, '\P{Block:	_	MISCELLANEOUS_Technical}', "");
    Expect(1, 9215, '\P{^Block:	_	MISCELLANEOUS_Technical}', "");
    Expect(0, 9216, '\p{Block:	_	MISCELLANEOUS_Technical}', "");
    Expect(1, 9216, '\p{^Block:	_	MISCELLANEOUS_Technical}', "");
    Expect(1, 9216, '\P{Block:	_	MISCELLANEOUS_Technical}', "");
    Expect(0, 9216, '\P{^Block:	_	MISCELLANEOUS_Technical}', "");
    Error('\p{Blk=:=	Misc_Technical}');
    Error('\P{Blk=:=	Misc_Technical}');
    Expect(1, 9215, '\p{Blk=:\AMisc_Technical\z:}', "");;
    Expect(0, 9216, '\p{Blk=:\AMisc_Technical\z:}', "");;
    Expect(1, 9215, '\p{Blk=misctechnical}', "");
    Expect(0, 9215, '\p{^Blk=misctechnical}', "");
    Expect(0, 9215, '\P{Blk=misctechnical}', "");
    Expect(1, 9215, '\P{^Blk=misctechnical}', "");
    Expect(0, 9216, '\p{Blk=misctechnical}', "");
    Expect(1, 9216, '\p{^Blk=misctechnical}', "");
    Expect(1, 9216, '\P{Blk=misctechnical}', "");
    Expect(0, 9216, '\P{^Blk=misctechnical}', "");
    Expect(1, 9215, '\p{Blk=:\Amisctechnical\z:}', "");;
    Expect(0, 9216, '\p{Blk=:\Amisctechnical\z:}', "");;
    Expect(1, 9215, '\p{Blk:     misc_TECHNICAL}', "");
    Expect(0, 9215, '\p{^Blk:     misc_TECHNICAL}', "");
    Expect(0, 9215, '\P{Blk:     misc_TECHNICAL}', "");
    Expect(1, 9215, '\P{^Blk:     misc_TECHNICAL}', "");
    Expect(0, 9216, '\p{Blk:     misc_TECHNICAL}', "");
    Expect(1, 9216, '\p{^Blk:     misc_TECHNICAL}', "");
    Expect(1, 9216, '\P{Blk:     misc_TECHNICAL}', "");
    Expect(0, 9216, '\P{^Blk:     misc_TECHNICAL}', "");
    Error('\p{Is_Block=_ miscellaneous_technical/a/}');
    Error('\P{Is_Block=_ miscellaneous_technical/a/}');
    Expect(1, 9215, '\p{Is_Block=miscellaneoustechnical}', "");
    Expect(0, 9215, '\p{^Is_Block=miscellaneoustechnical}', "");
    Expect(0, 9215, '\P{Is_Block=miscellaneoustechnical}', "");
    Expect(1, 9215, '\P{^Is_Block=miscellaneoustechnical}', "");
    Expect(0, 9216, '\p{Is_Block=miscellaneoustechnical}', "");
    Expect(1, 9216, '\p{^Is_Block=miscellaneoustechnical}', "");
    Expect(1, 9216, '\P{Is_Block=miscellaneoustechnical}', "");
    Expect(0, 9216, '\P{^Is_Block=miscellaneoustechnical}', "");
    Expect(1, 9215, '\p{Is_Block=_	MISCELLANEOUS_technical}', "");
    Expect(0, 9215, '\p{^Is_Block=_	MISCELLANEOUS_technical}', "");
    Expect(0, 9215, '\P{Is_Block=_	MISCELLANEOUS_technical}', "");
    Expect(1, 9215, '\P{^Is_Block=_	MISCELLANEOUS_technical}', "");
    Expect(0, 9216, '\p{Is_Block=_	MISCELLANEOUS_technical}', "");
    Expect(1, 9216, '\p{^Is_Block=_	MISCELLANEOUS_technical}', "");
    Expect(1, 9216, '\P{Is_Block=_	MISCELLANEOUS_technical}', "");
    Expect(0, 9216, '\P{^Is_Block=_	MISCELLANEOUS_technical}', "");
    Error('\p{Is_Blk=:= _MISC_technical}');
    Error('\P{Is_Blk=:= _MISC_technical}');
    Expect(1, 9215, '\p{Is_Blk=misctechnical}', "");
    Expect(0, 9215, '\p{^Is_Blk=misctechnical}', "");
    Expect(0, 9215, '\P{Is_Blk=misctechnical}', "");
    Expect(1, 9215, '\P{^Is_Blk=misctechnical}', "");
    Expect(0, 9216, '\p{Is_Blk=misctechnical}', "");
    Expect(1, 9216, '\p{^Is_Blk=misctechnical}', "");
    Expect(1, 9216, '\P{Is_Blk=misctechnical}', "");
    Expect(0, 9216, '\P{^Is_Blk=misctechnical}', "");
    Expect(1, 9215, '\p{Is_Blk=-Misc_Technical}', "");
    Expect(0, 9215, '\p{^Is_Blk=-Misc_Technical}', "");
    Expect(0, 9215, '\P{Is_Blk=-Misc_Technical}', "");
    Expect(1, 9215, '\P{^Is_Blk=-Misc_Technical}', "");
    Expect(0, 9216, '\p{Is_Blk=-Misc_Technical}', "");
    Expect(1, 9216, '\p{^Is_Blk=-Misc_Technical}', "");
    Expect(1, 9216, '\P{Is_Blk=-Misc_Technical}', "");
    Expect(0, 9216, '\P{^Is_Blk=-Misc_Technical}', "");
    Error('\p{Block: 	 Modi/a/}');
    Error('\P{Block: 	 Modi/a/}');
    Expect(1, 71263, '\p{Block=:\AModi\z:}', "");;
    Expect(0, 71264, '\p{Block=:\AModi\z:}', "");;
    Expect(1, 71263, '\p{Block=modi}', "");
    Expect(0, 71263, '\p{^Block=modi}', "");
    Expect(0, 71263, '\P{Block=modi}', "");
    Expect(1, 71263, '\P{^Block=modi}', "");
    Expect(0, 71264, '\p{Block=modi}', "");
    Expect(1, 71264, '\p{^Block=modi}', "");
    Expect(1, 71264, '\P{Block=modi}', "");
    Expect(0, 71264, '\P{^Block=modi}', "");
    Expect(1, 71263, '\p{Block=:\Amodi\z:}', "");;
    Expect(0, 71264, '\p{Block=:\Amodi\z:}', "");;
    Expect(1, 71263, '\p{Block: Modi}', "");
    Expect(0, 71263, '\p{^Block: Modi}', "");
    Expect(0, 71263, '\P{Block: Modi}', "");
    Expect(1, 71263, '\P{^Block: Modi}', "");
    Expect(0, 71264, '\p{Block: Modi}', "");
    Expect(1, 71264, '\p{^Block: Modi}', "");
    Expect(1, 71264, '\P{Block: Modi}', "");
    Expect(0, 71264, '\P{^Block: Modi}', "");
    Error('\p{Blk=_/a/Modi}');
    Error('\P{Blk=_/a/Modi}');
    Expect(1, 71263, '\p{Blk=:\AModi\z:}', "");;
    Expect(0, 71264, '\p{Blk=:\AModi\z:}', "");;
    Expect(1, 71263, '\p{Blk=modi}', "");
    Expect(0, 71263, '\p{^Blk=modi}', "");
    Expect(0, 71263, '\P{Blk=modi}', "");
    Expect(1, 71263, '\P{^Blk=modi}', "");
    Expect(0, 71264, '\p{Blk=modi}', "");
    Expect(1, 71264, '\p{^Blk=modi}', "");
    Expect(1, 71264, '\P{Blk=modi}', "");
    Expect(0, 71264, '\P{^Blk=modi}', "");
    Expect(1, 71263, '\p{Blk=:\Amodi\z:}', "");;
    Expect(0, 71264, '\p{Blk=:\Amodi\z:}', "");;
    Expect(1, 71263, '\p{Blk=		modi}', "");
    Expect(0, 71263, '\p{^Blk=		modi}', "");
    Expect(0, 71263, '\P{Blk=		modi}', "");
    Expect(1, 71263, '\P{^Blk=		modi}', "");
    Expect(0, 71264, '\p{Blk=		modi}', "");
    Expect(1, 71264, '\p{^Blk=		modi}', "");
    Expect(1, 71264, '\P{Blk=		modi}', "");
    Expect(0, 71264, '\P{^Blk=		modi}', "");
    Error('\p{Is_Block=_:=Modi}');
    Error('\P{Is_Block=_:=Modi}');
    Expect(1, 71263, '\p{Is_Block=modi}', "");
    Expect(0, 71263, '\p{^Is_Block=modi}', "");
    Expect(0, 71263, '\P{Is_Block=modi}', "");
    Expect(1, 71263, '\P{^Is_Block=modi}', "");
    Expect(0, 71264, '\p{Is_Block=modi}', "");
    Expect(1, 71264, '\p{^Is_Block=modi}', "");
    Expect(1, 71264, '\P{Is_Block=modi}', "");
    Expect(0, 71264, '\P{^Is_Block=modi}', "");
    Expect(1, 71263, '\p{Is_Block=-Modi}', "");
    Expect(0, 71263, '\p{^Is_Block=-Modi}', "");
    Expect(0, 71263, '\P{Is_Block=-Modi}', "");
    Expect(1, 71263, '\P{^Is_Block=-Modi}', "");
    Expect(0, 71264, '\p{Is_Block=-Modi}', "");
    Expect(1, 71264, '\p{^Is_Block=-Modi}', "");
    Expect(1, 71264, '\P{Is_Block=-Modi}', "");
    Expect(0, 71264, '\P{^Is_Block=-Modi}', "");
    Error('\p{Is_Blk=		modi/a/}');
    Error('\P{Is_Blk=		modi/a/}');
    Expect(1, 71263, '\p{Is_Blk:modi}', "");
    Expect(0, 71263, '\p{^Is_Blk:modi}', "");
    Expect(0, 71263, '\P{Is_Blk:modi}', "");
    Expect(1, 71263, '\P{^Is_Blk:modi}', "");
    Expect(0, 71264, '\p{Is_Blk:modi}', "");
    Expect(1, 71264, '\p{^Is_Blk:modi}', "");
    Expect(1, 71264, '\P{Is_Blk:modi}', "");
    Expect(0, 71264, '\P{^Is_Blk:modi}', "");
    Expect(1, 71263, '\p{Is_Blk= 	modi}', "");
    Expect(0, 71263, '\p{^Is_Blk= 	modi}', "");
    Expect(0, 71263, '\P{Is_Blk= 	modi}', "");
    Expect(1, 71263, '\P{^Is_Blk= 	modi}', "");
    Expect(0, 71264, '\p{Is_Blk= 	modi}', "");
    Expect(1, 71264, '\p{^Is_Blk= 	modi}', "");
    Expect(1, 71264, '\P{Is_Blk= 	modi}', "");
    Expect(0, 71264, '\P{^Is_Blk= 	modi}', "");
    Error('\p{Block=/a/spacing_modifier_LETTERS}');
    Error('\P{Block=/a/spacing_modifier_LETTERS}');
    Expect(1, 767, '\p{Block=:\ASpacing_Modifier_Letters\z:}', "");;
    Expect(0, 768, '\p{Block=:\ASpacing_Modifier_Letters\z:}', "");;
    Expect(1, 767, '\p{Block=spacingmodifierletters}', "");
    Expect(0, 767, '\p{^Block=spacingmodifierletters}', "");
    Expect(0, 767, '\P{Block=spacingmodifierletters}', "");
    Expect(1, 767, '\P{^Block=spacingmodifierletters}', "");
    Expect(0, 768, '\p{Block=spacingmodifierletters}', "");
    Expect(1, 768, '\p{^Block=spacingmodifierletters}', "");
    Expect(1, 768, '\P{Block=spacingmodifierletters}', "");
    Expect(0, 768, '\P{^Block=spacingmodifierletters}', "");
    Expect(1, 767, '\p{Block=:\Aspacingmodifierletters\z:}', "");;
    Expect(0, 768, '\p{Block=:\Aspacingmodifierletters\z:}', "");;
    Expect(1, 767, '\p{Block=__SPACING_modifier_letters}', "");
    Expect(0, 767, '\p{^Block=__SPACING_modifier_letters}', "");
    Expect(0, 767, '\P{Block=__SPACING_modifier_letters}', "");
    Expect(1, 767, '\P{^Block=__SPACING_modifier_letters}', "");
    Expect(0, 768, '\p{Block=__SPACING_modifier_letters}', "");
    Expect(1, 768, '\p{^Block=__SPACING_modifier_letters}', "");
    Expect(1, 768, '\P{Block=__SPACING_modifier_letters}', "");
    Expect(0, 768, '\P{^Block=__SPACING_modifier_letters}', "");
    Error('\p{Blk=-:=Modifier_LETTERS}');
    Error('\P{Blk=-:=Modifier_LETTERS}');
    Expect(1, 767, '\p{Blk=:\AModifier_Letters\z:}', "");;
    Expect(0, 768, '\p{Blk=:\AModifier_Letters\z:}', "");;
    Expect(1, 767, '\p{Blk=modifierletters}', "");
    Expect(0, 767, '\p{^Blk=modifierletters}', "");
    Expect(0, 767, '\P{Blk=modifierletters}', "");
    Expect(1, 767, '\P{^Blk=modifierletters}', "");
    Expect(0, 768, '\p{Blk=modifierletters}', "");
    Expect(1, 768, '\p{^Blk=modifierletters}', "");
    Expect(1, 768, '\P{Blk=modifierletters}', "");
    Expect(0, 768, '\P{^Blk=modifierletters}', "");
    Expect(1, 767, '\p{Blk=:\Amodifierletters\z:}', "");;
    Expect(0, 768, '\p{Blk=:\Amodifierletters\z:}', "");;
    Expect(1, 767, '\p{Blk=_-Modifier_letters}', "");
    Expect(0, 767, '\p{^Blk=_-Modifier_letters}', "");
    Expect(0, 767, '\P{Blk=_-Modifier_letters}', "");
    Expect(1, 767, '\P{^Blk=_-Modifier_letters}', "");
    Expect(0, 768, '\p{Blk=_-Modifier_letters}', "");
    Expect(1, 768, '\p{^Blk=_-Modifier_letters}', "");
    Expect(1, 768, '\P{Blk=_-Modifier_letters}', "");
    Expect(0, 768, '\P{^Blk=_-Modifier_letters}', "");
    Error('\p{Is_Block=	Spacing_MODIFIER_Letters/a/}');
    Error('\P{Is_Block=	Spacing_MODIFIER_Letters/a/}');
    Expect(1, 767, '\p{Is_Block=spacingmodifierletters}', "");
    Expect(0, 767, '\p{^Is_Block=spacingmodifierletters}', "");
    Expect(0, 767, '\P{Is_Block=spacingmodifierletters}', "");
    Expect(1, 767, '\P{^Is_Block=spacingmodifierletters}', "");
    Expect(0, 768, '\p{Is_Block=spacingmodifierletters}', "");
    Expect(1, 768, '\p{^Is_Block=spacingmodifierletters}', "");
    Expect(1, 768, '\P{Is_Block=spacingmodifierletters}', "");
    Expect(0, 768, '\P{^Is_Block=spacingmodifierletters}', "");
    Expect(1, 767, '\p{Is_Block=-SPACING_modifier_Letters}', "");
    Expect(0, 767, '\p{^Is_Block=-SPACING_modifier_Letters}', "");
    Expect(0, 767, '\P{Is_Block=-SPACING_modifier_Letters}', "");
    Expect(1, 767, '\P{^Is_Block=-SPACING_modifier_Letters}', "");
    Expect(0, 768, '\p{Is_Block=-SPACING_modifier_Letters}', "");
    Expect(1, 768, '\p{^Is_Block=-SPACING_modifier_Letters}', "");
    Expect(1, 768, '\P{Is_Block=-SPACING_modifier_Letters}', "");
    Expect(0, 768, '\P{^Is_Block=-SPACING_modifier_Letters}', "");
    Error('\p{Is_Blk=/a/-MODIFIER_Letters}');
    Error('\P{Is_Blk=/a/-MODIFIER_Letters}');
    Expect(1, 767, '\p{Is_Blk=modifierletters}', "");
    Expect(0, 767, '\p{^Is_Blk=modifierletters}', "");
    Expect(0, 767, '\P{Is_Blk=modifierletters}', "");
    Expect(1, 767, '\P{^Is_Blk=modifierletters}', "");
    Expect(0, 768, '\p{Is_Blk=modifierletters}', "");
    Expect(1, 768, '\p{^Is_Blk=modifierletters}', "");
    Expect(1, 768, '\P{Is_Blk=modifierletters}', "");
    Expect(0, 768, '\P{^Is_Blk=modifierletters}', "");
    Expect(1, 767, '\p{Is_Blk=-Modifier_Letters}', "");
    Expect(0, 767, '\p{^Is_Blk=-Modifier_Letters}', "");
    Expect(0, 767, '\P{Is_Blk=-Modifier_Letters}', "");
    Expect(1, 767, '\P{^Is_Blk=-Modifier_Letters}', "");
    Expect(0, 768, '\p{Is_Blk=-Modifier_Letters}', "");
    Expect(1, 768, '\p{^Is_Blk=-Modifier_Letters}', "");
    Expect(1, 768, '\P{Is_Blk=-Modifier_Letters}', "");
    Expect(0, 768, '\P{^Is_Blk=-Modifier_Letters}', "");
    Error('\p{Block=:=_Modifier_Tone_letters}');
    Error('\P{Block=:=_Modifier_Tone_letters}');
    Expect(1, 42783, '\p{Block=:\AModifier_Tone_Letters\z:}', "");;
    Expect(0, 42784, '\p{Block=:\AModifier_Tone_Letters\z:}', "");;
    Expect(1, 42783, '\p{Block=modifiertoneletters}', "");
    Expect(0, 42783, '\p{^Block=modifiertoneletters}', "");
    Expect(0, 42783, '\P{Block=modifiertoneletters}', "");
    Expect(1, 42783, '\P{^Block=modifiertoneletters}', "");
    Expect(0, 42784, '\p{Block=modifiertoneletters}', "");
    Expect(1, 42784, '\p{^Block=modifiertoneletters}', "");
    Expect(1, 42784, '\P{Block=modifiertoneletters}', "");
    Expect(0, 42784, '\P{^Block=modifiertoneletters}', "");
    Expect(1, 42783, '\p{Block=:\Amodifiertoneletters\z:}', "");;
    Expect(0, 42784, '\p{Block=:\Amodifiertoneletters\z:}', "");;
    Expect(1, 42783, '\p{Block=	 Modifier_tone_Letters}', "");
    Expect(0, 42783, '\p{^Block=	 Modifier_tone_Letters}', "");
    Expect(0, 42783, '\P{Block=	 Modifier_tone_Letters}', "");
    Expect(1, 42783, '\P{^Block=	 Modifier_tone_Letters}', "");
    Expect(0, 42784, '\p{Block=	 Modifier_tone_Letters}', "");
    Expect(1, 42784, '\p{^Block=	 Modifier_tone_Letters}', "");
    Expect(1, 42784, '\P{Block=	 Modifier_tone_Letters}', "");
    Expect(0, 42784, '\P{^Block=	 Modifier_tone_Letters}', "");
    Error('\p{Blk=/a/Modifier_tone_Letters}');
    Error('\P{Blk=/a/Modifier_tone_Letters}');
    Expect(1, 42783, '\p{Blk=:\AModifier_Tone_Letters\z:}', "");;
    Expect(0, 42784, '\p{Blk=:\AModifier_Tone_Letters\z:}', "");;
    Expect(1, 42783, '\p{Blk=modifiertoneletters}', "");
    Expect(0, 42783, '\p{^Blk=modifiertoneletters}', "");
    Expect(0, 42783, '\P{Blk=modifiertoneletters}', "");
    Expect(1, 42783, '\P{^Blk=modifiertoneletters}', "");
    Expect(0, 42784, '\p{Blk=modifiertoneletters}', "");
    Expect(1, 42784, '\p{^Blk=modifiertoneletters}', "");
    Expect(1, 42784, '\P{Blk=modifiertoneletters}', "");
    Expect(0, 42784, '\P{^Blk=modifiertoneletters}', "");
    Expect(1, 42783, '\p{Blk=:\Amodifiertoneletters\z:}', "");;
    Expect(0, 42784, '\p{Blk=:\Amodifiertoneletters\z:}', "");;
    Expect(1, 42783, '\p{Blk=- modifier_Tone_LETTERS}', "");
    Expect(0, 42783, '\p{^Blk=- modifier_Tone_LETTERS}', "");
    Expect(0, 42783, '\P{Blk=- modifier_Tone_LETTERS}', "");
    Expect(1, 42783, '\P{^Blk=- modifier_Tone_LETTERS}', "");
    Expect(0, 42784, '\p{Blk=- modifier_Tone_LETTERS}', "");
    Expect(1, 42784, '\p{^Blk=- modifier_Tone_LETTERS}', "");
    Expect(1, 42784, '\P{Blk=- modifier_Tone_LETTERS}', "");
    Expect(0, 42784, '\P{^Blk=- modifier_Tone_LETTERS}', "");
    Error('\p{Is_Block: _/a/modifier_Tone_Letters}');
    Error('\P{Is_Block: _/a/modifier_Tone_Letters}');
    Expect(1, 42783, '\p{Is_Block: modifiertoneletters}', "");
    Expect(0, 42783, '\p{^Is_Block: modifiertoneletters}', "");
    Expect(0, 42783, '\P{Is_Block: modifiertoneletters}', "");
    Expect(1, 42783, '\P{^Is_Block: modifiertoneletters}', "");
    Expect(0, 42784, '\p{Is_Block: modifiertoneletters}', "");
    Expect(1, 42784, '\p{^Is_Block: modifiertoneletters}', "");
    Expect(1, 42784, '\P{Is_Block: modifiertoneletters}', "");
    Expect(0, 42784, '\P{^Is_Block: modifiertoneletters}', "");
    Expect(1, 42783, '\p{Is_Block=_ modifier_Tone_LETTERS}', "");
    Expect(0, 42783, '\p{^Is_Block=_ modifier_Tone_LETTERS}', "");
    Expect(0, 42783, '\P{Is_Block=_ modifier_Tone_LETTERS}', "");
    Expect(1, 42783, '\P{^Is_Block=_ modifier_Tone_LETTERS}', "");
    Expect(0, 42784, '\p{Is_Block=_ modifier_Tone_LETTERS}', "");
    Expect(1, 42784, '\p{^Is_Block=_ modifier_Tone_LETTERS}', "");
    Expect(1, 42784, '\P{Is_Block=_ modifier_Tone_LETTERS}', "");
    Expect(0, 42784, '\P{^Is_Block=_ modifier_Tone_LETTERS}', "");
    Error('\p{Is_Blk: :=_	Modifier_TONE_letters}');
    Error('\P{Is_Blk: :=_	Modifier_TONE_letters}');
    Expect(1, 42783, '\p{Is_Blk=modifiertoneletters}', "");
    Expect(0, 42783, '\p{^Is_Blk=modifiertoneletters}', "");
    Expect(0, 42783, '\P{Is_Blk=modifiertoneletters}', "");
    Expect(1, 42783, '\P{^Is_Blk=modifiertoneletters}', "");
    Expect(0, 42784, '\p{Is_Blk=modifiertoneletters}', "");
    Expect(1, 42784, '\p{^Is_Blk=modifiertoneletters}', "");
    Expect(1, 42784, '\P{Is_Blk=modifiertoneletters}', "");
    Expect(0, 42784, '\P{^Is_Blk=modifiertoneletters}', "");
    Expect(1, 42783, '\p{Is_Blk=-Modifier_tone_Letters}', "");
    Expect(0, 42783, '\p{^Is_Blk=-Modifier_tone_Letters}', "");
    Expect(0, 42783, '\P{Is_Blk=-Modifier_tone_Letters}', "");
    Expect(1, 42783, '\P{^Is_Blk=-Modifier_tone_Letters}', "");
    Expect(0, 42784, '\p{Is_Blk=-Modifier_tone_Letters}', "");
    Expect(1, 42784, '\p{^Is_Blk=-Modifier_tone_Letters}', "");
    Expect(1, 42784, '\P{Is_Blk=-Modifier_tone_Letters}', "");
    Expect(0, 42784, '\P{^Is_Blk=-Modifier_tone_Letters}', "");
    Error('\p{Block=/a/-	Mongolian}');
    Error('\P{Block=/a/-	Mongolian}');
    Expect(1, 6319, '\p{Block=:\AMongolian\z:}', "");;
    Expect(0, 6320, '\p{Block=:\AMongolian\z:}', "");;
    Expect(1, 6319, '\p{Block=mongolian}', "");
    Expect(0, 6319, '\p{^Block=mongolian}', "");
    Expect(0, 6319, '\P{Block=mongolian}', "");
    Expect(1, 6319, '\P{^Block=mongolian}', "");
    Expect(0, 6320, '\p{Block=mongolian}', "");
    Expect(1, 6320, '\p{^Block=mongolian}', "");
    Expect(1, 6320, '\P{Block=mongolian}', "");
    Expect(0, 6320, '\P{^Block=mongolian}', "");
    Expect(1, 6319, '\p{Block=:\Amongolian\z:}', "");;
    Expect(0, 6320, '\p{Block=:\Amongolian\z:}', "");;
    Expect(1, 6319, '\p{Block= Mongolian}', "");
    Expect(0, 6319, '\p{^Block= Mongolian}', "");
    Expect(0, 6319, '\P{Block= Mongolian}', "");
    Expect(1, 6319, '\P{^Block= Mongolian}', "");
    Expect(0, 6320, '\p{Block= Mongolian}', "");
    Expect(1, 6320, '\p{^Block= Mongolian}', "");
    Expect(1, 6320, '\P{Block= Mongolian}', "");
    Expect(0, 6320, '\P{^Block= Mongolian}', "");
    Error('\p{Blk=  MONGOLIAN:=}');
    Error('\P{Blk=  MONGOLIAN:=}');
    Expect(1, 6319, '\p{Blk=:\AMongolian\z:}', "");;
    Expect(0, 6320, '\p{Blk=:\AMongolian\z:}', "");;
    Expect(1, 6319, '\p{Blk=mongolian}', "");
    Expect(0, 6319, '\p{^Blk=mongolian}', "");
    Expect(0, 6319, '\P{Blk=mongolian}', "");
    Expect(1, 6319, '\P{^Blk=mongolian}', "");
    Expect(0, 6320, '\p{Blk=mongolian}', "");
    Expect(1, 6320, '\p{^Blk=mongolian}', "");
    Expect(1, 6320, '\P{Blk=mongolian}', "");
    Expect(0, 6320, '\P{^Blk=mongolian}', "");
    Expect(1, 6319, '\p{Blk=:\Amongolian\z:}', "");;
    Expect(0, 6320, '\p{Blk=:\Amongolian\z:}', "");;
    Expect(1, 6319, '\p{Blk: -mongolian}', "");
    Expect(0, 6319, '\p{^Blk: -mongolian}', "");
    Expect(0, 6319, '\P{Blk: -mongolian}', "");
    Expect(1, 6319, '\P{^Blk: -mongolian}', "");
    Expect(0, 6320, '\p{Blk: -mongolian}', "");
    Expect(1, 6320, '\p{^Blk: -mongolian}', "");
    Expect(1, 6320, '\P{Blk: -mongolian}', "");
    Expect(0, 6320, '\P{^Blk: -mongolian}', "");
    Error('\p{Is_Block=:=Mongolian}');
    Error('\P{Is_Block=:=Mongolian}');
    Expect(1, 6319, '\p{Is_Block=mongolian}', "");
    Expect(0, 6319, '\p{^Is_Block=mongolian}', "");
    Expect(0, 6319, '\P{Is_Block=mongolian}', "");
    Expect(1, 6319, '\P{^Is_Block=mongolian}', "");
    Expect(0, 6320, '\p{Is_Block=mongolian}', "");
    Expect(1, 6320, '\p{^Is_Block=mongolian}', "");
    Expect(1, 6320, '\P{Is_Block=mongolian}', "");
    Expect(0, 6320, '\P{^Is_Block=mongolian}', "");
    Expect(1, 6319, '\p{Is_Block=	Mongolian}', "");
    Expect(0, 6319, '\p{^Is_Block=	Mongolian}', "");
    Expect(0, 6319, '\P{Is_Block=	Mongolian}', "");
    Expect(1, 6319, '\P{^Is_Block=	Mongolian}', "");
    Expect(0, 6320, '\p{Is_Block=	Mongolian}', "");
    Expect(1, 6320, '\p{^Is_Block=	Mongolian}', "");
    Expect(1, 6320, '\P{Is_Block=	Mongolian}', "");
    Expect(0, 6320, '\P{^Is_Block=	Mongolian}', "");
    Error('\p{Is_Blk=_/a/mongolian}');
    Error('\P{Is_Blk=_/a/mongolian}');
    Expect(1, 6319, '\p{Is_Blk=mongolian}', "");
    Expect(0, 6319, '\p{^Is_Blk=mongolian}', "");
    Expect(0, 6319, '\P{Is_Blk=mongolian}', "");
    Expect(1, 6319, '\P{^Is_Blk=mongolian}', "");
    Expect(0, 6320, '\p{Is_Blk=mongolian}', "");
    Expect(1, 6320, '\p{^Is_Blk=mongolian}', "");
    Expect(1, 6320, '\P{Is_Blk=mongolian}', "");
    Expect(0, 6320, '\P{^Is_Blk=mongolian}', "");
    Expect(1, 6319, '\p{Is_Blk=_Mongolian}', "");
    Expect(0, 6319, '\p{^Is_Blk=_Mongolian}', "");
    Expect(0, 6319, '\P{Is_Blk=_Mongolian}', "");
    Expect(1, 6319, '\P{^Is_Blk=_Mongolian}', "");
    Expect(0, 6320, '\p{Is_Blk=_Mongolian}', "");
    Expect(1, 6320, '\p{^Is_Blk=_Mongolian}', "");
    Expect(1, 6320, '\P{Is_Blk=_Mongolian}', "");
    Expect(0, 6320, '\P{^Is_Blk=_Mongolian}', "");
    Error('\p{Block: 	mongolian_SUPPLEMENT:=}');
    Error('\P{Block: 	mongolian_SUPPLEMENT:=}');
    Expect(1, 71295, '\p{Block=:\AMongolian_Supplement\z:}', "");;
    Expect(0, 71296, '\p{Block=:\AMongolian_Supplement\z:}', "");;
    Expect(1, 71295, '\p{Block=mongoliansupplement}', "");
    Expect(0, 71295, '\p{^Block=mongoliansupplement}', "");
    Expect(0, 71295, '\P{Block=mongoliansupplement}', "");
    Expect(1, 71295, '\P{^Block=mongoliansupplement}', "");
    Expect(0, 71296, '\p{Block=mongoliansupplement}', "");
    Expect(1, 71296, '\p{^Block=mongoliansupplement}', "");
    Expect(1, 71296, '\P{Block=mongoliansupplement}', "");
    Expect(0, 71296, '\P{^Block=mongoliansupplement}', "");
    Expect(1, 71295, '\p{Block=:\Amongoliansupplement\z:}', "");;
    Expect(0, 71296, '\p{Block=:\Amongoliansupplement\z:}', "");;
    Expect(1, 71295, '\p{Block=--Mongolian_supplement}', "");
    Expect(0, 71295, '\p{^Block=--Mongolian_supplement}', "");
    Expect(0, 71295, '\P{Block=--Mongolian_supplement}', "");
    Expect(1, 71295, '\P{^Block=--Mongolian_supplement}', "");
    Expect(0, 71296, '\p{Block=--Mongolian_supplement}', "");
    Expect(1, 71296, '\p{^Block=--Mongolian_supplement}', "");
    Expect(1, 71296, '\P{Block=--Mongolian_supplement}', "");
    Expect(0, 71296, '\P{^Block=--Mongolian_supplement}', "");
    Error('\p{Blk=:=_-MONGOLIAN_SUP}');
    Error('\P{Blk=:=_-MONGOLIAN_SUP}');
    Expect(1, 71295, '\p{Blk=:\AMongolian_Sup\z:}', "");;
    Expect(0, 71296, '\p{Blk=:\AMongolian_Sup\z:}', "");;
    Expect(1, 71295, '\p{Blk:	mongoliansup}', "");
    Expect(0, 71295, '\p{^Blk:	mongoliansup}', "");
    Expect(0, 71295, '\P{Blk:	mongoliansup}', "");
    Expect(1, 71295, '\P{^Blk:	mongoliansup}', "");
    Expect(0, 71296, '\p{Blk:	mongoliansup}', "");
    Expect(1, 71296, '\p{^Blk:	mongoliansup}', "");
    Expect(1, 71296, '\P{Blk:	mongoliansup}', "");
    Expect(0, 71296, '\P{^Blk:	mongoliansup}', "");
    Expect(1, 71295, '\p{Blk=:\Amongoliansup\z:}', "");;
    Expect(0, 71296, '\p{Blk=:\Amongoliansup\z:}', "");;
    Expect(1, 71295, '\p{Blk=	_mongolian_Sup}', "");
    Expect(0, 71295, '\p{^Blk=	_mongolian_Sup}', "");
    Expect(0, 71295, '\P{Blk=	_mongolian_Sup}', "");
    Expect(1, 71295, '\P{^Blk=	_mongolian_Sup}', "");
    Expect(0, 71296, '\p{Blk=	_mongolian_Sup}', "");
    Expect(1, 71296, '\p{^Blk=	_mongolian_Sup}', "");
    Expect(1, 71296, '\P{Blk=	_mongolian_Sup}', "");
    Expect(0, 71296, '\P{^Blk=	_mongolian_Sup}', "");
    Error('\p{Is_Block= /a/MONGOLIAN_supplement}');
    Error('\P{Is_Block= /a/MONGOLIAN_supplement}');
    Expect(1, 71295, '\p{Is_Block=mongoliansupplement}', "");
    Expect(0, 71295, '\p{^Is_Block=mongoliansupplement}', "");
    Expect(0, 71295, '\P{Is_Block=mongoliansupplement}', "");
    Expect(1, 71295, '\P{^Is_Block=mongoliansupplement}', "");
    Expect(0, 71296, '\p{Is_Block=mongoliansupplement}', "");
    Expect(1, 71296, '\p{^Is_Block=mongoliansupplement}', "");
    Expect(1, 71296, '\P{Is_Block=mongoliansupplement}', "");
    Expect(0, 71296, '\P{^Is_Block=mongoliansupplement}', "");
    Expect(1, 71295, '\p{Is_Block=	Mongolian_Supplement}', "");
    Expect(0, 71295, '\p{^Is_Block=	Mongolian_Supplement}', "");
    Expect(0, 71295, '\P{Is_Block=	Mongolian_Supplement}', "");
    Expect(1, 71295, '\P{^Is_Block=	Mongolian_Supplement}', "");
    Expect(0, 71296, '\p{Is_Block=	Mongolian_Supplement}', "");
    Expect(1, 71296, '\p{^Is_Block=	Mongolian_Supplement}', "");
    Expect(1, 71296, '\P{Is_Block=	Mongolian_Supplement}', "");
    Expect(0, 71296, '\P{^Is_Block=	Mongolian_Supplement}', "");
    Error('\p{Is_Blk:		:=Mongolian_Sup}');
    Error('\P{Is_Blk:		:=Mongolian_Sup}');
    Expect(1, 71295, '\p{Is_Blk=mongoliansup}', "");
    Expect(0, 71295, '\p{^Is_Blk=mongoliansup}', "");
    Expect(0, 71295, '\P{Is_Blk=mongoliansup}', "");
    Expect(1, 71295, '\P{^Is_Blk=mongoliansup}', "");
    Expect(0, 71296, '\p{Is_Blk=mongoliansup}', "");
    Expect(1, 71296, '\p{^Is_Blk=mongoliansup}', "");
    Expect(1, 71296, '\P{Is_Blk=mongoliansup}', "");
    Expect(0, 71296, '\P{^Is_Blk=mongoliansup}', "");
    Expect(1, 71295, '\p{Is_Blk=_Mongolian_SUP}', "");
    Expect(0, 71295, '\p{^Is_Blk=_Mongolian_SUP}', "");
    Expect(0, 71295, '\P{Is_Blk=_Mongolian_SUP}', "");
    Expect(1, 71295, '\P{^Is_Blk=_Mongolian_SUP}', "");
    Expect(0, 71296, '\p{Is_Blk=_Mongolian_SUP}', "");
    Expect(1, 71296, '\p{^Is_Blk=_Mongolian_SUP}', "");
    Expect(1, 71296, '\P{Is_Blk=_Mongolian_SUP}', "");
    Expect(0, 71296, '\P{^Is_Blk=_Mongolian_SUP}', "");
    Error('\p{Block=__Mro:=}');
    Error('\P{Block=__Mro:=}');
    Expect(1, 92783, '\p{Block=:\AMro\z:}', "");;
    Expect(0, 92784, '\p{Block=:\AMro\z:}', "");;
    Expect(1, 92783, '\p{Block=mro}', "");
    Expect(0, 92783, '\p{^Block=mro}', "");
    Expect(0, 92783, '\P{Block=mro}', "");
    Expect(1, 92783, '\P{^Block=mro}', "");
    Expect(0, 92784, '\p{Block=mro}', "");
    Expect(1, 92784, '\p{^Block=mro}', "");
    Expect(1, 92784, '\P{Block=mro}', "");
    Expect(0, 92784, '\P{^Block=mro}', "");
    Expect(1, 92783, '\p{Block=:\Amro\z:}', "");;
    Expect(0, 92784, '\p{Block=:\Amro\z:}', "");;
    Expect(1, 92783, '\p{Block=__mro}', "");
    Expect(0, 92783, '\p{^Block=__mro}', "");
    Expect(0, 92783, '\P{Block=__mro}', "");
    Expect(1, 92783, '\P{^Block=__mro}', "");
    Expect(0, 92784, '\p{Block=__mro}', "");
    Expect(1, 92784, '\p{^Block=__mro}', "");
    Expect(1, 92784, '\P{Block=__mro}', "");
    Expect(0, 92784, '\P{^Block=__mro}', "");
    Error('\p{Blk: -/a/MRO}');
    Error('\P{Blk: -/a/MRO}');
    Expect(1, 92783, '\p{Blk=:\AMro\z:}', "");;
    Expect(0, 92784, '\p{Blk=:\AMro\z:}', "");;
    Expect(1, 92783, '\p{Blk=mro}', "");
    Expect(0, 92783, '\p{^Blk=mro}', "");
    Expect(0, 92783, '\P{Blk=mro}', "");
    Expect(1, 92783, '\P{^Blk=mro}', "");
    Expect(0, 92784, '\p{Blk=mro}', "");
    Expect(1, 92784, '\p{^Blk=mro}', "");
    Expect(1, 92784, '\P{Blk=mro}', "");
    Expect(0, 92784, '\P{^Blk=mro}', "");
    Expect(1, 92783, '\p{Blk=:\Amro\z:}', "");;
    Expect(0, 92784, '\p{Blk=:\Amro\z:}', "");;
    Expect(1, 92783, '\p{Blk= mro}', "");
    Expect(0, 92783, '\p{^Blk= mro}', "");
    Expect(0, 92783, '\P{Blk= mro}', "");
    Expect(1, 92783, '\P{^Blk= mro}', "");
    Expect(0, 92784, '\p{Blk= mro}', "");
    Expect(1, 92784, '\p{^Blk= mro}', "");
    Expect(1, 92784, '\P{Blk= mro}', "");
    Expect(0, 92784, '\P{^Blk= mro}', "");
    Error('\p{Is_Block=	mro:=}');
    Error('\P{Is_Block=	mro:=}');
    Expect(1, 92783, '\p{Is_Block=mro}', "");
    Expect(0, 92783, '\p{^Is_Block=mro}', "");
    Expect(0, 92783, '\P{Is_Block=mro}', "");
    Expect(1, 92783, '\P{^Is_Block=mro}', "");
    Expect(0, 92784, '\p{Is_Block=mro}', "");
    Expect(1, 92784, '\p{^Is_Block=mro}', "");
    Expect(1, 92784, '\P{Is_Block=mro}', "");
    Expect(0, 92784, '\P{^Is_Block=mro}', "");
    Expect(1, 92783, '\p{Is_Block=	_mro}', "");
    Expect(0, 92783, '\p{^Is_Block=	_mro}', "");
    Expect(0, 92783, '\P{Is_Block=	_mro}', "");
    Expect(1, 92783, '\P{^Is_Block=	_mro}', "");
    Expect(0, 92784, '\p{Is_Block=	_mro}', "");
    Expect(1, 92784, '\p{^Is_Block=	_mro}', "");
    Expect(1, 92784, '\P{Is_Block=	_mro}', "");
    Expect(0, 92784, '\P{^Is_Block=	_mro}', "");
    Error('\p{Is_Blk=	-Mro:=}');
    Error('\P{Is_Blk=	-Mro:=}');
    Expect(1, 92783, '\p{Is_Blk=mro}', "");
    Expect(0, 92783, '\p{^Is_Blk=mro}', "");
    Expect(0, 92783, '\P{Is_Blk=mro}', "");
    Expect(1, 92783, '\P{^Is_Blk=mro}', "");
    Expect(0, 92784, '\p{Is_Blk=mro}', "");
    Expect(1, 92784, '\p{^Is_Blk=mro}', "");
    Expect(1, 92784, '\P{Is_Blk=mro}', "");
    Expect(0, 92784, '\P{^Is_Blk=mro}', "");
    Expect(1, 92783, '\p{Is_Blk=_-Mro}', "");
    Expect(0, 92783, '\p{^Is_Blk=_-Mro}', "");
    Expect(0, 92783, '\P{Is_Blk=_-Mro}', "");
    Expect(1, 92783, '\P{^Is_Blk=_-Mro}', "");
    Expect(0, 92784, '\p{Is_Blk=_-Mro}', "");
    Expect(1, 92784, '\p{^Is_Blk=_-Mro}', "");
    Expect(1, 92784, '\P{Is_Blk=_-Mro}', "");
    Expect(0, 92784, '\P{^Is_Blk=_-Mro}', "");
    Error('\p{Block=	-Multani:=}');
    Error('\P{Block=	-Multani:=}');
    Expect(1, 70319, '\p{Block=:\AMultani\z:}', "");;
    Expect(0, 70320, '\p{Block=:\AMultani\z:}', "");;
    Expect(1, 70319, '\p{Block=multani}', "");
    Expect(0, 70319, '\p{^Block=multani}', "");
    Expect(0, 70319, '\P{Block=multani}', "");
    Expect(1, 70319, '\P{^Block=multani}', "");
    Expect(0, 70320, '\p{Block=multani}', "");
    Expect(1, 70320, '\p{^Block=multani}', "");
    Expect(1, 70320, '\P{Block=multani}', "");
    Expect(0, 70320, '\P{^Block=multani}', "");
    Expect(1, 70319, '\p{Block=:\Amultani\z:}', "");;
    Expect(0, 70320, '\p{Block=:\Amultani\z:}', "");;
    Expect(1, 70319, '\p{Block=		Multani}', "");
    Expect(0, 70319, '\p{^Block=		Multani}', "");
    Expect(0, 70319, '\P{Block=		Multani}', "");
    Expect(1, 70319, '\P{^Block=		Multani}', "");
    Expect(0, 70320, '\p{Block=		Multani}', "");
    Expect(1, 70320, '\p{^Block=		Multani}', "");
    Expect(1, 70320, '\P{Block=		Multani}', "");
    Expect(0, 70320, '\P{^Block=		Multani}', "");
    Error('\p{Blk=- Multani/a/}');
    Error('\P{Blk=- Multani/a/}');
    Expect(1, 70319, '\p{Blk=:\AMultani\z:}', "");;
    Expect(0, 70320, '\p{Blk=:\AMultani\z:}', "");;
    Expect(1, 70319, '\p{Blk:   multani}', "");
    Expect(0, 70319, '\p{^Blk:   multani}', "");
    Expect(0, 70319, '\P{Blk:   multani}', "");
    Expect(1, 70319, '\P{^Blk:   multani}', "");
    Expect(0, 70320, '\p{Blk:   multani}', "");
    Expect(1, 70320, '\p{^Blk:   multani}', "");
    Expect(1, 70320, '\P{Blk:   multani}', "");
    Expect(0, 70320, '\P{^Blk:   multani}', "");
    Expect(1, 70319, '\p{Blk=:\Amultani\z:}', "");;
    Expect(0, 70320, '\p{Blk=:\Amultani\z:}', "");;
    Expect(1, 70319, '\p{Blk=	 MULTANI}', "");
    Expect(0, 70319, '\p{^Blk=	 MULTANI}', "");
    Expect(0, 70319, '\P{Blk=	 MULTANI}', "");
    Expect(1, 70319, '\P{^Blk=	 MULTANI}', "");
    Expect(0, 70320, '\p{Blk=	 MULTANI}', "");
    Expect(1, 70320, '\p{^Blk=	 MULTANI}', "");
    Expect(1, 70320, '\P{Blk=	 MULTANI}', "");
    Expect(0, 70320, '\P{^Blk=	 MULTANI}', "");
    Error('\p{Is_Block=	Multani:=}');
    Error('\P{Is_Block=	Multani:=}');
    Expect(1, 70319, '\p{Is_Block: multani}', "");
    Expect(0, 70319, '\p{^Is_Block: multani}', "");
    Expect(0, 70319, '\P{Is_Block: multani}', "");
    Expect(1, 70319, '\P{^Is_Block: multani}', "");
    Expect(0, 70320, '\p{Is_Block: multani}', "");
    Expect(1, 70320, '\p{^Is_Block: multani}', "");
    Expect(1, 70320, '\P{Is_Block: multani}', "");
    Expect(0, 70320, '\P{^Is_Block: multani}', "");
    Expect(1, 70319, '\p{Is_Block=- Multani}', "");
    Expect(0, 70319, '\p{^Is_Block=- Multani}', "");
    Expect(0, 70319, '\P{Is_Block=- Multani}', "");
    Expect(1, 70319, '\P{^Is_Block=- Multani}', "");
    Expect(0, 70320, '\p{Is_Block=- Multani}', "");
    Expect(1, 70320, '\p{^Is_Block=- Multani}', "");
    Expect(1, 70320, '\P{Is_Block=- Multani}', "");
    Expect(0, 70320, '\P{^Is_Block=- Multani}', "");
    Error('\p{Is_Blk=:=-Multani}');
    Error('\P{Is_Blk=:=-Multani}');
    Expect(1, 70319, '\p{Is_Blk:multani}', "");
    Expect(0, 70319, '\p{^Is_Blk:multani}', "");
    Expect(0, 70319, '\P{Is_Blk:multani}', "");
    Expect(1, 70319, '\P{^Is_Blk:multani}', "");
    Expect(0, 70320, '\p{Is_Blk:multani}', "");
    Expect(1, 70320, '\p{^Is_Blk:multani}', "");
    Expect(1, 70320, '\P{Is_Blk:multani}', "");
    Expect(0, 70320, '\P{^Is_Blk:multani}', "");
    Expect(1, 70319, '\p{Is_Blk= 	Multani}', "");
    Expect(0, 70319, '\p{^Is_Blk= 	Multani}', "");
    Expect(0, 70319, '\P{Is_Blk= 	Multani}', "");
    Expect(1, 70319, '\P{^Is_Blk= 	Multani}', "");
    Expect(0, 70320, '\p{Is_Blk= 	Multani}', "");
    Expect(1, 70320, '\p{^Is_Blk= 	Multani}', "");
    Expect(1, 70320, '\P{Is_Blk= 	Multani}', "");
    Expect(0, 70320, '\P{^Is_Blk= 	Multani}', "");
    Error('\p{Block:	_ MUSICAL_symbols/a/}');
    Error('\P{Block:	_ MUSICAL_symbols/a/}');
    Expect(1, 119295, '\p{Block=:\AMusical_Symbols\z:}', "");;
    Expect(0, 119296, '\p{Block=:\AMusical_Symbols\z:}', "");;
    Expect(1, 119295, '\p{Block=musicalsymbols}', "");
    Expect(0, 119295, '\p{^Block=musicalsymbols}', "");
    Expect(0, 119295, '\P{Block=musicalsymbols}', "");
    Expect(1, 119295, '\P{^Block=musicalsymbols}', "");
    Expect(0, 119296, '\p{Block=musicalsymbols}', "");
    Expect(1, 119296, '\p{^Block=musicalsymbols}', "");
    Expect(1, 119296, '\P{Block=musicalsymbols}', "");
    Expect(0, 119296, '\P{^Block=musicalsymbols}', "");
    Expect(1, 119295, '\p{Block=:\Amusicalsymbols\z:}', "");;
    Expect(0, 119296, '\p{Block=:\Amusicalsymbols\z:}', "");;
    Expect(1, 119295, '\p{Block=_ Musical_Symbols}', "");
    Expect(0, 119295, '\p{^Block=_ Musical_Symbols}', "");
    Expect(0, 119295, '\P{Block=_ Musical_Symbols}', "");
    Expect(1, 119295, '\P{^Block=_ Musical_Symbols}', "");
    Expect(0, 119296, '\p{Block=_ Musical_Symbols}', "");
    Expect(1, 119296, '\p{^Block=_ Musical_Symbols}', "");
    Expect(1, 119296, '\P{Block=_ Musical_Symbols}', "");
    Expect(0, 119296, '\P{^Block=_ Musical_Symbols}', "");
    Error('\p{Blk=_Music:=}');
    Error('\P{Blk=_Music:=}');
    Expect(1, 119295, '\p{Blk=:\AMusic\z:}', "");;
    Expect(0, 119296, '\p{Blk=:\AMusic\z:}', "");;
    Expect(1, 119295, '\p{Blk=music}', "");
    Expect(0, 119295, '\p{^Blk=music}', "");
    Expect(0, 119295, '\P{Blk=music}', "");
    Expect(1, 119295, '\P{^Blk=music}', "");
    Expect(0, 119296, '\p{Blk=music}', "");
    Expect(1, 119296, '\p{^Blk=music}', "");
    Expect(1, 119296, '\P{Blk=music}', "");
    Expect(0, 119296, '\P{^Blk=music}', "");
    Expect(1, 119295, '\p{Blk=:\Amusic\z:}', "");;
    Expect(0, 119296, '\p{Blk=:\Amusic\z:}', "");;
    Expect(1, 119295, '\p{Blk= -Music}', "");
    Expect(0, 119295, '\p{^Blk= -Music}', "");
    Expect(0, 119295, '\P{Blk= -Music}', "");
    Expect(1, 119295, '\P{^Blk= -Music}', "");
    Expect(0, 119296, '\p{Blk= -Music}', "");
    Expect(1, 119296, '\p{^Blk= -Music}', "");
    Expect(1, 119296, '\P{Blk= -Music}', "");
    Expect(0, 119296, '\P{^Blk= -Music}', "");
    Error('\p{Is_Block= /a/Musical_Symbols}');
    Error('\P{Is_Block= /a/Musical_Symbols}');
    Expect(1, 119295, '\p{Is_Block=musicalsymbols}', "");
    Expect(0, 119295, '\p{^Is_Block=musicalsymbols}', "");
    Expect(0, 119295, '\P{Is_Block=musicalsymbols}', "");
    Expect(1, 119295, '\P{^Is_Block=musicalsymbols}', "");
    Expect(0, 119296, '\p{Is_Block=musicalsymbols}', "");
    Expect(1, 119296, '\p{^Is_Block=musicalsymbols}', "");
    Expect(1, 119296, '\P{Is_Block=musicalsymbols}', "");
    Expect(0, 119296, '\P{^Is_Block=musicalsymbols}', "");
    Expect(1, 119295, '\p{Is_Block=		Musical_SYMBOLS}', "");
    Expect(0, 119295, '\p{^Is_Block=		Musical_SYMBOLS}', "");
    Expect(0, 119295, '\P{Is_Block=		Musical_SYMBOLS}', "");
    Expect(1, 119295, '\P{^Is_Block=		Musical_SYMBOLS}', "");
    Expect(0, 119296, '\p{Is_Block=		Musical_SYMBOLS}', "");
    Expect(1, 119296, '\p{^Is_Block=		Musical_SYMBOLS}', "");
    Expect(1, 119296, '\P{Is_Block=		Musical_SYMBOLS}', "");
    Expect(0, 119296, '\P{^Is_Block=		Musical_SYMBOLS}', "");
    Error('\p{Is_Blk=_	music/a/}');
    Error('\P{Is_Blk=_	music/a/}');
    Expect(1, 119295, '\p{Is_Blk: music}', "");
    Expect(0, 119295, '\p{^Is_Blk: music}', "");
    Expect(0, 119295, '\P{Is_Blk: music}', "");
    Expect(1, 119295, '\P{^Is_Blk: music}', "");
    Expect(0, 119296, '\p{Is_Blk: music}', "");
    Expect(1, 119296, '\p{^Is_Blk: music}', "");
    Expect(1, 119296, '\P{Is_Blk: music}', "");
    Expect(0, 119296, '\P{^Is_Blk: music}', "");
    Expect(1, 119295, '\p{Is_Blk=_ music}', "");
    Expect(0, 119295, '\p{^Is_Blk=_ music}', "");
    Expect(0, 119295, '\P{Is_Blk=_ music}', "");
    Expect(1, 119295, '\P{^Is_Blk=_ music}', "");
    Expect(0, 119296, '\p{Is_Blk=_ music}', "");
    Expect(1, 119296, '\p{^Is_Blk=_ music}', "");
    Expect(1, 119296, '\P{Is_Blk=_ music}', "");
    Expect(0, 119296, '\P{^Is_Blk=_ music}', "");
    Error('\p{Block: := -myanmar}');
    Error('\P{Block: := -myanmar}');
    Expect(1, 4255, '\p{Block=:\AMyanmar\z:}', "");;
    Expect(0, 4256, '\p{Block=:\AMyanmar\z:}', "");;
    Expect(1, 4255, '\p{Block:myanmar}', "");
    Expect(0, 4255, '\p{^Block:myanmar}', "");
    Expect(0, 4255, '\P{Block:myanmar}', "");
    Expect(1, 4255, '\P{^Block:myanmar}', "");
    Expect(0, 4256, '\p{Block:myanmar}', "");
    Expect(1, 4256, '\p{^Block:myanmar}', "");
    Expect(1, 4256, '\P{Block:myanmar}', "");
    Expect(0, 4256, '\P{^Block:myanmar}', "");
    Expect(1, 4255, '\p{Block=:\Amyanmar\z:}', "");;
    Expect(0, 4256, '\p{Block=:\Amyanmar\z:}', "");;
    Expect(1, 4255, '\p{Block= -myanmar}', "");
    Expect(0, 4255, '\p{^Block= -myanmar}', "");
    Expect(0, 4255, '\P{Block= -myanmar}', "");
    Expect(1, 4255, '\P{^Block= -myanmar}', "");
    Expect(0, 4256, '\p{Block= -myanmar}', "");
    Expect(1, 4256, '\p{^Block= -myanmar}', "");
    Expect(1, 4256, '\P{Block= -myanmar}', "");
    Expect(0, 4256, '\P{^Block= -myanmar}', "");
    Error('\p{Blk=-_Myanmar:=}');
    Error('\P{Blk=-_Myanmar:=}');
    Expect(1, 4255, '\p{Blk=:\AMyanmar\z:}', "");;
    Expect(0, 4256, '\p{Blk=:\AMyanmar\z:}', "");;
    Expect(1, 4255, '\p{Blk=myanmar}', "");
    Expect(0, 4255, '\p{^Blk=myanmar}', "");
    Expect(0, 4255, '\P{Blk=myanmar}', "");
    Expect(1, 4255, '\P{^Blk=myanmar}', "");
    Expect(0, 4256, '\p{Blk=myanmar}', "");
    Expect(1, 4256, '\p{^Blk=myanmar}', "");
    Expect(1, 4256, '\P{Blk=myanmar}', "");
    Expect(0, 4256, '\P{^Blk=myanmar}', "");
    Expect(1, 4255, '\p{Blk=:\Amyanmar\z:}', "");;
    Expect(0, 4256, '\p{Blk=:\Amyanmar\z:}', "");;
    Expect(1, 4255, '\p{Blk=	 Myanmar}', "");
    Expect(0, 4255, '\p{^Blk=	 Myanmar}', "");
    Expect(0, 4255, '\P{Blk=	 Myanmar}', "");
    Expect(1, 4255, '\P{^Blk=	 Myanmar}', "");
    Expect(0, 4256, '\p{Blk=	 Myanmar}', "");
    Expect(1, 4256, '\p{^Blk=	 Myanmar}', "");
    Expect(1, 4256, '\P{Blk=	 Myanmar}', "");
    Expect(0, 4256, '\P{^Blk=	 Myanmar}', "");
    Error('\p{Is_Block=--Myanmar:=}');
    Error('\P{Is_Block=--Myanmar:=}');
    Expect(1, 4255, '\p{Is_Block=myanmar}', "");
    Expect(0, 4255, '\p{^Is_Block=myanmar}', "");
    Expect(0, 4255, '\P{Is_Block=myanmar}', "");
    Expect(1, 4255, '\P{^Is_Block=myanmar}', "");
    Expect(0, 4256, '\p{Is_Block=myanmar}', "");
    Expect(1, 4256, '\p{^Is_Block=myanmar}', "");
    Expect(1, 4256, '\P{Is_Block=myanmar}', "");
    Expect(0, 4256, '\P{^Is_Block=myanmar}', "");
    Expect(1, 4255, '\p{Is_Block:   -myanmar}', "");
    Expect(0, 4255, '\p{^Is_Block:   -myanmar}', "");
    Expect(0, 4255, '\P{Is_Block:   -myanmar}', "");
    Expect(1, 4255, '\P{^Is_Block:   -myanmar}', "");
    Expect(0, 4256, '\p{Is_Block:   -myanmar}', "");
    Expect(1, 4256, '\p{^Is_Block:   -myanmar}', "");
    Expect(1, 4256, '\P{Is_Block:   -myanmar}', "");
    Expect(0, 4256, '\P{^Is_Block:   -myanmar}', "");
    Error('\p{Is_Blk:	:=Myanmar}');
    Error('\P{Is_Blk:	:=Myanmar}');
    Expect(1, 4255, '\p{Is_Blk=myanmar}', "");
    Expect(0, 4255, '\p{^Is_Blk=myanmar}', "");
    Expect(0, 4255, '\P{Is_Blk=myanmar}', "");
    Expect(1, 4255, '\P{^Is_Blk=myanmar}', "");
    Expect(0, 4256, '\p{Is_Blk=myanmar}', "");
    Expect(1, 4256, '\p{^Is_Blk=myanmar}', "");
    Expect(1, 4256, '\P{Is_Blk=myanmar}', "");
    Expect(0, 4256, '\P{^Is_Blk=myanmar}', "");
    Expect(1, 4255, '\p{Is_Blk=-	myanmar}', "");
    Expect(0, 4255, '\p{^Is_Blk=-	myanmar}', "");
    Expect(0, 4255, '\P{Is_Blk=-	myanmar}', "");
    Expect(1, 4255, '\P{^Is_Blk=-	myanmar}', "");
    Expect(0, 4256, '\p{Is_Blk=-	myanmar}', "");
    Expect(1, 4256, '\p{^Is_Blk=-	myanmar}', "");
    Expect(1, 4256, '\P{Is_Blk=-	myanmar}', "");
    Expect(0, 4256, '\P{^Is_Blk=-	myanmar}', "");
    Error('\p{Block= myanmar_extended_A/a/}');
    Error('\P{Block= myanmar_extended_A/a/}');
    Expect(1, 43647, '\p{Block=:\AMyanmar_Extended_A\z:}', "");;
    Expect(0, 43648, '\p{Block=:\AMyanmar_Extended_A\z:}', "");;
    Expect(1, 43647, '\p{Block=myanmarextendeda}', "");
    Expect(0, 43647, '\p{^Block=myanmarextendeda}', "");
    Expect(0, 43647, '\P{Block=myanmarextendeda}', "");
    Expect(1, 43647, '\P{^Block=myanmarextendeda}', "");
    Expect(0, 43648, '\p{Block=myanmarextendeda}', "");
    Expect(1, 43648, '\p{^Block=myanmarextendeda}', "");
    Expect(1, 43648, '\P{Block=myanmarextendeda}', "");
    Expect(0, 43648, '\P{^Block=myanmarextendeda}', "");
    Expect(1, 43647, '\p{Block=:\Amyanmarextendeda\z:}', "");;
    Expect(0, 43648, '\p{Block=:\Amyanmarextendeda\z:}', "");;
    Expect(1, 43647, '\p{Block=-MYANMAR_Extended_A}', "");
    Expect(0, 43647, '\p{^Block=-MYANMAR_Extended_A}', "");
    Expect(0, 43647, '\P{Block=-MYANMAR_Extended_A}', "");
    Expect(1, 43647, '\P{^Block=-MYANMAR_Extended_A}', "");
    Expect(0, 43648, '\p{Block=-MYANMAR_Extended_A}', "");
    Expect(1, 43648, '\p{^Block=-MYANMAR_Extended_A}', "");
    Expect(1, 43648, '\P{Block=-MYANMAR_Extended_A}', "");
    Expect(0, 43648, '\P{^Block=-MYANMAR_Extended_A}', "");
    Error('\p{Blk=-_MYANMAR_EXT_a/a/}');
    Error('\P{Blk=-_MYANMAR_EXT_a/a/}');
    Expect(1, 43647, '\p{Blk=:\AMyanmar_Ext_A\z:}', "");;
    Expect(0, 43648, '\p{Blk=:\AMyanmar_Ext_A\z:}', "");;
    Expect(1, 43647, '\p{Blk=myanmarexta}', "");
    Expect(0, 43647, '\p{^Blk=myanmarexta}', "");
    Expect(0, 43647, '\P{Blk=myanmarexta}', "");
    Expect(1, 43647, '\P{^Blk=myanmarexta}', "");
    Expect(0, 43648, '\p{Blk=myanmarexta}', "");
    Expect(1, 43648, '\p{^Blk=myanmarexta}', "");
    Expect(1, 43648, '\P{Blk=myanmarexta}', "");
    Expect(0, 43648, '\P{^Blk=myanmarexta}', "");
    Expect(1, 43647, '\p{Blk=:\Amyanmarexta\z:}', "");;
    Expect(0, 43648, '\p{Blk=:\Amyanmarexta\z:}', "");;
    Expect(1, 43647, '\p{Blk=-_myanmar_Ext_a}', "");
    Expect(0, 43647, '\p{^Blk=-_myanmar_Ext_a}', "");
    Expect(0, 43647, '\P{Blk=-_myanmar_Ext_a}', "");
    Expect(1, 43647, '\P{^Blk=-_myanmar_Ext_a}', "");
    Expect(0, 43648, '\p{Blk=-_myanmar_Ext_a}', "");
    Expect(1, 43648, '\p{^Blk=-_myanmar_Ext_a}', "");
    Expect(1, 43648, '\P{Blk=-_myanmar_Ext_a}', "");
    Expect(0, 43648, '\P{^Blk=-_myanmar_Ext_a}', "");
    Error('\p{Is_Block=_:=MYANMAR_Extended_A}');
    Error('\P{Is_Block=_:=MYANMAR_Extended_A}');
    Expect(1, 43647, '\p{Is_Block=myanmarextendeda}', "");
    Expect(0, 43647, '\p{^Is_Block=myanmarextendeda}', "");
    Expect(0, 43647, '\P{Is_Block=myanmarextendeda}', "");
    Expect(1, 43647, '\P{^Is_Block=myanmarextendeda}', "");
    Expect(0, 43648, '\p{Is_Block=myanmarextendeda}', "");
    Expect(1, 43648, '\p{^Is_Block=myanmarextendeda}', "");
    Expect(1, 43648, '\P{Is_Block=myanmarextendeda}', "");
    Expect(0, 43648, '\P{^Is_Block=myanmarextendeda}', "");
    Expect(1, 43647, '\p{Is_Block=_Myanmar_Extended_A}', "");
    Expect(0, 43647, '\p{^Is_Block=_Myanmar_Extended_A}', "");
    Expect(0, 43647, '\P{Is_Block=_Myanmar_Extended_A}', "");
    Expect(1, 43647, '\P{^Is_Block=_Myanmar_Extended_A}', "");
    Expect(0, 43648, '\p{Is_Block=_Myanmar_Extended_A}', "");
    Expect(1, 43648, '\p{^Is_Block=_Myanmar_Extended_A}', "");
    Expect(1, 43648, '\P{Is_Block=_Myanmar_Extended_A}', "");
    Expect(0, 43648, '\P{^Is_Block=_Myanmar_Extended_A}', "");
    Error('\p{Is_Blk=-	MYANMAR_Ext_a/a/}');
    Error('\P{Is_Blk=-	MYANMAR_Ext_a/a/}');
    Expect(1, 43647, '\p{Is_Blk=myanmarexta}', "");
    Expect(0, 43647, '\p{^Is_Blk=myanmarexta}', "");
    Expect(0, 43647, '\P{Is_Blk=myanmarexta}', "");
    Expect(1, 43647, '\P{^Is_Blk=myanmarexta}', "");
    Expect(0, 43648, '\p{Is_Blk=myanmarexta}', "");
    Expect(1, 43648, '\p{^Is_Blk=myanmarexta}', "");
    Expect(1, 43648, '\P{Is_Blk=myanmarexta}', "");
    Expect(0, 43648, '\P{^Is_Blk=myanmarexta}', "");
    Expect(1, 43647, '\p{Is_Blk=	-Myanmar_Ext_A}', "");
    Expect(0, 43647, '\p{^Is_Blk=	-Myanmar_Ext_A}', "");
    Expect(0, 43647, '\P{Is_Blk=	-Myanmar_Ext_A}', "");
    Expect(1, 43647, '\P{^Is_Blk=	-Myanmar_Ext_A}', "");
    Expect(0, 43648, '\p{Is_Blk=	-Myanmar_Ext_A}', "");
    Expect(1, 43648, '\p{^Is_Blk=	-Myanmar_Ext_A}', "");
    Expect(1, 43648, '\P{Is_Blk=	-Myanmar_Ext_A}', "");
    Expect(0, 43648, '\P{^Is_Blk=	-Myanmar_Ext_A}', "");
    Error('\p{Block=:=Myanmar_EXTENDED_B}');
    Error('\P{Block=:=Myanmar_EXTENDED_B}');
    Expect(1, 43519, '\p{Block=:\AMyanmar_Extended_B\z:}', "");;
    Expect(0, 43520, '\p{Block=:\AMyanmar_Extended_B\z:}', "");;
    Expect(1, 43519, '\p{Block=myanmarextendedb}', "");
    Expect(0, 43519, '\p{^Block=myanmarextendedb}', "");
    Expect(0, 43519, '\P{Block=myanmarextendedb}', "");
    Expect(1, 43519, '\P{^Block=myanmarextendedb}', "");
    Expect(0, 43520, '\p{Block=myanmarextendedb}', "");
    Expect(1, 43520, '\p{^Block=myanmarextendedb}', "");
    Expect(1, 43520, '\P{Block=myanmarextendedb}', "");
    Expect(0, 43520, '\P{^Block=myanmarextendedb}', "");
    Expect(1, 43519, '\p{Block=:\Amyanmarextendedb\z:}', "");;
    Expect(0, 43520, '\p{Block=:\Amyanmarextendedb\z:}', "");;
    Expect(1, 43519, '\p{Block=-_myanmar_Extended_B}', "");
    Expect(0, 43519, '\p{^Block=-_myanmar_Extended_B}', "");
    Expect(0, 43519, '\P{Block=-_myanmar_Extended_B}', "");
    Expect(1, 43519, '\P{^Block=-_myanmar_Extended_B}', "");
    Expect(0, 43520, '\p{Block=-_myanmar_Extended_B}', "");
    Expect(1, 43520, '\p{^Block=-_myanmar_Extended_B}', "");
    Expect(1, 43520, '\P{Block=-_myanmar_Extended_B}', "");
    Expect(0, 43520, '\P{^Block=-_myanmar_Extended_B}', "");
    Error('\p{Blk:	/a/		Myanmar_Ext_B}');
    Error('\P{Blk:	/a/		Myanmar_Ext_B}');
    Expect(1, 43519, '\p{Blk=:\AMyanmar_Ext_B\z:}', "");;
    Expect(0, 43520, '\p{Blk=:\AMyanmar_Ext_B\z:}', "");;
    Expect(1, 43519, '\p{Blk=myanmarextb}', "");
    Expect(0, 43519, '\p{^Blk=myanmarextb}', "");
    Expect(0, 43519, '\P{Blk=myanmarextb}', "");
    Expect(1, 43519, '\P{^Blk=myanmarextb}', "");
    Expect(0, 43520, '\p{Blk=myanmarextb}', "");
    Expect(1, 43520, '\p{^Blk=myanmarextb}', "");
    Expect(1, 43520, '\P{Blk=myanmarextb}', "");
    Expect(0, 43520, '\P{^Blk=myanmarextb}', "");
    Expect(1, 43519, '\p{Blk=:\Amyanmarextb\z:}', "");;
    Expect(0, 43520, '\p{Blk=:\Amyanmarextb\z:}', "");;
    Expect(1, 43519, '\p{Blk:-Myanmar_ext_B}', "");
    Expect(0, 43519, '\p{^Blk:-Myanmar_ext_B}', "");
    Expect(0, 43519, '\P{Blk:-Myanmar_ext_B}', "");
    Expect(1, 43519, '\P{^Blk:-Myanmar_ext_B}', "");
    Expect(0, 43520, '\p{Blk:-Myanmar_ext_B}', "");
    Expect(1, 43520, '\p{^Blk:-Myanmar_ext_B}', "");
    Expect(1, 43520, '\P{Blk:-Myanmar_ext_B}', "");
    Expect(0, 43520, '\P{^Blk:-Myanmar_ext_B}', "");
    Error('\p{Is_Block= /a/Myanmar_EXTENDED_b}');
    Error('\P{Is_Block= /a/Myanmar_EXTENDED_b}');
    Expect(1, 43519, '\p{Is_Block=myanmarextendedb}', "");
    Expect(0, 43519, '\p{^Is_Block=myanmarextendedb}', "");
    Expect(0, 43519, '\P{Is_Block=myanmarextendedb}', "");
    Expect(1, 43519, '\P{^Is_Block=myanmarextendedb}', "");
    Expect(0, 43520, '\p{Is_Block=myanmarextendedb}', "");
    Expect(1, 43520, '\p{^Is_Block=myanmarextendedb}', "");
    Expect(1, 43520, '\P{Is_Block=myanmarextendedb}', "");
    Expect(0, 43520, '\P{^Is_Block=myanmarextendedb}', "");
    Expect(1, 43519, '\p{Is_Block= -Myanmar_extended_b}', "");
    Expect(0, 43519, '\p{^Is_Block= -Myanmar_extended_b}', "");
    Expect(0, 43519, '\P{Is_Block= -Myanmar_extended_b}', "");
    Expect(1, 43519, '\P{^Is_Block= -Myanmar_extended_b}', "");
    Expect(0, 43520, '\p{Is_Block= -Myanmar_extended_b}', "");
    Expect(1, 43520, '\p{^Is_Block= -Myanmar_extended_b}', "");
    Expect(1, 43520, '\P{Is_Block= -Myanmar_extended_b}', "");
    Expect(0, 43520, '\P{^Is_Block= -Myanmar_extended_b}', "");
    Error('\p{Is_Blk= :=MYANMAR_EXT_B}');
    Error('\P{Is_Blk= :=MYANMAR_EXT_B}');
    Expect(1, 43519, '\p{Is_Blk=myanmarextb}', "");
    Expect(0, 43519, '\p{^Is_Blk=myanmarextb}', "");
    Expect(0, 43519, '\P{Is_Blk=myanmarextb}', "");
    Expect(1, 43519, '\P{^Is_Blk=myanmarextb}', "");
    Expect(0, 43520, '\p{Is_Blk=myanmarextb}', "");
    Expect(1, 43520, '\p{^Is_Blk=myanmarextb}', "");
    Expect(1, 43520, '\P{Is_Blk=myanmarextb}', "");
    Expect(0, 43520, '\P{^Is_Blk=myanmarextb}', "");
    Expect(1, 43519, '\p{Is_Blk=-Myanmar_ext_b}', "");
    Expect(0, 43519, '\p{^Is_Blk=-Myanmar_ext_b}', "");
    Expect(0, 43519, '\P{Is_Blk=-Myanmar_ext_b}', "");
    Expect(1, 43519, '\P{^Is_Blk=-Myanmar_ext_b}', "");
    Expect(0, 43520, '\p{Is_Blk=-Myanmar_ext_b}', "");
    Expect(1, 43520, '\p{^Is_Blk=-Myanmar_ext_b}', "");
    Expect(1, 43520, '\P{Is_Blk=-Myanmar_ext_b}', "");
    Expect(0, 43520, '\P{^Is_Blk=-Myanmar_ext_b}', "");
    Error('\p{Block=:=--Nabataean}');
    Error('\P{Block=:=--Nabataean}');
    Expect(1, 67759, '\p{Block=:\ANabataean\z:}', "");;
    Expect(0, 67760, '\p{Block=:\ANabataean\z:}', "");;
    Expect(1, 67759, '\p{Block:nabataean}', "");
    Expect(0, 67759, '\p{^Block:nabataean}', "");
    Expect(0, 67759, '\P{Block:nabataean}', "");
    Expect(1, 67759, '\P{^Block:nabataean}', "");
    Expect(0, 67760, '\p{Block:nabataean}', "");
    Expect(1, 67760, '\p{^Block:nabataean}', "");
    Expect(1, 67760, '\P{Block:nabataean}', "");
    Expect(0, 67760, '\P{^Block:nabataean}', "");
    Expect(1, 67759, '\p{Block=:\Anabataean\z:}', "");;
    Expect(0, 67760, '\p{Block=:\Anabataean\z:}', "");;
    Expect(1, 67759, '\p{Block=__nabataean}', "");
    Expect(0, 67759, '\p{^Block=__nabataean}', "");
    Expect(0, 67759, '\P{Block=__nabataean}', "");
    Expect(1, 67759, '\P{^Block=__nabataean}', "");
    Expect(0, 67760, '\p{Block=__nabataean}', "");
    Expect(1, 67760, '\p{^Block=__nabataean}', "");
    Expect(1, 67760, '\P{Block=__nabataean}', "");
    Expect(0, 67760, '\P{^Block=__nabataean}', "");
    Error('\p{Blk=	/a/nabataean}');
    Error('\P{Blk=	/a/nabataean}');
    Expect(1, 67759, '\p{Blk=:\ANabataean\z:}', "");;
    Expect(0, 67760, '\p{Blk=:\ANabataean\z:}', "");;
    Expect(1, 67759, '\p{Blk=nabataean}', "");
    Expect(0, 67759, '\p{^Blk=nabataean}', "");
    Expect(0, 67759, '\P{Blk=nabataean}', "");
    Expect(1, 67759, '\P{^Blk=nabataean}', "");
    Expect(0, 67760, '\p{Blk=nabataean}', "");
    Expect(1, 67760, '\p{^Blk=nabataean}', "");
    Expect(1, 67760, '\P{Blk=nabataean}', "");
    Expect(0, 67760, '\P{^Blk=nabataean}', "");
    Expect(1, 67759, '\p{Blk=:\Anabataean\z:}', "");;
    Expect(0, 67760, '\p{Blk=:\Anabataean\z:}', "");;
    Expect(1, 67759, '\p{Blk=-NABATAEAN}', "");
    Expect(0, 67759, '\p{^Blk=-NABATAEAN}', "");
    Expect(0, 67759, '\P{Blk=-NABATAEAN}', "");
    Expect(1, 67759, '\P{^Blk=-NABATAEAN}', "");
    Expect(0, 67760, '\p{Blk=-NABATAEAN}', "");
    Expect(1, 67760, '\p{^Blk=-NABATAEAN}', "");
    Expect(1, 67760, '\P{Blk=-NABATAEAN}', "");
    Expect(0, 67760, '\P{^Blk=-NABATAEAN}', "");
    Error('\p{Is_Block=/a/-	NABATAEAN}');
    Error('\P{Is_Block=/a/-	NABATAEAN}');
    Expect(1, 67759, '\p{Is_Block=nabataean}', "");
    Expect(0, 67759, '\p{^Is_Block=nabataean}', "");
    Expect(0, 67759, '\P{Is_Block=nabataean}', "");
    Expect(1, 67759, '\P{^Is_Block=nabataean}', "");
    Expect(0, 67760, '\p{Is_Block=nabataean}', "");
    Expect(1, 67760, '\p{^Is_Block=nabataean}', "");
    Expect(1, 67760, '\P{Is_Block=nabataean}', "");
    Expect(0, 67760, '\P{^Is_Block=nabataean}', "");
    Expect(1, 67759, '\p{Is_Block=-	NABATAEAN}', "");
    Expect(0, 67759, '\p{^Is_Block=-	NABATAEAN}', "");
    Expect(0, 67759, '\P{Is_Block=-	NABATAEAN}', "");
    Expect(1, 67759, '\P{^Is_Block=-	NABATAEAN}', "");
    Expect(0, 67760, '\p{Is_Block=-	NABATAEAN}', "");
    Expect(1, 67760, '\p{^Is_Block=-	NABATAEAN}', "");
    Expect(1, 67760, '\P{Is_Block=-	NABATAEAN}', "");
    Expect(0, 67760, '\P{^Is_Block=-	NABATAEAN}', "");
    Error('\p{Is_Blk=-:=nabataean}');
    Error('\P{Is_Blk=-:=nabataean}');
    Expect(1, 67759, '\p{Is_Blk=nabataean}', "");
    Expect(0, 67759, '\p{^Is_Blk=nabataean}', "");
    Expect(0, 67759, '\P{Is_Blk=nabataean}', "");
    Expect(1, 67759, '\P{^Is_Blk=nabataean}', "");
    Expect(0, 67760, '\p{Is_Blk=nabataean}', "");
    Expect(1, 67760, '\p{^Is_Blk=nabataean}', "");
    Expect(1, 67760, '\P{Is_Blk=nabataean}', "");
    Expect(0, 67760, '\P{^Is_Blk=nabataean}', "");
    Expect(1, 67759, '\p{Is_Blk=_nabataean}', "");
    Expect(0, 67759, '\p{^Is_Blk=_nabataean}', "");
    Expect(0, 67759, '\P{Is_Blk=_nabataean}', "");
    Expect(1, 67759, '\P{^Is_Blk=_nabataean}', "");
    Expect(0, 67760, '\p{Is_Blk=_nabataean}', "");
    Expect(1, 67760, '\p{^Is_Blk=_nabataean}', "");
    Expect(1, 67760, '\P{Is_Blk=_nabataean}', "");
    Expect(0, 67760, '\P{^Is_Blk=_nabataean}', "");
    Error('\p{Block=	NANDINAGARI:=}');
    Error('\P{Block=	NANDINAGARI:=}');
    Expect(1, 72191, '\p{Block=:\ANandinagari\z:}', "");;
    Expect(0, 72192, '\p{Block=:\ANandinagari\z:}', "");;
    Expect(1, 72191, '\p{Block=nandinagari}', "");
    Expect(0, 72191, '\p{^Block=nandinagari}', "");
    Expect(0, 72191, '\P{Block=nandinagari}', "");
    Expect(1, 72191, '\P{^Block=nandinagari}', "");
    Expect(0, 72192, '\p{Block=nandinagari}', "");
    Expect(1, 72192, '\p{^Block=nandinagari}', "");
    Expect(1, 72192, '\P{Block=nandinagari}', "");
    Expect(0, 72192, '\P{^Block=nandinagari}', "");
    Expect(1, 72191, '\p{Block=:\Anandinagari\z:}', "");;
    Expect(0, 72192, '\p{Block=:\Anandinagari\z:}', "");;
    Expect(1, 72191, '\p{Block:  Nandinagari}', "");
    Expect(0, 72191, '\p{^Block:  Nandinagari}', "");
    Expect(0, 72191, '\P{Block:  Nandinagari}', "");
    Expect(1, 72191, '\P{^Block:  Nandinagari}', "");
    Expect(0, 72192, '\p{Block:  Nandinagari}', "");
    Expect(1, 72192, '\p{^Block:  Nandinagari}', "");
    Expect(1, 72192, '\P{Block:  Nandinagari}', "");
    Expect(0, 72192, '\P{^Block:  Nandinagari}', "");
    Error('\p{Blk= :=NANDINAGARI}');
    Error('\P{Blk= :=NANDINAGARI}');
    Expect(1, 72191, '\p{Blk=:\ANandinagari\z:}', "");;
    Expect(0, 72192, '\p{Blk=:\ANandinagari\z:}', "");;
    Expect(1, 72191, '\p{Blk=nandinagari}', "");
    Expect(0, 72191, '\p{^Blk=nandinagari}', "");
    Expect(0, 72191, '\P{Blk=nandinagari}', "");
    Expect(1, 72191, '\P{^Blk=nandinagari}', "");
    Expect(0, 72192, '\p{Blk=nandinagari}', "");
    Expect(1, 72192, '\p{^Blk=nandinagari}', "");
    Expect(1, 72192, '\P{Blk=nandinagari}', "");
    Expect(0, 72192, '\P{^Blk=nandinagari}', "");
    Expect(1, 72191, '\p{Blk=:\Anandinagari\z:}', "");;
    Expect(0, 72192, '\p{Blk=:\Anandinagari\z:}', "");;
    Expect(1, 72191, '\p{Blk=-NANDINAGARI}', "");
    Expect(0, 72191, '\p{^Blk=-NANDINAGARI}', "");
    Expect(0, 72191, '\P{Blk=-NANDINAGARI}', "");
    Expect(1, 72191, '\P{^Blk=-NANDINAGARI}', "");
    Expect(0, 72192, '\p{Blk=-NANDINAGARI}', "");
    Expect(1, 72192, '\p{^Blk=-NANDINAGARI}', "");
    Expect(1, 72192, '\P{Blk=-NANDINAGARI}', "");
    Expect(0, 72192, '\P{^Blk=-NANDINAGARI}', "");
    Error('\p{Is_Block=/a/__NANDINAGARI}');
    Error('\P{Is_Block=/a/__NANDINAGARI}');
    Expect(1, 72191, '\p{Is_Block=nandinagari}', "");
    Expect(0, 72191, '\p{^Is_Block=nandinagari}', "");
    Expect(0, 72191, '\P{Is_Block=nandinagari}', "");
    Expect(1, 72191, '\P{^Is_Block=nandinagari}', "");
    Expect(0, 72192, '\p{Is_Block=nandinagari}', "");
    Expect(1, 72192, '\p{^Is_Block=nandinagari}', "");
    Expect(1, 72192, '\P{Is_Block=nandinagari}', "");
    Expect(0, 72192, '\P{^Is_Block=nandinagari}', "");
    Expect(1, 72191, '\p{Is_Block=--Nandinagari}', "");
    Expect(0, 72191, '\p{^Is_Block=--Nandinagari}', "");
    Expect(0, 72191, '\P{Is_Block=--Nandinagari}', "");
    Expect(1, 72191, '\P{^Is_Block=--Nandinagari}', "");
    Expect(0, 72192, '\p{Is_Block=--Nandinagari}', "");
    Expect(1, 72192, '\p{^Is_Block=--Nandinagari}', "");
    Expect(1, 72192, '\P{Is_Block=--Nandinagari}', "");
    Expect(0, 72192, '\P{^Is_Block=--Nandinagari}', "");
    Error('\p{Is_Blk=--Nandinagari/a/}');
    Error('\P{Is_Blk=--Nandinagari/a/}');
    Expect(1, 72191, '\p{Is_Blk=nandinagari}', "");
    Expect(0, 72191, '\p{^Is_Blk=nandinagari}', "");
    Expect(0, 72191, '\P{Is_Blk=nandinagari}', "");
    Expect(1, 72191, '\P{^Is_Blk=nandinagari}', "");
    Expect(0, 72192, '\p{Is_Blk=nandinagari}', "");
    Expect(1, 72192, '\p{^Is_Blk=nandinagari}', "");
    Expect(1, 72192, '\P{Is_Blk=nandinagari}', "");
    Expect(0, 72192, '\P{^Is_Blk=nandinagari}', "");
    Error('\p{Block=:=No_block}');
    Error('\P{Block=:=No_block}');
    Expect(1, 918000, '\p{Block=:\ANo_Block\z:}', "");;
    Expect(0, 983040, '\p{Block=:\ANo_Block\z:}', "");;
    Expect(1, 918000, '\p{Block=noblock}', "");
    Expect(0, 918000, '\p{^Block=noblock}', "");
    Expect(0, 918000, '\P{Block=noblock}', "");
    Expect(1, 918000, '\P{^Block=noblock}', "");
    Expect(0, 983040, '\p{Block=noblock}', "");
    Expect(1, 983040, '\p{^Block=noblock}', "");
    Expect(1, 983040, '\P{Block=noblock}', "");
    Expect(0, 983040, '\P{^Block=noblock}', "");
    Expect(1, 918000, '\p{Block=:\Anoblock\z:}', "");;
    Expect(0, 983040, '\p{Block=:\Anoblock\z:}', "");;
    Expect(1, 918000, '\p{Block:   	No_Block}', "");
    Expect(0, 918000, '\p{^Block:   	No_Block}', "");
    Expect(0, 918000, '\P{Block:   	No_Block}', "");
    Expect(1, 918000, '\P{^Block:   	No_Block}', "");
    Expect(0, 983040, '\p{Block:   	No_Block}', "");
    Expect(1, 983040, '\p{^Block:   	No_Block}', "");
    Expect(1, 983040, '\P{Block:   	No_Block}', "");
    Expect(0, 983040, '\P{^Block:   	No_Block}', "");
    Error('\p{Blk=/a/		NB}');
    Error('\P{Blk=/a/		NB}');
    Expect(1, 918000, '\p{Blk=:\ANB\z:}', "");;
    Expect(0, 983040, '\p{Blk=:\ANB\z:}', "");;
    Expect(1, 918000, '\p{Blk=nb}', "");
    Expect(0, 918000, '\p{^Blk=nb}', "");
    Expect(0, 918000, '\P{Blk=nb}', "");
    Expect(1, 918000, '\P{^Blk=nb}', "");
    Expect(0, 983040, '\p{Blk=nb}', "");
    Expect(1, 983040, '\p{^Blk=nb}', "");
    Expect(1, 983040, '\P{Blk=nb}', "");
    Expect(0, 983040, '\P{^Blk=nb}', "");
    Expect(1, 918000, '\p{Blk=:\Anb\z:}', "");;
    Expect(0, 983040, '\p{Blk=:\Anb\z:}', "");;
    Expect(1, 918000, '\p{Blk= 	NB}', "");
    Expect(0, 918000, '\p{^Blk= 	NB}', "");
    Expect(0, 918000, '\P{Blk= 	NB}', "");
    Expect(1, 918000, '\P{^Blk= 	NB}', "");
    Expect(0, 983040, '\p{Blk= 	NB}', "");
    Expect(1, 983040, '\p{^Blk= 	NB}', "");
    Expect(1, 983040, '\P{Blk= 	NB}', "");
    Expect(0, 983040, '\P{^Blk= 	NB}', "");
    Error('\p{Is_Block=/a/-NO_BLOCK}');
    Error('\P{Is_Block=/a/-NO_BLOCK}');
    Expect(1, 918000, '\p{Is_Block=noblock}', "");
    Expect(0, 918000, '\p{^Is_Block=noblock}', "");
    Expect(0, 918000, '\P{Is_Block=noblock}', "");
    Expect(1, 918000, '\P{^Is_Block=noblock}', "");
    Expect(0, 983040, '\p{Is_Block=noblock}', "");
    Expect(1, 983040, '\p{^Is_Block=noblock}', "");
    Expect(1, 983040, '\P{Is_Block=noblock}', "");
    Expect(0, 983040, '\P{^Is_Block=noblock}', "");
    Expect(1, 918000, '\p{Is_Block: No_block}', "");
    Expect(0, 918000, '\p{^Is_Block: No_block}', "");
    Expect(0, 918000, '\P{Is_Block: No_block}', "");
    Expect(1, 918000, '\P{^Is_Block: No_block}', "");
    Expect(0, 983040, '\p{Is_Block: No_block}', "");
    Expect(1, 983040, '\p{^Is_Block: No_block}', "");
    Expect(1, 983040, '\P{Is_Block: No_block}', "");
    Expect(0, 983040, '\P{^Is_Block: No_block}', "");
    Error('\p{Is_Blk:-:=NB}');
    Error('\P{Is_Blk:-:=NB}');
    Expect(1, 918000, '\p{Is_Blk=nb}', "");
    Expect(0, 918000, '\p{^Is_Blk=nb}', "");
    Expect(0, 918000, '\P{Is_Blk=nb}', "");
    Expect(1, 918000, '\P{^Is_Blk=nb}', "");
    Expect(0, 983040, '\p{Is_Blk=nb}', "");
    Expect(1, 983040, '\p{^Is_Blk=nb}', "");
    Expect(1, 983040, '\P{Is_Blk=nb}', "");
    Expect(0, 983040, '\P{^Is_Blk=nb}', "");
    Expect(1, 918000, '\p{Is_Blk=_	NB}', "");
    Expect(0, 918000, '\p{^Is_Blk=_	NB}', "");
    Expect(0, 918000, '\P{Is_Blk=_	NB}', "");
    Expect(1, 918000, '\P{^Is_Blk=_	NB}', "");
    Expect(0, 983040, '\p{Is_Blk=_	NB}', "");
    Expect(1, 983040, '\p{^Is_Blk=_	NB}', "");
    Expect(1, 983040, '\P{Is_Blk=_	NB}', "");
    Expect(0, 983040, '\P{^Is_Blk=_	NB}', "");
    Error('\p{Block= :=NEW_tai_Lue}');
    Error('\P{Block= :=NEW_tai_Lue}');
    Expect(1, 6623, '\p{Block=:\ANew_Tai_Lue\z:}', "");;
    Expect(0, 6624, '\p{Block=:\ANew_Tai_Lue\z:}', "");;
    Expect(1, 6623, '\p{Block=newtailue}', "");
    Expect(0, 6623, '\p{^Block=newtailue}', "");
    Expect(0, 6623, '\P{Block=newtailue}', "");
    Expect(1, 6623, '\P{^Block=newtailue}', "");
    Expect(0, 6624, '\p{Block=newtailue}', "");
    Expect(1, 6624, '\p{^Block=newtailue}', "");
    Expect(1, 6624, '\P{Block=newtailue}', "");
    Expect(0, 6624, '\P{^Block=newtailue}', "");
    Expect(1, 6623, '\p{Block=:\Anewtailue\z:}', "");;
    Expect(0, 6624, '\p{Block=:\Anewtailue\z:}', "");;
    Expect(1, 6623, '\p{Block= _NEW_tai_Lue}', "");
    Expect(0, 6623, '\p{^Block= _NEW_tai_Lue}', "");
    Expect(0, 6623, '\P{Block= _NEW_tai_Lue}', "");
    Expect(1, 6623, '\P{^Block= _NEW_tai_Lue}', "");
    Expect(0, 6624, '\p{Block= _NEW_tai_Lue}', "");
    Expect(1, 6624, '\p{^Block= _NEW_tai_Lue}', "");
    Expect(1, 6624, '\P{Block= _NEW_tai_Lue}', "");
    Expect(0, 6624, '\P{^Block= _NEW_tai_Lue}', "");
    Error('\p{Blk=/a/-_New_Tai_Lue}');
    Error('\P{Blk=/a/-_New_Tai_Lue}');
    Expect(1, 6623, '\p{Blk=:\ANew_Tai_Lue\z:}', "");;
    Expect(0, 6624, '\p{Blk=:\ANew_Tai_Lue\z:}', "");;
    Expect(1, 6623, '\p{Blk=newtailue}', "");
    Expect(0, 6623, '\p{^Blk=newtailue}', "");
    Expect(0, 6623, '\P{Blk=newtailue}', "");
    Expect(1, 6623, '\P{^Blk=newtailue}', "");
    Expect(0, 6624, '\p{Blk=newtailue}', "");
    Expect(1, 6624, '\p{^Blk=newtailue}', "");
    Expect(1, 6624, '\P{Blk=newtailue}', "");
    Expect(0, 6624, '\P{^Blk=newtailue}', "");
    Expect(1, 6623, '\p{Blk=:\Anewtailue\z:}', "");;
    Expect(0, 6624, '\p{Blk=:\Anewtailue\z:}', "");;
    Expect(1, 6623, '\p{Blk=_	new_TAI_lue}', "");
    Expect(0, 6623, '\p{^Blk=_	new_TAI_lue}', "");
    Expect(0, 6623, '\P{Blk=_	new_TAI_lue}', "");
    Expect(1, 6623, '\P{^Blk=_	new_TAI_lue}', "");
    Expect(0, 6624, '\p{Blk=_	new_TAI_lue}', "");
    Expect(1, 6624, '\p{^Blk=_	new_TAI_lue}', "");
    Expect(1, 6624, '\P{Blk=_	new_TAI_lue}', "");
    Expect(0, 6624, '\P{^Blk=_	new_TAI_lue}', "");
    Error('\p{Is_Block=_:=new_Tai_Lue}');
    Error('\P{Is_Block=_:=new_Tai_Lue}');
    Expect(1, 6623, '\p{Is_Block=newtailue}', "");
    Expect(0, 6623, '\p{^Is_Block=newtailue}', "");
    Expect(0, 6623, '\P{Is_Block=newtailue}', "");
    Expect(1, 6623, '\P{^Is_Block=newtailue}', "");
    Expect(0, 6624, '\p{Is_Block=newtailue}', "");
    Expect(1, 6624, '\p{^Is_Block=newtailue}', "");
    Expect(1, 6624, '\P{Is_Block=newtailue}', "");
    Expect(0, 6624, '\P{^Is_Block=newtailue}', "");
    Expect(1, 6623, '\p{Is_Block=-_new_Tai_Lue}', "");
    Expect(0, 6623, '\p{^Is_Block=-_new_Tai_Lue}', "");
    Expect(0, 6623, '\P{Is_Block=-_new_Tai_Lue}', "");
    Expect(1, 6623, '\P{^Is_Block=-_new_Tai_Lue}', "");
    Expect(0, 6624, '\p{Is_Block=-_new_Tai_Lue}', "");
    Expect(1, 6624, '\p{^Is_Block=-_new_Tai_Lue}', "");
    Expect(1, 6624, '\P{Is_Block=-_new_Tai_Lue}', "");
    Expect(0, 6624, '\P{^Is_Block=-_new_Tai_Lue}', "");
    Error('\p{Is_Blk= new_tai_LUE/a/}');
    Error('\P{Is_Blk= new_tai_LUE/a/}');
    Expect(1, 6623, '\p{Is_Blk=newtailue}', "");
    Expect(0, 6623, '\p{^Is_Blk=newtailue}', "");
    Expect(0, 6623, '\P{Is_Blk=newtailue}', "");
    Expect(1, 6623, '\P{^Is_Blk=newtailue}', "");
    Expect(0, 6624, '\p{Is_Blk=newtailue}', "");
    Expect(1, 6624, '\p{^Is_Blk=newtailue}', "");
    Expect(1, 6624, '\P{Is_Blk=newtailue}', "");
    Expect(0, 6624, '\P{^Is_Blk=newtailue}', "");
    Expect(1, 6623, '\p{Is_Blk:  	New_TAI_lue}', "");
    Expect(0, 6623, '\p{^Is_Blk:  	New_TAI_lue}', "");
    Expect(0, 6623, '\P{Is_Blk:  	New_TAI_lue}', "");
    Expect(1, 6623, '\P{^Is_Blk:  	New_TAI_lue}', "");
    Expect(0, 6624, '\p{Is_Blk:  	New_TAI_lue}', "");
    Expect(1, 6624, '\p{^Is_Blk:  	New_TAI_lue}', "");
    Expect(1, 6624, '\P{Is_Blk:  	New_TAI_lue}', "");
    Expect(0, 6624, '\P{^Is_Blk:  	New_TAI_lue}', "");
    Error('\p{Block=/a/_Newa}');
    Error('\P{Block=/a/_Newa}');
    Expect(1, 70783, '\p{Block=:\ANewa\z:}', "");;
    Expect(0, 70784, '\p{Block=:\ANewa\z:}', "");;
    Expect(1, 70783, '\p{Block=newa}', "");
    Expect(0, 70783, '\p{^Block=newa}', "");
    Expect(0, 70783, '\P{Block=newa}', "");
    Expect(1, 70783, '\P{^Block=newa}', "");
    Expect(0, 70784, '\p{Block=newa}', "");
    Expect(1, 70784, '\p{^Block=newa}', "");
    Expect(1, 70784, '\P{Block=newa}', "");
    Expect(0, 70784, '\P{^Block=newa}', "");
    Expect(1, 70783, '\p{Block=:\Anewa\z:}', "");;
    Expect(0, 70784, '\p{Block=:\Anewa\z:}', "");;
    Expect(1, 70783, '\p{Block:		newa}', "");
    Expect(0, 70783, '\p{^Block:		newa}', "");
    Expect(0, 70783, '\P{Block:		newa}', "");
    Expect(1, 70783, '\P{^Block:		newa}', "");
    Expect(0, 70784, '\p{Block:		newa}', "");
    Expect(1, 70784, '\p{^Block:		newa}', "");
    Expect(1, 70784, '\P{Block:		newa}', "");
    Expect(0, 70784, '\P{^Block:		newa}', "");
    Error('\p{Blk=-:=NEWA}');
    Error('\P{Blk=-:=NEWA}');
    Expect(1, 70783, '\p{Blk=:\ANewa\z:}', "");;
    Expect(0, 70784, '\p{Blk=:\ANewa\z:}', "");;
    Expect(1, 70783, '\p{Blk=newa}', "");
    Expect(0, 70783, '\p{^Blk=newa}', "");
    Expect(0, 70783, '\P{Blk=newa}', "");
    Expect(1, 70783, '\P{^Blk=newa}', "");
    Expect(0, 70784, '\p{Blk=newa}', "");
    Expect(1, 70784, '\p{^Blk=newa}', "");
    Expect(1, 70784, '\P{Blk=newa}', "");
    Expect(0, 70784, '\P{^Blk=newa}', "");
    Expect(1, 70783, '\p{Blk=:\Anewa\z:}', "");;
    Expect(0, 70784, '\p{Blk=:\Anewa\z:}', "");;
    Expect(1, 70783, '\p{Blk=Newa}', "");
    Expect(0, 70783, '\p{^Blk=Newa}', "");
    Expect(0, 70783, '\P{Blk=Newa}', "");
    Expect(1, 70783, '\P{^Blk=Newa}', "");
    Expect(0, 70784, '\p{Blk=Newa}', "");
    Expect(1, 70784, '\p{^Blk=Newa}', "");
    Expect(1, 70784, '\P{Blk=Newa}', "");
    Expect(0, 70784, '\P{^Blk=Newa}', "");
    Error('\p{Is_Block: /a/_NEWA}');
    Error('\P{Is_Block: /a/_NEWA}');
    Expect(1, 70783, '\p{Is_Block=newa}', "");
    Expect(0, 70783, '\p{^Is_Block=newa}', "");
    Expect(0, 70783, '\P{Is_Block=newa}', "");
    Expect(1, 70783, '\P{^Is_Block=newa}', "");
    Expect(0, 70784, '\p{Is_Block=newa}', "");
    Expect(1, 70784, '\p{^Is_Block=newa}', "");
    Expect(1, 70784, '\P{Is_Block=newa}', "");
    Expect(0, 70784, '\P{^Is_Block=newa}', "");
    Expect(1, 70783, '\p{Is_Block:   -_NEWA}', "");
    Expect(0, 70783, '\p{^Is_Block:   -_NEWA}', "");
    Expect(0, 70783, '\P{Is_Block:   -_NEWA}', "");
    Expect(1, 70783, '\P{^Is_Block:   -_NEWA}', "");
    Expect(0, 70784, '\p{Is_Block:   -_NEWA}', "");
    Expect(1, 70784, '\p{^Is_Block:   -_NEWA}', "");
    Expect(1, 70784, '\P{Is_Block:   -_NEWA}', "");
    Expect(0, 70784, '\P{^Is_Block:   -_NEWA}', "");
    Error('\p{Is_Blk=_newa/a/}');
    Error('\P{Is_Blk=_newa/a/}');
    Expect(1, 70783, '\p{Is_Blk=newa}', "");
    Expect(0, 70783, '\p{^Is_Blk=newa}', "");
    Expect(0, 70783, '\P{Is_Blk=newa}', "");
    Expect(1, 70783, '\P{^Is_Blk=newa}', "");
    Expect(0, 70784, '\p{Is_Blk=newa}', "");
    Expect(1, 70784, '\p{^Is_Blk=newa}', "");
    Expect(1, 70784, '\P{Is_Blk=newa}', "");
    Expect(0, 70784, '\P{^Is_Blk=newa}', "");
    Expect(1, 70783, '\p{Is_Blk=	 Newa}', "");
    Expect(0, 70783, '\p{^Is_Blk=	 Newa}', "");
    Expect(0, 70783, '\P{Is_Blk=	 Newa}', "");
    Expect(1, 70783, '\P{^Is_Blk=	 Newa}', "");
    Expect(0, 70784, '\p{Is_Blk=	 Newa}', "");
    Expect(1, 70784, '\p{^Is_Blk=	 Newa}', "");
    Expect(1, 70784, '\P{Is_Blk=	 Newa}', "");
    Expect(0, 70784, '\P{^Is_Blk=	 Newa}', "");
    Error('\p{Block=- NKO/a/}');
    Error('\P{Block=- NKO/a/}');
    Expect(1, 2047, '\p{Block=:\ANKo\z:}', "");;
    Expect(0, 2048, '\p{Block=:\ANKo\z:}', "");;
    Expect(1, 2047, '\p{Block=nko}', "");
    Expect(0, 2047, '\p{^Block=nko}', "");
    Expect(0, 2047, '\P{Block=nko}', "");
    Expect(1, 2047, '\P{^Block=nko}', "");
    Expect(0, 2048, '\p{Block=nko}', "");
    Expect(1, 2048, '\p{^Block=nko}', "");
    Expect(1, 2048, '\P{Block=nko}', "");
    Expect(0, 2048, '\P{^Block=nko}', "");
    Expect(1, 2047, '\p{Block=:\Anko\z:}', "");;
    Expect(0, 2048, '\p{Block=:\Anko\z:}', "");;
    Expect(1, 2047, '\p{Block=NKO}', "");
    Expect(0, 2047, '\p{^Block=NKO}', "");
    Expect(0, 2047, '\P{Block=NKO}', "");
    Expect(1, 2047, '\P{^Block=NKO}', "");
    Expect(0, 2048, '\p{Block=NKO}', "");
    Expect(1, 2048, '\p{^Block=NKO}', "");
    Expect(1, 2048, '\P{Block=NKO}', "");
    Expect(0, 2048, '\P{^Block=NKO}', "");
    Error('\p{Blk=/a/_	NKO}');
    Error('\P{Blk=/a/_	NKO}');
    Expect(1, 2047, '\p{Blk=:\ANKo\z:}', "");;
    Expect(0, 2048, '\p{Blk=:\ANKo\z:}', "");;
    Expect(1, 2047, '\p{Blk=nko}', "");
    Expect(0, 2047, '\p{^Blk=nko}', "");
    Expect(0, 2047, '\P{Blk=nko}', "");
    Expect(1, 2047, '\P{^Blk=nko}', "");
    Expect(0, 2048, '\p{Blk=nko}', "");
    Expect(1, 2048, '\p{^Blk=nko}', "");
    Expect(1, 2048, '\P{Blk=nko}', "");
    Expect(0, 2048, '\P{^Blk=nko}', "");
    Expect(1, 2047, '\p{Blk=:\Anko\z:}', "");;
    Expect(0, 2048, '\p{Blk=:\Anko\z:}', "");;
    Expect(1, 2047, '\p{Blk=	 NKo}', "");
    Expect(0, 2047, '\p{^Blk=	 NKo}', "");
    Expect(0, 2047, '\P{Blk=	 NKo}', "");
    Expect(1, 2047, '\P{^Blk=	 NKo}', "");
    Expect(0, 2048, '\p{Blk=	 NKo}', "");
    Expect(1, 2048, '\p{^Blk=	 NKo}', "");
    Expect(1, 2048, '\P{Blk=	 NKo}', "");
    Expect(0, 2048, '\P{^Blk=	 NKo}', "");
    Error('\p{Is_Block:	 /a/nko}');
    Error('\P{Is_Block:	 /a/nko}');
    Expect(1, 2047, '\p{Is_Block=nko}', "");
    Expect(0, 2047, '\p{^Is_Block=nko}', "");
    Expect(0, 2047, '\P{Is_Block=nko}', "");
    Expect(1, 2047, '\P{^Is_Block=nko}', "");
    Expect(0, 2048, '\p{Is_Block=nko}', "");
    Expect(1, 2048, '\p{^Is_Block=nko}', "");
    Expect(1, 2048, '\P{Is_Block=nko}', "");
    Expect(0, 2048, '\P{^Is_Block=nko}', "");
    Expect(1, 2047, '\p{Is_Block:		nko}', "");
    Expect(0, 2047, '\p{^Is_Block:		nko}', "");
    Expect(0, 2047, '\P{Is_Block:		nko}', "");
    Expect(1, 2047, '\P{^Is_Block:		nko}', "");
    Expect(0, 2048, '\p{Is_Block:		nko}', "");
    Expect(1, 2048, '\p{^Is_Block:		nko}', "");
    Expect(1, 2048, '\P{Is_Block:		nko}', "");
    Expect(0, 2048, '\P{^Is_Block:		nko}', "");
    Error('\p{Is_Blk=/a/-	NKo}');
    Error('\P{Is_Blk=/a/-	NKo}');
    Expect(1, 2047, '\p{Is_Blk=nko}', "");
    Expect(0, 2047, '\p{^Is_Blk=nko}', "");
    Expect(0, 2047, '\P{Is_Blk=nko}', "");
    Expect(1, 2047, '\P{^Is_Blk=nko}', "");
    Expect(0, 2048, '\p{Is_Blk=nko}', "");
    Expect(1, 2048, '\p{^Is_Blk=nko}', "");
    Expect(1, 2048, '\P{Is_Blk=nko}', "");
    Expect(0, 2048, '\P{^Is_Blk=nko}', "");
    Expect(1, 2047, '\p{Is_Blk=- NKo}', "");
    Expect(0, 2047, '\p{^Is_Blk=- NKo}', "");
    Expect(0, 2047, '\P{Is_Blk=- NKo}', "");
    Expect(1, 2047, '\P{^Is_Blk=- NKo}', "");
    Expect(0, 2048, '\p{Is_Blk=- NKo}', "");
    Expect(1, 2048, '\p{^Is_Blk=- NKo}', "");
    Expect(1, 2048, '\P{Is_Blk=- NKo}', "");
    Expect(0, 2048, '\P{^Is_Blk=- NKo}', "");
    Error('\p{Block=:=-NUMBER_Forms}');
    Error('\P{Block=:=-NUMBER_Forms}');
    Expect(1, 8591, '\p{Block=:\ANumber_Forms\z:}', "");;
    Expect(0, 8592, '\p{Block=:\ANumber_Forms\z:}', "");;
    Expect(1, 8591, '\p{Block=numberforms}', "");
    Expect(0, 8591, '\p{^Block=numberforms}', "");
    Expect(0, 8591, '\P{Block=numberforms}', "");
    Expect(1, 8591, '\P{^Block=numberforms}', "");
    Expect(0, 8592, '\p{Block=numberforms}', "");
    Expect(1, 8592, '\p{^Block=numberforms}', "");
    Expect(1, 8592, '\P{Block=numberforms}', "");
    Expect(0, 8592, '\P{^Block=numberforms}', "");
    Expect(1, 8591, '\p{Block=:\Anumberforms\z:}', "");;
    Expect(0, 8592, '\p{Block=:\Anumberforms\z:}', "");;
    Expect(1, 8591, '\p{Block=-_number_forms}', "");
    Expect(0, 8591, '\p{^Block=-_number_forms}', "");
    Expect(0, 8591, '\P{Block=-_number_forms}', "");
    Expect(1, 8591, '\P{^Block=-_number_forms}', "");
    Expect(0, 8592, '\p{Block=-_number_forms}', "");
    Expect(1, 8592, '\p{^Block=-_number_forms}', "");
    Expect(1, 8592, '\P{Block=-_number_forms}', "");
    Expect(0, 8592, '\P{^Block=-_number_forms}', "");
    Error('\p{Blk=	Number_FORMS:=}');
    Error('\P{Blk=	Number_FORMS:=}');
    Expect(1, 8591, '\p{Blk=:\ANumber_Forms\z:}', "");;
    Expect(0, 8592, '\p{Blk=:\ANumber_Forms\z:}', "");;
    Expect(1, 8591, '\p{Blk=numberforms}', "");
    Expect(0, 8591, '\p{^Blk=numberforms}', "");
    Expect(0, 8591, '\P{Blk=numberforms}', "");
    Expect(1, 8591, '\P{^Blk=numberforms}', "");
    Expect(0, 8592, '\p{Blk=numberforms}', "");
    Expect(1, 8592, '\p{^Blk=numberforms}', "");
    Expect(1, 8592, '\P{Blk=numberforms}', "");
    Expect(0, 8592, '\P{^Blk=numberforms}', "");
    Expect(1, 8591, '\p{Blk=:\Anumberforms\z:}', "");;
    Expect(0, 8592, '\p{Blk=:\Anumberforms\z:}', "");;
    Expect(1, 8591, '\p{Blk= Number_Forms}', "");
    Expect(0, 8591, '\p{^Blk= Number_Forms}', "");
    Expect(0, 8591, '\P{Blk= Number_Forms}', "");
    Expect(1, 8591, '\P{^Blk= Number_Forms}', "");
    Expect(0, 8592, '\p{Blk= Number_Forms}', "");
    Expect(1, 8592, '\p{^Blk= Number_Forms}', "");
    Expect(1, 8592, '\P{Blk= Number_Forms}', "");
    Expect(0, 8592, '\P{^Blk= Number_Forms}', "");
    Error('\p{Is_Block=	 number_forms:=}');
    Error('\P{Is_Block=	 number_forms:=}');
    Expect(1, 8591, '\p{Is_Block=numberforms}', "");
    Expect(0, 8591, '\p{^Is_Block=numberforms}', "");
    Expect(0, 8591, '\P{Is_Block=numberforms}', "");
    Expect(1, 8591, '\P{^Is_Block=numberforms}', "");
    Expect(0, 8592, '\p{Is_Block=numberforms}', "");
    Expect(1, 8592, '\p{^Is_Block=numberforms}', "");
    Expect(1, 8592, '\P{Is_Block=numberforms}', "");
    Expect(0, 8592, '\P{^Is_Block=numberforms}', "");
    Expect(1, 8591, '\p{Is_Block=-_NUMBER_Forms}', "");
    Expect(0, 8591, '\p{^Is_Block=-_NUMBER_Forms}', "");
    Expect(0, 8591, '\P{Is_Block=-_NUMBER_Forms}', "");
    Expect(1, 8591, '\P{^Is_Block=-_NUMBER_Forms}', "");
    Expect(0, 8592, '\p{Is_Block=-_NUMBER_Forms}', "");
    Expect(1, 8592, '\p{^Is_Block=-_NUMBER_Forms}', "");
    Expect(1, 8592, '\P{Is_Block=-_NUMBER_Forms}', "");
    Expect(0, 8592, '\P{^Is_Block=-_NUMBER_Forms}', "");
    Error('\p{Is_Blk=/a/ NUMBER_Forms}');
    Error('\P{Is_Blk=/a/ NUMBER_Forms}');
    Expect(1, 8591, '\p{Is_Blk=numberforms}', "");
    Expect(0, 8591, '\p{^Is_Blk=numberforms}', "");
    Expect(0, 8591, '\P{Is_Blk=numberforms}', "");
    Expect(1, 8591, '\P{^Is_Blk=numberforms}', "");
    Expect(0, 8592, '\p{Is_Blk=numberforms}', "");
    Expect(1, 8592, '\p{^Is_Blk=numberforms}', "");
    Expect(1, 8592, '\P{Is_Blk=numberforms}', "");
    Expect(0, 8592, '\P{^Is_Blk=numberforms}', "");
    Expect(1, 8591, '\p{Is_Blk=_Number_FORMS}', "");
    Expect(0, 8591, '\p{^Is_Blk=_Number_FORMS}', "");
    Expect(0, 8591, '\P{Is_Blk=_Number_FORMS}', "");
    Expect(1, 8591, '\P{^Is_Blk=_Number_FORMS}', "");
    Expect(0, 8592, '\p{Is_Blk=_Number_FORMS}', "");
    Expect(1, 8592, '\p{^Is_Blk=_Number_FORMS}', "");
    Expect(1, 8592, '\P{Is_Blk=_Number_FORMS}', "");
    Expect(0, 8592, '\P{^Is_Blk=_Number_FORMS}', "");
    Error('\p{Block=:= _Nushu}');
    Error('\P{Block=:= _Nushu}');
    Expect(1, 111359, '\p{Block=:\ANushu\z:}', "");;
    Expect(0, 111360, '\p{Block=:\ANushu\z:}', "");;
    Expect(1, 111359, '\p{Block=nushu}', "");
    Expect(0, 111359, '\p{^Block=nushu}', "");
    Expect(0, 111359, '\P{Block=nushu}', "");
    Expect(1, 111359, '\P{^Block=nushu}', "");
    Expect(0, 111360, '\p{Block=nushu}', "");
    Expect(1, 111360, '\p{^Block=nushu}', "");
    Expect(1, 111360, '\P{Block=nushu}', "");
    Expect(0, 111360, '\P{^Block=nushu}', "");
    Expect(1, 111359, '\p{Block=:\Anushu\z:}', "");;
    Expect(0, 111360, '\p{Block=:\Anushu\z:}', "");;
    Expect(1, 111359, '\p{Block: 	nushu}', "");
    Expect(0, 111359, '\p{^Block: 	nushu}', "");
    Expect(0, 111359, '\P{Block: 	nushu}', "");
    Expect(1, 111359, '\P{^Block: 	nushu}', "");
    Expect(0, 111360, '\p{Block: 	nushu}', "");
    Expect(1, 111360, '\p{^Block: 	nushu}', "");
    Expect(1, 111360, '\P{Block: 	nushu}', "");
    Expect(0, 111360, '\P{^Block: 	nushu}', "");
    Error('\p{Blk=/a/_ NUSHU}');
    Error('\P{Blk=/a/_ NUSHU}');
    Expect(1, 111359, '\p{Blk=:\ANushu\z:}', "");;
    Expect(0, 111360, '\p{Blk=:\ANushu\z:}', "");;
    Expect(1, 111359, '\p{Blk=nushu}', "");
    Expect(0, 111359, '\p{^Blk=nushu}', "");
    Expect(0, 111359, '\P{Blk=nushu}', "");
    Expect(1, 111359, '\P{^Blk=nushu}', "");
    Expect(0, 111360, '\p{Blk=nushu}', "");
    Expect(1, 111360, '\p{^Blk=nushu}', "");
    Expect(1, 111360, '\P{Blk=nushu}', "");
    Expect(0, 111360, '\P{^Blk=nushu}', "");
    Expect(1, 111359, '\p{Blk=:\Anushu\z:}', "");;
    Expect(0, 111360, '\p{Blk=:\Anushu\z:}', "");;
    Expect(1, 111359, '\p{Blk= -nushu}', "");
    Expect(0, 111359, '\p{^Blk= -nushu}', "");
    Expect(0, 111359, '\P{Blk= -nushu}', "");
    Expect(1, 111359, '\P{^Blk= -nushu}', "");
    Expect(0, 111360, '\p{Blk= -nushu}', "");
    Expect(1, 111360, '\p{^Blk= -nushu}', "");
    Expect(1, 111360, '\P{Blk= -nushu}', "");
    Expect(0, 111360, '\P{^Blk= -nushu}', "");
    Error('\p{Is_Block=--nushu/a/}');
    Error('\P{Is_Block=--nushu/a/}');
    Expect(1, 111359, '\p{Is_Block=nushu}', "");
    Expect(0, 111359, '\p{^Is_Block=nushu}', "");
    Expect(0, 111359, '\P{Is_Block=nushu}', "");
    Expect(1, 111359, '\P{^Is_Block=nushu}', "");
    Expect(0, 111360, '\p{Is_Block=nushu}', "");
    Expect(1, 111360, '\p{^Is_Block=nushu}', "");
    Expect(1, 111360, '\P{Is_Block=nushu}', "");
    Expect(0, 111360, '\P{^Is_Block=nushu}', "");
    Expect(1, 111359, '\p{Is_Block:   __nushu}', "");
    Expect(0, 111359, '\p{^Is_Block:   __nushu}', "");
    Expect(0, 111359, '\P{Is_Block:   __nushu}', "");
    Expect(1, 111359, '\P{^Is_Block:   __nushu}', "");
    Expect(0, 111360, '\p{Is_Block:   __nushu}', "");
    Expect(1, 111360, '\p{^Is_Block:   __nushu}', "");
    Expect(1, 111360, '\P{Is_Block:   __nushu}', "");
    Expect(0, 111360, '\P{^Is_Block:   __nushu}', "");
    Error('\p{Is_Blk=  Nushu/a/}');
    Error('\P{Is_Blk=  Nushu/a/}');
    Expect(1, 111359, '\p{Is_Blk=nushu}', "");
    Expect(0, 111359, '\p{^Is_Blk=nushu}', "");
    Expect(0, 111359, '\P{Is_Blk=nushu}', "");
    Expect(1, 111359, '\P{^Is_Blk=nushu}', "");
    Expect(0, 111360, '\p{Is_Blk=nushu}', "");
    Expect(1, 111360, '\p{^Is_Blk=nushu}', "");
    Expect(1, 111360, '\P{Is_Blk=nushu}', "");
    Expect(0, 111360, '\P{^Is_Blk=nushu}', "");
    Expect(1, 111359, '\p{Is_Blk:	__Nushu}', "");
    Expect(0, 111359, '\p{^Is_Blk:	__Nushu}', "");
    Expect(0, 111359, '\P{Is_Blk:	__Nushu}', "");
    Expect(1, 111359, '\P{^Is_Blk:	__Nushu}', "");
    Expect(0, 111360, '\p{Is_Blk:	__Nushu}', "");
    Expect(1, 111360, '\p{^Is_Blk:	__Nushu}', "");
    Expect(1, 111360, '\P{Is_Blk:	__Nushu}', "");
    Expect(0, 111360, '\P{^Is_Blk:	__Nushu}', "");
    Error('\p{Block=/a/__Nyiakeng_puachue_Hmong}');
    Error('\P{Block=/a/__Nyiakeng_puachue_Hmong}');
    Expect(1, 123215, '\p{Block=:\ANyiakeng_Puachue_Hmong\z:}', "");;
    Expect(0, 123216, '\p{Block=:\ANyiakeng_Puachue_Hmong\z:}', "");;
    Expect(1, 123215, '\p{Block=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^Block=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{Block=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^Block=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{Block=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^Block=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{Block=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^Block=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{Block=:\Anyiakengpuachuehmong\z:}', "");;
    Expect(0, 123216, '\p{Block=:\Anyiakengpuachuehmong\z:}', "");;
    Expect(1, 123215, '\p{Block: -Nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123215, '\p{^Block: -Nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123215, '\P{Block: -Nyiakeng_Puachue_Hmong}', "");
    Expect(1, 123215, '\P{^Block: -Nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123216, '\p{Block: -Nyiakeng_Puachue_Hmong}', "");
    Expect(1, 123216, '\p{^Block: -Nyiakeng_Puachue_Hmong}', "");
    Expect(1, 123216, '\P{Block: -Nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123216, '\P{^Block: -Nyiakeng_Puachue_Hmong}', "");
    Error('\p{Blk:		/a/NYIAKENG_Puachue_hmong}');
    Error('\P{Blk:		/a/NYIAKENG_Puachue_hmong}');
    Expect(1, 123215, '\p{Blk=:\ANyiakeng_Puachue_Hmong\z:}', "");;
    Expect(0, 123216, '\p{Blk=:\ANyiakeng_Puachue_Hmong\z:}', "");;
    Expect(1, 123215, '\p{Blk=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^Blk=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{Blk=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^Blk=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{Blk=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^Blk=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{Blk=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^Blk=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{Blk=:\Anyiakengpuachuehmong\z:}', "");;
    Expect(0, 123216, '\p{Blk=:\Anyiakengpuachuehmong\z:}', "");;
    Expect(1, 123215, '\p{Blk=  Nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123215, '\p{^Blk=  Nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123215, '\P{Blk=  Nyiakeng_Puachue_Hmong}', "");
    Expect(1, 123215, '\P{^Blk=  Nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123216, '\p{Blk=  Nyiakeng_Puachue_Hmong}', "");
    Expect(1, 123216, '\p{^Blk=  Nyiakeng_Puachue_Hmong}', "");
    Expect(1, 123216, '\P{Blk=  Nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123216, '\P{^Blk=  Nyiakeng_Puachue_Hmong}', "");
    Error('\p{Is_Block=/a/-NYIAKENG_PUACHUE_hmong}');
    Error('\P{Is_Block=/a/-NYIAKENG_PUACHUE_hmong}');
    Expect(1, 123215, '\p{Is_Block=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^Is_Block=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{Is_Block=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^Is_Block=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{Is_Block=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^Is_Block=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{Is_Block=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^Is_Block=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{Is_Block=	-Nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123215, '\p{^Is_Block=	-Nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123215, '\P{Is_Block=	-Nyiakeng_Puachue_Hmong}', "");
    Expect(1, 123215, '\P{^Is_Block=	-Nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123216, '\p{Is_Block=	-Nyiakeng_Puachue_Hmong}', "");
    Expect(1, 123216, '\p{^Is_Block=	-Nyiakeng_Puachue_Hmong}', "");
    Expect(1, 123216, '\P{Is_Block=	-Nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123216, '\P{^Is_Block=	-Nyiakeng_Puachue_Hmong}', "");
    Error('\p{Is_Blk=/a/Nyiakeng_Puachue_Hmong}');
    Error('\P{Is_Blk=/a/Nyiakeng_Puachue_Hmong}');
    Expect(1, 123215, '\p{Is_Blk=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^Is_Blk=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{Is_Blk=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^Is_Blk=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{Is_Blk=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^Is_Blk=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{Is_Blk=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^Is_Blk=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{Is_Blk=-nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123215, '\p{^Is_Blk=-nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123215, '\P{Is_Blk=-nyiakeng_Puachue_Hmong}', "");
    Expect(1, 123215, '\P{^Is_Blk=-nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123216, '\p{Is_Blk=-nyiakeng_Puachue_Hmong}', "");
    Expect(1, 123216, '\p{^Is_Blk=-nyiakeng_Puachue_Hmong}', "");
    Expect(1, 123216, '\P{Is_Blk=-nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123216, '\P{^Is_Blk=-nyiakeng_Puachue_Hmong}', "");
    Error('\p{Block=/a/_	optical_Character_Recognition}');
    Error('\P{Block=/a/_	optical_Character_Recognition}');
    Expect(1, 9311, '\p{Block=:\AOptical_Character_Recognition\z:}', "");;
    Expect(0, 9312, '\p{Block=:\AOptical_Character_Recognition\z:}', "");;
    Expect(1, 9311, '\p{Block=opticalcharacterrecognition}', "");
    Expect(0, 9311, '\p{^Block=opticalcharacterrecognition}', "");
    Expect(0, 9311, '\P{Block=opticalcharacterrecognition}', "");
    Expect(1, 9311, '\P{^Block=opticalcharacterrecognition}', "");
    Expect(0, 9312, '\p{Block=opticalcharacterrecognition}', "");
    Expect(1, 9312, '\p{^Block=opticalcharacterrecognition}', "");
    Expect(1, 9312, '\P{Block=opticalcharacterrecognition}', "");
    Expect(0, 9312, '\P{^Block=opticalcharacterrecognition}', "");
    Expect(1, 9311, '\p{Block=:\Aopticalcharacterrecognition\z:}', "");;
    Expect(0, 9312, '\p{Block=:\Aopticalcharacterrecognition\z:}', "");;
    Expect(1, 9311, '\p{Block:		_optical_character_recognition}', "");
    Expect(0, 9311, '\p{^Block:		_optical_character_recognition}', "");
    Expect(0, 9311, '\P{Block:		_optical_character_recognition}', "");
    Expect(1, 9311, '\P{^Block:		_optical_character_recognition}', "");
    Expect(0, 9312, '\p{Block:		_optical_character_recognition}', "");
    Expect(1, 9312, '\p{^Block:		_optical_character_recognition}', "");
    Expect(1, 9312, '\P{Block:		_optical_character_recognition}', "");
    Expect(0, 9312, '\P{^Block:		_optical_character_recognition}', "");
    Error('\p{Blk=-	OCR:=}');
    Error('\P{Blk=-	OCR:=}');
    Expect(1, 9311, '\p{Blk=:\AOCR\z:}', "");;
    Expect(0, 9312, '\p{Blk=:\AOCR\z:}', "");;
    Expect(1, 9311, '\p{Blk=ocr}', "");
    Expect(0, 9311, '\p{^Blk=ocr}', "");
    Expect(0, 9311, '\P{Blk=ocr}', "");
    Expect(1, 9311, '\P{^Blk=ocr}', "");
    Expect(0, 9312, '\p{Blk=ocr}', "");
    Expect(1, 9312, '\p{^Blk=ocr}', "");
    Expect(1, 9312, '\P{Blk=ocr}', "");
    Expect(0, 9312, '\P{^Blk=ocr}', "");
    Expect(1, 9311, '\p{Blk=:\Aocr\z:}', "");;
    Expect(0, 9312, '\p{Blk=:\Aocr\z:}', "");;
    Expect(1, 9311, '\p{Blk=_OCR}', "");
    Expect(0, 9311, '\p{^Blk=_OCR}', "");
    Expect(0, 9311, '\P{Blk=_OCR}', "");
    Expect(1, 9311, '\P{^Blk=_OCR}', "");
    Expect(0, 9312, '\p{Blk=_OCR}', "");
    Expect(1, 9312, '\p{^Blk=_OCR}', "");
    Expect(1, 9312, '\P{Blk=_OCR}', "");
    Expect(0, 9312, '\P{^Blk=_OCR}', "");
    Error('\p{Is_Block=-/a/optical_Character_Recognition}');
    Error('\P{Is_Block=-/a/optical_Character_Recognition}');
    Expect(1, 9311, '\p{Is_Block=opticalcharacterrecognition}', "");
    Expect(0, 9311, '\p{^Is_Block=opticalcharacterrecognition}', "");
    Expect(0, 9311, '\P{Is_Block=opticalcharacterrecognition}', "");
    Expect(1, 9311, '\P{^Is_Block=opticalcharacterrecognition}', "");
    Expect(0, 9312, '\p{Is_Block=opticalcharacterrecognition}', "");
    Expect(1, 9312, '\p{^Is_Block=opticalcharacterrecognition}', "");
    Expect(1, 9312, '\P{Is_Block=opticalcharacterrecognition}', "");
    Expect(0, 9312, '\P{^Is_Block=opticalcharacterrecognition}', "");
    Expect(1, 9311, '\p{Is_Block: -_Optical_character_Recognition}', "");
    Expect(0, 9311, '\p{^Is_Block: -_Optical_character_Recognition}', "");
    Expect(0, 9311, '\P{Is_Block: -_Optical_character_Recognition}', "");
    Expect(1, 9311, '\P{^Is_Block: -_Optical_character_Recognition}', "");
    Expect(0, 9312, '\p{Is_Block: -_Optical_character_Recognition}', "");
    Expect(1, 9312, '\p{^Is_Block: -_Optical_character_Recognition}', "");
    Expect(1, 9312, '\P{Is_Block: -_Optical_character_Recognition}', "");
    Expect(0, 9312, '\P{^Is_Block: -_Optical_character_Recognition}', "");
    Error('\p{Is_Blk=:= OCR}');
    Error('\P{Is_Blk=:= OCR}');
    Expect(1, 9311, '\p{Is_Blk=ocr}', "");
    Expect(0, 9311, '\p{^Is_Blk=ocr}', "");
    Expect(0, 9311, '\P{Is_Blk=ocr}', "");
    Expect(1, 9311, '\P{^Is_Blk=ocr}', "");
    Expect(0, 9312, '\p{Is_Blk=ocr}', "");
    Expect(1, 9312, '\p{^Is_Blk=ocr}', "");
    Expect(1, 9312, '\P{Is_Blk=ocr}', "");
    Expect(0, 9312, '\P{^Is_Blk=ocr}', "");
    Expect(1, 9311, '\p{Is_Blk=-OCR}', "");
    Expect(0, 9311, '\p{^Is_Blk=-OCR}', "");
    Expect(0, 9311, '\P{Is_Blk=-OCR}', "");
    Expect(1, 9311, '\P{^Is_Blk=-OCR}', "");
    Expect(0, 9312, '\p{Is_Blk=-OCR}', "");
    Expect(1, 9312, '\p{^Is_Blk=-OCR}', "");
    Expect(1, 9312, '\P{Is_Blk=-OCR}', "");
    Expect(0, 9312, '\P{^Is_Blk=-OCR}', "");
    Error('\p{Block: _/a/OGHAM}');
    Error('\P{Block: _/a/OGHAM}');
    Expect(1, 5791, '\p{Block=:\AOgham\z:}', "");;
    Expect(0, 5792, '\p{Block=:\AOgham\z:}', "");;
    Expect(1, 5791, '\p{Block=ogham}', "");
    Expect(0, 5791, '\p{^Block=ogham}', "");
    Expect(0, 5791, '\P{Block=ogham}', "");
    Expect(1, 5791, '\P{^Block=ogham}', "");
    Expect(0, 5792, '\p{Block=ogham}', "");
    Expect(1, 5792, '\p{^Block=ogham}', "");
    Expect(1, 5792, '\P{Block=ogham}', "");
    Expect(0, 5792, '\P{^Block=ogham}', "");
    Expect(1, 5791, '\p{Block=:\Aogham\z:}', "");;
    Expect(0, 5792, '\p{Block=:\Aogham\z:}', "");;
    Expect(1, 5791, '\p{Block= _Ogham}', "");
    Expect(0, 5791, '\p{^Block= _Ogham}', "");
    Expect(0, 5791, '\P{Block= _Ogham}', "");
    Expect(1, 5791, '\P{^Block= _Ogham}', "");
    Expect(0, 5792, '\p{Block= _Ogham}', "");
    Expect(1, 5792, '\p{^Block= _Ogham}', "");
    Expect(1, 5792, '\P{Block= _Ogham}', "");
    Expect(0, 5792, '\P{^Block= _Ogham}', "");
    Error('\p{Blk= /a/ogham}');
    Error('\P{Blk= /a/ogham}');
    Expect(1, 5791, '\p{Blk=:\AOgham\z:}', "");;
    Expect(0, 5792, '\p{Blk=:\AOgham\z:}', "");;
    Expect(1, 5791, '\p{Blk=ogham}', "");
    Expect(0, 5791, '\p{^Blk=ogham}', "");
    Expect(0, 5791, '\P{Blk=ogham}', "");
    Expect(1, 5791, '\P{^Blk=ogham}', "");
    Expect(0, 5792, '\p{Blk=ogham}', "");
    Expect(1, 5792, '\p{^Blk=ogham}', "");
    Expect(1, 5792, '\P{Blk=ogham}', "");
    Expect(0, 5792, '\P{^Blk=ogham}', "");
    Expect(1, 5791, '\p{Blk=:\Aogham\z:}', "");;
    Expect(0, 5792, '\p{Blk=:\Aogham\z:}', "");;
    Expect(1, 5791, '\p{Blk=_Ogham}', "");
    Expect(0, 5791, '\p{^Blk=_Ogham}', "");
    Expect(0, 5791, '\P{Blk=_Ogham}', "");
    Expect(1, 5791, '\P{^Blk=_Ogham}', "");
    Expect(0, 5792, '\p{Blk=_Ogham}', "");
    Expect(1, 5792, '\p{^Blk=_Ogham}', "");
    Expect(1, 5792, '\P{Blk=_Ogham}', "");
    Expect(0, 5792, '\P{^Blk=_Ogham}', "");
    Error('\p{Is_Block=/a/Ogham}');
    Error('\P{Is_Block=/a/Ogham}');
    Expect(1, 5791, '\p{Is_Block=ogham}', "");
    Expect(0, 5791, '\p{^Is_Block=ogham}', "");
    Expect(0, 5791, '\P{Is_Block=ogham}', "");
    Expect(1, 5791, '\P{^Is_Block=ogham}', "");
    Expect(0, 5792, '\p{Is_Block=ogham}', "");
    Expect(1, 5792, '\p{^Is_Block=ogham}', "");
    Expect(1, 5792, '\P{Is_Block=ogham}', "");
    Expect(0, 5792, '\P{^Is_Block=ogham}', "");
    Expect(1, 5791, '\p{Is_Block=		OGHAM}', "");
    Expect(0, 5791, '\p{^Is_Block=		OGHAM}', "");
    Expect(0, 5791, '\P{Is_Block=		OGHAM}', "");
    Expect(1, 5791, '\P{^Is_Block=		OGHAM}', "");
    Expect(0, 5792, '\p{Is_Block=		OGHAM}', "");
    Expect(1, 5792, '\p{^Is_Block=		OGHAM}', "");
    Expect(1, 5792, '\P{Is_Block=		OGHAM}', "");
    Expect(0, 5792, '\P{^Is_Block=		OGHAM}', "");
    Error('\p{Is_Blk=:=	Ogham}');
    Error('\P{Is_Blk=:=	Ogham}');
    Expect(1, 5791, '\p{Is_Blk=ogham}', "");
    Expect(0, 5791, '\p{^Is_Blk=ogham}', "");
    Expect(0, 5791, '\P{Is_Blk=ogham}', "");
    Expect(1, 5791, '\P{^Is_Blk=ogham}', "");
    Expect(0, 5792, '\p{Is_Blk=ogham}', "");
    Expect(1, 5792, '\p{^Is_Blk=ogham}', "");
    Expect(1, 5792, '\P{Is_Blk=ogham}', "");
    Expect(0, 5792, '\P{^Is_Blk=ogham}', "");
    Expect(1, 5791, '\p{Is_Blk=_	Ogham}', "");
    Expect(0, 5791, '\p{^Is_Blk=_	Ogham}', "");
    Expect(0, 5791, '\P{Is_Blk=_	Ogham}', "");
    Expect(1, 5791, '\P{^Is_Blk=_	Ogham}', "");
    Expect(0, 5792, '\p{Is_Blk=_	Ogham}', "");
    Expect(1, 5792, '\p{^Is_Blk=_	Ogham}', "");
    Expect(1, 5792, '\P{Is_Blk=_	Ogham}', "");
    Expect(0, 5792, '\P{^Is_Blk=_	Ogham}', "");
    Error('\p{Block=/a/-Ol_chiki}');
    Error('\P{Block=/a/-Ol_chiki}');
    Expect(1, 7295, '\p{Block=:\AOl_Chiki\z:}', "");;
    Expect(0, 7296, '\p{Block=:\AOl_Chiki\z:}', "");;
    Expect(1, 7295, '\p{Block=olchiki}', "");
    Expect(0, 7295, '\p{^Block=olchiki}', "");
    Expect(0, 7295, '\P{Block=olchiki}', "");
    Expect(1, 7295, '\P{^Block=olchiki}', "");
    Expect(0, 7296, '\p{Block=olchiki}', "");
    Expect(1, 7296, '\p{^Block=olchiki}', "");
    Expect(1, 7296, '\P{Block=olchiki}', "");
    Expect(0, 7296, '\P{^Block=olchiki}', "");
    Expect(1, 7295, '\p{Block=:\Aolchiki\z:}', "");;
    Expect(0, 7296, '\p{Block=:\Aolchiki\z:}', "");;
    Expect(1, 7295, '\p{Block=_ Ol_chiki}', "");
    Expect(0, 7295, '\p{^Block=_ Ol_chiki}', "");
    Expect(0, 7295, '\P{Block=_ Ol_chiki}', "");
    Expect(1, 7295, '\P{^Block=_ Ol_chiki}', "");
    Expect(0, 7296, '\p{Block=_ Ol_chiki}', "");
    Expect(1, 7296, '\p{^Block=_ Ol_chiki}', "");
    Expect(1, 7296, '\P{Block=_ Ol_chiki}', "");
    Expect(0, 7296, '\P{^Block=_ Ol_chiki}', "");
    Error('\p{Blk=-ol_Chiki/a/}');
    Error('\P{Blk=-ol_Chiki/a/}');
    Expect(1, 7295, '\p{Blk=:\AOl_Chiki\z:}', "");;
    Expect(0, 7296, '\p{Blk=:\AOl_Chiki\z:}', "");;
    Expect(1, 7295, '\p{Blk=olchiki}', "");
    Expect(0, 7295, '\p{^Blk=olchiki}', "");
    Expect(0, 7295, '\P{Blk=olchiki}', "");
    Expect(1, 7295, '\P{^Blk=olchiki}', "");
    Expect(0, 7296, '\p{Blk=olchiki}', "");
    Expect(1, 7296, '\p{^Blk=olchiki}', "");
    Expect(1, 7296, '\P{Blk=olchiki}', "");
    Expect(0, 7296, '\P{^Blk=olchiki}', "");
    Expect(1, 7295, '\p{Blk=:\Aolchiki\z:}', "");;
    Expect(0, 7296, '\p{Blk=:\Aolchiki\z:}', "");;
    Expect(1, 7295, '\p{Blk=_ Ol_Chiki}', "");
    Expect(0, 7295, '\p{^Blk=_ Ol_Chiki}', "");
    Expect(0, 7295, '\P{Blk=_ Ol_Chiki}', "");
    Expect(1, 7295, '\P{^Blk=_ Ol_Chiki}', "");
    Expect(0, 7296, '\p{Blk=_ Ol_Chiki}', "");
    Expect(1, 7296, '\p{^Blk=_ Ol_Chiki}', "");
    Expect(1, 7296, '\P{Blk=_ Ol_Chiki}', "");
    Expect(0, 7296, '\P{^Blk=_ Ol_Chiki}', "");
    Error('\p{Is_Block=/a/	ol_CHIKI}');
    Error('\P{Is_Block=/a/	ol_CHIKI}');
    Expect(1, 7295, '\p{Is_Block=olchiki}', "");
    Expect(0, 7295, '\p{^Is_Block=olchiki}', "");
    Expect(0, 7295, '\P{Is_Block=olchiki}', "");
    Expect(1, 7295, '\P{^Is_Block=olchiki}', "");
    Expect(0, 7296, '\p{Is_Block=olchiki}', "");
    Expect(1, 7296, '\p{^Is_Block=olchiki}', "");
    Expect(1, 7296, '\P{Is_Block=olchiki}', "");
    Expect(0, 7296, '\P{^Is_Block=olchiki}', "");
    Expect(1, 7295, '\p{Is_Block=  Ol_CHIKI}', "");
    Expect(0, 7295, '\p{^Is_Block=  Ol_CHIKI}', "");
    Expect(0, 7295, '\P{Is_Block=  Ol_CHIKI}', "");
    Expect(1, 7295, '\P{^Is_Block=  Ol_CHIKI}', "");
    Expect(0, 7296, '\p{Is_Block=  Ol_CHIKI}', "");
    Expect(1, 7296, '\p{^Is_Block=  Ol_CHIKI}', "");
    Expect(1, 7296, '\P{Is_Block=  Ol_CHIKI}', "");
    Expect(0, 7296, '\P{^Is_Block=  Ol_CHIKI}', "");
    Error('\p{Is_Blk=:=	_ol_CHIKI}');
    Error('\P{Is_Blk=:=	_ol_CHIKI}');
    Expect(1, 7295, '\p{Is_Blk=olchiki}', "");
    Expect(0, 7295, '\p{^Is_Blk=olchiki}', "");
    Expect(0, 7295, '\P{Is_Blk=olchiki}', "");
    Expect(1, 7295, '\P{^Is_Blk=olchiki}', "");
    Expect(0, 7296, '\p{Is_Blk=olchiki}', "");
    Expect(1, 7296, '\p{^Is_Blk=olchiki}', "");
    Expect(1, 7296, '\P{Is_Blk=olchiki}', "");
    Expect(0, 7296, '\P{^Is_Blk=olchiki}', "");
    Expect(1, 7295, '\p{Is_Blk=	 ol_CHIKI}', "");
    Expect(0, 7295, '\p{^Is_Blk=	 ol_CHIKI}', "");
    Expect(0, 7295, '\P{Is_Blk=	 ol_CHIKI}', "");
    Expect(1, 7295, '\P{^Is_Blk=	 ol_CHIKI}', "");
    Expect(0, 7296, '\p{Is_Blk=	 ol_CHIKI}', "");
    Expect(1, 7296, '\p{^Is_Blk=	 ol_CHIKI}', "");
    Expect(1, 7296, '\P{Is_Blk=	 ol_CHIKI}', "");
    Expect(0, 7296, '\P{^Is_Blk=	 ol_CHIKI}', "");
    Error('\p{Block=/a/ Old_Hungarian}');
    Error('\P{Block=/a/ Old_Hungarian}');
    Expect(1, 68863, '\p{Block=:\AOld_Hungarian\z:}', "");;
    Expect(0, 68864, '\p{Block=:\AOld_Hungarian\z:}', "");;
    Expect(1, 68863, '\p{Block=oldhungarian}', "");
    Expect(0, 68863, '\p{^Block=oldhungarian}', "");
    Expect(0, 68863, '\P{Block=oldhungarian}', "");
    Expect(1, 68863, '\P{^Block=oldhungarian}', "");
    Expect(0, 68864, '\p{Block=oldhungarian}', "");
    Expect(1, 68864, '\p{^Block=oldhungarian}', "");
    Expect(1, 68864, '\P{Block=oldhungarian}', "");
    Expect(0, 68864, '\P{^Block=oldhungarian}', "");
    Expect(1, 68863, '\p{Block=:\Aoldhungarian\z:}', "");;
    Expect(0, 68864, '\p{Block=:\Aoldhungarian\z:}', "");;
    Expect(1, 68863, '\p{Block= _old_hungarian}', "");
    Expect(0, 68863, '\p{^Block= _old_hungarian}', "");
    Expect(0, 68863, '\P{Block= _old_hungarian}', "");
    Expect(1, 68863, '\P{^Block= _old_hungarian}', "");
    Expect(0, 68864, '\p{Block= _old_hungarian}', "");
    Expect(1, 68864, '\p{^Block= _old_hungarian}', "");
    Expect(1, 68864, '\P{Block= _old_hungarian}', "");
    Expect(0, 68864, '\P{^Block= _old_hungarian}', "");
    Error('\p{Blk=_ Old_Hungarian/a/}');
    Error('\P{Blk=_ Old_Hungarian/a/}');
    Expect(1, 68863, '\p{Blk=:\AOld_Hungarian\z:}', "");;
    Expect(0, 68864, '\p{Blk=:\AOld_Hungarian\z:}', "");;
    Expect(1, 68863, '\p{Blk=oldhungarian}', "");
    Expect(0, 68863, '\p{^Blk=oldhungarian}', "");
    Expect(0, 68863, '\P{Blk=oldhungarian}', "");
    Expect(1, 68863, '\P{^Blk=oldhungarian}', "");
    Expect(0, 68864, '\p{Blk=oldhungarian}', "");
    Expect(1, 68864, '\p{^Blk=oldhungarian}', "");
    Expect(1, 68864, '\P{Blk=oldhungarian}', "");
    Expect(0, 68864, '\P{^Blk=oldhungarian}', "");
    Expect(1, 68863, '\p{Blk=:\Aoldhungarian\z:}', "");;
    Expect(0, 68864, '\p{Blk=:\Aoldhungarian\z:}', "");;
    Expect(1, 68863, '\p{Blk= _Old_Hungarian}', "");
    Expect(0, 68863, '\p{^Blk= _Old_Hungarian}', "");
    Expect(0, 68863, '\P{Blk= _Old_Hungarian}', "");
    Expect(1, 68863, '\P{^Blk= _Old_Hungarian}', "");
    Expect(0, 68864, '\p{Blk= _Old_Hungarian}', "");
    Expect(1, 68864, '\p{^Blk= _Old_Hungarian}', "");
    Expect(1, 68864, '\P{Blk= _Old_Hungarian}', "");
    Expect(0, 68864, '\P{^Blk= _Old_Hungarian}', "");
    Error('\p{Is_Block= _Old_HUNGARIAN:=}');
    Error('\P{Is_Block= _Old_HUNGARIAN:=}');
    Expect(1, 68863, '\p{Is_Block=oldhungarian}', "");
    Expect(0, 68863, '\p{^Is_Block=oldhungarian}', "");
    Expect(0, 68863, '\P{Is_Block=oldhungarian}', "");
    Expect(1, 68863, '\P{^Is_Block=oldhungarian}', "");
    Expect(0, 68864, '\p{Is_Block=oldhungarian}', "");
    Expect(1, 68864, '\p{^Is_Block=oldhungarian}', "");
    Expect(1, 68864, '\P{Is_Block=oldhungarian}', "");
    Expect(0, 68864, '\P{^Is_Block=oldhungarian}', "");
    Expect(1, 68863, '\p{Is_Block=_-old_hungarian}', "");
    Expect(0, 68863, '\p{^Is_Block=_-old_hungarian}', "");
    Expect(0, 68863, '\P{Is_Block=_-old_hungarian}', "");
    Expect(1, 68863, '\P{^Is_Block=_-old_hungarian}', "");
    Expect(0, 68864, '\p{Is_Block=_-old_hungarian}', "");
    Expect(1, 68864, '\p{^Is_Block=_-old_hungarian}', "");
    Expect(1, 68864, '\P{Is_Block=_-old_hungarian}', "");
    Expect(0, 68864, '\P{^Is_Block=_-old_hungarian}', "");
    Error('\p{Is_Blk=	-Old_hungarian/a/}');
    Error('\P{Is_Blk=	-Old_hungarian/a/}');
    Expect(1, 68863, '\p{Is_Blk=oldhungarian}', "");
    Expect(0, 68863, '\p{^Is_Blk=oldhungarian}', "");
    Expect(0, 68863, '\P{Is_Blk=oldhungarian}', "");
    Expect(1, 68863, '\P{^Is_Blk=oldhungarian}', "");
    Expect(0, 68864, '\p{Is_Blk=oldhungarian}', "");
    Expect(1, 68864, '\p{^Is_Blk=oldhungarian}', "");
    Expect(1, 68864, '\P{Is_Blk=oldhungarian}', "");
    Expect(0, 68864, '\P{^Is_Blk=oldhungarian}', "");
    Expect(1, 68863, '\p{Is_Blk=_ Old_Hungarian}', "");
    Expect(0, 68863, '\p{^Is_Blk=_ Old_Hungarian}', "");
    Expect(0, 68863, '\P{Is_Blk=_ Old_Hungarian}', "");
    Expect(1, 68863, '\P{^Is_Blk=_ Old_Hungarian}', "");
    Expect(0, 68864, '\p{Is_Blk=_ Old_Hungarian}', "");
    Expect(1, 68864, '\p{^Is_Blk=_ Old_Hungarian}', "");
    Expect(1, 68864, '\P{Is_Blk=_ Old_Hungarian}', "");
    Expect(0, 68864, '\P{^Is_Blk=_ Old_Hungarian}', "");
    Error('\p{Block=:=	Old_Italic}');
    Error('\P{Block=:=	Old_Italic}');
    Expect(1, 66351, '\p{Block=:\AOld_Italic\z:}', "");;
    Expect(0, 66352, '\p{Block=:\AOld_Italic\z:}', "");;
    Expect(1, 66351, '\p{Block=olditalic}', "");
    Expect(0, 66351, '\p{^Block=olditalic}', "");
    Expect(0, 66351, '\P{Block=olditalic}', "");
    Expect(1, 66351, '\P{^Block=olditalic}', "");
    Expect(0, 66352, '\p{Block=olditalic}', "");
    Expect(1, 66352, '\p{^Block=olditalic}', "");
    Expect(1, 66352, '\P{Block=olditalic}', "");
    Expect(0, 66352, '\P{^Block=olditalic}', "");
    Expect(1, 66351, '\p{Block=:\Aolditalic\z:}', "");;
    Expect(0, 66352, '\p{Block=:\Aolditalic\z:}', "");;
    Expect(1, 66351, '\p{Block= Old_ITALIC}', "");
    Expect(0, 66351, '\p{^Block= Old_ITALIC}', "");
    Expect(0, 66351, '\P{Block= Old_ITALIC}', "");
    Expect(1, 66351, '\P{^Block= Old_ITALIC}', "");
    Expect(0, 66352, '\p{Block= Old_ITALIC}', "");
    Expect(1, 66352, '\p{^Block= Old_ITALIC}', "");
    Expect(1, 66352, '\P{Block= Old_ITALIC}', "");
    Expect(0, 66352, '\P{^Block= Old_ITALIC}', "");
    Error('\p{Blk:   _Old_Italic/a/}');
    Error('\P{Blk:   _Old_Italic/a/}');
    Expect(1, 66351, '\p{Blk=:\AOld_Italic\z:}', "");;
    Expect(0, 66352, '\p{Blk=:\AOld_Italic\z:}', "");;
    Expect(1, 66351, '\p{Blk=olditalic}', "");
    Expect(0, 66351, '\p{^Blk=olditalic}', "");
    Expect(0, 66351, '\P{Blk=olditalic}', "");
    Expect(1, 66351, '\P{^Blk=olditalic}', "");
    Expect(0, 66352, '\p{Blk=olditalic}', "");
    Expect(1, 66352, '\p{^Blk=olditalic}', "");
    Expect(1, 66352, '\P{Blk=olditalic}', "");
    Expect(0, 66352, '\P{^Blk=olditalic}', "");
    Expect(1, 66351, '\p{Blk=:\Aolditalic\z:}', "");;
    Expect(0, 66352, '\p{Blk=:\Aolditalic\z:}', "");;
    Expect(1, 66351, '\p{Blk=		old_italic}', "");
    Expect(0, 66351, '\p{^Blk=		old_italic}', "");
    Expect(0, 66351, '\P{Blk=		old_italic}', "");
    Expect(1, 66351, '\P{^Blk=		old_italic}', "");
    Expect(0, 66352, '\p{Blk=		old_italic}', "");
    Expect(1, 66352, '\p{^Blk=		old_italic}', "");
    Expect(1, 66352, '\P{Blk=		old_italic}', "");
    Expect(0, 66352, '\P{^Blk=		old_italic}', "");
    Error('\p{Is_Block=:=--old_Italic}');
    Error('\P{Is_Block=:=--old_Italic}');
    Expect(1, 66351, '\p{Is_Block=olditalic}', "");
    Expect(0, 66351, '\p{^Is_Block=olditalic}', "");
    Expect(0, 66351, '\P{Is_Block=olditalic}', "");
    Expect(1, 66351, '\P{^Is_Block=olditalic}', "");
    Expect(0, 66352, '\p{Is_Block=olditalic}', "");
    Expect(1, 66352, '\p{^Is_Block=olditalic}', "");
    Expect(1, 66352, '\P{Is_Block=olditalic}', "");
    Expect(0, 66352, '\P{^Is_Block=olditalic}', "");
    Expect(1, 66351, '\p{Is_Block=-	old_ITALIC}', "");
    Expect(0, 66351, '\p{^Is_Block=-	old_ITALIC}', "");
    Expect(0, 66351, '\P{Is_Block=-	old_ITALIC}', "");
    Expect(1, 66351, '\P{^Is_Block=-	old_ITALIC}', "");
    Expect(0, 66352, '\p{Is_Block=-	old_ITALIC}', "");
    Expect(1, 66352, '\p{^Is_Block=-	old_ITALIC}', "");
    Expect(1, 66352, '\P{Is_Block=-	old_ITALIC}', "");
    Expect(0, 66352, '\P{^Is_Block=-	old_ITALIC}', "");
    Error('\p{Is_Blk=	Old_Italic:=}');
    Error('\P{Is_Blk=	Old_Italic:=}');
    Expect(1, 66351, '\p{Is_Blk=olditalic}', "");
    Expect(0, 66351, '\p{^Is_Blk=olditalic}', "");
    Expect(0, 66351, '\P{Is_Blk=olditalic}', "");
    Expect(1, 66351, '\P{^Is_Blk=olditalic}', "");
    Expect(0, 66352, '\p{Is_Blk=olditalic}', "");
    Expect(1, 66352, '\p{^Is_Blk=olditalic}', "");
    Expect(1, 66352, '\P{Is_Blk=olditalic}', "");
    Expect(0, 66352, '\P{^Is_Blk=olditalic}', "");
    Expect(1, 66351, '\p{Is_Blk=__Old_Italic}', "");
    Expect(0, 66351, '\p{^Is_Blk=__Old_Italic}', "");
    Expect(0, 66351, '\P{Is_Blk=__Old_Italic}', "");
    Expect(1, 66351, '\P{^Is_Blk=__Old_Italic}', "");
    Expect(0, 66352, '\p{Is_Blk=__Old_Italic}', "");
    Expect(1, 66352, '\p{^Is_Blk=__Old_Italic}', "");
    Expect(1, 66352, '\P{Is_Blk=__Old_Italic}', "");
    Expect(0, 66352, '\P{^Is_Blk=__Old_Italic}', "");
    Error('\p{Block=	Old_North_ARABIAN/a/}');
    Error('\P{Block=	Old_North_ARABIAN/a/}');
    Expect(1, 68255, '\p{Block=:\AOld_North_Arabian\z:}', "");;
    Expect(0, 68256, '\p{Block=:\AOld_North_Arabian\z:}', "");;
    Expect(1, 68255, '\p{Block=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Block=oldnortharabian}', "");
    Expect(0, 68255, '\P{Block=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Block=oldnortharabian}', "");
    Expect(0, 68256, '\p{Block=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Block=oldnortharabian}', "");
    Expect(1, 68256, '\P{Block=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Block=oldnortharabian}', "");
    Expect(1, 68255, '\p{Block=:\Aoldnortharabian\z:}', "");;
    Expect(0, 68256, '\p{Block=:\Aoldnortharabian\z:}', "");;
    Expect(1, 68255, '\p{Block= Old_north_Arabian}', "");
    Expect(0, 68255, '\p{^Block= Old_north_Arabian}', "");
    Expect(0, 68255, '\P{Block= Old_north_Arabian}', "");
    Expect(1, 68255, '\P{^Block= Old_north_Arabian}', "");
    Expect(0, 68256, '\p{Block= Old_north_Arabian}', "");
    Expect(1, 68256, '\p{^Block= Old_north_Arabian}', "");
    Expect(1, 68256, '\P{Block= Old_north_Arabian}', "");
    Expect(0, 68256, '\P{^Block= Old_north_Arabian}', "");
    Error('\p{Blk=	:=Old_north_Arabian}');
    Error('\P{Blk=	:=Old_north_Arabian}');
    Expect(1, 68255, '\p{Blk=:\AOld_North_Arabian\z:}', "");;
    Expect(0, 68256, '\p{Blk=:\AOld_North_Arabian\z:}', "");;
    Expect(1, 68255, '\p{Blk=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Blk=oldnortharabian}', "");
    Expect(0, 68255, '\P{Blk=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Blk=oldnortharabian}', "");
    Expect(0, 68256, '\p{Blk=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Blk=oldnortharabian}', "");
    Expect(1, 68256, '\P{Blk=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Blk=oldnortharabian}', "");
    Expect(1, 68255, '\p{Blk=:\Aoldnortharabian\z:}', "");;
    Expect(0, 68256, '\p{Blk=:\Aoldnortharabian\z:}', "");;
    Expect(1, 68255, '\p{Blk:	 Old_NORTH_Arabian}', "");
    Expect(0, 68255, '\p{^Blk:	 Old_NORTH_Arabian}', "");
    Expect(0, 68255, '\P{Blk:	 Old_NORTH_Arabian}', "");
    Expect(1, 68255, '\P{^Blk:	 Old_NORTH_Arabian}', "");
    Expect(0, 68256, '\p{Blk:	 Old_NORTH_Arabian}', "");
    Expect(1, 68256, '\p{^Blk:	 Old_NORTH_Arabian}', "");
    Expect(1, 68256, '\P{Blk:	 Old_NORTH_Arabian}', "");
    Expect(0, 68256, '\P{^Blk:	 Old_NORTH_Arabian}', "");
    Error('\p{Is_Block=/a/	-old_NORTH_arabian}');
    Error('\P{Is_Block=/a/	-old_NORTH_arabian}');
    Expect(1, 68255, '\p{Is_Block=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Is_Block=oldnortharabian}', "");
    Expect(0, 68255, '\P{Is_Block=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Is_Block=oldnortharabian}', "");
    Expect(0, 68256, '\p{Is_Block=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Is_Block=oldnortharabian}', "");
    Expect(1, 68256, '\P{Is_Block=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Is_Block=oldnortharabian}', "");
    Expect(1, 68255, '\p{Is_Block=- OLD_NORTH_Arabian}', "");
    Expect(0, 68255, '\p{^Is_Block=- OLD_NORTH_Arabian}', "");
    Expect(0, 68255, '\P{Is_Block=- OLD_NORTH_Arabian}', "");
    Expect(1, 68255, '\P{^Is_Block=- OLD_NORTH_Arabian}', "");
    Expect(0, 68256, '\p{Is_Block=- OLD_NORTH_Arabian}', "");
    Expect(1, 68256, '\p{^Is_Block=- OLD_NORTH_Arabian}', "");
    Expect(1, 68256, '\P{Is_Block=- OLD_NORTH_Arabian}', "");
    Expect(0, 68256, '\P{^Is_Block=- OLD_NORTH_Arabian}', "");
    Error('\p{Is_Blk=_-old_north_Arabian:=}');
    Error('\P{Is_Blk=_-old_north_Arabian:=}');
    Expect(1, 68255, '\p{Is_Blk=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Is_Blk=oldnortharabian}', "");
    Expect(0, 68255, '\P{Is_Blk=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Is_Blk=oldnortharabian}', "");
    Expect(0, 68256, '\p{Is_Blk=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Is_Blk=oldnortharabian}', "");
    Expect(1, 68256, '\P{Is_Blk=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Is_Blk=oldnortharabian}', "");
    Expect(1, 68255, '\p{Is_Blk=	Old_North_Arabian}', "");
    Expect(0, 68255, '\p{^Is_Blk=	Old_North_Arabian}', "");
    Expect(0, 68255, '\P{Is_Blk=	Old_North_Arabian}', "");
    Expect(1, 68255, '\P{^Is_Blk=	Old_North_Arabian}', "");
    Expect(0, 68256, '\p{Is_Blk=	Old_North_Arabian}', "");
    Expect(1, 68256, '\p{^Is_Blk=	Old_North_Arabian}', "");
    Expect(1, 68256, '\P{Is_Blk=	Old_North_Arabian}', "");
    Expect(0, 68256, '\P{^Is_Blk=	Old_North_Arabian}', "");
    Error('\p{Block=/a/-old_PERMIC}');
    Error('\P{Block=/a/-old_PERMIC}');
    Expect(1, 66431, '\p{Block=:\AOld_Permic\z:}', "");;
    Expect(0, 66432, '\p{Block=:\AOld_Permic\z:}', "");;
    Expect(1, 66431, '\p{Block=oldpermic}', "");
    Expect(0, 66431, '\p{^Block=oldpermic}', "");
    Expect(0, 66431, '\P{Block=oldpermic}', "");
    Expect(1, 66431, '\P{^Block=oldpermic}', "");
    Expect(0, 66432, '\p{Block=oldpermic}', "");
    Expect(1, 66432, '\p{^Block=oldpermic}', "");
    Expect(1, 66432, '\P{Block=oldpermic}', "");
    Expect(0, 66432, '\P{^Block=oldpermic}', "");
    Expect(1, 66431, '\p{Block=:\Aoldpermic\z:}', "");;
    Expect(0, 66432, '\p{Block=:\Aoldpermic\z:}', "");;
    Expect(1, 66431, '\p{Block= -old_permic}', "");
    Expect(0, 66431, '\p{^Block= -old_permic}', "");
    Expect(0, 66431, '\P{Block= -old_permic}', "");
    Expect(1, 66431, '\P{^Block= -old_permic}', "");
    Expect(0, 66432, '\p{Block= -old_permic}', "");
    Expect(1, 66432, '\p{^Block= -old_permic}', "");
    Expect(1, 66432, '\P{Block= -old_permic}', "");
    Expect(0, 66432, '\P{^Block= -old_permic}', "");
    Error('\p{Blk= 	Old_permic:=}');
    Error('\P{Blk= 	Old_permic:=}');
    Expect(1, 66431, '\p{Blk=:\AOld_Permic\z:}', "");;
    Expect(0, 66432, '\p{Blk=:\AOld_Permic\z:}', "");;
    Expect(1, 66431, '\p{Blk=oldpermic}', "");
    Expect(0, 66431, '\p{^Blk=oldpermic}', "");
    Expect(0, 66431, '\P{Blk=oldpermic}', "");
    Expect(1, 66431, '\P{^Blk=oldpermic}', "");
    Expect(0, 66432, '\p{Blk=oldpermic}', "");
    Expect(1, 66432, '\p{^Blk=oldpermic}', "");
    Expect(1, 66432, '\P{Blk=oldpermic}', "");
    Expect(0, 66432, '\P{^Blk=oldpermic}', "");
    Expect(1, 66431, '\p{Blk=:\Aoldpermic\z:}', "");;
    Expect(0, 66432, '\p{Blk=:\Aoldpermic\z:}', "");;
    Expect(1, 66431, '\p{Blk: __Old_Permic}', "");
    Expect(0, 66431, '\p{^Blk: __Old_Permic}', "");
    Expect(0, 66431, '\P{Blk: __Old_Permic}', "");
    Expect(1, 66431, '\P{^Blk: __Old_Permic}', "");
    Expect(0, 66432, '\p{Blk: __Old_Permic}', "");
    Expect(1, 66432, '\p{^Blk: __Old_Permic}', "");
    Expect(1, 66432, '\P{Blk: __Old_Permic}', "");
    Expect(0, 66432, '\P{^Blk: __Old_Permic}', "");
    Error('\p{Is_Block= _OLD_permic:=}');
    Error('\P{Is_Block= _OLD_permic:=}');
    Expect(1, 66431, '\p{Is_Block=oldpermic}', "");
    Expect(0, 66431, '\p{^Is_Block=oldpermic}', "");
    Expect(0, 66431, '\P{Is_Block=oldpermic}', "");
    Expect(1, 66431, '\P{^Is_Block=oldpermic}', "");
    Expect(0, 66432, '\p{Is_Block=oldpermic}', "");
    Expect(1, 66432, '\p{^Is_Block=oldpermic}', "");
    Expect(1, 66432, '\P{Is_Block=oldpermic}', "");
    Expect(0, 66432, '\P{^Is_Block=oldpermic}', "");
    Expect(1, 66431, '\p{Is_Block=_Old_Permic}', "");
    Expect(0, 66431, '\p{^Is_Block=_Old_Permic}', "");
    Expect(0, 66431, '\P{Is_Block=_Old_Permic}', "");
    Expect(1, 66431, '\P{^Is_Block=_Old_Permic}', "");
    Expect(0, 66432, '\p{Is_Block=_Old_Permic}', "");
    Expect(1, 66432, '\p{^Is_Block=_Old_Permic}', "");
    Expect(1, 66432, '\P{Is_Block=_Old_Permic}', "");
    Expect(0, 66432, '\P{^Is_Block=_Old_Permic}', "");
    Error('\p{Is_Blk=-Old_Permic/a/}');
    Error('\P{Is_Blk=-Old_Permic/a/}');
    Expect(1, 66431, '\p{Is_Blk=oldpermic}', "");
    Expect(0, 66431, '\p{^Is_Blk=oldpermic}', "");
    Expect(0, 66431, '\P{Is_Blk=oldpermic}', "");
    Expect(1, 66431, '\P{^Is_Blk=oldpermic}', "");
    Expect(0, 66432, '\p{Is_Blk=oldpermic}', "");
    Expect(1, 66432, '\p{^Is_Blk=oldpermic}', "");
    Expect(1, 66432, '\P{Is_Blk=oldpermic}', "");
    Expect(0, 66432, '\P{^Is_Blk=oldpermic}', "");
    Expect(1, 66431, '\p{Is_Blk=-Old_Permic}', "");
    Expect(0, 66431, '\p{^Is_Blk=-Old_Permic}', "");
    Expect(0, 66431, '\P{Is_Blk=-Old_Permic}', "");
    Expect(1, 66431, '\P{^Is_Blk=-Old_Permic}', "");
    Expect(0, 66432, '\p{Is_Blk=-Old_Permic}', "");
    Expect(1, 66432, '\p{^Is_Blk=-Old_Permic}', "");
    Expect(1, 66432, '\P{Is_Blk=-Old_Permic}', "");
    Expect(0, 66432, '\P{^Is_Blk=-Old_Permic}', "");
    Error('\p{Block=	Old_persian:=}');
    Error('\P{Block=	Old_persian:=}');
    Expect(1, 66527, '\p{Block=:\AOld_Persian\z:}', "");;
    Expect(0, 66528, '\p{Block=:\AOld_Persian\z:}', "");;
    Expect(1, 66527, '\p{Block=oldpersian}', "");
    Expect(0, 66527, '\p{^Block=oldpersian}', "");
    Expect(0, 66527, '\P{Block=oldpersian}', "");
    Expect(1, 66527, '\P{^Block=oldpersian}', "");
    Expect(0, 66528, '\p{Block=oldpersian}', "");
    Expect(1, 66528, '\p{^Block=oldpersian}', "");
    Expect(1, 66528, '\P{Block=oldpersian}', "");
    Expect(0, 66528, '\P{^Block=oldpersian}', "");
    Expect(1, 66527, '\p{Block=:\Aoldpersian\z:}', "");;
    Expect(0, 66528, '\p{Block=:\Aoldpersian\z:}', "");;
    Expect(1, 66527, '\p{Block=_	OLD_PERSIAN}', "");
    Expect(0, 66527, '\p{^Block=_	OLD_PERSIAN}', "");
    Expect(0, 66527, '\P{Block=_	OLD_PERSIAN}', "");
    Expect(1, 66527, '\P{^Block=_	OLD_PERSIAN}', "");
    Expect(0, 66528, '\p{Block=_	OLD_PERSIAN}', "");
    Expect(1, 66528, '\p{^Block=_	OLD_PERSIAN}', "");
    Expect(1, 66528, '\P{Block=_	OLD_PERSIAN}', "");
    Expect(0, 66528, '\P{^Block=_	OLD_PERSIAN}', "");
    Error('\p{Blk=--OLD_Persian:=}');
    Error('\P{Blk=--OLD_Persian:=}');
    Expect(1, 66527, '\p{Blk=:\AOld_Persian\z:}', "");;
    Expect(0, 66528, '\p{Blk=:\AOld_Persian\z:}', "");;
    Expect(1, 66527, '\p{Blk=oldpersian}', "");
    Expect(0, 66527, '\p{^Blk=oldpersian}', "");
    Expect(0, 66527, '\P{Blk=oldpersian}', "");
    Expect(1, 66527, '\P{^Blk=oldpersian}', "");
    Expect(0, 66528, '\p{Blk=oldpersian}', "");
    Expect(1, 66528, '\p{^Blk=oldpersian}', "");
    Expect(1, 66528, '\P{Blk=oldpersian}', "");
    Expect(0, 66528, '\P{^Blk=oldpersian}', "");
    Expect(1, 66527, '\p{Blk=:\Aoldpersian\z:}', "");;
    Expect(0, 66528, '\p{Blk=:\Aoldpersian\z:}', "");;
    Expect(1, 66527, '\p{Blk=-	OLD_Persian}', "");
    Expect(0, 66527, '\p{^Blk=-	OLD_Persian}', "");
    Expect(0, 66527, '\P{Blk=-	OLD_Persian}', "");
    Expect(1, 66527, '\P{^Blk=-	OLD_Persian}', "");
    Expect(0, 66528, '\p{Blk=-	OLD_Persian}', "");
    Expect(1, 66528, '\p{^Blk=-	OLD_Persian}', "");
    Expect(1, 66528, '\P{Blk=-	OLD_Persian}', "");
    Expect(0, 66528, '\P{^Blk=-	OLD_Persian}', "");
    Error('\p{Is_Block=-OLD_persian:=}');
    Error('\P{Is_Block=-OLD_persian:=}');
    Expect(1, 66527, '\p{Is_Block: oldpersian}', "");
    Expect(0, 66527, '\p{^Is_Block: oldpersian}', "");
    Expect(0, 66527, '\P{Is_Block: oldpersian}', "");
    Expect(1, 66527, '\P{^Is_Block: oldpersian}', "");
    Expect(0, 66528, '\p{Is_Block: oldpersian}', "");
    Expect(1, 66528, '\p{^Is_Block: oldpersian}', "");
    Expect(1, 66528, '\P{Is_Block: oldpersian}', "");
    Expect(0, 66528, '\P{^Is_Block: oldpersian}', "");
    Expect(1, 66527, '\p{Is_Block=_-Old_Persian}', "");
    Expect(0, 66527, '\p{^Is_Block=_-Old_Persian}', "");
    Expect(0, 66527, '\P{Is_Block=_-Old_Persian}', "");
    Expect(1, 66527, '\P{^Is_Block=_-Old_Persian}', "");
    Expect(0, 66528, '\p{Is_Block=_-Old_Persian}', "");
    Expect(1, 66528, '\p{^Is_Block=_-Old_Persian}', "");
    Expect(1, 66528, '\P{Is_Block=_-Old_Persian}', "");
    Expect(0, 66528, '\P{^Is_Block=_-Old_Persian}', "");
    Error('\p{Is_Blk=  Old_persian:=}');
    Error('\P{Is_Blk=  Old_persian:=}');
    Expect(1, 66527, '\p{Is_Blk=oldpersian}', "");
    Expect(0, 66527, '\p{^Is_Blk=oldpersian}', "");
    Expect(0, 66527, '\P{Is_Blk=oldpersian}', "");
    Expect(1, 66527, '\P{^Is_Blk=oldpersian}', "");
    Expect(0, 66528, '\p{Is_Blk=oldpersian}', "");
    Expect(1, 66528, '\p{^Is_Blk=oldpersian}', "");
    Expect(1, 66528, '\P{Is_Blk=oldpersian}', "");
    Expect(0, 66528, '\P{^Is_Blk=oldpersian}', "");
    Expect(1, 66527, '\p{Is_Blk= -Old_Persian}', "");
    Expect(0, 66527, '\p{^Is_Blk= -Old_Persian}', "");
    Expect(0, 66527, '\P{Is_Blk= -Old_Persian}', "");
    Expect(1, 66527, '\P{^Is_Blk= -Old_Persian}', "");
    Expect(0, 66528, '\p{Is_Blk= -Old_Persian}', "");
    Expect(1, 66528, '\p{^Is_Blk= -Old_Persian}', "");
    Expect(1, 66528, '\P{Is_Blk= -Old_Persian}', "");
    Expect(0, 66528, '\P{^Is_Blk= -Old_Persian}', "");
    Error('\p{Block=-:=old_Sogdian}');
    Error('\P{Block=-:=old_Sogdian}');
    Expect(1, 69423, '\p{Block=:\AOld_Sogdian\z:}', "");;
    Expect(0, 69424, '\p{Block=:\AOld_Sogdian\z:}', "");;
    Expect(1, 69423, '\p{Block=oldsogdian}', "");
    Expect(0, 69423, '\p{^Block=oldsogdian}', "");
    Expect(0, 69423, '\P{Block=oldsogdian}', "");
    Expect(1, 69423, '\P{^Block=oldsogdian}', "");
    Expect(0, 69424, '\p{Block=oldsogdian}', "");
    Expect(1, 69424, '\p{^Block=oldsogdian}', "");
    Expect(1, 69424, '\P{Block=oldsogdian}', "");
    Expect(0, 69424, '\P{^Block=oldsogdian}', "");
    Expect(1, 69423, '\p{Block=:\Aoldsogdian\z:}', "");;
    Expect(0, 69424, '\p{Block=:\Aoldsogdian\z:}', "");;
    Expect(1, 69423, '\p{Block= 	Old_sogdian}', "");
    Expect(0, 69423, '\p{^Block= 	Old_sogdian}', "");
    Expect(0, 69423, '\P{Block= 	Old_sogdian}', "");
    Expect(1, 69423, '\P{^Block= 	Old_sogdian}', "");
    Expect(0, 69424, '\p{Block= 	Old_sogdian}', "");
    Expect(1, 69424, '\p{^Block= 	Old_sogdian}', "");
    Expect(1, 69424, '\P{Block= 	Old_sogdian}', "");
    Expect(0, 69424, '\P{^Block= 	Old_sogdian}', "");
    Error('\p{Blk=/a/--Old_Sogdian}');
    Error('\P{Blk=/a/--Old_Sogdian}');
    Expect(1, 69423, '\p{Blk=:\AOld_Sogdian\z:}', "");;
    Expect(0, 69424, '\p{Blk=:\AOld_Sogdian\z:}', "");;
    Expect(1, 69423, '\p{Blk: oldsogdian}', "");
    Expect(0, 69423, '\p{^Blk: oldsogdian}', "");
    Expect(0, 69423, '\P{Blk: oldsogdian}', "");
    Expect(1, 69423, '\P{^Blk: oldsogdian}', "");
    Expect(0, 69424, '\p{Blk: oldsogdian}', "");
    Expect(1, 69424, '\p{^Blk: oldsogdian}', "");
    Expect(1, 69424, '\P{Blk: oldsogdian}', "");
    Expect(0, 69424, '\P{^Blk: oldsogdian}', "");
    Expect(1, 69423, '\p{Blk=:\Aoldsogdian\z:}', "");;
    Expect(0, 69424, '\p{Blk=:\Aoldsogdian\z:}', "");;
    Expect(1, 69423, '\p{Blk= Old_Sogdian}', "");
    Expect(0, 69423, '\p{^Blk= Old_Sogdian}', "");
    Expect(0, 69423, '\P{Blk= Old_Sogdian}', "");
    Expect(1, 69423, '\P{^Blk= Old_Sogdian}', "");
    Expect(0, 69424, '\p{Blk= Old_Sogdian}', "");
    Expect(1, 69424, '\p{^Blk= Old_Sogdian}', "");
    Expect(1, 69424, '\P{Blk= Old_Sogdian}', "");
    Expect(0, 69424, '\P{^Blk= Old_Sogdian}', "");
    Error('\p{Is_Block=_/a/Old_SOGDIAN}');
    Error('\P{Is_Block=_/a/Old_SOGDIAN}');
    Expect(1, 69423, '\p{Is_Block=oldsogdian}', "");
    Expect(0, 69423, '\p{^Is_Block=oldsogdian}', "");
    Expect(0, 69423, '\P{Is_Block=oldsogdian}', "");
    Expect(1, 69423, '\P{^Is_Block=oldsogdian}', "");
    Expect(0, 69424, '\p{Is_Block=oldsogdian}', "");
    Expect(1, 69424, '\p{^Is_Block=oldsogdian}', "");
    Expect(1, 69424, '\P{Is_Block=oldsogdian}', "");
    Expect(0, 69424, '\P{^Is_Block=oldsogdian}', "");
    Expect(1, 69423, '\p{Is_Block=_OLD_sogdian}', "");
    Expect(0, 69423, '\p{^Is_Block=_OLD_sogdian}', "");
    Expect(0, 69423, '\P{Is_Block=_OLD_sogdian}', "");
    Expect(1, 69423, '\P{^Is_Block=_OLD_sogdian}', "");
    Expect(0, 69424, '\p{Is_Block=_OLD_sogdian}', "");
    Expect(1, 69424, '\p{^Is_Block=_OLD_sogdian}', "");
    Expect(1, 69424, '\P{Is_Block=_OLD_sogdian}', "");
    Expect(0, 69424, '\P{^Is_Block=_OLD_sogdian}', "");
    Error('\p{Is_Blk=:=--old_Sogdian}');
    Error('\P{Is_Blk=:=--old_Sogdian}');
    Expect(1, 69423, '\p{Is_Blk=oldsogdian}', "");
    Expect(0, 69423, '\p{^Is_Blk=oldsogdian}', "");
    Expect(0, 69423, '\P{Is_Blk=oldsogdian}', "");
    Expect(1, 69423, '\P{^Is_Blk=oldsogdian}', "");
    Expect(0, 69424, '\p{Is_Blk=oldsogdian}', "");
    Expect(1, 69424, '\p{^Is_Blk=oldsogdian}', "");
    Expect(1, 69424, '\P{Is_Blk=oldsogdian}', "");
    Expect(0, 69424, '\P{^Is_Blk=oldsogdian}', "");
    Expect(1, 69423, '\p{Is_Blk=-Old_Sogdian}', "");
    Expect(0, 69423, '\p{^Is_Blk=-Old_Sogdian}', "");
    Expect(0, 69423, '\P{Is_Blk=-Old_Sogdian}', "");
    Expect(1, 69423, '\P{^Is_Blk=-Old_Sogdian}', "");
    Expect(0, 69424, '\p{Is_Blk=-Old_Sogdian}', "");
    Expect(1, 69424, '\p{^Is_Blk=-Old_Sogdian}', "");
    Expect(1, 69424, '\P{Is_Blk=-Old_Sogdian}', "");
    Expect(0, 69424, '\P{^Is_Blk=-Old_Sogdian}', "");
    Error('\p{Block=/a/	 Old_South_arabian}');
    Error('\P{Block=/a/	 Old_South_arabian}');
    Expect(1, 68223, '\p{Block=:\AOld_South_Arabian\z:}', "");;
    Expect(0, 68224, '\p{Block=:\AOld_South_Arabian\z:}', "");;
    Expect(1, 68223, '\p{Block=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Block=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Block=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Block=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Block=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Block=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Block=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Block=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Block=:\Aoldsoutharabian\z:}', "");;
    Expect(0, 68224, '\p{Block=:\Aoldsoutharabian\z:}', "");;
    Expect(1, 68223, '\p{Block=  Old_South_ARABIAN}', "");
    Expect(0, 68223, '\p{^Block=  Old_South_ARABIAN}', "");
    Expect(0, 68223, '\P{Block=  Old_South_ARABIAN}', "");
    Expect(1, 68223, '\P{^Block=  Old_South_ARABIAN}', "");
    Expect(0, 68224, '\p{Block=  Old_South_ARABIAN}', "");
    Expect(1, 68224, '\p{^Block=  Old_South_ARABIAN}', "");
    Expect(1, 68224, '\P{Block=  Old_South_ARABIAN}', "");
    Expect(0, 68224, '\P{^Block=  Old_South_ARABIAN}', "");
    Error('\p{Blk=_/a/Old_south_Arabian}');
    Error('\P{Blk=_/a/Old_south_Arabian}');
    Expect(1, 68223, '\p{Blk=:\AOld_South_Arabian\z:}', "");;
    Expect(0, 68224, '\p{Blk=:\AOld_South_Arabian\z:}', "");;
    Expect(1, 68223, '\p{Blk=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Blk=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Blk=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Blk=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Blk=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Blk=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Blk=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Blk=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Blk=:\Aoldsoutharabian\z:}', "");;
    Expect(0, 68224, '\p{Blk=:\Aoldsoutharabian\z:}', "");;
    Expect(1, 68223, '\p{Blk= _old_South_Arabian}', "");
    Expect(0, 68223, '\p{^Blk= _old_South_Arabian}', "");
    Expect(0, 68223, '\P{Blk= _old_South_Arabian}', "");
    Expect(1, 68223, '\P{^Blk= _old_South_Arabian}', "");
    Expect(0, 68224, '\p{Blk= _old_South_Arabian}', "");
    Expect(1, 68224, '\p{^Blk= _old_South_Arabian}', "");
    Expect(1, 68224, '\P{Blk= _old_South_Arabian}', "");
    Expect(0, 68224, '\P{^Blk= _old_South_Arabian}', "");
    Error('\p{Is_Block=		Old_South_Arabian:=}');
    Error('\P{Is_Block=		Old_South_Arabian:=}');
    Expect(1, 68223, '\p{Is_Block=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Is_Block=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Is_Block=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Is_Block=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Is_Block=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Is_Block=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Is_Block=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Is_Block=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Is_Block: -Old_South_Arabian}', "");
    Expect(0, 68223, '\p{^Is_Block: -Old_South_Arabian}', "");
    Expect(0, 68223, '\P{Is_Block: -Old_South_Arabian}', "");
    Expect(1, 68223, '\P{^Is_Block: -Old_South_Arabian}', "");
    Expect(0, 68224, '\p{Is_Block: -Old_South_Arabian}', "");
    Expect(1, 68224, '\p{^Is_Block: -Old_South_Arabian}', "");
    Expect(1, 68224, '\P{Is_Block: -Old_South_Arabian}', "");
    Expect(0, 68224, '\P{^Is_Block: -Old_South_Arabian}', "");
    Error('\p{Is_Blk=	:=Old_SOUTH_Arabian}');
    Error('\P{Is_Blk=	:=Old_SOUTH_Arabian}');
    Expect(1, 68223, '\p{Is_Blk=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Is_Blk=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Is_Blk=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Is_Blk=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Is_Blk=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Is_Blk=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Is_Blk=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Is_Blk=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Is_Blk: _Old_South_ARABIAN}', "");
    Expect(0, 68223, '\p{^Is_Blk: _Old_South_ARABIAN}', "");
    Expect(0, 68223, '\P{Is_Blk: _Old_South_ARABIAN}', "");
    Expect(1, 68223, '\P{^Is_Blk: _Old_South_ARABIAN}', "");
    Expect(0, 68224, '\p{Is_Blk: _Old_South_ARABIAN}', "");
    Expect(1, 68224, '\p{^Is_Blk: _Old_South_ARABIAN}', "");
    Expect(1, 68224, '\P{Is_Blk: _Old_South_ARABIAN}', "");
    Expect(0, 68224, '\P{^Is_Blk: _Old_South_ARABIAN}', "");
    Error('\p{Block=	 OLD_Turkic/a/}');
    Error('\P{Block=	 OLD_Turkic/a/}');
    Expect(1, 68687, '\p{Block=:\AOld_Turkic\z:}', "");;
    Expect(0, 68688, '\p{Block=:\AOld_Turkic\z:}', "");;
    Expect(1, 68687, '\p{Block=oldturkic}', "");
    Expect(0, 68687, '\p{^Block=oldturkic}', "");
    Expect(0, 68687, '\P{Block=oldturkic}', "");
    Expect(1, 68687, '\P{^Block=oldturkic}', "");
    Expect(0, 68688, '\p{Block=oldturkic}', "");
    Expect(1, 68688, '\p{^Block=oldturkic}', "");
    Expect(1, 68688, '\P{Block=oldturkic}', "");
    Expect(0, 68688, '\P{^Block=oldturkic}', "");
    Expect(1, 68687, '\p{Block=:\Aoldturkic\z:}', "");;
    Expect(0, 68688, '\p{Block=:\Aoldturkic\z:}', "");;
    Expect(1, 68687, '\p{Block=- Old_Turkic}', "");
    Expect(0, 68687, '\p{^Block=- Old_Turkic}', "");
    Expect(0, 68687, '\P{Block=- Old_Turkic}', "");
    Expect(1, 68687, '\P{^Block=- Old_Turkic}', "");
    Expect(0, 68688, '\p{Block=- Old_Turkic}', "");
    Expect(1, 68688, '\p{^Block=- Old_Turkic}', "");
    Expect(1, 68688, '\P{Block=- Old_Turkic}', "");
    Expect(0, 68688, '\P{^Block=- Old_Turkic}', "");
    Error('\p{Blk:_:=Old_TURKIC}');
    Error('\P{Blk:_:=Old_TURKIC}');
    Expect(1, 68687, '\p{Blk=:\AOld_Turkic\z:}', "");;
    Expect(0, 68688, '\p{Blk=:\AOld_Turkic\z:}', "");;
    Expect(1, 68687, '\p{Blk=oldturkic}', "");
    Expect(0, 68687, '\p{^Blk=oldturkic}', "");
    Expect(0, 68687, '\P{Blk=oldturkic}', "");
    Expect(1, 68687, '\P{^Blk=oldturkic}', "");
    Expect(0, 68688, '\p{Blk=oldturkic}', "");
    Expect(1, 68688, '\p{^Blk=oldturkic}', "");
    Expect(1, 68688, '\P{Blk=oldturkic}', "");
    Expect(0, 68688, '\P{^Blk=oldturkic}', "");
    Expect(1, 68687, '\p{Blk=:\Aoldturkic\z:}', "");;
    Expect(0, 68688, '\p{Blk=:\Aoldturkic\z:}', "");;
    Expect(1, 68687, '\p{Blk= Old_turkic}', "");
    Expect(0, 68687, '\p{^Blk= Old_turkic}', "");
    Expect(0, 68687, '\P{Blk= Old_turkic}', "");
    Expect(1, 68687, '\P{^Blk= Old_turkic}', "");
    Expect(0, 68688, '\p{Blk= Old_turkic}', "");
    Expect(1, 68688, '\p{^Blk= Old_turkic}', "");
    Expect(1, 68688, '\P{Blk= Old_turkic}', "");
    Expect(0, 68688, '\P{^Blk= Old_turkic}', "");
    Error('\p{Is_Block:	/a/		OLD_TURKIC}');
    Error('\P{Is_Block:	/a/		OLD_TURKIC}');
    Expect(1, 68687, '\p{Is_Block=oldturkic}', "");
    Expect(0, 68687, '\p{^Is_Block=oldturkic}', "");
    Expect(0, 68687, '\P{Is_Block=oldturkic}', "");
    Expect(1, 68687, '\P{^Is_Block=oldturkic}', "");
    Expect(0, 68688, '\p{Is_Block=oldturkic}', "");
    Expect(1, 68688, '\p{^Is_Block=oldturkic}', "");
    Expect(1, 68688, '\P{Is_Block=oldturkic}', "");
    Expect(0, 68688, '\P{^Is_Block=oldturkic}', "");
    Expect(1, 68687, '\p{Is_Block=-	Old_TURKIC}', "");
    Expect(0, 68687, '\p{^Is_Block=-	Old_TURKIC}', "");
    Expect(0, 68687, '\P{Is_Block=-	Old_TURKIC}', "");
    Expect(1, 68687, '\P{^Is_Block=-	Old_TURKIC}', "");
    Expect(0, 68688, '\p{Is_Block=-	Old_TURKIC}', "");
    Expect(1, 68688, '\p{^Is_Block=-	Old_TURKIC}', "");
    Expect(1, 68688, '\P{Is_Block=-	Old_TURKIC}', "");
    Expect(0, 68688, '\P{^Is_Block=-	Old_TURKIC}', "");
    Error('\p{Is_Blk= :=Old_Turkic}');
    Error('\P{Is_Blk= :=Old_Turkic}');
    Expect(1, 68687, '\p{Is_Blk=oldturkic}', "");
    Expect(0, 68687, '\p{^Is_Blk=oldturkic}', "");
    Expect(0, 68687, '\P{Is_Blk=oldturkic}', "");
    Expect(1, 68687, '\P{^Is_Blk=oldturkic}', "");
    Expect(0, 68688, '\p{Is_Blk=oldturkic}', "");
    Expect(1, 68688, '\p{^Is_Blk=oldturkic}', "");
    Expect(1, 68688, '\P{Is_Blk=oldturkic}', "");
    Expect(0, 68688, '\P{^Is_Blk=oldturkic}', "");
    Expect(1, 68687, '\p{Is_Blk=Old_Turkic}', "");
    Expect(0, 68687, '\p{^Is_Blk=Old_Turkic}', "");
    Expect(0, 68687, '\P{Is_Blk=Old_Turkic}', "");
    Expect(1, 68687, '\P{^Is_Blk=Old_Turkic}', "");
    Expect(0, 68688, '\p{Is_Blk=Old_Turkic}', "");
    Expect(1, 68688, '\p{^Is_Blk=Old_Turkic}', "");
    Expect(1, 68688, '\P{Is_Blk=Old_Turkic}', "");
    Expect(0, 68688, '\P{^Is_Blk=Old_Turkic}', "");
    Error('\p{Block=:=ORIYA}');
    Error('\P{Block=:=ORIYA}');
    Expect(1, 2943, '\p{Block=:\AOriya\z:}', "");;
    Expect(0, 2944, '\p{Block=:\AOriya\z:}', "");;
    Expect(1, 2943, '\p{Block=oriya}', "");
    Expect(0, 2943, '\p{^Block=oriya}', "");
    Expect(0, 2943, '\P{Block=oriya}', "");
    Expect(1, 2943, '\P{^Block=oriya}', "");
    Expect(0, 2944, '\p{Block=oriya}', "");
    Expect(1, 2944, '\p{^Block=oriya}', "");
    Expect(1, 2944, '\P{Block=oriya}', "");
    Expect(0, 2944, '\P{^Block=oriya}', "");
    Expect(1, 2943, '\p{Block=:\Aoriya\z:}', "");;
    Expect(0, 2944, '\p{Block=:\Aoriya\z:}', "");;
    Expect(1, 2943, '\p{Block=_	ORIYA}', "");
    Expect(0, 2943, '\p{^Block=_	ORIYA}', "");
    Expect(0, 2943, '\P{Block=_	ORIYA}', "");
    Expect(1, 2943, '\P{^Block=_	ORIYA}', "");
    Expect(0, 2944, '\p{Block=_	ORIYA}', "");
    Expect(1, 2944, '\p{^Block=_	ORIYA}', "");
    Expect(1, 2944, '\P{Block=_	ORIYA}', "");
    Expect(0, 2944, '\P{^Block=_	ORIYA}', "");
    Error('\p{Blk=/a/  Oriya}');
    Error('\P{Blk=/a/  Oriya}');
    Expect(1, 2943, '\p{Blk=:\AOriya\z:}', "");;
    Expect(0, 2944, '\p{Blk=:\AOriya\z:}', "");;
    Expect(1, 2943, '\p{Blk:   oriya}', "");
    Expect(0, 2943, '\p{^Blk:   oriya}', "");
    Expect(0, 2943, '\P{Blk:   oriya}', "");
    Expect(1, 2943, '\P{^Blk:   oriya}', "");
    Expect(0, 2944, '\p{Blk:   oriya}', "");
    Expect(1, 2944, '\p{^Blk:   oriya}', "");
    Expect(1, 2944, '\P{Blk:   oriya}', "");
    Expect(0, 2944, '\P{^Blk:   oriya}', "");
    Expect(1, 2943, '\p{Blk=:\Aoriya\z:}', "");;
    Expect(0, 2944, '\p{Blk=:\Aoriya\z:}', "");;
    Expect(1, 2943, '\p{Blk=-	ORIYA}', "");
    Expect(0, 2943, '\p{^Blk=-	ORIYA}', "");
    Expect(0, 2943, '\P{Blk=-	ORIYA}', "");
    Expect(1, 2943, '\P{^Blk=-	ORIYA}', "");
    Expect(0, 2944, '\p{Blk=-	ORIYA}', "");
    Expect(1, 2944, '\p{^Blk=-	ORIYA}', "");
    Expect(1, 2944, '\P{Blk=-	ORIYA}', "");
    Expect(0, 2944, '\P{^Blk=-	ORIYA}', "");
    Error('\p{Is_Block:-_Oriya:=}');
    Error('\P{Is_Block:-_Oriya:=}');
    Expect(1, 2943, '\p{Is_Block=oriya}', "");
    Expect(0, 2943, '\p{^Is_Block=oriya}', "");
    Expect(0, 2943, '\P{Is_Block=oriya}', "");
    Expect(1, 2943, '\P{^Is_Block=oriya}', "");
    Expect(0, 2944, '\p{Is_Block=oriya}', "");
    Expect(1, 2944, '\p{^Is_Block=oriya}', "");
    Expect(1, 2944, '\P{Is_Block=oriya}', "");
    Expect(0, 2944, '\P{^Is_Block=oriya}', "");
    Expect(1, 2943, '\p{Is_Block=	Oriya}', "");
    Expect(0, 2943, '\p{^Is_Block=	Oriya}', "");
    Expect(0, 2943, '\P{Is_Block=	Oriya}', "");
    Expect(1, 2943, '\P{^Is_Block=	Oriya}', "");
    Expect(0, 2944, '\p{Is_Block=	Oriya}', "");
    Expect(1, 2944, '\p{^Is_Block=	Oriya}', "");
    Expect(1, 2944, '\P{Is_Block=	Oriya}', "");
    Expect(0, 2944, '\P{^Is_Block=	Oriya}', "");
    Error('\p{Is_Blk:	/a/- Oriya}');
    Error('\P{Is_Blk:	/a/- Oriya}');
    Expect(1, 2943, '\p{Is_Blk:   oriya}', "");
    Expect(0, 2943, '\p{^Is_Blk:   oriya}', "");
    Expect(0, 2943, '\P{Is_Blk:   oriya}', "");
    Expect(1, 2943, '\P{^Is_Blk:   oriya}', "");
    Expect(0, 2944, '\p{Is_Blk:   oriya}', "");
    Expect(1, 2944, '\p{^Is_Blk:   oriya}', "");
    Expect(1, 2944, '\P{Is_Blk:   oriya}', "");
    Expect(0, 2944, '\P{^Is_Blk:   oriya}', "");
    Expect(1, 2943, '\p{Is_Blk=	-Oriya}', "");
    Expect(0, 2943, '\p{^Is_Blk=	-Oriya}', "");
    Expect(0, 2943, '\P{Is_Blk=	-Oriya}', "");
    Expect(1, 2943, '\P{^Is_Blk=	-Oriya}', "");
    Expect(0, 2944, '\p{Is_Blk=	-Oriya}', "");
    Expect(1, 2944, '\p{^Is_Blk=	-Oriya}', "");
    Expect(1, 2944, '\P{Is_Blk=	-Oriya}', "");
    Expect(0, 2944, '\P{^Is_Blk=	-Oriya}', "");
    Error('\p{Block=_ornamental_Dingbats:=}');
    Error('\P{Block=_ornamental_Dingbats:=}');
    Expect(1, 128639, '\p{Block=:\AOrnamental_Dingbats\z:}', "");;
    Expect(0, 128640, '\p{Block=:\AOrnamental_Dingbats\z:}', "");;
    Expect(1, 128639, '\p{Block=ornamentaldingbats}', "");
    Expect(0, 128639, '\p{^Block=ornamentaldingbats}', "");
    Expect(0, 128639, '\P{Block=ornamentaldingbats}', "");
    Expect(1, 128639, '\P{^Block=ornamentaldingbats}', "");
    Expect(0, 128640, '\p{Block=ornamentaldingbats}', "");
    Expect(1, 128640, '\p{^Block=ornamentaldingbats}', "");
    Expect(1, 128640, '\P{Block=ornamentaldingbats}', "");
    Expect(0, 128640, '\P{^Block=ornamentaldingbats}', "");
    Expect(1, 128639, '\p{Block=:\Aornamentaldingbats\z:}', "");;
    Expect(0, 128640, '\p{Block=:\Aornamentaldingbats\z:}', "");;
    Expect(1, 128639, '\p{Block=	Ornamental_Dingbats}', "");
    Expect(0, 128639, '\p{^Block=	Ornamental_Dingbats}', "");
    Expect(0, 128639, '\P{Block=	Ornamental_Dingbats}', "");
    Expect(1, 128639, '\P{^Block=	Ornamental_Dingbats}', "");
    Expect(0, 128640, '\p{Block=	Ornamental_Dingbats}', "");
    Expect(1, 128640, '\p{^Block=	Ornamental_Dingbats}', "");
    Expect(1, 128640, '\P{Block=	Ornamental_Dingbats}', "");
    Expect(0, 128640, '\P{^Block=	Ornamental_Dingbats}', "");
    Error('\p{Blk=:=-ORNAMENTAL_Dingbats}');
    Error('\P{Blk=:=-ORNAMENTAL_Dingbats}');
    Expect(1, 128639, '\p{Blk=:\AOrnamental_Dingbats\z:}', "");;
    Expect(0, 128640, '\p{Blk=:\AOrnamental_Dingbats\z:}', "");;
    Expect(1, 128639, '\p{Blk:	ornamentaldingbats}', "");
    Expect(0, 128639, '\p{^Blk:	ornamentaldingbats}', "");
    Expect(0, 128639, '\P{Blk:	ornamentaldingbats}', "");
    Expect(1, 128639, '\P{^Blk:	ornamentaldingbats}', "");
    Expect(0, 128640, '\p{Blk:	ornamentaldingbats}', "");
    Expect(1, 128640, '\p{^Blk:	ornamentaldingbats}', "");
    Expect(1, 128640, '\P{Blk:	ornamentaldingbats}', "");
    Expect(0, 128640, '\P{^Blk:	ornamentaldingbats}', "");
    Expect(1, 128639, '\p{Blk=:\Aornamentaldingbats\z:}', "");;
    Expect(0, 128640, '\p{Blk=:\Aornamentaldingbats\z:}', "");;
    Expect(1, 128639, '\p{Blk= ORNAMENTAL_Dingbats}', "");
    Expect(0, 128639, '\p{^Blk= ORNAMENTAL_Dingbats}', "");
    Expect(0, 128639, '\P{Blk= ORNAMENTAL_Dingbats}', "");
    Expect(1, 128639, '\P{^Blk= ORNAMENTAL_Dingbats}', "");
    Expect(0, 128640, '\p{Blk= ORNAMENTAL_Dingbats}', "");
    Expect(1, 128640, '\p{^Blk= ORNAMENTAL_Dingbats}', "");
    Expect(1, 128640, '\P{Blk= ORNAMENTAL_Dingbats}', "");
    Expect(0, 128640, '\P{^Blk= ORNAMENTAL_Dingbats}', "");
    Error('\p{Is_Block=:=ORNAMENTAL_DINGBATS}');
    Error('\P{Is_Block=:=ORNAMENTAL_DINGBATS}');
    Expect(1, 128639, '\p{Is_Block=ornamentaldingbats}', "");
    Expect(0, 128639, '\p{^Is_Block=ornamentaldingbats}', "");
    Expect(0, 128639, '\P{Is_Block=ornamentaldingbats}', "");
    Expect(1, 128639, '\P{^Is_Block=ornamentaldingbats}', "");
    Expect(0, 128640, '\p{Is_Block=ornamentaldingbats}', "");
    Expect(1, 128640, '\p{^Is_Block=ornamentaldingbats}', "");
    Expect(1, 128640, '\P{Is_Block=ornamentaldingbats}', "");
    Expect(0, 128640, '\P{^Is_Block=ornamentaldingbats}', "");
    Expect(1, 128639, '\p{Is_Block= -ORNAMENTAL_Dingbats}', "");
    Expect(0, 128639, '\p{^Is_Block= -ORNAMENTAL_Dingbats}', "");
    Expect(0, 128639, '\P{Is_Block= -ORNAMENTAL_Dingbats}', "");
    Expect(1, 128639, '\P{^Is_Block= -ORNAMENTAL_Dingbats}', "");
    Expect(0, 128640, '\p{Is_Block= -ORNAMENTAL_Dingbats}', "");
    Expect(1, 128640, '\p{^Is_Block= -ORNAMENTAL_Dingbats}', "");
    Expect(1, 128640, '\P{Is_Block= -ORNAMENTAL_Dingbats}', "");
    Expect(0, 128640, '\P{^Is_Block= -ORNAMENTAL_Dingbats}', "");
    Error('\p{Is_Blk= ornamental_Dingbats:=}');
    Error('\P{Is_Blk= ornamental_Dingbats:=}');
    Expect(1, 128639, '\p{Is_Blk:ornamentaldingbats}', "");
    Expect(0, 128639, '\p{^Is_Blk:ornamentaldingbats}', "");
    Expect(0, 128639, '\P{Is_Blk:ornamentaldingbats}', "");
    Expect(1, 128639, '\P{^Is_Blk:ornamentaldingbats}', "");
    Expect(0, 128640, '\p{Is_Blk:ornamentaldingbats}', "");
    Expect(1, 128640, '\p{^Is_Blk:ornamentaldingbats}', "");
    Expect(1, 128640, '\P{Is_Blk:ornamentaldingbats}', "");
    Expect(0, 128640, '\P{^Is_Blk:ornamentaldingbats}', "");
    Expect(1, 128639, '\p{Is_Blk:	-_ornamental_dingbats}', "");
    Expect(0, 128639, '\p{^Is_Blk:	-_ornamental_dingbats}', "");
    Expect(0, 128639, '\P{Is_Blk:	-_ornamental_dingbats}', "");
    Expect(1, 128639, '\P{^Is_Blk:	-_ornamental_dingbats}', "");
    Expect(0, 128640, '\p{Is_Blk:	-_ornamental_dingbats}', "");
    Expect(1, 128640, '\p{^Is_Blk:	-_ornamental_dingbats}', "");
    Expect(1, 128640, '\P{Is_Blk:	-_ornamental_dingbats}', "");
    Expect(0, 128640, '\P{^Is_Blk:	-_ornamental_dingbats}', "");
    Error('\p{Block= /a/OSAGE}');
    Error('\P{Block= /a/OSAGE}');
    Expect(1, 66815, '\p{Block=:\AOsage\z:}', "");;
    Expect(0, 66816, '\p{Block=:\AOsage\z:}', "");;
    Expect(1, 66815, '\p{Block:   osage}', "");
    Expect(0, 66815, '\p{^Block:   osage}', "");
    Expect(0, 66815, '\P{Block:   osage}', "");
    Expect(1, 66815, '\P{^Block:   osage}', "");
    Expect(0, 66816, '\p{Block:   osage}', "");
    Expect(1, 66816, '\p{^Block:   osage}', "");
    Expect(1, 66816, '\P{Block:   osage}', "");
    Expect(0, 66816, '\P{^Block:   osage}', "");
    Expect(1, 66815, '\p{Block=:\Aosage\z:}', "");;
    Expect(0, 66816, '\p{Block=:\Aosage\z:}', "");;
    Expect(1, 66815, '\p{Block=	Osage}', "");
    Expect(0, 66815, '\p{^Block=	Osage}', "");
    Expect(0, 66815, '\P{Block=	Osage}', "");
    Expect(1, 66815, '\P{^Block=	Osage}', "");
    Expect(0, 66816, '\p{Block=	Osage}', "");
    Expect(1, 66816, '\p{^Block=	Osage}', "");
    Expect(1, 66816, '\P{Block=	Osage}', "");
    Expect(0, 66816, '\P{^Block=	Osage}', "");
    Error('\p{Blk:   -/a/osage}');
    Error('\P{Blk:   -/a/osage}');
    Expect(1, 66815, '\p{Blk=:\AOsage\z:}', "");;
    Expect(0, 66816, '\p{Blk=:\AOsage\z:}', "");;
    Expect(1, 66815, '\p{Blk=osage}', "");
    Expect(0, 66815, '\p{^Blk=osage}', "");
    Expect(0, 66815, '\P{Blk=osage}', "");
    Expect(1, 66815, '\P{^Blk=osage}', "");
    Expect(0, 66816, '\p{Blk=osage}', "");
    Expect(1, 66816, '\p{^Blk=osage}', "");
    Expect(1, 66816, '\P{Blk=osage}', "");
    Expect(0, 66816, '\P{^Blk=osage}', "");
    Expect(1, 66815, '\p{Blk=:\Aosage\z:}', "");;
    Expect(0, 66816, '\p{Blk=:\Aosage\z:}', "");;
    Expect(1, 66815, '\p{Blk=	Osage}', "");
    Expect(0, 66815, '\p{^Blk=	Osage}', "");
    Expect(0, 66815, '\P{Blk=	Osage}', "");
    Expect(1, 66815, '\P{^Blk=	Osage}', "");
    Expect(0, 66816, '\p{Blk=	Osage}', "");
    Expect(1, 66816, '\p{^Blk=	Osage}', "");
    Expect(1, 66816, '\P{Blk=	Osage}', "");
    Expect(0, 66816, '\P{^Blk=	Osage}', "");
    Error('\p{Is_Block=-	Osage:=}');
    Error('\P{Is_Block=-	Osage:=}');
    Expect(1, 66815, '\p{Is_Block=osage}', "");
    Expect(0, 66815, '\p{^Is_Block=osage}', "");
    Expect(0, 66815, '\P{Is_Block=osage}', "");
    Expect(1, 66815, '\P{^Is_Block=osage}', "");
    Expect(0, 66816, '\p{Is_Block=osage}', "");
    Expect(1, 66816, '\p{^Is_Block=osage}', "");
    Expect(1, 66816, '\P{Is_Block=osage}', "");
    Expect(0, 66816, '\P{^Is_Block=osage}', "");
    Expect(1, 66815, '\p{Is_Block=  Osage}', "");
    Expect(0, 66815, '\p{^Is_Block=  Osage}', "");
    Expect(0, 66815, '\P{Is_Block=  Osage}', "");
    Expect(1, 66815, '\P{^Is_Block=  Osage}', "");
    Expect(0, 66816, '\p{Is_Block=  Osage}', "");
    Expect(1, 66816, '\p{^Is_Block=  Osage}', "");
    Expect(1, 66816, '\P{Is_Block=  Osage}', "");
    Expect(0, 66816, '\P{^Is_Block=  Osage}', "");
    Error('\p{Is_Blk=	:=Osage}');
    Error('\P{Is_Blk=	:=Osage}');
    Expect(1, 66815, '\p{Is_Blk=osage}', "");
    Expect(0, 66815, '\p{^Is_Blk=osage}', "");
    Expect(0, 66815, '\P{Is_Blk=osage}', "");
    Expect(1, 66815, '\P{^Is_Blk=osage}', "");
    Expect(0, 66816, '\p{Is_Blk=osage}', "");
    Expect(1, 66816, '\p{^Is_Blk=osage}', "");
    Expect(1, 66816, '\P{Is_Blk=osage}', "");
    Expect(0, 66816, '\P{^Is_Blk=osage}', "");
    Expect(1, 66815, '\p{Is_Blk= osage}', "");
    Expect(0, 66815, '\p{^Is_Blk= osage}', "");
    Expect(0, 66815, '\P{Is_Blk= osage}', "");
    Expect(1, 66815, '\P{^Is_Blk= osage}', "");
    Expect(0, 66816, '\p{Is_Blk= osage}', "");
    Expect(1, 66816, '\p{^Is_Blk= osage}', "");
    Expect(1, 66816, '\P{Is_Blk= osage}', "");
    Expect(0, 66816, '\P{^Is_Blk= osage}', "");
    Error('\p{Block=_	OSMANYA/a/}');
    Error('\P{Block=_	OSMANYA/a/}');
    Expect(1, 66735, '\p{Block=:\AOsmanya\z:}', "");;
    Expect(0, 66736, '\p{Block=:\AOsmanya\z:}', "");;
    Expect(1, 66735, '\p{Block:	osmanya}', "");
    Expect(0, 66735, '\p{^Block:	osmanya}', "");
    Expect(0, 66735, '\P{Block:	osmanya}', "");
    Expect(1, 66735, '\P{^Block:	osmanya}', "");
    Expect(0, 66736, '\p{Block:	osmanya}', "");
    Expect(1, 66736, '\p{^Block:	osmanya}', "");
    Expect(1, 66736, '\P{Block:	osmanya}', "");
    Expect(0, 66736, '\P{^Block:	osmanya}', "");
    Expect(1, 66735, '\p{Block=:\Aosmanya\z:}', "");;
    Expect(0, 66736, '\p{Block=:\Aosmanya\z:}', "");;
    Expect(1, 66735, '\p{Block=	Osmanya}', "");
    Expect(0, 66735, '\p{^Block=	Osmanya}', "");
    Expect(0, 66735, '\P{Block=	Osmanya}', "");
    Expect(1, 66735, '\P{^Block=	Osmanya}', "");
    Expect(0, 66736, '\p{Block=	Osmanya}', "");
    Expect(1, 66736, '\p{^Block=	Osmanya}', "");
    Expect(1, 66736, '\P{Block=	Osmanya}', "");
    Expect(0, 66736, '\P{^Block=	Osmanya}', "");
    Error('\p{Blk=:=__Osmanya}');
    Error('\P{Blk=:=__Osmanya}');
    Expect(1, 66735, '\p{Blk=:\AOsmanya\z:}', "");;
    Expect(0, 66736, '\p{Blk=:\AOsmanya\z:}', "");;
    Expect(1, 66735, '\p{Blk=osmanya}', "");
    Expect(0, 66735, '\p{^Blk=osmanya}', "");
    Expect(0, 66735, '\P{Blk=osmanya}', "");
    Expect(1, 66735, '\P{^Blk=osmanya}', "");
    Expect(0, 66736, '\p{Blk=osmanya}', "");
    Expect(1, 66736, '\p{^Blk=osmanya}', "");
    Expect(1, 66736, '\P{Blk=osmanya}', "");
    Expect(0, 66736, '\P{^Blk=osmanya}', "");
    Expect(1, 66735, '\p{Blk=:\Aosmanya\z:}', "");;
    Expect(0, 66736, '\p{Blk=:\Aosmanya\z:}', "");;
    Expect(1, 66735, '\p{Blk=	_osmanya}', "");
    Expect(0, 66735, '\p{^Blk=	_osmanya}', "");
    Expect(0, 66735, '\P{Blk=	_osmanya}', "");
    Expect(1, 66735, '\P{^Blk=	_osmanya}', "");
    Expect(0, 66736, '\p{Blk=	_osmanya}', "");
    Expect(1, 66736, '\p{^Blk=	_osmanya}', "");
    Expect(1, 66736, '\P{Blk=	_osmanya}', "");
    Expect(0, 66736, '\P{^Blk=	_osmanya}', "");
    Error('\p{Is_Block=/a/ 	osmanya}');
    Error('\P{Is_Block=/a/ 	osmanya}');
    Expect(1, 66735, '\p{Is_Block:   osmanya}', "");
    Expect(0, 66735, '\p{^Is_Block:   osmanya}', "");
    Expect(0, 66735, '\P{Is_Block:   osmanya}', "");
    Expect(1, 66735, '\P{^Is_Block:   osmanya}', "");
    Expect(0, 66736, '\p{Is_Block:   osmanya}', "");
    Expect(1, 66736, '\p{^Is_Block:   osmanya}', "");
    Expect(1, 66736, '\P{Is_Block:   osmanya}', "");
    Expect(0, 66736, '\P{^Is_Block:   osmanya}', "");
    Expect(1, 66735, '\p{Is_Block=__Osmanya}', "");
    Expect(0, 66735, '\p{^Is_Block=__Osmanya}', "");
    Expect(0, 66735, '\P{Is_Block=__Osmanya}', "");
    Expect(1, 66735, '\P{^Is_Block=__Osmanya}', "");
    Expect(0, 66736, '\p{Is_Block=__Osmanya}', "");
    Expect(1, 66736, '\p{^Is_Block=__Osmanya}', "");
    Expect(1, 66736, '\P{Is_Block=__Osmanya}', "");
    Expect(0, 66736, '\P{^Is_Block=__Osmanya}', "");
    Error('\p{Is_Blk=	/a/Osmanya}');
    Error('\P{Is_Blk=	/a/Osmanya}');
    Expect(1, 66735, '\p{Is_Blk=osmanya}', "");
    Expect(0, 66735, '\p{^Is_Blk=osmanya}', "");
    Expect(0, 66735, '\P{Is_Blk=osmanya}', "");
    Expect(1, 66735, '\P{^Is_Blk=osmanya}', "");
    Expect(0, 66736, '\p{Is_Blk=osmanya}', "");
    Expect(1, 66736, '\p{^Is_Blk=osmanya}', "");
    Expect(1, 66736, '\P{Is_Blk=osmanya}', "");
    Expect(0, 66736, '\P{^Is_Blk=osmanya}', "");
    Expect(1, 66735, '\p{Is_Blk: -	osmanya}', "");
    Expect(0, 66735, '\p{^Is_Blk: -	osmanya}', "");
    Expect(0, 66735, '\P{Is_Blk: -	osmanya}', "");
    Expect(1, 66735, '\P{^Is_Blk: -	osmanya}', "");
    Expect(0, 66736, '\p{Is_Blk: -	osmanya}', "");
    Expect(1, 66736, '\p{^Is_Blk: -	osmanya}', "");
    Expect(1, 66736, '\P{Is_Blk: -	osmanya}', "");
    Expect(0, 66736, '\P{^Is_Blk: -	osmanya}', "");
    Error('\p{Block=_/a/Ottoman_siyaq_numbers}');
    Error('\P{Block=_/a/Ottoman_siyaq_numbers}');
    Expect(1, 126287, '\p{Block=:\AOttoman_Siyaq_Numbers\z:}', "");;
    Expect(0, 126288, '\p{Block=:\AOttoman_Siyaq_Numbers\z:}', "");;
    Expect(1, 126287, '\p{Block:	ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\p{^Block:	ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\P{Block:	ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\P{^Block:	ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\p{Block:	ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\p{^Block:	ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\P{Block:	ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\P{^Block:	ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\p{Block=:\Aottomansiyaqnumbers\z:}', "");;
    Expect(0, 126288, '\p{Block=:\Aottomansiyaqnumbers\z:}', "");;
    Expect(1, 126287, '\p{Block=-Ottoman_SIYAQ_Numbers}', "");
    Expect(0, 126287, '\p{^Block=-Ottoman_SIYAQ_Numbers}', "");
    Expect(0, 126287, '\P{Block=-Ottoman_SIYAQ_Numbers}', "");
    Expect(1, 126287, '\P{^Block=-Ottoman_SIYAQ_Numbers}', "");
    Expect(0, 126288, '\p{Block=-Ottoman_SIYAQ_Numbers}', "");
    Expect(1, 126288, '\p{^Block=-Ottoman_SIYAQ_Numbers}', "");
    Expect(1, 126288, '\P{Block=-Ottoman_SIYAQ_Numbers}', "");
    Expect(0, 126288, '\P{^Block=-Ottoman_SIYAQ_Numbers}', "");
    Error('\p{Blk=		Ottoman_Siyaq_Numbers/a/}');
    Error('\P{Blk=		Ottoman_Siyaq_Numbers/a/}');
    Expect(1, 126287, '\p{Blk=:\AOttoman_Siyaq_Numbers\z:}', "");;
    Expect(0, 126288, '\p{Blk=:\AOttoman_Siyaq_Numbers\z:}', "");;
    Expect(1, 126287, '\p{Blk=ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\p{^Blk=ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\P{Blk=ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\P{^Blk=ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\p{Blk=ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\p{^Blk=ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\P{Blk=ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\P{^Blk=ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\p{Blk=:\Aottomansiyaqnumbers\z:}', "");;
    Expect(0, 126288, '\p{Blk=:\Aottomansiyaqnumbers\z:}', "");;
    Expect(1, 126287, '\p{Blk=  ottoman_siyaq_NUMBERS}', "");
    Expect(0, 126287, '\p{^Blk=  ottoman_siyaq_NUMBERS}', "");
    Expect(0, 126287, '\P{Blk=  ottoman_siyaq_NUMBERS}', "");
    Expect(1, 126287, '\P{^Blk=  ottoman_siyaq_NUMBERS}', "");
    Expect(0, 126288, '\p{Blk=  ottoman_siyaq_NUMBERS}', "");
    Expect(1, 126288, '\p{^Blk=  ottoman_siyaq_NUMBERS}', "");
    Expect(1, 126288, '\P{Blk=  ottoman_siyaq_NUMBERS}', "");
    Expect(0, 126288, '\P{^Blk=  ottoman_siyaq_NUMBERS}', "");
    Error('\p{Is_Block=_-OTTOMAN_siyaq_Numbers:=}');
    Error('\P{Is_Block=_-OTTOMAN_siyaq_Numbers:=}');
    Expect(1, 126287, '\p{Is_Block=ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\p{^Is_Block=ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\P{Is_Block=ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\P{^Is_Block=ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\p{Is_Block=ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\p{^Is_Block=ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\P{Is_Block=ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\P{^Is_Block=ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\p{Is_Block=-OTTOMAN_SIYAQ_Numbers}', "");
    Expect(0, 126287, '\p{^Is_Block=-OTTOMAN_SIYAQ_Numbers}', "");
    Expect(0, 126287, '\P{Is_Block=-OTTOMAN_SIYAQ_Numbers}', "");
    Expect(1, 126287, '\P{^Is_Block=-OTTOMAN_SIYAQ_Numbers}', "");
    Expect(0, 126288, '\p{Is_Block=-OTTOMAN_SIYAQ_Numbers}', "");
    Expect(1, 126288, '\p{^Is_Block=-OTTOMAN_SIYAQ_Numbers}', "");
    Expect(1, 126288, '\P{Is_Block=-OTTOMAN_SIYAQ_Numbers}', "");
    Expect(0, 126288, '\P{^Is_Block=-OTTOMAN_SIYAQ_Numbers}', "");
    Error('\p{Is_Blk=_:=OTTOMAN_siyaq_Numbers}');
    Error('\P{Is_Blk=_:=OTTOMAN_siyaq_Numbers}');
    Expect(1, 126287, '\p{Is_Blk=ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\p{^Is_Blk=ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\P{Is_Blk=ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\P{^Is_Blk=ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\p{Is_Blk=ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\p{^Is_Blk=ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\P{Is_Blk=ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\P{^Is_Blk=ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\p{Is_Blk=-_Ottoman_SIYAQ_Numbers}', "");
    Expect(0, 126287, '\p{^Is_Blk=-_Ottoman_SIYAQ_Numbers}', "");
    Expect(0, 126287, '\P{Is_Blk=-_Ottoman_SIYAQ_Numbers}', "");
    Expect(1, 126287, '\P{^Is_Blk=-_Ottoman_SIYAQ_Numbers}', "");
    Expect(0, 126288, '\p{Is_Blk=-_Ottoman_SIYAQ_Numbers}', "");
    Expect(1, 126288, '\p{^Is_Blk=-_Ottoman_SIYAQ_Numbers}', "");
    Expect(1, 126288, '\P{Is_Blk=-_Ottoman_SIYAQ_Numbers}', "");
    Expect(0, 126288, '\P{^Is_Blk=-_Ottoman_SIYAQ_Numbers}', "");
    Error('\p{Block=/a/pahawh_Hmong}');
    Error('\P{Block=/a/pahawh_Hmong}');
    Expect(1, 93071, '\p{Block=:\APahawh_Hmong\z:}', "");;
    Expect(0, 93072, '\p{Block=:\APahawh_Hmong\z:}', "");;
    Expect(1, 93071, '\p{Block=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Block=pahawhhmong}', "");
    Expect(0, 93071, '\P{Block=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Block=pahawhhmong}', "");
    Expect(0, 93072, '\p{Block=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Block=pahawhhmong}', "");
    Expect(1, 93072, '\P{Block=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Block=pahawhhmong}', "");
    Expect(1, 93071, '\p{Block=:\Apahawhhmong\z:}', "");;
    Expect(0, 93072, '\p{Block=:\Apahawhhmong\z:}', "");;
    Expect(1, 93071, '\p{Block=__Pahawh_HMONG}', "");
    Expect(0, 93071, '\p{^Block=__Pahawh_HMONG}', "");
    Expect(0, 93071, '\P{Block=__Pahawh_HMONG}', "");
    Expect(1, 93071, '\P{^Block=__Pahawh_HMONG}', "");
    Expect(0, 93072, '\p{Block=__Pahawh_HMONG}', "");
    Expect(1, 93072, '\p{^Block=__Pahawh_HMONG}', "");
    Expect(1, 93072, '\P{Block=__Pahawh_HMONG}', "");
    Expect(0, 93072, '\P{^Block=__Pahawh_HMONG}', "");
    Error('\p{Blk:/a/	 PAHAWH_hmong}');
    Error('\P{Blk:/a/	 PAHAWH_hmong}');
    Expect(1, 93071, '\p{Blk=:\APahawh_Hmong\z:}', "");;
    Expect(0, 93072, '\p{Blk=:\APahawh_Hmong\z:}', "");;
    Expect(1, 93071, '\p{Blk=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Blk=pahawhhmong}', "");
    Expect(0, 93071, '\P{Blk=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Blk=pahawhhmong}', "");
    Expect(0, 93072, '\p{Blk=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Blk=pahawhhmong}', "");
    Expect(1, 93072, '\P{Blk=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Blk=pahawhhmong}', "");
    Expect(1, 93071, '\p{Blk=:\Apahawhhmong\z:}', "");;
    Expect(0, 93072, '\p{Blk=:\Apahawhhmong\z:}', "");;
    Expect(1, 93071, '\p{Blk=	_pahawh_HMONG}', "");
    Expect(0, 93071, '\p{^Blk=	_pahawh_HMONG}', "");
    Expect(0, 93071, '\P{Blk=	_pahawh_HMONG}', "");
    Expect(1, 93071, '\P{^Blk=	_pahawh_HMONG}', "");
    Expect(0, 93072, '\p{Blk=	_pahawh_HMONG}', "");
    Expect(1, 93072, '\p{^Blk=	_pahawh_HMONG}', "");
    Expect(1, 93072, '\P{Blk=	_pahawh_HMONG}', "");
    Expect(0, 93072, '\P{^Blk=	_pahawh_HMONG}', "");
    Error('\p{Is_Block=	:=PAHAWH_Hmong}');
    Error('\P{Is_Block=	:=PAHAWH_Hmong}');
    Expect(1, 93071, '\p{Is_Block=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Is_Block=pahawhhmong}', "");
    Expect(0, 93071, '\P{Is_Block=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Is_Block=pahawhhmong}', "");
    Expect(0, 93072, '\p{Is_Block=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Is_Block=pahawhhmong}', "");
    Expect(1, 93072, '\P{Is_Block=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Is_Block=pahawhhmong}', "");
    Expect(1, 93071, '\p{Is_Block=_Pahawh_HMONG}', "");
    Expect(0, 93071, '\p{^Is_Block=_Pahawh_HMONG}', "");
    Expect(0, 93071, '\P{Is_Block=_Pahawh_HMONG}', "");
    Expect(1, 93071, '\P{^Is_Block=_Pahawh_HMONG}', "");
    Expect(0, 93072, '\p{Is_Block=_Pahawh_HMONG}', "");
    Expect(1, 93072, '\p{^Is_Block=_Pahawh_HMONG}', "");
    Expect(1, 93072, '\P{Is_Block=_Pahawh_HMONG}', "");
    Expect(0, 93072, '\P{^Is_Block=_Pahawh_HMONG}', "");
    Error('\p{Is_Blk=_pahawh_HMONG:=}');
    Error('\P{Is_Blk=_pahawh_HMONG:=}');
    Expect(1, 93071, '\p{Is_Blk=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Is_Blk=pahawhhmong}', "");
    Expect(0, 93071, '\P{Is_Blk=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Is_Blk=pahawhhmong}', "");
    Expect(0, 93072, '\p{Is_Blk=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Is_Blk=pahawhhmong}', "");
    Expect(1, 93072, '\P{Is_Blk=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Is_Blk=pahawhhmong}', "");
    Expect(1, 93071, '\p{Is_Blk=- Pahawh_hmong}', "");
    Expect(0, 93071, '\p{^Is_Blk=- Pahawh_hmong}', "");
    Expect(0, 93071, '\P{Is_Blk=- Pahawh_hmong}', "");
    Expect(1, 93071, '\P{^Is_Blk=- Pahawh_hmong}', "");
    Expect(0, 93072, '\p{Is_Blk=- Pahawh_hmong}', "");
    Expect(1, 93072, '\p{^Is_Blk=- Pahawh_hmong}', "");
    Expect(1, 93072, '\P{Is_Blk=- Pahawh_hmong}', "");
    Expect(0, 93072, '\P{^Is_Blk=- Pahawh_hmong}', "");
    Error('\p{Block:   :=	-Palmyrene}');
    Error('\P{Block:   :=	-Palmyrene}');
    Expect(1, 67711, '\p{Block=:\APalmyrene\z:}', "");;
    Expect(0, 67712, '\p{Block=:\APalmyrene\z:}', "");;
    Expect(1, 67711, '\p{Block: palmyrene}', "");
    Expect(0, 67711, '\p{^Block: palmyrene}', "");
    Expect(0, 67711, '\P{Block: palmyrene}', "");
    Expect(1, 67711, '\P{^Block: palmyrene}', "");
    Expect(0, 67712, '\p{Block: palmyrene}', "");
    Expect(1, 67712, '\p{^Block: palmyrene}', "");
    Expect(1, 67712, '\P{Block: palmyrene}', "");
    Expect(0, 67712, '\P{^Block: palmyrene}', "");
    Expect(1, 67711, '\p{Block=:\Apalmyrene\z:}', "");;
    Expect(0, 67712, '\p{Block=:\Apalmyrene\z:}', "");;
    Expect(1, 67711, '\p{Block=	Palmyrene}', "");
    Expect(0, 67711, '\p{^Block=	Palmyrene}', "");
    Expect(0, 67711, '\P{Block=	Palmyrene}', "");
    Expect(1, 67711, '\P{^Block=	Palmyrene}', "");
    Expect(0, 67712, '\p{Block=	Palmyrene}', "");
    Expect(1, 67712, '\p{^Block=	Palmyrene}', "");
    Expect(1, 67712, '\P{Block=	Palmyrene}', "");
    Expect(0, 67712, '\P{^Block=	Palmyrene}', "");
    Error('\p{Blk=-	PALMYRENE/a/}');
    Error('\P{Blk=-	PALMYRENE/a/}');
    Expect(1, 67711, '\p{Blk=:\APalmyrene\z:}', "");;
    Expect(0, 67712, '\p{Blk=:\APalmyrene\z:}', "");;
    Expect(1, 67711, '\p{Blk=palmyrene}', "");
    Expect(0, 67711, '\p{^Blk=palmyrene}', "");
    Expect(0, 67711, '\P{Blk=palmyrene}', "");
    Expect(1, 67711, '\P{^Blk=palmyrene}', "");
    Expect(0, 67712, '\p{Blk=palmyrene}', "");
    Expect(1, 67712, '\p{^Blk=palmyrene}', "");
    Expect(1, 67712, '\P{Blk=palmyrene}', "");
    Expect(0, 67712, '\P{^Blk=palmyrene}', "");
    Expect(1, 67711, '\p{Blk=:\Apalmyrene\z:}', "");;
    Expect(0, 67712, '\p{Blk=:\Apalmyrene\z:}', "");;
    Expect(1, 67711, '\p{Blk=_-Palmyrene}', "");
    Expect(0, 67711, '\p{^Blk=_-Palmyrene}', "");
    Expect(0, 67711, '\P{Blk=_-Palmyrene}', "");
    Expect(1, 67711, '\P{^Blk=_-Palmyrene}', "");
    Expect(0, 67712, '\p{Blk=_-Palmyrene}', "");
    Expect(1, 67712, '\p{^Blk=_-Palmyrene}', "");
    Expect(1, 67712, '\P{Blk=_-Palmyrene}', "");
    Expect(0, 67712, '\P{^Blk=_-Palmyrene}', "");
    Error('\p{Is_Block=-:=Palmyrene}');
    Error('\P{Is_Block=-:=Palmyrene}');
    Expect(1, 67711, '\p{Is_Block=palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Block=palmyrene}', "");
    Expect(0, 67711, '\P{Is_Block=palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Block=palmyrene}', "");
    Expect(0, 67712, '\p{Is_Block=palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Block=palmyrene}', "");
    Expect(1, 67712, '\P{Is_Block=palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Block=palmyrene}', "");
    Expect(1, 67711, '\p{Is_Block:	-PALMYRENE}', "");
    Expect(0, 67711, '\p{^Is_Block:	-PALMYRENE}', "");
    Expect(0, 67711, '\P{Is_Block:	-PALMYRENE}', "");
    Expect(1, 67711, '\P{^Is_Block:	-PALMYRENE}', "");
    Expect(0, 67712, '\p{Is_Block:	-PALMYRENE}', "");
    Expect(1, 67712, '\p{^Is_Block:	-PALMYRENE}', "");
    Expect(1, 67712, '\P{Is_Block:	-PALMYRENE}', "");
    Expect(0, 67712, '\P{^Is_Block:	-PALMYRENE}', "");
    Error('\p{Is_Blk=/a/palmyrene}');
    Error('\P{Is_Blk=/a/palmyrene}');
    Expect(1, 67711, '\p{Is_Blk=palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Blk=palmyrene}', "");
    Expect(0, 67711, '\P{Is_Blk=palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Blk=palmyrene}', "");
    Expect(0, 67712, '\p{Is_Blk=palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Blk=palmyrene}', "");
    Expect(1, 67712, '\P{Is_Blk=palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Blk=palmyrene}', "");
    Expect(1, 67711, '\p{Is_Blk=	-PALMYRENE}', "");
    Expect(0, 67711, '\p{^Is_Blk=	-PALMYRENE}', "");
    Expect(0, 67711, '\P{Is_Blk=	-PALMYRENE}', "");
    Expect(1, 67711, '\P{^Is_Blk=	-PALMYRENE}', "");
    Expect(0, 67712, '\p{Is_Blk=	-PALMYRENE}', "");
    Expect(1, 67712, '\p{^Is_Blk=	-PALMYRENE}', "");
    Expect(1, 67712, '\P{Is_Blk=	-PALMYRENE}', "");
    Expect(0, 67712, '\P{^Is_Blk=	-PALMYRENE}', "");
    Error('\p{Block=_:=Pau_cin_HAU}');
    Error('\P{Block=_:=Pau_cin_HAU}');
    Expect(1, 72447, '\p{Block=:\APau_Cin_Hau\z:}', "");;
    Expect(0, 72448, '\p{Block=:\APau_Cin_Hau\z:}', "");;
    Expect(1, 72447, '\p{Block=paucinhau}', "");
    Expect(0, 72447, '\p{^Block=paucinhau}', "");
    Expect(0, 72447, '\P{Block=paucinhau}', "");
    Expect(1, 72447, '\P{^Block=paucinhau}', "");
    Expect(0, 72448, '\p{Block=paucinhau}', "");
    Expect(1, 72448, '\p{^Block=paucinhau}', "");
    Expect(1, 72448, '\P{Block=paucinhau}', "");
    Expect(0, 72448, '\P{^Block=paucinhau}', "");
    Expect(1, 72447, '\p{Block=:\Apaucinhau\z:}', "");;
    Expect(0, 72448, '\p{Block=:\Apaucinhau\z:}', "");;
    Expect(1, 72447, '\p{Block=-pau_Cin_HAU}', "");
    Expect(0, 72447, '\p{^Block=-pau_Cin_HAU}', "");
    Expect(0, 72447, '\P{Block=-pau_Cin_HAU}', "");
    Expect(1, 72447, '\P{^Block=-pau_Cin_HAU}', "");
    Expect(0, 72448, '\p{Block=-pau_Cin_HAU}', "");
    Expect(1, 72448, '\p{^Block=-pau_Cin_HAU}', "");
    Expect(1, 72448, '\P{Block=-pau_Cin_HAU}', "");
    Expect(0, 72448, '\P{^Block=-pau_Cin_HAU}', "");
    Error('\p{Blk= :=Pau_Cin_hau}');
    Error('\P{Blk= :=Pau_Cin_hau}');
    Expect(1, 72447, '\p{Blk=:\APau_Cin_Hau\z:}', "");;
    Expect(0, 72448, '\p{Blk=:\APau_Cin_Hau\z:}', "");;
    Expect(1, 72447, '\p{Blk=paucinhau}', "");
    Expect(0, 72447, '\p{^Blk=paucinhau}', "");
    Expect(0, 72447, '\P{Blk=paucinhau}', "");
    Expect(1, 72447, '\P{^Blk=paucinhau}', "");
    Expect(0, 72448, '\p{Blk=paucinhau}', "");
    Expect(1, 72448, '\p{^Blk=paucinhau}', "");
    Expect(1, 72448, '\P{Blk=paucinhau}', "");
    Expect(0, 72448, '\P{^Blk=paucinhau}', "");
    Expect(1, 72447, '\p{Blk=:\Apaucinhau\z:}', "");;
    Expect(0, 72448, '\p{Blk=:\Apaucinhau\z:}', "");;
    Expect(1, 72447, '\p{Blk= _pau_CIN_Hau}', "");
    Expect(0, 72447, '\p{^Blk= _pau_CIN_Hau}', "");
    Expect(0, 72447, '\P{Blk= _pau_CIN_Hau}', "");
    Expect(1, 72447, '\P{^Blk= _pau_CIN_Hau}', "");
    Expect(0, 72448, '\p{Blk= _pau_CIN_Hau}', "");
    Expect(1, 72448, '\p{^Blk= _pau_CIN_Hau}', "");
    Expect(1, 72448, '\P{Blk= _pau_CIN_Hau}', "");
    Expect(0, 72448, '\P{^Blk= _pau_CIN_Hau}', "");
    Error('\p{Is_Block=/a/	-Pau_Cin_hau}');
    Error('\P{Is_Block=/a/	-Pau_Cin_hau}');
    Expect(1, 72447, '\p{Is_Block=paucinhau}', "");
    Expect(0, 72447, '\p{^Is_Block=paucinhau}', "");
    Expect(0, 72447, '\P{Is_Block=paucinhau}', "");
    Expect(1, 72447, '\P{^Is_Block=paucinhau}', "");
    Expect(0, 72448, '\p{Is_Block=paucinhau}', "");
    Expect(1, 72448, '\p{^Is_Block=paucinhau}', "");
    Expect(1, 72448, '\P{Is_Block=paucinhau}', "");
    Expect(0, 72448, '\P{^Is_Block=paucinhau}', "");
    Expect(1, 72447, '\p{Is_Block=	 Pau_cin_Hau}', "");
    Expect(0, 72447, '\p{^Is_Block=	 Pau_cin_Hau}', "");
    Expect(0, 72447, '\P{Is_Block=	 Pau_cin_Hau}', "");
    Expect(1, 72447, '\P{^Is_Block=	 Pau_cin_Hau}', "");
    Expect(0, 72448, '\p{Is_Block=	 Pau_cin_Hau}', "");
    Expect(1, 72448, '\p{^Is_Block=	 Pau_cin_Hau}', "");
    Expect(1, 72448, '\P{Is_Block=	 Pau_cin_Hau}', "");
    Expect(0, 72448, '\P{^Is_Block=	 Pau_cin_Hau}', "");
    Error('\p{Is_Blk=PAU_Cin_HAU/a/}');
    Error('\P{Is_Blk=PAU_Cin_HAU/a/}');
    Expect(1, 72447, '\p{Is_Blk=paucinhau}', "");
    Expect(0, 72447, '\p{^Is_Blk=paucinhau}', "");
    Expect(0, 72447, '\P{Is_Blk=paucinhau}', "");
    Expect(1, 72447, '\P{^Is_Blk=paucinhau}', "");
    Expect(0, 72448, '\p{Is_Blk=paucinhau}', "");
    Expect(1, 72448, '\p{^Is_Blk=paucinhau}', "");
    Expect(1, 72448, '\P{Is_Blk=paucinhau}', "");
    Expect(0, 72448, '\P{^Is_Blk=paucinhau}', "");
    Expect(1, 72447, '\p{Is_Blk=--Pau_CIN_Hau}', "");
    Expect(0, 72447, '\p{^Is_Blk=--Pau_CIN_Hau}', "");
    Expect(0, 72447, '\P{Is_Blk=--Pau_CIN_Hau}', "");
    Expect(1, 72447, '\P{^Is_Blk=--Pau_CIN_Hau}', "");
    Expect(0, 72448, '\p{Is_Blk=--Pau_CIN_Hau}', "");
    Expect(1, 72448, '\p{^Is_Blk=--Pau_CIN_Hau}', "");
    Expect(1, 72448, '\P{Is_Blk=--Pau_CIN_Hau}', "");
    Expect(0, 72448, '\P{^Is_Blk=--Pau_CIN_Hau}', "");
    Error('\p{Block=_	phags_Pa:=}');
    Error('\P{Block=_	phags_Pa:=}');
    Expect(1, 43135, '\p{Block=:\APhags_Pa\z:}', "");;
    Expect(0, 43136, '\p{Block=:\APhags_Pa\z:}', "");;
    Expect(1, 43135, '\p{Block=phagspa}', "");
    Expect(0, 43135, '\p{^Block=phagspa}', "");
    Expect(0, 43135, '\P{Block=phagspa}', "");
    Expect(1, 43135, '\P{^Block=phagspa}', "");
    Expect(0, 43136, '\p{Block=phagspa}', "");
    Expect(1, 43136, '\p{^Block=phagspa}', "");
    Expect(1, 43136, '\P{Block=phagspa}', "");
    Expect(0, 43136, '\P{^Block=phagspa}', "");
    Expect(1, 43135, '\p{Block=:\Aphagspa\z:}', "");;
    Expect(0, 43136, '\p{Block=:\Aphagspa\z:}', "");;
    Expect(1, 43135, '\p{Block=_-PHAGS_Pa}', "");
    Expect(0, 43135, '\p{^Block=_-PHAGS_Pa}', "");
    Expect(0, 43135, '\P{Block=_-PHAGS_Pa}', "");
    Expect(1, 43135, '\P{^Block=_-PHAGS_Pa}', "");
    Expect(0, 43136, '\p{Block=_-PHAGS_Pa}', "");
    Expect(1, 43136, '\p{^Block=_-PHAGS_Pa}', "");
    Expect(1, 43136, '\P{Block=_-PHAGS_Pa}', "");
    Expect(0, 43136, '\P{^Block=_-PHAGS_Pa}', "");
    Error('\p{Blk=/a/		PHAGS_pa}');
    Error('\P{Blk=/a/		PHAGS_pa}');
    Expect(1, 43135, '\p{Blk=:\APhags_Pa\z:}', "");;
    Expect(0, 43136, '\p{Blk=:\APhags_Pa\z:}', "");;
    Expect(1, 43135, '\p{Blk=phagspa}', "");
    Expect(0, 43135, '\p{^Blk=phagspa}', "");
    Expect(0, 43135, '\P{Blk=phagspa}', "");
    Expect(1, 43135, '\P{^Blk=phagspa}', "");
    Expect(0, 43136, '\p{Blk=phagspa}', "");
    Expect(1, 43136, '\p{^Blk=phagspa}', "");
    Expect(1, 43136, '\P{Blk=phagspa}', "");
    Expect(0, 43136, '\P{^Blk=phagspa}', "");
    Expect(1, 43135, '\p{Blk=:\Aphagspa\z:}', "");;
    Expect(0, 43136, '\p{Blk=:\Aphagspa\z:}', "");;
    Expect(1, 43135, '\p{Blk= _Phags_Pa}', "");
    Expect(0, 43135, '\p{^Blk= _Phags_Pa}', "");
    Expect(0, 43135, '\P{Blk= _Phags_Pa}', "");
    Expect(1, 43135, '\P{^Blk= _Phags_Pa}', "");
    Expect(0, 43136, '\p{Blk= _Phags_Pa}', "");
    Expect(1, 43136, '\p{^Blk= _Phags_Pa}', "");
    Expect(1, 43136, '\P{Blk= _Phags_Pa}', "");
    Expect(0, 43136, '\P{^Blk= _Phags_Pa}', "");
    Error('\p{Is_Block=-:=Phags_Pa}');
    Error('\P{Is_Block=-:=Phags_Pa}');
    Expect(1, 43135, '\p{Is_Block=phagspa}', "");
    Expect(0, 43135, '\p{^Is_Block=phagspa}', "");
    Expect(0, 43135, '\P{Is_Block=phagspa}', "");
    Expect(1, 43135, '\P{^Is_Block=phagspa}', "");
    Expect(0, 43136, '\p{Is_Block=phagspa}', "");
    Expect(1, 43136, '\p{^Is_Block=phagspa}', "");
    Expect(1, 43136, '\P{Is_Block=phagspa}', "");
    Expect(0, 43136, '\P{^Is_Block=phagspa}', "");
    Expect(1, 43135, '\p{Is_Block=_phags_Pa}', "");
    Expect(0, 43135, '\p{^Is_Block=_phags_Pa}', "");
    Expect(0, 43135, '\P{Is_Block=_phags_Pa}', "");
    Expect(1, 43135, '\P{^Is_Block=_phags_Pa}', "");
    Expect(0, 43136, '\p{Is_Block=_phags_Pa}', "");
    Expect(1, 43136, '\p{^Is_Block=_phags_Pa}', "");
    Expect(1, 43136, '\P{Is_Block=_phags_Pa}', "");
    Expect(0, 43136, '\P{^Is_Block=_phags_Pa}', "");
    Error('\p{Is_Blk=/a/ PHAGS_PA}');
    Error('\P{Is_Blk=/a/ PHAGS_PA}');
    Expect(1, 43135, '\p{Is_Blk=phagspa}', "");
    Expect(0, 43135, '\p{^Is_Blk=phagspa}', "");
    Expect(0, 43135, '\P{Is_Blk=phagspa}', "");
    Expect(1, 43135, '\P{^Is_Blk=phagspa}', "");
    Expect(0, 43136, '\p{Is_Blk=phagspa}', "");
    Expect(1, 43136, '\p{^Is_Blk=phagspa}', "");
    Expect(1, 43136, '\P{Is_Blk=phagspa}', "");
    Expect(0, 43136, '\P{^Is_Blk=phagspa}', "");
    Expect(1, 43135, '\p{Is_Blk=- Phags_Pa}', "");
    Expect(0, 43135, '\p{^Is_Blk=- Phags_Pa}', "");
    Expect(0, 43135, '\P{Is_Blk=- Phags_Pa}', "");
    Expect(1, 43135, '\P{^Is_Blk=- Phags_Pa}', "");
    Expect(0, 43136, '\p{Is_Blk=- Phags_Pa}', "");
    Expect(1, 43136, '\p{^Is_Blk=- Phags_Pa}', "");
    Expect(1, 43136, '\P{Is_Blk=- Phags_Pa}', "");
    Expect(0, 43136, '\P{^Is_Blk=- Phags_Pa}', "");
    Error('\p{Block=:= phaistos_DISC}');
    Error('\P{Block=:= phaistos_DISC}');
    Expect(1, 66047, '\p{Block=:\APhaistos_Disc\z:}', "");;
    Expect(0, 66048, '\p{Block=:\APhaistos_Disc\z:}', "");;
    Expect(1, 66047, '\p{Block=phaistosdisc}', "");
    Expect(0, 66047, '\p{^Block=phaistosdisc}', "");
    Expect(0, 66047, '\P{Block=phaistosdisc}', "");
    Expect(1, 66047, '\P{^Block=phaistosdisc}', "");
    Expect(0, 66048, '\p{Block=phaistosdisc}', "");
    Expect(1, 66048, '\p{^Block=phaistosdisc}', "");
    Expect(1, 66048, '\P{Block=phaistosdisc}', "");
    Expect(0, 66048, '\P{^Block=phaistosdisc}', "");
    Expect(1, 66047, '\p{Block=:\Aphaistosdisc\z:}', "");;
    Expect(0, 66048, '\p{Block=:\Aphaistosdisc\z:}', "");;
    Expect(1, 66047, '\p{Block=--phaistos_Disc}', "");
    Expect(0, 66047, '\p{^Block=--phaistos_Disc}', "");
    Expect(0, 66047, '\P{Block=--phaistos_Disc}', "");
    Expect(1, 66047, '\P{^Block=--phaistos_Disc}', "");
    Expect(0, 66048, '\p{Block=--phaistos_Disc}', "");
    Expect(1, 66048, '\p{^Block=--phaistos_Disc}', "");
    Expect(1, 66048, '\P{Block=--phaistos_Disc}', "");
    Expect(0, 66048, '\P{^Block=--phaistos_Disc}', "");
    Error('\p{Blk=/a/PHAISTOS}');
    Error('\P{Blk=/a/PHAISTOS}');
    Expect(1, 66047, '\p{Blk=:\APhaistos\z:}', "");;
    Expect(0, 66048, '\p{Blk=:\APhaistos\z:}', "");;
    Expect(1, 66047, '\p{Blk=phaistos}', "");
    Expect(0, 66047, '\p{^Blk=phaistos}', "");
    Expect(0, 66047, '\P{Blk=phaistos}', "");
    Expect(1, 66047, '\P{^Blk=phaistos}', "");
    Expect(0, 66048, '\p{Blk=phaistos}', "");
    Expect(1, 66048, '\p{^Blk=phaistos}', "");
    Expect(1, 66048, '\P{Blk=phaistos}', "");
    Expect(0, 66048, '\P{^Blk=phaistos}', "");
    Expect(1, 66047, '\p{Blk=:\Aphaistos\z:}', "");;
    Expect(0, 66048, '\p{Blk=:\Aphaistos\z:}', "");;
    Expect(1, 66047, '\p{Blk=-Phaistos}', "");
    Expect(0, 66047, '\p{^Blk=-Phaistos}', "");
    Expect(0, 66047, '\P{Blk=-Phaistos}', "");
    Expect(1, 66047, '\P{^Blk=-Phaistos}', "");
    Expect(0, 66048, '\p{Blk=-Phaistos}', "");
    Expect(1, 66048, '\p{^Blk=-Phaistos}', "");
    Expect(1, 66048, '\P{Blk=-Phaistos}', "");
    Expect(0, 66048, '\P{^Blk=-Phaistos}', "");
    Error('\p{Is_Block=		Phaistos_Disc/a/}');
    Error('\P{Is_Block=		Phaistos_Disc/a/}');
    Expect(1, 66047, '\p{Is_Block=phaistosdisc}', "");
    Expect(0, 66047, '\p{^Is_Block=phaistosdisc}', "");
    Expect(0, 66047, '\P{Is_Block=phaistosdisc}', "");
    Expect(1, 66047, '\P{^Is_Block=phaistosdisc}', "");
    Expect(0, 66048, '\p{Is_Block=phaistosdisc}', "");
    Expect(1, 66048, '\p{^Is_Block=phaistosdisc}', "");
    Expect(1, 66048, '\P{Is_Block=phaistosdisc}', "");
    Expect(0, 66048, '\P{^Is_Block=phaistosdisc}', "");
    Expect(1, 66047, '\p{Is_Block= phaistos_Disc}', "");
    Expect(0, 66047, '\p{^Is_Block= phaistos_Disc}', "");
    Expect(0, 66047, '\P{Is_Block= phaistos_Disc}', "");
    Expect(1, 66047, '\P{^Is_Block= phaistos_Disc}', "");
    Expect(0, 66048, '\p{Is_Block= phaistos_Disc}', "");
    Expect(1, 66048, '\p{^Is_Block= phaistos_Disc}', "");
    Expect(1, 66048, '\P{Is_Block= phaistos_Disc}', "");
    Expect(0, 66048, '\P{^Is_Block= phaistos_Disc}', "");
    Error('\p{Is_Blk=_	phaistos:=}');
    Error('\P{Is_Blk=_	phaistos:=}');
    Expect(1, 66047, '\p{Is_Blk=phaistos}', "");
    Expect(0, 66047, '\p{^Is_Blk=phaistos}', "");
    Expect(0, 66047, '\P{Is_Blk=phaistos}', "");
    Expect(1, 66047, '\P{^Is_Blk=phaistos}', "");
    Expect(0, 66048, '\p{Is_Blk=phaistos}', "");
    Expect(1, 66048, '\p{^Is_Blk=phaistos}', "");
    Expect(1, 66048, '\P{Is_Blk=phaistos}', "");
    Expect(0, 66048, '\P{^Is_Blk=phaistos}', "");
    Expect(1, 66047, '\p{Is_Blk=-Phaistos}', "");
    Expect(0, 66047, '\p{^Is_Blk=-Phaistos}', "");
    Expect(0, 66047, '\P{Is_Blk=-Phaistos}', "");
    Expect(1, 66047, '\P{^Is_Blk=-Phaistos}', "");
    Expect(0, 66048, '\p{Is_Blk=-Phaistos}', "");
    Expect(1, 66048, '\p{^Is_Blk=-Phaistos}', "");
    Expect(1, 66048, '\P{Is_Blk=-Phaistos}', "");
    Expect(0, 66048, '\P{^Is_Blk=-Phaistos}', "");
    Error('\p{Block=:= phoenician}');
    Error('\P{Block=:= phoenician}');
    Expect(1, 67871, '\p{Block=:\APhoenician\z:}', "");;
    Expect(0, 67872, '\p{Block=:\APhoenician\z:}', "");;
    Expect(1, 67871, '\p{Block=phoenician}', "");
    Expect(0, 67871, '\p{^Block=phoenician}', "");
    Expect(0, 67871, '\P{Block=phoenician}', "");
    Expect(1, 67871, '\P{^Block=phoenician}', "");
    Expect(0, 67872, '\p{Block=phoenician}', "");
    Expect(1, 67872, '\p{^Block=phoenician}', "");
    Expect(1, 67872, '\P{Block=phoenician}', "");
    Expect(0, 67872, '\P{^Block=phoenician}', "");
    Expect(1, 67871, '\p{Block=:\Aphoenician\z:}', "");;
    Expect(0, 67872, '\p{Block=:\Aphoenician\z:}', "");;
    Expect(1, 67871, '\p{Block=_	Phoenician}', "");
    Expect(0, 67871, '\p{^Block=_	Phoenician}', "");
    Expect(0, 67871, '\P{Block=_	Phoenician}', "");
    Expect(1, 67871, '\P{^Block=_	Phoenician}', "");
    Expect(0, 67872, '\p{Block=_	Phoenician}', "");
    Expect(1, 67872, '\p{^Block=_	Phoenician}', "");
    Expect(1, 67872, '\P{Block=_	Phoenician}', "");
    Expect(0, 67872, '\P{^Block=_	Phoenician}', "");
    Error('\p{Blk=/a/	_Phoenician}');
    Error('\P{Blk=/a/	_Phoenician}');
    Expect(1, 67871, '\p{Blk=:\APhoenician\z:}', "");;
    Expect(0, 67872, '\p{Blk=:\APhoenician\z:}', "");;
    Expect(1, 67871, '\p{Blk:phoenician}', "");
    Expect(0, 67871, '\p{^Blk:phoenician}', "");
    Expect(0, 67871, '\P{Blk:phoenician}', "");
    Expect(1, 67871, '\P{^Blk:phoenician}', "");
    Expect(0, 67872, '\p{Blk:phoenician}', "");
    Expect(1, 67872, '\p{^Blk:phoenician}', "");
    Expect(1, 67872, '\P{Blk:phoenician}', "");
    Expect(0, 67872, '\P{^Blk:phoenician}', "");
    Expect(1, 67871, '\p{Blk=:\Aphoenician\z:}', "");;
    Expect(0, 67872, '\p{Blk=:\Aphoenician\z:}', "");;
    Expect(1, 67871, '\p{Blk=-	Phoenician}', "");
    Expect(0, 67871, '\p{^Blk=-	Phoenician}', "");
    Expect(0, 67871, '\P{Blk=-	Phoenician}', "");
    Expect(1, 67871, '\P{^Blk=-	Phoenician}', "");
    Expect(0, 67872, '\p{Blk=-	Phoenician}', "");
    Expect(1, 67872, '\p{^Blk=-	Phoenician}', "");
    Expect(1, 67872, '\P{Blk=-	Phoenician}', "");
    Expect(0, 67872, '\P{^Blk=-	Phoenician}', "");
    Error('\p{Is_Block=/a/- Phoenician}');
    Error('\P{Is_Block=/a/- Phoenician}');
    Expect(1, 67871, '\p{Is_Block=phoenician}', "");
    Expect(0, 67871, '\p{^Is_Block=phoenician}', "");
    Expect(0, 67871, '\P{Is_Block=phoenician}', "");
    Expect(1, 67871, '\P{^Is_Block=phoenician}', "");
    Expect(0, 67872, '\p{Is_Block=phoenician}', "");
    Expect(1, 67872, '\p{^Is_Block=phoenician}', "");
    Expect(1, 67872, '\P{Is_Block=phoenician}', "");
    Expect(0, 67872, '\P{^Is_Block=phoenician}', "");
    Expect(1, 67871, '\p{Is_Block=	 phoenician}', "");
    Expect(0, 67871, '\p{^Is_Block=	 phoenician}', "");
    Expect(0, 67871, '\P{Is_Block=	 phoenician}', "");
    Expect(1, 67871, '\P{^Is_Block=	 phoenician}', "");
    Expect(0, 67872, '\p{Is_Block=	 phoenician}', "");
    Expect(1, 67872, '\p{^Is_Block=	 phoenician}', "");
    Expect(1, 67872, '\P{Is_Block=	 phoenician}', "");
    Expect(0, 67872, '\P{^Is_Block=	 phoenician}', "");
    Error('\p{Is_Blk=	Phoenician/a/}');
    Error('\P{Is_Blk=	Phoenician/a/}');
    Expect(1, 67871, '\p{Is_Blk=phoenician}', "");
    Expect(0, 67871, '\p{^Is_Blk=phoenician}', "");
    Expect(0, 67871, '\P{Is_Blk=phoenician}', "");
    Expect(1, 67871, '\P{^Is_Blk=phoenician}', "");
    Expect(0, 67872, '\p{Is_Blk=phoenician}', "");
    Expect(1, 67872, '\p{^Is_Blk=phoenician}', "");
    Expect(1, 67872, '\P{Is_Blk=phoenician}', "");
    Expect(0, 67872, '\P{^Is_Blk=phoenician}', "");
    Expect(1, 67871, '\p{Is_Blk: 	-Phoenician}', "");
    Expect(0, 67871, '\p{^Is_Blk: 	-Phoenician}', "");
    Expect(0, 67871, '\P{Is_Blk: 	-Phoenician}', "");
    Expect(1, 67871, '\P{^Is_Blk: 	-Phoenician}', "");
    Expect(0, 67872, '\p{Is_Blk: 	-Phoenician}', "");
    Expect(1, 67872, '\p{^Is_Blk: 	-Phoenician}', "");
    Expect(1, 67872, '\P{Is_Blk: 	-Phoenician}', "");
    Expect(0, 67872, '\P{^Is_Blk: 	-Phoenician}', "");
    Error('\p{Block=:= _Phonetic_extensions}');
    Error('\P{Block=:= _Phonetic_extensions}');
    Expect(1, 7551, '\p{Block=:\APhonetic_Extensions\z:}', "");;
    Expect(0, 7552, '\p{Block=:\APhonetic_Extensions\z:}', "");;
    Expect(1, 7551, '\p{Block=phoneticextensions}', "");
    Expect(0, 7551, '\p{^Block=phoneticextensions}', "");
    Expect(0, 7551, '\P{Block=phoneticextensions}', "");
    Expect(1, 7551, '\P{^Block=phoneticextensions}', "");
    Expect(0, 7552, '\p{Block=phoneticextensions}', "");
    Expect(1, 7552, '\p{^Block=phoneticextensions}', "");
    Expect(1, 7552, '\P{Block=phoneticextensions}', "");
    Expect(0, 7552, '\P{^Block=phoneticextensions}', "");
    Expect(1, 7551, '\p{Block=:\Aphoneticextensions\z:}', "");;
    Expect(0, 7552, '\p{Block=:\Aphoneticextensions\z:}', "");;
    Expect(1, 7551, '\p{Block=_	Phonetic_Extensions}', "");
    Expect(0, 7551, '\p{^Block=_	Phonetic_Extensions}', "");
    Expect(0, 7551, '\P{Block=_	Phonetic_Extensions}', "");
    Expect(1, 7551, '\P{^Block=_	Phonetic_Extensions}', "");
    Expect(0, 7552, '\p{Block=_	Phonetic_Extensions}', "");
    Expect(1, 7552, '\p{^Block=_	Phonetic_Extensions}', "");
    Expect(1, 7552, '\P{Block=_	Phonetic_Extensions}', "");
    Expect(0, 7552, '\P{^Block=_	Phonetic_Extensions}', "");
    Error('\p{Blk=	/a/PHONETIC_EXT}');
    Error('\P{Blk=	/a/PHONETIC_EXT}');
    Expect(1, 7551, '\p{Blk=:\APhonetic_Ext\z:}', "");;
    Expect(0, 7552, '\p{Blk=:\APhonetic_Ext\z:}', "");;
    Expect(1, 7551, '\p{Blk=phoneticext}', "");
    Expect(0, 7551, '\p{^Blk=phoneticext}', "");
    Expect(0, 7551, '\P{Blk=phoneticext}', "");
    Expect(1, 7551, '\P{^Blk=phoneticext}', "");
    Expect(0, 7552, '\p{Blk=phoneticext}', "");
    Expect(1, 7552, '\p{^Blk=phoneticext}', "");
    Expect(1, 7552, '\P{Blk=phoneticext}', "");
    Expect(0, 7552, '\P{^Blk=phoneticext}', "");
    Expect(1, 7551, '\p{Blk=:\Aphoneticext\z:}', "");;
    Expect(0, 7552, '\p{Blk=:\Aphoneticext\z:}', "");;
    Expect(1, 7551, '\p{Blk=  phonetic_ext}', "");
    Expect(0, 7551, '\p{^Blk=  phonetic_ext}', "");
    Expect(0, 7551, '\P{Blk=  phonetic_ext}', "");
    Expect(1, 7551, '\P{^Blk=  phonetic_ext}', "");
    Expect(0, 7552, '\p{Blk=  phonetic_ext}', "");
    Expect(1, 7552, '\p{^Blk=  phonetic_ext}', "");
    Expect(1, 7552, '\P{Blk=  phonetic_ext}', "");
    Expect(0, 7552, '\P{^Blk=  phonetic_ext}', "");
    Error('\p{Is_Block=-:=phonetic_Extensions}');
    Error('\P{Is_Block=-:=phonetic_Extensions}');
    Expect(1, 7551, '\p{Is_Block=phoneticextensions}', "");
    Expect(0, 7551, '\p{^Is_Block=phoneticextensions}', "");
    Expect(0, 7551, '\P{Is_Block=phoneticextensions}', "");
    Expect(1, 7551, '\P{^Is_Block=phoneticextensions}', "");
    Expect(0, 7552, '\p{Is_Block=phoneticextensions}', "");
    Expect(1, 7552, '\p{^Is_Block=phoneticextensions}', "");
    Expect(1, 7552, '\P{Is_Block=phoneticextensions}', "");
    Expect(0, 7552, '\P{^Is_Block=phoneticextensions}', "");
    Expect(1, 7551, '\p{Is_Block=	 PHONETIC_Extensions}', "");
    Expect(0, 7551, '\p{^Is_Block=	 PHONETIC_Extensions}', "");
    Expect(0, 7551, '\P{Is_Block=	 PHONETIC_Extensions}', "");
    Expect(1, 7551, '\P{^Is_Block=	 PHONETIC_Extensions}', "");
    Expect(0, 7552, '\p{Is_Block=	 PHONETIC_Extensions}', "");
    Expect(1, 7552, '\p{^Is_Block=	 PHONETIC_Extensions}', "");
    Expect(1, 7552, '\P{Is_Block=	 PHONETIC_Extensions}', "");
    Expect(0, 7552, '\P{^Is_Block=	 PHONETIC_Extensions}', "");
    Error('\p{Is_Blk=:=_-phonetic_Ext}');
    Error('\P{Is_Blk=:=_-phonetic_Ext}');
    Expect(1, 7551, '\p{Is_Blk=phoneticext}', "");
    Expect(0, 7551, '\p{^Is_Blk=phoneticext}', "");
    Expect(0, 7551, '\P{Is_Blk=phoneticext}', "");
    Expect(1, 7551, '\P{^Is_Blk=phoneticext}', "");
    Expect(0, 7552, '\p{Is_Blk=phoneticext}', "");
    Expect(1, 7552, '\p{^Is_Blk=phoneticext}', "");
    Expect(1, 7552, '\P{Is_Blk=phoneticext}', "");
    Expect(0, 7552, '\P{^Is_Blk=phoneticext}', "");
    Expect(1, 7551, '\p{Is_Blk=	_Phonetic_ext}', "");
    Expect(0, 7551, '\p{^Is_Blk=	_Phonetic_ext}', "");
    Expect(0, 7551, '\P{Is_Blk=	_Phonetic_ext}', "");
    Expect(1, 7551, '\P{^Is_Blk=	_Phonetic_ext}', "");
    Expect(0, 7552, '\p{Is_Blk=	_Phonetic_ext}', "");
    Expect(1, 7552, '\p{^Is_Blk=	_Phonetic_ext}', "");
    Expect(1, 7552, '\P{Is_Blk=	_Phonetic_ext}', "");
    Expect(0, 7552, '\P{^Is_Blk=	_Phonetic_ext}', "");
    Error('\p{Block:	:=	_phonetic_Extensions_Supplement}');
    Error('\P{Block:	:=	_phonetic_Extensions_Supplement}');
    Expect(1, 7615, '\p{Block=:\APhonetic_Extensions_Supplement\z:}', "");;
    Expect(0, 7616, '\p{Block=:\APhonetic_Extensions_Supplement\z:}', "");;
    Expect(1, 7615, '\p{Block=phoneticextensionssupplement}', "");
    Expect(0, 7615, '\p{^Block=phoneticextensionssupplement}', "");
    Expect(0, 7615, '\P{Block=phoneticextensionssupplement}', "");
    Expect(1, 7615, '\P{^Block=phoneticextensionssupplement}', "");
    Expect(0, 7616, '\p{Block=phoneticextensionssupplement}', "");
    Expect(1, 7616, '\p{^Block=phoneticextensionssupplement}', "");
    Expect(1, 7616, '\P{Block=phoneticextensionssupplement}', "");
    Expect(0, 7616, '\P{^Block=phoneticextensionssupplement}', "");
    Expect(1, 7615, '\p{Block=:\Aphoneticextensionssupplement\z:}', "");;
    Expect(0, 7616, '\p{Block=:\Aphoneticextensionssupplement\z:}', "");;
    Expect(1, 7615, '\p{Block= PHONETIC_EXTENSIONS_supplement}', "");
    Expect(0, 7615, '\p{^Block= PHONETIC_EXTENSIONS_supplement}', "");
    Expect(0, 7615, '\P{Block= PHONETIC_EXTENSIONS_supplement}', "");
    Expect(1, 7615, '\P{^Block= PHONETIC_EXTENSIONS_supplement}', "");
    Expect(0, 7616, '\p{Block= PHONETIC_EXTENSIONS_supplement}', "");
    Expect(1, 7616, '\p{^Block= PHONETIC_EXTENSIONS_supplement}', "");
    Expect(1, 7616, '\P{Block= PHONETIC_EXTENSIONS_supplement}', "");
    Expect(0, 7616, '\P{^Block= PHONETIC_EXTENSIONS_supplement}', "");
    Error('\p{Blk= -phonetic_Ext_sup:=}');
    Error('\P{Blk= -phonetic_Ext_sup:=}');
    Expect(1, 7615, '\p{Blk=:\APhonetic_Ext_Sup\z:}', "");;
    Expect(0, 7616, '\p{Blk=:\APhonetic_Ext_Sup\z:}', "");;
    Expect(1, 7615, '\p{Blk=phoneticextsup}', "");
    Expect(0, 7615, '\p{^Blk=phoneticextsup}', "");
    Expect(0, 7615, '\P{Blk=phoneticextsup}', "");
    Expect(1, 7615, '\P{^Blk=phoneticextsup}', "");
    Expect(0, 7616, '\p{Blk=phoneticextsup}', "");
    Expect(1, 7616, '\p{^Blk=phoneticextsup}', "");
    Expect(1, 7616, '\P{Blk=phoneticextsup}', "");
    Expect(0, 7616, '\P{^Blk=phoneticextsup}', "");
    Expect(1, 7615, '\p{Blk=:\Aphoneticextsup\z:}', "");;
    Expect(0, 7616, '\p{Blk=:\Aphoneticextsup\z:}', "");;
    Expect(1, 7615, '\p{Blk=Phonetic_Ext_Sup}', "");
    Expect(0, 7615, '\p{^Blk=Phonetic_Ext_Sup}', "");
    Expect(0, 7615, '\P{Blk=Phonetic_Ext_Sup}', "");
    Expect(1, 7615, '\P{^Blk=Phonetic_Ext_Sup}', "");
    Expect(0, 7616, '\p{Blk=Phonetic_Ext_Sup}', "");
    Expect(1, 7616, '\p{^Blk=Phonetic_Ext_Sup}', "");
    Expect(1, 7616, '\P{Blk=Phonetic_Ext_Sup}', "");
    Expect(0, 7616, '\P{^Blk=Phonetic_Ext_Sup}', "");
    Error('\p{Is_Block=/a/__Phonetic_Extensions_SUPPLEMENT}');
    Error('\P{Is_Block=/a/__Phonetic_Extensions_SUPPLEMENT}');
    Expect(1, 7615, '\p{Is_Block:   phoneticextensionssupplement}', "");
    Expect(0, 7615, '\p{^Is_Block:   phoneticextensionssupplement}', "");
    Expect(0, 7615, '\P{Is_Block:   phoneticextensionssupplement}', "");
    Expect(1, 7615, '\P{^Is_Block:   phoneticextensionssupplement}', "");
    Expect(0, 7616, '\p{Is_Block:   phoneticextensionssupplement}', "");
    Expect(1, 7616, '\p{^Is_Block:   phoneticextensionssupplement}', "");
    Expect(1, 7616, '\P{Is_Block:   phoneticextensionssupplement}', "");
    Expect(0, 7616, '\P{^Is_Block:   phoneticextensionssupplement}', "");
    Expect(1, 7615, '\p{Is_Block=_	phonetic_Extensions_supplement}', "");
    Expect(0, 7615, '\p{^Is_Block=_	phonetic_Extensions_supplement}', "");
    Expect(0, 7615, '\P{Is_Block=_	phonetic_Extensions_supplement}', "");
    Expect(1, 7615, '\P{^Is_Block=_	phonetic_Extensions_supplement}', "");
    Expect(0, 7616, '\p{Is_Block=_	phonetic_Extensions_supplement}', "");
    Expect(1, 7616, '\p{^Is_Block=_	phonetic_Extensions_supplement}', "");
    Expect(1, 7616, '\P{Is_Block=_	phonetic_Extensions_supplement}', "");
    Expect(0, 7616, '\P{^Is_Block=_	phonetic_Extensions_supplement}', "");
    Error('\p{Is_Blk=/a/	_phonetic_EXT_sup}');
    Error('\P{Is_Blk=/a/	_phonetic_EXT_sup}');
    Expect(1, 7615, '\p{Is_Blk=phoneticextsup}', "");
    Expect(0, 7615, '\p{^Is_Blk=phoneticextsup}', "");
    Expect(0, 7615, '\P{Is_Blk=phoneticextsup}', "");
    Expect(1, 7615, '\P{^Is_Blk=phoneticextsup}', "");
    Expect(0, 7616, '\p{Is_Blk=phoneticextsup}', "");
    Expect(1, 7616, '\p{^Is_Blk=phoneticextsup}', "");
    Expect(1, 7616, '\P{Is_Blk=phoneticextsup}', "");
    Expect(0, 7616, '\P{^Is_Blk=phoneticextsup}', "");
    Expect(1, 7615, '\p{Is_Blk=	phonetic_ext_sup}', "");
    Expect(0, 7615, '\p{^Is_Blk=	phonetic_ext_sup}', "");
    Expect(0, 7615, '\P{Is_Blk=	phonetic_ext_sup}', "");
    Expect(1, 7615, '\P{^Is_Blk=	phonetic_ext_sup}', "");
    Expect(0, 7616, '\p{Is_Blk=	phonetic_ext_sup}', "");
    Expect(1, 7616, '\p{^Is_Blk=	phonetic_ext_sup}', "");
    Expect(1, 7616, '\P{Is_Blk=	phonetic_ext_sup}', "");
    Expect(0, 7616, '\P{^Is_Blk=	phonetic_ext_sup}', "");
    Error('\p{Block=-/a/playing_CARDS}');
    Error('\P{Block=-/a/playing_CARDS}');
    Expect(1, 127231, '\p{Block=:\APlaying_Cards\z:}', "");;
    Expect(0, 127232, '\p{Block=:\APlaying_Cards\z:}', "");;
    Expect(1, 127231, '\p{Block=playingcards}', "");
    Expect(0, 127231, '\p{^Block=playingcards}', "");
    Expect(0, 127231, '\P{Block=playingcards}', "");
    Expect(1, 127231, '\P{^Block=playingcards}', "");
    Expect(0, 127232, '\p{Block=playingcards}', "");
    Expect(1, 127232, '\p{^Block=playingcards}', "");
    Expect(1, 127232, '\P{Block=playingcards}', "");
    Expect(0, 127232, '\P{^Block=playingcards}', "");
    Expect(1, 127231, '\p{Block=:\Aplayingcards\z:}', "");;
    Expect(0, 127232, '\p{Block=:\Aplayingcards\z:}', "");;
    Expect(1, 127231, '\p{Block=	 Playing_CARDS}', "");
    Expect(0, 127231, '\p{^Block=	 Playing_CARDS}', "");
    Expect(0, 127231, '\P{Block=	 Playing_CARDS}', "");
    Expect(1, 127231, '\P{^Block=	 Playing_CARDS}', "");
    Expect(0, 127232, '\p{Block=	 Playing_CARDS}', "");
    Expect(1, 127232, '\p{^Block=	 Playing_CARDS}', "");
    Expect(1, 127232, '\P{Block=	 Playing_CARDS}', "");
    Expect(0, 127232, '\P{^Block=	 Playing_CARDS}', "");
    Error('\p{Blk=/a/		Playing_Cards}');
    Error('\P{Blk=/a/		Playing_Cards}');
    Expect(1, 127231, '\p{Blk=:\APlaying_Cards\z:}', "");;
    Expect(0, 127232, '\p{Blk=:\APlaying_Cards\z:}', "");;
    Expect(1, 127231, '\p{Blk=playingcards}', "");
    Expect(0, 127231, '\p{^Blk=playingcards}', "");
    Expect(0, 127231, '\P{Blk=playingcards}', "");
    Expect(1, 127231, '\P{^Blk=playingcards}', "");
    Expect(0, 127232, '\p{Blk=playingcards}', "");
    Expect(1, 127232, '\p{^Blk=playingcards}', "");
    Expect(1, 127232, '\P{Blk=playingcards}', "");
    Expect(0, 127232, '\P{^Blk=playingcards}', "");
    Expect(1, 127231, '\p{Blk=:\Aplayingcards\z:}', "");;
    Expect(0, 127232, '\p{Blk=:\Aplayingcards\z:}', "");;
    Expect(1, 127231, '\p{Blk=-_Playing_cards}', "");
    Expect(0, 127231, '\p{^Blk=-_Playing_cards}', "");
    Expect(0, 127231, '\P{Blk=-_Playing_cards}', "");
    Expect(1, 127231, '\P{^Blk=-_Playing_cards}', "");
    Expect(0, 127232, '\p{Blk=-_Playing_cards}', "");
    Expect(1, 127232, '\p{^Blk=-_Playing_cards}', "");
    Expect(1, 127232, '\P{Blk=-_Playing_cards}', "");
    Expect(0, 127232, '\P{^Blk=-_Playing_cards}', "");
    Error('\p{Is_Block=/a/	-Playing_cards}');
    Error('\P{Is_Block=/a/	-Playing_cards}');
    Expect(1, 127231, '\p{Is_Block=playingcards}', "");
    Expect(0, 127231, '\p{^Is_Block=playingcards}', "");
    Expect(0, 127231, '\P{Is_Block=playingcards}', "");
    Expect(1, 127231, '\P{^Is_Block=playingcards}', "");
    Expect(0, 127232, '\p{Is_Block=playingcards}', "");
    Expect(1, 127232, '\p{^Is_Block=playingcards}', "");
    Expect(1, 127232, '\P{Is_Block=playingcards}', "");
    Expect(0, 127232, '\P{^Is_Block=playingcards}', "");
    Expect(1, 127231, '\p{Is_Block=-Playing_cards}', "");
    Expect(0, 127231, '\p{^Is_Block=-Playing_cards}', "");
    Expect(0, 127231, '\P{Is_Block=-Playing_cards}', "");
    Expect(1, 127231, '\P{^Is_Block=-Playing_cards}', "");
    Expect(0, 127232, '\p{Is_Block=-Playing_cards}', "");
    Expect(1, 127232, '\p{^Is_Block=-Playing_cards}', "");
    Expect(1, 127232, '\P{Is_Block=-Playing_cards}', "");
    Expect(0, 127232, '\P{^Is_Block=-Playing_cards}', "");
    Error('\p{Is_Blk:  :=Playing_Cards}');
    Error('\P{Is_Blk:  :=Playing_Cards}');
    Expect(1, 127231, '\p{Is_Blk=playingcards}', "");
    Expect(0, 127231, '\p{^Is_Blk=playingcards}', "");
    Expect(0, 127231, '\P{Is_Blk=playingcards}', "");
    Expect(1, 127231, '\P{^Is_Blk=playingcards}', "");
    Expect(0, 127232, '\p{Is_Blk=playingcards}', "");
    Expect(1, 127232, '\p{^Is_Blk=playingcards}', "");
    Expect(1, 127232, '\P{Is_Blk=playingcards}', "");
    Expect(0, 127232, '\P{^Is_Blk=playingcards}', "");
    Expect(1, 127231, '\p{Is_Blk: 	playing_Cards}', "");
    Expect(0, 127231, '\p{^Is_Blk: 	playing_Cards}', "");
    Expect(0, 127231, '\P{Is_Blk: 	playing_Cards}', "");
    Expect(1, 127231, '\P{^Is_Blk: 	playing_Cards}', "");
    Expect(0, 127232, '\p{Is_Blk: 	playing_Cards}', "");
    Expect(1, 127232, '\p{^Is_Blk: 	playing_Cards}', "");
    Expect(1, 127232, '\P{Is_Blk: 	playing_Cards}', "");
    Expect(0, 127232, '\P{^Is_Blk: 	playing_Cards}', "");
    Error('\p{Block:   _Psalter_Pahlavi/a/}');
    Error('\P{Block:   _Psalter_Pahlavi/a/}');
    Expect(1, 68527, '\p{Block=:\APsalter_Pahlavi\z:}', "");;
    Expect(0, 68528, '\p{Block=:\APsalter_Pahlavi\z:}', "");;
    Expect(1, 68527, '\p{Block=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Block=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Block=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Block=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Block=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Block=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Block=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Block=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Block=:\Apsalterpahlavi\z:}', "");;
    Expect(0, 68528, '\p{Block=:\Apsalterpahlavi\z:}', "");;
    Expect(1, 68527, '\p{Block=	 PSALTER_pahlavi}', "");
    Expect(0, 68527, '\p{^Block=	 PSALTER_pahlavi}', "");
    Expect(0, 68527, '\P{Block=	 PSALTER_pahlavi}', "");
    Expect(1, 68527, '\P{^Block=	 PSALTER_pahlavi}', "");
    Expect(0, 68528, '\p{Block=	 PSALTER_pahlavi}', "");
    Expect(1, 68528, '\p{^Block=	 PSALTER_pahlavi}', "");
    Expect(1, 68528, '\P{Block=	 PSALTER_pahlavi}', "");
    Expect(0, 68528, '\P{^Block=	 PSALTER_pahlavi}', "");
    Error('\p{Blk=_:=Psalter_PAHLAVI}');
    Error('\P{Blk=_:=Psalter_PAHLAVI}');
    Expect(1, 68527, '\p{Blk=:\APsalter_Pahlavi\z:}', "");;
    Expect(0, 68528, '\p{Blk=:\APsalter_Pahlavi\z:}', "");;
    Expect(1, 68527, '\p{Blk=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Blk=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Blk=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Blk=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Blk=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Blk=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Blk=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Blk=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Blk=:\Apsalterpahlavi\z:}', "");;
    Expect(0, 68528, '\p{Blk=:\Apsalterpahlavi\z:}', "");;
    Expect(1, 68527, '\p{Blk=  PSALTER_Pahlavi}', "");
    Expect(0, 68527, '\p{^Blk=  PSALTER_Pahlavi}', "");
    Expect(0, 68527, '\P{Blk=  PSALTER_Pahlavi}', "");
    Expect(1, 68527, '\P{^Blk=  PSALTER_Pahlavi}', "");
    Expect(0, 68528, '\p{Blk=  PSALTER_Pahlavi}', "");
    Expect(1, 68528, '\p{^Blk=  PSALTER_Pahlavi}', "");
    Expect(1, 68528, '\P{Blk=  PSALTER_Pahlavi}', "");
    Expect(0, 68528, '\P{^Blk=  PSALTER_Pahlavi}', "");
    Error('\p{Is_Block=:=_Psalter_PAHLAVI}');
    Error('\P{Is_Block=:=_Psalter_PAHLAVI}');
    Expect(1, 68527, '\p{Is_Block=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Is_Block=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Is_Block=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Is_Block=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Is_Block=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Is_Block=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Is_Block=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Is_Block=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Is_Block:-psalter_PAHLAVI}', "");
    Expect(0, 68527, '\p{^Is_Block:-psalter_PAHLAVI}', "");
    Expect(0, 68527, '\P{Is_Block:-psalter_PAHLAVI}', "");
    Expect(1, 68527, '\P{^Is_Block:-psalter_PAHLAVI}', "");
    Expect(0, 68528, '\p{Is_Block:-psalter_PAHLAVI}', "");
    Expect(1, 68528, '\p{^Is_Block:-psalter_PAHLAVI}', "");
    Expect(1, 68528, '\P{Is_Block:-psalter_PAHLAVI}', "");
    Expect(0, 68528, '\P{^Is_Block:-psalter_PAHLAVI}', "");
    Error('\p{Is_Blk=:=	psalter_PAHLAVI}');
    Error('\P{Is_Blk=:=	psalter_PAHLAVI}');
    Expect(1, 68527, '\p{Is_Blk=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Is_Blk=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Is_Blk=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Is_Blk=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Is_Blk=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Is_Blk=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Is_Blk=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Is_Blk=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Is_Blk= -psalter_Pahlavi}', "");
    Expect(0, 68527, '\p{^Is_Blk= -psalter_Pahlavi}', "");
    Expect(0, 68527, '\P{Is_Blk= -psalter_Pahlavi}', "");
    Expect(1, 68527, '\P{^Is_Blk= -psalter_Pahlavi}', "");
    Expect(0, 68528, '\p{Is_Blk= -psalter_Pahlavi}', "");
    Expect(1, 68528, '\p{^Is_Blk= -psalter_Pahlavi}', "");
    Expect(1, 68528, '\P{Is_Blk= -psalter_Pahlavi}', "");
    Expect(0, 68528, '\P{^Is_Blk= -psalter_Pahlavi}', "");
    Error('\p{Block:   -/a/Private_Use_AREA}');
    Error('\P{Block:   -/a/Private_Use_AREA}');
    Expect(1, 63743, '\p{Block=:\APrivate_Use_Area\z:}', "");;
    Expect(0, 63744, '\p{Block=:\APrivate_Use_Area\z:}', "");;
    Expect(1, 63743, '\p{Block=privateusearea}', "");
    Expect(0, 63743, '\p{^Block=privateusearea}', "");
    Expect(0, 63743, '\P{Block=privateusearea}', "");
    Expect(1, 63743, '\P{^Block=privateusearea}', "");
    Expect(0, 63744, '\p{Block=privateusearea}', "");
    Expect(1, 63744, '\p{^Block=privateusearea}', "");
    Expect(1, 63744, '\P{Block=privateusearea}', "");
    Expect(0, 63744, '\P{^Block=privateusearea}', "");
    Expect(1, 63743, '\p{Block=:\Aprivateusearea\z:}', "");;
    Expect(0, 63744, '\p{Block=:\Aprivateusearea\z:}', "");;
    Expect(1, 63743, '\p{Block=_-private_use_AREA}', "");
    Expect(0, 63743, '\p{^Block=_-private_use_AREA}', "");
    Expect(0, 63743, '\P{Block=_-private_use_AREA}', "");
    Expect(1, 63743, '\P{^Block=_-private_use_AREA}', "");
    Expect(0, 63744, '\p{Block=_-private_use_AREA}', "");
    Expect(1, 63744, '\p{^Block=_-private_use_AREA}', "");
    Expect(1, 63744, '\P{Block=_-private_use_AREA}', "");
    Expect(0, 63744, '\P{^Block=_-private_use_AREA}', "");
    Error('\p{Blk=	:=PUA}');
    Error('\P{Blk=	:=PUA}');
    Expect(1, 63743, '\p{Blk=:\APUA\z:}', "");;
    Expect(0, 63744, '\p{Blk=:\APUA\z:}', "");;
    Expect(1, 63743, '\p{Blk=pua}', "");
    Expect(0, 63743, '\p{^Blk=pua}', "");
    Expect(0, 63743, '\P{Blk=pua}', "");
    Expect(1, 63743, '\P{^Blk=pua}', "");
    Expect(0, 63744, '\p{Blk=pua}', "");
    Expect(1, 63744, '\p{^Blk=pua}', "");
    Expect(1, 63744, '\P{Blk=pua}', "");
    Expect(0, 63744, '\P{^Blk=pua}', "");
    Expect(1, 63743, '\p{Blk=:\Apua\z:}', "");;
    Expect(0, 63744, '\p{Blk=:\Apua\z:}', "");;
    Expect(1, 63743, '\p{Blk=_	PUA}', "");
    Expect(0, 63743, '\p{^Blk=_	PUA}', "");
    Expect(0, 63743, '\P{Blk=_	PUA}', "");
    Expect(1, 63743, '\P{^Blk=_	PUA}', "");
    Expect(0, 63744, '\p{Blk=_	PUA}', "");
    Expect(1, 63744, '\p{^Blk=_	PUA}', "");
    Expect(1, 63744, '\P{Blk=_	PUA}', "");
    Expect(0, 63744, '\P{^Blk=_	PUA}', "");
    Error('\p{Is_Block=Private_use/a/}');
    Error('\P{Is_Block=Private_use/a/}');
    Expect(1, 63743, '\p{Is_Block:   privateuse}', "");
    Expect(0, 63743, '\p{^Is_Block:   privateuse}', "");
    Expect(0, 63743, '\P{Is_Block:   privateuse}', "");
    Expect(1, 63743, '\P{^Is_Block:   privateuse}', "");
    Expect(0, 63744, '\p{Is_Block:   privateuse}', "");
    Expect(1, 63744, '\p{^Is_Block:   privateuse}', "");
    Expect(1, 63744, '\P{Is_Block:   privateuse}', "");
    Expect(0, 63744, '\P{^Is_Block:   privateuse}', "");
    Expect(1, 63743, '\p{Is_Block=_Private_use}', "");
    Expect(0, 63743, '\p{^Is_Block=_Private_use}', "");
    Expect(0, 63743, '\P{Is_Block=_Private_use}', "");
    Expect(1, 63743, '\P{^Is_Block=_Private_use}', "");
    Expect(0, 63744, '\p{Is_Block=_Private_use}', "");
    Expect(1, 63744, '\p{^Is_Block=_Private_use}', "");
    Expect(1, 63744, '\P{Is_Block=_Private_use}', "");
    Expect(0, 63744, '\P{^Is_Block=_Private_use}', "");
    Error('\p{Is_Blk=_ Private_Use_AREA:=}');
    Error('\P{Is_Blk=_ Private_Use_AREA:=}');
    Expect(1, 63743, '\p{Is_Blk=privateusearea}', "");
    Expect(0, 63743, '\p{^Is_Blk=privateusearea}', "");
    Expect(0, 63743, '\P{Is_Blk=privateusearea}', "");
    Expect(1, 63743, '\P{^Is_Blk=privateusearea}', "");
    Expect(0, 63744, '\p{Is_Blk=privateusearea}', "");
    Expect(1, 63744, '\p{^Is_Blk=privateusearea}', "");
    Expect(1, 63744, '\P{Is_Blk=privateusearea}', "");
    Expect(0, 63744, '\P{^Is_Blk=privateusearea}', "");
    Expect(1, 63743, '\p{Is_Blk=-_Private_USE_Area}', "");
    Expect(0, 63743, '\p{^Is_Blk=-_Private_USE_Area}', "");
    Expect(0, 63743, '\P{Is_Blk=-_Private_USE_Area}', "");
    Expect(1, 63743, '\P{^Is_Blk=-_Private_USE_Area}', "");
    Expect(0, 63744, '\p{Is_Blk=-_Private_USE_Area}', "");
    Expect(1, 63744, '\p{^Is_Blk=-_Private_USE_Area}', "");
    Expect(1, 63744, '\P{Is_Blk=-_Private_USE_Area}', "");
    Expect(0, 63744, '\P{^Is_Blk=-_Private_USE_Area}', "");
    Error('\p{Block=_/a/General_Punctuation}');
    Error('\P{Block=_/a/General_Punctuation}');
    Expect(1, 8303, '\p{Block=:\AGeneral_Punctuation\z:}', "");;
    Expect(0, 8304, '\p{Block=:\AGeneral_Punctuation\z:}', "");;
    Expect(1, 8303, '\p{Block=generalpunctuation}', "");
    Expect(0, 8303, '\p{^Block=generalpunctuation}', "");
    Expect(0, 8303, '\P{Block=generalpunctuation}', "");
    Expect(1, 8303, '\P{^Block=generalpunctuation}', "");
    Expect(0, 8304, '\p{Block=generalpunctuation}', "");
    Expect(1, 8304, '\p{^Block=generalpunctuation}', "");
    Expect(1, 8304, '\P{Block=generalpunctuation}', "");
    Expect(0, 8304, '\P{^Block=generalpunctuation}', "");
    Expect(1, 8303, '\p{Block=:\Ageneralpunctuation\z:}', "");;
    Expect(0, 8304, '\p{Block=:\Ageneralpunctuation\z:}', "");;
    Expect(1, 8303, '\p{Block=	-General_Punctuation}', "");
    Expect(0, 8303, '\p{^Block=	-General_Punctuation}', "");
    Expect(0, 8303, '\P{Block=	-General_Punctuation}', "");
    Expect(1, 8303, '\P{^Block=	-General_Punctuation}', "");
    Expect(0, 8304, '\p{Block=	-General_Punctuation}', "");
    Expect(1, 8304, '\p{^Block=	-General_Punctuation}', "");
    Expect(1, 8304, '\P{Block=	-General_Punctuation}', "");
    Expect(0, 8304, '\P{^Block=	-General_Punctuation}', "");
    Error('\p{Blk:    punctuation:=}');
    Error('\P{Blk:    punctuation:=}');
    Expect(1, 8303, '\p{Blk=:\APunctuation\z:}', "");;
    Expect(0, 8304, '\p{Blk=:\APunctuation\z:}', "");;
    Expect(1, 8303, '\p{Blk=punctuation}', "");
    Expect(0, 8303, '\p{^Blk=punctuation}', "");
    Expect(0, 8303, '\P{Blk=punctuation}', "");
    Expect(1, 8303, '\P{^Blk=punctuation}', "");
    Expect(0, 8304, '\p{Blk=punctuation}', "");
    Expect(1, 8304, '\p{^Blk=punctuation}', "");
    Expect(1, 8304, '\P{Blk=punctuation}', "");
    Expect(0, 8304, '\P{^Blk=punctuation}', "");
    Expect(1, 8303, '\p{Blk=:\Apunctuation\z:}', "");;
    Expect(0, 8304, '\p{Blk=:\Apunctuation\z:}', "");;
    Expect(1, 8303, '\p{Blk=_ Punctuation}', "");
    Expect(0, 8303, '\p{^Blk=_ Punctuation}', "");
    Expect(0, 8303, '\P{Blk=_ Punctuation}', "");
    Expect(1, 8303, '\P{^Blk=_ Punctuation}', "");
    Expect(0, 8304, '\p{Blk=_ Punctuation}', "");
    Expect(1, 8304, '\p{^Blk=_ Punctuation}', "");
    Expect(1, 8304, '\P{Blk=_ Punctuation}', "");
    Expect(0, 8304, '\P{^Blk=_ Punctuation}', "");
    Error('\p{Is_Block=_	general_Punctuation:=}');
    Error('\P{Is_Block=_	general_Punctuation:=}');
    Expect(1, 8303, '\p{Is_Block=generalpunctuation}', "");
    Expect(0, 8303, '\p{^Is_Block=generalpunctuation}', "");
    Expect(0, 8303, '\P{Is_Block=generalpunctuation}', "");
    Expect(1, 8303, '\P{^Is_Block=generalpunctuation}', "");
    Expect(0, 8304, '\p{Is_Block=generalpunctuation}', "");
    Expect(1, 8304, '\p{^Is_Block=generalpunctuation}', "");
    Expect(1, 8304, '\P{Is_Block=generalpunctuation}', "");
    Expect(0, 8304, '\P{^Is_Block=generalpunctuation}', "");
    Expect(1, 8303, '\p{Is_Block= 	General_punctuation}', "");
    Expect(0, 8303, '\p{^Is_Block= 	General_punctuation}', "");
    Expect(0, 8303, '\P{Is_Block= 	General_punctuation}', "");
    Expect(1, 8303, '\P{^Is_Block= 	General_punctuation}', "");
    Expect(0, 8304, '\p{Is_Block= 	General_punctuation}', "");
    Expect(1, 8304, '\p{^Is_Block= 	General_punctuation}', "");
    Expect(1, 8304, '\P{Is_Block= 	General_punctuation}', "");
    Expect(0, 8304, '\P{^Is_Block= 	General_punctuation}', "");
    Error('\p{Is_Blk=_/a/Punctuation}');
    Error('\P{Is_Blk=_/a/Punctuation}');
    Expect(1, 8303, '\p{Is_Blk=punctuation}', "");
    Expect(0, 8303, '\p{^Is_Blk=punctuation}', "");
    Expect(0, 8303, '\P{Is_Blk=punctuation}', "");
    Expect(1, 8303, '\P{^Is_Blk=punctuation}', "");
    Expect(0, 8304, '\p{Is_Blk=punctuation}', "");
    Expect(1, 8304, '\p{^Is_Blk=punctuation}', "");
    Expect(1, 8304, '\P{Is_Blk=punctuation}', "");
    Expect(0, 8304, '\P{^Is_Blk=punctuation}', "");
    Expect(1, 8303, '\p{Is_Blk=		PUNCTUATION}', "");
    Expect(0, 8303, '\p{^Is_Blk=		PUNCTUATION}', "");
    Expect(0, 8303, '\P{Is_Blk=		PUNCTUATION}', "");
    Expect(1, 8303, '\P{^Is_Blk=		PUNCTUATION}', "");
    Expect(0, 8304, '\p{Is_Blk=		PUNCTUATION}', "");
    Expect(1, 8304, '\p{^Is_Blk=		PUNCTUATION}', "");
    Expect(1, 8304, '\P{Is_Blk=		PUNCTUATION}', "");
    Expect(0, 8304, '\P{^Is_Blk=		PUNCTUATION}', "");
    Error('\p{Block=/a/ 	rejang}');
    Error('\P{Block=/a/ 	rejang}');
    Expect(1, 43359, '\p{Block=:\ARejang\z:}', "");;
    Expect(0, 43360, '\p{Block=:\ARejang\z:}', "");;
    Expect(1, 43359, '\p{Block:rejang}', "");
    Expect(0, 43359, '\p{^Block:rejang}', "");
    Expect(0, 43359, '\P{Block:rejang}', "");
    Expect(1, 43359, '\P{^Block:rejang}', "");
    Expect(0, 43360, '\p{Block:rejang}', "");
    Expect(1, 43360, '\p{^Block:rejang}', "");
    Expect(1, 43360, '\P{Block:rejang}', "");
    Expect(0, 43360, '\P{^Block:rejang}', "");
    Expect(1, 43359, '\p{Block=:\Arejang\z:}', "");;
    Expect(0, 43360, '\p{Block=:\Arejang\z:}', "");;
    Expect(1, 43359, '\p{Block= _REJANG}', "");
    Expect(0, 43359, '\p{^Block= _REJANG}', "");
    Expect(0, 43359, '\P{Block= _REJANG}', "");
    Expect(1, 43359, '\P{^Block= _REJANG}', "");
    Expect(0, 43360, '\p{Block= _REJANG}', "");
    Expect(1, 43360, '\p{^Block= _REJANG}', "");
    Expect(1, 43360, '\P{Block= _REJANG}', "");
    Expect(0, 43360, '\P{^Block= _REJANG}', "");
    Error('\p{Blk=:=-_Rejang}');
    Error('\P{Blk=:=-_Rejang}');
    Expect(1, 43359, '\p{Blk=:\ARejang\z:}', "");;
    Expect(0, 43360, '\p{Blk=:\ARejang\z:}', "");;
    Expect(1, 43359, '\p{Blk=rejang}', "");
    Expect(0, 43359, '\p{^Blk=rejang}', "");
    Expect(0, 43359, '\P{Blk=rejang}', "");
    Expect(1, 43359, '\P{^Blk=rejang}', "");
    Expect(0, 43360, '\p{Blk=rejang}', "");
    Expect(1, 43360, '\p{^Blk=rejang}', "");
    Expect(1, 43360, '\P{Blk=rejang}', "");
    Expect(0, 43360, '\P{^Blk=rejang}', "");
    Expect(1, 43359, '\p{Blk=:\Arejang\z:}', "");;
    Expect(0, 43360, '\p{Blk=:\Arejang\z:}', "");;
    Expect(1, 43359, '\p{Blk=_REJANG}', "");
    Expect(0, 43359, '\p{^Blk=_REJANG}', "");
    Expect(0, 43359, '\P{Blk=_REJANG}', "");
    Expect(1, 43359, '\P{^Blk=_REJANG}', "");
    Expect(0, 43360, '\p{Blk=_REJANG}', "");
    Expect(1, 43360, '\p{^Blk=_REJANG}', "");
    Expect(1, 43360, '\P{Blk=_REJANG}', "");
    Expect(0, 43360, '\P{^Blk=_REJANG}', "");
    Error('\p{Is_Block= /a/Rejang}');
    Error('\P{Is_Block= /a/Rejang}');
    Expect(1, 43359, '\p{Is_Block:rejang}', "");
    Expect(0, 43359, '\p{^Is_Block:rejang}', "");
    Expect(0, 43359, '\P{Is_Block:rejang}', "");
    Expect(1, 43359, '\P{^Is_Block:rejang}', "");
    Expect(0, 43360, '\p{Is_Block:rejang}', "");
    Expect(1, 43360, '\p{^Is_Block:rejang}', "");
    Expect(1, 43360, '\P{Is_Block:rejang}', "");
    Expect(0, 43360, '\P{^Is_Block:rejang}', "");
    Expect(1, 43359, '\p{Is_Block=-rejang}', "");
    Expect(0, 43359, '\p{^Is_Block=-rejang}', "");
    Expect(0, 43359, '\P{Is_Block=-rejang}', "");
    Expect(1, 43359, '\P{^Is_Block=-rejang}', "");
    Expect(0, 43360, '\p{Is_Block=-rejang}', "");
    Expect(1, 43360, '\p{^Is_Block=-rejang}', "");
    Expect(1, 43360, '\P{Is_Block=-rejang}', "");
    Expect(0, 43360, '\P{^Is_Block=-rejang}', "");
    Error('\p{Is_Blk=_:=REJANG}');
    Error('\P{Is_Blk=_:=REJANG}');
    Expect(1, 43359, '\p{Is_Blk:rejang}', "");
    Expect(0, 43359, '\p{^Is_Blk:rejang}', "");
    Expect(0, 43359, '\P{Is_Blk:rejang}', "");
    Expect(1, 43359, '\P{^Is_Blk:rejang}', "");
    Expect(0, 43360, '\p{Is_Blk:rejang}', "");
    Expect(1, 43360, '\p{^Is_Blk:rejang}', "");
    Expect(1, 43360, '\P{Is_Blk:rejang}', "");
    Expect(0, 43360, '\P{^Is_Blk:rejang}', "");
    Expect(1, 43359, '\p{Is_Blk=	-REJANG}', "");
    Expect(0, 43359, '\p{^Is_Blk=	-REJANG}', "");
    Expect(0, 43359, '\P{Is_Blk=	-REJANG}', "");
    Expect(1, 43359, '\P{^Is_Blk=	-REJANG}', "");
    Expect(0, 43360, '\p{Is_Blk=	-REJANG}', "");
    Expect(1, 43360, '\p{^Is_Blk=	-REJANG}', "");
    Expect(1, 43360, '\P{Is_Blk=	-REJANG}', "");
    Expect(0, 43360, '\P{^Is_Blk=	-REJANG}', "");
    Error('\p{Block=-:=Rumi_Numeral_Symbols}');
    Error('\P{Block=-:=Rumi_Numeral_Symbols}');
    Expect(1, 69247, '\p{Block=:\ARumi_Numeral_Symbols\z:}', "");;
    Expect(0, 69248, '\p{Block=:\ARumi_Numeral_Symbols\z:}', "");;
    Expect(1, 69247, '\p{Block: ruminumeralsymbols}', "");
    Expect(0, 69247, '\p{^Block: ruminumeralsymbols}', "");
    Expect(0, 69247, '\P{Block: ruminumeralsymbols}', "");
    Expect(1, 69247, '\P{^Block: ruminumeralsymbols}', "");
    Expect(0, 69248, '\p{Block: ruminumeralsymbols}', "");
    Expect(1, 69248, '\p{^Block: ruminumeralsymbols}', "");
    Expect(1, 69248, '\P{Block: ruminumeralsymbols}', "");
    Expect(0, 69248, '\P{^Block: ruminumeralsymbols}', "");
    Expect(1, 69247, '\p{Block=:\Aruminumeralsymbols\z:}', "");;
    Expect(0, 69248, '\p{Block=:\Aruminumeralsymbols\z:}', "");;
    Expect(1, 69247, '\p{Block=		RUMI_Numeral_symbols}', "");
    Expect(0, 69247, '\p{^Block=		RUMI_Numeral_symbols}', "");
    Expect(0, 69247, '\P{Block=		RUMI_Numeral_symbols}', "");
    Expect(1, 69247, '\P{^Block=		RUMI_Numeral_symbols}', "");
    Expect(0, 69248, '\p{Block=		RUMI_Numeral_symbols}', "");
    Expect(1, 69248, '\p{^Block=		RUMI_Numeral_symbols}', "");
    Expect(1, 69248, '\P{Block=		RUMI_Numeral_symbols}', "");
    Expect(0, 69248, '\P{^Block=		RUMI_Numeral_symbols}', "");
    Error('\p{Blk=:=	rumi}');
    Error('\P{Blk=:=	rumi}');
    Expect(1, 69247, '\p{Blk=:\ARumi\z:}', "");;
    Expect(0, 69248, '\p{Blk=:\ARumi\z:}', "");;
    Expect(1, 69247, '\p{Blk=rumi}', "");
    Expect(0, 69247, '\p{^Blk=rumi}', "");
    Expect(0, 69247, '\P{Blk=rumi}', "");
    Expect(1, 69247, '\P{^Blk=rumi}', "");
    Expect(0, 69248, '\p{Blk=rumi}', "");
    Expect(1, 69248, '\p{^Blk=rumi}', "");
    Expect(1, 69248, '\P{Blk=rumi}', "");
    Expect(0, 69248, '\P{^Blk=rumi}', "");
    Expect(1, 69247, '\p{Blk=:\Arumi\z:}', "");;
    Expect(0, 69248, '\p{Blk=:\Arumi\z:}', "");;
    Expect(1, 69247, '\p{Blk=_	RUMI}', "");
    Expect(0, 69247, '\p{^Blk=_	RUMI}', "");
    Expect(0, 69247, '\P{Blk=_	RUMI}', "");
    Expect(1, 69247, '\P{^Blk=_	RUMI}', "");
    Expect(0, 69248, '\p{Blk=_	RUMI}', "");
    Expect(1, 69248, '\p{^Blk=_	RUMI}', "");
    Expect(1, 69248, '\P{Blk=_	RUMI}', "");
    Expect(0, 69248, '\P{^Blk=_	RUMI}', "");
    Error('\p{Is_Block=_-Rumi_numeral_Symbols/a/}');
    Error('\P{Is_Block=_-Rumi_numeral_Symbols/a/}');
    Expect(1, 69247, '\p{Is_Block:   ruminumeralsymbols}', "");
    Expect(0, 69247, '\p{^Is_Block:   ruminumeralsymbols}', "");
    Expect(0, 69247, '\P{Is_Block:   ruminumeralsymbols}', "");
    Expect(1, 69247, '\P{^Is_Block:   ruminumeralsymbols}', "");
    Expect(0, 69248, '\p{Is_Block:   ruminumeralsymbols}', "");
    Expect(1, 69248, '\p{^Is_Block:   ruminumeralsymbols}', "");
    Expect(1, 69248, '\P{Is_Block:   ruminumeralsymbols}', "");
    Expect(0, 69248, '\P{^Is_Block:   ruminumeralsymbols}', "");
    Expect(1, 69247, '\p{Is_Block:	 	RUMI_NUMERAL_SYMBOLS}', "");
    Expect(0, 69247, '\p{^Is_Block:	 	RUMI_NUMERAL_SYMBOLS}', "");
    Expect(0, 69247, '\P{Is_Block:	 	RUMI_NUMERAL_SYMBOLS}', "");
    Expect(1, 69247, '\P{^Is_Block:	 	RUMI_NUMERAL_SYMBOLS}', "");
    Expect(0, 69248, '\p{Is_Block:	 	RUMI_NUMERAL_SYMBOLS}', "");
    Expect(1, 69248, '\p{^Is_Block:	 	RUMI_NUMERAL_SYMBOLS}', "");
    Expect(1, 69248, '\P{Is_Block:	 	RUMI_NUMERAL_SYMBOLS}', "");
    Expect(0, 69248, '\P{^Is_Block:	 	RUMI_NUMERAL_SYMBOLS}', "");
    Error('\p{Is_Blk= Rumi:=}');
    Error('\P{Is_Blk= Rumi:=}');
    Expect(1, 69247, '\p{Is_Blk=rumi}', "");
    Expect(0, 69247, '\p{^Is_Blk=rumi}', "");
    Expect(0, 69247, '\P{Is_Blk=rumi}', "");
    Expect(1, 69247, '\P{^Is_Blk=rumi}', "");
    Expect(0, 69248, '\p{Is_Blk=rumi}', "");
    Expect(1, 69248, '\p{^Is_Blk=rumi}', "");
    Expect(1, 69248, '\P{Is_Blk=rumi}', "");
    Expect(0, 69248, '\P{^Is_Blk=rumi}', "");
    Expect(1, 69247, '\p{Is_Blk=	_Rumi}', "");
    Expect(0, 69247, '\p{^Is_Blk=	_Rumi}', "");
    Expect(0, 69247, '\P{Is_Blk=	_Rumi}', "");
    Expect(1, 69247, '\P{^Is_Blk=	_Rumi}', "");
    Expect(0, 69248, '\p{Is_Blk=	_Rumi}', "");
    Expect(1, 69248, '\p{^Is_Blk=	_Rumi}', "");
    Expect(1, 69248, '\P{Is_Blk=	_Rumi}', "");
    Expect(0, 69248, '\P{^Is_Blk=	_Rumi}', "");
    Error('\p{Block=-runic:=}');
    Error('\P{Block=-runic:=}');
    Expect(1, 5887, '\p{Block=:\ARunic\z:}', "");;
    Expect(0, 5888, '\p{Block=:\ARunic\z:}', "");;
    Expect(1, 5887, '\p{Block=runic}', "");
    Expect(0, 5887, '\p{^Block=runic}', "");
    Expect(0, 5887, '\P{Block=runic}', "");
    Expect(1, 5887, '\P{^Block=runic}', "");
    Expect(0, 5888, '\p{Block=runic}', "");
    Expect(1, 5888, '\p{^Block=runic}', "");
    Expect(1, 5888, '\P{Block=runic}', "");
    Expect(0, 5888, '\P{^Block=runic}', "");
    Expect(1, 5887, '\p{Block=:\Arunic\z:}', "");;
    Expect(0, 5888, '\p{Block=:\Arunic\z:}', "");;
    Expect(1, 5887, '\p{Block=__RUNIC}', "");
    Expect(0, 5887, '\p{^Block=__RUNIC}', "");
    Expect(0, 5887, '\P{Block=__RUNIC}', "");
    Expect(1, 5887, '\P{^Block=__RUNIC}', "");
    Expect(0, 5888, '\p{Block=__RUNIC}', "");
    Expect(1, 5888, '\p{^Block=__RUNIC}', "");
    Expect(1, 5888, '\P{Block=__RUNIC}', "");
    Expect(0, 5888, '\P{^Block=__RUNIC}', "");
    Error('\p{Blk=/a/__Runic}');
    Error('\P{Blk=/a/__Runic}');
    Expect(1, 5887, '\p{Blk=:\ARunic\z:}', "");;
    Expect(0, 5888, '\p{Blk=:\ARunic\z:}', "");;
    Expect(1, 5887, '\p{Blk=runic}', "");
    Expect(0, 5887, '\p{^Blk=runic}', "");
    Expect(0, 5887, '\P{Blk=runic}', "");
    Expect(1, 5887, '\P{^Blk=runic}', "");
    Expect(0, 5888, '\p{Blk=runic}', "");
    Expect(1, 5888, '\p{^Blk=runic}', "");
    Expect(1, 5888, '\P{Blk=runic}', "");
    Expect(0, 5888, '\P{^Blk=runic}', "");
    Expect(1, 5887, '\p{Blk=:\Arunic\z:}', "");;
    Expect(0, 5888, '\p{Blk=:\Arunic\z:}', "");;
    Expect(1, 5887, '\p{Blk:	_	runic}', "");
    Expect(0, 5887, '\p{^Blk:	_	runic}', "");
    Expect(0, 5887, '\P{Blk:	_	runic}', "");
    Expect(1, 5887, '\P{^Blk:	_	runic}', "");
    Expect(0, 5888, '\p{Blk:	_	runic}', "");
    Expect(1, 5888, '\p{^Blk:	_	runic}', "");
    Expect(1, 5888, '\P{Blk:	_	runic}', "");
    Expect(0, 5888, '\P{^Blk:	_	runic}', "");
    Error('\p{Is_Block=_/a/Runic}');
    Error('\P{Is_Block=_/a/Runic}');
    Expect(1, 5887, '\p{Is_Block=runic}', "");
    Expect(0, 5887, '\p{^Is_Block=runic}', "");
    Expect(0, 5887, '\P{Is_Block=runic}', "");
    Expect(1, 5887, '\P{^Is_Block=runic}', "");
    Expect(0, 5888, '\p{Is_Block=runic}', "");
    Expect(1, 5888, '\p{^Is_Block=runic}', "");
    Expect(1, 5888, '\P{Is_Block=runic}', "");
    Expect(0, 5888, '\P{^Is_Block=runic}', "");
    Expect(1, 5887, '\p{Is_Block=RUNIC}', "");
    Expect(0, 5887, '\p{^Is_Block=RUNIC}', "");
    Expect(0, 5887, '\P{Is_Block=RUNIC}', "");
    Expect(1, 5887, '\P{^Is_Block=RUNIC}', "");
    Expect(0, 5888, '\p{Is_Block=RUNIC}', "");
    Expect(1, 5888, '\p{^Is_Block=RUNIC}', "");
    Expect(1, 5888, '\P{Is_Block=RUNIC}', "");
    Expect(0, 5888, '\P{^Is_Block=RUNIC}', "");
    Error('\p{Is_Blk=:=Runic}');
    Error('\P{Is_Blk=:=Runic}');
    Expect(1, 5887, '\p{Is_Blk=runic}', "");
    Expect(0, 5887, '\p{^Is_Blk=runic}', "");
    Expect(0, 5887, '\P{Is_Blk=runic}', "");
    Expect(1, 5887, '\P{^Is_Blk=runic}', "");
    Expect(0, 5888, '\p{Is_Blk=runic}', "");
    Expect(1, 5888, '\p{^Is_Blk=runic}', "");
    Expect(1, 5888, '\P{Is_Blk=runic}', "");
    Expect(0, 5888, '\P{^Is_Blk=runic}', "");
    Expect(1, 5887, '\p{Is_Blk=__runic}', "");
    Expect(0, 5887, '\p{^Is_Blk=__runic}', "");
    Expect(0, 5887, '\P{Is_Blk=__runic}', "");
    Expect(1, 5887, '\P{^Is_Blk=__runic}', "");
    Expect(0, 5888, '\p{Is_Blk=__runic}', "");
    Expect(1, 5888, '\p{^Is_Blk=__runic}', "");
    Expect(1, 5888, '\P{Is_Blk=__runic}', "");
    Expect(0, 5888, '\P{^Is_Blk=__runic}', "");
    Error('\p{Block=/a/	SAMARITAN}');
    Error('\P{Block=/a/	SAMARITAN}');
    Expect(1, 2111, '\p{Block=:\ASamaritan\z:}', "");;
    Expect(0, 2112, '\p{Block=:\ASamaritan\z:}', "");;
    Expect(1, 2111, '\p{Block:   samaritan}', "");
    Expect(0, 2111, '\p{^Block:   samaritan}', "");
    Expect(0, 2111, '\P{Block:   samaritan}', "");
    Expect(1, 2111, '\P{^Block:   samaritan}', "");
    Expect(0, 2112, '\p{Block:   samaritan}', "");
    Expect(1, 2112, '\p{^Block:   samaritan}', "");
    Expect(1, 2112, '\P{Block:   samaritan}', "");
    Expect(0, 2112, '\P{^Block:   samaritan}', "");
    Expect(1, 2111, '\p{Block=:\Asamaritan\z:}', "");;
    Expect(0, 2112, '\p{Block=:\Asamaritan\z:}', "");;
    Expect(1, 2111, '\p{Block=	 Samaritan}', "");
    Expect(0, 2111, '\p{^Block=	 Samaritan}', "");
    Expect(0, 2111, '\P{Block=	 Samaritan}', "");
    Expect(1, 2111, '\P{^Block=	 Samaritan}', "");
    Expect(0, 2112, '\p{Block=	 Samaritan}', "");
    Expect(1, 2112, '\p{^Block=	 Samaritan}', "");
    Expect(1, 2112, '\P{Block=	 Samaritan}', "");
    Expect(0, 2112, '\P{^Block=	 Samaritan}', "");
    Error('\p{Blk=-Samaritan:=}');
    Error('\P{Blk=-Samaritan:=}');
    Expect(1, 2111, '\p{Blk=:\ASamaritan\z:}', "");;
    Expect(0, 2112, '\p{Blk=:\ASamaritan\z:}', "");;
    Expect(1, 2111, '\p{Blk=samaritan}', "");
    Expect(0, 2111, '\p{^Blk=samaritan}', "");
    Expect(0, 2111, '\P{Blk=samaritan}', "");
    Expect(1, 2111, '\P{^Blk=samaritan}', "");
    Expect(0, 2112, '\p{Blk=samaritan}', "");
    Expect(1, 2112, '\p{^Blk=samaritan}', "");
    Expect(1, 2112, '\P{Blk=samaritan}', "");
    Expect(0, 2112, '\P{^Blk=samaritan}', "");
    Expect(1, 2111, '\p{Blk=:\Asamaritan\z:}', "");;
    Expect(0, 2112, '\p{Blk=:\Asamaritan\z:}', "");;
    Expect(1, 2111, '\p{Blk:		Samaritan}', "");
    Expect(0, 2111, '\p{^Blk:		Samaritan}', "");
    Expect(0, 2111, '\P{Blk:		Samaritan}', "");
    Expect(1, 2111, '\P{^Blk:		Samaritan}', "");
    Expect(0, 2112, '\p{Blk:		Samaritan}', "");
    Expect(1, 2112, '\p{^Blk:		Samaritan}', "");
    Expect(1, 2112, '\P{Blk:		Samaritan}', "");
    Expect(0, 2112, '\P{^Blk:		Samaritan}', "");
    Error('\p{Is_Block:_:=samaritan}');
    Error('\P{Is_Block:_:=samaritan}');
    Expect(1, 2111, '\p{Is_Block=samaritan}', "");
    Expect(0, 2111, '\p{^Is_Block=samaritan}', "");
    Expect(0, 2111, '\P{Is_Block=samaritan}', "");
    Expect(1, 2111, '\P{^Is_Block=samaritan}', "");
    Expect(0, 2112, '\p{Is_Block=samaritan}', "");
    Expect(1, 2112, '\p{^Is_Block=samaritan}', "");
    Expect(1, 2112, '\P{Is_Block=samaritan}', "");
    Expect(0, 2112, '\P{^Is_Block=samaritan}', "");
    Expect(1, 2111, '\p{Is_Block=__samaritan}', "");
    Expect(0, 2111, '\p{^Is_Block=__samaritan}', "");
    Expect(0, 2111, '\P{Is_Block=__samaritan}', "");
    Expect(1, 2111, '\P{^Is_Block=__samaritan}', "");
    Expect(0, 2112, '\p{Is_Block=__samaritan}', "");
    Expect(1, 2112, '\p{^Is_Block=__samaritan}', "");
    Expect(1, 2112, '\P{Is_Block=__samaritan}', "");
    Expect(0, 2112, '\P{^Is_Block=__samaritan}', "");
    Error('\p{Is_Blk=:=	 samaritan}');
    Error('\P{Is_Blk=:=	 samaritan}');
    Expect(1, 2111, '\p{Is_Blk=samaritan}', "");
    Expect(0, 2111, '\p{^Is_Blk=samaritan}', "");
    Expect(0, 2111, '\P{Is_Blk=samaritan}', "");
    Expect(1, 2111, '\P{^Is_Blk=samaritan}', "");
    Expect(0, 2112, '\p{Is_Blk=samaritan}', "");
    Expect(1, 2112, '\p{^Is_Blk=samaritan}', "");
    Expect(1, 2112, '\P{Is_Blk=samaritan}', "");
    Expect(0, 2112, '\P{^Is_Blk=samaritan}', "");
    Expect(1, 2111, '\p{Is_Blk= 	samaritan}', "");
    Expect(0, 2111, '\p{^Is_Blk= 	samaritan}', "");
    Expect(0, 2111, '\P{Is_Blk= 	samaritan}', "");
    Expect(1, 2111, '\P{^Is_Blk= 	samaritan}', "");
    Expect(0, 2112, '\p{Is_Blk= 	samaritan}', "");
    Expect(1, 2112, '\p{^Is_Blk= 	samaritan}', "");
    Expect(1, 2112, '\P{Is_Blk= 	samaritan}', "");
    Expect(0, 2112, '\P{^Is_Blk= 	samaritan}', "");
    Error('\p{Block=-_SAURASHTRA:=}');
    Error('\P{Block=-_SAURASHTRA:=}');
    Expect(1, 43231, '\p{Block=:\ASaurashtra\z:}', "");;
    Expect(0, 43232, '\p{Block=:\ASaurashtra\z:}', "");;
    Expect(1, 43231, '\p{Block=saurashtra}', "");
    Expect(0, 43231, '\p{^Block=saurashtra}', "");
    Expect(0, 43231, '\P{Block=saurashtra}', "");
    Expect(1, 43231, '\P{^Block=saurashtra}', "");
    Expect(0, 43232, '\p{Block=saurashtra}', "");
    Expect(1, 43232, '\p{^Block=saurashtra}', "");
    Expect(1, 43232, '\P{Block=saurashtra}', "");
    Expect(0, 43232, '\P{^Block=saurashtra}', "");
    Expect(1, 43231, '\p{Block=:\Asaurashtra\z:}', "");;
    Expect(0, 43232, '\p{Block=:\Asaurashtra\z:}', "");;
    Expect(1, 43231, '\p{Block=-_Saurashtra}', "");
    Expect(0, 43231, '\p{^Block=-_Saurashtra}', "");
    Expect(0, 43231, '\P{Block=-_Saurashtra}', "");
    Expect(1, 43231, '\P{^Block=-_Saurashtra}', "");
    Expect(0, 43232, '\p{Block=-_Saurashtra}', "");
    Expect(1, 43232, '\p{^Block=-_Saurashtra}', "");
    Expect(1, 43232, '\P{Block=-_Saurashtra}', "");
    Expect(0, 43232, '\P{^Block=-_Saurashtra}', "");
    Error('\p{Blk=_-Saurashtra/a/}');
    Error('\P{Blk=_-Saurashtra/a/}');
    Expect(1, 43231, '\p{Blk=:\ASaurashtra\z:}', "");;
    Expect(0, 43232, '\p{Blk=:\ASaurashtra\z:}', "");;
    Expect(1, 43231, '\p{Blk:	saurashtra}', "");
    Expect(0, 43231, '\p{^Blk:	saurashtra}', "");
    Expect(0, 43231, '\P{Blk:	saurashtra}', "");
    Expect(1, 43231, '\P{^Blk:	saurashtra}', "");
    Expect(0, 43232, '\p{Blk:	saurashtra}', "");
    Expect(1, 43232, '\p{^Blk:	saurashtra}', "");
    Expect(1, 43232, '\P{Blk:	saurashtra}', "");
    Expect(0, 43232, '\P{^Blk:	saurashtra}', "");
    Expect(1, 43231, '\p{Blk=:\Asaurashtra\z:}', "");;
    Expect(0, 43232, '\p{Blk=:\Asaurashtra\z:}', "");;
    Expect(1, 43231, '\p{Blk=_	Saurashtra}', "");
    Expect(0, 43231, '\p{^Blk=_	Saurashtra}', "");
    Expect(0, 43231, '\P{Blk=_	Saurashtra}', "");
    Expect(1, 43231, '\P{^Blk=_	Saurashtra}', "");
    Expect(0, 43232, '\p{Blk=_	Saurashtra}', "");
    Expect(1, 43232, '\p{^Blk=_	Saurashtra}', "");
    Expect(1, 43232, '\P{Blk=_	Saurashtra}', "");
    Expect(0, 43232, '\P{^Blk=_	Saurashtra}', "");
    Error('\p{Is_Block=-/a/saurashtra}');
    Error('\P{Is_Block=-/a/saurashtra}');
    Expect(1, 43231, '\p{Is_Block=saurashtra}', "");
    Expect(0, 43231, '\p{^Is_Block=saurashtra}', "");
    Expect(0, 43231, '\P{Is_Block=saurashtra}', "");
    Expect(1, 43231, '\P{^Is_Block=saurashtra}', "");
    Expect(0, 43232, '\p{Is_Block=saurashtra}', "");
    Expect(1, 43232, '\p{^Is_Block=saurashtra}', "");
    Expect(1, 43232, '\P{Is_Block=saurashtra}', "");
    Expect(0, 43232, '\P{^Is_Block=saurashtra}', "");
    Expect(1, 43231, '\p{Is_Block=	saurashtra}', "");
    Expect(0, 43231, '\p{^Is_Block=	saurashtra}', "");
    Expect(0, 43231, '\P{Is_Block=	saurashtra}', "");
    Expect(1, 43231, '\P{^Is_Block=	saurashtra}', "");
    Expect(0, 43232, '\p{Is_Block=	saurashtra}', "");
    Expect(1, 43232, '\p{^Is_Block=	saurashtra}', "");
    Expect(1, 43232, '\P{Is_Block=	saurashtra}', "");
    Expect(0, 43232, '\P{^Is_Block=	saurashtra}', "");
    Error('\p{Is_Blk=/a/ 	SAURASHTRA}');
    Error('\P{Is_Blk=/a/ 	SAURASHTRA}');
    Expect(1, 43231, '\p{Is_Blk=saurashtra}', "");
    Expect(0, 43231, '\p{^Is_Blk=saurashtra}', "");
    Expect(0, 43231, '\P{Is_Blk=saurashtra}', "");
    Expect(1, 43231, '\P{^Is_Blk=saurashtra}', "");
    Expect(0, 43232, '\p{Is_Blk=saurashtra}', "");
    Expect(1, 43232, '\p{^Is_Blk=saurashtra}', "");
    Expect(1, 43232, '\P{Is_Blk=saurashtra}', "");
    Expect(0, 43232, '\P{^Is_Blk=saurashtra}', "");
    Expect(1, 43231, '\p{Is_Blk=  Saurashtra}', "");
    Expect(0, 43231, '\p{^Is_Blk=  Saurashtra}', "");
    Expect(0, 43231, '\P{Is_Blk=  Saurashtra}', "");
    Expect(1, 43231, '\P{^Is_Blk=  Saurashtra}', "");
    Expect(0, 43232, '\p{Is_Blk=  Saurashtra}', "");
    Expect(1, 43232, '\p{^Is_Blk=  Saurashtra}', "");
    Expect(1, 43232, '\P{Is_Blk=  Saurashtra}', "");
    Expect(0, 43232, '\P{^Is_Blk=  Saurashtra}', "");
    Error('\p{Block=:=Sharada}');
    Error('\P{Block=:=Sharada}');
    Expect(1, 70111, '\p{Block=:\ASharada\z:}', "");;
    Expect(0, 70112, '\p{Block=:\ASharada\z:}', "");;
    Expect(1, 70111, '\p{Block=sharada}', "");
    Expect(0, 70111, '\p{^Block=sharada}', "");
    Expect(0, 70111, '\P{Block=sharada}', "");
    Expect(1, 70111, '\P{^Block=sharada}', "");
    Expect(0, 70112, '\p{Block=sharada}', "");
    Expect(1, 70112, '\p{^Block=sharada}', "");
    Expect(1, 70112, '\P{Block=sharada}', "");
    Expect(0, 70112, '\P{^Block=sharada}', "");
    Expect(1, 70111, '\p{Block=:\Asharada\z:}', "");;
    Expect(0, 70112, '\p{Block=:\Asharada\z:}', "");;
    Expect(1, 70111, '\p{Block=	Sharada}', "");
    Expect(0, 70111, '\p{^Block=	Sharada}', "");
    Expect(0, 70111, '\P{Block=	Sharada}', "");
    Expect(1, 70111, '\P{^Block=	Sharada}', "");
    Expect(0, 70112, '\p{Block=	Sharada}', "");
    Expect(1, 70112, '\p{^Block=	Sharada}', "");
    Expect(1, 70112, '\P{Block=	Sharada}', "");
    Expect(0, 70112, '\P{^Block=	Sharada}', "");
    Error('\p{Blk=-sharada/a/}');
    Error('\P{Blk=-sharada/a/}');
    Expect(1, 70111, '\p{Blk=:\ASharada\z:}', "");;
    Expect(0, 70112, '\p{Blk=:\ASharada\z:}', "");;
    Expect(1, 70111, '\p{Blk=sharada}', "");
    Expect(0, 70111, '\p{^Blk=sharada}', "");
    Expect(0, 70111, '\P{Blk=sharada}', "");
    Expect(1, 70111, '\P{^Blk=sharada}', "");
    Expect(0, 70112, '\p{Blk=sharada}', "");
    Expect(1, 70112, '\p{^Blk=sharada}', "");
    Expect(1, 70112, '\P{Blk=sharada}', "");
    Expect(0, 70112, '\P{^Blk=sharada}', "");
    Expect(1, 70111, '\p{Blk=:\Asharada\z:}', "");;
    Expect(0, 70112, '\p{Blk=:\Asharada\z:}', "");;
    Expect(1, 70111, '\p{Blk=- SHARADA}', "");
    Expect(0, 70111, '\p{^Blk=- SHARADA}', "");
    Expect(0, 70111, '\P{Blk=- SHARADA}', "");
    Expect(1, 70111, '\P{^Blk=- SHARADA}', "");
    Expect(0, 70112, '\p{Blk=- SHARADA}', "");
    Expect(1, 70112, '\p{^Blk=- SHARADA}', "");
    Expect(1, 70112, '\P{Blk=- SHARADA}', "");
    Expect(0, 70112, '\P{^Blk=- SHARADA}', "");
    Error('\p{Is_Block=:= -Sharada}');
    Error('\P{Is_Block=:= -Sharada}');
    Expect(1, 70111, '\p{Is_Block=sharada}', "");
    Expect(0, 70111, '\p{^Is_Block=sharada}', "");
    Expect(0, 70111, '\P{Is_Block=sharada}', "");
    Expect(1, 70111, '\P{^Is_Block=sharada}', "");
    Expect(0, 70112, '\p{Is_Block=sharada}', "");
    Expect(1, 70112, '\p{^Is_Block=sharada}', "");
    Expect(1, 70112, '\P{Is_Block=sharada}', "");
    Expect(0, 70112, '\P{^Is_Block=sharada}', "");
    Expect(1, 70111, '\p{Is_Block:   -	sharada}', "");
    Expect(0, 70111, '\p{^Is_Block:   -	sharada}', "");
    Expect(0, 70111, '\P{Is_Block:   -	sharada}', "");
    Expect(1, 70111, '\P{^Is_Block:   -	sharada}', "");
    Expect(0, 70112, '\p{Is_Block:   -	sharada}', "");
    Expect(1, 70112, '\p{^Is_Block:   -	sharada}', "");
    Expect(1, 70112, '\P{Is_Block:   -	sharada}', "");
    Expect(0, 70112, '\P{^Is_Block:   -	sharada}', "");
    Error('\p{Is_Blk:   /a/		SHARADA}');
    Error('\P{Is_Blk:   /a/		SHARADA}');
    Expect(1, 70111, '\p{Is_Blk=sharada}', "");
    Expect(0, 70111, '\p{^Is_Blk=sharada}', "");
    Expect(0, 70111, '\P{Is_Blk=sharada}', "");
    Expect(1, 70111, '\P{^Is_Blk=sharada}', "");
    Expect(0, 70112, '\p{Is_Blk=sharada}', "");
    Expect(1, 70112, '\p{^Is_Blk=sharada}', "");
    Expect(1, 70112, '\P{Is_Blk=sharada}', "");
    Expect(0, 70112, '\P{^Is_Blk=sharada}', "");
    Expect(1, 70111, '\p{Is_Blk=	 sharada}', "");
    Expect(0, 70111, '\p{^Is_Blk=	 sharada}', "");
    Expect(0, 70111, '\P{Is_Blk=	 sharada}', "");
    Expect(1, 70111, '\P{^Is_Blk=	 sharada}', "");
    Expect(0, 70112, '\p{Is_Blk=	 sharada}', "");
    Expect(1, 70112, '\p{^Is_Blk=	 sharada}', "");
    Expect(1, 70112, '\P{Is_Blk=	 sharada}', "");
    Expect(0, 70112, '\P{^Is_Blk=	 sharada}', "");
    Error('\p{Block=--Shavian:=}');
    Error('\P{Block=--Shavian:=}');
    Expect(1, 66687, '\p{Block=:\AShavian\z:}', "");;
    Expect(0, 66688, '\p{Block=:\AShavian\z:}', "");;
    Expect(1, 66687, '\p{Block=shavian}', "");
    Expect(0, 66687, '\p{^Block=shavian}', "");
    Expect(0, 66687, '\P{Block=shavian}', "");
    Expect(1, 66687, '\P{^Block=shavian}', "");
    Expect(0, 66688, '\p{Block=shavian}', "");
    Expect(1, 66688, '\p{^Block=shavian}', "");
    Expect(1, 66688, '\P{Block=shavian}', "");
    Expect(0, 66688, '\P{^Block=shavian}', "");
    Expect(1, 66687, '\p{Block=:\Ashavian\z:}', "");;
    Expect(0, 66688, '\p{Block=:\Ashavian\z:}', "");;
    Expect(1, 66687, '\p{Block:   	Shavian}', "");
    Expect(0, 66687, '\p{^Block:   	Shavian}', "");
    Expect(0, 66687, '\P{Block:   	Shavian}', "");
    Expect(1, 66687, '\P{^Block:   	Shavian}', "");
    Expect(0, 66688, '\p{Block:   	Shavian}', "");
    Expect(1, 66688, '\p{^Block:   	Shavian}', "");
    Expect(1, 66688, '\P{Block:   	Shavian}', "");
    Expect(0, 66688, '\P{^Block:   	Shavian}', "");
    Error('\p{Blk=_/a/SHAVIAN}');
    Error('\P{Blk=_/a/SHAVIAN}');
    Expect(1, 66687, '\p{Blk=:\AShavian\z:}', "");;
    Expect(0, 66688, '\p{Blk=:\AShavian\z:}', "");;
    Expect(1, 66687, '\p{Blk=shavian}', "");
    Expect(0, 66687, '\p{^Blk=shavian}', "");
    Expect(0, 66687, '\P{Blk=shavian}', "");
    Expect(1, 66687, '\P{^Blk=shavian}', "");
    Expect(0, 66688, '\p{Blk=shavian}', "");
    Expect(1, 66688, '\p{^Blk=shavian}', "");
    Expect(1, 66688, '\P{Blk=shavian}', "");
    Expect(0, 66688, '\P{^Blk=shavian}', "");
    Expect(1, 66687, '\p{Blk=:\Ashavian\z:}', "");;
    Expect(0, 66688, '\p{Blk=:\Ashavian\z:}', "");;
    Expect(1, 66687, '\p{Blk=_shavian}', "");
    Expect(0, 66687, '\p{^Blk=_shavian}', "");
    Expect(0, 66687, '\P{Blk=_shavian}', "");
    Expect(1, 66687, '\P{^Blk=_shavian}', "");
    Expect(0, 66688, '\p{Blk=_shavian}', "");
    Expect(1, 66688, '\p{^Blk=_shavian}', "");
    Expect(1, 66688, '\P{Blk=_shavian}', "");
    Expect(0, 66688, '\P{^Blk=_shavian}', "");
    Error('\p{Is_Block=-Shavian/a/}');
    Error('\P{Is_Block=-Shavian/a/}');
    Expect(1, 66687, '\p{Is_Block=shavian}', "");
    Expect(0, 66687, '\p{^Is_Block=shavian}', "");
    Expect(0, 66687, '\P{Is_Block=shavian}', "");
    Expect(1, 66687, '\P{^Is_Block=shavian}', "");
    Expect(0, 66688, '\p{Is_Block=shavian}', "");
    Expect(1, 66688, '\p{^Is_Block=shavian}', "");
    Expect(1, 66688, '\P{Is_Block=shavian}', "");
    Expect(0, 66688, '\P{^Is_Block=shavian}', "");
    Expect(1, 66687, '\p{Is_Block=_	Shavian}', "");
    Expect(0, 66687, '\p{^Is_Block=_	Shavian}', "");
    Expect(0, 66687, '\P{Is_Block=_	Shavian}', "");
    Expect(1, 66687, '\P{^Is_Block=_	Shavian}', "");
    Expect(0, 66688, '\p{Is_Block=_	Shavian}', "");
    Expect(1, 66688, '\p{^Is_Block=_	Shavian}', "");
    Expect(1, 66688, '\P{Is_Block=_	Shavian}', "");
    Expect(0, 66688, '\P{^Is_Block=_	Shavian}', "");
    Error('\p{Is_Blk=:=_shavian}');
    Error('\P{Is_Blk=:=_shavian}');
    Expect(1, 66687, '\p{Is_Blk=shavian}', "");
    Expect(0, 66687, '\p{^Is_Blk=shavian}', "");
    Expect(0, 66687, '\P{Is_Blk=shavian}', "");
    Expect(1, 66687, '\P{^Is_Blk=shavian}', "");
    Expect(0, 66688, '\p{Is_Blk=shavian}', "");
    Expect(1, 66688, '\p{^Is_Blk=shavian}', "");
    Expect(1, 66688, '\P{Is_Blk=shavian}', "");
    Expect(0, 66688, '\P{^Is_Blk=shavian}', "");
    Expect(1, 66687, '\p{Is_Blk:	-	SHAVIAN}', "");
    Expect(0, 66687, '\p{^Is_Blk:	-	SHAVIAN}', "");
    Expect(0, 66687, '\P{Is_Blk:	-	SHAVIAN}', "");
    Expect(1, 66687, '\P{^Is_Blk:	-	SHAVIAN}', "");
    Expect(0, 66688, '\p{Is_Blk:	-	SHAVIAN}', "");
    Expect(1, 66688, '\p{^Is_Blk:	-	SHAVIAN}', "");
    Expect(1, 66688, '\P{Is_Blk:	-	SHAVIAN}', "");
    Expect(0, 66688, '\P{^Is_Blk:	-	SHAVIAN}', "");
    Error('\p{Block=_	Shorthand_format_controls/a/}');
    Error('\P{Block=_	Shorthand_format_controls/a/}');
    Expect(1, 113839, '\p{Block=:\AShorthand_Format_Controls\z:}', "");;
    Expect(0, 113840, '\p{Block=:\AShorthand_Format_Controls\z:}', "");;
    Expect(1, 113839, '\p{Block=shorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^Block=shorthandformatcontrols}', "");
    Expect(0, 113839, '\P{Block=shorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^Block=shorthandformatcontrols}', "");
    Expect(0, 113840, '\p{Block=shorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^Block=shorthandformatcontrols}', "");
    Expect(1, 113840, '\P{Block=shorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^Block=shorthandformatcontrols}', "");
    Expect(1, 113839, '\p{Block=:\Ashorthandformatcontrols\z:}', "");;
    Expect(0, 113840, '\p{Block=:\Ashorthandformatcontrols\z:}', "");;
    Expect(1, 113839, '\p{Block:	SHORTHAND_format_Controls}', "");
    Expect(0, 113839, '\p{^Block:	SHORTHAND_format_Controls}', "");
    Expect(0, 113839, '\P{Block:	SHORTHAND_format_Controls}', "");
    Expect(1, 113839, '\P{^Block:	SHORTHAND_format_Controls}', "");
    Expect(0, 113840, '\p{Block:	SHORTHAND_format_Controls}', "");
    Expect(1, 113840, '\p{^Block:	SHORTHAND_format_Controls}', "");
    Expect(1, 113840, '\P{Block:	SHORTHAND_format_Controls}', "");
    Expect(0, 113840, '\P{^Block:	SHORTHAND_format_Controls}', "");
    Error('\p{Blk=_-shorthand_Format_Controls/a/}');
    Error('\P{Blk=_-shorthand_Format_Controls/a/}');
    Expect(1, 113839, '\p{Blk=:\AShorthand_Format_Controls\z:}', "");;
    Expect(0, 113840, '\p{Blk=:\AShorthand_Format_Controls\z:}', "");;
    Expect(1, 113839, '\p{Blk=shorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^Blk=shorthandformatcontrols}', "");
    Expect(0, 113839, '\P{Blk=shorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^Blk=shorthandformatcontrols}', "");
    Expect(0, 113840, '\p{Blk=shorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^Blk=shorthandformatcontrols}', "");
    Expect(1, 113840, '\P{Blk=shorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^Blk=shorthandformatcontrols}', "");
    Expect(1, 113839, '\p{Blk=:\Ashorthandformatcontrols\z:}', "");;
    Expect(0, 113840, '\p{Blk=:\Ashorthandformatcontrols\z:}', "");;
    Expect(1, 113839, '\p{Blk=_shorthand_Format_controls}', "");
    Expect(0, 113839, '\p{^Blk=_shorthand_Format_controls}', "");
    Expect(0, 113839, '\P{Blk=_shorthand_Format_controls}', "");
    Expect(1, 113839, '\P{^Blk=_shorthand_Format_controls}', "");
    Expect(0, 113840, '\p{Blk=_shorthand_Format_controls}', "");
    Expect(1, 113840, '\p{^Blk=_shorthand_Format_controls}', "");
    Expect(1, 113840, '\P{Blk=_shorthand_Format_controls}', "");
    Expect(0, 113840, '\P{^Blk=_shorthand_Format_controls}', "");
    Error('\p{Is_Block=-/a/shorthand_format_controls}');
    Error('\P{Is_Block=-/a/shorthand_format_controls}');
    Expect(1, 113839, '\p{Is_Block=shorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^Is_Block=shorthandformatcontrols}', "");
    Expect(0, 113839, '\P{Is_Block=shorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^Is_Block=shorthandformatcontrols}', "");
    Expect(0, 113840, '\p{Is_Block=shorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^Is_Block=shorthandformatcontrols}', "");
    Expect(1, 113840, '\P{Is_Block=shorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^Is_Block=shorthandformatcontrols}', "");
    Expect(1, 113839, '\p{Is_Block=	SHORTHAND_Format_controls}', "");
    Expect(0, 113839, '\p{^Is_Block=	SHORTHAND_Format_controls}', "");
    Expect(0, 113839, '\P{Is_Block=	SHORTHAND_Format_controls}', "");
    Expect(1, 113839, '\P{^Is_Block=	SHORTHAND_Format_controls}', "");
    Expect(0, 113840, '\p{Is_Block=	SHORTHAND_Format_controls}', "");
    Expect(1, 113840, '\p{^Is_Block=	SHORTHAND_Format_controls}', "");
    Expect(1, 113840, '\P{Is_Block=	SHORTHAND_Format_controls}', "");
    Expect(0, 113840, '\P{^Is_Block=	SHORTHAND_Format_controls}', "");
    Error('\p{Is_Blk=/a/_shorthand_Format_controls}');
    Error('\P{Is_Blk=/a/_shorthand_Format_controls}');
    Expect(1, 113839, '\p{Is_Blk=shorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^Is_Blk=shorthandformatcontrols}', "");
    Expect(0, 113839, '\P{Is_Blk=shorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^Is_Blk=shorthandformatcontrols}', "");
    Expect(0, 113840, '\p{Is_Blk=shorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^Is_Blk=shorthandformatcontrols}', "");
    Expect(1, 113840, '\P{Is_Blk=shorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^Is_Blk=shorthandformatcontrols}', "");
    Expect(1, 113839, '\p{Is_Blk=- shorthand_Format_controls}', "");
    Expect(0, 113839, '\p{^Is_Blk=- shorthand_Format_controls}', "");
    Expect(0, 113839, '\P{Is_Blk=- shorthand_Format_controls}', "");
    Expect(1, 113839, '\P{^Is_Blk=- shorthand_Format_controls}', "");
    Expect(0, 113840, '\p{Is_Blk=- shorthand_Format_controls}', "");
    Expect(1, 113840, '\p{^Is_Blk=- shorthand_Format_controls}', "");
    Expect(1, 113840, '\P{Is_Blk=- shorthand_Format_controls}', "");
    Expect(0, 113840, '\P{^Is_Blk=- shorthand_Format_controls}', "");
    Error('\p{Block=-:=siddham}');
    Error('\P{Block=-:=siddham}');
    Expect(1, 71167, '\p{Block=:\ASiddham\z:}', "");;
    Expect(0, 71168, '\p{Block=:\ASiddham\z:}', "");;
    Expect(1, 71167, '\p{Block=siddham}', "");
    Expect(0, 71167, '\p{^Block=siddham}', "");
    Expect(0, 71167, '\P{Block=siddham}', "");
    Expect(1, 71167, '\P{^Block=siddham}', "");
    Expect(0, 71168, '\p{Block=siddham}', "");
    Expect(1, 71168, '\p{^Block=siddham}', "");
    Expect(1, 71168, '\P{Block=siddham}', "");
    Expect(0, 71168, '\P{^Block=siddham}', "");
    Expect(1, 71167, '\p{Block=:\Asiddham\z:}', "");;
    Expect(0, 71168, '\p{Block=:\Asiddham\z:}', "");;
    Expect(1, 71167, '\p{Block=_Siddham}', "");
    Expect(0, 71167, '\p{^Block=_Siddham}', "");
    Expect(0, 71167, '\P{Block=_Siddham}', "");
    Expect(1, 71167, '\P{^Block=_Siddham}', "");
    Expect(0, 71168, '\p{Block=_Siddham}', "");
    Expect(1, 71168, '\p{^Block=_Siddham}', "");
    Expect(1, 71168, '\P{Block=_Siddham}', "");
    Expect(0, 71168, '\P{^Block=_Siddham}', "");
    Error('\p{Blk=__SIDDHAM/a/}');
    Error('\P{Blk=__SIDDHAM/a/}');
    Expect(1, 71167, '\p{Blk=:\ASiddham\z:}', "");;
    Expect(0, 71168, '\p{Blk=:\ASiddham\z:}', "");;
    Expect(1, 71167, '\p{Blk=siddham}', "");
    Expect(0, 71167, '\p{^Blk=siddham}', "");
    Expect(0, 71167, '\P{Blk=siddham}', "");
    Expect(1, 71167, '\P{^Blk=siddham}', "");
    Expect(0, 71168, '\p{Blk=siddham}', "");
    Expect(1, 71168, '\p{^Blk=siddham}', "");
    Expect(1, 71168, '\P{Blk=siddham}', "");
    Expect(0, 71168, '\P{^Blk=siddham}', "");
    Expect(1, 71167, '\p{Blk=:\Asiddham\z:}', "");;
    Expect(0, 71168, '\p{Blk=:\Asiddham\z:}', "");;
    Expect(1, 71167, '\p{Blk=		Siddham}', "");
    Expect(0, 71167, '\p{^Blk=		Siddham}', "");
    Expect(0, 71167, '\P{Blk=		Siddham}', "");
    Expect(1, 71167, '\P{^Blk=		Siddham}', "");
    Expect(0, 71168, '\p{Blk=		Siddham}', "");
    Expect(1, 71168, '\p{^Blk=		Siddham}', "");
    Expect(1, 71168, '\P{Blk=		Siddham}', "");
    Expect(0, 71168, '\P{^Blk=		Siddham}', "");
    Error('\p{Is_Block=:=_	Siddham}');
    Error('\P{Is_Block=:=_	Siddham}');
    Expect(1, 71167, '\p{Is_Block=siddham}', "");
    Expect(0, 71167, '\p{^Is_Block=siddham}', "");
    Expect(0, 71167, '\P{Is_Block=siddham}', "");
    Expect(1, 71167, '\P{^Is_Block=siddham}', "");
    Expect(0, 71168, '\p{Is_Block=siddham}', "");
    Expect(1, 71168, '\p{^Is_Block=siddham}', "");
    Expect(1, 71168, '\P{Is_Block=siddham}', "");
    Expect(0, 71168, '\P{^Is_Block=siddham}', "");
    Expect(1, 71167, '\p{Is_Block:		SIDDHAM}', "");
    Expect(0, 71167, '\p{^Is_Block:		SIDDHAM}', "");
    Expect(0, 71167, '\P{Is_Block:		SIDDHAM}', "");
    Expect(1, 71167, '\P{^Is_Block:		SIDDHAM}', "");
    Expect(0, 71168, '\p{Is_Block:		SIDDHAM}', "");
    Expect(1, 71168, '\p{^Is_Block:		SIDDHAM}', "");
    Expect(1, 71168, '\P{Is_Block:		SIDDHAM}', "");
    Expect(0, 71168, '\P{^Is_Block:		SIDDHAM}', "");
    Error('\p{Is_Blk=_:=SIDDHAM}');
    Error('\P{Is_Blk=_:=SIDDHAM}');
    Expect(1, 71167, '\p{Is_Blk=siddham}', "");
    Expect(0, 71167, '\p{^Is_Blk=siddham}', "");
    Expect(0, 71167, '\P{Is_Blk=siddham}', "");
    Expect(1, 71167, '\P{^Is_Blk=siddham}', "");
    Expect(0, 71168, '\p{Is_Blk=siddham}', "");
    Expect(1, 71168, '\p{^Is_Blk=siddham}', "");
    Expect(1, 71168, '\P{Is_Blk=siddham}', "");
    Expect(0, 71168, '\P{^Is_Blk=siddham}', "");
    Expect(1, 71167, '\p{Is_Blk=-	siddham}', "");
    Expect(0, 71167, '\p{^Is_Blk=-	siddham}', "");
    Expect(0, 71167, '\P{Is_Blk=-	siddham}', "");
    Expect(1, 71167, '\P{^Is_Blk=-	siddham}', "");
    Expect(0, 71168, '\p{Is_Blk=-	siddham}', "");
    Expect(1, 71168, '\p{^Is_Blk=-	siddham}', "");
    Expect(1, 71168, '\P{Is_Blk=-	siddham}', "");
    Expect(0, 71168, '\P{^Is_Blk=-	siddham}', "");
    Error('\p{Block=/a/ -sinhala}');
    Error('\P{Block=/a/ -sinhala}');
    Expect(1, 3583, '\p{Block=:\ASinhala\z:}', "");;
    Expect(0, 3584, '\p{Block=:\ASinhala\z:}', "");;
    Expect(1, 3583, '\p{Block:	sinhala}', "");
    Expect(0, 3583, '\p{^Block:	sinhala}', "");
    Expect(0, 3583, '\P{Block:	sinhala}', "");
    Expect(1, 3583, '\P{^Block:	sinhala}', "");
    Expect(0, 3584, '\p{Block:	sinhala}', "");
    Expect(1, 3584, '\p{^Block:	sinhala}', "");
    Expect(1, 3584, '\P{Block:	sinhala}', "");
    Expect(0, 3584, '\P{^Block:	sinhala}', "");
    Expect(1, 3583, '\p{Block=:\Asinhala\z:}', "");;
    Expect(0, 3584, '\p{Block=:\Asinhala\z:}', "");;
    Expect(1, 3583, '\p{Block=		Sinhala}', "");
    Expect(0, 3583, '\p{^Block=		Sinhala}', "");
    Expect(0, 3583, '\P{Block=		Sinhala}', "");
    Expect(1, 3583, '\P{^Block=		Sinhala}', "");
    Expect(0, 3584, '\p{Block=		Sinhala}', "");
    Expect(1, 3584, '\p{^Block=		Sinhala}', "");
    Expect(1, 3584, '\P{Block=		Sinhala}', "");
    Expect(0, 3584, '\P{^Block=		Sinhala}', "");
    Error('\p{Blk=:=  SINHALA}');
    Error('\P{Blk=:=  SINHALA}');
    Expect(1, 3583, '\p{Blk=:\ASinhala\z:}', "");;
    Expect(0, 3584, '\p{Blk=:\ASinhala\z:}', "");;
    Expect(1, 3583, '\p{Blk=sinhala}', "");
    Expect(0, 3583, '\p{^Blk=sinhala}', "");
    Expect(0, 3583, '\P{Blk=sinhala}', "");
    Expect(1, 3583, '\P{^Blk=sinhala}', "");
    Expect(0, 3584, '\p{Blk=sinhala}', "");
    Expect(1, 3584, '\p{^Blk=sinhala}', "");
    Expect(1, 3584, '\P{Blk=sinhala}', "");
    Expect(0, 3584, '\P{^Blk=sinhala}', "");
    Expect(1, 3583, '\p{Blk=:\Asinhala\z:}', "");;
    Expect(0, 3584, '\p{Blk=:\Asinhala\z:}', "");;
    Expect(1, 3583, '\p{Blk=  SINHALA}', "");
    Expect(0, 3583, '\p{^Blk=  SINHALA}', "");
    Expect(0, 3583, '\P{Blk=  SINHALA}', "");
    Expect(1, 3583, '\P{^Blk=  SINHALA}', "");
    Expect(0, 3584, '\p{Blk=  SINHALA}', "");
    Expect(1, 3584, '\p{^Blk=  SINHALA}', "");
    Expect(1, 3584, '\P{Blk=  SINHALA}', "");
    Expect(0, 3584, '\P{^Blk=  SINHALA}', "");
    Error('\p{Is_Block=	/a/SINHALA}');
    Error('\P{Is_Block=	/a/SINHALA}');
    Expect(1, 3583, '\p{Is_Block=sinhala}', "");
    Expect(0, 3583, '\p{^Is_Block=sinhala}', "");
    Expect(0, 3583, '\P{Is_Block=sinhala}', "");
    Expect(1, 3583, '\P{^Is_Block=sinhala}', "");
    Expect(0, 3584, '\p{Is_Block=sinhala}', "");
    Expect(1, 3584, '\p{^Is_Block=sinhala}', "");
    Expect(1, 3584, '\P{Is_Block=sinhala}', "");
    Expect(0, 3584, '\P{^Is_Block=sinhala}', "");
    Expect(1, 3583, '\p{Is_Block=	-Sinhala}', "");
    Expect(0, 3583, '\p{^Is_Block=	-Sinhala}', "");
    Expect(0, 3583, '\P{Is_Block=	-Sinhala}', "");
    Expect(1, 3583, '\P{^Is_Block=	-Sinhala}', "");
    Expect(0, 3584, '\p{Is_Block=	-Sinhala}', "");
    Expect(1, 3584, '\p{^Is_Block=	-Sinhala}', "");
    Expect(1, 3584, '\P{Is_Block=	-Sinhala}', "");
    Expect(0, 3584, '\P{^Is_Block=	-Sinhala}', "");
    Error('\p{Is_Blk= /a/SINHALA}');
    Error('\P{Is_Blk= /a/SINHALA}');
    Expect(1, 3583, '\p{Is_Blk=sinhala}', "");
    Expect(0, 3583, '\p{^Is_Blk=sinhala}', "");
    Expect(0, 3583, '\P{Is_Blk=sinhala}', "");
    Expect(1, 3583, '\P{^Is_Blk=sinhala}', "");
    Expect(0, 3584, '\p{Is_Blk=sinhala}', "");
    Expect(1, 3584, '\p{^Is_Blk=sinhala}', "");
    Expect(1, 3584, '\P{Is_Blk=sinhala}', "");
    Expect(0, 3584, '\P{^Is_Blk=sinhala}', "");
    Expect(1, 3583, '\p{Is_Blk= Sinhala}', "");
    Expect(0, 3583, '\p{^Is_Blk= Sinhala}', "");
    Expect(0, 3583, '\P{Is_Blk= Sinhala}', "");
    Expect(1, 3583, '\P{^Is_Blk= Sinhala}', "");
    Expect(0, 3584, '\p{Is_Blk= Sinhala}', "");
    Expect(1, 3584, '\p{^Is_Blk= Sinhala}', "");
    Expect(1, 3584, '\P{Is_Blk= Sinhala}', "");
    Expect(0, 3584, '\P{^Is_Blk= Sinhala}', "");
    Error('\p{Block=/a/ Sinhala_Archaic_Numbers}');
    Error('\P{Block=/a/ Sinhala_Archaic_Numbers}');
    Expect(1, 70143, '\p{Block=:\ASinhala_Archaic_Numbers\z:}', "");;
    Expect(0, 70144, '\p{Block=:\ASinhala_Archaic_Numbers\z:}', "");;
    Expect(1, 70143, '\p{Block=sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^Block=sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{Block=sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^Block=sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{Block=sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^Block=sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{Block=sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^Block=sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{Block=:\Asinhalaarchaicnumbers\z:}', "");;
    Expect(0, 70144, '\p{Block=:\Asinhalaarchaicnumbers\z:}', "");;
    Expect(1, 70143, '\p{Block=	Sinhala_Archaic_Numbers}', "");
    Expect(0, 70143, '\p{^Block=	Sinhala_Archaic_Numbers}', "");
    Expect(0, 70143, '\P{Block=	Sinhala_Archaic_Numbers}', "");
    Expect(1, 70143, '\P{^Block=	Sinhala_Archaic_Numbers}', "");
    Expect(0, 70144, '\p{Block=	Sinhala_Archaic_Numbers}', "");
    Expect(1, 70144, '\p{^Block=	Sinhala_Archaic_Numbers}', "");
    Expect(1, 70144, '\P{Block=	Sinhala_Archaic_Numbers}', "");
    Expect(0, 70144, '\P{^Block=	Sinhala_Archaic_Numbers}', "");
    Error('\p{Blk=_Sinhala_Archaic_numbers/a/}');
    Error('\P{Blk=_Sinhala_Archaic_numbers/a/}');
    Expect(1, 70143, '\p{Blk=:\ASinhala_Archaic_Numbers\z:}', "");;
    Expect(0, 70144, '\p{Blk=:\ASinhala_Archaic_Numbers\z:}', "");;
    Expect(1, 70143, '\p{Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{Blk=:\Asinhalaarchaicnumbers\z:}', "");;
    Expect(0, 70144, '\p{Blk=:\Asinhalaarchaicnumbers\z:}', "");;
    Expect(1, 70143, '\p{Blk=__Sinhala_Archaic_Numbers}', "");
    Expect(0, 70143, '\p{^Blk=__Sinhala_Archaic_Numbers}', "");
    Expect(0, 70143, '\P{Blk=__Sinhala_Archaic_Numbers}', "");
    Expect(1, 70143, '\P{^Blk=__Sinhala_Archaic_Numbers}', "");
    Expect(0, 70144, '\p{Blk=__Sinhala_Archaic_Numbers}', "");
    Expect(1, 70144, '\p{^Blk=__Sinhala_Archaic_Numbers}', "");
    Expect(1, 70144, '\P{Blk=__Sinhala_Archaic_Numbers}', "");
    Expect(0, 70144, '\P{^Blk=__Sinhala_Archaic_Numbers}', "");
    Error('\p{Is_Block=-	sinhala_archaic_NUMBERS/a/}');
    Error('\P{Is_Block=-	sinhala_archaic_NUMBERS/a/}');
    Expect(1, 70143, '\p{Is_Block: sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^Is_Block: sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{Is_Block: sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^Is_Block: sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{Is_Block: sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^Is_Block: sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{Is_Block: sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^Is_Block: sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{Is_Block=  Sinhala_Archaic_Numbers}', "");
    Expect(0, 70143, '\p{^Is_Block=  Sinhala_Archaic_Numbers}', "");
    Expect(0, 70143, '\P{Is_Block=  Sinhala_Archaic_Numbers}', "");
    Expect(1, 70143, '\P{^Is_Block=  Sinhala_Archaic_Numbers}', "");
    Expect(0, 70144, '\p{Is_Block=  Sinhala_Archaic_Numbers}', "");
    Expect(1, 70144, '\p{^Is_Block=  Sinhala_Archaic_Numbers}', "");
    Expect(1, 70144, '\P{Is_Block=  Sinhala_Archaic_Numbers}', "");
    Expect(0, 70144, '\P{^Is_Block=  Sinhala_Archaic_Numbers}', "");
    Error('\p{Is_Blk=Sinhala_archaic_NUMBERS/a/}');
    Error('\P{Is_Blk=Sinhala_archaic_NUMBERS/a/}');
    Expect(1, 70143, '\p{Is_Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^Is_Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{Is_Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^Is_Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{Is_Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^Is_Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{Is_Blk=sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^Is_Blk=sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{Is_Blk=__sinhala_Archaic_Numbers}', "");
    Expect(0, 70143, '\p{^Is_Blk=__sinhala_Archaic_Numbers}', "");
    Expect(0, 70143, '\P{Is_Blk=__sinhala_Archaic_Numbers}', "");
    Expect(1, 70143, '\P{^Is_Blk=__sinhala_Archaic_Numbers}', "");
    Expect(0, 70144, '\p{Is_Blk=__sinhala_Archaic_Numbers}', "");
    Expect(1, 70144, '\p{^Is_Blk=__sinhala_Archaic_Numbers}', "");
    Expect(1, 70144, '\P{Is_Blk=__sinhala_Archaic_Numbers}', "");
    Expect(0, 70144, '\P{^Is_Blk=__sinhala_Archaic_Numbers}', "");
    Error('\p{Block=/a/_small_Form_VARIANTS}');
    Error('\P{Block=/a/_small_Form_VARIANTS}');
    Expect(1, 65135, '\p{Block=:\ASmall_Form_Variants\z:}', "");;
    Expect(0, 65136, '\p{Block=:\ASmall_Form_Variants\z:}', "");;
    Expect(1, 65135, '\p{Block=smallformvariants}', "");
    Expect(0, 65135, '\p{^Block=smallformvariants}', "");
    Expect(0, 65135, '\P{Block=smallformvariants}', "");
    Expect(1, 65135, '\P{^Block=smallformvariants}', "");
    Expect(0, 65136, '\p{Block=smallformvariants}', "");
    Expect(1, 65136, '\p{^Block=smallformvariants}', "");
    Expect(1, 65136, '\P{Block=smallformvariants}', "");
    Expect(0, 65136, '\P{^Block=smallformvariants}', "");
    Expect(1, 65135, '\p{Block=:\Asmallformvariants\z:}', "");;
    Expect(0, 65136, '\p{Block=:\Asmallformvariants\z:}', "");;
    Expect(1, 65135, '\p{Block=__Small_form_Variants}', "");
    Expect(0, 65135, '\p{^Block=__Small_form_Variants}', "");
    Expect(0, 65135, '\P{Block=__Small_form_Variants}', "");
    Expect(1, 65135, '\P{^Block=__Small_form_Variants}', "");
    Expect(0, 65136, '\p{Block=__Small_form_Variants}', "");
    Expect(1, 65136, '\p{^Block=__Small_form_Variants}', "");
    Expect(1, 65136, '\P{Block=__Small_form_Variants}', "");
    Expect(0, 65136, '\P{^Block=__Small_form_Variants}', "");
    Error('\p{Blk=_/a/small_Forms}');
    Error('\P{Blk=_/a/small_Forms}');
    Expect(1, 65135, '\p{Blk=:\ASmall_Forms\z:}', "");;
    Expect(0, 65136, '\p{Blk=:\ASmall_Forms\z:}', "");;
    Expect(1, 65135, '\p{Blk=smallforms}', "");
    Expect(0, 65135, '\p{^Blk=smallforms}', "");
    Expect(0, 65135, '\P{Blk=smallforms}', "");
    Expect(1, 65135, '\P{^Blk=smallforms}', "");
    Expect(0, 65136, '\p{Blk=smallforms}', "");
    Expect(1, 65136, '\p{^Blk=smallforms}', "");
    Expect(1, 65136, '\P{Blk=smallforms}', "");
    Expect(0, 65136, '\P{^Blk=smallforms}', "");
    Expect(1, 65135, '\p{Blk=:\Asmallforms\z:}', "");;
    Expect(0, 65136, '\p{Blk=:\Asmallforms\z:}', "");;
    Expect(1, 65135, '\p{Blk=-	SMALL_FORMS}', "");
    Expect(0, 65135, '\p{^Blk=-	SMALL_FORMS}', "");
    Expect(0, 65135, '\P{Blk=-	SMALL_FORMS}', "");
    Expect(1, 65135, '\P{^Blk=-	SMALL_FORMS}', "");
    Expect(0, 65136, '\p{Blk=-	SMALL_FORMS}', "");
    Expect(1, 65136, '\p{^Blk=-	SMALL_FORMS}', "");
    Expect(1, 65136, '\P{Blk=-	SMALL_FORMS}', "");
    Expect(0, 65136, '\P{^Blk=-	SMALL_FORMS}', "");
    Error('\p{Is_Block:_/a/Small_Form_Variants}');
    Error('\P{Is_Block:_/a/Small_Form_Variants}');
    Expect(1, 65135, '\p{Is_Block=smallformvariants}', "");
    Expect(0, 65135, '\p{^Is_Block=smallformvariants}', "");
    Expect(0, 65135, '\P{Is_Block=smallformvariants}', "");
    Expect(1, 65135, '\P{^Is_Block=smallformvariants}', "");
    Expect(0, 65136, '\p{Is_Block=smallformvariants}', "");
    Expect(1, 65136, '\p{^Is_Block=smallformvariants}', "");
    Expect(1, 65136, '\P{Is_Block=smallformvariants}', "");
    Expect(0, 65136, '\P{^Is_Block=smallformvariants}', "");
    Expect(1, 65135, '\p{Is_Block= _Small_Form_Variants}', "");
    Expect(0, 65135, '\p{^Is_Block= _Small_Form_Variants}', "");
    Expect(0, 65135, '\P{Is_Block= _Small_Form_Variants}', "");
    Expect(1, 65135, '\P{^Is_Block= _Small_Form_Variants}', "");
    Expect(0, 65136, '\p{Is_Block= _Small_Form_Variants}', "");
    Expect(1, 65136, '\p{^Is_Block= _Small_Form_Variants}', "");
    Expect(1, 65136, '\P{Is_Block= _Small_Form_Variants}', "");
    Expect(0, 65136, '\P{^Is_Block= _Small_Form_Variants}', "");
    Error('\p{Is_Blk=:= -SMALL_Forms}');
    Error('\P{Is_Blk=:= -SMALL_Forms}');
    Expect(1, 65135, '\p{Is_Blk=smallforms}', "");
    Expect(0, 65135, '\p{^Is_Blk=smallforms}', "");
    Expect(0, 65135, '\P{Is_Blk=smallforms}', "");
    Expect(1, 65135, '\P{^Is_Blk=smallforms}', "");
    Expect(0, 65136, '\p{Is_Blk=smallforms}', "");
    Expect(1, 65136, '\p{^Is_Blk=smallforms}', "");
    Expect(1, 65136, '\P{Is_Blk=smallforms}', "");
    Expect(0, 65136, '\P{^Is_Blk=smallforms}', "");
    Expect(1, 65135, '\p{Is_Blk= -SMALL_Forms}', "");
    Expect(0, 65135, '\p{^Is_Blk= -SMALL_Forms}', "");
    Expect(0, 65135, '\P{Is_Blk= -SMALL_Forms}', "");
    Expect(1, 65135, '\P{^Is_Blk= -SMALL_Forms}', "");
    Expect(0, 65136, '\p{Is_Blk= -SMALL_Forms}', "");
    Expect(1, 65136, '\p{^Is_Blk= -SMALL_Forms}', "");
    Expect(1, 65136, '\P{Is_Blk= -SMALL_Forms}', "");
    Expect(0, 65136, '\P{^Is_Blk= -SMALL_Forms}', "");
    Error('\p{Block: 	 Small_Kana_extension/a/}');
    Error('\P{Block: 	 Small_Kana_extension/a/}');
    Expect(1, 110959, '\p{Block=:\ASmall_Kana_Extension\z:}', "");;
    Expect(0, 110960, '\p{Block=:\ASmall_Kana_Extension\z:}', "");;
    Expect(1, 110959, '\p{Block=smallkanaextension}', "");
    Expect(0, 110959, '\p{^Block=smallkanaextension}', "");
    Expect(0, 110959, '\P{Block=smallkanaextension}', "");
    Expect(1, 110959, '\P{^Block=smallkanaextension}', "");
    Expect(0, 110960, '\p{Block=smallkanaextension}', "");
    Expect(1, 110960, '\p{^Block=smallkanaextension}', "");
    Expect(1, 110960, '\P{Block=smallkanaextension}', "");
    Expect(0, 110960, '\P{^Block=smallkanaextension}', "");
    Expect(1, 110959, '\p{Block=:\Asmallkanaextension\z:}', "");;
    Expect(0, 110960, '\p{Block=:\Asmallkanaextension\z:}', "");;
    Expect(1, 110959, '\p{Block=__SMALL_kana_EXTENSION}', "");
    Expect(0, 110959, '\p{^Block=__SMALL_kana_EXTENSION}', "");
    Expect(0, 110959, '\P{Block=__SMALL_kana_EXTENSION}', "");
    Expect(1, 110959, '\P{^Block=__SMALL_kana_EXTENSION}', "");
    Expect(0, 110960, '\p{Block=__SMALL_kana_EXTENSION}', "");
    Expect(1, 110960, '\p{^Block=__SMALL_kana_EXTENSION}', "");
    Expect(1, 110960, '\P{Block=__SMALL_kana_EXTENSION}', "");
    Expect(0, 110960, '\P{^Block=__SMALL_kana_EXTENSION}', "");
    Error('\p{Blk= :=Small_kana_ext}');
    Error('\P{Blk= :=Small_kana_ext}');
    Expect(1, 110959, '\p{Blk=:\ASmall_Kana_Ext\z:}', "");;
    Expect(0, 110960, '\p{Blk=:\ASmall_Kana_Ext\z:}', "");;
    Expect(1, 110959, '\p{Blk=smallkanaext}', "");
    Expect(0, 110959, '\p{^Blk=smallkanaext}', "");
    Expect(0, 110959, '\P{Blk=smallkanaext}', "");
    Expect(1, 110959, '\P{^Blk=smallkanaext}', "");
    Expect(0, 110960, '\p{Blk=smallkanaext}', "");
    Expect(1, 110960, '\p{^Blk=smallkanaext}', "");
    Expect(1, 110960, '\P{Blk=smallkanaext}', "");
    Expect(0, 110960, '\P{^Blk=smallkanaext}', "");
    Expect(1, 110959, '\p{Blk=:\Asmallkanaext\z:}', "");;
    Expect(0, 110960, '\p{Blk=:\Asmallkanaext\z:}', "");;
    Expect(1, 110959, '\p{Blk=		Small_kana_ext}', "");
    Expect(0, 110959, '\p{^Blk=		Small_kana_ext}', "");
    Expect(0, 110959, '\P{Blk=		Small_kana_ext}', "");
    Expect(1, 110959, '\P{^Blk=		Small_kana_ext}', "");
    Expect(0, 110960, '\p{Blk=		Small_kana_ext}', "");
    Expect(1, 110960, '\p{^Blk=		Small_kana_ext}', "");
    Expect(1, 110960, '\P{Blk=		Small_kana_ext}', "");
    Expect(0, 110960, '\P{^Blk=		Small_kana_ext}', "");
    Error('\p{Is_Block=:=SMALL_kana_Extension}');
    Error('\P{Is_Block=:=SMALL_kana_Extension}');
    Expect(1, 110959, '\p{Is_Block: smallkanaextension}', "");
    Expect(0, 110959, '\p{^Is_Block: smallkanaextension}', "");
    Expect(0, 110959, '\P{Is_Block: smallkanaextension}', "");
    Expect(1, 110959, '\P{^Is_Block: smallkanaextension}', "");
    Expect(0, 110960, '\p{Is_Block: smallkanaextension}', "");
    Expect(1, 110960, '\p{^Is_Block: smallkanaextension}', "");
    Expect(1, 110960, '\P{Is_Block: smallkanaextension}', "");
    Expect(0, 110960, '\P{^Is_Block: smallkanaextension}', "");
    Expect(1, 110959, '\p{Is_Block=--small_Kana_EXTENSION}', "");
    Expect(0, 110959, '\p{^Is_Block=--small_Kana_EXTENSION}', "");
    Expect(0, 110959, '\P{Is_Block=--small_Kana_EXTENSION}', "");
    Expect(1, 110959, '\P{^Is_Block=--small_Kana_EXTENSION}', "");
    Expect(0, 110960, '\p{Is_Block=--small_Kana_EXTENSION}', "");
    Expect(1, 110960, '\p{^Is_Block=--small_Kana_EXTENSION}', "");
    Expect(1, 110960, '\P{Is_Block=--small_Kana_EXTENSION}', "");
    Expect(0, 110960, '\P{^Is_Block=--small_Kana_EXTENSION}', "");
    Error('\p{Is_Blk=	:=SMALL_KANA_ext}');
    Error('\P{Is_Blk=	:=SMALL_KANA_ext}');
    Expect(1, 110959, '\p{Is_Blk:smallkanaext}', "");
    Expect(0, 110959, '\p{^Is_Blk:smallkanaext}', "");
    Expect(0, 110959, '\P{Is_Blk:smallkanaext}', "");
    Expect(1, 110959, '\P{^Is_Blk:smallkanaext}', "");
    Expect(0, 110960, '\p{Is_Blk:smallkanaext}', "");
    Expect(1, 110960, '\p{^Is_Blk:smallkanaext}', "");
    Expect(1, 110960, '\P{Is_Blk:smallkanaext}', "");
    Expect(0, 110960, '\P{^Is_Blk:smallkanaext}', "");
    Expect(1, 110959, '\p{Is_Blk=	_Small_Kana_ext}', "");
    Expect(0, 110959, '\p{^Is_Blk=	_Small_Kana_ext}', "");
    Expect(0, 110959, '\P{Is_Blk=	_Small_Kana_ext}', "");
    Expect(1, 110959, '\P{^Is_Blk=	_Small_Kana_ext}', "");
    Expect(0, 110960, '\p{Is_Blk=	_Small_Kana_ext}', "");
    Expect(1, 110960, '\p{^Is_Blk=	_Small_Kana_ext}', "");
    Expect(1, 110960, '\P{Is_Blk=	_Small_Kana_ext}', "");
    Expect(0, 110960, '\P{^Is_Blk=	_Small_Kana_ext}', "");
    Error('\p{Block:  -SOGDIAN/a/}');
    Error('\P{Block:  -SOGDIAN/a/}');
    Expect(1, 69487, '\p{Block=:\ASogdian\z:}', "");;
    Expect(0, 69488, '\p{Block=:\ASogdian\z:}', "");;
    Expect(1, 69487, '\p{Block=sogdian}', "");
    Expect(0, 69487, '\p{^Block=sogdian}', "");
    Expect(0, 69487, '\P{Block=sogdian}', "");
    Expect(1, 69487, '\P{^Block=sogdian}', "");
    Expect(0, 69488, '\p{Block=sogdian}', "");
    Expect(1, 69488, '\p{^Block=sogdian}', "");
    Expect(1, 69488, '\P{Block=sogdian}', "");
    Expect(0, 69488, '\P{^Block=sogdian}', "");
    Expect(1, 69487, '\p{Block=:\Asogdian\z:}', "");;
    Expect(0, 69488, '\p{Block=:\Asogdian\z:}', "");;
    Expect(1, 69487, '\p{Block= -Sogdian}', "");
    Expect(0, 69487, '\p{^Block= -Sogdian}', "");
    Expect(0, 69487, '\P{Block= -Sogdian}', "");
    Expect(1, 69487, '\P{^Block= -Sogdian}', "");
    Expect(0, 69488, '\p{Block= -Sogdian}', "");
    Expect(1, 69488, '\p{^Block= -Sogdian}', "");
    Expect(1, 69488, '\P{Block= -Sogdian}', "");
    Expect(0, 69488, '\P{^Block= -Sogdian}', "");
    Error('\p{Blk=_:=SOGDIAN}');
    Error('\P{Blk=_:=SOGDIAN}');
    Expect(1, 69487, '\p{Blk=:\ASogdian\z:}', "");;
    Expect(0, 69488, '\p{Blk=:\ASogdian\z:}', "");;
    Expect(1, 69487, '\p{Blk=sogdian}', "");
    Expect(0, 69487, '\p{^Blk=sogdian}', "");
    Expect(0, 69487, '\P{Blk=sogdian}', "");
    Expect(1, 69487, '\P{^Blk=sogdian}', "");
    Expect(0, 69488, '\p{Blk=sogdian}', "");
    Expect(1, 69488, '\p{^Blk=sogdian}', "");
    Expect(1, 69488, '\P{Blk=sogdian}', "");
    Expect(0, 69488, '\P{^Blk=sogdian}', "");
    Expect(1, 69487, '\p{Blk=:\Asogdian\z:}', "");;
    Expect(0, 69488, '\p{Blk=:\Asogdian\z:}', "");;
    Expect(1, 69487, '\p{Blk= sogdian}', "");
    Expect(0, 69487, '\p{^Blk= sogdian}', "");
    Expect(0, 69487, '\P{Blk= sogdian}', "");
    Expect(1, 69487, '\P{^Blk= sogdian}', "");
    Expect(0, 69488, '\p{Blk= sogdian}', "");
    Expect(1, 69488, '\p{^Blk= sogdian}', "");
    Expect(1, 69488, '\P{Blk= sogdian}', "");
    Expect(0, 69488, '\P{^Blk= sogdian}', "");
    Error('\p{Is_Block= :=sogdian}');
    Error('\P{Is_Block= :=sogdian}');
    Expect(1, 69487, '\p{Is_Block=sogdian}', "");
    Expect(0, 69487, '\p{^Is_Block=sogdian}', "");
    Expect(0, 69487, '\P{Is_Block=sogdian}', "");
    Expect(1, 69487, '\P{^Is_Block=sogdian}', "");
    Expect(0, 69488, '\p{Is_Block=sogdian}', "");
    Expect(1, 69488, '\p{^Is_Block=sogdian}', "");
    Expect(1, 69488, '\P{Is_Block=sogdian}', "");
    Expect(0, 69488, '\P{^Is_Block=sogdian}', "");
    Expect(1, 69487, '\p{Is_Block=_-sogdian}', "");
    Expect(0, 69487, '\p{^Is_Block=_-sogdian}', "");
    Expect(0, 69487, '\P{Is_Block=_-sogdian}', "");
    Expect(1, 69487, '\P{^Is_Block=_-sogdian}', "");
    Expect(0, 69488, '\p{Is_Block=_-sogdian}', "");
    Expect(1, 69488, '\p{^Is_Block=_-sogdian}', "");
    Expect(1, 69488, '\P{Is_Block=_-sogdian}', "");
    Expect(0, 69488, '\P{^Is_Block=_-sogdian}', "");
    Error('\p{Is_Blk=:=-	Sogdian}');
    Error('\P{Is_Blk=:=-	Sogdian}');
    Expect(1, 69487, '\p{Is_Blk=sogdian}', "");
    Expect(0, 69487, '\p{^Is_Blk=sogdian}', "");
    Expect(0, 69487, '\P{Is_Blk=sogdian}', "");
    Expect(1, 69487, '\P{^Is_Blk=sogdian}', "");
    Expect(0, 69488, '\p{Is_Blk=sogdian}', "");
    Expect(1, 69488, '\p{^Is_Blk=sogdian}', "");
    Expect(1, 69488, '\P{Is_Blk=sogdian}', "");
    Expect(0, 69488, '\P{^Is_Blk=sogdian}', "");
    Expect(1, 69487, '\p{Is_Blk=-SOGDIAN}', "");
    Expect(0, 69487, '\p{^Is_Blk=-SOGDIAN}', "");
    Expect(0, 69487, '\P{Is_Blk=-SOGDIAN}', "");
    Expect(1, 69487, '\P{^Is_Blk=-SOGDIAN}', "");
    Expect(0, 69488, '\p{Is_Blk=-SOGDIAN}', "");
    Expect(1, 69488, '\p{^Is_Blk=-SOGDIAN}', "");
    Expect(1, 69488, '\P{Is_Blk=-SOGDIAN}', "");
    Expect(0, 69488, '\P{^Is_Blk=-SOGDIAN}', "");
    Error('\p{Block=-:=SORA_Sompeng}');
    Error('\P{Block=-:=SORA_Sompeng}');
    Expect(1, 69887, '\p{Block=:\ASora_Sompeng\z:}', "");;
    Expect(0, 69888, '\p{Block=:\ASora_Sompeng\z:}', "");;
    Expect(1, 69887, '\p{Block=sorasompeng}', "");
    Expect(0, 69887, '\p{^Block=sorasompeng}', "");
    Expect(0, 69887, '\P{Block=sorasompeng}', "");
    Expect(1, 69887, '\P{^Block=sorasompeng}', "");
    Expect(0, 69888, '\p{Block=sorasompeng}', "");
    Expect(1, 69888, '\p{^Block=sorasompeng}', "");
    Expect(1, 69888, '\P{Block=sorasompeng}', "");
    Expect(0, 69888, '\P{^Block=sorasompeng}', "");
    Expect(1, 69887, '\p{Block=:\Asorasompeng\z:}', "");;
    Expect(0, 69888, '\p{Block=:\Asorasompeng\z:}', "");;
    Expect(1, 69887, '\p{Block=_Sora_sompeng}', "");
    Expect(0, 69887, '\p{^Block=_Sora_sompeng}', "");
    Expect(0, 69887, '\P{Block=_Sora_sompeng}', "");
    Expect(1, 69887, '\P{^Block=_Sora_sompeng}', "");
    Expect(0, 69888, '\p{Block=_Sora_sompeng}', "");
    Expect(1, 69888, '\p{^Block=_Sora_sompeng}', "");
    Expect(1, 69888, '\P{Block=_Sora_sompeng}', "");
    Expect(0, 69888, '\P{^Block=_Sora_sompeng}', "");
    Error('\p{Blk=SORA_sompeng/a/}');
    Error('\P{Blk=SORA_sompeng/a/}');
    Expect(1, 69887, '\p{Blk=:\ASora_Sompeng\z:}', "");;
    Expect(0, 69888, '\p{Blk=:\ASora_Sompeng\z:}', "");;
    Expect(1, 69887, '\p{Blk=sorasompeng}', "");
    Expect(0, 69887, '\p{^Blk=sorasompeng}', "");
    Expect(0, 69887, '\P{Blk=sorasompeng}', "");
    Expect(1, 69887, '\P{^Blk=sorasompeng}', "");
    Expect(0, 69888, '\p{Blk=sorasompeng}', "");
    Expect(1, 69888, '\p{^Blk=sorasompeng}', "");
    Expect(1, 69888, '\P{Blk=sorasompeng}', "");
    Expect(0, 69888, '\P{^Blk=sorasompeng}', "");
    Expect(1, 69887, '\p{Blk=:\Asorasompeng\z:}', "");;
    Expect(0, 69888, '\p{Blk=:\Asorasompeng\z:}', "");;
    Expect(1, 69887, '\p{Blk: sora_Sompeng}', "");
    Expect(0, 69887, '\p{^Blk: sora_Sompeng}', "");
    Expect(0, 69887, '\P{Blk: sora_Sompeng}', "");
    Expect(1, 69887, '\P{^Blk: sora_Sompeng}', "");
    Expect(0, 69888, '\p{Blk: sora_Sompeng}', "");
    Expect(1, 69888, '\p{^Blk: sora_Sompeng}', "");
    Expect(1, 69888, '\P{Blk: sora_Sompeng}', "");
    Expect(0, 69888, '\P{^Blk: sora_Sompeng}', "");
    Error('\p{Is_Block=sora_sompeng/a/}');
    Error('\P{Is_Block=sora_sompeng/a/}');
    Expect(1, 69887, '\p{Is_Block=sorasompeng}', "");
    Expect(0, 69887, '\p{^Is_Block=sorasompeng}', "");
    Expect(0, 69887, '\P{Is_Block=sorasompeng}', "");
    Expect(1, 69887, '\P{^Is_Block=sorasompeng}', "");
    Expect(0, 69888, '\p{Is_Block=sorasompeng}', "");
    Expect(1, 69888, '\p{^Is_Block=sorasompeng}', "");
    Expect(1, 69888, '\P{Is_Block=sorasompeng}', "");
    Expect(0, 69888, '\P{^Is_Block=sorasompeng}', "");
    Expect(1, 69887, '\p{Is_Block=_ Sora_sompeng}', "");
    Expect(0, 69887, '\p{^Is_Block=_ Sora_sompeng}', "");
    Expect(0, 69887, '\P{Is_Block=_ Sora_sompeng}', "");
    Expect(1, 69887, '\P{^Is_Block=_ Sora_sompeng}', "");
    Expect(0, 69888, '\p{Is_Block=_ Sora_sompeng}', "");
    Expect(1, 69888, '\p{^Is_Block=_ Sora_sompeng}', "");
    Expect(1, 69888, '\P{Is_Block=_ Sora_sompeng}', "");
    Expect(0, 69888, '\P{^Is_Block=_ Sora_sompeng}', "");
    Error('\p{Is_Blk=/a/ 	sora_Sompeng}');
    Error('\P{Is_Blk=/a/ 	sora_Sompeng}');
    Expect(1, 69887, '\p{Is_Blk=sorasompeng}', "");
    Expect(0, 69887, '\p{^Is_Blk=sorasompeng}', "");
    Expect(0, 69887, '\P{Is_Blk=sorasompeng}', "");
    Expect(1, 69887, '\P{^Is_Blk=sorasompeng}', "");
    Expect(0, 69888, '\p{Is_Blk=sorasompeng}', "");
    Expect(1, 69888, '\p{^Is_Blk=sorasompeng}', "");
    Expect(1, 69888, '\P{Is_Blk=sorasompeng}', "");
    Expect(0, 69888, '\P{^Is_Blk=sorasompeng}', "");
    Expect(1, 69887, '\p{Is_Blk=-_Sora_sompeng}', "");
    Expect(0, 69887, '\p{^Is_Blk=-_Sora_sompeng}', "");
    Expect(0, 69887, '\P{Is_Blk=-_Sora_sompeng}', "");
    Expect(1, 69887, '\P{^Is_Blk=-_Sora_sompeng}', "");
    Expect(0, 69888, '\p{Is_Blk=-_Sora_sompeng}', "");
    Expect(1, 69888, '\p{^Is_Blk=-_Sora_sompeng}', "");
    Expect(1, 69888, '\P{Is_Blk=-_Sora_sompeng}', "");
    Expect(0, 69888, '\P{^Is_Blk=-_Sora_sompeng}', "");
    Error('\p{Block=_soyombo/a/}');
    Error('\P{Block=_soyombo/a/}');
    Expect(1, 72367, '\p{Block=:\ASoyombo\z:}', "");;
    Expect(0, 72368, '\p{Block=:\ASoyombo\z:}', "");;
    Expect(1, 72367, '\p{Block=soyombo}', "");
    Expect(0, 72367, '\p{^Block=soyombo}', "");
    Expect(0, 72367, '\P{Block=soyombo}', "");
    Expect(1, 72367, '\P{^Block=soyombo}', "");
    Expect(0, 72368, '\p{Block=soyombo}', "");
    Expect(1, 72368, '\p{^Block=soyombo}', "");
    Expect(1, 72368, '\P{Block=soyombo}', "");
    Expect(0, 72368, '\P{^Block=soyombo}', "");
    Expect(1, 72367, '\p{Block=:\Asoyombo\z:}', "");;
    Expect(0, 72368, '\p{Block=:\Asoyombo\z:}', "");;
    Expect(1, 72367, '\p{Block= SOYOMBO}', "");
    Expect(0, 72367, '\p{^Block= SOYOMBO}', "");
    Expect(0, 72367, '\P{Block= SOYOMBO}', "");
    Expect(1, 72367, '\P{^Block= SOYOMBO}', "");
    Expect(0, 72368, '\p{Block= SOYOMBO}', "");
    Expect(1, 72368, '\p{^Block= SOYOMBO}', "");
    Expect(1, 72368, '\P{Block= SOYOMBO}', "");
    Expect(0, 72368, '\P{^Block= SOYOMBO}', "");
    Error('\p{Blk=--Soyombo/a/}');
    Error('\P{Blk=--Soyombo/a/}');
    Expect(1, 72367, '\p{Blk=:\ASoyombo\z:}', "");;
    Expect(0, 72368, '\p{Blk=:\ASoyombo\z:}', "");;
    Expect(1, 72367, '\p{Blk=soyombo}', "");
    Expect(0, 72367, '\p{^Blk=soyombo}', "");
    Expect(0, 72367, '\P{Blk=soyombo}', "");
    Expect(1, 72367, '\P{^Blk=soyombo}', "");
    Expect(0, 72368, '\p{Blk=soyombo}', "");
    Expect(1, 72368, '\p{^Blk=soyombo}', "");
    Expect(1, 72368, '\P{Blk=soyombo}', "");
    Expect(0, 72368, '\P{^Blk=soyombo}', "");
    Expect(1, 72367, '\p{Blk=:\Asoyombo\z:}', "");;
    Expect(0, 72368, '\p{Blk=:\Asoyombo\z:}', "");;
    Expect(1, 72367, '\p{Blk= _Soyombo}', "");
    Expect(0, 72367, '\p{^Blk= _Soyombo}', "");
    Expect(0, 72367, '\P{Blk= _Soyombo}', "");
    Expect(1, 72367, '\P{^Blk= _Soyombo}', "");
    Expect(0, 72368, '\p{Blk= _Soyombo}', "");
    Expect(1, 72368, '\p{^Blk= _Soyombo}', "");
    Expect(1, 72368, '\P{Blk= _Soyombo}', "");
    Expect(0, 72368, '\P{^Blk= _Soyombo}', "");
    Error('\p{Is_Block=:=	_Soyombo}');
    Error('\P{Is_Block=:=	_Soyombo}');
    Expect(1, 72367, '\p{Is_Block=soyombo}', "");
    Expect(0, 72367, '\p{^Is_Block=soyombo}', "");
    Expect(0, 72367, '\P{Is_Block=soyombo}', "");
    Expect(1, 72367, '\P{^Is_Block=soyombo}', "");
    Expect(0, 72368, '\p{Is_Block=soyombo}', "");
    Expect(1, 72368, '\p{^Is_Block=soyombo}', "");
    Expect(1, 72368, '\P{Is_Block=soyombo}', "");
    Expect(0, 72368, '\P{^Is_Block=soyombo}', "");
    Expect(1, 72367, '\p{Is_Block= SOYOMBO}', "");
    Expect(0, 72367, '\p{^Is_Block= SOYOMBO}', "");
    Expect(0, 72367, '\P{Is_Block= SOYOMBO}', "");
    Expect(1, 72367, '\P{^Is_Block= SOYOMBO}', "");
    Expect(0, 72368, '\p{Is_Block= SOYOMBO}', "");
    Expect(1, 72368, '\p{^Is_Block= SOYOMBO}', "");
    Expect(1, 72368, '\P{Is_Block= SOYOMBO}', "");
    Expect(0, 72368, '\P{^Is_Block= SOYOMBO}', "");
    Error('\p{Is_Blk=SOYOMBO:=}');
    Error('\P{Is_Blk=SOYOMBO:=}');
    Expect(1, 72367, '\p{Is_Blk=soyombo}', "");
    Expect(0, 72367, '\p{^Is_Blk=soyombo}', "");
    Expect(0, 72367, '\P{Is_Blk=soyombo}', "");
    Expect(1, 72367, '\P{^Is_Blk=soyombo}', "");
    Expect(0, 72368, '\p{Is_Blk=soyombo}', "");
    Expect(1, 72368, '\p{^Is_Blk=soyombo}', "");
    Expect(1, 72368, '\P{Is_Blk=soyombo}', "");
    Expect(0, 72368, '\P{^Is_Blk=soyombo}', "");
    Expect(1, 72367, '\p{Is_Blk=		soyombo}', "");
    Expect(0, 72367, '\p{^Is_Blk=		soyombo}', "");
    Expect(0, 72367, '\P{Is_Blk=		soyombo}', "");
    Expect(1, 72367, '\P{^Is_Blk=		soyombo}', "");
    Expect(0, 72368, '\p{Is_Blk=		soyombo}', "");
    Expect(1, 72368, '\p{^Is_Blk=		soyombo}', "");
    Expect(1, 72368, '\P{Is_Blk=		soyombo}', "");
    Expect(0, 72368, '\P{^Is_Blk=		soyombo}', "");
    Error('\p{Block=/a/-_specials}');
    Error('\P{Block=/a/-_specials}');
    Expect(1, 65520, '\p{Block=:\ASpecials\z:}', "");;
    Expect(0, 65536, '\p{Block=:\ASpecials\z:}', "");;
    Expect(1, 65520, '\p{Block:specials}', "");
    Expect(0, 65520, '\p{^Block:specials}', "");
    Expect(0, 65520, '\P{Block:specials}', "");
    Expect(1, 65520, '\P{^Block:specials}', "");
    Expect(0, 65536, '\p{Block:specials}', "");
    Expect(1, 65536, '\p{^Block:specials}', "");
    Expect(1, 65536, '\P{Block:specials}', "");
    Expect(0, 65536, '\P{^Block:specials}', "");
    Expect(1, 65520, '\p{Block=:\Aspecials\z:}', "");;
    Expect(0, 65536, '\p{Block=:\Aspecials\z:}', "");;
    Expect(1, 65520, '\p{Block=	Specials}', "");
    Expect(0, 65520, '\p{^Block=	Specials}', "");
    Expect(0, 65520, '\P{Block=	Specials}', "");
    Expect(1, 65520, '\P{^Block=	Specials}', "");
    Expect(0, 65536, '\p{Block=	Specials}', "");
    Expect(1, 65536, '\p{^Block=	Specials}', "");
    Expect(1, 65536, '\P{Block=	Specials}', "");
    Expect(0, 65536, '\P{^Block=	Specials}', "");
    Error('\p{Blk: /a/specials}');
    Error('\P{Blk: /a/specials}');
    Expect(1, 65520, '\p{Blk=:\ASpecials\z:}', "");;
    Expect(0, 65536, '\p{Blk=:\ASpecials\z:}', "");;
    Expect(1, 65520, '\p{Blk=specials}', "");
    Expect(0, 65520, '\p{^Blk=specials}', "");
    Expect(0, 65520, '\P{Blk=specials}', "");
    Expect(1, 65520, '\P{^Blk=specials}', "");
    Expect(0, 65536, '\p{Blk=specials}', "");
    Expect(1, 65536, '\p{^Blk=specials}', "");
    Expect(1, 65536, '\P{Blk=specials}', "");
    Expect(0, 65536, '\P{^Blk=specials}', "");
    Expect(1, 65520, '\p{Blk=:\Aspecials\z:}', "");;
    Expect(0, 65536, '\p{Blk=:\Aspecials\z:}', "");;
    Expect(1, 65520, '\p{Blk=_Specials}', "");
    Expect(0, 65520, '\p{^Blk=_Specials}', "");
    Expect(0, 65520, '\P{Blk=_Specials}', "");
    Expect(1, 65520, '\P{^Blk=_Specials}', "");
    Expect(0, 65536, '\p{Blk=_Specials}', "");
    Expect(1, 65536, '\p{^Blk=_Specials}', "");
    Expect(1, 65536, '\P{Blk=_Specials}', "");
    Expect(0, 65536, '\P{^Blk=_Specials}', "");
    Error('\p{Is_Block=-Specials/a/}');
    Error('\P{Is_Block=-Specials/a/}');
    Expect(1, 65520, '\p{Is_Block:   specials}', "");
    Expect(0, 65520, '\p{^Is_Block:   specials}', "");
    Expect(0, 65520, '\P{Is_Block:   specials}', "");
    Expect(1, 65520, '\P{^Is_Block:   specials}', "");
    Expect(0, 65536, '\p{Is_Block:   specials}', "");
    Expect(1, 65536, '\p{^Is_Block:   specials}', "");
    Expect(1, 65536, '\P{Is_Block:   specials}', "");
    Expect(0, 65536, '\P{^Is_Block:   specials}', "");
    Expect(1, 65520, '\p{Is_Block=_ specials}', "");
    Expect(0, 65520, '\p{^Is_Block=_ specials}', "");
    Expect(0, 65520, '\P{Is_Block=_ specials}', "");
    Expect(1, 65520, '\P{^Is_Block=_ specials}', "");
    Expect(0, 65536, '\p{Is_Block=_ specials}', "");
    Expect(1, 65536, '\p{^Is_Block=_ specials}', "");
    Expect(1, 65536, '\P{Is_Block=_ specials}', "");
    Expect(0, 65536, '\P{^Is_Block=_ specials}', "");
    Error('\p{Is_Blk=	/a/Specials}');
    Error('\P{Is_Blk=	/a/Specials}');
    Expect(1, 65520, '\p{Is_Blk=specials}', "");
    Expect(0, 65520, '\p{^Is_Blk=specials}', "");
    Expect(0, 65520, '\P{Is_Blk=specials}', "");
    Expect(1, 65520, '\P{^Is_Blk=specials}', "");
    Expect(0, 65536, '\p{Is_Blk=specials}', "");
    Expect(1, 65536, '\p{^Is_Blk=specials}', "");
    Expect(1, 65536, '\P{Is_Blk=specials}', "");
    Expect(0, 65536, '\P{^Is_Blk=specials}', "");
    Expect(1, 65520, '\p{Is_Blk= SPECIALS}', "");
    Expect(0, 65520, '\p{^Is_Blk= SPECIALS}', "");
    Expect(0, 65520, '\P{Is_Blk= SPECIALS}', "");
    Expect(1, 65520, '\P{^Is_Blk= SPECIALS}', "");
    Expect(0, 65536, '\p{Is_Blk= SPECIALS}', "");
    Expect(1, 65536, '\p{^Is_Blk= SPECIALS}', "");
    Expect(1, 65536, '\P{Is_Blk= SPECIALS}', "");
    Expect(0, 65536, '\P{^Is_Blk= SPECIALS}', "");
    Error('\p{Block=Sundanese:=}');
    Error('\P{Block=Sundanese:=}');
    Expect(1, 7103, '\p{Block=:\ASundanese\z:}', "");;
    Expect(0, 7104, '\p{Block=:\ASundanese\z:}', "");;
    Expect(1, 7103, '\p{Block=sundanese}', "");
    Expect(0, 7103, '\p{^Block=sundanese}', "");
    Expect(0, 7103, '\P{Block=sundanese}', "");
    Expect(1, 7103, '\P{^Block=sundanese}', "");
    Expect(0, 7104, '\p{Block=sundanese}', "");
    Expect(1, 7104, '\p{^Block=sundanese}', "");
    Expect(1, 7104, '\P{Block=sundanese}', "");
    Expect(0, 7104, '\P{^Block=sundanese}', "");
    Expect(1, 7103, '\p{Block=:\Asundanese\z:}', "");;
    Expect(0, 7104, '\p{Block=:\Asundanese\z:}', "");;
    Expect(1, 7103, '\p{Block=		sundanese}', "");
    Expect(0, 7103, '\p{^Block=		sundanese}', "");
    Expect(0, 7103, '\P{Block=		sundanese}', "");
    Expect(1, 7103, '\P{^Block=		sundanese}', "");
    Expect(0, 7104, '\p{Block=		sundanese}', "");
    Expect(1, 7104, '\p{^Block=		sundanese}', "");
    Expect(1, 7104, '\P{Block=		sundanese}', "");
    Expect(0, 7104, '\P{^Block=		sundanese}', "");
    Error('\p{Blk=/a/sundanese}');
    Error('\P{Blk=/a/sundanese}');
    Expect(1, 7103, '\p{Blk=:\ASundanese\z:}', "");;
    Expect(0, 7104, '\p{Blk=:\ASundanese\z:}', "");;
    Expect(1, 7103, '\p{Blk=sundanese}', "");
    Expect(0, 7103, '\p{^Blk=sundanese}', "");
    Expect(0, 7103, '\P{Blk=sundanese}', "");
    Expect(1, 7103, '\P{^Blk=sundanese}', "");
    Expect(0, 7104, '\p{Blk=sundanese}', "");
    Expect(1, 7104, '\p{^Blk=sundanese}', "");
    Expect(1, 7104, '\P{Blk=sundanese}', "");
    Expect(0, 7104, '\P{^Blk=sundanese}', "");
    Expect(1, 7103, '\p{Blk=:\Asundanese\z:}', "");;
    Expect(0, 7104, '\p{Blk=:\Asundanese\z:}', "");;
    Expect(1, 7103, '\p{Blk=-	sundanese}', "");
    Expect(0, 7103, '\p{^Blk=-	sundanese}', "");
    Expect(0, 7103, '\P{Blk=-	sundanese}', "");
    Expect(1, 7103, '\P{^Blk=-	sundanese}', "");
    Expect(0, 7104, '\p{Blk=-	sundanese}', "");
    Expect(1, 7104, '\p{^Blk=-	sundanese}', "");
    Expect(1, 7104, '\P{Blk=-	sundanese}', "");
    Expect(0, 7104, '\P{^Blk=-	sundanese}', "");
    Error('\p{Is_Block=-/a/sundanese}');
    Error('\P{Is_Block=-/a/sundanese}');
    Expect(1, 7103, '\p{Is_Block:sundanese}', "");
    Expect(0, 7103, '\p{^Is_Block:sundanese}', "");
    Expect(0, 7103, '\P{Is_Block:sundanese}', "");
    Expect(1, 7103, '\P{^Is_Block:sundanese}', "");
    Expect(0, 7104, '\p{Is_Block:sundanese}', "");
    Expect(1, 7104, '\p{^Is_Block:sundanese}', "");
    Expect(1, 7104, '\P{Is_Block:sundanese}', "");
    Expect(0, 7104, '\P{^Is_Block:sundanese}', "");
    Expect(1, 7103, '\p{Is_Block=- Sundanese}', "");
    Expect(0, 7103, '\p{^Is_Block=- Sundanese}', "");
    Expect(0, 7103, '\P{Is_Block=- Sundanese}', "");
    Expect(1, 7103, '\P{^Is_Block=- Sundanese}', "");
    Expect(0, 7104, '\p{Is_Block=- Sundanese}', "");
    Expect(1, 7104, '\p{^Is_Block=- Sundanese}', "");
    Expect(1, 7104, '\P{Is_Block=- Sundanese}', "");
    Expect(0, 7104, '\P{^Is_Block=- Sundanese}', "");
    Error('\p{Is_Blk=/a/ Sundanese}');
    Error('\P{Is_Blk=/a/ Sundanese}');
    Expect(1, 7103, '\p{Is_Blk:   sundanese}', "");
    Expect(0, 7103, '\p{^Is_Blk:   sundanese}', "");
    Expect(0, 7103, '\P{Is_Blk:   sundanese}', "");
    Expect(1, 7103, '\P{^Is_Blk:   sundanese}', "");
    Expect(0, 7104, '\p{Is_Blk:   sundanese}', "");
    Expect(1, 7104, '\p{^Is_Blk:   sundanese}', "");
    Expect(1, 7104, '\P{Is_Blk:   sundanese}', "");
    Expect(0, 7104, '\P{^Is_Blk:   sundanese}', "");
    Expect(1, 7103, '\p{Is_Blk=SUNDANESE}', "");
    Expect(0, 7103, '\p{^Is_Blk=SUNDANESE}', "");
    Expect(0, 7103, '\P{Is_Blk=SUNDANESE}', "");
    Expect(1, 7103, '\P{^Is_Blk=SUNDANESE}', "");
    Expect(0, 7104, '\p{Is_Blk=SUNDANESE}', "");
    Expect(1, 7104, '\p{^Is_Blk=SUNDANESE}', "");
    Expect(1, 7104, '\P{Is_Blk=SUNDANESE}', "");
    Expect(0, 7104, '\P{^Is_Blk=SUNDANESE}', "");
    Error('\p{Block:_/a/Sundanese_Supplement}');
    Error('\P{Block:_/a/Sundanese_Supplement}');
    Expect(1, 7375, '\p{Block=:\ASundanese_Supplement\z:}', "");;
    Expect(0, 7376, '\p{Block=:\ASundanese_Supplement\z:}', "");;
    Expect(1, 7375, '\p{Block=sundanesesupplement}', "");
    Expect(0, 7375, '\p{^Block=sundanesesupplement}', "");
    Expect(0, 7375, '\P{Block=sundanesesupplement}', "");
    Expect(1, 7375, '\P{^Block=sundanesesupplement}', "");
    Expect(0, 7376, '\p{Block=sundanesesupplement}', "");
    Expect(1, 7376, '\p{^Block=sundanesesupplement}', "");
    Expect(1, 7376, '\P{Block=sundanesesupplement}', "");
    Expect(0, 7376, '\P{^Block=sundanesesupplement}', "");
    Expect(1, 7375, '\p{Block=:\Asundanesesupplement\z:}', "");;
    Expect(0, 7376, '\p{Block=:\Asundanesesupplement\z:}', "");;
    Expect(1, 7375, '\p{Block=		SUNDANESE_SUPPLEMENT}', "");
    Expect(0, 7375, '\p{^Block=		SUNDANESE_SUPPLEMENT}', "");
    Expect(0, 7375, '\P{Block=		SUNDANESE_SUPPLEMENT}', "");
    Expect(1, 7375, '\P{^Block=		SUNDANESE_SUPPLEMENT}', "");
    Expect(0, 7376, '\p{Block=		SUNDANESE_SUPPLEMENT}', "");
    Expect(1, 7376, '\p{^Block=		SUNDANESE_SUPPLEMENT}', "");
    Expect(1, 7376, '\P{Block=		SUNDANESE_SUPPLEMENT}', "");
    Expect(0, 7376, '\P{^Block=		SUNDANESE_SUPPLEMENT}', "");
    Error('\p{Blk=	/a/sundanese_SUP}');
    Error('\P{Blk=	/a/sundanese_SUP}');
    Expect(1, 7375, '\p{Blk=:\ASundanese_Sup\z:}', "");;
    Expect(0, 7376, '\p{Blk=:\ASundanese_Sup\z:}', "");;
    Expect(1, 7375, '\p{Blk=sundanesesup}', "");
    Expect(0, 7375, '\p{^Blk=sundanesesup}', "");
    Expect(0, 7375, '\P{Blk=sundanesesup}', "");
    Expect(1, 7375, '\P{^Blk=sundanesesup}', "");
    Expect(0, 7376, '\p{Blk=sundanesesup}', "");
    Expect(1, 7376, '\p{^Blk=sundanesesup}', "");
    Expect(1, 7376, '\P{Blk=sundanesesup}', "");
    Expect(0, 7376, '\P{^Blk=sundanesesup}', "");
    Expect(1, 7375, '\p{Blk=:\Asundanesesup\z:}', "");;
    Expect(0, 7376, '\p{Blk=:\Asundanesesup\z:}', "");;
    Expect(1, 7375, '\p{Blk=- SUNDANESE_sup}', "");
    Expect(0, 7375, '\p{^Blk=- SUNDANESE_sup}', "");
    Expect(0, 7375, '\P{Blk=- SUNDANESE_sup}', "");
    Expect(1, 7375, '\P{^Blk=- SUNDANESE_sup}', "");
    Expect(0, 7376, '\p{Blk=- SUNDANESE_sup}', "");
    Expect(1, 7376, '\p{^Blk=- SUNDANESE_sup}', "");
    Expect(1, 7376, '\P{Blk=- SUNDANESE_sup}', "");
    Expect(0, 7376, '\P{^Blk=- SUNDANESE_sup}', "");
    Error('\p{Is_Block= -Sundanese_Supplement/a/}');
    Error('\P{Is_Block= -Sundanese_Supplement/a/}');
    Expect(1, 7375, '\p{Is_Block=sundanesesupplement}', "");
    Expect(0, 7375, '\p{^Is_Block=sundanesesupplement}', "");
    Expect(0, 7375, '\P{Is_Block=sundanesesupplement}', "");
    Expect(1, 7375, '\P{^Is_Block=sundanesesupplement}', "");
    Expect(0, 7376, '\p{Is_Block=sundanesesupplement}', "");
    Expect(1, 7376, '\p{^Is_Block=sundanesesupplement}', "");
    Expect(1, 7376, '\P{Is_Block=sundanesesupplement}', "");
    Expect(0, 7376, '\P{^Is_Block=sundanesesupplement}', "");
    Expect(1, 7375, '\p{Is_Block=_	Sundanese_Supplement}', "");
    Expect(0, 7375, '\p{^Is_Block=_	Sundanese_Supplement}', "");
    Expect(0, 7375, '\P{Is_Block=_	Sundanese_Supplement}', "");
    Expect(1, 7375, '\P{^Is_Block=_	Sundanese_Supplement}', "");
    Expect(0, 7376, '\p{Is_Block=_	Sundanese_Supplement}', "");
    Expect(1, 7376, '\p{^Is_Block=_	Sundanese_Supplement}', "");
    Expect(1, 7376, '\P{Is_Block=_	Sundanese_Supplement}', "");
    Expect(0, 7376, '\P{^Is_Block=_	Sundanese_Supplement}', "");
    Error('\p{Is_Blk=:= _sundanese_sup}');
    Error('\P{Is_Blk=:= _sundanese_sup}');
    Expect(1, 7375, '\p{Is_Blk=sundanesesup}', "");
    Expect(0, 7375, '\p{^Is_Blk=sundanesesup}', "");
    Expect(0, 7375, '\P{Is_Blk=sundanesesup}', "");
    Expect(1, 7375, '\P{^Is_Blk=sundanesesup}', "");
    Expect(0, 7376, '\p{Is_Blk=sundanesesup}', "");
    Expect(1, 7376, '\p{^Is_Blk=sundanesesup}', "");
    Expect(1, 7376, '\P{Is_Blk=sundanesesup}', "");
    Expect(0, 7376, '\P{^Is_Blk=sundanesesup}', "");
    Expect(1, 7375, '\p{Is_Blk: -_SUNDANESE_Sup}', "");
    Expect(0, 7375, '\p{^Is_Blk: -_SUNDANESE_Sup}', "");
    Expect(0, 7375, '\P{Is_Blk: -_SUNDANESE_Sup}', "");
    Expect(1, 7375, '\P{^Is_Blk: -_SUNDANESE_Sup}', "");
    Expect(0, 7376, '\p{Is_Blk: -_SUNDANESE_Sup}', "");
    Expect(1, 7376, '\p{^Is_Blk: -_SUNDANESE_Sup}', "");
    Expect(1, 7376, '\P{Is_Blk: -_SUNDANESE_Sup}', "");
    Expect(0, 7376, '\P{^Is_Blk: -_SUNDANESE_Sup}', "");
    Error('\p{Block=_:=Supplemental_arrows_A}');
    Error('\P{Block=_:=Supplemental_arrows_A}');
    Expect(1, 10239, '\p{Block=:\ASupplemental_Arrows_A\z:}', "");;
    Expect(0, 10240, '\p{Block=:\ASupplemental_Arrows_A\z:}', "");;
    Expect(1, 10239, '\p{Block:supplementalarrowsa}', "");
    Expect(0, 10239, '\p{^Block:supplementalarrowsa}', "");
    Expect(0, 10239, '\P{Block:supplementalarrowsa}', "");
    Expect(1, 10239, '\P{^Block:supplementalarrowsa}', "");
    Expect(0, 10240, '\p{Block:supplementalarrowsa}', "");
    Expect(1, 10240, '\p{^Block:supplementalarrowsa}', "");
    Expect(1, 10240, '\P{Block:supplementalarrowsa}', "");
    Expect(0, 10240, '\P{^Block:supplementalarrowsa}', "");
    Expect(1, 10239, '\p{Block=:\Asupplementalarrowsa\z:}', "");;
    Expect(0, 10240, '\p{Block=:\Asupplementalarrowsa\z:}', "");;
    Expect(1, 10239, '\p{Block= -SUPPLEMENTAL_ARROWS_A}', "");
    Expect(0, 10239, '\p{^Block= -SUPPLEMENTAL_ARROWS_A}', "");
    Expect(0, 10239, '\P{Block= -SUPPLEMENTAL_ARROWS_A}', "");
    Expect(1, 10239, '\P{^Block= -SUPPLEMENTAL_ARROWS_A}', "");
    Expect(0, 10240, '\p{Block= -SUPPLEMENTAL_ARROWS_A}', "");
    Expect(1, 10240, '\p{^Block= -SUPPLEMENTAL_ARROWS_A}', "");
    Expect(1, 10240, '\P{Block= -SUPPLEMENTAL_ARROWS_A}', "");
    Expect(0, 10240, '\P{^Block= -SUPPLEMENTAL_ARROWS_A}', "");
    Error('\p{Blk:	_/a/SUP_Arrows_A}');
    Error('\P{Blk:	_/a/SUP_Arrows_A}');
    Expect(1, 10239, '\p{Blk=:\ASup_Arrows_A\z:}', "");;
    Expect(0, 10240, '\p{Blk=:\ASup_Arrows_A\z:}', "");;
    Expect(1, 10239, '\p{Blk=suparrowsa}', "");
    Expect(0, 10239, '\p{^Blk=suparrowsa}', "");
    Expect(0, 10239, '\P{Blk=suparrowsa}', "");
    Expect(1, 10239, '\P{^Blk=suparrowsa}', "");
    Expect(0, 10240, '\p{Blk=suparrowsa}', "");
    Expect(1, 10240, '\p{^Blk=suparrowsa}', "");
    Expect(1, 10240, '\P{Blk=suparrowsa}', "");
    Expect(0, 10240, '\P{^Blk=suparrowsa}', "");
    Expect(1, 10239, '\p{Blk=:\Asuparrowsa\z:}', "");;
    Expect(0, 10240, '\p{Blk=:\Asuparrowsa\z:}', "");;
    Expect(1, 10239, '\p{Blk: SUP_Arrows_A}', "");
    Expect(0, 10239, '\p{^Blk: SUP_Arrows_A}', "");
    Expect(0, 10239, '\P{Blk: SUP_Arrows_A}', "");
    Expect(1, 10239, '\P{^Blk: SUP_Arrows_A}', "");
    Expect(0, 10240, '\p{Blk: SUP_Arrows_A}', "");
    Expect(1, 10240, '\p{^Blk: SUP_Arrows_A}', "");
    Expect(1, 10240, '\P{Blk: SUP_Arrows_A}', "");
    Expect(0, 10240, '\P{^Blk: SUP_Arrows_A}', "");
    Error('\p{Is_Block=-/a/Supplemental_ARROWS_a}');
    Error('\P{Is_Block=-/a/Supplemental_ARROWS_a}');
    Expect(1, 10239, '\p{Is_Block=supplementalarrowsa}', "");
    Expect(0, 10239, '\p{^Is_Block=supplementalarrowsa}', "");
    Expect(0, 10239, '\P{Is_Block=supplementalarrowsa}', "");
    Expect(1, 10239, '\P{^Is_Block=supplementalarrowsa}', "");
    Expect(0, 10240, '\p{Is_Block=supplementalarrowsa}', "");
    Expect(1, 10240, '\p{^Is_Block=supplementalarrowsa}', "");
    Expect(1, 10240, '\P{Is_Block=supplementalarrowsa}', "");
    Expect(0, 10240, '\P{^Is_Block=supplementalarrowsa}', "");
    Expect(1, 10239, '\p{Is_Block=-Supplemental_Arrows_a}', "");
    Expect(0, 10239, '\p{^Is_Block=-Supplemental_Arrows_a}', "");
    Expect(0, 10239, '\P{Is_Block=-Supplemental_Arrows_a}', "");
    Expect(1, 10239, '\P{^Is_Block=-Supplemental_Arrows_a}', "");
    Expect(0, 10240, '\p{Is_Block=-Supplemental_Arrows_a}', "");
    Expect(1, 10240, '\p{^Is_Block=-Supplemental_Arrows_a}', "");
    Expect(1, 10240, '\P{Is_Block=-Supplemental_Arrows_a}', "");
    Expect(0, 10240, '\P{^Is_Block=-Supplemental_Arrows_a}', "");
    Error('\p{Is_Blk=-/a/Sup_Arrows_A}');
    Error('\P{Is_Blk=-/a/Sup_Arrows_A}');
    Expect(1, 10239, '\p{Is_Blk:	suparrowsa}', "");
    Expect(0, 10239, '\p{^Is_Blk:	suparrowsa}', "");
    Expect(0, 10239, '\P{Is_Blk:	suparrowsa}', "");
    Expect(1, 10239, '\P{^Is_Blk:	suparrowsa}', "");
    Expect(0, 10240, '\p{Is_Blk:	suparrowsa}', "");
    Expect(1, 10240, '\p{^Is_Blk:	suparrowsa}', "");
    Expect(1, 10240, '\P{Is_Blk:	suparrowsa}', "");
    Expect(0, 10240, '\P{^Is_Blk:	suparrowsa}', "");
    Expect(1, 10239, '\p{Is_Blk=--SUP_ARROWS_A}', "");
    Expect(0, 10239, '\p{^Is_Blk=--SUP_ARROWS_A}', "");
    Expect(0, 10239, '\P{Is_Blk=--SUP_ARROWS_A}', "");
    Expect(1, 10239, '\P{^Is_Blk=--SUP_ARROWS_A}', "");
    Expect(0, 10240, '\p{Is_Blk=--SUP_ARROWS_A}', "");
    Expect(1, 10240, '\p{^Is_Blk=--SUP_ARROWS_A}', "");
    Expect(1, 10240, '\P{Is_Blk=--SUP_ARROWS_A}', "");
    Expect(0, 10240, '\P{^Is_Blk=--SUP_ARROWS_A}', "");
    Error('\p{Block=-/a/Supplemental_arrows_B}');
    Error('\P{Block=-/a/Supplemental_arrows_B}');
    Expect(1, 10623, '\p{Block=:\ASupplemental_Arrows_B\z:}', "");;
    Expect(0, 10624, '\p{Block=:\ASupplemental_Arrows_B\z:}', "");;
    Expect(1, 10623, '\p{Block=supplementalarrowsb}', "");
    Expect(0, 10623, '\p{^Block=supplementalarrowsb}', "");
    Expect(0, 10623, '\P{Block=supplementalarrowsb}', "");
    Expect(1, 10623, '\P{^Block=supplementalarrowsb}', "");
    Expect(0, 10624, '\p{Block=supplementalarrowsb}', "");
    Expect(1, 10624, '\p{^Block=supplementalarrowsb}', "");
    Expect(1, 10624, '\P{Block=supplementalarrowsb}', "");
    Expect(0, 10624, '\P{^Block=supplementalarrowsb}', "");
    Expect(1, 10623, '\p{Block=:\Asupplementalarrowsb\z:}', "");;
    Expect(0, 10624, '\p{Block=:\Asupplementalarrowsb\z:}', "");;
    Expect(1, 10623, '\p{Block= supplemental_ARROWS_B}', "");
    Expect(0, 10623, '\p{^Block= supplemental_ARROWS_B}', "");
    Expect(0, 10623, '\P{Block= supplemental_ARROWS_B}', "");
    Expect(1, 10623, '\P{^Block= supplemental_ARROWS_B}', "");
    Expect(0, 10624, '\p{Block= supplemental_ARROWS_B}', "");
    Expect(1, 10624, '\p{^Block= supplemental_ARROWS_B}', "");
    Expect(1, 10624, '\P{Block= supplemental_ARROWS_B}', "");
    Expect(0, 10624, '\P{^Block= supplemental_ARROWS_B}', "");
    Error('\p{Blk:  /a/Sup_Arrows_B}');
    Error('\P{Blk:  /a/Sup_Arrows_B}');
    Expect(1, 10623, '\p{Blk=:\ASup_Arrows_B\z:}', "");;
    Expect(0, 10624, '\p{Blk=:\ASup_Arrows_B\z:}', "");;
    Expect(1, 10623, '\p{Blk=suparrowsb}', "");
    Expect(0, 10623, '\p{^Blk=suparrowsb}', "");
    Expect(0, 10623, '\P{Blk=suparrowsb}', "");
    Expect(1, 10623, '\P{^Blk=suparrowsb}', "");
    Expect(0, 10624, '\p{Blk=suparrowsb}', "");
    Expect(1, 10624, '\p{^Blk=suparrowsb}', "");
    Expect(1, 10624, '\P{Blk=suparrowsb}', "");
    Expect(0, 10624, '\P{^Blk=suparrowsb}', "");
    Expect(1, 10623, '\p{Blk=:\Asuparrowsb\z:}', "");;
    Expect(0, 10624, '\p{Blk=:\Asuparrowsb\z:}', "");;
    Expect(1, 10623, '\p{Blk=-	sup_ARROWS_B}', "");
    Expect(0, 10623, '\p{^Blk=-	sup_ARROWS_B}', "");
    Expect(0, 10623, '\P{Blk=-	sup_ARROWS_B}', "");
    Expect(1, 10623, '\P{^Blk=-	sup_ARROWS_B}', "");
    Expect(0, 10624, '\p{Blk=-	sup_ARROWS_B}', "");
    Expect(1, 10624, '\p{^Blk=-	sup_ARROWS_B}', "");
    Expect(1, 10624, '\P{Blk=-	sup_ARROWS_B}', "");
    Expect(0, 10624, '\P{^Blk=-	sup_ARROWS_B}', "");
    Error('\p{Is_Block=/a/		supplemental_Arrows_B}');
    Error('\P{Is_Block=/a/		supplemental_Arrows_B}');
    Expect(1, 10623, '\p{Is_Block=supplementalarrowsb}', "");
    Expect(0, 10623, '\p{^Is_Block=supplementalarrowsb}', "");
    Expect(0, 10623, '\P{Is_Block=supplementalarrowsb}', "");
    Expect(1, 10623, '\P{^Is_Block=supplementalarrowsb}', "");
    Expect(0, 10624, '\p{Is_Block=supplementalarrowsb}', "");
    Expect(1, 10624, '\p{^Is_Block=supplementalarrowsb}', "");
    Expect(1, 10624, '\P{Is_Block=supplementalarrowsb}', "");
    Expect(0, 10624, '\P{^Is_Block=supplementalarrowsb}', "");
    Expect(1, 10623, '\p{Is_Block=_ SUPPLEMENTAL_arrows_B}', "");
    Expect(0, 10623, '\p{^Is_Block=_ SUPPLEMENTAL_arrows_B}', "");
    Expect(0, 10623, '\P{Is_Block=_ SUPPLEMENTAL_arrows_B}', "");
    Expect(1, 10623, '\P{^Is_Block=_ SUPPLEMENTAL_arrows_B}', "");
    Expect(0, 10624, '\p{Is_Block=_ SUPPLEMENTAL_arrows_B}', "");
    Expect(1, 10624, '\p{^Is_Block=_ SUPPLEMENTAL_arrows_B}', "");
    Expect(1, 10624, '\P{Is_Block=_ SUPPLEMENTAL_arrows_B}', "");
    Expect(0, 10624, '\P{^Is_Block=_ SUPPLEMENTAL_arrows_B}', "");
    Error('\p{Is_Blk=:=-	Sup_Arrows_b}');
    Error('\P{Is_Blk=:=-	Sup_Arrows_b}');
    Expect(1, 10623, '\p{Is_Blk=suparrowsb}', "");
    Expect(0, 10623, '\p{^Is_Blk=suparrowsb}', "");
    Expect(0, 10623, '\P{Is_Blk=suparrowsb}', "");
    Expect(1, 10623, '\P{^Is_Blk=suparrowsb}', "");
    Expect(0, 10624, '\p{Is_Blk=suparrowsb}', "");
    Expect(1, 10624, '\p{^Is_Blk=suparrowsb}', "");
    Expect(1, 10624, '\P{Is_Blk=suparrowsb}', "");
    Expect(0, 10624, '\P{^Is_Blk=suparrowsb}', "");
    Expect(1, 10623, '\p{Is_Blk=  sup_Arrows_b}', "");
    Expect(0, 10623, '\p{^Is_Blk=  sup_Arrows_b}', "");
    Expect(0, 10623, '\P{Is_Blk=  sup_Arrows_b}', "");
    Expect(1, 10623, '\P{^Is_Blk=  sup_Arrows_b}', "");
    Expect(0, 10624, '\p{Is_Blk=  sup_Arrows_b}', "");
    Expect(1, 10624, '\p{^Is_Blk=  sup_Arrows_b}', "");
    Expect(1, 10624, '\P{Is_Blk=  sup_Arrows_b}', "");
    Expect(0, 10624, '\P{^Is_Blk=  sup_Arrows_b}', "");
    Error('\p{Block:   	Supplemental_ARROWS_C/a/}');
    Error('\P{Block:   	Supplemental_ARROWS_C/a/}');
    Expect(1, 129279, '\p{Block=:\ASupplemental_Arrows_C\z:}', "");;
    Expect(0, 129280, '\p{Block=:\ASupplemental_Arrows_C\z:}', "");;
    Expect(1, 129279, '\p{Block=supplementalarrowsc}', "");
    Expect(0, 129279, '\p{^Block=supplementalarrowsc}', "");
    Expect(0, 129279, '\P{Block=supplementalarrowsc}', "");
    Expect(1, 129279, '\P{^Block=supplementalarrowsc}', "");
    Expect(0, 129280, '\p{Block=supplementalarrowsc}', "");
    Expect(1, 129280, '\p{^Block=supplementalarrowsc}', "");
    Expect(1, 129280, '\P{Block=supplementalarrowsc}', "");
    Expect(0, 129280, '\P{^Block=supplementalarrowsc}', "");
    Expect(1, 129279, '\p{Block=:\Asupplementalarrowsc\z:}', "");;
    Expect(0, 129280, '\p{Block=:\Asupplementalarrowsc\z:}', "");;
    Expect(1, 129279, '\p{Block=--supplemental_arrows_c}', "");
    Expect(0, 129279, '\p{^Block=--supplemental_arrows_c}', "");
    Expect(0, 129279, '\P{Block=--supplemental_arrows_c}', "");
    Expect(1, 129279, '\P{^Block=--supplemental_arrows_c}', "");
    Expect(0, 129280, '\p{Block=--supplemental_arrows_c}', "");
    Expect(1, 129280, '\p{^Block=--supplemental_arrows_c}', "");
    Expect(1, 129280, '\P{Block=--supplemental_arrows_c}', "");
    Expect(0, 129280, '\P{^Block=--supplemental_arrows_c}', "");
    Error('\p{Blk= :=sup_Arrows_C}');
    Error('\P{Blk= :=sup_Arrows_C}');
    Expect(1, 129279, '\p{Blk=:\ASup_Arrows_C\z:}', "");;
    Expect(0, 129280, '\p{Blk=:\ASup_Arrows_C\z:}', "");;
    Expect(1, 129279, '\p{Blk=suparrowsc}', "");
    Expect(0, 129279, '\p{^Blk=suparrowsc}', "");
    Expect(0, 129279, '\P{Blk=suparrowsc}', "");
    Expect(1, 129279, '\P{^Blk=suparrowsc}', "");
    Expect(0, 129280, '\p{Blk=suparrowsc}', "");
    Expect(1, 129280, '\p{^Blk=suparrowsc}', "");
    Expect(1, 129280, '\P{Blk=suparrowsc}', "");
    Expect(0, 129280, '\P{^Blk=suparrowsc}', "");
    Expect(1, 129279, '\p{Blk=:\Asuparrowsc\z:}', "");;
    Expect(0, 129280, '\p{Blk=:\Asuparrowsc\z:}', "");;
    Expect(1, 129279, '\p{Blk=_Sup_Arrows_c}', "");
    Expect(0, 129279, '\p{^Blk=_Sup_Arrows_c}', "");
    Expect(0, 129279, '\P{Blk=_Sup_Arrows_c}', "");
    Expect(1, 129279, '\P{^Blk=_Sup_Arrows_c}', "");
    Expect(0, 129280, '\p{Blk=_Sup_Arrows_c}', "");
    Expect(1, 129280, '\p{^Blk=_Sup_Arrows_c}', "");
    Expect(1, 129280, '\P{Blk=_Sup_Arrows_c}', "");
    Expect(0, 129280, '\P{^Blk=_Sup_Arrows_c}', "");
    Error('\p{Is_Block= -Supplemental_arrows_C:=}');
    Error('\P{Is_Block= -Supplemental_arrows_C:=}');
    Expect(1, 129279, '\p{Is_Block=supplementalarrowsc}', "");
    Expect(0, 129279, '\p{^Is_Block=supplementalarrowsc}', "");
    Expect(0, 129279, '\P{Is_Block=supplementalarrowsc}', "");
    Expect(1, 129279, '\P{^Is_Block=supplementalarrowsc}', "");
    Expect(0, 129280, '\p{Is_Block=supplementalarrowsc}', "");
    Expect(1, 129280, '\p{^Is_Block=supplementalarrowsc}', "");
    Expect(1, 129280, '\P{Is_Block=supplementalarrowsc}', "");
    Expect(0, 129280, '\P{^Is_Block=supplementalarrowsc}', "");
    Expect(1, 129279, '\p{Is_Block=	_SUPPLEMENTAL_arrows_C}', "");
    Expect(0, 129279, '\p{^Is_Block=	_SUPPLEMENTAL_arrows_C}', "");
    Expect(0, 129279, '\P{Is_Block=	_SUPPLEMENTAL_arrows_C}', "");
    Expect(1, 129279, '\P{^Is_Block=	_SUPPLEMENTAL_arrows_C}', "");
    Expect(0, 129280, '\p{Is_Block=	_SUPPLEMENTAL_arrows_C}', "");
    Expect(1, 129280, '\p{^Is_Block=	_SUPPLEMENTAL_arrows_C}', "");
    Expect(1, 129280, '\P{Is_Block=	_SUPPLEMENTAL_arrows_C}', "");
    Expect(0, 129280, '\P{^Is_Block=	_SUPPLEMENTAL_arrows_C}', "");
    Error('\p{Is_Blk=/a/-sup_Arrows_C}');
    Error('\P{Is_Blk=/a/-sup_Arrows_C}');
    Expect(1, 129279, '\p{Is_Blk=suparrowsc}', "");
    Expect(0, 129279, '\p{^Is_Blk=suparrowsc}', "");
    Expect(0, 129279, '\P{Is_Blk=suparrowsc}', "");
    Expect(1, 129279, '\P{^Is_Blk=suparrowsc}', "");
    Expect(0, 129280, '\p{Is_Blk=suparrowsc}', "");
    Expect(1, 129280, '\p{^Is_Blk=suparrowsc}', "");
    Expect(1, 129280, '\P{Is_Blk=suparrowsc}', "");
    Expect(0, 129280, '\P{^Is_Blk=suparrowsc}', "");
    Expect(1, 129279, '\p{Is_Blk: 	sup_Arrows_C}', "");
    Expect(0, 129279, '\p{^Is_Blk: 	sup_Arrows_C}', "");
    Expect(0, 129279, '\P{Is_Blk: 	sup_Arrows_C}', "");
    Expect(1, 129279, '\P{^Is_Blk: 	sup_Arrows_C}', "");
    Expect(0, 129280, '\p{Is_Blk: 	sup_Arrows_C}', "");
    Expect(1, 129280, '\p{^Is_Blk: 	sup_Arrows_C}', "");
    Expect(1, 129280, '\P{Is_Blk: 	sup_Arrows_C}', "");
    Expect(0, 129280, '\P{^Is_Blk: 	sup_Arrows_C}', "");
    Error('\p{Block=	/a/SUPPLEMENTAL_Mathematical_OPERATORS}');
    Error('\P{Block=	/a/SUPPLEMENTAL_Mathematical_OPERATORS}');
    Expect(1, 11007, '\p{Block=:\ASupplemental_Mathematical_Operators\z:}', "");;
    Expect(0, 11008, '\p{Block=:\ASupplemental_Mathematical_Operators\z:}', "");;
    Expect(1, 11007, '\p{Block=supplementalmathematicaloperators}', "");
    Expect(0, 11007, '\p{^Block=supplementalmathematicaloperators}', "");
    Expect(0, 11007, '\P{Block=supplementalmathematicaloperators}', "");
    Expect(1, 11007, '\P{^Block=supplementalmathematicaloperators}', "");
    Expect(0, 11008, '\p{Block=supplementalmathematicaloperators}', "");
    Expect(1, 11008, '\p{^Block=supplementalmathematicaloperators}', "");
    Expect(1, 11008, '\P{Block=supplementalmathematicaloperators}', "");
    Expect(0, 11008, '\P{^Block=supplementalmathematicaloperators}', "");
    Expect(1, 11007, '\p{Block=:\Asupplementalmathematicaloperators\z:}', "");;
    Expect(0, 11008, '\p{Block=:\Asupplementalmathematicaloperators\z:}', "");;
    Expect(1, 11007, '\p{Block= 	SUPPLEMENTAL_Mathematical_OPERATORS}', "");
    Expect(0, 11007, '\p{^Block= 	SUPPLEMENTAL_Mathematical_OPERATORS}', "");
    Expect(0, 11007, '\P{Block= 	SUPPLEMENTAL_Mathematical_OPERATORS}', "");
    Expect(1, 11007, '\P{^Block= 	SUPPLEMENTAL_Mathematical_OPERATORS}', "");
    Expect(0, 11008, '\p{Block= 	SUPPLEMENTAL_Mathematical_OPERATORS}', "");
    Expect(1, 11008, '\p{^Block= 	SUPPLEMENTAL_Mathematical_OPERATORS}', "");
    Expect(1, 11008, '\P{Block= 	SUPPLEMENTAL_Mathematical_OPERATORS}', "");
    Expect(0, 11008, '\P{^Block= 	SUPPLEMENTAL_Mathematical_OPERATORS}', "");
    Error('\p{Blk=	-sup_math_Operators:=}');
    Error('\P{Blk=	-sup_math_Operators:=}');
    Expect(1, 11007, '\p{Blk=:\ASup_Math_Operators\z:}', "");;
    Expect(0, 11008, '\p{Blk=:\ASup_Math_Operators\z:}', "");;
    Expect(1, 11007, '\p{Blk: supmathoperators}', "");
    Expect(0, 11007, '\p{^Blk: supmathoperators}', "");
    Expect(0, 11007, '\P{Blk: supmathoperators}', "");
    Expect(1, 11007, '\P{^Blk: supmathoperators}', "");
    Expect(0, 11008, '\p{Blk: supmathoperators}', "");
    Expect(1, 11008, '\p{^Blk: supmathoperators}', "");
    Expect(1, 11008, '\P{Blk: supmathoperators}', "");
    Expect(0, 11008, '\P{^Blk: supmathoperators}', "");
    Expect(1, 11007, '\p{Blk=:\Asupmathoperators\z:}', "");;
    Expect(0, 11008, '\p{Blk=:\Asupmathoperators\z:}', "");;
    Expect(1, 11007, '\p{Blk=-Sup_Math_Operators}', "");
    Expect(0, 11007, '\p{^Blk=-Sup_Math_Operators}', "");
    Expect(0, 11007, '\P{Blk=-Sup_Math_Operators}', "");
    Expect(1, 11007, '\P{^Blk=-Sup_Math_Operators}', "");
    Expect(0, 11008, '\p{Blk=-Sup_Math_Operators}', "");
    Expect(1, 11008, '\p{^Blk=-Sup_Math_Operators}', "");
    Expect(1, 11008, '\P{Blk=-Sup_Math_Operators}', "");
    Expect(0, 11008, '\P{^Blk=-Sup_Math_Operators}', "");
    Error('\p{Is_Block=_:=Supplemental_Mathematical_operators}');
    Error('\P{Is_Block=_:=Supplemental_Mathematical_operators}');
    Expect(1, 11007, '\p{Is_Block:	supplementalmathematicaloperators}', "");
    Expect(0, 11007, '\p{^Is_Block:	supplementalmathematicaloperators}', "");
    Expect(0, 11007, '\P{Is_Block:	supplementalmathematicaloperators}', "");
    Expect(1, 11007, '\P{^Is_Block:	supplementalmathematicaloperators}', "");
    Expect(0, 11008, '\p{Is_Block:	supplementalmathematicaloperators}', "");
    Expect(1, 11008, '\p{^Is_Block:	supplementalmathematicaloperators}', "");
    Expect(1, 11008, '\P{Is_Block:	supplementalmathematicaloperators}', "");
    Expect(0, 11008, '\P{^Is_Block:	supplementalmathematicaloperators}', "");
    Expect(1, 11007, '\p{Is_Block=	_supplemental_Mathematical_operators}', "");
    Expect(0, 11007, '\p{^Is_Block=	_supplemental_Mathematical_operators}', "");
    Expect(0, 11007, '\P{Is_Block=	_supplemental_Mathematical_operators}', "");
    Expect(1, 11007, '\P{^Is_Block=	_supplemental_Mathematical_operators}', "");
    Expect(0, 11008, '\p{Is_Block=	_supplemental_Mathematical_operators}', "");
    Expect(1, 11008, '\p{^Is_Block=	_supplemental_Mathematical_operators}', "");
    Expect(1, 11008, '\P{Is_Block=	_supplemental_Mathematical_operators}', "");
    Expect(0, 11008, '\P{^Is_Block=	_supplemental_Mathematical_operators}', "");
    Error('\p{Is_Blk=-:=Sup_Math_OPERATORS}');
    Error('\P{Is_Blk=-:=Sup_Math_OPERATORS}');
    Expect(1, 11007, '\p{Is_Blk=supmathoperators}', "");
    Expect(0, 11007, '\p{^Is_Blk=supmathoperators}', "");
    Expect(0, 11007, '\P{Is_Blk=supmathoperators}', "");
    Expect(1, 11007, '\P{^Is_Blk=supmathoperators}', "");
    Expect(0, 11008, '\p{Is_Blk=supmathoperators}', "");
    Expect(1, 11008, '\p{^Is_Blk=supmathoperators}', "");
    Expect(1, 11008, '\P{Is_Blk=supmathoperators}', "");
    Expect(0, 11008, '\P{^Is_Blk=supmathoperators}', "");
    Expect(1, 11007, '\p{Is_Blk:   _	Sup_Math_OPERATORS}', "");
    Expect(0, 11007, '\p{^Is_Blk:   _	Sup_Math_OPERATORS}', "");
    Expect(0, 11007, '\P{Is_Blk:   _	Sup_Math_OPERATORS}', "");
    Expect(1, 11007, '\P{^Is_Blk:   _	Sup_Math_OPERATORS}', "");
    Expect(0, 11008, '\p{Is_Blk:   _	Sup_Math_OPERATORS}', "");
    Expect(1, 11008, '\p{^Is_Blk:   _	Sup_Math_OPERATORS}', "");
    Expect(1, 11008, '\P{Is_Blk:   _	Sup_Math_OPERATORS}', "");
    Expect(0, 11008, '\P{^Is_Blk:   _	Sup_Math_OPERATORS}', "");
    Error('\p{Block=_SUPPLEMENTARY_Private_use_Area_a/a/}');
    Error('\P{Block=_SUPPLEMENTARY_Private_use_Area_a/a/}');
    Expect(1, 983040, '\p{Block=:\ASupplementary_Private_Use_Area_A\z:}', "");;
    Expect(0, 1048576, '\p{Block=:\ASupplementary_Private_Use_Area_A\z:}', "");;
    Expect(1, 983040, '\p{Block: supplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\p{^Block: supplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\P{Block: supplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\P{^Block: supplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\p{Block: supplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\p{^Block: supplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\P{Block: supplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\P{^Block: supplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\p{Block=:\Asupplementaryprivateuseareaa\z:}', "");;
    Expect(0, 1048576, '\p{Block=:\Asupplementaryprivateuseareaa\z:}', "");;
    Expect(1, 983040, '\p{Block=	SUPPLEMENTARY_Private_Use_Area_A}', "");
    Expect(0, 983040, '\p{^Block=	SUPPLEMENTARY_Private_Use_Area_A}', "");
    Expect(0, 983040, '\P{Block=	SUPPLEMENTARY_Private_Use_Area_A}', "");
    Expect(1, 983040, '\P{^Block=	SUPPLEMENTARY_Private_Use_Area_A}', "");
    Expect(0, 1048576, '\p{Block=	SUPPLEMENTARY_Private_Use_Area_A}', "");
    Expect(1, 1048576, '\p{^Block=	SUPPLEMENTARY_Private_Use_Area_A}', "");
    Expect(1, 1048576, '\P{Block=	SUPPLEMENTARY_Private_Use_Area_A}', "");
    Expect(0, 1048576, '\P{^Block=	SUPPLEMENTARY_Private_Use_Area_A}', "");
    Error('\p{Blk=_:=Sup_pua_A}');
    Error('\P{Blk=_:=Sup_pua_A}');
    Expect(1, 983040, '\p{Blk=:\ASup_PUA_A\z:}', "");;
    Expect(0, 1048576, '\p{Blk=:\ASup_PUA_A\z:}', "");;
    Expect(1, 983040, '\p{Blk:   suppuaa}', "");
    Expect(0, 983040, '\p{^Blk:   suppuaa}', "");
    Expect(0, 983040, '\P{Blk:   suppuaa}', "");
    Expect(1, 983040, '\P{^Blk:   suppuaa}', "");
    Expect(0, 1048576, '\p{Blk:   suppuaa}', "");
    Expect(1, 1048576, '\p{^Blk:   suppuaa}', "");
    Expect(1, 1048576, '\P{Blk:   suppuaa}', "");
    Expect(0, 1048576, '\P{^Blk:   suppuaa}', "");
    Expect(1, 983040, '\p{Blk=:\Asuppuaa\z:}', "");;
    Expect(0, 1048576, '\p{Blk=:\Asuppuaa\z:}', "");;
    Expect(1, 983040, '\p{Blk:   --sup_PUA_A}', "");
    Expect(0, 983040, '\p{^Blk:   --sup_PUA_A}', "");
    Expect(0, 983040, '\P{Blk:   --sup_PUA_A}', "");
    Expect(1, 983040, '\P{^Blk:   --sup_PUA_A}', "");
    Expect(0, 1048576, '\p{Blk:   --sup_PUA_A}', "");
    Expect(1, 1048576, '\p{^Blk:   --sup_PUA_A}', "");
    Expect(1, 1048576, '\P{Blk:   --sup_PUA_A}', "");
    Expect(0, 1048576, '\P{^Blk:   --sup_PUA_A}', "");
    Error('\p{Is_Block:-/a/SUPPLEMENTARY_private_Use_Area_a}');
    Error('\P{Is_Block:-/a/SUPPLEMENTARY_private_Use_Area_a}');
    Expect(1, 983040, '\p{Is_Block=supplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\p{^Is_Block=supplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\P{Is_Block=supplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\P{^Is_Block=supplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\p{Is_Block=supplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\p{^Is_Block=supplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\P{Is_Block=supplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\P{^Is_Block=supplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\p{Is_Block=	-Supplementary_Private_use_Area_a}', "");
    Expect(0, 983040, '\p{^Is_Block=	-Supplementary_Private_use_Area_a}', "");
    Expect(0, 983040, '\P{Is_Block=	-Supplementary_Private_use_Area_a}', "");
    Expect(1, 983040, '\P{^Is_Block=	-Supplementary_Private_use_Area_a}', "");
    Expect(0, 1048576, '\p{Is_Block=	-Supplementary_Private_use_Area_a}', "");
    Expect(1, 1048576, '\p{^Is_Block=	-Supplementary_Private_use_Area_a}', "");
    Expect(1, 1048576, '\P{Is_Block=	-Supplementary_Private_use_Area_a}', "");
    Expect(0, 1048576, '\P{^Is_Block=	-Supplementary_Private_use_Area_a}', "");
    Error('\p{Is_Blk:_/a/Sup_pua_A}');
    Error('\P{Is_Blk:_/a/Sup_pua_A}');
    Expect(1, 983040, '\p{Is_Blk=suppuaa}', "");
    Expect(0, 983040, '\p{^Is_Blk=suppuaa}', "");
    Expect(0, 983040, '\P{Is_Blk=suppuaa}', "");
    Expect(1, 983040, '\P{^Is_Blk=suppuaa}', "");
    Expect(0, 1048576, '\p{Is_Blk=suppuaa}', "");
    Expect(1, 1048576, '\p{^Is_Blk=suppuaa}', "");
    Expect(1, 1048576, '\P{Is_Blk=suppuaa}', "");
    Expect(0, 1048576, '\P{^Is_Blk=suppuaa}', "");
    Expect(1, 983040, '\p{Is_Blk=_-Sup_pua_A}', "");
    Expect(0, 983040, '\p{^Is_Blk=_-Sup_pua_A}', "");
    Expect(0, 983040, '\P{Is_Blk=_-Sup_pua_A}', "");
    Expect(1, 983040, '\P{^Is_Blk=_-Sup_pua_A}', "");
    Expect(0, 1048576, '\p{Is_Blk=_-Sup_pua_A}', "");
    Expect(1, 1048576, '\p{^Is_Blk=_-Sup_pua_A}', "");
    Expect(1, 1048576, '\P{Is_Blk=_-Sup_pua_A}', "");
    Expect(0, 1048576, '\P{^Is_Blk=_-Sup_pua_A}', "");
    Error('\p{Block= /a/SUPPLEMENTARY_PRIVATE_USE_area_b}');
    Error('\P{Block= /a/SUPPLEMENTARY_PRIVATE_USE_area_b}');
    Expect(1, 1048576, '\p{Block=:\ASupplementary_Private_Use_Area_B\z:}', "");;
    Expect(0, 1, '\p{Block=:\ASupplementary_Private_Use_Area_B\z:}', "");;
    Expect(1, 1048576, '\p{Block=supplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\p{^Block=supplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\P{Block=supplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\P{^Block=supplementaryprivateuseareab}', "");
    Expect(0, 1, '\p{Block=supplementaryprivateuseareab}', "");
    Expect(1, 1, '\p{^Block=supplementaryprivateuseareab}', "");
    Expect(1, 1, '\P{Block=supplementaryprivateuseareab}', "");
    Expect(0, 1, '\P{^Block=supplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\p{Block=:\Asupplementaryprivateuseareab\z:}', "");;
    Expect(0, 1, '\p{Block=:\Asupplementaryprivateuseareab\z:}', "");;
    Expect(1, 1048576, '\p{Block=	-supplementary_private_Use_AREA_b}', "");
    Expect(0, 1048576, '\p{^Block=	-supplementary_private_Use_AREA_b}', "");
    Expect(0, 1048576, '\P{Block=	-supplementary_private_Use_AREA_b}', "");
    Expect(1, 1048576, '\P{^Block=	-supplementary_private_Use_AREA_b}', "");
    Expect(0, 1, '\p{Block=	-supplementary_private_Use_AREA_b}', "");
    Expect(1, 1, '\p{^Block=	-supplementary_private_Use_AREA_b}', "");
    Expect(1, 1, '\P{Block=	-supplementary_private_Use_AREA_b}', "");
    Expect(0, 1, '\P{^Block=	-supplementary_private_Use_AREA_b}', "");
    Error('\p{Blk=	sup_PUA_B:=}');
    Error('\P{Blk=	sup_PUA_B:=}');
    Expect(1, 1048576, '\p{Blk=:\ASup_PUA_B\z:}', "");;
    Expect(0, 1, '\p{Blk=:\ASup_PUA_B\z:}', "");;
    Expect(1, 1048576, '\p{Blk:   suppuab}', "");
    Expect(0, 1048576, '\p{^Blk:   suppuab}', "");
    Expect(0, 1048576, '\P{Blk:   suppuab}', "");
    Expect(1, 1048576, '\P{^Blk:   suppuab}', "");
    Expect(0, 1, '\p{Blk:   suppuab}', "");
    Expect(1, 1, '\p{^Blk:   suppuab}', "");
    Expect(1, 1, '\P{Blk:   suppuab}', "");
    Expect(0, 1, '\P{^Blk:   suppuab}', "");
    Expect(1, 1048576, '\p{Blk=:\Asuppuab\z:}', "");;
    Expect(0, 1, '\p{Blk=:\Asuppuab\z:}', "");;
    Expect(1, 1048576, '\p{Blk=_sup_PUA_b}', "");
    Expect(0, 1048576, '\p{^Blk=_sup_PUA_b}', "");
    Expect(0, 1048576, '\P{Blk=_sup_PUA_b}', "");
    Expect(1, 1048576, '\P{^Blk=_sup_PUA_b}', "");
    Expect(0, 1, '\p{Blk=_sup_PUA_b}', "");
    Expect(1, 1, '\p{^Blk=_sup_PUA_b}', "");
    Expect(1, 1, '\P{Blk=_sup_PUA_b}', "");
    Expect(0, 1, '\P{^Blk=_sup_PUA_b}', "");
    Error('\p{Is_Block=	supplementary_Private_Use_AREA_b:=}');
    Error('\P{Is_Block=	supplementary_Private_Use_AREA_b:=}');
    Expect(1, 1048576, '\p{Is_Block=supplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\p{^Is_Block=supplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\P{Is_Block=supplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\P{^Is_Block=supplementaryprivateuseareab}', "");
    Expect(0, 1, '\p{Is_Block=supplementaryprivateuseareab}', "");
    Expect(1, 1, '\p{^Is_Block=supplementaryprivateuseareab}', "");
    Expect(1, 1, '\P{Is_Block=supplementaryprivateuseareab}', "");
    Expect(0, 1, '\P{^Is_Block=supplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\p{Is_Block= -SUPPLEMENTARY_PRIVATE_Use_AREA_B}', "");
    Expect(0, 1048576, '\p{^Is_Block= -SUPPLEMENTARY_PRIVATE_Use_AREA_B}', "");
    Expect(0, 1048576, '\P{Is_Block= -SUPPLEMENTARY_PRIVATE_Use_AREA_B}', "");
    Expect(1, 1048576, '\P{^Is_Block= -SUPPLEMENTARY_PRIVATE_Use_AREA_B}', "");
    Expect(0, 1, '\p{Is_Block= -SUPPLEMENTARY_PRIVATE_Use_AREA_B}', "");
    Expect(1, 1, '\p{^Is_Block= -SUPPLEMENTARY_PRIVATE_Use_AREA_B}', "");
    Expect(1, 1, '\P{Is_Block= -SUPPLEMENTARY_PRIVATE_Use_AREA_B}', "");
    Expect(0, 1, '\P{^Is_Block= -SUPPLEMENTARY_PRIVATE_Use_AREA_B}', "");
    Error('\p{Is_Blk: 	sup_PUA_B:=}');
    Error('\P{Is_Blk: 	sup_PUA_B:=}');
    Expect(1, 1048576, '\p{Is_Blk=suppuab}', "");
    Expect(0, 1048576, '\p{^Is_Blk=suppuab}', "");
    Expect(0, 1048576, '\P{Is_Blk=suppuab}', "");
    Expect(1, 1048576, '\P{^Is_Blk=suppuab}', "");
    Expect(0, 1, '\p{Is_Blk=suppuab}', "");
    Expect(1, 1, '\p{^Is_Blk=suppuab}', "");
    Expect(1, 1, '\P{Is_Blk=suppuab}', "");
    Expect(0, 1, '\P{^Is_Blk=suppuab}', "");
    Expect(1, 1048576, '\p{Is_Blk=  Sup_PUA_B}', "");
    Expect(0, 1048576, '\p{^Is_Blk=  Sup_PUA_B}', "");
    Expect(0, 1048576, '\P{Is_Blk=  Sup_PUA_B}', "");
    Expect(1, 1048576, '\P{^Is_Blk=  Sup_PUA_B}', "");
    Expect(0, 1, '\p{Is_Blk=  Sup_PUA_B}', "");
    Expect(1, 1, '\p{^Is_Blk=  Sup_PUA_B}', "");
    Expect(1, 1, '\P{Is_Blk=  Sup_PUA_B}', "");
    Expect(0, 1, '\P{^Is_Blk=  Sup_PUA_B}', "");
    Error('\p{Block:   /a/Supplemental_punctuation}');
    Error('\P{Block:   /a/Supplemental_punctuation}');
    Expect(1, 11903, '\p{Block=:\ASupplemental_Punctuation\z:}', "");;
    Expect(0, 11904, '\p{Block=:\ASupplemental_Punctuation\z:}', "");;
    Expect(1, 11903, '\p{Block: supplementalpunctuation}', "");
    Expect(0, 11903, '\p{^Block: supplementalpunctuation}', "");
    Expect(0, 11903, '\P{Block: supplementalpunctuation}', "");
    Expect(1, 11903, '\P{^Block: supplementalpunctuation}', "");
    Expect(0, 11904, '\p{Block: supplementalpunctuation}', "");
    Expect(1, 11904, '\p{^Block: supplementalpunctuation}', "");
    Expect(1, 11904, '\P{Block: supplementalpunctuation}', "");
    Expect(0, 11904, '\P{^Block: supplementalpunctuation}', "");
    Expect(1, 11903, '\p{Block=:\Asupplementalpunctuation\z:}', "");;
    Expect(0, 11904, '\p{Block=:\Asupplementalpunctuation\z:}', "");;
    Expect(1, 11903, '\p{Block=-Supplemental_PUNCTUATION}', "");
    Expect(0, 11903, '\p{^Block=-Supplemental_PUNCTUATION}', "");
    Expect(0, 11903, '\P{Block=-Supplemental_PUNCTUATION}', "");
    Expect(1, 11903, '\P{^Block=-Supplemental_PUNCTUATION}', "");
    Expect(0, 11904, '\p{Block=-Supplemental_PUNCTUATION}', "");
    Expect(1, 11904, '\p{^Block=-Supplemental_PUNCTUATION}', "");
    Expect(1, 11904, '\P{Block=-Supplemental_PUNCTUATION}', "");
    Expect(0, 11904, '\P{^Block=-Supplemental_PUNCTUATION}', "");
    Error('\p{Blk=  Sup_PUNCTUATION:=}');
    Error('\P{Blk=  Sup_PUNCTUATION:=}');
    Expect(1, 11903, '\p{Blk=:\ASup_Punctuation\z:}', "");;
    Expect(0, 11904, '\p{Blk=:\ASup_Punctuation\z:}', "");;
    Expect(1, 11903, '\p{Blk=suppunctuation}', "");
    Expect(0, 11903, '\p{^Blk=suppunctuation}', "");
    Expect(0, 11903, '\P{Blk=suppunctuation}', "");
    Expect(1, 11903, '\P{^Blk=suppunctuation}', "");
    Expect(0, 11904, '\p{Blk=suppunctuation}', "");
    Expect(1, 11904, '\p{^Blk=suppunctuation}', "");
    Expect(1, 11904, '\P{Blk=suppunctuation}', "");
    Expect(0, 11904, '\P{^Blk=suppunctuation}', "");
    Expect(1, 11903, '\p{Blk=:\Asuppunctuation\z:}', "");;
    Expect(0, 11904, '\p{Blk=:\Asuppunctuation\z:}', "");;
    Expect(1, 11903, '\p{Blk=_Sup_PUNCTUATION}', "");
    Expect(0, 11903, '\p{^Blk=_Sup_PUNCTUATION}', "");
    Expect(0, 11903, '\P{Blk=_Sup_PUNCTUATION}', "");
    Expect(1, 11903, '\P{^Blk=_Sup_PUNCTUATION}', "");
    Expect(0, 11904, '\p{Blk=_Sup_PUNCTUATION}', "");
    Expect(1, 11904, '\p{^Blk=_Sup_PUNCTUATION}', "");
    Expect(1, 11904, '\P{Blk=_Sup_PUNCTUATION}', "");
    Expect(0, 11904, '\P{^Blk=_Sup_PUNCTUATION}', "");
    Error('\p{Is_Block=-:=Supplemental_punctuation}');
    Error('\P{Is_Block=-:=Supplemental_punctuation}');
    Expect(1, 11903, '\p{Is_Block: supplementalpunctuation}', "");
    Expect(0, 11903, '\p{^Is_Block: supplementalpunctuation}', "");
    Expect(0, 11903, '\P{Is_Block: supplementalpunctuation}', "");
    Expect(1, 11903, '\P{^Is_Block: supplementalpunctuation}', "");
    Expect(0, 11904, '\p{Is_Block: supplementalpunctuation}', "");
    Expect(1, 11904, '\p{^Is_Block: supplementalpunctuation}', "");
    Expect(1, 11904, '\P{Is_Block: supplementalpunctuation}', "");
    Expect(0, 11904, '\P{^Is_Block: supplementalpunctuation}', "");
    Expect(1, 11903, '\p{Is_Block=-_Supplemental_Punctuation}', "");
    Expect(0, 11903, '\p{^Is_Block=-_Supplemental_Punctuation}', "");
    Expect(0, 11903, '\P{Is_Block=-_Supplemental_Punctuation}', "");
    Expect(1, 11903, '\P{^Is_Block=-_Supplemental_Punctuation}', "");
    Expect(0, 11904, '\p{Is_Block=-_Supplemental_Punctuation}', "");
    Expect(1, 11904, '\p{^Is_Block=-_Supplemental_Punctuation}', "");
    Expect(1, 11904, '\P{Is_Block=-_Supplemental_Punctuation}', "");
    Expect(0, 11904, '\P{^Is_Block=-_Supplemental_Punctuation}', "");
    Error('\p{Is_Blk:-SUP_Punctuation:=}');
    Error('\P{Is_Blk:-SUP_Punctuation:=}');
    Expect(1, 11903, '\p{Is_Blk=suppunctuation}', "");
    Expect(0, 11903, '\p{^Is_Blk=suppunctuation}', "");
    Expect(0, 11903, '\P{Is_Blk=suppunctuation}', "");
    Expect(1, 11903, '\P{^Is_Blk=suppunctuation}', "");
    Expect(0, 11904, '\p{Is_Blk=suppunctuation}', "");
    Expect(1, 11904, '\p{^Is_Blk=suppunctuation}', "");
    Expect(1, 11904, '\P{Is_Blk=suppunctuation}', "");
    Expect(0, 11904, '\P{^Is_Blk=suppunctuation}', "");
    Expect(1, 11903, '\p{Is_Blk=_	Sup_punctuation}', "");
    Expect(0, 11903, '\p{^Is_Blk=_	Sup_punctuation}', "");
    Expect(0, 11903, '\P{Is_Blk=_	Sup_punctuation}', "");
    Expect(1, 11903, '\P{^Is_Blk=_	Sup_punctuation}', "");
    Expect(0, 11904, '\p{Is_Blk=_	Sup_punctuation}', "");
    Expect(1, 11904, '\p{^Is_Blk=_	Sup_punctuation}', "");
    Expect(1, 11904, '\P{Is_Blk=_	Sup_punctuation}', "");
    Expect(0, 11904, '\P{^Is_Blk=_	Sup_punctuation}', "");
    Error('\p{Block:	 Supplemental_SYMBOLS_AND_PICTOGRAPHS:=}');
    Error('\P{Block:	 Supplemental_SYMBOLS_AND_PICTOGRAPHS:=}');
    Expect(1, 129535, '\p{Block=:\ASupplemental_Symbols_And_Pictographs\z:}', "");;
    Expect(0, 129536, '\p{Block=:\ASupplemental_Symbols_And_Pictographs\z:}', "");;
    Expect(1, 129535, '\p{Block=supplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^Block=supplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{Block=supplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^Block=supplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{Block=supplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^Block=supplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{Block=supplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^Block=supplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{Block=:\Asupplementalsymbolsandpictographs\z:}', "");;
    Expect(0, 129536, '\p{Block=:\Asupplementalsymbolsandpictographs\z:}', "");;
    Expect(1, 129535, '\p{Block= -SUPPLEMENTAL_SYMBOLS_And_Pictographs}', "");
    Expect(0, 129535, '\p{^Block= -SUPPLEMENTAL_SYMBOLS_And_Pictographs}', "");
    Expect(0, 129535, '\P{Block= -SUPPLEMENTAL_SYMBOLS_And_Pictographs}', "");
    Expect(1, 129535, '\P{^Block= -SUPPLEMENTAL_SYMBOLS_And_Pictographs}', "");
    Expect(0, 129536, '\p{Block= -SUPPLEMENTAL_SYMBOLS_And_Pictographs}', "");
    Expect(1, 129536, '\p{^Block= -SUPPLEMENTAL_SYMBOLS_And_Pictographs}', "");
    Expect(1, 129536, '\P{Block= -SUPPLEMENTAL_SYMBOLS_And_Pictographs}', "");
    Expect(0, 129536, '\P{^Block= -SUPPLEMENTAL_SYMBOLS_And_Pictographs}', "");
    Error('\p{Blk=-/a/SUP_SYMBOLS_and_PICTOGRAPHS}');
    Error('\P{Blk=-/a/SUP_SYMBOLS_and_PICTOGRAPHS}');
    Expect(1, 129535, '\p{Blk=:\ASup_Symbols_And_Pictographs\z:}', "");;
    Expect(0, 129536, '\p{Blk=:\ASup_Symbols_And_Pictographs\z:}', "");;
    Expect(1, 129535, '\p{Blk=supsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^Blk=supsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{Blk=supsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^Blk=supsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{Blk=supsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^Blk=supsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{Blk=supsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^Blk=supsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{Blk=:\Asupsymbolsandpictographs\z:}', "");;
    Expect(0, 129536, '\p{Blk=:\Asupsymbolsandpictographs\z:}', "");;
    Expect(1, 129535, '\p{Blk=	Sup_symbols_And_pictographs}', "");
    Expect(0, 129535, '\p{^Blk=	Sup_symbols_And_pictographs}', "");
    Expect(0, 129535, '\P{Blk=	Sup_symbols_And_pictographs}', "");
    Expect(1, 129535, '\P{^Blk=	Sup_symbols_And_pictographs}', "");
    Expect(0, 129536, '\p{Blk=	Sup_symbols_And_pictographs}', "");
    Expect(1, 129536, '\p{^Blk=	Sup_symbols_And_pictographs}', "");
    Expect(1, 129536, '\P{Blk=	Sup_symbols_And_pictographs}', "");
    Expect(0, 129536, '\P{^Blk=	Sup_symbols_And_pictographs}', "");
    Error('\p{Is_Block=/a/- SUPPLEMENTAL_SYMBOLS_and_Pictographs}');
    Error('\P{Is_Block=/a/- SUPPLEMENTAL_SYMBOLS_and_Pictographs}');
    Expect(1, 129535, '\p{Is_Block=supplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^Is_Block=supplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{Is_Block=supplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^Is_Block=supplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{Is_Block=supplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^Is_Block=supplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{Is_Block=supplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^Is_Block=supplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{Is_Block= Supplemental_Symbols_And_Pictographs}', "");
    Expect(0, 129535, '\p{^Is_Block= Supplemental_Symbols_And_Pictographs}', "");
    Expect(0, 129535, '\P{Is_Block= Supplemental_Symbols_And_Pictographs}', "");
    Expect(1, 129535, '\P{^Is_Block= Supplemental_Symbols_And_Pictographs}', "");
    Expect(0, 129536, '\p{Is_Block= Supplemental_Symbols_And_Pictographs}', "");
    Expect(1, 129536, '\p{^Is_Block= Supplemental_Symbols_And_Pictographs}', "");
    Expect(1, 129536, '\P{Is_Block= Supplemental_Symbols_And_Pictographs}', "");
    Expect(0, 129536, '\P{^Is_Block= Supplemental_Symbols_And_Pictographs}', "");
    Error('\p{Is_Blk=-/a/sup_Symbols_AND_PICTOGRAPHS}');
    Error('\P{Is_Blk=-/a/sup_Symbols_AND_PICTOGRAPHS}');
    Expect(1, 129535, '\p{Is_Blk=supsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^Is_Blk=supsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{Is_Blk=supsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^Is_Blk=supsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{Is_Blk=supsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^Is_Blk=supsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{Is_Blk=supsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^Is_Blk=supsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{Is_Blk=_sup_SYMBOLS_And_Pictographs}', "");
    Expect(0, 129535, '\p{^Is_Blk=_sup_SYMBOLS_And_Pictographs}', "");
    Expect(0, 129535, '\P{Is_Blk=_sup_SYMBOLS_And_Pictographs}', "");
    Expect(1, 129535, '\P{^Is_Blk=_sup_SYMBOLS_And_Pictographs}', "");
    Expect(0, 129536, '\p{Is_Blk=_sup_SYMBOLS_And_Pictographs}', "");
    Expect(1, 129536, '\p{^Is_Blk=_sup_SYMBOLS_And_Pictographs}', "");
    Expect(1, 129536, '\P{Is_Blk=_sup_SYMBOLS_And_Pictographs}', "");
    Expect(0, 129536, '\P{^Is_Blk=_sup_SYMBOLS_And_Pictographs}', "");
    Error('\p{Block=-_SUPERSCRIPTS_AND_subscripts:=}');
    Error('\P{Block=-_SUPERSCRIPTS_AND_subscripts:=}');
    Expect(1, 8351, '\p{Block=:\ASuperscripts_And_Subscripts\z:}', "");;
    Expect(0, 8352, '\p{Block=:\ASuperscripts_And_Subscripts\z:}', "");;
    Expect(1, 8351, '\p{Block=superscriptsandsubscripts}', "");
    Expect(0, 8351, '\p{^Block=superscriptsandsubscripts}', "");
    Expect(0, 8351, '\P{Block=superscriptsandsubscripts}', "");
    Expect(1, 8351, '\P{^Block=superscriptsandsubscripts}', "");
    Expect(0, 8352, '\p{Block=superscriptsandsubscripts}', "");
    Expect(1, 8352, '\p{^Block=superscriptsandsubscripts}', "");
    Expect(1, 8352, '\P{Block=superscriptsandsubscripts}', "");
    Expect(0, 8352, '\P{^Block=superscriptsandsubscripts}', "");
    Expect(1, 8351, '\p{Block=:\Asuperscriptsandsubscripts\z:}', "");;
    Expect(0, 8352, '\p{Block=:\Asuperscriptsandsubscripts\z:}', "");;
    Expect(1, 8351, '\p{Block:	-	superscripts_AND_subscripts}', "");
    Expect(0, 8351, '\p{^Block:	-	superscripts_AND_subscripts}', "");
    Expect(0, 8351, '\P{Block:	-	superscripts_AND_subscripts}', "");
    Expect(1, 8351, '\P{^Block:	-	superscripts_AND_subscripts}', "");
    Expect(0, 8352, '\p{Block:	-	superscripts_AND_subscripts}', "");
    Expect(1, 8352, '\p{^Block:	-	superscripts_AND_subscripts}', "");
    Expect(1, 8352, '\P{Block:	-	superscripts_AND_subscripts}', "");
    Expect(0, 8352, '\P{^Block:	-	superscripts_AND_subscripts}', "");
    Error('\p{Blk=:=-	Super_and_SUB}');
    Error('\P{Blk=:=-	Super_and_SUB}');
    Expect(1, 8351, '\p{Blk=:\ASuper_And_Sub\z:}', "");;
    Expect(0, 8352, '\p{Blk=:\ASuper_And_Sub\z:}', "");;
    Expect(1, 8351, '\p{Blk=superandsub}', "");
    Expect(0, 8351, '\p{^Blk=superandsub}', "");
    Expect(0, 8351, '\P{Blk=superandsub}', "");
    Expect(1, 8351, '\P{^Blk=superandsub}', "");
    Expect(0, 8352, '\p{Blk=superandsub}', "");
    Expect(1, 8352, '\p{^Blk=superandsub}', "");
    Expect(1, 8352, '\P{Blk=superandsub}', "");
    Expect(0, 8352, '\P{^Blk=superandsub}', "");
    Expect(1, 8351, '\p{Blk=:\Asuperandsub\z:}', "");;
    Expect(0, 8352, '\p{Blk=:\Asuperandsub\z:}', "");;
    Expect(1, 8351, '\p{Blk=-	Super_AND_sub}', "");
    Expect(0, 8351, '\p{^Blk=-	Super_AND_sub}', "");
    Expect(0, 8351, '\P{Blk=-	Super_AND_sub}', "");
    Expect(1, 8351, '\P{^Blk=-	Super_AND_sub}', "");
    Expect(0, 8352, '\p{Blk=-	Super_AND_sub}', "");
    Expect(1, 8352, '\p{^Blk=-	Super_AND_sub}', "");
    Expect(1, 8352, '\P{Blk=-	Super_AND_sub}', "");
    Expect(0, 8352, '\P{^Blk=-	Super_AND_sub}', "");
    Error('\p{Is_Block=/a/_Superscripts_And_Subscripts}');
    Error('\P{Is_Block=/a/_Superscripts_And_Subscripts}');
    Expect(1, 8351, '\p{Is_Block=superscriptsandsubscripts}', "");
    Expect(0, 8351, '\p{^Is_Block=superscriptsandsubscripts}', "");
    Expect(0, 8351, '\P{Is_Block=superscriptsandsubscripts}', "");
    Expect(1, 8351, '\P{^Is_Block=superscriptsandsubscripts}', "");
    Expect(0, 8352, '\p{Is_Block=superscriptsandsubscripts}', "");
    Expect(1, 8352, '\p{^Is_Block=superscriptsandsubscripts}', "");
    Expect(1, 8352, '\P{Is_Block=superscriptsandsubscripts}', "");
    Expect(0, 8352, '\P{^Is_Block=superscriptsandsubscripts}', "");
    Expect(1, 8351, '\p{Is_Block: _-Superscripts_And_Subscripts}', "");
    Expect(0, 8351, '\p{^Is_Block: _-Superscripts_And_Subscripts}', "");
    Expect(0, 8351, '\P{Is_Block: _-Superscripts_And_Subscripts}', "");
    Expect(1, 8351, '\P{^Is_Block: _-Superscripts_And_Subscripts}', "");
    Expect(0, 8352, '\p{Is_Block: _-Superscripts_And_Subscripts}', "");
    Expect(1, 8352, '\p{^Is_Block: _-Superscripts_And_Subscripts}', "");
    Expect(1, 8352, '\P{Is_Block: _-Superscripts_And_Subscripts}', "");
    Expect(0, 8352, '\P{^Is_Block: _-Superscripts_And_Subscripts}', "");
    Error('\p{Is_Blk=__Super_and_Sub/a/}');
    Error('\P{Is_Blk=__Super_and_Sub/a/}');
    Expect(1, 8351, '\p{Is_Blk=superandsub}', "");
    Expect(0, 8351, '\p{^Is_Blk=superandsub}', "");
    Expect(0, 8351, '\P{Is_Blk=superandsub}', "");
    Expect(1, 8351, '\P{^Is_Blk=superandsub}', "");
    Expect(0, 8352, '\p{Is_Blk=superandsub}', "");
    Expect(1, 8352, '\p{^Is_Blk=superandsub}', "");
    Expect(1, 8352, '\P{Is_Blk=superandsub}', "");
    Expect(0, 8352, '\P{^Is_Blk=superandsub}', "");
    Expect(1, 8351, '\p{Is_Blk=--SUPER_And_Sub}', "");
    Expect(0, 8351, '\p{^Is_Blk=--SUPER_And_Sub}', "");
    Expect(0, 8351, '\P{Is_Blk=--SUPER_And_Sub}', "");
    Expect(1, 8351, '\P{^Is_Blk=--SUPER_And_Sub}', "");
    Expect(0, 8352, '\p{Is_Blk=--SUPER_And_Sub}', "");
    Expect(1, 8352, '\p{^Is_Blk=--SUPER_And_Sub}', "");
    Expect(1, 8352, '\P{Is_Blk=--SUPER_And_Sub}', "");
    Expect(0, 8352, '\P{^Is_Blk=--SUPER_And_Sub}', "");
    Error('\p{Block=/a/ 	Sutton_SignWriting}');
    Error('\P{Block=/a/ 	Sutton_SignWriting}');
    Expect(1, 121519, '\p{Block=:\ASutton_SignWriting\z:}', "");;
    Expect(0, 121520, '\p{Block=:\ASutton_SignWriting\z:}', "");;
    Expect(1, 121519, '\p{Block=suttonsignwriting}', "");
    Expect(0, 121519, '\p{^Block=suttonsignwriting}', "");
    Expect(0, 121519, '\P{Block=suttonsignwriting}', "");
    Expect(1, 121519, '\P{^Block=suttonsignwriting}', "");
    Expect(0, 121520, '\p{Block=suttonsignwriting}', "");
    Expect(1, 121520, '\p{^Block=suttonsignwriting}', "");
    Expect(1, 121520, '\P{Block=suttonsignwriting}', "");
    Expect(0, 121520, '\P{^Block=suttonsignwriting}', "");
    Expect(1, 121519, '\p{Block=:\Asuttonsignwriting\z:}', "");;
    Expect(0, 121520, '\p{Block=:\Asuttonsignwriting\z:}', "");;
    Expect(1, 121519, '\p{Block=		Sutton_signwriting}', "");
    Expect(0, 121519, '\p{^Block=		Sutton_signwriting}', "");
    Expect(0, 121519, '\P{Block=		Sutton_signwriting}', "");
    Expect(1, 121519, '\P{^Block=		Sutton_signwriting}', "");
    Expect(0, 121520, '\p{Block=		Sutton_signwriting}', "");
    Expect(1, 121520, '\p{^Block=		Sutton_signwriting}', "");
    Expect(1, 121520, '\P{Block=		Sutton_signwriting}', "");
    Expect(0, 121520, '\P{^Block=		Sutton_signwriting}', "");
    Error('\p{Blk=:= sutton_SIGNWRITING}');
    Error('\P{Blk=:= sutton_SIGNWRITING}');
    Expect(1, 121519, '\p{Blk=:\ASutton_SignWriting\z:}', "");;
    Expect(0, 121520, '\p{Blk=:\ASutton_SignWriting\z:}', "");;
    Expect(1, 121519, '\p{Blk=suttonsignwriting}', "");
    Expect(0, 121519, '\p{^Blk=suttonsignwriting}', "");
    Expect(0, 121519, '\P{Blk=suttonsignwriting}', "");
    Expect(1, 121519, '\P{^Blk=suttonsignwriting}', "");
    Expect(0, 121520, '\p{Blk=suttonsignwriting}', "");
    Expect(1, 121520, '\p{^Blk=suttonsignwriting}', "");
    Expect(1, 121520, '\P{Blk=suttonsignwriting}', "");
    Expect(0, 121520, '\P{^Blk=suttonsignwriting}', "");
    Expect(1, 121519, '\p{Blk=:\Asuttonsignwriting\z:}', "");;
    Expect(0, 121520, '\p{Blk=:\Asuttonsignwriting\z:}', "");;
    Expect(1, 121519, '\p{Blk=-_Sutton_signwriting}', "");
    Expect(0, 121519, '\p{^Blk=-_Sutton_signwriting}', "");
    Expect(0, 121519, '\P{Blk=-_Sutton_signwriting}', "");
    Expect(1, 121519, '\P{^Blk=-_Sutton_signwriting}', "");
    Expect(0, 121520, '\p{Blk=-_Sutton_signwriting}', "");
    Expect(1, 121520, '\p{^Blk=-_Sutton_signwriting}', "");
    Expect(1, 121520, '\P{Blk=-_Sutton_signwriting}', "");
    Expect(0, 121520, '\P{^Blk=-_Sutton_signwriting}', "");
    Error('\p{Is_Block=:=	Sutton_SIGNWRITING}');
    Error('\P{Is_Block=:=	Sutton_SIGNWRITING}');
    Expect(1, 121519, '\p{Is_Block=suttonsignwriting}', "");
    Expect(0, 121519, '\p{^Is_Block=suttonsignwriting}', "");
    Expect(0, 121519, '\P{Is_Block=suttonsignwriting}', "");
    Expect(1, 121519, '\P{^Is_Block=suttonsignwriting}', "");
    Expect(0, 121520, '\p{Is_Block=suttonsignwriting}', "");
    Expect(1, 121520, '\p{^Is_Block=suttonsignwriting}', "");
    Expect(1, 121520, '\P{Is_Block=suttonsignwriting}', "");
    Expect(0, 121520, '\P{^Is_Block=suttonsignwriting}', "");
    Expect(1, 121519, '\p{Is_Block=	 Sutton_SIGNWRITING}', "");
    Expect(0, 121519, '\p{^Is_Block=	 Sutton_SIGNWRITING}', "");
    Expect(0, 121519, '\P{Is_Block=	 Sutton_SIGNWRITING}', "");
    Expect(1, 121519, '\P{^Is_Block=	 Sutton_SIGNWRITING}', "");
    Expect(0, 121520, '\p{Is_Block=	 Sutton_SIGNWRITING}', "");
    Expect(1, 121520, '\p{^Is_Block=	 Sutton_SIGNWRITING}', "");
    Expect(1, 121520, '\P{Is_Block=	 Sutton_SIGNWRITING}', "");
    Expect(0, 121520, '\P{^Is_Block=	 Sutton_SIGNWRITING}', "");
    Error('\p{Is_Blk:	-/a/Sutton_SignWriting}');
    Error('\P{Is_Blk:	-/a/Sutton_SignWriting}');
    Expect(1, 121519, '\p{Is_Blk=suttonsignwriting}', "");
    Expect(0, 121519, '\p{^Is_Blk=suttonsignwriting}', "");
    Expect(0, 121519, '\P{Is_Blk=suttonsignwriting}', "");
    Expect(1, 121519, '\P{^Is_Blk=suttonsignwriting}', "");
    Expect(0, 121520, '\p{Is_Blk=suttonsignwriting}', "");
    Expect(1, 121520, '\p{^Is_Blk=suttonsignwriting}', "");
    Expect(1, 121520, '\P{Is_Blk=suttonsignwriting}', "");
    Expect(0, 121520, '\P{^Is_Blk=suttonsignwriting}', "");
    Expect(1, 121519, '\p{Is_Blk= -SUTTON_SignWriting}', "");
    Expect(0, 121519, '\p{^Is_Blk= -SUTTON_SignWriting}', "");
    Expect(0, 121519, '\P{Is_Blk= -SUTTON_SignWriting}', "");
    Expect(1, 121519, '\P{^Is_Blk= -SUTTON_SignWriting}', "");
    Expect(0, 121520, '\p{Is_Blk= -SUTTON_SignWriting}', "");
    Expect(1, 121520, '\p{^Is_Blk= -SUTTON_SignWriting}', "");
    Expect(1, 121520, '\P{Is_Blk= -SUTTON_SignWriting}', "");
    Expect(0, 121520, '\P{^Is_Blk= -SUTTON_SignWriting}', "");
    Error('\p{Block=-SYLOTI_nagri:=}');
    Error('\P{Block=-SYLOTI_nagri:=}');
    Expect(1, 43055, '\p{Block=:\ASyloti_Nagri\z:}', "");;
    Expect(0, 43056, '\p{Block=:\ASyloti_Nagri\z:}', "");;
    Expect(1, 43055, '\p{Block=sylotinagri}', "");
    Expect(0, 43055, '\p{^Block=sylotinagri}', "");
    Expect(0, 43055, '\P{Block=sylotinagri}', "");
    Expect(1, 43055, '\P{^Block=sylotinagri}', "");
    Expect(0, 43056, '\p{Block=sylotinagri}', "");
    Expect(1, 43056, '\p{^Block=sylotinagri}', "");
    Expect(1, 43056, '\P{Block=sylotinagri}', "");
    Expect(0, 43056, '\P{^Block=sylotinagri}', "");
    Expect(1, 43055, '\p{Block=:\Asylotinagri\z:}', "");;
    Expect(0, 43056, '\p{Block=:\Asylotinagri\z:}', "");;
    Expect(1, 43055, '\p{Block=-Syloti_NAGRI}', "");
    Expect(0, 43055, '\p{^Block=-Syloti_NAGRI}', "");
    Expect(0, 43055, '\P{Block=-Syloti_NAGRI}', "");
    Expect(1, 43055, '\P{^Block=-Syloti_NAGRI}', "");
    Expect(0, 43056, '\p{Block=-Syloti_NAGRI}', "");
    Expect(1, 43056, '\p{^Block=-Syloti_NAGRI}', "");
    Expect(1, 43056, '\P{Block=-Syloti_NAGRI}', "");
    Expect(0, 43056, '\P{^Block=-Syloti_NAGRI}', "");
    Error('\p{Blk=/a/ Syloti_Nagri}');
    Error('\P{Blk=/a/ Syloti_Nagri}');
    Expect(1, 43055, '\p{Blk=:\ASyloti_Nagri\z:}', "");;
    Expect(0, 43056, '\p{Blk=:\ASyloti_Nagri\z:}', "");;
    Expect(1, 43055, '\p{Blk=sylotinagri}', "");
    Expect(0, 43055, '\p{^Blk=sylotinagri}', "");
    Expect(0, 43055, '\P{Blk=sylotinagri}', "");
    Expect(1, 43055, '\P{^Blk=sylotinagri}', "");
    Expect(0, 43056, '\p{Blk=sylotinagri}', "");
    Expect(1, 43056, '\p{^Blk=sylotinagri}', "");
    Expect(1, 43056, '\P{Blk=sylotinagri}', "");
    Expect(0, 43056, '\P{^Blk=sylotinagri}', "");
    Expect(1, 43055, '\p{Blk=:\Asylotinagri\z:}', "");;
    Expect(0, 43056, '\p{Blk=:\Asylotinagri\z:}', "");;
    Expect(1, 43055, '\p{Blk= 	SYLOTI_NAGRI}', "");
    Expect(0, 43055, '\p{^Blk= 	SYLOTI_NAGRI}', "");
    Expect(0, 43055, '\P{Blk= 	SYLOTI_NAGRI}', "");
    Expect(1, 43055, '\P{^Blk= 	SYLOTI_NAGRI}', "");
    Expect(0, 43056, '\p{Blk= 	SYLOTI_NAGRI}', "");
    Expect(1, 43056, '\p{^Blk= 	SYLOTI_NAGRI}', "");
    Expect(1, 43056, '\P{Blk= 	SYLOTI_NAGRI}', "");
    Expect(0, 43056, '\P{^Blk= 	SYLOTI_NAGRI}', "");
    Error('\p{Is_Block=__syloti_nagri:=}');
    Error('\P{Is_Block=__syloti_nagri:=}');
    Expect(1, 43055, '\p{Is_Block=sylotinagri}', "");
    Expect(0, 43055, '\p{^Is_Block=sylotinagri}', "");
    Expect(0, 43055, '\P{Is_Block=sylotinagri}', "");
    Expect(1, 43055, '\P{^Is_Block=sylotinagri}', "");
    Expect(0, 43056, '\p{Is_Block=sylotinagri}', "");
    Expect(1, 43056, '\p{^Is_Block=sylotinagri}', "");
    Expect(1, 43056, '\P{Is_Block=sylotinagri}', "");
    Expect(0, 43056, '\P{^Is_Block=sylotinagri}', "");
    Expect(1, 43055, '\p{Is_Block=_Syloti_Nagri}', "");
    Expect(0, 43055, '\p{^Is_Block=_Syloti_Nagri}', "");
    Expect(0, 43055, '\P{Is_Block=_Syloti_Nagri}', "");
    Expect(1, 43055, '\P{^Is_Block=_Syloti_Nagri}', "");
    Expect(0, 43056, '\p{Is_Block=_Syloti_Nagri}', "");
    Expect(1, 43056, '\p{^Is_Block=_Syloti_Nagri}', "");
    Expect(1, 43056, '\P{Is_Block=_Syloti_Nagri}', "");
    Expect(0, 43056, '\P{^Is_Block=_Syloti_Nagri}', "");
    Error('\p{Is_Blk= _SYLOTI_Nagri/a/}');
    Error('\P{Is_Blk= _SYLOTI_Nagri/a/}');
    Expect(1, 43055, '\p{Is_Blk=sylotinagri}', "");
    Expect(0, 43055, '\p{^Is_Blk=sylotinagri}', "");
    Expect(0, 43055, '\P{Is_Blk=sylotinagri}', "");
    Expect(1, 43055, '\P{^Is_Blk=sylotinagri}', "");
    Expect(0, 43056, '\p{Is_Blk=sylotinagri}', "");
    Expect(1, 43056, '\p{^Is_Blk=sylotinagri}', "");
    Expect(1, 43056, '\P{Is_Blk=sylotinagri}', "");
    Expect(0, 43056, '\P{^Is_Blk=sylotinagri}', "");
    Expect(1, 43055, '\p{Is_Blk= _syloti_Nagri}', "");
    Expect(0, 43055, '\p{^Is_Blk= _syloti_Nagri}', "");
    Expect(0, 43055, '\P{Is_Blk= _syloti_Nagri}', "");
    Expect(1, 43055, '\P{^Is_Blk= _syloti_Nagri}', "");
    Expect(0, 43056, '\p{Is_Blk= _syloti_Nagri}', "");
    Expect(1, 43056, '\p{^Is_Blk= _syloti_Nagri}', "");
    Expect(1, 43056, '\P{Is_Blk= _syloti_Nagri}', "");
    Expect(0, 43056, '\P{^Is_Blk= _syloti_Nagri}', "");
    Error('\p{Block=	/a/Symbols_AND_PICTOGRAPHS_extended_a}');
    Error('\P{Block=	/a/Symbols_AND_PICTOGRAPHS_extended_a}');
    Expect(1, 129791, '\p{Block=:\ASymbols_And_Pictographs_Extended_A\z:}', "");;
    Expect(0, 129792, '\p{Block=:\ASymbols_And_Pictographs_Extended_A\z:}', "");;
    Expect(1, 129791, '\p{Block=symbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\p{^Block=symbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\P{Block=symbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\P{^Block=symbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\p{Block=symbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\p{^Block=symbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\P{Block=symbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\P{^Block=symbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\p{Block=:\Asymbolsandpictographsextendeda\z:}', "");;
    Expect(0, 129792, '\p{Block=:\Asymbolsandpictographsextendeda\z:}', "");;
    Expect(1, 129791, '\p{Block:	 Symbols_And_pictographs_extended_A}', "");
    Expect(0, 129791, '\p{^Block:	 Symbols_And_pictographs_extended_A}', "");
    Expect(0, 129791, '\P{Block:	 Symbols_And_pictographs_extended_A}', "");
    Expect(1, 129791, '\P{^Block:	 Symbols_And_pictographs_extended_A}', "");
    Expect(0, 129792, '\p{Block:	 Symbols_And_pictographs_extended_A}', "");
    Expect(1, 129792, '\p{^Block:	 Symbols_And_pictographs_extended_A}', "");
    Expect(1, 129792, '\P{Block:	 Symbols_And_pictographs_extended_A}', "");
    Expect(0, 129792, '\P{^Block:	 Symbols_And_pictographs_extended_A}', "");
    Error('\p{Blk=_:=SYMBOLS_And_Pictographs_Ext_a}');
    Error('\P{Blk=_:=SYMBOLS_And_Pictographs_Ext_a}');
    Expect(1, 129791, '\p{Blk=:\ASymbols_And_Pictographs_Ext_A\z:}', "");;
    Expect(0, 129792, '\p{Blk=:\ASymbols_And_Pictographs_Ext_A\z:}', "");;
    Expect(1, 129791, '\p{Blk=symbolsandpictographsexta}', "");
    Expect(0, 129791, '\p{^Blk=symbolsandpictographsexta}', "");
    Expect(0, 129791, '\P{Blk=symbolsandpictographsexta}', "");
    Expect(1, 129791, '\P{^Blk=symbolsandpictographsexta}', "");
    Expect(0, 129792, '\p{Blk=symbolsandpictographsexta}', "");
    Expect(1, 129792, '\p{^Blk=symbolsandpictographsexta}', "");
    Expect(1, 129792, '\P{Blk=symbolsandpictographsexta}', "");
    Expect(0, 129792, '\P{^Blk=symbolsandpictographsexta}', "");
    Expect(1, 129791, '\p{Blk=:\Asymbolsandpictographsexta\z:}', "");;
    Expect(0, 129792, '\p{Blk=:\Asymbolsandpictographsexta\z:}', "");;
    Expect(1, 129791, '\p{Blk=- SYMBOLS_and_pictographs_Ext_A}', "");
    Expect(0, 129791, '\p{^Blk=- SYMBOLS_and_pictographs_Ext_A}', "");
    Expect(0, 129791, '\P{Blk=- SYMBOLS_and_pictographs_Ext_A}', "");
    Expect(1, 129791, '\P{^Blk=- SYMBOLS_and_pictographs_Ext_A}', "");
    Expect(0, 129792, '\p{Blk=- SYMBOLS_and_pictographs_Ext_A}', "");
    Expect(1, 129792, '\p{^Blk=- SYMBOLS_and_pictographs_Ext_A}', "");
    Expect(1, 129792, '\P{Blk=- SYMBOLS_and_pictographs_Ext_A}', "");
    Expect(0, 129792, '\P{^Blk=- SYMBOLS_and_pictographs_Ext_A}', "");
    Error('\p{Is_Block=/a/-_Symbols_And_PICTOGRAPHS_Extended_a}');
    Error('\P{Is_Block=/a/-_Symbols_And_PICTOGRAPHS_Extended_a}');
    Expect(1, 129791, '\p{Is_Block:symbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\p{^Is_Block:symbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\P{Is_Block:symbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\P{^Is_Block:symbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\p{Is_Block:symbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\p{^Is_Block:symbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\P{Is_Block:symbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\P{^Is_Block:symbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\p{Is_Block= _Symbols_and_PICTOGRAPHS_extended_A}', "");
    Expect(0, 129791, '\p{^Is_Block= _Symbols_and_PICTOGRAPHS_extended_A}', "");
    Expect(0, 129791, '\P{Is_Block= _Symbols_and_PICTOGRAPHS_extended_A}', "");
    Expect(1, 129791, '\P{^Is_Block= _Symbols_and_PICTOGRAPHS_extended_A}', "");
    Expect(0, 129792, '\p{Is_Block= _Symbols_and_PICTOGRAPHS_extended_A}', "");
    Expect(1, 129792, '\p{^Is_Block= _Symbols_and_PICTOGRAPHS_extended_A}', "");
    Expect(1, 129792, '\P{Is_Block= _Symbols_and_PICTOGRAPHS_extended_A}', "");
    Expect(0, 129792, '\P{^Is_Block= _Symbols_and_PICTOGRAPHS_extended_A}', "");
    Error('\p{Is_Blk=/a/-SYMBOLS_And_Pictographs_Ext_A}');
    Error('\P{Is_Blk=/a/-SYMBOLS_And_Pictographs_Ext_A}');
    Expect(1, 129791, '\p{Is_Blk=symbolsandpictographsexta}', "");
    Expect(0, 129791, '\p{^Is_Blk=symbolsandpictographsexta}', "");
    Expect(0, 129791, '\P{Is_Blk=symbolsandpictographsexta}', "");
    Expect(1, 129791, '\P{^Is_Blk=symbolsandpictographsexta}', "");
    Expect(0, 129792, '\p{Is_Blk=symbolsandpictographsexta}', "");
    Expect(1, 129792, '\p{^Is_Blk=symbolsandpictographsexta}', "");
    Expect(1, 129792, '\P{Is_Blk=symbolsandpictographsexta}', "");
    Expect(0, 129792, '\P{^Is_Blk=symbolsandpictographsexta}', "");
    Expect(1, 129791, '\p{Is_Blk: --symbols_AND_PICTOGRAPHS_Ext_a}', "");
    Expect(0, 129791, '\p{^Is_Blk: --symbols_AND_PICTOGRAPHS_Ext_a}', "");
    Expect(0, 129791, '\P{Is_Blk: --symbols_AND_PICTOGRAPHS_Ext_a}', "");
    Expect(1, 129791, '\P{^Is_Blk: --symbols_AND_PICTOGRAPHS_Ext_a}', "");
    Expect(0, 129792, '\p{Is_Blk: --symbols_AND_PICTOGRAPHS_Ext_a}', "");
    Expect(1, 129792, '\p{^Is_Blk: --symbols_AND_PICTOGRAPHS_Ext_a}', "");
    Expect(1, 129792, '\P{Is_Blk: --symbols_AND_PICTOGRAPHS_Ext_a}', "");
    Expect(0, 129792, '\P{^Is_Blk: --symbols_AND_PICTOGRAPHS_Ext_a}', "");
    Error('\p{Block=_-SYRIAC:=}');
    Error('\P{Block=_-SYRIAC:=}');
    Expect(1, 1871, '\p{Block=:\ASyriac\z:}', "");;
    Expect(0, 1872, '\p{Block=:\ASyriac\z:}', "");;
    Expect(1, 1871, '\p{Block=syriac}', "");
    Expect(0, 1871, '\p{^Block=syriac}', "");
    Expect(0, 1871, '\P{Block=syriac}', "");
    Expect(1, 1871, '\P{^Block=syriac}', "");
    Expect(0, 1872, '\p{Block=syriac}', "");
    Expect(1, 1872, '\p{^Block=syriac}', "");
    Expect(1, 1872, '\P{Block=syriac}', "");
    Expect(0, 1872, '\P{^Block=syriac}', "");
    Expect(1, 1871, '\p{Block=:\Asyriac\z:}', "");;
    Expect(0, 1872, '\p{Block=:\Asyriac\z:}', "");;
    Expect(1, 1871, '\p{Block=	syriac}', "");
    Expect(0, 1871, '\p{^Block=	syriac}', "");
    Expect(0, 1871, '\P{Block=	syriac}', "");
    Expect(1, 1871, '\P{^Block=	syriac}', "");
    Expect(0, 1872, '\p{Block=	syriac}', "");
    Expect(1, 1872, '\p{^Block=	syriac}', "");
    Expect(1, 1872, '\P{Block=	syriac}', "");
    Expect(0, 1872, '\P{^Block=	syriac}', "");
    Error('\p{Blk=:=Syriac}');
    Error('\P{Blk=:=Syriac}');
    Expect(1, 1871, '\p{Blk=:\ASyriac\z:}', "");;
    Expect(0, 1872, '\p{Blk=:\ASyriac\z:}', "");;
    Expect(1, 1871, '\p{Blk=syriac}', "");
    Expect(0, 1871, '\p{^Blk=syriac}', "");
    Expect(0, 1871, '\P{Blk=syriac}', "");
    Expect(1, 1871, '\P{^Blk=syriac}', "");
    Expect(0, 1872, '\p{Blk=syriac}', "");
    Expect(1, 1872, '\p{^Blk=syriac}', "");
    Expect(1, 1872, '\P{Blk=syriac}', "");
    Expect(0, 1872, '\P{^Blk=syriac}', "");
    Expect(1, 1871, '\p{Blk=:\Asyriac\z:}', "");;
    Expect(0, 1872, '\p{Blk=:\Asyriac\z:}', "");;
    Expect(1, 1871, '\p{Blk=	SYRIAC}', "");
    Expect(0, 1871, '\p{^Blk=	SYRIAC}', "");
    Expect(0, 1871, '\P{Blk=	SYRIAC}', "");
    Expect(1, 1871, '\P{^Blk=	SYRIAC}', "");
    Expect(0, 1872, '\p{Blk=	SYRIAC}', "");
    Expect(1, 1872, '\p{^Blk=	SYRIAC}', "");
    Expect(1, 1872, '\P{Blk=	SYRIAC}', "");
    Expect(0, 1872, '\P{^Blk=	SYRIAC}', "");
    Error('\p{Is_Block=:= 	Syriac}');
    Error('\P{Is_Block=:= 	Syriac}');
    Expect(1, 1871, '\p{Is_Block=syriac}', "");
    Expect(0, 1871, '\p{^Is_Block=syriac}', "");
    Expect(0, 1871, '\P{Is_Block=syriac}', "");
    Expect(1, 1871, '\P{^Is_Block=syriac}', "");
    Expect(0, 1872, '\p{Is_Block=syriac}', "");
    Expect(1, 1872, '\p{^Is_Block=syriac}', "");
    Expect(1, 1872, '\P{Is_Block=syriac}', "");
    Expect(0, 1872, '\P{^Is_Block=syriac}', "");
    Expect(1, 1871, '\p{Is_Block=-SYRIAC}', "");
    Expect(0, 1871, '\p{^Is_Block=-SYRIAC}', "");
    Expect(0, 1871, '\P{Is_Block=-SYRIAC}', "");
    Expect(1, 1871, '\P{^Is_Block=-SYRIAC}', "");
    Expect(0, 1872, '\p{Is_Block=-SYRIAC}', "");
    Expect(1, 1872, '\p{^Is_Block=-SYRIAC}', "");
    Expect(1, 1872, '\P{Is_Block=-SYRIAC}', "");
    Expect(0, 1872, '\P{^Is_Block=-SYRIAC}', "");
    Error('\p{Is_Blk= /a/syriac}');
    Error('\P{Is_Blk= /a/syriac}');
    Expect(1, 1871, '\p{Is_Blk=syriac}', "");
    Expect(0, 1871, '\p{^Is_Blk=syriac}', "");
    Expect(0, 1871, '\P{Is_Blk=syriac}', "");
    Expect(1, 1871, '\P{^Is_Blk=syriac}', "");
    Expect(0, 1872, '\p{Is_Blk=syriac}', "");
    Expect(1, 1872, '\p{^Is_Blk=syriac}', "");
    Expect(1, 1872, '\P{Is_Blk=syriac}', "");
    Expect(0, 1872, '\P{^Is_Blk=syriac}', "");
    Expect(1, 1871, '\p{Is_Blk=SYRIAC}', "");
    Expect(0, 1871, '\p{^Is_Blk=SYRIAC}', "");
    Expect(0, 1871, '\P{Is_Blk=SYRIAC}', "");
    Expect(1, 1871, '\P{^Is_Blk=SYRIAC}', "");
    Expect(0, 1872, '\p{Is_Blk=SYRIAC}', "");
    Expect(1, 1872, '\p{^Is_Blk=SYRIAC}', "");
    Expect(1, 1872, '\P{Is_Blk=SYRIAC}', "");
    Expect(0, 1872, '\P{^Is_Blk=SYRIAC}', "");
    Error('\p{Block=:= Syriac_Supplement}');
    Error('\P{Block=:= Syriac_Supplement}');
    Expect(1, 2159, '\p{Block=:\ASyriac_Supplement\z:}', "");;
    Expect(0, 2160, '\p{Block=:\ASyriac_Supplement\z:}', "");;
    Expect(1, 2159, '\p{Block=syriacsupplement}', "");
    Expect(0, 2159, '\p{^Block=syriacsupplement}', "");
    Expect(0, 2159, '\P{Block=syriacsupplement}', "");
    Expect(1, 2159, '\P{^Block=syriacsupplement}', "");
    Expect(0, 2160, '\p{Block=syriacsupplement}', "");
    Expect(1, 2160, '\p{^Block=syriacsupplement}', "");
    Expect(1, 2160, '\P{Block=syriacsupplement}', "");
    Expect(0, 2160, '\P{^Block=syriacsupplement}', "");
    Expect(1, 2159, '\p{Block=:\Asyriacsupplement\z:}', "");;
    Expect(0, 2160, '\p{Block=:\Asyriacsupplement\z:}', "");;
    Expect(1, 2159, '\p{Block=_-Syriac_supplement}', "");
    Expect(0, 2159, '\p{^Block=_-Syriac_supplement}', "");
    Expect(0, 2159, '\P{Block=_-Syriac_supplement}', "");
    Expect(1, 2159, '\P{^Block=_-Syriac_supplement}', "");
    Expect(0, 2160, '\p{Block=_-Syriac_supplement}', "");
    Expect(1, 2160, '\p{^Block=_-Syriac_supplement}', "");
    Expect(1, 2160, '\P{Block=_-Syriac_supplement}', "");
    Expect(0, 2160, '\P{^Block=_-Syriac_supplement}', "");
    Error('\p{Blk=/a/Syriac_sup}');
    Error('\P{Blk=/a/Syriac_sup}');
    Expect(1, 2159, '\p{Blk=:\ASyriac_Sup\z:}', "");;
    Expect(0, 2160, '\p{Blk=:\ASyriac_Sup\z:}', "");;
    Expect(1, 2159, '\p{Blk=syriacsup}', "");
    Expect(0, 2159, '\p{^Blk=syriacsup}', "");
    Expect(0, 2159, '\P{Blk=syriacsup}', "");
    Expect(1, 2159, '\P{^Blk=syriacsup}', "");
    Expect(0, 2160, '\p{Blk=syriacsup}', "");
    Expect(1, 2160, '\p{^Blk=syriacsup}', "");
    Expect(1, 2160, '\P{Blk=syriacsup}', "");
    Expect(0, 2160, '\P{^Blk=syriacsup}', "");
    Expect(1, 2159, '\p{Blk=:\Asyriacsup\z:}', "");;
    Expect(0, 2160, '\p{Blk=:\Asyriacsup\z:}', "");;
    Expect(1, 2159, '\p{Blk=	syriac_sup}', "");
    Expect(0, 2159, '\p{^Blk=	syriac_sup}', "");
    Expect(0, 2159, '\P{Blk=	syriac_sup}', "");
    Expect(1, 2159, '\P{^Blk=	syriac_sup}', "");
    Expect(0, 2160, '\p{Blk=	syriac_sup}', "");
    Expect(1, 2160, '\p{^Blk=	syriac_sup}', "");
    Expect(1, 2160, '\P{Blk=	syriac_sup}', "");
    Expect(0, 2160, '\P{^Blk=	syriac_sup}', "");
    Error('\p{Is_Block:- Syriac_Supplement/a/}');
    Error('\P{Is_Block:- Syriac_Supplement/a/}');
    Expect(1, 2159, '\p{Is_Block=syriacsupplement}', "");
    Expect(0, 2159, '\p{^Is_Block=syriacsupplement}', "");
    Expect(0, 2159, '\P{Is_Block=syriacsupplement}', "");
    Expect(1, 2159, '\P{^Is_Block=syriacsupplement}', "");
    Expect(0, 2160, '\p{Is_Block=syriacsupplement}', "");
    Expect(1, 2160, '\p{^Is_Block=syriacsupplement}', "");
    Expect(1, 2160, '\P{Is_Block=syriacsupplement}', "");
    Expect(0, 2160, '\P{^Is_Block=syriacsupplement}', "");
    Expect(1, 2159, '\p{Is_Block:   _SYRIAC_Supplement}', "");
    Expect(0, 2159, '\p{^Is_Block:   _SYRIAC_Supplement}', "");
    Expect(0, 2159, '\P{Is_Block:   _SYRIAC_Supplement}', "");
    Expect(1, 2159, '\P{^Is_Block:   _SYRIAC_Supplement}', "");
    Expect(0, 2160, '\p{Is_Block:   _SYRIAC_Supplement}', "");
    Expect(1, 2160, '\p{^Is_Block:   _SYRIAC_Supplement}', "");
    Expect(1, 2160, '\P{Is_Block:   _SYRIAC_Supplement}', "");
    Expect(0, 2160, '\P{^Is_Block:   _SYRIAC_Supplement}', "");
    Error('\p{Is_Blk=/a/	 syriac_sup}');
    Error('\P{Is_Blk=/a/	 syriac_sup}');
    Expect(1, 2159, '\p{Is_Blk=syriacsup}', "");
    Expect(0, 2159, '\p{^Is_Blk=syriacsup}', "");
    Expect(0, 2159, '\P{Is_Blk=syriacsup}', "");
    Expect(1, 2159, '\P{^Is_Blk=syriacsup}', "");
    Expect(0, 2160, '\p{Is_Blk=syriacsup}', "");
    Expect(1, 2160, '\p{^Is_Blk=syriacsup}', "");
    Expect(1, 2160, '\P{Is_Blk=syriacsup}', "");
    Expect(0, 2160, '\P{^Is_Blk=syriacsup}', "");
    Expect(1, 2159, '\p{Is_Blk=	_Syriac_SUP}', "");
    Expect(0, 2159, '\p{^Is_Blk=	_Syriac_SUP}', "");
    Expect(0, 2159, '\P{Is_Blk=	_Syriac_SUP}', "");
    Expect(1, 2159, '\P{^Is_Blk=	_Syriac_SUP}', "");
    Expect(0, 2160, '\p{Is_Blk=	_Syriac_SUP}', "");
    Expect(1, 2160, '\p{^Is_Blk=	_Syriac_SUP}', "");
    Expect(1, 2160, '\P{Is_Blk=	_Syriac_SUP}', "");
    Expect(0, 2160, '\P{^Is_Blk=	_Syriac_SUP}', "");
    Error('\p{Block=/a/_Tagalog}');
    Error('\P{Block=/a/_Tagalog}');
    Expect(1, 5919, '\p{Block=:\ATagalog\z:}', "");;
    Expect(0, 5920, '\p{Block=:\ATagalog\z:}', "");;
    Expect(1, 5919, '\p{Block=tagalog}', "");
    Expect(0, 5919, '\p{^Block=tagalog}', "");
    Expect(0, 5919, '\P{Block=tagalog}', "");
    Expect(1, 5919, '\P{^Block=tagalog}', "");
    Expect(0, 5920, '\p{Block=tagalog}', "");
    Expect(1, 5920, '\p{^Block=tagalog}', "");
    Expect(1, 5920, '\P{Block=tagalog}', "");
    Expect(0, 5920, '\P{^Block=tagalog}', "");
    Expect(1, 5919, '\p{Block=:\Atagalog\z:}', "");;
    Expect(0, 5920, '\p{Block=:\Atagalog\z:}', "");;
    Expect(1, 5919, '\p{Block= 	tagalog}', "");
    Expect(0, 5919, '\p{^Block= 	tagalog}', "");
    Expect(0, 5919, '\P{Block= 	tagalog}', "");
    Expect(1, 5919, '\P{^Block= 	tagalog}', "");
    Expect(0, 5920, '\p{Block= 	tagalog}', "");
    Expect(1, 5920, '\p{^Block= 	tagalog}', "");
    Expect(1, 5920, '\P{Block= 	tagalog}', "");
    Expect(0, 5920, '\P{^Block= 	tagalog}', "");
    Error('\p{Blk=/a/-Tagalog}');
    Error('\P{Blk=/a/-Tagalog}');
    Expect(1, 5919, '\p{Blk=:\ATagalog\z:}', "");;
    Expect(0, 5920, '\p{Blk=:\ATagalog\z:}', "");;
    Expect(1, 5919, '\p{Blk=tagalog}', "");
    Expect(0, 5919, '\p{^Blk=tagalog}', "");
    Expect(0, 5919, '\P{Blk=tagalog}', "");
    Expect(1, 5919, '\P{^Blk=tagalog}', "");
    Expect(0, 5920, '\p{Blk=tagalog}', "");
    Expect(1, 5920, '\p{^Blk=tagalog}', "");
    Expect(1, 5920, '\P{Blk=tagalog}', "");
    Expect(0, 5920, '\P{^Blk=tagalog}', "");
    Expect(1, 5919, '\p{Blk=:\Atagalog\z:}', "");;
    Expect(0, 5920, '\p{Blk=:\Atagalog\z:}', "");;
    Expect(1, 5919, '\p{Blk= tagalog}', "");
    Expect(0, 5919, '\p{^Blk= tagalog}', "");
    Expect(0, 5919, '\P{Blk= tagalog}', "");
    Expect(1, 5919, '\P{^Blk= tagalog}', "");
    Expect(0, 5920, '\p{Blk= tagalog}', "");
    Expect(1, 5920, '\p{^Blk= tagalog}', "");
    Expect(1, 5920, '\P{Blk= tagalog}', "");
    Expect(0, 5920, '\P{^Blk= tagalog}', "");
    Error('\p{Is_Block=/a/tagalog}');
    Error('\P{Is_Block=/a/tagalog}');
    Expect(1, 5919, '\p{Is_Block=tagalog}', "");
    Expect(0, 5919, '\p{^Is_Block=tagalog}', "");
    Expect(0, 5919, '\P{Is_Block=tagalog}', "");
    Expect(1, 5919, '\P{^Is_Block=tagalog}', "");
    Expect(0, 5920, '\p{Is_Block=tagalog}', "");
    Expect(1, 5920, '\p{^Is_Block=tagalog}', "");
    Expect(1, 5920, '\P{Is_Block=tagalog}', "");
    Expect(0, 5920, '\P{^Is_Block=tagalog}', "");
    Expect(1, 5919, '\p{Is_Block=		TAGALOG}', "");
    Expect(0, 5919, '\p{^Is_Block=		TAGALOG}', "");
    Expect(0, 5919, '\P{Is_Block=		TAGALOG}', "");
    Expect(1, 5919, '\P{^Is_Block=		TAGALOG}', "");
    Expect(0, 5920, '\p{Is_Block=		TAGALOG}', "");
    Expect(1, 5920, '\p{^Is_Block=		TAGALOG}', "");
    Expect(1, 5920, '\P{Is_Block=		TAGALOG}', "");
    Expect(0, 5920, '\P{^Is_Block=		TAGALOG}', "");
    Error('\p{Is_Blk=:=TAGALOG}');
    Error('\P{Is_Blk=:=TAGALOG}');
    Expect(1, 5919, '\p{Is_Blk:tagalog}', "");
    Expect(0, 5919, '\p{^Is_Blk:tagalog}', "");
    Expect(0, 5919, '\P{Is_Blk:tagalog}', "");
    Expect(1, 5919, '\P{^Is_Blk:tagalog}', "");
    Expect(0, 5920, '\p{Is_Blk:tagalog}', "");
    Expect(1, 5920, '\p{^Is_Blk:tagalog}', "");
    Expect(1, 5920, '\P{Is_Blk:tagalog}', "");
    Expect(0, 5920, '\P{^Is_Blk:tagalog}', "");
    Expect(1, 5919, '\p{Is_Blk=--tagalog}', "");
    Expect(0, 5919, '\p{^Is_Blk=--tagalog}', "");
    Expect(0, 5919, '\P{Is_Blk=--tagalog}', "");
    Expect(1, 5919, '\P{^Is_Blk=--tagalog}', "");
    Expect(0, 5920, '\p{Is_Blk=--tagalog}', "");
    Expect(1, 5920, '\p{^Is_Blk=--tagalog}', "");
    Expect(1, 5920, '\P{Is_Blk=--tagalog}', "");
    Expect(0, 5920, '\P{^Is_Blk=--tagalog}', "");
    Error('\p{Block=:=_	Tagbanwa}');
    Error('\P{Block=:=_	Tagbanwa}');
    Expect(1, 6015, '\p{Block=:\ATagbanwa\z:}', "");;
    Expect(0, 6016, '\p{Block=:\ATagbanwa\z:}', "");;
    Expect(1, 6015, '\p{Block=tagbanwa}', "");
    Expect(0, 6015, '\p{^Block=tagbanwa}', "");
    Expect(0, 6015, '\P{Block=tagbanwa}', "");
    Expect(1, 6015, '\P{^Block=tagbanwa}', "");
    Expect(0, 6016, '\p{Block=tagbanwa}', "");
    Expect(1, 6016, '\p{^Block=tagbanwa}', "");
    Expect(1, 6016, '\P{Block=tagbanwa}', "");
    Expect(0, 6016, '\P{^Block=tagbanwa}', "");
    Expect(1, 6015, '\p{Block=:\Atagbanwa\z:}', "");;
    Expect(0, 6016, '\p{Block=:\Atagbanwa\z:}', "");;
    Expect(1, 6015, '\p{Block=	 Tagbanwa}', "");
    Expect(0, 6015, '\p{^Block=	 Tagbanwa}', "");
    Expect(0, 6015, '\P{Block=	 Tagbanwa}', "");
    Expect(1, 6015, '\P{^Block=	 Tagbanwa}', "");
    Expect(0, 6016, '\p{Block=	 Tagbanwa}', "");
    Expect(1, 6016, '\p{^Block=	 Tagbanwa}', "");
    Expect(1, 6016, '\P{Block=	 Tagbanwa}', "");
    Expect(0, 6016, '\P{^Block=	 Tagbanwa}', "");
    Error('\p{Blk=:= -Tagbanwa}');
    Error('\P{Blk=:= -Tagbanwa}');
    Expect(1, 6015, '\p{Blk=:\ATagbanwa\z:}', "");;
    Expect(0, 6016, '\p{Blk=:\ATagbanwa\z:}', "");;
    Expect(1, 6015, '\p{Blk=tagbanwa}', "");
    Expect(0, 6015, '\p{^Blk=tagbanwa}', "");
    Expect(0, 6015, '\P{Blk=tagbanwa}', "");
    Expect(1, 6015, '\P{^Blk=tagbanwa}', "");
    Expect(0, 6016, '\p{Blk=tagbanwa}', "");
    Expect(1, 6016, '\p{^Blk=tagbanwa}', "");
    Expect(1, 6016, '\P{Blk=tagbanwa}', "");
    Expect(0, 6016, '\P{^Blk=tagbanwa}', "");
    Expect(1, 6015, '\p{Blk=:\Atagbanwa\z:}', "");;
    Expect(0, 6016, '\p{Blk=:\Atagbanwa\z:}', "");;
    Expect(1, 6015, '\p{Blk=--tagbanwa}', "");
    Expect(0, 6015, '\p{^Blk=--tagbanwa}', "");
    Expect(0, 6015, '\P{Blk=--tagbanwa}', "");
    Expect(1, 6015, '\P{^Blk=--tagbanwa}', "");
    Expect(0, 6016, '\p{Blk=--tagbanwa}', "");
    Expect(1, 6016, '\p{^Blk=--tagbanwa}', "");
    Expect(1, 6016, '\P{Blk=--tagbanwa}', "");
    Expect(0, 6016, '\P{^Blk=--tagbanwa}', "");
    Error('\p{Is_Block=-:=Tagbanwa}');
    Error('\P{Is_Block=-:=Tagbanwa}');
    Expect(1, 6015, '\p{Is_Block: tagbanwa}', "");
    Expect(0, 6015, '\p{^Is_Block: tagbanwa}', "");
    Expect(0, 6015, '\P{Is_Block: tagbanwa}', "");
    Expect(1, 6015, '\P{^Is_Block: tagbanwa}', "");
    Expect(0, 6016, '\p{Is_Block: tagbanwa}', "");
    Expect(1, 6016, '\p{^Is_Block: tagbanwa}', "");
    Expect(1, 6016, '\P{Is_Block: tagbanwa}', "");
    Expect(0, 6016, '\P{^Is_Block: tagbanwa}', "");
    Expect(1, 6015, '\p{Is_Block=__Tagbanwa}', "");
    Expect(0, 6015, '\p{^Is_Block=__Tagbanwa}', "");
    Expect(0, 6015, '\P{Is_Block=__Tagbanwa}', "");
    Expect(1, 6015, '\P{^Is_Block=__Tagbanwa}', "");
    Expect(0, 6016, '\p{Is_Block=__Tagbanwa}', "");
    Expect(1, 6016, '\p{^Is_Block=__Tagbanwa}', "");
    Expect(1, 6016, '\P{Is_Block=__Tagbanwa}', "");
    Expect(0, 6016, '\P{^Is_Block=__Tagbanwa}', "");
    Error('\p{Is_Blk=/a/	_TAGBANWA}');
    Error('\P{Is_Blk=/a/	_TAGBANWA}');
    Expect(1, 6015, '\p{Is_Blk:tagbanwa}', "");
    Expect(0, 6015, '\p{^Is_Blk:tagbanwa}', "");
    Expect(0, 6015, '\P{Is_Blk:tagbanwa}', "");
    Expect(1, 6015, '\P{^Is_Blk:tagbanwa}', "");
    Expect(0, 6016, '\p{Is_Blk:tagbanwa}', "");
    Expect(1, 6016, '\p{^Is_Blk:tagbanwa}', "");
    Expect(1, 6016, '\P{Is_Blk:tagbanwa}', "");
    Expect(0, 6016, '\P{^Is_Blk:tagbanwa}', "");
    Expect(1, 6015, '\p{Is_Blk=_TAGBANWA}', "");
    Expect(0, 6015, '\p{^Is_Blk=_TAGBANWA}', "");
    Expect(0, 6015, '\P{Is_Blk=_TAGBANWA}', "");
    Expect(1, 6015, '\P{^Is_Blk=_TAGBANWA}', "");
    Expect(0, 6016, '\p{Is_Blk=_TAGBANWA}', "");
    Expect(1, 6016, '\p{^Is_Blk=_TAGBANWA}', "");
    Expect(1, 6016, '\P{Is_Blk=_TAGBANWA}', "");
    Expect(0, 6016, '\P{^Is_Blk=_TAGBANWA}', "");
    Error('\p{Block=-TAGS:=}');
    Error('\P{Block=-TAGS:=}');
    Expect(1, 917631, '\p{Block=:\ATags\z:}', "");;
    Expect(0, 917632, '\p{Block=:\ATags\z:}', "");;
    Expect(1, 917631, '\p{Block=tags}', "");
    Expect(0, 917631, '\p{^Block=tags}', "");
    Expect(0, 917631, '\P{Block=tags}', "");
    Expect(1, 917631, '\P{^Block=tags}', "");
    Expect(0, 917632, '\p{Block=tags}', "");
    Expect(1, 917632, '\p{^Block=tags}', "");
    Expect(1, 917632, '\P{Block=tags}', "");
    Expect(0, 917632, '\P{^Block=tags}', "");
    Expect(1, 917631, '\p{Block=:\Atags\z:}', "");;
    Expect(0, 917632, '\p{Block=:\Atags\z:}', "");;
    Expect(1, 917631, '\p{Block=_	TAGS}', "");
    Expect(0, 917631, '\p{^Block=_	TAGS}', "");
    Expect(0, 917631, '\P{Block=_	TAGS}', "");
    Expect(1, 917631, '\P{^Block=_	TAGS}', "");
    Expect(0, 917632, '\p{Block=_	TAGS}', "");
    Expect(1, 917632, '\p{^Block=_	TAGS}', "");
    Expect(1, 917632, '\P{Block=_	TAGS}', "");
    Expect(0, 917632, '\P{^Block=_	TAGS}', "");
    Error('\p{Blk=	Tags:=}');
    Error('\P{Blk=	Tags:=}');
    Expect(1, 917631, '\p{Blk=:\ATags\z:}', "");;
    Expect(0, 917632, '\p{Blk=:\ATags\z:}', "");;
    Expect(1, 917631, '\p{Blk=tags}', "");
    Expect(0, 917631, '\p{^Blk=tags}', "");
    Expect(0, 917631, '\P{Blk=tags}', "");
    Expect(1, 917631, '\P{^Blk=tags}', "");
    Expect(0, 917632, '\p{Blk=tags}', "");
    Expect(1, 917632, '\p{^Blk=tags}', "");
    Expect(1, 917632, '\P{Blk=tags}', "");
    Expect(0, 917632, '\P{^Blk=tags}', "");
    Expect(1, 917631, '\p{Blk=:\Atags\z:}', "");;
    Expect(0, 917632, '\p{Blk=:\Atags\z:}', "");;
    Expect(1, 917631, '\p{Blk= TAGS}', "");
    Expect(0, 917631, '\p{^Blk= TAGS}', "");
    Expect(0, 917631, '\P{Blk= TAGS}', "");
    Expect(1, 917631, '\P{^Blk= TAGS}', "");
    Expect(0, 917632, '\p{Blk= TAGS}', "");
    Expect(1, 917632, '\p{^Blk= TAGS}', "");
    Expect(1, 917632, '\P{Blk= TAGS}', "");
    Expect(0, 917632, '\P{^Blk= TAGS}', "");
    Error('\p{Is_Block=__TAGS:=}');
    Error('\P{Is_Block=__TAGS:=}');
    Expect(1, 917631, '\p{Is_Block=tags}', "");
    Expect(0, 917631, '\p{^Is_Block=tags}', "");
    Expect(0, 917631, '\P{Is_Block=tags}', "");
    Expect(1, 917631, '\P{^Is_Block=tags}', "");
    Expect(0, 917632, '\p{Is_Block=tags}', "");
    Expect(1, 917632, '\p{^Is_Block=tags}', "");
    Expect(1, 917632, '\P{Is_Block=tags}', "");
    Expect(0, 917632, '\P{^Is_Block=tags}', "");
    Expect(1, 917631, '\p{Is_Block= tags}', "");
    Expect(0, 917631, '\p{^Is_Block= tags}', "");
    Expect(0, 917631, '\P{Is_Block= tags}', "");
    Expect(1, 917631, '\P{^Is_Block= tags}', "");
    Expect(0, 917632, '\p{Is_Block= tags}', "");
    Expect(1, 917632, '\p{^Is_Block= tags}', "");
    Expect(1, 917632, '\P{Is_Block= tags}', "");
    Expect(0, 917632, '\P{^Is_Block= tags}', "");
    Error('\p{Is_Blk: -:=Tags}');
    Error('\P{Is_Blk: -:=Tags}');
    Expect(1, 917631, '\p{Is_Blk=tags}', "");
    Expect(0, 917631, '\p{^Is_Blk=tags}', "");
    Expect(0, 917631, '\P{Is_Blk=tags}', "");
    Expect(1, 917631, '\P{^Is_Blk=tags}', "");
    Expect(0, 917632, '\p{Is_Blk=tags}', "");
    Expect(1, 917632, '\p{^Is_Blk=tags}', "");
    Expect(1, 917632, '\P{Is_Blk=tags}', "");
    Expect(0, 917632, '\P{^Is_Blk=tags}', "");
    Expect(1, 917631, '\p{Is_Blk:	- tags}', "");
    Expect(0, 917631, '\p{^Is_Blk:	- tags}', "");
    Expect(0, 917631, '\P{Is_Blk:	- tags}', "");
    Expect(1, 917631, '\P{^Is_Blk:	- tags}', "");
    Expect(0, 917632, '\p{Is_Blk:	- tags}', "");
    Expect(1, 917632, '\p{^Is_Blk:	- tags}', "");
    Expect(1, 917632, '\P{Is_Blk:	- tags}', "");
    Expect(0, 917632, '\P{^Is_Blk:	- tags}', "");
    Error('\p{Block: := 	tai_Le}');
    Error('\P{Block: := 	tai_Le}');
    Expect(1, 6527, '\p{Block=:\ATai_Le\z:}', "");;
    Expect(0, 6528, '\p{Block=:\ATai_Le\z:}', "");;
    Expect(1, 6527, '\p{Block=taile}', "");
    Expect(0, 6527, '\p{^Block=taile}', "");
    Expect(0, 6527, '\P{Block=taile}', "");
    Expect(1, 6527, '\P{^Block=taile}', "");
    Expect(0, 6528, '\p{Block=taile}', "");
    Expect(1, 6528, '\p{^Block=taile}', "");
    Expect(1, 6528, '\P{Block=taile}', "");
    Expect(0, 6528, '\P{^Block=taile}', "");
    Expect(1, 6527, '\p{Block=:\Ataile\z:}', "");;
    Expect(0, 6528, '\p{Block=:\Ataile\z:}', "");;
    Expect(1, 6527, '\p{Block=	Tai_le}', "");
    Expect(0, 6527, '\p{^Block=	Tai_le}', "");
    Expect(0, 6527, '\P{Block=	Tai_le}', "");
    Expect(1, 6527, '\P{^Block=	Tai_le}', "");
    Expect(0, 6528, '\p{Block=	Tai_le}', "");
    Expect(1, 6528, '\p{^Block=	Tai_le}', "");
    Expect(1, 6528, '\P{Block=	Tai_le}', "");
    Expect(0, 6528, '\P{^Block=	Tai_le}', "");
    Error('\p{Blk=:=	_tai_LE}');
    Error('\P{Blk=:=	_tai_LE}');
    Expect(1, 6527, '\p{Blk=:\ATai_Le\z:}', "");;
    Expect(0, 6528, '\p{Blk=:\ATai_Le\z:}', "");;
    Expect(1, 6527, '\p{Blk=taile}', "");
    Expect(0, 6527, '\p{^Blk=taile}', "");
    Expect(0, 6527, '\P{Blk=taile}', "");
    Expect(1, 6527, '\P{^Blk=taile}', "");
    Expect(0, 6528, '\p{Blk=taile}', "");
    Expect(1, 6528, '\p{^Blk=taile}', "");
    Expect(1, 6528, '\P{Blk=taile}', "");
    Expect(0, 6528, '\P{^Blk=taile}', "");
    Expect(1, 6527, '\p{Blk=:\Ataile\z:}', "");;
    Expect(0, 6528, '\p{Blk=:\Ataile\z:}', "");;
    Expect(1, 6527, '\p{Blk=-tai_le}', "");
    Expect(0, 6527, '\p{^Blk=-tai_le}', "");
    Expect(0, 6527, '\P{Blk=-tai_le}', "");
    Expect(1, 6527, '\P{^Blk=-tai_le}', "");
    Expect(0, 6528, '\p{Blk=-tai_le}', "");
    Expect(1, 6528, '\p{^Blk=-tai_le}', "");
    Expect(1, 6528, '\P{Blk=-tai_le}', "");
    Expect(0, 6528, '\P{^Blk=-tai_le}', "");
    Error('\p{Is_Block=_:=Tai_Le}');
    Error('\P{Is_Block=_:=Tai_Le}');
    Expect(1, 6527, '\p{Is_Block=taile}', "");
    Expect(0, 6527, '\p{^Is_Block=taile}', "");
    Expect(0, 6527, '\P{Is_Block=taile}', "");
    Expect(1, 6527, '\P{^Is_Block=taile}', "");
    Expect(0, 6528, '\p{Is_Block=taile}', "");
    Expect(1, 6528, '\p{^Is_Block=taile}', "");
    Expect(1, 6528, '\P{Is_Block=taile}', "");
    Expect(0, 6528, '\P{^Is_Block=taile}', "");
    Expect(1, 6527, '\p{Is_Block=	Tai_le}', "");
    Expect(0, 6527, '\p{^Is_Block=	Tai_le}', "");
    Expect(0, 6527, '\P{Is_Block=	Tai_le}', "");
    Expect(1, 6527, '\P{^Is_Block=	Tai_le}', "");
    Expect(0, 6528, '\p{Is_Block=	Tai_le}', "");
    Expect(1, 6528, '\p{^Is_Block=	Tai_le}', "");
    Expect(1, 6528, '\P{Is_Block=	Tai_le}', "");
    Expect(0, 6528, '\P{^Is_Block=	Tai_le}', "");
    Error('\p{Is_Blk=:=	 Tai_LE}');
    Error('\P{Is_Blk=:=	 Tai_LE}');
    Expect(1, 6527, '\p{Is_Blk=taile}', "");
    Expect(0, 6527, '\p{^Is_Blk=taile}', "");
    Expect(0, 6527, '\P{Is_Blk=taile}', "");
    Expect(1, 6527, '\P{^Is_Blk=taile}', "");
    Expect(0, 6528, '\p{Is_Blk=taile}', "");
    Expect(1, 6528, '\p{^Is_Blk=taile}', "");
    Expect(1, 6528, '\P{Is_Blk=taile}', "");
    Expect(0, 6528, '\P{^Is_Blk=taile}', "");
    Expect(1, 6527, '\p{Is_Blk=Tai_Le}', "");
    Expect(0, 6527, '\p{^Is_Blk=Tai_Le}', "");
    Expect(0, 6527, '\P{Is_Blk=Tai_Le}', "");
    Expect(1, 6527, '\P{^Is_Blk=Tai_Le}', "");
    Expect(0, 6528, '\p{Is_Blk=Tai_Le}', "");
    Expect(1, 6528, '\p{^Is_Blk=Tai_Le}', "");
    Expect(1, 6528, '\P{Is_Blk=Tai_Le}', "");
    Expect(0, 6528, '\P{^Is_Blk=Tai_Le}', "");
    Error('\p{Block=:=_ tai_tham}');
    Error('\P{Block=:=_ tai_tham}');
    Expect(1, 6831, '\p{Block=:\ATai_Tham\z:}', "");;
    Expect(0, 6832, '\p{Block=:\ATai_Tham\z:}', "");;
    Expect(1, 6831, '\p{Block: taitham}', "");
    Expect(0, 6831, '\p{^Block: taitham}', "");
    Expect(0, 6831, '\P{Block: taitham}', "");
    Expect(1, 6831, '\P{^Block: taitham}', "");
    Expect(0, 6832, '\p{Block: taitham}', "");
    Expect(1, 6832, '\p{^Block: taitham}', "");
    Expect(1, 6832, '\P{Block: taitham}', "");
    Expect(0, 6832, '\P{^Block: taitham}', "");
    Expect(1, 6831, '\p{Block=:\Ataitham\z:}', "");;
    Expect(0, 6832, '\p{Block=:\Ataitham\z:}', "");;
    Expect(1, 6831, '\p{Block=-Tai_THAM}', "");
    Expect(0, 6831, '\p{^Block=-Tai_THAM}', "");
    Expect(0, 6831, '\P{Block=-Tai_THAM}', "");
    Expect(1, 6831, '\P{^Block=-Tai_THAM}', "");
    Expect(0, 6832, '\p{Block=-Tai_THAM}', "");
    Expect(1, 6832, '\p{^Block=-Tai_THAM}', "");
    Expect(1, 6832, '\P{Block=-Tai_THAM}', "");
    Expect(0, 6832, '\P{^Block=-Tai_THAM}', "");
    Error('\p{Blk=	 Tai_THAM/a/}');
    Error('\P{Blk=	 Tai_THAM/a/}');
    Expect(1, 6831, '\p{Blk=:\ATai_Tham\z:}', "");;
    Expect(0, 6832, '\p{Blk=:\ATai_Tham\z:}', "");;
    Expect(1, 6831, '\p{Blk=taitham}', "");
    Expect(0, 6831, '\p{^Blk=taitham}', "");
    Expect(0, 6831, '\P{Blk=taitham}', "");
    Expect(1, 6831, '\P{^Blk=taitham}', "");
    Expect(0, 6832, '\p{Blk=taitham}', "");
    Expect(1, 6832, '\p{^Blk=taitham}', "");
    Expect(1, 6832, '\P{Blk=taitham}', "");
    Expect(0, 6832, '\P{^Blk=taitham}', "");
    Expect(1, 6831, '\p{Blk=:\Ataitham\z:}', "");;
    Expect(0, 6832, '\p{Blk=:\Ataitham\z:}', "");;
    Expect(1, 6831, '\p{Blk= -TAI_Tham}', "");
    Expect(0, 6831, '\p{^Blk= -TAI_Tham}', "");
    Expect(0, 6831, '\P{Blk= -TAI_Tham}', "");
    Expect(1, 6831, '\P{^Blk= -TAI_Tham}', "");
    Expect(0, 6832, '\p{Blk= -TAI_Tham}', "");
    Expect(1, 6832, '\p{^Blk= -TAI_Tham}', "");
    Expect(1, 6832, '\P{Blk= -TAI_Tham}', "");
    Expect(0, 6832, '\P{^Blk= -TAI_Tham}', "");
    Error('\p{Is_Block=:=-TAI_THAM}');
    Error('\P{Is_Block=:=-TAI_THAM}');
    Expect(1, 6831, '\p{Is_Block:   taitham}', "");
    Expect(0, 6831, '\p{^Is_Block:   taitham}', "");
    Expect(0, 6831, '\P{Is_Block:   taitham}', "");
    Expect(1, 6831, '\P{^Is_Block:   taitham}', "");
    Expect(0, 6832, '\p{Is_Block:   taitham}', "");
    Expect(1, 6832, '\p{^Is_Block:   taitham}', "");
    Expect(1, 6832, '\P{Is_Block:   taitham}', "");
    Expect(0, 6832, '\P{^Is_Block:   taitham}', "");
    Expect(1, 6831, '\p{Is_Block= tai_tham}', "");
    Expect(0, 6831, '\p{^Is_Block= tai_tham}', "");
    Expect(0, 6831, '\P{Is_Block= tai_tham}', "");
    Expect(1, 6831, '\P{^Is_Block= tai_tham}', "");
    Expect(0, 6832, '\p{Is_Block= tai_tham}', "");
    Expect(1, 6832, '\p{^Is_Block= tai_tham}', "");
    Expect(1, 6832, '\P{Is_Block= tai_tham}', "");
    Expect(0, 6832, '\P{^Is_Block= tai_tham}', "");
    Error('\p{Is_Blk=/a/_-Tai_Tham}');
    Error('\P{Is_Blk=/a/_-Tai_Tham}');
    Expect(1, 6831, '\p{Is_Blk:	taitham}', "");
    Expect(0, 6831, '\p{^Is_Blk:	taitham}', "");
    Expect(0, 6831, '\P{Is_Blk:	taitham}', "");
    Expect(1, 6831, '\P{^Is_Blk:	taitham}', "");
    Expect(0, 6832, '\p{Is_Blk:	taitham}', "");
    Expect(1, 6832, '\p{^Is_Blk:	taitham}', "");
    Expect(1, 6832, '\P{Is_Blk:	taitham}', "");
    Expect(0, 6832, '\P{^Is_Blk:	taitham}', "");
    Expect(1, 6831, '\p{Is_Blk=- Tai_Tham}', "");
    Expect(0, 6831, '\p{^Is_Blk=- Tai_Tham}', "");
    Expect(0, 6831, '\P{Is_Blk=- Tai_Tham}', "");
    Expect(1, 6831, '\P{^Is_Blk=- Tai_Tham}', "");
    Expect(0, 6832, '\p{Is_Blk=- Tai_Tham}', "");
    Expect(1, 6832, '\p{^Is_Blk=- Tai_Tham}', "");
    Expect(1, 6832, '\P{Is_Blk=- Tai_Tham}', "");
    Expect(0, 6832, '\P{^Is_Blk=- Tai_Tham}', "");
    Error('\p{Block=/a/Tai_viet}');
    Error('\P{Block=/a/Tai_viet}');
    Expect(1, 43743, '\p{Block=:\ATai_Viet\z:}', "");;
    Expect(0, 43744, '\p{Block=:\ATai_Viet\z:}', "");;
    Expect(1, 43743, '\p{Block=taiviet}', "");
    Expect(0, 43743, '\p{^Block=taiviet}', "");
    Expect(0, 43743, '\P{Block=taiviet}', "");
    Expect(1, 43743, '\P{^Block=taiviet}', "");
    Expect(0, 43744, '\p{Block=taiviet}', "");
    Expect(1, 43744, '\p{^Block=taiviet}', "");
    Expect(1, 43744, '\P{Block=taiviet}', "");
    Expect(0, 43744, '\P{^Block=taiviet}', "");
    Expect(1, 43743, '\p{Block=:\Ataiviet\z:}', "");;
    Expect(0, 43744, '\p{Block=:\Ataiviet\z:}', "");;
    Expect(1, 43743, '\p{Block=-	TAI_viet}', "");
    Expect(0, 43743, '\p{^Block=-	TAI_viet}', "");
    Expect(0, 43743, '\P{Block=-	TAI_viet}', "");
    Expect(1, 43743, '\P{^Block=-	TAI_viet}', "");
    Expect(0, 43744, '\p{Block=-	TAI_viet}', "");
    Expect(1, 43744, '\p{^Block=-	TAI_viet}', "");
    Expect(1, 43744, '\P{Block=-	TAI_viet}', "");
    Expect(0, 43744, '\P{^Block=-	TAI_viet}', "");
    Error('\p{Blk=		Tai_Viet:=}');
    Error('\P{Blk=		Tai_Viet:=}');
    Expect(1, 43743, '\p{Blk=:\ATai_Viet\z:}', "");;
    Expect(0, 43744, '\p{Blk=:\ATai_Viet\z:}', "");;
    Expect(1, 43743, '\p{Blk=taiviet}', "");
    Expect(0, 43743, '\p{^Blk=taiviet}', "");
    Expect(0, 43743, '\P{Blk=taiviet}', "");
    Expect(1, 43743, '\P{^Blk=taiviet}', "");
    Expect(0, 43744, '\p{Blk=taiviet}', "");
    Expect(1, 43744, '\p{^Blk=taiviet}', "");
    Expect(1, 43744, '\P{Blk=taiviet}', "");
    Expect(0, 43744, '\P{^Blk=taiviet}', "");
    Expect(1, 43743, '\p{Blk=:\Ataiviet\z:}', "");;
    Expect(0, 43744, '\p{Blk=:\Ataiviet\z:}', "");;
    Expect(1, 43743, '\p{Blk=	-tai_VIET}', "");
    Expect(0, 43743, '\p{^Blk=	-tai_VIET}', "");
    Expect(0, 43743, '\P{Blk=	-tai_VIET}', "");
    Expect(1, 43743, '\P{^Blk=	-tai_VIET}', "");
    Expect(0, 43744, '\p{Blk=	-tai_VIET}', "");
    Expect(1, 43744, '\p{^Blk=	-tai_VIET}', "");
    Expect(1, 43744, '\P{Blk=	-tai_VIET}', "");
    Expect(0, 43744, '\P{^Blk=	-tai_VIET}', "");
    Error('\p{Is_Block=	/a/tai_Viet}');
    Error('\P{Is_Block=	/a/tai_Viet}');
    Expect(1, 43743, '\p{Is_Block=taiviet}', "");
    Expect(0, 43743, '\p{^Is_Block=taiviet}', "");
    Expect(0, 43743, '\P{Is_Block=taiviet}', "");
    Expect(1, 43743, '\P{^Is_Block=taiviet}', "");
    Expect(0, 43744, '\p{Is_Block=taiviet}', "");
    Expect(1, 43744, '\p{^Is_Block=taiviet}', "");
    Expect(1, 43744, '\P{Is_Block=taiviet}', "");
    Expect(0, 43744, '\P{^Is_Block=taiviet}', "");
    Expect(1, 43743, '\p{Is_Block=_TAI_Viet}', "");
    Expect(0, 43743, '\p{^Is_Block=_TAI_Viet}', "");
    Expect(0, 43743, '\P{Is_Block=_TAI_Viet}', "");
    Expect(1, 43743, '\P{^Is_Block=_TAI_Viet}', "");
    Expect(0, 43744, '\p{Is_Block=_TAI_Viet}', "");
    Expect(1, 43744, '\p{^Is_Block=_TAI_Viet}', "");
    Expect(1, 43744, '\P{Is_Block=_TAI_Viet}', "");
    Expect(0, 43744, '\P{^Is_Block=_TAI_Viet}', "");
    Error('\p{Is_Blk:-_TAI_viet:=}');
    Error('\P{Is_Blk:-_TAI_viet:=}');
    Expect(1, 43743, '\p{Is_Blk=taiviet}', "");
    Expect(0, 43743, '\p{^Is_Blk=taiviet}', "");
    Expect(0, 43743, '\P{Is_Blk=taiviet}', "");
    Expect(1, 43743, '\P{^Is_Blk=taiviet}', "");
    Expect(0, 43744, '\p{Is_Blk=taiviet}', "");
    Expect(1, 43744, '\p{^Is_Blk=taiviet}', "");
    Expect(1, 43744, '\P{Is_Blk=taiviet}', "");
    Expect(0, 43744, '\P{^Is_Blk=taiviet}', "");
    Expect(1, 43743, '\p{Is_Blk=-	tai_Viet}', "");
    Expect(0, 43743, '\p{^Is_Blk=-	tai_Viet}', "");
    Expect(0, 43743, '\P{Is_Blk=-	tai_Viet}', "");
    Expect(1, 43743, '\P{^Is_Blk=-	tai_Viet}', "");
    Expect(0, 43744, '\p{Is_Blk=-	tai_Viet}', "");
    Expect(1, 43744, '\p{^Is_Blk=-	tai_Viet}', "");
    Expect(1, 43744, '\P{Is_Blk=-	tai_Viet}', "");
    Expect(0, 43744, '\P{^Is_Blk=-	tai_Viet}', "");
    Error('\p{Block=- TAI_Xuan_Jing_SYMBOLS:=}');
    Error('\P{Block=- TAI_Xuan_Jing_SYMBOLS:=}');
    Expect(1, 119647, '\p{Block=:\ATai_Xuan_Jing_Symbols\z:}', "");;
    Expect(0, 119648, '\p{Block=:\ATai_Xuan_Jing_Symbols\z:}', "");;
    Expect(1, 119647, '\p{Block=taixuanjingsymbols}', "");
    Expect(0, 119647, '\p{^Block=taixuanjingsymbols}', "");
    Expect(0, 119647, '\P{Block=taixuanjingsymbols}', "");
    Expect(1, 119647, '\P{^Block=taixuanjingsymbols}', "");
    Expect(0, 119648, '\p{Block=taixuanjingsymbols}', "");
    Expect(1, 119648, '\p{^Block=taixuanjingsymbols}', "");
    Expect(1, 119648, '\P{Block=taixuanjingsymbols}', "");
    Expect(0, 119648, '\P{^Block=taixuanjingsymbols}', "");
    Expect(1, 119647, '\p{Block=:\Ataixuanjingsymbols\z:}', "");;
    Expect(0, 119648, '\p{Block=:\Ataixuanjingsymbols\z:}', "");;
    Expect(1, 119647, '\p{Block=	 Tai_Xuan_jing_Symbols}', "");
    Expect(0, 119647, '\p{^Block=	 Tai_Xuan_jing_Symbols}', "");
    Expect(0, 119647, '\P{Block=	 Tai_Xuan_jing_Symbols}', "");
    Expect(1, 119647, '\P{^Block=	 Tai_Xuan_jing_Symbols}', "");
    Expect(0, 119648, '\p{Block=	 Tai_Xuan_jing_Symbols}', "");
    Expect(1, 119648, '\p{^Block=	 Tai_Xuan_jing_Symbols}', "");
    Expect(1, 119648, '\P{Block=	 Tai_Xuan_jing_Symbols}', "");
    Expect(0, 119648, '\P{^Block=	 Tai_Xuan_jing_Symbols}', "");
    Error('\p{Blk= :=TAI_Xuan_Jing}');
    Error('\P{Blk= :=TAI_Xuan_Jing}');
    Expect(1, 119647, '\p{Blk=:\ATai_Xuan_Jing\z:}', "");;
    Expect(0, 119648, '\p{Blk=:\ATai_Xuan_Jing\z:}', "");;
    Expect(1, 119647, '\p{Blk:	taixuanjing}', "");
    Expect(0, 119647, '\p{^Blk:	taixuanjing}', "");
    Expect(0, 119647, '\P{Blk:	taixuanjing}', "");
    Expect(1, 119647, '\P{^Blk:	taixuanjing}', "");
    Expect(0, 119648, '\p{Blk:	taixuanjing}', "");
    Expect(1, 119648, '\p{^Blk:	taixuanjing}', "");
    Expect(1, 119648, '\P{Blk:	taixuanjing}', "");
    Expect(0, 119648, '\P{^Blk:	taixuanjing}', "");
    Expect(1, 119647, '\p{Blk=:\Ataixuanjing\z:}', "");;
    Expect(0, 119648, '\p{Blk=:\Ataixuanjing\z:}', "");;
    Expect(1, 119647, '\p{Blk= -TAI_xuan_JING}', "");
    Expect(0, 119647, '\p{^Blk= -TAI_xuan_JING}', "");
    Expect(0, 119647, '\P{Blk= -TAI_xuan_JING}', "");
    Expect(1, 119647, '\P{^Blk= -TAI_xuan_JING}', "");
    Expect(0, 119648, '\p{Blk= -TAI_xuan_JING}', "");
    Expect(1, 119648, '\p{^Blk= -TAI_xuan_JING}', "");
    Expect(1, 119648, '\P{Blk= -TAI_xuan_JING}', "");
    Expect(0, 119648, '\P{^Blk= -TAI_xuan_JING}', "");
    Error('\p{Is_Block=:=	_Tai_XUAN_Jing_symbols}');
    Error('\P{Is_Block=:=	_Tai_XUAN_Jing_symbols}');
    Expect(1, 119647, '\p{Is_Block=taixuanjingsymbols}', "");
    Expect(0, 119647, '\p{^Is_Block=taixuanjingsymbols}', "");
    Expect(0, 119647, '\P{Is_Block=taixuanjingsymbols}', "");
    Expect(1, 119647, '\P{^Is_Block=taixuanjingsymbols}', "");
    Expect(0, 119648, '\p{Is_Block=taixuanjingsymbols}', "");
    Expect(1, 119648, '\p{^Is_Block=taixuanjingsymbols}', "");
    Expect(1, 119648, '\P{Is_Block=taixuanjingsymbols}', "");
    Expect(0, 119648, '\P{^Is_Block=taixuanjingsymbols}', "");
    Expect(1, 119647, '\p{Is_Block=	 TAI_Xuan_JING_symbols}', "");
    Expect(0, 119647, '\p{^Is_Block=	 TAI_Xuan_JING_symbols}', "");
    Expect(0, 119647, '\P{Is_Block=	 TAI_Xuan_JING_symbols}', "");
    Expect(1, 119647, '\P{^Is_Block=	 TAI_Xuan_JING_symbols}', "");
    Expect(0, 119648, '\p{Is_Block=	 TAI_Xuan_JING_symbols}', "");
    Expect(1, 119648, '\p{^Is_Block=	 TAI_Xuan_JING_symbols}', "");
    Expect(1, 119648, '\P{Is_Block=	 TAI_Xuan_JING_symbols}', "");
    Expect(0, 119648, '\P{^Is_Block=	 TAI_Xuan_JING_symbols}', "");
    Error('\p{Is_Blk=/a/__TAI_XUAN_Jing}');
    Error('\P{Is_Blk=/a/__TAI_XUAN_Jing}');
    Expect(1, 119647, '\p{Is_Blk=taixuanjing}', "");
    Expect(0, 119647, '\p{^Is_Blk=taixuanjing}', "");
    Expect(0, 119647, '\P{Is_Blk=taixuanjing}', "");
    Expect(1, 119647, '\P{^Is_Blk=taixuanjing}', "");
    Expect(0, 119648, '\p{Is_Blk=taixuanjing}', "");
    Expect(1, 119648, '\p{^Is_Blk=taixuanjing}', "");
    Expect(1, 119648, '\P{Is_Blk=taixuanjing}', "");
    Expect(0, 119648, '\P{^Is_Blk=taixuanjing}', "");
    Expect(1, 119647, '\p{Is_Blk=- TAI_xuan_JING}', "");
    Expect(0, 119647, '\p{^Is_Blk=- TAI_xuan_JING}', "");
    Expect(0, 119647, '\P{Is_Blk=- TAI_xuan_JING}', "");
    Expect(1, 119647, '\P{^Is_Blk=- TAI_xuan_JING}', "");
    Expect(0, 119648, '\p{Is_Blk=- TAI_xuan_JING}', "");
    Expect(1, 119648, '\p{^Is_Blk=- TAI_xuan_JING}', "");
    Expect(1, 119648, '\P{Is_Blk=- TAI_xuan_JING}', "");
    Expect(0, 119648, '\P{^Is_Blk=- TAI_xuan_JING}', "");
    Error('\p{Block= /a/TAKRI}');
    Error('\P{Block= /a/TAKRI}');
    Expect(1, 71375, '\p{Block=:\ATakri\z:}', "");;
    Expect(0, 71376, '\p{Block=:\ATakri\z:}', "");;
    Expect(1, 71375, '\p{Block=takri}', "");
    Expect(0, 71375, '\p{^Block=takri}', "");
    Expect(0, 71375, '\P{Block=takri}', "");
    Expect(1, 71375, '\P{^Block=takri}', "");
    Expect(0, 71376, '\p{Block=takri}', "");
    Expect(1, 71376, '\p{^Block=takri}', "");
    Expect(1, 71376, '\P{Block=takri}', "");
    Expect(0, 71376, '\P{^Block=takri}', "");
    Expect(1, 71375, '\p{Block=:\Atakri\z:}', "");;
    Expect(0, 71376, '\p{Block=:\Atakri\z:}', "");;
    Expect(1, 71375, '\p{Block=	Takri}', "");
    Expect(0, 71375, '\p{^Block=	Takri}', "");
    Expect(0, 71375, '\P{Block=	Takri}', "");
    Expect(1, 71375, '\P{^Block=	Takri}', "");
    Expect(0, 71376, '\p{Block=	Takri}', "");
    Expect(1, 71376, '\p{^Block=	Takri}', "");
    Expect(1, 71376, '\P{Block=	Takri}', "");
    Expect(0, 71376, '\P{^Block=	Takri}', "");
    Error('\p{Blk=:=TAKRI}');
    Error('\P{Blk=:=TAKRI}');
    Expect(1, 71375, '\p{Blk=:\ATakri\z:}', "");;
    Expect(0, 71376, '\p{Blk=:\ATakri\z:}', "");;
    Expect(1, 71375, '\p{Blk:takri}', "");
    Expect(0, 71375, '\p{^Blk:takri}', "");
    Expect(0, 71375, '\P{Blk:takri}', "");
    Expect(1, 71375, '\P{^Blk:takri}', "");
    Expect(0, 71376, '\p{Blk:takri}', "");
    Expect(1, 71376, '\p{^Blk:takri}', "");
    Expect(1, 71376, '\P{Blk:takri}', "");
    Expect(0, 71376, '\P{^Blk:takri}', "");
    Expect(1, 71375, '\p{Blk=:\Atakri\z:}', "");;
    Expect(0, 71376, '\p{Blk=:\Atakri\z:}', "");;
    Expect(1, 71375, '\p{Blk=-	Takri}', "");
    Expect(0, 71375, '\p{^Blk=-	Takri}', "");
    Expect(0, 71375, '\P{Blk=-	Takri}', "");
    Expect(1, 71375, '\P{^Blk=-	Takri}', "");
    Expect(0, 71376, '\p{Blk=-	Takri}', "");
    Expect(1, 71376, '\p{^Blk=-	Takri}', "");
    Expect(1, 71376, '\P{Blk=-	Takri}', "");
    Expect(0, 71376, '\P{^Blk=-	Takri}', "");
    Error('\p{Is_Block= /a/Takri}');
    Error('\P{Is_Block= /a/Takri}');
    Expect(1, 71375, '\p{Is_Block=takri}', "");
    Expect(0, 71375, '\p{^Is_Block=takri}', "");
    Expect(0, 71375, '\P{Is_Block=takri}', "");
    Expect(1, 71375, '\P{^Is_Block=takri}', "");
    Expect(0, 71376, '\p{Is_Block=takri}', "");
    Expect(1, 71376, '\p{^Is_Block=takri}', "");
    Expect(1, 71376, '\P{Is_Block=takri}', "");
    Expect(0, 71376, '\P{^Is_Block=takri}', "");
    Expect(1, 71375, '\p{Is_Block= -TAKRI}', "");
    Expect(0, 71375, '\p{^Is_Block= -TAKRI}', "");
    Expect(0, 71375, '\P{Is_Block= -TAKRI}', "");
    Expect(1, 71375, '\P{^Is_Block= -TAKRI}', "");
    Expect(0, 71376, '\p{Is_Block= -TAKRI}', "");
    Expect(1, 71376, '\p{^Is_Block= -TAKRI}', "");
    Expect(1, 71376, '\P{Is_Block= -TAKRI}', "");
    Expect(0, 71376, '\P{^Is_Block= -TAKRI}', "");
    Error('\p{Is_Blk=/a/Takri}');
    Error('\P{Is_Blk=/a/Takri}');
    Expect(1, 71375, '\p{Is_Blk=takri}', "");
    Expect(0, 71375, '\p{^Is_Blk=takri}', "");
    Expect(0, 71375, '\P{Is_Blk=takri}', "");
    Expect(1, 71375, '\P{^Is_Blk=takri}', "");
    Expect(0, 71376, '\p{Is_Blk=takri}', "");
    Expect(1, 71376, '\p{^Is_Blk=takri}', "");
    Expect(1, 71376, '\P{Is_Blk=takri}', "");
    Expect(0, 71376, '\P{^Is_Blk=takri}', "");
    Expect(1, 71375, '\p{Is_Blk=	-Takri}', "");
    Expect(0, 71375, '\p{^Is_Blk=	-Takri}', "");
    Expect(0, 71375, '\P{Is_Blk=	-Takri}', "");
    Expect(1, 71375, '\P{^Is_Blk=	-Takri}', "");
    Expect(0, 71376, '\p{Is_Blk=	-Takri}', "");
    Expect(1, 71376, '\p{^Is_Blk=	-Takri}', "");
    Expect(1, 71376, '\P{Is_Blk=	-Takri}', "");
    Expect(0, 71376, '\P{^Is_Blk=	-Takri}', "");
    Error('\p{Block=_ tamil:=}');
    Error('\P{Block=_ tamil:=}');
    Expect(1, 3071, '\p{Block=:\ATamil\z:}', "");;
    Expect(0, 3072, '\p{Block=:\ATamil\z:}', "");;
    Expect(1, 3071, '\p{Block=tamil}', "");
    Expect(0, 3071, '\p{^Block=tamil}', "");
    Expect(0, 3071, '\P{Block=tamil}', "");
    Expect(1, 3071, '\P{^Block=tamil}', "");
    Expect(0, 3072, '\p{Block=tamil}', "");
    Expect(1, 3072, '\p{^Block=tamil}', "");
    Expect(1, 3072, '\P{Block=tamil}', "");
    Expect(0, 3072, '\P{^Block=tamil}', "");
    Expect(1, 3071, '\p{Block=:\Atamil\z:}', "");;
    Expect(0, 3072, '\p{Block=:\Atamil\z:}', "");;
    Expect(1, 3071, '\p{Block=Tamil}', "");
    Expect(0, 3071, '\p{^Block=Tamil}', "");
    Expect(0, 3071, '\P{Block=Tamil}', "");
    Expect(1, 3071, '\P{^Block=Tamil}', "");
    Expect(0, 3072, '\p{Block=Tamil}', "");
    Expect(1, 3072, '\p{^Block=Tamil}', "");
    Expect(1, 3072, '\P{Block=Tamil}', "");
    Expect(0, 3072, '\P{^Block=Tamil}', "");
    Error('\p{Blk=-/a/TAMIL}');
    Error('\P{Blk=-/a/TAMIL}');
    Expect(1, 3071, '\p{Blk=:\ATamil\z:}', "");;
    Expect(0, 3072, '\p{Blk=:\ATamil\z:}', "");;
    Expect(1, 3071, '\p{Blk=tamil}', "");
    Expect(0, 3071, '\p{^Blk=tamil}', "");
    Expect(0, 3071, '\P{Blk=tamil}', "");
    Expect(1, 3071, '\P{^Blk=tamil}', "");
    Expect(0, 3072, '\p{Blk=tamil}', "");
    Expect(1, 3072, '\p{^Blk=tamil}', "");
    Expect(1, 3072, '\P{Blk=tamil}', "");
    Expect(0, 3072, '\P{^Blk=tamil}', "");
    Expect(1, 3071, '\p{Blk=:\Atamil\z:}', "");;
    Expect(0, 3072, '\p{Blk=:\Atamil\z:}', "");;
    Expect(1, 3071, '\p{Blk:-_Tamil}', "");
    Expect(0, 3071, '\p{^Blk:-_Tamil}', "");
    Expect(0, 3071, '\P{Blk:-_Tamil}', "");
    Expect(1, 3071, '\P{^Blk:-_Tamil}', "");
    Expect(0, 3072, '\p{Blk:-_Tamil}', "");
    Expect(1, 3072, '\p{^Blk:-_Tamil}', "");
    Expect(1, 3072, '\P{Blk:-_Tamil}', "");
    Expect(0, 3072, '\P{^Blk:-_Tamil}', "");
    Error('\p{Is_Block:   :=_-TAMIL}');
    Error('\P{Is_Block:   :=_-TAMIL}');
    Expect(1, 3071, '\p{Is_Block: tamil}', "");
    Expect(0, 3071, '\p{^Is_Block: tamil}', "");
    Expect(0, 3071, '\P{Is_Block: tamil}', "");
    Expect(1, 3071, '\P{^Is_Block: tamil}', "");
    Expect(0, 3072, '\p{Is_Block: tamil}', "");
    Expect(1, 3072, '\p{^Is_Block: tamil}', "");
    Expect(1, 3072, '\P{Is_Block: tamil}', "");
    Expect(0, 3072, '\P{^Is_Block: tamil}', "");
    Expect(1, 3071, '\p{Is_Block= Tamil}', "");
    Expect(0, 3071, '\p{^Is_Block= Tamil}', "");
    Expect(0, 3071, '\P{Is_Block= Tamil}', "");
    Expect(1, 3071, '\P{^Is_Block= Tamil}', "");
    Expect(0, 3072, '\p{Is_Block= Tamil}', "");
    Expect(1, 3072, '\p{^Is_Block= Tamil}', "");
    Expect(1, 3072, '\P{Is_Block= Tamil}', "");
    Expect(0, 3072, '\P{^Is_Block= Tamil}', "");
    Error('\p{Is_Blk=	TAMIL/a/}');
    Error('\P{Is_Blk=	TAMIL/a/}');
    Expect(1, 3071, '\p{Is_Blk=tamil}', "");
    Expect(0, 3071, '\p{^Is_Blk=tamil}', "");
    Expect(0, 3071, '\P{Is_Blk=tamil}', "");
    Expect(1, 3071, '\P{^Is_Blk=tamil}', "");
    Expect(0, 3072, '\p{Is_Blk=tamil}', "");
    Expect(1, 3072, '\p{^Is_Blk=tamil}', "");
    Expect(1, 3072, '\P{Is_Blk=tamil}', "");
    Expect(0, 3072, '\P{^Is_Blk=tamil}', "");
    Expect(1, 3071, '\p{Is_Blk=-Tamil}', "");
    Expect(0, 3071, '\p{^Is_Blk=-Tamil}', "");
    Expect(0, 3071, '\P{Is_Blk=-Tamil}', "");
    Expect(1, 3071, '\P{^Is_Blk=-Tamil}', "");
    Expect(0, 3072, '\p{Is_Blk=-Tamil}', "");
    Expect(1, 3072, '\p{^Is_Blk=-Tamil}', "");
    Expect(1, 3072, '\P{Is_Blk=-Tamil}', "");
    Expect(0, 3072, '\P{^Is_Blk=-Tamil}', "");
    Error('\p{Block=/a/		TAMIL_SUPPLEMENT}');
    Error('\P{Block=/a/		TAMIL_SUPPLEMENT}');
    Expect(1, 73727, '\p{Block=:\ATamil_Supplement\z:}', "");;
    Expect(0, 73728, '\p{Block=:\ATamil_Supplement\z:}', "");;
    Expect(1, 73727, '\p{Block=tamilsupplement}', "");
    Expect(0, 73727, '\p{^Block=tamilsupplement}', "");
    Expect(0, 73727, '\P{Block=tamilsupplement}', "");
    Expect(1, 73727, '\P{^Block=tamilsupplement}', "");
    Expect(0, 73728, '\p{Block=tamilsupplement}', "");
    Expect(1, 73728, '\p{^Block=tamilsupplement}', "");
    Expect(1, 73728, '\P{Block=tamilsupplement}', "");
    Expect(0, 73728, '\P{^Block=tamilsupplement}', "");
    Expect(1, 73727, '\p{Block=:\Atamilsupplement\z:}', "");;
    Expect(0, 73728, '\p{Block=:\Atamilsupplement\z:}', "");;
    Expect(1, 73727, '\p{Block= 	Tamil_Supplement}', "");
    Expect(0, 73727, '\p{^Block= 	Tamil_Supplement}', "");
    Expect(0, 73727, '\P{Block= 	Tamil_Supplement}', "");
    Expect(1, 73727, '\P{^Block= 	Tamil_Supplement}', "");
    Expect(0, 73728, '\p{Block= 	Tamil_Supplement}', "");
    Expect(1, 73728, '\p{^Block= 	Tamil_Supplement}', "");
    Expect(1, 73728, '\P{Block= 	Tamil_Supplement}', "");
    Expect(0, 73728, '\P{^Block= 	Tamil_Supplement}', "");
    Error('\p{Blk: :=-tamil_SUP}');
    Error('\P{Blk: :=-tamil_SUP}');
    Expect(1, 73727, '\p{Blk=:\ATamil_Sup\z:}', "");;
    Expect(0, 73728, '\p{Blk=:\ATamil_Sup\z:}', "");;
    Expect(1, 73727, '\p{Blk=tamilsup}', "");
    Expect(0, 73727, '\p{^Blk=tamilsup}', "");
    Expect(0, 73727, '\P{Blk=tamilsup}', "");
    Expect(1, 73727, '\P{^Blk=tamilsup}', "");
    Expect(0, 73728, '\p{Blk=tamilsup}', "");
    Expect(1, 73728, '\p{^Blk=tamilsup}', "");
    Expect(1, 73728, '\P{Blk=tamilsup}', "");
    Expect(0, 73728, '\P{^Blk=tamilsup}', "");
    Expect(1, 73727, '\p{Blk=:\Atamilsup\z:}', "");;
    Expect(0, 73728, '\p{Blk=:\Atamilsup\z:}', "");;
    Expect(1, 73727, '\p{Blk=-_tamil_sup}', "");
    Expect(0, 73727, '\p{^Blk=-_tamil_sup}', "");
    Expect(0, 73727, '\P{Blk=-_tamil_sup}', "");
    Expect(1, 73727, '\P{^Blk=-_tamil_sup}', "");
    Expect(0, 73728, '\p{Blk=-_tamil_sup}', "");
    Expect(1, 73728, '\p{^Blk=-_tamil_sup}', "");
    Expect(1, 73728, '\P{Blk=-_tamil_sup}', "");
    Expect(0, 73728, '\P{^Blk=-_tamil_sup}', "");
    Error('\p{Is_Block=_/a/tamil_supplement}');
    Error('\P{Is_Block=_/a/tamil_supplement}');
    Expect(1, 73727, '\p{Is_Block=tamilsupplement}', "");
    Expect(0, 73727, '\p{^Is_Block=tamilsupplement}', "");
    Expect(0, 73727, '\P{Is_Block=tamilsupplement}', "");
    Expect(1, 73727, '\P{^Is_Block=tamilsupplement}', "");
    Expect(0, 73728, '\p{Is_Block=tamilsupplement}', "");
    Expect(1, 73728, '\p{^Is_Block=tamilsupplement}', "");
    Expect(1, 73728, '\P{Is_Block=tamilsupplement}', "");
    Expect(0, 73728, '\P{^Is_Block=tamilsupplement}', "");
    Expect(1, 73727, '\p{Is_Block=-	tamil_SUPPLEMENT}', "");
    Expect(0, 73727, '\p{^Is_Block=-	tamil_SUPPLEMENT}', "");
    Expect(0, 73727, '\P{Is_Block=-	tamil_SUPPLEMENT}', "");
    Expect(1, 73727, '\P{^Is_Block=-	tamil_SUPPLEMENT}', "");
    Expect(0, 73728, '\p{Is_Block=-	tamil_SUPPLEMENT}', "");
    Expect(1, 73728, '\p{^Is_Block=-	tamil_SUPPLEMENT}', "");
    Expect(1, 73728, '\P{Is_Block=-	tamil_SUPPLEMENT}', "");
    Expect(0, 73728, '\P{^Is_Block=-	tamil_SUPPLEMENT}', "");
    Error('\p{Is_Blk:  -Tamil_Sup:=}');
    Error('\P{Is_Blk:  -Tamil_Sup:=}');
    Expect(1, 73727, '\p{Is_Blk=tamilsup}', "");
    Expect(0, 73727, '\p{^Is_Blk=tamilsup}', "");
    Expect(0, 73727, '\P{Is_Blk=tamilsup}', "");
    Expect(1, 73727, '\P{^Is_Blk=tamilsup}', "");
    Expect(0, 73728, '\p{Is_Blk=tamilsup}', "");
    Expect(1, 73728, '\p{^Is_Blk=tamilsup}', "");
    Expect(1, 73728, '\P{Is_Blk=tamilsup}', "");
    Expect(0, 73728, '\P{^Is_Blk=tamilsup}', "");
    Expect(1, 73727, '\p{Is_Blk=	 TAMIL_SUP}', "");
    Expect(0, 73727, '\p{^Is_Blk=	 TAMIL_SUP}', "");
    Expect(0, 73727, '\P{Is_Blk=	 TAMIL_SUP}', "");
    Expect(1, 73727, '\P{^Is_Blk=	 TAMIL_SUP}', "");
    Expect(0, 73728, '\p{Is_Blk=	 TAMIL_SUP}', "");
    Expect(1, 73728, '\p{^Is_Blk=	 TAMIL_SUP}', "");
    Expect(1, 73728, '\P{Is_Blk=	 TAMIL_SUP}', "");
    Expect(0, 73728, '\P{^Is_Blk=	 TAMIL_SUP}', "");
    Error('\p{Block=	TANGUT:=}');
    Error('\P{Block=	TANGUT:=}');
    Expect(1, 100351, '\p{Block=:\ATangut\z:}', "");;
    Expect(0, 100352, '\p{Block=:\ATangut\z:}', "");;
    Expect(1, 100351, '\p{Block=tangut}', "");
    Expect(0, 100351, '\p{^Block=tangut}', "");
    Expect(0, 100351, '\P{Block=tangut}', "");
    Expect(1, 100351, '\P{^Block=tangut}', "");
    Expect(0, 100352, '\p{Block=tangut}', "");
    Expect(1, 100352, '\p{^Block=tangut}', "");
    Expect(1, 100352, '\P{Block=tangut}', "");
    Expect(0, 100352, '\P{^Block=tangut}', "");
    Expect(1, 100351, '\p{Block=:\Atangut\z:}', "");;
    Expect(0, 100352, '\p{Block=:\Atangut\z:}', "");;
    Expect(1, 100351, '\p{Block=-Tangut}', "");
    Expect(0, 100351, '\p{^Block=-Tangut}', "");
    Expect(0, 100351, '\P{Block=-Tangut}', "");
    Expect(1, 100351, '\P{^Block=-Tangut}', "");
    Expect(0, 100352, '\p{Block=-Tangut}', "");
    Expect(1, 100352, '\p{^Block=-Tangut}', "");
    Expect(1, 100352, '\P{Block=-Tangut}', "");
    Expect(0, 100352, '\P{^Block=-Tangut}', "");
    Error('\p{Blk=/a/ -TANGUT}');
    Error('\P{Blk=/a/ -TANGUT}');
    Expect(1, 100351, '\p{Blk=:\ATangut\z:}', "");;
    Expect(0, 100352, '\p{Blk=:\ATangut\z:}', "");;
    Expect(1, 100351, '\p{Blk=tangut}', "");
    Expect(0, 100351, '\p{^Blk=tangut}', "");
    Expect(0, 100351, '\P{Blk=tangut}', "");
    Expect(1, 100351, '\P{^Blk=tangut}', "");
    Expect(0, 100352, '\p{Blk=tangut}', "");
    Expect(1, 100352, '\p{^Blk=tangut}', "");
    Expect(1, 100352, '\P{Blk=tangut}', "");
    Expect(0, 100352, '\P{^Blk=tangut}', "");
    Expect(1, 100351, '\p{Blk=:\Atangut\z:}', "");;
    Expect(0, 100352, '\p{Blk=:\Atangut\z:}', "");;
    Expect(1, 100351, '\p{Blk=--Tangut}', "");
    Expect(0, 100351, '\p{^Blk=--Tangut}', "");
    Expect(0, 100351, '\P{Blk=--Tangut}', "");
    Expect(1, 100351, '\P{^Blk=--Tangut}', "");
    Expect(0, 100352, '\p{Blk=--Tangut}', "");
    Expect(1, 100352, '\p{^Blk=--Tangut}', "");
    Expect(1, 100352, '\P{Blk=--Tangut}', "");
    Expect(0, 100352, '\P{^Blk=--Tangut}', "");
    Error('\p{Is_Block=:= -TANGUT}');
    Error('\P{Is_Block=:= -TANGUT}');
    Expect(1, 100351, '\p{Is_Block=tangut}', "");
    Expect(0, 100351, '\p{^Is_Block=tangut}', "");
    Expect(0, 100351, '\P{Is_Block=tangut}', "");
    Expect(1, 100351, '\P{^Is_Block=tangut}', "");
    Expect(0, 100352, '\p{Is_Block=tangut}', "");
    Expect(1, 100352, '\p{^Is_Block=tangut}', "");
    Expect(1, 100352, '\P{Is_Block=tangut}', "");
    Expect(0, 100352, '\P{^Is_Block=tangut}', "");
    Expect(1, 100351, '\p{Is_Block=  tangut}', "");
    Expect(0, 100351, '\p{^Is_Block=  tangut}', "");
    Expect(0, 100351, '\P{Is_Block=  tangut}', "");
    Expect(1, 100351, '\P{^Is_Block=  tangut}', "");
    Expect(0, 100352, '\p{Is_Block=  tangut}', "");
    Expect(1, 100352, '\p{^Is_Block=  tangut}', "");
    Expect(1, 100352, '\P{Is_Block=  tangut}', "");
    Expect(0, 100352, '\P{^Is_Block=  tangut}', "");
    Error('\p{Is_Blk=/a/_TANGUT}');
    Error('\P{Is_Blk=/a/_TANGUT}');
    Expect(1, 100351, '\p{Is_Blk=tangut}', "");
    Expect(0, 100351, '\p{^Is_Blk=tangut}', "");
    Expect(0, 100351, '\P{Is_Blk=tangut}', "");
    Expect(1, 100351, '\P{^Is_Blk=tangut}', "");
    Expect(0, 100352, '\p{Is_Blk=tangut}', "");
    Expect(1, 100352, '\p{^Is_Blk=tangut}', "");
    Expect(1, 100352, '\P{Is_Blk=tangut}', "");
    Expect(0, 100352, '\P{^Is_Blk=tangut}', "");
    Expect(1, 100351, '\p{Is_Blk=-TANGUT}', "");
    Expect(0, 100351, '\p{^Is_Blk=-TANGUT}', "");
    Expect(0, 100351, '\P{Is_Blk=-TANGUT}', "");
    Expect(1, 100351, '\P{^Is_Blk=-TANGUT}', "");
    Expect(0, 100352, '\p{Is_Blk=-TANGUT}', "");
    Expect(1, 100352, '\p{^Is_Blk=-TANGUT}', "");
    Expect(1, 100352, '\P{Is_Blk=-TANGUT}', "");
    Expect(0, 100352, '\P{^Is_Blk=-TANGUT}', "");
    Error('\p{Block=:=Tangut_Components}');
    Error('\P{Block=:=Tangut_Components}');
    Expect(1, 101119, '\p{Block=:\ATangut_Components\z:}', "");;
    Expect(0, 101120, '\p{Block=:\ATangut_Components\z:}', "");;
    Expect(1, 101119, '\p{Block=tangutcomponents}', "");
    Expect(0, 101119, '\p{^Block=tangutcomponents}', "");
    Expect(0, 101119, '\P{Block=tangutcomponents}', "");
    Expect(1, 101119, '\P{^Block=tangutcomponents}', "");
    Expect(0, 101120, '\p{Block=tangutcomponents}', "");
    Expect(1, 101120, '\p{^Block=tangutcomponents}', "");
    Expect(1, 101120, '\P{Block=tangutcomponents}', "");
    Expect(0, 101120, '\P{^Block=tangutcomponents}', "");
    Expect(1, 101119, '\p{Block=:\Atangutcomponents\z:}', "");;
    Expect(0, 101120, '\p{Block=:\Atangutcomponents\z:}', "");;
    Expect(1, 101119, '\p{Block=	-Tangut_Components}', "");
    Expect(0, 101119, '\p{^Block=	-Tangut_Components}', "");
    Expect(0, 101119, '\P{Block=	-Tangut_Components}', "");
    Expect(1, 101119, '\P{^Block=	-Tangut_Components}', "");
    Expect(0, 101120, '\p{Block=	-Tangut_Components}', "");
    Expect(1, 101120, '\p{^Block=	-Tangut_Components}', "");
    Expect(1, 101120, '\P{Block=	-Tangut_Components}', "");
    Expect(0, 101120, '\P{^Block=	-Tangut_Components}', "");
    Error('\p{Blk=/a/-	TANGUT_COMPONENTS}');
    Error('\P{Blk=/a/-	TANGUT_COMPONENTS}');
    Expect(1, 101119, '\p{Blk=:\ATangut_Components\z:}', "");;
    Expect(0, 101120, '\p{Blk=:\ATangut_Components\z:}', "");;
    Expect(1, 101119, '\p{Blk=tangutcomponents}', "");
    Expect(0, 101119, '\p{^Blk=tangutcomponents}', "");
    Expect(0, 101119, '\P{Blk=tangutcomponents}', "");
    Expect(1, 101119, '\P{^Blk=tangutcomponents}', "");
    Expect(0, 101120, '\p{Blk=tangutcomponents}', "");
    Expect(1, 101120, '\p{^Blk=tangutcomponents}', "");
    Expect(1, 101120, '\P{Blk=tangutcomponents}', "");
    Expect(0, 101120, '\P{^Blk=tangutcomponents}', "");
    Expect(1, 101119, '\p{Blk=:\Atangutcomponents\z:}', "");;
    Expect(0, 101120, '\p{Blk=:\Atangutcomponents\z:}', "");;
    Expect(1, 101119, '\p{Blk= 	Tangut_Components}', "");
    Expect(0, 101119, '\p{^Blk= 	Tangut_Components}', "");
    Expect(0, 101119, '\P{Blk= 	Tangut_Components}', "");
    Expect(1, 101119, '\P{^Blk= 	Tangut_Components}', "");
    Expect(0, 101120, '\p{Blk= 	Tangut_Components}', "");
    Expect(1, 101120, '\p{^Blk= 	Tangut_Components}', "");
    Expect(1, 101120, '\P{Blk= 	Tangut_Components}', "");
    Expect(0, 101120, '\P{^Blk= 	Tangut_Components}', "");
    Error('\p{Is_Block=		tangut_Components:=}');
    Error('\P{Is_Block=		tangut_Components:=}');
    Expect(1, 101119, '\p{Is_Block=tangutcomponents}', "");
    Expect(0, 101119, '\p{^Is_Block=tangutcomponents}', "");
    Expect(0, 101119, '\P{Is_Block=tangutcomponents}', "");
    Expect(1, 101119, '\P{^Is_Block=tangutcomponents}', "");
    Expect(0, 101120, '\p{Is_Block=tangutcomponents}', "");
    Expect(1, 101120, '\p{^Is_Block=tangutcomponents}', "");
    Expect(1, 101120, '\P{Is_Block=tangutcomponents}', "");
    Expect(0, 101120, '\P{^Is_Block=tangutcomponents}', "");
    Expect(1, 101119, '\p{Is_Block= Tangut_Components}', "");
    Expect(0, 101119, '\p{^Is_Block= Tangut_Components}', "");
    Expect(0, 101119, '\P{Is_Block= Tangut_Components}', "");
    Expect(1, 101119, '\P{^Is_Block= Tangut_Components}', "");
    Expect(0, 101120, '\p{Is_Block= Tangut_Components}', "");
    Expect(1, 101120, '\p{^Is_Block= Tangut_Components}', "");
    Expect(1, 101120, '\P{Is_Block= Tangut_Components}', "");
    Expect(0, 101120, '\P{^Is_Block= Tangut_Components}', "");
    Error('\p{Is_Blk=:=Tangut_COMPONENTS}');
    Error('\P{Is_Blk=:=Tangut_COMPONENTS}');
    Expect(1, 101119, '\p{Is_Blk=tangutcomponents}', "");
    Expect(0, 101119, '\p{^Is_Blk=tangutcomponents}', "");
    Expect(0, 101119, '\P{Is_Blk=tangutcomponents}', "");
    Expect(1, 101119, '\P{^Is_Blk=tangutcomponents}', "");
    Expect(0, 101120, '\p{Is_Blk=tangutcomponents}', "");
    Expect(1, 101120, '\p{^Is_Blk=tangutcomponents}', "");
    Expect(1, 101120, '\P{Is_Blk=tangutcomponents}', "");
    Expect(0, 101120, '\P{^Is_Blk=tangutcomponents}', "");
    Expect(1, 101119, '\p{Is_Blk= Tangut_COMPONENTS}', "");
    Expect(0, 101119, '\p{^Is_Blk= Tangut_COMPONENTS}', "");
    Expect(0, 101119, '\P{Is_Blk= Tangut_COMPONENTS}', "");
    Expect(1, 101119, '\P{^Is_Blk= Tangut_COMPONENTS}', "");
    Expect(0, 101120, '\p{Is_Blk= Tangut_COMPONENTS}', "");
    Expect(1, 101120, '\p{^Is_Blk= Tangut_COMPONENTS}', "");
    Expect(1, 101120, '\P{Is_Blk= Tangut_COMPONENTS}', "");
    Expect(0, 101120, '\P{^Is_Blk= Tangut_COMPONENTS}', "");
    Error('\p{Block=/a/	Telugu}');
    Error('\P{Block=/a/	Telugu}');
    Expect(1, 3199, '\p{Block=:\ATelugu\z:}', "");;
    Expect(0, 3200, '\p{Block=:\ATelugu\z:}', "");;
    Expect(1, 3199, '\p{Block=telugu}', "");
    Expect(0, 3199, '\p{^Block=telugu}', "");
    Expect(0, 3199, '\P{Block=telugu}', "");
    Expect(1, 3199, '\P{^Block=telugu}', "");
    Expect(0, 3200, '\p{Block=telugu}', "");
    Expect(1, 3200, '\p{^Block=telugu}', "");
    Expect(1, 3200, '\P{Block=telugu}', "");
    Expect(0, 3200, '\P{^Block=telugu}', "");
    Expect(1, 3199, '\p{Block=:\Atelugu\z:}', "");;
    Expect(0, 3200, '\p{Block=:\Atelugu\z:}', "");;
    Expect(1, 3199, '\p{Block= -telugu}', "");
    Expect(0, 3199, '\p{^Block= -telugu}', "");
    Expect(0, 3199, '\P{Block= -telugu}', "");
    Expect(1, 3199, '\P{^Block= -telugu}', "");
    Expect(0, 3200, '\p{Block= -telugu}', "");
    Expect(1, 3200, '\p{^Block= -telugu}', "");
    Expect(1, 3200, '\P{Block= -telugu}', "");
    Expect(0, 3200, '\P{^Block= -telugu}', "");
    Error('\p{Blk=/a/_telugu}');
    Error('\P{Blk=/a/_telugu}');
    Expect(1, 3199, '\p{Blk=:\ATelugu\z:}', "");;
    Expect(0, 3200, '\p{Blk=:\ATelugu\z:}', "");;
    Expect(1, 3199, '\p{Blk=telugu}', "");
    Expect(0, 3199, '\p{^Blk=telugu}', "");
    Expect(0, 3199, '\P{Blk=telugu}', "");
    Expect(1, 3199, '\P{^Blk=telugu}', "");
    Expect(0, 3200, '\p{Blk=telugu}', "");
    Expect(1, 3200, '\p{^Blk=telugu}', "");
    Expect(1, 3200, '\P{Blk=telugu}', "");
    Expect(0, 3200, '\P{^Blk=telugu}', "");
    Expect(1, 3199, '\p{Blk=:\Atelugu\z:}', "");;
    Expect(0, 3200, '\p{Blk=:\Atelugu\z:}', "");;
    Expect(1, 3199, '\p{Blk=-	telugu}', "");
    Expect(0, 3199, '\p{^Blk=-	telugu}', "");
    Expect(0, 3199, '\P{Blk=-	telugu}', "");
    Expect(1, 3199, '\P{^Blk=-	telugu}', "");
    Expect(0, 3200, '\p{Blk=-	telugu}', "");
    Expect(1, 3200, '\p{^Blk=-	telugu}', "");
    Expect(1, 3200, '\P{Blk=-	telugu}', "");
    Expect(0, 3200, '\P{^Blk=-	telugu}', "");
    Error('\p{Is_Block=/a/Telugu}');
    Error('\P{Is_Block=/a/Telugu}');
    Expect(1, 3199, '\p{Is_Block=telugu}', "");
    Expect(0, 3199, '\p{^Is_Block=telugu}', "");
    Expect(0, 3199, '\P{Is_Block=telugu}', "");
    Expect(1, 3199, '\P{^Is_Block=telugu}', "");
    Expect(0, 3200, '\p{Is_Block=telugu}', "");
    Expect(1, 3200, '\p{^Is_Block=telugu}', "");
    Expect(1, 3200, '\P{Is_Block=telugu}', "");
    Expect(0, 3200, '\P{^Is_Block=telugu}', "");
    Expect(1, 3199, '\p{Is_Block=-Telugu}', "");
    Expect(0, 3199, '\p{^Is_Block=-Telugu}', "");
    Expect(0, 3199, '\P{Is_Block=-Telugu}', "");
    Expect(1, 3199, '\P{^Is_Block=-Telugu}', "");
    Expect(0, 3200, '\p{Is_Block=-Telugu}', "");
    Expect(1, 3200, '\p{^Is_Block=-Telugu}', "");
    Expect(1, 3200, '\P{Is_Block=-Telugu}', "");
    Expect(0, 3200, '\P{^Is_Block=-Telugu}', "");
    Error('\p{Is_Blk=:= _TELUGU}');
    Error('\P{Is_Blk=:= _TELUGU}');
    Expect(1, 3199, '\p{Is_Blk=telugu}', "");
    Expect(0, 3199, '\p{^Is_Blk=telugu}', "");
    Expect(0, 3199, '\P{Is_Blk=telugu}', "");
    Expect(1, 3199, '\P{^Is_Blk=telugu}', "");
    Expect(0, 3200, '\p{Is_Blk=telugu}', "");
    Expect(1, 3200, '\p{^Is_Blk=telugu}', "");
    Expect(1, 3200, '\P{Is_Blk=telugu}', "");
    Expect(0, 3200, '\P{^Is_Blk=telugu}', "");
    Expect(1, 3199, '\p{Is_Blk=Telugu}', "");
    Expect(0, 3199, '\p{^Is_Blk=Telugu}', "");
    Expect(0, 3199, '\P{Is_Blk=Telugu}', "");
    Expect(1, 3199, '\P{^Is_Blk=Telugu}', "");
    Expect(0, 3200, '\p{Is_Blk=Telugu}', "");
    Expect(1, 3200, '\p{^Is_Blk=Telugu}', "");
    Expect(1, 3200, '\P{Is_Blk=Telugu}', "");
    Expect(0, 3200, '\P{^Is_Blk=Telugu}', "");
    Error('\p{Block=	_Thaana:=}');
    Error('\P{Block=	_Thaana:=}');
    Expect(1, 1983, '\p{Block=:\AThaana\z:}', "");;
    Expect(0, 1984, '\p{Block=:\AThaana\z:}', "");;
    Expect(1, 1983, '\p{Block=thaana}', "");
    Expect(0, 1983, '\p{^Block=thaana}', "");
    Expect(0, 1983, '\P{Block=thaana}', "");
    Expect(1, 1983, '\P{^Block=thaana}', "");
    Expect(0, 1984, '\p{Block=thaana}', "");
    Expect(1, 1984, '\p{^Block=thaana}', "");
    Expect(1, 1984, '\P{Block=thaana}', "");
    Expect(0, 1984, '\P{^Block=thaana}', "");
    Expect(1, 1983, '\p{Block=:\Athaana\z:}', "");;
    Expect(0, 1984, '\p{Block=:\Athaana\z:}', "");;
    Expect(1, 1983, '\p{Block=  thaana}', "");
    Expect(0, 1983, '\p{^Block=  thaana}', "");
    Expect(0, 1983, '\P{Block=  thaana}', "");
    Expect(1, 1983, '\P{^Block=  thaana}', "");
    Expect(0, 1984, '\p{Block=  thaana}', "");
    Expect(1, 1984, '\p{^Block=  thaana}', "");
    Expect(1, 1984, '\P{Block=  thaana}', "");
    Expect(0, 1984, '\P{^Block=  thaana}', "");
    Error('\p{Blk=	Thaana:=}');
    Error('\P{Blk=	Thaana:=}');
    Expect(1, 1983, '\p{Blk=:\AThaana\z:}', "");;
    Expect(0, 1984, '\p{Blk=:\AThaana\z:}', "");;
    Expect(1, 1983, '\p{Blk=thaana}', "");
    Expect(0, 1983, '\p{^Blk=thaana}', "");
    Expect(0, 1983, '\P{Blk=thaana}', "");
    Expect(1, 1983, '\P{^Blk=thaana}', "");
    Expect(0, 1984, '\p{Blk=thaana}', "");
    Expect(1, 1984, '\p{^Blk=thaana}', "");
    Expect(1, 1984, '\P{Blk=thaana}', "");
    Expect(0, 1984, '\P{^Blk=thaana}', "");
    Expect(1, 1983, '\p{Blk=:\Athaana\z:}', "");;
    Expect(0, 1984, '\p{Blk=:\Athaana\z:}', "");;
    Expect(1, 1983, '\p{Blk=_ THAANA}', "");
    Expect(0, 1983, '\p{^Blk=_ THAANA}', "");
    Expect(0, 1983, '\P{Blk=_ THAANA}', "");
    Expect(1, 1983, '\P{^Blk=_ THAANA}', "");
    Expect(0, 1984, '\p{Blk=_ THAANA}', "");
    Expect(1, 1984, '\p{^Blk=_ THAANA}', "");
    Expect(1, 1984, '\P{Blk=_ THAANA}', "");
    Expect(0, 1984, '\P{^Blk=_ THAANA}', "");
    Error('\p{Is_Block=:=-	thaana}');
    Error('\P{Is_Block=:=-	thaana}');
    Expect(1, 1983, '\p{Is_Block=thaana}', "");
    Expect(0, 1983, '\p{^Is_Block=thaana}', "");
    Expect(0, 1983, '\P{Is_Block=thaana}', "");
    Expect(1, 1983, '\P{^Is_Block=thaana}', "");
    Expect(0, 1984, '\p{Is_Block=thaana}', "");
    Expect(1, 1984, '\p{^Is_Block=thaana}', "");
    Expect(1, 1984, '\P{Is_Block=thaana}', "");
    Expect(0, 1984, '\P{^Is_Block=thaana}', "");
    Expect(1, 1983, '\p{Is_Block=-Thaana}', "");
    Expect(0, 1983, '\p{^Is_Block=-Thaana}', "");
    Expect(0, 1983, '\P{Is_Block=-Thaana}', "");
    Expect(1, 1983, '\P{^Is_Block=-Thaana}', "");
    Expect(0, 1984, '\p{Is_Block=-Thaana}', "");
    Expect(1, 1984, '\p{^Is_Block=-Thaana}', "");
    Expect(1, 1984, '\P{Is_Block=-Thaana}', "");
    Expect(0, 1984, '\P{^Is_Block=-Thaana}', "");
    Error('\p{Is_Blk=_ Thaana:=}');
    Error('\P{Is_Blk=_ Thaana:=}');
    Expect(1, 1983, '\p{Is_Blk=thaana}', "");
    Expect(0, 1983, '\p{^Is_Blk=thaana}', "");
    Expect(0, 1983, '\P{Is_Blk=thaana}', "");
    Expect(1, 1983, '\P{^Is_Blk=thaana}', "");
    Expect(0, 1984, '\p{Is_Blk=thaana}', "");
    Expect(1, 1984, '\p{^Is_Blk=thaana}', "");
    Expect(1, 1984, '\P{Is_Blk=thaana}', "");
    Expect(0, 1984, '\P{^Is_Blk=thaana}', "");
    Expect(1, 1983, '\p{Is_Blk=  Thaana}', "");
    Expect(0, 1983, '\p{^Is_Blk=  Thaana}', "");
    Expect(0, 1983, '\P{Is_Blk=  Thaana}', "");
    Expect(1, 1983, '\P{^Is_Blk=  Thaana}', "");
    Expect(0, 1984, '\p{Is_Blk=  Thaana}', "");
    Expect(1, 1984, '\p{^Is_Blk=  Thaana}', "");
    Expect(1, 1984, '\P{Is_Blk=  Thaana}', "");
    Expect(0, 1984, '\P{^Is_Blk=  Thaana}', "");
    Error('\p{Block:_	Thai/a/}');
    Error('\P{Block:_	Thai/a/}');
    Expect(1, 3711, '\p{Block=:\AThai\z:}', "");;
    Expect(0, 3712, '\p{Block=:\AThai\z:}', "");;
    Expect(1, 3711, '\p{Block=thai}', "");
    Expect(0, 3711, '\p{^Block=thai}', "");
    Expect(0, 3711, '\P{Block=thai}', "");
    Expect(1, 3711, '\P{^Block=thai}', "");
    Expect(0, 3712, '\p{Block=thai}', "");
    Expect(1, 3712, '\p{^Block=thai}', "");
    Expect(1, 3712, '\P{Block=thai}', "");
    Expect(0, 3712, '\P{^Block=thai}', "");
    Expect(1, 3711, '\p{Block=:\Athai\z:}', "");;
    Expect(0, 3712, '\p{Block=:\Athai\z:}', "");;
    Expect(1, 3711, '\p{Block=		Thai}', "");
    Expect(0, 3711, '\p{^Block=		Thai}', "");
    Expect(0, 3711, '\P{Block=		Thai}', "");
    Expect(1, 3711, '\P{^Block=		Thai}', "");
    Expect(0, 3712, '\p{Block=		Thai}', "");
    Expect(1, 3712, '\p{^Block=		Thai}', "");
    Expect(1, 3712, '\P{Block=		Thai}', "");
    Expect(0, 3712, '\P{^Block=		Thai}', "");
    Error('\p{Blk=/a/	_THAI}');
    Error('\P{Blk=/a/	_THAI}');
    Expect(1, 3711, '\p{Blk=:\AThai\z:}', "");;
    Expect(0, 3712, '\p{Blk=:\AThai\z:}', "");;
    Expect(1, 3711, '\p{Blk:	thai}', "");
    Expect(0, 3711, '\p{^Blk:	thai}', "");
    Expect(0, 3711, '\P{Blk:	thai}', "");
    Expect(1, 3711, '\P{^Blk:	thai}', "");
    Expect(0, 3712, '\p{Blk:	thai}', "");
    Expect(1, 3712, '\p{^Blk:	thai}', "");
    Expect(1, 3712, '\P{Blk:	thai}', "");
    Expect(0, 3712, '\P{^Blk:	thai}', "");
    Expect(1, 3711, '\p{Blk=:\Athai\z:}', "");;
    Expect(0, 3712, '\p{Blk=:\Athai\z:}', "");;
    Expect(1, 3711, '\p{Blk= 	thai}', "");
    Expect(0, 3711, '\p{^Blk= 	thai}', "");
    Expect(0, 3711, '\P{Blk= 	thai}', "");
    Expect(1, 3711, '\P{^Blk= 	thai}', "");
    Expect(0, 3712, '\p{Blk= 	thai}', "");
    Expect(1, 3712, '\p{^Blk= 	thai}', "");
    Expect(1, 3712, '\P{Blk= 	thai}', "");
    Expect(0, 3712, '\P{^Blk= 	thai}', "");
    Error('\p{Is_Block= THAI/a/}');
    Error('\P{Is_Block= THAI/a/}');
    Expect(1, 3711, '\p{Is_Block=thai}', "");
    Expect(0, 3711, '\p{^Is_Block=thai}', "");
    Expect(0, 3711, '\P{Is_Block=thai}', "");
    Expect(1, 3711, '\P{^Is_Block=thai}', "");
    Expect(0, 3712, '\p{Is_Block=thai}', "");
    Expect(1, 3712, '\p{^Is_Block=thai}', "");
    Expect(1, 3712, '\P{Is_Block=thai}', "");
    Expect(0, 3712, '\P{^Is_Block=thai}', "");
    Expect(1, 3711, '\p{Is_Block=  Thai}', "");
    Expect(0, 3711, '\p{^Is_Block=  Thai}', "");
    Expect(0, 3711, '\P{Is_Block=  Thai}', "");
    Expect(1, 3711, '\P{^Is_Block=  Thai}', "");
    Expect(0, 3712, '\p{Is_Block=  Thai}', "");
    Expect(1, 3712, '\p{^Is_Block=  Thai}', "");
    Expect(1, 3712, '\P{Is_Block=  Thai}', "");
    Expect(0, 3712, '\P{^Is_Block=  Thai}', "");
    Error('\p{Is_Blk=thai/a/}');
    Error('\P{Is_Blk=thai/a/}');
    Expect(1, 3711, '\p{Is_Blk=thai}', "");
    Expect(0, 3711, '\p{^Is_Blk=thai}', "");
    Expect(0, 3711, '\P{Is_Blk=thai}', "");
    Expect(1, 3711, '\P{^Is_Blk=thai}', "");
    Expect(0, 3712, '\p{Is_Blk=thai}', "");
    Expect(1, 3712, '\p{^Is_Blk=thai}', "");
    Expect(1, 3712, '\P{Is_Blk=thai}', "");
    Expect(0, 3712, '\P{^Is_Blk=thai}', "");
    Expect(1, 3711, '\p{Is_Blk= Thai}', "");
    Expect(0, 3711, '\p{^Is_Blk= Thai}', "");
    Expect(0, 3711, '\P{Is_Blk= Thai}', "");
    Expect(1, 3711, '\P{^Is_Blk= Thai}', "");
    Expect(0, 3712, '\p{Is_Blk= Thai}', "");
    Expect(1, 3712, '\p{^Is_Blk= Thai}', "");
    Expect(1, 3712, '\P{Is_Blk= Thai}', "");
    Expect(0, 3712, '\P{^Is_Blk= Thai}', "");
    Error('\p{Block= 	TIBETAN/a/}');
    Error('\P{Block= 	TIBETAN/a/}');
    Expect(1, 4095, '\p{Block=:\ATibetan\z:}', "");;
    Expect(0, 4096, '\p{Block=:\ATibetan\z:}', "");;
    Expect(1, 4095, '\p{Block:tibetan}', "");
    Expect(0, 4095, '\p{^Block:tibetan}', "");
    Expect(0, 4095, '\P{Block:tibetan}', "");
    Expect(1, 4095, '\P{^Block:tibetan}', "");
    Expect(0, 4096, '\p{Block:tibetan}', "");
    Expect(1, 4096, '\p{^Block:tibetan}', "");
    Expect(1, 4096, '\P{Block:tibetan}', "");
    Expect(0, 4096, '\P{^Block:tibetan}', "");
    Expect(1, 4095, '\p{Block=:\Atibetan\z:}', "");;
    Expect(0, 4096, '\p{Block=:\Atibetan\z:}', "");;
    Expect(1, 4095, '\p{Block=-_Tibetan}', "");
    Expect(0, 4095, '\p{^Block=-_Tibetan}', "");
    Expect(0, 4095, '\P{Block=-_Tibetan}', "");
    Expect(1, 4095, '\P{^Block=-_Tibetan}', "");
    Expect(0, 4096, '\p{Block=-_Tibetan}', "");
    Expect(1, 4096, '\p{^Block=-_Tibetan}', "");
    Expect(1, 4096, '\P{Block=-_Tibetan}', "");
    Expect(0, 4096, '\P{^Block=-_Tibetan}', "");
    Error('\p{Blk=	/a/Tibetan}');
    Error('\P{Blk=	/a/Tibetan}');
    Expect(1, 4095, '\p{Blk=:\ATibetan\z:}', "");;
    Expect(0, 4096, '\p{Blk=:\ATibetan\z:}', "");;
    Expect(1, 4095, '\p{Blk=tibetan}', "");
    Expect(0, 4095, '\p{^Blk=tibetan}', "");
    Expect(0, 4095, '\P{Blk=tibetan}', "");
    Expect(1, 4095, '\P{^Blk=tibetan}', "");
    Expect(0, 4096, '\p{Blk=tibetan}', "");
    Expect(1, 4096, '\p{^Blk=tibetan}', "");
    Expect(1, 4096, '\P{Blk=tibetan}', "");
    Expect(0, 4096, '\P{^Blk=tibetan}', "");
    Expect(1, 4095, '\p{Blk=:\Atibetan\z:}', "");;
    Expect(0, 4096, '\p{Blk=:\Atibetan\z:}', "");;
    Expect(1, 4095, '\p{Blk=-TIBETAN}', "");
    Expect(0, 4095, '\p{^Blk=-TIBETAN}', "");
    Expect(0, 4095, '\P{Blk=-TIBETAN}', "");
    Expect(1, 4095, '\P{^Blk=-TIBETAN}', "");
    Expect(0, 4096, '\p{Blk=-TIBETAN}', "");
    Expect(1, 4096, '\p{^Blk=-TIBETAN}', "");
    Expect(1, 4096, '\P{Blk=-TIBETAN}', "");
    Expect(0, 4096, '\P{^Blk=-TIBETAN}', "");
    Error('\p{Is_Block=/a/_-Tibetan}');
    Error('\P{Is_Block=/a/_-Tibetan}');
    Expect(1, 4095, '\p{Is_Block=tibetan}', "");
    Expect(0, 4095, '\p{^Is_Block=tibetan}', "");
    Expect(0, 4095, '\P{Is_Block=tibetan}', "");
    Expect(1, 4095, '\P{^Is_Block=tibetan}', "");
    Expect(0, 4096, '\p{Is_Block=tibetan}', "");
    Expect(1, 4096, '\p{^Is_Block=tibetan}', "");
    Expect(1, 4096, '\P{Is_Block=tibetan}', "");
    Expect(0, 4096, '\P{^Is_Block=tibetan}', "");
    Expect(1, 4095, '\p{Is_Block:    -Tibetan}', "");
    Expect(0, 4095, '\p{^Is_Block:    -Tibetan}', "");
    Expect(0, 4095, '\P{Is_Block:    -Tibetan}', "");
    Expect(1, 4095, '\P{^Is_Block:    -Tibetan}', "");
    Expect(0, 4096, '\p{Is_Block:    -Tibetan}', "");
    Expect(1, 4096, '\p{^Is_Block:    -Tibetan}', "");
    Expect(1, 4096, '\P{Is_Block:    -Tibetan}', "");
    Expect(0, 4096, '\P{^Is_Block:    -Tibetan}', "");
    Error('\p{Is_Blk=:=-_tibetan}');
    Error('\P{Is_Blk=:=-_tibetan}');
    Expect(1, 4095, '\p{Is_Blk=tibetan}', "");
    Expect(0, 4095, '\p{^Is_Blk=tibetan}', "");
    Expect(0, 4095, '\P{Is_Blk=tibetan}', "");
    Expect(1, 4095, '\P{^Is_Blk=tibetan}', "");
    Expect(0, 4096, '\p{Is_Blk=tibetan}', "");
    Expect(1, 4096, '\p{^Is_Blk=tibetan}', "");
    Expect(1, 4096, '\P{Is_Blk=tibetan}', "");
    Expect(0, 4096, '\P{^Is_Blk=tibetan}', "");
    Error('\p{Block=:=_ TIFINAGH}');
    Error('\P{Block=:=_ TIFINAGH}');
    Expect(1, 11647, '\p{Block=:\ATifinagh\z:}', "");;
    Expect(0, 11648, '\p{Block=:\ATifinagh\z:}', "");;
    Expect(1, 11647, '\p{Block=tifinagh}', "");
    Expect(0, 11647, '\p{^Block=tifinagh}', "");
    Expect(0, 11647, '\P{Block=tifinagh}', "");
    Expect(1, 11647, '\P{^Block=tifinagh}', "");
    Expect(0, 11648, '\p{Block=tifinagh}', "");
    Expect(1, 11648, '\p{^Block=tifinagh}', "");
    Expect(1, 11648, '\P{Block=tifinagh}', "");
    Expect(0, 11648, '\P{^Block=tifinagh}', "");
    Expect(1, 11647, '\p{Block=:\Atifinagh\z:}', "");;
    Expect(0, 11648, '\p{Block=:\Atifinagh\z:}', "");;
    Expect(1, 11647, '\p{Block=_-tifinagh}', "");
    Expect(0, 11647, '\p{^Block=_-tifinagh}', "");
    Expect(0, 11647, '\P{Block=_-tifinagh}', "");
    Expect(1, 11647, '\P{^Block=_-tifinagh}', "");
    Expect(0, 11648, '\p{Block=_-tifinagh}', "");
    Expect(1, 11648, '\p{^Block=_-tifinagh}', "");
    Expect(1, 11648, '\P{Block=_-tifinagh}', "");
    Expect(0, 11648, '\P{^Block=_-tifinagh}', "");
    Error('\p{Blk=/a/ Tifinagh}');
    Error('\P{Blk=/a/ Tifinagh}');
    Expect(1, 11647, '\p{Blk=:\ATifinagh\z:}', "");;
    Expect(0, 11648, '\p{Blk=:\ATifinagh\z:}', "");;
    Expect(1, 11647, '\p{Blk=tifinagh}', "");
    Expect(0, 11647, '\p{^Blk=tifinagh}', "");
    Expect(0, 11647, '\P{Blk=tifinagh}', "");
    Expect(1, 11647, '\P{^Blk=tifinagh}', "");
    Expect(0, 11648, '\p{Blk=tifinagh}', "");
    Expect(1, 11648, '\p{^Blk=tifinagh}', "");
    Expect(1, 11648, '\P{Blk=tifinagh}', "");
    Expect(0, 11648, '\P{^Blk=tifinagh}', "");
    Expect(1, 11647, '\p{Blk=:\Atifinagh\z:}', "");;
    Expect(0, 11648, '\p{Blk=:\Atifinagh\z:}', "");;
    Expect(1, 11647, '\p{Blk= _tifinagh}', "");
    Expect(0, 11647, '\p{^Blk= _tifinagh}', "");
    Expect(0, 11647, '\P{Blk= _tifinagh}', "");
    Expect(1, 11647, '\P{^Blk= _tifinagh}', "");
    Expect(0, 11648, '\p{Blk= _tifinagh}', "");
    Expect(1, 11648, '\p{^Blk= _tifinagh}', "");
    Expect(1, 11648, '\P{Blk= _tifinagh}', "");
    Expect(0, 11648, '\P{^Blk= _tifinagh}', "");
    Error('\p{Is_Block=-tifinagh/a/}');
    Error('\P{Is_Block=-tifinagh/a/}');
    Expect(1, 11647, '\p{Is_Block=tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Block=tifinagh}', "");
    Expect(0, 11647, '\P{Is_Block=tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Block=tifinagh}', "");
    Expect(0, 11648, '\p{Is_Block=tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Block=tifinagh}', "");
    Expect(1, 11648, '\P{Is_Block=tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Block=tifinagh}', "");
    Expect(1, 11647, '\p{Is_Block= 	Tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Block= 	Tifinagh}', "");
    Expect(0, 11647, '\P{Is_Block= 	Tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Block= 	Tifinagh}', "");
    Expect(0, 11648, '\p{Is_Block= 	Tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Block= 	Tifinagh}', "");
    Expect(1, 11648, '\P{Is_Block= 	Tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Block= 	Tifinagh}', "");
    Error('\p{Is_Blk:_:=tifinagh}');
    Error('\P{Is_Blk:_:=tifinagh}');
    Expect(1, 11647, '\p{Is_Blk:	tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Blk:	tifinagh}', "");
    Expect(0, 11647, '\P{Is_Blk:	tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Blk:	tifinagh}', "");
    Expect(0, 11648, '\p{Is_Blk:	tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Blk:	tifinagh}', "");
    Expect(1, 11648, '\P{Is_Blk:	tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Blk:	tifinagh}', "");
    Expect(1, 11647, '\p{Is_Blk=	-Tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Blk=	-Tifinagh}', "");
    Expect(0, 11647, '\P{Is_Blk=	-Tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Blk=	-Tifinagh}', "");
    Expect(0, 11648, '\p{Is_Blk=	-Tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Blk=	-Tifinagh}', "");
    Expect(1, 11648, '\P{Is_Blk=	-Tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Blk=	-Tifinagh}', "");
    Error('\p{Block=	/a/Tirhuta}');
    Error('\P{Block=	/a/Tirhuta}');
    Expect(1, 70879, '\p{Block=:\ATirhuta\z:}', "");;
    Expect(0, 70880, '\p{Block=:\ATirhuta\z:}', "");;
    Expect(1, 70879, '\p{Block=tirhuta}', "");
    Expect(0, 70879, '\p{^Block=tirhuta}', "");
    Expect(0, 70879, '\P{Block=tirhuta}', "");
    Expect(1, 70879, '\P{^Block=tirhuta}', "");
    Expect(0, 70880, '\p{Block=tirhuta}', "");
    Expect(1, 70880, '\p{^Block=tirhuta}', "");
    Expect(1, 70880, '\P{Block=tirhuta}', "");
    Expect(0, 70880, '\P{^Block=tirhuta}', "");
    Expect(1, 70879, '\p{Block=:\Atirhuta\z:}', "");;
    Expect(0, 70880, '\p{Block=:\Atirhuta\z:}', "");;
    Expect(1, 70879, '\p{Block=-	TIRHUTA}', "");
    Expect(0, 70879, '\p{^Block=-	TIRHUTA}', "");
    Expect(0, 70879, '\P{Block=-	TIRHUTA}', "");
    Expect(1, 70879, '\P{^Block=-	TIRHUTA}', "");
    Expect(0, 70880, '\p{Block=-	TIRHUTA}', "");
    Expect(1, 70880, '\p{^Block=-	TIRHUTA}', "");
    Expect(1, 70880, '\P{Block=-	TIRHUTA}', "");
    Expect(0, 70880, '\P{^Block=-	TIRHUTA}', "");
    Error('\p{Blk=	 TIRHUTA:=}');
    Error('\P{Blk=	 TIRHUTA:=}');
    Expect(1, 70879, '\p{Blk=:\ATirhuta\z:}', "");;
    Expect(0, 70880, '\p{Blk=:\ATirhuta\z:}', "");;
    Expect(1, 70879, '\p{Blk=tirhuta}', "");
    Expect(0, 70879, '\p{^Blk=tirhuta}', "");
    Expect(0, 70879, '\P{Blk=tirhuta}', "");
    Expect(1, 70879, '\P{^Blk=tirhuta}', "");
    Expect(0, 70880, '\p{Blk=tirhuta}', "");
    Expect(1, 70880, '\p{^Blk=tirhuta}', "");
    Expect(1, 70880, '\P{Blk=tirhuta}', "");
    Expect(0, 70880, '\P{^Blk=tirhuta}', "");
    Expect(1, 70879, '\p{Blk=:\Atirhuta\z:}', "");;
    Expect(0, 70880, '\p{Blk=:\Atirhuta\z:}', "");;
    Expect(1, 70879, '\p{Blk=_	TIRHUTA}', "");
    Expect(0, 70879, '\p{^Blk=_	TIRHUTA}', "");
    Expect(0, 70879, '\P{Blk=_	TIRHUTA}', "");
    Expect(1, 70879, '\P{^Blk=_	TIRHUTA}', "");
    Expect(0, 70880, '\p{Blk=_	TIRHUTA}', "");
    Expect(1, 70880, '\p{^Blk=_	TIRHUTA}', "");
    Expect(1, 70880, '\P{Blk=_	TIRHUTA}', "");
    Expect(0, 70880, '\P{^Blk=_	TIRHUTA}', "");
    Error('\p{Is_Block=:=TIRHUTA}');
    Error('\P{Is_Block=:=TIRHUTA}');
    Expect(1, 70879, '\p{Is_Block=tirhuta}', "");
    Expect(0, 70879, '\p{^Is_Block=tirhuta}', "");
    Expect(0, 70879, '\P{Is_Block=tirhuta}', "");
    Expect(1, 70879, '\P{^Is_Block=tirhuta}', "");
    Expect(0, 70880, '\p{Is_Block=tirhuta}', "");
    Expect(1, 70880, '\p{^Is_Block=tirhuta}', "");
    Expect(1, 70880, '\P{Is_Block=tirhuta}', "");
    Expect(0, 70880, '\P{^Is_Block=tirhuta}', "");
    Expect(1, 70879, '\p{Is_Block= 	tirhuta}', "");
    Expect(0, 70879, '\p{^Is_Block= 	tirhuta}', "");
    Expect(0, 70879, '\P{Is_Block= 	tirhuta}', "");
    Expect(1, 70879, '\P{^Is_Block= 	tirhuta}', "");
    Expect(0, 70880, '\p{Is_Block= 	tirhuta}', "");
    Expect(1, 70880, '\p{^Is_Block= 	tirhuta}', "");
    Expect(1, 70880, '\P{Is_Block= 	tirhuta}', "");
    Expect(0, 70880, '\P{^Is_Block= 	tirhuta}', "");
    Error('\p{Is_Blk=_:=Tirhuta}');
    Error('\P{Is_Blk=_:=Tirhuta}');
    Expect(1, 70879, '\p{Is_Blk:   tirhuta}', "");
    Expect(0, 70879, '\p{^Is_Blk:   tirhuta}', "");
    Expect(0, 70879, '\P{Is_Blk:   tirhuta}', "");
    Expect(1, 70879, '\P{^Is_Blk:   tirhuta}', "");
    Expect(0, 70880, '\p{Is_Blk:   tirhuta}', "");
    Expect(1, 70880, '\p{^Is_Blk:   tirhuta}', "");
    Expect(1, 70880, '\P{Is_Blk:   tirhuta}', "");
    Expect(0, 70880, '\P{^Is_Blk:   tirhuta}', "");
    Expect(1, 70879, '\p{Is_Blk=--TIRHUTA}', "");
    Expect(0, 70879, '\p{^Is_Blk=--TIRHUTA}', "");
    Expect(0, 70879, '\P{Is_Blk=--TIRHUTA}', "");
    Expect(1, 70879, '\P{^Is_Blk=--TIRHUTA}', "");
    Expect(0, 70880, '\p{Is_Blk=--TIRHUTA}', "");
    Expect(1, 70880, '\p{^Is_Blk=--TIRHUTA}', "");
    Expect(1, 70880, '\P{Is_Blk=--TIRHUTA}', "");
    Expect(0, 70880, '\P{^Is_Blk=--TIRHUTA}', "");
    Error('\p{Block=_/a/Transport_and_Map_symbols}');
    Error('\P{Block=_/a/Transport_and_Map_symbols}');
    Expect(1, 128767, '\p{Block=:\ATransport_And_Map_Symbols\z:}', "");;
    Expect(0, 128768, '\p{Block=:\ATransport_And_Map_Symbols\z:}', "");;
    Expect(1, 128767, '\p{Block=transportandmapsymbols}', "");
    Expect(0, 128767, '\p{^Block=transportandmapsymbols}', "");
    Expect(0, 128767, '\P{Block=transportandmapsymbols}', "");
    Expect(1, 128767, '\P{^Block=transportandmapsymbols}', "");
    Expect(0, 128768, '\p{Block=transportandmapsymbols}', "");
    Expect(1, 128768, '\p{^Block=transportandmapsymbols}', "");
    Expect(1, 128768, '\P{Block=transportandmapsymbols}', "");
    Expect(0, 128768, '\P{^Block=transportandmapsymbols}', "");
    Expect(1, 128767, '\p{Block=:\Atransportandmapsymbols\z:}', "");;
    Expect(0, 128768, '\p{Block=:\Atransportandmapsymbols\z:}', "");;
    Expect(1, 128767, '\p{Block= -Transport_AND_MAP_SYMBOLS}', "");
    Expect(0, 128767, '\p{^Block= -Transport_AND_MAP_SYMBOLS}', "");
    Expect(0, 128767, '\P{Block= -Transport_AND_MAP_SYMBOLS}', "");
    Expect(1, 128767, '\P{^Block= -Transport_AND_MAP_SYMBOLS}', "");
    Expect(0, 128768, '\p{Block= -Transport_AND_MAP_SYMBOLS}', "");
    Expect(1, 128768, '\p{^Block= -Transport_AND_MAP_SYMBOLS}', "");
    Expect(1, 128768, '\P{Block= -Transport_AND_MAP_SYMBOLS}', "");
    Expect(0, 128768, '\P{^Block= -Transport_AND_MAP_SYMBOLS}', "");
    Error('\p{Blk= :=transport_And_Map}');
    Error('\P{Blk= :=transport_And_Map}');
    Expect(1, 128767, '\p{Blk=:\ATransport_And_Map\z:}', "");;
    Expect(0, 128768, '\p{Blk=:\ATransport_And_Map\z:}', "");;
    Expect(1, 128767, '\p{Blk=transportandmap}', "");
    Expect(0, 128767, '\p{^Blk=transportandmap}', "");
    Expect(0, 128767, '\P{Blk=transportandmap}', "");
    Expect(1, 128767, '\P{^Blk=transportandmap}', "");
    Expect(0, 128768, '\p{Blk=transportandmap}', "");
    Expect(1, 128768, '\p{^Blk=transportandmap}', "");
    Expect(1, 128768, '\P{Blk=transportandmap}', "");
    Expect(0, 128768, '\P{^Blk=transportandmap}', "");
    Expect(1, 128767, '\p{Blk=:\Atransportandmap\z:}', "");;
    Expect(0, 128768, '\p{Blk=:\Atransportandmap\z:}', "");;
    Expect(1, 128767, '\p{Blk=	_transport_AND_Map}', "");
    Expect(0, 128767, '\p{^Blk=	_transport_AND_Map}', "");
    Expect(0, 128767, '\P{Blk=	_transport_AND_Map}', "");
    Expect(1, 128767, '\P{^Blk=	_transport_AND_Map}', "");
    Expect(0, 128768, '\p{Blk=	_transport_AND_Map}', "");
    Expect(1, 128768, '\p{^Blk=	_transport_AND_Map}', "");
    Expect(1, 128768, '\P{Blk=	_transport_AND_Map}', "");
    Expect(0, 128768, '\P{^Blk=	_transport_AND_Map}', "");
    Error('\p{Is_Block=:= Transport_AND_map_Symbols}');
    Error('\P{Is_Block=:= Transport_AND_map_Symbols}');
    Expect(1, 128767, '\p{Is_Block=transportandmapsymbols}', "");
    Expect(0, 128767, '\p{^Is_Block=transportandmapsymbols}', "");
    Expect(0, 128767, '\P{Is_Block=transportandmapsymbols}', "");
    Expect(1, 128767, '\P{^Is_Block=transportandmapsymbols}', "");
    Expect(0, 128768, '\p{Is_Block=transportandmapsymbols}', "");
    Expect(1, 128768, '\p{^Is_Block=transportandmapsymbols}', "");
    Expect(1, 128768, '\P{Is_Block=transportandmapsymbols}', "");
    Expect(0, 128768, '\P{^Is_Block=transportandmapsymbols}', "");
    Expect(1, 128767, '\p{Is_Block=__Transport_And_map_SYMBOLS}', "");
    Expect(0, 128767, '\p{^Is_Block=__Transport_And_map_SYMBOLS}', "");
    Expect(0, 128767, '\P{Is_Block=__Transport_And_map_SYMBOLS}', "");
    Expect(1, 128767, '\P{^Is_Block=__Transport_And_map_SYMBOLS}', "");
    Expect(0, 128768, '\p{Is_Block=__Transport_And_map_SYMBOLS}', "");
    Expect(1, 128768, '\p{^Is_Block=__Transport_And_map_SYMBOLS}', "");
    Expect(1, 128768, '\P{Is_Block=__Transport_And_map_SYMBOLS}', "");
    Expect(0, 128768, '\P{^Is_Block=__Transport_And_map_SYMBOLS}', "");
    Error('\p{Is_Blk=	:=transport_And_MAP}');
    Error('\P{Is_Blk=	:=transport_And_MAP}');
    Expect(1, 128767, '\p{Is_Blk=transportandmap}', "");
    Expect(0, 128767, '\p{^Is_Blk=transportandmap}', "");
    Expect(0, 128767, '\P{Is_Blk=transportandmap}', "");
    Expect(1, 128767, '\P{^Is_Blk=transportandmap}', "");
    Expect(0, 128768, '\p{Is_Blk=transportandmap}', "");
    Expect(1, 128768, '\p{^Is_Blk=transportandmap}', "");
    Expect(1, 128768, '\P{Is_Blk=transportandmap}', "");
    Expect(0, 128768, '\P{^Is_Blk=transportandmap}', "");
    Expect(1, 128767, '\p{Is_Blk:--Transport_AND_Map}', "");
    Expect(0, 128767, '\p{^Is_Blk:--Transport_AND_Map}', "");
    Expect(0, 128767, '\P{Is_Blk:--Transport_AND_Map}', "");
    Expect(1, 128767, '\P{^Is_Blk:--Transport_AND_Map}', "");
    Expect(0, 128768, '\p{Is_Blk:--Transport_AND_Map}', "");
    Expect(1, 128768, '\p{^Is_Blk:--Transport_AND_Map}', "");
    Expect(1, 128768, '\P{Is_Blk:--Transport_AND_Map}', "");
    Expect(0, 128768, '\P{^Is_Blk:--Transport_AND_Map}', "");
    Error('\p{Block=	_unified_Canadian_ABORIGINAL_SYLLABICS:=}');
    Error('\P{Block=	_unified_Canadian_ABORIGINAL_SYLLABICS:=}');
    Expect(1, 5759, '\p{Block=:\AUnified_Canadian_Aboriginal_Syllabics\z:}', "");;
    Expect(0, 5760, '\p{Block=:\AUnified_Canadian_Aboriginal_Syllabics\z:}', "");;
    Expect(1, 5759, '\p{Block=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\p{^Block=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\P{Block=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\P{^Block=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\p{Block=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\p{^Block=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\P{Block=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\P{^Block=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\p{Block=:\Aunifiedcanadianaboriginalsyllabics\z:}', "");;
    Expect(0, 5760, '\p{Block=:\Aunifiedcanadianaboriginalsyllabics\z:}', "");;
    Expect(1, 5759, '\p{Block=- UNIFIED_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(0, 5759, '\p{^Block=- UNIFIED_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(0, 5759, '\P{Block=- UNIFIED_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(1, 5759, '\P{^Block=- UNIFIED_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(0, 5760, '\p{Block=- UNIFIED_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(1, 5760, '\p{^Block=- UNIFIED_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(1, 5760, '\P{Block=- UNIFIED_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(0, 5760, '\P{^Block=- UNIFIED_Canadian_Aboriginal_SYLLABICS}', "");
    Error('\p{Blk=/a/--UCAS}');
    Error('\P{Blk=/a/--UCAS}');
    Expect(1, 5759, '\p{Blk=:\AUCAS\z:}', "");;
    Expect(0, 5760, '\p{Blk=:\AUCAS\z:}', "");;
    Expect(1, 5759, '\p{Blk=ucas}', "");
    Expect(0, 5759, '\p{^Blk=ucas}', "");
    Expect(0, 5759, '\P{Blk=ucas}', "");
    Expect(1, 5759, '\P{^Blk=ucas}', "");
    Expect(0, 5760, '\p{Blk=ucas}', "");
    Expect(1, 5760, '\p{^Blk=ucas}', "");
    Expect(1, 5760, '\P{Blk=ucas}', "");
    Expect(0, 5760, '\P{^Blk=ucas}', "");
    Expect(1, 5759, '\p{Blk=:\Aucas\z:}', "");;
    Expect(0, 5760, '\p{Blk=:\Aucas\z:}', "");;
    Expect(1, 5759, '\p{Blk=_ucas}', "");
    Expect(0, 5759, '\p{^Blk=_ucas}', "");
    Expect(0, 5759, '\P{Blk=_ucas}', "");
    Expect(1, 5759, '\P{^Blk=_ucas}', "");
    Expect(0, 5760, '\p{Blk=_ucas}', "");
    Expect(1, 5760, '\p{^Blk=_ucas}', "");
    Expect(1, 5760, '\P{Blk=_ucas}', "");
    Expect(0, 5760, '\P{^Blk=_ucas}', "");
    Error('\p{Is_Block::=_-canadian_SYLLABICS}');
    Error('\P{Is_Block::=_-canadian_SYLLABICS}');
    Expect(1, 5759, '\p{Is_Block=canadiansyllabics}', "");
    Expect(0, 5759, '\p{^Is_Block=canadiansyllabics}', "");
    Expect(0, 5759, '\P{Is_Block=canadiansyllabics}', "");
    Expect(1, 5759, '\P{^Is_Block=canadiansyllabics}', "");
    Expect(0, 5760, '\p{Is_Block=canadiansyllabics}', "");
    Expect(1, 5760, '\p{^Is_Block=canadiansyllabics}', "");
    Expect(1, 5760, '\P{Is_Block=canadiansyllabics}', "");
    Expect(0, 5760, '\P{^Is_Block=canadiansyllabics}', "");
    Expect(1, 5759, '\p{Is_Block=  CANADIAN_Syllabics}', "");
    Expect(0, 5759, '\p{^Is_Block=  CANADIAN_Syllabics}', "");
    Expect(0, 5759, '\P{Is_Block=  CANADIAN_Syllabics}', "");
    Expect(1, 5759, '\P{^Is_Block=  CANADIAN_Syllabics}', "");
    Expect(0, 5760, '\p{Is_Block=  CANADIAN_Syllabics}', "");
    Expect(1, 5760, '\p{^Is_Block=  CANADIAN_Syllabics}', "");
    Expect(1, 5760, '\P{Is_Block=  CANADIAN_Syllabics}', "");
    Expect(0, 5760, '\P{^Is_Block=  CANADIAN_Syllabics}', "");
    Error('\p{Is_Blk=--unified_Canadian_ABORIGINAL_Syllabics/a/}');
    Error('\P{Is_Blk=--unified_Canadian_ABORIGINAL_Syllabics/a/}');
    Expect(1, 5759, '\p{Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\p{^Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\P{Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\P{^Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\p{Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\p{^Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\P{Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\P{^Is_Blk=unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\p{Is_Blk=Unified_canadian_Aboriginal_syllabics}', "");
    Expect(0, 5759, '\p{^Is_Blk=Unified_canadian_Aboriginal_syllabics}', "");
    Expect(0, 5759, '\P{Is_Blk=Unified_canadian_Aboriginal_syllabics}', "");
    Expect(1, 5759, '\P{^Is_Blk=Unified_canadian_Aboriginal_syllabics}', "");
    Expect(0, 5760, '\p{Is_Blk=Unified_canadian_Aboriginal_syllabics}', "");
    Expect(1, 5760, '\p{^Is_Blk=Unified_canadian_Aboriginal_syllabics}', "");
    Expect(1, 5760, '\P{Is_Blk=Unified_canadian_Aboriginal_syllabics}', "");
    Expect(0, 5760, '\P{^Is_Blk=Unified_canadian_Aboriginal_syllabics}', "");
    Error('\p{Block:  Unified_Canadian_aboriginal_Syllabics_extended:=}');
    Error('\P{Block:  Unified_Canadian_aboriginal_Syllabics_extended:=}');
    Expect(1, 6399, '\p{Block=:\AUnified_Canadian_Aboriginal_Syllabics_Extended\z:}', "");;
    Expect(0, 6400, '\p{Block=:\AUnified_Canadian_Aboriginal_Syllabics_Extended\z:}', "");;
    Expect(1, 6399, '\p{Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\p{^Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\P{Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\P{^Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\p{Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\p{^Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\P{Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\P{^Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\p{Block=:\Aunifiedcanadianaboriginalsyllabicsextended\z:}', "");;
    Expect(0, 6400, '\p{Block=:\Aunifiedcanadianaboriginalsyllabicsextended\z:}', "");;
    Expect(1, 6399, '\p{Block=unified_CANADIAN_aboriginal_Syllabics_extended}', "");
    Expect(0, 6399, '\p{^Block=unified_CANADIAN_aboriginal_Syllabics_extended}', "");
    Expect(0, 6399, '\P{Block=unified_CANADIAN_aboriginal_Syllabics_extended}', "");
    Expect(1, 6399, '\P{^Block=unified_CANADIAN_aboriginal_Syllabics_extended}', "");
    Expect(0, 6400, '\p{Block=unified_CANADIAN_aboriginal_Syllabics_extended}', "");
    Expect(1, 6400, '\p{^Block=unified_CANADIAN_aboriginal_Syllabics_extended}', "");
    Expect(1, 6400, '\P{Block=unified_CANADIAN_aboriginal_Syllabics_extended}', "");
    Expect(0, 6400, '\P{^Block=unified_CANADIAN_aboriginal_Syllabics_extended}', "");
    Error('\p{Blk: UCAS_ext/a/}');
    Error('\P{Blk: UCAS_ext/a/}');
    Expect(1, 6399, '\p{Blk=:\AUCAS_Ext\z:}', "");;
    Expect(0, 6400, '\p{Blk=:\AUCAS_Ext\z:}', "");;
    Expect(1, 6399, '\p{Blk=ucasext}', "");
    Expect(0, 6399, '\p{^Blk=ucasext}', "");
    Expect(0, 6399, '\P{Blk=ucasext}', "");
    Expect(1, 6399, '\P{^Blk=ucasext}', "");
    Expect(0, 6400, '\p{Blk=ucasext}', "");
    Expect(1, 6400, '\p{^Blk=ucasext}', "");
    Expect(1, 6400, '\P{Blk=ucasext}', "");
    Expect(0, 6400, '\P{^Blk=ucasext}', "");
    Expect(1, 6399, '\p{Blk=:\Aucasext\z:}', "");;
    Expect(0, 6400, '\p{Blk=:\Aucasext\z:}', "");;
    Expect(1, 6399, '\p{Blk=	_UCAS_EXT}', "");
    Expect(0, 6399, '\p{^Blk=	_UCAS_EXT}', "");
    Expect(0, 6399, '\P{Blk=	_UCAS_EXT}', "");
    Expect(1, 6399, '\P{^Blk=	_UCAS_EXT}', "");
    Expect(0, 6400, '\p{Blk=	_UCAS_EXT}', "");
    Expect(1, 6400, '\p{^Blk=	_UCAS_EXT}', "");
    Expect(1, 6400, '\P{Blk=	_UCAS_EXT}', "");
    Expect(0, 6400, '\P{^Blk=	_UCAS_EXT}', "");
    Error('\p{Is_Block=_-Unified_Canadian_ABORIGINAL_SYLLABICS_extended/a/}');
    Error('\P{Is_Block=_-Unified_Canadian_ABORIGINAL_SYLLABICS_extended/a/}');
    Expect(1, 6399, '\p{Is_Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\p{^Is_Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\P{Is_Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\P{^Is_Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\p{Is_Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\p{^Is_Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\P{Is_Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\P{^Is_Block=unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\p{Is_Block=	 UNIFIED_Canadian_Aboriginal_Syllabics_extended}', "");
    Expect(0, 6399, '\p{^Is_Block=	 UNIFIED_Canadian_Aboriginal_Syllabics_extended}', "");
    Expect(0, 6399, '\P{Is_Block=	 UNIFIED_Canadian_Aboriginal_Syllabics_extended}', "");
    Expect(1, 6399, '\P{^Is_Block=	 UNIFIED_Canadian_Aboriginal_Syllabics_extended}', "");
    Expect(0, 6400, '\p{Is_Block=	 UNIFIED_Canadian_Aboriginal_Syllabics_extended}', "");
    Expect(1, 6400, '\p{^Is_Block=	 UNIFIED_Canadian_Aboriginal_Syllabics_extended}', "");
    Expect(1, 6400, '\P{Is_Block=	 UNIFIED_Canadian_Aboriginal_Syllabics_extended}', "");
    Expect(0, 6400, '\P{^Is_Block=	 UNIFIED_Canadian_Aboriginal_Syllabics_extended}', "");
    Error('\p{Is_Blk= -UCAS_Ext/a/}');
    Error('\P{Is_Blk= -UCAS_Ext/a/}');
    Expect(1, 6399, '\p{Is_Blk=ucasext}', "");
    Expect(0, 6399, '\p{^Is_Blk=ucasext}', "");
    Expect(0, 6399, '\P{Is_Blk=ucasext}', "");
    Expect(1, 6399, '\P{^Is_Blk=ucasext}', "");
    Expect(0, 6400, '\p{Is_Blk=ucasext}', "");
    Expect(1, 6400, '\p{^Is_Blk=ucasext}', "");
    Expect(1, 6400, '\P{Is_Blk=ucasext}', "");
    Expect(0, 6400, '\P{^Is_Blk=ucasext}', "");
    Expect(1, 6399, '\p{Is_Blk:-_ucas_ext}', "");
    Expect(0, 6399, '\p{^Is_Blk:-_ucas_ext}', "");
    Expect(0, 6399, '\P{Is_Blk:-_ucas_ext}', "");
    Expect(1, 6399, '\P{^Is_Blk:-_ucas_ext}', "");
    Expect(0, 6400, '\p{Is_Blk:-_ucas_ext}', "");
    Expect(1, 6400, '\p{^Is_Blk:-_ucas_ext}', "");
    Expect(1, 6400, '\P{Is_Blk:-_ucas_ext}', "");
    Expect(0, 6400, '\P{^Is_Blk:-_ucas_ext}', "");
    Error('\p{Block:	_Ugaritic:=}');
    Error('\P{Block:	_Ugaritic:=}');
    Expect(1, 66463, '\p{Block=:\AUgaritic\z:}', "");;
    Expect(0, 66464, '\p{Block=:\AUgaritic\z:}', "");;
    Expect(1, 66463, '\p{Block=ugaritic}', "");
    Expect(0, 66463, '\p{^Block=ugaritic}', "");
    Expect(0, 66463, '\P{Block=ugaritic}', "");
    Expect(1, 66463, '\P{^Block=ugaritic}', "");
    Expect(0, 66464, '\p{Block=ugaritic}', "");
    Expect(1, 66464, '\p{^Block=ugaritic}', "");
    Expect(1, 66464, '\P{Block=ugaritic}', "");
    Expect(0, 66464, '\P{^Block=ugaritic}', "");
    Expect(1, 66463, '\p{Block=:\Augaritic\z:}', "");;
    Expect(0, 66464, '\p{Block=:\Augaritic\z:}', "");;
    Expect(1, 66463, '\p{Block=Ugaritic}', "");
    Expect(0, 66463, '\p{^Block=Ugaritic}', "");
    Expect(0, 66463, '\P{Block=Ugaritic}', "");
    Expect(1, 66463, '\P{^Block=Ugaritic}', "");
    Expect(0, 66464, '\p{Block=Ugaritic}', "");
    Expect(1, 66464, '\p{^Block=Ugaritic}', "");
    Expect(1, 66464, '\P{Block=Ugaritic}', "");
    Expect(0, 66464, '\P{^Block=Ugaritic}', "");
    Error('\p{Blk= :=ugaritic}');
    Error('\P{Blk= :=ugaritic}');
    Expect(1, 66463, '\p{Blk=:\AUgaritic\z:}', "");;
    Expect(0, 66464, '\p{Blk=:\AUgaritic\z:}', "");;
    Expect(1, 66463, '\p{Blk=ugaritic}', "");
    Expect(0, 66463, '\p{^Blk=ugaritic}', "");
    Expect(0, 66463, '\P{Blk=ugaritic}', "");
    Expect(1, 66463, '\P{^Blk=ugaritic}', "");
    Expect(0, 66464, '\p{Blk=ugaritic}', "");
    Expect(1, 66464, '\p{^Blk=ugaritic}', "");
    Expect(1, 66464, '\P{Blk=ugaritic}', "");
    Expect(0, 66464, '\P{^Blk=ugaritic}', "");
    Expect(1, 66463, '\p{Blk=:\Augaritic\z:}', "");;
    Expect(0, 66464, '\p{Blk=:\Augaritic\z:}', "");;
    Expect(1, 66463, '\p{Blk=		UGARITIC}', "");
    Expect(0, 66463, '\p{^Blk=		UGARITIC}', "");
    Expect(0, 66463, '\P{Blk=		UGARITIC}', "");
    Expect(1, 66463, '\P{^Blk=		UGARITIC}', "");
    Expect(0, 66464, '\p{Blk=		UGARITIC}', "");
    Expect(1, 66464, '\p{^Blk=		UGARITIC}', "");
    Expect(1, 66464, '\P{Blk=		UGARITIC}', "");
    Expect(0, 66464, '\P{^Blk=		UGARITIC}', "");
    Error('\p{Is_Block= _Ugaritic/a/}');
    Error('\P{Is_Block= _Ugaritic/a/}');
    Expect(1, 66463, '\p{Is_Block=ugaritic}', "");
    Expect(0, 66463, '\p{^Is_Block=ugaritic}', "");
    Expect(0, 66463, '\P{Is_Block=ugaritic}', "");
    Expect(1, 66463, '\P{^Is_Block=ugaritic}', "");
    Expect(0, 66464, '\p{Is_Block=ugaritic}', "");
    Expect(1, 66464, '\p{^Is_Block=ugaritic}', "");
    Expect(1, 66464, '\P{Is_Block=ugaritic}', "");
    Expect(0, 66464, '\P{^Is_Block=ugaritic}', "");
    Expect(1, 66463, '\p{Is_Block= 	UGARITIC}', "");
    Expect(0, 66463, '\p{^Is_Block= 	UGARITIC}', "");
    Expect(0, 66463, '\P{Is_Block= 	UGARITIC}', "");
    Expect(1, 66463, '\P{^Is_Block= 	UGARITIC}', "");
    Expect(0, 66464, '\p{Is_Block= 	UGARITIC}', "");
    Expect(1, 66464, '\p{^Is_Block= 	UGARITIC}', "");
    Expect(1, 66464, '\P{Is_Block= 	UGARITIC}', "");
    Expect(0, 66464, '\P{^Is_Block= 	UGARITIC}', "");
    Error('\p{Is_Blk=-:=Ugaritic}');
    Error('\P{Is_Blk=-:=Ugaritic}');
    Expect(1, 66463, '\p{Is_Blk=ugaritic}', "");
    Expect(0, 66463, '\p{^Is_Blk=ugaritic}', "");
    Expect(0, 66463, '\P{Is_Blk=ugaritic}', "");
    Expect(1, 66463, '\P{^Is_Blk=ugaritic}', "");
    Expect(0, 66464, '\p{Is_Blk=ugaritic}', "");
    Expect(1, 66464, '\p{^Is_Blk=ugaritic}', "");
    Expect(1, 66464, '\P{Is_Blk=ugaritic}', "");
    Expect(0, 66464, '\P{^Is_Blk=ugaritic}', "");
    Expect(1, 66463, '\p{Is_Blk=_	UGARITIC}', "");
    Expect(0, 66463, '\p{^Is_Blk=_	UGARITIC}', "");
    Expect(0, 66463, '\P{Is_Blk=_	UGARITIC}', "");
    Expect(1, 66463, '\P{^Is_Blk=_	UGARITIC}', "");
    Expect(0, 66464, '\p{Is_Blk=_	UGARITIC}', "");
    Expect(1, 66464, '\p{^Is_Blk=_	UGARITIC}', "");
    Expect(1, 66464, '\P{Is_Blk=_	UGARITIC}', "");
    Expect(0, 66464, '\P{^Is_Blk=_	UGARITIC}', "");
    Error('\p{Block=:=_	Vai}');
    Error('\P{Block=:=_	Vai}');
    Expect(1, 42559, '\p{Block=:\AVai\z:}', "");;
    Expect(0, 42560, '\p{Block=:\AVai\z:}', "");;
    Expect(1, 42559, '\p{Block=vai}', "");
    Expect(0, 42559, '\p{^Block=vai}', "");
    Expect(0, 42559, '\P{Block=vai}', "");
    Expect(1, 42559, '\P{^Block=vai}', "");
    Expect(0, 42560, '\p{Block=vai}', "");
    Expect(1, 42560, '\p{^Block=vai}', "");
    Expect(1, 42560, '\P{Block=vai}', "");
    Expect(0, 42560, '\P{^Block=vai}', "");
    Expect(1, 42559, '\p{Block=:\Avai\z:}', "");;
    Expect(0, 42560, '\p{Block=:\Avai\z:}', "");;
    Expect(1, 42559, '\p{Block=	-Vai}', "");
    Expect(0, 42559, '\p{^Block=	-Vai}', "");
    Expect(0, 42559, '\P{Block=	-Vai}', "");
    Expect(1, 42559, '\P{^Block=	-Vai}', "");
    Expect(0, 42560, '\p{Block=	-Vai}', "");
    Expect(1, 42560, '\p{^Block=	-Vai}', "");
    Expect(1, 42560, '\P{Block=	-Vai}', "");
    Expect(0, 42560, '\P{^Block=	-Vai}', "");
    Error('\p{Blk=:=_VAI}');
    Error('\P{Blk=:=_VAI}');
    Expect(1, 42559, '\p{Blk=:\AVai\z:}', "");;
    Expect(0, 42560, '\p{Blk=:\AVai\z:}', "");;
    Expect(1, 42559, '\p{Blk=vai}', "");
    Expect(0, 42559, '\p{^Blk=vai}', "");
    Expect(0, 42559, '\P{Blk=vai}', "");
    Expect(1, 42559, '\P{^Blk=vai}', "");
    Expect(0, 42560, '\p{Blk=vai}', "");
    Expect(1, 42560, '\p{^Blk=vai}', "");
    Expect(1, 42560, '\P{Blk=vai}', "");
    Expect(0, 42560, '\P{^Blk=vai}', "");
    Expect(1, 42559, '\p{Blk=:\Avai\z:}', "");;
    Expect(0, 42560, '\p{Blk=:\Avai\z:}', "");;
    Expect(1, 42559, '\p{Blk=	vai}', "");
    Expect(0, 42559, '\p{^Blk=	vai}', "");
    Expect(0, 42559, '\P{Blk=	vai}', "");
    Expect(1, 42559, '\P{^Blk=	vai}', "");
    Expect(0, 42560, '\p{Blk=	vai}', "");
    Expect(1, 42560, '\p{^Blk=	vai}', "");
    Expect(1, 42560, '\P{Blk=	vai}', "");
    Expect(0, 42560, '\P{^Blk=	vai}', "");
    Error('\p{Is_Block=-Vai:=}');
    Error('\P{Is_Block=-Vai:=}');
    Expect(1, 42559, '\p{Is_Block=vai}', "");
    Expect(0, 42559, '\p{^Is_Block=vai}', "");
    Expect(0, 42559, '\P{Is_Block=vai}', "");
    Expect(1, 42559, '\P{^Is_Block=vai}', "");
    Expect(0, 42560, '\p{Is_Block=vai}', "");
    Expect(1, 42560, '\p{^Is_Block=vai}', "");
    Expect(1, 42560, '\P{Is_Block=vai}', "");
    Expect(0, 42560, '\P{^Is_Block=vai}', "");
    Expect(1, 42559, '\p{Is_Block=	-Vai}', "");
    Expect(0, 42559, '\p{^Is_Block=	-Vai}', "");
    Expect(0, 42559, '\P{Is_Block=	-Vai}', "");
    Expect(1, 42559, '\P{^Is_Block=	-Vai}', "");
    Expect(0, 42560, '\p{Is_Block=	-Vai}', "");
    Expect(1, 42560, '\p{^Is_Block=	-Vai}', "");
    Expect(1, 42560, '\P{Is_Block=	-Vai}', "");
    Expect(0, 42560, '\P{^Is_Block=	-Vai}', "");
    Error('\p{Is_Blk=/a/- vai}');
    Error('\P{Is_Blk=/a/- vai}');
    Expect(1, 42559, '\p{Is_Blk=vai}', "");
    Expect(0, 42559, '\p{^Is_Blk=vai}', "");
    Expect(0, 42559, '\P{Is_Blk=vai}', "");
    Expect(1, 42559, '\P{^Is_Blk=vai}', "");
    Expect(0, 42560, '\p{Is_Blk=vai}', "");
    Expect(1, 42560, '\p{^Is_Blk=vai}', "");
    Expect(1, 42560, '\P{Is_Blk=vai}', "");
    Expect(0, 42560, '\P{^Is_Blk=vai}', "");
    Error('\p{Block:/a/ _Vedic_EXTENSIONS}');
    Error('\P{Block:/a/ _Vedic_EXTENSIONS}');
    Expect(1, 7423, '\p{Block=:\AVedic_Extensions\z:}', "");;
    Expect(0, 7424, '\p{Block=:\AVedic_Extensions\z:}', "");;
    Expect(1, 7423, '\p{Block=vedicextensions}', "");
    Expect(0, 7423, '\p{^Block=vedicextensions}', "");
    Expect(0, 7423, '\P{Block=vedicextensions}', "");
    Expect(1, 7423, '\P{^Block=vedicextensions}', "");
    Expect(0, 7424, '\p{Block=vedicextensions}', "");
    Expect(1, 7424, '\p{^Block=vedicextensions}', "");
    Expect(1, 7424, '\P{Block=vedicextensions}', "");
    Expect(0, 7424, '\P{^Block=vedicextensions}', "");
    Expect(1, 7423, '\p{Block=:\Avedicextensions\z:}', "");;
    Expect(0, 7424, '\p{Block=:\Avedicextensions\z:}', "");;
    Expect(1, 7423, '\p{Block= VEDIC_extensions}', "");
    Expect(0, 7423, '\p{^Block= VEDIC_extensions}', "");
    Expect(0, 7423, '\P{Block= VEDIC_extensions}', "");
    Expect(1, 7423, '\P{^Block= VEDIC_extensions}', "");
    Expect(0, 7424, '\p{Block= VEDIC_extensions}', "");
    Expect(1, 7424, '\p{^Block= VEDIC_extensions}', "");
    Expect(1, 7424, '\P{Block= VEDIC_extensions}', "");
    Expect(0, 7424, '\P{^Block= VEDIC_extensions}', "");
    Error('\p{Blk=/a/_ Vedic_EXT}');
    Error('\P{Blk=/a/_ Vedic_EXT}');
    Expect(1, 7423, '\p{Blk=:\AVedic_Ext\z:}', "");;
    Expect(0, 7424, '\p{Blk=:\AVedic_Ext\z:}', "");;
    Expect(1, 7423, '\p{Blk=vedicext}', "");
    Expect(0, 7423, '\p{^Blk=vedicext}', "");
    Expect(0, 7423, '\P{Blk=vedicext}', "");
    Expect(1, 7423, '\P{^Blk=vedicext}', "");
    Expect(0, 7424, '\p{Blk=vedicext}', "");
    Expect(1, 7424, '\p{^Blk=vedicext}', "");
    Expect(1, 7424, '\P{Blk=vedicext}', "");
    Expect(0, 7424, '\P{^Blk=vedicext}', "");
    Expect(1, 7423, '\p{Blk=:\Avedicext\z:}', "");;
    Expect(0, 7424, '\p{Blk=:\Avedicext\z:}', "");;
    Expect(1, 7423, '\p{Blk=_	Vedic_Ext}', "");
    Expect(0, 7423, '\p{^Blk=_	Vedic_Ext}', "");
    Expect(0, 7423, '\P{Blk=_	Vedic_Ext}', "");
    Expect(1, 7423, '\P{^Blk=_	Vedic_Ext}', "");
    Expect(0, 7424, '\p{Blk=_	Vedic_Ext}', "");
    Expect(1, 7424, '\p{^Blk=_	Vedic_Ext}', "");
    Expect(1, 7424, '\P{Blk=_	Vedic_Ext}', "");
    Expect(0, 7424, '\P{^Blk=_	Vedic_Ext}', "");
    Error('\p{Is_Block= Vedic_Extensions/a/}');
    Error('\P{Is_Block= Vedic_Extensions/a/}');
    Expect(1, 7423, '\p{Is_Block=vedicextensions}', "");
    Expect(0, 7423, '\p{^Is_Block=vedicextensions}', "");
    Expect(0, 7423, '\P{Is_Block=vedicextensions}', "");
    Expect(1, 7423, '\P{^Is_Block=vedicextensions}', "");
    Expect(0, 7424, '\p{Is_Block=vedicextensions}', "");
    Expect(1, 7424, '\p{^Is_Block=vedicextensions}', "");
    Expect(1, 7424, '\P{Is_Block=vedicextensions}', "");
    Expect(0, 7424, '\P{^Is_Block=vedicextensions}', "");
    Expect(1, 7423, '\p{Is_Block=- VEDIC_Extensions}', "");
    Expect(0, 7423, '\p{^Is_Block=- VEDIC_Extensions}', "");
    Expect(0, 7423, '\P{Is_Block=- VEDIC_Extensions}', "");
    Expect(1, 7423, '\P{^Is_Block=- VEDIC_Extensions}', "");
    Expect(0, 7424, '\p{Is_Block=- VEDIC_Extensions}', "");
    Expect(1, 7424, '\p{^Is_Block=- VEDIC_Extensions}', "");
    Expect(1, 7424, '\P{Is_Block=- VEDIC_Extensions}', "");
    Expect(0, 7424, '\P{^Is_Block=- VEDIC_Extensions}', "");
    Error('\p{Is_Blk:   :=	Vedic_Ext}');
    Error('\P{Is_Blk:   :=	Vedic_Ext}');
    Expect(1, 7423, '\p{Is_Blk=vedicext}', "");
    Expect(0, 7423, '\p{^Is_Blk=vedicext}', "");
    Expect(0, 7423, '\P{Is_Blk=vedicext}', "");
    Expect(1, 7423, '\P{^Is_Blk=vedicext}', "");
    Expect(0, 7424, '\p{Is_Blk=vedicext}', "");
    Expect(1, 7424, '\p{^Is_Blk=vedicext}', "");
    Expect(1, 7424, '\P{Is_Blk=vedicext}', "");
    Expect(0, 7424, '\P{^Is_Blk=vedicext}', "");
    Expect(1, 7423, '\p{Is_Blk=	Vedic_Ext}', "");
    Expect(0, 7423, '\p{^Is_Blk=	Vedic_Ext}', "");
    Expect(0, 7423, '\P{Is_Blk=	Vedic_Ext}', "");
    Expect(1, 7423, '\P{^Is_Blk=	Vedic_Ext}', "");
    Expect(0, 7424, '\p{Is_Blk=	Vedic_Ext}', "");
    Expect(1, 7424, '\p{^Is_Blk=	Vedic_Ext}', "");
    Expect(1, 7424, '\P{Is_Blk=	Vedic_Ext}', "");
    Expect(0, 7424, '\P{^Is_Blk=	Vedic_Ext}', "");
    Error('\p{Block=/a/VERTICAL_FORMS}');
    Error('\P{Block=/a/VERTICAL_FORMS}');
    Expect(1, 65055, '\p{Block=:\AVertical_Forms\z:}', "");;
    Expect(0, 65056, '\p{Block=:\AVertical_Forms\z:}', "");;
    Expect(1, 65055, '\p{Block=verticalforms}', "");
    Expect(0, 65055, '\p{^Block=verticalforms}', "");
    Expect(0, 65055, '\P{Block=verticalforms}', "");
    Expect(1, 65055, '\P{^Block=verticalforms}', "");
    Expect(0, 65056, '\p{Block=verticalforms}', "");
    Expect(1, 65056, '\p{^Block=verticalforms}', "");
    Expect(1, 65056, '\P{Block=verticalforms}', "");
    Expect(0, 65056, '\P{^Block=verticalforms}', "");
    Expect(1, 65055, '\p{Block=:\Averticalforms\z:}', "");;
    Expect(0, 65056, '\p{Block=:\Averticalforms\z:}', "");;
    Expect(1, 65055, '\p{Block:    	Vertical_Forms}', "");
    Expect(0, 65055, '\p{^Block:    	Vertical_Forms}', "");
    Expect(0, 65055, '\P{Block:    	Vertical_Forms}', "");
    Expect(1, 65055, '\P{^Block:    	Vertical_Forms}', "");
    Expect(0, 65056, '\p{Block:    	Vertical_Forms}', "");
    Expect(1, 65056, '\p{^Block:    	Vertical_Forms}', "");
    Expect(1, 65056, '\P{Block:    	Vertical_Forms}', "");
    Expect(0, 65056, '\P{^Block:    	Vertical_Forms}', "");
    Error('\p{Blk=/a/_	vertical_forms}');
    Error('\P{Blk=/a/_	vertical_forms}');
    Expect(1, 65055, '\p{Blk=:\AVertical_Forms\z:}', "");;
    Expect(0, 65056, '\p{Blk=:\AVertical_Forms\z:}', "");;
    Expect(1, 65055, '\p{Blk:   verticalforms}', "");
    Expect(0, 65055, '\p{^Blk:   verticalforms}', "");
    Expect(0, 65055, '\P{Blk:   verticalforms}', "");
    Expect(1, 65055, '\P{^Blk:   verticalforms}', "");
    Expect(0, 65056, '\p{Blk:   verticalforms}', "");
    Expect(1, 65056, '\p{^Blk:   verticalforms}', "");
    Expect(1, 65056, '\P{Blk:   verticalforms}', "");
    Expect(0, 65056, '\P{^Blk:   verticalforms}', "");
    Expect(1, 65055, '\p{Blk=:\Averticalforms\z:}', "");;
    Expect(0, 65056, '\p{Blk=:\Averticalforms\z:}', "");;
    Expect(1, 65055, '\p{Blk=VERTICAL_Forms}', "");
    Expect(0, 65055, '\p{^Blk=VERTICAL_Forms}', "");
    Expect(0, 65055, '\P{Blk=VERTICAL_Forms}', "");
    Expect(1, 65055, '\P{^Blk=VERTICAL_Forms}', "");
    Expect(0, 65056, '\p{Blk=VERTICAL_Forms}', "");
    Expect(1, 65056, '\p{^Blk=VERTICAL_Forms}', "");
    Expect(1, 65056, '\P{Blk=VERTICAL_Forms}', "");
    Expect(0, 65056, '\P{^Blk=VERTICAL_Forms}', "");
    Error('\p{Is_Block=		Vertical_Forms:=}');
    Error('\P{Is_Block=		Vertical_Forms:=}');
    Expect(1, 65055, '\p{Is_Block=verticalforms}', "");
    Expect(0, 65055, '\p{^Is_Block=verticalforms}', "");
    Expect(0, 65055, '\P{Is_Block=verticalforms}', "");
    Expect(1, 65055, '\P{^Is_Block=verticalforms}', "");
    Expect(0, 65056, '\p{Is_Block=verticalforms}', "");
    Expect(1, 65056, '\p{^Is_Block=verticalforms}', "");
    Expect(1, 65056, '\P{Is_Block=verticalforms}', "");
    Expect(0, 65056, '\P{^Is_Block=verticalforms}', "");
    Expect(1, 65055, '\p{Is_Block=	VERTICAL_FORMS}', "");
    Expect(0, 65055, '\p{^Is_Block=	VERTICAL_FORMS}', "");
    Expect(0, 65055, '\P{Is_Block=	VERTICAL_FORMS}', "");
    Expect(1, 65055, '\P{^Is_Block=	VERTICAL_FORMS}', "");
    Expect(0, 65056, '\p{Is_Block=	VERTICAL_FORMS}', "");
    Expect(1, 65056, '\p{^Is_Block=	VERTICAL_FORMS}', "");
    Expect(1, 65056, '\P{Is_Block=	VERTICAL_FORMS}', "");
    Expect(0, 65056, '\P{^Is_Block=	VERTICAL_FORMS}', "");
    Error('\p{Is_Blk=:=_ Vertical_forms}');
    Error('\P{Is_Blk=:=_ Vertical_forms}');
    Expect(1, 65055, '\p{Is_Blk=verticalforms}', "");
    Expect(0, 65055, '\p{^Is_Blk=verticalforms}', "");
    Expect(0, 65055, '\P{Is_Blk=verticalforms}', "");
    Expect(1, 65055, '\P{^Is_Blk=verticalforms}', "");
    Expect(0, 65056, '\p{Is_Blk=verticalforms}', "");
    Expect(1, 65056, '\p{^Is_Blk=verticalforms}', "");
    Expect(1, 65056, '\P{Is_Blk=verticalforms}', "");
    Expect(0, 65056, '\P{^Is_Blk=verticalforms}', "");
    Expect(1, 65055, '\p{Is_Blk: 	vertical_Forms}', "");
    Expect(0, 65055, '\p{^Is_Blk: 	vertical_Forms}', "");
    Expect(0, 65055, '\P{Is_Blk: 	vertical_Forms}', "");
    Expect(1, 65055, '\P{^Is_Blk: 	vertical_Forms}', "");
    Expect(0, 65056, '\p{Is_Blk: 	vertical_Forms}', "");
    Expect(1, 65056, '\p{^Is_Blk: 	vertical_Forms}', "");
    Expect(1, 65056, '\P{Is_Blk: 	vertical_Forms}', "");
    Expect(0, 65056, '\P{^Is_Blk: 	vertical_Forms}', "");
    Error('\p{Block=-	Variation_SELECTORS:=}');
    Error('\P{Block=-	Variation_SELECTORS:=}');
    Expect(1, 65039, '\p{Block=:\AVariation_Selectors\z:}', "");;
    Expect(0, 65040, '\p{Block=:\AVariation_Selectors\z:}', "");;
    Expect(1, 65039, '\p{Block=variationselectors}', "");
    Expect(0, 65039, '\p{^Block=variationselectors}', "");
    Expect(0, 65039, '\P{Block=variationselectors}', "");
    Expect(1, 65039, '\P{^Block=variationselectors}', "");
    Expect(0, 65040, '\p{Block=variationselectors}', "");
    Expect(1, 65040, '\p{^Block=variationselectors}', "");
    Expect(1, 65040, '\P{Block=variationselectors}', "");
    Expect(0, 65040, '\P{^Block=variationselectors}', "");
    Expect(1, 65039, '\p{Block=:\Avariationselectors\z:}', "");;
    Expect(0, 65040, '\p{Block=:\Avariationselectors\z:}', "");;
    Expect(1, 65039, '\p{Block=-Variation_selectors}', "");
    Expect(0, 65039, '\p{^Block=-Variation_selectors}', "");
    Expect(0, 65039, '\P{Block=-Variation_selectors}', "");
    Expect(1, 65039, '\P{^Block=-Variation_selectors}', "");
    Expect(0, 65040, '\p{Block=-Variation_selectors}', "");
    Expect(1, 65040, '\p{^Block=-Variation_selectors}', "");
    Expect(1, 65040, '\P{Block=-Variation_selectors}', "");
    Expect(0, 65040, '\P{^Block=-Variation_selectors}', "");
    Error('\p{Blk=	VS:=}');
    Error('\P{Blk=	VS:=}');
    Expect(1, 65039, '\p{Blk=:\AVS\z:}', "");;
    Expect(0, 65040, '\p{Blk=:\AVS\z:}', "");;
    Expect(1, 65039, '\p{Blk=vs}', "");
    Expect(0, 65039, '\p{^Blk=vs}', "");
    Expect(0, 65039, '\P{Blk=vs}', "");
    Expect(1, 65039, '\P{^Blk=vs}', "");
    Expect(0, 65040, '\p{Blk=vs}', "");
    Expect(1, 65040, '\p{^Blk=vs}', "");
    Expect(1, 65040, '\P{Blk=vs}', "");
    Expect(0, 65040, '\P{^Blk=vs}', "");
    Expect(1, 65039, '\p{Blk=:\Avs\z:}', "");;
    Expect(0, 65040, '\p{Blk=:\Avs\z:}', "");;
    Error('\p{Is_Block=/a/Variation_selectors}');
    Error('\P{Is_Block=/a/Variation_selectors}');
    Expect(1, 65039, '\p{Is_Block:   variationselectors}', "");
    Expect(0, 65039, '\p{^Is_Block:   variationselectors}', "");
    Expect(0, 65039, '\P{Is_Block:   variationselectors}', "");
    Expect(1, 65039, '\P{^Is_Block:   variationselectors}', "");
    Expect(0, 65040, '\p{Is_Block:   variationselectors}', "");
    Expect(1, 65040, '\p{^Is_Block:   variationselectors}', "");
    Expect(1, 65040, '\P{Is_Block:   variationselectors}', "");
    Expect(0, 65040, '\P{^Is_Block:   variationselectors}', "");
    Expect(1, 65039, '\p{Is_Block= VARIATION_Selectors}', "");
    Expect(0, 65039, '\p{^Is_Block= VARIATION_Selectors}', "");
    Expect(0, 65039, '\P{Is_Block= VARIATION_Selectors}', "");
    Expect(1, 65039, '\P{^Is_Block= VARIATION_Selectors}', "");
    Expect(0, 65040, '\p{Is_Block= VARIATION_Selectors}', "");
    Expect(1, 65040, '\p{^Is_Block= VARIATION_Selectors}', "");
    Expect(1, 65040, '\P{Is_Block= VARIATION_Selectors}', "");
    Expect(0, 65040, '\P{^Is_Block= VARIATION_Selectors}', "");
    Error('\p{Is_Blk=/a/- VS}');
    Error('\P{Is_Blk=/a/- VS}');
    Expect(1, 65039, '\p{Is_Blk=vs}', "");
    Expect(0, 65039, '\p{^Is_Blk=vs}', "");
    Expect(0, 65039, '\P{Is_Blk=vs}', "");
    Expect(1, 65039, '\P{^Is_Blk=vs}', "");
    Expect(0, 65040, '\p{Is_Blk=vs}', "");
    Expect(1, 65040, '\p{^Is_Blk=vs}', "");
    Expect(1, 65040, '\P{Is_Blk=vs}', "");
    Expect(0, 65040, '\P{^Is_Blk=vs}', "");
    Expect(1, 65039, '\p{Is_Blk=		vs}', "");
    Expect(0, 65039, '\p{^Is_Blk=		vs}', "");
    Expect(0, 65039, '\P{Is_Blk=		vs}', "");
    Expect(1, 65039, '\P{^Is_Blk=		vs}', "");
    Expect(0, 65040, '\p{Is_Blk=		vs}', "");
    Expect(1, 65040, '\p{^Is_Blk=		vs}', "");
    Expect(1, 65040, '\P{Is_Blk=		vs}', "");
    Expect(0, 65040, '\P{^Is_Blk=		vs}', "");
    Error('\p{Block=:= -Variation_selectors_Supplement}');
    Error('\P{Block=:= -Variation_selectors_Supplement}');
    Expect(1, 917999, '\p{Block=:\AVariation_Selectors_Supplement\z:}', "");;
    Expect(0, 918000, '\p{Block=:\AVariation_Selectors_Supplement\z:}', "");;
    Expect(1, 917999, '\p{Block=variationselectorssupplement}', "");
    Expect(0, 917999, '\p{^Block=variationselectorssupplement}', "");
    Expect(0, 917999, '\P{Block=variationselectorssupplement}', "");
    Expect(1, 917999, '\P{^Block=variationselectorssupplement}', "");
    Expect(0, 918000, '\p{Block=variationselectorssupplement}', "");
    Expect(1, 918000, '\p{^Block=variationselectorssupplement}', "");
    Expect(1, 918000, '\P{Block=variationselectorssupplement}', "");
    Expect(0, 918000, '\P{^Block=variationselectorssupplement}', "");
    Expect(1, 917999, '\p{Block=:\Avariationselectorssupplement\z:}', "");;
    Expect(0, 918000, '\p{Block=:\Avariationselectorssupplement\z:}', "");;
    Expect(1, 917999, '\p{Block= Variation_Selectors_Supplement}', "");
    Expect(0, 917999, '\p{^Block= Variation_Selectors_Supplement}', "");
    Expect(0, 917999, '\P{Block= Variation_Selectors_Supplement}', "");
    Expect(1, 917999, '\P{^Block= Variation_Selectors_Supplement}', "");
    Expect(0, 918000, '\p{Block= Variation_Selectors_Supplement}', "");
    Expect(1, 918000, '\p{^Block= Variation_Selectors_Supplement}', "");
    Expect(1, 918000, '\P{Block= Variation_Selectors_Supplement}', "");
    Expect(0, 918000, '\P{^Block= Variation_Selectors_Supplement}', "");
    Error('\p{Blk=  VS_Sup:=}');
    Error('\P{Blk=  VS_Sup:=}');
    Expect(1, 917999, '\p{Blk=:\AVS_Sup\z:}', "");;
    Expect(0, 918000, '\p{Blk=:\AVS_Sup\z:}', "");;
    Expect(1, 917999, '\p{Blk=vssup}', "");
    Expect(0, 917999, '\p{^Blk=vssup}', "");
    Expect(0, 917999, '\P{Blk=vssup}', "");
    Expect(1, 917999, '\P{^Blk=vssup}', "");
    Expect(0, 918000, '\p{Blk=vssup}', "");
    Expect(1, 918000, '\p{^Blk=vssup}', "");
    Expect(1, 918000, '\P{Blk=vssup}', "");
    Expect(0, 918000, '\P{^Blk=vssup}', "");
    Expect(1, 917999, '\p{Blk=:\Avssup\z:}', "");;
    Expect(0, 918000, '\p{Blk=:\Avssup\z:}', "");;
    Expect(1, 917999, '\p{Blk= 	VS_sup}', "");
    Expect(0, 917999, '\p{^Blk= 	VS_sup}', "");
    Expect(0, 917999, '\P{Blk= 	VS_sup}', "");
    Expect(1, 917999, '\P{^Blk= 	VS_sup}', "");
    Expect(0, 918000, '\p{Blk= 	VS_sup}', "");
    Expect(1, 918000, '\p{^Blk= 	VS_sup}', "");
    Expect(1, 918000, '\P{Blk= 	VS_sup}', "");
    Expect(0, 918000, '\P{^Blk= 	VS_sup}', "");
    Error('\p{Is_Block=/a/	-variation_selectors_SUPPLEMENT}');
    Error('\P{Is_Block=/a/	-variation_selectors_SUPPLEMENT}');
    Expect(1, 917999, '\p{Is_Block=variationselectorssupplement}', "");
    Expect(0, 917999, '\p{^Is_Block=variationselectorssupplement}', "");
    Expect(0, 917999, '\P{Is_Block=variationselectorssupplement}', "");
    Expect(1, 917999, '\P{^Is_Block=variationselectorssupplement}', "");
    Expect(0, 918000, '\p{Is_Block=variationselectorssupplement}', "");
    Expect(1, 918000, '\p{^Is_Block=variationselectorssupplement}', "");
    Expect(1, 918000, '\P{Is_Block=variationselectorssupplement}', "");
    Expect(0, 918000, '\P{^Is_Block=variationselectorssupplement}', "");
    Expect(1, 917999, '\p{Is_Block=	VARIATION_selectors_SUPPLEMENT}', "");
    Expect(0, 917999, '\p{^Is_Block=	VARIATION_selectors_SUPPLEMENT}', "");
    Expect(0, 917999, '\P{Is_Block=	VARIATION_selectors_SUPPLEMENT}', "");
    Expect(1, 917999, '\P{^Is_Block=	VARIATION_selectors_SUPPLEMENT}', "");
    Expect(0, 918000, '\p{Is_Block=	VARIATION_selectors_SUPPLEMENT}', "");
    Expect(1, 918000, '\p{^Is_Block=	VARIATION_selectors_SUPPLEMENT}', "");
    Expect(1, 918000, '\P{Is_Block=	VARIATION_selectors_SUPPLEMENT}', "");
    Expect(0, 918000, '\P{^Is_Block=	VARIATION_selectors_SUPPLEMENT}', "");
    Error('\p{Is_Blk=:=--VS_Sup}');
    Error('\P{Is_Blk=:=--VS_Sup}');
    Expect(1, 917999, '\p{Is_Blk=vssup}', "");
    Expect(0, 917999, '\p{^Is_Blk=vssup}', "");
    Expect(0, 917999, '\P{Is_Blk=vssup}', "");
    Expect(1, 917999, '\P{^Is_Blk=vssup}', "");
    Expect(0, 918000, '\p{Is_Blk=vssup}', "");
    Expect(1, 918000, '\p{^Is_Blk=vssup}', "");
    Expect(1, 918000, '\P{Is_Blk=vssup}', "");
    Expect(0, 918000, '\P{^Is_Blk=vssup}', "");
    Expect(1, 917999, '\p{Is_Blk: 	VS_Sup}', "");
    Expect(0, 917999, '\p{^Is_Blk: 	VS_Sup}', "");
    Expect(0, 917999, '\P{Is_Blk: 	VS_Sup}', "");
    Expect(1, 917999, '\P{^Is_Blk: 	VS_Sup}', "");
    Expect(0, 918000, '\p{Is_Blk: 	VS_Sup}', "");
    Expect(1, 918000, '\p{^Is_Blk: 	VS_Sup}', "");
    Expect(1, 918000, '\P{Is_Blk: 	VS_Sup}', "");
    Expect(0, 918000, '\P{^Is_Blk: 	VS_Sup}', "");
    Error('\p{Block= -WANCHO/a/}');
    Error('\P{Block= -WANCHO/a/}');
    Expect(1, 123647, '\p{Block=:\AWancho\z:}', "");;
    Expect(0, 123648, '\p{Block=:\AWancho\z:}', "");;
    Expect(1, 123647, '\p{Block=wancho}', "");
    Expect(0, 123647, '\p{^Block=wancho}', "");
    Expect(0, 123647, '\P{Block=wancho}', "");
    Expect(1, 123647, '\P{^Block=wancho}', "");
    Expect(0, 123648, '\p{Block=wancho}', "");
    Expect(1, 123648, '\p{^Block=wancho}', "");
    Expect(1, 123648, '\P{Block=wancho}', "");
    Expect(0, 123648, '\P{^Block=wancho}', "");
    Expect(1, 123647, '\p{Block=:\Awancho\z:}', "");;
    Expect(0, 123648, '\p{Block=:\Awancho\z:}', "");;
    Expect(1, 123647, '\p{Block=	-wancho}', "");
    Expect(0, 123647, '\p{^Block=	-wancho}', "");
    Expect(0, 123647, '\P{Block=	-wancho}', "");
    Expect(1, 123647, '\P{^Block=	-wancho}', "");
    Expect(0, 123648, '\p{Block=	-wancho}', "");
    Expect(1, 123648, '\p{^Block=	-wancho}', "");
    Expect(1, 123648, '\P{Block=	-wancho}', "");
    Expect(0, 123648, '\P{^Block=	-wancho}', "");
    Error('\p{Blk=	/a/wancho}');
    Error('\P{Blk=	/a/wancho}');
    Expect(1, 123647, '\p{Blk=:\AWancho\z:}', "");;
    Expect(0, 123648, '\p{Blk=:\AWancho\z:}', "");;
    Expect(1, 123647, '\p{Blk=wancho}', "");
    Expect(0, 123647, '\p{^Blk=wancho}', "");
    Expect(0, 123647, '\P{Blk=wancho}', "");
    Expect(1, 123647, '\P{^Blk=wancho}', "");
    Expect(0, 123648, '\p{Blk=wancho}', "");
    Expect(1, 123648, '\p{^Blk=wancho}', "");
    Expect(1, 123648, '\P{Blk=wancho}', "");
    Expect(0, 123648, '\P{^Blk=wancho}', "");
    Expect(1, 123647, '\p{Blk=:\Awancho\z:}', "");;
    Expect(0, 123648, '\p{Blk=:\Awancho\z:}', "");;
    Expect(1, 123647, '\p{Blk=Wancho}', "");
    Expect(0, 123647, '\p{^Blk=Wancho}', "");
    Expect(0, 123647, '\P{Blk=Wancho}', "");
    Expect(1, 123647, '\P{^Blk=Wancho}', "");
    Expect(0, 123648, '\p{Blk=Wancho}', "");
    Expect(1, 123648, '\p{^Blk=Wancho}', "");
    Expect(1, 123648, '\P{Blk=Wancho}', "");
    Expect(0, 123648, '\P{^Blk=Wancho}', "");
    Error('\p{Is_Block=	Wancho/a/}');
    Error('\P{Is_Block=	Wancho/a/}');
    Expect(1, 123647, '\p{Is_Block=wancho}', "");
    Expect(0, 123647, '\p{^Is_Block=wancho}', "");
    Expect(0, 123647, '\P{Is_Block=wancho}', "");
    Expect(1, 123647, '\P{^Is_Block=wancho}', "");
    Expect(0, 123648, '\p{Is_Block=wancho}', "");
    Expect(1, 123648, '\p{^Is_Block=wancho}', "");
    Expect(1, 123648, '\P{Is_Block=wancho}', "");
    Expect(0, 123648, '\P{^Is_Block=wancho}', "");
    Expect(1, 123647, '\p{Is_Block=  Wancho}', "");
    Expect(0, 123647, '\p{^Is_Block=  Wancho}', "");
    Expect(0, 123647, '\P{Is_Block=  Wancho}', "");
    Expect(1, 123647, '\P{^Is_Block=  Wancho}', "");
    Expect(0, 123648, '\p{Is_Block=  Wancho}', "");
    Expect(1, 123648, '\p{^Is_Block=  Wancho}', "");
    Expect(1, 123648, '\P{Is_Block=  Wancho}', "");
    Expect(0, 123648, '\P{^Is_Block=  Wancho}', "");
    Error('\p{Is_Blk=_:=wancho}');
    Error('\P{Is_Blk=_:=wancho}');
    Expect(1, 123647, '\p{Is_Blk=wancho}', "");
    Expect(0, 123647, '\p{^Is_Blk=wancho}', "");
    Expect(0, 123647, '\P{Is_Blk=wancho}', "");
    Expect(1, 123647, '\P{^Is_Blk=wancho}', "");
    Expect(0, 123648, '\p{Is_Blk=wancho}', "");
    Expect(1, 123648, '\p{^Is_Blk=wancho}', "");
    Expect(1, 123648, '\P{Is_Blk=wancho}', "");
    Expect(0, 123648, '\P{^Is_Blk=wancho}', "");
    Expect(1, 123647, '\p{Is_Blk=	_WANCHO}', "");
    Expect(0, 123647, '\p{^Is_Blk=	_WANCHO}', "");
    Expect(0, 123647, '\P{Is_Blk=	_WANCHO}', "");
    Expect(1, 123647, '\P{^Is_Blk=	_WANCHO}', "");
    Expect(0, 123648, '\p{Is_Blk=	_WANCHO}', "");
    Expect(1, 123648, '\p{^Is_Blk=	_WANCHO}', "");
    Expect(1, 123648, '\P{Is_Blk=	_WANCHO}', "");
    Expect(0, 123648, '\P{^Is_Blk=	_WANCHO}', "");
    Error('\p{Block=/a/-warang_CITI}');
    Error('\P{Block=/a/-warang_CITI}');
    Expect(1, 71935, '\p{Block=:\AWarang_Citi\z:}', "");;
    Expect(0, 71936, '\p{Block=:\AWarang_Citi\z:}', "");;
    Expect(1, 71935, '\p{Block=warangciti}', "");
    Expect(0, 71935, '\p{^Block=warangciti}', "");
    Expect(0, 71935, '\P{Block=warangciti}', "");
    Expect(1, 71935, '\P{^Block=warangciti}', "");
    Expect(0, 71936, '\p{Block=warangciti}', "");
    Expect(1, 71936, '\p{^Block=warangciti}', "");
    Expect(1, 71936, '\P{Block=warangciti}', "");
    Expect(0, 71936, '\P{^Block=warangciti}', "");
    Expect(1, 71935, '\p{Block=:\Awarangciti\z:}', "");;
    Expect(0, 71936, '\p{Block=:\Awarangciti\z:}', "");;
    Expect(1, 71935, '\p{Block= _Warang_Citi}', "");
    Expect(0, 71935, '\p{^Block= _Warang_Citi}', "");
    Expect(0, 71935, '\P{Block= _Warang_Citi}', "");
    Expect(1, 71935, '\P{^Block= _Warang_Citi}', "");
    Expect(0, 71936, '\p{Block= _Warang_Citi}', "");
    Expect(1, 71936, '\p{^Block= _Warang_Citi}', "");
    Expect(1, 71936, '\P{Block= _Warang_Citi}', "");
    Expect(0, 71936, '\P{^Block= _Warang_Citi}', "");
    Error('\p{Blk=/a/	-WARANG_CITI}');
    Error('\P{Blk=/a/	-WARANG_CITI}');
    Expect(1, 71935, '\p{Blk=:\AWarang_Citi\z:}', "");;
    Expect(0, 71936, '\p{Blk=:\AWarang_Citi\z:}', "");;
    Expect(1, 71935, '\p{Blk=warangciti}', "");
    Expect(0, 71935, '\p{^Blk=warangciti}', "");
    Expect(0, 71935, '\P{Blk=warangciti}', "");
    Expect(1, 71935, '\P{^Blk=warangciti}', "");
    Expect(0, 71936, '\p{Blk=warangciti}', "");
    Expect(1, 71936, '\p{^Blk=warangciti}', "");
    Expect(1, 71936, '\P{Blk=warangciti}', "");
    Expect(0, 71936, '\P{^Blk=warangciti}', "");
    Expect(1, 71935, '\p{Blk=:\Awarangciti\z:}', "");;
    Expect(0, 71936, '\p{Blk=:\Awarangciti\z:}', "");;
    Expect(1, 71935, '\p{Blk=		Warang_Citi}', "");
    Expect(0, 71935, '\p{^Blk=		Warang_Citi}', "");
    Expect(0, 71935, '\P{Blk=		Warang_Citi}', "");
    Expect(1, 71935, '\P{^Blk=		Warang_Citi}', "");
    Expect(0, 71936, '\p{Blk=		Warang_Citi}', "");
    Expect(1, 71936, '\p{^Blk=		Warang_Citi}', "");
    Expect(1, 71936, '\P{Blk=		Warang_Citi}', "");
    Expect(0, 71936, '\P{^Blk=		Warang_Citi}', "");
    Error('\p{Is_Block=_ WARANG_Citi/a/}');
    Error('\P{Is_Block=_ WARANG_Citi/a/}');
    Expect(1, 71935, '\p{Is_Block=warangciti}', "");
    Expect(0, 71935, '\p{^Is_Block=warangciti}', "");
    Expect(0, 71935, '\P{Is_Block=warangciti}', "");
    Expect(1, 71935, '\P{^Is_Block=warangciti}', "");
    Expect(0, 71936, '\p{Is_Block=warangciti}', "");
    Expect(1, 71936, '\p{^Is_Block=warangciti}', "");
    Expect(1, 71936, '\P{Is_Block=warangciti}', "");
    Expect(0, 71936, '\P{^Is_Block=warangciti}', "");
    Expect(1, 71935, '\p{Is_Block=	 warang_Citi}', "");
    Expect(0, 71935, '\p{^Is_Block=	 warang_Citi}', "");
    Expect(0, 71935, '\P{Is_Block=	 warang_Citi}', "");
    Expect(1, 71935, '\P{^Is_Block=	 warang_Citi}', "");
    Expect(0, 71936, '\p{Is_Block=	 warang_Citi}', "");
    Expect(1, 71936, '\p{^Is_Block=	 warang_Citi}', "");
    Expect(1, 71936, '\P{Is_Block=	 warang_Citi}', "");
    Expect(0, 71936, '\P{^Is_Block=	 warang_Citi}', "");
    Error('\p{Is_Blk=-	Warang_CITI:=}');
    Error('\P{Is_Blk=-	Warang_CITI:=}');
    Expect(1, 71935, '\p{Is_Blk=warangciti}', "");
    Expect(0, 71935, '\p{^Is_Blk=warangciti}', "");
    Expect(0, 71935, '\P{Is_Blk=warangciti}', "");
    Expect(1, 71935, '\P{^Is_Blk=warangciti}', "");
    Expect(0, 71936, '\p{Is_Blk=warangciti}', "");
    Expect(1, 71936, '\p{^Is_Blk=warangciti}', "");
    Expect(1, 71936, '\P{Is_Blk=warangciti}', "");
    Expect(0, 71936, '\P{^Is_Blk=warangciti}', "");
    Expect(1, 71935, '\p{Is_Blk=	 Warang_CITI}', "");
    Expect(0, 71935, '\p{^Is_Blk=	 Warang_CITI}', "");
    Expect(0, 71935, '\P{Is_Blk=	 Warang_CITI}', "");
    Expect(1, 71935, '\P{^Is_Blk=	 Warang_CITI}', "");
    Expect(0, 71936, '\p{Is_Blk=	 Warang_CITI}', "");
    Expect(1, 71936, '\p{^Is_Blk=	 Warang_CITI}', "");
    Expect(1, 71936, '\P{Is_Blk=	 Warang_CITI}', "");
    Expect(0, 71936, '\P{^Is_Blk=	 Warang_CITI}', "");
    Error('\p{Block=/a/	-YI_radicals}');
    Error('\P{Block=/a/	-YI_radicals}');
    Expect(1, 42191, '\p{Block=:\AYi_Radicals\z:}', "");;
    Expect(0, 42192, '\p{Block=:\AYi_Radicals\z:}', "");;
    Expect(1, 42191, '\p{Block=yiradicals}', "");
    Expect(0, 42191, '\p{^Block=yiradicals}', "");
    Expect(0, 42191, '\P{Block=yiradicals}', "");
    Expect(1, 42191, '\P{^Block=yiradicals}', "");
    Expect(0, 42192, '\p{Block=yiradicals}', "");
    Expect(1, 42192, '\p{^Block=yiradicals}', "");
    Expect(1, 42192, '\P{Block=yiradicals}', "");
    Expect(0, 42192, '\P{^Block=yiradicals}', "");
    Expect(1, 42191, '\p{Block=:\Ayiradicals\z:}', "");;
    Expect(0, 42192, '\p{Block=:\Ayiradicals\z:}', "");;
    Expect(1, 42191, '\p{Block= _Yi_RADICALS}', "");
    Expect(0, 42191, '\p{^Block= _Yi_RADICALS}', "");
    Expect(0, 42191, '\P{Block= _Yi_RADICALS}', "");
    Expect(1, 42191, '\P{^Block= _Yi_RADICALS}', "");
    Expect(0, 42192, '\p{Block= _Yi_RADICALS}', "");
    Expect(1, 42192, '\p{^Block= _Yi_RADICALS}', "");
    Expect(1, 42192, '\P{Block= _Yi_RADICALS}', "");
    Expect(0, 42192, '\P{^Block= _Yi_RADICALS}', "");
    Error('\p{Blk:	-/a/Yi_Radicals}');
    Error('\P{Blk:	-/a/Yi_Radicals}');
    Expect(1, 42191, '\p{Blk=:\AYi_Radicals\z:}', "");;
    Expect(0, 42192, '\p{Blk=:\AYi_Radicals\z:}', "");;
    Expect(1, 42191, '\p{Blk=yiradicals}', "");
    Expect(0, 42191, '\p{^Blk=yiradicals}', "");
    Expect(0, 42191, '\P{Blk=yiradicals}', "");
    Expect(1, 42191, '\P{^Blk=yiradicals}', "");
    Expect(0, 42192, '\p{Blk=yiradicals}', "");
    Expect(1, 42192, '\p{^Blk=yiradicals}', "");
    Expect(1, 42192, '\P{Blk=yiradicals}', "");
    Expect(0, 42192, '\P{^Blk=yiradicals}', "");
    Expect(1, 42191, '\p{Blk=:\Ayiradicals\z:}', "");;
    Expect(0, 42192, '\p{Blk=:\Ayiradicals\z:}', "");;
    Expect(1, 42191, '\p{Blk:	 Yi_radicals}', "");
    Expect(0, 42191, '\p{^Blk:	 Yi_radicals}', "");
    Expect(0, 42191, '\P{Blk:	 Yi_radicals}', "");
    Expect(1, 42191, '\P{^Blk:	 Yi_radicals}', "");
    Expect(0, 42192, '\p{Blk:	 Yi_radicals}', "");
    Expect(1, 42192, '\p{^Blk:	 Yi_radicals}', "");
    Expect(1, 42192, '\P{Blk:	 Yi_radicals}', "");
    Expect(0, 42192, '\P{^Blk:	 Yi_radicals}', "");
    Error('\p{Is_Block= _YI_radicals/a/}');
    Error('\P{Is_Block= _YI_radicals/a/}');
    Expect(1, 42191, '\p{Is_Block: yiradicals}', "");
    Expect(0, 42191, '\p{^Is_Block: yiradicals}', "");
    Expect(0, 42191, '\P{Is_Block: yiradicals}', "");
    Expect(1, 42191, '\P{^Is_Block: yiradicals}', "");
    Expect(0, 42192, '\p{Is_Block: yiradicals}', "");
    Expect(1, 42192, '\p{^Is_Block: yiradicals}', "");
    Expect(1, 42192, '\P{Is_Block: yiradicals}', "");
    Expect(0, 42192, '\P{^Is_Block: yiradicals}', "");
    Expect(1, 42191, '\p{Is_Block=		YI_RADICALS}', "");
    Expect(0, 42191, '\p{^Is_Block=		YI_RADICALS}', "");
    Expect(0, 42191, '\P{Is_Block=		YI_RADICALS}', "");
    Expect(1, 42191, '\P{^Is_Block=		YI_RADICALS}', "");
    Expect(0, 42192, '\p{Is_Block=		YI_RADICALS}', "");
    Expect(1, 42192, '\p{^Is_Block=		YI_RADICALS}', "");
    Expect(1, 42192, '\P{Is_Block=		YI_RADICALS}', "");
    Expect(0, 42192, '\P{^Is_Block=		YI_RADICALS}', "");
    Error('\p{Is_Blk= yi_RADICALS/a/}');
    Error('\P{Is_Blk= yi_RADICALS/a/}');
    Expect(1, 42191, '\p{Is_Blk=yiradicals}', "");
    Expect(0, 42191, '\p{^Is_Blk=yiradicals}', "");
    Expect(0, 42191, '\P{Is_Blk=yiradicals}', "");
    Expect(1, 42191, '\P{^Is_Blk=yiradicals}', "");
    Expect(0, 42192, '\p{Is_Blk=yiradicals}', "");
    Expect(1, 42192, '\p{^Is_Blk=yiradicals}', "");
    Expect(1, 42192, '\P{Is_Blk=yiradicals}', "");
    Expect(0, 42192, '\P{^Is_Blk=yiradicals}', "");
    Expect(1, 42191, '\p{Is_Blk=	-yi_radicals}', "");
    Expect(0, 42191, '\p{^Is_Blk=	-yi_radicals}', "");
    Expect(0, 42191, '\P{Is_Blk=	-yi_radicals}', "");
    Expect(1, 42191, '\P{^Is_Blk=	-yi_radicals}', "");
    Expect(0, 42192, '\p{Is_Blk=	-yi_radicals}', "");
    Expect(1, 42192, '\p{^Is_Blk=	-yi_radicals}', "");
    Expect(1, 42192, '\P{Is_Blk=	-yi_radicals}', "");
    Expect(0, 42192, '\P{^Is_Blk=	-yi_radicals}', "");
    Error('\p{Block=	-yi_Syllables/a/}');
    Error('\P{Block=	-yi_Syllables/a/}');
    Expect(1, 42127, '\p{Block=:\AYi_Syllables\z:}', "");;
    Expect(0, 42128, '\p{Block=:\AYi_Syllables\z:}', "");;
    Expect(1, 42127, '\p{Block=yisyllables}', "");
    Expect(0, 42127, '\p{^Block=yisyllables}', "");
    Expect(0, 42127, '\P{Block=yisyllables}', "");
    Expect(1, 42127, '\P{^Block=yisyllables}', "");
    Expect(0, 42128, '\p{Block=yisyllables}', "");
    Expect(1, 42128, '\p{^Block=yisyllables}', "");
    Expect(1, 42128, '\P{Block=yisyllables}', "");
    Expect(0, 42128, '\P{^Block=yisyllables}', "");
    Expect(1, 42127, '\p{Block=:\Ayisyllables\z:}', "");;
    Expect(0, 42128, '\p{Block=:\Ayisyllables\z:}', "");;
    Expect(1, 42127, '\p{Block:  Yi_SYLLABLES}', "");
    Expect(0, 42127, '\p{^Block:  Yi_SYLLABLES}', "");
    Expect(0, 42127, '\P{Block:  Yi_SYLLABLES}', "");
    Expect(1, 42127, '\P{^Block:  Yi_SYLLABLES}', "");
    Expect(0, 42128, '\p{Block:  Yi_SYLLABLES}', "");
    Expect(1, 42128, '\p{^Block:  Yi_SYLLABLES}', "");
    Expect(1, 42128, '\P{Block:  Yi_SYLLABLES}', "");
    Expect(0, 42128, '\P{^Block:  Yi_SYLLABLES}', "");
    Error('\p{Blk: 	:=yi_SYLLABLES}');
    Error('\P{Blk: 	:=yi_SYLLABLES}');
    Expect(1, 42127, '\p{Blk=:\AYi_Syllables\z:}', "");;
    Expect(0, 42128, '\p{Blk=:\AYi_Syllables\z:}', "");;
    Expect(1, 42127, '\p{Blk=yisyllables}', "");
    Expect(0, 42127, '\p{^Blk=yisyllables}', "");
    Expect(0, 42127, '\P{Blk=yisyllables}', "");
    Expect(1, 42127, '\P{^Blk=yisyllables}', "");
    Expect(0, 42128, '\p{Blk=yisyllables}', "");
    Expect(1, 42128, '\p{^Blk=yisyllables}', "");
    Expect(1, 42128, '\P{Blk=yisyllables}', "");
    Expect(0, 42128, '\P{^Blk=yisyllables}', "");
    Expect(1, 42127, '\p{Blk=:\Ayisyllables\z:}', "");;
    Expect(0, 42128, '\p{Blk=:\Ayisyllables\z:}', "");;
    Expect(1, 42127, '\p{Blk=Yi_SYLLABLES}', "");
    Expect(0, 42127, '\p{^Blk=Yi_SYLLABLES}', "");
    Expect(0, 42127, '\P{Blk=Yi_SYLLABLES}', "");
    Expect(1, 42127, '\P{^Blk=Yi_SYLLABLES}', "");
    Expect(0, 42128, '\p{Blk=Yi_SYLLABLES}', "");
    Expect(1, 42128, '\p{^Blk=Yi_SYLLABLES}', "");
    Expect(1, 42128, '\P{Blk=Yi_SYLLABLES}', "");
    Expect(0, 42128, '\P{^Blk=Yi_SYLLABLES}', "");
    Error('\p{Is_Block=  yi_Syllables:=}');
    Error('\P{Is_Block=  yi_Syllables:=}');
    Expect(1, 42127, '\p{Is_Block=yisyllables}', "");
    Expect(0, 42127, '\p{^Is_Block=yisyllables}', "");
    Expect(0, 42127, '\P{Is_Block=yisyllables}', "");
    Expect(1, 42127, '\P{^Is_Block=yisyllables}', "");
    Expect(0, 42128, '\p{Is_Block=yisyllables}', "");
    Expect(1, 42128, '\p{^Is_Block=yisyllables}', "");
    Expect(1, 42128, '\P{Is_Block=yisyllables}', "");
    Expect(0, 42128, '\P{^Is_Block=yisyllables}', "");
    Expect(1, 42127, '\p{Is_Block= _Yi_Syllables}', "");
    Expect(0, 42127, '\p{^Is_Block= _Yi_Syllables}', "");
    Expect(0, 42127, '\P{Is_Block= _Yi_Syllables}', "");
    Expect(1, 42127, '\P{^Is_Block= _Yi_Syllables}', "");
    Expect(0, 42128, '\p{Is_Block= _Yi_Syllables}', "");
    Expect(1, 42128, '\p{^Is_Block= _Yi_Syllables}', "");
    Expect(1, 42128, '\P{Is_Block= _Yi_Syllables}', "");
    Expect(0, 42128, '\P{^Is_Block= _Yi_Syllables}', "");
    Error('\p{Is_Blk=-yi_syllables/a/}');
    Error('\P{Is_Blk=-yi_syllables/a/}');
    Expect(1, 42127, '\p{Is_Blk=yisyllables}', "");
    Expect(0, 42127, '\p{^Is_Blk=yisyllables}', "");
    Expect(0, 42127, '\P{Is_Blk=yisyllables}', "");
    Expect(1, 42127, '\P{^Is_Blk=yisyllables}', "");
    Expect(0, 42128, '\p{Is_Blk=yisyllables}', "");
    Expect(1, 42128, '\p{^Is_Blk=yisyllables}', "");
    Expect(1, 42128, '\P{Is_Blk=yisyllables}', "");
    Expect(0, 42128, '\P{^Is_Blk=yisyllables}', "");
    Expect(1, 42127, '\p{Is_Blk= Yi_syllables}', "");
    Expect(0, 42127, '\p{^Is_Blk= Yi_syllables}', "");
    Expect(0, 42127, '\P{Is_Blk= Yi_syllables}', "");
    Expect(1, 42127, '\P{^Is_Blk= Yi_syllables}', "");
    Expect(0, 42128, '\p{Is_Blk= Yi_syllables}', "");
    Expect(1, 42128, '\p{^Is_Blk= Yi_syllables}', "");
    Expect(1, 42128, '\P{Is_Blk= Yi_syllables}', "");
    Expect(0, 42128, '\P{^Is_Blk= Yi_syllables}', "");
    Error('\p{Block=-_Yijing_HEXAGRAM_Symbols/a/}');
    Error('\P{Block=-_Yijing_HEXAGRAM_Symbols/a/}');
    Expect(1, 19967, '\p{Block=:\AYijing_Hexagram_Symbols\z:}', "");;
    Expect(0, 19968, '\p{Block=:\AYijing_Hexagram_Symbols\z:}', "");;
    Expect(1, 19967, '\p{Block=yijinghexagramsymbols}', "");
    Expect(0, 19967, '\p{^Block=yijinghexagramsymbols}', "");
    Expect(0, 19967, '\P{Block=yijinghexagramsymbols}', "");
    Expect(1, 19967, '\P{^Block=yijinghexagramsymbols}', "");
    Expect(0, 19968, '\p{Block=yijinghexagramsymbols}', "");
    Expect(1, 19968, '\p{^Block=yijinghexagramsymbols}', "");
    Expect(1, 19968, '\P{Block=yijinghexagramsymbols}', "");
    Expect(0, 19968, '\P{^Block=yijinghexagramsymbols}', "");
    Expect(1, 19967, '\p{Block=:\Ayijinghexagramsymbols\z:}', "");;
    Expect(0, 19968, '\p{Block=:\Ayijinghexagramsymbols\z:}', "");;
    Expect(1, 19967, '\p{Block=  Yijing_Hexagram_symbols}', "");
    Expect(0, 19967, '\p{^Block=  Yijing_Hexagram_symbols}', "");
    Expect(0, 19967, '\P{Block=  Yijing_Hexagram_symbols}', "");
    Expect(1, 19967, '\P{^Block=  Yijing_Hexagram_symbols}', "");
    Expect(0, 19968, '\p{Block=  Yijing_Hexagram_symbols}', "");
    Expect(1, 19968, '\p{^Block=  Yijing_Hexagram_symbols}', "");
    Expect(1, 19968, '\P{Block=  Yijing_Hexagram_symbols}', "");
    Expect(0, 19968, '\P{^Block=  Yijing_Hexagram_symbols}', "");
    Error('\p{Blk=:=_	YIJING}');
    Error('\P{Blk=:=_	YIJING}');
    Expect(1, 19967, '\p{Blk=:\AYijing\z:}', "");;
    Expect(0, 19968, '\p{Blk=:\AYijing\z:}', "");;
    Expect(1, 19967, '\p{Blk=yijing}', "");
    Expect(0, 19967, '\p{^Blk=yijing}', "");
    Expect(0, 19967, '\P{Blk=yijing}', "");
    Expect(1, 19967, '\P{^Blk=yijing}', "");
    Expect(0, 19968, '\p{Blk=yijing}', "");
    Expect(1, 19968, '\p{^Blk=yijing}', "");
    Expect(1, 19968, '\P{Blk=yijing}', "");
    Expect(0, 19968, '\P{^Blk=yijing}', "");
    Expect(1, 19967, '\p{Blk=:\Ayijing\z:}', "");;
    Expect(0, 19968, '\p{Blk=:\Ayijing\z:}', "");;
    Expect(1, 19967, '\p{Blk= Yijing}', "");
    Expect(0, 19967, '\p{^Blk= Yijing}', "");
    Expect(0, 19967, '\P{Blk= Yijing}', "");
    Expect(1, 19967, '\P{^Blk= Yijing}', "");
    Expect(0, 19968, '\p{Blk= Yijing}', "");
    Expect(1, 19968, '\p{^Blk= Yijing}', "");
    Expect(1, 19968, '\P{Blk= Yijing}', "");
    Expect(0, 19968, '\P{^Blk= Yijing}', "");
    Error('\p{Is_Block=--Yijing_Hexagram_symbols:=}');
    Error('\P{Is_Block=--Yijing_Hexagram_symbols:=}');
    Expect(1, 19967, '\p{Is_Block=yijinghexagramsymbols}', "");
    Expect(0, 19967, '\p{^Is_Block=yijinghexagramsymbols}', "");
    Expect(0, 19967, '\P{Is_Block=yijinghexagramsymbols}', "");
    Expect(1, 19967, '\P{^Is_Block=yijinghexagramsymbols}', "");
    Expect(0, 19968, '\p{Is_Block=yijinghexagramsymbols}', "");
    Expect(1, 19968, '\p{^Is_Block=yijinghexagramsymbols}', "");
    Expect(1, 19968, '\P{Is_Block=yijinghexagramsymbols}', "");
    Expect(0, 19968, '\P{^Is_Block=yijinghexagramsymbols}', "");
    Expect(1, 19967, '\p{Is_Block= 	Yijing_hexagram_SYMBOLS}', "");
    Expect(0, 19967, '\p{^Is_Block= 	Yijing_hexagram_SYMBOLS}', "");
    Expect(0, 19967, '\P{Is_Block= 	Yijing_hexagram_SYMBOLS}', "");
    Expect(1, 19967, '\P{^Is_Block= 	Yijing_hexagram_SYMBOLS}', "");
    Expect(0, 19968, '\p{Is_Block= 	Yijing_hexagram_SYMBOLS}', "");
    Expect(1, 19968, '\p{^Is_Block= 	Yijing_hexagram_SYMBOLS}', "");
    Expect(1, 19968, '\P{Is_Block= 	Yijing_hexagram_SYMBOLS}', "");
    Expect(0, 19968, '\P{^Is_Block= 	Yijing_hexagram_SYMBOLS}', "");
    Error('\p{Is_Blk=/a/_	Yijing}');
    Error('\P{Is_Blk=/a/_	Yijing}');
    Expect(1, 19967, '\p{Is_Blk=yijing}', "");
    Expect(0, 19967, '\p{^Is_Blk=yijing}', "");
    Expect(0, 19967, '\P{Is_Blk=yijing}', "");
    Expect(1, 19967, '\P{^Is_Blk=yijing}', "");
    Expect(0, 19968, '\p{Is_Blk=yijing}', "");
    Expect(1, 19968, '\p{^Is_Blk=yijing}', "");
    Expect(1, 19968, '\P{Is_Blk=yijing}', "");
    Expect(0, 19968, '\P{^Is_Blk=yijing}', "");
    Expect(1, 19967, '\p{Is_Blk= YIJING}', "");
    Expect(0, 19967, '\p{^Is_Blk= YIJING}', "");
    Expect(0, 19967, '\P{Is_Blk= YIJING}', "");
    Expect(1, 19967, '\P{^Is_Blk= YIJING}', "");
    Expect(0, 19968, '\p{Is_Blk= YIJING}', "");
    Expect(1, 19968, '\p{^Is_Blk= YIJING}', "");
    Expect(1, 19968, '\P{Is_Blk= YIJING}', "");
    Expect(0, 19968, '\P{^Is_Blk= YIJING}', "");
    Error('\p{Block= Zanabazar_Square:=}');
    Error('\P{Block= Zanabazar_Square:=}');
    Expect(1, 72271, '\p{Block=:\AZanabazar_Square\z:}', "");;
    Expect(0, 72272, '\p{Block=:\AZanabazar_Square\z:}', "");;
    Expect(1, 72271, '\p{Block=zanabazarsquare}', "");
    Expect(0, 72271, '\p{^Block=zanabazarsquare}', "");
    Expect(0, 72271, '\P{Block=zanabazarsquare}', "");
    Expect(1, 72271, '\P{^Block=zanabazarsquare}', "");
    Expect(0, 72272, '\p{Block=zanabazarsquare}', "");
    Expect(1, 72272, '\p{^Block=zanabazarsquare}', "");
    Expect(1, 72272, '\P{Block=zanabazarsquare}', "");
    Expect(0, 72272, '\P{^Block=zanabazarsquare}', "");
    Expect(1, 72271, '\p{Block=:\Azanabazarsquare\z:}', "");;
    Expect(0, 72272, '\p{Block=:\Azanabazarsquare\z:}', "");;
    Expect(1, 72271, '\p{Block=	_ZANABAZAR_Square}', "");
    Expect(0, 72271, '\p{^Block=	_ZANABAZAR_Square}', "");
    Expect(0, 72271, '\P{Block=	_ZANABAZAR_Square}', "");
    Expect(1, 72271, '\P{^Block=	_ZANABAZAR_Square}', "");
    Expect(0, 72272, '\p{Block=	_ZANABAZAR_Square}', "");
    Expect(1, 72272, '\p{^Block=	_ZANABAZAR_Square}', "");
    Expect(1, 72272, '\P{Block=	_ZANABAZAR_Square}', "");
    Expect(0, 72272, '\P{^Block=	_ZANABAZAR_Square}', "");
    Error('\p{Blk=:=Zanabazar_Square}');
    Error('\P{Blk=:=Zanabazar_Square}');
    Expect(1, 72271, '\p{Blk=:\AZanabazar_Square\z:}', "");;
    Expect(0, 72272, '\p{Blk=:\AZanabazar_Square\z:}', "");;
    Expect(1, 72271, '\p{Blk=zanabazarsquare}', "");
    Expect(0, 72271, '\p{^Blk=zanabazarsquare}', "");
    Expect(0, 72271, '\P{Blk=zanabazarsquare}', "");
    Expect(1, 72271, '\P{^Blk=zanabazarsquare}', "");
    Expect(0, 72272, '\p{Blk=zanabazarsquare}', "");
    Expect(1, 72272, '\p{^Blk=zanabazarsquare}', "");
    Expect(1, 72272, '\P{Blk=zanabazarsquare}', "");
    Expect(0, 72272, '\P{^Blk=zanabazarsquare}', "");
    Expect(1, 72271, '\p{Blk=:\Azanabazarsquare\z:}', "");;
    Expect(0, 72272, '\p{Blk=:\Azanabazarsquare\z:}', "");;
    Expect(1, 72271, '\p{Blk:_	ZANABAZAR_SQUARE}', "");
    Expect(0, 72271, '\p{^Blk:_	ZANABAZAR_SQUARE}', "");
    Expect(0, 72271, '\P{Blk:_	ZANABAZAR_SQUARE}', "");
    Expect(1, 72271, '\P{^Blk:_	ZANABAZAR_SQUARE}', "");
    Expect(0, 72272, '\p{Blk:_	ZANABAZAR_SQUARE}', "");
    Expect(1, 72272, '\p{^Blk:_	ZANABAZAR_SQUARE}', "");
    Expect(1, 72272, '\P{Blk:_	ZANABAZAR_SQUARE}', "");
    Expect(0, 72272, '\P{^Blk:_	ZANABAZAR_SQUARE}', "");
    Error('\p{Is_Block:  -ZANABAZAR_Square/a/}');
    Error('\P{Is_Block:  -ZANABAZAR_Square/a/}');
    Expect(1, 72271, '\p{Is_Block=zanabazarsquare}', "");
    Expect(0, 72271, '\p{^Is_Block=zanabazarsquare}', "");
    Expect(0, 72271, '\P{Is_Block=zanabazarsquare}', "");
    Expect(1, 72271, '\P{^Is_Block=zanabazarsquare}', "");
    Expect(0, 72272, '\p{Is_Block=zanabazarsquare}', "");
    Expect(1, 72272, '\p{^Is_Block=zanabazarsquare}', "");
    Expect(1, 72272, '\P{Is_Block=zanabazarsquare}', "");
    Expect(0, 72272, '\P{^Is_Block=zanabazarsquare}', "");
    Expect(1, 72271, '\p{Is_Block: Zanabazar_SQUARE}', "");
    Expect(0, 72271, '\p{^Is_Block: Zanabazar_SQUARE}', "");
    Expect(0, 72271, '\P{Is_Block: Zanabazar_SQUARE}', "");
    Expect(1, 72271, '\P{^Is_Block: Zanabazar_SQUARE}', "");
    Expect(0, 72272, '\p{Is_Block: Zanabazar_SQUARE}', "");
    Expect(1, 72272, '\p{^Is_Block: Zanabazar_SQUARE}', "");
    Expect(1, 72272, '\P{Is_Block: Zanabazar_SQUARE}', "");
    Expect(0, 72272, '\P{^Is_Block: Zanabazar_SQUARE}', "");
    Error('\p{Is_Blk=-/a/Zanabazar_square}');
    Error('\P{Is_Blk=-/a/Zanabazar_square}');
    Expect(1, 72271, '\p{Is_Blk=zanabazarsquare}', "");
    Expect(0, 72271, '\p{^Is_Blk=zanabazarsquare}', "");
    Expect(0, 72271, '\P{Is_Blk=zanabazarsquare}', "");
    Expect(1, 72271, '\P{^Is_Blk=zanabazarsquare}', "");
    Expect(0, 72272, '\p{Is_Blk=zanabazarsquare}', "");
    Expect(1, 72272, '\p{^Is_Blk=zanabazarsquare}', "");
    Expect(1, 72272, '\P{Is_Blk=zanabazarsquare}', "");
    Expect(0, 72272, '\P{^Is_Blk=zanabazarsquare}', "");
    Expect(1, 72271, '\p{Is_Blk=--Zanabazar_Square}', "");
    Expect(0, 72271, '\p{^Is_Blk=--Zanabazar_Square}', "");
    Expect(0, 72271, '\P{Is_Blk=--Zanabazar_Square}', "");
    Expect(1, 72271, '\P{^Is_Blk=--Zanabazar_Square}', "");
    Expect(0, 72272, '\p{Is_Blk=--Zanabazar_Square}', "");
    Expect(1, 72272, '\p{^Is_Blk=--Zanabazar_Square}', "");
    Expect(1, 72272, '\P{Is_Blk=--Zanabazar_Square}', "");
    Expect(0, 72272, '\P{^Is_Blk=--Zanabazar_Square}', "");
    Error('\p{bidimirroringglyph}');
    Error('\P{bidimirroringglyph}');
    Error('\p{bmg}');
    Error('\P{bmg}');
    Error('\p{bidipairedbracket}');
    Error('\P{bidipairedbracket}');
    Error('\p{bpb}');
    Error('\P{bpb}');
    Error('\p{bidipairedbrackettype}');
    Error('\P{bidipairedbrackettype}');
    Error('\p{bpt}');
    Error('\P{bpt}');
    Error('\p{Bidi_Paired_Bracket_Type:   -Close/a/}');
    Error('\P{Bidi_Paired_Bracket_Type:   -Close/a/}');
    Expect(1, 65379, '\p{Bidi_Paired_Bracket_Type=:\AClose\z:}', "");;
    Expect(0, 65380, '\p{Bidi_Paired_Bracket_Type=:\AClose\z:}', "");;
    Expect(1, 65379, '\p{Bidi_Paired_Bracket_Type=close}', "");
    Expect(0, 65379, '\p{^Bidi_Paired_Bracket_Type=close}', "");
    Expect(0, 65379, '\P{Bidi_Paired_Bracket_Type=close}', "");
    Expect(1, 65379, '\P{^Bidi_Paired_Bracket_Type=close}', "");
    Expect(0, 65380, '\p{Bidi_Paired_Bracket_Type=close}', "");
    Expect(1, 65380, '\p{^Bidi_Paired_Bracket_Type=close}', "");
    Expect(1, 65380, '\P{Bidi_Paired_Bracket_Type=close}', "");
    Expect(0, 65380, '\P{^Bidi_Paired_Bracket_Type=close}', "");
    Expect(1, 65379, '\p{Bidi_Paired_Bracket_Type=:\Aclose\z:}', "");;
    Expect(0, 65380, '\p{Bidi_Paired_Bracket_Type=:\Aclose\z:}', "");;
    Expect(1, 65379, '\p{Bidi_Paired_Bracket_Type=-close}', "");
    Expect(0, 65379, '\p{^Bidi_Paired_Bracket_Type=-close}', "");
    Expect(0, 65379, '\P{Bidi_Paired_Bracket_Type=-close}', "");
    Expect(1, 65379, '\P{^Bidi_Paired_Bracket_Type=-close}', "");
    Expect(0, 65380, '\p{Bidi_Paired_Bracket_Type=-close}', "");
    Expect(1, 65380, '\p{^Bidi_Paired_Bracket_Type=-close}', "");
    Expect(1, 65380, '\P{Bidi_Paired_Bracket_Type=-close}', "");
    Expect(0, 65380, '\P{^Bidi_Paired_Bracket_Type=-close}', "");
    Error('\p{Bpt=  C:=}');
    Error('\P{Bpt=  C:=}');
    Expect(1, 65379, '\p{Bpt=:\AC\z:}', "");;
    Expect(0, 65380, '\p{Bpt=:\AC\z:}', "");;
    Expect(1, 65379, '\p{Bpt=c}', "");
    Expect(0, 65379, '\p{^Bpt=c}', "");
    Expect(0, 65379, '\P{Bpt=c}', "");
    Expect(1, 65379, '\P{^Bpt=c}', "");
    Expect(0, 65380, '\p{Bpt=c}', "");
    Expect(1, 65380, '\p{^Bpt=c}', "");
    Expect(1, 65380, '\P{Bpt=c}', "");
    Expect(0, 65380, '\P{^Bpt=c}', "");
    Expect(1, 65379, '\p{Bpt=:\Ac\z:}', "");;
    Expect(0, 65380, '\p{Bpt=:\Ac\z:}', "");;
    Expect(1, 65379, '\p{Bpt=_c}', "");
    Expect(0, 65379, '\p{^Bpt=_c}', "");
    Expect(0, 65379, '\P{Bpt=_c}', "");
    Expect(1, 65379, '\P{^Bpt=_c}', "");
    Expect(0, 65380, '\p{Bpt=_c}', "");
    Expect(1, 65380, '\p{^Bpt=_c}', "");
    Expect(1, 65380, '\P{Bpt=_c}', "");
    Expect(0, 65380, '\P{^Bpt=_c}', "");
    Error('\p{Is_Bidi_Paired_Bracket_Type=-CLOSE:=}');
    Error('\P{Is_Bidi_Paired_Bracket_Type=-CLOSE:=}');
    Expect(1, 65379, '\p{Is_Bidi_Paired_Bracket_Type=close}', "");
    Expect(0, 65379, '\p{^Is_Bidi_Paired_Bracket_Type=close}', "");
    Expect(0, 65379, '\P{Is_Bidi_Paired_Bracket_Type=close}', "");
    Expect(1, 65379, '\P{^Is_Bidi_Paired_Bracket_Type=close}', "");
    Expect(0, 65380, '\p{Is_Bidi_Paired_Bracket_Type=close}', "");
    Expect(1, 65380, '\p{^Is_Bidi_Paired_Bracket_Type=close}', "");
    Expect(1, 65380, '\P{Is_Bidi_Paired_Bracket_Type=close}', "");
    Expect(0, 65380, '\P{^Is_Bidi_Paired_Bracket_Type=close}', "");
    Expect(1, 65379, '\p{Is_Bidi_Paired_Bracket_Type=-Close}', "");
    Expect(0, 65379, '\p{^Is_Bidi_Paired_Bracket_Type=-Close}', "");
    Expect(0, 65379, '\P{Is_Bidi_Paired_Bracket_Type=-Close}', "");
    Expect(1, 65379, '\P{^Is_Bidi_Paired_Bracket_Type=-Close}', "");
    Expect(0, 65380, '\p{Is_Bidi_Paired_Bracket_Type=-Close}', "");
    Expect(1, 65380, '\p{^Is_Bidi_Paired_Bracket_Type=-Close}', "");
    Expect(1, 65380, '\P{Is_Bidi_Paired_Bracket_Type=-Close}', "");
    Expect(0, 65380, '\P{^Is_Bidi_Paired_Bracket_Type=-Close}', "");
    Error('\p{Is_Bpt:_c:=}');
    Error('\P{Is_Bpt:_c:=}');
    Expect(1, 65379, '\p{Is_Bpt=c}', "");
    Expect(0, 65379, '\p{^Is_Bpt=c}', "");
    Expect(0, 65379, '\P{Is_Bpt=c}', "");
    Expect(1, 65379, '\P{^Is_Bpt=c}', "");
    Expect(0, 65380, '\p{Is_Bpt=c}', "");
    Expect(1, 65380, '\p{^Is_Bpt=c}', "");
    Expect(1, 65380, '\P{Is_Bpt=c}', "");
    Expect(0, 65380, '\P{^Is_Bpt=c}', "");
    Expect(1, 65379, '\p{Is_Bpt=	-C}', "");
    Expect(0, 65379, '\p{^Is_Bpt=	-C}', "");
    Expect(0, 65379, '\P{Is_Bpt=	-C}', "");
    Expect(1, 65379, '\P{^Is_Bpt=	-C}', "");
    Expect(0, 65380, '\p{Is_Bpt=	-C}', "");
    Expect(1, 65380, '\p{^Is_Bpt=	-C}', "");
    Expect(1, 65380, '\P{Is_Bpt=	-C}', "");
    Expect(0, 65380, '\P{^Is_Bpt=	-C}', "");
    Error('\p{Bidi_Paired_Bracket_Type: /a/	_None}');
    Error('\P{Bidi_Paired_Bracket_Type: /a/	_None}');
    Expect(1, 65380, '\p{Bidi_Paired_Bracket_Type=:\ANone\z:}', "");;
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type=:\ANone\z:}', "");;
    Expect(1, 65380, '\p{Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65380, '\p{^Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65380, '\P{Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65380, '\P{^Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65379, '\p{^Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65379, '\P{Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65379, '\P{^Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65380, '\p{Bidi_Paired_Bracket_Type=:\Anone\z:}', "");;
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type=:\Anone\z:}', "");;
    Expect(1, 65380, '\p{Bidi_Paired_Bracket_Type=  none}', "");
    Expect(0, 65380, '\p{^Bidi_Paired_Bracket_Type=  none}', "");
    Expect(0, 65380, '\P{Bidi_Paired_Bracket_Type=  none}', "");
    Expect(1, 65380, '\P{^Bidi_Paired_Bracket_Type=  none}', "");
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type=  none}', "");
    Expect(1, 65379, '\p{^Bidi_Paired_Bracket_Type=  none}', "");
    Expect(1, 65379, '\P{Bidi_Paired_Bracket_Type=  none}', "");
    Expect(0, 65379, '\P{^Bidi_Paired_Bracket_Type=  none}', "");
    Error('\p{Bpt=/a/ _N}');
    Error('\P{Bpt=/a/ _N}');
    Expect(1, 65380, '\p{Bpt=:\AN\z:}', "");;
    Expect(0, 65379, '\p{Bpt=:\AN\z:}', "");;
    Expect(1, 65380, '\p{Bpt=n}', "");
    Expect(0, 65380, '\p{^Bpt=n}', "");
    Expect(0, 65380, '\P{Bpt=n}', "");
    Expect(1, 65380, '\P{^Bpt=n}', "");
    Expect(0, 65379, '\p{Bpt=n}', "");
    Expect(1, 65379, '\p{^Bpt=n}', "");
    Expect(1, 65379, '\P{Bpt=n}', "");
    Expect(0, 65379, '\P{^Bpt=n}', "");
    Expect(1, 65380, '\p{Bpt=:\An\z:}', "");;
    Expect(0, 65379, '\p{Bpt=:\An\z:}', "");;
    Expect(1, 65380, '\p{Bpt=	n}', "");
    Expect(0, 65380, '\p{^Bpt=	n}', "");
    Expect(0, 65380, '\P{Bpt=	n}', "");
    Expect(1, 65380, '\P{^Bpt=	n}', "");
    Expect(0, 65379, '\p{Bpt=	n}', "");
    Expect(1, 65379, '\p{^Bpt=	n}', "");
    Expect(1, 65379, '\P{Bpt=	n}', "");
    Expect(0, 65379, '\P{^Bpt=	n}', "");
    Error('\p{Is_Bidi_Paired_Bracket_Type=/a/_ NONE}');
    Error('\P{Is_Bidi_Paired_Bracket_Type=/a/_ NONE}');
    Expect(1, 65380, '\p{Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65380, '\p{^Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65380, '\P{Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65380, '\P{^Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65379, '\p{Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65379, '\p{^Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65379, '\P{Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(0, 65379, '\P{^Is_Bidi_Paired_Bracket_Type=none}', "");
    Expect(1, 65380, '\p{Is_Bidi_Paired_Bracket_Type=-None}', "");
    Expect(0, 65380, '\p{^Is_Bidi_Paired_Bracket_Type=-None}', "");
    Expect(0, 65380, '\P{Is_Bidi_Paired_Bracket_Type=-None}', "");
    Expect(1, 65380, '\P{^Is_Bidi_Paired_Bracket_Type=-None}', "");
    Expect(0, 65379, '\p{Is_Bidi_Paired_Bracket_Type=-None}', "");
    Expect(1, 65379, '\p{^Is_Bidi_Paired_Bracket_Type=-None}', "");
    Expect(1, 65379, '\P{Is_Bidi_Paired_Bracket_Type=-None}', "");
    Expect(0, 65379, '\P{^Is_Bidi_Paired_Bracket_Type=-None}', "");
    Error('\p{Is_Bpt=_ N/a/}');
    Error('\P{Is_Bpt=_ N/a/}');
    Expect(1, 65380, '\p{Is_Bpt=n}', "");
    Expect(0, 65380, '\p{^Is_Bpt=n}', "");
    Expect(0, 65380, '\P{Is_Bpt=n}', "");
    Expect(1, 65380, '\P{^Is_Bpt=n}', "");
    Expect(0, 65379, '\p{Is_Bpt=n}', "");
    Expect(1, 65379, '\p{^Is_Bpt=n}', "");
    Expect(1, 65379, '\P{Is_Bpt=n}', "");
    Expect(0, 65379, '\P{^Is_Bpt=n}', "");
    Expect(1, 65380, '\p{Is_Bpt=-_N}', "");
    Expect(0, 65380, '\p{^Is_Bpt=-_N}', "");
    Expect(0, 65380, '\P{Is_Bpt=-_N}', "");
    Expect(1, 65380, '\P{^Is_Bpt=-_N}', "");
    Expect(0, 65379, '\p{Is_Bpt=-_N}', "");
    Expect(1, 65379, '\p{^Is_Bpt=-_N}', "");
    Expect(1, 65379, '\P{Is_Bpt=-_N}', "");
    Expect(0, 65379, '\P{^Is_Bpt=-_N}', "");
    Error('\p{Bidi_Paired_Bracket_Type=	_OPEN:=}');
    Error('\P{Bidi_Paired_Bracket_Type=	_OPEN:=}');
    Expect(1, 65378, '\p{Bidi_Paired_Bracket_Type=:\AOpen\z:}', "");;
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type=:\AOpen\z:}', "");;
    Expect(1, 65378, '\p{Bidi_Paired_Bracket_Type=open}', "");
    Expect(0, 65378, '\p{^Bidi_Paired_Bracket_Type=open}', "");
    Expect(0, 65378, '\P{Bidi_Paired_Bracket_Type=open}', "");
    Expect(1, 65378, '\P{^Bidi_Paired_Bracket_Type=open}', "");
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type=open}', "");
    Expect(1, 65379, '\p{^Bidi_Paired_Bracket_Type=open}', "");
    Expect(1, 65379, '\P{Bidi_Paired_Bracket_Type=open}', "");
    Expect(0, 65379, '\P{^Bidi_Paired_Bracket_Type=open}', "");
    Expect(1, 65378, '\p{Bidi_Paired_Bracket_Type=:\Aopen\z:}', "");;
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type=:\Aopen\z:}', "");;
    Expect(1, 65378, '\p{Bidi_Paired_Bracket_Type=  open}', "");
    Expect(0, 65378, '\p{^Bidi_Paired_Bracket_Type=  open}', "");
    Expect(0, 65378, '\P{Bidi_Paired_Bracket_Type=  open}', "");
    Expect(1, 65378, '\P{^Bidi_Paired_Bracket_Type=  open}', "");
    Expect(0, 65379, '\p{Bidi_Paired_Bracket_Type=  open}', "");
    Expect(1, 65379, '\p{^Bidi_Paired_Bracket_Type=  open}', "");
    Expect(1, 65379, '\P{Bidi_Paired_Bracket_Type=  open}', "");
    Expect(0, 65379, '\P{^Bidi_Paired_Bracket_Type=  open}', "");
    Error('\p{Bpt=	O:=}');
    Error('\P{Bpt=	O:=}');
    Expect(1, 65378, '\p{Bpt=:\AO\z:}', "");;
    Expect(0, 65379, '\p{Bpt=:\AO\z:}', "");;
    Expect(1, 65378, '\p{Bpt=o}', "");
    Expect(0, 65378, '\p{^Bpt=o}', "");
    Expect(0, 65378, '\P{Bpt=o}', "");
    Expect(1, 65378, '\P{^Bpt=o}', "");
    Expect(0, 65379, '\p{Bpt=o}', "");
    Expect(1, 65379, '\p{^Bpt=o}', "");
    Expect(1, 65379, '\P{Bpt=o}', "");
    Expect(0, 65379, '\P{^Bpt=o}', "");
    Expect(1, 65378, '\p{Bpt=:\Ao\z:}', "");;
    Expect(0, 65379, '\p{Bpt=:\Ao\z:}', "");;
    Expect(1, 65378, '\p{Bpt=_ O}', "");
    Expect(0, 65378, '\p{^Bpt=_ O}', "");
    Expect(0, 65378, '\P{Bpt=_ O}', "");
    Expect(1, 65378, '\P{^Bpt=_ O}', "");
    Expect(0, 65379, '\p{Bpt=_ O}', "");
    Expect(1, 65379, '\p{^Bpt=_ O}', "");
    Expect(1, 65379, '\P{Bpt=_ O}', "");
    Expect(0, 65379, '\P{^Bpt=_ O}', "");
    Error('\p{Is_Bidi_Paired_Bracket_Type=:= OPEN}');
    Error('\P{Is_Bidi_Paired_Bracket_Type=:= OPEN}');
    Expect(1, 65378, '\p{Is_Bidi_Paired_Bracket_Type=open}', "");
    Expect(0, 65378, '\p{^Is_Bidi_Paired_Bracket_Type=open}', "");
    Expect(0, 65378, '\P{Is_Bidi_Paired_Bracket_Type=open}', "");
    Expect(1, 65378, '\P{^Is_Bidi_Paired_Bracket_Type=open}', "");
    Expect(0, 65379, '\p{Is_Bidi_Paired_Bracket_Type=open}', "");
    Expect(1, 65379, '\p{^Is_Bidi_Paired_Bracket_Type=open}', "");
    Expect(1, 65379, '\P{Is_Bidi_Paired_Bracket_Type=open}', "");
    Expect(0, 65379, '\P{^Is_Bidi_Paired_Bracket_Type=open}', "");
    Expect(1, 65378, '\p{Is_Bidi_Paired_Bracket_Type=-	open}', "");
    Expect(0, 65378, '\p{^Is_Bidi_Paired_Bracket_Type=-	open}', "");
    Expect(0, 65378, '\P{Is_Bidi_Paired_Bracket_Type=-	open}', "");
    Expect(1, 65378, '\P{^Is_Bidi_Paired_Bracket_Type=-	open}', "");
    Expect(0, 65379, '\p{Is_Bidi_Paired_Bracket_Type=-	open}', "");
    Expect(1, 65379, '\p{^Is_Bidi_Paired_Bracket_Type=-	open}', "");
    Expect(1, 65379, '\P{Is_Bidi_Paired_Bracket_Type=-	open}', "");
    Expect(0, 65379, '\P{^Is_Bidi_Paired_Bracket_Type=-	open}', "");
    Error('\p{Is_Bpt=	:=O}');
    Error('\P{Is_Bpt=	:=O}');
    Expect(1, 65378, '\p{Is_Bpt=o}', "");
    Expect(0, 65378, '\p{^Is_Bpt=o}', "");
    Expect(0, 65378, '\P{Is_Bpt=o}', "");
    Expect(1, 65378, '\P{^Is_Bpt=o}', "");
    Expect(0, 65379, '\p{Is_Bpt=o}', "");
    Expect(1, 65379, '\p{^Is_Bpt=o}', "");
    Expect(1, 65379, '\P{Is_Bpt=o}', "");
    Expect(0, 65379, '\P{^Is_Bpt=o}', "");
    Expect(1, 65378, '\p{Is_Bpt=-o}', "");
    Expect(0, 65378, '\p{^Is_Bpt=-o}', "");
    Expect(0, 65378, '\P{Is_Bpt=-o}', "");
    Expect(1, 65378, '\P{^Is_Bpt=-o}', "");
    Expect(0, 65379, '\p{Is_Bpt=-o}', "");
    Expect(1, 65379, '\p{^Is_Bpt=-o}', "");
    Expect(1, 65379, '\P{Is_Bpt=-o}', "");
    Expect(0, 65379, '\P{^Is_Bpt=-o}', "");
    Error('\p{Cased::=--NO}');
    Error('\P{Cased::=--NO}');
    Expect(1, 127370, '\p{Cased=:\ANo\z:}', "");;
    Expect(0, 127369, '\p{Cased=:\ANo\z:}', "");;
    Expect(1, 127370, '\p{Cased=no}', "");
    Expect(0, 127370, '\p{^Cased=no}', "");
    Expect(0, 127370, '\P{Cased=no}', "");
    Expect(1, 127370, '\P{^Cased=no}', "");
    Expect(0, 127369, '\p{Cased=no}', "");
    Expect(1, 127369, '\p{^Cased=no}', "");
    Expect(1, 127369, '\P{Cased=no}', "");
    Expect(0, 127369, '\P{^Cased=no}', "");
    Expect(1, 127370, '\p{Cased=:\Ano\z:}', "");;
    Expect(0, 127369, '\p{Cased=:\Ano\z:}', "");;
    Expect(1, 127370, '\p{Cased=- No}', "");
    Expect(0, 127370, '\p{^Cased=- No}', "");
    Expect(0, 127370, '\P{Cased=- No}', "");
    Expect(1, 127370, '\P{^Cased=- No}', "");
    Expect(0, 127369, '\p{Cased=- No}', "");
    Expect(1, 127369, '\p{^Cased=- No}', "");
    Expect(1, 127369, '\P{Cased=- No}', "");
    Expect(0, 127369, '\P{^Cased=- No}', "");
    Error('\p{Is_Cased= N:=}');
    Error('\P{Is_Cased= N:=}');
    Expect(1, 127370, '\p{Is_Cased=n}', "");
    Expect(0, 127370, '\p{^Is_Cased=n}', "");
    Expect(0, 127370, '\P{Is_Cased=n}', "");
    Expect(1, 127370, '\P{^Is_Cased=n}', "");
    Expect(0, 127369, '\p{Is_Cased=n}', "");
    Expect(1, 127369, '\p{^Is_Cased=n}', "");
    Expect(1, 127369, '\P{Is_Cased=n}', "");
    Expect(0, 127369, '\P{^Is_Cased=n}', "");
    Expect(1, 127370, '\p{Is_Cased:	 -N}', "");
    Expect(0, 127370, '\p{^Is_Cased:	 -N}', "");
    Expect(0, 127370, '\P{Is_Cased:	 -N}', "");
    Expect(1, 127370, '\P{^Is_Cased:	 -N}', "");
    Expect(0, 127369, '\p{Is_Cased:	 -N}', "");
    Expect(1, 127369, '\p{^Is_Cased:	 -N}', "");
    Expect(1, 127369, '\P{Is_Cased:	 -N}', "");
    Expect(0, 127369, '\P{^Is_Cased:	 -N}', "");
    Error('\p{Cased=/a/F}');
    Error('\P{Cased=/a/F}');
    Expect(1, 127370, '\p{Cased=:\AF\z:}', "");;
    Expect(0, 127369, '\p{Cased=:\AF\z:}', "");;
    Expect(1, 127370, '\p{Cased=f}', "");
    Expect(0, 127370, '\p{^Cased=f}', "");
    Expect(0, 127370, '\P{Cased=f}', "");
    Expect(1, 127370, '\P{^Cased=f}', "");
    Expect(0, 127369, '\p{Cased=f}', "");
    Expect(1, 127369, '\p{^Cased=f}', "");
    Expect(1, 127369, '\P{Cased=f}', "");
    Expect(0, 127369, '\P{^Cased=f}', "");
    Expect(1, 127370, '\p{Cased=:\Af\z:}', "");;
    Expect(0, 127369, '\p{Cased=:\Af\z:}', "");;
    Expect(1, 127370, '\p{Cased= F}', "");
    Expect(0, 127370, '\p{^Cased= F}', "");
    Expect(0, 127370, '\P{Cased= F}', "");
    Expect(1, 127370, '\P{^Cased= F}', "");
    Expect(0, 127369, '\p{Cased= F}', "");
    Expect(1, 127369, '\p{^Cased= F}', "");
    Expect(1, 127369, '\P{Cased= F}', "");
    Expect(0, 127369, '\P{^Cased= F}', "");
    Error('\p{Is_Cased=	 FALSE/a/}');
    Error('\P{Is_Cased=	 FALSE/a/}');
    Expect(1, 127370, '\p{Is_Cased=false}', "");
    Expect(0, 127370, '\p{^Is_Cased=false}', "");
    Expect(0, 127370, '\P{Is_Cased=false}', "");
    Expect(1, 127370, '\P{^Is_Cased=false}', "");
    Expect(0, 127369, '\p{Is_Cased=false}', "");
    Expect(1, 127369, '\p{^Is_Cased=false}', "");
    Expect(1, 127369, '\P{Is_Cased=false}', "");
    Expect(0, 127369, '\P{^Is_Cased=false}', "");
    Expect(1, 127370, '\p{Is_Cased=_False}', "");
    Expect(0, 127370, '\p{^Is_Cased=_False}', "");
    Expect(0, 127370, '\P{Is_Cased=_False}', "");
    Expect(1, 127370, '\P{^Is_Cased=_False}', "");
    Expect(0, 127369, '\p{Is_Cased=_False}', "");
    Expect(1, 127369, '\p{^Is_Cased=_False}', "");
    Expect(1, 127369, '\P{Is_Cased=_False}', "");
    Expect(0, 127369, '\P{^Is_Cased=_False}', "");
    Error('\p{Cased=:=YES}');
    Error('\P{Cased=:=YES}');
    Expect(1, 127369, '\p{Cased=:\AYes\z:}', "");;
    Expect(0, 127370, '\p{Cased=:\AYes\z:}', "");;
    Expect(1, 127369, '\p{Cased=yes}', "");
    Expect(0, 127369, '\p{^Cased=yes}', "");
    Expect(0, 127369, '\P{Cased=yes}', "");
    Expect(1, 127369, '\P{^Cased=yes}', "");
    Expect(0, 127370, '\p{Cased=yes}', "");
    Expect(1, 127370, '\p{^Cased=yes}', "");
    Expect(1, 127370, '\P{Cased=yes}', "");
    Expect(0, 127370, '\P{^Cased=yes}', "");
    Expect(1, 127369, '\p{Cased=:\Ayes\z:}', "");;
    Expect(0, 127370, '\p{Cased=:\Ayes\z:}', "");;
    Expect(1, 127369, '\p{Cased= yes}', "");
    Expect(0, 127369, '\p{^Cased= yes}', "");
    Expect(0, 127369, '\P{Cased= yes}', "");
    Expect(1, 127369, '\P{^Cased= yes}', "");
    Expect(0, 127370, '\p{Cased= yes}', "");
    Expect(1, 127370, '\p{^Cased= yes}', "");
    Expect(1, 127370, '\P{Cased= yes}', "");
    Expect(0, 127370, '\P{^Cased= yes}', "");
    Error('\p{Is_Cased=--Y/a/}');
    Error('\P{Is_Cased=--Y/a/}');
    Expect(1, 127369, '\p{Is_Cased=y}', "");
    Expect(0, 127369, '\p{^Is_Cased=y}', "");
    Expect(0, 127369, '\P{Is_Cased=y}', "");
    Expect(1, 127369, '\P{^Is_Cased=y}', "");
    Expect(0, 127370, '\p{Is_Cased=y}', "");
    Expect(1, 127370, '\p{^Is_Cased=y}', "");
    Expect(1, 127370, '\P{Is_Cased=y}', "");
    Expect(0, 127370, '\P{^Is_Cased=y}', "");
    Expect(1, 127369, '\p{Is_Cased=_-Y}', "");
    Expect(0, 127369, '\p{^Is_Cased=_-Y}', "");
    Expect(0, 127369, '\P{Is_Cased=_-Y}', "");
    Expect(1, 127369, '\P{^Is_Cased=_-Y}', "");
    Expect(0, 127370, '\p{Is_Cased=_-Y}', "");
    Expect(1, 127370, '\p{^Is_Cased=_-Y}', "");
    Expect(1, 127370, '\P{Is_Cased=_-Y}', "");
    Expect(0, 127370, '\P{^Is_Cased=_-Y}', "");
    Error('\p{Cased=:=  T}');
    Error('\P{Cased=:=  T}');
    Expect(1, 127369, '\p{Cased=:\AT\z:}', "");;
    Expect(0, 127370, '\p{Cased=:\AT\z:}', "");;
    Expect(1, 127369, '\p{Cased=t}', "");
    Expect(0, 127369, '\p{^Cased=t}', "");
    Expect(0, 127369, '\P{Cased=t}', "");
    Expect(1, 127369, '\P{^Cased=t}', "");
    Expect(0, 127370, '\p{Cased=t}', "");
    Expect(1, 127370, '\p{^Cased=t}', "");
    Expect(1, 127370, '\P{Cased=t}', "");
    Expect(0, 127370, '\P{^Cased=t}', "");
    Expect(1, 127369, '\p{Cased=:\At\z:}', "");;
    Expect(0, 127370, '\p{Cased=:\At\z:}', "");;
    Expect(1, 127369, '\p{Cased=-_T}', "");
    Expect(0, 127369, '\p{^Cased=-_T}', "");
    Expect(0, 127369, '\P{Cased=-_T}', "");
    Expect(1, 127369, '\P{^Cased=-_T}', "");
    Expect(0, 127370, '\p{Cased=-_T}', "");
    Expect(1, 127370, '\p{^Cased=-_T}', "");
    Expect(1, 127370, '\P{Cased=-_T}', "");
    Expect(0, 127370, '\P{^Cased=-_T}', "");
    Error('\p{Is_Cased=-/a/True}');
    Error('\P{Is_Cased=-/a/True}');
    Expect(1, 127369, '\p{Is_Cased=true}', "");
    Expect(0, 127369, '\p{^Is_Cased=true}', "");
    Expect(0, 127369, '\P{Is_Cased=true}', "");
    Expect(1, 127369, '\P{^Is_Cased=true}', "");
    Expect(0, 127370, '\p{Is_Cased=true}', "");
    Expect(1, 127370, '\p{^Is_Cased=true}', "");
    Expect(1, 127370, '\P{Is_Cased=true}', "");
    Expect(0, 127370, '\P{^Is_Cased=true}', "");
    Expect(1, 127369, '\p{Is_Cased=	 True}', "");
    Expect(0, 127369, '\p{^Is_Cased=	 True}', "");
    Expect(0, 127369, '\P{Is_Cased=	 True}', "");
    Expect(1, 127369, '\P{^Is_Cased=	 True}', "");
    Expect(0, 127370, '\p{Is_Cased=	 True}', "");
    Expect(1, 127370, '\p{^Is_Cased=	 True}', "");
    Expect(1, 127370, '\P{Is_Cased=	 True}', "");
    Expect(0, 127370, '\P{^Is_Cased=	 True}', "");
    Error('\p{canonicalcombiningclass}');
    Error('\P{canonicalcombiningclass}');
    Error('\p{ccc}');
    Error('\P{ccc}');
    Error('\p{Canonical_Combining_Class=_-above:=}');
    Error('\P{Canonical_Combining_Class=_-above:=}');
    Expect(1, 125257, '\p{Canonical_Combining_Class=:\AAbove\z:}', "");;
    Expect(0, 125258, '\p{Canonical_Combining_Class=:\AAbove\z:}', "");;
    Expect(1, 125257, '\p{Canonical_Combining_Class=above}', "");
    Expect(0, 125257, '\p{^Canonical_Combining_Class=above}', "");
    Expect(0, 125257, '\P{Canonical_Combining_Class=above}', "");
    Expect(1, 125257, '\P{^Canonical_Combining_Class=above}', "");
    Expect(0, 125258, '\p{Canonical_Combining_Class=above}', "");
    Expect(1, 125258, '\p{^Canonical_Combining_Class=above}', "");
    Expect(1, 125258, '\P{Canonical_Combining_Class=above}', "");
    Expect(0, 125258, '\P{^Canonical_Combining_Class=above}', "");
    Expect(1, 125257, '\p{Canonical_Combining_Class=:\Aabove\z:}', "");;
    Expect(0, 125258, '\p{Canonical_Combining_Class=:\Aabove\z:}', "");;
    Expect(1, 125257, '\p{Canonical_Combining_Class: 	ABOVE}', "");
    Expect(0, 125257, '\p{^Canonical_Combining_Class: 	ABOVE}', "");
    Expect(0, 125257, '\P{Canonical_Combining_Class: 	ABOVE}', "");
    Expect(1, 125257, '\P{^Canonical_Combining_Class: 	ABOVE}', "");
    Expect(0, 125258, '\p{Canonical_Combining_Class: 	ABOVE}', "");
    Expect(1, 125258, '\p{^Canonical_Combining_Class: 	ABOVE}', "");
    Expect(1, 125258, '\P{Canonical_Combining_Class: 	ABOVE}', "");
    Expect(0, 125258, '\P{^Canonical_Combining_Class: 	ABOVE}', "");
    Error('\p{Ccc=/a/- a}');
    Error('\P{Ccc=/a/- a}');
    Expect(1, 125257, '\p{Ccc=:\AA\z:}', "");;
    Expect(0, 125258, '\p{Ccc=:\AA\z:}', "");;
    Expect(1, 125257, '\p{Ccc=a}', "");
    Expect(0, 125257, '\p{^Ccc=a}', "");
    Expect(0, 125257, '\P{Ccc=a}', "");
    Expect(1, 125257, '\P{^Ccc=a}', "");
    Expect(0, 125258, '\p{Ccc=a}', "");
    Expect(1, 125258, '\p{^Ccc=a}', "");
    Expect(1, 125258, '\P{Ccc=a}', "");
    Expect(0, 125258, '\P{^Ccc=a}', "");
    Expect(1, 125257, '\p{Ccc=:\Aa\z:}', "");;
    Expect(0, 125258, '\p{Ccc=:\Aa\z:}', "");;
    Expect(1, 125257, '\p{Ccc= -A}', "");
    Expect(0, 125257, '\p{^Ccc= -A}', "");
    Expect(0, 125257, '\P{Ccc= -A}', "");
    Expect(1, 125257, '\P{^Ccc= -A}', "");
    Expect(0, 125258, '\p{Ccc= -A}', "");
    Expect(1, 125258, '\p{^Ccc= -A}', "");
    Expect(1, 125258, '\P{Ccc= -A}', "");
    Expect(0, 125258, '\P{^Ccc= -A}', "");
    Error('\p{Is_Canonical_Combining_Class=_/a/00000000230}');
    Error('\P{Is_Canonical_Combining_Class=_/a/00000000230}');
    Expect(1, 125257, '\p{Is_Canonical_Combining_Class=0_0_0_0_2_30}', "");
    Expect(0, 125257, '\p{^Is_Canonical_Combining_Class=0_0_0_0_2_30}', "");
    Expect(0, 125257, '\P{Is_Canonical_Combining_Class=0_0_0_0_2_30}', "");
    Expect(1, 125257, '\P{^Is_Canonical_Combining_Class=0_0_0_0_2_30}', "");
    Expect(0, 125258, '\p{Is_Canonical_Combining_Class=0_0_0_0_2_30}', "");
    Expect(1, 125258, '\p{^Is_Canonical_Combining_Class=0_0_0_0_2_30}', "");
    Expect(1, 125258, '\P{Is_Canonical_Combining_Class=0_0_0_0_2_30}', "");
    Expect(0, 125258, '\P{^Is_Canonical_Combining_Class=0_0_0_0_2_30}', "");
    Error('\p{Is_Ccc=	-Above/a/}');
    Error('\P{Is_Ccc=	-Above/a/}');
    Expect(1, 125257, '\p{Is_Ccc=above}', "");
    Expect(0, 125257, '\p{^Is_Ccc=above}', "");
    Expect(0, 125257, '\P{Is_Ccc=above}', "");
    Expect(1, 125257, '\P{^Is_Ccc=above}', "");
    Expect(0, 125258, '\p{Is_Ccc=above}', "");
    Expect(1, 125258, '\p{^Is_Ccc=above}', "");
    Expect(1, 125258, '\P{Is_Ccc=above}', "");
    Expect(0, 125258, '\P{^Is_Ccc=above}', "");
    Expect(1, 125257, '\p{Is_Ccc=	 above}', "");
    Expect(0, 125257, '\p{^Is_Ccc=	 above}', "");
    Expect(0, 125257, '\P{Is_Ccc=	 above}', "");
    Expect(1, 125257, '\P{^Is_Ccc=	 above}', "");
    Expect(0, 125258, '\p{Is_Ccc=	 above}', "");
    Expect(1, 125258, '\p{^Is_Ccc=	 above}', "");
    Expect(1, 125258, '\P{Is_Ccc=	 above}', "");
    Expect(0, 125258, '\P{^Is_Ccc=	 above}', "");
    Error('\p{Canonical_Combining_Class= :=ABOVE_left}');
    Error('\P{Canonical_Combining_Class= :=ABOVE_left}');
    Expect(1, 12331, '\p{Canonical_Combining_Class=:\AAbove_Left\z:}', "");;
    Expect(0, 12332, '\p{Canonical_Combining_Class=:\AAbove_Left\z:}', "");;
    Expect(1, 12331, '\p{Canonical_Combining_Class=aboveleft}', "");
    Expect(0, 12331, '\p{^Canonical_Combining_Class=aboveleft}', "");
    Expect(0, 12331, '\P{Canonical_Combining_Class=aboveleft}', "");
    Expect(1, 12331, '\P{^Canonical_Combining_Class=aboveleft}', "");
    Expect(0, 12332, '\p{Canonical_Combining_Class=aboveleft}', "");
    Expect(1, 12332, '\p{^Canonical_Combining_Class=aboveleft}', "");
    Expect(1, 12332, '\P{Canonical_Combining_Class=aboveleft}', "");
    Expect(0, 12332, '\P{^Canonical_Combining_Class=aboveleft}', "");
    Expect(1, 12331, '\p{Canonical_Combining_Class=:\Aaboveleft\z:}', "");;
    Expect(0, 12332, '\p{Canonical_Combining_Class=:\Aaboveleft\z:}', "");;
    Expect(1, 12331, '\p{Canonical_Combining_Class=-above_Left}', "");
    Expect(0, 12331, '\p{^Canonical_Combining_Class=-above_Left}', "");
    Expect(0, 12331, '\P{Canonical_Combining_Class=-above_Left}', "");
    Expect(1, 12331, '\P{^Canonical_Combining_Class=-above_Left}', "");
    Expect(0, 12332, '\p{Canonical_Combining_Class=-above_Left}', "");
    Expect(1, 12332, '\p{^Canonical_Combining_Class=-above_Left}', "");
    Expect(1, 12332, '\P{Canonical_Combining_Class=-above_Left}', "");
    Expect(0, 12332, '\P{^Canonical_Combining_Class=-above_Left}', "");
    Error('\p{Ccc=--AL:=}');
    Error('\P{Ccc=--AL:=}');
    Expect(1, 12331, '\p{Ccc=:\AAL\z:}', "");;
    Expect(0, 12332, '\p{Ccc=:\AAL\z:}', "");;
    Expect(1, 12331, '\p{Ccc=al}', "");
    Expect(0, 12331, '\p{^Ccc=al}', "");
    Expect(0, 12331, '\P{Ccc=al}', "");
    Expect(1, 12331, '\P{^Ccc=al}', "");
    Expect(0, 12332, '\p{Ccc=al}', "");
    Expect(1, 12332, '\p{^Ccc=al}', "");
    Expect(1, 12332, '\P{Ccc=al}', "");
    Expect(0, 12332, '\P{^Ccc=al}', "");
    Expect(1, 12331, '\p{Ccc=:\Aal\z:}', "");;
    Expect(0, 12332, '\p{Ccc=:\Aal\z:}', "");;
    Expect(1, 12331, '\p{Ccc=-al}', "");
    Expect(0, 12331, '\p{^Ccc=-al}', "");
    Expect(0, 12331, '\P{Ccc=-al}', "");
    Expect(1, 12331, '\P{^Ccc=-al}', "");
    Expect(0, 12332, '\p{Ccc=-al}', "");
    Expect(1, 12332, '\p{^Ccc=-al}', "");
    Expect(1, 12332, '\P{Ccc=-al}', "");
    Expect(0, 12332, '\P{^Ccc=-al}', "");
    Error('\p{Is_Canonical_Combining_Class= +22_8/a/}');
    Error('\P{Is_Canonical_Combining_Class= +22_8/a/}');
    Expect(1, 12331, '\p{Is_Canonical_Combining_Class=00228}', "");
    Expect(0, 12331, '\p{^Is_Canonical_Combining_Class=00228}', "");
    Expect(0, 12331, '\P{Is_Canonical_Combining_Class=00228}', "");
    Expect(1, 12331, '\P{^Is_Canonical_Combining_Class=00228}', "");
    Expect(0, 12332, '\p{Is_Canonical_Combining_Class=00228}', "");
    Expect(1, 12332, '\p{^Is_Canonical_Combining_Class=00228}', "");
    Expect(1, 12332, '\P{Is_Canonical_Combining_Class=00228}', "");
    Expect(0, 12332, '\P{^Is_Canonical_Combining_Class=00228}', "");
    Error('\p{Is_Ccc=-:=above_Left}');
    Error('\P{Is_Ccc=-:=above_Left}');
    Expect(1, 12331, '\p{Is_Ccc=aboveleft}', "");
    Expect(0, 12331, '\p{^Is_Ccc=aboveleft}', "");
    Expect(0, 12331, '\P{Is_Ccc=aboveleft}', "");
    Expect(1, 12331, '\P{^Is_Ccc=aboveleft}', "");
    Expect(0, 12332, '\p{Is_Ccc=aboveleft}', "");
    Expect(1, 12332, '\p{^Is_Ccc=aboveleft}', "");
    Expect(1, 12332, '\P{Is_Ccc=aboveleft}', "");
    Expect(0, 12332, '\P{^Is_Ccc=aboveleft}', "");
    Expect(1, 12331, '\p{Is_Ccc=		Above_Left}', "");
    Expect(0, 12331, '\p{^Is_Ccc=		Above_Left}', "");
    Expect(0, 12331, '\P{Is_Ccc=		Above_Left}', "");
    Expect(1, 12331, '\P{^Is_Ccc=		Above_Left}', "");
    Expect(0, 12332, '\p{Is_Ccc=		Above_Left}', "");
    Expect(1, 12332, '\p{^Is_Ccc=		Above_Left}', "");
    Expect(1, 12332, '\P{Is_Ccc=		Above_Left}', "");
    Expect(0, 12332, '\P{^Is_Ccc=		Above_Left}', "");
    Error('\p{Canonical_Combining_Class:   :=	_Above_RIGHT}');
    Error('\P{Canonical_Combining_Class:   :=	_Above_RIGHT}');
    Expect(1, 12332, '\p{Canonical_Combining_Class=:\AAbove_Right\z:}', "");;
    Expect(0, 12333, '\p{Canonical_Combining_Class=:\AAbove_Right\z:}', "");;
    Expect(1, 12332, '\p{Canonical_Combining_Class=aboveright}', "");
    Expect(0, 12332, '\p{^Canonical_Combining_Class=aboveright}', "");
    Expect(0, 12332, '\P{Canonical_Combining_Class=aboveright}', "");
    Expect(1, 12332, '\P{^Canonical_Combining_Class=aboveright}', "");
    Expect(0, 12333, '\p{Canonical_Combining_Class=aboveright}', "");
    Expect(1, 12333, '\p{^Canonical_Combining_Class=aboveright}', "");
    Expect(1, 12333, '\P{Canonical_Combining_Class=aboveright}', "");
    Expect(0, 12333, '\P{^Canonical_Combining_Class=aboveright}', "");
    Expect(1, 12332, '\p{Canonical_Combining_Class=:\Aaboveright\z:}', "");;
    Expect(0, 12333, '\p{Canonical_Combining_Class=:\Aaboveright\z:}', "");;
    Expect(1, 12332, '\p{Canonical_Combining_Class=	ABOVE_Right}', "");
    Expect(0, 12332, '\p{^Canonical_Combining_Class=	ABOVE_Right}', "");
    Expect(0, 12332, '\P{Canonical_Combining_Class=	ABOVE_Right}', "");
    Expect(1, 12332, '\P{^Canonical_Combining_Class=	ABOVE_Right}', "");
    Expect(0, 12333, '\p{Canonical_Combining_Class=	ABOVE_Right}', "");
    Expect(1, 12333, '\p{^Canonical_Combining_Class=	ABOVE_Right}', "");
    Expect(1, 12333, '\P{Canonical_Combining_Class=	ABOVE_Right}', "");
    Expect(0, 12333, '\P{^Canonical_Combining_Class=	ABOVE_Right}', "");
    Error('\p{Ccc=-:=AR}');
    Error('\P{Ccc=-:=AR}');
    Expect(1, 12332, '\p{Ccc=:\AAR\z:}', "");;
    Expect(0, 12333, '\p{Ccc=:\AAR\z:}', "");;
    Expect(1, 12332, '\p{Ccc=ar}', "");
    Expect(0, 12332, '\p{^Ccc=ar}', "");
    Expect(0, 12332, '\P{Ccc=ar}', "");
    Expect(1, 12332, '\P{^Ccc=ar}', "");
    Expect(0, 12333, '\p{Ccc=ar}', "");
    Expect(1, 12333, '\p{^Ccc=ar}', "");
    Expect(1, 12333, '\P{Ccc=ar}', "");
    Expect(0, 12333, '\P{^Ccc=ar}', "");
    Expect(1, 12332, '\p{Ccc=:\Aar\z:}', "");;
    Expect(0, 12333, '\p{Ccc=:\Aar\z:}', "");;
    Expect(1, 12332, '\p{Ccc=-	AR}', "");
    Expect(0, 12332, '\p{^Ccc=-	AR}', "");
    Expect(0, 12332, '\P{Ccc=-	AR}', "");
    Expect(1, 12332, '\P{^Ccc=-	AR}', "");
    Expect(0, 12333, '\p{Ccc=-	AR}', "");
    Expect(1, 12333, '\p{^Ccc=-	AR}', "");
    Expect(1, 12333, '\P{Ccc=-	AR}', "");
    Expect(0, 12333, '\P{^Ccc=-	AR}', "");
    Error('\p{Is_Canonical_Combining_Class=	_00_00_02_32/a/}');
    Error('\P{Is_Canonical_Combining_Class=	_00_00_02_32/a/}');
    Expect(1, 12332, '\p{Is_Canonical_Combining_Class=0023_2}', "");
    Expect(0, 12332, '\p{^Is_Canonical_Combining_Class=0023_2}', "");
    Expect(0, 12332, '\P{Is_Canonical_Combining_Class=0023_2}', "");
    Expect(1, 12332, '\P{^Is_Canonical_Combining_Class=0023_2}', "");
    Expect(0, 12333, '\p{Is_Canonical_Combining_Class=0023_2}', "");
    Expect(1, 12333, '\p{^Is_Canonical_Combining_Class=0023_2}', "");
    Expect(1, 12333, '\P{Is_Canonical_Combining_Class=0023_2}', "");
    Expect(0, 12333, '\P{^Is_Canonical_Combining_Class=0023_2}', "");
    Error('\p{Is_Ccc=	_Above_right/a/}');
    Error('\P{Is_Ccc=	_Above_right/a/}');
    Expect(1, 12332, '\p{Is_Ccc=aboveright}', "");
    Expect(0, 12332, '\p{^Is_Ccc=aboveright}', "");
    Expect(0, 12332, '\P{Is_Ccc=aboveright}', "");
    Expect(1, 12332, '\P{^Is_Ccc=aboveright}', "");
    Expect(0, 12333, '\p{Is_Ccc=aboveright}', "");
    Expect(1, 12333, '\p{^Is_Ccc=aboveright}', "");
    Expect(1, 12333, '\P{Is_Ccc=aboveright}', "");
    Expect(0, 12333, '\P{^Is_Ccc=aboveright}', "");
    Expect(1, 12332, '\p{Is_Ccc=-Above_Right}', "");
    Expect(0, 12332, '\p{^Is_Ccc=-Above_Right}', "");
    Expect(0, 12332, '\P{Is_Ccc=-Above_Right}', "");
    Expect(1, 12332, '\P{^Is_Ccc=-Above_Right}', "");
    Expect(0, 12333, '\p{Is_Ccc=-Above_Right}', "");
    Expect(1, 12333, '\p{^Is_Ccc=-Above_Right}', "");
    Expect(1, 12333, '\P{Is_Ccc=-Above_Right}', "");
    Expect(0, 12333, '\P{^Is_Ccc=-Above_Right}', "");
    Error('\p{Canonical_Combining_Class=:=		Attached_ABOVE}');
    Error('\P{Canonical_Combining_Class=:=		Attached_ABOVE}');
    Expect(1, 7630, '\p{Canonical_Combining_Class=:\AAttached_Above\z:}', "");;
    Expect(0, 7631, '\p{Canonical_Combining_Class=:\AAttached_Above\z:}', "");;
    Expect(1, 7630, '\p{Canonical_Combining_Class=attachedabove}', "");
    Expect(0, 7630, '\p{^Canonical_Combining_Class=attachedabove}', "");
    Expect(0, 7630, '\P{Canonical_Combining_Class=attachedabove}', "");
    Expect(1, 7630, '\P{^Canonical_Combining_Class=attachedabove}', "");
    Expect(0, 7631, '\p{Canonical_Combining_Class=attachedabove}', "");
    Expect(1, 7631, '\p{^Canonical_Combining_Class=attachedabove}', "");
    Expect(1, 7631, '\P{Canonical_Combining_Class=attachedabove}', "");
    Expect(0, 7631, '\P{^Canonical_Combining_Class=attachedabove}', "");
    Expect(1, 7630, '\p{Canonical_Combining_Class=:\Aattachedabove\z:}', "");;
    Expect(0, 7631, '\p{Canonical_Combining_Class=:\Aattachedabove\z:}', "");;
    Expect(1, 7630, '\p{Canonical_Combining_Class= 	Attached_ABOVE}', "");
    Expect(0, 7630, '\p{^Canonical_Combining_Class= 	Attached_ABOVE}', "");
    Expect(0, 7630, '\P{Canonical_Combining_Class= 	Attached_ABOVE}', "");
    Expect(1, 7630, '\P{^Canonical_Combining_Class= 	Attached_ABOVE}', "");
    Expect(0, 7631, '\p{Canonical_Combining_Class= 	Attached_ABOVE}', "");
    Expect(1, 7631, '\p{^Canonical_Combining_Class= 	Attached_ABOVE}', "");
    Expect(1, 7631, '\P{Canonical_Combining_Class= 	Attached_ABOVE}', "");
    Expect(0, 7631, '\P{^Canonical_Combining_Class= 	Attached_ABOVE}', "");
    Error('\p{Ccc=:=		ATA}');
    Error('\P{Ccc=:=		ATA}');
    Expect(1, 7630, '\p{Ccc=:\AATA\z:}', "");;
    Expect(0, 7631, '\p{Ccc=:\AATA\z:}', "");;
    Expect(1, 7630, '\p{Ccc=ata}', "");
    Expect(0, 7630, '\p{^Ccc=ata}', "");
    Expect(0, 7630, '\P{Ccc=ata}', "");
    Expect(1, 7630, '\P{^Ccc=ata}', "");
    Expect(0, 7631, '\p{Ccc=ata}', "");
    Expect(1, 7631, '\p{^Ccc=ata}', "");
    Expect(1, 7631, '\P{Ccc=ata}', "");
    Expect(0, 7631, '\P{^Ccc=ata}', "");
    Expect(1, 7630, '\p{Ccc=:\Aata\z:}', "");;
    Expect(0, 7631, '\p{Ccc=:\Aata\z:}', "");;
    Expect(1, 7630, '\p{Ccc=__ATA}', "");
    Expect(0, 7630, '\p{^Ccc=__ATA}', "");
    Expect(0, 7630, '\P{Ccc=__ATA}', "");
    Expect(1, 7630, '\P{^Ccc=__ATA}', "");
    Expect(0, 7631, '\p{Ccc=__ATA}', "");
    Expect(1, 7631, '\p{^Ccc=__ATA}', "");
    Expect(1, 7631, '\P{Ccc=__ATA}', "");
    Expect(0, 7631, '\P{^Ccc=__ATA}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/	021_4}');
    Error('\P{Is_Canonical_Combining_Class=/a/	021_4}');
    Expect(1, 7630, '\p{Is_Canonical_Combining_Class=00_00_00_00_214}', "");
    Expect(0, 7630, '\p{^Is_Canonical_Combining_Class=00_00_00_00_214}', "");
    Expect(0, 7630, '\P{Is_Canonical_Combining_Class=00_00_00_00_214}', "");
    Expect(1, 7630, '\P{^Is_Canonical_Combining_Class=00_00_00_00_214}', "");
    Expect(0, 7631, '\p{Is_Canonical_Combining_Class=00_00_00_00_214}', "");
    Expect(1, 7631, '\p{^Is_Canonical_Combining_Class=00_00_00_00_214}', "");
    Expect(1, 7631, '\P{Is_Canonical_Combining_Class=00_00_00_00_214}', "");
    Expect(0, 7631, '\P{^Is_Canonical_Combining_Class=00_00_00_00_214}', "");
    Error('\p{Is_Ccc=-/a/Attached_Above}');
    Error('\P{Is_Ccc=-/a/Attached_Above}');
    Expect(1, 7630, '\p{Is_Ccc=attachedabove}', "");
    Expect(0, 7630, '\p{^Is_Ccc=attachedabove}', "");
    Expect(0, 7630, '\P{Is_Ccc=attachedabove}', "");
    Expect(1, 7630, '\P{^Is_Ccc=attachedabove}', "");
    Expect(0, 7631, '\p{Is_Ccc=attachedabove}', "");
    Expect(1, 7631, '\p{^Is_Ccc=attachedabove}', "");
    Expect(1, 7631, '\P{Is_Ccc=attachedabove}', "");
    Expect(0, 7631, '\P{^Is_Ccc=attachedabove}', "");
    Expect(1, 7630, '\p{Is_Ccc: -_attached_Above}', "");
    Expect(0, 7630, '\p{^Is_Ccc: -_attached_Above}', "");
    Expect(0, 7630, '\P{Is_Ccc: -_attached_Above}', "");
    Expect(1, 7630, '\P{^Is_Ccc: -_attached_Above}', "");
    Expect(0, 7631, '\p{Is_Ccc: -_attached_Above}', "");
    Expect(1, 7631, '\p{^Is_Ccc: -_attached_Above}', "");
    Expect(1, 7631, '\P{Is_Ccc: -_attached_Above}', "");
    Expect(0, 7631, '\P{^Is_Ccc: -_attached_Above}', "");
    Error('\p{Canonical_Combining_Class=:=--attached_Above_Right}');
    Error('\P{Canonical_Combining_Class=:=--attached_Above_Right}');
    Expect(1, 119154, '\p{Canonical_Combining_Class=:\AAttached_Above_Right\z:}', "");;
    Expect(0, 119155, '\p{Canonical_Combining_Class=:\AAttached_Above_Right\z:}', "");;
    Expect(1, 119154, '\p{Canonical_Combining_Class=attachedaboveright}', "");
    Expect(0, 119154, '\p{^Canonical_Combining_Class=attachedaboveright}', "");
    Expect(0, 119154, '\P{Canonical_Combining_Class=attachedaboveright}', "");
    Expect(1, 119154, '\P{^Canonical_Combining_Class=attachedaboveright}', "");
    Expect(0, 119155, '\p{Canonical_Combining_Class=attachedaboveright}', "");
    Expect(1, 119155, '\p{^Canonical_Combining_Class=attachedaboveright}', "");
    Expect(1, 119155, '\P{Canonical_Combining_Class=attachedaboveright}', "");
    Expect(0, 119155, '\P{^Canonical_Combining_Class=attachedaboveright}', "");
    Expect(1, 119154, '\p{Canonical_Combining_Class=:\Aattachedaboveright\z:}', "");;
    Expect(0, 119155, '\p{Canonical_Combining_Class=:\Aattachedaboveright\z:}', "");;
    Expect(1, 119154, '\p{Canonical_Combining_Class=-Attached_above_Right}', "");
    Expect(0, 119154, '\p{^Canonical_Combining_Class=-Attached_above_Right}', "");
    Expect(0, 119154, '\P{Canonical_Combining_Class=-Attached_above_Right}', "");
    Expect(1, 119154, '\P{^Canonical_Combining_Class=-Attached_above_Right}', "");
    Expect(0, 119155, '\p{Canonical_Combining_Class=-Attached_above_Right}', "");
    Expect(1, 119155, '\p{^Canonical_Combining_Class=-Attached_above_Right}', "");
    Expect(1, 119155, '\P{Canonical_Combining_Class=-Attached_above_Right}', "");
    Expect(0, 119155, '\P{^Canonical_Combining_Class=-Attached_above_Right}', "");
    Error('\p{Ccc= -ATAR:=}');
    Error('\P{Ccc= -ATAR:=}');
    Expect(1, 119154, '\p{Ccc=:\AATAR\z:}', "");;
    Expect(0, 119155, '\p{Ccc=:\AATAR\z:}', "");;
    Expect(1, 119154, '\p{Ccc=atar}', "");
    Expect(0, 119154, '\p{^Ccc=atar}', "");
    Expect(0, 119154, '\P{Ccc=atar}', "");
    Expect(1, 119154, '\P{^Ccc=atar}', "");
    Expect(0, 119155, '\p{Ccc=atar}', "");
    Expect(1, 119155, '\p{^Ccc=atar}', "");
    Expect(1, 119155, '\P{Ccc=atar}', "");
    Expect(0, 119155, '\P{^Ccc=atar}', "");
    Expect(1, 119154, '\p{Ccc=:\Aatar\z:}', "");;
    Expect(0, 119155, '\p{Ccc=:\Aatar\z:}', "");;
    Expect(1, 119154, '\p{Ccc=  ATAR}', "");
    Expect(0, 119154, '\p{^Ccc=  ATAR}', "");
    Expect(0, 119154, '\P{Ccc=  ATAR}', "");
    Expect(1, 119154, '\P{^Ccc=  ATAR}', "");
    Expect(0, 119155, '\p{Ccc=  ATAR}', "");
    Expect(1, 119155, '\p{^Ccc=  ATAR}', "");
    Expect(1, 119155, '\P{Ccc=  ATAR}', "");
    Expect(0, 119155, '\P{^Ccc=  ATAR}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/000000216}');
    Error('\P{Is_Canonical_Combining_Class=/a/000000216}');
    Expect(1, 119154, '\p{Is_Canonical_Combining_Class=000216}', "");
    Expect(0, 119154, '\p{^Is_Canonical_Combining_Class=000216}', "");
    Expect(0, 119154, '\P{Is_Canonical_Combining_Class=000216}', "");
    Expect(1, 119154, '\P{^Is_Canonical_Combining_Class=000216}', "");
    Expect(0, 119155, '\p{Is_Canonical_Combining_Class=000216}', "");
    Expect(1, 119155, '\p{^Is_Canonical_Combining_Class=000216}', "");
    Expect(1, 119155, '\P{Is_Canonical_Combining_Class=000216}', "");
    Expect(0, 119155, '\P{^Is_Canonical_Combining_Class=000216}', "");
    Error('\p{Is_Ccc=/a/--Attached_ABOVE_RIGHT}');
    Error('\P{Is_Ccc=/a/--Attached_ABOVE_RIGHT}');
    Expect(1, 119154, '\p{Is_Ccc=attachedaboveright}', "");
    Expect(0, 119154, '\p{^Is_Ccc=attachedaboveright}', "");
    Expect(0, 119154, '\P{Is_Ccc=attachedaboveright}', "");
    Expect(1, 119154, '\P{^Is_Ccc=attachedaboveright}', "");
    Expect(0, 119155, '\p{Is_Ccc=attachedaboveright}', "");
    Expect(1, 119155, '\p{^Is_Ccc=attachedaboveright}', "");
    Expect(1, 119155, '\P{Is_Ccc=attachedaboveright}', "");
    Expect(0, 119155, '\P{^Is_Ccc=attachedaboveright}', "");
    Expect(1, 119154, '\p{Is_Ccc=	Attached_Above_right}', "");
    Expect(0, 119154, '\p{^Is_Ccc=	Attached_Above_right}', "");
    Expect(0, 119154, '\P{Is_Ccc=	Attached_Above_right}', "");
    Expect(1, 119154, '\P{^Is_Ccc=	Attached_Above_right}', "");
    Expect(0, 119155, '\p{Is_Ccc=	Attached_Above_right}', "");
    Expect(1, 119155, '\p{^Is_Ccc=	Attached_Above_right}', "");
    Expect(1, 119155, '\P{Is_Ccc=	Attached_Above_right}', "");
    Expect(0, 119155, '\P{^Is_Ccc=	Attached_Above_right}', "");
    Error('\p{Canonical_Combining_Class=_ Attached_below/a/}');
    Error('\P{Canonical_Combining_Class=_ Attached_below/a/}');
    Expect(1, 7632, '\p{Canonical_Combining_Class=:\AAttached_Below\z:}', "");;
    Expect(0, 7633, '\p{Canonical_Combining_Class=:\AAttached_Below\z:}', "");;
    Expect(1, 7632, '\p{Canonical_Combining_Class=attachedbelow}', "");
    Expect(0, 7632, '\p{^Canonical_Combining_Class=attachedbelow}', "");
    Expect(0, 7632, '\P{Canonical_Combining_Class=attachedbelow}', "");
    Expect(1, 7632, '\P{^Canonical_Combining_Class=attachedbelow}', "");
    Expect(0, 7633, '\p{Canonical_Combining_Class=attachedbelow}', "");
    Expect(1, 7633, '\p{^Canonical_Combining_Class=attachedbelow}', "");
    Expect(1, 7633, '\P{Canonical_Combining_Class=attachedbelow}', "");
    Expect(0, 7633, '\P{^Canonical_Combining_Class=attachedbelow}', "");
    Expect(1, 7632, '\p{Canonical_Combining_Class=:\Aattachedbelow\z:}', "");;
    Expect(0, 7633, '\p{Canonical_Combining_Class=:\Aattachedbelow\z:}', "");;
    Expect(1, 7632, '\p{Canonical_Combining_Class=		attached_Below}', "");
    Expect(0, 7632, '\p{^Canonical_Combining_Class=		attached_Below}', "");
    Expect(0, 7632, '\P{Canonical_Combining_Class=		attached_Below}', "");
    Expect(1, 7632, '\P{^Canonical_Combining_Class=		attached_Below}', "");
    Expect(0, 7633, '\p{Canonical_Combining_Class=		attached_Below}', "");
    Expect(1, 7633, '\p{^Canonical_Combining_Class=		attached_Below}', "");
    Expect(1, 7633, '\P{Canonical_Combining_Class=		attached_Below}', "");
    Expect(0, 7633, '\P{^Canonical_Combining_Class=		attached_Below}', "");
    Error('\p{Ccc=_/a/ATB}');
    Error('\P{Ccc=_/a/ATB}');
    Expect(1, 7632, '\p{Ccc=:\AATB\z:}', "");;
    Expect(0, 7633, '\p{Ccc=:\AATB\z:}', "");;
    Expect(1, 7632, '\p{Ccc=atb}', "");
    Expect(0, 7632, '\p{^Ccc=atb}', "");
    Expect(0, 7632, '\P{Ccc=atb}', "");
    Expect(1, 7632, '\P{^Ccc=atb}', "");
    Expect(0, 7633, '\p{Ccc=atb}', "");
    Expect(1, 7633, '\p{^Ccc=atb}', "");
    Expect(1, 7633, '\P{Ccc=atb}', "");
    Expect(0, 7633, '\P{^Ccc=atb}', "");
    Expect(1, 7632, '\p{Ccc=:\Aatb\z:}', "");;
    Expect(0, 7633, '\p{Ccc=:\Aatb\z:}', "");;
    Expect(1, 7632, '\p{Ccc=	ATB}', "");
    Expect(0, 7632, '\p{^Ccc=	ATB}', "");
    Expect(0, 7632, '\P{Ccc=	ATB}', "");
    Expect(1, 7632, '\P{^Ccc=	ATB}', "");
    Expect(0, 7633, '\p{Ccc=	ATB}', "");
    Expect(1, 7633, '\p{^Ccc=	ATB}', "");
    Expect(1, 7633, '\P{Ccc=	ATB}', "");
    Expect(0, 7633, '\P{^Ccc=	ATB}', "");
    Error('\p{Is_Canonical_Combining_Class=_/a/0020_2}');
    Error('\P{Is_Canonical_Combining_Class=_/a/0020_2}');
    Expect(1, 7632, '\p{Is_Canonical_Combining_Class=0_0_0_0_0_0_202}', "");
    Expect(0, 7632, '\p{^Is_Canonical_Combining_Class=0_0_0_0_0_0_202}', "");
    Expect(0, 7632, '\P{Is_Canonical_Combining_Class=0_0_0_0_0_0_202}', "");
    Expect(1, 7632, '\P{^Is_Canonical_Combining_Class=0_0_0_0_0_0_202}', "");
    Expect(0, 7633, '\p{Is_Canonical_Combining_Class=0_0_0_0_0_0_202}', "");
    Expect(1, 7633, '\p{^Is_Canonical_Combining_Class=0_0_0_0_0_0_202}', "");
    Expect(1, 7633, '\P{Is_Canonical_Combining_Class=0_0_0_0_0_0_202}', "");
    Expect(0, 7633, '\P{^Is_Canonical_Combining_Class=0_0_0_0_0_0_202}', "");
    Error('\p{Is_Ccc=	attached_Below/a/}');
    Error('\P{Is_Ccc=	attached_Below/a/}');
    Expect(1, 7632, '\p{Is_Ccc=attachedbelow}', "");
    Expect(0, 7632, '\p{^Is_Ccc=attachedbelow}', "");
    Expect(0, 7632, '\P{Is_Ccc=attachedbelow}', "");
    Expect(1, 7632, '\P{^Is_Ccc=attachedbelow}', "");
    Expect(0, 7633, '\p{Is_Ccc=attachedbelow}', "");
    Expect(1, 7633, '\p{^Is_Ccc=attachedbelow}', "");
    Expect(1, 7633, '\P{Is_Ccc=attachedbelow}', "");
    Expect(0, 7633, '\P{^Is_Ccc=attachedbelow}', "");
    Expect(1, 7632, '\p{Is_Ccc= _ATTACHED_Below}', "");
    Expect(0, 7632, '\p{^Is_Ccc= _ATTACHED_Below}', "");
    Expect(0, 7632, '\P{Is_Ccc= _ATTACHED_Below}', "");
    Expect(1, 7632, '\P{^Is_Ccc= _ATTACHED_Below}', "");
    Expect(0, 7633, '\p{Is_Ccc= _ATTACHED_Below}', "");
    Expect(1, 7633, '\p{^Is_Ccc= _ATTACHED_Below}', "");
    Expect(1, 7633, '\P{Is_Ccc= _ATTACHED_Below}', "");
    Expect(0, 7633, '\P{^Is_Ccc= _ATTACHED_Below}', "");
    Error('\p{Canonical_Combining_Class=-:=ATTACHED_below_Left}');
    Error('\P{Canonical_Combining_Class=-:=ATTACHED_below_Left}');
    Expect(0, 1, '\p{Canonical_Combining_Class=:\AAttached_Below_Left\z:}', "");;
    Expect(0, 1, '\p{Canonical_Combining_Class=attachedbelowleft}', "");
    Expect(1, 1, '\p{^Canonical_Combining_Class=attachedbelowleft}', "");
    Expect(1, 1, '\P{Canonical_Combining_Class=attachedbelowleft}', "");
    Expect(0, 1, '\P{^Canonical_Combining_Class=attachedbelowleft}', "");
    Expect(0, 1, '\p{Canonical_Combining_Class=:\Aattachedbelowleft\z:}', "");;
    Expect(0, 1, '\p{Canonical_Combining_Class=ATTACHED_below_Left}', "");
    Expect(1, 1, '\p{^Canonical_Combining_Class=ATTACHED_below_Left}', "");
    Expect(1, 1, '\P{Canonical_Combining_Class=ATTACHED_below_Left}', "");
    Expect(0, 1, '\P{^Canonical_Combining_Class=ATTACHED_below_Left}', "");
    Error('\p{Ccc=	/a/ATBL}');
    Error('\P{Ccc=	/a/ATBL}');
    Expect(0, 1, '\p{Ccc=:\AATBL\z:}', "");;
    Expect(0, 1, '\p{Ccc=atbl}', "");
    Expect(1, 1, '\p{^Ccc=atbl}', "");
    Expect(1, 1, '\P{Ccc=atbl}', "");
    Expect(0, 1, '\P{^Ccc=atbl}', "");
    Expect(0, 1, '\p{Ccc=:\Aatbl\z:}', "");;
    Expect(0, 1, '\p{Ccc=_	ATBL}', "");
    Expect(1, 1, '\p{^Ccc=_	ATBL}', "");
    Expect(1, 1, '\P{Ccc=_	ATBL}', "");
    Expect(0, 1, '\P{^Ccc=_	ATBL}', "");
    Error('\p{Is_Canonical_Combining_Class:/a/_200}');
    Error('\P{Is_Canonical_Combining_Class:/a/_200}');
    Expect(0, 1, '\p{Is_Canonical_Combining_Class:+000200}', "");
    Expect(1, 1, '\p{^Is_Canonical_Combining_Class:+000200}', "");
    Expect(1, 1, '\P{Is_Canonical_Combining_Class:+000200}', "");
    Expect(0, 1, '\P{^Is_Canonical_Combining_Class:+000200}', "");
    Error('\p{Is_Ccc= /a/Attached_BELOW_Left}');
    Error('\P{Is_Ccc= /a/Attached_BELOW_Left}');
    Expect(0, 1, '\p{Is_Ccc=attachedbelowleft}', "");
    Expect(1, 1, '\p{^Is_Ccc=attachedbelowleft}', "");
    Expect(1, 1, '\P{Is_Ccc=attachedbelowleft}', "");
    Expect(0, 1, '\P{^Is_Ccc=attachedbelowleft}', "");
    Expect(0, 1, '\p{Is_Ccc= 	ATTACHED_BELOW_LEFT}', "");
    Expect(1, 1, '\p{^Is_Ccc= 	ATTACHED_BELOW_LEFT}', "");
    Expect(1, 1, '\P{Is_Ccc= 	ATTACHED_BELOW_LEFT}', "");
    Expect(0, 1, '\P{^Is_Ccc= 	ATTACHED_BELOW_LEFT}', "");
    Error('\p{Canonical_Combining_Class=__BELOW:=}');
    Error('\P{Canonical_Combining_Class=__BELOW:=}');
    Expect(1, 125142, '\p{Canonical_Combining_Class=:\ABelow\z:}', "");;
    Expect(0, 125143, '\p{Canonical_Combining_Class=:\ABelow\z:}', "");;
    Expect(1, 125142, '\p{Canonical_Combining_Class=below}', "");
    Expect(0, 125142, '\p{^Canonical_Combining_Class=below}', "");
    Expect(0, 125142, '\P{Canonical_Combining_Class=below}', "");
    Expect(1, 125142, '\P{^Canonical_Combining_Class=below}', "");
    Expect(0, 125143, '\p{Canonical_Combining_Class=below}', "");
    Expect(1, 125143, '\p{^Canonical_Combining_Class=below}', "");
    Expect(1, 125143, '\P{Canonical_Combining_Class=below}', "");
    Expect(0, 125143, '\P{^Canonical_Combining_Class=below}', "");
    Expect(1, 125142, '\p{Canonical_Combining_Class=:\Abelow\z:}', "");;
    Expect(0, 125143, '\p{Canonical_Combining_Class=:\Abelow\z:}', "");;
    Expect(1, 125142, '\p{Canonical_Combining_Class=-_below}', "");
    Expect(0, 125142, '\p{^Canonical_Combining_Class=-_below}', "");
    Expect(0, 125142, '\P{Canonical_Combining_Class=-_below}', "");
    Expect(1, 125142, '\P{^Canonical_Combining_Class=-_below}', "");
    Expect(0, 125143, '\p{Canonical_Combining_Class=-_below}', "");
    Expect(1, 125143, '\p{^Canonical_Combining_Class=-_below}', "");
    Expect(1, 125143, '\P{Canonical_Combining_Class=-_below}', "");
    Expect(0, 125143, '\P{^Canonical_Combining_Class=-_below}', "");
    Error('\p{Ccc=-B/a/}');
    Error('\P{Ccc=-B/a/}');
    Expect(1, 125142, '\p{Ccc=:\AB\z:}', "");;
    Expect(0, 125143, '\p{Ccc=:\AB\z:}', "");;
    Expect(1, 125142, '\p{Ccc:   b}', "");
    Expect(0, 125142, '\p{^Ccc:   b}', "");
    Expect(0, 125142, '\P{Ccc:   b}', "");
    Expect(1, 125142, '\P{^Ccc:   b}', "");
    Expect(0, 125143, '\p{Ccc:   b}', "");
    Expect(1, 125143, '\p{^Ccc:   b}', "");
    Expect(1, 125143, '\P{Ccc:   b}', "");
    Expect(0, 125143, '\P{^Ccc:   b}', "");
    Expect(1, 125142, '\p{Ccc=:\Ab\z:}', "");;
    Expect(0, 125143, '\p{Ccc=:\Ab\z:}', "");;
    Expect(1, 125142, '\p{Ccc=_b}', "");
    Expect(0, 125142, '\p{^Ccc=_b}', "");
    Expect(0, 125142, '\P{Ccc=_b}', "");
    Expect(1, 125142, '\P{^Ccc=_b}', "");
    Expect(0, 125143, '\p{Ccc=_b}', "");
    Expect(1, 125143, '\p{^Ccc=_b}', "");
    Expect(1, 125143, '\P{Ccc=_b}', "");
    Expect(0, 125143, '\P{^Ccc=_b}', "");
    Error('\p{Is_Canonical_Combining_Class=_+000000000220/a/}');
    Error('\P{Is_Canonical_Combining_Class=_+000000000220/a/}');
    Expect(1, 125142, '\p{Is_Canonical_Combining_Class=000220}', "");
    Expect(0, 125142, '\p{^Is_Canonical_Combining_Class=000220}', "");
    Expect(0, 125142, '\P{Is_Canonical_Combining_Class=000220}', "");
    Expect(1, 125142, '\P{^Is_Canonical_Combining_Class=000220}', "");
    Expect(0, 125143, '\p{Is_Canonical_Combining_Class=000220}', "");
    Expect(1, 125143, '\p{^Is_Canonical_Combining_Class=000220}', "");
    Expect(1, 125143, '\P{Is_Canonical_Combining_Class=000220}', "");
    Expect(0, 125143, '\P{^Is_Canonical_Combining_Class=000220}', "");
    Error('\p{Is_Ccc=	/a/Below}');
    Error('\P{Is_Ccc=	/a/Below}');
    Expect(1, 125142, '\p{Is_Ccc=below}', "");
    Expect(0, 125142, '\p{^Is_Ccc=below}', "");
    Expect(0, 125142, '\P{Is_Ccc=below}', "");
    Expect(1, 125142, '\P{^Is_Ccc=below}', "");
    Expect(0, 125143, '\p{Is_Ccc=below}', "");
    Expect(1, 125143, '\p{^Is_Ccc=below}', "");
    Expect(1, 125143, '\P{Is_Ccc=below}', "");
    Expect(0, 125143, '\P{^Is_Ccc=below}', "");
    Expect(1, 125142, '\p{Is_Ccc=- Below}', "");
    Expect(0, 125142, '\p{^Is_Ccc=- Below}', "");
    Expect(0, 125142, '\P{Is_Ccc=- Below}', "");
    Expect(1, 125142, '\P{^Is_Ccc=- Below}', "");
    Expect(0, 125143, '\p{Is_Ccc=- Below}', "");
    Expect(1, 125143, '\p{^Is_Ccc=- Below}', "");
    Expect(1, 125143, '\P{Is_Ccc=- Below}', "");
    Expect(0, 125143, '\P{^Is_Ccc=- Below}', "");
    Error('\p{Canonical_Combining_Class=_-BELOW_Left/a/}');
    Error('\P{Canonical_Combining_Class=_-BELOW_Left/a/}');
    Expect(1, 12330, '\p{Canonical_Combining_Class=:\ABelow_Left\z:}', "");;
    Expect(0, 12331, '\p{Canonical_Combining_Class=:\ABelow_Left\z:}', "");;
    Expect(1, 12330, '\p{Canonical_Combining_Class=belowleft}', "");
    Expect(0, 12330, '\p{^Canonical_Combining_Class=belowleft}', "");
    Expect(0, 12330, '\P{Canonical_Combining_Class=belowleft}', "");
    Expect(1, 12330, '\P{^Canonical_Combining_Class=belowleft}', "");
    Expect(0, 12331, '\p{Canonical_Combining_Class=belowleft}', "");
    Expect(1, 12331, '\p{^Canonical_Combining_Class=belowleft}', "");
    Expect(1, 12331, '\P{Canonical_Combining_Class=belowleft}', "");
    Expect(0, 12331, '\P{^Canonical_Combining_Class=belowleft}', "");
    Expect(1, 12330, '\p{Canonical_Combining_Class=:\Abelowleft\z:}', "");;
    Expect(0, 12331, '\p{Canonical_Combining_Class=:\Abelowleft\z:}', "");;
    Expect(1, 12330, '\p{Canonical_Combining_Class=-Below_left}', "");
    Expect(0, 12330, '\p{^Canonical_Combining_Class=-Below_left}', "");
    Expect(0, 12330, '\P{Canonical_Combining_Class=-Below_left}', "");
    Expect(1, 12330, '\P{^Canonical_Combining_Class=-Below_left}', "");
    Expect(0, 12331, '\p{Canonical_Combining_Class=-Below_left}', "");
    Expect(1, 12331, '\p{^Canonical_Combining_Class=-Below_left}', "");
    Expect(1, 12331, '\P{Canonical_Combining_Class=-Below_left}', "");
    Expect(0, 12331, '\P{^Canonical_Combining_Class=-Below_left}', "");
    Error('\p{Ccc=:= 	bl}');
    Error('\P{Ccc=:= 	bl}');
    Expect(1, 12330, '\p{Ccc=:\ABL\z:}', "");;
    Expect(0, 12331, '\p{Ccc=:\ABL\z:}', "");;
    Expect(1, 12330, '\p{Ccc:bl}', "");
    Expect(0, 12330, '\p{^Ccc:bl}', "");
    Expect(0, 12330, '\P{Ccc:bl}', "");
    Expect(1, 12330, '\P{^Ccc:bl}', "");
    Expect(0, 12331, '\p{Ccc:bl}', "");
    Expect(1, 12331, '\p{^Ccc:bl}', "");
    Expect(1, 12331, '\P{Ccc:bl}', "");
    Expect(0, 12331, '\P{^Ccc:bl}', "");
    Expect(1, 12330, '\p{Ccc=:\Abl\z:}', "");;
    Expect(0, 12331, '\p{Ccc=:\Abl\z:}', "");;
    Expect(1, 12330, '\p{Ccc:   BL}', "");
    Expect(0, 12330, '\p{^Ccc:   BL}', "");
    Expect(0, 12330, '\P{Ccc:   BL}', "");
    Expect(1, 12330, '\P{^Ccc:   BL}', "");
    Expect(0, 12331, '\p{Ccc:   BL}', "");
    Expect(1, 12331, '\p{^Ccc:   BL}', "");
    Expect(1, 12331, '\P{Ccc:   BL}', "");
    Expect(0, 12331, '\P{^Ccc:   BL}', "");
    Error('\p{Is_Canonical_Combining_Class=_0_0_0_0_0_218:=}');
    Error('\P{Is_Canonical_Combining_Class=_0_0_0_0_0_218:=}');
    Expect(1, 12330, '\p{Is_Canonical_Combining_Class=+0000000218}', "");
    Expect(0, 12330, '\p{^Is_Canonical_Combining_Class=+0000000218}', "");
    Expect(0, 12330, '\P{Is_Canonical_Combining_Class=+0000000218}', "");
    Expect(1, 12330, '\P{^Is_Canonical_Combining_Class=+0000000218}', "");
    Expect(0, 12331, '\p{Is_Canonical_Combining_Class=+0000000218}', "");
    Expect(1, 12331, '\p{^Is_Canonical_Combining_Class=+0000000218}', "");
    Expect(1, 12331, '\P{Is_Canonical_Combining_Class=+0000000218}', "");
    Expect(0, 12331, '\P{^Is_Canonical_Combining_Class=+0000000218}', "");
    Error('\p{Is_Ccc=:=		Below_Left}');
    Error('\P{Is_Ccc=:=		Below_Left}');
    Expect(1, 12330, '\p{Is_Ccc=belowleft}', "");
    Expect(0, 12330, '\p{^Is_Ccc=belowleft}', "");
    Expect(0, 12330, '\P{Is_Ccc=belowleft}', "");
    Expect(1, 12330, '\P{^Is_Ccc=belowleft}', "");
    Expect(0, 12331, '\p{Is_Ccc=belowleft}', "");
    Expect(1, 12331, '\p{^Is_Ccc=belowleft}', "");
    Expect(1, 12331, '\P{Is_Ccc=belowleft}', "");
    Expect(0, 12331, '\P{^Is_Ccc=belowleft}', "");
    Expect(1, 12330, '\p{Is_Ccc=_ Below_left}', "");
    Expect(0, 12330, '\p{^Is_Ccc=_ Below_left}', "");
    Expect(0, 12330, '\P{Is_Ccc=_ Below_left}', "");
    Expect(1, 12330, '\P{^Is_Ccc=_ Below_left}', "");
    Expect(0, 12331, '\p{Is_Ccc=_ Below_left}', "");
    Expect(1, 12331, '\p{^Is_Ccc=_ Below_left}', "");
    Expect(1, 12331, '\P{Is_Ccc=_ Below_left}', "");
    Expect(0, 12331, '\P{^Is_Ccc=_ Below_left}', "");
    Error('\p{Canonical_Combining_Class=/a/ BELOW_RIGHT}');
    Error('\P{Canonical_Combining_Class=/a/ BELOW_RIGHT}');
    Expect(1, 12333, '\p{Canonical_Combining_Class=:\ABelow_Right\z:}', "");;
    Expect(0, 12334, '\p{Canonical_Combining_Class=:\ABelow_Right\z:}', "");;
    Expect(1, 12333, '\p{Canonical_Combining_Class=belowright}', "");
    Expect(0, 12333, '\p{^Canonical_Combining_Class=belowright}', "");
    Expect(0, 12333, '\P{Canonical_Combining_Class=belowright}', "");
    Expect(1, 12333, '\P{^Canonical_Combining_Class=belowright}', "");
    Expect(0, 12334, '\p{Canonical_Combining_Class=belowright}', "");
    Expect(1, 12334, '\p{^Canonical_Combining_Class=belowright}', "");
    Expect(1, 12334, '\P{Canonical_Combining_Class=belowright}', "");
    Expect(0, 12334, '\P{^Canonical_Combining_Class=belowright}', "");
    Expect(1, 12333, '\p{Canonical_Combining_Class=:\Abelowright\z:}', "");;
    Expect(0, 12334, '\p{Canonical_Combining_Class=:\Abelowright\z:}', "");;
    Expect(1, 12333, '\p{Canonical_Combining_Class:_below_right}', "");
    Expect(0, 12333, '\p{^Canonical_Combining_Class:_below_right}', "");
    Expect(0, 12333, '\P{Canonical_Combining_Class:_below_right}', "");
    Expect(1, 12333, '\P{^Canonical_Combining_Class:_below_right}', "");
    Expect(0, 12334, '\p{Canonical_Combining_Class:_below_right}', "");
    Expect(1, 12334, '\p{^Canonical_Combining_Class:_below_right}', "");
    Expect(1, 12334, '\P{Canonical_Combining_Class:_below_right}', "");
    Expect(0, 12334, '\P{^Canonical_Combining_Class:_below_right}', "");
    Error('\p{Ccc=	_br/a/}');
    Error('\P{Ccc=	_br/a/}');
    Expect(1, 12333, '\p{Ccc=:\ABR\z:}', "");;
    Expect(0, 12334, '\p{Ccc=:\ABR\z:}', "");;
    Expect(1, 12333, '\p{Ccc:   br}', "");
    Expect(0, 12333, '\p{^Ccc:   br}', "");
    Expect(0, 12333, '\P{Ccc:   br}', "");
    Expect(1, 12333, '\P{^Ccc:   br}', "");
    Expect(0, 12334, '\p{Ccc:   br}', "");
    Expect(1, 12334, '\p{^Ccc:   br}', "");
    Expect(1, 12334, '\P{Ccc:   br}', "");
    Expect(0, 12334, '\P{^Ccc:   br}', "");
    Expect(1, 12333, '\p{Ccc=:\Abr\z:}', "");;
    Expect(0, 12334, '\p{Ccc=:\Abr\z:}', "");;
    Expect(1, 12333, '\p{Ccc=-	BR}', "");
    Expect(0, 12333, '\p{^Ccc=-	BR}', "");
    Expect(0, 12333, '\P{Ccc=-	BR}', "");
    Expect(1, 12333, '\P{^Ccc=-	BR}', "");
    Expect(0, 12334, '\p{Ccc=-	BR}', "");
    Expect(1, 12334, '\p{^Ccc=-	BR}', "");
    Expect(1, 12334, '\P{Ccc=-	BR}', "");
    Expect(0, 12334, '\P{^Ccc=-	BR}', "");
    Error('\p{Is_Canonical_Combining_Class=-/a/+000000000222}');
    Error('\P{Is_Canonical_Combining_Class=-/a/+000000000222}');
    Expect(1, 12333, '\p{Is_Canonical_Combining_Class=+0022_2}', "");
    Expect(0, 12333, '\p{^Is_Canonical_Combining_Class=+0022_2}', "");
    Expect(0, 12333, '\P{Is_Canonical_Combining_Class=+0022_2}', "");
    Expect(1, 12333, '\P{^Is_Canonical_Combining_Class=+0022_2}', "");
    Expect(0, 12334, '\p{Is_Canonical_Combining_Class=+0022_2}', "");
    Expect(1, 12334, '\p{^Is_Canonical_Combining_Class=+0022_2}', "");
    Expect(1, 12334, '\P{Is_Canonical_Combining_Class=+0022_2}', "");
    Expect(0, 12334, '\P{^Is_Canonical_Combining_Class=+0022_2}', "");
    Error('\p{Is_Ccc=_Below_Right/a/}');
    Error('\P{Is_Ccc=_Below_Right/a/}');
    Expect(1, 12333, '\p{Is_Ccc=belowright}', "");
    Expect(0, 12333, '\p{^Is_Ccc=belowright}', "");
    Expect(0, 12333, '\P{Is_Ccc=belowright}', "");
    Expect(1, 12333, '\P{^Is_Ccc=belowright}', "");
    Expect(0, 12334, '\p{Is_Ccc=belowright}', "");
    Expect(1, 12334, '\p{^Is_Ccc=belowright}', "");
    Expect(1, 12334, '\P{Is_Ccc=belowright}', "");
    Expect(0, 12334, '\P{^Is_Ccc=belowright}', "");
    Expect(1, 12333, '\p{Is_Ccc: __below_Right}', "");
    Expect(0, 12333, '\p{^Is_Ccc: __below_Right}', "");
    Expect(0, 12333, '\P{Is_Ccc: __below_Right}', "");
    Expect(1, 12333, '\P{^Is_Ccc: __below_Right}', "");
    Expect(0, 12334, '\p{Is_Ccc: __below_Right}', "");
    Expect(1, 12334, '\p{^Is_Ccc: __below_Right}', "");
    Expect(1, 12334, '\P{Is_Ccc: __below_Right}', "");
    Expect(0, 12334, '\P{^Is_Ccc: __below_Right}', "");
    Error('\p{Canonical_Combining_Class=/a/_	CCC10}');
    Error('\P{Canonical_Combining_Class=/a/_	CCC10}');
    Expect(1, 1456, '\p{Canonical_Combining_Class=:\ACCC10\z:}', "");;
    Expect(0, 1457, '\p{Canonical_Combining_Class=:\ACCC10\z:}', "");;
    Expect(1, 1456, '\p{Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1456, '\p{^Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1456, '\P{Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1456, '\P{^Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1457, '\p{Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1457, '\p{^Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1457, '\P{Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1457, '\P{^Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1456, '\p{Canonical_Combining_Class=:\Accc10\z:}', "");;
    Expect(0, 1457, '\p{Canonical_Combining_Class=:\Accc10\z:}', "");;
    Expect(1, 1456, '\p{Canonical_Combining_Class=__CCC10}', "");
    Expect(0, 1456, '\p{^Canonical_Combining_Class=__CCC10}', "");
    Expect(0, 1456, '\P{Canonical_Combining_Class=__CCC10}', "");
    Expect(1, 1456, '\P{^Canonical_Combining_Class=__CCC10}', "");
    Expect(0, 1457, '\p{Canonical_Combining_Class=__CCC10}', "");
    Expect(1, 1457, '\p{^Canonical_Combining_Class=__CCC10}', "");
    Expect(1, 1457, '\P{Canonical_Combining_Class=__CCC10}', "");
    Expect(0, 1457, '\P{^Canonical_Combining_Class=__CCC10}', "");
    Error('\p{Ccc=:=	00010}');
    Error('\P{Ccc=:=	00010}');
    Expect(1, 1456, '\p{Ccc=:\A10\z:}', "");;
    Expect(0, 1457, '\p{Ccc=:\A10\z:}', "");;
    Expect(1, 1456, '\p{Ccc:	0000000010}', "");
    Expect(0, 1456, '\p{^Ccc:	0000000010}', "");
    Expect(0, 1456, '\P{Ccc:	0000000010}', "");
    Expect(1, 1456, '\P{^Ccc:	0000000010}', "");
    Expect(0, 1457, '\p{Ccc:	0000000010}', "");
    Expect(1, 1457, '\p{^Ccc:	0000000010}', "");
    Expect(1, 1457, '\P{Ccc:	0000000010}', "");
    Expect(0, 1457, '\P{^Ccc:	0000000010}', "");
    Error('\p{Is_Canonical_Combining_Class: 	/a/CCC10}');
    Error('\P{Is_Canonical_Combining_Class: 	/a/CCC10}');
    Expect(1, 1456, '\p{Is_Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1456, '\p{^Is_Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1456, '\P{Is_Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1456, '\P{^Is_Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1457, '\p{Is_Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1457, '\p{^Is_Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1457, '\P{Is_Canonical_Combining_Class=ccc10}', "");
    Expect(0, 1457, '\P{^Is_Canonical_Combining_Class=ccc10}', "");
    Expect(1, 1456, '\p{Is_Canonical_Combining_Class=-_CCC10}', "");
    Expect(0, 1456, '\p{^Is_Canonical_Combining_Class=-_CCC10}', "");
    Expect(0, 1456, '\P{Is_Canonical_Combining_Class=-_CCC10}', "");
    Expect(1, 1456, '\P{^Is_Canonical_Combining_Class=-_CCC10}', "");
    Expect(0, 1457, '\p{Is_Canonical_Combining_Class=-_CCC10}', "");
    Expect(1, 1457, '\p{^Is_Canonical_Combining_Class=-_CCC10}', "");
    Expect(1, 1457, '\P{Is_Canonical_Combining_Class=-_CCC10}', "");
    Expect(0, 1457, '\P{^Is_Canonical_Combining_Class=-_CCC10}', "");
    Error('\p{Is_Ccc=:=	_00000000010}');
    Error('\P{Is_Ccc=:=	_00000000010}');
    Expect(1, 1456, '\p{Is_Ccc=01_0}', "");
    Expect(0, 1456, '\p{^Is_Ccc=01_0}', "");
    Expect(0, 1456, '\P{Is_Ccc=01_0}', "");
    Expect(1, 1456, '\P{^Is_Ccc=01_0}', "");
    Expect(0, 1457, '\p{Is_Ccc=01_0}', "");
    Expect(1, 1457, '\p{^Is_Ccc=01_0}', "");
    Expect(1, 1457, '\P{Is_Ccc=01_0}', "");
    Expect(0, 1457, '\P{^Is_Ccc=01_0}', "");
    Error('\p{Canonical_Combining_Class=  CCC103:=}');
    Error('\P{Canonical_Combining_Class=  CCC103:=}');
    Expect(1, 3641, '\p{Canonical_Combining_Class=:\ACCC103\z:}', "");;
    Expect(0, 3642, '\p{Canonical_Combining_Class=:\ACCC103\z:}', "");;
    Expect(1, 3641, '\p{Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3641, '\p{^Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3641, '\P{Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3641, '\P{^Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3642, '\p{Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3642, '\p{^Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3642, '\P{Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3642, '\P{^Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3641, '\p{Canonical_Combining_Class=:\Accc103\z:}', "");;
    Expect(0, 3642, '\p{Canonical_Combining_Class=:\Accc103\z:}', "");;
    Expect(1, 3641, '\p{Canonical_Combining_Class=-_ccc103}', "");
    Expect(0, 3641, '\p{^Canonical_Combining_Class=-_ccc103}', "");
    Expect(0, 3641, '\P{Canonical_Combining_Class=-_ccc103}', "");
    Expect(1, 3641, '\P{^Canonical_Combining_Class=-_ccc103}', "");
    Expect(0, 3642, '\p{Canonical_Combining_Class=-_ccc103}', "");
    Expect(1, 3642, '\p{^Canonical_Combining_Class=-_ccc103}', "");
    Expect(1, 3642, '\P{Canonical_Combining_Class=-_ccc103}', "");
    Expect(0, 3642, '\P{^Canonical_Combining_Class=-_ccc103}', "");
    Error('\p{Ccc= 	00000000103/a/}');
    Error('\P{Ccc= 	00000000103/a/}');
    Expect(1, 3641, '\p{Ccc=:\A103\z:}', "");;
    Expect(0, 3642, '\p{Ccc=:\A103\z:}', "");;
    Expect(1, 3641, '\p{Ccc=103}', "");
    Expect(0, 3641, '\p{^Ccc=103}', "");
    Expect(0, 3641, '\P{Ccc=103}', "");
    Expect(1, 3641, '\P{^Ccc=103}', "");
    Expect(0, 3642, '\p{Ccc=103}', "");
    Expect(1, 3642, '\p{^Ccc=103}', "");
    Expect(1, 3642, '\P{Ccc=103}', "");
    Expect(0, 3642, '\P{^Ccc=103}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/_-CCC103}');
    Error('\P{Is_Canonical_Combining_Class=/a/_-CCC103}');
    Expect(1, 3641, '\p{Is_Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3641, '\p{^Is_Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3641, '\P{Is_Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3641, '\P{^Is_Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3642, '\p{Is_Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3642, '\p{^Is_Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3642, '\P{Is_Canonical_Combining_Class=ccc103}', "");
    Expect(0, 3642, '\P{^Is_Canonical_Combining_Class=ccc103}', "");
    Expect(1, 3641, '\p{Is_Canonical_Combining_Class=		CCC103}', "");
    Expect(0, 3641, '\p{^Is_Canonical_Combining_Class=		CCC103}', "");
    Expect(0, 3641, '\P{Is_Canonical_Combining_Class=		CCC103}', "");
    Expect(1, 3641, '\P{^Is_Canonical_Combining_Class=		CCC103}', "");
    Expect(0, 3642, '\p{Is_Canonical_Combining_Class=		CCC103}', "");
    Expect(1, 3642, '\p{^Is_Canonical_Combining_Class=		CCC103}', "");
    Expect(1, 3642, '\P{Is_Canonical_Combining_Class=		CCC103}', "");
    Expect(0, 3642, '\P{^Is_Canonical_Combining_Class=		CCC103}', "");
    Error('\p{Is_Ccc=	/a/103}');
    Error('\P{Is_Ccc=	/a/103}');
    Expect(1, 3641, '\p{Is_Ccc:   0000010_3}', "");
    Expect(0, 3641, '\p{^Is_Ccc:   0000010_3}', "");
    Expect(0, 3641, '\P{Is_Ccc:   0000010_3}', "");
    Expect(1, 3641, '\P{^Is_Ccc:   0000010_3}', "");
    Expect(0, 3642, '\p{Is_Ccc:   0000010_3}', "");
    Expect(1, 3642, '\p{^Is_Ccc:   0000010_3}', "");
    Expect(1, 3642, '\P{Is_Ccc:   0000010_3}', "");
    Expect(0, 3642, '\P{^Is_Ccc:   0000010_3}', "");
    Error('\p{Canonical_Combining_Class=-:=ccc107}');
    Error('\P{Canonical_Combining_Class=-:=ccc107}');
    Expect(1, 3659, '\p{Canonical_Combining_Class=:\ACCC107\z:}', "");;
    Expect(0, 3660, '\p{Canonical_Combining_Class=:\ACCC107\z:}', "");;
    Expect(1, 3659, '\p{Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3659, '\p{^Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3659, '\P{Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3659, '\P{^Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3660, '\p{Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3660, '\p{^Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3660, '\P{Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3660, '\P{^Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3659, '\p{Canonical_Combining_Class=:\Accc107\z:}', "");;
    Expect(0, 3660, '\p{Canonical_Combining_Class=:\Accc107\z:}', "");;
    Expect(1, 3659, '\p{Canonical_Combining_Class=__CCC107}', "");
    Expect(0, 3659, '\p{^Canonical_Combining_Class=__CCC107}', "");
    Expect(0, 3659, '\P{Canonical_Combining_Class=__CCC107}', "");
    Expect(1, 3659, '\P{^Canonical_Combining_Class=__CCC107}', "");
    Expect(0, 3660, '\p{Canonical_Combining_Class=__CCC107}', "");
    Expect(1, 3660, '\p{^Canonical_Combining_Class=__CCC107}', "");
    Expect(1, 3660, '\P{Canonical_Combining_Class=__CCC107}', "");
    Expect(0, 3660, '\P{^Canonical_Combining_Class=__CCC107}', "");
    Error('\p{Ccc=:=+00_00_00_00_10_7}');
    Error('\P{Ccc=:=+00_00_00_00_10_7}');
    Expect(1, 3659, '\p{Ccc=:\A107\z:}', "");;
    Expect(0, 3660, '\p{Ccc=:\A107\z:}', "");;
    Expect(1, 3659, '\p{Ccc:	0_0_1_07}', "");
    Expect(0, 3659, '\p{^Ccc:	0_0_1_07}', "");
    Expect(0, 3659, '\P{Ccc:	0_0_1_07}', "");
    Expect(1, 3659, '\P{^Ccc:	0_0_1_07}', "");
    Expect(0, 3660, '\p{Ccc:	0_0_1_07}', "");
    Expect(1, 3660, '\p{^Ccc:	0_0_1_07}', "");
    Expect(1, 3660, '\P{Ccc:	0_0_1_07}', "");
    Expect(0, 3660, '\P{^Ccc:	0_0_1_07}', "");
    Error('\p{Is_Canonical_Combining_Class=_:=CCC107}');
    Error('\P{Is_Canonical_Combining_Class=_:=CCC107}');
    Expect(1, 3659, '\p{Is_Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3659, '\p{^Is_Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3659, '\P{Is_Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3659, '\P{^Is_Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3660, '\p{Is_Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3660, '\p{^Is_Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3660, '\P{Is_Canonical_Combining_Class=ccc107}', "");
    Expect(0, 3660, '\P{^Is_Canonical_Combining_Class=ccc107}', "");
    Expect(1, 3659, '\p{Is_Canonical_Combining_Class= -CCC107}', "");
    Expect(0, 3659, '\p{^Is_Canonical_Combining_Class= -CCC107}', "");
    Expect(0, 3659, '\P{Is_Canonical_Combining_Class= -CCC107}', "");
    Expect(1, 3659, '\P{^Is_Canonical_Combining_Class= -CCC107}', "");
    Expect(0, 3660, '\p{Is_Canonical_Combining_Class= -CCC107}', "");
    Expect(1, 3660, '\p{^Is_Canonical_Combining_Class= -CCC107}', "");
    Expect(1, 3660, '\P{Is_Canonical_Combining_Class= -CCC107}', "");
    Expect(0, 3660, '\P{^Is_Canonical_Combining_Class= -CCC107}', "");
    Error('\p{Is_Ccc=00010_7:=}');
    Error('\P{Is_Ccc=00010_7:=}');
    Expect(1, 3659, '\p{Is_Ccc=+00107}', "");
    Expect(0, 3659, '\p{^Is_Ccc=+00107}', "");
    Expect(0, 3659, '\P{Is_Ccc=+00107}', "");
    Expect(1, 3659, '\P{^Is_Ccc=+00107}', "");
    Expect(0, 3660, '\p{Is_Ccc=+00107}', "");
    Expect(1, 3660, '\p{^Is_Ccc=+00107}', "");
    Expect(1, 3660, '\P{Is_Ccc=+00107}', "");
    Expect(0, 3660, '\P{^Is_Ccc=+00107}', "");
    Error('\p{Canonical_Combining_Class=:=	-CCC11}');
    Error('\P{Canonical_Combining_Class=:=	-CCC11}');
    Expect(1, 1457, '\p{Canonical_Combining_Class=:\ACCC11\z:}', "");;
    Expect(0, 1458, '\p{Canonical_Combining_Class=:\ACCC11\z:}', "");;
    Expect(1, 1457, '\p{Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1457, '\p{^Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1457, '\P{Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1457, '\P{^Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1458, '\p{Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1458, '\p{^Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1458, '\P{Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1458, '\P{^Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1457, '\p{Canonical_Combining_Class=:\Accc11\z:}', "");;
    Expect(0, 1458, '\p{Canonical_Combining_Class=:\Accc11\z:}', "");;
    Expect(1, 1457, '\p{Canonical_Combining_Class:	__CCC11}', "");
    Expect(0, 1457, '\p{^Canonical_Combining_Class:	__CCC11}', "");
    Expect(0, 1457, '\P{Canonical_Combining_Class:	__CCC11}', "");
    Expect(1, 1457, '\P{^Canonical_Combining_Class:	__CCC11}', "");
    Expect(0, 1458, '\p{Canonical_Combining_Class:	__CCC11}', "");
    Expect(1, 1458, '\p{^Canonical_Combining_Class:	__CCC11}', "");
    Expect(1, 1458, '\P{Canonical_Combining_Class:	__CCC11}', "");
    Expect(0, 1458, '\P{^Canonical_Combining_Class:	__CCC11}', "");
    Error('\p{Ccc= -+0000011:=}');
    Error('\P{Ccc= -+0000011:=}');
    Expect(1, 1457, '\p{Ccc=:\A11\z:}', "");;
    Expect(0, 1458, '\p{Ccc=:\A11\z:}', "");;
    Expect(1, 1457, '\p{Ccc=0000011}', "");
    Expect(0, 1457, '\p{^Ccc=0000011}', "");
    Expect(0, 1457, '\P{Ccc=0000011}', "");
    Expect(1, 1457, '\P{^Ccc=0000011}', "");
    Expect(0, 1458, '\p{Ccc=0000011}', "");
    Expect(1, 1458, '\p{^Ccc=0000011}', "");
    Expect(1, 1458, '\P{Ccc=0000011}', "");
    Expect(0, 1458, '\P{^Ccc=0000011}', "");
    Error('\p{Is_Canonical_Combining_Class=:=  CCC11}');
    Error('\P{Is_Canonical_Combining_Class=:=  CCC11}');
    Expect(1, 1457, '\p{Is_Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1457, '\p{^Is_Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1457, '\P{Is_Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1457, '\P{^Is_Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1458, '\p{Is_Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1458, '\p{^Is_Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1458, '\P{Is_Canonical_Combining_Class=ccc11}', "");
    Expect(0, 1458, '\P{^Is_Canonical_Combining_Class=ccc11}', "");
    Expect(1, 1457, '\p{Is_Canonical_Combining_Class:-CCC11}', "");
    Expect(0, 1457, '\p{^Is_Canonical_Combining_Class:-CCC11}', "");
    Expect(0, 1457, '\P{Is_Canonical_Combining_Class:-CCC11}', "");
    Expect(1, 1457, '\P{^Is_Canonical_Combining_Class:-CCC11}', "");
    Expect(0, 1458, '\p{Is_Canonical_Combining_Class:-CCC11}', "");
    Expect(1, 1458, '\p{^Is_Canonical_Combining_Class:-CCC11}', "");
    Expect(1, 1458, '\P{Is_Canonical_Combining_Class:-CCC11}', "");
    Expect(0, 1458, '\P{^Is_Canonical_Combining_Class:-CCC11}', "");
    Error('\p{Is_Ccc=-:=0_0_11}');
    Error('\P{Is_Ccc=-:=0_0_11}');
    Expect(1, 1457, '\p{Is_Ccc=+0_0_0_0_11}', "");
    Expect(0, 1457, '\p{^Is_Ccc=+0_0_0_0_11}', "");
    Expect(0, 1457, '\P{Is_Ccc=+0_0_0_0_11}', "");
    Expect(1, 1457, '\P{^Is_Ccc=+0_0_0_0_11}', "");
    Expect(0, 1458, '\p{Is_Ccc=+0_0_0_0_11}', "");
    Expect(1, 1458, '\p{^Is_Ccc=+0_0_0_0_11}', "");
    Expect(1, 1458, '\P{Is_Ccc=+0_0_0_0_11}', "");
    Expect(0, 1458, '\P{^Is_Ccc=+0_0_0_0_11}', "");
    Error('\p{Canonical_Combining_Class=:=--CCC118}');
    Error('\P{Canonical_Combining_Class=:=--CCC118}');
    Expect(1, 3769, '\p{Canonical_Combining_Class=:\ACCC118\z:}', "");;
    Expect(0, 3770, '\p{Canonical_Combining_Class=:\ACCC118\z:}', "");;
    Expect(1, 3769, '\p{Canonical_Combining_Class=ccc118}', "");
    Expect(0, 3769, '\p{^Canonical_Combining_Class=ccc118}', "");
    Expect(0, 3769, '\P{Canonical_Combining_Class=ccc118}', "");
    Expect(1, 3769, '\P{^Canonical_Combining_Class=ccc118}', "");
    Expect(0, 3770, '\p{Canonical_Combining_Class=ccc118}', "");
    Expect(1, 3770, '\p{^Canonical_Combining_Class=ccc118}', "");
    Expect(1, 3770, '\P{Canonical_Combining_Class=ccc118}', "");
    Expect(0, 3770, '\P{^Canonical_Combining_Class=ccc118}', "");
    Expect(1, 3769, '\p{Canonical_Combining_Class=:\Accc118\z:}', "");;
    Expect(0, 3770, '\p{Canonical_Combining_Class=:\Accc118\z:}', "");;
    Expect(1, 3769, '\p{Canonical_Combining_Class= CCC118}', "");
    Expect(0, 3769, '\p{^Canonical_Combining_Class= CCC118}', "");
    Expect(0, 3769, '\P{Canonical_Combining_Class= CCC118}', "");
    Expect(1, 3769, '\P{^Canonical_Combining_Class= CCC118}', "");
    Expect(0, 3770, '\p{Canonical_Combining_Class= CCC118}', "");
    Expect(1, 3770, '\p{^Canonical_Combining_Class= CCC118}', "");
    Expect(1, 3770, '\P{Canonical_Combining_Class= CCC118}', "");
    Expect(0, 3770, '\P{^Canonical_Combining_Class= CCC118}', "");
    Error('\p{Ccc=-/a/+00_00_00_01_18}');
    Error('\P{Ccc=-/a/+00_00_00_01_18}');
    Expect(1, 3769, '\p{Ccc=:\A118\z:}', "");;
    Expect(0, 3770, '\p{Ccc=:\A118\z:}', "");;
    Expect(1, 3769, '\p{Ccc=00000000118}', "");
    Expect(0, 3769, '\p{^Ccc=00000000118}', "");
    Expect(0, 3769, '\P{Ccc=00000000118}', "");
    Expect(1, 3769, '\P{^Ccc=00000000118}', "");
    Expect(0, 3770, '\p{Ccc=00000000118}', "");
    Expect(1, 3770, '\p{^Ccc=00000000118}', "");
    Expect(1, 3770, '\P{Ccc=00000000118}', "");
    Expect(0, 3770, '\P{^Ccc=00000000118}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/_ CCC118}');
    Error('\P{Is_Canonical_Combining_Class=/a/_ CCC118}');
    Expect(1, 3769, '\p{Is_Canonical_Combining_Class=ccc118}', "");
    Expect(0, 3769, '\p{^Is_Canonical_Combining_Class=ccc118}', "");
    Expect(0, 3769, '\P{Is_Canonical_Combining_Class=ccc118}', "");
    Expect(1, 3769, '\P{^Is_Canonical_Combining_Class=ccc118}', "");
    Expect(0, 3770, '\p{Is_Canonical_Combining_Class=ccc118}', "");
    Expect(1, 3770, '\p{^Is_Canonical_Combining_Class=ccc118}', "");
    Expect(1, 3770, '\P{Is_Canonical_Combining_Class=ccc118}', "");
    Expect(0, 3770, '\P{^Is_Canonical_Combining_Class=ccc118}', "");
    Expect(1, 3769, '\p{Is_Canonical_Combining_Class=- ccc118}', "");
    Expect(0, 3769, '\p{^Is_Canonical_Combining_Class=- ccc118}', "");
    Expect(0, 3769, '\P{Is_Canonical_Combining_Class=- ccc118}', "");
    Expect(1, 3769, '\P{^Is_Canonical_Combining_Class=- ccc118}', "");
    Expect(0, 3770, '\p{Is_Canonical_Combining_Class=- ccc118}', "");
    Expect(1, 3770, '\p{^Is_Canonical_Combining_Class=- ccc118}', "");
    Expect(1, 3770, '\P{Is_Canonical_Combining_Class=- ccc118}', "");
    Expect(0, 3770, '\P{^Is_Canonical_Combining_Class=- ccc118}', "");
    Error('\p{Is_Ccc=	/a/+0_0_1_18}');
    Error('\P{Is_Ccc=	/a/+0_0_1_18}');
    Expect(1, 3769, '\p{Is_Ccc=0011_8}', "");
    Expect(0, 3769, '\p{^Is_Ccc=0011_8}', "");
    Expect(0, 3769, '\P{Is_Ccc=0011_8}', "");
    Expect(1, 3769, '\P{^Is_Ccc=0011_8}', "");
    Expect(0, 3770, '\p{Is_Ccc=0011_8}', "");
    Expect(1, 3770, '\p{^Is_Ccc=0011_8}', "");
    Expect(1, 3770, '\P{Is_Ccc=0011_8}', "");
    Expect(0, 3770, '\P{^Is_Ccc=0011_8}', "");
    Error('\p{Canonical_Combining_Class=--CCC12:=}');
    Error('\P{Canonical_Combining_Class=--CCC12:=}');
    Expect(1, 1458, '\p{Canonical_Combining_Class=:\ACCC12\z:}', "");;
    Expect(0, 1459, '\p{Canonical_Combining_Class=:\ACCC12\z:}', "");;
    Expect(1, 1458, '\p{Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1458, '\p{^Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1458, '\P{Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1458, '\P{^Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1459, '\p{Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1459, '\p{^Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1459, '\P{Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1459, '\P{^Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1458, '\p{Canonical_Combining_Class=:\Accc12\z:}', "");;
    Expect(0, 1459, '\p{Canonical_Combining_Class=:\Accc12\z:}', "");;
    Expect(1, 1458, '\p{Canonical_Combining_Class= CCC12}', "");
    Expect(0, 1458, '\p{^Canonical_Combining_Class= CCC12}', "");
    Expect(0, 1458, '\P{Canonical_Combining_Class= CCC12}', "");
    Expect(1, 1458, '\P{^Canonical_Combining_Class= CCC12}', "");
    Expect(0, 1459, '\p{Canonical_Combining_Class= CCC12}', "");
    Expect(1, 1459, '\p{^Canonical_Combining_Class= CCC12}', "");
    Expect(1, 1459, '\P{Canonical_Combining_Class= CCC12}', "");
    Expect(0, 1459, '\P{^Canonical_Combining_Class= CCC12}', "");
    Error('\p{Ccc=:=-+00_01_2}');
    Error('\P{Ccc=:=-+00_01_2}');
    Expect(1, 1458, '\p{Ccc=:\A12\z:}', "");;
    Expect(0, 1459, '\p{Ccc=:\A12\z:}', "");;
    Expect(1, 1458, '\p{Ccc=+001_2}', "");
    Expect(0, 1458, '\p{^Ccc=+001_2}', "");
    Expect(0, 1458, '\P{Ccc=+001_2}', "");
    Expect(1, 1458, '\P{^Ccc=+001_2}', "");
    Expect(0, 1459, '\p{Ccc=+001_2}', "");
    Expect(1, 1459, '\p{^Ccc=+001_2}', "");
    Expect(1, 1459, '\P{Ccc=+001_2}', "");
    Expect(0, 1459, '\P{^Ccc=+001_2}', "");
    Error('\p{Is_Canonical_Combining_Class:	_/a/CCC12}');
    Error('\P{Is_Canonical_Combining_Class:	_/a/CCC12}');
    Expect(1, 1458, '\p{Is_Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1458, '\p{^Is_Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1458, '\P{Is_Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1458, '\P{^Is_Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1459, '\p{Is_Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1459, '\p{^Is_Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1459, '\P{Is_Canonical_Combining_Class=ccc12}', "");
    Expect(0, 1459, '\P{^Is_Canonical_Combining_Class=ccc12}', "");
    Expect(1, 1458, '\p{Is_Canonical_Combining_Class=	ccc12}', "");
    Expect(0, 1458, '\p{^Is_Canonical_Combining_Class=	ccc12}', "");
    Expect(0, 1458, '\P{Is_Canonical_Combining_Class=	ccc12}', "");
    Expect(1, 1458, '\P{^Is_Canonical_Combining_Class=	ccc12}', "");
    Expect(0, 1459, '\p{Is_Canonical_Combining_Class=	ccc12}', "");
    Expect(1, 1459, '\p{^Is_Canonical_Combining_Class=	ccc12}', "");
    Expect(1, 1459, '\P{Is_Canonical_Combining_Class=	ccc12}', "");
    Expect(0, 1459, '\P{^Is_Canonical_Combining_Class=	ccc12}', "");
    Error('\p{Is_Ccc=-:=+0000000001_2}');
    Error('\P{Is_Ccc=-:=+0000000001_2}');
    Expect(1, 1458, '\p{Is_Ccc=+001_2}', "");
    Expect(0, 1458, '\p{^Is_Ccc=+001_2}', "");
    Expect(0, 1458, '\P{Is_Ccc=+001_2}', "");
    Expect(1, 1458, '\P{^Is_Ccc=+001_2}', "");
    Expect(0, 1459, '\p{Is_Ccc=+001_2}', "");
    Expect(1, 1459, '\p{^Is_Ccc=+001_2}', "");
    Expect(1, 1459, '\P{Is_Ccc=+001_2}', "");
    Expect(0, 1459, '\P{^Is_Ccc=+001_2}', "");
    Error('\p{Canonical_Combining_Class:	/a/_-CCC122}');
    Error('\P{Canonical_Combining_Class:	/a/_-CCC122}');
    Expect(1, 3787, '\p{Canonical_Combining_Class=:\ACCC122\z:}', "");;
    Expect(0, 3788, '\p{Canonical_Combining_Class=:\ACCC122\z:}', "");;
    Expect(1, 3787, '\p{Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3787, '\p{^Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3787, '\P{Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3787, '\P{^Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3788, '\p{Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3788, '\p{^Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3788, '\P{Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3788, '\P{^Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3787, '\p{Canonical_Combining_Class=:\Accc122\z:}', "");;
    Expect(0, 3788, '\p{Canonical_Combining_Class=:\Accc122\z:}', "");;
    Expect(1, 3787, '\p{Canonical_Combining_Class=-_CCC122}', "");
    Expect(0, 3787, '\p{^Canonical_Combining_Class=-_CCC122}', "");
    Expect(0, 3787, '\P{Canonical_Combining_Class=-_CCC122}', "");
    Expect(1, 3787, '\P{^Canonical_Combining_Class=-_CCC122}', "");
    Expect(0, 3788, '\p{Canonical_Combining_Class=-_CCC122}', "");
    Expect(1, 3788, '\p{^Canonical_Combining_Class=-_CCC122}', "");
    Expect(1, 3788, '\P{Canonical_Combining_Class=-_CCC122}', "");
    Expect(0, 3788, '\P{^Canonical_Combining_Class=-_CCC122}', "");
    Error('\p{Ccc=_/a/12_2}');
    Error('\P{Ccc=_/a/12_2}');
    Expect(1, 3787, '\p{Ccc=:\A122\z:}', "");;
    Expect(0, 3788, '\p{Ccc=:\A122\z:}', "");;
    Expect(1, 3787, '\p{Ccc:   0000000122}', "");
    Expect(0, 3787, '\p{^Ccc:   0000000122}', "");
    Expect(0, 3787, '\P{Ccc:   0000000122}', "");
    Expect(1, 3787, '\P{^Ccc:   0000000122}', "");
    Expect(0, 3788, '\p{Ccc:   0000000122}', "");
    Expect(1, 3788, '\p{^Ccc:   0000000122}', "");
    Expect(1, 3788, '\P{Ccc:   0000000122}', "");
    Expect(0, 3788, '\P{^Ccc:   0000000122}', "");
    Error('\p{Is_Canonical_Combining_Class=:=_CCC122}');
    Error('\P{Is_Canonical_Combining_Class=:=_CCC122}');
    Expect(1, 3787, '\p{Is_Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3787, '\p{^Is_Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3787, '\P{Is_Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3787, '\P{^Is_Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3788, '\p{Is_Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3788, '\p{^Is_Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3788, '\P{Is_Canonical_Combining_Class=ccc122}', "");
    Expect(0, 3788, '\P{^Is_Canonical_Combining_Class=ccc122}', "");
    Expect(1, 3787, '\p{Is_Canonical_Combining_Class=	_CCC122}', "");
    Expect(0, 3787, '\p{^Is_Canonical_Combining_Class=	_CCC122}', "");
    Expect(0, 3787, '\P{Is_Canonical_Combining_Class=	_CCC122}', "");
    Expect(1, 3787, '\P{^Is_Canonical_Combining_Class=	_CCC122}', "");
    Expect(0, 3788, '\p{Is_Canonical_Combining_Class=	_CCC122}', "");
    Expect(1, 3788, '\p{^Is_Canonical_Combining_Class=	_CCC122}', "");
    Expect(1, 3788, '\P{Is_Canonical_Combining_Class=	_CCC122}', "");
    Expect(0, 3788, '\P{^Is_Canonical_Combining_Class=	_CCC122}', "");
    Error('\p{Is_Ccc=		0_0_0_0_0_0_0_122/a/}');
    Error('\P{Is_Ccc=		0_0_0_0_0_0_0_122/a/}');
    Expect(1, 3787, '\p{Is_Ccc=000000000122}', "");
    Expect(0, 3787, '\p{^Is_Ccc=000000000122}', "");
    Expect(0, 3787, '\P{Is_Ccc=000000000122}', "");
    Expect(1, 3787, '\P{^Is_Ccc=000000000122}', "");
    Expect(0, 3788, '\p{Is_Ccc=000000000122}', "");
    Expect(1, 3788, '\p{^Is_Ccc=000000000122}', "");
    Expect(1, 3788, '\P{Is_Ccc=000000000122}', "");
    Expect(0, 3788, '\P{^Is_Ccc=000000000122}', "");
    Error('\p{Canonical_Combining_Class=:=CCC129}');
    Error('\P{Canonical_Combining_Class=:=CCC129}');
    Expect(1, 3953, '\p{Canonical_Combining_Class=:\ACCC129\z:}', "");;
    Expect(0, 3954, '\p{Canonical_Combining_Class=:\ACCC129\z:}', "");;
    Expect(1, 3953, '\p{Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3953, '\p{^Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3953, '\P{Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3953, '\P{^Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3954, '\p{Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3954, '\p{^Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3954, '\P{Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3954, '\P{^Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3953, '\p{Canonical_Combining_Class=:\Accc129\z:}', "");;
    Expect(0, 3954, '\p{Canonical_Combining_Class=:\Accc129\z:}', "");;
    Expect(1, 3953, '\p{Canonical_Combining_Class=	 CCC129}', "");
    Expect(0, 3953, '\p{^Canonical_Combining_Class=	 CCC129}', "");
    Expect(0, 3953, '\P{Canonical_Combining_Class=	 CCC129}', "");
    Expect(1, 3953, '\P{^Canonical_Combining_Class=	 CCC129}', "");
    Expect(0, 3954, '\p{Canonical_Combining_Class=	 CCC129}', "");
    Expect(1, 3954, '\p{^Canonical_Combining_Class=	 CCC129}', "");
    Expect(1, 3954, '\P{Canonical_Combining_Class=	 CCC129}', "");
    Expect(0, 3954, '\P{^Canonical_Combining_Class=	 CCC129}', "");
    Error('\p{Ccc=:=+12_9}');
    Error('\P{Ccc=:=+12_9}');
    Expect(1, 3953, '\p{Ccc=:\A129\z:}', "");;
    Expect(0, 3954, '\p{Ccc=:\A129\z:}', "");;
    Expect(1, 3953, '\p{Ccc=0000000129}', "");
    Expect(0, 3953, '\p{^Ccc=0000000129}', "");
    Expect(0, 3953, '\P{Ccc=0000000129}', "");
    Expect(1, 3953, '\P{^Ccc=0000000129}', "");
    Expect(0, 3954, '\p{Ccc=0000000129}', "");
    Expect(1, 3954, '\p{^Ccc=0000000129}', "");
    Expect(1, 3954, '\P{Ccc=0000000129}', "");
    Expect(0, 3954, '\P{^Ccc=0000000129}', "");
    Error('\p{Is_Canonical_Combining_Class= CCC129/a/}');
    Error('\P{Is_Canonical_Combining_Class= CCC129/a/}');
    Expect(1, 3953, '\p{Is_Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3953, '\p{^Is_Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3953, '\P{Is_Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3953, '\P{^Is_Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3954, '\p{Is_Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3954, '\p{^Is_Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3954, '\P{Is_Canonical_Combining_Class=ccc129}', "");
    Expect(0, 3954, '\P{^Is_Canonical_Combining_Class=ccc129}', "");
    Expect(1, 3953, '\p{Is_Canonical_Combining_Class=-CCC129}', "");
    Expect(0, 3953, '\p{^Is_Canonical_Combining_Class=-CCC129}', "");
    Expect(0, 3953, '\P{Is_Canonical_Combining_Class=-CCC129}', "");
    Expect(1, 3953, '\P{^Is_Canonical_Combining_Class=-CCC129}', "");
    Expect(0, 3954, '\p{Is_Canonical_Combining_Class=-CCC129}', "");
    Expect(1, 3954, '\p{^Is_Canonical_Combining_Class=-CCC129}', "");
    Expect(1, 3954, '\P{Is_Canonical_Combining_Class=-CCC129}', "");
    Expect(0, 3954, '\P{^Is_Canonical_Combining_Class=-CCC129}', "");
    Error('\p{Is_Ccc=	/a/+000000000129}');
    Error('\P{Is_Ccc=	/a/+000000000129}');
    Expect(1, 3953, '\p{Is_Ccc=0_0_0_0_0_0129}', "");
    Expect(0, 3953, '\p{^Is_Ccc=0_0_0_0_0_0129}', "");
    Expect(0, 3953, '\P{Is_Ccc=0_0_0_0_0_0129}', "");
    Expect(1, 3953, '\P{^Is_Ccc=0_0_0_0_0_0129}', "");
    Expect(0, 3954, '\p{Is_Ccc=0_0_0_0_0_0129}', "");
    Expect(1, 3954, '\p{^Is_Ccc=0_0_0_0_0_0129}', "");
    Expect(1, 3954, '\P{Is_Ccc=0_0_0_0_0_0129}', "");
    Expect(0, 3954, '\P{^Is_Ccc=0_0_0_0_0_0129}', "");
    Error('\p{Canonical_Combining_Class=-/a/CCC13}');
    Error('\P{Canonical_Combining_Class=-/a/CCC13}');
    Expect(1, 1459, '\p{Canonical_Combining_Class=:\ACCC13\z:}', "");;
    Expect(0, 1460, '\p{Canonical_Combining_Class=:\ACCC13\z:}', "");;
    Expect(1, 1459, '\p{Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1459, '\p{^Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1459, '\P{Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1459, '\P{^Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1460, '\p{Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1460, '\p{^Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1460, '\P{Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1460, '\P{^Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1459, '\p{Canonical_Combining_Class=:\Accc13\z:}', "");;
    Expect(0, 1460, '\p{Canonical_Combining_Class=:\Accc13\z:}', "");;
    Expect(1, 1459, '\p{Canonical_Combining_Class= ccc13}', "");
    Expect(0, 1459, '\p{^Canonical_Combining_Class= ccc13}', "");
    Expect(0, 1459, '\P{Canonical_Combining_Class= ccc13}', "");
    Expect(1, 1459, '\P{^Canonical_Combining_Class= ccc13}', "");
    Expect(0, 1460, '\p{Canonical_Combining_Class= ccc13}', "");
    Expect(1, 1460, '\p{^Canonical_Combining_Class= ccc13}', "");
    Expect(1, 1460, '\P{Canonical_Combining_Class= ccc13}', "");
    Expect(0, 1460, '\P{^Canonical_Combining_Class= ccc13}', "");
    Error('\p{Ccc=:= 0013}');
    Error('\P{Ccc=:= 0013}');
    Expect(1, 1459, '\p{Ccc=:\A13\z:}', "");;
    Expect(0, 1460, '\p{Ccc=:\A13\z:}', "");;
    Expect(1, 1459, '\p{Ccc:   00000_00001_3}', "");
    Expect(0, 1459, '\p{^Ccc:   00000_00001_3}', "");
    Expect(0, 1459, '\P{Ccc:   00000_00001_3}', "");
    Expect(1, 1459, '\P{^Ccc:   00000_00001_3}', "");
    Expect(0, 1460, '\p{Ccc:   00000_00001_3}', "");
    Expect(1, 1460, '\p{^Ccc:   00000_00001_3}', "");
    Expect(1, 1460, '\P{Ccc:   00000_00001_3}', "");
    Expect(0, 1460, '\P{^Ccc:   00000_00001_3}', "");
    Error('\p{Is_Canonical_Combining_Class=_/a/CCC13}');
    Error('\P{Is_Canonical_Combining_Class=_/a/CCC13}');
    Expect(1, 1459, '\p{Is_Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1459, '\p{^Is_Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1459, '\P{Is_Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1459, '\P{^Is_Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1460, '\p{Is_Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1460, '\p{^Is_Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1460, '\P{Is_Canonical_Combining_Class=ccc13}', "");
    Expect(0, 1460, '\P{^Is_Canonical_Combining_Class=ccc13}', "");
    Expect(1, 1459, '\p{Is_Canonical_Combining_Class=- CCC13}', "");
    Expect(0, 1459, '\p{^Is_Canonical_Combining_Class=- CCC13}', "");
    Expect(0, 1459, '\P{Is_Canonical_Combining_Class=- CCC13}', "");
    Expect(1, 1459, '\P{^Is_Canonical_Combining_Class=- CCC13}', "");
    Expect(0, 1460, '\p{Is_Canonical_Combining_Class=- CCC13}', "");
    Expect(1, 1460, '\p{^Is_Canonical_Combining_Class=- CCC13}', "");
    Expect(1, 1460, '\P{Is_Canonical_Combining_Class=- CCC13}', "");
    Expect(0, 1460, '\P{^Is_Canonical_Combining_Class=- CCC13}', "");
    Error('\p{Is_Ccc=/a/ 00000013}');
    Error('\P{Is_Ccc=/a/ 00000013}');
    Expect(1, 1459, '\p{Is_Ccc=0_0_0_13}', "");
    Expect(0, 1459, '\p{^Is_Ccc=0_0_0_13}', "");
    Expect(0, 1459, '\P{Is_Ccc=0_0_0_13}', "");
    Expect(1, 1459, '\P{^Is_Ccc=0_0_0_13}', "");
    Expect(0, 1460, '\p{Is_Ccc=0_0_0_13}', "");
    Expect(1, 1460, '\p{^Is_Ccc=0_0_0_13}', "");
    Expect(1, 1460, '\P{Is_Ccc=0_0_0_13}', "");
    Expect(0, 1460, '\P{^Is_Ccc=0_0_0_13}', "");
    Error('\p{Canonical_Combining_Class=/a/  CCC130}');
    Error('\P{Canonical_Combining_Class=/a/  CCC130}');
    Expect(1, 3968, '\p{Canonical_Combining_Class=:\ACCC130\z:}', "");;
    Expect(0, 3969, '\p{Canonical_Combining_Class=:\ACCC130\z:}', "");;
    Expect(1, 3968, '\p{Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3968, '\p{^Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3968, '\P{Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3968, '\P{^Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3969, '\p{Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3969, '\p{^Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3969, '\P{Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3969, '\P{^Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3968, '\p{Canonical_Combining_Class=:\Accc130\z:}', "");;
    Expect(0, 3969, '\p{Canonical_Combining_Class=:\Accc130\z:}', "");;
    Expect(1, 3968, '\p{Canonical_Combining_Class=-ccc130}', "");
    Expect(0, 3968, '\p{^Canonical_Combining_Class=-ccc130}', "");
    Expect(0, 3968, '\P{Canonical_Combining_Class=-ccc130}', "");
    Expect(1, 3968, '\P{^Canonical_Combining_Class=-ccc130}', "");
    Expect(0, 3969, '\p{Canonical_Combining_Class=-ccc130}', "");
    Expect(1, 3969, '\p{^Canonical_Combining_Class=-ccc130}', "");
    Expect(1, 3969, '\P{Canonical_Combining_Class=-ccc130}', "");
    Expect(0, 3969, '\P{^Canonical_Combining_Class=-ccc130}', "");
    Error('\p{Ccc=:= 	13_0}');
    Error('\P{Ccc=:= 	13_0}');
    Expect(1, 3968, '\p{Ccc=:\A130\z:}', "");;
    Expect(0, 3969, '\p{Ccc=:\A130\z:}', "");;
    Expect(1, 3968, '\p{Ccc=0130}', "");
    Expect(0, 3968, '\p{^Ccc=0130}', "");
    Expect(0, 3968, '\P{Ccc=0130}', "");
    Expect(1, 3968, '\P{^Ccc=0130}', "");
    Expect(0, 3969, '\p{Ccc=0130}', "");
    Expect(1, 3969, '\p{^Ccc=0130}', "");
    Expect(1, 3969, '\P{Ccc=0130}', "");
    Expect(0, 3969, '\P{^Ccc=0130}', "");
    Error('\p{Is_Canonical_Combining_Class=_:=ccc130}');
    Error('\P{Is_Canonical_Combining_Class=_:=ccc130}');
    Expect(1, 3968, '\p{Is_Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3968, '\p{^Is_Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3968, '\P{Is_Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3968, '\P{^Is_Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3969, '\p{Is_Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3969, '\p{^Is_Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3969, '\P{Is_Canonical_Combining_Class=ccc130}', "");
    Expect(0, 3969, '\P{^Is_Canonical_Combining_Class=ccc130}', "");
    Expect(1, 3968, '\p{Is_Canonical_Combining_Class:   -CCC130}', "");
    Expect(0, 3968, '\p{^Is_Canonical_Combining_Class:   -CCC130}', "");
    Expect(0, 3968, '\P{Is_Canonical_Combining_Class:   -CCC130}', "");
    Expect(1, 3968, '\P{^Is_Canonical_Combining_Class:   -CCC130}', "");
    Expect(0, 3969, '\p{Is_Canonical_Combining_Class:   -CCC130}', "");
    Expect(1, 3969, '\p{^Is_Canonical_Combining_Class:   -CCC130}', "");
    Expect(1, 3969, '\P{Is_Canonical_Combining_Class:   -CCC130}', "");
    Expect(0, 3969, '\P{^Is_Canonical_Combining_Class:   -CCC130}', "");
    Error('\p{Is_Ccc=-_130/a/}');
    Error('\P{Is_Ccc=-_130/a/}');
    Expect(1, 3968, '\p{Is_Ccc=000130}', "");
    Expect(0, 3968, '\p{^Is_Ccc=000130}', "");
    Expect(0, 3968, '\P{Is_Ccc=000130}', "");
    Expect(1, 3968, '\P{^Is_Ccc=000130}', "");
    Expect(0, 3969, '\p{Is_Ccc=000130}', "");
    Expect(1, 3969, '\p{^Is_Ccc=000130}', "");
    Expect(1, 3969, '\P{Is_Ccc=000130}', "");
    Expect(0, 3969, '\P{^Is_Ccc=000130}', "");
    Error('\p{Canonical_Combining_Class=-CCC132/a/}');
    Error('\P{Canonical_Combining_Class=-CCC132/a/}');
    Expect(1, 3956, '\p{Canonical_Combining_Class=:\ACCC132\z:}', "");;
    Expect(0, 3957, '\p{Canonical_Combining_Class=:\ACCC132\z:}', "");;
    Expect(1, 3956, '\p{Canonical_Combining_Class=ccc132}', "");
    Expect(0, 3956, '\p{^Canonical_Combining_Class=ccc132}', "");
    Expect(0, 3956, '\P{Canonical_Combining_Class=ccc132}', "");
    Expect(1, 3956, '\P{^Canonical_Combining_Class=ccc132}', "");
    Expect(0, 3957, '\p{Canonical_Combining_Class=ccc132}', "");
    Expect(1, 3957, '\p{^Canonical_Combining_Class=ccc132}', "");
    Expect(1, 3957, '\P{Canonical_Combining_Class=ccc132}', "");
    Expect(0, 3957, '\P{^Canonical_Combining_Class=ccc132}', "");
    Expect(1, 3956, '\p{Canonical_Combining_Class=:\Accc132\z:}', "");;
    Expect(0, 3957, '\p{Canonical_Combining_Class=:\Accc132\z:}', "");;
    Expect(1, 3956, '\p{Canonical_Combining_Class=	CCC132}', "");
    Expect(0, 3956, '\p{^Canonical_Combining_Class=	CCC132}', "");
    Expect(0, 3956, '\P{Canonical_Combining_Class=	CCC132}', "");
    Expect(1, 3956, '\P{^Canonical_Combining_Class=	CCC132}', "");
    Expect(0, 3957, '\p{Canonical_Combining_Class=	CCC132}', "");
    Expect(1, 3957, '\p{^Canonical_Combining_Class=	CCC132}', "");
    Expect(1, 3957, '\P{Canonical_Combining_Class=	CCC132}', "");
    Expect(0, 3957, '\P{^Canonical_Combining_Class=	CCC132}', "");
    Error('\p{Ccc=:=_+00132}');
    Error('\P{Ccc=:=_+00132}');
    Expect(1, 3956, '\p{Ccc=:\A132\z:}', "");;
    Expect(0, 3957, '\p{Ccc=:\A132\z:}', "");;
    Expect(1, 3956, '\p{Ccc=+000013_2}', "");
    Expect(0, 3956, '\p{^Ccc=+000013_2}', "");
    Expect(0, 3956, '\P{Ccc=+000013_2}', "");
    Expect(1, 3956, '\P{^Ccc=+000013_2}', "");
    Expect(0, 3957, '\p{Ccc=+000013_2}', "");
    Expect(1, 3957, '\p{^Ccc=+000013_2}', "");
    Expect(1, 3957, '\P{Ccc=+000013_2}', "");
    Expect(0, 3957, '\P{^Ccc=+000013_2}', "");
    Error('\p{Is_Canonical_Combining_Class:   :=ccc132}');
    Error('\P{Is_Canonical_Combining_Class:   :=ccc132}');
    Expect(1, 3956, '\p{Is_Canonical_Combining_Class: ccc132}', "");
    Expect(0, 3956, '\p{^Is_Canonical_Combining_Class: ccc132}', "");
    Expect(0, 3956, '\P{Is_Canonical_Combining_Class: ccc132}', "");
    Expect(1, 3956, '\P{^Is_Canonical_Combining_Class: ccc132}', "");
    Expect(0, 3957, '\p{Is_Canonical_Combining_Class: ccc132}', "");
    Expect(1, 3957, '\p{^Is_Canonical_Combining_Class: ccc132}', "");
    Expect(1, 3957, '\P{Is_Canonical_Combining_Class: ccc132}', "");
    Expect(0, 3957, '\P{^Is_Canonical_Combining_Class: ccc132}', "");
    Expect(1, 3956, '\p{Is_Canonical_Combining_Class=_CCC132}', "");
    Expect(0, 3956, '\p{^Is_Canonical_Combining_Class=_CCC132}', "");
    Expect(0, 3956, '\P{Is_Canonical_Combining_Class=_CCC132}', "");
    Expect(1, 3956, '\P{^Is_Canonical_Combining_Class=_CCC132}', "");
    Expect(0, 3957, '\p{Is_Canonical_Combining_Class=_CCC132}', "");
    Expect(1, 3957, '\p{^Is_Canonical_Combining_Class=_CCC132}', "");
    Expect(1, 3957, '\P{Is_Canonical_Combining_Class=_CCC132}', "");
    Expect(0, 3957, '\P{^Is_Canonical_Combining_Class=_CCC132}', "");
    Error('\p{Is_Ccc=_-00000000132/a/}');
    Error('\P{Is_Ccc=_-00000000132/a/}');
    Expect(1, 3956, '\p{Is_Ccc=013_2}', "");
    Expect(0, 3956, '\p{^Is_Ccc=013_2}', "");
    Expect(0, 3956, '\P{Is_Ccc=013_2}', "");
    Expect(1, 3956, '\P{^Is_Ccc=013_2}', "");
    Expect(0, 3957, '\p{Is_Ccc=013_2}', "");
    Expect(1, 3957, '\p{^Is_Ccc=013_2}', "");
    Expect(1, 3957, '\P{Is_Ccc=013_2}', "");
    Expect(0, 3957, '\P{^Is_Ccc=013_2}', "");
    Error('\p{Canonical_Combining_Class=-CCC133/a/}');
    Error('\P{Canonical_Combining_Class=-CCC133/a/}');
    Expect(0, 1, '\p{Canonical_Combining_Class=:\ACCC133\z:}', "");;
    Expect(0, 1, '\p{Canonical_Combining_Class=ccc133}', "");
    Expect(1, 1, '\p{^Canonical_Combining_Class=ccc133}', "");
    Expect(1, 1, '\P{Canonical_Combining_Class=ccc133}', "");
    Expect(0, 1, '\P{^Canonical_Combining_Class=ccc133}', "");
    Expect(0, 1, '\p{Canonical_Combining_Class=:\Accc133\z:}', "");;
    Expect(0, 1, '\p{Canonical_Combining_Class=		ccc133}', "");
    Expect(1, 1, '\p{^Canonical_Combining_Class=		ccc133}', "");
    Expect(1, 1, '\P{Canonical_Combining_Class=		ccc133}', "");
    Expect(0, 1, '\P{^Canonical_Combining_Class=		ccc133}', "");
    Error('\p{Ccc=_	000013_3:=}');
    Error('\P{Ccc=_	000013_3:=}');
    Expect(0, 1, '\p{Ccc=:\A133\z:}', "");;
    Expect(0, 1, '\p{Ccc=000000000133}', "");
    Expect(1, 1, '\p{^Ccc=000000000133}', "");
    Expect(1, 1, '\P{Ccc=000000000133}', "");
    Expect(0, 1, '\P{^Ccc=000000000133}', "");
    Error('\p{Is_Canonical_Combining_Class= /a/CCC133}');
    Error('\P{Is_Canonical_Combining_Class= /a/CCC133}');
    Expect(0, 1, '\p{Is_Canonical_Combining_Class=ccc133}', "");
    Expect(1, 1, '\p{^Is_Canonical_Combining_Class=ccc133}', "");
    Expect(1, 1, '\P{Is_Canonical_Combining_Class=ccc133}', "");
    Expect(0, 1, '\P{^Is_Canonical_Combining_Class=ccc133}', "");
    Expect(0, 1, '\p{Is_Canonical_Combining_Class=__CCC133}', "");
    Expect(1, 1, '\p{^Is_Canonical_Combining_Class=__CCC133}', "");
    Expect(1, 1, '\P{Is_Canonical_Combining_Class=__CCC133}', "");
    Expect(0, 1, '\P{^Is_Canonical_Combining_Class=__CCC133}', "");
    Error('\p{Is_Ccc=	:=0000000013_3}');
    Error('\P{Is_Ccc=	:=0000000013_3}');
    Expect(0, 1, '\p{Is_Ccc=+0133}', "");
    Expect(1, 1, '\p{^Is_Ccc=+0133}', "");
    Expect(1, 1, '\P{Is_Ccc=+0133}', "");
    Expect(0, 1, '\P{^Is_Ccc=+0133}', "");
    Error('\p{Canonical_Combining_Class=_ ccc14:=}');
    Error('\P{Canonical_Combining_Class=_ ccc14:=}');
    Expect(1, 1460, '\p{Canonical_Combining_Class=:\ACCC14\z:}', "");;
    Expect(0, 1461, '\p{Canonical_Combining_Class=:\ACCC14\z:}', "");;
    Expect(1, 1460, '\p{Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1460, '\p{^Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1460, '\P{Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1460, '\P{^Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1461, '\p{Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1461, '\p{^Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1461, '\P{Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1461, '\P{^Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1460, '\p{Canonical_Combining_Class=:\Accc14\z:}', "");;
    Expect(0, 1461, '\p{Canonical_Combining_Class=:\Accc14\z:}', "");;
    Expect(1, 1460, '\p{Canonical_Combining_Class= CCC14}', "");
    Expect(0, 1460, '\p{^Canonical_Combining_Class= CCC14}', "");
    Expect(0, 1460, '\P{Canonical_Combining_Class= CCC14}', "");
    Expect(1, 1460, '\P{^Canonical_Combining_Class= CCC14}', "");
    Expect(0, 1461, '\p{Canonical_Combining_Class= CCC14}', "");
    Expect(1, 1461, '\p{^Canonical_Combining_Class= CCC14}', "");
    Expect(1, 1461, '\P{Canonical_Combining_Class= CCC14}', "");
    Expect(0, 1461, '\P{^Canonical_Combining_Class= CCC14}', "");
    Error('\p{Ccc= 	00000000014:=}');
    Error('\P{Ccc= 	00000000014:=}');
    Expect(1, 1460, '\p{Ccc=:\A14\z:}', "");;
    Expect(0, 1461, '\p{Ccc=:\A14\z:}', "");;
    Expect(1, 1460, '\p{Ccc=0_0_14}', "");
    Expect(0, 1460, '\p{^Ccc=0_0_14}', "");
    Expect(0, 1460, '\P{Ccc=0_0_14}', "");
    Expect(1, 1460, '\P{^Ccc=0_0_14}', "");
    Expect(0, 1461, '\p{Ccc=0_0_14}', "");
    Expect(1, 1461, '\p{^Ccc=0_0_14}', "");
    Expect(1, 1461, '\P{Ccc=0_0_14}', "");
    Expect(0, 1461, '\P{^Ccc=0_0_14}', "");
    Error('\p{Is_Canonical_Combining_Class=_CCC14/a/}');
    Error('\P{Is_Canonical_Combining_Class=_CCC14/a/}');
    Expect(1, 1460, '\p{Is_Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1460, '\p{^Is_Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1460, '\P{Is_Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1460, '\P{^Is_Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1461, '\p{Is_Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1461, '\p{^Is_Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1461, '\P{Is_Canonical_Combining_Class=ccc14}', "");
    Expect(0, 1461, '\P{^Is_Canonical_Combining_Class=ccc14}', "");
    Expect(1, 1460, '\p{Is_Canonical_Combining_Class=  ccc14}', "");
    Expect(0, 1460, '\p{^Is_Canonical_Combining_Class=  ccc14}', "");
    Expect(0, 1460, '\P{Is_Canonical_Combining_Class=  ccc14}', "");
    Expect(1, 1460, '\P{^Is_Canonical_Combining_Class=  ccc14}', "");
    Expect(0, 1461, '\p{Is_Canonical_Combining_Class=  ccc14}', "");
    Expect(1, 1461, '\p{^Is_Canonical_Combining_Class=  ccc14}', "");
    Expect(1, 1461, '\P{Is_Canonical_Combining_Class=  ccc14}', "");
    Expect(0, 1461, '\P{^Is_Canonical_Combining_Class=  ccc14}', "");
    Error('\p{Is_Ccc=:=01_4}');
    Error('\P{Is_Ccc=:=01_4}');
    Expect(1, 1460, '\p{Is_Ccc=1_4}', "");
    Expect(0, 1460, '\p{^Is_Ccc=1_4}', "");
    Expect(0, 1460, '\P{Is_Ccc=1_4}', "");
    Expect(1, 1460, '\P{^Is_Ccc=1_4}', "");
    Expect(0, 1461, '\p{Is_Ccc=1_4}', "");
    Expect(1, 1461, '\p{^Is_Ccc=1_4}', "");
    Expect(1, 1461, '\P{Is_Ccc=1_4}', "");
    Expect(0, 1461, '\P{^Is_Ccc=1_4}', "");
    Error('\p{Canonical_Combining_Class=/a/_ccc15}');
    Error('\P{Canonical_Combining_Class=/a/_ccc15}');
    Expect(1, 1461, '\p{Canonical_Combining_Class=:\ACCC15\z:}', "");;
    Expect(0, 1462, '\p{Canonical_Combining_Class=:\ACCC15\z:}', "");;
    Expect(1, 1461, '\p{Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1461, '\p{^Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1461, '\P{Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1461, '\P{^Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1462, '\p{Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1462, '\p{^Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1462, '\P{Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1462, '\P{^Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1461, '\p{Canonical_Combining_Class=:\Accc15\z:}', "");;
    Expect(0, 1462, '\p{Canonical_Combining_Class=:\Accc15\z:}', "");;
    Expect(1, 1461, '\p{Canonical_Combining_Class=_ CCC15}', "");
    Expect(0, 1461, '\p{^Canonical_Combining_Class=_ CCC15}', "");
    Expect(0, 1461, '\P{Canonical_Combining_Class=_ CCC15}', "");
    Expect(1, 1461, '\P{^Canonical_Combining_Class=_ CCC15}', "");
    Expect(0, 1462, '\p{Canonical_Combining_Class=_ CCC15}', "");
    Expect(1, 1462, '\p{^Canonical_Combining_Class=_ CCC15}', "");
    Expect(1, 1462, '\P{Canonical_Combining_Class=_ CCC15}', "");
    Expect(0, 1462, '\P{^Canonical_Combining_Class=_ CCC15}', "");
    Error('\p{Ccc=/a/_+1_5}');
    Error('\P{Ccc=/a/_+1_5}');
    Expect(1, 1461, '\p{Ccc=:\A15\z:}', "");;
    Expect(0, 1462, '\p{Ccc=:\A15\z:}', "");;
    Expect(1, 1461, '\p{Ccc=000015}', "");
    Expect(0, 1461, '\p{^Ccc=000015}', "");
    Expect(0, 1461, '\P{Ccc=000015}', "");
    Expect(1, 1461, '\P{^Ccc=000015}', "");
    Expect(0, 1462, '\p{Ccc=000015}', "");
    Expect(1, 1462, '\p{^Ccc=000015}', "");
    Expect(1, 1462, '\P{Ccc=000015}', "");
    Expect(0, 1462, '\P{^Ccc=000015}', "");
    Error('\p{Is_Canonical_Combining_Class=  CCC15:=}');
    Error('\P{Is_Canonical_Combining_Class=  CCC15:=}');
    Expect(1, 1461, '\p{Is_Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1461, '\p{^Is_Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1461, '\P{Is_Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1461, '\P{^Is_Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1462, '\p{Is_Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1462, '\p{^Is_Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1462, '\P{Is_Canonical_Combining_Class=ccc15}', "");
    Expect(0, 1462, '\P{^Is_Canonical_Combining_Class=ccc15}', "");
    Expect(1, 1461, '\p{Is_Canonical_Combining_Class=_CCC15}', "");
    Expect(0, 1461, '\p{^Is_Canonical_Combining_Class=_CCC15}', "");
    Expect(0, 1461, '\P{Is_Canonical_Combining_Class=_CCC15}', "");
    Expect(1, 1461, '\P{^Is_Canonical_Combining_Class=_CCC15}', "");
    Expect(0, 1462, '\p{Is_Canonical_Combining_Class=_CCC15}', "");
    Expect(1, 1462, '\p{^Is_Canonical_Combining_Class=_CCC15}', "");
    Expect(1, 1462, '\P{Is_Canonical_Combining_Class=_CCC15}', "");
    Expect(0, 1462, '\P{^Is_Canonical_Combining_Class=_CCC15}', "");
    Error('\p{Is_Ccc=	_00000015:=}');
    Error('\P{Is_Ccc=	_00000015:=}');
    Expect(1, 1461, '\p{Is_Ccc=0000015}', "");
    Expect(0, 1461, '\p{^Is_Ccc=0000015}', "");
    Expect(0, 1461, '\P{Is_Ccc=0000015}', "");
    Expect(1, 1461, '\P{^Is_Ccc=0000015}', "");
    Expect(0, 1462, '\p{Is_Ccc=0000015}', "");
    Expect(1, 1462, '\p{^Is_Ccc=0000015}', "");
    Expect(1, 1462, '\P{Is_Ccc=0000015}', "");
    Expect(0, 1462, '\P{^Is_Ccc=0000015}', "");
    Error('\p{Canonical_Combining_Class=:= -CCC16}');
    Error('\P{Canonical_Combining_Class=:= -CCC16}');
    Expect(1, 1462, '\p{Canonical_Combining_Class=:\ACCC16\z:}', "");;
    Expect(0, 1463, '\p{Canonical_Combining_Class=:\ACCC16\z:}', "");;
    Expect(1, 1462, '\p{Canonical_Combining_Class=ccc16}', "");
    Expect(0, 1462, '\p{^Canonical_Combining_Class=ccc16}', "");
    Expect(0, 1462, '\P{Canonical_Combining_Class=ccc16}', "");
    Expect(1, 1462, '\P{^Canonical_Combining_Class=ccc16}', "");
    Expect(0, 1463, '\p{Canonical_Combining_Class=ccc16}', "");
    Expect(1, 1463, '\p{^Canonical_Combining_Class=ccc16}', "");
    Expect(1, 1463, '\P{Canonical_Combining_Class=ccc16}', "");
    Expect(0, 1463, '\P{^Canonical_Combining_Class=ccc16}', "");
    Expect(1, 1462, '\p{Canonical_Combining_Class=:\Accc16\z:}', "");;
    Expect(0, 1463, '\p{Canonical_Combining_Class=:\Accc16\z:}', "");;
    Expect(1, 1462, '\p{Canonical_Combining_Class=	_ccc16}', "");
    Expect(0, 1462, '\p{^Canonical_Combining_Class=	_ccc16}', "");
    Expect(0, 1462, '\P{Canonical_Combining_Class=	_ccc16}', "");
    Expect(1, 1462, '\P{^Canonical_Combining_Class=	_ccc16}', "");
    Expect(0, 1463, '\p{Canonical_Combining_Class=	_ccc16}', "");
    Expect(1, 1463, '\p{^Canonical_Combining_Class=	_ccc16}', "");
    Expect(1, 1463, '\P{Canonical_Combining_Class=	_ccc16}', "");
    Expect(0, 1463, '\P{^Canonical_Combining_Class=	_ccc16}', "");
    Error('\p{Ccc=-/a/+00000000016}');
    Error('\P{Ccc=-/a/+00000000016}');
    Expect(1, 1462, '\p{Ccc=:\A16\z:}', "");;
    Expect(0, 1463, '\p{Ccc=:\A16\z:}', "");;
    Expect(1, 1462, '\p{Ccc=+016}', "");
    Expect(0, 1462, '\p{^Ccc=+016}', "");
    Expect(0, 1462, '\P{Ccc=+016}', "");
    Expect(1, 1462, '\P{^Ccc=+016}', "");
    Expect(0, 1463, '\p{Ccc=+016}', "");
    Expect(1, 1463, '\p{^Ccc=+016}', "");
    Expect(1, 1463, '\P{Ccc=+016}', "");
    Expect(0, 1463, '\P{^Ccc=+016}', "");
    Error('\p{Is_Canonical_Combining_Class=:= CCC16}');
    Error('\P{Is_Canonical_Combining_Class=:= CCC16}');
    Expect(1, 1462, '\p{Is_Canonical_Combining_Class:ccc16}', "");
    Expect(0, 1462, '\p{^Is_Canonical_Combining_Class:ccc16}', "");
    Expect(0, 1462, '\P{Is_Canonical_Combining_Class:ccc16}', "");
    Expect(1, 1462, '\P{^Is_Canonical_Combining_Class:ccc16}', "");
    Expect(0, 1463, '\p{Is_Canonical_Combining_Class:ccc16}', "");
    Expect(1, 1463, '\p{^Is_Canonical_Combining_Class:ccc16}', "");
    Expect(1, 1463, '\P{Is_Canonical_Combining_Class:ccc16}', "");
    Expect(0, 1463, '\P{^Is_Canonical_Combining_Class:ccc16}', "");
    Expect(1, 1462, '\p{Is_Canonical_Combining_Class=CCC16}', "");
    Expect(0, 1462, '\p{^Is_Canonical_Combining_Class=CCC16}', "");
    Expect(0, 1462, '\P{Is_Canonical_Combining_Class=CCC16}', "");
    Expect(1, 1462, '\P{^Is_Canonical_Combining_Class=CCC16}', "");
    Expect(0, 1463, '\p{Is_Canonical_Combining_Class=CCC16}', "");
    Expect(1, 1463, '\p{^Is_Canonical_Combining_Class=CCC16}', "");
    Expect(1, 1463, '\P{Is_Canonical_Combining_Class=CCC16}', "");
    Expect(0, 1463, '\P{^Is_Canonical_Combining_Class=CCC16}', "");
    Error('\p{Is_Ccc: /a/	_+1_6}');
    Error('\P{Is_Ccc: /a/	_+1_6}');
    Expect(1, 1462, '\p{Is_Ccc=00000016}', "");
    Expect(0, 1462, '\p{^Is_Ccc=00000016}', "");
    Expect(0, 1462, '\P{Is_Ccc=00000016}', "");
    Expect(1, 1462, '\P{^Is_Ccc=00000016}', "");
    Expect(0, 1463, '\p{Is_Ccc=00000016}', "");
    Expect(1, 1463, '\p{^Is_Ccc=00000016}', "");
    Expect(1, 1463, '\P{Is_Ccc=00000016}', "");
    Expect(0, 1463, '\P{^Is_Ccc=00000016}', "");
    Error('\p{Canonical_Combining_Class=/a/- ccc17}');
    Error('\P{Canonical_Combining_Class=/a/- ccc17}');
    Expect(1, 1463, '\p{Canonical_Combining_Class=:\ACCC17\z:}', "");;
    Expect(0, 1464, '\p{Canonical_Combining_Class=:\ACCC17\z:}', "");;
    Expect(1, 1463, '\p{Canonical_Combining_Class=ccc17}', "");
    Expect(0, 1463, '\p{^Canonical_Combining_Class=ccc17}', "");
    Expect(0, 1463, '\P{Canonical_Combining_Class=ccc17}', "");
    Expect(1, 1463, '\P{^Canonical_Combining_Class=ccc17}', "");
    Expect(0, 1464, '\p{Canonical_Combining_Class=ccc17}', "");
    Expect(1, 1464, '\p{^Canonical_Combining_Class=ccc17}', "");
    Expect(1, 1464, '\P{Canonical_Combining_Class=ccc17}', "");
    Expect(0, 1464, '\P{^Canonical_Combining_Class=ccc17}', "");
    Expect(1, 1463, '\p{Canonical_Combining_Class=:\Accc17\z:}', "");;
    Expect(0, 1464, '\p{Canonical_Combining_Class=:\Accc17\z:}', "");;
    Expect(1, 1463, '\p{Canonical_Combining_Class= 	CCC17}', "");
    Expect(0, 1463, '\p{^Canonical_Combining_Class= 	CCC17}', "");
    Expect(0, 1463, '\P{Canonical_Combining_Class= 	CCC17}', "");
    Expect(1, 1463, '\P{^Canonical_Combining_Class= 	CCC17}', "");
    Expect(0, 1464, '\p{Canonical_Combining_Class= 	CCC17}', "");
    Expect(1, 1464, '\p{^Canonical_Combining_Class= 	CCC17}', "");
    Expect(1, 1464, '\P{Canonical_Combining_Class= 	CCC17}', "");
    Expect(0, 1464, '\P{^Canonical_Combining_Class= 	CCC17}', "");
    Error('\p{Ccc=--+00000000017/a/}');
    Error('\P{Ccc=--+00000000017/a/}');
    Expect(1, 1463, '\p{Ccc=:\A17\z:}', "");;
    Expect(0, 1464, '\p{Ccc=:\A17\z:}', "");;
    Expect(1, 1463, '\p{Ccc=0000000017}', "");
    Expect(0, 1463, '\p{^Ccc=0000000017}', "");
    Expect(0, 1463, '\P{Ccc=0000000017}', "");
    Expect(1, 1463, '\P{^Ccc=0000000017}', "");
    Expect(0, 1464, '\p{Ccc=0000000017}', "");
    Expect(1, 1464, '\p{^Ccc=0000000017}', "");
    Expect(1, 1464, '\P{Ccc=0000000017}', "");
    Expect(0, 1464, '\P{^Ccc=0000000017}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/		CCC17}');
    Error('\P{Is_Canonical_Combining_Class=/a/		CCC17}');
    Expect(1, 1463, '\p{Is_Canonical_Combining_Class:	ccc17}', "");
    Expect(0, 1463, '\p{^Is_Canonical_Combining_Class:	ccc17}', "");
    Expect(0, 1463, '\P{Is_Canonical_Combining_Class:	ccc17}', "");
    Expect(1, 1463, '\P{^Is_Canonical_Combining_Class:	ccc17}', "");
    Expect(0, 1464, '\p{Is_Canonical_Combining_Class:	ccc17}', "");
    Expect(1, 1464, '\p{^Is_Canonical_Combining_Class:	ccc17}', "");
    Expect(1, 1464, '\P{Is_Canonical_Combining_Class:	ccc17}', "");
    Expect(0, 1464, '\P{^Is_Canonical_Combining_Class:	ccc17}', "");
    Expect(1, 1463, '\p{Is_Canonical_Combining_Class=--CCC17}', "");
    Expect(0, 1463, '\p{^Is_Canonical_Combining_Class=--CCC17}', "");
    Expect(0, 1463, '\P{Is_Canonical_Combining_Class=--CCC17}', "");
    Expect(1, 1463, '\P{^Is_Canonical_Combining_Class=--CCC17}', "");
    Expect(0, 1464, '\p{Is_Canonical_Combining_Class=--CCC17}', "");
    Expect(1, 1464, '\p{^Is_Canonical_Combining_Class=--CCC17}', "");
    Expect(1, 1464, '\P{Is_Canonical_Combining_Class=--CCC17}', "");
    Expect(0, 1464, '\P{^Is_Canonical_Combining_Class=--CCC17}', "");
    Error('\p{Is_Ccc:	_:=+000000017}');
    Error('\P{Is_Ccc:	_:=+000000017}');
    Expect(1, 1463, '\p{Is_Ccc=+000000017}', "");
    Expect(0, 1463, '\p{^Is_Ccc=+000000017}', "");
    Expect(0, 1463, '\P{Is_Ccc=+000000017}', "");
    Expect(1, 1463, '\P{^Is_Ccc=+000000017}', "");
    Expect(0, 1464, '\p{Is_Ccc=+000000017}', "");
    Expect(1, 1464, '\p{^Is_Ccc=+000000017}', "");
    Expect(1, 1464, '\P{Is_Ccc=+000000017}', "");
    Expect(0, 1464, '\P{^Is_Ccc=+000000017}', "");
    Error('\p{Canonical_Combining_Class= /a/CCC18}');
    Error('\P{Canonical_Combining_Class= /a/CCC18}');
    Expect(1, 1479, '\p{Canonical_Combining_Class=:\ACCC18\z:}', "");;
    Expect(0, 1480, '\p{Canonical_Combining_Class=:\ACCC18\z:}', "");;
    Expect(1, 1479, '\p{Canonical_Combining_Class:   ccc18}', "");
    Expect(0, 1479, '\p{^Canonical_Combining_Class:   ccc18}', "");
    Expect(0, 1479, '\P{Canonical_Combining_Class:   ccc18}', "");
    Expect(1, 1479, '\P{^Canonical_Combining_Class:   ccc18}', "");
    Expect(0, 1480, '\p{Canonical_Combining_Class:   ccc18}', "");
    Expect(1, 1480, '\p{^Canonical_Combining_Class:   ccc18}', "");
    Expect(1, 1480, '\P{Canonical_Combining_Class:   ccc18}', "");
    Expect(0, 1480, '\P{^Canonical_Combining_Class:   ccc18}', "");
    Expect(1, 1479, '\p{Canonical_Combining_Class=:\Accc18\z:}', "");;
    Expect(0, 1480, '\p{Canonical_Combining_Class=:\Accc18\z:}', "");;
    Expect(1, 1479, '\p{Canonical_Combining_Class=		ccc18}', "");
    Expect(0, 1479, '\p{^Canonical_Combining_Class=		ccc18}', "");
    Expect(0, 1479, '\P{Canonical_Combining_Class=		ccc18}', "");
    Expect(1, 1479, '\P{^Canonical_Combining_Class=		ccc18}', "");
    Expect(0, 1480, '\p{Canonical_Combining_Class=		ccc18}', "");
    Expect(1, 1480, '\p{^Canonical_Combining_Class=		ccc18}', "");
    Expect(1, 1480, '\P{Canonical_Combining_Class=		ccc18}', "");
    Expect(0, 1480, '\P{^Canonical_Combining_Class=		ccc18}', "");
    Error('\p{Ccc=_/a/+0001_8}');
    Error('\P{Ccc=_/a/+0001_8}');
    Expect(1, 1479, '\p{Ccc=:\A18\z:}', "");;
    Expect(0, 1480, '\p{Ccc=:\A18\z:}', "");;
    Expect(1, 1479, '\p{Ccc=0_0_18}', "");
    Expect(0, 1479, '\p{^Ccc=0_0_18}', "");
    Expect(0, 1479, '\P{Ccc=0_0_18}', "");
    Expect(1, 1479, '\P{^Ccc=0_0_18}', "");
    Expect(0, 1480, '\p{Ccc=0_0_18}', "");
    Expect(1, 1480, '\p{^Ccc=0_0_18}', "");
    Expect(1, 1480, '\P{Ccc=0_0_18}', "");
    Expect(0, 1480, '\P{^Ccc=0_0_18}', "");
    Error('\p{Is_Canonical_Combining_Class=:=_ccc18}');
    Error('\P{Is_Canonical_Combining_Class=:=_ccc18}');
    Expect(1, 1479, '\p{Is_Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1479, '\p{^Is_Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1479, '\P{Is_Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1479, '\P{^Is_Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1480, '\p{Is_Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1480, '\p{^Is_Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1480, '\P{Is_Canonical_Combining_Class=ccc18}', "");
    Expect(0, 1480, '\P{^Is_Canonical_Combining_Class=ccc18}', "");
    Expect(1, 1479, '\p{Is_Canonical_Combining_Class=CCC18}', "");
    Expect(0, 1479, '\p{^Is_Canonical_Combining_Class=CCC18}', "");
    Expect(0, 1479, '\P{Is_Canonical_Combining_Class=CCC18}', "");
    Expect(1, 1479, '\P{^Is_Canonical_Combining_Class=CCC18}', "");
    Expect(0, 1480, '\p{Is_Canonical_Combining_Class=CCC18}', "");
    Expect(1, 1480, '\p{^Is_Canonical_Combining_Class=CCC18}', "");
    Expect(1, 1480, '\P{Is_Canonical_Combining_Class=CCC18}', "");
    Expect(0, 1480, '\P{^Is_Canonical_Combining_Class=CCC18}', "");
    Error('\p{Is_Ccc=_/a/0_0_0_0_0_0_0_018}');
    Error('\P{Is_Ccc=_/a/0_0_0_0_0_0_0_018}');
    Expect(1, 1479, '\p{Is_Ccc=000_000_001_8}', "");
    Expect(0, 1479, '\p{^Is_Ccc=000_000_001_8}', "");
    Expect(0, 1479, '\P{Is_Ccc=000_000_001_8}', "");
    Expect(1, 1479, '\P{^Is_Ccc=000_000_001_8}', "");
    Expect(0, 1480, '\p{Is_Ccc=000_000_001_8}', "");
    Expect(1, 1480, '\p{^Is_Ccc=000_000_001_8}', "");
    Expect(1, 1480, '\P{Is_Ccc=000_000_001_8}', "");
    Expect(0, 1480, '\P{^Is_Ccc=000_000_001_8}', "");
    Error('\p{Canonical_Combining_Class= _CCC19/a/}');
    Error('\P{Canonical_Combining_Class= _CCC19/a/}');
    Expect(1, 1466, '\p{Canonical_Combining_Class=:\ACCC19\z:}', "");;
    Expect(0, 1467, '\p{Canonical_Combining_Class=:\ACCC19\z:}', "");;
    Expect(1, 1466, '\p{Canonical_Combining_Class:	ccc19}', "");
    Expect(0, 1466, '\p{^Canonical_Combining_Class:	ccc19}', "");
    Expect(0, 1466, '\P{Canonical_Combining_Class:	ccc19}', "");
    Expect(1, 1466, '\P{^Canonical_Combining_Class:	ccc19}', "");
    Expect(0, 1467, '\p{Canonical_Combining_Class:	ccc19}', "");
    Expect(1, 1467, '\p{^Canonical_Combining_Class:	ccc19}', "");
    Expect(1, 1467, '\P{Canonical_Combining_Class:	ccc19}', "");
    Expect(0, 1467, '\P{^Canonical_Combining_Class:	ccc19}', "");
    Expect(1, 1466, '\p{Canonical_Combining_Class=:\Accc19\z:}', "");;
    Expect(0, 1467, '\p{Canonical_Combining_Class=:\Accc19\z:}', "");;
    Expect(1, 1466, '\p{Canonical_Combining_Class= 	CCC19}', "");
    Expect(0, 1466, '\p{^Canonical_Combining_Class= 	CCC19}', "");
    Expect(0, 1466, '\P{Canonical_Combining_Class= 	CCC19}', "");
    Expect(1, 1466, '\P{^Canonical_Combining_Class= 	CCC19}', "");
    Expect(0, 1467, '\p{Canonical_Combining_Class= 	CCC19}', "");
    Expect(1, 1467, '\p{^Canonical_Combining_Class= 	CCC19}', "");
    Expect(1, 1467, '\P{Canonical_Combining_Class= 	CCC19}', "");
    Expect(0, 1467, '\P{^Canonical_Combining_Class= 	CCC19}', "");
    Error('\p{Ccc=/a/	-019}');
    Error('\P{Ccc=/a/	-019}');
    Expect(1, 1466, '\p{Ccc=:\A19\z:}', "");;
    Expect(0, 1467, '\p{Ccc=:\A19\z:}', "");;
    Expect(1, 1466, '\p{Ccc=00000000019}', "");
    Expect(0, 1466, '\p{^Ccc=00000000019}', "");
    Expect(0, 1466, '\P{Ccc=00000000019}', "");
    Expect(1, 1466, '\P{^Ccc=00000000019}', "");
    Expect(0, 1467, '\p{Ccc=00000000019}', "");
    Expect(1, 1467, '\p{^Ccc=00000000019}', "");
    Expect(1, 1467, '\P{Ccc=00000000019}', "");
    Expect(0, 1467, '\P{^Ccc=00000000019}', "");
    Error('\p{Is_Canonical_Combining_Class= :=CCC19}');
    Error('\P{Is_Canonical_Combining_Class= :=CCC19}');
    Expect(1, 1466, '\p{Is_Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1466, '\p{^Is_Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1466, '\P{Is_Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1466, '\P{^Is_Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1467, '\p{Is_Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1467, '\p{^Is_Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1467, '\P{Is_Canonical_Combining_Class=ccc19}', "");
    Expect(0, 1467, '\P{^Is_Canonical_Combining_Class=ccc19}', "");
    Expect(1, 1466, '\p{Is_Canonical_Combining_Class= CCC19}', "");
    Expect(0, 1466, '\p{^Is_Canonical_Combining_Class= CCC19}', "");
    Expect(0, 1466, '\P{Is_Canonical_Combining_Class= CCC19}', "");
    Expect(1, 1466, '\P{^Is_Canonical_Combining_Class= CCC19}', "");
    Expect(0, 1467, '\p{Is_Canonical_Combining_Class= CCC19}', "");
    Expect(1, 1467, '\p{^Is_Canonical_Combining_Class= CCC19}', "");
    Expect(1, 1467, '\P{Is_Canonical_Combining_Class= CCC19}', "");
    Expect(0, 1467, '\P{^Is_Canonical_Combining_Class= CCC19}', "");
    Error('\p{Is_Ccc=/a/-+01_9}');
    Error('\P{Is_Ccc=/a/-+01_9}');
    Expect(1, 1466, '\p{Is_Ccc=00019}', "");
    Expect(0, 1466, '\p{^Is_Ccc=00019}', "");
    Expect(0, 1466, '\P{Is_Ccc=00019}', "");
    Expect(1, 1466, '\P{^Is_Ccc=00019}', "");
    Expect(0, 1467, '\p{Is_Ccc=00019}', "");
    Expect(1, 1467, '\p{^Is_Ccc=00019}', "");
    Expect(1, 1467, '\P{Is_Ccc=00019}', "");
    Expect(0, 1467, '\P{^Is_Ccc=00019}', "");
    Error('\p{Canonical_Combining_Class=_ccc20/a/}');
    Error('\P{Canonical_Combining_Class=_ccc20/a/}');
    Expect(1, 1467, '\p{Canonical_Combining_Class=:\ACCC20\z:}', "");;
    Expect(0, 1468, '\p{Canonical_Combining_Class=:\ACCC20\z:}', "");;
    Expect(1, 1467, '\p{Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1467, '\p{^Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1467, '\P{Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1467, '\P{^Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1468, '\p{Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1468, '\p{^Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1468, '\P{Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1468, '\P{^Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1467, '\p{Canonical_Combining_Class=:\Accc20\z:}', "");;
    Expect(0, 1468, '\p{Canonical_Combining_Class=:\Accc20\z:}', "");;
    Expect(1, 1467, '\p{Canonical_Combining_Class=-ccc20}', "");
    Expect(0, 1467, '\p{^Canonical_Combining_Class=-ccc20}', "");
    Expect(0, 1467, '\P{Canonical_Combining_Class=-ccc20}', "");
    Expect(1, 1467, '\P{^Canonical_Combining_Class=-ccc20}', "");
    Expect(0, 1468, '\p{Canonical_Combining_Class=-ccc20}', "");
    Expect(1, 1468, '\p{^Canonical_Combining_Class=-ccc20}', "");
    Expect(1, 1468, '\P{Canonical_Combining_Class=-ccc20}', "");
    Expect(0, 1468, '\P{^Canonical_Combining_Class=-ccc20}', "");
    Error('\p{Ccc: /a/	0000020}');
    Error('\P{Ccc: /a/	0000020}');
    Expect(1, 1467, '\p{Ccc=:\A20\z:}', "");;
    Expect(0, 1468, '\p{Ccc=:\A20\z:}', "");;
    Expect(1, 1467, '\p{Ccc=2_0}', "");
    Expect(0, 1467, '\p{^Ccc=2_0}', "");
    Expect(0, 1467, '\P{Ccc=2_0}', "");
    Expect(1, 1467, '\P{^Ccc=2_0}', "");
    Expect(0, 1468, '\p{Ccc=2_0}', "");
    Expect(1, 1468, '\p{^Ccc=2_0}', "");
    Expect(1, 1468, '\P{Ccc=2_0}', "");
    Expect(0, 1468, '\P{^Ccc=2_0}', "");
    Error('\p{Is_Canonical_Combining_Class=:=__CCC20}');
    Error('\P{Is_Canonical_Combining_Class=:=__CCC20}');
    Expect(1, 1467, '\p{Is_Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1467, '\p{^Is_Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1467, '\P{Is_Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1467, '\P{^Is_Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1468, '\p{Is_Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1468, '\p{^Is_Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1468, '\P{Is_Canonical_Combining_Class=ccc20}', "");
    Expect(0, 1468, '\P{^Is_Canonical_Combining_Class=ccc20}', "");
    Expect(1, 1467, '\p{Is_Canonical_Combining_Class= -CCC20}', "");
    Expect(0, 1467, '\p{^Is_Canonical_Combining_Class= -CCC20}', "");
    Expect(0, 1467, '\P{Is_Canonical_Combining_Class= -CCC20}', "");
    Expect(1, 1467, '\P{^Is_Canonical_Combining_Class= -CCC20}', "");
    Expect(0, 1468, '\p{Is_Canonical_Combining_Class= -CCC20}', "");
    Expect(1, 1468, '\p{^Is_Canonical_Combining_Class= -CCC20}', "");
    Expect(1, 1468, '\P{Is_Canonical_Combining_Class= -CCC20}', "");
    Expect(0, 1468, '\P{^Is_Canonical_Combining_Class= -CCC20}', "");
    Error('\p{Is_Ccc=	/a/+00000000020}');
    Error('\P{Is_Ccc=	/a/+00000000020}');
    Expect(1, 1467, '\p{Is_Ccc=+000020}', "");
    Expect(0, 1467, '\p{^Is_Ccc=+000020}', "");
    Expect(0, 1467, '\P{Is_Ccc=+000020}', "");
    Expect(1, 1467, '\P{^Is_Ccc=+000020}', "");
    Expect(0, 1468, '\p{Is_Ccc=+000020}', "");
    Expect(1, 1468, '\p{^Is_Ccc=+000020}', "");
    Expect(1, 1468, '\P{Is_Ccc=+000020}', "");
    Expect(0, 1468, '\P{^Is_Ccc=+000020}', "");
    Error('\p{Canonical_Combining_Class= CCC21/a/}');
    Error('\P{Canonical_Combining_Class= CCC21/a/}');
    Expect(1, 1468, '\p{Canonical_Combining_Class=:\ACCC21\z:}', "");;
    Expect(0, 1469, '\p{Canonical_Combining_Class=:\ACCC21\z:}', "");;
    Expect(1, 1468, '\p{Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1468, '\p{^Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1468, '\P{Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1468, '\P{^Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1469, '\p{Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1469, '\p{^Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1469, '\P{Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1469, '\P{^Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1468, '\p{Canonical_Combining_Class=:\Accc21\z:}', "");;
    Expect(0, 1469, '\p{Canonical_Combining_Class=:\Accc21\z:}', "");;
    Expect(1, 1468, '\p{Canonical_Combining_Class=	_CCC21}', "");
    Expect(0, 1468, '\p{^Canonical_Combining_Class=	_CCC21}', "");
    Expect(0, 1468, '\P{Canonical_Combining_Class=	_CCC21}', "");
    Expect(1, 1468, '\P{^Canonical_Combining_Class=	_CCC21}', "");
    Expect(0, 1469, '\p{Canonical_Combining_Class=	_CCC21}', "");
    Expect(1, 1469, '\p{^Canonical_Combining_Class=	_CCC21}', "");
    Expect(1, 1469, '\P{Canonical_Combining_Class=	_CCC21}', "");
    Expect(0, 1469, '\P{^Canonical_Combining_Class=	_CCC21}', "");
    Error('\p{Ccc=_:=+0_0_0_0_0_021}');
    Error('\P{Ccc=_:=+0_0_0_0_0_021}');
    Expect(1, 1468, '\p{Ccc=:\A21\z:}', "");;
    Expect(0, 1469, '\p{Ccc=:\A21\z:}', "");;
    Expect(1, 1468, '\p{Ccc=+00000021}', "");
    Expect(0, 1468, '\p{^Ccc=+00000021}', "");
    Expect(0, 1468, '\P{Ccc=+00000021}', "");
    Expect(1, 1468, '\P{^Ccc=+00000021}', "");
    Expect(0, 1469, '\p{Ccc=+00000021}', "");
    Expect(1, 1469, '\p{^Ccc=+00000021}', "");
    Expect(1, 1469, '\P{Ccc=+00000021}', "");
    Expect(0, 1469, '\P{^Ccc=+00000021}', "");
    Error('\p{Is_Canonical_Combining_Class=-_CCC21:=}');
    Error('\P{Is_Canonical_Combining_Class=-_CCC21:=}');
    Expect(1, 1468, '\p{Is_Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1468, '\p{^Is_Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1468, '\P{Is_Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1468, '\P{^Is_Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1469, '\p{Is_Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1469, '\p{^Is_Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1469, '\P{Is_Canonical_Combining_Class=ccc21}', "");
    Expect(0, 1469, '\P{^Is_Canonical_Combining_Class=ccc21}', "");
    Expect(1, 1468, '\p{Is_Canonical_Combining_Class=	-CCC21}', "");
    Expect(0, 1468, '\p{^Is_Canonical_Combining_Class=	-CCC21}', "");
    Expect(0, 1468, '\P{Is_Canonical_Combining_Class=	-CCC21}', "");
    Expect(1, 1468, '\P{^Is_Canonical_Combining_Class=	-CCC21}', "");
    Expect(0, 1469, '\p{Is_Canonical_Combining_Class=	-CCC21}', "");
    Expect(1, 1469, '\p{^Is_Canonical_Combining_Class=	-CCC21}', "");
    Expect(1, 1469, '\P{Is_Canonical_Combining_Class=	-CCC21}', "");
    Expect(0, 1469, '\P{^Is_Canonical_Combining_Class=	-CCC21}', "");
    Error('\p{Is_Ccc=_-0_0_0_0_021:=}');
    Error('\P{Is_Ccc=_-0_0_0_0_021:=}');
    Expect(1, 1468, '\p{Is_Ccc=2_1}', "");
    Expect(0, 1468, '\p{^Is_Ccc=2_1}', "");
    Expect(0, 1468, '\P{Is_Ccc=2_1}', "");
    Expect(1, 1468, '\P{^Is_Ccc=2_1}', "");
    Expect(0, 1469, '\p{Is_Ccc=2_1}', "");
    Expect(1, 1469, '\p{^Is_Ccc=2_1}', "");
    Expect(1, 1469, '\P{Is_Ccc=2_1}', "");
    Expect(0, 1469, '\P{^Is_Ccc=2_1}', "");
    Error('\p{Canonical_Combining_Class=-_ccc22:=}');
    Error('\P{Canonical_Combining_Class=-_ccc22:=}');
    Expect(1, 1469, '\p{Canonical_Combining_Class=:\ACCC22\z:}', "");;
    Expect(0, 1470, '\p{Canonical_Combining_Class=:\ACCC22\z:}', "");;
    Expect(1, 1469, '\p{Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1469, '\p{^Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1469, '\P{Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1469, '\P{^Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1470, '\p{Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1470, '\p{^Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1470, '\P{Canonical_Combining_Class=ccc22}', "");
    Expect(0, 1470, '\P{^Canonical_Combining_Class=ccc22}', "");
    Expect(1, 1469, '\p{Canonical_Combining_Class=:\Accc22\z:}', "");;
    Expect(0, 1470, '\p{Canonical_Combining_Class=:\Accc22\z:}', "");;
    Expect(1, 1469, '\p{Canonical_Combining_Class:	 	ccc22}', "");
    Expect(0, 1469, '\p{^Canonical_Combining_Class:	 	ccc22}', "");
    Expect(0, 1469, '\P{Canonical_Combining_Class:	 	ccc22}', "");
    Expect(1, 1469, '\P{^Canonical_Combining_Class:	 	ccc22}', "");
    Expect(0, 1470, '\p{Canonical_Combining_Class:	 	ccc22}', "");
    Expect(1, 1470, '\p{^Canonical_Combining_Class:	 	ccc22}', "");
    Expect(1, 1470, '\P{Canonical_Combining_Class:	 	ccc22}', "");
    Expect(0, 1470, '\P{^Canonical_Combining_Class:	 	ccc22}', "");
    Error('\p{Ccc=:=-+000000022}');
    Error('\P{Ccc=:=-+000000022}');
    Expect(1, 1469, '\p{Ccc=:\A22\z:}', "");;
    Expect(0, 1470, '\p{Ccc=:\A22\z:}', "");;
    Expect(1, 1469, '\p{Ccc:   02_2}', "");
    Expect(0, 1469, '\p{^Ccc:   02_2}', "");
    Expect(0, 1469, '\P{Ccc:   02_2}', "");
    Expect(1, 1469, '\P{^Ccc:   02_2}', "");
    Expect(0, 1470, '\p{Ccc:   02_2}', "");
    Expect(1, 1470, '\p{^Ccc:   02_2}', "");
    Expect(1, 1470, '\P{Ccc:   02_2}', "");
    Expect(0, 1470, '\P{^Ccc:   02_2}', "");
    Error('\p{Is_Canonical_Combining_Class=:=-	CCC22}');
    Error('\P{Is_Canonical_Combining_Class=:=-	CCC22}');
    Expect(1, 1469, '\p{Is_Canonical_Combining_Class:   ccc22}', "");
    Expect(0, 1469, '\p{^Is_Canonical_Combining_Class:   ccc22}', "");
    Expect(0, 1469, '\P{Is_Canonical_Combining_Class:   ccc22}', "");
    Expect(1, 1469, '\P{^Is_Canonical_Combining_Class:   ccc22}', "");
    Expect(0, 1470, '\p{Is_Canonical_Combining_Class:   ccc22}', "");
    Expect(1, 1470, '\p{^Is_Canonical_Combining_Class:   ccc22}', "");
    Expect(1, 1470, '\P{Is_Canonical_Combining_Class:   ccc22}', "");
    Expect(0, 1470, '\P{^Is_Canonical_Combining_Class:   ccc22}', "");
    Expect(1, 1469, '\p{Is_Canonical_Combining_Class=--ccc22}', "");
    Expect(0, 1469, '\p{^Is_Canonical_Combining_Class=--ccc22}', "");
    Expect(0, 1469, '\P{Is_Canonical_Combining_Class=--ccc22}', "");
    Expect(1, 1469, '\P{^Is_Canonical_Combining_Class=--ccc22}', "");
    Expect(0, 1470, '\p{Is_Canonical_Combining_Class=--ccc22}', "");
    Expect(1, 1470, '\p{^Is_Canonical_Combining_Class=--ccc22}', "");
    Expect(1, 1470, '\P{Is_Canonical_Combining_Class=--ccc22}', "");
    Expect(0, 1470, '\P{^Is_Canonical_Combining_Class=--ccc22}', "");
    Error('\p{Is_Ccc=:=	+00000000022}');
    Error('\P{Is_Ccc=:=	+00000000022}');
    Expect(1, 1469, '\p{Is_Ccc=+0_0_0_0_022}', "");
    Expect(0, 1469, '\p{^Is_Ccc=+0_0_0_0_022}', "");
    Expect(0, 1469, '\P{Is_Ccc=+0_0_0_0_022}', "");
    Expect(1, 1469, '\P{^Is_Ccc=+0_0_0_0_022}', "");
    Expect(0, 1470, '\p{Is_Ccc=+0_0_0_0_022}', "");
    Expect(1, 1470, '\p{^Is_Ccc=+0_0_0_0_022}', "");
    Expect(1, 1470, '\P{Is_Ccc=+0_0_0_0_022}', "");
    Expect(0, 1470, '\P{^Is_Ccc=+0_0_0_0_022}', "");
    Error('\p{Canonical_Combining_Class=:=	CCC23}');
    Error('\P{Canonical_Combining_Class=:=	CCC23}');
    Expect(1, 1471, '\p{Canonical_Combining_Class=:\ACCC23\z:}', "");;
    Expect(0, 1472, '\p{Canonical_Combining_Class=:\ACCC23\z:}', "");;
    Expect(1, 1471, '\p{Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1471, '\p{^Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1471, '\P{Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1471, '\P{^Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1472, '\p{Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1472, '\p{^Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1472, '\P{Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1472, '\P{^Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1471, '\p{Canonical_Combining_Class=:\Accc23\z:}', "");;
    Expect(0, 1472, '\p{Canonical_Combining_Class=:\Accc23\z:}', "");;
    Expect(1, 1471, '\p{Canonical_Combining_Class=		CCC23}', "");
    Expect(0, 1471, '\p{^Canonical_Combining_Class=		CCC23}', "");
    Expect(0, 1471, '\P{Canonical_Combining_Class=		CCC23}', "");
    Expect(1, 1471, '\P{^Canonical_Combining_Class=		CCC23}', "");
    Expect(0, 1472, '\p{Canonical_Combining_Class=		CCC23}', "");
    Expect(1, 1472, '\p{^Canonical_Combining_Class=		CCC23}', "");
    Expect(1, 1472, '\P{Canonical_Combining_Class=		CCC23}', "");
    Expect(0, 1472, '\P{^Canonical_Combining_Class=		CCC23}', "");
    Error('\p{Ccc=/a/_02_3}');
    Error('\P{Ccc=/a/_02_3}');
    Expect(1, 1471, '\p{Ccc=:\A23\z:}', "");;
    Expect(0, 1472, '\p{Ccc=:\A23\z:}', "");;
    Expect(1, 1471, '\p{Ccc=00_02_3}', "");
    Expect(0, 1471, '\p{^Ccc=00_02_3}', "");
    Expect(0, 1471, '\P{Ccc=00_02_3}', "");
    Expect(1, 1471, '\P{^Ccc=00_02_3}', "");
    Expect(0, 1472, '\p{Ccc=00_02_3}', "");
    Expect(1, 1472, '\p{^Ccc=00_02_3}', "");
    Expect(1, 1472, '\P{Ccc=00_02_3}', "");
    Expect(0, 1472, '\P{^Ccc=00_02_3}', "");
    Error('\p{Is_Canonical_Combining_Class=-:=CCC23}');
    Error('\P{Is_Canonical_Combining_Class=-:=CCC23}');
    Expect(1, 1471, '\p{Is_Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1471, '\p{^Is_Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1471, '\P{Is_Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1471, '\P{^Is_Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1472, '\p{Is_Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1472, '\p{^Is_Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1472, '\P{Is_Canonical_Combining_Class=ccc23}', "");
    Expect(0, 1472, '\P{^Is_Canonical_Combining_Class=ccc23}', "");
    Expect(1, 1471, '\p{Is_Canonical_Combining_Class= CCC23}', "");
    Expect(0, 1471, '\p{^Is_Canonical_Combining_Class= CCC23}', "");
    Expect(0, 1471, '\P{Is_Canonical_Combining_Class= CCC23}', "");
    Expect(1, 1471, '\P{^Is_Canonical_Combining_Class= CCC23}', "");
    Expect(0, 1472, '\p{Is_Canonical_Combining_Class= CCC23}', "");
    Expect(1, 1472, '\p{^Is_Canonical_Combining_Class= CCC23}', "");
    Expect(1, 1472, '\P{Is_Canonical_Combining_Class= CCC23}', "");
    Expect(0, 1472, '\P{^Is_Canonical_Combining_Class= CCC23}', "");
    Error('\p{Is_Ccc=/a/	00_00_00_00_02_3}');
    Error('\P{Is_Ccc=/a/	00_00_00_00_02_3}');
    Expect(1, 1471, '\p{Is_Ccc=0_0_0_0_23}', "");
    Expect(0, 1471, '\p{^Is_Ccc=0_0_0_0_23}', "");
    Expect(0, 1471, '\P{Is_Ccc=0_0_0_0_23}', "");
    Expect(1, 1471, '\P{^Is_Ccc=0_0_0_0_23}', "");
    Expect(0, 1472, '\p{Is_Ccc=0_0_0_0_23}', "");
    Expect(1, 1472, '\p{^Is_Ccc=0_0_0_0_23}', "");
    Expect(1, 1472, '\P{Is_Ccc=0_0_0_0_23}', "");
    Expect(0, 1472, '\P{^Is_Ccc=0_0_0_0_23}', "");
    Error('\p{Canonical_Combining_Class:	 :=ccc24}');
    Error('\P{Canonical_Combining_Class:	 :=ccc24}');
    Expect(1, 1473, '\p{Canonical_Combining_Class=:\ACCC24\z:}', "");;
    Expect(0, 1474, '\p{Canonical_Combining_Class=:\ACCC24\z:}', "");;
    Expect(1, 1473, '\p{Canonical_Combining_Class=ccc24}', "");
    Expect(0, 1473, '\p{^Canonical_Combining_Class=ccc24}', "");
    Expect(0, 1473, '\P{Canonical_Combining_Class=ccc24}', "");
    Expect(1, 1473, '\P{^Canonical_Combining_Class=ccc24}', "");
    Expect(0, 1474, '\p{Canonical_Combining_Class=ccc24}', "");
    Expect(1, 1474, '\p{^Canonical_Combining_Class=ccc24}', "");
    Expect(1, 1474, '\P{Canonical_Combining_Class=ccc24}', "");
    Expect(0, 1474, '\P{^Canonical_Combining_Class=ccc24}', "");
    Expect(1, 1473, '\p{Canonical_Combining_Class=:\Accc24\z:}', "");;
    Expect(0, 1474, '\p{Canonical_Combining_Class=:\Accc24\z:}', "");;
    Expect(1, 1473, '\p{Canonical_Combining_Class=_CCC24}', "");
    Expect(0, 1473, '\p{^Canonical_Combining_Class=_CCC24}', "");
    Expect(0, 1473, '\P{Canonical_Combining_Class=_CCC24}', "");
    Expect(1, 1473, '\P{^Canonical_Combining_Class=_CCC24}', "");
    Expect(0, 1474, '\p{Canonical_Combining_Class=_CCC24}', "");
    Expect(1, 1474, '\p{^Canonical_Combining_Class=_CCC24}', "");
    Expect(1, 1474, '\P{Canonical_Combining_Class=_CCC24}', "");
    Expect(0, 1474, '\P{^Canonical_Combining_Class=_CCC24}', "");
    Error('\p{Ccc:   --+0024:=}');
    Error('\P{Ccc:   --+0024:=}');
    Expect(1, 1473, '\p{Ccc=:\A24\z:}', "");;
    Expect(0, 1474, '\p{Ccc=:\A24\z:}', "");;
    Expect(1, 1473, '\p{Ccc=24}', "");
    Expect(0, 1473, '\p{^Ccc=24}', "");
    Expect(0, 1473, '\P{Ccc=24}', "");
    Expect(1, 1473, '\P{^Ccc=24}', "");
    Expect(0, 1474, '\p{Ccc=24}', "");
    Expect(1, 1474, '\p{^Ccc=24}', "");
    Expect(1, 1474, '\P{Ccc=24}', "");
    Expect(0, 1474, '\P{^Ccc=24}', "");
    Error('\p{Is_Canonical_Combining_Class=_ CCC24/a/}');
    Error('\P{Is_Canonical_Combining_Class=_ CCC24/a/}');
    Expect(1, 1473, '\p{Is_Canonical_Combining_Class:	ccc24}', "");
    Expect(0, 1473, '\p{^Is_Canonical_Combining_Class:	ccc24}', "");
    Expect(0, 1473, '\P{Is_Canonical_Combining_Class:	ccc24}', "");
    Expect(1, 1473, '\P{^Is_Canonical_Combining_Class:	ccc24}', "");
    Expect(0, 1474, '\p{Is_Canonical_Combining_Class:	ccc24}', "");
    Expect(1, 1474, '\p{^Is_Canonical_Combining_Class:	ccc24}', "");
    Expect(1, 1474, '\P{Is_Canonical_Combining_Class:	ccc24}', "");
    Expect(0, 1474, '\P{^Is_Canonical_Combining_Class:	ccc24}', "");
    Expect(1, 1473, '\p{Is_Canonical_Combining_Class=--ccc24}', "");
    Expect(0, 1473, '\p{^Is_Canonical_Combining_Class=--ccc24}', "");
    Expect(0, 1473, '\P{Is_Canonical_Combining_Class=--ccc24}', "");
    Expect(1, 1473, '\P{^Is_Canonical_Combining_Class=--ccc24}', "");
    Expect(0, 1474, '\p{Is_Canonical_Combining_Class=--ccc24}', "");
    Expect(1, 1474, '\p{^Is_Canonical_Combining_Class=--ccc24}', "");
    Expect(1, 1474, '\P{Is_Canonical_Combining_Class=--ccc24}', "");
    Expect(0, 1474, '\P{^Is_Canonical_Combining_Class=--ccc24}', "");
    Error('\p{Is_Ccc=  0_0_0_24/a/}');
    Error('\P{Is_Ccc=  0_0_0_24/a/}');
    Expect(1, 1473, '\p{Is_Ccc=+0002_4}', "");
    Expect(0, 1473, '\p{^Is_Ccc=+0002_4}', "");
    Expect(0, 1473, '\P{Is_Ccc=+0002_4}', "");
    Expect(1, 1473, '\P{^Is_Ccc=+0002_4}', "");
    Expect(0, 1474, '\p{Is_Ccc=+0002_4}', "");
    Expect(1, 1474, '\p{^Is_Ccc=+0002_4}', "");
    Expect(1, 1474, '\P{Is_Ccc=+0002_4}', "");
    Expect(0, 1474, '\P{^Is_Ccc=+0002_4}', "");
    Error('\p{Canonical_Combining_Class=	_CCC25:=}');
    Error('\P{Canonical_Combining_Class=	_CCC25:=}');
    Expect(1, 1474, '\p{Canonical_Combining_Class=:\ACCC25\z:}', "");;
    Expect(0, 1475, '\p{Canonical_Combining_Class=:\ACCC25\z:}', "");;
    Expect(1, 1474, '\p{Canonical_Combining_Class=ccc25}', "");
    Expect(0, 1474, '\p{^Canonical_Combining_Class=ccc25}', "");
    Expect(0, 1474, '\P{Canonical_Combining_Class=ccc25}', "");
    Expect(1, 1474, '\P{^Canonical_Combining_Class=ccc25}', "");
    Expect(0, 1475, '\p{Canonical_Combining_Class=ccc25}', "");
    Expect(1, 1475, '\p{^Canonical_Combining_Class=ccc25}', "");
    Expect(1, 1475, '\P{Canonical_Combining_Class=ccc25}', "");
    Expect(0, 1475, '\P{^Canonical_Combining_Class=ccc25}', "");
    Expect(1, 1474, '\p{Canonical_Combining_Class=:\Accc25\z:}', "");;
    Expect(0, 1475, '\p{Canonical_Combining_Class=:\Accc25\z:}', "");;
    Expect(1, 1474, '\p{Canonical_Combining_Class=	ccc25}', "");
    Expect(0, 1474, '\p{^Canonical_Combining_Class=	ccc25}', "");
    Expect(0, 1474, '\P{Canonical_Combining_Class=	ccc25}', "");
    Expect(1, 1474, '\P{^Canonical_Combining_Class=	ccc25}', "");
    Expect(0, 1475, '\p{Canonical_Combining_Class=	ccc25}', "");
    Expect(1, 1475, '\p{^Canonical_Combining_Class=	ccc25}', "");
    Expect(1, 1475, '\P{Canonical_Combining_Class=	ccc25}', "");
    Expect(0, 1475, '\P{^Canonical_Combining_Class=	ccc25}', "");
    Error('\p{Ccc=__00000000025:=}');
    Error('\P{Ccc=__00000000025:=}');
    Expect(1, 1474, '\p{Ccc=:\A25\z:}', "");;
    Expect(0, 1475, '\p{Ccc=:\A25\z:}', "");;
    Expect(1, 1474, '\p{Ccc=0025}', "");
    Expect(0, 1474, '\p{^Ccc=0025}', "");
    Expect(0, 1474, '\P{Ccc=0025}', "");
    Expect(1, 1474, '\P{^Ccc=0025}', "");
    Expect(0, 1475, '\p{Ccc=0025}', "");
    Expect(1, 1475, '\p{^Ccc=0025}', "");
    Expect(1, 1475, '\P{Ccc=0025}', "");
    Expect(0, 1475, '\P{^Ccc=0025}', "");
    Error('\p{Is_Canonical_Combining_Class=:= 	CCC25}');
    Error('\P{Is_Canonical_Combining_Class=:= 	CCC25}');
    Expect(1, 1474, '\p{Is_Canonical_Combining_Class=ccc25}', "");
    Expect(0, 1474, '\p{^Is_Canonical_Combining_Class=ccc25}', "");
    Expect(0, 1474, '\P{Is_Canonical_Combining_Class=ccc25}', "");
    Expect(1, 1474, '\P{^Is_Canonical_Combining_Class=ccc25}', "");
    Expect(0, 1475, '\p{Is_Canonical_Combining_Class=ccc25}', "");
    Expect(1, 1475, '\p{^Is_Canonical_Combining_Class=ccc25}', "");
    Expect(1, 1475, '\P{Is_Canonical_Combining_Class=ccc25}', "");
    Expect(0, 1475, '\P{^Is_Canonical_Combining_Class=ccc25}', "");
    Expect(1, 1474, '\p{Is_Canonical_Combining_Class=		ccc25}', "");
    Expect(0, 1474, '\p{^Is_Canonical_Combining_Class=		ccc25}', "");
    Expect(0, 1474, '\P{Is_Canonical_Combining_Class=		ccc25}', "");
    Expect(1, 1474, '\P{^Is_Canonical_Combining_Class=		ccc25}', "");
    Expect(0, 1475, '\p{Is_Canonical_Combining_Class=		ccc25}', "");
    Expect(1, 1475, '\p{^Is_Canonical_Combining_Class=		ccc25}', "");
    Expect(1, 1475, '\P{Is_Canonical_Combining_Class=		ccc25}', "");
    Expect(0, 1475, '\P{^Is_Canonical_Combining_Class=		ccc25}', "");
    Error('\p{Is_Ccc= :=0_0_0_25}');
    Error('\P{Is_Ccc= :=0_0_0_25}');
    Expect(1, 1474, '\p{Is_Ccc=2_5}', "");
    Expect(0, 1474, '\p{^Is_Ccc=2_5}', "");
    Expect(0, 1474, '\P{Is_Ccc=2_5}', "");
    Expect(1, 1474, '\P{^Is_Ccc=2_5}', "");
    Expect(0, 1475, '\p{Is_Ccc=2_5}', "");
    Expect(1, 1475, '\p{^Is_Ccc=2_5}', "");
    Expect(1, 1475, '\P{Is_Ccc=2_5}', "");
    Expect(0, 1475, '\P{^Is_Ccc=2_5}', "");
    Error('\p{Canonical_Combining_Class:	:=- CCC26}');
    Error('\P{Canonical_Combining_Class:	:=- CCC26}');
    Expect(1, 64286, '\p{Canonical_Combining_Class=:\ACCC26\z:}', "");;
    Expect(0, 64287, '\p{Canonical_Combining_Class=:\ACCC26\z:}', "");;
    Expect(1, 64286, '\p{Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64286, '\p{^Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64286, '\P{Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64286, '\P{^Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64287, '\p{Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64287, '\p{^Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64287, '\P{Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64287, '\P{^Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64286, '\p{Canonical_Combining_Class=:\Accc26\z:}', "");;
    Expect(0, 64287, '\p{Canonical_Combining_Class=:\Accc26\z:}', "");;
    Expect(1, 64286, '\p{Canonical_Combining_Class=	_CCC26}', "");
    Expect(0, 64286, '\p{^Canonical_Combining_Class=	_CCC26}', "");
    Expect(0, 64286, '\P{Canonical_Combining_Class=	_CCC26}', "");
    Expect(1, 64286, '\P{^Canonical_Combining_Class=	_CCC26}', "");
    Expect(0, 64287, '\p{Canonical_Combining_Class=	_CCC26}', "");
    Expect(1, 64287, '\p{^Canonical_Combining_Class=	_CCC26}', "");
    Expect(1, 64287, '\P{Canonical_Combining_Class=	_CCC26}', "");
    Expect(0, 64287, '\P{^Canonical_Combining_Class=	_CCC26}', "");
    Error('\p{Ccc=_ +0_0_0_0_0_00026/a/}');
    Error('\P{Ccc=_ +0_0_0_0_0_00026/a/}');
    Expect(1, 64286, '\p{Ccc=:\A26\z:}', "");;
    Expect(0, 64287, '\p{Ccc=:\A26\z:}', "");;
    Expect(1, 64286, '\p{Ccc=+02_6}', "");
    Expect(0, 64286, '\p{^Ccc=+02_6}', "");
    Expect(0, 64286, '\P{Ccc=+02_6}', "");
    Expect(1, 64286, '\P{^Ccc=+02_6}', "");
    Expect(0, 64287, '\p{Ccc=+02_6}', "");
    Expect(1, 64287, '\p{^Ccc=+02_6}', "");
    Expect(1, 64287, '\P{Ccc=+02_6}', "");
    Expect(0, 64287, '\P{^Ccc=+02_6}', "");
    Error('\p{Is_Canonical_Combining_Class:	/a/CCC26}');
    Error('\P{Is_Canonical_Combining_Class:	/a/CCC26}');
    Expect(1, 64286, '\p{Is_Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64286, '\p{^Is_Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64286, '\P{Is_Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64286, '\P{^Is_Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64287, '\p{Is_Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64287, '\p{^Is_Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64287, '\P{Is_Canonical_Combining_Class=ccc26}', "");
    Expect(0, 64287, '\P{^Is_Canonical_Combining_Class=ccc26}', "");
    Expect(1, 64286, '\p{Is_Canonical_Combining_Class=_ CCC26}', "");
    Expect(0, 64286, '\p{^Is_Canonical_Combining_Class=_ CCC26}', "");
    Expect(0, 64286, '\P{Is_Canonical_Combining_Class=_ CCC26}', "");
    Expect(1, 64286, '\P{^Is_Canonical_Combining_Class=_ CCC26}', "");
    Expect(0, 64287, '\p{Is_Canonical_Combining_Class=_ CCC26}', "");
    Expect(1, 64287, '\p{^Is_Canonical_Combining_Class=_ CCC26}', "");
    Expect(1, 64287, '\P{Is_Canonical_Combining_Class=_ CCC26}', "");
    Expect(0, 64287, '\P{^Is_Canonical_Combining_Class=_ CCC26}', "");
    Error('\p{Is_Ccc=-:=+00000026}');
    Error('\P{Is_Ccc=-:=+00000026}');
    Expect(1, 64286, '\p{Is_Ccc=+00000002_6}', "");
    Expect(0, 64286, '\p{^Is_Ccc=+00000002_6}', "");
    Expect(0, 64286, '\P{Is_Ccc=+00000002_6}', "");
    Expect(1, 64286, '\P{^Is_Ccc=+00000002_6}', "");
    Expect(0, 64287, '\p{Is_Ccc=+00000002_6}', "");
    Expect(1, 64287, '\p{^Is_Ccc=+00000002_6}', "");
    Expect(1, 64287, '\P{Is_Ccc=+00000002_6}', "");
    Expect(0, 64287, '\P{^Is_Ccc=+00000002_6}', "");
    Error('\p{Canonical_Combining_Class:    /a/CCC27}');
    Error('\P{Canonical_Combining_Class:    /a/CCC27}');
    Expect(1, 2288, '\p{Canonical_Combining_Class=:\ACCC27\z:}', "");;
    Expect(0, 2289, '\p{Canonical_Combining_Class=:\ACCC27\z:}', "");;
    Expect(1, 2288, '\p{Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2288, '\p{^Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2288, '\P{Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2288, '\P{^Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2289, '\p{Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2289, '\p{^Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2289, '\P{Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2289, '\P{^Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2288, '\p{Canonical_Combining_Class=:\Accc27\z:}', "");;
    Expect(0, 2289, '\p{Canonical_Combining_Class=:\Accc27\z:}', "");;
    Expect(1, 2288, '\p{Canonical_Combining_Class=	CCC27}', "");
    Expect(0, 2288, '\p{^Canonical_Combining_Class=	CCC27}', "");
    Expect(0, 2288, '\P{Canonical_Combining_Class=	CCC27}', "");
    Expect(1, 2288, '\P{^Canonical_Combining_Class=	CCC27}', "");
    Expect(0, 2289, '\p{Canonical_Combining_Class=	CCC27}', "");
    Expect(1, 2289, '\p{^Canonical_Combining_Class=	CCC27}', "");
    Expect(1, 2289, '\P{Canonical_Combining_Class=	CCC27}', "");
    Expect(0, 2289, '\P{^Canonical_Combining_Class=	CCC27}', "");
    Error('\p{Ccc=-:=0_0_0_27}');
    Error('\P{Ccc=-:=0_0_0_27}');
    Expect(1, 2288, '\p{Ccc=:\A27\z:}', "");;
    Expect(0, 2289, '\p{Ccc=:\A27\z:}', "");;
    Expect(1, 2288, '\p{Ccc=+027}', "");
    Expect(0, 2288, '\p{^Ccc=+027}', "");
    Expect(0, 2288, '\P{Ccc=+027}', "");
    Expect(1, 2288, '\P{^Ccc=+027}', "");
    Expect(0, 2289, '\p{Ccc=+027}', "");
    Expect(1, 2289, '\p{^Ccc=+027}', "");
    Expect(1, 2289, '\P{Ccc=+027}', "");
    Expect(0, 2289, '\P{^Ccc=+027}', "");
    Error('\p{Is_Canonical_Combining_Class=:=-	CCC27}');
    Error('\P{Is_Canonical_Combining_Class=:=-	CCC27}');
    Expect(1, 2288, '\p{Is_Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2288, '\p{^Is_Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2288, '\P{Is_Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2288, '\P{^Is_Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2289, '\p{Is_Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2289, '\p{^Is_Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2289, '\P{Is_Canonical_Combining_Class=ccc27}', "");
    Expect(0, 2289, '\P{^Is_Canonical_Combining_Class=ccc27}', "");
    Expect(1, 2288, '\p{Is_Canonical_Combining_Class= CCC27}', "");
    Expect(0, 2288, '\p{^Is_Canonical_Combining_Class= CCC27}', "");
    Expect(0, 2288, '\P{Is_Canonical_Combining_Class= CCC27}', "");
    Expect(1, 2288, '\P{^Is_Canonical_Combining_Class= CCC27}', "");
    Expect(0, 2289, '\p{Is_Canonical_Combining_Class= CCC27}', "");
    Expect(1, 2289, '\p{^Is_Canonical_Combining_Class= CCC27}', "");
    Expect(1, 2289, '\P{Is_Canonical_Combining_Class= CCC27}', "");
    Expect(0, 2289, '\P{^Is_Canonical_Combining_Class= CCC27}', "");
    Error('\p{Is_Ccc=:= 	000027}');
    Error('\P{Is_Ccc=:= 	000027}');
    Expect(1, 2288, '\p{Is_Ccc=+27}', "");
    Expect(0, 2288, '\p{^Is_Ccc=+27}', "");
    Expect(0, 2288, '\P{Is_Ccc=+27}', "");
    Expect(1, 2288, '\P{^Is_Ccc=+27}', "");
    Expect(0, 2289, '\p{Is_Ccc=+27}', "");
    Expect(1, 2289, '\p{^Is_Ccc=+27}', "");
    Expect(1, 2289, '\P{Is_Ccc=+27}', "");
    Expect(0, 2289, '\P{^Is_Ccc=+27}', "");
    Error('\p{Canonical_Combining_Class:	-/a/CCC28}');
    Error('\P{Canonical_Combining_Class:	-/a/CCC28}');
    Expect(1, 2289, '\p{Canonical_Combining_Class=:\ACCC28\z:}', "");;
    Expect(0, 2290, '\p{Canonical_Combining_Class=:\ACCC28\z:}', "");;
    Expect(1, 2289, '\p{Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2289, '\p{^Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2289, '\P{Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2289, '\P{^Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2290, '\p{Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2290, '\p{^Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2290, '\P{Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2290, '\P{^Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2289, '\p{Canonical_Combining_Class=:\Accc28\z:}', "");;
    Expect(0, 2290, '\p{Canonical_Combining_Class=:\Accc28\z:}', "");;
    Expect(1, 2289, '\p{Canonical_Combining_Class= -ccc28}', "");
    Expect(0, 2289, '\p{^Canonical_Combining_Class= -ccc28}', "");
    Expect(0, 2289, '\P{Canonical_Combining_Class= -ccc28}', "");
    Expect(1, 2289, '\P{^Canonical_Combining_Class= -ccc28}', "");
    Expect(0, 2290, '\p{Canonical_Combining_Class= -ccc28}', "");
    Expect(1, 2290, '\p{^Canonical_Combining_Class= -ccc28}', "");
    Expect(1, 2290, '\P{Canonical_Combining_Class= -ccc28}', "");
    Expect(0, 2290, '\P{^Canonical_Combining_Class= -ccc28}', "");
    Error('\p{Ccc=  000000028:=}');
    Error('\P{Ccc=  000000028:=}');
    Expect(1, 2289, '\p{Ccc=:\A28\z:}', "");;
    Expect(0, 2290, '\p{Ccc=:\A28\z:}', "");;
    Expect(1, 2289, '\p{Ccc=0028}', "");
    Expect(0, 2289, '\p{^Ccc=0028}', "");
    Expect(0, 2289, '\P{Ccc=0028}', "");
    Expect(1, 2289, '\P{^Ccc=0028}', "");
    Expect(0, 2290, '\p{Ccc=0028}', "");
    Expect(1, 2290, '\p{^Ccc=0028}', "");
    Expect(1, 2290, '\P{Ccc=0028}', "");
    Expect(0, 2290, '\P{^Ccc=0028}', "");
    Error('\p{Is_Canonical_Combining_Class=:=__CCC28}');
    Error('\P{Is_Canonical_Combining_Class=:=__CCC28}');
    Expect(1, 2289, '\p{Is_Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2289, '\p{^Is_Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2289, '\P{Is_Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2289, '\P{^Is_Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2290, '\p{Is_Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2290, '\p{^Is_Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2290, '\P{Is_Canonical_Combining_Class=ccc28}', "");
    Expect(0, 2290, '\P{^Is_Canonical_Combining_Class=ccc28}', "");
    Expect(1, 2289, '\p{Is_Canonical_Combining_Class=_ CCC28}', "");
    Expect(0, 2289, '\p{^Is_Canonical_Combining_Class=_ CCC28}', "");
    Expect(0, 2289, '\P{Is_Canonical_Combining_Class=_ CCC28}', "");
    Expect(1, 2289, '\P{^Is_Canonical_Combining_Class=_ CCC28}', "");
    Expect(0, 2290, '\p{Is_Canonical_Combining_Class=_ CCC28}', "");
    Expect(1, 2290, '\p{^Is_Canonical_Combining_Class=_ CCC28}', "");
    Expect(1, 2290, '\P{Is_Canonical_Combining_Class=_ CCC28}', "");
    Expect(0, 2290, '\P{^Is_Canonical_Combining_Class=_ CCC28}', "");
    Error('\p{Is_Ccc=/a/-	+0000028}');
    Error('\P{Is_Ccc=/a/-	+0000028}');
    Expect(1, 2289, '\p{Is_Ccc=+02_8}', "");
    Expect(0, 2289, '\p{^Is_Ccc=+02_8}', "");
    Expect(0, 2289, '\P{Is_Ccc=+02_8}', "");
    Expect(1, 2289, '\P{^Is_Ccc=+02_8}', "");
    Expect(0, 2290, '\p{Is_Ccc=+02_8}', "");
    Expect(1, 2290, '\p{^Is_Ccc=+02_8}', "");
    Expect(1, 2290, '\P{Is_Ccc=+02_8}', "");
    Expect(0, 2290, '\P{^Is_Ccc=+02_8}', "");
    Error('\p{Canonical_Combining_Class:	_/a/CCC29}');
    Error('\P{Canonical_Combining_Class:	_/a/CCC29}');
    Expect(1, 2290, '\p{Canonical_Combining_Class=:\ACCC29\z:}', "");;
    Expect(0, 2291, '\p{Canonical_Combining_Class=:\ACCC29\z:}', "");;
    Expect(1, 2290, '\p{Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2290, '\p{^Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2290, '\P{Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2290, '\P{^Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2291, '\p{Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2291, '\p{^Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2291, '\P{Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2291, '\P{^Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2290, '\p{Canonical_Combining_Class=:\Accc29\z:}', "");;
    Expect(0, 2291, '\p{Canonical_Combining_Class=:\Accc29\z:}', "");;
    Expect(1, 2290, '\p{Canonical_Combining_Class=	 CCC29}', "");
    Expect(0, 2290, '\p{^Canonical_Combining_Class=	 CCC29}', "");
    Expect(0, 2290, '\P{Canonical_Combining_Class=	 CCC29}', "");
    Expect(1, 2290, '\P{^Canonical_Combining_Class=	 CCC29}', "");
    Expect(0, 2291, '\p{Canonical_Combining_Class=	 CCC29}', "");
    Expect(1, 2291, '\p{^Canonical_Combining_Class=	 CCC29}', "");
    Expect(1, 2291, '\P{Canonical_Combining_Class=	 CCC29}', "");
    Expect(0, 2291, '\P{^Canonical_Combining_Class=	 CCC29}', "");
    Error('\p{Ccc=/a/ 000000029}');
    Error('\P{Ccc=/a/ 000000029}');
    Expect(1, 2290, '\p{Ccc=:\A29\z:}', "");;
    Expect(0, 2291, '\p{Ccc=:\A29\z:}', "");;
    Expect(1, 2290, '\p{Ccc=00000000029}', "");
    Expect(0, 2290, '\p{^Ccc=00000000029}', "");
    Expect(0, 2290, '\P{Ccc=00000000029}', "");
    Expect(1, 2290, '\P{^Ccc=00000000029}', "");
    Expect(0, 2291, '\p{Ccc=00000000029}', "");
    Expect(1, 2291, '\p{^Ccc=00000000029}', "");
    Expect(1, 2291, '\P{Ccc=00000000029}', "");
    Expect(0, 2291, '\P{^Ccc=00000000029}', "");
    Error('\p{Is_Canonical_Combining_Class=	CCC29:=}');
    Error('\P{Is_Canonical_Combining_Class=	CCC29:=}');
    Expect(1, 2290, '\p{Is_Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2290, '\p{^Is_Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2290, '\P{Is_Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2290, '\P{^Is_Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2291, '\p{Is_Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2291, '\p{^Is_Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2291, '\P{Is_Canonical_Combining_Class=ccc29}', "");
    Expect(0, 2291, '\P{^Is_Canonical_Combining_Class=ccc29}', "");
    Expect(1, 2290, '\p{Is_Canonical_Combining_Class=	_CCC29}', "");
    Expect(0, 2290, '\p{^Is_Canonical_Combining_Class=	_CCC29}', "");
    Expect(0, 2290, '\P{Is_Canonical_Combining_Class=	_CCC29}', "");
    Expect(1, 2290, '\P{^Is_Canonical_Combining_Class=	_CCC29}', "");
    Expect(0, 2291, '\p{Is_Canonical_Combining_Class=	_CCC29}', "");
    Expect(1, 2291, '\p{^Is_Canonical_Combining_Class=	_CCC29}', "");
    Expect(1, 2291, '\P{Is_Canonical_Combining_Class=	_CCC29}', "");
    Expect(0, 2291, '\P{^Is_Canonical_Combining_Class=	_CCC29}', "");
    Error('\p{Is_Ccc=-	0_0_0_29/a/}');
    Error('\P{Is_Ccc=-	0_0_0_29/a/}');
    Expect(1, 2290, '\p{Is_Ccc=0_0_0_0_0_0_0029}', "");
    Expect(0, 2290, '\p{^Is_Ccc=0_0_0_0_0_0_0029}', "");
    Expect(0, 2290, '\P{Is_Ccc=0_0_0_0_0_0_0029}', "");
    Expect(1, 2290, '\P{^Is_Ccc=0_0_0_0_0_0_0029}', "");
    Expect(0, 2291, '\p{Is_Ccc=0_0_0_0_0_0_0029}', "");
    Expect(1, 2291, '\p{^Is_Ccc=0_0_0_0_0_0_0029}', "");
    Expect(1, 2291, '\P{Is_Ccc=0_0_0_0_0_0_0029}', "");
    Expect(0, 2291, '\P{^Is_Ccc=0_0_0_0_0_0_0029}', "");
    Error('\p{Canonical_Combining_Class=	ccc30:=}');
    Error('\P{Canonical_Combining_Class=	ccc30:=}');
    Expect(1, 1614, '\p{Canonical_Combining_Class=:\ACCC30\z:}', "");;
    Expect(0, 1615, '\p{Canonical_Combining_Class=:\ACCC30\z:}', "");;
    Expect(1, 1614, '\p{Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1614, '\p{^Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1614, '\P{Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1614, '\P{^Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1615, '\p{Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1615, '\p{^Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1615, '\P{Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1615, '\P{^Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1614, '\p{Canonical_Combining_Class=:\Accc30\z:}', "");;
    Expect(0, 1615, '\p{Canonical_Combining_Class=:\Accc30\z:}', "");;
    Expect(1, 1614, '\p{Canonical_Combining_Class= CCC30}', "");
    Expect(0, 1614, '\p{^Canonical_Combining_Class= CCC30}', "");
    Expect(0, 1614, '\P{Canonical_Combining_Class= CCC30}', "");
    Expect(1, 1614, '\P{^Canonical_Combining_Class= CCC30}', "");
    Expect(0, 1615, '\p{Canonical_Combining_Class= CCC30}', "");
    Expect(1, 1615, '\p{^Canonical_Combining_Class= CCC30}', "");
    Expect(1, 1615, '\P{Canonical_Combining_Class= CCC30}', "");
    Expect(0, 1615, '\P{^Canonical_Combining_Class= CCC30}', "");
    Error('\p{Ccc=-:=+00003_0}');
    Error('\P{Ccc=-:=+00003_0}');
    Expect(1, 1614, '\p{Ccc=:\A30\z:}', "");;
    Expect(0, 1615, '\p{Ccc=:\A30\z:}', "");;
    Expect(1, 1614, '\p{Ccc=00000000030}', "");
    Expect(0, 1614, '\p{^Ccc=00000000030}', "");
    Expect(0, 1614, '\P{Ccc=00000000030}', "");
    Expect(1, 1614, '\P{^Ccc=00000000030}', "");
    Expect(0, 1615, '\p{Ccc=00000000030}', "");
    Expect(1, 1615, '\p{^Ccc=00000000030}', "");
    Expect(1, 1615, '\P{Ccc=00000000030}', "");
    Expect(0, 1615, '\P{^Ccc=00000000030}', "");
    Error('\p{Is_Canonical_Combining_Class:   :=-CCC30}');
    Error('\P{Is_Canonical_Combining_Class:   :=-CCC30}');
    Expect(1, 1614, '\p{Is_Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1614, '\p{^Is_Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1614, '\P{Is_Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1614, '\P{^Is_Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1615, '\p{Is_Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1615, '\p{^Is_Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1615, '\P{Is_Canonical_Combining_Class=ccc30}', "");
    Expect(0, 1615, '\P{^Is_Canonical_Combining_Class=ccc30}', "");
    Expect(1, 1614, '\p{Is_Canonical_Combining_Class=_CCC30}', "");
    Expect(0, 1614, '\p{^Is_Canonical_Combining_Class=_CCC30}', "");
    Expect(0, 1614, '\P{Is_Canonical_Combining_Class=_CCC30}', "");
    Expect(1, 1614, '\P{^Is_Canonical_Combining_Class=_CCC30}', "");
    Expect(0, 1615, '\p{Is_Canonical_Combining_Class=_CCC30}', "");
    Expect(1, 1615, '\p{^Is_Canonical_Combining_Class=_CCC30}', "");
    Expect(1, 1615, '\P{Is_Canonical_Combining_Class=_CCC30}', "");
    Expect(0, 1615, '\P{^Is_Canonical_Combining_Class=_CCC30}', "");
    Error('\p{Is_Ccc=-:=0030}');
    Error('\P{Is_Ccc=-:=0030}');
    Expect(1, 1614, '\p{Is_Ccc=+000000030}', "");
    Expect(0, 1614, '\p{^Is_Ccc=+000000030}', "");
    Expect(0, 1614, '\P{Is_Ccc=+000000030}', "");
    Expect(1, 1614, '\P{^Is_Ccc=+000000030}', "");
    Expect(0, 1615, '\p{Is_Ccc=+000000030}', "");
    Expect(1, 1615, '\p{^Is_Ccc=+000000030}', "");
    Expect(1, 1615, '\P{Is_Ccc=+000000030}', "");
    Expect(0, 1615, '\P{^Is_Ccc=+000000030}', "");
    Error('\p{Canonical_Combining_Class=__ccc31/a/}');
    Error('\P{Canonical_Combining_Class=__ccc31/a/}');
    Expect(1, 1615, '\p{Canonical_Combining_Class=:\ACCC31\z:}', "");;
    Expect(0, 1616, '\p{Canonical_Combining_Class=:\ACCC31\z:}', "");;
    Expect(1, 1615, '\p{Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1615, '\p{^Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1615, '\P{Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1615, '\P{^Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1616, '\p{Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1616, '\p{^Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1616, '\P{Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1616, '\P{^Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1615, '\p{Canonical_Combining_Class=:\Accc31\z:}', "");;
    Expect(0, 1616, '\p{Canonical_Combining_Class=:\Accc31\z:}', "");;
    Expect(1, 1615, '\p{Canonical_Combining_Class=-_CCC31}', "");
    Expect(0, 1615, '\p{^Canonical_Combining_Class=-_CCC31}', "");
    Expect(0, 1615, '\P{Canonical_Combining_Class=-_CCC31}', "");
    Expect(1, 1615, '\P{^Canonical_Combining_Class=-_CCC31}', "");
    Expect(0, 1616, '\p{Canonical_Combining_Class=-_CCC31}', "");
    Expect(1, 1616, '\p{^Canonical_Combining_Class=-_CCC31}', "");
    Expect(1, 1616, '\P{Canonical_Combining_Class=-_CCC31}', "");
    Expect(0, 1616, '\P{^Canonical_Combining_Class=-_CCC31}', "");
    Error('\p{Ccc=/a/	_000031}');
    Error('\P{Ccc=/a/	_000031}');
    Expect(1, 1615, '\p{Ccc=:\A31\z:}', "");;
    Expect(0, 1616, '\p{Ccc=:\A31\z:}', "");;
    Expect(1, 1615, '\p{Ccc=+000000031}', "");
    Expect(0, 1615, '\p{^Ccc=+000000031}', "");
    Expect(0, 1615, '\P{Ccc=+000000031}', "");
    Expect(1, 1615, '\P{^Ccc=+000000031}', "");
    Expect(0, 1616, '\p{Ccc=+000000031}', "");
    Expect(1, 1616, '\p{^Ccc=+000000031}', "");
    Expect(1, 1616, '\P{Ccc=+000000031}', "");
    Expect(0, 1616, '\P{^Ccc=+000000031}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/_-ccc31}');
    Error('\P{Is_Canonical_Combining_Class=/a/_-ccc31}');
    Expect(1, 1615, '\p{Is_Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1615, '\p{^Is_Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1615, '\P{Is_Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1615, '\P{^Is_Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1616, '\p{Is_Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1616, '\p{^Is_Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1616, '\P{Is_Canonical_Combining_Class=ccc31}', "");
    Expect(0, 1616, '\P{^Is_Canonical_Combining_Class=ccc31}', "");
    Expect(1, 1615, '\p{Is_Canonical_Combining_Class=		ccc31}', "");
    Expect(0, 1615, '\p{^Is_Canonical_Combining_Class=		ccc31}', "");
    Expect(0, 1615, '\P{Is_Canonical_Combining_Class=		ccc31}', "");
    Expect(1, 1615, '\P{^Is_Canonical_Combining_Class=		ccc31}', "");
    Expect(0, 1616, '\p{Is_Canonical_Combining_Class=		ccc31}', "");
    Expect(1, 1616, '\p{^Is_Canonical_Combining_Class=		ccc31}', "");
    Expect(1, 1616, '\P{Is_Canonical_Combining_Class=		ccc31}', "");
    Expect(0, 1616, '\P{^Is_Canonical_Combining_Class=		ccc31}', "");
    Error('\p{Is_Ccc=:=-+00031}');
    Error('\P{Is_Ccc=:=-+00031}');
    Expect(1, 1615, '\p{Is_Ccc=00000031}', "");
    Expect(0, 1615, '\p{^Is_Ccc=00000031}', "");
    Expect(0, 1615, '\P{Is_Ccc=00000031}', "");
    Expect(1, 1615, '\P{^Is_Ccc=00000031}', "");
    Expect(0, 1616, '\p{Is_Ccc=00000031}', "");
    Expect(1, 1616, '\p{^Is_Ccc=00000031}', "");
    Expect(1, 1616, '\P{Is_Ccc=00000031}', "");
    Expect(0, 1616, '\P{^Is_Ccc=00000031}', "");
    Error('\p{Canonical_Combining_Class=_	CCC32:=}');
    Error('\P{Canonical_Combining_Class=_	CCC32:=}');
    Expect(1, 1616, '\p{Canonical_Combining_Class=:\ACCC32\z:}', "");;
    Expect(0, 1617, '\p{Canonical_Combining_Class=:\ACCC32\z:}', "");;
    Expect(1, 1616, '\p{Canonical_Combining_Class=ccc32}', "");
    Expect(0, 1616, '\p{^Canonical_Combining_Class=ccc32}', "");
    Expect(0, 1616, '\P{Canonical_Combining_Class=ccc32}', "");
    Expect(1, 1616, '\P{^Canonical_Combining_Class=ccc32}', "");
    Expect(0, 1617, '\p{Canonical_Combining_Class=ccc32}', "");
    Expect(1, 1617, '\p{^Canonical_Combining_Class=ccc32}', "");
    Expect(1, 1617, '\P{Canonical_Combining_Class=ccc32}', "");
    Expect(0, 1617, '\P{^Canonical_Combining_Class=ccc32}', "");
    Expect(1, 1616, '\p{Canonical_Combining_Class=:\Accc32\z:}', "");;
    Expect(0, 1617, '\p{Canonical_Combining_Class=:\Accc32\z:}', "");;
    Expect(1, 1616, '\p{Canonical_Combining_Class= 	CCC32}', "");
    Expect(0, 1616, '\p{^Canonical_Combining_Class= 	CCC32}', "");
    Expect(0, 1616, '\P{Canonical_Combining_Class= 	CCC32}', "");
    Expect(1, 1616, '\P{^Canonical_Combining_Class= 	CCC32}', "");
    Expect(0, 1617, '\p{Canonical_Combining_Class= 	CCC32}', "");
    Expect(1, 1617, '\p{^Canonical_Combining_Class= 	CCC32}', "");
    Expect(1, 1617, '\P{Canonical_Combining_Class= 	CCC32}', "");
    Expect(0, 1617, '\P{^Canonical_Combining_Class= 	CCC32}', "");
    Error('\p{Ccc=/a/ -000000032}');
    Error('\P{Ccc=/a/ -000000032}');
    Expect(1, 1616, '\p{Ccc=:\A32\z:}', "");;
    Expect(0, 1617, '\p{Ccc=:\A32\z:}', "");;
    Expect(1, 1616, '\p{Ccc=0_0_0_32}', "");
    Expect(0, 1616, '\p{^Ccc=0_0_0_32}', "");
    Expect(0, 1616, '\P{Ccc=0_0_0_32}', "");
    Expect(1, 1616, '\P{^Ccc=0_0_0_32}', "");
    Expect(0, 1617, '\p{Ccc=0_0_0_32}', "");
    Expect(1, 1617, '\p{^Ccc=0_0_0_32}', "");
    Expect(1, 1617, '\P{Ccc=0_0_0_32}', "");
    Expect(0, 1617, '\P{^Ccc=0_0_0_32}', "");
    Error('\p{Is_Canonical_Combining_Class= 	CCC32/a/}');
    Error('\P{Is_Canonical_Combining_Class= 	CCC32/a/}');
    Expect(1, 1616, '\p{Is_Canonical_Combining_Class=ccc32}', "");
    Expect(0, 1616, '\p{^Is_Canonical_Combining_Class=ccc32}', "");
    Expect(0, 1616, '\P{Is_Canonical_Combining_Class=ccc32}', "");
    Expect(1, 1616, '\P{^Is_Canonical_Combining_Class=ccc32}', "");
    Expect(0, 1617, '\p{Is_Canonical_Combining_Class=ccc32}', "");
    Expect(1, 1617, '\p{^Is_Canonical_Combining_Class=ccc32}', "");
    Expect(1, 1617, '\P{Is_Canonical_Combining_Class=ccc32}', "");
    Expect(0, 1617, '\P{^Is_Canonical_Combining_Class=ccc32}', "");
    Expect(1, 1616, '\p{Is_Canonical_Combining_Class= ccc32}', "");
    Expect(0, 1616, '\p{^Is_Canonical_Combining_Class= ccc32}', "");
    Expect(0, 1616, '\P{Is_Canonical_Combining_Class= ccc32}', "");
    Expect(1, 1616, '\P{^Is_Canonical_Combining_Class= ccc32}', "");
    Expect(0, 1617, '\p{Is_Canonical_Combining_Class= ccc32}', "");
    Expect(1, 1617, '\p{^Is_Canonical_Combining_Class= ccc32}', "");
    Expect(1, 1617, '\P{Is_Canonical_Combining_Class= ccc32}', "");
    Expect(0, 1617, '\P{^Is_Canonical_Combining_Class= ccc32}', "");
    Error('\p{Is_Ccc=_ 0_0_0_0_0_0_0_0_0_32/a/}');
    Error('\P{Is_Ccc=_ 0_0_0_0_0_0_0_0_0_32/a/}');
    Expect(1, 1616, '\p{Is_Ccc=+00_00_00_32}', "");
    Expect(0, 1616, '\p{^Is_Ccc=+00_00_00_32}', "");
    Expect(0, 1616, '\P{Is_Ccc=+00_00_00_32}', "");
    Expect(1, 1616, '\P{^Is_Ccc=+00_00_00_32}', "");
    Expect(0, 1617, '\p{Is_Ccc=+00_00_00_32}', "");
    Expect(1, 1617, '\p{^Is_Ccc=+00_00_00_32}', "");
    Expect(1, 1617, '\P{Is_Ccc=+00_00_00_32}', "");
    Expect(0, 1617, '\P{^Is_Ccc=+00_00_00_32}', "");
    Error('\p{Canonical_Combining_Class=/a/__CCC33}');
    Error('\P{Canonical_Combining_Class=/a/__CCC33}');
    Expect(1, 1617, '\p{Canonical_Combining_Class=:\ACCC33\z:}', "");;
    Expect(0, 1618, '\p{Canonical_Combining_Class=:\ACCC33\z:}', "");;
    Expect(1, 1617, '\p{Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1617, '\p{^Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1617, '\P{Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1617, '\P{^Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1618, '\p{Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1618, '\p{^Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1618, '\P{Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1618, '\P{^Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1617, '\p{Canonical_Combining_Class=:\Accc33\z:}', "");;
    Expect(0, 1618, '\p{Canonical_Combining_Class=:\Accc33\z:}', "");;
    Expect(1, 1617, '\p{Canonical_Combining_Class=_ ccc33}', "");
    Expect(0, 1617, '\p{^Canonical_Combining_Class=_ ccc33}', "");
    Expect(0, 1617, '\P{Canonical_Combining_Class=_ ccc33}', "");
    Expect(1, 1617, '\P{^Canonical_Combining_Class=_ ccc33}', "");
    Expect(0, 1618, '\p{Canonical_Combining_Class=_ ccc33}', "");
    Expect(1, 1618, '\p{^Canonical_Combining_Class=_ ccc33}', "");
    Expect(1, 1618, '\P{Canonical_Combining_Class=_ ccc33}', "");
    Expect(0, 1618, '\P{^Canonical_Combining_Class=_ ccc33}', "");
    Error('\p{Ccc=	000033/a/}');
    Error('\P{Ccc=	000033/a/}');
    Expect(1, 1617, '\p{Ccc=:\A33\z:}', "");;
    Expect(0, 1618, '\p{Ccc=:\A33\z:}', "");;
    Expect(1, 1617, '\p{Ccc=0_0_0_0_0_33}', "");
    Expect(0, 1617, '\p{^Ccc=0_0_0_0_0_33}', "");
    Expect(0, 1617, '\P{Ccc=0_0_0_0_0_33}', "");
    Expect(1, 1617, '\P{^Ccc=0_0_0_0_0_33}', "");
    Expect(0, 1618, '\p{Ccc=0_0_0_0_0_33}', "");
    Expect(1, 1618, '\p{^Ccc=0_0_0_0_0_33}', "");
    Expect(1, 1618, '\P{Ccc=0_0_0_0_0_33}', "");
    Expect(0, 1618, '\P{^Ccc=0_0_0_0_0_33}', "");
    Error('\p{Is_Canonical_Combining_Class=  CCC33:=}');
    Error('\P{Is_Canonical_Combining_Class=  CCC33:=}');
    Expect(1, 1617, '\p{Is_Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1617, '\p{^Is_Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1617, '\P{Is_Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1617, '\P{^Is_Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1618, '\p{Is_Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1618, '\p{^Is_Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1618, '\P{Is_Canonical_Combining_Class=ccc33}', "");
    Expect(0, 1618, '\P{^Is_Canonical_Combining_Class=ccc33}', "");
    Expect(1, 1617, '\p{Is_Canonical_Combining_Class:		ccc33}', "");
    Expect(0, 1617, '\p{^Is_Canonical_Combining_Class:		ccc33}', "");
    Expect(0, 1617, '\P{Is_Canonical_Combining_Class:		ccc33}', "");
    Expect(1, 1617, '\P{^Is_Canonical_Combining_Class:		ccc33}', "");
    Expect(0, 1618, '\p{Is_Canonical_Combining_Class:		ccc33}', "");
    Expect(1, 1618, '\p{^Is_Canonical_Combining_Class:		ccc33}', "");
    Expect(1, 1618, '\P{Is_Canonical_Combining_Class:		ccc33}', "");
    Expect(0, 1618, '\P{^Is_Canonical_Combining_Class:		ccc33}', "");
    Error('\p{Is_Ccc=-00000000033:=}');
    Error('\P{Is_Ccc=-00000000033:=}');
    Expect(1, 1617, '\p{Is_Ccc=+033}', "");
    Expect(0, 1617, '\p{^Is_Ccc=+033}', "");
    Expect(0, 1617, '\P{Is_Ccc=+033}', "");
    Expect(1, 1617, '\P{^Is_Ccc=+033}', "");
    Expect(0, 1618, '\p{Is_Ccc=+033}', "");
    Expect(1, 1618, '\p{^Is_Ccc=+033}', "");
    Expect(1, 1618, '\P{Is_Ccc=+033}', "");
    Expect(0, 1618, '\P{^Is_Ccc=+033}', "");
    Error('\p{Canonical_Combining_Class=-:=CCC34}');
    Error('\P{Canonical_Combining_Class=-:=CCC34}');
    Expect(1, 1618, '\p{Canonical_Combining_Class=:\ACCC34\z:}', "");;
    Expect(0, 1619, '\p{Canonical_Combining_Class=:\ACCC34\z:}', "");;
    Expect(1, 1618, '\p{Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1618, '\p{^Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1618, '\P{Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1618, '\P{^Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1619, '\p{Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1619, '\p{^Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1619, '\P{Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1619, '\P{^Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1618, '\p{Canonical_Combining_Class=:\Accc34\z:}', "");;
    Expect(0, 1619, '\p{Canonical_Combining_Class=:\Accc34\z:}', "");;
    Expect(1, 1618, '\p{Canonical_Combining_Class= -CCC34}', "");
    Expect(0, 1618, '\p{^Canonical_Combining_Class= -CCC34}', "");
    Expect(0, 1618, '\P{Canonical_Combining_Class= -CCC34}', "");
    Expect(1, 1618, '\P{^Canonical_Combining_Class= -CCC34}', "");
    Expect(0, 1619, '\p{Canonical_Combining_Class= -CCC34}', "");
    Expect(1, 1619, '\p{^Canonical_Combining_Class= -CCC34}', "");
    Expect(1, 1619, '\P{Canonical_Combining_Class= -CCC34}', "");
    Expect(0, 1619, '\P{^Canonical_Combining_Class= -CCC34}', "");
    Error('\p{Ccc= _+00_00_00_00_34/a/}');
    Error('\P{Ccc= _+00_00_00_00_34/a/}');
    Expect(1, 1618, '\p{Ccc=:\A34\z:}', "");;
    Expect(0, 1619, '\p{Ccc=:\A34\z:}', "");;
    Expect(1, 1618, '\p{Ccc=00034}', "");
    Expect(0, 1618, '\p{^Ccc=00034}', "");
    Expect(0, 1618, '\P{Ccc=00034}', "");
    Expect(1, 1618, '\P{^Ccc=00034}', "");
    Expect(0, 1619, '\p{Ccc=00034}', "");
    Expect(1, 1619, '\p{^Ccc=00034}', "");
    Expect(1, 1619, '\P{Ccc=00034}', "");
    Expect(0, 1619, '\P{^Ccc=00034}', "");
    Error('\p{Is_Canonical_Combining_Class=:=		CCC34}');
    Error('\P{Is_Canonical_Combining_Class=:=		CCC34}');
    Expect(1, 1618, '\p{Is_Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1618, '\p{^Is_Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1618, '\P{Is_Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1618, '\P{^Is_Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1619, '\p{Is_Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1619, '\p{^Is_Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1619, '\P{Is_Canonical_Combining_Class=ccc34}', "");
    Expect(0, 1619, '\P{^Is_Canonical_Combining_Class=ccc34}', "");
    Expect(1, 1618, '\p{Is_Canonical_Combining_Class=-ccc34}', "");
    Expect(0, 1618, '\p{^Is_Canonical_Combining_Class=-ccc34}', "");
    Expect(0, 1618, '\P{Is_Canonical_Combining_Class=-ccc34}', "");
    Expect(1, 1618, '\P{^Is_Canonical_Combining_Class=-ccc34}', "");
    Expect(0, 1619, '\p{Is_Canonical_Combining_Class=-ccc34}', "");
    Expect(1, 1619, '\p{^Is_Canonical_Combining_Class=-ccc34}', "");
    Expect(1, 1619, '\P{Is_Canonical_Combining_Class=-ccc34}', "");
    Expect(0, 1619, '\P{^Is_Canonical_Combining_Class=-ccc34}', "");
    Error('\p{Is_Ccc=_:=0000034}');
    Error('\P{Is_Ccc=_:=0000034}');
    Expect(1, 1618, '\p{Is_Ccc:034}', "");
    Expect(0, 1618, '\p{^Is_Ccc:034}', "");
    Expect(0, 1618, '\P{Is_Ccc:034}', "");
    Expect(1, 1618, '\P{^Is_Ccc:034}', "");
    Expect(0, 1619, '\p{Is_Ccc:034}', "");
    Expect(1, 1619, '\p{^Is_Ccc:034}', "");
    Expect(1, 1619, '\P{Is_Ccc:034}', "");
    Expect(0, 1619, '\P{^Is_Ccc:034}', "");
    Error('\p{Canonical_Combining_Class= _CCC35/a/}');
    Error('\P{Canonical_Combining_Class= _CCC35/a/}');
    Expect(1, 1648, '\p{Canonical_Combining_Class=:\ACCC35\z:}', "");;
    Expect(0, 1649, '\p{Canonical_Combining_Class=:\ACCC35\z:}', "");;
    Expect(1, 1648, '\p{Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1648, '\p{^Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1648, '\P{Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1648, '\P{^Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1649, '\p{Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1649, '\p{^Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1649, '\P{Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1649, '\P{^Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1648, '\p{Canonical_Combining_Class=:\Accc35\z:}', "");;
    Expect(0, 1649, '\p{Canonical_Combining_Class=:\Accc35\z:}', "");;
    Expect(1, 1648, '\p{Canonical_Combining_Class:	- CCC35}', "");
    Expect(0, 1648, '\p{^Canonical_Combining_Class:	- CCC35}', "");
    Expect(0, 1648, '\P{Canonical_Combining_Class:	- CCC35}', "");
    Expect(1, 1648, '\P{^Canonical_Combining_Class:	- CCC35}', "");
    Expect(0, 1649, '\p{Canonical_Combining_Class:	- CCC35}', "");
    Expect(1, 1649, '\p{^Canonical_Combining_Class:	- CCC35}', "");
    Expect(1, 1649, '\P{Canonical_Combining_Class:	- CCC35}', "");
    Expect(0, 1649, '\P{^Canonical_Combining_Class:	- CCC35}', "");
    Error('\p{Ccc: :=		000_000_35}');
    Error('\P{Ccc: :=		000_000_35}');
    Expect(1, 1648, '\p{Ccc=:\A35\z:}', "");;
    Expect(0, 1649, '\p{Ccc=:\A35\z:}', "");;
    Expect(1, 1648, '\p{Ccc=0000000035}', "");
    Expect(0, 1648, '\p{^Ccc=0000000035}', "");
    Expect(0, 1648, '\P{Ccc=0000000035}', "");
    Expect(1, 1648, '\P{^Ccc=0000000035}', "");
    Expect(0, 1649, '\p{Ccc=0000000035}', "");
    Expect(1, 1649, '\p{^Ccc=0000000035}', "");
    Expect(1, 1649, '\P{Ccc=0000000035}', "");
    Expect(0, 1649, '\P{^Ccc=0000000035}', "");
    Error('\p{Is_Canonical_Combining_Class=-CCC35:=}');
    Error('\P{Is_Canonical_Combining_Class=-CCC35:=}');
    Expect(1, 1648, '\p{Is_Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1648, '\p{^Is_Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1648, '\P{Is_Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1648, '\P{^Is_Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1649, '\p{Is_Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1649, '\p{^Is_Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1649, '\P{Is_Canonical_Combining_Class=ccc35}', "");
    Expect(0, 1649, '\P{^Is_Canonical_Combining_Class=ccc35}', "");
    Expect(1, 1648, '\p{Is_Canonical_Combining_Class= _ccc35}', "");
    Expect(0, 1648, '\p{^Is_Canonical_Combining_Class= _ccc35}', "");
    Expect(0, 1648, '\P{Is_Canonical_Combining_Class= _ccc35}', "");
    Expect(1, 1648, '\P{^Is_Canonical_Combining_Class= _ccc35}', "");
    Expect(0, 1649, '\p{Is_Canonical_Combining_Class= _ccc35}', "");
    Expect(1, 1649, '\p{^Is_Canonical_Combining_Class= _ccc35}', "");
    Expect(1, 1649, '\P{Is_Canonical_Combining_Class= _ccc35}', "");
    Expect(0, 1649, '\P{^Is_Canonical_Combining_Class= _ccc35}', "");
    Error('\p{Is_Ccc=-0000_0003_5/a/}');
    Error('\P{Is_Ccc=-0000_0003_5/a/}');
    Expect(1, 1648, '\p{Is_Ccc=+000_000_35}', "");
    Expect(0, 1648, '\p{^Is_Ccc=+000_000_35}', "");
    Expect(0, 1648, '\P{Is_Ccc=+000_000_35}', "");
    Expect(1, 1648, '\P{^Is_Ccc=+000_000_35}', "");
    Expect(0, 1649, '\p{Is_Ccc=+000_000_35}', "");
    Expect(1, 1649, '\p{^Is_Ccc=+000_000_35}', "");
    Expect(1, 1649, '\P{Is_Ccc=+000_000_35}', "");
    Expect(0, 1649, '\P{^Is_Ccc=+000_000_35}', "");
    Error('\p{Canonical_Combining_Class=_:=CCC36}');
    Error('\P{Canonical_Combining_Class=_:=CCC36}');
    Expect(1, 1809, '\p{Canonical_Combining_Class=:\ACCC36\z:}', "");;
    Expect(0, 1810, '\p{Canonical_Combining_Class=:\ACCC36\z:}', "");;
    Expect(1, 1809, '\p{Canonical_Combining_Class=ccc36}', "");
    Expect(0, 1809, '\p{^Canonical_Combining_Class=ccc36}', "");
    Expect(0, 1809, '\P{Canonical_Combining_Class=ccc36}', "");
    Expect(1, 1809, '\P{^Canonical_Combining_Class=ccc36}', "");
    Expect(0, 1810, '\p{Canonical_Combining_Class=ccc36}', "");
    Expect(1, 1810, '\p{^Canonical_Combining_Class=ccc36}', "");
    Expect(1, 1810, '\P{Canonical_Combining_Class=ccc36}', "");
    Expect(0, 1810, '\P{^Canonical_Combining_Class=ccc36}', "");
    Expect(1, 1809, '\p{Canonical_Combining_Class=:\Accc36\z:}', "");;
    Expect(0, 1810, '\p{Canonical_Combining_Class=:\Accc36\z:}', "");;
    Expect(1, 1809, '\p{Canonical_Combining_Class: --CCC36}', "");
    Expect(0, 1809, '\p{^Canonical_Combining_Class: --CCC36}', "");
    Expect(0, 1809, '\P{Canonical_Combining_Class: --CCC36}', "");
    Expect(1, 1809, '\P{^Canonical_Combining_Class: --CCC36}', "");
    Expect(0, 1810, '\p{Canonical_Combining_Class: --CCC36}', "");
    Expect(1, 1810, '\p{^Canonical_Combining_Class: --CCC36}', "");
    Expect(1, 1810, '\P{Canonical_Combining_Class: --CCC36}', "");
    Expect(0, 1810, '\P{^Canonical_Combining_Class: --CCC36}', "");
    Error('\p{Ccc:--+000000036:=}');
    Error('\P{Ccc:--+000000036:=}');
    Expect(1, 1809, '\p{Ccc=:\A36\z:}', "");;
    Expect(0, 1810, '\p{Ccc=:\A36\z:}', "");;
    Expect(1, 1809, '\p{Ccc=36}', "");
    Expect(0, 1809, '\p{^Ccc=36}', "");
    Expect(0, 1809, '\P{Ccc=36}', "");
    Expect(1, 1809, '\P{^Ccc=36}', "");
    Expect(0, 1810, '\p{Ccc=36}', "");
    Expect(1, 1810, '\p{^Ccc=36}', "");
    Expect(1, 1810, '\P{Ccc=36}', "");
    Expect(0, 1810, '\P{^Ccc=36}', "");
    Error('\p{Is_Canonical_Combining_Class=CCC36:=}');
    Error('\P{Is_Canonical_Combining_Class=CCC36:=}');
    Expect(1, 1809, '\p{Is_Canonical_Combining_Class:	ccc36}', "");
    Expect(0, 1809, '\p{^Is_Canonical_Combining_Class:	ccc36}', "");
    Expect(0, 1809, '\P{Is_Canonical_Combining_Class:	ccc36}', "");
    Expect(1, 1809, '\P{^Is_Canonical_Combining_Class:	ccc36}', "");
    Expect(0, 1810, '\p{Is_Canonical_Combining_Class:	ccc36}', "");
    Expect(1, 1810, '\p{^Is_Canonical_Combining_Class:	ccc36}', "");
    Expect(1, 1810, '\P{Is_Canonical_Combining_Class:	ccc36}', "");
    Expect(0, 1810, '\P{^Is_Canonical_Combining_Class:	ccc36}', "");
    Expect(1, 1809, '\p{Is_Canonical_Combining_Class=- ccc36}', "");
    Expect(0, 1809, '\p{^Is_Canonical_Combining_Class=- ccc36}', "");
    Expect(0, 1809, '\P{Is_Canonical_Combining_Class=- ccc36}', "");
    Expect(1, 1809, '\P{^Is_Canonical_Combining_Class=- ccc36}', "");
    Expect(0, 1810, '\p{Is_Canonical_Combining_Class=- ccc36}', "");
    Expect(1, 1810, '\p{^Is_Canonical_Combining_Class=- ccc36}', "");
    Expect(1, 1810, '\P{Is_Canonical_Combining_Class=- ccc36}', "");
    Expect(0, 1810, '\P{^Is_Canonical_Combining_Class=- ccc36}', "");
    Error('\p{Is_Ccc=- 03_6:=}');
    Error('\P{Is_Ccc=- 03_6:=}');
    Expect(1, 1809, '\p{Is_Ccc: 00000036}', "");
    Expect(0, 1809, '\p{^Is_Ccc: 00000036}', "");
    Expect(0, 1809, '\P{Is_Ccc: 00000036}', "");
    Expect(1, 1809, '\P{^Is_Ccc: 00000036}', "");
    Expect(0, 1810, '\p{Is_Ccc: 00000036}', "");
    Expect(1, 1810, '\p{^Is_Ccc: 00000036}', "");
    Expect(1, 1810, '\P{Is_Ccc: 00000036}', "");
    Expect(0, 1810, '\P{^Is_Ccc: 00000036}', "");
    Error('\p{Canonical_Combining_Class=-/a/ccc84}');
    Error('\P{Canonical_Combining_Class=-/a/ccc84}');
    Expect(1, 3157, '\p{Canonical_Combining_Class=:\ACCC84\z:}', "");;
    Expect(0, 3158, '\p{Canonical_Combining_Class=:\ACCC84\z:}', "");;
    Expect(1, 3157, '\p{Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3157, '\p{^Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3157, '\P{Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3157, '\P{^Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3158, '\p{Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3158, '\p{^Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3158, '\P{Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3158, '\P{^Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3157, '\p{Canonical_Combining_Class=:\Accc84\z:}', "");;
    Expect(0, 3158, '\p{Canonical_Combining_Class=:\Accc84\z:}', "");;
    Expect(1, 3157, '\p{Canonical_Combining_Class= CCC84}', "");
    Expect(0, 3157, '\p{^Canonical_Combining_Class= CCC84}', "");
    Expect(0, 3157, '\P{Canonical_Combining_Class= CCC84}', "");
    Expect(1, 3157, '\P{^Canonical_Combining_Class= CCC84}', "");
    Expect(0, 3158, '\p{Canonical_Combining_Class= CCC84}', "");
    Expect(1, 3158, '\p{^Canonical_Combining_Class= CCC84}', "");
    Expect(1, 3158, '\P{Canonical_Combining_Class= CCC84}', "");
    Expect(0, 3158, '\P{^Canonical_Combining_Class= CCC84}', "");
    Error('\p{Ccc=:=	_0000000084}');
    Error('\P{Ccc=:=	_0000000084}');
    Expect(1, 3157, '\p{Ccc=:\A84\z:}', "");;
    Expect(0, 3158, '\p{Ccc=:\A84\z:}', "");;
    Expect(1, 3157, '\p{Ccc=0_0_84}', "");
    Expect(0, 3157, '\p{^Ccc=0_0_84}', "");
    Expect(0, 3157, '\P{Ccc=0_0_84}', "");
    Expect(1, 3157, '\P{^Ccc=0_0_84}', "");
    Expect(0, 3158, '\p{Ccc=0_0_84}', "");
    Expect(1, 3158, '\p{^Ccc=0_0_84}', "");
    Expect(1, 3158, '\P{Ccc=0_0_84}', "");
    Expect(0, 3158, '\P{^Ccc=0_0_84}', "");
    Error('\p{Is_Canonical_Combining_Class=:=CCC84}');
    Error('\P{Is_Canonical_Combining_Class=:=CCC84}');
    Expect(1, 3157, '\p{Is_Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3157, '\p{^Is_Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3157, '\P{Is_Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3157, '\P{^Is_Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3158, '\p{Is_Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3158, '\p{^Is_Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3158, '\P{Is_Canonical_Combining_Class=ccc84}', "");
    Expect(0, 3158, '\P{^Is_Canonical_Combining_Class=ccc84}', "");
    Expect(1, 3157, '\p{Is_Canonical_Combining_Class=  CCC84}', "");
    Expect(0, 3157, '\p{^Is_Canonical_Combining_Class=  CCC84}', "");
    Expect(0, 3157, '\P{Is_Canonical_Combining_Class=  CCC84}', "");
    Expect(1, 3157, '\P{^Is_Canonical_Combining_Class=  CCC84}', "");
    Expect(0, 3158, '\p{Is_Canonical_Combining_Class=  CCC84}', "");
    Expect(1, 3158, '\p{^Is_Canonical_Combining_Class=  CCC84}', "");
    Expect(1, 3158, '\P{Is_Canonical_Combining_Class=  CCC84}', "");
    Expect(0, 3158, '\P{^Is_Canonical_Combining_Class=  CCC84}', "");
    Error('\p{Is_Ccc= 0_0_0_0_0084/a/}');
    Error('\P{Is_Ccc= 0_0_0_0_0084/a/}');
    Expect(1, 3157, '\p{Is_Ccc=+000_008_4}', "");
    Expect(0, 3157, '\p{^Is_Ccc=+000_008_4}', "");
    Expect(0, 3157, '\P{Is_Ccc=+000_008_4}', "");
    Expect(1, 3157, '\P{^Is_Ccc=+000_008_4}', "");
    Expect(0, 3158, '\p{Is_Ccc=+000_008_4}', "");
    Expect(1, 3158, '\p{^Is_Ccc=+000_008_4}', "");
    Expect(1, 3158, '\P{Is_Ccc=+000_008_4}', "");
    Expect(0, 3158, '\P{^Is_Ccc=+000_008_4}', "");
    Error('\p{Canonical_Combining_Class=	CCC91/a/}');
    Error('\P{Canonical_Combining_Class=	CCC91/a/}');
    Expect(1, 3158, '\p{Canonical_Combining_Class=:\ACCC91\z:}', "");;
    Expect(0, 3159, '\p{Canonical_Combining_Class=:\ACCC91\z:}', "");;
    Expect(1, 3158, '\p{Canonical_Combining_Class=ccc91}', "");
    Expect(0, 3158, '\p{^Canonical_Combining_Class=ccc91}', "");
    Expect(0, 3158, '\P{Canonical_Combining_Class=ccc91}', "");
    Expect(1, 3158, '\P{^Canonical_Combining_Class=ccc91}', "");
    Expect(0, 3159, '\p{Canonical_Combining_Class=ccc91}', "");
    Expect(1, 3159, '\p{^Canonical_Combining_Class=ccc91}', "");
    Expect(1, 3159, '\P{Canonical_Combining_Class=ccc91}', "");
    Expect(0, 3159, '\P{^Canonical_Combining_Class=ccc91}', "");
    Expect(1, 3158, '\p{Canonical_Combining_Class=:\Accc91\z:}', "");;
    Expect(0, 3159, '\p{Canonical_Combining_Class=:\Accc91\z:}', "");;
    Expect(1, 3158, '\p{Canonical_Combining_Class= CCC91}', "");
    Expect(0, 3158, '\p{^Canonical_Combining_Class= CCC91}', "");
    Expect(0, 3158, '\P{Canonical_Combining_Class= CCC91}', "");
    Expect(1, 3158, '\P{^Canonical_Combining_Class= CCC91}', "");
    Expect(0, 3159, '\p{Canonical_Combining_Class= CCC91}', "");
    Expect(1, 3159, '\p{^Canonical_Combining_Class= CCC91}', "");
    Expect(1, 3159, '\P{Canonical_Combining_Class= CCC91}', "");
    Expect(0, 3159, '\P{^Canonical_Combining_Class= CCC91}', "");
    Error('\p{Ccc:	 :=+00_00_00_091}');
    Error('\P{Ccc:	 :=+00_00_00_091}');
    Expect(1, 3158, '\p{Ccc=:\A91\z:}', "");;
    Expect(0, 3159, '\p{Ccc=:\A91\z:}', "");;
    Expect(1, 3158, '\p{Ccc=+091}', "");
    Expect(0, 3158, '\p{^Ccc=+091}', "");
    Expect(0, 3158, '\P{Ccc=+091}', "");
    Expect(1, 3158, '\P{^Ccc=+091}', "");
    Expect(0, 3159, '\p{Ccc=+091}', "");
    Expect(1, 3159, '\p{^Ccc=+091}', "");
    Expect(1, 3159, '\P{Ccc=+091}', "");
    Expect(0, 3159, '\P{^Ccc=+091}', "");
    Error('\p{Is_Canonical_Combining_Class=_:=CCC91}');
    Error('\P{Is_Canonical_Combining_Class=_:=CCC91}');
    Expect(1, 3158, '\p{Is_Canonical_Combining_Class=ccc91}', "");
    Expect(0, 3158, '\p{^Is_Canonical_Combining_Class=ccc91}', "");
    Expect(0, 3158, '\P{Is_Canonical_Combining_Class=ccc91}', "");
    Expect(1, 3158, '\P{^Is_Canonical_Combining_Class=ccc91}', "");
    Expect(0, 3159, '\p{Is_Canonical_Combining_Class=ccc91}', "");
    Expect(1, 3159, '\p{^Is_Canonical_Combining_Class=ccc91}', "");
    Expect(1, 3159, '\P{Is_Canonical_Combining_Class=ccc91}', "");
    Expect(0, 3159, '\P{^Is_Canonical_Combining_Class=ccc91}', "");
    Expect(1, 3158, '\p{Is_Canonical_Combining_Class= ccc91}', "");
    Expect(0, 3158, '\p{^Is_Canonical_Combining_Class= ccc91}', "");
    Expect(0, 3158, '\P{Is_Canonical_Combining_Class= ccc91}', "");
    Expect(1, 3158, '\P{^Is_Canonical_Combining_Class= ccc91}', "");
    Expect(0, 3159, '\p{Is_Canonical_Combining_Class= ccc91}', "");
    Expect(1, 3159, '\p{^Is_Canonical_Combining_Class= ccc91}', "");
    Expect(1, 3159, '\P{Is_Canonical_Combining_Class= ccc91}', "");
    Expect(0, 3159, '\P{^Is_Canonical_Combining_Class= ccc91}', "");
    Error('\p{Is_Ccc=--0000000091/a/}');
    Error('\P{Is_Ccc=--0000000091/a/}');
    Expect(1, 3158, '\p{Is_Ccc=00000000091}', "");
    Expect(0, 3158, '\p{^Is_Ccc=00000000091}', "");
    Expect(0, 3158, '\P{Is_Ccc=00000000091}', "");
    Expect(1, 3158, '\P{^Is_Ccc=00000000091}', "");
    Expect(0, 3159, '\p{Is_Ccc=00000000091}', "");
    Expect(1, 3159, '\p{^Is_Ccc=00000000091}', "");
    Expect(1, 3159, '\P{Is_Ccc=00000000091}', "");
    Expect(0, 3159, '\P{^Is_Ccc=00000000091}', "");
    Error('\p{Canonical_Combining_Class=- double_Above:=}');
    Error('\P{Canonical_Combining_Class=- double_Above:=}');
    Expect(1, 7629, '\p{Canonical_Combining_Class=:\ADouble_Above\z:}', "");;
    Expect(0, 7630, '\p{Canonical_Combining_Class=:\ADouble_Above\z:}', "");;
    Expect(1, 7629, '\p{Canonical_Combining_Class=doubleabove}', "");
    Expect(0, 7629, '\p{^Canonical_Combining_Class=doubleabove}', "");
    Expect(0, 7629, '\P{Canonical_Combining_Class=doubleabove}', "");
    Expect(1, 7629, '\P{^Canonical_Combining_Class=doubleabove}', "");
    Expect(0, 7630, '\p{Canonical_Combining_Class=doubleabove}', "");
    Expect(1, 7630, '\p{^Canonical_Combining_Class=doubleabove}', "");
    Expect(1, 7630, '\P{Canonical_Combining_Class=doubleabove}', "");
    Expect(0, 7630, '\P{^Canonical_Combining_Class=doubleabove}', "");
    Expect(1, 7629, '\p{Canonical_Combining_Class=:\Adoubleabove\z:}', "");;
    Expect(0, 7630, '\p{Canonical_Combining_Class=:\Adoubleabove\z:}', "");;
    Expect(1, 7629, '\p{Canonical_Combining_Class=	double_ABOVE}', "");
    Expect(0, 7629, '\p{^Canonical_Combining_Class=	double_ABOVE}', "");
    Expect(0, 7629, '\P{Canonical_Combining_Class=	double_ABOVE}', "");
    Expect(1, 7629, '\P{^Canonical_Combining_Class=	double_ABOVE}', "");
    Expect(0, 7630, '\p{Canonical_Combining_Class=	double_ABOVE}', "");
    Expect(1, 7630, '\p{^Canonical_Combining_Class=	double_ABOVE}', "");
    Expect(1, 7630, '\P{Canonical_Combining_Class=	double_ABOVE}', "");
    Expect(0, 7630, '\P{^Canonical_Combining_Class=	double_ABOVE}', "");
    Error('\p{Ccc:	/a/ _DA}');
    Error('\P{Ccc:	/a/ _DA}');
    Expect(1, 7629, '\p{Ccc=:\ADA\z:}', "");;
    Expect(0, 7630, '\p{Ccc=:\ADA\z:}', "");;
    Expect(1, 7629, '\p{Ccc=da}', "");
    Expect(0, 7629, '\p{^Ccc=da}', "");
    Expect(0, 7629, '\P{Ccc=da}', "");
    Expect(1, 7629, '\P{^Ccc=da}', "");
    Expect(0, 7630, '\p{Ccc=da}', "");
    Expect(1, 7630, '\p{^Ccc=da}', "");
    Expect(1, 7630, '\P{Ccc=da}', "");
    Expect(0, 7630, '\P{^Ccc=da}', "");
    Expect(1, 7629, '\p{Ccc=:\Ada\z:}', "");;
    Expect(0, 7630, '\p{Ccc=:\Ada\z:}', "");;
    Expect(1, 7629, '\p{Ccc=	DA}', "");
    Expect(0, 7629, '\p{^Ccc=	DA}', "");
    Expect(0, 7629, '\P{Ccc=	DA}', "");
    Expect(1, 7629, '\P{^Ccc=	DA}', "");
    Expect(0, 7630, '\p{Ccc=	DA}', "");
    Expect(1, 7630, '\p{^Ccc=	DA}', "");
    Expect(1, 7630, '\P{Ccc=	DA}', "");
    Expect(0, 7630, '\P{^Ccc=	DA}', "");
    Error('\p{Is_Canonical_Combining_Class=:=_00_00_00_23_4}');
    Error('\P{Is_Canonical_Combining_Class=:=_00_00_00_23_4}');
    Expect(1, 7629, '\p{Is_Canonical_Combining_Class=+00_00_00_00_23_4}', "");
    Expect(0, 7629, '\p{^Is_Canonical_Combining_Class=+00_00_00_00_23_4}', "");
    Expect(0, 7629, '\P{Is_Canonical_Combining_Class=+00_00_00_00_23_4}', "");
    Expect(1, 7629, '\P{^Is_Canonical_Combining_Class=+00_00_00_00_23_4}', "");
    Expect(0, 7630, '\p{Is_Canonical_Combining_Class=+00_00_00_00_23_4}', "");
    Expect(1, 7630, '\p{^Is_Canonical_Combining_Class=+00_00_00_00_23_4}', "");
    Expect(1, 7630, '\P{Is_Canonical_Combining_Class=+00_00_00_00_23_4}', "");
    Expect(0, 7630, '\P{^Is_Canonical_Combining_Class=+00_00_00_00_23_4}', "");
    Error('\p{Is_Ccc=	_Double_ABOVE:=}');
    Error('\P{Is_Ccc=	_Double_ABOVE:=}');
    Expect(1, 7629, '\p{Is_Ccc=doubleabove}', "");
    Expect(0, 7629, '\p{^Is_Ccc=doubleabove}', "");
    Expect(0, 7629, '\P{Is_Ccc=doubleabove}', "");
    Expect(1, 7629, '\P{^Is_Ccc=doubleabove}', "");
    Expect(0, 7630, '\p{Is_Ccc=doubleabove}', "");
    Expect(1, 7630, '\p{^Is_Ccc=doubleabove}', "");
    Expect(1, 7630, '\P{Is_Ccc=doubleabove}', "");
    Expect(0, 7630, '\P{^Is_Ccc=doubleabove}', "");
    Expect(1, 7629, '\p{Is_Ccc=__double_Above}', "");
    Expect(0, 7629, '\p{^Is_Ccc=__double_Above}', "");
    Expect(0, 7629, '\P{Is_Ccc=__double_Above}', "");
    Expect(1, 7629, '\P{^Is_Ccc=__double_Above}', "");
    Expect(0, 7630, '\p{Is_Ccc=__double_Above}', "");
    Expect(1, 7630, '\p{^Is_Ccc=__double_Above}', "");
    Expect(1, 7630, '\P{Is_Ccc=__double_Above}', "");
    Expect(0, 7630, '\P{^Is_Ccc=__double_Above}', "");
    Error('\p{Canonical_Combining_Class: 	-DOUBLE_below/a/}');
    Error('\P{Canonical_Combining_Class: 	-DOUBLE_below/a/}');
    Expect(1, 7676, '\p{Canonical_Combining_Class=:\ADouble_Below\z:}', "");;
    Expect(0, 7677, '\p{Canonical_Combining_Class=:\ADouble_Below\z:}', "");;
    Expect(1, 7676, '\p{Canonical_Combining_Class=doublebelow}', "");
    Expect(0, 7676, '\p{^Canonical_Combining_Class=doublebelow}', "");
    Expect(0, 7676, '\P{Canonical_Combining_Class=doublebelow}', "");
    Expect(1, 7676, '\P{^Canonical_Combining_Class=doublebelow}', "");
    Expect(0, 7677, '\p{Canonical_Combining_Class=doublebelow}', "");
    Expect(1, 7677, '\p{^Canonical_Combining_Class=doublebelow}', "");
    Expect(1, 7677, '\P{Canonical_Combining_Class=doublebelow}', "");
    Expect(0, 7677, '\P{^Canonical_Combining_Class=doublebelow}', "");
    Expect(1, 7676, '\p{Canonical_Combining_Class=:\Adoublebelow\z:}', "");;
    Expect(0, 7677, '\p{Canonical_Combining_Class=:\Adoublebelow\z:}', "");;
    Expect(1, 7676, '\p{Canonical_Combining_Class=-Double_Below}', "");
    Expect(0, 7676, '\p{^Canonical_Combining_Class=-Double_Below}', "");
    Expect(0, 7676, '\P{Canonical_Combining_Class=-Double_Below}', "");
    Expect(1, 7676, '\P{^Canonical_Combining_Class=-Double_Below}', "");
    Expect(0, 7677, '\p{Canonical_Combining_Class=-Double_Below}', "");
    Expect(1, 7677, '\p{^Canonical_Combining_Class=-Double_Below}', "");
    Expect(1, 7677, '\P{Canonical_Combining_Class=-Double_Below}', "");
    Expect(0, 7677, '\P{^Canonical_Combining_Class=-Double_Below}', "");
    Error('\p{Ccc=:= DB}');
    Error('\P{Ccc=:= DB}');
    Expect(1, 7676, '\p{Ccc=:\ADB\z:}', "");;
    Expect(0, 7677, '\p{Ccc=:\ADB\z:}', "");;
    Expect(1, 7676, '\p{Ccc=db}', "");
    Expect(0, 7676, '\p{^Ccc=db}', "");
    Expect(0, 7676, '\P{Ccc=db}', "");
    Expect(1, 7676, '\P{^Ccc=db}', "");
    Expect(0, 7677, '\p{Ccc=db}', "");
    Expect(1, 7677, '\p{^Ccc=db}', "");
    Expect(1, 7677, '\P{Ccc=db}', "");
    Expect(0, 7677, '\P{^Ccc=db}', "");
    Expect(1, 7676, '\p{Ccc=:\Adb\z:}', "");;
    Expect(0, 7677, '\p{Ccc=:\Adb\z:}', "");;
    Expect(1, 7676, '\p{Ccc= DB}', "");
    Expect(0, 7676, '\p{^Ccc= DB}', "");
    Expect(0, 7676, '\P{Ccc= DB}', "");
    Expect(1, 7676, '\P{^Ccc= DB}', "");
    Expect(0, 7677, '\p{Ccc= DB}', "");
    Expect(1, 7677, '\p{^Ccc= DB}', "");
    Expect(1, 7677, '\P{Ccc= DB}', "");
    Expect(0, 7677, '\P{^Ccc= DB}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/-0_0_0_0_0_0_000233}');
    Error('\P{Is_Canonical_Combining_Class=/a/-0_0_0_0_0_0_000233}');
    Expect(1, 7676, '\p{Is_Canonical_Combining_Class=+00000233}', "");
    Expect(0, 7676, '\p{^Is_Canonical_Combining_Class=+00000233}', "");
    Expect(0, 7676, '\P{Is_Canonical_Combining_Class=+00000233}', "");
    Expect(1, 7676, '\P{^Is_Canonical_Combining_Class=+00000233}', "");
    Expect(0, 7677, '\p{Is_Canonical_Combining_Class=+00000233}', "");
    Expect(1, 7677, '\p{^Is_Canonical_Combining_Class=+00000233}', "");
    Expect(1, 7677, '\P{Is_Canonical_Combining_Class=+00000233}', "");
    Expect(0, 7677, '\P{^Is_Canonical_Combining_Class=+00000233}', "");
    Error('\p{Is_Ccc=/a/-DOUBLE_Below}');
    Error('\P{Is_Ccc=/a/-DOUBLE_Below}');
    Expect(1, 7676, '\p{Is_Ccc=doublebelow}', "");
    Expect(0, 7676, '\p{^Is_Ccc=doublebelow}', "");
    Expect(0, 7676, '\P{Is_Ccc=doublebelow}', "");
    Expect(1, 7676, '\P{^Is_Ccc=doublebelow}', "");
    Expect(0, 7677, '\p{Is_Ccc=doublebelow}', "");
    Expect(1, 7677, '\p{^Is_Ccc=doublebelow}', "");
    Expect(1, 7677, '\P{Is_Ccc=doublebelow}', "");
    Expect(0, 7677, '\P{^Is_Ccc=doublebelow}', "");
    Expect(1, 7676, '\p{Is_Ccc=_double_below}', "");
    Expect(0, 7676, '\p{^Is_Ccc=_double_below}', "");
    Expect(0, 7676, '\P{Is_Ccc=_double_below}', "");
    Expect(1, 7676, '\P{^Is_Ccc=_double_below}', "");
    Expect(0, 7677, '\p{Is_Ccc=_double_below}', "");
    Expect(1, 7677, '\p{^Is_Ccc=_double_below}', "");
    Expect(1, 7677, '\P{Is_Ccc=_double_below}', "");
    Expect(0, 7677, '\P{^Is_Ccc=_double_below}', "");
    Error('\p{Canonical_Combining_Class=:= -iota_Subscript}');
    Error('\P{Canonical_Combining_Class=:= -iota_Subscript}');
    Expect(1, 837, '\p{Canonical_Combining_Class=:\AIota_Subscript\z:}', "");;
    Expect(0, 838, '\p{Canonical_Combining_Class=:\AIota_Subscript\z:}', "");;
    Expect(1, 837, '\p{Canonical_Combining_Class=iotasubscript}', "");
    Expect(0, 837, '\p{^Canonical_Combining_Class=iotasubscript}', "");
    Expect(0, 837, '\P{Canonical_Combining_Class=iotasubscript}', "");
    Expect(1, 837, '\P{^Canonical_Combining_Class=iotasubscript}', "");
    Expect(0, 838, '\p{Canonical_Combining_Class=iotasubscript}', "");
    Expect(1, 838, '\p{^Canonical_Combining_Class=iotasubscript}', "");
    Expect(1, 838, '\P{Canonical_Combining_Class=iotasubscript}', "");
    Expect(0, 838, '\P{^Canonical_Combining_Class=iotasubscript}', "");
    Expect(1, 837, '\p{Canonical_Combining_Class=:\Aiotasubscript\z:}', "");;
    Expect(0, 838, '\p{Canonical_Combining_Class=:\Aiotasubscript\z:}', "");;
    Expect(1, 837, '\p{Canonical_Combining_Class= 	Iota_Subscript}', "");
    Expect(0, 837, '\p{^Canonical_Combining_Class= 	Iota_Subscript}', "");
    Expect(0, 837, '\P{Canonical_Combining_Class= 	Iota_Subscript}', "");
    Expect(1, 837, '\P{^Canonical_Combining_Class= 	Iota_Subscript}', "");
    Expect(0, 838, '\p{Canonical_Combining_Class= 	Iota_Subscript}', "");
    Expect(1, 838, '\p{^Canonical_Combining_Class= 	Iota_Subscript}', "");
    Expect(1, 838, '\P{Canonical_Combining_Class= 	Iota_Subscript}', "");
    Expect(0, 838, '\P{^Canonical_Combining_Class= 	Iota_Subscript}', "");
    Error('\p{Ccc=	-IS:=}');
    Error('\P{Ccc=	-IS:=}');
    Expect(1, 837, '\p{Ccc=:\AIS\z:}', "");;
    Expect(0, 838, '\p{Ccc=:\AIS\z:}', "");;
    Expect(1, 837, '\p{Ccc=is}', "");
    Expect(0, 837, '\p{^Ccc=is}', "");
    Expect(0, 837, '\P{Ccc=is}', "");
    Expect(1, 837, '\P{^Ccc=is}', "");
    Expect(0, 838, '\p{Ccc=is}', "");
    Expect(1, 838, '\p{^Ccc=is}', "");
    Expect(1, 838, '\P{Ccc=is}', "");
    Expect(0, 838, '\P{^Ccc=is}', "");
    Expect(1, 837, '\p{Ccc=:\Ais\z:}', "");;
    Expect(0, 838, '\p{Ccc=:\Ais\z:}', "");;
    Expect(1, 837, '\p{Ccc=-IS}', "");
    Expect(0, 837, '\p{^Ccc=-IS}', "");
    Expect(0, 837, '\P{Ccc=-IS}', "");
    Expect(1, 837, '\P{^Ccc=-IS}', "");
    Expect(0, 838, '\p{Ccc=-IS}', "");
    Expect(1, 838, '\p{^Ccc=-IS}', "");
    Expect(1, 838, '\P{Ccc=-IS}', "");
    Expect(0, 838, '\P{^Ccc=-IS}', "");
    Error('\p{Is_Canonical_Combining_Class= :=+000000024_0}');
    Error('\P{Is_Canonical_Combining_Class= :=+000000024_0}');
    Expect(1, 837, '\p{Is_Canonical_Combining_Class:   240}', "");
    Expect(0, 837, '\p{^Is_Canonical_Combining_Class:   240}', "");
    Expect(0, 837, '\P{Is_Canonical_Combining_Class:   240}', "");
    Expect(1, 837, '\P{^Is_Canonical_Combining_Class:   240}', "");
    Expect(0, 838, '\p{Is_Canonical_Combining_Class:   240}', "");
    Expect(1, 838, '\p{^Is_Canonical_Combining_Class:   240}', "");
    Expect(1, 838, '\P{Is_Canonical_Combining_Class:   240}', "");
    Expect(0, 838, '\P{^Is_Canonical_Combining_Class:   240}', "");
    Error('\p{Is_Ccc= /a/IOTA_SUBSCRIPT}');
    Error('\P{Is_Ccc= /a/IOTA_SUBSCRIPT}');
    Expect(1, 837, '\p{Is_Ccc=iotasubscript}', "");
    Expect(0, 837, '\p{^Is_Ccc=iotasubscript}', "");
    Expect(0, 837, '\P{Is_Ccc=iotasubscript}', "");
    Expect(1, 837, '\P{^Is_Ccc=iotasubscript}', "");
    Expect(0, 838, '\p{Is_Ccc=iotasubscript}', "");
    Expect(1, 838, '\p{^Is_Ccc=iotasubscript}', "");
    Expect(1, 838, '\P{Is_Ccc=iotasubscript}', "");
    Expect(0, 838, '\P{^Is_Ccc=iotasubscript}', "");
    Expect(1, 837, '\p{Is_Ccc=-iota_SUBSCRIPT}', "");
    Expect(0, 837, '\p{^Is_Ccc=-iota_SUBSCRIPT}', "");
    Expect(0, 837, '\P{Is_Ccc=-iota_SUBSCRIPT}', "");
    Expect(1, 837, '\P{^Is_Ccc=-iota_SUBSCRIPT}', "");
    Expect(0, 838, '\p{Is_Ccc=-iota_SUBSCRIPT}', "");
    Expect(1, 838, '\p{^Is_Ccc=-iota_SUBSCRIPT}', "");
    Expect(1, 838, '\P{Is_Ccc=-iota_SUBSCRIPT}', "");
    Expect(0, 838, '\P{^Is_Ccc=-iota_SUBSCRIPT}', "");
    Error('\p{Canonical_Combining_Class=	 kana_Voicing/a/}');
    Error('\P{Canonical_Combining_Class=	 kana_Voicing/a/}');
    Expect(1, 12442, '\p{Canonical_Combining_Class=:\AKana_Voicing\z:}', "");;
    Expect(0, 12443, '\p{Canonical_Combining_Class=:\AKana_Voicing\z:}', "");;
    Expect(1, 12442, '\p{Canonical_Combining_Class=kanavoicing}', "");
    Expect(0, 12442, '\p{^Canonical_Combining_Class=kanavoicing}', "");
    Expect(0, 12442, '\P{Canonical_Combining_Class=kanavoicing}', "");
    Expect(1, 12442, '\P{^Canonical_Combining_Class=kanavoicing}', "");
    Expect(0, 12443, '\p{Canonical_Combining_Class=kanavoicing}', "");
    Expect(1, 12443, '\p{^Canonical_Combining_Class=kanavoicing}', "");
    Expect(1, 12443, '\P{Canonical_Combining_Class=kanavoicing}', "");
    Expect(0, 12443, '\P{^Canonical_Combining_Class=kanavoicing}', "");
    Expect(1, 12442, '\p{Canonical_Combining_Class=:\Akanavoicing\z:}', "");;
    Expect(0, 12443, '\p{Canonical_Combining_Class=:\Akanavoicing\z:}', "");;
    Expect(1, 12442, '\p{Canonical_Combining_Class= 	kana_voicing}', "");
    Expect(0, 12442, '\p{^Canonical_Combining_Class= 	kana_voicing}', "");
    Expect(0, 12442, '\P{Canonical_Combining_Class= 	kana_voicing}', "");
    Expect(1, 12442, '\P{^Canonical_Combining_Class= 	kana_voicing}', "");
    Expect(0, 12443, '\p{Canonical_Combining_Class= 	kana_voicing}', "");
    Expect(1, 12443, '\p{^Canonical_Combining_Class= 	kana_voicing}', "");
    Expect(1, 12443, '\P{Canonical_Combining_Class= 	kana_voicing}', "");
    Expect(0, 12443, '\P{^Canonical_Combining_Class= 	kana_voicing}', "");
    Error('\p{Ccc:  KV:=}');
    Error('\P{Ccc:  KV:=}');
    Expect(1, 12442, '\p{Ccc=:\AKV\z:}', "");;
    Expect(0, 12443, '\p{Ccc=:\AKV\z:}', "");;
    Expect(1, 12442, '\p{Ccc=kv}', "");
    Expect(0, 12442, '\p{^Ccc=kv}', "");
    Expect(0, 12442, '\P{Ccc=kv}', "");
    Expect(1, 12442, '\P{^Ccc=kv}', "");
    Expect(0, 12443, '\p{Ccc=kv}', "");
    Expect(1, 12443, '\p{^Ccc=kv}', "");
    Expect(1, 12443, '\P{Ccc=kv}', "");
    Expect(0, 12443, '\P{^Ccc=kv}', "");
    Expect(1, 12442, '\p{Ccc=:\Akv\z:}', "");;
    Expect(0, 12443, '\p{Ccc=:\Akv\z:}', "");;
    Expect(1, 12442, '\p{Ccc=	_KV}', "");
    Expect(0, 12442, '\p{^Ccc=	_KV}', "");
    Expect(0, 12442, '\P{Ccc=	_KV}', "");
    Expect(1, 12442, '\P{^Ccc=	_KV}', "");
    Expect(0, 12443, '\p{Ccc=	_KV}', "");
    Expect(1, 12443, '\p{^Ccc=	_KV}', "");
    Expect(1, 12443, '\P{Ccc=	_KV}', "");
    Expect(0, 12443, '\P{^Ccc=	_KV}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/ +000000008}');
    Error('\P{Is_Canonical_Combining_Class=/a/ +000000008}');
    Expect(1, 12442, '\p{Is_Canonical_Combining_Class=00008}', "");
    Expect(0, 12442, '\p{^Is_Canonical_Combining_Class=00008}', "");
    Expect(0, 12442, '\P{Is_Canonical_Combining_Class=00008}', "");
    Expect(1, 12442, '\P{^Is_Canonical_Combining_Class=00008}', "");
    Expect(0, 12443, '\p{Is_Canonical_Combining_Class=00008}', "");
    Expect(1, 12443, '\p{^Is_Canonical_Combining_Class=00008}', "");
    Expect(1, 12443, '\P{Is_Canonical_Combining_Class=00008}', "");
    Expect(0, 12443, '\P{^Is_Canonical_Combining_Class=00008}', "");
    Error('\p{Is_Ccc=/a/  Kana_Voicing}');
    Error('\P{Is_Ccc=/a/  Kana_Voicing}');
    Expect(1, 12442, '\p{Is_Ccc=kanavoicing}', "");
    Expect(0, 12442, '\p{^Is_Ccc=kanavoicing}', "");
    Expect(0, 12442, '\P{Is_Ccc=kanavoicing}', "");
    Expect(1, 12442, '\P{^Is_Ccc=kanavoicing}', "");
    Expect(0, 12443, '\p{Is_Ccc=kanavoicing}', "");
    Expect(1, 12443, '\p{^Is_Ccc=kanavoicing}', "");
    Expect(1, 12443, '\P{Is_Ccc=kanavoicing}', "");
    Expect(0, 12443, '\P{^Is_Ccc=kanavoicing}', "");
    Expect(1, 12442, '\p{Is_Ccc:		-Kana_Voicing}', "");
    Expect(0, 12442, '\p{^Is_Ccc:		-Kana_Voicing}', "");
    Expect(0, 12442, '\P{Is_Ccc:		-Kana_Voicing}', "");
    Expect(1, 12442, '\P{^Is_Ccc:		-Kana_Voicing}', "");
    Expect(0, 12443, '\p{Is_Ccc:		-Kana_Voicing}', "");
    Expect(1, 12443, '\p{^Is_Ccc:		-Kana_Voicing}', "");
    Expect(1, 12443, '\P{Is_Ccc:		-Kana_Voicing}', "");
    Expect(0, 12443, '\P{^Is_Ccc:		-Kana_Voicing}', "");
    Error('\p{Canonical_Combining_Class=- Left:=}');
    Error('\P{Canonical_Combining_Class=- Left:=}');
    Expect(1, 12335, '\p{Canonical_Combining_Class=:\ALeft\z:}', "");;
    Expect(0, 12336, '\p{Canonical_Combining_Class=:\ALeft\z:}', "");;
    Expect(1, 12335, '\p{Canonical_Combining_Class=left}', "");
    Expect(0, 12335, '\p{^Canonical_Combining_Class=left}', "");
    Expect(0, 12335, '\P{Canonical_Combining_Class=left}', "");
    Expect(1, 12335, '\P{^Canonical_Combining_Class=left}', "");
    Expect(0, 12336, '\p{Canonical_Combining_Class=left}', "");
    Expect(1, 12336, '\p{^Canonical_Combining_Class=left}', "");
    Expect(1, 12336, '\P{Canonical_Combining_Class=left}', "");
    Expect(0, 12336, '\P{^Canonical_Combining_Class=left}', "");
    Expect(1, 12335, '\p{Canonical_Combining_Class=:\Aleft\z:}', "");;
    Expect(0, 12336, '\p{Canonical_Combining_Class=:\Aleft\z:}', "");;
    Expect(1, 12335, '\p{Canonical_Combining_Class=	left}', "");
    Expect(0, 12335, '\p{^Canonical_Combining_Class=	left}', "");
    Expect(0, 12335, '\P{Canonical_Combining_Class=	left}', "");
    Expect(1, 12335, '\P{^Canonical_Combining_Class=	left}', "");
    Expect(0, 12336, '\p{Canonical_Combining_Class=	left}', "");
    Expect(1, 12336, '\p{^Canonical_Combining_Class=	left}', "");
    Expect(1, 12336, '\P{Canonical_Combining_Class=	left}', "");
    Expect(0, 12336, '\P{^Canonical_Combining_Class=	left}', "");
    Error('\p{Ccc=-l:=}');
    Error('\P{Ccc=-l:=}');
    Expect(1, 12335, '\p{Ccc=:\AL\z:}', "");;
    Expect(0, 12336, '\p{Ccc=:\AL\z:}', "");;
    Expect(1, 12335, '\p{Ccc=l}', "");
    Expect(0, 12335, '\p{^Ccc=l}', "");
    Expect(0, 12335, '\P{Ccc=l}', "");
    Expect(1, 12335, '\P{^Ccc=l}', "");
    Expect(0, 12336, '\p{Ccc=l}', "");
    Expect(1, 12336, '\p{^Ccc=l}', "");
    Expect(1, 12336, '\P{Ccc=l}', "");
    Expect(0, 12336, '\P{^Ccc=l}', "");
    Expect(1, 12335, '\p{Ccc=:\Al\z:}', "");;
    Expect(0, 12336, '\p{Ccc=:\Al\z:}', "");;
    Expect(1, 12335, '\p{Ccc=L}', "");
    Expect(0, 12335, '\p{^Ccc=L}', "");
    Expect(0, 12335, '\P{Ccc=L}', "");
    Expect(1, 12335, '\P{^Ccc=L}', "");
    Expect(0, 12336, '\p{Ccc=L}', "");
    Expect(1, 12336, '\p{^Ccc=L}', "");
    Expect(1, 12336, '\P{Ccc=L}', "");
    Expect(0, 12336, '\P{^Ccc=L}', "");
    Error('\p{Is_Canonical_Combining_Class=:=_	+022_4}');
    Error('\P{Is_Canonical_Combining_Class=:=_	+022_4}');
    Expect(1, 12335, '\p{Is_Canonical_Combining_Class=+0_0_0_0_0_0_000224}', "");
    Expect(0, 12335, '\p{^Is_Canonical_Combining_Class=+0_0_0_0_0_0_000224}', "");
    Expect(0, 12335, '\P{Is_Canonical_Combining_Class=+0_0_0_0_0_0_000224}', "");
    Expect(1, 12335, '\P{^Is_Canonical_Combining_Class=+0_0_0_0_0_0_000224}', "");
    Expect(0, 12336, '\p{Is_Canonical_Combining_Class=+0_0_0_0_0_0_000224}', "");
    Expect(1, 12336, '\p{^Is_Canonical_Combining_Class=+0_0_0_0_0_0_000224}', "");
    Expect(1, 12336, '\P{Is_Canonical_Combining_Class=+0_0_0_0_0_0_000224}', "");
    Expect(0, 12336, '\P{^Is_Canonical_Combining_Class=+0_0_0_0_0_0_000224}', "");
    Error('\p{Is_Ccc= :=Left}');
    Error('\P{Is_Ccc= :=Left}');
    Expect(1, 12335, '\p{Is_Ccc=left}', "");
    Expect(0, 12335, '\p{^Is_Ccc=left}', "");
    Expect(0, 12335, '\P{Is_Ccc=left}', "");
    Expect(1, 12335, '\P{^Is_Ccc=left}', "");
    Expect(0, 12336, '\p{Is_Ccc=left}', "");
    Expect(1, 12336, '\p{^Is_Ccc=left}', "");
    Expect(1, 12336, '\P{Is_Ccc=left}', "");
    Expect(0, 12336, '\P{^Is_Ccc=left}', "");
    Expect(1, 12335, '\p{Is_Ccc=--Left}', "");
    Expect(0, 12335, '\p{^Is_Ccc=--Left}', "");
    Expect(0, 12335, '\P{Is_Ccc=--Left}', "");
    Expect(1, 12335, '\P{^Is_Ccc=--Left}', "");
    Expect(0, 12336, '\p{Is_Ccc=--Left}', "");
    Expect(1, 12336, '\p{^Is_Ccc=--Left}', "");
    Expect(1, 12336, '\P{Is_Ccc=--Left}', "");
    Expect(0, 12336, '\P{^Is_Ccc=--Left}', "");
    Error('\p{Canonical_Combining_Class=:=		NUKTA}');
    Error('\P{Canonical_Combining_Class=:=		NUKTA}');
    Expect(1, 125258, '\p{Canonical_Combining_Class=:\ANukta\z:}', "");;
    Expect(0, 125259, '\p{Canonical_Combining_Class=:\ANukta\z:}', "");;
    Expect(1, 125258, '\p{Canonical_Combining_Class=nukta}', "");
    Expect(0, 125258, '\p{^Canonical_Combining_Class=nukta}', "");
    Expect(0, 125258, '\P{Canonical_Combining_Class=nukta}', "");
    Expect(1, 125258, '\P{^Canonical_Combining_Class=nukta}', "");
    Expect(0, 125259, '\p{Canonical_Combining_Class=nukta}', "");
    Expect(1, 125259, '\p{^Canonical_Combining_Class=nukta}', "");
    Expect(1, 125259, '\P{Canonical_Combining_Class=nukta}', "");
    Expect(0, 125259, '\P{^Canonical_Combining_Class=nukta}', "");
    Expect(1, 125258, '\p{Canonical_Combining_Class=:\Anukta\z:}', "");;
    Expect(0, 125259, '\p{Canonical_Combining_Class=:\Anukta\z:}', "");;
    Expect(1, 125258, '\p{Canonical_Combining_Class=Nukta}', "");
    Expect(0, 125258, '\p{^Canonical_Combining_Class=Nukta}', "");
    Expect(0, 125258, '\P{Canonical_Combining_Class=Nukta}', "");
    Expect(1, 125258, '\P{^Canonical_Combining_Class=Nukta}', "");
    Expect(0, 125259, '\p{Canonical_Combining_Class=Nukta}', "");
    Expect(1, 125259, '\p{^Canonical_Combining_Class=Nukta}', "");
    Expect(1, 125259, '\P{Canonical_Combining_Class=Nukta}', "");
    Expect(0, 125259, '\P{^Canonical_Combining_Class=Nukta}', "");
    Error('\p{Ccc=:= NK}');
    Error('\P{Ccc=:= NK}');
    Expect(1, 125258, '\p{Ccc=:\ANK\z:}', "");;
    Expect(0, 125259, '\p{Ccc=:\ANK\z:}', "");;
    Expect(1, 125258, '\p{Ccc=nk}', "");
    Expect(0, 125258, '\p{^Ccc=nk}', "");
    Expect(0, 125258, '\P{Ccc=nk}', "");
    Expect(1, 125258, '\P{^Ccc=nk}', "");
    Expect(0, 125259, '\p{Ccc=nk}', "");
    Expect(1, 125259, '\p{^Ccc=nk}', "");
    Expect(1, 125259, '\P{Ccc=nk}', "");
    Expect(0, 125259, '\P{^Ccc=nk}', "");
    Expect(1, 125258, '\p{Ccc=:\Ank\z:}', "");;
    Expect(0, 125259, '\p{Ccc=:\Ank\z:}', "");;
    Expect(1, 125258, '\p{Ccc=_ NK}', "");
    Expect(0, 125258, '\p{^Ccc=_ NK}', "");
    Expect(0, 125258, '\P{Ccc=_ NK}', "");
    Expect(1, 125258, '\P{^Ccc=_ NK}', "");
    Expect(0, 125259, '\p{Ccc=_ NK}', "");
    Expect(1, 125259, '\p{^Ccc=_ NK}', "");
    Expect(1, 125259, '\P{Ccc=_ NK}', "");
    Expect(0, 125259, '\P{^Ccc=_ NK}', "");
    Error('\p{Is_Canonical_Combining_Class=/a/00_7}');
    Error('\P{Is_Canonical_Combining_Class=/a/00_7}');
    Expect(1, 125258, '\p{Is_Canonical_Combining_Class=00_00_7}', "");
    Expect(0, 125258, '\p{^Is_Canonical_Combining_Class=00_00_7}', "");
    Expect(0, 125258, '\P{Is_Canonical_Combining_Class=00_00_7}', "");
    Expect(1, 125258, '\P{^Is_Canonical_Combining_Class=00_00_7}', "");
    Expect(0, 125259, '\p{Is_Canonical_Combining_Class=00_00_7}', "");
    Expect(1, 125259, '\p{^Is_Canonical_Combining_Class=00_00_7}', "");
    Expect(1, 125259, '\P{Is_Canonical_Combining_Class=00_00_7}', "");
    Expect(0, 125259, '\P{^Is_Canonical_Combining_Class=00_00_7}', "");
    Error('\p{Is_Ccc: /a/ _Nukta}');
    Error('\P{Is_Ccc: /a/ _Nukta}');
    Expect(1, 125258, '\p{Is_Ccc=nukta}', "");
    Expect(0, 125258, '\p{^Is_Ccc=nukta}', "");
    Expect(0, 125258, '\P{Is_Ccc=nukta}', "");
    Expect(1, 125258, '\P{^Is_Ccc=nukta}', "");
    Expect(0, 125259, '\p{Is_Ccc=nukta}', "");
    Expect(1, 125259, '\p{^Is_Ccc=nukta}', "");
    Expect(1, 125259, '\P{Is_Ccc=nukta}', "");
    Expect(0, 125259, '\P{^Is_Ccc=nukta}', "");
    Expect(1, 125258, '\p{Is_Ccc= 	Nukta}', "");
    Expect(0, 125258, '\p{^Is_Ccc= 	Nukta}', "");
    Expect(0, 125258, '\P{Is_Ccc= 	Nukta}', "");
    Expect(1, 125258, '\P{^Is_Ccc= 	Nukta}', "");
    Expect(0, 125259, '\p{Is_Ccc= 	Nukta}', "");
    Expect(1, 125259, '\p{^Is_Ccc= 	Nukta}', "");
    Expect(1, 125259, '\P{Is_Ccc= 	Nukta}', "");
    Expect(0, 125259, '\P{^Is_Ccc= 	Nukta}', "");
    Error('\p{Canonical_Combining_Class=/a/  Not_Reordered}');
    Error('\P{Canonical_Combining_Class=/a/  Not_Reordered}');
    Expect(1, 125259, '\p{Canonical_Combining_Class=:\ANot_Reordered\z:}', "");;
    Expect(0, 125258, '\p{Canonical_Combining_Class=:\ANot_Reordered\z:}', "");;
    Expect(1, 125259, '\p{Canonical_Combining_Class: notreordered}', "");
    Expect(0, 125259, '\p{^Canonical_Combining_Class: notreordered}', "");
    Expect(0, 125259, '\P{Canonical_Combining_Class: notreordered}', "");
    Expect(1, 125259, '\P{^Canonical_Combining_Class: notreordered}', "");
    Expect(0, 125258, '\p{Canonical_Combining_Class: notreordered}', "");
    Expect(1, 125258, '\p{^Canonical_Combining_Class: notreordered}', "");
    Expect(1, 125258, '\P{Canonical_Combining_Class: notreordered}', "");
    Expect(0, 125258, '\P{^Canonical_Combining_Class: notreordered}', "");
    Expect(1, 125259, '\p{Canonical_Combining_Class=:\Anotreordered\z:}', "");;
    Expect(0, 125258, '\p{Canonical_Combining_Class=:\Anotreordered\z:}', "");;
    Expect(1, 125259, '\p{Canonical_Combining_Class=-	NOT_reordered}', "");
    Expect(0, 125259, '\p{^Canonical_Combining_Class=-	NOT_reordered}', "");
    Expect(0, 125259, '\P{Canonical_Combining_Class=-	NOT_reordered}', "");
    Expect(1, 125259, '\P{^Canonical_Combining_Class=-	NOT_reordered}', "");
    Expect(0, 125258, '\p{Canonical_Combining_Class=-	NOT_reordered}', "");
    Expect(1, 125258, '\p{^Canonical_Combining_Class=-	NOT_reordered}', "");
    Expect(1, 125258, '\P{Canonical_Combining_Class=-	NOT_reordered}', "");
    Expect(0, 125258, '\P{^Canonical_Combining_Class=-	NOT_reordered}', "");
    Error('\p{Ccc=:=		NR}');
    Error('\P{Ccc=:=		NR}');
    Expect(1, 125259, '\p{Ccc=:\ANR\z:}', "");;
    Expect(0, 125258, '\p{Ccc=:\ANR\z:}', "");;
    Expect(1, 125259, '\p{Ccc=nr}', "");
    Expect(0, 125259, '\p{^Ccc=nr}', "");
    Expect(0, 125259, '\P{Ccc=nr}', "");
    Expect(1, 125259, '\P{^Ccc=nr}', "");
    Expect(0, 125258, '\p{Ccc=nr}', "");
    Expect(1, 125258, '\p{^Ccc=nr}', "");
    Expect(1, 125258, '\P{Ccc=nr}', "");
    Expect(0, 125258, '\P{^Ccc=nr}', "");
    Expect(1, 125259, '\p{Ccc=:\Anr\z:}', "");;
    Expect(0, 125258, '\p{Ccc=:\Anr\z:}', "");;
    Expect(1, 125259, '\p{Ccc:--nr}', "");
    Expect(0, 125259, '\p{^Ccc:--nr}', "");
    Expect(0, 125259, '\P{Ccc:--nr}', "");
    Expect(1, 125259, '\P{^Ccc:--nr}', "");
    Expect(0, 125258, '\p{Ccc:--nr}', "");
    Expect(1, 125258, '\p{^Ccc:--nr}', "");
    Expect(1, 125258, '\P{Ccc:--nr}', "");
    Expect(0, 125258, '\P{^Ccc:--nr}', "");
    Error('\p{Is_Canonical_Combining_Class=-/a/0000000}');
    Error('\P{Is_Canonical_Combining_Class=-/a/0000000}');
    Expect(1, 125259, '\p{Is_Canonical_Combining_Class=+0_0_0_0_0_00}', "");
    Expect(0, 125259, '\p{^Is_Canonical_Combining_Class=+0_0_0_0_0_00}', "");
    Expect(0, 125259, '\P{Is_Canonical_Combining_Class=+0_0_0_0_0_00}', "");
    Expect(1, 125259, '\P{^Is_Canonical_Combining_Class=+0_0_0_0_0_00}', "");
    Expect(0, 125258, '\p{Is_Canonical_Combining_Class=+0_0_0_0_0_00}', "");
    Expect(1, 125258, '\p{^Is_Canonical_Combining_Class=+0_0_0_0_0_00}', "");
    Expect(1, 125258, '\P{Is_Canonical_Combining_Class=+0_0_0_0_0_00}', "");
    Expect(0, 125258, '\P{^Is_Canonical_Combining_Class=+0_0_0_0_0_00}', "");
    Error('\p{Is_Ccc=:=-NOT_REORDERED}');
    Error('\P{Is_Ccc=:=-NOT_REORDERED}');
    Expect(1, 125259, '\p{Is_Ccc=notreordered}', "");
    Expect(0, 125259, '\p{^Is_Ccc=notreordered}', "");
    Expect(0, 125259, '\P{Is_Ccc=notreordered}', "");
    Expect(1, 125259, '\P{^Is_Ccc=notreordered}', "");
    Expect(0, 125258, '\p{Is_Ccc=notreordered}', "");
    Expect(1, 125258, '\p{^Is_Ccc=notreordered}', "");
    Expect(1, 125258, '\P{Is_Ccc=notreordered}', "");
    Expect(0, 125258, '\P{^Is_Ccc=notreordered}', "");
    Expect(1, 125259, '\p{Is_Ccc= 	Not_Reordered}', "");
    Expect(0, 125259, '\p{^Is_Ccc= 	Not_Reordered}', "");
    Expect(0, 125259, '\P{Is_Ccc= 	Not_Reordered}', "");
    Expect(1, 125259, '\P{^Is_Ccc= 	Not_Reordered}', "");
    Expect(0, 125258, '\p{Is_Ccc= 	Not_Reordered}', "");
    Expect(1, 125258, '\p{^Is_Ccc= 	Not_Reordered}', "");
    Expect(1, 125258, '\P{Is_Ccc= 	Not_Reordered}', "");
    Expect(0, 125258, '\P{^Is_Ccc= 	Not_Reordered}', "");
    Error('\p{Canonical_Combining_Class=-/a/Overlay}');
    Error('\P{Canonical_Combining_Class=-/a/Overlay}');
    Expect(1, 119145, '\p{Canonical_Combining_Class=:\AOverlay\z:}', "");;
    Expect(0, 119146, '\p{Canonical_Combining_Class=:\AOverlay\z:}', "");;
    Expect(1, 119145, '\p{Canonical_Combining_Class:	overlay}', "");
    Expect(0, 119145, '\p{^Canonical_Combining_Class:	overlay}', "");
    Expect(0, 119145, '\P{Canonical_Combining_Class:	overlay}', "");
    Expect(1, 119145, '\P{^Canonical_Combining_Class:	overlay}', "");
    Expect(0, 119146, '\p{Canonical_Combining_Class:	overlay}', "");
    Expect(1, 119146, '\p{^Canonical_Combining_Class:	overlay}', "");
    Expect(1, 119146, '\P{Canonical_Combining_Class:	overlay}', "");
    Expect(0, 119146, '\P{^Canonical_Combining_Class:	overlay}', "");
    Expect(1, 119145, '\p{Canonical_Combining_Class=:\Aoverlay\z:}', "");;
    Expect(0, 119146, '\p{Canonical_Combining_Class=:\Aoverlay\z:}', "");;
    Expect(1, 119145, '\p{Canonical_Combining_Class=	Overlay}', "");
    Expect(0, 119145, '\p{^Canonical_Combining_Class=	Overlay}', "");
    Expect(0, 119145, '\P{Canonical_Combining_Class=	Overlay}', "");
    Expect(1, 119145, '\P{^Canonical_Combining_Class=	Overlay}', "");
    Expect(0, 119146, '\p{Canonical_Combining_Class=	Overlay}', "");
    Expect(1, 119146, '\p{^Canonical_Combining_Class=	Overlay}', "");
    Expect(1, 119146, '\P{Canonical_Combining_Class=	Overlay}', "");
    Expect(0, 119146, '\P{^Canonical_Combining_Class=	Overlay}', "");
    Error('\p{Ccc=_:=OV}');
    Error('\P{Ccc=_:=OV}');
    Expect(1, 119145, '\p{Ccc=:\AOV\z:}', "");;
    Expect(0, 119146, '\p{Ccc=:\AOV\z:}', "");;
    Expect(1, 119145, '\p{Ccc=ov}', "");
    Expect(0, 119145, '\p{^Ccc=ov}', "");
    Expect(0, 119145, '\P{Ccc=ov}', "");
    Expect(1, 119145, '\P{^Ccc=ov}', "");
    Expect(0, 119146, '\p{Ccc=ov}', "");
    Expect(1, 119146, '\p{^Ccc=ov}', "");
    Expect(1, 119146, '\P{Ccc=ov}', "");
    Expect(0, 119146, '\P{^Ccc=ov}', "");
    Expect(1, 119145, '\p{Ccc=:\Aov\z:}', "");;
    Expect(0, 119146, '\p{Ccc=:\Aov\z:}', "");;
    Expect(1, 119145, '\p{Ccc=_-OV}', "");
    Expect(0, 119145, '\p{^Ccc=_-OV}', "");
    Expect(0, 119145, '\P{Ccc=_-OV}', "");
    Expect(1, 119145, '\P{^Ccc=_-OV}', "");
    Expect(0, 119146, '\p{Ccc=_-OV}', "");
    Expect(1, 119146, '\p{^Ccc=_-OV}', "");
    Expect(1, 119146, '\P{Ccc=_-OV}', "");
    Expect(0, 119146, '\P{^Ccc=_-OV}', "");
    Error('\p{Is_Canonical_Combining_Class= _0_0_0_0_0_01/a/}');
    Error('\P{Is_Canonical_Combining_Class= _0_0_0_0_0_01/a/}');
    Expect(1, 119145, '\p{Is_Canonical_Combining_Class=00_00_1}', "");
    Expect(0, 119145, '\p{^Is_Canonical_Combining_Class=00_00_1}', "");
    Expect(0, 119145, '\P{Is_Canonical_Combining_Class=00_00_1}', "");
    Expect(1, 119145, '\P{^Is_Canonical_Combining_Class=00_00_1}', "");
    Expect(0, 119146, '\p{Is_Canonical_Combining_Class=00_00_1}', "");
    Expect(1, 119146, '\p{^Is_Canonical_Combining_Class=00_00_1}', "");
    Expect(1, 119146, '\P{Is_Canonical_Combining_Class=00_00_1}', "");
    Expect(0, 119146, '\P{^Is_Canonical_Combining_Class=00_00_1}', "");
    Error('\p{Is_Ccc= /a/Overlay}');
    Error('\P{Is_Ccc= /a/Overlay}');
    Expect(1, 119145, '\p{Is_Ccc=overlay}', "");
    Expect(0, 119145, '\p{^Is_Ccc=overlay}', "");
    Expect(0, 119145, '\P{Is_Ccc=overlay}', "");
    Expect(1, 119145, '\P{^Is_Ccc=overlay}', "");
    Expect(0, 119146, '\p{Is_Ccc=overlay}', "");
    Expect(1, 119146, '\p{^Is_Ccc=overlay}', "");
    Expect(1, 119146, '\P{Is_Ccc=overlay}', "");
    Expect(0, 119146, '\P{^Is_Ccc=overlay}', "");
    Expect(1, 119145, '\p{Is_Ccc=-	overlay}', "");
    Expect(0, 119145, '\p{^Is_Ccc=-	overlay}', "");
    Expect(0, 119145, '\P{Is_Ccc=-	overlay}', "");
    Expect(1, 119145, '\P{^Is_Ccc=-	overlay}', "");
    Expect(0, 119146, '\p{Is_Ccc=-	overlay}', "");
    Expect(1, 119146, '\p{^Is_Ccc=-	overlay}', "");
    Expect(1, 119146, '\P{Is_Ccc=-	overlay}', "");
    Expect(0, 119146, '\P{^Is_Ccc=-	overlay}', "");
    Error('\p{Canonical_Combining_Class=	:=Right}');
    Error('\P{Canonical_Combining_Class=	:=Right}');
    Expect(1, 119149, '\p{Canonical_Combining_Class=:\ARight\z:}', "");;
    Expect(0, 119150, '\p{Canonical_Combining_Class=:\ARight\z:}', "");;
    Expect(1, 119149, '\p{Canonical_Combining_Class=right}', "");
    Expect(0, 119149, '\p{^Canonical_Combining_Class=right}', "");
    Expect(0, 119149, '\P{Canonical_Combining_Class=right}', "");
    Expect(1, 119149, '\P{^Canonical_Combining_Class=right}', "");
    Expect(0, 119150, '\p{Canonical_Combining_Class=right}', "");
    Expect(1, 119150, '\p{^Canonical_Combining_Class=right}', "");
    Expect(1, 119150, '\P{Canonical_Combining_Class=right}', "");
    Expect(0, 119150, '\P{^Canonical_Combining_Class=right}', "");
    Expect(1, 119149, '\p{Canonical_Combining_Class=:\Aright\z:}', "");;
    Expect(0, 119150, '\p{Canonical_Combining_Class=:\Aright\z:}', "");;
    Expect(1, 119149, '\p{Canonical_Combining_Class=-_right}', "");
    Expect(0, 119149, '\p{^Canonical_Combining_Class=-_right}', "");
    Expect(0, 119149, '\P{Canonical_Combining_Class=-_right}', "");
    Expect(1, 119149, '\P{^Canonical_Combining_Class=-_right}', "");
    Expect(0, 119150, '\p{Canonical_Combining_Class=-_right}', "");
    Expect(1, 119150, '\p{^Canonical_Combining_Class=-_right}', "");
    Expect(1, 119150, '\P{Canonical_Combining_Class=-_right}', "");
    Expect(0, 119150, '\P{^Canonical_Combining_Class=-_right}', "");
    Error('\p{Ccc=/a/__R}');
    Error('\P{Ccc=/a/__R}');
    Expect(1, 119149, '\p{Ccc=:\AR\z:}', "");;
    Expect(0, 119150, '\p{Ccc=:\AR\z:}', "");;
    Expect(1, 119149, '\p{Ccc=r}', "");
    Expect(0, 119149, '\p{^Ccc=r}', "");
    Expect(0, 119149, '\P{Ccc=r}', "");
    Expect(1, 119149, '\P{^Ccc=r}', "");
    Expect(0, 119150, '\p{Ccc=r}', "");
    Expect(1, 119150, '\p{^Ccc=r}', "");
    Expect(1, 119150, '\P{Ccc=r}', "");
    Expect(0, 119150, '\P{^Ccc=r}', "");
    Expect(1, 119149, '\p{Ccc=:\Ar\z:}', "");;
    Expect(0, 119150, '\p{Ccc=:\Ar\z:}', "");;
    Expect(1, 119149, '\p{Ccc=_-R}', "");
    Expect(0, 119149, '\p{^Ccc=_-R}', "");
    Expect(0, 119149, '\P{Ccc=_-R}', "");
    Expect(1, 119149, '\P{^Ccc=_-R}', "");
    Expect(0, 119150, '\p{Ccc=_-R}', "");
    Expect(1, 119150, '\p{^Ccc=_-R}', "");
    Expect(1, 119150, '\P{Ccc=_-R}', "");
    Expect(0, 119150, '\P{^Ccc=_-R}', "");
    Error('\p{Is_Canonical_Combining_Class=_:=+000022_6}');
    Error('\P{Is_Canonical_Combining_Class=_:=+000022_6}');
    Expect(1, 119149, '\p{Is_Canonical_Combining_Class=+00226}', "");
    Expect(0, 119149, '\p{^Is_Canonical_Combining_Class=+00226}', "");
    Expect(0, 119149, '\P{Is_Canonical_Combining_Class=+00226}', "");
    Expect(1, 119149, '\P{^Is_Canonical_Combining_Class=+00226}', "");
    Expect(0, 119150, '\p{Is_Canonical_Combining_Class=+00226}', "");
    Expect(1, 119150, '\p{^Is_Canonical_Combining_Class=+00226}', "");
    Expect(1, 119150, '\P{Is_Canonical_Combining_Class=+00226}', "");
    Expect(0, 119150, '\P{^Is_Canonical_Combining_Class=+00226}', "");
    Error('\p{Is_Ccc:	/a/Right}');
    Error('\P{Is_Ccc:	/a/Right}');
    Expect(1, 119149, '\p{Is_Ccc=right}', "");
    Expect(0, 119149, '\p{^Is_Ccc=right}', "");
    Expect(0, 119149, '\P{Is_Ccc=right}', "");
    Expect(1, 119149, '\P{^Is_Ccc=right}', "");
    Expect(0, 119150, '\p{Is_Ccc=right}', "");
    Expect(1, 119150, '\p{^Is_Ccc=right}', "");
    Expect(1, 119150, '\P{Is_Ccc=right}', "");
    Expect(0, 119150, '\P{^Is_Ccc=right}', "");
    Expect(1, 119149, '\p{Is_Ccc=- Right}', "");
    Expect(0, 119149, '\p{^Is_Ccc=- Right}', "");
    Expect(0, 119149, '\P{Is_Ccc=- Right}', "");
    Expect(1, 119149, '\P{^Is_Ccc=- Right}', "");
    Expect(0, 119150, '\p{Is_Ccc=- Right}', "");
    Expect(1, 119150, '\p{^Is_Ccc=- Right}', "");
    Expect(1, 119150, '\P{Is_Ccc=- Right}', "");
    Expect(0, 119150, '\P{^Is_Ccc=- Right}', "");
    Error('\p{Canonical_Combining_Class=_virama/a/}');
    Error('\P{Canonical_Combining_Class=_virama/a/}');
    Expect(1, 73111, '\p{Canonical_Combining_Class=:\AVirama\z:}', "");;
    Expect(0, 73112, '\p{Canonical_Combining_Class=:\AVirama\z:}', "");;
    Expect(1, 73111, '\p{Canonical_Combining_Class=virama}', "");
    Expect(0, 73111, '\p{^Canonical_Combining_Class=virama}', "");
    Expect(0, 73111, '\P{Canonical_Combining_Class=virama}', "");
    Expect(1, 73111, '\P{^Canonical_Combining_Class=virama}', "");
    Expect(0, 73112, '\p{Canonical_Combining_Class=virama}', "");
    Expect(1, 73112, '\p{^Canonical_Combining_Class=virama}', "");
    Expect(1, 73112, '\P{Canonical_Combining_Class=virama}', "");
    Expect(0, 73112, '\P{^Canonical_Combining_Class=virama}', "");
    Expect(1, 73111, '\p{Canonical_Combining_Class=:\Avirama\z:}', "");;
    Expect(0, 73112, '\p{Canonical_Combining_Class=:\Avirama\z:}', "");;
    Expect(1, 73111, '\p{Canonical_Combining_Class=_ Virama}', "");
    Expect(0, 73111, '\p{^Canonical_Combining_Class=_ Virama}', "");
    Expect(0, 73111, '\P{Canonical_Combining_Class=_ Virama}', "");
    Expect(1, 73111, '\P{^Canonical_Combining_Class=_ Virama}', "");
    Expect(0, 73112, '\p{Canonical_Combining_Class=_ Virama}', "");
    Expect(1, 73112, '\p{^Canonical_Combining_Class=_ Virama}', "");
    Expect(1, 73112, '\P{Canonical_Combining_Class=_ Virama}', "");
    Expect(0, 73112, '\P{^Canonical_Combining_Class=_ Virama}', "");
    Error('\p{Ccc: -VR/a/}');
    Error('\P{Ccc: -VR/a/}');
    Expect(1, 73111, '\p{Ccc=:\AVR\z:}', "");;
    Expect(0, 73112, '\p{Ccc=:\AVR\z:}', "");;
    Expect(1, 73111, '\p{Ccc=vr}', "");
    Expect(0, 73111, '\p{^Ccc=vr}', "");
    Expect(0, 73111, '\P{Ccc=vr}', "");
    Expect(1, 73111, '\P{^Ccc=vr}', "");
    Expect(0, 73112, '\p{Ccc=vr}', "");
    Expect(1, 73112, '\p{^Ccc=vr}', "");
    Expect(1, 73112, '\P{Ccc=vr}', "");
    Expect(0, 73112, '\P{^Ccc=vr}', "");
    Expect(1, 73111, '\p{Ccc=:\Avr\z:}', "");;
    Expect(0, 73112, '\p{Ccc=:\Avr\z:}', "");;
    Expect(1, 73111, '\p{Ccc= -VR}', "");
    Expect(0, 73111, '\p{^Ccc= -VR}', "");
    Expect(0, 73111, '\P{Ccc= -VR}', "");
    Expect(1, 73111, '\P{^Ccc= -VR}', "");
    Expect(0, 73112, '\p{Ccc= -VR}', "");
    Expect(1, 73112, '\p{^Ccc= -VR}', "");
    Expect(1, 73112, '\P{Ccc= -VR}', "");
    Expect(0, 73112, '\P{^Ccc= -VR}', "");
    Error('\p{Is_Canonical_Combining_Class:  /a/0_0_0_0_0_00009}');
    Error('\P{Is_Canonical_Combining_Class:  /a/0_0_0_0_0_00009}');
    Expect(1, 73111, '\p{Is_Canonical_Combining_Class=+00_9}', "");
    Expect(0, 73111, '\p{^Is_Canonical_Combining_Class=+00_9}', "");
    Expect(0, 73111, '\P{Is_Canonical_Combining_Class=+00_9}', "");
    Expect(1, 73111, '\P{^Is_Canonical_Combining_Class=+00_9}', "");
    Expect(0, 73112, '\p{Is_Canonical_Combining_Class=+00_9}', "");
    Expect(1, 73112, '\p{^Is_Canonical_Combining_Class=+00_9}', "");
    Expect(1, 73112, '\P{Is_Canonical_Combining_Class=+00_9}', "");
    Expect(0, 73112, '\P{^Is_Canonical_Combining_Class=+00_9}', "");
    Error('\p{Is_Ccc= Virama/a/}');
    Error('\P{Is_Ccc= Virama/a/}');
    Expect(1, 73111, '\p{Is_Ccc=virama}', "");
    Expect(0, 73111, '\p{^Is_Ccc=virama}', "");
    Expect(0, 73111, '\P{Is_Ccc=virama}', "");
    Expect(1, 73111, '\P{^Is_Ccc=virama}', "");
    Expect(0, 73112, '\p{Is_Ccc=virama}', "");
    Expect(1, 73112, '\p{^Is_Ccc=virama}', "");
    Expect(1, 73112, '\P{Is_Ccc=virama}', "");
    Expect(0, 73112, '\P{^Is_Ccc=virama}', "");
    Expect(1, 73111, '\p{Is_Ccc=--VIRAMA}', "");
    Expect(0, 73111, '\p{^Is_Ccc=--VIRAMA}', "");
    Expect(0, 73111, '\P{Is_Ccc=--VIRAMA}', "");
    Expect(1, 73111, '\P{^Is_Ccc=--VIRAMA}', "");
    Expect(0, 73112, '\p{Is_Ccc=--VIRAMA}', "");
    Expect(1, 73112, '\p{^Is_Ccc=--VIRAMA}', "");
    Expect(1, 73112, '\P{Is_Ccc=--VIRAMA}', "");
    Expect(0, 73112, '\P{^Is_Ccc=--VIRAMA}', "");
    Error('\p{Composition_Exclusion=/a/	-NO}');
    Error('\P{Composition_Exclusion=/a/	-NO}');
    Expect(1, 119233, '\p{Composition_Exclusion=:\ANo\z:}', "");;
    Expect(0, 119232, '\p{Composition_Exclusion=:\ANo\z:}', "");;
    Expect(1, 119233, '\p{Composition_Exclusion=no}', "");
    Expect(0, 119233, '\p{^Composition_Exclusion=no}', "");
    Expect(0, 119233, '\P{Composition_Exclusion=no}', "");
    Expect(1, 119233, '\P{^Composition_Exclusion=no}', "");
    Expect(0, 119232, '\p{Composition_Exclusion=no}', "");
    Expect(1, 119232, '\p{^Composition_Exclusion=no}', "");
    Expect(1, 119232, '\P{Composition_Exclusion=no}', "");
    Expect(0, 119232, '\P{^Composition_Exclusion=no}', "");
    Expect(1, 119233, '\p{Composition_Exclusion=:\Ano\z:}', "");;
    Expect(0, 119232, '\p{Composition_Exclusion=:\Ano\z:}', "");;
    Expect(1, 119233, '\p{Composition_Exclusion:   -_no}', "");
    Expect(0, 119233, '\p{^Composition_Exclusion:   -_no}', "");
    Expect(0, 119233, '\P{Composition_Exclusion:   -_no}', "");
    Expect(1, 119233, '\P{^Composition_Exclusion:   -_no}', "");
    Expect(0, 119232, '\p{Composition_Exclusion:   -_no}', "");
    Expect(1, 119232, '\p{^Composition_Exclusion:   -_no}', "");
    Expect(1, 119232, '\P{Composition_Exclusion:   -_no}', "");
    Expect(0, 119232, '\P{^Composition_Exclusion:   -_no}', "");
    Error('\p{CE: _/a/N}');
    Error('\P{CE: _/a/N}');
    Expect(1, 119233, '\p{CE=:\AN\z:}', "");;
    Expect(0, 119232, '\p{CE=:\AN\z:}', "");;
    Expect(1, 119233, '\p{CE=n}', "");
    Expect(0, 119233, '\p{^CE=n}', "");
    Expect(0, 119233, '\P{CE=n}', "");
    Expect(1, 119233, '\P{^CE=n}', "");
    Expect(0, 119232, '\p{CE=n}', "");
    Expect(1, 119232, '\p{^CE=n}', "");
    Expect(1, 119232, '\P{CE=n}', "");
    Expect(0, 119232, '\P{^CE=n}', "");
    Expect(1, 119233, '\p{CE=:\An\z:}', "");;
    Expect(0, 119232, '\p{CE=:\An\z:}', "");;
    Expect(1, 119233, '\p{CE=__n}', "");
    Expect(0, 119233, '\p{^CE=__n}', "");
    Expect(0, 119233, '\P{CE=__n}', "");
    Expect(1, 119233, '\P{^CE=__n}', "");
    Expect(0, 119232, '\p{CE=__n}', "");
    Expect(1, 119232, '\p{^CE=__n}', "");
    Expect(1, 119232, '\P{CE=__n}', "");
    Expect(0, 119232, '\P{^CE=__n}', "");
    Error('\p{Is_Composition_Exclusion=:=	F}');
    Error('\P{Is_Composition_Exclusion=:=	F}');
    Expect(1, 119233, '\p{Is_Composition_Exclusion=f}', "");
    Expect(0, 119233, '\p{^Is_Composition_Exclusion=f}', "");
    Expect(0, 119233, '\P{Is_Composition_Exclusion=f}', "");
    Expect(1, 119233, '\P{^Is_Composition_Exclusion=f}', "");
    Expect(0, 119232, '\p{Is_Composition_Exclusion=f}', "");
    Expect(1, 119232, '\p{^Is_Composition_Exclusion=f}', "");
    Expect(1, 119232, '\P{Is_Composition_Exclusion=f}', "");
    Expect(0, 119232, '\P{^Is_Composition_Exclusion=f}', "");
    Expect(1, 119233, '\p{Is_Composition_Exclusion=F}', "");
    Expect(0, 119233, '\p{^Is_Composition_Exclusion=F}', "");
    Expect(0, 119233, '\P{Is_Composition_Exclusion=F}', "");
    Expect(1, 119233, '\P{^Is_Composition_Exclusion=F}', "");
    Expect(0, 119232, '\p{Is_Composition_Exclusion=F}', "");
    Expect(1, 119232, '\p{^Is_Composition_Exclusion=F}', "");
    Expect(1, 119232, '\P{Is_Composition_Exclusion=F}', "");
    Expect(0, 119232, '\P{^Is_Composition_Exclusion=F}', "");
    Error('\p{Is_CE= -false:=}');
    Error('\P{Is_CE= -false:=}');
    Expect(1, 119233, '\p{Is_CE=false}', "");
    Expect(0, 119233, '\p{^Is_CE=false}', "");
    Expect(0, 119233, '\P{Is_CE=false}', "");
    Expect(1, 119233, '\P{^Is_CE=false}', "");
    Expect(0, 119232, '\p{Is_CE=false}', "");
    Expect(1, 119232, '\p{^Is_CE=false}', "");
    Expect(1, 119232, '\P{Is_CE=false}', "");
    Expect(0, 119232, '\P{^Is_CE=false}', "");
    Expect(1, 119233, '\p{Is_CE=	_false}', "");
    Expect(0, 119233, '\p{^Is_CE=	_false}', "");
    Expect(0, 119233, '\P{Is_CE=	_false}', "");
    Expect(1, 119233, '\P{^Is_CE=	_false}', "");
    Expect(0, 119232, '\p{Is_CE=	_false}', "");
    Expect(1, 119232, '\p{^Is_CE=	_false}', "");
    Expect(1, 119232, '\P{Is_CE=	_false}', "");
    Expect(0, 119232, '\P{^Is_CE=	_false}', "");
    Error('\p{Composition_Exclusion=--YES:=}');
    Error('\P{Composition_Exclusion=--YES:=}');
    Expect(1, 119232, '\p{Composition_Exclusion=:\AYes\z:}', "");;
    Expect(0, 119233, '\p{Composition_Exclusion=:\AYes\z:}', "");;
    Expect(1, 119232, '\p{Composition_Exclusion=yes}', "");
    Expect(0, 119232, '\p{^Composition_Exclusion=yes}', "");
    Expect(0, 119232, '\P{Composition_Exclusion=yes}', "");
    Expect(1, 119232, '\P{^Composition_Exclusion=yes}', "");
    Expect(0, 119233, '\p{Composition_Exclusion=yes}', "");
    Expect(1, 119233, '\p{^Composition_Exclusion=yes}', "");
    Expect(1, 119233, '\P{Composition_Exclusion=yes}', "");
    Expect(0, 119233, '\P{^Composition_Exclusion=yes}', "");
    Expect(1, 119232, '\p{Composition_Exclusion=:\Ayes\z:}', "");;
    Expect(0, 119233, '\p{Composition_Exclusion=:\Ayes\z:}', "");;
    Expect(1, 119232, '\p{Composition_Exclusion=	Yes}', "");
    Expect(0, 119232, '\p{^Composition_Exclusion=	Yes}', "");
    Expect(0, 119232, '\P{Composition_Exclusion=	Yes}', "");
    Expect(1, 119232, '\P{^Composition_Exclusion=	Yes}', "");
    Expect(0, 119233, '\p{Composition_Exclusion=	Yes}', "");
    Expect(1, 119233, '\p{^Composition_Exclusion=	Yes}', "");
    Expect(1, 119233, '\P{Composition_Exclusion=	Yes}', "");
    Expect(0, 119233, '\P{^Composition_Exclusion=	Yes}', "");
    Error('\p{CE=_-y:=}');
    Error('\P{CE=_-y:=}');
    Expect(1, 119232, '\p{CE=:\AY\z:}', "");;
    Expect(0, 119233, '\p{CE=:\AY\z:}', "");;
    Expect(1, 119232, '\p{CE=y}', "");
    Expect(0, 119232, '\p{^CE=y}', "");
    Expect(0, 119232, '\P{CE=y}', "");
    Expect(1, 119232, '\P{^CE=y}', "");
    Expect(0, 119233, '\p{CE=y}', "");
    Expect(1, 119233, '\p{^CE=y}', "");
    Expect(1, 119233, '\P{CE=y}', "");
    Expect(0, 119233, '\P{^CE=y}', "");
    Expect(1, 119232, '\p{CE=:\Ay\z:}', "");;
    Expect(0, 119233, '\p{CE=:\Ay\z:}', "");;
    Expect(1, 119232, '\p{CE=--Y}', "");
    Expect(0, 119232, '\p{^CE=--Y}', "");
    Expect(0, 119232, '\P{CE=--Y}', "");
    Expect(1, 119232, '\P{^CE=--Y}', "");
    Expect(0, 119233, '\p{CE=--Y}', "");
    Expect(1, 119233, '\p{^CE=--Y}', "");
    Expect(1, 119233, '\P{CE=--Y}', "");
    Expect(0, 119233, '\P{^CE=--Y}', "");
    Error('\p{Is_Composition_Exclusion: :=T}');
    Error('\P{Is_Composition_Exclusion: :=T}');
    Expect(1, 119232, '\p{Is_Composition_Exclusion:	t}', "");
    Expect(0, 119232, '\p{^Is_Composition_Exclusion:	t}', "");
    Expect(0, 119232, '\P{Is_Composition_Exclusion:	t}', "");
    Expect(1, 119232, '\P{^Is_Composition_Exclusion:	t}', "");
    Expect(0, 119233, '\p{Is_Composition_Exclusion:	t}', "");
    Expect(1, 119233, '\p{^Is_Composition_Exclusion:	t}', "");
    Expect(1, 119233, '\P{Is_Composition_Exclusion:	t}', "");
    Expect(0, 119233, '\P{^Is_Composition_Exclusion:	t}', "");
    Expect(1, 119232, '\p{Is_Composition_Exclusion:   	_T}', "");
    Expect(0, 119232, '\p{^Is_Composition_Exclusion:   	_T}', "");
    Expect(0, 119232, '\P{Is_Composition_Exclusion:   	_T}', "");
    Expect(1, 119232, '\P{^Is_Composition_Exclusion:   	_T}', "");
    Expect(0, 119233, '\p{Is_Composition_Exclusion:   	_T}', "");
    Expect(1, 119233, '\p{^Is_Composition_Exclusion:   	_T}', "");
    Expect(1, 119233, '\P{Is_Composition_Exclusion:   	_T}', "");
    Expect(0, 119233, '\P{^Is_Composition_Exclusion:   	_T}', "");
    Error('\p{Is_CE:		/a/true}');
    Error('\P{Is_CE:		/a/true}');
    Expect(1, 119232, '\p{Is_CE=true}', "");
    Expect(0, 119232, '\p{^Is_CE=true}', "");
    Expect(0, 119232, '\P{Is_CE=true}', "");
    Expect(1, 119232, '\P{^Is_CE=true}', "");
    Expect(0, 119233, '\p{Is_CE=true}', "");
    Expect(1, 119233, '\p{^Is_CE=true}', "");
    Expect(1, 119233, '\P{Is_CE=true}', "");
    Expect(0, 119233, '\P{^Is_CE=true}', "");
    Expect(1, 119232, '\p{Is_CE=_	True}', "");
    Expect(0, 119232, '\p{^Is_CE=_	True}', "");
    Expect(0, 119232, '\P{Is_CE=_	True}', "");
    Expect(1, 119232, '\P{^Is_CE=_	True}', "");
    Expect(0, 119233, '\p{Is_CE=_	True}', "");
    Expect(1, 119233, '\p{^Is_CE=_	True}', "");
    Expect(1, 119233, '\P{Is_CE=_	True}', "");
    Expect(0, 119233, '\P{^Is_CE=_	True}', "");
    Error('\p{casefolding}');
    Error('\P{casefolding}');
    Error('\p{Case_Ignorable=_no:=}');
    Error('\P{Case_Ignorable=_no:=}');
    Expect(1, 918000, '\p{Case_Ignorable=:\ANo\z:}', "");;
    Expect(0, 917999, '\p{Case_Ignorable=:\ANo\z:}', "");;
    Expect(1, 918000, '\p{Case_Ignorable:	no}', "");
    Expect(0, 918000, '\p{^Case_Ignorable:	no}', "");
    Expect(0, 918000, '\P{Case_Ignorable:	no}', "");
    Expect(1, 918000, '\P{^Case_Ignorable:	no}', "");
    Expect(0, 917999, '\p{Case_Ignorable:	no}', "");
    Expect(1, 917999, '\p{^Case_Ignorable:	no}', "");
    Expect(1, 917999, '\P{Case_Ignorable:	no}', "");
    Expect(0, 917999, '\P{^Case_Ignorable:	no}', "");
    Expect(1, 918000, '\p{Case_Ignorable=:\Ano\z:}', "");;
    Expect(0, 917999, '\p{Case_Ignorable=:\Ano\z:}', "");;
    Expect(1, 918000, '\p{Case_Ignorable=  No}', "");
    Expect(0, 918000, '\p{^Case_Ignorable=  No}', "");
    Expect(0, 918000, '\P{Case_Ignorable=  No}', "");
    Expect(1, 918000, '\P{^Case_Ignorable=  No}', "");
    Expect(0, 917999, '\p{Case_Ignorable=  No}', "");
    Expect(1, 917999, '\p{^Case_Ignorable=  No}', "");
    Expect(1, 917999, '\P{Case_Ignorable=  No}', "");
    Expect(0, 917999, '\P{^Case_Ignorable=  No}', "");
    Error('\p{CI=	N/a/}');
    Error('\P{CI=	N/a/}');
    Expect(1, 918000, '\p{CI=:\AN\z:}', "");;
    Expect(0, 917999, '\p{CI=:\AN\z:}', "");;
    Expect(1, 918000, '\p{CI=n}', "");
    Expect(0, 918000, '\p{^CI=n}', "");
    Expect(0, 918000, '\P{CI=n}', "");
    Expect(1, 918000, '\P{^CI=n}', "");
    Expect(0, 917999, '\p{CI=n}', "");
    Expect(1, 917999, '\p{^CI=n}', "");
    Expect(1, 917999, '\P{CI=n}', "");
    Expect(0, 917999, '\P{^CI=n}', "");
    Expect(1, 918000, '\p{CI=:\An\z:}', "");;
    Expect(0, 917999, '\p{CI=:\An\z:}', "");;
    Expect(1, 918000, '\p{CI=_n}', "");
    Expect(0, 918000, '\p{^CI=_n}', "");
    Expect(0, 918000, '\P{CI=_n}', "");
    Expect(1, 918000, '\P{^CI=_n}', "");
    Expect(0, 917999, '\p{CI=_n}', "");
    Expect(1, 917999, '\p{^CI=_n}', "");
    Expect(1, 917999, '\P{CI=_n}', "");
    Expect(0, 917999, '\P{^CI=_n}', "");
    Error('\p{Is_Case_Ignorable=/a/	_F}');
    Error('\P{Is_Case_Ignorable=/a/	_F}');
    Expect(1, 918000, '\p{Is_Case_Ignorable=f}', "");
    Expect(0, 918000, '\p{^Is_Case_Ignorable=f}', "");
    Expect(0, 918000, '\P{Is_Case_Ignorable=f}', "");
    Expect(1, 918000, '\P{^Is_Case_Ignorable=f}', "");
    Expect(0, 917999, '\p{Is_Case_Ignorable=f}', "");
    Expect(1, 917999, '\p{^Is_Case_Ignorable=f}', "");
    Expect(1, 917999, '\P{Is_Case_Ignorable=f}', "");
    Expect(0, 917999, '\P{^Is_Case_Ignorable=f}', "");
    Expect(1, 918000, '\p{Is_Case_Ignorable=	 F}', "");
    Expect(0, 918000, '\p{^Is_Case_Ignorable=	 F}', "");
    Expect(0, 918000, '\P{Is_Case_Ignorable=	 F}', "");
    Expect(1, 918000, '\P{^Is_Case_Ignorable=	 F}', "");
    Expect(0, 917999, '\p{Is_Case_Ignorable=	 F}', "");
    Expect(1, 917999, '\p{^Is_Case_Ignorable=	 F}', "");
    Expect(1, 917999, '\P{Is_Case_Ignorable=	 F}', "");
    Expect(0, 917999, '\P{^Is_Case_Ignorable=	 F}', "");
    Error('\p{Is_CI=	_FALSE:=}');
    Error('\P{Is_CI=	_FALSE:=}');
    Expect(1, 918000, '\p{Is_CI=false}', "");
    Expect(0, 918000, '\p{^Is_CI=false}', "");
    Expect(0, 918000, '\P{Is_CI=false}', "");
    Expect(1, 918000, '\P{^Is_CI=false}', "");
    Expect(0, 917999, '\p{Is_CI=false}', "");
    Expect(1, 917999, '\p{^Is_CI=false}', "");
    Expect(1, 917999, '\P{Is_CI=false}', "");
    Expect(0, 917999, '\P{^Is_CI=false}', "");
    Expect(1, 918000, '\p{Is_CI: - False}', "");
    Expect(0, 918000, '\p{^Is_CI: - False}', "");
    Expect(0, 918000, '\P{Is_CI: - False}', "");
    Expect(1, 918000, '\P{^Is_CI: - False}', "");
    Expect(0, 917999, '\p{Is_CI: - False}', "");
    Expect(1, 917999, '\p{^Is_CI: - False}', "");
    Expect(1, 917999, '\P{Is_CI: - False}', "");
    Expect(0, 917999, '\P{^Is_CI: - False}', "");
    Error('\p{Case_Ignorable=:=Yes}');
    Error('\P{Case_Ignorable=:=Yes}');
    Expect(1, 917999, '\p{Case_Ignorable=:\AYes\z:}', "");;
    Expect(0, 918000, '\p{Case_Ignorable=:\AYes\z:}', "");;
    Expect(1, 917999, '\p{Case_Ignorable=yes}', "");
    Expect(0, 917999, '\p{^Case_Ignorable=yes}', "");
    Expect(0, 917999, '\P{Case_Ignorable=yes}', "");
    Expect(1, 917999, '\P{^Case_Ignorable=yes}', "");
    Expect(0, 918000, '\p{Case_Ignorable=yes}', "");
    Expect(1, 918000, '\p{^Case_Ignorable=yes}', "");
    Expect(1, 918000, '\P{Case_Ignorable=yes}', "");
    Expect(0, 918000, '\P{^Case_Ignorable=yes}', "");
    Expect(1, 917999, '\p{Case_Ignorable=:\Ayes\z:}', "");;
    Expect(0, 918000, '\p{Case_Ignorable=:\Ayes\z:}', "");;
    Expect(1, 917999, '\p{Case_Ignorable=__Yes}', "");
    Expect(0, 917999, '\p{^Case_Ignorable=__Yes}', "");
    Expect(0, 917999, '\P{Case_Ignorable=__Yes}', "");
    Expect(1, 917999, '\P{^Case_Ignorable=__Yes}', "");
    Expect(0, 918000, '\p{Case_Ignorable=__Yes}', "");
    Expect(1, 918000, '\p{^Case_Ignorable=__Yes}', "");
    Expect(1, 918000, '\P{Case_Ignorable=__Yes}', "");
    Expect(0, 918000, '\P{^Case_Ignorable=__Yes}', "");
    Error('\p{CI= /a/Y}');
    Error('\P{CI= /a/Y}');
    Expect(1, 917999, '\p{CI=:\AY\z:}', "");;
    Expect(0, 918000, '\p{CI=:\AY\z:}', "");;
    Expect(1, 917999, '\p{CI=y}', "");
    Expect(0, 917999, '\p{^CI=y}', "");
    Expect(0, 917999, '\P{CI=y}', "");
    Expect(1, 917999, '\P{^CI=y}', "");
    Expect(0, 918000, '\p{CI=y}', "");
    Expect(1, 918000, '\p{^CI=y}', "");
    Expect(1, 918000, '\P{CI=y}', "");
    Expect(0, 918000, '\P{^CI=y}', "");
    Expect(1, 917999, '\p{CI=:\Ay\z:}', "");;
    Expect(0, 918000, '\p{CI=:\Ay\z:}', "");;
    Expect(1, 917999, '\p{CI:    _Y}', "");
    Expect(0, 917999, '\p{^CI:    _Y}', "");
    Expect(0, 917999, '\P{CI:    _Y}', "");
    Expect(1, 917999, '\P{^CI:    _Y}', "");
    Expect(0, 918000, '\p{CI:    _Y}', "");
    Expect(1, 918000, '\p{^CI:    _Y}', "");
    Expect(1, 918000, '\P{CI:    _Y}', "");
    Expect(0, 918000, '\P{^CI:    _Y}', "");
    Error('\p{Is_Case_Ignorable=/a/T}');
    Error('\P{Is_Case_Ignorable=/a/T}');
    Expect(1, 917999, '\p{Is_Case_Ignorable=t}', "");
    Expect(0, 917999, '\p{^Is_Case_Ignorable=t}', "");
    Expect(0, 917999, '\P{Is_Case_Ignorable=t}', "");
    Expect(1, 917999, '\P{^Is_Case_Ignorable=t}', "");
    Expect(0, 918000, '\p{Is_Case_Ignorable=t}', "");
    Expect(1, 918000, '\p{^Is_Case_Ignorable=t}', "");
    Expect(1, 918000, '\P{Is_Case_Ignorable=t}', "");
    Expect(0, 918000, '\P{^Is_Case_Ignorable=t}', "");
    Expect(1, 917999, '\p{Is_Case_Ignorable=-_T}', "");
    Expect(0, 917999, '\p{^Is_Case_Ignorable=-_T}', "");
    Expect(0, 917999, '\P{Is_Case_Ignorable=-_T}', "");
    Expect(1, 917999, '\P{^Is_Case_Ignorable=-_T}', "");
    Expect(0, 918000, '\p{Is_Case_Ignorable=-_T}', "");
    Expect(1, 918000, '\p{^Is_Case_Ignorable=-_T}', "");
    Expect(1, 918000, '\P{Is_Case_Ignorable=-_T}', "");
    Expect(0, 918000, '\P{^Is_Case_Ignorable=-_T}', "");
    Error('\p{Is_CI=_:=True}');
    Error('\P{Is_CI=_:=True}');
    Expect(1, 917999, '\p{Is_CI:   true}', "");
    Expect(0, 917999, '\p{^Is_CI:   true}', "");
    Expect(0, 917999, '\P{Is_CI:   true}', "");
    Expect(1, 917999, '\P{^Is_CI:   true}', "");
    Expect(0, 918000, '\p{Is_CI:   true}', "");
    Expect(1, 918000, '\p{^Is_CI:   true}', "");
    Expect(1, 918000, '\P{Is_CI:   true}', "");
    Expect(0, 918000, '\P{^Is_CI:   true}', "");
    Expect(1, 917999, '\p{Is_CI=_True}', "");
    Expect(0, 917999, '\p{^Is_CI=_True}', "");
    Expect(0, 917999, '\P{Is_CI=_True}', "");
    Expect(1, 917999, '\P{^Is_CI=_True}', "");
    Expect(0, 918000, '\p{Is_CI=_True}', "");
    Expect(1, 918000, '\p{^Is_CI=_True}', "");
    Expect(1, 918000, '\P{Is_CI=_True}', "");
    Expect(0, 918000, '\P{^Is_CI=_True}', "");
    Error('\p{kaccountingnumeric}');
    Error('\P{kaccountingnumeric}');
    Error('\p{cjkaccountingnumeric}');
    Error('\P{cjkaccountingnumeric}');
    Error('\p{kcompatibilityvariant}');
    Error('\P{kcompatibilityvariant}');
    Error('\p{cjkcompatibilityvariant}');
    Error('\P{cjkcompatibilityvariant}');
    Error('\p{kiicore}');
    Error('\P{kiicore}');
    Error('\p{cjkiicore}');
    Error('\P{cjkiicore}');
    Error('\p{kirggsource}');
    Error('\P{kirggsource}');
    Error('\p{cjkirggsource}');
    Error('\P{cjkirggsource}');
    Error('\p{kirghsource}');
    Error('\P{kirghsource}');
    Error('\p{cjkirghsource}');
    Error('\P{cjkirghsource}');
    Error('\p{kirgjsource}');
    Error('\P{kirgjsource}');
    Error('\p{cjkirgjsource}');
    Error('\P{cjkirgjsource}');
    Error('\p{kirgkpsource}');
    Error('\P{kirgkpsource}');
    Error('\p{cjkirgkpsource}');
    Error('\P{cjkirgkpsource}');
    Error('\p{kirgksource}');
    Error('\P{kirgksource}');
    Error('\p{cjkirgksource}');
    Error('\P{cjkirgksource}');
    Error('\p{kirgmsource}');
    Error('\P{kirgmsource}');
    Error('\p{cjkirgmsource}');
    Error('\P{cjkirgmsource}');
    Error('\p{kirgtsource}');
    Error('\P{kirgtsource}');
    Error('\p{cjkirgtsource}');
    Error('\P{cjkirgtsource}');
    Error('\p{kirgusource}');
    Error('\P{kirgusource}');
    Error('\p{cjkirgusource}');
    Error('\P{cjkirgusource}');
    Error('\p{kirgvsource}');
    Error('\P{kirgvsource}');
    Error('\p{cjkirgvsource}');
    Error('\P{cjkirgvsource}');
    Error('\p{kothernumeric}');
    Error('\P{kothernumeric}');
    Error('\p{cjkothernumeric}');
    Error('\P{cjkothernumeric}');
    Error('\p{kprimarynumeric}');
    Error('\P{kprimarynumeric}');
    Error('\p{cjkprimarynumeric}');
    Error('\P{cjkprimarynumeric}');
    Error('\p{krsunicode}');
    Error('\P{krsunicode}');
    Error('\p{cjkrsunicode}');
    Error('\P{cjkrsunicode}');
    Error('\p{unicoderadicalstroke}');
    Error('\P{unicoderadicalstroke}');
    Error('\p{urs}');
    Error('\P{urs}');
    Error('\p{Full_Composition_Exclusion= 	no/a/}');
    Error('\P{Full_Composition_Exclusion= 	no/a/}');
    Expect(1, 195102, '\p{Full_Composition_Exclusion=:\ANo\z:}', "");;
    Expect(0, 195101, '\p{Full_Composition_Exclusion=:\ANo\z:}', "");;
    Expect(1, 195102, '\p{Full_Composition_Exclusion=no}', "");
    Expect(0, 195102, '\p{^Full_Composition_Exclusion=no}', "");
    Expect(0, 195102, '\P{Full_Composition_Exclusion=no}', "");
    Expect(1, 195102, '\P{^Full_Composition_Exclusion=no}', "");
    Expect(0, 195101, '\p{Full_Composition_Exclusion=no}', "");
    Expect(1, 195101, '\p{^Full_Composition_Exclusion=no}', "");
    Expect(1, 195101, '\P{Full_Composition_Exclusion=no}', "");
    Expect(0, 195101, '\P{^Full_Composition_Exclusion=no}', "");
    Expect(1, 195102, '\p{Full_Composition_Exclusion=:\Ano\z:}', "");;
    Expect(0, 195101, '\p{Full_Composition_Exclusion=:\Ano\z:}', "");;
    Expect(1, 195102, '\p{Full_Composition_Exclusion=_	No}', "");
    Expect(0, 195102, '\p{^Full_Composition_Exclusion=_	No}', "");
    Expect(0, 195102, '\P{Full_Composition_Exclusion=_	No}', "");
    Expect(1, 195102, '\P{^Full_Composition_Exclusion=_	No}', "");
    Expect(0, 195101, '\p{Full_Composition_Exclusion=_	No}', "");
    Expect(1, 195101, '\p{^Full_Composition_Exclusion=_	No}', "");
    Expect(1, 195101, '\P{Full_Composition_Exclusion=_	No}', "");
    Expect(0, 195101, '\P{^Full_Composition_Exclusion=_	No}', "");
    Error('\p{Comp_Ex=:=n}');
    Error('\P{Comp_Ex=:=n}');
    Expect(1, 195102, '\p{Comp_Ex=:\AN\z:}', "");;
    Expect(0, 195101, '\p{Comp_Ex=:\AN\z:}', "");;
    Expect(1, 195102, '\p{Comp_Ex=n}', "");
    Expect(0, 195102, '\p{^Comp_Ex=n}', "");
    Expect(0, 195102, '\P{Comp_Ex=n}', "");
    Expect(1, 195102, '\P{^Comp_Ex=n}', "");
    Expect(0, 195101, '\p{Comp_Ex=n}', "");
    Expect(1, 195101, '\p{^Comp_Ex=n}', "");
    Expect(1, 195101, '\P{Comp_Ex=n}', "");
    Expect(0, 195101, '\P{^Comp_Ex=n}', "");
    Expect(1, 195102, '\p{Comp_Ex=:\An\z:}', "");;
    Expect(0, 195101, '\p{Comp_Ex=:\An\z:}', "");;
    Expect(1, 195102, '\p{Comp_Ex:	-	n}', "");
    Expect(0, 195102, '\p{^Comp_Ex:	-	n}', "");
    Expect(0, 195102, '\P{Comp_Ex:	-	n}', "");
    Expect(1, 195102, '\P{^Comp_Ex:	-	n}', "");
    Expect(0, 195101, '\p{Comp_Ex:	-	n}', "");
    Expect(1, 195101, '\p{^Comp_Ex:	-	n}', "");
    Expect(1, 195101, '\P{Comp_Ex:	-	n}', "");
    Expect(0, 195101, '\P{^Comp_Ex:	-	n}', "");
    Error('\p{Is_Full_Composition_Exclusion:   	:=F}');
    Error('\P{Is_Full_Composition_Exclusion:   	:=F}');
    Expect(1, 195102, '\p{Is_Full_Composition_Exclusion=f}', "");
    Expect(0, 195102, '\p{^Is_Full_Composition_Exclusion=f}', "");
    Expect(0, 195102, '\P{Is_Full_Composition_Exclusion=f}', "");
    Expect(1, 195102, '\P{^Is_Full_Composition_Exclusion=f}', "");
    Expect(0, 195101, '\p{Is_Full_Composition_Exclusion=f}', "");
    Expect(1, 195101, '\p{^Is_Full_Composition_Exclusion=f}', "");
    Expect(1, 195101, '\P{Is_Full_Composition_Exclusion=f}', "");
    Expect(0, 195101, '\P{^Is_Full_Composition_Exclusion=f}', "");
    Expect(1, 195102, '\p{Is_Full_Composition_Exclusion=	 F}', "");
    Expect(0, 195102, '\p{^Is_Full_Composition_Exclusion=	 F}', "");
    Expect(0, 195102, '\P{Is_Full_Composition_Exclusion=	 F}', "");
    Expect(1, 195102, '\P{^Is_Full_Composition_Exclusion=	 F}', "");
    Expect(0, 195101, '\p{Is_Full_Composition_Exclusion=	 F}', "");
    Expect(1, 195101, '\p{^Is_Full_Composition_Exclusion=	 F}', "");
    Expect(1, 195101, '\P{Is_Full_Composition_Exclusion=	 F}', "");
    Expect(0, 195101, '\P{^Is_Full_Composition_Exclusion=	 F}', "");
    Error('\p{Is_Comp_Ex=	/a/false}');
    Error('\P{Is_Comp_Ex=	/a/false}');
    Expect(1, 195102, '\p{Is_Comp_Ex=false}', "");
    Expect(0, 195102, '\p{^Is_Comp_Ex=false}', "");
    Expect(0, 195102, '\P{Is_Comp_Ex=false}', "");
    Expect(1, 195102, '\P{^Is_Comp_Ex=false}', "");
    Expect(0, 195101, '\p{Is_Comp_Ex=false}', "");
    Expect(1, 195101, '\p{^Is_Comp_Ex=false}', "");
    Expect(1, 195101, '\P{Is_Comp_Ex=false}', "");
    Expect(0, 195101, '\P{^Is_Comp_Ex=false}', "");
    Expect(1, 195102, '\p{Is_Comp_Ex=_false}', "");
    Expect(0, 195102, '\p{^Is_Comp_Ex=_false}', "");
    Expect(0, 195102, '\P{Is_Comp_Ex=_false}', "");
    Expect(1, 195102, '\P{^Is_Comp_Ex=_false}', "");
    Expect(0, 195101, '\p{Is_Comp_Ex=_false}', "");
    Expect(1, 195101, '\p{^Is_Comp_Ex=_false}', "");
    Expect(1, 195101, '\P{Is_Comp_Ex=_false}', "");
    Expect(0, 195101, '\P{^Is_Comp_Ex=_false}', "");
    Error('\p{Full_Composition_Exclusion=--yes:=}');
    Error('\P{Full_Composition_Exclusion=--yes:=}');
    Expect(1, 195101, '\p{Full_Composition_Exclusion=:\AYes\z:}', "");;
    Expect(0, 195102, '\p{Full_Composition_Exclusion=:\AYes\z:}', "");;
    Expect(1, 195101, '\p{Full_Composition_Exclusion=yes}', "");
    Expect(0, 195101, '\p{^Full_Composition_Exclusion=yes}', "");
    Expect(0, 195101, '\P{Full_Composition_Exclusion=yes}', "");
    Expect(1, 195101, '\P{^Full_Composition_Exclusion=yes}', "");
    Expect(0, 195102, '\p{Full_Composition_Exclusion=yes}', "");
    Expect(1, 195102, '\p{^Full_Composition_Exclusion=yes}', "");
    Expect(1, 195102, '\P{Full_Composition_Exclusion=yes}', "");
    Expect(0, 195102, '\P{^Full_Composition_Exclusion=yes}', "");
    Expect(1, 195101, '\p{Full_Composition_Exclusion=:\Ayes\z:}', "");;
    Expect(0, 195102, '\p{Full_Composition_Exclusion=:\Ayes\z:}', "");;
    Expect(1, 195101, '\p{Full_Composition_Exclusion=__yes}', "");
    Expect(0, 195101, '\p{^Full_Composition_Exclusion=__yes}', "");
    Expect(0, 195101, '\P{Full_Composition_Exclusion=__yes}', "");
    Expect(1, 195101, '\P{^Full_Composition_Exclusion=__yes}', "");
    Expect(0, 195102, '\p{Full_Composition_Exclusion=__yes}', "");
    Expect(1, 195102, '\p{^Full_Composition_Exclusion=__yes}', "");
    Expect(1, 195102, '\P{Full_Composition_Exclusion=__yes}', "");
    Expect(0, 195102, '\P{^Full_Composition_Exclusion=__yes}', "");
    Error('\p{Comp_Ex=:=	-Y}');
    Error('\P{Comp_Ex=:=	-Y}');
    Expect(1, 195101, '\p{Comp_Ex=:\AY\z:}', "");;
    Expect(0, 195102, '\p{Comp_Ex=:\AY\z:}', "");;
    Expect(1, 195101, '\p{Comp_Ex: y}', "");
    Expect(0, 195101, '\p{^Comp_Ex: y}', "");
    Expect(0, 195101, '\P{Comp_Ex: y}', "");
    Expect(1, 195101, '\P{^Comp_Ex: y}', "");
    Expect(0, 195102, '\p{Comp_Ex: y}', "");
    Expect(1, 195102, '\p{^Comp_Ex: y}', "");
    Expect(1, 195102, '\P{Comp_Ex: y}', "");
    Expect(0, 195102, '\P{^Comp_Ex: y}', "");
    Expect(1, 195101, '\p{Comp_Ex=:\Ay\z:}', "");;
    Expect(0, 195102, '\p{Comp_Ex=:\Ay\z:}', "");;
    Expect(1, 195101, '\p{Comp_Ex= Y}', "");
    Expect(0, 195101, '\p{^Comp_Ex= Y}', "");
    Expect(0, 195101, '\P{Comp_Ex= Y}', "");
    Expect(1, 195101, '\P{^Comp_Ex= Y}', "");
    Expect(0, 195102, '\p{Comp_Ex= Y}', "");
    Expect(1, 195102, '\p{^Comp_Ex= Y}', "");
    Expect(1, 195102, '\P{Comp_Ex= Y}', "");
    Expect(0, 195102, '\P{^Comp_Ex= Y}', "");
    Error('\p{Is_Full_Composition_Exclusion=-T:=}');
    Error('\P{Is_Full_Composition_Exclusion=-T:=}');
    Expect(1, 195101, '\p{Is_Full_Composition_Exclusion=t}', "");
    Expect(0, 195101, '\p{^Is_Full_Composition_Exclusion=t}', "");
    Expect(0, 195101, '\P{Is_Full_Composition_Exclusion=t}', "");
    Expect(1, 195101, '\P{^Is_Full_Composition_Exclusion=t}', "");
    Expect(0, 195102, '\p{Is_Full_Composition_Exclusion=t}', "");
    Expect(1, 195102, '\p{^Is_Full_Composition_Exclusion=t}', "");
    Expect(1, 195102, '\P{Is_Full_Composition_Exclusion=t}', "");
    Expect(0, 195102, '\P{^Is_Full_Composition_Exclusion=t}', "");
    Expect(1, 195101, '\p{Is_Full_Composition_Exclusion= -T}', "");
    Expect(0, 195101, '\p{^Is_Full_Composition_Exclusion= -T}', "");
    Expect(0, 195101, '\P{Is_Full_Composition_Exclusion= -T}', "");
    Expect(1, 195101, '\P{^Is_Full_Composition_Exclusion= -T}', "");
    Expect(0, 195102, '\p{Is_Full_Composition_Exclusion= -T}', "");
    Expect(1, 195102, '\p{^Is_Full_Composition_Exclusion= -T}', "");
    Expect(1, 195102, '\P{Is_Full_Composition_Exclusion= -T}', "");
    Expect(0, 195102, '\P{^Is_Full_Composition_Exclusion= -T}', "");
    Error('\p{Is_Comp_Ex=:=TRUE}');
    Error('\P{Is_Comp_Ex=:=TRUE}');
    Expect(1, 195101, '\p{Is_Comp_Ex=true}', "");
    Expect(0, 195101, '\p{^Is_Comp_Ex=true}', "");
    Expect(0, 195101, '\P{Is_Comp_Ex=true}', "");
    Expect(1, 195101, '\P{^Is_Comp_Ex=true}', "");
    Expect(0, 195102, '\p{Is_Comp_Ex=true}', "");
    Expect(1, 195102, '\p{^Is_Comp_Ex=true}', "");
    Expect(1, 195102, '\P{Is_Comp_Ex=true}', "");
    Expect(0, 195102, '\P{^Is_Comp_Ex=true}', "");
    Expect(1, 195101, '\p{Is_Comp_Ex:   -_TRUE}', "");
    Expect(0, 195101, '\p{^Is_Comp_Ex:   -_TRUE}', "");
    Expect(0, 195101, '\P{Is_Comp_Ex:   -_TRUE}', "");
    Expect(1, 195101, '\P{^Is_Comp_Ex:   -_TRUE}', "");
    Expect(0, 195102, '\p{Is_Comp_Ex:   -_TRUE}', "");
    Expect(1, 195102, '\p{^Is_Comp_Ex:   -_TRUE}', "");
    Expect(1, 195102, '\P{Is_Comp_Ex:   -_TRUE}', "");
    Expect(0, 195102, '\P{^Is_Comp_Ex:   -_TRUE}', "");
    Error('\p{Changes_When_Casefolded=_No/a/}');
    Error('\P{Changes_When_Casefolded=_No/a/}');
    Expect(1, 125218, '\p{Changes_When_Casefolded=:\ANo\z:}', "");;
    Expect(0, 125217, '\p{Changes_When_Casefolded=:\ANo\z:}', "");;
    Expect(1, 125218, '\p{Changes_When_Casefolded=no}', "");
    Expect(0, 125218, '\p{^Changes_When_Casefolded=no}', "");
    Expect(0, 125218, '\P{Changes_When_Casefolded=no}', "");
    Expect(1, 125218, '\P{^Changes_When_Casefolded=no}', "");
    Expect(0, 125217, '\p{Changes_When_Casefolded=no}', "");
    Expect(1, 125217, '\p{^Changes_When_Casefolded=no}', "");
    Expect(1, 125217, '\P{Changes_When_Casefolded=no}', "");
    Expect(0, 125217, '\P{^Changes_When_Casefolded=no}', "");
    Expect(1, 125218, '\p{Changes_When_Casefolded=:\Ano\z:}', "");;
    Expect(0, 125217, '\p{Changes_When_Casefolded=:\Ano\z:}', "");;
    Expect(1, 125218, '\p{Changes_When_Casefolded= 	no}', "");
    Expect(0, 125218, '\p{^Changes_When_Casefolded= 	no}', "");
    Expect(0, 125218, '\P{Changes_When_Casefolded= 	no}', "");
    Expect(1, 125218, '\P{^Changes_When_Casefolded= 	no}', "");
    Expect(0, 125217, '\p{Changes_When_Casefolded= 	no}', "");
    Expect(1, 125217, '\p{^Changes_When_Casefolded= 	no}', "");
    Expect(1, 125217, '\P{Changes_When_Casefolded= 	no}', "");
    Expect(0, 125217, '\P{^Changes_When_Casefolded= 	no}', "");
    Error('\p{CWCF=-:=N}');
    Error('\P{CWCF=-:=N}');
    Expect(1, 125218, '\p{CWCF=:\AN\z:}', "");;
    Expect(0, 125217, '\p{CWCF=:\AN\z:}', "");;
    Expect(1, 125218, '\p{CWCF=n}', "");
    Expect(0, 125218, '\p{^CWCF=n}', "");
    Expect(0, 125218, '\P{CWCF=n}', "");
    Expect(1, 125218, '\P{^CWCF=n}', "");
    Expect(0, 125217, '\p{CWCF=n}', "");
    Expect(1, 125217, '\p{^CWCF=n}', "");
    Expect(1, 125217, '\P{CWCF=n}', "");
    Expect(0, 125217, '\P{^CWCF=n}', "");
    Expect(1, 125218, '\p{CWCF=:\An\z:}', "");;
    Expect(0, 125217, '\p{CWCF=:\An\z:}', "");;
    Expect(1, 125218, '\p{CWCF= n}', "");
    Expect(0, 125218, '\p{^CWCF= n}', "");
    Expect(0, 125218, '\P{CWCF= n}', "");
    Expect(1, 125218, '\P{^CWCF= n}', "");
    Expect(0, 125217, '\p{CWCF= n}', "");
    Expect(1, 125217, '\p{^CWCF= n}', "");
    Expect(1, 125217, '\P{CWCF= n}', "");
    Expect(0, 125217, '\P{^CWCF= n}', "");
    Error('\p{Is_Changes_When_Casefolded=:=f}');
    Error('\P{Is_Changes_When_Casefolded=:=f}');
    Expect(1, 125218, '\p{Is_Changes_When_Casefolded: f}', "");
    Expect(0, 125218, '\p{^Is_Changes_When_Casefolded: f}', "");
    Expect(0, 125218, '\P{Is_Changes_When_Casefolded: f}', "");
    Expect(1, 125218, '\P{^Is_Changes_When_Casefolded: f}', "");
    Expect(0, 125217, '\p{Is_Changes_When_Casefolded: f}', "");
    Expect(1, 125217, '\p{^Is_Changes_When_Casefolded: f}', "");
    Expect(1, 125217, '\P{Is_Changes_When_Casefolded: f}', "");
    Expect(0, 125217, '\P{^Is_Changes_When_Casefolded: f}', "");
    Expect(1, 125218, '\p{Is_Changes_When_Casefolded=-	F}', "");
    Expect(0, 125218, '\p{^Is_Changes_When_Casefolded=-	F}', "");
    Expect(0, 125218, '\P{Is_Changes_When_Casefolded=-	F}', "");
    Expect(1, 125218, '\P{^Is_Changes_When_Casefolded=-	F}', "");
    Expect(0, 125217, '\p{Is_Changes_When_Casefolded=-	F}', "");
    Expect(1, 125217, '\p{^Is_Changes_When_Casefolded=-	F}', "");
    Expect(1, 125217, '\P{Is_Changes_When_Casefolded=-	F}', "");
    Expect(0, 125217, '\P{^Is_Changes_When_Casefolded=-	F}', "");
    Error('\p{Is_CWCF=--FALSE/a/}');
    Error('\P{Is_CWCF=--FALSE/a/}');
    Expect(1, 125218, '\p{Is_CWCF=false}', "");
    Expect(0, 125218, '\p{^Is_CWCF=false}', "");
    Expect(0, 125218, '\P{Is_CWCF=false}', "");
    Expect(1, 125218, '\P{^Is_CWCF=false}', "");
    Expect(0, 125217, '\p{Is_CWCF=false}', "");
    Expect(1, 125217, '\p{^Is_CWCF=false}', "");
    Expect(1, 125217, '\P{Is_CWCF=false}', "");
    Expect(0, 125217, '\P{^Is_CWCF=false}', "");
    Expect(1, 125218, '\p{Is_CWCF=-FALSE}', "");
    Expect(0, 125218, '\p{^Is_CWCF=-FALSE}', "");
    Expect(0, 125218, '\P{Is_CWCF=-FALSE}', "");
    Expect(1, 125218, '\P{^Is_CWCF=-FALSE}', "");
    Expect(0, 125217, '\p{Is_CWCF=-FALSE}', "");
    Expect(1, 125217, '\p{^Is_CWCF=-FALSE}', "");
    Expect(1, 125217, '\P{Is_CWCF=-FALSE}', "");
    Expect(0, 125217, '\P{^Is_CWCF=-FALSE}', "");
    Error('\p{Changes_When_Casefolded=_yes:=}');
    Error('\P{Changes_When_Casefolded=_yes:=}');
    Expect(1, 125217, '\p{Changes_When_Casefolded=:\AYes\z:}', "");;
    Expect(0, 125218, '\p{Changes_When_Casefolded=:\AYes\z:}', "");;
    Expect(1, 125217, '\p{Changes_When_Casefolded=yes}', "");
    Expect(0, 125217, '\p{^Changes_When_Casefolded=yes}', "");
    Expect(0, 125217, '\P{Changes_When_Casefolded=yes}', "");
    Expect(1, 125217, '\P{^Changes_When_Casefolded=yes}', "");
    Expect(0, 125218, '\p{Changes_When_Casefolded=yes}', "");
    Expect(1, 125218, '\p{^Changes_When_Casefolded=yes}', "");
    Expect(1, 125218, '\P{Changes_When_Casefolded=yes}', "");
    Expect(0, 125218, '\P{^Changes_When_Casefolded=yes}', "");
    Expect(1, 125217, '\p{Changes_When_Casefolded=:\Ayes\z:}', "");;
    Expect(0, 125218, '\p{Changes_When_Casefolded=:\Ayes\z:}', "");;
    Expect(1, 125217, '\p{Changes_When_Casefolded=		Yes}', "");
    Expect(0, 125217, '\p{^Changes_When_Casefolded=		Yes}', "");
    Expect(0, 125217, '\P{Changes_When_Casefolded=		Yes}', "");
    Expect(1, 125217, '\P{^Changes_When_Casefolded=		Yes}', "");
    Expect(0, 125218, '\p{Changes_When_Casefolded=		Yes}', "");
    Expect(1, 125218, '\p{^Changes_When_Casefolded=		Yes}', "");
    Expect(1, 125218, '\P{Changes_When_Casefolded=		Yes}', "");
    Expect(0, 125218, '\P{^Changes_When_Casefolded=		Yes}', "");
    Error('\p{CWCF=_/a/Y}');
    Error('\P{CWCF=_/a/Y}');
    Expect(1, 125217, '\p{CWCF=:\AY\z:}', "");;
    Expect(0, 125218, '\p{CWCF=:\AY\z:}', "");;
    Expect(1, 125217, '\p{CWCF=y}', "");
    Expect(0, 125217, '\p{^CWCF=y}', "");
    Expect(0, 125217, '\P{CWCF=y}', "");
    Expect(1, 125217, '\P{^CWCF=y}', "");
    Expect(0, 125218, '\p{CWCF=y}', "");
    Expect(1, 125218, '\p{^CWCF=y}', "");
    Expect(1, 125218, '\P{CWCF=y}', "");
    Expect(0, 125218, '\P{^CWCF=y}', "");
    Expect(1, 125217, '\p{CWCF=:\Ay\z:}', "");;
    Expect(0, 125218, '\p{CWCF=:\Ay\z:}', "");;
    Expect(1, 125217, '\p{CWCF=-_Y}', "");
    Expect(0, 125217, '\p{^CWCF=-_Y}', "");
    Expect(0, 125217, '\P{CWCF=-_Y}', "");
    Expect(1, 125217, '\P{^CWCF=-_Y}', "");
    Expect(0, 125218, '\p{CWCF=-_Y}', "");
    Expect(1, 125218, '\p{^CWCF=-_Y}', "");
    Expect(1, 125218, '\P{CWCF=-_Y}', "");
    Expect(0, 125218, '\P{^CWCF=-_Y}', "");
    Error('\p{Is_Changes_When_Casefolded=/a/--T}');
    Error('\P{Is_Changes_When_Casefolded=/a/--T}');
    Expect(1, 125217, '\p{Is_Changes_When_Casefolded=t}', "");
    Expect(0, 125217, '\p{^Is_Changes_When_Casefolded=t}', "");
    Expect(0, 125217, '\P{Is_Changes_When_Casefolded=t}', "");
    Expect(1, 125217, '\P{^Is_Changes_When_Casefolded=t}', "");
    Expect(0, 125218, '\p{Is_Changes_When_Casefolded=t}', "");
    Expect(1, 125218, '\p{^Is_Changes_When_Casefolded=t}', "");
    Expect(1, 125218, '\P{Is_Changes_When_Casefolded=t}', "");
    Expect(0, 125218, '\P{^Is_Changes_When_Casefolded=t}', "");
    Expect(1, 125217, '\p{Is_Changes_When_Casefolded=_	T}', "");
    Expect(0, 125217, '\p{^Is_Changes_When_Casefolded=_	T}', "");
    Expect(0, 125217, '\P{Is_Changes_When_Casefolded=_	T}', "");
    Expect(1, 125217, '\P{^Is_Changes_When_Casefolded=_	T}', "");
    Expect(0, 125218, '\p{Is_Changes_When_Casefolded=_	T}', "");
    Expect(1, 125218, '\p{^Is_Changes_When_Casefolded=_	T}', "");
    Expect(1, 125218, '\P{Is_Changes_When_Casefolded=_	T}', "");
    Expect(0, 125218, '\P{^Is_Changes_When_Casefolded=_	T}', "");
    Error('\p{Is_CWCF=	/a/True}');
    Error('\P{Is_CWCF=	/a/True}');
    Expect(1, 125217, '\p{Is_CWCF=true}', "");
    Expect(0, 125217, '\p{^Is_CWCF=true}', "");
    Expect(0, 125217, '\P{Is_CWCF=true}', "");
    Expect(1, 125217, '\P{^Is_CWCF=true}', "");
    Expect(0, 125218, '\p{Is_CWCF=true}', "");
    Expect(1, 125218, '\p{^Is_CWCF=true}', "");
    Expect(1, 125218, '\P{Is_CWCF=true}', "");
    Expect(0, 125218, '\P{^Is_CWCF=true}', "");
    Expect(1, 125217, '\p{Is_CWCF=	True}', "");
    Expect(0, 125217, '\p{^Is_CWCF=	True}', "");
    Expect(0, 125217, '\P{Is_CWCF=	True}', "");
    Expect(1, 125217, '\P{^Is_CWCF=	True}', "");
    Expect(0, 125218, '\p{Is_CWCF=	True}', "");
    Expect(1, 125218, '\p{^Is_CWCF=	True}', "");
    Expect(1, 125218, '\P{Is_CWCF=	True}', "");
    Expect(0, 125218, '\P{^Is_CWCF=	True}', "");
    Error('\p{Changes_When_Casemapped=_/a/No}');
    Error('\P{Changes_When_Casemapped=_/a/No}');
    Expect(1, 125252, '\p{Changes_When_Casemapped=:\ANo\z:}', "");;
    Expect(0, 125251, '\p{Changes_When_Casemapped=:\ANo\z:}', "");;
    Expect(1, 125252, '\p{Changes_When_Casemapped=no}', "");
    Expect(0, 125252, '\p{^Changes_When_Casemapped=no}', "");
    Expect(0, 125252, '\P{Changes_When_Casemapped=no}', "");
    Expect(1, 125252, '\P{^Changes_When_Casemapped=no}', "");
    Expect(0, 125251, '\p{Changes_When_Casemapped=no}', "");
    Expect(1, 125251, '\p{^Changes_When_Casemapped=no}', "");
    Expect(1, 125251, '\P{Changes_When_Casemapped=no}', "");
    Expect(0, 125251, '\P{^Changes_When_Casemapped=no}', "");
    Expect(1, 125252, '\p{Changes_When_Casemapped=:\Ano\z:}', "");;
    Expect(0, 125251, '\p{Changes_When_Casemapped=:\Ano\z:}', "");;
    Expect(1, 125252, '\p{Changes_When_Casemapped= NO}', "");
    Expect(0, 125252, '\p{^Changes_When_Casemapped= NO}', "");
    Expect(0, 125252, '\P{Changes_When_Casemapped= NO}', "");
    Expect(1, 125252, '\P{^Changes_When_Casemapped= NO}', "");
    Expect(0, 125251, '\p{Changes_When_Casemapped= NO}', "");
    Expect(1, 125251, '\p{^Changes_When_Casemapped= NO}', "");
    Expect(1, 125251, '\P{Changes_When_Casemapped= NO}', "");
    Expect(0, 125251, '\P{^Changes_When_Casemapped= NO}', "");
    Error('\p{CWCM=_N/a/}');
    Error('\P{CWCM=_N/a/}');
    Expect(1, 125252, '\p{CWCM=:\AN\z:}', "");;
    Expect(0, 125251, '\p{CWCM=:\AN\z:}', "");;
    Expect(1, 125252, '\p{CWCM: n}', "");
    Expect(0, 125252, '\p{^CWCM: n}', "");
    Expect(0, 125252, '\P{CWCM: n}', "");
    Expect(1, 125252, '\P{^CWCM: n}', "");
    Expect(0, 125251, '\p{CWCM: n}', "");
    Expect(1, 125251, '\p{^CWCM: n}', "");
    Expect(1, 125251, '\P{CWCM: n}', "");
    Expect(0, 125251, '\P{^CWCM: n}', "");
    Expect(1, 125252, '\p{CWCM=:\An\z:}', "");;
    Expect(0, 125251, '\p{CWCM=:\An\z:}', "");;
    Expect(1, 125252, '\p{CWCM:   -_N}', "");
    Expect(0, 125252, '\p{^CWCM:   -_N}', "");
    Expect(0, 125252, '\P{CWCM:   -_N}', "");
    Expect(1, 125252, '\P{^CWCM:   -_N}', "");
    Expect(0, 125251, '\p{CWCM:   -_N}', "");
    Expect(1, 125251, '\p{^CWCM:   -_N}', "");
    Expect(1, 125251, '\P{CWCM:   -_N}', "");
    Expect(0, 125251, '\P{^CWCM:   -_N}', "");
    Error('\p{Is_Changes_When_Casemapped=_-F/a/}');
    Error('\P{Is_Changes_When_Casemapped=_-F/a/}');
    Expect(1, 125252, '\p{Is_Changes_When_Casemapped=f}', "");
    Expect(0, 125252, '\p{^Is_Changes_When_Casemapped=f}', "");
    Expect(0, 125252, '\P{Is_Changes_When_Casemapped=f}', "");
    Expect(1, 125252, '\P{^Is_Changes_When_Casemapped=f}', "");
    Expect(0, 125251, '\p{Is_Changes_When_Casemapped=f}', "");
    Expect(1, 125251, '\p{^Is_Changes_When_Casemapped=f}', "");
    Expect(1, 125251, '\P{Is_Changes_When_Casemapped=f}', "");
    Expect(0, 125251, '\P{^Is_Changes_When_Casemapped=f}', "");
    Expect(1, 125252, '\p{Is_Changes_When_Casemapped=_F}', "");
    Expect(0, 125252, '\p{^Is_Changes_When_Casemapped=_F}', "");
    Expect(0, 125252, '\P{Is_Changes_When_Casemapped=_F}', "");
    Expect(1, 125252, '\P{^Is_Changes_When_Casemapped=_F}', "");
    Expect(0, 125251, '\p{Is_Changes_When_Casemapped=_F}', "");
    Expect(1, 125251, '\p{^Is_Changes_When_Casemapped=_F}', "");
    Expect(1, 125251, '\P{Is_Changes_When_Casemapped=_F}', "");
    Expect(0, 125251, '\P{^Is_Changes_When_Casemapped=_F}', "");
    Error('\p{Is_CWCM= FALSE:=}');
    Error('\P{Is_CWCM= FALSE:=}');
    Expect(1, 125252, '\p{Is_CWCM=false}', "");
    Expect(0, 125252, '\p{^Is_CWCM=false}', "");
    Expect(0, 125252, '\P{Is_CWCM=false}', "");
    Expect(1, 125252, '\P{^Is_CWCM=false}', "");
    Expect(0, 125251, '\p{Is_CWCM=false}', "");
    Expect(1, 125251, '\p{^Is_CWCM=false}', "");
    Expect(1, 125251, '\P{Is_CWCM=false}', "");
    Expect(0, 125251, '\P{^Is_CWCM=false}', "");
    Expect(1, 125252, '\p{Is_CWCM=_FALSE}', "");
    Expect(0, 125252, '\p{^Is_CWCM=_FALSE}', "");
    Expect(0, 125252, '\P{Is_CWCM=_FALSE}', "");
    Expect(1, 125252, '\P{^Is_CWCM=_FALSE}', "");
    Expect(0, 125251, '\p{Is_CWCM=_FALSE}', "");
    Expect(1, 125251, '\p{^Is_CWCM=_FALSE}', "");
    Expect(1, 125251, '\P{Is_CWCM=_FALSE}', "");
    Expect(0, 125251, '\P{^Is_CWCM=_FALSE}', "");
    Error('\p{Changes_When_Casemapped=/a/yes}');
    Error('\P{Changes_When_Casemapped=/a/yes}');
    Expect(1, 125251, '\p{Changes_When_Casemapped=:\AYes\z:}', "");;
    Expect(0, 125252, '\p{Changes_When_Casemapped=:\AYes\z:}', "");;
    Expect(1, 125251, '\p{Changes_When_Casemapped=yes}', "");
    Expect(0, 125251, '\p{^Changes_When_Casemapped=yes}', "");
    Expect(0, 125251, '\P{Changes_When_Casemapped=yes}', "");
    Expect(1, 125251, '\P{^Changes_When_Casemapped=yes}', "");
    Expect(0, 125252, '\p{Changes_When_Casemapped=yes}', "");
    Expect(1, 125252, '\p{^Changes_When_Casemapped=yes}', "");
    Expect(1, 125252, '\P{Changes_When_Casemapped=yes}', "");
    Expect(0, 125252, '\P{^Changes_When_Casemapped=yes}', "");
    Expect(1, 125251, '\p{Changes_When_Casemapped=:\Ayes\z:}', "");;
    Expect(0, 125252, '\p{Changes_When_Casemapped=:\Ayes\z:}', "");;
    Expect(1, 125251, '\p{Changes_When_Casemapped=__yes}', "");
    Expect(0, 125251, '\p{^Changes_When_Casemapped=__yes}', "");
    Expect(0, 125251, '\P{Changes_When_Casemapped=__yes}', "");
    Expect(1, 125251, '\P{^Changes_When_Casemapped=__yes}', "");
    Expect(0, 125252, '\p{Changes_When_Casemapped=__yes}', "");
    Expect(1, 125252, '\p{^Changes_When_Casemapped=__yes}', "");
    Expect(1, 125252, '\P{Changes_When_Casemapped=__yes}', "");
    Expect(0, 125252, '\P{^Changes_When_Casemapped=__yes}', "");
    Error('\p{CWCM=/a/__Y}');
    Error('\P{CWCM=/a/__Y}');
    Expect(1, 125251, '\p{CWCM=:\AY\z:}', "");;
    Expect(0, 125252, '\p{CWCM=:\AY\z:}', "");;
    Expect(1, 125251, '\p{CWCM=y}', "");
    Expect(0, 125251, '\p{^CWCM=y}', "");
    Expect(0, 125251, '\P{CWCM=y}', "");
    Expect(1, 125251, '\P{^CWCM=y}', "");
    Expect(0, 125252, '\p{CWCM=y}', "");
    Expect(1, 125252, '\p{^CWCM=y}', "");
    Expect(1, 125252, '\P{CWCM=y}', "");
    Expect(0, 125252, '\P{^CWCM=y}', "");
    Expect(1, 125251, '\p{CWCM=:\Ay\z:}', "");;
    Expect(0, 125252, '\p{CWCM=:\Ay\z:}', "");;
    Expect(1, 125251, '\p{CWCM= _y}', "");
    Expect(0, 125251, '\p{^CWCM= _y}', "");
    Expect(0, 125251, '\P{CWCM= _y}', "");
    Expect(1, 125251, '\P{^CWCM= _y}', "");
    Expect(0, 125252, '\p{CWCM= _y}', "");
    Expect(1, 125252, '\p{^CWCM= _y}', "");
    Expect(1, 125252, '\P{CWCM= _y}', "");
    Expect(0, 125252, '\P{^CWCM= _y}', "");
    Error('\p{Is_Changes_When_Casemapped=/a/-	T}');
    Error('\P{Is_Changes_When_Casemapped=/a/-	T}');
    Expect(1, 125251, '\p{Is_Changes_When_Casemapped=t}', "");
    Expect(0, 125251, '\p{^Is_Changes_When_Casemapped=t}', "");
    Expect(0, 125251, '\P{Is_Changes_When_Casemapped=t}', "");
    Expect(1, 125251, '\P{^Is_Changes_When_Casemapped=t}', "");
    Expect(0, 125252, '\p{Is_Changes_When_Casemapped=t}', "");
    Expect(1, 125252, '\p{^Is_Changes_When_Casemapped=t}', "");
    Expect(1, 125252, '\P{Is_Changes_When_Casemapped=t}', "");
    Expect(0, 125252, '\P{^Is_Changes_When_Casemapped=t}', "");
    Expect(1, 125251, '\p{Is_Changes_When_Casemapped: -_T}', "");
    Expect(0, 125251, '\p{^Is_Changes_When_Casemapped: -_T}', "");
    Expect(0, 125251, '\P{Is_Changes_When_Casemapped: -_T}', "");
    Expect(1, 125251, '\P{^Is_Changes_When_Casemapped: -_T}', "");
    Expect(0, 125252, '\p{Is_Changes_When_Casemapped: -_T}', "");
    Expect(1, 125252, '\p{^Is_Changes_When_Casemapped: -_T}', "");
    Expect(1, 125252, '\P{Is_Changes_When_Casemapped: -_T}', "");
    Expect(0, 125252, '\P{^Is_Changes_When_Casemapped: -_T}', "");
    Error('\p{Is_CWCM=/a/	 True}');
    Error('\P{Is_CWCM=/a/	 True}');
    Expect(1, 125251, '\p{Is_CWCM=true}', "");
    Expect(0, 125251, '\p{^Is_CWCM=true}', "");
    Expect(0, 125251, '\P{Is_CWCM=true}', "");
    Expect(1, 125251, '\P{^Is_CWCM=true}', "");
    Expect(0, 125252, '\p{Is_CWCM=true}', "");
    Expect(1, 125252, '\p{^Is_CWCM=true}', "");
    Expect(1, 125252, '\P{Is_CWCM=true}', "");
    Expect(0, 125252, '\P{^Is_CWCM=true}', "");
    Expect(1, 125251, '\p{Is_CWCM=-_True}', "");
    Expect(0, 125251, '\p{^Is_CWCM=-_True}', "");
    Expect(0, 125251, '\P{Is_CWCM=-_True}', "");
    Expect(1, 125251, '\P{^Is_CWCM=-_True}', "");
    Expect(0, 125252, '\p{Is_CWCM=-_True}', "");
    Expect(1, 125252, '\p{^Is_CWCM=-_True}', "");
    Expect(1, 125252, '\P{Is_CWCM=-_True}', "");
    Expect(0, 125252, '\P{^Is_CWCM=-_True}', "");
    Error('\p{Changes_When_NFKC_Casefolded=/a/No}');
    Error('\P{Changes_When_NFKC_Casefolded=/a/No}');
    Expect(1, 921600, '\p{Changes_When_NFKC_Casefolded=:\ANo\z:}', "");;
    Expect(0, 921599, '\p{Changes_When_NFKC_Casefolded=:\ANo\z:}', "");;
    Expect(1, 921600, '\p{Changes_When_NFKC_Casefolded=no}', "");
    Expect(0, 921600, '\p{^Changes_When_NFKC_Casefolded=no}', "");
    Expect(0, 921600, '\P{Changes_When_NFKC_Casefolded=no}', "");
    Expect(1, 921600, '\P{^Changes_When_NFKC_Casefolded=no}', "");
    Expect(0, 921599, '\p{Changes_When_NFKC_Casefolded=no}', "");
    Expect(1, 921599, '\p{^Changes_When_NFKC_Casefolded=no}', "");
    Expect(1, 921599, '\P{Changes_When_NFKC_Casefolded=no}', "");
    Expect(0, 921599, '\P{^Changes_When_NFKC_Casefolded=no}', "");
    Expect(1, 921600, '\p{Changes_When_NFKC_Casefolded=:\Ano\z:}', "");;
    Expect(0, 921599, '\p{Changes_When_NFKC_Casefolded=:\Ano\z:}', "");;
    Expect(1, 921600, '\p{Changes_When_NFKC_Casefolded: No}', "");
    Expect(0, 921600, '\p{^Changes_When_NFKC_Casefolded: No}', "");
    Expect(0, 921600, '\P{Changes_When_NFKC_Casefolded: No}', "");
    Expect(1, 921600, '\P{^Changes_When_NFKC_Casefolded: No}', "");
    Expect(0, 921599, '\p{Changes_When_NFKC_Casefolded: No}', "");
    Expect(1, 921599, '\p{^Changes_When_NFKC_Casefolded: No}', "");
    Expect(1, 921599, '\P{Changes_When_NFKC_Casefolded: No}', "");
    Expect(0, 921599, '\P{^Changes_When_NFKC_Casefolded: No}', "");
    Error('\p{CWKCF=	N:=}');
    Error('\P{CWKCF=	N:=}');
    Expect(1, 921600, '\p{CWKCF=:\AN\z:}', "");;
    Expect(0, 921599, '\p{CWKCF=:\AN\z:}', "");;
    Expect(1, 921600, '\p{CWKCF=n}', "");
    Expect(0, 921600, '\p{^CWKCF=n}', "");
    Expect(0, 921600, '\P{CWKCF=n}', "");
    Expect(1, 921600, '\P{^CWKCF=n}', "");
    Expect(0, 921599, '\p{CWKCF=n}', "");
    Expect(1, 921599, '\p{^CWKCF=n}', "");
    Expect(1, 921599, '\P{CWKCF=n}', "");
    Expect(0, 921599, '\P{^CWKCF=n}', "");
    Expect(1, 921600, '\p{CWKCF=:\An\z:}', "");;
    Expect(0, 921599, '\p{CWKCF=:\An\z:}', "");;
    Expect(1, 921600, '\p{CWKCF= -N}', "");
    Expect(0, 921600, '\p{^CWKCF= -N}', "");
    Expect(0, 921600, '\P{CWKCF= -N}', "");
    Expect(1, 921600, '\P{^CWKCF= -N}', "");
    Expect(0, 921599, '\p{CWKCF= -N}', "");
    Expect(1, 921599, '\p{^CWKCF= -N}', "");
    Expect(1, 921599, '\P{CWKCF= -N}', "");
    Expect(0, 921599, '\P{^CWKCF= -N}', "");
    Error('\p{Is_Changes_When_NFKC_Casefolded= /a/f}');
    Error('\P{Is_Changes_When_NFKC_Casefolded= /a/f}');
    Expect(1, 921600, '\p{Is_Changes_When_NFKC_Casefolded: f}', "");
    Expect(0, 921600, '\p{^Is_Changes_When_NFKC_Casefolded: f}', "");
    Expect(0, 921600, '\P{Is_Changes_When_NFKC_Casefolded: f}', "");
    Expect(1, 921600, '\P{^Is_Changes_When_NFKC_Casefolded: f}', "");
    Expect(0, 921599, '\p{Is_Changes_When_NFKC_Casefolded: f}', "");
    Expect(1, 921599, '\p{^Is_Changes_When_NFKC_Casefolded: f}', "");
    Expect(1, 921599, '\P{Is_Changes_When_NFKC_Casefolded: f}', "");
    Expect(0, 921599, '\P{^Is_Changes_When_NFKC_Casefolded: f}', "");
    Expect(1, 921600, '\p{Is_Changes_When_NFKC_Casefolded:	_	F}', "");
    Expect(0, 921600, '\p{^Is_Changes_When_NFKC_Casefolded:	_	F}', "");
    Expect(0, 921600, '\P{Is_Changes_When_NFKC_Casefolded:	_	F}', "");
    Expect(1, 921600, '\P{^Is_Changes_When_NFKC_Casefolded:	_	F}', "");
    Expect(0, 921599, '\p{Is_Changes_When_NFKC_Casefolded:	_	F}', "");
    Expect(1, 921599, '\p{^Is_Changes_When_NFKC_Casefolded:	_	F}', "");
    Expect(1, 921599, '\P{Is_Changes_When_NFKC_Casefolded:	_	F}', "");
    Expect(0, 921599, '\P{^Is_Changes_When_NFKC_Casefolded:	_	F}', "");
    Error('\p{Is_CWKCF= /a/False}');
    Error('\P{Is_CWKCF= /a/False}');
    Expect(1, 921600, '\p{Is_CWKCF: false}', "");
    Expect(0, 921600, '\p{^Is_CWKCF: false}', "");
    Expect(0, 921600, '\P{Is_CWKCF: false}', "");
    Expect(1, 921600, '\P{^Is_CWKCF: false}', "");
    Expect(0, 921599, '\p{Is_CWKCF: false}', "");
    Expect(1, 921599, '\p{^Is_CWKCF: false}', "");
    Expect(1, 921599, '\P{Is_CWKCF: false}', "");
    Expect(0, 921599, '\P{^Is_CWKCF: false}', "");
    Expect(1, 921600, '\p{Is_CWKCF:__False}', "");
    Expect(0, 921600, '\p{^Is_CWKCF:__False}', "");
    Expect(0, 921600, '\P{Is_CWKCF:__False}', "");
    Expect(1, 921600, '\P{^Is_CWKCF:__False}', "");
    Expect(0, 921599, '\p{Is_CWKCF:__False}', "");
    Expect(1, 921599, '\p{^Is_CWKCF:__False}', "");
    Expect(1, 921599, '\P{Is_CWKCF:__False}', "");
    Expect(0, 921599, '\P{^Is_CWKCF:__False}', "");
    Error('\p{Changes_When_NFKC_Casefolded=/a/ _Yes}');
    Error('\P{Changes_When_NFKC_Casefolded=/a/ _Yes}');
    Expect(1, 921599, '\p{Changes_When_NFKC_Casefolded=:\AYes\z:}', "");;
    Expect(0, 921600, '\p{Changes_When_NFKC_Casefolded=:\AYes\z:}', "");;
    Expect(1, 921599, '\p{Changes_When_NFKC_Casefolded=yes}', "");
    Expect(0, 921599, '\p{^Changes_When_NFKC_Casefolded=yes}', "");
    Expect(0, 921599, '\P{Changes_When_NFKC_Casefolded=yes}', "");
    Expect(1, 921599, '\P{^Changes_When_NFKC_Casefolded=yes}', "");
    Expect(0, 921600, '\p{Changes_When_NFKC_Casefolded=yes}', "");
    Expect(1, 921600, '\p{^Changes_When_NFKC_Casefolded=yes}', "");
    Expect(1, 921600, '\P{Changes_When_NFKC_Casefolded=yes}', "");
    Expect(0, 921600, '\P{^Changes_When_NFKC_Casefolded=yes}', "");
    Expect(1, 921599, '\p{Changes_When_NFKC_Casefolded=:\Ayes\z:}', "");;
    Expect(0, 921600, '\p{Changes_When_NFKC_Casefolded=:\Ayes\z:}', "");;
    Expect(1, 921599, '\p{Changes_When_NFKC_Casefolded=_-Yes}', "");
    Expect(0, 921599, '\p{^Changes_When_NFKC_Casefolded=_-Yes}', "");
    Expect(0, 921599, '\P{Changes_When_NFKC_Casefolded=_-Yes}', "");
    Expect(1, 921599, '\P{^Changes_When_NFKC_Casefolded=_-Yes}', "");
    Expect(0, 921600, '\p{Changes_When_NFKC_Casefolded=_-Yes}', "");
    Expect(1, 921600, '\p{^Changes_When_NFKC_Casefolded=_-Yes}', "");
    Expect(1, 921600, '\P{Changes_When_NFKC_Casefolded=_-Yes}', "");
    Expect(0, 921600, '\P{^Changes_When_NFKC_Casefolded=_-Yes}', "");
    Error('\p{CWKCF:	_Y:=}');
    Error('\P{CWKCF:	_Y:=}');
    Expect(1, 921599, '\p{CWKCF=:\AY\z:}', "");;
    Expect(0, 921600, '\p{CWKCF=:\AY\z:}', "");;
    Expect(1, 921599, '\p{CWKCF=y}', "");
    Expect(0, 921599, '\p{^CWKCF=y}', "");
    Expect(0, 921599, '\P{CWKCF=y}', "");
    Expect(1, 921599, '\P{^CWKCF=y}', "");
    Expect(0, 921600, '\p{CWKCF=y}', "");
    Expect(1, 921600, '\p{^CWKCF=y}', "");
    Expect(1, 921600, '\P{CWKCF=y}', "");
    Expect(0, 921600, '\P{^CWKCF=y}', "");
    Expect(1, 921599, '\p{CWKCF=:\Ay\z:}', "");;
    Expect(0, 921600, '\p{CWKCF=:\Ay\z:}', "");;
    Expect(1, 921599, '\p{CWKCF= Y}', "");
    Expect(0, 921599, '\p{^CWKCF= Y}', "");
    Expect(0, 921599, '\P{CWKCF= Y}', "");
    Expect(1, 921599, '\P{^CWKCF= Y}', "");
    Expect(0, 921600, '\p{CWKCF= Y}', "");
    Expect(1, 921600, '\p{^CWKCF= Y}', "");
    Expect(1, 921600, '\P{CWKCF= Y}', "");
    Expect(0, 921600, '\P{^CWKCF= Y}', "");
    Error('\p{Is_Changes_When_NFKC_Casefolded=- T:=}');
    Error('\P{Is_Changes_When_NFKC_Casefolded=- T:=}');
    Expect(1, 921599, '\p{Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(0, 921599, '\p{^Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(0, 921599, '\P{Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(1, 921599, '\P{^Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(0, 921600, '\p{Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(1, 921600, '\p{^Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(1, 921600, '\P{Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(0, 921600, '\P{^Is_Changes_When_NFKC_Casefolded=t}', "");
    Expect(1, 921599, '\p{Is_Changes_When_NFKC_Casefolded=  T}', "");
    Expect(0, 921599, '\p{^Is_Changes_When_NFKC_Casefolded=  T}', "");
    Expect(0, 921599, '\P{Is_Changes_When_NFKC_Casefolded=  T}', "");
    Expect(1, 921599, '\P{^Is_Changes_When_NFKC_Casefolded=  T}', "");
    Expect(0, 921600, '\p{Is_Changes_When_NFKC_Casefolded=  T}', "");
    Expect(1, 921600, '\p{^Is_Changes_When_NFKC_Casefolded=  T}', "");
    Expect(1, 921600, '\P{Is_Changes_When_NFKC_Casefolded=  T}', "");
    Expect(0, 921600, '\P{^Is_Changes_When_NFKC_Casefolded=  T}', "");
    Error('\p{Is_CWKCF=/a/True}');
    Error('\P{Is_CWKCF=/a/True}');
    Expect(1, 921599, '\p{Is_CWKCF=true}', "");
    Expect(0, 921599, '\p{^Is_CWKCF=true}', "");
    Expect(0, 921599, '\P{Is_CWKCF=true}', "");
    Expect(1, 921599, '\P{^Is_CWKCF=true}', "");
    Expect(0, 921600, '\p{Is_CWKCF=true}', "");
    Expect(1, 921600, '\p{^Is_CWKCF=true}', "");
    Expect(1, 921600, '\P{Is_CWKCF=true}', "");
    Expect(0, 921600, '\P{^Is_CWKCF=true}', "");
    Expect(1, 921599, '\p{Is_CWKCF=-True}', "");
    Expect(0, 921599, '\p{^Is_CWKCF=-True}', "");
    Expect(0, 921599, '\P{Is_CWKCF=-True}', "");
    Expect(1, 921599, '\P{^Is_CWKCF=-True}', "");
    Expect(0, 921600, '\p{Is_CWKCF=-True}', "");
    Expect(1, 921600, '\p{^Is_CWKCF=-True}', "");
    Expect(1, 921600, '\P{Is_CWKCF=-True}', "");
    Expect(0, 921600, '\P{^Is_CWKCF=-True}', "");
    Error('\p{Changes_When_Lowercased=:=-	No}');
    Error('\P{Changes_When_Lowercased=:=-	No}');
    Expect(1, 125218, '\p{Changes_When_Lowercased=:\ANo\z:}', "");;
    Expect(0, 125217, '\p{Changes_When_Lowercased=:\ANo\z:}', "");;
    Expect(1, 125218, '\p{Changes_When_Lowercased=no}', "");
    Expect(0, 125218, '\p{^Changes_When_Lowercased=no}', "");
    Expect(0, 125218, '\P{Changes_When_Lowercased=no}', "");
    Expect(1, 125218, '\P{^Changes_When_Lowercased=no}', "");
    Expect(0, 125217, '\p{Changes_When_Lowercased=no}', "");
    Expect(1, 125217, '\p{^Changes_When_Lowercased=no}', "");
    Expect(1, 125217, '\P{Changes_When_Lowercased=no}', "");
    Expect(0, 125217, '\P{^Changes_When_Lowercased=no}', "");
    Expect(1, 125218, '\p{Changes_When_Lowercased=:\Ano\z:}', "");;
    Expect(0, 125217, '\p{Changes_When_Lowercased=:\Ano\z:}', "");;
    Error('\p{CWL:  n:=}');
    Error('\P{CWL:  n:=}');
    Expect(1, 125218, '\p{CWL=:\AN\z:}', "");;
    Expect(0, 125217, '\p{CWL=:\AN\z:}', "");;
    Expect(1, 125218, '\p{CWL=n}', "");
    Expect(0, 125218, '\p{^CWL=n}', "");
    Expect(0, 125218, '\P{CWL=n}', "");
    Expect(1, 125218, '\P{^CWL=n}', "");
    Expect(0, 125217, '\p{CWL=n}', "");
    Expect(1, 125217, '\p{^CWL=n}', "");
    Expect(1, 125217, '\P{CWL=n}', "");
    Expect(0, 125217, '\P{^CWL=n}', "");
    Expect(1, 125218, '\p{CWL=:\An\z:}', "");;
    Expect(0, 125217, '\p{CWL=:\An\z:}', "");;
    Expect(1, 125218, '\p{CWL=	N}', "");
    Expect(0, 125218, '\p{^CWL=	N}', "");
    Expect(0, 125218, '\P{CWL=	N}', "");
    Expect(1, 125218, '\P{^CWL=	N}', "");
    Expect(0, 125217, '\p{CWL=	N}', "");
    Expect(1, 125217, '\p{^CWL=	N}', "");
    Expect(1, 125217, '\P{CWL=	N}', "");
    Expect(0, 125217, '\P{^CWL=	N}', "");
    Error('\p{Is_Changes_When_Lowercased= f/a/}');
    Error('\P{Is_Changes_When_Lowercased= f/a/}');
    Expect(1, 125218, '\p{Is_Changes_When_Lowercased=f}', "");
    Expect(0, 125218, '\p{^Is_Changes_When_Lowercased=f}', "");
    Expect(0, 125218, '\P{Is_Changes_When_Lowercased=f}', "");
    Expect(1, 125218, '\P{^Is_Changes_When_Lowercased=f}', "");
    Expect(0, 125217, '\p{Is_Changes_When_Lowercased=f}', "");
    Expect(1, 125217, '\p{^Is_Changes_When_Lowercased=f}', "");
    Expect(1, 125217, '\P{Is_Changes_When_Lowercased=f}', "");
    Expect(0, 125217, '\P{^Is_Changes_When_Lowercased=f}', "");
    Expect(1, 125218, '\p{Is_Changes_When_Lowercased=	 F}', "");
    Expect(0, 125218, '\p{^Is_Changes_When_Lowercased=	 F}', "");
    Expect(0, 125218, '\P{Is_Changes_When_Lowercased=	 F}', "");
    Expect(1, 125218, '\P{^Is_Changes_When_Lowercased=	 F}', "");
    Expect(0, 125217, '\p{Is_Changes_When_Lowercased=	 F}', "");
    Expect(1, 125217, '\p{^Is_Changes_When_Lowercased=	 F}', "");
    Expect(1, 125217, '\P{Is_Changes_When_Lowercased=	 F}', "");
    Expect(0, 125217, '\P{^Is_Changes_When_Lowercased=	 F}', "");
    Error('\p{Is_CWL= :=False}');
    Error('\P{Is_CWL= :=False}');
    Expect(1, 125218, '\p{Is_CWL=false}', "");
    Expect(0, 125218, '\p{^Is_CWL=false}', "");
    Expect(0, 125218, '\P{Is_CWL=false}', "");
    Expect(1, 125218, '\P{^Is_CWL=false}', "");
    Expect(0, 125217, '\p{Is_CWL=false}', "");
    Expect(1, 125217, '\p{^Is_CWL=false}', "");
    Expect(1, 125217, '\P{Is_CWL=false}', "");
    Expect(0, 125217, '\P{^Is_CWL=false}', "");
    Expect(1, 125218, '\p{Is_CWL=-False}', "");
    Expect(0, 125218, '\p{^Is_CWL=-False}', "");
    Expect(0, 125218, '\P{Is_CWL=-False}', "");
    Expect(1, 125218, '\P{^Is_CWL=-False}', "");
    Expect(0, 125217, '\p{Is_CWL=-False}', "");
    Expect(1, 125217, '\p{^Is_CWL=-False}', "");
    Expect(1, 125217, '\P{Is_CWL=-False}', "");
    Expect(0, 125217, '\P{^Is_CWL=-False}', "");
    Error('\p{Changes_When_Lowercased=/a/Yes}');
    Error('\P{Changes_When_Lowercased=/a/Yes}');
    Expect(1, 125217, '\p{Changes_When_Lowercased=:\AYes\z:}', "");;
    Expect(0, 125218, '\p{Changes_When_Lowercased=:\AYes\z:}', "");;
    Expect(1, 125217, '\p{Changes_When_Lowercased=yes}', "");
    Expect(0, 125217, '\p{^Changes_When_Lowercased=yes}', "");
    Expect(0, 125217, '\P{Changes_When_Lowercased=yes}', "");
    Expect(1, 125217, '\P{^Changes_When_Lowercased=yes}', "");
    Expect(0, 125218, '\p{Changes_When_Lowercased=yes}', "");
    Expect(1, 125218, '\p{^Changes_When_Lowercased=yes}', "");
    Expect(1, 125218, '\P{Changes_When_Lowercased=yes}', "");
    Expect(0, 125218, '\P{^Changes_When_Lowercased=yes}', "");
    Expect(1, 125217, '\p{Changes_When_Lowercased=:\Ayes\z:}', "");;
    Expect(0, 125218, '\p{Changes_When_Lowercased=:\Ayes\z:}', "");;
    Expect(1, 125217, '\p{Changes_When_Lowercased=_	YES}', "");
    Expect(0, 125217, '\p{^Changes_When_Lowercased=_	YES}', "");
    Expect(0, 125217, '\P{Changes_When_Lowercased=_	YES}', "");
    Expect(1, 125217, '\P{^Changes_When_Lowercased=_	YES}', "");
    Expect(0, 125218, '\p{Changes_When_Lowercased=_	YES}', "");
    Expect(1, 125218, '\p{^Changes_When_Lowercased=_	YES}', "");
    Expect(1, 125218, '\P{Changes_When_Lowercased=_	YES}', "");
    Expect(0, 125218, '\P{^Changes_When_Lowercased=_	YES}', "");
    Error('\p{CWL:	_/a/y}');
    Error('\P{CWL:	_/a/y}');
    Expect(1, 125217, '\p{CWL=:\AY\z:}', "");;
    Expect(0, 125218, '\p{CWL=:\AY\z:}', "");;
    Expect(1, 125217, '\p{CWL=y}', "");
    Expect(0, 125217, '\p{^CWL=y}', "");
    Expect(0, 125217, '\P{CWL=y}', "");
    Expect(1, 125217, '\P{^CWL=y}', "");
    Expect(0, 125218, '\p{CWL=y}', "");
    Expect(1, 125218, '\p{^CWL=y}', "");
    Expect(1, 125218, '\P{CWL=y}', "");
    Expect(0, 125218, '\P{^CWL=y}', "");
    Expect(1, 125217, '\p{CWL=:\Ay\z:}', "");;
    Expect(0, 125218, '\p{CWL=:\Ay\z:}', "");;
    Expect(1, 125217, '\p{CWL: -Y}', "");
    Expect(0, 125217, '\p{^CWL: -Y}', "");
    Expect(0, 125217, '\P{CWL: -Y}', "");
    Expect(1, 125217, '\P{^CWL: -Y}', "");
    Expect(0, 125218, '\p{CWL: -Y}', "");
    Expect(1, 125218, '\p{^CWL: -Y}', "");
    Expect(1, 125218, '\P{CWL: -Y}', "");
    Expect(0, 125218, '\P{^CWL: -Y}', "");
    Error('\p{Is_Changes_When_Lowercased=:= 	T}');
    Error('\P{Is_Changes_When_Lowercased=:= 	T}');
    Expect(1, 125217, '\p{Is_Changes_When_Lowercased=t}', "");
    Expect(0, 125217, '\p{^Is_Changes_When_Lowercased=t}', "");
    Expect(0, 125217, '\P{Is_Changes_When_Lowercased=t}', "");
    Expect(1, 125217, '\P{^Is_Changes_When_Lowercased=t}', "");
    Expect(0, 125218, '\p{Is_Changes_When_Lowercased=t}', "");
    Expect(1, 125218, '\p{^Is_Changes_When_Lowercased=t}', "");
    Expect(1, 125218, '\P{Is_Changes_When_Lowercased=t}', "");
    Expect(0, 125218, '\P{^Is_Changes_When_Lowercased=t}', "");
    Expect(1, 125217, '\p{Is_Changes_When_Lowercased=-T}', "");
    Expect(0, 125217, '\p{^Is_Changes_When_Lowercased=-T}', "");
    Expect(0, 125217, '\P{Is_Changes_When_Lowercased=-T}', "");
    Expect(1, 125217, '\P{^Is_Changes_When_Lowercased=-T}', "");
    Expect(0, 125218, '\p{Is_Changes_When_Lowercased=-T}', "");
    Expect(1, 125218, '\p{^Is_Changes_When_Lowercased=-T}', "");
    Expect(1, 125218, '\P{Is_Changes_When_Lowercased=-T}', "");
    Expect(0, 125218, '\P{^Is_Changes_When_Lowercased=-T}', "");
    Error('\p{Is_CWL=:=true}');
    Error('\P{Is_CWL=:=true}');
    Expect(1, 125217, '\p{Is_CWL=true}', "");
    Expect(0, 125217, '\p{^Is_CWL=true}', "");
    Expect(0, 125217, '\P{Is_CWL=true}', "");
    Expect(1, 125217, '\P{^Is_CWL=true}', "");
    Expect(0, 125218, '\p{Is_CWL=true}', "");
    Expect(1, 125218, '\p{^Is_CWL=true}', "");
    Expect(1, 125218, '\P{Is_CWL=true}', "");
    Expect(0, 125218, '\P{^Is_CWL=true}', "");
    Expect(1, 125217, '\p{Is_CWL=_True}', "");
    Expect(0, 125217, '\p{^Is_CWL=_True}', "");
    Expect(0, 125217, '\P{Is_CWL=_True}', "");
    Expect(1, 125217, '\P{^Is_CWL=_True}', "");
    Expect(0, 125218, '\p{Is_CWL=_True}', "");
    Expect(1, 125218, '\p{^Is_CWL=_True}', "");
    Expect(1, 125218, '\P{Is_CWL=_True}', "");
    Expect(0, 125218, '\P{^Is_CWL=_True}', "");
    Error('\p{Changes_When_Titlecased=-:=No}');
    Error('\P{Changes_When_Titlecased=-:=No}');
    Expect(1, 125252, '\p{Changes_When_Titlecased=:\ANo\z:}', "");;
    Expect(0, 125251, '\p{Changes_When_Titlecased=:\ANo\z:}', "");;
    Expect(1, 125252, '\p{Changes_When_Titlecased=no}', "");
    Expect(0, 125252, '\p{^Changes_When_Titlecased=no}', "");
    Expect(0, 125252, '\P{Changes_When_Titlecased=no}', "");
    Expect(1, 125252, '\P{^Changes_When_Titlecased=no}', "");
    Expect(0, 125251, '\p{Changes_When_Titlecased=no}', "");
    Expect(1, 125251, '\p{^Changes_When_Titlecased=no}', "");
    Expect(1, 125251, '\P{Changes_When_Titlecased=no}', "");
    Expect(0, 125251, '\P{^Changes_When_Titlecased=no}', "");
    Expect(1, 125252, '\p{Changes_When_Titlecased=:\Ano\z:}', "");;
    Expect(0, 125251, '\p{Changes_When_Titlecased=:\Ano\z:}', "");;
    Expect(1, 125252, '\p{Changes_When_Titlecased=	_no}', "");
    Expect(0, 125252, '\p{^Changes_When_Titlecased=	_no}', "");
    Expect(0, 125252, '\P{Changes_When_Titlecased=	_no}', "");
    Expect(1, 125252, '\P{^Changes_When_Titlecased=	_no}', "");
    Expect(0, 125251, '\p{Changes_When_Titlecased=	_no}', "");
    Expect(1, 125251, '\p{^Changes_When_Titlecased=	_no}', "");
    Expect(1, 125251, '\P{Changes_When_Titlecased=	_no}', "");
    Expect(0, 125251, '\P{^Changes_When_Titlecased=	_no}', "");
    Error('\p{CWT=:=	 N}');
    Error('\P{CWT=:=	 N}');
    Expect(1, 125252, '\p{CWT=:\AN\z:}', "");;
    Expect(0, 125251, '\p{CWT=:\AN\z:}', "");;
    Expect(1, 125252, '\p{CWT=n}', "");
    Expect(0, 125252, '\p{^CWT=n}', "");
    Expect(0, 125252, '\P{CWT=n}', "");
    Expect(1, 125252, '\P{^CWT=n}', "");
    Expect(0, 125251, '\p{CWT=n}', "");
    Expect(1, 125251, '\p{^CWT=n}', "");
    Expect(1, 125251, '\P{CWT=n}', "");
    Expect(0, 125251, '\P{^CWT=n}', "");
    Expect(1, 125252, '\p{CWT=:\An\z:}', "");;
    Expect(0, 125251, '\p{CWT=:\An\z:}', "");;
    Expect(1, 125252, '\p{CWT=	N}', "");
    Expect(0, 125252, '\p{^CWT=	N}', "");
    Expect(0, 125252, '\P{CWT=	N}', "");
    Expect(1, 125252, '\P{^CWT=	N}', "");
    Expect(0, 125251, '\p{CWT=	N}', "");
    Expect(1, 125251, '\p{^CWT=	N}', "");
    Expect(1, 125251, '\P{CWT=	N}', "");
    Expect(0, 125251, '\P{^CWT=	N}', "");
    Error('\p{Is_Changes_When_Titlecased=/a/ f}');
    Error('\P{Is_Changes_When_Titlecased=/a/ f}');
    Expect(1, 125252, '\p{Is_Changes_When_Titlecased: f}', "");
    Expect(0, 125252, '\p{^Is_Changes_When_Titlecased: f}', "");
    Expect(0, 125252, '\P{Is_Changes_When_Titlecased: f}', "");
    Expect(1, 125252, '\P{^Is_Changes_When_Titlecased: f}', "");
    Expect(0, 125251, '\p{Is_Changes_When_Titlecased: f}', "");
    Expect(1, 125251, '\p{^Is_Changes_When_Titlecased: f}', "");
    Expect(1, 125251, '\P{Is_Changes_When_Titlecased: f}', "");
    Expect(0, 125251, '\P{^Is_Changes_When_Titlecased: f}', "");
    Expect(1, 125252, '\p{Is_Changes_When_Titlecased=	 F}', "");
    Expect(0, 125252, '\p{^Is_Changes_When_Titlecased=	 F}', "");
    Expect(0, 125252, '\P{Is_Changes_When_Titlecased=	 F}', "");
    Expect(1, 125252, '\P{^Is_Changes_When_Titlecased=	 F}', "");
    Expect(0, 125251, '\p{Is_Changes_When_Titlecased=	 F}', "");
    Expect(1, 125251, '\p{^Is_Changes_When_Titlecased=	 F}', "");
    Expect(1, 125251, '\P{Is_Changes_When_Titlecased=	 F}', "");
    Expect(0, 125251, '\P{^Is_Changes_When_Titlecased=	 F}', "");
    Error('\p{Is_CWT=_FALSE/a/}');
    Error('\P{Is_CWT=_FALSE/a/}');
    Expect(1, 125252, '\p{Is_CWT=false}', "");
    Expect(0, 125252, '\p{^Is_CWT=false}', "");
    Expect(0, 125252, '\P{Is_CWT=false}', "");
    Expect(1, 125252, '\P{^Is_CWT=false}', "");
    Expect(0, 125251, '\p{Is_CWT=false}', "");
    Expect(1, 125251, '\p{^Is_CWT=false}', "");
    Expect(1, 125251, '\P{Is_CWT=false}', "");
    Expect(0, 125251, '\P{^Is_CWT=false}', "");
    Expect(1, 125252, '\p{Is_CWT= False}', "");
    Expect(0, 125252, '\p{^Is_CWT= False}', "");
    Expect(0, 125252, '\P{Is_CWT= False}', "");
    Expect(1, 125252, '\P{^Is_CWT= False}', "");
    Expect(0, 125251, '\p{Is_CWT= False}', "");
    Expect(1, 125251, '\p{^Is_CWT= False}', "");
    Expect(1, 125251, '\P{Is_CWT= False}', "");
    Expect(0, 125251, '\P{^Is_CWT= False}', "");
    Error('\p{Changes_When_Titlecased=__yes:=}');
    Error('\P{Changes_When_Titlecased=__yes:=}');
    Expect(1, 125251, '\p{Changes_When_Titlecased=:\AYes\z:}', "");;
    Expect(0, 125252, '\p{Changes_When_Titlecased=:\AYes\z:}', "");;
    Expect(1, 125251, '\p{Changes_When_Titlecased=yes}', "");
    Expect(0, 125251, '\p{^Changes_When_Titlecased=yes}', "");
    Expect(0, 125251, '\P{Changes_When_Titlecased=yes}', "");
    Expect(1, 125251, '\P{^Changes_When_Titlecased=yes}', "");
    Expect(0, 125252, '\p{Changes_When_Titlecased=yes}', "");
    Expect(1, 125252, '\p{^Changes_When_Titlecased=yes}', "");
    Expect(1, 125252, '\P{Changes_When_Titlecased=yes}', "");
    Expect(0, 125252, '\P{^Changes_When_Titlecased=yes}', "");
    Expect(1, 125251, '\p{Changes_When_Titlecased=:\Ayes\z:}', "");;
    Expect(0, 125252, '\p{Changes_When_Titlecased=:\Ayes\z:}', "");;
    Expect(1, 125251, '\p{Changes_When_Titlecased=- yes}', "");
    Expect(0, 125251, '\p{^Changes_When_Titlecased=- yes}', "");
    Expect(0, 125251, '\P{Changes_When_Titlecased=- yes}', "");
    Expect(1, 125251, '\P{^Changes_When_Titlecased=- yes}', "");
    Expect(0, 125252, '\p{Changes_When_Titlecased=- yes}', "");
    Expect(1, 125252, '\p{^Changes_When_Titlecased=- yes}', "");
    Expect(1, 125252, '\P{Changes_When_Titlecased=- yes}', "");
    Expect(0, 125252, '\P{^Changes_When_Titlecased=- yes}', "");
    Error('\p{CWT=/a/		Y}');
    Error('\P{CWT=/a/		Y}');
    Expect(1, 125251, '\p{CWT=:\AY\z:}', "");;
    Expect(0, 125252, '\p{CWT=:\AY\z:}', "");;
    Expect(1, 125251, '\p{CWT=y}', "");
    Expect(0, 125251, '\p{^CWT=y}', "");
    Expect(0, 125251, '\P{CWT=y}', "");
    Expect(1, 125251, '\P{^CWT=y}', "");
    Expect(0, 125252, '\p{CWT=y}', "");
    Expect(1, 125252, '\p{^CWT=y}', "");
    Expect(1, 125252, '\P{CWT=y}', "");
    Expect(0, 125252, '\P{^CWT=y}', "");
    Expect(1, 125251, '\p{CWT=:\Ay\z:}', "");;
    Expect(0, 125252, '\p{CWT=:\Ay\z:}', "");;
    Expect(1, 125251, '\p{CWT=_-Y}', "");
    Expect(0, 125251, '\p{^CWT=_-Y}', "");
    Expect(0, 125251, '\P{CWT=_-Y}', "");
    Expect(1, 125251, '\P{^CWT=_-Y}', "");
    Expect(0, 125252, '\p{CWT=_-Y}', "");
    Expect(1, 125252, '\p{^CWT=_-Y}', "");
    Expect(1, 125252, '\P{CWT=_-Y}', "");
    Expect(0, 125252, '\P{^CWT=_-Y}', "");
    Error('\p{Is_Changes_When_Titlecased=:= _T}');
    Error('\P{Is_Changes_When_Titlecased=:= _T}');
    Expect(1, 125251, '\p{Is_Changes_When_Titlecased=t}', "");
    Expect(0, 125251, '\p{^Is_Changes_When_Titlecased=t}', "");
    Expect(0, 125251, '\P{Is_Changes_When_Titlecased=t}', "");
    Expect(1, 125251, '\P{^Is_Changes_When_Titlecased=t}', "");
    Expect(0, 125252, '\p{Is_Changes_When_Titlecased=t}', "");
    Expect(1, 125252, '\p{^Is_Changes_When_Titlecased=t}', "");
    Expect(1, 125252, '\P{Is_Changes_When_Titlecased=t}', "");
    Expect(0, 125252, '\P{^Is_Changes_When_Titlecased=t}', "");
    Expect(1, 125251, '\p{Is_Changes_When_Titlecased=		T}', "");
    Expect(0, 125251, '\p{^Is_Changes_When_Titlecased=		T}', "");
    Expect(0, 125251, '\P{Is_Changes_When_Titlecased=		T}', "");
    Expect(1, 125251, '\P{^Is_Changes_When_Titlecased=		T}', "");
    Expect(0, 125252, '\p{Is_Changes_When_Titlecased=		T}', "");
    Expect(1, 125252, '\p{^Is_Changes_When_Titlecased=		T}', "");
    Expect(1, 125252, '\P{Is_Changes_When_Titlecased=		T}', "");
    Expect(0, 125252, '\P{^Is_Changes_When_Titlecased=		T}', "");
    Error('\p{Is_CWT=TRUE/a/}');
    Error('\P{Is_CWT=TRUE/a/}');
    Expect(1, 125251, '\p{Is_CWT=true}', "");
    Expect(0, 125251, '\p{^Is_CWT=true}', "");
    Expect(0, 125251, '\P{Is_CWT=true}', "");
    Expect(1, 125251, '\P{^Is_CWT=true}', "");
    Expect(0, 125252, '\p{Is_CWT=true}', "");
    Expect(1, 125252, '\p{^Is_CWT=true}', "");
    Expect(1, 125252, '\P{Is_CWT=true}', "");
    Expect(0, 125252, '\P{^Is_CWT=true}', "");
    Expect(1, 125251, '\p{Is_CWT=-True}', "");
    Expect(0, 125251, '\p{^Is_CWT=-True}', "");
    Expect(0, 125251, '\P{Is_CWT=-True}', "");
    Expect(1, 125251, '\P{^Is_CWT=-True}', "");
    Expect(0, 125252, '\p{Is_CWT=-True}', "");
    Expect(1, 125252, '\p{^Is_CWT=-True}', "");
    Expect(1, 125252, '\P{Is_CWT=-True}', "");
    Expect(0, 125252, '\P{^Is_CWT=-True}', "");
    Error('\p{Changes_When_Uppercased=:=- No}');
    Error('\P{Changes_When_Uppercased=:=- No}');
    Expect(1, 125252, '\p{Changes_When_Uppercased=:\ANo\z:}', "");;
    Expect(0, 125251, '\p{Changes_When_Uppercased=:\ANo\z:}', "");;
    Expect(1, 125252, '\p{Changes_When_Uppercased=no}', "");
    Expect(0, 125252, '\p{^Changes_When_Uppercased=no}', "");
    Expect(0, 125252, '\P{Changes_When_Uppercased=no}', "");
    Expect(1, 125252, '\P{^Changes_When_Uppercased=no}', "");
    Expect(0, 125251, '\p{Changes_When_Uppercased=no}', "");
    Expect(1, 125251, '\p{^Changes_When_Uppercased=no}', "");
    Expect(1, 125251, '\P{Changes_When_Uppercased=no}', "");
    Expect(0, 125251, '\P{^Changes_When_Uppercased=no}', "");
    Expect(1, 125252, '\p{Changes_When_Uppercased=:\Ano\z:}', "");;
    Expect(0, 125251, '\p{Changes_When_Uppercased=:\Ano\z:}', "");;
    Expect(1, 125252, '\p{Changes_When_Uppercased=-No}', "");
    Expect(0, 125252, '\p{^Changes_When_Uppercased=-No}', "");
    Expect(0, 125252, '\P{Changes_When_Uppercased=-No}', "");
    Expect(1, 125252, '\P{^Changes_When_Uppercased=-No}', "");
    Expect(0, 125251, '\p{Changes_When_Uppercased=-No}', "");
    Expect(1, 125251, '\p{^Changes_When_Uppercased=-No}', "");
    Expect(1, 125251, '\P{Changes_When_Uppercased=-No}', "");
    Expect(0, 125251, '\P{^Changes_When_Uppercased=-No}', "");
    Error('\p{CWU=:=N}');
    Error('\P{CWU=:=N}');
    Expect(1, 125252, '\p{CWU=:\AN\z:}', "");;
    Expect(0, 125251, '\p{CWU=:\AN\z:}', "");;
    Expect(1, 125252, '\p{CWU=n}', "");
    Expect(0, 125252, '\p{^CWU=n}', "");
    Expect(0, 125252, '\P{CWU=n}', "");
    Expect(1, 125252, '\P{^CWU=n}', "");
    Expect(0, 125251, '\p{CWU=n}', "");
    Expect(1, 125251, '\p{^CWU=n}', "");
    Expect(1, 125251, '\P{CWU=n}', "");
    Expect(0, 125251, '\P{^CWU=n}', "");
    Expect(1, 125252, '\p{CWU=:\An\z:}', "");;
    Expect(0, 125251, '\p{CWU=:\An\z:}', "");;
    Expect(1, 125252, '\p{CWU=  N}', "");
    Expect(0, 125252, '\p{^CWU=  N}', "");
    Expect(0, 125252, '\P{CWU=  N}', "");
    Expect(1, 125252, '\P{^CWU=  N}', "");
    Expect(0, 125251, '\p{CWU=  N}', "");
    Expect(1, 125251, '\p{^CWU=  N}', "");
    Expect(1, 125251, '\P{CWU=  N}', "");
    Expect(0, 125251, '\P{^CWU=  N}', "");
    Error('\p{Is_Changes_When_Uppercased=:=	f}');
    Error('\P{Is_Changes_When_Uppercased=:=	f}');
    Expect(1, 125252, '\p{Is_Changes_When_Uppercased=f}', "");
    Expect(0, 125252, '\p{^Is_Changes_When_Uppercased=f}', "");
    Expect(0, 125252, '\P{Is_Changes_When_Uppercased=f}', "");
    Expect(1, 125252, '\P{^Is_Changes_When_Uppercased=f}', "");
    Expect(0, 125251, '\p{Is_Changes_When_Uppercased=f}', "");
    Expect(1, 125251, '\p{^Is_Changes_When_Uppercased=f}', "");
    Expect(1, 125251, '\P{Is_Changes_When_Uppercased=f}', "");
    Expect(0, 125251, '\P{^Is_Changes_When_Uppercased=f}', "");
    Expect(1, 125252, '\p{Is_Changes_When_Uppercased=_F}', "");
    Expect(0, 125252, '\p{^Is_Changes_When_Uppercased=_F}', "");
    Expect(0, 125252, '\P{Is_Changes_When_Uppercased=_F}', "");
    Expect(1, 125252, '\P{^Is_Changes_When_Uppercased=_F}', "");
    Expect(0, 125251, '\p{Is_Changes_When_Uppercased=_F}', "");
    Expect(1, 125251, '\p{^Is_Changes_When_Uppercased=_F}', "");
    Expect(1, 125251, '\P{Is_Changes_When_Uppercased=_F}', "");
    Expect(0, 125251, '\P{^Is_Changes_When_Uppercased=_F}', "");
    Error('\p{Is_CWU=:=False}');
    Error('\P{Is_CWU=:=False}');
    Expect(1, 125252, '\p{Is_CWU=false}', "");
    Expect(0, 125252, '\p{^Is_CWU=false}', "");
    Expect(0, 125252, '\P{Is_CWU=false}', "");
    Expect(1, 125252, '\P{^Is_CWU=false}', "");
    Expect(0, 125251, '\p{Is_CWU=false}', "");
    Expect(1, 125251, '\p{^Is_CWU=false}', "");
    Expect(1, 125251, '\P{Is_CWU=false}', "");
    Expect(0, 125251, '\P{^Is_CWU=false}', "");
    Expect(1, 125252, '\p{Is_CWU=-_false}', "");
    Expect(0, 125252, '\p{^Is_CWU=-_false}', "");
    Expect(0, 125252, '\P{Is_CWU=-_false}', "");
    Expect(1, 125252, '\P{^Is_CWU=-_false}', "");
    Expect(0, 125251, '\p{Is_CWU=-_false}', "");
    Expect(1, 125251, '\p{^Is_CWU=-_false}', "");
    Expect(1, 125251, '\P{Is_CWU=-_false}', "");
    Expect(0, 125251, '\P{^Is_CWU=-_false}', "");
    Error('\p{Changes_When_Uppercased=--yes:=}');
    Error('\P{Changes_When_Uppercased=--yes:=}');
    Expect(1, 125251, '\p{Changes_When_Uppercased=:\AYes\z:}', "");;
    Expect(0, 125252, '\p{Changes_When_Uppercased=:\AYes\z:}', "");;
    Expect(1, 125251, '\p{Changes_When_Uppercased=yes}', "");
    Expect(0, 125251, '\p{^Changes_When_Uppercased=yes}', "");
    Expect(0, 125251, '\P{Changes_When_Uppercased=yes}', "");
    Expect(1, 125251, '\P{^Changes_When_Uppercased=yes}', "");
    Expect(0, 125252, '\p{Changes_When_Uppercased=yes}', "");
    Expect(1, 125252, '\p{^Changes_When_Uppercased=yes}', "");
    Expect(1, 125252, '\P{Changes_When_Uppercased=yes}', "");
    Expect(0, 125252, '\P{^Changes_When_Uppercased=yes}', "");
    Expect(1, 125251, '\p{Changes_When_Uppercased=:\Ayes\z:}', "");;
    Expect(0, 125252, '\p{Changes_When_Uppercased=:\Ayes\z:}', "");;
    Expect(1, 125251, '\p{Changes_When_Uppercased=	YES}', "");
    Expect(0, 125251, '\p{^Changes_When_Uppercased=	YES}', "");
    Expect(0, 125251, '\P{Changes_When_Uppercased=	YES}', "");
    Expect(1, 125251, '\P{^Changes_When_Uppercased=	YES}', "");
    Expect(0, 125252, '\p{Changes_When_Uppercased=	YES}', "");
    Expect(1, 125252, '\p{^Changes_When_Uppercased=	YES}', "");
    Expect(1, 125252, '\P{Changes_When_Uppercased=	YES}', "");
    Expect(0, 125252, '\P{^Changes_When_Uppercased=	YES}', "");
    Error('\p{CWU= -y:=}');
    Error('\P{CWU= -y:=}');
    Expect(1, 125251, '\p{CWU=:\AY\z:}', "");;
    Expect(0, 125252, '\p{CWU=:\AY\z:}', "");;
    Expect(1, 125251, '\p{CWU=y}', "");
    Expect(0, 125251, '\p{^CWU=y}', "");
    Expect(0, 125251, '\P{CWU=y}', "");
    Expect(1, 125251, '\P{^CWU=y}', "");
    Expect(0, 125252, '\p{CWU=y}', "");
    Expect(1, 125252, '\p{^CWU=y}', "");
    Expect(1, 125252, '\P{CWU=y}', "");
    Expect(0, 125252, '\P{^CWU=y}', "");
    Expect(1, 125251, '\p{CWU=:\Ay\z:}', "");;
    Expect(0, 125252, '\p{CWU=:\Ay\z:}', "");;
    Expect(1, 125251, '\p{CWU=-	Y}', "");
    Expect(0, 125251, '\p{^CWU=-	Y}', "");
    Expect(0, 125251, '\P{CWU=-	Y}', "");
    Expect(1, 125251, '\P{^CWU=-	Y}', "");
    Expect(0, 125252, '\p{CWU=-	Y}', "");
    Expect(1, 125252, '\p{^CWU=-	Y}', "");
    Expect(1, 125252, '\P{CWU=-	Y}', "");
    Expect(0, 125252, '\P{^CWU=-	Y}', "");
    Error('\p{Is_Changes_When_Uppercased=- T/a/}');
    Error('\P{Is_Changes_When_Uppercased=- T/a/}');
    Expect(1, 125251, '\p{Is_Changes_When_Uppercased=t}', "");
    Expect(0, 125251, '\p{^Is_Changes_When_Uppercased=t}', "");
    Expect(0, 125251, '\P{Is_Changes_When_Uppercased=t}', "");
    Expect(1, 125251, '\P{^Is_Changes_When_Uppercased=t}', "");
    Expect(0, 125252, '\p{Is_Changes_When_Uppercased=t}', "");
    Expect(1, 125252, '\p{^Is_Changes_When_Uppercased=t}', "");
    Expect(1, 125252, '\P{Is_Changes_When_Uppercased=t}', "");
    Expect(0, 125252, '\P{^Is_Changes_When_Uppercased=t}', "");
    Expect(1, 125251, '\p{Is_Changes_When_Uppercased=_T}', "");
    Expect(0, 125251, '\p{^Is_Changes_When_Uppercased=_T}', "");
    Expect(0, 125251, '\P{Is_Changes_When_Uppercased=_T}', "");
    Expect(1, 125251, '\P{^Is_Changes_When_Uppercased=_T}', "");
    Expect(0, 125252, '\p{Is_Changes_When_Uppercased=_T}', "");
    Expect(1, 125252, '\p{^Is_Changes_When_Uppercased=_T}', "");
    Expect(1, 125252, '\P{Is_Changes_When_Uppercased=_T}', "");
    Expect(0, 125252, '\P{^Is_Changes_When_Uppercased=_T}', "");
    Error('\p{Is_CWU=--True:=}');
    Error('\P{Is_CWU=--True:=}');
    Expect(1, 125251, '\p{Is_CWU:true}', "");
    Expect(0, 125251, '\p{^Is_CWU:true}', "");
    Expect(0, 125251, '\P{Is_CWU:true}', "");
    Expect(1, 125251, '\P{^Is_CWU:true}', "");
    Expect(0, 125252, '\p{Is_CWU:true}', "");
    Expect(1, 125252, '\p{^Is_CWU:true}', "");
    Expect(1, 125252, '\P{Is_CWU:true}', "");
    Expect(0, 125252, '\P{^Is_CWU:true}', "");
    Expect(1, 125251, '\p{Is_CWU=	-TRUE}', "");
    Expect(0, 125251, '\p{^Is_CWU=	-TRUE}', "");
    Expect(0, 125251, '\P{Is_CWU=	-TRUE}', "");
    Expect(1, 125251, '\P{^Is_CWU=	-TRUE}', "");
    Expect(0, 125252, '\p{Is_CWU=	-TRUE}', "");
    Expect(1, 125252, '\p{^Is_CWU=	-TRUE}', "");
    Expect(1, 125252, '\P{Is_CWU=	-TRUE}', "");
    Expect(0, 125252, '\P{^Is_CWU=	-TRUE}', "");
    Error('\p{Dash=:=	 NO}');
    Error('\P{Dash=:=	 NO}');
    Expect(1, 65294, '\p{Dash=:\ANo\z:}', "");;
    Expect(0, 65293, '\p{Dash=:\ANo\z:}', "");;
    Expect(1, 65294, '\p{Dash=no}', "");
    Expect(0, 65294, '\p{^Dash=no}', "");
    Expect(0, 65294, '\P{Dash=no}', "");
    Expect(1, 65294, '\P{^Dash=no}', "");
    Expect(0, 65293, '\p{Dash=no}', "");
    Expect(1, 65293, '\p{^Dash=no}', "");
    Expect(1, 65293, '\P{Dash=no}', "");
    Expect(0, 65293, '\P{^Dash=no}', "");
    Expect(1, 65294, '\p{Dash=:\Ano\z:}', "");;
    Expect(0, 65293, '\p{Dash=:\Ano\z:}', "");;
    Expect(1, 65294, '\p{Dash=-_NO}', "");
    Expect(0, 65294, '\p{^Dash=-_NO}', "");
    Expect(0, 65294, '\P{Dash=-_NO}', "");
    Expect(1, 65294, '\P{^Dash=-_NO}', "");
    Expect(0, 65293, '\p{Dash=-_NO}', "");
    Expect(1, 65293, '\p{^Dash=-_NO}', "");
    Expect(1, 65293, '\P{Dash=-_NO}', "");
    Expect(0, 65293, '\P{^Dash=-_NO}', "");
    Error('\p{Is_Dash=-	n/a/}');
    Error('\P{Is_Dash=-	n/a/}');
    Expect(1, 65294, '\p{Is_Dash=n}', "");
    Expect(0, 65294, '\p{^Is_Dash=n}', "");
    Expect(0, 65294, '\P{Is_Dash=n}', "");
    Expect(1, 65294, '\P{^Is_Dash=n}', "");
    Expect(0, 65293, '\p{Is_Dash=n}', "");
    Expect(1, 65293, '\p{^Is_Dash=n}', "");
    Expect(1, 65293, '\P{Is_Dash=n}', "");
    Expect(0, 65293, '\P{^Is_Dash=n}', "");
    Expect(1, 65294, '\p{Is_Dash:- N}', "");
    Expect(0, 65294, '\p{^Is_Dash:- N}', "");
    Expect(0, 65294, '\P{Is_Dash:- N}', "");
    Expect(1, 65294, '\P{^Is_Dash:- N}', "");
    Expect(0, 65293, '\p{Is_Dash:- N}', "");
    Expect(1, 65293, '\p{^Is_Dash:- N}', "");
    Expect(1, 65293, '\P{Is_Dash:- N}', "");
    Expect(0, 65293, '\P{^Is_Dash:- N}', "");
    Error('\p{Dash:	:=	 F}');
    Error('\P{Dash:	:=	 F}');
    Expect(1, 65294, '\p{Dash=:\AF\z:}', "");;
    Expect(0, 65293, '\p{Dash=:\AF\z:}', "");;
    Expect(1, 65294, '\p{Dash:   f}', "");
    Expect(0, 65294, '\p{^Dash:   f}', "");
    Expect(0, 65294, '\P{Dash:   f}', "");
    Expect(1, 65294, '\P{^Dash:   f}', "");
    Expect(0, 65293, '\p{Dash:   f}', "");
    Expect(1, 65293, '\p{^Dash:   f}', "");
    Expect(1, 65293, '\P{Dash:   f}', "");
    Expect(0, 65293, '\P{^Dash:   f}', "");
    Expect(1, 65294, '\p{Dash=:\Af\z:}', "");;
    Expect(0, 65293, '\p{Dash=:\Af\z:}', "");;
    Expect(1, 65294, '\p{Dash=_ F}', "");
    Expect(0, 65294, '\p{^Dash=_ F}', "");
    Expect(0, 65294, '\P{Dash=_ F}', "");
    Expect(1, 65294, '\P{^Dash=_ F}', "");
    Expect(0, 65293, '\p{Dash=_ F}', "");
    Expect(1, 65293, '\p{^Dash=_ F}', "");
    Expect(1, 65293, '\P{Dash=_ F}', "");
    Expect(0, 65293, '\P{^Dash=_ F}', "");
    Error('\p{Is_Dash=_:=false}');
    Error('\P{Is_Dash=_:=false}');
    Expect(1, 65294, '\p{Is_Dash=false}', "");
    Expect(0, 65294, '\p{^Is_Dash=false}', "");
    Expect(0, 65294, '\P{Is_Dash=false}', "");
    Expect(1, 65294, '\P{^Is_Dash=false}', "");
    Expect(0, 65293, '\p{Is_Dash=false}', "");
    Expect(1, 65293, '\p{^Is_Dash=false}', "");
    Expect(1, 65293, '\P{Is_Dash=false}', "");
    Expect(0, 65293, '\P{^Is_Dash=false}', "");
    Expect(1, 65294, '\p{Is_Dash=		False}', "");
    Expect(0, 65294, '\p{^Is_Dash=		False}', "");
    Expect(0, 65294, '\P{Is_Dash=		False}', "");
    Expect(1, 65294, '\P{^Is_Dash=		False}', "");
    Expect(0, 65293, '\p{Is_Dash=		False}', "");
    Expect(1, 65293, '\p{^Is_Dash=		False}', "");
    Expect(1, 65293, '\P{Is_Dash=		False}', "");
    Expect(0, 65293, '\P{^Is_Dash=		False}', "");
    Error('\p{Dash: :=Yes}');
    Error('\P{Dash: :=Yes}');
    Expect(1, 65293, '\p{Dash=:\AYes\z:}', "");;
    Expect(0, 65294, '\p{Dash=:\AYes\z:}', "");;
    Expect(1, 65293, '\p{Dash=yes}', "");
    Expect(0, 65293, '\p{^Dash=yes}', "");
    Expect(0, 65293, '\P{Dash=yes}', "");
    Expect(1, 65293, '\P{^Dash=yes}', "");
    Expect(0, 65294, '\p{Dash=yes}', "");
    Expect(1, 65294, '\p{^Dash=yes}', "");
    Expect(1, 65294, '\P{Dash=yes}', "");
    Expect(0, 65294, '\P{^Dash=yes}', "");
    Expect(1, 65293, '\p{Dash=:\Ayes\z:}', "");;
    Expect(0, 65294, '\p{Dash=:\Ayes\z:}', "");;
    Expect(1, 65293, '\p{Dash=__YES}', "");
    Expect(0, 65293, '\p{^Dash=__YES}', "");
    Expect(0, 65293, '\P{Dash=__YES}', "");
    Expect(1, 65293, '\P{^Dash=__YES}', "");
    Expect(0, 65294, '\p{Dash=__YES}', "");
    Expect(1, 65294, '\p{^Dash=__YES}', "");
    Expect(1, 65294, '\P{Dash=__YES}', "");
    Expect(0, 65294, '\P{^Dash=__YES}', "");
    Error('\p{Is_Dash=/a/Y}');
    Error('\P{Is_Dash=/a/Y}');
    Expect(1, 65293, '\p{Is_Dash: y}', "");
    Expect(0, 65293, '\p{^Is_Dash: y}', "");
    Expect(0, 65293, '\P{Is_Dash: y}', "");
    Expect(1, 65293, '\P{^Is_Dash: y}', "");
    Expect(0, 65294, '\p{Is_Dash: y}', "");
    Expect(1, 65294, '\p{^Is_Dash: y}', "");
    Expect(1, 65294, '\P{Is_Dash: y}', "");
    Expect(0, 65294, '\P{^Is_Dash: y}', "");
    Expect(1, 65293, '\p{Is_Dash: _ Y}', "");
    Expect(0, 65293, '\p{^Is_Dash: _ Y}', "");
    Expect(0, 65293, '\P{Is_Dash: _ Y}', "");
    Expect(1, 65293, '\P{^Is_Dash: _ Y}', "");
    Expect(0, 65294, '\p{Is_Dash: _ Y}', "");
    Expect(1, 65294, '\p{^Is_Dash: _ Y}', "");
    Expect(1, 65294, '\P{Is_Dash: _ Y}', "");
    Expect(0, 65294, '\P{^Is_Dash: _ Y}', "");
    Error('\p{Dash=:= -T}');
    Error('\P{Dash=:= -T}');
    Expect(1, 65293, '\p{Dash=:\AT\z:}', "");;
    Expect(0, 65294, '\p{Dash=:\AT\z:}', "");;
    Expect(1, 65293, '\p{Dash=t}', "");
    Expect(0, 65293, '\p{^Dash=t}', "");
    Expect(0, 65293, '\P{Dash=t}', "");
    Expect(1, 65293, '\P{^Dash=t}', "");
    Expect(0, 65294, '\p{Dash=t}', "");
    Expect(1, 65294, '\p{^Dash=t}', "");
    Expect(1, 65294, '\P{Dash=t}', "");
    Expect(0, 65294, '\P{^Dash=t}', "");
    Expect(1, 65293, '\p{Dash=:\At\z:}', "");;
    Expect(0, 65294, '\p{Dash=:\At\z:}', "");;
    Expect(1, 65293, '\p{Dash=	T}', "");
    Expect(0, 65293, '\p{^Dash=	T}', "");
    Expect(0, 65293, '\P{Dash=	T}', "");
    Expect(1, 65293, '\P{^Dash=	T}', "");
    Expect(0, 65294, '\p{Dash=	T}', "");
    Expect(1, 65294, '\p{^Dash=	T}', "");
    Expect(1, 65294, '\P{Dash=	T}', "");
    Expect(0, 65294, '\P{^Dash=	T}', "");
    Error('\p{Is_Dash=:= _True}');
    Error('\P{Is_Dash=:= _True}');
    Expect(1, 65293, '\p{Is_Dash=true}', "");
    Expect(0, 65293, '\p{^Is_Dash=true}', "");
    Expect(0, 65293, '\P{Is_Dash=true}', "");
    Expect(1, 65293, '\P{^Is_Dash=true}', "");
    Expect(0, 65294, '\p{Is_Dash=true}', "");
    Expect(1, 65294, '\p{^Is_Dash=true}', "");
    Expect(1, 65294, '\P{Is_Dash=true}', "");
    Expect(0, 65294, '\P{^Is_Dash=true}', "");
    Expect(1, 65293, '\p{Is_Dash=-True}', "");
    Expect(0, 65293, '\p{^Is_Dash=-True}', "");
    Expect(0, 65293, '\P{Is_Dash=-True}', "");
    Expect(1, 65293, '\P{^Is_Dash=-True}', "");
    Expect(0, 65294, '\p{Is_Dash=-True}', "");
    Expect(1, 65294, '\p{^Is_Dash=-True}', "");
    Expect(1, 65294, '\P{Is_Dash=-True}', "");
    Expect(0, 65294, '\P{^Is_Dash=-True}', "");
    Error('\p{Deprecated=:=	no}');
    Error('\P{Deprecated=:=	no}');
    Expect(1, 917506, '\p{Deprecated=:\ANo\z:}', "");;
    Expect(0, 917505, '\p{Deprecated=:\ANo\z:}', "");;
    Expect(1, 917506, '\p{Deprecated:	no}', "");
    Expect(0, 917506, '\p{^Deprecated:	no}', "");
    Expect(0, 917506, '\P{Deprecated:	no}', "");
    Expect(1, 917506, '\P{^Deprecated:	no}', "");
    Expect(0, 917505, '\p{Deprecated:	no}', "");
    Expect(1, 917505, '\p{^Deprecated:	no}', "");
    Expect(1, 917505, '\P{Deprecated:	no}', "");
    Expect(0, 917505, '\P{^Deprecated:	no}', "");
    Expect(1, 917506, '\p{Deprecated=:\Ano\z:}', "");;
    Expect(0, 917505, '\p{Deprecated=:\Ano\z:}', "");;
    Expect(1, 917506, '\p{Deprecated=	-No}', "");
    Expect(0, 917506, '\p{^Deprecated=	-No}', "");
    Expect(0, 917506, '\P{Deprecated=	-No}', "");
    Expect(1, 917506, '\P{^Deprecated=	-No}', "");
    Expect(0, 917505, '\p{Deprecated=	-No}', "");
    Expect(1, 917505, '\p{^Deprecated=	-No}', "");
    Expect(1, 917505, '\P{Deprecated=	-No}', "");
    Expect(0, 917505, '\P{^Deprecated=	-No}', "");
    Error('\p{Dep=-/a/N}');
    Error('\P{Dep=-/a/N}');
    Expect(1, 917506, '\p{Dep=:\AN\z:}', "");;
    Expect(0, 917505, '\p{Dep=:\AN\z:}', "");;
    Expect(1, 917506, '\p{Dep=n}', "");
    Expect(0, 917506, '\p{^Dep=n}', "");
    Expect(0, 917506, '\P{Dep=n}', "");
    Expect(1, 917506, '\P{^Dep=n}', "");
    Expect(0, 917505, '\p{Dep=n}', "");
    Expect(1, 917505, '\p{^Dep=n}', "");
    Expect(1, 917505, '\P{Dep=n}', "");
    Expect(0, 917505, '\P{^Dep=n}', "");
    Expect(1, 917506, '\p{Dep=:\An\z:}', "");;
    Expect(0, 917505, '\p{Dep=:\An\z:}', "");;
    Expect(1, 917506, '\p{Dep=	N}', "");
    Expect(0, 917506, '\p{^Dep=	N}', "");
    Expect(0, 917506, '\P{Dep=	N}', "");
    Expect(1, 917506, '\P{^Dep=	N}', "");
    Expect(0, 917505, '\p{Dep=	N}', "");
    Expect(1, 917505, '\p{^Dep=	N}', "");
    Expect(1, 917505, '\P{Dep=	N}', "");
    Expect(0, 917505, '\P{^Dep=	N}', "");
    Error('\p{Is_Deprecated=/a/F}');
    Error('\P{Is_Deprecated=/a/F}');
    Expect(1, 917506, '\p{Is_Deprecated: f}', "");
    Expect(0, 917506, '\p{^Is_Deprecated: f}', "");
    Expect(0, 917506, '\P{Is_Deprecated: f}', "");
    Expect(1, 917506, '\P{^Is_Deprecated: f}', "");
    Expect(0, 917505, '\p{Is_Deprecated: f}', "");
    Expect(1, 917505, '\p{^Is_Deprecated: f}', "");
    Expect(1, 917505, '\P{Is_Deprecated: f}', "");
    Expect(0, 917505, '\P{^Is_Deprecated: f}', "");
    Expect(1, 917506, '\p{Is_Deprecated= F}', "");
    Expect(0, 917506, '\p{^Is_Deprecated= F}', "");
    Expect(0, 917506, '\P{Is_Deprecated= F}', "");
    Expect(1, 917506, '\P{^Is_Deprecated= F}', "");
    Expect(0, 917505, '\p{Is_Deprecated= F}', "");
    Expect(1, 917505, '\p{^Is_Deprecated= F}', "");
    Expect(1, 917505, '\P{Is_Deprecated= F}', "");
    Expect(0, 917505, '\P{^Is_Deprecated= F}', "");
    Error('\p{Is_Dep=/a/_-False}');
    Error('\P{Is_Dep=/a/_-False}');
    Expect(1, 917506, '\p{Is_Dep=false}', "");
    Expect(0, 917506, '\p{^Is_Dep=false}', "");
    Expect(0, 917506, '\P{Is_Dep=false}', "");
    Expect(1, 917506, '\P{^Is_Dep=false}', "");
    Expect(0, 917505, '\p{Is_Dep=false}', "");
    Expect(1, 917505, '\p{^Is_Dep=false}', "");
    Expect(1, 917505, '\P{Is_Dep=false}', "");
    Expect(0, 917505, '\P{^Is_Dep=false}', "");
    Expect(1, 917506, '\p{Is_Dep=	FALSE}', "");
    Expect(0, 917506, '\p{^Is_Dep=	FALSE}', "");
    Expect(0, 917506, '\P{Is_Dep=	FALSE}', "");
    Expect(1, 917506, '\P{^Is_Dep=	FALSE}', "");
    Expect(0, 917505, '\p{Is_Dep=	FALSE}', "");
    Expect(1, 917505, '\p{^Is_Dep=	FALSE}', "");
    Expect(1, 917505, '\P{Is_Dep=	FALSE}', "");
    Expect(0, 917505, '\P{^Is_Dep=	FALSE}', "");
    Error('\p{Deprecated=:= -YES}');
    Error('\P{Deprecated=:= -YES}');
    Expect(1, 917505, '\p{Deprecated=:\AYes\z:}', "");;
    Expect(0, 917506, '\p{Deprecated=:\AYes\z:}', "");;
    Expect(1, 917505, '\p{Deprecated=yes}', "");
    Expect(0, 917505, '\p{^Deprecated=yes}', "");
    Expect(0, 917505, '\P{Deprecated=yes}', "");
    Expect(1, 917505, '\P{^Deprecated=yes}', "");
    Expect(0, 917506, '\p{Deprecated=yes}', "");
    Expect(1, 917506, '\p{^Deprecated=yes}', "");
    Expect(1, 917506, '\P{Deprecated=yes}', "");
    Expect(0, 917506, '\P{^Deprecated=yes}', "");
    Expect(1, 917505, '\p{Deprecated=:\Ayes\z:}', "");;
    Expect(0, 917506, '\p{Deprecated=:\Ayes\z:}', "");;
    Expect(1, 917505, '\p{Deprecated=	-yes}', "");
    Expect(0, 917505, '\p{^Deprecated=	-yes}', "");
    Expect(0, 917505, '\P{Deprecated=	-yes}', "");
    Expect(1, 917505, '\P{^Deprecated=	-yes}', "");
    Expect(0, 917506, '\p{Deprecated=	-yes}', "");
    Expect(1, 917506, '\p{^Deprecated=	-yes}', "");
    Expect(1, 917506, '\P{Deprecated=	-yes}', "");
    Expect(0, 917506, '\P{^Deprecated=	-yes}', "");
    Error('\p{Dep= Y:=}');
    Error('\P{Dep= Y:=}');
    Expect(1, 917505, '\p{Dep=:\AY\z:}', "");;
    Expect(0, 917506, '\p{Dep=:\AY\z:}', "");;
    Expect(1, 917505, '\p{Dep=y}', "");
    Expect(0, 917505, '\p{^Dep=y}', "");
    Expect(0, 917505, '\P{Dep=y}', "");
    Expect(1, 917505, '\P{^Dep=y}', "");
    Expect(0, 917506, '\p{Dep=y}', "");
    Expect(1, 917506, '\p{^Dep=y}', "");
    Expect(1, 917506, '\P{Dep=y}', "");
    Expect(0, 917506, '\P{^Dep=y}', "");
    Expect(1, 917505, '\p{Dep=:\Ay\z:}', "");;
    Expect(0, 917506, '\p{Dep=:\Ay\z:}', "");;
    Expect(1, 917505, '\p{Dep=_ Y}', "");
    Expect(0, 917505, '\p{^Dep=_ Y}', "");
    Expect(0, 917505, '\P{Dep=_ Y}', "");
    Expect(1, 917505, '\P{^Dep=_ Y}', "");
    Expect(0, 917506, '\p{Dep=_ Y}', "");
    Expect(1, 917506, '\p{^Dep=_ Y}', "");
    Expect(1, 917506, '\P{Dep=_ Y}', "");
    Expect(0, 917506, '\P{^Dep=_ Y}', "");
    Error('\p{Is_Deprecated= /a/t}');
    Error('\P{Is_Deprecated= /a/t}');
    Expect(1, 917505, '\p{Is_Deprecated:t}', "");
    Expect(0, 917505, '\p{^Is_Deprecated:t}', "");
    Expect(0, 917505, '\P{Is_Deprecated:t}', "");
    Expect(1, 917505, '\P{^Is_Deprecated:t}', "");
    Expect(0, 917506, '\p{Is_Deprecated:t}', "");
    Expect(1, 917506, '\p{^Is_Deprecated:t}', "");
    Expect(1, 917506, '\P{Is_Deprecated:t}', "");
    Expect(0, 917506, '\P{^Is_Deprecated:t}', "");
    Expect(1, 917505, '\p{Is_Deprecated=-T}', "");
    Expect(0, 917505, '\p{^Is_Deprecated=-T}', "");
    Expect(0, 917505, '\P{Is_Deprecated=-T}', "");
    Expect(1, 917505, '\P{^Is_Deprecated=-T}', "");
    Expect(0, 917506, '\p{Is_Deprecated=-T}', "");
    Expect(1, 917506, '\p{^Is_Deprecated=-T}', "");
    Expect(1, 917506, '\P{Is_Deprecated=-T}', "");
    Expect(0, 917506, '\P{^Is_Deprecated=-T}', "");
    Error('\p{Is_Dep=	true:=}');
    Error('\P{Is_Dep=	true:=}');
    Expect(1, 917505, '\p{Is_Dep=true}', "");
    Expect(0, 917505, '\p{^Is_Dep=true}', "");
    Expect(0, 917505, '\P{Is_Dep=true}', "");
    Expect(1, 917505, '\P{^Is_Dep=true}', "");
    Expect(0, 917506, '\p{Is_Dep=true}', "");
    Expect(1, 917506, '\p{^Is_Dep=true}', "");
    Expect(1, 917506, '\P{Is_Dep=true}', "");
    Expect(0, 917506, '\P{^Is_Dep=true}', "");
    Expect(1, 917505, '\p{Is_Dep= _TRUE}', "");
    Expect(0, 917505, '\p{^Is_Dep= _TRUE}', "");
    Expect(0, 917505, '\P{Is_Dep= _TRUE}', "");
    Expect(1, 917505, '\P{^Is_Dep= _TRUE}', "");
    Expect(0, 917506, '\p{Is_Dep= _TRUE}', "");
    Expect(1, 917506, '\p{^Is_Dep= _TRUE}', "");
    Expect(1, 917506, '\P{Is_Dep= _TRUE}', "");
    Expect(0, 917506, '\P{^Is_Dep= _TRUE}', "");
    Error('\p{Default_Ignorable_Code_Point=:= _No}');
    Error('\P{Default_Ignorable_Code_Point=:= _No}');
    Expect(1, 921600, '\p{Default_Ignorable_Code_Point=:\ANo\z:}', "");;
    Expect(0, 921599, '\p{Default_Ignorable_Code_Point=:\ANo\z:}', "");;
    Expect(1, 921600, '\p{Default_Ignorable_Code_Point=no}', "");
    Expect(0, 921600, '\p{^Default_Ignorable_Code_Point=no}', "");
    Expect(0, 921600, '\P{Default_Ignorable_Code_Point=no}', "");
    Expect(1, 921600, '\P{^Default_Ignorable_Code_Point=no}', "");
    Expect(0, 921599, '\p{Default_Ignorable_Code_Point=no}', "");
    Expect(1, 921599, '\p{^Default_Ignorable_Code_Point=no}', "");
    Expect(1, 921599, '\P{Default_Ignorable_Code_Point=no}', "");
    Expect(0, 921599, '\P{^Default_Ignorable_Code_Point=no}', "");
    Expect(1, 921600, '\p{Default_Ignorable_Code_Point=:\Ano\z:}', "");;
    Expect(0, 921599, '\p{Default_Ignorable_Code_Point=:\Ano\z:}', "");;
    Expect(1, 921600, '\p{Default_Ignorable_Code_Point=		no}', "");
    Expect(0, 921600, '\p{^Default_Ignorable_Code_Point=		no}', "");
    Expect(0, 921600, '\P{Default_Ignorable_Code_Point=		no}', "");
    Expect(1, 921600, '\P{^Default_Ignorable_Code_Point=		no}', "");
    Expect(0, 921599, '\p{Default_Ignorable_Code_Point=		no}', "");
    Expect(1, 921599, '\p{^Default_Ignorable_Code_Point=		no}', "");
    Expect(1, 921599, '\P{Default_Ignorable_Code_Point=		no}', "");
    Expect(0, 921599, '\P{^Default_Ignorable_Code_Point=		no}', "");
    Error('\p{DI= N:=}');
    Error('\P{DI= N:=}');
    Expect(1, 921600, '\p{DI=:\AN\z:}', "");;
    Expect(0, 921599, '\p{DI=:\AN\z:}', "");;
    Expect(1, 921600, '\p{DI=n}', "");
    Expect(0, 921600, '\p{^DI=n}', "");
    Expect(0, 921600, '\P{DI=n}', "");
    Expect(1, 921600, '\P{^DI=n}', "");
    Expect(0, 921599, '\p{DI=n}', "");
    Expect(1, 921599, '\p{^DI=n}', "");
    Expect(1, 921599, '\P{DI=n}', "");
    Expect(0, 921599, '\P{^DI=n}', "");
    Expect(1, 921600, '\p{DI=:\An\z:}', "");;
    Expect(0, 921599, '\p{DI=:\An\z:}', "");;
    Expect(1, 921600, '\p{DI=	N}', "");
    Expect(0, 921600, '\p{^DI=	N}', "");
    Expect(0, 921600, '\P{DI=	N}', "");
    Expect(1, 921600, '\P{^DI=	N}', "");
    Expect(0, 921599, '\p{DI=	N}', "");
    Expect(1, 921599, '\p{^DI=	N}', "");
    Expect(1, 921599, '\P{DI=	N}', "");
    Expect(0, 921599, '\P{^DI=	N}', "");
    Error('\p{Is_Default_Ignorable_Code_Point: :=F}');
    Error('\P{Is_Default_Ignorable_Code_Point: :=F}');
    Expect(1, 921600, '\p{Is_Default_Ignorable_Code_Point=f}', "");
    Expect(0, 921600, '\p{^Is_Default_Ignorable_Code_Point=f}', "");
    Expect(0, 921600, '\P{Is_Default_Ignorable_Code_Point=f}', "");
    Expect(1, 921600, '\P{^Is_Default_Ignorable_Code_Point=f}', "");
    Expect(0, 921599, '\p{Is_Default_Ignorable_Code_Point=f}', "");
    Expect(1, 921599, '\p{^Is_Default_Ignorable_Code_Point=f}', "");
    Expect(1, 921599, '\P{Is_Default_Ignorable_Code_Point=f}', "");
    Expect(0, 921599, '\P{^Is_Default_Ignorable_Code_Point=f}', "");
    Expect(1, 921600, '\p{Is_Default_Ignorable_Code_Point=- F}', "");
    Expect(0, 921600, '\p{^Is_Default_Ignorable_Code_Point=- F}', "");
    Expect(0, 921600, '\P{Is_Default_Ignorable_Code_Point=- F}', "");
    Expect(1, 921600, '\P{^Is_Default_Ignorable_Code_Point=- F}', "");
    Expect(0, 921599, '\p{Is_Default_Ignorable_Code_Point=- F}', "");
    Expect(1, 921599, '\p{^Is_Default_Ignorable_Code_Point=- F}', "");
    Expect(1, 921599, '\P{Is_Default_Ignorable_Code_Point=- F}', "");
    Expect(0, 921599, '\P{^Is_Default_Ignorable_Code_Point=- F}', "");
    Error('\p{Is_DI=-:=FALSE}');
    Error('\P{Is_DI=-:=FALSE}');
    Expect(1, 921600, '\p{Is_DI=false}', "");
    Expect(0, 921600, '\p{^Is_DI=false}', "");
    Expect(0, 921600, '\P{Is_DI=false}', "");
    Expect(1, 921600, '\P{^Is_DI=false}', "");
    Expect(0, 921599, '\p{Is_DI=false}', "");
    Expect(1, 921599, '\p{^Is_DI=false}', "");
    Expect(1, 921599, '\P{Is_DI=false}', "");
    Expect(0, 921599, '\P{^Is_DI=false}', "");
    Expect(1, 921600, '\p{Is_DI=_-False}', "");
    Expect(0, 921600, '\p{^Is_DI=_-False}', "");
    Expect(0, 921600, '\P{Is_DI=_-False}', "");
    Expect(1, 921600, '\P{^Is_DI=_-False}', "");
    Expect(0, 921599, '\p{Is_DI=_-False}', "");
    Expect(1, 921599, '\p{^Is_DI=_-False}', "");
    Expect(1, 921599, '\P{Is_DI=_-False}', "");
    Expect(0, 921599, '\P{^Is_DI=_-False}', "");
    Error('\p{Default_Ignorable_Code_Point=/a/_	YES}');
    Error('\P{Default_Ignorable_Code_Point=/a/_	YES}');
    Expect(1, 921599, '\p{Default_Ignorable_Code_Point=:\AYes\z:}', "");;
    Expect(0, 921600, '\p{Default_Ignorable_Code_Point=:\AYes\z:}', "");;
    Expect(1, 921599, '\p{Default_Ignorable_Code_Point=yes}', "");
    Expect(0, 921599, '\p{^Default_Ignorable_Code_Point=yes}', "");
    Expect(0, 921599, '\P{Default_Ignorable_Code_Point=yes}', "");
    Expect(1, 921599, '\P{^Default_Ignorable_Code_Point=yes}', "");
    Expect(0, 921600, '\p{Default_Ignorable_Code_Point=yes}', "");
    Expect(1, 921600, '\p{^Default_Ignorable_Code_Point=yes}', "");
    Expect(1, 921600, '\P{Default_Ignorable_Code_Point=yes}', "");
    Expect(0, 921600, '\P{^Default_Ignorable_Code_Point=yes}', "");
    Expect(1, 921599, '\p{Default_Ignorable_Code_Point=:\Ayes\z:}', "");;
    Expect(0, 921600, '\p{Default_Ignorable_Code_Point=:\Ayes\z:}', "");;
    Expect(1, 921599, '\p{Default_Ignorable_Code_Point=- yes}', "");
    Expect(0, 921599, '\p{^Default_Ignorable_Code_Point=- yes}', "");
    Expect(0, 921599, '\P{Default_Ignorable_Code_Point=- yes}', "");
    Expect(1, 921599, '\P{^Default_Ignorable_Code_Point=- yes}', "");
    Expect(0, 921600, '\p{Default_Ignorable_Code_Point=- yes}', "");
    Expect(1, 921600, '\p{^Default_Ignorable_Code_Point=- yes}', "");
    Expect(1, 921600, '\P{Default_Ignorable_Code_Point=- yes}', "");
    Expect(0, 921600, '\P{^Default_Ignorable_Code_Point=- yes}', "");
    Error('\p{DI=		Y:=}');
    Error('\P{DI=		Y:=}');
    Expect(1, 921599, '\p{DI=:\AY\z:}', "");;
    Expect(0, 921600, '\p{DI=:\AY\z:}', "");;
    Expect(1, 921599, '\p{DI: y}', "");
    Expect(0, 921599, '\p{^DI: y}', "");
    Expect(0, 921599, '\P{DI: y}', "");
    Expect(1, 921599, '\P{^DI: y}', "");
    Expect(0, 921600, '\p{DI: y}', "");
    Expect(1, 921600, '\p{^DI: y}', "");
    Expect(1, 921600, '\P{DI: y}', "");
    Expect(0, 921600, '\P{^DI: y}', "");
    Expect(1, 921599, '\p{DI=:\Ay\z:}', "");;
    Expect(0, 921600, '\p{DI=:\Ay\z:}', "");;
    Expect(1, 921599, '\p{DI=	-Y}', "");
    Expect(0, 921599, '\p{^DI=	-Y}', "");
    Expect(0, 921599, '\P{DI=	-Y}', "");
    Expect(1, 921599, '\P{^DI=	-Y}', "");
    Expect(0, 921600, '\p{DI=	-Y}', "");
    Expect(1, 921600, '\p{^DI=	-Y}', "");
    Expect(1, 921600, '\P{DI=	-Y}', "");
    Expect(0, 921600, '\P{^DI=	-Y}', "");
    Error('\p{Is_Default_Ignorable_Code_Point=- t/a/}');
    Error('\P{Is_Default_Ignorable_Code_Point=- t/a/}');
    Expect(1, 921599, '\p{Is_Default_Ignorable_Code_Point=t}', "");
    Expect(0, 921599, '\p{^Is_Default_Ignorable_Code_Point=t}', "");
    Expect(0, 921599, '\P{Is_Default_Ignorable_Code_Point=t}', "");
    Expect(1, 921599, '\P{^Is_Default_Ignorable_Code_Point=t}', "");
    Expect(0, 921600, '\p{Is_Default_Ignorable_Code_Point=t}', "");
    Expect(1, 921600, '\p{^Is_Default_Ignorable_Code_Point=t}', "");
    Expect(1, 921600, '\P{Is_Default_Ignorable_Code_Point=t}', "");
    Expect(0, 921600, '\P{^Is_Default_Ignorable_Code_Point=t}', "");
    Expect(1, 921599, '\p{Is_Default_Ignorable_Code_Point=-	T}', "");
    Expect(0, 921599, '\p{^Is_Default_Ignorable_Code_Point=-	T}', "");
    Expect(0, 921599, '\P{Is_Default_Ignorable_Code_Point=-	T}', "");
    Expect(1, 921599, '\P{^Is_Default_Ignorable_Code_Point=-	T}', "");
    Expect(0, 921600, '\p{Is_Default_Ignorable_Code_Point=-	T}', "");
    Expect(1, 921600, '\p{^Is_Default_Ignorable_Code_Point=-	T}', "");
    Expect(1, 921600, '\P{Is_Default_Ignorable_Code_Point=-	T}', "");
    Expect(0, 921600, '\P{^Is_Default_Ignorable_Code_Point=-	T}', "");
    Error('\p{Is_DI=:=_	True}');
    Error('\P{Is_DI=:=_	True}');
    Expect(1, 921599, '\p{Is_DI=true}', "");
    Expect(0, 921599, '\p{^Is_DI=true}', "");
    Expect(0, 921599, '\P{Is_DI=true}', "");
    Expect(1, 921599, '\P{^Is_DI=true}', "");
    Expect(0, 921600, '\p{Is_DI=true}', "");
    Expect(1, 921600, '\p{^Is_DI=true}', "");
    Expect(1, 921600, '\P{Is_DI=true}', "");
    Expect(0, 921600, '\P{^Is_DI=true}', "");
    Expect(1, 921599, '\p{Is_DI=_-True}', "");
    Expect(0, 921599, '\p{^Is_DI=_-True}', "");
    Expect(0, 921599, '\P{Is_DI=_-True}', "");
    Expect(1, 921599, '\P{^Is_DI=_-True}', "");
    Expect(0, 921600, '\p{Is_DI=_-True}', "");
    Expect(1, 921600, '\p{^Is_DI=_-True}', "");
    Expect(1, 921600, '\P{Is_DI=_-True}', "");
    Expect(0, 921600, '\P{^Is_DI=_-True}', "");
    Error('\p{Diacritic=  no/a/}');
    Error('\P{Diacritic=  no/a/}');
    Expect(1, 125259, '\p{Diacritic=:\ANo\z:}', "");;
    Expect(0, 125258, '\p{Diacritic=:\ANo\z:}', "");;
    Expect(1, 125259, '\p{Diacritic=no}', "");
    Expect(0, 125259, '\p{^Diacritic=no}', "");
    Expect(0, 125259, '\P{Diacritic=no}', "");
    Expect(1, 125259, '\P{^Diacritic=no}', "");
    Expect(0, 125258, '\p{Diacritic=no}', "");
    Expect(1, 125258, '\p{^Diacritic=no}', "");
    Expect(1, 125258, '\P{Diacritic=no}', "");
    Expect(0, 125258, '\P{^Diacritic=no}', "");
    Expect(1, 125259, '\p{Diacritic=:\Ano\z:}', "");;
    Expect(0, 125258, '\p{Diacritic=:\Ano\z:}', "");;
    Expect(1, 125259, '\p{Diacritic=	NO}', "");
    Expect(0, 125259, '\p{^Diacritic=	NO}', "");
    Expect(0, 125259, '\P{Diacritic=	NO}', "");
    Expect(1, 125259, '\P{^Diacritic=	NO}', "");
    Expect(0, 125258, '\p{Diacritic=	NO}', "");
    Expect(1, 125258, '\p{^Diacritic=	NO}', "");
    Expect(1, 125258, '\P{Diacritic=	NO}', "");
    Expect(0, 125258, '\P{^Diacritic=	NO}', "");
    Error('\p{Dia= /a/N}');
    Error('\P{Dia= /a/N}');
    Expect(1, 125259, '\p{Dia=:\AN\z:}', "");;
    Expect(0, 125258, '\p{Dia=:\AN\z:}', "");;
    Expect(1, 125259, '\p{Dia=n}', "");
    Expect(0, 125259, '\p{^Dia=n}', "");
    Expect(0, 125259, '\P{Dia=n}', "");
    Expect(1, 125259, '\P{^Dia=n}', "");
    Expect(0, 125258, '\p{Dia=n}', "");
    Expect(1, 125258, '\p{^Dia=n}', "");
    Expect(1, 125258, '\P{Dia=n}', "");
    Expect(0, 125258, '\P{^Dia=n}', "");
    Expect(1, 125259, '\p{Dia=:\An\z:}', "");;
    Expect(0, 125258, '\p{Dia=:\An\z:}', "");;
    Expect(1, 125259, '\p{Dia=	 N}', "");
    Expect(0, 125259, '\p{^Dia=	 N}', "");
    Expect(0, 125259, '\P{Dia=	 N}', "");
    Expect(1, 125259, '\P{^Dia=	 N}', "");
    Expect(0, 125258, '\p{Dia=	 N}', "");
    Expect(1, 125258, '\p{^Dia=	 N}', "");
    Expect(1, 125258, '\P{Dia=	 N}', "");
    Expect(0, 125258, '\P{^Dia=	 N}', "");
    Error('\p{Is_Diacritic= :=f}');
    Error('\P{Is_Diacritic= :=f}');
    Expect(1, 125259, '\p{Is_Diacritic=f}', "");
    Expect(0, 125259, '\p{^Is_Diacritic=f}', "");
    Expect(0, 125259, '\P{Is_Diacritic=f}', "");
    Expect(1, 125259, '\P{^Is_Diacritic=f}', "");
    Expect(0, 125258, '\p{Is_Diacritic=f}', "");
    Expect(1, 125258, '\p{^Is_Diacritic=f}', "");
    Expect(1, 125258, '\P{Is_Diacritic=f}', "");
    Expect(0, 125258, '\P{^Is_Diacritic=f}', "");
    Expect(1, 125259, '\p{Is_Diacritic= 	F}', "");
    Expect(0, 125259, '\p{^Is_Diacritic= 	F}', "");
    Expect(0, 125259, '\P{Is_Diacritic= 	F}', "");
    Expect(1, 125259, '\P{^Is_Diacritic= 	F}', "");
    Expect(0, 125258, '\p{Is_Diacritic= 	F}', "");
    Expect(1, 125258, '\p{^Is_Diacritic= 	F}', "");
    Expect(1, 125258, '\P{Is_Diacritic= 	F}', "");
    Expect(0, 125258, '\P{^Is_Diacritic= 	F}', "");
    Error('\p{Is_Dia=/a/ -FALSE}');
    Error('\P{Is_Dia=/a/ -FALSE}');
    Expect(1, 125259, '\p{Is_Dia=false}', "");
    Expect(0, 125259, '\p{^Is_Dia=false}', "");
    Expect(0, 125259, '\P{Is_Dia=false}', "");
    Expect(1, 125259, '\P{^Is_Dia=false}', "");
    Expect(0, 125258, '\p{Is_Dia=false}', "");
    Expect(1, 125258, '\p{^Is_Dia=false}', "");
    Expect(1, 125258, '\P{Is_Dia=false}', "");
    Expect(0, 125258, '\P{^Is_Dia=false}', "");
    Expect(1, 125259, '\p{Is_Dia=	_False}', "");
    Expect(0, 125259, '\p{^Is_Dia=	_False}', "");
    Expect(0, 125259, '\P{Is_Dia=	_False}', "");
    Expect(1, 125259, '\P{^Is_Dia=	_False}', "");
    Expect(0, 125258, '\p{Is_Dia=	_False}', "");
    Expect(1, 125258, '\p{^Is_Dia=	_False}', "");
    Expect(1, 125258, '\P{Is_Dia=	_False}', "");
    Expect(0, 125258, '\P{^Is_Dia=	_False}', "");
    Error('\p{Diacritic= yes:=}');
    Error('\P{Diacritic= yes:=}');
    Expect(1, 125258, '\p{Diacritic=:\AYes\z:}', "");;
    Expect(0, 125259, '\p{Diacritic=:\AYes\z:}', "");;
    Expect(1, 125258, '\p{Diacritic=yes}', "");
    Expect(0, 125258, '\p{^Diacritic=yes}', "");
    Expect(0, 125258, '\P{Diacritic=yes}', "");
    Expect(1, 125258, '\P{^Diacritic=yes}', "");
    Expect(0, 125259, '\p{Diacritic=yes}', "");
    Expect(1, 125259, '\p{^Diacritic=yes}', "");
    Expect(1, 125259, '\P{Diacritic=yes}', "");
    Expect(0, 125259, '\P{^Diacritic=yes}', "");
    Expect(1, 125258, '\p{Diacritic=:\Ayes\z:}', "");;
    Expect(0, 125259, '\p{Diacritic=:\Ayes\z:}', "");;
    Expect(1, 125258, '\p{Diacritic=YES}', "");
    Expect(0, 125258, '\p{^Diacritic=YES}', "");
    Expect(0, 125258, '\P{Diacritic=YES}', "");
    Expect(1, 125258, '\P{^Diacritic=YES}', "");
    Expect(0, 125259, '\p{Diacritic=YES}', "");
    Expect(1, 125259, '\p{^Diacritic=YES}', "");
    Expect(1, 125259, '\P{Diacritic=YES}', "");
    Expect(0, 125259, '\P{^Diacritic=YES}', "");
    Error('\p{Dia=:=	-Y}');
    Error('\P{Dia=:=	-Y}');
    Expect(1, 125258, '\p{Dia=:\AY\z:}', "");;
    Expect(0, 125259, '\p{Dia=:\AY\z:}', "");;
    Expect(1, 125258, '\p{Dia:	y}', "");
    Expect(0, 125258, '\p{^Dia:	y}', "");
    Expect(0, 125258, '\P{Dia:	y}', "");
    Expect(1, 125258, '\P{^Dia:	y}', "");
    Expect(0, 125259, '\p{Dia:	y}', "");
    Expect(1, 125259, '\p{^Dia:	y}', "");
    Expect(1, 125259, '\P{Dia:	y}', "");
    Expect(0, 125259, '\P{^Dia:	y}', "");
    Expect(1, 125258, '\p{Dia=:\Ay\z:}', "");;
    Expect(0, 125259, '\p{Dia=:\Ay\z:}', "");;
    Expect(1, 125258, '\p{Dia=-Y}', "");
    Expect(0, 125258, '\p{^Dia=-Y}', "");
    Expect(0, 125258, '\P{Dia=-Y}', "");
    Expect(1, 125258, '\P{^Dia=-Y}', "");
    Expect(0, 125259, '\p{Dia=-Y}', "");
    Expect(1, 125259, '\p{^Dia=-Y}', "");
    Expect(1, 125259, '\P{Dia=-Y}', "");
    Expect(0, 125259, '\P{^Dia=-Y}', "");
    Error('\p{Is_Diacritic=-_T:=}');
    Error('\P{Is_Diacritic=-_T:=}');
    Expect(1, 125258, '\p{Is_Diacritic=t}', "");
    Expect(0, 125258, '\p{^Is_Diacritic=t}', "");
    Expect(0, 125258, '\P{Is_Diacritic=t}', "");
    Expect(1, 125258, '\P{^Is_Diacritic=t}', "");
    Expect(0, 125259, '\p{Is_Diacritic=t}', "");
    Expect(1, 125259, '\p{^Is_Diacritic=t}', "");
    Expect(1, 125259, '\P{Is_Diacritic=t}', "");
    Expect(0, 125259, '\P{^Is_Diacritic=t}', "");
    Expect(1, 125258, '\p{Is_Diacritic=--t}', "");
    Expect(0, 125258, '\p{^Is_Diacritic=--t}', "");
    Expect(0, 125258, '\P{Is_Diacritic=--t}', "");
    Expect(1, 125258, '\P{^Is_Diacritic=--t}', "");
    Expect(0, 125259, '\p{Is_Diacritic=--t}', "");
    Expect(1, 125259, '\p{^Is_Diacritic=--t}', "");
    Expect(1, 125259, '\P{Is_Diacritic=--t}', "");
    Expect(0, 125259, '\P{^Is_Diacritic=--t}', "");
    Error('\p{Is_Dia= True/a/}');
    Error('\P{Is_Dia= True/a/}');
    Expect(1, 125258, '\p{Is_Dia=true}', "");
    Expect(0, 125258, '\p{^Is_Dia=true}', "");
    Expect(0, 125258, '\P{Is_Dia=true}', "");
    Expect(1, 125258, '\P{^Is_Dia=true}', "");
    Expect(0, 125259, '\p{Is_Dia=true}', "");
    Expect(1, 125259, '\p{^Is_Dia=true}', "");
    Expect(1, 125259, '\P{Is_Dia=true}', "");
    Expect(0, 125259, '\P{^Is_Dia=true}', "");
    Expect(1, 125258, '\p{Is_Dia=True}', "");
    Expect(0, 125258, '\p{^Is_Dia=True}', "");
    Expect(0, 125258, '\P{Is_Dia=True}', "");
    Expect(1, 125258, '\P{^Is_Dia=True}', "");
    Expect(0, 125259, '\p{Is_Dia=True}', "");
    Expect(1, 125259, '\p{^Is_Dia=True}', "");
    Expect(1, 125259, '\P{Is_Dia=True}', "");
    Expect(0, 125259, '\P{^Is_Dia=True}', "");
    Error('\p{decompositionmapping}');
    Error('\P{decompositionmapping}');
    Error('\p{dm}');
    Error('\P{dm}');
    Error('\p{decompositiontype}');
    Error('\P{decompositiontype}');
    Error('\p{dt}');
    Error('\P{dt}');
    Error('\p{Decomposition_Type=-	CANONICAL:=}');
    Error('\P{Decomposition_Type=-	CANONICAL:=}');
    Expect(1, 195101, '\p{Decomposition_Type=:\ACanonical\z:}', "");;
    Expect(0, 195102, '\p{Decomposition_Type=:\ACanonical\z:}', "");;
    Expect(1, 195101, '\p{Decomposition_Type=canonical}', "");
    Expect(0, 195101, '\p{^Decomposition_Type=canonical}', "");
    Expect(0, 195101, '\P{Decomposition_Type=canonical}', "");
    Expect(1, 195101, '\P{^Decomposition_Type=canonical}', "");
    Expect(0, 195102, '\p{Decomposition_Type=canonical}', "");
    Expect(1, 195102, '\p{^Decomposition_Type=canonical}', "");
    Expect(1, 195102, '\P{Decomposition_Type=canonical}', "");
    Expect(0, 195102, '\P{^Decomposition_Type=canonical}', "");
    Expect(1, 195101, '\p{Decomposition_Type=:\Acanonical\z:}', "");;
    Expect(0, 195102, '\p{Decomposition_Type=:\Acanonical\z:}', "");;
    Expect(1, 195101, '\p{Decomposition_Type:	_Canonical}', "");
    Expect(0, 195101, '\p{^Decomposition_Type:	_Canonical}', "");
    Expect(0, 195101, '\P{Decomposition_Type:	_Canonical}', "");
    Expect(1, 195101, '\P{^Decomposition_Type:	_Canonical}', "");
    Expect(0, 195102, '\p{Decomposition_Type:	_Canonical}', "");
    Expect(1, 195102, '\p{^Decomposition_Type:	_Canonical}', "");
    Expect(1, 195102, '\P{Decomposition_Type:	_Canonical}', "");
    Expect(0, 195102, '\P{^Decomposition_Type:	_Canonical}', "");
    Error('\p{Dt=  can/a/}');
    Error('\P{Dt=  can/a/}');
    Expect(1, 195101, '\p{Dt=:\ACan\z:}', "");;
    Expect(0, 195102, '\p{Dt=:\ACan\z:}', "");;
    Expect(1, 195101, '\p{Dt=can}', "");
    Expect(0, 195101, '\p{^Dt=can}', "");
    Expect(0, 195101, '\P{Dt=can}', "");
    Expect(1, 195101, '\P{^Dt=can}', "");
    Expect(0, 195102, '\p{Dt=can}', "");
    Expect(1, 195102, '\p{^Dt=can}', "");
    Expect(1, 195102, '\P{Dt=can}', "");
    Expect(0, 195102, '\P{^Dt=can}', "");
    Expect(1, 195101, '\p{Dt=:\Acan\z:}', "");;
    Expect(0, 195102, '\p{Dt=:\Acan\z:}', "");;
    Expect(1, 195101, '\p{Dt:	 _Can}', "");
    Expect(0, 195101, '\p{^Dt:	 _Can}', "");
    Expect(0, 195101, '\P{Dt:	 _Can}', "");
    Expect(1, 195101, '\P{^Dt:	 _Can}', "");
    Expect(0, 195102, '\p{Dt:	 _Can}', "");
    Expect(1, 195102, '\p{^Dt:	 _Can}', "");
    Expect(1, 195102, '\P{Dt:	 _Can}', "");
    Expect(0, 195102, '\P{^Dt:	 _Can}', "");
    Error('\p{Is_Decomposition_Type=/a/- Canonical}');
    Error('\P{Is_Decomposition_Type=/a/- Canonical}');
    Expect(1, 195101, '\p{Is_Decomposition_Type: canonical}', "");
    Expect(0, 195101, '\p{^Is_Decomposition_Type: canonical}', "");
    Expect(0, 195101, '\P{Is_Decomposition_Type: canonical}', "");
    Expect(1, 195101, '\P{^Is_Decomposition_Type: canonical}', "");
    Expect(0, 195102, '\p{Is_Decomposition_Type: canonical}', "");
    Expect(1, 195102, '\p{^Is_Decomposition_Type: canonical}', "");
    Expect(1, 195102, '\P{Is_Decomposition_Type: canonical}', "");
    Expect(0, 195102, '\P{^Is_Decomposition_Type: canonical}', "");
    Expect(1, 195101, '\p{Is_Decomposition_Type:	_canonical}', "");
    Expect(0, 195101, '\p{^Is_Decomposition_Type:	_canonical}', "");
    Expect(0, 195101, '\P{Is_Decomposition_Type:	_canonical}', "");
    Expect(1, 195101, '\P{^Is_Decomposition_Type:	_canonical}', "");
    Expect(0, 195102, '\p{Is_Decomposition_Type:	_canonical}', "");
    Expect(1, 195102, '\p{^Is_Decomposition_Type:	_canonical}', "");
    Expect(1, 195102, '\P{Is_Decomposition_Type:	_canonical}', "");
    Expect(0, 195102, '\P{^Is_Decomposition_Type:	_canonical}', "");
    Error('\p{Is_Dt=	/a/can}');
    Error('\P{Is_Dt=	/a/can}');
    Expect(1, 195101, '\p{Is_Dt=can}', "");
    Expect(0, 195101, '\p{^Is_Dt=can}', "");
    Expect(0, 195101, '\P{Is_Dt=can}', "");
    Expect(1, 195101, '\P{^Is_Dt=can}', "");
    Expect(0, 195102, '\p{Is_Dt=can}', "");
    Expect(1, 195102, '\p{^Is_Dt=can}', "");
    Expect(1, 195102, '\P{Is_Dt=can}', "");
    Expect(0, 195102, '\P{^Is_Dt=can}', "");
    Expect(1, 195101, '\p{Is_Dt=	_can}', "");
    Expect(0, 195101, '\p{^Is_Dt=	_can}', "");
    Expect(0, 195101, '\P{Is_Dt=	_can}', "");
    Expect(1, 195101, '\P{^Is_Dt=	_can}', "");
    Expect(0, 195102, '\p{Is_Dt=	_can}', "");
    Expect(1, 195102, '\p{^Is_Dt=	_can}', "");
    Expect(1, 195102, '\P{Is_Dt=	_can}', "");
    Expect(0, 195102, '\P{^Is_Dt=	_can}', "");
    Error('\p{Decomposition_Type: :=__COMPAT}');
    Error('\P{Decomposition_Type: :=__COMPAT}');
    Expect(1, 127560, '\p{Decomposition_Type=:\ACompat\z:}', "");;
    Expect(0, 127561, '\p{Decomposition_Type=:\ACompat\z:}', "");;
    Expect(1, 127560, '\p{Decomposition_Type=compat}', "");
    Expect(0, 127560, '\p{^Decomposition_Type=compat}', "");
    Expect(0, 127560, '\P{Decomposition_Type=compat}', "");
    Expect(1, 127560, '\P{^Decomposition_Type=compat}', "");
    Expect(0, 127561, '\p{Decomposition_Type=compat}', "");
    Expect(1, 127561, '\p{^Decomposition_Type=compat}', "");
    Expect(1, 127561, '\P{Decomposition_Type=compat}', "");
    Expect(0, 127561, '\P{^Decomposition_Type=compat}', "");
    Expect(1, 127560, '\p{Decomposition_Type=:\Acompat\z:}', "");;
    Expect(0, 127561, '\p{Decomposition_Type=:\Acompat\z:}', "");;
    Expect(1, 127560, '\p{Decomposition_Type:   --compat}', "");
    Expect(0, 127560, '\p{^Decomposition_Type:   --compat}', "");
    Expect(0, 127560, '\P{Decomposition_Type:   --compat}', "");
    Expect(1, 127560, '\P{^Decomposition_Type:   --compat}', "");
    Expect(0, 127561, '\p{Decomposition_Type:   --compat}', "");
    Expect(1, 127561, '\p{^Decomposition_Type:   --compat}', "");
    Expect(1, 127561, '\P{Decomposition_Type:   --compat}', "");
    Expect(0, 127561, '\P{^Decomposition_Type:   --compat}', "");
    Error('\p{Dt=  Com/a/}');
    Error('\P{Dt=  Com/a/}');
    Expect(1, 127560, '\p{Dt=:\ACom\z:}', "");;
    Expect(0, 127561, '\p{Dt=:\ACom\z:}', "");;
    Expect(1, 127560, '\p{Dt=com}', "");
    Expect(0, 127560, '\p{^Dt=com}', "");
    Expect(0, 127560, '\P{Dt=com}', "");
    Expect(1, 127560, '\P{^Dt=com}', "");
    Expect(0, 127561, '\p{Dt=com}', "");
    Expect(1, 127561, '\p{^Dt=com}', "");
    Expect(1, 127561, '\P{Dt=com}', "");
    Expect(0, 127561, '\P{^Dt=com}', "");
    Expect(1, 127560, '\p{Dt=:\Acom\z:}', "");;
    Expect(0, 127561, '\p{Dt=:\Acom\z:}', "");;
    Expect(1, 127560, '\p{Dt=-	Com}', "");
    Expect(0, 127560, '\p{^Dt=-	Com}', "");
    Expect(0, 127560, '\P{Dt=-	Com}', "");
    Expect(1, 127560, '\P{^Dt=-	Com}', "");
    Expect(0, 127561, '\p{Dt=-	Com}', "");
    Expect(1, 127561, '\p{^Dt=-	Com}', "");
    Expect(1, 127561, '\P{Dt=-	Com}', "");
    Expect(0, 127561, '\P{^Dt=-	Com}', "");
    Error('\p{Is_Decomposition_Type:	:=	Compat}');
    Error('\P{Is_Decomposition_Type:	:=	Compat}');
    Expect(1, 127560, '\p{Is_Decomposition_Type=compat}', "");
    Expect(0, 127560, '\p{^Is_Decomposition_Type=compat}', "");
    Expect(0, 127560, '\P{Is_Decomposition_Type=compat}', "");
    Expect(1, 127560, '\P{^Is_Decomposition_Type=compat}', "");
    Expect(0, 127561, '\p{Is_Decomposition_Type=compat}', "");
    Expect(1, 127561, '\p{^Is_Decomposition_Type=compat}', "");
    Expect(1, 127561, '\P{Is_Decomposition_Type=compat}', "");
    Expect(0, 127561, '\P{^Is_Decomposition_Type=compat}', "");
    Expect(1, 127560, '\p{Is_Decomposition_Type=_ compat}', "");
    Expect(0, 127560, '\p{^Is_Decomposition_Type=_ compat}', "");
    Expect(0, 127560, '\P{Is_Decomposition_Type=_ compat}', "");
    Expect(1, 127560, '\P{^Is_Decomposition_Type=_ compat}', "");
    Expect(0, 127561, '\p{Is_Decomposition_Type=_ compat}', "");
    Expect(1, 127561, '\p{^Is_Decomposition_Type=_ compat}', "");
    Expect(1, 127561, '\P{Is_Decomposition_Type=_ compat}', "");
    Expect(0, 127561, '\P{^Is_Decomposition_Type=_ compat}', "");
    Error('\p{Is_Dt:	:= Com}');
    Error('\P{Is_Dt:	:= Com}');
    Expect(1, 127560, '\p{Is_Dt=com}', "");
    Expect(0, 127560, '\p{^Is_Dt=com}', "");
    Expect(0, 127560, '\P{Is_Dt=com}', "");
    Expect(1, 127560, '\P{^Is_Dt=com}', "");
    Expect(0, 127561, '\p{Is_Dt=com}', "");
    Expect(1, 127561, '\p{^Is_Dt=com}', "");
    Expect(1, 127561, '\P{Is_Dt=com}', "");
    Expect(0, 127561, '\P{^Is_Dt=com}', "");
    Expect(1, 127560, '\p{Is_Dt=-	com}', "");
    Expect(0, 127560, '\p{^Is_Dt=-	com}', "");
    Expect(0, 127560, '\P{Is_Dt=-	com}', "");
    Expect(1, 127560, '\P{^Is_Dt=-	com}', "");
    Expect(0, 127561, '\p{Is_Dt=-	com}', "");
    Expect(1, 127561, '\p{^Is_Dt=-	com}', "");
    Expect(1, 127561, '\P{Is_Dt=-	com}', "");
    Expect(0, 127561, '\P{^Is_Dt=-	com}', "");
    Error('\p{Decomposition_Type=-/a/Circle}');
    Error('\P{Decomposition_Type=-/a/Circle}');
    Expect(1, 127569, '\p{Decomposition_Type=:\ACircle\z:}', "");;
    Expect(0, 127570, '\p{Decomposition_Type=:\ACircle\z:}', "");;
    Expect(1, 127569, '\p{Decomposition_Type=circle}', "");
    Expect(0, 127569, '\p{^Decomposition_Type=circle}', "");
    Expect(0, 127569, '\P{Decomposition_Type=circle}', "");
    Expect(1, 127569, '\P{^Decomposition_Type=circle}', "");
    Expect(0, 127570, '\p{Decomposition_Type=circle}', "");
    Expect(1, 127570, '\p{^Decomposition_Type=circle}', "");
    Expect(1, 127570, '\P{Decomposition_Type=circle}', "");
    Expect(0, 127570, '\P{^Decomposition_Type=circle}', "");
    Expect(1, 127569, '\p{Decomposition_Type=:\Acircle\z:}', "");;
    Expect(0, 127570, '\p{Decomposition_Type=:\Acircle\z:}', "");;
    Expect(1, 127569, '\p{Decomposition_Type: Circle}', "");
    Expect(0, 127569, '\p{^Decomposition_Type: Circle}', "");
    Expect(0, 127569, '\P{Decomposition_Type: Circle}', "");
    Expect(1, 127569, '\P{^Decomposition_Type: Circle}', "");
    Expect(0, 127570, '\p{Decomposition_Type: Circle}', "");
    Expect(1, 127570, '\p{^Decomposition_Type: Circle}', "");
    Expect(1, 127570, '\P{Decomposition_Type: Circle}', "");
    Expect(0, 127570, '\P{^Decomposition_Type: Circle}', "");
    Error('\p{Dt:-_Enc/a/}');
    Error('\P{Dt:-_Enc/a/}');
    Expect(1, 127569, '\p{Dt=:\AEnc\z:}', "");;
    Expect(0, 127570, '\p{Dt=:\AEnc\z:}', "");;
    Expect(1, 127569, '\p{Dt:	enc}', "");
    Expect(0, 127569, '\p{^Dt:	enc}', "");
    Expect(0, 127569, '\P{Dt:	enc}', "");
    Expect(1, 127569, '\P{^Dt:	enc}', "");
    Expect(0, 127570, '\p{Dt:	enc}', "");
    Expect(1, 127570, '\p{^Dt:	enc}', "");
    Expect(1, 127570, '\P{Dt:	enc}', "");
    Expect(0, 127570, '\P{^Dt:	enc}', "");
    Expect(1, 127569, '\p{Dt=:\Aenc\z:}', "");;
    Expect(0, 127570, '\p{Dt=:\Aenc\z:}', "");;
    Expect(1, 127569, '\p{Dt=	 Enc}', "");
    Expect(0, 127569, '\p{^Dt=	 Enc}', "");
    Expect(0, 127569, '\P{Dt=	 Enc}', "");
    Expect(1, 127569, '\P{^Dt=	 Enc}', "");
    Expect(0, 127570, '\p{Dt=	 Enc}', "");
    Expect(1, 127570, '\p{^Dt=	 Enc}', "");
    Expect(1, 127570, '\P{Dt=	 Enc}', "");
    Expect(0, 127570, '\P{^Dt=	 Enc}', "");
    Error('\p{Is_Decomposition_Type=-/a/Circle}');
    Error('\P{Is_Decomposition_Type=-/a/Circle}');
    Expect(1, 127569, '\p{Is_Decomposition_Type=circle}', "");
    Expect(0, 127569, '\p{^Is_Decomposition_Type=circle}', "");
    Expect(0, 127569, '\P{Is_Decomposition_Type=circle}', "");
    Expect(1, 127569, '\P{^Is_Decomposition_Type=circle}', "");
    Expect(0, 127570, '\p{Is_Decomposition_Type=circle}', "");
    Expect(1, 127570, '\p{^Is_Decomposition_Type=circle}', "");
    Expect(1, 127570, '\P{Is_Decomposition_Type=circle}', "");
    Expect(0, 127570, '\P{^Is_Decomposition_Type=circle}', "");
    Expect(1, 127569, '\p{Is_Decomposition_Type: -Circle}', "");
    Expect(0, 127569, '\p{^Is_Decomposition_Type: -Circle}', "");
    Expect(0, 127569, '\P{Is_Decomposition_Type: -Circle}', "");
    Expect(1, 127569, '\P{^Is_Decomposition_Type: -Circle}', "");
    Expect(0, 127570, '\p{Is_Decomposition_Type: -Circle}', "");
    Expect(1, 127570, '\p{^Is_Decomposition_Type: -Circle}', "");
    Expect(1, 127570, '\P{Is_Decomposition_Type: -Circle}', "");
    Expect(0, 127570, '\P{^Is_Decomposition_Type: -Circle}', "");
    Error('\p{Is_Dt=:=	ENC}');
    Error('\P{Is_Dt=:=	ENC}');
    Expect(1, 127569, '\p{Is_Dt=enc}', "");
    Expect(0, 127569, '\p{^Is_Dt=enc}', "");
    Expect(0, 127569, '\P{Is_Dt=enc}', "");
    Expect(1, 127569, '\P{^Is_Dt=enc}', "");
    Expect(0, 127570, '\p{Is_Dt=enc}', "");
    Expect(1, 127570, '\p{^Is_Dt=enc}', "");
    Expect(1, 127570, '\P{Is_Dt=enc}', "");
    Expect(0, 127570, '\P{^Is_Dt=enc}', "");
    Expect(1, 127569, '\p{Is_Dt=_enc}', "");
    Expect(0, 127569, '\p{^Is_Dt=_enc}', "");
    Expect(0, 127569, '\P{Is_Dt=_enc}', "");
    Expect(1, 127569, '\P{^Is_Dt=_enc}', "");
    Expect(0, 127570, '\p{Is_Dt=_enc}', "");
    Expect(1, 127570, '\p{^Is_Dt=_enc}', "");
    Expect(1, 127570, '\P{Is_Dt=_enc}', "");
    Expect(0, 127570, '\P{^Is_Dt=_enc}', "");
    Error('\p{Decomposition_Type=/a/_final}');
    Error('\P{Decomposition_Type=/a/_final}');
    Expect(1, 65276, '\p{Decomposition_Type=:\AFinal\z:}', "");;
    Expect(0, 65277, '\p{Decomposition_Type=:\AFinal\z:}', "");;
    Expect(1, 65276, '\p{Decomposition_Type=final}', "");
    Expect(0, 65276, '\p{^Decomposition_Type=final}', "");
    Expect(0, 65276, '\P{Decomposition_Type=final}', "");
    Expect(1, 65276, '\P{^Decomposition_Type=final}', "");
    Expect(0, 65277, '\p{Decomposition_Type=final}', "");
    Expect(1, 65277, '\p{^Decomposition_Type=final}', "");
    Expect(1, 65277, '\P{Decomposition_Type=final}', "");
    Expect(0, 65277, '\P{^Decomposition_Type=final}', "");
    Expect(1, 65276, '\p{Decomposition_Type=:\Afinal\z:}', "");;
    Expect(0, 65277, '\p{Decomposition_Type=:\Afinal\z:}', "");;
    Expect(1, 65276, '\p{Decomposition_Type=__FINAL}', "");
    Expect(0, 65276, '\p{^Decomposition_Type=__FINAL}', "");
    Expect(0, 65276, '\P{Decomposition_Type=__FINAL}', "");
    Expect(1, 65276, '\P{^Decomposition_Type=__FINAL}', "");
    Expect(0, 65277, '\p{Decomposition_Type=__FINAL}', "");
    Expect(1, 65277, '\p{^Decomposition_Type=__FINAL}', "");
    Expect(1, 65277, '\P{Decomposition_Type=__FINAL}', "");
    Expect(0, 65277, '\P{^Decomposition_Type=__FINAL}', "");
    Error('\p{Dt= /a/FIN}');
    Error('\P{Dt= /a/FIN}');
    Expect(1, 65276, '\p{Dt=:\AFin\z:}', "");;
    Expect(0, 65277, '\p{Dt=:\AFin\z:}', "");;
    Expect(1, 65276, '\p{Dt=fin}', "");
    Expect(0, 65276, '\p{^Dt=fin}', "");
    Expect(0, 65276, '\P{Dt=fin}', "");
    Expect(1, 65276, '\P{^Dt=fin}', "");
    Expect(0, 65277, '\p{Dt=fin}', "");
    Expect(1, 65277, '\p{^Dt=fin}', "");
    Expect(1, 65277, '\P{Dt=fin}', "");
    Expect(0, 65277, '\P{^Dt=fin}', "");
    Expect(1, 65276, '\p{Dt=:\Afin\z:}', "");;
    Expect(0, 65277, '\p{Dt=:\Afin\z:}', "");;
    Expect(1, 65276, '\p{Dt=  Fin}', "");
    Expect(0, 65276, '\p{^Dt=  Fin}', "");
    Expect(0, 65276, '\P{Dt=  Fin}', "");
    Expect(1, 65276, '\P{^Dt=  Fin}', "");
    Expect(0, 65277, '\p{Dt=  Fin}', "");
    Expect(1, 65277, '\p{^Dt=  Fin}', "");
    Expect(1, 65277, '\P{Dt=  Fin}', "");
    Expect(0, 65277, '\P{^Dt=  Fin}', "");
    Error('\p{Is_Decomposition_Type=-	FINAL/a/}');
    Error('\P{Is_Decomposition_Type=-	FINAL/a/}');
    Expect(1, 65276, '\p{Is_Decomposition_Type=final}', "");
    Expect(0, 65276, '\p{^Is_Decomposition_Type=final}', "");
    Expect(0, 65276, '\P{Is_Decomposition_Type=final}', "");
    Expect(1, 65276, '\P{^Is_Decomposition_Type=final}', "");
    Expect(0, 65277, '\p{Is_Decomposition_Type=final}', "");
    Expect(1, 65277, '\p{^Is_Decomposition_Type=final}', "");
    Expect(1, 65277, '\P{Is_Decomposition_Type=final}', "");
    Expect(0, 65277, '\P{^Is_Decomposition_Type=final}', "");
    Expect(1, 65276, '\p{Is_Decomposition_Type=--FINAL}', "");
    Expect(0, 65276, '\p{^Is_Decomposition_Type=--FINAL}', "");
    Expect(0, 65276, '\P{Is_Decomposition_Type=--FINAL}', "");
    Expect(1, 65276, '\P{^Is_Decomposition_Type=--FINAL}', "");
    Expect(0, 65277, '\p{Is_Decomposition_Type=--FINAL}', "");
    Expect(1, 65277, '\p{^Is_Decomposition_Type=--FINAL}', "");
    Expect(1, 65277, '\P{Is_Decomposition_Type=--FINAL}', "");
    Expect(0, 65277, '\P{^Is_Decomposition_Type=--FINAL}', "");
    Error('\p{Is_Dt=_-FIN/a/}');
    Error('\P{Is_Dt=_-FIN/a/}');
    Expect(1, 65276, '\p{Is_Dt=fin}', "");
    Expect(0, 65276, '\p{^Is_Dt=fin}', "");
    Expect(0, 65276, '\P{Is_Dt=fin}', "");
    Expect(1, 65276, '\P{^Is_Dt=fin}', "");
    Expect(0, 65277, '\p{Is_Dt=fin}', "");
    Expect(1, 65277, '\p{^Is_Dt=fin}', "");
    Expect(1, 65277, '\P{Is_Dt=fin}', "");
    Expect(0, 65277, '\P{^Is_Dt=fin}', "");
    Expect(1, 65276, '\p{Is_Dt:-	Fin}', "");
    Expect(0, 65276, '\p{^Is_Dt:-	Fin}', "");
    Expect(0, 65276, '\P{Is_Dt:-	Fin}', "");
    Expect(1, 65276, '\P{^Is_Dt:-	Fin}', "");
    Expect(0, 65277, '\p{Is_Dt:-	Fin}', "");
    Expect(1, 65277, '\p{^Is_Dt:-	Fin}', "");
    Expect(1, 65277, '\P{Is_Dt:-	Fin}', "");
    Expect(0, 65277, '\P{^Is_Dt:-	Fin}', "");
    Error('\p{Decomposition_Type=_:=font}');
    Error('\P{Decomposition_Type=_:=font}');
    Expect(1, 126651, '\p{Decomposition_Type=:\AFont\z:}', "");;
    Expect(0, 126652, '\p{Decomposition_Type=:\AFont\z:}', "");;
    Expect(1, 126651, '\p{Decomposition_Type=font}', "");
    Expect(0, 126651, '\p{^Decomposition_Type=font}', "");
    Expect(0, 126651, '\P{Decomposition_Type=font}', "");
    Expect(1, 126651, '\P{^Decomposition_Type=font}', "");
    Expect(0, 126652, '\p{Decomposition_Type=font}', "");
    Expect(1, 126652, '\p{^Decomposition_Type=font}', "");
    Expect(1, 126652, '\P{Decomposition_Type=font}', "");
    Expect(0, 126652, '\P{^Decomposition_Type=font}', "");
    Expect(1, 126651, '\p{Decomposition_Type=:\Afont\z:}', "");;
    Expect(0, 126652, '\p{Decomposition_Type=:\Afont\z:}', "");;
    Expect(1, 126651, '\p{Decomposition_Type= font}', "");
    Expect(0, 126651, '\p{^Decomposition_Type= font}', "");
    Expect(0, 126651, '\P{Decomposition_Type= font}', "");
    Expect(1, 126651, '\P{^Decomposition_Type= font}', "");
    Expect(0, 126652, '\p{Decomposition_Type= font}', "");
    Expect(1, 126652, '\p{^Decomposition_Type= font}', "");
    Expect(1, 126652, '\P{Decomposition_Type= font}', "");
    Expect(0, 126652, '\P{^Decomposition_Type= font}', "");
    Error('\p{Dt=:=_-Font}');
    Error('\P{Dt=:=_-Font}');
    Expect(1, 126651, '\p{Dt=:\AFont\z:}', "");;
    Expect(0, 126652, '\p{Dt=:\AFont\z:}', "");;
    Expect(1, 126651, '\p{Dt=font}', "");
    Expect(0, 126651, '\p{^Dt=font}', "");
    Expect(0, 126651, '\P{Dt=font}', "");
    Expect(1, 126651, '\P{^Dt=font}', "");
    Expect(0, 126652, '\p{Dt=font}', "");
    Expect(1, 126652, '\p{^Dt=font}', "");
    Expect(1, 126652, '\P{Dt=font}', "");
    Expect(0, 126652, '\P{^Dt=font}', "");
    Expect(1, 126651, '\p{Dt=:\Afont\z:}', "");;
    Expect(0, 126652, '\p{Dt=:\Afont\z:}', "");;
    Expect(1, 126651, '\p{Dt= -font}', "");
    Expect(0, 126651, '\p{^Dt= -font}', "");
    Expect(0, 126651, '\P{Dt= -font}', "");
    Expect(1, 126651, '\P{^Dt= -font}', "");
    Expect(0, 126652, '\p{Dt= -font}', "");
    Expect(1, 126652, '\p{^Dt= -font}', "");
    Expect(1, 126652, '\P{Dt= -font}', "");
    Expect(0, 126652, '\P{^Dt= -font}', "");
    Error('\p{Is_Decomposition_Type=/a/ _Font}');
    Error('\P{Is_Decomposition_Type=/a/ _Font}');
    Expect(1, 126651, '\p{Is_Decomposition_Type=font}', "");
    Expect(0, 126651, '\p{^Is_Decomposition_Type=font}', "");
    Expect(0, 126651, '\P{Is_Decomposition_Type=font}', "");
    Expect(1, 126651, '\P{^Is_Decomposition_Type=font}', "");
    Expect(0, 126652, '\p{Is_Decomposition_Type=font}', "");
    Expect(1, 126652, '\p{^Is_Decomposition_Type=font}', "");
    Expect(1, 126652, '\P{Is_Decomposition_Type=font}', "");
    Expect(0, 126652, '\P{^Is_Decomposition_Type=font}', "");
    Expect(1, 126651, '\p{Is_Decomposition_Type:   - font}', "");
    Expect(0, 126651, '\p{^Is_Decomposition_Type:   - font}', "");
    Expect(0, 126651, '\P{Is_Decomposition_Type:   - font}', "");
    Expect(1, 126651, '\P{^Is_Decomposition_Type:   - font}', "");
    Expect(0, 126652, '\p{Is_Decomposition_Type:   - font}', "");
    Expect(1, 126652, '\p{^Is_Decomposition_Type:   - font}', "");
    Expect(1, 126652, '\P{Is_Decomposition_Type:   - font}', "");
    Expect(0, 126652, '\P{^Is_Decomposition_Type:   - font}', "");
    Error('\p{Is_Dt=-	Font/a/}');
    Error('\P{Is_Dt=-	Font/a/}');
    Expect(1, 126651, '\p{Is_Dt=font}', "");
    Expect(0, 126651, '\p{^Is_Dt=font}', "");
    Expect(0, 126651, '\P{Is_Dt=font}', "");
    Expect(1, 126651, '\P{^Is_Dt=font}', "");
    Expect(0, 126652, '\p{Is_Dt=font}', "");
    Expect(1, 126652, '\p{^Is_Dt=font}', "");
    Expect(1, 126652, '\P{Is_Dt=font}', "");
    Expect(0, 126652, '\P{^Is_Dt=font}', "");
    Expect(1, 126651, '\p{Is_Dt=_	FONT}', "");
    Expect(0, 126651, '\p{^Is_Dt=_	FONT}', "");
    Expect(0, 126651, '\P{Is_Dt=_	FONT}', "");
    Expect(1, 126651, '\P{^Is_Dt=_	FONT}', "");
    Expect(0, 126652, '\p{Is_Dt=_	FONT}', "");
    Expect(1, 126652, '\p{^Is_Dt=_	FONT}', "");
    Expect(1, 126652, '\P{Is_Dt=_	FONT}', "");
    Expect(0, 126652, '\P{^Is_Dt=_	FONT}', "");
    Error('\p{Decomposition_Type=_:=Fraction}');
    Error('\P{Decomposition_Type=_:=Fraction}');
    Expect(1, 8585, '\p{Decomposition_Type=:\AFraction\z:}', "");;
    Expect(0, 8586, '\p{Decomposition_Type=:\AFraction\z:}', "");;
    Expect(1, 8585, '\p{Decomposition_Type=fraction}', "");
    Expect(0, 8585, '\p{^Decomposition_Type=fraction}', "");
    Expect(0, 8585, '\P{Decomposition_Type=fraction}', "");
    Expect(1, 8585, '\P{^Decomposition_Type=fraction}', "");
    Expect(0, 8586, '\p{Decomposition_Type=fraction}', "");
    Expect(1, 8586, '\p{^Decomposition_Type=fraction}', "");
    Expect(1, 8586, '\P{Decomposition_Type=fraction}', "");
    Expect(0, 8586, '\P{^Decomposition_Type=fraction}', "");
    Expect(1, 8585, '\p{Decomposition_Type=:\Afraction\z:}', "");;
    Expect(0, 8586, '\p{Decomposition_Type=:\Afraction\z:}', "");;
    Expect(1, 8585, '\p{Decomposition_Type:  	Fraction}', "");
    Expect(0, 8585, '\p{^Decomposition_Type:  	Fraction}', "");
    Expect(0, 8585, '\P{Decomposition_Type:  	Fraction}', "");
    Expect(1, 8585, '\P{^Decomposition_Type:  	Fraction}', "");
    Expect(0, 8586, '\p{Decomposition_Type:  	Fraction}', "");
    Expect(1, 8586, '\p{^Decomposition_Type:  	Fraction}', "");
    Expect(1, 8586, '\P{Decomposition_Type:  	Fraction}', "");
    Expect(0, 8586, '\P{^Decomposition_Type:  	Fraction}', "");
    Error('\p{Dt: /a/__Fra}');
    Error('\P{Dt: /a/__Fra}');
    Expect(1, 8585, '\p{Dt=:\AFra\z:}', "");;
    Expect(0, 8586, '\p{Dt=:\AFra\z:}', "");;
    Expect(1, 8585, '\p{Dt=fra}', "");
    Expect(0, 8585, '\p{^Dt=fra}', "");
    Expect(0, 8585, '\P{Dt=fra}', "");
    Expect(1, 8585, '\P{^Dt=fra}', "");
    Expect(0, 8586, '\p{Dt=fra}', "");
    Expect(1, 8586, '\p{^Dt=fra}', "");
    Expect(1, 8586, '\P{Dt=fra}', "");
    Expect(0, 8586, '\P{^Dt=fra}', "");
    Expect(1, 8585, '\p{Dt=:\Afra\z:}', "");;
    Expect(0, 8586, '\p{Dt=:\Afra\z:}', "");;
    Expect(1, 8585, '\p{Dt:   -_Fra}', "");
    Expect(0, 8585, '\p{^Dt:   -_Fra}', "");
    Expect(0, 8585, '\P{Dt:   -_Fra}', "");
    Expect(1, 8585, '\P{^Dt:   -_Fra}', "");
    Expect(0, 8586, '\p{Dt:   -_Fra}', "");
    Expect(1, 8586, '\p{^Dt:   -_Fra}', "");
    Expect(1, 8586, '\P{Dt:   -_Fra}', "");
    Expect(0, 8586, '\P{^Dt:   -_Fra}', "");
    Error('\p{Is_Decomposition_Type:   :=-	FRACTION}');
    Error('\P{Is_Decomposition_Type:   :=-	FRACTION}');
    Expect(1, 8585, '\p{Is_Decomposition_Type=fraction}', "");
    Expect(0, 8585, '\p{^Is_Decomposition_Type=fraction}', "");
    Expect(0, 8585, '\P{Is_Decomposition_Type=fraction}', "");
    Expect(1, 8585, '\P{^Is_Decomposition_Type=fraction}', "");
    Expect(0, 8586, '\p{Is_Decomposition_Type=fraction}', "");
    Expect(1, 8586, '\p{^Is_Decomposition_Type=fraction}', "");
    Expect(1, 8586, '\P{Is_Decomposition_Type=fraction}', "");
    Expect(0, 8586, '\P{^Is_Decomposition_Type=fraction}', "");
    Expect(1, 8585, '\p{Is_Decomposition_Type=- FRACTION}', "");
    Expect(0, 8585, '\p{^Is_Decomposition_Type=- FRACTION}', "");
    Expect(0, 8585, '\P{Is_Decomposition_Type=- FRACTION}', "");
    Expect(1, 8585, '\P{^Is_Decomposition_Type=- FRACTION}', "");
    Expect(0, 8586, '\p{Is_Decomposition_Type=- FRACTION}', "");
    Expect(1, 8586, '\p{^Is_Decomposition_Type=- FRACTION}', "");
    Expect(1, 8586, '\P{Is_Decomposition_Type=- FRACTION}', "");
    Expect(0, 8586, '\P{^Is_Decomposition_Type=- FRACTION}', "");
    Error('\p{Is_Dt=/a/ -Fra}');
    Error('\P{Is_Dt=/a/ -Fra}');
    Expect(1, 8585, '\p{Is_Dt=fra}', "");
    Expect(0, 8585, '\p{^Is_Dt=fra}', "");
    Expect(0, 8585, '\P{Is_Dt=fra}', "");
    Expect(1, 8585, '\P{^Is_Dt=fra}', "");
    Expect(0, 8586, '\p{Is_Dt=fra}', "");
    Expect(1, 8586, '\p{^Is_Dt=fra}', "");
    Expect(1, 8586, '\P{Is_Dt=fra}', "");
    Expect(0, 8586, '\P{^Is_Dt=fra}', "");
    Error('\p{Decomposition_Type=-	Initial:=}');
    Error('\P{Decomposition_Type=-	Initial:=}');
    Expect(1, 65267, '\p{Decomposition_Type=:\AInitial\z:}', "");;
    Expect(0, 65268, '\p{Decomposition_Type=:\AInitial\z:}', "");;
    Expect(1, 65267, '\p{Decomposition_Type=initial}', "");
    Expect(0, 65267, '\p{^Decomposition_Type=initial}', "");
    Expect(0, 65267, '\P{Decomposition_Type=initial}', "");
    Expect(1, 65267, '\P{^Decomposition_Type=initial}', "");
    Expect(0, 65268, '\p{Decomposition_Type=initial}', "");
    Expect(1, 65268, '\p{^Decomposition_Type=initial}', "");
    Expect(1, 65268, '\P{Decomposition_Type=initial}', "");
    Expect(0, 65268, '\P{^Decomposition_Type=initial}', "");
    Expect(1, 65267, '\p{Decomposition_Type=:\Ainitial\z:}', "");;
    Expect(0, 65268, '\p{Decomposition_Type=:\Ainitial\z:}', "");;
    Expect(1, 65267, '\p{Decomposition_Type=	Initial}', "");
    Expect(0, 65267, '\p{^Decomposition_Type=	Initial}', "");
    Expect(0, 65267, '\P{Decomposition_Type=	Initial}', "");
    Expect(1, 65267, '\P{^Decomposition_Type=	Initial}', "");
    Expect(0, 65268, '\p{Decomposition_Type=	Initial}', "");
    Expect(1, 65268, '\p{^Decomposition_Type=	Initial}', "");
    Expect(1, 65268, '\P{Decomposition_Type=	Initial}', "");
    Expect(0, 65268, '\P{^Decomposition_Type=	Initial}', "");
    Error('\p{Dt=_:=INIT}');
    Error('\P{Dt=_:=INIT}');
    Expect(1, 65267, '\p{Dt=:\AInit\z:}', "");;
    Expect(0, 65268, '\p{Dt=:\AInit\z:}', "");;
    Expect(1, 65267, '\p{Dt=init}', "");
    Expect(0, 65267, '\p{^Dt=init}', "");
    Expect(0, 65267, '\P{Dt=init}', "");
    Expect(1, 65267, '\P{^Dt=init}', "");
    Expect(0, 65268, '\p{Dt=init}', "");
    Expect(1, 65268, '\p{^Dt=init}', "");
    Expect(1, 65268, '\P{Dt=init}', "");
    Expect(0, 65268, '\P{^Dt=init}', "");
    Expect(1, 65267, '\p{Dt=:\Ainit\z:}', "");;
    Expect(0, 65268, '\p{Dt=:\Ainit\z:}', "");;
    Expect(1, 65267, '\p{Dt=_ Init}', "");
    Expect(0, 65267, '\p{^Dt=_ Init}', "");
    Expect(0, 65267, '\P{Dt=_ Init}', "");
    Expect(1, 65267, '\P{^Dt=_ Init}', "");
    Expect(0, 65268, '\p{Dt=_ Init}', "");
    Expect(1, 65268, '\p{^Dt=_ Init}', "");
    Expect(1, 65268, '\P{Dt=_ Init}', "");
    Expect(0, 65268, '\P{^Dt=_ Init}', "");
    Error('\p{Is_Decomposition_Type=/a/_	Initial}');
    Error('\P{Is_Decomposition_Type=/a/_	Initial}');
    Expect(1, 65267, '\p{Is_Decomposition_Type=initial}', "");
    Expect(0, 65267, '\p{^Is_Decomposition_Type=initial}', "");
    Expect(0, 65267, '\P{Is_Decomposition_Type=initial}', "");
    Expect(1, 65267, '\P{^Is_Decomposition_Type=initial}', "");
    Expect(0, 65268, '\p{Is_Decomposition_Type=initial}', "");
    Expect(1, 65268, '\p{^Is_Decomposition_Type=initial}', "");
    Expect(1, 65268, '\P{Is_Decomposition_Type=initial}', "");
    Expect(0, 65268, '\P{^Is_Decomposition_Type=initial}', "");
    Expect(1, 65267, '\p{Is_Decomposition_Type= 	INITIAL}', "");
    Expect(0, 65267, '\p{^Is_Decomposition_Type= 	INITIAL}', "");
    Expect(0, 65267, '\P{Is_Decomposition_Type= 	INITIAL}', "");
    Expect(1, 65267, '\P{^Is_Decomposition_Type= 	INITIAL}', "");
    Expect(0, 65268, '\p{Is_Decomposition_Type= 	INITIAL}', "");
    Expect(1, 65268, '\p{^Is_Decomposition_Type= 	INITIAL}', "");
    Expect(1, 65268, '\P{Is_Decomposition_Type= 	INITIAL}', "");
    Expect(0, 65268, '\P{^Is_Decomposition_Type= 	INITIAL}', "");
    Error('\p{Is_Dt=_	Init/a/}');
    Error('\P{Is_Dt=_	Init/a/}');
    Expect(1, 65267, '\p{Is_Dt=init}', "");
    Expect(0, 65267, '\p{^Is_Dt=init}', "");
    Expect(0, 65267, '\P{Is_Dt=init}', "");
    Expect(1, 65267, '\P{^Is_Dt=init}', "");
    Expect(0, 65268, '\p{Is_Dt=init}', "");
    Expect(1, 65268, '\p{^Is_Dt=init}', "");
    Expect(1, 65268, '\P{Is_Dt=init}', "");
    Expect(0, 65268, '\P{^Is_Dt=init}', "");
    Error('\p{Decomposition_Type:/a/--Isolated}');
    Error('\P{Decomposition_Type:/a/--Isolated}');
    Expect(1, 65275, '\p{Decomposition_Type=:\AIsolated\z:}', "");;
    Expect(0, 65276, '\p{Decomposition_Type=:\AIsolated\z:}', "");;
    Expect(1, 65275, '\p{Decomposition_Type=isolated}', "");
    Expect(0, 65275, '\p{^Decomposition_Type=isolated}', "");
    Expect(0, 65275, '\P{Decomposition_Type=isolated}', "");
    Expect(1, 65275, '\P{^Decomposition_Type=isolated}', "");
    Expect(0, 65276, '\p{Decomposition_Type=isolated}', "");
    Expect(1, 65276, '\p{^Decomposition_Type=isolated}', "");
    Expect(1, 65276, '\P{Decomposition_Type=isolated}', "");
    Expect(0, 65276, '\P{^Decomposition_Type=isolated}', "");
    Expect(1, 65275, '\p{Decomposition_Type=:\Aisolated\z:}', "");;
    Expect(0, 65276, '\p{Decomposition_Type=:\Aisolated\z:}', "");;
    Expect(1, 65275, '\p{Decomposition_Type= -Isolated}', "");
    Expect(0, 65275, '\p{^Decomposition_Type= -Isolated}', "");
    Expect(0, 65275, '\P{Decomposition_Type= -Isolated}', "");
    Expect(1, 65275, '\P{^Decomposition_Type= -Isolated}', "");
    Expect(0, 65276, '\p{Decomposition_Type= -Isolated}', "");
    Expect(1, 65276, '\p{^Decomposition_Type= -Isolated}', "");
    Expect(1, 65276, '\P{Decomposition_Type= -Isolated}', "");
    Expect(0, 65276, '\P{^Decomposition_Type= -Isolated}', "");
    Error('\p{Dt=	_iso:=}');
    Error('\P{Dt=	_iso:=}');
    Expect(1, 65275, '\p{Dt=:\AIso\z:}', "");;
    Expect(0, 65276, '\p{Dt=:\AIso\z:}', "");;
    Expect(1, 65275, '\p{Dt=iso}', "");
    Expect(0, 65275, '\p{^Dt=iso}', "");
    Expect(0, 65275, '\P{Dt=iso}', "");
    Expect(1, 65275, '\P{^Dt=iso}', "");
    Expect(0, 65276, '\p{Dt=iso}', "");
    Expect(1, 65276, '\p{^Dt=iso}', "");
    Expect(1, 65276, '\P{Dt=iso}', "");
    Expect(0, 65276, '\P{^Dt=iso}', "");
    Expect(1, 65275, '\p{Dt=:\Aiso\z:}', "");;
    Expect(0, 65276, '\p{Dt=:\Aiso\z:}', "");;
    Expect(1, 65275, '\p{Dt=	-Iso}', "");
    Expect(0, 65275, '\p{^Dt=	-Iso}', "");
    Expect(0, 65275, '\P{Dt=	-Iso}', "");
    Expect(1, 65275, '\P{^Dt=	-Iso}', "");
    Expect(0, 65276, '\p{Dt=	-Iso}', "");
    Expect(1, 65276, '\p{^Dt=	-Iso}', "");
    Expect(1, 65276, '\P{Dt=	-Iso}', "");
    Expect(0, 65276, '\P{^Dt=	-Iso}', "");
    Error('\p{Is_Decomposition_Type=/a/		ISOLATED}');
    Error('\P{Is_Decomposition_Type=/a/		ISOLATED}');
    Expect(1, 65275, '\p{Is_Decomposition_Type=isolated}', "");
    Expect(0, 65275, '\p{^Is_Decomposition_Type=isolated}', "");
    Expect(0, 65275, '\P{Is_Decomposition_Type=isolated}', "");
    Expect(1, 65275, '\P{^Is_Decomposition_Type=isolated}', "");
    Expect(0, 65276, '\p{Is_Decomposition_Type=isolated}', "");
    Expect(1, 65276, '\p{^Is_Decomposition_Type=isolated}', "");
    Expect(1, 65276, '\P{Is_Decomposition_Type=isolated}', "");
    Expect(0, 65276, '\P{^Is_Decomposition_Type=isolated}', "");
    Expect(1, 65275, '\p{Is_Decomposition_Type=__isolated}', "");
    Expect(0, 65275, '\p{^Is_Decomposition_Type=__isolated}', "");
    Expect(0, 65275, '\P{Is_Decomposition_Type=__isolated}', "");
    Expect(1, 65275, '\P{^Is_Decomposition_Type=__isolated}', "");
    Expect(0, 65276, '\p{Is_Decomposition_Type=__isolated}', "");
    Expect(1, 65276, '\p{^Is_Decomposition_Type=__isolated}', "");
    Expect(1, 65276, '\P{Is_Decomposition_Type=__isolated}', "");
    Expect(0, 65276, '\P{^Is_Decomposition_Type=__isolated}', "");
    Error('\p{Is_Dt=__Iso/a/}');
    Error('\P{Is_Dt=__Iso/a/}');
    Expect(1, 65275, '\p{Is_Dt=iso}', "");
    Expect(0, 65275, '\p{^Is_Dt=iso}', "");
    Expect(0, 65275, '\P{Is_Dt=iso}', "");
    Expect(1, 65275, '\P{^Is_Dt=iso}', "");
    Expect(0, 65276, '\p{Is_Dt=iso}', "");
    Expect(1, 65276, '\p{^Is_Dt=iso}', "");
    Expect(1, 65276, '\P{Is_Dt=iso}', "");
    Expect(0, 65276, '\P{^Is_Dt=iso}', "");
    Expect(1, 65275, '\p{Is_Dt= 	Iso}', "");
    Expect(0, 65275, '\p{^Is_Dt= 	Iso}', "");
    Expect(0, 65275, '\P{Is_Dt= 	Iso}', "");
    Expect(1, 65275, '\P{^Is_Dt= 	Iso}', "");
    Expect(0, 65276, '\p{Is_Dt= 	Iso}', "");
    Expect(1, 65276, '\p{^Is_Dt= 	Iso}', "");
    Expect(1, 65276, '\P{Is_Dt= 	Iso}', "");
    Expect(0, 65276, '\P{^Is_Dt= 	Iso}', "");
    Error('\p{Decomposition_Type=:=Medial}');
    Error('\P{Decomposition_Type=:=Medial}');
    Expect(1, 65268, '\p{Decomposition_Type=:\AMedial\z:}', "");;
    Expect(0, 65269, '\p{Decomposition_Type=:\AMedial\z:}', "");;
    Expect(1, 65268, '\p{Decomposition_Type=medial}', "");
    Expect(0, 65268, '\p{^Decomposition_Type=medial}', "");
    Expect(0, 65268, '\P{Decomposition_Type=medial}', "");
    Expect(1, 65268, '\P{^Decomposition_Type=medial}', "");
    Expect(0, 65269, '\p{Decomposition_Type=medial}', "");
    Expect(1, 65269, '\p{^Decomposition_Type=medial}', "");
    Expect(1, 65269, '\P{Decomposition_Type=medial}', "");
    Expect(0, 65269, '\P{^Decomposition_Type=medial}', "");
    Expect(1, 65268, '\p{Decomposition_Type=:\Amedial\z:}', "");;
    Expect(0, 65269, '\p{Decomposition_Type=:\Amedial\z:}', "");;
    Expect(1, 65268, '\p{Decomposition_Type=- MEDIAL}', "");
    Expect(0, 65268, '\p{^Decomposition_Type=- MEDIAL}', "");
    Expect(0, 65268, '\P{Decomposition_Type=- MEDIAL}', "");
    Expect(1, 65268, '\P{^Decomposition_Type=- MEDIAL}', "");
    Expect(0, 65269, '\p{Decomposition_Type=- MEDIAL}', "");
    Expect(1, 65269, '\p{^Decomposition_Type=- MEDIAL}', "");
    Expect(1, 65269, '\P{Decomposition_Type=- MEDIAL}', "");
    Expect(0, 65269, '\P{^Decomposition_Type=- MEDIAL}', "");
    Error('\p{Dt=-	med:=}');
    Error('\P{Dt=-	med:=}');
    Expect(1, 65268, '\p{Dt=:\AMed\z:}', "");;
    Expect(0, 65269, '\p{Dt=:\AMed\z:}', "");;
    Expect(1, 65268, '\p{Dt=med}', "");
    Expect(0, 65268, '\p{^Dt=med}', "");
    Expect(0, 65268, '\P{Dt=med}', "");
    Expect(1, 65268, '\P{^Dt=med}', "");
    Expect(0, 65269, '\p{Dt=med}', "");
    Expect(1, 65269, '\p{^Dt=med}', "");
    Expect(1, 65269, '\P{Dt=med}', "");
    Expect(0, 65269, '\P{^Dt=med}', "");
    Expect(1, 65268, '\p{Dt=:\Amed\z:}', "");;
    Expect(0, 65269, '\p{Dt=:\Amed\z:}', "");;
    Expect(1, 65268, '\p{Dt=_Med}', "");
    Expect(0, 65268, '\p{^Dt=_Med}', "");
    Expect(0, 65268, '\P{Dt=_Med}', "");
    Expect(1, 65268, '\P{^Dt=_Med}', "");
    Expect(0, 65269, '\p{Dt=_Med}', "");
    Expect(1, 65269, '\p{^Dt=_Med}', "");
    Expect(1, 65269, '\P{Dt=_Med}', "");
    Expect(0, 65269, '\P{^Dt=_Med}', "");
    Error('\p{Is_Decomposition_Type=__medial:=}');
    Error('\P{Is_Decomposition_Type=__medial:=}');
    Expect(1, 65268, '\p{Is_Decomposition_Type=medial}', "");
    Expect(0, 65268, '\p{^Is_Decomposition_Type=medial}', "");
    Expect(0, 65268, '\P{Is_Decomposition_Type=medial}', "");
    Expect(1, 65268, '\P{^Is_Decomposition_Type=medial}', "");
    Expect(0, 65269, '\p{Is_Decomposition_Type=medial}', "");
    Expect(1, 65269, '\p{^Is_Decomposition_Type=medial}', "");
    Expect(1, 65269, '\P{Is_Decomposition_Type=medial}', "");
    Expect(0, 65269, '\P{^Is_Decomposition_Type=medial}', "");
    Expect(1, 65268, '\p{Is_Decomposition_Type= 	MEDIAL}', "");
    Expect(0, 65268, '\p{^Is_Decomposition_Type= 	MEDIAL}', "");
    Expect(0, 65268, '\P{Is_Decomposition_Type= 	MEDIAL}', "");
    Expect(1, 65268, '\P{^Is_Decomposition_Type= 	MEDIAL}', "");
    Expect(0, 65269, '\p{Is_Decomposition_Type= 	MEDIAL}', "");
    Expect(1, 65269, '\p{^Is_Decomposition_Type= 	MEDIAL}', "");
    Expect(1, 65269, '\P{Is_Decomposition_Type= 	MEDIAL}', "");
    Expect(0, 65269, '\P{^Is_Decomposition_Type= 	MEDIAL}', "");
    Error('\p{Is_Dt= med:=}');
    Error('\P{Is_Dt= med:=}');
    Expect(1, 65268, '\p{Is_Dt=med}', "");
    Expect(0, 65268, '\p{^Is_Dt=med}', "");
    Expect(0, 65268, '\P{Is_Dt=med}', "");
    Expect(1, 65268, '\P{^Is_Dt=med}', "");
    Expect(0, 65269, '\p{Is_Dt=med}', "");
    Expect(1, 65269, '\p{^Is_Dt=med}', "");
    Expect(1, 65269, '\P{Is_Dt=med}', "");
    Expect(0, 65269, '\P{^Is_Dt=med}', "");
    Expect(1, 65268, '\p{Is_Dt= _Med}', "");
    Expect(0, 65268, '\p{^Is_Dt= _Med}', "");
    Expect(0, 65268, '\P{Is_Dt= _Med}', "");
    Expect(1, 65268, '\P{^Is_Dt= _Med}', "");
    Expect(0, 65269, '\p{Is_Dt= _Med}', "");
    Expect(1, 65269, '\p{^Is_Dt= _Med}', "");
    Expect(1, 65269, '\P{Is_Dt= _Med}', "");
    Expect(0, 65269, '\P{^Is_Dt= _Med}', "");
    Error('\p{Decomposition_Type=_/a/NARROW}');
    Error('\P{Decomposition_Type=_/a/NARROW}');
    Expect(1, 65518, '\p{Decomposition_Type=:\ANarrow\z:}', "");;
    Expect(0, 65519, '\p{Decomposition_Type=:\ANarrow\z:}', "");;
    Expect(1, 65518, '\p{Decomposition_Type=narrow}', "");
    Expect(0, 65518, '\p{^Decomposition_Type=narrow}', "");
    Expect(0, 65518, '\P{Decomposition_Type=narrow}', "");
    Expect(1, 65518, '\P{^Decomposition_Type=narrow}', "");
    Expect(0, 65519, '\p{Decomposition_Type=narrow}', "");
    Expect(1, 65519, '\p{^Decomposition_Type=narrow}', "");
    Expect(1, 65519, '\P{Decomposition_Type=narrow}', "");
    Expect(0, 65519, '\P{^Decomposition_Type=narrow}', "");
    Expect(1, 65518, '\p{Decomposition_Type=:\Anarrow\z:}', "");;
    Expect(0, 65519, '\p{Decomposition_Type=:\Anarrow\z:}', "");;
    Expect(1, 65518, '\p{Decomposition_Type=-Narrow}', "");
    Expect(0, 65518, '\p{^Decomposition_Type=-Narrow}', "");
    Expect(0, 65518, '\P{Decomposition_Type=-Narrow}', "");
    Expect(1, 65518, '\P{^Decomposition_Type=-Narrow}', "");
    Expect(0, 65519, '\p{Decomposition_Type=-Narrow}', "");
    Expect(1, 65519, '\p{^Decomposition_Type=-Narrow}', "");
    Expect(1, 65519, '\P{Decomposition_Type=-Narrow}', "");
    Expect(0, 65519, '\P{^Decomposition_Type=-Narrow}', "");
    Error('\p{Dt=Nar/a/}');
    Error('\P{Dt=Nar/a/}');
    Expect(1, 65518, '\p{Dt=:\ANar\z:}', "");;
    Expect(0, 65519, '\p{Dt=:\ANar\z:}', "");;
    Expect(1, 65518, '\p{Dt=nar}', "");
    Expect(0, 65518, '\p{^Dt=nar}', "");
    Expect(0, 65518, '\P{Dt=nar}', "");
    Expect(1, 65518, '\P{^Dt=nar}', "");
    Expect(0, 65519, '\p{Dt=nar}', "");
    Expect(1, 65519, '\p{^Dt=nar}', "");
    Expect(1, 65519, '\P{Dt=nar}', "");
    Expect(0, 65519, '\P{^Dt=nar}', "");
    Expect(1, 65518, '\p{Dt=:\Anar\z:}', "");;
    Expect(0, 65519, '\p{Dt=:\Anar\z:}', "");;
    Expect(1, 65518, '\p{Dt= nar}', "");
    Expect(0, 65518, '\p{^Dt= nar}', "");
    Expect(0, 65518, '\P{Dt= nar}', "");
    Expect(1, 65518, '\P{^Dt= nar}', "");
    Expect(0, 65519, '\p{Dt= nar}', "");
    Expect(1, 65519, '\p{^Dt= nar}', "");
    Expect(1, 65519, '\P{Dt= nar}', "");
    Expect(0, 65519, '\P{^Dt= nar}', "");
    Error('\p{Is_Decomposition_Type=:= _Narrow}');
    Error('\P{Is_Decomposition_Type=:= _Narrow}');
    Expect(1, 65518, '\p{Is_Decomposition_Type=narrow}', "");
    Expect(0, 65518, '\p{^Is_Decomposition_Type=narrow}', "");
    Expect(0, 65518, '\P{Is_Decomposition_Type=narrow}', "");
    Expect(1, 65518, '\P{^Is_Decomposition_Type=narrow}', "");
    Expect(0, 65519, '\p{Is_Decomposition_Type=narrow}', "");
    Expect(1, 65519, '\p{^Is_Decomposition_Type=narrow}', "");
    Expect(1, 65519, '\P{Is_Decomposition_Type=narrow}', "");
    Expect(0, 65519, '\P{^Is_Decomposition_Type=narrow}', "");
    Expect(1, 65518, '\p{Is_Decomposition_Type=-narrow}', "");
    Expect(0, 65518, '\p{^Is_Decomposition_Type=-narrow}', "");
    Expect(0, 65518, '\P{Is_Decomposition_Type=-narrow}', "");
    Expect(1, 65518, '\P{^Is_Decomposition_Type=-narrow}', "");
    Expect(0, 65519, '\p{Is_Decomposition_Type=-narrow}', "");
    Expect(1, 65519, '\p{^Is_Decomposition_Type=-narrow}', "");
    Expect(1, 65519, '\P{Is_Decomposition_Type=-narrow}', "");
    Expect(0, 65519, '\P{^Is_Decomposition_Type=-narrow}', "");
    Error('\p{Is_Dt=__nar:=}');
    Error('\P{Is_Dt=__nar:=}');
    Expect(1, 65518, '\p{Is_Dt=nar}', "");
    Expect(0, 65518, '\p{^Is_Dt=nar}', "");
    Expect(0, 65518, '\P{Is_Dt=nar}', "");
    Expect(1, 65518, '\P{^Is_Dt=nar}', "");
    Expect(0, 65519, '\p{Is_Dt=nar}', "");
    Expect(1, 65519, '\p{^Is_Dt=nar}', "");
    Expect(1, 65519, '\P{Is_Dt=nar}', "");
    Expect(0, 65519, '\P{^Is_Dt=nar}', "");
    Expect(1, 65518, '\p{Is_Dt=_-Nar}', "");
    Expect(0, 65518, '\p{^Is_Dt=_-Nar}', "");
    Expect(0, 65518, '\P{Is_Dt=_-Nar}', "");
    Expect(1, 65518, '\P{^Is_Dt=_-Nar}', "");
    Expect(0, 65519, '\p{Is_Dt=_-Nar}', "");
    Expect(1, 65519, '\p{^Is_Dt=_-Nar}', "");
    Expect(1, 65519, '\P{Is_Dt=_-Nar}', "");
    Expect(0, 65519, '\P{^Is_Dt=_-Nar}', "");
    Error('\p{Decomposition_Type=_:=NOBREAK}');
    Error('\P{Decomposition_Type=_:=NOBREAK}');
    Expect(1, 8239, '\p{Decomposition_Type=:\ANobreak\z:}', "");;
    Expect(0, 8240, '\p{Decomposition_Type=:\ANobreak\z:}', "");;
    Expect(1, 8239, '\p{Decomposition_Type: nobreak}', "");
    Expect(0, 8239, '\p{^Decomposition_Type: nobreak}', "");
    Expect(0, 8239, '\P{Decomposition_Type: nobreak}', "");
    Expect(1, 8239, '\P{^Decomposition_Type: nobreak}', "");
    Expect(0, 8240, '\p{Decomposition_Type: nobreak}', "");
    Expect(1, 8240, '\p{^Decomposition_Type: nobreak}', "");
    Expect(1, 8240, '\P{Decomposition_Type: nobreak}', "");
    Expect(0, 8240, '\P{^Decomposition_Type: nobreak}', "");
    Expect(1, 8239, '\p{Decomposition_Type=:\Anobreak\z:}', "");;
    Expect(0, 8240, '\p{Decomposition_Type=:\Anobreak\z:}', "");;
    Expect(1, 8239, '\p{Decomposition_Type=- nobreak}', "");
    Expect(0, 8239, '\p{^Decomposition_Type=- nobreak}', "");
    Expect(0, 8239, '\P{Decomposition_Type=- nobreak}', "");
    Expect(1, 8239, '\P{^Decomposition_Type=- nobreak}', "");
    Expect(0, 8240, '\p{Decomposition_Type=- nobreak}', "");
    Expect(1, 8240, '\p{^Decomposition_Type=- nobreak}', "");
    Expect(1, 8240, '\P{Decomposition_Type=- nobreak}', "");
    Expect(0, 8240, '\P{^Decomposition_Type=- nobreak}', "");
    Error('\p{Dt=_-NB/a/}');
    Error('\P{Dt=_-NB/a/}');
    Expect(1, 8239, '\p{Dt=:\ANb\z:}', "");;
    Expect(0, 8240, '\p{Dt=:\ANb\z:}', "");;
    Expect(1, 8239, '\p{Dt=nb}', "");
    Expect(0, 8239, '\p{^Dt=nb}', "");
    Expect(0, 8239, '\P{Dt=nb}', "");
    Expect(1, 8239, '\P{^Dt=nb}', "");
    Expect(0, 8240, '\p{Dt=nb}', "");
    Expect(1, 8240, '\p{^Dt=nb}', "");
    Expect(1, 8240, '\P{Dt=nb}', "");
    Expect(0, 8240, '\P{^Dt=nb}', "");
    Expect(1, 8239, '\p{Dt=:\Anb\z:}', "");;
    Expect(0, 8240, '\p{Dt=:\Anb\z:}', "");;
    Expect(1, 8239, '\p{Dt= Nb}', "");
    Expect(0, 8239, '\p{^Dt= Nb}', "");
    Expect(0, 8239, '\P{Dt= Nb}', "");
    Expect(1, 8239, '\P{^Dt= Nb}', "");
    Expect(0, 8240, '\p{Dt= Nb}', "");
    Expect(1, 8240, '\p{^Dt= Nb}', "");
    Expect(1, 8240, '\P{Dt= Nb}', "");
    Expect(0, 8240, '\P{^Dt= Nb}', "");
    Error('\p{Is_Decomposition_Type:   :=_Nobreak}');
    Error('\P{Is_Decomposition_Type:   :=_Nobreak}');
    Expect(1, 8239, '\p{Is_Decomposition_Type=nobreak}', "");
    Expect(0, 8239, '\p{^Is_Decomposition_Type=nobreak}', "");
    Expect(0, 8239, '\P{Is_Decomposition_Type=nobreak}', "");
    Expect(1, 8239, '\P{^Is_Decomposition_Type=nobreak}', "");
    Expect(0, 8240, '\p{Is_Decomposition_Type=nobreak}', "");
    Expect(1, 8240, '\p{^Is_Decomposition_Type=nobreak}', "");
    Expect(1, 8240, '\P{Is_Decomposition_Type=nobreak}', "");
    Expect(0, 8240, '\P{^Is_Decomposition_Type=nobreak}', "");
    Expect(1, 8239, '\p{Is_Decomposition_Type=__nobreak}', "");
    Expect(0, 8239, '\p{^Is_Decomposition_Type=__nobreak}', "");
    Expect(0, 8239, '\P{Is_Decomposition_Type=__nobreak}', "");
    Expect(1, 8239, '\P{^Is_Decomposition_Type=__nobreak}', "");
    Expect(0, 8240, '\p{Is_Decomposition_Type=__nobreak}', "");
    Expect(1, 8240, '\p{^Is_Decomposition_Type=__nobreak}', "");
    Expect(1, 8240, '\P{Is_Decomposition_Type=__nobreak}', "");
    Expect(0, 8240, '\P{^Is_Decomposition_Type=__nobreak}', "");
    Error('\p{Is_Dt=:=-Nb}');
    Error('\P{Is_Dt=:=-Nb}');
    Expect(1, 8239, '\p{Is_Dt:	nb}', "");
    Expect(0, 8239, '\p{^Is_Dt:	nb}', "");
    Expect(0, 8239, '\P{Is_Dt:	nb}', "");
    Expect(1, 8239, '\P{^Is_Dt:	nb}', "");
    Expect(0, 8240, '\p{Is_Dt:	nb}', "");
    Expect(1, 8240, '\p{^Is_Dt:	nb}', "");
    Expect(1, 8240, '\P{Is_Dt:	nb}', "");
    Expect(0, 8240, '\P{^Is_Dt:	nb}', "");
    Expect(1, 8239, '\p{Is_Dt:	_-Nb}', "");
    Expect(0, 8239, '\p{^Is_Dt:	_-Nb}', "");
    Expect(0, 8239, '\P{Is_Dt:	_-Nb}', "");
    Expect(1, 8239, '\P{^Is_Dt:	_-Nb}', "");
    Expect(0, 8240, '\p{Is_Dt:	_-Nb}', "");
    Expect(1, 8240, '\p{^Is_Dt:	_-Nb}', "");
    Expect(1, 8240, '\P{Is_Dt:	_-Nb}', "");
    Expect(0, 8240, '\P{^Is_Dt:	_-Nb}', "");
    Error('\p{Decomposition_Type=/a/ NON_Canonical}');
    Error('\P{Decomposition_Type=/a/ NON_Canonical}');
    Expect(1, 127569, '\p{Decomposition_Type=:\ANon_Canonical\z:}', "");;
    Expect(0, 127570, '\p{Decomposition_Type=:\ANon_Canonical\z:}', "");;
    Expect(1, 127569, '\p{Decomposition_Type=noncanonical}', "");
    Expect(0, 127569, '\p{^Decomposition_Type=noncanonical}', "");
    Expect(0, 127569, '\P{Decomposition_Type=noncanonical}', "");
    Expect(1, 127569, '\P{^Decomposition_Type=noncanonical}', "");
    Expect(0, 127570, '\p{Decomposition_Type=noncanonical}', "");
    Expect(1, 127570, '\p{^Decomposition_Type=noncanonical}', "");
    Expect(1, 127570, '\P{Decomposition_Type=noncanonical}', "");
    Expect(0, 127570, '\P{^Decomposition_Type=noncanonical}', "");
    Expect(1, 127569, '\p{Decomposition_Type=:\Anoncanonical\z:}', "");;
    Expect(0, 127570, '\p{Decomposition_Type=:\Anoncanonical\z:}', "");;
    Expect(1, 127569, '\p{Decomposition_Type=_ NON_CANONICAL}', "");
    Expect(0, 127569, '\p{^Decomposition_Type=_ NON_CANONICAL}', "");
    Expect(0, 127569, '\P{Decomposition_Type=_ NON_CANONICAL}', "");
    Expect(1, 127569, '\P{^Decomposition_Type=_ NON_CANONICAL}', "");
    Expect(0, 127570, '\p{Decomposition_Type=_ NON_CANONICAL}', "");
    Expect(1, 127570, '\p{^Decomposition_Type=_ NON_CANONICAL}', "");
    Expect(1, 127570, '\P{Decomposition_Type=_ NON_CANONICAL}', "");
    Expect(0, 127570, '\P{^Decomposition_Type=_ NON_CANONICAL}', "");
    Error('\p{Dt= :=Non_canon}');
    Error('\P{Dt= :=Non_canon}');
    Expect(1, 127569, '\p{Dt=:\ANon_Canon\z:}', "");;
    Expect(0, 127570, '\p{Dt=:\ANon_Canon\z:}', "");;
    Expect(1, 127569, '\p{Dt=noncanon}', "");
    Expect(0, 127569, '\p{^Dt=noncanon}', "");
    Expect(0, 127569, '\P{Dt=noncanon}', "");
    Expect(1, 127569, '\P{^Dt=noncanon}', "");
    Expect(0, 127570, '\p{Dt=noncanon}', "");
    Expect(1, 127570, '\p{^Dt=noncanon}', "");
    Expect(1, 127570, '\P{Dt=noncanon}', "");
    Expect(0, 127570, '\P{^Dt=noncanon}', "");
    Expect(1, 127569, '\p{Dt=:\Anoncanon\z:}', "");;
    Expect(0, 127570, '\p{Dt=:\Anoncanon\z:}', "");;
    Expect(1, 127569, '\p{Dt= -Non_canon}', "");
    Expect(0, 127569, '\p{^Dt= -Non_canon}', "");
    Expect(0, 127569, '\P{Dt= -Non_canon}', "");
    Expect(1, 127569, '\P{^Dt= -Non_canon}', "");
    Expect(0, 127570, '\p{Dt= -Non_canon}', "");
    Expect(1, 127570, '\p{^Dt= -Non_canon}', "");
    Expect(1, 127570, '\P{Dt= -Non_canon}', "");
    Expect(0, 127570, '\P{^Dt= -Non_canon}', "");
    Error('\p{Is_Decomposition_Type=_ Non_Canonical:=}');
    Error('\P{Is_Decomposition_Type=_ Non_Canonical:=}');
    Expect(1, 127569, '\p{Is_Decomposition_Type=noncanonical}', "");
    Expect(0, 127569, '\p{^Is_Decomposition_Type=noncanonical}', "");
    Expect(0, 127569, '\P{Is_Decomposition_Type=noncanonical}', "");
    Expect(1, 127569, '\P{^Is_Decomposition_Type=noncanonical}', "");
    Expect(0, 127570, '\p{Is_Decomposition_Type=noncanonical}', "");
    Expect(1, 127570, '\p{^Is_Decomposition_Type=noncanonical}', "");
    Expect(1, 127570, '\P{Is_Decomposition_Type=noncanonical}', "");
    Expect(0, 127570, '\P{^Is_Decomposition_Type=noncanonical}', "");
    Expect(1, 127569, '\p{Is_Decomposition_Type=		Non_canonical}', "");
    Expect(0, 127569, '\p{^Is_Decomposition_Type=		Non_canonical}', "");
    Expect(0, 127569, '\P{Is_Decomposition_Type=		Non_canonical}', "");
    Expect(1, 127569, '\P{^Is_Decomposition_Type=		Non_canonical}', "");
    Expect(0, 127570, '\p{Is_Decomposition_Type=		Non_canonical}', "");
    Expect(1, 127570, '\p{^Is_Decomposition_Type=		Non_canonical}', "");
    Expect(1, 127570, '\P{Is_Decomposition_Type=		Non_canonical}', "");
    Expect(0, 127570, '\P{^Is_Decomposition_Type=		Non_canonical}', "");
    Error('\p{Is_Dt=-:=Non_CANON}');
    Error('\P{Is_Dt=-:=Non_CANON}');
    Expect(1, 127569, '\p{Is_Dt=noncanon}', "");
    Expect(0, 127569, '\p{^Is_Dt=noncanon}', "");
    Expect(0, 127569, '\P{Is_Dt=noncanon}', "");
    Expect(1, 127569, '\P{^Is_Dt=noncanon}', "");
    Expect(0, 127570, '\p{Is_Dt=noncanon}', "");
    Expect(1, 127570, '\p{^Is_Dt=noncanon}', "");
    Expect(1, 127570, '\P{Is_Dt=noncanon}', "");
    Expect(0, 127570, '\P{^Is_Dt=noncanon}', "");
    Expect(1, 127569, '\p{Is_Dt=_	NON_Canon}', "");
    Expect(0, 127569, '\p{^Is_Dt=_	NON_Canon}', "");
    Expect(0, 127569, '\P{Is_Dt=_	NON_Canon}', "");
    Expect(1, 127569, '\P{^Is_Dt=_	NON_Canon}', "");
    Expect(0, 127570, '\p{Is_Dt=_	NON_Canon}', "");
    Expect(1, 127570, '\p{^Is_Dt=_	NON_Canon}', "");
    Expect(1, 127570, '\P{Is_Dt=_	NON_Canon}', "");
    Expect(0, 127570, '\P{^Is_Dt=_	NON_Canon}', "");
    Error('\p{Decomposition_Type: none/a/}');
    Error('\P{Decomposition_Type: none/a/}');
    Expect(1, 195102, '\p{Decomposition_Type=:\ANone\z:}', "");;
    Expect(0, 195101, '\p{Decomposition_Type=:\ANone\z:}', "");;
    Expect(1, 195102, '\p{Decomposition_Type=none}', "");
    Expect(0, 195102, '\p{^Decomposition_Type=none}', "");
    Expect(0, 195102, '\P{Decomposition_Type=none}', "");
    Expect(1, 195102, '\P{^Decomposition_Type=none}', "");
    Expect(0, 195101, '\p{Decomposition_Type=none}', "");
    Expect(1, 195101, '\p{^Decomposition_Type=none}', "");
    Expect(1, 195101, '\P{Decomposition_Type=none}', "");
    Expect(0, 195101, '\P{^Decomposition_Type=none}', "");
    Expect(1, 195102, '\p{Decomposition_Type=:\Anone\z:}', "");;
    Expect(0, 195101, '\p{Decomposition_Type=:\Anone\z:}', "");;
    Expect(1, 195102, '\p{Decomposition_Type= none}', "");
    Expect(0, 195102, '\p{^Decomposition_Type= none}', "");
    Expect(0, 195102, '\P{Decomposition_Type= none}', "");
    Expect(1, 195102, '\P{^Decomposition_Type= none}', "");
    Expect(0, 195101, '\p{Decomposition_Type= none}', "");
    Expect(1, 195101, '\p{^Decomposition_Type= none}', "");
    Expect(1, 195101, '\P{Decomposition_Type= none}', "");
    Expect(0, 195101, '\P{^Decomposition_Type= none}', "");
    Error('\p{Dt= /a/None}');
    Error('\P{Dt= /a/None}');
    Expect(1, 195102, '\p{Dt=:\ANone\z:}', "");;
    Expect(0, 195101, '\p{Dt=:\ANone\z:}', "");;
    Expect(1, 195102, '\p{Dt=none}', "");
    Expect(0, 195102, '\p{^Dt=none}', "");
    Expect(0, 195102, '\P{Dt=none}', "");
    Expect(1, 195102, '\P{^Dt=none}', "");
    Expect(0, 195101, '\p{Dt=none}', "");
    Expect(1, 195101, '\p{^Dt=none}', "");
    Expect(1, 195101, '\P{Dt=none}', "");
    Expect(0, 195101, '\P{^Dt=none}', "");
    Expect(1, 195102, '\p{Dt=:\Anone\z:}', "");;
    Expect(0, 195101, '\p{Dt=:\Anone\z:}', "");;
    Expect(1, 195102, '\p{Dt=-	None}', "");
    Expect(0, 195102, '\p{^Dt=-	None}', "");
    Expect(0, 195102, '\P{Dt=-	None}', "");
    Expect(1, 195102, '\P{^Dt=-	None}', "");
    Expect(0, 195101, '\p{Dt=-	None}', "");
    Expect(1, 195101, '\p{^Dt=-	None}', "");
    Expect(1, 195101, '\P{Dt=-	None}', "");
    Expect(0, 195101, '\P{^Dt=-	None}', "");
    Error('\p{Is_Decomposition_Type=	/a/NONE}');
    Error('\P{Is_Decomposition_Type=	/a/NONE}');
    Expect(1, 195102, '\p{Is_Decomposition_Type=none}', "");
    Expect(0, 195102, '\p{^Is_Decomposition_Type=none}', "");
    Expect(0, 195102, '\P{Is_Decomposition_Type=none}', "");
    Expect(1, 195102, '\P{^Is_Decomposition_Type=none}', "");
    Expect(0, 195101, '\p{Is_Decomposition_Type=none}', "");
    Expect(1, 195101, '\p{^Is_Decomposition_Type=none}', "");
    Expect(1, 195101, '\P{Is_Decomposition_Type=none}', "");
    Expect(0, 195101, '\P{^Is_Decomposition_Type=none}', "");
    Expect(1, 195102, '\p{Is_Decomposition_Type= 	None}', "");
    Expect(0, 195102, '\p{^Is_Decomposition_Type= 	None}', "");
    Expect(0, 195102, '\P{Is_Decomposition_Type= 	None}', "");
    Expect(1, 195102, '\P{^Is_Decomposition_Type= 	None}', "");
    Expect(0, 195101, '\p{Is_Decomposition_Type= 	None}', "");
    Expect(1, 195101, '\p{^Is_Decomposition_Type= 	None}', "");
    Expect(1, 195101, '\P{Is_Decomposition_Type= 	None}', "");
    Expect(0, 195101, '\P{^Is_Decomposition_Type= 	None}', "");
    Error('\p{Is_Dt=:=_None}');
    Error('\P{Is_Dt=:=_None}');
    Expect(1, 195102, '\p{Is_Dt=none}', "");
    Expect(0, 195102, '\p{^Is_Dt=none}', "");
    Expect(0, 195102, '\P{Is_Dt=none}', "");
    Expect(1, 195102, '\P{^Is_Dt=none}', "");
    Expect(0, 195101, '\p{Is_Dt=none}', "");
    Expect(1, 195101, '\p{^Is_Dt=none}', "");
    Expect(1, 195101, '\P{Is_Dt=none}', "");
    Expect(0, 195101, '\P{^Is_Dt=none}', "");
    Expect(1, 195102, '\p{Is_Dt=None}', "");
    Expect(0, 195102, '\p{^Is_Dt=None}', "");
    Expect(0, 195102, '\P{Is_Dt=None}', "");
    Expect(1, 195102, '\P{^Is_Dt=None}', "");
    Expect(0, 195101, '\p{Is_Dt=None}', "");
    Expect(1, 195101, '\p{^Is_Dt=None}', "");
    Expect(1, 195101, '\P{Is_Dt=None}', "");
    Expect(0, 195101, '\P{^Is_Dt=None}', "");
    Error('\p{Decomposition_Type=_small:=}');
    Error('\P{Decomposition_Type=_small:=}');
    Expect(1, 65131, '\p{Decomposition_Type=:\ASmall\z:}', "");;
    Expect(0, 65132, '\p{Decomposition_Type=:\ASmall\z:}', "");;
    Expect(1, 65131, '\p{Decomposition_Type=small}', "");
    Expect(0, 65131, '\p{^Decomposition_Type=small}', "");
    Expect(0, 65131, '\P{Decomposition_Type=small}', "");
    Expect(1, 65131, '\P{^Decomposition_Type=small}', "");
    Expect(0, 65132, '\p{Decomposition_Type=small}', "");
    Expect(1, 65132, '\p{^Decomposition_Type=small}', "");
    Expect(1, 65132, '\P{Decomposition_Type=small}', "");
    Expect(0, 65132, '\P{^Decomposition_Type=small}', "");
    Expect(1, 65131, '\p{Decomposition_Type=:\Asmall\z:}', "");;
    Expect(0, 65132, '\p{Decomposition_Type=:\Asmall\z:}', "");;
    Expect(1, 65131, '\p{Decomposition_Type=SMALL}', "");
    Expect(0, 65131, '\p{^Decomposition_Type=SMALL}', "");
    Expect(0, 65131, '\P{Decomposition_Type=SMALL}', "");
    Expect(1, 65131, '\P{^Decomposition_Type=SMALL}', "");
    Expect(0, 65132, '\p{Decomposition_Type=SMALL}', "");
    Expect(1, 65132, '\p{^Decomposition_Type=SMALL}', "");
    Expect(1, 65132, '\P{Decomposition_Type=SMALL}', "");
    Expect(0, 65132, '\P{^Decomposition_Type=SMALL}', "");
    Error('\p{Dt= /a/Sml}');
    Error('\P{Dt= /a/Sml}');
    Expect(1, 65131, '\p{Dt=:\ASml\z:}', "");;
    Expect(0, 65132, '\p{Dt=:\ASml\z:}', "");;
    Expect(1, 65131, '\p{Dt=sml}', "");
    Expect(0, 65131, '\p{^Dt=sml}', "");
    Expect(0, 65131, '\P{Dt=sml}', "");
    Expect(1, 65131, '\P{^Dt=sml}', "");
    Expect(0, 65132, '\p{Dt=sml}', "");
    Expect(1, 65132, '\p{^Dt=sml}', "");
    Expect(1, 65132, '\P{Dt=sml}', "");
    Expect(0, 65132, '\P{^Dt=sml}', "");
    Expect(1, 65131, '\p{Dt=:\Asml\z:}', "");;
    Expect(0, 65132, '\p{Dt=:\Asml\z:}', "");;
    Expect(1, 65131, '\p{Dt=  Sml}', "");
    Expect(0, 65131, '\p{^Dt=  Sml}', "");
    Expect(0, 65131, '\P{Dt=  Sml}', "");
    Expect(1, 65131, '\P{^Dt=  Sml}', "");
    Expect(0, 65132, '\p{Dt=  Sml}', "");
    Expect(1, 65132, '\p{^Dt=  Sml}', "");
    Expect(1, 65132, '\P{Dt=  Sml}', "");
    Expect(0, 65132, '\P{^Dt=  Sml}', "");
    Error('\p{Is_Decomposition_Type=:=-Small}');
    Error('\P{Is_Decomposition_Type=:=-Small}');
    Expect(1, 65131, '\p{Is_Decomposition_Type=small}', "");
    Expect(0, 65131, '\p{^Is_Decomposition_Type=small}', "");
    Expect(0, 65131, '\P{Is_Decomposition_Type=small}', "");
    Expect(1, 65131, '\P{^Is_Decomposition_Type=small}', "");
    Expect(0, 65132, '\p{Is_Decomposition_Type=small}', "");
    Expect(1, 65132, '\p{^Is_Decomposition_Type=small}', "");
    Expect(1, 65132, '\P{Is_Decomposition_Type=small}', "");
    Expect(0, 65132, '\P{^Is_Decomposition_Type=small}', "");
    Expect(1, 65131, '\p{Is_Decomposition_Type=- SMALL}', "");
    Expect(0, 65131, '\p{^Is_Decomposition_Type=- SMALL}', "");
    Expect(0, 65131, '\P{Is_Decomposition_Type=- SMALL}', "");
    Expect(1, 65131, '\P{^Is_Decomposition_Type=- SMALL}', "");
    Expect(0, 65132, '\p{Is_Decomposition_Type=- SMALL}', "");
    Expect(1, 65132, '\p{^Is_Decomposition_Type=- SMALL}', "");
    Expect(1, 65132, '\P{Is_Decomposition_Type=- SMALL}', "");
    Expect(0, 65132, '\P{^Is_Decomposition_Type=- SMALL}', "");
    Error('\p{Is_Dt=:=_sml}');
    Error('\P{Is_Dt=:=_sml}');
    Expect(1, 65131, '\p{Is_Dt=sml}', "");
    Expect(0, 65131, '\p{^Is_Dt=sml}', "");
    Expect(0, 65131, '\P{Is_Dt=sml}', "");
    Expect(1, 65131, '\P{^Is_Dt=sml}', "");
    Expect(0, 65132, '\p{Is_Dt=sml}', "");
    Expect(1, 65132, '\p{^Is_Dt=sml}', "");
    Expect(1, 65132, '\P{Is_Dt=sml}', "");
    Expect(0, 65132, '\P{^Is_Dt=sml}', "");
    Expect(1, 65131, '\p{Is_Dt=-	Sml}', "");
    Expect(0, 65131, '\p{^Is_Dt=-	Sml}', "");
    Expect(0, 65131, '\P{Is_Dt=-	Sml}', "");
    Expect(1, 65131, '\P{^Is_Dt=-	Sml}', "");
    Expect(0, 65132, '\p{Is_Dt=-	Sml}', "");
    Expect(1, 65132, '\p{^Is_Dt=-	Sml}', "");
    Expect(1, 65132, '\P{Is_Dt=-	Sml}', "");
    Expect(0, 65132, '\P{^Is_Dt=-	Sml}', "");
    Error('\p{Decomposition_Type=	 Square/a/}');
    Error('\P{Decomposition_Type=	 Square/a/}');
    Expect(1, 127547, '\p{Decomposition_Type=:\ASquare\z:}', "");;
    Expect(0, 127548, '\p{Decomposition_Type=:\ASquare\z:}', "");;
    Expect(1, 127547, '\p{Decomposition_Type=square}', "");
    Expect(0, 127547, '\p{^Decomposition_Type=square}', "");
    Expect(0, 127547, '\P{Decomposition_Type=square}', "");
    Expect(1, 127547, '\P{^Decomposition_Type=square}', "");
    Expect(0, 127548, '\p{Decomposition_Type=square}', "");
    Expect(1, 127548, '\p{^Decomposition_Type=square}', "");
    Expect(1, 127548, '\P{Decomposition_Type=square}', "");
    Expect(0, 127548, '\P{^Decomposition_Type=square}', "");
    Expect(1, 127547, '\p{Decomposition_Type=:\Asquare\z:}', "");;
    Expect(0, 127548, '\p{Decomposition_Type=:\Asquare\z:}', "");;
    Expect(1, 127547, '\p{Decomposition_Type=	_Square}', "");
    Expect(0, 127547, '\p{^Decomposition_Type=	_Square}', "");
    Expect(0, 127547, '\P{Decomposition_Type=	_Square}', "");
    Expect(1, 127547, '\P{^Decomposition_Type=	_Square}', "");
    Expect(0, 127548, '\p{Decomposition_Type=	_Square}', "");
    Expect(1, 127548, '\p{^Decomposition_Type=	_Square}', "");
    Expect(1, 127548, '\P{Decomposition_Type=	_Square}', "");
    Expect(0, 127548, '\P{^Decomposition_Type=	_Square}', "");
    Error('\p{Dt: -Sqr/a/}');
    Error('\P{Dt: -Sqr/a/}');
    Expect(1, 127547, '\p{Dt=:\ASqr\z:}', "");;
    Expect(0, 127548, '\p{Dt=:\ASqr\z:}', "");;
    Expect(1, 127547, '\p{Dt=sqr}', "");
    Expect(0, 127547, '\p{^Dt=sqr}', "");
    Expect(0, 127547, '\P{Dt=sqr}', "");
    Expect(1, 127547, '\P{^Dt=sqr}', "");
    Expect(0, 127548, '\p{Dt=sqr}', "");
    Expect(1, 127548, '\p{^Dt=sqr}', "");
    Expect(1, 127548, '\P{Dt=sqr}', "");
    Expect(0, 127548, '\P{^Dt=sqr}', "");
    Expect(1, 127547, '\p{Dt=:\Asqr\z:}', "");;
    Expect(0, 127548, '\p{Dt=:\Asqr\z:}', "");;
    Expect(1, 127547, '\p{Dt=	_Sqr}', "");
    Expect(0, 127547, '\p{^Dt=	_Sqr}', "");
    Expect(0, 127547, '\P{Dt=	_Sqr}', "");
    Expect(1, 127547, '\P{^Dt=	_Sqr}', "");
    Expect(0, 127548, '\p{Dt=	_Sqr}', "");
    Expect(1, 127548, '\p{^Dt=	_Sqr}', "");
    Expect(1, 127548, '\P{Dt=	_Sqr}', "");
    Expect(0, 127548, '\P{^Dt=	_Sqr}', "");
    Error('\p{Is_Decomposition_Type=Square:=}');
    Error('\P{Is_Decomposition_Type=Square:=}');
    Expect(1, 127547, '\p{Is_Decomposition_Type=square}', "");
    Expect(0, 127547, '\p{^Is_Decomposition_Type=square}', "");
    Expect(0, 127547, '\P{Is_Decomposition_Type=square}', "");
    Expect(1, 127547, '\P{^Is_Decomposition_Type=square}', "");
    Expect(0, 127548, '\p{Is_Decomposition_Type=square}', "");
    Expect(1, 127548, '\p{^Is_Decomposition_Type=square}', "");
    Expect(1, 127548, '\P{Is_Decomposition_Type=square}', "");
    Expect(0, 127548, '\P{^Is_Decomposition_Type=square}', "");
    Expect(1, 127547, '\p{Is_Decomposition_Type=	_SQUARE}', "");
    Expect(0, 127547, '\p{^Is_Decomposition_Type=	_SQUARE}', "");
    Expect(0, 127547, '\P{Is_Decomposition_Type=	_SQUARE}', "");
    Expect(1, 127547, '\P{^Is_Decomposition_Type=	_SQUARE}', "");
    Expect(0, 127548, '\p{Is_Decomposition_Type=	_SQUARE}', "");
    Expect(1, 127548, '\p{^Is_Decomposition_Type=	_SQUARE}', "");
    Expect(1, 127548, '\P{Is_Decomposition_Type=	_SQUARE}', "");
    Expect(0, 127548, '\P{^Is_Decomposition_Type=	_SQUARE}', "");
    Error('\p{Is_Dt=	Sqr:=}');
    Error('\P{Is_Dt=	Sqr:=}');
    Expect(1, 127547, '\p{Is_Dt=sqr}', "");
    Expect(0, 127547, '\p{^Is_Dt=sqr}', "");
    Expect(0, 127547, '\P{Is_Dt=sqr}', "");
    Expect(1, 127547, '\P{^Is_Dt=sqr}', "");
    Expect(0, 127548, '\p{Is_Dt=sqr}', "");
    Expect(1, 127548, '\p{^Is_Dt=sqr}', "");
    Expect(1, 127548, '\P{Is_Dt=sqr}', "");
    Expect(0, 127548, '\P{^Is_Dt=sqr}', "");
    Expect(1, 127547, '\p{Is_Dt= sqr}', "");
    Expect(0, 127547, '\p{^Is_Dt= sqr}', "");
    Expect(0, 127547, '\P{Is_Dt= sqr}', "");
    Expect(1, 127547, '\P{^Is_Dt= sqr}', "");
    Expect(0, 127548, '\p{Is_Dt= sqr}', "");
    Expect(1, 127548, '\p{^Is_Dt= sqr}', "");
    Expect(1, 127548, '\P{Is_Dt= sqr}', "");
    Expect(0, 127548, '\P{^Is_Dt= sqr}', "");
    Error('\p{Decomposition_Type=-/a/SUB}');
    Error('\P{Decomposition_Type=-/a/SUB}');
    Expect(1, 11388, '\p{Decomposition_Type=:\ASub\z:}', "");;
    Expect(0, 11389, '\p{Decomposition_Type=:\ASub\z:}', "");;
    Expect(1, 11388, '\p{Decomposition_Type=sub}', "");
    Expect(0, 11388, '\p{^Decomposition_Type=sub}', "");
    Expect(0, 11388, '\P{Decomposition_Type=sub}', "");
    Expect(1, 11388, '\P{^Decomposition_Type=sub}', "");
    Expect(0, 11389, '\p{Decomposition_Type=sub}', "");
    Expect(1, 11389, '\p{^Decomposition_Type=sub}', "");
    Expect(1, 11389, '\P{Decomposition_Type=sub}', "");
    Expect(0, 11389, '\P{^Decomposition_Type=sub}', "");
    Expect(1, 11388, '\p{Decomposition_Type=:\Asub\z:}', "");;
    Expect(0, 11389, '\p{Decomposition_Type=:\Asub\z:}', "");;
    Expect(1, 11388, '\p{Decomposition_Type=--sub}', "");
    Expect(0, 11388, '\p{^Decomposition_Type=--sub}', "");
    Expect(0, 11388, '\P{Decomposition_Type=--sub}', "");
    Expect(1, 11388, '\P{^Decomposition_Type=--sub}', "");
    Expect(0, 11389, '\p{Decomposition_Type=--sub}', "");
    Expect(1, 11389, '\p{^Decomposition_Type=--sub}', "");
    Expect(1, 11389, '\P{Decomposition_Type=--sub}', "");
    Expect(0, 11389, '\P{^Decomposition_Type=--sub}', "");
    Error('\p{Dt=:=_Sub}');
    Error('\P{Dt=:=_Sub}');
    Expect(1, 11388, '\p{Dt=:\ASub\z:}', "");;
    Expect(0, 11389, '\p{Dt=:\ASub\z:}', "");;
    Expect(1, 11388, '\p{Dt=sub}', "");
    Expect(0, 11388, '\p{^Dt=sub}', "");
    Expect(0, 11388, '\P{Dt=sub}', "");
    Expect(1, 11388, '\P{^Dt=sub}', "");
    Expect(0, 11389, '\p{Dt=sub}', "");
    Expect(1, 11389, '\p{^Dt=sub}', "");
    Expect(1, 11389, '\P{Dt=sub}', "");
    Expect(0, 11389, '\P{^Dt=sub}', "");
    Expect(1, 11388, '\p{Dt=:\Asub\z:}', "");;
    Expect(0, 11389, '\p{Dt=:\Asub\z:}', "");;
    Expect(1, 11388, '\p{Dt=  Sub}', "");
    Expect(0, 11388, '\p{^Dt=  Sub}', "");
    Expect(0, 11388, '\P{Dt=  Sub}', "");
    Expect(1, 11388, '\P{^Dt=  Sub}', "");
    Expect(0, 11389, '\p{Dt=  Sub}', "");
    Expect(1, 11389, '\p{^Dt=  Sub}', "");
    Expect(1, 11389, '\P{Dt=  Sub}', "");
    Expect(0, 11389, '\P{^Dt=  Sub}', "");
    Error('\p{Is_Decomposition_Type= SUB:=}');
    Error('\P{Is_Decomposition_Type= SUB:=}');
    Expect(1, 11388, '\p{Is_Decomposition_Type=sub}', "");
    Expect(0, 11388, '\p{^Is_Decomposition_Type=sub}', "");
    Expect(0, 11388, '\P{Is_Decomposition_Type=sub}', "");
    Expect(1, 11388, '\P{^Is_Decomposition_Type=sub}', "");
    Expect(0, 11389, '\p{Is_Decomposition_Type=sub}', "");
    Expect(1, 11389, '\p{^Is_Decomposition_Type=sub}', "");
    Expect(1, 11389, '\P{Is_Decomposition_Type=sub}', "");
    Expect(0, 11389, '\P{^Is_Decomposition_Type=sub}', "");
    Expect(1, 11388, '\p{Is_Decomposition_Type=-	sub}', "");
    Expect(0, 11388, '\p{^Is_Decomposition_Type=-	sub}', "");
    Expect(0, 11388, '\P{Is_Decomposition_Type=-	sub}', "");
    Expect(1, 11388, '\P{^Is_Decomposition_Type=-	sub}', "");
    Expect(0, 11389, '\p{Is_Decomposition_Type=-	sub}', "");
    Expect(1, 11389, '\p{^Is_Decomposition_Type=-	sub}', "");
    Expect(1, 11389, '\P{Is_Decomposition_Type=-	sub}', "");
    Expect(0, 11389, '\P{^Is_Decomposition_Type=-	sub}', "");
    Error('\p{Is_Dt: :=_sub}');
    Error('\P{Is_Dt: :=_sub}');
    Expect(1, 11388, '\p{Is_Dt=sub}', "");
    Expect(0, 11388, '\p{^Is_Dt=sub}', "");
    Expect(0, 11388, '\P{Is_Dt=sub}', "");
    Expect(1, 11388, '\P{^Is_Dt=sub}', "");
    Expect(0, 11389, '\p{Is_Dt=sub}', "");
    Expect(1, 11389, '\p{^Is_Dt=sub}', "");
    Expect(1, 11389, '\P{Is_Dt=sub}', "");
    Expect(0, 11389, '\P{^Is_Dt=sub}', "");
    Expect(1, 11388, '\p{Is_Dt=	 Sub}', "");
    Expect(0, 11388, '\p{^Is_Dt=	 Sub}', "");
    Expect(0, 11388, '\P{Is_Dt=	 Sub}', "");
    Expect(1, 11388, '\P{^Is_Dt=	 Sub}', "");
    Expect(0, 11389, '\p{Is_Dt=	 Sub}', "");
    Expect(1, 11389, '\p{^Is_Dt=	 Sub}', "");
    Expect(1, 11389, '\P{Is_Dt=	 Sub}', "");
    Expect(0, 11389, '\P{^Is_Dt=	 Sub}', "");
    Error('\p{Decomposition_Type= /a/SUPER}');
    Error('\P{Decomposition_Type= /a/SUPER}');
    Expect(1, 127340, '\p{Decomposition_Type=:\ASuper\z:}', "");;
    Expect(0, 127341, '\p{Decomposition_Type=:\ASuper\z:}', "");;
    Expect(1, 127340, '\p{Decomposition_Type=super}', "");
    Expect(0, 127340, '\p{^Decomposition_Type=super}', "");
    Expect(0, 127340, '\P{Decomposition_Type=super}', "");
    Expect(1, 127340, '\P{^Decomposition_Type=super}', "");
    Expect(0, 127341, '\p{Decomposition_Type=super}', "");
    Expect(1, 127341, '\p{^Decomposition_Type=super}', "");
    Expect(1, 127341, '\P{Decomposition_Type=super}', "");
    Expect(0, 127341, '\P{^Decomposition_Type=super}', "");
    Expect(1, 127340, '\p{Decomposition_Type=:\Asuper\z:}', "");;
    Expect(0, 127341, '\p{Decomposition_Type=:\Asuper\z:}', "");;
    Expect(1, 127340, '\p{Decomposition_Type=	Super}', "");
    Expect(0, 127340, '\p{^Decomposition_Type=	Super}', "");
    Expect(0, 127340, '\P{Decomposition_Type=	Super}', "");
    Expect(1, 127340, '\P{^Decomposition_Type=	Super}', "");
    Expect(0, 127341, '\p{Decomposition_Type=	Super}', "");
    Expect(1, 127341, '\p{^Decomposition_Type=	Super}', "");
    Expect(1, 127341, '\P{Decomposition_Type=	Super}', "");
    Expect(0, 127341, '\P{^Decomposition_Type=	Super}', "");
    Error('\p{Dt= _Sup/a/}');
    Error('\P{Dt= _Sup/a/}');
    Expect(1, 127340, '\p{Dt=:\ASup\z:}', "");;
    Expect(0, 127341, '\p{Dt=:\ASup\z:}', "");;
    Expect(1, 127340, '\p{Dt=sup}', "");
    Expect(0, 127340, '\p{^Dt=sup}', "");
    Expect(0, 127340, '\P{Dt=sup}', "");
    Expect(1, 127340, '\P{^Dt=sup}', "");
    Expect(0, 127341, '\p{Dt=sup}', "");
    Expect(1, 127341, '\p{^Dt=sup}', "");
    Expect(1, 127341, '\P{Dt=sup}', "");
    Expect(0, 127341, '\P{^Dt=sup}', "");
    Expect(1, 127340, '\p{Dt=:\Asup\z:}', "");;
    Expect(0, 127341, '\p{Dt=:\Asup\z:}', "");;
    Expect(1, 127340, '\p{Dt=_ Sup}', "");
    Expect(0, 127340, '\p{^Dt=_ Sup}', "");
    Expect(0, 127340, '\P{Dt=_ Sup}', "");
    Expect(1, 127340, '\P{^Dt=_ Sup}', "");
    Expect(0, 127341, '\p{Dt=_ Sup}', "");
    Expect(1, 127341, '\p{^Dt=_ Sup}', "");
    Expect(1, 127341, '\P{Dt=_ Sup}', "");
    Expect(0, 127341, '\P{^Dt=_ Sup}', "");
    Error('\p{Is_Decomposition_Type=/a/_super}');
    Error('\P{Is_Decomposition_Type=/a/_super}');
    Expect(1, 127340, '\p{Is_Decomposition_Type=super}', "");
    Expect(0, 127340, '\p{^Is_Decomposition_Type=super}', "");
    Expect(0, 127340, '\P{Is_Decomposition_Type=super}', "");
    Expect(1, 127340, '\P{^Is_Decomposition_Type=super}', "");
    Expect(0, 127341, '\p{Is_Decomposition_Type=super}', "");
    Expect(1, 127341, '\p{^Is_Decomposition_Type=super}', "");
    Expect(1, 127341, '\P{Is_Decomposition_Type=super}', "");
    Expect(0, 127341, '\P{^Is_Decomposition_Type=super}', "");
    Error('\p{Is_Dt=:=_ Sup}');
    Error('\P{Is_Dt=:=_ Sup}');
    Expect(1, 127340, '\p{Is_Dt=sup}', "");
    Expect(0, 127340, '\p{^Is_Dt=sup}', "");
    Expect(0, 127340, '\P{Is_Dt=sup}', "");
    Expect(1, 127340, '\P{^Is_Dt=sup}', "");
    Expect(0, 127341, '\p{Is_Dt=sup}', "");
    Expect(1, 127341, '\p{^Is_Dt=sup}', "");
    Expect(1, 127341, '\P{Is_Dt=sup}', "");
    Expect(0, 127341, '\P{^Is_Dt=sup}', "");
    Expect(1, 127340, '\p{Is_Dt=	 Sup}', "");
    Expect(0, 127340, '\p{^Is_Dt=	 Sup}', "");
    Expect(0, 127340, '\P{Is_Dt=	 Sup}', "");
    Expect(1, 127340, '\P{^Is_Dt=	 Sup}', "");
    Expect(0, 127341, '\p{Is_Dt=	 Sup}', "");
    Expect(1, 127341, '\p{^Is_Dt=	 Sup}', "");
    Expect(1, 127341, '\P{Is_Dt=	 Sup}', "");
    Expect(0, 127341, '\P{^Is_Dt=	 Sup}', "");
    Error('\p{Decomposition_Type=-/a/Vertical}');
    Error('\P{Decomposition_Type=-/a/Vertical}');
    Expect(1, 65096, '\p{Decomposition_Type=:\AVertical\z:}', "");;
    Expect(0, 65097, '\p{Decomposition_Type=:\AVertical\z:}', "");;
    Expect(1, 65096, '\p{Decomposition_Type=vertical}', "");
    Expect(0, 65096, '\p{^Decomposition_Type=vertical}', "");
    Expect(0, 65096, '\P{Decomposition_Type=vertical}', "");
    Expect(1, 65096, '\P{^Decomposition_Type=vertical}', "");
    Expect(0, 65097, '\p{Decomposition_Type=vertical}', "");
    Expect(1, 65097, '\p{^Decomposition_Type=vertical}', "");
    Expect(1, 65097, '\P{Decomposition_Type=vertical}', "");
    Expect(0, 65097, '\P{^Decomposition_Type=vertical}', "");
    Expect(1, 65096, '\p{Decomposition_Type=:\Avertical\z:}', "");;
    Expect(0, 65097, '\p{Decomposition_Type=:\Avertical\z:}', "");;
    Expect(1, 65096, '\p{Decomposition_Type:_ VERTICAL}', "");
    Expect(0, 65096, '\p{^Decomposition_Type:_ VERTICAL}', "");
    Expect(0, 65096, '\P{Decomposition_Type:_ VERTICAL}', "");
    Expect(1, 65096, '\P{^Decomposition_Type:_ VERTICAL}', "");
    Expect(0, 65097, '\p{Decomposition_Type:_ VERTICAL}', "");
    Expect(1, 65097, '\p{^Decomposition_Type:_ VERTICAL}', "");
    Expect(1, 65097, '\P{Decomposition_Type:_ VERTICAL}', "");
    Expect(0, 65097, '\P{^Decomposition_Type:_ VERTICAL}', "");
    Error('\p{Dt::= -vert}');
    Error('\P{Dt::= -vert}');
    Expect(1, 65096, '\p{Dt=:\AVert\z:}', "");;
    Expect(0, 65097, '\p{Dt=:\AVert\z:}', "");;
    Expect(1, 65096, '\p{Dt=vert}', "");
    Expect(0, 65096, '\p{^Dt=vert}', "");
    Expect(0, 65096, '\P{Dt=vert}', "");
    Expect(1, 65096, '\P{^Dt=vert}', "");
    Expect(0, 65097, '\p{Dt=vert}', "");
    Expect(1, 65097, '\p{^Dt=vert}', "");
    Expect(1, 65097, '\P{Dt=vert}', "");
    Expect(0, 65097, '\P{^Dt=vert}', "");
    Expect(1, 65096, '\p{Dt=:\Avert\z:}', "");;
    Expect(0, 65097, '\p{Dt=:\Avert\z:}', "");;
    Expect(1, 65096, '\p{Dt=_Vert}', "");
    Expect(0, 65096, '\p{^Dt=_Vert}', "");
    Expect(0, 65096, '\P{Dt=_Vert}', "");
    Expect(1, 65096, '\P{^Dt=_Vert}', "");
    Expect(0, 65097, '\p{Dt=_Vert}', "");
    Expect(1, 65097, '\p{^Dt=_Vert}', "");
    Expect(1, 65097, '\P{Dt=_Vert}', "");
    Expect(0, 65097, '\P{^Dt=_Vert}', "");
    Error('\p{Is_Decomposition_Type=/a/	vertical}');
    Error('\P{Is_Decomposition_Type=/a/	vertical}');
    Expect(1, 65096, '\p{Is_Decomposition_Type: vertical}', "");
    Expect(0, 65096, '\p{^Is_Decomposition_Type: vertical}', "");
    Expect(0, 65096, '\P{Is_Decomposition_Type: vertical}', "");
    Expect(1, 65096, '\P{^Is_Decomposition_Type: vertical}', "");
    Expect(0, 65097, '\p{Is_Decomposition_Type: vertical}', "");
    Expect(1, 65097, '\p{^Is_Decomposition_Type: vertical}', "");
    Expect(1, 65097, '\P{Is_Decomposition_Type: vertical}', "");
    Expect(0, 65097, '\P{^Is_Decomposition_Type: vertical}', "");
    Expect(1, 65096, '\p{Is_Decomposition_Type=		Vertical}', "");
    Expect(0, 65096, '\p{^Is_Decomposition_Type=		Vertical}', "");
    Expect(0, 65096, '\P{Is_Decomposition_Type=		Vertical}', "");
    Expect(1, 65096, '\P{^Is_Decomposition_Type=		Vertical}', "");
    Expect(0, 65097, '\p{Is_Decomposition_Type=		Vertical}', "");
    Expect(1, 65097, '\p{^Is_Decomposition_Type=		Vertical}', "");
    Expect(1, 65097, '\P{Is_Decomposition_Type=		Vertical}', "");
    Expect(0, 65097, '\P{^Is_Decomposition_Type=		Vertical}', "");
    Error('\p{Is_Dt:  _vert/a/}');
    Error('\P{Is_Dt:  _vert/a/}');
    Expect(1, 65096, '\p{Is_Dt=vert}', "");
    Expect(0, 65096, '\p{^Is_Dt=vert}', "");
    Expect(0, 65096, '\P{Is_Dt=vert}', "");
    Expect(1, 65096, '\P{^Is_Dt=vert}', "");
    Expect(0, 65097, '\p{Is_Dt=vert}', "");
    Expect(1, 65097, '\p{^Is_Dt=vert}', "");
    Expect(1, 65097, '\P{Is_Dt=vert}', "");
    Expect(0, 65097, '\P{^Is_Dt=vert}', "");
    Expect(1, 65096, '\p{Is_Dt=	Vert}', "");
    Expect(0, 65096, '\p{^Is_Dt=	Vert}', "");
    Expect(0, 65096, '\P{Is_Dt=	Vert}', "");
    Expect(1, 65096, '\P{^Is_Dt=	Vert}', "");
    Expect(0, 65097, '\p{Is_Dt=	Vert}', "");
    Expect(1, 65097, '\p{^Is_Dt=	Vert}', "");
    Expect(1, 65097, '\P{Is_Dt=	Vert}', "");
    Expect(0, 65097, '\P{^Is_Dt=	Vert}', "");
    Error('\p{Decomposition_Type=:=_-Wide}');
    Error('\P{Decomposition_Type=:=_-Wide}');
    Expect(1, 65510, '\p{Decomposition_Type=:\AWide\z:}', "");;
    Expect(0, 65511, '\p{Decomposition_Type=:\AWide\z:}', "");;
    Expect(1, 65510, '\p{Decomposition_Type=wide}', "");
    Expect(0, 65510, '\p{^Decomposition_Type=wide}', "");
    Expect(0, 65510, '\P{Decomposition_Type=wide}', "");
    Expect(1, 65510, '\P{^Decomposition_Type=wide}', "");
    Expect(0, 65511, '\p{Decomposition_Type=wide}', "");
    Expect(1, 65511, '\p{^Decomposition_Type=wide}', "");
    Expect(1, 65511, '\P{Decomposition_Type=wide}', "");
    Expect(0, 65511, '\P{^Decomposition_Type=wide}', "");
    Expect(1, 65510, '\p{Decomposition_Type=:\Awide\z:}', "");;
    Expect(0, 65511, '\p{Decomposition_Type=:\Awide\z:}', "");;
    Expect(1, 65510, '\p{Decomposition_Type=  Wide}', "");
    Expect(0, 65510, '\p{^Decomposition_Type=  Wide}', "");
    Expect(0, 65510, '\P{Decomposition_Type=  Wide}', "");
    Expect(1, 65510, '\P{^Decomposition_Type=  Wide}', "");
    Expect(0, 65511, '\p{Decomposition_Type=  Wide}', "");
    Expect(1, 65511, '\p{^Decomposition_Type=  Wide}', "");
    Expect(1, 65511, '\P{Decomposition_Type=  Wide}', "");
    Expect(0, 65511, '\P{^Decomposition_Type=  Wide}', "");
    Error('\p{Dt=	wide:=}');
    Error('\P{Dt=	wide:=}');
    Expect(1, 65510, '\p{Dt=:\AWide\z:}', "");;
    Expect(0, 65511, '\p{Dt=:\AWide\z:}', "");;
    Expect(1, 65510, '\p{Dt=wide}', "");
    Expect(0, 65510, '\p{^Dt=wide}', "");
    Expect(0, 65510, '\P{Dt=wide}', "");
    Expect(1, 65510, '\P{^Dt=wide}', "");
    Expect(0, 65511, '\p{Dt=wide}', "");
    Expect(1, 65511, '\p{^Dt=wide}', "");
    Expect(1, 65511, '\P{Dt=wide}', "");
    Expect(0, 65511, '\P{^Dt=wide}', "");
    Expect(1, 65510, '\p{Dt=:\Awide\z:}', "");;
    Expect(0, 65511, '\p{Dt=:\Awide\z:}', "");;
    Expect(1, 65510, '\p{Dt=-	WIDE}', "");
    Expect(0, 65510, '\p{^Dt=-	WIDE}', "");
    Expect(0, 65510, '\P{Dt=-	WIDE}', "");
    Expect(1, 65510, '\P{^Dt=-	WIDE}', "");
    Expect(0, 65511, '\p{Dt=-	WIDE}', "");
    Expect(1, 65511, '\p{^Dt=-	WIDE}', "");
    Expect(1, 65511, '\P{Dt=-	WIDE}', "");
    Expect(0, 65511, '\P{^Dt=-	WIDE}', "");
    Error('\p{Is_Decomposition_Type=-:=Wide}');
    Error('\P{Is_Decomposition_Type=-:=Wide}');
    Expect(1, 65510, '\p{Is_Decomposition_Type=wide}', "");
    Expect(0, 65510, '\p{^Is_Decomposition_Type=wide}', "");
    Expect(0, 65510, '\P{Is_Decomposition_Type=wide}', "");
    Expect(1, 65510, '\P{^Is_Decomposition_Type=wide}', "");
    Expect(0, 65511, '\p{Is_Decomposition_Type=wide}', "");
    Expect(1, 65511, '\p{^Is_Decomposition_Type=wide}', "");
    Expect(1, 65511, '\P{Is_Decomposition_Type=wide}', "");
    Expect(0, 65511, '\P{^Is_Decomposition_Type=wide}', "");
    Expect(1, 65510, '\p{Is_Decomposition_Type:	_Wide}', "");
    Expect(0, 65510, '\p{^Is_Decomposition_Type:	_Wide}', "");
    Expect(0, 65510, '\P{Is_Decomposition_Type:	_Wide}', "");
    Expect(1, 65510, '\P{^Is_Decomposition_Type:	_Wide}', "");
    Expect(0, 65511, '\p{Is_Decomposition_Type:	_Wide}', "");
    Expect(1, 65511, '\p{^Is_Decomposition_Type:	_Wide}', "");
    Expect(1, 65511, '\P{Is_Decomposition_Type:	_Wide}', "");
    Expect(0, 65511, '\P{^Is_Decomposition_Type:	_Wide}', "");
    Error('\p{Is_Dt=_wide:=}');
    Error('\P{Is_Dt=_wide:=}');
    Expect(1, 65510, '\p{Is_Dt=wide}', "");
    Expect(0, 65510, '\p{^Is_Dt=wide}', "");
    Expect(0, 65510, '\P{Is_Dt=wide}', "");
    Expect(1, 65510, '\P{^Is_Dt=wide}', "");
    Expect(0, 65511, '\p{Is_Dt=wide}', "");
    Expect(1, 65511, '\p{^Is_Dt=wide}', "");
    Expect(1, 65511, '\P{Is_Dt=wide}', "");
    Expect(0, 65511, '\P{^Is_Dt=wide}', "");
    Expect(1, 65510, '\p{Is_Dt:    -WIDE}', "");
    Expect(0, 65510, '\p{^Is_Dt:    -WIDE}', "");
    Expect(0, 65510, '\P{Is_Dt:    -WIDE}', "");
    Expect(1, 65510, '\P{^Is_Dt:    -WIDE}', "");
    Expect(0, 65511, '\p{Is_Dt:    -WIDE}', "");
    Expect(1, 65511, '\p{^Is_Dt:    -WIDE}', "");
    Expect(1, 65511, '\P{Is_Dt:    -WIDE}', "");
    Expect(0, 65511, '\P{^Is_Dt:    -WIDE}', "");
    Error('\p{eastasianwidth}');
    Error('\P{eastasianwidth}');
    Error('\p{ea}');
    Error('\P{ea}');
    Error('\p{East_Asian_Width=	/a/Ambiguous}');
    Error('\P{East_Asian_Width=	/a/Ambiguous}');
    Expect(1, 1114109, '\p{East_Asian_Width=:\AAmbiguous\z:}', "");;
    Expect(0, 918000, '\p{East_Asian_Width=:\AAmbiguous\z:}', "");;
    Expect(1, 1114109, '\p{East_Asian_Width=ambiguous}', "");
    Expect(0, 1114109, '\p{^East_Asian_Width=ambiguous}', "");
    Expect(0, 1114109, '\P{East_Asian_Width=ambiguous}', "");
    Expect(1, 1114109, '\P{^East_Asian_Width=ambiguous}', "");
    Expect(0, 918000, '\p{East_Asian_Width=ambiguous}', "");
    Expect(1, 918000, '\p{^East_Asian_Width=ambiguous}', "");
    Expect(1, 918000, '\P{East_Asian_Width=ambiguous}', "");
    Expect(0, 918000, '\P{^East_Asian_Width=ambiguous}', "");
    Expect(1, 1114109, '\p{East_Asian_Width=:\Aambiguous\z:}', "");;
    Expect(0, 918000, '\p{East_Asian_Width=:\Aambiguous\z:}', "");;
    Expect(1, 1114109, '\p{East_Asian_Width= AMBIGUOUS}', "");
    Expect(0, 1114109, '\p{^East_Asian_Width= AMBIGUOUS}', "");
    Expect(0, 1114109, '\P{East_Asian_Width= AMBIGUOUS}', "");
    Expect(1, 1114109, '\P{^East_Asian_Width= AMBIGUOUS}', "");
    Expect(0, 918000, '\p{East_Asian_Width= AMBIGUOUS}', "");
    Expect(1, 918000, '\p{^East_Asian_Width= AMBIGUOUS}', "");
    Expect(1, 918000, '\P{East_Asian_Width= AMBIGUOUS}', "");
    Expect(0, 918000, '\P{^East_Asian_Width= AMBIGUOUS}', "");
    Error('\p{Ea:		 A:=}');
    Error('\P{Ea:		 A:=}');
    Expect(1, 1114109, '\p{Ea=:\AA\z:}', "");;
    Expect(0, 918000, '\p{Ea=:\AA\z:}', "");;
    Expect(1, 1114109, '\p{Ea=a}', "");
    Expect(0, 1114109, '\p{^Ea=a}', "");
    Expect(0, 1114109, '\P{Ea=a}', "");
    Expect(1, 1114109, '\P{^Ea=a}', "");
    Expect(0, 918000, '\p{Ea=a}', "");
    Expect(1, 918000, '\p{^Ea=a}', "");
    Expect(1, 918000, '\P{Ea=a}', "");
    Expect(0, 918000, '\P{^Ea=a}', "");
    Expect(1, 1114109, '\p{Ea=:\Aa\z:}', "");;
    Expect(0, 918000, '\p{Ea=:\Aa\z:}', "");;
    Expect(1, 1114109, '\p{Ea=		a}', "");
    Expect(0, 1114109, '\p{^Ea=		a}', "");
    Expect(0, 1114109, '\P{Ea=		a}', "");
    Expect(1, 1114109, '\P{^Ea=		a}', "");
    Expect(0, 918000, '\p{Ea=		a}', "");
    Expect(1, 918000, '\p{^Ea=		a}', "");
    Expect(1, 918000, '\P{Ea=		a}', "");
    Expect(0, 918000, '\P{^Ea=		a}', "");
    Error('\p{Is_East_Asian_Width=	AMBIGUOUS/a/}');
    Error('\P{Is_East_Asian_Width=	AMBIGUOUS/a/}');
    Expect(1, 1114109, '\p{Is_East_Asian_Width=ambiguous}', "");
    Expect(0, 1114109, '\p{^Is_East_Asian_Width=ambiguous}', "");
    Expect(0, 1114109, '\P{Is_East_Asian_Width=ambiguous}', "");
    Expect(1, 1114109, '\P{^Is_East_Asian_Width=ambiguous}', "");
    Expect(0, 918000, '\p{Is_East_Asian_Width=ambiguous}', "");
    Expect(1, 918000, '\p{^Is_East_Asian_Width=ambiguous}', "");
    Expect(1, 918000, '\P{Is_East_Asian_Width=ambiguous}', "");
    Expect(0, 918000, '\P{^Is_East_Asian_Width=ambiguous}', "");
    Expect(1, 1114109, '\p{Is_East_Asian_Width= 	Ambiguous}', "");
    Expect(0, 1114109, '\p{^Is_East_Asian_Width= 	Ambiguous}', "");
    Expect(0, 1114109, '\P{Is_East_Asian_Width= 	Ambiguous}', "");
    Expect(1, 1114109, '\P{^Is_East_Asian_Width= 	Ambiguous}', "");
    Expect(0, 918000, '\p{Is_East_Asian_Width= 	Ambiguous}', "");
    Expect(1, 918000, '\p{^Is_East_Asian_Width= 	Ambiguous}', "");
    Expect(1, 918000, '\P{Is_East_Asian_Width= 	Ambiguous}', "");
    Expect(0, 918000, '\P{^Is_East_Asian_Width= 	Ambiguous}', "");
    Error('\p{Is_Ea=:=__A}');
    Error('\P{Is_Ea=:=__A}');
    Expect(1, 1114109, '\p{Is_Ea=a}', "");
    Expect(0, 1114109, '\p{^Is_Ea=a}', "");
    Expect(0, 1114109, '\P{Is_Ea=a}', "");
    Expect(1, 1114109, '\P{^Is_Ea=a}', "");
    Expect(0, 918000, '\p{Is_Ea=a}', "");
    Expect(1, 918000, '\p{^Is_Ea=a}', "");
    Expect(1, 918000, '\P{Is_Ea=a}', "");
    Expect(0, 918000, '\P{^Is_Ea=a}', "");
    Expect(1, 1114109, '\p{Is_Ea= 	a}', "");
    Expect(0, 1114109, '\p{^Is_Ea= 	a}', "");
    Expect(0, 1114109, '\P{Is_Ea= 	a}', "");
    Expect(1, 1114109, '\P{^Is_Ea= 	a}', "");
    Expect(0, 918000, '\p{Is_Ea= 	a}', "");
    Expect(1, 918000, '\p{^Is_Ea= 	a}', "");
    Expect(1, 918000, '\P{Is_Ea= 	a}', "");
    Expect(0, 918000, '\P{^Is_Ea= 	a}', "");
    Error('\p{East_Asian_Width=	 FULLWIDTH:=}');
    Error('\P{East_Asian_Width=	 FULLWIDTH:=}');
    Expect(1, 65510, '\p{East_Asian_Width=:\AFullwidth\z:}', "");;
    Expect(0, 65511, '\p{East_Asian_Width=:\AFullwidth\z:}', "");;
    Expect(1, 65510, '\p{East_Asian_Width=fullwidth}', "");
    Expect(0, 65510, '\p{^East_Asian_Width=fullwidth}', "");
    Expect(0, 65510, '\P{East_Asian_Width=fullwidth}', "");
    Expect(1, 65510, '\P{^East_Asian_Width=fullwidth}', "");
    Expect(0, 65511, '\p{East_Asian_Width=fullwidth}', "");
    Expect(1, 65511, '\p{^East_Asian_Width=fullwidth}', "");
    Expect(1, 65511, '\P{East_Asian_Width=fullwidth}', "");
    Expect(0, 65511, '\P{^East_Asian_Width=fullwidth}', "");
    Expect(1, 65510, '\p{East_Asian_Width=:\Afullwidth\z:}', "");;
    Expect(0, 65511, '\p{East_Asian_Width=:\Afullwidth\z:}', "");;
    Expect(1, 65510, '\p{East_Asian_Width=- fullwidth}', "");
    Expect(0, 65510, '\p{^East_Asian_Width=- fullwidth}', "");
    Expect(0, 65510, '\P{East_Asian_Width=- fullwidth}', "");
    Expect(1, 65510, '\P{^East_Asian_Width=- fullwidth}', "");
    Expect(0, 65511, '\p{East_Asian_Width=- fullwidth}', "");
    Expect(1, 65511, '\p{^East_Asian_Width=- fullwidth}', "");
    Expect(1, 65511, '\P{East_Asian_Width=- fullwidth}', "");
    Expect(0, 65511, '\P{^East_Asian_Width=- fullwidth}', "");
    Error('\p{Ea=:=_F}');
    Error('\P{Ea=:=_F}');
    Expect(1, 65510, '\p{Ea=:\AF\z:}', "");;
    Expect(0, 65511, '\p{Ea=:\AF\z:}', "");;
    Expect(1, 65510, '\p{Ea=f}', "");
    Expect(0, 65510, '\p{^Ea=f}', "");
    Expect(0, 65510, '\P{Ea=f}', "");
    Expect(1, 65510, '\P{^Ea=f}', "");
    Expect(0, 65511, '\p{Ea=f}', "");
    Expect(1, 65511, '\p{^Ea=f}', "");
    Expect(1, 65511, '\P{Ea=f}', "");
    Expect(0, 65511, '\P{^Ea=f}', "");
    Expect(1, 65510, '\p{Ea=:\Af\z:}', "");;
    Expect(0, 65511, '\p{Ea=:\Af\z:}', "");;
    Expect(1, 65510, '\p{Ea:	F}', "");
    Expect(0, 65510, '\p{^Ea:	F}', "");
    Expect(0, 65510, '\P{Ea:	F}', "");
    Expect(1, 65510, '\P{^Ea:	F}', "");
    Expect(0, 65511, '\p{Ea:	F}', "");
    Expect(1, 65511, '\p{^Ea:	F}', "");
    Expect(1, 65511, '\P{Ea:	F}', "");
    Expect(0, 65511, '\P{^Ea:	F}', "");
    Error('\p{Is_East_Asian_Width=:=Fullwidth}');
    Error('\P{Is_East_Asian_Width=:=Fullwidth}');
    Expect(1, 65510, '\p{Is_East_Asian_Width=fullwidth}', "");
    Expect(0, 65510, '\p{^Is_East_Asian_Width=fullwidth}', "");
    Expect(0, 65510, '\P{Is_East_Asian_Width=fullwidth}', "");
    Expect(1, 65510, '\P{^Is_East_Asian_Width=fullwidth}', "");
    Expect(0, 65511, '\p{Is_East_Asian_Width=fullwidth}', "");
    Expect(1, 65511, '\p{^Is_East_Asian_Width=fullwidth}', "");
    Expect(1, 65511, '\P{Is_East_Asian_Width=fullwidth}', "");
    Expect(0, 65511, '\P{^Is_East_Asian_Width=fullwidth}', "");
    Expect(1, 65510, '\p{Is_East_Asian_Width= FULLWIDTH}', "");
    Expect(0, 65510, '\p{^Is_East_Asian_Width= FULLWIDTH}', "");
    Expect(0, 65510, '\P{Is_East_Asian_Width= FULLWIDTH}', "");
    Expect(1, 65510, '\P{^Is_East_Asian_Width= FULLWIDTH}', "");
    Expect(0, 65511, '\p{Is_East_Asian_Width= FULLWIDTH}', "");
    Expect(1, 65511, '\p{^Is_East_Asian_Width= FULLWIDTH}', "");
    Expect(1, 65511, '\P{Is_East_Asian_Width= FULLWIDTH}', "");
    Expect(0, 65511, '\P{^Is_East_Asian_Width= FULLWIDTH}', "");
    Error('\p{Is_Ea=_/a/F}');
    Error('\P{Is_Ea=_/a/F}');
    Expect(1, 65510, '\p{Is_Ea=f}', "");
    Expect(0, 65510, '\p{^Is_Ea=f}', "");
    Expect(0, 65510, '\P{Is_Ea=f}', "");
    Expect(1, 65510, '\P{^Is_Ea=f}', "");
    Expect(0, 65511, '\p{Is_Ea=f}', "");
    Expect(1, 65511, '\p{^Is_Ea=f}', "");
    Expect(1, 65511, '\P{Is_Ea=f}', "");
    Expect(0, 65511, '\P{^Is_Ea=f}', "");
    Expect(1, 65510, '\p{Is_Ea=-F}', "");
    Expect(0, 65510, '\p{^Is_Ea=-F}', "");
    Expect(0, 65510, '\P{Is_Ea=-F}', "");
    Expect(1, 65510, '\P{^Is_Ea=-F}', "");
    Expect(0, 65511, '\p{Is_Ea=-F}', "");
    Expect(1, 65511, '\p{^Is_Ea=-F}', "");
    Expect(1, 65511, '\P{Is_Ea=-F}', "");
    Expect(0, 65511, '\P{^Is_Ea=-F}', "");
    Error('\p{East_Asian_Width:    /a/halfwidth}');
    Error('\P{East_Asian_Width:    /a/halfwidth}');
    Expect(1, 65518, '\p{East_Asian_Width=:\AHalfwidth\z:}', "");;
    Expect(0, 65519, '\p{East_Asian_Width=:\AHalfwidth\z:}', "");;
    Expect(1, 65518, '\p{East_Asian_Width=halfwidth}', "");
    Expect(0, 65518, '\p{^East_Asian_Width=halfwidth}', "");
    Expect(0, 65518, '\P{East_Asian_Width=halfwidth}', "");
    Expect(1, 65518, '\P{^East_Asian_Width=halfwidth}', "");
    Expect(0, 65519, '\p{East_Asian_Width=halfwidth}', "");
    Expect(1, 65519, '\p{^East_Asian_Width=halfwidth}', "");
    Expect(1, 65519, '\P{East_Asian_Width=halfwidth}', "");
    Expect(0, 65519, '\P{^East_Asian_Width=halfwidth}', "");
    Expect(1, 65518, '\p{East_Asian_Width=:\Ahalfwidth\z:}', "");;
    Expect(0, 65519, '\p{East_Asian_Width=:\Ahalfwidth\z:}', "");;
    Expect(1, 65518, '\p{East_Asian_Width=-HALFWIDTH}', "");
    Expect(0, 65518, '\p{^East_Asian_Width=-HALFWIDTH}', "");
    Expect(0, 65518, '\P{East_Asian_Width=-HALFWIDTH}', "");
    Expect(1, 65518, '\P{^East_Asian_Width=-HALFWIDTH}', "");
    Expect(0, 65519, '\p{East_Asian_Width=-HALFWIDTH}', "");
    Expect(1, 65519, '\p{^East_Asian_Width=-HALFWIDTH}', "");
    Expect(1, 65519, '\P{East_Asian_Width=-HALFWIDTH}', "");
    Expect(0, 65519, '\P{^East_Asian_Width=-HALFWIDTH}', "");
    Error('\p{Ea=		H/a/}');
    Error('\P{Ea=		H/a/}');
    Expect(1, 65518, '\p{Ea=:\AH\z:}', "");;
    Expect(0, 65519, '\p{Ea=:\AH\z:}', "");;
    Expect(1, 65518, '\p{Ea=h}', "");
    Expect(0, 65518, '\p{^Ea=h}', "");
    Expect(0, 65518, '\P{Ea=h}', "");
    Expect(1, 65518, '\P{^Ea=h}', "");
    Expect(0, 65519, '\p{Ea=h}', "");
    Expect(1, 65519, '\p{^Ea=h}', "");
    Expect(1, 65519, '\P{Ea=h}', "");
    Expect(0, 65519, '\P{^Ea=h}', "");
    Expect(1, 65518, '\p{Ea=:\Ah\z:}', "");;
    Expect(0, 65519, '\p{Ea=:\Ah\z:}', "");;
    Expect(1, 65518, '\p{Ea=  H}', "");
    Expect(0, 65518, '\p{^Ea=  H}', "");
    Expect(0, 65518, '\P{Ea=  H}', "");
    Expect(1, 65518, '\P{^Ea=  H}', "");
    Expect(0, 65519, '\p{Ea=  H}', "");
    Expect(1, 65519, '\p{^Ea=  H}', "");
    Expect(1, 65519, '\P{Ea=  H}', "");
    Expect(0, 65519, '\P{^Ea=  H}', "");
    Error('\p{Is_East_Asian_Width=		Halfwidth:=}');
    Error('\P{Is_East_Asian_Width=		Halfwidth:=}');
    Expect(1, 65518, '\p{Is_East_Asian_Width=halfwidth}', "");
    Expect(0, 65518, '\p{^Is_East_Asian_Width=halfwidth}', "");
    Expect(0, 65518, '\P{Is_East_Asian_Width=halfwidth}', "");
    Expect(1, 65518, '\P{^Is_East_Asian_Width=halfwidth}', "");
    Expect(0, 65519, '\p{Is_East_Asian_Width=halfwidth}', "");
    Expect(1, 65519, '\p{^Is_East_Asian_Width=halfwidth}', "");
    Expect(1, 65519, '\P{Is_East_Asian_Width=halfwidth}', "");
    Expect(0, 65519, '\P{^Is_East_Asian_Width=halfwidth}', "");
    Expect(1, 65518, '\p{Is_East_Asian_Width=Halfwidth}', "");
    Expect(0, 65518, '\p{^Is_East_Asian_Width=Halfwidth}', "");
    Expect(0, 65518, '\P{Is_East_Asian_Width=Halfwidth}', "");
    Expect(1, 65518, '\P{^Is_East_Asian_Width=Halfwidth}', "");
    Expect(0, 65519, '\p{Is_East_Asian_Width=Halfwidth}', "");
    Expect(1, 65519, '\p{^Is_East_Asian_Width=Halfwidth}', "");
    Expect(1, 65519, '\P{Is_East_Asian_Width=Halfwidth}', "");
    Expect(0, 65519, '\P{^Is_East_Asian_Width=Halfwidth}', "");
    Error('\p{Is_Ea= _H:=}');
    Error('\P{Is_Ea= _H:=}');
    Expect(1, 65518, '\p{Is_Ea=h}', "");
    Expect(0, 65518, '\p{^Is_Ea=h}', "");
    Expect(0, 65518, '\P{Is_Ea=h}', "");
    Expect(1, 65518, '\P{^Is_Ea=h}', "");
    Expect(0, 65519, '\p{Is_Ea=h}', "");
    Expect(1, 65519, '\p{^Is_Ea=h}', "");
    Expect(1, 65519, '\P{Is_Ea=h}', "");
    Expect(0, 65519, '\P{^Is_Ea=h}', "");
    Expect(1, 65518, '\p{Is_Ea= H}', "");
    Expect(0, 65518, '\p{^Is_Ea= H}', "");
    Expect(0, 65518, '\P{Is_Ea= H}', "");
    Expect(1, 65518, '\P{^Is_Ea= H}', "");
    Expect(0, 65519, '\p{Is_Ea= H}', "");
    Expect(1, 65519, '\p{^Is_Ea= H}', "");
    Expect(1, 65519, '\P{Is_Ea= H}', "");
    Expect(0, 65519, '\P{^Is_Ea= H}', "");
    Error('\p{East_Asian_Width=	_Neutral/a/}');
    Error('\P{East_Asian_Width=	_Neutral/a/}');
    Expect(1, 918000, '\p{East_Asian_Width=:\ANeutral\z:}', "");;
    Expect(0, 1114109, '\p{East_Asian_Width=:\ANeutral\z:}', "");;
    Expect(1, 918000, '\p{East_Asian_Width=neutral}', "");
    Expect(0, 918000, '\p{^East_Asian_Width=neutral}', "");
    Expect(0, 918000, '\P{East_Asian_Width=neutral}', "");
    Expect(1, 918000, '\P{^East_Asian_Width=neutral}', "");
    Expect(0, 1114109, '\p{East_Asian_Width=neutral}', "");
    Expect(1, 1114109, '\p{^East_Asian_Width=neutral}', "");
    Expect(1, 1114109, '\P{East_Asian_Width=neutral}', "");
    Expect(0, 1114109, '\P{^East_Asian_Width=neutral}', "");
    Expect(1, 918000, '\p{East_Asian_Width=:\Aneutral\z:}', "");;
    Expect(0, 1114109, '\p{East_Asian_Width=:\Aneutral\z:}', "");;
    Expect(1, 918000, '\p{East_Asian_Width=-	NEUTRAL}', "");
    Expect(0, 918000, '\p{^East_Asian_Width=-	NEUTRAL}', "");
    Expect(0, 918000, '\P{East_Asian_Width=-	NEUTRAL}', "");
    Expect(1, 918000, '\P{^East_Asian_Width=-	NEUTRAL}', "");
    Expect(0, 1114109, '\p{East_Asian_Width=-	NEUTRAL}', "");
    Expect(1, 1114109, '\p{^East_Asian_Width=-	NEUTRAL}', "");
    Expect(1, 1114109, '\P{East_Asian_Width=-	NEUTRAL}', "");
    Expect(0, 1114109, '\P{^East_Asian_Width=-	NEUTRAL}', "");
    Error('\p{Ea= _N/a/}');
    Error('\P{Ea= _N/a/}');
    Expect(1, 918000, '\p{Ea=:\AN\z:}', "");;
    Expect(0, 1114109, '\p{Ea=:\AN\z:}', "");;
    Expect(1, 918000, '\p{Ea=n}', "");
    Expect(0, 918000, '\p{^Ea=n}', "");
    Expect(0, 918000, '\P{Ea=n}', "");
    Expect(1, 918000, '\P{^Ea=n}', "");
    Expect(0, 1114109, '\p{Ea=n}', "");
    Expect(1, 1114109, '\p{^Ea=n}', "");
    Expect(1, 1114109, '\P{Ea=n}', "");
    Expect(0, 1114109, '\P{^Ea=n}', "");
    Expect(1, 918000, '\p{Ea=:\An\z:}', "");;
    Expect(0, 1114109, '\p{Ea=:\An\z:}', "");;
    Expect(1, 918000, '\p{Ea=	N}', "");
    Expect(0, 918000, '\p{^Ea=	N}', "");
    Expect(0, 918000, '\P{Ea=	N}', "");
    Expect(1, 918000, '\P{^Ea=	N}', "");
    Expect(0, 1114109, '\p{Ea=	N}', "");
    Expect(1, 1114109, '\p{^Ea=	N}', "");
    Expect(1, 1114109, '\P{Ea=	N}', "");
    Expect(0, 1114109, '\P{^Ea=	N}', "");
    Error('\p{Is_East_Asian_Width=_:=neutral}');
    Error('\P{Is_East_Asian_Width=_:=neutral}');
    Expect(1, 918000, '\p{Is_East_Asian_Width:neutral}', "");
    Expect(0, 918000, '\p{^Is_East_Asian_Width:neutral}', "");
    Expect(0, 918000, '\P{Is_East_Asian_Width:neutral}', "");
    Expect(1, 918000, '\P{^Is_East_Asian_Width:neutral}', "");
    Expect(0, 1114109, '\p{Is_East_Asian_Width:neutral}', "");
    Expect(1, 1114109, '\p{^Is_East_Asian_Width:neutral}', "");
    Expect(1, 1114109, '\P{Is_East_Asian_Width:neutral}', "");
    Expect(0, 1114109, '\P{^Is_East_Asian_Width:neutral}', "");
    Expect(1, 918000, '\p{Is_East_Asian_Width=-Neutral}', "");
    Expect(0, 918000, '\p{^Is_East_Asian_Width=-Neutral}', "");
    Expect(0, 918000, '\P{Is_East_Asian_Width=-Neutral}', "");
    Expect(1, 918000, '\P{^Is_East_Asian_Width=-Neutral}', "");
    Expect(0, 1114109, '\p{Is_East_Asian_Width=-Neutral}', "");
    Expect(1, 1114109, '\p{^Is_East_Asian_Width=-Neutral}', "");
    Expect(1, 1114109, '\P{Is_East_Asian_Width=-Neutral}', "");
    Expect(0, 1114109, '\P{^Is_East_Asian_Width=-Neutral}', "");
    Error('\p{Is_Ea=:=	-N}');
    Error('\P{Is_Ea=:=	-N}');
    Expect(1, 918000, '\p{Is_Ea:n}', "");
    Expect(0, 918000, '\p{^Is_Ea:n}', "");
    Expect(0, 918000, '\P{Is_Ea:n}', "");
    Expect(1, 918000, '\P{^Is_Ea:n}', "");
    Expect(0, 1114109, '\p{Is_Ea:n}', "");
    Expect(1, 1114109, '\p{^Is_Ea:n}', "");
    Expect(1, 1114109, '\P{Is_Ea:n}', "");
    Expect(0, 1114109, '\P{^Is_Ea:n}', "");
    Expect(1, 918000, '\p{Is_Ea=_N}', "");
    Expect(0, 918000, '\p{^Is_Ea=_N}', "");
    Expect(0, 918000, '\P{Is_Ea=_N}', "");
    Expect(1, 918000, '\P{^Is_Ea=_N}', "");
    Expect(0, 1114109, '\p{Is_Ea=_N}', "");
    Expect(1, 1114109, '\p{^Is_Ea=_N}', "");
    Expect(1, 1114109, '\P{Is_Ea=_N}', "");
    Expect(0, 1114109, '\P{^Is_Ea=_N}', "");
    Error('\p{East_Asian_Width:		narrow/a/}');
    Error('\P{East_Asian_Width:		narrow/a/}');
    Expect(1, 10630, '\p{East_Asian_Width=:\ANarrow\z:}', "");;
    Expect(0, 10631, '\p{East_Asian_Width=:\ANarrow\z:}', "");;
    Expect(1, 10630, '\p{East_Asian_Width:   narrow}', "");
    Expect(0, 10630, '\p{^East_Asian_Width:   narrow}', "");
    Expect(0, 10630, '\P{East_Asian_Width:   narrow}', "");
    Expect(1, 10630, '\P{^East_Asian_Width:   narrow}', "");
    Expect(0, 10631, '\p{East_Asian_Width:   narrow}', "");
    Expect(1, 10631, '\p{^East_Asian_Width:   narrow}', "");
    Expect(1, 10631, '\P{East_Asian_Width:   narrow}', "");
    Expect(0, 10631, '\P{^East_Asian_Width:   narrow}', "");
    Expect(1, 10630, '\p{East_Asian_Width=:\Anarrow\z:}', "");;
    Expect(0, 10631, '\p{East_Asian_Width=:\Anarrow\z:}', "");;
    Expect(1, 10630, '\p{East_Asian_Width=-Narrow}', "");
    Expect(0, 10630, '\p{^East_Asian_Width=-Narrow}', "");
    Expect(0, 10630, '\P{East_Asian_Width=-Narrow}', "");
    Expect(1, 10630, '\P{^East_Asian_Width=-Narrow}', "");
    Expect(0, 10631, '\p{East_Asian_Width=-Narrow}', "");
    Expect(1, 10631, '\p{^East_Asian_Width=-Narrow}', "");
    Expect(1, 10631, '\P{East_Asian_Width=-Narrow}', "");
    Expect(0, 10631, '\P{^East_Asian_Width=-Narrow}', "");
    Error('\p{Ea=_Na/a/}');
    Error('\P{Ea=_Na/a/}');
    Expect(1, 10630, '\p{Ea=:\ANa\z:}', "");;
    Expect(0, 10631, '\p{Ea=:\ANa\z:}', "");;
    Expect(1, 10630, '\p{Ea=na}', "");
    Expect(0, 10630, '\p{^Ea=na}', "");
    Expect(0, 10630, '\P{Ea=na}', "");
    Expect(1, 10630, '\P{^Ea=na}', "");
    Expect(0, 10631, '\p{Ea=na}', "");
    Expect(1, 10631, '\p{^Ea=na}', "");
    Expect(1, 10631, '\P{Ea=na}', "");
    Expect(0, 10631, '\P{^Ea=na}', "");
    Expect(1, 10630, '\p{Ea=:\Ana\z:}', "");;
    Expect(0, 10631, '\p{Ea=:\Ana\z:}', "");;
    Expect(1, 10630, '\p{Ea=_ Na}', "");
    Expect(0, 10630, '\p{^Ea=_ Na}', "");
    Expect(0, 10630, '\P{Ea=_ Na}', "");
    Expect(1, 10630, '\P{^Ea=_ Na}', "");
    Expect(0, 10631, '\p{Ea=_ Na}', "");
    Expect(1, 10631, '\p{^Ea=_ Na}', "");
    Expect(1, 10631, '\P{Ea=_ Na}', "");
    Expect(0, 10631, '\P{^Ea=_ Na}', "");
    Error('\p{Is_East_Asian_Width=/a/narrow}');
    Error('\P{Is_East_Asian_Width=/a/narrow}');
    Expect(1, 10630, '\p{Is_East_Asian_Width=narrow}', "");
    Expect(0, 10630, '\p{^Is_East_Asian_Width=narrow}', "");
    Expect(0, 10630, '\P{Is_East_Asian_Width=narrow}', "");
    Expect(1, 10630, '\P{^Is_East_Asian_Width=narrow}', "");
    Expect(0, 10631, '\p{Is_East_Asian_Width=narrow}', "");
    Expect(1, 10631, '\p{^Is_East_Asian_Width=narrow}', "");
    Expect(1, 10631, '\P{Is_East_Asian_Width=narrow}', "");
    Expect(0, 10631, '\P{^Is_East_Asian_Width=narrow}', "");
    Expect(1, 10630, '\p{Is_East_Asian_Width=-Narrow}', "");
    Expect(0, 10630, '\p{^Is_East_Asian_Width=-Narrow}', "");
    Expect(0, 10630, '\P{Is_East_Asian_Width=-Narrow}', "");
    Expect(1, 10630, '\P{^Is_East_Asian_Width=-Narrow}', "");
    Expect(0, 10631, '\p{Is_East_Asian_Width=-Narrow}', "");
    Expect(1, 10631, '\p{^Is_East_Asian_Width=-Narrow}', "");
    Expect(1, 10631, '\P{Is_East_Asian_Width=-Narrow}', "");
    Expect(0, 10631, '\P{^Is_East_Asian_Width=-Narrow}', "");
    Error('\p{Is_Ea=_NA/a/}');
    Error('\P{Is_Ea=_NA/a/}');
    Expect(1, 10630, '\p{Is_Ea=na}', "");
    Expect(0, 10630, '\p{^Is_Ea=na}', "");
    Expect(0, 10630, '\P{Is_Ea=na}', "");
    Expect(1, 10630, '\P{^Is_Ea=na}', "");
    Expect(0, 10631, '\p{Is_Ea=na}', "");
    Expect(1, 10631, '\p{^Is_Ea=na}', "");
    Expect(1, 10631, '\P{Is_Ea=na}', "");
    Expect(0, 10631, '\P{^Is_Ea=na}', "");
    Expect(1, 10630, '\p{Is_Ea= Na}', "");
    Expect(0, 10630, '\p{^Is_Ea= Na}', "");
    Expect(0, 10630, '\P{Is_Ea= Na}', "");
    Expect(1, 10630, '\P{^Is_Ea= Na}', "");
    Expect(0, 10631, '\p{Is_Ea= Na}', "");
    Expect(1, 10631, '\p{^Is_Ea= Na}', "");
    Expect(1, 10631, '\P{Is_Ea= Na}', "");
    Expect(0, 10631, '\P{^Is_Ea= Na}', "");
    Error('\p{East_Asian_Width:	/a/ Wide}');
    Error('\P{East_Asian_Width:	/a/ Wide}');
    Expect(1, 262141, '\p{East_Asian_Width=:\AWide\z:}', "");;
    Expect(0, 262144, '\p{East_Asian_Width=:\AWide\z:}', "");;
    Expect(1, 262141, '\p{East_Asian_Width=wide}', "");
    Expect(0, 262141, '\p{^East_Asian_Width=wide}', "");
    Expect(0, 262141, '\P{East_Asian_Width=wide}', "");
    Expect(1, 262141, '\P{^East_Asian_Width=wide}', "");
    Expect(0, 262144, '\p{East_Asian_Width=wide}', "");
    Expect(1, 262144, '\p{^East_Asian_Width=wide}', "");
    Expect(1, 262144, '\P{East_Asian_Width=wide}', "");
    Expect(0, 262144, '\P{^East_Asian_Width=wide}', "");
    Expect(1, 262141, '\p{East_Asian_Width=:\Awide\z:}', "");;
    Expect(0, 262144, '\p{East_Asian_Width=:\Awide\z:}', "");;
    Expect(1, 262141, '\p{East_Asian_Width= _WIDE}', "");
    Expect(0, 262141, '\p{^East_Asian_Width= _WIDE}', "");
    Expect(0, 262141, '\P{East_Asian_Width= _WIDE}', "");
    Expect(1, 262141, '\P{^East_Asian_Width= _WIDE}', "");
    Expect(0, 262144, '\p{East_Asian_Width= _WIDE}', "");
    Expect(1, 262144, '\p{^East_Asian_Width= _WIDE}', "");
    Expect(1, 262144, '\P{East_Asian_Width= _WIDE}', "");
    Expect(0, 262144, '\P{^East_Asian_Width= _WIDE}', "");
    Error('\p{Ea=	:=W}');
    Error('\P{Ea=	:=W}');
    Expect(1, 262141, '\p{Ea=:\AW\z:}', "");;
    Expect(0, 262144, '\p{Ea=:\AW\z:}', "");;
    Expect(1, 262141, '\p{Ea=w}', "");
    Expect(0, 262141, '\p{^Ea=w}', "");
    Expect(0, 262141, '\P{Ea=w}', "");
    Expect(1, 262141, '\P{^Ea=w}', "");
    Expect(0, 262144, '\p{Ea=w}', "");
    Expect(1, 262144, '\p{^Ea=w}', "");
    Expect(1, 262144, '\P{Ea=w}', "");
    Expect(0, 262144, '\P{^Ea=w}', "");
    Expect(1, 262141, '\p{Ea=:\Aw\z:}', "");;
    Expect(0, 262144, '\p{Ea=:\Aw\z:}', "");;
    Expect(1, 262141, '\p{Ea=--W}', "");
    Expect(0, 262141, '\p{^Ea=--W}', "");
    Expect(0, 262141, '\P{Ea=--W}', "");
    Expect(1, 262141, '\P{^Ea=--W}', "");
    Expect(0, 262144, '\p{Ea=--W}', "");
    Expect(1, 262144, '\p{^Ea=--W}', "");
    Expect(1, 262144, '\P{Ea=--W}', "");
    Expect(0, 262144, '\P{^Ea=--W}', "");
    Error('\p{Is_East_Asian_Width=/a/Wide}');
    Error('\P{Is_East_Asian_Width=/a/Wide}');
    Expect(1, 262141, '\p{Is_East_Asian_Width=wide}', "");
    Expect(0, 262141, '\p{^Is_East_Asian_Width=wide}', "");
    Expect(0, 262141, '\P{Is_East_Asian_Width=wide}', "");
    Expect(1, 262141, '\P{^Is_East_Asian_Width=wide}', "");
    Expect(0, 262144, '\p{Is_East_Asian_Width=wide}', "");
    Expect(1, 262144, '\p{^Is_East_Asian_Width=wide}', "");
    Expect(1, 262144, '\P{Is_East_Asian_Width=wide}', "");
    Expect(0, 262144, '\P{^Is_East_Asian_Width=wide}', "");
    Expect(1, 262141, '\p{Is_East_Asian_Width=-	Wide}', "");
    Expect(0, 262141, '\p{^Is_East_Asian_Width=-	Wide}', "");
    Expect(0, 262141, '\P{Is_East_Asian_Width=-	Wide}', "");
    Expect(1, 262141, '\P{^Is_East_Asian_Width=-	Wide}', "");
    Expect(0, 262144, '\p{Is_East_Asian_Width=-	Wide}', "");
    Expect(1, 262144, '\p{^Is_East_Asian_Width=-	Wide}', "");
    Expect(1, 262144, '\P{Is_East_Asian_Width=-	Wide}', "");
    Expect(0, 262144, '\P{^Is_East_Asian_Width=-	Wide}', "");
    Error('\p{Is_Ea=_W:=}');
    Error('\P{Is_Ea=_W:=}');
    Expect(1, 262141, '\p{Is_Ea=w}', "");
    Expect(0, 262141, '\p{^Is_Ea=w}', "");
    Expect(0, 262141, '\P{Is_Ea=w}', "");
    Expect(1, 262141, '\P{^Is_Ea=w}', "");
    Expect(0, 262144, '\p{Is_Ea=w}', "");
    Expect(1, 262144, '\p{^Is_Ea=w}', "");
    Expect(1, 262144, '\P{Is_Ea=w}', "");
    Expect(0, 262144, '\P{^Is_Ea=w}', "");
    Expect(1, 262141, '\p{Is_Ea:	_ w}', "");
    Expect(0, 262141, '\p{^Is_Ea:	_ w}', "");
    Expect(0, 262141, '\P{Is_Ea:	_ w}', "");
    Expect(1, 262141, '\P{^Is_Ea:	_ w}', "");
    Expect(0, 262144, '\p{Is_Ea:	_ w}', "");
    Expect(1, 262144, '\p{^Is_Ea:	_ w}', "");
    Expect(1, 262144, '\P{Is_Ea:	_ w}', "");
    Expect(0, 262144, '\P{^Is_Ea:	_ w}', "");
    Error('\p{equivalentunifiedideograph}');
    Error('\P{equivalentunifiedideograph}');
    Error('\p{equideo}');
    Error('\P{equideo}');
    Error('\p{Extender:   :=	_no}');
    Error('\P{Extender:   :=	_no}');
    Expect(1, 125255, '\p{Extender=:\ANo\z:}', "");;
    Expect(0, 125254, '\p{Extender=:\ANo\z:}', "");;
    Expect(1, 125255, '\p{Extender=no}', "");
    Expect(0, 125255, '\p{^Extender=no}', "");
    Expect(0, 125255, '\P{Extender=no}', "");
    Expect(1, 125255, '\P{^Extender=no}', "");
    Expect(0, 125254, '\p{Extender=no}', "");
    Expect(1, 125254, '\p{^Extender=no}', "");
    Expect(1, 125254, '\P{Extender=no}', "");
    Expect(0, 125254, '\P{^Extender=no}', "");
    Expect(1, 125255, '\p{Extender=:\Ano\z:}', "");;
    Expect(0, 125254, '\p{Extender=:\Ano\z:}', "");;
    Expect(1, 125255, '\p{Extender= No}', "");
    Expect(0, 125255, '\p{^Extender= No}', "");
    Expect(0, 125255, '\P{Extender= No}', "");
    Expect(1, 125255, '\P{^Extender= No}', "");
    Expect(0, 125254, '\p{Extender= No}', "");
    Expect(1, 125254, '\p{^Extender= No}', "");
    Expect(1, 125254, '\P{Extender= No}', "");
    Expect(0, 125254, '\P{^Extender= No}', "");
    Error('\p{Ext=_	N:=}');
    Error('\P{Ext=_	N:=}');
    Expect(1, 125255, '\p{Ext=:\AN\z:}', "");;
    Expect(0, 125254, '\p{Ext=:\AN\z:}', "");;
    Expect(1, 125255, '\p{Ext=n}', "");
    Expect(0, 125255, '\p{^Ext=n}', "");
    Expect(0, 125255, '\P{Ext=n}', "");
    Expect(1, 125255, '\P{^Ext=n}', "");
    Expect(0, 125254, '\p{Ext=n}', "");
    Expect(1, 125254, '\p{^Ext=n}', "");
    Expect(1, 125254, '\P{Ext=n}', "");
    Expect(0, 125254, '\P{^Ext=n}', "");
    Expect(1, 125255, '\p{Ext=:\An\z:}', "");;
    Expect(0, 125254, '\p{Ext=:\An\z:}', "");;
    Expect(1, 125255, '\p{Ext:	 -N}', "");
    Expect(0, 125255, '\p{^Ext:	 -N}', "");
    Expect(0, 125255, '\P{Ext:	 -N}', "");
    Expect(1, 125255, '\P{^Ext:	 -N}', "");
    Expect(0, 125254, '\p{Ext:	 -N}', "");
    Expect(1, 125254, '\p{^Ext:	 -N}', "");
    Expect(1, 125254, '\P{Ext:	 -N}', "");
    Expect(0, 125254, '\P{^Ext:	 -N}', "");
    Error('\p{Is_Extender=_ F/a/}');
    Error('\P{Is_Extender=_ F/a/}');
    Expect(1, 125255, '\p{Is_Extender:f}', "");
    Expect(0, 125255, '\p{^Is_Extender:f}', "");
    Expect(0, 125255, '\P{Is_Extender:f}', "");
    Expect(1, 125255, '\P{^Is_Extender:f}', "");
    Expect(0, 125254, '\p{Is_Extender:f}', "");
    Expect(1, 125254, '\p{^Is_Extender:f}', "");
    Expect(1, 125254, '\P{Is_Extender:f}', "");
    Expect(0, 125254, '\P{^Is_Extender:f}', "");
    Expect(1, 125255, '\p{Is_Extender=-F}', "");
    Expect(0, 125255, '\p{^Is_Extender=-F}', "");
    Expect(0, 125255, '\P{Is_Extender=-F}', "");
    Expect(1, 125255, '\P{^Is_Extender=-F}', "");
    Expect(0, 125254, '\p{Is_Extender=-F}', "");
    Expect(1, 125254, '\p{^Is_Extender=-F}', "");
    Expect(1, 125254, '\P{Is_Extender=-F}', "");
    Expect(0, 125254, '\P{^Is_Extender=-F}', "");
    Error('\p{Is_Ext=-/a/false}');
    Error('\P{Is_Ext=-/a/false}');
    Expect(1, 125255, '\p{Is_Ext=false}', "");
    Expect(0, 125255, '\p{^Is_Ext=false}', "");
    Expect(0, 125255, '\P{Is_Ext=false}', "");
    Expect(1, 125255, '\P{^Is_Ext=false}', "");
    Expect(0, 125254, '\p{Is_Ext=false}', "");
    Expect(1, 125254, '\p{^Is_Ext=false}', "");
    Expect(1, 125254, '\P{Is_Ext=false}', "");
    Expect(0, 125254, '\P{^Is_Ext=false}', "");
    Expect(1, 125255, '\p{Is_Ext=	False}', "");
    Expect(0, 125255, '\p{^Is_Ext=	False}', "");
    Expect(0, 125255, '\P{Is_Ext=	False}', "");
    Expect(1, 125255, '\P{^Is_Ext=	False}', "");
    Expect(0, 125254, '\p{Is_Ext=	False}', "");
    Expect(1, 125254, '\p{^Is_Ext=	False}', "");
    Expect(1, 125254, '\P{Is_Ext=	False}', "");
    Expect(0, 125254, '\P{^Is_Ext=	False}', "");
    Error('\p{Extender= 	YES/a/}');
    Error('\P{Extender= 	YES/a/}');
    Expect(1, 125254, '\p{Extender=:\AYes\z:}', "");;
    Expect(0, 125255, '\p{Extender=:\AYes\z:}', "");;
    Expect(1, 125254, '\p{Extender: yes}', "");
    Expect(0, 125254, '\p{^Extender: yes}', "");
    Expect(0, 125254, '\P{Extender: yes}', "");
    Expect(1, 125254, '\P{^Extender: yes}', "");
    Expect(0, 125255, '\p{Extender: yes}', "");
    Expect(1, 125255, '\p{^Extender: yes}', "");
    Expect(1, 125255, '\P{Extender: yes}', "");
    Expect(0, 125255, '\P{^Extender: yes}', "");
    Expect(1, 125254, '\p{Extender=:\Ayes\z:}', "");;
    Expect(0, 125255, '\p{Extender=:\Ayes\z:}', "");;
    Expect(1, 125254, '\p{Extender=- Yes}', "");
    Expect(0, 125254, '\p{^Extender=- Yes}', "");
    Expect(0, 125254, '\P{Extender=- Yes}', "");
    Expect(1, 125254, '\P{^Extender=- Yes}', "");
    Expect(0, 125255, '\p{Extender=- Yes}', "");
    Expect(1, 125255, '\p{^Extender=- Yes}', "");
    Expect(1, 125255, '\P{Extender=- Yes}', "");
    Expect(0, 125255, '\P{^Extender=- Yes}', "");
    Error('\p{Ext=	_y/a/}');
    Error('\P{Ext=	_y/a/}');
    Expect(1, 125254, '\p{Ext=:\AY\z:}', "");;
    Expect(0, 125255, '\p{Ext=:\AY\z:}', "");;
    Expect(1, 125254, '\p{Ext=y}', "");
    Expect(0, 125254, '\p{^Ext=y}', "");
    Expect(0, 125254, '\P{Ext=y}', "");
    Expect(1, 125254, '\P{^Ext=y}', "");
    Expect(0, 125255, '\p{Ext=y}', "");
    Expect(1, 125255, '\p{^Ext=y}', "");
    Expect(1, 125255, '\P{Ext=y}', "");
    Expect(0, 125255, '\P{^Ext=y}', "");
    Expect(1, 125254, '\p{Ext=:\Ay\z:}', "");;
    Expect(0, 125255, '\p{Ext=:\Ay\z:}', "");;
    Expect(1, 125254, '\p{Ext=__Y}', "");
    Expect(0, 125254, '\p{^Ext=__Y}', "");
    Expect(0, 125254, '\P{Ext=__Y}', "");
    Expect(1, 125254, '\P{^Ext=__Y}', "");
    Expect(0, 125255, '\p{Ext=__Y}', "");
    Expect(1, 125255, '\p{^Ext=__Y}', "");
    Expect(1, 125255, '\P{Ext=__Y}', "");
    Expect(0, 125255, '\P{^Ext=__Y}', "");
    Error('\p{Is_Extender:   	/a/T}');
    Error('\P{Is_Extender:   	/a/T}');
    Expect(1, 125254, '\p{Is_Extender=t}', "");
    Expect(0, 125254, '\p{^Is_Extender=t}', "");
    Expect(0, 125254, '\P{Is_Extender=t}', "");
    Expect(1, 125254, '\P{^Is_Extender=t}', "");
    Expect(0, 125255, '\p{Is_Extender=t}', "");
    Expect(1, 125255, '\p{^Is_Extender=t}', "");
    Expect(1, 125255, '\P{Is_Extender=t}', "");
    Expect(0, 125255, '\P{^Is_Extender=t}', "");
    Expect(1, 125254, '\p{Is_Extender:    T}', "");
    Expect(0, 125254, '\p{^Is_Extender:    T}', "");
    Expect(0, 125254, '\P{Is_Extender:    T}', "");
    Expect(1, 125254, '\P{^Is_Extender:    T}', "");
    Expect(0, 125255, '\p{Is_Extender:    T}', "");
    Expect(1, 125255, '\p{^Is_Extender:    T}', "");
    Expect(1, 125255, '\P{Is_Extender:    T}', "");
    Expect(0, 125255, '\P{^Is_Extender:    T}', "");
    Error('\p{Is_Ext=:=TRUE}');
    Error('\P{Is_Ext=:=TRUE}');
    Expect(1, 125254, '\p{Is_Ext=true}', "");
    Expect(0, 125254, '\p{^Is_Ext=true}', "");
    Expect(0, 125254, '\P{Is_Ext=true}', "");
    Expect(1, 125254, '\P{^Is_Ext=true}', "");
    Expect(0, 125255, '\p{Is_Ext=true}', "");
    Expect(1, 125255, '\p{^Is_Ext=true}', "");
    Expect(1, 125255, '\P{Is_Ext=true}', "");
    Expect(0, 125255, '\P{^Is_Ext=true}', "");
    Expect(1, 125254, '\p{Is_Ext:   -True}', "");
    Expect(0, 125254, '\p{^Is_Ext:   -True}', "");
    Expect(0, 125254, '\P{Is_Ext:   -True}', "");
    Expect(1, 125254, '\P{^Is_Ext:   -True}', "");
    Expect(0, 125255, '\p{Is_Ext:   -True}', "");
    Expect(1, 125255, '\p{^Is_Ext:   -True}', "");
    Expect(1, 125255, '\P{Is_Ext:   -True}', "");
    Expect(0, 125255, '\P{^Is_Ext:   -True}', "");
    Error('\p{fcnfkcclosure}');
    Error('\P{fcnfkcclosure}');
    Error('\p{fcnfkc}');
    Error('\P{fcnfkc}');
    Error('\p{generalcategory}');
    Error('\P{generalcategory}');
    Error('\p{gc}');
    Error('\P{gc}');
    Error('\p{category}');
    Error('\P{category}');
    Error('\p{General_Category=	-other/a/}');
    Error('\P{General_Category=	-other/a/}');
    Expect(1, 918000, '\p{General_Category=:\AOther\z:}', "");;
    Expect(0, 917999, '\p{General_Category=:\AOther\z:}', "");;
    Expect(1, 918000, '\p{General_Category=other}', "");
    Expect(0, 918000, '\p{^General_Category=other}', "");
    Expect(0, 918000, '\P{General_Category=other}', "");
    Expect(1, 918000, '\P{^General_Category=other}', "");
    Expect(0, 917999, '\p{General_Category=other}', "");
    Expect(1, 917999, '\p{^General_Category=other}', "");
    Expect(1, 917999, '\P{General_Category=other}', "");
    Expect(0, 917999, '\P{^General_Category=other}', "");
    Expect(1, 918000, '\p{General_Category=:\Aother\z:}', "");;
    Expect(0, 917999, '\p{General_Category=:\Aother\z:}', "");;
    Expect(1, 918000, '\p{General_Category=	other}', "");
    Expect(0, 918000, '\p{^General_Category=	other}', "");
    Expect(0, 918000, '\P{General_Category=	other}', "");
    Expect(1, 918000, '\P{^General_Category=	other}', "");
    Expect(0, 917999, '\p{General_Category=	other}', "");
    Expect(1, 917999, '\p{^General_Category=	other}', "");
    Expect(1, 917999, '\P{General_Category=	other}', "");
    Expect(0, 917999, '\P{^General_Category=	other}', "");
    Error('\p{Gc: 	:=C}');
    Error('\P{Gc: 	:=C}');
    Expect(1, 918000, '\p{Gc=:\AC\z:}', "");;
    Expect(0, 917999, '\p{Gc=:\AC\z:}', "");;
    Expect(1, 918000, '\p{Gc=c}', "");
    Expect(0, 918000, '\p{^Gc=c}', "");
    Expect(0, 918000, '\P{Gc=c}', "");
    Expect(1, 918000, '\P{^Gc=c}', "");
    Expect(0, 917999, '\p{Gc=c}', "");
    Expect(1, 917999, '\p{^Gc=c}', "");
    Expect(1, 917999, '\P{Gc=c}', "");
    Expect(0, 917999, '\P{^Gc=c}', "");
    Expect(1, 918000, '\p{Gc=:\Ac\z:}', "");;
    Expect(0, 917999, '\p{Gc=:\Ac\z:}', "");;
    Expect(1, 918000, '\p{Gc=- C}', "");
    Expect(0, 918000, '\p{^Gc=- C}', "");
    Expect(0, 918000, '\P{Gc=- C}', "");
    Expect(1, 918000, '\P{^Gc=- C}', "");
    Expect(0, 917999, '\p{Gc=- C}', "");
    Expect(1, 917999, '\p{^Gc=- C}', "");
    Expect(1, 917999, '\P{Gc=- C}', "");
    Expect(0, 917999, '\P{^Gc=- C}', "");
    Error('\p{Category=_ other:=}');
    Error('\P{Category=_ other:=}');
    Expect(1, 918000, '\p{Category=:\AOther\z:}', "");;
    Expect(0, 917999, '\p{Category=:\AOther\z:}', "");;
    Expect(1, 918000, '\p{Category=other}', "");
    Expect(0, 918000, '\p{^Category=other}', "");
    Expect(0, 918000, '\P{Category=other}', "");
    Expect(1, 918000, '\P{^Category=other}', "");
    Expect(0, 917999, '\p{Category=other}', "");
    Expect(1, 917999, '\p{^Category=other}', "");
    Expect(1, 917999, '\P{Category=other}', "");
    Expect(0, 917999, '\P{^Category=other}', "");
    Expect(1, 918000, '\p{Category=:\Aother\z:}', "");;
    Expect(0, 917999, '\p{Category=:\Aother\z:}', "");;
    Expect(1, 918000, '\p{Category: 	other}', "");
    Expect(0, 918000, '\p{^Category: 	other}', "");
    Expect(0, 918000, '\P{Category: 	other}', "");
    Expect(1, 918000, '\P{^Category: 	other}', "");
    Expect(0, 917999, '\p{Category: 	other}', "");
    Expect(1, 917999, '\p{^Category: 	other}', "");
    Expect(1, 917999, '\P{Category: 	other}', "");
    Expect(0, 917999, '\P{^Category: 	other}', "");
    Error('\p{Is_General_Category=--C/a/}');
    Error('\P{Is_General_Category=--C/a/}');
    Expect(1, 918000, '\p{Is_General_Category=c}', "");
    Expect(0, 918000, '\p{^Is_General_Category=c}', "");
    Expect(0, 918000, '\P{Is_General_Category=c}', "");
    Expect(1, 918000, '\P{^Is_General_Category=c}', "");
    Expect(0, 917999, '\p{Is_General_Category=c}', "");
    Expect(1, 917999, '\p{^Is_General_Category=c}', "");
    Expect(1, 917999, '\P{Is_General_Category=c}', "");
    Expect(0, 917999, '\P{^Is_General_Category=c}', "");
    Expect(1, 918000, '\p{Is_General_Category=_c}', "");
    Expect(0, 918000, '\p{^Is_General_Category=_c}', "");
    Expect(0, 918000, '\P{Is_General_Category=_c}', "");
    Expect(1, 918000, '\P{^Is_General_Category=_c}', "");
    Expect(0, 917999, '\p{Is_General_Category=_c}', "");
    Expect(1, 917999, '\p{^Is_General_Category=_c}', "");
    Expect(1, 917999, '\P{Is_General_Category=_c}', "");
    Expect(0, 917999, '\P{^Is_General_Category=_c}', "");
    Error('\p{Is_Gc=_Other:=}');
    Error('\P{Is_Gc=_Other:=}');
    Expect(1, 918000, '\p{Is_Gc=other}', "");
    Expect(0, 918000, '\p{^Is_Gc=other}', "");
    Expect(0, 918000, '\P{Is_Gc=other}', "");
    Expect(1, 918000, '\P{^Is_Gc=other}', "");
    Expect(0, 917999, '\p{Is_Gc=other}', "");
    Expect(1, 917999, '\p{^Is_Gc=other}', "");
    Expect(1, 917999, '\P{Is_Gc=other}', "");
    Expect(0, 917999, '\P{^Is_Gc=other}', "");
    Expect(1, 918000, '\p{Is_Gc=--Other}', "");
    Expect(0, 918000, '\p{^Is_Gc=--Other}', "");
    Expect(0, 918000, '\P{Is_Gc=--Other}', "");
    Expect(1, 918000, '\P{^Is_Gc=--Other}', "");
    Expect(0, 917999, '\p{Is_Gc=--Other}', "");
    Expect(1, 917999, '\p{^Is_Gc=--Other}', "");
    Expect(1, 917999, '\P{Is_Gc=--Other}', "");
    Expect(0, 917999, '\P{^Is_Gc=--Other}', "");
    Error('\p{Is_Category=-_C/a/}');
    Error('\P{Is_Category=-_C/a/}');
    Expect(1, 918000, '\p{Is_Category=c}', "");
    Expect(0, 918000, '\p{^Is_Category=c}', "");
    Expect(0, 918000, '\P{Is_Category=c}', "");
    Expect(1, 918000, '\P{^Is_Category=c}', "");
    Expect(0, 917999, '\p{Is_Category=c}', "");
    Expect(1, 917999, '\p{^Is_Category=c}', "");
    Expect(1, 917999, '\P{Is_Category=c}', "");
    Expect(0, 917999, '\P{^Is_Category=c}', "");
    Expect(1, 918000, '\p{Is_Category=	_C}', "");
    Expect(0, 918000, '\p{^Is_Category=	_C}', "");
    Expect(0, 918000, '\P{Is_Category=	_C}', "");
    Expect(1, 918000, '\P{^Is_Category=	_C}', "");
    Expect(0, 917999, '\p{Is_Category=	_C}', "");
    Expect(1, 917999, '\p{^Is_Category=	_C}', "");
    Expect(1, 917999, '\P{Is_Category=	_C}', "");
    Expect(0, 917999, '\P{^Is_Category=	_C}', "");
    Error('\p{General_Category=_ Control:=}');
    Error('\P{General_Category=_ Control:=}');
    Expect(1, 159, '\p{General_Category=:\AControl\z:}', "");;
    Expect(0, 160, '\p{General_Category=:\AControl\z:}', "");;
    Expect(1, 159, '\p{General_Category=control}', "");
    Expect(0, 159, '\p{^General_Category=control}', "");
    Expect(0, 159, '\P{General_Category=control}', "");
    Expect(1, 159, '\P{^General_Category=control}', "");
    Expect(0, 160, '\p{General_Category=control}', "");
    Expect(1, 160, '\p{^General_Category=control}', "");
    Expect(1, 160, '\P{General_Category=control}', "");
    Expect(0, 160, '\P{^General_Category=control}', "");
    Expect(1, 159, '\p{General_Category=:\Acontrol\z:}', "");;
    Expect(0, 160, '\p{General_Category=:\Acontrol\z:}', "");;
    Expect(1, 159, '\p{General_Category=-	Control}', "");
    Expect(0, 159, '\p{^General_Category=-	Control}', "");
    Expect(0, 159, '\P{General_Category=-	Control}', "");
    Expect(1, 159, '\P{^General_Category=-	Control}', "");
    Expect(0, 160, '\p{General_Category=-	Control}', "");
    Expect(1, 160, '\p{^General_Category=-	Control}', "");
    Expect(1, 160, '\P{General_Category=-	Control}', "");
    Expect(0, 160, '\P{^General_Category=-	Control}', "");
    Error('\p{Gc=CC/a/}');
    Error('\P{Gc=CC/a/}');
    Expect(1, 159, '\p{Gc=:\ACc\z:}', "");;
    Expect(0, 160, '\p{Gc=:\ACc\z:}', "");;
    Expect(1, 159, '\p{Gc=cc}', "");
    Expect(0, 159, '\p{^Gc=cc}', "");
    Expect(0, 159, '\P{Gc=cc}', "");
    Expect(1, 159, '\P{^Gc=cc}', "");
    Expect(0, 160, '\p{Gc=cc}', "");
    Expect(1, 160, '\p{^Gc=cc}', "");
    Expect(1, 160, '\P{Gc=cc}', "");
    Expect(0, 160, '\P{^Gc=cc}', "");
    Expect(1, 159, '\p{Gc=:\Acc\z:}', "");;
    Expect(0, 160, '\p{Gc=:\Acc\z:}', "");;
    Expect(1, 159, '\p{Gc=  Cc}', "");
    Expect(0, 159, '\p{^Gc=  Cc}', "");
    Expect(0, 159, '\P{Gc=  Cc}', "");
    Expect(1, 159, '\P{^Gc=  Cc}', "");
    Expect(0, 160, '\p{Gc=  Cc}', "");
    Expect(1, 160, '\p{^Gc=  Cc}', "");
    Expect(1, 160, '\P{Gc=  Cc}', "");
    Expect(0, 160, '\P{^Gc=  Cc}', "");
    Error('\p{Category=/a/_Cntrl}');
    Error('\P{Category=/a/_Cntrl}');
    Expect(1, 159, '\p{Category=:\ACntrl\z:}', "");;
    Expect(0, 160, '\p{Category=:\ACntrl\z:}', "");;
    Expect(1, 159, '\p{Category: cntrl}', "");
    Expect(0, 159, '\p{^Category: cntrl}', "");
    Expect(0, 159, '\P{Category: cntrl}', "");
    Expect(1, 159, '\P{^Category: cntrl}', "");
    Expect(0, 160, '\p{Category: cntrl}', "");
    Expect(1, 160, '\p{^Category: cntrl}', "");
    Expect(1, 160, '\P{Category: cntrl}', "");
    Expect(0, 160, '\P{^Category: cntrl}', "");
    Expect(1, 159, '\p{Category=:\Acntrl\z:}', "");;
    Expect(0, 160, '\p{Category=:\Acntrl\z:}', "");;
    Expect(1, 159, '\p{Category= _cntrl}', "");
    Expect(0, 159, '\p{^Category= _cntrl}', "");
    Expect(0, 159, '\P{Category= _cntrl}', "");
    Expect(1, 159, '\P{^Category= _cntrl}', "");
    Expect(0, 160, '\p{Category= _cntrl}', "");
    Expect(1, 160, '\p{^Category= _cntrl}', "");
    Expect(1, 160, '\P{Category= _cntrl}', "");
    Expect(0, 160, '\P{^Category= _cntrl}', "");
    Error('\p{Is_General_Category=/a/ _CONTROL}');
    Error('\P{Is_General_Category=/a/ _CONTROL}');
    Expect(1, 159, '\p{Is_General_Category=control}', "");
    Expect(0, 159, '\p{^Is_General_Category=control}', "");
    Expect(0, 159, '\P{Is_General_Category=control}', "");
    Expect(1, 159, '\P{^Is_General_Category=control}', "");
    Expect(0, 160, '\p{Is_General_Category=control}', "");
    Expect(1, 160, '\p{^Is_General_Category=control}', "");
    Expect(1, 160, '\P{Is_General_Category=control}', "");
    Expect(0, 160, '\P{^Is_General_Category=control}', "");
    Expect(1, 159, '\p{Is_General_Category= Control}', "");
    Expect(0, 159, '\p{^Is_General_Category= Control}', "");
    Expect(0, 159, '\P{Is_General_Category= Control}', "");
    Expect(1, 159, '\P{^Is_General_Category= Control}', "");
    Expect(0, 160, '\p{Is_General_Category= Control}', "");
    Expect(1, 160, '\p{^Is_General_Category= Control}', "");
    Expect(1, 160, '\P{Is_General_Category= Control}', "");
    Expect(0, 160, '\P{^Is_General_Category= Control}', "");
    Error('\p{Is_Gc:   /a/cc}');
    Error('\P{Is_Gc:   /a/cc}');
    Expect(1, 159, '\p{Is_Gc=cc}', "");
    Expect(0, 159, '\p{^Is_Gc=cc}', "");
    Expect(0, 159, '\P{Is_Gc=cc}', "");
    Expect(1, 159, '\P{^Is_Gc=cc}', "");
    Expect(0, 160, '\p{Is_Gc=cc}', "");
    Expect(1, 160, '\p{^Is_Gc=cc}', "");
    Expect(1, 160, '\P{Is_Gc=cc}', "");
    Expect(0, 160, '\P{^Is_Gc=cc}', "");
    Expect(1, 159, '\p{Is_Gc= _cc}', "");
    Expect(0, 159, '\p{^Is_Gc= _cc}', "");
    Expect(0, 159, '\P{Is_Gc= _cc}', "");
    Expect(1, 159, '\P{^Is_Gc= _cc}', "");
    Expect(0, 160, '\p{Is_Gc= _cc}', "");
    Expect(1, 160, '\p{^Is_Gc= _cc}', "");
    Expect(1, 160, '\P{Is_Gc= _cc}', "");
    Expect(0, 160, '\P{^Is_Gc= _cc}', "");
    Error('\p{Is_Category=_cntrl:=}');
    Error('\P{Is_Category=_cntrl:=}');
    Expect(1, 159, '\p{Is_Category=cntrl}', "");
    Expect(0, 159, '\p{^Is_Category=cntrl}', "");
    Expect(0, 159, '\P{Is_Category=cntrl}', "");
    Expect(1, 159, '\P{^Is_Category=cntrl}', "");
    Expect(0, 160, '\p{Is_Category=cntrl}', "");
    Expect(1, 160, '\p{^Is_Category=cntrl}', "");
    Expect(1, 160, '\P{Is_Category=cntrl}', "");
    Expect(0, 160, '\P{^Is_Category=cntrl}', "");
    Expect(1, 159, '\p{Is_Category= Cntrl}', "");
    Expect(0, 159, '\p{^Is_Category= Cntrl}', "");
    Expect(0, 159, '\P{Is_Category= Cntrl}', "");
    Expect(1, 159, '\P{^Is_Category= Cntrl}', "");
    Expect(0, 160, '\p{Is_Category= Cntrl}', "");
    Expect(1, 160, '\p{^Is_Category= Cntrl}', "");
    Expect(1, 160, '\P{Is_Category= Cntrl}', "");
    Expect(0, 160, '\P{^Is_Category= Cntrl}', "");
    Error('\p{General_Category=:=-_format}');
    Error('\P{General_Category=:=-_format}');
    Expect(1, 917631, '\p{General_Category=:\AFormat\z:}', "");;
    Expect(0, 917632, '\p{General_Category=:\AFormat\z:}', "");;
    Expect(1, 917631, '\p{General_Category=format}', "");
    Expect(0, 917631, '\p{^General_Category=format}', "");
    Expect(0, 917631, '\P{General_Category=format}', "");
    Expect(1, 917631, '\P{^General_Category=format}', "");
    Expect(0, 917632, '\p{General_Category=format}', "");
    Expect(1, 917632, '\p{^General_Category=format}', "");
    Expect(1, 917632, '\P{General_Category=format}', "");
    Expect(0, 917632, '\P{^General_Category=format}', "");
    Expect(1, 917631, '\p{General_Category=:\Aformat\z:}', "");;
    Expect(0, 917632, '\p{General_Category=:\Aformat\z:}', "");;
    Expect(1, 917631, '\p{General_Category= 	Format}', "");
    Expect(0, 917631, '\p{^General_Category= 	Format}', "");
    Expect(0, 917631, '\P{General_Category= 	Format}', "");
    Expect(1, 917631, '\P{^General_Category= 	Format}', "");
    Expect(0, 917632, '\p{General_Category= 	Format}', "");
    Expect(1, 917632, '\p{^General_Category= 	Format}', "");
    Expect(1, 917632, '\P{General_Category= 	Format}', "");
    Expect(0, 917632, '\P{^General_Category= 	Format}', "");
    Error('\p{Gc=-_Cf:=}');
    Error('\P{Gc=-_Cf:=}');
    Expect(1, 917631, '\p{Gc=:\ACf\z:}', "");;
    Expect(0, 917632, '\p{Gc=:\ACf\z:}', "");;
    Expect(1, 917631, '\p{Gc=cf}', "");
    Expect(0, 917631, '\p{^Gc=cf}', "");
    Expect(0, 917631, '\P{Gc=cf}', "");
    Expect(1, 917631, '\P{^Gc=cf}', "");
    Expect(0, 917632, '\p{Gc=cf}', "");
    Expect(1, 917632, '\p{^Gc=cf}', "");
    Expect(1, 917632, '\P{Gc=cf}', "");
    Expect(0, 917632, '\P{^Gc=cf}', "");
    Expect(1, 917631, '\p{Gc=:\Acf\z:}', "");;
    Expect(0, 917632, '\p{Gc=:\Acf\z:}', "");;
    Expect(1, 917631, '\p{Gc=_	Cf}', "");
    Expect(0, 917631, '\p{^Gc=_	Cf}', "");
    Expect(0, 917631, '\P{Gc=_	Cf}', "");
    Expect(1, 917631, '\P{^Gc=_	Cf}', "");
    Expect(0, 917632, '\p{Gc=_	Cf}', "");
    Expect(1, 917632, '\p{^Gc=_	Cf}', "");
    Expect(1, 917632, '\P{Gc=_	Cf}', "");
    Expect(0, 917632, '\P{^Gc=_	Cf}', "");
    Error('\p{Category=	/a/Format}');
    Error('\P{Category=	/a/Format}');
    Expect(1, 917631, '\p{Category=:\AFormat\z:}', "");;
    Expect(0, 917632, '\p{Category=:\AFormat\z:}', "");;
    Expect(1, 917631, '\p{Category=format}', "");
    Expect(0, 917631, '\p{^Category=format}', "");
    Expect(0, 917631, '\P{Category=format}', "");
    Expect(1, 917631, '\P{^Category=format}', "");
    Expect(0, 917632, '\p{Category=format}', "");
    Expect(1, 917632, '\p{^Category=format}', "");
    Expect(1, 917632, '\P{Category=format}', "");
    Expect(0, 917632, '\P{^Category=format}', "");
    Expect(1, 917631, '\p{Category=:\Aformat\z:}', "");;
    Expect(0, 917632, '\p{Category=:\Aformat\z:}', "");;
    Expect(1, 917631, '\p{Category: 	 Format}', "");
    Expect(0, 917631, '\p{^Category: 	 Format}', "");
    Expect(0, 917631, '\P{Category: 	 Format}', "");
    Expect(1, 917631, '\P{^Category: 	 Format}', "");
    Expect(0, 917632, '\p{Category: 	 Format}', "");
    Expect(1, 917632, '\p{^Category: 	 Format}', "");
    Expect(1, 917632, '\P{Category: 	 Format}', "");
    Expect(0, 917632, '\P{^Category: 	 Format}', "");
    Error('\p{Is_General_Category=:=-_cf}');
    Error('\P{Is_General_Category=:=-_cf}');
    Expect(1, 917631, '\p{Is_General_Category:	cf}', "");
    Expect(0, 917631, '\p{^Is_General_Category:	cf}', "");
    Expect(0, 917631, '\P{Is_General_Category:	cf}', "");
    Expect(1, 917631, '\P{^Is_General_Category:	cf}', "");
    Expect(0, 917632, '\p{Is_General_Category:	cf}', "");
    Expect(1, 917632, '\p{^Is_General_Category:	cf}', "");
    Expect(1, 917632, '\P{Is_General_Category:	cf}', "");
    Expect(0, 917632, '\P{^Is_General_Category:	cf}', "");
    Expect(1, 917631, '\p{Is_General_Category= 	cf}', "");
    Expect(0, 917631, '\p{^Is_General_Category= 	cf}', "");
    Expect(0, 917631, '\P{Is_General_Category= 	cf}', "");
    Expect(1, 917631, '\P{^Is_General_Category= 	cf}', "");
    Expect(0, 917632, '\p{Is_General_Category= 	cf}', "");
    Expect(1, 917632, '\p{^Is_General_Category= 	cf}', "");
    Expect(1, 917632, '\P{Is_General_Category= 	cf}', "");
    Expect(0, 917632, '\P{^Is_General_Category= 	cf}', "");
    Error('\p{Is_Gc:	 Format/a/}');
    Error('\P{Is_Gc:	 Format/a/}');
    Expect(1, 917631, '\p{Is_Gc=format}', "");
    Expect(0, 917631, '\p{^Is_Gc=format}', "");
    Expect(0, 917631, '\P{Is_Gc=format}', "");
    Expect(1, 917631, '\P{^Is_Gc=format}', "");
    Expect(0, 917632, '\p{Is_Gc=format}', "");
    Expect(1, 917632, '\p{^Is_Gc=format}', "");
    Expect(1, 917632, '\P{Is_Gc=format}', "");
    Expect(0, 917632, '\P{^Is_Gc=format}', "");
    Expect(1, 917631, '\p{Is_Gc=_FORMAT}', "");
    Expect(0, 917631, '\p{^Is_Gc=_FORMAT}', "");
    Expect(0, 917631, '\P{Is_Gc=_FORMAT}', "");
    Expect(1, 917631, '\P{^Is_Gc=_FORMAT}', "");
    Expect(0, 917632, '\p{Is_Gc=_FORMAT}', "");
    Expect(1, 917632, '\p{^Is_Gc=_FORMAT}', "");
    Expect(1, 917632, '\P{Is_Gc=_FORMAT}', "");
    Expect(0, 917632, '\P{^Is_Gc=_FORMAT}', "");
    Error('\p{Is_Category=/a/Cf}');
    Error('\P{Is_Category=/a/Cf}');
    Expect(1, 917631, '\p{Is_Category=cf}', "");
    Expect(0, 917631, '\p{^Is_Category=cf}', "");
    Expect(0, 917631, '\P{Is_Category=cf}', "");
    Expect(1, 917631, '\P{^Is_Category=cf}', "");
    Expect(0, 917632, '\p{Is_Category=cf}', "");
    Expect(1, 917632, '\p{^Is_Category=cf}', "");
    Expect(1, 917632, '\P{Is_Category=cf}', "");
    Expect(0, 917632, '\P{^Is_Category=cf}', "");
    Expect(1, 917631, '\p{Is_Category=	 cf}', "");
    Expect(0, 917631, '\p{^Is_Category=	 cf}', "");
    Expect(0, 917631, '\P{Is_Category=	 cf}', "");
    Expect(1, 917631, '\P{^Is_Category=	 cf}', "");
    Expect(0, 917632, '\p{Is_Category=	 cf}', "");
    Expect(1, 917632, '\p{^Is_Category=	 cf}', "");
    Expect(1, 917632, '\P{Is_Category=	 cf}', "");
    Expect(0, 917632, '\P{^Is_Category=	 cf}', "");
    Error('\p{General_Category=_/a/Unassigned}');
    Error('\P{General_Category=_/a/Unassigned}');
    Expect(1, 918000, '\p{General_Category=:\AUnassigned\z:}', "");;
    Expect(0, 1114109, '\p{General_Category=:\AUnassigned\z:}', "");;
    Expect(1, 918000, '\p{General_Category:   unassigned}', "");
    Expect(0, 918000, '\p{^General_Category:   unassigned}', "");
    Expect(0, 918000, '\P{General_Category:   unassigned}', "");
    Expect(1, 918000, '\P{^General_Category:   unassigned}', "");
    Expect(0, 1114109, '\p{General_Category:   unassigned}', "");
    Expect(1, 1114109, '\p{^General_Category:   unassigned}', "");
    Expect(1, 1114109, '\P{General_Category:   unassigned}', "");
    Expect(0, 1114109, '\P{^General_Category:   unassigned}', "");
    Expect(1, 918000, '\p{General_Category=:\Aunassigned\z:}', "");;
    Expect(0, 1114109, '\p{General_Category=:\Aunassigned\z:}', "");;
    Expect(1, 918000, '\p{General_Category=-_UNASSIGNED}', "");
    Expect(0, 918000, '\p{^General_Category=-_UNASSIGNED}', "");
    Expect(0, 918000, '\P{General_Category=-_UNASSIGNED}', "");
    Expect(1, 918000, '\P{^General_Category=-_UNASSIGNED}', "");
    Expect(0, 1114109, '\p{General_Category=-_UNASSIGNED}', "");
    Expect(1, 1114109, '\p{^General_Category=-_UNASSIGNED}', "");
    Expect(1, 1114109, '\P{General_Category=-_UNASSIGNED}', "");
    Expect(0, 1114109, '\P{^General_Category=-_UNASSIGNED}', "");
    Error('\p{Gc=/a/__CN}');
    Error('\P{Gc=/a/__CN}');
    Expect(1, 918000, '\p{Gc=:\ACn\z:}', "");;
    Expect(0, 1114109, '\p{Gc=:\ACn\z:}', "");;
    Expect(1, 918000, '\p{Gc:	cn}', "");
    Expect(0, 918000, '\p{^Gc:	cn}', "");
    Expect(0, 918000, '\P{Gc:	cn}', "");
    Expect(1, 918000, '\P{^Gc:	cn}', "");
    Expect(0, 1114109, '\p{Gc:	cn}', "");
    Expect(1, 1114109, '\p{^Gc:	cn}', "");
    Expect(1, 1114109, '\P{Gc:	cn}', "");
    Expect(0, 1114109, '\P{^Gc:	cn}', "");
    Expect(1, 918000, '\p{Gc=:\Acn\z:}', "");;
    Expect(0, 1114109, '\p{Gc=:\Acn\z:}', "");;
    Expect(1, 918000, '\p{Gc=  cn}', "");
    Expect(0, 918000, '\p{^Gc=  cn}', "");
    Expect(0, 918000, '\P{Gc=  cn}', "");
    Expect(1, 918000, '\P{^Gc=  cn}', "");
    Expect(0, 1114109, '\p{Gc=  cn}', "");
    Expect(1, 1114109, '\p{^Gc=  cn}', "");
    Expect(1, 1114109, '\P{Gc=  cn}', "");
    Expect(0, 1114109, '\P{^Gc=  cn}', "");
    Error('\p{Category=:=-Unassigned}');
    Error('\P{Category=:=-Unassigned}');
    Expect(1, 918000, '\p{Category=:\AUnassigned\z:}', "");;
    Expect(0, 1114109, '\p{Category=:\AUnassigned\z:}', "");;
    Expect(1, 918000, '\p{Category=unassigned}', "");
    Expect(0, 918000, '\p{^Category=unassigned}', "");
    Expect(0, 918000, '\P{Category=unassigned}', "");
    Expect(1, 918000, '\P{^Category=unassigned}', "");
    Expect(0, 1114109, '\p{Category=unassigned}', "");
    Expect(1, 1114109, '\p{^Category=unassigned}', "");
    Expect(1, 1114109, '\P{Category=unassigned}', "");
    Expect(0, 1114109, '\P{^Category=unassigned}', "");
    Expect(1, 918000, '\p{Category=:\Aunassigned\z:}', "");;
    Expect(0, 1114109, '\p{Category=:\Aunassigned\z:}', "");;
    Expect(1, 918000, '\p{Category:	  UNASSIGNED}', "");
    Expect(0, 918000, '\p{^Category:	  UNASSIGNED}', "");
    Expect(0, 918000, '\P{Category:	  UNASSIGNED}', "");
    Expect(1, 918000, '\P{^Category:	  UNASSIGNED}', "");
    Expect(0, 1114109, '\p{Category:	  UNASSIGNED}', "");
    Expect(1, 1114109, '\p{^Category:	  UNASSIGNED}', "");
    Expect(1, 1114109, '\P{Category:	  UNASSIGNED}', "");
    Expect(0, 1114109, '\P{^Category:	  UNASSIGNED}', "");
    Error('\p{Is_General_Category=--cn:=}');
    Error('\P{Is_General_Category=--cn:=}');
    Expect(1, 918000, '\p{Is_General_Category=cn}', "");
    Expect(0, 918000, '\p{^Is_General_Category=cn}', "");
    Expect(0, 918000, '\P{Is_General_Category=cn}', "");
    Expect(1, 918000, '\P{^Is_General_Category=cn}', "");
    Expect(0, 1114109, '\p{Is_General_Category=cn}', "");
    Expect(1, 1114109, '\p{^Is_General_Category=cn}', "");
    Expect(1, 1114109, '\P{Is_General_Category=cn}', "");
    Expect(0, 1114109, '\P{^Is_General_Category=cn}', "");
    Expect(1, 918000, '\p{Is_General_Category=--cn}', "");
    Expect(0, 918000, '\p{^Is_General_Category=--cn}', "");
    Expect(0, 918000, '\P{Is_General_Category=--cn}', "");
    Expect(1, 918000, '\P{^Is_General_Category=--cn}', "");
    Expect(0, 1114109, '\p{Is_General_Category=--cn}', "");
    Expect(1, 1114109, '\p{^Is_General_Category=--cn}', "");
    Expect(1, 1114109, '\P{Is_General_Category=--cn}', "");
    Expect(0, 1114109, '\P{^Is_General_Category=--cn}', "");
    Error('\p{Is_Gc=	Unassigned/a/}');
    Error('\P{Is_Gc=	Unassigned/a/}');
    Expect(1, 918000, '\p{Is_Gc=unassigned}', "");
    Expect(0, 918000, '\p{^Is_Gc=unassigned}', "");
    Expect(0, 918000, '\P{Is_Gc=unassigned}', "");
    Expect(1, 918000, '\P{^Is_Gc=unassigned}', "");
    Expect(0, 1114109, '\p{Is_Gc=unassigned}', "");
    Expect(1, 1114109, '\p{^Is_Gc=unassigned}', "");
    Expect(1, 1114109, '\P{Is_Gc=unassigned}', "");
    Expect(0, 1114109, '\P{^Is_Gc=unassigned}', "");
    Expect(1, 918000, '\p{Is_Gc=	Unassigned}', "");
    Expect(0, 918000, '\p{^Is_Gc=	Unassigned}', "");
    Expect(0, 918000, '\P{Is_Gc=	Unassigned}', "");
    Expect(1, 918000, '\P{^Is_Gc=	Unassigned}', "");
    Expect(0, 1114109, '\p{Is_Gc=	Unassigned}', "");
    Expect(1, 1114109, '\p{^Is_Gc=	Unassigned}', "");
    Expect(1, 1114109, '\P{Is_Gc=	Unassigned}', "");
    Expect(0, 1114109, '\P{^Is_Gc=	Unassigned}', "");
    Error('\p{Is_Category= -Cn/a/}');
    Error('\P{Is_Category= -Cn/a/}');
    Expect(1, 918000, '\p{Is_Category=cn}', "");
    Expect(0, 918000, '\p{^Is_Category=cn}', "");
    Expect(0, 918000, '\P{Is_Category=cn}', "");
    Expect(1, 918000, '\P{^Is_Category=cn}', "");
    Expect(0, 1114109, '\p{Is_Category=cn}', "");
    Expect(1, 1114109, '\p{^Is_Category=cn}', "");
    Expect(1, 1114109, '\P{Is_Category=cn}', "");
    Expect(0, 1114109, '\P{^Is_Category=cn}', "");
    Expect(1, 918000, '\p{Is_Category=	cn}', "");
    Expect(0, 918000, '\p{^Is_Category=	cn}', "");
    Expect(0, 918000, '\P{Is_Category=	cn}', "");
    Expect(1, 918000, '\P{^Is_Category=	cn}', "");
    Expect(0, 1114109, '\p{Is_Category=	cn}', "");
    Expect(1, 1114109, '\p{^Is_Category=	cn}', "");
    Expect(1, 1114109, '\P{Is_Category=	cn}', "");
    Expect(0, 1114109, '\P{^Is_Category=	cn}', "");
    Error('\p{General_Category:	/a/ private_Use}');
    Error('\P{General_Category:	/a/ private_Use}');
    Expect(1, 1114109, '\p{General_Category=:\APrivate_Use\z:}', "");;
    Expect(0, 63744, '\p{General_Category=:\APrivate_Use\z:}', "");;
    Expect(1, 1114109, '\p{General_Category=privateuse}', "");
    Expect(0, 1114109, '\p{^General_Category=privateuse}', "");
    Expect(0, 1114109, '\P{General_Category=privateuse}', "");
    Expect(1, 1114109, '\P{^General_Category=privateuse}', "");
    Expect(0, 63744, '\p{General_Category=privateuse}', "");
    Expect(1, 63744, '\p{^General_Category=privateuse}', "");
    Expect(1, 63744, '\P{General_Category=privateuse}', "");
    Expect(0, 63744, '\P{^General_Category=privateuse}', "");
    Expect(1, 1114109, '\p{General_Category=:\Aprivateuse\z:}', "");;
    Expect(0, 63744, '\p{General_Category=:\Aprivateuse\z:}', "");;
    Expect(1, 1114109, '\p{General_Category=	-Private_USE}', "");
    Expect(0, 1114109, '\p{^General_Category=	-Private_USE}', "");
    Expect(0, 1114109, '\P{General_Category=	-Private_USE}', "");
    Expect(1, 1114109, '\P{^General_Category=	-Private_USE}', "");
    Expect(0, 63744, '\p{General_Category=	-Private_USE}', "");
    Expect(1, 63744, '\p{^General_Category=	-Private_USE}', "");
    Expect(1, 63744, '\P{General_Category=	-Private_USE}', "");
    Expect(0, 63744, '\P{^General_Category=	-Private_USE}', "");
    Error('\p{Gc=	-co/a/}');
    Error('\P{Gc=	-co/a/}');
    Expect(1, 1114109, '\p{Gc=:\ACo\z:}', "");;
    Expect(0, 63744, '\p{Gc=:\ACo\z:}', "");;
    Expect(1, 1114109, '\p{Gc=co}', "");
    Expect(0, 1114109, '\p{^Gc=co}', "");
    Expect(0, 1114109, '\P{Gc=co}', "");
    Expect(1, 1114109, '\P{^Gc=co}', "");
    Expect(0, 63744, '\p{Gc=co}', "");
    Expect(1, 63744, '\p{^Gc=co}', "");
    Expect(1, 63744, '\P{Gc=co}', "");
    Expect(0, 63744, '\P{^Gc=co}', "");
    Expect(1, 1114109, '\p{Gc=:\Aco\z:}', "");;
    Expect(0, 63744, '\p{Gc=:\Aco\z:}', "");;
    Expect(1, 1114109, '\p{Gc=--co}', "");
    Expect(0, 1114109, '\p{^Gc=--co}', "");
    Expect(0, 1114109, '\P{Gc=--co}', "");
    Expect(1, 1114109, '\P{^Gc=--co}', "");
    Expect(0, 63744, '\p{Gc=--co}', "");
    Expect(1, 63744, '\p{^Gc=--co}', "");
    Expect(1, 63744, '\P{Gc=--co}', "");
    Expect(0, 63744, '\P{^Gc=--co}', "");
    Error('\p{Category=/a/__private_Use}');
    Error('\P{Category=/a/__private_Use}');
    Expect(1, 1114109, '\p{Category=:\APrivate_Use\z:}', "");;
    Expect(0, 63744, '\p{Category=:\APrivate_Use\z:}', "");;
    Expect(1, 1114109, '\p{Category:privateuse}', "");
    Expect(0, 1114109, '\p{^Category:privateuse}', "");
    Expect(0, 1114109, '\P{Category:privateuse}', "");
    Expect(1, 1114109, '\P{^Category:privateuse}', "");
    Expect(0, 63744, '\p{Category:privateuse}', "");
    Expect(1, 63744, '\p{^Category:privateuse}', "");
    Expect(1, 63744, '\P{Category:privateuse}', "");
    Expect(0, 63744, '\P{^Category:privateuse}', "");
    Expect(1, 1114109, '\p{Category=:\Aprivateuse\z:}', "");;
    Expect(0, 63744, '\p{Category=:\Aprivateuse\z:}', "");;
    Expect(1, 1114109, '\p{Category=-_Private_Use}', "");
    Expect(0, 1114109, '\p{^Category=-_Private_Use}', "");
    Expect(0, 1114109, '\P{Category=-_Private_Use}', "");
    Expect(1, 1114109, '\P{^Category=-_Private_Use}', "");
    Expect(0, 63744, '\p{Category=-_Private_Use}', "");
    Expect(1, 63744, '\p{^Category=-_Private_Use}', "");
    Expect(1, 63744, '\P{Category=-_Private_Use}', "");
    Expect(0, 63744, '\P{^Category=-_Private_Use}', "");
    Error('\p{Is_General_Category=:=-Co}');
    Error('\P{Is_General_Category=:=-Co}');
    Expect(1, 1114109, '\p{Is_General_Category=co}', "");
    Expect(0, 1114109, '\p{^Is_General_Category=co}', "");
    Expect(0, 1114109, '\P{Is_General_Category=co}', "");
    Expect(1, 1114109, '\P{^Is_General_Category=co}', "");
    Expect(0, 63744, '\p{Is_General_Category=co}', "");
    Expect(1, 63744, '\p{^Is_General_Category=co}', "");
    Expect(1, 63744, '\P{Is_General_Category=co}', "");
    Expect(0, 63744, '\P{^Is_General_Category=co}', "");
    Expect(1, 1114109, '\p{Is_General_Category=_ co}', "");
    Expect(0, 1114109, '\p{^Is_General_Category=_ co}', "");
    Expect(0, 1114109, '\P{Is_General_Category=_ co}', "");
    Expect(1, 1114109, '\P{^Is_General_Category=_ co}', "");
    Expect(0, 63744, '\p{Is_General_Category=_ co}', "");
    Expect(1, 63744, '\p{^Is_General_Category=_ co}', "");
    Expect(1, 63744, '\P{Is_General_Category=_ co}', "");
    Expect(0, 63744, '\P{^Is_General_Category=_ co}', "");
    Error('\p{Is_Gc= :=PRIVATE_USE}');
    Error('\P{Is_Gc= :=PRIVATE_USE}');
    Expect(1, 1114109, '\p{Is_Gc=privateuse}', "");
    Expect(0, 1114109, '\p{^Is_Gc=privateuse}', "");
    Expect(0, 1114109, '\P{Is_Gc=privateuse}', "");
    Expect(1, 1114109, '\P{^Is_Gc=privateuse}', "");
    Expect(0, 63744, '\p{Is_Gc=privateuse}', "");
    Expect(1, 63744, '\p{^Is_Gc=privateuse}', "");
    Expect(1, 63744, '\P{Is_Gc=privateuse}', "");
    Expect(0, 63744, '\P{^Is_Gc=privateuse}', "");
    Expect(1, 1114109, '\p{Is_Gc=__private_use}', "");
    Expect(0, 1114109, '\p{^Is_Gc=__private_use}', "");
    Expect(0, 1114109, '\P{Is_Gc=__private_use}', "");
    Expect(1, 1114109, '\P{^Is_Gc=__private_use}', "");
    Expect(0, 63744, '\p{Is_Gc=__private_use}', "");
    Expect(1, 63744, '\p{^Is_Gc=__private_use}', "");
    Expect(1, 63744, '\P{Is_Gc=__private_use}', "");
    Expect(0, 63744, '\P{^Is_Gc=__private_use}', "");
    Error('\p{Is_Category=:= 	CO}');
    Error('\P{Is_Category=:= 	CO}');
    Expect(1, 1114109, '\p{Is_Category=co}', "");
    Expect(0, 1114109, '\p{^Is_Category=co}', "");
    Expect(0, 1114109, '\P{Is_Category=co}', "");
    Expect(1, 1114109, '\P{^Is_Category=co}', "");
    Expect(0, 63744, '\p{Is_Category=co}', "");
    Expect(1, 63744, '\p{^Is_Category=co}', "");
    Expect(1, 63744, '\P{Is_Category=co}', "");
    Expect(0, 63744, '\P{^Is_Category=co}', "");
    Expect(1, 1114109, '\p{Is_Category=--co}', "");
    Expect(0, 1114109, '\p{^Is_Category=--co}', "");
    Expect(0, 1114109, '\P{Is_Category=--co}', "");
    Expect(1, 1114109, '\P{^Is_Category=--co}', "");
    Expect(0, 63744, '\p{Is_Category=--co}', "");
    Expect(1, 63744, '\p{^Is_Category=--co}', "");
    Expect(1, 63744, '\P{Is_Category=--co}', "");
    Expect(0, 63744, '\P{^Is_Category=--co}', "");
    Error('\p{General_Category=:=surrogate}');
    Error('\P{General_Category=:=surrogate}');
    Expect(1, 57343, '\p{General_Category=:\ASurrogate\z:}', "");;
    Expect(0, 57344, '\p{General_Category=:\ASurrogate\z:}', "");;
    Expect(1, 57343, '\p{General_Category=surrogate}', "");
    Expect(0, 57343, '\p{^General_Category=surrogate}', "");
    Expect(0, 57343, '\P{General_Category=surrogate}', "");
    Expect(1, 57343, '\P{^General_Category=surrogate}', "");
    Expect(0, 57344, '\p{General_Category=surrogate}', "");
    Expect(1, 57344, '\p{^General_Category=surrogate}', "");
    Expect(1, 57344, '\P{General_Category=surrogate}', "");
    Expect(0, 57344, '\P{^General_Category=surrogate}', "");
    Expect(1, 57343, '\p{General_Category=:\Asurrogate\z:}', "");;
    Expect(0, 57344, '\p{General_Category=:\Asurrogate\z:}', "");;
    Expect(1, 57343, '\p{General_Category=	 Surrogate}', "");
    Expect(0, 57343, '\p{^General_Category=	 Surrogate}', "");
    Expect(0, 57343, '\P{General_Category=	 Surrogate}', "");
    Expect(1, 57343, '\P{^General_Category=	 Surrogate}', "");
    Expect(0, 57344, '\p{General_Category=	 Surrogate}', "");
    Expect(1, 57344, '\p{^General_Category=	 Surrogate}', "");
    Expect(1, 57344, '\P{General_Category=	 Surrogate}', "");
    Expect(0, 57344, '\P{^General_Category=	 Surrogate}', "");
    Error('\p{Gc=- cs/a/}');
    Error('\P{Gc=- cs/a/}');
    Expect(1, 57343, '\p{Gc=:\ACs\z:}', "");;
    Expect(0, 57344, '\p{Gc=:\ACs\z:}', "");;
    Expect(1, 57343, '\p{Gc=cs}', "");
    Expect(0, 57343, '\p{^Gc=cs}', "");
    Expect(0, 57343, '\P{Gc=cs}', "");
    Expect(1, 57343, '\P{^Gc=cs}', "");
    Expect(0, 57344, '\p{Gc=cs}', "");
    Expect(1, 57344, '\p{^Gc=cs}', "");
    Expect(1, 57344, '\P{Gc=cs}', "");
    Expect(0, 57344, '\P{^Gc=cs}', "");
    Expect(1, 57343, '\p{Gc=:\Acs\z:}', "");;
    Expect(0, 57344, '\p{Gc=:\Acs\z:}', "");;
    Expect(1, 57343, '\p{Gc:	_	CS}', "");
    Expect(0, 57343, '\p{^Gc:	_	CS}', "");
    Expect(0, 57343, '\P{Gc:	_	CS}', "");
    Expect(1, 57343, '\P{^Gc:	_	CS}', "");
    Expect(0, 57344, '\p{Gc:	_	CS}', "");
    Expect(1, 57344, '\p{^Gc:	_	CS}', "");
    Expect(1, 57344, '\P{Gc:	_	CS}', "");
    Expect(0, 57344, '\P{^Gc:	_	CS}', "");
    Error('\p{Category=	-SURROGATE:=}');
    Error('\P{Category=	-SURROGATE:=}');
    Expect(1, 57343, '\p{Category=:\ASurrogate\z:}', "");;
    Expect(0, 57344, '\p{Category=:\ASurrogate\z:}', "");;
    Expect(1, 57343, '\p{Category: surrogate}', "");
    Expect(0, 57343, '\p{^Category: surrogate}', "");
    Expect(0, 57343, '\P{Category: surrogate}', "");
    Expect(1, 57343, '\P{^Category: surrogate}', "");
    Expect(0, 57344, '\p{Category: surrogate}', "");
    Expect(1, 57344, '\p{^Category: surrogate}', "");
    Expect(1, 57344, '\P{Category: surrogate}', "");
    Expect(0, 57344, '\P{^Category: surrogate}', "");
    Expect(1, 57343, '\p{Category=:\Asurrogate\z:}', "");;
    Expect(0, 57344, '\p{Category=:\Asurrogate\z:}', "");;
    Expect(1, 57343, '\p{Category=  surrogate}', "");
    Expect(0, 57343, '\p{^Category=  surrogate}', "");
    Expect(0, 57343, '\P{Category=  surrogate}', "");
    Expect(1, 57343, '\P{^Category=  surrogate}', "");
    Expect(0, 57344, '\p{Category=  surrogate}', "");
    Expect(1, 57344, '\p{^Category=  surrogate}', "");
    Expect(1, 57344, '\P{Category=  surrogate}', "");
    Expect(0, 57344, '\P{^Category=  surrogate}', "");
    Error('\p{Is_General_Category= CS:=}');
    Error('\P{Is_General_Category= CS:=}');
    Expect(1, 57343, '\p{Is_General_Category=cs}', "");
    Expect(0, 57343, '\p{^Is_General_Category=cs}', "");
    Expect(0, 57343, '\P{Is_General_Category=cs}', "");
    Expect(1, 57343, '\P{^Is_General_Category=cs}', "");
    Expect(0, 57344, '\p{Is_General_Category=cs}', "");
    Expect(1, 57344, '\p{^Is_General_Category=cs}', "");
    Expect(1, 57344, '\P{Is_General_Category=cs}', "");
    Expect(0, 57344, '\P{^Is_General_Category=cs}', "");
    Expect(1, 57343, '\p{Is_General_Category=__CS}', "");
    Expect(0, 57343, '\p{^Is_General_Category=__CS}', "");
    Expect(0, 57343, '\P{Is_General_Category=__CS}', "");
    Expect(1, 57343, '\P{^Is_General_Category=__CS}', "");
    Expect(0, 57344, '\p{Is_General_Category=__CS}', "");
    Expect(1, 57344, '\p{^Is_General_Category=__CS}', "");
    Expect(1, 57344, '\P{Is_General_Category=__CS}', "");
    Expect(0, 57344, '\P{^Is_General_Category=__CS}', "");
    Error('\p{Is_Gc=:=- SURROGATE}');
    Error('\P{Is_Gc=:=- SURROGATE}');
    Expect(1, 57343, '\p{Is_Gc=surrogate}', "");
    Expect(0, 57343, '\p{^Is_Gc=surrogate}', "");
    Expect(0, 57343, '\P{Is_Gc=surrogate}', "");
    Expect(1, 57343, '\P{^Is_Gc=surrogate}', "");
    Expect(0, 57344, '\p{Is_Gc=surrogate}', "");
    Expect(1, 57344, '\p{^Is_Gc=surrogate}', "");
    Expect(1, 57344, '\P{Is_Gc=surrogate}', "");
    Expect(0, 57344, '\P{^Is_Gc=surrogate}', "");
    Expect(1, 57343, '\p{Is_Gc:-Surrogate}', "");
    Expect(0, 57343, '\p{^Is_Gc:-Surrogate}', "");
    Expect(0, 57343, '\P{Is_Gc:-Surrogate}', "");
    Expect(1, 57343, '\P{^Is_Gc:-Surrogate}', "");
    Expect(0, 57344, '\p{Is_Gc:-Surrogate}', "");
    Expect(1, 57344, '\p{^Is_Gc:-Surrogate}', "");
    Expect(1, 57344, '\P{Is_Gc:-Surrogate}', "");
    Expect(0, 57344, '\P{^Is_Gc:-Surrogate}', "");
    Error('\p{Is_Category=- Cs:=}');
    Error('\P{Is_Category=- Cs:=}');
    Expect(1, 57343, '\p{Is_Category:	cs}', "");
    Expect(0, 57343, '\p{^Is_Category:	cs}', "");
    Expect(0, 57343, '\P{Is_Category:	cs}', "");
    Expect(1, 57343, '\P{^Is_Category:	cs}', "");
    Expect(0, 57344, '\p{Is_Category:	cs}', "");
    Expect(1, 57344, '\p{^Is_Category:	cs}', "");
    Expect(1, 57344, '\P{Is_Category:	cs}', "");
    Expect(0, 57344, '\P{^Is_Category:	cs}', "");
    Expect(1, 57343, '\p{Is_Category: 	_Cs}', "");
    Expect(0, 57343, '\p{^Is_Category: 	_Cs}', "");
    Expect(0, 57343, '\P{Is_Category: 	_Cs}', "");
    Expect(1, 57343, '\P{^Is_Category: 	_Cs}', "");
    Expect(0, 57344, '\p{Is_Category: 	_Cs}', "");
    Expect(1, 57344, '\p{^Is_Category: 	_Cs}', "");
    Expect(1, 57344, '\P{Is_Category: 	_Cs}', "");
    Expect(0, 57344, '\P{^Is_Category: 	_Cs}', "");
    Error('\p{General_Category=  Letter:=}');
    Error('\P{General_Category=  Letter:=}');
    Expect(1, 195101, '\p{General_Category=:\ALetter\z:}', "");;
    Expect(0, 195102, '\p{General_Category=:\ALetter\z:}', "");;
    Expect(1, 195101, '\p{General_Category=letter}', "");
    Expect(0, 195101, '\p{^General_Category=letter}', "");
    Expect(0, 195101, '\P{General_Category=letter}', "");
    Expect(1, 195101, '\P{^General_Category=letter}', "");
    Expect(0, 195102, '\p{General_Category=letter}', "");
    Expect(1, 195102, '\p{^General_Category=letter}', "");
    Expect(1, 195102, '\P{General_Category=letter}', "");
    Expect(0, 195102, '\P{^General_Category=letter}', "");
    Expect(1, 195101, '\p{General_Category=:\Aletter\z:}', "");;
    Expect(0, 195102, '\p{General_Category=:\Aletter\z:}', "");;
    Expect(1, 195101, '\p{General_Category:  Letter}', "");
    Expect(0, 195101, '\p{^General_Category:  Letter}', "");
    Expect(0, 195101, '\P{General_Category:  Letter}', "");
    Expect(1, 195101, '\P{^General_Category:  Letter}', "");
    Expect(0, 195102, '\p{General_Category:  Letter}', "");
    Expect(1, 195102, '\p{^General_Category:  Letter}', "");
    Expect(1, 195102, '\P{General_Category:  Letter}', "");
    Expect(0, 195102, '\P{^General_Category:  Letter}', "");
    Error('\p{Gc=/a/	L}');
    Error('\P{Gc=/a/	L}');
    Expect(1, 195101, '\p{Gc=:\AL\z:}', "");;
    Expect(0, 195102, '\p{Gc=:\AL\z:}', "");;
    Expect(1, 195101, '\p{Gc=l}', "");
    Expect(0, 195101, '\p{^Gc=l}', "");
    Expect(0, 195101, '\P{Gc=l}', "");
    Expect(1, 195101, '\P{^Gc=l}', "");
    Expect(0, 195102, '\p{Gc=l}', "");
    Expect(1, 195102, '\p{^Gc=l}', "");
    Expect(1, 195102, '\P{Gc=l}', "");
    Expect(0, 195102, '\P{^Gc=l}', "");
    Expect(1, 195101, '\p{Gc=:\Al\z:}', "");;
    Expect(0, 195102, '\p{Gc=:\Al\z:}', "");;
    Expect(1, 195101, '\p{Gc=-	L}', "");
    Expect(0, 195101, '\p{^Gc=-	L}', "");
    Expect(0, 195101, '\P{Gc=-	L}', "");
    Expect(1, 195101, '\P{^Gc=-	L}', "");
    Expect(0, 195102, '\p{Gc=-	L}', "");
    Expect(1, 195102, '\p{^Gc=-	L}', "");
    Expect(1, 195102, '\P{Gc=-	L}', "");
    Expect(0, 195102, '\P{^Gc=-	L}', "");
    Error('\p{Category: -_letter:=}');
    Error('\P{Category: -_letter:=}');
    Expect(1, 195101, '\p{Category=:\ALetter\z:}', "");;
    Expect(0, 195102, '\p{Category=:\ALetter\z:}', "");;
    Expect(1, 195101, '\p{Category=letter}', "");
    Expect(0, 195101, '\p{^Category=letter}', "");
    Expect(0, 195101, '\P{Category=letter}', "");
    Expect(1, 195101, '\P{^Category=letter}', "");
    Expect(0, 195102, '\p{Category=letter}', "");
    Expect(1, 195102, '\p{^Category=letter}', "");
    Expect(1, 195102, '\P{Category=letter}', "");
    Expect(0, 195102, '\P{^Category=letter}', "");
    Expect(1, 195101, '\p{Category=:\Aletter\z:}', "");;
    Expect(0, 195102, '\p{Category=:\Aletter\z:}', "");;
    Expect(1, 195101, '\p{Category= -LETTER}', "");
    Expect(0, 195101, '\p{^Category= -LETTER}', "");
    Expect(0, 195101, '\P{Category= -LETTER}', "");
    Expect(1, 195101, '\P{^Category= -LETTER}', "");
    Expect(0, 195102, '\p{Category= -LETTER}', "");
    Expect(1, 195102, '\p{^Category= -LETTER}', "");
    Expect(1, 195102, '\P{Category= -LETTER}', "");
    Expect(0, 195102, '\P{^Category= -LETTER}', "");
    Error('\p{Is_General_Category=_L/a/}');
    Error('\P{Is_General_Category=_L/a/}');
    Expect(1, 195101, '\p{Is_General_Category=l}', "");
    Expect(0, 195101, '\p{^Is_General_Category=l}', "");
    Expect(0, 195101, '\P{Is_General_Category=l}', "");
    Expect(1, 195101, '\P{^Is_General_Category=l}', "");
    Expect(0, 195102, '\p{Is_General_Category=l}', "");
    Expect(1, 195102, '\p{^Is_General_Category=l}', "");
    Expect(1, 195102, '\P{Is_General_Category=l}', "");
    Expect(0, 195102, '\P{^Is_General_Category=l}', "");
    Expect(1, 195101, '\p{Is_General_Category:   	 L}', "");
    Expect(0, 195101, '\p{^Is_General_Category:   	 L}', "");
    Expect(0, 195101, '\P{Is_General_Category:   	 L}', "");
    Expect(1, 195101, '\P{^Is_General_Category:   	 L}', "");
    Expect(0, 195102, '\p{Is_General_Category:   	 L}', "");
    Expect(1, 195102, '\p{^Is_General_Category:   	 L}', "");
    Expect(1, 195102, '\P{Is_General_Category:   	 L}', "");
    Expect(0, 195102, '\P{^Is_General_Category:   	 L}', "");
    Error('\p{Is_Gc=:=- letter}');
    Error('\P{Is_Gc=:=- letter}');
    Expect(1, 195101, '\p{Is_Gc=letter}', "");
    Expect(0, 195101, '\p{^Is_Gc=letter}', "");
    Expect(0, 195101, '\P{Is_Gc=letter}', "");
    Expect(1, 195101, '\P{^Is_Gc=letter}', "");
    Expect(0, 195102, '\p{Is_Gc=letter}', "");
    Expect(1, 195102, '\p{^Is_Gc=letter}', "");
    Expect(1, 195102, '\P{Is_Gc=letter}', "");
    Expect(0, 195102, '\P{^Is_Gc=letter}', "");
    Expect(1, 195101, '\p{Is_Gc=Letter}', "");
    Expect(0, 195101, '\p{^Is_Gc=Letter}', "");
    Expect(0, 195101, '\P{Is_Gc=Letter}', "");
    Expect(1, 195101, '\P{^Is_Gc=Letter}', "");
    Expect(0, 195102, '\p{Is_Gc=Letter}', "");
    Expect(1, 195102, '\p{^Is_Gc=Letter}', "");
    Expect(1, 195102, '\P{Is_Gc=Letter}', "");
    Expect(0, 195102, '\P{^Is_Gc=Letter}', "");
    Error('\p{Is_Category:   -/a/L}');
    Error('\P{Is_Category:   -/a/L}');
    Expect(1, 195101, '\p{Is_Category=l}', "");
    Expect(0, 195101, '\p{^Is_Category=l}', "");
    Expect(0, 195101, '\P{Is_Category=l}', "");
    Expect(1, 195101, '\P{^Is_Category=l}', "");
    Expect(0, 195102, '\p{Is_Category=l}', "");
    Expect(1, 195102, '\p{^Is_Category=l}', "");
    Expect(1, 195102, '\P{Is_Category=l}', "");
    Expect(0, 195102, '\P{^Is_Category=l}', "");
    Expect(1, 195101, '\p{Is_Category= L}', "");
    Expect(0, 195101, '\p{^Is_Category= L}', "");
    Expect(0, 195101, '\P{Is_Category= L}', "");
    Expect(1, 195101, '\P{^Is_Category= L}', "");
    Expect(0, 195102, '\p{Is_Category= L}', "");
    Expect(1, 195102, '\p{^Is_Category= L}', "");
    Expect(1, 195102, '\P{Is_Category= L}', "");
    Expect(0, 195102, '\P{^Is_Category= L}', "");
    Error('\p{General_Category=__Cased_letter:=}');
    Error('\P{General_Category=__Cased_letter:=}');
    Expect(1, 125251, '\p{General_Category=:\ACased_Letter\z:}', "");;
    Expect(0, 125252, '\p{General_Category=:\ACased_Letter\z:}', "");;
    Expect(1, 125251, '\p{General_Category=casedletter}', "");
    Expect(0, 125251, '\p{^General_Category=casedletter}', "");
    Expect(0, 125251, '\P{General_Category=casedletter}', "");
    Expect(1, 125251, '\P{^General_Category=casedletter}', "");
    Expect(0, 125252, '\p{General_Category=casedletter}', "");
    Expect(1, 125252, '\p{^General_Category=casedletter}', "");
    Expect(1, 125252, '\P{General_Category=casedletter}', "");
    Expect(0, 125252, '\P{^General_Category=casedletter}', "");
    Expect(1, 125251, '\p{General_Category=:\Acasedletter\z:}', "");;
    Expect(0, 125252, '\p{General_Category=:\Acasedletter\z:}', "");;
    Expect(1, 125251, '\p{General_Category=_Cased_letter}', "");
    Expect(0, 125251, '\p{^General_Category=_Cased_letter}', "");
    Expect(0, 125251, '\P{General_Category=_Cased_letter}', "");
    Expect(1, 125251, '\P{^General_Category=_Cased_letter}', "");
    Expect(0, 125252, '\p{General_Category=_Cased_letter}', "");
    Expect(1, 125252, '\p{^General_Category=_Cased_letter}', "");
    Expect(1, 125252, '\P{General_Category=_Cased_letter}', "");
    Expect(0, 125252, '\P{^General_Category=_Cased_letter}', "");
    Error('\p{Gc=	 LC/a/}');
    Error('\P{Gc=	 LC/a/}');
    Expect(1, 125251, '\p{Gc=:\ALC\z:}', "");;
    Expect(0, 125252, '\p{Gc=:\ALC\z:}', "");;
    Expect(1, 125251, '\p{Gc:   lc}', "");
    Expect(0, 125251, '\p{^Gc:   lc}', "");
    Expect(0, 125251, '\P{Gc:   lc}', "");
    Expect(1, 125251, '\P{^Gc:   lc}', "");
    Expect(0, 125252, '\p{Gc:   lc}', "");
    Expect(1, 125252, '\p{^Gc:   lc}', "");
    Expect(1, 125252, '\P{Gc:   lc}', "");
    Expect(0, 125252, '\P{^Gc:   lc}', "");
    Expect(1, 125251, '\p{Gc=:\Alc\z:}', "");;
    Expect(0, 125252, '\p{Gc=:\Alc\z:}', "");;
    Expect(1, 125251, '\p{Gc=-	LC}', "");
    Expect(0, 125251, '\p{^Gc=-	LC}', "");
    Expect(0, 125251, '\P{Gc=-	LC}', "");
    Expect(1, 125251, '\P{^Gc=-	LC}', "");
    Expect(0, 125252, '\p{Gc=-	LC}', "");
    Expect(1, 125252, '\p{^Gc=-	LC}', "");
    Expect(1, 125252, '\P{Gc=-	LC}', "");
    Expect(0, 125252, '\P{^Gc=-	LC}', "");
    Error('\p{Category=--L_:=}');
    Error('\P{Category=--L_:=}');
    Expect(1, 125251, '\p{Category=l_}', "");
    Expect(0, 125251, '\p{^Category=l_}', "");
    Expect(0, 125251, '\P{Category=l_}', "");
    Expect(1, 125251, '\P{^Category=l_}', "");
    Expect(0, 125252, '\p{Category=l_}', "");
    Expect(1, 125252, '\p{^Category=l_}', "");
    Expect(1, 125252, '\P{Category=l_}', "");
    Expect(0, 125252, '\P{^Category=l_}', "");
    Expect(1, 125251, '\p{Category= _L_}', "");
    Expect(0, 125251, '\p{^Category= _L_}', "");
    Expect(0, 125251, '\P{Category= _L_}', "");
    Expect(1, 125251, '\P{^Category= _L_}', "");
    Expect(0, 125252, '\p{Category= _L_}', "");
    Expect(1, 125252, '\p{^Category= _L_}', "");
    Expect(1, 125252, '\P{Category= _L_}', "");
    Expect(0, 125252, '\P{^Category= _L_}', "");
    Error('\p{Is_General_Category=:=_ L&}');
    Error('\P{Is_General_Category=:=_ L&}');
    Expect(1, 125251, '\p{Is_General_Category:l&}', "");
    Expect(0, 125251, '\p{^Is_General_Category:l&}', "");
    Expect(0, 125251, '\P{Is_General_Category:l&}', "");
    Expect(1, 125251, '\P{^Is_General_Category:l&}', "");
    Expect(0, 125252, '\p{Is_General_Category:l&}', "");
    Expect(1, 125252, '\p{^Is_General_Category:l&}', "");
    Expect(1, 125252, '\P{Is_General_Category:l&}', "");
    Expect(0, 125252, '\P{^Is_General_Category:l&}', "");
    Expect(1, 125251, '\p{Is_General_Category= L&}', "");
    Expect(0, 125251, '\p{^Is_General_Category= L&}', "");
    Expect(0, 125251, '\P{Is_General_Category= L&}', "");
    Expect(1, 125251, '\P{^Is_General_Category= L&}', "");
    Expect(0, 125252, '\p{Is_General_Category= L&}', "");
    Expect(1, 125252, '\p{^Is_General_Category= L&}', "");
    Expect(1, 125252, '\P{Is_General_Category= L&}', "");
    Expect(0, 125252, '\P{^Is_General_Category= L&}', "");
    Error('\p{Is_Gc=/a/	Cased_letter}');
    Error('\P{Is_Gc=/a/	Cased_letter}');
    Expect(1, 125251, '\p{Is_Gc:   casedletter}', "");
    Expect(0, 125251, '\p{^Is_Gc:   casedletter}', "");
    Expect(0, 125251, '\P{Is_Gc:   casedletter}', "");
    Expect(1, 125251, '\P{^Is_Gc:   casedletter}', "");
    Expect(0, 125252, '\p{Is_Gc:   casedletter}', "");
    Expect(1, 125252, '\p{^Is_Gc:   casedletter}', "");
    Expect(1, 125252, '\P{Is_Gc:   casedletter}', "");
    Expect(0, 125252, '\P{^Is_Gc:   casedletter}', "");
    Expect(1, 125251, '\p{Is_Gc= -Cased_Letter}', "");
    Expect(0, 125251, '\p{^Is_Gc= -Cased_Letter}', "");
    Expect(0, 125251, '\P{Is_Gc= -Cased_Letter}', "");
    Expect(1, 125251, '\P{^Is_Gc= -Cased_Letter}', "");
    Expect(0, 125252, '\p{Is_Gc= -Cased_Letter}', "");
    Expect(1, 125252, '\p{^Is_Gc= -Cased_Letter}', "");
    Expect(1, 125252, '\P{Is_Gc= -Cased_Letter}', "");
    Expect(0, 125252, '\P{^Is_Gc= -Cased_Letter}', "");
    Error('\p{Is_Category=:=-LC}');
    Error('\P{Is_Category=:=-LC}');
    Expect(1, 125251, '\p{Is_Category=lc}', "");
    Expect(0, 125251, '\p{^Is_Category=lc}', "");
    Expect(0, 125251, '\P{Is_Category=lc}', "");
    Expect(1, 125251, '\P{^Is_Category=lc}', "");
    Expect(0, 125252, '\p{Is_Category=lc}', "");
    Expect(1, 125252, '\p{^Is_Category=lc}', "");
    Expect(1, 125252, '\P{Is_Category=lc}', "");
    Expect(0, 125252, '\P{^Is_Category=lc}', "");
    Expect(1, 125251, '\p{Is_Category=	LC}', "");
    Expect(0, 125251, '\p{^Is_Category=	LC}', "");
    Expect(0, 125251, '\P{Is_Category=	LC}', "");
    Expect(1, 125251, '\P{^Is_Category=	LC}', "");
    Expect(0, 125252, '\p{Is_Category=	LC}', "");
    Expect(1, 125252, '\p{^Is_Category=	LC}', "");
    Expect(1, 125252, '\P{Is_Category=	LC}', "");
    Expect(0, 125252, '\P{^Is_Category=	LC}', "");
    Error('\p{General_Category=-/a/LOWERCASE_letter}');
    Error('\P{General_Category=-/a/LOWERCASE_letter}');
    Expect(1, 125251, '\p{General_Category=:\ALowercase_Letter\z:}', "");;
    Expect(0, 125252, '\p{General_Category=:\ALowercase_Letter\z:}', "");;
    Expect(1, 125251, '\p{General_Category: lowercaseletter}', "");
    Expect(0, 125251, '\p{^General_Category: lowercaseletter}', "");
    Expect(0, 125251, '\P{General_Category: lowercaseletter}', "");
    Expect(1, 125251, '\P{^General_Category: lowercaseletter}', "");
    Expect(0, 125252, '\p{General_Category: lowercaseletter}', "");
    Expect(1, 125252, '\p{^General_Category: lowercaseletter}', "");
    Expect(1, 125252, '\P{General_Category: lowercaseletter}', "");
    Expect(0, 125252, '\P{^General_Category: lowercaseletter}', "");
    Expect(1, 125251, '\p{General_Category=:\Alowercaseletter\z:}', "");;
    Expect(0, 125252, '\p{General_Category=:\Alowercaseletter\z:}', "");;
    Expect(1, 125251, '\p{General_Category=-Lowercase_Letter}', "");
    Expect(0, 125251, '\p{^General_Category=-Lowercase_Letter}', "");
    Expect(0, 125251, '\P{General_Category=-Lowercase_Letter}', "");
    Expect(1, 125251, '\P{^General_Category=-Lowercase_Letter}', "");
    Expect(0, 125252, '\p{General_Category=-Lowercase_Letter}', "");
    Expect(1, 125252, '\p{^General_Category=-Lowercase_Letter}', "");
    Expect(1, 125252, '\P{General_Category=-Lowercase_Letter}', "");
    Expect(0, 125252, '\P{^General_Category=-Lowercase_Letter}', "");
    Error('\p{Gc=:= _Ll}');
    Error('\P{Gc=:= _Ll}');
    Expect(1, 125251, '\p{Gc=:\ALl\z:}', "");;
    Expect(0, 125252, '\p{Gc=:\ALl\z:}', "");;
    Expect(1, 125251, '\p{Gc=ll}', "");
    Expect(0, 125251, '\p{^Gc=ll}', "");
    Expect(0, 125251, '\P{Gc=ll}', "");
    Expect(1, 125251, '\P{^Gc=ll}', "");
    Expect(0, 125252, '\p{Gc=ll}', "");
    Expect(1, 125252, '\p{^Gc=ll}', "");
    Expect(1, 125252, '\P{Gc=ll}', "");
    Expect(0, 125252, '\P{^Gc=ll}', "");
    Expect(1, 125251, '\p{Gc=:\All\z:}', "");;
    Expect(0, 125252, '\p{Gc=:\All\z:}', "");;
    Expect(1, 125251, '\p{Gc: _Ll}', "");
    Expect(0, 125251, '\p{^Gc: _Ll}', "");
    Expect(0, 125251, '\P{Gc: _Ll}', "");
    Expect(1, 125251, '\P{^Gc: _Ll}', "");
    Expect(0, 125252, '\p{Gc: _Ll}', "");
    Expect(1, 125252, '\p{^Gc: _Ll}', "");
    Expect(1, 125252, '\P{Gc: _Ll}', "");
    Expect(0, 125252, '\P{^Gc: _Ll}', "");
    Error('\p{Category=- LOWERCASE_Letter/a/}');
    Error('\P{Category=- LOWERCASE_Letter/a/}');
    Expect(1, 125251, '\p{Category=:\ALowercase_Letter\z:}', "");;
    Expect(0, 125252, '\p{Category=:\ALowercase_Letter\z:}', "");;
    Expect(1, 125251, '\p{Category=lowercaseletter}', "");
    Expect(0, 125251, '\p{^Category=lowercaseletter}', "");
    Expect(0, 125251, '\P{Category=lowercaseletter}', "");
    Expect(1, 125251, '\P{^Category=lowercaseletter}', "");
    Expect(0, 125252, '\p{Category=lowercaseletter}', "");
    Expect(1, 125252, '\p{^Category=lowercaseletter}', "");
    Expect(1, 125252, '\P{Category=lowercaseletter}', "");
    Expect(0, 125252, '\P{^Category=lowercaseletter}', "");
    Expect(1, 125251, '\p{Category=:\Alowercaseletter\z:}', "");;
    Expect(0, 125252, '\p{Category=:\Alowercaseletter\z:}', "");;
    Expect(1, 125251, '\p{Category=_ Lowercase_Letter}', "");
    Expect(0, 125251, '\p{^Category=_ Lowercase_Letter}', "");
    Expect(0, 125251, '\P{Category=_ Lowercase_Letter}', "");
    Expect(1, 125251, '\P{^Category=_ Lowercase_Letter}', "");
    Expect(0, 125252, '\p{Category=_ Lowercase_Letter}', "");
    Expect(1, 125252, '\p{^Category=_ Lowercase_Letter}', "");
    Expect(1, 125252, '\P{Category=_ Lowercase_Letter}', "");
    Expect(0, 125252, '\P{^Category=_ Lowercase_Letter}', "");
    Error('\p{Is_General_Category=:=_	LL}');
    Error('\P{Is_General_Category=:=_	LL}');
    Expect(1, 125251, '\p{Is_General_Category=ll}', "");
    Expect(0, 125251, '\p{^Is_General_Category=ll}', "");
    Expect(0, 125251, '\P{Is_General_Category=ll}', "");
    Expect(1, 125251, '\P{^Is_General_Category=ll}', "");
    Expect(0, 125252, '\p{Is_General_Category=ll}', "");
    Expect(1, 125252, '\p{^Is_General_Category=ll}', "");
    Expect(1, 125252, '\P{Is_General_Category=ll}', "");
    Expect(0, 125252, '\P{^Is_General_Category=ll}', "");
    Expect(1, 125251, '\p{Is_General_Category=_	Ll}', "");
    Expect(0, 125251, '\p{^Is_General_Category=_	Ll}', "");
    Expect(0, 125251, '\P{Is_General_Category=_	Ll}', "");
    Expect(1, 125251, '\P{^Is_General_Category=_	Ll}', "");
    Expect(0, 125252, '\p{Is_General_Category=_	Ll}', "");
    Expect(1, 125252, '\p{^Is_General_Category=_	Ll}', "");
    Expect(1, 125252, '\P{Is_General_Category=_	Ll}', "");
    Expect(0, 125252, '\P{^Is_General_Category=_	Ll}', "");
    Error('\p{Is_Gc:   -_LOWERCASE_Letter:=}');
    Error('\P{Is_Gc:   -_LOWERCASE_Letter:=}');
    Expect(1, 125251, '\p{Is_Gc:lowercaseletter}', "");
    Expect(0, 125251, '\p{^Is_Gc:lowercaseletter}', "");
    Expect(0, 125251, '\P{Is_Gc:lowercaseletter}', "");
    Expect(1, 125251, '\P{^Is_Gc:lowercaseletter}', "");
    Expect(0, 125252, '\p{Is_Gc:lowercaseletter}', "");
    Expect(1, 125252, '\p{^Is_Gc:lowercaseletter}', "");
    Expect(1, 125252, '\P{Is_Gc:lowercaseletter}', "");
    Expect(0, 125252, '\P{^Is_Gc:lowercaseletter}', "");
    Expect(1, 125251, '\p{Is_Gc=		LOWERCASE_LETTER}', "");
    Expect(0, 125251, '\p{^Is_Gc=		LOWERCASE_LETTER}', "");
    Expect(0, 125251, '\P{Is_Gc=		LOWERCASE_LETTER}', "");
    Expect(1, 125251, '\P{^Is_Gc=		LOWERCASE_LETTER}', "");
    Expect(0, 125252, '\p{Is_Gc=		LOWERCASE_LETTER}', "");
    Expect(1, 125252, '\p{^Is_Gc=		LOWERCASE_LETTER}', "");
    Expect(1, 125252, '\P{Is_Gc=		LOWERCASE_LETTER}', "");
    Expect(0, 125252, '\P{^Is_Gc=		LOWERCASE_LETTER}', "");
    Error('\p{Is_Category=_:=Ll}');
    Error('\P{Is_Category=_:=Ll}');
    Expect(1, 125251, '\p{Is_Category=ll}', "");
    Expect(0, 125251, '\p{^Is_Category=ll}', "");
    Expect(0, 125251, '\P{Is_Category=ll}', "");
    Expect(1, 125251, '\P{^Is_Category=ll}', "");
    Expect(0, 125252, '\p{Is_Category=ll}', "");
    Expect(1, 125252, '\p{^Is_Category=ll}', "");
    Expect(1, 125252, '\P{Is_Category=ll}', "");
    Expect(0, 125252, '\P{^Is_Category=ll}', "");
    Expect(1, 125251, '\p{Is_Category= LL}', "");
    Expect(0, 125251, '\p{^Is_Category= LL}', "");
    Expect(0, 125251, '\P{Is_Category= LL}', "");
    Expect(1, 125251, '\P{^Is_Category= LL}', "");
    Expect(0, 125252, '\p{Is_Category= LL}', "");
    Expect(1, 125252, '\p{^Is_Category= LL}', "");
    Expect(1, 125252, '\P{Is_Category= LL}', "");
    Expect(0, 125252, '\P{^Is_Category= LL}', "");
    Error('\p{General_Category=/a/ -modifier_Letter}');
    Error('\P{General_Category=/a/ -modifier_Letter}');
    Expect(1, 125259, '\p{General_Category=:\AModifier_Letter\z:}', "");;
    Expect(0, 125260, '\p{General_Category=:\AModifier_Letter\z:}', "");;
    Expect(1, 125259, '\p{General_Category=modifierletter}', "");
    Expect(0, 125259, '\p{^General_Category=modifierletter}', "");
    Expect(0, 125259, '\P{General_Category=modifierletter}', "");
    Expect(1, 125259, '\P{^General_Category=modifierletter}', "");
    Expect(0, 125260, '\p{General_Category=modifierletter}', "");
    Expect(1, 125260, '\p{^General_Category=modifierletter}', "");
    Expect(1, 125260, '\P{General_Category=modifierletter}', "");
    Expect(0, 125260, '\P{^General_Category=modifierletter}', "");
    Expect(1, 125259, '\p{General_Category=:\Amodifierletter\z:}', "");;
    Expect(0, 125260, '\p{General_Category=:\Amodifierletter\z:}', "");;
    Expect(1, 125259, '\p{General_Category=	_MODIFIER_Letter}', "");
    Expect(0, 125259, '\p{^General_Category=	_MODIFIER_Letter}', "");
    Expect(0, 125259, '\P{General_Category=	_MODIFIER_Letter}', "");
    Expect(1, 125259, '\P{^General_Category=	_MODIFIER_Letter}', "");
    Expect(0, 125260, '\p{General_Category=	_MODIFIER_Letter}', "");
    Expect(1, 125260, '\p{^General_Category=	_MODIFIER_Letter}', "");
    Expect(1, 125260, '\P{General_Category=	_MODIFIER_Letter}', "");
    Expect(0, 125260, '\P{^General_Category=	_MODIFIER_Letter}', "");
    Error('\p{Gc=/a/- lm}');
    Error('\P{Gc=/a/- lm}');
    Expect(1, 125259, '\p{Gc=:\ALm\z:}', "");;
    Expect(0, 125260, '\p{Gc=:\ALm\z:}', "");;
    Expect(1, 125259, '\p{Gc=lm}', "");
    Expect(0, 125259, '\p{^Gc=lm}', "");
    Expect(0, 125259, '\P{Gc=lm}', "");
    Expect(1, 125259, '\P{^Gc=lm}', "");
    Expect(0, 125260, '\p{Gc=lm}', "");
    Expect(1, 125260, '\p{^Gc=lm}', "");
    Expect(1, 125260, '\P{Gc=lm}', "");
    Expect(0, 125260, '\P{^Gc=lm}', "");
    Expect(1, 125259, '\p{Gc=:\Alm\z:}', "");;
    Expect(0, 125260, '\p{Gc=:\Alm\z:}', "");;
    Expect(1, 125259, '\p{Gc: __LM}', "");
    Expect(0, 125259, '\p{^Gc: __LM}', "");
    Expect(0, 125259, '\P{Gc: __LM}', "");
    Expect(1, 125259, '\P{^Gc: __LM}', "");
    Expect(0, 125260, '\p{Gc: __LM}', "");
    Expect(1, 125260, '\p{^Gc: __LM}', "");
    Expect(1, 125260, '\P{Gc: __LM}', "");
    Expect(0, 125260, '\P{^Gc: __LM}', "");
    Error('\p{Category: /a/_MODIFIER_letter}');
    Error('\P{Category: /a/_MODIFIER_letter}');
    Expect(1, 125259, '\p{Category=:\AModifier_Letter\z:}', "");;
    Expect(0, 125260, '\p{Category=:\AModifier_Letter\z:}', "");;
    Expect(1, 125259, '\p{Category=modifierletter}', "");
    Expect(0, 125259, '\p{^Category=modifierletter}', "");
    Expect(0, 125259, '\P{Category=modifierletter}', "");
    Expect(1, 125259, '\P{^Category=modifierletter}', "");
    Expect(0, 125260, '\p{Category=modifierletter}', "");
    Expect(1, 125260, '\p{^Category=modifierletter}', "");
    Expect(1, 125260, '\P{Category=modifierletter}', "");
    Expect(0, 125260, '\P{^Category=modifierletter}', "");
    Expect(1, 125259, '\p{Category=:\Amodifierletter\z:}', "");;
    Expect(0, 125260, '\p{Category=:\Amodifierletter\z:}', "");;
    Expect(1, 125259, '\p{Category:	_modifier_Letter}', "");
    Expect(0, 125259, '\p{^Category:	_modifier_Letter}', "");
    Expect(0, 125259, '\P{Category:	_modifier_Letter}', "");
    Expect(1, 125259, '\P{^Category:	_modifier_Letter}', "");
    Expect(0, 125260, '\p{Category:	_modifier_Letter}', "");
    Expect(1, 125260, '\p{^Category:	_modifier_Letter}', "");
    Expect(1, 125260, '\P{Category:	_modifier_Letter}', "");
    Expect(0, 125260, '\P{^Category:	_modifier_Letter}', "");
    Error('\p{Is_General_Category= Lm:=}');
    Error('\P{Is_General_Category= Lm:=}');
    Expect(1, 125259, '\p{Is_General_Category=lm}', "");
    Expect(0, 125259, '\p{^Is_General_Category=lm}', "");
    Expect(0, 125259, '\P{Is_General_Category=lm}', "");
    Expect(1, 125259, '\P{^Is_General_Category=lm}', "");
    Expect(0, 125260, '\p{Is_General_Category=lm}', "");
    Expect(1, 125260, '\p{^Is_General_Category=lm}', "");
    Expect(1, 125260, '\P{Is_General_Category=lm}', "");
    Expect(0, 125260, '\P{^Is_General_Category=lm}', "");
    Expect(1, 125259, '\p{Is_General_Category=	lm}', "");
    Expect(0, 125259, '\p{^Is_General_Category=	lm}', "");
    Expect(0, 125259, '\P{Is_General_Category=	lm}', "");
    Expect(1, 125259, '\P{^Is_General_Category=	lm}', "");
    Expect(0, 125260, '\p{Is_General_Category=	lm}', "");
    Expect(1, 125260, '\p{^Is_General_Category=	lm}', "");
    Expect(1, 125260, '\P{Is_General_Category=	lm}', "");
    Expect(0, 125260, '\P{^Is_General_Category=	lm}', "");
    Error('\p{Is_Gc:	_ MODIFIER_LETTER/a/}');
    Error('\P{Is_Gc:	_ MODIFIER_LETTER/a/}');
    Expect(1, 125259, '\p{Is_Gc=modifierletter}', "");
    Expect(0, 125259, '\p{^Is_Gc=modifierletter}', "");
    Expect(0, 125259, '\P{Is_Gc=modifierletter}', "");
    Expect(1, 125259, '\P{^Is_Gc=modifierletter}', "");
    Expect(0, 125260, '\p{Is_Gc=modifierletter}', "");
    Expect(1, 125260, '\p{^Is_Gc=modifierletter}', "");
    Expect(1, 125260, '\P{Is_Gc=modifierletter}', "");
    Expect(0, 125260, '\P{^Is_Gc=modifierletter}', "");
    Expect(1, 125259, '\p{Is_Gc=__Modifier_Letter}', "");
    Expect(0, 125259, '\p{^Is_Gc=__Modifier_Letter}', "");
    Expect(0, 125259, '\P{Is_Gc=__Modifier_Letter}', "");
    Expect(1, 125259, '\P{^Is_Gc=__Modifier_Letter}', "");
    Expect(0, 125260, '\p{Is_Gc=__Modifier_Letter}', "");
    Expect(1, 125260, '\p{^Is_Gc=__Modifier_Letter}', "");
    Expect(1, 125260, '\P{Is_Gc=__Modifier_Letter}', "");
    Expect(0, 125260, '\P{^Is_Gc=__Modifier_Letter}', "");
    Error('\p{Is_Category=	:=LM}');
    Error('\P{Is_Category=	:=LM}');
    Expect(1, 125259, '\p{Is_Category=lm}', "");
    Expect(0, 125259, '\p{^Is_Category=lm}', "");
    Expect(0, 125259, '\P{Is_Category=lm}', "");
    Expect(1, 125259, '\P{^Is_Category=lm}', "");
    Expect(0, 125260, '\p{Is_Category=lm}', "");
    Expect(1, 125260, '\p{^Is_Category=lm}', "");
    Expect(1, 125260, '\P{Is_Category=lm}', "");
    Expect(0, 125260, '\P{^Is_Category=lm}', "");
    Expect(1, 125259, '\p{Is_Category=-Lm}', "");
    Expect(0, 125259, '\p{^Is_Category=-Lm}', "");
    Expect(0, 125259, '\P{Is_Category=-Lm}', "");
    Expect(1, 125259, '\P{^Is_Category=-Lm}', "");
    Expect(0, 125260, '\p{Is_Category=-Lm}', "");
    Expect(1, 125260, '\p{^Is_Category=-Lm}', "");
    Expect(1, 125260, '\P{Is_Category=-Lm}', "");
    Expect(0, 125260, '\P{^Is_Category=-Lm}', "");
    Error('\p{General_Category=:= -other_Letter}');
    Error('\P{General_Category=:= -other_Letter}');
    Expect(1, 195101, '\p{General_Category=:\AOther_Letter\z:}', "");;
    Expect(0, 195102, '\p{General_Category=:\AOther_Letter\z:}', "");;
    Expect(1, 195101, '\p{General_Category: otherletter}', "");
    Expect(0, 195101, '\p{^General_Category: otherletter}', "");
    Expect(0, 195101, '\P{General_Category: otherletter}', "");
    Expect(1, 195101, '\P{^General_Category: otherletter}', "");
    Expect(0, 195102, '\p{General_Category: otherletter}', "");
    Expect(1, 195102, '\p{^General_Category: otherletter}', "");
    Expect(1, 195102, '\P{General_Category: otherletter}', "");
    Expect(0, 195102, '\P{^General_Category: otherletter}', "");
    Expect(1, 195101, '\p{General_Category=:\Aotherletter\z:}', "");;
    Expect(0, 195102, '\p{General_Category=:\Aotherletter\z:}', "");;
    Expect(1, 195101, '\p{General_Category= OTHER_Letter}', "");
    Expect(0, 195101, '\p{^General_Category= OTHER_Letter}', "");
    Expect(0, 195101, '\P{General_Category= OTHER_Letter}', "");
    Expect(1, 195101, '\P{^General_Category= OTHER_Letter}', "");
    Expect(0, 195102, '\p{General_Category= OTHER_Letter}', "");
    Expect(1, 195102, '\p{^General_Category= OTHER_Letter}', "");
    Expect(1, 195102, '\P{General_Category= OTHER_Letter}', "");
    Expect(0, 195102, '\P{^General_Category= OTHER_Letter}', "");
    Error('\p{Gc=/a/_lo}');
    Error('\P{Gc=/a/_lo}');
    Expect(1, 195101, '\p{Gc=:\ALo\z:}', "");;
    Expect(0, 195102, '\p{Gc=:\ALo\z:}', "");;
    Expect(1, 195101, '\p{Gc=lo}', "");
    Expect(0, 195101, '\p{^Gc=lo}', "");
    Expect(0, 195101, '\P{Gc=lo}', "");
    Expect(1, 195101, '\P{^Gc=lo}', "");
    Expect(0, 195102, '\p{Gc=lo}', "");
    Expect(1, 195102, '\p{^Gc=lo}', "");
    Expect(1, 195102, '\P{Gc=lo}', "");
    Expect(0, 195102, '\P{^Gc=lo}', "");
    Expect(1, 195101, '\p{Gc=:\Alo\z:}', "");;
    Expect(0, 195102, '\p{Gc=:\Alo\z:}', "");;
    Expect(1, 195101, '\p{Gc=	Lo}', "");
    Expect(0, 195101, '\p{^Gc=	Lo}', "");
    Expect(0, 195101, '\P{Gc=	Lo}', "");
    Expect(1, 195101, '\P{^Gc=	Lo}', "");
    Expect(0, 195102, '\p{Gc=	Lo}', "");
    Expect(1, 195102, '\p{^Gc=	Lo}', "");
    Expect(1, 195102, '\P{Gc=	Lo}', "");
    Expect(0, 195102, '\P{^Gc=	Lo}', "");
    Error('\p{Category=_:=Other_Letter}');
    Error('\P{Category=_:=Other_Letter}');
    Expect(1, 195101, '\p{Category=:\AOther_Letter\z:}', "");;
    Expect(0, 195102, '\p{Category=:\AOther_Letter\z:}', "");;
    Expect(1, 195101, '\p{Category=otherletter}', "");
    Expect(0, 195101, '\p{^Category=otherletter}', "");
    Expect(0, 195101, '\P{Category=otherletter}', "");
    Expect(1, 195101, '\P{^Category=otherletter}', "");
    Expect(0, 195102, '\p{Category=otherletter}', "");
    Expect(1, 195102, '\p{^Category=otherletter}', "");
    Expect(1, 195102, '\P{Category=otherletter}', "");
    Expect(0, 195102, '\P{^Category=otherletter}', "");
    Expect(1, 195101, '\p{Category=:\Aotherletter\z:}', "");;
    Expect(0, 195102, '\p{Category=:\Aotherletter\z:}', "");;
    Expect(1, 195101, '\p{Category= other_LETTER}', "");
    Expect(0, 195101, '\p{^Category= other_LETTER}', "");
    Expect(0, 195101, '\P{Category= other_LETTER}', "");
    Expect(1, 195101, '\P{^Category= other_LETTER}', "");
    Expect(0, 195102, '\p{Category= other_LETTER}', "");
    Expect(1, 195102, '\p{^Category= other_LETTER}', "");
    Expect(1, 195102, '\P{Category= other_LETTER}', "");
    Expect(0, 195102, '\P{^Category= other_LETTER}', "");
    Error('\p{Is_General_Category=	/a/Lo}');
    Error('\P{Is_General_Category=	/a/Lo}');
    Expect(1, 195101, '\p{Is_General_Category=lo}', "");
    Expect(0, 195101, '\p{^Is_General_Category=lo}', "");
    Expect(0, 195101, '\P{Is_General_Category=lo}', "");
    Expect(1, 195101, '\P{^Is_General_Category=lo}', "");
    Expect(0, 195102, '\p{Is_General_Category=lo}', "");
    Expect(1, 195102, '\p{^Is_General_Category=lo}', "");
    Expect(1, 195102, '\P{Is_General_Category=lo}', "");
    Expect(0, 195102, '\P{^Is_General_Category=lo}', "");
    Expect(1, 195101, '\p{Is_General_Category=_LO}', "");
    Expect(0, 195101, '\p{^Is_General_Category=_LO}', "");
    Expect(0, 195101, '\P{Is_General_Category=_LO}', "");
    Expect(1, 195101, '\P{^Is_General_Category=_LO}', "");
    Expect(0, 195102, '\p{Is_General_Category=_LO}', "");
    Expect(1, 195102, '\p{^Is_General_Category=_LO}', "");
    Expect(1, 195102, '\P{Is_General_Category=_LO}', "");
    Expect(0, 195102, '\P{^Is_General_Category=_LO}', "");
    Error('\p{Is_Gc=/a/OTHER_Letter}');
    Error('\P{Is_Gc=/a/OTHER_Letter}');
    Expect(1, 195101, '\p{Is_Gc=otherletter}', "");
    Expect(0, 195101, '\p{^Is_Gc=otherletter}', "");
    Expect(0, 195101, '\P{Is_Gc=otherletter}', "");
    Expect(1, 195101, '\P{^Is_Gc=otherletter}', "");
    Expect(0, 195102, '\p{Is_Gc=otherletter}', "");
    Expect(1, 195102, '\p{^Is_Gc=otherletter}', "");
    Expect(1, 195102, '\P{Is_Gc=otherletter}', "");
    Expect(0, 195102, '\P{^Is_Gc=otherletter}', "");
    Expect(1, 195101, '\p{Is_Gc=-OTHER_LETTER}', "");
    Expect(0, 195101, '\p{^Is_Gc=-OTHER_LETTER}', "");
    Expect(0, 195101, '\P{Is_Gc=-OTHER_LETTER}', "");
    Expect(1, 195101, '\P{^Is_Gc=-OTHER_LETTER}', "");
    Expect(0, 195102, '\p{Is_Gc=-OTHER_LETTER}', "");
    Expect(1, 195102, '\p{^Is_Gc=-OTHER_LETTER}', "");
    Expect(1, 195102, '\P{Is_Gc=-OTHER_LETTER}', "");
    Expect(0, 195102, '\P{^Is_Gc=-OTHER_LETTER}', "");
    Error('\p{Is_Category= 	Lo/a/}');
    Error('\P{Is_Category= 	Lo/a/}');
    Expect(1, 195101, '\p{Is_Category=lo}', "");
    Expect(0, 195101, '\p{^Is_Category=lo}', "");
    Expect(0, 195101, '\P{Is_Category=lo}', "");
    Expect(1, 195101, '\P{^Is_Category=lo}', "");
    Expect(0, 195102, '\p{Is_Category=lo}', "");
    Expect(1, 195102, '\p{^Is_Category=lo}', "");
    Expect(1, 195102, '\P{Is_Category=lo}', "");
    Expect(0, 195102, '\P{^Is_Category=lo}', "");
    Expect(1, 195101, '\p{Is_Category=  lo}', "");
    Expect(0, 195101, '\p{^Is_Category=  lo}', "");
    Expect(0, 195101, '\P{Is_Category=  lo}', "");
    Expect(1, 195101, '\P{^Is_Category=  lo}', "");
    Expect(0, 195102, '\p{Is_Category=  lo}', "");
    Expect(1, 195102, '\p{^Is_Category=  lo}', "");
    Expect(1, 195102, '\P{Is_Category=  lo}', "");
    Expect(0, 195102, '\P{^Is_Category=  lo}', "");
    Error('\p{General_Category=--Titlecase_letter:=}');
    Error('\P{General_Category=--Titlecase_letter:=}');
    Expect(1, 8188, '\p{General_Category=:\ATitlecase_Letter\z:}', "");;
    Expect(0, 8189, '\p{General_Category=:\ATitlecase_Letter\z:}', "");;
    Expect(1, 8188, '\p{General_Category=titlecaseletter}', "");
    Expect(0, 8188, '\p{^General_Category=titlecaseletter}', "");
    Expect(0, 8188, '\P{General_Category=titlecaseletter}', "");
    Expect(1, 8188, '\P{^General_Category=titlecaseletter}', "");
    Expect(0, 8189, '\p{General_Category=titlecaseletter}', "");
    Expect(1, 8189, '\p{^General_Category=titlecaseletter}', "");
    Expect(1, 8189, '\P{General_Category=titlecaseletter}', "");
    Expect(0, 8189, '\P{^General_Category=titlecaseletter}', "");
    Expect(1, 8188, '\p{General_Category=:\Atitlecaseletter\z:}', "");;
    Expect(0, 8189, '\p{General_Category=:\Atitlecaseletter\z:}', "");;
    Expect(1, 8188, '\p{General_Category:Titlecase_Letter}', "");
    Expect(0, 8188, '\p{^General_Category:Titlecase_Letter}', "");
    Expect(0, 8188, '\P{General_Category:Titlecase_Letter}', "");
    Expect(1, 8188, '\P{^General_Category:Titlecase_Letter}', "");
    Expect(0, 8189, '\p{General_Category:Titlecase_Letter}', "");
    Expect(1, 8189, '\p{^General_Category:Titlecase_Letter}', "");
    Expect(1, 8189, '\P{General_Category:Titlecase_Letter}', "");
    Expect(0, 8189, '\P{^General_Category:Titlecase_Letter}', "");
    Error('\p{Gc=_-lt/a/}');
    Error('\P{Gc=_-lt/a/}');
    Expect(1, 8188, '\p{Gc=:\ALt\z:}', "");;
    Expect(0, 8189, '\p{Gc=:\ALt\z:}', "");;
    Expect(1, 8188, '\p{Gc=lt}', "");
    Expect(0, 8188, '\p{^Gc=lt}', "");
    Expect(0, 8188, '\P{Gc=lt}', "");
    Expect(1, 8188, '\P{^Gc=lt}', "");
    Expect(0, 8189, '\p{Gc=lt}', "");
    Expect(1, 8189, '\p{^Gc=lt}', "");
    Expect(1, 8189, '\P{Gc=lt}', "");
    Expect(0, 8189, '\P{^Gc=lt}', "");
    Expect(1, 8188, '\p{Gc=:\Alt\z:}', "");;
    Expect(0, 8189, '\p{Gc=:\Alt\z:}', "");;
    Expect(1, 8188, '\p{Gc:	  lt}', "");
    Expect(0, 8188, '\p{^Gc:	  lt}', "");
    Expect(0, 8188, '\P{Gc:	  lt}', "");
    Expect(1, 8188, '\P{^Gc:	  lt}', "");
    Expect(0, 8189, '\p{Gc:	  lt}', "");
    Expect(1, 8189, '\p{^Gc:	  lt}', "");
    Expect(1, 8189, '\P{Gc:	  lt}', "");
    Expect(0, 8189, '\P{^Gc:	  lt}', "");
    Error('\p{Category=/a/TITLECASE_Letter}');
    Error('\P{Category=/a/TITLECASE_Letter}');
    Expect(1, 8188, '\p{Category=:\ATitlecase_Letter\z:}', "");;
    Expect(0, 8189, '\p{Category=:\ATitlecase_Letter\z:}', "");;
    Expect(1, 8188, '\p{Category=titlecaseletter}', "");
    Expect(0, 8188, '\p{^Category=titlecaseletter}', "");
    Expect(0, 8188, '\P{Category=titlecaseletter}', "");
    Expect(1, 8188, '\P{^Category=titlecaseletter}', "");
    Expect(0, 8189, '\p{Category=titlecaseletter}', "");
    Expect(1, 8189, '\p{^Category=titlecaseletter}', "");
    Expect(1, 8189, '\P{Category=titlecaseletter}', "");
    Expect(0, 8189, '\P{^Category=titlecaseletter}', "");
    Expect(1, 8188, '\p{Category=:\Atitlecaseletter\z:}', "");;
    Expect(0, 8189, '\p{Category=:\Atitlecaseletter\z:}', "");;
    Expect(1, 8188, '\p{Category:__Titlecase_Letter}', "");
    Expect(0, 8188, '\p{^Category:__Titlecase_Letter}', "");
    Expect(0, 8188, '\P{Category:__Titlecase_Letter}', "");
    Expect(1, 8188, '\P{^Category:__Titlecase_Letter}', "");
    Expect(0, 8189, '\p{Category:__Titlecase_Letter}', "");
    Expect(1, 8189, '\p{^Category:__Titlecase_Letter}', "");
    Expect(1, 8189, '\P{Category:__Titlecase_Letter}', "");
    Expect(0, 8189, '\P{^Category:__Titlecase_Letter}', "");
    Error('\p{Is_General_Category=/a/-_lt}');
    Error('\P{Is_General_Category=/a/-_lt}');
    Expect(1, 8188, '\p{Is_General_Category=lt}', "");
    Expect(0, 8188, '\p{^Is_General_Category=lt}', "");
    Expect(0, 8188, '\P{Is_General_Category=lt}', "");
    Expect(1, 8188, '\P{^Is_General_Category=lt}', "");
    Expect(0, 8189, '\p{Is_General_Category=lt}', "");
    Expect(1, 8189, '\p{^Is_General_Category=lt}', "");
    Expect(1, 8189, '\P{Is_General_Category=lt}', "");
    Expect(0, 8189, '\P{^Is_General_Category=lt}', "");
    Expect(1, 8188, '\p{Is_General_Category=--lt}', "");
    Expect(0, 8188, '\p{^Is_General_Category=--lt}', "");
    Expect(0, 8188, '\P{Is_General_Category=--lt}', "");
    Expect(1, 8188, '\P{^Is_General_Category=--lt}', "");
    Expect(0, 8189, '\p{Is_General_Category=--lt}', "");
    Expect(1, 8189, '\p{^Is_General_Category=--lt}', "");
    Expect(1, 8189, '\P{Is_General_Category=--lt}', "");
    Expect(0, 8189, '\P{^Is_General_Category=--lt}', "");
    Error('\p{Is_Gc=- Titlecase_letter:=}');
    Error('\P{Is_Gc=- Titlecase_letter:=}');
    Expect(1, 8188, '\p{Is_Gc=titlecaseletter}', "");
    Expect(0, 8188, '\p{^Is_Gc=titlecaseletter}', "");
    Expect(0, 8188, '\P{Is_Gc=titlecaseletter}', "");
    Expect(1, 8188, '\P{^Is_Gc=titlecaseletter}', "");
    Expect(0, 8189, '\p{Is_Gc=titlecaseletter}', "");
    Expect(1, 8189, '\p{^Is_Gc=titlecaseletter}', "");
    Expect(1, 8189, '\P{Is_Gc=titlecaseletter}', "");
    Expect(0, 8189, '\P{^Is_Gc=titlecaseletter}', "");
    Expect(1, 8188, '\p{Is_Gc= Titlecase_letter}', "");
    Expect(0, 8188, '\p{^Is_Gc= Titlecase_letter}', "");
    Expect(0, 8188, '\P{Is_Gc= Titlecase_letter}', "");
    Expect(1, 8188, '\P{^Is_Gc= Titlecase_letter}', "");
    Expect(0, 8189, '\p{Is_Gc= Titlecase_letter}', "");
    Expect(1, 8189, '\p{^Is_Gc= Titlecase_letter}', "");
    Expect(1, 8189, '\P{Is_Gc= Titlecase_letter}', "");
    Expect(0, 8189, '\P{^Is_Gc= Titlecase_letter}', "");
    Error('\p{Is_Category=:= LT}');
    Error('\P{Is_Category=:= LT}');
    Expect(1, 8188, '\p{Is_Category=lt}', "");
    Expect(0, 8188, '\p{^Is_Category=lt}', "");
    Expect(0, 8188, '\P{Is_Category=lt}', "");
    Expect(1, 8188, '\P{^Is_Category=lt}', "");
    Expect(0, 8189, '\p{Is_Category=lt}', "");
    Expect(1, 8189, '\p{^Is_Category=lt}', "");
    Expect(1, 8189, '\P{Is_Category=lt}', "");
    Expect(0, 8189, '\P{^Is_Category=lt}', "");
    Expect(1, 8188, '\p{Is_Category=	-Lt}', "");
    Expect(0, 8188, '\p{^Is_Category=	-Lt}', "");
    Expect(0, 8188, '\P{Is_Category=	-Lt}', "");
    Expect(1, 8188, '\P{^Is_Category=	-Lt}', "");
    Expect(0, 8189, '\p{Is_Category=	-Lt}', "");
    Expect(1, 8189, '\p{^Is_Category=	-Lt}', "");
    Expect(1, 8189, '\P{Is_Category=	-Lt}', "");
    Expect(0, 8189, '\P{^Is_Category=	-Lt}', "");
    Error('\p{General_Category= /a/uppercase_Letter}');
    Error('\P{General_Category= /a/uppercase_Letter}');
    Expect(1, 125217, '\p{General_Category=:\AUppercase_Letter\z:}', "");;
    Expect(0, 125218, '\p{General_Category=:\AUppercase_Letter\z:}', "");;
    Expect(1, 125217, '\p{General_Category=uppercaseletter}', "");
    Expect(0, 125217, '\p{^General_Category=uppercaseletter}', "");
    Expect(0, 125217, '\P{General_Category=uppercaseletter}', "");
    Expect(1, 125217, '\P{^General_Category=uppercaseletter}', "");
    Expect(0, 125218, '\p{General_Category=uppercaseletter}', "");
    Expect(1, 125218, '\p{^General_Category=uppercaseletter}', "");
    Expect(1, 125218, '\P{General_Category=uppercaseletter}', "");
    Expect(0, 125218, '\P{^General_Category=uppercaseletter}', "");
    Expect(1, 125217, '\p{General_Category=:\Auppercaseletter\z:}', "");;
    Expect(0, 125218, '\p{General_Category=:\Auppercaseletter\z:}', "");;
    Expect(1, 125217, '\p{General_Category=	-Uppercase_Letter}', "");
    Expect(0, 125217, '\p{^General_Category=	-Uppercase_Letter}', "");
    Expect(0, 125217, '\P{General_Category=	-Uppercase_Letter}', "");
    Expect(1, 125217, '\P{^General_Category=	-Uppercase_Letter}', "");
    Expect(0, 125218, '\p{General_Category=	-Uppercase_Letter}', "");
    Expect(1, 125218, '\p{^General_Category=	-Uppercase_Letter}', "");
    Expect(1, 125218, '\P{General_Category=	-Uppercase_Letter}', "");
    Expect(0, 125218, '\P{^General_Category=	-Uppercase_Letter}', "");
    Error('\p{Gc= -LU:=}');
    Error('\P{Gc= -LU:=}');
    Expect(1, 125217, '\p{Gc=:\ALu\z:}', "");;
    Expect(0, 125218, '\p{Gc=:\ALu\z:}', "");;
    Expect(1, 125217, '\p{Gc=lu}', "");
    Expect(0, 125217, '\p{^Gc=lu}', "");
    Expect(0, 125217, '\P{Gc=lu}', "");
    Expect(1, 125217, '\P{^Gc=lu}', "");
    Expect(0, 125218, '\p{Gc=lu}', "");
    Expect(1, 125218, '\p{^Gc=lu}', "");
    Expect(1, 125218, '\P{Gc=lu}', "");
    Expect(0, 125218, '\P{^Gc=lu}', "");
    Expect(1, 125217, '\p{Gc=:\Alu\z:}', "");;
    Expect(0, 125218, '\p{Gc=:\Alu\z:}', "");;
    Expect(1, 125217, '\p{Gc:		Lu}', "");
    Expect(0, 125217, '\p{^Gc:		Lu}', "");
    Expect(0, 125217, '\P{Gc:		Lu}', "");
    Expect(1, 125217, '\P{^Gc:		Lu}', "");
    Expect(0, 125218, '\p{Gc:		Lu}', "");
    Expect(1, 125218, '\p{^Gc:		Lu}', "");
    Expect(1, 125218, '\P{Gc:		Lu}', "");
    Expect(0, 125218, '\P{^Gc:		Lu}', "");
    Error('\p{Category=__uppercase_Letter/a/}');
    Error('\P{Category=__uppercase_Letter/a/}');
    Expect(1, 125217, '\p{Category=:\AUppercase_Letter\z:}', "");;
    Expect(0, 125218, '\p{Category=:\AUppercase_Letter\z:}', "");;
    Expect(1, 125217, '\p{Category:	uppercaseletter}', "");
    Expect(0, 125217, '\p{^Category:	uppercaseletter}', "");
    Expect(0, 125217, '\P{Category:	uppercaseletter}', "");
    Expect(1, 125217, '\P{^Category:	uppercaseletter}', "");
    Expect(0, 125218, '\p{Category:	uppercaseletter}', "");
    Expect(1, 125218, '\p{^Category:	uppercaseletter}', "");
    Expect(1, 125218, '\P{Category:	uppercaseletter}', "");
    Expect(0, 125218, '\P{^Category:	uppercaseletter}', "");
    Expect(1, 125217, '\p{Category=:\Auppercaseletter\z:}', "");;
    Expect(0, 125218, '\p{Category=:\Auppercaseletter\z:}', "");;
    Expect(1, 125217, '\p{Category=	-Uppercase_LETTER}', "");
    Expect(0, 125217, '\p{^Category=	-Uppercase_LETTER}', "");
    Expect(0, 125217, '\P{Category=	-Uppercase_LETTER}', "");
    Expect(1, 125217, '\P{^Category=	-Uppercase_LETTER}', "");
    Expect(0, 125218, '\p{Category=	-Uppercase_LETTER}', "");
    Expect(1, 125218, '\p{^Category=	-Uppercase_LETTER}', "");
    Expect(1, 125218, '\P{Category=	-Uppercase_LETTER}', "");
    Expect(0, 125218, '\P{^Category=	-Uppercase_LETTER}', "");
    Error('\p{Is_General_Category=-	LU/a/}');
    Error('\P{Is_General_Category=-	LU/a/}');
    Expect(1, 125217, '\p{Is_General_Category=lu}', "");
    Expect(0, 125217, '\p{^Is_General_Category=lu}', "");
    Expect(0, 125217, '\P{Is_General_Category=lu}', "");
    Expect(1, 125217, '\P{^Is_General_Category=lu}', "");
    Expect(0, 125218, '\p{Is_General_Category=lu}', "");
    Expect(1, 125218, '\p{^Is_General_Category=lu}', "");
    Expect(1, 125218, '\P{Is_General_Category=lu}', "");
    Expect(0, 125218, '\P{^Is_General_Category=lu}', "");
    Expect(1, 125217, '\p{Is_General_Category=	lu}', "");
    Expect(0, 125217, '\p{^Is_General_Category=	lu}', "");
    Expect(0, 125217, '\P{Is_General_Category=	lu}', "");
    Expect(1, 125217, '\P{^Is_General_Category=	lu}', "");
    Expect(0, 125218, '\p{Is_General_Category=	lu}', "");
    Expect(1, 125218, '\p{^Is_General_Category=	lu}', "");
    Expect(1, 125218, '\P{Is_General_Category=	lu}', "");
    Expect(0, 125218, '\P{^Is_General_Category=	lu}', "");
    Error('\p{Is_Gc=:=Uppercase_Letter}');
    Error('\P{Is_Gc=:=Uppercase_Letter}');
    Expect(1, 125217, '\p{Is_Gc=uppercaseletter}', "");
    Expect(0, 125217, '\p{^Is_Gc=uppercaseletter}', "");
    Expect(0, 125217, '\P{Is_Gc=uppercaseletter}', "");
    Expect(1, 125217, '\P{^Is_Gc=uppercaseletter}', "");
    Expect(0, 125218, '\p{Is_Gc=uppercaseletter}', "");
    Expect(1, 125218, '\p{^Is_Gc=uppercaseletter}', "");
    Expect(1, 125218, '\P{Is_Gc=uppercaseletter}', "");
    Expect(0, 125218, '\P{^Is_Gc=uppercaseletter}', "");
    Expect(1, 125217, '\p{Is_Gc=-	Uppercase_Letter}', "");
    Expect(0, 125217, '\p{^Is_Gc=-	Uppercase_Letter}', "");
    Expect(0, 125217, '\P{Is_Gc=-	Uppercase_Letter}', "");
    Expect(1, 125217, '\P{^Is_Gc=-	Uppercase_Letter}', "");
    Expect(0, 125218, '\p{Is_Gc=-	Uppercase_Letter}', "");
    Expect(1, 125218, '\p{^Is_Gc=-	Uppercase_Letter}', "");
    Expect(1, 125218, '\P{Is_Gc=-	Uppercase_Letter}', "");
    Expect(0, 125218, '\P{^Is_Gc=-	Uppercase_Letter}', "");
    Error('\p{Is_Category=:=__Lu}');
    Error('\P{Is_Category=:=__Lu}');
    Expect(1, 125217, '\p{Is_Category=lu}', "");
    Expect(0, 125217, '\p{^Is_Category=lu}', "");
    Expect(0, 125217, '\P{Is_Category=lu}', "");
    Expect(1, 125217, '\P{^Is_Category=lu}', "");
    Expect(0, 125218, '\p{Is_Category=lu}', "");
    Expect(1, 125218, '\p{^Is_Category=lu}', "");
    Expect(1, 125218, '\P{Is_Category=lu}', "");
    Expect(0, 125218, '\P{^Is_Category=lu}', "");
    Expect(1, 125217, '\p{Is_Category= LU}', "");
    Expect(0, 125217, '\p{^Is_Category= LU}', "");
    Expect(0, 125217, '\P{Is_Category= LU}', "");
    Expect(1, 125217, '\P{^Is_Category= LU}', "");
    Expect(0, 125218, '\p{Is_Category= LU}', "");
    Expect(1, 125218, '\p{^Is_Category= LU}', "");
    Expect(1, 125218, '\P{Is_Category= LU}', "");
    Expect(0, 125218, '\P{^Is_Category= LU}', "");
    Error('\p{General_Category=__Mark/a/}');
    Error('\P{General_Category=__Mark/a/}');
    Expect(1, 917999, '\p{General_Category=:\AMark\z:}', "");;
    Expect(0, 918000, '\p{General_Category=:\AMark\z:}', "");;
    Expect(1, 917999, '\p{General_Category=mark}', "");
    Expect(0, 917999, '\p{^General_Category=mark}', "");
    Expect(0, 917999, '\P{General_Category=mark}', "");
    Expect(1, 917999, '\P{^General_Category=mark}', "");
    Expect(0, 918000, '\p{General_Category=mark}', "");
    Expect(1, 918000, '\p{^General_Category=mark}', "");
    Expect(1, 918000, '\P{General_Category=mark}', "");
    Expect(0, 918000, '\P{^General_Category=mark}', "");
    Expect(1, 917999, '\p{General_Category=:\Amark\z:}', "");;
    Expect(0, 918000, '\p{General_Category=:\Amark\z:}', "");;
    Expect(1, 917999, '\p{General_Category=	 Mark}', "");
    Expect(0, 917999, '\p{^General_Category=	 Mark}', "");
    Expect(0, 917999, '\P{General_Category=	 Mark}', "");
    Expect(1, 917999, '\P{^General_Category=	 Mark}', "");
    Expect(0, 918000, '\p{General_Category=	 Mark}', "");
    Expect(1, 918000, '\p{^General_Category=	 Mark}', "");
    Expect(1, 918000, '\P{General_Category=	 Mark}', "");
    Expect(0, 918000, '\P{^General_Category=	 Mark}', "");
    Error('\p{Gc= M/a/}');
    Error('\P{Gc= M/a/}');
    Expect(1, 917999, '\p{Gc=:\AM\z:}', "");;
    Expect(0, 918000, '\p{Gc=:\AM\z:}', "");;
    Expect(1, 917999, '\p{Gc=m}', "");
    Expect(0, 917999, '\p{^Gc=m}', "");
    Expect(0, 917999, '\P{Gc=m}', "");
    Expect(1, 917999, '\P{^Gc=m}', "");
    Expect(0, 918000, '\p{Gc=m}', "");
    Expect(1, 918000, '\p{^Gc=m}', "");
    Expect(1, 918000, '\P{Gc=m}', "");
    Expect(0, 918000, '\P{^Gc=m}', "");
    Expect(1, 917999, '\p{Gc=:\Am\z:}', "");;
    Expect(0, 918000, '\p{Gc=:\Am\z:}', "");;
    Expect(1, 917999, '\p{Gc=	 M}', "");
    Expect(0, 917999, '\p{^Gc=	 M}', "");
    Expect(0, 917999, '\P{Gc=	 M}', "");
    Expect(1, 917999, '\P{^Gc=	 M}', "");
    Expect(0, 918000, '\p{Gc=	 M}', "");
    Expect(1, 918000, '\p{^Gc=	 M}', "");
    Expect(1, 918000, '\P{Gc=	 M}', "");
    Expect(0, 918000, '\P{^Gc=	 M}', "");
    Error('\p{Category= /a/Combining_Mark}');
    Error('\P{Category= /a/Combining_Mark}');
    Expect(1, 917999, '\p{Category=:\ACombining_Mark\z:}', "");;
    Expect(0, 918000, '\p{Category=:\ACombining_Mark\z:}', "");;
    Expect(1, 917999, '\p{Category=combiningmark}', "");
    Expect(0, 917999, '\p{^Category=combiningmark}', "");
    Expect(0, 917999, '\P{Category=combiningmark}', "");
    Expect(1, 917999, '\P{^Category=combiningmark}', "");
    Expect(0, 918000, '\p{Category=combiningmark}', "");
    Expect(1, 918000, '\p{^Category=combiningmark}', "");
    Expect(1, 918000, '\P{Category=combiningmark}', "");
    Expect(0, 918000, '\P{^Category=combiningmark}', "");
    Expect(1, 917999, '\p{Category=:\Acombiningmark\z:}', "");;
    Expect(0, 918000, '\p{Category=:\Acombiningmark\z:}', "");;
    Expect(1, 917999, '\p{Category:_ Combining_Mark}', "");
    Expect(0, 917999, '\p{^Category:_ Combining_Mark}', "");
    Expect(0, 917999, '\P{Category:_ Combining_Mark}', "");
    Expect(1, 917999, '\P{^Category:_ Combining_Mark}', "");
    Expect(0, 918000, '\p{Category:_ Combining_Mark}', "");
    Expect(1, 918000, '\p{^Category:_ Combining_Mark}', "");
    Expect(1, 918000, '\P{Category:_ Combining_Mark}', "");
    Expect(0, 918000, '\P{^Category:_ Combining_Mark}', "");
    Error('\p{Is_General_Category=_/a/mark}');
    Error('\P{Is_General_Category=_/a/mark}');
    Expect(1, 917999, '\p{Is_General_Category=mark}', "");
    Expect(0, 917999, '\p{^Is_General_Category=mark}', "");
    Expect(0, 917999, '\P{Is_General_Category=mark}', "");
    Expect(1, 917999, '\P{^Is_General_Category=mark}', "");
    Expect(0, 918000, '\p{Is_General_Category=mark}', "");
    Expect(1, 918000, '\p{^Is_General_Category=mark}', "");
    Expect(1, 918000, '\P{Is_General_Category=mark}', "");
    Expect(0, 918000, '\P{^Is_General_Category=mark}', "");
    Expect(1, 917999, '\p{Is_General_Category:	-Mark}', "");
    Expect(0, 917999, '\p{^Is_General_Category:	-Mark}', "");
    Expect(0, 917999, '\P{Is_General_Category:	-Mark}', "");
    Expect(1, 917999, '\P{^Is_General_Category:	-Mark}', "");
    Expect(0, 918000, '\p{Is_General_Category:	-Mark}', "");
    Expect(1, 918000, '\p{^Is_General_Category:	-Mark}', "");
    Expect(1, 918000, '\P{Is_General_Category:	-Mark}', "");
    Expect(0, 918000, '\P{^Is_General_Category:	-Mark}', "");
    Error('\p{Is_Gc=_-M/a/}');
    Error('\P{Is_Gc=_-M/a/}');
    Expect(1, 917999, '\p{Is_Gc=m}', "");
    Expect(0, 917999, '\p{^Is_Gc=m}', "");
    Expect(0, 917999, '\P{Is_Gc=m}', "");
    Expect(1, 917999, '\P{^Is_Gc=m}', "");
    Expect(0, 918000, '\p{Is_Gc=m}', "");
    Expect(1, 918000, '\p{^Is_Gc=m}', "");
    Expect(1, 918000, '\P{Is_Gc=m}', "");
    Expect(0, 918000, '\P{^Is_Gc=m}', "");
    Expect(1, 917999, '\p{Is_Gc=	M}', "");
    Expect(0, 917999, '\p{^Is_Gc=	M}', "");
    Expect(0, 917999, '\P{Is_Gc=	M}', "");
    Expect(1, 917999, '\P{^Is_Gc=	M}', "");
    Expect(0, 918000, '\p{Is_Gc=	M}', "");
    Expect(1, 918000, '\p{^Is_Gc=	M}', "");
    Expect(1, 918000, '\P{Is_Gc=	M}', "");
    Expect(0, 918000, '\P{^Is_Gc=	M}', "");
    Error('\p{Is_Category=:=	-combining_Mark}');
    Error('\P{Is_Category=:=	-combining_Mark}');
    Expect(1, 917999, '\p{Is_Category=combiningmark}', "");
    Expect(0, 917999, '\p{^Is_Category=combiningmark}', "");
    Expect(0, 917999, '\P{Is_Category=combiningmark}', "");
    Expect(1, 917999, '\P{^Is_Category=combiningmark}', "");
    Expect(0, 918000, '\p{Is_Category=combiningmark}', "");
    Expect(1, 918000, '\p{^Is_Category=combiningmark}', "");
    Expect(1, 918000, '\P{Is_Category=combiningmark}', "");
    Expect(0, 918000, '\P{^Is_Category=combiningmark}', "");
    Expect(1, 917999, '\p{Is_Category=	-Combining_Mark}', "");
    Expect(0, 917999, '\p{^Is_Category=	-Combining_Mark}', "");
    Expect(0, 917999, '\P{Is_Category=	-Combining_Mark}', "");
    Expect(1, 917999, '\P{^Is_Category=	-Combining_Mark}', "");
    Expect(0, 918000, '\p{Is_Category=	-Combining_Mark}', "");
    Expect(1, 918000, '\p{^Is_Category=	-Combining_Mark}', "");
    Expect(1, 918000, '\P{Is_Category=	-Combining_Mark}', "");
    Expect(0, 918000, '\P{^Is_Category=	-Combining_Mark}', "");
    Error('\p{General_Category=:=Spacing_MARK}');
    Error('\P{General_Category=:=Spacing_MARK}');
    Expect(1, 119154, '\p{General_Category=:\ASpacing_Mark\z:}', "");;
    Expect(0, 119155, '\p{General_Category=:\ASpacing_Mark\z:}', "");;
    Expect(1, 119154, '\p{General_Category=spacingmark}', "");
    Expect(0, 119154, '\p{^General_Category=spacingmark}', "");
    Expect(0, 119154, '\P{General_Category=spacingmark}', "");
    Expect(1, 119154, '\P{^General_Category=spacingmark}', "");
    Expect(0, 119155, '\p{General_Category=spacingmark}', "");
    Expect(1, 119155, '\p{^General_Category=spacingmark}', "");
    Expect(1, 119155, '\P{General_Category=spacingmark}', "");
    Expect(0, 119155, '\P{^General_Category=spacingmark}', "");
    Expect(1, 119154, '\p{General_Category=:\Aspacingmark\z:}', "");;
    Expect(0, 119155, '\p{General_Category=:\Aspacingmark\z:}', "");;
    Expect(1, 119154, '\p{General_Category=	_Spacing_mark}', "");
    Expect(0, 119154, '\p{^General_Category=	_Spacing_mark}', "");
    Expect(0, 119154, '\P{General_Category=	_Spacing_mark}', "");
    Expect(1, 119154, '\P{^General_Category=	_Spacing_mark}', "");
    Expect(0, 119155, '\p{General_Category=	_Spacing_mark}', "");
    Expect(1, 119155, '\p{^General_Category=	_Spacing_mark}', "");
    Expect(1, 119155, '\P{General_Category=	_Spacing_mark}', "");
    Expect(0, 119155, '\P{^General_Category=	_Spacing_mark}', "");
    Error('\p{Gc=-	MC:=}');
    Error('\P{Gc=-	MC:=}');
    Expect(1, 119154, '\p{Gc=:\AMc\z:}', "");;
    Expect(0, 119155, '\p{Gc=:\AMc\z:}', "");;
    Expect(1, 119154, '\p{Gc=mc}', "");
    Expect(0, 119154, '\p{^Gc=mc}', "");
    Expect(0, 119154, '\P{Gc=mc}', "");
    Expect(1, 119154, '\P{^Gc=mc}', "");
    Expect(0, 119155, '\p{Gc=mc}', "");
    Expect(1, 119155, '\p{^Gc=mc}', "");
    Expect(1, 119155, '\P{Gc=mc}', "");
    Expect(0, 119155, '\P{^Gc=mc}', "");
    Expect(1, 119154, '\p{Gc=:\Amc\z:}', "");;
    Expect(0, 119155, '\p{Gc=:\Amc\z:}', "");;
    Expect(1, 119154, '\p{Gc=-	Mc}', "");
    Expect(0, 119154, '\p{^Gc=-	Mc}', "");
    Expect(0, 119154, '\P{Gc=-	Mc}', "");
    Expect(1, 119154, '\P{^Gc=-	Mc}', "");
    Expect(0, 119155, '\p{Gc=-	Mc}', "");
    Expect(1, 119155, '\p{^Gc=-	Mc}', "");
    Expect(1, 119155, '\P{Gc=-	Mc}', "");
    Expect(0, 119155, '\P{^Gc=-	Mc}', "");
    Error('\p{Category: /a/ spacing_Mark}');
    Error('\P{Category: /a/ spacing_Mark}');
    Expect(1, 119154, '\p{Category=:\ASpacing_Mark\z:}', "");;
    Expect(0, 119155, '\p{Category=:\ASpacing_Mark\z:}', "");;
    Expect(1, 119154, '\p{Category=spacingmark}', "");
    Expect(0, 119154, '\p{^Category=spacingmark}', "");
    Expect(0, 119154, '\P{Category=spacingmark}', "");
    Expect(1, 119154, '\P{^Category=spacingmark}', "");
    Expect(0, 119155, '\p{Category=spacingmark}', "");
    Expect(1, 119155, '\p{^Category=spacingmark}', "");
    Expect(1, 119155, '\P{Category=spacingmark}', "");
    Expect(0, 119155, '\P{^Category=spacingmark}', "");
    Expect(1, 119154, '\p{Category=:\Aspacingmark\z:}', "");;
    Expect(0, 119155, '\p{Category=:\Aspacingmark\z:}', "");;
    Expect(1, 119154, '\p{Category= Spacing_Mark}', "");
    Expect(0, 119154, '\p{^Category= Spacing_Mark}', "");
    Expect(0, 119154, '\P{Category= Spacing_Mark}', "");
    Expect(1, 119154, '\P{^Category= Spacing_Mark}', "");
    Expect(0, 119155, '\p{Category= Spacing_Mark}', "");
    Expect(1, 119155, '\p{^Category= Spacing_Mark}', "");
    Expect(1, 119155, '\P{Category= Spacing_Mark}', "");
    Expect(0, 119155, '\P{^Category= Spacing_Mark}', "");
    Error('\p{Is_General_Category=:= -Mc}');
    Error('\P{Is_General_Category=:= -Mc}');
    Expect(1, 119154, '\p{Is_General_Category=mc}', "");
    Expect(0, 119154, '\p{^Is_General_Category=mc}', "");
    Expect(0, 119154, '\P{Is_General_Category=mc}', "");
    Expect(1, 119154, '\P{^Is_General_Category=mc}', "");
    Expect(0, 119155, '\p{Is_General_Category=mc}', "");
    Expect(1, 119155, '\p{^Is_General_Category=mc}', "");
    Expect(1, 119155, '\P{Is_General_Category=mc}', "");
    Expect(0, 119155, '\P{^Is_General_Category=mc}', "");
    Expect(1, 119154, '\p{Is_General_Category=	 Mc}', "");
    Expect(0, 119154, '\p{^Is_General_Category=	 Mc}', "");
    Expect(0, 119154, '\P{Is_General_Category=	 Mc}', "");
    Expect(1, 119154, '\P{^Is_General_Category=	 Mc}', "");
    Expect(0, 119155, '\p{Is_General_Category=	 Mc}', "");
    Expect(1, 119155, '\p{^Is_General_Category=	 Mc}', "");
    Expect(1, 119155, '\P{Is_General_Category=	 Mc}', "");
    Expect(0, 119155, '\P{^Is_General_Category=	 Mc}', "");
    Error('\p{Is_Gc=_:=SPACING_MARK}');
    Error('\P{Is_Gc=_:=SPACING_MARK}');
    Expect(1, 119154, '\p{Is_Gc=spacingmark}', "");
    Expect(0, 119154, '\p{^Is_Gc=spacingmark}', "");
    Expect(0, 119154, '\P{Is_Gc=spacingmark}', "");
    Expect(1, 119154, '\P{^Is_Gc=spacingmark}', "");
    Expect(0, 119155, '\p{Is_Gc=spacingmark}', "");
    Expect(1, 119155, '\p{^Is_Gc=spacingmark}', "");
    Expect(1, 119155, '\P{Is_Gc=spacingmark}', "");
    Expect(0, 119155, '\P{^Is_Gc=spacingmark}', "");
    Expect(1, 119154, '\p{Is_Gc:	-_SPACING_MARK}', "");
    Expect(0, 119154, '\p{^Is_Gc:	-_SPACING_MARK}', "");
    Expect(0, 119154, '\P{Is_Gc:	-_SPACING_MARK}', "");
    Expect(1, 119154, '\P{^Is_Gc:	-_SPACING_MARK}', "");
    Expect(0, 119155, '\p{Is_Gc:	-_SPACING_MARK}', "");
    Expect(1, 119155, '\p{^Is_Gc:	-_SPACING_MARK}', "");
    Expect(1, 119155, '\P{Is_Gc:	-_SPACING_MARK}', "");
    Expect(0, 119155, '\P{^Is_Gc:	-_SPACING_MARK}', "");
    Error('\p{Is_Category=-	mc/a/}');
    Error('\P{Is_Category=-	mc/a/}');
    Expect(1, 119154, '\p{Is_Category=mc}', "");
    Expect(0, 119154, '\p{^Is_Category=mc}', "");
    Expect(0, 119154, '\P{Is_Category=mc}', "");
    Expect(1, 119154, '\P{^Is_Category=mc}', "");
    Expect(0, 119155, '\p{Is_Category=mc}', "");
    Expect(1, 119155, '\p{^Is_Category=mc}', "");
    Expect(1, 119155, '\P{Is_Category=mc}', "");
    Expect(0, 119155, '\P{^Is_Category=mc}', "");
    Expect(1, 119154, '\p{Is_Category=	-mc}', "");
    Expect(0, 119154, '\p{^Is_Category=	-mc}', "");
    Expect(0, 119154, '\P{Is_Category=	-mc}', "");
    Expect(1, 119154, '\P{^Is_Category=	-mc}', "");
    Expect(0, 119155, '\p{Is_Category=	-mc}', "");
    Expect(1, 119155, '\p{^Is_Category=	-mc}', "");
    Expect(1, 119155, '\P{Is_Category=	-mc}', "");
    Expect(0, 119155, '\P{^Is_Category=	-mc}', "");
    Error('\p{General_Category=--enclosing_Mark/a/}');
    Error('\P{General_Category=--enclosing_Mark/a/}');
    Expect(1, 42610, '\p{General_Category=:\AEnclosing_Mark\z:}', "");;
    Expect(0, 42611, '\p{General_Category=:\AEnclosing_Mark\z:}', "");;
    Expect(1, 42610, '\p{General_Category=enclosingmark}', "");
    Expect(0, 42610, '\p{^General_Category=enclosingmark}', "");
    Expect(0, 42610, '\P{General_Category=enclosingmark}', "");
    Expect(1, 42610, '\P{^General_Category=enclosingmark}', "");
    Expect(0, 42611, '\p{General_Category=enclosingmark}', "");
    Expect(1, 42611, '\p{^General_Category=enclosingmark}', "");
    Expect(1, 42611, '\P{General_Category=enclosingmark}', "");
    Expect(0, 42611, '\P{^General_Category=enclosingmark}', "");
}
if (!$::TESTCHUNK or $::TESTCHUNK == 2) {
    Expect(1, 42610, '\p{General_Category=:\Aenclosingmark\z:}', "");;
    Expect(0, 42611, '\p{General_Category=:\Aenclosingmark\z:}', "");;
    Expect(1, 42610, '\p{General_Category= _Enclosing_Mark}', "");
    Expect(0, 42610, '\p{^General_Category= _Enclosing_Mark}', "");
    Expect(0, 42610, '\P{General_Category= _Enclosing_Mark}', "");
    Expect(1, 42610, '\P{^General_Category= _Enclosing_Mark}', "");
    Expect(0, 42611, '\p{General_Category= _Enclosing_Mark}', "");
    Expect(1, 42611, '\p{^General_Category= _Enclosing_Mark}', "");
    Expect(1, 42611, '\P{General_Category= _Enclosing_Mark}', "");
    Expect(0, 42611, '\P{^General_Category= _Enclosing_Mark}', "");
    Error('\p{Gc=-me:=}');
    Error('\P{Gc=-me:=}');
    Expect(1, 42610, '\p{Gc=:\AMe\z:}', "");;
    Expect(0, 42611, '\p{Gc=:\AMe\z:}', "");;
    Expect(1, 42610, '\p{Gc=me}', "");
    Expect(0, 42610, '\p{^Gc=me}', "");
    Expect(0, 42610, '\P{Gc=me}', "");
    Expect(1, 42610, '\P{^Gc=me}', "");
    Expect(0, 42611, '\p{Gc=me}', "");
    Expect(1, 42611, '\p{^Gc=me}', "");
    Expect(1, 42611, '\P{Gc=me}', "");
    Expect(0, 42611, '\P{^Gc=me}', "");
    Expect(1, 42610, '\p{Gc=:\Ame\z:}', "");;
    Expect(0, 42611, '\p{Gc=:\Ame\z:}', "");;
    Expect(1, 42610, '\p{Gc=	ME}', "");
    Expect(0, 42610, '\p{^Gc=	ME}', "");
    Expect(0, 42610, '\P{Gc=	ME}', "");
    Expect(1, 42610, '\P{^Gc=	ME}', "");
    Expect(0, 42611, '\p{Gc=	ME}', "");
    Expect(1, 42611, '\p{^Gc=	ME}', "");
    Expect(1, 42611, '\P{Gc=	ME}', "");
    Expect(0, 42611, '\P{^Gc=	ME}', "");
    Error('\p{Category=_ enclosing_Mark:=}');
    Error('\P{Category=_ enclosing_Mark:=}');
    Expect(1, 42610, '\p{Category=:\AEnclosing_Mark\z:}', "");;
    Expect(0, 42611, '\p{Category=:\AEnclosing_Mark\z:}', "");;
    Expect(1, 42610, '\p{Category: enclosingmark}', "");
    Expect(0, 42610, '\p{^Category: enclosingmark}', "");
    Expect(0, 42610, '\P{Category: enclosingmark}', "");
    Expect(1, 42610, '\P{^Category: enclosingmark}', "");
    Expect(0, 42611, '\p{Category: enclosingmark}', "");
    Expect(1, 42611, '\p{^Category: enclosingmark}', "");
    Expect(1, 42611, '\P{Category: enclosingmark}', "");
    Expect(0, 42611, '\P{^Category: enclosingmark}', "");
    Expect(1, 42610, '\p{Category=:\Aenclosingmark\z:}', "");;
    Expect(0, 42611, '\p{Category=:\Aenclosingmark\z:}', "");;
    Expect(1, 42610, '\p{Category:	- enclosing_mark}', "");
    Expect(0, 42610, '\p{^Category:	- enclosing_mark}', "");
    Expect(0, 42610, '\P{Category:	- enclosing_mark}', "");
    Expect(1, 42610, '\P{^Category:	- enclosing_mark}', "");
    Expect(0, 42611, '\p{Category:	- enclosing_mark}', "");
    Expect(1, 42611, '\p{^Category:	- enclosing_mark}', "");
    Expect(1, 42611, '\P{Category:	- enclosing_mark}', "");
    Expect(0, 42611, '\P{^Category:	- enclosing_mark}', "");
    Error('\p{Is_General_Category=:= 	ME}');
    Error('\P{Is_General_Category=:= 	ME}');
    Expect(1, 42610, '\p{Is_General_Category:   me}', "");
    Expect(0, 42610, '\p{^Is_General_Category:   me}', "");
    Expect(0, 42610, '\P{Is_General_Category:   me}', "");
    Expect(1, 42610, '\P{^Is_General_Category:   me}', "");
    Expect(0, 42611, '\p{Is_General_Category:   me}', "");
    Expect(1, 42611, '\p{^Is_General_Category:   me}', "");
    Expect(1, 42611, '\P{Is_General_Category:   me}', "");
    Expect(0, 42611, '\P{^Is_General_Category:   me}', "");
    Expect(1, 42610, '\p{Is_General_Category: 	Me}', "");
    Expect(0, 42610, '\p{^Is_General_Category: 	Me}', "");
    Expect(0, 42610, '\P{Is_General_Category: 	Me}', "");
    Expect(1, 42610, '\P{^Is_General_Category: 	Me}', "");
    Expect(0, 42611, '\p{Is_General_Category: 	Me}', "");
    Expect(1, 42611, '\p{^Is_General_Category: 	Me}', "");
    Expect(1, 42611, '\P{Is_General_Category: 	Me}', "");
    Expect(0, 42611, '\P{^Is_General_Category: 	Me}', "");
    Error('\p{Is_Gc: /a/	_Enclosing_mark}');
    Error('\P{Is_Gc: /a/	_Enclosing_mark}');
    Expect(1, 42610, '\p{Is_Gc=enclosingmark}', "");
    Expect(0, 42610, '\p{^Is_Gc=enclosingmark}', "");
    Expect(0, 42610, '\P{Is_Gc=enclosingmark}', "");
    Expect(1, 42610, '\P{^Is_Gc=enclosingmark}', "");
    Expect(0, 42611, '\p{Is_Gc=enclosingmark}', "");
    Expect(1, 42611, '\p{^Is_Gc=enclosingmark}', "");
    Expect(1, 42611, '\P{Is_Gc=enclosingmark}', "");
    Expect(0, 42611, '\P{^Is_Gc=enclosingmark}', "");
    Expect(1, 42610, '\p{Is_Gc=_Enclosing_Mark}', "");
    Expect(0, 42610, '\p{^Is_Gc=_Enclosing_Mark}', "");
    Expect(0, 42610, '\P{Is_Gc=_Enclosing_Mark}', "");
    Expect(1, 42610, '\P{^Is_Gc=_Enclosing_Mark}', "");
    Expect(0, 42611, '\p{Is_Gc=_Enclosing_Mark}', "");
    Expect(1, 42611, '\p{^Is_Gc=_Enclosing_Mark}', "");
    Expect(1, 42611, '\P{Is_Gc=_Enclosing_Mark}', "");
    Expect(0, 42611, '\P{^Is_Gc=_Enclosing_Mark}', "");
    Error('\p{Is_Category= :=Me}');
    Error('\P{Is_Category= :=Me}');
    Expect(1, 42610, '\p{Is_Category=me}', "");
    Expect(0, 42610, '\p{^Is_Category=me}', "");
    Expect(0, 42610, '\P{Is_Category=me}', "");
    Expect(1, 42610, '\P{^Is_Category=me}', "");
    Expect(0, 42611, '\p{Is_Category=me}', "");
    Expect(1, 42611, '\p{^Is_Category=me}', "");
    Expect(1, 42611, '\P{Is_Category=me}', "");
    Expect(0, 42611, '\P{^Is_Category=me}', "");
    Expect(1, 42610, '\p{Is_Category= ME}', "");
    Expect(0, 42610, '\p{^Is_Category= ME}', "");
    Expect(0, 42610, '\P{Is_Category= ME}', "");
    Expect(1, 42610, '\P{^Is_Category= ME}', "");
    Expect(0, 42611, '\p{Is_Category= ME}', "");
    Expect(1, 42611, '\p{^Is_Category= ME}', "");
    Expect(1, 42611, '\P{Is_Category= ME}', "");
    Expect(0, 42611, '\P{^Is_Category= ME}', "");
    Error('\p{General_Category=/a/-_NONSPACING_MARK}');
    Error('\P{General_Category=/a/-_NONSPACING_MARK}');
    Expect(1, 917999, '\p{General_Category=:\ANonspacing_Mark\z:}', "");;
    Expect(0, 918000, '\p{General_Category=:\ANonspacing_Mark\z:}', "");;
    Expect(1, 917999, '\p{General_Category=nonspacingmark}', "");
    Expect(0, 917999, '\p{^General_Category=nonspacingmark}', "");
    Expect(0, 917999, '\P{General_Category=nonspacingmark}', "");
    Expect(1, 917999, '\P{^General_Category=nonspacingmark}', "");
    Expect(0, 918000, '\p{General_Category=nonspacingmark}', "");
    Expect(1, 918000, '\p{^General_Category=nonspacingmark}', "");
    Expect(1, 918000, '\P{General_Category=nonspacingmark}', "");
    Expect(0, 918000, '\P{^General_Category=nonspacingmark}', "");
    Expect(1, 917999, '\p{General_Category=:\Anonspacingmark\z:}', "");;
    Expect(0, 918000, '\p{General_Category=:\Anonspacingmark\z:}', "");;
    Expect(1, 917999, '\p{General_Category=--NONSPACING_Mark}', "");
    Expect(0, 917999, '\p{^General_Category=--NONSPACING_Mark}', "");
    Expect(0, 917999, '\P{General_Category=--NONSPACING_Mark}', "");
    Expect(1, 917999, '\P{^General_Category=--NONSPACING_Mark}', "");
    Expect(0, 918000, '\p{General_Category=--NONSPACING_Mark}', "");
    Expect(1, 918000, '\p{^General_Category=--NONSPACING_Mark}', "");
    Expect(1, 918000, '\P{General_Category=--NONSPACING_Mark}', "");
    Expect(0, 918000, '\P{^General_Category=--NONSPACING_Mark}', "");
    Error('\p{Gc=	/a/Mn}');
    Error('\P{Gc=	/a/Mn}');
    Expect(1, 917999, '\p{Gc=:\AMn\z:}', "");;
    Expect(0, 918000, '\p{Gc=:\AMn\z:}', "");;
    Expect(1, 917999, '\p{Gc=mn}', "");
    Expect(0, 917999, '\p{^Gc=mn}', "");
    Expect(0, 917999, '\P{Gc=mn}', "");
    Expect(1, 917999, '\P{^Gc=mn}', "");
    Expect(0, 918000, '\p{Gc=mn}', "");
    Expect(1, 918000, '\p{^Gc=mn}', "");
    Expect(1, 918000, '\P{Gc=mn}', "");
    Expect(0, 918000, '\P{^Gc=mn}', "");
    Expect(1, 917999, '\p{Gc=:\Amn\z:}', "");;
    Expect(0, 918000, '\p{Gc=:\Amn\z:}', "");;
    Expect(1, 917999, '\p{Gc=	-MN}', "");
    Expect(0, 917999, '\p{^Gc=	-MN}', "");
    Expect(0, 917999, '\P{Gc=	-MN}', "");
    Expect(1, 917999, '\P{^Gc=	-MN}', "");
    Expect(0, 918000, '\p{Gc=	-MN}', "");
    Expect(1, 918000, '\p{^Gc=	-MN}', "");
    Expect(1, 918000, '\P{Gc=	-MN}', "");
    Expect(0, 918000, '\P{^Gc=	-MN}', "");
    Error('\p{Category=:=	Nonspacing_Mark}');
    Error('\P{Category=:=	Nonspacing_Mark}');
    Expect(1, 917999, '\p{Category=:\ANonspacing_Mark\z:}', "");;
    Expect(0, 918000, '\p{Category=:\ANonspacing_Mark\z:}', "");;
    Expect(1, 917999, '\p{Category=nonspacingmark}', "");
    Expect(0, 917999, '\p{^Category=nonspacingmark}', "");
    Expect(0, 917999, '\P{Category=nonspacingmark}', "");
    Expect(1, 917999, '\P{^Category=nonspacingmark}', "");
    Expect(0, 918000, '\p{Category=nonspacingmark}', "");
    Expect(1, 918000, '\p{^Category=nonspacingmark}', "");
    Expect(1, 918000, '\P{Category=nonspacingmark}', "");
    Expect(0, 918000, '\P{^Category=nonspacingmark}', "");
    Expect(1, 917999, '\p{Category=:\Anonspacingmark\z:}', "");;
    Expect(0, 918000, '\p{Category=:\Anonspacingmark\z:}', "");;
    Expect(1, 917999, '\p{Category= nonspacing_MARK}', "");
    Expect(0, 917999, '\p{^Category= nonspacing_MARK}', "");
    Expect(0, 917999, '\P{Category= nonspacing_MARK}', "");
    Expect(1, 917999, '\P{^Category= nonspacing_MARK}', "");
    Expect(0, 918000, '\p{Category= nonspacing_MARK}', "");
    Expect(1, 918000, '\p{^Category= nonspacing_MARK}', "");
    Expect(1, 918000, '\P{Category= nonspacing_MARK}', "");
    Expect(0, 918000, '\P{^Category= nonspacing_MARK}', "");
    Error('\p{Is_General_Category=-	MN:=}');
    Error('\P{Is_General_Category=-	MN:=}');
    Expect(1, 917999, '\p{Is_General_Category=mn}', "");
    Expect(0, 917999, '\p{^Is_General_Category=mn}', "");
    Expect(0, 917999, '\P{Is_General_Category=mn}', "");
    Expect(1, 917999, '\P{^Is_General_Category=mn}', "");
    Expect(0, 918000, '\p{Is_General_Category=mn}', "");
    Expect(1, 918000, '\p{^Is_General_Category=mn}', "");
    Expect(1, 918000, '\P{Is_General_Category=mn}', "");
    Expect(0, 918000, '\P{^Is_General_Category=mn}', "");
    Expect(1, 917999, '\p{Is_General_Category:   _-Mn}', "");
    Expect(0, 917999, '\p{^Is_General_Category:   _-Mn}', "");
    Expect(0, 917999, '\P{Is_General_Category:   _-Mn}', "");
    Expect(1, 917999, '\P{^Is_General_Category:   _-Mn}', "");
    Expect(0, 918000, '\p{Is_General_Category:   _-Mn}', "");
    Expect(1, 918000, '\p{^Is_General_Category:   _-Mn}', "");
    Expect(1, 918000, '\P{Is_General_Category:   _-Mn}', "");
    Expect(0, 918000, '\P{^Is_General_Category:   _-Mn}', "");
    Error('\p{Is_Gc=		nonspacing_mark:=}');
    Error('\P{Is_Gc=		nonspacing_mark:=}');
    Expect(1, 917999, '\p{Is_Gc=nonspacingmark}', "");
    Expect(0, 917999, '\p{^Is_Gc=nonspacingmark}', "");
    Expect(0, 917999, '\P{Is_Gc=nonspacingmark}', "");
    Expect(1, 917999, '\P{^Is_Gc=nonspacingmark}', "");
    Expect(0, 918000, '\p{Is_Gc=nonspacingmark}', "");
    Expect(1, 918000, '\p{^Is_Gc=nonspacingmark}', "");
    Expect(1, 918000, '\P{Is_Gc=nonspacingmark}', "");
    Expect(0, 918000, '\P{^Is_Gc=nonspacingmark}', "");
    Expect(1, 917999, '\p{Is_Gc=-Nonspacing_mark}', "");
    Expect(0, 917999, '\p{^Is_Gc=-Nonspacing_mark}', "");
    Expect(0, 917999, '\P{Is_Gc=-Nonspacing_mark}', "");
    Expect(1, 917999, '\P{^Is_Gc=-Nonspacing_mark}', "");
    Expect(0, 918000, '\p{Is_Gc=-Nonspacing_mark}', "");
    Expect(1, 918000, '\p{^Is_Gc=-Nonspacing_mark}', "");
    Expect(1, 918000, '\P{Is_Gc=-Nonspacing_mark}', "");
    Expect(0, 918000, '\P{^Is_Gc=-Nonspacing_mark}', "");
    Error('\p{Is_Category=_-MN:=}');
    Error('\P{Is_Category=_-MN:=}');
    Expect(1, 917999, '\p{Is_Category=mn}', "");
    Expect(0, 917999, '\p{^Is_Category=mn}', "");
    Expect(0, 917999, '\P{Is_Category=mn}', "");
    Expect(1, 917999, '\P{^Is_Category=mn}', "");
    Expect(0, 918000, '\p{Is_Category=mn}', "");
    Expect(1, 918000, '\p{^Is_Category=mn}', "");
    Expect(1, 918000, '\P{Is_Category=mn}', "");
    Expect(0, 918000, '\P{^Is_Category=mn}', "");
    Expect(1, 917999, '\p{Is_Category=-mn}', "");
    Expect(0, 917999, '\p{^Is_Category=-mn}', "");
    Expect(0, 917999, '\P{Is_Category=-mn}', "");
    Expect(1, 917999, '\P{^Is_Category=-mn}', "");
    Expect(0, 918000, '\p{Is_Category=-mn}', "");
    Expect(1, 918000, '\p{^Is_Category=-mn}', "");
    Expect(1, 918000, '\P{Is_Category=-mn}', "");
    Expect(0, 918000, '\P{^Is_Category=-mn}', "");
    Error('\p{General_Category=:=	-NUMBER}');
    Error('\P{General_Category=:=	-NUMBER}');
    Expect(1, 127244, '\p{General_Category=:\ANumber\z:}', "");;
    Expect(0, 127245, '\p{General_Category=:\ANumber\z:}', "");;
    Expect(1, 127244, '\p{General_Category=number}', "");
    Expect(0, 127244, '\p{^General_Category=number}', "");
    Expect(0, 127244, '\P{General_Category=number}', "");
    Expect(1, 127244, '\P{^General_Category=number}', "");
    Expect(0, 127245, '\p{General_Category=number}', "");
    Expect(1, 127245, '\p{^General_Category=number}', "");
    Expect(1, 127245, '\P{General_Category=number}', "");
    Expect(0, 127245, '\P{^General_Category=number}', "");
    Expect(1, 127244, '\p{General_Category=:\Anumber\z:}', "");;
    Expect(0, 127245, '\p{General_Category=:\Anumber\z:}', "");;
    Expect(1, 127244, '\p{General_Category=	Number}', "");
    Expect(0, 127244, '\p{^General_Category=	Number}', "");
    Expect(0, 127244, '\P{General_Category=	Number}', "");
    Expect(1, 127244, '\P{^General_Category=	Number}', "");
    Expect(0, 127245, '\p{General_Category=	Number}', "");
    Expect(1, 127245, '\p{^General_Category=	Number}', "");
    Expect(1, 127245, '\P{General_Category=	Number}', "");
    Expect(0, 127245, '\P{^General_Category=	Number}', "");
    Error('\p{Gc=	-N:=}');
    Error('\P{Gc=	-N:=}');
    Expect(1, 127244, '\p{Gc=:\AN\z:}', "");;
    Expect(0, 127245, '\p{Gc=:\AN\z:}', "");;
    Expect(1, 127244, '\p{Gc=n}', "");
    Expect(0, 127244, '\p{^Gc=n}', "");
    Expect(0, 127244, '\P{Gc=n}', "");
    Expect(1, 127244, '\P{^Gc=n}', "");
    Expect(0, 127245, '\p{Gc=n}', "");
    Expect(1, 127245, '\p{^Gc=n}', "");
    Expect(1, 127245, '\P{Gc=n}', "");
    Expect(0, 127245, '\P{^Gc=n}', "");
    Expect(1, 127244, '\p{Gc=:\An\z:}', "");;
    Expect(0, 127245, '\p{Gc=:\An\z:}', "");;
    Expect(1, 127244, '\p{Gc=	_n}', "");
    Expect(0, 127244, '\p{^Gc=	_n}', "");
    Expect(0, 127244, '\P{Gc=	_n}', "");
    Expect(1, 127244, '\P{^Gc=	_n}', "");
    Expect(0, 127245, '\p{Gc=	_n}', "");
    Expect(1, 127245, '\p{^Gc=	_n}', "");
    Expect(1, 127245, '\P{Gc=	_n}', "");
    Expect(0, 127245, '\P{^Gc=	_n}', "");
    Error('\p{Category=:=	 Number}');
    Error('\P{Category=:=	 Number}');
    Expect(1, 127244, '\p{Category=:\ANumber\z:}', "");;
    Expect(0, 127245, '\p{Category=:\ANumber\z:}', "");;
    Expect(1, 127244, '\p{Category=number}', "");
    Expect(0, 127244, '\p{^Category=number}', "");
    Expect(0, 127244, '\P{Category=number}', "");
    Expect(1, 127244, '\P{^Category=number}', "");
    Expect(0, 127245, '\p{Category=number}', "");
    Expect(1, 127245, '\p{^Category=number}', "");
    Expect(1, 127245, '\P{Category=number}', "");
    Expect(0, 127245, '\P{^Category=number}', "");
    Expect(1, 127244, '\p{Category=:\Anumber\z:}', "");;
    Expect(0, 127245, '\p{Category=:\Anumber\z:}', "");;
    Expect(1, 127244, '\p{Category=	 number}', "");
    Expect(0, 127244, '\p{^Category=	 number}', "");
    Expect(0, 127244, '\P{Category=	 number}', "");
    Expect(1, 127244, '\P{^Category=	 number}', "");
    Expect(0, 127245, '\p{Category=	 number}', "");
    Expect(1, 127245, '\p{^Category=	 number}', "");
    Expect(1, 127245, '\P{Category=	 number}', "");
    Expect(0, 127245, '\P{^Category=	 number}', "");
    Error('\p{Is_General_Category: -/a/N}');
    Error('\P{Is_General_Category: -/a/N}');
    Expect(1, 127244, '\p{Is_General_Category=n}', "");
    Expect(0, 127244, '\p{^Is_General_Category=n}', "");
    Expect(0, 127244, '\P{Is_General_Category=n}', "");
    Expect(1, 127244, '\P{^Is_General_Category=n}', "");
    Expect(0, 127245, '\p{Is_General_Category=n}', "");
    Expect(1, 127245, '\p{^Is_General_Category=n}', "");
    Expect(1, 127245, '\P{Is_General_Category=n}', "");
    Expect(0, 127245, '\P{^Is_General_Category=n}', "");
    Expect(1, 127244, '\p{Is_General_Category=_ N}', "");
    Expect(0, 127244, '\p{^Is_General_Category=_ N}', "");
    Expect(0, 127244, '\P{Is_General_Category=_ N}', "");
    Expect(1, 127244, '\P{^Is_General_Category=_ N}', "");
    Expect(0, 127245, '\p{Is_General_Category=_ N}', "");
    Expect(1, 127245, '\p{^Is_General_Category=_ N}', "");
    Expect(1, 127245, '\P{Is_General_Category=_ N}', "");
    Expect(0, 127245, '\P{^Is_General_Category=_ N}', "");
    Error('\p{Is_Gc=_-Number/a/}');
    Error('\P{Is_Gc=_-Number/a/}');
    Expect(1, 127244, '\p{Is_Gc=number}', "");
    Expect(0, 127244, '\p{^Is_Gc=number}', "");
    Expect(0, 127244, '\P{Is_Gc=number}', "");
    Expect(1, 127244, '\P{^Is_Gc=number}', "");
    Expect(0, 127245, '\p{Is_Gc=number}', "");
    Expect(1, 127245, '\p{^Is_Gc=number}', "");
    Expect(1, 127245, '\P{Is_Gc=number}', "");
    Expect(0, 127245, '\P{^Is_Gc=number}', "");
    Expect(1, 127244, '\p{Is_Gc=  number}', "");
    Expect(0, 127244, '\p{^Is_Gc=  number}', "");
    Expect(0, 127244, '\P{Is_Gc=  number}', "");
    Expect(1, 127244, '\P{^Is_Gc=  number}', "");
    Expect(0, 127245, '\p{Is_Gc=  number}', "");
    Expect(1, 127245, '\p{^Is_Gc=  number}', "");
    Expect(1, 127245, '\P{Is_Gc=  number}', "");
    Expect(0, 127245, '\P{^Is_Gc=  number}', "");
    Error('\p{Is_Category= -N/a/}');
    Error('\P{Is_Category= -N/a/}');
    Expect(1, 127244, '\p{Is_Category=n}', "");
    Expect(0, 127244, '\p{^Is_Category=n}', "");
    Expect(0, 127244, '\P{Is_Category=n}', "");
    Expect(1, 127244, '\P{^Is_Category=n}', "");
    Expect(0, 127245, '\p{Is_Category=n}', "");
    Expect(1, 127245, '\p{^Is_Category=n}', "");
    Expect(1, 127245, '\P{Is_Category=n}', "");
    Expect(0, 127245, '\P{^Is_Category=n}', "");
    Expect(1, 127244, '\p{Is_Category=__N}', "");
    Expect(0, 127244, '\p{^Is_Category=__N}', "");
    Expect(0, 127244, '\P{Is_Category=__N}', "");
    Expect(1, 127244, '\P{^Is_Category=__N}', "");
    Expect(0, 127245, '\p{Is_Category=__N}', "");
    Expect(1, 127245, '\p{^Is_Category=__N}', "");
    Expect(1, 127245, '\P{Is_Category=__N}', "");
    Expect(0, 127245, '\P{^Is_Category=__N}', "");
    Error('\p{General_Category=:=_ decimal_Number}');
    Error('\P{General_Category=:=_ decimal_Number}');
    Expect(1, 125273, '\p{General_Category=:\ADecimal_Number\z:}', "");;
    Expect(0, 125274, '\p{General_Category=:\ADecimal_Number\z:}', "");;
    Expect(1, 125273, '\p{General_Category:decimalnumber}', "");
    Expect(0, 125273, '\p{^General_Category:decimalnumber}', "");
    Expect(0, 125273, '\P{General_Category:decimalnumber}', "");
    Expect(1, 125273, '\P{^General_Category:decimalnumber}', "");
    Expect(0, 125274, '\p{General_Category:decimalnumber}', "");
    Expect(1, 125274, '\p{^General_Category:decimalnumber}', "");
    Expect(1, 125274, '\P{General_Category:decimalnumber}', "");
    Expect(0, 125274, '\P{^General_Category:decimalnumber}', "");
    Expect(1, 125273, '\p{General_Category=:\Adecimalnumber\z:}', "");;
    Expect(0, 125274, '\p{General_Category=:\Adecimalnumber\z:}', "");;
    Expect(1, 125273, '\p{General_Category=  Decimal_Number}', "");
    Expect(0, 125273, '\p{^General_Category=  Decimal_Number}', "");
    Expect(0, 125273, '\P{General_Category=  Decimal_Number}', "");
    Expect(1, 125273, '\P{^General_Category=  Decimal_Number}', "");
    Expect(0, 125274, '\p{General_Category=  Decimal_Number}', "");
    Expect(1, 125274, '\p{^General_Category=  Decimal_Number}', "");
    Expect(1, 125274, '\P{General_Category=  Decimal_Number}', "");
    Expect(0, 125274, '\P{^General_Category=  Decimal_Number}', "");
    Error('\p{Gc:   -_Nd/a/}');
    Error('\P{Gc:   -_Nd/a/}');
    Expect(1, 125273, '\p{Gc=:\ANd\z:}', "");;
    Expect(0, 125274, '\p{Gc=:\ANd\z:}', "");;
    Expect(1, 125273, '\p{Gc=nd}', "");
    Expect(0, 125273, '\p{^Gc=nd}', "");
    Expect(0, 125273, '\P{Gc=nd}', "");
    Expect(1, 125273, '\P{^Gc=nd}', "");
    Expect(0, 125274, '\p{Gc=nd}', "");
    Expect(1, 125274, '\p{^Gc=nd}', "");
    Expect(1, 125274, '\P{Gc=nd}', "");
    Expect(0, 125274, '\P{^Gc=nd}', "");
    Expect(1, 125273, '\p{Gc=:\And\z:}', "");;
    Expect(0, 125274, '\p{Gc=:\And\z:}', "");;
    Expect(1, 125273, '\p{Gc= ND}', "");
    Expect(0, 125273, '\p{^Gc= ND}', "");
    Expect(0, 125273, '\P{Gc= ND}', "");
    Expect(1, 125273, '\P{^Gc= ND}', "");
    Expect(0, 125274, '\p{Gc= ND}', "");
    Expect(1, 125274, '\p{^Gc= ND}', "");
    Expect(1, 125274, '\P{Gc= ND}', "");
    Expect(0, 125274, '\P{^Gc= ND}', "");
    Error('\p{Category=	Digit/a/}');
    Error('\P{Category=	Digit/a/}');
    Expect(1, 125273, '\p{Category=:\ADigit\z:}', "");;
    Expect(0, 125274, '\p{Category=:\ADigit\z:}', "");;
    Expect(1, 125273, '\p{Category=digit}', "");
    Expect(0, 125273, '\p{^Category=digit}', "");
    Expect(0, 125273, '\P{Category=digit}', "");
    Expect(1, 125273, '\P{^Category=digit}', "");
    Expect(0, 125274, '\p{Category=digit}', "");
    Expect(1, 125274, '\p{^Category=digit}', "");
    Expect(1, 125274, '\P{Category=digit}', "");
    Expect(0, 125274, '\P{^Category=digit}', "");
    Expect(1, 125273, '\p{Category=:\Adigit\z:}', "");;
    Expect(0, 125274, '\p{Category=:\Adigit\z:}', "");;
    Expect(1, 125273, '\p{Category=  Digit}', "");
    Expect(0, 125273, '\p{^Category=  Digit}', "");
    Expect(0, 125273, '\P{Category=  Digit}', "");
    Expect(1, 125273, '\P{^Category=  Digit}', "");
    Expect(0, 125274, '\p{Category=  Digit}', "");
    Expect(1, 125274, '\p{^Category=  Digit}', "");
    Expect(1, 125274, '\P{Category=  Digit}', "");
    Expect(0, 125274, '\P{^Category=  Digit}', "");
    Error('\p{Is_General_Category=-/a/Decimal_Number}');
    Error('\P{Is_General_Category=-/a/Decimal_Number}');
    Expect(1, 125273, '\p{Is_General_Category=decimalnumber}', "");
    Expect(0, 125273, '\p{^Is_General_Category=decimalnumber}', "");
    Expect(0, 125273, '\P{Is_General_Category=decimalnumber}', "");
    Expect(1, 125273, '\P{^Is_General_Category=decimalnumber}', "");
    Expect(0, 125274, '\p{Is_General_Category=decimalnumber}', "");
    Expect(1, 125274, '\p{^Is_General_Category=decimalnumber}', "");
    Expect(1, 125274, '\P{Is_General_Category=decimalnumber}', "");
    Expect(0, 125274, '\P{^Is_General_Category=decimalnumber}', "");
    Expect(1, 125273, '\p{Is_General_Category=--Decimal_Number}', "");
    Expect(0, 125273, '\p{^Is_General_Category=--Decimal_Number}', "");
    Expect(0, 125273, '\P{Is_General_Category=--Decimal_Number}', "");
    Expect(1, 125273, '\P{^Is_General_Category=--Decimal_Number}', "");
    Expect(0, 125274, '\p{Is_General_Category=--Decimal_Number}', "");
    Expect(1, 125274, '\p{^Is_General_Category=--Decimal_Number}', "");
    Expect(1, 125274, '\P{Is_General_Category=--Decimal_Number}', "");
    Expect(0, 125274, '\P{^Is_General_Category=--Decimal_Number}', "");
    Error('\p{Is_Gc=_:=Nd}');
    Error('\P{Is_Gc=_:=Nd}');
    Expect(1, 125273, '\p{Is_Gc=nd}', "");
    Expect(0, 125273, '\p{^Is_Gc=nd}', "");
    Expect(0, 125273, '\P{Is_Gc=nd}', "");
    Expect(1, 125273, '\P{^Is_Gc=nd}', "");
    Expect(0, 125274, '\p{Is_Gc=nd}', "");
    Expect(1, 125274, '\p{^Is_Gc=nd}', "");
    Expect(1, 125274, '\P{Is_Gc=nd}', "");
    Expect(0, 125274, '\P{^Is_Gc=nd}', "");
    Expect(1, 125273, '\p{Is_Gc= _Nd}', "");
    Expect(0, 125273, '\p{^Is_Gc= _Nd}', "");
    Expect(0, 125273, '\P{Is_Gc= _Nd}', "");
    Expect(1, 125273, '\P{^Is_Gc= _Nd}', "");
    Expect(0, 125274, '\p{Is_Gc= _Nd}', "");
    Expect(1, 125274, '\p{^Is_Gc= _Nd}', "");
    Expect(1, 125274, '\P{Is_Gc= _Nd}', "");
    Expect(0, 125274, '\P{^Is_Gc= _Nd}', "");
    Error('\p{Is_Category=:=  Digit}');
    Error('\P{Is_Category=:=  Digit}');
    Expect(1, 125273, '\p{Is_Category=digit}', "");
    Expect(0, 125273, '\p{^Is_Category=digit}', "");
    Expect(0, 125273, '\P{Is_Category=digit}', "");
    Expect(1, 125273, '\P{^Is_Category=digit}', "");
    Expect(0, 125274, '\p{Is_Category=digit}', "");
    Expect(1, 125274, '\p{^Is_Category=digit}', "");
    Expect(1, 125274, '\P{Is_Category=digit}', "");
    Expect(0, 125274, '\P{^Is_Category=digit}', "");
    Expect(1, 125273, '\p{Is_Category=	 DIGIT}', "");
    Expect(0, 125273, '\p{^Is_Category=	 DIGIT}', "");
    Expect(0, 125273, '\P{Is_Category=	 DIGIT}', "");
    Expect(1, 125273, '\P{^Is_Category=	 DIGIT}', "");
    Expect(0, 125274, '\p{Is_Category=	 DIGIT}', "");
    Expect(1, 125274, '\p{^Is_Category=	 DIGIT}', "");
    Expect(1, 125274, '\P{Is_Category=	 DIGIT}', "");
    Expect(0, 125274, '\P{^Is_Category=	 DIGIT}', "");
    Error('\p{General_Category= :=Letter_Number}');
    Error('\P{General_Category= :=Letter_Number}');
    Expect(1, 74862, '\p{General_Category=:\ALetter_Number\z:}', "");;
    Expect(0, 74863, '\p{General_Category=:\ALetter_Number\z:}', "");;
    Expect(1, 74862, '\p{General_Category=letternumber}', "");
    Expect(0, 74862, '\p{^General_Category=letternumber}', "");
    Expect(0, 74862, '\P{General_Category=letternumber}', "");
    Expect(1, 74862, '\P{^General_Category=letternumber}', "");
    Expect(0, 74863, '\p{General_Category=letternumber}', "");
    Expect(1, 74863, '\p{^General_Category=letternumber}', "");
    Expect(1, 74863, '\P{General_Category=letternumber}', "");
    Expect(0, 74863, '\P{^General_Category=letternumber}', "");
    Expect(1, 74862, '\p{General_Category=:\Aletternumber\z:}', "");;
    Expect(0, 74863, '\p{General_Category=:\Aletternumber\z:}', "");;
    Expect(1, 74862, '\p{General_Category=	letter_NUMBER}', "");
    Expect(0, 74862, '\p{^General_Category=	letter_NUMBER}', "");
    Expect(0, 74862, '\P{General_Category=	letter_NUMBER}', "");
    Expect(1, 74862, '\P{^General_Category=	letter_NUMBER}', "");
    Expect(0, 74863, '\p{General_Category=	letter_NUMBER}', "");
    Expect(1, 74863, '\p{^General_Category=	letter_NUMBER}', "");
    Expect(1, 74863, '\P{General_Category=	letter_NUMBER}', "");
    Expect(0, 74863, '\P{^General_Category=	letter_NUMBER}', "");
    Error('\p{Gc= nl/a/}');
    Error('\P{Gc= nl/a/}');
    Expect(1, 74862, '\p{Gc=:\ANl\z:}', "");;
    Expect(0, 74863, '\p{Gc=:\ANl\z:}', "");;
    Expect(1, 74862, '\p{Gc=nl}', "");
    Expect(0, 74862, '\p{^Gc=nl}', "");
    Expect(0, 74862, '\P{Gc=nl}', "");
    Expect(1, 74862, '\P{^Gc=nl}', "");
    Expect(0, 74863, '\p{Gc=nl}', "");
    Expect(1, 74863, '\p{^Gc=nl}', "");
    Expect(1, 74863, '\P{Gc=nl}', "");
    Expect(0, 74863, '\P{^Gc=nl}', "");
    Expect(1, 74862, '\p{Gc=:\Anl\z:}', "");;
    Expect(0, 74863, '\p{Gc=:\Anl\z:}', "");;
    Expect(1, 74862, '\p{Gc=- NL}', "");
    Expect(0, 74862, '\p{^Gc=- NL}', "");
    Expect(0, 74862, '\P{Gc=- NL}', "");
    Expect(1, 74862, '\P{^Gc=- NL}', "");
    Expect(0, 74863, '\p{Gc=- NL}', "");
    Expect(1, 74863, '\p{^Gc=- NL}', "");
    Expect(1, 74863, '\P{Gc=- NL}', "");
    Expect(0, 74863, '\P{^Gc=- NL}', "");
    Error('\p{Category=:=- Letter_Number}');
    Error('\P{Category=:=- Letter_Number}');
    Expect(1, 74862, '\p{Category=:\ALetter_Number\z:}', "");;
    Expect(0, 74863, '\p{Category=:\ALetter_Number\z:}', "");;
    Expect(1, 74862, '\p{Category:   letternumber}', "");
    Expect(0, 74862, '\p{^Category:   letternumber}', "");
    Expect(0, 74862, '\P{Category:   letternumber}', "");
    Expect(1, 74862, '\P{^Category:   letternumber}', "");
    Expect(0, 74863, '\p{Category:   letternumber}', "");
    Expect(1, 74863, '\p{^Category:   letternumber}', "");
    Expect(1, 74863, '\P{Category:   letternumber}', "");
    Expect(0, 74863, '\P{^Category:   letternumber}', "");
    Expect(1, 74862, '\p{Category=:\Aletternumber\z:}', "");;
    Expect(0, 74863, '\p{Category=:\Aletternumber\z:}', "");;
    Expect(1, 74862, '\p{Category=	_LETTER_Number}', "");
    Expect(0, 74862, '\p{^Category=	_LETTER_Number}', "");
    Expect(0, 74862, '\P{Category=	_LETTER_Number}', "");
    Expect(1, 74862, '\P{^Category=	_LETTER_Number}', "");
    Expect(0, 74863, '\p{Category=	_LETTER_Number}', "");
    Expect(1, 74863, '\p{^Category=	_LETTER_Number}', "");
    Expect(1, 74863, '\P{Category=	_LETTER_Number}', "");
    Expect(0, 74863, '\P{^Category=	_LETTER_Number}', "");
    Error('\p{Is_General_Category=/a/		NL}');
    Error('\P{Is_General_Category=/a/		NL}');
    Expect(1, 74862, '\p{Is_General_Category=nl}', "");
    Expect(0, 74862, '\p{^Is_General_Category=nl}', "");
    Expect(0, 74862, '\P{Is_General_Category=nl}', "");
    Expect(1, 74862, '\P{^Is_General_Category=nl}', "");
    Expect(0, 74863, '\p{Is_General_Category=nl}', "");
    Expect(1, 74863, '\p{^Is_General_Category=nl}', "");
    Expect(1, 74863, '\P{Is_General_Category=nl}', "");
    Expect(0, 74863, '\P{^Is_General_Category=nl}', "");
    Expect(1, 74862, '\p{Is_General_Category= NL}', "");
    Expect(0, 74862, '\p{^Is_General_Category= NL}', "");
    Expect(0, 74862, '\P{Is_General_Category= NL}', "");
    Expect(1, 74862, '\P{^Is_General_Category= NL}', "");
    Expect(0, 74863, '\p{Is_General_Category= NL}', "");
    Expect(1, 74863, '\p{^Is_General_Category= NL}', "");
    Expect(1, 74863, '\P{Is_General_Category= NL}', "");
    Expect(0, 74863, '\P{^Is_General_Category= NL}', "");
    Error('\p{Is_Gc=:=	Letter_Number}');
    Error('\P{Is_Gc=:=	Letter_Number}');
    Expect(1, 74862, '\p{Is_Gc=letternumber}', "");
    Expect(0, 74862, '\p{^Is_Gc=letternumber}', "");
    Expect(0, 74862, '\P{Is_Gc=letternumber}', "");
    Expect(1, 74862, '\P{^Is_Gc=letternumber}', "");
    Expect(0, 74863, '\p{Is_Gc=letternumber}', "");
    Expect(1, 74863, '\p{^Is_Gc=letternumber}', "");
    Expect(1, 74863, '\P{Is_Gc=letternumber}', "");
    Expect(0, 74863, '\P{^Is_Gc=letternumber}', "");
    Expect(1, 74862, '\p{Is_Gc=-_Letter_number}', "");
    Expect(0, 74862, '\p{^Is_Gc=-_Letter_number}', "");
    Expect(0, 74862, '\P{Is_Gc=-_Letter_number}', "");
    Expect(1, 74862, '\P{^Is_Gc=-_Letter_number}', "");
    Expect(0, 74863, '\p{Is_Gc=-_Letter_number}', "");
    Expect(1, 74863, '\p{^Is_Gc=-_Letter_number}', "");
    Expect(1, 74863, '\P{Is_Gc=-_Letter_number}', "");
    Expect(0, 74863, '\P{^Is_Gc=-_Letter_number}', "");
    Error('\p{Is_Category=/a/_Nl}');
    Error('\P{Is_Category=/a/_Nl}');
    Expect(1, 74862, '\p{Is_Category=nl}', "");
    Expect(0, 74862, '\p{^Is_Category=nl}', "");
    Expect(0, 74862, '\P{Is_Category=nl}', "");
    Expect(1, 74862, '\P{^Is_Category=nl}', "");
    Expect(0, 74863, '\p{Is_Category=nl}', "");
    Expect(1, 74863, '\p{^Is_Category=nl}', "");
    Expect(1, 74863, '\P{Is_Category=nl}', "");
    Expect(0, 74863, '\P{^Is_Category=nl}', "");
    Expect(1, 74862, '\p{Is_Category=_	Nl}', "");
    Expect(0, 74862, '\p{^Is_Category=_	Nl}', "");
    Expect(0, 74862, '\P{Is_Category=_	Nl}', "");
    Expect(1, 74862, '\P{^Is_Category=_	Nl}', "");
    Expect(0, 74863, '\p{Is_Category=_	Nl}', "");
    Expect(1, 74863, '\p{^Is_Category=_	Nl}', "");
    Expect(1, 74863, '\P{Is_Category=_	Nl}', "");
    Expect(0, 74863, '\P{^Is_Category=_	Nl}', "");
    Error('\p{General_Category=_-OTHER_NUMBER/a/}');
    Error('\P{General_Category=_-OTHER_NUMBER/a/}');
    Expect(1, 127244, '\p{General_Category=:\AOther_Number\z:}', "");;
    Expect(0, 127245, '\p{General_Category=:\AOther_Number\z:}', "");;
    Expect(1, 127244, '\p{General_Category=othernumber}', "");
    Expect(0, 127244, '\p{^General_Category=othernumber}', "");
    Expect(0, 127244, '\P{General_Category=othernumber}', "");
    Expect(1, 127244, '\P{^General_Category=othernumber}', "");
    Expect(0, 127245, '\p{General_Category=othernumber}', "");
    Expect(1, 127245, '\p{^General_Category=othernumber}', "");
    Expect(1, 127245, '\P{General_Category=othernumber}', "");
    Expect(0, 127245, '\P{^General_Category=othernumber}', "");
    Expect(1, 127244, '\p{General_Category=:\Aothernumber\z:}', "");;
    Expect(0, 127245, '\p{General_Category=:\Aothernumber\z:}', "");;
    Expect(1, 127244, '\p{General_Category:   _other_Number}', "");
    Expect(0, 127244, '\p{^General_Category:   _other_Number}', "");
    Expect(0, 127244, '\P{General_Category:   _other_Number}', "");
    Expect(1, 127244, '\P{^General_Category:   _other_Number}', "");
    Expect(0, 127245, '\p{General_Category:   _other_Number}', "");
    Expect(1, 127245, '\p{^General_Category:   _other_Number}', "");
    Expect(1, 127245, '\P{General_Category:   _other_Number}', "");
    Expect(0, 127245, '\P{^General_Category:   _other_Number}', "");
    Error('\p{Gc=_:=NO}');
    Error('\P{Gc=_:=NO}');
    Expect(1, 127244, '\p{Gc=:\ANo\z:}', "");;
    Expect(0, 127245, '\p{Gc=:\ANo\z:}', "");;
    Expect(1, 127244, '\p{Gc=no}', "");
    Expect(0, 127244, '\p{^Gc=no}', "");
    Expect(0, 127244, '\P{Gc=no}', "");
    Expect(1, 127244, '\P{^Gc=no}', "");
    Expect(0, 127245, '\p{Gc=no}', "");
    Expect(1, 127245, '\p{^Gc=no}', "");
    Expect(1, 127245, '\P{Gc=no}', "");
    Expect(0, 127245, '\P{^Gc=no}', "");
    Expect(1, 127244, '\p{Gc=:\Ano\z:}', "");;
    Expect(0, 127245, '\p{Gc=:\Ano\z:}', "");;
    Expect(1, 127244, '\p{Gc=_	No}', "");
    Expect(0, 127244, '\p{^Gc=_	No}', "");
    Expect(0, 127244, '\P{Gc=_	No}', "");
    Expect(1, 127244, '\P{^Gc=_	No}', "");
    Expect(0, 127245, '\p{Gc=_	No}', "");
    Expect(1, 127245, '\p{^Gc=_	No}', "");
    Expect(1, 127245, '\P{Gc=_	No}', "");
    Expect(0, 127245, '\P{^Gc=_	No}', "");
    Error('\p{Category=:=		Other_number}');
    Error('\P{Category=:=		Other_number}');
    Expect(1, 127244, '\p{Category=:\AOther_Number\z:}', "");;
    Expect(0, 127245, '\p{Category=:\AOther_Number\z:}', "");;
    Expect(1, 127244, '\p{Category=othernumber}', "");
    Expect(0, 127244, '\p{^Category=othernumber}', "");
    Expect(0, 127244, '\P{Category=othernumber}', "");
    Expect(1, 127244, '\P{^Category=othernumber}', "");
    Expect(0, 127245, '\p{Category=othernumber}', "");
    Expect(1, 127245, '\p{^Category=othernumber}', "");
    Expect(1, 127245, '\P{Category=othernumber}', "");
    Expect(0, 127245, '\P{^Category=othernumber}', "");
    Expect(1, 127244, '\p{Category=:\Aothernumber\z:}', "");;
    Expect(0, 127245, '\p{Category=:\Aothernumber\z:}', "");;
    Expect(1, 127244, '\p{Category=		Other_Number}', "");
    Expect(0, 127244, '\p{^Category=		Other_Number}', "");
    Expect(0, 127244, '\P{Category=		Other_Number}', "");
    Expect(1, 127244, '\P{^Category=		Other_Number}', "");
    Expect(0, 127245, '\p{Category=		Other_Number}', "");
    Expect(1, 127245, '\p{^Category=		Other_Number}', "");
    Expect(1, 127245, '\P{Category=		Other_Number}', "");
    Expect(0, 127245, '\P{^Category=		Other_Number}', "");
    Error('\p{Is_General_Category=:=__no}');
    Error('\P{Is_General_Category=:=__no}');
    Expect(1, 127244, '\p{Is_General_Category:no}', "");
    Expect(0, 127244, '\p{^Is_General_Category:no}', "");
    Expect(0, 127244, '\P{Is_General_Category:no}', "");
    Expect(1, 127244, '\P{^Is_General_Category:no}', "");
    Expect(0, 127245, '\p{Is_General_Category:no}', "");
    Expect(1, 127245, '\p{^Is_General_Category:no}', "");
    Expect(1, 127245, '\P{Is_General_Category:no}', "");
    Expect(0, 127245, '\P{^Is_General_Category:no}', "");
    Expect(1, 127244, '\p{Is_General_Category=-_No}', "");
    Expect(0, 127244, '\p{^Is_General_Category=-_No}', "");
    Expect(0, 127244, '\P{Is_General_Category=-_No}', "");
    Expect(1, 127244, '\P{^Is_General_Category=-_No}', "");
    Expect(0, 127245, '\p{Is_General_Category=-_No}', "");
    Expect(1, 127245, '\p{^Is_General_Category=-_No}', "");
    Expect(1, 127245, '\P{Is_General_Category=-_No}', "");
    Expect(0, 127245, '\P{^Is_General_Category=-_No}', "");
    Error('\p{Is_Gc=	:=OTHER_NUMBER}');
    Error('\P{Is_Gc=	:=OTHER_NUMBER}');
    Expect(1, 127244, '\p{Is_Gc=othernumber}', "");
    Expect(0, 127244, '\p{^Is_Gc=othernumber}', "");
    Expect(0, 127244, '\P{Is_Gc=othernumber}', "");
    Expect(1, 127244, '\P{^Is_Gc=othernumber}', "");
    Expect(0, 127245, '\p{Is_Gc=othernumber}', "");
    Expect(1, 127245, '\p{^Is_Gc=othernumber}', "");
    Expect(1, 127245, '\P{Is_Gc=othernumber}', "");
    Expect(0, 127245, '\P{^Is_Gc=othernumber}', "");
    Expect(1, 127244, '\p{Is_Gc=  other_NUMBER}', "");
    Expect(0, 127244, '\p{^Is_Gc=  other_NUMBER}', "");
    Expect(0, 127244, '\P{Is_Gc=  other_NUMBER}', "");
    Expect(1, 127244, '\P{^Is_Gc=  other_NUMBER}', "");
    Expect(0, 127245, '\p{Is_Gc=  other_NUMBER}', "");
    Expect(1, 127245, '\p{^Is_Gc=  other_NUMBER}', "");
    Expect(1, 127245, '\P{Is_Gc=  other_NUMBER}', "");
    Expect(0, 127245, '\P{^Is_Gc=  other_NUMBER}', "");
    Error('\p{Is_Category:/a/ no}');
    Error('\P{Is_Category:/a/ no}');
    Expect(1, 127244, '\p{Is_Category=no}', "");
    Expect(0, 127244, '\p{^Is_Category=no}', "");
    Expect(0, 127244, '\P{Is_Category=no}', "");
    Expect(1, 127244, '\P{^Is_Category=no}', "");
    Expect(0, 127245, '\p{Is_Category=no}', "");
    Expect(1, 127245, '\p{^Is_Category=no}', "");
    Expect(1, 127245, '\P{Is_Category=no}', "");
    Expect(0, 127245, '\P{^Is_Category=no}', "");
    Expect(1, 127244, '\p{Is_Category=--NO}', "");
    Expect(0, 127244, '\p{^Is_Category=--NO}', "");
    Expect(0, 127244, '\P{Is_Category=--NO}', "");
    Expect(1, 127244, '\P{^Is_Category=--NO}', "");
    Expect(0, 127245, '\p{Is_Category=--NO}', "");
    Expect(1, 127245, '\p{^Is_Category=--NO}', "");
    Expect(1, 127245, '\P{Is_Category=--NO}', "");
    Expect(0, 127245, '\P{^Is_Category=--NO}', "");
    Error('\p{General_Category=-:=punctuation}');
    Error('\P{General_Category=-:=punctuation}');
    Expect(1, 125279, '\p{General_Category=:\APunctuation\z:}', "");;
    Expect(0, 125280, '\p{General_Category=:\APunctuation\z:}', "");;
    Expect(1, 125279, '\p{General_Category=punctuation}', "");
    Expect(0, 125279, '\p{^General_Category=punctuation}', "");
    Expect(0, 125279, '\P{General_Category=punctuation}', "");
    Expect(1, 125279, '\P{^General_Category=punctuation}', "");
    Expect(0, 125280, '\p{General_Category=punctuation}', "");
    Expect(1, 125280, '\p{^General_Category=punctuation}', "");
    Expect(1, 125280, '\P{General_Category=punctuation}', "");
    Expect(0, 125280, '\P{^General_Category=punctuation}', "");
    Expect(1, 125279, '\p{General_Category=:\Apunctuation\z:}', "");;
    Expect(0, 125280, '\p{General_Category=:\Apunctuation\z:}', "");;
    Expect(1, 125279, '\p{General_Category=	Punctuation}', "");
    Expect(0, 125279, '\p{^General_Category=	Punctuation}', "");
    Expect(0, 125279, '\P{General_Category=	Punctuation}', "");
    Expect(1, 125279, '\P{^General_Category=	Punctuation}', "");
    Expect(0, 125280, '\p{General_Category=	Punctuation}', "");
    Expect(1, 125280, '\p{^General_Category=	Punctuation}', "");
    Expect(1, 125280, '\P{General_Category=	Punctuation}', "");
    Expect(0, 125280, '\P{^General_Category=	Punctuation}', "");
    Error('\p{Gc=__p:=}');
    Error('\P{Gc=__p:=}');
    Expect(1, 125279, '\p{Gc=:\AP\z:}', "");;
    Expect(0, 125280, '\p{Gc=:\AP\z:}', "");;
    Expect(1, 125279, '\p{Gc=p}', "");
    Expect(0, 125279, '\p{^Gc=p}', "");
    Expect(0, 125279, '\P{Gc=p}', "");
    Expect(1, 125279, '\P{^Gc=p}', "");
    Expect(0, 125280, '\p{Gc=p}', "");
    Expect(1, 125280, '\p{^Gc=p}', "");
    Expect(1, 125280, '\P{Gc=p}', "");
    Expect(0, 125280, '\P{^Gc=p}', "");
    Expect(1, 125279, '\p{Gc=:\Ap\z:}', "");;
    Expect(0, 125280, '\p{Gc=:\Ap\z:}', "");;
    Expect(1, 125279, '\p{Gc=--p}', "");
    Expect(0, 125279, '\p{^Gc=--p}', "");
    Expect(0, 125279, '\P{Gc=--p}', "");
    Expect(1, 125279, '\P{^Gc=--p}', "");
    Expect(0, 125280, '\p{Gc=--p}', "");
    Expect(1, 125280, '\p{^Gc=--p}', "");
    Expect(1, 125280, '\P{Gc=--p}', "");
    Expect(0, 125280, '\P{^Gc=--p}', "");
    Error('\p{Category=  PUNCT/a/}');
    Error('\P{Category=  PUNCT/a/}');
    Expect(1, 125279, '\p{Category=:\APunct\z:}', "");;
    Expect(0, 125280, '\p{Category=:\APunct\z:}', "");;
    Expect(1, 125279, '\p{Category=punct}', "");
    Expect(0, 125279, '\p{^Category=punct}', "");
    Expect(0, 125279, '\P{Category=punct}', "");
    Expect(1, 125279, '\P{^Category=punct}', "");
    Expect(0, 125280, '\p{Category=punct}', "");
    Expect(1, 125280, '\p{^Category=punct}', "");
    Expect(1, 125280, '\P{Category=punct}', "");
    Expect(0, 125280, '\P{^Category=punct}', "");
    Expect(1, 125279, '\p{Category=:\Apunct\z:}', "");;
    Expect(0, 125280, '\p{Category=:\Apunct\z:}', "");;
    Expect(1, 125279, '\p{Category= punct}', "");
    Expect(0, 125279, '\p{^Category= punct}', "");
    Expect(0, 125279, '\P{Category= punct}', "");
    Expect(1, 125279, '\P{^Category= punct}', "");
    Expect(0, 125280, '\p{Category= punct}', "");
    Expect(1, 125280, '\p{^Category= punct}', "");
    Expect(1, 125280, '\P{Category= punct}', "");
    Expect(0, 125280, '\P{^Category= punct}', "");
    Error('\p{Is_General_Category=:=punctuation}');
    Error('\P{Is_General_Category=:=punctuation}');
    Expect(1, 125279, '\p{Is_General_Category=punctuation}', "");
    Expect(0, 125279, '\p{^Is_General_Category=punctuation}', "");
    Expect(0, 125279, '\P{Is_General_Category=punctuation}', "");
    Expect(1, 125279, '\P{^Is_General_Category=punctuation}', "");
    Expect(0, 125280, '\p{Is_General_Category=punctuation}', "");
    Expect(1, 125280, '\p{^Is_General_Category=punctuation}', "");
    Expect(1, 125280, '\P{Is_General_Category=punctuation}', "");
    Expect(0, 125280, '\P{^Is_General_Category=punctuation}', "");
    Expect(1, 125279, '\p{Is_General_Category= Punctuation}', "");
    Expect(0, 125279, '\p{^Is_General_Category= Punctuation}', "");
    Expect(0, 125279, '\P{Is_General_Category= Punctuation}', "");
    Expect(1, 125279, '\P{^Is_General_Category= Punctuation}', "");
    Expect(0, 125280, '\p{Is_General_Category= Punctuation}', "");
    Expect(1, 125280, '\p{^Is_General_Category= Punctuation}', "");
    Expect(1, 125280, '\P{Is_General_Category= Punctuation}', "");
    Expect(0, 125280, '\P{^Is_General_Category= Punctuation}', "");
    Error('\p{Is_Gc=:=-P}');
    Error('\P{Is_Gc=:=-P}');
    Expect(1, 125279, '\p{Is_Gc=p}', "");
    Expect(0, 125279, '\p{^Is_Gc=p}', "");
    Expect(0, 125279, '\P{Is_Gc=p}', "");
    Expect(1, 125279, '\P{^Is_Gc=p}', "");
    Expect(0, 125280, '\p{Is_Gc=p}', "");
    Expect(1, 125280, '\p{^Is_Gc=p}', "");
    Expect(1, 125280, '\P{Is_Gc=p}', "");
    Expect(0, 125280, '\P{^Is_Gc=p}', "");
    Expect(1, 125279, '\p{Is_Gc=--P}', "");
    Expect(0, 125279, '\p{^Is_Gc=--P}', "");
    Expect(0, 125279, '\P{Is_Gc=--P}', "");
    Expect(1, 125279, '\P{^Is_Gc=--P}', "");
    Expect(0, 125280, '\p{Is_Gc=--P}', "");
    Expect(1, 125280, '\p{^Is_Gc=--P}', "");
    Expect(1, 125280, '\P{Is_Gc=--P}', "");
    Expect(0, 125280, '\P{^Is_Gc=--P}', "");
    Error('\p{Is_Category=:= -Punct}');
    Error('\P{Is_Category=:= -Punct}');
    Expect(1, 125279, '\p{Is_Category=punct}', "");
    Expect(0, 125279, '\p{^Is_Category=punct}', "");
    Expect(0, 125279, '\P{Is_Category=punct}', "");
    Expect(1, 125279, '\P{^Is_Category=punct}', "");
    Expect(0, 125280, '\p{Is_Category=punct}', "");
    Expect(1, 125280, '\p{^Is_Category=punct}', "");
    Expect(1, 125280, '\P{Is_Category=punct}', "");
    Expect(0, 125280, '\P{^Is_Category=punct}', "");
    Expect(1, 125279, '\p{Is_Category= -Punct}', "");
    Expect(0, 125279, '\p{^Is_Category= -Punct}', "");
    Expect(0, 125279, '\P{Is_Category= -Punct}', "");
    Expect(1, 125279, '\P{^Is_Category= -Punct}', "");
    Expect(0, 125280, '\p{Is_Category= -Punct}', "");
    Expect(1, 125280, '\p{^Is_Category= -Punct}', "");
    Expect(1, 125280, '\P{Is_Category= -Punct}', "");
    Expect(0, 125280, '\P{^Is_Category= -Punct}', "");
    Error('\p{General_Category=:= CONNECTOR_PUNCTUATION}');
    Error('\P{General_Category=:= CONNECTOR_PUNCTUATION}');
    Expect(1, 65343, '\p{General_Category=:\AConnector_Punctuation\z:}', "");;
    Expect(0, 65344, '\p{General_Category=:\AConnector_Punctuation\z:}', "");;
    Expect(1, 65343, '\p{General_Category=connectorpunctuation}', "");
    Expect(0, 65343, '\p{^General_Category=connectorpunctuation}', "");
    Expect(0, 65343, '\P{General_Category=connectorpunctuation}', "");
    Expect(1, 65343, '\P{^General_Category=connectorpunctuation}', "");
    Expect(0, 65344, '\p{General_Category=connectorpunctuation}', "");
    Expect(1, 65344, '\p{^General_Category=connectorpunctuation}', "");
    Expect(1, 65344, '\P{General_Category=connectorpunctuation}', "");
    Expect(0, 65344, '\P{^General_Category=connectorpunctuation}', "");
    Expect(1, 65343, '\p{General_Category=:\Aconnectorpunctuation\z:}', "");;
    Expect(0, 65344, '\p{General_Category=:\Aconnectorpunctuation\z:}', "");;
    Expect(1, 65343, '\p{General_Category=_Connector_PUNCTUATION}', "");
    Expect(0, 65343, '\p{^General_Category=_Connector_PUNCTUATION}', "");
    Expect(0, 65343, '\P{General_Category=_Connector_PUNCTUATION}', "");
    Expect(1, 65343, '\P{^General_Category=_Connector_PUNCTUATION}', "");
    Expect(0, 65344, '\p{General_Category=_Connector_PUNCTUATION}', "");
    Expect(1, 65344, '\p{^General_Category=_Connector_PUNCTUATION}', "");
    Expect(1, 65344, '\P{General_Category=_Connector_PUNCTUATION}', "");
    Expect(0, 65344, '\P{^General_Category=_Connector_PUNCTUATION}', "");
    Error('\p{Gc=-Pc/a/}');
    Error('\P{Gc=-Pc/a/}');
    Expect(1, 65343, '\p{Gc=:\APc\z:}', "");;
    Expect(0, 65344, '\p{Gc=:\APc\z:}', "");;
    Expect(1, 65343, '\p{Gc=pc}', "");
    Expect(0, 65343, '\p{^Gc=pc}', "");
    Expect(0, 65343, '\P{Gc=pc}', "");
    Expect(1, 65343, '\P{^Gc=pc}', "");
    Expect(0, 65344, '\p{Gc=pc}', "");
    Expect(1, 65344, '\p{^Gc=pc}', "");
    Expect(1, 65344, '\P{Gc=pc}', "");
    Expect(0, 65344, '\P{^Gc=pc}', "");
    Expect(1, 65343, '\p{Gc=:\Apc\z:}', "");;
    Expect(0, 65344, '\p{Gc=:\Apc\z:}', "");;
    Expect(1, 65343, '\p{Gc=	Pc}', "");
    Expect(0, 65343, '\p{^Gc=	Pc}', "");
    Expect(0, 65343, '\P{Gc=	Pc}', "");
    Expect(1, 65343, '\P{^Gc=	Pc}', "");
    Expect(0, 65344, '\p{Gc=	Pc}', "");
    Expect(1, 65344, '\p{^Gc=	Pc}', "");
    Expect(1, 65344, '\P{Gc=	Pc}', "");
    Expect(0, 65344, '\P{^Gc=	Pc}', "");
    Error('\p{Category=	 CONNECTOR_punctuation:=}');
    Error('\P{Category=	 CONNECTOR_punctuation:=}');
    Expect(1, 65343, '\p{Category=:\AConnector_Punctuation\z:}', "");;
    Expect(0, 65344, '\p{Category=:\AConnector_Punctuation\z:}', "");;
    Expect(1, 65343, '\p{Category:   connectorpunctuation}', "");
    Expect(0, 65343, '\p{^Category:   connectorpunctuation}', "");
    Expect(0, 65343, '\P{Category:   connectorpunctuation}', "");
    Expect(1, 65343, '\P{^Category:   connectorpunctuation}', "");
    Expect(0, 65344, '\p{Category:   connectorpunctuation}', "");
    Expect(1, 65344, '\p{^Category:   connectorpunctuation}', "");
    Expect(1, 65344, '\P{Category:   connectorpunctuation}', "");
    Expect(0, 65344, '\P{^Category:   connectorpunctuation}', "");
    Expect(1, 65343, '\p{Category=:\Aconnectorpunctuation\z:}', "");;
    Expect(0, 65344, '\p{Category=:\Aconnectorpunctuation\z:}', "");;
    Expect(1, 65343, '\p{Category=		Connector_PUNCTUATION}', "");
    Expect(0, 65343, '\p{^Category=		Connector_PUNCTUATION}', "");
    Expect(0, 65343, '\P{Category=		Connector_PUNCTUATION}', "");
    Expect(1, 65343, '\P{^Category=		Connector_PUNCTUATION}', "");
    Expect(0, 65344, '\p{Category=		Connector_PUNCTUATION}', "");
    Expect(1, 65344, '\p{^Category=		Connector_PUNCTUATION}', "");
    Expect(1, 65344, '\P{Category=		Connector_PUNCTUATION}', "");
    Expect(0, 65344, '\P{^Category=		Connector_PUNCTUATION}', "");
    Error('\p{Is_General_Category=:=Pc}');
    Error('\P{Is_General_Category=:=Pc}');
    Expect(1, 65343, '\p{Is_General_Category=pc}', "");
    Expect(0, 65343, '\p{^Is_General_Category=pc}', "");
    Expect(0, 65343, '\P{Is_General_Category=pc}', "");
    Expect(1, 65343, '\P{^Is_General_Category=pc}', "");
    Expect(0, 65344, '\p{Is_General_Category=pc}', "");
    Expect(1, 65344, '\p{^Is_General_Category=pc}', "");
    Expect(1, 65344, '\P{Is_General_Category=pc}', "");
    Expect(0, 65344, '\P{^Is_General_Category=pc}', "");
    Expect(1, 65343, '\p{Is_General_Category= PC}', "");
    Expect(0, 65343, '\p{^Is_General_Category= PC}', "");
    Expect(0, 65343, '\P{Is_General_Category= PC}', "");
    Expect(1, 65343, '\P{^Is_General_Category= PC}', "");
    Expect(0, 65344, '\p{Is_General_Category= PC}', "");
    Expect(1, 65344, '\p{^Is_General_Category= PC}', "");
    Expect(1, 65344, '\P{Is_General_Category= PC}', "");
    Expect(0, 65344, '\P{^Is_General_Category= PC}', "");
    Error('\p{Is_Gc=/a/-connector_punctuation}');
    Error('\P{Is_Gc=/a/-connector_punctuation}');
    Expect(1, 65343, '\p{Is_Gc=connectorpunctuation}', "");
    Expect(0, 65343, '\p{^Is_Gc=connectorpunctuation}', "");
    Expect(0, 65343, '\P{Is_Gc=connectorpunctuation}', "");
    Expect(1, 65343, '\P{^Is_Gc=connectorpunctuation}', "");
    Expect(0, 65344, '\p{Is_Gc=connectorpunctuation}', "");
    Expect(1, 65344, '\p{^Is_Gc=connectorpunctuation}', "");
    Expect(1, 65344, '\P{Is_Gc=connectorpunctuation}', "");
    Expect(0, 65344, '\P{^Is_Gc=connectorpunctuation}', "");
    Expect(1, 65343, '\p{Is_Gc:_	Connector_punctuation}', "");
    Expect(0, 65343, '\p{^Is_Gc:_	Connector_punctuation}', "");
    Expect(0, 65343, '\P{Is_Gc:_	Connector_punctuation}', "");
    Expect(1, 65343, '\P{^Is_Gc:_	Connector_punctuation}', "");
    Expect(0, 65344, '\p{Is_Gc:_	Connector_punctuation}', "");
    Expect(1, 65344, '\p{^Is_Gc:_	Connector_punctuation}', "");
    Expect(1, 65344, '\P{Is_Gc:_	Connector_punctuation}', "");
    Expect(0, 65344, '\P{^Is_Gc:_	Connector_punctuation}', "");
    Error('\p{Is_Category=-	pc/a/}');
    Error('\P{Is_Category=-	pc/a/}');
    Expect(1, 65343, '\p{Is_Category=pc}', "");
    Expect(0, 65343, '\p{^Is_Category=pc}', "");
    Expect(0, 65343, '\P{Is_Category=pc}', "");
    Expect(1, 65343, '\P{^Is_Category=pc}', "");
    Expect(0, 65344, '\p{Is_Category=pc}', "");
    Expect(1, 65344, '\p{^Is_Category=pc}', "");
    Expect(1, 65344, '\P{Is_Category=pc}', "");
    Expect(0, 65344, '\P{^Is_Category=pc}', "");
    Expect(1, 65343, '\p{Is_Category=_pc}', "");
    Expect(0, 65343, '\p{^Is_Category=_pc}', "");
    Expect(0, 65343, '\P{Is_Category=_pc}', "");
    Expect(1, 65343, '\P{^Is_Category=_pc}', "");
    Expect(0, 65344, '\p{Is_Category=_pc}', "");
    Expect(1, 65344, '\p{^Is_Category=_pc}', "");
    Expect(1, 65344, '\P{Is_Category=_pc}', "");
    Expect(0, 65344, '\P{^Is_Category=_pc}', "");
    Error('\p{General_Category=-	Dash_PUNCTUATION/a/}');
    Error('\P{General_Category=-	Dash_PUNCTUATION/a/}');
    Expect(1, 65293, '\p{General_Category=:\ADash_Punctuation\z:}', "");;
    Expect(0, 65294, '\p{General_Category=:\ADash_Punctuation\z:}', "");;
    Expect(1, 65293, '\p{General_Category=dashpunctuation}', "");
    Expect(0, 65293, '\p{^General_Category=dashpunctuation}', "");
    Expect(0, 65293, '\P{General_Category=dashpunctuation}', "");
    Expect(1, 65293, '\P{^General_Category=dashpunctuation}', "");
    Expect(0, 65294, '\p{General_Category=dashpunctuation}', "");
    Expect(1, 65294, '\p{^General_Category=dashpunctuation}', "");
    Expect(1, 65294, '\P{General_Category=dashpunctuation}', "");
    Expect(0, 65294, '\P{^General_Category=dashpunctuation}', "");
    Expect(1, 65293, '\p{General_Category=:\Adashpunctuation\z:}', "");;
    Expect(0, 65294, '\p{General_Category=:\Adashpunctuation\z:}', "");;
    Expect(1, 65293, '\p{General_Category=Dash_Punctuation}', "");
    Expect(0, 65293, '\p{^General_Category=Dash_Punctuation}', "");
    Expect(0, 65293, '\P{General_Category=Dash_Punctuation}', "");
    Expect(1, 65293, '\P{^General_Category=Dash_Punctuation}', "");
    Expect(0, 65294, '\p{General_Category=Dash_Punctuation}', "");
    Expect(1, 65294, '\p{^General_Category=Dash_Punctuation}', "");
    Expect(1, 65294, '\P{General_Category=Dash_Punctuation}', "");
    Expect(0, 65294, '\P{^General_Category=Dash_Punctuation}', "");
    Error('\p{Gc=  Pd/a/}');
    Error('\P{Gc=  Pd/a/}');
    Expect(1, 65293, '\p{Gc=:\APd\z:}', "");;
    Expect(0, 65294, '\p{Gc=:\APd\z:}', "");;
    Expect(1, 65293, '\p{Gc=pd}', "");
    Expect(0, 65293, '\p{^Gc=pd}', "");
    Expect(0, 65293, '\P{Gc=pd}', "");
    Expect(1, 65293, '\P{^Gc=pd}', "");
    Expect(0, 65294, '\p{Gc=pd}', "");
    Expect(1, 65294, '\p{^Gc=pd}', "");
    Expect(1, 65294, '\P{Gc=pd}', "");
    Expect(0, 65294, '\P{^Gc=pd}', "");
    Expect(1, 65293, '\p{Gc=:\Apd\z:}', "");;
    Expect(0, 65294, '\p{Gc=:\Apd\z:}', "");;
    Expect(1, 65293, '\p{Gc=	_pd}', "");
    Expect(0, 65293, '\p{^Gc=	_pd}', "");
    Expect(0, 65293, '\P{Gc=	_pd}', "");
    Expect(1, 65293, '\P{^Gc=	_pd}', "");
    Expect(0, 65294, '\p{Gc=	_pd}', "");
    Expect(1, 65294, '\p{^Gc=	_pd}', "");
    Expect(1, 65294, '\P{Gc=	_pd}', "");
    Expect(0, 65294, '\P{^Gc=	_pd}', "");
    Error('\p{Category=/a/Dash_PUNCTUATION}');
    Error('\P{Category=/a/Dash_PUNCTUATION}');
    Expect(1, 65293, '\p{Category=:\ADash_Punctuation\z:}', "");;
    Expect(0, 65294, '\p{Category=:\ADash_Punctuation\z:}', "");;
    Expect(1, 65293, '\p{Category=dashpunctuation}', "");
    Expect(0, 65293, '\p{^Category=dashpunctuation}', "");
    Expect(0, 65293, '\P{Category=dashpunctuation}', "");
    Expect(1, 65293, '\P{^Category=dashpunctuation}', "");
    Expect(0, 65294, '\p{Category=dashpunctuation}', "");
    Expect(1, 65294, '\p{^Category=dashpunctuation}', "");
    Expect(1, 65294, '\P{Category=dashpunctuation}', "");
    Expect(0, 65294, '\P{^Category=dashpunctuation}', "");
    Expect(1, 65293, '\p{Category=:\Adashpunctuation\z:}', "");;
    Expect(0, 65294, '\p{Category=:\Adashpunctuation\z:}', "");;
    Expect(1, 65293, '\p{Category=	DASH_Punctuation}', "");
    Expect(0, 65293, '\p{^Category=	DASH_Punctuation}', "");
    Expect(0, 65293, '\P{Category=	DASH_Punctuation}', "");
    Expect(1, 65293, '\P{^Category=	DASH_Punctuation}', "");
    Expect(0, 65294, '\p{Category=	DASH_Punctuation}', "");
    Expect(1, 65294, '\p{^Category=	DASH_Punctuation}', "");
    Expect(1, 65294, '\P{Category=	DASH_Punctuation}', "");
    Expect(0, 65294, '\P{^Category=	DASH_Punctuation}', "");
    Error('\p{Is_General_Category= :=pd}');
    Error('\P{Is_General_Category= :=pd}');
    Expect(1, 65293, '\p{Is_General_Category:	pd}', "");
    Expect(0, 65293, '\p{^Is_General_Category:	pd}', "");
    Expect(0, 65293, '\P{Is_General_Category:	pd}', "");
    Expect(1, 65293, '\P{^Is_General_Category:	pd}', "");
    Expect(0, 65294, '\p{Is_General_Category:	pd}', "");
    Expect(1, 65294, '\p{^Is_General_Category:	pd}', "");
    Expect(1, 65294, '\P{Is_General_Category:	pd}', "");
    Expect(0, 65294, '\P{^Is_General_Category:	pd}', "");
    Expect(1, 65293, '\p{Is_General_Category=- pd}', "");
    Expect(0, 65293, '\p{^Is_General_Category=- pd}', "");
    Expect(0, 65293, '\P{Is_General_Category=- pd}', "");
    Expect(1, 65293, '\P{^Is_General_Category=- pd}', "");
    Expect(0, 65294, '\p{Is_General_Category=- pd}', "");
    Expect(1, 65294, '\p{^Is_General_Category=- pd}', "");
    Expect(1, 65294, '\P{Is_General_Category=- pd}', "");
    Expect(0, 65294, '\P{^Is_General_Category=- pd}', "");
    Error('\p{Is_Gc= :=DASH_PUNCTUATION}');
    Error('\P{Is_Gc= :=DASH_PUNCTUATION}');
    Expect(1, 65293, '\p{Is_Gc:dashpunctuation}', "");
    Expect(0, 65293, '\p{^Is_Gc:dashpunctuation}', "");
    Expect(0, 65293, '\P{Is_Gc:dashpunctuation}', "");
    Expect(1, 65293, '\P{^Is_Gc:dashpunctuation}', "");
    Expect(0, 65294, '\p{Is_Gc:dashpunctuation}', "");
    Expect(1, 65294, '\p{^Is_Gc:dashpunctuation}', "");
    Expect(1, 65294, '\P{Is_Gc:dashpunctuation}', "");
    Expect(0, 65294, '\P{^Is_Gc:dashpunctuation}', "");
    Expect(1, 65293, '\p{Is_Gc=__Dash_Punctuation}', "");
    Expect(0, 65293, '\p{^Is_Gc=__Dash_Punctuation}', "");
    Expect(0, 65293, '\P{Is_Gc=__Dash_Punctuation}', "");
    Expect(1, 65293, '\P{^Is_Gc=__Dash_Punctuation}', "");
    Expect(0, 65294, '\p{Is_Gc=__Dash_Punctuation}', "");
    Expect(1, 65294, '\p{^Is_Gc=__Dash_Punctuation}', "");
    Expect(1, 65294, '\P{Is_Gc=__Dash_Punctuation}', "");
    Expect(0, 65294, '\P{^Is_Gc=__Dash_Punctuation}', "");
    Error('\p{Is_Category=	Pd:=}');
    Error('\P{Is_Category=	Pd:=}');
    Expect(1, 65293, '\p{Is_Category=pd}', "");
    Expect(0, 65293, '\p{^Is_Category=pd}', "");
    Expect(0, 65293, '\P{Is_Category=pd}', "");
    Expect(1, 65293, '\P{^Is_Category=pd}', "");
    Expect(0, 65294, '\p{Is_Category=pd}', "");
    Expect(1, 65294, '\p{^Is_Category=pd}', "");
    Expect(1, 65294, '\P{Is_Category=pd}', "");
    Expect(0, 65294, '\P{^Is_Category=pd}', "");
    Expect(1, 65293, '\p{Is_Category:   	Pd}', "");
    Expect(0, 65293, '\p{^Is_Category:   	Pd}', "");
    Expect(0, 65293, '\P{Is_Category:   	Pd}', "");
    Expect(1, 65293, '\P{^Is_Category:   	Pd}', "");
    Expect(0, 65294, '\p{Is_Category:   	Pd}', "");
    Expect(1, 65294, '\p{^Is_Category:   	Pd}', "");
    Expect(1, 65294, '\P{Is_Category:   	Pd}', "");
    Expect(0, 65294, '\P{^Is_Category:   	Pd}', "");
    Error('\p{General_Category=- CLOSE_Punctuation/a/}');
    Error('\P{General_Category=- CLOSE_Punctuation/a/}');
    Expect(1, 65379, '\p{General_Category=:\AClose_Punctuation\z:}', "");;
    Expect(0, 65380, '\p{General_Category=:\AClose_Punctuation\z:}', "");;
    Expect(1, 65379, '\p{General_Category=closepunctuation}', "");
    Expect(0, 65379, '\p{^General_Category=closepunctuation}', "");
    Expect(0, 65379, '\P{General_Category=closepunctuation}', "");
    Expect(1, 65379, '\P{^General_Category=closepunctuation}', "");
    Expect(0, 65380, '\p{General_Category=closepunctuation}', "");
    Expect(1, 65380, '\p{^General_Category=closepunctuation}', "");
    Expect(1, 65380, '\P{General_Category=closepunctuation}', "");
    Expect(0, 65380, '\P{^General_Category=closepunctuation}', "");
    Expect(1, 65379, '\p{General_Category=:\Aclosepunctuation\z:}', "");;
    Expect(0, 65380, '\p{General_Category=:\Aclosepunctuation\z:}', "");;
    Expect(1, 65379, '\p{General_Category=  CLOSE_Punctuation}', "");
    Expect(0, 65379, '\p{^General_Category=  CLOSE_Punctuation}', "");
    Expect(0, 65379, '\P{General_Category=  CLOSE_Punctuation}', "");
    Expect(1, 65379, '\P{^General_Category=  CLOSE_Punctuation}', "");
    Expect(0, 65380, '\p{General_Category=  CLOSE_Punctuation}', "");
    Expect(1, 65380, '\p{^General_Category=  CLOSE_Punctuation}', "");
    Expect(1, 65380, '\P{General_Category=  CLOSE_Punctuation}', "");
    Expect(0, 65380, '\P{^General_Category=  CLOSE_Punctuation}', "");
    Error('\p{Gc=/a/Pe}');
    Error('\P{Gc=/a/Pe}');
    Expect(1, 65379, '\p{Gc=:\APe\z:}', "");;
    Expect(0, 65380, '\p{Gc=:\APe\z:}', "");;
    Expect(1, 65379, '\p{Gc=pe}', "");
    Expect(0, 65379, '\p{^Gc=pe}', "");
    Expect(0, 65379, '\P{Gc=pe}', "");
    Expect(1, 65379, '\P{^Gc=pe}', "");
    Expect(0, 65380, '\p{Gc=pe}', "");
    Expect(1, 65380, '\p{^Gc=pe}', "");
    Expect(1, 65380, '\P{Gc=pe}', "");
    Expect(0, 65380, '\P{^Gc=pe}', "");
    Expect(1, 65379, '\p{Gc=:\Ape\z:}', "");;
    Expect(0, 65380, '\p{Gc=:\Ape\z:}', "");;
    Expect(1, 65379, '\p{Gc=__Pe}', "");
    Expect(0, 65379, '\p{^Gc=__Pe}', "");
    Expect(0, 65379, '\P{Gc=__Pe}', "");
    Expect(1, 65379, '\P{^Gc=__Pe}', "");
    Expect(0, 65380, '\p{Gc=__Pe}', "");
    Expect(1, 65380, '\p{^Gc=__Pe}', "");
    Expect(1, 65380, '\P{Gc=__Pe}', "");
    Expect(0, 65380, '\P{^Gc=__Pe}', "");
    Error('\p{Category=_	close_Punctuation:=}');
    Error('\P{Category=_	close_Punctuation:=}');
    Expect(1, 65379, '\p{Category=:\AClose_Punctuation\z:}', "");;
    Expect(0, 65380, '\p{Category=:\AClose_Punctuation\z:}', "");;
    Expect(1, 65379, '\p{Category=closepunctuation}', "");
    Expect(0, 65379, '\p{^Category=closepunctuation}', "");
    Expect(0, 65379, '\P{Category=closepunctuation}', "");
    Expect(1, 65379, '\P{^Category=closepunctuation}', "");
    Expect(0, 65380, '\p{Category=closepunctuation}', "");
    Expect(1, 65380, '\p{^Category=closepunctuation}', "");
    Expect(1, 65380, '\P{Category=closepunctuation}', "");
    Expect(0, 65380, '\P{^Category=closepunctuation}', "");
    Expect(1, 65379, '\p{Category=:\Aclosepunctuation\z:}', "");;
    Expect(0, 65380, '\p{Category=:\Aclosepunctuation\z:}', "");;
    Expect(1, 65379, '\p{Category= 	close_PUNCTUATION}', "");
    Expect(0, 65379, '\p{^Category= 	close_PUNCTUATION}', "");
    Expect(0, 65379, '\P{Category= 	close_PUNCTUATION}', "");
    Expect(1, 65379, '\P{^Category= 	close_PUNCTUATION}', "");
    Expect(0, 65380, '\p{Category= 	close_PUNCTUATION}', "");
    Expect(1, 65380, '\p{^Category= 	close_PUNCTUATION}', "");
    Expect(1, 65380, '\P{Category= 	close_PUNCTUATION}', "");
    Expect(0, 65380, '\P{^Category= 	close_PUNCTUATION}', "");
    Error('\p{Is_General_Category=--Pe/a/}');
    Error('\P{Is_General_Category=--Pe/a/}');
    Expect(1, 65379, '\p{Is_General_Category=pe}', "");
    Expect(0, 65379, '\p{^Is_General_Category=pe}', "");
    Expect(0, 65379, '\P{Is_General_Category=pe}', "");
    Expect(1, 65379, '\P{^Is_General_Category=pe}', "");
    Expect(0, 65380, '\p{Is_General_Category=pe}', "");
    Expect(1, 65380, '\p{^Is_General_Category=pe}', "");
    Expect(1, 65380, '\P{Is_General_Category=pe}', "");
    Expect(0, 65380, '\P{^Is_General_Category=pe}', "");
    Expect(1, 65379, '\p{Is_General_Category=__Pe}', "");
    Expect(0, 65379, '\p{^Is_General_Category=__Pe}', "");
    Expect(0, 65379, '\P{Is_General_Category=__Pe}', "");
    Expect(1, 65379, '\P{^Is_General_Category=__Pe}', "");
    Expect(0, 65380, '\p{Is_General_Category=__Pe}', "");
    Expect(1, 65380, '\p{^Is_General_Category=__Pe}', "");
    Expect(1, 65380, '\P{Is_General_Category=__Pe}', "");
    Expect(0, 65380, '\P{^Is_General_Category=__Pe}', "");
    Error('\p{Is_Gc= _Close_Punctuation:=}');
    Error('\P{Is_Gc= _Close_Punctuation:=}');
    Expect(1, 65379, '\p{Is_Gc=closepunctuation}', "");
    Expect(0, 65379, '\p{^Is_Gc=closepunctuation}', "");
    Expect(0, 65379, '\P{Is_Gc=closepunctuation}', "");
    Expect(1, 65379, '\P{^Is_Gc=closepunctuation}', "");
    Expect(0, 65380, '\p{Is_Gc=closepunctuation}', "");
    Expect(1, 65380, '\p{^Is_Gc=closepunctuation}', "");
    Expect(1, 65380, '\P{Is_Gc=closepunctuation}', "");
    Expect(0, 65380, '\P{^Is_Gc=closepunctuation}', "");
    Expect(1, 65379, '\p{Is_Gc=__close_PUNCTUATION}', "");
    Expect(0, 65379, '\p{^Is_Gc=__close_PUNCTUATION}', "");
    Expect(0, 65379, '\P{Is_Gc=__close_PUNCTUATION}', "");
    Expect(1, 65379, '\P{^Is_Gc=__close_PUNCTUATION}', "");
    Expect(0, 65380, '\p{Is_Gc=__close_PUNCTUATION}', "");
    Expect(1, 65380, '\p{^Is_Gc=__close_PUNCTUATION}', "");
    Expect(1, 65380, '\P{Is_Gc=__close_PUNCTUATION}', "");
    Expect(0, 65380, '\P{^Is_Gc=__close_PUNCTUATION}', "");
    Error('\p{Is_Category=-/a/Pe}');
    Error('\P{Is_Category=-/a/Pe}');
    Expect(1, 65379, '\p{Is_Category=pe}', "");
    Expect(0, 65379, '\p{^Is_Category=pe}', "");
    Expect(0, 65379, '\P{Is_Category=pe}', "");
    Expect(1, 65379, '\P{^Is_Category=pe}', "");
    Expect(0, 65380, '\p{Is_Category=pe}', "");
    Expect(1, 65380, '\p{^Is_Category=pe}', "");
    Expect(1, 65380, '\P{Is_Category=pe}', "");
    Expect(0, 65380, '\P{^Is_Category=pe}', "");
    Expect(1, 65379, '\p{Is_Category=_Pe}', "");
    Expect(0, 65379, '\p{^Is_Category=_Pe}', "");
    Expect(0, 65379, '\P{Is_Category=_Pe}', "");
    Expect(1, 65379, '\P{^Is_Category=_Pe}', "");
    Expect(0, 65380, '\p{Is_Category=_Pe}', "");
    Expect(1, 65380, '\p{^Is_Category=_Pe}', "");
    Expect(1, 65380, '\P{Is_Category=_Pe}', "");
    Expect(0, 65380, '\P{^Is_Category=_Pe}', "");
    Error('\p{General_Category= Final_Punctuation/a/}');
    Error('\P{General_Category= Final_Punctuation/a/}');
    Expect(1, 11809, '\p{General_Category=:\AFinal_Punctuation\z:}', "");;
    Expect(0, 11810, '\p{General_Category=:\AFinal_Punctuation\z:}', "");;
    Expect(1, 11809, '\p{General_Category=finalpunctuation}', "");
    Expect(0, 11809, '\p{^General_Category=finalpunctuation}', "");
    Expect(0, 11809, '\P{General_Category=finalpunctuation}', "");
    Expect(1, 11809, '\P{^General_Category=finalpunctuation}', "");
    Expect(0, 11810, '\p{General_Category=finalpunctuation}', "");
    Expect(1, 11810, '\p{^General_Category=finalpunctuation}', "");
    Expect(1, 11810, '\P{General_Category=finalpunctuation}', "");
    Expect(0, 11810, '\P{^General_Category=finalpunctuation}', "");
    Expect(1, 11809, '\p{General_Category=:\Afinalpunctuation\z:}', "");;
    Expect(0, 11810, '\p{General_Category=:\Afinalpunctuation\z:}', "");;
    Expect(1, 11809, '\p{General_Category=-Final_punctuation}', "");
    Expect(0, 11809, '\p{^General_Category=-Final_punctuation}', "");
    Expect(0, 11809, '\P{General_Category=-Final_punctuation}', "");
    Expect(1, 11809, '\P{^General_Category=-Final_punctuation}', "");
    Expect(0, 11810, '\p{General_Category=-Final_punctuation}', "");
    Expect(1, 11810, '\p{^General_Category=-Final_punctuation}', "");
    Expect(1, 11810, '\P{General_Category=-Final_punctuation}', "");
    Expect(0, 11810, '\P{^General_Category=-Final_punctuation}', "");
    Error('\p{Gc=-:=Pf}');
    Error('\P{Gc=-:=Pf}');
    Expect(1, 11809, '\p{Gc=:\APf\z:}', "");;
    Expect(0, 11810, '\p{Gc=:\APf\z:}', "");;
    Expect(1, 11809, '\p{Gc=pf}', "");
    Expect(0, 11809, '\p{^Gc=pf}', "");
    Expect(0, 11809, '\P{Gc=pf}', "");
    Expect(1, 11809, '\P{^Gc=pf}', "");
    Expect(0, 11810, '\p{Gc=pf}', "");
    Expect(1, 11810, '\p{^Gc=pf}', "");
    Expect(1, 11810, '\P{Gc=pf}', "");
    Expect(0, 11810, '\P{^Gc=pf}', "");
    Expect(1, 11809, '\p{Gc=:\Apf\z:}', "");;
    Expect(0, 11810, '\p{Gc=:\Apf\z:}', "");;
    Expect(1, 11809, '\p{Gc=-PF}', "");
    Expect(0, 11809, '\p{^Gc=-PF}', "");
    Expect(0, 11809, '\P{Gc=-PF}', "");
    Expect(1, 11809, '\P{^Gc=-PF}', "");
    Expect(0, 11810, '\p{Gc=-PF}', "");
    Expect(1, 11810, '\p{^Gc=-PF}', "");
    Expect(1, 11810, '\P{Gc=-PF}', "");
    Expect(0, 11810, '\P{^Gc=-PF}', "");
    Error('\p{Category= final_Punctuation/a/}');
    Error('\P{Category= final_Punctuation/a/}');
    Expect(1, 11809, '\p{Category=:\AFinal_Punctuation\z:}', "");;
    Expect(0, 11810, '\p{Category=:\AFinal_Punctuation\z:}', "");;
    Expect(1, 11809, '\p{Category=finalpunctuation}', "");
    Expect(0, 11809, '\p{^Category=finalpunctuation}', "");
    Expect(0, 11809, '\P{Category=finalpunctuation}', "");
    Expect(1, 11809, '\P{^Category=finalpunctuation}', "");
    Expect(0, 11810, '\p{Category=finalpunctuation}', "");
    Expect(1, 11810, '\p{^Category=finalpunctuation}', "");
    Expect(1, 11810, '\P{Category=finalpunctuation}', "");
    Expect(0, 11810, '\P{^Category=finalpunctuation}', "");
    Expect(1, 11809, '\p{Category=:\Afinalpunctuation\z:}', "");;
    Expect(0, 11810, '\p{Category=:\Afinalpunctuation\z:}', "");;
    Expect(1, 11809, '\p{Category=_ final_PUNCTUATION}', "");
    Expect(0, 11809, '\p{^Category=_ final_PUNCTUATION}', "");
    Expect(0, 11809, '\P{Category=_ final_PUNCTUATION}', "");
    Expect(1, 11809, '\P{^Category=_ final_PUNCTUATION}', "");
    Expect(0, 11810, '\p{Category=_ final_PUNCTUATION}', "");
    Expect(1, 11810, '\p{^Category=_ final_PUNCTUATION}', "");
    Expect(1, 11810, '\P{Category=_ final_PUNCTUATION}', "");
    Expect(0, 11810, '\P{^Category=_ final_PUNCTUATION}', "");
    Error('\p{Is_General_Category=:=_	PF}');
    Error('\P{Is_General_Category=:=_	PF}');
    Expect(1, 11809, '\p{Is_General_Category=pf}', "");
    Expect(0, 11809, '\p{^Is_General_Category=pf}', "");
    Expect(0, 11809, '\P{Is_General_Category=pf}', "");
    Expect(1, 11809, '\P{^Is_General_Category=pf}', "");
    Expect(0, 11810, '\p{Is_General_Category=pf}', "");
    Expect(1, 11810, '\p{^Is_General_Category=pf}', "");
    Expect(1, 11810, '\P{Is_General_Category=pf}', "");
    Expect(0, 11810, '\P{^Is_General_Category=pf}', "");
    Expect(1, 11809, '\p{Is_General_Category= Pf}', "");
    Expect(0, 11809, '\p{^Is_General_Category= Pf}', "");
    Expect(0, 11809, '\P{Is_General_Category= Pf}', "");
    Expect(1, 11809, '\P{^Is_General_Category= Pf}', "");
    Expect(0, 11810, '\p{Is_General_Category= Pf}', "");
    Expect(1, 11810, '\p{^Is_General_Category= Pf}', "");
    Expect(1, 11810, '\P{Is_General_Category= Pf}', "");
    Expect(0, 11810, '\P{^Is_General_Category= Pf}', "");
    Error('\p{Is_Gc=		final_Punctuation/a/}');
    Error('\P{Is_Gc=		final_Punctuation/a/}');
    Expect(1, 11809, '\p{Is_Gc=finalpunctuation}', "");
    Expect(0, 11809, '\p{^Is_Gc=finalpunctuation}', "");
    Expect(0, 11809, '\P{Is_Gc=finalpunctuation}', "");
    Expect(1, 11809, '\P{^Is_Gc=finalpunctuation}', "");
    Expect(0, 11810, '\p{Is_Gc=finalpunctuation}', "");
    Expect(1, 11810, '\p{^Is_Gc=finalpunctuation}', "");
    Expect(1, 11810, '\P{Is_Gc=finalpunctuation}', "");
    Expect(0, 11810, '\P{^Is_Gc=finalpunctuation}', "");
    Expect(1, 11809, '\p{Is_Gc= _final_Punctuation}', "");
    Expect(0, 11809, '\p{^Is_Gc= _final_Punctuation}', "");
    Expect(0, 11809, '\P{Is_Gc= _final_Punctuation}', "");
    Expect(1, 11809, '\P{^Is_Gc= _final_Punctuation}', "");
    Expect(0, 11810, '\p{Is_Gc= _final_Punctuation}', "");
    Expect(1, 11810, '\p{^Is_Gc= _final_Punctuation}', "");
    Expect(1, 11810, '\P{Is_Gc= _final_Punctuation}', "");
    Expect(0, 11810, '\P{^Is_Gc= _final_Punctuation}', "");
    Error('\p{Is_Category=	:=Pf}');
    Error('\P{Is_Category=	:=Pf}');
    Expect(1, 11809, '\p{Is_Category=pf}', "");
    Expect(0, 11809, '\p{^Is_Category=pf}', "");
    Expect(0, 11809, '\P{Is_Category=pf}', "");
    Expect(1, 11809, '\P{^Is_Category=pf}', "");
    Expect(0, 11810, '\p{Is_Category=pf}', "");
    Expect(1, 11810, '\p{^Is_Category=pf}', "");
    Expect(1, 11810, '\P{Is_Category=pf}', "");
    Expect(0, 11810, '\P{^Is_Category=pf}', "");
    Expect(1, 11809, '\p{Is_Category=  Pf}', "");
    Expect(0, 11809, '\p{^Is_Category=  Pf}', "");
    Expect(0, 11809, '\P{Is_Category=  Pf}', "");
    Expect(1, 11809, '\P{^Is_Category=  Pf}', "");
    Expect(0, 11810, '\p{Is_Category=  Pf}', "");
    Expect(1, 11810, '\p{^Is_Category=  Pf}', "");
    Expect(1, 11810, '\P{Is_Category=  Pf}', "");
    Expect(0, 11810, '\P{^Is_Category=  Pf}', "");
    Error('\p{General_Category:	/a/		Initial_Punctuation}');
    Error('\P{General_Category:	/a/		Initial_Punctuation}');
    Expect(1, 11808, '\p{General_Category=:\AInitial_Punctuation\z:}', "");;
    Expect(0, 11809, '\p{General_Category=:\AInitial_Punctuation\z:}', "");;
    Expect(1, 11808, '\p{General_Category=initialpunctuation}', "");
    Expect(0, 11808, '\p{^General_Category=initialpunctuation}', "");
    Expect(0, 11808, '\P{General_Category=initialpunctuation}', "");
    Expect(1, 11808, '\P{^General_Category=initialpunctuation}', "");
    Expect(0, 11809, '\p{General_Category=initialpunctuation}', "");
    Expect(1, 11809, '\p{^General_Category=initialpunctuation}', "");
    Expect(1, 11809, '\P{General_Category=initialpunctuation}', "");
    Expect(0, 11809, '\P{^General_Category=initialpunctuation}', "");
    Expect(1, 11808, '\p{General_Category=:\Ainitialpunctuation\z:}', "");;
    Expect(0, 11809, '\p{General_Category=:\Ainitialpunctuation\z:}', "");;
    Expect(1, 11808, '\p{General_Category=  Initial_punctuation}', "");
    Expect(0, 11808, '\p{^General_Category=  Initial_punctuation}', "");
    Expect(0, 11808, '\P{General_Category=  Initial_punctuation}', "");
    Expect(1, 11808, '\P{^General_Category=  Initial_punctuation}', "");
    Expect(0, 11809, '\p{General_Category=  Initial_punctuation}', "");
    Expect(1, 11809, '\p{^General_Category=  Initial_punctuation}', "");
    Expect(1, 11809, '\P{General_Category=  Initial_punctuation}', "");
    Expect(0, 11809, '\P{^General_Category=  Initial_punctuation}', "");
    Error('\p{Gc=	:=PI}');
    Error('\P{Gc=	:=PI}');
    Expect(1, 11808, '\p{Gc=:\APi\z:}', "");;
    Expect(0, 11809, '\p{Gc=:\APi\z:}', "");;
    Expect(1, 11808, '\p{Gc=pi}', "");
    Expect(0, 11808, '\p{^Gc=pi}', "");
    Expect(0, 11808, '\P{Gc=pi}', "");
    Expect(1, 11808, '\P{^Gc=pi}', "");
    Expect(0, 11809, '\p{Gc=pi}', "");
    Expect(1, 11809, '\p{^Gc=pi}', "");
    Expect(1, 11809, '\P{Gc=pi}', "");
    Expect(0, 11809, '\P{^Gc=pi}', "");
    Expect(1, 11808, '\p{Gc=:\Api\z:}', "");;
    Expect(0, 11809, '\p{Gc=:\Api\z:}', "");;
    Expect(1, 11808, '\p{Gc= 	PI}', "");
    Expect(0, 11808, '\p{^Gc= 	PI}', "");
    Expect(0, 11808, '\P{Gc= 	PI}', "");
    Expect(1, 11808, '\P{^Gc= 	PI}', "");
    Expect(0, 11809, '\p{Gc= 	PI}', "");
    Expect(1, 11809, '\p{^Gc= 	PI}', "");
    Expect(1, 11809, '\P{Gc= 	PI}', "");
    Expect(0, 11809, '\P{^Gc= 	PI}', "");
    Error('\p{Category: /a/	Initial_PUNCTUATION}');
    Error('\P{Category: /a/	Initial_PUNCTUATION}');
    Expect(1, 11808, '\p{Category=:\AInitial_Punctuation\z:}', "");;
    Expect(0, 11809, '\p{Category=:\AInitial_Punctuation\z:}', "");;
    Expect(1, 11808, '\p{Category=initialpunctuation}', "");
    Expect(0, 11808, '\p{^Category=initialpunctuation}', "");
    Expect(0, 11808, '\P{Category=initialpunctuation}', "");
    Expect(1, 11808, '\P{^Category=initialpunctuation}', "");
    Expect(0, 11809, '\p{Category=initialpunctuation}', "");
    Expect(1, 11809, '\p{^Category=initialpunctuation}', "");
    Expect(1, 11809, '\P{Category=initialpunctuation}', "");
    Expect(0, 11809, '\P{^Category=initialpunctuation}', "");
    Expect(1, 11808, '\p{Category=:\Ainitialpunctuation\z:}', "");;
    Expect(0, 11809, '\p{Category=:\Ainitialpunctuation\z:}', "");;
    Expect(1, 11808, '\p{Category= -Initial_punctuation}', "");
    Expect(0, 11808, '\p{^Category= -Initial_punctuation}', "");
    Expect(0, 11808, '\P{Category= -Initial_punctuation}', "");
    Expect(1, 11808, '\P{^Category= -Initial_punctuation}', "");
    Expect(0, 11809, '\p{Category= -Initial_punctuation}', "");
    Expect(1, 11809, '\p{^Category= -Initial_punctuation}', "");
    Expect(1, 11809, '\P{Category= -Initial_punctuation}', "");
    Expect(0, 11809, '\P{^Category= -Initial_punctuation}', "");
    Error('\p{Is_General_Category=/a/ -Pi}');
    Error('\P{Is_General_Category=/a/ -Pi}');
    Expect(1, 11808, '\p{Is_General_Category=pi}', "");
    Expect(0, 11808, '\p{^Is_General_Category=pi}', "");
    Expect(0, 11808, '\P{Is_General_Category=pi}', "");
    Expect(1, 11808, '\P{^Is_General_Category=pi}', "");
    Expect(0, 11809, '\p{Is_General_Category=pi}', "");
    Expect(1, 11809, '\p{^Is_General_Category=pi}', "");
    Expect(1, 11809, '\P{Is_General_Category=pi}', "");
    Expect(0, 11809, '\P{^Is_General_Category=pi}', "");
    Expect(1, 11808, '\p{Is_General_Category=-pi}', "");
    Expect(0, 11808, '\p{^Is_General_Category=-pi}', "");
    Expect(0, 11808, '\P{Is_General_Category=-pi}', "");
    Expect(1, 11808, '\P{^Is_General_Category=-pi}', "");
    Expect(0, 11809, '\p{Is_General_Category=-pi}', "");
    Expect(1, 11809, '\p{^Is_General_Category=-pi}', "");
    Expect(1, 11809, '\P{Is_General_Category=-pi}', "");
    Expect(0, 11809, '\P{^Is_General_Category=-pi}', "");
    Error('\p{Is_Gc=--initial_PUNCTUATION:=}');
    Error('\P{Is_Gc=--initial_PUNCTUATION:=}');
    Expect(1, 11808, '\p{Is_Gc=initialpunctuation}', "");
    Expect(0, 11808, '\p{^Is_Gc=initialpunctuation}', "");
    Expect(0, 11808, '\P{Is_Gc=initialpunctuation}', "");
    Expect(1, 11808, '\P{^Is_Gc=initialpunctuation}', "");
    Expect(0, 11809, '\p{Is_Gc=initialpunctuation}', "");
    Expect(1, 11809, '\p{^Is_Gc=initialpunctuation}', "");
    Expect(1, 11809, '\P{Is_Gc=initialpunctuation}', "");
    Expect(0, 11809, '\P{^Is_Gc=initialpunctuation}', "");
    Expect(1, 11808, '\p{Is_Gc=_Initial_PUNCTUATION}', "");
    Expect(0, 11808, '\p{^Is_Gc=_Initial_PUNCTUATION}', "");
    Expect(0, 11808, '\P{Is_Gc=_Initial_PUNCTUATION}', "");
    Expect(1, 11808, '\P{^Is_Gc=_Initial_PUNCTUATION}', "");
    Expect(0, 11809, '\p{Is_Gc=_Initial_PUNCTUATION}', "");
    Expect(1, 11809, '\p{^Is_Gc=_Initial_PUNCTUATION}', "");
    Expect(1, 11809, '\P{Is_Gc=_Initial_PUNCTUATION}', "");
    Expect(0, 11809, '\P{^Is_Gc=_Initial_PUNCTUATION}', "");
    Error('\p{Is_Category=/a/Pi}');
    Error('\P{Is_Category=/a/Pi}');
    Expect(1, 11808, '\p{Is_Category=pi}', "");
    Expect(0, 11808, '\p{^Is_Category=pi}', "");
    Expect(0, 11808, '\P{Is_Category=pi}', "");
    Expect(1, 11808, '\P{^Is_Category=pi}', "");
    Expect(0, 11809, '\p{Is_Category=pi}', "");
    Expect(1, 11809, '\p{^Is_Category=pi}', "");
    Expect(1, 11809, '\P{Is_Category=pi}', "");
    Expect(0, 11809, '\P{^Is_Category=pi}', "");
    Expect(1, 11808, '\p{Is_Category=	_Pi}', "");
    Expect(0, 11808, '\p{^Is_Category=	_Pi}', "");
    Expect(0, 11808, '\P{Is_Category=	_Pi}', "");
    Expect(1, 11808, '\P{^Is_Category=	_Pi}', "");
    Expect(0, 11809, '\p{Is_Category=	_Pi}', "");
    Expect(1, 11809, '\p{^Is_Category=	_Pi}', "");
    Expect(1, 11809, '\P{Is_Category=	_Pi}', "");
    Expect(0, 11809, '\P{^Is_Category=	_Pi}', "");
    Error('\p{General_Category=:= OTHER_PUNCTUATION}');
    Error('\P{General_Category=:= OTHER_PUNCTUATION}');
    Expect(1, 125279, '\p{General_Category=:\AOther_Punctuation\z:}', "");;
    Expect(0, 125280, '\p{General_Category=:\AOther_Punctuation\z:}', "");;
    Expect(1, 125279, '\p{General_Category=otherpunctuation}', "");
    Expect(0, 125279, '\p{^General_Category=otherpunctuation}', "");
    Expect(0, 125279, '\P{General_Category=otherpunctuation}', "");
    Expect(1, 125279, '\P{^General_Category=otherpunctuation}', "");
    Expect(0, 125280, '\p{General_Category=otherpunctuation}', "");
    Expect(1, 125280, '\p{^General_Category=otherpunctuation}', "");
    Expect(1, 125280, '\P{General_Category=otherpunctuation}', "");
    Expect(0, 125280, '\P{^General_Category=otherpunctuation}', "");
    Expect(1, 125279, '\p{General_Category=:\Aotherpunctuation\z:}', "");;
    Expect(0, 125280, '\p{General_Category=:\Aotherpunctuation\z:}', "");;
    Expect(1, 125279, '\p{General_Category=-Other_punctuation}', "");
    Expect(0, 125279, '\p{^General_Category=-Other_punctuation}', "");
    Expect(0, 125279, '\P{General_Category=-Other_punctuation}', "");
    Expect(1, 125279, '\P{^General_Category=-Other_punctuation}', "");
    Expect(0, 125280, '\p{General_Category=-Other_punctuation}', "");
    Expect(1, 125280, '\p{^General_Category=-Other_punctuation}', "");
    Expect(1, 125280, '\P{General_Category=-Other_punctuation}', "");
    Expect(0, 125280, '\P{^General_Category=-Other_punctuation}', "");
    Error('\p{Gc=:=	 Po}');
    Error('\P{Gc=:=	 Po}');
    Expect(1, 125279, '\p{Gc=:\APo\z:}', "");;
    Expect(0, 125280, '\p{Gc=:\APo\z:}', "");;
    Expect(1, 125279, '\p{Gc:po}', "");
    Expect(0, 125279, '\p{^Gc:po}', "");
    Expect(0, 125279, '\P{Gc:po}', "");
    Expect(1, 125279, '\P{^Gc:po}', "");
    Expect(0, 125280, '\p{Gc:po}', "");
    Expect(1, 125280, '\p{^Gc:po}', "");
    Expect(1, 125280, '\P{Gc:po}', "");
    Expect(0, 125280, '\P{^Gc:po}', "");
    Expect(1, 125279, '\p{Gc=:\Apo\z:}', "");;
    Expect(0, 125280, '\p{Gc=:\Apo\z:}', "");;
    Expect(1, 125279, '\p{Gc=_Po}', "");
    Expect(0, 125279, '\p{^Gc=_Po}', "");
    Expect(0, 125279, '\P{Gc=_Po}', "");
    Expect(1, 125279, '\P{^Gc=_Po}', "");
    Expect(0, 125280, '\p{Gc=_Po}', "");
    Expect(1, 125280, '\p{^Gc=_Po}', "");
    Expect(1, 125280, '\P{Gc=_Po}', "");
    Expect(0, 125280, '\P{^Gc=_Po}', "");
    Error('\p{Category=/a/ -Other_Punctuation}');
    Error('\P{Category=/a/ -Other_Punctuation}');
    Expect(1, 125279, '\p{Category=:\AOther_Punctuation\z:}', "");;
    Expect(0, 125280, '\p{Category=:\AOther_Punctuation\z:}', "");;
    Expect(1, 125279, '\p{Category=otherpunctuation}', "");
    Expect(0, 125279, '\p{^Category=otherpunctuation}', "");
    Expect(0, 125279, '\P{Category=otherpunctuation}', "");
    Expect(1, 125279, '\P{^Category=otherpunctuation}', "");
    Expect(0, 125280, '\p{Category=otherpunctuation}', "");
    Expect(1, 125280, '\p{^Category=otherpunctuation}', "");
    Expect(1, 125280, '\P{Category=otherpunctuation}', "");
    Expect(0, 125280, '\P{^Category=otherpunctuation}', "");
    Expect(1, 125279, '\p{Category=:\Aotherpunctuation\z:}', "");;
    Expect(0, 125280, '\p{Category=:\Aotherpunctuation\z:}', "");;
    Expect(1, 125279, '\p{Category=	OTHER_Punctuation}', "");
    Expect(0, 125279, '\p{^Category=	OTHER_Punctuation}', "");
    Expect(0, 125279, '\P{Category=	OTHER_Punctuation}', "");
    Expect(1, 125279, '\P{^Category=	OTHER_Punctuation}', "");
    Expect(0, 125280, '\p{Category=	OTHER_Punctuation}', "");
    Expect(1, 125280, '\p{^Category=	OTHER_Punctuation}', "");
    Expect(1, 125280, '\P{Category=	OTHER_Punctuation}', "");
    Expect(0, 125280, '\P{^Category=	OTHER_Punctuation}', "");
    Error('\p{Is_General_Category= po/a/}');
    Error('\P{Is_General_Category= po/a/}');
    Expect(1, 125279, '\p{Is_General_Category=po}', "");
    Expect(0, 125279, '\p{^Is_General_Category=po}', "");
    Expect(0, 125279, '\P{Is_General_Category=po}', "");
    Expect(1, 125279, '\P{^Is_General_Category=po}', "");
    Expect(0, 125280, '\p{Is_General_Category=po}', "");
    Expect(1, 125280, '\p{^Is_General_Category=po}', "");
    Expect(1, 125280, '\P{Is_General_Category=po}', "");
    Expect(0, 125280, '\P{^Is_General_Category=po}', "");
    Expect(1, 125279, '\p{Is_General_Category= po}', "");
    Expect(0, 125279, '\p{^Is_General_Category= po}', "");
    Expect(0, 125279, '\P{Is_General_Category= po}', "");
    Expect(1, 125279, '\P{^Is_General_Category= po}', "");
    Expect(0, 125280, '\p{Is_General_Category= po}', "");
    Expect(1, 125280, '\p{^Is_General_Category= po}', "");
    Expect(1, 125280, '\P{Is_General_Category= po}', "");
    Expect(0, 125280, '\P{^Is_General_Category= po}', "");
    Error('\p{Is_Gc=	Other_Punctuation/a/}');
    Error('\P{Is_Gc=	Other_Punctuation/a/}');
    Expect(1, 125279, '\p{Is_Gc=otherpunctuation}', "");
    Expect(0, 125279, '\p{^Is_Gc=otherpunctuation}', "");
    Expect(0, 125279, '\P{Is_Gc=otherpunctuation}', "");
    Expect(1, 125279, '\P{^Is_Gc=otherpunctuation}', "");
    Expect(0, 125280, '\p{Is_Gc=otherpunctuation}', "");
    Expect(1, 125280, '\p{^Is_Gc=otherpunctuation}', "");
    Expect(1, 125280, '\P{Is_Gc=otherpunctuation}', "");
    Expect(0, 125280, '\P{^Is_Gc=otherpunctuation}', "");
    Expect(1, 125279, '\p{Is_Gc=-Other_punctuation}', "");
    Expect(0, 125279, '\p{^Is_Gc=-Other_punctuation}', "");
    Expect(0, 125279, '\P{Is_Gc=-Other_punctuation}', "");
    Expect(1, 125279, '\P{^Is_Gc=-Other_punctuation}', "");
    Expect(0, 125280, '\p{Is_Gc=-Other_punctuation}', "");
    Expect(1, 125280, '\p{^Is_Gc=-Other_punctuation}', "");
    Expect(1, 125280, '\P{Is_Gc=-Other_punctuation}', "");
    Expect(0, 125280, '\P{^Is_Gc=-Other_punctuation}', "");
    Error('\p{Is_Category=/a/	-PO}');
    Error('\P{Is_Category=/a/	-PO}');
    Expect(1, 125279, '\p{Is_Category:po}', "");
    Expect(0, 125279, '\p{^Is_Category:po}', "");
    Expect(0, 125279, '\P{Is_Category:po}', "");
    Expect(1, 125279, '\P{^Is_Category:po}', "");
    Expect(0, 125280, '\p{Is_Category:po}', "");
    Expect(1, 125280, '\p{^Is_Category:po}', "");
    Expect(1, 125280, '\P{Is_Category:po}', "");
    Expect(0, 125280, '\P{^Is_Category:po}', "");
    Expect(1, 125279, '\p{Is_Category= PO}', "");
    Expect(0, 125279, '\p{^Is_Category= PO}', "");
    Expect(0, 125279, '\P{Is_Category= PO}', "");
    Expect(1, 125279, '\P{^Is_Category= PO}', "");
    Expect(0, 125280, '\p{Is_Category= PO}', "");
    Expect(1, 125280, '\p{^Is_Category= PO}', "");
    Expect(1, 125280, '\P{Is_Category= PO}', "");
    Expect(0, 125280, '\P{^Is_Category= PO}', "");
    Error('\p{General_Category=/a/Open_Punctuation}');
    Error('\P{General_Category=/a/Open_Punctuation}');
    Expect(1, 65378, '\p{General_Category=:\AOpen_Punctuation\z:}', "");;
    Expect(0, 65379, '\p{General_Category=:\AOpen_Punctuation\z:}', "");;
    Expect(1, 65378, '\p{General_Category=openpunctuation}', "");
    Expect(0, 65378, '\p{^General_Category=openpunctuation}', "");
    Expect(0, 65378, '\P{General_Category=openpunctuation}', "");
    Expect(1, 65378, '\P{^General_Category=openpunctuation}', "");
    Expect(0, 65379, '\p{General_Category=openpunctuation}', "");
    Expect(1, 65379, '\p{^General_Category=openpunctuation}', "");
    Expect(1, 65379, '\P{General_Category=openpunctuation}', "");
    Expect(0, 65379, '\P{^General_Category=openpunctuation}', "");
    Expect(1, 65378, '\p{General_Category=:\Aopenpunctuation\z:}', "");;
    Expect(0, 65379, '\p{General_Category=:\Aopenpunctuation\z:}', "");;
    Expect(1, 65378, '\p{General_Category=	-OPEN_Punctuation}', "");
    Expect(0, 65378, '\p{^General_Category=	-OPEN_Punctuation}', "");
    Expect(0, 65378, '\P{General_Category=	-OPEN_Punctuation}', "");
    Expect(1, 65378, '\P{^General_Category=	-OPEN_Punctuation}', "");
    Expect(0, 65379, '\p{General_Category=	-OPEN_Punctuation}', "");
    Expect(1, 65379, '\p{^General_Category=	-OPEN_Punctuation}', "");
    Expect(1, 65379, '\P{General_Category=	-OPEN_Punctuation}', "");
    Expect(0, 65379, '\P{^General_Category=	-OPEN_Punctuation}', "");
    Error('\p{Gc=:=	_Ps}');
    Error('\P{Gc=:=	_Ps}');
    Expect(1, 65378, '\p{Gc=:\APs\z:}', "");;
    Expect(0, 65379, '\p{Gc=:\APs\z:}', "");;
    Expect(1, 65378, '\p{Gc:   ps}', "");
    Expect(0, 65378, '\p{^Gc:   ps}', "");
    Expect(0, 65378, '\P{Gc:   ps}', "");
    Expect(1, 65378, '\P{^Gc:   ps}', "");
    Expect(0, 65379, '\p{Gc:   ps}', "");
    Expect(1, 65379, '\p{^Gc:   ps}', "");
    Expect(1, 65379, '\P{Gc:   ps}', "");
    Expect(0, 65379, '\P{^Gc:   ps}', "");
    Expect(1, 65378, '\p{Gc=:\Aps\z:}', "");;
    Expect(0, 65379, '\p{Gc=:\Aps\z:}', "");;
    Expect(1, 65378, '\p{Gc=  Ps}', "");
    Expect(0, 65378, '\p{^Gc=  Ps}', "");
    Expect(0, 65378, '\P{Gc=  Ps}', "");
    Expect(1, 65378, '\P{^Gc=  Ps}', "");
    Expect(0, 65379, '\p{Gc=  Ps}', "");
    Expect(1, 65379, '\p{^Gc=  Ps}', "");
    Expect(1, 65379, '\P{Gc=  Ps}', "");
    Expect(0, 65379, '\P{^Gc=  Ps}', "");
    Error('\p{Category=_OPEN_punctuation:=}');
    Error('\P{Category=_OPEN_punctuation:=}');
    Expect(1, 65378, '\p{Category=:\AOpen_Punctuation\z:}', "");;
    Expect(0, 65379, '\p{Category=:\AOpen_Punctuation\z:}', "");;
    Expect(1, 65378, '\p{Category=openpunctuation}', "");
    Expect(0, 65378, '\p{^Category=openpunctuation}', "");
    Expect(0, 65378, '\P{Category=openpunctuation}', "");
    Expect(1, 65378, '\P{^Category=openpunctuation}', "");
    Expect(0, 65379, '\p{Category=openpunctuation}', "");
    Expect(1, 65379, '\p{^Category=openpunctuation}', "");
    Expect(1, 65379, '\P{Category=openpunctuation}', "");
    Expect(0, 65379, '\P{^Category=openpunctuation}', "");
    Expect(1, 65378, '\p{Category=:\Aopenpunctuation\z:}', "");;
    Expect(0, 65379, '\p{Category=:\Aopenpunctuation\z:}', "");;
    Expect(1, 65378, '\p{Category=_open_Punctuation}', "");
    Expect(0, 65378, '\p{^Category=_open_Punctuation}', "");
    Expect(0, 65378, '\P{Category=_open_Punctuation}', "");
    Expect(1, 65378, '\P{^Category=_open_Punctuation}', "");
    Expect(0, 65379, '\p{Category=_open_Punctuation}', "");
    Expect(1, 65379, '\p{^Category=_open_Punctuation}', "");
    Expect(1, 65379, '\P{Category=_open_Punctuation}', "");
    Expect(0, 65379, '\P{^Category=_open_Punctuation}', "");
    Error('\p{Is_General_Category=_/a/Ps}');
    Error('\P{Is_General_Category=_/a/Ps}');
    Expect(1, 65378, '\p{Is_General_Category=ps}', "");
    Expect(0, 65378, '\p{^Is_General_Category=ps}', "");
    Expect(0, 65378, '\P{Is_General_Category=ps}', "");
    Expect(1, 65378, '\P{^Is_General_Category=ps}', "");
    Expect(0, 65379, '\p{Is_General_Category=ps}', "");
    Expect(1, 65379, '\p{^Is_General_Category=ps}', "");
    Expect(1, 65379, '\P{Is_General_Category=ps}', "");
    Expect(0, 65379, '\P{^Is_General_Category=ps}', "");
    Expect(1, 65378, '\p{Is_General_Category:	 	Ps}', "");
    Expect(0, 65378, '\p{^Is_General_Category:	 	Ps}', "");
    Expect(0, 65378, '\P{Is_General_Category:	 	Ps}', "");
    Expect(1, 65378, '\P{^Is_General_Category:	 	Ps}', "");
    Expect(0, 65379, '\p{Is_General_Category:	 	Ps}', "");
    Expect(1, 65379, '\p{^Is_General_Category:	 	Ps}', "");
    Expect(1, 65379, '\P{Is_General_Category:	 	Ps}', "");
    Expect(0, 65379, '\P{^Is_General_Category:	 	Ps}', "");
    Error('\p{Is_Gc=:=	 Open_PUNCTUATION}');
    Error('\P{Is_Gc=:=	 Open_PUNCTUATION}');
    Expect(1, 65378, '\p{Is_Gc=openpunctuation}', "");
    Expect(0, 65378, '\p{^Is_Gc=openpunctuation}', "");
    Expect(0, 65378, '\P{Is_Gc=openpunctuation}', "");
    Expect(1, 65378, '\P{^Is_Gc=openpunctuation}', "");
    Expect(0, 65379, '\p{Is_Gc=openpunctuation}', "");
    Expect(1, 65379, '\p{^Is_Gc=openpunctuation}', "");
    Expect(1, 65379, '\P{Is_Gc=openpunctuation}', "");
    Expect(0, 65379, '\P{^Is_Gc=openpunctuation}', "");
    Expect(1, 65378, '\p{Is_Gc=Open_PUNCTUATION}', "");
    Expect(0, 65378, '\p{^Is_Gc=Open_PUNCTUATION}', "");
    Expect(0, 65378, '\P{Is_Gc=Open_PUNCTUATION}', "");
    Expect(1, 65378, '\P{^Is_Gc=Open_PUNCTUATION}', "");
    Expect(0, 65379, '\p{Is_Gc=Open_PUNCTUATION}', "");
    Expect(1, 65379, '\p{^Is_Gc=Open_PUNCTUATION}', "");
    Expect(1, 65379, '\P{Is_Gc=Open_PUNCTUATION}', "");
    Expect(0, 65379, '\P{^Is_Gc=Open_PUNCTUATION}', "");
    Error('\p{Is_Category=/a/ _Ps}');
    Error('\P{Is_Category=/a/ _Ps}');
    Expect(1, 65378, '\p{Is_Category=ps}', "");
    Expect(0, 65378, '\p{^Is_Category=ps}', "");
    Expect(0, 65378, '\P{Is_Category=ps}', "");
    Expect(1, 65378, '\P{^Is_Category=ps}', "");
    Expect(0, 65379, '\p{Is_Category=ps}', "");
    Expect(1, 65379, '\p{^Is_Category=ps}', "");
    Expect(1, 65379, '\P{Is_Category=ps}', "");
    Expect(0, 65379, '\P{^Is_Category=ps}', "");
    Expect(1, 65378, '\p{Is_Category= _Ps}', "");
    Expect(0, 65378, '\p{^Is_Category= _Ps}', "");
    Expect(0, 65378, '\P{Is_Category= _Ps}', "");
    Expect(1, 65378, '\P{^Is_Category= _Ps}', "");
    Expect(0, 65379, '\p{Is_Category= _Ps}', "");
    Expect(1, 65379, '\p{^Is_Category= _Ps}', "");
    Expect(1, 65379, '\P{Is_Category= _Ps}', "");
    Expect(0, 65379, '\P{^Is_Category= _Ps}', "");
    Error('\p{General_Category=:=__Symbol}');
    Error('\P{General_Category=:=__Symbol}');
    Expect(1, 129685, '\p{General_Category=:\ASymbol\z:}', "");;
    Expect(0, 129686, '\p{General_Category=:\ASymbol\z:}', "");;
    Expect(1, 129685, '\p{General_Category=symbol}', "");
    Expect(0, 129685, '\p{^General_Category=symbol}', "");
    Expect(0, 129685, '\P{General_Category=symbol}', "");
    Expect(1, 129685, '\P{^General_Category=symbol}', "");
    Expect(0, 129686, '\p{General_Category=symbol}', "");
    Expect(1, 129686, '\p{^General_Category=symbol}', "");
    Expect(1, 129686, '\P{General_Category=symbol}', "");
    Expect(0, 129686, '\P{^General_Category=symbol}', "");
    Expect(1, 129685, '\p{General_Category=:\Asymbol\z:}', "");;
    Expect(0, 129686, '\p{General_Category=:\Asymbol\z:}', "");;
    Expect(1, 129685, '\p{General_Category= Symbol}', "");
    Expect(0, 129685, '\p{^General_Category= Symbol}', "");
    Expect(0, 129685, '\P{General_Category= Symbol}', "");
    Expect(1, 129685, '\P{^General_Category= Symbol}', "");
    Expect(0, 129686, '\p{General_Category= Symbol}', "");
    Expect(1, 129686, '\p{^General_Category= Symbol}', "");
    Expect(1, 129686, '\P{General_Category= Symbol}', "");
    Expect(0, 129686, '\P{^General_Category= Symbol}', "");
    Error('\p{Gc= /a/S}');
    Error('\P{Gc= /a/S}');
    Expect(1, 129685, '\p{Gc=:\AS\z:}', "");;
    Expect(0, 129686, '\p{Gc=:\AS\z:}', "");;
    Expect(1, 129685, '\p{Gc=s}', "");
    Expect(0, 129685, '\p{^Gc=s}', "");
    Expect(0, 129685, '\P{Gc=s}', "");
    Expect(1, 129685, '\P{^Gc=s}', "");
    Expect(0, 129686, '\p{Gc=s}', "");
    Expect(1, 129686, '\p{^Gc=s}', "");
    Expect(1, 129686, '\P{Gc=s}', "");
    Expect(0, 129686, '\P{^Gc=s}', "");
    Expect(1, 129685, '\p{Gc=:\As\z:}', "");;
    Expect(0, 129686, '\p{Gc=:\As\z:}', "");;
    Expect(1, 129685, '\p{Gc= _s}', "");
    Expect(0, 129685, '\p{^Gc= _s}', "");
    Expect(0, 129685, '\P{Gc= _s}', "");
    Expect(1, 129685, '\P{^Gc= _s}', "");
    Expect(0, 129686, '\p{Gc= _s}', "");
    Expect(1, 129686, '\p{^Gc= _s}', "");
    Expect(1, 129686, '\P{Gc= _s}', "");
    Expect(0, 129686, '\P{^Gc= _s}', "");
    Error('\p{Category=/a/- SYMBOL}');
    Error('\P{Category=/a/- SYMBOL}');
    Expect(1, 129685, '\p{Category=:\ASymbol\z:}', "");;
    Expect(0, 129686, '\p{Category=:\ASymbol\z:}', "");;
    Expect(1, 129685, '\p{Category=symbol}', "");
    Expect(0, 129685, '\p{^Category=symbol}', "");
    Expect(0, 129685, '\P{Category=symbol}', "");
    Expect(1, 129685, '\P{^Category=symbol}', "");
    Expect(0, 129686, '\p{Category=symbol}', "");
    Expect(1, 129686, '\p{^Category=symbol}', "");
    Expect(1, 129686, '\P{Category=symbol}', "");
    Expect(0, 129686, '\P{^Category=symbol}', "");
    Expect(1, 129685, '\p{Category=:\Asymbol\z:}', "");;
    Expect(0, 129686, '\p{Category=:\Asymbol\z:}', "");;
    Expect(1, 129685, '\p{Category= 	symbol}', "");
    Expect(0, 129685, '\p{^Category= 	symbol}', "");
    Expect(0, 129685, '\P{Category= 	symbol}', "");
    Expect(1, 129685, '\P{^Category= 	symbol}', "");
    Expect(0, 129686, '\p{Category= 	symbol}', "");
    Expect(1, 129686, '\p{^Category= 	symbol}', "");
    Expect(1, 129686, '\P{Category= 	symbol}', "");
    Expect(0, 129686, '\P{^Category= 	symbol}', "");
    Error('\p{Is_General_Category= S/a/}');
    Error('\P{Is_General_Category= S/a/}');
    Expect(1, 129685, '\p{Is_General_Category=s}', "");
    Expect(0, 129685, '\p{^Is_General_Category=s}', "");
    Expect(0, 129685, '\P{Is_General_Category=s}', "");
    Expect(1, 129685, '\P{^Is_General_Category=s}', "");
    Expect(0, 129686, '\p{Is_General_Category=s}', "");
    Expect(1, 129686, '\p{^Is_General_Category=s}', "");
    Expect(1, 129686, '\P{Is_General_Category=s}', "");
    Expect(0, 129686, '\P{^Is_General_Category=s}', "");
    Expect(1, 129685, '\p{Is_General_Category=	S}', "");
    Expect(0, 129685, '\p{^Is_General_Category=	S}', "");
    Expect(0, 129685, '\P{Is_General_Category=	S}', "");
    Expect(1, 129685, '\P{^Is_General_Category=	S}', "");
    Expect(0, 129686, '\p{Is_General_Category=	S}', "");
    Expect(1, 129686, '\p{^Is_General_Category=	S}', "");
    Expect(1, 129686, '\P{Is_General_Category=	S}', "");
    Expect(0, 129686, '\P{^Is_General_Category=	S}', "");
    Error('\p{Is_Gc=	/a/Symbol}');
    Error('\P{Is_Gc=	/a/Symbol}');
    Expect(1, 129685, '\p{Is_Gc=symbol}', "");
    Expect(0, 129685, '\p{^Is_Gc=symbol}', "");
    Expect(0, 129685, '\P{Is_Gc=symbol}', "");
    Expect(1, 129685, '\P{^Is_Gc=symbol}', "");
    Expect(0, 129686, '\p{Is_Gc=symbol}', "");
    Expect(1, 129686, '\p{^Is_Gc=symbol}', "");
    Expect(1, 129686, '\P{Is_Gc=symbol}', "");
    Expect(0, 129686, '\P{^Is_Gc=symbol}', "");
    Expect(1, 129685, '\p{Is_Gc=		Symbol}', "");
    Expect(0, 129685, '\p{^Is_Gc=		Symbol}', "");
    Expect(0, 129685, '\P{Is_Gc=		Symbol}', "");
    Expect(1, 129685, '\P{^Is_Gc=		Symbol}', "");
    Expect(0, 129686, '\p{Is_Gc=		Symbol}', "");
    Expect(1, 129686, '\p{^Is_Gc=		Symbol}', "");
    Expect(1, 129686, '\P{Is_Gc=		Symbol}', "");
    Expect(0, 129686, '\P{^Is_Gc=		Symbol}', "");
    Error('\p{Is_Category=_	S/a/}');
    Error('\P{Is_Category=_	S/a/}');
    Expect(1, 129685, '\p{Is_Category=s}', "");
    Expect(0, 129685, '\p{^Is_Category=s}', "");
    Expect(0, 129685, '\P{Is_Category=s}', "");
    Expect(1, 129685, '\P{^Is_Category=s}', "");
    Expect(0, 129686, '\p{Is_Category=s}', "");
    Expect(1, 129686, '\p{^Is_Category=s}', "");
    Expect(1, 129686, '\P{Is_Category=s}', "");
    Expect(0, 129686, '\P{^Is_Category=s}', "");
    Expect(1, 129685, '\p{Is_Category=_s}', "");
    Expect(0, 129685, '\p{^Is_Category=_s}', "");
    Expect(0, 129685, '\P{Is_Category=_s}', "");
    Expect(1, 129685, '\P{^Is_Category=_s}', "");
    Expect(0, 129686, '\p{Is_Category=_s}', "");
    Expect(1, 129686, '\p{^Is_Category=_s}', "");
    Expect(1, 129686, '\P{Is_Category=_s}', "");
    Expect(0, 129686, '\P{^Is_Category=_s}', "");
    Error('\p{General_Category=_Currency_symbol:=}');
    Error('\P{General_Category=_Currency_symbol:=}');
    Expect(1, 126128, '\p{General_Category=:\ACurrency_Symbol\z:}', "");;
    Expect(0, 126129, '\p{General_Category=:\ACurrency_Symbol\z:}', "");;
    Expect(1, 126128, '\p{General_Category=currencysymbol}', "");
    Expect(0, 126128, '\p{^General_Category=currencysymbol}', "");
    Expect(0, 126128, '\P{General_Category=currencysymbol}', "");
    Expect(1, 126128, '\P{^General_Category=currencysymbol}', "");
    Expect(0, 126129, '\p{General_Category=currencysymbol}', "");
    Expect(1, 126129, '\p{^General_Category=currencysymbol}', "");
    Expect(1, 126129, '\P{General_Category=currencysymbol}', "");
    Expect(0, 126129, '\P{^General_Category=currencysymbol}', "");
    Expect(1, 126128, '\p{General_Category=:\Acurrencysymbol\z:}', "");;
    Expect(0, 126129, '\p{General_Category=:\Acurrencysymbol\z:}', "");;
    Expect(1, 126128, '\p{General_Category=	CURRENCY_Symbol}', "");
    Expect(0, 126128, '\p{^General_Category=	CURRENCY_Symbol}', "");
    Expect(0, 126128, '\P{General_Category=	CURRENCY_Symbol}', "");
    Expect(1, 126128, '\P{^General_Category=	CURRENCY_Symbol}', "");
    Expect(0, 126129, '\p{General_Category=	CURRENCY_Symbol}', "");
    Expect(1, 126129, '\p{^General_Category=	CURRENCY_Symbol}', "");
    Expect(1, 126129, '\P{General_Category=	CURRENCY_Symbol}', "");
    Expect(0, 126129, '\P{^General_Category=	CURRENCY_Symbol}', "");
    Error('\p{Gc=:=-sc}');
    Error('\P{Gc=:=-sc}');
    Expect(1, 126128, '\p{Gc=:\ASc\z:}', "");;
    Expect(0, 126129, '\p{Gc=:\ASc\z:}', "");;
    Expect(1, 126128, '\p{Gc=sc}', "");
    Expect(0, 126128, '\p{^Gc=sc}', "");
    Expect(0, 126128, '\P{Gc=sc}', "");
    Expect(1, 126128, '\P{^Gc=sc}', "");
    Expect(0, 126129, '\p{Gc=sc}', "");
    Expect(1, 126129, '\p{^Gc=sc}', "");
    Expect(1, 126129, '\P{Gc=sc}', "");
    Expect(0, 126129, '\P{^Gc=sc}', "");
    Expect(1, 126128, '\p{Gc=:\Asc\z:}', "");;
    Expect(0, 126129, '\p{Gc=:\Asc\z:}', "");;
    Expect(1, 126128, '\p{Gc=-	SC}', "");
    Expect(0, 126128, '\p{^Gc=-	SC}', "");
    Expect(0, 126128, '\P{Gc=-	SC}', "");
    Expect(1, 126128, '\P{^Gc=-	SC}', "");
    Expect(0, 126129, '\p{Gc=-	SC}', "");
    Expect(1, 126129, '\p{^Gc=-	SC}', "");
    Expect(1, 126129, '\P{Gc=-	SC}', "");
    Expect(0, 126129, '\P{^Gc=-	SC}', "");
    Error('\p{Category=/a/ 	Currency_symbol}');
    Error('\P{Category=/a/ 	Currency_symbol}');
    Expect(1, 126128, '\p{Category=:\ACurrency_Symbol\z:}', "");;
    Expect(0, 126129, '\p{Category=:\ACurrency_Symbol\z:}', "");;
    Expect(1, 126128, '\p{Category=currencysymbol}', "");
    Expect(0, 126128, '\p{^Category=currencysymbol}', "");
    Expect(0, 126128, '\P{Category=currencysymbol}', "");
    Expect(1, 126128, '\P{^Category=currencysymbol}', "");
    Expect(0, 126129, '\p{Category=currencysymbol}', "");
    Expect(1, 126129, '\p{^Category=currencysymbol}', "");
    Expect(1, 126129, '\P{Category=currencysymbol}', "");
    Expect(0, 126129, '\P{^Category=currencysymbol}', "");
    Expect(1, 126128, '\p{Category=:\Acurrencysymbol\z:}', "");;
    Expect(0, 126129, '\p{Category=:\Acurrencysymbol\z:}', "");;
    Expect(1, 126128, '\p{Category=_Currency_Symbol}', "");
    Expect(0, 126128, '\p{^Category=_Currency_Symbol}', "");
    Expect(0, 126128, '\P{Category=_Currency_Symbol}', "");
    Expect(1, 126128, '\P{^Category=_Currency_Symbol}', "");
    Expect(0, 126129, '\p{Category=_Currency_Symbol}', "");
    Expect(1, 126129, '\p{^Category=_Currency_Symbol}', "");
    Expect(1, 126129, '\P{Category=_Currency_Symbol}', "");
    Expect(0, 126129, '\P{^Category=_Currency_Symbol}', "");
    Error('\p{Is_General_Category=-	Sc/a/}');
    Error('\P{Is_General_Category=-	Sc/a/}');
    Expect(1, 126128, '\p{Is_General_Category:sc}', "");
    Expect(0, 126128, '\p{^Is_General_Category:sc}', "");
    Expect(0, 126128, '\P{Is_General_Category:sc}', "");
    Expect(1, 126128, '\P{^Is_General_Category:sc}', "");
    Expect(0, 126129, '\p{Is_General_Category:sc}', "");
    Expect(1, 126129, '\p{^Is_General_Category:sc}', "");
    Expect(1, 126129, '\P{Is_General_Category:sc}', "");
    Expect(0, 126129, '\P{^Is_General_Category:sc}', "");
    Expect(1, 126128, '\p{Is_General_Category=_ Sc}', "");
    Expect(0, 126128, '\p{^Is_General_Category=_ Sc}', "");
    Expect(0, 126128, '\P{Is_General_Category=_ Sc}', "");
    Expect(1, 126128, '\P{^Is_General_Category=_ Sc}', "");
    Expect(0, 126129, '\p{Is_General_Category=_ Sc}', "");
    Expect(1, 126129, '\p{^Is_General_Category=_ Sc}', "");
    Expect(1, 126129, '\P{Is_General_Category=_ Sc}', "");
    Expect(0, 126129, '\P{^Is_General_Category=_ Sc}', "");
    Error('\p{Is_Gc=/a/	Currency_Symbol}');
    Error('\P{Is_Gc=/a/	Currency_Symbol}');
    Expect(1, 126128, '\p{Is_Gc=currencysymbol}', "");
    Expect(0, 126128, '\p{^Is_Gc=currencysymbol}', "");
    Expect(0, 126128, '\P{Is_Gc=currencysymbol}', "");
    Expect(1, 126128, '\P{^Is_Gc=currencysymbol}', "");
    Expect(0, 126129, '\p{Is_Gc=currencysymbol}', "");
    Expect(1, 126129, '\p{^Is_Gc=currencysymbol}', "");
    Expect(1, 126129, '\P{Is_Gc=currencysymbol}', "");
    Expect(0, 126129, '\P{^Is_Gc=currencysymbol}', "");
    Expect(1, 126128, '\p{Is_Gc=	CURRENCY_symbol}', "");
    Expect(0, 126128, '\p{^Is_Gc=	CURRENCY_symbol}', "");
    Expect(0, 126128, '\P{Is_Gc=	CURRENCY_symbol}', "");
    Expect(1, 126128, '\P{^Is_Gc=	CURRENCY_symbol}', "");
    Expect(0, 126129, '\p{Is_Gc=	CURRENCY_symbol}', "");
    Expect(1, 126129, '\p{^Is_Gc=	CURRENCY_symbol}', "");
    Expect(1, 126129, '\P{Is_Gc=	CURRENCY_symbol}', "");
    Expect(0, 126129, '\P{^Is_Gc=	CURRENCY_symbol}', "");
    Error('\p{Is_Category=/a/  Sc}');
    Error('\P{Is_Category=/a/  Sc}');
    Expect(1, 126128, '\p{Is_Category=sc}', "");
    Expect(0, 126128, '\p{^Is_Category=sc}', "");
    Expect(0, 126128, '\P{Is_Category=sc}', "");
    Expect(1, 126128, '\P{^Is_Category=sc}', "");
    Expect(0, 126129, '\p{Is_Category=sc}', "");
    Expect(1, 126129, '\p{^Is_Category=sc}', "");
    Expect(1, 126129, '\P{Is_Category=sc}', "");
    Expect(0, 126129, '\P{^Is_Category=sc}', "");
    Expect(1, 126128, '\p{Is_Category: -sc}', "");
    Expect(0, 126128, '\p{^Is_Category: -sc}', "");
    Expect(0, 126128, '\P{Is_Category: -sc}', "");
    Expect(1, 126128, '\P{^Is_Category: -sc}', "");
    Expect(0, 126129, '\p{Is_Category: -sc}', "");
    Expect(1, 126129, '\p{^Is_Category: -sc}', "");
    Expect(1, 126129, '\P{Is_Category: -sc}', "");
    Expect(0, 126129, '\P{^Is_Category: -sc}', "");
    Error('\p{General_Category=-:=modifier_symbol}');
    Error('\P{General_Category=-:=modifier_symbol}');
    Expect(1, 127999, '\p{General_Category=:\AModifier_Symbol\z:}', "");;
    Expect(0, 128000, '\p{General_Category=:\AModifier_Symbol\z:}', "");;
    Expect(1, 127999, '\p{General_Category:	modifiersymbol}', "");
    Expect(0, 127999, '\p{^General_Category:	modifiersymbol}', "");
    Expect(0, 127999, '\P{General_Category:	modifiersymbol}', "");
    Expect(1, 127999, '\P{^General_Category:	modifiersymbol}', "");
    Expect(0, 128000, '\p{General_Category:	modifiersymbol}', "");
    Expect(1, 128000, '\p{^General_Category:	modifiersymbol}', "");
    Expect(1, 128000, '\P{General_Category:	modifiersymbol}', "");
    Expect(0, 128000, '\P{^General_Category:	modifiersymbol}', "");
    Expect(1, 127999, '\p{General_Category=:\Amodifiersymbol\z:}', "");;
    Expect(0, 128000, '\p{General_Category=:\Amodifiersymbol\z:}', "");;
    Expect(1, 127999, '\p{General_Category= _MODIFIER_symbol}', "");
    Expect(0, 127999, '\p{^General_Category= _MODIFIER_symbol}', "");
    Expect(0, 127999, '\P{General_Category= _MODIFIER_symbol}', "");
    Expect(1, 127999, '\P{^General_Category= _MODIFIER_symbol}', "");
    Expect(0, 128000, '\p{General_Category= _MODIFIER_symbol}', "");
    Expect(1, 128000, '\p{^General_Category= _MODIFIER_symbol}', "");
    Expect(1, 128000, '\P{General_Category= _MODIFIER_symbol}', "");
    Expect(0, 128000, '\P{^General_Category= _MODIFIER_symbol}', "");
    Error('\p{Gc=	Sk/a/}');
    Error('\P{Gc=	Sk/a/}');
    Expect(1, 127999, '\p{Gc=:\ASk\z:}', "");;
    Expect(0, 128000, '\p{Gc=:\ASk\z:}', "");;
    Expect(1, 127999, '\p{Gc=sk}', "");
    Expect(0, 127999, '\p{^Gc=sk}', "");
    Expect(0, 127999, '\P{Gc=sk}', "");
    Expect(1, 127999, '\P{^Gc=sk}', "");
    Expect(0, 128000, '\p{Gc=sk}', "");
    Expect(1, 128000, '\p{^Gc=sk}', "");
    Expect(1, 128000, '\P{Gc=sk}', "");
    Expect(0, 128000, '\P{^Gc=sk}', "");
    Expect(1, 127999, '\p{Gc=:\Ask\z:}', "");;
    Expect(0, 128000, '\p{Gc=:\Ask\z:}', "");;
    Expect(1, 127999, '\p{Gc=-_sk}', "");
    Expect(0, 127999, '\p{^Gc=-_sk}', "");
    Expect(0, 127999, '\P{Gc=-_sk}', "");
    Expect(1, 127999, '\P{^Gc=-_sk}', "");
    Expect(0, 128000, '\p{Gc=-_sk}', "");
    Expect(1, 128000, '\p{^Gc=-_sk}', "");
    Expect(1, 128000, '\P{Gc=-_sk}', "");
    Expect(0, 128000, '\P{^Gc=-_sk}', "");
    Error('\p{Category=:=--MODIFIER_Symbol}');
    Error('\P{Category=:=--MODIFIER_Symbol}');
    Expect(1, 127999, '\p{Category=:\AModifier_Symbol\z:}', "");;
    Expect(0, 128000, '\p{Category=:\AModifier_Symbol\z:}', "");;
    Expect(1, 127999, '\p{Category:   modifiersymbol}', "");
    Expect(0, 127999, '\p{^Category:   modifiersymbol}', "");
    Expect(0, 127999, '\P{Category:   modifiersymbol}', "");
    Expect(1, 127999, '\P{^Category:   modifiersymbol}', "");
    Expect(0, 128000, '\p{Category:   modifiersymbol}', "");
    Expect(1, 128000, '\p{^Category:   modifiersymbol}', "");
    Expect(1, 128000, '\P{Category:   modifiersymbol}', "");
    Expect(0, 128000, '\P{^Category:   modifiersymbol}', "");
    Expect(1, 127999, '\p{Category=:\Amodifiersymbol\z:}', "");;
    Expect(0, 128000, '\p{Category=:\Amodifiersymbol\z:}', "");;
    Expect(1, 127999, '\p{Category= modifier_symbol}', "");
    Expect(0, 127999, '\p{^Category= modifier_symbol}', "");
    Expect(0, 127999, '\P{Category= modifier_symbol}', "");
    Expect(1, 127999, '\P{^Category= modifier_symbol}', "");
    Expect(0, 128000, '\p{Category= modifier_symbol}', "");
    Expect(1, 128000, '\p{^Category= modifier_symbol}', "");
    Expect(1, 128000, '\P{Category= modifier_symbol}', "");
    Expect(0, 128000, '\P{^Category= modifier_symbol}', "");
    Error('\p{Is_General_Category=_:=Sk}');
    Error('\P{Is_General_Category=_:=Sk}');
    Expect(1, 127999, '\p{Is_General_Category=sk}', "");
    Expect(0, 127999, '\p{^Is_General_Category=sk}', "");
    Expect(0, 127999, '\P{Is_General_Category=sk}', "");
    Expect(1, 127999, '\P{^Is_General_Category=sk}', "");
    Expect(0, 128000, '\p{Is_General_Category=sk}', "");
    Expect(1, 128000, '\p{^Is_General_Category=sk}', "");
    Expect(1, 128000, '\P{Is_General_Category=sk}', "");
    Expect(0, 128000, '\P{^Is_General_Category=sk}', "");
    Expect(1, 127999, '\p{Is_General_Category=	SK}', "");
    Expect(0, 127999, '\p{^Is_General_Category=	SK}', "");
    Expect(0, 127999, '\P{Is_General_Category=	SK}', "");
    Expect(1, 127999, '\P{^Is_General_Category=	SK}', "");
    Expect(0, 128000, '\p{Is_General_Category=	SK}', "");
    Expect(1, 128000, '\p{^Is_General_Category=	SK}', "");
    Expect(1, 128000, '\P{Is_General_Category=	SK}', "");
    Expect(0, 128000, '\P{^Is_General_Category=	SK}', "");
    Error('\p{Is_Gc=-/a/Modifier_SYMBOL}');
    Error('\P{Is_Gc=-/a/Modifier_SYMBOL}');
    Expect(1, 127999, '\p{Is_Gc=modifiersymbol}', "");
    Expect(0, 127999, '\p{^Is_Gc=modifiersymbol}', "");
    Expect(0, 127999, '\P{Is_Gc=modifiersymbol}', "");
    Expect(1, 127999, '\P{^Is_Gc=modifiersymbol}', "");
    Expect(0, 128000, '\p{Is_Gc=modifiersymbol}', "");
    Expect(1, 128000, '\p{^Is_Gc=modifiersymbol}', "");
    Expect(1, 128000, '\P{Is_Gc=modifiersymbol}', "");
    Expect(0, 128000, '\P{^Is_Gc=modifiersymbol}', "");
    Expect(1, 127999, '\p{Is_Gc=-modifier_Symbol}', "");
    Expect(0, 127999, '\p{^Is_Gc=-modifier_Symbol}', "");
    Expect(0, 127999, '\P{Is_Gc=-modifier_Symbol}', "");
    Expect(1, 127999, '\P{^Is_Gc=-modifier_Symbol}', "");
    Expect(0, 128000, '\p{Is_Gc=-modifier_Symbol}', "");
    Expect(1, 128000, '\p{^Is_Gc=-modifier_Symbol}', "");
    Expect(1, 128000, '\P{Is_Gc=-modifier_Symbol}', "");
    Expect(0, 128000, '\P{^Is_Gc=-modifier_Symbol}', "");
    Error('\p{Is_Category:   -Sk/a/}');
    Error('\P{Is_Category:   -Sk/a/}');
    Expect(1, 127999, '\p{Is_Category=sk}', "");
    Expect(0, 127999, '\p{^Is_Category=sk}', "");
    Expect(0, 127999, '\P{Is_Category=sk}', "");
    Expect(1, 127999, '\P{^Is_Category=sk}', "");
    Expect(0, 128000, '\p{Is_Category=sk}', "");
    Expect(1, 128000, '\p{^Is_Category=sk}', "");
    Expect(1, 128000, '\P{Is_Category=sk}', "");
    Expect(0, 128000, '\P{^Is_Category=sk}', "");
    Expect(1, 127999, '\p{Is_Category=_SK}', "");
    Expect(0, 127999, '\p{^Is_Category=_SK}', "");
    Expect(0, 127999, '\P{Is_Category=_SK}', "");
    Expect(1, 127999, '\P{^Is_Category=_SK}', "");
    Expect(0, 128000, '\p{Is_Category=_SK}', "");
    Expect(1, 128000, '\p{^Is_Category=_SK}', "");
    Expect(1, 128000, '\P{Is_Category=_SK}', "");
    Expect(0, 128000, '\P{^Is_Category=_SK}', "");
    Error('\p{General_Category=	-math_Symbol:=}');
    Error('\P{General_Category=	-math_Symbol:=}');
    Expect(1, 126705, '\p{General_Category=:\AMath_Symbol\z:}', "");;
    Expect(0, 126706, '\p{General_Category=:\AMath_Symbol\z:}', "");;
    Expect(1, 126705, '\p{General_Category=mathsymbol}', "");
    Expect(0, 126705, '\p{^General_Category=mathsymbol}', "");
    Expect(0, 126705, '\P{General_Category=mathsymbol}', "");
    Expect(1, 126705, '\P{^General_Category=mathsymbol}', "");
    Expect(0, 126706, '\p{General_Category=mathsymbol}', "");
    Expect(1, 126706, '\p{^General_Category=mathsymbol}', "");
    Expect(1, 126706, '\P{General_Category=mathsymbol}', "");
    Expect(0, 126706, '\P{^General_Category=mathsymbol}', "");
    Expect(1, 126705, '\p{General_Category=:\Amathsymbol\z:}', "");;
    Expect(0, 126706, '\p{General_Category=:\Amathsymbol\z:}', "");;
    Expect(1, 126705, '\p{General_Category=	math_Symbol}', "");
    Expect(0, 126705, '\p{^General_Category=	math_Symbol}', "");
    Expect(0, 126705, '\P{General_Category=	math_Symbol}', "");
    Expect(1, 126705, '\P{^General_Category=	math_Symbol}', "");
    Expect(0, 126706, '\p{General_Category=	math_Symbol}', "");
    Expect(1, 126706, '\p{^General_Category=	math_Symbol}', "");
    Expect(1, 126706, '\P{General_Category=	math_Symbol}', "");
    Expect(0, 126706, '\P{^General_Category=	math_Symbol}', "");
    Error('\p{Gc=	/a/Sm}');
    Error('\P{Gc=	/a/Sm}');
    Expect(1, 126705, '\p{Gc=:\ASm\z:}', "");;
    Expect(0, 126706, '\p{Gc=:\ASm\z:}', "");;
    Expect(1, 126705, '\p{Gc:   sm}', "");
    Expect(0, 126705, '\p{^Gc:   sm}', "");
    Expect(0, 126705, '\P{Gc:   sm}', "");
    Expect(1, 126705, '\P{^Gc:   sm}', "");
    Expect(0, 126706, '\p{Gc:   sm}', "");
    Expect(1, 126706, '\p{^Gc:   sm}', "");
    Expect(1, 126706, '\P{Gc:   sm}', "");
    Expect(0, 126706, '\P{^Gc:   sm}', "");
    Expect(1, 126705, '\p{Gc=:\Asm\z:}', "");;
    Expect(0, 126706, '\p{Gc=:\Asm\z:}', "");;
    Expect(1, 126705, '\p{Gc=__Sm}', "");
    Expect(0, 126705, '\p{^Gc=__Sm}', "");
    Expect(0, 126705, '\P{Gc=__Sm}', "");
    Expect(1, 126705, '\P{^Gc=__Sm}', "");
    Expect(0, 126706, '\p{Gc=__Sm}', "");
    Expect(1, 126706, '\p{^Gc=__Sm}', "");
    Expect(1, 126706, '\P{Gc=__Sm}', "");
    Expect(0, 126706, '\P{^Gc=__Sm}', "");
    Error('\p{Category:   _/a/Math_symbol}');
    Error('\P{Category:   _/a/Math_symbol}');
    Expect(1, 126705, '\p{Category=:\AMath_Symbol\z:}', "");;
    Expect(0, 126706, '\p{Category=:\AMath_Symbol\z:}', "");;
    Expect(1, 126705, '\p{Category=mathsymbol}', "");
    Expect(0, 126705, '\p{^Category=mathsymbol}', "");
    Expect(0, 126705, '\P{Category=mathsymbol}', "");
    Expect(1, 126705, '\P{^Category=mathsymbol}', "");
    Expect(0, 126706, '\p{Category=mathsymbol}', "");
    Expect(1, 126706, '\p{^Category=mathsymbol}', "");
    Expect(1, 126706, '\P{Category=mathsymbol}', "");
    Expect(0, 126706, '\P{^Category=mathsymbol}', "");
    Expect(1, 126705, '\p{Category=:\Amathsymbol\z:}', "");;
    Expect(0, 126706, '\p{Category=:\Amathsymbol\z:}', "");;
    Expect(1, 126705, '\p{Category=	 MATH_symbol}', "");
    Expect(0, 126705, '\p{^Category=	 MATH_symbol}', "");
    Expect(0, 126705, '\P{Category=	 MATH_symbol}', "");
    Expect(1, 126705, '\P{^Category=	 MATH_symbol}', "");
    Expect(0, 126706, '\p{Category=	 MATH_symbol}', "");
    Expect(1, 126706, '\p{^Category=	 MATH_symbol}', "");
    Expect(1, 126706, '\P{Category=	 MATH_symbol}', "");
    Expect(0, 126706, '\P{^Category=	 MATH_symbol}', "");
    Error('\p{Is_General_Category=_:=Sm}');
    Error('\P{Is_General_Category=_:=Sm}');
    Expect(1, 126705, '\p{Is_General_Category=sm}', "");
    Expect(0, 126705, '\p{^Is_General_Category=sm}', "");
    Expect(0, 126705, '\P{Is_General_Category=sm}', "");
    Expect(1, 126705, '\P{^Is_General_Category=sm}', "");
    Expect(0, 126706, '\p{Is_General_Category=sm}', "");
    Expect(1, 126706, '\p{^Is_General_Category=sm}', "");
    Expect(1, 126706, '\P{Is_General_Category=sm}', "");
    Expect(0, 126706, '\P{^Is_General_Category=sm}', "");
    Expect(1, 126705, '\p{Is_General_Category=_-SM}', "");
    Expect(0, 126705, '\p{^Is_General_Category=_-SM}', "");
    Expect(0, 126705, '\P{Is_General_Category=_-SM}', "");
    Expect(1, 126705, '\P{^Is_General_Category=_-SM}', "");
    Expect(0, 126706, '\p{Is_General_Category=_-SM}', "");
    Expect(1, 126706, '\p{^Is_General_Category=_-SM}', "");
    Expect(1, 126706, '\P{Is_General_Category=_-SM}', "");
    Expect(0, 126706, '\P{^Is_General_Category=_-SM}', "");
    Error('\p{Is_Gc=:=	MATH_symbol}');
    Error('\P{Is_Gc=:=	MATH_symbol}');
    Expect(1, 126705, '\p{Is_Gc:	mathsymbol}', "");
    Expect(0, 126705, '\p{^Is_Gc:	mathsymbol}', "");
    Expect(0, 126705, '\P{Is_Gc:	mathsymbol}', "");
    Expect(1, 126705, '\P{^Is_Gc:	mathsymbol}', "");
    Expect(0, 126706, '\p{Is_Gc:	mathsymbol}', "");
    Expect(1, 126706, '\p{^Is_Gc:	mathsymbol}', "");
    Expect(1, 126706, '\P{Is_Gc:	mathsymbol}', "");
    Expect(0, 126706, '\P{^Is_Gc:	mathsymbol}', "");
    Expect(1, 126705, '\p{Is_Gc= _Math_Symbol}', "");
    Expect(0, 126705, '\p{^Is_Gc= _Math_Symbol}', "");
    Expect(0, 126705, '\P{Is_Gc= _Math_Symbol}', "");
    Expect(1, 126705, '\P{^Is_Gc= _Math_Symbol}', "");
    Expect(0, 126706, '\p{Is_Gc= _Math_Symbol}', "");
    Expect(1, 126706, '\p{^Is_Gc= _Math_Symbol}', "");
    Expect(1, 126706, '\P{Is_Gc= _Math_Symbol}', "");
    Expect(0, 126706, '\P{^Is_Gc= _Math_Symbol}', "");
    Error('\p{Is_Category=:=--sm}');
    Error('\P{Is_Category=:=--sm}');
    Expect(1, 126705, '\p{Is_Category=sm}', "");
    Expect(0, 126705, '\p{^Is_Category=sm}', "");
    Expect(0, 126705, '\P{Is_Category=sm}', "");
    Expect(1, 126705, '\P{^Is_Category=sm}', "");
    Expect(0, 126706, '\p{Is_Category=sm}', "");
    Expect(1, 126706, '\p{^Is_Category=sm}', "");
    Expect(1, 126706, '\P{Is_Category=sm}', "");
    Expect(0, 126706, '\P{^Is_Category=sm}', "");
    Expect(1, 126705, '\p{Is_Category=_SM}', "");
    Expect(0, 126705, '\p{^Is_Category=_SM}', "");
    Expect(0, 126705, '\P{Is_Category=_SM}', "");
    Expect(1, 126705, '\P{^Is_Category=_SM}', "");
    Expect(0, 126706, '\p{Is_Category=_SM}', "");
    Expect(1, 126706, '\p{^Is_Category=_SM}', "");
    Expect(1, 126706, '\P{Is_Category=_SM}', "");
    Expect(0, 126706, '\P{^Is_Category=_SM}', "");
    Error('\p{General_Category= _Other_Symbol/a/}');
    Error('\P{General_Category= _Other_Symbol/a/}');
    Expect(1, 129685, '\p{General_Category=:\AOther_Symbol\z:}', "");;
    Expect(0, 129686, '\p{General_Category=:\AOther_Symbol\z:}', "");;
    Expect(1, 129685, '\p{General_Category=othersymbol}', "");
    Expect(0, 129685, '\p{^General_Category=othersymbol}', "");
    Expect(0, 129685, '\P{General_Category=othersymbol}', "");
    Expect(1, 129685, '\P{^General_Category=othersymbol}', "");
    Expect(0, 129686, '\p{General_Category=othersymbol}', "");
    Expect(1, 129686, '\p{^General_Category=othersymbol}', "");
    Expect(1, 129686, '\P{General_Category=othersymbol}', "");
    Expect(0, 129686, '\P{^General_Category=othersymbol}', "");
    Expect(1, 129685, '\p{General_Category=:\Aothersymbol\z:}', "");;
    Expect(0, 129686, '\p{General_Category=:\Aothersymbol\z:}', "");;
    Expect(1, 129685, '\p{General_Category=_Other_Symbol}', "");
    Expect(0, 129685, '\p{^General_Category=_Other_Symbol}', "");
    Expect(0, 129685, '\P{General_Category=_Other_Symbol}', "");
    Expect(1, 129685, '\P{^General_Category=_Other_Symbol}', "");
    Expect(0, 129686, '\p{General_Category=_Other_Symbol}', "");
    Expect(1, 129686, '\p{^General_Category=_Other_Symbol}', "");
    Expect(1, 129686, '\P{General_Category=_Other_Symbol}', "");
    Expect(0, 129686, '\P{^General_Category=_Other_Symbol}', "");
    Error('\p{Gc:	SO/a/}');
    Error('\P{Gc:	SO/a/}');
    Expect(1, 129685, '\p{Gc=:\ASo\z:}', "");;
    Expect(0, 129686, '\p{Gc=:\ASo\z:}', "");;
    Expect(1, 129685, '\p{Gc=so}', "");
    Expect(0, 129685, '\p{^Gc=so}', "");
    Expect(0, 129685, '\P{Gc=so}', "");
    Expect(1, 129685, '\P{^Gc=so}', "");
    Expect(0, 129686, '\p{Gc=so}', "");
    Expect(1, 129686, '\p{^Gc=so}', "");
    Expect(1, 129686, '\P{Gc=so}', "");
    Expect(0, 129686, '\P{^Gc=so}', "");
    Expect(1, 129685, '\p{Gc=:\Aso\z:}', "");;
    Expect(0, 129686, '\p{Gc=:\Aso\z:}', "");;
    Expect(1, 129685, '\p{Gc:   _So}', "");
    Expect(0, 129685, '\p{^Gc:   _So}', "");
    Expect(0, 129685, '\P{Gc:   _So}', "");
    Expect(1, 129685, '\P{^Gc:   _So}', "");
    Expect(0, 129686, '\p{Gc:   _So}', "");
    Expect(1, 129686, '\p{^Gc:   _So}', "");
    Expect(1, 129686, '\P{Gc:   _So}', "");
    Expect(0, 129686, '\P{^Gc:   _So}', "");
    Error('\p{Category=	other_symbol/a/}');
    Error('\P{Category=	other_symbol/a/}');
    Expect(1, 129685, '\p{Category=:\AOther_Symbol\z:}', "");;
    Expect(0, 129686, '\p{Category=:\AOther_Symbol\z:}', "");;
    Expect(1, 129685, '\p{Category=othersymbol}', "");
    Expect(0, 129685, '\p{^Category=othersymbol}', "");
    Expect(0, 129685, '\P{Category=othersymbol}', "");
    Expect(1, 129685, '\P{^Category=othersymbol}', "");
    Expect(0, 129686, '\p{Category=othersymbol}', "");
    Expect(1, 129686, '\p{^Category=othersymbol}', "");
    Expect(1, 129686, '\P{Category=othersymbol}', "");
    Expect(0, 129686, '\P{^Category=othersymbol}', "");
    Expect(1, 129685, '\p{Category=:\Aothersymbol\z:}', "");;
    Expect(0, 129686, '\p{Category=:\Aothersymbol\z:}', "");;
    Expect(1, 129685, '\p{Category:   	Other_Symbol}', "");
    Expect(0, 129685, '\p{^Category:   	Other_Symbol}', "");
    Expect(0, 129685, '\P{Category:   	Other_Symbol}', "");
    Expect(1, 129685, '\P{^Category:   	Other_Symbol}', "");
    Expect(0, 129686, '\p{Category:   	Other_Symbol}', "");
    Expect(1, 129686, '\p{^Category:   	Other_Symbol}', "");
    Expect(1, 129686, '\P{Category:   	Other_Symbol}', "");
    Expect(0, 129686, '\P{^Category:   	Other_Symbol}', "");
    Error('\p{Is_General_Category=/a/So}');
    Error('\P{Is_General_Category=/a/So}');
    Expect(1, 129685, '\p{Is_General_Category=so}', "");
    Expect(0, 129685, '\p{^Is_General_Category=so}', "");
    Expect(0, 129685, '\P{Is_General_Category=so}', "");
    Expect(1, 129685, '\P{^Is_General_Category=so}', "");
    Expect(0, 129686, '\p{Is_General_Category=so}', "");
    Expect(1, 129686, '\p{^Is_General_Category=so}', "");
    Expect(1, 129686, '\P{Is_General_Category=so}', "");
    Expect(0, 129686, '\P{^Is_General_Category=so}', "");
    Expect(1, 129685, '\p{Is_General_Category=	_So}', "");
    Expect(0, 129685, '\p{^Is_General_Category=	_So}', "");
    Expect(0, 129685, '\P{Is_General_Category=	_So}', "");
    Expect(1, 129685, '\P{^Is_General_Category=	_So}', "");
    Expect(0, 129686, '\p{Is_General_Category=	_So}', "");
    Expect(1, 129686, '\p{^Is_General_Category=	_So}', "");
    Expect(1, 129686, '\P{Is_General_Category=	_So}', "");
    Expect(0, 129686, '\P{^Is_General_Category=	_So}', "");
    Error('\p{Is_Gc= :=other_Symbol}');
    Error('\P{Is_Gc= :=other_Symbol}');
    Expect(1, 129685, '\p{Is_Gc=othersymbol}', "");
    Expect(0, 129685, '\p{^Is_Gc=othersymbol}', "");
    Expect(0, 129685, '\P{Is_Gc=othersymbol}', "");
    Expect(1, 129685, '\P{^Is_Gc=othersymbol}', "");
    Expect(0, 129686, '\p{Is_Gc=othersymbol}', "");
    Expect(1, 129686, '\p{^Is_Gc=othersymbol}', "");
    Expect(1, 129686, '\P{Is_Gc=othersymbol}', "");
    Expect(0, 129686, '\P{^Is_Gc=othersymbol}', "");
    Expect(1, 129685, '\p{Is_Gc=_OTHER_Symbol}', "");
    Expect(0, 129685, '\p{^Is_Gc=_OTHER_Symbol}', "");
    Expect(0, 129685, '\P{Is_Gc=_OTHER_Symbol}', "");
    Expect(1, 129685, '\P{^Is_Gc=_OTHER_Symbol}', "");
    Expect(0, 129686, '\p{Is_Gc=_OTHER_Symbol}', "");
    Expect(1, 129686, '\p{^Is_Gc=_OTHER_Symbol}', "");
    Expect(1, 129686, '\P{Is_Gc=_OTHER_Symbol}', "");
    Expect(0, 129686, '\P{^Is_Gc=_OTHER_Symbol}', "");
    Error('\p{Is_Category=:=so}');
    Error('\P{Is_Category=:=so}');
    Expect(1, 129685, '\p{Is_Category=so}', "");
    Expect(0, 129685, '\p{^Is_Category=so}', "");
    Expect(0, 129685, '\P{Is_Category=so}', "");
    Expect(1, 129685, '\P{^Is_Category=so}', "");
    Expect(0, 129686, '\p{Is_Category=so}', "");
    Expect(1, 129686, '\p{^Is_Category=so}', "");
    Expect(1, 129686, '\P{Is_Category=so}', "");
    Expect(0, 129686, '\P{^Is_Category=so}', "");
    Expect(1, 129685, '\p{Is_Category=-So}', "");
    Expect(0, 129685, '\p{^Is_Category=-So}', "");
    Expect(0, 129685, '\P{Is_Category=-So}', "");
    Expect(1, 129685, '\P{^Is_Category=-So}', "");
    Expect(0, 129686, '\p{Is_Category=-So}', "");
    Expect(1, 129686, '\p{^Is_Category=-So}', "");
    Expect(1, 129686, '\P{Is_Category=-So}', "");
    Expect(0, 129686, '\P{^Is_Category=-So}', "");
    Error('\p{General_Category:			Separator/a/}');
    Error('\P{General_Category:			Separator/a/}');
    Expect(1, 12288, '\p{General_Category=:\ASeparator\z:}', "");;
    Expect(0, 12289, '\p{General_Category=:\ASeparator\z:}', "");;
    Expect(1, 12288, '\p{General_Category=separator}', "");
    Expect(0, 12288, '\p{^General_Category=separator}', "");
    Expect(0, 12288, '\P{General_Category=separator}', "");
    Expect(1, 12288, '\P{^General_Category=separator}', "");
    Expect(0, 12289, '\p{General_Category=separator}', "");
    Expect(1, 12289, '\p{^General_Category=separator}', "");
    Expect(1, 12289, '\P{General_Category=separator}', "");
    Expect(0, 12289, '\P{^General_Category=separator}', "");
    Expect(1, 12288, '\p{General_Category=:\Aseparator\z:}', "");;
    Expect(0, 12289, '\p{General_Category=:\Aseparator\z:}', "");;
    Expect(1, 12288, '\p{General_Category:	__Separator}', "");
    Expect(0, 12288, '\p{^General_Category:	__Separator}', "");
    Expect(0, 12288, '\P{General_Category:	__Separator}', "");
    Expect(1, 12288, '\P{^General_Category:	__Separator}', "");
    Expect(0, 12289, '\p{General_Category:	__Separator}', "");
    Expect(1, 12289, '\p{^General_Category:	__Separator}', "");
    Expect(1, 12289, '\P{General_Category:	__Separator}', "");
    Expect(0, 12289, '\P{^General_Category:	__Separator}', "");
    Error('\p{Gc=:=_Z}');
    Error('\P{Gc=:=_Z}');
    Expect(1, 12288, '\p{Gc=:\AZ\z:}', "");;
    Expect(0, 12289, '\p{Gc=:\AZ\z:}', "");;
    Expect(1, 12288, '\p{Gc=z}', "");
    Expect(0, 12288, '\p{^Gc=z}', "");
    Expect(0, 12288, '\P{Gc=z}', "");
    Expect(1, 12288, '\P{^Gc=z}', "");
    Expect(0, 12289, '\p{Gc=z}', "");
    Expect(1, 12289, '\p{^Gc=z}', "");
    Expect(1, 12289, '\P{Gc=z}', "");
    Expect(0, 12289, '\P{^Gc=z}', "");
    Expect(1, 12288, '\p{Gc=:\Az\z:}', "");;
    Expect(0, 12289, '\p{Gc=:\Az\z:}', "");;
    Expect(1, 12288, '\p{Gc=Z}', "");
    Expect(0, 12288, '\p{^Gc=Z}', "");
    Expect(0, 12288, '\P{Gc=Z}', "");
    Expect(1, 12288, '\P{^Gc=Z}', "");
    Expect(0, 12289, '\p{Gc=Z}', "");
    Expect(1, 12289, '\p{^Gc=Z}', "");
    Expect(1, 12289, '\P{Gc=Z}', "");
    Expect(0, 12289, '\P{^Gc=Z}', "");
    Error('\p{Category::=_	Separator}');
    Error('\P{Category::=_	Separator}');
    Expect(1, 12288, '\p{Category=:\ASeparator\z:}', "");;
    Expect(0, 12289, '\p{Category=:\ASeparator\z:}', "");;
    Expect(1, 12288, '\p{Category=separator}', "");
    Expect(0, 12288, '\p{^Category=separator}', "");
    Expect(0, 12288, '\P{Category=separator}', "");
    Expect(1, 12288, '\P{^Category=separator}', "");
    Expect(0, 12289, '\p{Category=separator}', "");
    Expect(1, 12289, '\p{^Category=separator}', "");
    Expect(1, 12289, '\P{Category=separator}', "");
    Expect(0, 12289, '\P{^Category=separator}', "");
    Expect(1, 12288, '\p{Category=:\Aseparator\z:}', "");;
    Expect(0, 12289, '\p{Category=:\Aseparator\z:}', "");;
    Expect(1, 12288, '\p{Category: -Separator}', "");
    Expect(0, 12288, '\p{^Category: -Separator}', "");
    Expect(0, 12288, '\P{Category: -Separator}', "");
    Expect(1, 12288, '\P{^Category: -Separator}', "");
    Expect(0, 12289, '\p{Category: -Separator}', "");
    Expect(1, 12289, '\p{^Category: -Separator}', "");
    Expect(1, 12289, '\P{Category: -Separator}', "");
    Expect(0, 12289, '\P{^Category: -Separator}', "");
    Error('\p{Is_General_Category=/a/-	z}');
    Error('\P{Is_General_Category=/a/-	z}');
    Expect(1, 12288, '\p{Is_General_Category=z}', "");
    Expect(0, 12288, '\p{^Is_General_Category=z}', "");
    Expect(0, 12288, '\P{Is_General_Category=z}', "");
    Expect(1, 12288, '\P{^Is_General_Category=z}', "");
    Expect(0, 12289, '\p{Is_General_Category=z}', "");
    Expect(1, 12289, '\p{^Is_General_Category=z}', "");
    Expect(1, 12289, '\P{Is_General_Category=z}', "");
    Expect(0, 12289, '\P{^Is_General_Category=z}', "");
    Expect(1, 12288, '\p{Is_General_Category=_	z}', "");
    Expect(0, 12288, '\p{^Is_General_Category=_	z}', "");
    Expect(0, 12288, '\P{Is_General_Category=_	z}', "");
    Expect(1, 12288, '\P{^Is_General_Category=_	z}', "");
    Expect(0, 12289, '\p{Is_General_Category=_	z}', "");
    Expect(1, 12289, '\p{^Is_General_Category=_	z}', "");
    Expect(1, 12289, '\P{Is_General_Category=_	z}', "");
    Expect(0, 12289, '\P{^Is_General_Category=_	z}', "");
    Error('\p{Is_Gc=/a/-Separator}');
    Error('\P{Is_Gc=/a/-Separator}');
    Expect(1, 12288, '\p{Is_Gc=separator}', "");
    Expect(0, 12288, '\p{^Is_Gc=separator}', "");
    Expect(0, 12288, '\P{Is_Gc=separator}', "");
    Expect(1, 12288, '\P{^Is_Gc=separator}', "");
    Expect(0, 12289, '\p{Is_Gc=separator}', "");
    Expect(1, 12289, '\p{^Is_Gc=separator}', "");
    Expect(1, 12289, '\P{Is_Gc=separator}', "");
    Expect(0, 12289, '\P{^Is_Gc=separator}', "");
    Expect(1, 12288, '\p{Is_Gc=-	Separator}', "");
    Expect(0, 12288, '\p{^Is_Gc=-	Separator}', "");
    Expect(0, 12288, '\P{Is_Gc=-	Separator}', "");
    Expect(1, 12288, '\P{^Is_Gc=-	Separator}', "");
    Expect(0, 12289, '\p{Is_Gc=-	Separator}', "");
    Expect(1, 12289, '\p{^Is_Gc=-	Separator}', "");
    Expect(1, 12289, '\P{Is_Gc=-	Separator}', "");
    Expect(0, 12289, '\P{^Is_Gc=-	Separator}', "");
    Error('\p{Is_Category=_:=Z}');
    Error('\P{Is_Category=_:=Z}');
    Expect(1, 12288, '\p{Is_Category=z}', "");
    Expect(0, 12288, '\p{^Is_Category=z}', "");
    Expect(0, 12288, '\P{Is_Category=z}', "");
    Expect(1, 12288, '\P{^Is_Category=z}', "");
    Expect(0, 12289, '\p{Is_Category=z}', "");
    Expect(1, 12289, '\p{^Is_Category=z}', "");
    Expect(1, 12289, '\P{Is_Category=z}', "");
    Expect(0, 12289, '\P{^Is_Category=z}', "");
    Expect(1, 12288, '\p{Is_Category=- Z}', "");
    Expect(0, 12288, '\p{^Is_Category=- Z}', "");
    Expect(0, 12288, '\P{Is_Category=- Z}', "");
    Expect(1, 12288, '\P{^Is_Category=- Z}', "");
    Expect(0, 12289, '\p{Is_Category=- Z}', "");
    Expect(1, 12289, '\p{^Is_Category=- Z}', "");
    Expect(1, 12289, '\P{Is_Category=- Z}', "");
    Expect(0, 12289, '\P{^Is_Category=- Z}', "");
    Error('\p{General_Category:	 	LINE_Separator/a/}');
    Error('\P{General_Category:	 	LINE_Separator/a/}');
    Expect(1, 8232, '\p{General_Category=:\ALine_Separator\z:}', "");;
    Expect(0, 8233, '\p{General_Category=:\ALine_Separator\z:}', "");;
    Expect(1, 8232, '\p{General_Category=lineseparator}', "");
    Expect(0, 8232, '\p{^General_Category=lineseparator}', "");
    Expect(0, 8232, '\P{General_Category=lineseparator}', "");
    Expect(1, 8232, '\P{^General_Category=lineseparator}', "");
    Expect(0, 8233, '\p{General_Category=lineseparator}', "");
    Expect(1, 8233, '\p{^General_Category=lineseparator}', "");
    Expect(1, 8233, '\P{General_Category=lineseparator}', "");
    Expect(0, 8233, '\P{^General_Category=lineseparator}', "");
    Expect(1, 8232, '\p{General_Category=:\Alineseparator\z:}', "");;
    Expect(0, 8233, '\p{General_Category=:\Alineseparator\z:}', "");;
    Expect(1, 8232, '\p{General_Category=__Line_separator}', "");
    Expect(0, 8232, '\p{^General_Category=__Line_separator}', "");
    Expect(0, 8232, '\P{General_Category=__Line_separator}', "");
    Expect(1, 8232, '\P{^General_Category=__Line_separator}', "");
    Expect(0, 8233, '\p{General_Category=__Line_separator}', "");
    Expect(1, 8233, '\p{^General_Category=__Line_separator}', "");
    Expect(1, 8233, '\P{General_Category=__Line_separator}', "");
    Expect(0, 8233, '\P{^General_Category=__Line_separator}', "");
    Error('\p{Gc=:=__Zl}');
    Error('\P{Gc=:=__Zl}');
    Expect(1, 8232, '\p{Gc=:\AZl\z:}', "");;
    Expect(0, 8233, '\p{Gc=:\AZl\z:}', "");;
    Expect(1, 8232, '\p{Gc=zl}', "");
    Expect(0, 8232, '\p{^Gc=zl}', "");
    Expect(0, 8232, '\P{Gc=zl}', "");
    Expect(1, 8232, '\P{^Gc=zl}', "");
    Expect(0, 8233, '\p{Gc=zl}', "");
    Expect(1, 8233, '\p{^Gc=zl}', "");
    Expect(1, 8233, '\P{Gc=zl}', "");
    Expect(0, 8233, '\P{^Gc=zl}', "");
    Expect(1, 8232, '\p{Gc=:\Azl\z:}', "");;
    Expect(0, 8233, '\p{Gc=:\Azl\z:}', "");;
    Expect(1, 8232, '\p{Gc=		ZL}', "");
    Expect(0, 8232, '\p{^Gc=		ZL}', "");
    Expect(0, 8232, '\P{Gc=		ZL}', "");
    Expect(1, 8232, '\P{^Gc=		ZL}', "");
    Expect(0, 8233, '\p{Gc=		ZL}', "");
    Expect(1, 8233, '\p{^Gc=		ZL}', "");
    Expect(1, 8233, '\P{Gc=		ZL}', "");
    Expect(0, 8233, '\P{^Gc=		ZL}', "");
    Error('\p{Category=/a/LINE_SEPARATOR}');
    Error('\P{Category=/a/LINE_SEPARATOR}');
    Expect(1, 8232, '\p{Category=:\ALine_Separator\z:}', "");;
    Expect(0, 8233, '\p{Category=:\ALine_Separator\z:}', "");;
    Expect(1, 8232, '\p{Category=lineseparator}', "");
    Expect(0, 8232, '\p{^Category=lineseparator}', "");
    Expect(0, 8232, '\P{Category=lineseparator}', "");
    Expect(1, 8232, '\P{^Category=lineseparator}', "");
    Expect(0, 8233, '\p{Category=lineseparator}', "");
    Expect(1, 8233, '\p{^Category=lineseparator}', "");
    Expect(1, 8233, '\P{Category=lineseparator}', "");
    Expect(0, 8233, '\P{^Category=lineseparator}', "");
    Expect(1, 8232, '\p{Category=:\Alineseparator\z:}', "");;
    Expect(0, 8233, '\p{Category=:\Alineseparator\z:}', "");;
    Expect(1, 8232, '\p{Category= Line_separator}', "");
    Expect(0, 8232, '\p{^Category= Line_separator}', "");
    Expect(0, 8232, '\P{Category= Line_separator}', "");
    Expect(1, 8232, '\P{^Category= Line_separator}', "");
    Expect(0, 8233, '\p{Category= Line_separator}', "");
    Expect(1, 8233, '\p{^Category= Line_separator}', "");
    Expect(1, 8233, '\P{Category= Line_separator}', "");
    Expect(0, 8233, '\P{^Category= Line_separator}', "");
    Error('\p{Is_General_Category=/a/ zl}');
    Error('\P{Is_General_Category=/a/ zl}');
    Expect(1, 8232, '\p{Is_General_Category=zl}', "");
    Expect(0, 8232, '\p{^Is_General_Category=zl}', "");
    Expect(0, 8232, '\P{Is_General_Category=zl}', "");
    Expect(1, 8232, '\P{^Is_General_Category=zl}', "");
    Expect(0, 8233, '\p{Is_General_Category=zl}', "");
    Expect(1, 8233, '\p{^Is_General_Category=zl}', "");
    Expect(1, 8233, '\P{Is_General_Category=zl}', "");
    Expect(0, 8233, '\P{^Is_General_Category=zl}', "");
    Expect(1, 8232, '\p{Is_General_Category=  Zl}', "");
    Expect(0, 8232, '\p{^Is_General_Category=  Zl}', "");
    Expect(0, 8232, '\P{Is_General_Category=  Zl}', "");
    Expect(1, 8232, '\P{^Is_General_Category=  Zl}', "");
    Expect(0, 8233, '\p{Is_General_Category=  Zl}', "");
    Expect(1, 8233, '\p{^Is_General_Category=  Zl}', "");
    Expect(1, 8233, '\P{Is_General_Category=  Zl}', "");
    Expect(0, 8233, '\P{^Is_General_Category=  Zl}', "");
    Error('\p{Is_Gc=:= _Line_Separator}');
    Error('\P{Is_Gc=:= _Line_Separator}');
    Expect(1, 8232, '\p{Is_Gc=lineseparator}', "");
    Expect(0, 8232, '\p{^Is_Gc=lineseparator}', "");
    Expect(0, 8232, '\P{Is_Gc=lineseparator}', "");
    Expect(1, 8232, '\P{^Is_Gc=lineseparator}', "");
    Expect(0, 8233, '\p{Is_Gc=lineseparator}', "");
    Expect(1, 8233, '\p{^Is_Gc=lineseparator}', "");
    Expect(1, 8233, '\P{Is_Gc=lineseparator}', "");
    Expect(0, 8233, '\P{^Is_Gc=lineseparator}', "");
    Expect(1, 8232, '\p{Is_Gc=-	Line_Separator}', "");
    Expect(0, 8232, '\p{^Is_Gc=-	Line_Separator}', "");
    Expect(0, 8232, '\P{Is_Gc=-	Line_Separator}', "");
    Expect(1, 8232, '\P{^Is_Gc=-	Line_Separator}', "");
    Expect(0, 8233, '\p{Is_Gc=-	Line_Separator}', "");
    Expect(1, 8233, '\p{^Is_Gc=-	Line_Separator}', "");
    Expect(1, 8233, '\P{Is_Gc=-	Line_Separator}', "");
    Expect(0, 8233, '\P{^Is_Gc=-	Line_Separator}', "");
    Error('\p{Is_Category=	:=ZL}');
    Error('\P{Is_Category=	:=ZL}');
    Expect(1, 8232, '\p{Is_Category=zl}', "");
    Expect(0, 8232, '\p{^Is_Category=zl}', "");
    Expect(0, 8232, '\P{Is_Category=zl}', "");
    Expect(1, 8232, '\P{^Is_Category=zl}', "");
    Expect(0, 8233, '\p{Is_Category=zl}', "");
    Expect(1, 8233, '\p{^Is_Category=zl}', "");
    Expect(1, 8233, '\P{Is_Category=zl}', "");
    Expect(0, 8233, '\P{^Is_Category=zl}', "");
    Expect(1, 8232, '\p{Is_Category=_ Zl}', "");
    Expect(0, 8232, '\p{^Is_Category=_ Zl}', "");
    Expect(0, 8232, '\P{Is_Category=_ Zl}', "");
    Expect(1, 8232, '\P{^Is_Category=_ Zl}', "");
    Expect(0, 8233, '\p{Is_Category=_ Zl}', "");
    Expect(1, 8233, '\p{^Is_Category=_ Zl}', "");
    Expect(1, 8233, '\P{Is_Category=_ Zl}', "");
    Expect(0, 8233, '\P{^Is_Category=_ Zl}', "");
    Error('\p{General_Category=_	paragraph_Separator/a/}');
    Error('\P{General_Category=_	paragraph_Separator/a/}');
    Expect(1, 8233, '\p{General_Category=:\AParagraph_Separator\z:}', "");;
    Expect(0, 8234, '\p{General_Category=:\AParagraph_Separator\z:}', "");;
    Expect(1, 8233, '\p{General_Category=paragraphseparator}', "");
    Expect(0, 8233, '\p{^General_Category=paragraphseparator}', "");
    Expect(0, 8233, '\P{General_Category=paragraphseparator}', "");
    Expect(1, 8233, '\P{^General_Category=paragraphseparator}', "");
    Expect(0, 8234, '\p{General_Category=paragraphseparator}', "");
    Expect(1, 8234, '\p{^General_Category=paragraphseparator}', "");
    Expect(1, 8234, '\P{General_Category=paragraphseparator}', "");
    Expect(0, 8234, '\P{^General_Category=paragraphseparator}', "");
    Expect(1, 8233, '\p{General_Category=:\Aparagraphseparator\z:}', "");;
    Expect(0, 8234, '\p{General_Category=:\Aparagraphseparator\z:}', "");;
    Expect(1, 8233, '\p{General_Category=--Paragraph_Separator}', "");
    Expect(0, 8233, '\p{^General_Category=--Paragraph_Separator}', "");
    Expect(0, 8233, '\P{General_Category=--Paragraph_Separator}', "");
    Expect(1, 8233, '\P{^General_Category=--Paragraph_Separator}', "");
    Expect(0, 8234, '\p{General_Category=--Paragraph_Separator}', "");
    Expect(1, 8234, '\p{^General_Category=--Paragraph_Separator}', "");
    Expect(1, 8234, '\P{General_Category=--Paragraph_Separator}', "");
    Expect(0, 8234, '\P{^General_Category=--Paragraph_Separator}', "");
    Error('\p{Gc=/a/-	Zp}');
    Error('\P{Gc=/a/-	Zp}');
    Expect(1, 8233, '\p{Gc=:\AZp\z:}', "");;
    Expect(0, 8234, '\p{Gc=:\AZp\z:}', "");;
    Expect(1, 8233, '\p{Gc=zp}', "");
    Expect(0, 8233, '\p{^Gc=zp}', "");
    Expect(0, 8233, '\P{Gc=zp}', "");
    Expect(1, 8233, '\P{^Gc=zp}', "");
    Expect(0, 8234, '\p{Gc=zp}', "");
    Expect(1, 8234, '\p{^Gc=zp}', "");
    Expect(1, 8234, '\P{Gc=zp}', "");
    Expect(0, 8234, '\P{^Gc=zp}', "");
    Expect(1, 8233, '\p{Gc=:\Azp\z:}', "");;
    Expect(0, 8234, '\p{Gc=:\Azp\z:}', "");;
    Expect(1, 8233, '\p{Gc=-Zp}', "");
    Expect(0, 8233, '\p{^Gc=-Zp}', "");
    Expect(0, 8233, '\P{Gc=-Zp}', "");
    Expect(1, 8233, '\P{^Gc=-Zp}', "");
    Expect(0, 8234, '\p{Gc=-Zp}', "");
    Expect(1, 8234, '\p{^Gc=-Zp}', "");
    Expect(1, 8234, '\P{Gc=-Zp}', "");
    Expect(0, 8234, '\P{^Gc=-Zp}', "");
    Error('\p{Category=_/a/PARAGRAPH_separator}');
    Error('\P{Category=_/a/PARAGRAPH_separator}');
    Expect(1, 8233, '\p{Category=:\AParagraph_Separator\z:}', "");;
    Expect(0, 8234, '\p{Category=:\AParagraph_Separator\z:}', "");;
    Expect(1, 8233, '\p{Category=paragraphseparator}', "");
    Expect(0, 8233, '\p{^Category=paragraphseparator}', "");
    Expect(0, 8233, '\P{Category=paragraphseparator}', "");
    Expect(1, 8233, '\P{^Category=paragraphseparator}', "");
    Expect(0, 8234, '\p{Category=paragraphseparator}', "");
    Expect(1, 8234, '\p{^Category=paragraphseparator}', "");
    Expect(1, 8234, '\P{Category=paragraphseparator}', "");
    Expect(0, 8234, '\P{^Category=paragraphseparator}', "");
    Expect(1, 8233, '\p{Category=:\Aparagraphseparator\z:}', "");;
    Expect(0, 8234, '\p{Category=:\Aparagraphseparator\z:}', "");;
    Expect(1, 8233, '\p{Category:	 Paragraph_separator}', "");
    Expect(0, 8233, '\p{^Category:	 Paragraph_separator}', "");
    Expect(0, 8233, '\P{Category:	 Paragraph_separator}', "");
    Expect(1, 8233, '\P{^Category:	 Paragraph_separator}', "");
    Expect(0, 8234, '\p{Category:	 Paragraph_separator}', "");
    Expect(1, 8234, '\p{^Category:	 Paragraph_separator}', "");
    Expect(1, 8234, '\P{Category:	 Paragraph_separator}', "");
    Expect(0, 8234, '\P{^Category:	 Paragraph_separator}', "");
    Error('\p{Is_General_Category:	:=Zp}');
    Error('\P{Is_General_Category:	:=Zp}');
    Expect(1, 8233, '\p{Is_General_Category=zp}', "");
    Expect(0, 8233, '\p{^Is_General_Category=zp}', "");
    Expect(0, 8233, '\P{Is_General_Category=zp}', "");
    Expect(1, 8233, '\P{^Is_General_Category=zp}', "");
    Expect(0, 8234, '\p{Is_General_Category=zp}', "");
    Expect(1, 8234, '\p{^Is_General_Category=zp}', "");
    Expect(1, 8234, '\P{Is_General_Category=zp}', "");
    Expect(0, 8234, '\P{^Is_General_Category=zp}', "");
    Expect(1, 8233, '\p{Is_General_Category=--Zp}', "");
    Expect(0, 8233, '\p{^Is_General_Category=--Zp}', "");
    Expect(0, 8233, '\P{Is_General_Category=--Zp}', "");
    Expect(1, 8233, '\P{^Is_General_Category=--Zp}', "");
    Expect(0, 8234, '\p{Is_General_Category=--Zp}', "");
    Expect(1, 8234, '\p{^Is_General_Category=--Zp}', "");
    Expect(1, 8234, '\P{Is_General_Category=--Zp}', "");
    Expect(0, 8234, '\P{^Is_General_Category=--Zp}', "");
    Error('\p{Is_Gc=_/a/PARAGRAPH_SEPARATOR}');
    Error('\P{Is_Gc=_/a/PARAGRAPH_SEPARATOR}');
    Expect(1, 8233, '\p{Is_Gc=paragraphseparator}', "");
    Expect(0, 8233, '\p{^Is_Gc=paragraphseparator}', "");
    Expect(0, 8233, '\P{Is_Gc=paragraphseparator}', "");
    Expect(1, 8233, '\P{^Is_Gc=paragraphseparator}', "");
    Expect(0, 8234, '\p{Is_Gc=paragraphseparator}', "");
    Expect(1, 8234, '\p{^Is_Gc=paragraphseparator}', "");
    Expect(1, 8234, '\P{Is_Gc=paragraphseparator}', "");
    Expect(0, 8234, '\P{^Is_Gc=paragraphseparator}', "");
    Expect(1, 8233, '\p{Is_Gc= -Paragraph_Separator}', "");
    Expect(0, 8233, '\p{^Is_Gc= -Paragraph_Separator}', "");
    Expect(0, 8233, '\P{Is_Gc= -Paragraph_Separator}', "");
    Expect(1, 8233, '\P{^Is_Gc= -Paragraph_Separator}', "");
    Expect(0, 8234, '\p{Is_Gc= -Paragraph_Separator}', "");
    Expect(1, 8234, '\p{^Is_Gc= -Paragraph_Separator}', "");
    Expect(1, 8234, '\P{Is_Gc= -Paragraph_Separator}', "");
    Expect(0, 8234, '\P{^Is_Gc= -Paragraph_Separator}', "");
    Error('\p{Is_Category:   :=	-Zp}');
    Error('\P{Is_Category:   :=	-Zp}');
    Expect(1, 8233, '\p{Is_Category:zp}', "");
    Expect(0, 8233, '\p{^Is_Category:zp}', "");
    Expect(0, 8233, '\P{Is_Category:zp}', "");
    Expect(1, 8233, '\P{^Is_Category:zp}', "");
    Expect(0, 8234, '\p{Is_Category:zp}', "");
    Expect(1, 8234, '\p{^Is_Category:zp}', "");
    Expect(1, 8234, '\P{Is_Category:zp}', "");
    Expect(0, 8234, '\P{^Is_Category:zp}', "");
    Expect(1, 8233, '\p{Is_Category=	-ZP}', "");
    Expect(0, 8233, '\p{^Is_Category=	-ZP}', "");
    Expect(0, 8233, '\P{Is_Category=	-ZP}', "");
    Expect(1, 8233, '\P{^Is_Category=	-ZP}', "");
    Expect(0, 8234, '\p{Is_Category=	-ZP}', "");
    Expect(1, 8234, '\p{^Is_Category=	-ZP}', "");
    Expect(1, 8234, '\P{Is_Category=	-ZP}', "");
    Expect(0, 8234, '\P{^Is_Category=	-ZP}', "");
    Error('\p{General_Category=:=	Space_SEPARATOR}');
    Error('\P{General_Category=:=	Space_SEPARATOR}');
    Expect(1, 12288, '\p{General_Category=:\ASpace_Separator\z:}', "");;
    Expect(0, 12289, '\p{General_Category=:\ASpace_Separator\z:}', "");;
    Expect(1, 12288, '\p{General_Category=spaceseparator}', "");
    Expect(0, 12288, '\p{^General_Category=spaceseparator}', "");
    Expect(0, 12288, '\P{General_Category=spaceseparator}', "");
    Expect(1, 12288, '\P{^General_Category=spaceseparator}', "");
    Expect(0, 12289, '\p{General_Category=spaceseparator}', "");
    Expect(1, 12289, '\p{^General_Category=spaceseparator}', "");
    Expect(1, 12289, '\P{General_Category=spaceseparator}', "");
    Expect(0, 12289, '\P{^General_Category=spaceseparator}', "");
    Expect(1, 12288, '\p{General_Category=:\Aspaceseparator\z:}', "");;
    Expect(0, 12289, '\p{General_Category=:\Aspaceseparator\z:}', "");;
    Expect(1, 12288, '\p{General_Category=-space_Separator}', "");
    Expect(0, 12288, '\p{^General_Category=-space_Separator}', "");
    Expect(0, 12288, '\P{General_Category=-space_Separator}', "");
    Expect(1, 12288, '\P{^General_Category=-space_Separator}', "");
    Expect(0, 12289, '\p{General_Category=-space_Separator}', "");
    Expect(1, 12289, '\p{^General_Category=-space_Separator}', "");
    Expect(1, 12289, '\P{General_Category=-space_Separator}', "");
    Expect(0, 12289, '\P{^General_Category=-space_Separator}', "");
    Error('\p{Gc=-_ZS/a/}');
    Error('\P{Gc=-_ZS/a/}');
    Expect(1, 12288, '\p{Gc=:\AZs\z:}', "");;
    Expect(0, 12289, '\p{Gc=:\AZs\z:}', "");;
    Expect(1, 12288, '\p{Gc: zs}', "");
    Expect(0, 12288, '\p{^Gc: zs}', "");
    Expect(0, 12288, '\P{Gc: zs}', "");
    Expect(1, 12288, '\P{^Gc: zs}', "");
    Expect(0, 12289, '\p{Gc: zs}', "");
    Expect(1, 12289, '\p{^Gc: zs}', "");
    Expect(1, 12289, '\P{Gc: zs}', "");
    Expect(0, 12289, '\P{^Gc: zs}', "");
    Expect(1, 12288, '\p{Gc=:\Azs\z:}', "");;
    Expect(0, 12289, '\p{Gc=:\Azs\z:}', "");;
    Expect(1, 12288, '\p{Gc=--Zs}', "");
    Expect(0, 12288, '\p{^Gc=--Zs}', "");
    Expect(0, 12288, '\P{Gc=--Zs}', "");
    Expect(1, 12288, '\P{^Gc=--Zs}', "");
    Expect(0, 12289, '\p{Gc=--Zs}', "");
    Expect(1, 12289, '\p{^Gc=--Zs}', "");
    Expect(1, 12289, '\P{Gc=--Zs}', "");
    Expect(0, 12289, '\P{^Gc=--Zs}', "");
    Error('\p{Category=_:=Space_Separator}');
    Error('\P{Category=_:=Space_Separator}');
    Expect(1, 12288, '\p{Category=:\ASpace_Separator\z:}', "");;
    Expect(0, 12289, '\p{Category=:\ASpace_Separator\z:}', "");;
    Expect(1, 12288, '\p{Category=spaceseparator}', "");
    Expect(0, 12288, '\p{^Category=spaceseparator}', "");
    Expect(0, 12288, '\P{Category=spaceseparator}', "");
    Expect(1, 12288, '\P{^Category=spaceseparator}', "");
    Expect(0, 12289, '\p{Category=spaceseparator}', "");
    Expect(1, 12289, '\p{^Category=spaceseparator}', "");
    Expect(1, 12289, '\P{Category=spaceseparator}', "");
    Expect(0, 12289, '\P{^Category=spaceseparator}', "");
    Expect(1, 12288, '\p{Category=:\Aspaceseparator\z:}', "");;
    Expect(0, 12289, '\p{Category=:\Aspaceseparator\z:}', "");;
    Expect(1, 12288, '\p{Category=--Space_Separator}', "");
    Expect(0, 12288, '\p{^Category=--Space_Separator}', "");
    Expect(0, 12288, '\P{Category=--Space_Separator}', "");
    Expect(1, 12288, '\P{^Category=--Space_Separator}', "");
    Expect(0, 12289, '\p{Category=--Space_Separator}', "");
    Expect(1, 12289, '\p{^Category=--Space_Separator}', "");
    Expect(1, 12289, '\P{Category=--Space_Separator}', "");
    Expect(0, 12289, '\P{^Category=--Space_Separator}', "");
    Error('\p{Is_General_Category=/a/_ZS}');
    Error('\P{Is_General_Category=/a/_ZS}');
    Expect(1, 12288, '\p{Is_General_Category=zs}', "");
    Expect(0, 12288, '\p{^Is_General_Category=zs}', "");
    Expect(0, 12288, '\P{Is_General_Category=zs}', "");
    Expect(1, 12288, '\P{^Is_General_Category=zs}', "");
    Expect(0, 12289, '\p{Is_General_Category=zs}', "");
    Expect(1, 12289, '\p{^Is_General_Category=zs}', "");
    Expect(1, 12289, '\P{Is_General_Category=zs}', "");
    Expect(0, 12289, '\P{^Is_General_Category=zs}', "");
    Expect(1, 12288, '\p{Is_General_Category=  ZS}', "");
    Expect(0, 12288, '\p{^Is_General_Category=  ZS}', "");
    Expect(0, 12288, '\P{Is_General_Category=  ZS}', "");
    Expect(1, 12288, '\P{^Is_General_Category=  ZS}', "");
    Expect(0, 12289, '\p{Is_General_Category=  ZS}', "");
    Expect(1, 12289, '\p{^Is_General_Category=  ZS}', "");
    Expect(1, 12289, '\P{Is_General_Category=  ZS}', "");
    Expect(0, 12289, '\P{^Is_General_Category=  ZS}', "");
    Error('\p{Is_Gc=- Space_Separator/a/}');
    Error('\P{Is_Gc=- Space_Separator/a/}');
    Expect(1, 12288, '\p{Is_Gc=spaceseparator}', "");
    Expect(0, 12288, '\p{^Is_Gc=spaceseparator}', "");
    Expect(0, 12288, '\P{Is_Gc=spaceseparator}', "");
    Expect(1, 12288, '\P{^Is_Gc=spaceseparator}', "");
    Expect(0, 12289, '\p{Is_Gc=spaceseparator}', "");
    Expect(1, 12289, '\p{^Is_Gc=spaceseparator}', "");
    Expect(1, 12289, '\P{Is_Gc=spaceseparator}', "");
    Expect(0, 12289, '\P{^Is_Gc=spaceseparator}', "");
    Expect(1, 12288, '\p{Is_Gc= _Space_Separator}', "");
    Expect(0, 12288, '\p{^Is_Gc= _Space_Separator}', "");
    Expect(0, 12288, '\P{Is_Gc= _Space_Separator}', "");
    Expect(1, 12288, '\P{^Is_Gc= _Space_Separator}', "");
    Expect(0, 12289, '\p{Is_Gc= _Space_Separator}', "");
    Expect(1, 12289, '\p{^Is_Gc= _Space_Separator}', "");
    Expect(1, 12289, '\P{Is_Gc= _Space_Separator}', "");
    Expect(0, 12289, '\P{^Is_Gc= _Space_Separator}', "");
    Error('\p{Is_Category=/a/-_zs}');
    Error('\P{Is_Category=/a/-_zs}');
    Expect(1, 12288, '\p{Is_Category:	zs}', "");
    Expect(0, 12288, '\p{^Is_Category:	zs}', "");
    Expect(0, 12288, '\P{Is_Category:	zs}', "");
    Expect(1, 12288, '\P{^Is_Category:	zs}', "");
    Expect(0, 12289, '\p{Is_Category:	zs}', "");
    Expect(1, 12289, '\p{^Is_Category:	zs}', "");
    Expect(1, 12289, '\P{Is_Category:	zs}', "");
    Expect(0, 12289, '\P{^Is_Category:	zs}', "");
    Expect(1, 12288, '\p{Is_Category=__Zs}', "");
    Expect(0, 12288, '\p{^Is_Category=__Zs}', "");
    Expect(0, 12288, '\P{Is_Category=__Zs}', "");
    Expect(1, 12288, '\P{^Is_Category=__Zs}', "");
    Expect(0, 12289, '\p{Is_Category=__Zs}', "");
    Expect(1, 12289, '\p{^Is_Category=__Zs}', "");
    Expect(1, 12289, '\P{Is_Category=__Zs}', "");
    Expect(0, 12289, '\P{^Is_Category=__Zs}', "");
    Error('\p{graphemeclusterbreak}');
    Error('\P{graphemeclusterbreak}');
    Error('\p{gcb}');
    Error('\P{gcb}');
    Error('\p{_perlgcb}');
    Error('\P{_perlgcb}');
    Error('\p{Grapheme_Cluster_Break:   -:=Control}');
    Error('\P{Grapheme_Cluster_Break:   -:=Control}');
    Expect(1, 921599, '\p{Grapheme_Cluster_Break=:\AControl\z:}', "");;
    Expect(0, 921600, '\p{Grapheme_Cluster_Break=:\AControl\z:}', "");;
    Expect(1, 921599, '\p{Grapheme_Cluster_Break=control}', "");
    Expect(0, 921599, '\p{^Grapheme_Cluster_Break=control}', "");
    Expect(0, 921599, '\P{Grapheme_Cluster_Break=control}', "");
    Expect(1, 921599, '\P{^Grapheme_Cluster_Break=control}', "");
    Expect(0, 921600, '\p{Grapheme_Cluster_Break=control}', "");
    Expect(1, 921600, '\p{^Grapheme_Cluster_Break=control}', "");
    Expect(1, 921600, '\P{Grapheme_Cluster_Break=control}', "");
    Expect(0, 921600, '\P{^Grapheme_Cluster_Break=control}', "");
    Expect(1, 921599, '\p{Grapheme_Cluster_Break=:\Acontrol\z:}', "");;
    Expect(0, 921600, '\p{Grapheme_Cluster_Break=:\Acontrol\z:}', "");;
    Expect(1, 921599, '\p{Grapheme_Cluster_Break=  CONTROL}', "");
    Expect(0, 921599, '\p{^Grapheme_Cluster_Break=  CONTROL}', "");
    Expect(0, 921599, '\P{Grapheme_Cluster_Break=  CONTROL}', "");
    Expect(1, 921599, '\P{^Grapheme_Cluster_Break=  CONTROL}', "");
    Expect(0, 921600, '\p{Grapheme_Cluster_Break=  CONTROL}', "");
    Expect(1, 921600, '\p{^Grapheme_Cluster_Break=  CONTROL}', "");
    Expect(1, 921600, '\P{Grapheme_Cluster_Break=  CONTROL}', "");
    Expect(0, 921600, '\P{^Grapheme_Cluster_Break=  CONTROL}', "");
    Error('\p{GCB:	--cn/a/}');
    Error('\P{GCB:	--cn/a/}');
    Expect(1, 921599, '\p{GCB=:\ACN\z:}', "");;
    Expect(0, 921600, '\p{GCB=:\ACN\z:}', "");;
    Expect(1, 921599, '\p{GCB=cn}', "");
    Expect(0, 921599, '\p{^GCB=cn}', "");
    Expect(0, 921599, '\P{GCB=cn}', "");
    Expect(1, 921599, '\P{^GCB=cn}', "");
    Expect(0, 921600, '\p{GCB=cn}', "");
    Expect(1, 921600, '\p{^GCB=cn}', "");
    Expect(1, 921600, '\P{GCB=cn}', "");
    Expect(0, 921600, '\P{^GCB=cn}', "");
    Expect(1, 921599, '\p{GCB=:\Acn\z:}', "");;
    Expect(0, 921600, '\p{GCB=:\Acn\z:}', "");;
    Expect(1, 921599, '\p{GCB=	-cn}', "");
    Expect(0, 921599, '\p{^GCB=	-cn}', "");
    Expect(0, 921599, '\P{GCB=	-cn}', "");
    Expect(1, 921599, '\P{^GCB=	-cn}', "");
    Expect(0, 921600, '\p{GCB=	-cn}', "");
    Expect(1, 921600, '\p{^GCB=	-cn}', "");
    Expect(1, 921600, '\P{GCB=	-cn}', "");
    Expect(0, 921600, '\P{^GCB=	-cn}', "");
    Error('\p{Is_Grapheme_Cluster_Break=-	CONTROL/a/}');
    Error('\P{Is_Grapheme_Cluster_Break=-	CONTROL/a/}');
    Expect(1, 921599, '\p{Is_Grapheme_Cluster_Break=control}', "");
    Expect(0, 921599, '\p{^Is_Grapheme_Cluster_Break=control}', "");
    Expect(0, 921599, '\P{Is_Grapheme_Cluster_Break=control}', "");
    Expect(1, 921599, '\P{^Is_Grapheme_Cluster_Break=control}', "");
    Expect(0, 921600, '\p{Is_Grapheme_Cluster_Break=control}', "");
    Expect(1, 921600, '\p{^Is_Grapheme_Cluster_Break=control}', "");
    Expect(1, 921600, '\P{Is_Grapheme_Cluster_Break=control}', "");
    Expect(0, 921600, '\P{^Is_Grapheme_Cluster_Break=control}', "");
    Expect(1, 921599, '\p{Is_Grapheme_Cluster_Break=		control}', "");
    Expect(0, 921599, '\p{^Is_Grapheme_Cluster_Break=		control}', "");
    Expect(0, 921599, '\P{Is_Grapheme_Cluster_Break=		control}', "");
    Expect(1, 921599, '\P{^Is_Grapheme_Cluster_Break=		control}', "");
    Expect(0, 921600, '\p{Is_Grapheme_Cluster_Break=		control}', "");
    Expect(1, 921600, '\p{^Is_Grapheme_Cluster_Break=		control}', "");
    Expect(1, 921600, '\P{Is_Grapheme_Cluster_Break=		control}', "");
    Expect(0, 921600, '\P{^Is_Grapheme_Cluster_Break=		control}', "");
    Error('\p{Is_GCB=_	CN:=}');
    Error('\P{Is_GCB=_	CN:=}');
    Expect(1, 921599, '\p{Is_GCB=cn}', "");
    Expect(0, 921599, '\p{^Is_GCB=cn}', "");
    Expect(0, 921599, '\P{Is_GCB=cn}', "");
    Expect(1, 921599, '\P{^Is_GCB=cn}', "");
    Expect(0, 921600, '\p{Is_GCB=cn}', "");
    Expect(1, 921600, '\p{^Is_GCB=cn}', "");
    Expect(1, 921600, '\P{Is_GCB=cn}', "");
    Expect(0, 921600, '\P{^Is_GCB=cn}', "");
    Expect(1, 921599, '\p{Is_GCB: _CN}', "");
    Expect(0, 921599, '\p{^Is_GCB: _CN}', "");
    Expect(0, 921599, '\P{Is_GCB: _CN}', "");
    Expect(1, 921599, '\P{^Is_GCB: _CN}', "");
    Expect(0, 921600, '\p{Is_GCB: _CN}', "");
    Expect(1, 921600, '\p{^Is_GCB: _CN}', "");
    Expect(1, 921600, '\P{Is_GCB: _CN}', "");
    Expect(0, 921600, '\P{^Is_GCB: _CN}', "");
    Error('\p{Grapheme_Cluster_Break=__CR/a/}');
    Error('\P{Grapheme_Cluster_Break=__CR/a/}');
    Expect(1, 13, '\p{Grapheme_Cluster_Break=:\ACR\z:}', "");;
    Expect(0, 14, '\p{Grapheme_Cluster_Break=:\ACR\z:}', "");;
    Expect(1, 13, '\p{Grapheme_Cluster_Break=cr}', "");
    Expect(0, 13, '\p{^Grapheme_Cluster_Break=cr}', "");
    Expect(0, 13, '\P{Grapheme_Cluster_Break=cr}', "");
    Expect(1, 13, '\P{^Grapheme_Cluster_Break=cr}', "");
    Expect(0, 14, '\p{Grapheme_Cluster_Break=cr}', "");
    Expect(1, 14, '\p{^Grapheme_Cluster_Break=cr}', "");
    Expect(1, 14, '\P{Grapheme_Cluster_Break=cr}', "");
    Expect(0, 14, '\P{^Grapheme_Cluster_Break=cr}', "");
    Expect(1, 13, '\p{Grapheme_Cluster_Break=:\Acr\z:}', "");;
    Expect(0, 14, '\p{Grapheme_Cluster_Break=:\Acr\z:}', "");;
    Expect(1, 13, '\p{Grapheme_Cluster_Break:	- CR}', "");
    Expect(0, 13, '\p{^Grapheme_Cluster_Break:	- CR}', "");
    Expect(0, 13, '\P{Grapheme_Cluster_Break:	- CR}', "");
    Expect(1, 13, '\P{^Grapheme_Cluster_Break:	- CR}', "");
    Expect(0, 14, '\p{Grapheme_Cluster_Break:	- CR}', "");
    Expect(1, 14, '\p{^Grapheme_Cluster_Break:	- CR}', "");
    Expect(1, 14, '\P{Grapheme_Cluster_Break:	- CR}', "");
    Expect(0, 14, '\P{^Grapheme_Cluster_Break:	- CR}', "");
    Error('\p{GCB:    	CR:=}');
    Error('\P{GCB:    	CR:=}');
    Expect(1, 13, '\p{GCB=:\ACR\z:}', "");;
    Expect(0, 14, '\p{GCB=:\ACR\z:}', "");;
    Expect(1, 13, '\p{GCB=cr}', "");
    Expect(0, 13, '\p{^GCB=cr}', "");
    Expect(0, 13, '\P{GCB=cr}', "");
    Expect(1, 13, '\P{^GCB=cr}', "");
    Expect(0, 14, '\p{GCB=cr}', "");
    Expect(1, 14, '\p{^GCB=cr}', "");
    Expect(1, 14, '\P{GCB=cr}', "");
    Expect(0, 14, '\P{^GCB=cr}', "");
    Expect(1, 13, '\p{GCB=:\Acr\z:}', "");;
    Expect(0, 14, '\p{GCB=:\Acr\z:}', "");;
    Expect(1, 13, '\p{GCB:   	cr}', "");
    Expect(0, 13, '\p{^GCB:   	cr}', "");
    Expect(0, 13, '\P{GCB:   	cr}', "");
    Expect(1, 13, '\P{^GCB:   	cr}', "");
    Expect(0, 14, '\p{GCB:   	cr}', "");
    Expect(1, 14, '\p{^GCB:   	cr}', "");
    Expect(1, 14, '\P{GCB:   	cr}', "");
    Expect(0, 14, '\P{^GCB:   	cr}', "");
    Error('\p{Is_Grapheme_Cluster_Break=--cr/a/}');
    Error('\P{Is_Grapheme_Cluster_Break=--cr/a/}');
    Expect(1, 13, '\p{Is_Grapheme_Cluster_Break=cr}', "");
    Expect(0, 13, '\p{^Is_Grapheme_Cluster_Break=cr}', "");
    Expect(0, 13, '\P{Is_Grapheme_Cluster_Break=cr}', "");
    Expect(1, 13, '\P{^Is_Grapheme_Cluster_Break=cr}', "");
    Expect(0, 14, '\p{Is_Grapheme_Cluster_Break=cr}', "");
    Expect(1, 14, '\p{^Is_Grapheme_Cluster_Break=cr}', "");
    Expect(1, 14, '\P{Is_Grapheme_Cluster_Break=cr}', "");
    Expect(0, 14, '\P{^Is_Grapheme_Cluster_Break=cr}', "");
    Expect(1, 13, '\p{Is_Grapheme_Cluster_Break=	CR}', "");
    Expect(0, 13, '\p{^Is_Grapheme_Cluster_Break=	CR}', "");
    Expect(0, 13, '\P{Is_Grapheme_Cluster_Break=	CR}', "");
    Expect(1, 13, '\P{^Is_Grapheme_Cluster_Break=	CR}', "");
    Expect(0, 14, '\p{Is_Grapheme_Cluster_Break=	CR}', "");
    Expect(1, 14, '\p{^Is_Grapheme_Cluster_Break=	CR}', "");
    Expect(1, 14, '\P{Is_Grapheme_Cluster_Break=	CR}', "");
    Expect(0, 14, '\P{^Is_Grapheme_Cluster_Break=	CR}', "");
    Error('\p{Is_GCB=/a/CR}');
    Error('\P{Is_GCB=/a/CR}');
    Expect(1, 13, '\p{Is_GCB=cr}', "");
    Expect(0, 13, '\p{^Is_GCB=cr}', "");
    Expect(0, 13, '\P{Is_GCB=cr}', "");
    Expect(1, 13, '\P{^Is_GCB=cr}', "");
    Expect(0, 14, '\p{Is_GCB=cr}', "");
    Expect(1, 14, '\p{^Is_GCB=cr}', "");
    Expect(1, 14, '\P{Is_GCB=cr}', "");
    Expect(0, 14, '\P{^Is_GCB=cr}', "");
    Expect(1, 13, '\p{Is_GCB=- cr}', "");
    Expect(0, 13, '\p{^Is_GCB=- cr}', "");
    Expect(0, 13, '\P{Is_GCB=- cr}', "");
    Expect(1, 13, '\P{^Is_GCB=- cr}', "");
    Expect(0, 14, '\p{Is_GCB=- cr}', "");
    Expect(1, 14, '\p{^Is_GCB=- cr}', "");
    Expect(1, 14, '\P{Is_GCB=- cr}', "");
    Expect(0, 14, '\P{^Is_GCB=- cr}', "");
    Error('\p{Grapheme_Cluster_Break=/a/-	E_BASE}');
    Error('\P{Grapheme_Cluster_Break=/a/-	E_BASE}');
    Expect(0, 1, '\p{Grapheme_Cluster_Break=:\AE_Base\z:}', "");;
    Expect(0, 1, '\p{Grapheme_Cluster_Break=ebase}', "");
    Expect(1, 1, '\p{^Grapheme_Cluster_Break=ebase}', "");
    Expect(1, 1, '\P{Grapheme_Cluster_Break=ebase}', "");
    Expect(0, 1, '\P{^Grapheme_Cluster_Break=ebase}', "");
    Expect(0, 1, '\p{Grapheme_Cluster_Break=:\Aebase\z:}', "");;
    Expect(0, 1, '\p{Grapheme_Cluster_Break=_E_base}', "");
    Expect(1, 1, '\p{^Grapheme_Cluster_Break=_E_base}', "");
    Expect(1, 1, '\P{Grapheme_Cluster_Break=_E_base}', "");
    Expect(0, 1, '\P{^Grapheme_Cluster_Break=_E_base}', "");
    Error('\p{GCB= :=EB}');
    Error('\P{GCB= :=EB}');
    Expect(0, 1, '\p{GCB=:\AEB\z:}', "");;
    Expect(0, 1, '\p{GCB=eb}', "");
    Expect(1, 1, '\p{^GCB=eb}', "");
    Expect(1, 1, '\P{GCB=eb}', "");
    Expect(0, 1, '\P{^GCB=eb}', "");
    Expect(0, 1, '\p{GCB=:\Aeb\z:}', "");;
    Expect(0, 1, '\p{GCB= 	EB}', "");
    Expect(1, 1, '\p{^GCB= 	EB}', "");
    Expect(1, 1, '\P{GCB= 	EB}', "");
    Expect(0, 1, '\P{^GCB= 	EB}', "");
    Error('\p{Is_Grapheme_Cluster_Break= _e_base/a/}');
    Error('\P{Is_Grapheme_Cluster_Break= _e_base/a/}');
    Expect(0, 1, '\p{Is_Grapheme_Cluster_Break:ebase}', "");
    Expect(1, 1, '\p{^Is_Grapheme_Cluster_Break:ebase}', "");
    Expect(1, 1, '\P{Is_Grapheme_Cluster_Break:ebase}', "");
    Expect(0, 1, '\P{^Is_Grapheme_Cluster_Break:ebase}', "");
    Expect(0, 1, '\p{Is_Grapheme_Cluster_Break:e_BASE}', "");
    Expect(1, 1, '\p{^Is_Grapheme_Cluster_Break:e_BASE}', "");
    Expect(1, 1, '\P{Is_Grapheme_Cluster_Break:e_BASE}', "");
    Expect(0, 1, '\P{^Is_Grapheme_Cluster_Break:e_BASE}', "");
    Error('\p{Is_GCB=:=EB}');
    Error('\P{Is_GCB=:=EB}');
    Expect(0, 1, '\p{Is_GCB=eb}', "");
    Expect(1, 1, '\p{^Is_GCB=eb}', "");
    Expect(1, 1, '\P{Is_GCB=eb}', "");
    Expect(0, 1, '\P{^Is_GCB=eb}', "");
    Expect(0, 1, '\p{Is_GCB= EB}', "");
    Expect(1, 1, '\p{^Is_GCB= EB}', "");
    Expect(1, 1, '\P{Is_GCB= EB}', "");
    Expect(0, 1, '\P{^Is_GCB= EB}', "");
    Error('\p{Grapheme_Cluster_Break= 	e_Base_GAZ:=}');
    Error('\P{Grapheme_Cluster_Break= 	e_Base_GAZ:=}');
    Expect(0, 1, '\p{Grapheme_Cluster_Break=:\AE_Base_GAZ\z:}', "");;
    Expect(0, 1, '\p{Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(1, 1, '\p{^Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(1, 1, '\P{Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(0, 1, '\P{^Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(0, 1, '\p{Grapheme_Cluster_Break=:\Aebasegaz\z:}', "");;
    Expect(0, 1, '\p{Grapheme_Cluster_Break=  E_Base_GAZ}', "");
    Expect(1, 1, '\p{^Grapheme_Cluster_Break=  E_Base_GAZ}', "");
    Expect(1, 1, '\P{Grapheme_Cluster_Break=  E_Base_GAZ}', "");
    Expect(0, 1, '\P{^Grapheme_Cluster_Break=  E_Base_GAZ}', "");
    Error('\p{GCB::=__EBG}');
    Error('\P{GCB::=__EBG}');
    Expect(0, 1, '\p{GCB=:\AEBG\z:}', "");;
    Expect(0, 1, '\p{GCB=ebg}', "");
    Expect(1, 1, '\p{^GCB=ebg}', "");
    Expect(1, 1, '\P{GCB=ebg}', "");
    Expect(0, 1, '\P{^GCB=ebg}', "");
    Expect(0, 1, '\p{GCB=:\Aebg\z:}', "");;
    Expect(0, 1, '\p{GCB=- EBG}', "");
    Expect(1, 1, '\p{^GCB=- EBG}', "");
    Expect(1, 1, '\P{GCB=- EBG}', "");
    Expect(0, 1, '\P{^GCB=- EBG}', "");
    Error('\p{Is_Grapheme_Cluster_Break=_:=E_Base_GAZ}');
    Error('\P{Is_Grapheme_Cluster_Break=_:=E_Base_GAZ}');
    Expect(0, 1, '\p{Is_Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(1, 1, '\p{^Is_Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(1, 1, '\P{Is_Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(0, 1, '\P{^Is_Grapheme_Cluster_Break=ebasegaz}', "");
    Expect(0, 1, '\p{Is_Grapheme_Cluster_Break=	_E_base_GAZ}', "");
    Expect(1, 1, '\p{^Is_Grapheme_Cluster_Break=	_E_base_GAZ}', "");
    Expect(1, 1, '\P{Is_Grapheme_Cluster_Break=	_E_base_GAZ}', "");
    Expect(0, 1, '\P{^Is_Grapheme_Cluster_Break=	_E_base_GAZ}', "");
    Error('\p{Is_GCB=/a/ebg}');
    Error('\P{Is_GCB=/a/ebg}');
    Expect(0, 1, '\p{Is_GCB=ebg}', "");
    Expect(1, 1, '\p{^Is_GCB=ebg}', "");
    Expect(1, 1, '\P{Is_GCB=ebg}', "");
    Expect(0, 1, '\P{^Is_GCB=ebg}', "");
    Expect(0, 1, '\p{Is_GCB=_	ebg}', "");
    Expect(1, 1, '\p{^Is_GCB=_	ebg}', "");
    Expect(1, 1, '\P{Is_GCB=_	ebg}', "");
    Expect(0, 1, '\P{^Is_GCB=_	ebg}', "");
    Error('\p{Grapheme_Cluster_Break=_ E_Modifier:=}');
    Error('\P{Grapheme_Cluster_Break=_ E_Modifier:=}');
    Expect(0, 1, '\p{Grapheme_Cluster_Break=:\AE_Modifier\z:}', "");;
    Expect(0, 1, '\p{Grapheme_Cluster_Break=emodifier}', "");
    Expect(1, 1, '\p{^Grapheme_Cluster_Break=emodifier}', "");
    Expect(1, 1, '\P{Grapheme_Cluster_Break=emodifier}', "");
    Expect(0, 1, '\P{^Grapheme_Cluster_Break=emodifier}', "");
    Expect(0, 1, '\p{Grapheme_Cluster_Break=:\Aemodifier\z:}', "");;
    Expect(0, 1, '\p{Grapheme_Cluster_Break= _e_Modifier}', "");
    Expect(1, 1, '\p{^Grapheme_Cluster_Break= _e_Modifier}', "");
    Expect(1, 1, '\P{Grapheme_Cluster_Break= _e_Modifier}', "");
    Expect(0, 1, '\P{^Grapheme_Cluster_Break= _e_Modifier}', "");
    Error('\p{GCB=- EM:=}');
    Error('\P{GCB=- EM:=}');
    Expect(0, 1, '\p{GCB=:\AEM\z:}', "");;
    Expect(0, 1, '\p{GCB=em}', "");
    Expect(1, 1, '\p{^GCB=em}', "");
    Expect(1, 1, '\P{GCB=em}', "");
    Expect(0, 1, '\P{^GCB=em}', "");
    Expect(0, 1, '\p{GCB=:\Aem\z:}', "");;
    Expect(0, 1, '\p{GCB=  EM}', "");
    Expect(1, 1, '\p{^GCB=  EM}', "");
    Expect(1, 1, '\P{GCB=  EM}', "");
    Expect(0, 1, '\P{^GCB=  EM}', "");
    Error('\p{Is_Grapheme_Cluster_Break= _e_Modifier:=}');
    Error('\P{Is_Grapheme_Cluster_Break= _e_Modifier:=}');
    Expect(0, 1, '\p{Is_Grapheme_Cluster_Break=emodifier}', "");
    Expect(1, 1, '\p{^Is_Grapheme_Cluster_Break=emodifier}', "");
    Expect(1, 1, '\P{Is_Grapheme_Cluster_Break=emodifier}', "");
    Expect(0, 1, '\P{^Is_Grapheme_Cluster_Break=emodifier}', "");
    Expect(0, 1, '\p{Is_Grapheme_Cluster_Break= 	e_Modifier}', "");
    Expect(1, 1, '\p{^Is_Grapheme_Cluster_Break= 	e_Modifier}', "");
    Expect(1, 1, '\P{Is_Grapheme_Cluster_Break= 	e_Modifier}', "");
    Expect(0, 1, '\P{^Is_Grapheme_Cluster_Break= 	e_Modifier}', "");
    Error('\p{Is_GCB=_:=EM}');
    Error('\P{Is_GCB=_:=EM}');
    Expect(0, 1, '\p{Is_GCB=em}', "");
    Expect(1, 1, '\p{^Is_GCB=em}', "");
    Expect(1, 1, '\P{Is_GCB=em}', "");
    Expect(0, 1, '\P{^Is_GCB=em}', "");
    Expect(0, 1, '\p{Is_GCB=_	em}', "");
    Expect(1, 1, '\p{^Is_GCB=_	em}', "");
    Expect(1, 1, '\P{Is_GCB=_	em}', "");
    Expect(0, 1, '\P{^Is_GCB=_	em}', "");
    Error('\p{Grapheme_Cluster_Break= EXTEND:=}');
    Error('\P{Grapheme_Cluster_Break= EXTEND:=}');
    Expect(1, 917999, '\p{Grapheme_Cluster_Break=:\AExtend\z:}', "");;
    Expect(0, 918000, '\p{Grapheme_Cluster_Break=:\AExtend\z:}', "");;
    Expect(1, 917999, '\p{Grapheme_Cluster_Break=extend}', "");
    Expect(0, 917999, '\p{^Grapheme_Cluster_Break=extend}', "");
    Expect(0, 917999, '\P{Grapheme_Cluster_Break=extend}', "");
    Expect(1, 917999, '\P{^Grapheme_Cluster_Break=extend}', "");
    Expect(0, 918000, '\p{Grapheme_Cluster_Break=extend}', "");
    Expect(1, 918000, '\p{^Grapheme_Cluster_Break=extend}', "");
    Expect(1, 918000, '\P{Grapheme_Cluster_Break=extend}', "");
    Expect(0, 918000, '\P{^Grapheme_Cluster_Break=extend}', "");
    Expect(1, 917999, '\p{Grapheme_Cluster_Break=:\Aextend\z:}', "");;
    Expect(0, 918000, '\p{Grapheme_Cluster_Break=:\Aextend\z:}', "");;
    Expect(1, 917999, '\p{Grapheme_Cluster_Break= -extend}', "");
    Expect(0, 917999, '\p{^Grapheme_Cluster_Break= -extend}', "");
    Expect(0, 917999, '\P{Grapheme_Cluster_Break= -extend}', "");
    Expect(1, 917999, '\P{^Grapheme_Cluster_Break= -extend}', "");
    Expect(0, 918000, '\p{Grapheme_Cluster_Break= -extend}', "");
    Expect(1, 918000, '\p{^Grapheme_Cluster_Break= -extend}', "");
    Expect(1, 918000, '\P{Grapheme_Cluster_Break= -extend}', "");
    Expect(0, 918000, '\P{^Grapheme_Cluster_Break= -extend}', "");
    Error('\p{GCB=	EX:=}');
    Error('\P{GCB=	EX:=}');
    Expect(1, 917999, '\p{GCB=:\AEX\z:}', "");;
    Expect(0, 918000, '\p{GCB=:\AEX\z:}', "");;
    Expect(1, 917999, '\p{GCB: ex}', "");
    Expect(0, 917999, '\p{^GCB: ex}', "");
    Expect(0, 917999, '\P{GCB: ex}', "");
    Expect(1, 917999, '\P{^GCB: ex}', "");
    Expect(0, 918000, '\p{GCB: ex}', "");
    Expect(1, 918000, '\p{^GCB: ex}', "");
    Expect(1, 918000, '\P{GCB: ex}', "");
    Expect(0, 918000, '\P{^GCB: ex}', "");
    Expect(1, 917999, '\p{GCB=:\Aex\z:}', "");;
    Expect(0, 918000, '\p{GCB=:\Aex\z:}', "");;
    Expect(1, 917999, '\p{GCB= EX}', "");
    Expect(0, 917999, '\p{^GCB= EX}', "");
    Expect(0, 917999, '\P{GCB= EX}', "");
    Expect(1, 917999, '\P{^GCB= EX}', "");
    Expect(0, 918000, '\p{GCB= EX}', "");
    Expect(1, 918000, '\p{^GCB= EX}', "");
    Expect(1, 918000, '\P{GCB= EX}', "");
    Expect(0, 918000, '\P{^GCB= EX}', "");
    Error('\p{Is_Grapheme_Cluster_Break::=	-EXTEND}');
    Error('\P{Is_Grapheme_Cluster_Break::=	-EXTEND}');
    Expect(1, 917999, '\p{Is_Grapheme_Cluster_Break=extend}', "");
    Expect(0, 917999, '\p{^Is_Grapheme_Cluster_Break=extend}', "");
    Expect(0, 917999, '\P{Is_Grapheme_Cluster_Break=extend}', "");
    Expect(1, 917999, '\P{^Is_Grapheme_Cluster_Break=extend}', "");
    Expect(0, 918000, '\p{Is_Grapheme_Cluster_Break=extend}', "");
    Expect(1, 918000, '\p{^Is_Grapheme_Cluster_Break=extend}', "");
    Expect(1, 918000, '\P{Is_Grapheme_Cluster_Break=extend}', "");
    Expect(0, 918000, '\P{^Is_Grapheme_Cluster_Break=extend}', "");
    Expect(1, 917999, '\p{Is_Grapheme_Cluster_Break=	Extend}', "");
    Expect(0, 917999, '\p{^Is_Grapheme_Cluster_Break=	Extend}', "");
    Expect(0, 917999, '\P{Is_Grapheme_Cluster_Break=	Extend}', "");
    Expect(1, 917999, '\P{^Is_Grapheme_Cluster_Break=	Extend}', "");
    Expect(0, 918000, '\p{Is_Grapheme_Cluster_Break=	Extend}', "");
    Expect(1, 918000, '\p{^Is_Grapheme_Cluster_Break=	Extend}', "");
    Expect(1, 918000, '\P{Is_Grapheme_Cluster_Break=	Extend}', "");
    Expect(0, 918000, '\P{^Is_Grapheme_Cluster_Break=	Extend}', "");
    Error('\p{Is_GCB:    EX:=}');
    Error('\P{Is_GCB:    EX:=}');
    Expect(1, 917999, '\p{Is_GCB=ex}', "");
    Expect(0, 917999, '\p{^Is_GCB=ex}', "");
    Expect(0, 917999, '\P{Is_GCB=ex}', "");
    Expect(1, 917999, '\P{^Is_GCB=ex}', "");
    Expect(0, 918000, '\p{Is_GCB=ex}', "");
    Expect(1, 918000, '\p{^Is_GCB=ex}', "");
    Expect(1, 918000, '\P{Is_GCB=ex}', "");
    Expect(0, 918000, '\P{^Is_GCB=ex}', "");
    Expect(1, 917999, '\p{Is_GCB=	-ex}', "");
    Expect(0, 917999, '\p{^Is_GCB=	-ex}', "");
    Expect(0, 917999, '\P{Is_GCB=	-ex}', "");
    Expect(1, 917999, '\P{^Is_GCB=	-ex}', "");
    Expect(0, 918000, '\p{Is_GCB=	-ex}', "");
    Expect(1, 918000, '\p{^Is_GCB=	-ex}', "");
    Expect(1, 918000, '\P{Is_GCB=	-ex}', "");
    Expect(0, 918000, '\P{^Is_GCB=	-ex}', "");
    Error('\p{Grapheme_Cluster_Break=/a/ -Glue_After_Zwj}');
    Error('\P{Grapheme_Cluster_Break=/a/ -Glue_After_Zwj}');
    Expect(0, 1, '\p{Grapheme_Cluster_Break=:\AGlue_After_Zwj\z:}', "");;
    Expect(0, 1, '\p{Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(1, 1, '\p{^Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(1, 1, '\P{Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(0, 1, '\P{^Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(0, 1, '\p{Grapheme_Cluster_Break=:\Aglueafterzwj\z:}', "");;
    Expect(0, 1, '\p{Grapheme_Cluster_Break= Glue_after_ZWJ}', "");
    Expect(1, 1, '\p{^Grapheme_Cluster_Break= Glue_after_ZWJ}', "");
    Expect(1, 1, '\P{Grapheme_Cluster_Break= Glue_after_ZWJ}', "");
    Expect(0, 1, '\P{^Grapheme_Cluster_Break= Glue_after_ZWJ}', "");
    Error('\p{GCB= /a/GAZ}');
    Error('\P{GCB= /a/GAZ}');
    Expect(0, 1, '\p{GCB=:\AGAZ\z:}', "");;
    Expect(0, 1, '\p{GCB=gaz}', "");
    Expect(1, 1, '\p{^GCB=gaz}', "");
    Expect(1, 1, '\P{GCB=gaz}', "");
    Expect(0, 1, '\P{^GCB=gaz}', "");
    Expect(0, 1, '\p{GCB=:\Agaz\z:}', "");;
    Expect(0, 1, '\p{GCB=__GAZ}', "");
    Expect(1, 1, '\p{^GCB=__GAZ}', "");
    Expect(1, 1, '\P{GCB=__GAZ}', "");
    Expect(0, 1, '\P{^GCB=__GAZ}', "");
    Error('\p{Is_Grapheme_Cluster_Break=/a/- GLUE_After_Zwj}');
    Error('\P{Is_Grapheme_Cluster_Break=/a/- GLUE_After_Zwj}');
    Expect(0, 1, '\p{Is_Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(1, 1, '\p{^Is_Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(1, 1, '\P{Is_Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(0, 1, '\P{^Is_Grapheme_Cluster_Break=glueafterzwj}', "");
    Expect(0, 1, '\p{Is_Grapheme_Cluster_Break=	 GLUE_After_Zwj}', "");
    Expect(1, 1, '\p{^Is_Grapheme_Cluster_Break=	 GLUE_After_Zwj}', "");
    Expect(1, 1, '\P{Is_Grapheme_Cluster_Break=	 GLUE_After_Zwj}', "");
    Expect(0, 1, '\P{^Is_Grapheme_Cluster_Break=	 GLUE_After_Zwj}', "");
    Error('\p{Is_GCB=_/a/GAZ}');
    Error('\P{Is_GCB=_/a/GAZ}');
    Expect(0, 1, '\p{Is_GCB=gaz}', "");
    Expect(1, 1, '\p{^Is_GCB=gaz}', "");
    Expect(1, 1, '\P{Is_GCB=gaz}', "");
    Expect(0, 1, '\P{^Is_GCB=gaz}', "");
    Expect(0, 1, '\p{Is_GCB=_	GAZ}', "");
    Expect(1, 1, '\p{^Is_GCB=_	GAZ}', "");
    Expect(1, 1, '\P{Is_GCB=_	GAZ}', "");
    Expect(0, 1, '\P{^Is_GCB=_	GAZ}', "");
    Error('\p{Grapheme_Cluster_Break:    :=l}');
    Error('\P{Grapheme_Cluster_Break:    :=l}');
    Expect(1, 43388, '\p{Grapheme_Cluster_Break=:\AL\z:}', "");;
    Expect(0, 43389, '\p{Grapheme_Cluster_Break=:\AL\z:}', "");;
    Expect(1, 43388, '\p{Grapheme_Cluster_Break=l}', "");
    Expect(0, 43388, '\p{^Grapheme_Cluster_Break=l}', "");
    Expect(0, 43388, '\P{Grapheme_Cluster_Break=l}', "");
    Expect(1, 43388, '\P{^Grapheme_Cluster_Break=l}', "");
    Expect(0, 43389, '\p{Grapheme_Cluster_Break=l}', "");
    Expect(1, 43389, '\p{^Grapheme_Cluster_Break=l}', "");
    Expect(1, 43389, '\P{Grapheme_Cluster_Break=l}', "");
    Expect(0, 43389, '\P{^Grapheme_Cluster_Break=l}', "");
    Expect(1, 43388, '\p{Grapheme_Cluster_Break=:\Al\z:}', "");;
    Expect(0, 43389, '\p{Grapheme_Cluster_Break=:\Al\z:}', "");;
    Expect(1, 43388, '\p{Grapheme_Cluster_Break: -_L}', "");
    Expect(0, 43388, '\p{^Grapheme_Cluster_Break: -_L}', "");
    Expect(0, 43388, '\P{Grapheme_Cluster_Break: -_L}', "");
    Expect(1, 43388, '\P{^Grapheme_Cluster_Break: -_L}', "");
    Expect(0, 43389, '\p{Grapheme_Cluster_Break: -_L}', "");
    Expect(1, 43389, '\p{^Grapheme_Cluster_Break: -_L}', "");
    Expect(1, 43389, '\P{Grapheme_Cluster_Break: -_L}', "");
    Expect(0, 43389, '\P{^Grapheme_Cluster_Break: -_L}', "");
    Error('\p{GCB=/a/L}');
    Error('\P{GCB=/a/L}');
    Expect(1, 43388, '\p{GCB=:\AL\z:}', "");;
    Expect(0, 43389, '\p{GCB=:\AL\z:}', "");;
    Expect(1, 43388, '\p{GCB=l}', "");
    Expect(0, 43388, '\p{^GCB=l}', "");
    Expect(0, 43388, '\P{GCB=l}', "");
    Expect(1, 43388, '\P{^GCB=l}', "");
    Expect(0, 43389, '\p{GCB=l}', "");
    Expect(1, 43389, '\p{^GCB=l}', "");
    Expect(1, 43389, '\P{GCB=l}', "");
    Expect(0, 43389, '\P{^GCB=l}', "");
    Expect(1, 43388, '\p{GCB=:\Al\z:}', "");;
    Expect(0, 43389, '\p{GCB=:\Al\z:}', "");;
    Expect(1, 43388, '\p{GCB= -L}', "");
    Expect(0, 43388, '\p{^GCB= -L}', "");
    Expect(0, 43388, '\P{GCB= -L}', "");
    Expect(1, 43388, '\P{^GCB= -L}', "");
    Expect(0, 43389, '\p{GCB= -L}', "");
    Expect(1, 43389, '\p{^GCB= -L}', "");
    Expect(1, 43389, '\P{GCB= -L}', "");
    Expect(0, 43389, '\P{^GCB= -L}', "");
    Error('\p{Is_Grapheme_Cluster_Break=_-l/a/}');
    Error('\P{Is_Grapheme_Cluster_Break=_-l/a/}');
    Expect(1, 43388, '\p{Is_Grapheme_Cluster_Break=l}', "");
    Expect(0, 43388, '\p{^Is_Grapheme_Cluster_Break=l}', "");
    Expect(0, 43388, '\P{Is_Grapheme_Cluster_Break=l}', "");
    Expect(1, 43388, '\P{^Is_Grapheme_Cluster_Break=l}', "");
    Expect(0, 43389, '\p{Is_Grapheme_Cluster_Break=l}', "");
    Expect(1, 43389, '\p{^Is_Grapheme_Cluster_Break=l}', "");
    Expect(1, 43389, '\P{Is_Grapheme_Cluster_Break=l}', "");
    Expect(0, 43389, '\P{^Is_Grapheme_Cluster_Break=l}', "");
    Expect(1, 43388, '\p{Is_Grapheme_Cluster_Break=  L}', "");
    Expect(0, 43388, '\p{^Is_Grapheme_Cluster_Break=  L}', "");
    Expect(0, 43388, '\P{Is_Grapheme_Cluster_Break=  L}', "");
    Expect(1, 43388, '\P{^Is_Grapheme_Cluster_Break=  L}', "");
    Expect(0, 43389, '\p{Is_Grapheme_Cluster_Break=  L}', "");
    Expect(1, 43389, '\p{^Is_Grapheme_Cluster_Break=  L}', "");
    Expect(1, 43389, '\P{Is_Grapheme_Cluster_Break=  L}', "");
    Expect(0, 43389, '\P{^Is_Grapheme_Cluster_Break=  L}', "");
    Error('\p{Is_GCB=:=_-L}');
    Error('\P{Is_GCB=:=_-L}');
    Expect(1, 43388, '\p{Is_GCB=l}', "");
    Expect(0, 43388, '\p{^Is_GCB=l}', "");
    Expect(0, 43388, '\P{Is_GCB=l}', "");
    Expect(1, 43388, '\P{^Is_GCB=l}', "");
    Expect(0, 43389, '\p{Is_GCB=l}', "");
    Expect(1, 43389, '\p{^Is_GCB=l}', "");
    Expect(1, 43389, '\P{Is_GCB=l}', "");
    Expect(0, 43389, '\P{^Is_GCB=l}', "");
    Expect(1, 43388, '\p{Is_GCB:	-L}', "");
    Expect(0, 43388, '\p{^Is_GCB:	-L}', "");
    Expect(0, 43388, '\P{Is_GCB:	-L}', "");
    Expect(1, 43388, '\P{^Is_GCB:	-L}', "");
    Expect(0, 43389, '\p{Is_GCB:	-L}', "");
    Expect(1, 43389, '\p{^Is_GCB:	-L}', "");
    Expect(1, 43389, '\P{Is_GCB:	-L}', "");
    Expect(0, 43389, '\P{^Is_GCB:	-L}', "");
    Error('\p{Grapheme_Cluster_Break: _LF/a/}');
    Error('\P{Grapheme_Cluster_Break: _LF/a/}');
    Expect(1, 10, '\p{Grapheme_Cluster_Break=:\ALF\z:}', "");;
    Expect(0, 11, '\p{Grapheme_Cluster_Break=:\ALF\z:}', "");;
    Expect(1, 10, '\p{Grapheme_Cluster_Break=lf}', "");
    Expect(0, 10, '\p{^Grapheme_Cluster_Break=lf}', "");
    Expect(0, 10, '\P{Grapheme_Cluster_Break=lf}', "");
    Expect(1, 10, '\P{^Grapheme_Cluster_Break=lf}', "");
    Expect(0, 11, '\p{Grapheme_Cluster_Break=lf}', "");
    Expect(1, 11, '\p{^Grapheme_Cluster_Break=lf}', "");
    Expect(1, 11, '\P{Grapheme_Cluster_Break=lf}', "");
    Expect(0, 11, '\P{^Grapheme_Cluster_Break=lf}', "");
    Expect(1, 10, '\p{Grapheme_Cluster_Break=:\Alf\z:}', "");;
    Expect(0, 11, '\p{Grapheme_Cluster_Break=:\Alf\z:}', "");;
    Expect(1, 10, '\p{Grapheme_Cluster_Break=	-LF}', "");
    Expect(0, 10, '\p{^Grapheme_Cluster_Break=	-LF}', "");
    Expect(0, 10, '\P{Grapheme_Cluster_Break=	-LF}', "");
    Expect(1, 10, '\P{^Grapheme_Cluster_Break=	-LF}', "");
    Expect(0, 11, '\p{Grapheme_Cluster_Break=	-LF}', "");
    Expect(1, 11, '\p{^Grapheme_Cluster_Break=	-LF}', "");
    Expect(1, 11, '\P{Grapheme_Cluster_Break=	-LF}', "");
    Expect(0, 11, '\P{^Grapheme_Cluster_Break=	-LF}', "");
    Error('\p{GCB=:=	LF}');
    Error('\P{GCB=:=	LF}');
    Expect(1, 10, '\p{GCB=:\ALF\z:}', "");;
    Expect(0, 11, '\p{GCB=:\ALF\z:}', "");;
    Expect(1, 10, '\p{GCB: lf}', "");
    Expect(0, 10, '\p{^GCB: lf}', "");
    Expect(0, 10, '\P{GCB: lf}', "");
    Expect(1, 10, '\P{^GCB: lf}', "");
    Expect(0, 11, '\p{GCB: lf}', "");
    Expect(1, 11, '\p{^GCB: lf}', "");
    Expect(1, 11, '\P{GCB: lf}', "");
    Expect(0, 11, '\P{^GCB: lf}', "");
    Expect(1, 10, '\p{GCB=:\Alf\z:}', "");;
    Expect(0, 11, '\p{GCB=:\Alf\z:}', "");;
    Expect(1, 10, '\p{GCB=-	LF}', "");
    Expect(0, 10, '\p{^GCB=-	LF}', "");
    Expect(0, 10, '\P{GCB=-	LF}', "");
    Expect(1, 10, '\P{^GCB=-	LF}', "");
    Expect(0, 11, '\p{GCB=-	LF}', "");
    Expect(1, 11, '\p{^GCB=-	LF}', "");
    Expect(1, 11, '\P{GCB=-	LF}', "");
    Expect(0, 11, '\P{^GCB=-	LF}', "");
    Error('\p{Is_Grapheme_Cluster_Break=/a/	LF}');
    Error('\P{Is_Grapheme_Cluster_Break=/a/	LF}');
    Expect(1, 10, '\p{Is_Grapheme_Cluster_Break=lf}', "");
    Expect(0, 10, '\p{^Is_Grapheme_Cluster_Break=lf}', "");
    Expect(0, 10, '\P{Is_Grapheme_Cluster_Break=lf}', "");
    Expect(1, 10, '\P{^Is_Grapheme_Cluster_Break=lf}', "");
    Expect(0, 11, '\p{Is_Grapheme_Cluster_Break=lf}', "");
    Expect(1, 11, '\p{^Is_Grapheme_Cluster_Break=lf}', "");
    Expect(1, 11, '\P{Is_Grapheme_Cluster_Break=lf}', "");
    Expect(0, 11, '\P{^Is_Grapheme_Cluster_Break=lf}', "");
    Expect(1, 10, '\p{Is_Grapheme_Cluster_Break=- lf}', "");
    Expect(0, 10, '\p{^Is_Grapheme_Cluster_Break=- lf}', "");
    Expect(0, 10, '\P{Is_Grapheme_Cluster_Break=- lf}', "");
    Expect(1, 10, '\P{^Is_Grapheme_Cluster_Break=- lf}', "");
    Expect(0, 11, '\p{Is_Grapheme_Cluster_Break=- lf}', "");
    Expect(1, 11, '\p{^Is_Grapheme_Cluster_Break=- lf}', "");
    Expect(1, 11, '\P{Is_Grapheme_Cluster_Break=- lf}', "");
    Expect(0, 11, '\P{^Is_Grapheme_Cluster_Break=- lf}', "");
    Error('\p{Is_GCB=_ lf/a/}');
    Error('\P{Is_GCB=_ lf/a/}');
    Expect(1, 10, '\p{Is_GCB:   lf}', "");
    Expect(0, 10, '\p{^Is_GCB:   lf}', "");
    Expect(0, 10, '\P{Is_GCB:   lf}', "");
    Expect(1, 10, '\P{^Is_GCB:   lf}', "");
    Expect(0, 11, '\p{Is_GCB:   lf}', "");
    Expect(1, 11, '\p{^Is_GCB:   lf}', "");
    Expect(1, 11, '\P{Is_GCB:   lf}', "");
    Expect(0, 11, '\P{^Is_GCB:   lf}', "");
    Expect(1, 10, '\p{Is_GCB=LF}', "");
    Expect(0, 10, '\p{^Is_GCB=LF}', "");
    Expect(0, 10, '\P{Is_GCB=LF}', "");
    Expect(1, 10, '\P{^Is_GCB=LF}', "");
    Expect(0, 11, '\p{Is_GCB=LF}', "");
    Expect(1, 11, '\p{^Is_GCB=LF}', "");
    Expect(1, 11, '\P{Is_GCB=LF}', "");
    Expect(0, 11, '\P{^Is_GCB=LF}', "");
    Error('\p{Grapheme_Cluster_Break:	_-LV/a/}');
    Error('\P{Grapheme_Cluster_Break:	_-LV/a/}');
    Expect(1, 55176, '\p{Grapheme_Cluster_Break=:\ALV\z:}', "");;
    Expect(0, 55177, '\p{Grapheme_Cluster_Break=:\ALV\z:}', "");;
    Expect(1, 55176, '\p{Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55176, '\p{^Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55176, '\P{Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55176, '\P{^Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55177, '\p{Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55177, '\p{^Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55177, '\P{Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55177, '\P{^Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55176, '\p{Grapheme_Cluster_Break=:\Alv\z:}', "");;
    Expect(0, 55177, '\p{Grapheme_Cluster_Break=:\Alv\z:}', "");;
    Expect(1, 55176, '\p{Grapheme_Cluster_Break=	-lv}', "");
    Expect(0, 55176, '\p{^Grapheme_Cluster_Break=	-lv}', "");
    Expect(0, 55176, '\P{Grapheme_Cluster_Break=	-lv}', "");
    Expect(1, 55176, '\P{^Grapheme_Cluster_Break=	-lv}', "");
    Expect(0, 55177, '\p{Grapheme_Cluster_Break=	-lv}', "");
    Expect(1, 55177, '\p{^Grapheme_Cluster_Break=	-lv}', "");
    Expect(1, 55177, '\P{Grapheme_Cluster_Break=	-lv}', "");
    Expect(0, 55177, '\P{^Grapheme_Cluster_Break=	-lv}', "");
    Error('\p{GCB=-/a/LV}');
    Error('\P{GCB=-/a/LV}');
    Expect(1, 55176, '\p{GCB=:\ALV\z:}', "");;
    Expect(0, 55177, '\p{GCB=:\ALV\z:}', "");;
    Expect(1, 55176, '\p{GCB=lv}', "");
    Expect(0, 55176, '\p{^GCB=lv}', "");
    Expect(0, 55176, '\P{GCB=lv}', "");
    Expect(1, 55176, '\P{^GCB=lv}', "");
    Expect(0, 55177, '\p{GCB=lv}', "");
    Expect(1, 55177, '\p{^GCB=lv}', "");
    Expect(1, 55177, '\P{GCB=lv}', "");
    Expect(0, 55177, '\P{^GCB=lv}', "");
    Expect(1, 55176, '\p{GCB=:\Alv\z:}', "");;
    Expect(0, 55177, '\p{GCB=:\Alv\z:}', "");;
    Expect(1, 55176, '\p{GCB=	LV}', "");
    Expect(0, 55176, '\p{^GCB=	LV}', "");
    Expect(0, 55176, '\P{GCB=	LV}', "");
    Expect(1, 55176, '\P{^GCB=	LV}', "");
    Expect(0, 55177, '\p{GCB=	LV}', "");
    Expect(1, 55177, '\p{^GCB=	LV}', "");
    Expect(1, 55177, '\P{GCB=	LV}', "");
    Expect(0, 55177, '\P{^GCB=	LV}', "");
    Error('\p{Is_Grapheme_Cluster_Break::=-	LV}');
    Error('\P{Is_Grapheme_Cluster_Break::=-	LV}');
    Expect(1, 55176, '\p{Is_Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55176, '\p{^Is_Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55176, '\P{Is_Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55176, '\P{^Is_Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55177, '\p{Is_Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55177, '\p{^Is_Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55177, '\P{Is_Grapheme_Cluster_Break=lv}', "");
    Expect(0, 55177, '\P{^Is_Grapheme_Cluster_Break=lv}', "");
    Expect(1, 55176, '\p{Is_Grapheme_Cluster_Break= 	lv}', "");
    Expect(0, 55176, '\p{^Is_Grapheme_Cluster_Break= 	lv}', "");
    Expect(0, 55176, '\P{Is_Grapheme_Cluster_Break= 	lv}', "");
    Expect(1, 55176, '\P{^Is_Grapheme_Cluster_Break= 	lv}', "");
    Expect(0, 55177, '\p{Is_Grapheme_Cluster_Break= 	lv}', "");
    Expect(1, 55177, '\p{^Is_Grapheme_Cluster_Break= 	lv}', "");
    Expect(1, 55177, '\P{Is_Grapheme_Cluster_Break= 	lv}', "");
    Expect(0, 55177, '\P{^Is_Grapheme_Cluster_Break= 	lv}', "");
    Error('\p{Is_GCB=		lv:=}');
    Error('\P{Is_GCB=		lv:=}');
    Expect(1, 55176, '\p{Is_GCB=lv}', "");
    Expect(0, 55176, '\p{^Is_GCB=lv}', "");
    Expect(0, 55176, '\P{Is_GCB=lv}', "");
    Expect(1, 55176, '\P{^Is_GCB=lv}', "");
    Expect(0, 55177, '\p{Is_GCB=lv}', "");
    Expect(1, 55177, '\p{^Is_GCB=lv}', "");
    Expect(1, 55177, '\P{Is_GCB=lv}', "");
    Expect(0, 55177, '\P{^Is_GCB=lv}', "");
    Expect(1, 55176, '\p{Is_GCB= LV}', "");
    Expect(0, 55176, '\p{^Is_GCB= LV}', "");
    Expect(0, 55176, '\P{Is_GCB= LV}', "");
    Expect(1, 55176, '\P{^Is_GCB= LV}', "");
    Expect(0, 55177, '\p{Is_GCB= LV}', "");
    Expect(1, 55177, '\p{^Is_GCB= LV}', "");
    Expect(1, 55177, '\P{Is_GCB= LV}', "");
    Expect(0, 55177, '\P{^Is_GCB= LV}', "");
    Error('\p{Grapheme_Cluster_Break:  	LVT/a/}');
    Error('\P{Grapheme_Cluster_Break:  	LVT/a/}');
    Expect(1, 55203, '\p{Grapheme_Cluster_Break=:\ALVT\z:}', "");;
    Expect(0, 55204, '\p{Grapheme_Cluster_Break=:\ALVT\z:}', "");;
    Expect(1, 55203, '\p{Grapheme_Cluster_Break:lvt}', "");
    Expect(0, 55203, '\p{^Grapheme_Cluster_Break:lvt}', "");
    Expect(0, 55203, '\P{Grapheme_Cluster_Break:lvt}', "");
    Expect(1, 55203, '\P{^Grapheme_Cluster_Break:lvt}', "");
    Expect(0, 55204, '\p{Grapheme_Cluster_Break:lvt}', "");
    Expect(1, 55204, '\p{^Grapheme_Cluster_Break:lvt}', "");
    Expect(1, 55204, '\P{Grapheme_Cluster_Break:lvt}', "");
    Expect(0, 55204, '\P{^Grapheme_Cluster_Break:lvt}', "");
    Expect(1, 55203, '\p{Grapheme_Cluster_Break=:\Alvt\z:}', "");;
    Expect(0, 55204, '\p{Grapheme_Cluster_Break=:\Alvt\z:}', "");;
    Expect(1, 55203, '\p{Grapheme_Cluster_Break=LVT}', "");
    Expect(0, 55203, '\p{^Grapheme_Cluster_Break=LVT}', "");
    Expect(0, 55203, '\P{Grapheme_Cluster_Break=LVT}', "");
    Expect(1, 55203, '\P{^Grapheme_Cluster_Break=LVT}', "");
    Expect(0, 55204, '\p{Grapheme_Cluster_Break=LVT}', "");
    Expect(1, 55204, '\p{^Grapheme_Cluster_Break=LVT}', "");
    Expect(1, 55204, '\P{Grapheme_Cluster_Break=LVT}', "");
    Expect(0, 55204, '\P{^Grapheme_Cluster_Break=LVT}', "");
    Error('\p{GCB=-/a/lvt}');
    Error('\P{GCB=-/a/lvt}');
    Expect(1, 55203, '\p{GCB=:\ALVT\z:}', "");;
    Expect(0, 55204, '\p{GCB=:\ALVT\z:}', "");;
    Expect(1, 55203, '\p{GCB:	lvt}', "");
    Expect(0, 55203, '\p{^GCB:	lvt}', "");
    Expect(0, 55203, '\P{GCB:	lvt}', "");
    Expect(1, 55203, '\P{^GCB:	lvt}', "");
    Expect(0, 55204, '\p{GCB:	lvt}', "");
    Expect(1, 55204, '\p{^GCB:	lvt}', "");
    Expect(1, 55204, '\P{GCB:	lvt}', "");
    Expect(0, 55204, '\P{^GCB:	lvt}', "");
    Expect(1, 55203, '\p{GCB=:\Alvt\z:}', "");;
    Expect(0, 55204, '\p{GCB=:\Alvt\z:}', "");;
    Expect(1, 55203, '\p{GCB=-	lvt}', "");
    Expect(0, 55203, '\p{^GCB=-	lvt}', "");
    Expect(0, 55203, '\P{GCB=-	lvt}', "");
    Expect(1, 55203, '\P{^GCB=-	lvt}', "");
    Expect(0, 55204, '\p{GCB=-	lvt}', "");
    Expect(1, 55204, '\p{^GCB=-	lvt}', "");
    Expect(1, 55204, '\P{GCB=-	lvt}', "");
    Expect(0, 55204, '\P{^GCB=-	lvt}', "");
    Error('\p{Is_Grapheme_Cluster_Break:	:=-LVT}');
    Error('\P{Is_Grapheme_Cluster_Break:	:=-LVT}');
    Expect(1, 55203, '\p{Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(0, 55203, '\p{^Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(0, 55203, '\P{Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(1, 55203, '\P{^Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(0, 55204, '\p{Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(1, 55204, '\p{^Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(1, 55204, '\P{Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(0, 55204, '\P{^Is_Grapheme_Cluster_Break=lvt}', "");
    Expect(1, 55203, '\p{Is_Grapheme_Cluster_Break=__LVT}', "");
    Expect(0, 55203, '\p{^Is_Grapheme_Cluster_Break=__LVT}', "");
    Expect(0, 55203, '\P{Is_Grapheme_Cluster_Break=__LVT}', "");
    Expect(1, 55203, '\P{^Is_Grapheme_Cluster_Break=__LVT}', "");
    Expect(0, 55204, '\p{Is_Grapheme_Cluster_Break=__LVT}', "");
    Expect(1, 55204, '\p{^Is_Grapheme_Cluster_Break=__LVT}', "");
    Expect(1, 55204, '\P{Is_Grapheme_Cluster_Break=__LVT}', "");
    Expect(0, 55204, '\P{^Is_Grapheme_Cluster_Break=__LVT}', "");
    Error('\p{Is_GCB=/a/ -LVT}');
    Error('\P{Is_GCB=/a/ -LVT}');
    Expect(1, 55203, '\p{Is_GCB=lvt}', "");
    Expect(0, 55203, '\p{^Is_GCB=lvt}', "");
    Expect(0, 55203, '\P{Is_GCB=lvt}', "");
    Expect(1, 55203, '\P{^Is_GCB=lvt}', "");
    Expect(0, 55204, '\p{Is_GCB=lvt}', "");
    Expect(1, 55204, '\p{^Is_GCB=lvt}', "");
    Expect(1, 55204, '\P{Is_GCB=lvt}', "");
    Expect(0, 55204, '\P{^Is_GCB=lvt}', "");
    Expect(1, 55203, '\p{Is_GCB=  lvt}', "");
    Expect(0, 55203, '\p{^Is_GCB=  lvt}', "");
    Expect(0, 55203, '\P{Is_GCB=  lvt}', "");
    Expect(1, 55203, '\P{^Is_GCB=  lvt}', "");
    Expect(0, 55204, '\p{Is_GCB=  lvt}', "");
    Expect(1, 55204, '\p{^Is_GCB=  lvt}', "");
    Expect(1, 55204, '\P{Is_GCB=  lvt}', "");
    Expect(0, 55204, '\P{^Is_GCB=  lvt}', "");
    Error('\p{Grapheme_Cluster_Break=_/a/prepend}');
    Error('\P{Grapheme_Cluster_Break=_/a/prepend}');
    Expect(1, 73030, '\p{Grapheme_Cluster_Break=:\APrepend\z:}', "");;
    Expect(0, 73031, '\p{Grapheme_Cluster_Break=:\APrepend\z:}', "");;
    Expect(1, 73030, '\p{Grapheme_Cluster_Break:   prepend}', "");
    Expect(0, 73030, '\p{^Grapheme_Cluster_Break:   prepend}', "");
    Expect(0, 73030, '\P{Grapheme_Cluster_Break:   prepend}', "");
    Expect(1, 73030, '\P{^Grapheme_Cluster_Break:   prepend}', "");
    Expect(0, 73031, '\p{Grapheme_Cluster_Break:   prepend}', "");
    Expect(1, 73031, '\p{^Grapheme_Cluster_Break:   prepend}', "");
    Expect(1, 73031, '\P{Grapheme_Cluster_Break:   prepend}', "");
    Expect(0, 73031, '\P{^Grapheme_Cluster_Break:   prepend}', "");
    Expect(1, 73030, '\p{Grapheme_Cluster_Break=:\Aprepend\z:}', "");;
    Expect(0, 73031, '\p{Grapheme_Cluster_Break=:\Aprepend\z:}', "");;
    Expect(1, 73030, '\p{Grapheme_Cluster_Break= -prepend}', "");
    Expect(0, 73030, '\p{^Grapheme_Cluster_Break= -prepend}', "");
    Expect(0, 73030, '\P{Grapheme_Cluster_Break= -prepend}', "");
    Expect(1, 73030, '\P{^Grapheme_Cluster_Break= -prepend}', "");
    Expect(0, 73031, '\p{Grapheme_Cluster_Break= -prepend}', "");
    Expect(1, 73031, '\p{^Grapheme_Cluster_Break= -prepend}', "");
    Expect(1, 73031, '\P{Grapheme_Cluster_Break= -prepend}', "");
    Expect(0, 73031, '\P{^Grapheme_Cluster_Break= -prepend}', "");
    Error('\p{GCB:	-pp:=}');
    Error('\P{GCB:	-pp:=}');
    Expect(1, 73030, '\p{GCB=:\APP\z:}', "");;
    Expect(0, 73031, '\p{GCB=:\APP\z:}', "");;
    Expect(1, 73030, '\p{GCB=pp}', "");
    Expect(0, 73030, '\p{^GCB=pp}', "");
    Expect(0, 73030, '\P{GCB=pp}', "");
    Expect(1, 73030, '\P{^GCB=pp}', "");
    Expect(0, 73031, '\p{GCB=pp}', "");
    Expect(1, 73031, '\p{^GCB=pp}', "");
    Expect(1, 73031, '\P{GCB=pp}', "");
    Expect(0, 73031, '\P{^GCB=pp}', "");
    Expect(1, 73030, '\p{GCB=:\App\z:}', "");;
    Expect(0, 73031, '\p{GCB=:\App\z:}', "");;
    Expect(1, 73030, '\p{GCB= 	pp}', "");
    Expect(0, 73030, '\p{^GCB= 	pp}', "");
    Expect(0, 73030, '\P{GCB= 	pp}', "");
    Expect(1, 73030, '\P{^GCB= 	pp}', "");
    Expect(0, 73031, '\p{GCB= 	pp}', "");
    Expect(1, 73031, '\p{^GCB= 	pp}', "");
    Expect(1, 73031, '\P{GCB= 	pp}', "");
    Expect(0, 73031, '\P{^GCB= 	pp}', "");
    Error('\p{Is_Grapheme_Cluster_Break=/a/Prepend}');
    Error('\P{Is_Grapheme_Cluster_Break=/a/Prepend}');
    Expect(1, 73030, '\p{Is_Grapheme_Cluster_Break=prepend}', "");
    Expect(0, 73030, '\p{^Is_Grapheme_Cluster_Break=prepend}', "");
    Expect(0, 73030, '\P{Is_Grapheme_Cluster_Break=prepend}', "");
    Expect(1, 73030, '\P{^Is_Grapheme_Cluster_Break=prepend}', "");
    Expect(0, 73031, '\p{Is_Grapheme_Cluster_Break=prepend}', "");
    Expect(1, 73031, '\p{^Is_Grapheme_Cluster_Break=prepend}', "");
    Expect(1, 73031, '\P{Is_Grapheme_Cluster_Break=prepend}', "");
    Expect(0, 73031, '\P{^Is_Grapheme_Cluster_Break=prepend}', "");
    Expect(1, 73030, '\p{Is_Grapheme_Cluster_Break=PREPEND}', "");
    Expect(0, 73030, '\p{^Is_Grapheme_Cluster_Break=PREPEND}', "");
    Expect(0, 73030, '\P{Is_Grapheme_Cluster_Break=PREPEND}', "");
    Expect(1, 73030, '\P{^Is_Grapheme_Cluster_Break=PREPEND}', "");
    Expect(0, 73031, '\p{Is_Grapheme_Cluster_Break=PREPEND}', "");
    Expect(1, 73031, '\p{^Is_Grapheme_Cluster_Break=PREPEND}', "");
    Expect(1, 73031, '\P{Is_Grapheme_Cluster_Break=PREPEND}', "");
    Expect(0, 73031, '\P{^Is_Grapheme_Cluster_Break=PREPEND}', "");
    Error('\p{Is_GCB=_:=PP}');
    Error('\P{Is_GCB=_:=PP}');
    Expect(1, 73030, '\p{Is_GCB=pp}', "");
    Expect(0, 73030, '\p{^Is_GCB=pp}', "");
    Expect(0, 73030, '\P{Is_GCB=pp}', "");
    Expect(1, 73030, '\P{^Is_GCB=pp}', "");
    Expect(0, 73031, '\p{Is_GCB=pp}', "");
    Expect(1, 73031, '\p{^Is_GCB=pp}', "");
    Expect(1, 73031, '\P{Is_GCB=pp}', "");
    Expect(0, 73031, '\P{^Is_GCB=pp}', "");
    Expect(1, 73030, '\p{Is_GCB=_ PP}', "");
    Expect(0, 73030, '\p{^Is_GCB=_ PP}', "");
    Expect(0, 73030, '\P{Is_GCB=_ PP}', "");
    Expect(1, 73030, '\P{^Is_GCB=_ PP}', "");
    Expect(0, 73031, '\p{Is_GCB=_ PP}', "");
    Expect(1, 73031, '\p{^Is_GCB=_ PP}', "");
    Expect(1, 73031, '\P{Is_GCB=_ PP}', "");
    Expect(0, 73031, '\P{^Is_GCB=_ PP}', "");
    Error('\p{Grapheme_Cluster_Break=:=	-regional_Indicator}');
    Error('\P{Grapheme_Cluster_Break=:=	-regional_Indicator}');
    Expect(1, 127487, '\p{Grapheme_Cluster_Break=:\ARegional_Indicator\z:}', "");;
    Expect(0, 127488, '\p{Grapheme_Cluster_Break=:\ARegional_Indicator\z:}', "");;
    Expect(1, 127487, '\p{Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127487, '\p{^Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127487, '\P{Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127487, '\P{^Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127488, '\p{Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127488, '\p{^Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127488, '\P{Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127488, '\P{^Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127487, '\p{Grapheme_Cluster_Break=:\Aregionalindicator\z:}', "");;
    Expect(0, 127488, '\p{Grapheme_Cluster_Break=:\Aregionalindicator\z:}', "");;
    Expect(1, 127487, '\p{Grapheme_Cluster_Break=	 Regional_Indicator}', "");
    Expect(0, 127487, '\p{^Grapheme_Cluster_Break=	 Regional_Indicator}', "");
    Expect(0, 127487, '\P{Grapheme_Cluster_Break=	 Regional_Indicator}', "");
    Expect(1, 127487, '\P{^Grapheme_Cluster_Break=	 Regional_Indicator}', "");
    Expect(0, 127488, '\p{Grapheme_Cluster_Break=	 Regional_Indicator}', "");
    Expect(1, 127488, '\p{^Grapheme_Cluster_Break=	 Regional_Indicator}', "");
    Expect(1, 127488, '\P{Grapheme_Cluster_Break=	 Regional_Indicator}', "");
    Expect(0, 127488, '\P{^Grapheme_Cluster_Break=	 Regional_Indicator}', "");
    Error('\p{GCB=	_ri:=}');
    Error('\P{GCB=	_ri:=}');
    Expect(1, 127487, '\p{GCB=:\ARI\z:}', "");;
    Expect(0, 127488, '\p{GCB=:\ARI\z:}', "");;
    Expect(1, 127487, '\p{GCB=ri}', "");
    Expect(0, 127487, '\p{^GCB=ri}', "");
    Expect(0, 127487, '\P{GCB=ri}', "");
    Expect(1, 127487, '\P{^GCB=ri}', "");
    Expect(0, 127488, '\p{GCB=ri}', "");
    Expect(1, 127488, '\p{^GCB=ri}', "");
    Expect(1, 127488, '\P{GCB=ri}', "");
    Expect(0, 127488, '\P{^GCB=ri}', "");
    Expect(1, 127487, '\p{GCB=:\Ari\z:}', "");;
    Expect(0, 127488, '\p{GCB=:\Ari\z:}', "");;
    Expect(1, 127487, '\p{GCB=  RI}', "");
    Expect(0, 127487, '\p{^GCB=  RI}', "");
    Expect(0, 127487, '\P{GCB=  RI}', "");
    Expect(1, 127487, '\P{^GCB=  RI}', "");
    Expect(0, 127488, '\p{GCB=  RI}', "");
    Expect(1, 127488, '\p{^GCB=  RI}', "");
    Expect(1, 127488, '\P{GCB=  RI}', "");
    Expect(0, 127488, '\P{^GCB=  RI}', "");
    Error('\p{Is_Grapheme_Cluster_Break=-/a/regional_indicator}');
    Error('\P{Is_Grapheme_Cluster_Break=-/a/regional_indicator}');
    Expect(1, 127487, '\p{Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127487, '\p{^Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127487, '\P{Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127487, '\P{^Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127488, '\p{Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127488, '\p{^Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127488, '\P{Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(0, 127488, '\P{^Is_Grapheme_Cluster_Break=regionalindicator}', "");
    Expect(1, 127487, '\p{Is_Grapheme_Cluster_Break=_REGIONAL_INDICATOR}', "");
    Expect(0, 127487, '\p{^Is_Grapheme_Cluster_Break=_REGIONAL_INDICATOR}', "");
    Expect(0, 127487, '\P{Is_Grapheme_Cluster_Break=_REGIONAL_INDICATOR}', "");
    Expect(1, 127487, '\P{^Is_Grapheme_Cluster_Break=_REGIONAL_INDICATOR}', "");
    Expect(0, 127488, '\p{Is_Grapheme_Cluster_Break=_REGIONAL_INDICATOR}', "");
    Expect(1, 127488, '\p{^Is_Grapheme_Cluster_Break=_REGIONAL_INDICATOR}', "");
    Expect(1, 127488, '\P{Is_Grapheme_Cluster_Break=_REGIONAL_INDICATOR}', "");
    Expect(0, 127488, '\P{^Is_Grapheme_Cluster_Break=_REGIONAL_INDICATOR}', "");
    Error('\p{Is_GCB=_/a/RI}');
    Error('\P{Is_GCB=_/a/RI}');
    Expect(1, 127487, '\p{Is_GCB=ri}', "");
    Expect(0, 127487, '\p{^Is_GCB=ri}', "");
    Expect(0, 127487, '\P{Is_GCB=ri}', "");
    Expect(1, 127487, '\P{^Is_GCB=ri}', "");
    Expect(0, 127488, '\p{Is_GCB=ri}', "");
    Expect(1, 127488, '\p{^Is_GCB=ri}', "");
    Expect(1, 127488, '\P{Is_GCB=ri}', "");
    Expect(0, 127488, '\P{^Is_GCB=ri}', "");
    Expect(1, 127487, '\p{Is_GCB= _RI}', "");
    Expect(0, 127487, '\p{^Is_GCB= _RI}', "");
    Expect(0, 127487, '\P{Is_GCB= _RI}', "");
    Expect(1, 127487, '\P{^Is_GCB= _RI}', "");
    Expect(0, 127488, '\p{Is_GCB= _RI}', "");
    Expect(1, 127488, '\p{^Is_GCB= _RI}', "");
    Expect(1, 127488, '\P{Is_GCB= _RI}', "");
    Expect(0, 127488, '\P{^Is_GCB= _RI}', "");
    Error('\p{Grapheme_Cluster_Break= spacingmark/a/}');
    Error('\P{Grapheme_Cluster_Break= spacingmark/a/}');
    Expect(1, 119149, '\p{Grapheme_Cluster_Break=:\ASpacingMark\z:}', "");;
    Expect(0, 119150, '\p{Grapheme_Cluster_Break=:\ASpacingMark\z:}', "");;
    Expect(1, 119149, '\p{Grapheme_Cluster_Break:   spacingmark}', "");
    Expect(0, 119149, '\p{^Grapheme_Cluster_Break:   spacingmark}', "");
    Expect(0, 119149, '\P{Grapheme_Cluster_Break:   spacingmark}', "");
    Expect(1, 119149, '\P{^Grapheme_Cluster_Break:   spacingmark}', "");
    Expect(0, 119150, '\p{Grapheme_Cluster_Break:   spacingmark}', "");
    Expect(1, 119150, '\p{^Grapheme_Cluster_Break:   spacingmark}', "");
    Expect(1, 119150, '\P{Grapheme_Cluster_Break:   spacingmark}', "");
    Expect(0, 119150, '\P{^Grapheme_Cluster_Break:   spacingmark}', "");
    Expect(1, 119149, '\p{Grapheme_Cluster_Break=:\Aspacingmark\z:}', "");;
    Expect(0, 119150, '\p{Grapheme_Cluster_Break=:\Aspacingmark\z:}', "");;
    Expect(1, 119149, '\p{Grapheme_Cluster_Break=- SpacingMark}', "");
    Expect(0, 119149, '\p{^Grapheme_Cluster_Break=- SpacingMark}', "");
    Expect(0, 119149, '\P{Grapheme_Cluster_Break=- SpacingMark}', "");
    Expect(1, 119149, '\P{^Grapheme_Cluster_Break=- SpacingMark}', "");
    Expect(0, 119150, '\p{Grapheme_Cluster_Break=- SpacingMark}', "");
    Expect(1, 119150, '\p{^Grapheme_Cluster_Break=- SpacingMark}', "");
    Expect(1, 119150, '\P{Grapheme_Cluster_Break=- SpacingMark}', "");
    Expect(0, 119150, '\P{^Grapheme_Cluster_Break=- SpacingMark}', "");
    Error('\p{GCB:   	_SM/a/}');
    Error('\P{GCB:   	_SM/a/}');
    Expect(1, 119149, '\p{GCB=:\ASM\z:}', "");;
    Expect(0, 119150, '\p{GCB=:\ASM\z:}', "");;
    Expect(1, 119149, '\p{GCB=sm}', "");
    Expect(0, 119149, '\p{^GCB=sm}', "");
    Expect(0, 119149, '\P{GCB=sm}', "");
    Expect(1, 119149, '\P{^GCB=sm}', "");
    Expect(0, 119150, '\p{GCB=sm}', "");
    Expect(1, 119150, '\p{^GCB=sm}', "");
    Expect(1, 119150, '\P{GCB=sm}', "");
    Expect(0, 119150, '\P{^GCB=sm}', "");
    Expect(1, 119149, '\p{GCB=:\Asm\z:}', "");;
    Expect(0, 119150, '\p{GCB=:\Asm\z:}', "");;
    Expect(1, 119149, '\p{GCB= SM}', "");
    Expect(0, 119149, '\p{^GCB= SM}', "");
    Expect(0, 119149, '\P{GCB= SM}', "");
    Expect(1, 119149, '\P{^GCB= SM}', "");
    Expect(0, 119150, '\p{GCB= SM}', "");
    Expect(1, 119150, '\p{^GCB= SM}', "");
    Expect(1, 119150, '\P{GCB= SM}', "");
    Expect(0, 119150, '\P{^GCB= SM}', "");
    Error('\p{Is_Grapheme_Cluster_Break=_	SpacingMark/a/}');
    Error('\P{Is_Grapheme_Cluster_Break=_	SpacingMark/a/}');
    Expect(1, 119149, '\p{Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119149, '\p{^Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119149, '\P{Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119149, '\P{^Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119150, '\p{Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119150, '\p{^Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119150, '\P{Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(0, 119150, '\P{^Is_Grapheme_Cluster_Break=spacingmark}', "");
    Expect(1, 119149, '\p{Is_Grapheme_Cluster_Break:	 -SpacingMark}', "");
    Expect(0, 119149, '\p{^Is_Grapheme_Cluster_Break:	 -SpacingMark}', "");
    Expect(0, 119149, '\P{Is_Grapheme_Cluster_Break:	 -SpacingMark}', "");
    Expect(1, 119149, '\P{^Is_Grapheme_Cluster_Break:	 -SpacingMark}', "");
    Expect(0, 119150, '\p{Is_Grapheme_Cluster_Break:	 -SpacingMark}', "");
    Expect(1, 119150, '\p{^Is_Grapheme_Cluster_Break:	 -SpacingMark}', "");
    Expect(1, 119150, '\P{Is_Grapheme_Cluster_Break:	 -SpacingMark}', "");
    Expect(0, 119150, '\P{^Is_Grapheme_Cluster_Break:	 -SpacingMark}', "");
    Error('\p{Is_GCB=:=	sm}');
    Error('\P{Is_GCB=:=	sm}');
    Expect(1, 119149, '\p{Is_GCB: sm}', "");
    Expect(0, 119149, '\p{^Is_GCB: sm}', "");
    Expect(0, 119149, '\P{Is_GCB: sm}', "");
    Expect(1, 119149, '\P{^Is_GCB: sm}', "");
    Expect(0, 119150, '\p{Is_GCB: sm}', "");
    Expect(1, 119150, '\p{^Is_GCB: sm}', "");
    Expect(1, 119150, '\P{Is_GCB: sm}', "");
    Expect(0, 119150, '\P{^Is_GCB: sm}', "");
    Expect(1, 119149, '\p{Is_GCB= SM}', "");
    Expect(0, 119149, '\p{^Is_GCB= SM}', "");
    Expect(0, 119149, '\P{Is_GCB= SM}', "");
    Expect(1, 119149, '\P{^Is_GCB= SM}', "");
    Expect(0, 119150, '\p{Is_GCB= SM}', "");
    Expect(1, 119150, '\p{^Is_GCB= SM}', "");
    Expect(1, 119150, '\P{Is_GCB= SM}', "");
    Expect(0, 119150, '\P{^Is_GCB= SM}', "");
    Error('\p{Grapheme_Cluster_Break= T/a/}');
    Error('\P{Grapheme_Cluster_Break= T/a/}');
    Expect(1, 55291, '\p{Grapheme_Cluster_Break=:\AT\z:}', "");;
    Expect(0, 55292, '\p{Grapheme_Cluster_Break=:\AT\z:}', "");;
    Expect(1, 55291, '\p{Grapheme_Cluster_Break=t}', "");
    Expect(0, 55291, '\p{^Grapheme_Cluster_Break=t}', "");
    Expect(0, 55291, '\P{Grapheme_Cluster_Break=t}', "");
    Expect(1, 55291, '\P{^Grapheme_Cluster_Break=t}', "");
    Expect(0, 55292, '\p{Grapheme_Cluster_Break=t}', "");
    Expect(1, 55292, '\p{^Grapheme_Cluster_Break=t}', "");
    Expect(1, 55292, '\P{Grapheme_Cluster_Break=t}', "");
    Expect(0, 55292, '\P{^Grapheme_Cluster_Break=t}', "");
    Expect(1, 55291, '\p{Grapheme_Cluster_Break=:\At\z:}', "");;
    Expect(0, 55292, '\p{Grapheme_Cluster_Break=:\At\z:}', "");;
    Expect(1, 55291, '\p{Grapheme_Cluster_Break=__T}', "");
    Expect(0, 55291, '\p{^Grapheme_Cluster_Break=__T}', "");
    Expect(0, 55291, '\P{Grapheme_Cluster_Break=__T}', "");
    Expect(1, 55291, '\P{^Grapheme_Cluster_Break=__T}', "");
    Expect(0, 55292, '\p{Grapheme_Cluster_Break=__T}', "");
    Expect(1, 55292, '\p{^Grapheme_Cluster_Break=__T}', "");
    Expect(1, 55292, '\P{Grapheme_Cluster_Break=__T}', "");
    Expect(0, 55292, '\P{^Grapheme_Cluster_Break=__T}', "");
    Error('\p{GCB=/a/_T}');
    Error('\P{GCB=/a/_T}');
    Expect(1, 55291, '\p{GCB=:\AT\z:}', "");;
    Expect(0, 55292, '\p{GCB=:\AT\z:}', "");;
    Expect(1, 55291, '\p{GCB=t}', "");
    Expect(0, 55291, '\p{^GCB=t}', "");
    Expect(0, 55291, '\P{GCB=t}', "");
    Expect(1, 55291, '\P{^GCB=t}', "");
    Expect(0, 55292, '\p{GCB=t}', "");
    Expect(1, 55292, '\p{^GCB=t}', "");
    Expect(1, 55292, '\P{GCB=t}', "");
    Expect(0, 55292, '\P{^GCB=t}', "");
    Expect(1, 55291, '\p{GCB=:\At\z:}', "");;
    Expect(0, 55292, '\p{GCB=:\At\z:}', "");;
    Expect(1, 55291, '\p{GCB= T}', "");
    Expect(0, 55291, '\p{^GCB= T}', "");
    Expect(0, 55291, '\P{GCB= T}', "");
    Expect(1, 55291, '\P{^GCB= T}', "");
    Expect(0, 55292, '\p{GCB= T}', "");
    Expect(1, 55292, '\p{^GCB= T}', "");
    Expect(1, 55292, '\P{GCB= T}', "");
    Expect(0, 55292, '\P{^GCB= T}', "");
    Error('\p{Is_Grapheme_Cluster_Break:    T:=}');
    Error('\P{Is_Grapheme_Cluster_Break:    T:=}');
    Expect(1, 55291, '\p{Is_Grapheme_Cluster_Break=t}', "");
    Expect(0, 55291, '\p{^Is_Grapheme_Cluster_Break=t}', "");
    Expect(0, 55291, '\P{Is_Grapheme_Cluster_Break=t}', "");
    Expect(1, 55291, '\P{^Is_Grapheme_Cluster_Break=t}', "");
    Expect(0, 55292, '\p{Is_Grapheme_Cluster_Break=t}', "");
    Expect(1, 55292, '\p{^Is_Grapheme_Cluster_Break=t}', "");
    Expect(1, 55292, '\P{Is_Grapheme_Cluster_Break=t}', "");
    Expect(0, 55292, '\P{^Is_Grapheme_Cluster_Break=t}', "");
    Expect(1, 55291, '\p{Is_Grapheme_Cluster_Break= 	T}', "");
    Expect(0, 55291, '\p{^Is_Grapheme_Cluster_Break= 	T}', "");
    Expect(0, 55291, '\P{Is_Grapheme_Cluster_Break= 	T}', "");
    Expect(1, 55291, '\P{^Is_Grapheme_Cluster_Break= 	T}', "");
    Expect(0, 55292, '\p{Is_Grapheme_Cluster_Break= 	T}', "");
    Expect(1, 55292, '\p{^Is_Grapheme_Cluster_Break= 	T}', "");
    Expect(1, 55292, '\P{Is_Grapheme_Cluster_Break= 	T}', "");
    Expect(0, 55292, '\P{^Is_Grapheme_Cluster_Break= 	T}', "");
    Error('\p{Is_GCB= T/a/}');
    Error('\P{Is_GCB= T/a/}');
    Expect(1, 55291, '\p{Is_GCB=t}', "");
    Expect(0, 55291, '\p{^Is_GCB=t}', "");
    Expect(0, 55291, '\P{Is_GCB=t}', "");
    Expect(1, 55291, '\P{^Is_GCB=t}', "");
    Expect(0, 55292, '\p{Is_GCB=t}', "");
    Expect(1, 55292, '\p{^Is_GCB=t}', "");
    Expect(1, 55292, '\P{Is_GCB=t}', "");
    Expect(0, 55292, '\P{^Is_GCB=t}', "");
    Expect(1, 55291, '\p{Is_GCB=	T}', "");
    Expect(0, 55291, '\p{^Is_GCB=	T}', "");
    Expect(0, 55291, '\P{Is_GCB=	T}', "");
    Expect(1, 55291, '\P{^Is_GCB=	T}', "");
    Expect(0, 55292, '\p{Is_GCB=	T}', "");
    Expect(1, 55292, '\p{^Is_GCB=	T}', "");
    Expect(1, 55292, '\P{Is_GCB=	T}', "");
    Expect(0, 55292, '\P{^Is_GCB=	T}', "");
    Error('\p{Grapheme_Cluster_Break= 	V:=}');
    Error('\P{Grapheme_Cluster_Break= 	V:=}');
    Expect(1, 55238, '\p{Grapheme_Cluster_Break=:\AV\z:}', "");;
    Expect(0, 55239, '\p{Grapheme_Cluster_Break=:\AV\z:}', "");;
    Expect(1, 55238, '\p{Grapheme_Cluster_Break=v}', "");
    Expect(0, 55238, '\p{^Grapheme_Cluster_Break=v}', "");
    Expect(0, 55238, '\P{Grapheme_Cluster_Break=v}', "");
    Expect(1, 55238, '\P{^Grapheme_Cluster_Break=v}', "");
    Expect(0, 55239, '\p{Grapheme_Cluster_Break=v}', "");
    Expect(1, 55239, '\p{^Grapheme_Cluster_Break=v}', "");
    Expect(1, 55239, '\P{Grapheme_Cluster_Break=v}', "");
    Expect(0, 55239, '\P{^Grapheme_Cluster_Break=v}', "");
    Expect(1, 55238, '\p{Grapheme_Cluster_Break=:\Av\z:}', "");;
    Expect(0, 55239, '\p{Grapheme_Cluster_Break=:\Av\z:}', "");;
    Expect(1, 55238, '\p{Grapheme_Cluster_Break=-_V}', "");
    Expect(0, 55238, '\p{^Grapheme_Cluster_Break=-_V}', "");
    Expect(0, 55238, '\P{Grapheme_Cluster_Break=-_V}', "");
    Expect(1, 55238, '\P{^Grapheme_Cluster_Break=-_V}', "");
    Expect(0, 55239, '\p{Grapheme_Cluster_Break=-_V}', "");
    Expect(1, 55239, '\p{^Grapheme_Cluster_Break=-_V}', "");
    Expect(1, 55239, '\P{Grapheme_Cluster_Break=-_V}', "");
    Expect(0, 55239, '\P{^Grapheme_Cluster_Break=-_V}', "");
    Error('\p{GCB=/a/V}');
    Error('\P{GCB=/a/V}');
    Expect(1, 55238, '\p{GCB=:\AV\z:}', "");;
    Expect(0, 55239, '\p{GCB=:\AV\z:}', "");;
    Expect(1, 55238, '\p{GCB=v}', "");
    Expect(0, 55238, '\p{^GCB=v}', "");
    Expect(0, 55238, '\P{GCB=v}', "");
    Expect(1, 55238, '\P{^GCB=v}', "");
    Expect(0, 55239, '\p{GCB=v}', "");
    Expect(1, 55239, '\p{^GCB=v}', "");
    Expect(1, 55239, '\P{GCB=v}', "");
    Expect(0, 55239, '\P{^GCB=v}', "");
    Expect(1, 55238, '\p{GCB=:\Av\z:}', "");;
    Expect(0, 55239, '\p{GCB=:\Av\z:}', "");;
    Expect(1, 55238, '\p{GCB=-V}', "");
    Expect(0, 55238, '\p{^GCB=-V}', "");
    Expect(0, 55238, '\P{GCB=-V}', "");
    Expect(1, 55238, '\P{^GCB=-V}', "");
    Expect(0, 55239, '\p{GCB=-V}', "");
    Expect(1, 55239, '\p{^GCB=-V}', "");
    Expect(1, 55239, '\P{GCB=-V}', "");
    Expect(0, 55239, '\P{^GCB=-V}', "");
    Error('\p{Is_Grapheme_Cluster_Break=:=-	V}');
    Error('\P{Is_Grapheme_Cluster_Break=:=-	V}');
    Expect(1, 55238, '\p{Is_Grapheme_Cluster_Break=v}', "");
    Expect(0, 55238, '\p{^Is_Grapheme_Cluster_Break=v}', "");
    Expect(0, 55238, '\P{Is_Grapheme_Cluster_Break=v}', "");
    Expect(1, 55238, '\P{^Is_Grapheme_Cluster_Break=v}', "");
    Expect(0, 55239, '\p{Is_Grapheme_Cluster_Break=v}', "");
    Expect(1, 55239, '\p{^Is_Grapheme_Cluster_Break=v}', "");
    Expect(1, 55239, '\P{Is_Grapheme_Cluster_Break=v}', "");
    Expect(0, 55239, '\P{^Is_Grapheme_Cluster_Break=v}', "");
    Expect(1, 55238, '\p{Is_Grapheme_Cluster_Break=- V}', "");
    Expect(0, 55238, '\p{^Is_Grapheme_Cluster_Break=- V}', "");
    Expect(0, 55238, '\P{Is_Grapheme_Cluster_Break=- V}', "");
    Expect(1, 55238, '\P{^Is_Grapheme_Cluster_Break=- V}', "");
    Expect(0, 55239, '\p{Is_Grapheme_Cluster_Break=- V}', "");
    Expect(1, 55239, '\p{^Is_Grapheme_Cluster_Break=- V}', "");
    Expect(1, 55239, '\P{Is_Grapheme_Cluster_Break=- V}', "");
    Expect(0, 55239, '\P{^Is_Grapheme_Cluster_Break=- V}', "");
    Error('\p{Is_GCB=	/a/V}');
    Error('\P{Is_GCB=	/a/V}');
    Expect(1, 55238, '\p{Is_GCB:	v}', "");
    Expect(0, 55238, '\p{^Is_GCB:	v}', "");
    Expect(0, 55238, '\P{Is_GCB:	v}', "");
    Expect(1, 55238, '\P{^Is_GCB:	v}', "");
    Expect(0, 55239, '\p{Is_GCB:	v}', "");
    Expect(1, 55239, '\p{^Is_GCB:	v}', "");
    Expect(1, 55239, '\P{Is_GCB:	v}', "");
    Expect(0, 55239, '\P{^Is_GCB:	v}', "");
    Expect(1, 55238, '\p{Is_GCB=-	V}', "");
    Expect(0, 55238, '\p{^Is_GCB=-	V}', "");
    Expect(0, 55238, '\P{Is_GCB=-	V}', "");
    Expect(1, 55238, '\P{^Is_GCB=-	V}', "");
    Expect(0, 55239, '\p{Is_GCB=-	V}', "");
    Expect(1, 55239, '\p{^Is_GCB=-	V}', "");
    Expect(1, 55239, '\P{Is_GCB=-	V}', "");
    Expect(0, 55239, '\P{^Is_GCB=-	V}', "");
    Error('\p{Grapheme_Cluster_Break:	 other:=}');
    Error('\P{Grapheme_Cluster_Break:	 other:=}');
    Expect(1, 921600, '\p{Grapheme_Cluster_Break=:\AOther\z:}', "");;
    Expect(0, 921599, '\p{Grapheme_Cluster_Break=:\AOther\z:}', "");;
    Expect(1, 921600, '\p{Grapheme_Cluster_Break=other}', "");
    Expect(0, 921600, '\p{^Grapheme_Cluster_Break=other}', "");
    Expect(0, 921600, '\P{Grapheme_Cluster_Break=other}', "");
    Expect(1, 921600, '\P{^Grapheme_Cluster_Break=other}', "");
    Expect(0, 921599, '\p{Grapheme_Cluster_Break=other}', "");
    Expect(1, 921599, '\p{^Grapheme_Cluster_Break=other}', "");
    Expect(1, 921599, '\P{Grapheme_Cluster_Break=other}', "");
    Expect(0, 921599, '\P{^Grapheme_Cluster_Break=other}', "");
    Expect(1, 921600, '\p{Grapheme_Cluster_Break=:\Aother\z:}', "");;
    Expect(0, 921599, '\p{Grapheme_Cluster_Break=:\Aother\z:}', "");;
    Expect(1, 921600, '\p{Grapheme_Cluster_Break= -other}', "");
    Expect(0, 921600, '\p{^Grapheme_Cluster_Break= -other}', "");
    Expect(0, 921600, '\P{Grapheme_Cluster_Break= -other}', "");
    Expect(1, 921600, '\P{^Grapheme_Cluster_Break= -other}', "");
    Expect(0, 921599, '\p{Grapheme_Cluster_Break= -other}', "");
    Expect(1, 921599, '\p{^Grapheme_Cluster_Break= -other}', "");
    Expect(1, 921599, '\P{Grapheme_Cluster_Break= -other}', "");
    Expect(0, 921599, '\P{^Grapheme_Cluster_Break= -other}', "");
    Error('\p{GCB: _/a/XX}');
    Error('\P{GCB: _/a/XX}');
    Expect(1, 921600, '\p{GCB=:\AXX\z:}', "");;
    Expect(0, 921599, '\p{GCB=:\AXX\z:}', "");;
    Expect(1, 921600, '\p{GCB=xx}', "");
    Expect(0, 921600, '\p{^GCB=xx}', "");
    Expect(0, 921600, '\P{GCB=xx}', "");
    Expect(1, 921600, '\P{^GCB=xx}', "");
    Expect(0, 921599, '\p{GCB=xx}', "");
    Expect(1, 921599, '\p{^GCB=xx}', "");
    Expect(1, 921599, '\P{GCB=xx}', "");
    Expect(0, 921599, '\P{^GCB=xx}', "");
    Expect(1, 921600, '\p{GCB=:\Axx\z:}', "");;
    Expect(0, 921599, '\p{GCB=:\Axx\z:}', "");;
    Expect(1, 921600, '\p{GCB:-_xx}', "");
    Expect(0, 921600, '\p{^GCB:-_xx}', "");
    Expect(0, 921600, '\P{GCB:-_xx}', "");
    Expect(1, 921600, '\P{^GCB:-_xx}', "");
    Expect(0, 921599, '\p{GCB:-_xx}', "");
    Expect(1, 921599, '\p{^GCB:-_xx}', "");
    Expect(1, 921599, '\P{GCB:-_xx}', "");
    Expect(0, 921599, '\P{^GCB:-_xx}', "");
    Error('\p{Is_Grapheme_Cluster_Break=_-Other/a/}');
    Error('\P{Is_Grapheme_Cluster_Break=_-Other/a/}');
    Expect(1, 921600, '\p{Is_Grapheme_Cluster_Break=other}', "");
    Expect(0, 921600, '\p{^Is_Grapheme_Cluster_Break=other}', "");
    Expect(0, 921600, '\P{Is_Grapheme_Cluster_Break=other}', "");
    Expect(1, 921600, '\P{^Is_Grapheme_Cluster_Break=other}', "");
    Expect(0, 921599, '\p{Is_Grapheme_Cluster_Break=other}', "");
    Expect(1, 921599, '\p{^Is_Grapheme_Cluster_Break=other}', "");
    Expect(1, 921599, '\P{Is_Grapheme_Cluster_Break=other}', "");
    Expect(0, 921599, '\P{^Is_Grapheme_Cluster_Break=other}', "");
    Expect(1, 921600, '\p{Is_Grapheme_Cluster_Break=--OTHER}', "");
    Expect(0, 921600, '\p{^Is_Grapheme_Cluster_Break=--OTHER}', "");
    Expect(0, 921600, '\P{Is_Grapheme_Cluster_Break=--OTHER}', "");
    Expect(1, 921600, '\P{^Is_Grapheme_Cluster_Break=--OTHER}', "");
    Expect(0, 921599, '\p{Is_Grapheme_Cluster_Break=--OTHER}', "");
    Expect(1, 921599, '\p{^Is_Grapheme_Cluster_Break=--OTHER}', "");
    Expect(1, 921599, '\P{Is_Grapheme_Cluster_Break=--OTHER}', "");
    Expect(0, 921599, '\P{^Is_Grapheme_Cluster_Break=--OTHER}', "");
    Error('\p{Is_GCB:_:=XX}');
    Error('\P{Is_GCB:_:=XX}');
    Expect(1, 921600, '\p{Is_GCB: xx}', "");
    Expect(0, 921600, '\p{^Is_GCB: xx}', "");
    Expect(0, 921600, '\P{Is_GCB: xx}', "");
    Expect(1, 921600, '\P{^Is_GCB: xx}', "");
    Expect(0, 921599, '\p{Is_GCB: xx}', "");
    Expect(1, 921599, '\p{^Is_GCB: xx}', "");
    Expect(1, 921599, '\P{Is_GCB: xx}', "");
    Expect(0, 921599, '\P{^Is_GCB: xx}', "");
    Expect(1, 921600, '\p{Is_GCB:	-XX}', "");
    Expect(0, 921600, '\p{^Is_GCB:	-XX}', "");
    Expect(0, 921600, '\P{Is_GCB:	-XX}', "");
    Expect(1, 921600, '\P{^Is_GCB:	-XX}', "");
    Expect(0, 921599, '\p{Is_GCB:	-XX}', "");
    Expect(1, 921599, '\p{^Is_GCB:	-XX}', "");
    Expect(1, 921599, '\P{Is_GCB:	-XX}', "");
    Expect(0, 921599, '\P{^Is_GCB:	-XX}', "");
    Error('\p{Grapheme_Cluster_Break=:=__ZWJ}');
    Error('\P{Grapheme_Cluster_Break=:=__ZWJ}');
    Expect(1, 8205, '\p{Grapheme_Cluster_Break=:\AZWJ\z:}', "");;
    Expect(0, 8206, '\p{Grapheme_Cluster_Break=:\AZWJ\z:}', "");;
    Expect(1, 8205, '\p{Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8205, '\p{^Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8205, '\P{Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8205, '\P{^Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8206, '\p{Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8206, '\p{^Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8206, '\P{Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8206, '\P{^Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8205, '\p{Grapheme_Cluster_Break=:\Azwj\z:}', "");;
    Expect(0, 8206, '\p{Grapheme_Cluster_Break=:\Azwj\z:}', "");;
    Expect(1, 8205, '\p{Grapheme_Cluster_Break=_-ZWJ}', "");
    Expect(0, 8205, '\p{^Grapheme_Cluster_Break=_-ZWJ}', "");
    Expect(0, 8205, '\P{Grapheme_Cluster_Break=_-ZWJ}', "");
    Expect(1, 8205, '\P{^Grapheme_Cluster_Break=_-ZWJ}', "");
    Expect(0, 8206, '\p{Grapheme_Cluster_Break=_-ZWJ}', "");
    Expect(1, 8206, '\p{^Grapheme_Cluster_Break=_-ZWJ}', "");
    Expect(1, 8206, '\P{Grapheme_Cluster_Break=_-ZWJ}', "");
    Expect(0, 8206, '\P{^Grapheme_Cluster_Break=_-ZWJ}', "");
    Error('\p{GCB=	ZWJ/a/}');
    Error('\P{GCB=	ZWJ/a/}');
    Expect(1, 8205, '\p{GCB=:\AZWJ\z:}', "");;
    Expect(0, 8206, '\p{GCB=:\AZWJ\z:}', "");;
    Expect(1, 8205, '\p{GCB: zwj}', "");
    Expect(0, 8205, '\p{^GCB: zwj}', "");
    Expect(0, 8205, '\P{GCB: zwj}', "");
    Expect(1, 8205, '\P{^GCB: zwj}', "");
    Expect(0, 8206, '\p{GCB: zwj}', "");
    Expect(1, 8206, '\p{^GCB: zwj}', "");
    Expect(1, 8206, '\P{GCB: zwj}', "");
    Expect(0, 8206, '\P{^GCB: zwj}', "");
    Expect(1, 8205, '\p{GCB=:\Azwj\z:}', "");;
    Expect(0, 8206, '\p{GCB=:\Azwj\z:}', "");;
    Expect(1, 8205, '\p{GCB:		-ZWJ}', "");
    Expect(0, 8205, '\p{^GCB:		-ZWJ}', "");
    Expect(0, 8205, '\P{GCB:		-ZWJ}', "");
    Expect(1, 8205, '\P{^GCB:		-ZWJ}', "");
    Expect(0, 8206, '\p{GCB:		-ZWJ}', "");
    Expect(1, 8206, '\p{^GCB:		-ZWJ}', "");
    Expect(1, 8206, '\P{GCB:		-ZWJ}', "");
    Expect(0, 8206, '\P{^GCB:		-ZWJ}', "");
    Error('\p{Is_Grapheme_Cluster_Break=_ ZWJ/a/}');
    Error('\P{Is_Grapheme_Cluster_Break=_ ZWJ/a/}');
    Expect(1, 8205, '\p{Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8205, '\p{^Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8205, '\P{Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8205, '\P{^Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8206, '\p{Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8206, '\p{^Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8206, '\P{Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(0, 8206, '\P{^Is_Grapheme_Cluster_Break=zwj}', "");
    Expect(1, 8205, '\p{Is_Grapheme_Cluster_Break= 	ZWJ}', "");
    Expect(0, 8205, '\p{^Is_Grapheme_Cluster_Break= 	ZWJ}', "");
    Expect(0, 8205, '\P{Is_Grapheme_Cluster_Break= 	ZWJ}', "");
    Expect(1, 8205, '\P{^Is_Grapheme_Cluster_Break= 	ZWJ}', "");
    Expect(0, 8206, '\p{Is_Grapheme_Cluster_Break= 	ZWJ}', "");
    Expect(1, 8206, '\p{^Is_Grapheme_Cluster_Break= 	ZWJ}', "");
    Expect(1, 8206, '\P{Is_Grapheme_Cluster_Break= 	ZWJ}', "");
    Expect(0, 8206, '\P{^Is_Grapheme_Cluster_Break= 	ZWJ}', "");
    Error('\p{Is_GCB= /a/ZWJ}');
    Error('\P{Is_GCB= /a/ZWJ}');
    Expect(1, 8205, '\p{Is_GCB=zwj}', "");
    Expect(0, 8205, '\p{^Is_GCB=zwj}', "");
    Expect(0, 8205, '\P{Is_GCB=zwj}', "");
    Expect(1, 8205, '\P{^Is_GCB=zwj}', "");
    Expect(0, 8206, '\p{Is_GCB=zwj}', "");
    Expect(1, 8206, '\p{^Is_GCB=zwj}', "");
    Expect(1, 8206, '\P{Is_GCB=zwj}', "");
    Expect(0, 8206, '\P{^Is_GCB=zwj}', "");
    Expect(1, 8205, '\p{Is_GCB=_ zwj}', "");
    Expect(0, 8205, '\p{^Is_GCB=_ zwj}', "");
    Expect(0, 8205, '\P{Is_GCB=_ zwj}', "");
    Expect(1, 8205, '\P{^Is_GCB=_ zwj}', "");
    Expect(0, 8206, '\p{Is_GCB=_ zwj}', "");
    Expect(1, 8206, '\p{^Is_GCB=_ zwj}', "");
    Expect(1, 8206, '\P{Is_GCB=_ zwj}', "");
    Expect(0, 8206, '\P{^Is_GCB=_ zwj}', "");
    Error('\p{Grapheme_Base=--No/a/}');
    Error('\P{Grapheme_Base=--No/a/}');
    Expect(1, 195102, '\p{Grapheme_Base=:\ANo\z:}', "");;
    Expect(0, 195101, '\p{Grapheme_Base=:\ANo\z:}', "");;
    Expect(1, 195102, '\p{Grapheme_Base=no}', "");
    Expect(0, 195102, '\p{^Grapheme_Base=no}', "");
    Expect(0, 195102, '\P{Grapheme_Base=no}', "");
    Expect(1, 195102, '\P{^Grapheme_Base=no}', "");
    Expect(0, 195101, '\p{Grapheme_Base=no}', "");
    Expect(1, 195101, '\p{^Grapheme_Base=no}', "");
    Expect(1, 195101, '\P{Grapheme_Base=no}', "");
    Expect(0, 195101, '\P{^Grapheme_Base=no}', "");
    Expect(1, 195102, '\p{Grapheme_Base=:\Ano\z:}', "");;
    Expect(0, 195101, '\p{Grapheme_Base=:\Ano\z:}', "");;
    Expect(1, 195102, '\p{Grapheme_Base=	NO}', "");
    Expect(0, 195102, '\p{^Grapheme_Base=	NO}', "");
    Expect(0, 195102, '\P{Grapheme_Base=	NO}', "");
    Expect(1, 195102, '\P{^Grapheme_Base=	NO}', "");
    Expect(0, 195101, '\p{Grapheme_Base=	NO}', "");
    Expect(1, 195101, '\p{^Grapheme_Base=	NO}', "");
    Expect(1, 195101, '\P{Grapheme_Base=	NO}', "");
    Expect(0, 195101, '\P{^Grapheme_Base=	NO}', "");
    Error('\p{Gr_Base:	 N:=}');
    Error('\P{Gr_Base:	 N:=}');
    Expect(1, 195102, '\p{Gr_Base=:\AN\z:}', "");;
    Expect(0, 195101, '\p{Gr_Base=:\AN\z:}', "");;
    Expect(1, 195102, '\p{Gr_Base=n}', "");
    Expect(0, 195102, '\p{^Gr_Base=n}', "");
    Expect(0, 195102, '\P{Gr_Base=n}', "");
    Expect(1, 195102, '\P{^Gr_Base=n}', "");
    Expect(0, 195101, '\p{Gr_Base=n}', "");
    Expect(1, 195101, '\p{^Gr_Base=n}', "");
    Expect(1, 195101, '\P{Gr_Base=n}', "");
    Expect(0, 195101, '\P{^Gr_Base=n}', "");
    Expect(1, 195102, '\p{Gr_Base=:\An\z:}', "");;
    Expect(0, 195101, '\p{Gr_Base=:\An\z:}', "");;
    Expect(1, 195102, '\p{Gr_Base:    -N}', "");
    Expect(0, 195102, '\p{^Gr_Base:    -N}', "");
    Expect(0, 195102, '\P{Gr_Base:    -N}', "");
    Expect(1, 195102, '\P{^Gr_Base:    -N}', "");
    Expect(0, 195101, '\p{Gr_Base:    -N}', "");
    Expect(1, 195101, '\p{^Gr_Base:    -N}', "");
    Expect(1, 195101, '\P{Gr_Base:    -N}', "");
    Expect(0, 195101, '\P{^Gr_Base:    -N}', "");
    Error('\p{Is_Grapheme_Base=	 f:=}');
    Error('\P{Is_Grapheme_Base=	 f:=}');
    Expect(1, 195102, '\p{Is_Grapheme_Base:	f}', "");
    Expect(0, 195102, '\p{^Is_Grapheme_Base:	f}', "");
    Expect(0, 195102, '\P{Is_Grapheme_Base:	f}', "");
    Expect(1, 195102, '\P{^Is_Grapheme_Base:	f}', "");
    Expect(0, 195101, '\p{Is_Grapheme_Base:	f}', "");
    Expect(1, 195101, '\p{^Is_Grapheme_Base:	f}', "");
    Expect(1, 195101, '\P{Is_Grapheme_Base:	f}', "");
    Expect(0, 195101, '\P{^Is_Grapheme_Base:	f}', "");
    Expect(1, 195102, '\p{Is_Grapheme_Base:	 -F}', "");
    Expect(0, 195102, '\p{^Is_Grapheme_Base:	 -F}', "");
    Expect(0, 195102, '\P{Is_Grapheme_Base:	 -F}', "");
    Expect(1, 195102, '\P{^Is_Grapheme_Base:	 -F}', "");
    Expect(0, 195101, '\p{Is_Grapheme_Base:	 -F}', "");
    Expect(1, 195101, '\p{^Is_Grapheme_Base:	 -F}', "");
    Expect(1, 195101, '\P{Is_Grapheme_Base:	 -F}', "");
    Expect(0, 195101, '\P{^Is_Grapheme_Base:	 -F}', "");
    Error('\p{Is_Gr_Base=:=	False}');
    Error('\P{Is_Gr_Base=:=	False}');
    Expect(1, 195102, '\p{Is_Gr_Base=false}', "");
    Expect(0, 195102, '\p{^Is_Gr_Base=false}', "");
    Expect(0, 195102, '\P{Is_Gr_Base=false}', "");
    Expect(1, 195102, '\P{^Is_Gr_Base=false}', "");
    Expect(0, 195101, '\p{Is_Gr_Base=false}', "");
    Expect(1, 195101, '\p{^Is_Gr_Base=false}', "");
    Expect(1, 195101, '\P{Is_Gr_Base=false}', "");
    Expect(0, 195101, '\P{^Is_Gr_Base=false}', "");
    Expect(1, 195102, '\p{Is_Gr_Base= false}', "");
    Expect(0, 195102, '\p{^Is_Gr_Base= false}', "");
    Expect(0, 195102, '\P{Is_Gr_Base= false}', "");
    Expect(1, 195102, '\P{^Is_Gr_Base= false}', "");
    Expect(0, 195101, '\p{Is_Gr_Base= false}', "");
    Expect(1, 195101, '\p{^Is_Gr_Base= false}', "");
    Expect(1, 195101, '\P{Is_Gr_Base= false}', "");
    Expect(0, 195101, '\P{^Is_Gr_Base= false}', "");
    Error('\p{Grapheme_Base:		-YES:=}');
    Error('\P{Grapheme_Base:		-YES:=}');
    Expect(1, 195101, '\p{Grapheme_Base=:\AYes\z:}', "");;
    Expect(0, 195102, '\p{Grapheme_Base=:\AYes\z:}', "");;
    Expect(1, 195101, '\p{Grapheme_Base=yes}', "");
    Expect(0, 195101, '\p{^Grapheme_Base=yes}', "");
    Expect(0, 195101, '\P{Grapheme_Base=yes}', "");
    Expect(1, 195101, '\P{^Grapheme_Base=yes}', "");
    Expect(0, 195102, '\p{Grapheme_Base=yes}', "");
    Expect(1, 195102, '\p{^Grapheme_Base=yes}', "");
    Expect(1, 195102, '\P{Grapheme_Base=yes}', "");
    Expect(0, 195102, '\P{^Grapheme_Base=yes}', "");
    Expect(1, 195101, '\p{Grapheme_Base=:\Ayes\z:}', "");;
    Expect(0, 195102, '\p{Grapheme_Base=:\Ayes\z:}', "");;
    Expect(1, 195101, '\p{Grapheme_Base=-_yes}', "");
    Expect(0, 195101, '\p{^Grapheme_Base=-_yes}', "");
    Expect(0, 195101, '\P{Grapheme_Base=-_yes}', "");
    Expect(1, 195101, '\P{^Grapheme_Base=-_yes}', "");
    Expect(0, 195102, '\p{Grapheme_Base=-_yes}', "");
    Expect(1, 195102, '\p{^Grapheme_Base=-_yes}', "");
    Expect(1, 195102, '\P{Grapheme_Base=-_yes}', "");
    Expect(0, 195102, '\P{^Grapheme_Base=-_yes}', "");
    Error('\p{Gr_Base=:=-Y}');
    Error('\P{Gr_Base=:=-Y}');
    Expect(1, 195101, '\p{Gr_Base=:\AY\z:}', "");;
    Expect(0, 195102, '\p{Gr_Base=:\AY\z:}', "");;
    Expect(1, 195101, '\p{Gr_Base=y}', "");
    Expect(0, 195101, '\p{^Gr_Base=y}', "");
    Expect(0, 195101, '\P{Gr_Base=y}', "");
    Expect(1, 195101, '\P{^Gr_Base=y}', "");
    Expect(0, 195102, '\p{Gr_Base=y}', "");
    Expect(1, 195102, '\p{^Gr_Base=y}', "");
    Expect(1, 195102, '\P{Gr_Base=y}', "");
    Expect(0, 195102, '\P{^Gr_Base=y}', "");
    Expect(1, 195101, '\p{Gr_Base=:\Ay\z:}', "");;
    Expect(0, 195102, '\p{Gr_Base=:\Ay\z:}', "");;
    Expect(1, 195101, '\p{Gr_Base= -Y}', "");
    Expect(0, 195101, '\p{^Gr_Base= -Y}', "");
    Expect(0, 195101, '\P{Gr_Base= -Y}', "");
    Expect(1, 195101, '\P{^Gr_Base= -Y}', "");
    Expect(0, 195102, '\p{Gr_Base= -Y}', "");
    Expect(1, 195102, '\p{^Gr_Base= -Y}', "");
    Expect(1, 195102, '\P{Gr_Base= -Y}', "");
    Expect(0, 195102, '\P{^Gr_Base= -Y}', "");
    Error('\p{Is_Grapheme_Base=	 T/a/}');
    Error('\P{Is_Grapheme_Base=	 T/a/}');
    Expect(1, 195101, '\p{Is_Grapheme_Base=t}', "");
    Expect(0, 195101, '\p{^Is_Grapheme_Base=t}', "");
    Expect(0, 195101, '\P{Is_Grapheme_Base=t}', "");
    Expect(1, 195101, '\P{^Is_Grapheme_Base=t}', "");
    Expect(0, 195102, '\p{Is_Grapheme_Base=t}', "");
    Expect(1, 195102, '\p{^Is_Grapheme_Base=t}', "");
    Expect(1, 195102, '\P{Is_Grapheme_Base=t}', "");
    Expect(0, 195102, '\P{^Is_Grapheme_Base=t}', "");
    Expect(1, 195101, '\p{Is_Grapheme_Base=T}', "");
    Expect(0, 195101, '\p{^Is_Grapheme_Base=T}', "");
    Expect(0, 195101, '\P{Is_Grapheme_Base=T}', "");
    Expect(1, 195101, '\P{^Is_Grapheme_Base=T}', "");
    Expect(0, 195102, '\p{Is_Grapheme_Base=T}', "");
    Expect(1, 195102, '\p{^Is_Grapheme_Base=T}', "");
    Expect(1, 195102, '\P{Is_Grapheme_Base=T}', "");
    Expect(0, 195102, '\P{^Is_Grapheme_Base=T}', "");
    Error('\p{Is_Gr_Base=	/a/True}');
    Error('\P{Is_Gr_Base=	/a/True}');
    Expect(1, 195101, '\p{Is_Gr_Base=true}', "");
    Expect(0, 195101, '\p{^Is_Gr_Base=true}', "");
    Expect(0, 195101, '\P{Is_Gr_Base=true}', "");
    Expect(1, 195101, '\P{^Is_Gr_Base=true}', "");
    Expect(0, 195102, '\p{Is_Gr_Base=true}', "");
    Expect(1, 195102, '\p{^Is_Gr_Base=true}', "");
    Expect(1, 195102, '\P{Is_Gr_Base=true}', "");
    Expect(0, 195102, '\P{^Is_Gr_Base=true}', "");
    Expect(1, 195101, '\p{Is_Gr_Base=_ True}', "");
    Expect(0, 195101, '\p{^Is_Gr_Base=_ True}', "");
    Expect(0, 195101, '\P{Is_Gr_Base=_ True}', "");
    Expect(1, 195101, '\P{^Is_Gr_Base=_ True}', "");
    Expect(0, 195102, '\p{Is_Gr_Base=_ True}', "");
    Expect(1, 195102, '\p{^Is_Gr_Base=_ True}', "");
    Expect(1, 195102, '\P{Is_Gr_Base=_ True}', "");
    Expect(0, 195102, '\P{^Is_Gr_Base=_ True}', "");
    Error('\p{Grapheme_Extend:- NO/a/}');
    Error('\P{Grapheme_Extend:- NO/a/}');
    Expect(1, 918000, '\p{Grapheme_Extend=:\ANo\z:}', "");;
    Expect(0, 917999, '\p{Grapheme_Extend=:\ANo\z:}', "");;
    Expect(1, 918000, '\p{Grapheme_Extend=no}', "");
    Expect(0, 918000, '\p{^Grapheme_Extend=no}', "");
    Expect(0, 918000, '\P{Grapheme_Extend=no}', "");
    Expect(1, 918000, '\P{^Grapheme_Extend=no}', "");
    Expect(0, 917999, '\p{Grapheme_Extend=no}', "");
    Expect(1, 917999, '\p{^Grapheme_Extend=no}', "");
    Expect(1, 917999, '\P{Grapheme_Extend=no}', "");
    Expect(0, 917999, '\P{^Grapheme_Extend=no}', "");
    Expect(1, 918000, '\p{Grapheme_Extend=:\Ano\z:}', "");;
    Expect(0, 917999, '\p{Grapheme_Extend=:\Ano\z:}', "");;
    Expect(1, 918000, '\p{Grapheme_Extend= NO}', "");
    Expect(0, 918000, '\p{^Grapheme_Extend= NO}', "");
    Expect(0, 918000, '\P{Grapheme_Extend= NO}', "");
    Expect(1, 918000, '\P{^Grapheme_Extend= NO}', "");
    Expect(0, 917999, '\p{Grapheme_Extend= NO}', "");
    Expect(1, 917999, '\p{^Grapheme_Extend= NO}', "");
    Expect(1, 917999, '\P{Grapheme_Extend= NO}', "");
    Expect(0, 917999, '\P{^Grapheme_Extend= NO}', "");
    Error('\p{Gr_Ext=/a/N}');
    Error('\P{Gr_Ext=/a/N}');
    Expect(1, 918000, '\p{Gr_Ext=:\AN\z:}', "");;
    Expect(0, 917999, '\p{Gr_Ext=:\AN\z:}', "");;
    Expect(1, 918000, '\p{Gr_Ext=n}', "");
    Expect(0, 918000, '\p{^Gr_Ext=n}', "");
    Expect(0, 918000, '\P{Gr_Ext=n}', "");
    Expect(1, 918000, '\P{^Gr_Ext=n}', "");
    Expect(0, 917999, '\p{Gr_Ext=n}', "");
    Expect(1, 917999, '\p{^Gr_Ext=n}', "");
    Expect(1, 917999, '\P{Gr_Ext=n}', "");
    Expect(0, 917999, '\P{^Gr_Ext=n}', "");
    Expect(1, 918000, '\p{Gr_Ext=:\An\z:}', "");;
    Expect(0, 917999, '\p{Gr_Ext=:\An\z:}', "");;
    Expect(1, 918000, '\p{Gr_Ext:	n}', "");
    Expect(0, 918000, '\p{^Gr_Ext:	n}', "");
    Expect(0, 918000, '\P{Gr_Ext:	n}', "");
    Expect(1, 918000, '\P{^Gr_Ext:	n}', "");
    Expect(0, 917999, '\p{Gr_Ext:	n}', "");
    Expect(1, 917999, '\p{^Gr_Ext:	n}', "");
    Expect(1, 917999, '\P{Gr_Ext:	n}', "");
    Expect(0, 917999, '\P{^Gr_Ext:	n}', "");
    Error('\p{Is_Grapheme_Extend=	-F/a/}');
    Error('\P{Is_Grapheme_Extend=	-F/a/}');
    Expect(1, 918000, '\p{Is_Grapheme_Extend=f}', "");
    Expect(0, 918000, '\p{^Is_Grapheme_Extend=f}', "");
    Expect(0, 918000, '\P{Is_Grapheme_Extend=f}', "");
    Expect(1, 918000, '\P{^Is_Grapheme_Extend=f}', "");
    Expect(0, 917999, '\p{Is_Grapheme_Extend=f}', "");
    Expect(1, 917999, '\p{^Is_Grapheme_Extend=f}', "");
    Expect(1, 917999, '\P{Is_Grapheme_Extend=f}', "");
    Expect(0, 917999, '\P{^Is_Grapheme_Extend=f}', "");
    Expect(1, 918000, '\p{Is_Grapheme_Extend=-	f}', "");
    Expect(0, 918000, '\p{^Is_Grapheme_Extend=-	f}', "");
    Expect(0, 918000, '\P{Is_Grapheme_Extend=-	f}', "");
    Expect(1, 918000, '\P{^Is_Grapheme_Extend=-	f}', "");
    Expect(0, 917999, '\p{Is_Grapheme_Extend=-	f}', "");
    Expect(1, 917999, '\p{^Is_Grapheme_Extend=-	f}', "");
    Expect(1, 917999, '\P{Is_Grapheme_Extend=-	f}', "");
    Expect(0, 917999, '\P{^Is_Grapheme_Extend=-	f}', "");
    Error('\p{Is_Gr_Ext=	_FALSE:=}');
    Error('\P{Is_Gr_Ext=	_FALSE:=}');
    Expect(1, 918000, '\p{Is_Gr_Ext=false}', "");
    Expect(0, 918000, '\p{^Is_Gr_Ext=false}', "");
    Expect(0, 918000, '\P{Is_Gr_Ext=false}', "");
    Expect(1, 918000, '\P{^Is_Gr_Ext=false}', "");
    Expect(0, 917999, '\p{Is_Gr_Ext=false}', "");
    Expect(1, 917999, '\p{^Is_Gr_Ext=false}', "");
    Expect(1, 917999, '\P{Is_Gr_Ext=false}', "");
    Expect(0, 917999, '\P{^Is_Gr_Ext=false}', "");
    Expect(1, 918000, '\p{Is_Gr_Ext=_ False}', "");
    Expect(0, 918000, '\p{^Is_Gr_Ext=_ False}', "");
    Expect(0, 918000, '\P{Is_Gr_Ext=_ False}', "");
    Expect(1, 918000, '\P{^Is_Gr_Ext=_ False}', "");
    Expect(0, 917999, '\p{Is_Gr_Ext=_ False}', "");
    Expect(1, 917999, '\p{^Is_Gr_Ext=_ False}', "");
    Expect(1, 917999, '\P{Is_Gr_Ext=_ False}', "");
    Expect(0, 917999, '\P{^Is_Gr_Ext=_ False}', "");
    Error('\p{Grapheme_Extend:	-:=yes}');
    Error('\P{Grapheme_Extend:	-:=yes}');
    Expect(1, 917999, '\p{Grapheme_Extend=:\AYes\z:}', "");;
    Expect(0, 918000, '\p{Grapheme_Extend=:\AYes\z:}', "");;
    Expect(1, 917999, '\p{Grapheme_Extend=yes}', "");
    Expect(0, 917999, '\p{^Grapheme_Extend=yes}', "");
    Expect(0, 917999, '\P{Grapheme_Extend=yes}', "");
    Expect(1, 917999, '\P{^Grapheme_Extend=yes}', "");
    Expect(0, 918000, '\p{Grapheme_Extend=yes}', "");
    Expect(1, 918000, '\p{^Grapheme_Extend=yes}', "");
    Expect(1, 918000, '\P{Grapheme_Extend=yes}', "");
    Expect(0, 918000, '\P{^Grapheme_Extend=yes}', "");
    Expect(1, 917999, '\p{Grapheme_Extend=:\Ayes\z:}', "");;
    Expect(0, 918000, '\p{Grapheme_Extend=:\Ayes\z:}', "");;
    Expect(1, 917999, '\p{Grapheme_Extend:	-	yes}', "");
    Expect(0, 917999, '\p{^Grapheme_Extend:	-	yes}', "");
    Expect(0, 917999, '\P{Grapheme_Extend:	-	yes}', "");
    Expect(1, 917999, '\P{^Grapheme_Extend:	-	yes}', "");
    Expect(0, 918000, '\p{Grapheme_Extend:	-	yes}', "");
    Expect(1, 918000, '\p{^Grapheme_Extend:	-	yes}', "");
    Expect(1, 918000, '\P{Grapheme_Extend:	-	yes}', "");
    Expect(0, 918000, '\P{^Grapheme_Extend:	-	yes}', "");
    Error('\p{Gr_Ext=:= 	Y}');
    Error('\P{Gr_Ext=:= 	Y}');
    Expect(1, 917999, '\p{Gr_Ext=:\AY\z:}', "");;
    Expect(0, 918000, '\p{Gr_Ext=:\AY\z:}', "");;
    Expect(1, 917999, '\p{Gr_Ext=y}', "");
    Expect(0, 917999, '\p{^Gr_Ext=y}', "");
    Expect(0, 917999, '\P{Gr_Ext=y}', "");
    Expect(1, 917999, '\P{^Gr_Ext=y}', "");
    Expect(0, 918000, '\p{Gr_Ext=y}', "");
    Expect(1, 918000, '\p{^Gr_Ext=y}', "");
    Expect(1, 918000, '\P{Gr_Ext=y}', "");
    Expect(0, 918000, '\P{^Gr_Ext=y}', "");
    Expect(1, 917999, '\p{Gr_Ext=:\Ay\z:}', "");;
    Expect(0, 918000, '\p{Gr_Ext=:\Ay\z:}', "");;
    Expect(1, 917999, '\p{Gr_Ext=  y}', "");
    Expect(0, 917999, '\p{^Gr_Ext=  y}', "");
    Expect(0, 917999, '\P{Gr_Ext=  y}', "");
    Expect(1, 917999, '\P{^Gr_Ext=  y}', "");
    Expect(0, 918000, '\p{Gr_Ext=  y}', "");
    Expect(1, 918000, '\p{^Gr_Ext=  y}', "");
    Expect(1, 918000, '\P{Gr_Ext=  y}', "");
    Expect(0, 918000, '\P{^Gr_Ext=  y}', "");
    Error('\p{Is_Grapheme_Extend=:=T}');
    Error('\P{Is_Grapheme_Extend=:=T}');
    Expect(1, 917999, '\p{Is_Grapheme_Extend=t}', "");
    Expect(0, 917999, '\p{^Is_Grapheme_Extend=t}', "");
    Expect(0, 917999, '\P{Is_Grapheme_Extend=t}', "");
    Expect(1, 917999, '\P{^Is_Grapheme_Extend=t}', "");
    Expect(0, 918000, '\p{Is_Grapheme_Extend=t}', "");
    Expect(1, 918000, '\p{^Is_Grapheme_Extend=t}', "");
    Expect(1, 918000, '\P{Is_Grapheme_Extend=t}', "");
    Expect(0, 918000, '\P{^Is_Grapheme_Extend=t}', "");
    Expect(1, 917999, '\p{Is_Grapheme_Extend= _t}', "");
    Expect(0, 917999, '\p{^Is_Grapheme_Extend= _t}', "");
    Expect(0, 917999, '\P{Is_Grapheme_Extend= _t}', "");
    Expect(1, 917999, '\P{^Is_Grapheme_Extend= _t}', "");
    Expect(0, 918000, '\p{Is_Grapheme_Extend= _t}', "");
    Expect(1, 918000, '\p{^Is_Grapheme_Extend= _t}', "");
    Expect(1, 918000, '\P{Is_Grapheme_Extend= _t}', "");
    Expect(0, 918000, '\P{^Is_Grapheme_Extend= _t}', "");
    Error('\p{Is_Gr_Ext=/a/--True}');
    Error('\P{Is_Gr_Ext=/a/--True}');
    Expect(1, 917999, '\p{Is_Gr_Ext=true}', "");
    Expect(0, 917999, '\p{^Is_Gr_Ext=true}', "");
    Expect(0, 917999, '\P{Is_Gr_Ext=true}', "");
    Expect(1, 917999, '\P{^Is_Gr_Ext=true}', "");
    Expect(0, 918000, '\p{Is_Gr_Ext=true}', "");
    Expect(1, 918000, '\p{^Is_Gr_Ext=true}', "");
    Expect(1, 918000, '\P{Is_Gr_Ext=true}', "");
    Expect(0, 918000, '\P{^Is_Gr_Ext=true}', "");
    Expect(1, 917999, '\p{Is_Gr_Ext=_-TRUE}', "");
    Expect(0, 917999, '\p{^Is_Gr_Ext=_-TRUE}', "");
    Expect(0, 917999, '\P{Is_Gr_Ext=_-TRUE}', "");
    Expect(1, 917999, '\P{^Is_Gr_Ext=_-TRUE}', "");
    Expect(0, 918000, '\p{Is_Gr_Ext=_-TRUE}', "");
    Expect(1, 918000, '\p{^Is_Gr_Ext=_-TRUE}', "");
    Expect(1, 918000, '\P{Is_Gr_Ext=_-TRUE}', "");
    Expect(0, 918000, '\P{^Is_Gr_Ext=_-TRUE}', "");
    Error('\p{Grapheme_Link=No}');
    Error('\P{Grapheme_Link=No}');
    Error('\p{Gr_Link=N}');
    Error('\P{Gr_Link=N}');
    Error('\p{Is_Grapheme_Link:	F}');
    Error('\P{Is_Grapheme_Link:	F}');
    Error('\p{Is_Gr_Link=False}');
    Error('\P{Is_Gr_Link=False}');
    Error('\p{Grapheme_Link=Yes}');
    Error('\P{Grapheme_Link=Yes}');
    Error('\p{Gr_Link=Y}');
    Error('\P{Gr_Link=Y}');
    Error('\p{Is_Grapheme_Link=T}');
    Error('\P{Is_Grapheme_Link=T}');
    Error('\p{Is_Gr_Link=True}');
    Error('\P{Is_Gr_Link=True}');
    Error('\p{Hex_Digit= _no:=}');
    Error('\P{Hex_Digit= _no:=}');
    Expect(1, 65351, '\p{Hex_Digit=:\ANo\z:}', "");;
    Expect(0, 65350, '\p{Hex_Digit=:\ANo\z:}', "");;
    Expect(1, 65351, '\p{Hex_Digit:no}', "");
    Expect(0, 65351, '\p{^Hex_Digit:no}', "");
    Expect(0, 65351, '\P{Hex_Digit:no}', "");
    Expect(1, 65351, '\P{^Hex_Digit:no}', "");
    Expect(0, 65350, '\p{Hex_Digit:no}', "");
    Expect(1, 65350, '\p{^Hex_Digit:no}', "");
    Expect(1, 65350, '\P{Hex_Digit:no}', "");
    Expect(0, 65350, '\P{^Hex_Digit:no}', "");
    Expect(1, 65351, '\p{Hex_Digit=:\Ano\z:}', "");;
    Expect(0, 65350, '\p{Hex_Digit=:\Ano\z:}', "");;
    Expect(1, 65351, '\p{Hex_Digit=		No}', "");
    Expect(0, 65351, '\p{^Hex_Digit=		No}', "");
    Expect(0, 65351, '\P{Hex_Digit=		No}', "");
    Expect(1, 65351, '\P{^Hex_Digit=		No}', "");
    Expect(0, 65350, '\p{Hex_Digit=		No}', "");
    Expect(1, 65350, '\p{^Hex_Digit=		No}', "");
    Expect(1, 65350, '\P{Hex_Digit=		No}', "");
    Expect(0, 65350, '\P{^Hex_Digit=		No}', "");
    Error('\p{Hex= /a/N}');
    Error('\P{Hex= /a/N}');
    Expect(1, 65351, '\p{Hex=:\AN\z:}', "");;
    Expect(0, 65350, '\p{Hex=:\AN\z:}', "");;
    Expect(1, 65351, '\p{Hex=n}', "");
    Expect(0, 65351, '\p{^Hex=n}', "");
    Expect(0, 65351, '\P{Hex=n}', "");
    Expect(1, 65351, '\P{^Hex=n}', "");
    Expect(0, 65350, '\p{Hex=n}', "");
    Expect(1, 65350, '\p{^Hex=n}', "");
    Expect(1, 65350, '\P{Hex=n}', "");
    Expect(0, 65350, '\P{^Hex=n}', "");
    Expect(1, 65351, '\p{Hex=:\An\z:}', "");;
    Expect(0, 65350, '\p{Hex=:\An\z:}', "");;
    Expect(1, 65351, '\p{Hex= -N}', "");
    Expect(0, 65351, '\p{^Hex= -N}', "");
    Expect(0, 65351, '\P{Hex= -N}', "");
    Expect(1, 65351, '\P{^Hex= -N}', "");
    Expect(0, 65350, '\p{Hex= -N}', "");
    Expect(1, 65350, '\p{^Hex= -N}', "");
    Expect(1, 65350, '\P{Hex= -N}', "");
    Expect(0, 65350, '\P{^Hex= -N}', "");
    Error('\p{Is_Hex_Digit=	-F:=}');
    Error('\P{Is_Hex_Digit=	-F:=}');
    Expect(1, 65351, '\p{Is_Hex_Digit=f}', "");
    Expect(0, 65351, '\p{^Is_Hex_Digit=f}', "");
    Expect(0, 65351, '\P{Is_Hex_Digit=f}', "");
    Expect(1, 65351, '\P{^Is_Hex_Digit=f}', "");
    Expect(0, 65350, '\p{Is_Hex_Digit=f}', "");
    Expect(1, 65350, '\p{^Is_Hex_Digit=f}', "");
    Expect(1, 65350, '\P{Is_Hex_Digit=f}', "");
    Expect(0, 65350, '\P{^Is_Hex_Digit=f}', "");
    Expect(1, 65351, '\p{Is_Hex_Digit= 	F}', "");
    Expect(0, 65351, '\p{^Is_Hex_Digit= 	F}', "");
    Expect(0, 65351, '\P{Is_Hex_Digit= 	F}', "");
    Expect(1, 65351, '\P{^Is_Hex_Digit= 	F}', "");
    Expect(0, 65350, '\p{Is_Hex_Digit= 	F}', "");
    Expect(1, 65350, '\p{^Is_Hex_Digit= 	F}', "");
    Expect(1, 65350, '\P{Is_Hex_Digit= 	F}', "");
    Expect(0, 65350, '\P{^Is_Hex_Digit= 	F}', "");
    Error('\p{Is_Hex=:=- False}');
    Error('\P{Is_Hex=:=- False}');
    Expect(1, 65351, '\p{Is_Hex=false}', "");
    Expect(0, 65351, '\p{^Is_Hex=false}', "");
    Expect(0, 65351, '\P{Is_Hex=false}', "");
    Expect(1, 65351, '\P{^Is_Hex=false}', "");
    Expect(0, 65350, '\p{Is_Hex=false}', "");
    Expect(1, 65350, '\p{^Is_Hex=false}', "");
    Expect(1, 65350, '\P{Is_Hex=false}', "");
    Expect(0, 65350, '\P{^Is_Hex=false}', "");
    Expect(1, 65351, '\p{Is_Hex=		False}', "");
    Expect(0, 65351, '\p{^Is_Hex=		False}', "");
    Expect(0, 65351, '\P{Is_Hex=		False}', "");
    Expect(1, 65351, '\P{^Is_Hex=		False}', "");
    Expect(0, 65350, '\p{Is_Hex=		False}', "");
    Expect(1, 65350, '\p{^Is_Hex=		False}', "");
    Expect(1, 65350, '\P{Is_Hex=		False}', "");
    Expect(0, 65350, '\P{^Is_Hex=		False}', "");
    Error('\p{Hex_Digit=_-YES:=}');
    Error('\P{Hex_Digit=_-YES:=}');
    Expect(1, 65350, '\p{Hex_Digit=:\AYes\z:}', "");;
    Expect(0, 65351, '\p{Hex_Digit=:\AYes\z:}', "");;
    Expect(1, 65350, '\p{Hex_Digit=yes}', "");
    Expect(0, 65350, '\p{^Hex_Digit=yes}', "");
    Expect(0, 65350, '\P{Hex_Digit=yes}', "");
    Expect(1, 65350, '\P{^Hex_Digit=yes}', "");
    Expect(0, 65351, '\p{Hex_Digit=yes}', "");
    Expect(1, 65351, '\p{^Hex_Digit=yes}', "");
    Expect(1, 65351, '\P{Hex_Digit=yes}', "");
    Expect(0, 65351, '\P{^Hex_Digit=yes}', "");
    Expect(1, 65350, '\p{Hex_Digit=:\Ayes\z:}', "");;
    Expect(0, 65351, '\p{Hex_Digit=:\Ayes\z:}', "");;
    Expect(1, 65350, '\p{Hex_Digit:	_YES}', "");
    Expect(0, 65350, '\p{^Hex_Digit:	_YES}', "");
    Expect(0, 65350, '\P{Hex_Digit:	_YES}', "");
    Expect(1, 65350, '\P{^Hex_Digit:	_YES}', "");
    Expect(0, 65351, '\p{Hex_Digit:	_YES}', "");
    Expect(1, 65351, '\p{^Hex_Digit:	_YES}', "");
    Expect(1, 65351, '\P{Hex_Digit:	_YES}', "");
    Expect(0, 65351, '\P{^Hex_Digit:	_YES}', "");
    Error('\p{Hex= /a/y}');
    Error('\P{Hex= /a/y}');
    Expect(1, 65350, '\p{Hex=:\AY\z:}', "");;
    Expect(0, 65351, '\p{Hex=:\AY\z:}', "");;
    Expect(1, 65350, '\p{Hex=y}', "");
    Expect(0, 65350, '\p{^Hex=y}', "");
    Expect(0, 65350, '\P{Hex=y}', "");
    Expect(1, 65350, '\P{^Hex=y}', "");
    Expect(0, 65351, '\p{Hex=y}', "");
    Expect(1, 65351, '\p{^Hex=y}', "");
    Expect(1, 65351, '\P{Hex=y}', "");
    Expect(0, 65351, '\P{^Hex=y}', "");
    Expect(1, 65350, '\p{Hex=:\Ay\z:}', "");;
    Expect(0, 65351, '\p{Hex=:\Ay\z:}', "");;
    Expect(1, 65350, '\p{Hex:   --Y}', "");
    Expect(0, 65350, '\p{^Hex:   --Y}', "");
    Expect(0, 65350, '\P{Hex:   --Y}', "");
    Expect(1, 65350, '\P{^Hex:   --Y}', "");
    Expect(0, 65351, '\p{Hex:   --Y}', "");
    Expect(1, 65351, '\p{^Hex:   --Y}', "");
    Expect(1, 65351, '\P{Hex:   --Y}', "");
    Expect(0, 65351, '\P{^Hex:   --Y}', "");
    Error('\p{Is_Hex_Digit=--t:=}');
    Error('\P{Is_Hex_Digit=--t:=}');
    Expect(1, 65350, '\p{Is_Hex_Digit=t}', "");
    Expect(0, 65350, '\p{^Is_Hex_Digit=t}', "");
    Expect(0, 65350, '\P{Is_Hex_Digit=t}', "");
    Expect(1, 65350, '\P{^Is_Hex_Digit=t}', "");
    Expect(0, 65351, '\p{Is_Hex_Digit=t}', "");
    Expect(1, 65351, '\p{^Is_Hex_Digit=t}', "");
    Expect(1, 65351, '\P{Is_Hex_Digit=t}', "");
    Expect(0, 65351, '\P{^Is_Hex_Digit=t}', "");
    Expect(1, 65350, '\p{Is_Hex_Digit=T}', "");
    Expect(0, 65350, '\p{^Is_Hex_Digit=T}', "");
    Expect(0, 65350, '\P{Is_Hex_Digit=T}', "");
    Expect(1, 65350, '\P{^Is_Hex_Digit=T}', "");
    Expect(0, 65351, '\p{Is_Hex_Digit=T}', "");
    Expect(1, 65351, '\p{^Is_Hex_Digit=T}', "");
    Expect(1, 65351, '\P{Is_Hex_Digit=T}', "");
    Expect(0, 65351, '\P{^Is_Hex_Digit=T}', "");
    Error('\p{Is_Hex= _TRUE:=}');
    Error('\P{Is_Hex= _TRUE:=}');
    Expect(1, 65350, '\p{Is_Hex=true}', "");
    Expect(0, 65350, '\p{^Is_Hex=true}', "");
    Expect(0, 65350, '\P{Is_Hex=true}', "");
    Expect(1, 65350, '\P{^Is_Hex=true}', "");
    Expect(0, 65351, '\p{Is_Hex=true}', "");
    Expect(1, 65351, '\p{^Is_Hex=true}', "");
    Expect(1, 65351, '\P{Is_Hex=true}', "");
    Expect(0, 65351, '\P{^Is_Hex=true}', "");
    Expect(1, 65350, '\p{Is_Hex=	-true}', "");
    Expect(0, 65350, '\p{^Is_Hex=	-true}', "");
    Expect(0, 65350, '\P{Is_Hex=	-true}', "");
    Expect(1, 65350, '\P{^Is_Hex=	-true}', "");
    Expect(0, 65351, '\p{Is_Hex=	-true}', "");
    Expect(1, 65351, '\p{^Is_Hex=	-true}', "");
    Expect(1, 65351, '\P{Is_Hex=	-true}', "");
    Expect(0, 65351, '\P{^Is_Hex=	-true}', "");
    Error('\p{hangulsyllabletype}');
    Error('\P{hangulsyllabletype}');
    Error('\p{hst}');
    Error('\P{hst}');
    Error('\p{Hangul_Syllable_Type=-Leading_Jamo:=}');
    Error('\P{Hangul_Syllable_Type=-Leading_Jamo:=}');
    Expect(1, 43388, '\p{Hangul_Syllable_Type=:\ALeading_Jamo\z:}', "");;
    Expect(0, 43389, '\p{Hangul_Syllable_Type=:\ALeading_Jamo\z:}', "");;
    Expect(1, 43388, '\p{Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43388, '\p{^Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43388, '\P{Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43388, '\P{^Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43389, '\p{Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43389, '\p{^Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43389, '\P{Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43389, '\P{^Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43388, '\p{Hangul_Syllable_Type=:\Aleadingjamo\z:}', "");;
    Expect(0, 43389, '\p{Hangul_Syllable_Type=:\Aleadingjamo\z:}', "");;
    Expect(1, 43388, '\p{Hangul_Syllable_Type=_	Leading_Jamo}', "");
    Expect(0, 43388, '\p{^Hangul_Syllable_Type=_	Leading_Jamo}', "");
    Expect(0, 43388, '\P{Hangul_Syllable_Type=_	Leading_Jamo}', "");
    Expect(1, 43388, '\P{^Hangul_Syllable_Type=_	Leading_Jamo}', "");
    Expect(0, 43389, '\p{Hangul_Syllable_Type=_	Leading_Jamo}', "");
    Expect(1, 43389, '\p{^Hangul_Syllable_Type=_	Leading_Jamo}', "");
    Expect(1, 43389, '\P{Hangul_Syllable_Type=_	Leading_Jamo}', "");
    Expect(0, 43389, '\P{^Hangul_Syllable_Type=_	Leading_Jamo}', "");
    Error('\p{Hst= /a/L}');
    Error('\P{Hst= /a/L}');
    Expect(1, 43388, '\p{Hst=:\AL\z:}', "");;
    Expect(0, 43389, '\p{Hst=:\AL\z:}', "");;
    Expect(1, 43388, '\p{Hst=l}', "");
    Expect(0, 43388, '\p{^Hst=l}', "");
    Expect(0, 43388, '\P{Hst=l}', "");
    Expect(1, 43388, '\P{^Hst=l}', "");
    Expect(0, 43389, '\p{Hst=l}', "");
    Expect(1, 43389, '\p{^Hst=l}', "");
    Expect(1, 43389, '\P{Hst=l}', "");
    Expect(0, 43389, '\P{^Hst=l}', "");
    Expect(1, 43388, '\p{Hst=:\Al\z:}', "");;
    Expect(0, 43389, '\p{Hst=:\Al\z:}', "");;
    Expect(1, 43388, '\p{Hst=-L}', "");
    Expect(0, 43388, '\p{^Hst=-L}', "");
    Expect(0, 43388, '\P{Hst=-L}', "");
    Expect(1, 43388, '\P{^Hst=-L}', "");
    Expect(0, 43389, '\p{Hst=-L}', "");
    Expect(1, 43389, '\p{^Hst=-L}', "");
    Expect(1, 43389, '\P{Hst=-L}', "");
    Expect(0, 43389, '\P{^Hst=-L}', "");
    Error('\p{Is_Hangul_Syllable_Type=-:=Leading_Jamo}');
    Error('\P{Is_Hangul_Syllable_Type=-:=Leading_Jamo}');
    Expect(1, 43388, '\p{Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43388, '\p{^Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43388, '\P{Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43388, '\P{^Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43389, '\p{Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43389, '\p{^Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43389, '\P{Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(0, 43389, '\P{^Is_Hangul_Syllable_Type=leadingjamo}', "");
    Expect(1, 43388, '\p{Is_Hangul_Syllable_Type= leading_JAMO}', "");
    Expect(0, 43388, '\p{^Is_Hangul_Syllable_Type= leading_JAMO}', "");
    Expect(0, 43388, '\P{Is_Hangul_Syllable_Type= leading_JAMO}', "");
    Expect(1, 43388, '\P{^Is_Hangul_Syllable_Type= leading_JAMO}', "");
    Expect(0, 43389, '\p{Is_Hangul_Syllable_Type= leading_JAMO}', "");
    Expect(1, 43389, '\p{^Is_Hangul_Syllable_Type= leading_JAMO}', "");
    Expect(1, 43389, '\P{Is_Hangul_Syllable_Type= leading_JAMO}', "");
    Expect(0, 43389, '\P{^Is_Hangul_Syllable_Type= leading_JAMO}', "");
    Error('\p{Is_Hst=/a/L}');
    Error('\P{Is_Hst=/a/L}');
    Expect(1, 43388, '\p{Is_Hst=l}', "");
    Expect(0, 43388, '\p{^Is_Hst=l}', "");
    Expect(0, 43388, '\P{Is_Hst=l}', "");
    Expect(1, 43388, '\P{^Is_Hst=l}', "");
    Expect(0, 43389, '\p{Is_Hst=l}', "");
    Expect(1, 43389, '\p{^Is_Hst=l}', "");
    Expect(1, 43389, '\P{Is_Hst=l}', "");
    Expect(0, 43389, '\P{^Is_Hst=l}', "");
    Expect(1, 43388, '\p{Is_Hst=	 L}', "");
    Expect(0, 43388, '\p{^Is_Hst=	 L}', "");
    Expect(0, 43388, '\P{Is_Hst=	 L}', "");
    Expect(1, 43388, '\P{^Is_Hst=	 L}', "");
    Expect(0, 43389, '\p{Is_Hst=	 L}', "");
    Expect(1, 43389, '\p{^Is_Hst=	 L}', "");
    Expect(1, 43389, '\P{Is_Hst=	 L}', "");
    Expect(0, 43389, '\P{^Is_Hst=	 L}', "");
    Error('\p{Hangul_Syllable_Type::=--LV_SYLLABLE}');
    Error('\P{Hangul_Syllable_Type::=--LV_SYLLABLE}');
    Expect(1, 55176, '\p{Hangul_Syllable_Type=:\ALV_Syllable\z:}', "");;
    Expect(0, 55177, '\p{Hangul_Syllable_Type=:\ALV_Syllable\z:}', "");;
    Expect(1, 55176, '\p{Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55176, '\p{^Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55176, '\P{Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55176, '\P{^Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55177, '\p{Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55177, '\p{^Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55177, '\P{Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55177, '\P{^Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55176, '\p{Hangul_Syllable_Type=:\Alvsyllable\z:}', "");;
    Expect(0, 55177, '\p{Hangul_Syllable_Type=:\Alvsyllable\z:}', "");;
    Expect(1, 55176, '\p{Hangul_Syllable_Type=  LV_syllable}', "");
    Expect(0, 55176, '\p{^Hangul_Syllable_Type=  LV_syllable}', "");
    Expect(0, 55176, '\P{Hangul_Syllable_Type=  LV_syllable}', "");
    Expect(1, 55176, '\P{^Hangul_Syllable_Type=  LV_syllable}', "");
    Expect(0, 55177, '\p{Hangul_Syllable_Type=  LV_syllable}', "");
    Expect(1, 55177, '\p{^Hangul_Syllable_Type=  LV_syllable}', "");
    Expect(1, 55177, '\P{Hangul_Syllable_Type=  LV_syllable}', "");
    Expect(0, 55177, '\P{^Hangul_Syllable_Type=  LV_syllable}', "");
    Error('\p{Hst=_/a/LV}');
    Error('\P{Hst=_/a/LV}');
    Expect(1, 55176, '\p{Hst=:\ALV\z:}', "");;
    Expect(0, 55177, '\p{Hst=:\ALV\z:}', "");;
    Expect(1, 55176, '\p{Hst=lv}', "");
    Expect(0, 55176, '\p{^Hst=lv}', "");
    Expect(0, 55176, '\P{Hst=lv}', "");
    Expect(1, 55176, '\P{^Hst=lv}', "");
    Expect(0, 55177, '\p{Hst=lv}', "");
    Expect(1, 55177, '\p{^Hst=lv}', "");
    Expect(1, 55177, '\P{Hst=lv}', "");
    Expect(0, 55177, '\P{^Hst=lv}', "");
    Expect(1, 55176, '\p{Hst=:\Alv\z:}', "");;
    Expect(0, 55177, '\p{Hst=:\Alv\z:}', "");;
    Expect(1, 55176, '\p{Hst= -LV}', "");
    Expect(0, 55176, '\p{^Hst= -LV}', "");
    Expect(0, 55176, '\P{Hst= -LV}', "");
    Expect(1, 55176, '\P{^Hst= -LV}', "");
    Expect(0, 55177, '\p{Hst= -LV}', "");
    Expect(1, 55177, '\p{^Hst= -LV}', "");
    Expect(1, 55177, '\P{Hst= -LV}', "");
    Expect(0, 55177, '\P{^Hst= -LV}', "");
    Error('\p{Is_Hangul_Syllable_Type=-:=LV_Syllable}');
    Error('\P{Is_Hangul_Syllable_Type=-:=LV_Syllable}');
    Expect(1, 55176, '\p{Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55176, '\p{^Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55176, '\P{Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55176, '\P{^Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55177, '\p{Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55177, '\p{^Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55177, '\P{Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(0, 55177, '\P{^Is_Hangul_Syllable_Type=lvsyllable}', "");
    Expect(1, 55176, '\p{Is_Hangul_Syllable_Type=	-LV_Syllable}', "");
    Expect(0, 55176, '\p{^Is_Hangul_Syllable_Type=	-LV_Syllable}', "");
    Expect(0, 55176, '\P{Is_Hangul_Syllable_Type=	-LV_Syllable}', "");
    Expect(1, 55176, '\P{^Is_Hangul_Syllable_Type=	-LV_Syllable}', "");
    Expect(0, 55177, '\p{Is_Hangul_Syllable_Type=	-LV_Syllable}', "");
    Expect(1, 55177, '\p{^Is_Hangul_Syllable_Type=	-LV_Syllable}', "");
    Expect(1, 55177, '\P{Is_Hangul_Syllable_Type=	-LV_Syllable}', "");
    Expect(0, 55177, '\P{^Is_Hangul_Syllable_Type=	-LV_Syllable}', "");
    Error('\p{Is_Hst=	-LV/a/}');
    Error('\P{Is_Hst=	-LV/a/}');
    Expect(1, 55176, '\p{Is_Hst=lv}', "");
    Expect(0, 55176, '\p{^Is_Hst=lv}', "");
    Expect(0, 55176, '\P{Is_Hst=lv}', "");
    Expect(1, 55176, '\P{^Is_Hst=lv}', "");
    Expect(0, 55177, '\p{Is_Hst=lv}', "");
    Expect(1, 55177, '\p{^Is_Hst=lv}', "");
    Expect(1, 55177, '\P{Is_Hst=lv}', "");
    Expect(0, 55177, '\P{^Is_Hst=lv}', "");
    Expect(1, 55176, '\p{Is_Hst=- LV}', "");
    Expect(0, 55176, '\p{^Is_Hst=- LV}', "");
    Expect(0, 55176, '\P{Is_Hst=- LV}', "");
    Expect(1, 55176, '\P{^Is_Hst=- LV}', "");
    Expect(0, 55177, '\p{Is_Hst=- LV}', "");
    Expect(1, 55177, '\p{^Is_Hst=- LV}', "");
    Expect(1, 55177, '\P{Is_Hst=- LV}', "");
    Expect(0, 55177, '\P{^Is_Hst=- LV}', "");
    Error('\p{Hangul_Syllable_Type= 	LVT_syllable:=}');
    Error('\P{Hangul_Syllable_Type= 	LVT_syllable:=}');
    Expect(1, 55203, '\p{Hangul_Syllable_Type=:\ALVT_Syllable\z:}', "");;
    Expect(0, 55204, '\p{Hangul_Syllable_Type=:\ALVT_Syllable\z:}', "");;
    Expect(1, 55203, '\p{Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55203, '\p{^Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55203, '\P{Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55203, '\P{^Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55204, '\p{Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55204, '\p{^Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55204, '\P{Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55204, '\P{^Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55203, '\p{Hangul_Syllable_Type=:\Alvtsyllable\z:}', "");;
    Expect(0, 55204, '\p{Hangul_Syllable_Type=:\Alvtsyllable\z:}', "");;
    Expect(1, 55203, '\p{Hangul_Syllable_Type= LVT_Syllable}', "");
    Expect(0, 55203, '\p{^Hangul_Syllable_Type= LVT_Syllable}', "");
    Expect(0, 55203, '\P{Hangul_Syllable_Type= LVT_Syllable}', "");
    Expect(1, 55203, '\P{^Hangul_Syllable_Type= LVT_Syllable}', "");
    Expect(0, 55204, '\p{Hangul_Syllable_Type= LVT_Syllable}', "");
    Expect(1, 55204, '\p{^Hangul_Syllable_Type= LVT_Syllable}', "");
    Expect(1, 55204, '\P{Hangul_Syllable_Type= LVT_Syllable}', "");
    Expect(0, 55204, '\P{^Hangul_Syllable_Type= LVT_Syllable}', "");
    Error('\p{Hst:   _/a/LVT}');
    Error('\P{Hst:   _/a/LVT}');
    Expect(1, 55203, '\p{Hst=:\ALVT\z:}', "");;
    Expect(0, 55204, '\p{Hst=:\ALVT\z:}', "");;
    Expect(1, 55203, '\p{Hst=lvt}', "");
    Expect(0, 55203, '\p{^Hst=lvt}', "");
    Expect(0, 55203, '\P{Hst=lvt}', "");
    Expect(1, 55203, '\P{^Hst=lvt}', "");
    Expect(0, 55204, '\p{Hst=lvt}', "");
    Expect(1, 55204, '\p{^Hst=lvt}', "");
    Expect(1, 55204, '\P{Hst=lvt}', "");
    Expect(0, 55204, '\P{^Hst=lvt}', "");
    Expect(1, 55203, '\p{Hst=:\Alvt\z:}', "");;
    Expect(0, 55204, '\p{Hst=:\Alvt\z:}', "");;
    Expect(1, 55203, '\p{Hst:	_ lvt}', "");
    Expect(0, 55203, '\p{^Hst:	_ lvt}', "");
    Expect(0, 55203, '\P{Hst:	_ lvt}', "");
    Expect(1, 55203, '\P{^Hst:	_ lvt}', "");
    Expect(0, 55204, '\p{Hst:	_ lvt}', "");
    Expect(1, 55204, '\p{^Hst:	_ lvt}', "");
    Expect(1, 55204, '\P{Hst:	_ lvt}', "");
    Expect(0, 55204, '\P{^Hst:	_ lvt}', "");
    Error('\p{Is_Hangul_Syllable_Type=_:=lvt_syllable}');
    Error('\P{Is_Hangul_Syllable_Type=_:=lvt_syllable}');
    Expect(1, 55203, '\p{Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55203, '\p{^Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55203, '\P{Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55203, '\P{^Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55204, '\p{Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55204, '\p{^Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55204, '\P{Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(0, 55204, '\P{^Is_Hangul_Syllable_Type=lvtsyllable}', "");
    Expect(1, 55203, '\p{Is_Hangul_Syllable_Type=-	LVT_Syllable}', "");
    Expect(0, 55203, '\p{^Is_Hangul_Syllable_Type=-	LVT_Syllable}', "");
    Expect(0, 55203, '\P{Is_Hangul_Syllable_Type=-	LVT_Syllable}', "");
    Expect(1, 55203, '\P{^Is_Hangul_Syllable_Type=-	LVT_Syllable}', "");
    Expect(0, 55204, '\p{Is_Hangul_Syllable_Type=-	LVT_Syllable}', "");
    Expect(1, 55204, '\p{^Is_Hangul_Syllable_Type=-	LVT_Syllable}', "");
    Expect(1, 55204, '\P{Is_Hangul_Syllable_Type=-	LVT_Syllable}', "");
    Expect(0, 55204, '\P{^Is_Hangul_Syllable_Type=-	LVT_Syllable}', "");
    Error('\p{Is_Hst: :=LVT}');
    Error('\P{Is_Hst: :=LVT}');
    Expect(1, 55203, '\p{Is_Hst=lvt}', "");
    Expect(0, 55203, '\p{^Is_Hst=lvt}', "");
    Expect(0, 55203, '\P{Is_Hst=lvt}', "");
    Expect(1, 55203, '\P{^Is_Hst=lvt}', "");
    Expect(0, 55204, '\p{Is_Hst=lvt}', "");
    Expect(1, 55204, '\p{^Is_Hst=lvt}', "");
    Expect(1, 55204, '\P{Is_Hst=lvt}', "");
    Expect(0, 55204, '\P{^Is_Hst=lvt}', "");
    Expect(1, 55203, '\p{Is_Hst=	lvt}', "");
    Expect(0, 55203, '\p{^Is_Hst=	lvt}', "");
    Expect(0, 55203, '\P{Is_Hst=	lvt}', "");
    Expect(1, 55203, '\P{^Is_Hst=	lvt}', "");
    Expect(0, 55204, '\p{Is_Hst=	lvt}', "");
    Expect(1, 55204, '\p{^Is_Hst=	lvt}', "");
    Expect(1, 55204, '\P{Is_Hst=	lvt}', "");
    Expect(0, 55204, '\P{^Is_Hst=	lvt}', "");
    Error('\p{Hangul_Syllable_Type=/a/_Not_Applicable}');
    Error('\P{Hangul_Syllable_Type=/a/_Not_Applicable}');
    Expect(1, 55292, '\p{Hangul_Syllable_Type=:\ANot_Applicable\z:}', "");;
    Expect(0, 55291, '\p{Hangul_Syllable_Type=:\ANot_Applicable\z:}', "");;
    Expect(1, 55292, '\p{Hangul_Syllable_Type:	notapplicable}', "");
    Expect(0, 55292, '\p{^Hangul_Syllable_Type:	notapplicable}', "");
    Expect(0, 55292, '\P{Hangul_Syllable_Type:	notapplicable}', "");
    Expect(1, 55292, '\P{^Hangul_Syllable_Type:	notapplicable}', "");
    Expect(0, 55291, '\p{Hangul_Syllable_Type:	notapplicable}', "");
    Expect(1, 55291, '\p{^Hangul_Syllable_Type:	notapplicable}', "");
    Expect(1, 55291, '\P{Hangul_Syllable_Type:	notapplicable}', "");
    Expect(0, 55291, '\P{^Hangul_Syllable_Type:	notapplicable}', "");
    Expect(1, 55292, '\p{Hangul_Syllable_Type=:\Anotapplicable\z:}', "");;
    Expect(0, 55291, '\p{Hangul_Syllable_Type=:\Anotapplicable\z:}', "");;
    Expect(1, 55292, '\p{Hangul_Syllable_Type= -Not_applicable}', "");
    Expect(0, 55292, '\p{^Hangul_Syllable_Type= -Not_applicable}', "");
    Expect(0, 55292, '\P{Hangul_Syllable_Type= -Not_applicable}', "");
    Expect(1, 55292, '\P{^Hangul_Syllable_Type= -Not_applicable}', "");
    Expect(0, 55291, '\p{Hangul_Syllable_Type= -Not_applicable}', "");
    Expect(1, 55291, '\p{^Hangul_Syllable_Type= -Not_applicable}', "");
    Expect(1, 55291, '\P{Hangul_Syllable_Type= -Not_applicable}', "");
    Expect(0, 55291, '\P{^Hangul_Syllable_Type= -Not_applicable}', "");
    Error('\p{Hst=:= _NA}');
    Error('\P{Hst=:= _NA}');
    Expect(1, 55292, '\p{Hst=:\ANA\z:}', "");;
    Expect(0, 55291, '\p{Hst=:\ANA\z:}', "");;
    Expect(1, 55292, '\p{Hst=na}', "");
    Expect(0, 55292, '\p{^Hst=na}', "");
    Expect(0, 55292, '\P{Hst=na}', "");
    Expect(1, 55292, '\P{^Hst=na}', "");
    Expect(0, 55291, '\p{Hst=na}', "");
    Expect(1, 55291, '\p{^Hst=na}', "");
    Expect(1, 55291, '\P{Hst=na}', "");
    Expect(0, 55291, '\P{^Hst=na}', "");
    Expect(1, 55292, '\p{Hst=:\Ana\z:}', "");;
    Expect(0, 55291, '\p{Hst=:\Ana\z:}', "");;
    Expect(1, 55292, '\p{Hst=	_NA}', "");
    Expect(0, 55292, '\p{^Hst=	_NA}', "");
    Expect(0, 55292, '\P{Hst=	_NA}', "");
    Expect(1, 55292, '\P{^Hst=	_NA}', "");
    Expect(0, 55291, '\p{Hst=	_NA}', "");
    Expect(1, 55291, '\p{^Hst=	_NA}', "");
    Expect(1, 55291, '\P{Hst=	_NA}', "");
    Expect(0, 55291, '\P{^Hst=	_NA}', "");
    Error('\p{Is_Hangul_Syllable_Type: :=	-NOT_Applicable}');
    Error('\P{Is_Hangul_Syllable_Type: :=	-NOT_Applicable}');
    Expect(1, 55292, '\p{Is_Hangul_Syllable_Type=notapplicable}', "");
    Expect(0, 55292, '\p{^Is_Hangul_Syllable_Type=notapplicable}', "");
    Expect(0, 55292, '\P{Is_Hangul_Syllable_Type=notapplicable}', "");
    Expect(1, 55292, '\P{^Is_Hangul_Syllable_Type=notapplicable}', "");
    Expect(0, 55291, '\p{Is_Hangul_Syllable_Type=notapplicable}', "");
    Expect(1, 55291, '\p{^Is_Hangul_Syllable_Type=notapplicable}', "");
    Expect(1, 55291, '\P{Is_Hangul_Syllable_Type=notapplicable}', "");
    Expect(0, 55291, '\P{^Is_Hangul_Syllable_Type=notapplicable}', "");
    Expect(1, 55292, '\p{Is_Hangul_Syllable_Type=		not_APPLICABLE}', "");
    Expect(0, 55292, '\p{^Is_Hangul_Syllable_Type=		not_APPLICABLE}', "");
    Expect(0, 55292, '\P{Is_Hangul_Syllable_Type=		not_APPLICABLE}', "");
    Expect(1, 55292, '\P{^Is_Hangul_Syllable_Type=		not_APPLICABLE}', "");
    Expect(0, 55291, '\p{Is_Hangul_Syllable_Type=		not_APPLICABLE}', "");
    Expect(1, 55291, '\p{^Is_Hangul_Syllable_Type=		not_APPLICABLE}', "");
    Expect(1, 55291, '\P{Is_Hangul_Syllable_Type=		not_APPLICABLE}', "");
    Expect(0, 55291, '\P{^Is_Hangul_Syllable_Type=		not_APPLICABLE}', "");
    Error('\p{Is_Hst=- NA/a/}');
    Error('\P{Is_Hst=- NA/a/}');
    Expect(1, 55292, '\p{Is_Hst=na}', "");
    Expect(0, 55292, '\p{^Is_Hst=na}', "");
    Expect(0, 55292, '\P{Is_Hst=na}', "");
    Expect(1, 55292, '\P{^Is_Hst=na}', "");
    Expect(0, 55291, '\p{Is_Hst=na}', "");
    Expect(1, 55291, '\p{^Is_Hst=na}', "");
    Expect(1, 55291, '\P{Is_Hst=na}', "");
    Expect(0, 55291, '\P{^Is_Hst=na}', "");
    Expect(1, 55292, '\p{Is_Hst=	_NA}', "");
    Expect(0, 55292, '\p{^Is_Hst=	_NA}', "");
    Expect(0, 55292, '\P{Is_Hst=	_NA}', "");
    Expect(1, 55292, '\P{^Is_Hst=	_NA}', "");
    Expect(0, 55291, '\p{Is_Hst=	_NA}', "");
    Expect(1, 55291, '\p{^Is_Hst=	_NA}', "");
    Expect(1, 55291, '\P{Is_Hst=	_NA}', "");
    Expect(0, 55291, '\P{^Is_Hst=	_NA}', "");
    Error('\p{Hangul_Syllable_Type=TRAILING_Jamo/a/}');
    Error('\P{Hangul_Syllable_Type=TRAILING_Jamo/a/}');
    Expect(1, 55291, '\p{Hangul_Syllable_Type=:\ATrailing_Jamo\z:}', "");;
    Expect(0, 55292, '\p{Hangul_Syllable_Type=:\ATrailing_Jamo\z:}', "");;
    Expect(1, 55291, '\p{Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55291, '\p{^Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55291, '\P{Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55291, '\P{^Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55292, '\p{Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55292, '\p{^Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55292, '\P{Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55292, '\P{^Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55291, '\p{Hangul_Syllable_Type=:\Atrailingjamo\z:}', "");;
    Expect(0, 55292, '\p{Hangul_Syllable_Type=:\Atrailingjamo\z:}', "");;
    Expect(1, 55291, '\p{Hangul_Syllable_Type= _trailing_Jamo}', "");
    Expect(0, 55291, '\p{^Hangul_Syllable_Type= _trailing_Jamo}', "");
    Expect(0, 55291, '\P{Hangul_Syllable_Type= _trailing_Jamo}', "");
    Expect(1, 55291, '\P{^Hangul_Syllable_Type= _trailing_Jamo}', "");
    Expect(0, 55292, '\p{Hangul_Syllable_Type= _trailing_Jamo}', "");
    Expect(1, 55292, '\p{^Hangul_Syllable_Type= _trailing_Jamo}', "");
    Expect(1, 55292, '\P{Hangul_Syllable_Type= _trailing_Jamo}', "");
    Expect(0, 55292, '\P{^Hangul_Syllable_Type= _trailing_Jamo}', "");
    Error('\p{Hst=-T:=}');
    Error('\P{Hst=-T:=}');
    Expect(1, 55291, '\p{Hst=:\AT\z:}', "");;
    Expect(0, 55292, '\p{Hst=:\AT\z:}', "");;
    Expect(1, 55291, '\p{Hst=t}', "");
    Expect(0, 55291, '\p{^Hst=t}', "");
    Expect(0, 55291, '\P{Hst=t}', "");
    Expect(1, 55291, '\P{^Hst=t}', "");
    Expect(0, 55292, '\p{Hst=t}', "");
    Expect(1, 55292, '\p{^Hst=t}', "");
    Expect(1, 55292, '\P{Hst=t}', "");
    Expect(0, 55292, '\P{^Hst=t}', "");
    Expect(1, 55291, '\p{Hst=:\At\z:}', "");;
    Expect(0, 55292, '\p{Hst=:\At\z:}', "");;
    Expect(1, 55291, '\p{Hst=__t}', "");
    Expect(0, 55291, '\p{^Hst=__t}', "");
    Expect(0, 55291, '\P{Hst=__t}', "");
    Expect(1, 55291, '\P{^Hst=__t}', "");
    Expect(0, 55292, '\p{Hst=__t}', "");
    Expect(1, 55292, '\p{^Hst=__t}', "");
    Expect(1, 55292, '\P{Hst=__t}', "");
    Expect(0, 55292, '\P{^Hst=__t}', "");
    Error('\p{Is_Hangul_Syllable_Type: --TRAILING_Jamo:=}');
    Error('\P{Is_Hangul_Syllable_Type: --TRAILING_Jamo:=}');
    Expect(1, 55291, '\p{Is_Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55291, '\p{^Is_Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55291, '\P{Is_Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55291, '\P{^Is_Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55292, '\p{Is_Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55292, '\p{^Is_Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55292, '\P{Is_Hangul_Syllable_Type=trailingjamo}', "");
    Expect(0, 55292, '\P{^Is_Hangul_Syllable_Type=trailingjamo}', "");
    Expect(1, 55291, '\p{Is_Hangul_Syllable_Type=  Trailing_Jamo}', "");
    Expect(0, 55291, '\p{^Is_Hangul_Syllable_Type=  Trailing_Jamo}', "");
    Expect(0, 55291, '\P{Is_Hangul_Syllable_Type=  Trailing_Jamo}', "");
    Expect(1, 55291, '\P{^Is_Hangul_Syllable_Type=  Trailing_Jamo}', "");
    Expect(0, 55292, '\p{Is_Hangul_Syllable_Type=  Trailing_Jamo}', "");
    Expect(1, 55292, '\p{^Is_Hangul_Syllable_Type=  Trailing_Jamo}', "");
    Expect(1, 55292, '\P{Is_Hangul_Syllable_Type=  Trailing_Jamo}', "");
    Expect(0, 55292, '\P{^Is_Hangul_Syllable_Type=  Trailing_Jamo}', "");
    Error('\p{Is_Hst=/a/-_T}');
    Error('\P{Is_Hst=/a/-_T}');
    Expect(1, 55291, '\p{Is_Hst:t}', "");
    Expect(0, 55291, '\p{^Is_Hst:t}', "");
    Expect(0, 55291, '\P{Is_Hst:t}', "");
    Expect(1, 55291, '\P{^Is_Hst:t}', "");
    Expect(0, 55292, '\p{Is_Hst:t}', "");
    Expect(1, 55292, '\p{^Is_Hst:t}', "");
    Expect(1, 55292, '\P{Is_Hst:t}', "");
    Expect(0, 55292, '\P{^Is_Hst:t}', "");
    Expect(1, 55291, '\p{Is_Hst:   T}', "");
    Expect(0, 55291, '\p{^Is_Hst:   T}', "");
    Expect(0, 55291, '\P{Is_Hst:   T}', "");
    Expect(1, 55291, '\P{^Is_Hst:   T}', "");
    Expect(0, 55292, '\p{Is_Hst:   T}', "");
    Expect(1, 55292, '\p{^Is_Hst:   T}', "");
    Expect(1, 55292, '\P{Is_Hst:   T}', "");
    Expect(0, 55292, '\P{^Is_Hst:   T}', "");
    Error('\p{Hangul_Syllable_Type= :=Vowel_Jamo}');
    Error('\P{Hangul_Syllable_Type= :=Vowel_Jamo}');
    Expect(1, 55238, '\p{Hangul_Syllable_Type=:\AVowel_Jamo\z:}', "");;
    Expect(0, 55239, '\p{Hangul_Syllable_Type=:\AVowel_Jamo\z:}', "");;
    Expect(1, 55238, '\p{Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55238, '\p{^Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55238, '\P{Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55238, '\P{^Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55239, '\p{Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55239, '\p{^Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55239, '\P{Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55239, '\P{^Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55238, '\p{Hangul_Syllable_Type=:\Avoweljamo\z:}', "");;
    Expect(0, 55239, '\p{Hangul_Syllable_Type=:\Avoweljamo\z:}', "");;
    Expect(1, 55238, '\p{Hangul_Syllable_Type=-	Vowel_Jamo}', "");
    Expect(0, 55238, '\p{^Hangul_Syllable_Type=-	Vowel_Jamo}', "");
    Expect(0, 55238, '\P{Hangul_Syllable_Type=-	Vowel_Jamo}', "");
    Expect(1, 55238, '\P{^Hangul_Syllable_Type=-	Vowel_Jamo}', "");
    Expect(0, 55239, '\p{Hangul_Syllable_Type=-	Vowel_Jamo}', "");
    Expect(1, 55239, '\p{^Hangul_Syllable_Type=-	Vowel_Jamo}', "");
    Expect(1, 55239, '\P{Hangul_Syllable_Type=-	Vowel_Jamo}', "");
    Expect(0, 55239, '\P{^Hangul_Syllable_Type=-	Vowel_Jamo}', "");
    Error('\p{Hst= /a/V}');
    Error('\P{Hst= /a/V}');
    Expect(1, 55238, '\p{Hst=:\AV\z:}', "");;
    Expect(0, 55239, '\p{Hst=:\AV\z:}', "");;
    Expect(1, 55238, '\p{Hst=v}', "");
    Expect(0, 55238, '\p{^Hst=v}', "");
    Expect(0, 55238, '\P{Hst=v}', "");
    Expect(1, 55238, '\P{^Hst=v}', "");
    Expect(0, 55239, '\p{Hst=v}', "");
    Expect(1, 55239, '\p{^Hst=v}', "");
    Expect(1, 55239, '\P{Hst=v}', "");
    Expect(0, 55239, '\P{^Hst=v}', "");
    Expect(1, 55238, '\p{Hst=:\Av\z:}', "");;
    Expect(0, 55239, '\p{Hst=:\Av\z:}', "");;
    Expect(1, 55238, '\p{Hst= 	V}', "");
    Expect(0, 55238, '\p{^Hst= 	V}', "");
    Expect(0, 55238, '\P{Hst= 	V}', "");
    Expect(1, 55238, '\P{^Hst= 	V}', "");
    Expect(0, 55239, '\p{Hst= 	V}', "");
    Expect(1, 55239, '\p{^Hst= 	V}', "");
    Expect(1, 55239, '\P{Hst= 	V}', "");
    Expect(0, 55239, '\P{^Hst= 	V}', "");
    Error('\p{Is_Hangul_Syllable_Type=-Vowel_JAMO/a/}');
    Error('\P{Is_Hangul_Syllable_Type=-Vowel_JAMO/a/}');
    Expect(1, 55238, '\p{Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55238, '\p{^Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55238, '\P{Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55238, '\P{^Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55239, '\p{Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55239, '\p{^Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55239, '\P{Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(0, 55239, '\P{^Is_Hangul_Syllable_Type=voweljamo}', "");
    Expect(1, 55238, '\p{Is_Hangul_Syllable_Type= Vowel_JAMO}', "");
    Expect(0, 55238, '\p{^Is_Hangul_Syllable_Type= Vowel_JAMO}', "");
    Expect(0, 55238, '\P{Is_Hangul_Syllable_Type= Vowel_JAMO}', "");
    Expect(1, 55238, '\P{^Is_Hangul_Syllable_Type= Vowel_JAMO}', "");
    Expect(0, 55239, '\p{Is_Hangul_Syllable_Type= Vowel_JAMO}', "");
    Expect(1, 55239, '\p{^Is_Hangul_Syllable_Type= Vowel_JAMO}', "");
    Expect(1, 55239, '\P{Is_Hangul_Syllable_Type= Vowel_JAMO}', "");
    Expect(0, 55239, '\P{^Is_Hangul_Syllable_Type= Vowel_JAMO}', "");
    Error('\p{Is_Hst=:=v}');
    Error('\P{Is_Hst=:=v}');
    Expect(1, 55238, '\p{Is_Hst=v}', "");
    Expect(0, 55238, '\p{^Is_Hst=v}', "");
    Expect(0, 55238, '\P{Is_Hst=v}', "");
    Expect(1, 55238, '\P{^Is_Hst=v}', "");
    Expect(0, 55239, '\p{Is_Hst=v}', "");
    Expect(1, 55239, '\p{^Is_Hst=v}', "");
    Expect(1, 55239, '\P{Is_Hst=v}', "");
    Expect(0, 55239, '\P{^Is_Hst=v}', "");
    Expect(1, 55238, '\p{Is_Hst= V}', "");
    Expect(0, 55238, '\p{^Is_Hst= V}', "");
    Expect(0, 55238, '\P{Is_Hst= V}', "");
    Expect(1, 55238, '\P{^Is_Hst= V}', "");
    Expect(0, 55239, '\p{Is_Hst= V}', "");
    Expect(1, 55239, '\p{^Is_Hst= V}', "");
    Expect(1, 55239, '\P{Is_Hst= V}', "");
    Expect(0, 55239, '\P{^Is_Hst= V}', "");
    Error('\p{Hyphen=/a/_No}');
    Error('\P{Hyphen=/a/_No}');
    Expect(1, 65382, '\p{Hyphen=no}', 'deprecated');
    Expect(0, 65382, '\p{^Hyphen=no}', 'deprecated');
    Expect(0, 65382, '\P{Hyphen=no}', 'deprecated');
    Expect(1, 65382, '\P{^Hyphen=no}', 'deprecated');
    Expect(0, 65381, '\p{Hyphen=no}', 'deprecated');
    Expect(1, 65381, '\p{^Hyphen=no}', 'deprecated');
    Expect(1, 65381, '\P{Hyphen=no}', 'deprecated');
    Expect(0, 65381, '\P{^Hyphen=no}', 'deprecated');
    Expect(1, 65382, '\p{Hyphen= NO}', 'deprecated');
    Expect(0, 65382, '\p{^Hyphen= NO}', 'deprecated');
    Expect(0, 65382, '\P{Hyphen= NO}', 'deprecated');
    Expect(1, 65382, '\P{^Hyphen= NO}', 'deprecated');
    Expect(0, 65381, '\p{Hyphen= NO}', 'deprecated');
    Expect(1, 65381, '\p{^Hyphen= NO}', 'deprecated');
    Expect(1, 65381, '\P{Hyphen= NO}', 'deprecated');
    Expect(0, 65381, '\P{^Hyphen= NO}', 'deprecated');
    Error('\p{Is_Hyphen=/a/- n}');
    Error('\P{Is_Hyphen=/a/- n}');
    Expect(1, 65382, '\p{Is_Hyphen=n}', 'deprecated');
    Expect(0, 65382, '\p{^Is_Hyphen=n}', 'deprecated');
    Expect(0, 65382, '\P{Is_Hyphen=n}', 'deprecated');
    Expect(1, 65382, '\P{^Is_Hyphen=n}', 'deprecated');
    Expect(0, 65381, '\p{Is_Hyphen=n}', 'deprecated');
    Expect(1, 65381, '\p{^Is_Hyphen=n}', 'deprecated');
    Expect(1, 65381, '\P{Is_Hyphen=n}', 'deprecated');
    Expect(0, 65381, '\P{^Is_Hyphen=n}', 'deprecated');
    Expect(1, 65382, '\p{Is_Hyphen: -	N}', 'deprecated');
    Expect(0, 65382, '\p{^Is_Hyphen: -	N}', 'deprecated');
    Expect(0, 65382, '\P{Is_Hyphen: -	N}', 'deprecated');
    Expect(1, 65382, '\P{^Is_Hyphen: -	N}', 'deprecated');
    Expect(0, 65381, '\p{Is_Hyphen: -	N}', 'deprecated');
    Expect(1, 65381, '\p{^Is_Hyphen: -	N}', 'deprecated');
    Expect(1, 65381, '\P{Is_Hyphen: -	N}', 'deprecated');
    Expect(0, 65381, '\P{^Is_Hyphen: -	N}', 'deprecated');
    Error('\p{Hyphen=:=_F}');
    Error('\P{Hyphen=:=_F}');
    Expect(1, 65382, '\p{Hyphen=:\AF\z:}', 'deprecated');;
    Expect(0, 65381, '\p{Hyphen=:\AF\z:}', 'deprecated');;
    Expect(1, 65382, '\p{Hyphen=f}', 'deprecated');
    Expect(0, 65382, '\p{^Hyphen=f}', 'deprecated');
    Expect(0, 65382, '\P{Hyphen=f}', 'deprecated');
    Expect(1, 65382, '\P{^Hyphen=f}', 'deprecated');
    Expect(0, 65381, '\p{Hyphen=f}', 'deprecated');
    Expect(1, 65381, '\p{^Hyphen=f}', 'deprecated');
    Expect(1, 65381, '\P{Hyphen=f}', 'deprecated');
    Expect(0, 65381, '\P{^Hyphen=f}', 'deprecated');
    Expect(1, 65382, '\p{Hyphen=:\Af\z:}', 'deprecated');;
    Expect(0, 65381, '\p{Hyphen=:\Af\z:}', 'deprecated');;
    Expect(1, 65382, '\p{Hyphen=_ F}', 'deprecated');
    Expect(0, 65382, '\p{^Hyphen=_ F}', 'deprecated');
    Expect(0, 65382, '\P{Hyphen=_ F}', 'deprecated');
    Expect(1, 65382, '\P{^Hyphen=_ F}', 'deprecated');
    Expect(0, 65381, '\p{Hyphen=_ F}', 'deprecated');
    Expect(1, 65381, '\p{^Hyphen=_ F}', 'deprecated');
    Expect(1, 65381, '\P{Hyphen=_ F}', 'deprecated');
    Expect(0, 65381, '\P{^Hyphen=_ F}', 'deprecated');
    Error('\p{Is_Hyphen=_/a/False}');
    Error('\P{Is_Hyphen=_/a/False}');
    Expect(1, 65382, '\p{Is_Hyphen=false}', 'deprecated');
    Expect(0, 65382, '\p{^Is_Hyphen=false}', 'deprecated');
    Expect(0, 65382, '\P{Is_Hyphen=false}', 'deprecated');
    Expect(1, 65382, '\P{^Is_Hyphen=false}', 'deprecated');
    Expect(0, 65381, '\p{Is_Hyphen=false}', 'deprecated');
    Expect(1, 65381, '\p{^Is_Hyphen=false}', 'deprecated');
    Expect(1, 65381, '\P{Is_Hyphen=false}', 'deprecated');
    Expect(0, 65381, '\P{^Is_Hyphen=false}', 'deprecated');
    Expect(1, 65382, '\p{Is_Hyphen=	-False}', 'deprecated');
    Expect(0, 65382, '\p{^Is_Hyphen=	-False}', 'deprecated');
    Expect(0, 65382, '\P{Is_Hyphen=	-False}', 'deprecated');
    Expect(1, 65382, '\P{^Is_Hyphen=	-False}', 'deprecated');
    Expect(0, 65381, '\p{Is_Hyphen=	-False}', 'deprecated');
    Expect(1, 65381, '\p{^Is_Hyphen=	-False}', 'deprecated');
    Expect(1, 65381, '\P{Is_Hyphen=	-False}', 'deprecated');
    Expect(0, 65381, '\P{^Is_Hyphen=	-False}', 'deprecated');
    Error('\p{Hyphen: -	yes/a/}');
    Error('\P{Hyphen: -	yes/a/}');
    Expect(1, 65381, '\p{Hyphen=yes}', 'deprecated');
    Expect(0, 65381, '\p{^Hyphen=yes}', 'deprecated');
    Expect(0, 65381, '\P{Hyphen=yes}', 'deprecated');
    Expect(1, 65381, '\P{^Hyphen=yes}', 'deprecated');
    Expect(0, 65382, '\p{Hyphen=yes}', 'deprecated');
    Expect(1, 65382, '\p{^Hyphen=yes}', 'deprecated');
    Expect(1, 65382, '\P{Hyphen=yes}', 'deprecated');
    Expect(0, 65382, '\P{^Hyphen=yes}', 'deprecated');
    Expect(1, 65381, '\p{Hyphen= Yes}', 'deprecated');
    Expect(0, 65381, '\p{^Hyphen= Yes}', 'deprecated');
    Expect(0, 65381, '\P{Hyphen= Yes}', 'deprecated');
    Expect(1, 65381, '\P{^Hyphen= Yes}', 'deprecated');
    Expect(0, 65382, '\p{Hyphen= Yes}', 'deprecated');
    Expect(1, 65382, '\p{^Hyphen= Yes}', 'deprecated');
    Expect(1, 65382, '\P{Hyphen= Yes}', 'deprecated');
    Expect(0, 65382, '\P{^Hyphen= Yes}', 'deprecated');
    Error('\p{Is_Hyphen=	/a/Y}');
    Error('\P{Is_Hyphen=	/a/Y}');
    Expect(1, 65381, '\p{Is_Hyphen: y}', 'deprecated');
    Expect(0, 65381, '\p{^Is_Hyphen: y}', 'deprecated');
    Expect(0, 65381, '\P{Is_Hyphen: y}', 'deprecated');
    Expect(1, 65381, '\P{^Is_Hyphen: y}', 'deprecated');
    Expect(0, 65382, '\p{Is_Hyphen: y}', 'deprecated');
    Expect(1, 65382, '\p{^Is_Hyphen: y}', 'deprecated');
    Expect(1, 65382, '\P{Is_Hyphen: y}', 'deprecated');
    Expect(0, 65382, '\P{^Is_Hyphen: y}', 'deprecated');
    Expect(1, 65381, '\p{Is_Hyphen= _Y}', 'deprecated');
    Expect(0, 65381, '\p{^Is_Hyphen= _Y}', 'deprecated');
    Expect(0, 65381, '\P{Is_Hyphen= _Y}', 'deprecated');
    Expect(1, 65381, '\P{^Is_Hyphen= _Y}', 'deprecated');
    Expect(0, 65382, '\p{Is_Hyphen= _Y}', 'deprecated');
    Expect(1, 65382, '\p{^Is_Hyphen= _Y}', 'deprecated');
    Expect(1, 65382, '\P{Is_Hyphen= _Y}', 'deprecated');
    Expect(0, 65382, '\P{^Is_Hyphen= _Y}', 'deprecated');
    Error('\p{Hyphen=/a/_ t}');
    Error('\P{Hyphen=/a/_ t}');
    Expect(1, 65381, '\p{Hyphen=:\AT\z:}', 'deprecated');;
    Expect(0, 65382, '\p{Hyphen=:\AT\z:}', 'deprecated');;
    Expect(1, 65381, '\p{Hyphen=t}', 'deprecated');
    Expect(0, 65381, '\p{^Hyphen=t}', 'deprecated');
    Expect(0, 65381, '\P{Hyphen=t}', 'deprecated');
    Expect(1, 65381, '\P{^Hyphen=t}', 'deprecated');
    Expect(0, 65382, '\p{Hyphen=t}', 'deprecated');
    Expect(1, 65382, '\p{^Hyphen=t}', 'deprecated');
    Expect(1, 65382, '\P{Hyphen=t}', 'deprecated');
    Expect(0, 65382, '\P{^Hyphen=t}', 'deprecated');
    Expect(1, 65381, '\p{Hyphen=:\At\z:}', 'deprecated');;
    Expect(0, 65382, '\p{Hyphen=:\At\z:}', 'deprecated');;
    Expect(1, 65381, '\p{Hyphen=		T}', 'deprecated');
    Expect(0, 65381, '\p{^Hyphen=		T}', 'deprecated');
    Expect(0, 65381, '\P{Hyphen=		T}', 'deprecated');
    Expect(1, 65381, '\P{^Hyphen=		T}', 'deprecated');
    Expect(0, 65382, '\p{Hyphen=		T}', 'deprecated');
    Expect(1, 65382, '\p{^Hyphen=		T}', 'deprecated');
    Expect(1, 65382, '\P{Hyphen=		T}', 'deprecated');
    Expect(0, 65382, '\P{^Hyphen=		T}', 'deprecated');
    Error('\p{Is_Hyphen:  /a/True}');
    Error('\P{Is_Hyphen:  /a/True}');
    Expect(1, 65381, '\p{Is_Hyphen=true}', 'deprecated');
    Expect(0, 65381, '\p{^Is_Hyphen=true}', 'deprecated');
    Expect(0, 65381, '\P{Is_Hyphen=true}', 'deprecated');
    Expect(1, 65381, '\P{^Is_Hyphen=true}', 'deprecated');
    Expect(0, 65382, '\p{Is_Hyphen=true}', 'deprecated');
    Expect(1, 65382, '\p{^Is_Hyphen=true}', 'deprecated');
    Expect(1, 65382, '\P{Is_Hyphen=true}', 'deprecated');
    Expect(0, 65382, '\P{^Is_Hyphen=true}', 'deprecated');
    Expect(1, 65381, '\p{Is_Hyphen:   _ True}', 'deprecated');
    Expect(0, 65381, '\p{^Is_Hyphen:   _ True}', 'deprecated');
    Expect(0, 65381, '\P{Is_Hyphen:   _ True}', 'deprecated');
    Expect(1, 65381, '\P{^Is_Hyphen:   _ True}', 'deprecated');
    Expect(0, 65382, '\p{Is_Hyphen:   _ True}', 'deprecated');
    Expect(1, 65382, '\p{^Is_Hyphen:   _ True}', 'deprecated');
    Expect(1, 65382, '\P{Is_Hyphen:   _ True}', 'deprecated');
    Expect(0, 65382, '\P{^Is_Hyphen:   _ True}', 'deprecated');
    Error('\p{ID_Continue=_/a/No}');
    Error('\P{ID_Continue=_/a/No}');
    Expect(1, 918000, '\p{ID_Continue=:\ANo\z:}', "");;
    Expect(0, 917999, '\p{ID_Continue=:\ANo\z:}', "");;
    Expect(1, 918000, '\p{ID_Continue=no}', "");
    Expect(0, 918000, '\p{^ID_Continue=no}', "");
    Expect(0, 918000, '\P{ID_Continue=no}', "");
    Expect(1, 918000, '\P{^ID_Continue=no}', "");
    Expect(0, 917999, '\p{ID_Continue=no}', "");
    Expect(1, 917999, '\p{^ID_Continue=no}', "");
    Expect(1, 917999, '\P{ID_Continue=no}', "");
    Expect(0, 917999, '\P{^ID_Continue=no}', "");
    Expect(1, 918000, '\p{ID_Continue=:\Ano\z:}', "");;
    Expect(0, 917999, '\p{ID_Continue=:\Ano\z:}', "");;
    Expect(1, 918000, '\p{ID_Continue=-no}', "");
    Expect(0, 918000, '\p{^ID_Continue=-no}', "");
    Expect(0, 918000, '\P{ID_Continue=-no}', "");
    Expect(1, 918000, '\P{^ID_Continue=-no}', "");
    Expect(0, 917999, '\p{ID_Continue=-no}', "");
    Expect(1, 917999, '\p{^ID_Continue=-no}', "");
    Expect(1, 917999, '\P{ID_Continue=-no}', "");
    Expect(0, 917999, '\P{^ID_Continue=-no}', "");
    Error('\p{IDC=_/a/N}');
    Error('\P{IDC=_/a/N}');
    Expect(1, 918000, '\p{IDC=:\AN\z:}', "");;
    Expect(0, 917999, '\p{IDC=:\AN\z:}', "");;
    Expect(1, 918000, '\p{IDC=n}', "");
    Expect(0, 918000, '\p{^IDC=n}', "");
    Expect(0, 918000, '\P{IDC=n}', "");
    Expect(1, 918000, '\P{^IDC=n}', "");
    Expect(0, 917999, '\p{IDC=n}', "");
    Expect(1, 917999, '\p{^IDC=n}', "");
    Expect(1, 917999, '\P{IDC=n}', "");
    Expect(0, 917999, '\P{^IDC=n}', "");
    Expect(1, 918000, '\p{IDC=:\An\z:}', "");;
    Expect(0, 917999, '\p{IDC=:\An\z:}', "");;
    Expect(1, 918000, '\p{IDC= n}', "");
    Expect(0, 918000, '\p{^IDC= n}', "");
    Expect(0, 918000, '\P{IDC= n}', "");
    Expect(1, 918000, '\P{^IDC= n}', "");
    Expect(0, 917999, '\p{IDC= n}', "");
    Expect(1, 917999, '\p{^IDC= n}', "");
    Expect(1, 917999, '\P{IDC= n}', "");
    Expect(0, 917999, '\P{^IDC= n}', "");
    Error('\p{Is_ID_Continue=:=  F}');
    Error('\P{Is_ID_Continue=:=  F}');
    Expect(1, 918000, '\p{Is_ID_Continue=f}', "");
    Expect(0, 918000, '\p{^Is_ID_Continue=f}', "");
    Expect(0, 918000, '\P{Is_ID_Continue=f}', "");
    Expect(1, 918000, '\P{^Is_ID_Continue=f}', "");
    Expect(0, 917999, '\p{Is_ID_Continue=f}', "");
    Expect(1, 917999, '\p{^Is_ID_Continue=f}', "");
    Expect(1, 917999, '\P{Is_ID_Continue=f}', "");
    Expect(0, 917999, '\P{^Is_ID_Continue=f}', "");
    Expect(1, 918000, '\p{Is_ID_Continue=-F}', "");
    Expect(0, 918000, '\p{^Is_ID_Continue=-F}', "");
    Expect(0, 918000, '\P{Is_ID_Continue=-F}', "");
    Expect(1, 918000, '\P{^Is_ID_Continue=-F}', "");
    Expect(0, 917999, '\p{Is_ID_Continue=-F}', "");
    Expect(1, 917999, '\p{^Is_ID_Continue=-F}', "");
    Expect(1, 917999, '\P{Is_ID_Continue=-F}', "");
    Expect(0, 917999, '\P{^Is_ID_Continue=-F}', "");
    Error('\p{Is_IDC=:=_FALSE}');
    Error('\P{Is_IDC=:=_FALSE}');
    Expect(1, 918000, '\p{Is_IDC=false}', "");
    Expect(0, 918000, '\p{^Is_IDC=false}', "");
    Expect(0, 918000, '\P{Is_IDC=false}', "");
    Expect(1, 918000, '\P{^Is_IDC=false}', "");
    Expect(0, 917999, '\p{Is_IDC=false}', "");
    Expect(1, 917999, '\p{^Is_IDC=false}', "");
    Expect(1, 917999, '\P{Is_IDC=false}', "");
    Expect(0, 917999, '\P{^Is_IDC=false}', "");
    Expect(1, 918000, '\p{Is_IDC:	_	FALSE}', "");
    Expect(0, 918000, '\p{^Is_IDC:	_	FALSE}', "");
    Expect(0, 918000, '\P{Is_IDC:	_	FALSE}', "");
    Expect(1, 918000, '\P{^Is_IDC:	_	FALSE}', "");
    Expect(0, 917999, '\p{Is_IDC:	_	FALSE}', "");
    Expect(1, 917999, '\p{^Is_IDC:	_	FALSE}', "");
    Expect(1, 917999, '\P{Is_IDC:	_	FALSE}', "");
    Expect(0, 917999, '\P{^Is_IDC:	_	FALSE}', "");
    Error('\p{ID_Continue=-:=Yes}');
    Error('\P{ID_Continue=-:=Yes}');
    Expect(1, 917999, '\p{ID_Continue=:\AYes\z:}', "");;
    Expect(0, 918000, '\p{ID_Continue=:\AYes\z:}', "");;
    Expect(1, 917999, '\p{ID_Continue:	yes}', "");
    Expect(0, 917999, '\p{^ID_Continue:	yes}', "");
    Expect(0, 917999, '\P{ID_Continue:	yes}', "");
    Expect(1, 917999, '\P{^ID_Continue:	yes}', "");
    Expect(0, 918000, '\p{ID_Continue:	yes}', "");
    Expect(1, 918000, '\p{^ID_Continue:	yes}', "");
    Expect(1, 918000, '\P{ID_Continue:	yes}', "");
    Expect(0, 918000, '\P{^ID_Continue:	yes}', "");
    Expect(1, 917999, '\p{ID_Continue=:\Ayes\z:}', "");;
    Expect(0, 918000, '\p{ID_Continue=:\Ayes\z:}', "");;
    Expect(1, 917999, '\p{ID_Continue=	_Yes}', "");
    Expect(0, 917999, '\p{^ID_Continue=	_Yes}', "");
    Expect(0, 917999, '\P{ID_Continue=	_Yes}', "");
    Expect(1, 917999, '\P{^ID_Continue=	_Yes}', "");
    Expect(0, 918000, '\p{ID_Continue=	_Yes}', "");
    Expect(1, 918000, '\p{^ID_Continue=	_Yes}', "");
    Expect(1, 918000, '\P{ID_Continue=	_Yes}', "");
    Expect(0, 918000, '\P{^ID_Continue=	_Yes}', "");
    Error('\p{IDC= :=Y}');
    Error('\P{IDC= :=Y}');
    Expect(1, 917999, '\p{IDC=:\AY\z:}', "");;
    Expect(0, 918000, '\p{IDC=:\AY\z:}', "");;
    Expect(1, 917999, '\p{IDC=y}', "");
    Expect(0, 917999, '\p{^IDC=y}', "");
    Expect(0, 917999, '\P{IDC=y}', "");
    Expect(1, 917999, '\P{^IDC=y}', "");
    Expect(0, 918000, '\p{IDC=y}', "");
    Expect(1, 918000, '\p{^IDC=y}', "");
    Expect(1, 918000, '\P{IDC=y}', "");
    Expect(0, 918000, '\P{^IDC=y}', "");
    Expect(1, 917999, '\p{IDC=:\Ay\z:}', "");;
    Expect(0, 918000, '\p{IDC=:\Ay\z:}', "");;
    Expect(1, 917999, '\p{IDC=	-Y}', "");
    Expect(0, 917999, '\p{^IDC=	-Y}', "");
    Expect(0, 917999, '\P{IDC=	-Y}', "");
    Expect(1, 917999, '\P{^IDC=	-Y}', "");
    Expect(0, 918000, '\p{IDC=	-Y}', "");
    Expect(1, 918000, '\p{^IDC=	-Y}', "");
    Expect(1, 918000, '\P{IDC=	-Y}', "");
    Expect(0, 918000, '\P{^IDC=	-Y}', "");
    Error('\p{Is_ID_Continue=-_T:=}');
    Error('\P{Is_ID_Continue=-_T:=}');
    Expect(1, 917999, '\p{Is_ID_Continue=t}', "");
    Expect(0, 917999, '\p{^Is_ID_Continue=t}', "");
    Expect(0, 917999, '\P{Is_ID_Continue=t}', "");
    Expect(1, 917999, '\P{^Is_ID_Continue=t}', "");
    Expect(0, 918000, '\p{Is_ID_Continue=t}', "");
    Expect(1, 918000, '\p{^Is_ID_Continue=t}', "");
    Expect(1, 918000, '\P{Is_ID_Continue=t}', "");
    Expect(0, 918000, '\P{^Is_ID_Continue=t}', "");
    Expect(1, 917999, '\p{Is_ID_Continue:   _-T}', "");
    Expect(0, 917999, '\p{^Is_ID_Continue:   _-T}', "");
    Expect(0, 917999, '\P{Is_ID_Continue:   _-T}', "");
    Expect(1, 917999, '\P{^Is_ID_Continue:   _-T}', "");
    Expect(0, 918000, '\p{Is_ID_Continue:   _-T}', "");
    Expect(1, 918000, '\p{^Is_ID_Continue:   _-T}', "");
    Expect(1, 918000, '\P{Is_ID_Continue:   _-T}', "");
    Expect(0, 918000, '\P{^Is_ID_Continue:   _-T}', "");
    Error('\p{Is_IDC=:=_-True}');
    Error('\P{Is_IDC=:=_-True}');
    Expect(1, 917999, '\p{Is_IDC=true}', "");
    Expect(0, 917999, '\p{^Is_IDC=true}', "");
    Expect(0, 917999, '\P{Is_IDC=true}', "");
    Expect(1, 917999, '\P{^Is_IDC=true}', "");
    Expect(0, 918000, '\p{Is_IDC=true}', "");
    Expect(1, 918000, '\p{^Is_IDC=true}', "");
    Expect(1, 918000, '\P{Is_IDC=true}', "");
    Expect(0, 918000, '\P{^Is_IDC=true}', "");
    Expect(1, 917999, '\p{Is_IDC= true}', "");
    Expect(0, 917999, '\p{^Is_IDC= true}', "");
    Expect(0, 917999, '\P{Is_IDC= true}', "");
    Expect(1, 917999, '\P{^Is_IDC= true}', "");
    Expect(0, 918000, '\p{Is_IDC= true}', "");
    Expect(1, 918000, '\p{^Is_IDC= true}', "");
    Expect(1, 918000, '\P{Is_IDC= true}', "");
    Expect(0, 918000, '\P{^Is_IDC= true}', "");
    Error('\p{Ideographic: _NO:=}');
    Error('\P{Ideographic: _NO:=}');
    Expect(1, 195102, '\p{Ideographic=:\ANo\z:}', "");;
    Expect(0, 195101, '\p{Ideographic=:\ANo\z:}', "");;
    Expect(1, 195102, '\p{Ideographic:no}', "");
    Expect(0, 195102, '\p{^Ideographic:no}', "");
    Expect(0, 195102, '\P{Ideographic:no}', "");
    Expect(1, 195102, '\P{^Ideographic:no}', "");
    Expect(0, 195101, '\p{Ideographic:no}', "");
    Expect(1, 195101, '\p{^Ideographic:no}', "");
    Expect(1, 195101, '\P{Ideographic:no}', "");
    Expect(0, 195101, '\P{^Ideographic:no}', "");
    Expect(1, 195102, '\p{Ideographic=:\Ano\z:}', "");;
    Expect(0, 195101, '\p{Ideographic=:\Ano\z:}', "");;
    Expect(1, 195102, '\p{Ideographic=-	no}', "");
    Expect(0, 195102, '\p{^Ideographic=-	no}', "");
    Expect(0, 195102, '\P{Ideographic=-	no}', "");
    Expect(1, 195102, '\P{^Ideographic=-	no}', "");
    Expect(0, 195101, '\p{Ideographic=-	no}', "");
    Expect(1, 195101, '\p{^Ideographic=-	no}', "");
    Expect(1, 195101, '\P{Ideographic=-	no}', "");
    Expect(0, 195101, '\P{^Ideographic=-	no}', "");
    Error('\p{Ideo=	 N:=}');
    Error('\P{Ideo=	 N:=}');
    Expect(1, 195102, '\p{Ideo=:\AN\z:}', "");;
    Expect(0, 195101, '\p{Ideo=:\AN\z:}', "");;
    Expect(1, 195102, '\p{Ideo=n}', "");
    Expect(0, 195102, '\p{^Ideo=n}', "");
    Expect(0, 195102, '\P{Ideo=n}', "");
    Expect(1, 195102, '\P{^Ideo=n}', "");
    Expect(0, 195101, '\p{Ideo=n}', "");
    Expect(1, 195101, '\p{^Ideo=n}', "");
    Expect(1, 195101, '\P{Ideo=n}', "");
    Expect(0, 195101, '\P{^Ideo=n}', "");
    Expect(1, 195102, '\p{Ideo=:\An\z:}', "");;
    Expect(0, 195101, '\p{Ideo=:\An\z:}', "");;
    Expect(1, 195102, '\p{Ideo= N}', "");
    Expect(0, 195102, '\p{^Ideo= N}', "");
    Expect(0, 195102, '\P{Ideo= N}', "");
    Expect(1, 195102, '\P{^Ideo= N}', "");
    Expect(0, 195101, '\p{Ideo= N}', "");
    Expect(1, 195101, '\p{^Ideo= N}', "");
    Expect(1, 195101, '\P{Ideo= N}', "");
    Expect(0, 195101, '\P{^Ideo= N}', "");
    Error('\p{Is_Ideographic=:=f}');
    Error('\P{Is_Ideographic=:=f}');
    Expect(1, 195102, '\p{Is_Ideographic=f}', "");
    Expect(0, 195102, '\p{^Is_Ideographic=f}', "");
    Expect(0, 195102, '\P{Is_Ideographic=f}', "");
    Expect(1, 195102, '\P{^Is_Ideographic=f}', "");
    Expect(0, 195101, '\p{Is_Ideographic=f}', "");
    Expect(1, 195101, '\p{^Is_Ideographic=f}', "");
    Expect(1, 195101, '\P{Is_Ideographic=f}', "");
    Expect(0, 195101, '\P{^Is_Ideographic=f}', "");
    Expect(1, 195102, '\p{Is_Ideographic=-	F}', "");
    Expect(0, 195102, '\p{^Is_Ideographic=-	F}', "");
    Expect(0, 195102, '\P{Is_Ideographic=-	F}', "");
    Expect(1, 195102, '\P{^Is_Ideographic=-	F}', "");
    Expect(0, 195101, '\p{Is_Ideographic=-	F}', "");
    Expect(1, 195101, '\p{^Is_Ideographic=-	F}', "");
    Expect(1, 195101, '\P{Is_Ideographic=-	F}', "");
    Expect(0, 195101, '\P{^Is_Ideographic=-	F}', "");
    Error('\p{Is_Ideo= 	False:=}');
    Error('\P{Is_Ideo= 	False:=}');
    Expect(1, 195102, '\p{Is_Ideo: false}', "");
    Expect(0, 195102, '\p{^Is_Ideo: false}', "");
    Expect(0, 195102, '\P{Is_Ideo: false}', "");
    Expect(1, 195102, '\P{^Is_Ideo: false}', "");
    Expect(0, 195101, '\p{Is_Ideo: false}', "");
    Expect(1, 195101, '\p{^Is_Ideo: false}', "");
    Expect(1, 195101, '\P{Is_Ideo: false}', "");
    Expect(0, 195101, '\P{^Is_Ideo: false}', "");
    Expect(1, 195102, '\p{Is_Ideo=	-False}', "");
    Expect(0, 195102, '\p{^Is_Ideo=	-False}', "");
    Expect(0, 195102, '\P{Is_Ideo=	-False}', "");
    Expect(1, 195102, '\P{^Is_Ideo=	-False}', "");
    Expect(0, 195101, '\p{Is_Ideo=	-False}', "");
    Expect(1, 195101, '\p{^Is_Ideo=	-False}', "");
    Expect(1, 195101, '\P{Is_Ideo=	-False}', "");
    Expect(0, 195101, '\P{^Is_Ideo=	-False}', "");
    Error('\p{Ideographic= -Yes/a/}');
    Error('\P{Ideographic= -Yes/a/}');
    Expect(1, 195101, '\p{Ideographic=:\AYes\z:}', "");;
    Expect(0, 195102, '\p{Ideographic=:\AYes\z:}', "");;
    Expect(1, 195101, '\p{Ideographic=yes}', "");
    Expect(0, 195101, '\p{^Ideographic=yes}', "");
    Expect(0, 195101, '\P{Ideographic=yes}', "");
    Expect(1, 195101, '\P{^Ideographic=yes}', "");
    Expect(0, 195102, '\p{Ideographic=yes}', "");
    Expect(1, 195102, '\p{^Ideographic=yes}', "");
    Expect(1, 195102, '\P{Ideographic=yes}', "");
    Expect(0, 195102, '\P{^Ideographic=yes}', "");
    Expect(1, 195101, '\p{Ideographic=:\Ayes\z:}', "");;
    Expect(0, 195102, '\p{Ideographic=:\Ayes\z:}', "");;
    Expect(1, 195101, '\p{Ideographic=	 Yes}', "");
    Expect(0, 195101, '\p{^Ideographic=	 Yes}', "");
    Expect(0, 195101, '\P{Ideographic=	 Yes}', "");
    Expect(1, 195101, '\P{^Ideographic=	 Yes}', "");
    Expect(0, 195102, '\p{Ideographic=	 Yes}', "");
    Expect(1, 195102, '\p{^Ideographic=	 Yes}', "");
    Expect(1, 195102, '\P{Ideographic=	 Yes}', "");
    Expect(0, 195102, '\P{^Ideographic=	 Yes}', "");
    Error('\p{Ideo=_Y/a/}');
    Error('\P{Ideo=_Y/a/}');
    Expect(1, 195101, '\p{Ideo=:\AY\z:}', "");;
    Expect(0, 195102, '\p{Ideo=:\AY\z:}', "");;
    Expect(1, 195101, '\p{Ideo:   y}', "");
    Expect(0, 195101, '\p{^Ideo:   y}', "");
    Expect(0, 195101, '\P{Ideo:   y}', "");
    Expect(1, 195101, '\P{^Ideo:   y}', "");
    Expect(0, 195102, '\p{Ideo:   y}', "");
    Expect(1, 195102, '\p{^Ideo:   y}', "");
    Expect(1, 195102, '\P{Ideo:   y}', "");
    Expect(0, 195102, '\P{^Ideo:   y}', "");
    Expect(1, 195101, '\p{Ideo=:\Ay\z:}', "");;
    Expect(0, 195102, '\p{Ideo=:\Ay\z:}', "");;
    Expect(1, 195101, '\p{Ideo=		Y}', "");
    Expect(0, 195101, '\p{^Ideo=		Y}', "");
    Expect(0, 195101, '\P{Ideo=		Y}', "");
    Expect(1, 195101, '\P{^Ideo=		Y}', "");
    Expect(0, 195102, '\p{Ideo=		Y}', "");
    Expect(1, 195102, '\p{^Ideo=		Y}', "");
    Expect(1, 195102, '\P{Ideo=		Y}', "");
    Expect(0, 195102, '\P{^Ideo=		Y}', "");
    Error('\p{Is_Ideographic=/a/T}');
    Error('\P{Is_Ideographic=/a/T}');
    Expect(1, 195101, '\p{Is_Ideographic=t}', "");
    Expect(0, 195101, '\p{^Is_Ideographic=t}', "");
    Expect(0, 195101, '\P{Is_Ideographic=t}', "");
    Expect(1, 195101, '\P{^Is_Ideographic=t}', "");
    Expect(0, 195102, '\p{Is_Ideographic=t}', "");
    Expect(1, 195102, '\p{^Is_Ideographic=t}', "");
    Expect(1, 195102, '\P{Is_Ideographic=t}', "");
    Expect(0, 195102, '\P{^Is_Ideographic=t}', "");
    Expect(1, 195101, '\p{Is_Ideographic=- t}', "");
    Expect(0, 195101, '\p{^Is_Ideographic=- t}', "");
    Expect(0, 195101, '\P{Is_Ideographic=- t}', "");
    Expect(1, 195101, '\P{^Is_Ideographic=- t}', "");
    Expect(0, 195102, '\p{Is_Ideographic=- t}', "");
    Expect(1, 195102, '\p{^Is_Ideographic=- t}', "");
    Expect(1, 195102, '\P{Is_Ideographic=- t}', "");
    Expect(0, 195102, '\P{^Is_Ideographic=- t}', "");
    Error('\p{Is_Ideo=	:=True}');
    Error('\P{Is_Ideo=	:=True}');
    Expect(1, 195101, '\p{Is_Ideo=true}', "");
    Expect(0, 195101, '\p{^Is_Ideo=true}', "");
    Expect(0, 195101, '\P{Is_Ideo=true}', "");
    Expect(1, 195101, '\P{^Is_Ideo=true}', "");
    Expect(0, 195102, '\p{Is_Ideo=true}', "");
    Expect(1, 195102, '\p{^Is_Ideo=true}', "");
    Expect(1, 195102, '\P{Is_Ideo=true}', "");
    Expect(0, 195102, '\P{^Is_Ideo=true}', "");
    Expect(1, 195101, '\p{Is_Ideo=	_True}', "");
    Expect(0, 195101, '\p{^Is_Ideo=	_True}', "");
    Expect(0, 195101, '\P{Is_Ideo=	_True}', "");
    Expect(1, 195101, '\P{^Is_Ideo=	_True}', "");
    Expect(0, 195102, '\p{Is_Ideo=	_True}', "");
    Expect(1, 195102, '\p{^Is_Ideo=	_True}', "");
    Expect(1, 195102, '\P{Is_Ideo=	_True}', "");
    Expect(0, 195102, '\P{^Is_Ideo=	_True}', "");
    Error('\p{ID_Start=:=-_NO}');
    Error('\P{ID_Start=:=-_NO}');
    Expect(1, 195102, '\p{ID_Start=:\ANo\z:}', "");;
    Expect(0, 195101, '\p{ID_Start=:\ANo\z:}', "");;
    Expect(1, 195102, '\p{ID_Start=no}', "");
    Expect(0, 195102, '\p{^ID_Start=no}', "");
    Expect(0, 195102, '\P{ID_Start=no}', "");
    Expect(1, 195102, '\P{^ID_Start=no}', "");
    Expect(0, 195101, '\p{ID_Start=no}', "");
    Expect(1, 195101, '\p{^ID_Start=no}', "");
    Expect(1, 195101, '\P{ID_Start=no}', "");
    Expect(0, 195101, '\P{^ID_Start=no}', "");
    Expect(1, 195102, '\p{ID_Start=:\Ano\z:}', "");;
    Expect(0, 195101, '\p{ID_Start=:\Ano\z:}', "");;
    Expect(1, 195102, '\p{ID_Start= NO}', "");
    Expect(0, 195102, '\p{^ID_Start= NO}', "");
    Expect(0, 195102, '\P{ID_Start= NO}', "");
    Expect(1, 195102, '\P{^ID_Start= NO}', "");
    Expect(0, 195101, '\p{ID_Start= NO}', "");
    Expect(1, 195101, '\p{^ID_Start= NO}', "");
    Expect(1, 195101, '\P{ID_Start= NO}', "");
    Expect(0, 195101, '\P{^ID_Start= NO}', "");
    Error('\p{IDS=	/a/N}');
    Error('\P{IDS=	/a/N}');
    Expect(1, 195102, '\p{IDS=:\AN\z:}', "");;
    Expect(0, 195101, '\p{IDS=:\AN\z:}', "");;
    Expect(1, 195102, '\p{IDS=n}', "");
    Expect(0, 195102, '\p{^IDS=n}', "");
    Expect(0, 195102, '\P{IDS=n}', "");
    Expect(1, 195102, '\P{^IDS=n}', "");
    Expect(0, 195101, '\p{IDS=n}', "");
    Expect(1, 195101, '\p{^IDS=n}', "");
    Expect(1, 195101, '\P{IDS=n}', "");
    Expect(0, 195101, '\P{^IDS=n}', "");
    Expect(1, 195102, '\p{IDS=:\An\z:}', "");;
    Expect(0, 195101, '\p{IDS=:\An\z:}', "");;
    Expect(1, 195102, '\p{IDS=_N}', "");
    Expect(0, 195102, '\p{^IDS=_N}', "");
    Expect(0, 195102, '\P{IDS=_N}', "");
    Expect(1, 195102, '\P{^IDS=_N}', "");
    Expect(0, 195101, '\p{IDS=_N}', "");
    Expect(1, 195101, '\p{^IDS=_N}', "");
    Expect(1, 195101, '\P{IDS=_N}', "");
    Expect(0, 195101, '\P{^IDS=_N}', "");
    Error('\p{Is_ID_Start=:= F}');
    Error('\P{Is_ID_Start=:= F}');
    Expect(1, 195102, '\p{Is_ID_Start=f}', "");
    Expect(0, 195102, '\p{^Is_ID_Start=f}', "");
    Expect(0, 195102, '\P{Is_ID_Start=f}', "");
    Expect(1, 195102, '\P{^Is_ID_Start=f}', "");
    Expect(0, 195101, '\p{Is_ID_Start=f}', "");
    Expect(1, 195101, '\p{^Is_ID_Start=f}', "");
    Expect(1, 195101, '\P{Is_ID_Start=f}', "");
    Expect(0, 195101, '\P{^Is_ID_Start=f}', "");
    Expect(1, 195102, '\p{Is_ID_Start=	F}', "");
    Expect(0, 195102, '\p{^Is_ID_Start=	F}', "");
    Expect(0, 195102, '\P{Is_ID_Start=	F}', "");
    Expect(1, 195102, '\P{^Is_ID_Start=	F}', "");
    Expect(0, 195101, '\p{Is_ID_Start=	F}', "");
    Expect(1, 195101, '\p{^Is_ID_Start=	F}', "");
    Expect(1, 195101, '\P{Is_ID_Start=	F}', "");
    Expect(0, 195101, '\P{^Is_ID_Start=	F}', "");
    Error('\p{Is_IDS=__False/a/}');
    Error('\P{Is_IDS=__False/a/}');
    Expect(1, 195102, '\p{Is_IDS:   false}', "");
    Expect(0, 195102, '\p{^Is_IDS:   false}', "");
    Expect(0, 195102, '\P{Is_IDS:   false}', "");
    Expect(1, 195102, '\P{^Is_IDS:   false}', "");
    Expect(0, 195101, '\p{Is_IDS:   false}', "");
    Expect(1, 195101, '\p{^Is_IDS:   false}', "");
    Expect(1, 195101, '\P{Is_IDS:   false}', "");
    Expect(0, 195101, '\P{^Is_IDS:   false}', "");
    Expect(1, 195102, '\p{Is_IDS=	false}', "");
    Expect(0, 195102, '\p{^Is_IDS=	false}', "");
    Expect(0, 195102, '\P{Is_IDS=	false}', "");
    Expect(1, 195102, '\P{^Is_IDS=	false}', "");
    Expect(0, 195101, '\p{Is_IDS=	false}', "");
    Expect(1, 195101, '\p{^Is_IDS=	false}', "");
    Expect(1, 195101, '\P{Is_IDS=	false}', "");
    Expect(0, 195101, '\P{^Is_IDS=	false}', "");
    Error('\p{ID_Start=/a/_	YES}');
    Error('\P{ID_Start=/a/_	YES}');
    Expect(1, 195101, '\p{ID_Start=:\AYes\z:}', "");;
    Expect(0, 195102, '\p{ID_Start=:\AYes\z:}', "");;
    Expect(1, 195101, '\p{ID_Start=yes}', "");
    Expect(0, 195101, '\p{^ID_Start=yes}', "");
    Expect(0, 195101, '\P{ID_Start=yes}', "");
    Expect(1, 195101, '\P{^ID_Start=yes}', "");
    Expect(0, 195102, '\p{ID_Start=yes}', "");
    Expect(1, 195102, '\p{^ID_Start=yes}', "");
    Expect(1, 195102, '\P{ID_Start=yes}', "");
    Expect(0, 195102, '\P{^ID_Start=yes}', "");
    Expect(1, 195101, '\p{ID_Start=:\Ayes\z:}', "");;
    Expect(0, 195102, '\p{ID_Start=:\Ayes\z:}', "");;
    Expect(1, 195101, '\p{ID_Start=_-Yes}', "");
    Expect(0, 195101, '\p{^ID_Start=_-Yes}', "");
    Expect(0, 195101, '\P{ID_Start=_-Yes}', "");
    Expect(1, 195101, '\P{^ID_Start=_-Yes}', "");
    Expect(0, 195102, '\p{ID_Start=_-Yes}', "");
    Expect(1, 195102, '\p{^ID_Start=_-Yes}', "");
    Expect(1, 195102, '\P{ID_Start=_-Yes}', "");
    Expect(0, 195102, '\P{^ID_Start=_-Yes}', "");
    Error('\p{IDS=	:=Y}');
    Error('\P{IDS=	:=Y}');
    Expect(1, 195101, '\p{IDS=:\AY\z:}', "");;
    Expect(0, 195102, '\p{IDS=:\AY\z:}', "");;
    Expect(1, 195101, '\p{IDS:	y}', "");
    Expect(0, 195101, '\p{^IDS:	y}', "");
    Expect(0, 195101, '\P{IDS:	y}', "");
    Expect(1, 195101, '\P{^IDS:	y}', "");
    Expect(0, 195102, '\p{IDS:	y}', "");
    Expect(1, 195102, '\p{^IDS:	y}', "");
    Expect(1, 195102, '\P{IDS:	y}', "");
    Expect(0, 195102, '\P{^IDS:	y}', "");
    Expect(1, 195101, '\p{IDS=:\Ay\z:}', "");;
    Expect(0, 195102, '\p{IDS=:\Ay\z:}', "");;
    Expect(1, 195101, '\p{IDS=--Y}', "");
    Expect(0, 195101, '\p{^IDS=--Y}', "");
    Expect(0, 195101, '\P{IDS=--Y}', "");
    Expect(1, 195101, '\P{^IDS=--Y}', "");
    Expect(0, 195102, '\p{IDS=--Y}', "");
    Expect(1, 195102, '\p{^IDS=--Y}', "");
    Expect(1, 195102, '\P{IDS=--Y}', "");
    Expect(0, 195102, '\P{^IDS=--Y}', "");
    Error('\p{Is_ID_Start:	-T/a/}');
    Error('\P{Is_ID_Start:	-T/a/}');
    Expect(1, 195101, '\p{Is_ID_Start=t}', "");
    Expect(0, 195101, '\p{^Is_ID_Start=t}', "");
    Expect(0, 195101, '\P{Is_ID_Start=t}', "");
    Expect(1, 195101, '\P{^Is_ID_Start=t}', "");
    Expect(0, 195102, '\p{Is_ID_Start=t}', "");
    Expect(1, 195102, '\p{^Is_ID_Start=t}', "");
    Expect(1, 195102, '\P{Is_ID_Start=t}', "");
    Expect(0, 195102, '\P{^Is_ID_Start=t}', "");
    Expect(1, 195101, '\p{Is_ID_Start= -T}', "");
    Expect(0, 195101, '\p{^Is_ID_Start= -T}', "");
    Expect(0, 195101, '\P{Is_ID_Start= -T}', "");
    Expect(1, 195101, '\P{^Is_ID_Start= -T}', "");
    Expect(0, 195102, '\p{Is_ID_Start= -T}', "");
    Expect(1, 195102, '\p{^Is_ID_Start= -T}', "");
    Expect(1, 195102, '\P{Is_ID_Start= -T}', "");
    Expect(0, 195102, '\P{^Is_ID_Start= -T}', "");
    Error('\p{Is_IDS=:=		TRUE}');
    Error('\P{Is_IDS=:=		TRUE}');
    Expect(1, 195101, '\p{Is_IDS:true}', "");
    Expect(0, 195101, '\p{^Is_IDS:true}', "");
    Expect(0, 195101, '\P{Is_IDS:true}', "");
    Expect(1, 195101, '\P{^Is_IDS:true}', "");
    Expect(0, 195102, '\p{Is_IDS:true}', "");
    Expect(1, 195102, '\p{^Is_IDS:true}', "");
    Expect(1, 195102, '\P{Is_IDS:true}', "");
    Expect(0, 195102, '\P{^Is_IDS:true}', "");
    Expect(1, 195101, '\p{Is_IDS=_ True}', "");
    Expect(0, 195101, '\p{^Is_IDS=_ True}', "");
    Expect(0, 195101, '\P{Is_IDS=_ True}', "");
    Expect(1, 195101, '\P{^Is_IDS=_ True}', "");
    Expect(0, 195102, '\p{Is_IDS=_ True}', "");
    Expect(1, 195102, '\p{^Is_IDS=_ True}', "");
    Expect(1, 195102, '\P{Is_IDS=_ True}', "");
    Expect(0, 195102, '\P{^Is_IDS=_ True}', "");
    Error('\p{IDS_Binary_Operator=-NO/a/}');
    Error('\P{IDS_Binary_Operator=-NO/a/}');
    Expect(1, 12284, '\p{IDS_Binary_Operator=:\ANo\z:}', "");;
    Expect(0, 12283, '\p{IDS_Binary_Operator=:\ANo\z:}', "");;
    Expect(1, 12284, '\p{IDS_Binary_Operator=no}', "");
    Expect(0, 12284, '\p{^IDS_Binary_Operator=no}', "");
    Expect(0, 12284, '\P{IDS_Binary_Operator=no}', "");
    Expect(1, 12284, '\P{^IDS_Binary_Operator=no}', "");
    Expect(0, 12283, '\p{IDS_Binary_Operator=no}', "");
    Expect(1, 12283, '\p{^IDS_Binary_Operator=no}', "");
    Expect(1, 12283, '\P{IDS_Binary_Operator=no}', "");
    Expect(0, 12283, '\P{^IDS_Binary_Operator=no}', "");
    Expect(1, 12284, '\p{IDS_Binary_Operator=:\Ano\z:}', "");;
    Expect(0, 12283, '\p{IDS_Binary_Operator=:\Ano\z:}', "");;
    Expect(1, 12284, '\p{IDS_Binary_Operator=	_no}', "");
    Expect(0, 12284, '\p{^IDS_Binary_Operator=	_no}', "");
    Expect(0, 12284, '\P{IDS_Binary_Operator=	_no}', "");
    Expect(1, 12284, '\P{^IDS_Binary_Operator=	_no}', "");
    Expect(0, 12283, '\p{IDS_Binary_Operator=	_no}', "");
    Expect(1, 12283, '\p{^IDS_Binary_Operator=	_no}', "");
    Expect(1, 12283, '\P{IDS_Binary_Operator=	_no}', "");
    Expect(0, 12283, '\P{^IDS_Binary_Operator=	_no}', "");
    Error('\p{IDSB:	/a/N}');
    Error('\P{IDSB:	/a/N}');
    Expect(1, 12284, '\p{IDSB=:\AN\z:}', "");;
    Expect(0, 12283, '\p{IDSB=:\AN\z:}', "");;
    Expect(1, 12284, '\p{IDSB=n}', "");
    Expect(0, 12284, '\p{^IDSB=n}', "");
    Expect(0, 12284, '\P{IDSB=n}', "");
    Expect(1, 12284, '\P{^IDSB=n}', "");
    Expect(0, 12283, '\p{IDSB=n}', "");
    Expect(1, 12283, '\p{^IDSB=n}', "");
    Expect(1, 12283, '\P{IDSB=n}', "");
    Expect(0, 12283, '\P{^IDSB=n}', "");
    Expect(1, 12284, '\p{IDSB=:\An\z:}', "");;
    Expect(0, 12283, '\p{IDSB=:\An\z:}', "");;
    Expect(1, 12284, '\p{IDSB=	_N}', "");
    Expect(0, 12284, '\p{^IDSB=	_N}', "");
    Expect(0, 12284, '\P{IDSB=	_N}', "");
    Expect(1, 12284, '\P{^IDSB=	_N}', "");
    Expect(0, 12283, '\p{IDSB=	_N}', "");
    Expect(1, 12283, '\p{^IDSB=	_N}', "");
    Expect(1, 12283, '\P{IDSB=	_N}', "");
    Expect(0, 12283, '\P{^IDSB=	_N}', "");
    Error('\p{Is_IDS_Binary_Operator=/a/--F}');
    Error('\P{Is_IDS_Binary_Operator=/a/--F}');
    Expect(1, 12284, '\p{Is_IDS_Binary_Operator: f}', "");
    Expect(0, 12284, '\p{^Is_IDS_Binary_Operator: f}', "");
    Expect(0, 12284, '\P{Is_IDS_Binary_Operator: f}', "");
    Expect(1, 12284, '\P{^Is_IDS_Binary_Operator: f}', "");
    Expect(0, 12283, '\p{Is_IDS_Binary_Operator: f}', "");
    Expect(1, 12283, '\p{^Is_IDS_Binary_Operator: f}', "");
    Expect(1, 12283, '\P{Is_IDS_Binary_Operator: f}', "");
    Expect(0, 12283, '\P{^Is_IDS_Binary_Operator: f}', "");
    Expect(1, 12284, '\p{Is_IDS_Binary_Operator=_	F}', "");
    Expect(0, 12284, '\p{^Is_IDS_Binary_Operator=_	F}', "");
    Expect(0, 12284, '\P{Is_IDS_Binary_Operator=_	F}', "");
    Expect(1, 12284, '\P{^Is_IDS_Binary_Operator=_	F}', "");
    Expect(0, 12283, '\p{Is_IDS_Binary_Operator=_	F}', "");
    Expect(1, 12283, '\p{^Is_IDS_Binary_Operator=_	F}', "");
    Expect(1, 12283, '\P{Is_IDS_Binary_Operator=_	F}', "");
    Expect(0, 12283, '\P{^Is_IDS_Binary_Operator=_	F}', "");
    Error('\p{Is_IDSB:	/a/False}');
    Error('\P{Is_IDSB:	/a/False}');
    Expect(1, 12284, '\p{Is_IDSB=false}', "");
    Expect(0, 12284, '\p{^Is_IDSB=false}', "");
    Expect(0, 12284, '\P{Is_IDSB=false}', "");
    Expect(1, 12284, '\P{^Is_IDSB=false}', "");
    Expect(0, 12283, '\p{Is_IDSB=false}', "");
    Expect(1, 12283, '\p{^Is_IDSB=false}', "");
    Expect(1, 12283, '\P{Is_IDSB=false}', "");
    Expect(0, 12283, '\P{^Is_IDSB=false}', "");
    Expect(1, 12284, '\p{Is_IDSB= 	false}', "");
    Expect(0, 12284, '\p{^Is_IDSB= 	false}', "");
    Expect(0, 12284, '\P{Is_IDSB= 	false}', "");
    Expect(1, 12284, '\P{^Is_IDSB= 	false}', "");
    Expect(0, 12283, '\p{Is_IDSB= 	false}', "");
    Expect(1, 12283, '\p{^Is_IDSB= 	false}', "");
    Expect(1, 12283, '\P{Is_IDSB= 	false}', "");
    Expect(0, 12283, '\P{^Is_IDSB= 	false}', "");
    Error('\p{IDS_Binary_Operator= _YES/a/}');
    Error('\P{IDS_Binary_Operator= _YES/a/}');
    Expect(1, 12283, '\p{IDS_Binary_Operator=:\AYes\z:}', "");;
    Expect(0, 12284, '\p{IDS_Binary_Operator=:\AYes\z:}', "");;
    Expect(1, 12283, '\p{IDS_Binary_Operator=yes}', "");
    Expect(0, 12283, '\p{^IDS_Binary_Operator=yes}', "");
    Expect(0, 12283, '\P{IDS_Binary_Operator=yes}', "");
    Expect(1, 12283, '\P{^IDS_Binary_Operator=yes}', "");
    Expect(0, 12284, '\p{IDS_Binary_Operator=yes}', "");
    Expect(1, 12284, '\p{^IDS_Binary_Operator=yes}', "");
    Expect(1, 12284, '\P{IDS_Binary_Operator=yes}', "");
    Expect(0, 12284, '\P{^IDS_Binary_Operator=yes}', "");
    Expect(1, 12283, '\p{IDS_Binary_Operator=:\Ayes\z:}', "");;
    Expect(0, 12284, '\p{IDS_Binary_Operator=:\Ayes\z:}', "");;
    Expect(1, 12283, '\p{IDS_Binary_Operator=-_Yes}', "");
    Expect(0, 12283, '\p{^IDS_Binary_Operator=-_Yes}', "");
    Expect(0, 12283, '\P{IDS_Binary_Operator=-_Yes}', "");
    Expect(1, 12283, '\P{^IDS_Binary_Operator=-_Yes}', "");
    Expect(0, 12284, '\p{IDS_Binary_Operator=-_Yes}', "");
    Expect(1, 12284, '\p{^IDS_Binary_Operator=-_Yes}', "");
    Expect(1, 12284, '\P{IDS_Binary_Operator=-_Yes}', "");
    Expect(0, 12284, '\P{^IDS_Binary_Operator=-_Yes}', "");
    Error('\p{IDSB=-:=Y}');
    Error('\P{IDSB=-:=Y}');
    Expect(1, 12283, '\p{IDSB=:\AY\z:}', "");;
    Expect(0, 12284, '\p{IDSB=:\AY\z:}', "");;
    Expect(1, 12283, '\p{IDSB=y}', "");
    Expect(0, 12283, '\p{^IDSB=y}', "");
    Expect(0, 12283, '\P{IDSB=y}', "");
    Expect(1, 12283, '\P{^IDSB=y}', "");
    Expect(0, 12284, '\p{IDSB=y}', "");
    Expect(1, 12284, '\p{^IDSB=y}', "");
    Expect(1, 12284, '\P{IDSB=y}', "");
    Expect(0, 12284, '\P{^IDSB=y}', "");
    Expect(1, 12283, '\p{IDSB=:\Ay\z:}', "");;
    Expect(0, 12284, '\p{IDSB=:\Ay\z:}', "");;
    Expect(1, 12283, '\p{IDSB=_Y}', "");
    Expect(0, 12283, '\p{^IDSB=_Y}', "");
    Expect(0, 12283, '\P{IDSB=_Y}', "");
    Expect(1, 12283, '\P{^IDSB=_Y}', "");
    Expect(0, 12284, '\p{IDSB=_Y}', "");
    Expect(1, 12284, '\p{^IDSB=_Y}', "");
    Expect(1, 12284, '\P{IDSB=_Y}', "");
    Expect(0, 12284, '\P{^IDSB=_Y}', "");
    Error('\p{Is_IDS_Binary_Operator=/a/		T}');
    Error('\P{Is_IDS_Binary_Operator=/a/		T}');
    Expect(1, 12283, '\p{Is_IDS_Binary_Operator=t}', "");
    Expect(0, 12283, '\p{^Is_IDS_Binary_Operator=t}', "");
    Expect(0, 12283, '\P{Is_IDS_Binary_Operator=t}', "");
    Expect(1, 12283, '\P{^Is_IDS_Binary_Operator=t}', "");
    Expect(0, 12284, '\p{Is_IDS_Binary_Operator=t}', "");
    Expect(1, 12284, '\p{^Is_IDS_Binary_Operator=t}', "");
    Expect(1, 12284, '\P{Is_IDS_Binary_Operator=t}', "");
    Expect(0, 12284, '\P{^Is_IDS_Binary_Operator=t}', "");
    Expect(1, 12283, '\p{Is_IDS_Binary_Operator=  T}', "");
    Expect(0, 12283, '\p{^Is_IDS_Binary_Operator=  T}', "");
    Expect(0, 12283, '\P{Is_IDS_Binary_Operator=  T}', "");
    Expect(1, 12283, '\P{^Is_IDS_Binary_Operator=  T}', "");
    Expect(0, 12284, '\p{Is_IDS_Binary_Operator=  T}', "");
    Expect(1, 12284, '\p{^Is_IDS_Binary_Operator=  T}', "");
    Expect(1, 12284, '\P{Is_IDS_Binary_Operator=  T}', "");
    Expect(0, 12284, '\P{^Is_IDS_Binary_Operator=  T}', "");
    Error('\p{Is_IDSB=	true:=}');
    Error('\P{Is_IDSB=	true:=}');
    Expect(1, 12283, '\p{Is_IDSB=true}', "");
    Expect(0, 12283, '\p{^Is_IDSB=true}', "");
    Expect(0, 12283, '\P{Is_IDSB=true}', "");
    Expect(1, 12283, '\P{^Is_IDSB=true}', "");
    Expect(0, 12284, '\p{Is_IDSB=true}', "");
    Expect(1, 12284, '\p{^Is_IDSB=true}', "");
    Expect(1, 12284, '\P{Is_IDSB=true}', "");
    Expect(0, 12284, '\P{^Is_IDSB=true}', "");
    Expect(1, 12283, '\p{Is_IDSB=  TRUE}', "");
    Expect(0, 12283, '\p{^Is_IDSB=  TRUE}', "");
    Expect(0, 12283, '\P{Is_IDSB=  TRUE}', "");
    Expect(1, 12283, '\P{^Is_IDSB=  TRUE}', "");
    Expect(0, 12284, '\p{Is_IDSB=  TRUE}', "");
    Expect(1, 12284, '\p{^Is_IDSB=  TRUE}', "");
    Expect(1, 12284, '\P{Is_IDSB=  TRUE}', "");
    Expect(0, 12284, '\P{^Is_IDSB=  TRUE}', "");
    Error('\p{IDS_Trinary_Operator=/a/_No}');
    Error('\P{IDS_Trinary_Operator=/a/_No}');
    Expect(1, 12276, '\p{IDS_Trinary_Operator=:\ANo\z:}', "");;
    Expect(0, 12275, '\p{IDS_Trinary_Operator=:\ANo\z:}', "");;
    Expect(1, 12276, '\p{IDS_Trinary_Operator=no}', "");
    Expect(0, 12276, '\p{^IDS_Trinary_Operator=no}', "");
    Expect(0, 12276, '\P{IDS_Trinary_Operator=no}', "");
    Expect(1, 12276, '\P{^IDS_Trinary_Operator=no}', "");
    Expect(0, 12275, '\p{IDS_Trinary_Operator=no}', "");
    Expect(1, 12275, '\p{^IDS_Trinary_Operator=no}', "");
    Expect(1, 12275, '\P{IDS_Trinary_Operator=no}', "");
    Expect(0, 12275, '\P{^IDS_Trinary_Operator=no}', "");
    Expect(1, 12276, '\p{IDS_Trinary_Operator=:\Ano\z:}', "");;
    Expect(0, 12275, '\p{IDS_Trinary_Operator=:\Ano\z:}', "");;
    Expect(1, 12276, '\p{IDS_Trinary_Operator=-	no}', "");
    Expect(0, 12276, '\p{^IDS_Trinary_Operator=-	no}', "");
    Expect(0, 12276, '\P{IDS_Trinary_Operator=-	no}', "");
    Expect(1, 12276, '\P{^IDS_Trinary_Operator=-	no}', "");
    Expect(0, 12275, '\p{IDS_Trinary_Operator=-	no}', "");
    Expect(1, 12275, '\p{^IDS_Trinary_Operator=-	no}', "");
    Expect(1, 12275, '\P{IDS_Trinary_Operator=-	no}', "");
    Expect(0, 12275, '\P{^IDS_Trinary_Operator=-	no}', "");
    Error('\p{IDST: -:=N}');
    Error('\P{IDST: -:=N}');
    Expect(1, 12276, '\p{IDST=:\AN\z:}', "");;
    Expect(0, 12275, '\p{IDST=:\AN\z:}', "");;
    Expect(1, 12276, '\p{IDST=n}', "");
    Expect(0, 12276, '\p{^IDST=n}', "");
    Expect(0, 12276, '\P{IDST=n}', "");
    Expect(1, 12276, '\P{^IDST=n}', "");
    Expect(0, 12275, '\p{IDST=n}', "");
    Expect(1, 12275, '\p{^IDST=n}', "");
    Expect(1, 12275, '\P{IDST=n}', "");
    Expect(0, 12275, '\P{^IDST=n}', "");
    Expect(1, 12276, '\p{IDST=:\An\z:}', "");;
    Expect(0, 12275, '\p{IDST=:\An\z:}', "");;
    Expect(1, 12276, '\p{IDST=--N}', "");
    Expect(0, 12276, '\p{^IDST=--N}', "");
    Expect(0, 12276, '\P{IDST=--N}', "");
    Expect(1, 12276, '\P{^IDST=--N}', "");
    Expect(0, 12275, '\p{IDST=--N}', "");
    Expect(1, 12275, '\p{^IDST=--N}', "");
    Expect(1, 12275, '\P{IDST=--N}', "");
    Expect(0, 12275, '\P{^IDST=--N}', "");
    Error('\p{Is_IDS_Trinary_Operator=-F:=}');
    Error('\P{Is_IDS_Trinary_Operator=-F:=}');
    Expect(1, 12276, '\p{Is_IDS_Trinary_Operator=f}', "");
    Expect(0, 12276, '\p{^Is_IDS_Trinary_Operator=f}', "");
    Expect(0, 12276, '\P{Is_IDS_Trinary_Operator=f}', "");
    Expect(1, 12276, '\P{^Is_IDS_Trinary_Operator=f}', "");
    Expect(0, 12275, '\p{Is_IDS_Trinary_Operator=f}', "");
    Expect(1, 12275, '\p{^Is_IDS_Trinary_Operator=f}', "");
    Expect(1, 12275, '\P{Is_IDS_Trinary_Operator=f}', "");
    Expect(0, 12275, '\P{^Is_IDS_Trinary_Operator=f}', "");
    Expect(1, 12276, '\p{Is_IDS_Trinary_Operator=		F}', "");
    Expect(0, 12276, '\p{^Is_IDS_Trinary_Operator=		F}', "");
    Expect(0, 12276, '\P{Is_IDS_Trinary_Operator=		F}', "");
    Expect(1, 12276, '\P{^Is_IDS_Trinary_Operator=		F}', "");
    Expect(0, 12275, '\p{Is_IDS_Trinary_Operator=		F}', "");
    Expect(1, 12275, '\p{^Is_IDS_Trinary_Operator=		F}', "");
    Expect(1, 12275, '\P{Is_IDS_Trinary_Operator=		F}', "");
    Expect(0, 12275, '\P{^Is_IDS_Trinary_Operator=		F}', "");
    Error('\p{Is_IDST:   _-False:=}');
    Error('\P{Is_IDST:   _-False:=}');
    Expect(1, 12276, '\p{Is_IDST:   false}', "");
    Expect(0, 12276, '\p{^Is_IDST:   false}', "");
    Expect(0, 12276, '\P{Is_IDST:   false}', "");
    Expect(1, 12276, '\P{^Is_IDST:   false}', "");
    Expect(0, 12275, '\p{Is_IDST:   false}', "");
    Expect(1, 12275, '\p{^Is_IDST:   false}', "");
    Expect(1, 12275, '\P{Is_IDST:   false}', "");
    Expect(0, 12275, '\P{^Is_IDST:   false}', "");
    Expect(1, 12276, '\p{Is_IDST=	-false}', "");
    Expect(0, 12276, '\p{^Is_IDST=	-false}', "");
    Expect(0, 12276, '\P{Is_IDST=	-false}', "");
    Expect(1, 12276, '\P{^Is_IDST=	-false}', "");
    Expect(0, 12275, '\p{Is_IDST=	-false}', "");
    Expect(1, 12275, '\p{^Is_IDST=	-false}', "");
    Expect(1, 12275, '\P{Is_IDST=	-false}', "");
    Expect(0, 12275, '\P{^Is_IDST=	-false}', "");
    Error('\p{IDS_Trinary_Operator=-/a/YES}');
    Error('\P{IDS_Trinary_Operator=-/a/YES}');
    Expect(1, 12275, '\p{IDS_Trinary_Operator=:\AYes\z:}', "");;
    Expect(0, 12276, '\p{IDS_Trinary_Operator=:\AYes\z:}', "");;
    Expect(1, 12275, '\p{IDS_Trinary_Operator=yes}', "");
    Expect(0, 12275, '\p{^IDS_Trinary_Operator=yes}', "");
    Expect(0, 12275, '\P{IDS_Trinary_Operator=yes}', "");
    Expect(1, 12275, '\P{^IDS_Trinary_Operator=yes}', "");
    Expect(0, 12276, '\p{IDS_Trinary_Operator=yes}', "");
    Expect(1, 12276, '\p{^IDS_Trinary_Operator=yes}', "");
    Expect(1, 12276, '\P{IDS_Trinary_Operator=yes}', "");
    Expect(0, 12276, '\P{^IDS_Trinary_Operator=yes}', "");
    Expect(1, 12275, '\p{IDS_Trinary_Operator=:\Ayes\z:}', "");;
    Expect(0, 12276, '\p{IDS_Trinary_Operator=:\Ayes\z:}', "");;
    Expect(1, 12275, '\p{IDS_Trinary_Operator=	_Yes}', "");
    Expect(0, 12275, '\p{^IDS_Trinary_Operator=	_Yes}', "");
    Expect(0, 12275, '\P{IDS_Trinary_Operator=	_Yes}', "");
    Expect(1, 12275, '\P{^IDS_Trinary_Operator=	_Yes}', "");
    Expect(0, 12276, '\p{IDS_Trinary_Operator=	_Yes}', "");
    Expect(1, 12276, '\p{^IDS_Trinary_Operator=	_Yes}', "");
    Expect(1, 12276, '\P{IDS_Trinary_Operator=	_Yes}', "");
    Expect(0, 12276, '\P{^IDS_Trinary_Operator=	_Yes}', "");
    Error('\p{IDST:   -Y/a/}');
    Error('\P{IDST:   -Y/a/}');
    Expect(1, 12275, '\p{IDST=:\AY\z:}', "");;
    Expect(0, 12276, '\p{IDST=:\AY\z:}', "");;
    Expect(1, 12275, '\p{IDST=y}', "");
    Expect(0, 12275, '\p{^IDST=y}', "");
    Expect(0, 12275, '\P{IDST=y}', "");
    Expect(1, 12275, '\P{^IDST=y}', "");
    Expect(0, 12276, '\p{IDST=y}', "");
    Expect(1, 12276, '\p{^IDST=y}', "");
    Expect(1, 12276, '\P{IDST=y}', "");
    Expect(0, 12276, '\P{^IDST=y}', "");
    Expect(1, 12275, '\p{IDST=:\Ay\z:}', "");;
    Expect(0, 12276, '\p{IDST=:\Ay\z:}', "");;
    Expect(1, 12275, '\p{IDST=-	Y}', "");
    Expect(0, 12275, '\p{^IDST=-	Y}', "");
    Expect(0, 12275, '\P{IDST=-	Y}', "");
    Expect(1, 12275, '\P{^IDST=-	Y}', "");
    Expect(0, 12276, '\p{IDST=-	Y}', "");
    Expect(1, 12276, '\p{^IDST=-	Y}', "");
    Expect(1, 12276, '\P{IDST=-	Y}', "");
    Expect(0, 12276, '\P{^IDST=-	Y}', "");
    Error('\p{Is_IDS_Trinary_Operator=	/a/T}');
    Error('\P{Is_IDS_Trinary_Operator=	/a/T}');
    Expect(1, 12275, '\p{Is_IDS_Trinary_Operator:   t}', "");
    Expect(0, 12275, '\p{^Is_IDS_Trinary_Operator:   t}', "");
    Expect(0, 12275, '\P{Is_IDS_Trinary_Operator:   t}', "");
    Expect(1, 12275, '\P{^Is_IDS_Trinary_Operator:   t}', "");
    Expect(0, 12276, '\p{Is_IDS_Trinary_Operator:   t}', "");
    Expect(1, 12276, '\p{^Is_IDS_Trinary_Operator:   t}', "");
    Expect(1, 12276, '\P{Is_IDS_Trinary_Operator:   t}', "");
    Expect(0, 12276, '\P{^Is_IDS_Trinary_Operator:   t}', "");
    Expect(1, 12275, '\p{Is_IDS_Trinary_Operator=	_T}', "");
    Expect(0, 12275, '\p{^Is_IDS_Trinary_Operator=	_T}', "");
    Expect(0, 12275, '\P{Is_IDS_Trinary_Operator=	_T}', "");
    Expect(1, 12275, '\P{^Is_IDS_Trinary_Operator=	_T}', "");
    Expect(0, 12276, '\p{Is_IDS_Trinary_Operator=	_T}', "");
    Expect(1, 12276, '\p{^Is_IDS_Trinary_Operator=	_T}', "");
    Expect(1, 12276, '\P{Is_IDS_Trinary_Operator=	_T}', "");
    Expect(0, 12276, '\P{^Is_IDS_Trinary_Operator=	_T}', "");
    Error('\p{Is_IDST=	_TRUE:=}');
    Error('\P{Is_IDST=	_TRUE:=}');
    Expect(1, 12275, '\p{Is_IDST=true}', "");
    Expect(0, 12275, '\p{^Is_IDST=true}', "");
    Expect(0, 12275, '\P{Is_IDST=true}', "");
    Expect(1, 12275, '\P{^Is_IDST=true}', "");
    Expect(0, 12276, '\p{Is_IDST=true}', "");
    Expect(1, 12276, '\p{^Is_IDST=true}', "");
    Expect(1, 12276, '\P{Is_IDST=true}', "");
    Expect(0, 12276, '\P{^Is_IDST=true}', "");
    Expect(1, 12275, '\p{Is_IDST:  -True}', "");
    Expect(0, 12275, '\p{^Is_IDST:  -True}', "");
    Expect(0, 12275, '\P{Is_IDST:  -True}', "");
    Expect(1, 12275, '\P{^Is_IDST:  -True}', "");
    Expect(0, 12276, '\p{Is_IDST:  -True}', "");
    Expect(1, 12276, '\p{^Is_IDST:  -True}', "");
    Expect(1, 12276, '\P{Is_IDST:  -True}', "");
    Expect(0, 12276, '\P{^Is_IDST:  -True}', "");
    Error('\p{presentin}');
    Error('\P{presentin}');
    Error('\p{in}');
    Error('\P{in}');
    Error('\p{Present_In: /a/0001.1}');
    Error('\P{Present_In: /a/0001.1}');
    Expect(1, 65533, '\p{Present_In=:\A1.1\z:}', "");;
    Expect(0, 65536, '\p{Present_In=:\A1.1\z:}', "");;
    Expect(1, 65533, '\p{Present_In=1.1}', "");
    Expect(0, 65533, '\p{^Present_In=1.1}', "");
    Expect(0, 65533, '\P{Present_In=1.1}', "");
    Expect(1, 65533, '\P{^Present_In=1.1}', "");
    Expect(0, 65536, '\p{Present_In=1.1}', "");
    Expect(1, 65536, '\p{^Present_In=1.1}', "");
    Expect(1, 65536, '\P{Present_In=1.1}', "");
    Expect(0, 65536, '\P{^Present_In=1.1}', "");
    Error('\p{In=	:=1.1}');
    Error('\P{In=	:=1.1}');
    Expect(1, 65533, '\p{In=:\A1.1\z:}', "");;
    Expect(0, 65536, '\p{In=:\A1.1\z:}', "");;
    Expect(1, 65533, '\p{In=0_1.1}', "");
    Expect(0, 65533, '\p{^In=0_1.1}', "");
    Expect(0, 65533, '\P{In=0_1.1}', "");
    Expect(1, 65533, '\P{^In=0_1.1}', "");
    Expect(0, 65536, '\p{In=0_1.1}', "");
    Expect(1, 65536, '\p{^In=0_1.1}', "");
    Expect(1, 65536, '\P{In=0_1.1}', "");
    Expect(0, 65536, '\P{^In=0_1.1}', "");
    Error('\p{Is_Present_In:	+0000000001.1/a/}');
    Error('\P{Is_Present_In:	+0000000001.1/a/}');
    Expect(1, 65533, '\p{Is_Present_In=00_00_01.1}', "");
    Expect(0, 65533, '\p{^Is_Present_In=00_00_01.1}', "");
    Expect(0, 65533, '\P{Is_Present_In=00_00_01.1}', "");
    Expect(1, 65533, '\P{^Is_Present_In=00_00_01.1}', "");
    Expect(0, 65536, '\p{Is_Present_In=00_00_01.1}', "");
    Expect(1, 65536, '\p{^Is_Present_In=00_00_01.1}', "");
    Expect(1, 65536, '\P{Is_Present_In=00_00_01.1}', "");
    Expect(0, 65536, '\P{^Is_Present_In=00_00_01.1}', "");
    Error('\p{Is_In:	/a/1.1}');
    Error('\P{Is_In:	/a/1.1}');
    Expect(1, 65533, '\p{Is_In=0_0_0_01.1}', "");
    Expect(0, 65533, '\p{^Is_In=0_0_0_01.1}', "");
    Expect(0, 65533, '\P{Is_In=0_0_0_01.1}', "");
    Expect(1, 65533, '\P{^Is_In=0_0_0_01.1}', "");
    Expect(0, 65536, '\p{Is_In=0_0_0_01.1}', "");
    Expect(1, 65536, '\p{^Is_In=0_0_0_01.1}', "");
    Expect(1, 65536, '\P{Is_In=0_0_0_01.1}', "");
    Expect(0, 65536, '\P{^Is_In=0_0_0_01.1}', "");
    Error('\p{Present_In=	000000010.0:=}');
    Error('\P{Present_In=	000000010.0:=}');
    Expect(1, 983040, '\p{Present_In=:\A10.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A10.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=+00_00_00_00_010.0}', "");
    Expect(0, 983040, '\p{^Present_In=+00_00_00_00_010.0}', "");
    Expect(0, 983040, '\P{Present_In=+00_00_00_00_010.0}', "");
    Expect(1, 983040, '\P{^Present_In=+00_00_00_00_010.0}', "");
    Expect(0, 983037, '\p{Present_In=+00_00_00_00_010.0}', "");
    Expect(1, 983037, '\p{^Present_In=+00_00_00_00_010.0}', "");
    Expect(1, 983037, '\P{Present_In=+00_00_00_00_010.0}', "");
    Expect(0, 983037, '\P{^Present_In=+00_00_00_00_010.0}', "");
    Error('\p{In=/a/ _v10_0}');
    Error('\P{In=/a/ _v10_0}');
    Expect(1, 983040, '\p{In=:\AV10_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV10_0\z:}', "");;
    Expect(1, 983040, '\p{In=v100}', "");
    Expect(0, 983040, '\p{^In=v100}', "");
    Expect(0, 983040, '\P{In=v100}', "");
    Expect(1, 983040, '\P{^In=v100}', "");
    Expect(0, 983037, '\p{In=v100}', "");
    Expect(1, 983037, '\p{^In=v100}', "");
    Expect(1, 983037, '\P{In=v100}', "");
    Expect(0, 983037, '\P{^In=v100}', "");
    Expect(1, 983040, '\p{In=:\Av100\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av100\z:}', "");;
    Expect(1, 983040, '\p{In=_	v10_0}', "");
    Expect(0, 983040, '\p{^In=_	v10_0}', "");
    Expect(0, 983040, '\P{In=_	v10_0}', "");
    Expect(1, 983040, '\P{^In=_	v10_0}', "");
    Expect(0, 983037, '\p{In=_	v10_0}', "");
    Expect(1, 983037, '\p{^In=_	v10_0}', "");
    Expect(1, 983037, '\P{In=_	v10_0}', "");
    Expect(0, 983037, '\P{^In=_	v10_0}', "");
    Error('\p{Is_Present_In:/a/ 00_00_00_010.0}');
    Error('\P{Is_Present_In:/a/ 00_00_00_010.0}');
    Expect(1, 983040, '\p{Is_Present_In=+00_00_00_00_010.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=+00_00_00_00_010.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=+00_00_00_00_010.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=+00_00_00_00_010.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=+00_00_00_00_010.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=+00_00_00_00_010.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=+00_00_00_00_010.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=+00_00_00_00_010.0}', "");
    Error('\p{Is_In=_V10_0/a/}');
    Error('\P{Is_In=_V10_0/a/}');
    Expect(1, 983040, '\p{Is_In: v100}', "");
    Expect(0, 983040, '\p{^Is_In: v100}', "");
    Expect(0, 983040, '\P{Is_In: v100}', "");
    Expect(1, 983040, '\P{^Is_In: v100}', "");
    Expect(0, 983037, '\p{Is_In: v100}', "");
    Expect(1, 983037, '\p{^Is_In: v100}', "");
    Expect(1, 983037, '\P{Is_In: v100}', "");
    Expect(0, 983037, '\P{^Is_In: v100}', "");
    Expect(1, 983040, '\p{Is_In=_ V10_0}', "");
    Expect(0, 983040, '\p{^Is_In=_ V10_0}', "");
    Expect(0, 983040, '\P{Is_In=_ V10_0}', "");
    Expect(1, 983040, '\P{^Is_In=_ V10_0}', "");
    Expect(0, 983037, '\p{Is_In=_ V10_0}', "");
    Expect(1, 983037, '\p{^Is_In=_ V10_0}', "");
    Expect(1, 983037, '\P{Is_In=_ V10_0}', "");
    Expect(0, 983037, '\P{^Is_In=_ V10_0}', "");
    Error('\p{Present_In=		000000001_1.0:=}');
    Error('\P{Present_In=		000000001_1.0:=}');
    Expect(1, 983040, '\p{Present_In=:\A11.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A11.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=+0_0_11.0}', "");
    Expect(0, 983040, '\p{^Present_In=+0_0_11.0}', "");
    Expect(0, 983040, '\P{Present_In=+0_0_11.0}', "");
    Expect(1, 983040, '\P{^Present_In=+0_0_11.0}', "");
    Expect(0, 983037, '\p{Present_In=+0_0_11.0}', "");
    Expect(1, 983037, '\p{^Present_In=+0_0_11.0}', "");
    Expect(1, 983037, '\P{Present_In=+0_0_11.0}', "");
    Expect(0, 983037, '\P{^Present_In=+0_0_11.0}', "");
    Error('\p{In= /a/V11_0}');
    Error('\P{In= /a/V11_0}');
    Expect(1, 983040, '\p{In=:\AV11_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV11_0\z:}', "");;
    Expect(1, 983040, '\p{In=v110}', "");
    Expect(0, 983040, '\p{^In=v110}', "");
    Expect(0, 983040, '\P{In=v110}', "");
    Expect(1, 983040, '\P{^In=v110}', "");
    Expect(0, 983037, '\p{In=v110}', "");
    Expect(1, 983037, '\p{^In=v110}', "");
    Expect(1, 983037, '\P{In=v110}', "");
    Expect(0, 983037, '\P{^In=v110}', "");
    Expect(1, 983040, '\p{In=:\Av110\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av110\z:}', "");;
    Expect(1, 983040, '\p{In=v11_0}', "");
    Expect(0, 983040, '\p{^In=v11_0}', "");
    Expect(0, 983040, '\P{In=v11_0}', "");
    Expect(1, 983040, '\P{^In=v11_0}', "");
    Expect(0, 983037, '\p{In=v11_0}', "");
    Expect(1, 983037, '\p{^In=v11_0}', "");
    Expect(1, 983037, '\P{In=v11_0}', "");
    Expect(0, 983037, '\P{^In=v11_0}', "");
    Error('\p{Is_Present_In=/a/	-1_1.0}');
    Error('\P{Is_Present_In=/a/	-1_1.0}');
    Expect(1, 983040, '\p{Is_Present_In:   000_001_1.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In:   000_001_1.0}', "");
    Expect(0, 983040, '\P{Is_Present_In:   000_001_1.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In:   000_001_1.0}', "");
    Expect(0, 983037, '\p{Is_Present_In:   000_001_1.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In:   000_001_1.0}', "");
    Expect(1, 983037, '\P{Is_Present_In:   000_001_1.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In:   000_001_1.0}', "");
    Error('\p{Is_In=:= V11_0}');
    Error('\P{Is_In=:= V11_0}');
    Expect(1, 983040, '\p{Is_In=v110}', "");
    Expect(0, 983040, '\p{^Is_In=v110}', "");
    Expect(0, 983040, '\P{Is_In=v110}', "");
    Expect(1, 983040, '\P{^Is_In=v110}', "");
    Expect(0, 983037, '\p{Is_In=v110}', "");
    Expect(1, 983037, '\p{^Is_In=v110}', "");
    Expect(1, 983037, '\P{Is_In=v110}', "");
    Expect(0, 983037, '\P{^Is_In=v110}', "");
    Expect(1, 983040, '\p{Is_In=--V11_0}', "");
    Expect(0, 983040, '\p{^Is_In=--V11_0}', "");
    Expect(0, 983040, '\P{Is_In=--V11_0}', "");
    Expect(1, 983040, '\P{^Is_In=--V11_0}', "");
    Expect(0, 983037, '\p{Is_In=--V11_0}', "");
    Expect(1, 983037, '\p{^Is_In=--V11_0}', "");
    Expect(1, 983037, '\P{Is_In=--V11_0}', "");
    Expect(0, 983037, '\P{^Is_In=--V11_0}', "");
    Error('\p{Present_In:/a/- 1_2.0}');
    Error('\P{Present_In:/a/- 1_2.0}');
    Expect(1, 983040, '\p{Present_In=:\A12.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A12.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=00_01_2.0}', "");
    Expect(0, 983040, '\p{^Present_In=00_01_2.0}', "");
    Expect(0, 983040, '\P{Present_In=00_01_2.0}', "");
    Expect(1, 983040, '\P{^Present_In=00_01_2.0}', "");
    Expect(0, 983037, '\p{Present_In=00_01_2.0}', "");
    Expect(1, 983037, '\p{^Present_In=00_01_2.0}', "");
    Expect(1, 983037, '\P{Present_In=00_01_2.0}', "");
    Expect(0, 983037, '\P{^Present_In=00_01_2.0}', "");
    Error('\p{In=	:=V12_0}');
    Error('\P{In=	:=V12_0}');
    Expect(1, 983040, '\p{In=:\AV12_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV12_0\z:}', "");;
    Expect(1, 983040, '\p{In:	v120}', "");
    Expect(0, 983040, '\p{^In:	v120}', "");
    Expect(0, 983040, '\P{In:	v120}', "");
    Expect(1, 983040, '\P{^In:	v120}', "");
    Expect(0, 983037, '\p{In:	v120}', "");
    Expect(1, 983037, '\p{^In:	v120}', "");
    Expect(1, 983037, '\P{In:	v120}', "");
    Expect(0, 983037, '\P{^In:	v120}', "");
    Expect(1, 983040, '\p{In=:\Av120\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av120\z:}', "");;
    Expect(1, 983040, '\p{In= -v12_0}', "");
    Expect(0, 983040, '\p{^In= -v12_0}', "");
    Expect(0, 983040, '\P{In= -v12_0}', "");
    Expect(1, 983040, '\P{^In= -v12_0}', "");
    Expect(0, 983037, '\p{In= -v12_0}', "");
    Expect(1, 983037, '\p{^In= -v12_0}', "");
    Expect(1, 983037, '\P{In= -v12_0}', "");
    Expect(0, 983037, '\P{^In= -v12_0}', "");
    Error('\p{Is_Present_In= :=+00000012.0}');
    Error('\P{Is_Present_In= :=+00000012.0}');
    Expect(1, 983040, '\p{Is_Present_In=000000012.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=000000012.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=000000012.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=000000012.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=000000012.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=000000012.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=000000012.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=000000012.0}', "");
    Error('\p{Is_In:	 /a/V12_0}');
    Error('\P{Is_In:	 /a/V12_0}');
    Expect(1, 983040, '\p{Is_In=v120}', "");
    Expect(0, 983040, '\p{^Is_In=v120}', "");
    Expect(0, 983040, '\P{Is_In=v120}', "");
    Expect(1, 983040, '\P{^Is_In=v120}', "");
    Expect(0, 983037, '\p{Is_In=v120}', "");
    Expect(1, 983037, '\p{^Is_In=v120}', "");
    Expect(1, 983037, '\P{Is_In=v120}', "");
    Expect(0, 983037, '\P{^Is_In=v120}', "");
    Expect(1, 983040, '\p{Is_In=_-V12_0}', "");
    Expect(0, 983040, '\p{^Is_In=_-V12_0}', "");
    Expect(0, 983040, '\P{Is_In=_-V12_0}', "");
    Expect(1, 983040, '\P{^Is_In=_-V12_0}', "");
    Expect(0, 983037, '\p{Is_In=_-V12_0}', "");
    Expect(1, 983037, '\p{^Is_In=_-V12_0}', "");
    Expect(1, 983037, '\P{Is_In=_-V12_0}', "");
    Expect(0, 983037, '\P{^Is_In=_-V12_0}', "");
    Error('\p{Present_In= _0_0_0_0_12.1:=}');
    Error('\P{Present_In= _0_0_0_0_12.1:=}');
    Expect(1, 983040, '\p{Present_In=:\A12.1\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A12.1\z:}', "");;
    Expect(1, 983040, '\p{Present_In=000_000_000_12.1}', "");
    Expect(0, 983040, '\p{^Present_In=000_000_000_12.1}', "");
    Expect(0, 983040, '\P{Present_In=000_000_000_12.1}', "");
    Expect(1, 983040, '\P{^Present_In=000_000_000_12.1}', "");
    Expect(0, 983037, '\p{Present_In=000_000_000_12.1}', "");
    Expect(1, 983037, '\p{^Present_In=000_000_000_12.1}', "");
    Expect(1, 983037, '\P{Present_In=000_000_000_12.1}', "");
    Expect(0, 983037, '\P{^Present_In=000_000_000_12.1}', "");
    Error('\p{In=-:=V12_1}');
    Error('\P{In=-:=V12_1}');
    Expect(1, 983040, '\p{In=:\AV12_1\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV12_1\z:}', "");;
    Expect(1, 983040, '\p{In=v121}', "");
    Expect(0, 983040, '\p{^In=v121}', "");
    Expect(0, 983040, '\P{In=v121}', "");
    Expect(1, 983040, '\P{^In=v121}', "");
    Expect(0, 983037, '\p{In=v121}', "");
    Expect(1, 983037, '\p{^In=v121}', "");
    Expect(1, 983037, '\P{In=v121}', "");
    Expect(0, 983037, '\P{^In=v121}', "");
    Expect(1, 983040, '\p{In=:\Av121\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av121\z:}', "");;
    Expect(1, 983040, '\p{In: V12_1}', "");
    Expect(0, 983040, '\p{^In: V12_1}', "");
    Expect(0, 983040, '\P{In: V12_1}', "");
    Expect(1, 983040, '\P{^In: V12_1}', "");
    Expect(0, 983037, '\p{In: V12_1}', "");
    Expect(1, 983037, '\p{^In: V12_1}', "");
    Expect(1, 983037, '\P{In: V12_1}', "");
    Expect(0, 983037, '\P{^In: V12_1}', "");
    Error('\p{Is_Present_In= /a/00_00_00_01_2.1}');
    Error('\P{Is_Present_In= /a/00_00_00_01_2.1}');
    Expect(1, 983040, '\p{Is_Present_In=0000012.1}', "");
    Expect(0, 983040, '\p{^Is_Present_In=0000012.1}', "");
    Expect(0, 983040, '\P{Is_Present_In=0000012.1}', "");
    Expect(1, 983040, '\P{^Is_Present_In=0000012.1}', "");
    Expect(0, 983037, '\p{Is_Present_In=0000012.1}', "");
    Expect(1, 983037, '\p{^Is_Present_In=0000012.1}', "");
    Expect(1, 983037, '\P{Is_Present_In=0000012.1}', "");
    Expect(0, 983037, '\P{^Is_Present_In=0000012.1}', "");
    Error('\p{Is_In=_-V12_1/a/}');
    Error('\P{Is_In=_-V12_1/a/}');
    Expect(1, 983040, '\p{Is_In=v121}', "");
    Expect(0, 983040, '\p{^Is_In=v121}', "");
    Expect(0, 983040, '\P{Is_In=v121}', "");
    Expect(1, 983040, '\P{^Is_In=v121}', "");
    Expect(0, 983037, '\p{Is_In=v121}', "");
    Expect(1, 983037, '\p{^Is_In=v121}', "");
    Expect(1, 983037, '\P{Is_In=v121}', "");
    Expect(0, 983037, '\P{^Is_In=v121}', "");
    Expect(1, 983040, '\p{Is_In= 	V12_1}', "");
    Expect(0, 983040, '\p{^Is_In= 	V12_1}', "");
    Expect(0, 983040, '\P{Is_In= 	V12_1}', "");
    Expect(1, 983040, '\P{^Is_In= 	V12_1}', "");
    Expect(0, 983037, '\p{Is_In= 	V12_1}', "");
    Expect(1, 983037, '\p{^Is_In= 	V12_1}', "");
    Expect(1, 983037, '\P{Is_In= 	V12_1}', "");
    Expect(0, 983037, '\P{^Is_In= 	V12_1}', "");
    Error('\p{Present_In= _00000002.0/a/}');
    Error('\P{Present_In= _00000002.0/a/}');
    Expect(1, 983040, '\p{Present_In=:\A2.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A2.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=+000002.0}', "");
    Expect(0, 983040, '\p{^Present_In=+000002.0}', "");
    Expect(0, 983040, '\P{Present_In=+000002.0}', "");
    Expect(1, 983040, '\P{^Present_In=+000002.0}', "");
    Expect(0, 983037, '\p{Present_In=+000002.0}', "");
    Expect(1, 983037, '\p{^Present_In=+000002.0}', "");
    Expect(1, 983037, '\P{Present_In=+000002.0}', "");
    Expect(0, 983037, '\P{^Present_In=+000002.0}', "");
    Error('\p{In=/a/ -V2_0}');
    Error('\P{In=/a/ -V2_0}');
    Expect(1, 983040, '\p{In=:\AV2_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV2_0\z:}', "");;
    Expect(1, 983040, '\p{In=v20}', "");
    Expect(0, 983040, '\p{^In=v20}', "");
    Expect(0, 983040, '\P{In=v20}', "");
    Expect(1, 983040, '\P{^In=v20}', "");
    Expect(0, 983037, '\p{In=v20}', "");
    Expect(1, 983037, '\p{^In=v20}', "");
    Expect(1, 983037, '\P{In=v20}', "");
    Expect(0, 983037, '\P{^In=v20}', "");
    Expect(1, 983040, '\p{In=:\Av20\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av20\z:}', "");;
    Expect(1, 983040, '\p{In=-V2_0}', "");
    Expect(0, 983040, '\p{^In=-V2_0}', "");
    Expect(0, 983040, '\P{In=-V2_0}', "");
    Expect(1, 983040, '\P{^In=-V2_0}', "");
    Expect(0, 983037, '\p{In=-V2_0}', "");
    Expect(1, 983037, '\p{^In=-V2_0}', "");
    Expect(1, 983037, '\P{In=-V2_0}', "");
    Expect(0, 983037, '\P{^In=-V2_0}', "");
    Error('\p{Is_Present_In=:= _+00000002.0}');
    Error('\P{Is_Present_In=:= _+00000002.0}');
    Expect(1, 983040, '\p{Is_Present_In=00002.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=00002.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=00002.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=00002.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=00002.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=00002.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=00002.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=00002.0}', "");
    Error('\p{Is_In=:=V2_0}');
    Error('\P{Is_In=:=V2_0}');
    Expect(1, 983040, '\p{Is_In=v20}', "");
    Expect(0, 983040, '\p{^Is_In=v20}', "");
    Expect(0, 983040, '\P{Is_In=v20}', "");
    Expect(1, 983040, '\P{^Is_In=v20}', "");
    Expect(0, 983037, '\p{Is_In=v20}', "");
    Expect(1, 983037, '\p{^Is_In=v20}', "");
    Expect(1, 983037, '\P{Is_In=v20}', "");
    Expect(0, 983037, '\P{^Is_In=v20}', "");
    Expect(1, 983040, '\p{Is_In=_V2_0}', "");
    Expect(0, 983040, '\p{^Is_In=_V2_0}', "");
    Expect(0, 983040, '\P{Is_In=_V2_0}', "");
    Expect(1, 983040, '\P{^Is_In=_V2_0}', "");
    Expect(0, 983037, '\p{Is_In=_V2_0}', "");
    Expect(1, 983037, '\p{^Is_In=_V2_0}', "");
    Expect(1, 983037, '\P{Is_In=_V2_0}', "");
    Expect(0, 983037, '\P{^Is_In=_V2_0}', "");
    Error('\p{Present_In:    /a/+00002.1}');
    Error('\P{Present_In:    /a/+00002.1}');
    Expect(1, 983040, '\p{Present_In=:\A2.1\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A2.1\z:}', "");;
    Expect(1, 983040, '\p{Present_In=002.1}', "");
    Expect(0, 983040, '\p{^Present_In=002.1}', "");
    Expect(0, 983040, '\P{Present_In=002.1}', "");
    Expect(1, 983040, '\P{^Present_In=002.1}', "");
    Expect(0, 983037, '\p{Present_In=002.1}', "");
    Expect(1, 983037, '\p{^Present_In=002.1}', "");
    Expect(1, 983037, '\P{Present_In=002.1}', "");
    Expect(0, 983037, '\P{^Present_In=002.1}', "");
    Error('\p{In=:=-v2_1}');
    Error('\P{In=:=-v2_1}');
    Expect(1, 983040, '\p{In=:\AV2_1\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV2_1\z:}', "");;
    Expect(1, 983040, '\p{In=v21}', "");
    Expect(0, 983040, '\p{^In=v21}', "");
    Expect(0, 983040, '\P{In=v21}', "");
    Expect(1, 983040, '\P{^In=v21}', "");
    Expect(0, 983037, '\p{In=v21}', "");
    Expect(1, 983037, '\p{^In=v21}', "");
    Expect(1, 983037, '\P{In=v21}', "");
    Expect(0, 983037, '\P{^In=v21}', "");
    Expect(1, 983040, '\p{In=:\Av21\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av21\z:}', "");;
    Expect(1, 983040, '\p{In:    V2_1}', "");
    Expect(0, 983040, '\p{^In:    V2_1}', "");
    Expect(0, 983040, '\P{In:    V2_1}', "");
    Expect(1, 983040, '\P{^In:    V2_1}', "");
    Expect(0, 983037, '\p{In:    V2_1}', "");
    Expect(1, 983037, '\p{^In:    V2_1}', "");
    Expect(1, 983037, '\P{In:    V2_1}', "");
    Expect(0, 983037, '\P{^In:    V2_1}', "");
    Error('\p{Is_Present_In=	:=2.1}');
    Error('\P{Is_Present_In=	:=2.1}');
    Expect(1, 983040, '\p{Is_Present_In=02.1}', "");
    Expect(0, 983040, '\p{^Is_Present_In=02.1}', "");
    Expect(0, 983040, '\P{Is_Present_In=02.1}', "");
    Expect(1, 983040, '\P{^Is_Present_In=02.1}', "");
    Expect(0, 983037, '\p{Is_Present_In=02.1}', "");
    Expect(1, 983037, '\p{^Is_Present_In=02.1}', "");
    Expect(1, 983037, '\P{Is_Present_In=02.1}', "");
    Expect(0, 983037, '\P{^Is_Present_In=02.1}', "");
    Error('\p{Is_In=_	v2_1:=}');
    Error('\P{Is_In=_	v2_1:=}');
    Expect(1, 983040, '\p{Is_In=v21}', "");
    Expect(0, 983040, '\p{^Is_In=v21}', "");
    Expect(0, 983040, '\P{Is_In=v21}', "");
    Expect(1, 983040, '\P{^Is_In=v21}', "");
    Expect(0, 983037, '\p{Is_In=v21}', "");
    Expect(1, 983037, '\p{^Is_In=v21}', "");
    Expect(1, 983037, '\P{Is_In=v21}', "");
    Expect(0, 983037, '\P{^Is_In=v21}', "");
    Expect(1, 983040, '\p{Is_In=-V2_1}', "");
    Expect(0, 983040, '\p{^Is_In=-V2_1}', "");
    Expect(0, 983040, '\P{Is_In=-V2_1}', "");
    Expect(1, 983040, '\P{^Is_In=-V2_1}', "");
    Expect(0, 983037, '\p{Is_In=-V2_1}', "");
    Expect(1, 983037, '\p{^Is_In=-V2_1}', "");
    Expect(1, 983037, '\P{Is_In=-V2_1}', "");
    Expect(0, 983037, '\P{^Is_In=-V2_1}', "");
    Error('\p{Present_In= _+0000000003.0/a/}');
    Error('\P{Present_In= _+0000000003.0/a/}');
    Expect(1, 983040, '\p{Present_In=:\A3.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A3.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=0_0_0_0_0_03.0}', "");
    Expect(0, 983040, '\p{^Present_In=0_0_0_0_0_03.0}', "");
    Expect(0, 983040, '\P{Present_In=0_0_0_0_0_03.0}', "");
    Expect(1, 983040, '\P{^Present_In=0_0_0_0_0_03.0}', "");
    Expect(0, 983037, '\p{Present_In=0_0_0_0_0_03.0}', "");
    Expect(1, 983037, '\p{^Present_In=0_0_0_0_0_03.0}', "");
    Expect(1, 983037, '\P{Present_In=0_0_0_0_0_03.0}', "");
    Expect(0, 983037, '\P{^Present_In=0_0_0_0_0_03.0}', "");
    Error('\p{In= _V3_0:=}');
    Error('\P{In= _V3_0:=}');
    Expect(1, 983040, '\p{In=:\AV3_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV3_0\z:}', "");;
    Expect(1, 983040, '\p{In=v30}', "");
    Expect(0, 983040, '\p{^In=v30}', "");
    Expect(0, 983040, '\P{In=v30}', "");
    Expect(1, 983040, '\P{^In=v30}', "");
    Expect(0, 983037, '\p{In=v30}', "");
    Expect(1, 983037, '\p{^In=v30}', "");
    Expect(1, 983037, '\P{In=v30}', "");
    Expect(0, 983037, '\P{^In=v30}', "");
    Expect(1, 983040, '\p{In=:\Av30\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av30\z:}', "");;
    Expect(1, 983040, '\p{In=-_V3_0}', "");
    Expect(0, 983040, '\p{^In=-_V3_0}', "");
    Expect(0, 983040, '\P{In=-_V3_0}', "");
    Expect(1, 983040, '\P{^In=-_V3_0}', "");
    Expect(0, 983037, '\p{In=-_V3_0}', "");
    Expect(1, 983037, '\p{^In=-_V3_0}', "");
    Expect(1, 983037, '\P{In=-_V3_0}', "");
    Expect(0, 983037, '\P{^In=-_V3_0}', "");
    Error('\p{Is_Present_In=__+0000000003.0:=}');
    Error('\P{Is_Present_In=__+0000000003.0:=}');
    Expect(1, 983040, '\p{Is_Present_In=3.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=3.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=3.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=3.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=3.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=3.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=3.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=3.0}', "");
    Error('\p{Is_In=:= V3_0}');
    Error('\P{Is_In=:= V3_0}');
    Expect(1, 983040, '\p{Is_In=v30}', "");
    Expect(0, 983040, '\p{^Is_In=v30}', "");
    Expect(0, 983040, '\P{Is_In=v30}', "");
    Expect(1, 983040, '\P{^Is_In=v30}', "");
    Expect(0, 983037, '\p{Is_In=v30}', "");
    Expect(1, 983037, '\p{^Is_In=v30}', "");
    Expect(1, 983037, '\P{Is_In=v30}', "");
    Expect(0, 983037, '\P{^Is_In=v30}', "");
    Expect(1, 983040, '\p{Is_In=-v3_0}', "");
    Expect(0, 983040, '\p{^Is_In=-v3_0}', "");
    Expect(0, 983040, '\P{Is_In=-v3_0}', "");
    Expect(1, 983040, '\P{^Is_In=-v3_0}', "");
    Expect(0, 983037, '\p{Is_In=-v3_0}', "");
    Expect(1, 983037, '\p{^Is_In=-v3_0}', "");
    Expect(1, 983037, '\P{Is_In=-v3_0}', "");
    Expect(0, 983037, '\P{^Is_In=-v3_0}', "");
    Error('\p{Present_In= 0_0_0_0_0_03.1:=}');
    Error('\P{Present_In= 0_0_0_0_0_03.1:=}');
    Expect(1, 983040, '\p{Present_In=:\A3.1\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A3.1\z:}', "");;
    Expect(1, 983040, '\p{Present_In=00_00_00_003.1}', "");
    Expect(0, 983040, '\p{^Present_In=00_00_00_003.1}', "");
    Expect(0, 983040, '\P{Present_In=00_00_00_003.1}', "");
    Expect(1, 983040, '\P{^Present_In=00_00_00_003.1}', "");
    Expect(0, 983037, '\p{Present_In=00_00_00_003.1}', "");
    Expect(1, 983037, '\p{^Present_In=00_00_00_003.1}', "");
    Expect(1, 983037, '\P{Present_In=00_00_00_003.1}', "");
    Expect(0, 983037, '\P{^Present_In=00_00_00_003.1}', "");
    Error('\p{In=-_V3_1:=}');
    Error('\P{In=-_V3_1:=}');
    Expect(1, 983040, '\p{In=:\AV3_1\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV3_1\z:}', "");;
    Expect(1, 983040, '\p{In=v31}', "");
    Expect(0, 983040, '\p{^In=v31}', "");
    Expect(0, 983040, '\P{In=v31}', "");
    Expect(1, 983040, '\P{^In=v31}', "");
    Expect(0, 983037, '\p{In=v31}', "");
    Expect(1, 983037, '\p{^In=v31}', "");
    Expect(1, 983037, '\P{In=v31}', "");
    Expect(0, 983037, '\P{^In=v31}', "");
    Expect(1, 983040, '\p{In=:\Av31\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av31\z:}', "");;
    Expect(1, 983040, '\p{In=  v3_1}', "");
    Expect(0, 983040, '\p{^In=  v3_1}', "");
    Expect(0, 983040, '\P{In=  v3_1}', "");
    Expect(1, 983040, '\P{^In=  v3_1}', "");
    Expect(0, 983037, '\p{In=  v3_1}', "");
    Expect(1, 983037, '\p{^In=  v3_1}', "");
    Expect(1, 983037, '\P{In=  v3_1}', "");
    Expect(0, 983037, '\P{^In=  v3_1}', "");
    Error('\p{Is_Present_In: -	+0000000003.1:=}');
    Error('\P{Is_Present_In: -	+0000000003.1:=}');
    Expect(1, 983040, '\p{Is_Present_In=00_3.1}', "");
    Expect(0, 983040, '\p{^Is_Present_In=00_3.1}', "");
    Expect(0, 983040, '\P{Is_Present_In=00_3.1}', "");
    Expect(1, 983040, '\P{^Is_Present_In=00_3.1}', "");
    Expect(0, 983037, '\p{Is_Present_In=00_3.1}', "");
    Expect(1, 983037, '\p{^Is_Present_In=00_3.1}', "");
    Expect(1, 983037, '\P{Is_Present_In=00_3.1}', "");
    Expect(0, 983037, '\P{^Is_Present_In=00_3.1}', "");
    Error('\p{Is_In=:=- V3_1}');
    Error('\P{Is_In=:=- V3_1}');
    Expect(1, 983040, '\p{Is_In=v31}', "");
    Expect(0, 983040, '\p{^Is_In=v31}', "");
    Expect(0, 983040, '\P{Is_In=v31}', "");
    Expect(1, 983040, '\P{^Is_In=v31}', "");
    Expect(0, 983037, '\p{Is_In=v31}', "");
    Expect(1, 983037, '\p{^Is_In=v31}', "");
    Expect(1, 983037, '\P{Is_In=v31}', "");
    Expect(0, 983037, '\P{^Is_In=v31}', "");
    Expect(1, 983040, '\p{Is_In=_-V3_1}', "");
    Expect(0, 983040, '\p{^Is_In=_-V3_1}', "");
    Expect(0, 983040, '\P{Is_In=_-V3_1}', "");
    Expect(1, 983040, '\P{^Is_In=_-V3_1}', "");
    Expect(0, 983037, '\p{Is_In=_-V3_1}', "");
    Expect(1, 983037, '\p{^Is_In=_-V3_1}', "");
    Expect(1, 983037, '\P{Is_In=_-V3_1}', "");
    Expect(0, 983037, '\P{^Is_In=_-V3_1}', "");
    Error('\p{Present_In= /a/0003.2}');
    Error('\P{Present_In= /a/0003.2}');
    Expect(1, 983040, '\p{Present_In=:\A3.2\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A3.2\z:}', "");;
    Expect(1, 983040, '\p{Present_In=3.2}', "");
    Expect(0, 983040, '\p{^Present_In=3.2}', "");
    Expect(0, 983040, '\P{Present_In=3.2}', "");
    Expect(1, 983040, '\P{^Present_In=3.2}', "");
    Expect(0, 983037, '\p{Present_In=3.2}', "");
    Expect(1, 983037, '\p{^Present_In=3.2}', "");
    Expect(1, 983037, '\P{Present_In=3.2}', "");
    Expect(0, 983037, '\P{^Present_In=3.2}', "");
    Error('\p{In=	:=V3_2}');
    Error('\P{In=	:=V3_2}');
    Expect(1, 983040, '\p{In=:\AV3_2\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV3_2\z:}', "");;
    Expect(1, 983040, '\p{In=v32}', "");
    Expect(0, 983040, '\p{^In=v32}', "");
    Expect(0, 983040, '\P{In=v32}', "");
    Expect(1, 983040, '\P{^In=v32}', "");
    Expect(0, 983037, '\p{In=v32}', "");
    Expect(1, 983037, '\p{^In=v32}', "");
    Expect(1, 983037, '\P{In=v32}', "");
    Expect(0, 983037, '\P{^In=v32}', "");
    Expect(1, 983040, '\p{In=:\Av32\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av32\z:}', "");;
    Expect(1, 983040, '\p{In=-_V3_2}', "");
    Expect(0, 983040, '\p{^In=-_V3_2}', "");
    Expect(0, 983040, '\P{In=-_V3_2}', "");
    Expect(1, 983040, '\P{^In=-_V3_2}', "");
    Expect(0, 983037, '\p{In=-_V3_2}', "");
    Expect(1, 983037, '\p{^In=-_V3_2}', "");
    Expect(1, 983037, '\P{In=-_V3_2}', "");
    Expect(0, 983037, '\P{^In=-_V3_2}', "");
    Error('\p{Is_Present_In= :=000003.2}');
    Error('\P{Is_Present_In= :=000003.2}');
    Expect(1, 983040, '\p{Is_Present_In=3.2}', "");
    Expect(0, 983040, '\p{^Is_Present_In=3.2}', "");
    Expect(0, 983040, '\P{Is_Present_In=3.2}', "");
    Expect(1, 983040, '\P{^Is_Present_In=3.2}', "");
    Expect(0, 983037, '\p{Is_Present_In=3.2}', "");
    Expect(1, 983037, '\p{^Is_Present_In=3.2}', "");
    Expect(1, 983037, '\P{Is_Present_In=3.2}', "");
    Expect(0, 983037, '\P{^Is_Present_In=3.2}', "");
    Error('\p{Is_In=-:=V3_2}');
    Error('\P{Is_In=-:=V3_2}');
    Expect(1, 983040, '\p{Is_In=v32}', "");
    Expect(0, 983040, '\p{^Is_In=v32}', "");
    Expect(0, 983040, '\P{Is_In=v32}', "");
    Expect(1, 983040, '\P{^Is_In=v32}', "");
    Expect(0, 983037, '\p{Is_In=v32}', "");
    Expect(1, 983037, '\p{^Is_In=v32}', "");
    Expect(1, 983037, '\P{Is_In=v32}', "");
    Expect(0, 983037, '\P{^Is_In=v32}', "");
    Expect(1, 983040, '\p{Is_In=_	V3_2}', "");
    Expect(0, 983040, '\p{^Is_In=_	V3_2}', "");
    Expect(0, 983040, '\P{Is_In=_	V3_2}', "");
    Expect(1, 983040, '\P{^Is_In=_	V3_2}', "");
    Expect(0, 983037, '\p{Is_In=_	V3_2}', "");
    Expect(1, 983037, '\p{^Is_In=_	V3_2}', "");
    Expect(1, 983037, '\P{Is_In=_	V3_2}', "");
    Expect(0, 983037, '\P{^Is_In=_	V3_2}', "");
    Error('\p{Present_In:   		000004.0:=}');
    Error('\P{Present_In:   		000004.0:=}');
    Expect(1, 983040, '\p{Present_In=:\A4.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A4.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=4.0}', "");
    Expect(0, 983040, '\p{^Present_In=4.0}', "");
    Expect(0, 983040, '\P{Present_In=4.0}', "");
    Expect(1, 983040, '\P{^Present_In=4.0}', "");
    Expect(0, 983037, '\p{Present_In=4.0}', "");
    Expect(1, 983037, '\p{^Present_In=4.0}', "");
    Expect(1, 983037, '\P{Present_In=4.0}', "");
    Expect(0, 983037, '\P{^Present_In=4.0}', "");
    Error('\p{In=/a/_	v4_0}');
    Error('\P{In=/a/_	v4_0}');
    Expect(1, 983040, '\p{In=:\AV4_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV4_0\z:}', "");;
    Expect(1, 983040, '\p{In:	v40}', "");
    Expect(0, 983040, '\p{^In:	v40}', "");
    Expect(0, 983040, '\P{In:	v40}', "");
    Expect(1, 983040, '\P{^In:	v40}', "");
    Expect(0, 983037, '\p{In:	v40}', "");
    Expect(1, 983037, '\p{^In:	v40}', "");
    Expect(1, 983037, '\P{In:	v40}', "");
    Expect(0, 983037, '\P{^In:	v40}', "");
    Expect(1, 983040, '\p{In=:\Av40\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av40\z:}', "");;
    Expect(1, 983040, '\p{In=-V4_0}', "");
    Expect(0, 983040, '\p{^In=-V4_0}', "");
    Expect(0, 983040, '\P{In=-V4_0}', "");
    Expect(1, 983040, '\P{^In=-V4_0}', "");
    Expect(0, 983037, '\p{In=-V4_0}', "");
    Expect(1, 983037, '\p{^In=-V4_0}', "");
    Expect(1, 983037, '\P{In=-V4_0}', "");
    Expect(0, 983037, '\P{^In=-V4_0}', "");
    Error('\p{Is_Present_In=_-004.0:=}');
    Error('\P{Is_Present_In=_-004.0:=}');
    Expect(1, 983040, '\p{Is_Present_In=+0_0_0_0_0_0_004.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=+0_0_0_0_0_0_004.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=+0_0_0_0_0_0_004.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=+0_0_0_0_0_0_004.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=+0_0_0_0_0_0_004.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=+0_0_0_0_0_0_004.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=+0_0_0_0_0_0_004.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=+0_0_0_0_0_0_004.0}', "");
    Error('\p{Is_In: V4_0:=}');
    Error('\P{Is_In: V4_0:=}');
    Expect(1, 983040, '\p{Is_In:	v40}', "");
    Expect(0, 983040, '\p{^Is_In:	v40}', "");
    Expect(0, 983040, '\P{Is_In:	v40}', "");
    Expect(1, 983040, '\P{^Is_In:	v40}', "");
    Expect(0, 983037, '\p{Is_In:	v40}', "");
    Expect(1, 983037, '\p{^Is_In:	v40}', "");
    Expect(1, 983037, '\P{Is_In:	v40}', "");
    Expect(0, 983037, '\P{^Is_In:	v40}', "");
    Expect(1, 983040, '\p{Is_In=-V4_0}', "");
    Expect(0, 983040, '\p{^Is_In=-V4_0}', "");
    Expect(0, 983040, '\P{Is_In=-V4_0}', "");
    Expect(1, 983040, '\P{^Is_In=-V4_0}', "");
    Expect(0, 983037, '\p{Is_In=-V4_0}', "");
    Expect(1, 983037, '\p{^Is_In=-V4_0}', "");
    Expect(1, 983037, '\P{Is_In=-V4_0}', "");
    Expect(0, 983037, '\P{^Is_In=-V4_0}', "");
    Error('\p{Present_In=_	+000004.1/a/}');
    Error('\P{Present_In=_	+000004.1/a/}');
    Expect(1, 983040, '\p{Present_In=:\A4.1\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A4.1\z:}', "");;
    Expect(1, 983040, '\p{Present_In=0_4.1}', "");
    Expect(0, 983040, '\p{^Present_In=0_4.1}', "");
    Expect(0, 983040, '\P{Present_In=0_4.1}', "");
    Expect(1, 983040, '\P{^Present_In=0_4.1}', "");
    Expect(0, 983037, '\p{Present_In=0_4.1}', "");
    Expect(1, 983037, '\p{^Present_In=0_4.1}', "");
    Expect(1, 983037, '\P{Present_In=0_4.1}', "");
    Expect(0, 983037, '\P{^Present_In=0_4.1}', "");
    Error('\p{In=_/a/v4_1}');
    Error('\P{In=_/a/v4_1}');
    Expect(1, 983040, '\p{In=:\AV4_1\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV4_1\z:}', "");;
    Expect(1, 983040, '\p{In:   v41}', "");
    Expect(0, 983040, '\p{^In:   v41}', "");
    Expect(0, 983040, '\P{In:   v41}', "");
    Expect(1, 983040, '\P{^In:   v41}', "");
    Expect(0, 983037, '\p{In:   v41}', "");
    Expect(1, 983037, '\p{^In:   v41}', "");
    Expect(1, 983037, '\P{In:   v41}', "");
    Expect(0, 983037, '\P{^In:   v41}', "");
    Expect(1, 983040, '\p{In=:\Av41\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av41\z:}', "");;
    Expect(1, 983040, '\p{In:	 	V4_1}', "");
    Expect(0, 983040, '\p{^In:	 	V4_1}', "");
    Expect(0, 983040, '\P{In:	 	V4_1}', "");
    Expect(1, 983040, '\P{^In:	 	V4_1}', "");
    Expect(0, 983037, '\p{In:	 	V4_1}', "");
    Expect(1, 983037, '\p{^In:	 	V4_1}', "");
    Expect(1, 983037, '\P{In:	 	V4_1}', "");
    Expect(0, 983037, '\P{^In:	 	V4_1}', "");
    Error('\p{Is_Present_In=	04.1/a/}');
    Error('\P{Is_Present_In=	04.1/a/}');
    Expect(1, 983040, '\p{Is_Present_In=+0000004.1}', "");
    Expect(0, 983040, '\p{^Is_Present_In=+0000004.1}', "");
    Expect(0, 983040, '\P{Is_Present_In=+0000004.1}', "");
    Expect(1, 983040, '\P{^Is_Present_In=+0000004.1}', "");
    Expect(0, 983037, '\p{Is_Present_In=+0000004.1}', "");
    Expect(1, 983037, '\p{^Is_Present_In=+0000004.1}', "");
    Expect(1, 983037, '\P{Is_Present_In=+0000004.1}', "");
    Expect(0, 983037, '\P{^Is_Present_In=+0000004.1}', "");
    Error('\p{Is_In=/a/V4_1}');
    Error('\P{Is_In=/a/V4_1}');
    Expect(1, 983040, '\p{Is_In=v41}', "");
    Expect(0, 983040, '\p{^Is_In=v41}', "");
    Expect(0, 983040, '\P{Is_In=v41}', "");
    Expect(1, 983040, '\P{^Is_In=v41}', "");
    Expect(0, 983037, '\p{Is_In=v41}', "");
    Expect(1, 983037, '\p{^Is_In=v41}', "");
    Expect(1, 983037, '\P{Is_In=v41}', "");
    Expect(0, 983037, '\P{^Is_In=v41}', "");
    Expect(1, 983040, '\p{Is_In= _V4_1}', "");
    Expect(0, 983040, '\p{^Is_In= _V4_1}', "");
    Expect(0, 983040, '\P{Is_In= _V4_1}', "");
    Expect(1, 983040, '\P{^Is_In= _V4_1}', "");
    Expect(0, 983037, '\p{Is_In= _V4_1}', "");
    Expect(1, 983037, '\p{^Is_In= _V4_1}', "");
    Expect(1, 983037, '\P{Is_In= _V4_1}', "");
    Expect(0, 983037, '\P{^Is_In= _V4_1}', "");
    Error('\p{Present_In=:=	-0000_5.0}');
    Error('\P{Present_In=:=	-0000_5.0}');
    Expect(1, 983040, '\p{Present_In=:\A5.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A5.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=+0_5.0}', "");
    Expect(0, 983040, '\p{^Present_In=+0_5.0}', "");
    Expect(0, 983040, '\P{Present_In=+0_5.0}', "");
    Expect(1, 983040, '\P{^Present_In=+0_5.0}', "");
    Expect(0, 983037, '\p{Present_In=+0_5.0}', "");
    Expect(1, 983037, '\p{^Present_In=+0_5.0}', "");
    Expect(1, 983037, '\P{Present_In=+0_5.0}', "");
    Expect(0, 983037, '\P{^Present_In=+0_5.0}', "");
    Error('\p{In=_/a/V5_0}');
    Error('\P{In=_/a/V5_0}');
    Expect(1, 983040, '\p{In=:\AV5_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV5_0\z:}', "");;
    Expect(1, 983040, '\p{In=v50}', "");
    Expect(0, 983040, '\p{^In=v50}', "");
    Expect(0, 983040, '\P{In=v50}', "");
    Expect(1, 983040, '\P{^In=v50}', "");
    Expect(0, 983037, '\p{In=v50}', "");
    Expect(1, 983037, '\p{^In=v50}', "");
    Expect(1, 983037, '\P{In=v50}', "");
    Expect(0, 983037, '\P{^In=v50}', "");
    Expect(1, 983040, '\p{In=:\Av50\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av50\z:}', "");;
    Expect(1, 983040, '\p{In=-_v5_0}', "");
    Expect(0, 983040, '\p{^In=-_v5_0}', "");
    Expect(0, 983040, '\P{In=-_v5_0}', "");
    Expect(1, 983040, '\P{^In=-_v5_0}', "");
    Expect(0, 983037, '\p{In=-_v5_0}', "");
    Expect(1, 983037, '\p{^In=-_v5_0}', "");
    Expect(1, 983037, '\P{In=-_v5_0}', "");
    Expect(0, 983037, '\P{^In=-_v5_0}', "");
    Error('\p{Is_Present_In=:=-_5.0}');
    Error('\P{Is_Present_In=:=-_5.0}');
    Expect(1, 983040, '\p{Is_Present_In:   0_0_0_0_05.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In:   0_0_0_0_05.0}', "");
    Expect(0, 983040, '\P{Is_Present_In:   0_0_0_0_05.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In:   0_0_0_0_05.0}', "");
    Expect(0, 983037, '\p{Is_Present_In:   0_0_0_0_05.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In:   0_0_0_0_05.0}', "");
    Expect(1, 983037, '\P{Is_Present_In:   0_0_0_0_05.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In:   0_0_0_0_05.0}', "");
    Error('\p{Is_In=-:=V5_0}');
    Error('\P{Is_In=-:=V5_0}');
    Expect(1, 983040, '\p{Is_In=v50}', "");
    Expect(0, 983040, '\p{^Is_In=v50}', "");
    Expect(0, 983040, '\P{Is_In=v50}', "");
    Expect(1, 983040, '\P{^Is_In=v50}', "");
    Expect(0, 983037, '\p{Is_In=v50}', "");
    Expect(1, 983037, '\p{^Is_In=v50}', "");
    Expect(1, 983037, '\P{Is_In=v50}', "");
    Expect(0, 983037, '\P{^Is_In=v50}', "");
    Expect(1, 983040, '\p{Is_In= V5_0}', "");
    Expect(0, 983040, '\p{^Is_In= V5_0}', "");
    Expect(0, 983040, '\P{Is_In= V5_0}', "");
    Expect(1, 983040, '\P{^Is_In= V5_0}', "");
    Expect(0, 983037, '\p{Is_In= V5_0}', "");
    Expect(1, 983037, '\p{^Is_In= V5_0}', "");
    Expect(1, 983037, '\P{Is_In= V5_0}', "");
    Expect(0, 983037, '\P{^Is_In= V5_0}', "");
    Error('\p{Present_In=/a/- 05.1}');
    Error('\P{Present_In=/a/- 05.1}');
    Expect(1, 983040, '\p{Present_In=:\A5.1\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A5.1\z:}', "");;
    Expect(1, 983040, '\p{Present_In=00005.1}', "");
    Expect(0, 983040, '\p{^Present_In=00005.1}', "");
    Expect(0, 983040, '\P{Present_In=00005.1}', "");
    Expect(1, 983040, '\P{^Present_In=00005.1}', "");
    Expect(0, 983037, '\p{Present_In=00005.1}', "");
    Expect(1, 983037, '\p{^Present_In=00005.1}', "");
    Expect(1, 983037, '\P{Present_In=00005.1}', "");
    Expect(0, 983037, '\P{^Present_In=00005.1}', "");
    Error('\p{In: :=-V5_1}');
    Error('\P{In: :=-V5_1}');
    Expect(1, 983040, '\p{In=:\AV5_1\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV5_1\z:}', "");;
    Expect(1, 983040, '\p{In=v51}', "");
    Expect(0, 983040, '\p{^In=v51}', "");
    Expect(0, 983040, '\P{In=v51}', "");
    Expect(1, 983040, '\P{^In=v51}', "");
    Expect(0, 983037, '\p{In=v51}', "");
    Expect(1, 983037, '\p{^In=v51}', "");
    Expect(1, 983037, '\P{In=v51}', "");
    Expect(0, 983037, '\P{^In=v51}', "");
    Expect(1, 983040, '\p{In=:\Av51\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av51\z:}', "");;
    Expect(1, 983040, '\p{In=_	V5_1}', "");
    Expect(0, 983040, '\p{^In=_	V5_1}', "");
    Expect(0, 983040, '\P{In=_	V5_1}', "");
    Expect(1, 983040, '\P{^In=_	V5_1}', "");
    Expect(0, 983037, '\p{In=_	V5_1}', "");
    Expect(1, 983037, '\p{^In=_	V5_1}', "");
    Expect(1, 983037, '\P{In=_	V5_1}', "");
    Expect(0, 983037, '\P{^In=_	V5_1}', "");
    Error('\p{Is_Present_In=/a/_05.1}');
    Error('\P{Is_Present_In=/a/_05.1}');
    Expect(1, 983040, '\p{Is_Present_In=0_0_0_0_0_00005.1}', "");
    Expect(0, 983040, '\p{^Is_Present_In=0_0_0_0_0_00005.1}', "");
    Expect(0, 983040, '\P{Is_Present_In=0_0_0_0_0_00005.1}', "");
    Expect(1, 983040, '\P{^Is_Present_In=0_0_0_0_0_00005.1}', "");
    Expect(0, 983037, '\p{Is_Present_In=0_0_0_0_0_00005.1}', "");
    Expect(1, 983037, '\p{^Is_Present_In=0_0_0_0_0_00005.1}', "");
    Expect(1, 983037, '\P{Is_Present_In=0_0_0_0_0_00005.1}', "");
    Expect(0, 983037, '\P{^Is_Present_In=0_0_0_0_0_00005.1}', "");
    Error('\p{Is_In=/a/-v5_1}');
    Error('\P{Is_In=/a/-v5_1}');
    Expect(1, 983040, '\p{Is_In=v51}', "");
    Expect(0, 983040, '\p{^Is_In=v51}', "");
    Expect(0, 983040, '\P{Is_In=v51}', "");
    Expect(1, 983040, '\P{^Is_In=v51}', "");
    Expect(0, 983037, '\p{Is_In=v51}', "");
    Expect(1, 983037, '\p{^Is_In=v51}', "");
    Expect(1, 983037, '\P{Is_In=v51}', "");
    Expect(0, 983037, '\P{^Is_In=v51}', "");
    Expect(1, 983040, '\p{Is_In=-v5_1}', "");
    Expect(0, 983040, '\p{^Is_In=-v5_1}', "");
    Expect(0, 983040, '\P{Is_In=-v5_1}', "");
    Expect(1, 983040, '\P{^Is_In=-v5_1}', "");
    Expect(0, 983037, '\p{Is_In=-v5_1}', "");
    Expect(1, 983037, '\p{^Is_In=-v5_1}', "");
    Expect(1, 983037, '\P{Is_In=-v5_1}', "");
    Expect(0, 983037, '\P{^Is_In=-v5_1}', "");
    Error('\p{Present_In=	0_5.2/a/}');
    Error('\P{Present_In=	0_5.2/a/}');
    Expect(1, 983040, '\p{Present_In=:\A5.2\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A5.2\z:}', "");;
    Expect(1, 983040, '\p{Present_In=00005.2}', "");
    Expect(0, 983040, '\p{^Present_In=00005.2}', "");
    Expect(0, 983040, '\P{Present_In=00005.2}', "");
    Expect(1, 983040, '\P{^Present_In=00005.2}', "");
    Expect(0, 983037, '\p{Present_In=00005.2}', "");
    Expect(1, 983037, '\p{^Present_In=00005.2}', "");
    Expect(1, 983037, '\P{Present_In=00005.2}', "");
    Expect(0, 983037, '\P{^Present_In=00005.2}', "");
    Error('\p{In=:=	_V5_2}');
    Error('\P{In=:=	_V5_2}');
    Expect(1, 983040, '\p{In=:\AV5_2\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV5_2\z:}', "");;
    Expect(1, 983040, '\p{In=v52}', "");
    Expect(0, 983040, '\p{^In=v52}', "");
    Expect(0, 983040, '\P{In=v52}', "");
    Expect(1, 983040, '\P{^In=v52}', "");
    Expect(0, 983037, '\p{In=v52}', "");
    Expect(1, 983037, '\p{^In=v52}', "");
    Expect(1, 983037, '\P{In=v52}', "");
    Expect(0, 983037, '\P{^In=v52}', "");
    Expect(1, 983040, '\p{In=:\Av52\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av52\z:}', "");;
    Expect(1, 983040, '\p{In=v5_2}', "");
    Expect(0, 983040, '\p{^In=v5_2}', "");
    Expect(0, 983040, '\P{In=v5_2}', "");
    Expect(1, 983040, '\P{^In=v5_2}', "");
    Expect(0, 983037, '\p{In=v5_2}', "");
    Expect(1, 983037, '\p{^In=v5_2}', "");
    Expect(1, 983037, '\P{In=v5_2}', "");
    Expect(0, 983037, '\P{^In=v5_2}', "");
    Error('\p{Is_Present_In= :=05.2}');
    Error('\P{Is_Present_In= :=05.2}');
    Expect(1, 983040, '\p{Is_Present_In=+00000005.2}', "");
    Expect(0, 983040, '\p{^Is_Present_In=+00000005.2}', "");
    Expect(0, 983040, '\P{Is_Present_In=+00000005.2}', "");
    Expect(1, 983040, '\P{^Is_Present_In=+00000005.2}', "");
    Expect(0, 983037, '\p{Is_Present_In=+00000005.2}', "");
    Expect(1, 983037, '\p{^Is_Present_In=+00000005.2}', "");
    Expect(1, 983037, '\P{Is_Present_In=+00000005.2}', "");
    Expect(0, 983037, '\P{^Is_Present_In=+00000005.2}', "");
    Error('\p{Is_In=/a/	_V5_2}');
    Error('\P{Is_In=/a/	_V5_2}');
    Expect(1, 983040, '\p{Is_In=v52}', "");
    Expect(0, 983040, '\p{^Is_In=v52}', "");
    Expect(0, 983040, '\P{Is_In=v52}', "");
    Expect(1, 983040, '\P{^Is_In=v52}', "");
    Expect(0, 983037, '\p{Is_In=v52}', "");
    Expect(1, 983037, '\p{^Is_In=v52}', "");
    Expect(1, 983037, '\P{Is_In=v52}', "");
    Expect(0, 983037, '\P{^Is_In=v52}', "");
    Expect(1, 983040, '\p{Is_In=--V5_2}', "");
    Expect(0, 983040, '\p{^Is_In=--V5_2}', "");
    Expect(0, 983040, '\P{Is_In=--V5_2}', "");
    Expect(1, 983040, '\P{^Is_In=--V5_2}', "");
    Expect(0, 983037, '\p{Is_In=--V5_2}', "");
    Expect(1, 983037, '\p{^Is_In=--V5_2}', "");
    Expect(1, 983037, '\P{Is_In=--V5_2}', "");
    Expect(0, 983037, '\P{^Is_In=--V5_2}', "");
    Error('\p{Present_In=-/a/0000000006.0}');
    Error('\P{Present_In=-/a/0000000006.0}');
    Expect(1, 983040, '\p{Present_In=:\A6.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A6.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=+0006.0}', "");
    Expect(0, 983040, '\p{^Present_In=+0006.0}', "");
    Expect(0, 983040, '\P{Present_In=+0006.0}', "");
    Expect(1, 983040, '\P{^Present_In=+0006.0}', "");
    Expect(0, 983037, '\p{Present_In=+0006.0}', "");
    Expect(1, 983037, '\p{^Present_In=+0006.0}', "");
    Expect(1, 983037, '\P{Present_In=+0006.0}', "");
    Expect(0, 983037, '\P{^Present_In=+0006.0}', "");
    Error('\p{In=-:=v6_0}');
    Error('\P{In=-:=v6_0}');
    Expect(1, 983040, '\p{In=:\AV6_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV6_0\z:}', "");;
    Expect(1, 983040, '\p{In=v60}', "");
    Expect(0, 983040, '\p{^In=v60}', "");
    Expect(0, 983040, '\P{In=v60}', "");
    Expect(1, 983040, '\P{^In=v60}', "");
    Expect(0, 983037, '\p{In=v60}', "");
    Expect(1, 983037, '\p{^In=v60}', "");
    Expect(1, 983037, '\P{In=v60}', "");
    Expect(0, 983037, '\P{^In=v60}', "");
    Expect(1, 983040, '\p{In=:\Av60\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av60\z:}', "");;
    Expect(1, 983040, '\p{In= 	V6_0}', "");
    Expect(0, 983040, '\p{^In= 	V6_0}', "");
    Expect(0, 983040, '\P{In= 	V6_0}', "");
    Expect(1, 983040, '\P{^In= 	V6_0}', "");
    Expect(0, 983037, '\p{In= 	V6_0}', "");
    Expect(1, 983037, '\p{^In= 	V6_0}', "");
    Expect(1, 983037, '\P{In= 	V6_0}', "");
    Expect(0, 983037, '\P{^In= 	V6_0}', "");
    Error('\p{Is_Present_In=/a/ _06.0}');
    Error('\P{Is_Present_In=/a/ _06.0}');
    Expect(1, 983040, '\p{Is_Present_In=+006.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=+006.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=+006.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=+006.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=+006.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=+006.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=+006.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=+006.0}', "");
    Error('\p{Is_In=-/a/V6_0}');
    Error('\P{Is_In=-/a/V6_0}');
    Expect(1, 983040, '\p{Is_In=v60}', "");
    Expect(0, 983040, '\p{^Is_In=v60}', "");
    Expect(0, 983040, '\P{Is_In=v60}', "");
    Expect(1, 983040, '\P{^Is_In=v60}', "");
    Expect(0, 983037, '\p{Is_In=v60}', "");
    Expect(1, 983037, '\p{^Is_In=v60}', "");
    Expect(1, 983037, '\P{Is_In=v60}', "");
    Expect(0, 983037, '\P{^Is_In=v60}', "");
    Expect(1, 983040, '\p{Is_In=_	v6_0}', "");
    Expect(0, 983040, '\p{^Is_In=_	v6_0}', "");
    Expect(0, 983040, '\P{Is_In=_	v6_0}', "");
    Expect(1, 983040, '\P{^Is_In=_	v6_0}', "");
    Expect(0, 983037, '\p{Is_In=_	v6_0}', "");
    Expect(1, 983037, '\p{^Is_In=_	v6_0}', "");
    Expect(1, 983037, '\P{Is_In=_	v6_0}', "");
    Expect(0, 983037, '\P{^Is_In=_	v6_0}', "");
    Error('\p{Present_In=:=_+006.1}');
    Error('\P{Present_In=:=_+006.1}');
    Expect(1, 983040, '\p{Present_In=:\A6.1\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A6.1\z:}', "");;
    Expect(1, 983040, '\p{Present_In=00006.1}', "");
    Expect(0, 983040, '\p{^Present_In=00006.1}', "");
    Expect(0, 983040, '\P{Present_In=00006.1}', "");
    Expect(1, 983040, '\P{^Present_In=00006.1}', "");
    Expect(0, 983037, '\p{Present_In=00006.1}', "");
    Expect(1, 983037, '\p{^Present_In=00006.1}', "");
    Expect(1, 983037, '\P{Present_In=00006.1}', "");
    Expect(0, 983037, '\P{^Present_In=00006.1}', "");
    Error('\p{In=:= 	V6_1}');
    Error('\P{In=:= 	V6_1}');
    Expect(1, 983040, '\p{In=:\AV6_1\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV6_1\z:}', "");;
    Expect(1, 983040, '\p{In=v61}', "");
    Expect(0, 983040, '\p{^In=v61}', "");
    Expect(0, 983040, '\P{In=v61}', "");
    Expect(1, 983040, '\P{^In=v61}', "");
    Expect(0, 983037, '\p{In=v61}', "");
    Expect(1, 983037, '\p{^In=v61}', "");
    Expect(1, 983037, '\P{In=v61}', "");
    Expect(0, 983037, '\P{^In=v61}', "");
    Expect(1, 983040, '\p{In=:\Av61\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av61\z:}', "");;
    Expect(1, 983040, '\p{In= V6_1}', "");
    Expect(0, 983040, '\p{^In= V6_1}', "");
    Expect(0, 983040, '\P{In= V6_1}', "");
    Expect(1, 983040, '\P{^In= V6_1}', "");
    Expect(0, 983037, '\p{In= V6_1}', "");
    Expect(1, 983037, '\p{^In= V6_1}', "");
    Expect(1, 983037, '\P{In= V6_1}', "");
    Expect(0, 983037, '\P{^In= V6_1}', "");
    Error('\p{Is_Present_In=_:=6.1}');
    Error('\P{Is_Present_In=_:=6.1}');
    Expect(1, 983040, '\p{Is_Present_In=+00_6.1}', "");
    Expect(0, 983040, '\p{^Is_Present_In=+00_6.1}', "");
    Expect(0, 983040, '\P{Is_Present_In=+00_6.1}', "");
    Expect(1, 983040, '\P{^Is_Present_In=+00_6.1}', "");
    Expect(0, 983037, '\p{Is_Present_In=+00_6.1}', "");
    Expect(1, 983037, '\p{^Is_Present_In=+00_6.1}', "");
    Expect(1, 983037, '\P{Is_Present_In=+00_6.1}', "");
    Expect(0, 983037, '\P{^Is_Present_In=+00_6.1}', "");
    Error('\p{Is_In:	:=V6_1}');
    Error('\P{Is_In:	:=V6_1}');
    Expect(1, 983040, '\p{Is_In=v61}', "");
    Expect(0, 983040, '\p{^Is_In=v61}', "");
    Expect(0, 983040, '\P{Is_In=v61}', "");
    Expect(1, 983040, '\P{^Is_In=v61}', "");
    Expect(0, 983037, '\p{Is_In=v61}', "");
    Expect(1, 983037, '\p{^Is_In=v61}', "");
    Expect(1, 983037, '\P{Is_In=v61}', "");
    Expect(0, 983037, '\P{^Is_In=v61}', "");
    Expect(1, 983040, '\p{Is_In= -V6_1}', "");
    Expect(0, 983040, '\p{^Is_In= -V6_1}', "");
    Expect(0, 983040, '\P{Is_In= -V6_1}', "");
    Expect(1, 983040, '\P{^Is_In= -V6_1}', "");
    Expect(0, 983037, '\p{Is_In= -V6_1}', "");
    Expect(1, 983037, '\p{^Is_In= -V6_1}', "");
    Expect(1, 983037, '\P{Is_In= -V6_1}', "");
    Expect(0, 983037, '\P{^Is_In= -V6_1}', "");
    Error('\p{Present_In=-00006.2/a/}');
    Error('\P{Present_In=-00006.2/a/}');
    Expect(1, 983040, '\p{Present_In=:\A6.2\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A6.2\z:}', "");;
    Expect(1, 983040, '\p{Present_In=0000000006.2}', "");
    Expect(0, 983040, '\p{^Present_In=0000000006.2}', "");
    Expect(0, 983040, '\P{Present_In=0000000006.2}', "");
    Expect(1, 983040, '\P{^Present_In=0000000006.2}', "");
    Expect(0, 983037, '\p{Present_In=0000000006.2}', "");
    Expect(1, 983037, '\p{^Present_In=0000000006.2}', "");
    Expect(1, 983037, '\P{Present_In=0000000006.2}', "");
    Expect(0, 983037, '\P{^Present_In=0000000006.2}', "");
    Error('\p{In= -V6_2/a/}');
    Error('\P{In= -V6_2/a/}');
    Expect(1, 983040, '\p{In=:\AV6_2\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV6_2\z:}', "");;
    Expect(1, 983040, '\p{In:   v62}', "");
    Expect(0, 983040, '\p{^In:   v62}', "");
    Expect(0, 983040, '\P{In:   v62}', "");
    Expect(1, 983040, '\P{^In:   v62}', "");
    Expect(0, 983037, '\p{In:   v62}', "");
    Expect(1, 983037, '\p{^In:   v62}', "");
    Expect(1, 983037, '\P{In:   v62}', "");
    Expect(0, 983037, '\P{^In:   v62}', "");
    Expect(1, 983040, '\p{In=:\Av62\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av62\z:}', "");;
    Expect(1, 983040, '\p{In=_ V6_2}', "");
    Expect(0, 983040, '\p{^In=_ V6_2}', "");
    Expect(0, 983040, '\P{In=_ V6_2}', "");
    Expect(1, 983040, '\P{^In=_ V6_2}', "");
    Expect(0, 983037, '\p{In=_ V6_2}', "");
    Expect(1, 983037, '\p{^In=_ V6_2}', "");
    Expect(1, 983037, '\P{In=_ V6_2}', "");
    Expect(0, 983037, '\P{^In=_ V6_2}', "");
    Error('\p{Is_Present_In=/a/ _0000000_6.2}');
    Error('\P{Is_Present_In=/a/ _0000000_6.2}');
    Expect(1, 983040, '\p{Is_Present_In=006.2}', "");
    Expect(0, 983040, '\p{^Is_Present_In=006.2}', "");
    Expect(0, 983040, '\P{Is_Present_In=006.2}', "");
    Expect(1, 983040, '\P{^Is_Present_In=006.2}', "");
    Expect(0, 983037, '\p{Is_Present_In=006.2}', "");
    Expect(1, 983037, '\p{^Is_Present_In=006.2}', "");
    Expect(1, 983037, '\P{Is_Present_In=006.2}', "");
    Expect(0, 983037, '\P{^Is_Present_In=006.2}', "");
    Error('\p{Is_In=/a/-_V6_2}');
    Error('\P{Is_In=/a/-_V6_2}');
    Expect(1, 983040, '\p{Is_In=v62}', "");
    Expect(0, 983040, '\p{^Is_In=v62}', "");
    Expect(0, 983040, '\P{Is_In=v62}', "");
    Expect(1, 983040, '\P{^Is_In=v62}', "");
    Expect(0, 983037, '\p{Is_In=v62}', "");
    Expect(1, 983037, '\p{^Is_In=v62}', "");
    Expect(1, 983037, '\P{Is_In=v62}', "");
    Expect(0, 983037, '\P{^Is_In=v62}', "");
    Expect(1, 983040, '\p{Is_In:  _V6_2}', "");
    Expect(0, 983040, '\p{^Is_In:  _V6_2}', "");
    Expect(0, 983040, '\P{Is_In:  _V6_2}', "");
    Expect(1, 983040, '\P{^Is_In:  _V6_2}', "");
    Expect(0, 983037, '\p{Is_In:  _V6_2}', "");
    Expect(1, 983037, '\p{^Is_In:  _V6_2}', "");
    Expect(1, 983037, '\P{Is_In:  _V6_2}', "");
    Expect(0, 983037, '\P{^Is_In:  _V6_2}', "");
    Error('\p{Present_In=/a/		+00000006.3}');
    Error('\P{Present_In=/a/		+00000006.3}');
    Expect(1, 983040, '\p{Present_In=:\A6.3\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A6.3\z:}', "");;
    Expect(1, 983040, '\p{Present_In:	+00_00_6.3}', "");
    Expect(0, 983040, '\p{^Present_In:	+00_00_6.3}', "");
    Expect(0, 983040, '\P{Present_In:	+00_00_6.3}', "");
    Expect(1, 983040, '\P{^Present_In:	+00_00_6.3}', "");
    Expect(0, 983037, '\p{Present_In:	+00_00_6.3}', "");
    Expect(1, 983037, '\p{^Present_In:	+00_00_6.3}', "");
    Expect(1, 983037, '\P{Present_In:	+00_00_6.3}', "");
    Expect(0, 983037, '\P{^Present_In:	+00_00_6.3}', "");
    Error('\p{In=V6_3:=}');
    Error('\P{In=V6_3:=}');
    Expect(1, 983040, '\p{In=:\AV6_3\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV6_3\z:}', "");;
    Expect(1, 983040, '\p{In=v63}', "");
    Expect(0, 983040, '\p{^In=v63}', "");
    Expect(0, 983040, '\P{In=v63}', "");
    Expect(1, 983040, '\P{^In=v63}', "");
    Expect(0, 983037, '\p{In=v63}', "");
    Expect(1, 983037, '\p{^In=v63}', "");
    Expect(1, 983037, '\P{In=v63}', "");
    Expect(0, 983037, '\P{^In=v63}', "");
    Expect(1, 983040, '\p{In=:\Av63\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av63\z:}', "");;
    Expect(1, 983040, '\p{In:    _V6_3}', "");
    Expect(0, 983040, '\p{^In:    _V6_3}', "");
    Expect(0, 983040, '\P{In:    _V6_3}', "");
    Expect(1, 983040, '\P{^In:    _V6_3}', "");
    Expect(0, 983037, '\p{In:    _V6_3}', "");
    Expect(1, 983037, '\p{^In:    _V6_3}', "");
    Expect(1, 983037, '\P{In:    _V6_3}', "");
    Expect(0, 983037, '\P{^In:    _V6_3}', "");
    Error('\p{Is_Present_In=/a/		+000006.3}');
    Error('\P{Is_Present_In=/a/		+000006.3}');
    Expect(1, 983040, '\p{Is_Present_In=000006.3}', "");
    Expect(0, 983040, '\p{^Is_Present_In=000006.3}', "");
    Expect(0, 983040, '\P{Is_Present_In=000006.3}', "");
    Expect(1, 983040, '\P{^Is_Present_In=000006.3}', "");
    Expect(0, 983037, '\p{Is_Present_In=000006.3}', "");
    Expect(1, 983037, '\p{^Is_Present_In=000006.3}', "");
    Expect(1, 983037, '\P{Is_Present_In=000006.3}', "");
    Expect(0, 983037, '\P{^Is_Present_In=000006.3}', "");
    Error('\p{Is_In=--V6_3/a/}');
    Error('\P{Is_In=--V6_3/a/}');
    Expect(1, 983040, '\p{Is_In:   v63}', "");
    Expect(0, 983040, '\p{^Is_In:   v63}', "");
    Expect(0, 983040, '\P{Is_In:   v63}', "");
    Expect(1, 983040, '\P{^Is_In:   v63}', "");
    Expect(0, 983037, '\p{Is_In:   v63}', "");
    Expect(1, 983037, '\p{^Is_In:   v63}', "");
    Expect(1, 983037, '\P{Is_In:   v63}', "");
    Expect(0, 983037, '\P{^Is_In:   v63}', "");
    Expect(1, 983040, '\p{Is_In=	-v6_3}', "");
    Expect(0, 983040, '\p{^Is_In=	-v6_3}', "");
    Expect(0, 983040, '\P{Is_In=	-v6_3}', "");
    Expect(1, 983040, '\P{^Is_In=	-v6_3}', "");
    Expect(0, 983037, '\p{Is_In=	-v6_3}', "");
    Expect(1, 983037, '\p{^Is_In=	-v6_3}', "");
    Expect(1, 983037, '\P{Is_In=	-v6_3}', "");
    Expect(0, 983037, '\P{^Is_In=	-v6_3}', "");
    Error('\p{Present_In=	 0_0_0_0_0_0_0_0_07.0/a/}');
    Error('\P{Present_In=	 0_0_0_0_0_0_0_0_07.0/a/}');
    Expect(1, 983040, '\p{Present_In=:\A7.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A7.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=+000007.0}', "");
    Expect(0, 983040, '\p{^Present_In=+000007.0}', "");
    Expect(0, 983040, '\P{Present_In=+000007.0}', "");
    Expect(1, 983040, '\P{^Present_In=+000007.0}', "");
    Expect(0, 983037, '\p{Present_In=+000007.0}', "");
    Expect(1, 983037, '\p{^Present_In=+000007.0}', "");
    Expect(1, 983037, '\P{Present_In=+000007.0}', "");
    Expect(0, 983037, '\P{^Present_In=+000007.0}', "");
    Error('\p{In=_ V7_0/a/}');
    Error('\P{In=_ V7_0/a/}');
    Expect(1, 983040, '\p{In=:\AV7_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV7_0\z:}', "");;
    Expect(1, 983040, '\p{In=v70}', "");
    Expect(0, 983040, '\p{^In=v70}', "");
    Expect(0, 983040, '\P{In=v70}', "");
    Expect(1, 983040, '\P{^In=v70}', "");
    Expect(0, 983037, '\p{In=v70}', "");
    Expect(1, 983037, '\p{^In=v70}', "");
    Expect(1, 983037, '\P{In=v70}', "");
    Expect(0, 983037, '\P{^In=v70}', "");
    Expect(1, 983040, '\p{In=:\Av70\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av70\z:}', "");;
    Expect(1, 983040, '\p{In= -V7_0}', "");
    Expect(0, 983040, '\p{^In= -V7_0}', "");
    Expect(0, 983040, '\P{In= -V7_0}', "");
    Expect(1, 983040, '\P{^In= -V7_0}', "");
    Expect(0, 983037, '\p{In= -V7_0}', "");
    Expect(1, 983037, '\p{^In= -V7_0}', "");
    Expect(1, 983037, '\P{In= -V7_0}', "");
    Expect(0, 983037, '\P{^In= -V7_0}', "");
    Error('\p{Is_Present_In=_/a/0_7.0}');
    Error('\P{Is_Present_In=_/a/0_7.0}');
    Expect(1, 983040, '\p{Is_Present_In=0_0_07.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=0_0_07.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=0_0_07.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=0_0_07.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=0_0_07.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=0_0_07.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=0_0_07.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=0_0_07.0}', "");
    Error('\p{Is_In=:=_ V7_0}');
    Error('\P{Is_In=:=_ V7_0}');
    Expect(1, 983040, '\p{Is_In=v70}', "");
    Expect(0, 983040, '\p{^Is_In=v70}', "");
    Expect(0, 983040, '\P{Is_In=v70}', "");
    Expect(1, 983040, '\P{^Is_In=v70}', "");
    Expect(0, 983037, '\p{Is_In=v70}', "");
    Expect(1, 983037, '\p{^Is_In=v70}', "");
    Expect(1, 983037, '\P{Is_In=v70}', "");
    Expect(0, 983037, '\P{^Is_In=v70}', "");
    Expect(1, 983040, '\p{Is_In=--V7_0}', "");
    Expect(0, 983040, '\p{^Is_In=--V7_0}', "");
    Expect(0, 983040, '\P{Is_In=--V7_0}', "");
    Expect(1, 983040, '\P{^Is_In=--V7_0}', "");
    Expect(0, 983037, '\p{Is_In=--V7_0}', "");
    Expect(1, 983037, '\p{^Is_In=--V7_0}', "");
    Expect(1, 983037, '\P{Is_In=--V7_0}', "");
    Expect(0, 983037, '\P{^Is_In=--V7_0}', "");
    Error('\p{Present_In=-/a/+0_0_0_0_0_0008.0}');
    Error('\P{Present_In=-/a/+0_0_0_0_0_0008.0}');
    Expect(1, 983040, '\p{Present_In=:\A8.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A8.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=+00008.0}', "");
    Expect(0, 983040, '\p{^Present_In=+00008.0}', "");
    Expect(0, 983040, '\P{Present_In=+00008.0}', "");
    Expect(1, 983040, '\P{^Present_In=+00008.0}', "");
    Expect(0, 983037, '\p{Present_In=+00008.0}', "");
    Expect(1, 983037, '\p{^Present_In=+00008.0}', "");
    Expect(1, 983037, '\P{Present_In=+00008.0}', "");
    Expect(0, 983037, '\P{^Present_In=+00008.0}', "");
    Error('\p{In=:= V8_0}');
    Error('\P{In=:= V8_0}');
    Expect(1, 983040, '\p{In=:\AV8_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV8_0\z:}', "");;
    Expect(1, 983040, '\p{In=v80}', "");
    Expect(0, 983040, '\p{^In=v80}', "");
    Expect(0, 983040, '\P{In=v80}', "");
    Expect(1, 983040, '\P{^In=v80}', "");
    Expect(0, 983037, '\p{In=v80}', "");
    Expect(1, 983037, '\p{^In=v80}', "");
    Expect(1, 983037, '\P{In=v80}', "");
    Expect(0, 983037, '\P{^In=v80}', "");
    Expect(1, 983040, '\p{In=:\Av80\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av80\z:}', "");;
    Expect(1, 983040, '\p{In=	v8_0}', "");
    Expect(0, 983040, '\p{^In=	v8_0}', "");
    Expect(0, 983040, '\P{In=	v8_0}', "");
    Expect(1, 983040, '\P{^In=	v8_0}', "");
    Expect(0, 983037, '\p{In=	v8_0}', "");
    Expect(1, 983037, '\p{^In=	v8_0}', "");
    Expect(1, 983037, '\P{In=	v8_0}', "");
    Expect(0, 983037, '\P{^In=	v8_0}', "");
    Error('\p{Is_Present_In= /a/+000000008.0}');
    Error('\P{Is_Present_In= /a/+000000008.0}');
    Expect(1, 983040, '\p{Is_Present_In=000008.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=000008.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=000008.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=000008.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=000008.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=000008.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=000008.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=000008.0}', "");
    Error('\p{Is_In=:=_V8_0}');
    Error('\P{Is_In=:=_V8_0}');
    Expect(1, 983040, '\p{Is_In=v80}', "");
    Expect(0, 983040, '\p{^Is_In=v80}', "");
    Expect(0, 983040, '\P{Is_In=v80}', "");
    Expect(1, 983040, '\P{^Is_In=v80}', "");
    Expect(0, 983037, '\p{Is_In=v80}', "");
    Expect(1, 983037, '\p{^Is_In=v80}', "");
    Expect(1, 983037, '\P{Is_In=v80}', "");
    Expect(0, 983037, '\P{^Is_In=v80}', "");
    Expect(1, 983040, '\p{Is_In=-V8_0}', "");
    Expect(0, 983040, '\p{^Is_In=-V8_0}', "");
    Expect(0, 983040, '\P{Is_In=-V8_0}', "");
    Expect(1, 983040, '\P{^Is_In=-V8_0}', "");
    Expect(0, 983037, '\p{Is_In=-V8_0}', "");
    Expect(1, 983037, '\p{^Is_In=-V8_0}', "");
    Expect(1, 983037, '\P{Is_In=-V8_0}', "");
    Expect(0, 983037, '\P{^Is_In=-V8_0}', "");
    Error('\p{Present_In=_/a/+0_9.0}');
    Error('\P{Present_In=_/a/+0_9.0}');
    Expect(1, 983040, '\p{Present_In=:\A9.0\z:}', "");;
    Expect(0, 983037, '\p{Present_In=:\A9.0\z:}', "");;
    Expect(1, 983040, '\p{Present_In=+0000000009.0}', "");
    Expect(0, 983040, '\p{^Present_In=+0000000009.0}', "");
    Expect(0, 983040, '\P{Present_In=+0000000009.0}', "");
    Expect(1, 983040, '\P{^Present_In=+0000000009.0}', "");
    Expect(0, 983037, '\p{Present_In=+0000000009.0}', "");
    Expect(1, 983037, '\p{^Present_In=+0000000009.0}', "");
    Expect(1, 983037, '\P{Present_In=+0000000009.0}', "");
    Expect(0, 983037, '\P{^Present_In=+0000000009.0}', "");
    Error('\p{In:   :=__V9_0}');
    Error('\P{In:   :=__V9_0}');
    Expect(1, 983040, '\p{In=:\AV9_0\z:}', "");;
    Expect(0, 983037, '\p{In=:\AV9_0\z:}', "");;
    Expect(1, 983040, '\p{In:   v90}', "");
    Expect(0, 983040, '\p{^In:   v90}', "");
    Expect(0, 983040, '\P{In:   v90}', "");
    Expect(1, 983040, '\P{^In:   v90}', "");
    Expect(0, 983037, '\p{In:   v90}', "");
    Expect(1, 983037, '\p{^In:   v90}', "");
    Expect(1, 983037, '\P{In:   v90}', "");
    Expect(0, 983037, '\P{^In:   v90}', "");
    Expect(1, 983040, '\p{In=:\Av90\z:}', "");;
    Expect(0, 983037, '\p{In=:\Av90\z:}', "");;
    Expect(1, 983040, '\p{In=-_V9_0}', "");
    Expect(0, 983040, '\p{^In=-_V9_0}', "");
    Expect(0, 983040, '\P{In=-_V9_0}', "");
    Expect(1, 983040, '\P{^In=-_V9_0}', "");
    Expect(0, 983037, '\p{In=-_V9_0}', "");
    Expect(1, 983037, '\p{^In=-_V9_0}', "");
    Expect(1, 983037, '\P{In=-_V9_0}', "");
    Expect(0, 983037, '\P{^In=-_V9_0}', "");
    Error('\p{Is_Present_In=	:=+0_0_0_0_009.0}');
    Error('\P{Is_Present_In=	:=+0_0_0_0_009.0}');
    Expect(1, 983040, '\p{Is_Present_In=000_000_000_9.0}', "");
    Expect(0, 983040, '\p{^Is_Present_In=000_000_000_9.0}', "");
    Expect(0, 983040, '\P{Is_Present_In=000_000_000_9.0}', "");
    Expect(1, 983040, '\P{^Is_Present_In=000_000_000_9.0}', "");
    Expect(0, 983037, '\p{Is_Present_In=000_000_000_9.0}', "");
    Expect(1, 983037, '\p{^Is_Present_In=000_000_000_9.0}', "");
    Expect(1, 983037, '\P{Is_Present_In=000_000_000_9.0}', "");
    Expect(0, 983037, '\P{^Is_Present_In=000_000_000_9.0}', "");
    Error('\p{Is_In:V9_0:=}');
    Error('\P{Is_In:V9_0:=}');
    Expect(1, 983040, '\p{Is_In=v90}', "");
    Expect(0, 983040, '\p{^Is_In=v90}', "");
    Expect(0, 983040, '\P{Is_In=v90}', "");
    Expect(1, 983040, '\P{^Is_In=v90}', "");
    Expect(0, 983037, '\p{Is_In=v90}', "");
    Expect(1, 983037, '\p{^Is_In=v90}', "");
    Expect(1, 983037, '\P{Is_In=v90}', "");
    Expect(0, 983037, '\P{^Is_In=v90}', "");
    Expect(1, 983040, '\p{Is_In=--v9_0}', "");
    Expect(0, 983040, '\p{^Is_In=--v9_0}', "");
    Expect(0, 983040, '\P{Is_In=--v9_0}', "");
    Expect(1, 983040, '\P{^Is_In=--v9_0}', "");
    Expect(0, 983037, '\p{Is_In=--v9_0}', "");
    Expect(1, 983037, '\p{^Is_In=--v9_0}', "");
    Expect(1, 983037, '\P{Is_In=--v9_0}', "");
    Expect(0, 983037, '\P{^Is_In=--v9_0}', "");
    Error('\p{Present_In=:=-	Unassigned}');
    Error('\P{Present_In=:=-	Unassigned}');
    Expect(1, 983037, '\p{Present_In=:\AUnassigned\z:}', "");;
    Expect(0, 983040, '\p{Present_In=:\AUnassigned\z:}', "");;
    Expect(1, 983037, '\p{Present_In=unassigned}', "");
    Expect(0, 983037, '\p{^Present_In=unassigned}', "");
    Expect(0, 983037, '\P{Present_In=unassigned}', "");
    Expect(1, 983037, '\P{^Present_In=unassigned}', "");
    Expect(0, 983040, '\p{Present_In=unassigned}', "");
    Expect(1, 983040, '\p{^Present_In=unassigned}', "");
    Expect(1, 983040, '\P{Present_In=unassigned}', "");
    Expect(0, 983040, '\P{^Present_In=unassigned}', "");
    Expect(1, 983037, '\p{Present_In=:\Aunassigned\z:}', "");;
    Expect(0, 983040, '\p{Present_In=:\Aunassigned\z:}', "");;
    Expect(1, 983037, '\p{Present_In:	  Unassigned}', "");
    Expect(0, 983037, '\p{^Present_In:	  Unassigned}', "");
    Expect(0, 983037, '\P{Present_In:	  Unassigned}', "");
    Expect(1, 983037, '\P{^Present_In:	  Unassigned}', "");
    Expect(0, 983040, '\p{Present_In:	  Unassigned}', "");
    Expect(1, 983040, '\p{^Present_In:	  Unassigned}', "");
    Expect(1, 983040, '\P{Present_In:	  Unassigned}', "");
    Expect(0, 983040, '\P{^Present_In:	  Unassigned}', "");
    Error('\p{In=_	UNASSIGNED/a/}');
    Error('\P{In=_	UNASSIGNED/a/}');
    Expect(1, 983037, '\p{In=:\AUnassigned\z:}', "");;
    Expect(0, 983040, '\p{In=:\AUnassigned\z:}', "");;
    Expect(1, 983037, '\p{In:   unassigned}', "");
    Expect(0, 983037, '\p{^In:   unassigned}', "");
    Expect(0, 983037, '\P{In:   unassigned}', "");
    Expect(1, 983037, '\P{^In:   unassigned}', "");
    Expect(0, 983040, '\p{In:   unassigned}', "");
    Expect(1, 983040, '\p{^In:   unassigned}', "");
    Expect(1, 983040, '\P{In:   unassigned}', "");
    Expect(0, 983040, '\P{^In:   unassigned}', "");
    Expect(1, 983037, '\p{In=:\Aunassigned\z:}', "");;
    Expect(0, 983040, '\p{In=:\Aunassigned\z:}', "");;
    Expect(1, 983037, '\p{In:-unassigned}', "");
    Expect(0, 983037, '\p{^In:-unassigned}', "");
    Expect(0, 983037, '\P{In:-unassigned}', "");
    Expect(1, 983037, '\P{^In:-unassigned}', "");
    Expect(0, 983040, '\p{In:-unassigned}', "");
    Expect(1, 983040, '\p{^In:-unassigned}', "");
    Expect(1, 983040, '\P{In:-unassigned}', "");
    Expect(0, 983040, '\P{^In:-unassigned}', "");
    Error('\p{Is_Present_In=/a/		Unassigned}');
    Error('\P{Is_Present_In=/a/		Unassigned}');
    Expect(1, 983037, '\p{Is_Present_In=unassigned}', "");
    Expect(0, 983037, '\p{^Is_Present_In=unassigned}', "");
    Expect(0, 983037, '\P{Is_Present_In=unassigned}', "");
    Expect(1, 983037, '\P{^Is_Present_In=unassigned}', "");
    Expect(0, 983040, '\p{Is_Present_In=unassigned}', "");
    Expect(1, 983040, '\p{^Is_Present_In=unassigned}', "");
    Expect(1, 983040, '\P{Is_Present_In=unassigned}', "");
    Expect(0, 983040, '\P{^Is_Present_In=unassigned}', "");
    Expect(1, 983037, '\p{Is_Present_In=--Unassigned}', "");
    Expect(0, 983037, '\p{^Is_Present_In=--Unassigned}', "");
    Expect(0, 983037, '\P{Is_Present_In=--Unassigned}', "");
    Expect(1, 983037, '\P{^Is_Present_In=--Unassigned}', "");
    Expect(0, 983040, '\p{Is_Present_In=--Unassigned}', "");
    Expect(1, 983040, '\p{^Is_Present_In=--Unassigned}', "");
    Expect(1, 983040, '\P{Is_Present_In=--Unassigned}', "");
    Expect(0, 983040, '\P{^Is_Present_In=--Unassigned}', "");
    Error('\p{Is_In=:=Unassigned}');
    Error('\P{Is_In=:=Unassigned}');
    Expect(1, 983037, '\p{Is_In:   unassigned}', "");
    Expect(0, 983037, '\p{^Is_In:   unassigned}', "");
    Expect(0, 983037, '\P{Is_In:   unassigned}', "");
    Expect(1, 983037, '\P{^Is_In:   unassigned}', "");
    Expect(0, 983040, '\p{Is_In:   unassigned}', "");
    Expect(1, 983040, '\p{^Is_In:   unassigned}', "");
    Expect(1, 983040, '\P{Is_In:   unassigned}', "");
    Expect(0, 983040, '\P{^Is_In:   unassigned}', "");
    Expect(1, 983037, '\p{Is_In= UNASSIGNED}', "");
    Expect(0, 983037, '\p{^Is_In= UNASSIGNED}', "");
    Expect(0, 983037, '\P{Is_In= UNASSIGNED}', "");
    Expect(1, 983037, '\P{^Is_In= UNASSIGNED}', "");
    Expect(0, 983040, '\p{Is_In= UNASSIGNED}', "");
    Expect(1, 983040, '\p{^Is_In= UNASSIGNED}', "");
    Expect(1, 983040, '\P{Is_In= UNASSIGNED}', "");
    Expect(0, 983040, '\P{^Is_In= UNASSIGNED}', "");
    Error('\p{indicpositionalcategory}');
    Error('\P{indicpositionalcategory}');
    Error('\p{inpc}');
    Error('\P{inpc}');
    Error('\p{Indic_Positional_Category=:=	 BOTTOM}');
    Error('\P{Indic_Positional_Category=:=	 BOTTOM}');
    Expect(1, 73460, '\p{Indic_Positional_Category=:\ABottom\z:}', "");;
    Expect(0, 73461, '\p{Indic_Positional_Category=:\ABottom\z:}', "");;
    Expect(1, 73460, '\p{Indic_Positional_Category=bottom}', "");
    Expect(0, 73460, '\p{^Indic_Positional_Category=bottom}', "");
    Expect(0, 73460, '\P{Indic_Positional_Category=bottom}', "");
    Expect(1, 73460, '\P{^Indic_Positional_Category=bottom}', "");
    Expect(0, 73461, '\p{Indic_Positional_Category=bottom}', "");
    Expect(1, 73461, '\p{^Indic_Positional_Category=bottom}', "");
    Expect(1, 73461, '\P{Indic_Positional_Category=bottom}', "");
    Expect(0, 73461, '\P{^Indic_Positional_Category=bottom}', "");
    Expect(1, 73460, '\p{Indic_Positional_Category=:\Abottom\z:}', "");;
    Expect(0, 73461, '\p{Indic_Positional_Category=:\Abottom\z:}', "");;
    Expect(1, 73460, '\p{Indic_Positional_Category=_-BOTTOM}', "");
    Expect(0, 73460, '\p{^Indic_Positional_Category=_-BOTTOM}', "");
    Expect(0, 73460, '\P{Indic_Positional_Category=_-BOTTOM}', "");
    Expect(1, 73460, '\P{^Indic_Positional_Category=_-BOTTOM}', "");
    Expect(0, 73461, '\p{Indic_Positional_Category=_-BOTTOM}', "");
    Expect(1, 73461, '\p{^Indic_Positional_Category=_-BOTTOM}', "");
    Expect(1, 73461, '\P{Indic_Positional_Category=_-BOTTOM}', "");
    Expect(0, 73461, '\P{^Indic_Positional_Category=_-BOTTOM}', "");
    Error('\p{InPC=-	bottom/a/}');
    Error('\P{InPC=-	bottom/a/}');
    Expect(1, 73460, '\p{InPC=:\ABottom\z:}', "");;
    Expect(0, 73461, '\p{InPC=:\ABottom\z:}', "");;
    Expect(1, 73460, '\p{InPC=bottom}', "");
    Expect(0, 73460, '\p{^InPC=bottom}', "");
    Expect(0, 73460, '\P{InPC=bottom}', "");
    Expect(1, 73460, '\P{^InPC=bottom}', "");
    Expect(0, 73461, '\p{InPC=bottom}', "");
    Expect(1, 73461, '\p{^InPC=bottom}', "");
    Expect(1, 73461, '\P{InPC=bottom}', "");
    Expect(0, 73461, '\P{^InPC=bottom}', "");
    Expect(1, 73460, '\p{InPC=:\Abottom\z:}', "");;
    Expect(0, 73461, '\p{InPC=:\Abottom\z:}', "");;
    Expect(1, 73460, '\p{InPC=-	bottom}', "");
    Expect(0, 73460, '\p{^InPC=-	bottom}', "");
    Expect(0, 73460, '\P{InPC=-	bottom}', "");
    Expect(1, 73460, '\P{^InPC=-	bottom}', "");
    Expect(0, 73461, '\p{InPC=-	bottom}', "");
    Expect(1, 73461, '\p{^InPC=-	bottom}', "");
    Expect(1, 73461, '\P{InPC=-	bottom}', "");
    Expect(0, 73461, '\P{^InPC=-	bottom}', "");
    Error('\p{Is_Indic_Positional_Category=:=	 BOTTOM}');
    Error('\P{Is_Indic_Positional_Category=:=	 BOTTOM}');
    Expect(1, 73460, '\p{Is_Indic_Positional_Category=bottom}', "");
    Expect(0, 73460, '\p{^Is_Indic_Positional_Category=bottom}', "");
    Expect(0, 73460, '\P{Is_Indic_Positional_Category=bottom}', "");
    Expect(1, 73460, '\P{^Is_Indic_Positional_Category=bottom}', "");
    Expect(0, 73461, '\p{Is_Indic_Positional_Category=bottom}', "");
    Expect(1, 73461, '\p{^Is_Indic_Positional_Category=bottom}', "");
    Expect(1, 73461, '\P{Is_Indic_Positional_Category=bottom}', "");
    Expect(0, 73461, '\P{^Is_Indic_Positional_Category=bottom}', "");
    Expect(1, 73460, '\p{Is_Indic_Positional_Category=--BOTTOM}', "");
    Expect(0, 73460, '\p{^Is_Indic_Positional_Category=--BOTTOM}', "");
    Expect(0, 73460, '\P{Is_Indic_Positional_Category=--BOTTOM}', "");
    Expect(1, 73460, '\P{^Is_Indic_Positional_Category=--BOTTOM}', "");
    Expect(0, 73461, '\p{Is_Indic_Positional_Category=--BOTTOM}', "");
    Expect(1, 73461, '\p{^Is_Indic_Positional_Category=--BOTTOM}', "");
    Expect(1, 73461, '\P{Is_Indic_Positional_Category=--BOTTOM}', "");
    Expect(0, 73461, '\P{^Is_Indic_Positional_Category=--BOTTOM}', "");
    Error('\p{Is_InPC=:=- BOTTOM}');
    Error('\P{Is_InPC=:=- BOTTOM}');
    Expect(1, 73460, '\p{Is_InPC=bottom}', "");
    Expect(0, 73460, '\p{^Is_InPC=bottom}', "");
    Expect(0, 73460, '\P{Is_InPC=bottom}', "");
    Expect(1, 73460, '\P{^Is_InPC=bottom}', "");
    Expect(0, 73461, '\p{Is_InPC=bottom}', "");
    Expect(1, 73461, '\p{^Is_InPC=bottom}', "");
    Expect(1, 73461, '\P{Is_InPC=bottom}', "");
    Expect(0, 73461, '\P{^Is_InPC=bottom}', "");
    Expect(1, 73460, '\p{Is_InPC=Bottom}', "");
    Expect(0, 73460, '\p{^Is_InPC=Bottom}', "");
    Expect(0, 73460, '\P{Is_InPC=Bottom}', "");
    Expect(1, 73460, '\P{^Is_InPC=Bottom}', "");
    Expect(0, 73461, '\p{Is_InPC=Bottom}', "");
    Expect(1, 73461, '\p{^Is_InPC=Bottom}', "");
    Expect(1, 73461, '\P{Is_InPC=Bottom}', "");
    Expect(0, 73461, '\P{^Is_InPC=Bottom}', "");
    Error('\p{Indic_Positional_Category= /a/bottom_and_Left}');
    Error('\P{Indic_Positional_Category= /a/bottom_and_Left}');
    Expect(1, 43455, '\p{Indic_Positional_Category=:\ABottom_And_Left\z:}', "");;
    Expect(0, 43456, '\p{Indic_Positional_Category=:\ABottom_And_Left\z:}', "");;
    Expect(1, 43455, '\p{Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43455, '\p{^Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43455, '\P{Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43455, '\P{^Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43456, '\p{Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43456, '\p{^Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43456, '\P{Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43456, '\P{^Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43455, '\p{Indic_Positional_Category=:\Abottomandleft\z:}', "");;
    Expect(0, 43456, '\p{Indic_Positional_Category=:\Abottomandleft\z:}', "");;
    Expect(1, 43455, '\p{Indic_Positional_Category:	 _Bottom_And_Left}', "");
    Expect(0, 43455, '\p{^Indic_Positional_Category:	 _Bottom_And_Left}', "");
    Expect(0, 43455, '\P{Indic_Positional_Category:	 _Bottom_And_Left}', "");
    Expect(1, 43455, '\P{^Indic_Positional_Category:	 _Bottom_And_Left}', "");
    Expect(0, 43456, '\p{Indic_Positional_Category:	 _Bottom_And_Left}', "");
    Expect(1, 43456, '\p{^Indic_Positional_Category:	 _Bottom_And_Left}', "");
    Expect(1, 43456, '\P{Indic_Positional_Category:	 _Bottom_And_Left}', "");
    Expect(0, 43456, '\P{^Indic_Positional_Category:	 _Bottom_And_Left}', "");
    Error('\p{InPC=/a/_bottom_AND_LEFT}');
    Error('\P{InPC=/a/_bottom_AND_LEFT}');
    Expect(1, 43455, '\p{InPC=:\ABottom_And_Left\z:}', "");;
    Expect(0, 43456, '\p{InPC=:\ABottom_And_Left\z:}', "");;
    Expect(1, 43455, '\p{InPC=bottomandleft}', "");
    Expect(0, 43455, '\p{^InPC=bottomandleft}', "");
    Expect(0, 43455, '\P{InPC=bottomandleft}', "");
    Expect(1, 43455, '\P{^InPC=bottomandleft}', "");
    Expect(0, 43456, '\p{InPC=bottomandleft}', "");
    Expect(1, 43456, '\p{^InPC=bottomandleft}', "");
    Expect(1, 43456, '\P{InPC=bottomandleft}', "");
    Expect(0, 43456, '\P{^InPC=bottomandleft}', "");
    Expect(1, 43455, '\p{InPC=:\Abottomandleft\z:}', "");;
    Expect(0, 43456, '\p{InPC=:\Abottomandleft\z:}', "");;
    Expect(1, 43455, '\p{InPC=- Bottom_and_left}', "");
    Expect(0, 43455, '\p{^InPC=- Bottom_and_left}', "");
    Expect(0, 43455, '\P{InPC=- Bottom_and_left}', "");
    Expect(1, 43455, '\P{^InPC=- Bottom_and_left}', "");
    Expect(0, 43456, '\p{InPC=- Bottom_and_left}', "");
    Expect(1, 43456, '\p{^InPC=- Bottom_and_left}', "");
    Expect(1, 43456, '\P{InPC=- Bottom_and_left}', "");
    Expect(0, 43456, '\P{^InPC=- Bottom_and_left}', "");
    Error('\p{Is_Indic_Positional_Category=/a/-bottom_And_Left}');
    Error('\P{Is_Indic_Positional_Category=/a/-bottom_And_Left}');
    Expect(1, 43455, '\p{Is_Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43455, '\p{^Is_Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43455, '\P{Is_Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43455, '\P{^Is_Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43456, '\p{Is_Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43456, '\p{^Is_Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43456, '\P{Is_Indic_Positional_Category=bottomandleft}', "");
    Expect(0, 43456, '\P{^Is_Indic_Positional_Category=bottomandleft}', "");
    Expect(1, 43455, '\p{Is_Indic_Positional_Category=-	Bottom_And_LEFT}', "");
    Expect(0, 43455, '\p{^Is_Indic_Positional_Category=-	Bottom_And_LEFT}', "");
    Expect(0, 43455, '\P{Is_Indic_Positional_Category=-	Bottom_And_LEFT}', "");
    Expect(1, 43455, '\P{^Is_Indic_Positional_Category=-	Bottom_And_LEFT}', "");
    Expect(0, 43456, '\p{Is_Indic_Positional_Category=-	Bottom_And_LEFT}', "");
    Expect(1, 43456, '\p{^Is_Indic_Positional_Category=-	Bottom_And_LEFT}', "");
    Expect(1, 43456, '\P{Is_Indic_Positional_Category=-	Bottom_And_LEFT}', "");
    Expect(0, 43456, '\P{^Is_Indic_Positional_Category=-	Bottom_And_LEFT}', "");
    Error('\p{Is_InPC:   :=_	BOTTOM_And_Left}');
    Error('\P{Is_InPC:   :=_	BOTTOM_And_Left}');
    Expect(1, 43455, '\p{Is_InPC=bottomandleft}', "");
    Expect(0, 43455, '\p{^Is_InPC=bottomandleft}', "");
    Expect(0, 43455, '\P{Is_InPC=bottomandleft}', "");
    Expect(1, 43455, '\P{^Is_InPC=bottomandleft}', "");
    Expect(0, 43456, '\p{Is_InPC=bottomandleft}', "");
    Expect(1, 43456, '\p{^Is_InPC=bottomandleft}', "");
    Expect(1, 43456, '\P{Is_InPC=bottomandleft}', "");
    Expect(0, 43456, '\P{^Is_InPC=bottomandleft}', "");
    Expect(1, 43455, '\p{Is_InPC=BOTTOM_And_Left}', "");
    Expect(0, 43455, '\p{^Is_InPC=BOTTOM_And_Left}', "");
    Expect(0, 43455, '\P{Is_InPC=BOTTOM_And_Left}', "");
    Expect(1, 43455, '\P{^Is_InPC=BOTTOM_And_Left}', "");
    Expect(0, 43456, '\p{Is_InPC=BOTTOM_And_Left}', "");
    Expect(1, 43456, '\p{^Is_InPC=BOTTOM_And_Left}', "");
    Expect(1, 43456, '\P{Is_InPC=BOTTOM_And_Left}', "");
    Expect(0, 43456, '\P{^Is_InPC=BOTTOM_And_Left}', "");
    Error('\p{Indic_Positional_Category= -BOTTOM_and_right/a/}');
    Error('\P{Indic_Positional_Category= -BOTTOM_and_right/a/}');
    Expect(1, 43456, '\p{Indic_Positional_Category=:\ABottom_And_Right\z:}', "");;
    Expect(0, 43457, '\p{Indic_Positional_Category=:\ABottom_And_Right\z:}', "");;
    Expect(1, 43456, '\p{Indic_Positional_Category=bottomandright}', "");
    Expect(0, 43456, '\p{^Indic_Positional_Category=bottomandright}', "");
    Expect(0, 43456, '\P{Indic_Positional_Category=bottomandright}', "");
    Expect(1, 43456, '\P{^Indic_Positional_Category=bottomandright}', "");
    Expect(0, 43457, '\p{Indic_Positional_Category=bottomandright}', "");
    Expect(1, 43457, '\p{^Indic_Positional_Category=bottomandright}', "");
    Expect(1, 43457, '\P{Indic_Positional_Category=bottomandright}', "");
    Expect(0, 43457, '\P{^Indic_Positional_Category=bottomandright}', "");
    Expect(1, 43456, '\p{Indic_Positional_Category=:\Abottomandright\z:}', "");;
    Expect(0, 43457, '\p{Indic_Positional_Category=:\Abottomandright\z:}', "");;
    Expect(1, 43456, '\p{Indic_Positional_Category=-Bottom_And_RIGHT}', "");
    Expect(0, 43456, '\p{^Indic_Positional_Category=-Bottom_And_RIGHT}', "");
    Expect(0, 43456, '\P{Indic_Positional_Category=-Bottom_And_RIGHT}', "");
    Expect(1, 43456, '\P{^Indic_Positional_Category=-Bottom_And_RIGHT}', "");
    Expect(0, 43457, '\p{Indic_Positional_Category=-Bottom_And_RIGHT}', "");
    Expect(1, 43457, '\p{^Indic_Positional_Category=-Bottom_And_RIGHT}', "");
    Expect(1, 43457, '\P{Indic_Positional_Category=-Bottom_And_RIGHT}', "");
    Expect(0, 43457, '\P{^Indic_Positional_Category=-Bottom_And_RIGHT}', "");
    Error('\p{InPC=:= Bottom_And_Right}');
    Error('\P{InPC=:= Bottom_And_Right}');
    Expect(1, 43456, '\p{InPC=:\ABottom_And_Right\z:}', "");;
    Expect(0, 43457, '\p{InPC=:\ABottom_And_Right\z:}', "");;
    Expect(1, 43456, '\p{InPC:bottomandright}', "");
    Expect(0, 43456, '\p{^InPC:bottomandright}', "");
    Expect(0, 43456, '\P{InPC:bottomandright}', "");
    Expect(1, 43456, '\P{^InPC:bottomandright}', "");
    Expect(0, 43457, '\p{InPC:bottomandright}', "");
    Expect(1, 43457, '\p{^InPC:bottomandright}', "");
    Expect(1, 43457, '\P{InPC:bottomandright}', "");
    Expect(0, 43457, '\P{^InPC:bottomandright}', "");
    Expect(1, 43456, '\p{InPC=:\Abottomandright\z:}', "");;
    Expect(0, 43457, '\p{InPC=:\Abottomandright\z:}', "");;
    Expect(1, 43456, '\p{InPC=_Bottom_And_right}', "");
    Expect(0, 43456, '\p{^InPC=_Bottom_And_right}', "");
    Expect(0, 43456, '\P{InPC=_Bottom_And_right}', "");
    Expect(1, 43456, '\P{^InPC=_Bottom_And_right}', "");
    Expect(0, 43457, '\p{InPC=_Bottom_And_right}', "");
    Expect(1, 43457, '\p{^InPC=_Bottom_And_right}', "");
    Expect(1, 43457, '\P{InPC=_Bottom_And_right}', "");
    Expect(0, 43457, '\P{^InPC=_Bottom_And_right}', "");
    Error('\p{Is_Indic_Positional_Category= Bottom_And_RIGHT:=}');
    Error('\P{Is_Indic_Positional_Category= Bottom_And_RIGHT:=}');
    Expect(1, 43456, '\p{Is_Indic_Positional_Category=bottomandright}', "");
    Expect(0, 43456, '\p{^Is_Indic_Positional_Category=bottomandright}', "");
    Expect(0, 43456, '\P{Is_Indic_Positional_Category=bottomandright}', "");
    Expect(1, 43456, '\P{^Is_Indic_Positional_Category=bottomandright}', "");
    Expect(0, 43457, '\p{Is_Indic_Positional_Category=bottomandright}', "");
    Expect(1, 43457, '\p{^Is_Indic_Positional_Category=bottomandright}', "");
    Expect(1, 43457, '\P{Is_Indic_Positional_Category=bottomandright}', "");
    Expect(0, 43457, '\P{^Is_Indic_Positional_Category=bottomandright}', "");
    Expect(1, 43456, '\p{Is_Indic_Positional_Category:	_ BOTTOM_AND_right}', "");
    Expect(0, 43456, '\p{^Is_Indic_Positional_Category:	_ BOTTOM_AND_right}', "");
    Expect(0, 43456, '\P{Is_Indic_Positional_Category:	_ BOTTOM_AND_right}', "");
    Expect(1, 43456, '\P{^Is_Indic_Positional_Category:	_ BOTTOM_AND_right}', "");
    Expect(0, 43457, '\p{Is_Indic_Positional_Category:	_ BOTTOM_AND_right}', "");
    Expect(1, 43457, '\p{^Is_Indic_Positional_Category:	_ BOTTOM_AND_right}', "");
    Expect(1, 43457, '\P{Is_Indic_Positional_Category:	_ BOTTOM_AND_right}', "");
    Expect(0, 43457, '\P{^Is_Indic_Positional_Category:	_ BOTTOM_AND_right}', "");
    Error('\p{Is_InPC=	:=bottom_and_Right}');
    Error('\P{Is_InPC=	:=bottom_and_Right}');
    Expect(1, 43456, '\p{Is_InPC=bottomandright}', "");
    Expect(0, 43456, '\p{^Is_InPC=bottomandright}', "");
    Expect(0, 43456, '\P{Is_InPC=bottomandright}', "");
    Expect(1, 43456, '\P{^Is_InPC=bottomandright}', "");
    Expect(0, 43457, '\p{Is_InPC=bottomandright}', "");
    Expect(1, 43457, '\p{^Is_InPC=bottomandright}', "");
    Expect(1, 43457, '\P{Is_InPC=bottomandright}', "");
    Expect(0, 43457, '\P{^Is_InPC=bottomandright}', "");
    Expect(1, 43456, '\p{Is_InPC= -bottom_And_Right}', "");
    Expect(0, 43456, '\p{^Is_InPC= -bottom_And_Right}', "");
    Expect(0, 43456, '\P{Is_InPC= -bottom_And_Right}', "");
    Expect(1, 43456, '\P{^Is_InPC= -bottom_And_Right}', "");
    Expect(0, 43457, '\p{Is_InPC= -bottom_And_Right}', "");
    Expect(1, 43457, '\p{^Is_InPC= -bottom_And_Right}', "");
    Expect(1, 43457, '\P{Is_InPC= -bottom_And_Right}', "");
    Expect(0, 43457, '\P{^Is_InPC= -bottom_And_Right}', "");
    Error('\p{Indic_Positional_Category=_LEFT/a/}');
    Error('\P{Indic_Positional_Category=_LEFT/a/}');
    Expect(1, 73461, '\p{Indic_Positional_Category=:\ALeft\z:}', "");;
    Expect(0, 73462, '\p{Indic_Positional_Category=:\ALeft\z:}', "");;
    Expect(1, 73461, '\p{Indic_Positional_Category=left}', "");
    Expect(0, 73461, '\p{^Indic_Positional_Category=left}', "");
    Expect(0, 73461, '\P{Indic_Positional_Category=left}', "");
    Expect(1, 73461, '\P{^Indic_Positional_Category=left}', "");
    Expect(0, 73462, '\p{Indic_Positional_Category=left}', "");
    Expect(1, 73462, '\p{^Indic_Positional_Category=left}', "");
    Expect(1, 73462, '\P{Indic_Positional_Category=left}', "");
    Expect(0, 73462, '\P{^Indic_Positional_Category=left}', "");
    Expect(1, 73461, '\p{Indic_Positional_Category=:\Aleft\z:}', "");;
    Expect(0, 73462, '\p{Indic_Positional_Category=:\Aleft\z:}', "");;
    Expect(1, 73461, '\p{Indic_Positional_Category=-Left}', "");
    Expect(0, 73461, '\p{^Indic_Positional_Category=-Left}', "");
    Expect(0, 73461, '\P{Indic_Positional_Category=-Left}', "");
    Expect(1, 73461, '\P{^Indic_Positional_Category=-Left}', "");
    Expect(0, 73462, '\p{Indic_Positional_Category=-Left}', "");
    Expect(1, 73462, '\p{^Indic_Positional_Category=-Left}', "");
    Expect(1, 73462, '\P{Indic_Positional_Category=-Left}', "");
    Expect(0, 73462, '\P{^Indic_Positional_Category=-Left}', "");
    Error('\p{InPC=/a/--Left}');
    Error('\P{InPC=/a/--Left}');
    Expect(1, 73461, '\p{InPC=:\ALeft\z:}', "");;
    Expect(0, 73462, '\p{InPC=:\ALeft\z:}', "");;
    Expect(1, 73461, '\p{InPC=left}', "");
    Expect(0, 73461, '\p{^InPC=left}', "");
    Expect(0, 73461, '\P{InPC=left}', "");
    Expect(1, 73461, '\P{^InPC=left}', "");
    Expect(0, 73462, '\p{InPC=left}', "");
    Expect(1, 73462, '\p{^InPC=left}', "");
    Expect(1, 73462, '\P{InPC=left}', "");
    Expect(0, 73462, '\P{^InPC=left}', "");
    Expect(1, 73461, '\p{InPC=:\Aleft\z:}', "");;
    Expect(0, 73462, '\p{InPC=:\Aleft\z:}', "");;
    Expect(1, 73461, '\p{InPC=	-Left}', "");
    Expect(0, 73461, '\p{^InPC=	-Left}', "");
    Expect(0, 73461, '\P{InPC=	-Left}', "");
    Expect(1, 73461, '\P{^InPC=	-Left}', "");
    Expect(0, 73462, '\p{InPC=	-Left}', "");
    Expect(1, 73462, '\p{^InPC=	-Left}', "");
    Expect(1, 73462, '\P{InPC=	-Left}', "");
    Expect(0, 73462, '\P{^InPC=	-Left}', "");
    Error('\p{Is_Indic_Positional_Category=:= Left}');
    Error('\P{Is_Indic_Positional_Category=:= Left}');
    Expect(1, 73461, '\p{Is_Indic_Positional_Category:	left}', "");
    Expect(0, 73461, '\p{^Is_Indic_Positional_Category:	left}', "");
    Expect(0, 73461, '\P{Is_Indic_Positional_Category:	left}', "");
    Expect(1, 73461, '\P{^Is_Indic_Positional_Category:	left}', "");
    Expect(0, 73462, '\p{Is_Indic_Positional_Category:	left}', "");
    Expect(1, 73462, '\p{^Is_Indic_Positional_Category:	left}', "");
    Expect(1, 73462, '\P{Is_Indic_Positional_Category:	left}', "");
    Expect(0, 73462, '\P{^Is_Indic_Positional_Category:	left}', "");
    Expect(1, 73461, '\p{Is_Indic_Positional_Category=_	Left}', "");
    Expect(0, 73461, '\p{^Is_Indic_Positional_Category=_	Left}', "");
    Expect(0, 73461, '\P{Is_Indic_Positional_Category=_	Left}', "");
    Expect(1, 73461, '\P{^Is_Indic_Positional_Category=_	Left}', "");
    Expect(0, 73462, '\p{Is_Indic_Positional_Category=_	Left}', "");
    Expect(1, 73462, '\p{^Is_Indic_Positional_Category=_	Left}', "");
    Expect(1, 73462, '\P{Is_Indic_Positional_Category=_	Left}', "");
    Expect(0, 73462, '\P{^Is_Indic_Positional_Category=_	Left}', "");
    Error('\p{Is_InPC=/a/_	left}');
    Error('\P{Is_InPC=/a/_	left}');
    Expect(1, 73461, '\p{Is_InPC=left}', "");
    Expect(0, 73461, '\p{^Is_InPC=left}', "");
    Expect(0, 73461, '\P{Is_InPC=left}', "");
    Expect(1, 73461, '\P{^Is_InPC=left}', "");
    Expect(0, 73462, '\p{Is_InPC=left}', "");
    Expect(1, 73462, '\p{^Is_InPC=left}', "");
    Expect(1, 73462, '\P{Is_InPC=left}', "");
    Expect(0, 73462, '\P{^Is_InPC=left}', "");
    Expect(1, 73461, '\p{Is_InPC= Left}', "");
    Expect(0, 73461, '\p{^Is_InPC= Left}', "");
    Expect(0, 73461, '\P{Is_InPC= Left}', "");
    Expect(1, 73461, '\P{^Is_InPC= Left}', "");
    Expect(0, 73462, '\p{Is_InPC= Left}', "");
    Expect(1, 73462, '\p{^Is_InPC= Left}', "");
    Expect(1, 73462, '\P{Is_InPC= Left}', "");
    Expect(0, 73462, '\P{^Is_InPC= Left}', "");
    Error('\p{Indic_Positional_Category=	:=left_And_Right}');
    Error('\P{Indic_Positional_Category=	:=left_And_Right}');
    Expect(1, 71098, '\p{Indic_Positional_Category=:\ALeft_And_Right\z:}', "");;
    Expect(0, 71099, '\p{Indic_Positional_Category=:\ALeft_And_Right\z:}', "");;
    Expect(1, 71098, '\p{Indic_Positional_Category:	leftandright}', "");
    Expect(0, 71098, '\p{^Indic_Positional_Category:	leftandright}', "");
    Expect(0, 71098, '\P{Indic_Positional_Category:	leftandright}', "");
    Expect(1, 71098, '\P{^Indic_Positional_Category:	leftandright}', "");
    Expect(0, 71099, '\p{Indic_Positional_Category:	leftandright}', "");
    Expect(1, 71099, '\p{^Indic_Positional_Category:	leftandright}', "");
    Expect(1, 71099, '\P{Indic_Positional_Category:	leftandright}', "");
    Expect(0, 71099, '\P{^Indic_Positional_Category:	leftandright}', "");
    Expect(1, 71098, '\p{Indic_Positional_Category=:\Aleftandright\z:}', "");;
    Expect(0, 71099, '\p{Indic_Positional_Category=:\Aleftandright\z:}', "");;
    Expect(1, 71098, '\p{Indic_Positional_Category=	-Left_And_RIGHT}', "");
    Expect(0, 71098, '\p{^Indic_Positional_Category=	-Left_And_RIGHT}', "");
    Expect(0, 71098, '\P{Indic_Positional_Category=	-Left_And_RIGHT}', "");
    Expect(1, 71098, '\P{^Indic_Positional_Category=	-Left_And_RIGHT}', "");
    Expect(0, 71099, '\p{Indic_Positional_Category=	-Left_And_RIGHT}', "");
    Expect(1, 71099, '\p{^Indic_Positional_Category=	-Left_And_RIGHT}', "");
    Expect(1, 71099, '\P{Indic_Positional_Category=	-Left_And_RIGHT}', "");
    Expect(0, 71099, '\P{^Indic_Positional_Category=	-Left_And_RIGHT}', "");
    Error('\p{InPC=	_Left_And_right:=}');
    Error('\P{InPC=	_Left_And_right:=}');
    Expect(1, 71098, '\p{InPC=:\ALeft_And_Right\z:}', "");;
    Expect(0, 71099, '\p{InPC=:\ALeft_And_Right\z:}', "");;
    Expect(1, 71098, '\p{InPC=leftandright}', "");
    Expect(0, 71098, '\p{^InPC=leftandright}', "");
    Expect(0, 71098, '\P{InPC=leftandright}', "");
    Expect(1, 71098, '\P{^InPC=leftandright}', "");
    Expect(0, 71099, '\p{InPC=leftandright}', "");
    Expect(1, 71099, '\p{^InPC=leftandright}', "");
    Expect(1, 71099, '\P{InPC=leftandright}', "");
    Expect(0, 71099, '\P{^InPC=leftandright}', "");
    Expect(1, 71098, '\p{InPC=:\Aleftandright\z:}', "");;
    Expect(0, 71099, '\p{InPC=:\Aleftandright\z:}', "");;
    Expect(1, 71098, '\p{InPC=-LEFT_and_Right}', "");
    Expect(0, 71098, '\p{^InPC=-LEFT_and_Right}', "");
    Expect(0, 71098, '\P{InPC=-LEFT_and_Right}', "");
    Expect(1, 71098, '\P{^InPC=-LEFT_and_Right}', "");
    Expect(0, 71099, '\p{InPC=-LEFT_and_Right}', "");
    Expect(1, 71099, '\p{^InPC=-LEFT_and_Right}', "");
    Expect(1, 71099, '\P{InPC=-LEFT_and_Right}', "");
    Expect(0, 71099, '\P{^InPC=-LEFT_and_Right}', "");
    Error('\p{Is_Indic_Positional_Category= :=LEFT_And_Right}');
    Error('\P{Is_Indic_Positional_Category= :=LEFT_And_Right}');
    Expect(1, 71098, '\p{Is_Indic_Positional_Category=leftandright}', "");
    Expect(0, 71098, '\p{^Is_Indic_Positional_Category=leftandright}', "");
    Expect(0, 71098, '\P{Is_Indic_Positional_Category=leftandright}', "");
    Expect(1, 71098, '\P{^Is_Indic_Positional_Category=leftandright}', "");
    Expect(0, 71099, '\p{Is_Indic_Positional_Category=leftandright}', "");
    Expect(1, 71099, '\p{^Is_Indic_Positional_Category=leftandright}', "");
    Expect(1, 71099, '\P{Is_Indic_Positional_Category=leftandright}', "");
    Expect(0, 71099, '\P{^Is_Indic_Positional_Category=leftandright}', "");
    Expect(1, 71098, '\p{Is_Indic_Positional_Category=--left_AND_right}', "");
    Expect(0, 71098, '\p{^Is_Indic_Positional_Category=--left_AND_right}', "");
    Expect(0, 71098, '\P{Is_Indic_Positional_Category=--left_AND_right}', "");
    Expect(1, 71098, '\P{^Is_Indic_Positional_Category=--left_AND_right}', "");
    Expect(0, 71099, '\p{Is_Indic_Positional_Category=--left_AND_right}', "");
    Expect(1, 71099, '\p{^Is_Indic_Positional_Category=--left_AND_right}', "");
    Expect(1, 71099, '\P{Is_Indic_Positional_Category=--left_AND_right}', "");
    Expect(0, 71099, '\P{^Is_Indic_Positional_Category=--left_AND_right}', "");
    Error('\p{Is_InPC=_/a/left_And_RIGHT}');
    Error('\P{Is_InPC=_/a/left_And_RIGHT}');
    Expect(1, 71098, '\p{Is_InPC:	leftandright}', "");
    Expect(0, 71098, '\p{^Is_InPC:	leftandright}', "");
    Expect(0, 71098, '\P{Is_InPC:	leftandright}', "");
    Expect(1, 71098, '\P{^Is_InPC:	leftandright}', "");
    Expect(0, 71099, '\p{Is_InPC:	leftandright}', "");
    Expect(1, 71099, '\p{^Is_InPC:	leftandright}', "");
    Expect(1, 71099, '\P{Is_InPC:	leftandright}', "");
    Expect(0, 71099, '\P{^Is_InPC:	leftandright}', "");
    Expect(1, 71098, '\p{Is_InPC= _Left_AND_RIGHT}', "");
    Expect(0, 71098, '\p{^Is_InPC= _Left_AND_RIGHT}', "");
    Expect(0, 71098, '\P{Is_InPC= _Left_AND_RIGHT}', "");
    Expect(1, 71098, '\P{^Is_InPC= _Left_AND_RIGHT}', "");
    Expect(0, 71099, '\p{Is_InPC= _Left_AND_RIGHT}', "");
    Expect(1, 71099, '\p{^Is_InPC= _Left_AND_RIGHT}', "");
    Expect(1, 71099, '\P{Is_InPC= _Left_AND_RIGHT}', "");
    Expect(0, 71099, '\P{^Is_InPC= _Left_AND_RIGHT}', "");
    Error('\p{Indic_Positional_Category:	 /a/NA}');
    Error('\P{Indic_Positional_Category:	 /a/NA}');
    Expect(1, 73463, '\p{Indic_Positional_Category=:\ANA\z:}', "");;
    Expect(0, 73462, '\p{Indic_Positional_Category=:\ANA\z:}', "");;
    Expect(1, 73463, '\p{Indic_Positional_Category=na}', "");
    Expect(0, 73463, '\p{^Indic_Positional_Category=na}', "");
    Expect(0, 73463, '\P{Indic_Positional_Category=na}', "");
    Expect(1, 73463, '\P{^Indic_Positional_Category=na}', "");
    Expect(0, 73462, '\p{Indic_Positional_Category=na}', "");
    Expect(1, 73462, '\p{^Indic_Positional_Category=na}', "");
    Expect(1, 73462, '\P{Indic_Positional_Category=na}', "");
    Expect(0, 73462, '\P{^Indic_Positional_Category=na}', "");
    Expect(1, 73463, '\p{Indic_Positional_Category=:\Ana\z:}', "");;
    Expect(0, 73462, '\p{Indic_Positional_Category=:\Ana\z:}', "");;
    Expect(1, 73463, '\p{Indic_Positional_Category=	_NA}', "");
    Expect(0, 73463, '\p{^Indic_Positional_Category=	_NA}', "");
    Expect(0, 73463, '\P{Indic_Positional_Category=	_NA}', "");
    Expect(1, 73463, '\P{^Indic_Positional_Category=	_NA}', "");
    Expect(0, 73462, '\p{Indic_Positional_Category=	_NA}', "");
    Expect(1, 73462, '\p{^Indic_Positional_Category=	_NA}', "");
    Expect(1, 73462, '\P{Indic_Positional_Category=	_NA}', "");
    Expect(0, 73462, '\P{^Indic_Positional_Category=	_NA}', "");
    Error('\p{InPC=:=NA}');
    Error('\P{InPC=:=NA}');
    Expect(1, 73463, '\p{InPC=:\ANA\z:}', "");;
    Expect(0, 73462, '\p{InPC=:\ANA\z:}', "");;
    Expect(1, 73463, '\p{InPC=na}', "");
    Expect(0, 73463, '\p{^InPC=na}', "");
    Expect(0, 73463, '\P{InPC=na}', "");
    Expect(1, 73463, '\P{^InPC=na}', "");
    Expect(0, 73462, '\p{InPC=na}', "");
    Expect(1, 73462, '\p{^InPC=na}', "");
    Expect(1, 73462, '\P{InPC=na}', "");
    Expect(0, 73462, '\P{^InPC=na}', "");
    Expect(1, 73463, '\p{InPC=:\Ana\z:}', "");;
    Expect(0, 73462, '\p{InPC=:\Ana\z:}', "");;
    Expect(1, 73463, '\p{InPC=_NA}', "");
    Expect(0, 73463, '\p{^InPC=_NA}', "");
    Expect(0, 73463, '\P{InPC=_NA}', "");
    Expect(1, 73463, '\P{^InPC=_NA}', "");
    Expect(0, 73462, '\p{InPC=_NA}', "");
    Expect(1, 73462, '\p{^InPC=_NA}', "");
    Expect(1, 73462, '\P{InPC=_NA}', "");
    Expect(0, 73462, '\P{^InPC=_NA}', "");
    Error('\p{Is_Indic_Positional_Category=-NA:=}');
    Error('\P{Is_Indic_Positional_Category=-NA:=}');
    Expect(1, 73463, '\p{Is_Indic_Positional_Category=na}', "");
    Expect(0, 73463, '\p{^Is_Indic_Positional_Category=na}', "");
    Expect(0, 73463, '\P{Is_Indic_Positional_Category=na}', "");
    Expect(1, 73463, '\P{^Is_Indic_Positional_Category=na}', "");
    Expect(0, 73462, '\p{Is_Indic_Positional_Category=na}', "");
    Expect(1, 73462, '\p{^Is_Indic_Positional_Category=na}', "");
    Expect(1, 73462, '\P{Is_Indic_Positional_Category=na}', "");
    Expect(0, 73462, '\P{^Is_Indic_Positional_Category=na}', "");
    Expect(1, 73463, '\p{Is_Indic_Positional_Category=_NA}', "");
    Expect(0, 73463, '\p{^Is_Indic_Positional_Category=_NA}', "");
    Expect(0, 73463, '\P{Is_Indic_Positional_Category=_NA}', "");
    Expect(1, 73463, '\P{^Is_Indic_Positional_Category=_NA}', "");
    Expect(0, 73462, '\p{Is_Indic_Positional_Category=_NA}', "");
    Expect(1, 73462, '\p{^Is_Indic_Positional_Category=_NA}', "");
    Expect(1, 73462, '\P{Is_Indic_Positional_Category=_NA}', "");
    Expect(0, 73462, '\P{^Is_Indic_Positional_Category=_NA}', "");
    Error('\p{Is_InPC=:=	_NA}');
    Error('\P{Is_InPC=:=	_NA}');
    Expect(1, 73463, '\p{Is_InPC=na}', "");
    Expect(0, 73463, '\p{^Is_InPC=na}', "");
    Expect(0, 73463, '\P{Is_InPC=na}', "");
    Expect(1, 73463, '\P{^Is_InPC=na}', "");
    Expect(0, 73462, '\p{Is_InPC=na}', "");
    Expect(1, 73462, '\p{^Is_InPC=na}', "");
    Expect(1, 73462, '\P{Is_InPC=na}', "");
    Expect(0, 73462, '\P{^Is_InPC=na}', "");
    Expect(1, 73463, '\p{Is_InPC=	 NA}', "");
    Expect(0, 73463, '\p{^Is_InPC=	 NA}', "");
    Expect(0, 73463, '\P{Is_InPC=	 NA}', "");
    Expect(1, 73463, '\P{^Is_InPC=	 NA}', "");
    Expect(0, 73462, '\p{Is_InPC=	 NA}', "");
    Expect(1, 73462, '\p{^Is_InPC=	 NA}', "");
    Expect(1, 73462, '\P{Is_InPC=	 NA}', "");
    Expect(0, 73462, '\P{^Is_InPC=	 NA}', "");
    Error('\p{Indic_Positional_Category=/a/ 	Overstruck}');
    Error('\P{Indic_Positional_Category=/a/ 	Overstruck}');
    Expect(1, 68102, '\p{Indic_Positional_Category=:\AOverstruck\z:}', "");;
    Expect(0, 68103, '\p{Indic_Positional_Category=:\AOverstruck\z:}', "");;
    Expect(1, 68102, '\p{Indic_Positional_Category=overstruck}', "");
    Expect(0, 68102, '\p{^Indic_Positional_Category=overstruck}', "");
    Expect(0, 68102, '\P{Indic_Positional_Category=overstruck}', "");
    Expect(1, 68102, '\P{^Indic_Positional_Category=overstruck}', "");
    Expect(0, 68103, '\p{Indic_Positional_Category=overstruck}', "");
    Expect(1, 68103, '\p{^Indic_Positional_Category=overstruck}', "");
    Expect(1, 68103, '\P{Indic_Positional_Category=overstruck}', "");
    Expect(0, 68103, '\P{^Indic_Positional_Category=overstruck}', "");
    Expect(1, 68102, '\p{Indic_Positional_Category=:\Aoverstruck\z:}', "");;
    Expect(0, 68103, '\p{Indic_Positional_Category=:\Aoverstruck\z:}', "");;
    Expect(1, 68102, '\p{Indic_Positional_Category=-OVERSTRUCK}', "");
    Expect(0, 68102, '\p{^Indic_Positional_Category=-OVERSTRUCK}', "");
    Expect(0, 68102, '\P{Indic_Positional_Category=-OVERSTRUCK}', "");
    Expect(1, 68102, '\P{^Indic_Positional_Category=-OVERSTRUCK}', "");
    Expect(0, 68103, '\p{Indic_Positional_Category=-OVERSTRUCK}', "");
    Expect(1, 68103, '\p{^Indic_Positional_Category=-OVERSTRUCK}', "");
    Expect(1, 68103, '\P{Indic_Positional_Category=-OVERSTRUCK}', "");
    Expect(0, 68103, '\P{^Indic_Positional_Category=-OVERSTRUCK}', "");
    Error('\p{InPC=	:=overstruck}');
    Error('\P{InPC=	:=overstruck}');
    Expect(1, 68102, '\p{InPC=:\AOverstruck\z:}', "");;
    Expect(0, 68103, '\p{InPC=:\AOverstruck\z:}', "");;
    Expect(1, 68102, '\p{InPC=overstruck}', "");
    Expect(0, 68102, '\p{^InPC=overstruck}', "");
    Expect(0, 68102, '\P{InPC=overstruck}', "");
    Expect(1, 68102, '\P{^InPC=overstruck}', "");
    Expect(0, 68103, '\p{InPC=overstruck}', "");
    Expect(1, 68103, '\p{^InPC=overstruck}', "");
    Expect(1, 68103, '\P{InPC=overstruck}', "");
    Expect(0, 68103, '\P{^InPC=overstruck}', "");
    Expect(1, 68102, '\p{InPC=:\Aoverstruck\z:}', "");;
    Expect(0, 68103, '\p{InPC=:\Aoverstruck\z:}', "");;
    Expect(1, 68102, '\p{InPC:	-OVERSTRUCK}', "");
    Expect(0, 68102, '\p{^InPC:	-OVERSTRUCK}', "");
    Expect(0, 68102, '\P{InPC:	-OVERSTRUCK}', "");
    Expect(1, 68102, '\P{^InPC:	-OVERSTRUCK}', "");
    Expect(0, 68103, '\p{InPC:	-OVERSTRUCK}', "");
    Expect(1, 68103, '\p{^InPC:	-OVERSTRUCK}', "");
    Expect(1, 68103, '\P{InPC:	-OVERSTRUCK}', "");
    Expect(0, 68103, '\P{^InPC:	-OVERSTRUCK}', "");
    Error('\p{Is_Indic_Positional_Category=:=-	Overstruck}');
    Error('\P{Is_Indic_Positional_Category=:=-	Overstruck}');
    Expect(1, 68102, '\p{Is_Indic_Positional_Category=overstruck}', "");
    Expect(0, 68102, '\p{^Is_Indic_Positional_Category=overstruck}', "");
    Expect(0, 68102, '\P{Is_Indic_Positional_Category=overstruck}', "");
    Expect(1, 68102, '\P{^Is_Indic_Positional_Category=overstruck}', "");
    Expect(0, 68103, '\p{Is_Indic_Positional_Category=overstruck}', "");
    Expect(1, 68103, '\p{^Is_Indic_Positional_Category=overstruck}', "");
    Expect(1, 68103, '\P{Is_Indic_Positional_Category=overstruck}', "");
    Expect(0, 68103, '\P{^Is_Indic_Positional_Category=overstruck}', "");
    Expect(1, 68102, '\p{Is_Indic_Positional_Category=-OVERSTRUCK}', "");
    Expect(0, 68102, '\p{^Is_Indic_Positional_Category=-OVERSTRUCK}', "");
    Expect(0, 68102, '\P{Is_Indic_Positional_Category=-OVERSTRUCK}', "");
    Expect(1, 68102, '\P{^Is_Indic_Positional_Category=-OVERSTRUCK}', "");
    Expect(0, 68103, '\p{Is_Indic_Positional_Category=-OVERSTRUCK}', "");
    Expect(1, 68103, '\p{^Is_Indic_Positional_Category=-OVERSTRUCK}', "");
    Expect(1, 68103, '\P{Is_Indic_Positional_Category=-OVERSTRUCK}', "");
    Expect(0, 68103, '\P{^Is_Indic_Positional_Category=-OVERSTRUCK}', "");
    Error('\p{Is_InPC= :=overstruck}');
    Error('\P{Is_InPC= :=overstruck}');
    Expect(1, 68102, '\p{Is_InPC=overstruck}', "");
    Expect(0, 68102, '\p{^Is_InPC=overstruck}', "");
    Expect(0, 68102, '\P{Is_InPC=overstruck}', "");
    Expect(1, 68102, '\P{^Is_InPC=overstruck}', "");
    Expect(0, 68103, '\p{Is_InPC=overstruck}', "");
    Expect(1, 68103, '\p{^Is_InPC=overstruck}', "");
    Expect(1, 68103, '\P{Is_InPC=overstruck}', "");
    Expect(0, 68103, '\P{^Is_InPC=overstruck}', "");
    Expect(1, 68102, '\p{Is_InPC=	OVERSTRUCK}', "");
    Expect(0, 68102, '\p{^Is_InPC=	OVERSTRUCK}', "");
    Expect(0, 68102, '\P{Is_InPC=	OVERSTRUCK}', "");
    Expect(1, 68102, '\P{^Is_InPC=	OVERSTRUCK}', "");
    Expect(0, 68103, '\p{Is_InPC=	OVERSTRUCK}', "");
    Expect(1, 68103, '\p{^Is_InPC=	OVERSTRUCK}', "");
    Expect(1, 68103, '\P{Is_InPC=	OVERSTRUCK}', "");
    Expect(0, 68103, '\P{^Is_InPC=	OVERSTRUCK}', "");
    Error('\p{Indic_Positional_Category=-:=Right}');
    Error('\P{Indic_Positional_Category=-:=Right}');
    Expect(1, 73462, '\p{Indic_Positional_Category=:\ARight\z:}', "");;
    Expect(0, 73463, '\p{Indic_Positional_Category=:\ARight\z:}', "");;
    Expect(1, 73462, '\p{Indic_Positional_Category=right}', "");
    Expect(0, 73462, '\p{^Indic_Positional_Category=right}', "");
    Expect(0, 73462, '\P{Indic_Positional_Category=right}', "");
    Expect(1, 73462, '\P{^Indic_Positional_Category=right}', "");
    Expect(0, 73463, '\p{Indic_Positional_Category=right}', "");
    Expect(1, 73463, '\p{^Indic_Positional_Category=right}', "");
    Expect(1, 73463, '\P{Indic_Positional_Category=right}', "");
    Expect(0, 73463, '\P{^Indic_Positional_Category=right}', "");
    Expect(1, 73462, '\p{Indic_Positional_Category=:\Aright\z:}', "");;
    Expect(0, 73463, '\p{Indic_Positional_Category=:\Aright\z:}', "");;
    Expect(1, 73462, '\p{Indic_Positional_Category=-	Right}', "");
    Expect(0, 73462, '\p{^Indic_Positional_Category=-	Right}', "");
    Expect(0, 73462, '\P{Indic_Positional_Category=-	Right}', "");
    Expect(1, 73462, '\P{^Indic_Positional_Category=-	Right}', "");
    Expect(0, 73463, '\p{Indic_Positional_Category=-	Right}', "");
    Expect(1, 73463, '\p{^Indic_Positional_Category=-	Right}', "");
    Expect(1, 73463, '\P{Indic_Positional_Category=-	Right}', "");
    Expect(0, 73463, '\P{^Indic_Positional_Category=-	Right}', "");
    Error('\p{InPC=	_Right/a/}');
    Error('\P{InPC=	_Right/a/}');
    Expect(1, 73462, '\p{InPC=:\ARight\z:}', "");;
    Expect(0, 73463, '\p{InPC=:\ARight\z:}', "");;
    Expect(1, 73462, '\p{InPC=right}', "");
    Expect(0, 73462, '\p{^InPC=right}', "");
    Expect(0, 73462, '\P{InPC=right}', "");
    Expect(1, 73462, '\P{^InPC=right}', "");
    Expect(0, 73463, '\p{InPC=right}', "");
    Expect(1, 73463, '\p{^InPC=right}', "");
    Expect(1, 73463, '\P{InPC=right}', "");
    Expect(0, 73463, '\P{^InPC=right}', "");
    Expect(1, 73462, '\p{InPC=:\Aright\z:}', "");;
    Expect(0, 73463, '\p{InPC=:\Aright\z:}', "");;
    Expect(1, 73462, '\p{InPC=_	Right}', "");
    Expect(0, 73462, '\p{^InPC=_	Right}', "");
    Expect(0, 73462, '\P{InPC=_	Right}', "");
    Expect(1, 73462, '\P{^InPC=_	Right}', "");
    Expect(0, 73463, '\p{InPC=_	Right}', "");
    Expect(1, 73463, '\p{^InPC=_	Right}', "");
    Expect(1, 73463, '\P{InPC=_	Right}', "");
    Expect(0, 73463, '\P{^InPC=_	Right}', "");
    Error('\p{Is_Indic_Positional_Category=	:=Right}');
    Error('\P{Is_Indic_Positional_Category=	:=Right}');
    Expect(1, 73462, '\p{Is_Indic_Positional_Category=right}', "");
    Expect(0, 73462, '\p{^Is_Indic_Positional_Category=right}', "");
    Expect(0, 73462, '\P{Is_Indic_Positional_Category=right}', "");
    Expect(1, 73462, '\P{^Is_Indic_Positional_Category=right}', "");
    Expect(0, 73463, '\p{Is_Indic_Positional_Category=right}', "");
    Expect(1, 73463, '\p{^Is_Indic_Positional_Category=right}', "");
    Expect(1, 73463, '\P{Is_Indic_Positional_Category=right}', "");
    Expect(0, 73463, '\P{^Is_Indic_Positional_Category=right}', "");
    Expect(1, 73462, '\p{Is_Indic_Positional_Category= right}', "");
    Expect(0, 73462, '\p{^Is_Indic_Positional_Category= right}', "");
    Expect(0, 73462, '\P{Is_Indic_Positional_Category= right}', "");
    Expect(1, 73462, '\P{^Is_Indic_Positional_Category= right}', "");
    Expect(0, 73463, '\p{Is_Indic_Positional_Category= right}', "");
    Expect(1, 73463, '\p{^Is_Indic_Positional_Category= right}', "");
    Expect(1, 73463, '\P{Is_Indic_Positional_Category= right}', "");
    Expect(0, 73463, '\P{^Is_Indic_Positional_Category= right}', "");
    Error('\p{Is_InPC=-:=RIGHT}');
    Error('\P{Is_InPC=-:=RIGHT}');
    Expect(1, 73462, '\p{Is_InPC=right}', "");
    Expect(0, 73462, '\p{^Is_InPC=right}', "");
    Expect(0, 73462, '\P{Is_InPC=right}', "");
    Expect(1, 73462, '\P{^Is_InPC=right}', "");
    Expect(0, 73463, '\p{Is_InPC=right}', "");
    Expect(1, 73463, '\p{^Is_InPC=right}', "");
    Expect(1, 73463, '\P{Is_InPC=right}', "");
    Expect(0, 73463, '\P{^Is_InPC=right}', "");
    Expect(1, 73462, '\p{Is_InPC=_	RIGHT}', "");
    Expect(0, 73462, '\p{^Is_InPC=_	RIGHT}', "");
    Expect(0, 73462, '\P{Is_InPC=_	RIGHT}', "");
    Expect(1, 73462, '\P{^Is_InPC=_	RIGHT}', "");
    Expect(0, 73463, '\p{Is_InPC=_	RIGHT}', "");
    Expect(1, 73463, '\p{^Is_InPC=_	RIGHT}', "");
    Expect(1, 73463, '\P{Is_InPC=_	RIGHT}', "");
    Expect(0, 73463, '\P{^Is_InPC=_	RIGHT}', "");
    Error('\p{Indic_Positional_Category=--top/a/}');
    Error('\P{Indic_Positional_Category=--top/a/}');
    Expect(1, 73459, '\p{Indic_Positional_Category=:\ATop\z:}', "");;
    Expect(0, 73460, '\p{Indic_Positional_Category=:\ATop\z:}', "");;
    Expect(1, 73459, '\p{Indic_Positional_Category=top}', "");
    Expect(0, 73459, '\p{^Indic_Positional_Category=top}', "");
    Expect(0, 73459, '\P{Indic_Positional_Category=top}', "");
    Expect(1, 73459, '\P{^Indic_Positional_Category=top}', "");
    Expect(0, 73460, '\p{Indic_Positional_Category=top}', "");
    Expect(1, 73460, '\p{^Indic_Positional_Category=top}', "");
    Expect(1, 73460, '\P{Indic_Positional_Category=top}', "");
    Expect(0, 73460, '\P{^Indic_Positional_Category=top}', "");
    Expect(1, 73459, '\p{Indic_Positional_Category=:\Atop\z:}', "");;
    Expect(0, 73460, '\p{Indic_Positional_Category=:\Atop\z:}', "");;
    Expect(1, 73459, '\p{Indic_Positional_Category:    TOP}', "");
    Expect(0, 73459, '\p{^Indic_Positional_Category:    TOP}', "");
    Expect(0, 73459, '\P{Indic_Positional_Category:    TOP}', "");
    Expect(1, 73459, '\P{^Indic_Positional_Category:    TOP}', "");
    Expect(0, 73460, '\p{Indic_Positional_Category:    TOP}', "");
    Expect(1, 73460, '\p{^Indic_Positional_Category:    TOP}', "");
    Expect(1, 73460, '\P{Indic_Positional_Category:    TOP}', "");
    Expect(0, 73460, '\P{^Indic_Positional_Category:    TOP}', "");
    Error('\p{InPC:   _-top:=}');
    Error('\P{InPC:   _-top:=}');
    Expect(1, 73459, '\p{InPC=:\ATop\z:}', "");;
    Expect(0, 73460, '\p{InPC=:\ATop\z:}', "");;
    Expect(1, 73459, '\p{InPC=top}', "");
    Expect(0, 73459, '\p{^InPC=top}', "");
    Expect(0, 73459, '\P{InPC=top}', "");
    Expect(1, 73459, '\P{^InPC=top}', "");
    Expect(0, 73460, '\p{InPC=top}', "");
    Expect(1, 73460, '\p{^InPC=top}', "");
    Expect(1, 73460, '\P{InPC=top}', "");
    Expect(0, 73460, '\P{^InPC=top}', "");
    Expect(1, 73459, '\p{InPC=:\Atop\z:}', "");;
    Expect(0, 73460, '\p{InPC=:\Atop\z:}', "");;
    Expect(1, 73459, '\p{InPC=--top}', "");
    Expect(0, 73459, '\p{^InPC=--top}', "");
    Expect(0, 73459, '\P{InPC=--top}', "");
    Expect(1, 73459, '\P{^InPC=--top}', "");
    Expect(0, 73460, '\p{InPC=--top}', "");
    Expect(1, 73460, '\p{^InPC=--top}', "");
    Expect(1, 73460, '\P{InPC=--top}', "");
    Expect(0, 73460, '\P{^InPC=--top}', "");
    Error('\p{Is_Indic_Positional_Category=	-Top/a/}');
    Error('\P{Is_Indic_Positional_Category=	-Top/a/}');
    Expect(1, 73459, '\p{Is_Indic_Positional_Category=top}', "");
    Expect(0, 73459, '\p{^Is_Indic_Positional_Category=top}', "");
    Expect(0, 73459, '\P{Is_Indic_Positional_Category=top}', "");
    Expect(1, 73459, '\P{^Is_Indic_Positional_Category=top}', "");
    Expect(0, 73460, '\p{Is_Indic_Positional_Category=top}', "");
    Expect(1, 73460, '\p{^Is_Indic_Positional_Category=top}', "");
    Expect(1, 73460, '\P{Is_Indic_Positional_Category=top}', "");
    Expect(0, 73460, '\P{^Is_Indic_Positional_Category=top}', "");
    Expect(1, 73459, '\p{Is_Indic_Positional_Category= -Top}', "");
    Expect(0, 73459, '\p{^Is_Indic_Positional_Category= -Top}', "");
    Expect(0, 73459, '\P{Is_Indic_Positional_Category= -Top}', "");
    Expect(1, 73459, '\P{^Is_Indic_Positional_Category= -Top}', "");
    Expect(0, 73460, '\p{Is_Indic_Positional_Category= -Top}', "");
    Expect(1, 73460, '\p{^Is_Indic_Positional_Category= -Top}', "");
    Expect(1, 73460, '\P{Is_Indic_Positional_Category= -Top}', "");
    Expect(0, 73460, '\P{^Is_Indic_Positional_Category= -Top}', "");
    Error('\p{Is_InPC= Top/a/}');
    Error('\P{Is_InPC= Top/a/}');
    Expect(1, 73459, '\p{Is_InPC=top}', "");
    Expect(0, 73459, '\p{^Is_InPC=top}', "");
    Expect(0, 73459, '\P{Is_InPC=top}', "");
    Expect(1, 73459, '\P{^Is_InPC=top}', "");
    Expect(0, 73460, '\p{Is_InPC=top}', "");
    Expect(1, 73460, '\p{^Is_InPC=top}', "");
    Expect(1, 73460, '\P{Is_InPC=top}', "");
    Expect(0, 73460, '\P{^Is_InPC=top}', "");
    Expect(1, 73459, '\p{Is_InPC= -Top}', "");
    Expect(0, 73459, '\p{^Is_InPC= -Top}', "");
    Expect(0, 73459, '\P{Is_InPC= -Top}', "");
    Expect(1, 73459, '\P{^Is_InPC= -Top}', "");
    Expect(0, 73460, '\p{Is_InPC= -Top}', "");
    Expect(1, 73460, '\p{^Is_InPC= -Top}', "");
    Expect(1, 73460, '\P{Is_InPC= -Top}', "");
    Expect(0, 73460, '\P{^Is_InPC= -Top}', "");
    Error('\p{Indic_Positional_Category=/a/	Top_AND_bottom}');
    Error('\P{Indic_Positional_Category=/a/	Top_AND_bottom}');
    Expect(1, 69935, '\p{Indic_Positional_Category=:\ATop_And_Bottom\z:}', "");;
    Expect(0, 69936, '\p{Indic_Positional_Category=:\ATop_And_Bottom\z:}', "");;
    Expect(1, 69935, '\p{Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69935, '\p{^Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69935, '\P{Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69935, '\P{^Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69936, '\p{Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69936, '\p{^Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69936, '\P{Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69936, '\P{^Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69935, '\p{Indic_Positional_Category=:\Atopandbottom\z:}', "");;
    Expect(0, 69936, '\p{Indic_Positional_Category=:\Atopandbottom\z:}', "");;
    Expect(1, 69935, '\p{Indic_Positional_Category: top_and_bottom}', "");
    Expect(0, 69935, '\p{^Indic_Positional_Category: top_and_bottom}', "");
    Expect(0, 69935, '\P{Indic_Positional_Category: top_and_bottom}', "");
    Expect(1, 69935, '\P{^Indic_Positional_Category: top_and_bottom}', "");
    Expect(0, 69936, '\p{Indic_Positional_Category: top_and_bottom}', "");
    Expect(1, 69936, '\p{^Indic_Positional_Category: top_and_bottom}', "");
    Expect(1, 69936, '\P{Indic_Positional_Category: top_and_bottom}', "");
    Expect(0, 69936, '\P{^Indic_Positional_Category: top_and_bottom}', "");
    Error('\p{InPC=	/a/Top_and_bottom}');
    Error('\P{InPC=	/a/Top_and_bottom}');
    Expect(1, 69935, '\p{InPC=:\ATop_And_Bottom\z:}', "");;
    Expect(0, 69936, '\p{InPC=:\ATop_And_Bottom\z:}', "");;
    Expect(1, 69935, '\p{InPC=topandbottom}', "");
    Expect(0, 69935, '\p{^InPC=topandbottom}', "");
    Expect(0, 69935, '\P{InPC=topandbottom}', "");
    Expect(1, 69935, '\P{^InPC=topandbottom}', "");
    Expect(0, 69936, '\p{InPC=topandbottom}', "");
    Expect(1, 69936, '\p{^InPC=topandbottom}', "");
    Expect(1, 69936, '\P{InPC=topandbottom}', "");
    Expect(0, 69936, '\P{^InPC=topandbottom}', "");
    Expect(1, 69935, '\p{InPC=:\Atopandbottom\z:}', "");;
    Expect(0, 69936, '\p{InPC=:\Atopandbottom\z:}', "");;
    Expect(1, 69935, '\p{InPC=-	top_and_Bottom}', "");
    Expect(0, 69935, '\p{^InPC=-	top_and_Bottom}', "");
    Expect(0, 69935, '\P{InPC=-	top_and_Bottom}', "");
    Expect(1, 69935, '\P{^InPC=-	top_and_Bottom}', "");
    Expect(0, 69936, '\p{InPC=-	top_and_Bottom}', "");
    Expect(1, 69936, '\p{^InPC=-	top_and_Bottom}', "");
    Expect(1, 69936, '\P{InPC=-	top_and_Bottom}', "");
    Expect(0, 69936, '\P{^InPC=-	top_and_Bottom}', "");
    Error('\p{Is_Indic_Positional_Category=:=_top_AND_bottom}');
    Error('\P{Is_Indic_Positional_Category=:=_top_AND_bottom}');
    Expect(1, 69935, '\p{Is_Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69935, '\p{^Is_Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69935, '\P{Is_Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69935, '\P{^Is_Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69936, '\p{Is_Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69936, '\p{^Is_Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69936, '\P{Is_Indic_Positional_Category=topandbottom}', "");
    Expect(0, 69936, '\P{^Is_Indic_Positional_Category=topandbottom}', "");
    Expect(1, 69935, '\p{Is_Indic_Positional_Category=	 TOP_And_Bottom}', "");
    Expect(0, 69935, '\p{^Is_Indic_Positional_Category=	 TOP_And_Bottom}', "");
    Expect(0, 69935, '\P{Is_Indic_Positional_Category=	 TOP_And_Bottom}', "");
    Expect(1, 69935, '\P{^Is_Indic_Positional_Category=	 TOP_And_Bottom}', "");
    Expect(0, 69936, '\p{Is_Indic_Positional_Category=	 TOP_And_Bottom}', "");
    Expect(1, 69936, '\p{^Is_Indic_Positional_Category=	 TOP_And_Bottom}', "");
    Expect(1, 69936, '\P{Is_Indic_Positional_Category=	 TOP_And_Bottom}', "");
    Expect(0, 69936, '\P{^Is_Indic_Positional_Category=	 TOP_And_Bottom}', "");
    Error('\p{Is_InPC=-:=top_And_BOTTOM}');
    Error('\P{Is_InPC=-:=top_And_BOTTOM}');
    Expect(1, 69935, '\p{Is_InPC=topandbottom}', "");
    Expect(0, 69935, '\p{^Is_InPC=topandbottom}', "");
    Expect(0, 69935, '\P{Is_InPC=topandbottom}', "");
    Expect(1, 69935, '\P{^Is_InPC=topandbottom}', "");
    Expect(0, 69936, '\p{Is_InPC=topandbottom}', "");
    Expect(1, 69936, '\p{^Is_InPC=topandbottom}', "");
    Expect(1, 69936, '\P{Is_InPC=topandbottom}', "");
    Expect(0, 69936, '\P{^Is_InPC=topandbottom}', "");
    Expect(1, 69935, '\p{Is_InPC=Top_And_Bottom}', "");
    Expect(0, 69935, '\p{^Is_InPC=Top_And_Bottom}', "");
    Expect(0, 69935, '\P{Is_InPC=Top_And_Bottom}', "");
    Expect(1, 69935, '\P{^Is_InPC=Top_And_Bottom}', "");
    Expect(0, 69936, '\p{Is_InPC=Top_And_Bottom}', "");
    Expect(1, 69936, '\p{^Is_InPC=Top_And_Bottom}', "");
    Expect(1, 69936, '\P{Is_InPC=Top_And_Bottom}', "");
    Expect(0, 69936, '\P{^Is_InPC=Top_And_Bottom}', "");
    Error('\p{Indic_Positional_Category=/a/ TOP_And_Bottom_And_Right}');
    Error('\P{Indic_Positional_Category=/a/ TOP_And_Bottom_And_Right}');
    Expect(1, 6973, '\p{Indic_Positional_Category=:\ATop_And_Bottom_And_Right\z:}', "");;
    Expect(0, 6974, '\p{Indic_Positional_Category=:\ATop_And_Bottom_And_Right\z:}', "");;
    Expect(1, 6973, '\p{Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6973, '\p{^Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6973, '\P{Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6973, '\P{^Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6974, '\p{Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6974, '\p{^Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6974, '\P{Indic_Positional_Category=topandbottomandright}', "");
    Expect(0, 6974, '\P{^Indic_Positional_Category=topandbottomandright}', "");
    Expect(1, 6973, '\p{Indic_Positional_Category=:\Atopandbottomandright\z:}', "");;
    Expect(0, 6974, '\p{Indic_Positional_Category=:\Atopandbottomandright\z:}', "");;
    Expect(1, 6973, '\p{Indic_Positional_Category=	TOP_And_BOTTOM_And_right}', "");
    Expect(0, 6973, '\p{^Indic_Positional_Category=	TOP_And_BOTTOM_And_right}', "");
    Expect(0, 6973, '\P{Indic_Positional_Category=	TOP_And_BOTTOM_And_right}', "");
    Expect(1, 6973, '\P{^Indic_Positional_Category=	TOP_And_BOTTOM_And_right}', "");
    Expect(0, 6974, '\p{Indic_Positional_Category=	TOP_And_BOTTOM_And_right}', "");
    Expect(1, 6974, '\p{^Indic_Positional_Category=	TOP_And_BOTTOM_And_right}', "");
    Expect(1, 6974, '\P{Indic_Positional_Category=	TOP_And_BOTTOM_And_right}', "");
    Expect(0, 6974, '\P{^Indic_Positional_Category=	TOP_And_BOTTOM_And_right}', "");
    Error('\p{InPC:	/a/Top_And_Bottom_And_Right}');
    Error('\P{InPC:	/a/Top_And_Bottom_And_Right}');
    Expect(1, 6973, '\p{InPC=:\ATop_And_Bottom_And_Right\z:}', "");;
    Expect(0, 6974, '\p{InPC=:\ATop_And_Bottom_And_Right\z:}', "");;
    Expect(1, 6973, '\p{InPC=topandbottomandright}', "");
    Expect(0, 6973, '\p{^InPC=topandbottomandright}', "");
    Expect(0, 6973, '\P{InPC=topandbottomandright}', "");
    Expect(1, 6973, '\P{^InPC=topandbottomandright}', "");
    Expect(0, 6974, '\p{InPC=topandbottomandright}', "");
    Expect(1, 6974, '\p{^InPC=topandbottomandright}', "");
    Expect(1, 6974, '\P{InPC=topandbottomandright}', "");
    Expect(0, 6974, '\P{^InPC=topandbottomandright}', "");
    Expect(1, 6973, '\p{InPC=:\Atopandbottomandright\z:}', "");;
    Expect(0, 6974, '\p{InPC=:\Atopandbottomandright\z:}', "");;
    Expect(1, 6973, '\p{InPC=_	Top_and_bottom_And_right}', "");
    Expect(0, 6973, '\p{^InPC=_	Top_and_bottom_And_right}', "");
    Expect(0, 6973, '\P{InPC=_	Top_and_bottom_And_right}', "");
    Expect(1, 6973, '\P{^InPC=_	Top_and_bottom_And_right}', "");
    Expect(0, 6974, '\p{InPC=_	Top_and_bottom_And_right}', "");
    Expect(1, 6974, '\p{^InPC=_	Top_and_bottom_And_right}', "");
    Expect(1, 6974, '\P{InPC=_	Top_and_bottom_And_right}', "");
    Expect(0, 6974, '\P{^InPC=_	Top_and_bottom_And_right}', "");
    Error('\p{Is_Indic_Positional_Category=:=	 Top_And_Bottom_And_Right}');
    Error('\P{Is_Indic_Positional_Category=:=	 Top_And_Bottom_And_Right}');
    Expect(1, 6973, '\p{Is_Indic_Positional_Category:	topandbottomandright}', "");
    Expect(0, 6973, '\p{^Is_Indic_Positional_Category:	topandbottomandright}', "");
    Expect(0, 6973, '\P{Is_Indic_Positional_Category:	topandbottomandright}', "");
    Expect(1, 6973, '\P{^Is_Indic_Positional_Category:	topandbottomandright}', "");
    Expect(0, 6974, '\p{Is_Indic_Positional_Category:	topandbottomandright}', "");
    Expect(1, 6974, '\p{^Is_Indic_Positional_Category:	topandbottomandright}', "");
    Expect(1, 6974, '\P{Is_Indic_Positional_Category:	topandbottomandright}', "");
    Expect(0, 6974, '\P{^Is_Indic_Positional_Category:	topandbottomandright}', "");
    Expect(1, 6973, '\p{Is_Indic_Positional_Category=	-TOP_and_Bottom_AND_Right}', "");
    Expect(0, 6973, '\p{^Is_Indic_Positional_Category=	-TOP_and_Bottom_AND_Right}', "");
    Expect(0, 6973, '\P{Is_Indic_Positional_Category=	-TOP_and_Bottom_AND_Right}', "");
    Expect(1, 6973, '\P{^Is_Indic_Positional_Category=	-TOP_and_Bottom_AND_Right}', "");
    Expect(0, 6974, '\p{Is_Indic_Positional_Category=	-TOP_and_Bottom_AND_Right}', "");
    Expect(1, 6974, '\p{^Is_Indic_Positional_Category=	-TOP_and_Bottom_AND_Right}', "");
    Expect(1, 6974, '\P{Is_Indic_Positional_Category=	-TOP_and_Bottom_AND_Right}', "");
    Expect(0, 6974, '\P{^Is_Indic_Positional_Category=	-TOP_and_Bottom_AND_Right}', "");
    Error('\p{Is_InPC=:=-	Top_And_Bottom_and_RIGHT}');
    Error('\P{Is_InPC=:=-	Top_And_Bottom_and_RIGHT}');
    Expect(1, 6973, '\p{Is_InPC=topandbottomandright}', "");
    Expect(0, 6973, '\p{^Is_InPC=topandbottomandright}', "");
    Expect(0, 6973, '\P{Is_InPC=topandbottomandright}', "");
    Expect(1, 6973, '\P{^Is_InPC=topandbottomandright}', "");
    Expect(0, 6974, '\p{Is_InPC=topandbottomandright}', "");
    Expect(1, 6974, '\p{^Is_InPC=topandbottomandright}', "");
    Expect(1, 6974, '\P{Is_InPC=topandbottomandright}', "");
    Expect(0, 6974, '\P{^Is_InPC=topandbottomandright}', "");
    Expect(1, 6973, '\p{Is_InPC=	Top_and_BOTTOM_AND_right}', "");
    Expect(0, 6973, '\p{^Is_InPC=	Top_and_BOTTOM_AND_right}', "");
    Expect(0, 6973, '\P{Is_InPC=	Top_and_BOTTOM_AND_right}', "");
    Expect(1, 6973, '\P{^Is_InPC=	Top_and_BOTTOM_AND_right}', "");
    Expect(0, 6974, '\p{Is_InPC=	Top_and_BOTTOM_AND_right}', "");
    Expect(1, 6974, '\p{^Is_InPC=	Top_and_BOTTOM_AND_right}', "");
    Expect(1, 6974, '\P{Is_InPC=	Top_and_BOTTOM_AND_right}', "");
    Expect(0, 6974, '\P{^Is_InPC=	Top_and_BOTTOM_AND_right}', "");
    Error('\p{Indic_Positional_Category=/a/ Top_And_left}');
    Error('\P{Indic_Positional_Category=/a/ Top_And_left}');
    Expect(1, 71097, '\p{Indic_Positional_Category=:\ATop_And_Left\z:}', "");;
    Expect(0, 71098, '\p{Indic_Positional_Category=:\ATop_And_Left\z:}', "");;
    Expect(1, 71097, '\p{Indic_Positional_Category=topandleft}', "");
    Expect(0, 71097, '\p{^Indic_Positional_Category=topandleft}', "");
    Expect(0, 71097, '\P{Indic_Positional_Category=topandleft}', "");
    Expect(1, 71097, '\P{^Indic_Positional_Category=topandleft}', "");
    Expect(0, 71098, '\p{Indic_Positional_Category=topandleft}', "");
    Expect(1, 71098, '\p{^Indic_Positional_Category=topandleft}', "");
    Expect(1, 71098, '\P{Indic_Positional_Category=topandleft}', "");
    Expect(0, 71098, '\P{^Indic_Positional_Category=topandleft}', "");
    Expect(1, 71097, '\p{Indic_Positional_Category=:\Atopandleft\z:}', "");;
    Expect(0, 71098, '\p{Indic_Positional_Category=:\Atopandleft\z:}', "");;
    Expect(1, 71097, '\p{Indic_Positional_Category= _Top_and_Left}', "");
    Expect(0, 71097, '\p{^Indic_Positional_Category= _Top_and_Left}', "");
    Expect(0, 71097, '\P{Indic_Positional_Category= _Top_and_Left}', "");
    Expect(1, 71097, '\P{^Indic_Positional_Category= _Top_and_Left}', "");
    Expect(0, 71098, '\p{Indic_Positional_Category= _Top_and_Left}', "");
    Expect(1, 71098, '\p{^Indic_Positional_Category= _Top_and_Left}', "");
    Expect(1, 71098, '\P{Indic_Positional_Category= _Top_and_Left}', "");
    Expect(0, 71098, '\P{^Indic_Positional_Category= _Top_and_Left}', "");
    Error('\p{InPC=  top_And_left/a/}');
    Error('\P{InPC=  top_And_left/a/}');
    Expect(1, 71097, '\p{InPC=:\ATop_And_Left\z:}', "");;
    Expect(0, 71098, '\p{InPC=:\ATop_And_Left\z:}', "");;
    Expect(1, 71097, '\p{InPC=topandleft}', "");
    Expect(0, 71097, '\p{^InPC=topandleft}', "");
    Expect(0, 71097, '\P{InPC=topandleft}', "");
    Expect(1, 71097, '\P{^InPC=topandleft}', "");
    Expect(0, 71098, '\p{InPC=topandleft}', "");
    Expect(1, 71098, '\p{^InPC=topandleft}', "");
    Expect(1, 71098, '\P{InPC=topandleft}', "");
    Expect(0, 71098, '\P{^InPC=topandleft}', "");
    Expect(1, 71097, '\p{InPC=:\Atopandleft\z:}', "");;
    Expect(0, 71098, '\p{InPC=:\Atopandleft\z:}', "");;
    Expect(1, 71097, '\p{InPC=	TOP_AND_LEFT}', "");
    Expect(0, 71097, '\p{^InPC=	TOP_AND_LEFT}', "");
    Expect(0, 71097, '\P{InPC=	TOP_AND_LEFT}', "");
    Expect(1, 71097, '\P{^InPC=	TOP_AND_LEFT}', "");
    Expect(0, 71098, '\p{InPC=	TOP_AND_LEFT}', "");
    Expect(1, 71098, '\p{^InPC=	TOP_AND_LEFT}', "");
    Expect(1, 71098, '\P{InPC=	TOP_AND_LEFT}', "");
    Expect(0, 71098, '\P{^InPC=	TOP_AND_LEFT}', "");
    Error('\p{Is_Indic_Positional_Category=/a/Top_and_LEFT}');
    Error('\P{Is_Indic_Positional_Category=/a/Top_and_LEFT}');
    Expect(1, 71097, '\p{Is_Indic_Positional_Category=topandleft}', "");
    Expect(0, 71097, '\p{^Is_Indic_Positional_Category=topandleft}', "");
    Expect(0, 71097, '\P{Is_Indic_Positional_Category=topandleft}', "");
    Expect(1, 71097, '\P{^Is_Indic_Positional_Category=topandleft}', "");
    Expect(0, 71098, '\p{Is_Indic_Positional_Category=topandleft}', "");
    Expect(1, 71098, '\p{^Is_Indic_Positional_Category=topandleft}', "");
    Expect(1, 71098, '\P{Is_Indic_Positional_Category=topandleft}', "");
    Expect(0, 71098, '\P{^Is_Indic_Positional_Category=topandleft}', "");
    Expect(1, 71097, '\p{Is_Indic_Positional_Category=	_top_And_Left}', "");
    Expect(0, 71097, '\p{^Is_Indic_Positional_Category=	_top_And_Left}', "");
    Expect(0, 71097, '\P{Is_Indic_Positional_Category=	_top_And_Left}', "");
    Expect(1, 71097, '\P{^Is_Indic_Positional_Category=	_top_And_Left}', "");
    Expect(0, 71098, '\p{Is_Indic_Positional_Category=	_top_And_Left}', "");
    Expect(1, 71098, '\p{^Is_Indic_Positional_Category=	_top_And_Left}', "");
    Expect(1, 71098, '\P{Is_Indic_Positional_Category=	_top_And_Left}', "");
    Expect(0, 71098, '\P{^Is_Indic_Positional_Category=	_top_And_Left}', "");
    Error('\p{Is_InPC=_:=TOP_and_LEFT}');
    Error('\P{Is_InPC=_:=TOP_and_LEFT}');
    Expect(1, 71097, '\p{Is_InPC=topandleft}', "");
    Expect(0, 71097, '\p{^Is_InPC=topandleft}', "");
    Expect(0, 71097, '\P{Is_InPC=topandleft}', "");
    Expect(1, 71097, '\P{^Is_InPC=topandleft}', "");
    Expect(0, 71098, '\p{Is_InPC=topandleft}', "");
    Expect(1, 71098, '\p{^Is_InPC=topandleft}', "");
    Expect(1, 71098, '\P{Is_InPC=topandleft}', "");
    Expect(0, 71098, '\P{^Is_InPC=topandleft}', "");
    Expect(1, 71097, '\p{Is_InPC=-TOP_And_Left}', "");
    Expect(0, 71097, '\p{^Is_InPC=-TOP_And_Left}', "");
    Expect(0, 71097, '\P{Is_InPC=-TOP_And_Left}', "");
    Expect(1, 71097, '\P{^Is_InPC=-TOP_And_Left}', "");
    Expect(0, 71098, '\p{Is_InPC=-TOP_And_Left}', "");
    Expect(1, 71098, '\p{^Is_InPC=-TOP_And_Left}', "");
    Expect(1, 71098, '\P{Is_InPC=-TOP_And_Left}', "");
    Expect(0, 71098, '\P{^Is_InPC=-TOP_And_Left}', "");
    Error('\p{Indic_Positional_Category=/a/ -Top_AND_left_And_right}');
    Error('\P{Indic_Positional_Category=/a/ -Top_AND_left_And_right}');
    Expect(1, 71099, '\p{Indic_Positional_Category=:\ATop_And_Left_And_Right\z:}', "");;
    Expect(0, 71100, '\p{Indic_Positional_Category=:\ATop_And_Left_And_Right\z:}', "");;
    Expect(1, 71099, '\p{Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71099, '\p{^Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71099, '\P{Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71099, '\P{^Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71100, '\p{Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71100, '\p{^Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71100, '\P{Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71100, '\P{^Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71099, '\p{Indic_Positional_Category=:\Atopandleftandright\z:}', "");;
    Expect(0, 71100, '\p{Indic_Positional_Category=:\Atopandleftandright\z:}', "");;
    Expect(1, 71099, '\p{Indic_Positional_Category=	Top_And_LEFT_AND_right}', "");
    Expect(0, 71099, '\p{^Indic_Positional_Category=	Top_And_LEFT_AND_right}', "");
    Expect(0, 71099, '\P{Indic_Positional_Category=	Top_And_LEFT_AND_right}', "");
    Expect(1, 71099, '\P{^Indic_Positional_Category=	Top_And_LEFT_AND_right}', "");
    Expect(0, 71100, '\p{Indic_Positional_Category=	Top_And_LEFT_AND_right}', "");
    Expect(1, 71100, '\p{^Indic_Positional_Category=	Top_And_LEFT_AND_right}', "");
    Expect(1, 71100, '\P{Indic_Positional_Category=	Top_And_LEFT_AND_right}', "");
    Expect(0, 71100, '\P{^Indic_Positional_Category=	Top_And_LEFT_AND_right}', "");
    Error('\p{InPC=_/a/Top_and_Left_and_RIGHT}');
    Error('\P{InPC=_/a/Top_and_Left_and_RIGHT}');
    Expect(1, 71099, '\p{InPC=:\ATop_And_Left_And_Right\z:}', "");;
    Expect(0, 71100, '\p{InPC=:\ATop_And_Left_And_Right\z:}', "");;
    Expect(1, 71099, '\p{InPC=topandleftandright}', "");
    Expect(0, 71099, '\p{^InPC=topandleftandright}', "");
    Expect(0, 71099, '\P{InPC=topandleftandright}', "");
    Expect(1, 71099, '\P{^InPC=topandleftandright}', "");
    Expect(0, 71100, '\p{InPC=topandleftandright}', "");
    Expect(1, 71100, '\p{^InPC=topandleftandright}', "");
    Expect(1, 71100, '\P{InPC=topandleftandright}', "");
    Expect(0, 71100, '\P{^InPC=topandleftandright}', "");
    Expect(1, 71099, '\p{InPC=:\Atopandleftandright\z:}', "");;
    Expect(0, 71100, '\p{InPC=:\Atopandleftandright\z:}', "");;
    Expect(1, 71099, '\p{InPC=		top_AND_left_And_Right}', "");
    Expect(0, 71099, '\p{^InPC=		top_AND_left_And_Right}', "");
    Expect(0, 71099, '\P{InPC=		top_AND_left_And_Right}', "");
    Expect(1, 71099, '\P{^InPC=		top_AND_left_And_Right}', "");
    Expect(0, 71100, '\p{InPC=		top_AND_left_And_Right}', "");
    Expect(1, 71100, '\p{^InPC=		top_AND_left_And_Right}', "");
    Expect(1, 71100, '\P{InPC=		top_AND_left_And_Right}', "");
    Expect(0, 71100, '\P{^InPC=		top_AND_left_And_Right}', "");
    Error('\p{Is_Indic_Positional_Category=:=Top_and_Left_and_Right}');
    Error('\P{Is_Indic_Positional_Category=:=Top_and_Left_and_Right}');
    Expect(1, 71099, '\p{Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71099, '\p{^Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71099, '\P{Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71099, '\P{^Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71100, '\p{Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71100, '\p{^Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71100, '\P{Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(0, 71100, '\P{^Is_Indic_Positional_Category=topandleftandright}', "");
    Expect(1, 71099, '\p{Is_Indic_Positional_Category=__TOP_AND_Left_And_Right}', "");
    Expect(0, 71099, '\p{^Is_Indic_Positional_Category=__TOP_AND_Left_And_Right}', "");
    Expect(0, 71099, '\P{Is_Indic_Positional_Category=__TOP_AND_Left_And_Right}', "");
    Expect(1, 71099, '\P{^Is_Indic_Positional_Category=__TOP_AND_Left_And_Right}', "");
    Expect(0, 71100, '\p{Is_Indic_Positional_Category=__TOP_AND_Left_And_Right}', "");
    Expect(1, 71100, '\p{^Is_Indic_Positional_Category=__TOP_AND_Left_And_Right}', "");
    Expect(1, 71100, '\P{Is_Indic_Positional_Category=__TOP_AND_Left_And_Right}', "");
    Expect(0, 71100, '\P{^Is_Indic_Positional_Category=__TOP_AND_Left_And_Right}', "");
    Error('\p{Is_InPC=:=  Top_and_LEFT_And_Right}');
    Error('\P{Is_InPC=:=  Top_and_LEFT_And_Right}');
    Expect(1, 71099, '\p{Is_InPC=topandleftandright}', "");
    Expect(0, 71099, '\p{^Is_InPC=topandleftandright}', "");
    Expect(0, 71099, '\P{Is_InPC=topandleftandright}', "");
    Expect(1, 71099, '\P{^Is_InPC=topandleftandright}', "");
    Expect(0, 71100, '\p{Is_InPC=topandleftandright}', "");
    Expect(1, 71100, '\p{^Is_InPC=topandleftandright}', "");
    Expect(1, 71100, '\P{Is_InPC=topandleftandright}', "");
    Expect(0, 71100, '\P{^Is_InPC=topandleftandright}', "");
    Expect(1, 71099, '\p{Is_InPC=-top_And_left_AND_Right}', "");
    Expect(0, 71099, '\p{^Is_InPC=-top_And_left_AND_Right}', "");
    Expect(0, 71099, '\P{Is_InPC=-top_And_left_AND_Right}', "");
    Expect(1, 71099, '\P{^Is_InPC=-top_And_left_AND_Right}', "");
    Expect(0, 71100, '\p{Is_InPC=-top_And_left_AND_Right}', "");
    Expect(1, 71100, '\p{^Is_InPC=-top_And_left_AND_Right}', "");
    Expect(1, 71100, '\P{Is_InPC=-top_And_left_AND_Right}', "");
    Expect(0, 71100, '\P{^Is_InPC=-top_And_left_AND_Right}', "");
    Error('\p{Indic_Positional_Category=-/a/TOP_and_RIGHT}');
    Error('\P{Indic_Positional_Category=-/a/TOP_and_RIGHT}');
    Expect(1, 70195, '\p{Indic_Positional_Category=:\ATop_And_Right\z:}', "");;
    Expect(0, 70196, '\p{Indic_Positional_Category=:\ATop_And_Right\z:}', "");;
    Expect(1, 70195, '\p{Indic_Positional_Category=topandright}', "");
    Expect(0, 70195, '\p{^Indic_Positional_Category=topandright}', "");
    Expect(0, 70195, '\P{Indic_Positional_Category=topandright}', "");
    Expect(1, 70195, '\P{^Indic_Positional_Category=topandright}', "");
    Expect(0, 70196, '\p{Indic_Positional_Category=topandright}', "");
    Expect(1, 70196, '\p{^Indic_Positional_Category=topandright}', "");
    Expect(1, 70196, '\P{Indic_Positional_Category=topandright}', "");
    Expect(0, 70196, '\P{^Indic_Positional_Category=topandright}', "");
    Expect(1, 70195, '\p{Indic_Positional_Category=:\Atopandright\z:}', "");;
    Expect(0, 70196, '\p{Indic_Positional_Category=:\Atopandright\z:}', "");;
    Expect(1, 70195, '\p{Indic_Positional_Category=_TOP_And_Right}', "");
    Expect(0, 70195, '\p{^Indic_Positional_Category=_TOP_And_Right}', "");
    Expect(0, 70195, '\P{Indic_Positional_Category=_TOP_And_Right}', "");
    Expect(1, 70195, '\P{^Indic_Positional_Category=_TOP_And_Right}', "");
    Expect(0, 70196, '\p{Indic_Positional_Category=_TOP_And_Right}', "");
    Expect(1, 70196, '\p{^Indic_Positional_Category=_TOP_And_Right}', "");
    Expect(1, 70196, '\P{Indic_Positional_Category=_TOP_And_Right}', "");
    Expect(0, 70196, '\P{^Indic_Positional_Category=_TOP_And_Right}', "");
    Error('\p{InPC=:=	Top_and_right}');
    Error('\P{InPC=:=	Top_and_right}');
    Expect(1, 70195, '\p{InPC=:\ATop_And_Right\z:}', "");;
    Expect(0, 70196, '\p{InPC=:\ATop_And_Right\z:}', "");;
    Expect(1, 70195, '\p{InPC=topandright}', "");
    Expect(0, 70195, '\p{^InPC=topandright}', "");
    Expect(0, 70195, '\P{InPC=topandright}', "");
    Expect(1, 70195, '\P{^InPC=topandright}', "");
    Expect(0, 70196, '\p{InPC=topandright}', "");
    Expect(1, 70196, '\p{^InPC=topandright}', "");
    Expect(1, 70196, '\P{InPC=topandright}', "");
    Expect(0, 70196, '\P{^InPC=topandright}', "");
    Expect(1, 70195, '\p{InPC=:\Atopandright\z:}', "");;
    Expect(0, 70196, '\p{InPC=:\Atopandright\z:}', "");;
    Expect(1, 70195, '\p{InPC: _TOP_and_Right}', "");
    Expect(0, 70195, '\p{^InPC: _TOP_and_Right}', "");
    Expect(0, 70195, '\P{InPC: _TOP_and_Right}', "");
    Expect(1, 70195, '\P{^InPC: _TOP_and_Right}', "");
    Expect(0, 70196, '\p{InPC: _TOP_and_Right}', "");
    Expect(1, 70196, '\p{^InPC: _TOP_and_Right}', "");
    Expect(1, 70196, '\P{InPC: _TOP_and_Right}', "");
    Expect(0, 70196, '\P{^InPC: _TOP_and_Right}', "");
    Error('\p{Is_Indic_Positional_Category=-/a/TOP_AND_Right}');
    Error('\P{Is_Indic_Positional_Category=-/a/TOP_AND_Right}');
    Expect(1, 70195, '\p{Is_Indic_Positional_Category=topandright}', "");
    Expect(0, 70195, '\p{^Is_Indic_Positional_Category=topandright}', "");
    Expect(0, 70195, '\P{Is_Indic_Positional_Category=topandright}', "");
    Expect(1, 70195, '\P{^Is_Indic_Positional_Category=topandright}', "");
    Expect(0, 70196, '\p{Is_Indic_Positional_Category=topandright}', "");
    Expect(1, 70196, '\p{^Is_Indic_Positional_Category=topandright}', "");
    Expect(1, 70196, '\P{Is_Indic_Positional_Category=topandright}', "");
    Expect(0, 70196, '\P{^Is_Indic_Positional_Category=topandright}', "");
    Expect(1, 70195, '\p{Is_Indic_Positional_Category:_-Top_and_right}', "");
    Expect(0, 70195, '\p{^Is_Indic_Positional_Category:_-Top_and_right}', "");
    Expect(0, 70195, '\P{Is_Indic_Positional_Category:_-Top_and_right}', "");
    Expect(1, 70195, '\P{^Is_Indic_Positional_Category:_-Top_and_right}', "");
    Expect(0, 70196, '\p{Is_Indic_Positional_Category:_-Top_and_right}', "");
    Expect(1, 70196, '\p{^Is_Indic_Positional_Category:_-Top_and_right}', "");
    Expect(1, 70196, '\P{Is_Indic_Positional_Category:_-Top_and_right}', "");
    Expect(0, 70196, '\P{^Is_Indic_Positional_Category:_-Top_and_right}', "");
    Error('\p{Is_InPC=:=_top_And_right}');
    Error('\P{Is_InPC=:=_top_And_right}');
    Expect(1, 70195, '\p{Is_InPC=topandright}', "");
    Expect(0, 70195, '\p{^Is_InPC=topandright}', "");
    Expect(0, 70195, '\P{Is_InPC=topandright}', "");
    Expect(1, 70195, '\P{^Is_InPC=topandright}', "");
    Expect(0, 70196, '\p{Is_InPC=topandright}', "");
    Expect(1, 70196, '\p{^Is_InPC=topandright}', "");
    Expect(1, 70196, '\P{Is_InPC=topandright}', "");
    Expect(0, 70196, '\P{^Is_InPC=topandright}', "");
    Expect(1, 70195, '\p{Is_InPC=TOP_And_RIGHT}', "");
    Expect(0, 70195, '\p{^Is_InPC=TOP_And_RIGHT}', "");
    Expect(0, 70195, '\P{Is_InPC=TOP_And_RIGHT}', "");
    Expect(1, 70195, '\P{^Is_InPC=TOP_And_RIGHT}', "");
    Expect(0, 70196, '\p{Is_InPC=TOP_And_RIGHT}', "");
    Expect(1, 70196, '\p{^Is_InPC=TOP_And_RIGHT}', "");
    Expect(1, 70196, '\P{Is_InPC=TOP_And_RIGHT}', "");
    Expect(0, 70196, '\P{^Is_InPC=TOP_And_RIGHT}', "");
    Error('\p{Indic_Positional_Category=	-Visual_Order_Left/a/}');
    Error('\P{Indic_Positional_Category=	-Visual_Order_Left/a/}');
    Expect(1, 43708, '\p{Indic_Positional_Category=:\AVisual_Order_Left\z:}', "");;
    Expect(0, 43709, '\p{Indic_Positional_Category=:\AVisual_Order_Left\z:}', "");;
    Expect(1, 43708, '\p{Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43708, '\p{^Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43708, '\P{Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43708, '\P{^Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43709, '\p{Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43709, '\p{^Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43709, '\P{Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43709, '\P{^Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43708, '\p{Indic_Positional_Category=:\Avisualorderleft\z:}', "");;
    Expect(0, 43709, '\p{Indic_Positional_Category=:\Avisualorderleft\z:}', "");;
    Expect(1, 43708, '\p{Indic_Positional_Category=_visual_Order_Left}', "");
    Expect(0, 43708, '\p{^Indic_Positional_Category=_visual_Order_Left}', "");
    Expect(0, 43708, '\P{Indic_Positional_Category=_visual_Order_Left}', "");
    Expect(1, 43708, '\P{^Indic_Positional_Category=_visual_Order_Left}', "");
    Expect(0, 43709, '\p{Indic_Positional_Category=_visual_Order_Left}', "");
    Expect(1, 43709, '\p{^Indic_Positional_Category=_visual_Order_Left}', "");
    Expect(1, 43709, '\P{Indic_Positional_Category=_visual_Order_Left}', "");
    Expect(0, 43709, '\P{^Indic_Positional_Category=_visual_Order_Left}', "");
    Error('\p{InPC=	Visual_order_Left:=}');
    Error('\P{InPC=	Visual_order_Left:=}');
    Expect(1, 43708, '\p{InPC=:\AVisual_Order_Left\z:}', "");;
    Expect(0, 43709, '\p{InPC=:\AVisual_Order_Left\z:}', "");;
    Expect(1, 43708, '\p{InPC=visualorderleft}', "");
    Expect(0, 43708, '\p{^InPC=visualorderleft}', "");
    Expect(0, 43708, '\P{InPC=visualorderleft}', "");
    Expect(1, 43708, '\P{^InPC=visualorderleft}', "");
    Expect(0, 43709, '\p{InPC=visualorderleft}', "");
    Expect(1, 43709, '\p{^InPC=visualorderleft}', "");
    Expect(1, 43709, '\P{InPC=visualorderleft}', "");
    Expect(0, 43709, '\P{^InPC=visualorderleft}', "");
    Expect(1, 43708, '\p{InPC=:\Avisualorderleft\z:}', "");;
    Expect(0, 43709, '\p{InPC=:\Avisualorderleft\z:}', "");;
    Expect(1, 43708, '\p{InPC=- Visual_order_Left}', "");
    Expect(0, 43708, '\p{^InPC=- Visual_order_Left}', "");
    Expect(0, 43708, '\P{InPC=- Visual_order_Left}', "");
    Expect(1, 43708, '\P{^InPC=- Visual_order_Left}', "");
    Expect(0, 43709, '\p{InPC=- Visual_order_Left}', "");
    Expect(1, 43709, '\p{^InPC=- Visual_order_Left}', "");
    Expect(1, 43709, '\P{InPC=- Visual_order_Left}', "");
    Expect(0, 43709, '\P{^InPC=- Visual_order_Left}', "");
    Error('\p{Is_Indic_Positional_Category=:=-_visual_ORDER_left}');
    Error('\P{Is_Indic_Positional_Category=:=-_visual_ORDER_left}');
    Expect(1, 43708, '\p{Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43708, '\p{^Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43708, '\P{Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43708, '\P{^Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43709, '\p{Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43709, '\p{^Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43709, '\P{Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(0, 43709, '\P{^Is_Indic_Positional_Category=visualorderleft}', "");
    Expect(1, 43708, '\p{Is_Indic_Positional_Category: 	_visual_Order_Left}', "");
    Expect(0, 43708, '\p{^Is_Indic_Positional_Category: 	_visual_Order_Left}', "");
    Expect(0, 43708, '\P{Is_Indic_Positional_Category: 	_visual_Order_Left}', "");
    Expect(1, 43708, '\P{^Is_Indic_Positional_Category: 	_visual_Order_Left}', "");
    Expect(0, 43709, '\p{Is_Indic_Positional_Category: 	_visual_Order_Left}', "");
    Expect(1, 43709, '\p{^Is_Indic_Positional_Category: 	_visual_Order_Left}', "");
    Expect(1, 43709, '\P{Is_Indic_Positional_Category: 	_visual_Order_Left}', "");
    Expect(0, 43709, '\P{^Is_Indic_Positional_Category: 	_visual_Order_Left}', "");
    Error('\p{Is_InPC=/a/__VISUAL_ORDER_Left}');
    Error('\P{Is_InPC=/a/__VISUAL_ORDER_Left}');
    Expect(1, 43708, '\p{Is_InPC=visualorderleft}', "");
    Expect(0, 43708, '\p{^Is_InPC=visualorderleft}', "");
    Expect(0, 43708, '\P{Is_InPC=visualorderleft}', "");
    Expect(1, 43708, '\P{^Is_InPC=visualorderleft}', "");
    Expect(0, 43709, '\p{Is_InPC=visualorderleft}', "");
    Expect(1, 43709, '\p{^Is_InPC=visualorderleft}', "");
    Expect(1, 43709, '\P{Is_InPC=visualorderleft}', "");
    Expect(0, 43709, '\P{^Is_InPC=visualorderleft}', "");
    Expect(1, 43708, '\p{Is_InPC= _Visual_Order_left}', "");
    Expect(0, 43708, '\p{^Is_InPC= _Visual_Order_left}', "");
    Expect(0, 43708, '\P{Is_InPC= _Visual_Order_left}', "");
    Expect(1, 43708, '\P{^Is_InPC= _Visual_Order_left}', "");
    Expect(0, 43709, '\p{Is_InPC= _Visual_Order_left}', "");
    Expect(1, 43709, '\p{^Is_InPC= _Visual_Order_left}', "");
    Expect(1, 43709, '\P{Is_InPC= _Visual_Order_left}', "");
    Expect(0, 43709, '\P{^Is_InPC= _Visual_Order_left}', "");
    Error('\p{indicsyllabiccategory}');
    Error('\P{indicsyllabiccategory}');
    Error('\p{insc}');
    Error('\P{insc}');
    Error('\p{Indic_Syllabic_Category=	/a/Avagraha}');
    Error('\P{Indic_Syllabic_Category=	/a/Avagraha}');
    Expect(1, 72768, '\p{Indic_Syllabic_Category=:\AAvagraha\z:}', "");;
    Expect(0, 72769, '\p{Indic_Syllabic_Category=:\AAvagraha\z:}', "");;
    Expect(1, 72768, '\p{Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72768, '\p{^Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72768, '\P{Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72768, '\P{^Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72769, '\p{Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72769, '\p{^Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72769, '\P{Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72769, '\P{^Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72768, '\p{Indic_Syllabic_Category=:\Aavagraha\z:}', "");;
    Expect(0, 72769, '\p{Indic_Syllabic_Category=:\Aavagraha\z:}', "");;
    Expect(1, 72768, '\p{Indic_Syllabic_Category=-Avagraha}', "");
    Expect(0, 72768, '\p{^Indic_Syllabic_Category=-Avagraha}', "");
    Expect(0, 72768, '\P{Indic_Syllabic_Category=-Avagraha}', "");
    Expect(1, 72768, '\P{^Indic_Syllabic_Category=-Avagraha}', "");
    Expect(0, 72769, '\p{Indic_Syllabic_Category=-Avagraha}', "");
    Expect(1, 72769, '\p{^Indic_Syllabic_Category=-Avagraha}', "");
    Expect(1, 72769, '\P{Indic_Syllabic_Category=-Avagraha}', "");
    Expect(0, 72769, '\P{^Indic_Syllabic_Category=-Avagraha}', "");
    Error('\p{InSC=-Avagraha/a/}');
    Error('\P{InSC=-Avagraha/a/}');
    Expect(1, 72768, '\p{InSC=:\AAvagraha\z:}', "");;
    Expect(0, 72769, '\p{InSC=:\AAvagraha\z:}', "");;
    Expect(1, 72768, '\p{InSC=avagraha}', "");
    Expect(0, 72768, '\p{^InSC=avagraha}', "");
    Expect(0, 72768, '\P{InSC=avagraha}', "");
    Expect(1, 72768, '\P{^InSC=avagraha}', "");
    Expect(0, 72769, '\p{InSC=avagraha}', "");
    Expect(1, 72769, '\p{^InSC=avagraha}', "");
    Expect(1, 72769, '\P{InSC=avagraha}', "");
    Expect(0, 72769, '\P{^InSC=avagraha}', "");
    Expect(1, 72768, '\p{InSC=:\Aavagraha\z:}', "");;
    Expect(0, 72769, '\p{InSC=:\Aavagraha\z:}', "");;
    Expect(1, 72768, '\p{InSC=- Avagraha}', "");
    Expect(0, 72768, '\p{^InSC=- Avagraha}', "");
    Expect(0, 72768, '\P{InSC=- Avagraha}', "");
    Expect(1, 72768, '\P{^InSC=- Avagraha}', "");
    Expect(0, 72769, '\p{InSC=- Avagraha}', "");
    Expect(1, 72769, '\p{^InSC=- Avagraha}', "");
    Expect(1, 72769, '\P{InSC=- Avagraha}', "");
    Expect(0, 72769, '\P{^InSC=- Avagraha}', "");
    Error('\p{Is_Indic_Syllabic_Category:-/a/avagraha}');
    Error('\P{Is_Indic_Syllabic_Category:-/a/avagraha}');
    Expect(1, 72768, '\p{Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72768, '\p{^Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72768, '\P{Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72768, '\P{^Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72769, '\p{Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72769, '\p{^Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72769, '\P{Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(0, 72769, '\P{^Is_Indic_Syllabic_Category=avagraha}', "");
    Expect(1, 72768, '\p{Is_Indic_Syllabic_Category: -avagraha}', "");
    Expect(0, 72768, '\p{^Is_Indic_Syllabic_Category: -avagraha}', "");
    Expect(0, 72768, '\P{Is_Indic_Syllabic_Category: -avagraha}', "");
    Expect(1, 72768, '\P{^Is_Indic_Syllabic_Category: -avagraha}', "");
    Expect(0, 72769, '\p{Is_Indic_Syllabic_Category: -avagraha}', "");
    Expect(1, 72769, '\p{^Is_Indic_Syllabic_Category: -avagraha}', "");
    Expect(1, 72769, '\P{Is_Indic_Syllabic_Category: -avagraha}', "");
    Expect(0, 72769, '\P{^Is_Indic_Syllabic_Category: -avagraha}', "");
    Error('\p{Is_InSC= _avagraha/a/}');
    Error('\P{Is_InSC= _avagraha/a/}');
    Expect(1, 72768, '\p{Is_InSC=avagraha}', "");
    Expect(0, 72768, '\p{^Is_InSC=avagraha}', "");
    Expect(0, 72768, '\P{Is_InSC=avagraha}', "");
    Expect(1, 72768, '\P{^Is_InSC=avagraha}', "");
    Expect(0, 72769, '\p{Is_InSC=avagraha}', "");
    Expect(1, 72769, '\p{^Is_InSC=avagraha}', "");
    Expect(1, 72769, '\P{Is_InSC=avagraha}', "");
    Expect(0, 72769, '\P{^Is_InSC=avagraha}', "");
    Expect(1, 72768, '\p{Is_InSC= Avagraha}', "");
    Expect(0, 72768, '\p{^Is_InSC= Avagraha}', "");
    Expect(0, 72768, '\P{Is_InSC= Avagraha}', "");
    Expect(1, 72768, '\P{^Is_InSC= Avagraha}', "");
    Expect(0, 72769, '\p{Is_InSC= Avagraha}', "");
    Expect(1, 72769, '\p{^Is_InSC= Avagraha}', "");
    Expect(1, 72769, '\P{Is_InSC= Avagraha}', "");
    Expect(0, 72769, '\P{^Is_InSC= Avagraha}', "");
    Error('\p{Indic_Syllabic_Category:   -_Bindu/a/}');
    Error('\P{Indic_Syllabic_Category:   -_Bindu/a/}');
    Expect(1, 73109, '\p{Indic_Syllabic_Category=:\ABindu\z:}', "");;
    Expect(0, 73110, '\p{Indic_Syllabic_Category=:\ABindu\z:}', "");;
    Expect(1, 73109, '\p{Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73109, '\p{^Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73109, '\P{Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73109, '\P{^Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73110, '\p{Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73110, '\p{^Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73110, '\P{Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73110, '\P{^Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73109, '\p{Indic_Syllabic_Category=:\Abindu\z:}', "");;
    Expect(0, 73110, '\p{Indic_Syllabic_Category=:\Abindu\z:}', "");;
    Expect(1, 73109, '\p{Indic_Syllabic_Category=	bindu}', "");
    Expect(0, 73109, '\p{^Indic_Syllabic_Category=	bindu}', "");
    Expect(0, 73109, '\P{Indic_Syllabic_Category=	bindu}', "");
    Expect(1, 73109, '\P{^Indic_Syllabic_Category=	bindu}', "");
    Expect(0, 73110, '\p{Indic_Syllabic_Category=	bindu}', "");
    Expect(1, 73110, '\p{^Indic_Syllabic_Category=	bindu}', "");
    Expect(1, 73110, '\P{Indic_Syllabic_Category=	bindu}', "");
    Expect(0, 73110, '\P{^Indic_Syllabic_Category=	bindu}', "");
    Error('\p{InSC=	Bindu:=}');
    Error('\P{InSC=	Bindu:=}');
    Expect(1, 73109, '\p{InSC=:\ABindu\z:}', "");;
    Expect(0, 73110, '\p{InSC=:\ABindu\z:}', "");;
    Expect(1, 73109, '\p{InSC=bindu}', "");
    Expect(0, 73109, '\p{^InSC=bindu}', "");
    Expect(0, 73109, '\P{InSC=bindu}', "");
    Expect(1, 73109, '\P{^InSC=bindu}', "");
    Expect(0, 73110, '\p{InSC=bindu}', "");
    Expect(1, 73110, '\p{^InSC=bindu}', "");
    Expect(1, 73110, '\P{InSC=bindu}', "");
    Expect(0, 73110, '\P{^InSC=bindu}', "");
    Expect(1, 73109, '\p{InSC=:\Abindu\z:}', "");;
    Expect(0, 73110, '\p{InSC=:\Abindu\z:}', "");;
    Expect(1, 73109, '\p{InSC=__Bindu}', "");
    Expect(0, 73109, '\p{^InSC=__Bindu}', "");
    Expect(0, 73109, '\P{InSC=__Bindu}', "");
    Expect(1, 73109, '\P{^InSC=__Bindu}', "");
    Expect(0, 73110, '\p{InSC=__Bindu}', "");
    Expect(1, 73110, '\p{^InSC=__Bindu}', "");
    Expect(1, 73110, '\P{InSC=__Bindu}', "");
    Expect(0, 73110, '\P{^InSC=__Bindu}', "");
    Error('\p{Is_Indic_Syllabic_Category=		bindu:=}');
    Error('\P{Is_Indic_Syllabic_Category=		bindu:=}');
    Expect(1, 73109, '\p{Is_Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73109, '\p{^Is_Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73109, '\P{Is_Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73109, '\P{^Is_Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73110, '\p{Is_Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73110, '\p{^Is_Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73110, '\P{Is_Indic_Syllabic_Category=bindu}', "");
    Expect(0, 73110, '\P{^Is_Indic_Syllabic_Category=bindu}', "");
    Expect(1, 73109, '\p{Is_Indic_Syllabic_Category=_-Bindu}', "");
    Expect(0, 73109, '\p{^Is_Indic_Syllabic_Category=_-Bindu}', "");
    Expect(0, 73109, '\P{Is_Indic_Syllabic_Category=_-Bindu}', "");
    Expect(1, 73109, '\P{^Is_Indic_Syllabic_Category=_-Bindu}', "");
    Expect(0, 73110, '\p{Is_Indic_Syllabic_Category=_-Bindu}', "");
    Expect(1, 73110, '\p{^Is_Indic_Syllabic_Category=_-Bindu}', "");
    Expect(1, 73110, '\P{Is_Indic_Syllabic_Category=_-Bindu}', "");
    Expect(0, 73110, '\P{^Is_Indic_Syllabic_Category=_-Bindu}', "");
    Error('\p{Is_InSC:	Bindu/a/}');
    Error('\P{Is_InSC:	Bindu/a/}');
    Expect(1, 73109, '\p{Is_InSC=bindu}', "");
    Expect(0, 73109, '\p{^Is_InSC=bindu}', "");
    Expect(0, 73109, '\P{Is_InSC=bindu}', "");
    Expect(1, 73109, '\P{^Is_InSC=bindu}', "");
    Expect(0, 73110, '\p{Is_InSC=bindu}', "");
    Expect(1, 73110, '\p{^Is_InSC=bindu}', "");
    Expect(1, 73110, '\P{Is_InSC=bindu}', "");
    Expect(0, 73110, '\P{^Is_InSC=bindu}', "");
    Expect(1, 73109, '\p{Is_InSC=	_BINDU}', "");
    Expect(0, 73109, '\p{^Is_InSC=	_BINDU}', "");
    Expect(0, 73109, '\P{Is_InSC=	_BINDU}', "");
    Expect(1, 73109, '\P{^Is_InSC=	_BINDU}', "");
    Expect(0, 73110, '\p{Is_InSC=	_BINDU}', "");
    Expect(1, 73110, '\p{^Is_InSC=	_BINDU}', "");
    Expect(1, 73110, '\P{Is_InSC=	_BINDU}', "");
    Expect(0, 73110, '\P{^Is_InSC=	_BINDU}', "");
    Error('\p{Indic_Syllabic_Category=:=Brahmi_joining_Number}');
    Error('\P{Indic_Syllabic_Category=:=Brahmi_joining_Number}');
    Expect(1, 69733, '\p{Indic_Syllabic_Category=:\ABrahmi_Joining_Number\z:}', "");;
    Expect(0, 69734, '\p{Indic_Syllabic_Category=:\ABrahmi_Joining_Number\z:}', "");;
    Expect(1, 69733, '\p{Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69733, '\p{^Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69733, '\P{Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69733, '\P{^Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69734, '\p{Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69734, '\p{^Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69734, '\P{Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69734, '\P{^Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69733, '\p{Indic_Syllabic_Category=:\Abrahmijoiningnumber\z:}', "");;
    Expect(0, 69734, '\p{Indic_Syllabic_Category=:\Abrahmijoiningnumber\z:}', "");;
    Expect(1, 69733, '\p{Indic_Syllabic_Category= _BRAHMI_Joining_Number}', "");
    Expect(0, 69733, '\p{^Indic_Syllabic_Category= _BRAHMI_Joining_Number}', "");
    Expect(0, 69733, '\P{Indic_Syllabic_Category= _BRAHMI_Joining_Number}', "");
    Expect(1, 69733, '\P{^Indic_Syllabic_Category= _BRAHMI_Joining_Number}', "");
    Expect(0, 69734, '\p{Indic_Syllabic_Category= _BRAHMI_Joining_Number}', "");
    Expect(1, 69734, '\p{^Indic_Syllabic_Category= _BRAHMI_Joining_Number}', "");
    Expect(1, 69734, '\P{Indic_Syllabic_Category= _BRAHMI_Joining_Number}', "");
    Expect(0, 69734, '\P{^Indic_Syllabic_Category= _BRAHMI_Joining_Number}', "");
    Error('\p{InSC=/a/_-Brahmi_Joining_NUMBER}');
    Error('\P{InSC=/a/_-Brahmi_Joining_NUMBER}');
    Expect(1, 69733, '\p{InSC=:\ABrahmi_Joining_Number\z:}', "");;
    Expect(0, 69734, '\p{InSC=:\ABrahmi_Joining_Number\z:}', "");;
    Expect(1, 69733, '\p{InSC:	brahmijoiningnumber}', "");
    Expect(0, 69733, '\p{^InSC:	brahmijoiningnumber}', "");
    Expect(0, 69733, '\P{InSC:	brahmijoiningnumber}', "");
    Expect(1, 69733, '\P{^InSC:	brahmijoiningnumber}', "");
    Expect(0, 69734, '\p{InSC:	brahmijoiningnumber}', "");
    Expect(1, 69734, '\p{^InSC:	brahmijoiningnumber}', "");
    Expect(1, 69734, '\P{InSC:	brahmijoiningnumber}', "");
    Expect(0, 69734, '\P{^InSC:	brahmijoiningnumber}', "");
    Expect(1, 69733, '\p{InSC=:\Abrahmijoiningnumber\z:}', "");;
    Expect(0, 69734, '\p{InSC=:\Abrahmijoiningnumber\z:}', "");;
    Expect(1, 69733, '\p{InSC=-_Brahmi_joining_Number}', "");
    Expect(0, 69733, '\p{^InSC=-_Brahmi_joining_Number}', "");
    Expect(0, 69733, '\P{InSC=-_Brahmi_joining_Number}', "");
    Expect(1, 69733, '\P{^InSC=-_Brahmi_joining_Number}', "");
    Expect(0, 69734, '\p{InSC=-_Brahmi_joining_Number}', "");
    Expect(1, 69734, '\p{^InSC=-_Brahmi_joining_Number}', "");
    Expect(1, 69734, '\P{InSC=-_Brahmi_joining_Number}', "");
    Expect(0, 69734, '\P{^InSC=-_Brahmi_joining_Number}', "");
    Error('\p{Is_Indic_Syllabic_Category=		Brahmi_joining_NUMBER/a/}');
    Error('\P{Is_Indic_Syllabic_Category=		Brahmi_joining_NUMBER/a/}');
    Expect(1, 69733, '\p{Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69733, '\p{^Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69733, '\P{Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69733, '\P{^Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69734, '\p{Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69734, '\p{^Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69734, '\P{Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(0, 69734, '\P{^Is_Indic_Syllabic_Category=brahmijoiningnumber}', "");
    Expect(1, 69733, '\p{Is_Indic_Syllabic_Category=_-Brahmi_joining_Number}', "");
    Expect(0, 69733, '\p{^Is_Indic_Syllabic_Category=_-Brahmi_joining_Number}', "");
    Expect(0, 69733, '\P{Is_Indic_Syllabic_Category=_-Brahmi_joining_Number}', "");
    Expect(1, 69733, '\P{^Is_Indic_Syllabic_Category=_-Brahmi_joining_Number}', "");
    Expect(0, 69734, '\p{Is_Indic_Syllabic_Category=_-Brahmi_joining_Number}', "");
    Expect(1, 69734, '\p{^Is_Indic_Syllabic_Category=_-Brahmi_joining_Number}', "");
    Expect(1, 69734, '\P{Is_Indic_Syllabic_Category=_-Brahmi_joining_Number}', "");
    Expect(0, 69734, '\P{^Is_Indic_Syllabic_Category=_-Brahmi_joining_Number}', "");
    Error('\p{Is_InSC=/a/__Brahmi_JOINING_NUMBER}');
    Error('\P{Is_InSC=/a/__Brahmi_JOINING_NUMBER}');
    Expect(1, 69733, '\p{Is_InSC=brahmijoiningnumber}', "");
    Expect(0, 69733, '\p{^Is_InSC=brahmijoiningnumber}', "");
    Expect(0, 69733, '\P{Is_InSC=brahmijoiningnumber}', "");
    Expect(1, 69733, '\P{^Is_InSC=brahmijoiningnumber}', "");
    Expect(0, 69734, '\p{Is_InSC=brahmijoiningnumber}', "");
    Expect(1, 69734, '\p{^Is_InSC=brahmijoiningnumber}', "");
    Expect(1, 69734, '\P{Is_InSC=brahmijoiningnumber}', "");
    Expect(0, 69734, '\P{^Is_InSC=brahmijoiningnumber}', "");
    Expect(1, 69733, '\p{Is_InSC=-_BRAHMI_Joining_number}', "");
    Expect(0, 69733, '\p{^Is_InSC=-_BRAHMI_Joining_number}', "");
    Expect(0, 69733, '\P{Is_InSC=-_BRAHMI_Joining_number}', "");
    Expect(1, 69733, '\P{^Is_InSC=-_BRAHMI_Joining_number}', "");
    Expect(0, 69734, '\p{Is_InSC=-_BRAHMI_Joining_number}', "");
    Expect(1, 69734, '\p{^Is_InSC=-_BRAHMI_Joining_number}', "");
    Expect(1, 69734, '\P{Is_InSC=-_BRAHMI_Joining_number}', "");
    Expect(0, 69734, '\P{^Is_InSC=-_BRAHMI_Joining_number}', "");
    Error('\p{Indic_Syllabic_Category= cantillation_Mark/a/}');
    Error('\P{Indic_Syllabic_Category= cantillation_Mark/a/}');
    Expect(1, 70516, '\p{Indic_Syllabic_Category=:\ACantillation_Mark\z:}', "");;
    Expect(0, 70517, '\p{Indic_Syllabic_Category=:\ACantillation_Mark\z:}', "");;
    Expect(1, 70516, '\p{Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70516, '\p{^Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70516, '\P{Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70516, '\P{^Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70517, '\p{Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70517, '\p{^Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70517, '\P{Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70517, '\P{^Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70516, '\p{Indic_Syllabic_Category=:\Acantillationmark\z:}', "");;
    Expect(0, 70517, '\p{Indic_Syllabic_Category=:\Acantillationmark\z:}', "");;
    Expect(1, 70516, '\p{Indic_Syllabic_Category=Cantillation_Mark}', "");
    Expect(0, 70516, '\p{^Indic_Syllabic_Category=Cantillation_Mark}', "");
    Expect(0, 70516, '\P{Indic_Syllabic_Category=Cantillation_Mark}', "");
    Expect(1, 70516, '\P{^Indic_Syllabic_Category=Cantillation_Mark}', "");
    Expect(0, 70517, '\p{Indic_Syllabic_Category=Cantillation_Mark}', "");
    Expect(1, 70517, '\p{^Indic_Syllabic_Category=Cantillation_Mark}', "");
    Expect(1, 70517, '\P{Indic_Syllabic_Category=Cantillation_Mark}', "");
    Expect(0, 70517, '\P{^Indic_Syllabic_Category=Cantillation_Mark}', "");
    Error('\p{InSC=	:=Cantillation_mark}');
    Error('\P{InSC=	:=Cantillation_mark}');
    Expect(1, 70516, '\p{InSC=:\ACantillation_Mark\z:}', "");;
    Expect(0, 70517, '\p{InSC=:\ACantillation_Mark\z:}', "");;
    Expect(1, 70516, '\p{InSC=cantillationmark}', "");
    Expect(0, 70516, '\p{^InSC=cantillationmark}', "");
    Expect(0, 70516, '\P{InSC=cantillationmark}', "");
    Expect(1, 70516, '\P{^InSC=cantillationmark}', "");
    Expect(0, 70517, '\p{InSC=cantillationmark}', "");
    Expect(1, 70517, '\p{^InSC=cantillationmark}', "");
    Expect(1, 70517, '\P{InSC=cantillationmark}', "");
    Expect(0, 70517, '\P{^InSC=cantillationmark}', "");
    Expect(1, 70516, '\p{InSC=:\Acantillationmark\z:}', "");;
    Expect(0, 70517, '\p{InSC=:\Acantillationmark\z:}', "");;
    Expect(1, 70516, '\p{InSC=--CANTILLATION_Mark}', "");
    Expect(0, 70516, '\p{^InSC=--CANTILLATION_Mark}', "");
    Expect(0, 70516, '\P{InSC=--CANTILLATION_Mark}', "");
    Expect(1, 70516, '\P{^InSC=--CANTILLATION_Mark}', "");
    Expect(0, 70517, '\p{InSC=--CANTILLATION_Mark}', "");
    Expect(1, 70517, '\p{^InSC=--CANTILLATION_Mark}', "");
    Expect(1, 70517, '\P{InSC=--CANTILLATION_Mark}', "");
    Expect(0, 70517, '\P{^InSC=--CANTILLATION_Mark}', "");
    Error('\p{Is_Indic_Syllabic_Category: -	cantillation_MARK/a/}');
    Error('\P{Is_Indic_Syllabic_Category: -	cantillation_MARK/a/}');
    Expect(1, 70516, '\p{Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70516, '\p{^Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70516, '\P{Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70516, '\P{^Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70517, '\p{Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70517, '\p{^Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70517, '\P{Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(0, 70517, '\P{^Is_Indic_Syllabic_Category=cantillationmark}', "");
    Expect(1, 70516, '\p{Is_Indic_Syllabic_Category= CANTILLATION_MARK}', "");
    Expect(0, 70516, '\p{^Is_Indic_Syllabic_Category= CANTILLATION_MARK}', "");
    Expect(0, 70516, '\P{Is_Indic_Syllabic_Category= CANTILLATION_MARK}', "");
    Expect(1, 70516, '\P{^Is_Indic_Syllabic_Category= CANTILLATION_MARK}', "");
    Expect(0, 70517, '\p{Is_Indic_Syllabic_Category= CANTILLATION_MARK}', "");
    Expect(1, 70517, '\p{^Is_Indic_Syllabic_Category= CANTILLATION_MARK}', "");
    Expect(1, 70517, '\P{Is_Indic_Syllabic_Category= CANTILLATION_MARK}', "");
    Expect(0, 70517, '\P{^Is_Indic_Syllabic_Category= CANTILLATION_MARK}', "");
    Error('\p{Is_InSC= 	Cantillation_Mark:=}');
    Error('\P{Is_InSC= 	Cantillation_Mark:=}');
    Expect(1, 70516, '\p{Is_InSC=cantillationmark}', "");
    Expect(0, 70516, '\p{^Is_InSC=cantillationmark}', "");
    Expect(0, 70516, '\P{Is_InSC=cantillationmark}', "");
    Expect(1, 70516, '\P{^Is_InSC=cantillationmark}', "");
    Expect(0, 70517, '\p{Is_InSC=cantillationmark}', "");
    Expect(1, 70517, '\p{^Is_InSC=cantillationmark}', "");
    Expect(1, 70517, '\P{Is_InSC=cantillationmark}', "");
    Expect(0, 70517, '\P{^Is_InSC=cantillationmark}', "");
    Expect(1, 70516, '\p{Is_InSC=	CANTILLATION_mark}', "");
    Expect(0, 70516, '\p{^Is_InSC=	CANTILLATION_mark}', "");
    Expect(0, 70516, '\P{Is_InSC=	CANTILLATION_mark}', "");
    Expect(1, 70516, '\P{^Is_InSC=	CANTILLATION_mark}', "");
    Expect(0, 70517, '\p{Is_InSC=	CANTILLATION_mark}', "");
    Expect(1, 70517, '\p{^Is_InSC=	CANTILLATION_mark}', "");
    Expect(1, 70517, '\P{Is_InSC=	CANTILLATION_mark}', "");
    Expect(0, 70517, '\P{^Is_InSC=	CANTILLATION_mark}', "");
    Error('\p{Indic_Syllabic_Category=-Consonant/a/}');
    Error('\P{Indic_Syllabic_Category=-Consonant/a/}');
    Expect(1, 73457, '\p{Indic_Syllabic_Category=:\AConsonant\z:}', "");;
    Expect(0, 73458, '\p{Indic_Syllabic_Category=:\AConsonant\z:}', "");;
    Expect(1, 73457, '\p{Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73457, '\p{^Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73457, '\P{Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73457, '\P{^Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73458, '\p{Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73458, '\p{^Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73458, '\P{Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73458, '\P{^Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73457, '\p{Indic_Syllabic_Category=:\Aconsonant\z:}', "");;
    Expect(0, 73458, '\p{Indic_Syllabic_Category=:\Aconsonant\z:}', "");;
    Expect(1, 73457, '\p{Indic_Syllabic_Category=	-Consonant}', "");
    Expect(0, 73457, '\p{^Indic_Syllabic_Category=	-Consonant}', "");
    Expect(0, 73457, '\P{Indic_Syllabic_Category=	-Consonant}', "");
    Expect(1, 73457, '\P{^Indic_Syllabic_Category=	-Consonant}', "");
    Expect(0, 73458, '\p{Indic_Syllabic_Category=	-Consonant}', "");
    Expect(1, 73458, '\p{^Indic_Syllabic_Category=	-Consonant}', "");
    Expect(1, 73458, '\P{Indic_Syllabic_Category=	-Consonant}', "");
    Expect(0, 73458, '\P{^Indic_Syllabic_Category=	-Consonant}', "");
    Error('\p{InSC=:= 	consonant}');
    Error('\P{InSC=:= 	consonant}');
    Expect(1, 73457, '\p{InSC=:\AConsonant\z:}', "");;
    Expect(0, 73458, '\p{InSC=:\AConsonant\z:}', "");;
    Expect(1, 73457, '\p{InSC=consonant}', "");
    Expect(0, 73457, '\p{^InSC=consonant}', "");
    Expect(0, 73457, '\P{InSC=consonant}', "");
    Expect(1, 73457, '\P{^InSC=consonant}', "");
    Expect(0, 73458, '\p{InSC=consonant}', "");
    Expect(1, 73458, '\p{^InSC=consonant}', "");
    Expect(1, 73458, '\P{InSC=consonant}', "");
    Expect(0, 73458, '\P{^InSC=consonant}', "");
    Expect(1, 73457, '\p{InSC=:\Aconsonant\z:}', "");;
    Expect(0, 73458, '\p{InSC=:\Aconsonant\z:}', "");;
    Expect(1, 73457, '\p{InSC=_-CONSONANT}', "");
    Expect(0, 73457, '\p{^InSC=_-CONSONANT}', "");
    Expect(0, 73457, '\P{InSC=_-CONSONANT}', "");
    Expect(1, 73457, '\P{^InSC=_-CONSONANT}', "");
    Expect(0, 73458, '\p{InSC=_-CONSONANT}', "");
    Expect(1, 73458, '\p{^InSC=_-CONSONANT}', "");
    Expect(1, 73458, '\P{InSC=_-CONSONANT}', "");
    Expect(0, 73458, '\P{^InSC=_-CONSONANT}', "");
    Error('\p{Is_Indic_Syllabic_Category=_-consonant:=}');
    Error('\P{Is_Indic_Syllabic_Category=_-consonant:=}');
    Expect(1, 73457, '\p{Is_Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73457, '\p{^Is_Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73457, '\P{Is_Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73457, '\P{^Is_Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73458, '\p{Is_Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73458, '\p{^Is_Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73458, '\P{Is_Indic_Syllabic_Category=consonant}', "");
    Expect(0, 73458, '\P{^Is_Indic_Syllabic_Category=consonant}', "");
    Expect(1, 73457, '\p{Is_Indic_Syllabic_Category=_Consonant}', "");
    Expect(0, 73457, '\p{^Is_Indic_Syllabic_Category=_Consonant}', "");
    Expect(0, 73457, '\P{Is_Indic_Syllabic_Category=_Consonant}', "");
    Expect(1, 73457, '\P{^Is_Indic_Syllabic_Category=_Consonant}', "");
    Expect(0, 73458, '\p{Is_Indic_Syllabic_Category=_Consonant}', "");
    Expect(1, 73458, '\p{^Is_Indic_Syllabic_Category=_Consonant}', "");
    Expect(1, 73458, '\P{Is_Indic_Syllabic_Category=_Consonant}', "");
    Expect(0, 73458, '\P{^Is_Indic_Syllabic_Category=_Consonant}', "");
    Error('\p{Is_InSC=	:=consonant}');
    Error('\P{Is_InSC=	:=consonant}');
    Expect(1, 73457, '\p{Is_InSC=consonant}', "");
    Expect(0, 73457, '\p{^Is_InSC=consonant}', "");
    Expect(0, 73457, '\P{Is_InSC=consonant}', "");
    Expect(1, 73457, '\P{^Is_InSC=consonant}', "");
    Expect(0, 73458, '\p{Is_InSC=consonant}', "");
    Expect(1, 73458, '\p{^Is_InSC=consonant}', "");
    Expect(1, 73458, '\P{Is_InSC=consonant}', "");
    Expect(0, 73458, '\P{^Is_InSC=consonant}', "");
    Expect(1, 73457, '\p{Is_InSC: -_consonant}', "");
    Expect(0, 73457, '\p{^Is_InSC: -_consonant}', "");
    Expect(0, 73457, '\P{Is_InSC: -_consonant}', "");
    Expect(1, 73457, '\P{^Is_InSC: -_consonant}', "");
    Expect(0, 73458, '\p{Is_InSC: -_consonant}', "");
    Expect(1, 73458, '\p{^Is_InSC: -_consonant}', "");
    Expect(1, 73458, '\P{Is_InSC: -_consonant}', "");
    Expect(0, 73458, '\P{^Is_InSC: -_consonant}', "");
    Error('\p{Indic_Syllabic_Category=:= _Consonant_DEAD}');
    Error('\P{Indic_Syllabic_Category=:= _Consonant_DEAD}');
    Expect(1, 7411, '\p{Indic_Syllabic_Category=:\AConsonant_Dead\z:}', "");;
    Expect(0, 7412, '\p{Indic_Syllabic_Category=:\AConsonant_Dead\z:}', "");;
    Expect(1, 7411, '\p{Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 7411, '\p{^Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 7411, '\P{Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 7411, '\P{^Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 7412, '\p{Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 7412, '\p{^Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 7412, '\P{Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 7412, '\P{^Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 7411, '\p{Indic_Syllabic_Category=:\Aconsonantdead\z:}', "");;
    Expect(0, 7412, '\p{Indic_Syllabic_Category=:\Aconsonantdead\z:}', "");;
    Expect(1, 7411, '\p{Indic_Syllabic_Category=		CONSONANT_DEAD}', "");
    Expect(0, 7411, '\p{^Indic_Syllabic_Category=		CONSONANT_DEAD}', "");
    Expect(0, 7411, '\P{Indic_Syllabic_Category=		CONSONANT_DEAD}', "");
    Expect(1, 7411, '\P{^Indic_Syllabic_Category=		CONSONANT_DEAD}', "");
    Expect(0, 7412, '\p{Indic_Syllabic_Category=		CONSONANT_DEAD}', "");
    Expect(1, 7412, '\p{^Indic_Syllabic_Category=		CONSONANT_DEAD}', "");
    Expect(1, 7412, '\P{Indic_Syllabic_Category=		CONSONANT_DEAD}', "");
    Expect(0, 7412, '\P{^Indic_Syllabic_Category=		CONSONANT_DEAD}', "");
    Error('\p{InSC=	/a/consonant_Dead}');
    Error('\P{InSC=	/a/consonant_Dead}');
    Expect(1, 7411, '\p{InSC=:\AConsonant_Dead\z:}', "");;
    Expect(0, 7412, '\p{InSC=:\AConsonant_Dead\z:}', "");;
    Expect(1, 7411, '\p{InSC=consonantdead}', "");
    Expect(0, 7411, '\p{^InSC=consonantdead}', "");
    Expect(0, 7411, '\P{InSC=consonantdead}', "");
    Expect(1, 7411, '\P{^InSC=consonantdead}', "");
    Expect(0, 7412, '\p{InSC=consonantdead}', "");
    Expect(1, 7412, '\p{^InSC=consonantdead}', "");
    Expect(1, 7412, '\P{InSC=consonantdead}', "");
    Expect(0, 7412, '\P{^InSC=consonantdead}', "");
    Expect(1, 7411, '\p{InSC=:\Aconsonantdead\z:}', "");;
    Expect(0, 7412, '\p{InSC=:\Aconsonantdead\z:}', "");;
    Expect(1, 7411, '\p{InSC=_consonant_dead}', "");
    Expect(0, 7411, '\p{^InSC=_consonant_dead}', "");
    Expect(0, 7411, '\P{InSC=_consonant_dead}', "");
    Expect(1, 7411, '\P{^InSC=_consonant_dead}', "");
    Expect(0, 7412, '\p{InSC=_consonant_dead}', "");
    Expect(1, 7412, '\p{^InSC=_consonant_dead}', "");
    Expect(1, 7412, '\P{InSC=_consonant_dead}', "");
    Expect(0, 7412, '\P{^InSC=_consonant_dead}', "");
    Error('\p{Is_Indic_Syllabic_Category=  Consonant_dead:=}');
    Error('\P{Is_Indic_Syllabic_Category=  Consonant_dead:=}');
    Expect(1, 7411, '\p{Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 7411, '\p{^Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 7411, '\P{Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 7411, '\P{^Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 7412, '\p{Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 7412, '\p{^Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 7412, '\P{Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(0, 7412, '\P{^Is_Indic_Syllabic_Category=consonantdead}', "");
    Expect(1, 7411, '\p{Is_Indic_Syllabic_Category=-Consonant_dead}', "");
    Expect(0, 7411, '\p{^Is_Indic_Syllabic_Category=-Consonant_dead}', "");
    Expect(0, 7411, '\P{Is_Indic_Syllabic_Category=-Consonant_dead}', "");
    Expect(1, 7411, '\P{^Is_Indic_Syllabic_Category=-Consonant_dead}', "");
    Expect(0, 7412, '\p{Is_Indic_Syllabic_Category=-Consonant_dead}', "");
    Expect(1, 7412, '\p{^Is_Indic_Syllabic_Category=-Consonant_dead}', "");
    Expect(1, 7412, '\P{Is_Indic_Syllabic_Category=-Consonant_dead}', "");
    Expect(0, 7412, '\P{^Is_Indic_Syllabic_Category=-Consonant_dead}', "");
    Error('\p{Is_InSC=-_Consonant_DEAD:=}');
    Error('\P{Is_InSC=-_Consonant_DEAD:=}');
    Expect(1, 7411, '\p{Is_InSC=consonantdead}', "");
    Expect(0, 7411, '\p{^Is_InSC=consonantdead}', "");
    Expect(0, 7411, '\P{Is_InSC=consonantdead}', "");
    Expect(1, 7411, '\P{^Is_InSC=consonantdead}', "");
    Expect(0, 7412, '\p{Is_InSC=consonantdead}', "");
    Expect(1, 7412, '\p{^Is_InSC=consonantdead}', "");
    Expect(1, 7412, '\P{Is_InSC=consonantdead}', "");
    Expect(0, 7412, '\P{^Is_InSC=consonantdead}', "");
    Expect(1, 7411, '\p{Is_InSC=-	CONSONANT_DEAD}', "");
    Expect(0, 7411, '\p{^Is_InSC=-	CONSONANT_DEAD}', "");
    Expect(0, 7411, '\P{Is_InSC=-	CONSONANT_DEAD}', "");
    Expect(1, 7411, '\P{^Is_InSC=-	CONSONANT_DEAD}', "");
    Expect(0, 7412, '\p{Is_InSC=-	CONSONANT_DEAD}', "");
    Expect(1, 7412, '\p{^Is_InSC=-	CONSONANT_DEAD}', "");
    Expect(1, 7412, '\P{Is_InSC=-	CONSONANT_DEAD}', "");
    Expect(0, 7412, '\P{^Is_InSC=-	CONSONANT_DEAD}', "");
    Error('\p{Indic_Syllabic_Category=-	CONSONANT_Final/a/}');
    Error('\P{Indic_Syllabic_Category=-	CONSONANT_Final/a/}');
    Expect(1, 72341, '\p{Indic_Syllabic_Category=:\AConsonant_Final\z:}', "");;
    Expect(0, 72342, '\p{Indic_Syllabic_Category=:\AConsonant_Final\z:}', "");;
    Expect(1, 72341, '\p{Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72341, '\p{^Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72341, '\P{Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72341, '\P{^Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72342, '\p{Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72342, '\p{^Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72342, '\P{Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72342, '\P{^Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72341, '\p{Indic_Syllabic_Category=:\Aconsonantfinal\z:}', "");;
    Expect(0, 72342, '\p{Indic_Syllabic_Category=:\Aconsonantfinal\z:}', "");;
    Expect(1, 72341, '\p{Indic_Syllabic_Category=--Consonant_Final}', "");
    Expect(0, 72341, '\p{^Indic_Syllabic_Category=--Consonant_Final}', "");
    Expect(0, 72341, '\P{Indic_Syllabic_Category=--Consonant_Final}', "");
    Expect(1, 72341, '\P{^Indic_Syllabic_Category=--Consonant_Final}', "");
    Expect(0, 72342, '\p{Indic_Syllabic_Category=--Consonant_Final}', "");
    Expect(1, 72342, '\p{^Indic_Syllabic_Category=--Consonant_Final}', "");
    Expect(1, 72342, '\P{Indic_Syllabic_Category=--Consonant_Final}', "");
    Expect(0, 72342, '\P{^Indic_Syllabic_Category=--Consonant_Final}', "");
    Error('\p{InSC=-:=CONSONANT_Final}');
    Error('\P{InSC=-:=CONSONANT_Final}');
    Expect(1, 72341, '\p{InSC=:\AConsonant_Final\z:}', "");;
    Expect(0, 72342, '\p{InSC=:\AConsonant_Final\z:}', "");;
    Expect(1, 72341, '\p{InSC=consonantfinal}', "");
    Expect(0, 72341, '\p{^InSC=consonantfinal}', "");
    Expect(0, 72341, '\P{InSC=consonantfinal}', "");
    Expect(1, 72341, '\P{^InSC=consonantfinal}', "");
    Expect(0, 72342, '\p{InSC=consonantfinal}', "");
    Expect(1, 72342, '\p{^InSC=consonantfinal}', "");
    Expect(1, 72342, '\P{InSC=consonantfinal}', "");
    Expect(0, 72342, '\P{^InSC=consonantfinal}', "");
    Expect(1, 72341, '\p{InSC=:\Aconsonantfinal\z:}', "");;
    Expect(0, 72342, '\p{InSC=:\Aconsonantfinal\z:}', "");;
    Expect(1, 72341, '\p{InSC=Consonant_final}', "");
    Expect(0, 72341, '\p{^InSC=Consonant_final}', "");
    Expect(0, 72341, '\P{InSC=Consonant_final}', "");
    Expect(1, 72341, '\P{^InSC=Consonant_final}', "");
    Expect(0, 72342, '\p{InSC=Consonant_final}', "");
    Expect(1, 72342, '\p{^InSC=Consonant_final}', "");
    Expect(1, 72342, '\P{InSC=Consonant_final}', "");
    Expect(0, 72342, '\P{^InSC=Consonant_final}', "");
    Error('\p{Is_Indic_Syllabic_Category:	:=_consonant_final}');
    Error('\P{Is_Indic_Syllabic_Category:	:=_consonant_final}');
    Expect(1, 72341, '\p{Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72341, '\p{^Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72341, '\P{Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72341, '\P{^Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72342, '\p{Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72342, '\p{^Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72342, '\P{Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(0, 72342, '\P{^Is_Indic_Syllabic_Category=consonantfinal}', "");
    Expect(1, 72341, '\p{Is_Indic_Syllabic_Category:	-CONSONANT_Final}', "");
    Expect(0, 72341, '\p{^Is_Indic_Syllabic_Category:	-CONSONANT_Final}', "");
    Expect(0, 72341, '\P{Is_Indic_Syllabic_Category:	-CONSONANT_Final}', "");
    Expect(1, 72341, '\P{^Is_Indic_Syllabic_Category:	-CONSONANT_Final}', "");
    Expect(0, 72342, '\p{Is_Indic_Syllabic_Category:	-CONSONANT_Final}', "");
    Expect(1, 72342, '\p{^Is_Indic_Syllabic_Category:	-CONSONANT_Final}', "");
    Expect(1, 72342, '\P{Is_Indic_Syllabic_Category:	-CONSONANT_Final}', "");
    Expect(0, 72342, '\P{^Is_Indic_Syllabic_Category:	-CONSONANT_Final}', "");
    Error('\p{Is_InSC=/a/Consonant_final}');
    Error('\P{Is_InSC=/a/Consonant_final}');
    Expect(1, 72341, '\p{Is_InSC=consonantfinal}', "");
    Expect(0, 72341, '\p{^Is_InSC=consonantfinal}', "");
    Expect(0, 72341, '\P{Is_InSC=consonantfinal}', "");
    Expect(1, 72341, '\P{^Is_InSC=consonantfinal}', "");
    Expect(0, 72342, '\p{Is_InSC=consonantfinal}', "");
    Expect(1, 72342, '\p{^Is_InSC=consonantfinal}', "");
    Expect(1, 72342, '\P{Is_InSC=consonantfinal}', "");
    Expect(0, 72342, '\P{^Is_InSC=consonantfinal}', "");
    Expect(1, 72341, '\p{Is_InSC=		consonant_Final}', "");
    Expect(0, 72341, '\p{^Is_InSC=		consonant_Final}', "");
    Expect(0, 72341, '\P{Is_InSC=		consonant_Final}', "");
    Expect(1, 72341, '\P{^Is_InSC=		consonant_Final}', "");
    Expect(0, 72342, '\p{Is_InSC=		consonant_Final}', "");
    Expect(1, 72342, '\p{^Is_InSC=		consonant_Final}', "");
    Expect(1, 72342, '\P{Is_InSC=		consonant_Final}', "");
    Expect(0, 72342, '\P{^Is_InSC=		consonant_Final}', "");
    Error('\p{Indic_Syllabic_Category=_/a/Consonant_HEAD_LETTER}');
    Error('\P{Indic_Syllabic_Category=_/a/Consonant_HEAD_LETTER}');
    Expect(1, 3980, '\p{Indic_Syllabic_Category=:\AConsonant_Head_Letter\z:}', "");;
    Expect(0, 3981, '\p{Indic_Syllabic_Category=:\AConsonant_Head_Letter\z:}', "");;
    Expect(1, 3980, '\p{Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3980, '\p{^Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3980, '\P{Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3980, '\P{^Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3981, '\p{Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3981, '\p{^Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3981, '\P{Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3981, '\P{^Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3980, '\p{Indic_Syllabic_Category=:\Aconsonantheadletter\z:}', "");;
    Expect(0, 3981, '\p{Indic_Syllabic_Category=:\Aconsonantheadletter\z:}', "");;
    Expect(1, 3980, '\p{Indic_Syllabic_Category= consonant_Head_Letter}', "");
    Expect(0, 3980, '\p{^Indic_Syllabic_Category= consonant_Head_Letter}', "");
    Expect(0, 3980, '\P{Indic_Syllabic_Category= consonant_Head_Letter}', "");
    Expect(1, 3980, '\P{^Indic_Syllabic_Category= consonant_Head_Letter}', "");
    Expect(0, 3981, '\p{Indic_Syllabic_Category= consonant_Head_Letter}', "");
    Expect(1, 3981, '\p{^Indic_Syllabic_Category= consonant_Head_Letter}', "");
    Expect(1, 3981, '\P{Indic_Syllabic_Category= consonant_Head_Letter}', "");
    Expect(0, 3981, '\P{^Indic_Syllabic_Category= consonant_Head_Letter}', "");
    Error('\p{InSC=:=	-CONSONANT_head_Letter}');
    Error('\P{InSC=:=	-CONSONANT_head_Letter}');
    Expect(1, 3980, '\p{InSC=:\AConsonant_Head_Letter\z:}', "");;
    Expect(0, 3981, '\p{InSC=:\AConsonant_Head_Letter\z:}', "");;
    Expect(1, 3980, '\p{InSC=consonantheadletter}', "");
    Expect(0, 3980, '\p{^InSC=consonantheadletter}', "");
    Expect(0, 3980, '\P{InSC=consonantheadletter}', "");
    Expect(1, 3980, '\P{^InSC=consonantheadletter}', "");
    Expect(0, 3981, '\p{InSC=consonantheadletter}', "");
    Expect(1, 3981, '\p{^InSC=consonantheadletter}', "");
    Expect(1, 3981, '\P{InSC=consonantheadletter}', "");
    Expect(0, 3981, '\P{^InSC=consonantheadletter}', "");
    Expect(1, 3980, '\p{InSC=:\Aconsonantheadletter\z:}', "");;
    Expect(0, 3981, '\p{InSC=:\Aconsonantheadletter\z:}', "");;
    Expect(1, 3980, '\p{InSC=CONSONANT_Head_letter}', "");
    Expect(0, 3980, '\p{^InSC=CONSONANT_Head_letter}', "");
    Expect(0, 3980, '\P{InSC=CONSONANT_Head_letter}', "");
    Expect(1, 3980, '\P{^InSC=CONSONANT_Head_letter}', "");
    Expect(0, 3981, '\p{InSC=CONSONANT_Head_letter}', "");
    Expect(1, 3981, '\p{^InSC=CONSONANT_Head_letter}', "");
    Expect(1, 3981, '\P{InSC=CONSONANT_Head_letter}', "");
    Expect(0, 3981, '\P{^InSC=CONSONANT_Head_letter}', "");
    Error('\p{Is_Indic_Syllabic_Category=	:=CONSONANT_head_LETTER}');
    Error('\P{Is_Indic_Syllabic_Category=	:=CONSONANT_head_LETTER}');
    Expect(1, 3980, '\p{Is_Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3980, '\p{^Is_Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3980, '\P{Is_Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3980, '\P{^Is_Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3981, '\p{Is_Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3981, '\p{^Is_Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3981, '\P{Is_Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(0, 3981, '\P{^Is_Indic_Syllabic_Category=consonantheadletter}', "");
    Expect(1, 3980, '\p{Is_Indic_Syllabic_Category=__consonant_Head_Letter}', "");
    Expect(0, 3980, '\p{^Is_Indic_Syllabic_Category=__consonant_Head_Letter}', "");
    Expect(0, 3980, '\P{Is_Indic_Syllabic_Category=__consonant_Head_Letter}', "");
    Expect(1, 3980, '\P{^Is_Indic_Syllabic_Category=__consonant_Head_Letter}', "");
    Expect(0, 3981, '\p{Is_Indic_Syllabic_Category=__consonant_Head_Letter}', "");
    Expect(1, 3981, '\p{^Is_Indic_Syllabic_Category=__consonant_Head_Letter}', "");
    Expect(1, 3981, '\P{Is_Indic_Syllabic_Category=__consonant_Head_Letter}', "");
    Expect(0, 3981, '\P{^Is_Indic_Syllabic_Category=__consonant_Head_Letter}', "");
    Error('\p{Is_InSC=-CONSONANT_HEAD_Letter:=}');
    Error('\P{Is_InSC=-CONSONANT_HEAD_Letter:=}');
    Expect(1, 3980, '\p{Is_InSC=consonantheadletter}', "");
    Expect(0, 3980, '\p{^Is_InSC=consonantheadletter}', "");
    Expect(0, 3980, '\P{Is_InSC=consonantheadletter}', "");
    Expect(1, 3980, '\P{^Is_InSC=consonantheadletter}', "");
    Expect(0, 3981, '\p{Is_InSC=consonantheadletter}', "");
    Expect(1, 3981, '\p{^Is_InSC=consonantheadletter}', "");
    Expect(1, 3981, '\P{Is_InSC=consonantheadletter}', "");
    Expect(0, 3981, '\P{^Is_InSC=consonantheadletter}', "");
    Expect(1, 3980, '\p{Is_InSC=--Consonant_HEAD_letter}', "");
    Expect(0, 3980, '\p{^Is_InSC=--Consonant_HEAD_letter}', "");
    Expect(0, 3980, '\P{Is_InSC=--Consonant_HEAD_letter}', "");
    Expect(1, 3980, '\P{^Is_InSC=--Consonant_HEAD_letter}', "");
    Expect(0, 3981, '\p{Is_InSC=--Consonant_HEAD_letter}', "");
    Expect(1, 3981, '\p{^Is_InSC=--Consonant_HEAD_letter}', "");
    Expect(1, 3981, '\P{Is_InSC=--Consonant_HEAD_letter}', "");
    Expect(0, 3981, '\P{^Is_InSC=--Consonant_HEAD_letter}', "");
    Error('\p{Indic_Syllabic_Category=	/a/CONSONANT_Initial_Postfixed}');
    Error('\P{Indic_Syllabic_Category=	/a/CONSONANT_Initial_Postfixed}');
    Expect(1, 6746, '\p{Indic_Syllabic_Category=:\AConsonant_Initial_Postfixed\z:}', "");;
    Expect(0, 6747, '\p{Indic_Syllabic_Category=:\AConsonant_Initial_Postfixed\z:}', "");;
    Expect(1, 6746, '\p{Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(0, 6746, '\p{^Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(0, 6746, '\P{Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(1, 6746, '\P{^Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(0, 6747, '\p{Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(1, 6747, '\p{^Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(1, 6747, '\P{Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(0, 6747, '\P{^Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(1, 6746, '\p{Indic_Syllabic_Category=:\Aconsonantinitialpostfixed\z:}', "");;
    Expect(0, 6747, '\p{Indic_Syllabic_Category=:\Aconsonantinitialpostfixed\z:}', "");;
    Expect(1, 6746, '\p{Indic_Syllabic_Category=_	CONSONANT_Initial_POSTFIXED}', "");
    Expect(0, 6746, '\p{^Indic_Syllabic_Category=_	CONSONANT_Initial_POSTFIXED}', "");
    Expect(0, 6746, '\P{Indic_Syllabic_Category=_	CONSONANT_Initial_POSTFIXED}', "");
    Expect(1, 6746, '\P{^Indic_Syllabic_Category=_	CONSONANT_Initial_POSTFIXED}', "");
    Expect(0, 6747, '\p{Indic_Syllabic_Category=_	CONSONANT_Initial_POSTFIXED}', "");
    Expect(1, 6747, '\p{^Indic_Syllabic_Category=_	CONSONANT_Initial_POSTFIXED}', "");
    Expect(1, 6747, '\P{Indic_Syllabic_Category=_	CONSONANT_Initial_POSTFIXED}', "");
    Expect(0, 6747, '\P{^Indic_Syllabic_Category=_	CONSONANT_Initial_POSTFIXED}', "");
    Error('\p{InSC=:=-Consonant_INITIAL_POSTFIXED}');
    Error('\P{InSC=:=-Consonant_INITIAL_POSTFIXED}');
    Expect(1, 6746, '\p{InSC=:\AConsonant_Initial_Postfixed\z:}', "");;
    Expect(0, 6747, '\p{InSC=:\AConsonant_Initial_Postfixed\z:}', "");;
    Expect(1, 6746, '\p{InSC=consonantinitialpostfixed}', "");
    Expect(0, 6746, '\p{^InSC=consonantinitialpostfixed}', "");
    Expect(0, 6746, '\P{InSC=consonantinitialpostfixed}', "");
    Expect(1, 6746, '\P{^InSC=consonantinitialpostfixed}', "");
    Expect(0, 6747, '\p{InSC=consonantinitialpostfixed}', "");
    Expect(1, 6747, '\p{^InSC=consonantinitialpostfixed}', "");
    Expect(1, 6747, '\P{InSC=consonantinitialpostfixed}', "");
    Expect(0, 6747, '\P{^InSC=consonantinitialpostfixed}', "");
    Expect(1, 6746, '\p{InSC=:\Aconsonantinitialpostfixed\z:}', "");;
    Expect(0, 6747, '\p{InSC=:\Aconsonantinitialpostfixed\z:}', "");;
    Expect(1, 6746, '\p{InSC= -Consonant_initial_Postfixed}', "");
    Expect(0, 6746, '\p{^InSC= -Consonant_initial_Postfixed}', "");
    Expect(0, 6746, '\P{InSC= -Consonant_initial_Postfixed}', "");
    Expect(1, 6746, '\P{^InSC= -Consonant_initial_Postfixed}', "");
    Expect(0, 6747, '\p{InSC= -Consonant_initial_Postfixed}', "");
    Expect(1, 6747, '\p{^InSC= -Consonant_initial_Postfixed}', "");
    Expect(1, 6747, '\P{InSC= -Consonant_initial_Postfixed}', "");
    Expect(0, 6747, '\P{^InSC= -Consonant_initial_Postfixed}', "");
    Error('\p{Is_Indic_Syllabic_Category=/a/ -Consonant_Initial_POSTFIXED}');
    Error('\P{Is_Indic_Syllabic_Category=/a/ -Consonant_Initial_POSTFIXED}');
    Expect(1, 6746, '\p{Is_Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(0, 6746, '\p{^Is_Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(0, 6746, '\P{Is_Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(1, 6746, '\P{^Is_Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(0, 6747, '\p{Is_Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(1, 6747, '\p{^Is_Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(1, 6747, '\P{Is_Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(0, 6747, '\P{^Is_Indic_Syllabic_Category=consonantinitialpostfixed}', "");
    Expect(1, 6746, '\p{Is_Indic_Syllabic_Category=_Consonant_INITIAL_Postfixed}', "");
    Expect(0, 6746, '\p{^Is_Indic_Syllabic_Category=_Consonant_INITIAL_Postfixed}', "");
    Expect(0, 6746, '\P{Is_Indic_Syllabic_Category=_Consonant_INITIAL_Postfixed}', "");
    Expect(1, 6746, '\P{^Is_Indic_Syllabic_Category=_Consonant_INITIAL_Postfixed}', "");
    Expect(0, 6747, '\p{Is_Indic_Syllabic_Category=_Consonant_INITIAL_Postfixed}', "");
    Expect(1, 6747, '\p{^Is_Indic_Syllabic_Category=_Consonant_INITIAL_Postfixed}', "");
    Expect(1, 6747, '\P{Is_Indic_Syllabic_Category=_Consonant_INITIAL_Postfixed}', "");
    Expect(0, 6747, '\P{^Is_Indic_Syllabic_Category=_Consonant_INITIAL_Postfixed}', "");
    Error('\p{Is_InSC=_:=Consonant_Initial_Postfixed}');
    Error('\P{Is_InSC=_:=Consonant_Initial_Postfixed}');
    Expect(1, 6746, '\p{Is_InSC=consonantinitialpostfixed}', "");
    Expect(0, 6746, '\p{^Is_InSC=consonantinitialpostfixed}', "");
    Expect(0, 6746, '\P{Is_InSC=consonantinitialpostfixed}', "");
    Expect(1, 6746, '\P{^Is_InSC=consonantinitialpostfixed}', "");
    Expect(0, 6747, '\p{Is_InSC=consonantinitialpostfixed}', "");
    Expect(1, 6747, '\p{^Is_InSC=consonantinitialpostfixed}', "");
    Expect(1, 6747, '\P{Is_InSC=consonantinitialpostfixed}', "");
    Expect(0, 6747, '\P{^Is_InSC=consonantinitialpostfixed}', "");
    Expect(1, 6746, '\p{Is_InSC=-Consonant_Initial_Postfixed}', "");
    Expect(0, 6746, '\p{^Is_InSC=-Consonant_Initial_Postfixed}', "");
    Expect(0, 6746, '\P{Is_InSC=-Consonant_Initial_Postfixed}', "");
    Expect(1, 6746, '\P{^Is_InSC=-Consonant_Initial_Postfixed}', "");
    Expect(0, 6747, '\p{Is_InSC=-Consonant_Initial_Postfixed}', "");
    Expect(1, 6747, '\p{^Is_InSC=-Consonant_Initial_Postfixed}', "");
    Expect(1, 6747, '\P{Is_InSC=-Consonant_Initial_Postfixed}', "");
    Expect(0, 6747, '\P{^Is_InSC=-Consonant_Initial_Postfixed}', "");
    Error('\p{Indic_Syllabic_Category=_Consonant_Killer:=}');
    Error('\P{Indic_Syllabic_Category=_Consonant_Killer:=}');
    Expect(1, 6093, '\p{Indic_Syllabic_Category=:\AConsonant_Killer\z:}', "");;
    Expect(0, 6094, '\p{Indic_Syllabic_Category=:\AConsonant_Killer\z:}', "");;
    Expect(1, 6093, '\p{Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6093, '\p{^Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6093, '\P{Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6093, '\P{^Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6094, '\p{Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6094, '\p{^Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6094, '\P{Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6094, '\P{^Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6093, '\p{Indic_Syllabic_Category=:\Aconsonantkiller\z:}', "");;
    Expect(0, 6094, '\p{Indic_Syllabic_Category=:\Aconsonantkiller\z:}', "");;
    Expect(1, 6093, '\p{Indic_Syllabic_Category:   	Consonant_Killer}', "");
    Expect(0, 6093, '\p{^Indic_Syllabic_Category:   	Consonant_Killer}', "");
    Expect(0, 6093, '\P{Indic_Syllabic_Category:   	Consonant_Killer}', "");
    Expect(1, 6093, '\P{^Indic_Syllabic_Category:   	Consonant_Killer}', "");
    Expect(0, 6094, '\p{Indic_Syllabic_Category:   	Consonant_Killer}', "");
    Expect(1, 6094, '\p{^Indic_Syllabic_Category:   	Consonant_Killer}', "");
    Expect(1, 6094, '\P{Indic_Syllabic_Category:   	Consonant_Killer}', "");
    Expect(0, 6094, '\P{^Indic_Syllabic_Category:   	Consonant_Killer}', "");
    Error('\p{InSC=_CONSONANT_KILLER/a/}');
    Error('\P{InSC=_CONSONANT_KILLER/a/}');
    Expect(1, 6093, '\p{InSC=:\AConsonant_Killer\z:}', "");;
    Expect(0, 6094, '\p{InSC=:\AConsonant_Killer\z:}', "");;
    Expect(1, 6093, '\p{InSC=consonantkiller}', "");
    Expect(0, 6093, '\p{^InSC=consonantkiller}', "");
    Expect(0, 6093, '\P{InSC=consonantkiller}', "");
    Expect(1, 6093, '\P{^InSC=consonantkiller}', "");
    Expect(0, 6094, '\p{InSC=consonantkiller}', "");
    Expect(1, 6094, '\p{^InSC=consonantkiller}', "");
    Expect(1, 6094, '\P{InSC=consonantkiller}', "");
    Expect(0, 6094, '\P{^InSC=consonantkiller}', "");
    Expect(1, 6093, '\p{InSC=:\Aconsonantkiller\z:}', "");;
    Expect(0, 6094, '\p{InSC=:\Aconsonantkiller\z:}', "");;
    Expect(1, 6093, '\p{InSC=_	CONSONANT_Killer}', "");
    Expect(0, 6093, '\p{^InSC=_	CONSONANT_Killer}', "");
    Expect(0, 6093, '\P{InSC=_	CONSONANT_Killer}', "");
    Expect(1, 6093, '\P{^InSC=_	CONSONANT_Killer}', "");
    Expect(0, 6094, '\p{InSC=_	CONSONANT_Killer}', "");
    Expect(1, 6094, '\p{^InSC=_	CONSONANT_Killer}', "");
    Expect(1, 6094, '\P{InSC=_	CONSONANT_Killer}', "");
    Expect(0, 6094, '\P{^InSC=_	CONSONANT_Killer}', "");
    Error('\p{Is_Indic_Syllabic_Category=	:=consonant_KILLER}');
    Error('\P{Is_Indic_Syllabic_Category=	:=consonant_KILLER}');
    Expect(1, 6093, '\p{Is_Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6093, '\p{^Is_Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6093, '\P{Is_Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6093, '\P{^Is_Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6094, '\p{Is_Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6094, '\p{^Is_Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6094, '\P{Is_Indic_Syllabic_Category=consonantkiller}', "");
    Expect(0, 6094, '\P{^Is_Indic_Syllabic_Category=consonantkiller}', "");
    Expect(1, 6093, '\p{Is_Indic_Syllabic_Category:   _ Consonant_Killer}', "");
    Expect(0, 6093, '\p{^Is_Indic_Syllabic_Category:   _ Consonant_Killer}', "");
    Expect(0, 6093, '\P{Is_Indic_Syllabic_Category:   _ Consonant_Killer}', "");
    Expect(1, 6093, '\P{^Is_Indic_Syllabic_Category:   _ Consonant_Killer}', "");
    Expect(0, 6094, '\p{Is_Indic_Syllabic_Category:   _ Consonant_Killer}', "");
    Expect(1, 6094, '\p{^Is_Indic_Syllabic_Category:   _ Consonant_Killer}', "");
    Expect(1, 6094, '\P{Is_Indic_Syllabic_Category:   _ Consonant_Killer}', "");
    Expect(0, 6094, '\P{^Is_Indic_Syllabic_Category:   _ Consonant_Killer}', "");
    Error('\p{Is_InSC=	Consonant_Killer:=}');
    Error('\P{Is_InSC=	Consonant_Killer:=}');
    Expect(1, 6093, '\p{Is_InSC=consonantkiller}', "");
    Expect(0, 6093, '\p{^Is_InSC=consonantkiller}', "");
    Expect(0, 6093, '\P{Is_InSC=consonantkiller}', "");
    Expect(1, 6093, '\P{^Is_InSC=consonantkiller}', "");
    Expect(0, 6094, '\p{Is_InSC=consonantkiller}', "");
    Expect(1, 6094, '\p{^Is_InSC=consonantkiller}', "");
    Expect(1, 6094, '\P{Is_InSC=consonantkiller}', "");
    Expect(0, 6094, '\P{^Is_InSC=consonantkiller}', "");
    Expect(1, 6093, '\p{Is_InSC= Consonant_killer}', "");
    Expect(0, 6093, '\p{^Is_InSC= Consonant_killer}', "");
    Expect(0, 6093, '\P{Is_InSC= Consonant_killer}', "");
    Expect(1, 6093, '\P{^Is_InSC= Consonant_killer}', "");
    Expect(0, 6094, '\p{Is_InSC= Consonant_killer}', "");
    Expect(1, 6094, '\p{^Is_InSC= Consonant_killer}', "");
    Expect(1, 6094, '\P{Is_InSC= Consonant_killer}', "");
    Expect(0, 6094, '\P{^Is_InSC= Consonant_killer}', "");
    Error('\p{Indic_Syllabic_Category=:= -CONSONANT_medial}');
    Error('\P{Indic_Syllabic_Category=:= -CONSONANT_medial}');
    Expect(1, 73031, '\p{Indic_Syllabic_Category=:\AConsonant_Medial\z:}', "");;
    Expect(0, 73032, '\p{Indic_Syllabic_Category=:\AConsonant_Medial\z:}', "");;
    Expect(1, 73031, '\p{Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73031, '\p{^Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73031, '\P{Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73031, '\P{^Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73032, '\p{Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73032, '\p{^Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73032, '\P{Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73032, '\P{^Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73031, '\p{Indic_Syllabic_Category=:\Aconsonantmedial\z:}', "");;
    Expect(0, 73032, '\p{Indic_Syllabic_Category=:\Aconsonantmedial\z:}', "");;
    Expect(1, 73031, '\p{Indic_Syllabic_Category=  consonant_Medial}', "");
    Expect(0, 73031, '\p{^Indic_Syllabic_Category=  consonant_Medial}', "");
    Expect(0, 73031, '\P{Indic_Syllabic_Category=  consonant_Medial}', "");
    Expect(1, 73031, '\P{^Indic_Syllabic_Category=  consonant_Medial}', "");
    Expect(0, 73032, '\p{Indic_Syllabic_Category=  consonant_Medial}', "");
    Expect(1, 73032, '\p{^Indic_Syllabic_Category=  consonant_Medial}', "");
    Expect(1, 73032, '\P{Indic_Syllabic_Category=  consonant_Medial}', "");
    Expect(0, 73032, '\P{^Indic_Syllabic_Category=  consonant_Medial}', "");
    Error('\p{InSC=	Consonant_Medial/a/}');
    Error('\P{InSC=	Consonant_Medial/a/}');
    Expect(1, 73031, '\p{InSC=:\AConsonant_Medial\z:}', "");;
    Expect(0, 73032, '\p{InSC=:\AConsonant_Medial\z:}', "");;
    Expect(1, 73031, '\p{InSC=consonantmedial}', "");
    Expect(0, 73031, '\p{^InSC=consonantmedial}', "");
    Expect(0, 73031, '\P{InSC=consonantmedial}', "");
    Expect(1, 73031, '\P{^InSC=consonantmedial}', "");
    Expect(0, 73032, '\p{InSC=consonantmedial}', "");
    Expect(1, 73032, '\p{^InSC=consonantmedial}', "");
    Expect(1, 73032, '\P{InSC=consonantmedial}', "");
    Expect(0, 73032, '\P{^InSC=consonantmedial}', "");
    Expect(1, 73031, '\p{InSC=:\Aconsonantmedial\z:}', "");;
    Expect(0, 73032, '\p{InSC=:\Aconsonantmedial\z:}', "");;
    Expect(1, 73031, '\p{InSC=-consonant_medial}', "");
    Expect(0, 73031, '\p{^InSC=-consonant_medial}', "");
    Expect(0, 73031, '\P{InSC=-consonant_medial}', "");
    Expect(1, 73031, '\P{^InSC=-consonant_medial}', "");
    Expect(0, 73032, '\p{InSC=-consonant_medial}', "");
    Expect(1, 73032, '\p{^InSC=-consonant_medial}', "");
    Expect(1, 73032, '\P{InSC=-consonant_medial}', "");
    Expect(0, 73032, '\P{^InSC=-consonant_medial}', "");
    Error('\p{Is_Indic_Syllabic_Category=-Consonant_medial:=}');
    Error('\P{Is_Indic_Syllabic_Category=-Consonant_medial:=}');
    Expect(1, 73031, '\p{Is_Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73031, '\p{^Is_Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73031, '\P{Is_Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73031, '\P{^Is_Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73032, '\p{Is_Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73032, '\p{^Is_Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73032, '\P{Is_Indic_Syllabic_Category=consonantmedial}', "");
    Expect(0, 73032, '\P{^Is_Indic_Syllabic_Category=consonantmedial}', "");
    Expect(1, 73031, '\p{Is_Indic_Syllabic_Category=_ CONSONANT_Medial}', "");
    Expect(0, 73031, '\p{^Is_Indic_Syllabic_Category=_ CONSONANT_Medial}', "");
    Expect(0, 73031, '\P{Is_Indic_Syllabic_Category=_ CONSONANT_Medial}', "");
    Expect(1, 73031, '\P{^Is_Indic_Syllabic_Category=_ CONSONANT_Medial}', "");
    Expect(0, 73032, '\p{Is_Indic_Syllabic_Category=_ CONSONANT_Medial}', "");
    Expect(1, 73032, '\p{^Is_Indic_Syllabic_Category=_ CONSONANT_Medial}', "");
    Expect(1, 73032, '\P{Is_Indic_Syllabic_Category=_ CONSONANT_Medial}', "");
    Expect(0, 73032, '\P{^Is_Indic_Syllabic_Category=_ CONSONANT_Medial}', "");
    Error('\p{Is_InSC=_consonant_medial:=}');
    Error('\P{Is_InSC=_consonant_medial:=}');
    Expect(1, 73031, '\p{Is_InSC=consonantmedial}', "");
    Expect(0, 73031, '\p{^Is_InSC=consonantmedial}', "");
    Expect(0, 73031, '\P{Is_InSC=consonantmedial}', "");
    Expect(1, 73031, '\P{^Is_InSC=consonantmedial}', "");
    Expect(0, 73032, '\p{Is_InSC=consonantmedial}', "");
    Expect(1, 73032, '\p{^Is_InSC=consonantmedial}', "");
    Expect(1, 73032, '\P{Is_InSC=consonantmedial}', "");
    Expect(0, 73032, '\P{^Is_InSC=consonantmedial}', "");
    Expect(1, 73031, '\p{Is_InSC:	Consonant_medial}', "");
    Expect(0, 73031, '\p{^Is_InSC:	Consonant_medial}', "");
    Expect(0, 73031, '\P{Is_InSC:	Consonant_medial}', "");
    Expect(1, 73031, '\P{^Is_InSC:	Consonant_medial}', "");
    Expect(0, 73032, '\p{Is_InSC:	Consonant_medial}', "");
    Expect(1, 73032, '\p{^Is_InSC:	Consonant_medial}', "");
    Expect(1, 73032, '\P{Is_InSC:	Consonant_medial}', "");
    Expect(0, 73032, '\P{^Is_InSC:	Consonant_medial}', "");
    Error('\p{Indic_Syllabic_Category=_consonant_Placeholder/a/}');
    Error('\P{Indic_Syllabic_Category=_consonant_Placeholder/a/}');
    Expect(1, 73458, '\p{Indic_Syllabic_Category=:\AConsonant_Placeholder\z:}', "");;
    Expect(0, 73459, '\p{Indic_Syllabic_Category=:\AConsonant_Placeholder\z:}', "");;
    Expect(1, 73458, '\p{Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 73458, '\p{^Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 73458, '\P{Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 73458, '\P{^Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 73459, '\p{Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 73459, '\p{^Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 73459, '\P{Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 73459, '\P{^Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 73458, '\p{Indic_Syllabic_Category=:\Aconsonantplaceholder\z:}', "");;
    Expect(0, 73459, '\p{Indic_Syllabic_Category=:\Aconsonantplaceholder\z:}', "");;
    Expect(1, 73458, '\p{Indic_Syllabic_Category=- consonant_Placeholder}', "");
    Expect(0, 73458, '\p{^Indic_Syllabic_Category=- consonant_Placeholder}', "");
    Expect(0, 73458, '\P{Indic_Syllabic_Category=- consonant_Placeholder}', "");
    Expect(1, 73458, '\P{^Indic_Syllabic_Category=- consonant_Placeholder}', "");
    Expect(0, 73459, '\p{Indic_Syllabic_Category=- consonant_Placeholder}', "");
    Expect(1, 73459, '\p{^Indic_Syllabic_Category=- consonant_Placeholder}', "");
    Expect(1, 73459, '\P{Indic_Syllabic_Category=- consonant_Placeholder}', "");
    Expect(0, 73459, '\P{^Indic_Syllabic_Category=- consonant_Placeholder}', "");
    Error('\p{InSC=	_CONSONANT_Placeholder:=}');
    Error('\P{InSC=	_CONSONANT_Placeholder:=}');
    Expect(1, 73458, '\p{InSC=:\AConsonant_Placeholder\z:}', "");;
    Expect(0, 73459, '\p{InSC=:\AConsonant_Placeholder\z:}', "");;
    Expect(1, 73458, '\p{InSC:consonantplaceholder}', "");
    Expect(0, 73458, '\p{^InSC:consonantplaceholder}', "");
    Expect(0, 73458, '\P{InSC:consonantplaceholder}', "");
    Expect(1, 73458, '\P{^InSC:consonantplaceholder}', "");
    Expect(0, 73459, '\p{InSC:consonantplaceholder}', "");
    Expect(1, 73459, '\p{^InSC:consonantplaceholder}', "");
    Expect(1, 73459, '\P{InSC:consonantplaceholder}', "");
    Expect(0, 73459, '\P{^InSC:consonantplaceholder}', "");
    Expect(1, 73458, '\p{InSC=:\Aconsonantplaceholder\z:}', "");;
    Expect(0, 73459, '\p{InSC=:\Aconsonantplaceholder\z:}', "");;
    Expect(1, 73458, '\p{InSC=_Consonant_PLACEHOLDER}', "");
    Expect(0, 73458, '\p{^InSC=_Consonant_PLACEHOLDER}', "");
    Expect(0, 73458, '\P{InSC=_Consonant_PLACEHOLDER}', "");
    Expect(1, 73458, '\P{^InSC=_Consonant_PLACEHOLDER}', "");
    Expect(0, 73459, '\p{InSC=_Consonant_PLACEHOLDER}', "");
    Expect(1, 73459, '\p{^InSC=_Consonant_PLACEHOLDER}', "");
    Expect(1, 73459, '\P{InSC=_Consonant_PLACEHOLDER}', "");
    Expect(0, 73459, '\P{^InSC=_Consonant_PLACEHOLDER}', "");
    Error('\p{Is_Indic_Syllabic_Category=:= -Consonant_PLACEHOLDER}');
    Error('\P{Is_Indic_Syllabic_Category=:= -Consonant_PLACEHOLDER}');
    Expect(1, 73458, '\p{Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 73458, '\p{^Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 73458, '\P{Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 73458, '\P{^Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 73459, '\p{Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 73459, '\p{^Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 73459, '\P{Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(0, 73459, '\P{^Is_Indic_Syllabic_Category=consonantplaceholder}', "");
    Expect(1, 73458, '\p{Is_Indic_Syllabic_Category= Consonant_PLACEHOLDER}', "");
    Expect(0, 73458, '\p{^Is_Indic_Syllabic_Category= Consonant_PLACEHOLDER}', "");
    Expect(0, 73458, '\P{Is_Indic_Syllabic_Category= Consonant_PLACEHOLDER}', "");
    Expect(1, 73458, '\P{^Is_Indic_Syllabic_Category= Consonant_PLACEHOLDER}', "");
    Expect(0, 73459, '\p{Is_Indic_Syllabic_Category= Consonant_PLACEHOLDER}', "");
    Expect(1, 73459, '\p{^Is_Indic_Syllabic_Category= Consonant_PLACEHOLDER}', "");
    Expect(1, 73459, '\P{Is_Indic_Syllabic_Category= Consonant_PLACEHOLDER}', "");
    Expect(0, 73459, '\P{^Is_Indic_Syllabic_Category= Consonant_PLACEHOLDER}', "");
    Error('\p{Is_InSC: _-CONSONANT_Placeholder/a/}');
    Error('\P{Is_InSC: _-CONSONANT_Placeholder/a/}');
    Expect(1, 73458, '\p{Is_InSC=consonantplaceholder}', "");
    Expect(0, 73458, '\p{^Is_InSC=consonantplaceholder}', "");
    Expect(0, 73458, '\P{Is_InSC=consonantplaceholder}', "");
    Expect(1, 73458, '\P{^Is_InSC=consonantplaceholder}', "");
    Expect(0, 73459, '\p{Is_InSC=consonantplaceholder}', "");
    Expect(1, 73459, '\p{^Is_InSC=consonantplaceholder}', "");
    Expect(1, 73459, '\P{Is_InSC=consonantplaceholder}', "");
    Expect(0, 73459, '\P{^Is_InSC=consonantplaceholder}', "");
    Expect(1, 73458, '\p{Is_InSC=	 consonant_placeholder}', "");
    Expect(0, 73458, '\p{^Is_InSC=	 consonant_placeholder}', "");
    Expect(0, 73458, '\P{Is_InSC=	 consonant_placeholder}', "");
    Expect(1, 73458, '\P{^Is_InSC=	 consonant_placeholder}', "");
    Expect(0, 73459, '\p{Is_InSC=	 consonant_placeholder}', "");
    Expect(1, 73459, '\p{^Is_InSC=	 consonant_placeholder}', "");
    Expect(1, 73459, '\P{Is_InSC=	 consonant_placeholder}', "");
    Expect(0, 73459, '\P{^Is_InSC=	 consonant_placeholder}', "");
    Error('\p{Indic_Syllabic_Category=/a/_	Consonant_Preceding_Repha}');
    Error('\P{Indic_Syllabic_Category=/a/_	Consonant_Preceding_Repha}');
    Expect(1, 73030, '\p{Indic_Syllabic_Category=:\AConsonant_Preceding_Repha\z:}', "");;
    Expect(0, 73031, '\p{Indic_Syllabic_Category=:\AConsonant_Preceding_Repha\z:}', "");;
    Expect(1, 73030, '\p{Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73030, '\p{^Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73030, '\P{Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73030, '\P{^Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73031, '\p{Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73031, '\p{^Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73031, '\P{Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73031, '\P{^Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73030, '\p{Indic_Syllabic_Category=:\Aconsonantprecedingrepha\z:}', "");;
    Expect(0, 73031, '\p{Indic_Syllabic_Category=:\Aconsonantprecedingrepha\z:}', "");;
    Expect(1, 73030, '\p{Indic_Syllabic_Category=_-consonant_Preceding_Repha}', "");
    Expect(0, 73030, '\p{^Indic_Syllabic_Category=_-consonant_Preceding_Repha}', "");
    Expect(0, 73030, '\P{Indic_Syllabic_Category=_-consonant_Preceding_Repha}', "");
    Expect(1, 73030, '\P{^Indic_Syllabic_Category=_-consonant_Preceding_Repha}', "");
    Expect(0, 73031, '\p{Indic_Syllabic_Category=_-consonant_Preceding_Repha}', "");
    Expect(1, 73031, '\p{^Indic_Syllabic_Category=_-consonant_Preceding_Repha}', "");
    Expect(1, 73031, '\P{Indic_Syllabic_Category=_-consonant_Preceding_Repha}', "");
    Expect(0, 73031, '\P{^Indic_Syllabic_Category=_-consonant_Preceding_Repha}', "");
    Error('\p{InSC:	/a/CONSONANT_PRECEDING_Repha}');
    Error('\P{InSC:	/a/CONSONANT_PRECEDING_Repha}');
    Expect(1, 73030, '\p{InSC=:\AConsonant_Preceding_Repha\z:}', "");;
    Expect(0, 73031, '\p{InSC=:\AConsonant_Preceding_Repha\z:}', "");;
    Expect(1, 73030, '\p{InSC=consonantprecedingrepha}', "");
    Expect(0, 73030, '\p{^InSC=consonantprecedingrepha}', "");
    Expect(0, 73030, '\P{InSC=consonantprecedingrepha}', "");
    Expect(1, 73030, '\P{^InSC=consonantprecedingrepha}', "");
    Expect(0, 73031, '\p{InSC=consonantprecedingrepha}', "");
    Expect(1, 73031, '\p{^InSC=consonantprecedingrepha}', "");
    Expect(1, 73031, '\P{InSC=consonantprecedingrepha}', "");
    Expect(0, 73031, '\P{^InSC=consonantprecedingrepha}', "");
    Expect(1, 73030, '\p{InSC=:\Aconsonantprecedingrepha\z:}', "");;
    Expect(0, 73031, '\p{InSC=:\Aconsonantprecedingrepha\z:}', "");;
    Expect(1, 73030, '\p{InSC=	 consonant_PRECEDING_Repha}', "");
    Expect(0, 73030, '\p{^InSC=	 consonant_PRECEDING_Repha}', "");
    Expect(0, 73030, '\P{InSC=	 consonant_PRECEDING_Repha}', "");
    Expect(1, 73030, '\P{^InSC=	 consonant_PRECEDING_Repha}', "");
    Expect(0, 73031, '\p{InSC=	 consonant_PRECEDING_Repha}', "");
    Expect(1, 73031, '\p{^InSC=	 consonant_PRECEDING_Repha}', "");
    Expect(1, 73031, '\P{InSC=	 consonant_PRECEDING_Repha}', "");
    Expect(0, 73031, '\P{^InSC=	 consonant_PRECEDING_Repha}', "");
    Error('\p{Is_Indic_Syllabic_Category=:=CONSONANT_PRECEDING_REPHA}');
    Error('\P{Is_Indic_Syllabic_Category=:=CONSONANT_PRECEDING_REPHA}');
    Expect(1, 73030, '\p{Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73030, '\p{^Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73030, '\P{Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73030, '\P{^Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73031, '\p{Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73031, '\p{^Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73031, '\P{Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(0, 73031, '\P{^Is_Indic_Syllabic_Category=consonantprecedingrepha}', "");
    Expect(1, 73030, '\p{Is_Indic_Syllabic_Category= Consonant_Preceding_REPHA}', "");
    Expect(0, 73030, '\p{^Is_Indic_Syllabic_Category= Consonant_Preceding_REPHA}', "");
    Expect(0, 73030, '\P{Is_Indic_Syllabic_Category= Consonant_Preceding_REPHA}', "");
    Expect(1, 73030, '\P{^Is_Indic_Syllabic_Category= Consonant_Preceding_REPHA}', "");
    Expect(0, 73031, '\p{Is_Indic_Syllabic_Category= Consonant_Preceding_REPHA}', "");
    Expect(1, 73031, '\p{^Is_Indic_Syllabic_Category= Consonant_Preceding_REPHA}', "");
    Expect(1, 73031, '\P{Is_Indic_Syllabic_Category= Consonant_Preceding_REPHA}', "");
    Expect(0, 73031, '\P{^Is_Indic_Syllabic_Category= Consonant_Preceding_REPHA}', "");
    Error('\p{Is_InSC:    :=Consonant_Preceding_repha}');
    Error('\P{Is_InSC:    :=Consonant_Preceding_repha}');
    Expect(1, 73030, '\p{Is_InSC=consonantprecedingrepha}', "");
    Expect(0, 73030, '\p{^Is_InSC=consonantprecedingrepha}', "");
    Expect(0, 73030, '\P{Is_InSC=consonantprecedingrepha}', "");
    Expect(1, 73030, '\P{^Is_InSC=consonantprecedingrepha}', "");
    Expect(0, 73031, '\p{Is_InSC=consonantprecedingrepha}', "");
    Expect(1, 73031, '\p{^Is_InSC=consonantprecedingrepha}', "");
    Expect(1, 73031, '\P{Is_InSC=consonantprecedingrepha}', "");
    Expect(0, 73031, '\P{^Is_InSC=consonantprecedingrepha}', "");
    Expect(1, 73030, '\p{Is_InSC=	-consonant_Preceding_Repha}', "");
    Expect(0, 73030, '\p{^Is_InSC=	-consonant_Preceding_Repha}', "");
    Expect(0, 73030, '\P{Is_InSC=	-consonant_Preceding_Repha}', "");
    Expect(1, 73030, '\P{^Is_InSC=	-consonant_Preceding_Repha}', "");
    Expect(0, 73031, '\p{Is_InSC=	-consonant_Preceding_Repha}', "");
    Expect(1, 73031, '\p{^Is_InSC=	-consonant_Preceding_Repha}', "");
    Expect(1, 73031, '\P{Is_InSC=	-consonant_Preceding_Repha}', "");
    Expect(0, 73031, '\P{^Is_InSC=	-consonant_Preceding_Repha}', "");
    Error('\p{Indic_Syllabic_Category=:=	 consonant_PREFIXED}');
    Error('\P{Indic_Syllabic_Category=:=	 consonant_PREFIXED}');
    Expect(1, 72329, '\p{Indic_Syllabic_Category=:\AConsonant_Prefixed\z:}', "");;
    Expect(0, 72330, '\p{Indic_Syllabic_Category=:\AConsonant_Prefixed\z:}', "");;
    Expect(1, 72329, '\p{Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72329, '\p{^Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72329, '\P{Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72329, '\P{^Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72330, '\p{Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72330, '\p{^Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72330, '\P{Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72330, '\P{^Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72329, '\p{Indic_Syllabic_Category=:\Aconsonantprefixed\z:}', "");;
    Expect(0, 72330, '\p{Indic_Syllabic_Category=:\Aconsonantprefixed\z:}', "");;
    Expect(1, 72329, '\p{Indic_Syllabic_Category:  	Consonant_Prefixed}', "");
    Expect(0, 72329, '\p{^Indic_Syllabic_Category:  	Consonant_Prefixed}', "");
    Expect(0, 72329, '\P{Indic_Syllabic_Category:  	Consonant_Prefixed}', "");
    Expect(1, 72329, '\P{^Indic_Syllabic_Category:  	Consonant_Prefixed}', "");
    Expect(0, 72330, '\p{Indic_Syllabic_Category:  	Consonant_Prefixed}', "");
    Expect(1, 72330, '\p{^Indic_Syllabic_Category:  	Consonant_Prefixed}', "");
    Expect(1, 72330, '\P{Indic_Syllabic_Category:  	Consonant_Prefixed}', "");
    Expect(0, 72330, '\P{^Indic_Syllabic_Category:  	Consonant_Prefixed}', "");
    Error('\p{InSC=_Consonant_Prefixed:=}');
    Error('\P{InSC=_Consonant_Prefixed:=}');
    Expect(1, 72329, '\p{InSC=:\AConsonant_Prefixed\z:}', "");;
    Expect(0, 72330, '\p{InSC=:\AConsonant_Prefixed\z:}', "");;
    Expect(1, 72329, '\p{InSC=consonantprefixed}', "");
    Expect(0, 72329, '\p{^InSC=consonantprefixed}', "");
    Expect(0, 72329, '\P{InSC=consonantprefixed}', "");
    Expect(1, 72329, '\P{^InSC=consonantprefixed}', "");
    Expect(0, 72330, '\p{InSC=consonantprefixed}', "");
    Expect(1, 72330, '\p{^InSC=consonantprefixed}', "");
    Expect(1, 72330, '\P{InSC=consonantprefixed}', "");
    Expect(0, 72330, '\P{^InSC=consonantprefixed}', "");
    Expect(1, 72329, '\p{InSC=:\Aconsonantprefixed\z:}', "");;
    Expect(0, 72330, '\p{InSC=:\Aconsonantprefixed\z:}', "");;
    Expect(1, 72329, '\p{InSC=_CONSONANT_prefixed}', "");
    Expect(0, 72329, '\p{^InSC=_CONSONANT_prefixed}', "");
    Expect(0, 72329, '\P{InSC=_CONSONANT_prefixed}', "");
    Expect(1, 72329, '\P{^InSC=_CONSONANT_prefixed}', "");
    Expect(0, 72330, '\p{InSC=_CONSONANT_prefixed}', "");
    Expect(1, 72330, '\p{^InSC=_CONSONANT_prefixed}', "");
    Expect(1, 72330, '\P{InSC=_CONSONANT_prefixed}', "");
    Expect(0, 72330, '\P{^InSC=_CONSONANT_prefixed}', "");
    Error('\p{Is_Indic_Syllabic_Category=/a/	CONSONANT_Prefixed}');
    Error('\P{Is_Indic_Syllabic_Category=/a/	CONSONANT_Prefixed}');
    Expect(1, 72329, '\p{Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72329, '\p{^Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72329, '\P{Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72329, '\P{^Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72330, '\p{Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72330, '\p{^Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72330, '\P{Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(0, 72330, '\P{^Is_Indic_Syllabic_Category=consonantprefixed}', "");
    Expect(1, 72329, '\p{Is_Indic_Syllabic_Category= Consonant_Prefixed}', "");
    Expect(0, 72329, '\p{^Is_Indic_Syllabic_Category= Consonant_Prefixed}', "");
    Expect(0, 72329, '\P{Is_Indic_Syllabic_Category= Consonant_Prefixed}', "");
    Expect(1, 72329, '\P{^Is_Indic_Syllabic_Category= Consonant_Prefixed}', "");
    Expect(0, 72330, '\p{Is_Indic_Syllabic_Category= Consonant_Prefixed}', "");
    Expect(1, 72330, '\p{^Is_Indic_Syllabic_Category= Consonant_Prefixed}', "");
    Expect(1, 72330, '\P{Is_Indic_Syllabic_Category= Consonant_Prefixed}', "");
    Expect(0, 72330, '\P{^Is_Indic_Syllabic_Category= Consonant_Prefixed}', "");
    Error('\p{Is_InSC=	/a/Consonant_Prefixed}');
    Error('\P{Is_InSC=	/a/Consonant_Prefixed}');
    Expect(1, 72329, '\p{Is_InSC=consonantprefixed}', "");
    Expect(0, 72329, '\p{^Is_InSC=consonantprefixed}', "");
    Expect(0, 72329, '\P{Is_InSC=consonantprefixed}', "");
    Expect(1, 72329, '\P{^Is_InSC=consonantprefixed}', "");
    Expect(0, 72330, '\p{Is_InSC=consonantprefixed}', "");
    Expect(1, 72330, '\p{^Is_InSC=consonantprefixed}', "");
    Expect(1, 72330, '\P{Is_InSC=consonantprefixed}', "");
    Expect(0, 72330, '\P{^Is_InSC=consonantprefixed}', "");
    Expect(1, 72329, '\p{Is_InSC= Consonant_prefixed}', "");
    Expect(0, 72329, '\p{^Is_InSC= Consonant_prefixed}', "");
    Expect(0, 72329, '\P{Is_InSC= Consonant_prefixed}', "");
    Expect(1, 72329, '\P{^Is_InSC= Consonant_prefixed}', "");
    Expect(0, 72330, '\p{Is_InSC= Consonant_prefixed}', "");
    Expect(1, 72330, '\p{^Is_InSC= Consonant_prefixed}', "");
    Expect(1, 72330, '\P{Is_InSC= Consonant_prefixed}', "");
    Expect(0, 72330, '\P{^Is_InSC= Consonant_prefixed}', "");
    Error('\p{Indic_Syllabic_Category=__Consonant_Subjoined/a/}');
    Error('\P{Indic_Syllabic_Category=__Consonant_Subjoined/a/}');
    Expect(1, 72879, '\p{Indic_Syllabic_Category=:\AConsonant_Subjoined\z:}', "");;
    Expect(0, 72880, '\p{Indic_Syllabic_Category=:\AConsonant_Subjoined\z:}', "");;
    Expect(1, 72879, '\p{Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72879, '\p{^Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72879, '\P{Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72879, '\P{^Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72880, '\p{Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72880, '\p{^Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72880, '\P{Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72880, '\P{^Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72879, '\p{Indic_Syllabic_Category=:\Aconsonantsubjoined\z:}', "");;
    Expect(0, 72880, '\p{Indic_Syllabic_Category=:\Aconsonantsubjoined\z:}', "");;
    Expect(1, 72879, '\p{Indic_Syllabic_Category=Consonant_subjoined}', "");
    Expect(0, 72879, '\p{^Indic_Syllabic_Category=Consonant_subjoined}', "");
    Expect(0, 72879, '\P{Indic_Syllabic_Category=Consonant_subjoined}', "");
    Expect(1, 72879, '\P{^Indic_Syllabic_Category=Consonant_subjoined}', "");
    Expect(0, 72880, '\p{Indic_Syllabic_Category=Consonant_subjoined}', "");
    Expect(1, 72880, '\p{^Indic_Syllabic_Category=Consonant_subjoined}', "");
    Expect(1, 72880, '\P{Indic_Syllabic_Category=Consonant_subjoined}', "");
    Expect(0, 72880, '\P{^Indic_Syllabic_Category=Consonant_subjoined}', "");
    Error('\p{InSC:   	Consonant_SUBJOINED/a/}');
    Error('\P{InSC:   	Consonant_SUBJOINED/a/}');
    Expect(1, 72879, '\p{InSC=:\AConsonant_Subjoined\z:}', "");;
    Expect(0, 72880, '\p{InSC=:\AConsonant_Subjoined\z:}', "");;
    Expect(1, 72879, '\p{InSC=consonantsubjoined}', "");
    Expect(0, 72879, '\p{^InSC=consonantsubjoined}', "");
    Expect(0, 72879, '\P{InSC=consonantsubjoined}', "");
    Expect(1, 72879, '\P{^InSC=consonantsubjoined}', "");
    Expect(0, 72880, '\p{InSC=consonantsubjoined}', "");
    Expect(1, 72880, '\p{^InSC=consonantsubjoined}', "");
    Expect(1, 72880, '\P{InSC=consonantsubjoined}', "");
    Expect(0, 72880, '\P{^InSC=consonantsubjoined}', "");
    Expect(1, 72879, '\p{InSC=:\Aconsonantsubjoined\z:}', "");;
    Expect(0, 72880, '\p{InSC=:\Aconsonantsubjoined\z:}', "");;
    Expect(1, 72879, '\p{InSC= Consonant_SUBJOINED}', "");
    Expect(0, 72879, '\p{^InSC= Consonant_SUBJOINED}', "");
    Expect(0, 72879, '\P{InSC= Consonant_SUBJOINED}', "");
    Expect(1, 72879, '\P{^InSC= Consonant_SUBJOINED}', "");
    Expect(0, 72880, '\p{InSC= Consonant_SUBJOINED}', "");
    Expect(1, 72880, '\p{^InSC= Consonant_SUBJOINED}', "");
    Expect(1, 72880, '\P{InSC= Consonant_SUBJOINED}', "");
    Expect(0, 72880, '\P{^InSC= Consonant_SUBJOINED}', "");
    Error('\p{Is_Indic_Syllabic_Category:   /a/ 	Consonant_Subjoined}');
    Error('\P{Is_Indic_Syllabic_Category:   /a/ 	Consonant_Subjoined}');
    Expect(1, 72879, '\p{Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72879, '\p{^Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72879, '\P{Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72879, '\P{^Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72880, '\p{Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72880, '\p{^Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72880, '\P{Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(0, 72880, '\P{^Is_Indic_Syllabic_Category=consonantsubjoined}', "");
    Expect(1, 72879, '\p{Is_Indic_Syllabic_Category:     Consonant_Subjoined}', "");
    Expect(0, 72879, '\p{^Is_Indic_Syllabic_Category:     Consonant_Subjoined}', "");
    Expect(0, 72879, '\P{Is_Indic_Syllabic_Category:     Consonant_Subjoined}', "");
    Expect(1, 72879, '\P{^Is_Indic_Syllabic_Category:     Consonant_Subjoined}', "");
    Expect(0, 72880, '\p{Is_Indic_Syllabic_Category:     Consonant_Subjoined}', "");
    Expect(1, 72880, '\p{^Is_Indic_Syllabic_Category:     Consonant_Subjoined}', "");
    Expect(1, 72880, '\P{Is_Indic_Syllabic_Category:     Consonant_Subjoined}', "");
    Expect(0, 72880, '\P{^Is_Indic_Syllabic_Category:     Consonant_Subjoined}', "");
    Error('\p{Is_InSC=_:=Consonant_Subjoined}');
    Error('\P{Is_InSC=_:=Consonant_Subjoined}');
    Expect(1, 72879, '\p{Is_InSC:	consonantsubjoined}', "");
    Expect(0, 72879, '\p{^Is_InSC:	consonantsubjoined}', "");
    Expect(0, 72879, '\P{Is_InSC:	consonantsubjoined}', "");
    Expect(1, 72879, '\P{^Is_InSC:	consonantsubjoined}', "");
    Expect(0, 72880, '\p{Is_InSC:	consonantsubjoined}', "");
    Expect(1, 72880, '\p{^Is_InSC:	consonantsubjoined}', "");
    Expect(1, 72880, '\P{Is_InSC:	consonantsubjoined}', "");
    Expect(0, 72880, '\P{^Is_InSC:	consonantsubjoined}', "");
    Expect(1, 72879, '\p{Is_InSC= -CONSONANT_Subjoined}', "");
    Expect(0, 72879, '\p{^Is_InSC= -CONSONANT_Subjoined}', "");
    Expect(0, 72879, '\P{Is_InSC= -CONSONANT_Subjoined}', "");
    Expect(1, 72879, '\P{^Is_InSC= -CONSONANT_Subjoined}', "");
    Expect(0, 72880, '\p{Is_InSC= -CONSONANT_Subjoined}', "");
    Expect(1, 72880, '\p{^Is_InSC= -CONSONANT_Subjoined}', "");
    Expect(1, 72880, '\P{Is_InSC= -CONSONANT_Subjoined}', "");
    Expect(0, 72880, '\P{^Is_InSC= -CONSONANT_Subjoined}', "");
    Error('\p{Indic_Syllabic_Category=	/a/CONSONANT_SUCCEEDING_repha}');
    Error('\P{Indic_Syllabic_Category=	/a/CONSONANT_SUCCEEDING_repha}');
    Expect(1, 43394, '\p{Indic_Syllabic_Category=:\AConsonant_Succeeding_Repha\z:}', "");;
    Expect(0, 43395, '\p{Indic_Syllabic_Category=:\AConsonant_Succeeding_Repha\z:}', "");;
    Expect(1, 43394, '\p{Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 43394, '\p{^Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 43394, '\P{Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 43394, '\P{^Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 43395, '\p{Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 43395, '\p{^Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 43395, '\P{Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 43395, '\P{^Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 43394, '\p{Indic_Syllabic_Category=:\Aconsonantsucceedingrepha\z:}', "");;
    Expect(0, 43395, '\p{Indic_Syllabic_Category=:\Aconsonantsucceedingrepha\z:}', "");;
    Expect(1, 43394, '\p{Indic_Syllabic_Category=-_consonant_Succeeding_Repha}', "");
    Expect(0, 43394, '\p{^Indic_Syllabic_Category=-_consonant_Succeeding_Repha}', "");
    Expect(0, 43394, '\P{Indic_Syllabic_Category=-_consonant_Succeeding_Repha}', "");
    Expect(1, 43394, '\P{^Indic_Syllabic_Category=-_consonant_Succeeding_Repha}', "");
    Expect(0, 43395, '\p{Indic_Syllabic_Category=-_consonant_Succeeding_Repha}', "");
    Expect(1, 43395, '\p{^Indic_Syllabic_Category=-_consonant_Succeeding_Repha}', "");
    Expect(1, 43395, '\P{Indic_Syllabic_Category=-_consonant_Succeeding_Repha}', "");
    Expect(0, 43395, '\P{^Indic_Syllabic_Category=-_consonant_Succeeding_Repha}', "");
    Error('\p{InSC= /a/CONSONANT_Succeeding_Repha}');
    Error('\P{InSC= /a/CONSONANT_Succeeding_Repha}');
    Expect(1, 43394, '\p{InSC=:\AConsonant_Succeeding_Repha\z:}', "");;
    Expect(0, 43395, '\p{InSC=:\AConsonant_Succeeding_Repha\z:}', "");;
    Expect(1, 43394, '\p{InSC:	consonantsucceedingrepha}', "");
    Expect(0, 43394, '\p{^InSC:	consonantsucceedingrepha}', "");
    Expect(0, 43394, '\P{InSC:	consonantsucceedingrepha}', "");
    Expect(1, 43394, '\P{^InSC:	consonantsucceedingrepha}', "");
    Expect(0, 43395, '\p{InSC:	consonantsucceedingrepha}', "");
    Expect(1, 43395, '\p{^InSC:	consonantsucceedingrepha}', "");
    Expect(1, 43395, '\P{InSC:	consonantsucceedingrepha}', "");
    Expect(0, 43395, '\P{^InSC:	consonantsucceedingrepha}', "");
    Expect(1, 43394, '\p{InSC=:\Aconsonantsucceedingrepha\z:}', "");;
    Expect(0, 43395, '\p{InSC=:\Aconsonantsucceedingrepha\z:}', "");;
    Expect(1, 43394, '\p{InSC=	-Consonant_Succeeding_repha}', "");
    Expect(0, 43394, '\p{^InSC=	-Consonant_Succeeding_repha}', "");
    Expect(0, 43394, '\P{InSC=	-Consonant_Succeeding_repha}', "");
    Expect(1, 43394, '\P{^InSC=	-Consonant_Succeeding_repha}', "");
    Expect(0, 43395, '\p{InSC=	-Consonant_Succeeding_repha}', "");
    Expect(1, 43395, '\p{^InSC=	-Consonant_Succeeding_repha}', "");
    Expect(1, 43395, '\P{InSC=	-Consonant_Succeeding_repha}', "");
    Expect(0, 43395, '\P{^InSC=	-Consonant_Succeeding_repha}', "");
    Error('\p{Is_Indic_Syllabic_Category=-_Consonant_Succeeding_Repha:=}');
    Error('\P{Is_Indic_Syllabic_Category=-_Consonant_Succeeding_Repha:=}');
    Expect(1, 43394, '\p{Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 43394, '\p{^Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 43394, '\P{Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 43394, '\P{^Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 43395, '\p{Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 43395, '\p{^Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 43395, '\P{Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(0, 43395, '\P{^Is_Indic_Syllabic_Category=consonantsucceedingrepha}', "");
    Expect(1, 43394, '\p{Is_Indic_Syllabic_Category=_CONSONANT_succeeding_Repha}', "");
    Expect(0, 43394, '\p{^Is_Indic_Syllabic_Category=_CONSONANT_succeeding_Repha}', "");
    Expect(0, 43394, '\P{Is_Indic_Syllabic_Category=_CONSONANT_succeeding_Repha}', "");
    Expect(1, 43394, '\P{^Is_Indic_Syllabic_Category=_CONSONANT_succeeding_Repha}', "");
    Expect(0, 43395, '\p{Is_Indic_Syllabic_Category=_CONSONANT_succeeding_Repha}', "");
    Expect(1, 43395, '\p{^Is_Indic_Syllabic_Category=_CONSONANT_succeeding_Repha}', "");
    Expect(1, 43395, '\P{Is_Indic_Syllabic_Category=_CONSONANT_succeeding_Repha}', "");
    Expect(0, 43395, '\P{^Is_Indic_Syllabic_Category=_CONSONANT_succeeding_Repha}', "");
    Error('\p{Is_InSC=:=Consonant_Succeeding_repha}');
    Error('\P{Is_InSC=:=Consonant_Succeeding_repha}');
    Expect(1, 43394, '\p{Is_InSC=consonantsucceedingrepha}', "");
    Expect(0, 43394, '\p{^Is_InSC=consonantsucceedingrepha}', "");
    Expect(0, 43394, '\P{Is_InSC=consonantsucceedingrepha}', "");
    Expect(1, 43394, '\P{^Is_InSC=consonantsucceedingrepha}', "");
    Expect(0, 43395, '\p{Is_InSC=consonantsucceedingrepha}', "");
    Expect(1, 43395, '\p{^Is_InSC=consonantsucceedingrepha}', "");
    Expect(1, 43395, '\P{Is_InSC=consonantsucceedingrepha}', "");
    Expect(0, 43395, '\P{^Is_InSC=consonantsucceedingrepha}', "");
    Expect(1, 43394, '\p{Is_InSC=-	consonant_SUCCEEDING_REPHA}', "");
    Expect(0, 43394, '\p{^Is_InSC=-	consonant_SUCCEEDING_REPHA}', "");
    Expect(0, 43394, '\P{Is_InSC=-	consonant_SUCCEEDING_REPHA}', "");
    Expect(1, 43394, '\P{^Is_InSC=-	consonant_SUCCEEDING_REPHA}', "");
    Expect(0, 43395, '\p{Is_InSC=-	consonant_SUCCEEDING_REPHA}', "");
    Expect(1, 43395, '\p{^Is_InSC=-	consonant_SUCCEEDING_REPHA}', "");
    Expect(1, 43395, '\P{Is_InSC=-	consonant_SUCCEEDING_REPHA}', "");
    Expect(0, 43395, '\P{^Is_InSC=-	consonant_SUCCEEDING_REPHA}', "");
    Error('\p{Indic_Syllabic_Category:   /a/_	Consonant_With_STACKER}');
    Error('\P{Indic_Syllabic_Category:   /a/_	Consonant_With_STACKER}');
    Expect(1, 69636, '\p{Indic_Syllabic_Category=:\AConsonant_With_Stacker\z:}', "");;
    Expect(0, 69637, '\p{Indic_Syllabic_Category=:\AConsonant_With_Stacker\z:}', "");;
    Expect(1, 69636, '\p{Indic_Syllabic_Category:   consonantwithstacker}', "");
    Expect(0, 69636, '\p{^Indic_Syllabic_Category:   consonantwithstacker}', "");
    Expect(0, 69636, '\P{Indic_Syllabic_Category:   consonantwithstacker}', "");
    Expect(1, 69636, '\P{^Indic_Syllabic_Category:   consonantwithstacker}', "");
    Expect(0, 69637, '\p{Indic_Syllabic_Category:   consonantwithstacker}', "");
    Expect(1, 69637, '\p{^Indic_Syllabic_Category:   consonantwithstacker}', "");
    Expect(1, 69637, '\P{Indic_Syllabic_Category:   consonantwithstacker}', "");
    Expect(0, 69637, '\P{^Indic_Syllabic_Category:   consonantwithstacker}', "");
    Expect(1, 69636, '\p{Indic_Syllabic_Category=:\Aconsonantwithstacker\z:}', "");;
    Expect(0, 69637, '\p{Indic_Syllabic_Category=:\Aconsonantwithstacker\z:}', "");;
    Expect(1, 69636, '\p{Indic_Syllabic_Category=	-Consonant_With_STACKER}', "");
    Expect(0, 69636, '\p{^Indic_Syllabic_Category=	-Consonant_With_STACKER}', "");
    Expect(0, 69636, '\P{Indic_Syllabic_Category=	-Consonant_With_STACKER}', "");
    Expect(1, 69636, '\P{^Indic_Syllabic_Category=	-Consonant_With_STACKER}', "");
    Expect(0, 69637, '\p{Indic_Syllabic_Category=	-Consonant_With_STACKER}', "");
    Expect(1, 69637, '\p{^Indic_Syllabic_Category=	-Consonant_With_STACKER}', "");
    Expect(1, 69637, '\P{Indic_Syllabic_Category=	-Consonant_With_STACKER}', "");
    Expect(0, 69637, '\P{^Indic_Syllabic_Category=	-Consonant_With_STACKER}', "");
    Error('\p{InSC=	 consonant_WITH_Stacker/a/}');
    Error('\P{InSC=	 consonant_WITH_Stacker/a/}');
    Expect(1, 69636, '\p{InSC=:\AConsonant_With_Stacker\z:}', "");;
    Expect(0, 69637, '\p{InSC=:\AConsonant_With_Stacker\z:}', "");;
    Expect(1, 69636, '\p{InSC=consonantwithstacker}', "");
    Expect(0, 69636, '\p{^InSC=consonantwithstacker}', "");
    Expect(0, 69636, '\P{InSC=consonantwithstacker}', "");
    Expect(1, 69636, '\P{^InSC=consonantwithstacker}', "");
    Expect(0, 69637, '\p{InSC=consonantwithstacker}', "");
    Expect(1, 69637, '\p{^InSC=consonantwithstacker}', "");
    Expect(1, 69637, '\P{InSC=consonantwithstacker}', "");
    Expect(0, 69637, '\P{^InSC=consonantwithstacker}', "");
    Expect(1, 69636, '\p{InSC=:\Aconsonantwithstacker\z:}', "");;
    Expect(0, 69637, '\p{InSC=:\Aconsonantwithstacker\z:}', "");;
    Expect(1, 69636, '\p{InSC= _consonant_With_STACKER}', "");
    Expect(0, 69636, '\p{^InSC= _consonant_With_STACKER}', "");
    Expect(0, 69636, '\P{InSC= _consonant_With_STACKER}', "");
    Expect(1, 69636, '\P{^InSC= _consonant_With_STACKER}', "");
    Expect(0, 69637, '\p{InSC= _consonant_With_STACKER}', "");
    Expect(1, 69637, '\p{^InSC= _consonant_With_STACKER}', "");
    Expect(1, 69637, '\P{InSC= _consonant_With_STACKER}', "");
    Expect(0, 69637, '\P{^InSC= _consonant_With_STACKER}', "");
    Error('\p{Is_Indic_Syllabic_Category=	CONSONANT_With_STACKER/a/}');
    Error('\P{Is_Indic_Syllabic_Category=	CONSONANT_With_STACKER/a/}');
    Expect(1, 69636, '\p{Is_Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(0, 69636, '\p{^Is_Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(0, 69636, '\P{Is_Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(1, 69636, '\P{^Is_Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(0, 69637, '\p{Is_Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(1, 69637, '\p{^Is_Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(1, 69637, '\P{Is_Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(0, 69637, '\P{^Is_Indic_Syllabic_Category=consonantwithstacker}', "");
    Expect(1, 69636, '\p{Is_Indic_Syllabic_Category=-_CONSONANT_With_stacker}', "");
    Expect(0, 69636, '\p{^Is_Indic_Syllabic_Category=-_CONSONANT_With_stacker}', "");
    Expect(0, 69636, '\P{Is_Indic_Syllabic_Category=-_CONSONANT_With_stacker}', "");
    Expect(1, 69636, '\P{^Is_Indic_Syllabic_Category=-_CONSONANT_With_stacker}', "");
    Expect(0, 69637, '\p{Is_Indic_Syllabic_Category=-_CONSONANT_With_stacker}', "");
    Expect(1, 69637, '\p{^Is_Indic_Syllabic_Category=-_CONSONANT_With_stacker}', "");
    Expect(1, 69637, '\P{Is_Indic_Syllabic_Category=-_CONSONANT_With_stacker}', "");
    Expect(0, 69637, '\P{^Is_Indic_Syllabic_Category=-_CONSONANT_With_stacker}', "");
    Error('\p{Is_InSC= CONSONANT_WITH_stacker:=}');
    Error('\P{Is_InSC= CONSONANT_WITH_stacker:=}');
    Expect(1, 69636, '\p{Is_InSC=consonantwithstacker}', "");
    Expect(0, 69636, '\p{^Is_InSC=consonantwithstacker}', "");
    Expect(0, 69636, '\P{Is_InSC=consonantwithstacker}', "");
    Expect(1, 69636, '\P{^Is_InSC=consonantwithstacker}', "");
    Expect(0, 69637, '\p{Is_InSC=consonantwithstacker}', "");
    Expect(1, 69637, '\p{^Is_InSC=consonantwithstacker}', "");
    Expect(1, 69637, '\P{Is_InSC=consonantwithstacker}', "");
    Expect(0, 69637, '\P{^Is_InSC=consonantwithstacker}', "");
    Expect(1, 69636, '\p{Is_InSC=-	consonant_With_stacker}', "");
    Expect(0, 69636, '\p{^Is_InSC=-	consonant_With_stacker}', "");
    Expect(0, 69636, '\P{Is_InSC=-	consonant_With_stacker}', "");
    Expect(1, 69636, '\P{^Is_InSC=-	consonant_With_stacker}', "");
    Expect(0, 69637, '\p{Is_InSC=-	consonant_With_stacker}', "");
    Expect(1, 69637, '\p{^Is_InSC=-	consonant_With_stacker}', "");
    Expect(1, 69637, '\P{Is_InSC=-	consonant_With_stacker}', "");
    Expect(0, 69637, '\P{^Is_InSC=-	consonant_With_stacker}', "");
    Error('\p{Indic_Syllabic_Category:	 /a/Gemination_Mark}');
    Error('\P{Indic_Syllabic_Category:	 /a/Gemination_Mark}');
    Expect(1, 72344, '\p{Indic_Syllabic_Category=:\AGemination_Mark\z:}', "");;
    Expect(0, 72345, '\p{Indic_Syllabic_Category=:\AGemination_Mark\z:}', "");;
    Expect(1, 72344, '\p{Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72344, '\p{^Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72344, '\P{Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72344, '\P{^Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72345, '\p{Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72345, '\p{^Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72345, '\P{Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72345, '\P{^Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72344, '\p{Indic_Syllabic_Category=:\Ageminationmark\z:}', "");;
    Expect(0, 72345, '\p{Indic_Syllabic_Category=:\Ageminationmark\z:}', "");;
    Expect(1, 72344, '\p{Indic_Syllabic_Category= gemination_mark}', "");
    Expect(0, 72344, '\p{^Indic_Syllabic_Category= gemination_mark}', "");
    Expect(0, 72344, '\P{Indic_Syllabic_Category= gemination_mark}', "");
    Expect(1, 72344, '\P{^Indic_Syllabic_Category= gemination_mark}', "");
    Expect(0, 72345, '\p{Indic_Syllabic_Category= gemination_mark}', "");
    Expect(1, 72345, '\p{^Indic_Syllabic_Category= gemination_mark}', "");
    Expect(1, 72345, '\P{Indic_Syllabic_Category= gemination_mark}', "");
    Expect(0, 72345, '\P{^Indic_Syllabic_Category= gemination_mark}', "");
    Error('\p{InSC: :=GEMINATION_Mark}');
    Error('\P{InSC: :=GEMINATION_Mark}');
    Expect(1, 72344, '\p{InSC=:\AGemination_Mark\z:}', "");;
    Expect(0, 72345, '\p{InSC=:\AGemination_Mark\z:}', "");;
    Expect(1, 72344, '\p{InSC=geminationmark}', "");
    Expect(0, 72344, '\p{^InSC=geminationmark}', "");
    Expect(0, 72344, '\P{InSC=geminationmark}', "");
    Expect(1, 72344, '\P{^InSC=geminationmark}', "");
    Expect(0, 72345, '\p{InSC=geminationmark}', "");
    Expect(1, 72345, '\p{^InSC=geminationmark}', "");
    Expect(1, 72345, '\P{InSC=geminationmark}', "");
    Expect(0, 72345, '\P{^InSC=geminationmark}', "");
    Expect(1, 72344, '\p{InSC=:\Ageminationmark\z:}', "");;
    Expect(0, 72345, '\p{InSC=:\Ageminationmark\z:}', "");;
    Expect(1, 72344, '\p{InSC=-	GEMINATION_Mark}', "");
    Expect(0, 72344, '\p{^InSC=-	GEMINATION_Mark}', "");
    Expect(0, 72344, '\P{InSC=-	GEMINATION_Mark}', "");
    Expect(1, 72344, '\P{^InSC=-	GEMINATION_Mark}', "");
    Expect(0, 72345, '\p{InSC=-	GEMINATION_Mark}', "");
    Expect(1, 72345, '\p{^InSC=-	GEMINATION_Mark}', "");
    Expect(1, 72345, '\P{InSC=-	GEMINATION_Mark}', "");
    Expect(0, 72345, '\P{^InSC=-	GEMINATION_Mark}', "");
    Error('\p{Is_Indic_Syllabic_Category=/a/	-GEMINATION_Mark}');
    Error('\P{Is_Indic_Syllabic_Category=/a/	-GEMINATION_Mark}');
    Expect(1, 72344, '\p{Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72344, '\p{^Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72344, '\P{Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72344, '\P{^Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72345, '\p{Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72345, '\p{^Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72345, '\P{Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(0, 72345, '\P{^Is_Indic_Syllabic_Category=geminationmark}', "");
    Expect(1, 72344, '\p{Is_Indic_Syllabic_Category= -gemination_MARK}', "");
    Expect(0, 72344, '\p{^Is_Indic_Syllabic_Category= -gemination_MARK}', "");
    Expect(0, 72344, '\P{Is_Indic_Syllabic_Category= -gemination_MARK}', "");
    Expect(1, 72344, '\P{^Is_Indic_Syllabic_Category= -gemination_MARK}', "");
    Expect(0, 72345, '\p{Is_Indic_Syllabic_Category= -gemination_MARK}', "");
    Expect(1, 72345, '\p{^Is_Indic_Syllabic_Category= -gemination_MARK}', "");
    Expect(1, 72345, '\P{Is_Indic_Syllabic_Category= -gemination_MARK}', "");
    Expect(0, 72345, '\P{^Is_Indic_Syllabic_Category= -gemination_MARK}', "");
    Error('\p{Is_InSC=-:=Gemination_Mark}');
    Error('\P{Is_InSC=-:=Gemination_Mark}');
    Expect(1, 72344, '\p{Is_InSC=geminationmark}', "");
    Expect(0, 72344, '\p{^Is_InSC=geminationmark}', "");
    Expect(0, 72344, '\P{Is_InSC=geminationmark}', "");
    Expect(1, 72344, '\P{^Is_InSC=geminationmark}', "");
    Expect(0, 72345, '\p{Is_InSC=geminationmark}', "");
    Expect(1, 72345, '\p{^Is_InSC=geminationmark}', "");
    Expect(1, 72345, '\P{Is_InSC=geminationmark}', "");
    Expect(0, 72345, '\P{^Is_InSC=geminationmark}', "");
    Expect(1, 72344, '\p{Is_InSC:	_-gemination_mark}', "");
    Expect(0, 72344, '\p{^Is_InSC:	_-gemination_mark}', "");
    Expect(0, 72344, '\P{Is_InSC:	_-gemination_mark}', "");
    Expect(1, 72344, '\P{^Is_InSC:	_-gemination_mark}', "");
    Expect(0, 72345, '\p{Is_InSC:	_-gemination_mark}', "");
    Expect(1, 72345, '\p{^Is_InSC:	_-gemination_mark}', "");
    Expect(1, 72345, '\P{Is_InSC:	_-gemination_mark}', "");
    Expect(0, 72345, '\P{^Is_InSC:	_-gemination_mark}', "");
    Error('\p{Indic_Syllabic_Category=/a/_INVISIBLE_STACKER}');
    Error('\P{Indic_Syllabic_Category=/a/_INVISIBLE_STACKER}');
    Expect(1, 73111, '\p{Indic_Syllabic_Category=:\AInvisible_Stacker\z:}', "");;
    Expect(0, 73112, '\p{Indic_Syllabic_Category=:\AInvisible_Stacker\z:}', "");;
    Expect(1, 73111, '\p{Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73111, '\p{^Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73111, '\P{Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73111, '\P{^Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73112, '\p{Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73112, '\p{^Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73112, '\P{Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73112, '\P{^Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73111, '\p{Indic_Syllabic_Category=:\Ainvisiblestacker\z:}', "");;
    Expect(0, 73112, '\p{Indic_Syllabic_Category=:\Ainvisiblestacker\z:}', "");;
    Expect(1, 73111, '\p{Indic_Syllabic_Category:-Invisible_Stacker}', "");
    Expect(0, 73111, '\p{^Indic_Syllabic_Category:-Invisible_Stacker}', "");
    Expect(0, 73111, '\P{Indic_Syllabic_Category:-Invisible_Stacker}', "");
    Expect(1, 73111, '\P{^Indic_Syllabic_Category:-Invisible_Stacker}', "");
    Expect(0, 73112, '\p{Indic_Syllabic_Category:-Invisible_Stacker}', "");
    Expect(1, 73112, '\p{^Indic_Syllabic_Category:-Invisible_Stacker}', "");
    Expect(1, 73112, '\P{Indic_Syllabic_Category:-Invisible_Stacker}', "");
    Expect(0, 73112, '\P{^Indic_Syllabic_Category:-Invisible_Stacker}', "");
    Error('\p{InSC=-:=Invisible_stacker}');
    Error('\P{InSC=-:=Invisible_stacker}');
    Expect(1, 73111, '\p{InSC=:\AInvisible_Stacker\z:}', "");;
    Expect(0, 73112, '\p{InSC=:\AInvisible_Stacker\z:}', "");;
    Expect(1, 73111, '\p{InSC=invisiblestacker}', "");
    Expect(0, 73111, '\p{^InSC=invisiblestacker}', "");
    Expect(0, 73111, '\P{InSC=invisiblestacker}', "");
    Expect(1, 73111, '\P{^InSC=invisiblestacker}', "");
    Expect(0, 73112, '\p{InSC=invisiblestacker}', "");
    Expect(1, 73112, '\p{^InSC=invisiblestacker}', "");
    Expect(1, 73112, '\P{InSC=invisiblestacker}', "");
    Expect(0, 73112, '\P{^InSC=invisiblestacker}', "");
    Expect(1, 73111, '\p{InSC=:\Ainvisiblestacker\z:}', "");;
    Expect(0, 73112, '\p{InSC=:\Ainvisiblestacker\z:}', "");;
    Expect(1, 73111, '\p{InSC=	 invisible_stacker}', "");
    Expect(0, 73111, '\p{^InSC=	 invisible_stacker}', "");
    Expect(0, 73111, '\P{InSC=	 invisible_stacker}', "");
    Expect(1, 73111, '\P{^InSC=	 invisible_stacker}', "");
    Expect(0, 73112, '\p{InSC=	 invisible_stacker}', "");
    Expect(1, 73112, '\p{^InSC=	 invisible_stacker}', "");
    Expect(1, 73112, '\P{InSC=	 invisible_stacker}', "");
    Expect(0, 73112, '\P{^InSC=	 invisible_stacker}', "");
    Error('\p{Is_Indic_Syllabic_Category=_:=INVISIBLE_Stacker}');
    Error('\P{Is_Indic_Syllabic_Category=_:=INVISIBLE_Stacker}');
    Expect(1, 73111, '\p{Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73111, '\p{^Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73111, '\P{Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73111, '\P{^Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73112, '\p{Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73112, '\p{^Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73112, '\P{Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(0, 73112, '\P{^Is_Indic_Syllabic_Category=invisiblestacker}', "");
    Expect(1, 73111, '\p{Is_Indic_Syllabic_Category= 	invisible_Stacker}', "");
    Expect(0, 73111, '\p{^Is_Indic_Syllabic_Category= 	invisible_Stacker}', "");
    Expect(0, 73111, '\P{Is_Indic_Syllabic_Category= 	invisible_Stacker}', "");
    Expect(1, 73111, '\P{^Is_Indic_Syllabic_Category= 	invisible_Stacker}', "");
    Expect(0, 73112, '\p{Is_Indic_Syllabic_Category= 	invisible_Stacker}', "");
    Expect(1, 73112, '\p{^Is_Indic_Syllabic_Category= 	invisible_Stacker}', "");
    Expect(1, 73112, '\P{Is_Indic_Syllabic_Category= 	invisible_Stacker}', "");
    Expect(0, 73112, '\P{^Is_Indic_Syllabic_Category= 	invisible_Stacker}', "");
    Error('\p{Is_InSC=:=-_Invisible_stacker}');
    Error('\P{Is_InSC=:=-_Invisible_stacker}');
    Expect(1, 73111, '\p{Is_InSC=invisiblestacker}', "");
    Expect(0, 73111, '\p{^Is_InSC=invisiblestacker}', "");
    Expect(0, 73111, '\P{Is_InSC=invisiblestacker}', "");
    Expect(1, 73111, '\P{^Is_InSC=invisiblestacker}', "");
    Expect(0, 73112, '\p{Is_InSC=invisiblestacker}', "");
    Expect(1, 73112, '\p{^Is_InSC=invisiblestacker}', "");
    Expect(1, 73112, '\P{Is_InSC=invisiblestacker}', "");
    Expect(0, 73112, '\P{^Is_InSC=invisiblestacker}', "");
    Expect(1, 73111, '\p{Is_InSC=		Invisible_Stacker}', "");
    Expect(0, 73111, '\p{^Is_InSC=		Invisible_Stacker}', "");
    Expect(0, 73111, '\P{Is_InSC=		Invisible_Stacker}', "");
    Expect(1, 73111, '\P{^Is_InSC=		Invisible_Stacker}', "");
    Expect(0, 73112, '\p{Is_InSC=		Invisible_Stacker}', "");
    Expect(1, 73112, '\p{^Is_InSC=		Invisible_Stacker}', "");
    Expect(1, 73112, '\P{Is_InSC=		Invisible_Stacker}', "");
    Expect(0, 73112, '\P{^Is_InSC=		Invisible_Stacker}', "");
    Error('\p{Indic_Syllabic_Category=/a/-Joiner}');
    Error('\P{Indic_Syllabic_Category=/a/-Joiner}');
    Expect(1, 8205, '\p{Indic_Syllabic_Category=:\AJoiner\z:}', "");;
    Expect(0, 8206, '\p{Indic_Syllabic_Category=:\AJoiner\z:}', "");;
    Expect(1, 8205, '\p{Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8205, '\p{^Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8205, '\P{Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8205, '\P{^Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8206, '\p{Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8206, '\p{^Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8206, '\P{Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8206, '\P{^Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8205, '\p{Indic_Syllabic_Category=:\Ajoiner\z:}', "");;
    Expect(0, 8206, '\p{Indic_Syllabic_Category=:\Ajoiner\z:}', "");;
    Expect(1, 8205, '\p{Indic_Syllabic_Category= 	Joiner}', "");
    Expect(0, 8205, '\p{^Indic_Syllabic_Category= 	Joiner}', "");
    Expect(0, 8205, '\P{Indic_Syllabic_Category= 	Joiner}', "");
    Expect(1, 8205, '\P{^Indic_Syllabic_Category= 	Joiner}', "");
    Expect(0, 8206, '\p{Indic_Syllabic_Category= 	Joiner}', "");
    Expect(1, 8206, '\p{^Indic_Syllabic_Category= 	Joiner}', "");
    Expect(1, 8206, '\P{Indic_Syllabic_Category= 	Joiner}', "");
    Expect(0, 8206, '\P{^Indic_Syllabic_Category= 	Joiner}', "");
    Error('\p{InSC=:= -joiner}');
    Error('\P{InSC=:= -joiner}');
    Expect(1, 8205, '\p{InSC=:\AJoiner\z:}', "");;
    Expect(0, 8206, '\p{InSC=:\AJoiner\z:}', "");;
    Expect(1, 8205, '\p{InSC=joiner}', "");
    Expect(0, 8205, '\p{^InSC=joiner}', "");
    Expect(0, 8205, '\P{InSC=joiner}', "");
    Expect(1, 8205, '\P{^InSC=joiner}', "");
    Expect(0, 8206, '\p{InSC=joiner}', "");
    Expect(1, 8206, '\p{^InSC=joiner}', "");
    Expect(1, 8206, '\P{InSC=joiner}', "");
    Expect(0, 8206, '\P{^InSC=joiner}', "");
    Expect(1, 8205, '\p{InSC=:\Ajoiner\z:}', "");;
    Expect(0, 8206, '\p{InSC=:\Ajoiner\z:}', "");;
    Expect(1, 8205, '\p{InSC=	_Joiner}', "");
    Expect(0, 8205, '\p{^InSC=	_Joiner}', "");
    Expect(0, 8205, '\P{InSC=	_Joiner}', "");
    Expect(1, 8205, '\P{^InSC=	_Joiner}', "");
    Expect(0, 8206, '\p{InSC=	_Joiner}', "");
    Expect(1, 8206, '\p{^InSC=	_Joiner}', "");
    Expect(1, 8206, '\P{InSC=	_Joiner}', "");
    Expect(0, 8206, '\P{^InSC=	_Joiner}', "");
    Error('\p{Is_Indic_Syllabic_Category=:=- Joiner}');
    Error('\P{Is_Indic_Syllabic_Category=:=- Joiner}');
    Expect(1, 8205, '\p{Is_Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8205, '\p{^Is_Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8205, '\P{Is_Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8205, '\P{^Is_Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8206, '\p{Is_Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8206, '\p{^Is_Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8206, '\P{Is_Indic_Syllabic_Category=joiner}', "");
    Expect(0, 8206, '\P{^Is_Indic_Syllabic_Category=joiner}', "");
    Expect(1, 8205, '\p{Is_Indic_Syllabic_Category=		Joiner}', "");
    Expect(0, 8205, '\p{^Is_Indic_Syllabic_Category=		Joiner}', "");
    Expect(0, 8205, '\P{Is_Indic_Syllabic_Category=		Joiner}', "");
    Expect(1, 8205, '\P{^Is_Indic_Syllabic_Category=		Joiner}', "");
    Expect(0, 8206, '\p{Is_Indic_Syllabic_Category=		Joiner}', "");
    Expect(1, 8206, '\p{^Is_Indic_Syllabic_Category=		Joiner}', "");
    Expect(1, 8206, '\P{Is_Indic_Syllabic_Category=		Joiner}', "");
    Expect(0, 8206, '\P{^Is_Indic_Syllabic_Category=		Joiner}', "");
    Error('\p{Is_InSC=/a/ -Joiner}');
    Error('\P{Is_InSC=/a/ -Joiner}');
    Expect(1, 8205, '\p{Is_InSC=joiner}', "");
    Expect(0, 8205, '\p{^Is_InSC=joiner}', "");
    Expect(0, 8205, '\P{Is_InSC=joiner}', "");
    Expect(1, 8205, '\P{^Is_InSC=joiner}', "");
    Expect(0, 8206, '\p{Is_InSC=joiner}', "");
    Expect(1, 8206, '\p{^Is_InSC=joiner}', "");
    Expect(1, 8206, '\P{Is_InSC=joiner}', "");
    Expect(0, 8206, '\P{^Is_InSC=joiner}', "");
    Expect(1, 8205, '\p{Is_InSC=__JOINER}', "");
    Expect(0, 8205, '\p{^Is_InSC=__JOINER}', "");
    Expect(0, 8205, '\P{Is_InSC=__JOINER}', "");
    Expect(1, 8205, '\P{^Is_InSC=__JOINER}', "");
    Expect(0, 8206, '\p{Is_InSC=__JOINER}', "");
    Expect(1, 8206, '\p{^Is_InSC=__JOINER}', "");
    Expect(1, 8206, '\P{Is_InSC=__JOINER}', "");
    Expect(0, 8206, '\P{^Is_InSC=__JOINER}', "");
    Error('\p{Indic_Syllabic_Category=	_modifying_Letter:=}');
    Error('\P{Indic_Syllabic_Category=	_modifying_Letter:=}');
    Expect(1, 2947, '\p{Indic_Syllabic_Category=:\AModifying_Letter\z:}', "");;
    Expect(0, 2948, '\p{Indic_Syllabic_Category=:\AModifying_Letter\z:}', "");;
    Expect(1, 2947, '\p{Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2947, '\p{^Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2947, '\P{Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2947, '\P{^Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2948, '\p{Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2948, '\p{^Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2948, '\P{Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2948, '\P{^Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2947, '\p{Indic_Syllabic_Category=:\Amodifyingletter\z:}', "");;
    Expect(0, 2948, '\p{Indic_Syllabic_Category=:\Amodifyingletter\z:}', "");;
    Expect(1, 2947, '\p{Indic_Syllabic_Category=_MODIFYING_Letter}', "");
    Expect(0, 2947, '\p{^Indic_Syllabic_Category=_MODIFYING_Letter}', "");
    Expect(0, 2947, '\P{Indic_Syllabic_Category=_MODIFYING_Letter}', "");
    Expect(1, 2947, '\P{^Indic_Syllabic_Category=_MODIFYING_Letter}', "");
    Expect(0, 2948, '\p{Indic_Syllabic_Category=_MODIFYING_Letter}', "");
    Expect(1, 2948, '\p{^Indic_Syllabic_Category=_MODIFYING_Letter}', "");
    Expect(1, 2948, '\P{Indic_Syllabic_Category=_MODIFYING_Letter}', "");
    Expect(0, 2948, '\P{^Indic_Syllabic_Category=_MODIFYING_Letter}', "");
    Error('\p{InSC= Modifying_Letter:=}');
    Error('\P{InSC= Modifying_Letter:=}');
    Expect(1, 2947, '\p{InSC=:\AModifying_Letter\z:}', "");;
    Expect(0, 2948, '\p{InSC=:\AModifying_Letter\z:}', "");;
    Expect(1, 2947, '\p{InSC:modifyingletter}', "");
    Expect(0, 2947, '\p{^InSC:modifyingletter}', "");
    Expect(0, 2947, '\P{InSC:modifyingletter}', "");
    Expect(1, 2947, '\P{^InSC:modifyingletter}', "");
    Expect(0, 2948, '\p{InSC:modifyingletter}', "");
    Expect(1, 2948, '\p{^InSC:modifyingletter}', "");
    Expect(1, 2948, '\P{InSC:modifyingletter}', "");
    Expect(0, 2948, '\P{^InSC:modifyingletter}', "");
    Expect(1, 2947, '\p{InSC=:\Amodifyingletter\z:}', "");;
    Expect(0, 2948, '\p{InSC=:\Amodifyingletter\z:}', "");;
    Expect(1, 2947, '\p{InSC=_MODIFYING_Letter}', "");
    Expect(0, 2947, '\p{^InSC=_MODIFYING_Letter}', "");
    Expect(0, 2947, '\P{InSC=_MODIFYING_Letter}', "");
    Expect(1, 2947, '\P{^InSC=_MODIFYING_Letter}', "");
    Expect(0, 2948, '\p{InSC=_MODIFYING_Letter}', "");
    Expect(1, 2948, '\p{^InSC=_MODIFYING_Letter}', "");
    Expect(1, 2948, '\P{InSC=_MODIFYING_Letter}', "");
    Expect(0, 2948, '\P{^InSC=_MODIFYING_Letter}', "");
    Error('\p{Is_Indic_Syllabic_Category=_:=modifying_Letter}');
    Error('\P{Is_Indic_Syllabic_Category=_:=modifying_Letter}');
    Expect(1, 2947, '\p{Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2947, '\p{^Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2947, '\P{Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2947, '\P{^Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2948, '\p{Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2948, '\p{^Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2948, '\P{Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(0, 2948, '\P{^Is_Indic_Syllabic_Category=modifyingletter}', "");
    Expect(1, 2947, '\p{Is_Indic_Syllabic_Category=	-Modifying_LETTER}', "");
    Expect(0, 2947, '\p{^Is_Indic_Syllabic_Category=	-Modifying_LETTER}', "");
    Expect(0, 2947, '\P{Is_Indic_Syllabic_Category=	-Modifying_LETTER}', "");
    Expect(1, 2947, '\P{^Is_Indic_Syllabic_Category=	-Modifying_LETTER}', "");
    Expect(0, 2948, '\p{Is_Indic_Syllabic_Category=	-Modifying_LETTER}', "");
    Expect(1, 2948, '\p{^Is_Indic_Syllabic_Category=	-Modifying_LETTER}', "");
    Expect(1, 2948, '\P{Is_Indic_Syllabic_Category=	-Modifying_LETTER}', "");
    Expect(0, 2948, '\P{^Is_Indic_Syllabic_Category=	-Modifying_LETTER}', "");
    Error('\p{Is_InSC=/a/MODIFYING_letter}');
    Error('\P{Is_InSC=/a/MODIFYING_letter}');
    Expect(1, 2947, '\p{Is_InSC=modifyingletter}', "");
    Expect(0, 2947, '\p{^Is_InSC=modifyingletter}', "");
    Expect(0, 2947, '\P{Is_InSC=modifyingletter}', "");
    Expect(1, 2947, '\P{^Is_InSC=modifyingletter}', "");
    Expect(0, 2948, '\p{Is_InSC=modifyingletter}', "");
    Expect(1, 2948, '\p{^Is_InSC=modifyingletter}', "");
    Expect(1, 2948, '\P{Is_InSC=modifyingletter}', "");
    Expect(0, 2948, '\P{^Is_InSC=modifyingletter}', "");
    Expect(1, 2947, '\p{Is_InSC=	 MODIFYING_Letter}', "");
    Expect(0, 2947, '\p{^Is_InSC=	 MODIFYING_Letter}', "");
    Expect(0, 2947, '\P{Is_InSC=	 MODIFYING_Letter}', "");
    Expect(1, 2947, '\P{^Is_InSC=	 MODIFYING_Letter}', "");
    Expect(0, 2948, '\p{Is_InSC=	 MODIFYING_Letter}', "");
    Expect(1, 2948, '\p{^Is_InSC=	 MODIFYING_Letter}', "");
    Expect(1, 2948, '\P{Is_InSC=	 MODIFYING_Letter}', "");
    Expect(0, 2948, '\P{^Is_InSC=	 MODIFYING_Letter}', "");
    Error('\p{Indic_Syllabic_Category=:=Non_Joiner}');
    Error('\P{Indic_Syllabic_Category=:=Non_Joiner}');
    Expect(1, 8204, '\p{Indic_Syllabic_Category=:\ANon_Joiner\z:}', "");;
    Expect(0, 8205, '\p{Indic_Syllabic_Category=:\ANon_Joiner\z:}', "");;
    Expect(1, 8204, '\p{Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8204, '\p{^Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8204, '\P{Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8204, '\P{^Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8205, '\p{Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8205, '\p{^Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8205, '\P{Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8205, '\P{^Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8204, '\p{Indic_Syllabic_Category=:\Anonjoiner\z:}', "");;
    Expect(0, 8205, '\p{Indic_Syllabic_Category=:\Anonjoiner\z:}', "");;
    Expect(1, 8204, '\p{Indic_Syllabic_Category=Non_Joiner}', "");
    Expect(0, 8204, '\p{^Indic_Syllabic_Category=Non_Joiner}', "");
    Expect(0, 8204, '\P{Indic_Syllabic_Category=Non_Joiner}', "");
    Expect(1, 8204, '\P{^Indic_Syllabic_Category=Non_Joiner}', "");
    Expect(0, 8205, '\p{Indic_Syllabic_Category=Non_Joiner}', "");
    Expect(1, 8205, '\p{^Indic_Syllabic_Category=Non_Joiner}', "");
    Expect(1, 8205, '\P{Indic_Syllabic_Category=Non_Joiner}', "");
    Expect(0, 8205, '\P{^Indic_Syllabic_Category=Non_Joiner}', "");
    Error('\p{InSC=/a/Non_Joiner}');
    Error('\P{InSC=/a/Non_Joiner}');
    Expect(1, 8204, '\p{InSC=:\ANon_Joiner\z:}', "");;
    Expect(0, 8205, '\p{InSC=:\ANon_Joiner\z:}', "");;
    Expect(1, 8204, '\p{InSC=nonjoiner}', "");
    Expect(0, 8204, '\p{^InSC=nonjoiner}', "");
    Expect(0, 8204, '\P{InSC=nonjoiner}', "");
    Expect(1, 8204, '\P{^InSC=nonjoiner}', "");
    Expect(0, 8205, '\p{InSC=nonjoiner}', "");
    Expect(1, 8205, '\p{^InSC=nonjoiner}', "");
    Expect(1, 8205, '\P{InSC=nonjoiner}', "");
    Expect(0, 8205, '\P{^InSC=nonjoiner}', "");
    Expect(1, 8204, '\p{InSC=:\Anonjoiner\z:}', "");;
    Expect(0, 8205, '\p{InSC=:\Anonjoiner\z:}', "");;
    Expect(1, 8204, '\p{InSC= 	NON_Joiner}', "");
    Expect(0, 8204, '\p{^InSC= 	NON_Joiner}', "");
    Expect(0, 8204, '\P{InSC= 	NON_Joiner}', "");
    Expect(1, 8204, '\P{^InSC= 	NON_Joiner}', "");
    Expect(0, 8205, '\p{InSC= 	NON_Joiner}', "");
    Expect(1, 8205, '\p{^InSC= 	NON_Joiner}', "");
    Expect(1, 8205, '\P{InSC= 	NON_Joiner}', "");
    Expect(0, 8205, '\P{^InSC= 	NON_Joiner}', "");
    Error('\p{Is_Indic_Syllabic_Category=:=Non_Joiner}');
    Error('\P{Is_Indic_Syllabic_Category=:=Non_Joiner}');
    Expect(1, 8204, '\p{Is_Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8204, '\p{^Is_Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8204, '\P{Is_Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8204, '\P{^Is_Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8205, '\p{Is_Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8205, '\p{^Is_Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8205, '\P{Is_Indic_Syllabic_Category=nonjoiner}', "");
    Expect(0, 8205, '\P{^Is_Indic_Syllabic_Category=nonjoiner}', "");
    Expect(1, 8204, '\p{Is_Indic_Syllabic_Category=-non_JOINER}', "");
    Expect(0, 8204, '\p{^Is_Indic_Syllabic_Category=-non_JOINER}', "");
    Expect(0, 8204, '\P{Is_Indic_Syllabic_Category=-non_JOINER}', "");
    Expect(1, 8204, '\P{^Is_Indic_Syllabic_Category=-non_JOINER}', "");
    Expect(0, 8205, '\p{Is_Indic_Syllabic_Category=-non_JOINER}', "");
    Expect(1, 8205, '\p{^Is_Indic_Syllabic_Category=-non_JOINER}', "");
    Expect(1, 8205, '\P{Is_Indic_Syllabic_Category=-non_JOINER}', "");
    Expect(0, 8205, '\P{^Is_Indic_Syllabic_Category=-non_JOINER}', "");
    Error('\p{Is_InSC:/a/	_NON_Joiner}');
    Error('\P{Is_InSC:/a/	_NON_Joiner}');
    Expect(1, 8204, '\p{Is_InSC=nonjoiner}', "");
    Expect(0, 8204, '\p{^Is_InSC=nonjoiner}', "");
    Expect(0, 8204, '\P{Is_InSC=nonjoiner}', "");
    Expect(1, 8204, '\P{^Is_InSC=nonjoiner}', "");
    Expect(0, 8205, '\p{Is_InSC=nonjoiner}', "");
    Expect(1, 8205, '\p{^Is_InSC=nonjoiner}', "");
    Expect(1, 8205, '\P{Is_InSC=nonjoiner}', "");
    Expect(0, 8205, '\P{^Is_InSC=nonjoiner}', "");
    Expect(1, 8204, '\p{Is_InSC=	 Non_Joiner}', "");
    Expect(0, 8204, '\p{^Is_InSC=	 Non_Joiner}', "");
    Expect(0, 8204, '\P{Is_InSC=	 Non_Joiner}', "");
    Expect(1, 8204, '\P{^Is_InSC=	 Non_Joiner}', "");
    Expect(0, 8205, '\p{Is_InSC=	 Non_Joiner}', "");
    Expect(1, 8205, '\p{^Is_InSC=	 Non_Joiner}', "");
    Expect(1, 8205, '\P{Is_InSC=	 Non_Joiner}', "");
    Expect(0, 8205, '\P{^Is_InSC=	 Non_Joiner}', "");
    Error('\p{Indic_Syllabic_Category=/a/__Nukta}');
    Error('\P{Indic_Syllabic_Category=/a/__Nukta}');
    Expect(1, 73026, '\p{Indic_Syllabic_Category=:\ANukta\z:}', "");;
    Expect(0, 73027, '\p{Indic_Syllabic_Category=:\ANukta\z:}', "");;
    Expect(1, 73026, '\p{Indic_Syllabic_Category:nukta}', "");
    Expect(0, 73026, '\p{^Indic_Syllabic_Category:nukta}', "");
    Expect(0, 73026, '\P{Indic_Syllabic_Category:nukta}', "");
    Expect(1, 73026, '\P{^Indic_Syllabic_Category:nukta}', "");
    Expect(0, 73027, '\p{Indic_Syllabic_Category:nukta}', "");
    Expect(1, 73027, '\p{^Indic_Syllabic_Category:nukta}', "");
    Expect(1, 73027, '\P{Indic_Syllabic_Category:nukta}', "");
    Expect(0, 73027, '\P{^Indic_Syllabic_Category:nukta}', "");
    Expect(1, 73026, '\p{Indic_Syllabic_Category=:\Anukta\z:}', "");;
    Expect(0, 73027, '\p{Indic_Syllabic_Category=:\Anukta\z:}', "");;
    Expect(1, 73026, '\p{Indic_Syllabic_Category:	-NUKTA}', "");
    Expect(0, 73026, '\p{^Indic_Syllabic_Category:	-NUKTA}', "");
    Expect(0, 73026, '\P{Indic_Syllabic_Category:	-NUKTA}', "");
    Expect(1, 73026, '\P{^Indic_Syllabic_Category:	-NUKTA}', "");
    Expect(0, 73027, '\p{Indic_Syllabic_Category:	-NUKTA}', "");
    Expect(1, 73027, '\p{^Indic_Syllabic_Category:	-NUKTA}', "");
    Expect(1, 73027, '\P{Indic_Syllabic_Category:	-NUKTA}', "");
    Expect(0, 73027, '\P{^Indic_Syllabic_Category:	-NUKTA}', "");
    Error('\p{InSC=-/a/NUKTA}');
    Error('\P{InSC=-/a/NUKTA}');
    Expect(1, 73026, '\p{InSC=:\ANukta\z:}', "");;
    Expect(0, 73027, '\p{InSC=:\ANukta\z:}', "");;
    Expect(1, 73026, '\p{InSC=nukta}', "");
    Expect(0, 73026, '\p{^InSC=nukta}', "");
    Expect(0, 73026, '\P{InSC=nukta}', "");
    Expect(1, 73026, '\P{^InSC=nukta}', "");
    Expect(0, 73027, '\p{InSC=nukta}', "");
    Expect(1, 73027, '\p{^InSC=nukta}', "");
    Expect(1, 73027, '\P{InSC=nukta}', "");
    Expect(0, 73027, '\P{^InSC=nukta}', "");
    Expect(1, 73026, '\p{InSC=:\Anukta\z:}', "");;
    Expect(0, 73027, '\p{InSC=:\Anukta\z:}', "");;
    Expect(1, 73026, '\p{InSC=__nukta}', "");
    Expect(0, 73026, '\p{^InSC=__nukta}', "");
    Expect(0, 73026, '\P{InSC=__nukta}', "");
    Expect(1, 73026, '\P{^InSC=__nukta}', "");
    Expect(0, 73027, '\p{InSC=__nukta}', "");
    Expect(1, 73027, '\p{^InSC=__nukta}', "");
    Expect(1, 73027, '\P{InSC=__nukta}', "");
    Expect(0, 73027, '\P{^InSC=__nukta}', "");
    Error('\p{Is_Indic_Syllabic_Category=	_Nukta/a/}');
    Error('\P{Is_Indic_Syllabic_Category=	_Nukta/a/}');
    Expect(1, 73026, '\p{Is_Indic_Syllabic_Category:nukta}', "");
    Expect(0, 73026, '\p{^Is_Indic_Syllabic_Category:nukta}', "");
    Expect(0, 73026, '\P{Is_Indic_Syllabic_Category:nukta}', "");
    Expect(1, 73026, '\P{^Is_Indic_Syllabic_Category:nukta}', "");
    Expect(0, 73027, '\p{Is_Indic_Syllabic_Category:nukta}', "");
    Expect(1, 73027, '\p{^Is_Indic_Syllabic_Category:nukta}', "");
    Expect(1, 73027, '\P{Is_Indic_Syllabic_Category:nukta}', "");
    Expect(0, 73027, '\P{^Is_Indic_Syllabic_Category:nukta}', "");
    Expect(1, 73026, '\p{Is_Indic_Syllabic_Category=_Nukta}', "");
    Expect(0, 73026, '\p{^Is_Indic_Syllabic_Category=_Nukta}', "");
    Expect(0, 73026, '\P{Is_Indic_Syllabic_Category=_Nukta}', "");
    Expect(1, 73026, '\P{^Is_Indic_Syllabic_Category=_Nukta}', "");
    Expect(0, 73027, '\p{Is_Indic_Syllabic_Category=_Nukta}', "");
    Expect(1, 73027, '\p{^Is_Indic_Syllabic_Category=_Nukta}', "");
    Expect(1, 73027, '\P{Is_Indic_Syllabic_Category=_Nukta}', "");
    Expect(0, 73027, '\P{^Is_Indic_Syllabic_Category=_Nukta}', "");
    Error('\p{Is_InSC= 	NUKTA/a/}');
    Error('\P{Is_InSC= 	NUKTA/a/}');
    Expect(1, 73026, '\p{Is_InSC:   nukta}', "");
    Expect(0, 73026, '\p{^Is_InSC:   nukta}', "");
    Expect(0, 73026, '\P{Is_InSC:   nukta}', "");
    Expect(1, 73026, '\P{^Is_InSC:   nukta}', "");
    Expect(0, 73027, '\p{Is_InSC:   nukta}', "");
    Expect(1, 73027, '\p{^Is_InSC:   nukta}', "");
    Expect(1, 73027, '\P{Is_InSC:   nukta}', "");
    Expect(0, 73027, '\P{^Is_InSC:   nukta}', "");
    Expect(1, 73026, '\p{Is_InSC=		nukta}', "");
    Expect(0, 73026, '\p{^Is_InSC=		nukta}', "");
    Expect(0, 73026, '\P{Is_InSC=		nukta}', "");
    Expect(1, 73026, '\P{^Is_InSC=		nukta}', "");
    Expect(0, 73027, '\p{Is_InSC=		nukta}', "");
    Expect(1, 73027, '\p{^Is_InSC=		nukta}', "");
    Expect(1, 73027, '\P{Is_InSC=		nukta}', "");
    Expect(0, 73027, '\P{^Is_InSC=		nukta}', "");
    Error('\p{Indic_Syllabic_Category=-/a/number}');
    Error('\P{Indic_Syllabic_Category=-/a/number}');
    Expect(1, 73129, '\p{Indic_Syllabic_Category=:\ANumber\z:}', "");;
    Expect(0, 73130, '\p{Indic_Syllabic_Category=:\ANumber\z:}', "");;
    Expect(1, 73129, '\p{Indic_Syllabic_Category=number}', "");
    Expect(0, 73129, '\p{^Indic_Syllabic_Category=number}', "");
    Expect(0, 73129, '\P{Indic_Syllabic_Category=number}', "");
    Expect(1, 73129, '\P{^Indic_Syllabic_Category=number}', "");
    Expect(0, 73130, '\p{Indic_Syllabic_Category=number}', "");
    Expect(1, 73130, '\p{^Indic_Syllabic_Category=number}', "");
    Expect(1, 73130, '\P{Indic_Syllabic_Category=number}', "");
    Expect(0, 73130, '\P{^Indic_Syllabic_Category=number}', "");
    Expect(1, 73129, '\p{Indic_Syllabic_Category=:\Anumber\z:}', "");;
    Expect(0, 73130, '\p{Indic_Syllabic_Category=:\Anumber\z:}', "");;
    Expect(1, 73129, '\p{Indic_Syllabic_Category= Number}', "");
    Expect(0, 73129, '\p{^Indic_Syllabic_Category= Number}', "");
    Expect(0, 73129, '\P{Indic_Syllabic_Category= Number}', "");
    Expect(1, 73129, '\P{^Indic_Syllabic_Category= Number}', "");
    Expect(0, 73130, '\p{Indic_Syllabic_Category= Number}', "");
    Expect(1, 73130, '\p{^Indic_Syllabic_Category= Number}', "");
    Expect(1, 73130, '\P{Indic_Syllabic_Category= Number}', "");
    Expect(0, 73130, '\P{^Indic_Syllabic_Category= Number}', "");
    Error('\p{InSC=/a/-number}');
    Error('\P{InSC=/a/-number}');
    Expect(1, 73129, '\p{InSC=:\ANumber\z:}', "");;
    Expect(0, 73130, '\p{InSC=:\ANumber\z:}', "");;
    Expect(1, 73129, '\p{InSC=number}', "");
    Expect(0, 73129, '\p{^InSC=number}', "");
    Expect(0, 73129, '\P{InSC=number}', "");
    Expect(1, 73129, '\P{^InSC=number}', "");
    Expect(0, 73130, '\p{InSC=number}', "");
    Expect(1, 73130, '\p{^InSC=number}', "");
    Expect(1, 73130, '\P{InSC=number}', "");
    Expect(0, 73130, '\P{^InSC=number}', "");
    Expect(1, 73129, '\p{InSC=:\Anumber\z:}', "");;
    Expect(0, 73130, '\p{InSC=:\Anumber\z:}', "");;
    Expect(1, 73129, '\p{InSC=  Number}', "");
    Expect(0, 73129, '\p{^InSC=  Number}', "");
    Expect(0, 73129, '\P{InSC=  Number}', "");
    Expect(1, 73129, '\P{^InSC=  Number}', "");
    Expect(0, 73130, '\p{InSC=  Number}', "");
    Expect(1, 73130, '\p{^InSC=  Number}', "");
    Expect(1, 73130, '\P{InSC=  Number}', "");
    Expect(0, 73130, '\P{^InSC=  Number}', "");
    Error('\p{Is_Indic_Syllabic_Category=_/a/NUMBER}');
    Error('\P{Is_Indic_Syllabic_Category=_/a/NUMBER}');
    Expect(1, 73129, '\p{Is_Indic_Syllabic_Category=number}', "");
    Expect(0, 73129, '\p{^Is_Indic_Syllabic_Category=number}', "");
    Expect(0, 73129, '\P{Is_Indic_Syllabic_Category=number}', "");
    Expect(1, 73129, '\P{^Is_Indic_Syllabic_Category=number}', "");
    Expect(0, 73130, '\p{Is_Indic_Syllabic_Category=number}', "");
    Expect(1, 73130, '\p{^Is_Indic_Syllabic_Category=number}', "");
    Expect(1, 73130, '\P{Is_Indic_Syllabic_Category=number}', "");
    Expect(0, 73130, '\P{^Is_Indic_Syllabic_Category=number}', "");
    Expect(1, 73129, '\p{Is_Indic_Syllabic_Category=-_NUMBER}', "");
    Expect(0, 73129, '\p{^Is_Indic_Syllabic_Category=-_NUMBER}', "");
    Expect(0, 73129, '\P{Is_Indic_Syllabic_Category=-_NUMBER}', "");
    Expect(1, 73129, '\P{^Is_Indic_Syllabic_Category=-_NUMBER}', "");
    Expect(0, 73130, '\p{Is_Indic_Syllabic_Category=-_NUMBER}', "");
    Expect(1, 73130, '\p{^Is_Indic_Syllabic_Category=-_NUMBER}', "");
    Expect(1, 73130, '\P{Is_Indic_Syllabic_Category=-_NUMBER}', "");
    Expect(0, 73130, '\P{^Is_Indic_Syllabic_Category=-_NUMBER}', "");
    Error('\p{Is_InSC=_	Number:=}');
    Error('\P{Is_InSC=_	Number:=}');
    Expect(1, 73129, '\p{Is_InSC=number}', "");
    Expect(0, 73129, '\p{^Is_InSC=number}', "");
    Expect(0, 73129, '\P{Is_InSC=number}', "");
    Expect(1, 73129, '\P{^Is_InSC=number}', "");
    Expect(0, 73130, '\p{Is_InSC=number}', "");
    Expect(1, 73130, '\p{^Is_InSC=number}', "");
    Expect(1, 73130, '\P{Is_InSC=number}', "");
    Expect(0, 73130, '\P{^Is_InSC=number}', "");
    Expect(1, 73129, '\p{Is_InSC=-Number}', "");
    Expect(0, 73129, '\p{^Is_InSC=-Number}', "");
    Expect(0, 73129, '\P{Is_InSC=-Number}', "");
    Expect(1, 73129, '\P{^Is_InSC=-Number}', "");
    Expect(0, 73130, '\p{Is_InSC=-Number}', "");
    Expect(1, 73130, '\p{^Is_InSC=-Number}', "");
    Expect(1, 73130, '\P{Is_InSC=-Number}', "");
    Expect(0, 73130, '\P{^Is_InSC=-Number}', "");
    Error('\p{Indic_Syllabic_Category=-:=number_JOINER}');
    Error('\P{Indic_Syllabic_Category=-:=number_JOINER}');
    Expect(1, 69759, '\p{Indic_Syllabic_Category=:\ANumber_Joiner\z:}', "");;
    Expect(0, 69760, '\p{Indic_Syllabic_Category=:\ANumber_Joiner\z:}', "");;
    Expect(1, 69759, '\p{Indic_Syllabic_Category:	numberjoiner}', "");
    Expect(0, 69759, '\p{^Indic_Syllabic_Category:	numberjoiner}', "");
    Expect(0, 69759, '\P{Indic_Syllabic_Category:	numberjoiner}', "");
    Expect(1, 69759, '\P{^Indic_Syllabic_Category:	numberjoiner}', "");
    Expect(0, 69760, '\p{Indic_Syllabic_Category:	numberjoiner}', "");
    Expect(1, 69760, '\p{^Indic_Syllabic_Category:	numberjoiner}', "");
    Expect(1, 69760, '\P{Indic_Syllabic_Category:	numberjoiner}', "");
    Expect(0, 69760, '\P{^Indic_Syllabic_Category:	numberjoiner}', "");
    Expect(1, 69759, '\p{Indic_Syllabic_Category=:\Anumberjoiner\z:}', "");;
    Expect(0, 69760, '\p{Indic_Syllabic_Category=:\Anumberjoiner\z:}', "");;
    Expect(1, 69759, '\p{Indic_Syllabic_Category=-Number_Joiner}', "");
    Expect(0, 69759, '\p{^Indic_Syllabic_Category=-Number_Joiner}', "");
    Expect(0, 69759, '\P{Indic_Syllabic_Category=-Number_Joiner}', "");
    Expect(1, 69759, '\P{^Indic_Syllabic_Category=-Number_Joiner}', "");
    Expect(0, 69760, '\p{Indic_Syllabic_Category=-Number_Joiner}', "");
    Expect(1, 69760, '\p{^Indic_Syllabic_Category=-Number_Joiner}', "");
    Expect(1, 69760, '\P{Indic_Syllabic_Category=-Number_Joiner}', "");
    Expect(0, 69760, '\P{^Indic_Syllabic_Category=-Number_Joiner}', "");
    Error('\p{InSC=/a/ _NUMBER_Joiner}');
    Error('\P{InSC=/a/ _NUMBER_Joiner}');
    Expect(1, 69759, '\p{InSC=:\ANumber_Joiner\z:}', "");;
    Expect(0, 69760, '\p{InSC=:\ANumber_Joiner\z:}', "");;
    Expect(1, 69759, '\p{InSC=numberjoiner}', "");
    Expect(0, 69759, '\p{^InSC=numberjoiner}', "");
    Expect(0, 69759, '\P{InSC=numberjoiner}', "");
    Expect(1, 69759, '\P{^InSC=numberjoiner}', "");
    Expect(0, 69760, '\p{InSC=numberjoiner}', "");
    Expect(1, 69760, '\p{^InSC=numberjoiner}', "");
    Expect(1, 69760, '\P{InSC=numberjoiner}', "");
    Expect(0, 69760, '\P{^InSC=numberjoiner}', "");
    Expect(1, 69759, '\p{InSC=:\Anumberjoiner\z:}', "");;
    Expect(0, 69760, '\p{InSC=:\Anumberjoiner\z:}', "");;
    Expect(1, 69759, '\p{InSC=	-number_Joiner}', "");
    Expect(0, 69759, '\p{^InSC=	-number_Joiner}', "");
    Expect(0, 69759, '\P{InSC=	-number_Joiner}', "");
    Expect(1, 69759, '\P{^InSC=	-number_Joiner}', "");
    Expect(0, 69760, '\p{InSC=	-number_Joiner}', "");
    Expect(1, 69760, '\p{^InSC=	-number_Joiner}', "");
    Expect(1, 69760, '\P{InSC=	-number_Joiner}', "");
    Expect(0, 69760, '\P{^InSC=	-number_Joiner}', "");
    Error('\p{Is_Indic_Syllabic_Category:	_/a/Number_Joiner}');
    Error('\P{Is_Indic_Syllabic_Category:	_/a/Number_Joiner}');
    Expect(1, 69759, '\p{Is_Indic_Syllabic_Category=numberjoiner}', "");
    Expect(0, 69759, '\p{^Is_Indic_Syllabic_Category=numberjoiner}', "");
    Expect(0, 69759, '\P{Is_Indic_Syllabic_Category=numberjoiner}', "");
    Expect(1, 69759, '\P{^Is_Indic_Syllabic_Category=numberjoiner}', "");
    Expect(0, 69760, '\p{Is_Indic_Syllabic_Category=numberjoiner}', "");
    Expect(1, 69760, '\p{^Is_Indic_Syllabic_Category=numberjoiner}', "");
    Expect(1, 69760, '\P{Is_Indic_Syllabic_Category=numberjoiner}', "");
    Expect(0, 69760, '\P{^Is_Indic_Syllabic_Category=numberjoiner}', "");
    Expect(1, 69759, '\p{Is_Indic_Syllabic_Category=--Number_Joiner}', "");
    Expect(0, 69759, '\p{^Is_Indic_Syllabic_Category=--Number_Joiner}', "");
    Expect(0, 69759, '\P{Is_Indic_Syllabic_Category=--Number_Joiner}', "");
    Expect(1, 69759, '\P{^Is_Indic_Syllabic_Category=--Number_Joiner}', "");
    Expect(0, 69760, '\p{Is_Indic_Syllabic_Category=--Number_Joiner}', "");
    Expect(1, 69760, '\p{^Is_Indic_Syllabic_Category=--Number_Joiner}', "");
    Expect(1, 69760, '\P{Is_Indic_Syllabic_Category=--Number_Joiner}', "");
    Expect(0, 69760, '\P{^Is_Indic_Syllabic_Category=--Number_Joiner}', "");
    Error('\p{Is_InSC=:=--NUMBER_Joiner}');
    Error('\P{Is_InSC=:=--NUMBER_Joiner}');
    Expect(1, 69759, '\p{Is_InSC=numberjoiner}', "");
    Expect(0, 69759, '\p{^Is_InSC=numberjoiner}', "");
    Expect(0, 69759, '\P{Is_InSC=numberjoiner}', "");
    Expect(1, 69759, '\P{^Is_InSC=numberjoiner}', "");
    Expect(0, 69760, '\p{Is_InSC=numberjoiner}', "");
    Expect(1, 69760, '\p{^Is_InSC=numberjoiner}', "");
    Expect(1, 69760, '\P{Is_InSC=numberjoiner}', "");
    Expect(0, 69760, '\P{^Is_InSC=numberjoiner}', "");
    Expect(1, 69759, '\p{Is_InSC=-NUMBER_JOINER}', "");
    Expect(0, 69759, '\p{^Is_InSC=-NUMBER_JOINER}', "");
    Expect(0, 69759, '\P{Is_InSC=-NUMBER_JOINER}', "");
    Expect(1, 69759, '\P{^Is_InSC=-NUMBER_JOINER}', "");
    Expect(0, 69760, '\p{Is_InSC=-NUMBER_JOINER}', "");
    Expect(1, 69760, '\p{^Is_InSC=-NUMBER_JOINER}', "");
    Expect(1, 69760, '\P{Is_InSC=-NUMBER_JOINER}', "");
    Expect(0, 69760, '\P{^Is_InSC=-NUMBER_JOINER}', "");
    Error('\p{Indic_Syllabic_Category=:=-	other}');
    Error('\P{Indic_Syllabic_Category=:=-	other}');
    Expect(1, 73463, '\p{Indic_Syllabic_Category=:\AOther\z:}', "");;
    Expect(0, 73462, '\p{Indic_Syllabic_Category=:\AOther\z:}', "");;
    Expect(1, 73463, '\p{Indic_Syllabic_Category:other}', "");
    Expect(0, 73463, '\p{^Indic_Syllabic_Category:other}', "");
    Expect(0, 73463, '\P{Indic_Syllabic_Category:other}', "");
    Expect(1, 73463, '\P{^Indic_Syllabic_Category:other}', "");
    Expect(0, 73462, '\p{Indic_Syllabic_Category:other}', "");
    Expect(1, 73462, '\p{^Indic_Syllabic_Category:other}', "");
    Expect(1, 73462, '\P{Indic_Syllabic_Category:other}', "");
    Expect(0, 73462, '\P{^Indic_Syllabic_Category:other}', "");
    Expect(1, 73463, '\p{Indic_Syllabic_Category=:\Aother\z:}', "");;
    Expect(0, 73462, '\p{Indic_Syllabic_Category=:\Aother\z:}', "");;
    Expect(1, 73463, '\p{Indic_Syllabic_Category=_-OTHER}', "");
    Expect(0, 73463, '\p{^Indic_Syllabic_Category=_-OTHER}', "");
    Expect(0, 73463, '\P{Indic_Syllabic_Category=_-OTHER}', "");
    Expect(1, 73463, '\P{^Indic_Syllabic_Category=_-OTHER}', "");
    Expect(0, 73462, '\p{Indic_Syllabic_Category=_-OTHER}', "");
    Expect(1, 73462, '\p{^Indic_Syllabic_Category=_-OTHER}', "");
    Expect(1, 73462, '\P{Indic_Syllabic_Category=_-OTHER}', "");
    Expect(0, 73462, '\P{^Indic_Syllabic_Category=_-OTHER}', "");
    Error('\p{InSC=	:=other}');
    Error('\P{InSC=	:=other}');
    Expect(1, 73463, '\p{InSC=:\AOther\z:}', "");;
    Expect(0, 73462, '\p{InSC=:\AOther\z:}', "");;
    Expect(1, 73463, '\p{InSC=other}', "");
    Expect(0, 73463, '\p{^InSC=other}', "");
    Expect(0, 73463, '\P{InSC=other}', "");
    Expect(1, 73463, '\P{^InSC=other}', "");
    Expect(0, 73462, '\p{InSC=other}', "");
    Expect(1, 73462, '\p{^InSC=other}', "");
    Expect(1, 73462, '\P{InSC=other}', "");
    Expect(0, 73462, '\P{^InSC=other}', "");
    Expect(1, 73463, '\p{InSC=:\Aother\z:}', "");;
    Expect(0, 73462, '\p{InSC=:\Aother\z:}', "");;
    Expect(1, 73463, '\p{InSC=- other}', "");
    Expect(0, 73463, '\p{^InSC=- other}', "");
    Expect(0, 73463, '\P{InSC=- other}', "");
    Expect(1, 73463, '\P{^InSC=- other}', "");
    Expect(0, 73462, '\p{InSC=- other}', "");
    Expect(1, 73462, '\p{^InSC=- other}', "");
    Expect(1, 73462, '\P{InSC=- other}', "");
    Expect(0, 73462, '\P{^InSC=- other}', "");
    Error('\p{Is_Indic_Syllabic_Category=	/a/OTHER}');
    Error('\P{Is_Indic_Syllabic_Category=	/a/OTHER}');
    Expect(1, 73463, '\p{Is_Indic_Syllabic_Category=other}', "");
    Expect(0, 73463, '\p{^Is_Indic_Syllabic_Category=other}', "");
    Expect(0, 73463, '\P{Is_Indic_Syllabic_Category=other}', "");
    Expect(1, 73463, '\P{^Is_Indic_Syllabic_Category=other}', "");
    Expect(0, 73462, '\p{Is_Indic_Syllabic_Category=other}', "");
    Expect(1, 73462, '\p{^Is_Indic_Syllabic_Category=other}', "");
    Expect(1, 73462, '\P{Is_Indic_Syllabic_Category=other}', "");
    Expect(0, 73462, '\P{^Is_Indic_Syllabic_Category=other}', "");
    Expect(1, 73463, '\p{Is_Indic_Syllabic_Category=	-OTHER}', "");
    Expect(0, 73463, '\p{^Is_Indic_Syllabic_Category=	-OTHER}', "");
    Expect(0, 73463, '\P{Is_Indic_Syllabic_Category=	-OTHER}', "");
    Expect(1, 73463, '\P{^Is_Indic_Syllabic_Category=	-OTHER}', "");
    Expect(0, 73462, '\p{Is_Indic_Syllabic_Category=	-OTHER}', "");
    Expect(1, 73462, '\p{^Is_Indic_Syllabic_Category=	-OTHER}', "");
    Expect(1, 73462, '\P{Is_Indic_Syllabic_Category=	-OTHER}', "");
    Expect(0, 73462, '\P{^Is_Indic_Syllabic_Category=	-OTHER}', "");
    Error('\p{Is_InSC=  other/a/}');
    Error('\P{Is_InSC=  other/a/}');
    Expect(1, 73463, '\p{Is_InSC=other}', "");
    Expect(0, 73463, '\p{^Is_InSC=other}', "");
    Expect(0, 73463, '\P{Is_InSC=other}', "");
    Expect(1, 73463, '\P{^Is_InSC=other}', "");
    Expect(0, 73462, '\p{Is_InSC=other}', "");
    Expect(1, 73462, '\p{^Is_InSC=other}', "");
    Expect(1, 73462, '\P{Is_InSC=other}', "");
    Expect(0, 73462, '\P{^Is_InSC=other}', "");
    Expect(1, 73463, '\p{Is_InSC=-_Other}', "");
    Expect(0, 73463, '\p{^Is_InSC=-_Other}', "");
    Expect(0, 73463, '\P{Is_InSC=-_Other}', "");
    Expect(1, 73463, '\P{^Is_InSC=-_Other}', "");
    Expect(0, 73462, '\p{Is_InSC=-_Other}', "");
    Expect(1, 73462, '\p{^Is_InSC=-_Other}', "");
    Expect(1, 73462, '\P{Is_InSC=-_Other}', "");
    Expect(0, 73462, '\P{^Is_InSC=-_Other}', "");
    Error('\p{Indic_Syllabic_Category= pure_killer/a/}');
    Error('\P{Indic_Syllabic_Category= pure_killer/a/}');
    Expect(1, 73028, '\p{Indic_Syllabic_Category=:\APure_Killer\z:}', "");;
    Expect(0, 73029, '\p{Indic_Syllabic_Category=:\APure_Killer\z:}', "");;
    Expect(1, 73028, '\p{Indic_Syllabic_Category=purekiller}', "");
    Expect(0, 73028, '\p{^Indic_Syllabic_Category=purekiller}', "");
    Expect(0, 73028, '\P{Indic_Syllabic_Category=purekiller}', "");
    Expect(1, 73028, '\P{^Indic_Syllabic_Category=purekiller}', "");
    Expect(0, 73029, '\p{Indic_Syllabic_Category=purekiller}', "");
    Expect(1, 73029, '\p{^Indic_Syllabic_Category=purekiller}', "");
    Expect(1, 73029, '\P{Indic_Syllabic_Category=purekiller}', "");
    Expect(0, 73029, '\P{^Indic_Syllabic_Category=purekiller}', "");
    Expect(1, 73028, '\p{Indic_Syllabic_Category=:\Apurekiller\z:}', "");;
    Expect(0, 73029, '\p{Indic_Syllabic_Category=:\Apurekiller\z:}', "");;
    Expect(1, 73028, '\p{Indic_Syllabic_Category=- PURE_Killer}', "");
    Expect(0, 73028, '\p{^Indic_Syllabic_Category=- PURE_Killer}', "");
    Expect(0, 73028, '\P{Indic_Syllabic_Category=- PURE_Killer}', "");
    Expect(1, 73028, '\P{^Indic_Syllabic_Category=- PURE_Killer}', "");
    Expect(0, 73029, '\p{Indic_Syllabic_Category=- PURE_Killer}', "");
    Expect(1, 73029, '\p{^Indic_Syllabic_Category=- PURE_Killer}', "");
    Expect(1, 73029, '\P{Indic_Syllabic_Category=- PURE_Killer}', "");
    Expect(0, 73029, '\P{^Indic_Syllabic_Category=- PURE_Killer}', "");
    Error('\p{InSC=:=_Pure_Killer}');
    Error('\P{InSC=:=_Pure_Killer}');
    Expect(1, 73028, '\p{InSC=:\APure_Killer\z:}', "");;
    Expect(0, 73029, '\p{InSC=:\APure_Killer\z:}', "");;
    Expect(1, 73028, '\p{InSC:purekiller}', "");
    Expect(0, 73028, '\p{^InSC:purekiller}', "");
    Expect(0, 73028, '\P{InSC:purekiller}', "");
    Expect(1, 73028, '\P{^InSC:purekiller}', "");
    Expect(0, 73029, '\p{InSC:purekiller}', "");
    Expect(1, 73029, '\p{^InSC:purekiller}', "");
    Expect(1, 73029, '\P{InSC:purekiller}', "");
    Expect(0, 73029, '\P{^InSC:purekiller}', "");
    Expect(1, 73028, '\p{InSC=:\Apurekiller\z:}', "");;
    Expect(0, 73029, '\p{InSC=:\Apurekiller\z:}', "");;
    Expect(1, 73028, '\p{InSC: 	pure_killer}', "");
    Expect(0, 73028, '\p{^InSC: 	pure_killer}', "");
    Expect(0, 73028, '\P{InSC: 	pure_killer}', "");
    Expect(1, 73028, '\P{^InSC: 	pure_killer}', "");
    Expect(0, 73029, '\p{InSC: 	pure_killer}', "");
    Expect(1, 73029, '\p{^InSC: 	pure_killer}', "");
    Expect(1, 73029, '\P{InSC: 	pure_killer}', "");
    Expect(0, 73029, '\P{^InSC: 	pure_killer}', "");
    Error('\p{Is_Indic_Syllabic_Category=:=  PURE_Killer}');
    Error('\P{Is_Indic_Syllabic_Category=:=  PURE_Killer}');
    Expect(1, 73028, '\p{Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(0, 73028, '\p{^Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(0, 73028, '\P{Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(1, 73028, '\P{^Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(0, 73029, '\p{Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(1, 73029, '\p{^Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(1, 73029, '\P{Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(0, 73029, '\P{^Is_Indic_Syllabic_Category=purekiller}', "");
    Expect(1, 73028, '\p{Is_Indic_Syllabic_Category=		PURE_Killer}', "");
    Expect(0, 73028, '\p{^Is_Indic_Syllabic_Category=		PURE_Killer}', "");
    Expect(0, 73028, '\P{Is_Indic_Syllabic_Category=		PURE_Killer}', "");
    Expect(1, 73028, '\P{^Is_Indic_Syllabic_Category=		PURE_Killer}', "");
    Expect(0, 73029, '\p{Is_Indic_Syllabic_Category=		PURE_Killer}', "");
    Expect(1, 73029, '\p{^Is_Indic_Syllabic_Category=		PURE_Killer}', "");
    Expect(1, 73029, '\P{Is_Indic_Syllabic_Category=		PURE_Killer}', "");
    Expect(0, 73029, '\P{^Is_Indic_Syllabic_Category=		PURE_Killer}', "");
    Error('\p{Is_InSC=/a/PURE_KILLER}');
    Error('\P{Is_InSC=/a/PURE_KILLER}');
    Expect(1, 73028, '\p{Is_InSC=purekiller}', "");
    Expect(0, 73028, '\p{^Is_InSC=purekiller}', "");
    Expect(0, 73028, '\P{Is_InSC=purekiller}', "");
    Expect(1, 73028, '\P{^Is_InSC=purekiller}', "");
    Expect(0, 73029, '\p{Is_InSC=purekiller}', "");
    Expect(1, 73029, '\p{^Is_InSC=purekiller}', "");
    Expect(1, 73029, '\P{Is_InSC=purekiller}', "");
    Expect(0, 73029, '\P{^Is_InSC=purekiller}', "");
    Expect(1, 73028, '\p{Is_InSC=	 Pure_Killer}', "");
    Expect(0, 73028, '\p{^Is_InSC=	 Pure_Killer}', "");
    Expect(0, 73028, '\P{Is_InSC=	 Pure_Killer}', "");
    Expect(1, 73028, '\P{^Is_InSC=	 Pure_Killer}', "");
    Expect(0, 73029, '\p{Is_InSC=	 Pure_Killer}', "");
    Expect(1, 73029, '\p{^Is_InSC=	 Pure_Killer}', "");
    Expect(1, 73029, '\P{Is_InSC=	 Pure_Killer}', "");
    Expect(0, 73029, '\P{^Is_InSC=	 Pure_Killer}', "");
    Error('\p{Indic_Syllabic_Category=	 Register_shifter:=}');
    Error('\P{Indic_Syllabic_Category=	 Register_shifter:=}');
    Expect(1, 6090, '\p{Indic_Syllabic_Category=:\ARegister_Shifter\z:}', "");;
    Expect(0, 6091, '\p{Indic_Syllabic_Category=:\ARegister_Shifter\z:}', "");;
    Expect(1, 6090, '\p{Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6090, '\p{^Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6090, '\P{Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6090, '\P{^Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6091, '\p{Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6091, '\p{^Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6091, '\P{Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6091, '\P{^Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6090, '\p{Indic_Syllabic_Category=:\Aregistershifter\z:}', "");;
    Expect(0, 6091, '\p{Indic_Syllabic_Category=:\Aregistershifter\z:}', "");;
    Expect(1, 6090, '\p{Indic_Syllabic_Category=	REGISTER_shifter}', "");
    Expect(0, 6090, '\p{^Indic_Syllabic_Category=	REGISTER_shifter}', "");
    Expect(0, 6090, '\P{Indic_Syllabic_Category=	REGISTER_shifter}', "");
    Expect(1, 6090, '\P{^Indic_Syllabic_Category=	REGISTER_shifter}', "");
    Expect(0, 6091, '\p{Indic_Syllabic_Category=	REGISTER_shifter}', "");
    Expect(1, 6091, '\p{^Indic_Syllabic_Category=	REGISTER_shifter}', "");
    Expect(1, 6091, '\P{Indic_Syllabic_Category=	REGISTER_shifter}', "");
    Expect(0, 6091, '\P{^Indic_Syllabic_Category=	REGISTER_shifter}', "");
    Error('\p{InSC=	Register_SHIFTER:=}');
    Error('\P{InSC=	Register_SHIFTER:=}');
    Expect(1, 6090, '\p{InSC=:\ARegister_Shifter\z:}', "");;
    Expect(0, 6091, '\p{InSC=:\ARegister_Shifter\z:}', "");;
    Expect(1, 6090, '\p{InSC=registershifter}', "");
    Expect(0, 6090, '\p{^InSC=registershifter}', "");
    Expect(0, 6090, '\P{InSC=registershifter}', "");
    Expect(1, 6090, '\P{^InSC=registershifter}', "");
    Expect(0, 6091, '\p{InSC=registershifter}', "");
    Expect(1, 6091, '\p{^InSC=registershifter}', "");
    Expect(1, 6091, '\P{InSC=registershifter}', "");
    Expect(0, 6091, '\P{^InSC=registershifter}', "");
    Expect(1, 6090, '\p{InSC=:\Aregistershifter\z:}', "");;
    Expect(0, 6091, '\p{InSC=:\Aregistershifter\z:}', "");;
    Expect(1, 6090, '\p{InSC=	Register_Shifter}', "");
    Expect(0, 6090, '\p{^InSC=	Register_Shifter}', "");
    Expect(0, 6090, '\P{InSC=	Register_Shifter}', "");
    Expect(1, 6090, '\P{^InSC=	Register_Shifter}', "");
    Expect(0, 6091, '\p{InSC=	Register_Shifter}', "");
    Expect(1, 6091, '\p{^InSC=	Register_Shifter}', "");
    Expect(1, 6091, '\P{InSC=	Register_Shifter}', "");
    Expect(0, 6091, '\P{^InSC=	Register_Shifter}', "");
    Error('\p{Is_Indic_Syllabic_Category=  Register_Shifter/a/}');
    Error('\P{Is_Indic_Syllabic_Category=  Register_Shifter/a/}');
    Expect(1, 6090, '\p{Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6090, '\p{^Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6090, '\P{Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6090, '\P{^Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6091, '\p{Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6091, '\p{^Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6091, '\P{Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(0, 6091, '\P{^Is_Indic_Syllabic_Category=registershifter}', "");
    Expect(1, 6090, '\p{Is_Indic_Syllabic_Category= -register_SHIFTER}', "");
    Expect(0, 6090, '\p{^Is_Indic_Syllabic_Category= -register_SHIFTER}', "");
    Expect(0, 6090, '\P{Is_Indic_Syllabic_Category= -register_SHIFTER}', "");
    Expect(1, 6090, '\P{^Is_Indic_Syllabic_Category= -register_SHIFTER}', "");
    Expect(0, 6091, '\p{Is_Indic_Syllabic_Category= -register_SHIFTER}', "");
    Expect(1, 6091, '\p{^Is_Indic_Syllabic_Category= -register_SHIFTER}', "");
    Expect(1, 6091, '\P{Is_Indic_Syllabic_Category= -register_SHIFTER}', "");
    Expect(0, 6091, '\P{^Is_Indic_Syllabic_Category= -register_SHIFTER}', "");
    Error('\p{Is_InSC=:= -register_SHIFTER}');
    Error('\P{Is_InSC=:= -register_SHIFTER}');
    Expect(1, 6090, '\p{Is_InSC=registershifter}', "");
    Expect(0, 6090, '\p{^Is_InSC=registershifter}', "");
    Expect(0, 6090, '\P{Is_InSC=registershifter}', "");
    Expect(1, 6090, '\P{^Is_InSC=registershifter}', "");
    Expect(0, 6091, '\p{Is_InSC=registershifter}', "");
    Expect(1, 6091, '\p{^Is_InSC=registershifter}', "");
    Expect(1, 6091, '\P{Is_InSC=registershifter}', "");
    Expect(0, 6091, '\P{^Is_InSC=registershifter}', "");
    Expect(1, 6090, '\p{Is_InSC=		register_shifter}', "");
    Expect(0, 6090, '\p{^Is_InSC=		register_shifter}', "");
    Expect(0, 6090, '\P{Is_InSC=		register_shifter}', "");
    Expect(1, 6090, '\P{^Is_InSC=		register_shifter}', "");
    Expect(0, 6091, '\p{Is_InSC=		register_shifter}', "");
    Expect(1, 6091, '\p{^Is_InSC=		register_shifter}', "");
    Expect(1, 6091, '\P{Is_InSC=		register_shifter}', "");
    Expect(0, 6091, '\P{^Is_InSC=		register_shifter}', "");
    Error('\p{Indic_Syllabic_Category=_:=syllable_modifier}');
    Error('\P{Indic_Syllabic_Category=_:=syllable_modifier}');
    Expect(1, 72243, '\p{Indic_Syllabic_Category=:\ASyllable_Modifier\z:}', "");;
    Expect(0, 72244, '\p{Indic_Syllabic_Category=:\ASyllable_Modifier\z:}', "");;
    Expect(1, 72243, '\p{Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72243, '\p{^Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72243, '\P{Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72243, '\P{^Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72244, '\p{Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72244, '\p{^Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72244, '\P{Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72244, '\P{^Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72243, '\p{Indic_Syllabic_Category=:\Asyllablemodifier\z:}', "");;
    Expect(0, 72244, '\p{Indic_Syllabic_Category=:\Asyllablemodifier\z:}', "");;
    Expect(1, 72243, '\p{Indic_Syllabic_Category=_	Syllable_modifier}', "");
    Expect(0, 72243, '\p{^Indic_Syllabic_Category=_	Syllable_modifier}', "");
    Expect(0, 72243, '\P{Indic_Syllabic_Category=_	Syllable_modifier}', "");
    Expect(1, 72243, '\P{^Indic_Syllabic_Category=_	Syllable_modifier}', "");
    Expect(0, 72244, '\p{Indic_Syllabic_Category=_	Syllable_modifier}', "");
    Expect(1, 72244, '\p{^Indic_Syllabic_Category=_	Syllable_modifier}', "");
    Expect(1, 72244, '\P{Indic_Syllabic_Category=_	Syllable_modifier}', "");
    Expect(0, 72244, '\P{^Indic_Syllabic_Category=_	Syllable_modifier}', "");
    Error('\p{InSC=:= 	syllable_modifier}');
    Error('\P{InSC=:= 	syllable_modifier}');
    Expect(1, 72243, '\p{InSC=:\ASyllable_Modifier\z:}', "");;
    Expect(0, 72244, '\p{InSC=:\ASyllable_Modifier\z:}', "");;
    Expect(1, 72243, '\p{InSC=syllablemodifier}', "");
    Expect(0, 72243, '\p{^InSC=syllablemodifier}', "");
    Expect(0, 72243, '\P{InSC=syllablemodifier}', "");
    Expect(1, 72243, '\P{^InSC=syllablemodifier}', "");
    Expect(0, 72244, '\p{InSC=syllablemodifier}', "");
    Expect(1, 72244, '\p{^InSC=syllablemodifier}', "");
    Expect(1, 72244, '\P{InSC=syllablemodifier}', "");
    Expect(0, 72244, '\P{^InSC=syllablemodifier}', "");
    Expect(1, 72243, '\p{InSC=:\Asyllablemodifier\z:}', "");;
    Expect(0, 72244, '\p{InSC=:\Asyllablemodifier\z:}', "");;
    Expect(1, 72243, '\p{InSC= 	syllable_Modifier}', "");
    Expect(0, 72243, '\p{^InSC= 	syllable_Modifier}', "");
    Expect(0, 72243, '\P{InSC= 	syllable_Modifier}', "");
    Expect(1, 72243, '\P{^InSC= 	syllable_Modifier}', "");
    Expect(0, 72244, '\p{InSC= 	syllable_Modifier}', "");
    Expect(1, 72244, '\p{^InSC= 	syllable_Modifier}', "");
    Expect(1, 72244, '\P{InSC= 	syllable_Modifier}', "");
    Expect(0, 72244, '\P{^InSC= 	syllable_Modifier}', "");
    Error('\p{Is_Indic_Syllabic_Category=/a/		syllable_Modifier}');
    Error('\P{Is_Indic_Syllabic_Category=/a/		syllable_Modifier}');
    Expect(1, 72243, '\p{Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72243, '\p{^Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72243, '\P{Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72243, '\P{^Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72244, '\p{Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72244, '\p{^Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72244, '\P{Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(0, 72244, '\P{^Is_Indic_Syllabic_Category=syllablemodifier}', "");
    Expect(1, 72243, '\p{Is_Indic_Syllabic_Category=		Syllable_MODIFIER}', "");
    Expect(0, 72243, '\p{^Is_Indic_Syllabic_Category=		Syllable_MODIFIER}', "");
    Expect(0, 72243, '\P{Is_Indic_Syllabic_Category=		Syllable_MODIFIER}', "");
    Expect(1, 72243, '\P{^Is_Indic_Syllabic_Category=		Syllable_MODIFIER}', "");
    Expect(0, 72244, '\p{Is_Indic_Syllabic_Category=		Syllable_MODIFIER}', "");
    Expect(1, 72244, '\p{^Is_Indic_Syllabic_Category=		Syllable_MODIFIER}', "");
    Expect(1, 72244, '\P{Is_Indic_Syllabic_Category=		Syllable_MODIFIER}', "");
    Expect(0, 72244, '\P{^Is_Indic_Syllabic_Category=		Syllable_MODIFIER}', "");
    Error('\p{Is_InSC=_ Syllable_Modifier:=}');
    Error('\P{Is_InSC=_ Syllable_Modifier:=}');
    Expect(1, 72243, '\p{Is_InSC=syllablemodifier}', "");
    Expect(0, 72243, '\p{^Is_InSC=syllablemodifier}', "");
    Expect(0, 72243, '\P{Is_InSC=syllablemodifier}', "");
    Expect(1, 72243, '\P{^Is_InSC=syllablemodifier}', "");
    Expect(0, 72244, '\p{Is_InSC=syllablemodifier}', "");
    Expect(1, 72244, '\p{^Is_InSC=syllablemodifier}', "");
    Expect(1, 72244, '\P{Is_InSC=syllablemodifier}', "");
    Expect(0, 72244, '\P{^Is_InSC=syllablemodifier}', "");
    Expect(1, 72243, '\p{Is_InSC=-Syllable_MODIFIER}', "");
    Expect(0, 72243, '\p{^Is_InSC=-Syllable_MODIFIER}', "");
    Expect(0, 72243, '\P{Is_InSC=-Syllable_MODIFIER}', "");
    Expect(1, 72243, '\P{^Is_InSC=-Syllable_MODIFIER}', "");
    Expect(0, 72244, '\p{Is_InSC=-Syllable_MODIFIER}', "");
    Expect(1, 72244, '\p{^Is_InSC=-Syllable_MODIFIER}', "");
    Expect(1, 72244, '\P{Is_InSC=-Syllable_MODIFIER}', "");
    Expect(0, 72244, '\P{^Is_InSC=-Syllable_MODIFIER}', "");
    Error('\p{Indic_Syllabic_Category=  TONE_letter/a/}');
    Error('\P{Indic_Syllabic_Category=  TONE_letter/a/}');
    Expect(1, 43714, '\p{Indic_Syllabic_Category=:\ATone_Letter\z:}', "");;
    Expect(0, 43715, '\p{Indic_Syllabic_Category=:\ATone_Letter\z:}', "");;
    Expect(1, 43714, '\p{Indic_Syllabic_Category:   toneletter}', "");
    Expect(0, 43714, '\p{^Indic_Syllabic_Category:   toneletter}', "");
    Expect(0, 43714, '\P{Indic_Syllabic_Category:   toneletter}', "");
    Expect(1, 43714, '\P{^Indic_Syllabic_Category:   toneletter}', "");
    Expect(0, 43715, '\p{Indic_Syllabic_Category:   toneletter}', "");
    Expect(1, 43715, '\p{^Indic_Syllabic_Category:   toneletter}', "");
    Expect(1, 43715, '\P{Indic_Syllabic_Category:   toneletter}', "");
    Expect(0, 43715, '\P{^Indic_Syllabic_Category:   toneletter}', "");
    Expect(1, 43714, '\p{Indic_Syllabic_Category=:\Atoneletter\z:}', "");;
    Expect(0, 43715, '\p{Indic_Syllabic_Category=:\Atoneletter\z:}', "");;
    Expect(1, 43714, '\p{Indic_Syllabic_Category:   	 TONE_letter}', "");
    Expect(0, 43714, '\p{^Indic_Syllabic_Category:   	 TONE_letter}', "");
    Expect(0, 43714, '\P{Indic_Syllabic_Category:   	 TONE_letter}', "");
    Expect(1, 43714, '\P{^Indic_Syllabic_Category:   	 TONE_letter}', "");
    Expect(0, 43715, '\p{Indic_Syllabic_Category:   	 TONE_letter}', "");
    Expect(1, 43715, '\p{^Indic_Syllabic_Category:   	 TONE_letter}', "");
    Expect(1, 43715, '\P{Indic_Syllabic_Category:   	 TONE_letter}', "");
    Expect(0, 43715, '\P{^Indic_Syllabic_Category:   	 TONE_letter}', "");
    Error('\p{InSC: /a/  Tone_Letter}');
    Error('\P{InSC: /a/  Tone_Letter}');
    Expect(1, 43714, '\p{InSC=:\ATone_Letter\z:}', "");;
    Expect(0, 43715, '\p{InSC=:\ATone_Letter\z:}', "");;
    Expect(1, 43714, '\p{InSC=toneletter}', "");
    Expect(0, 43714, '\p{^InSC=toneletter}', "");
    Expect(0, 43714, '\P{InSC=toneletter}', "");
    Expect(1, 43714, '\P{^InSC=toneletter}', "");
    Expect(0, 43715, '\p{InSC=toneletter}', "");
    Expect(1, 43715, '\p{^InSC=toneletter}', "");
    Expect(1, 43715, '\P{InSC=toneletter}', "");
    Expect(0, 43715, '\P{^InSC=toneletter}', "");
    Expect(1, 43714, '\p{InSC=:\Atoneletter\z:}', "");;
    Expect(0, 43715, '\p{InSC=:\Atoneletter\z:}', "");;
    Expect(1, 43714, '\p{InSC=_-tone_letter}', "");
    Expect(0, 43714, '\p{^InSC=_-tone_letter}', "");
    Expect(0, 43714, '\P{InSC=_-tone_letter}', "");
    Expect(1, 43714, '\P{^InSC=_-tone_letter}', "");
    Expect(0, 43715, '\p{InSC=_-tone_letter}', "");
    Expect(1, 43715, '\p{^InSC=_-tone_letter}', "");
    Expect(1, 43715, '\P{InSC=_-tone_letter}', "");
    Expect(0, 43715, '\P{^InSC=_-tone_letter}', "");
    Error('\p{Is_Indic_Syllabic_Category= -Tone_LETTER:=}');
    Error('\P{Is_Indic_Syllabic_Category= -Tone_LETTER:=}');
    Expect(1, 43714, '\p{Is_Indic_Syllabic_Category=toneletter}', "");
    Expect(0, 43714, '\p{^Is_Indic_Syllabic_Category=toneletter}', "");
    Expect(0, 43714, '\P{Is_Indic_Syllabic_Category=toneletter}', "");
    Expect(1, 43714, '\P{^Is_Indic_Syllabic_Category=toneletter}', "");
    Expect(0, 43715, '\p{Is_Indic_Syllabic_Category=toneletter}', "");
    Expect(1, 43715, '\p{^Is_Indic_Syllabic_Category=toneletter}', "");
    Expect(1, 43715, '\P{Is_Indic_Syllabic_Category=toneletter}', "");
    Expect(0, 43715, '\P{^Is_Indic_Syllabic_Category=toneletter}', "");
    Expect(1, 43714, '\p{Is_Indic_Syllabic_Category=_ Tone_letter}', "");
    Expect(0, 43714, '\p{^Is_Indic_Syllabic_Category=_ Tone_letter}', "");
    Expect(0, 43714, '\P{Is_Indic_Syllabic_Category=_ Tone_letter}', "");
    Expect(1, 43714, '\P{^Is_Indic_Syllabic_Category=_ Tone_letter}', "");
    Expect(0, 43715, '\p{Is_Indic_Syllabic_Category=_ Tone_letter}', "");
    Expect(1, 43715, '\p{^Is_Indic_Syllabic_Category=_ Tone_letter}', "");
    Expect(1, 43715, '\P{Is_Indic_Syllabic_Category=_ Tone_letter}', "");
    Expect(0, 43715, '\P{^Is_Indic_Syllabic_Category=_ Tone_letter}', "");
    Error('\p{Is_InSC:	 /a/tone_Letter}');
    Error('\P{Is_InSC:	 /a/tone_Letter}');
    Expect(1, 43714, '\p{Is_InSC=toneletter}', "");
    Expect(0, 43714, '\p{^Is_InSC=toneletter}', "");
    Expect(0, 43714, '\P{Is_InSC=toneletter}', "");
    Expect(1, 43714, '\P{^Is_InSC=toneletter}', "");
    Expect(0, 43715, '\p{Is_InSC=toneletter}', "");
    Expect(1, 43715, '\p{^Is_InSC=toneletter}', "");
    Expect(1, 43715, '\P{Is_InSC=toneletter}', "");
    Expect(0, 43715, '\P{^Is_InSC=toneletter}', "");
    Expect(1, 43714, '\p{Is_InSC=-	tone_Letter}', "");
    Expect(0, 43714, '\p{^Is_InSC=-	tone_Letter}', "");
    Expect(0, 43714, '\P{Is_InSC=-	tone_Letter}', "");
    Expect(1, 43714, '\P{^Is_InSC=-	tone_Letter}', "");
    Expect(0, 43715, '\p{Is_InSC=-	tone_Letter}', "");
    Expect(1, 43715, '\p{^Is_InSC=-	tone_Letter}', "");
    Expect(1, 43715, '\P{Is_InSC=-	tone_Letter}', "");
    Expect(0, 43715, '\P{^Is_InSC=-	tone_Letter}', "");
    Error('\p{Indic_Syllabic_Category=/a/-Tone_Mark}');
    Error('\P{Indic_Syllabic_Category=/a/-Tone_Mark}');
    Expect(1, 44012, '\p{Indic_Syllabic_Category=:\ATone_Mark\z:}', "");;
    Expect(0, 44013, '\p{Indic_Syllabic_Category=:\ATone_Mark\z:}', "");;
    Expect(1, 44012, '\p{Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44012, '\p{^Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44012, '\P{Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44012, '\P{^Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44013, '\p{Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44013, '\p{^Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44013, '\P{Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44013, '\P{^Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44012, '\p{Indic_Syllabic_Category=:\Atonemark\z:}', "");;
    Expect(0, 44013, '\p{Indic_Syllabic_Category=:\Atonemark\z:}', "");;
    Expect(1, 44012, '\p{Indic_Syllabic_Category=		Tone_mark}', "");
    Expect(0, 44012, '\p{^Indic_Syllabic_Category=		Tone_mark}', "");
    Expect(0, 44012, '\P{Indic_Syllabic_Category=		Tone_mark}', "");
    Expect(1, 44012, '\P{^Indic_Syllabic_Category=		Tone_mark}', "");
    Expect(0, 44013, '\p{Indic_Syllabic_Category=		Tone_mark}', "");
    Expect(1, 44013, '\p{^Indic_Syllabic_Category=		Tone_mark}', "");
    Expect(1, 44013, '\P{Indic_Syllabic_Category=		Tone_mark}', "");
    Expect(0, 44013, '\P{^Indic_Syllabic_Category=		Tone_mark}', "");
    Error('\p{InSC=/a/-	TONE_Mark}');
    Error('\P{InSC=/a/-	TONE_Mark}');
    Expect(1, 44012, '\p{InSC=:\ATone_Mark\z:}', "");;
    Expect(0, 44013, '\p{InSC=:\ATone_Mark\z:}', "");;
    Expect(1, 44012, '\p{InSC=tonemark}', "");
    Expect(0, 44012, '\p{^InSC=tonemark}', "");
    Expect(0, 44012, '\P{InSC=tonemark}', "");
    Expect(1, 44012, '\P{^InSC=tonemark}', "");
    Expect(0, 44013, '\p{InSC=tonemark}', "");
    Expect(1, 44013, '\p{^InSC=tonemark}', "");
    Expect(1, 44013, '\P{InSC=tonemark}', "");
    Expect(0, 44013, '\P{^InSC=tonemark}', "");
    Expect(1, 44012, '\p{InSC=:\Atonemark\z:}', "");;
    Expect(0, 44013, '\p{InSC=:\Atonemark\z:}', "");;
    Expect(1, 44012, '\p{InSC=_TONE_mark}', "");
    Expect(0, 44012, '\p{^InSC=_TONE_mark}', "");
    Expect(0, 44012, '\P{InSC=_TONE_mark}', "");
    Expect(1, 44012, '\P{^InSC=_TONE_mark}', "");
    Expect(0, 44013, '\p{InSC=_TONE_mark}', "");
    Expect(1, 44013, '\p{^InSC=_TONE_mark}', "");
    Expect(1, 44013, '\P{InSC=_TONE_mark}', "");
    Expect(0, 44013, '\P{^InSC=_TONE_mark}', "");
    Error('\p{Is_Indic_Syllabic_Category=-:=tone_mark}');
    Error('\P{Is_Indic_Syllabic_Category=-:=tone_mark}');
    Expect(1, 44012, '\p{Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44012, '\p{^Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44012, '\P{Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44012, '\P{^Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44013, '\p{Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44013, '\p{^Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44013, '\P{Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(0, 44013, '\P{^Is_Indic_Syllabic_Category=tonemark}', "");
    Expect(1, 44012, '\p{Is_Indic_Syllabic_Category=-_Tone_Mark}', "");
    Expect(0, 44012, '\p{^Is_Indic_Syllabic_Category=-_Tone_Mark}', "");
    Expect(0, 44012, '\P{Is_Indic_Syllabic_Category=-_Tone_Mark}', "");
    Expect(1, 44012, '\P{^Is_Indic_Syllabic_Category=-_Tone_Mark}', "");
    Expect(0, 44013, '\p{Is_Indic_Syllabic_Category=-_Tone_Mark}', "");
    Expect(1, 44013, '\p{^Is_Indic_Syllabic_Category=-_Tone_Mark}', "");
    Expect(1, 44013, '\P{Is_Indic_Syllabic_Category=-_Tone_Mark}', "");
    Expect(0, 44013, '\P{^Is_Indic_Syllabic_Category=-_Tone_Mark}', "");
    Error('\p{Is_InSC=		tone_mark:=}');
    Error('\P{Is_InSC=		tone_mark:=}');
    Expect(1, 44012, '\p{Is_InSC=tonemark}', "");
    Expect(0, 44012, '\p{^Is_InSC=tonemark}', "");
    Expect(0, 44012, '\P{Is_InSC=tonemark}', "");
    Expect(1, 44012, '\P{^Is_InSC=tonemark}', "");
    Expect(0, 44013, '\p{Is_InSC=tonemark}', "");
    Expect(1, 44013, '\p{^Is_InSC=tonemark}', "");
    Expect(1, 44013, '\P{Is_InSC=tonemark}', "");
    Expect(0, 44013, '\P{^Is_InSC=tonemark}', "");
    Expect(1, 44012, '\p{Is_InSC=__Tone_mark}', "");
    Expect(0, 44012, '\p{^Is_InSC=__Tone_mark}', "");
    Expect(0, 44012, '\P{Is_InSC=__Tone_mark}', "");
    Expect(1, 44012, '\P{^Is_InSC=__Tone_mark}', "");
    Expect(0, 44013, '\p{Is_InSC=__Tone_mark}', "");
    Expect(1, 44013, '\p{^Is_InSC=__Tone_mark}', "");
    Expect(1, 44013, '\P{Is_InSC=__Tone_mark}', "");
    Expect(0, 44013, '\P{^Is_InSC=__Tone_mark}', "");
    Error('\p{Indic_Syllabic_Category=:=_VIRAMA}');
    Error('\P{Indic_Syllabic_Category=:=_VIRAMA}');
    Expect(1, 72767, '\p{Indic_Syllabic_Category=:\AVirama\z:}', "");;
    Expect(0, 72768, '\p{Indic_Syllabic_Category=:\AVirama\z:}', "");;
    Expect(1, 72767, '\p{Indic_Syllabic_Category:virama}', "");
    Expect(0, 72767, '\p{^Indic_Syllabic_Category:virama}', "");
    Expect(0, 72767, '\P{Indic_Syllabic_Category:virama}', "");
    Expect(1, 72767, '\P{^Indic_Syllabic_Category:virama}', "");
    Expect(0, 72768, '\p{Indic_Syllabic_Category:virama}', "");
    Expect(1, 72768, '\p{^Indic_Syllabic_Category:virama}', "");
    Expect(1, 72768, '\P{Indic_Syllabic_Category:virama}', "");
    Expect(0, 72768, '\P{^Indic_Syllabic_Category:virama}', "");
    Expect(1, 72767, '\p{Indic_Syllabic_Category=:\Avirama\z:}', "");;
    Expect(0, 72768, '\p{Indic_Syllabic_Category=:\Avirama\z:}', "");;
    Expect(1, 72767, '\p{Indic_Syllabic_Category=-VIRAMA}', "");
    Expect(0, 72767, '\p{^Indic_Syllabic_Category=-VIRAMA}', "");
    Expect(0, 72767, '\P{Indic_Syllabic_Category=-VIRAMA}', "");
    Expect(1, 72767, '\P{^Indic_Syllabic_Category=-VIRAMA}', "");
    Expect(0, 72768, '\p{Indic_Syllabic_Category=-VIRAMA}', "");
    Expect(1, 72768, '\p{^Indic_Syllabic_Category=-VIRAMA}', "");
    Expect(1, 72768, '\P{Indic_Syllabic_Category=-VIRAMA}', "");
    Expect(0, 72768, '\P{^Indic_Syllabic_Category=-VIRAMA}', "");
    Error('\p{InSC:	:=_	Virama}');
    Error('\P{InSC:	:=_	Virama}');
    Expect(1, 72767, '\p{InSC=:\AVirama\z:}', "");;
    Expect(0, 72768, '\p{InSC=:\AVirama\z:}', "");;
    Expect(1, 72767, '\p{InSC=virama}', "");
    Expect(0, 72767, '\p{^InSC=virama}', "");
    Expect(0, 72767, '\P{InSC=virama}', "");
    Expect(1, 72767, '\P{^InSC=virama}', "");
    Expect(0, 72768, '\p{InSC=virama}', "");
    Expect(1, 72768, '\p{^InSC=virama}', "");
    Expect(1, 72768, '\P{InSC=virama}', "");
    Expect(0, 72768, '\P{^InSC=virama}', "");
    Expect(1, 72767, '\p{InSC=:\Avirama\z:}', "");;
    Expect(0, 72768, '\p{InSC=:\Avirama\z:}', "");;
    Expect(1, 72767, '\p{InSC=_-virama}', "");
    Expect(0, 72767, '\p{^InSC=_-virama}', "");
    Expect(0, 72767, '\P{InSC=_-virama}', "");
    Expect(1, 72767, '\P{^InSC=_-virama}', "");
    Expect(0, 72768, '\p{InSC=_-virama}', "");
    Expect(1, 72768, '\p{^InSC=_-virama}', "");
    Expect(1, 72768, '\P{InSC=_-virama}', "");
    Expect(0, 72768, '\P{^InSC=_-virama}', "");
    Error('\p{Is_Indic_Syllabic_Category=	/a/VIRAMA}');
    Error('\P{Is_Indic_Syllabic_Category=	/a/VIRAMA}');
    Expect(1, 72767, '\p{Is_Indic_Syllabic_Category=virama}', "");
    Expect(0, 72767, '\p{^Is_Indic_Syllabic_Category=virama}', "");
    Expect(0, 72767, '\P{Is_Indic_Syllabic_Category=virama}', "");
    Expect(1, 72767, '\P{^Is_Indic_Syllabic_Category=virama}', "");
    Expect(0, 72768, '\p{Is_Indic_Syllabic_Category=virama}', "");
    Expect(1, 72768, '\p{^Is_Indic_Syllabic_Category=virama}', "");
    Expect(1, 72768, '\P{Is_Indic_Syllabic_Category=virama}', "");
    Expect(0, 72768, '\P{^Is_Indic_Syllabic_Category=virama}', "");
    Expect(1, 72767, '\p{Is_Indic_Syllabic_Category=-Virama}', "");
    Expect(0, 72767, '\p{^Is_Indic_Syllabic_Category=-Virama}', "");
    Expect(0, 72767, '\P{Is_Indic_Syllabic_Category=-Virama}', "");
    Expect(1, 72767, '\P{^Is_Indic_Syllabic_Category=-Virama}', "");
    Expect(0, 72768, '\p{Is_Indic_Syllabic_Category=-Virama}', "");
    Expect(1, 72768, '\p{^Is_Indic_Syllabic_Category=-Virama}', "");
    Expect(1, 72768, '\P{Is_Indic_Syllabic_Category=-Virama}', "");
    Expect(0, 72768, '\P{^Is_Indic_Syllabic_Category=-Virama}', "");
    Error('\p{Is_InSC=	VIRAMA:=}');
    Error('\P{Is_InSC=	VIRAMA:=}');
    Expect(1, 72767, '\p{Is_InSC=virama}', "");
    Expect(0, 72767, '\p{^Is_InSC=virama}', "");
    Expect(0, 72767, '\P{Is_InSC=virama}', "");
    Expect(1, 72767, '\P{^Is_InSC=virama}', "");
    Expect(0, 72768, '\p{Is_InSC=virama}', "");
    Expect(1, 72768, '\p{^Is_InSC=virama}', "");
    Expect(1, 72768, '\P{Is_InSC=virama}', "");
    Expect(0, 72768, '\P{^Is_InSC=virama}', "");
    Expect(1, 72767, '\p{Is_InSC= VIRAMA}', "");
    Expect(0, 72767, '\p{^Is_InSC= VIRAMA}', "");
    Expect(0, 72767, '\P{Is_InSC= VIRAMA}', "");
    Expect(1, 72767, '\P{^Is_InSC= VIRAMA}', "");
    Expect(0, 72768, '\p{Is_InSC= VIRAMA}', "");
    Expect(1, 72768, '\p{^Is_InSC= VIRAMA}', "");
    Expect(1, 72768, '\P{Is_InSC= VIRAMA}', "");
    Expect(0, 72768, '\P{^Is_InSC= VIRAMA}', "");
    Error('\p{Indic_Syllabic_Category=/a/Visarga}');
    Error('\P{Indic_Syllabic_Category=/a/Visarga}');
    Expect(1, 73110, '\p{Indic_Syllabic_Category=:\AVisarga\z:}', "");;
    Expect(0, 73111, '\p{Indic_Syllabic_Category=:\AVisarga\z:}', "");;
    Expect(1, 73110, '\p{Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73110, '\p{^Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73110, '\P{Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73110, '\P{^Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73111, '\p{Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73111, '\p{^Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73111, '\P{Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73111, '\P{^Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73110, '\p{Indic_Syllabic_Category=:\Avisarga\z:}', "");;
    Expect(0, 73111, '\p{Indic_Syllabic_Category=:\Avisarga\z:}', "");;
    Expect(1, 73110, '\p{Indic_Syllabic_Category=-visarga}', "");
    Expect(0, 73110, '\p{^Indic_Syllabic_Category=-visarga}', "");
    Expect(0, 73110, '\P{Indic_Syllabic_Category=-visarga}', "");
    Expect(1, 73110, '\P{^Indic_Syllabic_Category=-visarga}', "");
    Expect(0, 73111, '\p{Indic_Syllabic_Category=-visarga}', "");
    Expect(1, 73111, '\p{^Indic_Syllabic_Category=-visarga}', "");
    Expect(1, 73111, '\P{Indic_Syllabic_Category=-visarga}', "");
    Expect(0, 73111, '\P{^Indic_Syllabic_Category=-visarga}', "");
    Error('\p{InSC=-	visarga/a/}');
    Error('\P{InSC=-	visarga/a/}');
    Expect(1, 73110, '\p{InSC=:\AVisarga\z:}', "");;
    Expect(0, 73111, '\p{InSC=:\AVisarga\z:}', "");;
    Expect(1, 73110, '\p{InSC=visarga}', "");
    Expect(0, 73110, '\p{^InSC=visarga}', "");
    Expect(0, 73110, '\P{InSC=visarga}', "");
    Expect(1, 73110, '\P{^InSC=visarga}', "");
    Expect(0, 73111, '\p{InSC=visarga}', "");
    Expect(1, 73111, '\p{^InSC=visarga}', "");
    Expect(1, 73111, '\P{InSC=visarga}', "");
    Expect(0, 73111, '\P{^InSC=visarga}', "");
    Expect(1, 73110, '\p{InSC=:\Avisarga\z:}', "");;
    Expect(0, 73111, '\p{InSC=:\Avisarga\z:}', "");;
    Expect(1, 73110, '\p{InSC= -visarga}', "");
    Expect(0, 73110, '\p{^InSC= -visarga}', "");
    Expect(0, 73110, '\P{InSC= -visarga}', "");
    Expect(1, 73110, '\P{^InSC= -visarga}', "");
    Expect(0, 73111, '\p{InSC= -visarga}', "");
    Expect(1, 73111, '\p{^InSC= -visarga}', "");
    Expect(1, 73111, '\P{InSC= -visarga}', "");
    Expect(0, 73111, '\P{^InSC= -visarga}', "");
    Error('\p{Is_Indic_Syllabic_Category=-visarga:=}');
    Error('\P{Is_Indic_Syllabic_Category=-visarga:=}');
    Expect(1, 73110, '\p{Is_Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73110, '\p{^Is_Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73110, '\P{Is_Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73110, '\P{^Is_Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73111, '\p{Is_Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73111, '\p{^Is_Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73111, '\P{Is_Indic_Syllabic_Category=visarga}', "");
    Expect(0, 73111, '\P{^Is_Indic_Syllabic_Category=visarga}', "");
    Expect(1, 73110, '\p{Is_Indic_Syllabic_Category=-_Visarga}', "");
    Expect(0, 73110, '\p{^Is_Indic_Syllabic_Category=-_Visarga}', "");
    Expect(0, 73110, '\P{Is_Indic_Syllabic_Category=-_Visarga}', "");
    Expect(1, 73110, '\P{^Is_Indic_Syllabic_Category=-_Visarga}', "");
    Expect(0, 73111, '\p{Is_Indic_Syllabic_Category=-_Visarga}', "");
    Expect(1, 73111, '\p{^Is_Indic_Syllabic_Category=-_Visarga}', "");
    Expect(1, 73111, '\P{Is_Indic_Syllabic_Category=-_Visarga}', "");
    Expect(0, 73111, '\P{^Is_Indic_Syllabic_Category=-_Visarga}', "");
    Error('\p{Is_InSC= 	visarga:=}');
    Error('\P{Is_InSC= 	visarga:=}');
    Expect(1, 73110, '\p{Is_InSC=visarga}', "");
    Expect(0, 73110, '\p{^Is_InSC=visarga}', "");
    Expect(0, 73110, '\P{Is_InSC=visarga}', "");
    Expect(1, 73110, '\P{^Is_InSC=visarga}', "");
    Expect(0, 73111, '\p{Is_InSC=visarga}', "");
    Expect(1, 73111, '\p{^Is_InSC=visarga}', "");
    Expect(1, 73111, '\P{Is_InSC=visarga}', "");
    Expect(0, 73111, '\P{^Is_InSC=visarga}', "");
    Expect(1, 73110, '\p{Is_InSC=--Visarga}', "");
    Expect(0, 73110, '\p{^Is_InSC=--Visarga}', "");
    Expect(0, 73110, '\P{Is_InSC=--Visarga}', "");
    Expect(1, 73110, '\P{^Is_InSC=--Visarga}', "");
    Expect(0, 73111, '\p{Is_InSC=--Visarga}', "");
    Expect(1, 73111, '\p{^Is_InSC=--Visarga}', "");
    Expect(1, 73111, '\P{Is_InSC=--Visarga}', "");
    Expect(0, 73111, '\P{^Is_InSC=--Visarga}', "");
    Error('\p{Indic_Syllabic_Category:	-	Vowel/a/}');
    Error('\P{Indic_Syllabic_Category:	-	Vowel/a/}');
    Expect(1, 69972, '\p{Indic_Syllabic_Category=:\AVowel\z:}', "");;
    Expect(0, 69973, '\p{Indic_Syllabic_Category=:\AVowel\z:}', "");;
    Expect(1, 69972, '\p{Indic_Syllabic_Category=vowel}', "");
    Expect(0, 69972, '\p{^Indic_Syllabic_Category=vowel}', "");
    Expect(0, 69972, '\P{Indic_Syllabic_Category=vowel}', "");
    Expect(1, 69972, '\P{^Indic_Syllabic_Category=vowel}', "");
    Expect(0, 69973, '\p{Indic_Syllabic_Category=vowel}', "");
    Expect(1, 69973, '\p{^Indic_Syllabic_Category=vowel}', "");
    Expect(1, 69973, '\P{Indic_Syllabic_Category=vowel}', "");
    Expect(0, 69973, '\P{^Indic_Syllabic_Category=vowel}', "");
    Expect(1, 69972, '\p{Indic_Syllabic_Category=:\Avowel\z:}', "");;
    Expect(0, 69973, '\p{Indic_Syllabic_Category=:\Avowel\z:}', "");;
    Expect(1, 69972, '\p{Indic_Syllabic_Category:	VOWEL}', "");
    Expect(0, 69972, '\p{^Indic_Syllabic_Category:	VOWEL}', "");
    Expect(0, 69972, '\P{Indic_Syllabic_Category:	VOWEL}', "");
    Expect(1, 69972, '\P{^Indic_Syllabic_Category:	VOWEL}', "");
    Expect(0, 69973, '\p{Indic_Syllabic_Category:	VOWEL}', "");
    Expect(1, 69973, '\p{^Indic_Syllabic_Category:	VOWEL}', "");
    Expect(1, 69973, '\P{Indic_Syllabic_Category:	VOWEL}', "");
    Expect(0, 69973, '\P{^Indic_Syllabic_Category:	VOWEL}', "");
    Error('\p{InSC= :=VOWEL}');
    Error('\P{InSC= :=VOWEL}');
    Expect(1, 69972, '\p{InSC=:\AVowel\z:}', "");;
    Expect(0, 69973, '\p{InSC=:\AVowel\z:}', "");;
    Expect(1, 69972, '\p{InSC=vowel}', "");
    Expect(0, 69972, '\p{^InSC=vowel}', "");
    Expect(0, 69972, '\P{InSC=vowel}', "");
    Expect(1, 69972, '\P{^InSC=vowel}', "");
    Expect(0, 69973, '\p{InSC=vowel}', "");
    Expect(1, 69973, '\p{^InSC=vowel}', "");
    Expect(1, 69973, '\P{InSC=vowel}', "");
    Expect(0, 69973, '\P{^InSC=vowel}', "");
    Expect(1, 69972, '\p{InSC=:\Avowel\z:}', "");;
    Expect(0, 69973, '\p{InSC=:\Avowel\z:}', "");;
    Expect(1, 69972, '\p{InSC= _VOWEL}', "");
    Expect(0, 69972, '\p{^InSC= _VOWEL}', "");
    Expect(0, 69972, '\P{InSC= _VOWEL}', "");
    Expect(1, 69972, '\P{^InSC= _VOWEL}', "");
    Expect(0, 69973, '\p{InSC= _VOWEL}', "");
    Expect(1, 69973, '\p{^InSC= _VOWEL}', "");
    Expect(1, 69973, '\P{InSC= _VOWEL}', "");
    Expect(0, 69973, '\P{^InSC= _VOWEL}', "");
    Error('\p{Is_Indic_Syllabic_Category= _vowel/a/}');
    Error('\P{Is_Indic_Syllabic_Category= _vowel/a/}');
    Expect(1, 69972, '\p{Is_Indic_Syllabic_Category:   vowel}', "");
    Expect(0, 69972, '\p{^Is_Indic_Syllabic_Category:   vowel}', "");
    Expect(0, 69972, '\P{Is_Indic_Syllabic_Category:   vowel}', "");
    Expect(1, 69972, '\P{^Is_Indic_Syllabic_Category:   vowel}', "");
    Expect(0, 69973, '\p{Is_Indic_Syllabic_Category:   vowel}', "");
    Expect(1, 69973, '\p{^Is_Indic_Syllabic_Category:   vowel}', "");
    Expect(1, 69973, '\P{Is_Indic_Syllabic_Category:   vowel}', "");
    Expect(0, 69973, '\P{^Is_Indic_Syllabic_Category:   vowel}', "");
    Expect(1, 69972, '\p{Is_Indic_Syllabic_Category= -VOWEL}', "");
    Expect(0, 69972, '\p{^Is_Indic_Syllabic_Category= -VOWEL}', "");
    Expect(0, 69972, '\P{Is_Indic_Syllabic_Category= -VOWEL}', "");
    Expect(1, 69972, '\P{^Is_Indic_Syllabic_Category= -VOWEL}', "");
    Expect(0, 69973, '\p{Is_Indic_Syllabic_Category= -VOWEL}', "");
    Expect(1, 69973, '\p{^Is_Indic_Syllabic_Category= -VOWEL}', "");
    Expect(1, 69973, '\P{Is_Indic_Syllabic_Category= -VOWEL}', "");
    Expect(0, 69973, '\P{^Is_Indic_Syllabic_Category= -VOWEL}', "");
    Error('\p{Is_InSC=-	vowel:=}');
    Error('\P{Is_InSC=-	vowel:=}');
    Expect(1, 69972, '\p{Is_InSC:	vowel}', "");
    Expect(0, 69972, '\p{^Is_InSC:	vowel}', "");
    Expect(0, 69972, '\P{Is_InSC:	vowel}', "");
    Expect(1, 69972, '\P{^Is_InSC:	vowel}', "");
    Expect(0, 69973, '\p{Is_InSC:	vowel}', "");
    Expect(1, 69973, '\p{^Is_InSC:	vowel}', "");
    Expect(1, 69973, '\P{Is_InSC:	vowel}', "");
    Expect(0, 69973, '\P{^Is_InSC:	vowel}', "");
    Expect(1, 69972, '\p{Is_InSC=__Vowel}', "");
    Expect(0, 69972, '\p{^Is_InSC=__Vowel}', "");
    Expect(0, 69972, '\P{Is_InSC=__Vowel}', "");
    Expect(1, 69972, '\P{^Is_InSC=__Vowel}', "");
    Expect(0, 69973, '\p{Is_InSC=__Vowel}', "");
    Expect(1, 69973, '\p{^Is_InSC=__Vowel}', "");
    Expect(1, 69973, '\P{Is_InSC=__Vowel}', "");
    Expect(0, 69973, '\P{^Is_InSC=__Vowel}', "");
    Error('\p{Indic_Syllabic_Category=:= Vowel_Dependent}');
    Error('\P{Indic_Syllabic_Category=:= Vowel_Dependent}');
    Expect(1, 73462, '\p{Indic_Syllabic_Category=:\AVowel_Dependent\z:}', "");;
    Expect(0, 73463, '\p{Indic_Syllabic_Category=:\AVowel_Dependent\z:}', "");;
    Expect(1, 73462, '\p{Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73462, '\p{^Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73462, '\P{Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73462, '\P{^Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73463, '\p{Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73463, '\p{^Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73463, '\P{Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73463, '\P{^Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73462, '\p{Indic_Syllabic_Category=:\Avoweldependent\z:}', "");;
    Expect(0, 73463, '\p{Indic_Syllabic_Category=:\Avoweldependent\z:}', "");;
    Expect(1, 73462, '\p{Indic_Syllabic_Category=_ VOWEL_dependent}', "");
    Expect(0, 73462, '\p{^Indic_Syllabic_Category=_ VOWEL_dependent}', "");
    Expect(0, 73462, '\P{Indic_Syllabic_Category=_ VOWEL_dependent}', "");
    Expect(1, 73462, '\P{^Indic_Syllabic_Category=_ VOWEL_dependent}', "");
    Expect(0, 73463, '\p{Indic_Syllabic_Category=_ VOWEL_dependent}', "");
    Expect(1, 73463, '\p{^Indic_Syllabic_Category=_ VOWEL_dependent}', "");
    Expect(1, 73463, '\P{Indic_Syllabic_Category=_ VOWEL_dependent}', "");
    Expect(0, 73463, '\P{^Indic_Syllabic_Category=_ VOWEL_dependent}', "");
    Error('\p{InSC= _Vowel_Dependent:=}');
    Error('\P{InSC= _Vowel_Dependent:=}');
    Expect(1, 73462, '\p{InSC=:\AVowel_Dependent\z:}', "");;
    Expect(0, 73463, '\p{InSC=:\AVowel_Dependent\z:}', "");;
    Expect(1, 73462, '\p{InSC=voweldependent}', "");
    Expect(0, 73462, '\p{^InSC=voweldependent}', "");
    Expect(0, 73462, '\P{InSC=voweldependent}', "");
    Expect(1, 73462, '\P{^InSC=voweldependent}', "");
    Expect(0, 73463, '\p{InSC=voweldependent}', "");
    Expect(1, 73463, '\p{^InSC=voweldependent}', "");
    Expect(1, 73463, '\P{InSC=voweldependent}', "");
    Expect(0, 73463, '\P{^InSC=voweldependent}', "");
    Expect(1, 73462, '\p{InSC=:\Avoweldependent\z:}', "");;
    Expect(0, 73463, '\p{InSC=:\Avoweldependent\z:}', "");;
    Expect(1, 73462, '\p{InSC:_ Vowel_Dependent}', "");
    Expect(0, 73462, '\p{^InSC:_ Vowel_Dependent}', "");
    Expect(0, 73462, '\P{InSC:_ Vowel_Dependent}', "");
    Expect(1, 73462, '\P{^InSC:_ Vowel_Dependent}', "");
    Expect(0, 73463, '\p{InSC:_ Vowel_Dependent}', "");
    Expect(1, 73463, '\p{^InSC:_ Vowel_Dependent}', "");
    Expect(1, 73463, '\P{InSC:_ Vowel_Dependent}', "");
    Expect(0, 73463, '\P{^InSC:_ Vowel_Dependent}', "");
    Error('\p{Is_Indic_Syllabic_Category=VOWEL_Dependent:=}');
    Error('\P{Is_Indic_Syllabic_Category=VOWEL_Dependent:=}');
    Expect(1, 73462, '\p{Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73462, '\p{^Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73462, '\P{Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73462, '\P{^Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73463, '\p{Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73463, '\p{^Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73463, '\P{Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(0, 73463, '\P{^Is_Indic_Syllabic_Category=voweldependent}', "");
    Expect(1, 73462, '\p{Is_Indic_Syllabic_Category=- VOWEL_DEPENDENT}', "");
    Expect(0, 73462, '\p{^Is_Indic_Syllabic_Category=- VOWEL_DEPENDENT}', "");
    Expect(0, 73462, '\P{Is_Indic_Syllabic_Category=- VOWEL_DEPENDENT}', "");
    Expect(1, 73462, '\P{^Is_Indic_Syllabic_Category=- VOWEL_DEPENDENT}', "");
    Expect(0, 73463, '\p{Is_Indic_Syllabic_Category=- VOWEL_DEPENDENT}', "");
    Expect(1, 73463, '\p{^Is_Indic_Syllabic_Category=- VOWEL_DEPENDENT}', "");
    Expect(1, 73463, '\P{Is_Indic_Syllabic_Category=- VOWEL_DEPENDENT}', "");
    Expect(0, 73463, '\P{^Is_Indic_Syllabic_Category=- VOWEL_DEPENDENT}', "");
    Error('\p{Is_InSC=:= Vowel_DEPENDENT}');
    Error('\P{Is_InSC=:= Vowel_DEPENDENT}');
    Expect(1, 73462, '\p{Is_InSC=voweldependent}', "");
    Expect(0, 73462, '\p{^Is_InSC=voweldependent}', "");
    Expect(0, 73462, '\P{Is_InSC=voweldependent}', "");
    Expect(1, 73462, '\P{^Is_InSC=voweldependent}', "");
    Expect(0, 73463, '\p{Is_InSC=voweldependent}', "");
    Expect(1, 73463, '\p{^Is_InSC=voweldependent}', "");
    Expect(1, 73463, '\P{Is_InSC=voweldependent}', "");
    Expect(0, 73463, '\P{^Is_InSC=voweldependent}', "");
    Expect(1, 73462, '\p{Is_InSC=_ Vowel_dependent}', "");
    Expect(0, 73462, '\p{^Is_InSC=_ Vowel_dependent}', "");
    Expect(0, 73462, '\P{Is_InSC=_ Vowel_dependent}', "");
    Expect(1, 73462, '\P{^Is_InSC=_ Vowel_dependent}', "");
    Expect(0, 73463, '\p{Is_InSC=_ Vowel_dependent}', "");
    Expect(1, 73463, '\p{^Is_InSC=_ Vowel_dependent}', "");
    Expect(1, 73463, '\P{Is_InSC=_ Vowel_dependent}', "");
    Expect(0, 73463, '\P{^Is_InSC=_ Vowel_dependent}', "");
    Error('\p{Indic_Syllabic_Category=-/a/Vowel_Independent}');
    Error('\P{Indic_Syllabic_Category=-/a/Vowel_Independent}');
    Expect(1, 73067, '\p{Indic_Syllabic_Category=:\AVowel_Independent\z:}', "");;
    Expect(0, 73068, '\p{Indic_Syllabic_Category=:\AVowel_Independent\z:}', "");;
    Expect(1, 73067, '\p{Indic_Syllabic_Category=vowelindependent}', "");
    Expect(0, 73067, '\p{^Indic_Syllabic_Category=vowelindependent}', "");
    Expect(0, 73067, '\P{Indic_Syllabic_Category=vowelindependent}', "");
    Expect(1, 73067, '\P{^Indic_Syllabic_Category=vowelindependent}', "");
    Expect(0, 73068, '\p{Indic_Syllabic_Category=vowelindependent}', "");
    Expect(1, 73068, '\p{^Indic_Syllabic_Category=vowelindependent}', "");
    Expect(1, 73068, '\P{Indic_Syllabic_Category=vowelindependent}', "");
    Expect(0, 73068, '\P{^Indic_Syllabic_Category=vowelindependent}', "");
    Expect(1, 73067, '\p{Indic_Syllabic_Category=:\Avowelindependent\z:}', "");;
    Expect(0, 73068, '\p{Indic_Syllabic_Category=:\Avowelindependent\z:}', "");;
    Expect(1, 73067, '\p{Indic_Syllabic_Category: __Vowel_Independent}', "");
    Expect(0, 73067, '\p{^Indic_Syllabic_Category: __Vowel_Independent}', "");
    Expect(0, 73067, '\P{Indic_Syllabic_Category: __Vowel_Independent}', "");
    Expect(1, 73067, '\P{^Indic_Syllabic_Category: __Vowel_Independent}', "");
    Expect(0, 73068, '\p{Indic_Syllabic_Category: __Vowel_Independent}', "");
    Expect(1, 73068, '\p{^Indic_Syllabic_Category: __Vowel_Independent}', "");
    Expect(1, 73068, '\P{Indic_Syllabic_Category: __Vowel_Independent}', "");
    Expect(0, 73068, '\P{^Indic_Syllabic_Category: __Vowel_Independent}', "");
    Error('\p{InSC=_/a/Vowel_Independent}');
    Error('\P{InSC=_/a/Vowel_Independent}');
    Expect(1, 73067, '\p{InSC=:\AVowel_Independent\z:}', "");;
    Expect(0, 73068, '\p{InSC=:\AVowel_Independent\z:}', "");;
    Expect(1, 73067, '\p{InSC=vowelindependent}', "");
    Expect(0, 73067, '\p{^InSC=vowelindependent}', "");
    Expect(0, 73067, '\P{InSC=vowelindependent}', "");
    Expect(1, 73067, '\P{^InSC=vowelindependent}', "");
    Expect(0, 73068, '\p{InSC=vowelindependent}', "");
    Expect(1, 73068, '\p{^InSC=vowelindependent}', "");
    Expect(1, 73068, '\P{InSC=vowelindependent}', "");
    Expect(0, 73068, '\P{^InSC=vowelindependent}', "");
    Expect(1, 73067, '\p{InSC=:\Avowelindependent\z:}', "");;
    Expect(0, 73068, '\p{InSC=:\Avowelindependent\z:}', "");;
    Expect(1, 73067, '\p{InSC=_-VOWEL_independent}', "");
    Expect(0, 73067, '\p{^InSC=_-VOWEL_independent}', "");
    Expect(0, 73067, '\P{InSC=_-VOWEL_independent}', "");
    Expect(1, 73067, '\P{^InSC=_-VOWEL_independent}', "");
    Expect(0, 73068, '\p{InSC=_-VOWEL_independent}', "");
    Expect(1, 73068, '\p{^InSC=_-VOWEL_independent}', "");
    Expect(1, 73068, '\P{InSC=_-VOWEL_independent}', "");
    Expect(0, 73068, '\P{^InSC=_-VOWEL_independent}', "");
    Error('\p{Is_Indic_Syllabic_Category=_:=vowel_independent}');
    Error('\P{Is_Indic_Syllabic_Category=_:=vowel_independent}');
    Expect(1, 73067, '\p{Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(0, 73067, '\p{^Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(0, 73067, '\P{Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(1, 73067, '\P{^Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(0, 73068, '\p{Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(1, 73068, '\p{^Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(1, 73068, '\P{Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(0, 73068, '\P{^Is_Indic_Syllabic_Category=vowelindependent}', "");
    Expect(1, 73067, '\p{Is_Indic_Syllabic_Category:    Vowel_Independent}', "");
    Expect(0, 73067, '\p{^Is_Indic_Syllabic_Category:    Vowel_Independent}', "");
    Expect(0, 73067, '\P{Is_Indic_Syllabic_Category:    Vowel_Independent}', "");
    Expect(1, 73067, '\P{^Is_Indic_Syllabic_Category:    Vowel_Independent}', "");
    Expect(0, 73068, '\p{Is_Indic_Syllabic_Category:    Vowel_Independent}', "");
    Expect(1, 73068, '\p{^Is_Indic_Syllabic_Category:    Vowel_Independent}', "");
    Expect(1, 73068, '\P{Is_Indic_Syllabic_Category:    Vowel_Independent}', "");
    Expect(0, 73068, '\P{^Is_Indic_Syllabic_Category:    Vowel_Independent}', "");
    Error('\p{Is_InSC=		Vowel_independent/a/}');
    Error('\P{Is_InSC=		Vowel_independent/a/}');
    Expect(1, 73067, '\p{Is_InSC=vowelindependent}', "");
    Expect(0, 73067, '\p{^Is_InSC=vowelindependent}', "");
    Expect(0, 73067, '\P{Is_InSC=vowelindependent}', "");
    Expect(1, 73067, '\P{^Is_InSC=vowelindependent}', "");
    Expect(0, 73068, '\p{Is_InSC=vowelindependent}', "");
    Expect(1, 73068, '\p{^Is_InSC=vowelindependent}', "");
    Expect(1, 73068, '\P{Is_InSC=vowelindependent}', "");
    Expect(0, 73068, '\P{^Is_InSC=vowelindependent}', "");
    Expect(1, 73067, '\p{Is_InSC=--Vowel_Independent}', "");
    Expect(0, 73067, '\p{^Is_InSC=--Vowel_Independent}', "");
    Expect(0, 73067, '\P{Is_InSC=--Vowel_Independent}', "");
    Expect(1, 73067, '\P{^Is_InSC=--Vowel_Independent}', "");
    Expect(0, 73068, '\p{Is_InSC=--Vowel_Independent}', "");
    Expect(1, 73068, '\p{^Is_InSC=--Vowel_Independent}', "");
    Expect(1, 73068, '\P{Is_InSC=--Vowel_Independent}', "");
    Expect(0, 73068, '\P{^Is_InSC=--Vowel_Independent}', "");
    Error('\p{isocomment}');
    Error('\P{isocomment}');
    Error('\p{joininggroup}');
    Error('\P{joininggroup}');
    Error('\p{jg}');
    Error('\P{jg}');
    Error('\p{Joining_Group=/a/	african_FEH}');
    Error('\P{Joining_Group=/a/	african_FEH}');
    Expect(1, 2235, '\p{Joining_Group=:\AAfrican_Feh\z:}', "");;
    Expect(0, 2236, '\p{Joining_Group=:\AAfrican_Feh\z:}', "");;
    Expect(1, 2235, '\p{Joining_Group=africanfeh}', "");
    Expect(0, 2235, '\p{^Joining_Group=africanfeh}', "");
    Expect(0, 2235, '\P{Joining_Group=africanfeh}', "");
    Expect(1, 2235, '\P{^Joining_Group=africanfeh}', "");
    Expect(0, 2236, '\p{Joining_Group=africanfeh}', "");
    Expect(1, 2236, '\p{^Joining_Group=africanfeh}', "");
    Expect(1, 2236, '\P{Joining_Group=africanfeh}', "");
    Expect(0, 2236, '\P{^Joining_Group=africanfeh}', "");
    Expect(1, 2235, '\p{Joining_Group=:\Aafricanfeh\z:}', "");;
    Expect(0, 2236, '\p{Joining_Group=:\Aafricanfeh\z:}', "");;
    Expect(1, 2235, '\p{Joining_Group=--african_Feh}', "");
    Expect(0, 2235, '\p{^Joining_Group=--african_Feh}', "");
    Expect(0, 2235, '\P{Joining_Group=--african_Feh}', "");
    Expect(1, 2235, '\P{^Joining_Group=--african_Feh}', "");
    Expect(0, 2236, '\p{Joining_Group=--african_Feh}', "");
    Expect(1, 2236, '\p{^Joining_Group=--african_Feh}', "");
    Expect(1, 2236, '\P{Joining_Group=--african_Feh}', "");
    Expect(0, 2236, '\P{^Joining_Group=--african_Feh}', "");
    Error('\p{Jg=__African_feh/a/}');
    Error('\P{Jg=__African_feh/a/}');
    Expect(1, 2235, '\p{Jg=:\AAfrican_Feh\z:}', "");;
    Expect(0, 2236, '\p{Jg=:\AAfrican_Feh\z:}', "");;
    Expect(1, 2235, '\p{Jg=africanfeh}', "");
    Expect(0, 2235, '\p{^Jg=africanfeh}', "");
    Expect(0, 2235, '\P{Jg=africanfeh}', "");
    Expect(1, 2235, '\P{^Jg=africanfeh}', "");
    Expect(0, 2236, '\p{Jg=africanfeh}', "");
    Expect(1, 2236, '\p{^Jg=africanfeh}', "");
    Expect(1, 2236, '\P{Jg=africanfeh}', "");
    Expect(0, 2236, '\P{^Jg=africanfeh}', "");
    Expect(1, 2235, '\p{Jg=:\Aafricanfeh\z:}', "");;
    Expect(0, 2236, '\p{Jg=:\Aafricanfeh\z:}', "");;
    Expect(1, 2235, '\p{Jg=-african_FEH}', "");
    Expect(0, 2235, '\p{^Jg=-african_FEH}', "");
    Expect(0, 2235, '\P{Jg=-african_FEH}', "");
    Expect(1, 2235, '\P{^Jg=-african_FEH}', "");
    Expect(0, 2236, '\p{Jg=-african_FEH}', "");
    Expect(1, 2236, '\p{^Jg=-african_FEH}', "");
    Expect(1, 2236, '\P{Jg=-african_FEH}', "");
    Expect(0, 2236, '\P{^Jg=-african_FEH}', "");
    Error('\p{Is_Joining_Group=_	African_Feh:=}');
    Error('\P{Is_Joining_Group=_	African_Feh:=}');
    Expect(1, 2235, '\p{Is_Joining_Group=africanfeh}', "");
    Expect(0, 2235, '\p{^Is_Joining_Group=africanfeh}', "");
    Expect(0, 2235, '\P{Is_Joining_Group=africanfeh}', "");
    Expect(1, 2235, '\P{^Is_Joining_Group=africanfeh}', "");
    Expect(0, 2236, '\p{Is_Joining_Group=africanfeh}', "");
    Expect(1, 2236, '\p{^Is_Joining_Group=africanfeh}', "");
    Expect(1, 2236, '\P{Is_Joining_Group=africanfeh}', "");
    Expect(0, 2236, '\P{^Is_Joining_Group=africanfeh}', "");
    Expect(1, 2235, '\p{Is_Joining_Group: _african_FEH}', "");
    Expect(0, 2235, '\p{^Is_Joining_Group: _african_FEH}', "");
    Expect(0, 2235, '\P{Is_Joining_Group: _african_FEH}', "");
    Expect(1, 2235, '\P{^Is_Joining_Group: _african_FEH}', "");
    Expect(0, 2236, '\p{Is_Joining_Group: _african_FEH}', "");
    Expect(1, 2236, '\p{^Is_Joining_Group: _african_FEH}', "");
    Expect(1, 2236, '\P{Is_Joining_Group: _african_FEH}', "");
    Expect(0, 2236, '\P{^Is_Joining_Group: _african_FEH}', "");
    Error('\p{Is_Jg=	AFRICAN_Feh/a/}');
    Error('\P{Is_Jg=	AFRICAN_Feh/a/}');
    Expect(1, 2235, '\p{Is_Jg=africanfeh}', "");
    Expect(0, 2235, '\p{^Is_Jg=africanfeh}', "");
    Expect(0, 2235, '\P{Is_Jg=africanfeh}', "");
    Expect(1, 2235, '\P{^Is_Jg=africanfeh}', "");
    Expect(0, 2236, '\p{Is_Jg=africanfeh}', "");
    Expect(1, 2236, '\p{^Is_Jg=africanfeh}', "");
    Expect(1, 2236, '\P{Is_Jg=africanfeh}', "");
    Expect(0, 2236, '\P{^Is_Jg=africanfeh}', "");
    Expect(1, 2235, '\p{Is_Jg= _African_feh}', "");
    Expect(0, 2235, '\p{^Is_Jg= _African_feh}', "");
    Expect(0, 2235, '\P{Is_Jg= _African_feh}', "");
    Expect(1, 2235, '\P{^Is_Jg= _African_feh}', "");
    Expect(0, 2236, '\p{Is_Jg= _African_feh}', "");
    Expect(1, 2236, '\p{^Is_Jg= _African_feh}', "");
    Expect(1, 2236, '\P{Is_Jg= _African_feh}', "");
    Expect(0, 2236, '\P{^Is_Jg= _African_feh}', "");
    Error('\p{Joining_Group= /a/African_Noon}');
    Error('\P{Joining_Group= /a/African_Noon}');
    Expect(1, 2237, '\p{Joining_Group=:\AAfrican_Noon\z:}', "");;
    Expect(0, 2238, '\p{Joining_Group=:\AAfrican_Noon\z:}', "");;
    Expect(1, 2237, '\p{Joining_Group=africannoon}', "");
    Expect(0, 2237, '\p{^Joining_Group=africannoon}', "");
    Expect(0, 2237, '\P{Joining_Group=africannoon}', "");
    Expect(1, 2237, '\P{^Joining_Group=africannoon}', "");
    Expect(0, 2238, '\p{Joining_Group=africannoon}', "");
    Expect(1, 2238, '\p{^Joining_Group=africannoon}', "");
    Expect(1, 2238, '\P{Joining_Group=africannoon}', "");
    Expect(0, 2238, '\P{^Joining_Group=africannoon}', "");
    Expect(1, 2237, '\p{Joining_Group=:\Aafricannoon\z:}', "");;
    Expect(0, 2238, '\p{Joining_Group=:\Aafricannoon\z:}', "");;
    Expect(1, 2237, '\p{Joining_Group=  AFRICAN_noon}', "");
    Expect(0, 2237, '\p{^Joining_Group=  AFRICAN_noon}', "");
    Expect(0, 2237, '\P{Joining_Group=  AFRICAN_noon}', "");
    Expect(1, 2237, '\P{^Joining_Group=  AFRICAN_noon}', "");
    Expect(0, 2238, '\p{Joining_Group=  AFRICAN_noon}', "");
    Expect(1, 2238, '\p{^Joining_Group=  AFRICAN_noon}', "");
    Expect(1, 2238, '\P{Joining_Group=  AFRICAN_noon}', "");
    Expect(0, 2238, '\P{^Joining_Group=  AFRICAN_noon}', "");
    Error('\p{Jg=/a/-_AFRICAN_NOON}');
    Error('\P{Jg=/a/-_AFRICAN_NOON}');
    Expect(1, 2237, '\p{Jg=:\AAfrican_Noon\z:}', "");;
    Expect(0, 2238, '\p{Jg=:\AAfrican_Noon\z:}', "");;
    Expect(1, 2237, '\p{Jg=africannoon}', "");
    Expect(0, 2237, '\p{^Jg=africannoon}', "");
    Expect(0, 2237, '\P{Jg=africannoon}', "");
    Expect(1, 2237, '\P{^Jg=africannoon}', "");
    Expect(0, 2238, '\p{Jg=africannoon}', "");
    Expect(1, 2238, '\p{^Jg=africannoon}', "");
    Expect(1, 2238, '\P{Jg=africannoon}', "");
    Expect(0, 2238, '\P{^Jg=africannoon}', "");
    Expect(1, 2237, '\p{Jg=:\Aafricannoon\z:}', "");;
    Expect(0, 2238, '\p{Jg=:\Aafricannoon\z:}', "");;
    Expect(1, 2237, '\p{Jg=  african_noon}', "");
    Expect(0, 2237, '\p{^Jg=  african_noon}', "");
    Expect(0, 2237, '\P{Jg=  african_noon}', "");
    Expect(1, 2237, '\P{^Jg=  african_noon}', "");
    Expect(0, 2238, '\p{Jg=  african_noon}', "");
    Expect(1, 2238, '\p{^Jg=  african_noon}', "");
    Expect(1, 2238, '\P{Jg=  african_noon}', "");
    Expect(0, 2238, '\P{^Jg=  african_noon}', "");
    Error('\p{Is_Joining_Group=__african_Noon:=}');
    Error('\P{Is_Joining_Group=__african_Noon:=}');
    Expect(1, 2237, '\p{Is_Joining_Group=africannoon}', "");
    Expect(0, 2237, '\p{^Is_Joining_Group=africannoon}', "");
    Expect(0, 2237, '\P{Is_Joining_Group=africannoon}', "");
    Expect(1, 2237, '\P{^Is_Joining_Group=africannoon}', "");
    Expect(0, 2238, '\p{Is_Joining_Group=africannoon}', "");
    Expect(1, 2238, '\p{^Is_Joining_Group=africannoon}', "");
    Expect(1, 2238, '\P{Is_Joining_Group=africannoon}', "");
    Expect(0, 2238, '\P{^Is_Joining_Group=africannoon}', "");
    Expect(1, 2237, '\p{Is_Joining_Group:   - African_noon}', "");
    Expect(0, 2237, '\p{^Is_Joining_Group:   - African_noon}', "");
    Expect(0, 2237, '\P{Is_Joining_Group:   - African_noon}', "");
    Expect(1, 2237, '\P{^Is_Joining_Group:   - African_noon}', "");
    Expect(0, 2238, '\p{Is_Joining_Group:   - African_noon}', "");
    Expect(1, 2238, '\p{^Is_Joining_Group:   - African_noon}', "");
    Expect(1, 2238, '\P{Is_Joining_Group:   - African_noon}', "");
    Expect(0, 2238, '\P{^Is_Joining_Group:   - African_noon}', "");
    Error('\p{Is_Jg=_african_Noon:=}');
    Error('\P{Is_Jg=_african_Noon:=}');
    Expect(1, 2237, '\p{Is_Jg=africannoon}', "");
    Expect(0, 2237, '\p{^Is_Jg=africannoon}', "");
    Expect(0, 2237, '\P{Is_Jg=africannoon}', "");
    Expect(1, 2237, '\P{^Is_Jg=africannoon}', "");
    Expect(0, 2238, '\p{Is_Jg=africannoon}', "");
    Expect(1, 2238, '\p{^Is_Jg=africannoon}', "");
    Expect(1, 2238, '\P{Is_Jg=africannoon}', "");
    Expect(0, 2238, '\P{^Is_Jg=africannoon}', "");
    Expect(1, 2237, '\p{Is_Jg= -african_noon}', "");
    Expect(0, 2237, '\p{^Is_Jg= -african_noon}', "");
    Expect(0, 2237, '\P{Is_Jg= -african_noon}', "");
    Expect(1, 2237, '\P{^Is_Jg= -african_noon}', "");
    Expect(0, 2238, '\p{Is_Jg= -african_noon}', "");
    Expect(1, 2238, '\p{^Is_Jg= -african_noon}', "");
    Expect(1, 2238, '\P{Is_Jg= -african_noon}', "");
    Expect(0, 2238, '\P{^Is_Jg= -african_noon}', "");
    Error('\p{Joining_Group=_:=African_Qaf}');
    Error('\P{Joining_Group=_:=African_Qaf}');
    Expect(1, 2236, '\p{Joining_Group=:\AAfrican_Qaf\z:}', "");;
    Expect(0, 2237, '\p{Joining_Group=:\AAfrican_Qaf\z:}', "");;
    Expect(1, 2236, '\p{Joining_Group=africanqaf}', "");
    Expect(0, 2236, '\p{^Joining_Group=africanqaf}', "");
    Expect(0, 2236, '\P{Joining_Group=africanqaf}', "");
    Expect(1, 2236, '\P{^Joining_Group=africanqaf}', "");
    Expect(0, 2237, '\p{Joining_Group=africanqaf}', "");
    Expect(1, 2237, '\p{^Joining_Group=africanqaf}', "");
    Expect(1, 2237, '\P{Joining_Group=africanqaf}', "");
    Expect(0, 2237, '\P{^Joining_Group=africanqaf}', "");
    Expect(1, 2236, '\p{Joining_Group=:\Aafricanqaf\z:}', "");;
    Expect(0, 2237, '\p{Joining_Group=:\Aafricanqaf\z:}', "");;
    Expect(1, 2236, '\p{Joining_Group=	 african_qaf}', "");
    Expect(0, 2236, '\p{^Joining_Group=	 african_qaf}', "");
    Expect(0, 2236, '\P{Joining_Group=	 african_qaf}', "");
    Expect(1, 2236, '\P{^Joining_Group=	 african_qaf}', "");
    Expect(0, 2237, '\p{Joining_Group=	 african_qaf}', "");
    Expect(1, 2237, '\p{^Joining_Group=	 african_qaf}', "");
    Expect(1, 2237, '\P{Joining_Group=	 african_qaf}', "");
    Expect(0, 2237, '\P{^Joining_Group=	 african_qaf}', "");
    Error('\p{Jg=/a/_-AFRICAN_qaf}');
    Error('\P{Jg=/a/_-AFRICAN_qaf}');
    Expect(1, 2236, '\p{Jg=:\AAfrican_Qaf\z:}', "");;
    Expect(0, 2237, '\p{Jg=:\AAfrican_Qaf\z:}', "");;
    Expect(1, 2236, '\p{Jg=africanqaf}', "");
    Expect(0, 2236, '\p{^Jg=africanqaf}', "");
    Expect(0, 2236, '\P{Jg=africanqaf}', "");
    Expect(1, 2236, '\P{^Jg=africanqaf}', "");
    Expect(0, 2237, '\p{Jg=africanqaf}', "");
    Expect(1, 2237, '\p{^Jg=africanqaf}', "");
    Expect(1, 2237, '\P{Jg=africanqaf}', "");
    Expect(0, 2237, '\P{^Jg=africanqaf}', "");
    Expect(1, 2236, '\p{Jg=:\Aafricanqaf\z:}', "");;
    Expect(0, 2237, '\p{Jg=:\Aafricanqaf\z:}', "");;
    Expect(1, 2236, '\p{Jg=	 African_Qaf}', "");
    Expect(0, 2236, '\p{^Jg=	 African_Qaf}', "");
    Expect(0, 2236, '\P{Jg=	 African_Qaf}', "");
    Expect(1, 2236, '\P{^Jg=	 African_Qaf}', "");
    Expect(0, 2237, '\p{Jg=	 African_Qaf}', "");
    Expect(1, 2237, '\p{^Jg=	 African_Qaf}', "");
    Expect(1, 2237, '\P{Jg=	 African_Qaf}', "");
    Expect(0, 2237, '\P{^Jg=	 African_Qaf}', "");
    Error('\p{Is_Joining_Group=-_AFRICAN_Qaf/a/}');
    Error('\P{Is_Joining_Group=-_AFRICAN_Qaf/a/}');
    Expect(1, 2236, '\p{Is_Joining_Group=africanqaf}', "");
    Expect(0, 2236, '\p{^Is_Joining_Group=africanqaf}', "");
    Expect(0, 2236, '\P{Is_Joining_Group=africanqaf}', "");
    Expect(1, 2236, '\P{^Is_Joining_Group=africanqaf}', "");
    Expect(0, 2237, '\p{Is_Joining_Group=africanqaf}', "");
    Expect(1, 2237, '\p{^Is_Joining_Group=africanqaf}', "");
    Expect(1, 2237, '\P{Is_Joining_Group=africanqaf}', "");
    Expect(0, 2237, '\P{^Is_Joining_Group=africanqaf}', "");
    Expect(1, 2236, '\p{Is_Joining_Group=  african_Qaf}', "");
    Expect(0, 2236, '\p{^Is_Joining_Group=  african_Qaf}', "");
    Expect(0, 2236, '\P{Is_Joining_Group=  african_Qaf}', "");
    Expect(1, 2236, '\P{^Is_Joining_Group=  african_Qaf}', "");
    Expect(0, 2237, '\p{Is_Joining_Group=  african_Qaf}', "");
    Expect(1, 2237, '\p{^Is_Joining_Group=  african_Qaf}', "");
    Expect(1, 2237, '\P{Is_Joining_Group=  african_Qaf}', "");
    Expect(0, 2237, '\P{^Is_Joining_Group=  african_Qaf}', "");
    Error('\p{Is_Jg=	 african_Qaf:=}');
    Error('\P{Is_Jg=	 african_Qaf:=}');
    Expect(1, 2236, '\p{Is_Jg=africanqaf}', "");
    Expect(0, 2236, '\p{^Is_Jg=africanqaf}', "");
    Expect(0, 2236, '\P{Is_Jg=africanqaf}', "");
    Expect(1, 2236, '\P{^Is_Jg=africanqaf}', "");
    Expect(0, 2237, '\p{Is_Jg=africanqaf}', "");
    Expect(1, 2237, '\p{^Is_Jg=africanqaf}', "");
    Expect(1, 2237, '\P{Is_Jg=africanqaf}', "");
    Expect(0, 2237, '\P{^Is_Jg=africanqaf}', "");
    Expect(1, 2236, '\p{Is_Jg=	AFRICAN_qaf}', "");
    Expect(0, 2236, '\p{^Is_Jg=	AFRICAN_qaf}', "");
    Expect(0, 2236, '\P{Is_Jg=	AFRICAN_qaf}', "");
    Expect(1, 2236, '\P{^Is_Jg=	AFRICAN_qaf}', "");
    Expect(0, 2237, '\p{Is_Jg=	AFRICAN_qaf}', "");
    Expect(1, 2237, '\p{^Is_Jg=	AFRICAN_qaf}', "");
    Expect(1, 2237, '\P{Is_Jg=	AFRICAN_qaf}', "");
    Expect(0, 2237, '\P{^Is_Jg=	AFRICAN_qaf}', "");
    Error('\p{Joining_Group=:=ain}');
    Error('\P{Joining_Group=:=ain}');
    Expect(1, 2227, '\p{Joining_Group=:\AAin\z:}', "");;
    Expect(0, 2228, '\p{Joining_Group=:\AAin\z:}', "");;
    Expect(1, 2227, '\p{Joining_Group:   ain}', "");
    Expect(0, 2227, '\p{^Joining_Group:   ain}', "");
    Expect(0, 2227, '\P{Joining_Group:   ain}', "");
    Expect(1, 2227, '\P{^Joining_Group:   ain}', "");
    Expect(0, 2228, '\p{Joining_Group:   ain}', "");
    Expect(1, 2228, '\p{^Joining_Group:   ain}', "");
    Expect(1, 2228, '\P{Joining_Group:   ain}', "");
    Expect(0, 2228, '\P{^Joining_Group:   ain}', "");
    Expect(1, 2227, '\p{Joining_Group=:\Aain\z:}', "");;
    Expect(0, 2228, '\p{Joining_Group=:\Aain\z:}', "");;
    Expect(1, 2227, '\p{Joining_Group:	 ain}', "");
    Expect(0, 2227, '\p{^Joining_Group:	 ain}', "");
    Expect(0, 2227, '\P{Joining_Group:	 ain}', "");
    Expect(1, 2227, '\P{^Joining_Group:	 ain}', "");
    Expect(0, 2228, '\p{Joining_Group:	 ain}', "");
    Expect(1, 2228, '\p{^Joining_Group:	 ain}', "");
    Expect(1, 2228, '\P{Joining_Group:	 ain}', "");
    Expect(0, 2228, '\P{^Joining_Group:	 ain}', "");
    Error('\p{Jg=/a/ 	Ain}');
    Error('\P{Jg=/a/ 	Ain}');
    Expect(1, 2227, '\p{Jg=:\AAin\z:}', "");;
    Expect(0, 2228, '\p{Jg=:\AAin\z:}', "");;
    Expect(1, 2227, '\p{Jg: ain}', "");
    Expect(0, 2227, '\p{^Jg: ain}', "");
    Expect(0, 2227, '\P{Jg: ain}', "");
    Expect(1, 2227, '\P{^Jg: ain}', "");
    Expect(0, 2228, '\p{Jg: ain}', "");
    Expect(1, 2228, '\p{^Jg: ain}', "");
    Expect(1, 2228, '\P{Jg: ain}', "");
    Expect(0, 2228, '\P{^Jg: ain}', "");
    Expect(1, 2227, '\p{Jg=:\Aain\z:}', "");;
    Expect(0, 2228, '\p{Jg=:\Aain\z:}', "");;
    Expect(1, 2227, '\p{Jg:	- AIN}', "");
    Expect(0, 2227, '\p{^Jg:	- AIN}', "");
    Expect(0, 2227, '\P{Jg:	- AIN}', "");
    Expect(1, 2227, '\P{^Jg:	- AIN}', "");
    Expect(0, 2228, '\p{Jg:	- AIN}', "");
    Expect(1, 2228, '\p{^Jg:	- AIN}', "");
    Expect(1, 2228, '\P{Jg:	- AIN}', "");
    Expect(0, 2228, '\P{^Jg:	- AIN}', "");
    Error('\p{Is_Joining_Group=:=_	ain}');
    Error('\P{Is_Joining_Group=:=_	ain}');
    Expect(1, 2227, '\p{Is_Joining_Group=ain}', "");
    Expect(0, 2227, '\p{^Is_Joining_Group=ain}', "");
    Expect(0, 2227, '\P{Is_Joining_Group=ain}', "");
    Expect(1, 2227, '\P{^Is_Joining_Group=ain}', "");
    Expect(0, 2228, '\p{Is_Joining_Group=ain}', "");
    Expect(1, 2228, '\p{^Is_Joining_Group=ain}', "");
    Expect(1, 2228, '\P{Is_Joining_Group=ain}', "");
    Expect(0, 2228, '\P{^Is_Joining_Group=ain}', "");
    Expect(1, 2227, '\p{Is_Joining_Group:	 	Ain}', "");
    Expect(0, 2227, '\p{^Is_Joining_Group:	 	Ain}', "");
    Expect(0, 2227, '\P{Is_Joining_Group:	 	Ain}', "");
    Expect(1, 2227, '\P{^Is_Joining_Group:	 	Ain}', "");
    Expect(0, 2228, '\p{Is_Joining_Group:	 	Ain}', "");
    Expect(1, 2228, '\p{^Is_Joining_Group:	 	Ain}', "");
    Expect(1, 2228, '\P{Is_Joining_Group:	 	Ain}', "");
    Expect(0, 2228, '\P{^Is_Joining_Group:	 	Ain}', "");
    Error('\p{Is_Jg=:=--Ain}');
    Error('\P{Is_Jg=:=--Ain}');
    Expect(1, 2227, '\p{Is_Jg:	ain}', "");
    Expect(0, 2227, '\p{^Is_Jg:	ain}', "");
    Expect(0, 2227, '\P{Is_Jg:	ain}', "");
    Expect(1, 2227, '\P{^Is_Jg:	ain}', "");
    Expect(0, 2228, '\p{Is_Jg:	ain}', "");
    Expect(1, 2228, '\p{^Is_Jg:	ain}', "");
    Expect(1, 2228, '\P{Is_Jg:	ain}', "");
    Expect(0, 2228, '\P{^Is_Jg:	ain}', "");
    Expect(1, 2227, '\p{Is_Jg=-	Ain}', "");
    Expect(0, 2227, '\p{^Is_Jg=-	Ain}', "");
    Expect(0, 2227, '\P{Is_Jg=-	Ain}', "");
    Expect(1, 2227, '\P{^Is_Jg=-	Ain}', "");
    Expect(0, 2228, '\p{Is_Jg=-	Ain}', "");
    Expect(1, 2228, '\p{^Is_Jg=-	Ain}', "");
    Expect(1, 2228, '\P{Is_Jg=-	Ain}', "");
    Expect(0, 2228, '\P{^Is_Jg=-	Ain}', "");
    Error('\p{Joining_Group=:=_	Alaph}');
    Error('\P{Joining_Group=:=_	Alaph}');
    Expect(1, 1808, '\p{Joining_Group=:\AAlaph\z:}', "");;
    Expect(0, 1809, '\p{Joining_Group=:\AAlaph\z:}', "");;
    Expect(1, 1808, '\p{Joining_Group: alaph}', "");
    Expect(0, 1808, '\p{^Joining_Group: alaph}', "");
    Expect(0, 1808, '\P{Joining_Group: alaph}', "");
    Expect(1, 1808, '\P{^Joining_Group: alaph}', "");
    Expect(0, 1809, '\p{Joining_Group: alaph}', "");
    Expect(1, 1809, '\p{^Joining_Group: alaph}', "");
    Expect(1, 1809, '\P{Joining_Group: alaph}', "");
    Expect(0, 1809, '\P{^Joining_Group: alaph}', "");
    Expect(1, 1808, '\p{Joining_Group=:\Aalaph\z:}', "");;
    Expect(0, 1809, '\p{Joining_Group=:\Aalaph\z:}', "");;
    Expect(1, 1808, '\p{Joining_Group= Alaph}', "");
    Expect(0, 1808, '\p{^Joining_Group= Alaph}', "");
    Expect(0, 1808, '\P{Joining_Group= Alaph}', "");
    Expect(1, 1808, '\P{^Joining_Group= Alaph}', "");
    Expect(0, 1809, '\p{Joining_Group= Alaph}', "");
    Expect(1, 1809, '\p{^Joining_Group= Alaph}', "");
    Expect(1, 1809, '\P{Joining_Group= Alaph}', "");
    Expect(0, 1809, '\P{^Joining_Group= Alaph}', "");
    Error('\p{Jg=:=-alaph}');
    Error('\P{Jg=:=-alaph}');
    Expect(1, 1808, '\p{Jg=:\AAlaph\z:}', "");;
    Expect(0, 1809, '\p{Jg=:\AAlaph\z:}', "");;
    Expect(1, 1808, '\p{Jg=alaph}', "");
    Expect(0, 1808, '\p{^Jg=alaph}', "");
    Expect(0, 1808, '\P{Jg=alaph}', "");
    Expect(1, 1808, '\P{^Jg=alaph}', "");
    Expect(0, 1809, '\p{Jg=alaph}', "");
    Expect(1, 1809, '\p{^Jg=alaph}', "");
    Expect(1, 1809, '\P{Jg=alaph}', "");
    Expect(0, 1809, '\P{^Jg=alaph}', "");
    Expect(1, 1808, '\p{Jg=:\Aalaph\z:}', "");;
    Expect(0, 1809, '\p{Jg=:\Aalaph\z:}', "");;
    Expect(1, 1808, '\p{Jg=	-ALAPH}', "");
    Expect(0, 1808, '\p{^Jg=	-ALAPH}', "");
    Expect(0, 1808, '\P{Jg=	-ALAPH}', "");
    Expect(1, 1808, '\P{^Jg=	-ALAPH}', "");
    Expect(0, 1809, '\p{Jg=	-ALAPH}', "");
    Expect(1, 1809, '\p{^Jg=	-ALAPH}', "");
    Expect(1, 1809, '\P{Jg=	-ALAPH}', "");
    Expect(0, 1809, '\P{^Jg=	-ALAPH}', "");
    Error('\p{Is_Joining_Group:   /a/-	ALAPH}');
    Error('\P{Is_Joining_Group:   /a/-	ALAPH}');
    Expect(1, 1808, '\p{Is_Joining_Group=alaph}', "");
    Expect(0, 1808, '\p{^Is_Joining_Group=alaph}', "");
    Expect(0, 1808, '\P{Is_Joining_Group=alaph}', "");
    Expect(1, 1808, '\P{^Is_Joining_Group=alaph}', "");
    Expect(0, 1809, '\p{Is_Joining_Group=alaph}', "");
    Expect(1, 1809, '\p{^Is_Joining_Group=alaph}', "");
    Expect(1, 1809, '\P{Is_Joining_Group=alaph}', "");
    Expect(0, 1809, '\P{^Is_Joining_Group=alaph}', "");
    Expect(1, 1808, '\p{Is_Joining_Group=--Alaph}', "");
    Expect(0, 1808, '\p{^Is_Joining_Group=--Alaph}', "");
    Expect(0, 1808, '\P{Is_Joining_Group=--Alaph}', "");
    Expect(1, 1808, '\P{^Is_Joining_Group=--Alaph}', "");
    Expect(0, 1809, '\p{Is_Joining_Group=--Alaph}', "");
    Expect(1, 1809, '\p{^Is_Joining_Group=--Alaph}', "");
    Expect(1, 1809, '\P{Is_Joining_Group=--Alaph}', "");
    Expect(0, 1809, '\P{^Is_Joining_Group=--Alaph}', "");
    Error('\p{Is_Jg=-:=alaph}');
    Error('\P{Is_Jg=-:=alaph}');
    Expect(1, 1808, '\p{Is_Jg=alaph}', "");
    Expect(0, 1808, '\p{^Is_Jg=alaph}', "");
    Expect(0, 1808, '\P{Is_Jg=alaph}', "");
    Expect(1, 1808, '\P{^Is_Jg=alaph}', "");
    Expect(0, 1809, '\p{Is_Jg=alaph}', "");
    Expect(1, 1809, '\p{^Is_Jg=alaph}', "");
    Expect(1, 1809, '\P{Is_Jg=alaph}', "");
    Expect(0, 1809, '\P{^Is_Jg=alaph}', "");
    Expect(1, 1808, '\p{Is_Jg=Alaph}', "");
    Expect(0, 1808, '\p{^Is_Jg=Alaph}', "");
    Expect(0, 1808, '\P{Is_Jg=Alaph}', "");
    Expect(1, 1808, '\P{^Is_Jg=Alaph}', "");
    Expect(0, 1809, '\p{Is_Jg=Alaph}', "");
    Expect(1, 1809, '\p{^Is_Jg=Alaph}', "");
    Expect(1, 1809, '\P{Is_Jg=Alaph}', "");
    Expect(0, 1809, '\P{^Is_Jg=Alaph}', "");
    Error('\p{Joining_Group= Alef:=}');
    Error('\P{Joining_Group= Alef:=}');
    Expect(1, 1908, '\p{Joining_Group=:\AAlef\z:}', "");;
    Expect(0, 1909, '\p{Joining_Group=:\AAlef\z:}', "");;
    Expect(1, 1908, '\p{Joining_Group:   alef}', "");
    Expect(0, 1908, '\p{^Joining_Group:   alef}', "");
    Expect(0, 1908, '\P{Joining_Group:   alef}', "");
    Expect(1, 1908, '\P{^Joining_Group:   alef}', "");
    Expect(0, 1909, '\p{Joining_Group:   alef}', "");
    Expect(1, 1909, '\p{^Joining_Group:   alef}', "");
    Expect(1, 1909, '\P{Joining_Group:   alef}', "");
    Expect(0, 1909, '\P{^Joining_Group:   alef}', "");
    Expect(1, 1908, '\p{Joining_Group=:\Aalef\z:}', "");;
    Expect(0, 1909, '\p{Joining_Group=:\Aalef\z:}', "");;
    Expect(1, 1908, '\p{Joining_Group=_	ALEF}', "");
    Expect(0, 1908, '\p{^Joining_Group=_	ALEF}', "");
    Expect(0, 1908, '\P{Joining_Group=_	ALEF}', "");
    Expect(1, 1908, '\P{^Joining_Group=_	ALEF}', "");
    Expect(0, 1909, '\p{Joining_Group=_	ALEF}', "");
    Expect(1, 1909, '\p{^Joining_Group=_	ALEF}', "");
    Expect(1, 1909, '\P{Joining_Group=_	ALEF}', "");
    Expect(0, 1909, '\P{^Joining_Group=_	ALEF}', "");
    Error('\p{Jg:   :=_-Alef}');
    Error('\P{Jg:   :=_-Alef}');
    Expect(1, 1908, '\p{Jg=:\AAlef\z:}', "");;
    Expect(0, 1909, '\p{Jg=:\AAlef\z:}', "");;
    Expect(1, 1908, '\p{Jg:   alef}', "");
    Expect(0, 1908, '\p{^Jg:   alef}', "");
    Expect(0, 1908, '\P{Jg:   alef}', "");
    Expect(1, 1908, '\P{^Jg:   alef}', "");
    Expect(0, 1909, '\p{Jg:   alef}', "");
    Expect(1, 1909, '\p{^Jg:   alef}', "");
    Expect(1, 1909, '\P{Jg:   alef}', "");
    Expect(0, 1909, '\P{^Jg:   alef}', "");
    Expect(1, 1908, '\p{Jg=:\Aalef\z:}', "");;
    Expect(0, 1909, '\p{Jg=:\Aalef\z:}', "");;
    Expect(1, 1908, '\p{Jg=	-alef}', "");
    Expect(0, 1908, '\p{^Jg=	-alef}', "");
    Expect(0, 1908, '\P{Jg=	-alef}', "");
    Expect(1, 1908, '\P{^Jg=	-alef}', "");
    Expect(0, 1909, '\p{Jg=	-alef}', "");
    Expect(1, 1909, '\p{^Jg=	-alef}', "");
    Expect(1, 1909, '\P{Jg=	-alef}', "");
    Expect(0, 1909, '\P{^Jg=	-alef}', "");
    Error('\p{Is_Joining_Group=/a/	ALEF}');
    Error('\P{Is_Joining_Group=/a/	ALEF}');
    Expect(1, 1908, '\p{Is_Joining_Group=alef}', "");
    Expect(0, 1908, '\p{^Is_Joining_Group=alef}', "");
    Expect(0, 1908, '\P{Is_Joining_Group=alef}', "");
    Expect(1, 1908, '\P{^Is_Joining_Group=alef}', "");
    Expect(0, 1909, '\p{Is_Joining_Group=alef}', "");
    Expect(1, 1909, '\p{^Is_Joining_Group=alef}', "");
    Expect(1, 1909, '\P{Is_Joining_Group=alef}', "");
    Expect(0, 1909, '\P{^Is_Joining_Group=alef}', "");
    Expect(1, 1908, '\p{Is_Joining_Group= Alef}', "");
    Expect(0, 1908, '\p{^Is_Joining_Group= Alef}', "");
    Expect(0, 1908, '\P{Is_Joining_Group= Alef}', "");
    Expect(1, 1908, '\P{^Is_Joining_Group= Alef}', "");
    Expect(0, 1909, '\p{Is_Joining_Group= Alef}', "");
    Expect(1, 1909, '\p{^Is_Joining_Group= Alef}', "");
    Expect(1, 1909, '\P{Is_Joining_Group= Alef}', "");
    Expect(0, 1909, '\P{^Is_Joining_Group= Alef}', "");
    Error('\p{Is_Jg=/a/	Alef}');
    Error('\P{Is_Jg=/a/	Alef}');
    Expect(1, 1908, '\p{Is_Jg: alef}', "");
    Expect(0, 1908, '\p{^Is_Jg: alef}', "");
    Expect(0, 1908, '\P{Is_Jg: alef}', "");
    Expect(1, 1908, '\P{^Is_Jg: alef}', "");
    Expect(0, 1909, '\p{Is_Jg: alef}', "");
    Expect(1, 1909, '\p{^Is_Jg: alef}', "");
    Expect(1, 1909, '\P{Is_Jg: alef}', "");
    Expect(0, 1909, '\P{^Is_Jg: alef}', "");
    Expect(1, 1908, '\p{Is_Jg=	Alef}', "");
    Expect(0, 1908, '\p{^Is_Jg=	Alef}', "");
    Expect(0, 1908, '\P{Is_Jg=	Alef}', "");
    Expect(1, 1908, '\P{^Is_Jg=	Alef}', "");
    Expect(0, 1909, '\p{Is_Jg=	Alef}', "");
    Expect(1, 1909, '\p{^Is_Jg=	Alef}', "");
    Expect(1, 1909, '\P{Is_Jg=	Alef}', "");
    Expect(0, 1909, '\P{^Is_Jg=	Alef}', "");
    Error('\p{Joining_Group=:=	Beh}');
    Error('\P{Joining_Group=:=	Beh}');
    Expect(1, 2232, '\p{Joining_Group=:\ABeh\z:}', "");;
    Expect(0, 2233, '\p{Joining_Group=:\ABeh\z:}', "");;
    Expect(1, 2232, '\p{Joining_Group=beh}', "");
    Expect(0, 2232, '\p{^Joining_Group=beh}', "");
    Expect(0, 2232, '\P{Joining_Group=beh}', "");
    Expect(1, 2232, '\P{^Joining_Group=beh}', "");
    Expect(0, 2233, '\p{Joining_Group=beh}', "");
    Expect(1, 2233, '\p{^Joining_Group=beh}', "");
    Expect(1, 2233, '\P{Joining_Group=beh}', "");
    Expect(0, 2233, '\P{^Joining_Group=beh}', "");
    Expect(1, 2232, '\p{Joining_Group=:\Abeh\z:}', "");;
    Expect(0, 2233, '\p{Joining_Group=:\Abeh\z:}', "");;
    Expect(1, 2232, '\p{Joining_Group=	 beh}', "");
    Expect(0, 2232, '\p{^Joining_Group=	 beh}', "");
    Expect(0, 2232, '\P{Joining_Group=	 beh}', "");
    Expect(1, 2232, '\P{^Joining_Group=	 beh}', "");
    Expect(0, 2233, '\p{Joining_Group=	 beh}', "");
    Expect(1, 2233, '\p{^Joining_Group=	 beh}', "");
    Expect(1, 2233, '\P{Joining_Group=	 beh}', "");
    Expect(0, 2233, '\P{^Joining_Group=	 beh}', "");
    Error('\p{Jg=/a/_-Beh}');
    Error('\P{Jg=/a/_-Beh}');
    Expect(1, 2232, '\p{Jg=:\ABeh\z:}', "");;
    Expect(0, 2233, '\p{Jg=:\ABeh\z:}', "");;
    Expect(1, 2232, '\p{Jg=beh}', "");
    Expect(0, 2232, '\p{^Jg=beh}', "");
    Expect(0, 2232, '\P{Jg=beh}', "");
    Expect(1, 2232, '\P{^Jg=beh}', "");
    Expect(0, 2233, '\p{Jg=beh}', "");
    Expect(1, 2233, '\p{^Jg=beh}', "");
    Expect(1, 2233, '\P{Jg=beh}', "");
    Expect(0, 2233, '\P{^Jg=beh}', "");
    Expect(1, 2232, '\p{Jg=:\Abeh\z:}', "");;
    Expect(0, 2233, '\p{Jg=:\Abeh\z:}', "");;
    Expect(1, 2232, '\p{Jg=-	Beh}', "");
    Expect(0, 2232, '\p{^Jg=-	Beh}', "");
    Expect(0, 2232, '\P{Jg=-	Beh}', "");
    Expect(1, 2232, '\P{^Jg=-	Beh}', "");
    Expect(0, 2233, '\p{Jg=-	Beh}', "");
    Expect(1, 2233, '\p{^Jg=-	Beh}', "");
    Expect(1, 2233, '\P{Jg=-	Beh}', "");
    Expect(0, 2233, '\P{^Jg=-	Beh}', "");
    Error('\p{Is_Joining_Group=__Beh:=}');
    Error('\P{Is_Joining_Group=__Beh:=}');
    Expect(1, 2232, '\p{Is_Joining_Group=beh}', "");
    Expect(0, 2232, '\p{^Is_Joining_Group=beh}', "");
    Expect(0, 2232, '\P{Is_Joining_Group=beh}', "");
    Expect(1, 2232, '\P{^Is_Joining_Group=beh}', "");
    Expect(0, 2233, '\p{Is_Joining_Group=beh}', "");
    Expect(1, 2233, '\p{^Is_Joining_Group=beh}', "");
    Expect(1, 2233, '\P{Is_Joining_Group=beh}', "");
    Expect(0, 2233, '\P{^Is_Joining_Group=beh}', "");
    Expect(1, 2232, '\p{Is_Joining_Group=-Beh}', "");
    Expect(0, 2232, '\p{^Is_Joining_Group=-Beh}', "");
    Expect(0, 2232, '\P{Is_Joining_Group=-Beh}', "");
    Expect(1, 2232, '\P{^Is_Joining_Group=-Beh}', "");
    Expect(0, 2233, '\p{Is_Joining_Group=-Beh}', "");
    Expect(1, 2233, '\p{^Is_Joining_Group=-Beh}', "");
    Expect(1, 2233, '\P{Is_Joining_Group=-Beh}', "");
    Expect(0, 2233, '\P{^Is_Joining_Group=-Beh}', "");
    Error('\p{Is_Jg=/a/  Beh}');
    Error('\P{Is_Jg=/a/  Beh}');
    Expect(1, 2232, '\p{Is_Jg=beh}', "");
    Expect(0, 2232, '\p{^Is_Jg=beh}', "");
    Expect(0, 2232, '\P{Is_Jg=beh}', "");
    Expect(1, 2232, '\P{^Is_Jg=beh}', "");
    Expect(0, 2233, '\p{Is_Jg=beh}', "");
    Expect(1, 2233, '\p{^Is_Jg=beh}', "");
    Expect(1, 2233, '\P{Is_Jg=beh}', "");
    Expect(0, 2233, '\P{^Is_Jg=beh}', "");
    Expect(1, 2232, '\p{Is_Jg:		-BEH}', "");
    Expect(0, 2232, '\p{^Is_Jg:		-BEH}', "");
    Expect(0, 2232, '\P{Is_Jg:		-BEH}', "");
    Expect(1, 2232, '\P{^Is_Jg:		-BEH}', "");
    Expect(0, 2233, '\p{Is_Jg:		-BEH}', "");
    Expect(1, 2233, '\p{^Is_Jg:		-BEH}', "");
    Expect(1, 2233, '\P{Is_Jg:		-BEH}', "");
    Expect(0, 2233, '\P{^Is_Jg:		-BEH}', "");
    Error('\p{Joining_Group:   -Beth:=}');
    Error('\P{Joining_Group:   -Beth:=}');
    Expect(1, 1837, '\p{Joining_Group=:\ABeth\z:}', "");;
    Expect(0, 1838, '\p{Joining_Group=:\ABeth\z:}', "");;
    Expect(1, 1837, '\p{Joining_Group=beth}', "");
    Expect(0, 1837, '\p{^Joining_Group=beth}', "");
    Expect(0, 1837, '\P{Joining_Group=beth}', "");
    Expect(1, 1837, '\P{^Joining_Group=beth}', "");
    Expect(0, 1838, '\p{Joining_Group=beth}', "");
    Expect(1, 1838, '\p{^Joining_Group=beth}', "");
    Expect(1, 1838, '\P{Joining_Group=beth}', "");
    Expect(0, 1838, '\P{^Joining_Group=beth}', "");
    Expect(1, 1837, '\p{Joining_Group=:\Abeth\z:}', "");;
    Expect(0, 1838, '\p{Joining_Group=:\Abeth\z:}', "");;
    Expect(1, 1837, '\p{Joining_Group= Beth}', "");
    Expect(0, 1837, '\p{^Joining_Group= Beth}', "");
    Expect(0, 1837, '\P{Joining_Group= Beth}', "");
    Expect(1, 1837, '\P{^Joining_Group= Beth}', "");
    Expect(0, 1838, '\p{Joining_Group= Beth}', "");
    Expect(1, 1838, '\p{^Joining_Group= Beth}', "");
    Expect(1, 1838, '\P{Joining_Group= Beth}', "");
    Expect(0, 1838, '\P{^Joining_Group= Beth}', "");
    Error('\p{Jg=/a/--Beth}');
    Error('\P{Jg=/a/--Beth}');
    Expect(1, 1837, '\p{Jg=:\ABeth\z:}', "");;
    Expect(0, 1838, '\p{Jg=:\ABeth\z:}', "");;
    Expect(1, 1837, '\p{Jg=beth}', "");
    Expect(0, 1837, '\p{^Jg=beth}', "");
    Expect(0, 1837, '\P{Jg=beth}', "");
    Expect(1, 1837, '\P{^Jg=beth}', "");
    Expect(0, 1838, '\p{Jg=beth}', "");
    Expect(1, 1838, '\p{^Jg=beth}', "");
    Expect(1, 1838, '\P{Jg=beth}', "");
    Expect(0, 1838, '\P{^Jg=beth}', "");
    Expect(1, 1837, '\p{Jg=:\Abeth\z:}', "");;
    Expect(0, 1838, '\p{Jg=:\Abeth\z:}', "");;
    Expect(1, 1837, '\p{Jg=	BETH}', "");
    Expect(0, 1837, '\p{^Jg=	BETH}', "");
    Expect(0, 1837, '\P{Jg=	BETH}', "");
    Expect(1, 1837, '\P{^Jg=	BETH}', "");
    Expect(0, 1838, '\p{Jg=	BETH}', "");
    Expect(1, 1838, '\p{^Jg=	BETH}', "");
    Expect(1, 1838, '\P{Jg=	BETH}', "");
    Expect(0, 1838, '\P{^Jg=	BETH}', "");
    Error('\p{Is_Joining_Group=:= -Beth}');
    Error('\P{Is_Joining_Group=:= -Beth}');
    Expect(1, 1837, '\p{Is_Joining_Group=beth}', "");
    Expect(0, 1837, '\p{^Is_Joining_Group=beth}', "");
    Expect(0, 1837, '\P{Is_Joining_Group=beth}', "");
    Expect(1, 1837, '\P{^Is_Joining_Group=beth}', "");
    Expect(0, 1838, '\p{Is_Joining_Group=beth}', "");
    Expect(1, 1838, '\p{^Is_Joining_Group=beth}', "");
    Expect(1, 1838, '\P{Is_Joining_Group=beth}', "");
    Expect(0, 1838, '\P{^Is_Joining_Group=beth}', "");
    Expect(1, 1837, '\p{Is_Joining_Group:   	-beth}', "");
    Expect(0, 1837, '\p{^Is_Joining_Group:   	-beth}', "");
    Expect(0, 1837, '\P{Is_Joining_Group:   	-beth}', "");
    Expect(1, 1837, '\P{^Is_Joining_Group:   	-beth}', "");
    Expect(0, 1838, '\p{Is_Joining_Group:   	-beth}', "");
    Expect(1, 1838, '\p{^Is_Joining_Group:   	-beth}', "");
    Expect(1, 1838, '\P{Is_Joining_Group:   	-beth}', "");
    Expect(0, 1838, '\P{^Is_Joining_Group:   	-beth}', "");
    Error('\p{Is_Jg=_Beth:=}');
    Error('\P{Is_Jg=_Beth:=}');
    Expect(1, 1837, '\p{Is_Jg=beth}', "");
    Expect(0, 1837, '\p{^Is_Jg=beth}', "");
    Expect(0, 1837, '\P{Is_Jg=beth}', "");
    Expect(1, 1837, '\P{^Is_Jg=beth}', "");
    Expect(0, 1838, '\p{Is_Jg=beth}', "");
    Expect(1, 1838, '\p{^Is_Jg=beth}', "");
    Expect(1, 1838, '\P{Is_Jg=beth}', "");
    Expect(0, 1838, '\P{^Is_Jg=beth}', "");
    Expect(1, 1837, '\p{Is_Jg=-Beth}', "");
    Expect(0, 1837, '\p{^Is_Jg=-Beth}', "");
    Expect(0, 1837, '\P{Is_Jg=-Beth}', "");
    Expect(1, 1837, '\P{^Is_Jg=-Beth}', "");
    Expect(0, 1838, '\p{Is_Jg=-Beth}', "");
    Expect(1, 1838, '\p{^Is_Jg=-Beth}', "");
    Expect(1, 1838, '\P{Is_Jg=-Beth}', "");
    Expect(0, 1838, '\P{^Is_Jg=-Beth}', "");
    Error('\p{Joining_Group:	/a/  Burushaski_Yeh_BARREE}');
    Error('\P{Joining_Group:	/a/  Burushaski_Yeh_BARREE}');
    Expect(1, 1915, '\p{Joining_Group=:\ABurushaski_Yeh_Barree\z:}', "");;
    Expect(0, 1916, '\p{Joining_Group=:\ABurushaski_Yeh_Barree\z:}', "");;
    Expect(1, 1915, '\p{Joining_Group=burushaskiyehbarree}', "");
    Expect(0, 1915, '\p{^Joining_Group=burushaskiyehbarree}', "");
    Expect(0, 1915, '\P{Joining_Group=burushaskiyehbarree}', "");
    Expect(1, 1915, '\P{^Joining_Group=burushaskiyehbarree}', "");
    Expect(0, 1916, '\p{Joining_Group=burushaskiyehbarree}', "");
    Expect(1, 1916, '\p{^Joining_Group=burushaskiyehbarree}', "");
    Expect(1, 1916, '\P{Joining_Group=burushaskiyehbarree}', "");
    Expect(0, 1916, '\P{^Joining_Group=burushaskiyehbarree}', "");
    Expect(1, 1915, '\p{Joining_Group=:\Aburushaskiyehbarree\z:}', "");;
    Expect(0, 1916, '\p{Joining_Group=:\Aburushaskiyehbarree\z:}', "");;
    Expect(1, 1915, '\p{Joining_Group=- BURUSHASKI_Yeh_barree}', "");
    Expect(0, 1915, '\p{^Joining_Group=- BURUSHASKI_Yeh_barree}', "");
    Expect(0, 1915, '\P{Joining_Group=- BURUSHASKI_Yeh_barree}', "");
    Expect(1, 1915, '\P{^Joining_Group=- BURUSHASKI_Yeh_barree}', "");
    Expect(0, 1916, '\p{Joining_Group=- BURUSHASKI_Yeh_barree}', "");
    Expect(1, 1916, '\p{^Joining_Group=- BURUSHASKI_Yeh_barree}', "");
    Expect(1, 1916, '\P{Joining_Group=- BURUSHASKI_Yeh_barree}', "");
    Expect(0, 1916, '\P{^Joining_Group=- BURUSHASKI_Yeh_barree}', "");
    Error('\p{Jg:		:=Burushaski_YEH_barree}');
    Error('\P{Jg:		:=Burushaski_YEH_barree}');
    Expect(1, 1915, '\p{Jg=:\ABurushaski_Yeh_Barree\z:}', "");;
    Expect(0, 1916, '\p{Jg=:\ABurushaski_Yeh_Barree\z:}', "");;
    Expect(1, 1915, '\p{Jg=burushaskiyehbarree}', "");
    Expect(0, 1915, '\p{^Jg=burushaskiyehbarree}', "");
    Expect(0, 1915, '\P{Jg=burushaskiyehbarree}', "");
    Expect(1, 1915, '\P{^Jg=burushaskiyehbarree}', "");
    Expect(0, 1916, '\p{Jg=burushaskiyehbarree}', "");
    Expect(1, 1916, '\p{^Jg=burushaskiyehbarree}', "");
    Expect(1, 1916, '\P{Jg=burushaskiyehbarree}', "");
    Expect(0, 1916, '\P{^Jg=burushaskiyehbarree}', "");
    Expect(1, 1915, '\p{Jg=:\Aburushaskiyehbarree\z:}', "");;
    Expect(0, 1916, '\p{Jg=:\Aburushaskiyehbarree\z:}', "");;
    Expect(1, 1915, '\p{Jg=-burushaski_yeh_BARREE}', "");
    Expect(0, 1915, '\p{^Jg=-burushaski_yeh_BARREE}', "");
    Expect(0, 1915, '\P{Jg=-burushaski_yeh_BARREE}', "");
    Expect(1, 1915, '\P{^Jg=-burushaski_yeh_BARREE}', "");
    Expect(0, 1916, '\p{Jg=-burushaski_yeh_BARREE}', "");
    Expect(1, 1916, '\p{^Jg=-burushaski_yeh_BARREE}', "");
    Expect(1, 1916, '\P{Jg=-burushaski_yeh_BARREE}', "");
    Expect(0, 1916, '\P{^Jg=-burushaski_yeh_BARREE}', "");
    Error('\p{Is_Joining_Group=:=--Burushaski_yeh_Barree}');
    Error('\P{Is_Joining_Group=:=--Burushaski_yeh_Barree}');
    Expect(1, 1915, '\p{Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(0, 1915, '\p{^Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(0, 1915, '\P{Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(1, 1915, '\P{^Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(0, 1916, '\p{Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(1, 1916, '\p{^Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(1, 1916, '\P{Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(0, 1916, '\P{^Is_Joining_Group=burushaskiyehbarree}', "");
    Expect(1, 1915, '\p{Is_Joining_Group= _BURUSHASKI_YEH_barree}', "");
    Expect(0, 1915, '\p{^Is_Joining_Group= _BURUSHASKI_YEH_barree}', "");
    Expect(0, 1915, '\P{Is_Joining_Group= _BURUSHASKI_YEH_barree}', "");
    Expect(1, 1915, '\P{^Is_Joining_Group= _BURUSHASKI_YEH_barree}', "");
    Expect(0, 1916, '\p{Is_Joining_Group= _BURUSHASKI_YEH_barree}', "");
    Expect(1, 1916, '\p{^Is_Joining_Group= _BURUSHASKI_YEH_barree}', "");
    Expect(1, 1916, '\P{Is_Joining_Group= _BURUSHASKI_YEH_barree}', "");
    Expect(0, 1916, '\P{^Is_Joining_Group= _BURUSHASKI_YEH_barree}', "");
    Error('\p{Is_Jg=_ Burushaski_Yeh_Barree/a/}');
    Error('\P{Is_Jg=_ Burushaski_Yeh_Barree/a/}');
    Expect(1, 1915, '\p{Is_Jg: burushaskiyehbarree}', "");
    Expect(0, 1915, '\p{^Is_Jg: burushaskiyehbarree}', "");
    Expect(0, 1915, '\P{Is_Jg: burushaskiyehbarree}', "");
    Expect(1, 1915, '\P{^Is_Jg: burushaskiyehbarree}', "");
    Expect(0, 1916, '\p{Is_Jg: burushaskiyehbarree}', "");
    Expect(1, 1916, '\p{^Is_Jg: burushaskiyehbarree}', "");
    Expect(1, 1916, '\P{Is_Jg: burushaskiyehbarree}', "");
    Expect(0, 1916, '\P{^Is_Jg: burushaskiyehbarree}', "");
    Expect(1, 1915, '\p{Is_Jg=		Burushaski_Yeh_BARREE}', "");
    Expect(0, 1915, '\p{^Is_Jg=		Burushaski_Yeh_BARREE}', "");
    Expect(0, 1915, '\P{Is_Jg=		Burushaski_Yeh_BARREE}', "");
    Expect(1, 1915, '\P{^Is_Jg=		Burushaski_Yeh_BARREE}', "");
    Expect(0, 1916, '\p{Is_Jg=		Burushaski_Yeh_BARREE}', "");
    Expect(1, 1916, '\p{^Is_Jg=		Burushaski_Yeh_BARREE}', "");
    Expect(1, 1916, '\P{Is_Jg=		Burushaski_Yeh_BARREE}', "");
    Expect(0, 1916, '\P{^Is_Jg=		Burushaski_Yeh_BARREE}', "");
    Error('\p{Joining_Group=/a/  DAL}');
    Error('\P{Joining_Group=/a/  DAL}');
    Expect(1, 2222, '\p{Joining_Group=:\ADal\z:}', "");;
    Expect(0, 2223, '\p{Joining_Group=:\ADal\z:}', "");;
    Expect(1, 2222, '\p{Joining_Group=dal}', "");
    Expect(0, 2222, '\p{^Joining_Group=dal}', "");
    Expect(0, 2222, '\P{Joining_Group=dal}', "");
    Expect(1, 2222, '\P{^Joining_Group=dal}', "");
    Expect(0, 2223, '\p{Joining_Group=dal}', "");
    Expect(1, 2223, '\p{^Joining_Group=dal}', "");
    Expect(1, 2223, '\P{Joining_Group=dal}', "");
    Expect(0, 2223, '\P{^Joining_Group=dal}', "");
    Expect(1, 2222, '\p{Joining_Group=:\Adal\z:}', "");;
    Expect(0, 2223, '\p{Joining_Group=:\Adal\z:}', "");;
    Expect(1, 2222, '\p{Joining_Group= 	Dal}', "");
    Expect(0, 2222, '\p{^Joining_Group= 	Dal}', "");
    Expect(0, 2222, '\P{Joining_Group= 	Dal}', "");
    Expect(1, 2222, '\P{^Joining_Group= 	Dal}', "");
    Expect(0, 2223, '\p{Joining_Group= 	Dal}', "");
    Expect(1, 2223, '\p{^Joining_Group= 	Dal}', "");
    Expect(1, 2223, '\P{Joining_Group= 	Dal}', "");
    Expect(0, 2223, '\P{^Joining_Group= 	Dal}', "");
    Error('\p{Jg=/a/_-Dal}');
    Error('\P{Jg=/a/_-Dal}');
    Expect(1, 2222, '\p{Jg=:\ADal\z:}', "");;
    Expect(0, 2223, '\p{Jg=:\ADal\z:}', "");;
    Expect(1, 2222, '\p{Jg=dal}', "");
    Expect(0, 2222, '\p{^Jg=dal}', "");
    Expect(0, 2222, '\P{Jg=dal}', "");
    Expect(1, 2222, '\P{^Jg=dal}', "");
    Expect(0, 2223, '\p{Jg=dal}', "");
    Expect(1, 2223, '\p{^Jg=dal}', "");
    Expect(1, 2223, '\P{Jg=dal}', "");
    Expect(0, 2223, '\P{^Jg=dal}', "");
    Expect(1, 2222, '\p{Jg=:\Adal\z:}', "");;
    Expect(0, 2223, '\p{Jg=:\Adal\z:}', "");;
    Expect(1, 2222, '\p{Jg= -DAL}', "");
    Expect(0, 2222, '\p{^Jg= -DAL}', "");
    Expect(0, 2222, '\P{Jg= -DAL}', "");
    Expect(1, 2222, '\P{^Jg= -DAL}', "");
    Expect(0, 2223, '\p{Jg= -DAL}', "");
    Expect(1, 2223, '\p{^Jg= -DAL}', "");
    Expect(1, 2223, '\P{Jg= -DAL}', "");
    Expect(0, 2223, '\P{^Jg= -DAL}', "");
    Error('\p{Is_Joining_Group=:=	_dal}');
    Error('\P{Is_Joining_Group=:=	_dal}');
    Expect(1, 2222, '\p{Is_Joining_Group=dal}', "");
    Expect(0, 2222, '\p{^Is_Joining_Group=dal}', "");
    Expect(0, 2222, '\P{Is_Joining_Group=dal}', "");
    Expect(1, 2222, '\P{^Is_Joining_Group=dal}', "");
    Expect(0, 2223, '\p{Is_Joining_Group=dal}', "");
    Expect(1, 2223, '\p{^Is_Joining_Group=dal}', "");
    Expect(1, 2223, '\P{Is_Joining_Group=dal}', "");
    Expect(0, 2223, '\P{^Is_Joining_Group=dal}', "");
    Expect(1, 2222, '\p{Is_Joining_Group= -Dal}', "");
    Expect(0, 2222, '\p{^Is_Joining_Group= -Dal}', "");
    Expect(0, 2222, '\P{Is_Joining_Group= -Dal}', "");
    Expect(1, 2222, '\P{^Is_Joining_Group= -Dal}', "");
    Expect(0, 2223, '\p{Is_Joining_Group= -Dal}', "");
    Expect(1, 2223, '\p{^Is_Joining_Group= -Dal}', "");
    Expect(1, 2223, '\P{Is_Joining_Group= -Dal}', "");
    Expect(0, 2223, '\P{^Is_Joining_Group= -Dal}', "");
    Error('\p{Is_Jg= :=Dal}');
    Error('\P{Is_Jg= :=Dal}');
    Expect(1, 2222, '\p{Is_Jg=dal}', "");
    Expect(0, 2222, '\p{^Is_Jg=dal}', "");
    Expect(0, 2222, '\P{Is_Jg=dal}', "");
    Expect(1, 2222, '\P{^Is_Jg=dal}', "");
    Expect(0, 2223, '\p{Is_Jg=dal}', "");
    Expect(1, 2223, '\p{^Is_Jg=dal}', "");
    Expect(1, 2223, '\P{Is_Jg=dal}', "");
    Expect(0, 2223, '\P{^Is_Jg=dal}', "");
    Expect(1, 2222, '\p{Is_Jg= 	DAL}', "");
    Expect(0, 2222, '\p{^Is_Jg= 	DAL}', "");
    Expect(0, 2222, '\P{Is_Jg= 	DAL}', "");
    Expect(1, 2222, '\P{^Is_Jg= 	DAL}', "");
    Expect(0, 2223, '\p{Is_Jg= 	DAL}', "");
    Expect(1, 2223, '\p{^Is_Jg= 	DAL}', "");
    Expect(1, 2223, '\P{Is_Jg= 	DAL}', "");
    Expect(0, 2223, '\P{^Is_Jg= 	DAL}', "");
    Error('\p{Joining_Group=/a/	Dalath_Rish}');
    Error('\P{Joining_Group=/a/	Dalath_Rish}');
    Expect(1, 1839, '\p{Joining_Group=:\ADalath_Rish\z:}', "");;
    Expect(0, 1840, '\p{Joining_Group=:\ADalath_Rish\z:}', "");;
    Expect(1, 1839, '\p{Joining_Group=dalathrish}', "");
    Expect(0, 1839, '\p{^Joining_Group=dalathrish}', "");
    Expect(0, 1839, '\P{Joining_Group=dalathrish}', "");
    Expect(1, 1839, '\P{^Joining_Group=dalathrish}', "");
    Expect(0, 1840, '\p{Joining_Group=dalathrish}', "");
    Expect(1, 1840, '\p{^Joining_Group=dalathrish}', "");
    Expect(1, 1840, '\P{Joining_Group=dalathrish}', "");
    Expect(0, 1840, '\P{^Joining_Group=dalathrish}', "");
    Expect(1, 1839, '\p{Joining_Group=:\Adalathrish\z:}', "");;
    Expect(0, 1840, '\p{Joining_Group=:\Adalathrish\z:}', "");;
    Expect(1, 1839, '\p{Joining_Group=-DALATH_Rish}', "");
    Expect(0, 1839, '\p{^Joining_Group=-DALATH_Rish}', "");
    Expect(0, 1839, '\P{Joining_Group=-DALATH_Rish}', "");
    Expect(1, 1839, '\P{^Joining_Group=-DALATH_Rish}', "");
    Expect(0, 1840, '\p{Joining_Group=-DALATH_Rish}', "");
    Expect(1, 1840, '\p{^Joining_Group=-DALATH_Rish}', "");
    Expect(1, 1840, '\P{Joining_Group=-DALATH_Rish}', "");
    Expect(0, 1840, '\P{^Joining_Group=-DALATH_Rish}', "");
    Error('\p{Jg=_DALATH_Rish:=}');
    Error('\P{Jg=_DALATH_Rish:=}');
    Expect(1, 1839, '\p{Jg=:\ADalath_Rish\z:}', "");;
    Expect(0, 1840, '\p{Jg=:\ADalath_Rish\z:}', "");;
    Expect(1, 1839, '\p{Jg=dalathrish}', "");
    Expect(0, 1839, '\p{^Jg=dalathrish}', "");
    Expect(0, 1839, '\P{Jg=dalathrish}', "");
    Expect(1, 1839, '\P{^Jg=dalathrish}', "");
    Expect(0, 1840, '\p{Jg=dalathrish}', "");
    Expect(1, 1840, '\p{^Jg=dalathrish}', "");
    Expect(1, 1840, '\P{Jg=dalathrish}', "");
    Expect(0, 1840, '\P{^Jg=dalathrish}', "");
    Expect(1, 1839, '\p{Jg=:\Adalathrish\z:}', "");;
    Expect(0, 1840, '\p{Jg=:\Adalathrish\z:}', "");;
    Expect(1, 1839, '\p{Jg=  DALATH_Rish}', "");
    Expect(0, 1839, '\p{^Jg=  DALATH_Rish}', "");
    Expect(0, 1839, '\P{Jg=  DALATH_Rish}', "");
    Expect(1, 1839, '\P{^Jg=  DALATH_Rish}', "");
    Expect(0, 1840, '\p{Jg=  DALATH_Rish}', "");
    Expect(1, 1840, '\p{^Jg=  DALATH_Rish}', "");
    Expect(1, 1840, '\P{Jg=  DALATH_Rish}', "");
    Expect(0, 1840, '\P{^Jg=  DALATH_Rish}', "");
    Error('\p{Is_Joining_Group=:=  dalath_Rish}');
    Error('\P{Is_Joining_Group=:=  dalath_Rish}');
    Expect(1, 1839, '\p{Is_Joining_Group=dalathrish}', "");
    Expect(0, 1839, '\p{^Is_Joining_Group=dalathrish}', "");
    Expect(0, 1839, '\P{Is_Joining_Group=dalathrish}', "");
    Expect(1, 1839, '\P{^Is_Joining_Group=dalathrish}', "");
    Expect(0, 1840, '\p{Is_Joining_Group=dalathrish}', "");
    Expect(1, 1840, '\p{^Is_Joining_Group=dalathrish}', "");
    Expect(1, 1840, '\P{Is_Joining_Group=dalathrish}', "");
    Expect(0, 1840, '\P{^Is_Joining_Group=dalathrish}', "");
    Expect(1, 1839, '\p{Is_Joining_Group=__Dalath_rish}', "");
    Expect(0, 1839, '\p{^Is_Joining_Group=__Dalath_rish}', "");
    Expect(0, 1839, '\P{Is_Joining_Group=__Dalath_rish}', "");
    Expect(1, 1839, '\P{^Is_Joining_Group=__Dalath_rish}', "");
    Expect(0, 1840, '\p{Is_Joining_Group=__Dalath_rish}', "");
    Expect(1, 1840, '\p{^Is_Joining_Group=__Dalath_rish}', "");
    Expect(1, 1840, '\P{Is_Joining_Group=__Dalath_rish}', "");
    Expect(0, 1840, '\P{^Is_Joining_Group=__Dalath_rish}', "");
    Error('\p{Is_Jg:    dalath_Rish:=}');
    Error('\P{Is_Jg:    dalath_Rish:=}');
    Expect(1, 1839, '\p{Is_Jg=dalathrish}', "");
    Expect(0, 1839, '\p{^Is_Jg=dalathrish}', "");
    Expect(0, 1839, '\P{Is_Jg=dalathrish}', "");
    Expect(1, 1839, '\P{^Is_Jg=dalathrish}', "");
    Expect(0, 1840, '\p{Is_Jg=dalathrish}', "");
    Expect(1, 1840, '\p{^Is_Jg=dalathrish}', "");
    Expect(1, 1840, '\P{Is_Jg=dalathrish}', "");
    Expect(0, 1840, '\P{^Is_Jg=dalathrish}', "");
    Expect(1, 1839, '\p{Is_Jg=DALATH_Rish}', "");
    Expect(0, 1839, '\p{^Is_Jg=DALATH_Rish}', "");
    Expect(0, 1839, '\P{Is_Jg=DALATH_Rish}', "");
    Expect(1, 1839, '\P{^Is_Jg=DALATH_Rish}', "");
    Expect(0, 1840, '\p{Is_Jg=DALATH_Rish}', "");
    Expect(1, 1840, '\p{^Is_Jg=DALATH_Rish}', "");
    Expect(1, 1840, '\P{Is_Jg=DALATH_Rish}', "");
    Expect(0, 1840, '\P{^Is_Jg=DALATH_Rish}', "");
    Error('\p{Joining_Group=:=_	E}');
    Error('\P{Joining_Group=:=_	E}');
    Expect(1, 1829, '\p{Joining_Group=:\AE\z:}', "");;
    Expect(0, 1830, '\p{Joining_Group=:\AE\z:}', "");;
    Expect(1, 1829, '\p{Joining_Group=e}', "");
    Expect(0, 1829, '\p{^Joining_Group=e}', "");
    Expect(0, 1829, '\P{Joining_Group=e}', "");
    Expect(1, 1829, '\P{^Joining_Group=e}', "");
    Expect(0, 1830, '\p{Joining_Group=e}', "");
    Expect(1, 1830, '\p{^Joining_Group=e}', "");
    Expect(1, 1830, '\P{Joining_Group=e}', "");
    Expect(0, 1830, '\P{^Joining_Group=e}', "");
    Expect(1, 1829, '\p{Joining_Group=:\Ae\z:}', "");;
    Expect(0, 1830, '\p{Joining_Group=:\Ae\z:}', "");;
    Expect(1, 1829, '\p{Joining_Group= -E}', "");
    Expect(0, 1829, '\p{^Joining_Group= -E}', "");
    Expect(0, 1829, '\P{Joining_Group= -E}', "");
    Expect(1, 1829, '\P{^Joining_Group= -E}', "");
    Expect(0, 1830, '\p{Joining_Group= -E}', "");
    Expect(1, 1830, '\p{^Joining_Group= -E}', "");
    Expect(1, 1830, '\P{Joining_Group= -E}', "");
    Expect(0, 1830, '\P{^Joining_Group= -E}', "");
    Error('\p{Jg=/a/	_E}');
    Error('\P{Jg=/a/	_E}');
    Expect(1, 1829, '\p{Jg=:\AE\z:}', "");;
    Expect(0, 1830, '\p{Jg=:\AE\z:}', "");;
    Expect(1, 1829, '\p{Jg=e}', "");
    Expect(0, 1829, '\p{^Jg=e}', "");
    Expect(0, 1829, '\P{Jg=e}', "");
    Expect(1, 1829, '\P{^Jg=e}', "");
    Expect(0, 1830, '\p{Jg=e}', "");
    Expect(1, 1830, '\p{^Jg=e}', "");
    Expect(1, 1830, '\P{Jg=e}', "");
    Expect(0, 1830, '\P{^Jg=e}', "");
    Expect(1, 1829, '\p{Jg=:\Ae\z:}', "");;
    Expect(0, 1830, '\p{Jg=:\Ae\z:}', "");;
    Expect(1, 1829, '\p{Jg=	_E}', "");
    Expect(0, 1829, '\p{^Jg=	_E}', "");
    Expect(0, 1829, '\P{Jg=	_E}', "");
    Expect(1, 1829, '\P{^Jg=	_E}', "");
    Expect(0, 1830, '\p{Jg=	_E}', "");
    Expect(1, 1830, '\p{^Jg=	_E}', "");
    Expect(1, 1830, '\P{Jg=	_E}', "");
    Expect(0, 1830, '\P{^Jg=	_E}', "");
    Error('\p{Is_Joining_Group=:=  e}');
    Error('\P{Is_Joining_Group=:=  e}');
    Expect(1, 1829, '\p{Is_Joining_Group=e}', "");
    Expect(0, 1829, '\p{^Is_Joining_Group=e}', "");
    Expect(0, 1829, '\P{Is_Joining_Group=e}', "");
    Expect(1, 1829, '\P{^Is_Joining_Group=e}', "");
    Expect(0, 1830, '\p{Is_Joining_Group=e}', "");
    Expect(1, 1830, '\p{^Is_Joining_Group=e}', "");
    Expect(1, 1830, '\P{Is_Joining_Group=e}', "");
    Expect(0, 1830, '\P{^Is_Joining_Group=e}', "");
    Expect(1, 1829, '\p{Is_Joining_Group=_e}', "");
    Expect(0, 1829, '\p{^Is_Joining_Group=_e}', "");
    Expect(0, 1829, '\P{Is_Joining_Group=_e}', "");
    Expect(1, 1829, '\P{^Is_Joining_Group=_e}', "");
    Expect(0, 1830, '\p{Is_Joining_Group=_e}', "");
    Expect(1, 1830, '\p{^Is_Joining_Group=_e}', "");
    Expect(1, 1830, '\P{Is_Joining_Group=_e}', "");
    Expect(0, 1830, '\P{^Is_Joining_Group=_e}', "");
    Error('\p{Is_Jg=/a/E}');
    Error('\P{Is_Jg=/a/E}');
    Expect(1, 1829, '\p{Is_Jg=e}', "");
    Expect(0, 1829, '\p{^Is_Jg=e}', "");
    Expect(0, 1829, '\P{Is_Jg=e}', "");
    Expect(1, 1829, '\P{^Is_Jg=e}', "");
    Expect(0, 1830, '\p{Is_Jg=e}', "");
    Expect(1, 1830, '\p{^Is_Jg=e}', "");
    Expect(1, 1830, '\P{Is_Jg=e}', "");
    Expect(0, 1830, '\P{^Is_Jg=e}', "");
    Expect(1, 1829, '\p{Is_Jg:   _e}', "");
    Expect(0, 1829, '\p{^Is_Jg:   _e}', "");
    Expect(0, 1829, '\P{Is_Jg:   _e}', "");
    Expect(1, 1829, '\P{^Is_Jg:   _e}', "");
    Expect(0, 1830, '\p{Is_Jg:   _e}', "");
    Expect(1, 1830, '\p{^Is_Jg:   _e}', "");
    Expect(1, 1830, '\P{Is_Jg:   _e}', "");
    Expect(0, 1830, '\P{^Is_Jg:   _e}', "");
    Error('\p{Joining_Group:   :=-FARSI_YEH}');
    Error('\P{Joining_Group:   :=-FARSI_YEH}');
    Expect(1, 1910, '\p{Joining_Group=:\AFarsi_Yeh\z:}', "");;
    Expect(0, 1911, '\p{Joining_Group=:\AFarsi_Yeh\z:}', "");;
    Expect(1, 1910, '\p{Joining_Group=farsiyeh}', "");
    Expect(0, 1910, '\p{^Joining_Group=farsiyeh}', "");
    Expect(0, 1910, '\P{Joining_Group=farsiyeh}', "");
    Expect(1, 1910, '\P{^Joining_Group=farsiyeh}', "");
    Expect(0, 1911, '\p{Joining_Group=farsiyeh}', "");
    Expect(1, 1911, '\p{^Joining_Group=farsiyeh}', "");
    Expect(1, 1911, '\P{Joining_Group=farsiyeh}', "");
    Expect(0, 1911, '\P{^Joining_Group=farsiyeh}', "");
    Expect(1, 1910, '\p{Joining_Group=:\Afarsiyeh\z:}', "");;
    Expect(0, 1911, '\p{Joining_Group=:\Afarsiyeh\z:}', "");;
    Expect(1, 1910, '\p{Joining_Group= _FARSI_YEH}', "");
    Expect(0, 1910, '\p{^Joining_Group= _FARSI_YEH}', "");
    Expect(0, 1910, '\P{Joining_Group= _FARSI_YEH}', "");
    Expect(1, 1910, '\P{^Joining_Group= _FARSI_YEH}', "");
    Expect(0, 1911, '\p{Joining_Group= _FARSI_YEH}', "");
    Expect(1, 1911, '\p{^Joining_Group= _FARSI_YEH}', "");
    Expect(1, 1911, '\P{Joining_Group= _FARSI_YEH}', "");
    Expect(0, 1911, '\P{^Joining_Group= _FARSI_YEH}', "");
    Error('\p{Jg=:=-_Farsi_yeh}');
    Error('\P{Jg=:=-_Farsi_yeh}');
    Expect(1, 1910, '\p{Jg=:\AFarsi_Yeh\z:}', "");;
    Expect(0, 1911, '\p{Jg=:\AFarsi_Yeh\z:}', "");;
    Expect(1, 1910, '\p{Jg=farsiyeh}', "");
    Expect(0, 1910, '\p{^Jg=farsiyeh}', "");
    Expect(0, 1910, '\P{Jg=farsiyeh}', "");
    Expect(1, 1910, '\P{^Jg=farsiyeh}', "");
    Expect(0, 1911, '\p{Jg=farsiyeh}', "");
    Expect(1, 1911, '\p{^Jg=farsiyeh}', "");
    Expect(1, 1911, '\P{Jg=farsiyeh}', "");
    Expect(0, 1911, '\P{^Jg=farsiyeh}', "");
    Expect(1, 1910, '\p{Jg=:\Afarsiyeh\z:}', "");;
    Expect(0, 1911, '\p{Jg=:\Afarsiyeh\z:}', "");;
    Expect(1, 1910, '\p{Jg=	Farsi_yeh}', "");
    Expect(0, 1910, '\p{^Jg=	Farsi_yeh}', "");
    Expect(0, 1910, '\P{Jg=	Farsi_yeh}', "");
    Expect(1, 1910, '\P{^Jg=	Farsi_yeh}', "");
    Expect(0, 1911, '\p{Jg=	Farsi_yeh}', "");
    Expect(1, 1911, '\p{^Jg=	Farsi_yeh}', "");
    Expect(1, 1911, '\P{Jg=	Farsi_yeh}', "");
    Expect(0, 1911, '\P{^Jg=	Farsi_yeh}', "");
    Error('\p{Is_Joining_Group=	-farsi_Yeh:=}');
    Error('\P{Is_Joining_Group=	-farsi_Yeh:=}');
    Expect(1, 1910, '\p{Is_Joining_Group:   farsiyeh}', "");
    Expect(0, 1910, '\p{^Is_Joining_Group:   farsiyeh}', "");
    Expect(0, 1910, '\P{Is_Joining_Group:   farsiyeh}', "");
    Expect(1, 1910, '\P{^Is_Joining_Group:   farsiyeh}', "");
    Expect(0, 1911, '\p{Is_Joining_Group:   farsiyeh}', "");
    Expect(1, 1911, '\p{^Is_Joining_Group:   farsiyeh}', "");
    Expect(1, 1911, '\P{Is_Joining_Group:   farsiyeh}', "");
    Expect(0, 1911, '\P{^Is_Joining_Group:   farsiyeh}', "");
    Expect(1, 1910, '\p{Is_Joining_Group=		Farsi_Yeh}', "");
    Expect(0, 1910, '\p{^Is_Joining_Group=		Farsi_Yeh}', "");
    Expect(0, 1910, '\P{Is_Joining_Group=		Farsi_Yeh}', "");
    Expect(1, 1910, '\P{^Is_Joining_Group=		Farsi_Yeh}', "");
    Expect(0, 1911, '\p{Is_Joining_Group=		Farsi_Yeh}', "");
    Expect(1, 1911, '\p{^Is_Joining_Group=		Farsi_Yeh}', "");
    Expect(1, 1911, '\P{Is_Joining_Group=		Farsi_Yeh}', "");
    Expect(0, 1911, '\P{^Is_Joining_Group=		Farsi_Yeh}', "");
    Error('\p{Is_Jg= :=FARSI_yeh}');
    Error('\P{Is_Jg= :=FARSI_yeh}');
    Expect(1, 1910, '\p{Is_Jg: farsiyeh}', "");
    Expect(0, 1910, '\p{^Is_Jg: farsiyeh}', "");
    Expect(0, 1910, '\P{Is_Jg: farsiyeh}', "");
    Expect(1, 1910, '\P{^Is_Jg: farsiyeh}', "");
    Expect(0, 1911, '\p{Is_Jg: farsiyeh}', "");
    Expect(1, 1911, '\p{^Is_Jg: farsiyeh}', "");
    Expect(1, 1911, '\P{Is_Jg: farsiyeh}', "");
    Expect(0, 1911, '\P{^Is_Jg: farsiyeh}', "");
    Expect(1, 1910, '\p{Is_Jg=_ FARSI_YEH}', "");
    Expect(0, 1910, '\p{^Is_Jg=_ FARSI_YEH}', "");
    Expect(0, 1910, '\P{Is_Jg=_ FARSI_YEH}', "");
    Expect(1, 1910, '\P{^Is_Jg=_ FARSI_YEH}', "");
    Expect(0, 1911, '\p{Is_Jg=_ FARSI_YEH}', "");
    Expect(1, 1911, '\p{^Is_Jg=_ FARSI_YEH}', "");
    Expect(1, 1911, '\P{Is_Jg=_ FARSI_YEH}', "");
    Expect(0, 1911, '\P{^Is_Jg=_ FARSI_YEH}', "");
    Error('\p{Joining_Group=/a/  Fe}');
    Error('\P{Joining_Group=/a/  Fe}');
    Expect(1, 1871, '\p{Joining_Group=:\AFe\z:}', "");;
    Expect(0, 1872, '\p{Joining_Group=:\AFe\z:}', "");;
    Expect(1, 1871, '\p{Joining_Group=fe}', "");
    Expect(0, 1871, '\p{^Joining_Group=fe}', "");
    Expect(0, 1871, '\P{Joining_Group=fe}', "");
    Expect(1, 1871, '\P{^Joining_Group=fe}', "");
    Expect(0, 1872, '\p{Joining_Group=fe}', "");
    Expect(1, 1872, '\p{^Joining_Group=fe}', "");
    Expect(1, 1872, '\P{Joining_Group=fe}', "");
    Expect(0, 1872, '\P{^Joining_Group=fe}', "");
    Expect(1, 1871, '\p{Joining_Group=:\Afe\z:}', "");;
    Expect(0, 1872, '\p{Joining_Group=:\Afe\z:}', "");;
    Expect(1, 1871, '\p{Joining_Group=	_fe}', "");
    Expect(0, 1871, '\p{^Joining_Group=	_fe}', "");
    Expect(0, 1871, '\P{Joining_Group=	_fe}', "");
    Expect(1, 1871, '\P{^Joining_Group=	_fe}', "");
    Expect(0, 1872, '\p{Joining_Group=	_fe}', "");
    Expect(1, 1872, '\p{^Joining_Group=	_fe}', "");
    Expect(1, 1872, '\P{Joining_Group=	_fe}', "");
    Expect(0, 1872, '\P{^Joining_Group=	_fe}', "");
    Error('\p{Jg=_:=FE}');
    Error('\P{Jg=_:=FE}');
    Expect(1, 1871, '\p{Jg=:\AFe\z:}', "");;
    Expect(0, 1872, '\p{Jg=:\AFe\z:}', "");;
    Expect(1, 1871, '\p{Jg=fe}', "");
    Expect(0, 1871, '\p{^Jg=fe}', "");
    Expect(0, 1871, '\P{Jg=fe}', "");
    Expect(1, 1871, '\P{^Jg=fe}', "");
    Expect(0, 1872, '\p{Jg=fe}', "");
    Expect(1, 1872, '\p{^Jg=fe}', "");
    Expect(1, 1872, '\P{Jg=fe}', "");
    Expect(0, 1872, '\P{^Jg=fe}', "");
    Expect(1, 1871, '\p{Jg=:\Afe\z:}', "");;
    Expect(0, 1872, '\p{Jg=:\Afe\z:}', "");;
    Expect(1, 1871, '\p{Jg=	 fe}', "");
    Expect(0, 1871, '\p{^Jg=	 fe}', "");
    Expect(0, 1871, '\P{Jg=	 fe}', "");
    Expect(1, 1871, '\P{^Jg=	 fe}', "");
    Expect(0, 1872, '\p{Jg=	 fe}', "");
    Expect(1, 1872, '\p{^Jg=	 fe}', "");
    Expect(1, 1872, '\P{Jg=	 fe}', "");
    Expect(0, 1872, '\P{^Jg=	 fe}', "");
    Error('\p{Is_Joining_Group=:= FE}');
    Error('\P{Is_Joining_Group=:= FE}');
    Expect(1, 1871, '\p{Is_Joining_Group=fe}', "");
    Expect(0, 1871, '\p{^Is_Joining_Group=fe}', "");
    Expect(0, 1871, '\P{Is_Joining_Group=fe}', "");
    Expect(1, 1871, '\P{^Is_Joining_Group=fe}', "");
    Expect(0, 1872, '\p{Is_Joining_Group=fe}', "");
    Expect(1, 1872, '\p{^Is_Joining_Group=fe}', "");
    Expect(1, 1872, '\P{Is_Joining_Group=fe}', "");
    Expect(0, 1872, '\P{^Is_Joining_Group=fe}', "");
    Expect(1, 1871, '\p{Is_Joining_Group=	_Fe}', "");
    Expect(0, 1871, '\p{^Is_Joining_Group=	_Fe}', "");
    Expect(0, 1871, '\P{Is_Joining_Group=	_Fe}', "");
    Expect(1, 1871, '\P{^Is_Joining_Group=	_Fe}', "");
    Expect(0, 1872, '\p{Is_Joining_Group=	_Fe}', "");
    Expect(1, 1872, '\p{^Is_Joining_Group=	_Fe}', "");
    Expect(1, 1872, '\P{Is_Joining_Group=	_Fe}', "");
    Expect(0, 1872, '\P{^Is_Joining_Group=	_Fe}', "");
    Error('\p{Is_Jg=/a/ _Fe}');
    Error('\P{Is_Jg=/a/ _Fe}');
    Expect(1, 1871, '\p{Is_Jg:	fe}', "");
    Expect(0, 1871, '\p{^Is_Jg:	fe}', "");
    Expect(0, 1871, '\P{Is_Jg:	fe}', "");
    Expect(1, 1871, '\P{^Is_Jg:	fe}', "");
    Expect(0, 1872, '\p{Is_Jg:	fe}', "");
    Expect(1, 1872, '\p{^Is_Jg:	fe}', "");
    Expect(1, 1872, '\P{Is_Jg:	fe}', "");
    Expect(0, 1872, '\P{^Is_Jg:	fe}', "");
    Expect(1, 1871, '\p{Is_Jg:   _	fe}', "");
    Expect(0, 1871, '\p{^Is_Jg:   _	fe}', "");
    Expect(0, 1871, '\P{Is_Jg:   _	fe}', "");
    Expect(1, 1871, '\P{^Is_Jg:   _	fe}', "");
    Expect(0, 1872, '\p{Is_Jg:   _	fe}', "");
    Expect(1, 1872, '\p{^Is_Jg:   _	fe}', "");
    Expect(1, 1872, '\P{Is_Jg:   _	fe}', "");
    Expect(0, 1872, '\P{^Is_Jg:   _	fe}', "");
    Error('\p{Joining_Group: 	feh:=}');
    Error('\P{Joining_Group: 	feh:=}');
    Expect(1, 2212, '\p{Joining_Group=:\AFeh\z:}', "");;
    Expect(0, 2213, '\p{Joining_Group=:\AFeh\z:}', "");;
    Expect(1, 2212, '\p{Joining_Group=feh}', "");
    Expect(0, 2212, '\p{^Joining_Group=feh}', "");
    Expect(0, 2212, '\P{Joining_Group=feh}', "");
    Expect(1, 2212, '\P{^Joining_Group=feh}', "");
    Expect(0, 2213, '\p{Joining_Group=feh}', "");
    Expect(1, 2213, '\p{^Joining_Group=feh}', "");
    Expect(1, 2213, '\P{Joining_Group=feh}', "");
    Expect(0, 2213, '\P{^Joining_Group=feh}', "");
    Expect(1, 2212, '\p{Joining_Group=:\Afeh\z:}', "");;
    Expect(0, 2213, '\p{Joining_Group=:\Afeh\z:}', "");;
    Expect(1, 2212, '\p{Joining_Group=		Feh}', "");
    Expect(0, 2212, '\p{^Joining_Group=		Feh}', "");
    Expect(0, 2212, '\P{Joining_Group=		Feh}', "");
    Expect(1, 2212, '\P{^Joining_Group=		Feh}', "");
    Expect(0, 2213, '\p{Joining_Group=		Feh}', "");
    Expect(1, 2213, '\p{^Joining_Group=		Feh}', "");
    Expect(1, 2213, '\P{Joining_Group=		Feh}', "");
    Expect(0, 2213, '\P{^Joining_Group=		Feh}', "");
    Error('\p{Jg=-:=Feh}');
    Error('\P{Jg=-:=Feh}');
    Expect(1, 2212, '\p{Jg=:\AFeh\z:}', "");;
    Expect(0, 2213, '\p{Jg=:\AFeh\z:}', "");;
    Expect(1, 2212, '\p{Jg=feh}', "");
    Expect(0, 2212, '\p{^Jg=feh}', "");
    Expect(0, 2212, '\P{Jg=feh}', "");
    Expect(1, 2212, '\P{^Jg=feh}', "");
    Expect(0, 2213, '\p{Jg=feh}', "");
    Expect(1, 2213, '\p{^Jg=feh}', "");
    Expect(1, 2213, '\P{Jg=feh}', "");
    Expect(0, 2213, '\P{^Jg=feh}', "");
    Expect(1, 2212, '\p{Jg=:\Afeh\z:}', "");;
    Expect(0, 2213, '\p{Jg=:\Afeh\z:}', "");;
    Expect(1, 2212, '\p{Jg=	_feh}', "");
    Expect(0, 2212, '\p{^Jg=	_feh}', "");
    Expect(0, 2212, '\P{Jg=	_feh}', "");
    Expect(1, 2212, '\P{^Jg=	_feh}', "");
    Expect(0, 2213, '\p{Jg=	_feh}', "");
    Expect(1, 2213, '\p{^Jg=	_feh}', "");
    Expect(1, 2213, '\P{Jg=	_feh}', "");
    Expect(0, 2213, '\P{^Jg=	_feh}', "");
    Error('\p{Is_Joining_Group:   /a/ _feh}');
    Error('\P{Is_Joining_Group:   /a/ _feh}');
    Expect(1, 2212, '\p{Is_Joining_Group=feh}', "");
    Expect(0, 2212, '\p{^Is_Joining_Group=feh}', "");
    Expect(0, 2212, '\P{Is_Joining_Group=feh}', "");
    Expect(1, 2212, '\P{^Is_Joining_Group=feh}', "");
    Expect(0, 2213, '\p{Is_Joining_Group=feh}', "");
    Expect(1, 2213, '\p{^Is_Joining_Group=feh}', "");
    Expect(1, 2213, '\P{Is_Joining_Group=feh}', "");
    Expect(0, 2213, '\P{^Is_Joining_Group=feh}', "");
    Expect(1, 2212, '\p{Is_Joining_Group= -feh}', "");
    Expect(0, 2212, '\p{^Is_Joining_Group= -feh}', "");
    Expect(0, 2212, '\P{Is_Joining_Group= -feh}', "");
    Expect(1, 2212, '\P{^Is_Joining_Group= -feh}', "");
    Expect(0, 2213, '\p{Is_Joining_Group= -feh}', "");
    Expect(1, 2213, '\p{^Is_Joining_Group= -feh}', "");
    Expect(1, 2213, '\P{Is_Joining_Group= -feh}', "");
    Expect(0, 2213, '\P{^Is_Joining_Group= -feh}', "");
    Error('\p{Is_Jg=-:=Feh}');
    Error('\P{Is_Jg=-:=Feh}');
    Expect(1, 2212, '\p{Is_Jg=feh}', "");
    Expect(0, 2212, '\p{^Is_Jg=feh}', "");
    Expect(0, 2212, '\P{Is_Jg=feh}', "");
    Expect(1, 2212, '\P{^Is_Jg=feh}', "");
    Expect(0, 2213, '\p{Is_Jg=feh}', "");
    Expect(1, 2213, '\p{^Is_Jg=feh}', "");
    Expect(1, 2213, '\P{Is_Jg=feh}', "");
    Expect(0, 2213, '\P{^Is_Jg=feh}', "");
    Expect(1, 2212, '\p{Is_Jg=	Feh}', "");
    Expect(0, 2212, '\p{^Is_Jg=	Feh}', "");
    Expect(0, 2212, '\P{Is_Jg=	Feh}', "");
    Expect(1, 2212, '\P{^Is_Jg=	Feh}', "");
    Expect(0, 2213, '\p{Is_Jg=	Feh}', "");
    Expect(1, 2213, '\p{^Is_Jg=	Feh}', "");
    Expect(1, 2213, '\P{Is_Jg=	Feh}', "");
    Expect(0, 2213, '\P{^Is_Jg=	Feh}', "");
    Error('\p{Joining_Group=:=	-FINAL_Semkath}');
    Error('\P{Joining_Group=:=	-FINAL_Semkath}');
    Expect(1, 1828, '\p{Joining_Group=:\AFinal_Semkath\z:}', "");;
    Expect(0, 1829, '\p{Joining_Group=:\AFinal_Semkath\z:}', "");;
    Expect(1, 1828, '\p{Joining_Group=finalsemkath}', "");
    Expect(0, 1828, '\p{^Joining_Group=finalsemkath}', "");
    Expect(0, 1828, '\P{Joining_Group=finalsemkath}', "");
    Expect(1, 1828, '\P{^Joining_Group=finalsemkath}', "");
    Expect(0, 1829, '\p{Joining_Group=finalsemkath}', "");
    Expect(1, 1829, '\p{^Joining_Group=finalsemkath}', "");
    Expect(1, 1829, '\P{Joining_Group=finalsemkath}', "");
    Expect(0, 1829, '\P{^Joining_Group=finalsemkath}', "");
    Expect(1, 1828, '\p{Joining_Group=:\Afinalsemkath\z:}', "");;
    Expect(0, 1829, '\p{Joining_Group=:\Afinalsemkath\z:}', "");;
    Expect(1, 1828, '\p{Joining_Group=	-Final_semkath}', "");
    Expect(0, 1828, '\p{^Joining_Group=	-Final_semkath}', "");
    Expect(0, 1828, '\P{Joining_Group=	-Final_semkath}', "");
    Expect(1, 1828, '\P{^Joining_Group=	-Final_semkath}', "");
    Expect(0, 1829, '\p{Joining_Group=	-Final_semkath}', "");
    Expect(1, 1829, '\p{^Joining_Group=	-Final_semkath}', "");
    Expect(1, 1829, '\P{Joining_Group=	-Final_semkath}', "");
    Expect(0, 1829, '\P{^Joining_Group=	-Final_semkath}', "");
    Error('\p{Jg:/a/-final_Semkath}');
    Error('\P{Jg:/a/-final_Semkath}');
    Expect(1, 1828, '\p{Jg=:\AFinal_Semkath\z:}', "");;
    Expect(0, 1829, '\p{Jg=:\AFinal_Semkath\z:}', "");;
    Expect(1, 1828, '\p{Jg=finalsemkath}', "");
    Expect(0, 1828, '\p{^Jg=finalsemkath}', "");
    Expect(0, 1828, '\P{Jg=finalsemkath}', "");
    Expect(1, 1828, '\P{^Jg=finalsemkath}', "");
    Expect(0, 1829, '\p{Jg=finalsemkath}', "");
    Expect(1, 1829, '\p{^Jg=finalsemkath}', "");
    Expect(1, 1829, '\P{Jg=finalsemkath}', "");
    Expect(0, 1829, '\P{^Jg=finalsemkath}', "");
    Expect(1, 1828, '\p{Jg=:\Afinalsemkath\z:}', "");;
    Expect(0, 1829, '\p{Jg=:\Afinalsemkath\z:}', "");;
    Expect(1, 1828, '\p{Jg= -Final_Semkath}', "");
    Expect(0, 1828, '\p{^Jg= -Final_Semkath}', "");
    Expect(0, 1828, '\P{Jg= -Final_Semkath}', "");
    Expect(1, 1828, '\P{^Jg= -Final_Semkath}', "");
    Expect(0, 1829, '\p{Jg= -Final_Semkath}', "");
    Expect(1, 1829, '\p{^Jg= -Final_Semkath}', "");
    Expect(1, 1829, '\P{Jg= -Final_Semkath}', "");
    Expect(0, 1829, '\P{^Jg= -Final_Semkath}', "");
    Error('\p{Is_Joining_Group=:=-Final_SEMKATH}');
    Error('\P{Is_Joining_Group=:=-Final_SEMKATH}');
    Expect(1, 1828, '\p{Is_Joining_Group=finalsemkath}', "");
    Expect(0, 1828, '\p{^Is_Joining_Group=finalsemkath}', "");
    Expect(0, 1828, '\P{Is_Joining_Group=finalsemkath}', "");
    Expect(1, 1828, '\P{^Is_Joining_Group=finalsemkath}', "");
    Expect(0, 1829, '\p{Is_Joining_Group=finalsemkath}', "");
    Expect(1, 1829, '\p{^Is_Joining_Group=finalsemkath}', "");
    Expect(1, 1829, '\P{Is_Joining_Group=finalsemkath}', "");
    Expect(0, 1829, '\P{^Is_Joining_Group=finalsemkath}', "");
    Expect(1, 1828, '\p{Is_Joining_Group:Final_SEMKATH}', "");
    Expect(0, 1828, '\p{^Is_Joining_Group:Final_SEMKATH}', "");
    Expect(0, 1828, '\P{Is_Joining_Group:Final_SEMKATH}', "");
    Expect(1, 1828, '\P{^Is_Joining_Group:Final_SEMKATH}', "");
    Expect(0, 1829, '\p{Is_Joining_Group:Final_SEMKATH}', "");
    Expect(1, 1829, '\p{^Is_Joining_Group:Final_SEMKATH}', "");
    Expect(1, 1829, '\P{Is_Joining_Group:Final_SEMKATH}', "");
    Expect(0, 1829, '\P{^Is_Joining_Group:Final_SEMKATH}', "");
    Error('\p{Is_Jg=:=- FINAL_SEMKATH}');
    Error('\P{Is_Jg=:=- FINAL_SEMKATH}');
    Expect(1, 1828, '\p{Is_Jg=finalsemkath}', "");
    Expect(0, 1828, '\p{^Is_Jg=finalsemkath}', "");
    Expect(0, 1828, '\P{Is_Jg=finalsemkath}', "");
    Expect(1, 1828, '\P{^Is_Jg=finalsemkath}', "");
    Expect(0, 1829, '\p{Is_Jg=finalsemkath}', "");
    Expect(1, 1829, '\p{^Is_Jg=finalsemkath}', "");
    Expect(1, 1829, '\P{Is_Jg=finalsemkath}', "");
    Expect(0, 1829, '\P{^Is_Jg=finalsemkath}', "");
    Expect(1, 1828, '\p{Is_Jg=	 FINAL_Semkath}', "");
    Expect(0, 1828, '\p{^Is_Jg=	 FINAL_Semkath}', "");
    Expect(0, 1828, '\P{Is_Jg=	 FINAL_Semkath}', "");
    Expect(1, 1828, '\P{^Is_Jg=	 FINAL_Semkath}', "");
    Expect(0, 1829, '\p{Is_Jg=	 FINAL_Semkath}', "");
    Expect(1, 1829, '\p{^Is_Jg=	 FINAL_Semkath}', "");
    Expect(1, 1829, '\P{Is_Jg=	 FINAL_Semkath}', "");
    Expect(0, 1829, '\P{^Is_Jg=	 FINAL_Semkath}', "");
    Error('\p{Joining_Group: /a/gaf}');
    Error('\P{Joining_Group: /a/gaf}');
    Expect(1, 2224, '\p{Joining_Group=:\AGaf\z:}', "");;
    Expect(0, 2225, '\p{Joining_Group=:\AGaf\z:}', "");;
    Expect(1, 2224, '\p{Joining_Group=gaf}', "");
    Expect(0, 2224, '\p{^Joining_Group=gaf}', "");
    Expect(0, 2224, '\P{Joining_Group=gaf}', "");
    Expect(1, 2224, '\P{^Joining_Group=gaf}', "");
    Expect(0, 2225, '\p{Joining_Group=gaf}', "");
    Expect(1, 2225, '\p{^Joining_Group=gaf}', "");
    Expect(1, 2225, '\P{Joining_Group=gaf}', "");
    Expect(0, 2225, '\P{^Joining_Group=gaf}', "");
    Expect(1, 2224, '\p{Joining_Group=:\Agaf\z:}', "");;
    Expect(0, 2225, '\p{Joining_Group=:\Agaf\z:}', "");;
    Expect(1, 2224, '\p{Joining_Group=--GAF}', "");
    Expect(0, 2224, '\p{^Joining_Group=--GAF}', "");
    Expect(0, 2224, '\P{Joining_Group=--GAF}', "");
    Expect(1, 2224, '\P{^Joining_Group=--GAF}', "");
    Expect(0, 2225, '\p{Joining_Group=--GAF}', "");
    Expect(1, 2225, '\p{^Joining_Group=--GAF}', "");
    Expect(1, 2225, '\P{Joining_Group=--GAF}', "");
    Expect(0, 2225, '\P{^Joining_Group=--GAF}', "");
    Error('\p{Jg=	_GAF:=}');
    Error('\P{Jg=	_GAF:=}');
    Expect(1, 2224, '\p{Jg=:\AGaf\z:}', "");;
    Expect(0, 2225, '\p{Jg=:\AGaf\z:}', "");;
    Expect(1, 2224, '\p{Jg=gaf}', "");
    Expect(0, 2224, '\p{^Jg=gaf}', "");
    Expect(0, 2224, '\P{Jg=gaf}', "");
    Expect(1, 2224, '\P{^Jg=gaf}', "");
    Expect(0, 2225, '\p{Jg=gaf}', "");
    Expect(1, 2225, '\p{^Jg=gaf}', "");
    Expect(1, 2225, '\P{Jg=gaf}', "");
    Expect(0, 2225, '\P{^Jg=gaf}', "");
    Expect(1, 2224, '\p{Jg=:\Agaf\z:}', "");;
    Expect(0, 2225, '\p{Jg=:\Agaf\z:}', "");;
    Expect(1, 2224, '\p{Jg=-gaf}', "");
    Expect(0, 2224, '\p{^Jg=-gaf}', "");
    Expect(0, 2224, '\P{Jg=-gaf}', "");
    Expect(1, 2224, '\P{^Jg=-gaf}', "");
    Expect(0, 2225, '\p{Jg=-gaf}', "");
    Expect(1, 2225, '\p{^Jg=-gaf}', "");
    Expect(1, 2225, '\P{Jg=-gaf}', "");
    Expect(0, 2225, '\P{^Jg=-gaf}', "");
    Error('\p{Is_Joining_Group:   /a/_GAF}');
    Error('\P{Is_Joining_Group:   /a/_GAF}');
    Expect(1, 2224, '\p{Is_Joining_Group=gaf}', "");
    Expect(0, 2224, '\p{^Is_Joining_Group=gaf}', "");
    Expect(0, 2224, '\P{Is_Joining_Group=gaf}', "");
    Expect(1, 2224, '\P{^Is_Joining_Group=gaf}', "");
    Expect(0, 2225, '\p{Is_Joining_Group=gaf}', "");
    Expect(1, 2225, '\p{^Is_Joining_Group=gaf}', "");
    Expect(1, 2225, '\P{Is_Joining_Group=gaf}', "");
    Expect(0, 2225, '\P{^Is_Joining_Group=gaf}', "");
    Expect(1, 2224, '\p{Is_Joining_Group=	-GAF}', "");
    Expect(0, 2224, '\p{^Is_Joining_Group=	-GAF}', "");
    Expect(0, 2224, '\P{Is_Joining_Group=	-GAF}', "");
    Expect(1, 2224, '\P{^Is_Joining_Group=	-GAF}', "");
    Expect(0, 2225, '\p{Is_Joining_Group=	-GAF}', "");
    Expect(1, 2225, '\p{^Is_Joining_Group=	-GAF}', "");
    Expect(1, 2225, '\P{Is_Joining_Group=	-GAF}', "");
    Expect(0, 2225, '\P{^Is_Joining_Group=	-GAF}', "");
    Error('\p{Is_Jg=-_gaf/a/}');
    Error('\P{Is_Jg=-_gaf/a/}');
    Expect(1, 2224, '\p{Is_Jg=gaf}', "");
    Expect(0, 2224, '\p{^Is_Jg=gaf}', "");
    Expect(0, 2224, '\P{Is_Jg=gaf}', "");
    Expect(1, 2224, '\P{^Is_Jg=gaf}', "");
    Expect(0, 2225, '\p{Is_Jg=gaf}', "");
    Expect(1, 2225, '\p{^Is_Jg=gaf}', "");
    Expect(1, 2225, '\P{Is_Jg=gaf}', "");
    Expect(0, 2225, '\P{^Is_Jg=gaf}', "");
    Expect(1, 2224, '\p{Is_Jg: -	Gaf}', "");
    Expect(0, 2224, '\p{^Is_Jg: -	Gaf}', "");
    Expect(0, 2224, '\P{Is_Jg: -	Gaf}', "");
    Expect(1, 2224, '\P{^Is_Jg: -	Gaf}', "");
    Expect(0, 2225, '\p{Is_Jg: -	Gaf}', "");
    Expect(1, 2225, '\p{^Is_Jg: -	Gaf}', "");
    Expect(1, 2225, '\P{Is_Jg: -	Gaf}', "");
    Expect(0, 2225, '\P{^Is_Jg: -	Gaf}', "");
    Error('\p{Joining_Group:   _/a/Gamal}');
    Error('\P{Joining_Group:   _/a/Gamal}');
    Expect(1, 1838, '\p{Joining_Group=:\AGamal\z:}', "");;
    Expect(0, 1839, '\p{Joining_Group=:\AGamal\z:}', "");;
    Expect(1, 1838, '\p{Joining_Group=gamal}', "");
    Expect(0, 1838, '\p{^Joining_Group=gamal}', "");
    Expect(0, 1838, '\P{Joining_Group=gamal}', "");
    Expect(1, 1838, '\P{^Joining_Group=gamal}', "");
    Expect(0, 1839, '\p{Joining_Group=gamal}', "");
    Expect(1, 1839, '\p{^Joining_Group=gamal}', "");
    Expect(1, 1839, '\P{Joining_Group=gamal}', "");
    Expect(0, 1839, '\P{^Joining_Group=gamal}', "");
    Expect(1, 1838, '\p{Joining_Group=:\Agamal\z:}', "");;
    Expect(0, 1839, '\p{Joining_Group=:\Agamal\z:}', "");;
    Expect(1, 1838, '\p{Joining_Group=	Gamal}', "");
    Expect(0, 1838, '\p{^Joining_Group=	Gamal}', "");
    Expect(0, 1838, '\P{Joining_Group=	Gamal}', "");
    Expect(1, 1838, '\P{^Joining_Group=	Gamal}', "");
    Expect(0, 1839, '\p{Joining_Group=	Gamal}', "");
    Expect(1, 1839, '\p{^Joining_Group=	Gamal}', "");
    Expect(1, 1839, '\P{Joining_Group=	Gamal}', "");
    Expect(0, 1839, '\P{^Joining_Group=	Gamal}', "");
    Error('\p{Jg=/a/gamal}');
    Error('\P{Jg=/a/gamal}');
    Expect(1, 1838, '\p{Jg=:\AGamal\z:}', "");;
    Expect(0, 1839, '\p{Jg=:\AGamal\z:}', "");;
    Expect(1, 1838, '\p{Jg=gamal}', "");
    Expect(0, 1838, '\p{^Jg=gamal}', "");
    Expect(0, 1838, '\P{Jg=gamal}', "");
    Expect(1, 1838, '\P{^Jg=gamal}', "");
    Expect(0, 1839, '\p{Jg=gamal}', "");
    Expect(1, 1839, '\p{^Jg=gamal}', "");
    Expect(1, 1839, '\P{Jg=gamal}', "");
    Expect(0, 1839, '\P{^Jg=gamal}', "");
    Expect(1, 1838, '\p{Jg=:\Agamal\z:}', "");;
    Expect(0, 1839, '\p{Jg=:\Agamal\z:}', "");;
    Expect(1, 1838, '\p{Jg=		Gamal}', "");
    Expect(0, 1838, '\p{^Jg=		Gamal}', "");
    Expect(0, 1838, '\P{Jg=		Gamal}', "");
    Expect(1, 1838, '\P{^Jg=		Gamal}', "");
    Expect(0, 1839, '\p{Jg=		Gamal}', "");
    Expect(1, 1839, '\p{^Jg=		Gamal}', "");
    Expect(1, 1839, '\P{Jg=		Gamal}', "");
    Expect(0, 1839, '\P{^Jg=		Gamal}', "");
    Error('\p{Is_Joining_Group= Gamal/a/}');
    Error('\P{Is_Joining_Group= Gamal/a/}');
    Expect(1, 1838, '\p{Is_Joining_Group:	gamal}', "");
    Expect(0, 1838, '\p{^Is_Joining_Group:	gamal}', "");
    Expect(0, 1838, '\P{Is_Joining_Group:	gamal}', "");
    Expect(1, 1838, '\P{^Is_Joining_Group:	gamal}', "");
    Expect(0, 1839, '\p{Is_Joining_Group:	gamal}', "");
    Expect(1, 1839, '\p{^Is_Joining_Group:	gamal}', "");
    Expect(1, 1839, '\P{Is_Joining_Group:	gamal}', "");
    Expect(0, 1839, '\P{^Is_Joining_Group:	gamal}', "");
    Expect(1, 1838, '\p{Is_Joining_Group=	-Gamal}', "");
    Expect(0, 1838, '\p{^Is_Joining_Group=	-Gamal}', "");
    Expect(0, 1838, '\P{Is_Joining_Group=	-Gamal}', "");
    Expect(1, 1838, '\P{^Is_Joining_Group=	-Gamal}', "");
    Expect(0, 1839, '\p{Is_Joining_Group=	-Gamal}', "");
    Expect(1, 1839, '\p{^Is_Joining_Group=	-Gamal}', "");
    Expect(1, 1839, '\P{Is_Joining_Group=	-Gamal}', "");
    Expect(0, 1839, '\P{^Is_Joining_Group=	-Gamal}', "");
    Error('\p{Is_Jg=/a/-Gamal}');
    Error('\P{Is_Jg=/a/-Gamal}');
    Expect(1, 1838, '\p{Is_Jg=gamal}', "");
    Expect(0, 1838, '\p{^Is_Jg=gamal}', "");
    Expect(0, 1838, '\P{Is_Jg=gamal}', "");
    Expect(1, 1838, '\P{^Is_Jg=gamal}', "");
    Expect(0, 1839, '\p{Is_Jg=gamal}', "");
    Expect(1, 1839, '\p{^Is_Jg=gamal}', "");
    Expect(1, 1839, '\P{Is_Jg=gamal}', "");
    Expect(0, 1839, '\P{^Is_Jg=gamal}', "");
    Expect(1, 1838, '\p{Is_Jg= Gamal}', "");
    Expect(0, 1838, '\p{^Is_Jg= Gamal}', "");
    Expect(0, 1838, '\P{Is_Jg= Gamal}', "");
    Expect(1, 1838, '\P{^Is_Jg= Gamal}', "");
    Expect(0, 1839, '\p{Is_Jg= Gamal}', "");
    Expect(1, 1839, '\p{^Is_Jg= Gamal}', "");
    Expect(1, 1839, '\P{Is_Jg= Gamal}', "");
    Expect(0, 1839, '\P{^Is_Jg= Gamal}', "");
    Error('\p{Joining_Group=:=_	Hah}');
    Error('\P{Joining_Group=:=_	Hah}');
    Expect(1, 2210, '\p{Joining_Group=:\AHah\z:}', "");;
    Expect(0, 2211, '\p{Joining_Group=:\AHah\z:}', "");;
    Expect(1, 2210, '\p{Joining_Group=hah}', "");
    Expect(0, 2210, '\p{^Joining_Group=hah}', "");
    Expect(0, 2210, '\P{Joining_Group=hah}', "");
    Expect(1, 2210, '\P{^Joining_Group=hah}', "");
    Expect(0, 2211, '\p{Joining_Group=hah}', "");
    Expect(1, 2211, '\p{^Joining_Group=hah}', "");
    Expect(1, 2211, '\P{Joining_Group=hah}', "");
    Expect(0, 2211, '\P{^Joining_Group=hah}', "");
    Expect(1, 2210, '\p{Joining_Group=:\Ahah\z:}', "");;
    Expect(0, 2211, '\p{Joining_Group=:\Ahah\z:}', "");;
    Expect(1, 2210, '\p{Joining_Group=  Hah}', "");
    Expect(0, 2210, '\p{^Joining_Group=  Hah}', "");
    Expect(0, 2210, '\P{Joining_Group=  Hah}', "");
    Expect(1, 2210, '\P{^Joining_Group=  Hah}', "");
    Expect(0, 2211, '\p{Joining_Group=  Hah}', "");
    Expect(1, 2211, '\p{^Joining_Group=  Hah}', "");
    Expect(1, 2211, '\P{Joining_Group=  Hah}', "");
    Expect(0, 2211, '\P{^Joining_Group=  Hah}', "");
    Error('\p{Jg=/a/ -Hah}');
    Error('\P{Jg=/a/ -Hah}');
    Expect(1, 2210, '\p{Jg=:\AHah\z:}', "");;
    Expect(0, 2211, '\p{Jg=:\AHah\z:}', "");;
    Expect(1, 2210, '\p{Jg=hah}', "");
    Expect(0, 2210, '\p{^Jg=hah}', "");
    Expect(0, 2210, '\P{Jg=hah}', "");
    Expect(1, 2210, '\P{^Jg=hah}', "");
    Expect(0, 2211, '\p{Jg=hah}', "");
    Expect(1, 2211, '\p{^Jg=hah}', "");
    Expect(1, 2211, '\P{Jg=hah}', "");
    Expect(0, 2211, '\P{^Jg=hah}', "");
    Expect(1, 2210, '\p{Jg=:\Ahah\z:}', "");;
    Expect(0, 2211, '\p{Jg=:\Ahah\z:}', "");;
    Expect(1, 2210, '\p{Jg:_hah}', "");
    Expect(0, 2210, '\p{^Jg:_hah}', "");
    Expect(0, 2210, '\P{Jg:_hah}', "");
    Expect(1, 2210, '\P{^Jg:_hah}', "");
    Expect(0, 2211, '\p{Jg:_hah}', "");
    Expect(1, 2211, '\p{^Jg:_hah}', "");
    Expect(1, 2211, '\P{Jg:_hah}', "");
    Expect(0, 2211, '\P{^Jg:_hah}', "");
    Error('\p{Is_Joining_Group= :=HAH}');
    Error('\P{Is_Joining_Group= :=HAH}');
    Expect(1, 2210, '\p{Is_Joining_Group:   hah}', "");
    Expect(0, 2210, '\p{^Is_Joining_Group:   hah}', "");
    Expect(0, 2210, '\P{Is_Joining_Group:   hah}', "");
    Expect(1, 2210, '\P{^Is_Joining_Group:   hah}', "");
    Expect(0, 2211, '\p{Is_Joining_Group:   hah}', "");
    Expect(1, 2211, '\p{^Is_Joining_Group:   hah}', "");
    Expect(1, 2211, '\P{Is_Joining_Group:   hah}', "");
    Expect(0, 2211, '\P{^Is_Joining_Group:   hah}', "");
    Expect(1, 2210, '\p{Is_Joining_Group=	hah}', "");
    Expect(0, 2210, '\p{^Is_Joining_Group=	hah}', "");
    Expect(0, 2210, '\P{Is_Joining_Group=	hah}', "");
    Expect(1, 2210, '\P{^Is_Joining_Group=	hah}', "");
    Expect(0, 2211, '\p{Is_Joining_Group=	hah}', "");
    Expect(1, 2211, '\p{^Is_Joining_Group=	hah}', "");
    Expect(1, 2211, '\P{Is_Joining_Group=	hah}', "");
    Expect(0, 2211, '\P{^Is_Joining_Group=	hah}', "");
    Error('\p{Is_Jg=:=- Hah}');
    Error('\P{Is_Jg=:=- Hah}');
    Expect(1, 2210, '\p{Is_Jg=hah}', "");
    Expect(0, 2210, '\p{^Is_Jg=hah}', "");
    Expect(0, 2210, '\P{Is_Jg=hah}', "");
    Expect(1, 2210, '\P{^Is_Jg=hah}', "");
    Expect(0, 2211, '\p{Is_Jg=hah}', "");
    Expect(1, 2211, '\p{^Is_Jg=hah}', "");
    Expect(1, 2211, '\P{Is_Jg=hah}', "");
    Expect(0, 2211, '\P{^Is_Jg=hah}', "");
    Expect(1, 2210, '\p{Is_Jg=	Hah}', "");
    Expect(0, 2210, '\p{^Is_Jg=	Hah}', "");
    Expect(0, 2210, '\P{Is_Jg=	Hah}', "");
    Expect(1, 2210, '\P{^Is_Jg=	Hah}', "");
    Expect(0, 2211, '\p{Is_Jg=	Hah}', "");
    Expect(1, 2211, '\p{^Is_Jg=	Hah}', "");
    Expect(1, 2211, '\P{Is_Jg=	Hah}', "");
    Expect(0, 2211, '\P{^Is_Jg=	Hah}', "");
    Error('\p{Joining_Group=	hanifi_rohingya_KINNA_Ya/a/}');
    Error('\P{Joining_Group=	hanifi_rohingya_KINNA_Ya/a/}');
    Expect(1, 68899, '\p{Joining_Group=:\AHanifi_Rohingya_Kinna_Ya\z:}', "");;
    Expect(0, 68900, '\p{Joining_Group=:\AHanifi_Rohingya_Kinna_Ya\z:}', "");;
    Expect(1, 68899, '\p{Joining_Group=hanifirohingyakinnaya}', "");
    Expect(0, 68899, '\p{^Joining_Group=hanifirohingyakinnaya}', "");
    Expect(0, 68899, '\P{Joining_Group=hanifirohingyakinnaya}', "");
    Expect(1, 68899, '\P{^Joining_Group=hanifirohingyakinnaya}', "");
    Expect(0, 68900, '\p{Joining_Group=hanifirohingyakinnaya}', "");
    Expect(1, 68900, '\p{^Joining_Group=hanifirohingyakinnaya}', "");
    Expect(1, 68900, '\P{Joining_Group=hanifirohingyakinnaya}', "");
    Expect(0, 68900, '\P{^Joining_Group=hanifirohingyakinnaya}', "");
    Expect(1, 68899, '\p{Joining_Group=:\Ahanifirohingyakinnaya\z:}', "");;
    Expect(0, 68900, '\p{Joining_Group=:\Ahanifirohingyakinnaya\z:}', "");;
    Expect(1, 68899, '\p{Joining_Group=_ Hanifi_ROHINGYA_Kinna_YA}', "");
    Expect(0, 68899, '\p{^Joining_Group=_ Hanifi_ROHINGYA_Kinna_YA}', "");
    Expect(0, 68899, '\P{Joining_Group=_ Hanifi_ROHINGYA_Kinna_YA}', "");
    Expect(1, 68899, '\P{^Joining_Group=_ Hanifi_ROHINGYA_Kinna_YA}', "");
    Expect(0, 68900, '\p{Joining_Group=_ Hanifi_ROHINGYA_Kinna_YA}', "");
    Expect(1, 68900, '\p{^Joining_Group=_ Hanifi_ROHINGYA_Kinna_YA}', "");
    Expect(1, 68900, '\P{Joining_Group=_ Hanifi_ROHINGYA_Kinna_YA}', "");
    Expect(0, 68900, '\P{^Joining_Group=_ Hanifi_ROHINGYA_Kinna_YA}', "");
    Error('\p{Jg=:=-hanifi_Rohingya_Kinna_Ya}');
    Error('\P{Jg=:=-hanifi_Rohingya_Kinna_Ya}');
    Expect(1, 68899, '\p{Jg=:\AHanifi_Rohingya_Kinna_Ya\z:}', "");;
    Expect(0, 68900, '\p{Jg=:\AHanifi_Rohingya_Kinna_Ya\z:}', "");;
    Expect(1, 68899, '\p{Jg=hanifirohingyakinnaya}', "");
    Expect(0, 68899, '\p{^Jg=hanifirohingyakinnaya}', "");
    Expect(0, 68899, '\P{Jg=hanifirohingyakinnaya}', "");
    Expect(1, 68899, '\P{^Jg=hanifirohingyakinnaya}', "");
    Expect(0, 68900, '\p{Jg=hanifirohingyakinnaya}', "");
    Expect(1, 68900, '\p{^Jg=hanifirohingyakinnaya}', "");
    Expect(1, 68900, '\P{Jg=hanifirohingyakinnaya}', "");
    Expect(0, 68900, '\P{^Jg=hanifirohingyakinnaya}', "");
    Expect(1, 68899, '\p{Jg=:\Ahanifirohingyakinnaya\z:}', "");;
    Expect(0, 68900, '\p{Jg=:\Ahanifirohingyakinnaya\z:}', "");;
    Expect(1, 68899, '\p{Jg= -Hanifi_Rohingya_KINNA_Ya}', "");
    Expect(0, 68899, '\p{^Jg= -Hanifi_Rohingya_KINNA_Ya}', "");
    Expect(0, 68899, '\P{Jg= -Hanifi_Rohingya_KINNA_Ya}', "");
    Expect(1, 68899, '\P{^Jg= -Hanifi_Rohingya_KINNA_Ya}', "");
    Expect(0, 68900, '\p{Jg= -Hanifi_Rohingya_KINNA_Ya}', "");
    Expect(1, 68900, '\p{^Jg= -Hanifi_Rohingya_KINNA_Ya}', "");
    Expect(1, 68900, '\P{Jg= -Hanifi_Rohingya_KINNA_Ya}', "");
    Expect(0, 68900, '\P{^Jg= -Hanifi_Rohingya_KINNA_Ya}', "");
    Error('\p{Is_Joining_Group=-	hanifi_Rohingya_Kinna_Ya/a/}');
    Error('\P{Is_Joining_Group=-	hanifi_Rohingya_Kinna_Ya/a/}');
    Expect(1, 68899, '\p{Is_Joining_Group=hanifirohingyakinnaya}', "");
    Expect(0, 68899, '\p{^Is_Joining_Group=hanifirohingyakinnaya}', "");
    Expect(0, 68899, '\P{Is_Joining_Group=hanifirohingyakinnaya}', "");
    Expect(1, 68899, '\P{^Is_Joining_Group=hanifirohingyakinnaya}', "");
    Expect(0, 68900, '\p{Is_Joining_Group=hanifirohingyakinnaya}', "");
    Expect(1, 68900, '\p{^Is_Joining_Group=hanifirohingyakinnaya}', "");
    Expect(1, 68900, '\P{Is_Joining_Group=hanifirohingyakinnaya}', "");
    Expect(0, 68900, '\P{^Is_Joining_Group=hanifirohingyakinnaya}', "");
    Expect(1, 68899, '\p{Is_Joining_Group=-Hanifi_rohingya_kinna_Ya}', "");
    Expect(0, 68899, '\p{^Is_Joining_Group=-Hanifi_rohingya_kinna_Ya}', "");
    Expect(0, 68899, '\P{Is_Joining_Group=-Hanifi_rohingya_kinna_Ya}', "");
    Expect(1, 68899, '\P{^Is_Joining_Group=-Hanifi_rohingya_kinna_Ya}', "");
    Expect(0, 68900, '\p{Is_Joining_Group=-Hanifi_rohingya_kinna_Ya}', "");
    Expect(1, 68900, '\p{^Is_Joining_Group=-Hanifi_rohingya_kinna_Ya}', "");
    Expect(1, 68900, '\P{Is_Joining_Group=-Hanifi_rohingya_kinna_Ya}', "");
    Expect(0, 68900, '\P{^Is_Joining_Group=-Hanifi_rohingya_kinna_Ya}', "");
    Error('\p{Is_Jg=_/a/hanifi_rohingya_Kinna_Ya}');
    Error('\P{Is_Jg=_/a/hanifi_rohingya_Kinna_Ya}');
    Expect(1, 68899, '\p{Is_Jg:	hanifirohingyakinnaya}', "");
    Expect(0, 68899, '\p{^Is_Jg:	hanifirohingyakinnaya}', "");
    Expect(0, 68899, '\P{Is_Jg:	hanifirohingyakinnaya}', "");
    Expect(1, 68899, '\P{^Is_Jg:	hanifirohingyakinnaya}', "");
    Expect(0, 68900, '\p{Is_Jg:	hanifirohingyakinnaya}', "");
    Expect(1, 68900, '\p{^Is_Jg:	hanifirohingyakinnaya}', "");
    Expect(1, 68900, '\P{Is_Jg:	hanifirohingyakinnaya}', "");
    Expect(0, 68900, '\P{^Is_Jg:	hanifirohingyakinnaya}', "");
    Expect(1, 68899, '\p{Is_Jg=-Hanifi_ROHINGYA_Kinna_Ya}', "");
    Expect(0, 68899, '\p{^Is_Jg=-Hanifi_ROHINGYA_Kinna_Ya}', "");
    Expect(0, 68899, '\P{Is_Jg=-Hanifi_ROHINGYA_Kinna_Ya}', "");
    Expect(1, 68899, '\P{^Is_Jg=-Hanifi_ROHINGYA_Kinna_Ya}', "");
    Expect(0, 68900, '\p{Is_Jg=-Hanifi_ROHINGYA_Kinna_Ya}', "");
    Expect(1, 68900, '\p{^Is_Jg=-Hanifi_ROHINGYA_Kinna_Ya}', "");
    Expect(1, 68900, '\P{Is_Jg=-Hanifi_ROHINGYA_Kinna_Ya}', "");
    Expect(0, 68900, '\P{^Is_Jg=-Hanifi_ROHINGYA_Kinna_Ya}', "");
    Error('\p{Joining_Group=_/a/HANIFI_rohingya_pa}');
    Error('\P{Joining_Group=_/a/HANIFI_rohingya_pa}');
    Expect(1, 68892, '\p{Joining_Group=:\AHanifi_Rohingya_Pa\z:}', "");;
    Expect(0, 68893, '\p{Joining_Group=:\AHanifi_Rohingya_Pa\z:}', "");;
    Expect(1, 68892, '\p{Joining_Group=hanifirohingyapa}', "");
    Expect(0, 68892, '\p{^Joining_Group=hanifirohingyapa}', "");
    Expect(0, 68892, '\P{Joining_Group=hanifirohingyapa}', "");
    Expect(1, 68892, '\P{^Joining_Group=hanifirohingyapa}', "");
    Expect(0, 68893, '\p{Joining_Group=hanifirohingyapa}', "");
    Expect(1, 68893, '\p{^Joining_Group=hanifirohingyapa}', "");
    Expect(1, 68893, '\P{Joining_Group=hanifirohingyapa}', "");
    Expect(0, 68893, '\P{^Joining_Group=hanifirohingyapa}', "");
    Expect(1, 68892, '\p{Joining_Group=:\Ahanifirohingyapa\z:}', "");;
    Expect(0, 68893, '\p{Joining_Group=:\Ahanifirohingyapa\z:}', "");;
    Expect(1, 68892, '\p{Joining_Group=-	Hanifi_Rohingya_Pa}', "");
    Expect(0, 68892, '\p{^Joining_Group=-	Hanifi_Rohingya_Pa}', "");
    Expect(0, 68892, '\P{Joining_Group=-	Hanifi_Rohingya_Pa}', "");
    Expect(1, 68892, '\P{^Joining_Group=-	Hanifi_Rohingya_Pa}', "");
    Expect(0, 68893, '\p{Joining_Group=-	Hanifi_Rohingya_Pa}', "");
    Expect(1, 68893, '\p{^Joining_Group=-	Hanifi_Rohingya_Pa}', "");
    Expect(1, 68893, '\P{Joining_Group=-	Hanifi_Rohingya_Pa}', "");
    Expect(0, 68893, '\P{^Joining_Group=-	Hanifi_Rohingya_Pa}', "");
    Error('\p{Jg= :=Hanifi_Rohingya_Pa}');
    Error('\P{Jg= :=Hanifi_Rohingya_Pa}');
    Expect(1, 68892, '\p{Jg=:\AHanifi_Rohingya_Pa\z:}', "");;
    Expect(0, 68893, '\p{Jg=:\AHanifi_Rohingya_Pa\z:}', "");;
    Expect(1, 68892, '\p{Jg=hanifirohingyapa}', "");
    Expect(0, 68892, '\p{^Jg=hanifirohingyapa}', "");
    Expect(0, 68892, '\P{Jg=hanifirohingyapa}', "");
    Expect(1, 68892, '\P{^Jg=hanifirohingyapa}', "");
    Expect(0, 68893, '\p{Jg=hanifirohingyapa}', "");
    Expect(1, 68893, '\p{^Jg=hanifirohingyapa}', "");
    Expect(1, 68893, '\P{Jg=hanifirohingyapa}', "");
    Expect(0, 68893, '\P{^Jg=hanifirohingyapa}', "");
    Expect(1, 68892, '\p{Jg=:\Ahanifirohingyapa\z:}', "");;
    Expect(0, 68893, '\p{Jg=:\Ahanifirohingyapa\z:}', "");;
    Expect(1, 68892, '\p{Jg=	-Hanifi_Rohingya_PA}', "");
    Expect(0, 68892, '\p{^Jg=	-Hanifi_Rohingya_PA}', "");
    Expect(0, 68892, '\P{Jg=	-Hanifi_Rohingya_PA}', "");
    Expect(1, 68892, '\P{^Jg=	-Hanifi_Rohingya_PA}', "");
    Expect(0, 68893, '\p{Jg=	-Hanifi_Rohingya_PA}', "");
    Expect(1, 68893, '\p{^Jg=	-Hanifi_Rohingya_PA}', "");
    Expect(1, 68893, '\P{Jg=	-Hanifi_Rohingya_PA}', "");
    Expect(0, 68893, '\P{^Jg=	-Hanifi_Rohingya_PA}', "");
    Error('\p{Is_Joining_Group=  Hanifi_Rohingya_Pa:=}');
    Error('\P{Is_Joining_Group=  Hanifi_Rohingya_Pa:=}');
    Expect(1, 68892, '\p{Is_Joining_Group=hanifirohingyapa}', "");
    Expect(0, 68892, '\p{^Is_Joining_Group=hanifirohingyapa}', "");
    Expect(0, 68892, '\P{Is_Joining_Group=hanifirohingyapa}', "");
    Expect(1, 68892, '\P{^Is_Joining_Group=hanifirohingyapa}', "");
    Expect(0, 68893, '\p{Is_Joining_Group=hanifirohingyapa}', "");
    Expect(1, 68893, '\p{^Is_Joining_Group=hanifirohingyapa}', "");
    Expect(1, 68893, '\P{Is_Joining_Group=hanifirohingyapa}', "");
    Expect(0, 68893, '\P{^Is_Joining_Group=hanifirohingyapa}', "");
    Expect(1, 68892, '\p{Is_Joining_Group=	 hanifi_Rohingya_Pa}', "");
    Expect(0, 68892, '\p{^Is_Joining_Group=	 hanifi_Rohingya_Pa}', "");
    Expect(0, 68892, '\P{Is_Joining_Group=	 hanifi_Rohingya_Pa}', "");
    Expect(1, 68892, '\P{^Is_Joining_Group=	 hanifi_Rohingya_Pa}', "");
    Expect(0, 68893, '\p{Is_Joining_Group=	 hanifi_Rohingya_Pa}', "");
    Expect(1, 68893, '\p{^Is_Joining_Group=	 hanifi_Rohingya_Pa}', "");
    Expect(1, 68893, '\P{Is_Joining_Group=	 hanifi_Rohingya_Pa}', "");
    Expect(0, 68893, '\P{^Is_Joining_Group=	 hanifi_Rohingya_Pa}', "");
    Error('\p{Is_Jg: 	hanifi_rohingya_PA/a/}');
    Error('\P{Is_Jg: 	hanifi_rohingya_PA/a/}');
    Expect(1, 68892, '\p{Is_Jg:   hanifirohingyapa}', "");
    Expect(0, 68892, '\p{^Is_Jg:   hanifirohingyapa}', "");
    Expect(0, 68892, '\P{Is_Jg:   hanifirohingyapa}', "");
    Expect(1, 68892, '\P{^Is_Jg:   hanifirohingyapa}', "");
    Expect(0, 68893, '\p{Is_Jg:   hanifirohingyapa}', "");
    Expect(1, 68893, '\p{^Is_Jg:   hanifirohingyapa}', "");
    Expect(1, 68893, '\P{Is_Jg:   hanifirohingyapa}', "");
    Expect(0, 68893, '\P{^Is_Jg:   hanifirohingyapa}', "");
    Expect(1, 68892, '\p{Is_Jg=		Hanifi_rohingya_pa}', "");
    Expect(0, 68892, '\p{^Is_Jg=		Hanifi_rohingya_pa}', "");
    Expect(0, 68892, '\P{Is_Jg=		Hanifi_rohingya_pa}', "");
    Expect(1, 68892, '\P{^Is_Jg=		Hanifi_rohingya_pa}', "");
    Expect(0, 68893, '\p{Is_Jg=		Hanifi_rohingya_pa}', "");
    Expect(1, 68893, '\p{^Is_Jg=		Hanifi_rohingya_pa}', "");
    Expect(1, 68893, '\P{Is_Jg=		Hanifi_rohingya_pa}', "");
    Expect(0, 68893, '\P{^Is_Jg=		Hanifi_rohingya_pa}', "");
    Error('\p{Joining_Group=  HE/a/}');
    Error('\P{Joining_Group=  HE/a/}');
    Expect(1, 1815, '\p{Joining_Group=:\AHe\z:}', "");;
    Expect(0, 1816, '\p{Joining_Group=:\AHe\z:}', "");;
    Expect(1, 1815, '\p{Joining_Group=he}', "");
    Expect(0, 1815, '\p{^Joining_Group=he}', "");
    Expect(0, 1815, '\P{Joining_Group=he}', "");
    Expect(1, 1815, '\P{^Joining_Group=he}', "");
    Expect(0, 1816, '\p{Joining_Group=he}', "");
    Expect(1, 1816, '\p{^Joining_Group=he}', "");
    Expect(1, 1816, '\P{Joining_Group=he}', "");
    Expect(0, 1816, '\P{^Joining_Group=he}', "");
    Expect(1, 1815, '\p{Joining_Group=:\Ahe\z:}', "");;
    Expect(0, 1816, '\p{Joining_Group=:\Ahe\z:}', "");;
    Expect(1, 1815, '\p{Joining_Group= 	he}', "");
    Expect(0, 1815, '\p{^Joining_Group= 	he}', "");
    Expect(0, 1815, '\P{Joining_Group= 	he}', "");
    Expect(1, 1815, '\P{^Joining_Group= 	he}', "");
    Expect(0, 1816, '\p{Joining_Group= 	he}', "");
    Expect(1, 1816, '\p{^Joining_Group= 	he}', "");
    Expect(1, 1816, '\P{Joining_Group= 	he}', "");
    Expect(0, 1816, '\P{^Joining_Group= 	he}', "");
    Error('\p{Jg=_HE/a/}');
    Error('\P{Jg=_HE/a/}');
    Expect(1, 1815, '\p{Jg=:\AHe\z:}', "");;
    Expect(0, 1816, '\p{Jg=:\AHe\z:}', "");;
    Expect(1, 1815, '\p{Jg=he}', "");
    Expect(0, 1815, '\p{^Jg=he}', "");
    Expect(0, 1815, '\P{Jg=he}', "");
    Expect(1, 1815, '\P{^Jg=he}', "");
    Expect(0, 1816, '\p{Jg=he}', "");
    Expect(1, 1816, '\p{^Jg=he}', "");
    Expect(1, 1816, '\P{Jg=he}', "");
    Expect(0, 1816, '\P{^Jg=he}', "");
    Expect(1, 1815, '\p{Jg=:\Ahe\z:}', "");;
    Expect(0, 1816, '\p{Jg=:\Ahe\z:}', "");;
    Expect(1, 1815, '\p{Jg=	_He}', "");
    Expect(0, 1815, '\p{^Jg=	_He}', "");
    Expect(0, 1815, '\P{Jg=	_He}', "");
    Expect(1, 1815, '\P{^Jg=	_He}', "");
    Expect(0, 1816, '\p{Jg=	_He}', "");
    Expect(1, 1816, '\p{^Jg=	_He}', "");
    Expect(1, 1816, '\P{Jg=	_He}', "");
    Expect(0, 1816, '\P{^Jg=	_He}', "");
    Error('\p{Is_Joining_Group:/a/-he}');
    Error('\P{Is_Joining_Group:/a/-he}');
    Expect(1, 1815, '\p{Is_Joining_Group=he}', "");
    Expect(0, 1815, '\p{^Is_Joining_Group=he}', "");
    Expect(0, 1815, '\P{Is_Joining_Group=he}', "");
    Expect(1, 1815, '\P{^Is_Joining_Group=he}', "");
    Expect(0, 1816, '\p{Is_Joining_Group=he}', "");
    Expect(1, 1816, '\p{^Is_Joining_Group=he}', "");
    Expect(1, 1816, '\P{Is_Joining_Group=he}', "");
    Expect(0, 1816, '\P{^Is_Joining_Group=he}', "");
    Expect(1, 1815, '\p{Is_Joining_Group=	-he}', "");
    Expect(0, 1815, '\p{^Is_Joining_Group=	-he}', "");
    Expect(0, 1815, '\P{Is_Joining_Group=	-he}', "");
    Expect(1, 1815, '\P{^Is_Joining_Group=	-he}', "");
    Expect(0, 1816, '\p{Is_Joining_Group=	-he}', "");
    Expect(1, 1816, '\p{^Is_Joining_Group=	-he}', "");
    Expect(1, 1816, '\P{Is_Joining_Group=	-he}', "");
    Expect(0, 1816, '\P{^Is_Joining_Group=	-he}', "");
    Error('\p{Is_Jg=-/a/He}');
    Error('\P{Is_Jg=-/a/He}');
    Expect(1, 1815, '\p{Is_Jg:he}', "");
    Expect(0, 1815, '\p{^Is_Jg:he}', "");
    Expect(0, 1815, '\P{Is_Jg:he}', "");
    Expect(1, 1815, '\P{^Is_Jg:he}', "");
    Expect(0, 1816, '\p{Is_Jg:he}', "");
    Expect(1, 1816, '\p{^Is_Jg:he}', "");
    Expect(1, 1816, '\P{Is_Jg:he}', "");
    Expect(0, 1816, '\P{^Is_Jg:he}', "");
    Expect(1, 1815, '\p{Is_Jg=	 He}', "");
    Expect(0, 1815, '\p{^Is_Jg=	 He}', "");
    Expect(0, 1815, '\P{Is_Jg=	 He}', "");
    Expect(1, 1815, '\P{^Is_Jg=	 He}', "");
    Expect(0, 1816, '\p{Is_Jg=	 He}', "");
    Expect(1, 1816, '\p{^Is_Jg=	 He}', "");
    Expect(1, 1816, '\P{Is_Jg=	 He}', "");
    Expect(0, 1816, '\P{^Is_Jg=	 He}', "");
    Error('\p{Joining_Group=/a/-	HEH}');
    Error('\P{Joining_Group=/a/-	HEH}');
    Expect(1, 1607, '\p{Joining_Group=:\AHeh\z:}', "");;
    Expect(0, 1608, '\p{Joining_Group=:\AHeh\z:}', "");;
    Expect(1, 1607, '\p{Joining_Group=heh}', "");
    Expect(0, 1607, '\p{^Joining_Group=heh}', "");
    Expect(0, 1607, '\P{Joining_Group=heh}', "");
    Expect(1, 1607, '\P{^Joining_Group=heh}', "");
    Expect(0, 1608, '\p{Joining_Group=heh}', "");
    Expect(1, 1608, '\p{^Joining_Group=heh}', "");
    Expect(1, 1608, '\P{Joining_Group=heh}', "");
    Expect(0, 1608, '\P{^Joining_Group=heh}', "");
    Expect(1, 1607, '\p{Joining_Group=:\Aheh\z:}', "");;
    Expect(0, 1608, '\p{Joining_Group=:\Aheh\z:}', "");;
    Expect(1, 1607, '\p{Joining_Group=-_Heh}', "");
    Expect(0, 1607, '\p{^Joining_Group=-_Heh}', "");
    Expect(0, 1607, '\P{Joining_Group=-_Heh}', "");
    Expect(1, 1607, '\P{^Joining_Group=-_Heh}', "");
    Expect(0, 1608, '\p{Joining_Group=-_Heh}', "");
    Expect(1, 1608, '\p{^Joining_Group=-_Heh}', "");
    Expect(1, 1608, '\P{Joining_Group=-_Heh}', "");
    Expect(0, 1608, '\P{^Joining_Group=-_Heh}', "");
    Error('\p{Jg=:=heh}');
    Error('\P{Jg=:=heh}');
    Expect(1, 1607, '\p{Jg=:\AHeh\z:}', "");;
    Expect(0, 1608, '\p{Jg=:\AHeh\z:}', "");;
    Expect(1, 1607, '\p{Jg=heh}', "");
    Expect(0, 1607, '\p{^Jg=heh}', "");
    Expect(0, 1607, '\P{Jg=heh}', "");
    Expect(1, 1607, '\P{^Jg=heh}', "");
    Expect(0, 1608, '\p{Jg=heh}', "");
    Expect(1, 1608, '\p{^Jg=heh}', "");
    Expect(1, 1608, '\P{Jg=heh}', "");
    Expect(0, 1608, '\P{^Jg=heh}', "");
    Expect(1, 1607, '\p{Jg=:\Aheh\z:}', "");;
    Expect(0, 1608, '\p{Jg=:\Aheh\z:}', "");;
    Expect(1, 1607, '\p{Jg=  Heh}', "");
    Expect(0, 1607, '\p{^Jg=  Heh}', "");
    Expect(0, 1607, '\P{Jg=  Heh}', "");
    Expect(1, 1607, '\P{^Jg=  Heh}', "");
    Expect(0, 1608, '\p{Jg=  Heh}', "");
    Expect(1, 1608, '\p{^Jg=  Heh}', "");
    Expect(1, 1608, '\P{Jg=  Heh}', "");
    Expect(0, 1608, '\P{^Jg=  Heh}', "");
    Error('\p{Is_Joining_Group=:= heh}');
    Error('\P{Is_Joining_Group=:= heh}');
    Expect(1, 1607, '\p{Is_Joining_Group=heh}', "");
    Expect(0, 1607, '\p{^Is_Joining_Group=heh}', "");
    Expect(0, 1607, '\P{Is_Joining_Group=heh}', "");
    Expect(1, 1607, '\P{^Is_Joining_Group=heh}', "");
    Expect(0, 1608, '\p{Is_Joining_Group=heh}', "");
    Expect(1, 1608, '\p{^Is_Joining_Group=heh}', "");
    Expect(1, 1608, '\P{Is_Joining_Group=heh}', "");
    Expect(0, 1608, '\P{^Is_Joining_Group=heh}', "");
    Expect(1, 1607, '\p{Is_Joining_Group=HEH}', "");
    Expect(0, 1607, '\p{^Is_Joining_Group=HEH}', "");
    Expect(0, 1607, '\P{Is_Joining_Group=HEH}', "");
    Expect(1, 1607, '\P{^Is_Joining_Group=HEH}', "");
    Expect(0, 1608, '\p{Is_Joining_Group=HEH}', "");
    Expect(1, 1608, '\p{^Is_Joining_Group=HEH}', "");
    Expect(1, 1608, '\P{Is_Joining_Group=HEH}', "");
    Expect(0, 1608, '\P{^Is_Joining_Group=HEH}', "");
    Error('\p{Is_Jg=_:=heh}');
    Error('\P{Is_Jg=_:=heh}');
    Expect(1, 1607, '\p{Is_Jg=heh}', "");
    Expect(0, 1607, '\p{^Is_Jg=heh}', "");
    Expect(0, 1607, '\P{Is_Jg=heh}', "");
    Expect(1, 1607, '\P{^Is_Jg=heh}', "");
    Expect(0, 1608, '\p{Is_Jg=heh}', "");
    Expect(1, 1608, '\p{^Is_Jg=heh}', "");
    Expect(1, 1608, '\P{Is_Jg=heh}', "");
    Expect(0, 1608, '\P{^Is_Jg=heh}', "");
    Expect(1, 1607, '\p{Is_Jg=-Heh}', "");
    Expect(0, 1607, '\p{^Is_Jg=-Heh}', "");
    Expect(0, 1607, '\P{Is_Jg=-Heh}', "");
    Expect(1, 1607, '\P{^Is_Jg=-Heh}', "");
    Expect(0, 1608, '\p{Is_Jg=-Heh}', "");
    Expect(1, 1608, '\p{^Is_Jg=-Heh}', "");
    Expect(1, 1608, '\P{Is_Jg=-Heh}', "");
    Expect(0, 1608, '\P{^Is_Jg=-Heh}', "");
    Error('\p{Joining_Group=HEH_Goal:=}');
    Error('\P{Joining_Group=HEH_Goal:=}');
    Expect(1, 1730, '\p{Joining_Group=:\AHeh_Goal\z:}', "");;
    Expect(0, 1731, '\p{Joining_Group=:\AHeh_Goal\z:}', "");;
    Expect(1, 1730, '\p{Joining_Group=hehgoal}', "");
    Expect(0, 1730, '\p{^Joining_Group=hehgoal}', "");
    Expect(0, 1730, '\P{Joining_Group=hehgoal}', "");
    Expect(1, 1730, '\P{^Joining_Group=hehgoal}', "");
    Expect(0, 1731, '\p{Joining_Group=hehgoal}', "");
    Expect(1, 1731, '\p{^Joining_Group=hehgoal}', "");
    Expect(1, 1731, '\P{Joining_Group=hehgoal}', "");
    Expect(0, 1731, '\P{^Joining_Group=hehgoal}', "");
    Expect(1, 1730, '\p{Joining_Group=:\Ahehgoal\z:}', "");;
    Expect(0, 1731, '\p{Joining_Group=:\Ahehgoal\z:}', "");;
    Expect(1, 1730, '\p{Joining_Group= Heh_GOAL}', "");
    Expect(0, 1730, '\p{^Joining_Group= Heh_GOAL}', "");
    Expect(0, 1730, '\P{Joining_Group= Heh_GOAL}', "");
    Expect(1, 1730, '\P{^Joining_Group= Heh_GOAL}', "");
    Expect(0, 1731, '\p{Joining_Group= Heh_GOAL}', "");
    Expect(1, 1731, '\p{^Joining_Group= Heh_GOAL}', "");
    Expect(1, 1731, '\P{Joining_Group= Heh_GOAL}', "");
    Expect(0, 1731, '\P{^Joining_Group= Heh_GOAL}', "");
    Error('\p{Jg:   /a/Heh_goal}');
    Error('\P{Jg:   /a/Heh_goal}');
    Expect(1, 1730, '\p{Jg=:\AHeh_Goal\z:}', "");;
    Expect(0, 1731, '\p{Jg=:\AHeh_Goal\z:}', "");;
    Expect(1, 1730, '\p{Jg=hehgoal}', "");
    Expect(0, 1730, '\p{^Jg=hehgoal}', "");
    Expect(0, 1730, '\P{Jg=hehgoal}', "");
    Expect(1, 1730, '\P{^Jg=hehgoal}', "");
    Expect(0, 1731, '\p{Jg=hehgoal}', "");
    Expect(1, 1731, '\p{^Jg=hehgoal}', "");
    Expect(1, 1731, '\P{Jg=hehgoal}', "");
    Expect(0, 1731, '\P{^Jg=hehgoal}', "");
    Expect(1, 1730, '\p{Jg=:\Ahehgoal\z:}', "");;
    Expect(0, 1731, '\p{Jg=:\Ahehgoal\z:}', "");;
    Expect(1, 1730, '\p{Jg=	 Heh_Goal}', "");
    Expect(0, 1730, '\p{^Jg=	 Heh_Goal}', "");
    Expect(0, 1730, '\P{Jg=	 Heh_Goal}', "");
    Expect(1, 1730, '\P{^Jg=	 Heh_Goal}', "");
    Expect(0, 1731, '\p{Jg=	 Heh_Goal}', "");
    Expect(1, 1731, '\p{^Jg=	 Heh_Goal}', "");
    Expect(1, 1731, '\P{Jg=	 Heh_Goal}', "");
    Expect(0, 1731, '\P{^Jg=	 Heh_Goal}', "");
    Error('\p{Is_Joining_Group:   := _Heh_GOAL}');
    Error('\P{Is_Joining_Group:   := _Heh_GOAL}');
    Expect(1, 1730, '\p{Is_Joining_Group=hehgoal}', "");
    Expect(0, 1730, '\p{^Is_Joining_Group=hehgoal}', "");
    Expect(0, 1730, '\P{Is_Joining_Group=hehgoal}', "");
    Expect(1, 1730, '\P{^Is_Joining_Group=hehgoal}', "");
    Expect(0, 1731, '\p{Is_Joining_Group=hehgoal}', "");
    Expect(1, 1731, '\p{^Is_Joining_Group=hehgoal}', "");
    Expect(1, 1731, '\P{Is_Joining_Group=hehgoal}', "");
    Expect(0, 1731, '\P{^Is_Joining_Group=hehgoal}', "");
    Expect(1, 1730, '\p{Is_Joining_Group=- HEH_Goal}', "");
    Expect(0, 1730, '\p{^Is_Joining_Group=- HEH_Goal}', "");
    Expect(0, 1730, '\P{Is_Joining_Group=- HEH_Goal}', "");
    Expect(1, 1730, '\P{^Is_Joining_Group=- HEH_Goal}', "");
    Expect(0, 1731, '\p{Is_Joining_Group=- HEH_Goal}', "");
    Expect(1, 1731, '\p{^Is_Joining_Group=- HEH_Goal}', "");
    Expect(1, 1731, '\P{Is_Joining_Group=- HEH_Goal}', "");
    Expect(0, 1731, '\P{^Is_Joining_Group=- HEH_Goal}', "");
    Error('\p{Is_Jg:	_:=heh_goal}');
    Error('\P{Is_Jg:	_:=heh_goal}');
    Expect(1, 1730, '\p{Is_Jg=hehgoal}', "");
    Expect(0, 1730, '\p{^Is_Jg=hehgoal}', "");
    Expect(0, 1730, '\P{Is_Jg=hehgoal}', "");
    Expect(1, 1730, '\P{^Is_Jg=hehgoal}', "");
    Expect(0, 1731, '\p{Is_Jg=hehgoal}', "");
    Expect(1, 1731, '\p{^Is_Jg=hehgoal}', "");
    Expect(1, 1731, '\P{Is_Jg=hehgoal}', "");
    Expect(0, 1731, '\P{^Is_Jg=hehgoal}', "");
    Expect(1, 1730, '\p{Is_Jg= -HEH_goal}', "");
    Expect(0, 1730, '\p{^Is_Jg= -HEH_goal}', "");
    Expect(0, 1730, '\P{Is_Jg= -HEH_goal}', "");
    Expect(1, 1730, '\P{^Is_Jg= -HEH_goal}', "");
    Expect(0, 1731, '\p{Is_Jg= -HEH_goal}', "");
    Expect(1, 1731, '\p{^Is_Jg= -HEH_goal}', "");
    Expect(1, 1731, '\P{Is_Jg= -HEH_goal}', "");
    Expect(0, 1731, '\P{^Is_Jg= -HEH_goal}', "");
    Error('\p{Joining_Group=_/a/Heth}');
    Error('\P{Joining_Group=_/a/Heth}');
    Expect(1, 1818, '\p{Joining_Group=:\AHeth\z:}', "");;
    Expect(0, 1819, '\p{Joining_Group=:\AHeth\z:}', "");;
    Expect(1, 1818, '\p{Joining_Group=heth}', "");
    Expect(0, 1818, '\p{^Joining_Group=heth}', "");
    Expect(0, 1818, '\P{Joining_Group=heth}', "");
    Expect(1, 1818, '\P{^Joining_Group=heth}', "");
    Expect(0, 1819, '\p{Joining_Group=heth}', "");
    Expect(1, 1819, '\p{^Joining_Group=heth}', "");
    Expect(1, 1819, '\P{Joining_Group=heth}', "");
    Expect(0, 1819, '\P{^Joining_Group=heth}', "");
    Expect(1, 1818, '\p{Joining_Group=:\Aheth\z:}', "");;
    Expect(0, 1819, '\p{Joining_Group=:\Aheth\z:}', "");;
    Expect(1, 1818, '\p{Joining_Group=_heth}', "");
    Expect(0, 1818, '\p{^Joining_Group=_heth}', "");
    Expect(0, 1818, '\P{Joining_Group=_heth}', "");
    Expect(1, 1818, '\P{^Joining_Group=_heth}', "");
    Expect(0, 1819, '\p{Joining_Group=_heth}', "");
    Expect(1, 1819, '\p{^Joining_Group=_heth}', "");
    Expect(1, 1819, '\P{Joining_Group=_heth}', "");
    Expect(0, 1819, '\P{^Joining_Group=_heth}', "");
    Error('\p{Jg=:=	_HETH}');
    Error('\P{Jg=:=	_HETH}');
    Expect(1, 1818, '\p{Jg=:\AHeth\z:}', "");;
    Expect(0, 1819, '\p{Jg=:\AHeth\z:}', "");;
    Expect(1, 1818, '\p{Jg=heth}', "");
    Expect(0, 1818, '\p{^Jg=heth}', "");
    Expect(0, 1818, '\P{Jg=heth}', "");
    Expect(1, 1818, '\P{^Jg=heth}', "");
    Expect(0, 1819, '\p{Jg=heth}', "");
    Expect(1, 1819, '\p{^Jg=heth}', "");
    Expect(1, 1819, '\P{Jg=heth}', "");
    Expect(0, 1819, '\P{^Jg=heth}', "");
    Expect(1, 1818, '\p{Jg=:\Aheth\z:}', "");;
    Expect(0, 1819, '\p{Jg=:\Aheth\z:}', "");;
    Expect(1, 1818, '\p{Jg= Heth}', "");
    Expect(0, 1818, '\p{^Jg= Heth}', "");
    Expect(0, 1818, '\P{Jg= Heth}', "");
    Expect(1, 1818, '\P{^Jg= Heth}', "");
    Expect(0, 1819, '\p{Jg= Heth}', "");
    Expect(1, 1819, '\p{^Jg= Heth}', "");
    Expect(1, 1819, '\P{Jg= Heth}', "");
    Expect(0, 1819, '\P{^Jg= Heth}', "");
    Error('\p{Is_Joining_Group:_-heth:=}');
    Error('\P{Is_Joining_Group:_-heth:=}');
    Expect(1, 1818, '\p{Is_Joining_Group=heth}', "");
    Expect(0, 1818, '\p{^Is_Joining_Group=heth}', "");
    Expect(0, 1818, '\P{Is_Joining_Group=heth}', "");
    Expect(1, 1818, '\P{^Is_Joining_Group=heth}', "");
    Expect(0, 1819, '\p{Is_Joining_Group=heth}', "");
    Expect(1, 1819, '\p{^Is_Joining_Group=heth}', "");
    Expect(1, 1819, '\P{Is_Joining_Group=heth}', "");
    Expect(0, 1819, '\P{^Is_Joining_Group=heth}', "");
    Expect(1, 1818, '\p{Is_Joining_Group: Heth}', "");
    Expect(0, 1818, '\p{^Is_Joining_Group: Heth}', "");
    Expect(0, 1818, '\P{Is_Joining_Group: Heth}', "");
    Expect(1, 1818, '\P{^Is_Joining_Group: Heth}', "");
    Expect(0, 1819, '\p{Is_Joining_Group: Heth}', "");
    Expect(1, 1819, '\p{^Is_Joining_Group: Heth}', "");
    Expect(1, 1819, '\P{Is_Joining_Group: Heth}', "");
    Expect(0, 1819, '\P{^Is_Joining_Group: Heth}', "");
    Error('\p{Is_Jg=_HETH:=}');
    Error('\P{Is_Jg=_HETH:=}');
    Expect(1, 1818, '\p{Is_Jg=heth}', "");
    Expect(0, 1818, '\p{^Is_Jg=heth}', "");
    Expect(0, 1818, '\P{Is_Jg=heth}', "");
    Expect(1, 1818, '\P{^Is_Jg=heth}', "");
    Expect(0, 1819, '\p{Is_Jg=heth}', "");
    Expect(1, 1819, '\p{^Is_Jg=heth}', "");
    Expect(1, 1819, '\P{Is_Jg=heth}', "");
    Expect(0, 1819, '\P{^Is_Jg=heth}', "");
    Expect(1, 1818, '\p{Is_Jg=		Heth}', "");
    Expect(0, 1818, '\p{^Is_Jg=		Heth}', "");
    Expect(0, 1818, '\P{Is_Jg=		Heth}', "");
    Expect(1, 1818, '\P{^Is_Jg=		Heth}', "");
    Expect(0, 1819, '\p{Is_Jg=		Heth}', "");
    Expect(1, 1819, '\p{^Is_Jg=		Heth}', "");
    Expect(1, 1819, '\P{Is_Jg=		Heth}', "");
    Expect(0, 1819, '\P{^Is_Jg=		Heth}', "");
    Error('\p{Joining_Group=_-kaf:=}');
    Error('\P{Joining_Group=_-kaf:=}');
    Expect(1, 2228, '\p{Joining_Group=:\AKaf\z:}', "");;
    Expect(0, 2229, '\p{Joining_Group=:\AKaf\z:}', "");;
    Expect(1, 2228, '\p{Joining_Group=kaf}', "");
    Expect(0, 2228, '\p{^Joining_Group=kaf}', "");
    Expect(0, 2228, '\P{Joining_Group=kaf}', "");
    Expect(1, 2228, '\P{^Joining_Group=kaf}', "");
    Expect(0, 2229, '\p{Joining_Group=kaf}', "");
    Expect(1, 2229, '\p{^Joining_Group=kaf}', "");
    Expect(1, 2229, '\P{Joining_Group=kaf}', "");
    Expect(0, 2229, '\P{^Joining_Group=kaf}', "");
    Expect(1, 2228, '\p{Joining_Group=:\Akaf\z:}', "");;
    Expect(0, 2229, '\p{Joining_Group=:\Akaf\z:}', "");;
    Expect(1, 2228, '\p{Joining_Group= KAF}', "");
    Expect(0, 2228, '\p{^Joining_Group= KAF}', "");
    Expect(0, 2228, '\P{Joining_Group= KAF}', "");
    Expect(1, 2228, '\P{^Joining_Group= KAF}', "");
    Expect(0, 2229, '\p{Joining_Group= KAF}', "");
    Expect(1, 2229, '\p{^Joining_Group= KAF}', "");
    Expect(1, 2229, '\P{Joining_Group= KAF}', "");
    Expect(0, 2229, '\P{^Joining_Group= KAF}', "");
    Error('\p{Jg=	-Kaf/a/}');
    Error('\P{Jg=	-Kaf/a/}');
    Expect(1, 2228, '\p{Jg=:\AKaf\z:}', "");;
    Expect(0, 2229, '\p{Jg=:\AKaf\z:}', "");;
    Expect(1, 2228, '\p{Jg=kaf}', "");
    Expect(0, 2228, '\p{^Jg=kaf}', "");
    Expect(0, 2228, '\P{Jg=kaf}', "");
    Expect(1, 2228, '\P{^Jg=kaf}', "");
    Expect(0, 2229, '\p{Jg=kaf}', "");
    Expect(1, 2229, '\p{^Jg=kaf}', "");
    Expect(1, 2229, '\P{Jg=kaf}', "");
    Expect(0, 2229, '\P{^Jg=kaf}', "");
    Expect(1, 2228, '\p{Jg=:\Akaf\z:}', "");;
    Expect(0, 2229, '\p{Jg=:\Akaf\z:}', "");;
    Expect(1, 2228, '\p{Jg=	KAF}', "");
    Expect(0, 2228, '\p{^Jg=	KAF}', "");
    Expect(0, 2228, '\P{Jg=	KAF}', "");
    Expect(1, 2228, '\P{^Jg=	KAF}', "");
    Expect(0, 2229, '\p{Jg=	KAF}', "");
    Expect(1, 2229, '\p{^Jg=	KAF}', "");
    Expect(1, 2229, '\P{Jg=	KAF}', "");
    Expect(0, 2229, '\P{^Jg=	KAF}', "");
    Error('\p{Is_Joining_Group= /a/KAF}');
    Error('\P{Is_Joining_Group= /a/KAF}');
    Expect(1, 2228, '\p{Is_Joining_Group=kaf}', "");
    Expect(0, 2228, '\p{^Is_Joining_Group=kaf}', "");
    Expect(0, 2228, '\P{Is_Joining_Group=kaf}', "");
    Expect(1, 2228, '\P{^Is_Joining_Group=kaf}', "");
    Expect(0, 2229, '\p{Is_Joining_Group=kaf}', "");
    Expect(1, 2229, '\p{^Is_Joining_Group=kaf}', "");
    Expect(1, 2229, '\P{Is_Joining_Group=kaf}', "");
    Expect(0, 2229, '\P{^Is_Joining_Group=kaf}', "");
    Expect(1, 2228, '\p{Is_Joining_Group=	_Kaf}', "");
    Expect(0, 2228, '\p{^Is_Joining_Group=	_Kaf}', "");
    Expect(0, 2228, '\P{Is_Joining_Group=	_Kaf}', "");
    Expect(1, 2228, '\P{^Is_Joining_Group=	_Kaf}', "");
    Expect(0, 2229, '\p{Is_Joining_Group=	_Kaf}', "");
    Expect(1, 2229, '\p{^Is_Joining_Group=	_Kaf}', "");
    Expect(1, 2229, '\P{Is_Joining_Group=	_Kaf}', "");
    Expect(0, 2229, '\P{^Is_Joining_Group=	_Kaf}', "");
    Error('\p{Is_Jg=:=	-Kaf}');
    Error('\P{Is_Jg=:=	-Kaf}');
    Expect(1, 2228, '\p{Is_Jg=kaf}', "");
    Expect(0, 2228, '\p{^Is_Jg=kaf}', "");
    Expect(0, 2228, '\P{Is_Jg=kaf}', "");
    Expect(1, 2228, '\P{^Is_Jg=kaf}', "");
    Expect(0, 2229, '\p{Is_Jg=kaf}', "");
    Expect(1, 2229, '\p{^Is_Jg=kaf}', "");
    Expect(1, 2229, '\P{Is_Jg=kaf}', "");
    Expect(0, 2229, '\P{^Is_Jg=kaf}', "");
    Expect(1, 2228, '\p{Is_Jg= -KAF}', "");
    Expect(0, 2228, '\p{^Is_Jg= -KAF}', "");
    Expect(0, 2228, '\P{Is_Jg= -KAF}', "");
    Expect(1, 2228, '\P{^Is_Jg= -KAF}', "");
    Expect(0, 2229, '\p{Is_Jg= -KAF}', "");
    Expect(1, 2229, '\p{^Is_Jg= -KAF}', "");
    Expect(1, 2229, '\P{Is_Jg= -KAF}', "");
    Expect(0, 2229, '\P{^Is_Jg= -KAF}', "");
    Error('\p{Joining_Group=_:=kaph}');
    Error('\P{Joining_Group=_:=kaph}');
    Expect(1, 1823, '\p{Joining_Group=:\AKaph\z:}', "");;
    Expect(0, 1824, '\p{Joining_Group=:\AKaph\z:}', "");;
    Expect(1, 1823, '\p{Joining_Group=kaph}', "");
    Expect(0, 1823, '\p{^Joining_Group=kaph}', "");
    Expect(0, 1823, '\P{Joining_Group=kaph}', "");
    Expect(1, 1823, '\P{^Joining_Group=kaph}', "");
    Expect(0, 1824, '\p{Joining_Group=kaph}', "");
    Expect(1, 1824, '\p{^Joining_Group=kaph}', "");
    Expect(1, 1824, '\P{Joining_Group=kaph}', "");
    Expect(0, 1824, '\P{^Joining_Group=kaph}', "");
    Expect(1, 1823, '\p{Joining_Group=:\Akaph\z:}', "");;
    Expect(0, 1824, '\p{Joining_Group=:\Akaph\z:}', "");;
    Expect(1, 1823, '\p{Joining_Group=__Kaph}', "");
    Expect(0, 1823, '\p{^Joining_Group=__Kaph}', "");
    Expect(0, 1823, '\P{Joining_Group=__Kaph}', "");
    Expect(1, 1823, '\P{^Joining_Group=__Kaph}', "");
    Expect(0, 1824, '\p{Joining_Group=__Kaph}', "");
    Expect(1, 1824, '\p{^Joining_Group=__Kaph}', "");
    Expect(1, 1824, '\P{Joining_Group=__Kaph}', "");
    Expect(0, 1824, '\P{^Joining_Group=__Kaph}', "");
    Error('\p{Jg= -KAPH:=}');
    Error('\P{Jg= -KAPH:=}');
    Expect(1, 1823, '\p{Jg=:\AKaph\z:}', "");;
    Expect(0, 1824, '\p{Jg=:\AKaph\z:}', "");;
    Expect(1, 1823, '\p{Jg:	kaph}', "");
    Expect(0, 1823, '\p{^Jg:	kaph}', "");
    Expect(0, 1823, '\P{Jg:	kaph}', "");
    Expect(1, 1823, '\P{^Jg:	kaph}', "");
    Expect(0, 1824, '\p{Jg:	kaph}', "");
    Expect(1, 1824, '\p{^Jg:	kaph}', "");
    Expect(1, 1824, '\P{Jg:	kaph}', "");
    Expect(0, 1824, '\P{^Jg:	kaph}', "");
    Expect(1, 1823, '\p{Jg=:\Akaph\z:}', "");;
    Expect(0, 1824, '\p{Jg=:\Akaph\z:}', "");;
    Expect(1, 1823, '\p{Jg=	KAPH}', "");
    Expect(0, 1823, '\p{^Jg=	KAPH}', "");
    Expect(0, 1823, '\P{Jg=	KAPH}', "");
    Expect(1, 1823, '\P{^Jg=	KAPH}', "");
    Expect(0, 1824, '\p{Jg=	KAPH}', "");
    Expect(1, 1824, '\p{^Jg=	KAPH}', "");
    Expect(1, 1824, '\P{Jg=	KAPH}', "");
    Expect(0, 1824, '\P{^Jg=	KAPH}', "");
    Error('\p{Is_Joining_Group=	Kaph/a/}');
    Error('\P{Is_Joining_Group=	Kaph/a/}');
    Expect(1, 1823, '\p{Is_Joining_Group=kaph}', "");
    Expect(0, 1823, '\p{^Is_Joining_Group=kaph}', "");
    Expect(0, 1823, '\P{Is_Joining_Group=kaph}', "");
    Expect(1, 1823, '\P{^Is_Joining_Group=kaph}', "");
    Expect(0, 1824, '\p{Is_Joining_Group=kaph}', "");
    Expect(1, 1824, '\p{^Is_Joining_Group=kaph}', "");
    Expect(1, 1824, '\P{Is_Joining_Group=kaph}', "");
    Expect(0, 1824, '\P{^Is_Joining_Group=kaph}', "");
    Expect(1, 1823, '\p{Is_Joining_Group=	_kaph}', "");
    Expect(0, 1823, '\p{^Is_Joining_Group=	_kaph}', "");
    Expect(0, 1823, '\P{Is_Joining_Group=	_kaph}', "");
    Expect(1, 1823, '\P{^Is_Joining_Group=	_kaph}', "");
    Expect(0, 1824, '\p{Is_Joining_Group=	_kaph}', "");
    Expect(1, 1824, '\p{^Is_Joining_Group=	_kaph}', "");
    Expect(1, 1824, '\P{Is_Joining_Group=	_kaph}', "");
    Expect(0, 1824, '\P{^Is_Joining_Group=	_kaph}', "");
    Error('\p{Is_Jg=:=KAPH}');
    Error('\P{Is_Jg=:=KAPH}');
    Expect(1, 1823, '\p{Is_Jg=kaph}', "");
    Expect(0, 1823, '\p{^Is_Jg=kaph}', "");
    Expect(0, 1823, '\P{Is_Jg=kaph}', "");
    Expect(1, 1823, '\P{^Is_Jg=kaph}', "");
    Expect(0, 1824, '\p{Is_Jg=kaph}', "");
    Expect(1, 1824, '\p{^Is_Jg=kaph}', "");
    Expect(1, 1824, '\P{Is_Jg=kaph}', "");
    Expect(0, 1824, '\P{^Is_Jg=kaph}', "");
    Expect(1, 1823, '\p{Is_Jg: _Kaph}', "");
    Expect(0, 1823, '\p{^Is_Jg: _Kaph}', "");
    Expect(0, 1823, '\P{Is_Jg: _Kaph}', "");
    Expect(1, 1823, '\P{^Is_Jg: _Kaph}', "");
    Expect(0, 1824, '\p{Is_Jg: _Kaph}', "");
    Expect(1, 1824, '\p{^Is_Jg: _Kaph}', "");
    Expect(1, 1824, '\P{Is_Jg: _Kaph}', "");
    Expect(0, 1824, '\P{^Is_Jg: _Kaph}', "");
    Error('\p{Joining_Group=:=--Khaph}');
    Error('\P{Joining_Group=:=--Khaph}');
    Expect(1, 1870, '\p{Joining_Group=:\AKhaph\z:}', "");;
    Expect(0, 1871, '\p{Joining_Group=:\AKhaph\z:}', "");;
    Expect(1, 1870, '\p{Joining_Group:	khaph}', "");
    Expect(0, 1870, '\p{^Joining_Group:	khaph}', "");
    Expect(0, 1870, '\P{Joining_Group:	khaph}', "");
    Expect(1, 1870, '\P{^Joining_Group:	khaph}', "");
    Expect(0, 1871, '\p{Joining_Group:	khaph}', "");
    Expect(1, 1871, '\p{^Joining_Group:	khaph}', "");
    Expect(1, 1871, '\P{Joining_Group:	khaph}', "");
    Expect(0, 1871, '\P{^Joining_Group:	khaph}', "");
    Expect(1, 1870, '\p{Joining_Group=:\Akhaph\z:}', "");;
    Expect(0, 1871, '\p{Joining_Group=:\Akhaph\z:}', "");;
    Expect(1, 1870, '\p{Joining_Group= Khaph}', "");
    Expect(0, 1870, '\p{^Joining_Group= Khaph}', "");
    Expect(0, 1870, '\P{Joining_Group= Khaph}', "");
    Expect(1, 1870, '\P{^Joining_Group= Khaph}', "");
    Expect(0, 1871, '\p{Joining_Group= Khaph}', "");
    Expect(1, 1871, '\p{^Joining_Group= Khaph}', "");
    Expect(1, 1871, '\P{Joining_Group= Khaph}', "");
    Expect(0, 1871, '\P{^Joining_Group= Khaph}', "");
    Error('\p{Jg:	/a/__Khaph}');
    Error('\P{Jg:	/a/__Khaph}');
    Expect(1, 1870, '\p{Jg=:\AKhaph\z:}', "");;
    Expect(0, 1871, '\p{Jg=:\AKhaph\z:}', "");;
    Expect(1, 1870, '\p{Jg=khaph}', "");
    Expect(0, 1870, '\p{^Jg=khaph}', "");
    Expect(0, 1870, '\P{Jg=khaph}', "");
    Expect(1, 1870, '\P{^Jg=khaph}', "");
    Expect(0, 1871, '\p{Jg=khaph}', "");
    Expect(1, 1871, '\p{^Jg=khaph}', "");
    Expect(1, 1871, '\P{Jg=khaph}', "");
    Expect(0, 1871, '\P{^Jg=khaph}', "");
    Expect(1, 1870, '\p{Jg=:\Akhaph\z:}', "");;
    Expect(0, 1871, '\p{Jg=:\Akhaph\z:}', "");;
    Expect(1, 1870, '\p{Jg=-Khaph}', "");
    Expect(0, 1870, '\p{^Jg=-Khaph}', "");
    Expect(0, 1870, '\P{Jg=-Khaph}', "");
    Expect(1, 1870, '\P{^Jg=-Khaph}', "");
    Expect(0, 1871, '\p{Jg=-Khaph}', "");
    Expect(1, 1871, '\p{^Jg=-Khaph}', "");
    Expect(1, 1871, '\P{Jg=-Khaph}', "");
    Expect(0, 1871, '\P{^Jg=-Khaph}', "");
    Error('\p{Is_Joining_Group=		khaph:=}');
    Error('\P{Is_Joining_Group=		khaph:=}');
    Expect(1, 1870, '\p{Is_Joining_Group=khaph}', "");
    Expect(0, 1870, '\p{^Is_Joining_Group=khaph}', "");
    Expect(0, 1870, '\P{Is_Joining_Group=khaph}', "");
    Expect(1, 1870, '\P{^Is_Joining_Group=khaph}', "");
    Expect(0, 1871, '\p{Is_Joining_Group=khaph}', "");
    Expect(1, 1871, '\p{^Is_Joining_Group=khaph}', "");
    Expect(1, 1871, '\P{Is_Joining_Group=khaph}', "");
    Expect(0, 1871, '\P{^Is_Joining_Group=khaph}', "");
    Expect(1, 1870, '\p{Is_Joining_Group=	KHAPH}', "");
    Expect(0, 1870, '\p{^Is_Joining_Group=	KHAPH}', "");
    Expect(0, 1870, '\P{Is_Joining_Group=	KHAPH}', "");
    Expect(1, 1870, '\P{^Is_Joining_Group=	KHAPH}', "");
    Expect(0, 1871, '\p{Is_Joining_Group=	KHAPH}', "");
    Expect(1, 1871, '\p{^Is_Joining_Group=	KHAPH}', "");
    Expect(1, 1871, '\P{Is_Joining_Group=	KHAPH}', "");
    Expect(0, 1871, '\P{^Is_Joining_Group=	KHAPH}', "");
    Error('\p{Is_Jg=_:=Khaph}');
    Error('\P{Is_Jg=_:=Khaph}');
    Expect(1, 1870, '\p{Is_Jg=khaph}', "");
    Expect(0, 1870, '\p{^Is_Jg=khaph}', "");
    Expect(0, 1870, '\P{Is_Jg=khaph}', "");
    Expect(1, 1870, '\P{^Is_Jg=khaph}', "");
    Expect(0, 1871, '\p{Is_Jg=khaph}', "");
    Expect(1, 1871, '\p{^Is_Jg=khaph}', "");
    Expect(1, 1871, '\P{Is_Jg=khaph}', "");
    Expect(0, 1871, '\P{^Is_Jg=khaph}', "");
    Expect(1, 1870, '\p{Is_Jg=_	Khaph}', "");
    Expect(0, 1870, '\p{^Is_Jg=_	Khaph}', "");
    Expect(0, 1870, '\P{Is_Jg=_	Khaph}', "");
    Expect(1, 1870, '\P{^Is_Jg=_	Khaph}', "");
    Expect(0, 1871, '\p{Is_Jg=_	Khaph}', "");
    Expect(1, 1871, '\p{^Is_Jg=_	Khaph}', "");
    Expect(1, 1871, '\P{Is_Jg=_	Khaph}', "");
    Expect(0, 1871, '\P{^Is_Jg=_	Khaph}', "");
    Error('\p{Joining_Group= _KNOTTED_heh:=}');
    Error('\P{Joining_Group= _KNOTTED_heh:=}');
    Expect(1, 1791, '\p{Joining_Group=:\AKnotted_Heh\z:}', "");;
    Expect(0, 1792, '\p{Joining_Group=:\AKnotted_Heh\z:}', "");;
    Expect(1, 1791, '\p{Joining_Group=knottedheh}', "");
    Expect(0, 1791, '\p{^Joining_Group=knottedheh}', "");
    Expect(0, 1791, '\P{Joining_Group=knottedheh}', "");
    Expect(1, 1791, '\P{^Joining_Group=knottedheh}', "");
    Expect(0, 1792, '\p{Joining_Group=knottedheh}', "");
    Expect(1, 1792, '\p{^Joining_Group=knottedheh}', "");
    Expect(1, 1792, '\P{Joining_Group=knottedheh}', "");
    Expect(0, 1792, '\P{^Joining_Group=knottedheh}', "");
    Expect(1, 1791, '\p{Joining_Group=:\Aknottedheh\z:}', "");;
    Expect(0, 1792, '\p{Joining_Group=:\Aknottedheh\z:}', "");;
    Expect(1, 1791, '\p{Joining_Group=  Knotted_Heh}', "");
    Expect(0, 1791, '\p{^Joining_Group=  Knotted_Heh}', "");
    Expect(0, 1791, '\P{Joining_Group=  Knotted_Heh}', "");
    Expect(1, 1791, '\P{^Joining_Group=  Knotted_Heh}', "");
    Expect(0, 1792, '\p{Joining_Group=  Knotted_Heh}', "");
    Expect(1, 1792, '\p{^Joining_Group=  Knotted_Heh}', "");
    Expect(1, 1792, '\P{Joining_Group=  Knotted_Heh}', "");
    Expect(0, 1792, '\P{^Joining_Group=  Knotted_Heh}', "");
    Error('\p{Jg=:=	 Knotted_Heh}');
    Error('\P{Jg=:=	 Knotted_Heh}');
    Expect(1, 1791, '\p{Jg=:\AKnotted_Heh\z:}', "");;
    Expect(0, 1792, '\p{Jg=:\AKnotted_Heh\z:}', "");;
    Expect(1, 1791, '\p{Jg=knottedheh}', "");
    Expect(0, 1791, '\p{^Jg=knottedheh}', "");
    Expect(0, 1791, '\P{Jg=knottedheh}', "");
    Expect(1, 1791, '\P{^Jg=knottedheh}', "");
    Expect(0, 1792, '\p{Jg=knottedheh}', "");
    Expect(1, 1792, '\p{^Jg=knottedheh}', "");
    Expect(1, 1792, '\P{Jg=knottedheh}', "");
    Expect(0, 1792, '\P{^Jg=knottedheh}', "");
    Expect(1, 1791, '\p{Jg=:\Aknottedheh\z:}', "");;
    Expect(0, 1792, '\p{Jg=:\Aknottedheh\z:}', "");;
    Expect(1, 1791, '\p{Jg=_ Knotted_Heh}', "");
    Expect(0, 1791, '\p{^Jg=_ Knotted_Heh}', "");
    Expect(0, 1791, '\P{Jg=_ Knotted_Heh}', "");
    Expect(1, 1791, '\P{^Jg=_ Knotted_Heh}', "");
    Expect(0, 1792, '\p{Jg=_ Knotted_Heh}', "");
    Expect(1, 1792, '\p{^Jg=_ Knotted_Heh}', "");
    Expect(1, 1792, '\P{Jg=_ Knotted_Heh}', "");
    Expect(0, 1792, '\P{^Jg=_ Knotted_Heh}', "");
    Error('\p{Is_Joining_Group=:=KNOTTED_Heh}');
    Error('\P{Is_Joining_Group=:=KNOTTED_Heh}');
    Expect(1, 1791, '\p{Is_Joining_Group=knottedheh}', "");
    Expect(0, 1791, '\p{^Is_Joining_Group=knottedheh}', "");
    Expect(0, 1791, '\P{Is_Joining_Group=knottedheh}', "");
    Expect(1, 1791, '\P{^Is_Joining_Group=knottedheh}', "");
    Expect(0, 1792, '\p{Is_Joining_Group=knottedheh}', "");
    Expect(1, 1792, '\p{^Is_Joining_Group=knottedheh}', "");
    Expect(1, 1792, '\P{Is_Joining_Group=knottedheh}', "");
    Expect(0, 1792, '\P{^Is_Joining_Group=knottedheh}', "");
    Expect(1, 1791, '\p{Is_Joining_Group=_ knotted_heh}', "");
    Expect(0, 1791, '\p{^Is_Joining_Group=_ knotted_heh}', "");
    Expect(0, 1791, '\P{Is_Joining_Group=_ knotted_heh}', "");
    Expect(1, 1791, '\P{^Is_Joining_Group=_ knotted_heh}', "");
    Expect(0, 1792, '\p{Is_Joining_Group=_ knotted_heh}', "");
    Expect(1, 1792, '\p{^Is_Joining_Group=_ knotted_heh}', "");
    Expect(1, 1792, '\P{Is_Joining_Group=_ knotted_heh}', "");
    Expect(0, 1792, '\P{^Is_Joining_Group=_ knotted_heh}', "");
    Error('\p{Is_Jg=/a/	 KNOTTED_heh}');
    Error('\P{Is_Jg=/a/	 KNOTTED_heh}');
    Expect(1, 1791, '\p{Is_Jg=knottedheh}', "");
    Expect(0, 1791, '\p{^Is_Jg=knottedheh}', "");
    Expect(0, 1791, '\P{Is_Jg=knottedheh}', "");
    Expect(1, 1791, '\P{^Is_Jg=knottedheh}', "");
    Expect(0, 1792, '\p{Is_Jg=knottedheh}', "");
    Expect(1, 1792, '\p{^Is_Jg=knottedheh}', "");
    Expect(1, 1792, '\P{Is_Jg=knottedheh}', "");
    Expect(0, 1792, '\P{^Is_Jg=knottedheh}', "");
    Expect(1, 1791, '\p{Is_Jg=	 Knotted_HEH}', "");
    Expect(0, 1791, '\p{^Is_Jg=	 Knotted_HEH}', "");
    Expect(0, 1791, '\P{Is_Jg=	 Knotted_HEH}', "");
    Expect(1, 1791, '\P{^Is_Jg=	 Knotted_HEH}', "");
    Expect(0, 1792, '\p{Is_Jg=	 Knotted_HEH}', "");
    Expect(1, 1792, '\p{^Is_Jg=	 Knotted_HEH}', "");
    Expect(1, 1792, '\P{Is_Jg=	 Knotted_HEH}', "");
    Expect(0, 1792, '\P{^Is_Jg=	 Knotted_HEH}', "");
    Error('\p{Joining_Group=/a/_Lam}');
    Error('\P{Joining_Group=/a/_Lam}');
    Expect(1, 2214, '\p{Joining_Group=:\ALam\z:}', "");;
    Expect(0, 2215, '\p{Joining_Group=:\ALam\z:}', "");;
    Expect(1, 2214, '\p{Joining_Group=lam}', "");
    Expect(0, 2214, '\p{^Joining_Group=lam}', "");
    Expect(0, 2214, '\P{Joining_Group=lam}', "");
    Expect(1, 2214, '\P{^Joining_Group=lam}', "");
    Expect(0, 2215, '\p{Joining_Group=lam}', "");
    Expect(1, 2215, '\p{^Joining_Group=lam}', "");
    Expect(1, 2215, '\P{Joining_Group=lam}', "");
    Expect(0, 2215, '\P{^Joining_Group=lam}', "");
    Expect(1, 2214, '\p{Joining_Group=:\Alam\z:}', "");;
    Expect(0, 2215, '\p{Joining_Group=:\Alam\z:}', "");;
    Expect(1, 2214, '\p{Joining_Group=--lam}', "");
    Expect(0, 2214, '\p{^Joining_Group=--lam}', "");
    Expect(0, 2214, '\P{Joining_Group=--lam}', "");
    Expect(1, 2214, '\P{^Joining_Group=--lam}', "");
    Expect(0, 2215, '\p{Joining_Group=--lam}', "");
    Expect(1, 2215, '\p{^Joining_Group=--lam}', "");
    Expect(1, 2215, '\P{Joining_Group=--lam}', "");
    Expect(0, 2215, '\P{^Joining_Group=--lam}', "");
    Error('\p{Jg=_-lam:=}');
    Error('\P{Jg=_-lam:=}');
    Expect(1, 2214, '\p{Jg=:\ALam\z:}', "");;
    Expect(0, 2215, '\p{Jg=:\ALam\z:}', "");;
    Expect(1, 2214, '\p{Jg=lam}', "");
    Expect(0, 2214, '\p{^Jg=lam}', "");
    Expect(0, 2214, '\P{Jg=lam}', "");
    Expect(1, 2214, '\P{^Jg=lam}', "");
    Expect(0, 2215, '\p{Jg=lam}', "");
    Expect(1, 2215, '\p{^Jg=lam}', "");
    Expect(1, 2215, '\P{Jg=lam}', "");
    Expect(0, 2215, '\P{^Jg=lam}', "");
    Expect(1, 2214, '\p{Jg=:\Alam\z:}', "");;
    Expect(0, 2215, '\p{Jg=:\Alam\z:}', "");;
    Expect(1, 2214, '\p{Jg= Lam}', "");
    Expect(0, 2214, '\p{^Jg= Lam}', "");
    Expect(0, 2214, '\P{Jg= Lam}', "");
    Expect(1, 2214, '\P{^Jg= Lam}', "");
    Expect(0, 2215, '\p{Jg= Lam}', "");
    Expect(1, 2215, '\p{^Jg= Lam}', "");
    Expect(1, 2215, '\P{Jg= Lam}', "");
    Expect(0, 2215, '\P{^Jg= Lam}', "");
    Error('\p{Is_Joining_Group= lam:=}');
    Error('\P{Is_Joining_Group= lam:=}');
    Expect(1, 2214, '\p{Is_Joining_Group=lam}', "");
    Expect(0, 2214, '\p{^Is_Joining_Group=lam}', "");
    Expect(0, 2214, '\P{Is_Joining_Group=lam}', "");
    Expect(1, 2214, '\P{^Is_Joining_Group=lam}', "");
    Expect(0, 2215, '\p{Is_Joining_Group=lam}', "");
    Expect(1, 2215, '\p{^Is_Joining_Group=lam}', "");
    Expect(1, 2215, '\P{Is_Joining_Group=lam}', "");
    Expect(0, 2215, '\P{^Is_Joining_Group=lam}', "");
    Expect(1, 2214, '\p{Is_Joining_Group=Lam}', "");
    Expect(0, 2214, '\p{^Is_Joining_Group=Lam}', "");
    Expect(0, 2214, '\P{Is_Joining_Group=Lam}', "");
    Expect(1, 2214, '\P{^Is_Joining_Group=Lam}', "");
    Expect(0, 2215, '\p{Is_Joining_Group=Lam}', "");
    Expect(1, 2215, '\p{^Is_Joining_Group=Lam}', "");
    Expect(1, 2215, '\P{Is_Joining_Group=Lam}', "");
    Expect(0, 2215, '\P{^Is_Joining_Group=Lam}', "");
    Error('\p{Is_Jg: := _Lam}');
    Error('\P{Is_Jg: := _Lam}');
    Expect(1, 2214, '\p{Is_Jg=lam}', "");
    Expect(0, 2214, '\p{^Is_Jg=lam}', "");
    Expect(0, 2214, '\P{Is_Jg=lam}', "");
    Expect(1, 2214, '\P{^Is_Jg=lam}', "");
    Expect(0, 2215, '\p{Is_Jg=lam}', "");
    Expect(1, 2215, '\p{^Is_Jg=lam}', "");
    Expect(1, 2215, '\P{Is_Jg=lam}', "");
    Expect(0, 2215, '\P{^Is_Jg=lam}', "");
    Expect(1, 2214, '\p{Is_Jg= -Lam}', "");
    Expect(0, 2214, '\p{^Is_Jg= -Lam}', "");
    Expect(0, 2214, '\P{Is_Jg= -Lam}', "");
    Expect(1, 2214, '\P{^Is_Jg= -Lam}', "");
    Expect(0, 2215, '\p{Is_Jg= -Lam}', "");
    Expect(1, 2215, '\p{^Is_Jg= -Lam}', "");
    Expect(1, 2215, '\P{Is_Jg= -Lam}', "");
    Expect(0, 2215, '\P{^Is_Jg= -Lam}', "");
    Error('\p{Joining_Group=_/a/Lamadh}');
    Error('\P{Joining_Group=_/a/Lamadh}');
    Expect(1, 1824, '\p{Joining_Group=:\ALamadh\z:}', "");;
    Expect(0, 1825, '\p{Joining_Group=:\ALamadh\z:}', "");;
    Expect(1, 1824, '\p{Joining_Group=lamadh}', "");
    Expect(0, 1824, '\p{^Joining_Group=lamadh}', "");
    Expect(0, 1824, '\P{Joining_Group=lamadh}', "");
    Expect(1, 1824, '\P{^Joining_Group=lamadh}', "");
    Expect(0, 1825, '\p{Joining_Group=lamadh}', "");
    Expect(1, 1825, '\p{^Joining_Group=lamadh}', "");
    Expect(1, 1825, '\P{Joining_Group=lamadh}', "");
    Expect(0, 1825, '\P{^Joining_Group=lamadh}', "");
    Expect(1, 1824, '\p{Joining_Group=:\Alamadh\z:}', "");;
    Expect(0, 1825, '\p{Joining_Group=:\Alamadh\z:}', "");;
    Expect(1, 1824, '\p{Joining_Group:	_-lamadh}', "");
    Expect(0, 1824, '\p{^Joining_Group:	_-lamadh}', "");
    Expect(0, 1824, '\P{Joining_Group:	_-lamadh}', "");
    Expect(1, 1824, '\P{^Joining_Group:	_-lamadh}', "");
    Expect(0, 1825, '\p{Joining_Group:	_-lamadh}', "");
    Expect(1, 1825, '\p{^Joining_Group:	_-lamadh}', "");
    Expect(1, 1825, '\P{Joining_Group:	_-lamadh}', "");
    Expect(0, 1825, '\P{^Joining_Group:	_-lamadh}', "");
    Error('\p{Jg=-:=LAMADH}');
    Error('\P{Jg=-:=LAMADH}');
    Expect(1, 1824, '\p{Jg=:\ALamadh\z:}', "");;
    Expect(0, 1825, '\p{Jg=:\ALamadh\z:}', "");;
    Expect(1, 1824, '\p{Jg=lamadh}', "");
    Expect(0, 1824, '\p{^Jg=lamadh}', "");
    Expect(0, 1824, '\P{Jg=lamadh}', "");
    Expect(1, 1824, '\P{^Jg=lamadh}', "");
    Expect(0, 1825, '\p{Jg=lamadh}', "");
    Expect(1, 1825, '\p{^Jg=lamadh}', "");
    Expect(1, 1825, '\P{Jg=lamadh}', "");
    Expect(0, 1825, '\P{^Jg=lamadh}', "");
    Expect(1, 1824, '\p{Jg=:\Alamadh\z:}', "");;
    Expect(0, 1825, '\p{Jg=:\Alamadh\z:}', "");;
    Expect(1, 1824, '\p{Jg=--Lamadh}', "");
    Expect(0, 1824, '\p{^Jg=--Lamadh}', "");
    Expect(0, 1824, '\P{Jg=--Lamadh}', "");
    Expect(1, 1824, '\P{^Jg=--Lamadh}', "");
    Expect(0, 1825, '\p{Jg=--Lamadh}', "");
    Expect(1, 1825, '\p{^Jg=--Lamadh}', "");
    Expect(1, 1825, '\P{Jg=--Lamadh}', "");
    Expect(0, 1825, '\P{^Jg=--Lamadh}', "");
    Error('\p{Is_Joining_Group: 	/a/LAMADH}');
    Error('\P{Is_Joining_Group: 	/a/LAMADH}');
    Expect(1, 1824, '\p{Is_Joining_Group=lamadh}', "");
    Expect(0, 1824, '\p{^Is_Joining_Group=lamadh}', "");
    Expect(0, 1824, '\P{Is_Joining_Group=lamadh}', "");
    Expect(1, 1824, '\P{^Is_Joining_Group=lamadh}', "");
    Expect(0, 1825, '\p{Is_Joining_Group=lamadh}', "");
    Expect(1, 1825, '\p{^Is_Joining_Group=lamadh}', "");
    Expect(1, 1825, '\P{Is_Joining_Group=lamadh}', "");
    Expect(0, 1825, '\P{^Is_Joining_Group=lamadh}', "");
    Expect(1, 1824, '\p{Is_Joining_Group=_-Lamadh}', "");
    Expect(0, 1824, '\p{^Is_Joining_Group=_-Lamadh}', "");
    Expect(0, 1824, '\P{Is_Joining_Group=_-Lamadh}', "");
    Expect(1, 1824, '\P{^Is_Joining_Group=_-Lamadh}', "");
    Expect(0, 1825, '\p{Is_Joining_Group=_-Lamadh}', "");
    Expect(1, 1825, '\p{^Is_Joining_Group=_-Lamadh}', "");
    Expect(1, 1825, '\P{Is_Joining_Group=_-Lamadh}', "");
    Expect(0, 1825, '\P{^Is_Joining_Group=_-Lamadh}', "");
    Error('\p{Is_Jg:	/a/-lamadh}');
    Error('\P{Is_Jg:	/a/-lamadh}');
    Expect(1, 1824, '\p{Is_Jg=lamadh}', "");
    Expect(0, 1824, '\p{^Is_Jg=lamadh}', "");
    Expect(0, 1824, '\P{Is_Jg=lamadh}', "");
    Expect(1, 1824, '\P{^Is_Jg=lamadh}', "");
    Expect(0, 1825, '\p{Is_Jg=lamadh}', "");
    Expect(1, 1825, '\p{^Is_Jg=lamadh}', "");
    Expect(1, 1825, '\P{Is_Jg=lamadh}', "");
    Expect(0, 1825, '\P{^Is_Jg=lamadh}', "");
    Expect(1, 1824, '\p{Is_Jg= Lamadh}', "");
    Expect(0, 1824, '\p{^Is_Jg= Lamadh}', "");
    Expect(0, 1824, '\P{Is_Jg= Lamadh}', "");
    Expect(1, 1824, '\P{^Is_Jg= Lamadh}', "");
    Expect(0, 1825, '\p{Is_Jg= Lamadh}', "");
    Expect(1, 1825, '\p{^Is_Jg= Lamadh}', "");
    Expect(1, 1825, '\P{Is_Jg= Lamadh}', "");
    Expect(0, 1825, '\P{^Is_Jg= Lamadh}', "");
    Error('\p{Joining_Group=/a/	malayalam_bha}');
    Error('\P{Joining_Group=/a/	malayalam_bha}');
    Expect(1, 2150, '\p{Joining_Group=:\AMalayalam_Bha\z:}', "");;
    Expect(0, 2151, '\p{Joining_Group=:\AMalayalam_Bha\z:}', "");;
    Expect(1, 2150, '\p{Joining_Group=malayalambha}', "");
    Expect(0, 2150, '\p{^Joining_Group=malayalambha}', "");
    Expect(0, 2150, '\P{Joining_Group=malayalambha}', "");
    Expect(1, 2150, '\P{^Joining_Group=malayalambha}', "");
    Expect(0, 2151, '\p{Joining_Group=malayalambha}', "");
    Expect(1, 2151, '\p{^Joining_Group=malayalambha}', "");
    Expect(1, 2151, '\P{Joining_Group=malayalambha}', "");
    Expect(0, 2151, '\P{^Joining_Group=malayalambha}', "");
    Expect(1, 2150, '\p{Joining_Group=:\Amalayalambha\z:}', "");;
    Expect(0, 2151, '\p{Joining_Group=:\Amalayalambha\z:}', "");;
    Expect(1, 2150, '\p{Joining_Group=		MALAYALAM_Bha}', "");
    Expect(0, 2150, '\p{^Joining_Group=		MALAYALAM_Bha}', "");
    Expect(0, 2150, '\P{Joining_Group=		MALAYALAM_Bha}', "");
    Expect(1, 2150, '\P{^Joining_Group=		MALAYALAM_Bha}', "");
    Expect(0, 2151, '\p{Joining_Group=		MALAYALAM_Bha}', "");
    Expect(1, 2151, '\p{^Joining_Group=		MALAYALAM_Bha}', "");
    Expect(1, 2151, '\P{Joining_Group=		MALAYALAM_Bha}', "");
    Expect(0, 2151, '\P{^Joining_Group=		MALAYALAM_Bha}', "");
    Error('\p{Jg=-/a/MALAYALAM_bha}');
    Error('\P{Jg=-/a/MALAYALAM_bha}');
    Expect(1, 2150, '\p{Jg=:\AMalayalam_Bha\z:}', "");;
    Expect(0, 2151, '\p{Jg=:\AMalayalam_Bha\z:}', "");;
    Expect(1, 2150, '\p{Jg=malayalambha}', "");
    Expect(0, 2150, '\p{^Jg=malayalambha}', "");
    Expect(0, 2150, '\P{Jg=malayalambha}', "");
    Expect(1, 2150, '\P{^Jg=malayalambha}', "");
    Expect(0, 2151, '\p{Jg=malayalambha}', "");
    Expect(1, 2151, '\p{^Jg=malayalambha}', "");
    Expect(1, 2151, '\P{Jg=malayalambha}', "");
    Expect(0, 2151, '\P{^Jg=malayalambha}', "");
    Expect(1, 2150, '\p{Jg=:\Amalayalambha\z:}', "");;
    Expect(0, 2151, '\p{Jg=:\Amalayalambha\z:}', "");;
    Expect(1, 2150, '\p{Jg:   __MALAYALAM_Bha}', "");
    Expect(0, 2150, '\p{^Jg:   __MALAYALAM_Bha}', "");
    Expect(0, 2150, '\P{Jg:   __MALAYALAM_Bha}', "");
    Expect(1, 2150, '\P{^Jg:   __MALAYALAM_Bha}', "");
    Expect(0, 2151, '\p{Jg:   __MALAYALAM_Bha}', "");
    Expect(1, 2151, '\p{^Jg:   __MALAYALAM_Bha}', "");
    Expect(1, 2151, '\P{Jg:   __MALAYALAM_Bha}', "");
    Expect(0, 2151, '\P{^Jg:   __MALAYALAM_Bha}', "");
    Error('\p{Is_Joining_Group=:=--Malayalam_Bha}');
    Error('\P{Is_Joining_Group=:=--Malayalam_Bha}');
    Expect(1, 2150, '\p{Is_Joining_Group=malayalambha}', "");
    Expect(0, 2150, '\p{^Is_Joining_Group=malayalambha}', "");
    Expect(0, 2150, '\P{Is_Joining_Group=malayalambha}', "");
    Expect(1, 2150, '\P{^Is_Joining_Group=malayalambha}', "");
    Expect(0, 2151, '\p{Is_Joining_Group=malayalambha}', "");
    Expect(1, 2151, '\p{^Is_Joining_Group=malayalambha}', "");
    Expect(1, 2151, '\P{Is_Joining_Group=malayalambha}', "");
    Expect(0, 2151, '\P{^Is_Joining_Group=malayalambha}', "");
    Expect(1, 2150, '\p{Is_Joining_Group=-Malayalam_bha}', "");
    Expect(0, 2150, '\p{^Is_Joining_Group=-Malayalam_bha}', "");
    Expect(0, 2150, '\P{Is_Joining_Group=-Malayalam_bha}', "");
    Expect(1, 2150, '\P{^Is_Joining_Group=-Malayalam_bha}', "");
    Expect(0, 2151, '\p{Is_Joining_Group=-Malayalam_bha}', "");
    Expect(1, 2151, '\p{^Is_Joining_Group=-Malayalam_bha}', "");
    Expect(1, 2151, '\P{Is_Joining_Group=-Malayalam_bha}', "");
    Expect(0, 2151, '\P{^Is_Joining_Group=-Malayalam_bha}', "");
    Error('\p{Is_Jg=:= malayalam_bha}');
    Error('\P{Is_Jg=:= malayalam_bha}');
    Expect(1, 2150, '\p{Is_Jg=malayalambha}', "");
    Expect(0, 2150, '\p{^Is_Jg=malayalambha}', "");
    Expect(0, 2150, '\P{Is_Jg=malayalambha}', "");
    Expect(1, 2150, '\P{^Is_Jg=malayalambha}', "");
    Expect(0, 2151, '\p{Is_Jg=malayalambha}', "");
    Expect(1, 2151, '\p{^Is_Jg=malayalambha}', "");
    Expect(1, 2151, '\P{Is_Jg=malayalambha}', "");
    Expect(0, 2151, '\P{^Is_Jg=malayalambha}', "");
    Expect(1, 2150, '\p{Is_Jg=	Malayalam_Bha}', "");
    Expect(0, 2150, '\p{^Is_Jg=	Malayalam_Bha}', "");
    Expect(0, 2150, '\P{Is_Jg=	Malayalam_Bha}', "");
    Expect(1, 2150, '\P{^Is_Jg=	Malayalam_Bha}', "");
    Expect(0, 2151, '\p{Is_Jg=	Malayalam_Bha}', "");
    Expect(1, 2151, '\p{^Is_Jg=	Malayalam_Bha}', "");
    Expect(1, 2151, '\P{Is_Jg=	Malayalam_Bha}', "");
    Expect(0, 2151, '\P{^Is_Jg=	Malayalam_Bha}', "");
    Error('\p{Joining_Group=/a/malayalam_JA}');
    Error('\P{Joining_Group=/a/malayalam_JA}');
    Expect(1, 2145, '\p{Joining_Group=:\AMalayalam_Ja\z:}', "");;
    Expect(0, 2146, '\p{Joining_Group=:\AMalayalam_Ja\z:}', "");;
    Expect(1, 2145, '\p{Joining_Group:malayalamja}', "");
    Expect(0, 2145, '\p{^Joining_Group:malayalamja}', "");
    Expect(0, 2145, '\P{Joining_Group:malayalamja}', "");
    Expect(1, 2145, '\P{^Joining_Group:malayalamja}', "");
    Expect(0, 2146, '\p{Joining_Group:malayalamja}', "");
    Expect(1, 2146, '\p{^Joining_Group:malayalamja}', "");
    Expect(1, 2146, '\P{Joining_Group:malayalamja}', "");
    Expect(0, 2146, '\P{^Joining_Group:malayalamja}', "");
    Expect(1, 2145, '\p{Joining_Group=:\Amalayalamja\z:}', "");;
    Expect(0, 2146, '\p{Joining_Group=:\Amalayalamja\z:}', "");;
    Expect(1, 2145, '\p{Joining_Group=-Malayalam_Ja}', "");
    Expect(0, 2145, '\p{^Joining_Group=-Malayalam_Ja}', "");
    Expect(0, 2145, '\P{Joining_Group=-Malayalam_Ja}', "");
    Expect(1, 2145, '\P{^Joining_Group=-Malayalam_Ja}', "");
    Expect(0, 2146, '\p{Joining_Group=-Malayalam_Ja}', "");
    Expect(1, 2146, '\p{^Joining_Group=-Malayalam_Ja}', "");
    Expect(1, 2146, '\P{Joining_Group=-Malayalam_Ja}', "");
    Expect(0, 2146, '\P{^Joining_Group=-Malayalam_Ja}', "");
    Error('\p{Jg=/a/_Malayalam_JA}');
    Error('\P{Jg=/a/_Malayalam_JA}');
    Expect(1, 2145, '\p{Jg=:\AMalayalam_Ja\z:}', "");;
    Expect(0, 2146, '\p{Jg=:\AMalayalam_Ja\z:}', "");;
    Expect(1, 2145, '\p{Jg=malayalamja}', "");
    Expect(0, 2145, '\p{^Jg=malayalamja}', "");
    Expect(0, 2145, '\P{Jg=malayalamja}', "");
    Expect(1, 2145, '\P{^Jg=malayalamja}', "");
    Expect(0, 2146, '\p{Jg=malayalamja}', "");
    Expect(1, 2146, '\p{^Jg=malayalamja}', "");
    Expect(1, 2146, '\P{Jg=malayalamja}', "");
    Expect(0, 2146, '\P{^Jg=malayalamja}', "");
    Expect(1, 2145, '\p{Jg=:\Amalayalamja\z:}', "");;
    Expect(0, 2146, '\p{Jg=:\Amalayalamja\z:}', "");;
    Expect(1, 2145, '\p{Jg=__MALAYALAM_Ja}', "");
    Expect(0, 2145, '\p{^Jg=__MALAYALAM_Ja}', "");
    Expect(0, 2145, '\P{Jg=__MALAYALAM_Ja}', "");
    Expect(1, 2145, '\P{^Jg=__MALAYALAM_Ja}', "");
    Expect(0, 2146, '\p{Jg=__MALAYALAM_Ja}', "");
    Expect(1, 2146, '\p{^Jg=__MALAYALAM_Ja}', "");
    Expect(1, 2146, '\P{Jg=__MALAYALAM_Ja}', "");
    Expect(0, 2146, '\P{^Jg=__MALAYALAM_Ja}', "");
    Error('\p{Is_Joining_Group=_:=MALAYALAM_JA}');
    Error('\P{Is_Joining_Group=_:=MALAYALAM_JA}');
    Expect(1, 2145, '\p{Is_Joining_Group=malayalamja}', "");
    Expect(0, 2145, '\p{^Is_Joining_Group=malayalamja}', "");
    Expect(0, 2145, '\P{Is_Joining_Group=malayalamja}', "");
    Expect(1, 2145, '\P{^Is_Joining_Group=malayalamja}', "");
    Expect(0, 2146, '\p{Is_Joining_Group=malayalamja}', "");
    Expect(1, 2146, '\p{^Is_Joining_Group=malayalamja}', "");
    Expect(1, 2146, '\P{Is_Joining_Group=malayalamja}', "");
    Expect(0, 2146, '\P{^Is_Joining_Group=malayalamja}', "");
    Expect(1, 2145, '\p{Is_Joining_Group=_MALAYALAM_JA}', "");
    Expect(0, 2145, '\p{^Is_Joining_Group=_MALAYALAM_JA}', "");
    Expect(0, 2145, '\P{Is_Joining_Group=_MALAYALAM_JA}', "");
    Expect(1, 2145, '\P{^Is_Joining_Group=_MALAYALAM_JA}', "");
    Expect(0, 2146, '\p{Is_Joining_Group=_MALAYALAM_JA}', "");
    Expect(1, 2146, '\p{^Is_Joining_Group=_MALAYALAM_JA}', "");
    Expect(1, 2146, '\P{Is_Joining_Group=_MALAYALAM_JA}', "");
    Expect(0, 2146, '\P{^Is_Joining_Group=_MALAYALAM_JA}', "");
    Error('\p{Is_Jg= /a/MALAYALAM_Ja}');
    Error('\P{Is_Jg= /a/MALAYALAM_Ja}');
    Expect(1, 2145, '\p{Is_Jg=malayalamja}', "");
    Expect(0, 2145, '\p{^Is_Jg=malayalamja}', "");
    Expect(0, 2145, '\P{Is_Jg=malayalamja}', "");
    Expect(1, 2145, '\P{^Is_Jg=malayalamja}', "");
    Expect(0, 2146, '\p{Is_Jg=malayalamja}', "");
    Expect(1, 2146, '\p{^Is_Jg=malayalamja}', "");
    Expect(1, 2146, '\P{Is_Jg=malayalamja}', "");
    Expect(0, 2146, '\P{^Is_Jg=malayalamja}', "");
    Expect(1, 2145, '\p{Is_Jg=- malayalam_JA}', "");
    Expect(0, 2145, '\p{^Is_Jg=- malayalam_JA}', "");
    Expect(0, 2145, '\P{Is_Jg=- malayalam_JA}', "");
    Expect(1, 2145, '\P{^Is_Jg=- malayalam_JA}', "");
    Expect(0, 2146, '\p{Is_Jg=- malayalam_JA}', "");
    Expect(1, 2146, '\p{^Is_Jg=- malayalam_JA}', "");
    Expect(1, 2146, '\P{Is_Jg=- malayalam_JA}', "");
    Expect(0, 2146, '\P{^Is_Jg=- malayalam_JA}', "");
    Error('\p{Joining_Group=	malayalam_lla:=}');
    Error('\P{Joining_Group=	malayalam_lla:=}');
    Expect(1, 2152, '\p{Joining_Group=:\AMalayalam_Lla\z:}', "");;
    Expect(0, 2153, '\p{Joining_Group=:\AMalayalam_Lla\z:}', "");;
    Expect(1, 2152, '\p{Joining_Group: malayalamlla}', "");
    Expect(0, 2152, '\p{^Joining_Group: malayalamlla}', "");
    Expect(0, 2152, '\P{Joining_Group: malayalamlla}', "");
    Expect(1, 2152, '\P{^Joining_Group: malayalamlla}', "");
    Expect(0, 2153, '\p{Joining_Group: malayalamlla}', "");
    Expect(1, 2153, '\p{^Joining_Group: malayalamlla}', "");
    Expect(1, 2153, '\P{Joining_Group: malayalamlla}', "");
    Expect(0, 2153, '\P{^Joining_Group: malayalamlla}', "");
    Expect(1, 2152, '\p{Joining_Group=:\Amalayalamlla\z:}', "");;
    Expect(0, 2153, '\p{Joining_Group=:\Amalayalamlla\z:}', "");;
    Expect(1, 2152, '\p{Joining_Group=--Malayalam_Lla}', "");
    Expect(0, 2152, '\p{^Joining_Group=--Malayalam_Lla}', "");
    Expect(0, 2152, '\P{Joining_Group=--Malayalam_Lla}', "");
    Expect(1, 2152, '\P{^Joining_Group=--Malayalam_Lla}', "");
    Expect(0, 2153, '\p{Joining_Group=--Malayalam_Lla}', "");
    Expect(1, 2153, '\p{^Joining_Group=--Malayalam_Lla}', "");
    Expect(1, 2153, '\P{Joining_Group=--Malayalam_Lla}', "");
    Expect(0, 2153, '\P{^Joining_Group=--Malayalam_Lla}', "");
    Error('\p{Jg=:=_	Malayalam_lla}');
    Error('\P{Jg=:=_	Malayalam_lla}');
    Expect(1, 2152, '\p{Jg=:\AMalayalam_Lla\z:}', "");;
    Expect(0, 2153, '\p{Jg=:\AMalayalam_Lla\z:}', "");;
    Expect(1, 2152, '\p{Jg=malayalamlla}', "");
    Expect(0, 2152, '\p{^Jg=malayalamlla}', "");
    Expect(0, 2152, '\P{Jg=malayalamlla}', "");
    Expect(1, 2152, '\P{^Jg=malayalamlla}', "");
    Expect(0, 2153, '\p{Jg=malayalamlla}', "");
    Expect(1, 2153, '\p{^Jg=malayalamlla}', "");
    Expect(1, 2153, '\P{Jg=malayalamlla}', "");
    Expect(0, 2153, '\P{^Jg=malayalamlla}', "");
    Expect(1, 2152, '\p{Jg=:\Amalayalamlla\z:}', "");;
    Expect(0, 2153, '\p{Jg=:\Amalayalamlla\z:}', "");;
    Expect(1, 2152, '\p{Jg=_Malayalam_Lla}', "");
    Expect(0, 2152, '\p{^Jg=_Malayalam_Lla}', "");
    Expect(0, 2152, '\P{Jg=_Malayalam_Lla}', "");
    Expect(1, 2152, '\P{^Jg=_Malayalam_Lla}', "");
    Expect(0, 2153, '\p{Jg=_Malayalam_Lla}', "");
    Expect(1, 2153, '\p{^Jg=_Malayalam_Lla}', "");
    Expect(1, 2153, '\P{Jg=_Malayalam_Lla}', "");
    Expect(0, 2153, '\P{^Jg=_Malayalam_Lla}', "");
    Error('\p{Is_Joining_Group=-Malayalam_Lla:=}');
    Error('\P{Is_Joining_Group=-Malayalam_Lla:=}');
    Expect(1, 2152, '\p{Is_Joining_Group=malayalamlla}', "");
    Expect(0, 2152, '\p{^Is_Joining_Group=malayalamlla}', "");
    Expect(0, 2152, '\P{Is_Joining_Group=malayalamlla}', "");
    Expect(1, 2152, '\P{^Is_Joining_Group=malayalamlla}', "");
    Expect(0, 2153, '\p{Is_Joining_Group=malayalamlla}', "");
    Expect(1, 2153, '\p{^Is_Joining_Group=malayalamlla}', "");
    Expect(1, 2153, '\P{Is_Joining_Group=malayalamlla}', "");
    Expect(0, 2153, '\P{^Is_Joining_Group=malayalamlla}', "");
    Expect(1, 2152, '\p{Is_Joining_Group= 	Malayalam_Lla}', "");
    Expect(0, 2152, '\p{^Is_Joining_Group= 	Malayalam_Lla}', "");
    Expect(0, 2152, '\P{Is_Joining_Group= 	Malayalam_Lla}', "");
    Expect(1, 2152, '\P{^Is_Joining_Group= 	Malayalam_Lla}', "");
    Expect(0, 2153, '\p{Is_Joining_Group= 	Malayalam_Lla}', "");
    Expect(1, 2153, '\p{^Is_Joining_Group= 	Malayalam_Lla}', "");
    Expect(1, 2153, '\P{Is_Joining_Group= 	Malayalam_Lla}', "");
    Expect(0, 2153, '\P{^Is_Joining_Group= 	Malayalam_Lla}', "");
    Error('\p{Is_Jg= Malayalam_lla/a/}');
    Error('\P{Is_Jg= Malayalam_lla/a/}');
    Expect(1, 2152, '\p{Is_Jg=malayalamlla}', "");
    Expect(0, 2152, '\p{^Is_Jg=malayalamlla}', "");
    Expect(0, 2152, '\P{Is_Jg=malayalamlla}', "");
    Expect(1, 2152, '\P{^Is_Jg=malayalamlla}', "");
    Expect(0, 2153, '\p{Is_Jg=malayalamlla}', "");
    Expect(1, 2153, '\p{^Is_Jg=malayalamlla}', "");
    Expect(1, 2153, '\P{Is_Jg=malayalamlla}', "");
    Expect(0, 2153, '\P{^Is_Jg=malayalamlla}', "");
    Expect(1, 2152, '\p{Is_Jg=_Malayalam_Lla}', "");
    Expect(0, 2152, '\p{^Is_Jg=_Malayalam_Lla}', "");
    Expect(0, 2152, '\P{Is_Jg=_Malayalam_Lla}', "");
    Expect(1, 2152, '\P{^Is_Jg=_Malayalam_Lla}', "");
    Expect(0, 2153, '\p{Is_Jg=_Malayalam_Lla}', "");
    Expect(1, 2153, '\p{^Is_Jg=_Malayalam_Lla}', "");
    Expect(1, 2153, '\P{Is_Jg=_Malayalam_Lla}', "");
    Expect(0, 2153, '\P{^Is_Jg=_Malayalam_Lla}', "");
    Error('\p{Joining_Group=	:=Malayalam_Llla}');
    Error('\P{Joining_Group=	:=Malayalam_Llla}');
    Expect(1, 2153, '\p{Joining_Group=:\AMalayalam_Llla\z:}', "");;
    Expect(0, 2154, '\p{Joining_Group=:\AMalayalam_Llla\z:}', "");;
    Expect(1, 2153, '\p{Joining_Group=malayalamllla}', "");
    Expect(0, 2153, '\p{^Joining_Group=malayalamllla}', "");
    Expect(0, 2153, '\P{Joining_Group=malayalamllla}', "");
    Expect(1, 2153, '\P{^Joining_Group=malayalamllla}', "");
    Expect(0, 2154, '\p{Joining_Group=malayalamllla}', "");
    Expect(1, 2154, '\p{^Joining_Group=malayalamllla}', "");
    Expect(1, 2154, '\P{Joining_Group=malayalamllla}', "");
    Expect(0, 2154, '\P{^Joining_Group=malayalamllla}', "");
    Expect(1, 2153, '\p{Joining_Group=:\Amalayalamllla\z:}', "");;
    Expect(0, 2154, '\p{Joining_Group=:\Amalayalamllla\z:}', "");;
    Expect(1, 2153, '\p{Joining_Group=-	Malayalam_LLLA}', "");
    Expect(0, 2153, '\p{^Joining_Group=-	Malayalam_LLLA}', "");
    Expect(0, 2153, '\P{Joining_Group=-	Malayalam_LLLA}', "");
    Expect(1, 2153, '\P{^Joining_Group=-	Malayalam_LLLA}', "");
    Expect(0, 2154, '\p{Joining_Group=-	Malayalam_LLLA}', "");
    Expect(1, 2154, '\p{^Joining_Group=-	Malayalam_LLLA}', "");
    Expect(1, 2154, '\P{Joining_Group=-	Malayalam_LLLA}', "");
    Expect(0, 2154, '\P{^Joining_Group=-	Malayalam_LLLA}', "");
    Error('\p{Jg=__Malayalam_Llla/a/}');
    Error('\P{Jg=__Malayalam_Llla/a/}');
    Expect(1, 2153, '\p{Jg=:\AMalayalam_Llla\z:}', "");;
    Expect(0, 2154, '\p{Jg=:\AMalayalam_Llla\z:}', "");;
    Expect(1, 2153, '\p{Jg=malayalamllla}', "");
    Expect(0, 2153, '\p{^Jg=malayalamllla}', "");
    Expect(0, 2153, '\P{Jg=malayalamllla}', "");
    Expect(1, 2153, '\P{^Jg=malayalamllla}', "");
    Expect(0, 2154, '\p{Jg=malayalamllla}', "");
    Expect(1, 2154, '\p{^Jg=malayalamllla}', "");
    Expect(1, 2154, '\P{Jg=malayalamllla}', "");
    Expect(0, 2154, '\P{^Jg=malayalamllla}', "");
    Expect(1, 2153, '\p{Jg=:\Amalayalamllla\z:}', "");;
    Expect(0, 2154, '\p{Jg=:\Amalayalamllla\z:}', "");;
    Expect(1, 2153, '\p{Jg= 	malayalam_Llla}', "");
    Expect(0, 2153, '\p{^Jg= 	malayalam_Llla}', "");
    Expect(0, 2153, '\P{Jg= 	malayalam_Llla}', "");
    Expect(1, 2153, '\P{^Jg= 	malayalam_Llla}', "");
    Expect(0, 2154, '\p{Jg= 	malayalam_Llla}', "");
    Expect(1, 2154, '\p{^Jg= 	malayalam_Llla}', "");
    Expect(1, 2154, '\P{Jg= 	malayalam_Llla}', "");
    Expect(0, 2154, '\P{^Jg= 	malayalam_Llla}', "");
    Error('\p{Is_Joining_Group=-/a/malayalam_Llla}');
    Error('\P{Is_Joining_Group=-/a/malayalam_Llla}');
    Expect(1, 2153, '\p{Is_Joining_Group=malayalamllla}', "");
    Expect(0, 2153, '\p{^Is_Joining_Group=malayalamllla}', "");
    Expect(0, 2153, '\P{Is_Joining_Group=malayalamllla}', "");
    Expect(1, 2153, '\P{^Is_Joining_Group=malayalamllla}', "");
    Expect(0, 2154, '\p{Is_Joining_Group=malayalamllla}', "");
    Expect(1, 2154, '\p{^Is_Joining_Group=malayalamllla}', "");
    Expect(1, 2154, '\P{Is_Joining_Group=malayalamllla}', "");
    Expect(0, 2154, '\P{^Is_Joining_Group=malayalamllla}', "");
    Expect(1, 2153, '\p{Is_Joining_Group=		Malayalam_Llla}', "");
    Expect(0, 2153, '\p{^Is_Joining_Group=		Malayalam_Llla}', "");
    Expect(0, 2153, '\P{Is_Joining_Group=		Malayalam_Llla}', "");
    Expect(1, 2153, '\P{^Is_Joining_Group=		Malayalam_Llla}', "");
    Expect(0, 2154, '\p{Is_Joining_Group=		Malayalam_Llla}', "");
    Expect(1, 2154, '\p{^Is_Joining_Group=		Malayalam_Llla}', "");
    Expect(1, 2154, '\P{Is_Joining_Group=		Malayalam_Llla}', "");
    Expect(0, 2154, '\P{^Is_Joining_Group=		Malayalam_Llla}', "");
    Error('\p{Is_Jg=:=Malayalam_Llla}');
    Error('\P{Is_Jg=:=Malayalam_Llla}');
    Expect(1, 2153, '\p{Is_Jg=malayalamllla}', "");
    Expect(0, 2153, '\p{^Is_Jg=malayalamllla}', "");
    Expect(0, 2153, '\P{Is_Jg=malayalamllla}', "");
    Expect(1, 2153, '\P{^Is_Jg=malayalamllla}', "");
    Expect(0, 2154, '\p{Is_Jg=malayalamllla}', "");
    Expect(1, 2154, '\p{^Is_Jg=malayalamllla}', "");
    Expect(1, 2154, '\P{Is_Jg=malayalamllla}', "");
    Expect(0, 2154, '\P{^Is_Jg=malayalamllla}', "");
    Expect(1, 2153, '\p{Is_Jg=__Malayalam_Llla}', "");
    Expect(0, 2153, '\p{^Is_Jg=__Malayalam_Llla}', "");
    Expect(0, 2153, '\P{Is_Jg=__Malayalam_Llla}', "");
    Expect(1, 2153, '\P{^Is_Jg=__Malayalam_Llla}', "");
    Expect(0, 2154, '\p{Is_Jg=__Malayalam_Llla}', "");
    Expect(1, 2154, '\p{^Is_Jg=__Malayalam_Llla}', "");
    Expect(1, 2154, '\P{Is_Jg=__Malayalam_Llla}', "");
    Expect(0, 2154, '\P{^Is_Jg=__Malayalam_Llla}', "");
    Error('\p{Joining_Group:/a/_MALAYALAM_Nga}');
    Error('\P{Joining_Group:/a/_MALAYALAM_Nga}');
    Expect(1, 2144, '\p{Joining_Group=:\AMalayalam_Nga\z:}', "");;
    Expect(0, 2145, '\p{Joining_Group=:\AMalayalam_Nga\z:}', "");;
    Expect(1, 2144, '\p{Joining_Group=malayalamnga}', "");
    Expect(0, 2144, '\p{^Joining_Group=malayalamnga}', "");
    Expect(0, 2144, '\P{Joining_Group=malayalamnga}', "");
    Expect(1, 2144, '\P{^Joining_Group=malayalamnga}', "");
    Expect(0, 2145, '\p{Joining_Group=malayalamnga}', "");
    Expect(1, 2145, '\p{^Joining_Group=malayalamnga}', "");
    Expect(1, 2145, '\P{Joining_Group=malayalamnga}', "");
    Expect(0, 2145, '\P{^Joining_Group=malayalamnga}', "");
    Expect(1, 2144, '\p{Joining_Group=:\Amalayalamnga\z:}', "");;
    Expect(0, 2145, '\p{Joining_Group=:\Amalayalamnga\z:}', "");;
    Expect(1, 2144, '\p{Joining_Group:  _Malayalam_Nga}', "");
    Expect(0, 2144, '\p{^Joining_Group:  _Malayalam_Nga}', "");
    Expect(0, 2144, '\P{Joining_Group:  _Malayalam_Nga}', "");
    Expect(1, 2144, '\P{^Joining_Group:  _Malayalam_Nga}', "");
    Expect(0, 2145, '\p{Joining_Group:  _Malayalam_Nga}', "");
    Expect(1, 2145, '\p{^Joining_Group:  _Malayalam_Nga}', "");
    Expect(1, 2145, '\P{Joining_Group:  _Malayalam_Nga}', "");
    Expect(0, 2145, '\P{^Joining_Group:  _Malayalam_Nga}', "");
    Error('\p{Jg=	:=MALAYALAM_Nga}');
    Error('\P{Jg=	:=MALAYALAM_Nga}');
    Expect(1, 2144, '\p{Jg=:\AMalayalam_Nga\z:}', "");;
    Expect(0, 2145, '\p{Jg=:\AMalayalam_Nga\z:}', "");;
    Expect(1, 2144, '\p{Jg=malayalamnga}', "");
    Expect(0, 2144, '\p{^Jg=malayalamnga}', "");
    Expect(0, 2144, '\P{Jg=malayalamnga}', "");
    Expect(1, 2144, '\P{^Jg=malayalamnga}', "");
    Expect(0, 2145, '\p{Jg=malayalamnga}', "");
    Expect(1, 2145, '\p{^Jg=malayalamnga}', "");
    Expect(1, 2145, '\P{Jg=malayalamnga}', "");
    Expect(0, 2145, '\P{^Jg=malayalamnga}', "");
    Expect(1, 2144, '\p{Jg=:\Amalayalamnga\z:}', "");;
    Expect(0, 2145, '\p{Jg=:\Amalayalamnga\z:}', "");;
    Expect(1, 2144, '\p{Jg=	malayalam_NGA}', "");
    Expect(0, 2144, '\p{^Jg=	malayalam_NGA}', "");
    Expect(0, 2144, '\P{Jg=	malayalam_NGA}', "");
    Expect(1, 2144, '\P{^Jg=	malayalam_NGA}', "");
    Expect(0, 2145, '\p{Jg=	malayalam_NGA}', "");
    Expect(1, 2145, '\p{^Jg=	malayalam_NGA}', "");
    Expect(1, 2145, '\P{Jg=	malayalam_NGA}', "");
    Expect(0, 2145, '\P{^Jg=	malayalam_NGA}', "");
    Error('\p{Is_Joining_Group=/a/_malayalam_nga}');
    Error('\P{Is_Joining_Group=/a/_malayalam_nga}');
    Expect(1, 2144, '\p{Is_Joining_Group:malayalamnga}', "");
    Expect(0, 2144, '\p{^Is_Joining_Group:malayalamnga}', "");
    Expect(0, 2144, '\P{Is_Joining_Group:malayalamnga}', "");
    Expect(1, 2144, '\P{^Is_Joining_Group:malayalamnga}', "");
    Expect(0, 2145, '\p{Is_Joining_Group:malayalamnga}', "");
    Expect(1, 2145, '\p{^Is_Joining_Group:malayalamnga}', "");
    Expect(1, 2145, '\P{Is_Joining_Group:malayalamnga}', "");
    Expect(0, 2145, '\P{^Is_Joining_Group:malayalamnga}', "");
    Expect(1, 2144, '\p{Is_Joining_Group=		Malayalam_Nga}', "");
    Expect(0, 2144, '\p{^Is_Joining_Group=		Malayalam_Nga}', "");
    Expect(0, 2144, '\P{Is_Joining_Group=		Malayalam_Nga}', "");
    Expect(1, 2144, '\P{^Is_Joining_Group=		Malayalam_Nga}', "");
    Expect(0, 2145, '\p{Is_Joining_Group=		Malayalam_Nga}', "");
    Expect(1, 2145, '\p{^Is_Joining_Group=		Malayalam_Nga}', "");
    Expect(1, 2145, '\P{Is_Joining_Group=		Malayalam_Nga}', "");
    Expect(0, 2145, '\P{^Is_Joining_Group=		Malayalam_Nga}', "");
    Error('\p{Is_Jg=/a/-malayalam_NGA}');
    Error('\P{Is_Jg=/a/-malayalam_NGA}');
    Expect(1, 2144, '\p{Is_Jg=malayalamnga}', "");
    Expect(0, 2144, '\p{^Is_Jg=malayalamnga}', "");
    Expect(0, 2144, '\P{Is_Jg=malayalamnga}', "");
    Expect(1, 2144, '\P{^Is_Jg=malayalamnga}', "");
    Expect(0, 2145, '\p{Is_Jg=malayalamnga}', "");
    Expect(1, 2145, '\p{^Is_Jg=malayalamnga}', "");
    Expect(1, 2145, '\P{Is_Jg=malayalamnga}', "");
    Expect(0, 2145, '\P{^Is_Jg=malayalamnga}', "");
    Expect(1, 2144, '\p{Is_Jg=	 Malayalam_nga}', "");
    Expect(0, 2144, '\p{^Is_Jg=	 Malayalam_nga}', "");
    Expect(0, 2144, '\P{Is_Jg=	 Malayalam_nga}', "");
    Expect(1, 2144, '\P{^Is_Jg=	 Malayalam_nga}', "");
    Expect(0, 2145, '\p{Is_Jg=	 Malayalam_nga}', "");
    Expect(1, 2145, '\p{^Is_Jg=	 Malayalam_nga}', "");
    Expect(1, 2145, '\P{Is_Jg=	 Malayalam_nga}', "");
    Expect(0, 2145, '\P{^Is_Jg=	 Malayalam_nga}', "");
    Error('\p{Joining_Group=		MALAYALAM_Nna/a/}');
    Error('\P{Joining_Group=		MALAYALAM_Nna/a/}');
    Expect(1, 2148, '\p{Joining_Group=:\AMalayalam_Nna\z:}', "");;
    Expect(0, 2149, '\p{Joining_Group=:\AMalayalam_Nna\z:}', "");;
    Expect(1, 2148, '\p{Joining_Group=malayalamnna}', "");
    Expect(0, 2148, '\p{^Joining_Group=malayalamnna}', "");
    Expect(0, 2148, '\P{Joining_Group=malayalamnna}', "");
    Expect(1, 2148, '\P{^Joining_Group=malayalamnna}', "");
    Expect(0, 2149, '\p{Joining_Group=malayalamnna}', "");
    Expect(1, 2149, '\p{^Joining_Group=malayalamnna}', "");
    Expect(1, 2149, '\P{Joining_Group=malayalamnna}', "");
    Expect(0, 2149, '\P{^Joining_Group=malayalamnna}', "");
    Expect(1, 2148, '\p{Joining_Group=:\Amalayalamnna\z:}', "");;
    Expect(0, 2149, '\p{Joining_Group=:\Amalayalamnna\z:}', "");;
    Expect(1, 2148, '\p{Joining_Group=-malayalam_NNA}', "");
    Expect(0, 2148, '\p{^Joining_Group=-malayalam_NNA}', "");
    Expect(0, 2148, '\P{Joining_Group=-malayalam_NNA}', "");
    Expect(1, 2148, '\P{^Joining_Group=-malayalam_NNA}', "");
    Expect(0, 2149, '\p{Joining_Group=-malayalam_NNA}', "");
    Expect(1, 2149, '\p{^Joining_Group=-malayalam_NNA}', "");
    Expect(1, 2149, '\P{Joining_Group=-malayalam_NNA}', "");
    Expect(0, 2149, '\P{^Joining_Group=-malayalam_NNA}', "");
    Error('\p{Jg=/a/--Malayalam_NNA}');
    Error('\P{Jg=/a/--Malayalam_NNA}');
    Expect(1, 2148, '\p{Jg=:\AMalayalam_Nna\z:}', "");;
    Expect(0, 2149, '\p{Jg=:\AMalayalam_Nna\z:}', "");;
    Expect(1, 2148, '\p{Jg=malayalamnna}', "");
    Expect(0, 2148, '\p{^Jg=malayalamnna}', "");
    Expect(0, 2148, '\P{Jg=malayalamnna}', "");
    Expect(1, 2148, '\P{^Jg=malayalamnna}', "");
    Expect(0, 2149, '\p{Jg=malayalamnna}', "");
    Expect(1, 2149, '\p{^Jg=malayalamnna}', "");
    Expect(1, 2149, '\P{Jg=malayalamnna}', "");
    Expect(0, 2149, '\P{^Jg=malayalamnna}', "");
    Expect(1, 2148, '\p{Jg=:\Amalayalamnna\z:}', "");;
    Expect(0, 2149, '\p{Jg=:\Amalayalamnna\z:}', "");;
    Expect(1, 2148, '\p{Jg=_Malayalam_Nna}', "");
    Expect(0, 2148, '\p{^Jg=_Malayalam_Nna}', "");
    Expect(0, 2148, '\P{Jg=_Malayalam_Nna}', "");
    Expect(1, 2148, '\P{^Jg=_Malayalam_Nna}', "");
    Expect(0, 2149, '\p{Jg=_Malayalam_Nna}', "");
    Expect(1, 2149, '\p{^Jg=_Malayalam_Nna}', "");
    Expect(1, 2149, '\P{Jg=_Malayalam_Nna}', "");
    Expect(0, 2149, '\P{^Jg=_Malayalam_Nna}', "");
    Error('\p{Is_Joining_Group=-_MALAYALAM_NNA:=}');
    Error('\P{Is_Joining_Group=-_MALAYALAM_NNA:=}');
    Expect(1, 2148, '\p{Is_Joining_Group=malayalamnna}', "");
    Expect(0, 2148, '\p{^Is_Joining_Group=malayalamnna}', "");
    Expect(0, 2148, '\P{Is_Joining_Group=malayalamnna}', "");
    Expect(1, 2148, '\P{^Is_Joining_Group=malayalamnna}', "");
    Expect(0, 2149, '\p{Is_Joining_Group=malayalamnna}', "");
    Expect(1, 2149, '\p{^Is_Joining_Group=malayalamnna}', "");
    Expect(1, 2149, '\P{Is_Joining_Group=malayalamnna}', "");
    Expect(0, 2149, '\P{^Is_Joining_Group=malayalamnna}', "");
    Expect(1, 2148, '\p{Is_Joining_Group=	malayalam_NNA}', "");
    Expect(0, 2148, '\p{^Is_Joining_Group=	malayalam_NNA}', "");
    Expect(0, 2148, '\P{Is_Joining_Group=	malayalam_NNA}', "");
    Expect(1, 2148, '\P{^Is_Joining_Group=	malayalam_NNA}', "");
    Expect(0, 2149, '\p{Is_Joining_Group=	malayalam_NNA}', "");
    Expect(1, 2149, '\p{^Is_Joining_Group=	malayalam_NNA}', "");
    Expect(1, 2149, '\P{Is_Joining_Group=	malayalam_NNA}', "");
    Expect(0, 2149, '\P{^Is_Joining_Group=	malayalam_NNA}', "");
    Error('\p{Is_Jg=:=__malayalam_NNA}');
    Error('\P{Is_Jg=:=__malayalam_NNA}');
    Expect(1, 2148, '\p{Is_Jg=malayalamnna}', "");
    Expect(0, 2148, '\p{^Is_Jg=malayalamnna}', "");
    Expect(0, 2148, '\P{Is_Jg=malayalamnna}', "");
    Expect(1, 2148, '\P{^Is_Jg=malayalamnna}', "");
    Expect(0, 2149, '\p{Is_Jg=malayalamnna}', "");
    Expect(1, 2149, '\p{^Is_Jg=malayalamnna}', "");
    Expect(1, 2149, '\P{Is_Jg=malayalamnna}', "");
    Expect(0, 2149, '\P{^Is_Jg=malayalamnna}', "");
    Expect(1, 2148, '\p{Is_Jg=-Malayalam_nna}', "");
    Expect(0, 2148, '\p{^Is_Jg=-Malayalam_nna}', "");
    Expect(0, 2148, '\P{Is_Jg=-Malayalam_nna}', "");
    Expect(1, 2148, '\P{^Is_Jg=-Malayalam_nna}', "");
    Expect(0, 2149, '\p{Is_Jg=-Malayalam_nna}', "");
    Expect(1, 2149, '\p{^Is_Jg=-Malayalam_nna}', "");
    Expect(1, 2149, '\P{Is_Jg=-Malayalam_nna}', "");
    Expect(0, 2149, '\P{^Is_Jg=-Malayalam_nna}', "");
    Error('\p{Joining_Group=-_malayalam_Nnna:=}');
    Error('\P{Joining_Group=-_malayalam_Nnna:=}');
    Expect(1, 2149, '\p{Joining_Group=:\AMalayalam_Nnna\z:}', "");;
    Expect(0, 2150, '\p{Joining_Group=:\AMalayalam_Nnna\z:}', "");;
    Expect(1, 2149, '\p{Joining_Group=malayalamnnna}', "");
    Expect(0, 2149, '\p{^Joining_Group=malayalamnnna}', "");
    Expect(0, 2149, '\P{Joining_Group=malayalamnnna}', "");
    Expect(1, 2149, '\P{^Joining_Group=malayalamnnna}', "");
    Expect(0, 2150, '\p{Joining_Group=malayalamnnna}', "");
    Expect(1, 2150, '\p{^Joining_Group=malayalamnnna}', "");
    Expect(1, 2150, '\P{Joining_Group=malayalamnnna}', "");
    Expect(0, 2150, '\P{^Joining_Group=malayalamnnna}', "");
    Expect(1, 2149, '\p{Joining_Group=:\Amalayalamnnna\z:}', "");;
    Expect(0, 2150, '\p{Joining_Group=:\Amalayalamnnna\z:}', "");;
    Expect(1, 2149, '\p{Joining_Group=-_MALAYALAM_Nnna}', "");
    Expect(0, 2149, '\p{^Joining_Group=-_MALAYALAM_Nnna}', "");
    Expect(0, 2149, '\P{Joining_Group=-_MALAYALAM_Nnna}', "");
    Expect(1, 2149, '\P{^Joining_Group=-_MALAYALAM_Nnna}', "");
    Expect(0, 2150, '\p{Joining_Group=-_MALAYALAM_Nnna}', "");
    Expect(1, 2150, '\p{^Joining_Group=-_MALAYALAM_Nnna}', "");
    Expect(1, 2150, '\P{Joining_Group=-_MALAYALAM_Nnna}', "");
    Expect(0, 2150, '\P{^Joining_Group=-_MALAYALAM_Nnna}', "");
    Error('\p{Jg=/a/_ Malayalam_Nnna}');
    Error('\P{Jg=/a/_ Malayalam_Nnna}');
    Expect(1, 2149, '\p{Jg=:\AMalayalam_Nnna\z:}', "");;
    Expect(0, 2150, '\p{Jg=:\AMalayalam_Nnna\z:}', "");;
    Expect(1, 2149, '\p{Jg=malayalamnnna}', "");
    Expect(0, 2149, '\p{^Jg=malayalamnnna}', "");
    Expect(0, 2149, '\P{Jg=malayalamnnna}', "");
    Expect(1, 2149, '\P{^Jg=malayalamnnna}', "");
    Expect(0, 2150, '\p{Jg=malayalamnnna}', "");
    Expect(1, 2150, '\p{^Jg=malayalamnnna}', "");
    Expect(1, 2150, '\P{Jg=malayalamnnna}', "");
    Expect(0, 2150, '\P{^Jg=malayalamnnna}', "");
    Expect(1, 2149, '\p{Jg=:\Amalayalamnnna\z:}', "");;
    Expect(0, 2150, '\p{Jg=:\Amalayalamnnna\z:}', "");;
    Expect(1, 2149, '\p{Jg=-	Malayalam_nnna}', "");
    Expect(0, 2149, '\p{^Jg=-	Malayalam_nnna}', "");
    Expect(0, 2149, '\P{Jg=-	Malayalam_nnna}', "");
    Expect(1, 2149, '\P{^Jg=-	Malayalam_nnna}', "");
    Expect(0, 2150, '\p{Jg=-	Malayalam_nnna}', "");
    Expect(1, 2150, '\p{^Jg=-	Malayalam_nnna}', "");
    Expect(1, 2150, '\P{Jg=-	Malayalam_nnna}', "");
    Expect(0, 2150, '\P{^Jg=-	Malayalam_nnna}', "");
    Error('\p{Is_Joining_Group=:=	_MALAYALAM_nnna}');
    Error('\P{Is_Joining_Group=:=	_MALAYALAM_nnna}');
    Expect(1, 2149, '\p{Is_Joining_Group=malayalamnnna}', "");
    Expect(0, 2149, '\p{^Is_Joining_Group=malayalamnnna}', "");
    Expect(0, 2149, '\P{Is_Joining_Group=malayalamnnna}', "");
    Expect(1, 2149, '\P{^Is_Joining_Group=malayalamnnna}', "");
    Expect(0, 2150, '\p{Is_Joining_Group=malayalamnnna}', "");
    Expect(1, 2150, '\p{^Is_Joining_Group=malayalamnnna}', "");
    Expect(1, 2150, '\P{Is_Joining_Group=malayalamnnna}', "");
    Expect(0, 2150, '\P{^Is_Joining_Group=malayalamnnna}', "");
    Expect(1, 2149, '\p{Is_Joining_Group=-MALAYALAM_nnna}', "");
    Expect(0, 2149, '\p{^Is_Joining_Group=-MALAYALAM_nnna}', "");
    Expect(0, 2149, '\P{Is_Joining_Group=-MALAYALAM_nnna}', "");
    Expect(1, 2149, '\P{^Is_Joining_Group=-MALAYALAM_nnna}', "");
    Expect(0, 2150, '\p{Is_Joining_Group=-MALAYALAM_nnna}', "");
    Expect(1, 2150, '\p{^Is_Joining_Group=-MALAYALAM_nnna}', "");
    Expect(1, 2150, '\P{Is_Joining_Group=-MALAYALAM_nnna}', "");
    Expect(0, 2150, '\P{^Is_Joining_Group=-MALAYALAM_nnna}', "");
    Error('\p{Is_Jg= 	Malayalam_nnna/a/}');
    Error('\P{Is_Jg= 	Malayalam_nnna/a/}');
    Expect(1, 2149, '\p{Is_Jg=malayalamnnna}', "");
    Expect(0, 2149, '\p{^Is_Jg=malayalamnnna}', "");
    Expect(0, 2149, '\P{Is_Jg=malayalamnnna}', "");
    Expect(1, 2149, '\P{^Is_Jg=malayalamnnna}', "");
    Expect(0, 2150, '\p{Is_Jg=malayalamnnna}', "");
    Expect(1, 2150, '\p{^Is_Jg=malayalamnnna}', "");
    Expect(1, 2150, '\P{Is_Jg=malayalamnnna}', "");
    Expect(0, 2150, '\P{^Is_Jg=malayalamnnna}', "");
    Expect(1, 2149, '\p{Is_Jg= 	MALAYALAM_nnna}', "");
    Expect(0, 2149, '\p{^Is_Jg= 	MALAYALAM_nnna}', "");
    Expect(0, 2149, '\P{Is_Jg= 	MALAYALAM_nnna}', "");
    Expect(1, 2149, '\P{^Is_Jg= 	MALAYALAM_nnna}', "");
    Expect(0, 2150, '\p{Is_Jg= 	MALAYALAM_nnna}', "");
    Expect(1, 2150, '\p{^Is_Jg= 	MALAYALAM_nnna}', "");
    Expect(1, 2150, '\P{Is_Jg= 	MALAYALAM_nnna}', "");
    Expect(0, 2150, '\P{^Is_Jg= 	MALAYALAM_nnna}', "");
    Error('\p{Joining_Group=/a/_-malayalam_Nya}');
    Error('\P{Joining_Group=/a/_-malayalam_Nya}');
    Expect(1, 2146, '\p{Joining_Group=:\AMalayalam_Nya\z:}', "");;
    Expect(0, 2147, '\p{Joining_Group=:\AMalayalam_Nya\z:}', "");;
    Expect(1, 2146, '\p{Joining_Group=malayalamnya}', "");
    Expect(0, 2146, '\p{^Joining_Group=malayalamnya}', "");
    Expect(0, 2146, '\P{Joining_Group=malayalamnya}', "");
    Expect(1, 2146, '\P{^Joining_Group=malayalamnya}', "");
    Expect(0, 2147, '\p{Joining_Group=malayalamnya}', "");
    Expect(1, 2147, '\p{^Joining_Group=malayalamnya}', "");
    Expect(1, 2147, '\P{Joining_Group=malayalamnya}', "");
    Expect(0, 2147, '\P{^Joining_Group=malayalamnya}', "");
    Expect(1, 2146, '\p{Joining_Group=:\Amalayalamnya\z:}', "");;
    Expect(0, 2147, '\p{Joining_Group=:\Amalayalamnya\z:}', "");;
    Expect(1, 2146, '\p{Joining_Group=--MALAYALAM_NYA}', "");
    Expect(0, 2146, '\p{^Joining_Group=--MALAYALAM_NYA}', "");
    Expect(0, 2146, '\P{Joining_Group=--MALAYALAM_NYA}', "");
    Expect(1, 2146, '\P{^Joining_Group=--MALAYALAM_NYA}', "");
    Expect(0, 2147, '\p{Joining_Group=--MALAYALAM_NYA}', "");
    Expect(1, 2147, '\p{^Joining_Group=--MALAYALAM_NYA}', "");
    Expect(1, 2147, '\P{Joining_Group=--MALAYALAM_NYA}', "");
    Expect(0, 2147, '\P{^Joining_Group=--MALAYALAM_NYA}', "");
    Error('\p{Jg=:=		MALAYALAM_Nya}');
    Error('\P{Jg=:=		MALAYALAM_Nya}');
    Expect(1, 2146, '\p{Jg=:\AMalayalam_Nya\z:}', "");;
    Expect(0, 2147, '\p{Jg=:\AMalayalam_Nya\z:}', "");;
    Expect(1, 2146, '\p{Jg=malayalamnya}', "");
    Expect(0, 2146, '\p{^Jg=malayalamnya}', "");
    Expect(0, 2146, '\P{Jg=malayalamnya}', "");
    Expect(1, 2146, '\P{^Jg=malayalamnya}', "");
    Expect(0, 2147, '\p{Jg=malayalamnya}', "");
    Expect(1, 2147, '\p{^Jg=malayalamnya}', "");
    Expect(1, 2147, '\P{Jg=malayalamnya}', "");
    Expect(0, 2147, '\P{^Jg=malayalamnya}', "");
    Expect(1, 2146, '\p{Jg=:\Amalayalamnya\z:}', "");;
    Expect(0, 2147, '\p{Jg=:\Amalayalamnya\z:}', "");;
    Expect(1, 2146, '\p{Jg=	Malayalam_NYA}', "");
    Expect(0, 2146, '\p{^Jg=	Malayalam_NYA}', "");
    Expect(0, 2146, '\P{Jg=	Malayalam_NYA}', "");
    Expect(1, 2146, '\P{^Jg=	Malayalam_NYA}', "");
    Expect(0, 2147, '\p{Jg=	Malayalam_NYA}', "");
    Expect(1, 2147, '\p{^Jg=	Malayalam_NYA}', "");
    Expect(1, 2147, '\P{Jg=	Malayalam_NYA}', "");
    Expect(0, 2147, '\P{^Jg=	Malayalam_NYA}', "");
    Error('\p{Is_Joining_Group=/a/		Malayalam_NYA}');
    Error('\P{Is_Joining_Group=/a/		Malayalam_NYA}');
    Expect(1, 2146, '\p{Is_Joining_Group:	malayalamnya}', "");
    Expect(0, 2146, '\p{^Is_Joining_Group:	malayalamnya}', "");
    Expect(0, 2146, '\P{Is_Joining_Group:	malayalamnya}', "");
    Expect(1, 2146, '\P{^Is_Joining_Group:	malayalamnya}', "");
    Expect(0, 2147, '\p{Is_Joining_Group:	malayalamnya}', "");
    Expect(1, 2147, '\p{^Is_Joining_Group:	malayalamnya}', "");
    Expect(1, 2147, '\P{Is_Joining_Group:	malayalamnya}', "");
    Expect(0, 2147, '\P{^Is_Joining_Group:	malayalamnya}', "");
    Expect(1, 2146, '\p{Is_Joining_Group=	Malayalam_Nya}', "");
    Expect(0, 2146, '\p{^Is_Joining_Group=	Malayalam_Nya}', "");
    Expect(0, 2146, '\P{Is_Joining_Group=	Malayalam_Nya}', "");
    Expect(1, 2146, '\P{^Is_Joining_Group=	Malayalam_Nya}', "");
    Expect(0, 2147, '\p{Is_Joining_Group=	Malayalam_Nya}', "");
    Expect(1, 2147, '\p{^Is_Joining_Group=	Malayalam_Nya}', "");
    Expect(1, 2147, '\P{Is_Joining_Group=	Malayalam_Nya}', "");
    Expect(0, 2147, '\P{^Is_Joining_Group=	Malayalam_Nya}', "");
    Error('\p{Is_Jg=:=-	malayalam_Nya}');
    Error('\P{Is_Jg=:=-	malayalam_Nya}');
    Expect(1, 2146, '\p{Is_Jg=malayalamnya}', "");
    Expect(0, 2146, '\p{^Is_Jg=malayalamnya}', "");
    Expect(0, 2146, '\P{Is_Jg=malayalamnya}', "");
    Expect(1, 2146, '\P{^Is_Jg=malayalamnya}', "");
    Expect(0, 2147, '\p{Is_Jg=malayalamnya}', "");
    Expect(1, 2147, '\p{^Is_Jg=malayalamnya}', "");
    Expect(1, 2147, '\P{Is_Jg=malayalamnya}', "");
    Expect(0, 2147, '\P{^Is_Jg=malayalamnya}', "");
    Expect(1, 2146, '\p{Is_Jg= -malayalam_NYA}', "");
    Expect(0, 2146, '\p{^Is_Jg= -malayalam_NYA}', "");
    Expect(0, 2146, '\P{Is_Jg= -malayalam_NYA}', "");
    Expect(1, 2146, '\P{^Is_Jg= -malayalam_NYA}', "");
    Expect(0, 2147, '\p{Is_Jg= -malayalam_NYA}', "");
    Expect(1, 2147, '\p{^Is_Jg= -malayalam_NYA}', "");
    Expect(1, 2147, '\P{Is_Jg= -malayalam_NYA}', "");
    Expect(0, 2147, '\P{^Is_Jg= -malayalam_NYA}', "");
    Error('\p{Joining_Group=_-Malayalam_Ra/a/}');
    Error('\P{Joining_Group=_-Malayalam_Ra/a/}');
    Expect(1, 2151, '\p{Joining_Group=:\AMalayalam_Ra\z:}', "");;
    Expect(0, 2152, '\p{Joining_Group=:\AMalayalam_Ra\z:}', "");;
    Expect(1, 2151, '\p{Joining_Group=malayalamra}', "");
    Expect(0, 2151, '\p{^Joining_Group=malayalamra}', "");
    Expect(0, 2151, '\P{Joining_Group=malayalamra}', "");
    Expect(1, 2151, '\P{^Joining_Group=malayalamra}', "");
    Expect(0, 2152, '\p{Joining_Group=malayalamra}', "");
    Expect(1, 2152, '\p{^Joining_Group=malayalamra}', "");
    Expect(1, 2152, '\P{Joining_Group=malayalamra}', "");
    Expect(0, 2152, '\P{^Joining_Group=malayalamra}', "");
    Expect(1, 2151, '\p{Joining_Group=:\Amalayalamra\z:}', "");;
    Expect(0, 2152, '\p{Joining_Group=:\Amalayalamra\z:}', "");;
    Expect(1, 2151, '\p{Joining_Group=-_malayalam_ra}', "");
    Expect(0, 2151, '\p{^Joining_Group=-_malayalam_ra}', "");
    Expect(0, 2151, '\P{Joining_Group=-_malayalam_ra}', "");
    Expect(1, 2151, '\P{^Joining_Group=-_malayalam_ra}', "");
    Expect(0, 2152, '\p{Joining_Group=-_malayalam_ra}', "");
    Expect(1, 2152, '\p{^Joining_Group=-_malayalam_ra}', "");
    Expect(1, 2152, '\P{Joining_Group=-_malayalam_ra}', "");
    Expect(0, 2152, '\P{^Joining_Group=-_malayalam_ra}', "");
    Error('\p{Jg= _MALAYALAM_Ra:=}');
    Error('\P{Jg= _MALAYALAM_Ra:=}');
    Expect(1, 2151, '\p{Jg=:\AMalayalam_Ra\z:}', "");;
    Expect(0, 2152, '\p{Jg=:\AMalayalam_Ra\z:}', "");;
    Expect(1, 2151, '\p{Jg=malayalamra}', "");
    Expect(0, 2151, '\p{^Jg=malayalamra}', "");
    Expect(0, 2151, '\P{Jg=malayalamra}', "");
    Expect(1, 2151, '\P{^Jg=malayalamra}', "");
    Expect(0, 2152, '\p{Jg=malayalamra}', "");
    Expect(1, 2152, '\p{^Jg=malayalamra}', "");
    Expect(1, 2152, '\P{Jg=malayalamra}', "");
    Expect(0, 2152, '\P{^Jg=malayalamra}', "");
    Expect(1, 2151, '\p{Jg=:\Amalayalamra\z:}', "");;
    Expect(0, 2152, '\p{Jg=:\Amalayalamra\z:}', "");;
    Expect(1, 2151, '\p{Jg=_ malayalam_Ra}', "");
    Expect(0, 2151, '\p{^Jg=_ malayalam_Ra}', "");
    Expect(0, 2151, '\P{Jg=_ malayalam_Ra}', "");
    Expect(1, 2151, '\P{^Jg=_ malayalam_Ra}', "");
    Expect(0, 2152, '\p{Jg=_ malayalam_Ra}', "");
    Expect(1, 2152, '\p{^Jg=_ malayalam_Ra}', "");
    Expect(1, 2152, '\P{Jg=_ malayalam_Ra}', "");
    Expect(0, 2152, '\P{^Jg=_ malayalam_Ra}', "");
    Error('\p{Is_Joining_Group=Malayalam_ra/a/}');
    Error('\P{Is_Joining_Group=Malayalam_ra/a/}');
    Expect(1, 2151, '\p{Is_Joining_Group=malayalamra}', "");
    Expect(0, 2151, '\p{^Is_Joining_Group=malayalamra}', "");
    Expect(0, 2151, '\P{Is_Joining_Group=malayalamra}', "");
    Expect(1, 2151, '\P{^Is_Joining_Group=malayalamra}', "");
    Expect(0, 2152, '\p{Is_Joining_Group=malayalamra}', "");
    Expect(1, 2152, '\p{^Is_Joining_Group=malayalamra}', "");
    Expect(1, 2152, '\P{Is_Joining_Group=malayalamra}', "");
    Expect(0, 2152, '\P{^Is_Joining_Group=malayalamra}', "");
    Expect(1, 2151, '\p{Is_Joining_Group=_	Malayalam_RA}', "");
    Expect(0, 2151, '\p{^Is_Joining_Group=_	Malayalam_RA}', "");
    Expect(0, 2151, '\P{Is_Joining_Group=_	Malayalam_RA}', "");
    Expect(1, 2151, '\P{^Is_Joining_Group=_	Malayalam_RA}', "");
    Expect(0, 2152, '\p{Is_Joining_Group=_	Malayalam_RA}', "");
    Expect(1, 2152, '\p{^Is_Joining_Group=_	Malayalam_RA}', "");
    Expect(1, 2152, '\P{Is_Joining_Group=_	Malayalam_RA}', "");
    Expect(0, 2152, '\P{^Is_Joining_Group=_	Malayalam_RA}', "");
    Error('\p{Is_Jg=MALAYALAM_RA/a/}');
    Error('\P{Is_Jg=MALAYALAM_RA/a/}');
    Expect(1, 2151, '\p{Is_Jg=malayalamra}', "");
    Expect(0, 2151, '\p{^Is_Jg=malayalamra}', "");
    Expect(0, 2151, '\P{Is_Jg=malayalamra}', "");
    Expect(1, 2151, '\P{^Is_Jg=malayalamra}', "");
    Expect(0, 2152, '\p{Is_Jg=malayalamra}', "");
    Expect(1, 2152, '\p{^Is_Jg=malayalamra}', "");
    Expect(1, 2152, '\P{Is_Jg=malayalamra}', "");
    Expect(0, 2152, '\P{^Is_Jg=malayalamra}', "");
    Expect(1, 2151, '\p{Is_Jg= 	Malayalam_Ra}', "");
    Expect(0, 2151, '\p{^Is_Jg= 	Malayalam_Ra}', "");
    Expect(0, 2151, '\P{Is_Jg= 	Malayalam_Ra}', "");
    Expect(1, 2151, '\P{^Is_Jg= 	Malayalam_Ra}', "");
    Expect(0, 2152, '\p{Is_Jg= 	Malayalam_Ra}', "");
    Expect(1, 2152, '\p{^Is_Jg= 	Malayalam_Ra}', "");
    Expect(1, 2152, '\P{Is_Jg= 	Malayalam_Ra}', "");
    Expect(0, 2152, '\P{^Is_Jg= 	Malayalam_Ra}', "");
    Error('\p{Joining_Group=:=MALAYALAM_Ssa}');
    Error('\P{Joining_Group=:=MALAYALAM_Ssa}');
    Expect(1, 2154, '\p{Joining_Group=:\AMalayalam_Ssa\z:}', "");;
    Expect(0, 2155, '\p{Joining_Group=:\AMalayalam_Ssa\z:}', "");;
    Expect(1, 2154, '\p{Joining_Group:	malayalamssa}', "");
    Expect(0, 2154, '\p{^Joining_Group:	malayalamssa}', "");
    Expect(0, 2154, '\P{Joining_Group:	malayalamssa}', "");
    Expect(1, 2154, '\P{^Joining_Group:	malayalamssa}', "");
    Expect(0, 2155, '\p{Joining_Group:	malayalamssa}', "");
    Expect(1, 2155, '\p{^Joining_Group:	malayalamssa}', "");
    Expect(1, 2155, '\P{Joining_Group:	malayalamssa}', "");
    Expect(0, 2155, '\P{^Joining_Group:	malayalamssa}', "");
    Expect(1, 2154, '\p{Joining_Group=:\Amalayalamssa\z:}', "");;
    Expect(0, 2155, '\p{Joining_Group=:\Amalayalamssa\z:}', "");;
    Expect(1, 2154, '\p{Joining_Group=	_Malayalam_Ssa}', "");
    Expect(0, 2154, '\p{^Joining_Group=	_Malayalam_Ssa}', "");
    Expect(0, 2154, '\P{Joining_Group=	_Malayalam_Ssa}', "");
    Expect(1, 2154, '\P{^Joining_Group=	_Malayalam_Ssa}', "");
    Expect(0, 2155, '\p{Joining_Group=	_Malayalam_Ssa}', "");
    Expect(1, 2155, '\p{^Joining_Group=	_Malayalam_Ssa}', "");
    Expect(1, 2155, '\P{Joining_Group=	_Malayalam_Ssa}', "");
    Expect(0, 2155, '\P{^Joining_Group=	_Malayalam_Ssa}', "");
    Error('\p{Jg=__Malayalam_SSA:=}');
    Error('\P{Jg=__Malayalam_SSA:=}');
    Expect(1, 2154, '\p{Jg=:\AMalayalam_Ssa\z:}', "");;
    Expect(0, 2155, '\p{Jg=:\AMalayalam_Ssa\z:}', "");;
    Expect(1, 2154, '\p{Jg=malayalamssa}', "");
    Expect(0, 2154, '\p{^Jg=malayalamssa}', "");
    Expect(0, 2154, '\P{Jg=malayalamssa}', "");
    Expect(1, 2154, '\P{^Jg=malayalamssa}', "");
    Expect(0, 2155, '\p{Jg=malayalamssa}', "");
    Expect(1, 2155, '\p{^Jg=malayalamssa}', "");
    Expect(1, 2155, '\P{Jg=malayalamssa}', "");
    Expect(0, 2155, '\P{^Jg=malayalamssa}', "");
    Expect(1, 2154, '\p{Jg=:\Amalayalamssa\z:}', "");;
    Expect(0, 2155, '\p{Jg=:\Amalayalamssa\z:}', "");;
    Expect(1, 2154, '\p{Jg:	_ MALAYALAM_Ssa}', "");
    Expect(0, 2154, '\p{^Jg:	_ MALAYALAM_Ssa}', "");
    Expect(0, 2154, '\P{Jg:	_ MALAYALAM_Ssa}', "");
    Expect(1, 2154, '\P{^Jg:	_ MALAYALAM_Ssa}', "");
    Expect(0, 2155, '\p{Jg:	_ MALAYALAM_Ssa}', "");
    Expect(1, 2155, '\p{^Jg:	_ MALAYALAM_Ssa}', "");
    Expect(1, 2155, '\P{Jg:	_ MALAYALAM_Ssa}', "");
    Expect(0, 2155, '\P{^Jg:	_ MALAYALAM_Ssa}', "");
    Error('\p{Is_Joining_Group=-:=Malayalam_ssa}');
    Error('\P{Is_Joining_Group=-:=Malayalam_ssa}');
    Expect(1, 2154, '\p{Is_Joining_Group=malayalamssa}', "");
    Expect(0, 2154, '\p{^Is_Joining_Group=malayalamssa}', "");
    Expect(0, 2154, '\P{Is_Joining_Group=malayalamssa}', "");
    Expect(1, 2154, '\P{^Is_Joining_Group=malayalamssa}', "");
    Expect(0, 2155, '\p{Is_Joining_Group=malayalamssa}', "");
    Expect(1, 2155, '\p{^Is_Joining_Group=malayalamssa}', "");
    Expect(1, 2155, '\P{Is_Joining_Group=malayalamssa}', "");
    Expect(0, 2155, '\P{^Is_Joining_Group=malayalamssa}', "");
    Expect(1, 2154, '\p{Is_Joining_Group: _Malayalam_SSA}', "");
    Expect(0, 2154, '\p{^Is_Joining_Group: _Malayalam_SSA}', "");
    Expect(0, 2154, '\P{Is_Joining_Group: _Malayalam_SSA}', "");
    Expect(1, 2154, '\P{^Is_Joining_Group: _Malayalam_SSA}', "");
    Expect(0, 2155, '\p{Is_Joining_Group: _Malayalam_SSA}', "");
    Expect(1, 2155, '\p{^Is_Joining_Group: _Malayalam_SSA}', "");
    Expect(1, 2155, '\P{Is_Joining_Group: _Malayalam_SSA}', "");
    Expect(0, 2155, '\P{^Is_Joining_Group: _Malayalam_SSA}', "");
    Error('\p{Is_Jg=	Malayalam_Ssa:=}');
    Error('\P{Is_Jg=	Malayalam_Ssa:=}');
    Expect(1, 2154, '\p{Is_Jg=malayalamssa}', "");
    Expect(0, 2154, '\p{^Is_Jg=malayalamssa}', "");
    Expect(0, 2154, '\P{Is_Jg=malayalamssa}', "");
    Expect(1, 2154, '\P{^Is_Jg=malayalamssa}', "");
    Expect(0, 2155, '\p{Is_Jg=malayalamssa}', "");
    Expect(1, 2155, '\p{^Is_Jg=malayalamssa}', "");
    Expect(1, 2155, '\P{Is_Jg=malayalamssa}', "");
    Expect(0, 2155, '\P{^Is_Jg=malayalamssa}', "");
    Expect(1, 2154, '\p{Is_Jg=	-MALAYALAM_SSA}', "");
    Expect(0, 2154, '\p{^Is_Jg=	-MALAYALAM_SSA}', "");
    Expect(0, 2154, '\P{Is_Jg=	-MALAYALAM_SSA}', "");
    Expect(1, 2154, '\P{^Is_Jg=	-MALAYALAM_SSA}', "");
    Expect(0, 2155, '\p{Is_Jg=	-MALAYALAM_SSA}', "");
    Expect(1, 2155, '\p{^Is_Jg=	-MALAYALAM_SSA}', "");
    Expect(1, 2155, '\P{Is_Jg=	-MALAYALAM_SSA}', "");
    Expect(0, 2155, '\P{^Is_Jg=	-MALAYALAM_SSA}', "");
    Error('\p{Joining_Group= :=Malayalam_tta}');
    Error('\P{Joining_Group= :=Malayalam_tta}');
    Expect(1, 2147, '\p{Joining_Group=:\AMalayalam_Tta\z:}', "");;
    Expect(0, 2148, '\p{Joining_Group=:\AMalayalam_Tta\z:}', "");;
    Expect(1, 2147, '\p{Joining_Group=malayalamtta}', "");
    Expect(0, 2147, '\p{^Joining_Group=malayalamtta}', "");
    Expect(0, 2147, '\P{Joining_Group=malayalamtta}', "");
    Expect(1, 2147, '\P{^Joining_Group=malayalamtta}', "");
    Expect(0, 2148, '\p{Joining_Group=malayalamtta}', "");
    Expect(1, 2148, '\p{^Joining_Group=malayalamtta}', "");
    Expect(1, 2148, '\P{Joining_Group=malayalamtta}', "");
    Expect(0, 2148, '\P{^Joining_Group=malayalamtta}', "");
    Expect(1, 2147, '\p{Joining_Group=:\Amalayalamtta\z:}', "");;
    Expect(0, 2148, '\p{Joining_Group=:\Amalayalamtta\z:}', "");;
    Expect(1, 2147, '\p{Joining_Group=	MALAYALAM_Tta}', "");
    Expect(0, 2147, '\p{^Joining_Group=	MALAYALAM_Tta}', "");
    Expect(0, 2147, '\P{Joining_Group=	MALAYALAM_Tta}', "");
    Expect(1, 2147, '\P{^Joining_Group=	MALAYALAM_Tta}', "");
    Expect(0, 2148, '\p{Joining_Group=	MALAYALAM_Tta}', "");
    Expect(1, 2148, '\p{^Joining_Group=	MALAYALAM_Tta}', "");
    Expect(1, 2148, '\P{Joining_Group=	MALAYALAM_Tta}', "");
    Expect(0, 2148, '\P{^Joining_Group=	MALAYALAM_Tta}', "");
    Error('\p{Jg= :=malayalam_tta}');
    Error('\P{Jg= :=malayalam_tta}');
    Expect(1, 2147, '\p{Jg=:\AMalayalam_Tta\z:}', "");;
    Expect(0, 2148, '\p{Jg=:\AMalayalam_Tta\z:}', "");;
    Expect(1, 2147, '\p{Jg=malayalamtta}', "");
    Expect(0, 2147, '\p{^Jg=malayalamtta}', "");
    Expect(0, 2147, '\P{Jg=malayalamtta}', "");
    Expect(1, 2147, '\P{^Jg=malayalamtta}', "");
    Expect(0, 2148, '\p{Jg=malayalamtta}', "");
    Expect(1, 2148, '\p{^Jg=malayalamtta}', "");
    Expect(1, 2148, '\P{Jg=malayalamtta}', "");
    Expect(0, 2148, '\P{^Jg=malayalamtta}', "");
    Expect(1, 2147, '\p{Jg=:\Amalayalamtta\z:}', "");;
    Expect(0, 2148, '\p{Jg=:\Amalayalamtta\z:}', "");;
    Expect(1, 2147, '\p{Jg=	_malayalam_Tta}', "");
    Expect(0, 2147, '\p{^Jg=	_malayalam_Tta}', "");
    Expect(0, 2147, '\P{Jg=	_malayalam_Tta}', "");
    Expect(1, 2147, '\P{^Jg=	_malayalam_Tta}', "");
    Expect(0, 2148, '\p{Jg=	_malayalam_Tta}', "");
    Expect(1, 2148, '\p{^Jg=	_malayalam_Tta}', "");
    Expect(1, 2148, '\P{Jg=	_malayalam_Tta}', "");
    Expect(0, 2148, '\P{^Jg=	_malayalam_Tta}', "");
    Error('\p{Is_Joining_Group= MALAYALAM_Tta/a/}');
    Error('\P{Is_Joining_Group= MALAYALAM_Tta/a/}');
    Expect(1, 2147, '\p{Is_Joining_Group:malayalamtta}', "");
    Expect(0, 2147, '\p{^Is_Joining_Group:malayalamtta}', "");
    Expect(0, 2147, '\P{Is_Joining_Group:malayalamtta}', "");
    Expect(1, 2147, '\P{^Is_Joining_Group:malayalamtta}', "");
    Expect(0, 2148, '\p{Is_Joining_Group:malayalamtta}', "");
    Expect(1, 2148, '\p{^Is_Joining_Group:malayalamtta}', "");
    Expect(1, 2148, '\P{Is_Joining_Group:malayalamtta}', "");
    Expect(0, 2148, '\P{^Is_Joining_Group:malayalamtta}', "");
    Expect(1, 2147, '\p{Is_Joining_Group= Malayalam_Tta}', "");
    Expect(0, 2147, '\p{^Is_Joining_Group= Malayalam_Tta}', "");
    Expect(0, 2147, '\P{Is_Joining_Group= Malayalam_Tta}', "");
    Expect(1, 2147, '\P{^Is_Joining_Group= Malayalam_Tta}', "");
    Expect(0, 2148, '\p{Is_Joining_Group= Malayalam_Tta}', "");
    Expect(1, 2148, '\p{^Is_Joining_Group= Malayalam_Tta}', "");
    Expect(1, 2148, '\P{Is_Joining_Group= Malayalam_Tta}', "");
    Expect(0, 2148, '\P{^Is_Joining_Group= Malayalam_Tta}', "");
    Error('\p{Is_Jg= malayalam_tta/a/}');
    Error('\P{Is_Jg= malayalam_tta/a/}');
    Expect(1, 2147, '\p{Is_Jg: malayalamtta}', "");
    Expect(0, 2147, '\p{^Is_Jg: malayalamtta}', "");
    Expect(0, 2147, '\P{Is_Jg: malayalamtta}', "");
    Expect(1, 2147, '\P{^Is_Jg: malayalamtta}', "");
    Expect(0, 2148, '\p{Is_Jg: malayalamtta}', "");
    Expect(1, 2148, '\p{^Is_Jg: malayalamtta}', "");
    Expect(1, 2148, '\P{Is_Jg: malayalamtta}', "");
    Expect(0, 2148, '\P{^Is_Jg: malayalamtta}', "");
    Expect(1, 2147, '\p{Is_Jg= malayalam_Tta}', "");
    Expect(0, 2147, '\p{^Is_Jg= malayalam_Tta}', "");
    Expect(0, 2147, '\P{Is_Jg= malayalam_Tta}', "");
    Expect(1, 2147, '\P{^Is_Jg= malayalam_Tta}', "");
    Expect(0, 2148, '\p{Is_Jg= malayalam_Tta}', "");
    Expect(1, 2148, '\p{^Is_Jg= malayalam_Tta}', "");
    Expect(1, 2148, '\P{Is_Jg= malayalam_Tta}', "");
    Expect(0, 2148, '\P{^Is_Jg= malayalam_Tta}', "");
    Error('\p{Joining_Group=/a/  manichaean_Aleph}');
    Error('\P{Joining_Group=/a/  manichaean_Aleph}');
    Expect(1, 68288, '\p{Joining_Group=:\AManichaean_Aleph\z:}', "");;
    Expect(0, 68289, '\p{Joining_Group=:\AManichaean_Aleph\z:}', "");;
    Expect(1, 68288, '\p{Joining_Group=manichaeanaleph}', "");
    Expect(0, 68288, '\p{^Joining_Group=manichaeanaleph}', "");
    Expect(0, 68288, '\P{Joining_Group=manichaeanaleph}', "");
    Expect(1, 68288, '\P{^Joining_Group=manichaeanaleph}', "");
    Expect(0, 68289, '\p{Joining_Group=manichaeanaleph}', "");
    Expect(1, 68289, '\p{^Joining_Group=manichaeanaleph}', "");
    Expect(1, 68289, '\P{Joining_Group=manichaeanaleph}', "");
    Expect(0, 68289, '\P{^Joining_Group=manichaeanaleph}', "");
    Expect(1, 68288, '\p{Joining_Group=:\Amanichaeanaleph\z:}', "");;
    Expect(0, 68289, '\p{Joining_Group=:\Amanichaeanaleph\z:}', "");;
    Expect(1, 68288, '\p{Joining_Group=- manichaean_aleph}', "");
    Expect(0, 68288, '\p{^Joining_Group=- manichaean_aleph}', "");
    Expect(0, 68288, '\P{Joining_Group=- manichaean_aleph}', "");
    Expect(1, 68288, '\P{^Joining_Group=- manichaean_aleph}', "");
    Expect(0, 68289, '\p{Joining_Group=- manichaean_aleph}', "");
    Expect(1, 68289, '\p{^Joining_Group=- manichaean_aleph}', "");
    Expect(1, 68289, '\P{Joining_Group=- manichaean_aleph}', "");
    Expect(0, 68289, '\P{^Joining_Group=- manichaean_aleph}', "");
    Error('\p{Jg=:=- Manichaean_aleph}');
    Error('\P{Jg=:=- Manichaean_aleph}');
    Expect(1, 68288, '\p{Jg=:\AManichaean_Aleph\z:}', "");;
    Expect(0, 68289, '\p{Jg=:\AManichaean_Aleph\z:}', "");;
    Expect(1, 68288, '\p{Jg:	manichaeanaleph}', "");
    Expect(0, 68288, '\p{^Jg:	manichaeanaleph}', "");
    Expect(0, 68288, '\P{Jg:	manichaeanaleph}', "");
    Expect(1, 68288, '\P{^Jg:	manichaeanaleph}', "");
    Expect(0, 68289, '\p{Jg:	manichaeanaleph}', "");
    Expect(1, 68289, '\p{^Jg:	manichaeanaleph}', "");
    Expect(1, 68289, '\P{Jg:	manichaeanaleph}', "");
    Expect(0, 68289, '\P{^Jg:	manichaeanaleph}', "");
    Expect(1, 68288, '\p{Jg=:\Amanichaeanaleph\z:}', "");;
    Expect(0, 68289, '\p{Jg=:\Amanichaeanaleph\z:}', "");;
    Expect(1, 68288, '\p{Jg=-Manichaean_ALEPH}', "");
    Expect(0, 68288, '\p{^Jg=-Manichaean_ALEPH}', "");
    Expect(0, 68288, '\P{Jg=-Manichaean_ALEPH}', "");
    Expect(1, 68288, '\P{^Jg=-Manichaean_ALEPH}', "");
    Expect(0, 68289, '\p{Jg=-Manichaean_ALEPH}', "");
    Expect(1, 68289, '\p{^Jg=-Manichaean_ALEPH}', "");
    Expect(1, 68289, '\P{Jg=-Manichaean_ALEPH}', "");
    Expect(0, 68289, '\P{^Jg=-Manichaean_ALEPH}', "");
    Error('\p{Is_Joining_Group=  Manichaean_Aleph:=}');
    Error('\P{Is_Joining_Group=  Manichaean_Aleph:=}');
    Expect(1, 68288, '\p{Is_Joining_Group:   manichaeanaleph}', "");
    Expect(0, 68288, '\p{^Is_Joining_Group:   manichaeanaleph}', "");
    Expect(0, 68288, '\P{Is_Joining_Group:   manichaeanaleph}', "");
    Expect(1, 68288, '\P{^Is_Joining_Group:   manichaeanaleph}', "");
    Expect(0, 68289, '\p{Is_Joining_Group:   manichaeanaleph}', "");
    Expect(1, 68289, '\p{^Is_Joining_Group:   manichaeanaleph}', "");
    Expect(1, 68289, '\P{Is_Joining_Group:   manichaeanaleph}', "");
    Expect(0, 68289, '\P{^Is_Joining_Group:   manichaeanaleph}', "");
    Expect(1, 68288, '\p{Is_Joining_Group=_	manichaean_Aleph}', "");
    Expect(0, 68288, '\p{^Is_Joining_Group=_	manichaean_Aleph}', "");
    Expect(0, 68288, '\P{Is_Joining_Group=_	manichaean_Aleph}', "");
    Expect(1, 68288, '\P{^Is_Joining_Group=_	manichaean_Aleph}', "");
    Expect(0, 68289, '\p{Is_Joining_Group=_	manichaean_Aleph}', "");
    Expect(1, 68289, '\p{^Is_Joining_Group=_	manichaean_Aleph}', "");
    Expect(1, 68289, '\P{Is_Joining_Group=_	manichaean_Aleph}', "");
    Expect(0, 68289, '\P{^Is_Joining_Group=_	manichaean_Aleph}', "");
    Error('\p{Is_Jg=		MANICHAEAN_ALEPH/a/}');
    Error('\P{Is_Jg=		MANICHAEAN_ALEPH/a/}');
    Expect(1, 68288, '\p{Is_Jg=manichaeanaleph}', "");
    Expect(0, 68288, '\p{^Is_Jg=manichaeanaleph}', "");
    Expect(0, 68288, '\P{Is_Jg=manichaeanaleph}', "");
    Expect(1, 68288, '\P{^Is_Jg=manichaeanaleph}', "");
    Expect(0, 68289, '\p{Is_Jg=manichaeanaleph}', "");
    Expect(1, 68289, '\p{^Is_Jg=manichaeanaleph}', "");
    Expect(1, 68289, '\P{Is_Jg=manichaeanaleph}', "");
    Expect(0, 68289, '\P{^Is_Jg=manichaeanaleph}', "");
    Expect(1, 68288, '\p{Is_Jg=__Manichaean_aleph}', "");
    Expect(0, 68288, '\p{^Is_Jg=__Manichaean_aleph}', "");
    Expect(0, 68288, '\P{Is_Jg=__Manichaean_aleph}', "");
    Expect(1, 68288, '\P{^Is_Jg=__Manichaean_aleph}', "");
    Expect(0, 68289, '\p{Is_Jg=__Manichaean_aleph}', "");
    Expect(1, 68289, '\p{^Is_Jg=__Manichaean_aleph}', "");
    Expect(1, 68289, '\P{Is_Jg=__Manichaean_aleph}', "");
    Expect(0, 68289, '\P{^Is_Jg=__Manichaean_aleph}', "");
    Error('\p{Joining_Group=-Manichaean_Ayin/a/}');
    Error('\P{Joining_Group=-Manichaean_Ayin/a/}');
    Expect(1, 68314, '\p{Joining_Group=:\AManichaean_Ayin\z:}', "");;
    Expect(0, 68315, '\p{Joining_Group=:\AManichaean_Ayin\z:}', "");;
    Expect(1, 68314, '\p{Joining_Group=manichaeanayin}', "");
    Expect(0, 68314, '\p{^Joining_Group=manichaeanayin}', "");
    Expect(0, 68314, '\P{Joining_Group=manichaeanayin}', "");
    Expect(1, 68314, '\P{^Joining_Group=manichaeanayin}', "");
    Expect(0, 68315, '\p{Joining_Group=manichaeanayin}', "");
    Expect(1, 68315, '\p{^Joining_Group=manichaeanayin}', "");
    Expect(1, 68315, '\P{Joining_Group=manichaeanayin}', "");
    Expect(0, 68315, '\P{^Joining_Group=manichaeanayin}', "");
    Expect(1, 68314, '\p{Joining_Group=:\Amanichaeanayin\z:}', "");;
    Expect(0, 68315, '\p{Joining_Group=:\Amanichaeanayin\z:}', "");;
    Expect(1, 68314, '\p{Joining_Group= Manichaean_Ayin}', "");
    Expect(0, 68314, '\p{^Joining_Group= Manichaean_Ayin}', "");
    Expect(0, 68314, '\P{Joining_Group= Manichaean_Ayin}', "");
    Expect(1, 68314, '\P{^Joining_Group= Manichaean_Ayin}', "");
    Expect(0, 68315, '\p{Joining_Group= Manichaean_Ayin}', "");
    Expect(1, 68315, '\p{^Joining_Group= Manichaean_Ayin}', "");
    Expect(1, 68315, '\P{Joining_Group= Manichaean_Ayin}', "");
    Expect(0, 68315, '\P{^Joining_Group= Manichaean_Ayin}', "");
    Error('\p{Jg= _Manichaean_Ayin:=}');
    Error('\P{Jg= _Manichaean_Ayin:=}');
    Expect(1, 68314, '\p{Jg=:\AManichaean_Ayin\z:}', "");;
    Expect(0, 68315, '\p{Jg=:\AManichaean_Ayin\z:}', "");;
    Expect(1, 68314, '\p{Jg=manichaeanayin}', "");
    Expect(0, 68314, '\p{^Jg=manichaeanayin}', "");
    Expect(0, 68314, '\P{Jg=manichaeanayin}', "");
    Expect(1, 68314, '\P{^Jg=manichaeanayin}', "");
    Expect(0, 68315, '\p{Jg=manichaeanayin}', "");
    Expect(1, 68315, '\p{^Jg=manichaeanayin}', "");
    Expect(1, 68315, '\P{Jg=manichaeanayin}', "");
    Expect(0, 68315, '\P{^Jg=manichaeanayin}', "");
    Expect(1, 68314, '\p{Jg=:\Amanichaeanayin\z:}', "");;
    Expect(0, 68315, '\p{Jg=:\Amanichaeanayin\z:}', "");;
    Expect(1, 68314, '\p{Jg=_MANICHAEAN_Ayin}', "");
    Expect(0, 68314, '\p{^Jg=_MANICHAEAN_Ayin}', "");
    Expect(0, 68314, '\P{Jg=_MANICHAEAN_Ayin}', "");
    Expect(1, 68314, '\P{^Jg=_MANICHAEAN_Ayin}', "");
    Expect(0, 68315, '\p{Jg=_MANICHAEAN_Ayin}', "");
    Expect(1, 68315, '\p{^Jg=_MANICHAEAN_Ayin}', "");
    Expect(1, 68315, '\P{Jg=_MANICHAEAN_Ayin}', "");
    Expect(0, 68315, '\P{^Jg=_MANICHAEAN_Ayin}', "");
    Error('\p{Is_Joining_Group=  manichaean_ayin:=}');
    Error('\P{Is_Joining_Group=  manichaean_ayin:=}');
    Expect(1, 68314, '\p{Is_Joining_Group=manichaeanayin}', "");
    Expect(0, 68314, '\p{^Is_Joining_Group=manichaeanayin}', "");
    Expect(0, 68314, '\P{Is_Joining_Group=manichaeanayin}', "");
    Expect(1, 68314, '\P{^Is_Joining_Group=manichaeanayin}', "");
    Expect(0, 68315, '\p{Is_Joining_Group=manichaeanayin}', "");
    Expect(1, 68315, '\p{^Is_Joining_Group=manichaeanayin}', "");
    Expect(1, 68315, '\P{Is_Joining_Group=manichaeanayin}', "");
    Expect(0, 68315, '\P{^Is_Joining_Group=manichaeanayin}', "");
    Expect(1, 68314, '\p{Is_Joining_Group=	 MANICHAEAN_ayin}', "");
    Expect(0, 68314, '\p{^Is_Joining_Group=	 MANICHAEAN_ayin}', "");
    Expect(0, 68314, '\P{Is_Joining_Group=	 MANICHAEAN_ayin}', "");
    Expect(1, 68314, '\P{^Is_Joining_Group=	 MANICHAEAN_ayin}', "");
    Expect(0, 68315, '\p{Is_Joining_Group=	 MANICHAEAN_ayin}', "");
    Expect(1, 68315, '\p{^Is_Joining_Group=	 MANICHAEAN_ayin}', "");
    Expect(1, 68315, '\P{Is_Joining_Group=	 MANICHAEAN_ayin}', "");
    Expect(0, 68315, '\P{^Is_Joining_Group=	 MANICHAEAN_ayin}', "");
    Error('\p{Is_Jg=	/a/MANICHAEAN_Ayin}');
    Error('\P{Is_Jg=	/a/MANICHAEAN_Ayin}');
    Expect(1, 68314, '\p{Is_Jg=manichaeanayin}', "");
    Expect(0, 68314, '\p{^Is_Jg=manichaeanayin}', "");
    Expect(0, 68314, '\P{Is_Jg=manichaeanayin}', "");
    Expect(1, 68314, '\P{^Is_Jg=manichaeanayin}', "");
    Expect(0, 68315, '\p{Is_Jg=manichaeanayin}', "");
    Expect(1, 68315, '\p{^Is_Jg=manichaeanayin}', "");
    Expect(1, 68315, '\P{Is_Jg=manichaeanayin}', "");
    Expect(0, 68315, '\P{^Is_Jg=manichaeanayin}', "");
    Expect(1, 68314, '\p{Is_Jg=__manichaean_AYIN}', "");
    Expect(0, 68314, '\p{^Is_Jg=__manichaean_AYIN}', "");
    Expect(0, 68314, '\P{Is_Jg=__manichaean_AYIN}', "");
    Expect(1, 68314, '\P{^Is_Jg=__manichaean_AYIN}', "");
    Expect(0, 68315, '\p{Is_Jg=__manichaean_AYIN}', "");
    Expect(1, 68315, '\p{^Is_Jg=__manichaean_AYIN}', "");
    Expect(1, 68315, '\P{Is_Jg=__manichaean_AYIN}', "");
    Expect(0, 68315, '\P{^Is_Jg=__manichaean_AYIN}', "");
    Error('\p{Joining_Group= 	Manichaean_BETH:=}');
    Error('\P{Joining_Group= 	Manichaean_BETH:=}');
    Expect(1, 68290, '\p{Joining_Group=:\AManichaean_Beth\z:}', "");;
    Expect(0, 68291, '\p{Joining_Group=:\AManichaean_Beth\z:}', "");;
    Expect(1, 68290, '\p{Joining_Group:   manichaeanbeth}', "");
    Expect(0, 68290, '\p{^Joining_Group:   manichaeanbeth}', "");
    Expect(0, 68290, '\P{Joining_Group:   manichaeanbeth}', "");
    Expect(1, 68290, '\P{^Joining_Group:   manichaeanbeth}', "");
    Expect(0, 68291, '\p{Joining_Group:   manichaeanbeth}', "");
    Expect(1, 68291, '\p{^Joining_Group:   manichaeanbeth}', "");
    Expect(1, 68291, '\P{Joining_Group:   manichaeanbeth}', "");
    Expect(0, 68291, '\P{^Joining_Group:   manichaeanbeth}', "");
    Expect(1, 68290, '\p{Joining_Group=:\Amanichaeanbeth\z:}', "");;
    Expect(0, 68291, '\p{Joining_Group=:\Amanichaeanbeth\z:}', "");;
    Expect(1, 68290, '\p{Joining_Group= _manichaean_Beth}', "");
    Expect(0, 68290, '\p{^Joining_Group= _manichaean_Beth}', "");
    Expect(0, 68290, '\P{Joining_Group= _manichaean_Beth}', "");
    Expect(1, 68290, '\P{^Joining_Group= _manichaean_Beth}', "");
    Expect(0, 68291, '\p{Joining_Group= _manichaean_Beth}', "");
    Expect(1, 68291, '\p{^Joining_Group= _manichaean_Beth}', "");
    Expect(1, 68291, '\P{Joining_Group= _manichaean_Beth}', "");
    Expect(0, 68291, '\P{^Joining_Group= _manichaean_Beth}', "");
    Error('\p{Jg=  Manichaean_BETH:=}');
    Error('\P{Jg=  Manichaean_BETH:=}');
    Expect(1, 68290, '\p{Jg=:\AManichaean_Beth\z:}', "");;
    Expect(0, 68291, '\p{Jg=:\AManichaean_Beth\z:}', "");;
    Expect(1, 68290, '\p{Jg=manichaeanbeth}', "");
    Expect(0, 68290, '\p{^Jg=manichaeanbeth}', "");
    Expect(0, 68290, '\P{Jg=manichaeanbeth}', "");
    Expect(1, 68290, '\P{^Jg=manichaeanbeth}', "");
    Expect(0, 68291, '\p{Jg=manichaeanbeth}', "");
    Expect(1, 68291, '\p{^Jg=manichaeanbeth}', "");
    Expect(1, 68291, '\P{Jg=manichaeanbeth}', "");
    Expect(0, 68291, '\P{^Jg=manichaeanbeth}', "");
    Expect(1, 68290, '\p{Jg=:\Amanichaeanbeth\z:}', "");;
    Expect(0, 68291, '\p{Jg=:\Amanichaeanbeth\z:}', "");;
    Expect(1, 68290, '\p{Jg= manichaean_Beth}', "");
    Expect(0, 68290, '\p{^Jg= manichaean_Beth}', "");
    Expect(0, 68290, '\P{Jg= manichaean_Beth}', "");
    Expect(1, 68290, '\P{^Jg= manichaean_Beth}', "");
    Expect(0, 68291, '\p{Jg= manichaean_Beth}', "");
    Expect(1, 68291, '\p{^Jg= manichaean_Beth}', "");
    Expect(1, 68291, '\P{Jg= manichaean_Beth}', "");
    Expect(0, 68291, '\P{^Jg= manichaean_Beth}', "");
    Error('\p{Is_Joining_Group=--manichaean_Beth/a/}');
    Error('\P{Is_Joining_Group=--manichaean_Beth/a/}');
    Expect(1, 68290, '\p{Is_Joining_Group=manichaeanbeth}', "");
    Expect(0, 68290, '\p{^Is_Joining_Group=manichaeanbeth}', "");
    Expect(0, 68290, '\P{Is_Joining_Group=manichaeanbeth}', "");
    Expect(1, 68290, '\P{^Is_Joining_Group=manichaeanbeth}', "");
    Expect(0, 68291, '\p{Is_Joining_Group=manichaeanbeth}', "");
    Expect(1, 68291, '\p{^Is_Joining_Group=manichaeanbeth}', "");
    Expect(1, 68291, '\P{Is_Joining_Group=manichaeanbeth}', "");
    Expect(0, 68291, '\P{^Is_Joining_Group=manichaeanbeth}', "");
    Expect(1, 68290, '\p{Is_Joining_Group:  MANICHAEAN_Beth}', "");
    Expect(0, 68290, '\p{^Is_Joining_Group:  MANICHAEAN_Beth}', "");
    Expect(0, 68290, '\P{Is_Joining_Group:  MANICHAEAN_Beth}', "");
    Expect(1, 68290, '\P{^Is_Joining_Group:  MANICHAEAN_Beth}', "");
    Expect(0, 68291, '\p{Is_Joining_Group:  MANICHAEAN_Beth}', "");
    Expect(1, 68291, '\p{^Is_Joining_Group:  MANICHAEAN_Beth}', "");
    Expect(1, 68291, '\P{Is_Joining_Group:  MANICHAEAN_Beth}', "");
    Expect(0, 68291, '\P{^Is_Joining_Group:  MANICHAEAN_Beth}', "");
    Error('\p{Is_Jg:		Manichaean_BETH/a/}');
    Error('\P{Is_Jg:		Manichaean_BETH/a/}');
    Expect(1, 68290, '\p{Is_Jg=manichaeanbeth}', "");
    Expect(0, 68290, '\p{^Is_Jg=manichaeanbeth}', "");
    Expect(0, 68290, '\P{Is_Jg=manichaeanbeth}', "");
    Expect(1, 68290, '\P{^Is_Jg=manichaeanbeth}', "");
    Expect(0, 68291, '\p{Is_Jg=manichaeanbeth}', "");
    Expect(1, 68291, '\p{^Is_Jg=manichaeanbeth}', "");
    Expect(1, 68291, '\P{Is_Jg=manichaeanbeth}', "");
    Expect(0, 68291, '\P{^Is_Jg=manichaeanbeth}', "");
    Expect(1, 68290, '\p{Is_Jg:  MANICHAEAN_BETH}', "");
    Expect(0, 68290, '\p{^Is_Jg:  MANICHAEAN_BETH}', "");
    Expect(0, 68290, '\P{Is_Jg:  MANICHAEAN_BETH}', "");
    Expect(1, 68290, '\P{^Is_Jg:  MANICHAEAN_BETH}', "");
    Expect(0, 68291, '\p{Is_Jg:  MANICHAEAN_BETH}', "");
    Expect(1, 68291, '\p{^Is_Jg:  MANICHAEAN_BETH}', "");
    Expect(1, 68291, '\P{Is_Jg:  MANICHAEAN_BETH}', "");
    Expect(0, 68291, '\P{^Is_Jg:  MANICHAEAN_BETH}', "");
    Error('\p{Joining_Group=:=	 MANICHAEAN_Daleth}');
    Error('\P{Joining_Group=:=	 MANICHAEAN_Daleth}');
    Expect(1, 68293, '\p{Joining_Group=:\AManichaean_Daleth\z:}', "");;
    Expect(0, 68294, '\p{Joining_Group=:\AManichaean_Daleth\z:}', "");;
    Expect(1, 68293, '\p{Joining_Group=manichaeandaleth}', "");
    Expect(0, 68293, '\p{^Joining_Group=manichaeandaleth}', "");
    Expect(0, 68293, '\P{Joining_Group=manichaeandaleth}', "");
    Expect(1, 68293, '\P{^Joining_Group=manichaeandaleth}', "");
    Expect(0, 68294, '\p{Joining_Group=manichaeandaleth}', "");
    Expect(1, 68294, '\p{^Joining_Group=manichaeandaleth}', "");
    Expect(1, 68294, '\P{Joining_Group=manichaeandaleth}', "");
    Expect(0, 68294, '\P{^Joining_Group=manichaeandaleth}', "");
    Expect(1, 68293, '\p{Joining_Group=:\Amanichaeandaleth\z:}', "");;
    Expect(0, 68294, '\p{Joining_Group=:\Amanichaeandaleth\z:}', "");;
    Expect(1, 68293, '\p{Joining_Group=	-Manichaean_daleth}', "");
    Expect(0, 68293, '\p{^Joining_Group=	-Manichaean_daleth}', "");
    Expect(0, 68293, '\P{Joining_Group=	-Manichaean_daleth}', "");
    Expect(1, 68293, '\P{^Joining_Group=	-Manichaean_daleth}', "");
    Expect(0, 68294, '\p{Joining_Group=	-Manichaean_daleth}', "");
    Expect(1, 68294, '\p{^Joining_Group=	-Manichaean_daleth}', "");
    Expect(1, 68294, '\P{Joining_Group=	-Manichaean_daleth}', "");
    Expect(0, 68294, '\P{^Joining_Group=	-Manichaean_daleth}', "");
    Error('\p{Jg=-:=manichaean_DALETH}');
    Error('\P{Jg=-:=manichaean_DALETH}');
    Expect(1, 68293, '\p{Jg=:\AManichaean_Daleth\z:}', "");;
    Expect(0, 68294, '\p{Jg=:\AManichaean_Daleth\z:}', "");;
    Expect(1, 68293, '\p{Jg=manichaeandaleth}', "");
    Expect(0, 68293, '\p{^Jg=manichaeandaleth}', "");
    Expect(0, 68293, '\P{Jg=manichaeandaleth}', "");
    Expect(1, 68293, '\P{^Jg=manichaeandaleth}', "");
    Expect(0, 68294, '\p{Jg=manichaeandaleth}', "");
    Expect(1, 68294, '\p{^Jg=manichaeandaleth}', "");
    Expect(1, 68294, '\P{Jg=manichaeandaleth}', "");
    Expect(0, 68294, '\P{^Jg=manichaeandaleth}', "");
    Expect(1, 68293, '\p{Jg=:\Amanichaeandaleth\z:}', "");;
    Expect(0, 68294, '\p{Jg=:\Amanichaeandaleth\z:}', "");;
    Expect(1, 68293, '\p{Jg:	- MANICHAEAN_Daleth}', "");
    Expect(0, 68293, '\p{^Jg:	- MANICHAEAN_Daleth}', "");
    Expect(0, 68293, '\P{Jg:	- MANICHAEAN_Daleth}', "");
    Expect(1, 68293, '\P{^Jg:	- MANICHAEAN_Daleth}', "");
    Expect(0, 68294, '\p{Jg:	- MANICHAEAN_Daleth}', "");
    Expect(1, 68294, '\p{^Jg:	- MANICHAEAN_Daleth}', "");
    Expect(1, 68294, '\P{Jg:	- MANICHAEAN_Daleth}', "");
    Expect(0, 68294, '\P{^Jg:	- MANICHAEAN_Daleth}', "");
    Error('\p{Is_Joining_Group=-/a/Manichaean_Daleth}');
    Error('\P{Is_Joining_Group=-/a/Manichaean_Daleth}');
    Expect(1, 68293, '\p{Is_Joining_Group=manichaeandaleth}', "");
    Expect(0, 68293, '\p{^Is_Joining_Group=manichaeandaleth}', "");
    Expect(0, 68293, '\P{Is_Joining_Group=manichaeandaleth}', "");
    Expect(1, 68293, '\P{^Is_Joining_Group=manichaeandaleth}', "");
    Expect(0, 68294, '\p{Is_Joining_Group=manichaeandaleth}', "");
    Expect(1, 68294, '\p{^Is_Joining_Group=manichaeandaleth}', "");
    Expect(1, 68294, '\P{Is_Joining_Group=manichaeandaleth}', "");
    Expect(0, 68294, '\P{^Is_Joining_Group=manichaeandaleth}', "");
    Expect(1, 68293, '\p{Is_Joining_Group=	-manichaean_Daleth}', "");
    Expect(0, 68293, '\p{^Is_Joining_Group=	-manichaean_Daleth}', "");
    Expect(0, 68293, '\P{Is_Joining_Group=	-manichaean_Daleth}', "");
    Expect(1, 68293, '\P{^Is_Joining_Group=	-manichaean_Daleth}', "");
    Expect(0, 68294, '\p{Is_Joining_Group=	-manichaean_Daleth}', "");
    Expect(1, 68294, '\p{^Is_Joining_Group=	-manichaean_Daleth}', "");
    Expect(1, 68294, '\P{Is_Joining_Group=	-manichaean_Daleth}', "");
    Expect(0, 68294, '\P{^Is_Joining_Group=	-manichaean_Daleth}', "");
    Error('\p{Is_Jg=/a/Manichaean_daleth}');
    Error('\P{Is_Jg=/a/Manichaean_daleth}');
    Expect(1, 68293, '\p{Is_Jg=manichaeandaleth}', "");
    Expect(0, 68293, '\p{^Is_Jg=manichaeandaleth}', "");
    Expect(0, 68293, '\P{Is_Jg=manichaeandaleth}', "");
    Expect(1, 68293, '\P{^Is_Jg=manichaeandaleth}', "");
    Expect(0, 68294, '\p{Is_Jg=manichaeandaleth}', "");
    Expect(1, 68294, '\p{^Is_Jg=manichaeandaleth}', "");
    Expect(1, 68294, '\P{Is_Jg=manichaeandaleth}', "");
    Expect(0, 68294, '\P{^Is_Jg=manichaeandaleth}', "");
    Expect(1, 68293, '\p{Is_Jg=--Manichaean_daleth}', "");
    Expect(0, 68293, '\p{^Is_Jg=--Manichaean_daleth}', "");
    Expect(0, 68293, '\P{Is_Jg=--Manichaean_daleth}', "");
    Expect(1, 68293, '\P{^Is_Jg=--Manichaean_daleth}', "");
    Expect(0, 68294, '\p{Is_Jg=--Manichaean_daleth}', "");
    Expect(1, 68294, '\p{^Is_Jg=--Manichaean_daleth}', "");
    Expect(1, 68294, '\P{Is_Jg=--Manichaean_daleth}', "");
    Expect(0, 68294, '\P{^Is_Jg=--Manichaean_daleth}', "");
    Error('\p{Joining_Group= :=Manichaean_Dhamedh}');
    Error('\P{Joining_Group= :=Manichaean_Dhamedh}');
    Expect(1, 68308, '\p{Joining_Group=:\AManichaean_Dhamedh\z:}', "");;
    Expect(0, 68309, '\p{Joining_Group=:\AManichaean_Dhamedh\z:}', "");;
    Expect(1, 68308, '\p{Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68308, '\p{^Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68308, '\P{Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68308, '\P{^Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68309, '\p{Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68309, '\p{^Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68309, '\P{Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68309, '\P{^Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68308, '\p{Joining_Group=:\Amanichaeandhamedh\z:}', "");;
    Expect(0, 68309, '\p{Joining_Group=:\Amanichaeandhamedh\z:}', "");;
    Expect(1, 68308, '\p{Joining_Group=_manichaean_dhamedh}', "");
    Expect(0, 68308, '\p{^Joining_Group=_manichaean_dhamedh}', "");
    Expect(0, 68308, '\P{Joining_Group=_manichaean_dhamedh}', "");
    Expect(1, 68308, '\P{^Joining_Group=_manichaean_dhamedh}', "");
    Expect(0, 68309, '\p{Joining_Group=_manichaean_dhamedh}', "");
    Expect(1, 68309, '\p{^Joining_Group=_manichaean_dhamedh}', "");
    Expect(1, 68309, '\P{Joining_Group=_manichaean_dhamedh}', "");
    Expect(0, 68309, '\P{^Joining_Group=_manichaean_dhamedh}', "");
    Error('\p{Jg=-manichaean_Dhamedh/a/}');
    Error('\P{Jg=-manichaean_Dhamedh/a/}');
    Expect(1, 68308, '\p{Jg=:\AManichaean_Dhamedh\z:}', "");;
    Expect(0, 68309, '\p{Jg=:\AManichaean_Dhamedh\z:}', "");;
    Expect(1, 68308, '\p{Jg=manichaeandhamedh}', "");
    Expect(0, 68308, '\p{^Jg=manichaeandhamedh}', "");
    Expect(0, 68308, '\P{Jg=manichaeandhamedh}', "");
    Expect(1, 68308, '\P{^Jg=manichaeandhamedh}', "");
    Expect(0, 68309, '\p{Jg=manichaeandhamedh}', "");
    Expect(1, 68309, '\p{^Jg=manichaeandhamedh}', "");
    Expect(1, 68309, '\P{Jg=manichaeandhamedh}', "");
    Expect(0, 68309, '\P{^Jg=manichaeandhamedh}', "");
    Expect(1, 68308, '\p{Jg=:\Amanichaeandhamedh\z:}', "");;
    Expect(0, 68309, '\p{Jg=:\Amanichaeandhamedh\z:}', "");;
    Expect(1, 68308, '\p{Jg=_ MANICHAEAN_Dhamedh}', "");
    Expect(0, 68308, '\p{^Jg=_ MANICHAEAN_Dhamedh}', "");
    Expect(0, 68308, '\P{Jg=_ MANICHAEAN_Dhamedh}', "");
    Expect(1, 68308, '\P{^Jg=_ MANICHAEAN_Dhamedh}', "");
    Expect(0, 68309, '\p{Jg=_ MANICHAEAN_Dhamedh}', "");
    Expect(1, 68309, '\p{^Jg=_ MANICHAEAN_Dhamedh}', "");
    Expect(1, 68309, '\P{Jg=_ MANICHAEAN_Dhamedh}', "");
    Expect(0, 68309, '\P{^Jg=_ MANICHAEAN_Dhamedh}', "");
    Error('\p{Is_Joining_Group=-Manichaean_Dhamedh:=}');
    Error('\P{Is_Joining_Group=-Manichaean_Dhamedh:=}');
    Expect(1, 68308, '\p{Is_Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68308, '\p{^Is_Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68308, '\P{Is_Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68308, '\P{^Is_Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68309, '\p{Is_Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68309, '\p{^Is_Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68309, '\P{Is_Joining_Group=manichaeandhamedh}', "");
    Expect(0, 68309, '\P{^Is_Joining_Group=manichaeandhamedh}', "");
    Expect(1, 68308, '\p{Is_Joining_Group=_Manichaean_dhamedh}', "");
    Expect(0, 68308, '\p{^Is_Joining_Group=_Manichaean_dhamedh}', "");
    Expect(0, 68308, '\P{Is_Joining_Group=_Manichaean_dhamedh}', "");
    Expect(1, 68308, '\P{^Is_Joining_Group=_Manichaean_dhamedh}', "");
    Expect(0, 68309, '\p{Is_Joining_Group=_Manichaean_dhamedh}', "");
    Expect(1, 68309, '\p{^Is_Joining_Group=_Manichaean_dhamedh}', "");
    Expect(1, 68309, '\P{Is_Joining_Group=_Manichaean_dhamedh}', "");
    Expect(0, 68309, '\P{^Is_Joining_Group=_Manichaean_dhamedh}', "");
    Error('\p{Is_Jg= :=Manichaean_DHAMEDH}');
    Error('\P{Is_Jg= :=Manichaean_DHAMEDH}');
    Expect(1, 68308, '\p{Is_Jg=manichaeandhamedh}', "");
    Expect(0, 68308, '\p{^Is_Jg=manichaeandhamedh}', "");
    Expect(0, 68308, '\P{Is_Jg=manichaeandhamedh}', "");
    Expect(1, 68308, '\P{^Is_Jg=manichaeandhamedh}', "");
    Expect(0, 68309, '\p{Is_Jg=manichaeandhamedh}', "");
    Expect(1, 68309, '\p{^Is_Jg=manichaeandhamedh}', "");
    Expect(1, 68309, '\P{Is_Jg=manichaeandhamedh}', "");
    Expect(0, 68309, '\P{^Is_Jg=manichaeandhamedh}', "");
    Expect(1, 68308, '\p{Is_Jg=-MANICHAEAN_dhamedh}', "");
    Expect(0, 68308, '\p{^Is_Jg=-MANICHAEAN_dhamedh}', "");
    Expect(0, 68308, '\P{Is_Jg=-MANICHAEAN_dhamedh}', "");
    Expect(1, 68308, '\P{^Is_Jg=-MANICHAEAN_dhamedh}', "");
    Expect(0, 68309, '\p{Is_Jg=-MANICHAEAN_dhamedh}', "");
    Expect(1, 68309, '\p{^Is_Jg=-MANICHAEAN_dhamedh}', "");
    Expect(1, 68309, '\P{Is_Jg=-MANICHAEAN_dhamedh}', "");
    Expect(0, 68309, '\P{^Is_Jg=-MANICHAEAN_dhamedh}', "");
    Error('\p{Joining_Group=/a/__manichaean_Five}');
    Error('\P{Joining_Group=/a/__manichaean_Five}');
    Expect(1, 68332, '\p{Joining_Group=:\AManichaean_Five\z:}', "");;
    Expect(0, 68333, '\p{Joining_Group=:\AManichaean_Five\z:}', "");;
    Expect(1, 68332, '\p{Joining_Group=manichaeanfive}', "");
    Expect(0, 68332, '\p{^Joining_Group=manichaeanfive}', "");
    Expect(0, 68332, '\P{Joining_Group=manichaeanfive}', "");
    Expect(1, 68332, '\P{^Joining_Group=manichaeanfive}', "");
    Expect(0, 68333, '\p{Joining_Group=manichaeanfive}', "");
    Expect(1, 68333, '\p{^Joining_Group=manichaeanfive}', "");
    Expect(1, 68333, '\P{Joining_Group=manichaeanfive}', "");
    Expect(0, 68333, '\P{^Joining_Group=manichaeanfive}', "");
    Expect(1, 68332, '\p{Joining_Group=:\Amanichaeanfive\z:}', "");;
    Expect(0, 68333, '\p{Joining_Group=:\Amanichaeanfive\z:}', "");;
    Expect(1, 68332, '\p{Joining_Group=		Manichaean_five}', "");
    Expect(0, 68332, '\p{^Joining_Group=		Manichaean_five}', "");
    Expect(0, 68332, '\P{Joining_Group=		Manichaean_five}', "");
    Expect(1, 68332, '\P{^Joining_Group=		Manichaean_five}', "");
    Expect(0, 68333, '\p{Joining_Group=		Manichaean_five}', "");
    Expect(1, 68333, '\p{^Joining_Group=		Manichaean_five}', "");
    Expect(1, 68333, '\P{Joining_Group=		Manichaean_five}', "");
    Expect(0, 68333, '\P{^Joining_Group=		Manichaean_five}', "");
    Error('\p{Jg=--Manichaean_Five/a/}');
    Error('\P{Jg=--Manichaean_Five/a/}');
    Expect(1, 68332, '\p{Jg=:\AManichaean_Five\z:}', "");;
    Expect(0, 68333, '\p{Jg=:\AManichaean_Five\z:}', "");;
    Expect(1, 68332, '\p{Jg=manichaeanfive}', "");
    Expect(0, 68332, '\p{^Jg=manichaeanfive}', "");
    Expect(0, 68332, '\P{Jg=manichaeanfive}', "");
    Expect(1, 68332, '\P{^Jg=manichaeanfive}', "");
    Expect(0, 68333, '\p{Jg=manichaeanfive}', "");
    Expect(1, 68333, '\p{^Jg=manichaeanfive}', "");
    Expect(1, 68333, '\P{Jg=manichaeanfive}', "");
    Expect(0, 68333, '\P{^Jg=manichaeanfive}', "");
    Expect(1, 68332, '\p{Jg=:\Amanichaeanfive\z:}', "");;
    Expect(0, 68333, '\p{Jg=:\Amanichaeanfive\z:}', "");;
    Expect(1, 68332, '\p{Jg=-MANICHAEAN_Five}', "");
    Expect(0, 68332, '\p{^Jg=-MANICHAEAN_Five}', "");
    Expect(0, 68332, '\P{Jg=-MANICHAEAN_Five}', "");
    Expect(1, 68332, '\P{^Jg=-MANICHAEAN_Five}', "");
    Expect(0, 68333, '\p{Jg=-MANICHAEAN_Five}', "");
    Expect(1, 68333, '\p{^Jg=-MANICHAEAN_Five}', "");
    Expect(1, 68333, '\P{Jg=-MANICHAEAN_Five}', "");
    Expect(0, 68333, '\P{^Jg=-MANICHAEAN_Five}', "");
    Error('\p{Is_Joining_Group=-_Manichaean_five/a/}');
    Error('\P{Is_Joining_Group=-_Manichaean_five/a/}');
    Expect(1, 68332, '\p{Is_Joining_Group=manichaeanfive}', "");
    Expect(0, 68332, '\p{^Is_Joining_Group=manichaeanfive}', "");
    Expect(0, 68332, '\P{Is_Joining_Group=manichaeanfive}', "");
    Expect(1, 68332, '\P{^Is_Joining_Group=manichaeanfive}', "");
    Expect(0, 68333, '\p{Is_Joining_Group=manichaeanfive}', "");
    Expect(1, 68333, '\p{^Is_Joining_Group=manichaeanfive}', "");
    Expect(1, 68333, '\P{Is_Joining_Group=manichaeanfive}', "");
    Expect(0, 68333, '\P{^Is_Joining_Group=manichaeanfive}', "");
    Expect(1, 68332, '\p{Is_Joining_Group=MANICHAEAN_five}', "");
    Expect(0, 68332, '\p{^Is_Joining_Group=MANICHAEAN_five}', "");
    Expect(0, 68332, '\P{Is_Joining_Group=MANICHAEAN_five}', "");
    Expect(1, 68332, '\P{^Is_Joining_Group=MANICHAEAN_five}', "");
    Expect(0, 68333, '\p{Is_Joining_Group=MANICHAEAN_five}', "");
    Expect(1, 68333, '\p{^Is_Joining_Group=MANICHAEAN_five}', "");
    Expect(1, 68333, '\P{Is_Joining_Group=MANICHAEAN_five}', "");
    Expect(0, 68333, '\P{^Is_Joining_Group=MANICHAEAN_five}', "");
    Error('\p{Is_Jg:/a/	-Manichaean_five}');
    Error('\P{Is_Jg:/a/	-Manichaean_five}');
    Expect(1, 68332, '\p{Is_Jg=manichaeanfive}', "");
    Expect(0, 68332, '\p{^Is_Jg=manichaeanfive}', "");
    Expect(0, 68332, '\P{Is_Jg=manichaeanfive}', "");
    Expect(1, 68332, '\P{^Is_Jg=manichaeanfive}', "");
    Expect(0, 68333, '\p{Is_Jg=manichaeanfive}', "");
    Expect(1, 68333, '\p{^Is_Jg=manichaeanfive}', "");
    Expect(1, 68333, '\P{Is_Jg=manichaeanfive}', "");
    Expect(0, 68333, '\P{^Is_Jg=manichaeanfive}', "");
    Expect(1, 68332, '\p{Is_Jg=_Manichaean_Five}', "");
    Expect(0, 68332, '\p{^Is_Jg=_Manichaean_Five}', "");
    Expect(0, 68332, '\P{Is_Jg=_Manichaean_Five}', "");
    Expect(1, 68332, '\P{^Is_Jg=_Manichaean_Five}', "");
    Expect(0, 68333, '\p{Is_Jg=_Manichaean_Five}', "");
    Expect(1, 68333, '\p{^Is_Jg=_Manichaean_Five}', "");
    Expect(1, 68333, '\P{Is_Jg=_Manichaean_Five}', "");
    Expect(0, 68333, '\P{^Is_Jg=_Manichaean_Five}', "");
    Error('\p{Joining_Group=	MANICHAEAN_Gimel:=}');
    Error('\P{Joining_Group=	MANICHAEAN_Gimel:=}');
    Expect(1, 68292, '\p{Joining_Group=:\AManichaean_Gimel\z:}', "");;
    Expect(0, 68293, '\p{Joining_Group=:\AManichaean_Gimel\z:}', "");;
    Expect(1, 68292, '\p{Joining_Group=manichaeangimel}', "");
    Expect(0, 68292, '\p{^Joining_Group=manichaeangimel}', "");
    Expect(0, 68292, '\P{Joining_Group=manichaeangimel}', "");
    Expect(1, 68292, '\P{^Joining_Group=manichaeangimel}', "");
    Expect(0, 68293, '\p{Joining_Group=manichaeangimel}', "");
    Expect(1, 68293, '\p{^Joining_Group=manichaeangimel}', "");
    Expect(1, 68293, '\P{Joining_Group=manichaeangimel}', "");
    Expect(0, 68293, '\P{^Joining_Group=manichaeangimel}', "");
    Expect(1, 68292, '\p{Joining_Group=:\Amanichaeangimel\z:}', "");;
    Expect(0, 68293, '\p{Joining_Group=:\Amanichaeangimel\z:}', "");;
    Expect(1, 68292, '\p{Joining_Group= 	Manichaean_gimel}', "");
    Expect(0, 68292, '\p{^Joining_Group= 	Manichaean_gimel}', "");
    Expect(0, 68292, '\P{Joining_Group= 	Manichaean_gimel}', "");
    Expect(1, 68292, '\P{^Joining_Group= 	Manichaean_gimel}', "");
    Expect(0, 68293, '\p{Joining_Group= 	Manichaean_gimel}', "");
    Expect(1, 68293, '\p{^Joining_Group= 	Manichaean_gimel}', "");
    Expect(1, 68293, '\P{Joining_Group= 	Manichaean_gimel}', "");
    Expect(0, 68293, '\P{^Joining_Group= 	Manichaean_gimel}', "");
    Error('\p{Jg=:= manichaean_GIMEL}');
    Error('\P{Jg=:= manichaean_GIMEL}');
    Expect(1, 68292, '\p{Jg=:\AManichaean_Gimel\z:}', "");;
    Expect(0, 68293, '\p{Jg=:\AManichaean_Gimel\z:}', "");;
    Expect(1, 68292, '\p{Jg=manichaeangimel}', "");
    Expect(0, 68292, '\p{^Jg=manichaeangimel}', "");
    Expect(0, 68292, '\P{Jg=manichaeangimel}', "");
    Expect(1, 68292, '\P{^Jg=manichaeangimel}', "");
    Expect(0, 68293, '\p{Jg=manichaeangimel}', "");
    Expect(1, 68293, '\p{^Jg=manichaeangimel}', "");
    Expect(1, 68293, '\P{Jg=manichaeangimel}', "");
    Expect(0, 68293, '\P{^Jg=manichaeangimel}', "");
    Expect(1, 68292, '\p{Jg=:\Amanichaeangimel\z:}', "");;
    Expect(0, 68293, '\p{Jg=:\Amanichaeangimel\z:}', "");;
    Expect(1, 68292, '\p{Jg=	Manichaean_gimel}', "");
    Expect(0, 68292, '\p{^Jg=	Manichaean_gimel}', "");
    Expect(0, 68292, '\P{Jg=	Manichaean_gimel}', "");
    Expect(1, 68292, '\P{^Jg=	Manichaean_gimel}', "");
    Expect(0, 68293, '\p{Jg=	Manichaean_gimel}', "");
    Expect(1, 68293, '\p{^Jg=	Manichaean_gimel}', "");
    Expect(1, 68293, '\P{Jg=	Manichaean_gimel}', "");
    Expect(0, 68293, '\P{^Jg=	Manichaean_gimel}', "");
    Error('\p{Is_Joining_Group=:=	-MANICHAEAN_Gimel}');
    Error('\P{Is_Joining_Group=:=	-MANICHAEAN_Gimel}');
    Expect(1, 68292, '\p{Is_Joining_Group=manichaeangimel}', "");
    Expect(0, 68292, '\p{^Is_Joining_Group=manichaeangimel}', "");
    Expect(0, 68292, '\P{Is_Joining_Group=manichaeangimel}', "");
    Expect(1, 68292, '\P{^Is_Joining_Group=manichaeangimel}', "");
    Expect(0, 68293, '\p{Is_Joining_Group=manichaeangimel}', "");
    Expect(1, 68293, '\p{^Is_Joining_Group=manichaeangimel}', "");
    Expect(1, 68293, '\P{Is_Joining_Group=manichaeangimel}', "");
    Expect(0, 68293, '\P{^Is_Joining_Group=manichaeangimel}', "");
    Expect(1, 68292, '\p{Is_Joining_Group=	-manichaean_Gimel}', "");
    Expect(0, 68292, '\p{^Is_Joining_Group=	-manichaean_Gimel}', "");
    Expect(0, 68292, '\P{Is_Joining_Group=	-manichaean_Gimel}', "");
    Expect(1, 68292, '\P{^Is_Joining_Group=	-manichaean_Gimel}', "");
    Expect(0, 68293, '\p{Is_Joining_Group=	-manichaean_Gimel}', "");
    Expect(1, 68293, '\p{^Is_Joining_Group=	-manichaean_Gimel}', "");
    Expect(1, 68293, '\P{Is_Joining_Group=	-manichaean_Gimel}', "");
    Expect(0, 68293, '\P{^Is_Joining_Group=	-manichaean_Gimel}', "");
    Error('\p{Is_Jg=__Manichaean_gimel/a/}');
    Error('\P{Is_Jg=__Manichaean_gimel/a/}');
    Expect(1, 68292, '\p{Is_Jg=manichaeangimel}', "");
    Expect(0, 68292, '\p{^Is_Jg=manichaeangimel}', "");
    Expect(0, 68292, '\P{Is_Jg=manichaeangimel}', "");
    Expect(1, 68292, '\P{^Is_Jg=manichaeangimel}', "");
    Expect(0, 68293, '\p{Is_Jg=manichaeangimel}', "");
    Expect(1, 68293, '\p{^Is_Jg=manichaeangimel}', "");
    Expect(1, 68293, '\P{Is_Jg=manichaeangimel}', "");
    Expect(0, 68293, '\P{^Is_Jg=manichaeangimel}', "");
    Expect(1, 68292, '\p{Is_Jg=-	Manichaean_Gimel}', "");
    Expect(0, 68292, '\p{^Is_Jg=-	Manichaean_Gimel}', "");
    Expect(0, 68292, '\P{Is_Jg=-	Manichaean_Gimel}', "");
    Expect(1, 68292, '\P{^Is_Jg=-	Manichaean_Gimel}', "");
    Expect(0, 68293, '\p{Is_Jg=-	Manichaean_Gimel}', "");
    Expect(1, 68293, '\p{^Is_Jg=-	Manichaean_Gimel}', "");
    Expect(1, 68293, '\P{Is_Jg=-	Manichaean_Gimel}', "");
    Expect(0, 68293, '\P{^Is_Jg=-	Manichaean_Gimel}', "");
    Error('\p{Joining_Group: --Manichaean_Heth:=}');
    Error('\P{Joining_Group: --Manichaean_Heth:=}');
    Expect(1, 68301, '\p{Joining_Group=:\AManichaean_Heth\z:}', "");;
    Expect(0, 68302, '\p{Joining_Group=:\AManichaean_Heth\z:}', "");;
    Expect(1, 68301, '\p{Joining_Group=manichaeanheth}', "");
    Expect(0, 68301, '\p{^Joining_Group=manichaeanheth}', "");
    Expect(0, 68301, '\P{Joining_Group=manichaeanheth}', "");
    Expect(1, 68301, '\P{^Joining_Group=manichaeanheth}', "");
    Expect(0, 68302, '\p{Joining_Group=manichaeanheth}', "");
    Expect(1, 68302, '\p{^Joining_Group=manichaeanheth}', "");
    Expect(1, 68302, '\P{Joining_Group=manichaeanheth}', "");
    Expect(0, 68302, '\P{^Joining_Group=manichaeanheth}', "");
    Expect(1, 68301, '\p{Joining_Group=:\Amanichaeanheth\z:}', "");;
    Expect(0, 68302, '\p{Joining_Group=:\Amanichaeanheth\z:}', "");;
    Expect(1, 68301, '\p{Joining_Group=	 Manichaean_heth}', "");
    Expect(0, 68301, '\p{^Joining_Group=	 Manichaean_heth}', "");
    Expect(0, 68301, '\P{Joining_Group=	 Manichaean_heth}', "");
    Expect(1, 68301, '\P{^Joining_Group=	 Manichaean_heth}', "");
    Expect(0, 68302, '\p{Joining_Group=	 Manichaean_heth}', "");
    Expect(1, 68302, '\p{^Joining_Group=	 Manichaean_heth}', "");
    Expect(1, 68302, '\P{Joining_Group=	 Manichaean_heth}', "");
    Expect(0, 68302, '\P{^Joining_Group=	 Manichaean_heth}', "");
    Error('\p{Jg=	-manichaean_HETH:=}');
    Error('\P{Jg=	-manichaean_HETH:=}');
    Expect(1, 68301, '\p{Jg=:\AManichaean_Heth\z:}', "");;
    Expect(0, 68302, '\p{Jg=:\AManichaean_Heth\z:}', "");;
    Expect(1, 68301, '\p{Jg=manichaeanheth}', "");
    Expect(0, 68301, '\p{^Jg=manichaeanheth}', "");
    Expect(0, 68301, '\P{Jg=manichaeanheth}', "");
    Expect(1, 68301, '\P{^Jg=manichaeanheth}', "");
    Expect(0, 68302, '\p{Jg=manichaeanheth}', "");
    Expect(1, 68302, '\p{^Jg=manichaeanheth}', "");
    Expect(1, 68302, '\P{Jg=manichaeanheth}', "");
    Expect(0, 68302, '\P{^Jg=manichaeanheth}', "");
    Expect(1, 68301, '\p{Jg=:\Amanichaeanheth\z:}', "");;
    Expect(0, 68302, '\p{Jg=:\Amanichaeanheth\z:}', "");;
    Expect(1, 68301, '\p{Jg=-_Manichaean_heth}', "");
    Expect(0, 68301, '\p{^Jg=-_Manichaean_heth}', "");
    Expect(0, 68301, '\P{Jg=-_Manichaean_heth}', "");
    Expect(1, 68301, '\P{^Jg=-_Manichaean_heth}', "");
    Expect(0, 68302, '\p{Jg=-_Manichaean_heth}', "");
    Expect(1, 68302, '\p{^Jg=-_Manichaean_heth}', "");
    Expect(1, 68302, '\P{Jg=-_Manichaean_heth}', "");
    Expect(0, 68302, '\P{^Jg=-_Manichaean_heth}', "");
    Error('\p{Is_Joining_Group=_-manichaean_heth/a/}');
    Error('\P{Is_Joining_Group=_-manichaean_heth/a/}');
    Expect(1, 68301, '\p{Is_Joining_Group=manichaeanheth}', "");
    Expect(0, 68301, '\p{^Is_Joining_Group=manichaeanheth}', "");
    Expect(0, 68301, '\P{Is_Joining_Group=manichaeanheth}', "");
    Expect(1, 68301, '\P{^Is_Joining_Group=manichaeanheth}', "");
    Expect(0, 68302, '\p{Is_Joining_Group=manichaeanheth}', "");
    Expect(1, 68302, '\p{^Is_Joining_Group=manichaeanheth}', "");
    Expect(1, 68302, '\P{Is_Joining_Group=manichaeanheth}', "");
    Expect(0, 68302, '\P{^Is_Joining_Group=manichaeanheth}', "");
    Expect(1, 68301, '\p{Is_Joining_Group=		manichaean_HETH}', "");
    Expect(0, 68301, '\p{^Is_Joining_Group=		manichaean_HETH}', "");
    Expect(0, 68301, '\P{Is_Joining_Group=		manichaean_HETH}', "");
    Expect(1, 68301, '\P{^Is_Joining_Group=		manichaean_HETH}', "");
    Expect(0, 68302, '\p{Is_Joining_Group=		manichaean_HETH}', "");
    Expect(1, 68302, '\p{^Is_Joining_Group=		manichaean_HETH}', "");
    Expect(1, 68302, '\P{Is_Joining_Group=		manichaean_HETH}', "");
    Expect(0, 68302, '\P{^Is_Joining_Group=		manichaean_HETH}', "");
    Error('\p{Is_Jg=_:=Manichaean_Heth}');
    Error('\P{Is_Jg=_:=Manichaean_Heth}');
    Expect(1, 68301, '\p{Is_Jg=manichaeanheth}', "");
    Expect(0, 68301, '\p{^Is_Jg=manichaeanheth}', "");
    Expect(0, 68301, '\P{Is_Jg=manichaeanheth}', "");
    Expect(1, 68301, '\P{^Is_Jg=manichaeanheth}', "");
    Expect(0, 68302, '\p{Is_Jg=manichaeanheth}', "");
    Expect(1, 68302, '\p{^Is_Jg=manichaeanheth}', "");
    Expect(1, 68302, '\P{Is_Jg=manichaeanheth}', "");
    Expect(0, 68302, '\P{^Is_Jg=manichaeanheth}', "");
    Expect(1, 68301, '\p{Is_Jg=	-Manichaean_HETH}', "");
    Expect(0, 68301, '\p{^Is_Jg=	-Manichaean_HETH}', "");
    Expect(0, 68301, '\P{Is_Jg=	-Manichaean_HETH}', "");
    Expect(1, 68301, '\P{^Is_Jg=	-Manichaean_HETH}', "");
    Expect(0, 68302, '\p{Is_Jg=	-Manichaean_HETH}', "");
    Expect(1, 68302, '\p{^Is_Jg=	-Manichaean_HETH}', "");
    Expect(1, 68302, '\P{Is_Jg=	-Manichaean_HETH}', "");
    Expect(0, 68302, '\P{^Is_Jg=	-Manichaean_HETH}', "");
    Error('\p{Joining_Group=/a/_Manichaean_HUNDRED}');
    Error('\P{Joining_Group=/a/_Manichaean_HUNDRED}');
    Expect(1, 68335, '\p{Joining_Group=:\AManichaean_Hundred\z:}', "");;
    Expect(0, 68336, '\p{Joining_Group=:\AManichaean_Hundred\z:}', "");;
    Expect(1, 68335, '\p{Joining_Group:   manichaeanhundred}', "");
    Expect(0, 68335, '\p{^Joining_Group:   manichaeanhundred}', "");
    Expect(0, 68335, '\P{Joining_Group:   manichaeanhundred}', "");
    Expect(1, 68335, '\P{^Joining_Group:   manichaeanhundred}', "");
    Expect(0, 68336, '\p{Joining_Group:   manichaeanhundred}', "");
    Expect(1, 68336, '\p{^Joining_Group:   manichaeanhundred}', "");
    Expect(1, 68336, '\P{Joining_Group:   manichaeanhundred}', "");
    Expect(0, 68336, '\P{^Joining_Group:   manichaeanhundred}', "");
    Expect(1, 68335, '\p{Joining_Group=:\Amanichaeanhundred\z:}', "");;
    Expect(0, 68336, '\p{Joining_Group=:\Amanichaeanhundred\z:}', "");;
    Expect(1, 68335, '\p{Joining_Group=manichaean_hundred}', "");
    Expect(0, 68335, '\p{^Joining_Group=manichaean_hundred}', "");
    Expect(0, 68335, '\P{Joining_Group=manichaean_hundred}', "");
    Expect(1, 68335, '\P{^Joining_Group=manichaean_hundred}', "");
    Expect(0, 68336, '\p{Joining_Group=manichaean_hundred}', "");
    Expect(1, 68336, '\p{^Joining_Group=manichaean_hundred}', "");
    Expect(1, 68336, '\P{Joining_Group=manichaean_hundred}', "");
    Expect(0, 68336, '\P{^Joining_Group=manichaean_hundred}', "");
    Error('\p{Jg=/a/_-Manichaean_hundred}');
    Error('\P{Jg=/a/_-Manichaean_hundred}');
    Expect(1, 68335, '\p{Jg=:\AManichaean_Hundred\z:}', "");;
    Expect(0, 68336, '\p{Jg=:\AManichaean_Hundred\z:}', "");;
    Expect(1, 68335, '\p{Jg: manichaeanhundred}', "");
    Expect(0, 68335, '\p{^Jg: manichaeanhundred}', "");
    Expect(0, 68335, '\P{Jg: manichaeanhundred}', "");
    Expect(1, 68335, '\P{^Jg: manichaeanhundred}', "");
    Expect(0, 68336, '\p{Jg: manichaeanhundred}', "");
    Expect(1, 68336, '\p{^Jg: manichaeanhundred}', "");
    Expect(1, 68336, '\P{Jg: manichaeanhundred}', "");
    Expect(0, 68336, '\P{^Jg: manichaeanhundred}', "");
    Expect(1, 68335, '\p{Jg=:\Amanichaeanhundred\z:}', "");;
    Expect(0, 68336, '\p{Jg=:\Amanichaeanhundred\z:}', "");;
    Expect(1, 68335, '\p{Jg:- manichaean_Hundred}', "");
    Expect(0, 68335, '\p{^Jg:- manichaean_Hundred}', "");
    Expect(0, 68335, '\P{Jg:- manichaean_Hundred}', "");
    Expect(1, 68335, '\P{^Jg:- manichaean_Hundred}', "");
    Expect(0, 68336, '\p{Jg:- manichaean_Hundred}', "");
    Expect(1, 68336, '\p{^Jg:- manichaean_Hundred}', "");
    Expect(1, 68336, '\P{Jg:- manichaean_Hundred}', "");
    Expect(0, 68336, '\P{^Jg:- manichaean_Hundred}', "");
    Error('\p{Is_Joining_Group=:=_ Manichaean_Hundred}');
    Error('\P{Is_Joining_Group=:=_ Manichaean_Hundred}');
    Expect(1, 68335, '\p{Is_Joining_Group=manichaeanhundred}', "");
    Expect(0, 68335, '\p{^Is_Joining_Group=manichaeanhundred}', "");
    Expect(0, 68335, '\P{Is_Joining_Group=manichaeanhundred}', "");
    Expect(1, 68335, '\P{^Is_Joining_Group=manichaeanhundred}', "");
    Expect(0, 68336, '\p{Is_Joining_Group=manichaeanhundred}', "");
    Expect(1, 68336, '\p{^Is_Joining_Group=manichaeanhundred}', "");
    Expect(1, 68336, '\P{Is_Joining_Group=manichaeanhundred}', "");
    Expect(0, 68336, '\P{^Is_Joining_Group=manichaeanhundred}', "");
    Expect(1, 68335, '\p{Is_Joining_Group=__Manichaean_Hundred}', "");
    Expect(0, 68335, '\p{^Is_Joining_Group=__Manichaean_Hundred}', "");
    Expect(0, 68335, '\P{Is_Joining_Group=__Manichaean_Hundred}', "");
    Expect(1, 68335, '\P{^Is_Joining_Group=__Manichaean_Hundred}', "");
    Expect(0, 68336, '\p{Is_Joining_Group=__Manichaean_Hundred}', "");
    Expect(1, 68336, '\p{^Is_Joining_Group=__Manichaean_Hundred}', "");
    Expect(1, 68336, '\P{Is_Joining_Group=__Manichaean_Hundred}', "");
    Expect(0, 68336, '\P{^Is_Joining_Group=__Manichaean_Hundred}', "");
    Error('\p{Is_Jg=_MANICHAEAN_hundred/a/}');
    Error('\P{Is_Jg=_MANICHAEAN_hundred/a/}');
    Expect(1, 68335, '\p{Is_Jg=manichaeanhundred}', "");
    Expect(0, 68335, '\p{^Is_Jg=manichaeanhundred}', "");
    Expect(0, 68335, '\P{Is_Jg=manichaeanhundred}', "");
    Expect(1, 68335, '\P{^Is_Jg=manichaeanhundred}', "");
    Expect(0, 68336, '\p{Is_Jg=manichaeanhundred}', "");
    Expect(1, 68336, '\p{^Is_Jg=manichaeanhundred}', "");
    Expect(1, 68336, '\P{Is_Jg=manichaeanhundred}', "");
    Expect(0, 68336, '\P{^Is_Jg=manichaeanhundred}', "");
    Expect(1, 68335, '\p{Is_Jg=_Manichaean_Hundred}', "");
    Expect(0, 68335, '\p{^Is_Jg=_Manichaean_Hundred}', "");
    Expect(0, 68335, '\P{Is_Jg=_Manichaean_Hundred}', "");
    Expect(1, 68335, '\P{^Is_Jg=_Manichaean_Hundred}', "");
    Expect(0, 68336, '\p{Is_Jg=_Manichaean_Hundred}', "");
    Expect(1, 68336, '\p{^Is_Jg=_Manichaean_Hundred}', "");
    Expect(1, 68336, '\P{Is_Jg=_Manichaean_Hundred}', "");
    Expect(0, 68336, '\P{^Is_Jg=_Manichaean_Hundred}', "");
    Error('\p{Joining_Group= Manichaean_KAPH:=}');
    Error('\P{Joining_Group= Manichaean_KAPH:=}');
    Expect(1, 68306, '\p{Joining_Group=:\AManichaean_Kaph\z:}', "");;
    Expect(0, 68307, '\p{Joining_Group=:\AManichaean_Kaph\z:}', "");;
    Expect(1, 68306, '\p{Joining_Group=manichaeankaph}', "");
    Expect(0, 68306, '\p{^Joining_Group=manichaeankaph}', "");
    Expect(0, 68306, '\P{Joining_Group=manichaeankaph}', "");
    Expect(1, 68306, '\P{^Joining_Group=manichaeankaph}', "");
    Expect(0, 68307, '\p{Joining_Group=manichaeankaph}', "");
    Expect(1, 68307, '\p{^Joining_Group=manichaeankaph}', "");
    Expect(1, 68307, '\P{Joining_Group=manichaeankaph}', "");
    Expect(0, 68307, '\P{^Joining_Group=manichaeankaph}', "");
    Expect(1, 68306, '\p{Joining_Group=:\Amanichaeankaph\z:}', "");;
    Expect(0, 68307, '\p{Joining_Group=:\Amanichaeankaph\z:}', "");;
    Expect(1, 68306, '\p{Joining_Group=_	MANICHAEAN_KAPH}', "");
    Expect(0, 68306, '\p{^Joining_Group=_	MANICHAEAN_KAPH}', "");
    Expect(0, 68306, '\P{Joining_Group=_	MANICHAEAN_KAPH}', "");
    Expect(1, 68306, '\P{^Joining_Group=_	MANICHAEAN_KAPH}', "");
    Expect(0, 68307, '\p{Joining_Group=_	MANICHAEAN_KAPH}', "");
    Expect(1, 68307, '\p{^Joining_Group=_	MANICHAEAN_KAPH}', "");
    Expect(1, 68307, '\P{Joining_Group=_	MANICHAEAN_KAPH}', "");
    Expect(0, 68307, '\P{^Joining_Group=_	MANICHAEAN_KAPH}', "");
    Error('\p{Jg=:=  MANICHAEAN_Kaph}');
    Error('\P{Jg=:=  MANICHAEAN_Kaph}');
    Expect(1, 68306, '\p{Jg=:\AManichaean_Kaph\z:}', "");;
    Expect(0, 68307, '\p{Jg=:\AManichaean_Kaph\z:}', "");;
    Expect(1, 68306, '\p{Jg:   manichaeankaph}', "");
    Expect(0, 68306, '\p{^Jg:   manichaeankaph}', "");
    Expect(0, 68306, '\P{Jg:   manichaeankaph}', "");
    Expect(1, 68306, '\P{^Jg:   manichaeankaph}', "");
    Expect(0, 68307, '\p{Jg:   manichaeankaph}', "");
    Expect(1, 68307, '\p{^Jg:   manichaeankaph}', "");
    Expect(1, 68307, '\P{Jg:   manichaeankaph}', "");
    Expect(0, 68307, '\P{^Jg:   manichaeankaph}', "");
    Expect(1, 68306, '\p{Jg=:\Amanichaeankaph\z:}', "");;
    Expect(0, 68307, '\p{Jg=:\Amanichaeankaph\z:}', "");;
    Expect(1, 68306, '\p{Jg:-_manichaean_KAPH}', "");
    Expect(0, 68306, '\p{^Jg:-_manichaean_KAPH}', "");
    Expect(0, 68306, '\P{Jg:-_manichaean_KAPH}', "");
    Expect(1, 68306, '\P{^Jg:-_manichaean_KAPH}', "");
    Expect(0, 68307, '\p{Jg:-_manichaean_KAPH}', "");
    Expect(1, 68307, '\p{^Jg:-_manichaean_KAPH}', "");
    Expect(1, 68307, '\P{Jg:-_manichaean_KAPH}', "");
    Expect(0, 68307, '\P{^Jg:-_manichaean_KAPH}', "");
    Error('\p{Is_Joining_Group=-/a/manichaean_Kaph}');
    Error('\P{Is_Joining_Group=-/a/manichaean_Kaph}');
    Expect(1, 68306, '\p{Is_Joining_Group=manichaeankaph}', "");
    Expect(0, 68306, '\p{^Is_Joining_Group=manichaeankaph}', "");
    Expect(0, 68306, '\P{Is_Joining_Group=manichaeankaph}', "");
    Expect(1, 68306, '\P{^Is_Joining_Group=manichaeankaph}', "");
    Expect(0, 68307, '\p{Is_Joining_Group=manichaeankaph}', "");
    Expect(1, 68307, '\p{^Is_Joining_Group=manichaeankaph}', "");
    Expect(1, 68307, '\P{Is_Joining_Group=manichaeankaph}', "");
    Expect(0, 68307, '\P{^Is_Joining_Group=manichaeankaph}', "");
    Expect(1, 68306, '\p{Is_Joining_Group= Manichaean_Kaph}', "");
    Expect(0, 68306, '\p{^Is_Joining_Group= Manichaean_Kaph}', "");
    Expect(0, 68306, '\P{Is_Joining_Group= Manichaean_Kaph}', "");
    Expect(1, 68306, '\P{^Is_Joining_Group= Manichaean_Kaph}', "");
    Expect(0, 68307, '\p{Is_Joining_Group= Manichaean_Kaph}', "");
    Expect(1, 68307, '\p{^Is_Joining_Group= Manichaean_Kaph}', "");
    Expect(1, 68307, '\P{Is_Joining_Group= Manichaean_Kaph}', "");
    Expect(0, 68307, '\P{^Is_Joining_Group= Manichaean_Kaph}', "");
    Error('\p{Is_Jg=	manichaean_kaph:=}');
    Error('\P{Is_Jg=	manichaean_kaph:=}');
    Expect(1, 68306, '\p{Is_Jg:   manichaeankaph}', "");
    Expect(0, 68306, '\p{^Is_Jg:   manichaeankaph}', "");
    Expect(0, 68306, '\P{Is_Jg:   manichaeankaph}', "");
    Expect(1, 68306, '\P{^Is_Jg:   manichaeankaph}', "");
    Expect(0, 68307, '\p{Is_Jg:   manichaeankaph}', "");
    Expect(1, 68307, '\p{^Is_Jg:   manichaeankaph}', "");
    Expect(1, 68307, '\P{Is_Jg:   manichaeankaph}', "");
    Expect(0, 68307, '\P{^Is_Jg:   manichaeankaph}', "");
    Expect(1, 68306, '\p{Is_Jg: 	_Manichaean_kaph}', "");
    Expect(0, 68306, '\p{^Is_Jg: 	_Manichaean_kaph}', "");
    Expect(0, 68306, '\P{Is_Jg: 	_Manichaean_kaph}', "");
    Expect(1, 68306, '\P{^Is_Jg: 	_Manichaean_kaph}', "");
    Expect(0, 68307, '\p{Is_Jg: 	_Manichaean_kaph}', "");
    Expect(1, 68307, '\p{^Is_Jg: 	_Manichaean_kaph}', "");
    Expect(1, 68307, '\P{Is_Jg: 	_Manichaean_kaph}', "");
    Expect(0, 68307, '\P{^Is_Jg: 	_Manichaean_kaph}', "");
    Error('\p{Joining_Group=-/a/manichaean_lamedh}');
    Error('\P{Joining_Group=-/a/manichaean_lamedh}');
    Expect(1, 68307, '\p{Joining_Group=:\AManichaean_Lamedh\z:}', "");;
    Expect(0, 68308, '\p{Joining_Group=:\AManichaean_Lamedh\z:}', "");;
    Expect(1, 68307, '\p{Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68307, '\p{^Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68307, '\P{Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68307, '\P{^Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68308, '\p{Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68308, '\p{^Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68308, '\P{Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68308, '\P{^Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68307, '\p{Joining_Group=:\Amanichaeanlamedh\z:}', "");;
    Expect(0, 68308, '\p{Joining_Group=:\Amanichaeanlamedh\z:}', "");;
    Expect(1, 68307, '\p{Joining_Group=-MANICHAEAN_Lamedh}', "");
    Expect(0, 68307, '\p{^Joining_Group=-MANICHAEAN_Lamedh}', "");
    Expect(0, 68307, '\P{Joining_Group=-MANICHAEAN_Lamedh}', "");
    Expect(1, 68307, '\P{^Joining_Group=-MANICHAEAN_Lamedh}', "");
    Expect(0, 68308, '\p{Joining_Group=-MANICHAEAN_Lamedh}', "");
    Expect(1, 68308, '\p{^Joining_Group=-MANICHAEAN_Lamedh}', "");
    Expect(1, 68308, '\P{Joining_Group=-MANICHAEAN_Lamedh}', "");
    Expect(0, 68308, '\P{^Joining_Group=-MANICHAEAN_Lamedh}', "");
    Error('\p{Jg= /a/manichaean_LAMEDH}');
    Error('\P{Jg= /a/manichaean_LAMEDH}');
    Expect(1, 68307, '\p{Jg=:\AManichaean_Lamedh\z:}', "");;
    Expect(0, 68308, '\p{Jg=:\AManichaean_Lamedh\z:}', "");;
    Expect(1, 68307, '\p{Jg=manichaeanlamedh}', "");
    Expect(0, 68307, '\p{^Jg=manichaeanlamedh}', "");
    Expect(0, 68307, '\P{Jg=manichaeanlamedh}', "");
    Expect(1, 68307, '\P{^Jg=manichaeanlamedh}', "");
    Expect(0, 68308, '\p{Jg=manichaeanlamedh}', "");
    Expect(1, 68308, '\p{^Jg=manichaeanlamedh}', "");
    Expect(1, 68308, '\P{Jg=manichaeanlamedh}', "");
    Expect(0, 68308, '\P{^Jg=manichaeanlamedh}', "");
    Expect(1, 68307, '\p{Jg=:\Amanichaeanlamedh\z:}', "");;
    Expect(0, 68308, '\p{Jg=:\Amanichaeanlamedh\z:}', "");;
    Expect(1, 68307, '\p{Jg=__manichaean_LAMEDH}', "");
    Expect(0, 68307, '\p{^Jg=__manichaean_LAMEDH}', "");
    Expect(0, 68307, '\P{Jg=__manichaean_LAMEDH}', "");
    Expect(1, 68307, '\P{^Jg=__manichaean_LAMEDH}', "");
    Expect(0, 68308, '\p{Jg=__manichaean_LAMEDH}', "");
    Expect(1, 68308, '\p{^Jg=__manichaean_LAMEDH}', "");
    Expect(1, 68308, '\P{Jg=__manichaean_LAMEDH}', "");
    Expect(0, 68308, '\P{^Jg=__manichaean_LAMEDH}', "");
    Error('\p{Is_Joining_Group=__manichaean_lamedh/a/}');
    Error('\P{Is_Joining_Group=__manichaean_lamedh/a/}');
    Expect(1, 68307, '\p{Is_Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68307, '\p{^Is_Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68307, '\P{Is_Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68307, '\P{^Is_Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68308, '\p{Is_Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68308, '\p{^Is_Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68308, '\P{Is_Joining_Group=manichaeanlamedh}', "");
    Expect(0, 68308, '\P{^Is_Joining_Group=manichaeanlamedh}', "");
    Expect(1, 68307, '\p{Is_Joining_Group= -Manichaean_LAMEDH}', "");
    Expect(0, 68307, '\p{^Is_Joining_Group= -Manichaean_LAMEDH}', "");
    Expect(0, 68307, '\P{Is_Joining_Group= -Manichaean_LAMEDH}', "");
    Expect(1, 68307, '\P{^Is_Joining_Group= -Manichaean_LAMEDH}', "");
    Expect(0, 68308, '\p{Is_Joining_Group= -Manichaean_LAMEDH}', "");
    Expect(1, 68308, '\p{^Is_Joining_Group= -Manichaean_LAMEDH}', "");
    Expect(1, 68308, '\P{Is_Joining_Group= -Manichaean_LAMEDH}', "");
    Expect(0, 68308, '\P{^Is_Joining_Group= -Manichaean_LAMEDH}', "");
    Error('\p{Is_Jg=	:=Manichaean_lamedh}');
    Error('\P{Is_Jg=	:=Manichaean_lamedh}');
    Expect(1, 68307, '\p{Is_Jg=manichaeanlamedh}', "");
    Expect(0, 68307, '\p{^Is_Jg=manichaeanlamedh}', "");
    Expect(0, 68307, '\P{Is_Jg=manichaeanlamedh}', "");
    Expect(1, 68307, '\P{^Is_Jg=manichaeanlamedh}', "");
    Expect(0, 68308, '\p{Is_Jg=manichaeanlamedh}', "");
    Expect(1, 68308, '\p{^Is_Jg=manichaeanlamedh}', "");
    Expect(1, 68308, '\P{Is_Jg=manichaeanlamedh}', "");
    Expect(0, 68308, '\P{^Is_Jg=manichaeanlamedh}', "");
    Expect(1, 68307, '\p{Is_Jg=_Manichaean_Lamedh}', "");
    Expect(0, 68307, '\p{^Is_Jg=_Manichaean_Lamedh}', "");
    Expect(0, 68307, '\P{Is_Jg=_Manichaean_Lamedh}', "");
    Expect(1, 68307, '\P{^Is_Jg=_Manichaean_Lamedh}', "");
    Expect(0, 68308, '\p{Is_Jg=_Manichaean_Lamedh}', "");
    Expect(1, 68308, '\p{^Is_Jg=_Manichaean_Lamedh}', "");
    Expect(1, 68308, '\P{Is_Jg=_Manichaean_Lamedh}', "");
    Expect(0, 68308, '\P{^Is_Jg=_Manichaean_Lamedh}', "");
    Error('\p{Joining_Group=/a/manichaean_Mem}');
    Error('\P{Joining_Group=/a/manichaean_Mem}');
    Expect(1, 68310, '\p{Joining_Group=:\AManichaean_Mem\z:}', "");;
    Expect(0, 68311, '\p{Joining_Group=:\AManichaean_Mem\z:}', "");;
    Expect(1, 68310, '\p{Joining_Group=manichaeanmem}', "");
    Expect(0, 68310, '\p{^Joining_Group=manichaeanmem}', "");
    Expect(0, 68310, '\P{Joining_Group=manichaeanmem}', "");
    Expect(1, 68310, '\P{^Joining_Group=manichaeanmem}', "");
    Expect(0, 68311, '\p{Joining_Group=manichaeanmem}', "");
    Expect(1, 68311, '\p{^Joining_Group=manichaeanmem}', "");
    Expect(1, 68311, '\P{Joining_Group=manichaeanmem}', "");
    Expect(0, 68311, '\P{^Joining_Group=manichaeanmem}', "");
    Expect(1, 68310, '\p{Joining_Group=:\Amanichaeanmem\z:}', "");;
    Expect(0, 68311, '\p{Joining_Group=:\Amanichaeanmem\z:}', "");;
    Expect(1, 68310, '\p{Joining_Group=_ Manichaean_Mem}', "");
    Expect(0, 68310, '\p{^Joining_Group=_ Manichaean_Mem}', "");
    Expect(0, 68310, '\P{Joining_Group=_ Manichaean_Mem}', "");
    Expect(1, 68310, '\P{^Joining_Group=_ Manichaean_Mem}', "");
    Expect(0, 68311, '\p{Joining_Group=_ Manichaean_Mem}', "");
    Expect(1, 68311, '\p{^Joining_Group=_ Manichaean_Mem}', "");
    Expect(1, 68311, '\P{Joining_Group=_ Manichaean_Mem}', "");
    Expect(0, 68311, '\P{^Joining_Group=_ Manichaean_Mem}', "");
    Error('\p{Jg=_/a/manichaean_Mem}');
    Error('\P{Jg=_/a/manichaean_Mem}');
    Expect(1, 68310, '\p{Jg=:\AManichaean_Mem\z:}', "");;
    Expect(0, 68311, '\p{Jg=:\AManichaean_Mem\z:}', "");;
    Expect(1, 68310, '\p{Jg=manichaeanmem}', "");
    Expect(0, 68310, '\p{^Jg=manichaeanmem}', "");
    Expect(0, 68310, '\P{Jg=manichaeanmem}', "");
    Expect(1, 68310, '\P{^Jg=manichaeanmem}', "");
    Expect(0, 68311, '\p{Jg=manichaeanmem}', "");
    Expect(1, 68311, '\p{^Jg=manichaeanmem}', "");
    Expect(1, 68311, '\P{Jg=manichaeanmem}', "");
    Expect(0, 68311, '\P{^Jg=manichaeanmem}', "");
    Expect(1, 68310, '\p{Jg=:\Amanichaeanmem\z:}', "");;
    Expect(0, 68311, '\p{Jg=:\Amanichaeanmem\z:}', "");;
    Expect(1, 68310, '\p{Jg=-manichaean_MEM}', "");
    Expect(0, 68310, '\p{^Jg=-manichaean_MEM}', "");
    Expect(0, 68310, '\P{Jg=-manichaean_MEM}', "");
    Expect(1, 68310, '\P{^Jg=-manichaean_MEM}', "");
    Expect(0, 68311, '\p{Jg=-manichaean_MEM}', "");
    Expect(1, 68311, '\p{^Jg=-manichaean_MEM}', "");
    Expect(1, 68311, '\P{Jg=-manichaean_MEM}', "");
    Expect(0, 68311, '\P{^Jg=-manichaean_MEM}', "");
    Error('\p{Is_Joining_Group: /a/	Manichaean_Mem}');
    Error('\P{Is_Joining_Group: /a/	Manichaean_Mem}');
    Expect(1, 68310, '\p{Is_Joining_Group:   manichaeanmem}', "");
    Expect(0, 68310, '\p{^Is_Joining_Group:   manichaeanmem}', "");
    Expect(0, 68310, '\P{Is_Joining_Group:   manichaeanmem}', "");
    Expect(1, 68310, '\P{^Is_Joining_Group:   manichaeanmem}', "");
    Expect(0, 68311, '\p{Is_Joining_Group:   manichaeanmem}', "");
    Expect(1, 68311, '\p{^Is_Joining_Group:   manichaeanmem}', "");
    Expect(1, 68311, '\P{Is_Joining_Group:   manichaeanmem}', "");
    Expect(0, 68311, '\P{^Is_Joining_Group:   manichaeanmem}', "");
    Expect(1, 68310, '\p{Is_Joining_Group=_manichaean_Mem}', "");
    Expect(0, 68310, '\p{^Is_Joining_Group=_manichaean_Mem}', "");
    Expect(0, 68310, '\P{Is_Joining_Group=_manichaean_Mem}', "");
    Expect(1, 68310, '\P{^Is_Joining_Group=_manichaean_Mem}', "");
    Expect(0, 68311, '\p{Is_Joining_Group=_manichaean_Mem}', "");
    Expect(1, 68311, '\p{^Is_Joining_Group=_manichaean_Mem}', "");
    Expect(1, 68311, '\P{Is_Joining_Group=_manichaean_Mem}', "");
    Expect(0, 68311, '\P{^Is_Joining_Group=_manichaean_Mem}', "");
    Error('\p{Is_Jg= /a/Manichaean_Mem}');
    Error('\P{Is_Jg= /a/Manichaean_Mem}');
    Expect(1, 68310, '\p{Is_Jg=manichaeanmem}', "");
    Expect(0, 68310, '\p{^Is_Jg=manichaeanmem}', "");
    Expect(0, 68310, '\P{Is_Jg=manichaeanmem}', "");
    Expect(1, 68310, '\P{^Is_Jg=manichaeanmem}', "");
    Expect(0, 68311, '\p{Is_Jg=manichaeanmem}', "");
    Expect(1, 68311, '\p{^Is_Jg=manichaeanmem}', "");
    Expect(1, 68311, '\P{Is_Jg=manichaeanmem}', "");
    Expect(0, 68311, '\P{^Is_Jg=manichaeanmem}', "");
    Expect(1, 68310, '\p{Is_Jg=_-MANICHAEAN_Mem}', "");
    Expect(0, 68310, '\p{^Is_Jg=_-MANICHAEAN_Mem}', "");
    Expect(0, 68310, '\P{Is_Jg=_-MANICHAEAN_Mem}', "");
    Expect(1, 68310, '\P{^Is_Jg=_-MANICHAEAN_Mem}', "");
    Expect(0, 68311, '\p{Is_Jg=_-MANICHAEAN_Mem}', "");
    Expect(1, 68311, '\p{^Is_Jg=_-MANICHAEAN_Mem}', "");
    Expect(1, 68311, '\P{Is_Jg=_-MANICHAEAN_Mem}', "");
    Expect(0, 68311, '\P{^Is_Jg=_-MANICHAEAN_Mem}', "");
    Error('\p{Joining_Group=	/a/MANICHAEAN_Nun}');
    Error('\P{Joining_Group=	/a/MANICHAEAN_Nun}');
    Expect(1, 68311, '\p{Joining_Group=:\AManichaean_Nun\z:}', "");;
    Expect(0, 68312, '\p{Joining_Group=:\AManichaean_Nun\z:}', "");;
    Expect(1, 68311, '\p{Joining_Group=manichaeannun}', "");
    Expect(0, 68311, '\p{^Joining_Group=manichaeannun}', "");
    Expect(0, 68311, '\P{Joining_Group=manichaeannun}', "");
    Expect(1, 68311, '\P{^Joining_Group=manichaeannun}', "");
    Expect(0, 68312, '\p{Joining_Group=manichaeannun}', "");
    Expect(1, 68312, '\p{^Joining_Group=manichaeannun}', "");
    Expect(1, 68312, '\P{Joining_Group=manichaeannun}', "");
    Expect(0, 68312, '\P{^Joining_Group=manichaeannun}', "");
    Expect(1, 68311, '\p{Joining_Group=:\Amanichaeannun\z:}', "");;
    Expect(0, 68312, '\p{Joining_Group=:\Amanichaeannun\z:}', "");;
    Expect(1, 68311, '\p{Joining_Group=	MANICHAEAN_NUN}', "");
    Expect(0, 68311, '\p{^Joining_Group=	MANICHAEAN_NUN}', "");
    Expect(0, 68311, '\P{Joining_Group=	MANICHAEAN_NUN}', "");
    Expect(1, 68311, '\P{^Joining_Group=	MANICHAEAN_NUN}', "");
    Expect(0, 68312, '\p{Joining_Group=	MANICHAEAN_NUN}', "");
    Expect(1, 68312, '\p{^Joining_Group=	MANICHAEAN_NUN}', "");
    Expect(1, 68312, '\P{Joining_Group=	MANICHAEAN_NUN}', "");
    Expect(0, 68312, '\P{^Joining_Group=	MANICHAEAN_NUN}', "");
    Error('\p{Jg:    /a/Manichaean_nun}');
    Error('\P{Jg:    /a/Manichaean_nun}');
    Expect(1, 68311, '\p{Jg=:\AManichaean_Nun\z:}', "");;
    Expect(0, 68312, '\p{Jg=:\AManichaean_Nun\z:}', "");;
    Expect(1, 68311, '\p{Jg=manichaeannun}', "");
    Expect(0, 68311, '\p{^Jg=manichaeannun}', "");
    Expect(0, 68311, '\P{Jg=manichaeannun}', "");
    Expect(1, 68311, '\P{^Jg=manichaeannun}', "");
    Expect(0, 68312, '\p{Jg=manichaeannun}', "");
    Expect(1, 68312, '\p{^Jg=manichaeannun}', "");
    Expect(1, 68312, '\P{Jg=manichaeannun}', "");
    Expect(0, 68312, '\P{^Jg=manichaeannun}', "");
    Expect(1, 68311, '\p{Jg=:\Amanichaeannun\z:}', "");;
    Expect(0, 68312, '\p{Jg=:\Amanichaeannun\z:}', "");;
    Expect(1, 68311, '\p{Jg=		Manichaean_NUN}', "");
    Expect(0, 68311, '\p{^Jg=		Manichaean_NUN}', "");
    Expect(0, 68311, '\P{Jg=		Manichaean_NUN}', "");
    Expect(1, 68311, '\P{^Jg=		Manichaean_NUN}', "");
    Expect(0, 68312, '\p{Jg=		Manichaean_NUN}', "");
    Expect(1, 68312, '\p{^Jg=		Manichaean_NUN}', "");
    Expect(1, 68312, '\P{Jg=		Manichaean_NUN}', "");
    Expect(0, 68312, '\P{^Jg=		Manichaean_NUN}', "");
    Error('\p{Is_Joining_Group=_-Manichaean_Nun/a/}');
    Error('\P{Is_Joining_Group=_-Manichaean_Nun/a/}');
    Expect(1, 68311, '\p{Is_Joining_Group=manichaeannun}', "");
    Expect(0, 68311, '\p{^Is_Joining_Group=manichaeannun}', "");
    Expect(0, 68311, '\P{Is_Joining_Group=manichaeannun}', "");
    Expect(1, 68311, '\P{^Is_Joining_Group=manichaeannun}', "");
    Expect(0, 68312, '\p{Is_Joining_Group=manichaeannun}', "");
    Expect(1, 68312, '\p{^Is_Joining_Group=manichaeannun}', "");
    Expect(1, 68312, '\P{Is_Joining_Group=manichaeannun}', "");
    Expect(0, 68312, '\P{^Is_Joining_Group=manichaeannun}', "");
    Expect(1, 68311, '\p{Is_Joining_Group=_MANICHAEAN_Nun}', "");
    Expect(0, 68311, '\p{^Is_Joining_Group=_MANICHAEAN_Nun}', "");
    Expect(0, 68311, '\P{Is_Joining_Group=_MANICHAEAN_Nun}', "");
    Expect(1, 68311, '\P{^Is_Joining_Group=_MANICHAEAN_Nun}', "");
    Expect(0, 68312, '\p{Is_Joining_Group=_MANICHAEAN_Nun}', "");
    Expect(1, 68312, '\p{^Is_Joining_Group=_MANICHAEAN_Nun}', "");
    Expect(1, 68312, '\P{Is_Joining_Group=_MANICHAEAN_Nun}', "");
    Expect(0, 68312, '\P{^Is_Joining_Group=_MANICHAEAN_Nun}', "");
    Error('\p{Is_Jg=/a/ -Manichaean_Nun}');
    Error('\P{Is_Jg=/a/ -Manichaean_Nun}');
    Expect(1, 68311, '\p{Is_Jg=manichaeannun}', "");
    Expect(0, 68311, '\p{^Is_Jg=manichaeannun}', "");
    Expect(0, 68311, '\P{Is_Jg=manichaeannun}', "");
    Expect(1, 68311, '\P{^Is_Jg=manichaeannun}', "");
    Expect(0, 68312, '\p{Is_Jg=manichaeannun}', "");
    Expect(1, 68312, '\p{^Is_Jg=manichaeannun}', "");
    Expect(1, 68312, '\P{Is_Jg=manichaeannun}', "");
    Expect(0, 68312, '\P{^Is_Jg=manichaeannun}', "");
    Expect(1, 68311, '\p{Is_Jg:   _ Manichaean_Nun}', "");
    Expect(0, 68311, '\p{^Is_Jg:   _ Manichaean_Nun}', "");
    Expect(0, 68311, '\P{Is_Jg:   _ Manichaean_Nun}', "");
    Expect(1, 68311, '\P{^Is_Jg:   _ Manichaean_Nun}', "");
    Expect(0, 68312, '\p{Is_Jg:   _ Manichaean_Nun}', "");
    Expect(1, 68312, '\p{^Is_Jg:   _ Manichaean_Nun}', "");
    Expect(1, 68312, '\P{Is_Jg:   _ Manichaean_Nun}', "");
    Expect(0, 68312, '\P{^Is_Jg:   _ Manichaean_Nun}', "");
    Error('\p{Joining_Group= /a/Manichaean_One}');
    Error('\P{Joining_Group= /a/Manichaean_One}');
    Expect(1, 68331, '\p{Joining_Group=:\AManichaean_One\z:}', "");;
    Expect(0, 68332, '\p{Joining_Group=:\AManichaean_One\z:}', "");;
    Expect(1, 68331, '\p{Joining_Group=manichaeanone}', "");
    Expect(0, 68331, '\p{^Joining_Group=manichaeanone}', "");
    Expect(0, 68331, '\P{Joining_Group=manichaeanone}', "");
    Expect(1, 68331, '\P{^Joining_Group=manichaeanone}', "");
    Expect(0, 68332, '\p{Joining_Group=manichaeanone}', "");
    Expect(1, 68332, '\p{^Joining_Group=manichaeanone}', "");
    Expect(1, 68332, '\P{Joining_Group=manichaeanone}', "");
    Expect(0, 68332, '\P{^Joining_Group=manichaeanone}', "");
    Expect(1, 68331, '\p{Joining_Group=:\Amanichaeanone\z:}', "");;
    Expect(0, 68332, '\p{Joining_Group=:\Amanichaeanone\z:}', "");;
    Expect(1, 68331, '\p{Joining_Group= MANICHAEAN_One}', "");
    Expect(0, 68331, '\p{^Joining_Group= MANICHAEAN_One}', "");
    Expect(0, 68331, '\P{Joining_Group= MANICHAEAN_One}', "");
    Expect(1, 68331, '\P{^Joining_Group= MANICHAEAN_One}', "");
    Expect(0, 68332, '\p{Joining_Group= MANICHAEAN_One}', "");
    Expect(1, 68332, '\p{^Joining_Group= MANICHAEAN_One}', "");
    Expect(1, 68332, '\P{Joining_Group= MANICHAEAN_One}', "");
    Expect(0, 68332, '\P{^Joining_Group= MANICHAEAN_One}', "");
    Error('\p{Jg=:= _Manichaean_one}');
    Error('\P{Jg=:= _Manichaean_one}');
    Expect(1, 68331, '\p{Jg=:\AManichaean_One\z:}', "");;
    Expect(0, 68332, '\p{Jg=:\AManichaean_One\z:}', "");;
    Expect(1, 68331, '\p{Jg=manichaeanone}', "");
    Expect(0, 68331, '\p{^Jg=manichaeanone}', "");
    Expect(0, 68331, '\P{Jg=manichaeanone}', "");
    Expect(1, 68331, '\P{^Jg=manichaeanone}', "");
    Expect(0, 68332, '\p{Jg=manichaeanone}', "");
    Expect(1, 68332, '\p{^Jg=manichaeanone}', "");
    Expect(1, 68332, '\P{Jg=manichaeanone}', "");
    Expect(0, 68332, '\P{^Jg=manichaeanone}', "");
    Expect(1, 68331, '\p{Jg=:\Amanichaeanone\z:}', "");;
    Expect(0, 68332, '\p{Jg=:\Amanichaeanone\z:}', "");;
    Expect(1, 68331, '\p{Jg= 	manichaean_One}', "");
    Expect(0, 68331, '\p{^Jg= 	manichaean_One}', "");
    Expect(0, 68331, '\P{Jg= 	manichaean_One}', "");
    Expect(1, 68331, '\P{^Jg= 	manichaean_One}', "");
    Expect(0, 68332, '\p{Jg= 	manichaean_One}', "");
    Expect(1, 68332, '\p{^Jg= 	manichaean_One}', "");
    Expect(1, 68332, '\P{Jg= 	manichaean_One}', "");
    Expect(0, 68332, '\P{^Jg= 	manichaean_One}', "");
    Error('\p{Is_Joining_Group=	:=manichaean_One}');
    Error('\P{Is_Joining_Group=	:=manichaean_One}');
    Expect(1, 68331, '\p{Is_Joining_Group=manichaeanone}', "");
    Expect(0, 68331, '\p{^Is_Joining_Group=manichaeanone}', "");
    Expect(0, 68331, '\P{Is_Joining_Group=manichaeanone}', "");
    Expect(1, 68331, '\P{^Is_Joining_Group=manichaeanone}', "");
    Expect(0, 68332, '\p{Is_Joining_Group=manichaeanone}', "");
    Expect(1, 68332, '\p{^Is_Joining_Group=manichaeanone}', "");
    Expect(1, 68332, '\P{Is_Joining_Group=manichaeanone}', "");
    Expect(0, 68332, '\P{^Is_Joining_Group=manichaeanone}', "");
    Expect(1, 68331, '\p{Is_Joining_Group= -Manichaean_one}', "");
    Expect(0, 68331, '\p{^Is_Joining_Group= -Manichaean_one}', "");
    Expect(0, 68331, '\P{Is_Joining_Group= -Manichaean_one}', "");
    Expect(1, 68331, '\P{^Is_Joining_Group= -Manichaean_one}', "");
    Expect(0, 68332, '\p{Is_Joining_Group= -Manichaean_one}', "");
    Expect(1, 68332, '\p{^Is_Joining_Group= -Manichaean_one}', "");
    Expect(1, 68332, '\P{Is_Joining_Group= -Manichaean_one}', "");
    Expect(0, 68332, '\P{^Is_Joining_Group= -Manichaean_one}', "");
    Error('\p{Is_Jg=- manichaean_ONE/a/}');
    Error('\P{Is_Jg=- manichaean_ONE/a/}');
    Expect(1, 68331, '\p{Is_Jg=manichaeanone}', "");
    Expect(0, 68331, '\p{^Is_Jg=manichaeanone}', "");
    Expect(0, 68331, '\P{Is_Jg=manichaeanone}', "");
    Expect(1, 68331, '\P{^Is_Jg=manichaeanone}', "");
    Expect(0, 68332, '\p{Is_Jg=manichaeanone}', "");
    Expect(1, 68332, '\p{^Is_Jg=manichaeanone}', "");
    Expect(1, 68332, '\P{Is_Jg=manichaeanone}', "");
    Expect(0, 68332, '\P{^Is_Jg=manichaeanone}', "");
    Expect(1, 68331, '\p{Is_Jg=	 MANICHAEAN_One}', "");
    Expect(0, 68331, '\p{^Is_Jg=	 MANICHAEAN_One}', "");
    Expect(0, 68331, '\P{Is_Jg=	 MANICHAEAN_One}', "");
    Expect(1, 68331, '\P{^Is_Jg=	 MANICHAEAN_One}', "");
    Expect(0, 68332, '\p{Is_Jg=	 MANICHAEAN_One}', "");
    Expect(1, 68332, '\p{^Is_Jg=	 MANICHAEAN_One}', "");
    Expect(1, 68332, '\P{Is_Jg=	 MANICHAEAN_One}', "");
    Expect(0, 68332, '\P{^Is_Jg=	 MANICHAEAN_One}', "");
    Error('\p{Joining_Group= /a/Manichaean_Pe}');
    Error('\P{Joining_Group= /a/Manichaean_Pe}');
    Expect(1, 68316, '\p{Joining_Group=:\AManichaean_Pe\z:}', "");;
    Expect(0, 68317, '\p{Joining_Group=:\AManichaean_Pe\z:}', "");;
    Expect(1, 68316, '\p{Joining_Group=manichaeanpe}', "");
    Expect(0, 68316, '\p{^Joining_Group=manichaeanpe}', "");
    Expect(0, 68316, '\P{Joining_Group=manichaeanpe}', "");
    Expect(1, 68316, '\P{^Joining_Group=manichaeanpe}', "");
    Expect(0, 68317, '\p{Joining_Group=manichaeanpe}', "");
    Expect(1, 68317, '\p{^Joining_Group=manichaeanpe}', "");
    Expect(1, 68317, '\P{Joining_Group=manichaeanpe}', "");
    Expect(0, 68317, '\P{^Joining_Group=manichaeanpe}', "");
    Expect(1, 68316, '\p{Joining_Group=:\Amanichaeanpe\z:}', "");;
    Expect(0, 68317, '\p{Joining_Group=:\Amanichaeanpe\z:}', "");;
    Expect(1, 68316, '\p{Joining_Group=_ MANICHAEAN_Pe}', "");
    Expect(0, 68316, '\p{^Joining_Group=_ MANICHAEAN_Pe}', "");
    Expect(0, 68316, '\P{Joining_Group=_ MANICHAEAN_Pe}', "");
    Expect(1, 68316, '\P{^Joining_Group=_ MANICHAEAN_Pe}', "");
    Expect(0, 68317, '\p{Joining_Group=_ MANICHAEAN_Pe}', "");
    Expect(1, 68317, '\p{^Joining_Group=_ MANICHAEAN_Pe}', "");
    Expect(1, 68317, '\P{Joining_Group=_ MANICHAEAN_Pe}', "");
    Expect(0, 68317, '\P{^Joining_Group=_ MANICHAEAN_Pe}', "");
    Error('\p{Jg=_manichaean_PE:=}');
    Error('\P{Jg=_manichaean_PE:=}');
    Expect(1, 68316, '\p{Jg=:\AManichaean_Pe\z:}', "");;
    Expect(0, 68317, '\p{Jg=:\AManichaean_Pe\z:}', "");;
    Expect(1, 68316, '\p{Jg=manichaeanpe}', "");
    Expect(0, 68316, '\p{^Jg=manichaeanpe}', "");
    Expect(0, 68316, '\P{Jg=manichaeanpe}', "");
    Expect(1, 68316, '\P{^Jg=manichaeanpe}', "");
    Expect(0, 68317, '\p{Jg=manichaeanpe}', "");
    Expect(1, 68317, '\p{^Jg=manichaeanpe}', "");
    Expect(1, 68317, '\P{Jg=manichaeanpe}', "");
    Expect(0, 68317, '\P{^Jg=manichaeanpe}', "");
    Expect(1, 68316, '\p{Jg=:\Amanichaeanpe\z:}', "");;
    Expect(0, 68317, '\p{Jg=:\Amanichaeanpe\z:}', "");;
    Expect(1, 68316, '\p{Jg=_ Manichaean_Pe}', "");
    Expect(0, 68316, '\p{^Jg=_ Manichaean_Pe}', "");
    Expect(0, 68316, '\P{Jg=_ Manichaean_Pe}', "");
    Expect(1, 68316, '\P{^Jg=_ Manichaean_Pe}', "");
    Expect(0, 68317, '\p{Jg=_ Manichaean_Pe}', "");
    Expect(1, 68317, '\p{^Jg=_ Manichaean_Pe}', "");
    Expect(1, 68317, '\P{Jg=_ Manichaean_Pe}', "");
    Expect(0, 68317, '\P{^Jg=_ Manichaean_Pe}', "");
    Error('\p{Is_Joining_Group=	:=Manichaean_PE}');
    Error('\P{Is_Joining_Group=	:=Manichaean_PE}');
    Expect(1, 68316, '\p{Is_Joining_Group=manichaeanpe}', "");
    Expect(0, 68316, '\p{^Is_Joining_Group=manichaeanpe}', "");
    Expect(0, 68316, '\P{Is_Joining_Group=manichaeanpe}', "");
    Expect(1, 68316, '\P{^Is_Joining_Group=manichaeanpe}', "");
    Expect(0, 68317, '\p{Is_Joining_Group=manichaeanpe}', "");
    Expect(1, 68317, '\p{^Is_Joining_Group=manichaeanpe}', "");
    Expect(1, 68317, '\P{Is_Joining_Group=manichaeanpe}', "");
    Expect(0, 68317, '\P{^Is_Joining_Group=manichaeanpe}', "");
    Expect(1, 68316, '\p{Is_Joining_Group=_-Manichaean_pe}', "");
    Expect(0, 68316, '\p{^Is_Joining_Group=_-Manichaean_pe}', "");
    Expect(0, 68316, '\P{Is_Joining_Group=_-Manichaean_pe}', "");
    Expect(1, 68316, '\P{^Is_Joining_Group=_-Manichaean_pe}', "");
    Expect(0, 68317, '\p{Is_Joining_Group=_-Manichaean_pe}', "");
    Expect(1, 68317, '\p{^Is_Joining_Group=_-Manichaean_pe}', "");
    Expect(1, 68317, '\P{Is_Joining_Group=_-Manichaean_pe}', "");
    Expect(0, 68317, '\P{^Is_Joining_Group=_-Manichaean_pe}', "");
    Error('\p{Is_Jg=/a/Manichaean_Pe}');
    Error('\P{Is_Jg=/a/Manichaean_Pe}');
    Expect(1, 68316, '\p{Is_Jg=manichaeanpe}', "");
    Expect(0, 68316, '\p{^Is_Jg=manichaeanpe}', "");
    Expect(0, 68316, '\P{Is_Jg=manichaeanpe}', "");
    Expect(1, 68316, '\P{^Is_Jg=manichaeanpe}', "");
    Expect(0, 68317, '\p{Is_Jg=manichaeanpe}', "");
    Expect(1, 68317, '\p{^Is_Jg=manichaeanpe}', "");
    Expect(1, 68317, '\P{Is_Jg=manichaeanpe}', "");
    Expect(0, 68317, '\P{^Is_Jg=manichaeanpe}', "");
    Expect(1, 68316, '\p{Is_Jg=- MANICHAEAN_PE}', "");
    Expect(0, 68316, '\p{^Is_Jg=- MANICHAEAN_PE}', "");
    Expect(0, 68316, '\P{Is_Jg=- MANICHAEAN_PE}', "");
    Expect(1, 68316, '\P{^Is_Jg=- MANICHAEAN_PE}', "");
    Expect(0, 68317, '\p{Is_Jg=- MANICHAEAN_PE}', "");
    Expect(1, 68317, '\p{^Is_Jg=- MANICHAEAN_PE}', "");
    Expect(1, 68317, '\P{Is_Jg=- MANICHAEAN_PE}', "");
    Expect(0, 68317, '\P{^Is_Jg=- MANICHAEAN_PE}', "");
    Error('\p{Joining_Group=_/a/MANICHAEAN_QOPH}');
    Error('\P{Joining_Group=_/a/MANICHAEAN_QOPH}');
    Expect(1, 68320, '\p{Joining_Group=:\AManichaean_Qoph\z:}', "");;
    Expect(0, 68321, '\p{Joining_Group=:\AManichaean_Qoph\z:}', "");;
    Expect(1, 68320, '\p{Joining_Group:	manichaeanqoph}', "");
    Expect(0, 68320, '\p{^Joining_Group:	manichaeanqoph}', "");
    Expect(0, 68320, '\P{Joining_Group:	manichaeanqoph}', "");
    Expect(1, 68320, '\P{^Joining_Group:	manichaeanqoph}', "");
    Expect(0, 68321, '\p{Joining_Group:	manichaeanqoph}', "");
    Expect(1, 68321, '\p{^Joining_Group:	manichaeanqoph}', "");
    Expect(1, 68321, '\P{Joining_Group:	manichaeanqoph}', "");
    Expect(0, 68321, '\P{^Joining_Group:	manichaeanqoph}', "");
    Expect(1, 68320, '\p{Joining_Group=:\Amanichaeanqoph\z:}', "");;
    Expect(0, 68321, '\p{Joining_Group=:\Amanichaeanqoph\z:}', "");;
    Expect(1, 68320, '\p{Joining_Group=-	manichaean_Qoph}', "");
    Expect(0, 68320, '\p{^Joining_Group=-	manichaean_Qoph}', "");
    Expect(0, 68320, '\P{Joining_Group=-	manichaean_Qoph}', "");
    Expect(1, 68320, '\P{^Joining_Group=-	manichaean_Qoph}', "");
    Expect(0, 68321, '\p{Joining_Group=-	manichaean_Qoph}', "");
    Expect(1, 68321, '\p{^Joining_Group=-	manichaean_Qoph}', "");
    Expect(1, 68321, '\P{Joining_Group=-	manichaean_Qoph}', "");
    Expect(0, 68321, '\P{^Joining_Group=-	manichaean_Qoph}', "");
    Error('\p{Jg=/a/  MANICHAEAN_QOPH}');
    Error('\P{Jg=/a/  MANICHAEAN_QOPH}');
    Expect(1, 68320, '\p{Jg=:\AManichaean_Qoph\z:}', "");;
    Expect(0, 68321, '\p{Jg=:\AManichaean_Qoph\z:}', "");;
    Expect(1, 68320, '\p{Jg=manichaeanqoph}', "");
    Expect(0, 68320, '\p{^Jg=manichaeanqoph}', "");
    Expect(0, 68320, '\P{Jg=manichaeanqoph}', "");
    Expect(1, 68320, '\P{^Jg=manichaeanqoph}', "");
    Expect(0, 68321, '\p{Jg=manichaeanqoph}', "");
    Expect(1, 68321, '\p{^Jg=manichaeanqoph}', "");
    Expect(1, 68321, '\P{Jg=manichaeanqoph}', "");
    Expect(0, 68321, '\P{^Jg=manichaeanqoph}', "");
    Expect(1, 68320, '\p{Jg=:\Amanichaeanqoph\z:}', "");;
    Expect(0, 68321, '\p{Jg=:\Amanichaeanqoph\z:}', "");;
    Expect(1, 68320, '\p{Jg=	Manichaean_Qoph}', "");
    Expect(0, 68320, '\p{^Jg=	Manichaean_Qoph}', "");
    Expect(0, 68320, '\P{Jg=	Manichaean_Qoph}', "");
    Expect(1, 68320, '\P{^Jg=	Manichaean_Qoph}', "");
    Expect(0, 68321, '\p{Jg=	Manichaean_Qoph}', "");
    Expect(1, 68321, '\p{^Jg=	Manichaean_Qoph}', "");
    Expect(1, 68321, '\P{Jg=	Manichaean_Qoph}', "");
    Expect(0, 68321, '\P{^Jg=	Manichaean_Qoph}', "");
    Error('\p{Is_Joining_Group=/a/_ Manichaean_QOPH}');
    Error('\P{Is_Joining_Group=/a/_ Manichaean_QOPH}');
    Expect(1, 68320, '\p{Is_Joining_Group:manichaeanqoph}', "");
    Expect(0, 68320, '\p{^Is_Joining_Group:manichaeanqoph}', "");
    Expect(0, 68320, '\P{Is_Joining_Group:manichaeanqoph}', "");
    Expect(1, 68320, '\P{^Is_Joining_Group:manichaeanqoph}', "");
    Expect(0, 68321, '\p{Is_Joining_Group:manichaeanqoph}', "");
    Expect(1, 68321, '\p{^Is_Joining_Group:manichaeanqoph}', "");
    Expect(1, 68321, '\P{Is_Joining_Group:manichaeanqoph}', "");
    Expect(0, 68321, '\P{^Is_Joining_Group:manichaeanqoph}', "");
    Expect(1, 68320, '\p{Is_Joining_Group=__MANICHAEAN_Qoph}', "");
    Expect(0, 68320, '\p{^Is_Joining_Group=__MANICHAEAN_Qoph}', "");
    Expect(0, 68320, '\P{Is_Joining_Group=__MANICHAEAN_Qoph}', "");
    Expect(1, 68320, '\P{^Is_Joining_Group=__MANICHAEAN_Qoph}', "");
    Expect(0, 68321, '\p{Is_Joining_Group=__MANICHAEAN_Qoph}', "");
    Expect(1, 68321, '\p{^Is_Joining_Group=__MANICHAEAN_Qoph}', "");
    Expect(1, 68321, '\P{Is_Joining_Group=__MANICHAEAN_Qoph}', "");
    Expect(0, 68321, '\P{^Is_Joining_Group=__MANICHAEAN_Qoph}', "");
    Error('\p{Is_Jg= MANICHAEAN_Qoph/a/}');
    Error('\P{Is_Jg= MANICHAEAN_Qoph/a/}');
    Expect(1, 68320, '\p{Is_Jg=manichaeanqoph}', "");
    Expect(0, 68320, '\p{^Is_Jg=manichaeanqoph}', "");
    Expect(0, 68320, '\P{Is_Jg=manichaeanqoph}', "");
    Expect(1, 68320, '\P{^Is_Jg=manichaeanqoph}', "");
    Expect(0, 68321, '\p{Is_Jg=manichaeanqoph}', "");
    Expect(1, 68321, '\p{^Is_Jg=manichaeanqoph}', "");
    Expect(1, 68321, '\P{Is_Jg=manichaeanqoph}', "");
    Expect(0, 68321, '\P{^Is_Jg=manichaeanqoph}', "");
    Expect(1, 68320, '\p{Is_Jg=		Manichaean_Qoph}', "");
    Expect(0, 68320, '\p{^Is_Jg=		Manichaean_Qoph}', "");
    Expect(0, 68320, '\P{Is_Jg=		Manichaean_Qoph}', "");
    Expect(1, 68320, '\P{^Is_Jg=		Manichaean_Qoph}', "");
    Expect(0, 68321, '\p{Is_Jg=		Manichaean_Qoph}', "");
    Expect(1, 68321, '\p{^Is_Jg=		Manichaean_Qoph}', "");
    Expect(1, 68321, '\P{Is_Jg=		Manichaean_Qoph}', "");
    Expect(0, 68321, '\P{^Is_Jg=		Manichaean_Qoph}', "");
    Error('\p{Joining_Group:--MANICHAEAN_resh/a/}');
    Error('\P{Joining_Group:--MANICHAEAN_resh/a/}');
    Expect(1, 68321, '\p{Joining_Group=:\AManichaean_Resh\z:}', "");;
    Expect(0, 68322, '\p{Joining_Group=:\AManichaean_Resh\z:}', "");;
    Expect(1, 68321, '\p{Joining_Group=manichaeanresh}', "");
    Expect(0, 68321, '\p{^Joining_Group=manichaeanresh}', "");
    Expect(0, 68321, '\P{Joining_Group=manichaeanresh}', "");
    Expect(1, 68321, '\P{^Joining_Group=manichaeanresh}', "");
    Expect(0, 68322, '\p{Joining_Group=manichaeanresh}', "");
    Expect(1, 68322, '\p{^Joining_Group=manichaeanresh}', "");
    Expect(1, 68322, '\P{Joining_Group=manichaeanresh}', "");
    Expect(0, 68322, '\P{^Joining_Group=manichaeanresh}', "");
    Expect(1, 68321, '\p{Joining_Group=:\Amanichaeanresh\z:}', "");;
    Expect(0, 68322, '\p{Joining_Group=:\Amanichaeanresh\z:}', "");;
    Expect(1, 68321, '\p{Joining_Group: - manichaean_resh}', "");
    Expect(0, 68321, '\p{^Joining_Group: - manichaean_resh}', "");
    Expect(0, 68321, '\P{Joining_Group: - manichaean_resh}', "");
    Expect(1, 68321, '\P{^Joining_Group: - manichaean_resh}', "");
    Expect(0, 68322, '\p{Joining_Group: - manichaean_resh}', "");
    Expect(1, 68322, '\p{^Joining_Group: - manichaean_resh}', "");
    Expect(1, 68322, '\P{Joining_Group: - manichaean_resh}', "");
    Expect(0, 68322, '\P{^Joining_Group: - manichaean_resh}', "");
    Error('\p{Jg=:=__Manichaean_resh}');
    Error('\P{Jg=:=__Manichaean_resh}');
    Expect(1, 68321, '\p{Jg=:\AManichaean_Resh\z:}', "");;
    Expect(0, 68322, '\p{Jg=:\AManichaean_Resh\z:}', "");;
    Expect(1, 68321, '\p{Jg=manichaeanresh}', "");
    Expect(0, 68321, '\p{^Jg=manichaeanresh}', "");
    Expect(0, 68321, '\P{Jg=manichaeanresh}', "");
    Expect(1, 68321, '\P{^Jg=manichaeanresh}', "");
    Expect(0, 68322, '\p{Jg=manichaeanresh}', "");
    Expect(1, 68322, '\p{^Jg=manichaeanresh}', "");
    Expect(1, 68322, '\P{Jg=manichaeanresh}', "");
    Expect(0, 68322, '\P{^Jg=manichaeanresh}', "");
    Expect(1, 68321, '\p{Jg=:\Amanichaeanresh\z:}', "");;
    Expect(0, 68322, '\p{Jg=:\Amanichaeanresh\z:}', "");;
    Expect(1, 68321, '\p{Jg=	manichaean_RESH}', "");
    Expect(0, 68321, '\p{^Jg=	manichaean_RESH}', "");
    Expect(0, 68321, '\P{Jg=	manichaean_RESH}', "");
    Expect(1, 68321, '\P{^Jg=	manichaean_RESH}', "");
    Expect(0, 68322, '\p{Jg=	manichaean_RESH}', "");
    Expect(1, 68322, '\p{^Jg=	manichaean_RESH}', "");
    Expect(1, 68322, '\P{Jg=	manichaean_RESH}', "");
    Expect(0, 68322, '\P{^Jg=	manichaean_RESH}', "");
    Error('\p{Is_Joining_Group=- manichaean_Resh:=}');
    Error('\P{Is_Joining_Group=- manichaean_Resh:=}');
    Expect(1, 68321, '\p{Is_Joining_Group:   manichaeanresh}', "");
    Expect(0, 68321, '\p{^Is_Joining_Group:   manichaeanresh}', "");
    Expect(0, 68321, '\P{Is_Joining_Group:   manichaeanresh}', "");
    Expect(1, 68321, '\P{^Is_Joining_Group:   manichaeanresh}', "");
    Expect(0, 68322, '\p{Is_Joining_Group:   manichaeanresh}', "");
    Expect(1, 68322, '\p{^Is_Joining_Group:   manichaeanresh}', "");
    Expect(1, 68322, '\P{Is_Joining_Group:   manichaeanresh}', "");
    Expect(0, 68322, '\P{^Is_Joining_Group:   manichaeanresh}', "");
    Expect(1, 68321, '\p{Is_Joining_Group=	_Manichaean_resh}', "");
    Expect(0, 68321, '\p{^Is_Joining_Group=	_Manichaean_resh}', "");
    Expect(0, 68321, '\P{Is_Joining_Group=	_Manichaean_resh}', "");
    Expect(1, 68321, '\P{^Is_Joining_Group=	_Manichaean_resh}', "");
    Expect(0, 68322, '\p{Is_Joining_Group=	_Manichaean_resh}', "");
    Expect(1, 68322, '\p{^Is_Joining_Group=	_Manichaean_resh}', "");
    Expect(1, 68322, '\P{Is_Joining_Group=	_Manichaean_resh}', "");
    Expect(0, 68322, '\P{^Is_Joining_Group=	_Manichaean_resh}', "");
    Error('\p{Is_Jg=_:=MANICHAEAN_Resh}');
    Error('\P{Is_Jg=_:=MANICHAEAN_Resh}');
    Expect(1, 68321, '\p{Is_Jg=manichaeanresh}', "");
    Expect(0, 68321, '\p{^Is_Jg=manichaeanresh}', "");
    Expect(0, 68321, '\P{Is_Jg=manichaeanresh}', "");
    Expect(1, 68321, '\P{^Is_Jg=manichaeanresh}', "");
    Expect(0, 68322, '\p{Is_Jg=manichaeanresh}', "");
    Expect(1, 68322, '\p{^Is_Jg=manichaeanresh}', "");
    Expect(1, 68322, '\P{Is_Jg=manichaeanresh}', "");
    Expect(0, 68322, '\P{^Is_Jg=manichaeanresh}', "");
    Expect(1, 68321, '\p{Is_Jg=		Manichaean_resh}', "");
    Expect(0, 68321, '\p{^Is_Jg=		Manichaean_resh}', "");
    Expect(0, 68321, '\P{Is_Jg=		Manichaean_resh}', "");
    Expect(1, 68321, '\P{^Is_Jg=		Manichaean_resh}', "");
    Expect(0, 68322, '\p{Is_Jg=		Manichaean_resh}', "");
    Expect(1, 68322, '\p{^Is_Jg=		Manichaean_resh}', "");
    Expect(1, 68322, '\P{Is_Jg=		Manichaean_resh}', "");
    Expect(0, 68322, '\P{^Is_Jg=		Manichaean_resh}', "");
    Error('\p{Joining_Group=/a/ -Manichaean_Sadhe}');
    Error('\P{Joining_Group=/a/ -Manichaean_Sadhe}');
    Expect(1, 68317, '\p{Joining_Group=:\AManichaean_Sadhe\z:}', "");;
    Expect(0, 68318, '\p{Joining_Group=:\AManichaean_Sadhe\z:}', "");;
    Expect(1, 68317, '\p{Joining_Group=manichaeansadhe}', "");
    Expect(0, 68317, '\p{^Joining_Group=manichaeansadhe}', "");
    Expect(0, 68317, '\P{Joining_Group=manichaeansadhe}', "");
    Expect(1, 68317, '\P{^Joining_Group=manichaeansadhe}', "");
    Expect(0, 68318, '\p{Joining_Group=manichaeansadhe}', "");
    Expect(1, 68318, '\p{^Joining_Group=manichaeansadhe}', "");
    Expect(1, 68318, '\P{Joining_Group=manichaeansadhe}', "");
    Expect(0, 68318, '\P{^Joining_Group=manichaeansadhe}', "");
    Expect(1, 68317, '\p{Joining_Group=:\Amanichaeansadhe\z:}', "");;
    Expect(0, 68318, '\p{Joining_Group=:\Amanichaeansadhe\z:}', "");;
    Expect(1, 68317, '\p{Joining_Group=_ MANICHAEAN_Sadhe}', "");
    Expect(0, 68317, '\p{^Joining_Group=_ MANICHAEAN_Sadhe}', "");
    Expect(0, 68317, '\P{Joining_Group=_ MANICHAEAN_Sadhe}', "");
    Expect(1, 68317, '\P{^Joining_Group=_ MANICHAEAN_Sadhe}', "");
    Expect(0, 68318, '\p{Joining_Group=_ MANICHAEAN_Sadhe}', "");
    Expect(1, 68318, '\p{^Joining_Group=_ MANICHAEAN_Sadhe}', "");
    Expect(1, 68318, '\P{Joining_Group=_ MANICHAEAN_Sadhe}', "");
    Expect(0, 68318, '\P{^Joining_Group=_ MANICHAEAN_Sadhe}', "");
    Error('\p{Jg= _Manichaean_SADHE/a/}');
    Error('\P{Jg= _Manichaean_SADHE/a/}');
    Expect(1, 68317, '\p{Jg=:\AManichaean_Sadhe\z:}', "");;
    Expect(0, 68318, '\p{Jg=:\AManichaean_Sadhe\z:}', "");;
    Expect(1, 68317, '\p{Jg=manichaeansadhe}', "");
    Expect(0, 68317, '\p{^Jg=manichaeansadhe}', "");
    Expect(0, 68317, '\P{Jg=manichaeansadhe}', "");
    Expect(1, 68317, '\P{^Jg=manichaeansadhe}', "");
    Expect(0, 68318, '\p{Jg=manichaeansadhe}', "");
    Expect(1, 68318, '\p{^Jg=manichaeansadhe}', "");
    Expect(1, 68318, '\P{Jg=manichaeansadhe}', "");
    Expect(0, 68318, '\P{^Jg=manichaeansadhe}', "");
    Expect(1, 68317, '\p{Jg=:\Amanichaeansadhe\z:}', "");;
    Expect(0, 68318, '\p{Jg=:\Amanichaeansadhe\z:}', "");;
    Expect(1, 68317, '\p{Jg=manichaean_Sadhe}', "");
    Expect(0, 68317, '\p{^Jg=manichaean_Sadhe}', "");
    Expect(0, 68317, '\P{Jg=manichaean_Sadhe}', "");
    Expect(1, 68317, '\P{^Jg=manichaean_Sadhe}', "");
    Expect(0, 68318, '\p{Jg=manichaean_Sadhe}', "");
    Expect(1, 68318, '\p{^Jg=manichaean_Sadhe}', "");
    Expect(1, 68318, '\P{Jg=manichaean_Sadhe}', "");
    Expect(0, 68318, '\P{^Jg=manichaean_Sadhe}', "");
    Error('\p{Is_Joining_Group=-manichaean_SADHE:=}');
    Error('\P{Is_Joining_Group=-manichaean_SADHE:=}');
    Expect(1, 68317, '\p{Is_Joining_Group=manichaeansadhe}', "");
    Expect(0, 68317, '\p{^Is_Joining_Group=manichaeansadhe}', "");
    Expect(0, 68317, '\P{Is_Joining_Group=manichaeansadhe}', "");
    Expect(1, 68317, '\P{^Is_Joining_Group=manichaeansadhe}', "");
    Expect(0, 68318, '\p{Is_Joining_Group=manichaeansadhe}', "");
    Expect(1, 68318, '\p{^Is_Joining_Group=manichaeansadhe}', "");
    Expect(1, 68318, '\P{Is_Joining_Group=manichaeansadhe}', "");
    Expect(0, 68318, '\P{^Is_Joining_Group=manichaeansadhe}', "");
    Expect(1, 68317, '\p{Is_Joining_Group=  manichaean_sadhe}', "");
    Expect(0, 68317, '\p{^Is_Joining_Group=  manichaean_sadhe}', "");
    Expect(0, 68317, '\P{Is_Joining_Group=  manichaean_sadhe}', "");
    Expect(1, 68317, '\P{^Is_Joining_Group=  manichaean_sadhe}', "");
    Expect(0, 68318, '\p{Is_Joining_Group=  manichaean_sadhe}', "");
    Expect(1, 68318, '\p{^Is_Joining_Group=  manichaean_sadhe}', "");
    Expect(1, 68318, '\P{Is_Joining_Group=  manichaean_sadhe}', "");
    Expect(0, 68318, '\P{^Is_Joining_Group=  manichaean_sadhe}', "");
    Error('\p{Is_Jg=:=-	Manichaean_SADHE}');
    Error('\P{Is_Jg=:=-	Manichaean_SADHE}');
    Expect(1, 68317, '\p{Is_Jg=manichaeansadhe}', "");
    Expect(0, 68317, '\p{^Is_Jg=manichaeansadhe}', "");
    Expect(0, 68317, '\P{Is_Jg=manichaeansadhe}', "");
    Expect(1, 68317, '\P{^Is_Jg=manichaeansadhe}', "");
    Expect(0, 68318, '\p{Is_Jg=manichaeansadhe}', "");
    Expect(1, 68318, '\p{^Is_Jg=manichaeansadhe}', "");
    Expect(1, 68318, '\P{Is_Jg=manichaeansadhe}', "");
    Expect(0, 68318, '\P{^Is_Jg=manichaeansadhe}', "");
    Expect(1, 68317, '\p{Is_Jg=_	Manichaean_Sadhe}', "");
    Expect(0, 68317, '\p{^Is_Jg=_	Manichaean_Sadhe}', "");
    Expect(0, 68317, '\P{Is_Jg=_	Manichaean_Sadhe}', "");
    Expect(1, 68317, '\P{^Is_Jg=_	Manichaean_Sadhe}', "");
    Expect(0, 68318, '\p{Is_Jg=_	Manichaean_Sadhe}', "");
    Expect(1, 68318, '\p{^Is_Jg=_	Manichaean_Sadhe}', "");
    Expect(1, 68318, '\P{Is_Jg=_	Manichaean_Sadhe}', "");
    Expect(0, 68318, '\P{^Is_Jg=_	Manichaean_Sadhe}', "");
    Error('\p{Joining_Group=/a/Manichaean_Samekh}');
    Error('\P{Joining_Group=/a/Manichaean_Samekh}');
    Expect(1, 68312, '\p{Joining_Group=:\AManichaean_Samekh\z:}', "");;
    Expect(0, 68313, '\p{Joining_Group=:\AManichaean_Samekh\z:}', "");;
    Expect(1, 68312, '\p{Joining_Group=manichaeansamekh}', "");
    Expect(0, 68312, '\p{^Joining_Group=manichaeansamekh}', "");
    Expect(0, 68312, '\P{Joining_Group=manichaeansamekh}', "");
    Expect(1, 68312, '\P{^Joining_Group=manichaeansamekh}', "");
    Expect(0, 68313, '\p{Joining_Group=manichaeansamekh}', "");
    Expect(1, 68313, '\p{^Joining_Group=manichaeansamekh}', "");
    Expect(1, 68313, '\P{Joining_Group=manichaeansamekh}', "");
    Expect(0, 68313, '\P{^Joining_Group=manichaeansamekh}', "");
    Expect(1, 68312, '\p{Joining_Group=:\Amanichaeansamekh\z:}', "");;
    Expect(0, 68313, '\p{Joining_Group=:\Amanichaeansamekh\z:}', "");;
    Expect(1, 68312, '\p{Joining_Group=Manichaean_SAMEKH}', "");
    Expect(0, 68312, '\p{^Joining_Group=Manichaean_SAMEKH}', "");
    Expect(0, 68312, '\P{Joining_Group=Manichaean_SAMEKH}', "");
    Expect(1, 68312, '\P{^Joining_Group=Manichaean_SAMEKH}', "");
    Expect(0, 68313, '\p{Joining_Group=Manichaean_SAMEKH}', "");
    Expect(1, 68313, '\p{^Joining_Group=Manichaean_SAMEKH}', "");
    Expect(1, 68313, '\P{Joining_Group=Manichaean_SAMEKH}', "");
    Expect(0, 68313, '\P{^Joining_Group=Manichaean_SAMEKH}', "");
    Error('\p{Jg=	/a/MANICHAEAN_SAMEKH}');
    Error('\P{Jg=	/a/MANICHAEAN_SAMEKH}');
    Expect(1, 68312, '\p{Jg=:\AManichaean_Samekh\z:}', "");;
    Expect(0, 68313, '\p{Jg=:\AManichaean_Samekh\z:}', "");;
    Expect(1, 68312, '\p{Jg=manichaeansamekh}', "");
    Expect(0, 68312, '\p{^Jg=manichaeansamekh}', "");
    Expect(0, 68312, '\P{Jg=manichaeansamekh}', "");
    Expect(1, 68312, '\P{^Jg=manichaeansamekh}', "");
    Expect(0, 68313, '\p{Jg=manichaeansamekh}', "");
    Expect(1, 68313, '\p{^Jg=manichaeansamekh}', "");
    Expect(1, 68313, '\P{Jg=manichaeansamekh}', "");
    Expect(0, 68313, '\P{^Jg=manichaeansamekh}', "");
    Expect(1, 68312, '\p{Jg=:\Amanichaeansamekh\z:}', "");;
    Expect(0, 68313, '\p{Jg=:\Amanichaeansamekh\z:}', "");;
    Expect(1, 68312, '\p{Jg= -Manichaean_Samekh}', "");
    Expect(0, 68312, '\p{^Jg= -Manichaean_Samekh}', "");
    Expect(0, 68312, '\P{Jg= -Manichaean_Samekh}', "");
    Expect(1, 68312, '\P{^Jg= -Manichaean_Samekh}', "");
    Expect(0, 68313, '\p{Jg= -Manichaean_Samekh}', "");
    Expect(1, 68313, '\p{^Jg= -Manichaean_Samekh}', "");
    Expect(1, 68313, '\P{Jg= -Manichaean_Samekh}', "");
    Expect(0, 68313, '\P{^Jg= -Manichaean_Samekh}', "");
    Error('\p{Is_Joining_Group=/a/ Manichaean_Samekh}');
    Error('\P{Is_Joining_Group=/a/ Manichaean_Samekh}');
    Expect(1, 68312, '\p{Is_Joining_Group=manichaeansamekh}', "");
    Expect(0, 68312, '\p{^Is_Joining_Group=manichaeansamekh}', "");
    Expect(0, 68312, '\P{Is_Joining_Group=manichaeansamekh}', "");
    Expect(1, 68312, '\P{^Is_Joining_Group=manichaeansamekh}', "");
    Expect(0, 68313, '\p{Is_Joining_Group=manichaeansamekh}', "");
    Expect(1, 68313, '\p{^Is_Joining_Group=manichaeansamekh}', "");
    Expect(1, 68313, '\P{Is_Joining_Group=manichaeansamekh}', "");
    Expect(0, 68313, '\P{^Is_Joining_Group=manichaeansamekh}', "");
    Expect(1, 68312, '\p{Is_Joining_Group=__manichaean_Samekh}', "");
    Expect(0, 68312, '\p{^Is_Joining_Group=__manichaean_Samekh}', "");
    Expect(0, 68312, '\P{Is_Joining_Group=__manichaean_Samekh}', "");
    Expect(1, 68312, '\P{^Is_Joining_Group=__manichaean_Samekh}', "");
    Expect(0, 68313, '\p{Is_Joining_Group=__manichaean_Samekh}', "");
    Expect(1, 68313, '\p{^Is_Joining_Group=__manichaean_Samekh}', "");
    Expect(1, 68313, '\P{Is_Joining_Group=__manichaean_Samekh}', "");
    Expect(0, 68313, '\P{^Is_Joining_Group=__manichaean_Samekh}', "");
    Error('\p{Is_Jg= /a/Manichaean_samekh}');
    Error('\P{Is_Jg= /a/Manichaean_samekh}');
    Expect(1, 68312, '\p{Is_Jg=manichaeansamekh}', "");
    Expect(0, 68312, '\p{^Is_Jg=manichaeansamekh}', "");
    Expect(0, 68312, '\P{Is_Jg=manichaeansamekh}', "");
    Expect(1, 68312, '\P{^Is_Jg=manichaeansamekh}', "");
    Expect(0, 68313, '\p{Is_Jg=manichaeansamekh}', "");
    Expect(1, 68313, '\p{^Is_Jg=manichaeansamekh}', "");
    Expect(1, 68313, '\P{Is_Jg=manichaeansamekh}', "");
    Expect(0, 68313, '\P{^Is_Jg=manichaeansamekh}', "");
    Expect(1, 68312, '\p{Is_Jg= manichaean_Samekh}', "");
    Expect(0, 68312, '\p{^Is_Jg= manichaean_Samekh}', "");
    Expect(0, 68312, '\P{Is_Jg= manichaean_Samekh}', "");
    Expect(1, 68312, '\P{^Is_Jg= manichaean_Samekh}', "");
    Expect(0, 68313, '\p{Is_Jg= manichaean_Samekh}', "");
    Expect(1, 68313, '\p{^Is_Jg= manichaean_Samekh}', "");
    Expect(1, 68313, '\P{Is_Jg= manichaean_Samekh}', "");
    Expect(0, 68313, '\P{^Is_Jg= manichaean_Samekh}', "");
    Error('\p{Joining_Group=/a/	MANICHAEAN_Taw}');
    Error('\P{Joining_Group=/a/	MANICHAEAN_Taw}');
    Expect(1, 68324, '\p{Joining_Group=:\AManichaean_Taw\z:}', "");;
    Expect(0, 68325, '\p{Joining_Group=:\AManichaean_Taw\z:}', "");;
    Expect(1, 68324, '\p{Joining_Group=manichaeantaw}', "");
    Expect(0, 68324, '\p{^Joining_Group=manichaeantaw}', "");
    Expect(0, 68324, '\P{Joining_Group=manichaeantaw}', "");
    Expect(1, 68324, '\P{^Joining_Group=manichaeantaw}', "");
    Expect(0, 68325, '\p{Joining_Group=manichaeantaw}', "");
    Expect(1, 68325, '\p{^Joining_Group=manichaeantaw}', "");
    Expect(1, 68325, '\P{Joining_Group=manichaeantaw}', "");
    Expect(0, 68325, '\P{^Joining_Group=manichaeantaw}', "");
    Expect(1, 68324, '\p{Joining_Group=:\Amanichaeantaw\z:}', "");;
    Expect(0, 68325, '\p{Joining_Group=:\Amanichaeantaw\z:}', "");;
    Expect(1, 68324, '\p{Joining_Group=-manichaean_Taw}', "");
    Expect(0, 68324, '\p{^Joining_Group=-manichaean_Taw}', "");
    Expect(0, 68324, '\P{Joining_Group=-manichaean_Taw}', "");
    Expect(1, 68324, '\P{^Joining_Group=-manichaean_Taw}', "");
    Expect(0, 68325, '\p{Joining_Group=-manichaean_Taw}', "");
    Expect(1, 68325, '\p{^Joining_Group=-manichaean_Taw}', "");
    Expect(1, 68325, '\P{Joining_Group=-manichaean_Taw}', "");
    Expect(0, 68325, '\P{^Joining_Group=-manichaean_Taw}', "");
    Error('\p{Jg=		manichaean_taw/a/}');
    Error('\P{Jg=		manichaean_taw/a/}');
    Expect(1, 68324, '\p{Jg=:\AManichaean_Taw\z:}', "");;
    Expect(0, 68325, '\p{Jg=:\AManichaean_Taw\z:}', "");;
    Expect(1, 68324, '\p{Jg=manichaeantaw}', "");
    Expect(0, 68324, '\p{^Jg=manichaeantaw}', "");
    Expect(0, 68324, '\P{Jg=manichaeantaw}', "");
    Expect(1, 68324, '\P{^Jg=manichaeantaw}', "");
    Expect(0, 68325, '\p{Jg=manichaeantaw}', "");
    Expect(1, 68325, '\p{^Jg=manichaeantaw}', "");
    Expect(1, 68325, '\P{Jg=manichaeantaw}', "");
    Expect(0, 68325, '\P{^Jg=manichaeantaw}', "");
    Expect(1, 68324, '\p{Jg=:\Amanichaeantaw\z:}', "");;
    Expect(0, 68325, '\p{Jg=:\Amanichaeantaw\z:}', "");;
    Expect(1, 68324, '\p{Jg=	-Manichaean_Taw}', "");
    Expect(0, 68324, '\p{^Jg=	-Manichaean_Taw}', "");
    Expect(0, 68324, '\P{Jg=	-Manichaean_Taw}', "");
    Expect(1, 68324, '\P{^Jg=	-Manichaean_Taw}', "");
    Expect(0, 68325, '\p{Jg=	-Manichaean_Taw}', "");
    Expect(1, 68325, '\p{^Jg=	-Manichaean_Taw}', "");
    Expect(1, 68325, '\P{Jg=	-Manichaean_Taw}', "");
    Expect(0, 68325, '\P{^Jg=	-Manichaean_Taw}', "");
    Error('\p{Is_Joining_Group=/a/MANICHAEAN_Taw}');
    Error('\P{Is_Joining_Group=/a/MANICHAEAN_Taw}');
    Expect(1, 68324, '\p{Is_Joining_Group=manichaeantaw}', "");
    Expect(0, 68324, '\p{^Is_Joining_Group=manichaeantaw}', "");
    Expect(0, 68324, '\P{Is_Joining_Group=manichaeantaw}', "");
    Expect(1, 68324, '\P{^Is_Joining_Group=manichaeantaw}', "");
    Expect(0, 68325, '\p{Is_Joining_Group=manichaeantaw}', "");
    Expect(1, 68325, '\p{^Is_Joining_Group=manichaeantaw}', "");
    Expect(1, 68325, '\P{Is_Joining_Group=manichaeantaw}', "");
    Expect(0, 68325, '\P{^Is_Joining_Group=manichaeantaw}', "");
    Expect(1, 68324, '\p{Is_Joining_Group=_-Manichaean_TAW}', "");
    Expect(0, 68324, '\p{^Is_Joining_Group=_-Manichaean_TAW}', "");
    Expect(0, 68324, '\P{Is_Joining_Group=_-Manichaean_TAW}', "");
    Expect(1, 68324, '\P{^Is_Joining_Group=_-Manichaean_TAW}', "");
    Expect(0, 68325, '\p{Is_Joining_Group=_-Manichaean_TAW}', "");
    Expect(1, 68325, '\p{^Is_Joining_Group=_-Manichaean_TAW}', "");
    Expect(1, 68325, '\P{Is_Joining_Group=_-Manichaean_TAW}', "");
    Expect(0, 68325, '\P{^Is_Joining_Group=_-Manichaean_TAW}', "");
    Error('\p{Is_Jg=-:=manichaean_Taw}');
    Error('\P{Is_Jg=-:=manichaean_Taw}');
    Expect(1, 68324, '\p{Is_Jg:manichaeantaw}', "");
    Expect(0, 68324, '\p{^Is_Jg:manichaeantaw}', "");
    Expect(0, 68324, '\P{Is_Jg:manichaeantaw}', "");
    Expect(1, 68324, '\P{^Is_Jg:manichaeantaw}', "");
    Expect(0, 68325, '\p{Is_Jg:manichaeantaw}', "");
    Expect(1, 68325, '\p{^Is_Jg:manichaeantaw}', "");
    Expect(1, 68325, '\P{Is_Jg:manichaeantaw}', "");
    Expect(0, 68325, '\P{^Is_Jg:manichaeantaw}', "");
    Expect(1, 68324, '\p{Is_Jg= 	Manichaean_taw}', "");
    Expect(0, 68324, '\p{^Is_Jg= 	Manichaean_taw}', "");
    Expect(0, 68324, '\P{Is_Jg= 	Manichaean_taw}', "");
    Expect(1, 68324, '\P{^Is_Jg= 	Manichaean_taw}', "");
    Expect(0, 68325, '\p{Is_Jg= 	Manichaean_taw}', "");
    Expect(1, 68325, '\p{^Is_Jg= 	Manichaean_taw}', "");
    Expect(1, 68325, '\P{Is_Jg= 	Manichaean_taw}', "");
    Expect(0, 68325, '\P{^Is_Jg= 	Manichaean_taw}', "");
    Error('\p{Joining_Group= :=Manichaean_Ten}');
    Error('\P{Joining_Group= :=Manichaean_Ten}');
    Expect(1, 68333, '\p{Joining_Group=:\AManichaean_Ten\z:}', "");;
    Expect(0, 68334, '\p{Joining_Group=:\AManichaean_Ten\z:}', "");;
    Expect(1, 68333, '\p{Joining_Group: manichaeanten}', "");
    Expect(0, 68333, '\p{^Joining_Group: manichaeanten}', "");
    Expect(0, 68333, '\P{Joining_Group: manichaeanten}', "");
    Expect(1, 68333, '\P{^Joining_Group: manichaeanten}', "");
    Expect(0, 68334, '\p{Joining_Group: manichaeanten}', "");
    Expect(1, 68334, '\p{^Joining_Group: manichaeanten}', "");
    Expect(1, 68334, '\P{Joining_Group: manichaeanten}', "");
    Expect(0, 68334, '\P{^Joining_Group: manichaeanten}', "");
    Expect(1, 68333, '\p{Joining_Group=:\Amanichaeanten\z:}', "");;
    Expect(0, 68334, '\p{Joining_Group=:\Amanichaeanten\z:}', "");;
    Expect(1, 68333, '\p{Joining_Group:  Manichaean_ten}', "");
    Expect(0, 68333, '\p{^Joining_Group:  Manichaean_ten}', "");
    Expect(0, 68333, '\P{Joining_Group:  Manichaean_ten}', "");
    Expect(1, 68333, '\P{^Joining_Group:  Manichaean_ten}', "");
    Expect(0, 68334, '\p{Joining_Group:  Manichaean_ten}', "");
    Expect(1, 68334, '\p{^Joining_Group:  Manichaean_ten}', "");
    Expect(1, 68334, '\P{Joining_Group:  Manichaean_ten}', "");
    Expect(0, 68334, '\P{^Joining_Group:  Manichaean_ten}', "");
    Error('\p{Jg= Manichaean_Ten/a/}');
    Error('\P{Jg= Manichaean_Ten/a/}');
    Expect(1, 68333, '\p{Jg=:\AManichaean_Ten\z:}', "");;
    Expect(0, 68334, '\p{Jg=:\AManichaean_Ten\z:}', "");;
    Expect(1, 68333, '\p{Jg=manichaeanten}', "");
    Expect(0, 68333, '\p{^Jg=manichaeanten}', "");
    Expect(0, 68333, '\P{Jg=manichaeanten}', "");
    Expect(1, 68333, '\P{^Jg=manichaeanten}', "");
    Expect(0, 68334, '\p{Jg=manichaeanten}', "");
    Expect(1, 68334, '\p{^Jg=manichaeanten}', "");
    Expect(1, 68334, '\P{Jg=manichaeanten}', "");
    Expect(0, 68334, '\P{^Jg=manichaeanten}', "");
    Expect(1, 68333, '\p{Jg=:\Amanichaeanten\z:}', "");;
    Expect(0, 68334, '\p{Jg=:\Amanichaeanten\z:}', "");;
    Expect(1, 68333, '\p{Jg=Manichaean_TEN}', "");
    Expect(0, 68333, '\p{^Jg=Manichaean_TEN}', "");
    Expect(0, 68333, '\P{Jg=Manichaean_TEN}', "");
    Expect(1, 68333, '\P{^Jg=Manichaean_TEN}', "");
    Expect(0, 68334, '\p{Jg=Manichaean_TEN}', "");
    Expect(1, 68334, '\p{^Jg=Manichaean_TEN}', "");
    Expect(1, 68334, '\P{Jg=Manichaean_TEN}', "");
    Expect(0, 68334, '\P{^Jg=Manichaean_TEN}', "");
    Error('\p{Is_Joining_Group= /a/Manichaean_Ten}');
    Error('\P{Is_Joining_Group= /a/Manichaean_Ten}');
    Expect(1, 68333, '\p{Is_Joining_Group=manichaeanten}', "");
    Expect(0, 68333, '\p{^Is_Joining_Group=manichaeanten}', "");
    Expect(0, 68333, '\P{Is_Joining_Group=manichaeanten}', "");
    Expect(1, 68333, '\P{^Is_Joining_Group=manichaeanten}', "");
    Expect(0, 68334, '\p{Is_Joining_Group=manichaeanten}', "");
    Expect(1, 68334, '\p{^Is_Joining_Group=manichaeanten}', "");
    Expect(1, 68334, '\P{Is_Joining_Group=manichaeanten}', "");
    Expect(0, 68334, '\P{^Is_Joining_Group=manichaeanten}', "");
    Expect(1, 68333, '\p{Is_Joining_Group= -manichaean_TEN}', "");
    Expect(0, 68333, '\p{^Is_Joining_Group= -manichaean_TEN}', "");
    Expect(0, 68333, '\P{Is_Joining_Group= -manichaean_TEN}', "");
    Expect(1, 68333, '\P{^Is_Joining_Group= -manichaean_TEN}', "");
    Expect(0, 68334, '\p{Is_Joining_Group= -manichaean_TEN}', "");
    Expect(1, 68334, '\p{^Is_Joining_Group= -manichaean_TEN}', "");
    Expect(1, 68334, '\P{Is_Joining_Group= -manichaean_TEN}', "");
    Expect(0, 68334, '\P{^Is_Joining_Group= -manichaean_TEN}', "");
    Error('\p{Is_Jg=:=  Manichaean_TEN}');
    Error('\P{Is_Jg=:=  Manichaean_TEN}');
    Expect(1, 68333, '\p{Is_Jg=manichaeanten}', "");
    Expect(0, 68333, '\p{^Is_Jg=manichaeanten}', "");
    Expect(0, 68333, '\P{Is_Jg=manichaeanten}', "");
    Expect(1, 68333, '\P{^Is_Jg=manichaeanten}', "");
    Expect(0, 68334, '\p{Is_Jg=manichaeanten}', "");
    Expect(1, 68334, '\p{^Is_Jg=manichaeanten}', "");
    Expect(1, 68334, '\P{Is_Jg=manichaeanten}', "");
    Expect(0, 68334, '\P{^Is_Jg=manichaeanten}', "");
    Expect(1, 68333, '\p{Is_Jg= _manichaean_ten}', "");
    Expect(0, 68333, '\p{^Is_Jg= _manichaean_ten}', "");
    Expect(0, 68333, '\P{Is_Jg= _manichaean_ten}', "");
    Expect(1, 68333, '\P{^Is_Jg= _manichaean_ten}', "");
    Expect(0, 68334, '\p{Is_Jg= _manichaean_ten}', "");
    Expect(1, 68334, '\p{^Is_Jg= _manichaean_ten}', "");
    Expect(1, 68334, '\P{Is_Jg= _manichaean_ten}', "");
    Expect(0, 68334, '\P{^Is_Jg= _manichaean_ten}', "");
    Error('\p{Joining_Group=/a/-_Manichaean_Teth}');
    Error('\P{Joining_Group=/a/-_Manichaean_Teth}');
    Expect(1, 68302, '\p{Joining_Group=:\AManichaean_Teth\z:}', "");;
    Expect(0, 68303, '\p{Joining_Group=:\AManichaean_Teth\z:}', "");;
    Expect(1, 68302, '\p{Joining_Group=manichaeanteth}', "");
    Expect(0, 68302, '\p{^Joining_Group=manichaeanteth}', "");
    Expect(0, 68302, '\P{Joining_Group=manichaeanteth}', "");
    Expect(1, 68302, '\P{^Joining_Group=manichaeanteth}', "");
    Expect(0, 68303, '\p{Joining_Group=manichaeanteth}', "");
    Expect(1, 68303, '\p{^Joining_Group=manichaeanteth}', "");
    Expect(1, 68303, '\P{Joining_Group=manichaeanteth}', "");
    Expect(0, 68303, '\P{^Joining_Group=manichaeanteth}', "");
    Expect(1, 68302, '\p{Joining_Group=:\Amanichaeanteth\z:}', "");;
    Expect(0, 68303, '\p{Joining_Group=:\Amanichaeanteth\z:}', "");;
    Expect(1, 68302, '\p{Joining_Group=_Manichaean_TETH}', "");
    Expect(0, 68302, '\p{^Joining_Group=_Manichaean_TETH}', "");
    Expect(0, 68302, '\P{Joining_Group=_Manichaean_TETH}', "");
    Expect(1, 68302, '\P{^Joining_Group=_Manichaean_TETH}', "");
    Expect(0, 68303, '\p{Joining_Group=_Manichaean_TETH}', "");
    Expect(1, 68303, '\p{^Joining_Group=_Manichaean_TETH}', "");
    Expect(1, 68303, '\P{Joining_Group=_Manichaean_TETH}', "");
    Expect(0, 68303, '\P{^Joining_Group=_Manichaean_TETH}', "");
    Error('\p{Jg=/a/ _MANICHAEAN_Teth}');
    Error('\P{Jg=/a/ _MANICHAEAN_Teth}');
    Expect(1, 68302, '\p{Jg=:\AManichaean_Teth\z:}', "");;
    Expect(0, 68303, '\p{Jg=:\AManichaean_Teth\z:}', "");;
    Expect(1, 68302, '\p{Jg=manichaeanteth}', "");
    Expect(0, 68302, '\p{^Jg=manichaeanteth}', "");
    Expect(0, 68302, '\P{Jg=manichaeanteth}', "");
    Expect(1, 68302, '\P{^Jg=manichaeanteth}', "");
    Expect(0, 68303, '\p{Jg=manichaeanteth}', "");
    Expect(1, 68303, '\p{^Jg=manichaeanteth}', "");
    Expect(1, 68303, '\P{Jg=manichaeanteth}', "");
    Expect(0, 68303, '\P{^Jg=manichaeanteth}', "");
    Expect(1, 68302, '\p{Jg=:\Amanichaeanteth\z:}', "");;
    Expect(0, 68303, '\p{Jg=:\Amanichaeanteth\z:}', "");;
    Expect(1, 68302, '\p{Jg: - manichaean_teth}', "");
    Expect(0, 68302, '\p{^Jg: - manichaean_teth}', "");
    Expect(0, 68302, '\P{Jg: - manichaean_teth}', "");
    Expect(1, 68302, '\P{^Jg: - manichaean_teth}', "");
    Expect(0, 68303, '\p{Jg: - manichaean_teth}', "");
    Expect(1, 68303, '\p{^Jg: - manichaean_teth}', "");
    Expect(1, 68303, '\P{Jg: - manichaean_teth}', "");
    Expect(0, 68303, '\P{^Jg: - manichaean_teth}', "");
    Error('\p{Is_Joining_Group=	:=Manichaean_TETH}');
    Error('\P{Is_Joining_Group=	:=Manichaean_TETH}');
    Expect(1, 68302, '\p{Is_Joining_Group=manichaeanteth}', "");
    Expect(0, 68302, '\p{^Is_Joining_Group=manichaeanteth}', "");
    Expect(0, 68302, '\P{Is_Joining_Group=manichaeanteth}', "");
    Expect(1, 68302, '\P{^Is_Joining_Group=manichaeanteth}', "");
    Expect(0, 68303, '\p{Is_Joining_Group=manichaeanteth}', "");
    Expect(1, 68303, '\p{^Is_Joining_Group=manichaeanteth}', "");
    Expect(1, 68303, '\P{Is_Joining_Group=manichaeanteth}', "");
    Expect(0, 68303, '\P{^Is_Joining_Group=manichaeanteth}', "");
    Expect(1, 68302, '\p{Is_Joining_Group=	-Manichaean_TETH}', "");
    Expect(0, 68302, '\p{^Is_Joining_Group=	-Manichaean_TETH}', "");
    Expect(0, 68302, '\P{Is_Joining_Group=	-Manichaean_TETH}', "");
    Expect(1, 68302, '\P{^Is_Joining_Group=	-Manichaean_TETH}', "");
    Expect(0, 68303, '\p{Is_Joining_Group=	-Manichaean_TETH}', "");
    Expect(1, 68303, '\p{^Is_Joining_Group=	-Manichaean_TETH}', "");
    Expect(1, 68303, '\P{Is_Joining_Group=	-Manichaean_TETH}', "");
    Expect(0, 68303, '\P{^Is_Joining_Group=	-Manichaean_TETH}', "");
    Error('\p{Is_Jg=/a/ _manichaean_TETH}');
    Error('\P{Is_Jg=/a/ _manichaean_TETH}');
    Expect(1, 68302, '\p{Is_Jg=manichaeanteth}', "");
    Expect(0, 68302, '\p{^Is_Jg=manichaeanteth}', "");
    Expect(0, 68302, '\P{Is_Jg=manichaeanteth}', "");
    Expect(1, 68302, '\P{^Is_Jg=manichaeanteth}', "");
    Expect(0, 68303, '\p{Is_Jg=manichaeanteth}', "");
    Expect(1, 68303, '\p{^Is_Jg=manichaeanteth}', "");
    Expect(1, 68303, '\P{Is_Jg=manichaeanteth}', "");
    Expect(0, 68303, '\P{^Is_Jg=manichaeanteth}', "");
    Expect(1, 68302, '\p{Is_Jg= _Manichaean_Teth}', "");
    Expect(0, 68302, '\p{^Is_Jg= _Manichaean_Teth}', "");
    Expect(0, 68302, '\P{Is_Jg= _Manichaean_Teth}', "");
    Expect(1, 68302, '\P{^Is_Jg= _Manichaean_Teth}', "");
    Expect(0, 68303, '\p{Is_Jg= _Manichaean_Teth}', "");
    Expect(1, 68303, '\p{^Is_Jg= _Manichaean_Teth}', "");
    Expect(1, 68303, '\P{Is_Jg= _Manichaean_Teth}', "");
    Expect(0, 68303, '\P{^Is_Jg= _Manichaean_Teth}', "");
    Error('\p{Joining_Group=:=-_MANICHAEAN_Thamedh}');
    Error('\P{Joining_Group=:=-_MANICHAEAN_Thamedh}');
    Expect(1, 68309, '\p{Joining_Group=:\AManichaean_Thamedh\z:}', "");;
    Expect(0, 68310, '\p{Joining_Group=:\AManichaean_Thamedh\z:}', "");;
    Expect(1, 68309, '\p{Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68309, '\p{^Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68309, '\P{Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68309, '\P{^Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68310, '\p{Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68310, '\p{^Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68310, '\P{Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68310, '\P{^Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68309, '\p{Joining_Group=:\Amanichaeanthamedh\z:}', "");;
    Expect(0, 68310, '\p{Joining_Group=:\Amanichaeanthamedh\z:}', "");;
    Expect(1, 68309, '\p{Joining_Group:	-manichaean_Thamedh}', "");
    Expect(0, 68309, '\p{^Joining_Group:	-manichaean_Thamedh}', "");
    Expect(0, 68309, '\P{Joining_Group:	-manichaean_Thamedh}', "");
    Expect(1, 68309, '\P{^Joining_Group:	-manichaean_Thamedh}', "");
    Expect(0, 68310, '\p{Joining_Group:	-manichaean_Thamedh}', "");
    Expect(1, 68310, '\p{^Joining_Group:	-manichaean_Thamedh}', "");
    Expect(1, 68310, '\P{Joining_Group:	-manichaean_Thamedh}', "");
    Expect(0, 68310, '\P{^Joining_Group:	-manichaean_Thamedh}', "");
    Error('\p{Jg: -:=manichaean_Thamedh}');
    Error('\P{Jg: -:=manichaean_Thamedh}');
    Expect(1, 68309, '\p{Jg=:\AManichaean_Thamedh\z:}', "");;
    Expect(0, 68310, '\p{Jg=:\AManichaean_Thamedh\z:}', "");;
    Expect(1, 68309, '\p{Jg=manichaeanthamedh}', "");
    Expect(0, 68309, '\p{^Jg=manichaeanthamedh}', "");
    Expect(0, 68309, '\P{Jg=manichaeanthamedh}', "");
    Expect(1, 68309, '\P{^Jg=manichaeanthamedh}', "");
    Expect(0, 68310, '\p{Jg=manichaeanthamedh}', "");
    Expect(1, 68310, '\p{^Jg=manichaeanthamedh}', "");
    Expect(1, 68310, '\P{Jg=manichaeanthamedh}', "");
    Expect(0, 68310, '\P{^Jg=manichaeanthamedh}', "");
    Expect(1, 68309, '\p{Jg=:\Amanichaeanthamedh\z:}', "");;
    Expect(0, 68310, '\p{Jg=:\Amanichaeanthamedh\z:}', "");;
    Expect(1, 68309, '\p{Jg= 	MANICHAEAN_Thamedh}', "");
    Expect(0, 68309, '\p{^Jg= 	MANICHAEAN_Thamedh}', "");
    Expect(0, 68309, '\P{Jg= 	MANICHAEAN_Thamedh}', "");
    Expect(1, 68309, '\P{^Jg= 	MANICHAEAN_Thamedh}', "");
    Expect(0, 68310, '\p{Jg= 	MANICHAEAN_Thamedh}', "");
    Expect(1, 68310, '\p{^Jg= 	MANICHAEAN_Thamedh}', "");
    Expect(1, 68310, '\P{Jg= 	MANICHAEAN_Thamedh}', "");
    Expect(0, 68310, '\P{^Jg= 	MANICHAEAN_Thamedh}', "");
    Error('\p{Is_Joining_Group:/a/ -Manichaean_thamedh}');
    Error('\P{Is_Joining_Group:/a/ -Manichaean_thamedh}');
    Expect(1, 68309, '\p{Is_Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68309, '\p{^Is_Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68309, '\P{Is_Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68309, '\P{^Is_Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68310, '\p{Is_Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68310, '\p{^Is_Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68310, '\P{Is_Joining_Group=manichaeanthamedh}', "");
    Expect(0, 68310, '\P{^Is_Joining_Group=manichaeanthamedh}', "");
    Expect(1, 68309, '\p{Is_Joining_Group=	 manichaean_thamedh}', "");
    Expect(0, 68309, '\p{^Is_Joining_Group=	 manichaean_thamedh}', "");
    Expect(0, 68309, '\P{Is_Joining_Group=	 manichaean_thamedh}', "");
    Expect(1, 68309, '\P{^Is_Joining_Group=	 manichaean_thamedh}', "");
    Expect(0, 68310, '\p{Is_Joining_Group=	 manichaean_thamedh}', "");
    Expect(1, 68310, '\p{^Is_Joining_Group=	 manichaean_thamedh}', "");
    Expect(1, 68310, '\P{Is_Joining_Group=	 manichaean_thamedh}', "");
    Expect(0, 68310, '\P{^Is_Joining_Group=	 manichaean_thamedh}', "");
    Error('\p{Is_Jg:--Manichaean_thamedh:=}');
    Error('\P{Is_Jg:--Manichaean_thamedh:=}');
    Expect(1, 68309, '\p{Is_Jg=manichaeanthamedh}', "");
    Expect(0, 68309, '\p{^Is_Jg=manichaeanthamedh}', "");
    Expect(0, 68309, '\P{Is_Jg=manichaeanthamedh}', "");
    Expect(1, 68309, '\P{^Is_Jg=manichaeanthamedh}', "");
    Expect(0, 68310, '\p{Is_Jg=manichaeanthamedh}', "");
    Expect(1, 68310, '\p{^Is_Jg=manichaeanthamedh}', "");
    Expect(1, 68310, '\P{Is_Jg=manichaeanthamedh}', "");
    Expect(0, 68310, '\P{^Is_Jg=manichaeanthamedh}', "");
    Expect(1, 68309, '\p{Is_Jg=_-MANICHAEAN_thamedh}', "");
    Expect(0, 68309, '\p{^Is_Jg=_-MANICHAEAN_thamedh}', "");
    Expect(0, 68309, '\P{Is_Jg=_-MANICHAEAN_thamedh}', "");
    Expect(1, 68309, '\P{^Is_Jg=_-MANICHAEAN_thamedh}', "");
    Expect(0, 68310, '\p{Is_Jg=_-MANICHAEAN_thamedh}', "");
    Expect(1, 68310, '\p{^Is_Jg=_-MANICHAEAN_thamedh}', "");
    Expect(1, 68310, '\P{Is_Jg=_-MANICHAEAN_thamedh}', "");
    Expect(0, 68310, '\P{^Is_Jg=_-MANICHAEAN_thamedh}', "");
    Error('\p{Joining_Group=:=Manichaean_Twenty}');
    Error('\P{Joining_Group=:=Manichaean_Twenty}');
    Expect(1, 68334, '\p{Joining_Group=:\AManichaean_Twenty\z:}', "");;
    Expect(0, 68335, '\p{Joining_Group=:\AManichaean_Twenty\z:}', "");;
    Expect(1, 68334, '\p{Joining_Group=manichaeantwenty}', "");
    Expect(0, 68334, '\p{^Joining_Group=manichaeantwenty}', "");
    Expect(0, 68334, '\P{Joining_Group=manichaeantwenty}', "");
    Expect(1, 68334, '\P{^Joining_Group=manichaeantwenty}', "");
    Expect(0, 68335, '\p{Joining_Group=manichaeantwenty}', "");
    Expect(1, 68335, '\p{^Joining_Group=manichaeantwenty}', "");
    Expect(1, 68335, '\P{Joining_Group=manichaeantwenty}', "");
    Expect(0, 68335, '\P{^Joining_Group=manichaeantwenty}', "");
    Expect(1, 68334, '\p{Joining_Group=:\Amanichaeantwenty\z:}', "");;
    Expect(0, 68335, '\p{Joining_Group=:\Amanichaeantwenty\z:}', "");;
    Expect(1, 68334, '\p{Joining_Group= Manichaean_Twenty}', "");
    Expect(0, 68334, '\p{^Joining_Group= Manichaean_Twenty}', "");
    Expect(0, 68334, '\P{Joining_Group= Manichaean_Twenty}', "");
    Expect(1, 68334, '\P{^Joining_Group= Manichaean_Twenty}', "");
    Expect(0, 68335, '\p{Joining_Group= Manichaean_Twenty}', "");
    Expect(1, 68335, '\p{^Joining_Group= Manichaean_Twenty}', "");
    Expect(1, 68335, '\P{Joining_Group= Manichaean_Twenty}', "");
    Expect(0, 68335, '\P{^Joining_Group= Manichaean_Twenty}', "");
    Error('\p{Jg=:=--manichaean_Twenty}');
    Error('\P{Jg=:=--manichaean_Twenty}');
    Expect(1, 68334, '\p{Jg=:\AManichaean_Twenty\z:}', "");;
    Expect(0, 68335, '\p{Jg=:\AManichaean_Twenty\z:}', "");;
    Expect(1, 68334, '\p{Jg=manichaeantwenty}', "");
    Expect(0, 68334, '\p{^Jg=manichaeantwenty}', "");
    Expect(0, 68334, '\P{Jg=manichaeantwenty}', "");
    Expect(1, 68334, '\P{^Jg=manichaeantwenty}', "");
    Expect(0, 68335, '\p{Jg=manichaeantwenty}', "");
    Expect(1, 68335, '\p{^Jg=manichaeantwenty}', "");
    Expect(1, 68335, '\P{Jg=manichaeantwenty}', "");
    Expect(0, 68335, '\P{^Jg=manichaeantwenty}', "");
    Expect(1, 68334, '\p{Jg=:\Amanichaeantwenty\z:}', "");;
    Expect(0, 68335, '\p{Jg=:\Amanichaeantwenty\z:}', "");;
    Expect(1, 68334, '\p{Jg=-MANICHAEAN_TWENTY}', "");
    Expect(0, 68334, '\p{^Jg=-MANICHAEAN_TWENTY}', "");
    Expect(0, 68334, '\P{Jg=-MANICHAEAN_TWENTY}', "");
    Expect(1, 68334, '\P{^Jg=-MANICHAEAN_TWENTY}', "");
    Expect(0, 68335, '\p{Jg=-MANICHAEAN_TWENTY}', "");
    Expect(1, 68335, '\p{^Jg=-MANICHAEAN_TWENTY}', "");
    Expect(1, 68335, '\P{Jg=-MANICHAEAN_TWENTY}', "");
    Expect(0, 68335, '\P{^Jg=-MANICHAEAN_TWENTY}', "");
    Error('\p{Is_Joining_Group=_/a/manichaean_Twenty}');
    Error('\P{Is_Joining_Group=_/a/manichaean_Twenty}');
    Expect(1, 68334, '\p{Is_Joining_Group=manichaeantwenty}', "");
    Expect(0, 68334, '\p{^Is_Joining_Group=manichaeantwenty}', "");
    Expect(0, 68334, '\P{Is_Joining_Group=manichaeantwenty}', "");
    Expect(1, 68334, '\P{^Is_Joining_Group=manichaeantwenty}', "");
    Expect(0, 68335, '\p{Is_Joining_Group=manichaeantwenty}', "");
    Expect(1, 68335, '\p{^Is_Joining_Group=manichaeantwenty}', "");
    Expect(1, 68335, '\P{Is_Joining_Group=manichaeantwenty}', "");
    Expect(0, 68335, '\P{^Is_Joining_Group=manichaeantwenty}', "");
    Expect(1, 68334, '\p{Is_Joining_Group=_Manichaean_twenty}', "");
    Expect(0, 68334, '\p{^Is_Joining_Group=_Manichaean_twenty}', "");
    Expect(0, 68334, '\P{Is_Joining_Group=_Manichaean_twenty}', "");
    Expect(1, 68334, '\P{^Is_Joining_Group=_Manichaean_twenty}', "");
    Expect(0, 68335, '\p{Is_Joining_Group=_Manichaean_twenty}', "");
    Expect(1, 68335, '\p{^Is_Joining_Group=_Manichaean_twenty}', "");
    Expect(1, 68335, '\P{Is_Joining_Group=_Manichaean_twenty}', "");
    Expect(0, 68335, '\P{^Is_Joining_Group=_Manichaean_twenty}', "");
    Error('\p{Is_Jg=/a/-MANICHAEAN_Twenty}');
    Error('\P{Is_Jg=/a/-MANICHAEAN_Twenty}');
    Expect(1, 68334, '\p{Is_Jg=manichaeantwenty}', "");
    Expect(0, 68334, '\p{^Is_Jg=manichaeantwenty}', "");
    Expect(0, 68334, '\P{Is_Jg=manichaeantwenty}', "");
    Expect(1, 68334, '\P{^Is_Jg=manichaeantwenty}', "");
    Expect(0, 68335, '\p{Is_Jg=manichaeantwenty}', "");
    Expect(1, 68335, '\p{^Is_Jg=manichaeantwenty}', "");
    Expect(1, 68335, '\P{Is_Jg=manichaeantwenty}', "");
    Expect(0, 68335, '\P{^Is_Jg=manichaeantwenty}', "");
    Expect(1, 68334, '\p{Is_Jg=-_Manichaean_Twenty}', "");
    Expect(0, 68334, '\p{^Is_Jg=-_Manichaean_Twenty}', "");
    Expect(0, 68334, '\P{Is_Jg=-_Manichaean_Twenty}', "");
    Expect(1, 68334, '\P{^Is_Jg=-_Manichaean_Twenty}', "");
    Expect(0, 68335, '\p{Is_Jg=-_Manichaean_Twenty}', "");
    Expect(1, 68335, '\p{^Is_Jg=-_Manichaean_Twenty}', "");
    Expect(1, 68335, '\P{Is_Jg=-_Manichaean_Twenty}', "");
    Expect(0, 68335, '\P{^Is_Jg=-_Manichaean_Twenty}', "");
    Error('\p{Joining_Group=	/a/Manichaean_waw}');
    Error('\P{Joining_Group=	/a/Manichaean_waw}');
    Expect(1, 68295, '\p{Joining_Group=:\AManichaean_Waw\z:}', "");;
    Expect(0, 68296, '\p{Joining_Group=:\AManichaean_Waw\z:}', "");;
    Expect(1, 68295, '\p{Joining_Group:	manichaeanwaw}', "");
    Expect(0, 68295, '\p{^Joining_Group:	manichaeanwaw}', "");
    Expect(0, 68295, '\P{Joining_Group:	manichaeanwaw}', "");
    Expect(1, 68295, '\P{^Joining_Group:	manichaeanwaw}', "");
    Expect(0, 68296, '\p{Joining_Group:	manichaeanwaw}', "");
    Expect(1, 68296, '\p{^Joining_Group:	manichaeanwaw}', "");
    Expect(1, 68296, '\P{Joining_Group:	manichaeanwaw}', "");
    Expect(0, 68296, '\P{^Joining_Group:	manichaeanwaw}', "");
    Expect(1, 68295, '\p{Joining_Group=:\Amanichaeanwaw\z:}', "");;
    Expect(0, 68296, '\p{Joining_Group=:\Amanichaeanwaw\z:}', "");;
    Expect(1, 68295, '\p{Joining_Group=_Manichaean_WAW}', "");
    Expect(0, 68295, '\p{^Joining_Group=_Manichaean_WAW}', "");
    Expect(0, 68295, '\P{Joining_Group=_Manichaean_WAW}', "");
    Expect(1, 68295, '\P{^Joining_Group=_Manichaean_WAW}', "");
    Expect(0, 68296, '\p{Joining_Group=_Manichaean_WAW}', "");
    Expect(1, 68296, '\p{^Joining_Group=_Manichaean_WAW}', "");
    Expect(1, 68296, '\P{Joining_Group=_Manichaean_WAW}', "");
    Expect(0, 68296, '\P{^Joining_Group=_Manichaean_WAW}', "");
    Error('\p{Jg=	_MANICHAEAN_waw:=}');
    Error('\P{Jg=	_MANICHAEAN_waw:=}');
    Expect(1, 68295, '\p{Jg=:\AManichaean_Waw\z:}', "");;
    Expect(0, 68296, '\p{Jg=:\AManichaean_Waw\z:}', "");;
    Expect(1, 68295, '\p{Jg=manichaeanwaw}', "");
    Expect(0, 68295, '\p{^Jg=manichaeanwaw}', "");
    Expect(0, 68295, '\P{Jg=manichaeanwaw}', "");
    Expect(1, 68295, '\P{^Jg=manichaeanwaw}', "");
    Expect(0, 68296, '\p{Jg=manichaeanwaw}', "");
    Expect(1, 68296, '\p{^Jg=manichaeanwaw}', "");
    Expect(1, 68296, '\P{Jg=manichaeanwaw}', "");
    Expect(0, 68296, '\P{^Jg=manichaeanwaw}', "");
    Expect(1, 68295, '\p{Jg=:\Amanichaeanwaw\z:}', "");;
    Expect(0, 68296, '\p{Jg=:\Amanichaeanwaw\z:}', "");;
    Expect(1, 68295, '\p{Jg= -Manichaean_waw}', "");
    Expect(0, 68295, '\p{^Jg= -Manichaean_waw}', "");
    Expect(0, 68295, '\P{Jg= -Manichaean_waw}', "");
    Expect(1, 68295, '\P{^Jg= -Manichaean_waw}', "");
    Expect(0, 68296, '\p{Jg= -Manichaean_waw}', "");
    Expect(1, 68296, '\p{^Jg= -Manichaean_waw}', "");
    Expect(1, 68296, '\P{Jg= -Manichaean_waw}', "");
    Expect(0, 68296, '\P{^Jg= -Manichaean_waw}', "");
    Error('\p{Is_Joining_Group=	/a/MANICHAEAN_Waw}');
    Error('\P{Is_Joining_Group=	/a/MANICHAEAN_Waw}');
    Expect(1, 68295, '\p{Is_Joining_Group=manichaeanwaw}', "");
    Expect(0, 68295, '\p{^Is_Joining_Group=manichaeanwaw}', "");
    Expect(0, 68295, '\P{Is_Joining_Group=manichaeanwaw}', "");
    Expect(1, 68295, '\P{^Is_Joining_Group=manichaeanwaw}', "");
    Expect(0, 68296, '\p{Is_Joining_Group=manichaeanwaw}', "");
    Expect(1, 68296, '\p{^Is_Joining_Group=manichaeanwaw}', "");
    Expect(1, 68296, '\P{Is_Joining_Group=manichaeanwaw}', "");
    Expect(0, 68296, '\P{^Is_Joining_Group=manichaeanwaw}', "");
    Expect(1, 68295, '\p{Is_Joining_Group:	__manichaean_Waw}', "");
    Expect(0, 68295, '\p{^Is_Joining_Group:	__manichaean_Waw}', "");
    Expect(0, 68295, '\P{Is_Joining_Group:	__manichaean_Waw}', "");
    Expect(1, 68295, '\P{^Is_Joining_Group:	__manichaean_Waw}', "");
    Expect(0, 68296, '\p{Is_Joining_Group:	__manichaean_Waw}', "");
    Expect(1, 68296, '\p{^Is_Joining_Group:	__manichaean_Waw}', "");
    Expect(1, 68296, '\P{Is_Joining_Group:	__manichaean_Waw}', "");
    Expect(0, 68296, '\P{^Is_Joining_Group:	__manichaean_Waw}', "");
    Error('\p{Is_Jg=-manichaean_Waw/a/}');
    Error('\P{Is_Jg=-manichaean_Waw/a/}');
    Expect(1, 68295, '\p{Is_Jg=manichaeanwaw}', "");
    Expect(0, 68295, '\p{^Is_Jg=manichaeanwaw}', "");
    Expect(0, 68295, '\P{Is_Jg=manichaeanwaw}', "");
    Expect(1, 68295, '\P{^Is_Jg=manichaeanwaw}', "");
    Expect(0, 68296, '\p{Is_Jg=manichaeanwaw}', "");
    Expect(1, 68296, '\p{^Is_Jg=manichaeanwaw}', "");
    Expect(1, 68296, '\P{Is_Jg=manichaeanwaw}', "");
    Expect(0, 68296, '\P{^Is_Jg=manichaeanwaw}', "");
    Expect(1, 68295, '\p{Is_Jg:			Manichaean_WAW}', "");
    Expect(0, 68295, '\p{^Is_Jg:			Manichaean_WAW}', "");
    Expect(0, 68295, '\P{Is_Jg:			Manichaean_WAW}', "");
    Expect(1, 68295, '\P{^Is_Jg:			Manichaean_WAW}', "");
    Expect(0, 68296, '\p{Is_Jg:			Manichaean_WAW}', "");
    Expect(1, 68296, '\p{^Is_Jg:			Manichaean_WAW}', "");
    Expect(1, 68296, '\P{Is_Jg:			Manichaean_WAW}', "");
    Expect(0, 68296, '\P{^Is_Jg:			Manichaean_WAW}', "");
    Error('\p{Joining_Group=	:=MANICHAEAN_Yodh}');
    Error('\P{Joining_Group=	:=MANICHAEAN_Yodh}');
    Expect(1, 68303, '\p{Joining_Group=:\AManichaean_Yodh\z:}', "");;
    Expect(0, 68304, '\p{Joining_Group=:\AManichaean_Yodh\z:}', "");;
    Expect(1, 68303, '\p{Joining_Group=manichaeanyodh}', "");
    Expect(0, 68303, '\p{^Joining_Group=manichaeanyodh}', "");
    Expect(0, 68303, '\P{Joining_Group=manichaeanyodh}', "");
    Expect(1, 68303, '\P{^Joining_Group=manichaeanyodh}', "");
    Expect(0, 68304, '\p{Joining_Group=manichaeanyodh}', "");
    Expect(1, 68304, '\p{^Joining_Group=manichaeanyodh}', "");
    Expect(1, 68304, '\P{Joining_Group=manichaeanyodh}', "");
    Expect(0, 68304, '\P{^Joining_Group=manichaeanyodh}', "");
    Expect(1, 68303, '\p{Joining_Group=:\Amanichaeanyodh\z:}', "");;
    Expect(0, 68304, '\p{Joining_Group=:\Amanichaeanyodh\z:}', "");;
    Expect(1, 68303, '\p{Joining_Group=_Manichaean_yodh}', "");
    Expect(0, 68303, '\p{^Joining_Group=_Manichaean_yodh}', "");
    Expect(0, 68303, '\P{Joining_Group=_Manichaean_yodh}', "");
    Expect(1, 68303, '\P{^Joining_Group=_Manichaean_yodh}', "");
    Expect(0, 68304, '\p{Joining_Group=_Manichaean_yodh}', "");
    Expect(1, 68304, '\p{^Joining_Group=_Manichaean_yodh}', "");
    Expect(1, 68304, '\P{Joining_Group=_Manichaean_yodh}', "");
    Expect(0, 68304, '\P{^Joining_Group=_Manichaean_yodh}', "");
    Error('\p{Jg=_:=Manichaean_yodh}');
    Error('\P{Jg=_:=Manichaean_yodh}');
    Expect(1, 68303, '\p{Jg=:\AManichaean_Yodh\z:}', "");;
    Expect(0, 68304, '\p{Jg=:\AManichaean_Yodh\z:}', "");;
    Expect(1, 68303, '\p{Jg=manichaeanyodh}', "");
    Expect(0, 68303, '\p{^Jg=manichaeanyodh}', "");
    Expect(0, 68303, '\P{Jg=manichaeanyodh}', "");
    Expect(1, 68303, '\P{^Jg=manichaeanyodh}', "");
    Expect(0, 68304, '\p{Jg=manichaeanyodh}', "");
    Expect(1, 68304, '\p{^Jg=manichaeanyodh}', "");
    Expect(1, 68304, '\P{Jg=manichaeanyodh}', "");
    Expect(0, 68304, '\P{^Jg=manichaeanyodh}', "");
    Expect(1, 68303, '\p{Jg=:\Amanichaeanyodh\z:}', "");;
    Expect(0, 68304, '\p{Jg=:\Amanichaeanyodh\z:}', "");;
    Expect(1, 68303, '\p{Jg= Manichaean_yodh}', "");
    Expect(0, 68303, '\p{^Jg= Manichaean_yodh}', "");
    Expect(0, 68303, '\P{Jg= Manichaean_yodh}', "");
    Expect(1, 68303, '\P{^Jg= Manichaean_yodh}', "");
    Expect(0, 68304, '\p{Jg= Manichaean_yodh}', "");
    Expect(1, 68304, '\p{^Jg= Manichaean_yodh}', "");
    Expect(1, 68304, '\P{Jg= Manichaean_yodh}', "");
    Expect(0, 68304, '\P{^Jg= Manichaean_yodh}', "");
    Error('\p{Is_Joining_Group=/a/- MANICHAEAN_yodh}');
    Error('\P{Is_Joining_Group=/a/- MANICHAEAN_yodh}');
    Expect(1, 68303, '\p{Is_Joining_Group=manichaeanyodh}', "");
    Expect(0, 68303, '\p{^Is_Joining_Group=manichaeanyodh}', "");
    Expect(0, 68303, '\P{Is_Joining_Group=manichaeanyodh}', "");
    Expect(1, 68303, '\P{^Is_Joining_Group=manichaeanyodh}', "");
    Expect(0, 68304, '\p{Is_Joining_Group=manichaeanyodh}', "");
    Expect(1, 68304, '\p{^Is_Joining_Group=manichaeanyodh}', "");
    Expect(1, 68304, '\P{Is_Joining_Group=manichaeanyodh}', "");
    Expect(0, 68304, '\P{^Is_Joining_Group=manichaeanyodh}', "");
    Expect(1, 68303, '\p{Is_Joining_Group: -Manichaean_Yodh}', "");
    Expect(0, 68303, '\p{^Is_Joining_Group: -Manichaean_Yodh}', "");
    Expect(0, 68303, '\P{Is_Joining_Group: -Manichaean_Yodh}', "");
    Expect(1, 68303, '\P{^Is_Joining_Group: -Manichaean_Yodh}', "");
    Expect(0, 68304, '\p{Is_Joining_Group: -Manichaean_Yodh}', "");
    Expect(1, 68304, '\p{^Is_Joining_Group: -Manichaean_Yodh}', "");
    Expect(1, 68304, '\P{Is_Joining_Group: -Manichaean_Yodh}', "");
    Expect(0, 68304, '\P{^Is_Joining_Group: -Manichaean_Yodh}', "");
    Error('\p{Is_Jg= /a/Manichaean_YODH}');
    Error('\P{Is_Jg= /a/Manichaean_YODH}');
    Expect(1, 68303, '\p{Is_Jg=manichaeanyodh}', "");
    Expect(0, 68303, '\p{^Is_Jg=manichaeanyodh}', "");
    Expect(0, 68303, '\P{Is_Jg=manichaeanyodh}', "");
    Expect(1, 68303, '\P{^Is_Jg=manichaeanyodh}', "");
    Expect(0, 68304, '\p{Is_Jg=manichaeanyodh}', "");
    Expect(1, 68304, '\p{^Is_Jg=manichaeanyodh}', "");
    Expect(1, 68304, '\P{Is_Jg=manichaeanyodh}', "");
    Expect(0, 68304, '\P{^Is_Jg=manichaeanyodh}', "");
    Expect(1, 68303, '\p{Is_Jg=_ MANICHAEAN_Yodh}', "");
    Expect(0, 68303, '\p{^Is_Jg=_ MANICHAEAN_Yodh}', "");
    Expect(0, 68303, '\P{Is_Jg=_ MANICHAEAN_Yodh}', "");
    Expect(1, 68303, '\P{^Is_Jg=_ MANICHAEAN_Yodh}', "");
    Expect(0, 68304, '\p{Is_Jg=_ MANICHAEAN_Yodh}', "");
    Expect(1, 68304, '\p{^Is_Jg=_ MANICHAEAN_Yodh}', "");
    Expect(1, 68304, '\P{Is_Jg=_ MANICHAEAN_Yodh}', "");
    Expect(0, 68304, '\P{^Is_Jg=_ MANICHAEAN_Yodh}', "");
    Error('\p{Joining_Group=/a/ Manichaean_zayin}');
    Error('\P{Joining_Group=/a/ Manichaean_zayin}');
    Expect(1, 68298, '\p{Joining_Group=:\AManichaean_Zayin\z:}', "");;
    Expect(0, 68299, '\p{Joining_Group=:\AManichaean_Zayin\z:}', "");;
    Expect(1, 68298, '\p{Joining_Group: manichaeanzayin}', "");
    Expect(0, 68298, '\p{^Joining_Group: manichaeanzayin}', "");
    Expect(0, 68298, '\P{Joining_Group: manichaeanzayin}', "");
    Expect(1, 68298, '\P{^Joining_Group: manichaeanzayin}', "");
    Expect(0, 68299, '\p{Joining_Group: manichaeanzayin}', "");
    Expect(1, 68299, '\p{^Joining_Group: manichaeanzayin}', "");
    Expect(1, 68299, '\P{Joining_Group: manichaeanzayin}', "");
    Expect(0, 68299, '\P{^Joining_Group: manichaeanzayin}', "");
    Expect(1, 68298, '\p{Joining_Group=:\Amanichaeanzayin\z:}', "");;
    Expect(0, 68299, '\p{Joining_Group=:\Amanichaeanzayin\z:}', "");;
    Expect(1, 68298, '\p{Joining_Group=	_Manichaean_zayin}', "");
    Expect(0, 68298, '\p{^Joining_Group=	_Manichaean_zayin}', "");
    Expect(0, 68298, '\P{Joining_Group=	_Manichaean_zayin}', "");
    Expect(1, 68298, '\P{^Joining_Group=	_Manichaean_zayin}', "");
    Expect(0, 68299, '\p{Joining_Group=	_Manichaean_zayin}', "");
    Expect(1, 68299, '\p{^Joining_Group=	_Manichaean_zayin}', "");
    Expect(1, 68299, '\P{Joining_Group=	_Manichaean_zayin}', "");
    Expect(0, 68299, '\P{^Joining_Group=	_Manichaean_zayin}', "");
    Error('\p{Jg=/a/	_Manichaean_Zayin}');
    Error('\P{Jg=/a/	_Manichaean_Zayin}');
    Expect(1, 68298, '\p{Jg=:\AManichaean_Zayin\z:}', "");;
    Expect(0, 68299, '\p{Jg=:\AManichaean_Zayin\z:}', "");;
    Expect(1, 68298, '\p{Jg=manichaeanzayin}', "");
    Expect(0, 68298, '\p{^Jg=manichaeanzayin}', "");
    Expect(0, 68298, '\P{Jg=manichaeanzayin}', "");
    Expect(1, 68298, '\P{^Jg=manichaeanzayin}', "");
    Expect(0, 68299, '\p{Jg=manichaeanzayin}', "");
    Expect(1, 68299, '\p{^Jg=manichaeanzayin}', "");
    Expect(1, 68299, '\P{Jg=manichaeanzayin}', "");
    Expect(0, 68299, '\P{^Jg=manichaeanzayin}', "");
    Expect(1, 68298, '\p{Jg=:\Amanichaeanzayin\z:}', "");;
    Expect(0, 68299, '\p{Jg=:\Amanichaeanzayin\z:}', "");;
    Expect(1, 68298, '\p{Jg=	Manichaean_ZAYIN}', "");
    Expect(0, 68298, '\p{^Jg=	Manichaean_ZAYIN}', "");
    Expect(0, 68298, '\P{Jg=	Manichaean_ZAYIN}', "");
    Expect(1, 68298, '\P{^Jg=	Manichaean_ZAYIN}', "");
    Expect(0, 68299, '\p{Jg=	Manichaean_ZAYIN}', "");
    Expect(1, 68299, '\p{^Jg=	Manichaean_ZAYIN}', "");
    Expect(1, 68299, '\P{Jg=	Manichaean_ZAYIN}', "");
    Expect(0, 68299, '\P{^Jg=	Manichaean_ZAYIN}', "");
    Error('\p{Is_Joining_Group=:=-_MANICHAEAN_ZAYIN}');
    Error('\P{Is_Joining_Group=:=-_MANICHAEAN_ZAYIN}');
    Expect(1, 68298, '\p{Is_Joining_Group:manichaeanzayin}', "");
    Expect(0, 68298, '\p{^Is_Joining_Group:manichaeanzayin}', "");
    Expect(0, 68298, '\P{Is_Joining_Group:manichaeanzayin}', "");
    Expect(1, 68298, '\P{^Is_Joining_Group:manichaeanzayin}', "");
    Expect(0, 68299, '\p{Is_Joining_Group:manichaeanzayin}', "");
    Expect(1, 68299, '\p{^Is_Joining_Group:manichaeanzayin}', "");
    Expect(1, 68299, '\P{Is_Joining_Group:manichaeanzayin}', "");
    Expect(0, 68299, '\P{^Is_Joining_Group:manichaeanzayin}', "");
    Expect(1, 68298, '\p{Is_Joining_Group=-Manichaean_Zayin}', "");
    Expect(0, 68298, '\p{^Is_Joining_Group=-Manichaean_Zayin}', "");
    Expect(0, 68298, '\P{Is_Joining_Group=-Manichaean_Zayin}', "");
    Expect(1, 68298, '\P{^Is_Joining_Group=-Manichaean_Zayin}', "");
    Expect(0, 68299, '\p{Is_Joining_Group=-Manichaean_Zayin}', "");
    Expect(1, 68299, '\p{^Is_Joining_Group=-Manichaean_Zayin}', "");
    Expect(1, 68299, '\P{Is_Joining_Group=-Manichaean_Zayin}', "");
    Expect(0, 68299, '\P{^Is_Joining_Group=-Manichaean_Zayin}', "");
    Error('\p{Is_Jg=:=Manichaean_ZAYIN}');
    Error('\P{Is_Jg=:=Manichaean_ZAYIN}');
    Expect(1, 68298, '\p{Is_Jg=manichaeanzayin}', "");
    Expect(0, 68298, '\p{^Is_Jg=manichaeanzayin}', "");
    Expect(0, 68298, '\P{Is_Jg=manichaeanzayin}', "");
    Expect(1, 68298, '\P{^Is_Jg=manichaeanzayin}', "");
    Expect(0, 68299, '\p{Is_Jg=manichaeanzayin}', "");
    Expect(1, 68299, '\p{^Is_Jg=manichaeanzayin}', "");
    Expect(1, 68299, '\P{Is_Jg=manichaeanzayin}', "");
    Expect(0, 68299, '\P{^Is_Jg=manichaeanzayin}', "");
    Expect(1, 68298, '\p{Is_Jg=	-Manichaean_Zayin}', "");
    Expect(0, 68298, '\p{^Is_Jg=	-Manichaean_Zayin}', "");
    Expect(0, 68298, '\P{Is_Jg=	-Manichaean_Zayin}', "");
    Expect(1, 68298, '\P{^Is_Jg=	-Manichaean_Zayin}', "");
    Expect(0, 68299, '\p{Is_Jg=	-Manichaean_Zayin}', "");
    Expect(1, 68299, '\p{^Is_Jg=	-Manichaean_Zayin}', "");
    Expect(1, 68299, '\P{Is_Jg=	-Manichaean_Zayin}', "");
    Expect(0, 68299, '\P{^Is_Jg=	-Manichaean_Zayin}', "");
    Error('\p{Joining_Group=--Meem/a/}');
    Error('\P{Joining_Group=--Meem/a/}');
    Expect(1, 2215, '\p{Joining_Group=:\AMeem\z:}', "");;
    Expect(0, 2216, '\p{Joining_Group=:\AMeem\z:}', "");;
    Expect(1, 2215, '\p{Joining_Group=meem}', "");
    Expect(0, 2215, '\p{^Joining_Group=meem}', "");
    Expect(0, 2215, '\P{Joining_Group=meem}', "");
    Expect(1, 2215, '\P{^Joining_Group=meem}', "");
    Expect(0, 2216, '\p{Joining_Group=meem}', "");
    Expect(1, 2216, '\p{^Joining_Group=meem}', "");
    Expect(1, 2216, '\P{Joining_Group=meem}', "");
    Expect(0, 2216, '\P{^Joining_Group=meem}', "");
    Expect(1, 2215, '\p{Joining_Group=:\Ameem\z:}', "");;
    Expect(0, 2216, '\p{Joining_Group=:\Ameem\z:}', "");;
    Expect(1, 2215, '\p{Joining_Group=-_MEEM}', "");
    Expect(0, 2215, '\p{^Joining_Group=-_MEEM}', "");
    Expect(0, 2215, '\P{Joining_Group=-_MEEM}', "");
    Expect(1, 2215, '\P{^Joining_Group=-_MEEM}', "");
    Expect(0, 2216, '\p{Joining_Group=-_MEEM}', "");
    Expect(1, 2216, '\p{^Joining_Group=-_MEEM}', "");
    Expect(1, 2216, '\P{Joining_Group=-_MEEM}', "");
    Expect(0, 2216, '\P{^Joining_Group=-_MEEM}', "");
    Error('\p{Jg: 	:=Meem}');
    Error('\P{Jg: 	:=Meem}');
    Expect(1, 2215, '\p{Jg=:\AMeem\z:}', "");;
    Expect(0, 2216, '\p{Jg=:\AMeem\z:}', "");;
    Expect(1, 2215, '\p{Jg=meem}', "");
    Expect(0, 2215, '\p{^Jg=meem}', "");
    Expect(0, 2215, '\P{Jg=meem}', "");
    Expect(1, 2215, '\P{^Jg=meem}', "");
    Expect(0, 2216, '\p{Jg=meem}', "");
    Expect(1, 2216, '\p{^Jg=meem}', "");
    Expect(1, 2216, '\P{Jg=meem}', "");
    Expect(0, 2216, '\P{^Jg=meem}', "");
    Expect(1, 2215, '\p{Jg=:\Ameem\z:}', "");;
    Expect(0, 2216, '\p{Jg=:\Ameem\z:}', "");;
    Expect(1, 2215, '\p{Jg=- MEEM}', "");
    Expect(0, 2215, '\p{^Jg=- MEEM}', "");
    Expect(0, 2215, '\P{Jg=- MEEM}', "");
    Expect(1, 2215, '\P{^Jg=- MEEM}', "");
    Expect(0, 2216, '\p{Jg=- MEEM}', "");
    Expect(1, 2216, '\p{^Jg=- MEEM}', "");
    Expect(1, 2216, '\P{Jg=- MEEM}', "");
    Expect(0, 2216, '\P{^Jg=- MEEM}', "");
    Error('\p{Is_Joining_Group=  Meem/a/}');
    Error('\P{Is_Joining_Group=  Meem/a/}');
    Expect(1, 2215, '\p{Is_Joining_Group=meem}', "");
    Expect(0, 2215, '\p{^Is_Joining_Group=meem}', "");
    Expect(0, 2215, '\P{Is_Joining_Group=meem}', "");
    Expect(1, 2215, '\P{^Is_Joining_Group=meem}', "");
    Expect(0, 2216, '\p{Is_Joining_Group=meem}', "");
    Expect(1, 2216, '\p{^Is_Joining_Group=meem}', "");
    Expect(1, 2216, '\P{Is_Joining_Group=meem}', "");
    Expect(0, 2216, '\P{^Is_Joining_Group=meem}', "");
    Expect(1, 2215, '\p{Is_Joining_Group= 	Meem}', "");
    Expect(0, 2215, '\p{^Is_Joining_Group= 	Meem}', "");
    Expect(0, 2215, '\P{Is_Joining_Group= 	Meem}', "");
    Expect(1, 2215, '\P{^Is_Joining_Group= 	Meem}', "");
    Expect(0, 2216, '\p{Is_Joining_Group= 	Meem}', "");
    Expect(1, 2216, '\p{^Is_Joining_Group= 	Meem}', "");
    Expect(1, 2216, '\P{Is_Joining_Group= 	Meem}', "");
    Expect(0, 2216, '\P{^Is_Joining_Group= 	Meem}', "");
    Error('\p{Is_Jg=Meem/a/}');
    Error('\P{Is_Jg=Meem/a/}');
    Expect(1, 2215, '\p{Is_Jg=meem}', "");
    Expect(0, 2215, '\p{^Is_Jg=meem}', "");
    Expect(0, 2215, '\P{Is_Jg=meem}', "");
    Expect(1, 2215, '\P{^Is_Jg=meem}', "");
    Expect(0, 2216, '\p{Is_Jg=meem}', "");
    Expect(1, 2216, '\p{^Is_Jg=meem}', "");
    Expect(1, 2216, '\P{Is_Jg=meem}', "");
    Expect(0, 2216, '\P{^Is_Jg=meem}', "");
    Expect(1, 2215, '\p{Is_Jg=	meem}', "");
    Expect(0, 2215, '\p{^Is_Jg=	meem}', "");
    Expect(0, 2215, '\P{Is_Jg=	meem}', "");
    Expect(1, 2215, '\P{^Is_Jg=	meem}', "");
    Expect(0, 2216, '\p{Is_Jg=	meem}', "");
    Expect(1, 2216, '\p{^Is_Jg=	meem}', "");
    Expect(1, 2216, '\P{Is_Jg=	meem}', "");
    Expect(0, 2216, '\P{^Is_Jg=	meem}', "");
    Error('\p{Joining_Group: _mim:=}');
    Error('\P{Joining_Group: _mim:=}');
    Expect(1, 1825, '\p{Joining_Group=:\AMim\z:}', "");;
    Expect(0, 1826, '\p{Joining_Group=:\AMim\z:}', "");;
    Expect(1, 1825, '\p{Joining_Group=mim}', "");
    Expect(0, 1825, '\p{^Joining_Group=mim}', "");
    Expect(0, 1825, '\P{Joining_Group=mim}', "");
    Expect(1, 1825, '\P{^Joining_Group=mim}', "");
    Expect(0, 1826, '\p{Joining_Group=mim}', "");
    Expect(1, 1826, '\p{^Joining_Group=mim}', "");
    Expect(1, 1826, '\P{Joining_Group=mim}', "");
    Expect(0, 1826, '\P{^Joining_Group=mim}', "");
    Expect(1, 1825, '\p{Joining_Group=:\Amim\z:}', "");;
    Expect(0, 1826, '\p{Joining_Group=:\Amim\z:}', "");;
    Expect(1, 1825, '\p{Joining_Group:	_Mim}', "");
    Expect(0, 1825, '\p{^Joining_Group:	_Mim}', "");
    Expect(0, 1825, '\P{Joining_Group:	_Mim}', "");
    Expect(1, 1825, '\P{^Joining_Group:	_Mim}', "");
    Expect(0, 1826, '\p{Joining_Group:	_Mim}', "");
    Expect(1, 1826, '\p{^Joining_Group:	_Mim}', "");
    Expect(1, 1826, '\P{Joining_Group:	_Mim}', "");
    Expect(0, 1826, '\P{^Joining_Group:	_Mim}', "");
    Error('\p{Jg= Mim/a/}');
    Error('\P{Jg= Mim/a/}');
    Expect(1, 1825, '\p{Jg=:\AMim\z:}', "");;
    Expect(0, 1826, '\p{Jg=:\AMim\z:}', "");;
    Expect(1, 1825, '\p{Jg=mim}', "");
    Expect(0, 1825, '\p{^Jg=mim}', "");
    Expect(0, 1825, '\P{Jg=mim}', "");
    Expect(1, 1825, '\P{^Jg=mim}', "");
    Expect(0, 1826, '\p{Jg=mim}', "");
    Expect(1, 1826, '\p{^Jg=mim}', "");
    Expect(1, 1826, '\P{Jg=mim}', "");
    Expect(0, 1826, '\P{^Jg=mim}', "");
    Expect(1, 1825, '\p{Jg=:\Amim\z:}', "");;
    Expect(0, 1826, '\p{Jg=:\Amim\z:}', "");;
    Expect(1, 1825, '\p{Jg=-MIM}', "");
    Expect(0, 1825, '\p{^Jg=-MIM}', "");
    Expect(0, 1825, '\P{Jg=-MIM}', "");
    Expect(1, 1825, '\P{^Jg=-MIM}', "");
    Expect(0, 1826, '\p{Jg=-MIM}', "");
    Expect(1, 1826, '\p{^Jg=-MIM}', "");
    Expect(1, 1826, '\P{Jg=-MIM}', "");
    Expect(0, 1826, '\P{^Jg=-MIM}', "");
    Error('\p{Is_Joining_Group=_Mim:=}');
    Error('\P{Is_Joining_Group=_Mim:=}');
    Expect(1, 1825, '\p{Is_Joining_Group=mim}', "");
    Expect(0, 1825, '\p{^Is_Joining_Group=mim}', "");
    Expect(0, 1825, '\P{Is_Joining_Group=mim}', "");
    Expect(1, 1825, '\P{^Is_Joining_Group=mim}', "");
    Expect(0, 1826, '\p{Is_Joining_Group=mim}', "");
    Expect(1, 1826, '\p{^Is_Joining_Group=mim}', "");
    Expect(1, 1826, '\P{Is_Joining_Group=mim}', "");
    Expect(0, 1826, '\P{^Is_Joining_Group=mim}', "");
    Expect(1, 1825, '\p{Is_Joining_Group=- mim}', "");
    Expect(0, 1825, '\p{^Is_Joining_Group=- mim}', "");
    Expect(0, 1825, '\P{Is_Joining_Group=- mim}', "");
    Expect(1, 1825, '\P{^Is_Joining_Group=- mim}', "");
    Expect(0, 1826, '\p{Is_Joining_Group=- mim}', "");
    Expect(1, 1826, '\p{^Is_Joining_Group=- mim}', "");
    Expect(1, 1826, '\P{Is_Joining_Group=- mim}', "");
    Expect(0, 1826, '\P{^Is_Joining_Group=- mim}', "");
    Error('\p{Is_Jg=:=-	mim}');
    Error('\P{Is_Jg=:=-	mim}');
    Expect(1, 1825, '\p{Is_Jg=mim}', "");
    Expect(0, 1825, '\p{^Is_Jg=mim}', "");
    Expect(0, 1825, '\P{Is_Jg=mim}', "");
    Expect(1, 1825, '\P{^Is_Jg=mim}', "");
    Expect(0, 1826, '\p{Is_Jg=mim}', "");
    Expect(1, 1826, '\p{^Is_Jg=mim}', "");
    Expect(1, 1826, '\P{Is_Jg=mim}', "");
    Expect(0, 1826, '\P{^Is_Jg=mim}', "");
    Expect(1, 1825, '\p{Is_Jg=_	Mim}', "");
    Expect(0, 1825, '\p{^Is_Jg=_	Mim}', "");
    Expect(0, 1825, '\P{Is_Jg=_	Mim}', "");
    Expect(1, 1825, '\P{^Is_Jg=_	Mim}', "");
    Expect(0, 1826, '\p{Is_Jg=_	Mim}', "");
    Expect(1, 1826, '\p{^Is_Jg=_	Mim}', "");
    Expect(1, 1826, '\P{Is_Jg=_	Mim}', "");
    Expect(0, 1826, '\P{^Is_Jg=_	Mim}', "");
    Error('\p{Joining_Group=_:=No_JOINING_group}');
    Error('\P{Joining_Group=_:=No_JOINING_group}');
    Expect(1, 68900, '\p{Joining_Group=:\ANo_Joining_Group\z:}', "");;
    Expect(0, 68899, '\p{Joining_Group=:\ANo_Joining_Group\z:}', "");;
    Expect(1, 68900, '\p{Joining_Group=nojoininggroup}', "");
    Expect(0, 68900, '\p{^Joining_Group=nojoininggroup}', "");
    Expect(0, 68900, '\P{Joining_Group=nojoininggroup}', "");
    Expect(1, 68900, '\P{^Joining_Group=nojoininggroup}', "");
    Expect(0, 68899, '\p{Joining_Group=nojoininggroup}', "");
    Expect(1, 68899, '\p{^Joining_Group=nojoininggroup}', "");
    Expect(1, 68899, '\P{Joining_Group=nojoininggroup}', "");
    Expect(0, 68899, '\P{^Joining_Group=nojoininggroup}', "");
    Expect(1, 68900, '\p{Joining_Group=:\Anojoininggroup\z:}', "");;
    Expect(0, 68899, '\p{Joining_Group=:\Anojoininggroup\z:}', "");;
    Expect(1, 68900, '\p{Joining_Group=NO_JOINING_Group}', "");
    Expect(0, 68900, '\p{^Joining_Group=NO_JOINING_Group}', "");
    Expect(0, 68900, '\P{Joining_Group=NO_JOINING_Group}', "");
    Expect(1, 68900, '\P{^Joining_Group=NO_JOINING_Group}', "");
    Expect(0, 68899, '\p{Joining_Group=NO_JOINING_Group}', "");
    Expect(1, 68899, '\p{^Joining_Group=NO_JOINING_Group}', "");
    Expect(1, 68899, '\P{Joining_Group=NO_JOINING_Group}', "");
    Expect(0, 68899, '\P{^Joining_Group=NO_JOINING_Group}', "");
    Error('\p{Jg=-	No_JOINING_Group/a/}');
    Error('\P{Jg=-	No_JOINING_Group/a/}');
    Expect(1, 68900, '\p{Jg=:\ANo_Joining_Group\z:}', "");;
    Expect(0, 68899, '\p{Jg=:\ANo_Joining_Group\z:}', "");;
    Expect(1, 68900, '\p{Jg=nojoininggroup}', "");
    Expect(0, 68900, '\p{^Jg=nojoininggroup}', "");
    Expect(0, 68900, '\P{Jg=nojoininggroup}', "");
    Expect(1, 68900, '\P{^Jg=nojoininggroup}', "");
    Expect(0, 68899, '\p{Jg=nojoininggroup}', "");
    Expect(1, 68899, '\p{^Jg=nojoininggroup}', "");
    Expect(1, 68899, '\P{Jg=nojoininggroup}', "");
    Expect(0, 68899, '\P{^Jg=nojoininggroup}', "");
    Expect(1, 68900, '\p{Jg=:\Anojoininggroup\z:}', "");;
    Expect(0, 68899, '\p{Jg=:\Anojoininggroup\z:}', "");;
    Expect(1, 68900, '\p{Jg= _No_joining_Group}', "");
    Expect(0, 68900, '\p{^Jg= _No_joining_Group}', "");
    Expect(0, 68900, '\P{Jg= _No_joining_Group}', "");
    Expect(1, 68900, '\P{^Jg= _No_joining_Group}', "");
    Expect(0, 68899, '\p{Jg= _No_joining_Group}', "");
    Expect(1, 68899, '\p{^Jg= _No_joining_Group}', "");
    Expect(1, 68899, '\P{Jg= _No_joining_Group}', "");
    Expect(0, 68899, '\P{^Jg= _No_joining_Group}', "");
    Error('\p{Is_Joining_Group=-:=No_Joining_group}');
    Error('\P{Is_Joining_Group=-:=No_Joining_group}');
    Expect(1, 68900, '\p{Is_Joining_Group=nojoininggroup}', "");
    Expect(0, 68900, '\p{^Is_Joining_Group=nojoininggroup}', "");
    Expect(0, 68900, '\P{Is_Joining_Group=nojoininggroup}', "");
    Expect(1, 68900, '\P{^Is_Joining_Group=nojoininggroup}', "");
    Expect(0, 68899, '\p{Is_Joining_Group=nojoininggroup}', "");
    Expect(1, 68899, '\p{^Is_Joining_Group=nojoininggroup}', "");
    Expect(1, 68899, '\P{Is_Joining_Group=nojoininggroup}', "");
    Expect(0, 68899, '\P{^Is_Joining_Group=nojoininggroup}', "");
    Expect(1, 68900, '\p{Is_Joining_Group= _NO_Joining_Group}', "");
    Expect(0, 68900, '\p{^Is_Joining_Group= _NO_Joining_Group}', "");
    Expect(0, 68900, '\P{Is_Joining_Group= _NO_Joining_Group}', "");
    Expect(1, 68900, '\P{^Is_Joining_Group= _NO_Joining_Group}', "");
    Expect(0, 68899, '\p{Is_Joining_Group= _NO_Joining_Group}', "");
    Expect(1, 68899, '\p{^Is_Joining_Group= _NO_Joining_Group}', "");
    Expect(1, 68899, '\P{Is_Joining_Group= _NO_Joining_Group}', "");
    Expect(0, 68899, '\P{^Is_Joining_Group= _NO_Joining_Group}', "");
    Error('\p{Is_Jg=	/a/no_joining_group}');
    Error('\P{Is_Jg=	/a/no_joining_group}');
    Expect(1, 68900, '\p{Is_Jg:nojoininggroup}', "");
    Expect(0, 68900, '\p{^Is_Jg:nojoininggroup}', "");
    Expect(0, 68900, '\P{Is_Jg:nojoininggroup}', "");
    Expect(1, 68900, '\P{^Is_Jg:nojoininggroup}', "");
    Expect(0, 68899, '\p{Is_Jg:nojoininggroup}', "");
    Expect(1, 68899, '\p{^Is_Jg:nojoininggroup}', "");
    Expect(1, 68899, '\P{Is_Jg:nojoininggroup}', "");
    Expect(0, 68899, '\P{^Is_Jg:nojoininggroup}', "");
    Expect(1, 68900, '\p{Is_Jg=_ No_Joining_Group}', "");
    Expect(0, 68900, '\p{^Is_Jg=_ No_Joining_Group}', "");
    Expect(0, 68900, '\P{Is_Jg=_ No_Joining_Group}', "");
    Expect(1, 68900, '\P{^Is_Jg=_ No_Joining_Group}', "");
    Expect(0, 68899, '\p{Is_Jg=_ No_Joining_Group}', "");
    Expect(1, 68899, '\p{^Is_Jg=_ No_Joining_Group}', "");
    Expect(1, 68899, '\P{Is_Jg=_ No_Joining_Group}', "");
    Expect(0, 68899, '\P{^Is_Jg=_ No_Joining_Group}', "");
    Error('\p{Joining_Group: _ Noon/a/}');
    Error('\P{Joining_Group: _ Noon/a/}');
    Expect(1, 1897, '\p{Joining_Group=:\ANoon\z:}', "");;
    Expect(0, 1898, '\p{Joining_Group=:\ANoon\z:}', "");;
    Expect(1, 1897, '\p{Joining_Group=noon}', "");
    Expect(0, 1897, '\p{^Joining_Group=noon}', "");
    Expect(0, 1897, '\P{Joining_Group=noon}', "");
    Expect(1, 1897, '\P{^Joining_Group=noon}', "");
    Expect(0, 1898, '\p{Joining_Group=noon}', "");
    Expect(1, 1898, '\p{^Joining_Group=noon}', "");
    Expect(1, 1898, '\P{Joining_Group=noon}', "");
    Expect(0, 1898, '\P{^Joining_Group=noon}', "");
    Expect(1, 1897, '\p{Joining_Group=:\Anoon\z:}', "");;
    Expect(0, 1898, '\p{Joining_Group=:\Anoon\z:}', "");;
    Expect(1, 1897, '\p{Joining_Group=_ Noon}', "");
    Expect(0, 1897, '\p{^Joining_Group=_ Noon}', "");
    Expect(0, 1897, '\P{Joining_Group=_ Noon}', "");
    Expect(1, 1897, '\P{^Joining_Group=_ Noon}', "");
    Expect(0, 1898, '\p{Joining_Group=_ Noon}', "");
    Expect(1, 1898, '\p{^Joining_Group=_ Noon}', "");
    Expect(1, 1898, '\P{Joining_Group=_ Noon}', "");
    Expect(0, 1898, '\P{^Joining_Group=_ Noon}', "");
    Error('\p{Jg=_ Noon:=}');
    Error('\P{Jg=_ Noon:=}');
    Expect(1, 1897, '\p{Jg=:\ANoon\z:}', "");;
    Expect(0, 1898, '\p{Jg=:\ANoon\z:}', "");;
    Expect(1, 1897, '\p{Jg=noon}', "");
    Expect(0, 1897, '\p{^Jg=noon}', "");
    Expect(0, 1897, '\P{Jg=noon}', "");
    Expect(1, 1897, '\P{^Jg=noon}', "");
    Expect(0, 1898, '\p{Jg=noon}', "");
    Expect(1, 1898, '\p{^Jg=noon}', "");
    Expect(1, 1898, '\P{Jg=noon}', "");
    Expect(0, 1898, '\P{^Jg=noon}', "");
    Expect(1, 1897, '\p{Jg=:\Anoon\z:}', "");;
    Expect(0, 1898, '\p{Jg=:\Anoon\z:}', "");;
    Expect(1, 1897, '\p{Jg= 	Noon}', "");
    Expect(0, 1897, '\p{^Jg= 	Noon}', "");
    Expect(0, 1897, '\P{Jg= 	Noon}', "");
    Expect(1, 1897, '\P{^Jg= 	Noon}', "");
    Expect(0, 1898, '\p{Jg= 	Noon}', "");
    Expect(1, 1898, '\p{^Jg= 	Noon}', "");
    Expect(1, 1898, '\P{Jg= 	Noon}', "");
    Expect(0, 1898, '\P{^Jg= 	Noon}', "");
    Error('\p{Is_Joining_Group=	:=Noon}');
    Error('\P{Is_Joining_Group=	:=Noon}');
    Expect(1, 1897, '\p{Is_Joining_Group=noon}', "");
    Expect(0, 1897, '\p{^Is_Joining_Group=noon}', "");
    Expect(0, 1897, '\P{Is_Joining_Group=noon}', "");
    Expect(1, 1897, '\P{^Is_Joining_Group=noon}', "");
    Expect(0, 1898, '\p{Is_Joining_Group=noon}', "");
    Expect(1, 1898, '\p{^Is_Joining_Group=noon}', "");
    Expect(1, 1898, '\P{Is_Joining_Group=noon}', "");
    Expect(0, 1898, '\P{^Is_Joining_Group=noon}', "");
    Expect(1, 1897, '\p{Is_Joining_Group=_noon}', "");
    Expect(0, 1897, '\p{^Is_Joining_Group=_noon}', "");
    Expect(0, 1897, '\P{Is_Joining_Group=_noon}', "");
    Expect(1, 1897, '\P{^Is_Joining_Group=_noon}', "");
    Expect(0, 1898, '\p{Is_Joining_Group=_noon}', "");
    Expect(1, 1898, '\p{^Is_Joining_Group=_noon}', "");
    Expect(1, 1898, '\P{Is_Joining_Group=_noon}', "");
    Expect(0, 1898, '\P{^Is_Joining_Group=_noon}', "");
    Error('\p{Is_Jg=Noon:=}');
    Error('\P{Is_Jg=Noon:=}');
    Expect(1, 1897, '\p{Is_Jg=noon}', "");
    Expect(0, 1897, '\p{^Is_Jg=noon}', "");
    Expect(0, 1897, '\P{Is_Jg=noon}', "");
    Expect(1, 1897, '\P{^Is_Jg=noon}', "");
    Expect(0, 1898, '\p{Is_Jg=noon}', "");
    Expect(1, 1898, '\p{^Is_Jg=noon}', "");
    Expect(1, 1898, '\P{Is_Jg=noon}', "");
    Expect(0, 1898, '\P{^Is_Jg=noon}', "");
    Expect(1, 1897, '\p{Is_Jg=_NOON}', "");
    Expect(0, 1897, '\p{^Is_Jg=_NOON}', "");
    Expect(0, 1897, '\P{Is_Jg=_NOON}', "");
    Expect(1, 1897, '\P{^Is_Jg=_NOON}', "");
    Expect(0, 1898, '\p{Is_Jg=_NOON}', "");
    Expect(1, 1898, '\p{^Is_Jg=_NOON}', "");
    Expect(1, 1898, '\P{Is_Jg=_NOON}', "");
    Expect(0, 1898, '\P{^Is_Jg=_NOON}', "");
    Error('\p{Joining_Group=:= Nun}');
    Error('\P{Joining_Group=:= Nun}');
    Expect(1, 1826, '\p{Joining_Group=:\ANun\z:}', "");;
    Expect(0, 1827, '\p{Joining_Group=:\ANun\z:}', "");;
    Expect(1, 1826, '\p{Joining_Group=nun}', "");
    Expect(0, 1826, '\p{^Joining_Group=nun}', "");
    Expect(0, 1826, '\P{Joining_Group=nun}', "");
    Expect(1, 1826, '\P{^Joining_Group=nun}', "");
    Expect(0, 1827, '\p{Joining_Group=nun}', "");
    Expect(1, 1827, '\p{^Joining_Group=nun}', "");
    Expect(1, 1827, '\P{Joining_Group=nun}', "");
    Expect(0, 1827, '\P{^Joining_Group=nun}', "");
    Expect(1, 1826, '\p{Joining_Group=:\Anun\z:}', "");;
    Expect(0, 1827, '\p{Joining_Group=:\Anun\z:}', "");;
    Expect(1, 1826, '\p{Joining_Group=_nun}', "");
    Expect(0, 1826, '\p{^Joining_Group=_nun}', "");
    Expect(0, 1826, '\P{Joining_Group=_nun}', "");
    Expect(1, 1826, '\P{^Joining_Group=_nun}', "");
    Expect(0, 1827, '\p{Joining_Group=_nun}', "");
    Expect(1, 1827, '\p{^Joining_Group=_nun}', "");
    Expect(1, 1827, '\P{Joining_Group=_nun}', "");
    Expect(0, 1827, '\P{^Joining_Group=_nun}', "");
    Error('\p{Jg=-:=Nun}');
    Error('\P{Jg=-:=Nun}');
    Expect(1, 1826, '\p{Jg=:\ANun\z:}', "");;
    Expect(0, 1827, '\p{Jg=:\ANun\z:}', "");;
    Expect(1, 1826, '\p{Jg:	nun}', "");
    Expect(0, 1826, '\p{^Jg:	nun}', "");
    Expect(0, 1826, '\P{Jg:	nun}', "");
    Expect(1, 1826, '\P{^Jg:	nun}', "");
    Expect(0, 1827, '\p{Jg:	nun}', "");
    Expect(1, 1827, '\p{^Jg:	nun}', "");
    Expect(1, 1827, '\P{Jg:	nun}', "");
    Expect(0, 1827, '\P{^Jg:	nun}', "");
    Expect(1, 1826, '\p{Jg=:\Anun\z:}', "");;
    Expect(0, 1827, '\p{Jg=:\Anun\z:}', "");;
    Expect(1, 1826, '\p{Jg=- NUN}', "");
    Expect(0, 1826, '\p{^Jg=- NUN}', "");
    Expect(0, 1826, '\P{Jg=- NUN}', "");
    Expect(1, 1826, '\P{^Jg=- NUN}', "");
    Expect(0, 1827, '\p{Jg=- NUN}', "");
    Expect(1, 1827, '\p{^Jg=- NUN}', "");
    Expect(1, 1827, '\P{Jg=- NUN}', "");
    Expect(0, 1827, '\P{^Jg=- NUN}', "");
    Error('\p{Is_Joining_Group=-	Nun/a/}');
    Error('\P{Is_Joining_Group=-	Nun/a/}');
    Expect(1, 1826, '\p{Is_Joining_Group=nun}', "");
    Expect(0, 1826, '\p{^Is_Joining_Group=nun}', "");
    Expect(0, 1826, '\P{Is_Joining_Group=nun}', "");
    Expect(1, 1826, '\P{^Is_Joining_Group=nun}', "");
    Expect(0, 1827, '\p{Is_Joining_Group=nun}', "");
    Expect(1, 1827, '\p{^Is_Joining_Group=nun}', "");
    Expect(1, 1827, '\P{Is_Joining_Group=nun}', "");
    Expect(0, 1827, '\P{^Is_Joining_Group=nun}', "");
    Expect(1, 1826, '\p{Is_Joining_Group=_ NUN}', "");
    Expect(0, 1826, '\p{^Is_Joining_Group=_ NUN}', "");
    Expect(0, 1826, '\P{Is_Joining_Group=_ NUN}', "");
    Expect(1, 1826, '\P{^Is_Joining_Group=_ NUN}', "");
    Expect(0, 1827, '\p{Is_Joining_Group=_ NUN}', "");
    Expect(1, 1827, '\p{^Is_Joining_Group=_ NUN}', "");
    Expect(1, 1827, '\P{Is_Joining_Group=_ NUN}', "");
    Expect(0, 1827, '\P{^Is_Joining_Group=_ NUN}', "");
    Error('\p{Is_Jg:	:= -NUN}');
    Error('\P{Is_Jg:	:= -NUN}');
    Expect(1, 1826, '\p{Is_Jg=nun}', "");
    Expect(0, 1826, '\p{^Is_Jg=nun}', "");
    Expect(0, 1826, '\P{Is_Jg=nun}', "");
    Expect(1, 1826, '\P{^Is_Jg=nun}', "");
    Expect(0, 1827, '\p{Is_Jg=nun}', "");
    Expect(1, 1827, '\p{^Is_Jg=nun}', "");
    Expect(1, 1827, '\P{Is_Jg=nun}', "");
    Expect(0, 1827, '\P{^Is_Jg=nun}', "");
    Expect(1, 1826, '\p{Is_Jg= Nun}', "");
    Expect(0, 1826, '\p{^Is_Jg= Nun}', "");
    Expect(0, 1826, '\P{Is_Jg= Nun}', "");
    Expect(1, 1826, '\P{^Is_Jg= Nun}', "");
    Expect(0, 1827, '\p{Is_Jg= Nun}', "");
    Expect(1, 1827, '\p{^Is_Jg= Nun}', "");
    Expect(1, 1827, '\P{Is_Jg= Nun}', "");
    Expect(0, 1827, '\P{^Is_Jg= Nun}', "");
    Error('\p{Joining_Group: /a/		nya}');
    Error('\P{Joining_Group: /a/		nya}');
    Expect(1, 1725, '\p{Joining_Group=:\ANya\z:}', "");;
    Expect(0, 1726, '\p{Joining_Group=:\ANya\z:}', "");;
    Expect(1, 1725, '\p{Joining_Group=nya}', "");
    Expect(0, 1725, '\p{^Joining_Group=nya}', "");
    Expect(0, 1725, '\P{Joining_Group=nya}', "");
    Expect(1, 1725, '\P{^Joining_Group=nya}', "");
    Expect(0, 1726, '\p{Joining_Group=nya}', "");
    Expect(1, 1726, '\p{^Joining_Group=nya}', "");
    Expect(1, 1726, '\P{Joining_Group=nya}', "");
    Expect(0, 1726, '\P{^Joining_Group=nya}', "");
    Expect(1, 1725, '\p{Joining_Group=:\Anya\z:}', "");;
    Expect(0, 1726, '\p{Joining_Group=:\Anya\z:}', "");;
    Expect(1, 1725, '\p{Joining_Group= NYA}', "");
    Expect(0, 1725, '\p{^Joining_Group= NYA}', "");
    Expect(0, 1725, '\P{Joining_Group= NYA}', "");
    Expect(1, 1725, '\P{^Joining_Group= NYA}', "");
    Expect(0, 1726, '\p{Joining_Group= NYA}', "");
    Expect(1, 1726, '\p{^Joining_Group= NYA}', "");
    Expect(1, 1726, '\P{Joining_Group= NYA}', "");
    Expect(0, 1726, '\P{^Joining_Group= NYA}', "");
    Error('\p{Jg=/a/	Nya}');
    Error('\P{Jg=/a/	Nya}');
    Expect(1, 1725, '\p{Jg=:\ANya\z:}', "");;
    Expect(0, 1726, '\p{Jg=:\ANya\z:}', "");;
    Expect(1, 1725, '\p{Jg=nya}', "");
    Expect(0, 1725, '\p{^Jg=nya}', "");
    Expect(0, 1725, '\P{Jg=nya}', "");
    Expect(1, 1725, '\P{^Jg=nya}', "");
    Expect(0, 1726, '\p{Jg=nya}', "");
    Expect(1, 1726, '\p{^Jg=nya}', "");
    Expect(1, 1726, '\P{Jg=nya}', "");
    Expect(0, 1726, '\P{^Jg=nya}', "");
    Expect(1, 1725, '\p{Jg=:\Anya\z:}', "");;
    Expect(0, 1726, '\p{Jg=:\Anya\z:}', "");;
    Expect(1, 1725, '\p{Jg=  NYA}', "");
    Expect(0, 1725, '\p{^Jg=  NYA}', "");
    Expect(0, 1725, '\P{Jg=  NYA}', "");
    Expect(1, 1725, '\P{^Jg=  NYA}', "");
    Expect(0, 1726, '\p{Jg=  NYA}', "");
    Expect(1, 1726, '\p{^Jg=  NYA}', "");
    Expect(1, 1726, '\P{Jg=  NYA}', "");
    Expect(0, 1726, '\P{^Jg=  NYA}', "");
    Error('\p{Is_Joining_Group:-/a/Nya}');
    Error('\P{Is_Joining_Group:-/a/Nya}');
    Expect(1, 1725, '\p{Is_Joining_Group: nya}', "");
    Expect(0, 1725, '\p{^Is_Joining_Group: nya}', "");
    Expect(0, 1725, '\P{Is_Joining_Group: nya}', "");
    Expect(1, 1725, '\P{^Is_Joining_Group: nya}', "");
    Expect(0, 1726, '\p{Is_Joining_Group: nya}', "");
    Expect(1, 1726, '\p{^Is_Joining_Group: nya}', "");
    Expect(1, 1726, '\P{Is_Joining_Group: nya}', "");
    Expect(0, 1726, '\P{^Is_Joining_Group: nya}', "");
    Expect(1, 1725, '\p{Is_Joining_Group=-_nya}', "");
    Expect(0, 1725, '\p{^Is_Joining_Group=-_nya}', "");
    Expect(0, 1725, '\P{Is_Joining_Group=-_nya}', "");
    Expect(1, 1725, '\P{^Is_Joining_Group=-_nya}', "");
    Expect(0, 1726, '\p{Is_Joining_Group=-_nya}', "");
    Expect(1, 1726, '\p{^Is_Joining_Group=-_nya}', "");
    Expect(1, 1726, '\P{Is_Joining_Group=-_nya}', "");
    Expect(0, 1726, '\P{^Is_Joining_Group=-_nya}', "");
    Error('\p{Is_Jg= nya:=}');
    Error('\P{Is_Jg= nya:=}');
    Expect(1, 1725, '\p{Is_Jg=nya}', "");
    Expect(0, 1725, '\p{^Is_Jg=nya}', "");
    Expect(0, 1725, '\P{Is_Jg=nya}', "");
    Expect(1, 1725, '\P{^Is_Jg=nya}', "");
    Expect(0, 1726, '\p{Is_Jg=nya}', "");
    Expect(1, 1726, '\p{^Is_Jg=nya}', "");
    Expect(1, 1726, '\P{Is_Jg=nya}', "");
    Expect(0, 1726, '\P{^Is_Jg=nya}', "");
    Expect(1, 1725, '\p{Is_Jg:	 Nya}', "");
    Expect(0, 1725, '\p{^Is_Jg:	 Nya}', "");
    Expect(0, 1725, '\P{Is_Jg:	 Nya}', "");
    Expect(1, 1725, '\P{^Is_Jg:	 Nya}', "");
    Expect(0, 1726, '\p{Is_Jg:	 Nya}', "");
    Expect(1, 1726, '\p{^Is_Jg:	 Nya}', "");
    Expect(1, 1726, '\P{Is_Jg:	 Nya}', "");
    Expect(0, 1726, '\P{^Is_Jg:	 Nya}', "");
    Error('\p{Joining_Group=_Pe:=}');
    Error('\P{Joining_Group=_Pe:=}');
    Expect(1, 1830, '\p{Joining_Group=:\APe\z:}', "");;
    Expect(0, 1831, '\p{Joining_Group=:\APe\z:}', "");;
    Expect(1, 1830, '\p{Joining_Group=pe}', "");
    Expect(0, 1830, '\p{^Joining_Group=pe}', "");
    Expect(0, 1830, '\P{Joining_Group=pe}', "");
    Expect(1, 1830, '\P{^Joining_Group=pe}', "");
    Expect(0, 1831, '\p{Joining_Group=pe}', "");
    Expect(1, 1831, '\p{^Joining_Group=pe}', "");
    Expect(1, 1831, '\P{Joining_Group=pe}', "");
    Expect(0, 1831, '\P{^Joining_Group=pe}', "");
    Expect(1, 1830, '\p{Joining_Group=:\Ape\z:}', "");;
    Expect(0, 1831, '\p{Joining_Group=:\Ape\z:}', "");;
    Expect(1, 1830, '\p{Joining_Group=_-pe}', "");
    Expect(0, 1830, '\p{^Joining_Group=_-pe}', "");
    Expect(0, 1830, '\P{Joining_Group=_-pe}', "");
    Expect(1, 1830, '\P{^Joining_Group=_-pe}', "");
    Expect(0, 1831, '\p{Joining_Group=_-pe}', "");
    Expect(1, 1831, '\p{^Joining_Group=_-pe}', "");
    Expect(1, 1831, '\P{Joining_Group=_-pe}', "");
    Expect(0, 1831, '\P{^Joining_Group=_-pe}', "");
    Error('\p{Jg=	_PE:=}');
    Error('\P{Jg=	_PE:=}');
    Expect(1, 1830, '\p{Jg=:\APe\z:}', "");;
    Expect(0, 1831, '\p{Jg=:\APe\z:}', "");;
    Expect(1, 1830, '\p{Jg=pe}', "");
    Expect(0, 1830, '\p{^Jg=pe}', "");
    Expect(0, 1830, '\P{Jg=pe}', "");
    Expect(1, 1830, '\P{^Jg=pe}', "");
    Expect(0, 1831, '\p{Jg=pe}', "");
    Expect(1, 1831, '\p{^Jg=pe}', "");
    Expect(1, 1831, '\P{Jg=pe}', "");
    Expect(0, 1831, '\P{^Jg=pe}', "");
    Expect(1, 1830, '\p{Jg=:\Ape\z:}', "");;
    Expect(0, 1831, '\p{Jg=:\Ape\z:}', "");;
    Expect(1, 1830, '\p{Jg=	_Pe}', "");
    Expect(0, 1830, '\p{^Jg=	_Pe}', "");
    Expect(0, 1830, '\P{Jg=	_Pe}', "");
    Expect(1, 1830, '\P{^Jg=	_Pe}', "");
    Expect(0, 1831, '\p{Jg=	_Pe}', "");
    Expect(1, 1831, '\p{^Jg=	_Pe}', "");
    Expect(1, 1831, '\P{Jg=	_Pe}', "");
    Expect(0, 1831, '\P{^Jg=	_Pe}', "");
    Error('\p{Is_Joining_Group=:=		PE}');
    Error('\P{Is_Joining_Group=:=		PE}');
    Expect(1, 1830, '\p{Is_Joining_Group=pe}', "");
    Expect(0, 1830, '\p{^Is_Joining_Group=pe}', "");
    Expect(0, 1830, '\P{Is_Joining_Group=pe}', "");
    Expect(1, 1830, '\P{^Is_Joining_Group=pe}', "");
    Expect(0, 1831, '\p{Is_Joining_Group=pe}', "");
    Expect(1, 1831, '\p{^Is_Joining_Group=pe}', "");
    Expect(1, 1831, '\P{Is_Joining_Group=pe}', "");
    Expect(0, 1831, '\P{^Is_Joining_Group=pe}', "");
    Expect(1, 1830, '\p{Is_Joining_Group=PE}', "");
    Expect(0, 1830, '\p{^Is_Joining_Group=PE}', "");
    Expect(0, 1830, '\P{Is_Joining_Group=PE}', "");
    Expect(1, 1830, '\P{^Is_Joining_Group=PE}', "");
    Expect(0, 1831, '\p{Is_Joining_Group=PE}', "");
    Expect(1, 1831, '\p{^Is_Joining_Group=PE}', "");
    Expect(1, 1831, '\P{Is_Joining_Group=PE}', "");
    Expect(0, 1831, '\P{^Is_Joining_Group=PE}', "");
    Error('\p{Is_Jg=-/a/Pe}');
    Error('\P{Is_Jg=-/a/Pe}');
    Expect(1, 1830, '\p{Is_Jg: pe}', "");
    Expect(0, 1830, '\p{^Is_Jg: pe}', "");
    Expect(0, 1830, '\P{Is_Jg: pe}', "");
    Expect(1, 1830, '\P{^Is_Jg: pe}', "");
    Expect(0, 1831, '\p{Is_Jg: pe}', "");
    Expect(1, 1831, '\p{^Is_Jg: pe}', "");
    Expect(1, 1831, '\P{Is_Jg: pe}', "");
    Expect(0, 1831, '\P{^Is_Jg: pe}', "");
    Expect(1, 1830, '\p{Is_Jg=-	PE}', "");
    Expect(0, 1830, '\p{^Is_Jg=-	PE}', "");
    Expect(0, 1830, '\P{Is_Jg=-	PE}', "");
    Expect(1, 1830, '\P{^Is_Jg=-	PE}', "");
    Expect(0, 1831, '\p{Is_Jg=-	PE}', "");
    Expect(1, 1831, '\p{^Is_Jg=-	PE}', "");
    Expect(1, 1831, '\P{Is_Jg=-	PE}', "");
    Expect(0, 1831, '\P{^Is_Jg=-	PE}', "");
    Error('\p{Joining_Group=/a/	-qaf}');
    Error('\P{Joining_Group=/a/	-qaf}');
    Expect(1, 2213, '\p{Joining_Group=:\AQaf\z:}', "");;
    Expect(0, 2214, '\p{Joining_Group=:\AQaf\z:}', "");;
    Expect(1, 2213, '\p{Joining_Group=qaf}', "");
    Expect(0, 2213, '\p{^Joining_Group=qaf}', "");
    Expect(0, 2213, '\P{Joining_Group=qaf}', "");
    Expect(1, 2213, '\P{^Joining_Group=qaf}', "");
    Expect(0, 2214, '\p{Joining_Group=qaf}', "");
    Expect(1, 2214, '\p{^Joining_Group=qaf}', "");
    Expect(1, 2214, '\P{Joining_Group=qaf}', "");
    Expect(0, 2214, '\P{^Joining_Group=qaf}', "");
    Expect(1, 2213, '\p{Joining_Group=:\Aqaf\z:}', "");;
    Expect(0, 2214, '\p{Joining_Group=:\Aqaf\z:}', "");;
    Expect(1, 2213, '\p{Joining_Group=	-Qaf}', "");
    Expect(0, 2213, '\p{^Joining_Group=	-Qaf}', "");
    Expect(0, 2213, '\P{Joining_Group=	-Qaf}', "");
    Expect(1, 2213, '\P{^Joining_Group=	-Qaf}', "");
    Expect(0, 2214, '\p{Joining_Group=	-Qaf}', "");
    Expect(1, 2214, '\p{^Joining_Group=	-Qaf}', "");
    Expect(1, 2214, '\P{Joining_Group=	-Qaf}', "");
    Expect(0, 2214, '\P{^Joining_Group=	-Qaf}', "");
    Error('\p{Jg=-	Qaf/a/}');
    Error('\P{Jg=-	Qaf/a/}');
    Expect(1, 2213, '\p{Jg=:\AQaf\z:}', "");;
    Expect(0, 2214, '\p{Jg=:\AQaf\z:}', "");;
    Expect(1, 2213, '\p{Jg=qaf}', "");
    Expect(0, 2213, '\p{^Jg=qaf}', "");
    Expect(0, 2213, '\P{Jg=qaf}', "");
    Expect(1, 2213, '\P{^Jg=qaf}', "");
    Expect(0, 2214, '\p{Jg=qaf}', "");
    Expect(1, 2214, '\p{^Jg=qaf}', "");
    Expect(1, 2214, '\P{Jg=qaf}', "");
    Expect(0, 2214, '\P{^Jg=qaf}', "");
    Expect(1, 2213, '\p{Jg=:\Aqaf\z:}', "");;
    Expect(0, 2214, '\p{Jg=:\Aqaf\z:}', "");;
    Expect(1, 2213, '\p{Jg= Qaf}', "");
    Expect(0, 2213, '\p{^Jg= Qaf}', "");
    Expect(0, 2213, '\P{Jg= Qaf}', "");
    Expect(1, 2213, '\P{^Jg= Qaf}', "");
    Expect(0, 2214, '\p{Jg= Qaf}', "");
    Expect(1, 2214, '\p{^Jg= Qaf}', "");
    Expect(1, 2214, '\P{Jg= Qaf}', "");
    Expect(0, 2214, '\P{^Jg= Qaf}', "");
    Error('\p{Is_Joining_Group=:=Qaf}');
    Error('\P{Is_Joining_Group=:=Qaf}');
    Expect(1, 2213, '\p{Is_Joining_Group=qaf}', "");
    Expect(0, 2213, '\p{^Is_Joining_Group=qaf}', "");
    Expect(0, 2213, '\P{Is_Joining_Group=qaf}', "");
    Expect(1, 2213, '\P{^Is_Joining_Group=qaf}', "");
    Expect(0, 2214, '\p{Is_Joining_Group=qaf}', "");
    Expect(1, 2214, '\p{^Is_Joining_Group=qaf}', "");
    Expect(1, 2214, '\P{Is_Joining_Group=qaf}', "");
    Expect(0, 2214, '\P{^Is_Joining_Group=qaf}', "");
    Expect(1, 2213, '\p{Is_Joining_Group=_	qaf}', "");
    Expect(0, 2213, '\p{^Is_Joining_Group=_	qaf}', "");
    Expect(0, 2213, '\P{Is_Joining_Group=_	qaf}', "");
    Expect(1, 2213, '\P{^Is_Joining_Group=_	qaf}', "");
    Expect(0, 2214, '\p{Is_Joining_Group=_	qaf}', "");
    Expect(1, 2214, '\p{^Is_Joining_Group=_	qaf}', "");
    Expect(1, 2214, '\P{Is_Joining_Group=_	qaf}', "");
    Expect(0, 2214, '\P{^Is_Joining_Group=_	qaf}', "");
    Error('\p{Is_Jg=	/a/Qaf}');
    Error('\P{Is_Jg=	/a/Qaf}');
    Expect(1, 2213, '\p{Is_Jg=qaf}', "");
    Expect(0, 2213, '\p{^Is_Jg=qaf}', "");
    Expect(0, 2213, '\P{Is_Jg=qaf}', "");
    Expect(1, 2213, '\P{^Is_Jg=qaf}', "");
    Expect(0, 2214, '\p{Is_Jg=qaf}', "");
    Expect(1, 2214, '\p{^Is_Jg=qaf}', "");
    Expect(1, 2214, '\P{Is_Jg=qaf}', "");
    Expect(0, 2214, '\P{^Is_Jg=qaf}', "");
    Expect(1, 2213, '\p{Is_Jg:		_QAF}', "");
    Expect(0, 2213, '\p{^Is_Jg:		_QAF}', "");
    Expect(0, 2213, '\P{Is_Jg:		_QAF}', "");
    Expect(1, 2213, '\P{^Is_Jg:		_QAF}', "");
    Expect(0, 2214, '\p{Is_Jg:		_QAF}', "");
    Expect(1, 2214, '\p{^Is_Jg:		_QAF}', "");
    Expect(1, 2214, '\P{Is_Jg:		_QAF}', "");
    Expect(0, 2214, '\P{^Is_Jg:		_QAF}', "");
    Error('\p{Joining_Group=:=_qaph}');
    Error('\P{Joining_Group=:=_qaph}');
    Expect(1, 1833, '\p{Joining_Group=:\AQaph\z:}', "");;
    Expect(0, 1834, '\p{Joining_Group=:\AQaph\z:}', "");;
    Expect(1, 1833, '\p{Joining_Group=qaph}', "");
    Expect(0, 1833, '\p{^Joining_Group=qaph}', "");
    Expect(0, 1833, '\P{Joining_Group=qaph}', "");
    Expect(1, 1833, '\P{^Joining_Group=qaph}', "");
    Expect(0, 1834, '\p{Joining_Group=qaph}', "");
    Expect(1, 1834, '\p{^Joining_Group=qaph}', "");
    Expect(1, 1834, '\P{Joining_Group=qaph}', "");
    Expect(0, 1834, '\P{^Joining_Group=qaph}', "");
    Expect(1, 1833, '\p{Joining_Group=:\Aqaph\z:}', "");;
    Expect(0, 1834, '\p{Joining_Group=:\Aqaph\z:}', "");;
    Expect(1, 1833, '\p{Joining_Group=	qaph}', "");
    Expect(0, 1833, '\p{^Joining_Group=	qaph}', "");
    Expect(0, 1833, '\P{Joining_Group=	qaph}', "");
    Expect(1, 1833, '\P{^Joining_Group=	qaph}', "");
    Expect(0, 1834, '\p{Joining_Group=	qaph}', "");
    Expect(1, 1834, '\p{^Joining_Group=	qaph}', "");
    Expect(1, 1834, '\P{Joining_Group=	qaph}', "");
    Expect(0, 1834, '\P{^Joining_Group=	qaph}', "");
    Error('\p{Jg=  qaph:=}');
    Error('\P{Jg=  qaph:=}');
    Expect(1, 1833, '\p{Jg=:\AQaph\z:}', "");;
    Expect(0, 1834, '\p{Jg=:\AQaph\z:}', "");;
    Expect(1, 1833, '\p{Jg=qaph}', "");
    Expect(0, 1833, '\p{^Jg=qaph}', "");
    Expect(0, 1833, '\P{Jg=qaph}', "");
    Expect(1, 1833, '\P{^Jg=qaph}', "");
    Expect(0, 1834, '\p{Jg=qaph}', "");
    Expect(1, 1834, '\p{^Jg=qaph}', "");
    Expect(1, 1834, '\P{Jg=qaph}', "");
    Expect(0, 1834, '\P{^Jg=qaph}', "");
    Expect(1, 1833, '\p{Jg=:\Aqaph\z:}', "");;
    Expect(0, 1834, '\p{Jg=:\Aqaph\z:}', "");;
    Expect(1, 1833, '\p{Jg= _qaph}', "");
    Expect(0, 1833, '\p{^Jg= _qaph}', "");
    Expect(0, 1833, '\P{Jg= _qaph}', "");
    Expect(1, 1833, '\P{^Jg= _qaph}', "");
    Expect(0, 1834, '\p{Jg= _qaph}', "");
    Expect(1, 1834, '\p{^Jg= _qaph}', "");
    Expect(1, 1834, '\P{Jg= _qaph}', "");
    Expect(0, 1834, '\P{^Jg= _qaph}', "");
    Error('\p{Is_Joining_Group=:= _QAPH}');
    Error('\P{Is_Joining_Group=:= _QAPH}');
    Expect(1, 1833, '\p{Is_Joining_Group=qaph}', "");
    Expect(0, 1833, '\p{^Is_Joining_Group=qaph}', "");
    Expect(0, 1833, '\P{Is_Joining_Group=qaph}', "");
    Expect(1, 1833, '\P{^Is_Joining_Group=qaph}', "");
    Expect(0, 1834, '\p{Is_Joining_Group=qaph}', "");
    Expect(1, 1834, '\p{^Is_Joining_Group=qaph}', "");
    Expect(1, 1834, '\P{Is_Joining_Group=qaph}', "");
    Expect(0, 1834, '\P{^Is_Joining_Group=qaph}', "");
    Expect(1, 1833, '\p{Is_Joining_Group=_-qaph}', "");
    Expect(0, 1833, '\p{^Is_Joining_Group=_-qaph}', "");
    Expect(0, 1833, '\P{Is_Joining_Group=_-qaph}', "");
    Expect(1, 1833, '\P{^Is_Joining_Group=_-qaph}', "");
    Expect(0, 1834, '\p{Is_Joining_Group=_-qaph}', "");
    Expect(1, 1834, '\p{^Is_Joining_Group=_-qaph}', "");
    Expect(1, 1834, '\P{Is_Joining_Group=_-qaph}', "");
    Expect(0, 1834, '\P{^Is_Joining_Group=_-qaph}', "");
    Error('\p{Is_Jg= :=Qaph}');
    Error('\P{Is_Jg= :=Qaph}');
    Expect(1, 1833, '\p{Is_Jg=qaph}', "");
    Expect(0, 1833, '\p{^Is_Jg=qaph}', "");
    Expect(0, 1833, '\P{Is_Jg=qaph}', "");
    Expect(1, 1833, '\P{^Is_Jg=qaph}', "");
    Expect(0, 1834, '\p{Is_Jg=qaph}', "");
    Expect(1, 1834, '\p{^Is_Jg=qaph}', "");
    Expect(1, 1834, '\P{Is_Jg=qaph}', "");
    Expect(0, 1834, '\P{^Is_Jg=qaph}', "");
    Expect(1, 1833, '\p{Is_Jg=	_Qaph}', "");
    Expect(0, 1833, '\p{^Is_Jg=	_Qaph}', "");
    Expect(0, 1833, '\P{Is_Jg=	_Qaph}', "");
    Expect(1, 1833, '\P{^Is_Jg=	_Qaph}', "");
    Expect(0, 1834, '\p{Is_Jg=	_Qaph}', "");
    Expect(1, 1834, '\p{^Is_Jg=	_Qaph}', "");
    Expect(1, 1834, '\P{Is_Jg=	_Qaph}', "");
    Expect(0, 1834, '\P{^Is_Jg=	_Qaph}', "");
    Error('\p{Joining_Group: :=- reh}');
    Error('\P{Joining_Group: :=- reh}');
    Expect(1, 2233, '\p{Joining_Group=:\AReh\z:}', "");;
    Expect(0, 2234, '\p{Joining_Group=:\AReh\z:}', "");;
    Expect(1, 2233, '\p{Joining_Group=reh}', "");
    Expect(0, 2233, '\p{^Joining_Group=reh}', "");
    Expect(0, 2233, '\P{Joining_Group=reh}', "");
    Expect(1, 2233, '\P{^Joining_Group=reh}', "");
    Expect(0, 2234, '\p{Joining_Group=reh}', "");
    Expect(1, 2234, '\p{^Joining_Group=reh}', "");
    Expect(1, 2234, '\P{Joining_Group=reh}', "");
    Expect(0, 2234, '\P{^Joining_Group=reh}', "");
    Expect(1, 2233, '\p{Joining_Group=:\Areh\z:}', "");;
    Expect(0, 2234, '\p{Joining_Group=:\Areh\z:}', "");;
    Expect(1, 2233, '\p{Joining_Group=-Reh}', "");
    Expect(0, 2233, '\p{^Joining_Group=-Reh}', "");
    Expect(0, 2233, '\P{Joining_Group=-Reh}', "");
    Expect(1, 2233, '\P{^Joining_Group=-Reh}', "");
    Expect(0, 2234, '\p{Joining_Group=-Reh}', "");
    Expect(1, 2234, '\p{^Joining_Group=-Reh}', "");
    Expect(1, 2234, '\P{Joining_Group=-Reh}', "");
    Expect(0, 2234, '\P{^Joining_Group=-Reh}', "");
    Error('\p{Jg:  	reh/a/}');
    Error('\P{Jg:  	reh/a/}');
    Expect(1, 2233, '\p{Jg=:\AReh\z:}', "");;
    Expect(0, 2234, '\p{Jg=:\AReh\z:}', "");;
    Expect(1, 2233, '\p{Jg=reh}', "");
    Expect(0, 2233, '\p{^Jg=reh}', "");
    Expect(0, 2233, '\P{Jg=reh}', "");
    Expect(1, 2233, '\P{^Jg=reh}', "");
    Expect(0, 2234, '\p{Jg=reh}', "");
    Expect(1, 2234, '\p{^Jg=reh}', "");
    Expect(1, 2234, '\P{Jg=reh}', "");
    Expect(0, 2234, '\P{^Jg=reh}', "");
    Expect(1, 2233, '\p{Jg=:\Areh\z:}', "");;
    Expect(0, 2234, '\p{Jg=:\Areh\z:}', "");;
    Expect(1, 2233, '\p{Jg=	Reh}', "");
    Expect(0, 2233, '\p{^Jg=	Reh}', "");
    Expect(0, 2233, '\P{Jg=	Reh}', "");
    Expect(1, 2233, '\P{^Jg=	Reh}', "");
    Expect(0, 2234, '\p{Jg=	Reh}', "");
    Expect(1, 2234, '\p{^Jg=	Reh}', "");
    Expect(1, 2234, '\P{Jg=	Reh}', "");
    Expect(0, 2234, '\P{^Jg=	Reh}', "");
    Error('\p{Is_Joining_Group=	:=REH}');
    Error('\P{Is_Joining_Group=	:=REH}');
    Expect(1, 2233, '\p{Is_Joining_Group=reh}', "");
    Expect(0, 2233, '\p{^Is_Joining_Group=reh}', "");
    Expect(0, 2233, '\P{Is_Joining_Group=reh}', "");
    Expect(1, 2233, '\P{^Is_Joining_Group=reh}', "");
    Expect(0, 2234, '\p{Is_Joining_Group=reh}', "");
    Expect(1, 2234, '\p{^Is_Joining_Group=reh}', "");
    Expect(1, 2234, '\P{Is_Joining_Group=reh}', "");
    Expect(0, 2234, '\P{^Is_Joining_Group=reh}', "");
    Expect(1, 2233, '\p{Is_Joining_Group=  REH}', "");
    Expect(0, 2233, '\p{^Is_Joining_Group=  REH}', "");
    Expect(0, 2233, '\P{Is_Joining_Group=  REH}', "");
    Expect(1, 2233, '\P{^Is_Joining_Group=  REH}', "");
    Expect(0, 2234, '\p{Is_Joining_Group=  REH}', "");
    Expect(1, 2234, '\p{^Is_Joining_Group=  REH}', "");
    Expect(1, 2234, '\P{Is_Joining_Group=  REH}', "");
    Expect(0, 2234, '\P{^Is_Joining_Group=  REH}', "");
    Error('\p{Is_Jg=-/a/REH}');
    Error('\P{Is_Jg=-/a/REH}');
    Expect(1, 2233, '\p{Is_Jg=reh}', "");
    Expect(0, 2233, '\p{^Is_Jg=reh}', "");
    Expect(0, 2233, '\P{Is_Jg=reh}', "");
    Expect(1, 2233, '\P{^Is_Jg=reh}', "");
    Expect(0, 2234, '\p{Is_Jg=reh}', "");
    Expect(1, 2234, '\p{^Is_Jg=reh}', "");
    Expect(1, 2234, '\P{Is_Jg=reh}', "");
    Expect(0, 2234, '\P{^Is_Jg=reh}', "");
    Expect(1, 2233, '\p{Is_Jg=-Reh}', "");
    Expect(0, 2233, '\p{^Is_Jg=-Reh}', "");
    Expect(0, 2233, '\P{Is_Jg=-Reh}', "");
    Expect(1, 2233, '\P{^Is_Jg=-Reh}', "");
    Expect(0, 2234, '\p{Is_Jg=-Reh}', "");
    Expect(1, 2234, '\p{^Is_Jg=-Reh}', "");
    Expect(1, 2234, '\P{Is_Jg=-Reh}', "");
    Expect(0, 2234, '\P{^Is_Jg=-Reh}', "");
    Error('\p{Joining_Group=:=REVERSED_Pe}');
    Error('\P{Joining_Group=:=REVERSED_Pe}');
    Expect(1, 1831, '\p{Joining_Group=:\AReversed_Pe\z:}', "");;
    Expect(0, 1832, '\p{Joining_Group=:\AReversed_Pe\z:}', "");;
    Expect(1, 1831, '\p{Joining_Group=reversedpe}', "");
    Expect(0, 1831, '\p{^Joining_Group=reversedpe}', "");
    Expect(0, 1831, '\P{Joining_Group=reversedpe}', "");
    Expect(1, 1831, '\P{^Joining_Group=reversedpe}', "");
    Expect(0, 1832, '\p{Joining_Group=reversedpe}', "");
    Expect(1, 1832, '\p{^Joining_Group=reversedpe}', "");
    Expect(1, 1832, '\P{Joining_Group=reversedpe}', "");
    Expect(0, 1832, '\P{^Joining_Group=reversedpe}', "");
    Expect(1, 1831, '\p{Joining_Group=:\Areversedpe\z:}', "");;
    Expect(0, 1832, '\p{Joining_Group=:\Areversedpe\z:}', "");;
    Expect(1, 1831, '\p{Joining_Group=-reversed_pe}', "");
    Expect(0, 1831, '\p{^Joining_Group=-reversed_pe}', "");
    Expect(0, 1831, '\P{Joining_Group=-reversed_pe}', "");
    Expect(1, 1831, '\P{^Joining_Group=-reversed_pe}', "");
    Expect(0, 1832, '\p{Joining_Group=-reversed_pe}', "");
    Expect(1, 1832, '\p{^Joining_Group=-reversed_pe}', "");
    Expect(1, 1832, '\P{Joining_Group=-reversed_pe}', "");
    Expect(0, 1832, '\P{^Joining_Group=-reversed_pe}', "");
    Error('\p{Jg= /a/REVERSED_pe}');
    Error('\P{Jg= /a/REVERSED_pe}');
    Expect(1, 1831, '\p{Jg=:\AReversed_Pe\z:}', "");;
    Expect(0, 1832, '\p{Jg=:\AReversed_Pe\z:}', "");;
    Expect(1, 1831, '\p{Jg=reversedpe}', "");
    Expect(0, 1831, '\p{^Jg=reversedpe}', "");
    Expect(0, 1831, '\P{Jg=reversedpe}', "");
    Expect(1, 1831, '\P{^Jg=reversedpe}', "");
    Expect(0, 1832, '\p{Jg=reversedpe}', "");
    Expect(1, 1832, '\p{^Jg=reversedpe}', "");
    Expect(1, 1832, '\P{Jg=reversedpe}', "");
    Expect(0, 1832, '\P{^Jg=reversedpe}', "");
    Expect(1, 1831, '\p{Jg=:\Areversedpe\z:}', "");;
    Expect(0, 1832, '\p{Jg=:\Areversedpe\z:}', "");;
    Expect(1, 1831, '\p{Jg=	 Reversed_pe}', "");
    Expect(0, 1831, '\p{^Jg=	 Reversed_pe}', "");
    Expect(0, 1831, '\P{Jg=	 Reversed_pe}', "");
    Expect(1, 1831, '\P{^Jg=	 Reversed_pe}', "");
    Expect(0, 1832, '\p{Jg=	 Reversed_pe}', "");
    Expect(1, 1832, '\p{^Jg=	 Reversed_pe}', "");
    Expect(1, 1832, '\P{Jg=	 Reversed_pe}', "");
    Expect(0, 1832, '\P{^Jg=	 Reversed_pe}', "");
    Error('\p{Is_Joining_Group:    REVERSED_PE:=}');
    Error('\P{Is_Joining_Group:    REVERSED_PE:=}');
    Expect(1, 1831, '\p{Is_Joining_Group=reversedpe}', "");
    Expect(0, 1831, '\p{^Is_Joining_Group=reversedpe}', "");
    Expect(0, 1831, '\P{Is_Joining_Group=reversedpe}', "");
    Expect(1, 1831, '\P{^Is_Joining_Group=reversedpe}', "");
    Expect(0, 1832, '\p{Is_Joining_Group=reversedpe}', "");
    Expect(1, 1832, '\p{^Is_Joining_Group=reversedpe}', "");
    Expect(1, 1832, '\P{Is_Joining_Group=reversedpe}', "");
    Expect(0, 1832, '\P{^Is_Joining_Group=reversedpe}', "");
    Expect(1, 1831, '\p{Is_Joining_Group=		reversed_PE}', "");
    Expect(0, 1831, '\p{^Is_Joining_Group=		reversed_PE}', "");
    Expect(0, 1831, '\P{Is_Joining_Group=		reversed_PE}', "");
    Expect(1, 1831, '\P{^Is_Joining_Group=		reversed_PE}', "");
    Expect(0, 1832, '\p{Is_Joining_Group=		reversed_PE}', "");
    Expect(1, 1832, '\p{^Is_Joining_Group=		reversed_PE}', "");
    Expect(1, 1832, '\P{Is_Joining_Group=		reversed_PE}', "");
    Expect(0, 1832, '\P{^Is_Joining_Group=		reversed_PE}', "");
    Error('\p{Is_Jg=:=	-reversed_Pe}');
    Error('\P{Is_Jg=:=	-reversed_Pe}');
    Expect(1, 1831, '\p{Is_Jg=reversedpe}', "");
    Expect(0, 1831, '\p{^Is_Jg=reversedpe}', "");
    Expect(0, 1831, '\P{Is_Jg=reversedpe}', "");
    Expect(1, 1831, '\P{^Is_Jg=reversedpe}', "");
    Expect(0, 1832, '\p{Is_Jg=reversedpe}', "");
    Expect(1, 1832, '\p{^Is_Jg=reversedpe}', "");
    Expect(1, 1832, '\P{Is_Jg=reversedpe}', "");
    Expect(0, 1832, '\P{^Is_Jg=reversedpe}', "");
    Expect(1, 1831, '\p{Is_Jg=-_reversed_PE}', "");
    Expect(0, 1831, '\p{^Is_Jg=-_reversed_PE}', "");
    Expect(0, 1831, '\P{Is_Jg=-_reversed_PE}', "");
    Expect(1, 1831, '\P{^Is_Jg=-_reversed_PE}', "");
    Expect(0, 1832, '\p{Is_Jg=-_reversed_PE}', "");
    Expect(1, 1832, '\p{^Is_Jg=-_reversed_PE}', "");
    Expect(1, 1832, '\P{Is_Jg=-_reversed_PE}', "");
    Expect(0, 1832, '\P{^Is_Jg=-_reversed_PE}', "");
    Error('\p{Joining_Group=--Rohingya_yeh:=}');
    Error('\P{Joining_Group=--Rohingya_yeh:=}');
    Expect(1, 2220, '\p{Joining_Group=:\ARohingya_Yeh\z:}', "");;
    Expect(0, 2221, '\p{Joining_Group=:\ARohingya_Yeh\z:}', "");;
    Expect(1, 2220, '\p{Joining_Group=rohingyayeh}', "");
    Expect(0, 2220, '\p{^Joining_Group=rohingyayeh}', "");
    Expect(0, 2220, '\P{Joining_Group=rohingyayeh}', "");
    Expect(1, 2220, '\P{^Joining_Group=rohingyayeh}', "");
    Expect(0, 2221, '\p{Joining_Group=rohingyayeh}', "");
    Expect(1, 2221, '\p{^Joining_Group=rohingyayeh}', "");
    Expect(1, 2221, '\P{Joining_Group=rohingyayeh}', "");
    Expect(0, 2221, '\P{^Joining_Group=rohingyayeh}', "");
    Expect(1, 2220, '\p{Joining_Group=:\Arohingyayeh\z:}', "");;
    Expect(0, 2221, '\p{Joining_Group=:\Arohingyayeh\z:}', "");;
    Expect(1, 2220, '\p{Joining_Group= _rohingya_Yeh}', "");
    Expect(0, 2220, '\p{^Joining_Group= _rohingya_Yeh}', "");
    Expect(0, 2220, '\P{Joining_Group= _rohingya_Yeh}', "");
    Expect(1, 2220, '\P{^Joining_Group= _rohingya_Yeh}', "");
    Expect(0, 2221, '\p{Joining_Group= _rohingya_Yeh}', "");
    Expect(1, 2221, '\p{^Joining_Group= _rohingya_Yeh}', "");
    Expect(1, 2221, '\P{Joining_Group= _rohingya_Yeh}', "");
    Expect(0, 2221, '\P{^Joining_Group= _rohingya_Yeh}', "");
    Error('\p{Jg= Rohingya_yeh:=}');
    Error('\P{Jg= Rohingya_yeh:=}');
    Expect(1, 2220, '\p{Jg=:\ARohingya_Yeh\z:}', "");;
    Expect(0, 2221, '\p{Jg=:\ARohingya_Yeh\z:}', "");;
    Expect(1, 2220, '\p{Jg=rohingyayeh}', "");
    Expect(0, 2220, '\p{^Jg=rohingyayeh}', "");
    Expect(0, 2220, '\P{Jg=rohingyayeh}', "");
    Expect(1, 2220, '\P{^Jg=rohingyayeh}', "");
    Expect(0, 2221, '\p{Jg=rohingyayeh}', "");
    Expect(1, 2221, '\p{^Jg=rohingyayeh}', "");
    Expect(1, 2221, '\P{Jg=rohingyayeh}', "");
    Expect(0, 2221, '\P{^Jg=rohingyayeh}', "");
    Expect(1, 2220, '\p{Jg=:\Arohingyayeh\z:}', "");;
    Expect(0, 2221, '\p{Jg=:\Arohingyayeh\z:}', "");;
    Expect(1, 2220, '\p{Jg=	Rohingya_Yeh}', "");
    Expect(0, 2220, '\p{^Jg=	Rohingya_Yeh}', "");
    Expect(0, 2220, '\P{Jg=	Rohingya_Yeh}', "");
    Expect(1, 2220, '\P{^Jg=	Rohingya_Yeh}', "");
    Expect(0, 2221, '\p{Jg=	Rohingya_Yeh}', "");
    Expect(1, 2221, '\p{^Jg=	Rohingya_Yeh}', "");
    Expect(1, 2221, '\P{Jg=	Rohingya_Yeh}', "");
    Expect(0, 2221, '\P{^Jg=	Rohingya_Yeh}', "");
    Error('\p{Is_Joining_Group=	/a/Rohingya_YEH}');
    Error('\P{Is_Joining_Group=	/a/Rohingya_YEH}');
    Expect(1, 2220, '\p{Is_Joining_Group=rohingyayeh}', "");
    Expect(0, 2220, '\p{^Is_Joining_Group=rohingyayeh}', "");
    Expect(0, 2220, '\P{Is_Joining_Group=rohingyayeh}', "");
    Expect(1, 2220, '\P{^Is_Joining_Group=rohingyayeh}', "");
    Expect(0, 2221, '\p{Is_Joining_Group=rohingyayeh}', "");
    Expect(1, 2221, '\p{^Is_Joining_Group=rohingyayeh}', "");
    Expect(1, 2221, '\P{Is_Joining_Group=rohingyayeh}', "");
    Expect(0, 2221, '\P{^Is_Joining_Group=rohingyayeh}', "");
    Expect(1, 2220, '\p{Is_Joining_Group=ROHINGYA_yeh}', "");
    Expect(0, 2220, '\p{^Is_Joining_Group=ROHINGYA_yeh}', "");
    Expect(0, 2220, '\P{Is_Joining_Group=ROHINGYA_yeh}', "");
    Expect(1, 2220, '\P{^Is_Joining_Group=ROHINGYA_yeh}', "");
    Expect(0, 2221, '\p{Is_Joining_Group=ROHINGYA_yeh}', "");
    Expect(1, 2221, '\p{^Is_Joining_Group=ROHINGYA_yeh}', "");
    Expect(1, 2221, '\P{Is_Joining_Group=ROHINGYA_yeh}', "");
    Expect(0, 2221, '\P{^Is_Joining_Group=ROHINGYA_yeh}', "");
    Error('\p{Is_Jg=:=-Rohingya_Yeh}');
    Error('\P{Is_Jg=:=-Rohingya_Yeh}');
    Expect(1, 2220, '\p{Is_Jg=rohingyayeh}', "");
    Expect(0, 2220, '\p{^Is_Jg=rohingyayeh}', "");
    Expect(0, 2220, '\P{Is_Jg=rohingyayeh}', "");
    Expect(1, 2220, '\P{^Is_Jg=rohingyayeh}', "");
    Expect(0, 2221, '\p{Is_Jg=rohingyayeh}', "");
    Expect(1, 2221, '\p{^Is_Jg=rohingyayeh}', "");
    Expect(1, 2221, '\P{Is_Jg=rohingyayeh}', "");
    Expect(0, 2221, '\P{^Is_Jg=rohingyayeh}', "");
    Expect(1, 2220, '\p{Is_Jg=-	Rohingya_YEH}', "");
    Expect(0, 2220, '\p{^Is_Jg=-	Rohingya_YEH}', "");
    Expect(0, 2220, '\P{Is_Jg=-	Rohingya_YEH}', "");
    Expect(1, 2220, '\P{^Is_Jg=-	Rohingya_YEH}', "");
    Expect(0, 2221, '\p{Is_Jg=-	Rohingya_YEH}', "");
    Expect(1, 2221, '\p{^Is_Jg=-	Rohingya_YEH}', "");
    Expect(1, 2221, '\P{Is_Jg=-	Rohingya_YEH}', "");
    Expect(0, 2221, '\P{^Is_Jg=-	Rohingya_YEH}', "");
    Error('\p{Joining_Group=	-Sad/a/}');
    Error('\P{Joining_Group=	-Sad/a/}');
    Expect(1, 2223, '\p{Joining_Group=:\ASad\z:}', "");;
    Expect(0, 2224, '\p{Joining_Group=:\ASad\z:}', "");;
    Expect(1, 2223, '\p{Joining_Group=sad}', "");
    Expect(0, 2223, '\p{^Joining_Group=sad}', "");
    Expect(0, 2223, '\P{Joining_Group=sad}', "");
    Expect(1, 2223, '\P{^Joining_Group=sad}', "");
    Expect(0, 2224, '\p{Joining_Group=sad}', "");
    Expect(1, 2224, '\p{^Joining_Group=sad}', "");
    Expect(1, 2224, '\P{Joining_Group=sad}', "");
    Expect(0, 2224, '\P{^Joining_Group=sad}', "");
    Expect(1, 2223, '\p{Joining_Group=:\Asad\z:}', "");;
    Expect(0, 2224, '\p{Joining_Group=:\Asad\z:}', "");;
    Expect(1, 2223, '\p{Joining_Group=  Sad}', "");
    Expect(0, 2223, '\p{^Joining_Group=  Sad}', "");
    Expect(0, 2223, '\P{Joining_Group=  Sad}', "");
    Expect(1, 2223, '\P{^Joining_Group=  Sad}', "");
    Expect(0, 2224, '\p{Joining_Group=  Sad}', "");
    Expect(1, 2224, '\p{^Joining_Group=  Sad}', "");
    Expect(1, 2224, '\P{Joining_Group=  Sad}', "");
    Expect(0, 2224, '\P{^Joining_Group=  Sad}', "");
    Error('\p{Jg=:=_ sad}');
    Error('\P{Jg=:=_ sad}');
    Expect(1, 2223, '\p{Jg=:\ASad\z:}', "");;
    Expect(0, 2224, '\p{Jg=:\ASad\z:}', "");;
    Expect(1, 2223, '\p{Jg=sad}', "");
    Expect(0, 2223, '\p{^Jg=sad}', "");
    Expect(0, 2223, '\P{Jg=sad}', "");
    Expect(1, 2223, '\P{^Jg=sad}', "");
    Expect(0, 2224, '\p{Jg=sad}', "");
    Expect(1, 2224, '\p{^Jg=sad}', "");
    Expect(1, 2224, '\P{Jg=sad}', "");
    Expect(0, 2224, '\P{^Jg=sad}', "");
    Expect(1, 2223, '\p{Jg=:\Asad\z:}', "");;
    Expect(0, 2224, '\p{Jg=:\Asad\z:}', "");;
    Expect(1, 2223, '\p{Jg=-Sad}', "");
    Expect(0, 2223, '\p{^Jg=-Sad}', "");
    Expect(0, 2223, '\P{Jg=-Sad}', "");
    Expect(1, 2223, '\P{^Jg=-Sad}', "");
    Expect(0, 2224, '\p{Jg=-Sad}', "");
    Expect(1, 2224, '\p{^Jg=-Sad}', "");
    Expect(1, 2224, '\P{Jg=-Sad}', "");
    Expect(0, 2224, '\P{^Jg=-Sad}', "");
    Error('\p{Is_Joining_Group=/a/- Sad}');
    Error('\P{Is_Joining_Group=/a/- Sad}');
    Expect(1, 2223, '\p{Is_Joining_Group=sad}', "");
    Expect(0, 2223, '\p{^Is_Joining_Group=sad}', "");
    Expect(0, 2223, '\P{Is_Joining_Group=sad}', "");
    Expect(1, 2223, '\P{^Is_Joining_Group=sad}', "");
    Expect(0, 2224, '\p{Is_Joining_Group=sad}', "");
    Expect(1, 2224, '\p{^Is_Joining_Group=sad}', "");
    Expect(1, 2224, '\P{Is_Joining_Group=sad}', "");
    Expect(0, 2224, '\P{^Is_Joining_Group=sad}', "");
    Expect(1, 2223, '\p{Is_Joining_Group=_SAD}', "");
    Expect(0, 2223, '\p{^Is_Joining_Group=_SAD}', "");
    Expect(0, 2223, '\P{Is_Joining_Group=_SAD}', "");
    Expect(1, 2223, '\P{^Is_Joining_Group=_SAD}', "");
    Expect(0, 2224, '\p{Is_Joining_Group=_SAD}', "");
    Expect(1, 2224, '\p{^Is_Joining_Group=_SAD}', "");
    Expect(1, 2224, '\P{Is_Joining_Group=_SAD}', "");
    Expect(0, 2224, '\P{^Is_Joining_Group=_SAD}', "");
    Error('\p{Is_Jg=:=__sad}');
    Error('\P{Is_Jg=:=__sad}');
    Expect(1, 2223, '\p{Is_Jg=sad}', "");
    Expect(0, 2223, '\p{^Is_Jg=sad}', "");
    Expect(0, 2223, '\P{Is_Jg=sad}', "");
    Expect(1, 2223, '\P{^Is_Jg=sad}', "");
    Expect(0, 2224, '\p{Is_Jg=sad}', "");
    Expect(1, 2224, '\p{^Is_Jg=sad}', "");
    Expect(1, 2224, '\P{Is_Jg=sad}', "");
    Expect(0, 2224, '\P{^Is_Jg=sad}', "");
    Expect(1, 2223, '\p{Is_Jg=-SAD}', "");
    Expect(0, 2223, '\p{^Is_Jg=-SAD}', "");
    Expect(0, 2223, '\P{Is_Jg=-SAD}', "");
    Expect(1, 2223, '\P{^Is_Jg=-SAD}', "");
    Expect(0, 2224, '\p{Is_Jg=-SAD}', "");
    Expect(1, 2224, '\p{^Is_Jg=-SAD}', "");
    Expect(1, 2224, '\P{Is_Jg=-SAD}', "");
    Expect(0, 2224, '\P{^Is_Jg=-SAD}', "");
    Error('\p{Joining_Group=	/a/SADHE}');
    Error('\P{Joining_Group=	/a/SADHE}');
    Expect(1, 1832, '\p{Joining_Group=:\ASadhe\z:}', "");;
    Expect(0, 1833, '\p{Joining_Group=:\ASadhe\z:}', "");;
    Expect(1, 1832, '\p{Joining_Group=sadhe}', "");
    Expect(0, 1832, '\p{^Joining_Group=sadhe}', "");
    Expect(0, 1832, '\P{Joining_Group=sadhe}', "");
    Expect(1, 1832, '\P{^Joining_Group=sadhe}', "");
    Expect(0, 1833, '\p{Joining_Group=sadhe}', "");
    Expect(1, 1833, '\p{^Joining_Group=sadhe}', "");
    Expect(1, 1833, '\P{Joining_Group=sadhe}', "");
    Expect(0, 1833, '\P{^Joining_Group=sadhe}', "");
    Expect(1, 1832, '\p{Joining_Group=:\Asadhe\z:}', "");;
    Expect(0, 1833, '\p{Joining_Group=:\Asadhe\z:}', "");;
    Expect(1, 1832, '\p{Joining_Group=--SADHE}', "");
    Expect(0, 1832, '\p{^Joining_Group=--SADHE}', "");
    Expect(0, 1832, '\P{Joining_Group=--SADHE}', "");
    Expect(1, 1832, '\P{^Joining_Group=--SADHE}', "");
    Expect(0, 1833, '\p{Joining_Group=--SADHE}', "");
    Expect(1, 1833, '\p{^Joining_Group=--SADHE}', "");
    Expect(1, 1833, '\P{Joining_Group=--SADHE}', "");
    Expect(0, 1833, '\P{^Joining_Group=--SADHE}', "");
    Error('\p{Jg=-SADHE:=}');
    Error('\P{Jg=-SADHE:=}');
    Expect(1, 1832, '\p{Jg=:\ASadhe\z:}', "");;
    Expect(0, 1833, '\p{Jg=:\ASadhe\z:}', "");;
    Expect(1, 1832, '\p{Jg=sadhe}', "");
    Expect(0, 1832, '\p{^Jg=sadhe}', "");
    Expect(0, 1832, '\P{Jg=sadhe}', "");
    Expect(1, 1832, '\P{^Jg=sadhe}', "");
    Expect(0, 1833, '\p{Jg=sadhe}', "");
    Expect(1, 1833, '\p{^Jg=sadhe}', "");
    Expect(1, 1833, '\P{Jg=sadhe}', "");
    Expect(0, 1833, '\P{^Jg=sadhe}', "");
    Expect(1, 1832, '\p{Jg=:\Asadhe\z:}', "");;
    Expect(0, 1833, '\p{Jg=:\Asadhe\z:}', "");;
    Expect(1, 1832, '\p{Jg=-SADHE}', "");
    Expect(0, 1832, '\p{^Jg=-SADHE}', "");
    Expect(0, 1832, '\P{Jg=-SADHE}', "");
    Expect(1, 1832, '\P{^Jg=-SADHE}', "");
    Expect(0, 1833, '\p{Jg=-SADHE}', "");
    Expect(1, 1833, '\p{^Jg=-SADHE}', "");
    Expect(1, 1833, '\P{Jg=-SADHE}', "");
    Expect(0, 1833, '\P{^Jg=-SADHE}', "");
    Error('\p{Is_Joining_Group= Sadhe/a/}');
    Error('\P{Is_Joining_Group= Sadhe/a/}');
    Expect(1, 1832, '\p{Is_Joining_Group=sadhe}', "");
    Expect(0, 1832, '\p{^Is_Joining_Group=sadhe}', "");
    Expect(0, 1832, '\P{Is_Joining_Group=sadhe}', "");
    Expect(1, 1832, '\P{^Is_Joining_Group=sadhe}', "");
    Expect(0, 1833, '\p{Is_Joining_Group=sadhe}', "");
    Expect(1, 1833, '\p{^Is_Joining_Group=sadhe}', "");
    Expect(1, 1833, '\P{Is_Joining_Group=sadhe}', "");
    Expect(0, 1833, '\P{^Is_Joining_Group=sadhe}', "");
    Expect(1, 1832, '\p{Is_Joining_Group=Sadhe}', "");
    Expect(0, 1832, '\p{^Is_Joining_Group=Sadhe}', "");
    Expect(0, 1832, '\P{Is_Joining_Group=Sadhe}', "");
    Expect(1, 1832, '\P{^Is_Joining_Group=Sadhe}', "");
    Expect(0, 1833, '\p{Is_Joining_Group=Sadhe}', "");
    Expect(1, 1833, '\p{^Is_Joining_Group=Sadhe}', "");
    Expect(1, 1833, '\P{Is_Joining_Group=Sadhe}', "");
    Expect(0, 1833, '\P{^Is_Joining_Group=Sadhe}', "");
    Error('\p{Is_Jg=/a/	-Sadhe}');
    Error('\P{Is_Jg=/a/	-Sadhe}');
    Expect(1, 1832, '\p{Is_Jg=sadhe}', "");
    Expect(0, 1832, '\p{^Is_Jg=sadhe}', "");
    Expect(0, 1832, '\P{Is_Jg=sadhe}', "");
    Expect(1, 1832, '\P{^Is_Jg=sadhe}', "");
    Expect(0, 1833, '\p{Is_Jg=sadhe}', "");
    Expect(1, 1833, '\p{^Is_Jg=sadhe}', "");
    Expect(1, 1833, '\P{Is_Jg=sadhe}', "");
    Expect(0, 1833, '\P{^Is_Jg=sadhe}', "");
    Expect(1, 1832, '\p{Is_Jg=	sadhe}', "");
    Expect(0, 1832, '\p{^Is_Jg=	sadhe}', "");
    Expect(0, 1832, '\P{Is_Jg=	sadhe}', "");
    Expect(1, 1832, '\P{^Is_Jg=	sadhe}', "");
    Expect(0, 1833, '\p{Is_Jg=	sadhe}', "");
    Expect(1, 1833, '\p{^Is_Jg=	sadhe}', "");
    Expect(1, 1833, '\P{Is_Jg=	sadhe}', "");
    Expect(0, 1833, '\P{^Is_Jg=	sadhe}', "");
    Error('\p{Joining_Group=  seen:=}');
    Error('\P{Joining_Group=  seen:=}');
    Expect(1, 1918, '\p{Joining_Group=:\ASeen\z:}', "");;
    Expect(0, 1919, '\p{Joining_Group=:\ASeen\z:}', "");;
    Expect(1, 1918, '\p{Joining_Group=seen}', "");
    Expect(0, 1918, '\p{^Joining_Group=seen}', "");
    Expect(0, 1918, '\P{Joining_Group=seen}', "");
    Expect(1, 1918, '\P{^Joining_Group=seen}', "");
    Expect(0, 1919, '\p{Joining_Group=seen}', "");
    Expect(1, 1919, '\p{^Joining_Group=seen}', "");
    Expect(1, 1919, '\P{Joining_Group=seen}', "");
    Expect(0, 1919, '\P{^Joining_Group=seen}', "");
    Expect(1, 1918, '\p{Joining_Group=:\Aseen\z:}', "");;
    Expect(0, 1919, '\p{Joining_Group=:\Aseen\z:}', "");;
    Expect(1, 1918, '\p{Joining_Group=_	SEEN}', "");
    Expect(0, 1918, '\p{^Joining_Group=_	SEEN}', "");
    Expect(0, 1918, '\P{Joining_Group=_	SEEN}', "");
    Expect(1, 1918, '\P{^Joining_Group=_	SEEN}', "");
    Expect(0, 1919, '\p{Joining_Group=_	SEEN}', "");
    Expect(1, 1919, '\p{^Joining_Group=_	SEEN}', "");
    Expect(1, 1919, '\P{Joining_Group=_	SEEN}', "");
    Expect(0, 1919, '\P{^Joining_Group=_	SEEN}', "");
    Error('\p{Jg:   -seen/a/}');
    Error('\P{Jg:   -seen/a/}');
    Expect(1, 1918, '\p{Jg=:\ASeen\z:}', "");;
    Expect(0, 1919, '\p{Jg=:\ASeen\z:}', "");;
    Expect(1, 1918, '\p{Jg=seen}', "");
    Expect(0, 1918, '\p{^Jg=seen}', "");
    Expect(0, 1918, '\P{Jg=seen}', "");
    Expect(1, 1918, '\P{^Jg=seen}', "");
    Expect(0, 1919, '\p{Jg=seen}', "");
    Expect(1, 1919, '\p{^Jg=seen}', "");
    Expect(1, 1919, '\P{Jg=seen}', "");
    Expect(0, 1919, '\P{^Jg=seen}', "");
    Expect(1, 1918, '\p{Jg=:\Aseen\z:}', "");;
    Expect(0, 1919, '\p{Jg=:\Aseen\z:}', "");;
    Expect(1, 1918, '\p{Jg=	Seen}', "");
    Expect(0, 1918, '\p{^Jg=	Seen}', "");
    Expect(0, 1918, '\P{Jg=	Seen}', "");
    Expect(1, 1918, '\P{^Jg=	Seen}', "");
    Expect(0, 1919, '\p{Jg=	Seen}', "");
    Expect(1, 1919, '\p{^Jg=	Seen}', "");
    Expect(1, 1919, '\P{Jg=	Seen}', "");
    Expect(0, 1919, '\P{^Jg=	Seen}', "");
    Error('\p{Is_Joining_Group=	:=Seen}');
    Error('\P{Is_Joining_Group=	:=Seen}');
    Expect(1, 1918, '\p{Is_Joining_Group=seen}', "");
    Expect(0, 1918, '\p{^Is_Joining_Group=seen}', "");
    Expect(0, 1918, '\P{Is_Joining_Group=seen}', "");
    Expect(1, 1918, '\P{^Is_Joining_Group=seen}', "");
    Expect(0, 1919, '\p{Is_Joining_Group=seen}', "");
    Expect(1, 1919, '\p{^Is_Joining_Group=seen}', "");
    Expect(1, 1919, '\P{Is_Joining_Group=seen}', "");
    Expect(0, 1919, '\P{^Is_Joining_Group=seen}', "");
    Expect(1, 1918, '\p{Is_Joining_Group=_-SEEN}', "");
    Expect(0, 1918, '\p{^Is_Joining_Group=_-SEEN}', "");
    Expect(0, 1918, '\P{Is_Joining_Group=_-SEEN}', "");
    Expect(1, 1918, '\P{^Is_Joining_Group=_-SEEN}', "");
    Expect(0, 1919, '\p{Is_Joining_Group=_-SEEN}', "");
    Expect(1, 1919, '\p{^Is_Joining_Group=_-SEEN}', "");
    Expect(1, 1919, '\P{Is_Joining_Group=_-SEEN}', "");
    Expect(0, 1919, '\P{^Is_Joining_Group=_-SEEN}', "");
    Error('\p{Is_Jg=/a/seen}');
    Error('\P{Is_Jg=/a/seen}');
    Expect(1, 1918, '\p{Is_Jg=seen}', "");
    Expect(0, 1918, '\p{^Is_Jg=seen}', "");
    Expect(0, 1918, '\P{Is_Jg=seen}', "");
    Expect(1, 1918, '\P{^Is_Jg=seen}', "");
    Expect(0, 1919, '\p{Is_Jg=seen}', "");
    Expect(1, 1919, '\p{^Is_Jg=seen}', "");
    Expect(1, 1919, '\P{Is_Jg=seen}', "");
    Expect(0, 1919, '\P{^Is_Jg=seen}', "");
    Expect(1, 1918, '\p{Is_Jg=	Seen}', "");
    Expect(0, 1918, '\p{^Is_Jg=	Seen}', "");
    Expect(0, 1918, '\P{Is_Jg=	Seen}', "");
    Expect(1, 1918, '\P{^Is_Jg=	Seen}', "");
    Expect(0, 1919, '\p{Is_Jg=	Seen}', "");
    Expect(1, 1919, '\p{^Is_Jg=	Seen}', "");
    Expect(1, 1919, '\P{Is_Jg=	Seen}', "");
    Expect(0, 1919, '\P{^Is_Jg=	Seen}', "");
    Error('\p{Joining_Group=_/a/semkath}');
    Error('\P{Joining_Group=_/a/semkath}');
    Expect(1, 1827, '\p{Joining_Group=:\ASemkath\z:}', "");;
    Expect(0, 1828, '\p{Joining_Group=:\ASemkath\z:}', "");;
    Expect(1, 1827, '\p{Joining_Group=semkath}', "");
    Expect(0, 1827, '\p{^Joining_Group=semkath}', "");
    Expect(0, 1827, '\P{Joining_Group=semkath}', "");
    Expect(1, 1827, '\P{^Joining_Group=semkath}', "");
    Expect(0, 1828, '\p{Joining_Group=semkath}', "");
    Expect(1, 1828, '\p{^Joining_Group=semkath}', "");
    Expect(1, 1828, '\P{Joining_Group=semkath}', "");
    Expect(0, 1828, '\P{^Joining_Group=semkath}', "");
    Expect(1, 1827, '\p{Joining_Group=:\Asemkath\z:}', "");;
    Expect(0, 1828, '\p{Joining_Group=:\Asemkath\z:}', "");;
    Expect(1, 1827, '\p{Joining_Group=-SEMKATH}', "");
    Expect(0, 1827, '\p{^Joining_Group=-SEMKATH}', "");
    Expect(0, 1827, '\P{Joining_Group=-SEMKATH}', "");
    Expect(1, 1827, '\P{^Joining_Group=-SEMKATH}', "");
    Expect(0, 1828, '\p{Joining_Group=-SEMKATH}', "");
    Expect(1, 1828, '\p{^Joining_Group=-SEMKATH}', "");
    Expect(1, 1828, '\P{Joining_Group=-SEMKATH}', "");
    Expect(0, 1828, '\P{^Joining_Group=-SEMKATH}', "");
    Error('\p{Jg=/a/_-Semkath}');
    Error('\P{Jg=/a/_-Semkath}');
    Expect(1, 1827, '\p{Jg=:\ASemkath\z:}', "");;
    Expect(0, 1828, '\p{Jg=:\ASemkath\z:}', "");;
    Expect(1, 1827, '\p{Jg=semkath}', "");
    Expect(0, 1827, '\p{^Jg=semkath}', "");
    Expect(0, 1827, '\P{Jg=semkath}', "");
    Expect(1, 1827, '\P{^Jg=semkath}', "");
    Expect(0, 1828, '\p{Jg=semkath}', "");
    Expect(1, 1828, '\p{^Jg=semkath}', "");
    Expect(1, 1828, '\P{Jg=semkath}', "");
    Expect(0, 1828, '\P{^Jg=semkath}', "");
    Expect(1, 1827, '\p{Jg=:\Asemkath\z:}', "");;
    Expect(0, 1828, '\p{Jg=:\Asemkath\z:}', "");;
    Expect(1, 1827, '\p{Jg=	_semkath}', "");
    Expect(0, 1827, '\p{^Jg=	_semkath}', "");
    Expect(0, 1827, '\P{Jg=	_semkath}', "");
    Expect(1, 1827, '\P{^Jg=	_semkath}', "");
    Expect(0, 1828, '\p{Jg=	_semkath}', "");
    Expect(1, 1828, '\p{^Jg=	_semkath}', "");
    Expect(1, 1828, '\P{Jg=	_semkath}', "");
    Expect(0, 1828, '\P{^Jg=	_semkath}', "");
    Error('\p{Is_Joining_Group=_-Semkath/a/}');
    Error('\P{Is_Joining_Group=_-Semkath/a/}');
    Expect(1, 1827, '\p{Is_Joining_Group=semkath}', "");
    Expect(0, 1827, '\p{^Is_Joining_Group=semkath}', "");
    Expect(0, 1827, '\P{Is_Joining_Group=semkath}', "");
    Expect(1, 1827, '\P{^Is_Joining_Group=semkath}', "");
    Expect(0, 1828, '\p{Is_Joining_Group=semkath}', "");
    Expect(1, 1828, '\p{^Is_Joining_Group=semkath}', "");
    Expect(1, 1828, '\P{Is_Joining_Group=semkath}', "");
    Expect(0, 1828, '\P{^Is_Joining_Group=semkath}', "");
    Expect(1, 1827, '\p{Is_Joining_Group= semkath}', "");
    Expect(0, 1827, '\p{^Is_Joining_Group= semkath}', "");
    Expect(0, 1827, '\P{Is_Joining_Group= semkath}', "");
    Expect(1, 1827, '\P{^Is_Joining_Group= semkath}', "");
    Expect(0, 1828, '\p{Is_Joining_Group= semkath}', "");
    Expect(1, 1828, '\p{^Is_Joining_Group= semkath}', "");
    Expect(1, 1828, '\P{Is_Joining_Group= semkath}', "");
    Expect(0, 1828, '\P{^Is_Joining_Group= semkath}', "");
    Error('\p{Is_Jg=_/a/Semkath}');
    Error('\P{Is_Jg=_/a/Semkath}');
    Expect(1, 1827, '\p{Is_Jg=semkath}', "");
    Expect(0, 1827, '\p{^Is_Jg=semkath}', "");
    Expect(0, 1827, '\P{Is_Jg=semkath}', "");
    Expect(1, 1827, '\P{^Is_Jg=semkath}', "");
    Expect(0, 1828, '\p{Is_Jg=semkath}', "");
    Expect(1, 1828, '\p{^Is_Jg=semkath}', "");
    Expect(1, 1828, '\P{Is_Jg=semkath}', "");
    Expect(0, 1828, '\P{^Is_Jg=semkath}', "");
    Expect(1, 1827, '\p{Is_Jg= 	semkath}', "");
    Expect(0, 1827, '\p{^Is_Jg= 	semkath}', "");
    Expect(0, 1827, '\P{Is_Jg= 	semkath}', "");
    Expect(1, 1827, '\P{^Is_Jg= 	semkath}', "");
    Expect(0, 1828, '\p{Is_Jg= 	semkath}', "");
    Expect(1, 1828, '\p{^Is_Jg= 	semkath}', "");
    Expect(1, 1828, '\P{Is_Jg= 	semkath}', "");
    Expect(0, 1828, '\P{^Is_Jg= 	semkath}', "");
    Error('\p{Joining_Group: /a/		SHIN}');
    Error('\P{Joining_Group: /a/		SHIN}');
    Expect(1, 1835, '\p{Joining_Group=:\AShin\z:}', "");;
    Expect(0, 1836, '\p{Joining_Group=:\AShin\z:}', "");;
    Expect(1, 1835, '\p{Joining_Group=shin}', "");
    Expect(0, 1835, '\p{^Joining_Group=shin}', "");
    Expect(0, 1835, '\P{Joining_Group=shin}', "");
    Expect(1, 1835, '\P{^Joining_Group=shin}', "");
    Expect(0, 1836, '\p{Joining_Group=shin}', "");
    Expect(1, 1836, '\p{^Joining_Group=shin}', "");
    Expect(1, 1836, '\P{Joining_Group=shin}', "");
    Expect(0, 1836, '\P{^Joining_Group=shin}', "");
    Expect(1, 1835, '\p{Joining_Group=:\Ashin\z:}', "");;
    Expect(0, 1836, '\p{Joining_Group=:\Ashin\z:}', "");;
    Expect(1, 1835, '\p{Joining_Group: 		SHIN}', "");
    Expect(0, 1835, '\p{^Joining_Group: 		SHIN}', "");
    Expect(0, 1835, '\P{Joining_Group: 		SHIN}', "");
    Expect(1, 1835, '\P{^Joining_Group: 		SHIN}', "");
    Expect(0, 1836, '\p{Joining_Group: 		SHIN}', "");
    Expect(1, 1836, '\p{^Joining_Group: 		SHIN}', "");
    Expect(1, 1836, '\P{Joining_Group: 		SHIN}', "");
    Expect(0, 1836, '\P{^Joining_Group: 		SHIN}', "");
    Error('\p{Jg=/a/	shin}');
    Error('\P{Jg=/a/	shin}');
    Expect(1, 1835, '\p{Jg=:\AShin\z:}', "");;
    Expect(0, 1836, '\p{Jg=:\AShin\z:}', "");;
    Expect(1, 1835, '\p{Jg=shin}', "");
    Expect(0, 1835, '\p{^Jg=shin}', "");
    Expect(0, 1835, '\P{Jg=shin}', "");
    Expect(1, 1835, '\P{^Jg=shin}', "");
    Expect(0, 1836, '\p{Jg=shin}', "");
    Expect(1, 1836, '\p{^Jg=shin}', "");
    Expect(1, 1836, '\P{Jg=shin}', "");
    Expect(0, 1836, '\P{^Jg=shin}', "");
    Expect(1, 1835, '\p{Jg=:\Ashin\z:}', "");;
    Expect(0, 1836, '\p{Jg=:\Ashin\z:}', "");;
    Expect(1, 1835, '\p{Jg=- SHIN}', "");
    Expect(0, 1835, '\p{^Jg=- SHIN}', "");
    Expect(0, 1835, '\P{Jg=- SHIN}', "");
    Expect(1, 1835, '\P{^Jg=- SHIN}', "");
    Expect(0, 1836, '\p{Jg=- SHIN}', "");
    Expect(1, 1836, '\p{^Jg=- SHIN}', "");
    Expect(1, 1836, '\P{Jg=- SHIN}', "");
    Expect(0, 1836, '\P{^Jg=- SHIN}', "");
    Error('\p{Is_Joining_Group= :=SHIN}');
    Error('\P{Is_Joining_Group= :=SHIN}');
    Expect(1, 1835, '\p{Is_Joining_Group=shin}', "");
    Expect(0, 1835, '\p{^Is_Joining_Group=shin}', "");
    Expect(0, 1835, '\P{Is_Joining_Group=shin}', "");
    Expect(1, 1835, '\P{^Is_Joining_Group=shin}', "");
    Expect(0, 1836, '\p{Is_Joining_Group=shin}', "");
    Expect(1, 1836, '\p{^Is_Joining_Group=shin}', "");
    Expect(1, 1836, '\P{Is_Joining_Group=shin}', "");
    Expect(0, 1836, '\P{^Is_Joining_Group=shin}', "");
    Expect(1, 1835, '\p{Is_Joining_Group=- Shin}', "");
    Expect(0, 1835, '\p{^Is_Joining_Group=- Shin}', "");
    Expect(0, 1835, '\P{Is_Joining_Group=- Shin}', "");
    Expect(1, 1835, '\P{^Is_Joining_Group=- Shin}', "");
    Expect(0, 1836, '\p{Is_Joining_Group=- Shin}', "");
    Expect(1, 1836, '\p{^Is_Joining_Group=- Shin}', "");
    Expect(1, 1836, '\P{Is_Joining_Group=- Shin}', "");
    Expect(0, 1836, '\P{^Is_Joining_Group=- Shin}', "");
    Error('\p{Is_Jg=:= -Shin}');
    Error('\P{Is_Jg=:= -Shin}');
    Expect(1, 1835, '\p{Is_Jg=shin}', "");
    Expect(0, 1835, '\p{^Is_Jg=shin}', "");
    Expect(0, 1835, '\P{Is_Jg=shin}', "");
    Expect(1, 1835, '\P{^Is_Jg=shin}', "");
    Expect(0, 1836, '\p{Is_Jg=shin}', "");
    Expect(1, 1836, '\p{^Is_Jg=shin}', "");
    Expect(1, 1836, '\P{Is_Jg=shin}', "");
    Expect(0, 1836, '\P{^Is_Jg=shin}', "");
    Expect(1, 1835, '\p{Is_Jg=	_Shin}', "");
    Expect(0, 1835, '\p{^Is_Jg=	_Shin}', "");
    Expect(0, 1835, '\P{Is_Jg=	_Shin}', "");
    Expect(1, 1835, '\P{^Is_Jg=	_Shin}', "");
    Expect(0, 1836, '\p{Is_Jg=	_Shin}', "");
    Expect(1, 1836, '\p{^Is_Jg=	_Shin}', "");
    Expect(1, 1836, '\P{Is_Jg=	_Shin}', "");
    Expect(0, 1836, '\P{^Is_Jg=	_Shin}', "");
    Error('\p{Joining_Group=:=_-straight_waw}');
    Error('\P{Joining_Group=:=_-straight_waw}');
    Expect(1, 2225, '\p{Joining_Group=:\AStraight_Waw\z:}', "");;
    Expect(0, 2226, '\p{Joining_Group=:\AStraight_Waw\z:}', "");;
    Expect(1, 2225, '\p{Joining_Group=straightwaw}', "");
    Expect(0, 2225, '\p{^Joining_Group=straightwaw}', "");
    Expect(0, 2225, '\P{Joining_Group=straightwaw}', "");
    Expect(1, 2225, '\P{^Joining_Group=straightwaw}', "");
    Expect(0, 2226, '\p{Joining_Group=straightwaw}', "");
    Expect(1, 2226, '\p{^Joining_Group=straightwaw}', "");
    Expect(1, 2226, '\P{Joining_Group=straightwaw}', "");
    Expect(0, 2226, '\P{^Joining_Group=straightwaw}', "");
    Expect(1, 2225, '\p{Joining_Group=:\Astraightwaw\z:}', "");;
    Expect(0, 2226, '\p{Joining_Group=:\Astraightwaw\z:}', "");;
    Expect(1, 2225, '\p{Joining_Group=	Straight_waw}', "");
    Expect(0, 2225, '\p{^Joining_Group=	Straight_waw}', "");
    Expect(0, 2225, '\P{Joining_Group=	Straight_waw}', "");
    Expect(1, 2225, '\P{^Joining_Group=	Straight_waw}', "");
    Expect(0, 2226, '\p{Joining_Group=	Straight_waw}', "");
    Expect(1, 2226, '\p{^Joining_Group=	Straight_waw}', "");
    Expect(1, 2226, '\P{Joining_Group=	Straight_waw}', "");
    Expect(0, 2226, '\P{^Joining_Group=	Straight_waw}', "");
    Error('\p{Jg=:= Straight_waw}');
    Error('\P{Jg=:= Straight_waw}');
    Expect(1, 2225, '\p{Jg=:\AStraight_Waw\z:}', "");;
    Expect(0, 2226, '\p{Jg=:\AStraight_Waw\z:}', "");;
    Expect(1, 2225, '\p{Jg=straightwaw}', "");
    Expect(0, 2225, '\p{^Jg=straightwaw}', "");
    Expect(0, 2225, '\P{Jg=straightwaw}', "");
    Expect(1, 2225, '\P{^Jg=straightwaw}', "");
    Expect(0, 2226, '\p{Jg=straightwaw}', "");
    Expect(1, 2226, '\p{^Jg=straightwaw}', "");
    Expect(1, 2226, '\P{Jg=straightwaw}', "");
    Expect(0, 2226, '\P{^Jg=straightwaw}', "");
    Expect(1, 2225, '\p{Jg=:\Astraightwaw\z:}', "");;
    Expect(0, 2226, '\p{Jg=:\Astraightwaw\z:}', "");;
    Expect(1, 2225, '\p{Jg= -STRAIGHT_waw}', "");
    Expect(0, 2225, '\p{^Jg= -STRAIGHT_waw}', "");
    Expect(0, 2225, '\P{Jg= -STRAIGHT_waw}', "");
    Expect(1, 2225, '\P{^Jg= -STRAIGHT_waw}', "");
    Expect(0, 2226, '\p{Jg= -STRAIGHT_waw}', "");
    Expect(1, 2226, '\p{^Jg= -STRAIGHT_waw}', "");
    Expect(1, 2226, '\P{Jg= -STRAIGHT_waw}', "");
    Expect(0, 2226, '\P{^Jg= -STRAIGHT_waw}', "");
    Error('\p{Is_Joining_Group=_-Straight_Waw/a/}');
    Error('\P{Is_Joining_Group=_-Straight_Waw/a/}');
    Expect(1, 2225, '\p{Is_Joining_Group=straightwaw}', "");
    Expect(0, 2225, '\p{^Is_Joining_Group=straightwaw}', "");
    Expect(0, 2225, '\P{Is_Joining_Group=straightwaw}', "");
    Expect(1, 2225, '\P{^Is_Joining_Group=straightwaw}', "");
    Expect(0, 2226, '\p{Is_Joining_Group=straightwaw}', "");
    Expect(1, 2226, '\p{^Is_Joining_Group=straightwaw}', "");
    Expect(1, 2226, '\P{Is_Joining_Group=straightwaw}', "");
    Expect(0, 2226, '\P{^Is_Joining_Group=straightwaw}', "");
    Expect(1, 2225, '\p{Is_Joining_Group=_-Straight_waw}', "");
    Expect(0, 2225, '\p{^Is_Joining_Group=_-Straight_waw}', "");
    Expect(0, 2225, '\P{Is_Joining_Group=_-Straight_waw}', "");
    Expect(1, 2225, '\P{^Is_Joining_Group=_-Straight_waw}', "");
    Expect(0, 2226, '\p{Is_Joining_Group=_-Straight_waw}', "");
    Expect(1, 2226, '\p{^Is_Joining_Group=_-Straight_waw}', "");
    Expect(1, 2226, '\P{Is_Joining_Group=_-Straight_waw}', "");
    Expect(0, 2226, '\P{^Is_Joining_Group=_-Straight_waw}', "");
    Error('\p{Is_Jg=-	straight_Waw:=}');
    Error('\P{Is_Jg=-	straight_Waw:=}');
    Expect(1, 2225, '\p{Is_Jg: straightwaw}', "");
    Expect(0, 2225, '\p{^Is_Jg: straightwaw}', "");
    Expect(0, 2225, '\P{Is_Jg: straightwaw}', "");
    Expect(1, 2225, '\P{^Is_Jg: straightwaw}', "");
    Expect(0, 2226, '\p{Is_Jg: straightwaw}', "");
    Expect(1, 2226, '\p{^Is_Jg: straightwaw}', "");
    Expect(1, 2226, '\P{Is_Jg: straightwaw}', "");
    Expect(0, 2226, '\P{^Is_Jg: straightwaw}', "");
    Expect(1, 2225, '\p{Is_Jg=- Straight_waw}', "");
    Expect(0, 2225, '\p{^Is_Jg=- Straight_waw}', "");
    Expect(0, 2225, '\P{Is_Jg=- Straight_waw}', "");
    Expect(1, 2225, '\P{^Is_Jg=- Straight_waw}', "");
    Expect(0, 2226, '\p{Is_Jg=- Straight_waw}', "");
    Expect(1, 2226, '\p{^Is_Jg=- Straight_waw}', "");
    Expect(1, 2226, '\P{Is_Jg=- Straight_waw}', "");
    Expect(0, 2226, '\P{^Is_Jg=- Straight_waw}', "");
    Error('\p{Joining_Group:    Swash_Kaf:=}');
    Error('\P{Joining_Group:    Swash_Kaf:=}');
    Expect(1, 1706, '\p{Joining_Group=:\ASwash_Kaf\z:}', "");;
    Expect(0, 1707, '\p{Joining_Group=:\ASwash_Kaf\z:}', "");;
    Expect(1, 1706, '\p{Joining_Group=swashkaf}', "");
    Expect(0, 1706, '\p{^Joining_Group=swashkaf}', "");
    Expect(0, 1706, '\P{Joining_Group=swashkaf}', "");
    Expect(1, 1706, '\P{^Joining_Group=swashkaf}', "");
    Expect(0, 1707, '\p{Joining_Group=swashkaf}', "");
    Expect(1, 1707, '\p{^Joining_Group=swashkaf}', "");
    Expect(1, 1707, '\P{Joining_Group=swashkaf}', "");
    Expect(0, 1707, '\P{^Joining_Group=swashkaf}', "");
    Expect(1, 1706, '\p{Joining_Group=:\Aswashkaf\z:}', "");;
    Expect(0, 1707, '\p{Joining_Group=:\Aswashkaf\z:}', "");;
    Expect(1, 1706, '\p{Joining_Group=Swash_Kaf}', "");
    Expect(0, 1706, '\p{^Joining_Group=Swash_Kaf}', "");
    Expect(0, 1706, '\P{Joining_Group=Swash_Kaf}', "");
    Expect(1, 1706, '\P{^Joining_Group=Swash_Kaf}', "");
    Expect(0, 1707, '\p{Joining_Group=Swash_Kaf}', "");
    Expect(1, 1707, '\p{^Joining_Group=Swash_Kaf}', "");
    Expect(1, 1707, '\P{Joining_Group=Swash_Kaf}', "");
    Expect(0, 1707, '\P{^Joining_Group=Swash_Kaf}', "");
    Error('\p{Jg=	/a/SWASH_KAF}');
    Error('\P{Jg=	/a/SWASH_KAF}');
    Expect(1, 1706, '\p{Jg=:\ASwash_Kaf\z:}', "");;
    Expect(0, 1707, '\p{Jg=:\ASwash_Kaf\z:}', "");;
    Expect(1, 1706, '\p{Jg=swashkaf}', "");
    Expect(0, 1706, '\p{^Jg=swashkaf}', "");
    Expect(0, 1706, '\P{Jg=swashkaf}', "");
    Expect(1, 1706, '\P{^Jg=swashkaf}', "");
    Expect(0, 1707, '\p{Jg=swashkaf}', "");
    Expect(1, 1707, '\p{^Jg=swashkaf}', "");
    Expect(1, 1707, '\P{Jg=swashkaf}', "");
    Expect(0, 1707, '\P{^Jg=swashkaf}', "");
    Expect(1, 1706, '\p{Jg=:\Aswashkaf\z:}', "");;
    Expect(0, 1707, '\p{Jg=:\Aswashkaf\z:}', "");;
    Expect(1, 1706, '\p{Jg= swash_Kaf}', "");
    Expect(0, 1706, '\p{^Jg= swash_Kaf}', "");
    Expect(0, 1706, '\P{Jg= swash_Kaf}', "");
    Expect(1, 1706, '\P{^Jg= swash_Kaf}', "");
    Expect(0, 1707, '\p{Jg= swash_Kaf}', "");
    Expect(1, 1707, '\p{^Jg= swash_Kaf}', "");
    Expect(1, 1707, '\P{Jg= swash_Kaf}', "");
    Expect(0, 1707, '\P{^Jg= swash_Kaf}', "");
    Error('\p{Is_Joining_Group=/a/  swash_KAF}');
    Error('\P{Is_Joining_Group=/a/  swash_KAF}');
    Expect(1, 1706, '\p{Is_Joining_Group=swashkaf}', "");
    Expect(0, 1706, '\p{^Is_Joining_Group=swashkaf}', "");
    Expect(0, 1706, '\P{Is_Joining_Group=swashkaf}', "");
    Expect(1, 1706, '\P{^Is_Joining_Group=swashkaf}', "");
    Expect(0, 1707, '\p{Is_Joining_Group=swashkaf}', "");
    Expect(1, 1707, '\p{^Is_Joining_Group=swashkaf}', "");
    Expect(1, 1707, '\P{Is_Joining_Group=swashkaf}', "");
    Expect(0, 1707, '\P{^Is_Joining_Group=swashkaf}', "");
    Expect(1, 1706, '\p{Is_Joining_Group=	-SWASH_Kaf}', "");
    Expect(0, 1706, '\p{^Is_Joining_Group=	-SWASH_Kaf}', "");
    Expect(0, 1706, '\P{Is_Joining_Group=	-SWASH_Kaf}', "");
    Expect(1, 1706, '\P{^Is_Joining_Group=	-SWASH_Kaf}', "");
    Expect(0, 1707, '\p{Is_Joining_Group=	-SWASH_Kaf}', "");
    Expect(1, 1707, '\p{^Is_Joining_Group=	-SWASH_Kaf}', "");
    Expect(1, 1707, '\P{Is_Joining_Group=	-SWASH_Kaf}', "");
    Expect(0, 1707, '\P{^Is_Joining_Group=	-SWASH_Kaf}', "");
    Error('\p{Is_Jg=:=	Swash_KAF}');
    Error('\P{Is_Jg=:=	Swash_KAF}');
    Expect(1, 1706, '\p{Is_Jg=swashkaf}', "");
    Expect(0, 1706, '\p{^Is_Jg=swashkaf}', "");
    Expect(0, 1706, '\P{Is_Jg=swashkaf}', "");
    Expect(1, 1706, '\P{^Is_Jg=swashkaf}', "");
    Expect(0, 1707, '\p{Is_Jg=swashkaf}', "");
    Expect(1, 1707, '\p{^Is_Jg=swashkaf}', "");
    Expect(1, 1707, '\P{Is_Jg=swashkaf}', "");
    Expect(0, 1707, '\P{^Is_Jg=swashkaf}', "");
    Expect(1, 1706, '\p{Is_Jg=_-SWASH_KAF}', "");
    Expect(0, 1706, '\p{^Is_Jg=_-SWASH_KAF}', "");
    Expect(0, 1706, '\P{Is_Jg=_-SWASH_KAF}', "");
    Expect(1, 1706, '\P{^Is_Jg=_-SWASH_KAF}', "");
    Expect(0, 1707, '\p{Is_Jg=_-SWASH_KAF}', "");
    Expect(1, 1707, '\p{^Is_Jg=_-SWASH_KAF}', "");
    Expect(1, 1707, '\P{Is_Jg=_-SWASH_KAF}', "");
    Expect(0, 1707, '\P{^Is_Jg=_-SWASH_KAF}', "");
    Error('\p{Joining_Group=		Syriac_WAW:=}');
    Error('\P{Joining_Group=		Syriac_WAW:=}');
    Expect(1, 1816, '\p{Joining_Group=:\ASyriac_Waw\z:}', "");;
    Expect(0, 1817, '\p{Joining_Group=:\ASyriac_Waw\z:}', "");;
    Expect(1, 1816, '\p{Joining_Group=syriacwaw}', "");
    Expect(0, 1816, '\p{^Joining_Group=syriacwaw}', "");
    Expect(0, 1816, '\P{Joining_Group=syriacwaw}', "");
    Expect(1, 1816, '\P{^Joining_Group=syriacwaw}', "");
    Expect(0, 1817, '\p{Joining_Group=syriacwaw}', "");
    Expect(1, 1817, '\p{^Joining_Group=syriacwaw}', "");
    Expect(1, 1817, '\P{Joining_Group=syriacwaw}', "");
    Expect(0, 1817, '\P{^Joining_Group=syriacwaw}', "");
    Expect(1, 1816, '\p{Joining_Group=:\Asyriacwaw\z:}', "");;
    Expect(0, 1817, '\p{Joining_Group=:\Asyriacwaw\z:}', "");;
    Expect(1, 1816, '\p{Joining_Group=_ syriac_Waw}', "");
    Expect(0, 1816, '\p{^Joining_Group=_ syriac_Waw}', "");
    Expect(0, 1816, '\P{Joining_Group=_ syriac_Waw}', "");
    Expect(1, 1816, '\P{^Joining_Group=_ syriac_Waw}', "");
    Expect(0, 1817, '\p{Joining_Group=_ syriac_Waw}', "");
    Expect(1, 1817, '\p{^Joining_Group=_ syriac_Waw}', "");
    Expect(1, 1817, '\P{Joining_Group=_ syriac_Waw}', "");
    Expect(0, 1817, '\P{^Joining_Group=_ syriac_Waw}', "");
    Error('\p{Jg=:=-syriac_Waw}');
    Error('\P{Jg=:=-syriac_Waw}');
    Expect(1, 1816, '\p{Jg=:\ASyriac_Waw\z:}', "");;
    Expect(0, 1817, '\p{Jg=:\ASyriac_Waw\z:}', "");;
    Expect(1, 1816, '\p{Jg:   syriacwaw}', "");
    Expect(0, 1816, '\p{^Jg:   syriacwaw}', "");
    Expect(0, 1816, '\P{Jg:   syriacwaw}', "");
    Expect(1, 1816, '\P{^Jg:   syriacwaw}', "");
    Expect(0, 1817, '\p{Jg:   syriacwaw}', "");
    Expect(1, 1817, '\p{^Jg:   syriacwaw}', "");
    Expect(1, 1817, '\P{Jg:   syriacwaw}', "");
    Expect(0, 1817, '\P{^Jg:   syriacwaw}', "");
    Expect(1, 1816, '\p{Jg=:\Asyriacwaw\z:}', "");;
    Expect(0, 1817, '\p{Jg=:\Asyriacwaw\z:}', "");;
    Expect(1, 1816, '\p{Jg= 	Syriac_WAW}', "");
    Expect(0, 1816, '\p{^Jg= 	Syriac_WAW}', "");
    Expect(0, 1816, '\P{Jg= 	Syriac_WAW}', "");
    Expect(1, 1816, '\P{^Jg= 	Syriac_WAW}', "");
    Expect(0, 1817, '\p{Jg= 	Syriac_WAW}', "");
    Expect(1, 1817, '\p{^Jg= 	Syriac_WAW}', "");
    Expect(1, 1817, '\P{Jg= 	Syriac_WAW}', "");
    Expect(0, 1817, '\P{^Jg= 	Syriac_WAW}', "");
    Error('\p{Is_Joining_Group=:=_-SYRIAC_Waw}');
    Error('\P{Is_Joining_Group=:=_-SYRIAC_Waw}');
    Expect(1, 1816, '\p{Is_Joining_Group:   syriacwaw}', "");
    Expect(0, 1816, '\p{^Is_Joining_Group:   syriacwaw}', "");
    Expect(0, 1816, '\P{Is_Joining_Group:   syriacwaw}', "");
    Expect(1, 1816, '\P{^Is_Joining_Group:   syriacwaw}', "");
    Expect(0, 1817, '\p{Is_Joining_Group:   syriacwaw}', "");
    Expect(1, 1817, '\p{^Is_Joining_Group:   syriacwaw}', "");
    Expect(1, 1817, '\P{Is_Joining_Group:   syriacwaw}', "");
    Expect(0, 1817, '\P{^Is_Joining_Group:   syriacwaw}', "");
    Expect(1, 1816, '\p{Is_Joining_Group= 	Syriac_waw}', "");
    Expect(0, 1816, '\p{^Is_Joining_Group= 	Syriac_waw}', "");
    Expect(0, 1816, '\P{Is_Joining_Group= 	Syriac_waw}', "");
    Expect(1, 1816, '\P{^Is_Joining_Group= 	Syriac_waw}', "");
    Expect(0, 1817, '\p{Is_Joining_Group= 	Syriac_waw}', "");
    Expect(1, 1817, '\p{^Is_Joining_Group= 	Syriac_waw}', "");
    Expect(1, 1817, '\P{Is_Joining_Group= 	Syriac_waw}', "");
    Expect(0, 1817, '\P{^Is_Joining_Group= 	Syriac_waw}', "");
    Error('\p{Is_Jg= _SYRIAC_waw/a/}');
    Error('\P{Is_Jg= _SYRIAC_waw/a/}');
    Expect(1, 1816, '\p{Is_Jg=syriacwaw}', "");
    Expect(0, 1816, '\p{^Is_Jg=syriacwaw}', "");
    Expect(0, 1816, '\P{Is_Jg=syriacwaw}', "");
    Expect(1, 1816, '\P{^Is_Jg=syriacwaw}', "");
    Expect(0, 1817, '\p{Is_Jg=syriacwaw}', "");
    Expect(1, 1817, '\p{^Is_Jg=syriacwaw}', "");
    Expect(1, 1817, '\P{Is_Jg=syriacwaw}', "");
    Expect(0, 1817, '\P{^Is_Jg=syriacwaw}', "");
    Expect(1, 1816, '\p{Is_Jg= -syriac_WAW}', "");
    Expect(0, 1816, '\p{^Is_Jg= -syriac_WAW}', "");
    Expect(0, 1816, '\P{Is_Jg= -syriac_WAW}', "");
    Expect(1, 1816, '\P{^Is_Jg= -syriac_WAW}', "");
    Expect(0, 1817, '\p{Is_Jg= -syriac_WAW}', "");
    Expect(1, 1817, '\p{^Is_Jg= -syriac_WAW}', "");
    Expect(1, 1817, '\P{Is_Jg= -syriac_WAW}', "");
    Expect(0, 1817, '\P{^Is_Jg= -syriac_WAW}', "");
    Error('\p{Joining_Group=- TAH/a/}');
    Error('\P{Joining_Group=- TAH/a/}');
    Expect(1, 2211, '\p{Joining_Group=:\ATah\z:}', "");;
    Expect(0, 2212, '\p{Joining_Group=:\ATah\z:}', "");;
    Expect(1, 2211, '\p{Joining_Group=tah}', "");
    Expect(0, 2211, '\p{^Joining_Group=tah}', "");
    Expect(0, 2211, '\P{Joining_Group=tah}', "");
    Expect(1, 2211, '\P{^Joining_Group=tah}', "");
    Expect(0, 2212, '\p{Joining_Group=tah}', "");
    Expect(1, 2212, '\p{^Joining_Group=tah}', "");
    Expect(1, 2212, '\P{Joining_Group=tah}', "");
    Expect(0, 2212, '\P{^Joining_Group=tah}', "");
    Expect(1, 2211, '\p{Joining_Group=:\Atah\z:}', "");;
    Expect(0, 2212, '\p{Joining_Group=:\Atah\z:}', "");;
    Expect(1, 2211, '\p{Joining_Group: _ TAH}', "");
    Expect(0, 2211, '\p{^Joining_Group: _ TAH}', "");
    Expect(0, 2211, '\P{Joining_Group: _ TAH}', "");
    Expect(1, 2211, '\P{^Joining_Group: _ TAH}', "");
    Expect(0, 2212, '\p{Joining_Group: _ TAH}', "");
    Expect(1, 2212, '\p{^Joining_Group: _ TAH}', "");
    Expect(1, 2212, '\P{Joining_Group: _ TAH}', "");
    Expect(0, 2212, '\P{^Joining_Group: _ TAH}', "");
    Error('\p{Jg=:= _Tah}');
    Error('\P{Jg=:= _Tah}');
    Expect(1, 2211, '\p{Jg=:\ATah\z:}', "");;
    Expect(0, 2212, '\p{Jg=:\ATah\z:}', "");;
    Expect(1, 2211, '\p{Jg=tah}', "");
    Expect(0, 2211, '\p{^Jg=tah}', "");
    Expect(0, 2211, '\P{Jg=tah}', "");
    Expect(1, 2211, '\P{^Jg=tah}', "");
    Expect(0, 2212, '\p{Jg=tah}', "");
    Expect(1, 2212, '\p{^Jg=tah}', "");
    Expect(1, 2212, '\P{Jg=tah}', "");
    Expect(0, 2212, '\P{^Jg=tah}', "");
    Expect(1, 2211, '\p{Jg=:\Atah\z:}', "");;
    Expect(0, 2212, '\p{Jg=:\Atah\z:}', "");;
    Expect(1, 2211, '\p{Jg=	_TAH}', "");
    Expect(0, 2211, '\p{^Jg=	_TAH}', "");
    Expect(0, 2211, '\P{Jg=	_TAH}', "");
    Expect(1, 2211, '\P{^Jg=	_TAH}', "");
    Expect(0, 2212, '\p{Jg=	_TAH}', "");
    Expect(1, 2212, '\p{^Jg=	_TAH}', "");
    Expect(1, 2212, '\P{Jg=	_TAH}', "");
    Expect(0, 2212, '\P{^Jg=	_TAH}', "");
    Error('\p{Is_Joining_Group=-/a/Tah}');
    Error('\P{Is_Joining_Group=-/a/Tah}');
    Expect(1, 2211, '\p{Is_Joining_Group=tah}', "");
    Expect(0, 2211, '\p{^Is_Joining_Group=tah}', "");
    Expect(0, 2211, '\P{Is_Joining_Group=tah}', "");
    Expect(1, 2211, '\P{^Is_Joining_Group=tah}', "");
    Expect(0, 2212, '\p{Is_Joining_Group=tah}', "");
    Expect(1, 2212, '\p{^Is_Joining_Group=tah}', "");
    Expect(1, 2212, '\P{Is_Joining_Group=tah}', "");
    Expect(0, 2212, '\P{^Is_Joining_Group=tah}', "");
    Expect(1, 2211, '\p{Is_Joining_Group=-TAH}', "");
    Expect(0, 2211, '\p{^Is_Joining_Group=-TAH}', "");
    Expect(0, 2211, '\P{Is_Joining_Group=-TAH}', "");
    Expect(1, 2211, '\P{^Is_Joining_Group=-TAH}', "");
    Expect(0, 2212, '\p{Is_Joining_Group=-TAH}', "");
    Expect(1, 2212, '\p{^Is_Joining_Group=-TAH}', "");
    Expect(1, 2212, '\P{Is_Joining_Group=-TAH}', "");
    Expect(0, 2212, '\P{^Is_Joining_Group=-TAH}', "");
    Error('\p{Is_Jg=:=_TAH}');
    Error('\P{Is_Jg=:=_TAH}');
    Expect(1, 2211, '\p{Is_Jg=tah}', "");
    Expect(0, 2211, '\p{^Is_Jg=tah}', "");
    Expect(0, 2211, '\P{Is_Jg=tah}', "");
    Expect(1, 2211, '\P{^Is_Jg=tah}', "");
    Expect(0, 2212, '\p{Is_Jg=tah}', "");
    Expect(1, 2212, '\p{^Is_Jg=tah}', "");
    Expect(1, 2212, '\P{Is_Jg=tah}', "");
    Expect(0, 2212, '\P{^Is_Jg=tah}', "");
    Expect(1, 2211, '\p{Is_Jg=--tah}', "");
    Expect(0, 2211, '\p{^Is_Jg=--tah}', "");
    Expect(0, 2211, '\P{Is_Jg=--tah}', "");
    Expect(1, 2211, '\P{^Is_Jg=--tah}', "");
    Expect(0, 2212, '\p{Is_Jg=--tah}', "");
    Expect(1, 2212, '\p{^Is_Jg=--tah}', "");
    Expect(1, 2212, '\P{Is_Jg=--tah}', "");
    Expect(0, 2212, '\P{^Is_Jg=--tah}', "");
    Error('\p{Joining_Group=	/a/taw}');
    Error('\P{Joining_Group=	/a/taw}');
    Expect(1, 1836, '\p{Joining_Group=:\ATaw\z:}', "");;
    Expect(0, 1837, '\p{Joining_Group=:\ATaw\z:}', "");;
    Expect(1, 1836, '\p{Joining_Group=taw}', "");
    Expect(0, 1836, '\p{^Joining_Group=taw}', "");
    Expect(0, 1836, '\P{Joining_Group=taw}', "");
    Expect(1, 1836, '\P{^Joining_Group=taw}', "");
    Expect(0, 1837, '\p{Joining_Group=taw}', "");
    Expect(1, 1837, '\p{^Joining_Group=taw}', "");
    Expect(1, 1837, '\P{Joining_Group=taw}', "");
    Expect(0, 1837, '\P{^Joining_Group=taw}', "");
    Expect(1, 1836, '\p{Joining_Group=:\Ataw\z:}', "");;
    Expect(0, 1837, '\p{Joining_Group=:\Ataw\z:}', "");;
    Expect(1, 1836, '\p{Joining_Group= -TAW}', "");
    Expect(0, 1836, '\p{^Joining_Group= -TAW}', "");
    Expect(0, 1836, '\P{Joining_Group= -TAW}', "");
    Expect(1, 1836, '\P{^Joining_Group= -TAW}', "");
    Expect(0, 1837, '\p{Joining_Group= -TAW}', "");
    Expect(1, 1837, '\p{^Joining_Group= -TAW}', "");
    Expect(1, 1837, '\P{Joining_Group= -TAW}', "");
    Expect(0, 1837, '\P{^Joining_Group= -TAW}', "");
    Error('\p{Jg=-Taw/a/}');
    Error('\P{Jg=-Taw/a/}');
    Expect(1, 1836, '\p{Jg=:\ATaw\z:}', "");;
    Expect(0, 1837, '\p{Jg=:\ATaw\z:}', "");;
    Expect(1, 1836, '\p{Jg=taw}', "");
    Expect(0, 1836, '\p{^Jg=taw}', "");
    Expect(0, 1836, '\P{Jg=taw}', "");
    Expect(1, 1836, '\P{^Jg=taw}', "");
    Expect(0, 1837, '\p{Jg=taw}', "");
    Expect(1, 1837, '\p{^Jg=taw}', "");
    Expect(1, 1837, '\P{Jg=taw}', "");
    Expect(0, 1837, '\P{^Jg=taw}', "");
    Expect(1, 1836, '\p{Jg=:\Ataw\z:}', "");;
    Expect(0, 1837, '\p{Jg=:\Ataw\z:}', "");;
    Expect(1, 1836, '\p{Jg=Taw}', "");
    Expect(0, 1836, '\p{^Jg=Taw}', "");
    Expect(0, 1836, '\P{Jg=Taw}', "");
    Expect(1, 1836, '\P{^Jg=Taw}', "");
    Expect(0, 1837, '\p{Jg=Taw}', "");
    Expect(1, 1837, '\p{^Jg=Taw}', "");
    Expect(1, 1837, '\P{Jg=Taw}', "");
    Expect(0, 1837, '\P{^Jg=Taw}', "");
    Error('\p{Is_Joining_Group=-:=taw}');
    Error('\P{Is_Joining_Group=-:=taw}');
    Expect(1, 1836, '\p{Is_Joining_Group=taw}', "");
    Expect(0, 1836, '\p{^Is_Joining_Group=taw}', "");
    Expect(0, 1836, '\P{Is_Joining_Group=taw}', "");
    Expect(1, 1836, '\P{^Is_Joining_Group=taw}', "");
    Expect(0, 1837, '\p{Is_Joining_Group=taw}', "");
    Expect(1, 1837, '\p{^Is_Joining_Group=taw}', "");
    Expect(1, 1837, '\P{Is_Joining_Group=taw}', "");
    Expect(0, 1837, '\P{^Is_Joining_Group=taw}', "");
    Expect(1, 1836, '\p{Is_Joining_Group=	-taw}', "");
    Expect(0, 1836, '\p{^Is_Joining_Group=	-taw}', "");
    Expect(0, 1836, '\P{Is_Joining_Group=	-taw}', "");
    Expect(1, 1836, '\P{^Is_Joining_Group=	-taw}', "");
    Expect(0, 1837, '\p{Is_Joining_Group=	-taw}', "");
    Expect(1, 1837, '\p{^Is_Joining_Group=	-taw}', "");
    Expect(1, 1837, '\P{Is_Joining_Group=	-taw}', "");
    Expect(0, 1837, '\P{^Is_Joining_Group=	-taw}', "");
    Error('\p{Is_Jg=:=	_TAW}');
    Error('\P{Is_Jg=:=	_TAW}');
    Expect(1, 1836, '\p{Is_Jg=taw}', "");
    Expect(0, 1836, '\p{^Is_Jg=taw}', "");
    Expect(0, 1836, '\P{Is_Jg=taw}', "");
    Expect(1, 1836, '\P{^Is_Jg=taw}', "");
    Expect(0, 1837, '\p{Is_Jg=taw}', "");
    Expect(1, 1837, '\p{^Is_Jg=taw}', "");
    Expect(1, 1837, '\P{Is_Jg=taw}', "");
    Expect(0, 1837, '\P{^Is_Jg=taw}', "");
    Expect(1, 1836, '\p{Is_Jg=-_Taw}', "");
    Expect(0, 1836, '\p{^Is_Jg=-_Taw}', "");
    Expect(0, 1836, '\P{Is_Jg=-_Taw}', "");
    Expect(1, 1836, '\P{^Is_Jg=-_Taw}', "");
    Expect(0, 1837, '\p{Is_Jg=-_Taw}', "");
    Expect(1, 1837, '\p{^Is_Jg=-_Taw}', "");
    Expect(1, 1837, '\P{Is_Jg=-_Taw}', "");
    Expect(0, 1837, '\P{^Is_Jg=-_Taw}', "");
    Error('\p{Joining_Group=__teh_Marbuta:=}');
    Error('\P{Joining_Group=__teh_Marbuta:=}');
    Expect(1, 1749, '\p{Joining_Group=:\ATeh_Marbuta\z:}', "");;
    Expect(0, 1750, '\p{Joining_Group=:\ATeh_Marbuta\z:}', "");;
    Expect(1, 1749, '\p{Joining_Group=tehmarbuta}', "");
    Expect(0, 1749, '\p{^Joining_Group=tehmarbuta}', "");
    Expect(0, 1749, '\P{Joining_Group=tehmarbuta}', "");
    Expect(1, 1749, '\P{^Joining_Group=tehmarbuta}', "");
    Expect(0, 1750, '\p{Joining_Group=tehmarbuta}', "");
    Expect(1, 1750, '\p{^Joining_Group=tehmarbuta}', "");
    Expect(1, 1750, '\P{Joining_Group=tehmarbuta}', "");
    Expect(0, 1750, '\P{^Joining_Group=tehmarbuta}', "");
    Expect(1, 1749, '\p{Joining_Group=:\Atehmarbuta\z:}', "");;
    Expect(0, 1750, '\p{Joining_Group=:\Atehmarbuta\z:}', "");;
    Expect(1, 1749, '\p{Joining_Group=_	Teh_MARBUTA}', "");
    Expect(0, 1749, '\p{^Joining_Group=_	Teh_MARBUTA}', "");
    Expect(0, 1749, '\P{Joining_Group=_	Teh_MARBUTA}', "");
    Expect(1, 1749, '\P{^Joining_Group=_	Teh_MARBUTA}', "");
    Expect(0, 1750, '\p{Joining_Group=_	Teh_MARBUTA}', "");
    Expect(1, 1750, '\p{^Joining_Group=_	Teh_MARBUTA}', "");
    Expect(1, 1750, '\P{Joining_Group=_	Teh_MARBUTA}', "");
    Expect(0, 1750, '\P{^Joining_Group=_	Teh_MARBUTA}', "");
    Error('\p{Jg=/a/__Teh_Marbuta}');
    Error('\P{Jg=/a/__Teh_Marbuta}');
    Expect(1, 1749, '\p{Jg=:\ATeh_Marbuta\z:}', "");;
    Expect(0, 1750, '\p{Jg=:\ATeh_Marbuta\z:}', "");;
    Expect(1, 1749, '\p{Jg=tehmarbuta}', "");
    Expect(0, 1749, '\p{^Jg=tehmarbuta}', "");
    Expect(0, 1749, '\P{Jg=tehmarbuta}', "");
    Expect(1, 1749, '\P{^Jg=tehmarbuta}', "");
    Expect(0, 1750, '\p{Jg=tehmarbuta}', "");
    Expect(1, 1750, '\p{^Jg=tehmarbuta}', "");
    Expect(1, 1750, '\P{Jg=tehmarbuta}', "");
    Expect(0, 1750, '\P{^Jg=tehmarbuta}', "");
    Expect(1, 1749, '\p{Jg=:\Atehmarbuta\z:}', "");;
    Expect(0, 1750, '\p{Jg=:\Atehmarbuta\z:}', "");;
    Expect(1, 1749, '\p{Jg=-	teh_marbuta}', "");
    Expect(0, 1749, '\p{^Jg=-	teh_marbuta}', "");
    Expect(0, 1749, '\P{Jg=-	teh_marbuta}', "");
    Expect(1, 1749, '\P{^Jg=-	teh_marbuta}', "");
    Expect(0, 1750, '\p{Jg=-	teh_marbuta}', "");
    Expect(1, 1750, '\p{^Jg=-	teh_marbuta}', "");
    Expect(1, 1750, '\P{Jg=-	teh_marbuta}', "");
    Expect(0, 1750, '\P{^Jg=-	teh_marbuta}', "");
    Error('\p{Is_Joining_Group: -_teh_Marbuta/a/}');
    Error('\P{Is_Joining_Group: -_teh_Marbuta/a/}');
    Expect(1, 1749, '\p{Is_Joining_Group=tehmarbuta}', "");
    Expect(0, 1749, '\p{^Is_Joining_Group=tehmarbuta}', "");
    Expect(0, 1749, '\P{Is_Joining_Group=tehmarbuta}', "");
    Expect(1, 1749, '\P{^Is_Joining_Group=tehmarbuta}', "");
    Expect(0, 1750, '\p{Is_Joining_Group=tehmarbuta}', "");
    Expect(1, 1750, '\p{^Is_Joining_Group=tehmarbuta}', "");
    Expect(1, 1750, '\P{Is_Joining_Group=tehmarbuta}', "");
    Expect(0, 1750, '\P{^Is_Joining_Group=tehmarbuta}', "");
    Expect(1, 1749, '\p{Is_Joining_Group: 	TEH_marbuta}', "");
    Expect(0, 1749, '\p{^Is_Joining_Group: 	TEH_marbuta}', "");
    Expect(0, 1749, '\P{Is_Joining_Group: 	TEH_marbuta}', "");
    Expect(1, 1749, '\P{^Is_Joining_Group: 	TEH_marbuta}', "");
    Expect(0, 1750, '\p{Is_Joining_Group: 	TEH_marbuta}', "");
    Expect(1, 1750, '\p{^Is_Joining_Group: 	TEH_marbuta}', "");
    Expect(1, 1750, '\P{Is_Joining_Group: 	TEH_marbuta}', "");
    Expect(0, 1750, '\P{^Is_Joining_Group: 	TEH_marbuta}', "");
    Error('\p{Is_Jg=-:=teh_MARBUTA}');
    Error('\P{Is_Jg=-:=teh_MARBUTA}');
    Expect(1, 1749, '\p{Is_Jg=tehmarbuta}', "");
    Expect(0, 1749, '\p{^Is_Jg=tehmarbuta}', "");
    Expect(0, 1749, '\P{Is_Jg=tehmarbuta}', "");
    Expect(1, 1749, '\P{^Is_Jg=tehmarbuta}', "");
    Expect(0, 1750, '\p{Is_Jg=tehmarbuta}', "");
    Expect(1, 1750, '\p{^Is_Jg=tehmarbuta}', "");
    Expect(1, 1750, '\P{Is_Jg=tehmarbuta}', "");
    Expect(0, 1750, '\P{^Is_Jg=tehmarbuta}', "");
    Expect(1, 1749, '\p{Is_Jg=	 Teh_Marbuta}', "");
    Expect(0, 1749, '\p{^Is_Jg=	 Teh_Marbuta}', "");
    Expect(0, 1749, '\P{Is_Jg=	 Teh_Marbuta}', "");
    Expect(1, 1749, '\P{^Is_Jg=	 Teh_Marbuta}', "");
    Expect(0, 1750, '\p{Is_Jg=	 Teh_Marbuta}', "");
    Expect(1, 1750, '\p{^Is_Jg=	 Teh_Marbuta}', "");
    Expect(1, 1750, '\P{Is_Jg=	 Teh_Marbuta}', "");
    Expect(0, 1750, '\P{^Is_Jg=	 Teh_Marbuta}', "");
    Error('\p{Joining_Group= _HAMZA_On_Heh_Goal/a/}');
    Error('\P{Joining_Group= _HAMZA_On_Heh_Goal/a/}');
    Expect(1, 1731, '\p{Joining_Group=:\AHamza_On_Heh_Goal\z:}', "");;
    Expect(0, 1732, '\p{Joining_Group=:\AHamza_On_Heh_Goal\z:}', "");;
    Expect(1, 1731, '\p{Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1731, '\p{^Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1731, '\P{Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1731, '\P{^Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1732, '\p{Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1732, '\p{^Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1732, '\P{Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1732, '\P{^Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1731, '\p{Joining_Group=:\Ahamzaonhehgoal\z:}', "");;
    Expect(0, 1732, '\p{Joining_Group=:\Ahamzaonhehgoal\z:}', "");;
    Expect(1, 1731, '\p{Joining_Group= _hamza_on_heh_GOAL}', "");
    Expect(0, 1731, '\p{^Joining_Group= _hamza_on_heh_GOAL}', "");
    Expect(0, 1731, '\P{Joining_Group= _hamza_on_heh_GOAL}', "");
    Expect(1, 1731, '\P{^Joining_Group= _hamza_on_heh_GOAL}', "");
    Expect(0, 1732, '\p{Joining_Group= _hamza_on_heh_GOAL}', "");
    Expect(1, 1732, '\p{^Joining_Group= _hamza_on_heh_GOAL}', "");
    Expect(1, 1732, '\P{Joining_Group= _hamza_on_heh_GOAL}', "");
    Expect(0, 1732, '\P{^Joining_Group= _hamza_on_heh_GOAL}', "");
    Error('\p{Jg=_:=Teh_MARBUTA_Goal}');
    Error('\P{Jg=_:=Teh_MARBUTA_Goal}');
    Expect(1, 1731, '\p{Jg=:\ATeh_Marbuta_Goal\z:}', "");;
    Expect(0, 1732, '\p{Jg=:\ATeh_Marbuta_Goal\z:}', "");;
    Expect(1, 1731, '\p{Jg=tehmarbutagoal}', "");
    Expect(0, 1731, '\p{^Jg=tehmarbutagoal}', "");
    Expect(0, 1731, '\P{Jg=tehmarbutagoal}', "");
    Expect(1, 1731, '\P{^Jg=tehmarbutagoal}', "");
    Expect(0, 1732, '\p{Jg=tehmarbutagoal}', "");
    Expect(1, 1732, '\p{^Jg=tehmarbutagoal}', "");
    Expect(1, 1732, '\P{Jg=tehmarbutagoal}', "");
    Expect(0, 1732, '\P{^Jg=tehmarbutagoal}', "");
    Expect(1, 1731, '\p{Jg=:\Atehmarbutagoal\z:}', "");;
    Expect(0, 1732, '\p{Jg=:\Atehmarbutagoal\z:}', "");;
    Expect(1, 1731, '\p{Jg=-	teh_marbuta_GOAL}', "");
    Expect(0, 1731, '\p{^Jg=-	teh_marbuta_GOAL}', "");
    Expect(0, 1731, '\P{Jg=-	teh_marbuta_GOAL}', "");
    Expect(1, 1731, '\P{^Jg=-	teh_marbuta_GOAL}', "");
    Expect(0, 1732, '\p{Jg=-	teh_marbuta_GOAL}', "");
    Expect(1, 1732, '\p{^Jg=-	teh_marbuta_GOAL}', "");
    Expect(1, 1732, '\P{Jg=-	teh_marbuta_GOAL}', "");
    Expect(0, 1732, '\P{^Jg=-	teh_marbuta_GOAL}', "");
    Error('\p{Is_Joining_Group=_:=hamza_on_Heh_Goal}');
    Error('\P{Is_Joining_Group=_:=hamza_on_Heh_Goal}');
    Expect(1, 1731, '\p{Is_Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1731, '\p{^Is_Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1731, '\P{Is_Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1731, '\P{^Is_Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1732, '\p{Is_Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1732, '\p{^Is_Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1732, '\P{Is_Joining_Group=hamzaonhehgoal}', "");
    Expect(0, 1732, '\P{^Is_Joining_Group=hamzaonhehgoal}', "");
    Expect(1, 1731, '\p{Is_Joining_Group= 	hamza_On_HEH_Goal}', "");
    Expect(0, 1731, '\p{^Is_Joining_Group= 	hamza_On_HEH_Goal}', "");
    Expect(0, 1731, '\P{Is_Joining_Group= 	hamza_On_HEH_Goal}', "");
    Expect(1, 1731, '\P{^Is_Joining_Group= 	hamza_On_HEH_Goal}', "");
    Expect(0, 1732, '\p{Is_Joining_Group= 	hamza_On_HEH_Goal}', "");
    Expect(1, 1732, '\p{^Is_Joining_Group= 	hamza_On_HEH_Goal}', "");
    Expect(1, 1732, '\P{Is_Joining_Group= 	hamza_On_HEH_Goal}', "");
    Expect(0, 1732, '\P{^Is_Joining_Group= 	hamza_On_HEH_Goal}', "");
    Error('\p{Is_Jg=	teh_Marbuta_goal:=}');
    Error('\P{Is_Jg=	teh_Marbuta_goal:=}');
    Expect(1, 1731, '\p{Is_Jg=tehmarbutagoal}', "");
    Expect(0, 1731, '\p{^Is_Jg=tehmarbutagoal}', "");
    Expect(0, 1731, '\P{Is_Jg=tehmarbutagoal}', "");
    Expect(1, 1731, '\P{^Is_Jg=tehmarbutagoal}', "");
    Expect(0, 1732, '\p{Is_Jg=tehmarbutagoal}', "");
    Expect(1, 1732, '\p{^Is_Jg=tehmarbutagoal}', "");
    Expect(1, 1732, '\P{Is_Jg=tehmarbutagoal}', "");
    Expect(0, 1732, '\P{^Is_Jg=tehmarbutagoal}', "");
    Expect(1, 1731, '\p{Is_Jg=	 teh_Marbuta_GOAL}', "");
    Expect(0, 1731, '\p{^Is_Jg=	 teh_Marbuta_GOAL}', "");
    Expect(0, 1731, '\P{Is_Jg=	 teh_Marbuta_GOAL}', "");
    Expect(1, 1731, '\P{^Is_Jg=	 teh_Marbuta_GOAL}', "");
    Expect(0, 1732, '\p{Is_Jg=	 teh_Marbuta_GOAL}', "");
    Expect(1, 1732, '\p{^Is_Jg=	 teh_Marbuta_GOAL}', "");
    Expect(1, 1732, '\P{Is_Jg=	 teh_Marbuta_GOAL}', "");
    Expect(0, 1732, '\P{^Is_Jg=	 teh_Marbuta_GOAL}', "");
    Error('\p{Joining_Group=:= Teth}');
    Error('\P{Joining_Group=:= Teth}');
    Expect(1, 1820, '\p{Joining_Group=:\ATeth\z:}', "");;
    Expect(0, 1821, '\p{Joining_Group=:\ATeth\z:}', "");;
    Expect(1, 1820, '\p{Joining_Group=teth}', "");
    Expect(0, 1820, '\p{^Joining_Group=teth}', "");
    Expect(0, 1820, '\P{Joining_Group=teth}', "");
    Expect(1, 1820, '\P{^Joining_Group=teth}', "");
    Expect(0, 1821, '\p{Joining_Group=teth}', "");
    Expect(1, 1821, '\p{^Joining_Group=teth}', "");
    Expect(1, 1821, '\P{Joining_Group=teth}', "");
    Expect(0, 1821, '\P{^Joining_Group=teth}', "");
    Expect(1, 1820, '\p{Joining_Group=:\Ateth\z:}', "");;
    Expect(0, 1821, '\p{Joining_Group=:\Ateth\z:}', "");;
    Expect(1, 1820, '\p{Joining_Group= _TETH}', "");
    Expect(0, 1820, '\p{^Joining_Group= _TETH}', "");
    Expect(0, 1820, '\P{Joining_Group= _TETH}', "");
    Expect(1, 1820, '\P{^Joining_Group= _TETH}', "");
    Expect(0, 1821, '\p{Joining_Group= _TETH}', "");
    Expect(1, 1821, '\p{^Joining_Group= _TETH}', "");
    Expect(1, 1821, '\P{Joining_Group= _TETH}', "");
    Expect(0, 1821, '\P{^Joining_Group= _TETH}', "");
    Error('\p{Jg:	-/a/TETH}');
    Error('\P{Jg:	-/a/TETH}');
    Expect(1, 1820, '\p{Jg=:\ATeth\z:}', "");;
    Expect(0, 1821, '\p{Jg=:\ATeth\z:}', "");;
    Expect(1, 1820, '\p{Jg:teth}', "");
    Expect(0, 1820, '\p{^Jg:teth}', "");
    Expect(0, 1820, '\P{Jg:teth}', "");
    Expect(1, 1820, '\P{^Jg:teth}', "");
    Expect(0, 1821, '\p{Jg:teth}', "");
    Expect(1, 1821, '\p{^Jg:teth}', "");
    Expect(1, 1821, '\P{Jg:teth}', "");
    Expect(0, 1821, '\P{^Jg:teth}', "");
    Expect(1, 1820, '\p{Jg=:\Ateth\z:}', "");;
    Expect(0, 1821, '\p{Jg=:\Ateth\z:}', "");;
    Expect(1, 1820, '\p{Jg:-_Teth}', "");
    Expect(0, 1820, '\p{^Jg:-_Teth}', "");
    Expect(0, 1820, '\P{Jg:-_Teth}', "");
    Expect(1, 1820, '\P{^Jg:-_Teth}', "");
    Expect(0, 1821, '\p{Jg:-_Teth}', "");
    Expect(1, 1821, '\p{^Jg:-_Teth}', "");
    Expect(1, 1821, '\P{Jg:-_Teth}', "");
    Expect(0, 1821, '\P{^Jg:-_Teth}', "");
    Error('\p{Is_Joining_Group=/a/-_TETH}');
    Error('\P{Is_Joining_Group=/a/-_TETH}');
    Expect(1, 1820, '\p{Is_Joining_Group=teth}', "");
    Expect(0, 1820, '\p{^Is_Joining_Group=teth}', "");
    Expect(0, 1820, '\P{Is_Joining_Group=teth}', "");
    Expect(1, 1820, '\P{^Is_Joining_Group=teth}', "");
    Expect(0, 1821, '\p{Is_Joining_Group=teth}', "");
    Expect(1, 1821, '\p{^Is_Joining_Group=teth}', "");
    Expect(1, 1821, '\P{Is_Joining_Group=teth}', "");
    Expect(0, 1821, '\P{^Is_Joining_Group=teth}', "");
    Expect(1, 1820, '\p{Is_Joining_Group=__Teth}', "");
    Expect(0, 1820, '\p{^Is_Joining_Group=__Teth}', "");
    Expect(0, 1820, '\P{Is_Joining_Group=__Teth}', "");
    Expect(1, 1820, '\P{^Is_Joining_Group=__Teth}', "");
    Expect(0, 1821, '\p{Is_Joining_Group=__Teth}', "");
    Expect(1, 1821, '\p{^Is_Joining_Group=__Teth}', "");
    Expect(1, 1821, '\P{Is_Joining_Group=__Teth}', "");
    Expect(0, 1821, '\P{^Is_Joining_Group=__Teth}', "");
    Error('\p{Is_Jg:-/a/Teth}');
    Error('\P{Is_Jg:-/a/Teth}');
    Expect(1, 1820, '\p{Is_Jg=teth}', "");
    Expect(0, 1820, '\p{^Is_Jg=teth}', "");
    Expect(0, 1820, '\P{Is_Jg=teth}', "");
    Expect(1, 1820, '\P{^Is_Jg=teth}', "");
    Expect(0, 1821, '\p{Is_Jg=teth}', "");
    Expect(1, 1821, '\p{^Is_Jg=teth}', "");
    Expect(1, 1821, '\P{Is_Jg=teth}', "");
    Expect(0, 1821, '\P{^Is_Jg=teth}', "");
    Expect(1, 1820, '\p{Is_Jg= 	Teth}', "");
    Expect(0, 1820, '\p{^Is_Jg= 	Teth}', "");
    Expect(0, 1820, '\P{Is_Jg= 	Teth}', "");
    Expect(1, 1820, '\P{^Is_Jg= 	Teth}', "");
    Expect(0, 1821, '\p{Is_Jg= 	Teth}', "");
    Expect(1, 1821, '\p{^Is_Jg= 	Teth}', "");
    Expect(1, 1821, '\P{Is_Jg= 	Teth}', "");
    Expect(0, 1821, '\P{^Is_Jg= 	Teth}', "");
    Error('\p{Joining_Group=_	WAW/a/}');
    Error('\P{Joining_Group=_	WAW/a/}');
    Expect(1, 2219, '\p{Joining_Group=:\AWaw\z:}', "");;
    Expect(0, 2220, '\p{Joining_Group=:\AWaw\z:}', "");;
    Expect(1, 2219, '\p{Joining_Group=waw}', "");
    Expect(0, 2219, '\p{^Joining_Group=waw}', "");
    Expect(0, 2219, '\P{Joining_Group=waw}', "");
    Expect(1, 2219, '\P{^Joining_Group=waw}', "");
    Expect(0, 2220, '\p{Joining_Group=waw}', "");
    Expect(1, 2220, '\p{^Joining_Group=waw}', "");
    Expect(1, 2220, '\P{Joining_Group=waw}', "");
    Expect(0, 2220, '\P{^Joining_Group=waw}', "");
    Expect(1, 2219, '\p{Joining_Group=:\Awaw\z:}', "");;
    Expect(0, 2220, '\p{Joining_Group=:\Awaw\z:}', "");;
    Expect(1, 2219, '\p{Joining_Group=- waw}', "");
    Expect(0, 2219, '\p{^Joining_Group=- waw}', "");
    Expect(0, 2219, '\P{Joining_Group=- waw}', "");
    Expect(1, 2219, '\P{^Joining_Group=- waw}', "");
    Expect(0, 2220, '\p{Joining_Group=- waw}', "");
    Expect(1, 2220, '\p{^Joining_Group=- waw}', "");
    Expect(1, 2220, '\P{Joining_Group=- waw}', "");
    Expect(0, 2220, '\P{^Joining_Group=- waw}', "");
    Error('\p{Jg=:=_WAW}');
    Error('\P{Jg=:=_WAW}');
    Expect(1, 2219, '\p{Jg=:\AWaw\z:}', "");;
    Expect(0, 2220, '\p{Jg=:\AWaw\z:}', "");;
    Expect(1, 2219, '\p{Jg=waw}', "");
    Expect(0, 2219, '\p{^Jg=waw}', "");
    Expect(0, 2219, '\P{Jg=waw}', "");
    Expect(1, 2219, '\P{^Jg=waw}', "");
    Expect(0, 2220, '\p{Jg=waw}', "");
    Expect(1, 2220, '\p{^Jg=waw}', "");
    Expect(1, 2220, '\P{Jg=waw}', "");
    Expect(0, 2220, '\P{^Jg=waw}', "");
    Expect(1, 2219, '\p{Jg=:\Awaw\z:}', "");;
    Expect(0, 2220, '\p{Jg=:\Awaw\z:}', "");;
    Expect(1, 2219, '\p{Jg=--WAW}', "");
    Expect(0, 2219, '\p{^Jg=--WAW}', "");
    Expect(0, 2219, '\P{Jg=--WAW}', "");
    Expect(1, 2219, '\P{^Jg=--WAW}', "");
    Expect(0, 2220, '\p{Jg=--WAW}', "");
    Expect(1, 2220, '\p{^Jg=--WAW}', "");
    Expect(1, 2220, '\P{Jg=--WAW}', "");
    Expect(0, 2220, '\P{^Jg=--WAW}', "");
    Error('\p{Is_Joining_Group= :=Waw}');
    Error('\P{Is_Joining_Group= :=Waw}');
    Expect(1, 2219, '\p{Is_Joining_Group:   waw}', "");
    Expect(0, 2219, '\p{^Is_Joining_Group:   waw}', "");
    Expect(0, 2219, '\P{Is_Joining_Group:   waw}', "");
    Expect(1, 2219, '\P{^Is_Joining_Group:   waw}', "");
    Expect(0, 2220, '\p{Is_Joining_Group:   waw}', "");
    Expect(1, 2220, '\p{^Is_Joining_Group:   waw}', "");
    Expect(1, 2220, '\P{Is_Joining_Group:   waw}', "");
    Expect(0, 2220, '\P{^Is_Joining_Group:   waw}', "");
    Expect(1, 2219, '\p{Is_Joining_Group=_-waw}', "");
    Expect(0, 2219, '\p{^Is_Joining_Group=_-waw}', "");
    Expect(0, 2219, '\P{Is_Joining_Group=_-waw}', "");
    Expect(1, 2219, '\P{^Is_Joining_Group=_-waw}', "");
    Expect(0, 2220, '\p{Is_Joining_Group=_-waw}', "");
    Expect(1, 2220, '\p{^Is_Joining_Group=_-waw}', "");
    Expect(1, 2220, '\P{Is_Joining_Group=_-waw}', "");
    Expect(0, 2220, '\P{^Is_Joining_Group=_-waw}', "");
    Error('\p{Is_Jg:   :=-Waw}');
    Error('\P{Is_Jg:   :=-Waw}');
    Expect(1, 2219, '\p{Is_Jg=waw}', "");
    Expect(0, 2219, '\p{^Is_Jg=waw}', "");
    Expect(0, 2219, '\P{Is_Jg=waw}', "");
    Expect(1, 2219, '\P{^Is_Jg=waw}', "");
    Expect(0, 2220, '\p{Is_Jg=waw}', "");
    Expect(1, 2220, '\p{^Is_Jg=waw}', "");
    Expect(1, 2220, '\P{Is_Jg=waw}', "");
    Expect(0, 2220, '\P{^Is_Jg=waw}', "");
    Expect(1, 2219, '\p{Is_Jg=-	Waw}', "");
    Expect(0, 2219, '\p{^Is_Jg=-	Waw}', "");
    Expect(0, 2219, '\P{Is_Jg=-	Waw}', "");
    Expect(1, 2219, '\P{^Is_Jg=-	Waw}', "");
    Expect(0, 2220, '\p{Is_Jg=-	Waw}', "");
    Expect(1, 2220, '\p{^Is_Jg=-	Waw}', "");
    Expect(1, 2220, '\P{Is_Jg=-	Waw}', "");
    Expect(0, 2220, '\P{^Is_Jg=-	Waw}', "");
    Error('\p{Joining_Group=_/a/yeh}');
    Error('\P{Joining_Group=_/a/yeh}');
    Expect(1, 2234, '\p{Joining_Group=:\AYeh\z:}', "");;
    Expect(0, 2235, '\p{Joining_Group=:\AYeh\z:}', "");;
    Expect(1, 2234, '\p{Joining_Group=yeh}', "");
    Expect(0, 2234, '\p{^Joining_Group=yeh}', "");
    Expect(0, 2234, '\P{Joining_Group=yeh}', "");
    Expect(1, 2234, '\P{^Joining_Group=yeh}', "");
    Expect(0, 2235, '\p{Joining_Group=yeh}', "");
    Expect(1, 2235, '\p{^Joining_Group=yeh}', "");
    Expect(1, 2235, '\P{Joining_Group=yeh}', "");
    Expect(0, 2235, '\P{^Joining_Group=yeh}', "");
    Expect(1, 2234, '\p{Joining_Group=:\Ayeh\z:}', "");;
    Expect(0, 2235, '\p{Joining_Group=:\Ayeh\z:}', "");;
    Expect(1, 2234, '\p{Joining_Group=-	yeh}', "");
    Expect(0, 2234, '\p{^Joining_Group=-	yeh}', "");
    Expect(0, 2234, '\P{Joining_Group=-	yeh}', "");
    Expect(1, 2234, '\P{^Joining_Group=-	yeh}', "");
    Expect(0, 2235, '\p{Joining_Group=-	yeh}', "");
    Expect(1, 2235, '\p{^Joining_Group=-	yeh}', "");
    Expect(1, 2235, '\P{Joining_Group=-	yeh}', "");
    Expect(0, 2235, '\P{^Joining_Group=-	yeh}', "");
    Error('\p{Jg=-yeh/a/}');
    Error('\P{Jg=-yeh/a/}');
    Expect(1, 2234, '\p{Jg=:\AYeh\z:}', "");;
    Expect(0, 2235, '\p{Jg=:\AYeh\z:}', "");;
    Expect(1, 2234, '\p{Jg=yeh}', "");
    Expect(0, 2234, '\p{^Jg=yeh}', "");
    Expect(0, 2234, '\P{Jg=yeh}', "");
    Expect(1, 2234, '\P{^Jg=yeh}', "");
    Expect(0, 2235, '\p{Jg=yeh}', "");
    Expect(1, 2235, '\p{^Jg=yeh}', "");
    Expect(1, 2235, '\P{Jg=yeh}', "");
    Expect(0, 2235, '\P{^Jg=yeh}', "");
    Expect(1, 2234, '\p{Jg=:\Ayeh\z:}', "");;
    Expect(0, 2235, '\p{Jg=:\Ayeh\z:}', "");;
    Expect(1, 2234, '\p{Jg=-yeh}', "");
    Expect(0, 2234, '\p{^Jg=-yeh}', "");
    Expect(0, 2234, '\P{Jg=-yeh}', "");
    Expect(1, 2234, '\P{^Jg=-yeh}', "");
    Expect(0, 2235, '\p{Jg=-yeh}', "");
    Expect(1, 2235, '\p{^Jg=-yeh}', "");
    Expect(1, 2235, '\P{Jg=-yeh}', "");
    Expect(0, 2235, '\P{^Jg=-yeh}', "");
    Error('\p{Is_Joining_Group: :=		Yeh}');
    Error('\P{Is_Joining_Group: :=		Yeh}');
    Expect(1, 2234, '\p{Is_Joining_Group=yeh}', "");
    Expect(0, 2234, '\p{^Is_Joining_Group=yeh}', "");
    Expect(0, 2234, '\P{Is_Joining_Group=yeh}', "");
    Expect(1, 2234, '\P{^Is_Joining_Group=yeh}', "");
    Expect(0, 2235, '\p{Is_Joining_Group=yeh}', "");
    Expect(1, 2235, '\p{^Is_Joining_Group=yeh}', "");
    Expect(1, 2235, '\P{Is_Joining_Group=yeh}', "");
    Expect(0, 2235, '\P{^Is_Joining_Group=yeh}', "");
    Expect(1, 2234, '\p{Is_Joining_Group=--Yeh}', "");
    Expect(0, 2234, '\p{^Is_Joining_Group=--Yeh}', "");
    Expect(0, 2234, '\P{Is_Joining_Group=--Yeh}', "");
    Expect(1, 2234, '\P{^Is_Joining_Group=--Yeh}', "");
    Expect(0, 2235, '\p{Is_Joining_Group=--Yeh}', "");
    Expect(1, 2235, '\p{^Is_Joining_Group=--Yeh}', "");
    Expect(1, 2235, '\P{Is_Joining_Group=--Yeh}', "");
    Expect(0, 2235, '\P{^Is_Joining_Group=--Yeh}', "");
    Error('\p{Is_Jg=-:=YEH}');
    Error('\P{Is_Jg=-:=YEH}');
    Expect(1, 2234, '\p{Is_Jg:   yeh}', "");
    Expect(0, 2234, '\p{^Is_Jg:   yeh}', "");
    Expect(0, 2234, '\P{Is_Jg:   yeh}', "");
    Expect(1, 2234, '\P{^Is_Jg:   yeh}', "");
    Expect(0, 2235, '\p{Is_Jg:   yeh}', "");
    Expect(1, 2235, '\p{^Is_Jg:   yeh}', "");
    Expect(1, 2235, '\P{Is_Jg:   yeh}', "");
    Expect(0, 2235, '\P{^Is_Jg:   yeh}', "");
    Expect(1, 2234, '\p{Is_Jg=-_YEH}', "");
    Expect(0, 2234, '\p{^Is_Jg=-_YEH}', "");
    Expect(0, 2234, '\P{Is_Jg=-_YEH}', "");
    Expect(1, 2234, '\P{^Is_Jg=-_YEH}', "");
    Expect(0, 2235, '\p{Is_Jg=-_YEH}', "");
    Expect(1, 2235, '\p{^Is_Jg=-_YEH}', "");
    Expect(1, 2235, '\P{Is_Jg=-_YEH}', "");
    Expect(0, 2235, '\P{^Is_Jg=-_YEH}', "");
    Error('\p{Joining_Group=  YEH_Barree:=}');
    Error('\P{Joining_Group=  YEH_Barree:=}');
    Expect(1, 1747, '\p{Joining_Group=:\AYeh_Barree\z:}', "");;
    Expect(0, 1748, '\p{Joining_Group=:\AYeh_Barree\z:}', "");;
    Expect(1, 1747, '\p{Joining_Group=yehbarree}', "");
    Expect(0, 1747, '\p{^Joining_Group=yehbarree}', "");
    Expect(0, 1747, '\P{Joining_Group=yehbarree}', "");
    Expect(1, 1747, '\P{^Joining_Group=yehbarree}', "");
    Expect(0, 1748, '\p{Joining_Group=yehbarree}', "");
    Expect(1, 1748, '\p{^Joining_Group=yehbarree}', "");
    Expect(1, 1748, '\P{Joining_Group=yehbarree}', "");
    Expect(0, 1748, '\P{^Joining_Group=yehbarree}', "");
    Expect(1, 1747, '\p{Joining_Group=:\Ayehbarree\z:}', "");;
    Expect(0, 1748, '\p{Joining_Group=:\Ayehbarree\z:}', "");;
    Expect(1, 1747, '\p{Joining_Group:	_ Yeh_Barree}', "");
    Expect(0, 1747, '\p{^Joining_Group:	_ Yeh_Barree}', "");
    Expect(0, 1747, '\P{Joining_Group:	_ Yeh_Barree}', "");
    Expect(1, 1747, '\P{^Joining_Group:	_ Yeh_Barree}', "");
    Expect(0, 1748, '\p{Joining_Group:	_ Yeh_Barree}', "");
    Expect(1, 1748, '\p{^Joining_Group:	_ Yeh_Barree}', "");
    Expect(1, 1748, '\P{Joining_Group:	_ Yeh_Barree}', "");
    Expect(0, 1748, '\P{^Joining_Group:	_ Yeh_Barree}', "");
    Error('\p{Jg=_-Yeh_barree/a/}');
    Error('\P{Jg=_-Yeh_barree/a/}');
    Expect(1, 1747, '\p{Jg=:\AYeh_Barree\z:}', "");;
    Expect(0, 1748, '\p{Jg=:\AYeh_Barree\z:}', "");;
    Expect(1, 1747, '\p{Jg=yehbarree}', "");
    Expect(0, 1747, '\p{^Jg=yehbarree}', "");
    Expect(0, 1747, '\P{Jg=yehbarree}', "");
    Expect(1, 1747, '\P{^Jg=yehbarree}', "");
    Expect(0, 1748, '\p{Jg=yehbarree}', "");
    Expect(1, 1748, '\p{^Jg=yehbarree}', "");
    Expect(1, 1748, '\P{Jg=yehbarree}', "");
    Expect(0, 1748, '\P{^Jg=yehbarree}', "");
    Expect(1, 1747, '\p{Jg=:\Ayehbarree\z:}', "");;
    Expect(0, 1748, '\p{Jg=:\Ayehbarree\z:}', "");;
    Expect(1, 1747, '\p{Jg=_Yeh_BARREE}', "");
    Expect(0, 1747, '\p{^Jg=_Yeh_BARREE}', "");
    Expect(0, 1747, '\P{Jg=_Yeh_BARREE}', "");
    Expect(1, 1747, '\P{^Jg=_Yeh_BARREE}', "");
    Expect(0, 1748, '\p{Jg=_Yeh_BARREE}', "");
    Expect(1, 1748, '\p{^Jg=_Yeh_BARREE}', "");
    Expect(1, 1748, '\P{Jg=_Yeh_BARREE}', "");
    Expect(0, 1748, '\P{^Jg=_Yeh_BARREE}', "");
    Error('\p{Is_Joining_Group=:=YEH_BARREE}');
    Error('\P{Is_Joining_Group=:=YEH_BARREE}');
    Expect(1, 1747, '\p{Is_Joining_Group=yehbarree}', "");
    Expect(0, 1747, '\p{^Is_Joining_Group=yehbarree}', "");
    Expect(0, 1747, '\P{Is_Joining_Group=yehbarree}', "");
    Expect(1, 1747, '\P{^Is_Joining_Group=yehbarree}', "");
    Expect(0, 1748, '\p{Is_Joining_Group=yehbarree}', "");
    Expect(1, 1748, '\p{^Is_Joining_Group=yehbarree}', "");
    Expect(1, 1748, '\P{Is_Joining_Group=yehbarree}', "");
    Expect(0, 1748, '\P{^Is_Joining_Group=yehbarree}', "");
    Expect(1, 1747, '\p{Is_Joining_Group=__Yeh_Barree}', "");
    Expect(0, 1747, '\p{^Is_Joining_Group=__Yeh_Barree}', "");
    Expect(0, 1747, '\P{Is_Joining_Group=__Yeh_Barree}', "");
    Expect(1, 1747, '\P{^Is_Joining_Group=__Yeh_Barree}', "");
    Expect(0, 1748, '\p{Is_Joining_Group=__Yeh_Barree}', "");
    Expect(1, 1748, '\p{^Is_Joining_Group=__Yeh_Barree}', "");
    Expect(1, 1748, '\P{Is_Joining_Group=__Yeh_Barree}', "");
    Expect(0, 1748, '\P{^Is_Joining_Group=__Yeh_Barree}', "");
    Error('\p{Is_Jg=	-yeh_Barree/a/}');
    Error('\P{Is_Jg=	-yeh_Barree/a/}');
    Expect(1, 1747, '\p{Is_Jg=yehbarree}', "");
    Expect(0, 1747, '\p{^Is_Jg=yehbarree}', "");
    Expect(0, 1747, '\P{Is_Jg=yehbarree}', "");
    Expect(1, 1747, '\P{^Is_Jg=yehbarree}', "");
    Expect(0, 1748, '\p{Is_Jg=yehbarree}', "");
    Expect(1, 1748, '\p{^Is_Jg=yehbarree}', "");
    Expect(1, 1748, '\P{Is_Jg=yehbarree}', "");
    Expect(0, 1748, '\P{^Is_Jg=yehbarree}', "");
    Expect(1, 1747, '\p{Is_Jg=--Yeh_Barree}', "");
    Expect(0, 1747, '\p{^Is_Jg=--Yeh_Barree}', "");
    Expect(0, 1747, '\P{Is_Jg=--Yeh_Barree}', "");
    Expect(1, 1747, '\P{^Is_Jg=--Yeh_Barree}', "");
    Expect(0, 1748, '\p{Is_Jg=--Yeh_Barree}', "");
    Expect(1, 1748, '\p{^Is_Jg=--Yeh_Barree}', "");
    Expect(1, 1748, '\P{Is_Jg=--Yeh_Barree}', "");
    Expect(0, 1748, '\P{^Is_Jg=--Yeh_Barree}', "");
    Error('\p{Joining_Group:- YEH_WITH_TAIL:=}');
    Error('\P{Joining_Group:- YEH_WITH_TAIL:=}');
    Expect(1, 1741, '\p{Joining_Group=:\AYeh_With_Tail\z:}', "");;
    Expect(0, 1742, '\p{Joining_Group=:\AYeh_With_Tail\z:}', "");;
    Expect(1, 1741, '\p{Joining_Group=yehwithtail}', "");
    Expect(0, 1741, '\p{^Joining_Group=yehwithtail}', "");
    Expect(0, 1741, '\P{Joining_Group=yehwithtail}', "");
    Expect(1, 1741, '\P{^Joining_Group=yehwithtail}', "");
    Expect(0, 1742, '\p{Joining_Group=yehwithtail}', "");
    Expect(1, 1742, '\p{^Joining_Group=yehwithtail}', "");
    Expect(1, 1742, '\P{Joining_Group=yehwithtail}', "");
    Expect(0, 1742, '\P{^Joining_Group=yehwithtail}', "");
    Expect(1, 1741, '\p{Joining_Group=:\Ayehwithtail\z:}', "");;
    Expect(0, 1742, '\p{Joining_Group=:\Ayehwithtail\z:}', "");;
    Expect(1, 1741, '\p{Joining_Group=__yeh_With_Tail}', "");
    Expect(0, 1741, '\p{^Joining_Group=__yeh_With_Tail}', "");
    Expect(0, 1741, '\P{Joining_Group=__yeh_With_Tail}', "");
    Expect(1, 1741, '\P{^Joining_Group=__yeh_With_Tail}', "");
    Expect(0, 1742, '\p{Joining_Group=__yeh_With_Tail}', "");
    Expect(1, 1742, '\p{^Joining_Group=__yeh_With_Tail}', "");
    Expect(1, 1742, '\P{Joining_Group=__yeh_With_Tail}', "");
    Expect(0, 1742, '\P{^Joining_Group=__yeh_With_Tail}', "");
    Error('\p{Jg=_-YEH_WITH_TAIL/a/}');
    Error('\P{Jg=_-YEH_WITH_TAIL/a/}');
    Expect(1, 1741, '\p{Jg=:\AYeh_With_Tail\z:}', "");;
    Expect(0, 1742, '\p{Jg=:\AYeh_With_Tail\z:}', "");;
    Expect(1, 1741, '\p{Jg=yehwithtail}', "");
    Expect(0, 1741, '\p{^Jg=yehwithtail}', "");
    Expect(0, 1741, '\P{Jg=yehwithtail}', "");
    Expect(1, 1741, '\P{^Jg=yehwithtail}', "");
    Expect(0, 1742, '\p{Jg=yehwithtail}', "");
    Expect(1, 1742, '\p{^Jg=yehwithtail}', "");
    Expect(1, 1742, '\P{Jg=yehwithtail}', "");
    Expect(0, 1742, '\P{^Jg=yehwithtail}', "");
    Expect(1, 1741, '\p{Jg=:\Ayehwithtail\z:}', "");;
    Expect(0, 1742, '\p{Jg=:\Ayehwithtail\z:}', "");;
    Expect(1, 1741, '\p{Jg= _Yeh_With_TAIL}', "");
    Expect(0, 1741, '\p{^Jg= _Yeh_With_TAIL}', "");
    Expect(0, 1741, '\P{Jg= _Yeh_With_TAIL}', "");
    Expect(1, 1741, '\P{^Jg= _Yeh_With_TAIL}', "");
    Expect(0, 1742, '\p{Jg= _Yeh_With_TAIL}', "");
    Expect(1, 1742, '\p{^Jg= _Yeh_With_TAIL}', "");
    Expect(1, 1742, '\P{Jg= _Yeh_With_TAIL}', "");
    Expect(0, 1742, '\P{^Jg= _Yeh_With_TAIL}', "");
    Error('\p{Is_Joining_Group=_-YEH_With_TAIL:=}');
    Error('\P{Is_Joining_Group=_-YEH_With_TAIL:=}');
    Expect(1, 1741, '\p{Is_Joining_Group: yehwithtail}', "");
    Expect(0, 1741, '\p{^Is_Joining_Group: yehwithtail}', "");
    Expect(0, 1741, '\P{Is_Joining_Group: yehwithtail}', "");
    Expect(1, 1741, '\P{^Is_Joining_Group: yehwithtail}', "");
    Expect(0, 1742, '\p{Is_Joining_Group: yehwithtail}', "");
    Expect(1, 1742, '\p{^Is_Joining_Group: yehwithtail}', "");
    Expect(1, 1742, '\P{Is_Joining_Group: yehwithtail}', "");
    Expect(0, 1742, '\P{^Is_Joining_Group: yehwithtail}', "");
    Expect(1, 1741, '\p{Is_Joining_Group=Yeh_With_Tail}', "");
    Expect(0, 1741, '\p{^Is_Joining_Group=Yeh_With_Tail}', "");
    Expect(0, 1741, '\P{Is_Joining_Group=Yeh_With_Tail}', "");
    Expect(1, 1741, '\P{^Is_Joining_Group=Yeh_With_Tail}', "");
    Expect(0, 1742, '\p{Is_Joining_Group=Yeh_With_Tail}', "");
    Expect(1, 1742, '\p{^Is_Joining_Group=Yeh_With_Tail}', "");
    Expect(1, 1742, '\P{Is_Joining_Group=Yeh_With_Tail}', "");
    Expect(0, 1742, '\P{^Is_Joining_Group=Yeh_With_Tail}', "");
    Error('\p{Is_Jg=_/a/Yeh_with_Tail}');
    Error('\P{Is_Jg=_/a/Yeh_with_Tail}');
    Expect(1, 1741, '\p{Is_Jg=yehwithtail}', "");
    Expect(0, 1741, '\p{^Is_Jg=yehwithtail}', "");
    Expect(0, 1741, '\P{Is_Jg=yehwithtail}', "");
    Expect(1, 1741, '\P{^Is_Jg=yehwithtail}', "");
    Expect(0, 1742, '\p{Is_Jg=yehwithtail}', "");
    Expect(1, 1742, '\p{^Is_Jg=yehwithtail}', "");
    Expect(1, 1742, '\P{Is_Jg=yehwithtail}', "");
    Expect(0, 1742, '\P{^Is_Jg=yehwithtail}', "");
    Expect(1, 1741, '\p{Is_Jg=yeh_With_Tail}', "");
    Expect(0, 1741, '\p{^Is_Jg=yeh_With_Tail}', "");
    Expect(0, 1741, '\P{Is_Jg=yeh_With_Tail}', "");
    Expect(1, 1741, '\P{^Is_Jg=yeh_With_Tail}', "");
    Expect(0, 1742, '\p{Is_Jg=yeh_With_Tail}', "");
    Expect(1, 1742, '\p{^Is_Jg=yeh_With_Tail}', "");
    Expect(1, 1742, '\P{Is_Jg=yeh_With_Tail}', "");
    Expect(0, 1742, '\P{^Is_Jg=yeh_With_Tail}', "");
    Error('\p{Joining_Group=/a/-Yudh}');
    Error('\P{Joining_Group=/a/-Yudh}');
    Expect(1, 1821, '\p{Joining_Group=:\AYudh\z:}', "");;
    Expect(0, 1822, '\p{Joining_Group=:\AYudh\z:}', "");;
    Expect(1, 1821, '\p{Joining_Group:	yudh}', "");
    Expect(0, 1821, '\p{^Joining_Group:	yudh}', "");
    Expect(0, 1821, '\P{Joining_Group:	yudh}', "");
    Expect(1, 1821, '\P{^Joining_Group:	yudh}', "");
    Expect(0, 1822, '\p{Joining_Group:	yudh}', "");
    Expect(1, 1822, '\p{^Joining_Group:	yudh}', "");
    Expect(1, 1822, '\P{Joining_Group:	yudh}', "");
    Expect(0, 1822, '\P{^Joining_Group:	yudh}', "");
    Expect(1, 1821, '\p{Joining_Group=:\Ayudh\z:}', "");;
    Expect(0, 1822, '\p{Joining_Group=:\Ayudh\z:}', "");;
    Expect(1, 1821, '\p{Joining_Group:	_ YUDH}', "");
    Expect(0, 1821, '\p{^Joining_Group:	_ YUDH}', "");
    Expect(0, 1821, '\P{Joining_Group:	_ YUDH}', "");
    Expect(1, 1821, '\P{^Joining_Group:	_ YUDH}', "");
    Expect(0, 1822, '\p{Joining_Group:	_ YUDH}', "");
    Expect(1, 1822, '\p{^Joining_Group:	_ YUDH}', "");
    Expect(1, 1822, '\P{Joining_Group:	_ YUDH}', "");
    Expect(0, 1822, '\P{^Joining_Group:	_ YUDH}', "");
    Error('\p{Jg=/a/_	YUDH}');
    Error('\P{Jg=/a/_	YUDH}');
    Expect(1, 1821, '\p{Jg=:\AYudh\z:}', "");;
    Expect(0, 1822, '\p{Jg=:\AYudh\z:}', "");;
    Expect(1, 1821, '\p{Jg=yudh}', "");
    Expect(0, 1821, '\p{^Jg=yudh}', "");
    Expect(0, 1821, '\P{Jg=yudh}', "");
    Expect(1, 1821, '\P{^Jg=yudh}', "");
    Expect(0, 1822, '\p{Jg=yudh}', "");
    Expect(1, 1822, '\p{^Jg=yudh}', "");
    Expect(1, 1822, '\P{Jg=yudh}', "");
    Expect(0, 1822, '\P{^Jg=yudh}', "");
    Expect(1, 1821, '\p{Jg=:\Ayudh\z:}', "");;
    Expect(0, 1822, '\p{Jg=:\Ayudh\z:}', "");;
    Expect(1, 1821, '\p{Jg=_Yudh}', "");
    Expect(0, 1821, '\p{^Jg=_Yudh}', "");
    Expect(0, 1821, '\P{Jg=_Yudh}', "");
    Expect(1, 1821, '\P{^Jg=_Yudh}', "");
    Expect(0, 1822, '\p{Jg=_Yudh}', "");
    Expect(1, 1822, '\p{^Jg=_Yudh}', "");
    Expect(1, 1822, '\P{Jg=_Yudh}', "");
    Expect(0, 1822, '\P{^Jg=_Yudh}', "");
    Error('\p{Is_Joining_Group=_:=yudh}');
    Error('\P{Is_Joining_Group=_:=yudh}');
    Expect(1, 1821, '\p{Is_Joining_Group=yudh}', "");
    Expect(0, 1821, '\p{^Is_Joining_Group=yudh}', "");
    Expect(0, 1821, '\P{Is_Joining_Group=yudh}', "");
    Expect(1, 1821, '\P{^Is_Joining_Group=yudh}', "");
    Expect(0, 1822, '\p{Is_Joining_Group=yudh}', "");
    Expect(1, 1822, '\p{^Is_Joining_Group=yudh}', "");
    Expect(1, 1822, '\P{Is_Joining_Group=yudh}', "");
    Expect(0, 1822, '\P{^Is_Joining_Group=yudh}', "");
    Expect(1, 1821, '\p{Is_Joining_Group=	-YUDH}', "");
    Expect(0, 1821, '\p{^Is_Joining_Group=	-YUDH}', "");
    Expect(0, 1821, '\P{Is_Joining_Group=	-YUDH}', "");
    Expect(1, 1821, '\P{^Is_Joining_Group=	-YUDH}', "");
    Expect(0, 1822, '\p{Is_Joining_Group=	-YUDH}', "");
    Expect(1, 1822, '\p{^Is_Joining_Group=	-YUDH}', "");
    Expect(1, 1822, '\P{Is_Joining_Group=	-YUDH}', "");
    Expect(0, 1822, '\P{^Is_Joining_Group=	-YUDH}', "");
    Error('\p{Is_Jg=/a/_-Yudh}');
    Error('\P{Is_Jg=/a/_-Yudh}');
    Expect(1, 1821, '\p{Is_Jg=yudh}', "");
    Expect(0, 1821, '\p{^Is_Jg=yudh}', "");
    Expect(0, 1821, '\P{Is_Jg=yudh}', "");
    Expect(1, 1821, '\P{^Is_Jg=yudh}', "");
    Expect(0, 1822, '\p{Is_Jg=yudh}', "");
    Expect(1, 1822, '\p{^Is_Jg=yudh}', "");
    Expect(1, 1822, '\P{Is_Jg=yudh}', "");
    Expect(0, 1822, '\P{^Is_Jg=yudh}', "");
    Expect(1, 1821, '\p{Is_Jg=	_Yudh}', "");
    Expect(0, 1821, '\p{^Is_Jg=	_Yudh}', "");
    Expect(0, 1821, '\P{Is_Jg=	_Yudh}', "");
    Expect(1, 1821, '\P{^Is_Jg=	_Yudh}', "");
    Expect(0, 1822, '\p{Is_Jg=	_Yudh}', "");
    Expect(1, 1822, '\p{^Is_Jg=	_Yudh}', "");
    Expect(1, 1822, '\P{Is_Jg=	_Yudh}', "");
    Expect(0, 1822, '\P{^Is_Jg=	_Yudh}', "");
    Error('\p{Joining_Group=:=Yudh_He}');
    Error('\P{Joining_Group=:=Yudh_He}');
    Expect(1, 1822, '\p{Joining_Group=:\AYudh_He\z:}', "");;
    Expect(0, 1823, '\p{Joining_Group=:\AYudh_He\z:}', "");;
    Expect(1, 1822, '\p{Joining_Group=yudhhe}', "");
    Expect(0, 1822, '\p{^Joining_Group=yudhhe}', "");
    Expect(0, 1822, '\P{Joining_Group=yudhhe}', "");
    Expect(1, 1822, '\P{^Joining_Group=yudhhe}', "");
    Expect(0, 1823, '\p{Joining_Group=yudhhe}', "");
    Expect(1, 1823, '\p{^Joining_Group=yudhhe}', "");
    Expect(1, 1823, '\P{Joining_Group=yudhhe}', "");
    Expect(0, 1823, '\P{^Joining_Group=yudhhe}', "");
    Expect(1, 1822, '\p{Joining_Group=:\Ayudhhe\z:}', "");;
    Expect(0, 1823, '\p{Joining_Group=:\Ayudhhe\z:}', "");;
    Expect(1, 1822, '\p{Joining_Group=--YUDH_He}', "");
    Expect(0, 1822, '\p{^Joining_Group=--YUDH_He}', "");
    Expect(0, 1822, '\P{Joining_Group=--YUDH_He}', "");
    Expect(1, 1822, '\P{^Joining_Group=--YUDH_He}', "");
    Expect(0, 1823, '\p{Joining_Group=--YUDH_He}', "");
    Expect(1, 1823, '\p{^Joining_Group=--YUDH_He}', "");
    Expect(1, 1823, '\P{Joining_Group=--YUDH_He}', "");
    Expect(0, 1823, '\P{^Joining_Group=--YUDH_He}', "");
    Error('\p{Jg=Yudh_He/a/}');
    Error('\P{Jg=Yudh_He/a/}');
    Expect(1, 1822, '\p{Jg=:\AYudh_He\z:}', "");;
    Expect(0, 1823, '\p{Jg=:\AYudh_He\z:}', "");;
    Expect(1, 1822, '\p{Jg=yudhhe}', "");
    Expect(0, 1822, '\p{^Jg=yudhhe}', "");
    Expect(0, 1822, '\P{Jg=yudhhe}', "");
    Expect(1, 1822, '\P{^Jg=yudhhe}', "");
    Expect(0, 1823, '\p{Jg=yudhhe}', "");
    Expect(1, 1823, '\p{^Jg=yudhhe}', "");
    Expect(1, 1823, '\P{Jg=yudhhe}', "");
    Expect(0, 1823, '\P{^Jg=yudhhe}', "");
    Expect(1, 1822, '\p{Jg=:\Ayudhhe\z:}', "");;
    Expect(0, 1823, '\p{Jg=:\Ayudhhe\z:}', "");;
    Expect(1, 1822, '\p{Jg=__YUDH_He}', "");
    Expect(0, 1822, '\p{^Jg=__YUDH_He}', "");
    Expect(0, 1822, '\P{Jg=__YUDH_He}', "");
    Expect(1, 1822, '\P{^Jg=__YUDH_He}', "");
    Expect(0, 1823, '\p{Jg=__YUDH_He}', "");
    Expect(1, 1823, '\p{^Jg=__YUDH_He}', "");
    Expect(1, 1823, '\P{Jg=__YUDH_He}', "");
    Expect(0, 1823, '\P{^Jg=__YUDH_He}', "");
    Error('\p{Is_Joining_Group=- Yudh_He/a/}');
    Error('\P{Is_Joining_Group=- Yudh_He/a/}');
    Expect(1, 1822, '\p{Is_Joining_Group=yudhhe}', "");
    Expect(0, 1822, '\p{^Is_Joining_Group=yudhhe}', "");
    Expect(0, 1822, '\P{Is_Joining_Group=yudhhe}', "");
    Expect(1, 1822, '\P{^Is_Joining_Group=yudhhe}', "");
    Expect(0, 1823, '\p{Is_Joining_Group=yudhhe}', "");
    Expect(1, 1823, '\p{^Is_Joining_Group=yudhhe}', "");
    Expect(1, 1823, '\P{Is_Joining_Group=yudhhe}', "");
    Expect(0, 1823, '\P{^Is_Joining_Group=yudhhe}', "");
    Expect(1, 1822, '\p{Is_Joining_Group=_	Yudh_He}', "");
    Expect(0, 1822, '\p{^Is_Joining_Group=_	Yudh_He}', "");
    Expect(0, 1822, '\P{Is_Joining_Group=_	Yudh_He}', "");
    Expect(1, 1822, '\P{^Is_Joining_Group=_	Yudh_He}', "");
    Expect(0, 1823, '\p{Is_Joining_Group=_	Yudh_He}', "");
    Expect(1, 1823, '\p{^Is_Joining_Group=_	Yudh_He}', "");
    Expect(1, 1823, '\P{Is_Joining_Group=_	Yudh_He}', "");
    Expect(0, 1823, '\P{^Is_Joining_Group=_	Yudh_He}', "");
    Error('\p{Is_Jg=:=	_Yudh_He}');
    Error('\P{Is_Jg=:=	_Yudh_He}');
    Expect(1, 1822, '\p{Is_Jg=yudhhe}', "");
    Expect(0, 1822, '\p{^Is_Jg=yudhhe}', "");
    Expect(0, 1822, '\P{Is_Jg=yudhhe}', "");
    Expect(1, 1822, '\P{^Is_Jg=yudhhe}', "");
    Expect(0, 1823, '\p{Is_Jg=yudhhe}', "");
    Expect(1, 1823, '\p{^Is_Jg=yudhhe}', "");
    Expect(1, 1823, '\P{Is_Jg=yudhhe}', "");
    Expect(0, 1823, '\P{^Is_Jg=yudhhe}', "");
    Expect(1, 1822, '\p{Is_Jg=- YUDH_HE}', "");
    Expect(0, 1822, '\p{^Is_Jg=- YUDH_HE}', "");
    Expect(0, 1822, '\P{Is_Jg=- YUDH_HE}', "");
    Expect(1, 1822, '\P{^Is_Jg=- YUDH_HE}', "");
    Expect(0, 1823, '\p{Is_Jg=- YUDH_HE}', "");
    Expect(1, 1823, '\p{^Is_Jg=- YUDH_HE}', "");
    Expect(1, 1823, '\P{Is_Jg=- YUDH_HE}', "");
    Expect(0, 1823, '\P{^Is_Jg=- YUDH_HE}', "");
    Error('\p{Joining_Group=/a/_ZAIN}');
    Error('\P{Joining_Group=/a/_ZAIN}');
    Expect(1, 1817, '\p{Joining_Group=:\AZain\z:}', "");;
    Expect(0, 1818, '\p{Joining_Group=:\AZain\z:}', "");;
    Expect(1, 1817, '\p{Joining_Group=zain}', "");
    Expect(0, 1817, '\p{^Joining_Group=zain}', "");
    Expect(0, 1817, '\P{Joining_Group=zain}', "");
    Expect(1, 1817, '\P{^Joining_Group=zain}', "");
    Expect(0, 1818, '\p{Joining_Group=zain}', "");
    Expect(1, 1818, '\p{^Joining_Group=zain}', "");
    Expect(1, 1818, '\P{Joining_Group=zain}', "");
    Expect(0, 1818, '\P{^Joining_Group=zain}', "");
    Expect(1, 1817, '\p{Joining_Group=:\Azain\z:}', "");;
    Expect(0, 1818, '\p{Joining_Group=:\Azain\z:}', "");;
    Expect(1, 1817, '\p{Joining_Group= 	ZAIN}', "");
    Expect(0, 1817, '\p{^Joining_Group= 	ZAIN}', "");
    Expect(0, 1817, '\P{Joining_Group= 	ZAIN}', "");
    Expect(1, 1817, '\P{^Joining_Group= 	ZAIN}', "");
    Expect(0, 1818, '\p{Joining_Group= 	ZAIN}', "");
    Expect(1, 1818, '\p{^Joining_Group= 	ZAIN}', "");
    Expect(1, 1818, '\P{Joining_Group= 	ZAIN}', "");
    Expect(0, 1818, '\P{^Joining_Group= 	ZAIN}', "");
    Error('\p{Jg:	 	zain:=}');
    Error('\P{Jg:	 	zain:=}');
    Expect(1, 1817, '\p{Jg=:\AZain\z:}', "");;
    Expect(0, 1818, '\p{Jg=:\AZain\z:}', "");;
    Expect(1, 1817, '\p{Jg=zain}', "");
    Expect(0, 1817, '\p{^Jg=zain}', "");
    Expect(0, 1817, '\P{Jg=zain}', "");
    Expect(1, 1817, '\P{^Jg=zain}', "");
    Expect(0, 1818, '\p{Jg=zain}', "");
    Expect(1, 1818, '\p{^Jg=zain}', "");
    Expect(1, 1818, '\P{Jg=zain}', "");
    Expect(0, 1818, '\P{^Jg=zain}', "");
    Expect(1, 1817, '\p{Jg=:\Azain\z:}', "");;
    Expect(0, 1818, '\p{Jg=:\Azain\z:}', "");;
    Expect(1, 1817, '\p{Jg=_	ZAIN}', "");
    Expect(0, 1817, '\p{^Jg=_	ZAIN}', "");
    Expect(0, 1817, '\P{Jg=_	ZAIN}', "");
    Expect(1, 1817, '\P{^Jg=_	ZAIN}', "");
    Expect(0, 1818, '\p{Jg=_	ZAIN}', "");
    Expect(1, 1818, '\p{^Jg=_	ZAIN}', "");
    Expect(1, 1818, '\P{Jg=_	ZAIN}', "");
    Expect(0, 1818, '\P{^Jg=_	ZAIN}', "");
    Error('\p{Is_Joining_Group:	/a/_ Zain}');
    Error('\P{Is_Joining_Group:	/a/_ Zain}');
    Expect(1, 1817, '\p{Is_Joining_Group=zain}', "");
    Expect(0, 1817, '\p{^Is_Joining_Group=zain}', "");
    Expect(0, 1817, '\P{Is_Joining_Group=zain}', "");
    Expect(1, 1817, '\P{^Is_Joining_Group=zain}', "");
    Expect(0, 1818, '\p{Is_Joining_Group=zain}', "");
    Expect(1, 1818, '\p{^Is_Joining_Group=zain}', "");
    Expect(1, 1818, '\P{Is_Joining_Group=zain}', "");
    Expect(0, 1818, '\P{^Is_Joining_Group=zain}', "");
    Expect(1, 1817, '\p{Is_Joining_Group=-_ZAIN}', "");
    Expect(0, 1817, '\p{^Is_Joining_Group=-_ZAIN}', "");
    Expect(0, 1817, '\P{Is_Joining_Group=-_ZAIN}', "");
    Expect(1, 1817, '\P{^Is_Joining_Group=-_ZAIN}', "");
    Expect(0, 1818, '\p{Is_Joining_Group=-_ZAIN}', "");
    Expect(1, 1818, '\p{^Is_Joining_Group=-_ZAIN}', "");
    Expect(1, 1818, '\P{Is_Joining_Group=-_ZAIN}', "");
    Expect(0, 1818, '\P{^Is_Joining_Group=-_ZAIN}', "");
    Error('\p{Is_Jg=/a/ Zain}');
    Error('\P{Is_Jg=/a/ Zain}');
    Expect(1, 1817, '\p{Is_Jg=zain}', "");
    Expect(0, 1817, '\p{^Is_Jg=zain}', "");
    Expect(0, 1817, '\P{Is_Jg=zain}', "");
    Expect(1, 1817, '\P{^Is_Jg=zain}', "");
    Expect(0, 1818, '\p{Is_Jg=zain}', "");
    Expect(1, 1818, '\p{^Is_Jg=zain}', "");
    Expect(1, 1818, '\P{Is_Jg=zain}', "");
    Expect(0, 1818, '\P{^Is_Jg=zain}', "");
    Expect(1, 1817, '\p{Is_Jg=	Zain}', "");
    Expect(0, 1817, '\p{^Is_Jg=	Zain}', "");
    Expect(0, 1817, '\P{Is_Jg=	Zain}', "");
    Expect(1, 1817, '\P{^Is_Jg=	Zain}', "");
    Expect(0, 1818, '\p{Is_Jg=	Zain}', "");
    Expect(1, 1818, '\p{^Is_Jg=	Zain}', "");
    Expect(1, 1818, '\P{Is_Jg=	Zain}', "");
    Expect(0, 1818, '\P{^Is_Jg=	Zain}', "");
    Error('\p{Joining_Group:	_Zhain/a/}');
    Error('\P{Joining_Group:	_Zhain/a/}');
    Expect(1, 1869, '\p{Joining_Group=:\AZhain\z:}', "");;
    Expect(0, 1870, '\p{Joining_Group=:\AZhain\z:}', "");;
    Expect(1, 1869, '\p{Joining_Group=zhain}', "");
    Expect(0, 1869, '\p{^Joining_Group=zhain}', "");
    Expect(0, 1869, '\P{Joining_Group=zhain}', "");
    Expect(1, 1869, '\P{^Joining_Group=zhain}', "");
    Expect(0, 1870, '\p{Joining_Group=zhain}', "");
    Expect(1, 1870, '\p{^Joining_Group=zhain}', "");
    Expect(1, 1870, '\P{Joining_Group=zhain}', "");
    Expect(0, 1870, '\P{^Joining_Group=zhain}', "");
    Expect(1, 1869, '\p{Joining_Group=:\Azhain\z:}', "");;
    Expect(0, 1870, '\p{Joining_Group=:\Azhain\z:}', "");;
    Expect(1, 1869, '\p{Joining_Group: __Zhain}', "");
    Expect(0, 1869, '\p{^Joining_Group: __Zhain}', "");
    Expect(0, 1869, '\P{Joining_Group: __Zhain}', "");
    Expect(1, 1869, '\P{^Joining_Group: __Zhain}', "");
    Expect(0, 1870, '\p{Joining_Group: __Zhain}', "");
    Expect(1, 1870, '\p{^Joining_Group: __Zhain}', "");
    Expect(1, 1870, '\P{Joining_Group: __Zhain}', "");
    Expect(0, 1870, '\P{^Joining_Group: __Zhain}', "");
    Error('\p{Jg=/a/- zhain}');
    Error('\P{Jg=/a/- zhain}');
    Expect(1, 1869, '\p{Jg=:\AZhain\z:}', "");;
    Expect(0, 1870, '\p{Jg=:\AZhain\z:}', "");;
    Expect(1, 1869, '\p{Jg=zhain}', "");
    Expect(0, 1869, '\p{^Jg=zhain}', "");
    Expect(0, 1869, '\P{Jg=zhain}', "");
    Expect(1, 1869, '\P{^Jg=zhain}', "");
    Expect(0, 1870, '\p{Jg=zhain}', "");
    Expect(1, 1870, '\p{^Jg=zhain}', "");
    Expect(1, 1870, '\P{Jg=zhain}', "");
    Expect(0, 1870, '\P{^Jg=zhain}', "");
    Expect(1, 1869, '\p{Jg=:\Azhain\z:}', "");;
    Expect(0, 1870, '\p{Jg=:\Azhain\z:}', "");;
    Expect(1, 1869, '\p{Jg= -zhain}', "");
    Expect(0, 1869, '\p{^Jg= -zhain}', "");
    Expect(0, 1869, '\P{Jg= -zhain}', "");
    Expect(1, 1869, '\P{^Jg= -zhain}', "");
    Expect(0, 1870, '\p{Jg= -zhain}', "");
    Expect(1, 1870, '\p{^Jg= -zhain}', "");
    Expect(1, 1870, '\P{Jg= -zhain}', "");
    Expect(0, 1870, '\P{^Jg= -zhain}', "");
    Error('\p{Is_Joining_Group=-/a/Zhain}');
    Error('\P{Is_Joining_Group=-/a/Zhain}');
    Expect(1, 1869, '\p{Is_Joining_Group=zhain}', "");
    Expect(0, 1869, '\p{^Is_Joining_Group=zhain}', "");
    Expect(0, 1869, '\P{Is_Joining_Group=zhain}', "");
    Expect(1, 1869, '\P{^Is_Joining_Group=zhain}', "");
    Expect(0, 1870, '\p{Is_Joining_Group=zhain}', "");
    Expect(1, 1870, '\p{^Is_Joining_Group=zhain}', "");
    Expect(1, 1870, '\P{Is_Joining_Group=zhain}', "");
    Expect(0, 1870, '\P{^Is_Joining_Group=zhain}', "");
    Expect(1, 1869, '\p{Is_Joining_Group= 	ZHAIN}', "");
    Expect(0, 1869, '\p{^Is_Joining_Group= 	ZHAIN}', "");
    Expect(0, 1869, '\P{Is_Joining_Group= 	ZHAIN}', "");
    Expect(1, 1869, '\P{^Is_Joining_Group= 	ZHAIN}', "");
    Expect(0, 1870, '\p{Is_Joining_Group= 	ZHAIN}', "");
    Expect(1, 1870, '\p{^Is_Joining_Group= 	ZHAIN}', "");
    Expect(1, 1870, '\P{Is_Joining_Group= 	ZHAIN}', "");
    Expect(0, 1870, '\P{^Is_Joining_Group= 	ZHAIN}', "");
    Error('\p{Is_Jg=:=	Zhain}');
    Error('\P{Is_Jg=:=	Zhain}');
    Expect(1, 1869, '\p{Is_Jg=zhain}', "");
    Expect(0, 1869, '\p{^Is_Jg=zhain}', "");
    Expect(0, 1869, '\P{Is_Jg=zhain}', "");
    Expect(1, 1869, '\P{^Is_Jg=zhain}', "");
    Expect(0, 1870, '\p{Is_Jg=zhain}', "");
    Expect(1, 1870, '\p{^Is_Jg=zhain}', "");
    Expect(1, 1870, '\P{Is_Jg=zhain}', "");
    Expect(0, 1870, '\P{^Is_Jg=zhain}', "");
    Expect(1, 1869, '\p{Is_Jg=	-zhain}', "");
    Expect(0, 1869, '\p{^Is_Jg=	-zhain}', "");
    Expect(0, 1869, '\P{Is_Jg=	-zhain}', "");
    Expect(1, 1869, '\P{^Is_Jg=	-zhain}', "");
    Expect(0, 1870, '\p{Is_Jg=	-zhain}', "");
    Expect(1, 1870, '\p{^Is_Jg=	-zhain}', "");
    Expect(1, 1870, '\P{Is_Jg=	-zhain}', "");
    Expect(0, 1870, '\P{^Is_Jg=	-zhain}', "");
    Error('\p{Join_Control=/a/_no}');
    Error('\P{Join_Control=/a/_no}');
    Expect(1, 8206, '\p{Join_Control=:\ANo\z:}', "");;
    Expect(0, 8205, '\p{Join_Control=:\ANo\z:}', "");;
    Expect(1, 8206, '\p{Join_Control=no}', "");
    Expect(0, 8206, '\p{^Join_Control=no}', "");
    Expect(0, 8206, '\P{Join_Control=no}', "");
    Expect(1, 8206, '\P{^Join_Control=no}', "");
    Expect(0, 8205, '\p{Join_Control=no}', "");
    Expect(1, 8205, '\p{^Join_Control=no}', "");
    Expect(1, 8205, '\P{Join_Control=no}', "");
    Expect(0, 8205, '\P{^Join_Control=no}', "");
    Expect(1, 8206, '\p{Join_Control=:\Ano\z:}', "");;
    Expect(0, 8205, '\p{Join_Control=:\Ano\z:}', "");;
    Expect(1, 8206, '\p{Join_Control=		No}', "");
    Expect(0, 8206, '\p{^Join_Control=		No}', "");
    Expect(0, 8206, '\P{Join_Control=		No}', "");
    Expect(1, 8206, '\P{^Join_Control=		No}', "");
    Expect(0, 8205, '\p{Join_Control=		No}', "");
    Expect(1, 8205, '\p{^Join_Control=		No}', "");
    Expect(1, 8205, '\P{Join_Control=		No}', "");
    Expect(0, 8205, '\P{^Join_Control=		No}', "");
    Error('\p{Join_C=:=N}');
    Error('\P{Join_C=:=N}');
    Expect(1, 8206, '\p{Join_C=:\AN\z:}', "");;
    Expect(0, 8205, '\p{Join_C=:\AN\z:}', "");;
    Expect(1, 8206, '\p{Join_C=n}', "");
    Expect(0, 8206, '\p{^Join_C=n}', "");
    Expect(0, 8206, '\P{Join_C=n}', "");
    Expect(1, 8206, '\P{^Join_C=n}', "");
    Expect(0, 8205, '\p{Join_C=n}', "");
    Expect(1, 8205, '\p{^Join_C=n}', "");
    Expect(1, 8205, '\P{Join_C=n}', "");
    Expect(0, 8205, '\P{^Join_C=n}', "");
    Expect(1, 8206, '\p{Join_C=:\An\z:}', "");;
    Expect(0, 8205, '\p{Join_C=:\An\z:}', "");;
    Expect(1, 8206, '\p{Join_C=-_N}', "");
    Expect(0, 8206, '\p{^Join_C=-_N}', "");
    Expect(0, 8206, '\P{Join_C=-_N}', "");
    Expect(1, 8206, '\P{^Join_C=-_N}', "");
    Expect(0, 8205, '\p{Join_C=-_N}', "");
    Expect(1, 8205, '\p{^Join_C=-_N}', "");
    Expect(1, 8205, '\P{Join_C=-_N}', "");
    Expect(0, 8205, '\P{^Join_C=-_N}', "");
    Error('\p{Is_Join_Control=/a/ F}');
    Error('\P{Is_Join_Control=/a/ F}');
    Expect(1, 8206, '\p{Is_Join_Control=f}', "");
    Expect(0, 8206, '\p{^Is_Join_Control=f}', "");
    Expect(0, 8206, '\P{Is_Join_Control=f}', "");
    Expect(1, 8206, '\P{^Is_Join_Control=f}', "");
    Expect(0, 8205, '\p{Is_Join_Control=f}', "");
    Expect(1, 8205, '\p{^Is_Join_Control=f}', "");
    Expect(1, 8205, '\P{Is_Join_Control=f}', "");
    Expect(0, 8205, '\P{^Is_Join_Control=f}', "");
    Expect(1, 8206, '\p{Is_Join_Control=--F}', "");
    Expect(0, 8206, '\p{^Is_Join_Control=--F}', "");
    Expect(0, 8206, '\P{Is_Join_Control=--F}', "");
    Expect(1, 8206, '\P{^Is_Join_Control=--F}', "");
    Expect(0, 8205, '\p{Is_Join_Control=--F}', "");
    Expect(1, 8205, '\p{^Is_Join_Control=--F}', "");
    Expect(1, 8205, '\P{Is_Join_Control=--F}', "");
    Expect(0, 8205, '\P{^Is_Join_Control=--F}', "");
    Error('\p{Is_Join_C=		FALSE:=}');
    Error('\P{Is_Join_C=		FALSE:=}');
    Expect(1, 8206, '\p{Is_Join_C=false}', "");
    Expect(0, 8206, '\p{^Is_Join_C=false}', "");
    Expect(0, 8206, '\P{Is_Join_C=false}', "");
    Expect(1, 8206, '\P{^Is_Join_C=false}', "");
    Expect(0, 8205, '\p{Is_Join_C=false}', "");
    Expect(1, 8205, '\p{^Is_Join_C=false}', "");
    Expect(1, 8205, '\P{Is_Join_C=false}', "");
    Expect(0, 8205, '\P{^Is_Join_C=false}', "");
    Expect(1, 8206, '\p{Is_Join_C=_False}', "");
    Expect(0, 8206, '\p{^Is_Join_C=_False}', "");
    Expect(0, 8206, '\P{Is_Join_C=_False}', "");
    Expect(1, 8206, '\P{^Is_Join_C=_False}', "");
    Expect(0, 8205, '\p{Is_Join_C=_False}', "");
    Expect(1, 8205, '\p{^Is_Join_C=_False}', "");
    Expect(1, 8205, '\P{Is_Join_C=_False}', "");
    Expect(0, 8205, '\P{^Is_Join_C=_False}', "");
    Error('\p{Join_Control=:=-Yes}');
    Error('\P{Join_Control=:=-Yes}');
    Expect(1, 8205, '\p{Join_Control=:\AYes\z:}', "");;
    Expect(0, 8206, '\p{Join_Control=:\AYes\z:}', "");;
    Expect(1, 8205, '\p{Join_Control=yes}', "");
    Expect(0, 8205, '\p{^Join_Control=yes}', "");
    Expect(0, 8205, '\P{Join_Control=yes}', "");
    Expect(1, 8205, '\P{^Join_Control=yes}', "");
    Expect(0, 8206, '\p{Join_Control=yes}', "");
    Expect(1, 8206, '\p{^Join_Control=yes}', "");
    Expect(1, 8206, '\P{Join_Control=yes}', "");
    Expect(0, 8206, '\P{^Join_Control=yes}', "");
    Expect(1, 8205, '\p{Join_Control=:\Ayes\z:}', "");;
    Expect(0, 8206, '\p{Join_Control=:\Ayes\z:}', "");;
    Expect(1, 8205, '\p{Join_Control= yes}', "");
    Expect(0, 8205, '\p{^Join_Control= yes}', "");
    Expect(0, 8205, '\P{Join_Control= yes}', "");
    Expect(1, 8205, '\P{^Join_Control= yes}', "");
    Expect(0, 8206, '\p{Join_Control= yes}', "");
    Expect(1, 8206, '\p{^Join_Control= yes}', "");
    Expect(1, 8206, '\P{Join_Control= yes}', "");
    Expect(0, 8206, '\P{^Join_Control= yes}', "");
    Error('\p{Join_C=/a/Y}');
    Error('\P{Join_C=/a/Y}');
    Expect(1, 8205, '\p{Join_C=:\AY\z:}', "");;
    Expect(0, 8206, '\p{Join_C=:\AY\z:}', "");;
    Expect(1, 8205, '\p{Join_C=y}', "");
    Expect(0, 8205, '\p{^Join_C=y}', "");
    Expect(0, 8205, '\P{Join_C=y}', "");
    Expect(1, 8205, '\P{^Join_C=y}', "");
    Expect(0, 8206, '\p{Join_C=y}', "");
    Expect(1, 8206, '\p{^Join_C=y}', "");
    Expect(1, 8206, '\P{Join_C=y}', "");
    Expect(0, 8206, '\P{^Join_C=y}', "");
    Expect(1, 8205, '\p{Join_C=:\Ay\z:}', "");;
    Expect(0, 8206, '\p{Join_C=:\Ay\z:}', "");;
    Expect(1, 8205, '\p{Join_C= Y}', "");
    Expect(0, 8205, '\p{^Join_C= Y}', "");
    Expect(0, 8205, '\P{Join_C= Y}', "");
    Expect(1, 8205, '\P{^Join_C= Y}', "");
    Expect(0, 8206, '\p{Join_C= Y}', "");
    Expect(1, 8206, '\p{^Join_C= Y}', "");
    Expect(1, 8206, '\P{Join_C= Y}', "");
    Expect(0, 8206, '\P{^Join_C= Y}', "");
    Error('\p{Is_Join_Control=-:=t}');
    Error('\P{Is_Join_Control=-:=t}');
    Expect(1, 8205, '\p{Is_Join_Control:   t}', "");
    Expect(0, 8205, '\p{^Is_Join_Control:   t}', "");
    Expect(0, 8205, '\P{Is_Join_Control:   t}', "");
    Expect(1, 8205, '\P{^Is_Join_Control:   t}', "");
    Expect(0, 8206, '\p{Is_Join_Control:   t}', "");
    Expect(1, 8206, '\p{^Is_Join_Control:   t}', "");
    Expect(1, 8206, '\P{Is_Join_Control:   t}', "");
    Expect(0, 8206, '\P{^Is_Join_Control:   t}', "");
    Expect(1, 8205, '\p{Is_Join_Control=_-T}', "");
    Expect(0, 8205, '\p{^Is_Join_Control=_-T}', "");
    Expect(0, 8205, '\P{Is_Join_Control=_-T}', "");
    Expect(1, 8205, '\P{^Is_Join_Control=_-T}', "");
    Expect(0, 8206, '\p{Is_Join_Control=_-T}', "");
    Expect(1, 8206, '\p{^Is_Join_Control=_-T}', "");
    Expect(1, 8206, '\P{Is_Join_Control=_-T}', "");
    Expect(0, 8206, '\P{^Is_Join_Control=_-T}', "");
    Error('\p{Is_Join_C=:=True}');
    Error('\P{Is_Join_C=:=True}');
    Expect(1, 8205, '\p{Is_Join_C=true}', "");
    Expect(0, 8205, '\p{^Is_Join_C=true}', "");
    Expect(0, 8205, '\P{Is_Join_C=true}', "");
    Expect(1, 8205, '\P{^Is_Join_C=true}', "");
    Expect(0, 8206, '\p{Is_Join_C=true}', "");
    Expect(1, 8206, '\p{^Is_Join_C=true}', "");
    Expect(1, 8206, '\P{Is_Join_C=true}', "");
    Expect(0, 8206, '\P{^Is_Join_C=true}', "");
    Expect(1, 8205, '\p{Is_Join_C=_True}', "");
    Expect(0, 8205, '\p{^Is_Join_C=_True}', "");
    Expect(0, 8205, '\P{Is_Join_C=_True}', "");
    Expect(1, 8205, '\P{^Is_Join_C=_True}', "");
    Expect(0, 8206, '\p{Is_Join_C=_True}', "");
    Expect(1, 8206, '\p{^Is_Join_C=_True}', "");
    Expect(1, 8206, '\P{Is_Join_C=_True}', "");
    Expect(0, 8206, '\P{^Is_Join_C=_True}', "");
    Error('\p{jamoshortname}');
    Error('\P{jamoshortname}');
    Error('\p{jsn}');
    Error('\P{jsn}');
    Error('\p{Jamo_Short_Name=A}');
    Error('\P{Jamo_Short_Name=A}');
    Error('\p{JSN=A}');
    Error('\P{JSN=A}');
    Error('\p{Is_Jamo_Short_Name=A}');
    Error('\P{Is_Jamo_Short_Name=A}');
    Error('\p{Is_JSN=A}');
    Error('\P{Is_JSN=A}');
    Error('\p{Jamo_Short_Name=AE}');
    Error('\P{Jamo_Short_Name=AE}');
    Error('\p{JSN=AE}');
    Error('\P{JSN=AE}');
    Error('\p{Is_Jamo_Short_Name: AE}');
    Error('\P{Is_Jamo_Short_Name: AE}');
    Error('\p{Is_JSN=AE}');
    Error('\P{Is_JSN=AE}');
    Error('\p{Jamo_Short_Name=B}');
    Error('\P{Jamo_Short_Name=B}');
    Error('\p{JSN: B}');
    Error('\P{JSN: B}');
    Error('\p{Is_Jamo_Short_Name:B}');
    Error('\P{Is_Jamo_Short_Name:B}');
    Error('\p{Is_JSN=B}');
    Error('\P{Is_JSN=B}');
    Error('\p{Jamo_Short_Name=BB}');
    Error('\P{Jamo_Short_Name=BB}');
    Error('\p{JSN=BB}');
    Error('\P{JSN=BB}');
    Error('\p{Is_Jamo_Short_Name=BB}');
    Error('\P{Is_Jamo_Short_Name=BB}');
    Error('\p{Is_JSN=BB}');
    Error('\P{Is_JSN=BB}');
    Error('\p{Jamo_Short_Name=BS}');
    Error('\P{Jamo_Short_Name=BS}');
    Error('\p{JSN=BS}');
    Error('\P{JSN=BS}');
    Error('\p{Is_Jamo_Short_Name=BS}');
    Error('\P{Is_Jamo_Short_Name=BS}');
    Error('\p{Is_JSN=BS}');
    Error('\P{Is_JSN=BS}');
    Error('\p{Jamo_Short_Name=C}');
    Error('\P{Jamo_Short_Name=C}');
    Error('\p{JSN=C}');
    Error('\P{JSN=C}');
    Error('\p{Is_Jamo_Short_Name=C}');
    Error('\P{Is_Jamo_Short_Name=C}');
    Error('\p{Is_JSN=C}');
    Error('\P{Is_JSN=C}');
    Error('\p{Jamo_Short_Name=D}');
    Error('\P{Jamo_Short_Name=D}');
    Error('\p{JSN=D}');
    Error('\P{JSN=D}');
    Error('\p{Is_Jamo_Short_Name=D}');
    Error('\P{Is_Jamo_Short_Name=D}');
    Error('\p{Is_JSN=D}');
    Error('\P{Is_JSN=D}');
    Error('\p{Jamo_Short_Name=DD}');
    Error('\P{Jamo_Short_Name=DD}');
    Error('\p{JSN=DD}');
    Error('\P{JSN=DD}');
    Error('\p{Is_Jamo_Short_Name=DD}');
    Error('\P{Is_Jamo_Short_Name=DD}');
    Error('\p{Is_JSN=DD}');
    Error('\P{Is_JSN=DD}');
    Error('\p{Jamo_Short_Name=E}');
    Error('\P{Jamo_Short_Name=E}');
    Error('\p{JSN: E}');
    Error('\P{JSN: E}');
    Error('\p{Is_Jamo_Short_Name=E}');
    Error('\P{Is_Jamo_Short_Name=E}');
    Error('\p{Is_JSN=E}');
    Error('\P{Is_JSN=E}');
    Error('\p{Jamo_Short_Name=EO}');
    Error('\P{Jamo_Short_Name=EO}');
    Error('\p{JSN=EO}');
    Error('\P{JSN=EO}');
    Error('\p{Is_Jamo_Short_Name=EO}');
    Error('\P{Is_Jamo_Short_Name=EO}');
    Error('\p{Is_JSN=EO}');
    Error('\P{Is_JSN=EO}');
    Error('\p{Jamo_Short_Name=EU}');
    Error('\P{Jamo_Short_Name=EU}');
    Error('\p{JSN=EU}');
    Error('\P{JSN=EU}');
    Error('\p{Is_Jamo_Short_Name=EU}');
    Error('\P{Is_Jamo_Short_Name=EU}');
    Error('\p{Is_JSN=EU}');
    Error('\P{Is_JSN=EU}');
    Error('\p{Jamo_Short_Name=G}');
    Error('\P{Jamo_Short_Name=G}');
    Error('\p{JSN=G}');
    Error('\P{JSN=G}');
    Error('\p{Is_Jamo_Short_Name=G}');
    Error('\P{Is_Jamo_Short_Name=G}');
    Error('\p{Is_JSN=G}');
    Error('\P{Is_JSN=G}');
    Error('\p{Jamo_Short_Name=GG}');
    Error('\P{Jamo_Short_Name=GG}');
    Error('\p{JSN=GG}');
    Error('\P{JSN=GG}');
    Error('\p{Is_Jamo_Short_Name: GG}');
    Error('\P{Is_Jamo_Short_Name: GG}');
    Error('\p{Is_JSN:	GG}');
    Error('\P{Is_JSN:	GG}');
    Error('\p{Jamo_Short_Name=GS}');
    Error('\P{Jamo_Short_Name=GS}');
    Error('\p{JSN=GS}');
    Error('\P{JSN=GS}');
    Error('\p{Is_Jamo_Short_Name:   GS}');
    Error('\P{Is_Jamo_Short_Name:   GS}');
    Error('\p{Is_JSN=GS}');
    Error('\P{Is_JSN=GS}');
    Error('\p{Jamo_Short_Name=H}');
    Error('\P{Jamo_Short_Name=H}');
    Error('\p{JSN=H}');
    Error('\P{JSN=H}');
    Error('\p{Is_Jamo_Short_Name=H}');
    Error('\P{Is_Jamo_Short_Name=H}');
    Error('\p{Is_JSN=H}');
    Error('\P{Is_JSN=H}');
    Error('\p{Jamo_Short_Name=I}');
    Error('\P{Jamo_Short_Name=I}');
    Error('\p{JSN=I}');
    Error('\P{JSN=I}');
    Error('\p{Is_Jamo_Short_Name=I}');
    Error('\P{Is_Jamo_Short_Name=I}');
    Error('\p{Is_JSN=I}');
    Error('\P{Is_JSN=I}');
    Error('\p{Jamo_Short_Name=J}');
    Error('\P{Jamo_Short_Name=J}');
    Error('\p{JSN=J}');
    Error('\P{JSN=J}');
    Error('\p{Is_Jamo_Short_Name=J}');
    Error('\P{Is_Jamo_Short_Name=J}');
    Error('\p{Is_JSN=J}');
    Error('\P{Is_JSN=J}');
    Error('\p{Jamo_Short_Name=JJ}');
    Error('\P{Jamo_Short_Name=JJ}');
    Error('\p{JSN=JJ}');
    Error('\P{JSN=JJ}');
    Error('\p{Is_Jamo_Short_Name=JJ}');
    Error('\P{Is_Jamo_Short_Name=JJ}');
    Error('\p{Is_JSN=JJ}');
    Error('\P{Is_JSN=JJ}');
    Error('\p{Jamo_Short_Name=K}');
    Error('\P{Jamo_Short_Name=K}');
    Error('\p{JSN:K}');
    Error('\P{JSN:K}');
    Error('\p{Is_Jamo_Short_Name=K}');
    Error('\P{Is_Jamo_Short_Name=K}');
    Error('\p{Is_JSN=K}');
    Error('\P{Is_JSN=K}');
    Error('\p{Jamo_Short_Name=L}');
    Error('\P{Jamo_Short_Name=L}');
    Error('\p{JSN=L}');
    Error('\P{JSN=L}');
    Error('\p{Is_Jamo_Short_Name=L}');
    Error('\P{Is_Jamo_Short_Name=L}');
    Error('\p{Is_JSN=L}');
    Error('\P{Is_JSN=L}');
    Error('\p{Jamo_Short_Name=LB}');
    Error('\P{Jamo_Short_Name=LB}');
    Error('\p{JSN=LB}');
    Error('\P{JSN=LB}');
    Error('\p{Is_Jamo_Short_Name=LB}');
    Error('\P{Is_Jamo_Short_Name=LB}');
    Error('\p{Is_JSN:LB}');
    Error('\P{Is_JSN:LB}');
    Error('\p{Jamo_Short_Name=LG}');
    Error('\P{Jamo_Short_Name=LG}');
    Error('\p{JSN=LG}');
    Error('\P{JSN=LG}');
    Error('\p{Is_Jamo_Short_Name=LG}');
    Error('\P{Is_Jamo_Short_Name=LG}');
    Error('\p{Is_JSN=LG}');
    Error('\P{Is_JSN=LG}');
    Error('\p{Jamo_Short_Name=LH}');
    Error('\P{Jamo_Short_Name=LH}');
    Error('\p{JSN=LH}');
    Error('\P{JSN=LH}');
    Error('\p{Is_Jamo_Short_Name=LH}');
    Error('\P{Is_Jamo_Short_Name=LH}');
    Error('\p{Is_JSN=LH}');
    Error('\P{Is_JSN=LH}');
    Error('\p{Jamo_Short_Name:   LM}');
    Error('\P{Jamo_Short_Name:   LM}');
    Error('\p{JSN=LM}');
    Error('\P{JSN=LM}');
    Error('\p{Is_Jamo_Short_Name=LM}');
    Error('\P{Is_Jamo_Short_Name=LM}');
    Error('\p{Is_JSN=LM}');
    Error('\P{Is_JSN=LM}');
    Error('\p{Jamo_Short_Name=LP}');
    Error('\P{Jamo_Short_Name=LP}');
    Error('\p{JSN=LP}');
    Error('\P{JSN=LP}');
    Error('\p{Is_Jamo_Short_Name=LP}');
    Error('\P{Is_Jamo_Short_Name=LP}');
    Error('\p{Is_JSN=LP}');
    Error('\P{Is_JSN=LP}');
    Error('\p{Jamo_Short_Name=LS}');
    Error('\P{Jamo_Short_Name=LS}');
    Error('\p{JSN=LS}');
    Error('\P{JSN=LS}');
    Error('\p{Is_Jamo_Short_Name=LS}');
    Error('\P{Is_Jamo_Short_Name=LS}');
    Error('\p{Is_JSN=LS}');
    Error('\P{Is_JSN=LS}');
    Error('\p{Jamo_Short_Name=LT}');
    Error('\P{Jamo_Short_Name=LT}');
    Error('\p{JSN=LT}');
    Error('\P{JSN=LT}');
    Error('\p{Is_Jamo_Short_Name=LT}');
    Error('\P{Is_Jamo_Short_Name=LT}');
    Error('\p{Is_JSN=LT}');
    Error('\P{Is_JSN=LT}');
    Error('\p{Jamo_Short_Name=M}');
    Error('\P{Jamo_Short_Name=M}');
    Error('\p{JSN=M}');
    Error('\P{JSN=M}');
    Error('\p{Is_Jamo_Short_Name:	M}');
    Error('\P{Is_Jamo_Short_Name:	M}');
    Error('\p{Is_JSN=M}');
    Error('\P{Is_JSN=M}');
    Error('\p{Jamo_Short_Name=N}');
    Error('\P{Jamo_Short_Name=N}');
    Error('\p{JSN=N}');
    Error('\P{JSN=N}');
    Error('\p{Is_Jamo_Short_Name=N}');
    Error('\P{Is_Jamo_Short_Name=N}');
    Error('\p{Is_JSN=N}');
    Error('\P{Is_JSN=N}');
    Error('\p{Jamo_Short_Name:   NG}');
    Error('\P{Jamo_Short_Name:   NG}');
    Error('\p{JSN=NG}');
    Error('\P{JSN=NG}');
    Error('\p{Is_Jamo_Short_Name=NG}');
    Error('\P{Is_Jamo_Short_Name=NG}');
    Error('\p{Is_JSN=NG}');
    Error('\P{Is_JSN=NG}');
    Error('\p{Jamo_Short_Name=NH}');
    Error('\P{Jamo_Short_Name=NH}');
    Error('\p{JSN=NH}');
    Error('\P{JSN=NH}');
    Error('\p{Is_Jamo_Short_Name=NH}');
    Error('\P{Is_Jamo_Short_Name=NH}');
    Error('\p{Is_JSN=NH}');
    Error('\P{Is_JSN=NH}');
    Error('\p{Jamo_Short_Name=NJ}');
    Error('\P{Jamo_Short_Name=NJ}');
    Error('\p{JSN=NJ}');
    Error('\P{JSN=NJ}');
    Error('\p{Is_Jamo_Short_Name=NJ}');
    Error('\P{Is_Jamo_Short_Name=NJ}');
    Error('\p{Is_JSN=NJ}');
    Error('\P{Is_JSN=NJ}');
    Error('\p{Jamo_Short_Name=O}');
    Error('\P{Jamo_Short_Name=O}');
    Error('\p{JSN=O}');
    Error('\P{JSN=O}');
    Error('\p{Is_Jamo_Short_Name=O}');
    Error('\P{Is_Jamo_Short_Name=O}');
    Error('\p{Is_JSN=O}');
    Error('\P{Is_JSN=O}');
    Error('\p{Jamo_Short_Name=OE}');
    Error('\P{Jamo_Short_Name=OE}');
    Error('\p{JSN=OE}');
    Error('\P{JSN=OE}');
    Error('\p{Is_Jamo_Short_Name=OE}');
    Error('\P{Is_Jamo_Short_Name=OE}');
    Error('\p{Is_JSN=OE}');
    Error('\P{Is_JSN=OE}');
    Error('\p{Jamo_Short_Name: P}');
    Error('\P{Jamo_Short_Name: P}');
    Error('\p{JSN=P}');
    Error('\P{JSN=P}');
    Error('\p{Is_Jamo_Short_Name=P}');
    Error('\P{Is_Jamo_Short_Name=P}');
    Error('\p{Is_JSN=P}');
    Error('\P{Is_JSN=P}');
    Error('\p{Jamo_Short_Name=R}');
    Error('\P{Jamo_Short_Name=R}');
    Error('\p{JSN=R}');
    Error('\P{JSN=R}');
    Error('\p{Is_Jamo_Short_Name=R}');
    Error('\P{Is_Jamo_Short_Name=R}');
    Error('\p{Is_JSN=R}');
    Error('\P{Is_JSN=R}');
    Error('\p{Jamo_Short_Name:S}');
    Error('\P{Jamo_Short_Name:S}');
    Error('\p{JSN=S}');
    Error('\P{JSN=S}');
    Error('\p{Is_Jamo_Short_Name: S}');
    Error('\P{Is_Jamo_Short_Name: S}');
    Error('\p{Is_JSN=S}');
    Error('\P{Is_JSN=S}');
    Error('\p{Jamo_Short_Name=SS}');
    Error('\P{Jamo_Short_Name=SS}');
    Error('\p{JSN=SS}');
    Error('\P{JSN=SS}');
    Error('\p{Is_Jamo_Short_Name=SS}');
    Error('\P{Is_Jamo_Short_Name=SS}');
    Error('\p{Is_JSN=SS}');
    Error('\P{Is_JSN=SS}');
    Error('\p{Jamo_Short_Name=T}');
    Error('\P{Jamo_Short_Name=T}');
    Error('\p{JSN=T}');
    Error('\P{JSN=T}');
    Error('\p{Is_Jamo_Short_Name=T}');
    Error('\P{Is_Jamo_Short_Name=T}');
    Error('\p{Is_JSN=T}');
    Error('\P{Is_JSN=T}');
    Error('\p{Jamo_Short_Name=U}');
    Error('\P{Jamo_Short_Name=U}');
    Error('\p{JSN=U}');
    Error('\P{JSN=U}');
    Error('\p{Is_Jamo_Short_Name=U}');
    Error('\P{Is_Jamo_Short_Name=U}');
    Error('\p{Is_JSN=U}');
    Error('\P{Is_JSN=U}');
    Error('\p{Jamo_Short_Name:   WA}');
    Error('\P{Jamo_Short_Name:   WA}');
    Error('\p{JSN=WA}');
    Error('\P{JSN=WA}');
    Error('\p{Is_Jamo_Short_Name=WA}');
    Error('\P{Is_Jamo_Short_Name=WA}');
    Error('\p{Is_JSN=WA}');
    Error('\P{Is_JSN=WA}');
    Error('\p{Jamo_Short_Name=WAE}');
    Error('\P{Jamo_Short_Name=WAE}');
    Error('\p{JSN=WAE}');
    Error('\P{JSN=WAE}');
    Error('\p{Is_Jamo_Short_Name=WAE}');
    Error('\P{Is_Jamo_Short_Name=WAE}');
    Error('\p{Is_JSN: WAE}');
    Error('\P{Is_JSN: WAE}');
    Error('\p{Jamo_Short_Name: WE}');
    Error('\P{Jamo_Short_Name: WE}');
    Error('\p{JSN=WE}');
    Error('\P{JSN=WE}');
    Error('\p{Is_Jamo_Short_Name=WE}');
    Error('\P{Is_Jamo_Short_Name=WE}');
    Error('\p{Is_JSN=WE}');
    Error('\P{Is_JSN=WE}');
    Error('\p{Jamo_Short_Name: WEO}');
    Error('\P{Jamo_Short_Name: WEO}');
    Error('\p{JSN=WEO}');
    Error('\P{JSN=WEO}');
    Error('\p{Is_Jamo_Short_Name=WEO}');
    Error('\P{Is_Jamo_Short_Name=WEO}');
    Error('\p{Is_JSN=WEO}');
    Error('\P{Is_JSN=WEO}');
    Error('\p{Jamo_Short_Name=WI}');
    Error('\P{Jamo_Short_Name=WI}');
    Error('\p{JSN: WI}');
    Error('\P{JSN: WI}');
    Error('\p{Is_Jamo_Short_Name=WI}');
    Error('\P{Is_Jamo_Short_Name=WI}');
    Error('\p{Is_JSN=WI}');
    Error('\P{Is_JSN=WI}');
    Error('\p{Jamo_Short_Name: YA}');
    Error('\P{Jamo_Short_Name: YA}');
    Error('\p{JSN=YA}');
    Error('\P{JSN=YA}');
    Error('\p{Is_Jamo_Short_Name=YA}');
    Error('\P{Is_Jamo_Short_Name=YA}');
    Error('\p{Is_JSN=YA}');
    Error('\P{Is_JSN=YA}');
    Error('\p{Jamo_Short_Name=YAE}');
    Error('\P{Jamo_Short_Name=YAE}');
    Error('\p{JSN=YAE}');
    Error('\P{JSN=YAE}');
    Error('\p{Is_Jamo_Short_Name=YAE}');
    Error('\P{Is_Jamo_Short_Name=YAE}');
    Error('\p{Is_JSN=YAE}');
    Error('\P{Is_JSN=YAE}');
    Error('\p{Jamo_Short_Name=YE}');
    Error('\P{Jamo_Short_Name=YE}');
    Error('\p{JSN=YE}');
    Error('\P{JSN=YE}');
    Error('\p{Is_Jamo_Short_Name=YE}');
    Error('\P{Is_Jamo_Short_Name=YE}');
    Error('\p{Is_JSN=YE}');
    Error('\P{Is_JSN=YE}');
    Error('\p{Jamo_Short_Name=YEO}');
    Error('\P{Jamo_Short_Name=YEO}');
    Error('\p{JSN=YEO}');
    Error('\P{JSN=YEO}');
    Error('\p{Is_Jamo_Short_Name=YEO}');
    Error('\P{Is_Jamo_Short_Name=YEO}');
    Error('\p{Is_JSN=YEO}');
    Error('\P{Is_JSN=YEO}');
    Error('\p{Jamo_Short_Name=YI}');
    Error('\P{Jamo_Short_Name=YI}');
    Error('\p{JSN=YI}');
    Error('\P{JSN=YI}');
    Error('\p{Is_Jamo_Short_Name:	YI}');
    Error('\P{Is_Jamo_Short_Name:	YI}');
    Error('\p{Is_JSN=YI}');
    Error('\P{Is_JSN=YI}');
    Error('\p{Jamo_Short_Name=YO}');
    Error('\P{Jamo_Short_Name=YO}');
    Error('\p{JSN=YO}');
    Error('\P{JSN=YO}');
    Error('\p{Is_Jamo_Short_Name=YO}');
    Error('\P{Is_Jamo_Short_Name=YO}');
    Error('\p{Is_JSN=YO}');
    Error('\P{Is_JSN=YO}');
    Error('\p{Jamo_Short_Name=YU}');
    Error('\P{Jamo_Short_Name=YU}');
    Error('\p{JSN: YU}');
    Error('\P{JSN: YU}');
    Error('\p{Is_Jamo_Short_Name=YU}');
    Error('\P{Is_Jamo_Short_Name=YU}');
    Error('\p{Is_JSN=YU}');
    Error('\P{Is_JSN=YU}');
    Error('\p{joiningtype}');
    Error('\P{joiningtype}');
    Error('\p{jt}');
    Error('\P{jt}');
    Error('\p{Joining_Type=_/a/Join_CAUSING}');
    Error('\P{Joining_Type=_/a/Join_CAUSING}');
    Expect(1, 8205, '\p{Joining_Type=:\AJoin_Causing\z:}', "");;
    Expect(0, 8206, '\p{Joining_Type=:\AJoin_Causing\z:}', "");;
    Expect(1, 8205, '\p{Joining_Type=joincausing}', "");
    Expect(0, 8205, '\p{^Joining_Type=joincausing}', "");
    Expect(0, 8205, '\P{Joining_Type=joincausing}', "");
    Expect(1, 8205, '\P{^Joining_Type=joincausing}', "");
    Expect(0, 8206, '\p{Joining_Type=joincausing}', "");
    Expect(1, 8206, '\p{^Joining_Type=joincausing}', "");
    Expect(1, 8206, '\P{Joining_Type=joincausing}', "");
    Expect(0, 8206, '\P{^Joining_Type=joincausing}', "");
    Expect(1, 8205, '\p{Joining_Type=:\Ajoincausing\z:}', "");;
    Expect(0, 8206, '\p{Joining_Type=:\Ajoincausing\z:}', "");;
    Expect(1, 8205, '\p{Joining_Type=	-JOIN_causing}', "");
    Expect(0, 8205, '\p{^Joining_Type=	-JOIN_causing}', "");
    Expect(0, 8205, '\P{Joining_Type=	-JOIN_causing}', "");
    Expect(1, 8205, '\P{^Joining_Type=	-JOIN_causing}', "");
    Expect(0, 8206, '\p{Joining_Type=	-JOIN_causing}', "");
    Expect(1, 8206, '\p{^Joining_Type=	-JOIN_causing}', "");
    Expect(1, 8206, '\P{Joining_Type=	-JOIN_causing}', "");
    Expect(0, 8206, '\P{^Joining_Type=	-JOIN_causing}', "");
    Error('\p{Jt=/a/		C}');
    Error('\P{Jt=/a/		C}');
    Expect(1, 8205, '\p{Jt=:\AC\z:}', "");;
    Expect(0, 8206, '\p{Jt=:\AC\z:}', "");;
    Expect(1, 8205, '\p{Jt=c}', "");
    Expect(0, 8205, '\p{^Jt=c}', "");
    Expect(0, 8205, '\P{Jt=c}', "");
    Expect(1, 8205, '\P{^Jt=c}', "");
    Expect(0, 8206, '\p{Jt=c}', "");
    Expect(1, 8206, '\p{^Jt=c}', "");
    Expect(1, 8206, '\P{Jt=c}', "");
    Expect(0, 8206, '\P{^Jt=c}', "");
    Expect(1, 8205, '\p{Jt=:\Ac\z:}', "");;
    Expect(0, 8206, '\p{Jt=:\Ac\z:}', "");;
    Expect(1, 8205, '\p{Jt= C}', "");
    Expect(0, 8205, '\p{^Jt= C}', "");
    Expect(0, 8205, '\P{Jt= C}', "");
    Expect(1, 8205, '\P{^Jt= C}', "");
    Expect(0, 8206, '\p{Jt= C}', "");
    Expect(1, 8206, '\p{^Jt= C}', "");
    Expect(1, 8206, '\P{Jt= C}', "");
    Expect(0, 8206, '\P{^Jt= C}', "");
    Error('\p{Is_Joining_Type=/a/Join_Causing}');
    Error('\P{Is_Joining_Type=/a/Join_Causing}');
    Expect(1, 8205, '\p{Is_Joining_Type=joincausing}', "");
    Expect(0, 8205, '\p{^Is_Joining_Type=joincausing}', "");
    Expect(0, 8205, '\P{Is_Joining_Type=joincausing}', "");
    Expect(1, 8205, '\P{^Is_Joining_Type=joincausing}', "");
    Expect(0, 8206, '\p{Is_Joining_Type=joincausing}', "");
    Expect(1, 8206, '\p{^Is_Joining_Type=joincausing}', "");
    Expect(1, 8206, '\P{Is_Joining_Type=joincausing}', "");
    Expect(0, 8206, '\P{^Is_Joining_Type=joincausing}', "");
    Expect(1, 8205, '\p{Is_Joining_Type=-	Join_Causing}', "");
    Expect(0, 8205, '\p{^Is_Joining_Type=-	Join_Causing}', "");
    Expect(0, 8205, '\P{Is_Joining_Type=-	Join_Causing}', "");
    Expect(1, 8205, '\P{^Is_Joining_Type=-	Join_Causing}', "");
    Expect(0, 8206, '\p{Is_Joining_Type=-	Join_Causing}', "");
    Expect(1, 8206, '\p{^Is_Joining_Type=-	Join_Causing}', "");
    Expect(1, 8206, '\P{Is_Joining_Type=-	Join_Causing}', "");
    Expect(0, 8206, '\P{^Is_Joining_Type=-	Join_Causing}', "");
    Error('\p{Is_Jt=		C/a/}');
    Error('\P{Is_Jt=		C/a/}');
    Expect(1, 8205, '\p{Is_Jt=c}', "");
    Expect(0, 8205, '\p{^Is_Jt=c}', "");
    Expect(0, 8205, '\P{Is_Jt=c}', "");
    Expect(1, 8205, '\P{^Is_Jt=c}', "");
    Expect(0, 8206, '\p{Is_Jt=c}', "");
    Expect(1, 8206, '\p{^Is_Jt=c}', "");
    Expect(1, 8206, '\P{Is_Jt=c}', "");
    Expect(0, 8206, '\P{^Is_Jt=c}', "");
    Expect(1, 8205, '\p{Is_Jt=  C}', "");
    Expect(0, 8205, '\p{^Is_Jt=  C}', "");
    Expect(0, 8205, '\P{Is_Jt=  C}', "");
    Expect(1, 8205, '\P{^Is_Jt=  C}', "");
    Expect(0, 8206, '\p{Is_Jt=  C}', "");
    Expect(1, 8206, '\p{^Is_Jt=  C}', "");
    Expect(1, 8206, '\P{Is_Jt=  C}', "");
    Expect(0, 8206, '\P{^Is_Jt=  C}', "");
    Error('\p{Joining_Type=_/a/dual_Joining}');
    Error('\P{Joining_Type=_/a/dual_Joining}');
    Expect(1, 125251, '\p{Joining_Type=:\ADual_Joining\z:}', "");;
    Expect(0, 125252, '\p{Joining_Type=:\ADual_Joining\z:}', "");;
    Expect(1, 125251, '\p{Joining_Type=dualjoining}', "");
    Expect(0, 125251, '\p{^Joining_Type=dualjoining}', "");
    Expect(0, 125251, '\P{Joining_Type=dualjoining}', "");
    Expect(1, 125251, '\P{^Joining_Type=dualjoining}', "");
    Expect(0, 125252, '\p{Joining_Type=dualjoining}', "");
    Expect(1, 125252, '\p{^Joining_Type=dualjoining}', "");
    Expect(1, 125252, '\P{Joining_Type=dualjoining}', "");
    Expect(0, 125252, '\P{^Joining_Type=dualjoining}', "");
    Expect(1, 125251, '\p{Joining_Type=:\Adualjoining\z:}', "");;
    Expect(0, 125252, '\p{Joining_Type=:\Adualjoining\z:}', "");;
    Expect(1, 125251, '\p{Joining_Type=- DUAL_joining}', "");
    Expect(0, 125251, '\p{^Joining_Type=- DUAL_joining}', "");
    Expect(0, 125251, '\P{Joining_Type=- DUAL_joining}', "");
    Expect(1, 125251, '\P{^Joining_Type=- DUAL_joining}', "");
    Expect(0, 125252, '\p{Joining_Type=- DUAL_joining}', "");
    Expect(1, 125252, '\p{^Joining_Type=- DUAL_joining}', "");
    Expect(1, 125252, '\P{Joining_Type=- DUAL_joining}', "");
    Expect(0, 125252, '\P{^Joining_Type=- DUAL_joining}', "");
    Error('\p{Jt=-/a/D}');
    Error('\P{Jt=-/a/D}');
    Expect(1, 125251, '\p{Jt=:\AD\z:}', "");;
    Expect(0, 125252, '\p{Jt=:\AD\z:}', "");;
    Expect(1, 125251, '\p{Jt=d}', "");
    Expect(0, 125251, '\p{^Jt=d}', "");
    Expect(0, 125251, '\P{Jt=d}', "");
    Expect(1, 125251, '\P{^Jt=d}', "");
    Expect(0, 125252, '\p{Jt=d}', "");
    Expect(1, 125252, '\p{^Jt=d}', "");
    Expect(1, 125252, '\P{Jt=d}', "");
    Expect(0, 125252, '\P{^Jt=d}', "");
    Expect(1, 125251, '\p{Jt=:\Ad\z:}', "");;
    Expect(0, 125252, '\p{Jt=:\Ad\z:}', "");;
    Expect(1, 125251, '\p{Jt:   __D}', "");
    Expect(0, 125251, '\p{^Jt:   __D}', "");
    Expect(0, 125251, '\P{Jt:   __D}', "");
    Expect(1, 125251, '\P{^Jt:   __D}', "");
    Expect(0, 125252, '\p{Jt:   __D}', "");
    Expect(1, 125252, '\p{^Jt:   __D}', "");
    Expect(1, 125252, '\P{Jt:   __D}', "");
    Expect(0, 125252, '\P{^Jt:   __D}', "");
    Error('\p{Is_Joining_Type=_Dual_Joining:=}');
    Error('\P{Is_Joining_Type=_Dual_Joining:=}');
    Expect(1, 125251, '\p{Is_Joining_Type=dualjoining}', "");
    Expect(0, 125251, '\p{^Is_Joining_Type=dualjoining}', "");
    Expect(0, 125251, '\P{Is_Joining_Type=dualjoining}', "");
    Expect(1, 125251, '\P{^Is_Joining_Type=dualjoining}', "");
    Expect(0, 125252, '\p{Is_Joining_Type=dualjoining}', "");
    Expect(1, 125252, '\p{^Is_Joining_Type=dualjoining}', "");
    Expect(1, 125252, '\P{Is_Joining_Type=dualjoining}', "");
    Expect(0, 125252, '\P{^Is_Joining_Type=dualjoining}', "");
    Expect(1, 125251, '\p{Is_Joining_Type=	DUAL_JOINING}', "");
    Expect(0, 125251, '\p{^Is_Joining_Type=	DUAL_JOINING}', "");
    Expect(0, 125251, '\P{Is_Joining_Type=	DUAL_JOINING}', "");
    Expect(1, 125251, '\P{^Is_Joining_Type=	DUAL_JOINING}', "");
    Expect(0, 125252, '\p{Is_Joining_Type=	DUAL_JOINING}', "");
    Expect(1, 125252, '\p{^Is_Joining_Type=	DUAL_JOINING}', "");
    Expect(1, 125252, '\P{Is_Joining_Type=	DUAL_JOINING}', "");
    Expect(0, 125252, '\P{^Is_Joining_Type=	DUAL_JOINING}', "");
    Error('\p{Is_Jt=/a/D}');
    Error('\P{Is_Jt=/a/D}');
    Expect(1, 125251, '\p{Is_Jt=d}', "");
    Expect(0, 125251, '\p{^Is_Jt=d}', "");
    Expect(0, 125251, '\P{Is_Jt=d}', "");
    Expect(1, 125251, '\P{^Is_Jt=d}', "");
    Expect(0, 125252, '\p{Is_Jt=d}', "");
    Expect(1, 125252, '\p{^Is_Jt=d}', "");
    Expect(1, 125252, '\P{Is_Jt=d}', "");
    Expect(0, 125252, '\P{^Is_Jt=d}', "");
    Expect(1, 125251, '\p{Is_Jt= -D}', "");
    Expect(0, 125251, '\p{^Is_Jt= -D}', "");
    Expect(0, 125251, '\P{Is_Jt= -D}', "");
    Expect(1, 125251, '\P{^Is_Jt= -D}', "");
    Expect(0, 125252, '\p{Is_Jt= -D}', "");
    Expect(1, 125252, '\p{^Is_Jt= -D}', "");
    Expect(1, 125252, '\P{Is_Jt= -D}', "");
    Expect(0, 125252, '\P{^Is_Jt= -D}', "");
    Error('\p{Joining_Type=	/a/LEFT_Joining}');
    Error('\P{Joining_Type=	/a/LEFT_Joining}');
    Expect(1, 68864, '\p{Joining_Type=:\ALeft_Joining\z:}', "");;
    Expect(0, 68865, '\p{Joining_Type=:\ALeft_Joining\z:}', "");;
    Expect(1, 68864, '\p{Joining_Type:	leftjoining}', "");
    Expect(0, 68864, '\p{^Joining_Type:	leftjoining}', "");
    Expect(0, 68864, '\P{Joining_Type:	leftjoining}', "");
    Expect(1, 68864, '\P{^Joining_Type:	leftjoining}', "");
    Expect(0, 68865, '\p{Joining_Type:	leftjoining}', "");
    Expect(1, 68865, '\p{^Joining_Type:	leftjoining}', "");
    Expect(1, 68865, '\P{Joining_Type:	leftjoining}', "");
    Expect(0, 68865, '\P{^Joining_Type:	leftjoining}', "");
    Expect(1, 68864, '\p{Joining_Type=:\Aleftjoining\z:}', "");;
    Expect(0, 68865, '\p{Joining_Type=:\Aleftjoining\z:}', "");;
    Expect(1, 68864, '\p{Joining_Type= _Left_JOINING}', "");
    Expect(0, 68864, '\p{^Joining_Type= _Left_JOINING}', "");
    Expect(0, 68864, '\P{Joining_Type= _Left_JOINING}', "");
    Expect(1, 68864, '\P{^Joining_Type= _Left_JOINING}', "");
    Expect(0, 68865, '\p{Joining_Type= _Left_JOINING}', "");
    Expect(1, 68865, '\p{^Joining_Type= _Left_JOINING}', "");
    Expect(1, 68865, '\P{Joining_Type= _Left_JOINING}', "");
    Expect(0, 68865, '\P{^Joining_Type= _Left_JOINING}', "");
    Error('\p{Jt:/a/-L}');
    Error('\P{Jt:/a/-L}');
    Expect(1, 68864, '\p{Jt=:\AL\z:}', "");;
    Expect(0, 68865, '\p{Jt=:\AL\z:}', "");;
    Expect(1, 68864, '\p{Jt=l}', "");
    Expect(0, 68864, '\p{^Jt=l}', "");
    Expect(0, 68864, '\P{Jt=l}', "");
    Expect(1, 68864, '\P{^Jt=l}', "");
    Expect(0, 68865, '\p{Jt=l}', "");
    Expect(1, 68865, '\p{^Jt=l}', "");
    Expect(1, 68865, '\P{Jt=l}', "");
    Expect(0, 68865, '\P{^Jt=l}', "");
    Expect(1, 68864, '\p{Jt=:\Al\z:}', "");;
    Expect(0, 68865, '\p{Jt=:\Al\z:}', "");;
    Expect(1, 68864, '\p{Jt:   --L}', "");
    Expect(0, 68864, '\p{^Jt:   --L}', "");
    Expect(0, 68864, '\P{Jt:   --L}', "");
    Expect(1, 68864, '\P{^Jt:   --L}', "");
    Expect(0, 68865, '\p{Jt:   --L}', "");
    Expect(1, 68865, '\p{^Jt:   --L}', "");
    Expect(1, 68865, '\P{Jt:   --L}', "");
    Expect(0, 68865, '\P{^Jt:   --L}', "");
    Error('\p{Is_Joining_Type=:=_left_joining}');
    Error('\P{Is_Joining_Type=:=_left_joining}');
    Expect(1, 68864, '\p{Is_Joining_Type=leftjoining}', "");
    Expect(0, 68864, '\p{^Is_Joining_Type=leftjoining}', "");
    Expect(0, 68864, '\P{Is_Joining_Type=leftjoining}', "");
    Expect(1, 68864, '\P{^Is_Joining_Type=leftjoining}', "");
    Expect(0, 68865, '\p{Is_Joining_Type=leftjoining}', "");
    Expect(1, 68865, '\p{^Is_Joining_Type=leftjoining}', "");
    Expect(1, 68865, '\P{Is_Joining_Type=leftjoining}', "");
    Expect(0, 68865, '\P{^Is_Joining_Type=leftjoining}', "");
    Expect(1, 68864, '\p{Is_Joining_Type=_LEFT_Joining}', "");
    Expect(0, 68864, '\p{^Is_Joining_Type=_LEFT_Joining}', "");
    Expect(0, 68864, '\P{Is_Joining_Type=_LEFT_Joining}', "");
    Expect(1, 68864, '\P{^Is_Joining_Type=_LEFT_Joining}', "");
    Expect(0, 68865, '\p{Is_Joining_Type=_LEFT_Joining}', "");
    Expect(1, 68865, '\p{^Is_Joining_Type=_LEFT_Joining}', "");
    Expect(1, 68865, '\P{Is_Joining_Type=_LEFT_Joining}', "");
    Expect(0, 68865, '\P{^Is_Joining_Type=_LEFT_Joining}', "");
    Error('\p{Is_Jt=	/a/l}');
    Error('\P{Is_Jt=	/a/l}');
    Expect(1, 68864, '\p{Is_Jt=l}', "");
    Expect(0, 68864, '\p{^Is_Jt=l}', "");
    Expect(0, 68864, '\P{Is_Jt=l}', "");
    Expect(1, 68864, '\P{^Is_Jt=l}', "");
    Expect(0, 68865, '\p{Is_Jt=l}', "");
    Expect(1, 68865, '\p{^Is_Jt=l}', "");
    Expect(1, 68865, '\P{Is_Jt=l}', "");
    Expect(0, 68865, '\P{^Is_Jt=l}', "");
    Expect(1, 68864, '\p{Is_Jt=  L}', "");
    Expect(0, 68864, '\p{^Is_Jt=  L}', "");
    Expect(0, 68864, '\P{Is_Jt=  L}', "");
    Expect(1, 68864, '\P{^Is_Jt=  L}', "");
    Expect(0, 68865, '\p{Is_Jt=  L}', "");
    Expect(1, 68865, '\p{^Is_Jt=  L}', "");
    Expect(1, 68865, '\P{Is_Jt=  L}', "");
    Expect(0, 68865, '\P{^Is_Jt=  L}', "");
    Error('\p{Joining_Type=	Right_joining/a/}');
    Error('\P{Joining_Type=	Right_joining/a/}');
    Expect(1, 69460, '\p{Joining_Type=:\ARight_Joining\z:}', "");;
    Expect(0, 69461, '\p{Joining_Type=:\ARight_Joining\z:}', "");;
    Expect(1, 69460, '\p{Joining_Type:   rightjoining}', "");
    Expect(0, 69460, '\p{^Joining_Type:   rightjoining}', "");
    Expect(0, 69460, '\P{Joining_Type:   rightjoining}', "");
    Expect(1, 69460, '\P{^Joining_Type:   rightjoining}', "");
    Expect(0, 69461, '\p{Joining_Type:   rightjoining}', "");
    Expect(1, 69461, '\p{^Joining_Type:   rightjoining}', "");
    Expect(1, 69461, '\P{Joining_Type:   rightjoining}', "");
    Expect(0, 69461, '\P{^Joining_Type:   rightjoining}', "");
    Expect(1, 69460, '\p{Joining_Type=:\Arightjoining\z:}', "");;
    Expect(0, 69461, '\p{Joining_Type=:\Arightjoining\z:}', "");;
    Expect(1, 69460, '\p{Joining_Type=_ Right_Joining}', "");
    Expect(0, 69460, '\p{^Joining_Type=_ Right_Joining}', "");
    Expect(0, 69460, '\P{Joining_Type=_ Right_Joining}', "");
    Expect(1, 69460, '\P{^Joining_Type=_ Right_Joining}', "");
    Expect(0, 69461, '\p{Joining_Type=_ Right_Joining}', "");
    Expect(1, 69461, '\p{^Joining_Type=_ Right_Joining}', "");
    Expect(1, 69461, '\P{Joining_Type=_ Right_Joining}', "");
    Expect(0, 69461, '\P{^Joining_Type=_ Right_Joining}', "");
    Error('\p{Jt=-/a/R}');
    Error('\P{Jt=-/a/R}');
    Expect(1, 69460, '\p{Jt=:\AR\z:}', "");;
    Expect(0, 69461, '\p{Jt=:\AR\z:}', "");;
    Expect(1, 69460, '\p{Jt=r}', "");
    Expect(0, 69460, '\p{^Jt=r}', "");
    Expect(0, 69460, '\P{Jt=r}', "");
    Expect(1, 69460, '\P{^Jt=r}', "");
    Expect(0, 69461, '\p{Jt=r}', "");
    Expect(1, 69461, '\p{^Jt=r}', "");
    Expect(1, 69461, '\P{Jt=r}', "");
    Expect(0, 69461, '\P{^Jt=r}', "");
    Expect(1, 69460, '\p{Jt=:\Ar\z:}', "");;
    Expect(0, 69461, '\p{Jt=:\Ar\z:}', "");;
    Expect(1, 69460, '\p{Jt=-R}', "");
    Expect(0, 69460, '\p{^Jt=-R}', "");
    Expect(0, 69460, '\P{Jt=-R}', "");
    Expect(1, 69460, '\P{^Jt=-R}', "");
    Expect(0, 69461, '\p{Jt=-R}', "");
    Expect(1, 69461, '\p{^Jt=-R}', "");
    Expect(1, 69461, '\P{Jt=-R}', "");
    Expect(0, 69461, '\P{^Jt=-R}', "");
    Error('\p{Is_Joining_Type=/a/	RIGHT_Joining}');
    Error('\P{Is_Joining_Type=/a/	RIGHT_Joining}');
    Expect(1, 69460, '\p{Is_Joining_Type=rightjoining}', "");
    Expect(0, 69460, '\p{^Is_Joining_Type=rightjoining}', "");
    Expect(0, 69460, '\P{Is_Joining_Type=rightjoining}', "");
    Expect(1, 69460, '\P{^Is_Joining_Type=rightjoining}', "");
    Expect(0, 69461, '\p{Is_Joining_Type=rightjoining}', "");
    Expect(1, 69461, '\p{^Is_Joining_Type=rightjoining}', "");
    Expect(1, 69461, '\P{Is_Joining_Type=rightjoining}', "");
    Expect(0, 69461, '\P{^Is_Joining_Type=rightjoining}', "");
    Expect(1, 69460, '\p{Is_Joining_Type=	Right_JOINING}', "");
    Expect(0, 69460, '\p{^Is_Joining_Type=	Right_JOINING}', "");
    Expect(0, 69460, '\P{Is_Joining_Type=	Right_JOINING}', "");
    Expect(1, 69460, '\P{^Is_Joining_Type=	Right_JOINING}', "");
    Expect(0, 69461, '\p{Is_Joining_Type=	Right_JOINING}', "");
    Expect(1, 69461, '\p{^Is_Joining_Type=	Right_JOINING}', "");
    Expect(1, 69461, '\P{Is_Joining_Type=	Right_JOINING}', "");
    Expect(0, 69461, '\P{^Is_Joining_Type=	Right_JOINING}', "");
    Error('\p{Is_Jt=		R/a/}');
    Error('\P{Is_Jt=		R/a/}');
    Expect(1, 69460, '\p{Is_Jt=r}', "");
    Expect(0, 69460, '\p{^Is_Jt=r}', "");
    Expect(0, 69460, '\P{Is_Jt=r}', "");
    Expect(1, 69460, '\P{^Is_Jt=r}', "");
    Expect(0, 69461, '\p{Is_Jt=r}', "");
    Expect(1, 69461, '\p{^Is_Jt=r}', "");
    Expect(1, 69461, '\P{Is_Jt=r}', "");
    Expect(0, 69461, '\P{^Is_Jt=r}', "");
    Expect(1, 69460, '\p{Is_Jt=--R}', "");
    Expect(0, 69460, '\p{^Is_Jt=--R}', "");
    Expect(0, 69460, '\P{Is_Jt=--R}', "");
    Expect(1, 69460, '\P{^Is_Jt=--R}', "");
    Expect(0, 69461, '\p{Is_Jt=--R}', "");
    Expect(1, 69461, '\p{^Is_Jt=--R}', "");
    Expect(1, 69461, '\P{Is_Jt=--R}', "");
    Expect(0, 69461, '\P{^Is_Jt=--R}', "");
    Error('\p{Joining_Type=_/a/TRANSPARENT}');
    Error('\P{Joining_Type=_/a/TRANSPARENT}');
    Expect(1, 917999, '\p{Joining_Type=:\ATransparent\z:}', "");;
    Expect(0, 918000, '\p{Joining_Type=:\ATransparent\z:}', "");;
    Expect(1, 917999, '\p{Joining_Type=transparent}', "");
    Expect(0, 917999, '\p{^Joining_Type=transparent}', "");
    Expect(0, 917999, '\P{Joining_Type=transparent}', "");
    Expect(1, 917999, '\P{^Joining_Type=transparent}', "");
    Expect(0, 918000, '\p{Joining_Type=transparent}', "");
    Expect(1, 918000, '\p{^Joining_Type=transparent}', "");
    Expect(1, 918000, '\P{Joining_Type=transparent}', "");
    Expect(0, 918000, '\P{^Joining_Type=transparent}', "");
    Expect(1, 917999, '\p{Joining_Type=:\Atransparent\z:}', "");;
    Expect(0, 918000, '\p{Joining_Type=:\Atransparent\z:}', "");;
    Expect(1, 917999, '\p{Joining_Type=_transparent}', "");
    Expect(0, 917999, '\p{^Joining_Type=_transparent}', "");
    Expect(0, 917999, '\P{Joining_Type=_transparent}', "");
    Expect(1, 917999, '\P{^Joining_Type=_transparent}', "");
    Expect(0, 918000, '\p{Joining_Type=_transparent}', "");
    Expect(1, 918000, '\p{^Joining_Type=_transparent}', "");
    Expect(1, 918000, '\P{Joining_Type=_transparent}', "");
    Expect(0, 918000, '\P{^Joining_Type=_transparent}', "");
    Error('\p{Jt=-/a/T}');
    Error('\P{Jt=-/a/T}');
    Expect(1, 917999, '\p{Jt=:\AT\z:}', "");;
    Expect(0, 918000, '\p{Jt=:\AT\z:}', "");;
    Expect(1, 917999, '\p{Jt=t}', "");
    Expect(0, 917999, '\p{^Jt=t}', "");
    Expect(0, 917999, '\P{Jt=t}', "");
    Expect(1, 917999, '\P{^Jt=t}', "");
    Expect(0, 918000, '\p{Jt=t}', "");
    Expect(1, 918000, '\p{^Jt=t}', "");
    Expect(1, 918000, '\P{Jt=t}', "");
    Expect(0, 918000, '\P{^Jt=t}', "");
    Expect(1, 917999, '\p{Jt=:\At\z:}', "");;
    Expect(0, 918000, '\p{Jt=:\At\z:}', "");;
    Expect(1, 917999, '\p{Jt=- T}', "");
    Expect(0, 917999, '\p{^Jt=- T}', "");
    Expect(0, 917999, '\P{Jt=- T}', "");
    Expect(1, 917999, '\P{^Jt=- T}', "");
    Expect(0, 918000, '\p{Jt=- T}', "");
    Expect(1, 918000, '\p{^Jt=- T}', "");
    Expect(1, 918000, '\P{Jt=- T}', "");
    Expect(0, 918000, '\P{^Jt=- T}', "");
    Error('\p{Is_Joining_Type=:=	-transparent}');
    Error('\P{Is_Joining_Type=:=	-transparent}');
    Expect(1, 917999, '\p{Is_Joining_Type=transparent}', "");
    Expect(0, 917999, '\p{^Is_Joining_Type=transparent}', "");
    Expect(0, 917999, '\P{Is_Joining_Type=transparent}', "");
    Expect(1, 917999, '\P{^Is_Joining_Type=transparent}', "");
    Expect(0, 918000, '\p{Is_Joining_Type=transparent}', "");
    Expect(1, 918000, '\p{^Is_Joining_Type=transparent}', "");
    Expect(1, 918000, '\P{Is_Joining_Type=transparent}', "");
    Expect(0, 918000, '\P{^Is_Joining_Type=transparent}', "");
    Expect(1, 917999, '\p{Is_Joining_Type:__TRANSPARENT}', "");
    Expect(0, 917999, '\p{^Is_Joining_Type:__TRANSPARENT}', "");
    Expect(0, 917999, '\P{Is_Joining_Type:__TRANSPARENT}', "");
    Expect(1, 917999, '\P{^Is_Joining_Type:__TRANSPARENT}', "");
    Expect(0, 918000, '\p{Is_Joining_Type:__TRANSPARENT}', "");
    Expect(1, 918000, '\p{^Is_Joining_Type:__TRANSPARENT}', "");
    Expect(1, 918000, '\P{Is_Joining_Type:__TRANSPARENT}', "");
    Expect(0, 918000, '\P{^Is_Joining_Type:__TRANSPARENT}', "");
    Error('\p{Is_Jt=  T:=}');
    Error('\P{Is_Jt=  T:=}');
    Expect(1, 917999, '\p{Is_Jt=t}', "");
    Expect(0, 917999, '\p{^Is_Jt=t}', "");
    Expect(0, 917999, '\P{Is_Jt=t}', "");
    Expect(1, 917999, '\P{^Is_Jt=t}', "");
    Expect(0, 918000, '\p{Is_Jt=t}', "");
    Expect(1, 918000, '\p{^Is_Jt=t}', "");
    Expect(1, 918000, '\P{Is_Jt=t}', "");
    Expect(0, 918000, '\P{^Is_Jt=t}', "");
    Expect(1, 917999, '\p{Is_Jt=  T}', "");
    Expect(0, 917999, '\p{^Is_Jt=  T}', "");
    Expect(0, 917999, '\P{Is_Jt=  T}', "");
    Expect(1, 917999, '\P{^Is_Jt=  T}', "");
    Expect(0, 918000, '\p{Is_Jt=  T}', "");
    Expect(1, 918000, '\p{^Is_Jt=  T}', "");
    Expect(1, 918000, '\P{Is_Jt=  T}', "");
    Expect(0, 918000, '\P{^Is_Jt=  T}', "");
    Error('\p{Joining_Type=	Non_Joining/a/}');
    Error('\P{Joining_Type=	Non_Joining/a/}');
    Expect(1, 918000, '\p{Joining_Type=:\ANon_Joining\z:}', "");;
    Expect(0, 917999, '\p{Joining_Type=:\ANon_Joining\z:}', "");;
    Expect(1, 918000, '\p{Joining_Type:   nonjoining}', "");
    Expect(0, 918000, '\p{^Joining_Type:   nonjoining}', "");
    Expect(0, 918000, '\P{Joining_Type:   nonjoining}', "");
    Expect(1, 918000, '\P{^Joining_Type:   nonjoining}', "");
    Expect(0, 917999, '\p{Joining_Type:   nonjoining}', "");
    Expect(1, 917999, '\p{^Joining_Type:   nonjoining}', "");
    Expect(1, 917999, '\P{Joining_Type:   nonjoining}', "");
    Expect(0, 917999, '\P{^Joining_Type:   nonjoining}', "");
    Expect(1, 918000, '\p{Joining_Type=:\Anonjoining\z:}', "");;
    Expect(0, 917999, '\p{Joining_Type=:\Anonjoining\z:}', "");;
    Expect(1, 918000, '\p{Joining_Type=Non_JOINING}', "");
    Expect(0, 918000, '\p{^Joining_Type=Non_JOINING}', "");
    Expect(0, 918000, '\P{Joining_Type=Non_JOINING}', "");
    Expect(1, 918000, '\P{^Joining_Type=Non_JOINING}', "");
    Expect(0, 917999, '\p{Joining_Type=Non_JOINING}', "");
    Expect(1, 917999, '\p{^Joining_Type=Non_JOINING}', "");
    Expect(1, 917999, '\P{Joining_Type=Non_JOINING}', "");
    Expect(0, 917999, '\P{^Joining_Type=Non_JOINING}', "");
    Error('\p{Jt=	:=u}');
    Error('\P{Jt=	:=u}');
    Expect(1, 918000, '\p{Jt=:\AU\z:}', "");;
    Expect(0, 917999, '\p{Jt=:\AU\z:}', "");;
    Expect(1, 918000, '\p{Jt=u}', "");
    Expect(0, 918000, '\p{^Jt=u}', "");
    Expect(0, 918000, '\P{Jt=u}', "");
    Expect(1, 918000, '\P{^Jt=u}', "");
    Expect(0, 917999, '\p{Jt=u}', "");
    Expect(1, 917999, '\p{^Jt=u}', "");
    Expect(1, 917999, '\P{Jt=u}', "");
    Expect(0, 917999, '\P{^Jt=u}', "");
    Expect(1, 918000, '\p{Jt=:\Au\z:}', "");;
    Expect(0, 917999, '\p{Jt=:\Au\z:}', "");;
    Expect(1, 918000, '\p{Jt=-_U}', "");
    Expect(0, 918000, '\p{^Jt=-_U}', "");
    Expect(0, 918000, '\P{Jt=-_U}', "");
    Expect(1, 918000, '\P{^Jt=-_U}', "");
    Expect(0, 917999, '\p{Jt=-_U}', "");
    Expect(1, 917999, '\p{^Jt=-_U}', "");
    Expect(1, 917999, '\P{Jt=-_U}', "");
    Expect(0, 917999, '\P{^Jt=-_U}', "");
    Error('\p{Is_Joining_Type=_:=Non_Joining}');
    Error('\P{Is_Joining_Type=_:=Non_Joining}');
    Expect(1, 918000, '\p{Is_Joining_Type=nonjoining}', "");
    Expect(0, 918000, '\p{^Is_Joining_Type=nonjoining}', "");
    Expect(0, 918000, '\P{Is_Joining_Type=nonjoining}', "");
    Expect(1, 918000, '\P{^Is_Joining_Type=nonjoining}', "");
    Expect(0, 917999, '\p{Is_Joining_Type=nonjoining}', "");
    Expect(1, 917999, '\p{^Is_Joining_Type=nonjoining}', "");
    Expect(1, 917999, '\P{Is_Joining_Type=nonjoining}', "");
    Expect(0, 917999, '\P{^Is_Joining_Type=nonjoining}', "");
    Expect(1, 918000, '\p{Is_Joining_Type= 	Non_joining}', "");
    Expect(0, 918000, '\p{^Is_Joining_Type= 	Non_joining}', "");
    Expect(0, 918000, '\P{Is_Joining_Type= 	Non_joining}', "");
    Expect(1, 918000, '\P{^Is_Joining_Type= 	Non_joining}', "");
    Expect(0, 917999, '\p{Is_Joining_Type= 	Non_joining}', "");
    Expect(1, 917999, '\p{^Is_Joining_Type= 	Non_joining}', "");
    Expect(1, 917999, '\P{Is_Joining_Type= 	Non_joining}', "");
    Expect(0, 917999, '\P{^Is_Joining_Type= 	Non_joining}', "");
    Error('\p{Is_Jt=-/a/U}');
    Error('\P{Is_Jt=-/a/U}');
    Expect(1, 918000, '\p{Is_Jt=u}', "");
    Expect(0, 918000, '\p{^Is_Jt=u}', "");
    Expect(0, 918000, '\P{Is_Jt=u}', "");
    Expect(1, 918000, '\P{^Is_Jt=u}', "");
    Expect(0, 917999, '\p{Is_Jt=u}', "");
    Expect(1, 917999, '\p{^Is_Jt=u}', "");
    Expect(1, 917999, '\P{Is_Jt=u}', "");
    Expect(0, 917999, '\P{^Is_Jt=u}', "");
    Expect(1, 918000, '\p{Is_Jt=_U}', "");
    Expect(0, 918000, '\p{^Is_Jt=_U}', "");
    Expect(0, 918000, '\P{Is_Jt=_U}', "");
    Expect(1, 918000, '\P{^Is_Jt=_U}', "");
    Expect(0, 917999, '\p{Is_Jt=_U}', "");
    Expect(1, 917999, '\p{^Is_Jt=_U}', "");
    Expect(1, 917999, '\P{Is_Jt=_U}', "");
    Expect(0, 917999, '\P{^Is_Jt=_U}', "");
    Error('\p{linebreak}');
    Error('\P{linebreak}');
    Error('\p{lb}');
    Error('\P{lb}');
    Error('\p{Line_Break=/a/ 	Ambiguous}');
    Error('\P{Line_Break=/a/ 	Ambiguous}');
    Expect(1, 127404, '\p{Line_Break=:\AAmbiguous\z:}', "");;
    Expect(0, 127405, '\p{Line_Break=:\AAmbiguous\z:}', "");;
    Expect(1, 127404, '\p{Line_Break=ambiguous}', "");
    Expect(0, 127404, '\p{^Line_Break=ambiguous}', "");
    Expect(0, 127404, '\P{Line_Break=ambiguous}', "");
    Expect(1, 127404, '\P{^Line_Break=ambiguous}', "");
    Expect(0, 127405, '\p{Line_Break=ambiguous}', "");
    Expect(1, 127405, '\p{^Line_Break=ambiguous}', "");
    Expect(1, 127405, '\P{Line_Break=ambiguous}', "");
    Expect(0, 127405, '\P{^Line_Break=ambiguous}', "");
    Expect(1, 127404, '\p{Line_Break=:\Aambiguous\z:}', "");;
    Expect(0, 127405, '\p{Line_Break=:\Aambiguous\z:}', "");;
    Expect(1, 127404, '\p{Line_Break=-_Ambiguous}', "");
    Expect(0, 127404, '\p{^Line_Break=-_Ambiguous}', "");
    Expect(0, 127404, '\P{Line_Break=-_Ambiguous}', "");
    Expect(1, 127404, '\P{^Line_Break=-_Ambiguous}', "");
    Expect(0, 127405, '\p{Line_Break=-_Ambiguous}', "");
    Expect(1, 127405, '\p{^Line_Break=-_Ambiguous}', "");
    Expect(1, 127405, '\P{Line_Break=-_Ambiguous}', "");
    Expect(0, 127405, '\P{^Line_Break=-_Ambiguous}', "");
    Error('\p{Lb=:=AI}');
    Error('\P{Lb=:=AI}');
    Expect(1, 127404, '\p{Lb=:\AAI\z:}', "");;
    Expect(0, 127405, '\p{Lb=:\AAI\z:}', "");;
    Expect(1, 127404, '\p{Lb=ai}', "");
    Expect(0, 127404, '\p{^Lb=ai}', "");
    Expect(0, 127404, '\P{Lb=ai}', "");
    Expect(1, 127404, '\P{^Lb=ai}', "");
    Expect(0, 127405, '\p{Lb=ai}', "");
    Expect(1, 127405, '\p{^Lb=ai}', "");
    Expect(1, 127405, '\P{Lb=ai}', "");
    Expect(0, 127405, '\P{^Lb=ai}', "");
    Expect(1, 127404, '\p{Lb=:\Aai\z:}', "");;
    Expect(0, 127405, '\p{Lb=:\Aai\z:}', "");;
    Expect(1, 127404, '\p{Lb=-	ai}', "");
    Expect(0, 127404, '\p{^Lb=-	ai}', "");
    Expect(0, 127404, '\P{Lb=-	ai}', "");
    Expect(1, 127404, '\P{^Lb=-	ai}', "");
    Expect(0, 127405, '\p{Lb=-	ai}', "");
    Expect(1, 127405, '\p{^Lb=-	ai}', "");
    Expect(1, 127405, '\P{Lb=-	ai}', "");
    Expect(0, 127405, '\P{^Lb=-	ai}', "");
    Error('\p{Is_Line_Break=:= -ambiguous}');
    Error('\P{Is_Line_Break=:= -ambiguous}');
    Expect(1, 127404, '\p{Is_Line_Break=ambiguous}', "");
    Expect(0, 127404, '\p{^Is_Line_Break=ambiguous}', "");
    Expect(0, 127404, '\P{Is_Line_Break=ambiguous}', "");
    Expect(1, 127404, '\P{^Is_Line_Break=ambiguous}', "");
    Expect(0, 127405, '\p{Is_Line_Break=ambiguous}', "");
    Expect(1, 127405, '\p{^Is_Line_Break=ambiguous}', "");
    Expect(1, 127405, '\P{Is_Line_Break=ambiguous}', "");
    Expect(0, 127405, '\P{^Is_Line_Break=ambiguous}', "");
    Expect(1, 127404, '\p{Is_Line_Break= -AMBIGUOUS}', "");
    Expect(0, 127404, '\p{^Is_Line_Break= -AMBIGUOUS}', "");
    Expect(0, 127404, '\P{Is_Line_Break= -AMBIGUOUS}', "");
    Expect(1, 127404, '\P{^Is_Line_Break= -AMBIGUOUS}', "");
    Expect(0, 127405, '\p{Is_Line_Break= -AMBIGUOUS}', "");
    Expect(1, 127405, '\p{^Is_Line_Break= -AMBIGUOUS}', "");
    Expect(1, 127405, '\P{Is_Line_Break= -AMBIGUOUS}', "");
    Expect(0, 127405, '\P{^Is_Line_Break= -AMBIGUOUS}', "");
    Error('\p{Is_Lb=/a/AI}');
    Error('\P{Is_Lb=/a/AI}');
    Expect(1, 127404, '\p{Is_Lb=ai}', "");
    Expect(0, 127404, '\p{^Is_Lb=ai}', "");
    Expect(0, 127404, '\P{Is_Lb=ai}', "");
    Expect(1, 127404, '\P{^Is_Lb=ai}', "");
    Expect(0, 127405, '\p{Is_Lb=ai}', "");
    Expect(1, 127405, '\p{^Is_Lb=ai}', "");
    Expect(1, 127405, '\P{Is_Lb=ai}', "");
    Expect(0, 127405, '\P{^Is_Lb=ai}', "");
    Expect(1, 127404, '\p{Is_Lb:  -AI}', "");
    Expect(0, 127404, '\p{^Is_Lb:  -AI}', "");
    Expect(0, 127404, '\P{Is_Lb:  -AI}', "");
    Expect(1, 127404, '\P{^Is_Lb:  -AI}', "");
    Expect(0, 127405, '\p{Is_Lb:  -AI}', "");
    Expect(1, 127405, '\p{^Is_Lb:  -AI}', "");
    Expect(1, 127405, '\P{Is_Lb:  -AI}', "");
    Expect(0, 127405, '\P{^Is_Lb:  -AI}', "");
    Error('\p{Line_Break=-/a/ALPHABETIC}');
    Error('\P{Line_Break=-/a/ALPHABETIC}');
    Expect(1, 129619, '\p{Line_Break=:\AAlphabetic\z:}', "");;
    Expect(0, 129620, '\p{Line_Break=:\AAlphabetic\z:}', "");;
    Expect(1, 129619, '\p{Line_Break=alphabetic}', "");
    Expect(0, 129619, '\p{^Line_Break=alphabetic}', "");
    Expect(0, 129619, '\P{Line_Break=alphabetic}', "");
    Expect(1, 129619, '\P{^Line_Break=alphabetic}', "");
    Expect(0, 129620, '\p{Line_Break=alphabetic}', "");
    Expect(1, 129620, '\p{^Line_Break=alphabetic}', "");
    Expect(1, 129620, '\P{Line_Break=alphabetic}', "");
    Expect(0, 129620, '\P{^Line_Break=alphabetic}', "");
    Expect(1, 129619, '\p{Line_Break=:\Aalphabetic\z:}', "");;
    Expect(0, 129620, '\p{Line_Break=:\Aalphabetic\z:}', "");;
    Expect(1, 129619, '\p{Line_Break=		Alphabetic}', "");
    Expect(0, 129619, '\p{^Line_Break=		Alphabetic}', "");
    Expect(0, 129619, '\P{Line_Break=		Alphabetic}', "");
    Expect(1, 129619, '\P{^Line_Break=		Alphabetic}', "");
    Expect(0, 129620, '\p{Line_Break=		Alphabetic}', "");
    Expect(1, 129620, '\p{^Line_Break=		Alphabetic}', "");
    Expect(1, 129620, '\P{Line_Break=		Alphabetic}', "");
    Expect(0, 129620, '\P{^Line_Break=		Alphabetic}', "");
    Error('\p{Lb=/a/AL}');
    Error('\P{Lb=/a/AL}');
    Expect(1, 129619, '\p{Lb=:\AAL\z:}', "");;
    Expect(0, 129620, '\p{Lb=:\AAL\z:}', "");;
    Expect(1, 129619, '\p{Lb=al}', "");
    Expect(0, 129619, '\p{^Lb=al}', "");
    Expect(0, 129619, '\P{Lb=al}', "");
    Expect(1, 129619, '\P{^Lb=al}', "");
    Expect(0, 129620, '\p{Lb=al}', "");
    Expect(1, 129620, '\p{^Lb=al}', "");
    Expect(1, 129620, '\P{Lb=al}', "");
    Expect(0, 129620, '\P{^Lb=al}', "");
    Expect(1, 129619, '\p{Lb=:\Aal\z:}', "");;
    Expect(0, 129620, '\p{Lb=:\Aal\z:}', "");;
    Expect(1, 129619, '\p{Lb=-al}', "");
    Expect(0, 129619, '\p{^Lb=-al}', "");
    Expect(0, 129619, '\P{Lb=-al}', "");
    Expect(1, 129619, '\P{^Lb=-al}', "");
    Expect(0, 129620, '\p{Lb=-al}', "");
    Expect(1, 129620, '\p{^Lb=-al}', "");
    Expect(1, 129620, '\P{Lb=-al}', "");
    Expect(0, 129620, '\P{^Lb=-al}', "");
    Error('\p{Is_Line_Break=	Alphabetic/a/}');
    Error('\P{Is_Line_Break=	Alphabetic/a/}');
    Expect(1, 129619, '\p{Is_Line_Break=alphabetic}', "");
    Expect(0, 129619, '\p{^Is_Line_Break=alphabetic}', "");
    Expect(0, 129619, '\P{Is_Line_Break=alphabetic}', "");
    Expect(1, 129619, '\P{^Is_Line_Break=alphabetic}', "");
    Expect(0, 129620, '\p{Is_Line_Break=alphabetic}', "");
    Expect(1, 129620, '\p{^Is_Line_Break=alphabetic}', "");
    Expect(1, 129620, '\P{Is_Line_Break=alphabetic}', "");
    Expect(0, 129620, '\P{^Is_Line_Break=alphabetic}', "");
    Expect(1, 129619, '\p{Is_Line_Break=  alphabetic}', "");
    Expect(0, 129619, '\p{^Is_Line_Break=  alphabetic}', "");
    Expect(0, 129619, '\P{Is_Line_Break=  alphabetic}', "");
    Expect(1, 129619, '\P{^Is_Line_Break=  alphabetic}', "");
    Expect(0, 129620, '\p{Is_Line_Break=  alphabetic}', "");
    Expect(1, 129620, '\p{^Is_Line_Break=  alphabetic}', "");
    Expect(1, 129620, '\P{Is_Line_Break=  alphabetic}', "");
    Expect(0, 129620, '\P{^Is_Line_Break=  alphabetic}', "");
    Error('\p{Is_Lb=:=_-AL}');
    Error('\P{Is_Lb=:=_-AL}');
    Expect(1, 129619, '\p{Is_Lb=al}', "");
    Expect(0, 129619, '\p{^Is_Lb=al}', "");
    Expect(0, 129619, '\P{Is_Lb=al}', "");
    Expect(1, 129619, '\P{^Is_Lb=al}', "");
    Expect(0, 129620, '\p{Is_Lb=al}', "");
    Expect(1, 129620, '\p{^Is_Lb=al}', "");
    Expect(1, 129620, '\P{Is_Lb=al}', "");
    Expect(0, 129620, '\P{^Is_Lb=al}', "");
    Expect(1, 129619, '\p{Is_Lb:	 AL}', "");
    Expect(0, 129619, '\p{^Is_Lb:	 AL}', "");
    Expect(0, 129619, '\P{Is_Lb:	 AL}', "");
    Expect(1, 129619, '\P{^Is_Lb:	 AL}', "");
    Expect(0, 129620, '\p{Is_Lb:	 AL}', "");
    Expect(1, 129620, '\p{^Is_Lb:	 AL}', "");
    Expect(1, 129620, '\P{Is_Lb:	 AL}', "");
    Expect(0, 129620, '\P{^Is_Lb:	 AL}', "");
    Error('\p{Line_Break=-:=break_BOTH}');
    Error('\P{Line_Break=-:=break_BOTH}');
    Expect(1, 11835, '\p{Line_Break=:\ABreak_Both\z:}', "");;
    Expect(0, 11836, '\p{Line_Break=:\ABreak_Both\z:}', "");;
    Expect(1, 11835, '\p{Line_Break=breakboth}', "");
    Expect(0, 11835, '\p{^Line_Break=breakboth}', "");
    Expect(0, 11835, '\P{Line_Break=breakboth}', "");
    Expect(1, 11835, '\P{^Line_Break=breakboth}', "");
    Expect(0, 11836, '\p{Line_Break=breakboth}', "");
    Expect(1, 11836, '\p{^Line_Break=breakboth}', "");
    Expect(1, 11836, '\P{Line_Break=breakboth}', "");
    Expect(0, 11836, '\P{^Line_Break=breakboth}', "");
    Expect(1, 11835, '\p{Line_Break=:\Abreakboth\z:}', "");;
    Expect(0, 11836, '\p{Line_Break=:\Abreakboth\z:}', "");;
    Expect(1, 11835, '\p{Line_Break=-Break_both}', "");
    Expect(0, 11835, '\p{^Line_Break=-Break_both}', "");
    Expect(0, 11835, '\P{Line_Break=-Break_both}', "");
    Expect(1, 11835, '\P{^Line_Break=-Break_both}', "");
    Expect(0, 11836, '\p{Line_Break=-Break_both}', "");
    Expect(1, 11836, '\p{^Line_Break=-Break_both}', "");
    Expect(1, 11836, '\P{Line_Break=-Break_both}', "");
    Expect(0, 11836, '\P{^Line_Break=-Break_both}', "");
    Error('\p{Lb=		b2:=}');
    Error('\P{Lb=		b2:=}');
    Expect(1, 11835, '\p{Lb=:\AB2\z:}', "");;
    Expect(0, 11836, '\p{Lb=:\AB2\z:}', "");;
    Expect(1, 11835, '\p{Lb=b2}', "");
    Expect(0, 11835, '\p{^Lb=b2}', "");
    Expect(0, 11835, '\P{Lb=b2}', "");
    Expect(1, 11835, '\P{^Lb=b2}', "");
    Expect(0, 11836, '\p{Lb=b2}', "");
    Expect(1, 11836, '\p{^Lb=b2}', "");
    Expect(1, 11836, '\P{Lb=b2}', "");
    Expect(0, 11836, '\P{^Lb=b2}', "");
    Expect(1, 11835, '\p{Lb=:\Ab2\z:}', "");;
    Expect(0, 11836, '\p{Lb=:\Ab2\z:}', "");;
    Expect(1, 11835, '\p{Lb=  B2}', "");
    Expect(0, 11835, '\p{^Lb=  B2}', "");
    Expect(0, 11835, '\P{Lb=  B2}', "");
    Expect(1, 11835, '\P{^Lb=  B2}', "");
    Expect(0, 11836, '\p{Lb=  B2}', "");
    Expect(1, 11836, '\p{^Lb=  B2}', "");
    Expect(1, 11836, '\P{Lb=  B2}', "");
    Expect(0, 11836, '\P{^Lb=  B2}', "");
    Error('\p{Is_Line_Break: := BREAK_both}');
    Error('\P{Is_Line_Break: := BREAK_both}');
    Expect(1, 11835, '\p{Is_Line_Break=breakboth}', "");
    Expect(0, 11835, '\p{^Is_Line_Break=breakboth}', "");
    Expect(0, 11835, '\P{Is_Line_Break=breakboth}', "");
    Expect(1, 11835, '\P{^Is_Line_Break=breakboth}', "");
    Expect(0, 11836, '\p{Is_Line_Break=breakboth}', "");
    Expect(1, 11836, '\p{^Is_Line_Break=breakboth}', "");
    Expect(1, 11836, '\P{Is_Line_Break=breakboth}', "");
    Expect(0, 11836, '\P{^Is_Line_Break=breakboth}', "");
    Expect(1, 11835, '\p{Is_Line_Break=-_Break_both}', "");
    Expect(0, 11835, '\p{^Is_Line_Break=-_Break_both}', "");
    Expect(0, 11835, '\P{Is_Line_Break=-_Break_both}', "");
    Expect(1, 11835, '\P{^Is_Line_Break=-_Break_both}', "");
    Expect(0, 11836, '\p{Is_Line_Break=-_Break_both}', "");
    Expect(1, 11836, '\p{^Is_Line_Break=-_Break_both}', "");
    Expect(1, 11836, '\P{Is_Line_Break=-_Break_both}', "");
    Expect(0, 11836, '\P{^Is_Line_Break=-_Break_both}', "");
    Error('\p{Is_Lb=	b2:=}');
    Error('\P{Is_Lb=	b2:=}');
    Expect(1, 11835, '\p{Is_Lb=b2}', "");
    Expect(0, 11835, '\p{^Is_Lb=b2}', "");
    Expect(0, 11835, '\P{Is_Lb=b2}', "");
    Expect(1, 11835, '\P{^Is_Lb=b2}', "");
    Expect(0, 11836, '\p{Is_Lb=b2}', "");
    Expect(1, 11836, '\p{^Is_Lb=b2}', "");
    Expect(1, 11836, '\P{Is_Lb=b2}', "");
    Expect(0, 11836, '\P{^Is_Lb=b2}', "");
    Expect(1, 11835, '\p{Is_Lb=_B2}', "");
    Expect(0, 11835, '\p{^Is_Lb=_B2}', "");
    Expect(0, 11835, '\P{Is_Lb=_B2}', "");
    Expect(1, 11835, '\P{^Is_Lb=_B2}', "");
    Expect(0, 11836, '\p{Is_Lb=_B2}', "");
    Expect(1, 11836, '\p{^Is_Lb=_B2}', "");
    Expect(1, 11836, '\P{Is_Lb=_B2}', "");
    Expect(0, 11836, '\P{^Is_Lb=_B2}', "");
    Error('\p{Line_Break= -Break_after:=}');
    Error('\P{Line_Break= -Break_after:=}');
    Expect(1, 121482, '\p{Line_Break=:\ABreak_After\z:}', "");;
    Expect(0, 121483, '\p{Line_Break=:\ABreak_After\z:}', "");;
    Expect(1, 121482, '\p{Line_Break=breakafter}', "");
    Expect(0, 121482, '\p{^Line_Break=breakafter}', "");
    Expect(0, 121482, '\P{Line_Break=breakafter}', "");
    Expect(1, 121482, '\P{^Line_Break=breakafter}', "");
    Expect(0, 121483, '\p{Line_Break=breakafter}', "");
    Expect(1, 121483, '\p{^Line_Break=breakafter}', "");
    Expect(1, 121483, '\P{Line_Break=breakafter}', "");
    Expect(0, 121483, '\P{^Line_Break=breakafter}', "");
    Expect(1, 121482, '\p{Line_Break=:\Abreakafter\z:}', "");;
    Expect(0, 121483, '\p{Line_Break=:\Abreakafter\z:}', "");;
    Expect(1, 121482, '\p{Line_Break=	-Break_AFTER}', "");
    Expect(0, 121482, '\p{^Line_Break=	-Break_AFTER}', "");
    Expect(0, 121482, '\P{Line_Break=	-Break_AFTER}', "");
    Expect(1, 121482, '\P{^Line_Break=	-Break_AFTER}', "");
    Expect(0, 121483, '\p{Line_Break=	-Break_AFTER}', "");
    Expect(1, 121483, '\p{^Line_Break=	-Break_AFTER}', "");
    Expect(1, 121483, '\P{Line_Break=	-Break_AFTER}', "");
    Expect(0, 121483, '\P{^Line_Break=	-Break_AFTER}', "");
    Error('\p{Lb:/a/-BA}');
    Error('\P{Lb:/a/-BA}');
    Expect(1, 121482, '\p{Lb=:\ABA\z:}', "");;
    Expect(0, 121483, '\p{Lb=:\ABA\z:}', "");;
    Expect(1, 121482, '\p{Lb=ba}', "");
    Expect(0, 121482, '\p{^Lb=ba}', "");
    Expect(0, 121482, '\P{Lb=ba}', "");
    Expect(1, 121482, '\P{^Lb=ba}', "");
    Expect(0, 121483, '\p{Lb=ba}', "");
    Expect(1, 121483, '\p{^Lb=ba}', "");
    Expect(1, 121483, '\P{Lb=ba}', "");
    Expect(0, 121483, '\P{^Lb=ba}', "");
    Expect(1, 121482, '\p{Lb=:\Aba\z:}', "");;
    Expect(0, 121483, '\p{Lb=:\Aba\z:}', "");;
    Expect(1, 121482, '\p{Lb=  BA}', "");
    Expect(0, 121482, '\p{^Lb=  BA}', "");
    Expect(0, 121482, '\P{Lb=  BA}', "");
    Expect(1, 121482, '\P{^Lb=  BA}', "");
    Expect(0, 121483, '\p{Lb=  BA}', "");
    Expect(1, 121483, '\p{^Lb=  BA}', "");
    Expect(1, 121483, '\P{Lb=  BA}', "");
    Expect(0, 121483, '\P{^Lb=  BA}', "");
    Error('\p{Is_Line_Break=	Break_After:=}');
    Error('\P{Is_Line_Break=	Break_After:=}');
    Expect(1, 121482, '\p{Is_Line_Break=breakafter}', "");
    Expect(0, 121482, '\p{^Is_Line_Break=breakafter}', "");
    Expect(0, 121482, '\P{Is_Line_Break=breakafter}', "");
    Expect(1, 121482, '\P{^Is_Line_Break=breakafter}', "");
    Expect(0, 121483, '\p{Is_Line_Break=breakafter}', "");
    Expect(1, 121483, '\p{^Is_Line_Break=breakafter}', "");
    Expect(1, 121483, '\P{Is_Line_Break=breakafter}', "");
    Expect(0, 121483, '\P{^Is_Line_Break=breakafter}', "");
    Expect(1, 121482, '\p{Is_Line_Break=_break_After}', "");
    Expect(0, 121482, '\p{^Is_Line_Break=_break_After}', "");
    Expect(0, 121482, '\P{Is_Line_Break=_break_After}', "");
    Expect(1, 121482, '\P{^Is_Line_Break=_break_After}', "");
    Expect(0, 121483, '\p{Is_Line_Break=_break_After}', "");
    Expect(1, 121483, '\p{^Is_Line_Break=_break_After}', "");
    Expect(1, 121483, '\P{Is_Line_Break=_break_After}', "");
    Expect(0, 121483, '\P{^Is_Line_Break=_break_After}', "");
    Error('\p{Is_Lb=:=_-ba}');
    Error('\P{Is_Lb=:=_-ba}');
    Expect(1, 121482, '\p{Is_Lb=ba}', "");
    Expect(0, 121482, '\p{^Is_Lb=ba}', "");
    Expect(0, 121482, '\P{Is_Lb=ba}', "");
    Expect(1, 121482, '\P{^Is_Lb=ba}', "");
    Expect(0, 121483, '\p{Is_Lb=ba}', "");
    Expect(1, 121483, '\p{^Is_Lb=ba}', "");
    Expect(1, 121483, '\P{Is_Lb=ba}', "");
    Expect(0, 121483, '\P{^Is_Lb=ba}', "");
    Expect(1, 121482, '\p{Is_Lb= 	BA}', "");
    Expect(0, 121482, '\p{^Is_Lb= 	BA}', "");
    Expect(0, 121482, '\P{Is_Lb= 	BA}', "");
    Expect(1, 121482, '\P{^Is_Lb= 	BA}', "");
    Expect(0, 121483, '\p{Is_Lb= 	BA}', "");
    Expect(1, 121483, '\p{^Is_Lb= 	BA}', "");
    Expect(1, 121483, '\P{Is_Lb= 	BA}', "");
    Expect(0, 121483, '\P{^Is_Lb= 	BA}', "");
    Error('\p{Line_Break= /a/Break_before}');
    Error('\P{Line_Break= /a/Break_before}');
    Expect(1, 72816, '\p{Line_Break=:\ABreak_Before\z:}', "");;
    Expect(0, 72817, '\p{Line_Break=:\ABreak_Before\z:}', "");;
    Expect(1, 72816, '\p{Line_Break=breakbefore}', "");
    Expect(0, 72816, '\p{^Line_Break=breakbefore}', "");
    Expect(0, 72816, '\P{Line_Break=breakbefore}', "");
    Expect(1, 72816, '\P{^Line_Break=breakbefore}', "");
    Expect(0, 72817, '\p{Line_Break=breakbefore}', "");
    Expect(1, 72817, '\p{^Line_Break=breakbefore}', "");
    Expect(1, 72817, '\P{Line_Break=breakbefore}', "");
    Expect(0, 72817, '\P{^Line_Break=breakbefore}', "");
    Expect(1, 72816, '\p{Line_Break=:\Abreakbefore\z:}', "");;
    Expect(0, 72817, '\p{Line_Break=:\Abreakbefore\z:}', "");;
    Expect(1, 72816, '\p{Line_Break=	-Break_BEFORE}', "");
    Expect(0, 72816, '\p{^Line_Break=	-Break_BEFORE}', "");
    Expect(0, 72816, '\P{Line_Break=	-Break_BEFORE}', "");
    Expect(1, 72816, '\P{^Line_Break=	-Break_BEFORE}', "");
    Expect(0, 72817, '\p{Line_Break=	-Break_BEFORE}', "");
    Expect(1, 72817, '\p{^Line_Break=	-Break_BEFORE}', "");
    Expect(1, 72817, '\P{Line_Break=	-Break_BEFORE}', "");
    Expect(0, 72817, '\P{^Line_Break=	-Break_BEFORE}', "");
    Error('\p{Lb=	/a/bb}');
    Error('\P{Lb=	/a/bb}');
    Expect(1, 72816, '\p{Lb=:\ABB\z:}', "");;
    Expect(0, 72817, '\p{Lb=:\ABB\z:}', "");;
    Expect(1, 72816, '\p{Lb=bb}', "");
    Expect(0, 72816, '\p{^Lb=bb}', "");
    Expect(0, 72816, '\P{Lb=bb}', "");
    Expect(1, 72816, '\P{^Lb=bb}', "");
    Expect(0, 72817, '\p{Lb=bb}', "");
    Expect(1, 72817, '\p{^Lb=bb}', "");
    Expect(1, 72817, '\P{Lb=bb}', "");
    Expect(0, 72817, '\P{^Lb=bb}', "");
    Expect(1, 72816, '\p{Lb=:\Abb\z:}', "");;
    Expect(0, 72817, '\p{Lb=:\Abb\z:}', "");;
    Expect(1, 72816, '\p{Lb=_BB}', "");
    Expect(0, 72816, '\p{^Lb=_BB}', "");
    Expect(0, 72816, '\P{Lb=_BB}', "");
    Expect(1, 72816, '\P{^Lb=_BB}', "");
    Expect(0, 72817, '\p{Lb=_BB}', "");
    Expect(1, 72817, '\p{^Lb=_BB}', "");
    Expect(1, 72817, '\P{Lb=_BB}', "");
    Expect(0, 72817, '\P{^Lb=_BB}', "");
    Error('\p{Is_Line_Break=- Break_Before/a/}');
    Error('\P{Is_Line_Break=- Break_Before/a/}');
    Expect(1, 72816, '\p{Is_Line_Break=breakbefore}', "");
    Expect(0, 72816, '\p{^Is_Line_Break=breakbefore}', "");
    Expect(0, 72816, '\P{Is_Line_Break=breakbefore}', "");
    Expect(1, 72816, '\P{^Is_Line_Break=breakbefore}', "");
    Expect(0, 72817, '\p{Is_Line_Break=breakbefore}', "");
    Expect(1, 72817, '\p{^Is_Line_Break=breakbefore}', "");
    Expect(1, 72817, '\P{Is_Line_Break=breakbefore}', "");
    Expect(0, 72817, '\P{^Is_Line_Break=breakbefore}', "");
    Expect(1, 72816, '\p{Is_Line_Break=-	Break_Before}', "");
    Expect(0, 72816, '\p{^Is_Line_Break=-	Break_Before}', "");
    Expect(0, 72816, '\P{Is_Line_Break=-	Break_Before}', "");
    Expect(1, 72816, '\P{^Is_Line_Break=-	Break_Before}', "");
    Expect(0, 72817, '\p{Is_Line_Break=-	Break_Before}', "");
    Expect(1, 72817, '\p{^Is_Line_Break=-	Break_Before}', "");
    Expect(1, 72817, '\P{Is_Line_Break=-	Break_Before}', "");
    Expect(0, 72817, '\P{^Is_Line_Break=-	Break_Before}', "");
    Error('\p{Is_Lb=/a/BB}');
    Error('\P{Is_Lb=/a/BB}');
    Expect(1, 72816, '\p{Is_Lb=bb}', "");
    Expect(0, 72816, '\p{^Is_Lb=bb}', "");
    Expect(0, 72816, '\P{Is_Lb=bb}', "");
    Expect(1, 72816, '\P{^Is_Lb=bb}', "");
    Expect(0, 72817, '\p{Is_Lb=bb}', "");
    Expect(1, 72817, '\p{^Is_Lb=bb}', "");
    Expect(1, 72817, '\P{Is_Lb=bb}', "");
    Expect(0, 72817, '\P{^Is_Lb=bb}', "");
    Expect(1, 72816, '\p{Is_Lb= BB}', "");
    Expect(0, 72816, '\p{^Is_Lb= BB}', "");
    Expect(0, 72816, '\P{Is_Lb= BB}', "");
    Expect(1, 72816, '\P{^Is_Lb= BB}', "");
    Expect(0, 72817, '\p{Is_Lb= BB}', "");
    Expect(1, 72817, '\p{^Is_Lb= BB}', "");
    Expect(1, 72817, '\P{Is_Lb= BB}', "");
    Expect(0, 72817, '\P{^Is_Lb= BB}', "");
    Error('\p{Line_Break= MANDATORY_break/a/}');
    Error('\P{Line_Break= MANDATORY_break/a/}');
    Expect(1, 8233, '\p{Line_Break=:\AMandatory_Break\z:}', "");;
    Expect(0, 8234, '\p{Line_Break=:\AMandatory_Break\z:}', "");;
    Expect(1, 8233, '\p{Line_Break=mandatorybreak}', "");
    Expect(0, 8233, '\p{^Line_Break=mandatorybreak}', "");
    Expect(0, 8233, '\P{Line_Break=mandatorybreak}', "");
    Expect(1, 8233, '\P{^Line_Break=mandatorybreak}', "");
    Expect(0, 8234, '\p{Line_Break=mandatorybreak}', "");
    Expect(1, 8234, '\p{^Line_Break=mandatorybreak}', "");
    Expect(1, 8234, '\P{Line_Break=mandatorybreak}', "");
    Expect(0, 8234, '\P{^Line_Break=mandatorybreak}', "");
    Expect(1, 8233, '\p{Line_Break=:\Amandatorybreak\z:}', "");;
    Expect(0, 8234, '\p{Line_Break=:\Amandatorybreak\z:}', "");;
    Expect(1, 8233, '\p{Line_Break=_mandatory_Break}', "");
    Expect(0, 8233, '\p{^Line_Break=_mandatory_Break}', "");
    Expect(0, 8233, '\P{Line_Break=_mandatory_Break}', "");
    Expect(1, 8233, '\P{^Line_Break=_mandatory_Break}', "");
    Expect(0, 8234, '\p{Line_Break=_mandatory_Break}', "");
    Expect(1, 8234, '\p{^Line_Break=_mandatory_Break}', "");
    Expect(1, 8234, '\P{Line_Break=_mandatory_Break}', "");
    Expect(0, 8234, '\P{^Line_Break=_mandatory_Break}', "");
    Error('\p{Lb=-/a/BK}');
    Error('\P{Lb=-/a/BK}');
    Expect(1, 8233, '\p{Lb=:\ABK\z:}', "");;
    Expect(0, 8234, '\p{Lb=:\ABK\z:}', "");;
    Expect(1, 8233, '\p{Lb=bk}', "");
    Expect(0, 8233, '\p{^Lb=bk}', "");
    Expect(0, 8233, '\P{Lb=bk}', "");
    Expect(1, 8233, '\P{^Lb=bk}', "");
    Expect(0, 8234, '\p{Lb=bk}', "");
    Expect(1, 8234, '\p{^Lb=bk}', "");
    Expect(1, 8234, '\P{Lb=bk}', "");
    Expect(0, 8234, '\P{^Lb=bk}', "");
    Expect(1, 8233, '\p{Lb=:\Abk\z:}', "");;
    Expect(0, 8234, '\p{Lb=:\Abk\z:}', "");;
    Expect(1, 8233, '\p{Lb= _BK}', "");
    Expect(0, 8233, '\p{^Lb= _BK}', "");
    Expect(0, 8233, '\P{Lb= _BK}', "");
    Expect(1, 8233, '\P{^Lb= _BK}', "");
    Expect(0, 8234, '\p{Lb= _BK}', "");
    Expect(1, 8234, '\p{^Lb= _BK}', "");
    Expect(1, 8234, '\P{Lb= _BK}', "");
    Expect(0, 8234, '\P{^Lb= _BK}', "");
    Error('\p{Is_Line_Break=:=		MANDATORY_break}');
    Error('\P{Is_Line_Break=:=		MANDATORY_break}');
    Expect(1, 8233, '\p{Is_Line_Break=mandatorybreak}', "");
    Expect(0, 8233, '\p{^Is_Line_Break=mandatorybreak}', "");
    Expect(0, 8233, '\P{Is_Line_Break=mandatorybreak}', "");
    Expect(1, 8233, '\P{^Is_Line_Break=mandatorybreak}', "");
    Expect(0, 8234, '\p{Is_Line_Break=mandatorybreak}', "");
    Expect(1, 8234, '\p{^Is_Line_Break=mandatorybreak}', "");
    Expect(1, 8234, '\P{Is_Line_Break=mandatorybreak}', "");
    Expect(0, 8234, '\P{^Is_Line_Break=mandatorybreak}', "");
    Expect(1, 8233, '\p{Is_Line_Break=-mandatory_Break}', "");
    Expect(0, 8233, '\p{^Is_Line_Break=-mandatory_Break}', "");
    Expect(0, 8233, '\P{Is_Line_Break=-mandatory_Break}', "");
    Expect(1, 8233, '\P{^Is_Line_Break=-mandatory_Break}', "");
    Expect(0, 8234, '\p{Is_Line_Break=-mandatory_Break}', "");
    Expect(1, 8234, '\p{^Is_Line_Break=-mandatory_Break}', "");
    Expect(1, 8234, '\P{Is_Line_Break=-mandatory_Break}', "");
    Expect(0, 8234, '\P{^Is_Line_Break=-mandatory_Break}', "");
    Error('\p{Is_Lb=/a/	BK}');
    Error('\P{Is_Lb=/a/	BK}');
    Expect(1, 8233, '\p{Is_Lb=bk}', "");
    Expect(0, 8233, '\p{^Is_Lb=bk}', "");
    Expect(0, 8233, '\P{Is_Lb=bk}', "");
    Expect(1, 8233, '\P{^Is_Lb=bk}', "");
    Expect(0, 8234, '\p{Is_Lb=bk}', "");
    Expect(1, 8234, '\p{^Is_Lb=bk}', "");
    Expect(1, 8234, '\P{Is_Lb=bk}', "");
    Expect(0, 8234, '\P{^Is_Lb=bk}', "");
    Expect(1, 8233, '\p{Is_Lb=--BK}', "");
    Expect(0, 8233, '\p{^Is_Lb=--BK}', "");
    Expect(0, 8233, '\P{Is_Lb=--BK}', "");
    Expect(1, 8233, '\P{^Is_Lb=--BK}', "");
    Expect(0, 8234, '\p{Is_Lb=--BK}', "");
    Expect(1, 8234, '\p{^Is_Lb=--BK}', "");
    Expect(1, 8234, '\P{Is_Lb=--BK}', "");
    Expect(0, 8234, '\P{^Is_Lb=--BK}', "");
    Error('\p{Line_Break= _CONTINGENT_Break:=}');
    Error('\P{Line_Break= _CONTINGENT_Break:=}');
    Expect(1, 65532, '\p{Line_Break=:\AContingent_Break\z:}', "");;
    Expect(0, 65533, '\p{Line_Break=:\AContingent_Break\z:}', "");;
    Expect(1, 65532, '\p{Line_Break: contingentbreak}', "");
    Expect(0, 65532, '\p{^Line_Break: contingentbreak}', "");
    Expect(0, 65532, '\P{Line_Break: contingentbreak}', "");
    Expect(1, 65532, '\P{^Line_Break: contingentbreak}', "");
    Expect(0, 65533, '\p{Line_Break: contingentbreak}', "");
    Expect(1, 65533, '\p{^Line_Break: contingentbreak}', "");
    Expect(1, 65533, '\P{Line_Break: contingentbreak}', "");
    Expect(0, 65533, '\P{^Line_Break: contingentbreak}', "");
    Expect(1, 65532, '\p{Line_Break=:\Acontingentbreak\z:}', "");;
    Expect(0, 65533, '\p{Line_Break=:\Acontingentbreak\z:}', "");;
    Expect(1, 65532, '\p{Line_Break= Contingent_Break}', "");
    Expect(0, 65532, '\p{^Line_Break= Contingent_Break}', "");
    Expect(0, 65532, '\P{Line_Break= Contingent_Break}', "");
    Expect(1, 65532, '\P{^Line_Break= Contingent_Break}', "");
    Expect(0, 65533, '\p{Line_Break= Contingent_Break}', "");
    Expect(1, 65533, '\p{^Line_Break= Contingent_Break}', "");
    Expect(1, 65533, '\P{Line_Break= Contingent_Break}', "");
    Expect(0, 65533, '\P{^Line_Break= Contingent_Break}', "");
    Error('\p{Lb= /a/CB}');
    Error('\P{Lb= /a/CB}');
    Expect(1, 65532, '\p{Lb=:\ACB\z:}', "");;
    Expect(0, 65533, '\p{Lb=:\ACB\z:}', "");;
    Expect(1, 65532, '\p{Lb=cb}', "");
    Expect(0, 65532, '\p{^Lb=cb}', "");
    Expect(0, 65532, '\P{Lb=cb}', "");
    Expect(1, 65532, '\P{^Lb=cb}', "");
    Expect(0, 65533, '\p{Lb=cb}', "");
    Expect(1, 65533, '\p{^Lb=cb}', "");
    Expect(1, 65533, '\P{Lb=cb}', "");
    Expect(0, 65533, '\P{^Lb=cb}', "");
    Expect(1, 65532, '\p{Lb=:\Acb\z:}', "");;
    Expect(0, 65533, '\p{Lb=:\Acb\z:}', "");;
    Expect(1, 65532, '\p{Lb=	_cb}', "");
    Expect(0, 65532, '\p{^Lb=	_cb}', "");
    Expect(0, 65532, '\P{Lb=	_cb}', "");
    Expect(1, 65532, '\P{^Lb=	_cb}', "");
    Expect(0, 65533, '\p{Lb=	_cb}', "");
    Expect(1, 65533, '\p{^Lb=	_cb}', "");
    Expect(1, 65533, '\P{Lb=	_cb}', "");
    Expect(0, 65533, '\P{^Lb=	_cb}', "");
    Error('\p{Is_Line_Break=/a/ _Contingent_Break}');
    Error('\P{Is_Line_Break=/a/ _Contingent_Break}');
    Expect(1, 65532, '\p{Is_Line_Break=contingentbreak}', "");
    Expect(0, 65532, '\p{^Is_Line_Break=contingentbreak}', "");
    Expect(0, 65532, '\P{Is_Line_Break=contingentbreak}', "");
    Expect(1, 65532, '\P{^Is_Line_Break=contingentbreak}', "");
    Expect(0, 65533, '\p{Is_Line_Break=contingentbreak}', "");
    Expect(1, 65533, '\p{^Is_Line_Break=contingentbreak}', "");
    Expect(1, 65533, '\P{Is_Line_Break=contingentbreak}', "");
    Expect(0, 65533, '\P{^Is_Line_Break=contingentbreak}', "");
    Expect(1, 65532, '\p{Is_Line_Break=	CONTINGENT_break}', "");
    Expect(0, 65532, '\p{^Is_Line_Break=	CONTINGENT_break}', "");
    Expect(0, 65532, '\P{Is_Line_Break=	CONTINGENT_break}', "");
    Expect(1, 65532, '\P{^Is_Line_Break=	CONTINGENT_break}', "");
    Expect(0, 65533, '\p{Is_Line_Break=	CONTINGENT_break}', "");
    Expect(1, 65533, '\p{^Is_Line_Break=	CONTINGENT_break}', "");
    Expect(1, 65533, '\P{Is_Line_Break=	CONTINGENT_break}', "");
    Expect(0, 65533, '\P{^Is_Line_Break=	CONTINGENT_break}', "");
    Error('\p{Is_Lb=	_cb:=}');
    Error('\P{Is_Lb=	_cb:=}');
    Expect(1, 65532, '\p{Is_Lb: cb}', "");
    Expect(0, 65532, '\p{^Is_Lb: cb}', "");
    Expect(0, 65532, '\P{Is_Lb: cb}', "");
    Expect(1, 65532, '\P{^Is_Lb: cb}', "");
    Expect(0, 65533, '\p{Is_Lb: cb}', "");
    Expect(1, 65533, '\p{^Is_Lb: cb}', "");
    Expect(1, 65533, '\P{Is_Lb: cb}', "");
    Expect(0, 65533, '\P{^Is_Lb: cb}', "");
    Expect(1, 65532, '\p{Is_Lb=__cb}', "");
    Expect(0, 65532, '\p{^Is_Lb=__cb}', "");
    Expect(0, 65532, '\P{Is_Lb=__cb}', "");
    Expect(1, 65532, '\P{^Is_Lb=__cb}', "");
    Expect(0, 65533, '\p{Is_Lb=__cb}', "");
    Expect(1, 65533, '\p{^Is_Lb=__cb}', "");
    Expect(1, 65533, '\P{Is_Lb=__cb}', "");
    Expect(0, 65533, '\P{^Is_Lb=__cb}', "");
    Error('\p{Line_Break=--Conditional_japanese_starter/a/}');
    Error('\P{Line_Break=--Conditional_japanese_starter/a/}');
    Expect(1, 110951, '\p{Line_Break=:\AConditional_Japanese_Starter\z:}', "");;
    Expect(0, 110952, '\p{Line_Break=:\AConditional_Japanese_Starter\z:}', "");;
    Expect(1, 110951, '\p{Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 110951, '\p{^Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 110951, '\P{Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 110951, '\P{^Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 110952, '\p{Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 110952, '\p{^Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 110952, '\P{Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 110952, '\P{^Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 110951, '\p{Line_Break=:\Aconditionaljapanesestarter\z:}', "");;
    Expect(0, 110952, '\p{Line_Break=:\Aconditionaljapanesestarter\z:}', "");;
    Expect(1, 110951, '\p{Line_Break=--conditional_Japanese_STARTER}', "");
    Expect(0, 110951, '\p{^Line_Break=--conditional_Japanese_STARTER}', "");
    Expect(0, 110951, '\P{Line_Break=--conditional_Japanese_STARTER}', "");
    Expect(1, 110951, '\P{^Line_Break=--conditional_Japanese_STARTER}', "");
    Expect(0, 110952, '\p{Line_Break=--conditional_Japanese_STARTER}', "");
    Expect(1, 110952, '\p{^Line_Break=--conditional_Japanese_STARTER}', "");
    Expect(1, 110952, '\P{Line_Break=--conditional_Japanese_STARTER}', "");
    Expect(0, 110952, '\P{^Line_Break=--conditional_Japanese_STARTER}', "");
    Error('\p{Lb:   /a/CJ}');
    Error('\P{Lb:   /a/CJ}');
    Expect(1, 110951, '\p{Lb=:\ACJ\z:}', "");;
    Expect(0, 110952, '\p{Lb=:\ACJ\z:}', "");;
    Expect(1, 110951, '\p{Lb=cj}', "");
    Expect(0, 110951, '\p{^Lb=cj}', "");
    Expect(0, 110951, '\P{Lb=cj}', "");
    Expect(1, 110951, '\P{^Lb=cj}', "");
    Expect(0, 110952, '\p{Lb=cj}', "");
    Expect(1, 110952, '\p{^Lb=cj}', "");
    Expect(1, 110952, '\P{Lb=cj}', "");
    Expect(0, 110952, '\P{^Lb=cj}', "");
    Expect(1, 110951, '\p{Lb=:\Acj\z:}', "");;
    Expect(0, 110952, '\p{Lb=:\Acj\z:}', "");;
    Expect(1, 110951, '\p{Lb=_	CJ}', "");
    Expect(0, 110951, '\p{^Lb=_	CJ}', "");
    Expect(0, 110951, '\P{Lb=_	CJ}', "");
    Expect(1, 110951, '\P{^Lb=_	CJ}', "");
    Expect(0, 110952, '\p{Lb=_	CJ}', "");
    Expect(1, 110952, '\p{^Lb=_	CJ}', "");
    Expect(1, 110952, '\P{Lb=_	CJ}', "");
    Expect(0, 110952, '\P{^Lb=_	CJ}', "");
    Error('\p{Is_Line_Break=	CONDITIONAL_Japanese_Starter/a/}');
    Error('\P{Is_Line_Break=	CONDITIONAL_Japanese_Starter/a/}');
    Expect(1, 110951, '\p{Is_Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 110951, '\p{^Is_Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 110951, '\P{Is_Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 110951, '\P{^Is_Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 110952, '\p{Is_Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 110952, '\p{^Is_Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 110952, '\P{Is_Line_Break=conditionaljapanesestarter}', "");
    Expect(0, 110952, '\P{^Is_Line_Break=conditionaljapanesestarter}', "");
    Expect(1, 110951, '\p{Is_Line_Break=_-Conditional_JAPANESE_STARTER}', "");
    Expect(0, 110951, '\p{^Is_Line_Break=_-Conditional_JAPANESE_STARTER}', "");
    Expect(0, 110951, '\P{Is_Line_Break=_-Conditional_JAPANESE_STARTER}', "");
    Expect(1, 110951, '\P{^Is_Line_Break=_-Conditional_JAPANESE_STARTER}', "");
    Expect(0, 110952, '\p{Is_Line_Break=_-Conditional_JAPANESE_STARTER}', "");
    Expect(1, 110952, '\p{^Is_Line_Break=_-Conditional_JAPANESE_STARTER}', "");
    Expect(1, 110952, '\P{Is_Line_Break=_-Conditional_JAPANESE_STARTER}', "");
    Expect(0, 110952, '\P{^Is_Line_Break=_-Conditional_JAPANESE_STARTER}', "");
    Error('\p{Is_Lb=	-cj/a/}');
    Error('\P{Is_Lb=	-cj/a/}');
    Expect(1, 110951, '\p{Is_Lb=cj}', "");
    Expect(0, 110951, '\p{^Is_Lb=cj}', "");
    Expect(0, 110951, '\P{Is_Lb=cj}', "");
    Expect(1, 110951, '\P{^Is_Lb=cj}', "");
    Expect(0, 110952, '\p{Is_Lb=cj}', "");
    Expect(1, 110952, '\p{^Is_Lb=cj}', "");
    Expect(1, 110952, '\P{Is_Lb=cj}', "");
    Expect(0, 110952, '\P{^Is_Lb=cj}', "");
    Expect(1, 110951, '\p{Is_Lb=CJ}', "");
    Expect(0, 110951, '\p{^Is_Lb=CJ}', "");
    Expect(0, 110951, '\P{Is_Lb=CJ}', "");
    Expect(1, 110951, '\P{^Is_Lb=CJ}', "");
    Expect(0, 110952, '\p{Is_Lb=CJ}', "");
    Expect(1, 110952, '\p{^Is_Lb=CJ}', "");
    Expect(1, 110952, '\P{Is_Lb=CJ}', "");
    Expect(0, 110952, '\P{^Is_Lb=CJ}', "");
    Error('\p{Line_Break=-CLOSE_Punctuation/a/}');
    Error('\P{Line_Break=-CLOSE_Punctuation/a/}');
    Expect(1, 83407, '\p{Line_Break=:\AClose_Punctuation\z:}', "");;
    Expect(0, 83408, '\p{Line_Break=:\AClose_Punctuation\z:}', "");;
    Expect(1, 83407, '\p{Line_Break=closepunctuation}', "");
    Expect(0, 83407, '\p{^Line_Break=closepunctuation}', "");
    Expect(0, 83407, '\P{Line_Break=closepunctuation}', "");
    Expect(1, 83407, '\P{^Line_Break=closepunctuation}', "");
    Expect(0, 83408, '\p{Line_Break=closepunctuation}', "");
    Expect(1, 83408, '\p{^Line_Break=closepunctuation}', "");
    Expect(1, 83408, '\P{Line_Break=closepunctuation}', "");
    Expect(0, 83408, '\P{^Line_Break=closepunctuation}', "");
    Expect(1, 83407, '\p{Line_Break=:\Aclosepunctuation\z:}', "");;
    Expect(0, 83408, '\p{Line_Break=:\Aclosepunctuation\z:}', "");;
    Expect(1, 83407, '\p{Line_Break= _CLOSE_PUNCTUATION}', "");
    Expect(0, 83407, '\p{^Line_Break= _CLOSE_PUNCTUATION}', "");
    Expect(0, 83407, '\P{Line_Break= _CLOSE_PUNCTUATION}', "");
    Expect(1, 83407, '\P{^Line_Break= _CLOSE_PUNCTUATION}', "");
    Expect(0, 83408, '\p{Line_Break= _CLOSE_PUNCTUATION}', "");
    Expect(1, 83408, '\p{^Line_Break= _CLOSE_PUNCTUATION}', "");
    Expect(1, 83408, '\P{Line_Break= _CLOSE_PUNCTUATION}', "");
    Expect(0, 83408, '\P{^Line_Break= _CLOSE_PUNCTUATION}', "");
    Error('\p{Lb=/a/-cl}');
    Error('\P{Lb=/a/-cl}');
    Expect(1, 83407, '\p{Lb=:\ACL\z:}', "");;
    Expect(0, 83408, '\p{Lb=:\ACL\z:}', "");;
    Expect(1, 83407, '\p{Lb=cl}', "");
    Expect(0, 83407, '\p{^Lb=cl}', "");
    Expect(0, 83407, '\P{Lb=cl}', "");
    Expect(1, 83407, '\P{^Lb=cl}', "");
    Expect(0, 83408, '\p{Lb=cl}', "");
    Expect(1, 83408, '\p{^Lb=cl}', "");
    Expect(1, 83408, '\P{Lb=cl}', "");
    Expect(0, 83408, '\P{^Lb=cl}', "");
    Expect(1, 83407, '\p{Lb=:\Acl\z:}', "");;
    Expect(0, 83408, '\p{Lb=:\Acl\z:}', "");;
    Expect(1, 83407, '\p{Lb=- CL}', "");
    Expect(0, 83407, '\p{^Lb=- CL}', "");
    Expect(0, 83407, '\P{Lb=- CL}', "");
    Expect(1, 83407, '\P{^Lb=- CL}', "");
    Expect(0, 83408, '\p{Lb=- CL}', "");
    Expect(1, 83408, '\p{^Lb=- CL}', "");
    Expect(1, 83408, '\P{Lb=- CL}', "");
    Expect(0, 83408, '\P{^Lb=- CL}', "");
    Error('\p{Is_Line_Break=/a/-CLOSE_Punctuation}');
    Error('\P{Is_Line_Break=/a/-CLOSE_Punctuation}');
    Expect(1, 83407, '\p{Is_Line_Break=closepunctuation}', "");
    Expect(0, 83407, '\p{^Is_Line_Break=closepunctuation}', "");
    Expect(0, 83407, '\P{Is_Line_Break=closepunctuation}', "");
    Expect(1, 83407, '\P{^Is_Line_Break=closepunctuation}', "");
    Expect(0, 83408, '\p{Is_Line_Break=closepunctuation}', "");
    Expect(1, 83408, '\p{^Is_Line_Break=closepunctuation}', "");
    Expect(1, 83408, '\P{Is_Line_Break=closepunctuation}', "");
    Expect(0, 83408, '\P{^Is_Line_Break=closepunctuation}', "");
    Expect(1, 83407, '\p{Is_Line_Break=	_Close_Punctuation}', "");
    Expect(0, 83407, '\p{^Is_Line_Break=	_Close_Punctuation}', "");
    Expect(0, 83407, '\P{Is_Line_Break=	_Close_Punctuation}', "");
    Expect(1, 83407, '\P{^Is_Line_Break=	_Close_Punctuation}', "");
    Expect(0, 83408, '\p{Is_Line_Break=	_Close_Punctuation}', "");
    Expect(1, 83408, '\p{^Is_Line_Break=	_Close_Punctuation}', "");
    Expect(1, 83408, '\P{Is_Line_Break=	_Close_Punctuation}', "");
    Expect(0, 83408, '\P{^Is_Line_Break=	_Close_Punctuation}', "");
    Error('\p{Is_Lb= -cl/a/}');
    Error('\P{Is_Lb= -cl/a/}');
    Expect(1, 83407, '\p{Is_Lb=cl}', "");
    Expect(0, 83407, '\p{^Is_Lb=cl}', "");
    Expect(0, 83407, '\P{Is_Lb=cl}', "");
    Expect(1, 83407, '\P{^Is_Lb=cl}', "");
    Expect(0, 83408, '\p{Is_Lb=cl}', "");
    Expect(1, 83408, '\p{^Is_Lb=cl}', "");
    Expect(1, 83408, '\P{Is_Lb=cl}', "");
    Expect(0, 83408, '\P{^Is_Lb=cl}', "");
    Expect(1, 83407, '\p{Is_Lb=-_cl}', "");
    Expect(0, 83407, '\p{^Is_Lb=-_cl}', "");
    Expect(0, 83407, '\P{Is_Lb=-_cl}', "");
    Expect(1, 83407, '\P{^Is_Lb=-_cl}', "");
    Expect(0, 83408, '\p{Is_Lb=-_cl}', "");
    Expect(1, 83408, '\p{^Is_Lb=-_cl}', "");
    Expect(1, 83408, '\P{Is_Lb=-_cl}', "");
    Expect(0, 83408, '\P{^Is_Lb=-_cl}', "");
    Error('\p{Line_Break=	 Combining_Mark/a/}');
    Error('\P{Line_Break=	 Combining_Mark/a/}');
    Expect(1, 917999, '\p{Line_Break=:\ACombining_Mark\z:}', "");;
    Expect(0, 918000, '\p{Line_Break=:\ACombining_Mark\z:}', "");;
    Expect(1, 917999, '\p{Line_Break:combiningmark}', "");
    Expect(0, 917999, '\p{^Line_Break:combiningmark}', "");
    Expect(0, 917999, '\P{Line_Break:combiningmark}', "");
    Expect(1, 917999, '\P{^Line_Break:combiningmark}', "");
    Expect(0, 918000, '\p{Line_Break:combiningmark}', "");
    Expect(1, 918000, '\p{^Line_Break:combiningmark}', "");
    Expect(1, 918000, '\P{Line_Break:combiningmark}', "");
    Expect(0, 918000, '\P{^Line_Break:combiningmark}', "");
    Expect(1, 917999, '\p{Line_Break=:\Acombiningmark\z:}', "");;
    Expect(0, 918000, '\p{Line_Break=:\Acombiningmark\z:}', "");;
    Expect(1, 917999, '\p{Line_Break=	-COMBINING_mark}', "");
    Expect(0, 917999, '\p{^Line_Break=	-COMBINING_mark}', "");
    Expect(0, 917999, '\P{Line_Break=	-COMBINING_mark}', "");
    Expect(1, 917999, '\P{^Line_Break=	-COMBINING_mark}', "");
    Expect(0, 918000, '\p{Line_Break=	-COMBINING_mark}', "");
    Expect(1, 918000, '\p{^Line_Break=	-COMBINING_mark}', "");
    Expect(1, 918000, '\P{Line_Break=	-COMBINING_mark}', "");
    Expect(0, 918000, '\P{^Line_Break=	-COMBINING_mark}', "");
    Error('\p{Lb= 	CM:=}');
    Error('\P{Lb= 	CM:=}');
    Expect(1, 917999, '\p{Lb=:\ACM\z:}', "");;
    Expect(0, 918000, '\p{Lb=:\ACM\z:}', "");;
    Expect(1, 917999, '\p{Lb=cm}', "");
    Expect(0, 917999, '\p{^Lb=cm}', "");
    Expect(0, 917999, '\P{Lb=cm}', "");
    Expect(1, 917999, '\P{^Lb=cm}', "");
    Expect(0, 918000, '\p{Lb=cm}', "");
    Expect(1, 918000, '\p{^Lb=cm}', "");
    Expect(1, 918000, '\P{Lb=cm}', "");
    Expect(0, 918000, '\P{^Lb=cm}', "");
    Expect(1, 917999, '\p{Lb=:\Acm\z:}', "");;
    Expect(0, 918000, '\p{Lb=:\Acm\z:}', "");;
    Expect(1, 917999, '\p{Lb= 	CM}', "");
    Expect(0, 917999, '\p{^Lb= 	CM}', "");
    Expect(0, 917999, '\P{Lb= 	CM}', "");
    Expect(1, 917999, '\P{^Lb= 	CM}', "");
    Expect(0, 918000, '\p{Lb= 	CM}', "");
    Expect(1, 918000, '\p{^Lb= 	CM}', "");
    Expect(1, 918000, '\P{Lb= 	CM}', "");
    Expect(0, 918000, '\P{^Lb= 	CM}', "");
    Error('\p{Is_Line_Break=/a/COMBINING_Mark}');
    Error('\P{Is_Line_Break=/a/COMBINING_Mark}');
    Expect(1, 917999, '\p{Is_Line_Break=combiningmark}', "");
    Expect(0, 917999, '\p{^Is_Line_Break=combiningmark}', "");
    Expect(0, 917999, '\P{Is_Line_Break=combiningmark}', "");
    Expect(1, 917999, '\P{^Is_Line_Break=combiningmark}', "");
    Expect(0, 918000, '\p{Is_Line_Break=combiningmark}', "");
    Expect(1, 918000, '\p{^Is_Line_Break=combiningmark}', "");
    Expect(1, 918000, '\P{Is_Line_Break=combiningmark}', "");
    Expect(0, 918000, '\P{^Is_Line_Break=combiningmark}', "");
    Expect(1, 917999, '\p{Is_Line_Break=_	Combining_Mark}', "");
    Expect(0, 917999, '\p{^Is_Line_Break=_	Combining_Mark}', "");
    Expect(0, 917999, '\P{Is_Line_Break=_	Combining_Mark}', "");
    Expect(1, 917999, '\P{^Is_Line_Break=_	Combining_Mark}', "");
    Expect(0, 918000, '\p{Is_Line_Break=_	Combining_Mark}', "");
    Expect(1, 918000, '\p{^Is_Line_Break=_	Combining_Mark}', "");
    Expect(1, 918000, '\P{Is_Line_Break=_	Combining_Mark}', "");
    Expect(0, 918000, '\P{^Is_Line_Break=_	Combining_Mark}', "");
    Error('\p{Is_Lb=	-CM:=}');
    Error('\P{Is_Lb=	-CM:=}');
    Expect(1, 917999, '\p{Is_Lb=cm}', "");
    Expect(0, 917999, '\p{^Is_Lb=cm}', "");
    Expect(0, 917999, '\P{Is_Lb=cm}', "");
    Expect(1, 917999, '\P{^Is_Lb=cm}', "");
    Expect(0, 918000, '\p{Is_Lb=cm}', "");
    Expect(1, 918000, '\p{^Is_Lb=cm}', "");
    Expect(1, 918000, '\P{Is_Lb=cm}', "");
    Expect(0, 918000, '\P{^Is_Lb=cm}', "");
    Expect(1, 917999, '\p{Is_Lb=-cm}', "");
    Expect(0, 917999, '\p{^Is_Lb=-cm}', "");
    Expect(0, 917999, '\P{Is_Lb=-cm}', "");
    Expect(1, 917999, '\P{^Is_Lb=-cm}', "");
    Expect(0, 918000, '\p{Is_Lb=-cm}', "");
    Expect(1, 918000, '\p{^Is_Lb=-cm}', "");
    Expect(1, 918000, '\P{Is_Lb=-cm}', "");
    Expect(0, 918000, '\P{^Is_Lb=-cm}', "");
    Error('\p{Line_Break=/a/Close_Parenthesis}');
    Error('\P{Line_Break=/a/Close_Parenthesis}');
    Expect(1, 93, '\p{Line_Break=:\AClose_Parenthesis\z:}', "");;
    Expect(0, 94, '\p{Line_Break=:\AClose_Parenthesis\z:}', "");;
    Expect(1, 93, '\p{Line_Break=closeparenthesis}', "");
    Expect(0, 93, '\p{^Line_Break=closeparenthesis}', "");
    Expect(0, 93, '\P{Line_Break=closeparenthesis}', "");
    Expect(1, 93, '\P{^Line_Break=closeparenthesis}', "");
    Expect(0, 94, '\p{Line_Break=closeparenthesis}', "");
    Expect(1, 94, '\p{^Line_Break=closeparenthesis}', "");
    Expect(1, 94, '\P{Line_Break=closeparenthesis}', "");
    Expect(0, 94, '\P{^Line_Break=closeparenthesis}', "");
    Expect(1, 93, '\p{Line_Break=:\Acloseparenthesis\z:}', "");;
    Expect(0, 94, '\p{Line_Break=:\Acloseparenthesis\z:}', "");;
    Expect(1, 93, '\p{Line_Break=	Close_PARENTHESIS}', "");
    Expect(0, 93, '\p{^Line_Break=	Close_PARENTHESIS}', "");
    Expect(0, 93, '\P{Line_Break=	Close_PARENTHESIS}', "");
    Expect(1, 93, '\P{^Line_Break=	Close_PARENTHESIS}', "");
    Expect(0, 94, '\p{Line_Break=	Close_PARENTHESIS}', "");
    Expect(1, 94, '\p{^Line_Break=	Close_PARENTHESIS}', "");
    Expect(1, 94, '\P{Line_Break=	Close_PARENTHESIS}', "");
    Expect(0, 94, '\P{^Line_Break=	Close_PARENTHESIS}', "");
    Error('\p{Lb=_:=CP}');
    Error('\P{Lb=_:=CP}');
    Expect(1, 93, '\p{Lb=:\ACP\z:}', "");;
    Expect(0, 94, '\p{Lb=:\ACP\z:}', "");;
    Expect(1, 93, '\p{Lb=cp}', "");
    Expect(0, 93, '\p{^Lb=cp}', "");
    Expect(0, 93, '\P{Lb=cp}', "");
    Expect(1, 93, '\P{^Lb=cp}', "");
    Expect(0, 94, '\p{Lb=cp}', "");
    Expect(1, 94, '\p{^Lb=cp}', "");
    Expect(1, 94, '\P{Lb=cp}', "");
    Expect(0, 94, '\P{^Lb=cp}', "");
    Expect(1, 93, '\p{Lb=:\Acp\z:}', "");;
    Expect(0, 94, '\p{Lb=:\Acp\z:}', "");;
    Expect(1, 93, '\p{Lb= CP}', "");
    Expect(0, 93, '\p{^Lb= CP}', "");
    Expect(0, 93, '\P{Lb= CP}', "");
    Expect(1, 93, '\P{^Lb= CP}', "");
    Expect(0, 94, '\p{Lb= CP}', "");
    Expect(1, 94, '\p{^Lb= CP}', "");
    Expect(1, 94, '\P{Lb= CP}', "");
    Expect(0, 94, '\P{^Lb= CP}', "");
    Error('\p{Is_Line_Break: /a/-_Close_Parenthesis}');
    Error('\P{Is_Line_Break: /a/-_Close_Parenthesis}');
    Expect(1, 93, '\p{Is_Line_Break=closeparenthesis}', "");
    Expect(0, 93, '\p{^Is_Line_Break=closeparenthesis}', "");
    Expect(0, 93, '\P{Is_Line_Break=closeparenthesis}', "");
    Expect(1, 93, '\P{^Is_Line_Break=closeparenthesis}', "");
    Expect(0, 94, '\p{Is_Line_Break=closeparenthesis}', "");
    Expect(1, 94, '\p{^Is_Line_Break=closeparenthesis}', "");
    Expect(1, 94, '\P{Is_Line_Break=closeparenthesis}', "");
    Expect(0, 94, '\P{^Is_Line_Break=closeparenthesis}', "");
    Expect(1, 93, '\p{Is_Line_Break=-	CLOSE_PARENTHESIS}', "");
    Expect(0, 93, '\p{^Is_Line_Break=-	CLOSE_PARENTHESIS}', "");
    Expect(0, 93, '\P{Is_Line_Break=-	CLOSE_PARENTHESIS}', "");
    Expect(1, 93, '\P{^Is_Line_Break=-	CLOSE_PARENTHESIS}', "");
    Expect(0, 94, '\p{Is_Line_Break=-	CLOSE_PARENTHESIS}', "");
    Expect(1, 94, '\p{^Is_Line_Break=-	CLOSE_PARENTHESIS}', "");
    Expect(1, 94, '\P{Is_Line_Break=-	CLOSE_PARENTHESIS}', "");
    Expect(0, 94, '\P{^Is_Line_Break=-	CLOSE_PARENTHESIS}', "");
    Error('\p{Is_Lb=/a/-CP}');
    Error('\P{Is_Lb=/a/-CP}');
    Expect(1, 93, '\p{Is_Lb=cp}', "");
    Expect(0, 93, '\p{^Is_Lb=cp}', "");
    Expect(0, 93, '\P{Is_Lb=cp}', "");
    Expect(1, 93, '\P{^Is_Lb=cp}', "");
    Expect(0, 94, '\p{Is_Lb=cp}', "");
    Expect(1, 94, '\p{^Is_Lb=cp}', "");
    Expect(1, 94, '\P{Is_Lb=cp}', "");
    Expect(0, 94, '\P{^Is_Lb=cp}', "");
    Expect(1, 93, '\p{Is_Lb=	CP}', "");
    Expect(0, 93, '\p{^Is_Lb=	CP}', "");
    Expect(0, 93, '\P{Is_Lb=	CP}', "");
    Expect(1, 93, '\P{^Is_Lb=	CP}', "");
    Expect(0, 94, '\p{Is_Lb=	CP}', "");
    Expect(1, 94, '\p{^Is_Lb=	CP}', "");
    Expect(1, 94, '\P{Is_Lb=	CP}', "");
    Expect(0, 94, '\P{^Is_Lb=	CP}', "");
    Error('\p{Line_Break=_Carriage_Return:=}');
    Error('\P{Line_Break=_Carriage_Return:=}');
    Expect(1, 13, '\p{Line_Break=:\ACarriage_Return\z:}', "");;
    Expect(0, 14, '\p{Line_Break=:\ACarriage_Return\z:}', "");;
    Expect(1, 13, '\p{Line_Break:carriagereturn}', "");
    Expect(0, 13, '\p{^Line_Break:carriagereturn}', "");
    Expect(0, 13, '\P{Line_Break:carriagereturn}', "");
    Expect(1, 13, '\P{^Line_Break:carriagereturn}', "");
    Expect(0, 14, '\p{Line_Break:carriagereturn}', "");
    Expect(1, 14, '\p{^Line_Break:carriagereturn}', "");
    Expect(1, 14, '\P{Line_Break:carriagereturn}', "");
    Expect(0, 14, '\P{^Line_Break:carriagereturn}', "");
    Expect(1, 13, '\p{Line_Break=:\Acarriagereturn\z:}', "");;
    Expect(0, 14, '\p{Line_Break=:\Acarriagereturn\z:}', "");;
    Expect(1, 13, '\p{Line_Break=-_carriage_return}', "");
    Expect(0, 13, '\p{^Line_Break=-_carriage_return}', "");
    Expect(0, 13, '\P{Line_Break=-_carriage_return}', "");
    Expect(1, 13, '\P{^Line_Break=-_carriage_return}', "");
    Expect(0, 14, '\p{Line_Break=-_carriage_return}', "");
    Expect(1, 14, '\p{^Line_Break=-_carriage_return}', "");
    Expect(1, 14, '\P{Line_Break=-_carriage_return}', "");
    Expect(0, 14, '\P{^Line_Break=-_carriage_return}', "");
    Error('\p{Lb=-:=CR}');
    Error('\P{Lb=-:=CR}');
    Expect(1, 13, '\p{Lb=:\ACR\z:}', "");;
    Expect(0, 14, '\p{Lb=:\ACR\z:}', "");;
    Expect(1, 13, '\p{Lb=cr}', "");
    Expect(0, 13, '\p{^Lb=cr}', "");
    Expect(0, 13, '\P{Lb=cr}', "");
    Expect(1, 13, '\P{^Lb=cr}', "");
    Expect(0, 14, '\p{Lb=cr}', "");
    Expect(1, 14, '\p{^Lb=cr}', "");
    Expect(1, 14, '\P{Lb=cr}', "");
    Expect(0, 14, '\P{^Lb=cr}', "");
    Expect(1, 13, '\p{Lb=:\Acr\z:}', "");;
    Expect(0, 14, '\p{Lb=:\Acr\z:}', "");;
    Expect(1, 13, '\p{Lb:   -CR}', "");
    Expect(0, 13, '\p{^Lb:   -CR}', "");
    Expect(0, 13, '\P{Lb:   -CR}', "");
    Expect(1, 13, '\P{^Lb:   -CR}', "");
    Expect(0, 14, '\p{Lb:   -CR}', "");
    Expect(1, 14, '\p{^Lb:   -CR}', "");
    Expect(1, 14, '\P{Lb:   -CR}', "");
    Expect(0, 14, '\P{^Lb:   -CR}', "");
    Error('\p{Is_Line_Break=	:=Carriage_return}');
    Error('\P{Is_Line_Break=	:=Carriage_return}');
    Expect(1, 13, '\p{Is_Line_Break=carriagereturn}', "");
    Expect(0, 13, '\p{^Is_Line_Break=carriagereturn}', "");
    Expect(0, 13, '\P{Is_Line_Break=carriagereturn}', "");
    Expect(1, 13, '\P{^Is_Line_Break=carriagereturn}', "");
    Expect(0, 14, '\p{Is_Line_Break=carriagereturn}', "");
    Expect(1, 14, '\p{^Is_Line_Break=carriagereturn}', "");
    Expect(1, 14, '\P{Is_Line_Break=carriagereturn}', "");
    Expect(0, 14, '\P{^Is_Line_Break=carriagereturn}', "");
    Expect(1, 13, '\p{Is_Line_Break=	_carriage_Return}', "");
    Expect(0, 13, '\p{^Is_Line_Break=	_carriage_Return}', "");
    Expect(0, 13, '\P{Is_Line_Break=	_carriage_Return}', "");
    Expect(1, 13, '\P{^Is_Line_Break=	_carriage_Return}', "");
    Expect(0, 14, '\p{Is_Line_Break=	_carriage_Return}', "");
    Expect(1, 14, '\p{^Is_Line_Break=	_carriage_Return}', "");
    Expect(1, 14, '\P{Is_Line_Break=	_carriage_Return}', "");
    Expect(0, 14, '\P{^Is_Line_Break=	_carriage_Return}', "");
    Error('\p{Is_Lb=/a/ 	cr}');
    Error('\P{Is_Lb=/a/ 	cr}');
    Expect(1, 13, '\p{Is_Lb=cr}', "");
    Expect(0, 13, '\p{^Is_Lb=cr}', "");
    Expect(0, 13, '\P{Is_Lb=cr}', "");
    Expect(1, 13, '\P{^Is_Lb=cr}', "");
    Expect(0, 14, '\p{Is_Lb=cr}', "");
    Expect(1, 14, '\p{^Is_Lb=cr}', "");
    Expect(1, 14, '\P{Is_Lb=cr}', "");
    Expect(0, 14, '\P{^Is_Lb=cr}', "");
    Expect(1, 13, '\p{Is_Lb=	 CR}', "");
    Expect(0, 13, '\p{^Is_Lb=	 CR}', "");
    Expect(0, 13, '\P{Is_Lb=	 CR}', "");
    Expect(1, 13, '\P{^Is_Lb=	 CR}', "");
    Expect(0, 14, '\p{Is_Lb=	 CR}', "");
    Expect(1, 14, '\p{^Is_Lb=	 CR}', "");
    Expect(1, 14, '\P{Is_Lb=	 CR}', "");
    Expect(0, 14, '\P{^Is_Lb=	 CR}', "");
    Error('\p{Line_Break=	 e_base:=}');
    Error('\P{Line_Break=	 e_base:=}');
    Expect(1, 129501, '\p{Line_Break=:\AE_Base\z:}', "");;
    Expect(0, 129502, '\p{Line_Break=:\AE_Base\z:}', "");;
    Expect(1, 129501, '\p{Line_Break=ebase}', "");
    Expect(0, 129501, '\p{^Line_Break=ebase}', "");
    Expect(0, 129501, '\P{Line_Break=ebase}', "");
    Expect(1, 129501, '\P{^Line_Break=ebase}', "");
    Expect(0, 129502, '\p{Line_Break=ebase}', "");
    Expect(1, 129502, '\p{^Line_Break=ebase}', "");
    Expect(1, 129502, '\P{Line_Break=ebase}', "");
    Expect(0, 129502, '\P{^Line_Break=ebase}', "");
    Expect(1, 129501, '\p{Line_Break=:\Aebase\z:}', "");;
    Expect(0, 129502, '\p{Line_Break=:\Aebase\z:}', "");;
    Expect(1, 129501, '\p{Line_Break:    E_Base}', "");
    Expect(0, 129501, '\p{^Line_Break:    E_Base}', "");
    Expect(0, 129501, '\P{Line_Break:    E_Base}', "");
    Expect(1, 129501, '\P{^Line_Break:    E_Base}', "");
    Expect(0, 129502, '\p{Line_Break:    E_Base}', "");
    Expect(1, 129502, '\p{^Line_Break:    E_Base}', "");
    Expect(1, 129502, '\P{Line_Break:    E_Base}', "");
    Expect(0, 129502, '\P{^Line_Break:    E_Base}', "");
    Error('\p{Lb=	 EB:=}');
    Error('\P{Lb=	 EB:=}');
    Expect(1, 129501, '\p{Lb=:\AEB\z:}', "");;
    Expect(0, 129502, '\p{Lb=:\AEB\z:}', "");;
    Expect(1, 129501, '\p{Lb=eb}', "");
    Expect(0, 129501, '\p{^Lb=eb}', "");
    Expect(0, 129501, '\P{Lb=eb}', "");
    Expect(1, 129501, '\P{^Lb=eb}', "");
    Expect(0, 129502, '\p{Lb=eb}', "");
    Expect(1, 129502, '\p{^Lb=eb}', "");
    Expect(1, 129502, '\P{Lb=eb}', "");
    Expect(0, 129502, '\P{^Lb=eb}', "");
    Expect(1, 129501, '\p{Lb=:\Aeb\z:}', "");;
    Expect(0, 129502, '\p{Lb=:\Aeb\z:}', "");;
    Expect(1, 129501, '\p{Lb=	EB}', "");
    Expect(0, 129501, '\p{^Lb=	EB}', "");
    Expect(0, 129501, '\P{Lb=	EB}', "");
    Expect(1, 129501, '\P{^Lb=	EB}', "");
    Expect(0, 129502, '\p{Lb=	EB}', "");
    Expect(1, 129502, '\p{^Lb=	EB}', "");
    Expect(1, 129502, '\P{Lb=	EB}', "");
    Expect(0, 129502, '\P{^Lb=	EB}', "");
    Error('\p{Is_Line_Break=_E_Base/a/}');
    Error('\P{Is_Line_Break=_E_Base/a/}');
    Expect(1, 129501, '\p{Is_Line_Break: ebase}', "");
    Expect(0, 129501, '\p{^Is_Line_Break: ebase}', "");
    Expect(0, 129501, '\P{Is_Line_Break: ebase}', "");
    Expect(1, 129501, '\P{^Is_Line_Break: ebase}', "");
    Expect(0, 129502, '\p{Is_Line_Break: ebase}', "");
    Expect(1, 129502, '\p{^Is_Line_Break: ebase}', "");
    Expect(1, 129502, '\P{Is_Line_Break: ebase}', "");
    Expect(0, 129502, '\P{^Is_Line_Break: ebase}', "");
    Expect(1, 129501, '\p{Is_Line_Break=E_BASE}', "");
    Expect(0, 129501, '\p{^Is_Line_Break=E_BASE}', "");
    Expect(0, 129501, '\P{Is_Line_Break=E_BASE}', "");
    Expect(1, 129501, '\P{^Is_Line_Break=E_BASE}', "");
    Expect(0, 129502, '\p{Is_Line_Break=E_BASE}', "");
    Expect(1, 129502, '\p{^Is_Line_Break=E_BASE}', "");
    Expect(1, 129502, '\P{Is_Line_Break=E_BASE}', "");
    Expect(0, 129502, '\P{^Is_Line_Break=E_BASE}', "");
    Error('\p{Is_Lb=:=	EB}');
    Error('\P{Is_Lb=:=	EB}');
    Expect(1, 129501, '\p{Is_Lb=eb}', "");
    Expect(0, 129501, '\p{^Is_Lb=eb}', "");
    Expect(0, 129501, '\P{Is_Lb=eb}', "");
    Expect(1, 129501, '\P{^Is_Lb=eb}', "");
    Expect(0, 129502, '\p{Is_Lb=eb}', "");
    Expect(1, 129502, '\p{^Is_Lb=eb}', "");
    Expect(1, 129502, '\P{Is_Lb=eb}', "");
    Expect(0, 129502, '\P{^Is_Lb=eb}', "");
    Expect(1, 129501, '\p{Is_Lb=	-EB}', "");
    Expect(0, 129501, '\p{^Is_Lb=	-EB}', "");
    Expect(0, 129501, '\P{Is_Lb=	-EB}', "");
    Expect(1, 129501, '\P{^Is_Lb=	-EB}', "");
    Expect(0, 129502, '\p{Is_Lb=	-EB}', "");
    Expect(1, 129502, '\p{^Is_Lb=	-EB}', "");
    Expect(1, 129502, '\P{Is_Lb=	-EB}', "");
    Expect(0, 129502, '\P{^Is_Lb=	-EB}', "");
    Error('\p{Line_Break=	/a/e_MODIFIER}');
    Error('\P{Line_Break=	/a/e_MODIFIER}');
    Expect(1, 127999, '\p{Line_Break=:\AE_Modifier\z:}', "");;
    Expect(0, 128000, '\p{Line_Break=:\AE_Modifier\z:}', "");;
    Expect(1, 127999, '\p{Line_Break=emodifier}', "");
    Expect(0, 127999, '\p{^Line_Break=emodifier}', "");
    Expect(0, 127999, '\P{Line_Break=emodifier}', "");
    Expect(1, 127999, '\P{^Line_Break=emodifier}', "");
    Expect(0, 128000, '\p{Line_Break=emodifier}', "");
    Expect(1, 128000, '\p{^Line_Break=emodifier}', "");
    Expect(1, 128000, '\P{Line_Break=emodifier}', "");
    Expect(0, 128000, '\P{^Line_Break=emodifier}', "");
    Expect(1, 127999, '\p{Line_Break=:\Aemodifier\z:}', "");;
    Expect(0, 128000, '\p{Line_Break=:\Aemodifier\z:}', "");;
    Expect(1, 127999, '\p{Line_Break=	 E_MODIFIER}', "");
    Expect(0, 127999, '\p{^Line_Break=	 E_MODIFIER}', "");
    Expect(0, 127999, '\P{Line_Break=	 E_MODIFIER}', "");
    Expect(1, 127999, '\P{^Line_Break=	 E_MODIFIER}', "");
    Expect(0, 128000, '\p{Line_Break=	 E_MODIFIER}', "");
    Expect(1, 128000, '\p{^Line_Break=	 E_MODIFIER}', "");
    Expect(1, 128000, '\P{Line_Break=	 E_MODIFIER}', "");
    Expect(0, 128000, '\P{^Line_Break=	 E_MODIFIER}', "");
    Error('\p{Lb:/a/__em}');
    Error('\P{Lb:/a/__em}');
    Expect(1, 127999, '\p{Lb=:\AEM\z:}', "");;
    Expect(0, 128000, '\p{Lb=:\AEM\z:}', "");;
    Expect(1, 127999, '\p{Lb=em}', "");
    Expect(0, 127999, '\p{^Lb=em}', "");
    Expect(0, 127999, '\P{Lb=em}', "");
    Expect(1, 127999, '\P{^Lb=em}', "");
    Expect(0, 128000, '\p{Lb=em}', "");
    Expect(1, 128000, '\p{^Lb=em}', "");
    Expect(1, 128000, '\P{Lb=em}', "");
    Expect(0, 128000, '\P{^Lb=em}', "");
    Expect(1, 127999, '\p{Lb=:\Aem\z:}', "");;
    Expect(0, 128000, '\p{Lb=:\Aem\z:}', "");;
    Expect(1, 127999, '\p{Lb=_	EM}', "");
    Expect(0, 127999, '\p{^Lb=_	EM}', "");
    Expect(0, 127999, '\P{Lb=_	EM}', "");
    Expect(1, 127999, '\P{^Lb=_	EM}', "");
    Expect(0, 128000, '\p{Lb=_	EM}', "");
    Expect(1, 128000, '\p{^Lb=_	EM}', "");
    Expect(1, 128000, '\P{Lb=_	EM}', "");
    Expect(0, 128000, '\P{^Lb=_	EM}', "");
    Error('\p{Is_Line_Break=- e_Modifier/a/}');
    Error('\P{Is_Line_Break=- e_Modifier/a/}');
    Expect(1, 127999, '\p{Is_Line_Break=emodifier}', "");
    Expect(0, 127999, '\p{^Is_Line_Break=emodifier}', "");
    Expect(0, 127999, '\P{Is_Line_Break=emodifier}', "");
    Expect(1, 127999, '\P{^Is_Line_Break=emodifier}', "");
    Expect(0, 128000, '\p{Is_Line_Break=emodifier}', "");
    Expect(1, 128000, '\p{^Is_Line_Break=emodifier}', "");
    Expect(1, 128000, '\P{Is_Line_Break=emodifier}', "");
    Expect(0, 128000, '\P{^Is_Line_Break=emodifier}', "");
    Expect(1, 127999, '\p{Is_Line_Break=_-E_modifier}', "");
    Expect(0, 127999, '\p{^Is_Line_Break=_-E_modifier}', "");
    Expect(0, 127999, '\P{Is_Line_Break=_-E_modifier}', "");
    Expect(1, 127999, '\P{^Is_Line_Break=_-E_modifier}', "");
    Expect(0, 128000, '\p{Is_Line_Break=_-E_modifier}', "");
    Expect(1, 128000, '\p{^Is_Line_Break=_-E_modifier}', "");
    Expect(1, 128000, '\P{Is_Line_Break=_-E_modifier}', "");
    Expect(0, 128000, '\P{^Is_Line_Break=_-E_modifier}', "");
    Error('\p{Is_Lb=  em:=}');
    Error('\P{Is_Lb=  em:=}');
    Expect(1, 127999, '\p{Is_Lb=em}', "");
    Expect(0, 127999, '\p{^Is_Lb=em}', "");
    Expect(0, 127999, '\P{Is_Lb=em}', "");
    Expect(1, 127999, '\P{^Is_Lb=em}', "");
    Expect(0, 128000, '\p{Is_Lb=em}', "");
    Expect(1, 128000, '\p{^Is_Lb=em}', "");
    Expect(1, 128000, '\P{Is_Lb=em}', "");
    Expect(0, 128000, '\P{^Is_Lb=em}', "");
    Expect(1, 127999, '\p{Is_Lb: _	EM}', "");
    Expect(0, 127999, '\p{^Is_Lb: _	EM}', "");
    Expect(0, 127999, '\P{Is_Lb: _	EM}', "");
    Expect(1, 127999, '\P{^Is_Lb: _	EM}', "");
    Expect(0, 128000, '\p{Is_Lb: _	EM}', "");
    Expect(1, 128000, '\p{^Is_Lb: _	EM}', "");
    Expect(1, 128000, '\P{Is_Lb: _	EM}', "");
    Expect(0, 128000, '\P{^Is_Lb: _	EM}', "");
    Error('\p{Line_Break=/a/_Exclamation}');
    Error('\P{Line_Break=/a/_Exclamation}');
    Expect(1, 72817, '\p{Line_Break=:\AExclamation\z:}', "");;
    Expect(0, 72818, '\p{Line_Break=:\AExclamation\z:}', "");;
    Expect(1, 72817, '\p{Line_Break:	exclamation}', "");
    Expect(0, 72817, '\p{^Line_Break:	exclamation}', "");
    Expect(0, 72817, '\P{Line_Break:	exclamation}', "");
    Expect(1, 72817, '\P{^Line_Break:	exclamation}', "");
    Expect(0, 72818, '\p{Line_Break:	exclamation}', "");
    Expect(1, 72818, '\p{^Line_Break:	exclamation}', "");
    Expect(1, 72818, '\P{Line_Break:	exclamation}', "");
    Expect(0, 72818, '\P{^Line_Break:	exclamation}', "");
    Expect(1, 72817, '\p{Line_Break=:\Aexclamation\z:}', "");;
    Expect(0, 72818, '\p{Line_Break=:\Aexclamation\z:}', "");;
    Expect(1, 72817, '\p{Line_Break=-_Exclamation}', "");
    Expect(0, 72817, '\p{^Line_Break=-_Exclamation}', "");
    Expect(0, 72817, '\P{Line_Break=-_Exclamation}', "");
    Expect(1, 72817, '\P{^Line_Break=-_Exclamation}', "");
    Expect(0, 72818, '\p{Line_Break=-_Exclamation}', "");
    Expect(1, 72818, '\p{^Line_Break=-_Exclamation}', "");
    Expect(1, 72818, '\P{Line_Break=-_Exclamation}', "");
    Expect(0, 72818, '\P{^Line_Break=-_Exclamation}', "");
    Error('\p{Lb=:=		EX}');
    Error('\P{Lb=:=		EX}');
    Expect(1, 72817, '\p{Lb=:\AEX\z:}', "");;
    Expect(0, 72818, '\p{Lb=:\AEX\z:}', "");;
    Expect(1, 72817, '\p{Lb=ex}', "");
    Expect(0, 72817, '\p{^Lb=ex}', "");
    Expect(0, 72817, '\P{Lb=ex}', "");
    Expect(1, 72817, '\P{^Lb=ex}', "");
    Expect(0, 72818, '\p{Lb=ex}', "");
    Expect(1, 72818, '\p{^Lb=ex}', "");
    Expect(1, 72818, '\P{Lb=ex}', "");
    Expect(0, 72818, '\P{^Lb=ex}', "");
    Expect(1, 72817, '\p{Lb=:\Aex\z:}', "");;
    Expect(0, 72818, '\p{Lb=:\Aex\z:}', "");;
    Expect(1, 72817, '\p{Lb=--EX}', "");
    Expect(0, 72817, '\p{^Lb=--EX}', "");
    Expect(0, 72817, '\P{Lb=--EX}', "");
    Expect(1, 72817, '\P{^Lb=--EX}', "");
    Expect(0, 72818, '\p{Lb=--EX}', "");
    Expect(1, 72818, '\p{^Lb=--EX}', "");
    Expect(1, 72818, '\P{Lb=--EX}', "");
    Expect(0, 72818, '\P{^Lb=--EX}', "");
    Error('\p{Is_Line_Break=:=  Exclamation}');
    Error('\P{Is_Line_Break=:=  Exclamation}');
    Expect(1, 72817, '\p{Is_Line_Break=exclamation}', "");
    Expect(0, 72817, '\p{^Is_Line_Break=exclamation}', "");
    Expect(0, 72817, '\P{Is_Line_Break=exclamation}', "");
    Expect(1, 72817, '\P{^Is_Line_Break=exclamation}', "");
    Expect(0, 72818, '\p{Is_Line_Break=exclamation}', "");
    Expect(1, 72818, '\p{^Is_Line_Break=exclamation}', "");
    Expect(1, 72818, '\P{Is_Line_Break=exclamation}', "");
    Expect(0, 72818, '\P{^Is_Line_Break=exclamation}', "");
    Expect(1, 72817, '\p{Is_Line_Break=	 EXCLAMATION}', "");
    Expect(0, 72817, '\p{^Is_Line_Break=	 EXCLAMATION}', "");
    Expect(0, 72817, '\P{Is_Line_Break=	 EXCLAMATION}', "");
    Expect(1, 72817, '\P{^Is_Line_Break=	 EXCLAMATION}', "");
    Expect(0, 72818, '\p{Is_Line_Break=	 EXCLAMATION}', "");
    Expect(1, 72818, '\p{^Is_Line_Break=	 EXCLAMATION}', "");
    Expect(1, 72818, '\P{Is_Line_Break=	 EXCLAMATION}', "");
    Expect(0, 72818, '\P{^Is_Line_Break=	 EXCLAMATION}', "");
    Error('\p{Is_Lb=-/a/EX}');
    Error('\P{Is_Lb=-/a/EX}');
    Expect(1, 72817, '\p{Is_Lb=ex}', "");
    Expect(0, 72817, '\p{^Is_Lb=ex}', "");
    Expect(0, 72817, '\P{Is_Lb=ex}', "");
    Expect(1, 72817, '\P{^Is_Lb=ex}', "");
    Expect(0, 72818, '\p{Is_Lb=ex}', "");
    Expect(1, 72818, '\p{^Is_Lb=ex}', "");
    Expect(1, 72818, '\P{Is_Lb=ex}', "");
    Expect(0, 72818, '\P{^Is_Lb=ex}', "");
    Expect(1, 72817, '\p{Is_Lb:_EX}', "");
    Expect(0, 72817, '\p{^Is_Lb:_EX}', "");
    Expect(0, 72817, '\P{Is_Lb:_EX}', "");
    Expect(1, 72817, '\P{^Is_Lb:_EX}', "");
    Expect(0, 72818, '\p{Is_Lb:_EX}', "");
    Expect(1, 72818, '\p{^Is_Lb:_EX}', "");
    Expect(1, 72818, '\P{Is_Lb:_EX}', "");
    Expect(0, 72818, '\P{^Is_Lb:_EX}', "");
    Error('\p{Line_Break=:=glue}');
    Error('\P{Line_Break=:=glue}');
    Expect(1, 78902, '\p{Line_Break=:\AGlue\z:}', "");;
    Expect(0, 78903, '\p{Line_Break=:\AGlue\z:}', "");;
    Expect(1, 78902, '\p{Line_Break=glue}', "");
    Expect(0, 78902, '\p{^Line_Break=glue}', "");
    Expect(0, 78902, '\P{Line_Break=glue}', "");
    Expect(1, 78902, '\P{^Line_Break=glue}', "");
    Expect(0, 78903, '\p{Line_Break=glue}', "");
    Expect(1, 78903, '\p{^Line_Break=glue}', "");
    Expect(1, 78903, '\P{Line_Break=glue}', "");
    Expect(0, 78903, '\P{^Line_Break=glue}', "");
    Expect(1, 78902, '\p{Line_Break=:\Aglue\z:}', "");;
    Expect(0, 78903, '\p{Line_Break=:\Aglue\z:}', "");;
    Expect(1, 78902, '\p{Line_Break=	GLUE}', "");
    Expect(0, 78902, '\p{^Line_Break=	GLUE}', "");
    Expect(0, 78902, '\P{Line_Break=	GLUE}', "");
    Expect(1, 78902, '\P{^Line_Break=	GLUE}', "");
    Expect(0, 78903, '\p{Line_Break=	GLUE}', "");
    Expect(1, 78903, '\p{^Line_Break=	GLUE}', "");
    Expect(1, 78903, '\P{Line_Break=	GLUE}', "");
    Expect(0, 78903, '\P{^Line_Break=	GLUE}', "");
    Error('\p{Lb=/a/_gl}');
    Error('\P{Lb=/a/_gl}');
    Expect(1, 78902, '\p{Lb=:\AGL\z:}', "");;
    Expect(0, 78903, '\p{Lb=:\AGL\z:}', "");;
    Expect(1, 78902, '\p{Lb=gl}', "");
    Expect(0, 78902, '\p{^Lb=gl}', "");
    Expect(0, 78902, '\P{Lb=gl}', "");
    Expect(1, 78902, '\P{^Lb=gl}', "");
    Expect(0, 78903, '\p{Lb=gl}', "");
    Expect(1, 78903, '\p{^Lb=gl}', "");
    Expect(1, 78903, '\P{Lb=gl}', "");
    Expect(0, 78903, '\P{^Lb=gl}', "");
    Expect(1, 78902, '\p{Lb=:\Agl\z:}', "");;
    Expect(0, 78903, '\p{Lb=:\Agl\z:}', "");;
    Expect(1, 78902, '\p{Lb= GL}', "");
    Expect(0, 78902, '\p{^Lb= GL}', "");
    Expect(0, 78902, '\P{Lb= GL}', "");
    Expect(1, 78902, '\P{^Lb= GL}', "");
    Expect(0, 78903, '\p{Lb= GL}', "");
    Expect(1, 78903, '\p{^Lb= GL}', "");
    Expect(1, 78903, '\P{Lb= GL}', "");
    Expect(0, 78903, '\P{^Lb= GL}', "");
    Error('\p{Is_Line_Break:   :=	glue}');
    Error('\P{Is_Line_Break:   :=	glue}');
    Expect(1, 78902, '\p{Is_Line_Break=glue}', "");
    Expect(0, 78902, '\p{^Is_Line_Break=glue}', "");
    Expect(0, 78902, '\P{Is_Line_Break=glue}', "");
    Expect(1, 78902, '\P{^Is_Line_Break=glue}', "");
    Expect(0, 78903, '\p{Is_Line_Break=glue}', "");
    Expect(1, 78903, '\p{^Is_Line_Break=glue}', "");
    Expect(1, 78903, '\P{Is_Line_Break=glue}', "");
    Expect(0, 78903, '\P{^Is_Line_Break=glue}', "");
    Expect(1, 78902, '\p{Is_Line_Break:    Glue}', "");
    Expect(0, 78902, '\p{^Is_Line_Break:    Glue}', "");
    Expect(0, 78902, '\P{Is_Line_Break:    Glue}', "");
    Expect(1, 78902, '\P{^Is_Line_Break:    Glue}', "");
    Expect(0, 78903, '\p{Is_Line_Break:    Glue}', "");
    Expect(1, 78903, '\p{^Is_Line_Break:    Glue}', "");
    Expect(1, 78903, '\P{Is_Line_Break:    Glue}', "");
    Expect(0, 78903, '\P{^Is_Line_Break:    Glue}', "");
    Error('\p{Is_Lb=-_GL/a/}');
    Error('\P{Is_Lb=-_GL/a/}');
    Expect(1, 78902, '\p{Is_Lb:gl}', "");
    Expect(0, 78902, '\p{^Is_Lb:gl}', "");
    Expect(0, 78902, '\P{Is_Lb:gl}', "");
    Expect(1, 78902, '\P{^Is_Lb:gl}', "");
    Expect(0, 78903, '\p{Is_Lb:gl}', "");
    Expect(1, 78903, '\p{^Is_Lb:gl}', "");
    Expect(1, 78903, '\P{Is_Lb:gl}', "");
    Expect(0, 78903, '\P{^Is_Lb:gl}', "");
    Expect(1, 78902, '\p{Is_Lb=--GL}', "");
    Expect(0, 78902, '\p{^Is_Lb=--GL}', "");
    Expect(0, 78902, '\P{Is_Lb=--GL}', "");
    Expect(1, 78902, '\P{^Is_Lb=--GL}', "");
    Expect(0, 78903, '\p{Is_Lb=--GL}', "");
    Expect(1, 78903, '\p{^Is_Lb=--GL}', "");
    Expect(1, 78903, '\P{Is_Lb=--GL}', "");
    Expect(0, 78903, '\P{^Is_Lb=--GL}', "");
    Error('\p{Line_Break=-:=h2}');
    Error('\P{Line_Break=-:=h2}');
    Expect(1, 55176, '\p{Line_Break=:\AH2\z:}', "");;
    Expect(0, 55177, '\p{Line_Break=:\AH2\z:}', "");;
    Expect(1, 55176, '\p{Line_Break: h2}', "");
    Expect(0, 55176, '\p{^Line_Break: h2}', "");
    Expect(0, 55176, '\P{Line_Break: h2}', "");
    Expect(1, 55176, '\P{^Line_Break: h2}', "");
    Expect(0, 55177, '\p{Line_Break: h2}', "");
    Expect(1, 55177, '\p{^Line_Break: h2}', "");
    Expect(1, 55177, '\P{Line_Break: h2}', "");
    Expect(0, 55177, '\P{^Line_Break: h2}', "");
    Expect(1, 55176, '\p{Line_Break=:\Ah2\z:}', "");;
    Expect(0, 55177, '\p{Line_Break=:\Ah2\z:}', "");;
    Expect(1, 55176, '\p{Line_Break=	H2}', "");
    Expect(0, 55176, '\p{^Line_Break=	H2}', "");
    Expect(0, 55176, '\P{Line_Break=	H2}', "");
    Expect(1, 55176, '\P{^Line_Break=	H2}', "");
    Expect(0, 55177, '\p{Line_Break=	H2}', "");
    Expect(1, 55177, '\p{^Line_Break=	H2}', "");
    Expect(1, 55177, '\P{Line_Break=	H2}', "");
    Expect(0, 55177, '\P{^Line_Break=	H2}', "");
    Error('\p{Lb=_/a/H2}');
    Error('\P{Lb=_/a/H2}');
    Expect(1, 55176, '\p{Lb=:\AH2\z:}', "");;
    Expect(0, 55177, '\p{Lb=:\AH2\z:}', "");;
    Expect(1, 55176, '\p{Lb=h2}', "");
    Expect(0, 55176, '\p{^Lb=h2}', "");
    Expect(0, 55176, '\P{Lb=h2}', "");
    Expect(1, 55176, '\P{^Lb=h2}', "");
    Expect(0, 55177, '\p{Lb=h2}', "");
    Expect(1, 55177, '\p{^Lb=h2}', "");
    Expect(1, 55177, '\P{Lb=h2}', "");
    Expect(0, 55177, '\P{^Lb=h2}', "");
    Expect(1, 55176, '\p{Lb=:\Ah2\z:}', "");;
    Expect(0, 55177, '\p{Lb=:\Ah2\z:}', "");;
    Expect(1, 55176, '\p{Lb= 	h2}', "");
    Expect(0, 55176, '\p{^Lb= 	h2}', "");
    Expect(0, 55176, '\P{Lb= 	h2}', "");
    Expect(1, 55176, '\P{^Lb= 	h2}', "");
    Expect(0, 55177, '\p{Lb= 	h2}', "");
    Expect(1, 55177, '\p{^Lb= 	h2}', "");
    Expect(1, 55177, '\P{Lb= 	h2}', "");
    Expect(0, 55177, '\P{^Lb= 	h2}', "");
    Error('\p{Is_Line_Break=  H2/a/}');
    Error('\P{Is_Line_Break=  H2/a/}');
    Expect(1, 55176, '\p{Is_Line_Break=h2}', "");
    Expect(0, 55176, '\p{^Is_Line_Break=h2}', "");
    Expect(0, 55176, '\P{Is_Line_Break=h2}', "");
    Expect(1, 55176, '\P{^Is_Line_Break=h2}', "");
    Expect(0, 55177, '\p{Is_Line_Break=h2}', "");
    Expect(1, 55177, '\p{^Is_Line_Break=h2}', "");
    Expect(1, 55177, '\P{Is_Line_Break=h2}', "");
    Expect(0, 55177, '\P{^Is_Line_Break=h2}', "");
    Expect(1, 55176, '\p{Is_Line_Break=_H2}', "");
    Expect(0, 55176, '\p{^Is_Line_Break=_H2}', "");
    Expect(0, 55176, '\P{Is_Line_Break=_H2}', "");
    Expect(1, 55176, '\P{^Is_Line_Break=_H2}', "");
    Expect(0, 55177, '\p{Is_Line_Break=_H2}', "");
    Expect(1, 55177, '\p{^Is_Line_Break=_H2}', "");
    Expect(1, 55177, '\P{Is_Line_Break=_H2}', "");
    Expect(0, 55177, '\P{^Is_Line_Break=_H2}', "");
    Error('\p{Is_Lb=-H2:=}');
    Error('\P{Is_Lb=-H2:=}');
    Expect(1, 55176, '\p{Is_Lb=h2}', "");
    Expect(0, 55176, '\p{^Is_Lb=h2}', "");
    Expect(0, 55176, '\P{Is_Lb=h2}', "");
    Expect(1, 55176, '\P{^Is_Lb=h2}', "");
    Expect(0, 55177, '\p{Is_Lb=h2}', "");
    Expect(1, 55177, '\p{^Is_Lb=h2}', "");
    Expect(1, 55177, '\P{Is_Lb=h2}', "");
    Expect(0, 55177, '\P{^Is_Lb=h2}', "");
    Expect(1, 55176, '\p{Is_Lb=--H2}', "");
    Expect(0, 55176, '\p{^Is_Lb=--H2}', "");
    Expect(0, 55176, '\P{Is_Lb=--H2}', "");
    Expect(1, 55176, '\P{^Is_Lb=--H2}', "");
    Expect(0, 55177, '\p{Is_Lb=--H2}', "");
    Expect(1, 55177, '\p{^Is_Lb=--H2}', "");
    Expect(1, 55177, '\P{Is_Lb=--H2}', "");
    Expect(0, 55177, '\P{^Is_Lb=--H2}', "");
    Error('\p{Line_Break=-H3/a/}');
    Error('\P{Line_Break=-H3/a/}');
    Expect(1, 55203, '\p{Line_Break=:\AH3\z:}', "");;
    Expect(0, 55204, '\p{Line_Break=:\AH3\z:}', "");;
    Expect(1, 55203, '\p{Line_Break=h3}', "");
    Expect(0, 55203, '\p{^Line_Break=h3}', "");
    Expect(0, 55203, '\P{Line_Break=h3}', "");
    Expect(1, 55203, '\P{^Line_Break=h3}', "");
    Expect(0, 55204, '\p{Line_Break=h3}', "");
    Expect(1, 55204, '\p{^Line_Break=h3}', "");
    Expect(1, 55204, '\P{Line_Break=h3}', "");
    Expect(0, 55204, '\P{^Line_Break=h3}', "");
    Expect(1, 55203, '\p{Line_Break=:\Ah3\z:}', "");;
    Expect(0, 55204, '\p{Line_Break=:\Ah3\z:}', "");;
    Expect(1, 55203, '\p{Line_Break= _H3}', "");
    Expect(0, 55203, '\p{^Line_Break= _H3}', "");
    Expect(0, 55203, '\P{Line_Break= _H3}', "");
    Expect(1, 55203, '\P{^Line_Break= _H3}', "");
    Expect(0, 55204, '\p{Line_Break= _H3}', "");
    Expect(1, 55204, '\p{^Line_Break= _H3}', "");
    Expect(1, 55204, '\P{Line_Break= _H3}', "");
    Expect(0, 55204, '\P{^Line_Break= _H3}', "");
    Error('\p{Lb=_:=H3}');
    Error('\P{Lb=_:=H3}');
    Expect(1, 55203, '\p{Lb=:\AH3\z:}', "");;
    Expect(0, 55204, '\p{Lb=:\AH3\z:}', "");;
    Expect(1, 55203, '\p{Lb=h3}', "");
    Expect(0, 55203, '\p{^Lb=h3}', "");
    Expect(0, 55203, '\P{Lb=h3}', "");
    Expect(1, 55203, '\P{^Lb=h3}', "");
    Expect(0, 55204, '\p{Lb=h3}', "");
    Expect(1, 55204, '\p{^Lb=h3}', "");
    Expect(1, 55204, '\P{Lb=h3}', "");
    Expect(0, 55204, '\P{^Lb=h3}', "");
    Expect(1, 55203, '\p{Lb=:\Ah3\z:}', "");;
    Expect(0, 55204, '\p{Lb=:\Ah3\z:}', "");;
    Expect(1, 55203, '\p{Lb=	-h3}', "");
    Expect(0, 55203, '\p{^Lb=	-h3}', "");
    Expect(0, 55203, '\P{Lb=	-h3}', "");
    Expect(1, 55203, '\P{^Lb=	-h3}', "");
    Expect(0, 55204, '\p{Lb=	-h3}', "");
    Expect(1, 55204, '\p{^Lb=	-h3}', "");
    Expect(1, 55204, '\P{Lb=	-h3}', "");
    Expect(0, 55204, '\P{^Lb=	-h3}', "");
    Error('\p{Is_Line_Break=-H3/a/}');
    Error('\P{Is_Line_Break=-H3/a/}');
    Expect(1, 55203, '\p{Is_Line_Break=h3}', "");
    Expect(0, 55203, '\p{^Is_Line_Break=h3}', "");
    Expect(0, 55203, '\P{Is_Line_Break=h3}', "");
    Expect(1, 55203, '\P{^Is_Line_Break=h3}', "");
    Expect(0, 55204, '\p{Is_Line_Break=h3}', "");
    Expect(1, 55204, '\p{^Is_Line_Break=h3}', "");
    Expect(1, 55204, '\P{Is_Line_Break=h3}', "");
    Expect(0, 55204, '\P{^Is_Line_Break=h3}', "");
    Expect(1, 55203, '\p{Is_Line_Break= H3}', "");
    Expect(0, 55203, '\p{^Is_Line_Break= H3}', "");
    Expect(0, 55203, '\P{Is_Line_Break= H3}', "");
    Expect(1, 55203, '\P{^Is_Line_Break= H3}', "");
    Expect(0, 55204, '\p{Is_Line_Break= H3}', "");
    Expect(1, 55204, '\p{^Is_Line_Break= H3}', "");
    Expect(1, 55204, '\P{Is_Line_Break= H3}', "");
    Expect(0, 55204, '\P{^Is_Line_Break= H3}', "");
    Error('\p{Is_Lb=_	h3:=}');
    Error('\P{Is_Lb=_	h3:=}');
    Expect(1, 55203, '\p{Is_Lb=h3}', "");
    Expect(0, 55203, '\p{^Is_Lb=h3}', "");
    Expect(0, 55203, '\P{Is_Lb=h3}', "");
    Expect(1, 55203, '\P{^Is_Lb=h3}', "");
    Expect(0, 55204, '\p{Is_Lb=h3}', "");
    Expect(1, 55204, '\p{^Is_Lb=h3}', "");
    Expect(1, 55204, '\P{Is_Lb=h3}', "");
    Expect(0, 55204, '\P{^Is_Lb=h3}', "");
    Expect(1, 55203, '\p{Is_Lb= -H3}', "");
    Expect(0, 55203, '\p{^Is_Lb= -H3}', "");
    Expect(0, 55203, '\P{Is_Lb= -H3}', "");
    Expect(1, 55203, '\P{^Is_Lb= -H3}', "");
    Expect(0, 55204, '\p{Is_Lb= -H3}', "");
    Expect(1, 55204, '\p{^Is_Lb= -H3}', "");
    Expect(1, 55204, '\P{Is_Lb= -H3}', "");
    Expect(0, 55204, '\P{^Is_Lb= -H3}', "");
    Error('\p{Line_Break=/a/_Hebrew_Letter}');
    Error('\P{Line_Break=/a/_Hebrew_Letter}');
    Expect(1, 64335, '\p{Line_Break=:\AHebrew_Letter\z:}', "");;
    Expect(0, 64336, '\p{Line_Break=:\AHebrew_Letter\z:}', "");;
    Expect(1, 64335, '\p{Line_Break=hebrewletter}', "");
    Expect(0, 64335, '\p{^Line_Break=hebrewletter}', "");
    Expect(0, 64335, '\P{Line_Break=hebrewletter}', "");
    Expect(1, 64335, '\P{^Line_Break=hebrewletter}', "");
    Expect(0, 64336, '\p{Line_Break=hebrewletter}', "");
    Expect(1, 64336, '\p{^Line_Break=hebrewletter}', "");
    Expect(1, 64336, '\P{Line_Break=hebrewletter}', "");
    Expect(0, 64336, '\P{^Line_Break=hebrewletter}', "");
    Expect(1, 64335, '\p{Line_Break=:\Ahebrewletter\z:}', "");;
    Expect(0, 64336, '\p{Line_Break=:\Ahebrewletter\z:}', "");;
    Expect(1, 64335, '\p{Line_Break=_	Hebrew_Letter}', "");
    Expect(0, 64335, '\p{^Line_Break=_	Hebrew_Letter}', "");
    Expect(0, 64335, '\P{Line_Break=_	Hebrew_Letter}', "");
    Expect(1, 64335, '\P{^Line_Break=_	Hebrew_Letter}', "");
    Expect(0, 64336, '\p{Line_Break=_	Hebrew_Letter}', "");
    Expect(1, 64336, '\p{^Line_Break=_	Hebrew_Letter}', "");
    Expect(1, 64336, '\P{Line_Break=_	Hebrew_Letter}', "");
    Expect(0, 64336, '\P{^Line_Break=_	Hebrew_Letter}', "");
    Error('\p{Lb=	:=HL}');
    Error('\P{Lb=	:=HL}');
    Expect(1, 64335, '\p{Lb=:\AHL\z:}', "");;
    Expect(0, 64336, '\p{Lb=:\AHL\z:}', "");;
    Expect(1, 64335, '\p{Lb=hl}', "");
    Expect(0, 64335, '\p{^Lb=hl}', "");
    Expect(0, 64335, '\P{Lb=hl}', "");
    Expect(1, 64335, '\P{^Lb=hl}', "");
    Expect(0, 64336, '\p{Lb=hl}', "");
    Expect(1, 64336, '\p{^Lb=hl}', "");
    Expect(1, 64336, '\P{Lb=hl}', "");
    Expect(0, 64336, '\P{^Lb=hl}', "");
    Expect(1, 64335, '\p{Lb=:\Ahl\z:}', "");;
    Expect(0, 64336, '\p{Lb=:\Ahl\z:}', "");;
    Expect(1, 64335, '\p{Lb=-	hl}', "");
    Expect(0, 64335, '\p{^Lb=-	hl}', "");
    Expect(0, 64335, '\P{Lb=-	hl}', "");
    Expect(1, 64335, '\P{^Lb=-	hl}', "");
    Expect(0, 64336, '\p{Lb=-	hl}', "");
    Expect(1, 64336, '\p{^Lb=-	hl}', "");
    Expect(1, 64336, '\P{Lb=-	hl}', "");
    Expect(0, 64336, '\P{^Lb=-	hl}', "");
    Error('\p{Is_Line_Break=_	Hebrew_LETTER/a/}');
    Error('\P{Is_Line_Break=_	Hebrew_LETTER/a/}');
    Expect(1, 64335, '\p{Is_Line_Break=hebrewletter}', "");
    Expect(0, 64335, '\p{^Is_Line_Break=hebrewletter}', "");
    Expect(0, 64335, '\P{Is_Line_Break=hebrewletter}', "");
    Expect(1, 64335, '\P{^Is_Line_Break=hebrewletter}', "");
    Expect(0, 64336, '\p{Is_Line_Break=hebrewletter}', "");
    Expect(1, 64336, '\p{^Is_Line_Break=hebrewletter}', "");
    Expect(1, 64336, '\P{Is_Line_Break=hebrewletter}', "");
    Expect(0, 64336, '\P{^Is_Line_Break=hebrewletter}', "");
    Expect(1, 64335, '\p{Is_Line_Break=	 hebrew_Letter}', "");
    Expect(0, 64335, '\p{^Is_Line_Break=	 hebrew_Letter}', "");
    Expect(0, 64335, '\P{Is_Line_Break=	 hebrew_Letter}', "");
    Expect(1, 64335, '\P{^Is_Line_Break=	 hebrew_Letter}', "");
    Expect(0, 64336, '\p{Is_Line_Break=	 hebrew_Letter}', "");
    Expect(1, 64336, '\p{^Is_Line_Break=	 hebrew_Letter}', "");
    Expect(1, 64336, '\P{Is_Line_Break=	 hebrew_Letter}', "");
    Expect(0, 64336, '\P{^Is_Line_Break=	 hebrew_Letter}', "");
    Error('\p{Is_Lb=:=hl}');
    Error('\P{Is_Lb=:=hl}');
    Expect(1, 64335, '\p{Is_Lb=hl}', "");
    Expect(0, 64335, '\p{^Is_Lb=hl}', "");
    Expect(0, 64335, '\P{Is_Lb=hl}', "");
    Expect(1, 64335, '\P{^Is_Lb=hl}', "");
    Expect(0, 64336, '\p{Is_Lb=hl}', "");
    Expect(1, 64336, '\p{^Is_Lb=hl}', "");
    Expect(1, 64336, '\P{Is_Lb=hl}', "");
    Expect(0, 64336, '\P{^Is_Lb=hl}', "");
    Expect(1, 64335, '\p{Is_Lb=	 HL}', "");
    Expect(0, 64335, '\p{^Is_Lb=	 HL}', "");
    Expect(0, 64335, '\P{Is_Lb=	 HL}', "");
    Expect(1, 64335, '\P{^Is_Lb=	 HL}', "");
    Expect(0, 64336, '\p{Is_Lb=	 HL}', "");
    Expect(1, 64336, '\p{^Is_Lb=	 HL}', "");
    Expect(1, 64336, '\P{Is_Lb=	 HL}', "");
    Expect(0, 64336, '\P{^Is_Lb=	 HL}', "");
    Error('\p{Line_Break=/a/_-Hyphen}');
    Error('\P{Line_Break=/a/_-Hyphen}');
    Expect(1, 45, '\p{Line_Break=:\AHyphen\z:}', "");;
    Expect(0, 46, '\p{Line_Break=:\AHyphen\z:}', "");;
    Expect(1, 45, '\p{Line_Break:   hyphen}', "");
    Expect(0, 45, '\p{^Line_Break:   hyphen}', "");
    Expect(0, 45, '\P{Line_Break:   hyphen}', "");
    Expect(1, 45, '\P{^Line_Break:   hyphen}', "");
    Expect(0, 46, '\p{Line_Break:   hyphen}', "");
    Expect(1, 46, '\p{^Line_Break:   hyphen}', "");
    Expect(1, 46, '\P{Line_Break:   hyphen}', "");
    Expect(0, 46, '\P{^Line_Break:   hyphen}', "");
    Expect(1, 45, '\p{Line_Break=:\Ahyphen\z:}', "");;
    Expect(0, 46, '\p{Line_Break=:\Ahyphen\z:}', "");;
    Expect(1, 45, '\p{Line_Break=- Hyphen}', "");
    Expect(0, 45, '\p{^Line_Break=- Hyphen}', "");
    Expect(0, 45, '\P{Line_Break=- Hyphen}', "");
    Expect(1, 45, '\P{^Line_Break=- Hyphen}', "");
    Expect(0, 46, '\p{Line_Break=- Hyphen}', "");
    Expect(1, 46, '\p{^Line_Break=- Hyphen}', "");
    Expect(1, 46, '\P{Line_Break=- Hyphen}', "");
    Expect(0, 46, '\P{^Line_Break=- Hyphen}', "");
    Error('\p{Lb: :=_HY}');
    Error('\P{Lb: :=_HY}');
    Expect(1, 45, '\p{Lb=:\AHY\z:}', "");;
    Expect(0, 46, '\p{Lb=:\AHY\z:}', "");;
    Expect(1, 45, '\p{Lb=hy}', "");
    Expect(0, 45, '\p{^Lb=hy}', "");
    Expect(0, 45, '\P{Lb=hy}', "");
    Expect(1, 45, '\P{^Lb=hy}', "");
    Expect(0, 46, '\p{Lb=hy}', "");
    Expect(1, 46, '\p{^Lb=hy}', "");
    Expect(1, 46, '\P{Lb=hy}', "");
    Expect(0, 46, '\P{^Lb=hy}', "");
    Expect(1, 45, '\p{Lb=:\Ahy\z:}', "");;
    Expect(0, 46, '\p{Lb=:\Ahy\z:}', "");;
    Expect(1, 45, '\p{Lb=  HY}', "");
    Expect(0, 45, '\p{^Lb=  HY}', "");
    Expect(0, 45, '\P{Lb=  HY}', "");
    Expect(1, 45, '\P{^Lb=  HY}', "");
    Expect(0, 46, '\p{Lb=  HY}', "");
    Expect(1, 46, '\p{^Lb=  HY}', "");
    Expect(1, 46, '\P{Lb=  HY}', "");
    Expect(0, 46, '\P{^Lb=  HY}', "");
    Error('\p{Is_Line_Break= -Hyphen/a/}');
    Error('\P{Is_Line_Break= -Hyphen/a/}');
    Expect(1, 45, '\p{Is_Line_Break=hyphen}', "");
    Expect(0, 45, '\p{^Is_Line_Break=hyphen}', "");
    Expect(0, 45, '\P{Is_Line_Break=hyphen}', "");
    Expect(1, 45, '\P{^Is_Line_Break=hyphen}', "");
    Expect(0, 46, '\p{Is_Line_Break=hyphen}', "");
    Expect(1, 46, '\p{^Is_Line_Break=hyphen}', "");
    Expect(1, 46, '\P{Is_Line_Break=hyphen}', "");
    Expect(0, 46, '\P{^Is_Line_Break=hyphen}', "");
    Expect(1, 45, '\p{Is_Line_Break=	-Hyphen}', "");
    Expect(0, 45, '\p{^Is_Line_Break=	-Hyphen}', "");
    Expect(0, 45, '\P{Is_Line_Break=	-Hyphen}', "");
    Expect(1, 45, '\P{^Is_Line_Break=	-Hyphen}', "");
    Expect(0, 46, '\p{Is_Line_Break=	-Hyphen}', "");
    Expect(1, 46, '\p{^Is_Line_Break=	-Hyphen}', "");
    Expect(1, 46, '\P{Is_Line_Break=	-Hyphen}', "");
    Expect(0, 46, '\P{^Is_Line_Break=	-Hyphen}', "");
    Error('\p{Is_Lb=:=-_HY}');
    Error('\P{Is_Lb=:=-_HY}');
    Expect(1, 45, '\p{Is_Lb=hy}', "");
    Expect(0, 45, '\p{^Is_Lb=hy}', "");
    Expect(0, 45, '\P{Is_Lb=hy}', "");
    Expect(1, 45, '\P{^Is_Lb=hy}', "");
    Expect(0, 46, '\p{Is_Lb=hy}', "");
    Expect(1, 46, '\p{^Is_Lb=hy}', "");
    Expect(1, 46, '\P{Is_Lb=hy}', "");
    Expect(0, 46, '\P{^Is_Lb=hy}', "");
    Expect(1, 45, '\p{Is_Lb=-HY}', "");
    Expect(0, 45, '\p{^Is_Lb=-HY}', "");
    Expect(0, 45, '\P{Is_Lb=-HY}', "");
    Expect(1, 45, '\P{^Is_Lb=-HY}', "");
    Expect(0, 46, '\p{Is_Lb=-HY}', "");
    Expect(1, 46, '\p{^Is_Lb=-HY}', "");
    Expect(1, 46, '\P{Is_Lb=-HY}', "");
    Expect(0, 46, '\P{^Is_Lb=-HY}', "");
    Error('\p{Line_Break= Ideographic/a/}');
    Error('\P{Line_Break= Ideographic/a/}');
    Expect(1, 262141, '\p{Line_Break=:\AIdeographic\z:}', "");;
    Expect(0, 262144, '\p{Line_Break=:\AIdeographic\z:}', "");;
    Expect(1, 262141, '\p{Line_Break=ideographic}', "");
    Expect(0, 262141, '\p{^Line_Break=ideographic}', "");
    Expect(0, 262141, '\P{Line_Break=ideographic}', "");
    Expect(1, 262141, '\P{^Line_Break=ideographic}', "");
    Expect(0, 262144, '\p{Line_Break=ideographic}', "");
    Expect(1, 262144, '\p{^Line_Break=ideographic}', "");
    Expect(1, 262144, '\P{Line_Break=ideographic}', "");
    Expect(0, 262144, '\P{^Line_Break=ideographic}', "");
    Expect(1, 262141, '\p{Line_Break=:\Aideographic\z:}', "");;
    Expect(0, 262144, '\p{Line_Break=:\Aideographic\z:}', "");;
    Expect(1, 262141, '\p{Line_Break= 	ideographic}', "");
    Expect(0, 262141, '\p{^Line_Break= 	ideographic}', "");
    Expect(0, 262141, '\P{Line_Break= 	ideographic}', "");
    Expect(1, 262141, '\P{^Line_Break= 	ideographic}', "");
    Expect(0, 262144, '\p{Line_Break= 	ideographic}', "");
    Expect(1, 262144, '\p{^Line_Break= 	ideographic}', "");
    Expect(1, 262144, '\P{Line_Break= 	ideographic}', "");
    Expect(0, 262144, '\P{^Line_Break= 	ideographic}', "");
    Error('\p{Lb=:=	-id}');
    Error('\P{Lb=:=	-id}');
    Expect(1, 262141, '\p{Lb=:\AID\z:}', "");;
    Expect(0, 262144, '\p{Lb=:\AID\z:}', "");;
    Expect(1, 262141, '\p{Lb=id}', "");
    Expect(0, 262141, '\p{^Lb=id}', "");
    Expect(0, 262141, '\P{Lb=id}', "");
    Expect(1, 262141, '\P{^Lb=id}', "");
    Expect(0, 262144, '\p{Lb=id}', "");
    Expect(1, 262144, '\p{^Lb=id}', "");
    Expect(1, 262144, '\P{Lb=id}', "");
    Expect(0, 262144, '\P{^Lb=id}', "");
    Expect(1, 262141, '\p{Lb=:\Aid\z:}', "");;
    Expect(0, 262144, '\p{Lb=:\Aid\z:}', "");;
    Expect(1, 262141, '\p{Lb: 	ID}', "");
    Expect(0, 262141, '\p{^Lb: 	ID}', "");
    Expect(0, 262141, '\P{Lb: 	ID}', "");
    Expect(1, 262141, '\P{^Lb: 	ID}', "");
    Expect(0, 262144, '\p{Lb: 	ID}', "");
    Expect(1, 262144, '\p{^Lb: 	ID}', "");
    Expect(1, 262144, '\P{Lb: 	ID}', "");
    Expect(0, 262144, '\P{^Lb: 	ID}', "");
    Error('\p{Is_Line_Break:	:=--ideographic}');
    Error('\P{Is_Line_Break:	:=--ideographic}');
    Expect(1, 262141, '\p{Is_Line_Break=ideographic}', "");
    Expect(0, 262141, '\p{^Is_Line_Break=ideographic}', "");
    Expect(0, 262141, '\P{Is_Line_Break=ideographic}', "");
    Expect(1, 262141, '\P{^Is_Line_Break=ideographic}', "");
    Expect(0, 262144, '\p{Is_Line_Break=ideographic}', "");
    Expect(1, 262144, '\p{^Is_Line_Break=ideographic}', "");
    Expect(1, 262144, '\P{Is_Line_Break=ideographic}', "");
    Expect(0, 262144, '\P{^Is_Line_Break=ideographic}', "");
    Expect(1, 262141, '\p{Is_Line_Break= Ideographic}', "");
    Expect(0, 262141, '\p{^Is_Line_Break= Ideographic}', "");
    Expect(0, 262141, '\P{Is_Line_Break= Ideographic}', "");
    Expect(1, 262141, '\P{^Is_Line_Break= Ideographic}', "");
    Expect(0, 262144, '\p{Is_Line_Break= Ideographic}', "");
    Expect(1, 262144, '\p{^Is_Line_Break= Ideographic}', "");
    Expect(1, 262144, '\P{Is_Line_Break= Ideographic}', "");
    Expect(0, 262144, '\P{^Is_Line_Break= Ideographic}', "");
    Error('\p{Is_Lb: /a/_-ID}');
    Error('\P{Is_Lb: /a/_-ID}');
    Expect(1, 262141, '\p{Is_Lb=id}', "");
    Expect(0, 262141, '\p{^Is_Lb=id}', "");
    Expect(0, 262141, '\P{Is_Lb=id}', "");
    Expect(1, 262141, '\P{^Is_Lb=id}', "");
    Expect(0, 262144, '\p{Is_Lb=id}', "");
    Expect(1, 262144, '\p{^Is_Lb=id}', "");
    Expect(1, 262144, '\P{Is_Lb=id}', "");
    Expect(0, 262144, '\P{^Is_Lb=id}', "");
    Expect(1, 262141, '\p{Is_Lb=	_ID}', "");
    Expect(0, 262141, '\p{^Is_Lb=	_ID}', "");
    Expect(0, 262141, '\P{Is_Lb=	_ID}', "");
    Expect(1, 262141, '\P{^Is_Lb=	_ID}', "");
    Expect(0, 262144, '\p{Is_Lb=	_ID}', "");
    Expect(1, 262144, '\p{^Is_Lb=	_ID}', "");
    Expect(1, 262144, '\P{Is_Lb=	_ID}', "");
    Expect(0, 262144, '\P{^Is_Lb=	_ID}', "");
    Error('\p{Line_Break= -INSEPARABLE/a/}');
    Error('\P{Line_Break= -INSEPARABLE/a/}');
    Expect(1, 68342, '\p{Line_Break=:\AInseparable\z:}', "");;
    Expect(0, 68343, '\p{Line_Break=:\AInseparable\z:}', "");;
    Expect(1, 68342, '\p{Line_Break=inseparable}', "");
    Expect(0, 68342, '\p{^Line_Break=inseparable}', "");
    Expect(0, 68342, '\P{Line_Break=inseparable}', "");
    Expect(1, 68342, '\P{^Line_Break=inseparable}', "");
    Expect(0, 68343, '\p{Line_Break=inseparable}', "");
    Expect(1, 68343, '\p{^Line_Break=inseparable}', "");
    Expect(1, 68343, '\P{Line_Break=inseparable}', "");
    Expect(0, 68343, '\P{^Line_Break=inseparable}', "");
    Expect(1, 68342, '\p{Line_Break=:\Ainseparable\z:}', "");;
    Expect(0, 68343, '\p{Line_Break=:\Ainseparable\z:}', "");;
    Expect(1, 68342, '\p{Line_Break= -Inseparable}', "");
    Expect(0, 68342, '\p{^Line_Break= -Inseparable}', "");
    Expect(0, 68342, '\P{Line_Break= -Inseparable}', "");
    Expect(1, 68342, '\P{^Line_Break= -Inseparable}', "");
    Expect(0, 68343, '\p{Line_Break= -Inseparable}', "");
    Expect(1, 68343, '\p{^Line_Break= -Inseparable}', "");
    Expect(1, 68343, '\P{Line_Break= -Inseparable}', "");
    Expect(0, 68343, '\P{^Line_Break= -Inseparable}', "");
    Error('\p{Lb=/a/ 	IN}');
    Error('\P{Lb=/a/ 	IN}');
    Expect(1, 68342, '\p{Lb=:\AIN\z:}', "");;
    Expect(0, 68343, '\p{Lb=:\AIN\z:}', "");;
    Expect(1, 68342, '\p{Lb:	in}', "");
    Expect(0, 68342, '\p{^Lb:	in}', "");
    Expect(0, 68342, '\P{Lb:	in}', "");
    Expect(1, 68342, '\P{^Lb:	in}', "");
    Expect(0, 68343, '\p{Lb:	in}', "");
    Expect(1, 68343, '\p{^Lb:	in}', "");
    Expect(1, 68343, '\P{Lb:	in}', "");
    Expect(0, 68343, '\P{^Lb:	in}', "");
    Expect(1, 68342, '\p{Lb=:\Ain\z:}', "");;
    Expect(0, 68343, '\p{Lb=:\Ain\z:}', "");;
    Expect(1, 68342, '\p{Lb:_ in}', "");
    Expect(0, 68342, '\p{^Lb:_ in}', "");
    Expect(0, 68342, '\P{Lb:_ in}', "");
    Expect(1, 68342, '\P{^Lb:_ in}', "");
    Expect(0, 68343, '\p{Lb:_ in}', "");
    Expect(1, 68343, '\p{^Lb:_ in}', "");
    Expect(1, 68343, '\P{Lb:_ in}', "");
    Expect(0, 68343, '\P{^Lb:_ in}', "");
    Error('\p{Is_Line_Break=	 Inseperable:=}');
    Error('\P{Is_Line_Break=	 Inseperable:=}');
    Expect(1, 68342, '\p{Is_Line_Break=inseperable}', "");
    Expect(0, 68342, '\p{^Is_Line_Break=inseperable}', "");
    Expect(0, 68342, '\P{Is_Line_Break=inseperable}', "");
    Expect(1, 68342, '\P{^Is_Line_Break=inseperable}', "");
    Expect(0, 68343, '\p{Is_Line_Break=inseperable}', "");
    Expect(1, 68343, '\p{^Is_Line_Break=inseperable}', "");
    Expect(1, 68343, '\P{Is_Line_Break=inseperable}', "");
    Expect(0, 68343, '\P{^Is_Line_Break=inseperable}', "");
    Expect(1, 68342, '\p{Is_Line_Break=- inseperable}', "");
    Expect(0, 68342, '\p{^Is_Line_Break=- inseperable}', "");
    Expect(0, 68342, '\P{Is_Line_Break=- inseperable}', "");
    Expect(1, 68342, '\P{^Is_Line_Break=- inseperable}', "");
    Expect(0, 68343, '\p{Is_Line_Break=- inseperable}', "");
    Expect(1, 68343, '\p{^Is_Line_Break=- inseperable}', "");
    Expect(1, 68343, '\P{Is_Line_Break=- inseperable}', "");
    Expect(0, 68343, '\P{^Is_Line_Break=- inseperable}', "");
    Error('\p{Is_Lb=		inseparable:=}');
    Error('\P{Is_Lb=		inseparable:=}');
    Expect(1, 68342, '\p{Is_Lb=inseparable}', "");
    Expect(0, 68342, '\p{^Is_Lb=inseparable}', "");
    Expect(0, 68342, '\P{Is_Lb=inseparable}', "");
    Expect(1, 68342, '\P{^Is_Lb=inseparable}', "");
    Expect(0, 68343, '\p{Is_Lb=inseparable}', "");
    Expect(1, 68343, '\p{^Is_Lb=inseparable}', "");
    Expect(1, 68343, '\P{Is_Lb=inseparable}', "");
    Expect(0, 68343, '\P{^Is_Lb=inseparable}', "");
    Expect(1, 68342, '\p{Is_Lb=_Inseparable}', "");
    Expect(0, 68342, '\p{^Is_Lb=_Inseparable}', "");
    Expect(0, 68342, '\P{Is_Lb=_Inseparable}', "");
    Expect(1, 68342, '\P{^Is_Lb=_Inseparable}', "");
    Expect(0, 68343, '\p{Is_Lb=_Inseparable}', "");
    Expect(1, 68343, '\p{^Is_Lb=_Inseparable}', "");
    Expect(1, 68343, '\P{Is_Lb=_Inseparable}', "");
    Expect(0, 68343, '\P{^Is_Lb=_Inseparable}', "");
    Error('\p{Line_Break=:=		INFIX_NUMERIC}');
    Error('\P{Line_Break=:=		INFIX_NUMERIC}');
    Expect(1, 65044, '\p{Line_Break=:\AInfix_Numeric\z:}', "");;
    Expect(0, 65045, '\p{Line_Break=:\AInfix_Numeric\z:}', "");;
    Expect(1, 65044, '\p{Line_Break: infixnumeric}', "");
    Expect(0, 65044, '\p{^Line_Break: infixnumeric}', "");
    Expect(0, 65044, '\P{Line_Break: infixnumeric}', "");
    Expect(1, 65044, '\P{^Line_Break: infixnumeric}', "");
    Expect(0, 65045, '\p{Line_Break: infixnumeric}', "");
    Expect(1, 65045, '\p{^Line_Break: infixnumeric}', "");
    Expect(1, 65045, '\P{Line_Break: infixnumeric}', "");
    Expect(0, 65045, '\P{^Line_Break: infixnumeric}', "");
    Expect(1, 65044, '\p{Line_Break=:\Ainfixnumeric\z:}', "");;
    Expect(0, 65045, '\p{Line_Break=:\Ainfixnumeric\z:}', "");;
    Expect(1, 65044, '\p{Line_Break= Infix_Numeric}', "");
    Expect(0, 65044, '\p{^Line_Break= Infix_Numeric}', "");
    Expect(0, 65044, '\P{Line_Break= Infix_Numeric}', "");
    Expect(1, 65044, '\P{^Line_Break= Infix_Numeric}', "");
    Expect(0, 65045, '\p{Line_Break= Infix_Numeric}', "");
    Expect(1, 65045, '\p{^Line_Break= Infix_Numeric}', "");
    Expect(1, 65045, '\P{Line_Break= Infix_Numeric}', "");
    Expect(0, 65045, '\P{^Line_Break= Infix_Numeric}', "");
    Error('\p{Lb=/a/	IS}');
    Error('\P{Lb=/a/	IS}');
    Expect(1, 65044, '\p{Lb=:\AIS\z:}', "");;
    Expect(0, 65045, '\p{Lb=:\AIS\z:}', "");;
    Expect(1, 65044, '\p{Lb=is}', "");
    Expect(0, 65044, '\p{^Lb=is}', "");
    Expect(0, 65044, '\P{Lb=is}', "");
    Expect(1, 65044, '\P{^Lb=is}', "");
    Expect(0, 65045, '\p{Lb=is}', "");
    Expect(1, 65045, '\p{^Lb=is}', "");
    Expect(1, 65045, '\P{Lb=is}', "");
    Expect(0, 65045, '\P{^Lb=is}', "");
    Expect(1, 65044, '\p{Lb=:\Ais\z:}', "");;
    Expect(0, 65045, '\p{Lb=:\Ais\z:}', "");;
    Expect(1, 65044, '\p{Lb=_IS}', "");
    Expect(0, 65044, '\p{^Lb=_IS}', "");
    Expect(0, 65044, '\P{Lb=_IS}', "");
    Expect(1, 65044, '\P{^Lb=_IS}', "");
    Expect(0, 65045, '\p{Lb=_IS}', "");
    Expect(1, 65045, '\p{^Lb=_IS}', "");
    Expect(1, 65045, '\P{Lb=_IS}', "");
    Expect(0, 65045, '\P{^Lb=_IS}', "");
    Error('\p{Is_Line_Break= INFIX_Numeric/a/}');
    Error('\P{Is_Line_Break= INFIX_Numeric/a/}');
    Expect(1, 65044, '\p{Is_Line_Break=infixnumeric}', "");
    Expect(0, 65044, '\p{^Is_Line_Break=infixnumeric}', "");
    Expect(0, 65044, '\P{Is_Line_Break=infixnumeric}', "");
    Expect(1, 65044, '\P{^Is_Line_Break=infixnumeric}', "");
    Expect(0, 65045, '\p{Is_Line_Break=infixnumeric}', "");
    Expect(1, 65045, '\p{^Is_Line_Break=infixnumeric}', "");
    Expect(1, 65045, '\P{Is_Line_Break=infixnumeric}', "");
    Expect(0, 65045, '\P{^Is_Line_Break=infixnumeric}', "");
    Expect(1, 65044, '\p{Is_Line_Break:		INFIX_NUMERIC}', "");
    Expect(0, 65044, '\p{^Is_Line_Break:		INFIX_NUMERIC}', "");
    Expect(0, 65044, '\P{Is_Line_Break:		INFIX_NUMERIC}', "");
    Expect(1, 65044, '\P{^Is_Line_Break:		INFIX_NUMERIC}', "");
    Expect(0, 65045, '\p{Is_Line_Break:		INFIX_NUMERIC}', "");
    Expect(1, 65045, '\p{^Is_Line_Break:		INFIX_NUMERIC}', "");
    Expect(1, 65045, '\P{Is_Line_Break:		INFIX_NUMERIC}', "");
    Expect(0, 65045, '\P{^Is_Line_Break:		INFIX_NUMERIC}', "");
    Error('\p{Is_Lb:/a/_	IS}');
    Error('\P{Is_Lb:/a/_	IS}');
    Expect(1, 65044, '\p{Is_Lb=is}', "");
    Expect(0, 65044, '\p{^Is_Lb=is}', "");
    Expect(0, 65044, '\P{Is_Lb=is}', "");
    Expect(1, 65044, '\P{^Is_Lb=is}', "");
    Expect(0, 65045, '\p{Is_Lb=is}', "");
    Expect(1, 65045, '\p{^Is_Lb=is}', "");
    Expect(1, 65045, '\P{Is_Lb=is}', "");
    Expect(0, 65045, '\P{^Is_Lb=is}', "");
    Expect(1, 65044, '\p{Is_Lb=-	IS}', "");
    Expect(0, 65044, '\p{^Is_Lb=-	IS}', "");
    Expect(0, 65044, '\P{Is_Lb=-	IS}', "");
    Expect(1, 65044, '\P{^Is_Lb=-	IS}', "");
    Expect(0, 65045, '\p{Is_Lb=-	IS}', "");
    Expect(1, 65045, '\p{^Is_Lb=-	IS}', "");
    Expect(1, 65045, '\P{Is_Lb=-	IS}', "");
    Expect(0, 65045, '\P{^Is_Lb=-	IS}', "");
    Error('\p{Line_Break=	-JL/a/}');
    Error('\P{Line_Break=	-JL/a/}');
    Expect(1, 43388, '\p{Line_Break=:\AJL\z:}', "");;
    Expect(0, 43389, '\p{Line_Break=:\AJL\z:}', "");;
    Expect(1, 43388, '\p{Line_Break:   jl}', "");
    Expect(0, 43388, '\p{^Line_Break:   jl}', "");
    Expect(0, 43388, '\P{Line_Break:   jl}', "");
    Expect(1, 43388, '\P{^Line_Break:   jl}', "");
    Expect(0, 43389, '\p{Line_Break:   jl}', "");
    Expect(1, 43389, '\p{^Line_Break:   jl}', "");
    Expect(1, 43389, '\P{Line_Break:   jl}', "");
    Expect(0, 43389, '\P{^Line_Break:   jl}', "");
    Expect(1, 43388, '\p{Line_Break=:\Ajl\z:}', "");;
    Expect(0, 43389, '\p{Line_Break=:\Ajl\z:}', "");;
    Expect(1, 43388, '\p{Line_Break=  JL}', "");
    Expect(0, 43388, '\p{^Line_Break=  JL}', "");
    Expect(0, 43388, '\P{Line_Break=  JL}', "");
    Expect(1, 43388, '\P{^Line_Break=  JL}', "");
    Expect(0, 43389, '\p{Line_Break=  JL}', "");
    Expect(1, 43389, '\p{^Line_Break=  JL}', "");
    Expect(1, 43389, '\P{Line_Break=  JL}', "");
    Expect(0, 43389, '\P{^Line_Break=  JL}', "");
    Error('\p{Lb=/a/JL}');
    Error('\P{Lb=/a/JL}');
    Expect(1, 43388, '\p{Lb=:\AJL\z:}', "");;
    Expect(0, 43389, '\p{Lb=:\AJL\z:}', "");;
    Expect(1, 43388, '\p{Lb=jl}', "");
    Expect(0, 43388, '\p{^Lb=jl}', "");
    Expect(0, 43388, '\P{Lb=jl}', "");
    Expect(1, 43388, '\P{^Lb=jl}', "");
    Expect(0, 43389, '\p{Lb=jl}', "");
    Expect(1, 43389, '\p{^Lb=jl}', "");
    Expect(1, 43389, '\P{Lb=jl}', "");
    Expect(0, 43389, '\P{^Lb=jl}', "");
    Expect(1, 43388, '\p{Lb=:\Ajl\z:}', "");;
    Expect(0, 43389, '\p{Lb=:\Ajl\z:}', "");;
    Expect(1, 43388, '\p{Lb=__JL}', "");
    Expect(0, 43388, '\p{^Lb=__JL}', "");
    Expect(0, 43388, '\P{Lb=__JL}', "");
    Expect(1, 43388, '\P{^Lb=__JL}', "");
    Expect(0, 43389, '\p{Lb=__JL}', "");
    Expect(1, 43389, '\p{^Lb=__JL}', "");
    Expect(1, 43389, '\P{Lb=__JL}', "");
    Expect(0, 43389, '\P{^Lb=__JL}', "");
    Error('\p{Is_Line_Break= :=JL}');
    Error('\P{Is_Line_Break= :=JL}');
    Expect(1, 43388, '\p{Is_Line_Break=jl}', "");
    Expect(0, 43388, '\p{^Is_Line_Break=jl}', "");
    Expect(0, 43388, '\P{Is_Line_Break=jl}', "");
    Expect(1, 43388, '\P{^Is_Line_Break=jl}', "");
    Expect(0, 43389, '\p{Is_Line_Break=jl}', "");
    Expect(1, 43389, '\p{^Is_Line_Break=jl}', "");
    Expect(1, 43389, '\P{Is_Line_Break=jl}', "");
    Expect(0, 43389, '\P{^Is_Line_Break=jl}', "");
    Expect(1, 43388, '\p{Is_Line_Break=--jl}', "");
    Expect(0, 43388, '\p{^Is_Line_Break=--jl}', "");
    Expect(0, 43388, '\P{Is_Line_Break=--jl}', "");
    Expect(1, 43388, '\P{^Is_Line_Break=--jl}', "");
    Expect(0, 43389, '\p{Is_Line_Break=--jl}', "");
    Expect(1, 43389, '\p{^Is_Line_Break=--jl}', "");
    Expect(1, 43389, '\P{Is_Line_Break=--jl}', "");
    Expect(0, 43389, '\P{^Is_Line_Break=--jl}', "");
    Error('\p{Is_Lb=	-JL/a/}');
    Error('\P{Is_Lb=	-JL/a/}');
    Expect(1, 43388, '\p{Is_Lb=jl}', "");
    Expect(0, 43388, '\p{^Is_Lb=jl}', "");
    Expect(0, 43388, '\P{Is_Lb=jl}', "");
    Expect(1, 43388, '\P{^Is_Lb=jl}', "");
    Expect(0, 43389, '\p{Is_Lb=jl}', "");
    Expect(1, 43389, '\p{^Is_Lb=jl}', "");
    Expect(1, 43389, '\P{Is_Lb=jl}', "");
    Expect(0, 43389, '\P{^Is_Lb=jl}', "");
    Expect(1, 43388, '\p{Is_Lb=-	JL}', "");
    Expect(0, 43388, '\p{^Is_Lb=-	JL}', "");
    Expect(0, 43388, '\P{Is_Lb=-	JL}', "");
    Expect(1, 43388, '\P{^Is_Lb=-	JL}', "");
    Expect(0, 43389, '\p{Is_Lb=-	JL}', "");
    Expect(1, 43389, '\p{^Is_Lb=-	JL}', "");
    Expect(1, 43389, '\P{Is_Lb=-	JL}', "");
    Expect(0, 43389, '\P{^Is_Lb=-	JL}', "");
    Error('\p{Line_Break= 	jt:=}');
    Error('\P{Line_Break= 	jt:=}');
    Expect(1, 55291, '\p{Line_Break=:\AJT\z:}', "");;
    Expect(0, 55292, '\p{Line_Break=:\AJT\z:}', "");;
    Expect(1, 55291, '\p{Line_Break=jt}', "");
    Expect(0, 55291, '\p{^Line_Break=jt}', "");
    Expect(0, 55291, '\P{Line_Break=jt}', "");
    Expect(1, 55291, '\P{^Line_Break=jt}', "");
    Expect(0, 55292, '\p{Line_Break=jt}', "");
    Expect(1, 55292, '\p{^Line_Break=jt}', "");
    Expect(1, 55292, '\P{Line_Break=jt}', "");
    Expect(0, 55292, '\P{^Line_Break=jt}', "");
    Expect(1, 55291, '\p{Line_Break=:\Ajt\z:}', "");;
    Expect(0, 55292, '\p{Line_Break=:\Ajt\z:}', "");;
    Expect(1, 55291, '\p{Line_Break:__JT}', "");
    Expect(0, 55291, '\p{^Line_Break:__JT}', "");
    Expect(0, 55291, '\P{Line_Break:__JT}', "");
    Expect(1, 55291, '\P{^Line_Break:__JT}', "");
    Expect(0, 55292, '\p{Line_Break:__JT}', "");
    Expect(1, 55292, '\p{^Line_Break:__JT}', "");
    Expect(1, 55292, '\P{Line_Break:__JT}', "");
    Expect(0, 55292, '\P{^Line_Break:__JT}', "");
    Error('\p{Lb= /a/JT}');
    Error('\P{Lb= /a/JT}');
    Expect(1, 55291, '\p{Lb=:\AJT\z:}', "");;
    Expect(0, 55292, '\p{Lb=:\AJT\z:}', "");;
    Expect(1, 55291, '\p{Lb=jt}', "");
    Expect(0, 55291, '\p{^Lb=jt}', "");
    Expect(0, 55291, '\P{Lb=jt}', "");
    Expect(1, 55291, '\P{^Lb=jt}', "");
    Expect(0, 55292, '\p{Lb=jt}', "");
    Expect(1, 55292, '\p{^Lb=jt}', "");
    Expect(1, 55292, '\P{Lb=jt}', "");
    Expect(0, 55292, '\P{^Lb=jt}', "");
    Expect(1, 55291, '\p{Lb=:\Ajt\z:}', "");;
    Expect(0, 55292, '\p{Lb=:\Ajt\z:}', "");;
    Expect(1, 55291, '\p{Lb= JT}', "");
    Expect(0, 55291, '\p{^Lb= JT}', "");
    Expect(0, 55291, '\P{Lb= JT}', "");
    Expect(1, 55291, '\P{^Lb= JT}', "");
    Expect(0, 55292, '\p{Lb= JT}', "");
    Expect(1, 55292, '\p{^Lb= JT}', "");
    Expect(1, 55292, '\P{Lb= JT}', "");
    Expect(0, 55292, '\P{^Lb= JT}', "");
    Error('\p{Is_Line_Break=/a/-_JT}');
    Error('\P{Is_Line_Break=/a/-_JT}');
    Expect(1, 55291, '\p{Is_Line_Break=jt}', "");
    Expect(0, 55291, '\p{^Is_Line_Break=jt}', "");
    Expect(0, 55291, '\P{Is_Line_Break=jt}', "");
    Expect(1, 55291, '\P{^Is_Line_Break=jt}', "");
    Expect(0, 55292, '\p{Is_Line_Break=jt}', "");
    Expect(1, 55292, '\p{^Is_Line_Break=jt}', "");
    Expect(1, 55292, '\P{Is_Line_Break=jt}', "");
    Expect(0, 55292, '\P{^Is_Line_Break=jt}', "");
    Expect(1, 55291, '\p{Is_Line_Break=		jt}', "");
    Expect(0, 55291, '\p{^Is_Line_Break=		jt}', "");
    Expect(0, 55291, '\P{Is_Line_Break=		jt}', "");
    Expect(1, 55291, '\P{^Is_Line_Break=		jt}', "");
    Expect(0, 55292, '\p{Is_Line_Break=		jt}', "");
    Expect(1, 55292, '\p{^Is_Line_Break=		jt}', "");
    Expect(1, 55292, '\P{Is_Line_Break=		jt}', "");
    Expect(0, 55292, '\P{^Is_Line_Break=		jt}', "");
    Error('\p{Is_Lb: /a/_jt}');
    Error('\P{Is_Lb: /a/_jt}');
    Expect(1, 55291, '\p{Is_Lb=jt}', "");
    Expect(0, 55291, '\p{^Is_Lb=jt}', "");
    Expect(0, 55291, '\P{Is_Lb=jt}', "");
    Expect(1, 55291, '\P{^Is_Lb=jt}', "");
    Expect(0, 55292, '\p{Is_Lb=jt}', "");
    Expect(1, 55292, '\p{^Is_Lb=jt}', "");
    Expect(1, 55292, '\P{Is_Lb=jt}', "");
    Expect(0, 55292, '\P{^Is_Lb=jt}', "");
    Expect(1, 55291, '\p{Is_Lb= -JT}', "");
    Expect(0, 55291, '\p{^Is_Lb= -JT}', "");
    Expect(0, 55291, '\P{Is_Lb= -JT}', "");
    Expect(1, 55291, '\P{^Is_Lb= -JT}', "");
    Expect(0, 55292, '\p{Is_Lb= -JT}', "");
    Expect(1, 55292, '\p{^Is_Lb= -JT}', "");
    Expect(1, 55292, '\P{Is_Lb= -JT}', "");
    Expect(0, 55292, '\P{^Is_Lb= -JT}', "");
    Error('\p{Line_Break=-:=JV}');
    Error('\P{Line_Break=-:=JV}');
    Expect(1, 55238, '\p{Line_Break=:\AJV\z:}', "");;
    Expect(0, 55239, '\p{Line_Break=:\AJV\z:}', "");;
    Expect(1, 55238, '\p{Line_Break=jv}', "");
    Expect(0, 55238, '\p{^Line_Break=jv}', "");
    Expect(0, 55238, '\P{Line_Break=jv}', "");
    Expect(1, 55238, '\P{^Line_Break=jv}', "");
    Expect(0, 55239, '\p{Line_Break=jv}', "");
    Expect(1, 55239, '\p{^Line_Break=jv}', "");
    Expect(1, 55239, '\P{Line_Break=jv}', "");
    Expect(0, 55239, '\P{^Line_Break=jv}', "");
    Expect(1, 55238, '\p{Line_Break=:\Ajv\z:}', "");;
    Expect(0, 55239, '\p{Line_Break=:\Ajv\z:}', "");;
    Expect(1, 55238, '\p{Line_Break= _jv}', "");
    Expect(0, 55238, '\p{^Line_Break= _jv}', "");
    Expect(0, 55238, '\P{Line_Break= _jv}', "");
    Expect(1, 55238, '\P{^Line_Break= _jv}', "");
    Expect(0, 55239, '\p{Line_Break= _jv}', "");
    Expect(1, 55239, '\p{^Line_Break= _jv}', "");
    Expect(1, 55239, '\P{Line_Break= _jv}', "");
    Expect(0, 55239, '\P{^Line_Break= _jv}', "");
    Error('\p{Lb=-	jv/a/}');
    Error('\P{Lb=-	jv/a/}');
    Expect(1, 55238, '\p{Lb=:\AJV\z:}', "");;
    Expect(0, 55239, '\p{Lb=:\AJV\z:}', "");;
    Expect(1, 55238, '\p{Lb=jv}', "");
    Expect(0, 55238, '\p{^Lb=jv}', "");
    Expect(0, 55238, '\P{Lb=jv}', "");
    Expect(1, 55238, '\P{^Lb=jv}', "");
    Expect(0, 55239, '\p{Lb=jv}', "");
    Expect(1, 55239, '\p{^Lb=jv}', "");
    Expect(1, 55239, '\P{Lb=jv}', "");
    Expect(0, 55239, '\P{^Lb=jv}', "");
    Expect(1, 55238, '\p{Lb=:\Ajv\z:}', "");;
    Expect(0, 55239, '\p{Lb=:\Ajv\z:}', "");;
    Expect(1, 55238, '\p{Lb=_ JV}', "");
    Expect(0, 55238, '\p{^Lb=_ JV}', "");
    Expect(0, 55238, '\P{Lb=_ JV}', "");
    Expect(1, 55238, '\P{^Lb=_ JV}', "");
    Expect(0, 55239, '\p{Lb=_ JV}', "");
    Expect(1, 55239, '\p{^Lb=_ JV}', "");
    Expect(1, 55239, '\P{Lb=_ JV}', "");
    Expect(0, 55239, '\P{^Lb=_ JV}', "");
    Error('\p{Is_Line_Break=-/a/JV}');
    Error('\P{Is_Line_Break=-/a/JV}');
    Expect(1, 55238, '\p{Is_Line_Break=jv}', "");
    Expect(0, 55238, '\p{^Is_Line_Break=jv}', "");
    Expect(0, 55238, '\P{Is_Line_Break=jv}', "");
    Expect(1, 55238, '\P{^Is_Line_Break=jv}', "");
    Expect(0, 55239, '\p{Is_Line_Break=jv}', "");
    Expect(1, 55239, '\p{^Is_Line_Break=jv}', "");
    Expect(1, 55239, '\P{Is_Line_Break=jv}', "");
    Expect(0, 55239, '\P{^Is_Line_Break=jv}', "");
    Expect(1, 55238, '\p{Is_Line_Break=JV}', "");
    Expect(0, 55238, '\p{^Is_Line_Break=JV}', "");
    Expect(0, 55238, '\P{Is_Line_Break=JV}', "");
    Expect(1, 55238, '\P{^Is_Line_Break=JV}', "");
    Expect(0, 55239, '\p{Is_Line_Break=JV}', "");
    Expect(1, 55239, '\p{^Is_Line_Break=JV}', "");
    Expect(1, 55239, '\P{Is_Line_Break=JV}', "");
    Expect(0, 55239, '\P{^Is_Line_Break=JV}', "");
    Error('\p{Is_Lb:  	JV/a/}');
    Error('\P{Is_Lb:  	JV/a/}');
    Expect(1, 55238, '\p{Is_Lb=jv}', "");
    Expect(0, 55238, '\p{^Is_Lb=jv}', "");
    Expect(0, 55238, '\P{Is_Lb=jv}', "");
    Expect(1, 55238, '\P{^Is_Lb=jv}', "");
    Expect(0, 55239, '\p{Is_Lb=jv}', "");
    Expect(1, 55239, '\p{^Is_Lb=jv}', "");
    Expect(1, 55239, '\P{Is_Lb=jv}', "");
    Expect(0, 55239, '\P{^Is_Lb=jv}', "");
    Expect(1, 55238, '\p{Is_Lb=	JV}', "");
    Expect(0, 55238, '\p{^Is_Lb=	JV}', "");
    Expect(0, 55238, '\P{Is_Lb=	JV}', "");
    Expect(1, 55238, '\P{^Is_Lb=	JV}', "");
    Expect(0, 55239, '\p{Is_Lb=	JV}', "");
    Expect(1, 55239, '\p{^Is_Lb=	JV}', "");
    Expect(1, 55239, '\P{Is_Lb=	JV}', "");
    Expect(0, 55239, '\P{^Is_Lb=	JV}', "");
    Error('\p{Line_Break=	:=Line_feed}');
    Error('\P{Line_Break=	:=Line_feed}');
    Expect(1, 10, '\p{Line_Break=:\ALine_Feed\z:}', "");;
    Expect(0, 11, '\p{Line_Break=:\ALine_Feed\z:}', "");;
    Expect(1, 10, '\p{Line_Break=linefeed}', "");
    Expect(0, 10, '\p{^Line_Break=linefeed}', "");
    Expect(0, 10, '\P{Line_Break=linefeed}', "");
    Expect(1, 10, '\P{^Line_Break=linefeed}', "");
    Expect(0, 11, '\p{Line_Break=linefeed}', "");
    Expect(1, 11, '\p{^Line_Break=linefeed}', "");
    Expect(1, 11, '\P{Line_Break=linefeed}', "");
    Expect(0, 11, '\P{^Line_Break=linefeed}', "");
    Expect(1, 10, '\p{Line_Break=:\Alinefeed\z:}', "");;
    Expect(0, 11, '\p{Line_Break=:\Alinefeed\z:}', "");;
    Expect(1, 10, '\p{Line_Break=_ line_feed}', "");
    Expect(0, 10, '\p{^Line_Break=_ line_feed}', "");
    Expect(0, 10, '\P{Line_Break=_ line_feed}', "");
    Expect(1, 10, '\P{^Line_Break=_ line_feed}', "");
    Expect(0, 11, '\p{Line_Break=_ line_feed}', "");
    Expect(1, 11, '\p{^Line_Break=_ line_feed}', "");
    Expect(1, 11, '\P{Line_Break=_ line_feed}', "");
    Expect(0, 11, '\P{^Line_Break=_ line_feed}', "");
    Error('\p{Lb= 	LF:=}');
    Error('\P{Lb= 	LF:=}');
    Expect(1, 10, '\p{Lb=:\ALF\z:}', "");;
    Expect(0, 11, '\p{Lb=:\ALF\z:}', "");;
    Expect(1, 10, '\p{Lb:	lf}', "");
    Expect(0, 10, '\p{^Lb:	lf}', "");
    Expect(0, 10, '\P{Lb:	lf}', "");
    Expect(1, 10, '\P{^Lb:	lf}', "");
    Expect(0, 11, '\p{Lb:	lf}', "");
    Expect(1, 11, '\p{^Lb:	lf}', "");
    Expect(1, 11, '\P{Lb:	lf}', "");
    Expect(0, 11, '\P{^Lb:	lf}', "");
    Expect(1, 10, '\p{Lb=:\Alf\z:}', "");;
    Expect(0, 11, '\p{Lb=:\Alf\z:}', "");;
    Expect(1, 10, '\p{Lb=-LF}', "");
    Expect(0, 10, '\p{^Lb=-LF}', "");
    Expect(0, 10, '\P{Lb=-LF}', "");
    Expect(1, 10, '\P{^Lb=-LF}', "");
    Expect(0, 11, '\p{Lb=-LF}', "");
    Expect(1, 11, '\p{^Lb=-LF}', "");
    Expect(1, 11, '\P{Lb=-LF}', "");
    Expect(0, 11, '\P{^Lb=-LF}', "");
    Error('\p{Is_Line_Break=/a/_Line_feed}');
    Error('\P{Is_Line_Break=/a/_Line_feed}');
    Expect(1, 10, '\p{Is_Line_Break=linefeed}', "");
    Expect(0, 10, '\p{^Is_Line_Break=linefeed}', "");
    Expect(0, 10, '\P{Is_Line_Break=linefeed}', "");
    Expect(1, 10, '\P{^Is_Line_Break=linefeed}', "");
    Expect(0, 11, '\p{Is_Line_Break=linefeed}', "");
    Expect(1, 11, '\p{^Is_Line_Break=linefeed}', "");
    Expect(1, 11, '\P{Is_Line_Break=linefeed}', "");
    Expect(0, 11, '\P{^Is_Line_Break=linefeed}', "");
    Expect(1, 10, '\p{Is_Line_Break=-LINE_FEED}', "");
    Expect(0, 10, '\p{^Is_Line_Break=-LINE_FEED}', "");
    Expect(0, 10, '\P{Is_Line_Break=-LINE_FEED}', "");
    Expect(1, 10, '\P{^Is_Line_Break=-LINE_FEED}', "");
    Expect(0, 11, '\p{Is_Line_Break=-LINE_FEED}', "");
    Expect(1, 11, '\p{^Is_Line_Break=-LINE_FEED}', "");
    Expect(1, 11, '\P{Is_Line_Break=-LINE_FEED}', "");
    Expect(0, 11, '\P{^Is_Line_Break=-LINE_FEED}', "");
    Error('\p{Is_Lb=:=	-LF}');
    Error('\P{Is_Lb=:=	-LF}');
    Expect(1, 10, '\p{Is_Lb=lf}', "");
    Expect(0, 10, '\p{^Is_Lb=lf}', "");
    Expect(0, 10, '\P{Is_Lb=lf}', "");
    Expect(1, 10, '\P{^Is_Lb=lf}', "");
    Expect(0, 11, '\p{Is_Lb=lf}', "");
    Expect(1, 11, '\p{^Is_Lb=lf}', "");
    Expect(1, 11, '\P{Is_Lb=lf}', "");
    Expect(0, 11, '\P{^Is_Lb=lf}', "");
    Expect(1, 10, '\p{Is_Lb=_lf}', "");
    Expect(0, 10, '\p{^Is_Lb=_lf}', "");
    Expect(0, 10, '\P{Is_Lb=_lf}', "");
    Expect(1, 10, '\P{^Is_Lb=_lf}', "");
    Expect(0, 11, '\p{Is_Lb=_lf}', "");
    Expect(1, 11, '\p{^Is_Lb=_lf}', "");
    Expect(1, 11, '\P{Is_Lb=_lf}', "");
    Expect(0, 11, '\P{^Is_Lb=_lf}', "");
    Error('\p{Line_Break=/a/NEXT_line}');
    Error('\P{Line_Break=/a/NEXT_line}');
    Expect(1, 133, '\p{Line_Break=:\ANext_Line\z:}', "");;
    Expect(0, 134, '\p{Line_Break=:\ANext_Line\z:}', "");;
    Expect(1, 133, '\p{Line_Break=nextline}', "");
    Expect(0, 133, '\p{^Line_Break=nextline}', "");
    Expect(0, 133, '\P{Line_Break=nextline}', "");
    Expect(1, 133, '\P{^Line_Break=nextline}', "");
    Expect(0, 134, '\p{Line_Break=nextline}', "");
    Expect(1, 134, '\p{^Line_Break=nextline}', "");
    Expect(1, 134, '\P{Line_Break=nextline}', "");
    Expect(0, 134, '\P{^Line_Break=nextline}', "");
    Expect(1, 133, '\p{Line_Break=:\Anextline\z:}', "");;
    Expect(0, 134, '\p{Line_Break=:\Anextline\z:}', "");;
    Expect(1, 133, '\p{Line_Break=_ NEXT_Line}', "");
    Expect(0, 133, '\p{^Line_Break=_ NEXT_Line}', "");
    Expect(0, 133, '\P{Line_Break=_ NEXT_Line}', "");
    Expect(1, 133, '\P{^Line_Break=_ NEXT_Line}', "");
    Expect(0, 134, '\p{Line_Break=_ NEXT_Line}', "");
    Expect(1, 134, '\p{^Line_Break=_ NEXT_Line}', "");
    Expect(1, 134, '\P{Line_Break=_ NEXT_Line}', "");
    Expect(0, 134, '\P{^Line_Break=_ NEXT_Line}', "");
    Error('\p{Lb=_:=NL}');
    Error('\P{Lb=_:=NL}');
    Expect(1, 133, '\p{Lb=:\ANL\z:}', "");;
    Expect(0, 134, '\p{Lb=:\ANL\z:}', "");;
    Expect(1, 133, '\p{Lb=nl}', "");
    Expect(0, 133, '\p{^Lb=nl}', "");
    Expect(0, 133, '\P{Lb=nl}', "");
    Expect(1, 133, '\P{^Lb=nl}', "");
    Expect(0, 134, '\p{Lb=nl}', "");
    Expect(1, 134, '\p{^Lb=nl}', "");
    Expect(1, 134, '\P{Lb=nl}', "");
    Expect(0, 134, '\P{^Lb=nl}', "");
    Expect(1, 133, '\p{Lb=:\Anl\z:}', "");;
    Expect(0, 134, '\p{Lb=:\Anl\z:}', "");;
    Expect(1, 133, '\p{Lb= NL}', "");
    Expect(0, 133, '\p{^Lb= NL}', "");
    Expect(0, 133, '\P{Lb= NL}', "");
    Expect(1, 133, '\P{^Lb= NL}', "");
    Expect(0, 134, '\p{Lb= NL}', "");
    Expect(1, 134, '\p{^Lb= NL}', "");
    Expect(1, 134, '\P{Lb= NL}', "");
    Expect(0, 134, '\P{^Lb= NL}', "");
    Error('\p{Is_Line_Break=		Next_line:=}');
    Error('\P{Is_Line_Break=		Next_line:=}');
    Expect(1, 133, '\p{Is_Line_Break=nextline}', "");
    Expect(0, 133, '\p{^Is_Line_Break=nextline}', "");
    Expect(0, 133, '\P{Is_Line_Break=nextline}', "");
    Expect(1, 133, '\P{^Is_Line_Break=nextline}', "");
    Expect(0, 134, '\p{Is_Line_Break=nextline}', "");
    Expect(1, 134, '\p{^Is_Line_Break=nextline}', "");
    Expect(1, 134, '\P{Is_Line_Break=nextline}', "");
    Expect(0, 134, '\P{^Is_Line_Break=nextline}', "");
    Expect(1, 133, '\p{Is_Line_Break= -Next_LINE}', "");
    Expect(0, 133, '\p{^Is_Line_Break= -Next_LINE}', "");
    Expect(0, 133, '\P{Is_Line_Break= -Next_LINE}', "");
    Expect(1, 133, '\P{^Is_Line_Break= -Next_LINE}', "");
    Expect(0, 134, '\p{Is_Line_Break= -Next_LINE}', "");
    Expect(1, 134, '\p{^Is_Line_Break= -Next_LINE}', "");
    Expect(1, 134, '\P{Is_Line_Break= -Next_LINE}', "");
    Expect(0, 134, '\P{^Is_Line_Break= -Next_LINE}', "");
    Error('\p{Is_Lb= :=NL}');
    Error('\P{Is_Lb= :=NL}');
    Expect(1, 133, '\p{Is_Lb=nl}', "");
    Expect(0, 133, '\p{^Is_Lb=nl}', "");
    Expect(0, 133, '\P{Is_Lb=nl}', "");
    Expect(1, 133, '\P{^Is_Lb=nl}', "");
    Expect(0, 134, '\p{Is_Lb=nl}', "");
    Expect(1, 134, '\p{^Is_Lb=nl}', "");
    Expect(1, 134, '\P{Is_Lb=nl}', "");
    Expect(0, 134, '\P{^Is_Lb=nl}', "");
    Expect(1, 133, '\p{Is_Lb=__NL}', "");
    Expect(0, 133, '\p{^Is_Lb=__NL}', "");
    Expect(0, 133, '\P{Is_Lb=__NL}', "");
    Expect(1, 133, '\P{^Is_Lb=__NL}', "");
    Expect(0, 134, '\p{Is_Lb=__NL}', "");
    Expect(1, 134, '\p{^Is_Lb=__NL}', "");
    Expect(1, 134, '\P{Is_Lb=__NL}', "");
    Expect(0, 134, '\P{^Is_Lb=__NL}', "");
    Error('\p{Line_Break=/a/Nonstarter}');
    Error('\P{Line_Break=/a/Nonstarter}');
    Expect(1, 128635, '\p{Line_Break=:\ANonstarter\z:}', "");;
    Expect(0, 128636, '\p{Line_Break=:\ANonstarter\z:}', "");;
    Expect(1, 128635, '\p{Line_Break=nonstarter}', "");
    Expect(0, 128635, '\p{^Line_Break=nonstarter}', "");
    Expect(0, 128635, '\P{Line_Break=nonstarter}', "");
    Expect(1, 128635, '\P{^Line_Break=nonstarter}', "");
    Expect(0, 128636, '\p{Line_Break=nonstarter}', "");
    Expect(1, 128636, '\p{^Line_Break=nonstarter}', "");
    Expect(1, 128636, '\P{Line_Break=nonstarter}', "");
    Expect(0, 128636, '\P{^Line_Break=nonstarter}', "");
    Expect(1, 128635, '\p{Line_Break=:\Anonstarter\z:}', "");;
    Expect(0, 128636, '\p{Line_Break=:\Anonstarter\z:}', "");;
    Expect(1, 128635, '\p{Line_Break=__Nonstarter}', "");
    Expect(0, 128635, '\p{^Line_Break=__Nonstarter}', "");
    Expect(0, 128635, '\P{Line_Break=__Nonstarter}', "");
    Expect(1, 128635, '\P{^Line_Break=__Nonstarter}', "");
    Expect(0, 128636, '\p{Line_Break=__Nonstarter}', "");
    Expect(1, 128636, '\p{^Line_Break=__Nonstarter}', "");
    Expect(1, 128636, '\P{Line_Break=__Nonstarter}', "");
    Expect(0, 128636, '\P{^Line_Break=__Nonstarter}', "");
    Error('\p{Lb=_:=NS}');
    Error('\P{Lb=_:=NS}');
    Expect(1, 128635, '\p{Lb=:\ANS\z:}', "");;
    Expect(0, 128636, '\p{Lb=:\ANS\z:}', "");;
    Expect(1, 128635, '\p{Lb=ns}', "");
    Expect(0, 128635, '\p{^Lb=ns}', "");
    Expect(0, 128635, '\P{Lb=ns}', "");
    Expect(1, 128635, '\P{^Lb=ns}', "");
    Expect(0, 128636, '\p{Lb=ns}', "");
    Expect(1, 128636, '\p{^Lb=ns}', "");
    Expect(1, 128636, '\P{Lb=ns}', "");
    Expect(0, 128636, '\P{^Lb=ns}', "");
    Expect(1, 128635, '\p{Lb=:\Ans\z:}', "");;
    Expect(0, 128636, '\p{Lb=:\Ans\z:}', "");;
    Expect(1, 128635, '\p{Lb=  NS}', "");
    Expect(0, 128635, '\p{^Lb=  NS}', "");
    Expect(0, 128635, '\P{Lb=  NS}', "");
    Expect(1, 128635, '\P{^Lb=  NS}', "");
    Expect(0, 128636, '\p{Lb=  NS}', "");
    Expect(1, 128636, '\p{^Lb=  NS}', "");
    Expect(1, 128636, '\P{Lb=  NS}', "");
    Expect(0, 128636, '\P{^Lb=  NS}', "");
    Error('\p{Is_Line_Break:   /a/-	NONSTARTER}');
    Error('\P{Is_Line_Break:   /a/-	NONSTARTER}');
    Expect(1, 128635, '\p{Is_Line_Break=nonstarter}', "");
    Expect(0, 128635, '\p{^Is_Line_Break=nonstarter}', "");
    Expect(0, 128635, '\P{Is_Line_Break=nonstarter}', "");
    Expect(1, 128635, '\P{^Is_Line_Break=nonstarter}', "");
    Expect(0, 128636, '\p{Is_Line_Break=nonstarter}', "");
    Expect(1, 128636, '\p{^Is_Line_Break=nonstarter}', "");
    Expect(1, 128636, '\P{Is_Line_Break=nonstarter}', "");
    Expect(0, 128636, '\P{^Is_Line_Break=nonstarter}', "");
    Expect(1, 128635, '\p{Is_Line_Break=_	NONSTARTER}', "");
    Expect(0, 128635, '\p{^Is_Line_Break=_	NONSTARTER}', "");
    Expect(0, 128635, '\P{Is_Line_Break=_	NONSTARTER}', "");
    Expect(1, 128635, '\P{^Is_Line_Break=_	NONSTARTER}', "");
    Expect(0, 128636, '\p{Is_Line_Break=_	NONSTARTER}', "");
    Expect(1, 128636, '\p{^Is_Line_Break=_	NONSTARTER}', "");
    Expect(1, 128636, '\P{Is_Line_Break=_	NONSTARTER}', "");
    Expect(0, 128636, '\P{^Is_Line_Break=_	NONSTARTER}', "");
    Error('\p{Is_Lb=:=	_ns}');
    Error('\P{Is_Lb=:=	_ns}');
    Expect(1, 128635, '\p{Is_Lb=ns}', "");
    Expect(0, 128635, '\p{^Is_Lb=ns}', "");
    Expect(0, 128635, '\P{Is_Lb=ns}', "");
    Expect(1, 128635, '\P{^Is_Lb=ns}', "");
    Expect(0, 128636, '\p{Is_Lb=ns}', "");
    Expect(1, 128636, '\p{^Is_Lb=ns}', "");
    Expect(1, 128636, '\P{Is_Lb=ns}', "");
    Expect(0, 128636, '\P{^Is_Lb=ns}', "");
    Expect(1, 128635, '\p{Is_Lb=	-NS}', "");
    Expect(0, 128635, '\p{^Is_Lb=	-NS}', "");
    Expect(0, 128635, '\P{Is_Lb=	-NS}', "");
    Expect(1, 128635, '\P{^Is_Lb=	-NS}', "");
    Expect(0, 128636, '\p{Is_Lb=	-NS}', "");
    Expect(1, 128636, '\p{^Is_Lb=	-NS}', "");
    Expect(1, 128636, '\P{Is_Lb=	-NS}', "");
    Expect(0, 128636, '\P{^Is_Lb=	-NS}', "");
    Error('\p{Line_Break:	 /a/NUMERIC}');
    Error('\P{Line_Break:	 /a/NUMERIC}');
    Expect(1, 125273, '\p{Line_Break=:\ANumeric\z:}', "");;
    Expect(0, 125274, '\p{Line_Break=:\ANumeric\z:}', "");;
    Expect(1, 125273, '\p{Line_Break=numeric}', "");
    Expect(0, 125273, '\p{^Line_Break=numeric}', "");
    Expect(0, 125273, '\P{Line_Break=numeric}', "");
    Expect(1, 125273, '\P{^Line_Break=numeric}', "");
    Expect(0, 125274, '\p{Line_Break=numeric}', "");
    Expect(1, 125274, '\p{^Line_Break=numeric}', "");
    Expect(1, 125274, '\P{Line_Break=numeric}', "");
    Expect(0, 125274, '\P{^Line_Break=numeric}', "");
    Expect(1, 125273, '\p{Line_Break=:\Anumeric\z:}', "");;
    Expect(0, 125274, '\p{Line_Break=:\Anumeric\z:}', "");;
    Expect(1, 125273, '\p{Line_Break=  numeric}', "");
    Expect(0, 125273, '\p{^Line_Break=  numeric}', "");
    Expect(0, 125273, '\P{Line_Break=  numeric}', "");
    Expect(1, 125273, '\P{^Line_Break=  numeric}', "");
    Expect(0, 125274, '\p{Line_Break=  numeric}', "");
    Expect(1, 125274, '\p{^Line_Break=  numeric}', "");
    Expect(1, 125274, '\P{Line_Break=  numeric}', "");
    Expect(0, 125274, '\P{^Line_Break=  numeric}', "");
    Error('\p{Lb=	 nu:=}');
    Error('\P{Lb=	 nu:=}');
    Expect(1, 125273, '\p{Lb=:\ANU\z:}', "");;
    Expect(0, 125274, '\p{Lb=:\ANU\z:}', "");;
    Expect(1, 125273, '\p{Lb=nu}', "");
    Expect(0, 125273, '\p{^Lb=nu}', "");
    Expect(0, 125273, '\P{Lb=nu}', "");
    Expect(1, 125273, '\P{^Lb=nu}', "");
    Expect(0, 125274, '\p{Lb=nu}', "");
    Expect(1, 125274, '\p{^Lb=nu}', "");
    Expect(1, 125274, '\P{Lb=nu}', "");
    Expect(0, 125274, '\P{^Lb=nu}', "");
    Expect(1, 125273, '\p{Lb=:\Anu\z:}', "");;
    Expect(0, 125274, '\p{Lb=:\Anu\z:}', "");;
    Expect(1, 125273, '\p{Lb=		NU}', "");
    Expect(0, 125273, '\p{^Lb=		NU}', "");
    Expect(0, 125273, '\P{Lb=		NU}', "");
    Expect(1, 125273, '\P{^Lb=		NU}', "");
    Expect(0, 125274, '\p{Lb=		NU}', "");
    Expect(1, 125274, '\p{^Lb=		NU}', "");
    Expect(1, 125274, '\P{Lb=		NU}', "");
    Expect(0, 125274, '\P{^Lb=		NU}', "");
    Error('\p{Is_Line_Break=/a/ numeric}');
    Error('\P{Is_Line_Break=/a/ numeric}');
    Expect(1, 125273, '\p{Is_Line_Break=numeric}', "");
    Expect(0, 125273, '\p{^Is_Line_Break=numeric}', "");
    Expect(0, 125273, '\P{Is_Line_Break=numeric}', "");
    Expect(1, 125273, '\P{^Is_Line_Break=numeric}', "");
    Expect(0, 125274, '\p{Is_Line_Break=numeric}', "");
    Expect(1, 125274, '\p{^Is_Line_Break=numeric}', "");
    Expect(1, 125274, '\P{Is_Line_Break=numeric}', "");
    Expect(0, 125274, '\P{^Is_Line_Break=numeric}', "");
    Expect(1, 125273, '\p{Is_Line_Break= numeric}', "");
    Expect(0, 125273, '\p{^Is_Line_Break= numeric}', "");
    Expect(0, 125273, '\P{Is_Line_Break= numeric}', "");
    Expect(1, 125273, '\P{^Is_Line_Break= numeric}', "");
    Expect(0, 125274, '\p{Is_Line_Break= numeric}', "");
    Expect(1, 125274, '\p{^Is_Line_Break= numeric}', "");
    Expect(1, 125274, '\P{Is_Line_Break= numeric}', "");
    Expect(0, 125274, '\P{^Is_Line_Break= numeric}', "");
    Error('\p{Is_Lb=-/a/NU}');
    Error('\P{Is_Lb=-/a/NU}');
    Expect(1, 125273, '\p{Is_Lb=nu}', "");
    Expect(0, 125273, '\p{^Is_Lb=nu}', "");
    Expect(0, 125273, '\P{Is_Lb=nu}', "");
    Expect(1, 125273, '\P{^Is_Lb=nu}', "");
    Expect(0, 125274, '\p{Is_Lb=nu}', "");
    Expect(1, 125274, '\p{^Is_Lb=nu}', "");
    Expect(1, 125274, '\P{Is_Lb=nu}', "");
    Expect(0, 125274, '\P{^Is_Lb=nu}', "");
    Expect(1, 125273, '\p{Is_Lb= -nu}', "");
    Expect(0, 125273, '\p{^Is_Lb= -nu}', "");
    Expect(0, 125273, '\P{Is_Lb= -nu}', "");
    Expect(1, 125273, '\P{^Is_Lb= -nu}', "");
    Expect(0, 125274, '\p{Is_Lb= -nu}', "");
    Expect(1, 125274, '\p{^Is_Lb= -nu}', "");
    Expect(1, 125274, '\P{Is_Lb= -nu}', "");
    Expect(0, 125274, '\P{^Is_Lb= -nu}', "");
    Error('\p{Line_Break: _:=Open_PUNCTUATION}');
    Error('\P{Line_Break: _:=Open_PUNCTUATION}');
    Expect(1, 125279, '\p{Line_Break=:\AOpen_Punctuation\z:}', "");;
    Expect(0, 125280, '\p{Line_Break=:\AOpen_Punctuation\z:}', "");;
    Expect(1, 125279, '\p{Line_Break=openpunctuation}', "");
    Expect(0, 125279, '\p{^Line_Break=openpunctuation}', "");
    Expect(0, 125279, '\P{Line_Break=openpunctuation}', "");
    Expect(1, 125279, '\P{^Line_Break=openpunctuation}', "");
    Expect(0, 125280, '\p{Line_Break=openpunctuation}', "");
    Expect(1, 125280, '\p{^Line_Break=openpunctuation}', "");
    Expect(1, 125280, '\P{Line_Break=openpunctuation}', "");
    Expect(0, 125280, '\P{^Line_Break=openpunctuation}', "");
    Expect(1, 125279, '\p{Line_Break=:\Aopenpunctuation\z:}', "");;
    Expect(0, 125280, '\p{Line_Break=:\Aopenpunctuation\z:}', "");;
    Expect(1, 125279, '\p{Line_Break=_	Open_PUNCTUATION}', "");
    Expect(0, 125279, '\p{^Line_Break=_	Open_PUNCTUATION}', "");
    Expect(0, 125279, '\P{Line_Break=_	Open_PUNCTUATION}', "");
    Expect(1, 125279, '\P{^Line_Break=_	Open_PUNCTUATION}', "");
    Expect(0, 125280, '\p{Line_Break=_	Open_PUNCTUATION}', "");
    Expect(1, 125280, '\p{^Line_Break=_	Open_PUNCTUATION}', "");
    Expect(1, 125280, '\P{Line_Break=_	Open_PUNCTUATION}', "");
    Expect(0, 125280, '\P{^Line_Break=_	Open_PUNCTUATION}', "");
    Error('\p{Lb=-:=OP}');
    Error('\P{Lb=-:=OP}');
    Expect(1, 125279, '\p{Lb=:\AOP\z:}', "");;
    Expect(0, 125280, '\p{Lb=:\AOP\z:}', "");;
    Expect(1, 125279, '\p{Lb=op}', "");
    Expect(0, 125279, '\p{^Lb=op}', "");
    Expect(0, 125279, '\P{Lb=op}', "");
    Expect(1, 125279, '\P{^Lb=op}', "");
    Expect(0, 125280, '\p{Lb=op}', "");
    Expect(1, 125280, '\p{^Lb=op}', "");
    Expect(1, 125280, '\P{Lb=op}', "");
    Expect(0, 125280, '\P{^Lb=op}', "");
    Expect(1, 125279, '\p{Lb=:\Aop\z:}', "");;
    Expect(0, 125280, '\p{Lb=:\Aop\z:}', "");;
    Expect(1, 125279, '\p{Lb= op}', "");
    Expect(0, 125279, '\p{^Lb= op}', "");
    Expect(0, 125279, '\P{Lb= op}', "");
    Expect(1, 125279, '\P{^Lb= op}', "");
    Expect(0, 125280, '\p{Lb= op}', "");
    Expect(1, 125280, '\p{^Lb= op}', "");
    Expect(1, 125280, '\P{Lb= op}', "");
    Expect(0, 125280, '\P{^Lb= op}', "");
    Error('\p{Is_Line_Break=:=open_PUNCTUATION}');
    Error('\P{Is_Line_Break=:=open_PUNCTUATION}');
    Expect(1, 125279, '\p{Is_Line_Break=openpunctuation}', "");
    Expect(0, 125279, '\p{^Is_Line_Break=openpunctuation}', "");
    Expect(0, 125279, '\P{Is_Line_Break=openpunctuation}', "");
    Expect(1, 125279, '\P{^Is_Line_Break=openpunctuation}', "");
    Expect(0, 125280, '\p{Is_Line_Break=openpunctuation}', "");
    Expect(1, 125280, '\p{^Is_Line_Break=openpunctuation}', "");
    Expect(1, 125280, '\P{Is_Line_Break=openpunctuation}', "");
    Expect(0, 125280, '\P{^Is_Line_Break=openpunctuation}', "");
    Expect(1, 125279, '\p{Is_Line_Break: _-Open_Punctuation}', "");
    Expect(0, 125279, '\p{^Is_Line_Break: _-Open_Punctuation}', "");
    Expect(0, 125279, '\P{Is_Line_Break: _-Open_Punctuation}', "");
    Expect(1, 125279, '\P{^Is_Line_Break: _-Open_Punctuation}', "");
    Expect(0, 125280, '\p{Is_Line_Break: _-Open_Punctuation}', "");
    Expect(1, 125280, '\p{^Is_Line_Break: _-Open_Punctuation}', "");
    Expect(1, 125280, '\P{Is_Line_Break: _-Open_Punctuation}', "");
    Expect(0, 125280, '\P{^Is_Line_Break: _-Open_Punctuation}', "");
    Error('\p{Is_Lb=:=OP}');
    Error('\P{Is_Lb=:=OP}');
    Expect(1, 125279, '\p{Is_Lb=op}', "");
    Expect(0, 125279, '\p{^Is_Lb=op}', "");
    Expect(0, 125279, '\P{Is_Lb=op}', "");
    Expect(1, 125279, '\P{^Is_Lb=op}', "");
    Expect(0, 125280, '\p{Is_Lb=op}', "");
    Expect(1, 125280, '\p{^Is_Lb=op}', "");
    Expect(1, 125280, '\P{Is_Lb=op}', "");
    Expect(0, 125280, '\P{^Is_Lb=op}', "");
    Expect(1, 125279, '\p{Is_Lb=-op}', "");
    Expect(0, 125279, '\p{^Is_Lb=-op}', "");
    Expect(0, 125279, '\P{Is_Lb=-op}', "");
    Expect(1, 125279, '\P{^Is_Lb=-op}', "");
    Expect(0, 125280, '\p{Is_Lb=-op}', "");
    Expect(1, 125280, '\p{^Is_Lb=-op}', "");
    Expect(1, 125280, '\P{Is_Lb=-op}', "");
    Expect(0, 125280, '\P{^Is_Lb=-op}', "");
    Error('\p{Line_Break= /a/Postfix_Numeric}');
    Error('\P{Line_Break= /a/Postfix_Numeric}');
    Expect(1, 126128, '\p{Line_Break=:\APostfix_Numeric\z:}', "");;
    Expect(0, 126129, '\p{Line_Break=:\APostfix_Numeric\z:}', "");;
    Expect(1, 126128, '\p{Line_Break=postfixnumeric}', "");
    Expect(0, 126128, '\p{^Line_Break=postfixnumeric}', "");
    Expect(0, 126128, '\P{Line_Break=postfixnumeric}', "");
    Expect(1, 126128, '\P{^Line_Break=postfixnumeric}', "");
    Expect(0, 126129, '\p{Line_Break=postfixnumeric}', "");
    Expect(1, 126129, '\p{^Line_Break=postfixnumeric}', "");
    Expect(1, 126129, '\P{Line_Break=postfixnumeric}', "");
    Expect(0, 126129, '\P{^Line_Break=postfixnumeric}', "");
    Expect(1, 126128, '\p{Line_Break=:\Apostfixnumeric\z:}', "");;
    Expect(0, 126129, '\p{Line_Break=:\Apostfixnumeric\z:}', "");;
    Expect(1, 126128, '\p{Line_Break=	Postfix_numeric}', "");
    Expect(0, 126128, '\p{^Line_Break=	Postfix_numeric}', "");
    Expect(0, 126128, '\P{Line_Break=	Postfix_numeric}', "");
    Expect(1, 126128, '\P{^Line_Break=	Postfix_numeric}', "");
    Expect(0, 126129, '\p{Line_Break=	Postfix_numeric}', "");
    Expect(1, 126129, '\p{^Line_Break=	Postfix_numeric}', "");
    Expect(1, 126129, '\P{Line_Break=	Postfix_numeric}', "");
    Expect(0, 126129, '\P{^Line_Break=	Postfix_numeric}', "");
    Error('\p{Lb=	 po:=}');
    Error('\P{Lb=	 po:=}');
    Expect(1, 126128, '\p{Lb=:\APO\z:}', "");;
    Expect(0, 126129, '\p{Lb=:\APO\z:}', "");;
    Expect(1, 126128, '\p{Lb=po}', "");
    Expect(0, 126128, '\p{^Lb=po}', "");
    Expect(0, 126128, '\P{Lb=po}', "");
    Expect(1, 126128, '\P{^Lb=po}', "");
    Expect(0, 126129, '\p{Lb=po}', "");
    Expect(1, 126129, '\p{^Lb=po}', "");
    Expect(1, 126129, '\P{Lb=po}', "");
    Expect(0, 126129, '\P{^Lb=po}', "");
    Expect(1, 126128, '\p{Lb=:\Apo\z:}', "");;
    Expect(0, 126129, '\p{Lb=:\Apo\z:}', "");;
    Expect(1, 126128, '\p{Lb=-PO}', "");
    Expect(0, 126128, '\p{^Lb=-PO}', "");
    Expect(0, 126128, '\P{Lb=-PO}', "");
    Expect(1, 126128, '\P{^Lb=-PO}', "");
    Expect(0, 126129, '\p{Lb=-PO}', "");
    Expect(1, 126129, '\p{^Lb=-PO}', "");
    Expect(1, 126129, '\P{Lb=-PO}', "");
    Expect(0, 126129, '\P{^Lb=-PO}', "");
    Error('\p{Is_Line_Break=/a/_Postfix_NUMERIC}');
    Error('\P{Is_Line_Break=/a/_Postfix_NUMERIC}');
    Expect(1, 126128, '\p{Is_Line_Break=postfixnumeric}', "");
    Expect(0, 126128, '\p{^Is_Line_Break=postfixnumeric}', "");
    Expect(0, 126128, '\P{Is_Line_Break=postfixnumeric}', "");
    Expect(1, 126128, '\P{^Is_Line_Break=postfixnumeric}', "");
    Expect(0, 126129, '\p{Is_Line_Break=postfixnumeric}', "");
    Expect(1, 126129, '\p{^Is_Line_Break=postfixnumeric}', "");
    Expect(1, 126129, '\P{Is_Line_Break=postfixnumeric}', "");
    Expect(0, 126129, '\P{^Is_Line_Break=postfixnumeric}', "");
    Expect(1, 126128, '\p{Is_Line_Break=_ postfix_Numeric}', "");
    Expect(0, 126128, '\p{^Is_Line_Break=_ postfix_Numeric}', "");
    Expect(0, 126128, '\P{Is_Line_Break=_ postfix_Numeric}', "");
    Expect(1, 126128, '\P{^Is_Line_Break=_ postfix_Numeric}', "");
    Expect(0, 126129, '\p{Is_Line_Break=_ postfix_Numeric}', "");
    Expect(1, 126129, '\p{^Is_Line_Break=_ postfix_Numeric}', "");
    Expect(1, 126129, '\P{Is_Line_Break=_ postfix_Numeric}', "");
    Expect(0, 126129, '\P{^Is_Line_Break=_ postfix_Numeric}', "");
    Error('\p{Is_Lb:   :=_	po}');
    Error('\P{Is_Lb:   :=_	po}');
    Expect(1, 126128, '\p{Is_Lb=po}', "");
    Expect(0, 126128, '\p{^Is_Lb=po}', "");
    Expect(0, 126128, '\P{Is_Lb=po}', "");
    Expect(1, 126128, '\P{^Is_Lb=po}', "");
    Expect(0, 126129, '\p{Is_Lb=po}', "");
    Expect(1, 126129, '\p{^Is_Lb=po}', "");
    Expect(1, 126129, '\P{Is_Lb=po}', "");
    Expect(0, 126129, '\P{^Is_Lb=po}', "");
    Expect(1, 126128, '\p{Is_Lb:  PO}', "");
    Expect(0, 126128, '\p{^Is_Lb:  PO}', "");
    Expect(0, 126128, '\P{Is_Lb:  PO}', "");
    Expect(1, 126128, '\P{^Is_Lb:  PO}', "");
    Expect(0, 126129, '\p{Is_Lb:  PO}', "");
    Expect(1, 126129, '\p{^Is_Lb:  PO}', "");
    Expect(1, 126129, '\P{Is_Lb:  PO}', "");
    Expect(0, 126129, '\P{^Is_Lb:  PO}', "");
    Error('\p{Line_Break=:=prefix_Numeric}');
    Error('\P{Line_Break=:=prefix_Numeric}');
    Expect(1, 123647, '\p{Line_Break=:\APrefix_Numeric\z:}', "");;
    Expect(0, 123648, '\p{Line_Break=:\APrefix_Numeric\z:}', "");;
    Expect(1, 123647, '\p{Line_Break=prefixnumeric}', "");
    Expect(0, 123647, '\p{^Line_Break=prefixnumeric}', "");
    Expect(0, 123647, '\P{Line_Break=prefixnumeric}', "");
    Expect(1, 123647, '\P{^Line_Break=prefixnumeric}', "");
    Expect(0, 123648, '\p{Line_Break=prefixnumeric}', "");
    Expect(1, 123648, '\p{^Line_Break=prefixnumeric}', "");
    Expect(1, 123648, '\P{Line_Break=prefixnumeric}', "");
    Expect(0, 123648, '\P{^Line_Break=prefixnumeric}', "");
    Expect(1, 123647, '\p{Line_Break=:\Aprefixnumeric\z:}', "");;
    Expect(0, 123648, '\p{Line_Break=:\Aprefixnumeric\z:}', "");;
    Expect(1, 123647, '\p{Line_Break=- Prefix_NUMERIC}', "");
    Expect(0, 123647, '\p{^Line_Break=- Prefix_NUMERIC}', "");
    Expect(0, 123647, '\P{Line_Break=- Prefix_NUMERIC}', "");
    Expect(1, 123647, '\P{^Line_Break=- Prefix_NUMERIC}', "");
    Expect(0, 123648, '\p{Line_Break=- Prefix_NUMERIC}', "");
    Expect(1, 123648, '\p{^Line_Break=- Prefix_NUMERIC}', "");
    Expect(1, 123648, '\P{Line_Break=- Prefix_NUMERIC}', "");
    Expect(0, 123648, '\P{^Line_Break=- Prefix_NUMERIC}', "");
    Error('\p{Lb=	/a/pr}');
    Error('\P{Lb=	/a/pr}');
    Expect(1, 123647, '\p{Lb=:\APR\z:}', "");;
    Expect(0, 123648, '\p{Lb=:\APR\z:}', "");;
    Expect(1, 123647, '\p{Lb=pr}', "");
    Expect(0, 123647, '\p{^Lb=pr}', "");
    Expect(0, 123647, '\P{Lb=pr}', "");
    Expect(1, 123647, '\P{^Lb=pr}', "");
    Expect(0, 123648, '\p{Lb=pr}', "");
    Expect(1, 123648, '\p{^Lb=pr}', "");
    Expect(1, 123648, '\P{Lb=pr}', "");
    Expect(0, 123648, '\P{^Lb=pr}', "");
    Expect(1, 123647, '\p{Lb=:\Apr\z:}', "");;
    Expect(0, 123648, '\p{Lb=:\Apr\z:}', "");;
    Expect(1, 123647, '\p{Lb: 	_PR}', "");
    Expect(0, 123647, '\p{^Lb: 	_PR}', "");
    Expect(0, 123647, '\P{Lb: 	_PR}', "");
    Expect(1, 123647, '\P{^Lb: 	_PR}', "");
    Expect(0, 123648, '\p{Lb: 	_PR}', "");
    Expect(1, 123648, '\p{^Lb: 	_PR}', "");
    Expect(1, 123648, '\P{Lb: 	_PR}', "");
    Expect(0, 123648, '\P{^Lb: 	_PR}', "");
    Error('\p{Is_Line_Break=:=	 prefix_NUMERIC}');
    Error('\P{Is_Line_Break=:=	 prefix_NUMERIC}');
    Expect(1, 123647, '\p{Is_Line_Break=prefixnumeric}', "");
    Expect(0, 123647, '\p{^Is_Line_Break=prefixnumeric}', "");
    Expect(0, 123647, '\P{Is_Line_Break=prefixnumeric}', "");
    Expect(1, 123647, '\P{^Is_Line_Break=prefixnumeric}', "");
    Expect(0, 123648, '\p{Is_Line_Break=prefixnumeric}', "");
    Expect(1, 123648, '\p{^Is_Line_Break=prefixnumeric}', "");
    Expect(1, 123648, '\P{Is_Line_Break=prefixnumeric}', "");
    Expect(0, 123648, '\P{^Is_Line_Break=prefixnumeric}', "");
    Expect(1, 123647, '\p{Is_Line_Break:   	Prefix_Numeric}', "");
    Expect(0, 123647, '\p{^Is_Line_Break:   	Prefix_Numeric}', "");
    Expect(0, 123647, '\P{Is_Line_Break:   	Prefix_Numeric}', "");
    Expect(1, 123647, '\P{^Is_Line_Break:   	Prefix_Numeric}', "");
    Expect(0, 123648, '\p{Is_Line_Break:   	Prefix_Numeric}', "");
    Expect(1, 123648, '\p{^Is_Line_Break:   	Prefix_Numeric}', "");
    Expect(1, 123648, '\P{Is_Line_Break:   	Prefix_Numeric}', "");
    Expect(0, 123648, '\P{^Is_Line_Break:   	Prefix_Numeric}', "");
    Error('\p{Is_Lb=  pr/a/}');
    Error('\P{Is_Lb=  pr/a/}');
    Expect(1, 123647, '\p{Is_Lb=pr}', "");
    Expect(0, 123647, '\p{^Is_Lb=pr}', "");
    Expect(0, 123647, '\P{Is_Lb=pr}', "");
    Expect(1, 123647, '\P{^Is_Lb=pr}', "");
    Expect(0, 123648, '\p{Is_Lb=pr}', "");
    Expect(1, 123648, '\p{^Is_Lb=pr}', "");
    Expect(1, 123648, '\P{Is_Lb=pr}', "");
    Expect(0, 123648, '\P{^Is_Lb=pr}', "");
    Expect(1, 123647, '\p{Is_Lb=		PR}', "");
    Expect(0, 123647, '\p{^Is_Lb=		PR}', "");
    Expect(0, 123647, '\P{Is_Lb=		PR}', "");
    Expect(1, 123647, '\P{^Is_Lb=		PR}', "");
    Expect(0, 123648, '\p{Is_Lb=		PR}', "");
    Expect(1, 123648, '\p{^Is_Lb=		PR}', "");
    Expect(1, 123648, '\P{Is_Lb=		PR}', "");
    Expect(0, 123648, '\P{^Is_Lb=		PR}', "");
    Error('\p{Line_Break=	:=Quotation}');
    Error('\P{Line_Break=	:=Quotation}');
    Expect(1, 128632, '\p{Line_Break=:\AQuotation\z:}', "");;
    Expect(0, 128633, '\p{Line_Break=:\AQuotation\z:}', "");;
    Expect(1, 128632, '\p{Line_Break=quotation}', "");
    Expect(0, 128632, '\p{^Line_Break=quotation}', "");
    Expect(0, 128632, '\P{Line_Break=quotation}', "");
    Expect(1, 128632, '\P{^Line_Break=quotation}', "");
    Expect(0, 128633, '\p{Line_Break=quotation}', "");
    Expect(1, 128633, '\p{^Line_Break=quotation}', "");
    Expect(1, 128633, '\P{Line_Break=quotation}', "");
    Expect(0, 128633, '\P{^Line_Break=quotation}', "");
    Expect(1, 128632, '\p{Line_Break=:\Aquotation\z:}', "");;
    Expect(0, 128633, '\p{Line_Break=:\Aquotation\z:}', "");;
    Expect(1, 128632, '\p{Line_Break=_	Quotation}', "");
    Expect(0, 128632, '\p{^Line_Break=_	Quotation}', "");
    Expect(0, 128632, '\P{Line_Break=_	Quotation}', "");
    Expect(1, 128632, '\P{^Line_Break=_	Quotation}', "");
    Expect(0, 128633, '\p{Line_Break=_	Quotation}', "");
    Expect(1, 128633, '\p{^Line_Break=_	Quotation}', "");
    Expect(1, 128633, '\P{Line_Break=_	Quotation}', "");
    Expect(0, 128633, '\P{^Line_Break=_	Quotation}', "");
    Error('\p{Lb=/a/-_qu}');
    Error('\P{Lb=/a/-_qu}');
    Expect(1, 128632, '\p{Lb=:\AQU\z:}', "");;
    Expect(0, 128633, '\p{Lb=:\AQU\z:}', "");;
    Expect(1, 128632, '\p{Lb=qu}', "");
    Expect(0, 128632, '\p{^Lb=qu}', "");
    Expect(0, 128632, '\P{Lb=qu}', "");
    Expect(1, 128632, '\P{^Lb=qu}', "");
    Expect(0, 128633, '\p{Lb=qu}', "");
    Expect(1, 128633, '\p{^Lb=qu}', "");
    Expect(1, 128633, '\P{Lb=qu}', "");
    Expect(0, 128633, '\P{^Lb=qu}', "");
    Expect(1, 128632, '\p{Lb=:\Aqu\z:}', "");;
    Expect(0, 128633, '\p{Lb=:\Aqu\z:}', "");;
    Expect(1, 128632, '\p{Lb= 	QU}', "");
    Expect(0, 128632, '\p{^Lb= 	QU}', "");
    Expect(0, 128632, '\P{Lb= 	QU}', "");
    Expect(1, 128632, '\P{^Lb= 	QU}', "");
    Expect(0, 128633, '\p{Lb= 	QU}', "");
    Expect(1, 128633, '\p{^Lb= 	QU}', "");
    Expect(1, 128633, '\P{Lb= 	QU}', "");
    Expect(0, 128633, '\P{^Lb= 	QU}', "");
    Error('\p{Is_Line_Break=	Quotation:=}');
    Error('\P{Is_Line_Break=	Quotation:=}');
    Expect(1, 128632, '\p{Is_Line_Break=quotation}', "");
    Expect(0, 128632, '\p{^Is_Line_Break=quotation}', "");
    Expect(0, 128632, '\P{Is_Line_Break=quotation}', "");
    Expect(1, 128632, '\P{^Is_Line_Break=quotation}', "");
    Expect(0, 128633, '\p{Is_Line_Break=quotation}', "");
    Expect(1, 128633, '\p{^Is_Line_Break=quotation}', "");
    Expect(1, 128633, '\P{Is_Line_Break=quotation}', "");
    Expect(0, 128633, '\P{^Is_Line_Break=quotation}', "");
    Expect(1, 128632, '\p{Is_Line_Break=- QUOTATION}', "");
    Expect(0, 128632, '\p{^Is_Line_Break=- QUOTATION}', "");
    Expect(0, 128632, '\P{Is_Line_Break=- QUOTATION}', "");
    Expect(1, 128632, '\P{^Is_Line_Break=- QUOTATION}', "");
    Expect(0, 128633, '\p{Is_Line_Break=- QUOTATION}', "");
    Expect(1, 128633, '\p{^Is_Line_Break=- QUOTATION}', "");
    Expect(1, 128633, '\P{Is_Line_Break=- QUOTATION}', "");
    Expect(0, 128633, '\P{^Is_Line_Break=- QUOTATION}', "");
    Error('\p{Is_Lb=		QU/a/}');
    Error('\P{Is_Lb=		QU/a/}');
    Expect(1, 128632, '\p{Is_Lb=qu}', "");
    Expect(0, 128632, '\p{^Is_Lb=qu}', "");
    Expect(0, 128632, '\P{Is_Lb=qu}', "");
    Expect(1, 128632, '\P{^Is_Lb=qu}', "");
    Expect(0, 128633, '\p{Is_Lb=qu}', "");
    Expect(1, 128633, '\p{^Is_Lb=qu}', "");
    Expect(1, 128633, '\P{Is_Lb=qu}', "");
    Expect(0, 128633, '\P{^Is_Lb=qu}', "");
    Expect(1, 128632, '\p{Is_Lb: 		qu}', "");
    Expect(0, 128632, '\p{^Is_Lb: 		qu}', "");
    Expect(0, 128632, '\P{Is_Lb: 		qu}', "");
    Expect(1, 128632, '\P{^Is_Lb: 		qu}', "");
    Expect(0, 128633, '\p{Is_Lb: 		qu}', "");
    Expect(1, 128633, '\p{^Is_Lb: 		qu}', "");
    Expect(1, 128633, '\P{Is_Lb: 		qu}', "");
    Expect(0, 128633, '\P{^Is_Lb: 		qu}', "");
    Error('\p{Line_Break=_	Regional_INDICATOR/a/}');
    Error('\P{Line_Break=_	Regional_INDICATOR/a/}');
    Expect(1, 127487, '\p{Line_Break=:\ARegional_Indicator\z:}', "");;
    Expect(0, 127488, '\p{Line_Break=:\ARegional_Indicator\z:}', "");;
    Expect(1, 127487, '\p{Line_Break=regionalindicator}', "");
    Expect(0, 127487, '\p{^Line_Break=regionalindicator}', "");
    Expect(0, 127487, '\P{Line_Break=regionalindicator}', "");
    Expect(1, 127487, '\P{^Line_Break=regionalindicator}', "");
    Expect(0, 127488, '\p{Line_Break=regionalindicator}', "");
    Expect(1, 127488, '\p{^Line_Break=regionalindicator}', "");
    Expect(1, 127488, '\P{Line_Break=regionalindicator}', "");
    Expect(0, 127488, '\P{^Line_Break=regionalindicator}', "");
    Expect(1, 127487, '\p{Line_Break=:\Aregionalindicator\z:}', "");;
    Expect(0, 127488, '\p{Line_Break=:\Aregionalindicator\z:}', "");;
    Expect(1, 127487, '\p{Line_Break=- REGIONAL_INDICATOR}', "");
    Expect(0, 127487, '\p{^Line_Break=- REGIONAL_INDICATOR}', "");
    Expect(0, 127487, '\P{Line_Break=- REGIONAL_INDICATOR}', "");
    Expect(1, 127487, '\P{^Line_Break=- REGIONAL_INDICATOR}', "");
    Expect(0, 127488, '\p{Line_Break=- REGIONAL_INDICATOR}', "");
    Expect(1, 127488, '\p{^Line_Break=- REGIONAL_INDICATOR}', "");
    Expect(1, 127488, '\P{Line_Break=- REGIONAL_INDICATOR}', "");
    Expect(0, 127488, '\P{^Line_Break=- REGIONAL_INDICATOR}', "");
    Error('\p{Lb=/a/-RI}');
    Error('\P{Lb=/a/-RI}');
    Expect(1, 127487, '\p{Lb=:\ARI\z:}', "");;
    Expect(0, 127488, '\p{Lb=:\ARI\z:}', "");;
    Expect(1, 127487, '\p{Lb=ri}', "");
    Expect(0, 127487, '\p{^Lb=ri}', "");
    Expect(0, 127487, '\P{Lb=ri}', "");
    Expect(1, 127487, '\P{^Lb=ri}', "");
    Expect(0, 127488, '\p{Lb=ri}', "");
    Expect(1, 127488, '\p{^Lb=ri}', "");
    Expect(1, 127488, '\P{Lb=ri}', "");
    Expect(0, 127488, '\P{^Lb=ri}', "");
    Expect(1, 127487, '\p{Lb=:\Ari\z:}', "");;
    Expect(0, 127488, '\p{Lb=:\Ari\z:}', "");;
    Expect(1, 127487, '\p{Lb=-	ri}', "");
    Expect(0, 127487, '\p{^Lb=-	ri}', "");
    Expect(0, 127487, '\P{Lb=-	ri}', "");
    Expect(1, 127487, '\P{^Lb=-	ri}', "");
    Expect(0, 127488, '\p{Lb=-	ri}', "");
    Expect(1, 127488, '\p{^Lb=-	ri}', "");
    Expect(1, 127488, '\P{Lb=-	ri}', "");
    Expect(0, 127488, '\P{^Lb=-	ri}', "");
    Error('\p{Is_Line_Break=-Regional_indicator/a/}');
    Error('\P{Is_Line_Break=-Regional_indicator/a/}');
    Expect(1, 127487, '\p{Is_Line_Break=regionalindicator}', "");
    Expect(0, 127487, '\p{^Is_Line_Break=regionalindicator}', "");
    Expect(0, 127487, '\P{Is_Line_Break=regionalindicator}', "");
    Expect(1, 127487, '\P{^Is_Line_Break=regionalindicator}', "");
    Expect(0, 127488, '\p{Is_Line_Break=regionalindicator}', "");
    Expect(1, 127488, '\p{^Is_Line_Break=regionalindicator}', "");
    Expect(1, 127488, '\P{Is_Line_Break=regionalindicator}', "");
    Expect(0, 127488, '\P{^Is_Line_Break=regionalindicator}', "");
    Expect(1, 127487, '\p{Is_Line_Break:	_regional_Indicator}', "");
    Expect(0, 127487, '\p{^Is_Line_Break:	_regional_Indicator}', "");
    Expect(0, 127487, '\P{Is_Line_Break:	_regional_Indicator}', "");
    Expect(1, 127487, '\P{^Is_Line_Break:	_regional_Indicator}', "");
    Expect(0, 127488, '\p{Is_Line_Break:	_regional_Indicator}', "");
    Expect(1, 127488, '\p{^Is_Line_Break:	_regional_Indicator}', "");
    Expect(1, 127488, '\P{Is_Line_Break:	_regional_Indicator}', "");
    Expect(0, 127488, '\P{^Is_Line_Break:	_regional_Indicator}', "");
    Error('\p{Is_Lb=-	ri:=}');
    Error('\P{Is_Lb=-	ri:=}');
    Expect(1, 127487, '\p{Is_Lb=ri}', "");
    Expect(0, 127487, '\p{^Is_Lb=ri}', "");
    Expect(0, 127487, '\P{Is_Lb=ri}', "");
    Expect(1, 127487, '\P{^Is_Lb=ri}', "");
    Expect(0, 127488, '\p{Is_Lb=ri}', "");
    Expect(1, 127488, '\p{^Is_Lb=ri}', "");
    Expect(1, 127488, '\P{Is_Lb=ri}', "");
    Expect(0, 127488, '\P{^Is_Lb=ri}', "");
    Expect(1, 127487, '\p{Is_Lb=_RI}', "");
    Expect(0, 127487, '\p{^Is_Lb=_RI}', "");
    Expect(0, 127487, '\P{Is_Lb=_RI}', "");
    Expect(1, 127487, '\P{^Is_Lb=_RI}', "");
    Expect(0, 127488, '\p{Is_Lb=_RI}', "");
    Expect(1, 127488, '\p{^Is_Lb=_RI}', "");
    Expect(1, 127488, '\P{Is_Lb=_RI}', "");
    Expect(0, 127488, '\P{^Is_Lb=_RI}', "");
    Error('\p{Line_Break=:=-	COMPLEX_CONTEXT}');
    Error('\P{Line_Break=:=-	COMPLEX_CONTEXT}');
    Expect(1, 71487, '\p{Line_Break=:\AComplex_Context\z:}', "");;
    Expect(0, 71488, '\p{Line_Break=:\AComplex_Context\z:}', "");;
    Expect(1, 71487, '\p{Line_Break=complexcontext}', "");
    Expect(0, 71487, '\p{^Line_Break=complexcontext}', "");
    Expect(0, 71487, '\P{Line_Break=complexcontext}', "");
    Expect(1, 71487, '\P{^Line_Break=complexcontext}', "");
    Expect(0, 71488, '\p{Line_Break=complexcontext}', "");
    Expect(1, 71488, '\p{^Line_Break=complexcontext}', "");
    Expect(1, 71488, '\P{Line_Break=complexcontext}', "");
    Expect(0, 71488, '\P{^Line_Break=complexcontext}', "");
    Expect(1, 71487, '\p{Line_Break=:\Acomplexcontext\z:}', "");;
    Expect(0, 71488, '\p{Line_Break=:\Acomplexcontext\z:}', "");;
    Expect(1, 71487, '\p{Line_Break=	 COMPLEX_Context}', "");
    Expect(0, 71487, '\p{^Line_Break=	 COMPLEX_Context}', "");
    Expect(0, 71487, '\P{Line_Break=	 COMPLEX_Context}', "");
    Expect(1, 71487, '\P{^Line_Break=	 COMPLEX_Context}', "");
    Expect(0, 71488, '\p{Line_Break=	 COMPLEX_Context}', "");
    Expect(1, 71488, '\p{^Line_Break=	 COMPLEX_Context}', "");
    Expect(1, 71488, '\P{Line_Break=	 COMPLEX_Context}', "");
    Expect(0, 71488, '\P{^Line_Break=	 COMPLEX_Context}', "");
    Error('\p{Lb=:=-_SA}');
    Error('\P{Lb=:=-_SA}');
    Expect(1, 71487, '\p{Lb=:\ASA\z:}', "");;
    Expect(0, 71488, '\p{Lb=:\ASA\z:}', "");;
    Expect(1, 71487, '\p{Lb:   sa}', "");
    Expect(0, 71487, '\p{^Lb:   sa}', "");
    Expect(0, 71487, '\P{Lb:   sa}', "");
    Expect(1, 71487, '\P{^Lb:   sa}', "");
    Expect(0, 71488, '\p{Lb:   sa}', "");
    Expect(1, 71488, '\p{^Lb:   sa}', "");
    Expect(1, 71488, '\P{Lb:   sa}', "");
    Expect(0, 71488, '\P{^Lb:   sa}', "");
    Expect(1, 71487, '\p{Lb=:\Asa\z:}', "");;
    Expect(0, 71488, '\p{Lb=:\Asa\z:}', "");;
    Expect(1, 71487, '\p{Lb: _SA}', "");
    Expect(0, 71487, '\p{^Lb: _SA}', "");
    Expect(0, 71487, '\P{Lb: _SA}', "");
    Expect(1, 71487, '\P{^Lb: _SA}', "");
    Expect(0, 71488, '\p{Lb: _SA}', "");
    Expect(1, 71488, '\p{^Lb: _SA}', "");
    Expect(1, 71488, '\P{Lb: _SA}', "");
    Expect(0, 71488, '\P{^Lb: _SA}', "");
    Error('\p{Is_Line_Break= complex_context/a/}');
    Error('\P{Is_Line_Break= complex_context/a/}');
    Expect(1, 71487, '\p{Is_Line_Break=complexcontext}', "");
    Expect(0, 71487, '\p{^Is_Line_Break=complexcontext}', "");
    Expect(0, 71487, '\P{Is_Line_Break=complexcontext}', "");
    Expect(1, 71487, '\P{^Is_Line_Break=complexcontext}', "");
    Expect(0, 71488, '\p{Is_Line_Break=complexcontext}', "");
    Expect(1, 71488, '\p{^Is_Line_Break=complexcontext}', "");
    Expect(1, 71488, '\P{Is_Line_Break=complexcontext}', "");
    Expect(0, 71488, '\P{^Is_Line_Break=complexcontext}', "");
    Expect(1, 71487, '\p{Is_Line_Break=- COMPLEX_context}', "");
    Expect(0, 71487, '\p{^Is_Line_Break=- COMPLEX_context}', "");
    Expect(0, 71487, '\P{Is_Line_Break=- COMPLEX_context}', "");
    Expect(1, 71487, '\P{^Is_Line_Break=- COMPLEX_context}', "");
    Expect(0, 71488, '\p{Is_Line_Break=- COMPLEX_context}', "");
    Expect(1, 71488, '\p{^Is_Line_Break=- COMPLEX_context}', "");
    Expect(1, 71488, '\P{Is_Line_Break=- COMPLEX_context}', "");
    Expect(0, 71488, '\P{^Is_Line_Break=- COMPLEX_context}', "");
    Error('\p{Is_Lb= /a/SA}');
    Error('\P{Is_Lb= /a/SA}');
    Expect(1, 71487, '\p{Is_Lb=sa}', "");
    Expect(0, 71487, '\p{^Is_Lb=sa}', "");
    Expect(0, 71487, '\P{Is_Lb=sa}', "");
    Expect(1, 71487, '\P{^Is_Lb=sa}', "");
    Expect(0, 71488, '\p{Is_Lb=sa}', "");
    Expect(1, 71488, '\p{^Is_Lb=sa}', "");
    Expect(1, 71488, '\P{Is_Lb=sa}', "");
    Expect(0, 71488, '\P{^Is_Lb=sa}', "");
    Expect(1, 71487, '\p{Is_Lb= SA}', "");
    Expect(0, 71487, '\p{^Is_Lb= SA}', "");
    Expect(0, 71487, '\P{Is_Lb= SA}', "");
    Expect(1, 71487, '\P{^Is_Lb= SA}', "");
    Expect(0, 71488, '\p{Is_Lb= SA}', "");
    Expect(1, 71488, '\p{^Is_Lb= SA}', "");
    Expect(1, 71488, '\P{Is_Lb= SA}', "");
    Expect(0, 71488, '\P{^Is_Lb= SA}', "");
    Error('\p{Line_Break=/a/	-Surrogate}');
    Error('\P{Line_Break=/a/	-Surrogate}');
    Expect(1, 57343, '\p{Line_Break=surrogate}', 'deprecated');
    Expect(0, 57343, '\p{^Line_Break=surrogate}', 'deprecated');
    Expect(0, 57343, '\P{Line_Break=surrogate}', 'deprecated');
    Expect(1, 57343, '\P{^Line_Break=surrogate}', 'deprecated');
    Expect(0, 57344, '\p{Line_Break=surrogate}', 'deprecated');
    Expect(1, 57344, '\p{^Line_Break=surrogate}', 'deprecated');
    Expect(1, 57344, '\P{Line_Break=surrogate}', 'deprecated');
    Expect(0, 57344, '\P{^Line_Break=surrogate}', 'deprecated');
    Expect(1, 57343, '\p{Line_Break=_	Surrogate}', 'deprecated');
    Expect(0, 57343, '\p{^Line_Break=_	Surrogate}', 'deprecated');
    Expect(0, 57343, '\P{Line_Break=_	Surrogate}', 'deprecated');
    Expect(1, 57343, '\P{^Line_Break=_	Surrogate}', 'deprecated');
    Expect(0, 57344, '\p{Line_Break=_	Surrogate}', 'deprecated');
    Expect(1, 57344, '\p{^Line_Break=_	Surrogate}', 'deprecated');
    Expect(1, 57344, '\P{Line_Break=_	Surrogate}', 'deprecated');
    Expect(0, 57344, '\P{^Line_Break=_	Surrogate}', 'deprecated');
    Error('\p{Lb=-:=SG}');
    Error('\P{Lb=-:=SG}');
    Expect(1, 57343, '\p{Lb=sg}', 'deprecated');
    Expect(0, 57343, '\p{^Lb=sg}', 'deprecated');
    Expect(0, 57343, '\P{Lb=sg}', 'deprecated');
    Expect(1, 57343, '\P{^Lb=sg}', 'deprecated');
    Expect(0, 57344, '\p{Lb=sg}', 'deprecated');
    Expect(1, 57344, '\p{^Lb=sg}', 'deprecated');
    Expect(1, 57344, '\P{Lb=sg}', 'deprecated');
    Expect(0, 57344, '\P{^Lb=sg}', 'deprecated');
    Expect(1, 57343, '\p{Lb:	 _SG}', 'deprecated');
    Expect(0, 57343, '\p{^Lb:	 _SG}', 'deprecated');
    Expect(0, 57343, '\P{Lb:	 _SG}', 'deprecated');
    Expect(1, 57343, '\P{^Lb:	 _SG}', 'deprecated');
    Expect(0, 57344, '\p{Lb:	 _SG}', 'deprecated');
    Expect(1, 57344, '\p{^Lb:	 _SG}', 'deprecated');
    Expect(1, 57344, '\P{Lb:	 _SG}', 'deprecated');
    Expect(0, 57344, '\P{^Lb:	 _SG}', 'deprecated');
    Error('\p{Is_Line_Break=  Surrogate:=}');
    Error('\P{Is_Line_Break=  Surrogate:=}');
    Expect(1, 57343, '\p{Is_Line_Break=surrogate}', 'deprecated');
    Expect(0, 57343, '\p{^Is_Line_Break=surrogate}', 'deprecated');
    Expect(0, 57343, '\P{Is_Line_Break=surrogate}', 'deprecated');
    Expect(1, 57343, '\P{^Is_Line_Break=surrogate}', 'deprecated');
    Expect(0, 57344, '\p{Is_Line_Break=surrogate}', 'deprecated');
    Expect(1, 57344, '\p{^Is_Line_Break=surrogate}', 'deprecated');
    Expect(1, 57344, '\P{Is_Line_Break=surrogate}', 'deprecated');
    Expect(0, 57344, '\P{^Is_Line_Break=surrogate}', 'deprecated');
    Expect(1, 57343, '\p{Is_Line_Break= surrogate}', 'deprecated');
    Expect(0, 57343, '\p{^Is_Line_Break= surrogate}', 'deprecated');
    Expect(0, 57343, '\P{Is_Line_Break= surrogate}', 'deprecated');
    Expect(1, 57343, '\P{^Is_Line_Break= surrogate}', 'deprecated');
    Expect(0, 57344, '\p{Is_Line_Break= surrogate}', 'deprecated');
    Expect(1, 57344, '\p{^Is_Line_Break= surrogate}', 'deprecated');
    Expect(1, 57344, '\P{Is_Line_Break= surrogate}', 'deprecated');
    Expect(0, 57344, '\P{^Is_Line_Break= surrogate}', 'deprecated');
    Error('\p{Is_Lb=/a/-	sg}');
    Error('\P{Is_Lb=/a/-	sg}');
    Expect(1, 57343, '\p{Is_Lb=sg}', 'deprecated');
    Expect(0, 57343, '\p{^Is_Lb=sg}', 'deprecated');
    Expect(0, 57343, '\P{Is_Lb=sg}', 'deprecated');
    Expect(1, 57343, '\P{^Is_Lb=sg}', 'deprecated');
    Expect(0, 57344, '\p{Is_Lb=sg}', 'deprecated');
    Expect(1, 57344, '\p{^Is_Lb=sg}', 'deprecated');
    Expect(1, 57344, '\P{Is_Lb=sg}', 'deprecated');
    Expect(0, 57344, '\P{^Is_Lb=sg}', 'deprecated');
    Expect(1, 57343, '\p{Is_Lb=	-SG}', 'deprecated');
    Expect(0, 57343, '\p{^Is_Lb=	-SG}', 'deprecated');
    Expect(0, 57343, '\P{Is_Lb=	-SG}', 'deprecated');
    Expect(1, 57343, '\P{^Is_Lb=	-SG}', 'deprecated');
    Expect(0, 57344, '\p{Is_Lb=	-SG}', 'deprecated');
    Expect(1, 57344, '\p{^Is_Lb=	-SG}', 'deprecated');
    Expect(1, 57344, '\P{Is_Lb=	-SG}', 'deprecated');
    Expect(0, 57344, '\P{^Is_Lb=	-SG}', 'deprecated');
    Error('\p{Line_Break= /a/space}');
    Error('\P{Line_Break= /a/space}');
    Expect(1, 32, '\p{Line_Break=:\ASpace\z:}', "");;
    Expect(0, 33, '\p{Line_Break=:\ASpace\z:}', "");;
    Expect(1, 32, '\p{Line_Break=space}', "");
    Expect(0, 32, '\p{^Line_Break=space}', "");
    Expect(0, 32, '\P{Line_Break=space}', "");
    Expect(1, 32, '\P{^Line_Break=space}', "");
    Expect(0, 33, '\p{Line_Break=space}', "");
    Expect(1, 33, '\p{^Line_Break=space}', "");
    Expect(1, 33, '\P{Line_Break=space}', "");
    Expect(0, 33, '\P{^Line_Break=space}', "");
    Expect(1, 32, '\p{Line_Break=:\Aspace\z:}', "");;
    Expect(0, 33, '\p{Line_Break=:\Aspace\z:}', "");;
    Expect(1, 32, '\p{Line_Break=	_SPACE}', "");
    Expect(0, 32, '\p{^Line_Break=	_SPACE}', "");
    Expect(0, 32, '\P{Line_Break=	_SPACE}', "");
    Expect(1, 32, '\P{^Line_Break=	_SPACE}', "");
    Expect(0, 33, '\p{Line_Break=	_SPACE}', "");
    Expect(1, 33, '\p{^Line_Break=	_SPACE}', "");
    Expect(1, 33, '\P{Line_Break=	_SPACE}', "");
    Expect(0, 33, '\P{^Line_Break=	_SPACE}', "");
    Error('\p{Lb: -/a/SP}');
    Error('\P{Lb: -/a/SP}');
    Expect(1, 32, '\p{Lb=:\ASP\z:}', "");;
    Expect(0, 33, '\p{Lb=:\ASP\z:}', "");;
    Expect(1, 32, '\p{Lb=sp}', "");
    Expect(0, 32, '\p{^Lb=sp}', "");
    Expect(0, 32, '\P{Lb=sp}', "");
    Expect(1, 32, '\P{^Lb=sp}', "");
    Expect(0, 33, '\p{Lb=sp}', "");
    Expect(1, 33, '\p{^Lb=sp}', "");
    Expect(1, 33, '\P{Lb=sp}', "");
    Expect(0, 33, '\P{^Lb=sp}', "");
    Expect(1, 32, '\p{Lb=:\Asp\z:}', "");;
    Expect(0, 33, '\p{Lb=:\Asp\z:}', "");;
    Expect(1, 32, '\p{Lb=-_SP}', "");
    Expect(0, 32, '\p{^Lb=-_SP}', "");
    Expect(0, 32, '\P{Lb=-_SP}', "");
    Expect(1, 32, '\P{^Lb=-_SP}', "");
    Expect(0, 33, '\p{Lb=-_SP}', "");
    Expect(1, 33, '\p{^Lb=-_SP}', "");
    Expect(1, 33, '\P{Lb=-_SP}', "");
    Expect(0, 33, '\P{^Lb=-_SP}', "");
    Error('\p{Is_Line_Break=:=SPACE}');
    Error('\P{Is_Line_Break=:=SPACE}');
    Expect(1, 32, '\p{Is_Line_Break=space}', "");
    Expect(0, 32, '\p{^Is_Line_Break=space}', "");
    Expect(0, 32, '\P{Is_Line_Break=space}', "");
    Expect(1, 32, '\P{^Is_Line_Break=space}', "");
    Expect(0, 33, '\p{Is_Line_Break=space}', "");
    Expect(1, 33, '\p{^Is_Line_Break=space}', "");
    Expect(1, 33, '\P{Is_Line_Break=space}', "");
    Expect(0, 33, '\P{^Is_Line_Break=space}', "");
    Expect(1, 32, '\p{Is_Line_Break=-SPACE}', "");
    Expect(0, 32, '\p{^Is_Line_Break=-SPACE}', "");
    Expect(0, 32, '\P{Is_Line_Break=-SPACE}', "");
    Expect(1, 32, '\P{^Is_Line_Break=-SPACE}', "");
    Expect(0, 33, '\p{Is_Line_Break=-SPACE}', "");
    Expect(1, 33, '\p{^Is_Line_Break=-SPACE}', "");
    Expect(1, 33, '\P{Is_Line_Break=-SPACE}', "");
    Expect(0, 33, '\P{^Is_Line_Break=-SPACE}', "");
    Error('\p{Is_Lb:_ SP/a/}');
    Error('\P{Is_Lb:_ SP/a/}');
    Expect(1, 32, '\p{Is_Lb=sp}', "");
    Expect(0, 32, '\p{^Is_Lb=sp}', "");
    Expect(0, 32, '\P{Is_Lb=sp}', "");
    Expect(1, 32, '\P{^Is_Lb=sp}', "");
    Expect(0, 33, '\p{Is_Lb=sp}', "");
    Expect(1, 33, '\p{^Is_Lb=sp}', "");
    Expect(1, 33, '\P{Is_Lb=sp}', "");
    Expect(0, 33, '\P{^Is_Lb=sp}', "");
    Expect(1, 32, '\p{Is_Lb=_SP}', "");
    Expect(0, 32, '\p{^Is_Lb=_SP}', "");
    Expect(0, 32, '\P{Is_Lb=_SP}', "");
    Expect(1, 32, '\P{^Is_Lb=_SP}', "");
    Expect(0, 33, '\p{Is_Lb=_SP}', "");
    Expect(1, 33, '\p{^Is_Lb=_SP}', "");
    Expect(1, 33, '\P{Is_Lb=_SP}', "");
    Expect(0, 33, '\P{^Is_Lb=_SP}', "");
    Error('\p{Line_Break=  break_Symbols/a/}');
    Error('\P{Line_Break=  break_Symbols/a/}');
    Expect(1, 47, '\p{Line_Break=:\ABreak_Symbols\z:}', "");;
    Expect(0, 48, '\p{Line_Break=:\ABreak_Symbols\z:}', "");;
    Expect(1, 47, '\p{Line_Break=breaksymbols}', "");
    Expect(0, 47, '\p{^Line_Break=breaksymbols}', "");
    Expect(0, 47, '\P{Line_Break=breaksymbols}', "");
    Expect(1, 47, '\P{^Line_Break=breaksymbols}', "");
    Expect(0, 48, '\p{Line_Break=breaksymbols}', "");
    Expect(1, 48, '\p{^Line_Break=breaksymbols}', "");
    Expect(1, 48, '\P{Line_Break=breaksymbols}', "");
    Expect(0, 48, '\P{^Line_Break=breaksymbols}', "");
    Expect(1, 47, '\p{Line_Break=:\Abreaksymbols\z:}', "");;
    Expect(0, 48, '\p{Line_Break=:\Abreaksymbols\z:}', "");;
    Expect(1, 47, '\p{Line_Break=	_Break_symbols}', "");
    Expect(0, 47, '\p{^Line_Break=	_Break_symbols}', "");
    Expect(0, 47, '\P{Line_Break=	_Break_symbols}', "");
    Expect(1, 47, '\P{^Line_Break=	_Break_symbols}', "");
    Expect(0, 48, '\p{Line_Break=	_Break_symbols}', "");
    Expect(1, 48, '\p{^Line_Break=	_Break_symbols}', "");
    Expect(1, 48, '\P{Line_Break=	_Break_symbols}', "");
    Expect(0, 48, '\P{^Line_Break=	_Break_symbols}', "");
    Error('\p{Lb=_	SY:=}');
    Error('\P{Lb=_	SY:=}');
    Expect(1, 47, '\p{Lb=:\ASY\z:}', "");;
    Expect(0, 48, '\p{Lb=:\ASY\z:}', "");;
    Expect(1, 47, '\p{Lb=sy}', "");
    Expect(0, 47, '\p{^Lb=sy}', "");
    Expect(0, 47, '\P{Lb=sy}', "");
    Expect(1, 47, '\P{^Lb=sy}', "");
    Expect(0, 48, '\p{Lb=sy}', "");
    Expect(1, 48, '\p{^Lb=sy}', "");
    Expect(1, 48, '\P{Lb=sy}', "");
    Expect(0, 48, '\P{^Lb=sy}', "");
    Expect(1, 47, '\p{Lb=:\Asy\z:}', "");;
    Expect(0, 48, '\p{Lb=:\Asy\z:}', "");;
    Error('\p{Is_Line_Break=_:=BREAK_SYMBOLS}');
    Error('\P{Is_Line_Break=_:=BREAK_SYMBOLS}');
    Expect(1, 47, '\p{Is_Line_Break: breaksymbols}', "");
    Expect(0, 47, '\p{^Is_Line_Break: breaksymbols}', "");
    Expect(0, 47, '\P{Is_Line_Break: breaksymbols}', "");
    Expect(1, 47, '\P{^Is_Line_Break: breaksymbols}', "");
    Expect(0, 48, '\p{Is_Line_Break: breaksymbols}', "");
    Expect(1, 48, '\p{^Is_Line_Break: breaksymbols}', "");
    Expect(1, 48, '\P{Is_Line_Break: breaksymbols}', "");
    Expect(0, 48, '\P{^Is_Line_Break: breaksymbols}', "");
    Expect(1, 47, '\p{Is_Line_Break=_Break_symbols}', "");
    Expect(0, 47, '\p{^Is_Line_Break=_Break_symbols}', "");
    Expect(0, 47, '\P{Is_Line_Break=_Break_symbols}', "");
    Expect(1, 47, '\P{^Is_Line_Break=_Break_symbols}', "");
    Expect(0, 48, '\p{Is_Line_Break=_Break_symbols}', "");
    Expect(1, 48, '\p{^Is_Line_Break=_Break_symbols}', "");
    Expect(1, 48, '\P{Is_Line_Break=_Break_symbols}', "");
    Expect(0, 48, '\P{^Is_Line_Break=_Break_symbols}', "");
    Error('\p{Is_Lb:   :=_-SY}');
    Error('\P{Is_Lb:   :=_-SY}');
    Expect(1, 47, '\p{Is_Lb:   sy}', "");
    Expect(0, 47, '\p{^Is_Lb:   sy}', "");
    Expect(0, 47, '\P{Is_Lb:   sy}', "");
    Expect(1, 47, '\P{^Is_Lb:   sy}', "");
    Expect(0, 48, '\p{Is_Lb:   sy}', "");
    Expect(1, 48, '\p{^Is_Lb:   sy}', "");
    Expect(1, 48, '\P{Is_Lb:   sy}', "");
    Expect(0, 48, '\P{^Is_Lb:   sy}', "");
    Expect(1, 47, '\p{Is_Lb=_	sy}', "");
    Expect(0, 47, '\p{^Is_Lb=_	sy}', "");
    Expect(0, 47, '\P{Is_Lb=_	sy}', "");
    Expect(1, 47, '\P{^Is_Lb=_	sy}', "");
    Expect(0, 48, '\p{Is_Lb=_	sy}', "");
    Expect(1, 48, '\p{^Is_Lb=_	sy}', "");
    Expect(1, 48, '\P{Is_Lb=_	sy}', "");
    Expect(0, 48, '\P{^Is_Lb=_	sy}', "");
    Error('\p{Line_Break=:= word_JOINER}');
    Error('\P{Line_Break=:= word_JOINER}');
    Expect(1, 65279, '\p{Line_Break=:\AWord_Joiner\z:}', "");;
    Expect(0, 65280, '\p{Line_Break=:\AWord_Joiner\z:}', "");;
    Expect(1, 65279, '\p{Line_Break=wordjoiner}', "");
    Expect(0, 65279, '\p{^Line_Break=wordjoiner}', "");
    Expect(0, 65279, '\P{Line_Break=wordjoiner}', "");
    Expect(1, 65279, '\P{^Line_Break=wordjoiner}', "");
    Expect(0, 65280, '\p{Line_Break=wordjoiner}', "");
    Expect(1, 65280, '\p{^Line_Break=wordjoiner}', "");
    Expect(1, 65280, '\P{Line_Break=wordjoiner}', "");
    Expect(0, 65280, '\P{^Line_Break=wordjoiner}', "");
    Expect(1, 65279, '\p{Line_Break=:\Awordjoiner\z:}', "");;
    Expect(0, 65280, '\p{Line_Break=:\Awordjoiner\z:}', "");;
    Expect(1, 65279, '\p{Line_Break= 	WORD_JOINER}', "");
    Expect(0, 65279, '\p{^Line_Break= 	WORD_JOINER}', "");
    Expect(0, 65279, '\P{Line_Break= 	WORD_JOINER}', "");
    Expect(1, 65279, '\P{^Line_Break= 	WORD_JOINER}', "");
    Expect(0, 65280, '\p{Line_Break= 	WORD_JOINER}', "");
    Expect(1, 65280, '\p{^Line_Break= 	WORD_JOINER}', "");
    Expect(1, 65280, '\P{Line_Break= 	WORD_JOINER}', "");
    Expect(0, 65280, '\P{^Line_Break= 	WORD_JOINER}', "");
    Error('\p{Lb=_WJ:=}');
    Error('\P{Lb=_WJ:=}');
    Expect(1, 65279, '\p{Lb=:\AWJ\z:}', "");;
    Expect(0, 65280, '\p{Lb=:\AWJ\z:}', "");;
    Expect(1, 65279, '\p{Lb=wj}', "");
    Expect(0, 65279, '\p{^Lb=wj}', "");
    Expect(0, 65279, '\P{Lb=wj}', "");
    Expect(1, 65279, '\P{^Lb=wj}', "");
    Expect(0, 65280, '\p{Lb=wj}', "");
    Expect(1, 65280, '\p{^Lb=wj}', "");
    Expect(1, 65280, '\P{Lb=wj}', "");
    Expect(0, 65280, '\P{^Lb=wj}', "");
    Expect(1, 65279, '\p{Lb=:\Awj\z:}', "");;
    Expect(0, 65280, '\p{Lb=:\Awj\z:}', "");;
    Expect(1, 65279, '\p{Lb:-WJ}', "");
    Expect(0, 65279, '\p{^Lb:-WJ}', "");
    Expect(0, 65279, '\P{Lb:-WJ}', "");
    Expect(1, 65279, '\P{^Lb:-WJ}', "");
    Expect(0, 65280, '\p{Lb:-WJ}', "");
    Expect(1, 65280, '\p{^Lb:-WJ}', "");
    Expect(1, 65280, '\P{Lb:-WJ}', "");
    Expect(0, 65280, '\P{^Lb:-WJ}', "");
    Error('\p{Is_Line_Break:   --word_joiner/a/}');
    Error('\P{Is_Line_Break:   --word_joiner/a/}');
    Expect(1, 65279, '\p{Is_Line_Break=wordjoiner}', "");
    Expect(0, 65279, '\p{^Is_Line_Break=wordjoiner}', "");
    Expect(0, 65279, '\P{Is_Line_Break=wordjoiner}', "");
    Expect(1, 65279, '\P{^Is_Line_Break=wordjoiner}', "");
    Expect(0, 65280, '\p{Is_Line_Break=wordjoiner}', "");
    Expect(1, 65280, '\p{^Is_Line_Break=wordjoiner}', "");
    Expect(1, 65280, '\P{Is_Line_Break=wordjoiner}', "");
    Expect(0, 65280, '\P{^Is_Line_Break=wordjoiner}', "");
    Expect(1, 65279, '\p{Is_Line_Break=__Word_joiner}', "");
    Expect(0, 65279, '\p{^Is_Line_Break=__Word_joiner}', "");
    Expect(0, 65279, '\P{Is_Line_Break=__Word_joiner}', "");
    Expect(1, 65279, '\P{^Is_Line_Break=__Word_joiner}', "");
    Expect(0, 65280, '\p{Is_Line_Break=__Word_joiner}', "");
    Expect(1, 65280, '\p{^Is_Line_Break=__Word_joiner}', "");
    Expect(1, 65280, '\P{Is_Line_Break=__Word_joiner}', "");
    Expect(0, 65280, '\P{^Is_Line_Break=__Word_joiner}', "");
    Error('\p{Is_Lb:   :=-WJ}');
    Error('\P{Is_Lb:   :=-WJ}');
    Expect(1, 65279, '\p{Is_Lb=wj}', "");
    Expect(0, 65279, '\p{^Is_Lb=wj}', "");
    Expect(0, 65279, '\P{Is_Lb=wj}', "");
    Expect(1, 65279, '\P{^Is_Lb=wj}', "");
    Expect(0, 65280, '\p{Is_Lb=wj}', "");
    Expect(1, 65280, '\p{^Is_Lb=wj}', "");
    Expect(1, 65280, '\P{Is_Lb=wj}', "");
    Expect(0, 65280, '\P{^Is_Lb=wj}', "");
    Expect(1, 65279, '\p{Is_Lb= -WJ}', "");
    Expect(0, 65279, '\p{^Is_Lb= -WJ}', "");
    Expect(0, 65279, '\P{Is_Lb= -WJ}', "");
    Expect(1, 65279, '\P{^Is_Lb= -WJ}', "");
    Expect(0, 65280, '\p{Is_Lb= -WJ}', "");
    Expect(1, 65280, '\p{^Is_Lb= -WJ}', "");
    Expect(1, 65280, '\P{Is_Lb= -WJ}', "");
    Expect(0, 65280, '\P{^Is_Lb= -WJ}', "");
    Error('\p{Line_Break=-/a/Unknown}');
    Error('\P{Line_Break=-/a/Unknown}');
    Expect(1, 918000, '\p{Line_Break=:\AUnknown\z:}', "");;
    Expect(0, 917999, '\p{Line_Break=:\AUnknown\z:}', "");;
    Expect(1, 918000, '\p{Line_Break=unknown}', "");
    Expect(0, 918000, '\p{^Line_Break=unknown}', "");
    Expect(0, 918000, '\P{Line_Break=unknown}', "");
    Expect(1, 918000, '\P{^Line_Break=unknown}', "");
    Expect(0, 917999, '\p{Line_Break=unknown}', "");
    Expect(1, 917999, '\p{^Line_Break=unknown}', "");
    Expect(1, 917999, '\P{Line_Break=unknown}', "");
    Expect(0, 917999, '\P{^Line_Break=unknown}', "");
    Expect(1, 918000, '\p{Line_Break=:\Aunknown\z:}', "");;
    Expect(0, 917999, '\p{Line_Break=:\Aunknown\z:}', "");;
    Error('\p{Lb=-	XX/a/}');
    Error('\P{Lb=-	XX/a/}');
    Expect(1, 918000, '\p{Lb=:\AXX\z:}', "");;
    Expect(0, 917999, '\p{Lb=:\AXX\z:}', "");;
    Expect(1, 918000, '\p{Lb=xx}', "");
    Expect(0, 918000, '\p{^Lb=xx}', "");
    Expect(0, 918000, '\P{Lb=xx}', "");
    Expect(1, 918000, '\P{^Lb=xx}', "");
    Expect(0, 917999, '\p{Lb=xx}', "");
    Expect(1, 917999, '\p{^Lb=xx}', "");
    Expect(1, 917999, '\P{Lb=xx}', "");
    Expect(0, 917999, '\P{^Lb=xx}', "");
    Expect(1, 918000, '\p{Lb=:\Axx\z:}', "");;
    Expect(0, 917999, '\p{Lb=:\Axx\z:}', "");;
    Expect(1, 918000, '\p{Lb=-XX}', "");
    Expect(0, 918000, '\p{^Lb=-XX}', "");
    Expect(0, 918000, '\P{Lb=-XX}', "");
    Expect(1, 918000, '\P{^Lb=-XX}', "");
    Expect(0, 917999, '\p{Lb=-XX}', "");
    Expect(1, 917999, '\p{^Lb=-XX}', "");
    Expect(1, 917999, '\P{Lb=-XX}', "");
    Expect(0, 917999, '\P{^Lb=-XX}', "");
    Error('\p{Is_Line_Break:/a/_	Unknown}');
    Error('\P{Is_Line_Break:/a/_	Unknown}');
    Expect(1, 918000, '\p{Is_Line_Break=unknown}', "");
    Expect(0, 918000, '\p{^Is_Line_Break=unknown}', "");
    Expect(0, 918000, '\P{Is_Line_Break=unknown}', "");
    Expect(1, 918000, '\P{^Is_Line_Break=unknown}', "");
    Expect(0, 917999, '\p{Is_Line_Break=unknown}', "");
    Expect(1, 917999, '\p{^Is_Line_Break=unknown}', "");
    Expect(1, 917999, '\P{Is_Line_Break=unknown}', "");
    Expect(0, 917999, '\P{^Is_Line_Break=unknown}', "");
    Expect(1, 918000, '\p{Is_Line_Break= Unknown}', "");
    Expect(0, 918000, '\p{^Is_Line_Break= Unknown}', "");
    Expect(0, 918000, '\P{Is_Line_Break= Unknown}', "");
    Expect(1, 918000, '\P{^Is_Line_Break= Unknown}', "");
    Expect(0, 917999, '\p{Is_Line_Break= Unknown}', "");
    Expect(1, 917999, '\p{^Is_Line_Break= Unknown}', "");
    Expect(1, 917999, '\P{Is_Line_Break= Unknown}', "");
    Expect(0, 917999, '\P{^Is_Line_Break= Unknown}', "");
    Error('\p{Is_Lb=:=XX}');
    Error('\P{Is_Lb=:=XX}');
    Expect(1, 918000, '\p{Is_Lb=xx}', "");
    Expect(0, 918000, '\p{^Is_Lb=xx}', "");
    Expect(0, 918000, '\P{Is_Lb=xx}', "");
    Expect(1, 918000, '\P{^Is_Lb=xx}', "");
    Expect(0, 917999, '\p{Is_Lb=xx}', "");
    Expect(1, 917999, '\p{^Is_Lb=xx}', "");
    Expect(1, 917999, '\P{Is_Lb=xx}', "");
    Expect(0, 917999, '\P{^Is_Lb=xx}', "");
    Expect(1, 918000, '\p{Is_Lb=		XX}', "");
    Expect(0, 918000, '\p{^Is_Lb=		XX}', "");
    Expect(0, 918000, '\P{Is_Lb=		XX}', "");
    Expect(1, 918000, '\P{^Is_Lb=		XX}', "");
    Expect(0, 917999, '\p{Is_Lb=		XX}', "");
    Expect(1, 917999, '\p{^Is_Lb=		XX}', "");
    Expect(1, 917999, '\P{Is_Lb=		XX}', "");
    Expect(0, 917999, '\P{^Is_Lb=		XX}', "");
    Error('\p{Line_Break=-	ZWSpace/a/}');
    Error('\P{Line_Break=-	ZWSpace/a/}');
    Expect(1, 8203, '\p{Line_Break=:\AZWSpace\z:}', "");;
    Expect(0, 8204, '\p{Line_Break=:\AZWSpace\z:}', "");;
    Expect(1, 8203, '\p{Line_Break=zwspace}', "");
    Expect(0, 8203, '\p{^Line_Break=zwspace}', "");
    Expect(0, 8203, '\P{Line_Break=zwspace}', "");
    Expect(1, 8203, '\P{^Line_Break=zwspace}', "");
    Expect(0, 8204, '\p{Line_Break=zwspace}', "");
    Expect(1, 8204, '\p{^Line_Break=zwspace}', "");
    Expect(1, 8204, '\P{Line_Break=zwspace}', "");
    Expect(0, 8204, '\P{^Line_Break=zwspace}', "");
    Expect(1, 8203, '\p{Line_Break=:\Azwspace\z:}', "");;
    Expect(0, 8204, '\p{Line_Break=:\Azwspace\z:}', "");;
    Expect(1, 8203, '\p{Line_Break=	_ZWSpace}', "");
    Expect(0, 8203, '\p{^Line_Break=	_ZWSpace}', "");
    Expect(0, 8203, '\P{Line_Break=	_ZWSpace}', "");
    Expect(1, 8203, '\P{^Line_Break=	_ZWSpace}', "");
    Expect(0, 8204, '\p{Line_Break=	_ZWSpace}', "");
    Expect(1, 8204, '\p{^Line_Break=	_ZWSpace}', "");
    Expect(1, 8204, '\P{Line_Break=	_ZWSpace}', "");
    Expect(0, 8204, '\P{^Line_Break=	_ZWSpace}', "");
    Error('\p{Lb=_/a/ZW}');
    Error('\P{Lb=_/a/ZW}');
    Expect(1, 8203, '\p{Lb=:\AZW\z:}', "");;
    Expect(0, 8204, '\p{Lb=:\AZW\z:}', "");;
    Expect(1, 8203, '\p{Lb=zw}', "");
    Expect(0, 8203, '\p{^Lb=zw}', "");
    Expect(0, 8203, '\P{Lb=zw}', "");
    Expect(1, 8203, '\P{^Lb=zw}', "");
    Expect(0, 8204, '\p{Lb=zw}', "");
    Expect(1, 8204, '\p{^Lb=zw}', "");
    Expect(1, 8204, '\P{Lb=zw}', "");
    Expect(0, 8204, '\P{^Lb=zw}', "");
    Expect(1, 8203, '\p{Lb=:\Azw\z:}', "");;
    Expect(0, 8204, '\p{Lb=:\Azw\z:}', "");;
    Expect(1, 8203, '\p{Lb=ZW}', "");
    Expect(0, 8203, '\p{^Lb=ZW}', "");
    Expect(0, 8203, '\P{Lb=ZW}', "");
    Expect(1, 8203, '\P{^Lb=ZW}', "");
    Expect(0, 8204, '\p{Lb=ZW}', "");
    Expect(1, 8204, '\p{^Lb=ZW}', "");
    Expect(1, 8204, '\P{Lb=ZW}', "");
    Expect(0, 8204, '\P{^Lb=ZW}', "");
    Error('\p{Is_Line_Break=:=_	ZWSPACE}');
    Error('\P{Is_Line_Break=:=_	ZWSPACE}');
    Expect(1, 8203, '\p{Is_Line_Break: zwspace}', "");
    Expect(0, 8203, '\p{^Is_Line_Break: zwspace}', "");
    Expect(0, 8203, '\P{Is_Line_Break: zwspace}', "");
    Expect(1, 8203, '\P{^Is_Line_Break: zwspace}', "");
    Expect(0, 8204, '\p{Is_Line_Break: zwspace}', "");
    Expect(1, 8204, '\p{^Is_Line_Break: zwspace}', "");
    Expect(1, 8204, '\P{Is_Line_Break: zwspace}', "");
    Expect(0, 8204, '\P{^Is_Line_Break: zwspace}', "");
    Expect(1, 8203, '\p{Is_Line_Break= 	ZWSpace}', "");
    Expect(0, 8203, '\p{^Is_Line_Break= 	ZWSpace}', "");
    Expect(0, 8203, '\P{Is_Line_Break= 	ZWSpace}', "");
    Expect(1, 8203, '\P{^Is_Line_Break= 	ZWSpace}', "");
    Expect(0, 8204, '\p{Is_Line_Break= 	ZWSpace}', "");
    Expect(1, 8204, '\p{^Is_Line_Break= 	ZWSpace}', "");
    Expect(1, 8204, '\P{Is_Line_Break= 	ZWSpace}', "");
    Expect(0, 8204, '\P{^Is_Line_Break= 	ZWSpace}', "");
    Error('\p{Is_Lb=-/a/ZW}');
    Error('\P{Is_Lb=-/a/ZW}');
    Expect(1, 8203, '\p{Is_Lb=zw}', "");
    Expect(0, 8203, '\p{^Is_Lb=zw}', "");
    Expect(0, 8203, '\P{Is_Lb=zw}', "");
    Expect(1, 8203, '\P{^Is_Lb=zw}', "");
    Expect(0, 8204, '\p{Is_Lb=zw}', "");
    Expect(1, 8204, '\p{^Is_Lb=zw}', "");
    Expect(1, 8204, '\P{Is_Lb=zw}', "");
    Expect(0, 8204, '\P{^Is_Lb=zw}', "");
    Expect(1, 8203, '\p{Is_Lb= zw}', "");
    Expect(0, 8203, '\p{^Is_Lb= zw}', "");
    Expect(0, 8203, '\P{Is_Lb= zw}', "");
    Expect(1, 8203, '\P{^Is_Lb= zw}', "");
    Expect(0, 8204, '\p{Is_Lb= zw}', "");
    Expect(1, 8204, '\p{^Is_Lb= zw}', "");
    Expect(1, 8204, '\P{Is_Lb= zw}', "");
    Expect(0, 8204, '\P{^Is_Lb= zw}', "");
    Error('\p{Line_Break=/a/ZWJ}');
    Error('\P{Line_Break=/a/ZWJ}');
    Expect(1, 8205, '\p{Line_Break=:\AZWJ\z:}', "");;
    Expect(0, 8206, '\p{Line_Break=:\AZWJ\z:}', "");;
    Expect(1, 8205, '\p{Line_Break=zwj}', "");
    Expect(0, 8205, '\p{^Line_Break=zwj}', "");
    Expect(0, 8205, '\P{Line_Break=zwj}', "");
    Expect(1, 8205, '\P{^Line_Break=zwj}', "");
    Expect(0, 8206, '\p{Line_Break=zwj}', "");
    Expect(1, 8206, '\p{^Line_Break=zwj}', "");
    Expect(1, 8206, '\P{Line_Break=zwj}', "");
    Expect(0, 8206, '\P{^Line_Break=zwj}', "");
    Expect(1, 8205, '\p{Line_Break=:\Azwj\z:}', "");;
    Expect(0, 8206, '\p{Line_Break=:\Azwj\z:}', "");;
    Expect(1, 8205, '\p{Line_Break=	ZWJ}', "");
    Expect(0, 8205, '\p{^Line_Break=	ZWJ}', "");
    Expect(0, 8205, '\P{Line_Break=	ZWJ}', "");
    Expect(1, 8205, '\P{^Line_Break=	ZWJ}', "");
    Expect(0, 8206, '\p{Line_Break=	ZWJ}', "");
    Expect(1, 8206, '\p{^Line_Break=	ZWJ}', "");
    Expect(1, 8206, '\P{Line_Break=	ZWJ}', "");
    Expect(0, 8206, '\P{^Line_Break=	ZWJ}', "");
    Error('\p{Lb=-/a/ZWJ}');
    Error('\P{Lb=-/a/ZWJ}');
    Expect(1, 8205, '\p{Lb=:\AZWJ\z:}', "");;
    Expect(0, 8206, '\p{Lb=:\AZWJ\z:}', "");;
    Expect(1, 8205, '\p{Lb:zwj}', "");
    Expect(0, 8205, '\p{^Lb:zwj}', "");
    Expect(0, 8205, '\P{Lb:zwj}', "");
    Expect(1, 8205, '\P{^Lb:zwj}', "");
    Expect(0, 8206, '\p{Lb:zwj}', "");
    Expect(1, 8206, '\p{^Lb:zwj}', "");
    Expect(1, 8206, '\P{Lb:zwj}', "");
    Expect(0, 8206, '\P{^Lb:zwj}', "");
    Expect(1, 8205, '\p{Lb=:\Azwj\z:}', "");;
    Expect(0, 8206, '\p{Lb=:\Azwj\z:}', "");;
    Expect(1, 8205, '\p{Lb:   	_zwj}', "");
    Expect(0, 8205, '\p{^Lb:   	_zwj}', "");
    Expect(0, 8205, '\P{Lb:   	_zwj}', "");
    Expect(1, 8205, '\P{^Lb:   	_zwj}', "");
    Expect(0, 8206, '\p{Lb:   	_zwj}', "");
    Expect(1, 8206, '\p{^Lb:   	_zwj}', "");
    Expect(1, 8206, '\P{Lb:   	_zwj}', "");
    Expect(0, 8206, '\P{^Lb:   	_zwj}', "");
    Error('\p{Is_Line_Break= -zwj/a/}');
    Error('\P{Is_Line_Break= -zwj/a/}');
    Expect(1, 8205, '\p{Is_Line_Break=zwj}', "");
    Expect(0, 8205, '\p{^Is_Line_Break=zwj}', "");
    Expect(0, 8205, '\P{Is_Line_Break=zwj}', "");
    Expect(1, 8205, '\P{^Is_Line_Break=zwj}', "");
    Expect(0, 8206, '\p{Is_Line_Break=zwj}', "");
    Expect(1, 8206, '\p{^Is_Line_Break=zwj}', "");
    Expect(1, 8206, '\P{Is_Line_Break=zwj}', "");
    Expect(0, 8206, '\P{^Is_Line_Break=zwj}', "");
    Expect(1, 8205, '\p{Is_Line_Break=	ZWJ}', "");
    Expect(0, 8205, '\p{^Is_Line_Break=	ZWJ}', "");
    Expect(0, 8205, '\P{Is_Line_Break=	ZWJ}', "");
    Expect(1, 8205, '\P{^Is_Line_Break=	ZWJ}', "");
    Expect(0, 8206, '\p{Is_Line_Break=	ZWJ}', "");
    Expect(1, 8206, '\p{^Is_Line_Break=	ZWJ}', "");
    Expect(1, 8206, '\P{Is_Line_Break=	ZWJ}', "");
    Expect(0, 8206, '\P{^Is_Line_Break=	ZWJ}', "");
    Error('\p{Is_Lb=:=-ZWJ}');
    Error('\P{Is_Lb=:=-ZWJ}');
    Expect(1, 8205, '\p{Is_Lb:zwj}', "");
    Expect(0, 8205, '\p{^Is_Lb:zwj}', "");
    Expect(0, 8205, '\P{Is_Lb:zwj}', "");
    Expect(1, 8205, '\P{^Is_Lb:zwj}', "");
    Expect(0, 8206, '\p{Is_Lb:zwj}', "");
    Expect(1, 8206, '\p{^Is_Lb:zwj}', "");
    Expect(1, 8206, '\P{Is_Lb:zwj}', "");
    Expect(0, 8206, '\P{^Is_Lb:zwj}', "");
    Expect(1, 8205, '\p{Is_Lb=	 ZWJ}', "");
    Expect(0, 8205, '\p{^Is_Lb=	 ZWJ}', "");
    Expect(0, 8205, '\P{Is_Lb=	 ZWJ}', "");
    Expect(1, 8205, '\P{^Is_Lb=	 ZWJ}', "");
    Expect(0, 8206, '\p{Is_Lb=	 ZWJ}', "");
    Expect(1, 8206, '\p{^Is_Lb=	 ZWJ}', "");
    Expect(1, 8206, '\P{Is_Lb=	 ZWJ}', "");
    Expect(0, 8206, '\P{^Is_Lb=	 ZWJ}', "");
    Error('\p{lowercasemapping}');
    Error('\P{lowercasemapping}');
    Error('\p{legacycasefolding}');
    Error('\P{legacycasefolding}');
    Error('\p{legacylowercasemapping}');
    Error('\P{legacylowercasemapping}');
    Error('\p{legacyperldecimaldigit}');
    Error('\P{legacyperldecimaldigit}');
    Error('\p{legacytitlecasemapping}');
    Error('\P{legacytitlecasemapping}');
    Error('\p{legacyuppercasemapping}');
    Error('\P{legacyuppercasemapping}');
    Error('\p{Logical_Order_Exception= :=NO}');
    Error('\P{Logical_Order_Exception= :=NO}');
    Expect(1, 43709, '\p{Logical_Order_Exception=:\ANo\z:}', "");;
    Expect(0, 43708, '\p{Logical_Order_Exception=:\ANo\z:}', "");;
    Expect(1, 43709, '\p{Logical_Order_Exception=no}', "");
    Expect(0, 43709, '\p{^Logical_Order_Exception=no}', "");
    Expect(0, 43709, '\P{Logical_Order_Exception=no}', "");
    Expect(1, 43709, '\P{^Logical_Order_Exception=no}', "");
    Expect(0, 43708, '\p{Logical_Order_Exception=no}', "");
    Expect(1, 43708, '\p{^Logical_Order_Exception=no}', "");
    Expect(1, 43708, '\P{Logical_Order_Exception=no}', "");
    Expect(0, 43708, '\P{^Logical_Order_Exception=no}', "");
    Expect(1, 43709, '\p{Logical_Order_Exception=:\Ano\z:}', "");;
    Expect(0, 43708, '\p{Logical_Order_Exception=:\Ano\z:}', "");;
    Expect(1, 43709, '\p{Logical_Order_Exception=_No}', "");
    Expect(0, 43709, '\p{^Logical_Order_Exception=_No}', "");
    Expect(0, 43709, '\P{Logical_Order_Exception=_No}', "");
    Expect(1, 43709, '\P{^Logical_Order_Exception=_No}', "");
    Expect(0, 43708, '\p{Logical_Order_Exception=_No}', "");
    Expect(1, 43708, '\p{^Logical_Order_Exception=_No}', "");
    Expect(1, 43708, '\P{Logical_Order_Exception=_No}', "");
    Expect(0, 43708, '\P{^Logical_Order_Exception=_No}', "");
    Error('\p{LOE=/a/	N}');
    Error('\P{LOE=/a/	N}');
    Expect(1, 43709, '\p{LOE=:\AN\z:}', "");;
    Expect(0, 43708, '\p{LOE=:\AN\z:}', "");;
    Expect(1, 43709, '\p{LOE=n}', "");
    Expect(0, 43709, '\p{^LOE=n}', "");
    Expect(0, 43709, '\P{LOE=n}', "");
    Expect(1, 43709, '\P{^LOE=n}', "");
    Expect(0, 43708, '\p{LOE=n}', "");
    Expect(1, 43708, '\p{^LOE=n}', "");
    Expect(1, 43708, '\P{LOE=n}', "");
    Expect(0, 43708, '\P{^LOE=n}', "");
    Expect(1, 43709, '\p{LOE=:\An\z:}', "");;
    Expect(0, 43708, '\p{LOE=:\An\z:}', "");;
    Expect(1, 43709, '\p{LOE=	-N}', "");
    Expect(0, 43709, '\p{^LOE=	-N}', "");
    Expect(0, 43709, '\P{LOE=	-N}', "");
    Expect(1, 43709, '\P{^LOE=	-N}', "");
    Expect(0, 43708, '\p{LOE=	-N}', "");
    Expect(1, 43708, '\p{^LOE=	-N}', "");
    Expect(1, 43708, '\P{LOE=	-N}', "");
    Expect(0, 43708, '\P{^LOE=	-N}', "");
    Error('\p{Is_Logical_Order_Exception:	/a/-_F}');
    Error('\P{Is_Logical_Order_Exception:	/a/-_F}');
    Expect(1, 43709, '\p{Is_Logical_Order_Exception=f}', "");
    Expect(0, 43709, '\p{^Is_Logical_Order_Exception=f}', "");
    Expect(0, 43709, '\P{Is_Logical_Order_Exception=f}', "");
    Expect(1, 43709, '\P{^Is_Logical_Order_Exception=f}', "");
    Expect(0, 43708, '\p{Is_Logical_Order_Exception=f}', "");
    Expect(1, 43708, '\p{^Is_Logical_Order_Exception=f}', "");
    Expect(1, 43708, '\P{Is_Logical_Order_Exception=f}', "");
    Expect(0, 43708, '\P{^Is_Logical_Order_Exception=f}', "");
    Expect(1, 43709, '\p{Is_Logical_Order_Exception=--F}', "");
    Expect(0, 43709, '\p{^Is_Logical_Order_Exception=--F}', "");
    Expect(0, 43709, '\P{Is_Logical_Order_Exception=--F}', "");
    Expect(1, 43709, '\P{^Is_Logical_Order_Exception=--F}', "");
    Expect(0, 43708, '\p{Is_Logical_Order_Exception=--F}', "");
    Expect(1, 43708, '\p{^Is_Logical_Order_Exception=--F}', "");
    Expect(1, 43708, '\P{Is_Logical_Order_Exception=--F}', "");
    Expect(0, 43708, '\P{^Is_Logical_Order_Exception=--F}', "");
    Error('\p{Is_LOE=:=False}');
    Error('\P{Is_LOE=:=False}');
    Expect(1, 43709, '\p{Is_LOE=false}', "");
    Expect(0, 43709, '\p{^Is_LOE=false}', "");
    Expect(0, 43709, '\P{Is_LOE=false}', "");
    Expect(1, 43709, '\P{^Is_LOE=false}', "");
    Expect(0, 43708, '\p{Is_LOE=false}', "");
    Expect(1, 43708, '\p{^Is_LOE=false}', "");
    Expect(1, 43708, '\P{Is_LOE=false}', "");
    Expect(0, 43708, '\P{^Is_LOE=false}', "");
    Expect(1, 43709, '\p{Is_LOE=	-False}', "");
    Expect(0, 43709, '\p{^Is_LOE=	-False}', "");
    Expect(0, 43709, '\P{Is_LOE=	-False}', "");
    Expect(1, 43709, '\P{^Is_LOE=	-False}', "");
    Expect(0, 43708, '\p{Is_LOE=	-False}', "");
    Expect(1, 43708, '\p{^Is_LOE=	-False}', "");
    Expect(1, 43708, '\P{Is_LOE=	-False}', "");
    Expect(0, 43708, '\P{^Is_LOE=	-False}', "");
    Error('\p{Logical_Order_Exception=_:=Yes}');
    Error('\P{Logical_Order_Exception=_:=Yes}');
    Expect(1, 43708, '\p{Logical_Order_Exception=:\AYes\z:}', "");;
    Expect(0, 43709, '\p{Logical_Order_Exception=:\AYes\z:}', "");;
    Expect(1, 43708, '\p{Logical_Order_Exception=yes}', "");
    Expect(0, 43708, '\p{^Logical_Order_Exception=yes}', "");
    Expect(0, 43708, '\P{Logical_Order_Exception=yes}', "");
    Expect(1, 43708, '\P{^Logical_Order_Exception=yes}', "");
    Expect(0, 43709, '\p{Logical_Order_Exception=yes}', "");
    Expect(1, 43709, '\p{^Logical_Order_Exception=yes}', "");
    Expect(1, 43709, '\P{Logical_Order_Exception=yes}', "");
    Expect(0, 43709, '\P{^Logical_Order_Exception=yes}', "");
    Expect(1, 43708, '\p{Logical_Order_Exception=:\Ayes\z:}', "");;
    Expect(0, 43709, '\p{Logical_Order_Exception=:\Ayes\z:}', "");;
    Expect(1, 43708, '\p{Logical_Order_Exception=	_YES}', "");
    Expect(0, 43708, '\p{^Logical_Order_Exception=	_YES}', "");
    Expect(0, 43708, '\P{Logical_Order_Exception=	_YES}', "");
    Expect(1, 43708, '\P{^Logical_Order_Exception=	_YES}', "");
    Expect(0, 43709, '\p{Logical_Order_Exception=	_YES}', "");
    Expect(1, 43709, '\p{^Logical_Order_Exception=	_YES}', "");
    Expect(1, 43709, '\P{Logical_Order_Exception=	_YES}', "");
    Expect(0, 43709, '\P{^Logical_Order_Exception=	_YES}', "");
    Error('\p{LOE= -Y/a/}');
    Error('\P{LOE= -Y/a/}');
    Expect(1, 43708, '\p{LOE=:\AY\z:}', "");;
    Expect(0, 43709, '\p{LOE=:\AY\z:}', "");;
    Expect(1, 43708, '\p{LOE=y}', "");
    Expect(0, 43708, '\p{^LOE=y}', "");
    Expect(0, 43708, '\P{LOE=y}', "");
    Expect(1, 43708, '\P{^LOE=y}', "");
    Expect(0, 43709, '\p{LOE=y}', "");
    Expect(1, 43709, '\p{^LOE=y}', "");
    Expect(1, 43709, '\P{LOE=y}', "");
    Expect(0, 43709, '\P{^LOE=y}', "");
    Expect(1, 43708, '\p{LOE=:\Ay\z:}', "");;
    Expect(0, 43709, '\p{LOE=:\Ay\z:}', "");;
    Expect(1, 43708, '\p{LOE=		Y}', "");
    Expect(0, 43708, '\p{^LOE=		Y}', "");
    Expect(0, 43708, '\P{LOE=		Y}', "");
    Expect(1, 43708, '\P{^LOE=		Y}', "");
    Expect(0, 43709, '\p{LOE=		Y}', "");
    Expect(1, 43709, '\p{^LOE=		Y}', "");
    Expect(1, 43709, '\P{LOE=		Y}', "");
    Expect(0, 43709, '\P{^LOE=		Y}', "");
    Error('\p{Is_Logical_Order_Exception=-	T/a/}');
    Error('\P{Is_Logical_Order_Exception=-	T/a/}');
    Expect(1, 43708, '\p{Is_Logical_Order_Exception=t}', "");
    Expect(0, 43708, '\p{^Is_Logical_Order_Exception=t}', "");
    Expect(0, 43708, '\P{Is_Logical_Order_Exception=t}', "");
    Expect(1, 43708, '\P{^Is_Logical_Order_Exception=t}', "");
    Expect(0, 43709, '\p{Is_Logical_Order_Exception=t}', "");
    Expect(1, 43709, '\p{^Is_Logical_Order_Exception=t}', "");
    Expect(1, 43709, '\P{Is_Logical_Order_Exception=t}', "");
    Expect(0, 43709, '\P{^Is_Logical_Order_Exception=t}', "");
    Expect(1, 43708, '\p{Is_Logical_Order_Exception=_t}', "");
    Expect(0, 43708, '\p{^Is_Logical_Order_Exception=_t}', "");
    Expect(0, 43708, '\P{Is_Logical_Order_Exception=_t}', "");
    Expect(1, 43708, '\P{^Is_Logical_Order_Exception=_t}', "");
    Expect(0, 43709, '\p{Is_Logical_Order_Exception=_t}', "");
    Expect(1, 43709, '\p{^Is_Logical_Order_Exception=_t}', "");
    Expect(1, 43709, '\P{Is_Logical_Order_Exception=_t}', "");
    Expect(0, 43709, '\P{^Is_Logical_Order_Exception=_t}', "");
    Error('\p{Is_LOE= True/a/}');
    Error('\P{Is_LOE= True/a/}');
    Expect(1, 43708, '\p{Is_LOE=true}', "");
    Expect(0, 43708, '\p{^Is_LOE=true}', "");
    Expect(0, 43708, '\P{Is_LOE=true}', "");
    Expect(1, 43708, '\P{^Is_LOE=true}', "");
    Expect(0, 43709, '\p{Is_LOE=true}', "");
    Expect(1, 43709, '\p{^Is_LOE=true}', "");
    Expect(1, 43709, '\P{Is_LOE=true}', "");
    Expect(0, 43709, '\P{^Is_LOE=true}', "");
    Expect(1, 43708, '\p{Is_LOE=		true}', "");
    Expect(0, 43708, '\p{^Is_LOE=		true}', "");
    Expect(0, 43708, '\P{Is_LOE=		true}', "");
    Expect(1, 43708, '\P{^Is_LOE=		true}', "");
    Expect(0, 43709, '\p{Is_LOE=		true}', "");
    Expect(1, 43709, '\p{^Is_LOE=		true}', "");
    Expect(1, 43709, '\P{Is_LOE=		true}', "");
    Expect(0, 43709, '\P{^Is_LOE=		true}', "");
    Error('\p{Lowercase=-No:=}');
    Error('\P{Lowercase=-No:=}');
    Expect(1, 125252, '\p{Lowercase=:\ANo\z:}', "");;
    Expect(0, 125251, '\p{Lowercase=:\ANo\z:}', "");;
    Expect(1, 125252, '\p{Lowercase:no}', "");
    Expect(0, 125252, '\p{^Lowercase:no}', "");
    Expect(0, 125252, '\P{Lowercase:no}', "");
    Expect(1, 125252, '\P{^Lowercase:no}', "");
    Expect(0, 125251, '\p{Lowercase:no}', "");
    Expect(1, 125251, '\p{^Lowercase:no}', "");
    Expect(1, 125251, '\P{Lowercase:no}', "");
    Expect(0, 125251, '\P{^Lowercase:no}', "");
    Expect(1, 125252, '\p{Lowercase=:\Ano\z:}', "");;
    Expect(0, 125251, '\p{Lowercase=:\Ano\z:}', "");;
    Expect(1, 125252, '\p{Lowercase=-	No}', "");
    Expect(0, 125252, '\p{^Lowercase=-	No}', "");
    Expect(0, 125252, '\P{Lowercase=-	No}', "");
    Expect(1, 125252, '\P{^Lowercase=-	No}', "");
    Expect(0, 125251, '\p{Lowercase=-	No}', "");
    Expect(1, 125251, '\p{^Lowercase=-	No}', "");
    Expect(1, 125251, '\P{Lowercase=-	No}', "");
    Expect(0, 125251, '\P{^Lowercase=-	No}', "");
    Error('\p{Lower=__n/a/}');
    Error('\P{Lower=__n/a/}');
    Expect(1, 125252, '\p{Lower=:\AN\z:}', "");;
    Expect(0, 125251, '\p{Lower=:\AN\z:}', "");;
    Expect(1, 125252, '\p{Lower=n}', "");
    Expect(0, 125252, '\p{^Lower=n}', "");
    Expect(0, 125252, '\P{Lower=n}', "");
    Expect(1, 125252, '\P{^Lower=n}', "");
    Expect(0, 125251, '\p{Lower=n}', "");
    Expect(1, 125251, '\p{^Lower=n}', "");
    Expect(1, 125251, '\P{Lower=n}', "");
    Expect(0, 125251, '\P{^Lower=n}', "");
    Expect(1, 125252, '\p{Lower=:\An\z:}', "");;
    Expect(0, 125251, '\p{Lower=:\An\z:}', "");;
    Expect(1, 125252, '\p{Lower=-	N}', "");
    Expect(0, 125252, '\p{^Lower=-	N}', "");
    Expect(0, 125252, '\P{Lower=-	N}', "");
    Expect(1, 125252, '\P{^Lower=-	N}', "");
    Expect(0, 125251, '\p{Lower=-	N}', "");
    Expect(1, 125251, '\p{^Lower=-	N}', "");
    Expect(1, 125251, '\P{Lower=-	N}', "");
    Expect(0, 125251, '\P{^Lower=-	N}', "");
    Error('\p{Is_Lowercase=	:=F}');
    Error('\P{Is_Lowercase=	:=F}');
    Expect(1, 125252, '\p{Is_Lowercase=f}', "");
    Expect(0, 125252, '\p{^Is_Lowercase=f}', "");
    Expect(0, 125252, '\P{Is_Lowercase=f}', "");
    Expect(1, 125252, '\P{^Is_Lowercase=f}', "");
    Expect(0, 125251, '\p{Is_Lowercase=f}', "");
    Expect(1, 125251, '\p{^Is_Lowercase=f}', "");
    Expect(1, 125251, '\P{Is_Lowercase=f}', "");
    Expect(0, 125251, '\P{^Is_Lowercase=f}', "");
    Expect(1, 125252, '\p{Is_Lowercase= f}', "");
    Expect(0, 125252, '\p{^Is_Lowercase= f}', "");
    Expect(0, 125252, '\P{Is_Lowercase= f}', "");
    Expect(1, 125252, '\P{^Is_Lowercase= f}', "");
    Expect(0, 125251, '\p{Is_Lowercase= f}', "");
    Expect(1, 125251, '\p{^Is_Lowercase= f}', "");
    Expect(1, 125251, '\P{Is_Lowercase= f}', "");
    Expect(0, 125251, '\P{^Is_Lowercase= f}', "");
    Error('\p{Is_Lower:   _-False:=}');
    Error('\P{Is_Lower:   _-False:=}');
    Expect(1, 125252, '\p{Is_Lower=false}', "");
    Expect(0, 125252, '\p{^Is_Lower=false}', "");
    Expect(0, 125252, '\P{Is_Lower=false}', "");
    Expect(1, 125252, '\P{^Is_Lower=false}', "");
    Expect(0, 125251, '\p{Is_Lower=false}', "");
    Expect(1, 125251, '\p{^Is_Lower=false}', "");
    Expect(1, 125251, '\P{Is_Lower=false}', "");
    Expect(0, 125251, '\P{^Is_Lower=false}', "");
    Expect(1, 125252, '\p{Is_Lower:	- FALSE}', "");
    Expect(0, 125252, '\p{^Is_Lower:	- FALSE}', "");
    Expect(0, 125252, '\P{Is_Lower:	- FALSE}', "");
    Expect(1, 125252, '\P{^Is_Lower:	- FALSE}', "");
    Expect(0, 125251, '\p{Is_Lower:	- FALSE}', "");
    Expect(1, 125251, '\p{^Is_Lower:	- FALSE}', "");
    Expect(1, 125251, '\P{Is_Lower:	- FALSE}', "");
    Expect(0, 125251, '\P{^Is_Lower:	- FALSE}', "");
    Error('\p{Lowercase:	:=- Yes}');
    Error('\P{Lowercase:	:=- Yes}');
    Expect(1, 125251, '\p{Lowercase=:\AYes\z:}', "");;
    Expect(0, 125252, '\p{Lowercase=:\AYes\z:}', "");;
    Expect(1, 125251, '\p{Lowercase=yes}', "");
    Expect(0, 125251, '\p{^Lowercase=yes}', "");
    Expect(0, 125251, '\P{Lowercase=yes}', "");
    Expect(1, 125251, '\P{^Lowercase=yes}', "");
    Expect(0, 125252, '\p{Lowercase=yes}', "");
    Expect(1, 125252, '\p{^Lowercase=yes}', "");
    Expect(1, 125252, '\P{Lowercase=yes}', "");
    Expect(0, 125252, '\P{^Lowercase=yes}', "");
    Expect(1, 125251, '\p{Lowercase=:\Ayes\z:}', "");;
    Expect(0, 125252, '\p{Lowercase=:\Ayes\z:}', "");;
    Expect(1, 125251, '\p{Lowercase= -Yes}', "");
    Expect(0, 125251, '\p{^Lowercase= -Yes}', "");
    Expect(0, 125251, '\P{Lowercase= -Yes}', "");
    Expect(1, 125251, '\P{^Lowercase= -Yes}', "");
    Expect(0, 125252, '\p{Lowercase= -Yes}', "");
    Expect(1, 125252, '\p{^Lowercase= -Yes}', "");
    Expect(1, 125252, '\P{Lowercase= -Yes}', "");
    Expect(0, 125252, '\P{^Lowercase= -Yes}', "");
    Error('\p{Lower=/a/-	y}');
    Error('\P{Lower=/a/-	y}');
    Expect(1, 125251, '\p{Lower=:\AY\z:}', "");;
    Expect(0, 125252, '\p{Lower=:\AY\z:}', "");;
    Expect(1, 125251, '\p{Lower=y}', "");
    Expect(0, 125251, '\p{^Lower=y}', "");
    Expect(0, 125251, '\P{Lower=y}', "");
    Expect(1, 125251, '\P{^Lower=y}', "");
    Expect(0, 125252, '\p{Lower=y}', "");
    Expect(1, 125252, '\p{^Lower=y}', "");
    Expect(1, 125252, '\P{Lower=y}', "");
    Expect(0, 125252, '\P{^Lower=y}', "");
    Expect(1, 125251, '\p{Lower=:\Ay\z:}', "");;
    Expect(0, 125252, '\p{Lower=:\Ay\z:}', "");;
    Expect(1, 125251, '\p{Lower=	 Y}', "");
    Expect(0, 125251, '\p{^Lower=	 Y}', "");
    Expect(0, 125251, '\P{Lower=	 Y}', "");
    Expect(1, 125251, '\P{^Lower=	 Y}', "");
    Expect(0, 125252, '\p{Lower=	 Y}', "");
    Expect(1, 125252, '\p{^Lower=	 Y}', "");
    Expect(1, 125252, '\P{Lower=	 Y}', "");
    Expect(0, 125252, '\P{^Lower=	 Y}', "");
    Error('\p{Is_Lowercase=_/a/t}');
    Error('\P{Is_Lowercase=_/a/t}');
    Expect(1, 125251, '\p{Is_Lowercase=t}', "");
    Expect(0, 125251, '\p{^Is_Lowercase=t}', "");
    Expect(0, 125251, '\P{Is_Lowercase=t}', "");
    Expect(1, 125251, '\P{^Is_Lowercase=t}', "");
    Expect(0, 125252, '\p{Is_Lowercase=t}', "");
    Expect(1, 125252, '\p{^Is_Lowercase=t}', "");
    Expect(1, 125252, '\P{Is_Lowercase=t}', "");
    Expect(0, 125252, '\P{^Is_Lowercase=t}', "");
    Expect(1, 125251, '\p{Is_Lowercase= _t}', "");
    Expect(0, 125251, '\p{^Is_Lowercase= _t}', "");
    Expect(0, 125251, '\P{Is_Lowercase= _t}', "");
    Expect(1, 125251, '\P{^Is_Lowercase= _t}', "");
    Expect(0, 125252, '\p{Is_Lowercase= _t}', "");
    Expect(1, 125252, '\p{^Is_Lowercase= _t}', "");
    Expect(1, 125252, '\P{Is_Lowercase= _t}', "");
    Expect(0, 125252, '\P{^Is_Lowercase= _t}', "");
    Error('\p{Is_Lower: :=--TRUE}');
    Error('\P{Is_Lower: :=--TRUE}');
    Expect(1, 125251, '\p{Is_Lower=true}', "");
    Expect(0, 125251, '\p{^Is_Lower=true}', "");
    Expect(0, 125251, '\P{Is_Lower=true}', "");
    Expect(1, 125251, '\P{^Is_Lower=true}', "");
    Expect(0, 125252, '\p{Is_Lower=true}', "");
    Expect(1, 125252, '\p{^Is_Lower=true}', "");
    Expect(1, 125252, '\P{Is_Lower=true}', "");
    Expect(0, 125252, '\P{^Is_Lower=true}', "");
    Expect(1, 125251, '\p{Is_Lower= _true}', "");
    Expect(0, 125251, '\p{^Is_Lower= _true}', "");
    Expect(0, 125251, '\P{Is_Lower= _true}', "");
    Expect(1, 125251, '\P{^Is_Lower= _true}', "");
    Expect(0, 125252, '\p{Is_Lower= _true}', "");
    Expect(1, 125252, '\p{^Is_Lower= _true}', "");
    Expect(1, 125252, '\P{Is_Lower= _true}', "");
    Expect(0, 125252, '\P{^Is_Lower= _true}', "");
    Error('\p{Math=:=	 No}');
    Error('\P{Math=:=	 No}');
    Expect(1, 126706, '\p{Math=:\ANo\z:}', "");;
    Expect(0, 126705, '\p{Math=:\ANo\z:}', "");;
    Expect(1, 126706, '\p{Math=no}', "");
    Expect(0, 126706, '\p{^Math=no}', "");
    Expect(0, 126706, '\P{Math=no}', "");
    Expect(1, 126706, '\P{^Math=no}', "");
    Expect(0, 126705, '\p{Math=no}', "");
    Expect(1, 126705, '\p{^Math=no}', "");
    Expect(1, 126705, '\P{Math=no}', "");
    Expect(0, 126705, '\P{^Math=no}', "");
    Expect(1, 126706, '\p{Math=:\Ano\z:}', "");;
    Expect(0, 126705, '\p{Math=:\Ano\z:}', "");;
    Error('\p{Is_Math=:=		N}');
    Error('\P{Is_Math=:=		N}');
    Expect(1, 126706, '\p{Is_Math=n}', "");
    Expect(0, 126706, '\p{^Is_Math=n}', "");
    Expect(0, 126706, '\P{Is_Math=n}', "");
    Expect(1, 126706, '\P{^Is_Math=n}', "");
    Expect(0, 126705, '\p{Is_Math=n}', "");
    Expect(1, 126705, '\p{^Is_Math=n}', "");
    Expect(1, 126705, '\P{Is_Math=n}', "");
    Expect(0, 126705, '\P{^Is_Math=n}', "");
    Expect(1, 126706, '\p{Is_Math: 	n}', "");
    Expect(0, 126706, '\p{^Is_Math: 	n}', "");
    Expect(0, 126706, '\P{Is_Math: 	n}', "");
    Expect(1, 126706, '\P{^Is_Math: 	n}', "");
    Expect(0, 126705, '\p{Is_Math: 	n}', "");
    Expect(1, 126705, '\p{^Is_Math: 	n}', "");
    Expect(1, 126705, '\P{Is_Math: 	n}', "");
    Expect(0, 126705, '\P{^Is_Math: 	n}', "");
    Error('\p{Math=:= f}');
    Error('\P{Math=:= f}');
    Expect(1, 126706, '\p{Math=:\AF\z:}', "");;
    Expect(0, 126705, '\p{Math=:\AF\z:}', "");;
    Expect(1, 126706, '\p{Math=f}', "");
    Expect(0, 126706, '\p{^Math=f}', "");
    Expect(0, 126706, '\P{Math=f}', "");
    Expect(1, 126706, '\P{^Math=f}', "");
    Expect(0, 126705, '\p{Math=f}', "");
    Expect(1, 126705, '\p{^Math=f}', "");
    Expect(1, 126705, '\P{Math=f}', "");
    Expect(0, 126705, '\P{^Math=f}', "");
    Expect(1, 126706, '\p{Math=:\Af\z:}', "");;
    Expect(0, 126705, '\p{Math=:\Af\z:}', "");;
    Expect(1, 126706, '\p{Math=	F}', "");
    Expect(0, 126706, '\p{^Math=	F}', "");
    Expect(0, 126706, '\P{Math=	F}', "");
    Expect(1, 126706, '\P{^Math=	F}', "");
    Expect(0, 126705, '\p{Math=	F}', "");
    Expect(1, 126705, '\p{^Math=	F}', "");
    Expect(1, 126705, '\P{Math=	F}', "");
    Expect(0, 126705, '\P{^Math=	F}', "");
    Error('\p{Is_Math=/a/__false}');
    Error('\P{Is_Math=/a/__false}');
    Expect(1, 126706, '\p{Is_Math=false}', "");
    Expect(0, 126706, '\p{^Is_Math=false}', "");
    Expect(0, 126706, '\P{Is_Math=false}', "");
    Expect(1, 126706, '\P{^Is_Math=false}', "");
    Expect(0, 126705, '\p{Is_Math=false}', "");
    Expect(1, 126705, '\p{^Is_Math=false}', "");
    Expect(1, 126705, '\P{Is_Math=false}', "");
    Expect(0, 126705, '\P{^Is_Math=false}', "");
    Expect(1, 126706, '\p{Is_Math= -False}', "");
    Expect(0, 126706, '\p{^Is_Math= -False}', "");
    Expect(0, 126706, '\P{Is_Math= -False}', "");
    Expect(1, 126706, '\P{^Is_Math= -False}', "");
    Expect(0, 126705, '\p{Is_Math= -False}', "");
    Expect(1, 126705, '\p{^Is_Math= -False}', "");
    Expect(1, 126705, '\P{Is_Math= -False}', "");
    Expect(0, 126705, '\P{^Is_Math= -False}', "");
    Error('\p{Math=/a/YES}');
    Error('\P{Math=/a/YES}');
    Expect(1, 126705, '\p{Math=:\AYes\z:}', "");;
    Expect(0, 126706, '\p{Math=:\AYes\z:}', "");;
    Expect(1, 126705, '\p{Math=yes}', "");
    Expect(0, 126705, '\p{^Math=yes}', "");
    Expect(0, 126705, '\P{Math=yes}', "");
    Expect(1, 126705, '\P{^Math=yes}', "");
    Expect(0, 126706, '\p{Math=yes}', "");
    Expect(1, 126706, '\p{^Math=yes}', "");
    Expect(1, 126706, '\P{Math=yes}', "");
    Expect(0, 126706, '\P{^Math=yes}', "");
    Expect(1, 126705, '\p{Math=:\Ayes\z:}', "");;
    Expect(0, 126706, '\p{Math=:\Ayes\z:}', "");;
    Expect(1, 126705, '\p{Math=-YES}', "");
    Expect(0, 126705, '\p{^Math=-YES}', "");
    Expect(0, 126705, '\P{Math=-YES}', "");
    Expect(1, 126705, '\P{^Math=-YES}', "");
    Expect(0, 126706, '\p{Math=-YES}', "");
    Expect(1, 126706, '\p{^Math=-YES}', "");
    Expect(1, 126706, '\P{Math=-YES}', "");
    Expect(0, 126706, '\P{^Math=-YES}', "");
    Error('\p{Is_Math=:=__y}');
    Error('\P{Is_Math=:=__y}');
    Expect(1, 126705, '\p{Is_Math=y}', "");
    Expect(0, 126705, '\p{^Is_Math=y}', "");
    Expect(0, 126705, '\P{Is_Math=y}', "");
    Expect(1, 126705, '\P{^Is_Math=y}', "");
    Expect(0, 126706, '\p{Is_Math=y}', "");
    Expect(1, 126706, '\p{^Is_Math=y}', "");
    Expect(1, 126706, '\P{Is_Math=y}', "");
    Expect(0, 126706, '\P{^Is_Math=y}', "");
    Expect(1, 126705, '\p{Is_Math=__Y}', "");
    Expect(0, 126705, '\p{^Is_Math=__Y}', "");
    Expect(0, 126705, '\P{Is_Math=__Y}', "");
    Expect(1, 126705, '\P{^Is_Math=__Y}', "");
    Expect(0, 126706, '\p{Is_Math=__Y}', "");
    Expect(1, 126706, '\p{^Is_Math=__Y}', "");
    Expect(1, 126706, '\P{Is_Math=__Y}', "");
    Expect(0, 126706, '\P{^Is_Math=__Y}', "");
    Error('\p{Math:/a/ _T}');
    Error('\P{Math:/a/ _T}');
    Expect(1, 126705, '\p{Math=:\AT\z:}', "");;
    Expect(0, 126706, '\p{Math=:\AT\z:}', "");;
    Expect(1, 126705, '\p{Math=t}', "");
    Expect(0, 126705, '\p{^Math=t}', "");
    Expect(0, 126705, '\P{Math=t}', "");
    Expect(1, 126705, '\P{^Math=t}', "");
    Expect(0, 126706, '\p{Math=t}', "");
    Expect(1, 126706, '\p{^Math=t}', "");
    Expect(1, 126706, '\P{Math=t}', "");
    Expect(0, 126706, '\P{^Math=t}', "");
    Expect(1, 126705, '\p{Math=:\At\z:}', "");;
    Expect(0, 126706, '\p{Math=:\At\z:}', "");;
    Expect(1, 126705, '\p{Math:		T}', "");
    Expect(0, 126705, '\p{^Math:		T}', "");
    Expect(0, 126705, '\P{Math:		T}', "");
    Expect(1, 126705, '\P{^Math:		T}', "");
    Expect(0, 126706, '\p{Math:		T}', "");
    Expect(1, 126706, '\p{^Math:		T}', "");
    Expect(1, 126706, '\P{Math:		T}', "");
    Expect(0, 126706, '\P{^Math:		T}', "");
    Error('\p{Is_Math= :=True}');
    Error('\P{Is_Math= :=True}');
    Expect(1, 126705, '\p{Is_Math:	true}', "");
    Expect(0, 126705, '\p{^Is_Math:	true}', "");
    Expect(0, 126705, '\P{Is_Math:	true}', "");
    Expect(1, 126705, '\P{^Is_Math:	true}', "");
    Expect(0, 126706, '\p{Is_Math:	true}', "");
    Expect(1, 126706, '\p{^Is_Math:	true}', "");
    Expect(1, 126706, '\P{Is_Math:	true}', "");
    Expect(0, 126706, '\P{^Is_Math:	true}', "");
    Expect(1, 126705, '\p{Is_Math=TRUE}', "");
    Expect(0, 126705, '\p{^Is_Math=TRUE}', "");
    Expect(0, 126705, '\P{Is_Math=TRUE}', "");
    Expect(1, 126705, '\P{^Is_Math=TRUE}', "");
    Expect(0, 126706, '\p{Is_Math=TRUE}', "");
    Expect(1, 126706, '\p{^Is_Math=TRUE}', "");
    Expect(1, 126706, '\P{Is_Math=TRUE}', "");
    Expect(0, 126706, '\P{^Is_Math=TRUE}', "");
    Error('\p{name}');
    Error('\P{name}');
    Error('\p{na}');
    Error('\P{na}');
    Error('\p{unicode1name}');
    Error('\P{unicode1name}');
    Error('\p{na1}');
    Error('\P{na1}');
    Error('\p{namealias}');
    Error('\P{namealias}');
    Error('\p{_perlnamealias}');
    Error('\P{_perlnamealias}');
    Error('\p{Noncharacter_Code_Point=/a/No}');
    Error('\P{Noncharacter_Code_Point=/a/No}');
    Expect(1, 1114109, '\p{Noncharacter_Code_Point=:\ANo\z:}', "");;
    Expect(0, 1114111, '\p{Noncharacter_Code_Point=:\ANo\z:}', "");;
    Expect(1, 1114109, '\p{Noncharacter_Code_Point=no}', "");
    Expect(0, 1114109, '\p{^Noncharacter_Code_Point=no}', "");
    Expect(0, 1114109, '\P{Noncharacter_Code_Point=no}', "");
    Expect(1, 1114109, '\P{^Noncharacter_Code_Point=no}', "");
    Expect(0, 1114111, '\p{Noncharacter_Code_Point=no}', "");
    Expect(1, 1114111, '\p{^Noncharacter_Code_Point=no}', "");
    Expect(1, 1114111, '\P{Noncharacter_Code_Point=no}', "");
    Expect(0, 1114111, '\P{^Noncharacter_Code_Point=no}', "");
    Expect(1, 1114109, '\p{Noncharacter_Code_Point=:\Ano\z:}', "");;
    Expect(0, 1114111, '\p{Noncharacter_Code_Point=:\Ano\z:}', "");;
    Expect(1, 1114109, '\p{Noncharacter_Code_Point:		No}', "");
    Expect(0, 1114109, '\p{^Noncharacter_Code_Point:		No}', "");
    Expect(0, 1114109, '\P{Noncharacter_Code_Point:		No}', "");
    Expect(1, 1114109, '\P{^Noncharacter_Code_Point:		No}', "");
    Expect(0, 1114111, '\p{Noncharacter_Code_Point:		No}', "");
    Expect(1, 1114111, '\p{^Noncharacter_Code_Point:		No}', "");
    Expect(1, 1114111, '\P{Noncharacter_Code_Point:		No}', "");
    Expect(0, 1114111, '\P{^Noncharacter_Code_Point:		No}', "");
    Error('\p{NChar:-_N:=}');
    Error('\P{NChar:-_N:=}');
    Expect(1, 1114109, '\p{NChar=:\AN\z:}', "");;
    Expect(0, 1114111, '\p{NChar=:\AN\z:}', "");;
    Expect(1, 1114109, '\p{NChar=n}', "");
    Expect(0, 1114109, '\p{^NChar=n}', "");
    Expect(0, 1114109, '\P{NChar=n}', "");
    Expect(1, 1114109, '\P{^NChar=n}', "");
    Expect(0, 1114111, '\p{NChar=n}', "");
    Expect(1, 1114111, '\p{^NChar=n}', "");
    Expect(1, 1114111, '\P{NChar=n}', "");
    Expect(0, 1114111, '\P{^NChar=n}', "");
    Expect(1, 1114109, '\p{NChar=:\An\z:}', "");;
    Expect(0, 1114111, '\p{NChar=:\An\z:}', "");;
    Expect(1, 1114109, '\p{NChar=	N}', "");
    Expect(0, 1114109, '\p{^NChar=	N}', "");
    Expect(0, 1114109, '\P{NChar=	N}', "");
    Expect(1, 1114109, '\P{^NChar=	N}', "");
    Expect(0, 1114111, '\p{NChar=	N}', "");
    Expect(1, 1114111, '\p{^NChar=	N}', "");
    Expect(1, 1114111, '\P{NChar=	N}', "");
    Expect(0, 1114111, '\P{^NChar=	N}', "");
    Error('\p{Is_Noncharacter_Code_Point=/a/__F}');
    Error('\P{Is_Noncharacter_Code_Point=/a/__F}');
    Expect(1, 1114109, '\p{Is_Noncharacter_Code_Point=f}', "");
    Expect(0, 1114109, '\p{^Is_Noncharacter_Code_Point=f}', "");
    Expect(0, 1114109, '\P{Is_Noncharacter_Code_Point=f}', "");
    Expect(1, 1114109, '\P{^Is_Noncharacter_Code_Point=f}', "");
    Expect(0, 1114111, '\p{Is_Noncharacter_Code_Point=f}', "");
    Expect(1, 1114111, '\p{^Is_Noncharacter_Code_Point=f}', "");
    Expect(1, 1114111, '\P{Is_Noncharacter_Code_Point=f}', "");
    Expect(0, 1114111, '\P{^Is_Noncharacter_Code_Point=f}', "");
    Expect(1, 1114109, '\p{Is_Noncharacter_Code_Point=F}', "");
    Expect(0, 1114109, '\p{^Is_Noncharacter_Code_Point=F}', "");
    Expect(0, 1114109, '\P{Is_Noncharacter_Code_Point=F}', "");
    Expect(1, 1114109, '\P{^Is_Noncharacter_Code_Point=F}', "");
    Expect(0, 1114111, '\p{Is_Noncharacter_Code_Point=F}', "");
    Expect(1, 1114111, '\p{^Is_Noncharacter_Code_Point=F}', "");
    Expect(1, 1114111, '\P{Is_Noncharacter_Code_Point=F}', "");
    Expect(0, 1114111, '\P{^Is_Noncharacter_Code_Point=F}', "");
    Error('\p{Is_NChar= 	False/a/}');
    Error('\P{Is_NChar= 	False/a/}');
    Expect(1, 1114109, '\p{Is_NChar=false}', "");
    Expect(0, 1114109, '\p{^Is_NChar=false}', "");
    Expect(0, 1114109, '\P{Is_NChar=false}', "");
    Expect(1, 1114109, '\P{^Is_NChar=false}', "");
    Expect(0, 1114111, '\p{Is_NChar=false}', "");
    Expect(1, 1114111, '\p{^Is_NChar=false}', "");
    Expect(1, 1114111, '\P{Is_NChar=false}', "");
    Expect(0, 1114111, '\P{^Is_NChar=false}', "");
    Expect(1, 1114109, '\p{Is_NChar=FALSE}', "");
    Expect(0, 1114109, '\p{^Is_NChar=FALSE}', "");
    Expect(0, 1114109, '\P{Is_NChar=FALSE}', "");
    Expect(1, 1114109, '\P{^Is_NChar=FALSE}', "");
    Expect(0, 1114111, '\p{Is_NChar=FALSE}', "");
    Expect(1, 1114111, '\p{^Is_NChar=FALSE}', "");
    Expect(1, 1114111, '\P{Is_NChar=FALSE}', "");
    Expect(0, 1114111, '\P{^Is_NChar=FALSE}', "");
    Error('\p{Noncharacter_Code_Point=/a/yes}');
    Error('\P{Noncharacter_Code_Point=/a/yes}');
    Expect(1, 1114111, '\p{Noncharacter_Code_Point=:\AYes\z:}', "");;
    Expect(0, 1114109, '\p{Noncharacter_Code_Point=:\AYes\z:}', "");;
    Expect(1, 1114111, '\p{Noncharacter_Code_Point=yes}', "");
    Expect(0, 1114111, '\p{^Noncharacter_Code_Point=yes}', "");
    Expect(0, 1114111, '\P{Noncharacter_Code_Point=yes}', "");
    Expect(1, 1114111, '\P{^Noncharacter_Code_Point=yes}', "");
    Expect(0, 1114109, '\p{Noncharacter_Code_Point=yes}', "");
    Expect(1, 1114109, '\p{^Noncharacter_Code_Point=yes}', "");
    Expect(1, 1114109, '\P{Noncharacter_Code_Point=yes}', "");
    Expect(0, 1114109, '\P{^Noncharacter_Code_Point=yes}', "");
    Expect(1, 1114111, '\p{Noncharacter_Code_Point=:\Ayes\z:}', "");;
    Expect(0, 1114109, '\p{Noncharacter_Code_Point=:\Ayes\z:}', "");;
    Expect(1, 1114111, '\p{Noncharacter_Code_Point=-_YES}', "");
    Expect(0, 1114111, '\p{^Noncharacter_Code_Point=-_YES}', "");
    Expect(0, 1114111, '\P{Noncharacter_Code_Point=-_YES}', "");
    Expect(1, 1114111, '\P{^Noncharacter_Code_Point=-_YES}', "");
    Expect(0, 1114109, '\p{Noncharacter_Code_Point=-_YES}', "");
    Expect(1, 1114109, '\p{^Noncharacter_Code_Point=-_YES}', "");
    Expect(1, 1114109, '\P{Noncharacter_Code_Point=-_YES}', "");
    Expect(0, 1114109, '\P{^Noncharacter_Code_Point=-_YES}', "");
    Error('\p{NChar=_/a/Y}');
    Error('\P{NChar=_/a/Y}');
    Expect(1, 1114111, '\p{NChar=:\AY\z:}', "");;
    Expect(0, 1114109, '\p{NChar=:\AY\z:}', "");;
    Expect(1, 1114111, '\p{NChar=y}', "");
    Expect(0, 1114111, '\p{^NChar=y}', "");
    Expect(0, 1114111, '\P{NChar=y}', "");
    Expect(1, 1114111, '\P{^NChar=y}', "");
    Expect(0, 1114109, '\p{NChar=y}', "");
    Expect(1, 1114109, '\p{^NChar=y}', "");
    Expect(1, 1114109, '\P{NChar=y}', "");
    Expect(0, 1114109, '\P{^NChar=y}', "");
    Expect(1, 1114111, '\p{NChar=:\Ay\z:}', "");;
    Expect(0, 1114109, '\p{NChar=:\Ay\z:}', "");;
    Expect(1, 1114111, '\p{NChar=		y}', "");
    Expect(0, 1114111, '\p{^NChar=		y}', "");
    Expect(0, 1114111, '\P{NChar=		y}', "");
    Expect(1, 1114111, '\P{^NChar=		y}', "");
    Expect(0, 1114109, '\p{NChar=		y}', "");
    Expect(1, 1114109, '\p{^NChar=		y}', "");
    Expect(1, 1114109, '\P{NChar=		y}', "");
    Expect(0, 1114109, '\P{^NChar=		y}', "");
    Error('\p{Is_Noncharacter_Code_Point=/a/__T}');
    Error('\P{Is_Noncharacter_Code_Point=/a/__T}');
    Expect(1, 1114111, '\p{Is_Noncharacter_Code_Point:   t}', "");
    Expect(0, 1114111, '\p{^Is_Noncharacter_Code_Point:   t}', "");
    Expect(0, 1114111, '\P{Is_Noncharacter_Code_Point:   t}', "");
    Expect(1, 1114111, '\P{^Is_Noncharacter_Code_Point:   t}', "");
    Expect(0, 1114109, '\p{Is_Noncharacter_Code_Point:   t}', "");
    Expect(1, 1114109, '\p{^Is_Noncharacter_Code_Point:   t}', "");
    Expect(1, 1114109, '\P{Is_Noncharacter_Code_Point:   t}', "");
    Expect(0, 1114109, '\P{^Is_Noncharacter_Code_Point:   t}', "");
    Expect(1, 1114111, '\p{Is_Noncharacter_Code_Point= _T}', "");
    Expect(0, 1114111, '\p{^Is_Noncharacter_Code_Point= _T}', "");
    Expect(0, 1114111, '\P{Is_Noncharacter_Code_Point= _T}', "");
    Expect(1, 1114111, '\P{^Is_Noncharacter_Code_Point= _T}', "");
    Expect(0, 1114109, '\p{Is_Noncharacter_Code_Point= _T}', "");
    Expect(1, 1114109, '\p{^Is_Noncharacter_Code_Point= _T}', "");
    Expect(1, 1114109, '\P{Is_Noncharacter_Code_Point= _T}', "");
    Expect(0, 1114109, '\P{^Is_Noncharacter_Code_Point= _T}', "");
    Error('\p{Is_NChar=/a/_	True}');
    Error('\P{Is_NChar=/a/_	True}');
    Expect(1, 1114111, '\p{Is_NChar=true}', "");
    Expect(0, 1114111, '\p{^Is_NChar=true}', "");
    Expect(0, 1114111, '\P{Is_NChar=true}', "");
    Expect(1, 1114111, '\P{^Is_NChar=true}', "");
    Expect(0, 1114109, '\p{Is_NChar=true}', "");
    Expect(1, 1114109, '\p{^Is_NChar=true}', "");
    Expect(1, 1114109, '\P{Is_NChar=true}', "");
    Expect(0, 1114109, '\P{^Is_NChar=true}', "");
    Expect(1, 1114111, '\p{Is_NChar:		True}', "");
    Expect(0, 1114111, '\p{^Is_NChar:		True}', "");
    Expect(0, 1114111, '\P{Is_NChar:		True}', "");
    Expect(1, 1114111, '\P{^Is_NChar:		True}', "");
    Expect(0, 1114109, '\p{Is_NChar:		True}', "");
    Expect(1, 1114109, '\p{^Is_NChar:		True}', "");
    Expect(1, 1114109, '\P{Is_NChar:		True}', "");
    Expect(0, 1114109, '\P{^Is_NChar:		True}', "");
    Error('\p{nfcquickcheck}');
    Error('\P{nfcquickcheck}');
    Error('\p{nfcqc}');
    Error('\P{nfcqc}');
    Error('\p{NFC_Quick_Check:   	:=MAYBE}');
    Error('\P{NFC_Quick_Check:   	:=MAYBE}');
    Expect(1, 71087, '\p{NFC_Quick_Check=:\AMaybe\z:}', "");;
    Expect(0, 71088, '\p{NFC_Quick_Check=:\AMaybe\z:}', "");;
    Expect(1, 71087, '\p{NFC_Quick_Check=maybe}', "");
    Expect(0, 71087, '\p{^NFC_Quick_Check=maybe}', "");
    Expect(0, 71087, '\P{NFC_Quick_Check=maybe}', "");
    Expect(1, 71087, '\P{^NFC_Quick_Check=maybe}', "");
    Expect(0, 71088, '\p{NFC_Quick_Check=maybe}', "");
    Expect(1, 71088, '\p{^NFC_Quick_Check=maybe}', "");
    Expect(1, 71088, '\P{NFC_Quick_Check=maybe}', "");
    Expect(0, 71088, '\P{^NFC_Quick_Check=maybe}', "");
    Expect(1, 71087, '\p{NFC_Quick_Check=:\Amaybe\z:}', "");;
    Expect(0, 71088, '\p{NFC_Quick_Check=:\Amaybe\z:}', "");;
    Expect(1, 71087, '\p{NFC_Quick_Check=_Maybe}', "");
    Expect(0, 71087, '\p{^NFC_Quick_Check=_Maybe}', "");
    Expect(0, 71087, '\P{NFC_Quick_Check=_Maybe}', "");
    Expect(1, 71087, '\P{^NFC_Quick_Check=_Maybe}', "");
    Expect(0, 71088, '\p{NFC_Quick_Check=_Maybe}', "");
    Expect(1, 71088, '\p{^NFC_Quick_Check=_Maybe}', "");
    Expect(1, 71088, '\P{NFC_Quick_Check=_Maybe}', "");
    Expect(0, 71088, '\P{^NFC_Quick_Check=_Maybe}', "");
    Error('\p{NFC_QC= /a/M}');
    Error('\P{NFC_QC= /a/M}');
    Expect(1, 71087, '\p{NFC_QC=:\AM\z:}', "");;
    Expect(0, 71088, '\p{NFC_QC=:\AM\z:}', "");;
    Expect(1, 71087, '\p{NFC_QC=m}', "");
    Expect(0, 71087, '\p{^NFC_QC=m}', "");
    Expect(0, 71087, '\P{NFC_QC=m}', "");
    Expect(1, 71087, '\P{^NFC_QC=m}', "");
    Expect(0, 71088, '\p{NFC_QC=m}', "");
    Expect(1, 71088, '\p{^NFC_QC=m}', "");
    Expect(1, 71088, '\P{NFC_QC=m}', "");
    Expect(0, 71088, '\P{^NFC_QC=m}', "");
    Expect(1, 71087, '\p{NFC_QC=:\Am\z:}', "");;
    Expect(0, 71088, '\p{NFC_QC=:\Am\z:}', "");;
    Expect(1, 71087, '\p{NFC_QC= M}', "");
    Expect(0, 71087, '\p{^NFC_QC= M}', "");
    Expect(0, 71087, '\P{NFC_QC= M}', "");
    Expect(1, 71087, '\P{^NFC_QC= M}', "");
    Expect(0, 71088, '\p{NFC_QC= M}', "");
    Expect(1, 71088, '\p{^NFC_QC= M}', "");
    Expect(1, 71088, '\P{NFC_QC= M}', "");
    Expect(0, 71088, '\P{^NFC_QC= M}', "");
    Error('\p{Is_NFC_Quick_Check=:=MAYBE}');
    Error('\P{Is_NFC_Quick_Check=:=MAYBE}');
    Expect(1, 71087, '\p{Is_NFC_Quick_Check:   maybe}', "");
    Expect(0, 71087, '\p{^Is_NFC_Quick_Check:   maybe}', "");
    Expect(0, 71087, '\P{Is_NFC_Quick_Check:   maybe}', "");
    Expect(1, 71087, '\P{^Is_NFC_Quick_Check:   maybe}', "");
    Expect(0, 71088, '\p{Is_NFC_Quick_Check:   maybe}', "");
    Expect(1, 71088, '\p{^Is_NFC_Quick_Check:   maybe}', "");
    Expect(1, 71088, '\P{Is_NFC_Quick_Check:   maybe}', "");
    Expect(0, 71088, '\P{^Is_NFC_Quick_Check:   maybe}', "");
    Expect(1, 71087, '\p{Is_NFC_Quick_Check=__MAYBE}', "");
    Expect(0, 71087, '\p{^Is_NFC_Quick_Check=__MAYBE}', "");
    Expect(0, 71087, '\P{Is_NFC_Quick_Check=__MAYBE}', "");
    Expect(1, 71087, '\P{^Is_NFC_Quick_Check=__MAYBE}', "");
    Expect(0, 71088, '\p{Is_NFC_Quick_Check=__MAYBE}', "");
    Expect(1, 71088, '\p{^Is_NFC_Quick_Check=__MAYBE}', "");
    Expect(1, 71088, '\P{Is_NFC_Quick_Check=__MAYBE}', "");
    Expect(0, 71088, '\P{^Is_NFC_Quick_Check=__MAYBE}', "");
    Error('\p{Is_NFC_QC= M/a/}');
    Error('\P{Is_NFC_QC= M/a/}');
    Expect(1, 71087, '\p{Is_NFC_QC=m}', "");
    Expect(0, 71087, '\p{^Is_NFC_QC=m}', "");
    Expect(0, 71087, '\P{Is_NFC_QC=m}', "");
    Expect(1, 71087, '\P{^Is_NFC_QC=m}', "");
    Expect(0, 71088, '\p{Is_NFC_QC=m}', "");
    Expect(1, 71088, '\p{^Is_NFC_QC=m}', "");
    Expect(1, 71088, '\P{Is_NFC_QC=m}', "");
    Expect(0, 71088, '\P{^Is_NFC_QC=m}', "");
    Expect(1, 71087, '\p{Is_NFC_QC=--M}', "");
    Expect(0, 71087, '\p{^Is_NFC_QC=--M}', "");
    Expect(0, 71087, '\P{Is_NFC_QC=--M}', "");
    Expect(1, 71087, '\P{^Is_NFC_QC=--M}', "");
    Expect(0, 71088, '\p{Is_NFC_QC=--M}', "");
    Expect(1, 71088, '\p{^Is_NFC_QC=--M}', "");
    Expect(1, 71088, '\P{Is_NFC_QC=--M}', "");
    Expect(0, 71088, '\P{^Is_NFC_QC=--M}', "");
    Error('\p{NFC_Quick_Check=/a/ -no}');
    Error('\P{NFC_Quick_Check=/a/ -no}');
    Expect(1, 195101, '\p{NFC_Quick_Check=:\ANo\z:}', "");;
    Expect(0, 195102, '\p{NFC_Quick_Check=:\ANo\z:}', "");;
    Expect(1, 195101, '\p{NFC_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^NFC_Quick_Check=no}', "");
    Expect(0, 195101, '\P{NFC_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^NFC_Quick_Check=no}', "");
    Expect(0, 195102, '\p{NFC_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^NFC_Quick_Check=no}', "");
    Expect(1, 195102, '\P{NFC_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^NFC_Quick_Check=no}', "");
    Expect(1, 195101, '\p{NFC_Quick_Check=:\Ano\z:}', "");;
    Expect(0, 195102, '\p{NFC_Quick_Check=:\Ano\z:}', "");;
    Expect(1, 195101, '\p{NFC_Quick_Check=__NO}', "");
    Expect(0, 195101, '\p{^NFC_Quick_Check=__NO}', "");
    Expect(0, 195101, '\P{NFC_Quick_Check=__NO}', "");
    Expect(1, 195101, '\P{^NFC_Quick_Check=__NO}', "");
    Expect(0, 195102, '\p{NFC_Quick_Check=__NO}', "");
    Expect(1, 195102, '\p{^NFC_Quick_Check=__NO}', "");
    Expect(1, 195102, '\P{NFC_Quick_Check=__NO}', "");
    Expect(0, 195102, '\P{^NFC_Quick_Check=__NO}', "");
    Error('\p{NFC_QC=_-N:=}');
    Error('\P{NFC_QC=_-N:=}');
    Expect(1, 195101, '\p{NFC_QC=:\AN\z:}', "");;
    Expect(0, 195102, '\p{NFC_QC=:\AN\z:}', "");;
    Expect(1, 195101, '\p{NFC_QC=n}', "");
    Expect(0, 195101, '\p{^NFC_QC=n}', "");
    Expect(0, 195101, '\P{NFC_QC=n}', "");
    Expect(1, 195101, '\P{^NFC_QC=n}', "");
    Expect(0, 195102, '\p{NFC_QC=n}', "");
    Expect(1, 195102, '\p{^NFC_QC=n}', "");
    Expect(1, 195102, '\P{NFC_QC=n}', "");
    Expect(0, 195102, '\P{^NFC_QC=n}', "");
    Expect(1, 195101, '\p{NFC_QC=:\An\z:}', "");;
    Expect(0, 195102, '\p{NFC_QC=:\An\z:}', "");;
    Expect(1, 195101, '\p{NFC_QC=  n}', "");
    Expect(0, 195101, '\p{^NFC_QC=  n}', "");
    Expect(0, 195101, '\P{NFC_QC=  n}', "");
    Expect(1, 195101, '\P{^NFC_QC=  n}', "");
    Expect(0, 195102, '\p{NFC_QC=  n}', "");
    Expect(1, 195102, '\p{^NFC_QC=  n}', "");
    Expect(1, 195102, '\P{NFC_QC=  n}', "");
    Expect(0, 195102, '\P{^NFC_QC=  n}', "");
    Error('\p{Is_NFC_Quick_Check=:=		NO}');
    Error('\P{Is_NFC_Quick_Check=:=		NO}');
    Expect(1, 195101, '\p{Is_NFC_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^Is_NFC_Quick_Check=no}', "");
    Expect(0, 195101, '\P{Is_NFC_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^Is_NFC_Quick_Check=no}', "");
    Expect(0, 195102, '\p{Is_NFC_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^Is_NFC_Quick_Check=no}', "");
    Expect(1, 195102, '\P{Is_NFC_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^Is_NFC_Quick_Check=no}', "");
    Expect(1, 195101, '\p{Is_NFC_Quick_Check=		no}', "");
    Expect(0, 195101, '\p{^Is_NFC_Quick_Check=		no}', "");
    Expect(0, 195101, '\P{Is_NFC_Quick_Check=		no}', "");
    Expect(1, 195101, '\P{^Is_NFC_Quick_Check=		no}', "");
    Expect(0, 195102, '\p{Is_NFC_Quick_Check=		no}', "");
    Expect(1, 195102, '\p{^Is_NFC_Quick_Check=		no}', "");
    Expect(1, 195102, '\P{Is_NFC_Quick_Check=		no}', "");
    Expect(0, 195102, '\P{^Is_NFC_Quick_Check=		no}', "");
    Error('\p{Is_NFC_QC=:= N}');
    Error('\P{Is_NFC_QC=:= N}');
    Expect(1, 195101, '\p{Is_NFC_QC=n}', "");
    Expect(0, 195101, '\p{^Is_NFC_QC=n}', "");
    Expect(0, 195101, '\P{Is_NFC_QC=n}', "");
    Expect(1, 195101, '\P{^Is_NFC_QC=n}', "");
    Expect(0, 195102, '\p{Is_NFC_QC=n}', "");
    Expect(1, 195102, '\p{^Is_NFC_QC=n}', "");
    Expect(1, 195102, '\P{Is_NFC_QC=n}', "");
    Expect(0, 195102, '\P{^Is_NFC_QC=n}', "");
    Expect(1, 195101, '\p{Is_NFC_QC= -N}', "");
    Expect(0, 195101, '\p{^Is_NFC_QC= -N}', "");
    Expect(0, 195101, '\P{Is_NFC_QC= -N}', "");
    Expect(1, 195101, '\P{^Is_NFC_QC= -N}', "");
    Expect(0, 195102, '\p{Is_NFC_QC= -N}', "");
    Expect(1, 195102, '\p{^Is_NFC_QC= -N}', "");
    Expect(1, 195102, '\P{Is_NFC_QC= -N}', "");
    Expect(0, 195102, '\P{^Is_NFC_QC= -N}', "");
    Error('\p{NFC_Quick_Check=-YES:=}');
    Error('\P{NFC_Quick_Check=-YES:=}');
    Expect(1, 195102, '\p{NFC_Quick_Check=:\AYes\z:}', "");;
    Expect(0, 195101, '\p{NFC_Quick_Check=:\AYes\z:}', "");;
    Expect(1, 195102, '\p{NFC_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^NFC_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{NFC_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^NFC_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{NFC_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^NFC_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{NFC_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^NFC_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{NFC_Quick_Check=:\Ayes\z:}', "");;
    Expect(0, 195101, '\p{NFC_Quick_Check=:\Ayes\z:}', "");;
    Expect(1, 195102, '\p{NFC_Quick_Check=-	Yes}', "");
    Expect(0, 195102, '\p{^NFC_Quick_Check=-	Yes}', "");
    Expect(0, 195102, '\P{NFC_Quick_Check=-	Yes}', "");
    Expect(1, 195102, '\P{^NFC_Quick_Check=-	Yes}', "");
    Expect(0, 195101, '\p{NFC_Quick_Check=-	Yes}', "");
    Expect(1, 195101, '\p{^NFC_Quick_Check=-	Yes}', "");
    Expect(1, 195101, '\P{NFC_Quick_Check=-	Yes}', "");
    Expect(0, 195101, '\P{^NFC_Quick_Check=-	Yes}', "");
    Error('\p{NFC_QC:   _y/a/}');
    Error('\P{NFC_QC:   _y/a/}');
    Expect(1, 195102, '\p{NFC_QC=:\AY\z:}', "");;
    Expect(0, 195101, '\p{NFC_QC=:\AY\z:}', "");;
    Expect(1, 195102, '\p{NFC_QC=y}', "");
    Expect(0, 195102, '\p{^NFC_QC=y}', "");
    Expect(0, 195102, '\P{NFC_QC=y}', "");
    Expect(1, 195102, '\P{^NFC_QC=y}', "");
    Expect(0, 195101, '\p{NFC_QC=y}', "");
    Expect(1, 195101, '\p{^NFC_QC=y}', "");
    Expect(1, 195101, '\P{NFC_QC=y}', "");
    Expect(0, 195101, '\P{^NFC_QC=y}', "");
    Expect(1, 195102, '\p{NFC_QC=:\Ay\z:}', "");;
    Expect(0, 195101, '\p{NFC_QC=:\Ay\z:}', "");;
    Expect(1, 195102, '\p{NFC_QC= 	Y}', "");
    Expect(0, 195102, '\p{^NFC_QC= 	Y}', "");
    Expect(0, 195102, '\P{NFC_QC= 	Y}', "");
    Expect(1, 195102, '\P{^NFC_QC= 	Y}', "");
    Expect(0, 195101, '\p{NFC_QC= 	Y}', "");
    Expect(1, 195101, '\p{^NFC_QC= 	Y}', "");
    Expect(1, 195101, '\P{NFC_QC= 	Y}', "");
    Expect(0, 195101, '\P{^NFC_QC= 	Y}', "");
    Error('\p{Is_NFC_Quick_Check:/a/ yes}');
    Error('\P{Is_NFC_Quick_Check:/a/ yes}');
    Expect(1, 195102, '\p{Is_NFC_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^Is_NFC_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{Is_NFC_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^Is_NFC_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{Is_NFC_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^Is_NFC_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{Is_NFC_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^Is_NFC_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{Is_NFC_Quick_Check=	yes}', "");
    Expect(0, 195102, '\p{^Is_NFC_Quick_Check=	yes}', "");
    Expect(0, 195102, '\P{Is_NFC_Quick_Check=	yes}', "");
    Expect(1, 195102, '\P{^Is_NFC_Quick_Check=	yes}', "");
    Expect(0, 195101, '\p{Is_NFC_Quick_Check=	yes}', "");
    Expect(1, 195101, '\p{^Is_NFC_Quick_Check=	yes}', "");
    Expect(1, 195101, '\P{Is_NFC_Quick_Check=	yes}', "");
    Expect(0, 195101, '\P{^Is_NFC_Quick_Check=	yes}', "");
    Error('\p{Is_NFC_QC=	Y:=}');
    Error('\P{Is_NFC_QC=	Y:=}');
    Expect(1, 195102, '\p{Is_NFC_QC=y}', "");
    Expect(0, 195102, '\p{^Is_NFC_QC=y}', "");
    Expect(0, 195102, '\P{Is_NFC_QC=y}', "");
    Expect(1, 195102, '\P{^Is_NFC_QC=y}', "");
    Expect(0, 195101, '\p{Is_NFC_QC=y}', "");
    Expect(1, 195101, '\p{^Is_NFC_QC=y}', "");
    Expect(1, 195101, '\P{Is_NFC_QC=y}', "");
    Expect(0, 195101, '\P{^Is_NFC_QC=y}', "");
    Expect(1, 195102, '\p{Is_NFC_QC=		Y}', "");
    Expect(0, 195102, '\p{^Is_NFC_QC=		Y}', "");
    Expect(0, 195102, '\P{Is_NFC_QC=		Y}', "");
    Expect(1, 195102, '\P{^Is_NFC_QC=		Y}', "");
    Expect(0, 195101, '\p{Is_NFC_QC=		Y}', "");
    Expect(1, 195101, '\p{^Is_NFC_QC=		Y}', "");
    Expect(1, 195101, '\P{Is_NFC_QC=		Y}', "");
    Expect(0, 195101, '\P{^Is_NFC_QC=		Y}', "");
    Error('\p{nfdquickcheck}');
    Error('\P{nfdquickcheck}');
    Error('\p{nfdqc}');
    Error('\P{nfdqc}');
    Error('\p{NFD_Quick_Check=:=_	No}');
    Error('\P{NFD_Quick_Check=:=_	No}');
    Expect(1, 195101, '\p{NFD_Quick_Check=:\ANo\z:}', "");;
    Expect(0, 195102, '\p{NFD_Quick_Check=:\ANo\z:}', "");;
    Expect(1, 195101, '\p{NFD_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^NFD_Quick_Check=no}', "");
    Expect(0, 195101, '\P{NFD_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^NFD_Quick_Check=no}', "");
    Expect(0, 195102, '\p{NFD_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^NFD_Quick_Check=no}', "");
    Expect(1, 195102, '\P{NFD_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^NFD_Quick_Check=no}', "");
    Expect(1, 195101, '\p{NFD_Quick_Check=:\Ano\z:}', "");;
    Expect(0, 195102, '\p{NFD_Quick_Check=:\Ano\z:}', "");;
    Expect(1, 195101, '\p{NFD_Quick_Check=		No}', "");
    Expect(0, 195101, '\p{^NFD_Quick_Check=		No}', "");
    Expect(0, 195101, '\P{NFD_Quick_Check=		No}', "");
    Expect(1, 195101, '\P{^NFD_Quick_Check=		No}', "");
    Expect(0, 195102, '\p{NFD_Quick_Check=		No}', "");
    Expect(1, 195102, '\p{^NFD_Quick_Check=		No}', "");
    Expect(1, 195102, '\P{NFD_Quick_Check=		No}', "");
    Expect(0, 195102, '\P{^NFD_Quick_Check=		No}', "");
    Error('\p{NFD_QC=/a/	 N}');
    Error('\P{NFD_QC=/a/	 N}');
    Expect(1, 195101, '\p{NFD_QC=:\AN\z:}', "");;
    Expect(0, 195102, '\p{NFD_QC=:\AN\z:}', "");;
    Expect(1, 195101, '\p{NFD_QC=n}', "");
    Expect(0, 195101, '\p{^NFD_QC=n}', "");
    Expect(0, 195101, '\P{NFD_QC=n}', "");
    Expect(1, 195101, '\P{^NFD_QC=n}', "");
    Expect(0, 195102, '\p{NFD_QC=n}', "");
    Expect(1, 195102, '\p{^NFD_QC=n}', "");
    Expect(1, 195102, '\P{NFD_QC=n}', "");
    Expect(0, 195102, '\P{^NFD_QC=n}', "");
    Expect(1, 195101, '\p{NFD_QC=:\An\z:}', "");;
    Expect(0, 195102, '\p{NFD_QC=:\An\z:}', "");;
    Expect(1, 195101, '\p{NFD_QC:   -_N}', "");
    Expect(0, 195101, '\p{^NFD_QC:   -_N}', "");
    Expect(0, 195101, '\P{NFD_QC:   -_N}', "");
    Expect(1, 195101, '\P{^NFD_QC:   -_N}', "");
    Expect(0, 195102, '\p{NFD_QC:   -_N}', "");
    Expect(1, 195102, '\p{^NFD_QC:   -_N}', "");
    Expect(1, 195102, '\P{NFD_QC:   -_N}', "");
    Expect(0, 195102, '\P{^NFD_QC:   -_N}', "");
    Error('\p{Is_NFD_Quick_Check:_:=No}');
    Error('\P{Is_NFD_Quick_Check:_:=No}');
    Expect(1, 195101, '\p{Is_NFD_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^Is_NFD_Quick_Check=no}', "");
    Expect(0, 195101, '\P{Is_NFD_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^Is_NFD_Quick_Check=no}', "");
    Expect(0, 195102, '\p{Is_NFD_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^Is_NFD_Quick_Check=no}', "");
    Expect(1, 195102, '\P{Is_NFD_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^Is_NFD_Quick_Check=no}', "");
    Expect(1, 195101, '\p{Is_NFD_Quick_Check=	No}', "");
    Expect(0, 195101, '\p{^Is_NFD_Quick_Check=	No}', "");
    Expect(0, 195101, '\P{Is_NFD_Quick_Check=	No}', "");
    Expect(1, 195101, '\P{^Is_NFD_Quick_Check=	No}', "");
    Expect(0, 195102, '\p{Is_NFD_Quick_Check=	No}', "");
    Expect(1, 195102, '\p{^Is_NFD_Quick_Check=	No}', "");
    Expect(1, 195102, '\P{Is_NFD_Quick_Check=	No}', "");
    Expect(0, 195102, '\P{^Is_NFD_Quick_Check=	No}', "");
    Error('\p{Is_NFD_QC= n:=}');
    Error('\P{Is_NFD_QC= n:=}');
    Expect(1, 195101, '\p{Is_NFD_QC=n}', "");
    Expect(0, 195101, '\p{^Is_NFD_QC=n}', "");
    Expect(0, 195101, '\P{Is_NFD_QC=n}', "");
    Expect(1, 195101, '\P{^Is_NFD_QC=n}', "");
    Expect(0, 195102, '\p{Is_NFD_QC=n}', "");
    Expect(1, 195102, '\p{^Is_NFD_QC=n}', "");
    Expect(1, 195102, '\P{Is_NFD_QC=n}', "");
    Expect(0, 195102, '\P{^Is_NFD_QC=n}', "");
    Expect(1, 195101, '\p{Is_NFD_QC=--N}', "");
    Expect(0, 195101, '\p{^Is_NFD_QC=--N}', "");
    Expect(0, 195101, '\P{Is_NFD_QC=--N}', "");
    Expect(1, 195101, '\P{^Is_NFD_QC=--N}', "");
    Expect(0, 195102, '\p{Is_NFD_QC=--N}', "");
    Expect(1, 195102, '\p{^Is_NFD_QC=--N}', "");
    Expect(1, 195102, '\P{Is_NFD_QC=--N}', "");
    Expect(0, 195102, '\P{^Is_NFD_QC=--N}', "");
    Error('\p{NFD_Quick_Check=__Yes/a/}');
    Error('\P{NFD_Quick_Check=__Yes/a/}');
    Expect(1, 195102, '\p{NFD_Quick_Check=:\AYes\z:}', "");;
    Expect(0, 195101, '\p{NFD_Quick_Check=:\AYes\z:}', "");;
    Expect(1, 195102, '\p{NFD_Quick_Check: yes}', "");
    Expect(0, 195102, '\p{^NFD_Quick_Check: yes}', "");
    Expect(0, 195102, '\P{NFD_Quick_Check: yes}', "");
    Expect(1, 195102, '\P{^NFD_Quick_Check: yes}', "");
    Expect(0, 195101, '\p{NFD_Quick_Check: yes}', "");
    Expect(1, 195101, '\p{^NFD_Quick_Check: yes}', "");
    Expect(1, 195101, '\P{NFD_Quick_Check: yes}', "");
    Expect(0, 195101, '\P{^NFD_Quick_Check: yes}', "");
    Expect(1, 195102, '\p{NFD_Quick_Check=:\Ayes\z:}', "");;
    Expect(0, 195101, '\p{NFD_Quick_Check=:\Ayes\z:}', "");;
    Expect(1, 195102, '\p{NFD_Quick_Check=-	Yes}', "");
    Expect(0, 195102, '\p{^NFD_Quick_Check=-	Yes}', "");
    Expect(0, 195102, '\P{NFD_Quick_Check=-	Yes}', "");
    Expect(1, 195102, '\P{^NFD_Quick_Check=-	Yes}', "");
    Expect(0, 195101, '\p{NFD_Quick_Check=-	Yes}', "");
    Expect(1, 195101, '\p{^NFD_Quick_Check=-	Yes}', "");
    Expect(1, 195101, '\P{NFD_Quick_Check=-	Yes}', "");
    Expect(0, 195101, '\P{^NFD_Quick_Check=-	Yes}', "");
    Error('\p{NFD_QC=:=Y}');
    Error('\P{NFD_QC=:=Y}');
    Expect(1, 195102, '\p{NFD_QC=:\AY\z:}', "");;
    Expect(0, 195101, '\p{NFD_QC=:\AY\z:}', "");;
    Expect(1, 195102, '\p{NFD_QC=y}', "");
    Expect(0, 195102, '\p{^NFD_QC=y}', "");
    Expect(0, 195102, '\P{NFD_QC=y}', "");
    Expect(1, 195102, '\P{^NFD_QC=y}', "");
    Expect(0, 195101, '\p{NFD_QC=y}', "");
    Expect(1, 195101, '\p{^NFD_QC=y}', "");
    Expect(1, 195101, '\P{NFD_QC=y}', "");
    Expect(0, 195101, '\P{^NFD_QC=y}', "");
    Expect(1, 195102, '\p{NFD_QC=:\Ay\z:}', "");;
    Expect(0, 195101, '\p{NFD_QC=:\Ay\z:}', "");;
    Expect(1, 195102, '\p{NFD_QC=_	y}', "");
    Expect(0, 195102, '\p{^NFD_QC=_	y}', "");
    Expect(0, 195102, '\P{NFD_QC=_	y}', "");
    Expect(1, 195102, '\P{^NFD_QC=_	y}', "");
    Expect(0, 195101, '\p{NFD_QC=_	y}', "");
    Expect(1, 195101, '\p{^NFD_QC=_	y}', "");
    Expect(1, 195101, '\P{NFD_QC=_	y}', "");
    Expect(0, 195101, '\P{^NFD_QC=_	y}', "");
    Error('\p{Is_NFD_Quick_Check=	/a/Yes}');
    Error('\P{Is_NFD_Quick_Check=	/a/Yes}');
    Expect(1, 195102, '\p{Is_NFD_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^Is_NFD_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{Is_NFD_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^Is_NFD_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{Is_NFD_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^Is_NFD_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{Is_NFD_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^Is_NFD_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{Is_NFD_Quick_Check=-	Yes}', "");
    Expect(0, 195102, '\p{^Is_NFD_Quick_Check=-	Yes}', "");
    Expect(0, 195102, '\P{Is_NFD_Quick_Check=-	Yes}', "");
    Expect(1, 195102, '\P{^Is_NFD_Quick_Check=-	Yes}', "");
    Expect(0, 195101, '\p{Is_NFD_Quick_Check=-	Yes}', "");
    Expect(1, 195101, '\p{^Is_NFD_Quick_Check=-	Yes}', "");
    Expect(1, 195101, '\P{Is_NFD_Quick_Check=-	Yes}', "");
    Expect(0, 195101, '\P{^Is_NFD_Quick_Check=-	Yes}', "");
    Error('\p{Is_NFD_QC=:=y}');
    Error('\P{Is_NFD_QC=:=y}');
    Expect(1, 195102, '\p{Is_NFD_QC=y}', "");
    Expect(0, 195102, '\p{^Is_NFD_QC=y}', "");
    Expect(0, 195102, '\P{Is_NFD_QC=y}', "");
    Expect(1, 195102, '\P{^Is_NFD_QC=y}', "");
    Expect(0, 195101, '\p{Is_NFD_QC=y}', "");
    Expect(1, 195101, '\p{^Is_NFD_QC=y}', "");
    Expect(1, 195101, '\P{Is_NFD_QC=y}', "");
    Expect(0, 195101, '\P{^Is_NFD_QC=y}', "");
    Expect(1, 195102, '\p{Is_NFD_QC=Y}', "");
    Expect(0, 195102, '\p{^Is_NFD_QC=Y}', "");
    Expect(0, 195102, '\P{Is_NFD_QC=Y}', "");
    Expect(1, 195102, '\P{^Is_NFD_QC=Y}', "");
    Expect(0, 195101, '\p{Is_NFD_QC=Y}', "");
    Expect(1, 195101, '\p{^Is_NFD_QC=Y}', "");
    Expect(1, 195101, '\P{Is_NFD_QC=Y}', "");
    Expect(0, 195101, '\P{^Is_NFD_QC=Y}', "");
    Error('\p{nfkccasefold}');
    Error('\P{nfkccasefold}');
    Error('\p{nfkccf}');
    Error('\P{nfkccf}');
    Error('\p{nfkcquickcheck}');
    Error('\P{nfkcquickcheck}');
    Error('\p{nfkcqc}');
    Error('\P{nfkcqc}');
    Error('\p{NFKC_Quick_Check= maybe/a/}');
    Error('\P{NFKC_Quick_Check= maybe/a/}');
    Expect(1, 71087, '\p{NFKC_Quick_Check=:\AMaybe\z:}', "");;
    Expect(0, 71088, '\p{NFKC_Quick_Check=:\AMaybe\z:}', "");;
    Expect(1, 71087, '\p{NFKC_Quick_Check=maybe}', "");
    Expect(0, 71087, '\p{^NFKC_Quick_Check=maybe}', "");
    Expect(0, 71087, '\P{NFKC_Quick_Check=maybe}', "");
    Expect(1, 71087, '\P{^NFKC_Quick_Check=maybe}', "");
    Expect(0, 71088, '\p{NFKC_Quick_Check=maybe}', "");
    Expect(1, 71088, '\p{^NFKC_Quick_Check=maybe}', "");
    Expect(1, 71088, '\P{NFKC_Quick_Check=maybe}', "");
    Expect(0, 71088, '\P{^NFKC_Quick_Check=maybe}', "");
    Expect(1, 71087, '\p{NFKC_Quick_Check=:\Amaybe\z:}', "");;
    Expect(0, 71088, '\p{NFKC_Quick_Check=:\Amaybe\z:}', "");;
    Expect(1, 71087, '\p{NFKC_Quick_Check:   		maybe}', "");
    Expect(0, 71087, '\p{^NFKC_Quick_Check:   		maybe}', "");
    Expect(0, 71087, '\P{NFKC_Quick_Check:   		maybe}', "");
    Expect(1, 71087, '\P{^NFKC_Quick_Check:   		maybe}', "");
    Expect(0, 71088, '\p{NFKC_Quick_Check:   		maybe}', "");
    Expect(1, 71088, '\p{^NFKC_Quick_Check:   		maybe}', "");
    Expect(1, 71088, '\P{NFKC_Quick_Check:   		maybe}', "");
    Expect(0, 71088, '\P{^NFKC_Quick_Check:   		maybe}', "");
    Error('\p{NFKC_QC=/a/		M}');
    Error('\P{NFKC_QC=/a/		M}');
    Expect(1, 71087, '\p{NFKC_QC=:\AM\z:}', "");;
    Expect(0, 71088, '\p{NFKC_QC=:\AM\z:}', "");;
    Expect(1, 71087, '\p{NFKC_QC=m}', "");
    Expect(0, 71087, '\p{^NFKC_QC=m}', "");
    Expect(0, 71087, '\P{NFKC_QC=m}', "");
    Expect(1, 71087, '\P{^NFKC_QC=m}', "");
    Expect(0, 71088, '\p{NFKC_QC=m}', "");
    Expect(1, 71088, '\p{^NFKC_QC=m}', "");
    Expect(1, 71088, '\P{NFKC_QC=m}', "");
    Expect(0, 71088, '\P{^NFKC_QC=m}', "");
    Expect(1, 71087, '\p{NFKC_QC=:\Am\z:}', "");;
    Expect(0, 71088, '\p{NFKC_QC=:\Am\z:}', "");;
    Expect(1, 71087, '\p{NFKC_QC=--M}', "");
    Expect(0, 71087, '\p{^NFKC_QC=--M}', "");
    Expect(0, 71087, '\P{NFKC_QC=--M}', "");
    Expect(1, 71087, '\P{^NFKC_QC=--M}', "");
    Expect(0, 71088, '\p{NFKC_QC=--M}', "");
    Expect(1, 71088, '\p{^NFKC_QC=--M}', "");
    Expect(1, 71088, '\P{NFKC_QC=--M}', "");
    Expect(0, 71088, '\P{^NFKC_QC=--M}', "");
    Error('\p{Is_NFKC_Quick_Check=:=- maybe}');
    Error('\P{Is_NFKC_Quick_Check=:=- maybe}');
    Expect(1, 71087, '\p{Is_NFKC_Quick_Check=maybe}', "");
    Expect(0, 71087, '\p{^Is_NFKC_Quick_Check=maybe}', "");
    Expect(0, 71087, '\P{Is_NFKC_Quick_Check=maybe}', "");
    Expect(1, 71087, '\P{^Is_NFKC_Quick_Check=maybe}', "");
    Expect(0, 71088, '\p{Is_NFKC_Quick_Check=maybe}', "");
    Expect(1, 71088, '\p{^Is_NFKC_Quick_Check=maybe}', "");
    Expect(1, 71088, '\P{Is_NFKC_Quick_Check=maybe}', "");
    Expect(0, 71088, '\P{^Is_NFKC_Quick_Check=maybe}', "");
    Expect(1, 71087, '\p{Is_NFKC_Quick_Check:  maybe}', "");
    Expect(0, 71087, '\p{^Is_NFKC_Quick_Check:  maybe}', "");
    Expect(0, 71087, '\P{Is_NFKC_Quick_Check:  maybe}', "");
    Expect(1, 71087, '\P{^Is_NFKC_Quick_Check:  maybe}', "");
    Expect(0, 71088, '\p{Is_NFKC_Quick_Check:  maybe}', "");
    Expect(1, 71088, '\p{^Is_NFKC_Quick_Check:  maybe}', "");
    Expect(1, 71088, '\P{Is_NFKC_Quick_Check:  maybe}', "");
    Expect(0, 71088, '\P{^Is_NFKC_Quick_Check:  maybe}', "");
    Error('\p{Is_NFKC_QC=_M/a/}');
    Error('\P{Is_NFKC_QC=_M/a/}');
    Expect(1, 71087, '\p{Is_NFKC_QC=m}', "");
    Expect(0, 71087, '\p{^Is_NFKC_QC=m}', "");
    Expect(0, 71087, '\P{Is_NFKC_QC=m}', "");
    Expect(1, 71087, '\P{^Is_NFKC_QC=m}', "");
    Expect(0, 71088, '\p{Is_NFKC_QC=m}', "");
    Expect(1, 71088, '\p{^Is_NFKC_QC=m}', "");
    Expect(1, 71088, '\P{Is_NFKC_QC=m}', "");
    Expect(0, 71088, '\P{^Is_NFKC_QC=m}', "");
    Expect(1, 71087, '\p{Is_NFKC_QC=  m}', "");
    Expect(0, 71087, '\p{^Is_NFKC_QC=  m}', "");
    Expect(0, 71087, '\P{Is_NFKC_QC=  m}', "");
    Expect(1, 71087, '\P{^Is_NFKC_QC=  m}', "");
    Expect(0, 71088, '\p{Is_NFKC_QC=  m}', "");
    Expect(1, 71088, '\p{^Is_NFKC_QC=  m}', "");
    Expect(1, 71088, '\P{Is_NFKC_QC=  m}', "");
    Expect(0, 71088, '\P{^Is_NFKC_QC=  m}', "");
    Error('\p{NFKC_Quick_Check=	No/a/}');
    Error('\P{NFKC_Quick_Check=	No/a/}');
    Expect(1, 195101, '\p{NFKC_Quick_Check=:\ANo\z:}', "");;
    Expect(0, 195102, '\p{NFKC_Quick_Check=:\ANo\z:}', "");;
    Expect(1, 195101, '\p{NFKC_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^NFKC_Quick_Check=no}', "");
    Expect(0, 195101, '\P{NFKC_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^NFKC_Quick_Check=no}', "");
    Expect(0, 195102, '\p{NFKC_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^NFKC_Quick_Check=no}', "");
    Expect(1, 195102, '\P{NFKC_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^NFKC_Quick_Check=no}', "");
    Expect(1, 195101, '\p{NFKC_Quick_Check=:\Ano\z:}', "");;
    Expect(0, 195102, '\p{NFKC_Quick_Check=:\Ano\z:}', "");;
    Expect(1, 195101, '\p{NFKC_Quick_Check=_	NO}', "");
    Expect(0, 195101, '\p{^NFKC_Quick_Check=_	NO}', "");
    Expect(0, 195101, '\P{NFKC_Quick_Check=_	NO}', "");
    Expect(1, 195101, '\P{^NFKC_Quick_Check=_	NO}', "");
    Expect(0, 195102, '\p{NFKC_Quick_Check=_	NO}', "");
    Expect(1, 195102, '\p{^NFKC_Quick_Check=_	NO}', "");
    Expect(1, 195102, '\P{NFKC_Quick_Check=_	NO}', "");
    Expect(0, 195102, '\P{^NFKC_Quick_Check=_	NO}', "");
    Error('\p{NFKC_QC= /a/N}');
    Error('\P{NFKC_QC= /a/N}');
    Expect(1, 195101, '\p{NFKC_QC=:\AN\z:}', "");;
    Expect(0, 195102, '\p{NFKC_QC=:\AN\z:}', "");;
    Expect(1, 195101, '\p{NFKC_QC=n}', "");
    Expect(0, 195101, '\p{^NFKC_QC=n}', "");
    Expect(0, 195101, '\P{NFKC_QC=n}', "");
    Expect(1, 195101, '\P{^NFKC_QC=n}', "");
    Expect(0, 195102, '\p{NFKC_QC=n}', "");
    Expect(1, 195102, '\p{^NFKC_QC=n}', "");
    Expect(1, 195102, '\P{NFKC_QC=n}', "");
    Expect(0, 195102, '\P{^NFKC_QC=n}', "");
    Expect(1, 195101, '\p{NFKC_QC=:\An\z:}', "");;
    Expect(0, 195102, '\p{NFKC_QC=:\An\z:}', "");;
    Expect(1, 195101, '\p{NFKC_QC= N}', "");
    Expect(0, 195101, '\p{^NFKC_QC= N}', "");
    Expect(0, 195101, '\P{NFKC_QC= N}', "");
    Expect(1, 195101, '\P{^NFKC_QC= N}', "");
    Expect(0, 195102, '\p{NFKC_QC= N}', "");
    Expect(1, 195102, '\p{^NFKC_QC= N}', "");
    Expect(1, 195102, '\P{NFKC_QC= N}', "");
    Expect(0, 195102, '\P{^NFKC_QC= N}', "");
    Error('\p{Is_NFKC_Quick_Check=:=-NO}');
    Error('\P{Is_NFKC_Quick_Check=:=-NO}');
    Expect(1, 195101, '\p{Is_NFKC_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^Is_NFKC_Quick_Check=no}', "");
    Expect(0, 195101, '\P{Is_NFKC_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^Is_NFKC_Quick_Check=no}', "");
    Expect(0, 195102, '\p{Is_NFKC_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^Is_NFKC_Quick_Check=no}', "");
    Expect(1, 195102, '\P{Is_NFKC_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^Is_NFKC_Quick_Check=no}', "");
    Expect(1, 195101, '\p{Is_NFKC_Quick_Check= no}', "");
    Expect(0, 195101, '\p{^Is_NFKC_Quick_Check= no}', "");
    Expect(0, 195101, '\P{Is_NFKC_Quick_Check= no}', "");
    Expect(1, 195101, '\P{^Is_NFKC_Quick_Check= no}', "");
    Expect(0, 195102, '\p{Is_NFKC_Quick_Check= no}', "");
    Expect(1, 195102, '\p{^Is_NFKC_Quick_Check= no}', "");
    Expect(1, 195102, '\P{Is_NFKC_Quick_Check= no}', "");
    Expect(0, 195102, '\P{^Is_NFKC_Quick_Check= no}', "");
    Error('\p{Is_NFKC_QC=-/a/N}');
    Error('\P{Is_NFKC_QC=-/a/N}');
    Expect(1, 195101, '\p{Is_NFKC_QC=n}', "");
    Expect(0, 195101, '\p{^Is_NFKC_QC=n}', "");
    Expect(0, 195101, '\P{Is_NFKC_QC=n}', "");
    Expect(1, 195101, '\P{^Is_NFKC_QC=n}', "");
    Expect(0, 195102, '\p{Is_NFKC_QC=n}', "");
    Expect(1, 195102, '\p{^Is_NFKC_QC=n}', "");
    Expect(1, 195102, '\P{Is_NFKC_QC=n}', "");
    Expect(0, 195102, '\P{^Is_NFKC_QC=n}', "");
    Error('\p{NFKC_Quick_Check:	_YES:=}');
    Error('\P{NFKC_Quick_Check:	_YES:=}');
    Expect(1, 195102, '\p{NFKC_Quick_Check=:\AYes\z:}', "");;
    Expect(0, 195101, '\p{NFKC_Quick_Check=:\AYes\z:}', "");;
    Expect(1, 195102, '\p{NFKC_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^NFKC_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{NFKC_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^NFKC_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{NFKC_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^NFKC_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{NFKC_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^NFKC_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{NFKC_Quick_Check=:\Ayes\z:}', "");;
    Expect(0, 195101, '\p{NFKC_Quick_Check=:\Ayes\z:}', "");;
    Expect(1, 195102, '\p{NFKC_Quick_Check=  YES}', "");
    Expect(0, 195102, '\p{^NFKC_Quick_Check=  YES}', "");
    Expect(0, 195102, '\P{NFKC_Quick_Check=  YES}', "");
    Expect(1, 195102, '\P{^NFKC_Quick_Check=  YES}', "");
    Expect(0, 195101, '\p{NFKC_Quick_Check=  YES}', "");
    Expect(1, 195101, '\p{^NFKC_Quick_Check=  YES}', "");
    Expect(1, 195101, '\P{NFKC_Quick_Check=  YES}', "");
    Expect(0, 195101, '\P{^NFKC_Quick_Check=  YES}', "");
    Error('\p{NFKC_QC=/a/ Y}');
    Error('\P{NFKC_QC=/a/ Y}');
    Expect(1, 195102, '\p{NFKC_QC=:\AY\z:}', "");;
    Expect(0, 195101, '\p{NFKC_QC=:\AY\z:}', "");;
    Expect(1, 195102, '\p{NFKC_QC=y}', "");
    Expect(0, 195102, '\p{^NFKC_QC=y}', "");
    Expect(0, 195102, '\P{NFKC_QC=y}', "");
    Expect(1, 195102, '\P{^NFKC_QC=y}', "");
    Expect(0, 195101, '\p{NFKC_QC=y}', "");
    Expect(1, 195101, '\p{^NFKC_QC=y}', "");
    Expect(1, 195101, '\P{NFKC_QC=y}', "");
    Expect(0, 195101, '\P{^NFKC_QC=y}', "");
    Expect(1, 195102, '\p{NFKC_QC=:\Ay\z:}', "");;
    Expect(0, 195101, '\p{NFKC_QC=:\Ay\z:}', "");;
    Expect(1, 195102, '\p{NFKC_QC=	 Y}', "");
    Expect(0, 195102, '\p{^NFKC_QC=	 Y}', "");
    Expect(0, 195102, '\P{NFKC_QC=	 Y}', "");
    Expect(1, 195102, '\P{^NFKC_QC=	 Y}', "");
    Expect(0, 195101, '\p{NFKC_QC=	 Y}', "");
    Expect(1, 195101, '\p{^NFKC_QC=	 Y}', "");
    Expect(1, 195101, '\P{NFKC_QC=	 Y}', "");
    Expect(0, 195101, '\P{^NFKC_QC=	 Y}', "");
    Error('\p{Is_NFKC_Quick_Check=		YES/a/}');
    Error('\P{Is_NFKC_Quick_Check=		YES/a/}');
    Expect(1, 195102, '\p{Is_NFKC_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^Is_NFKC_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{Is_NFKC_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^Is_NFKC_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{Is_NFKC_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^Is_NFKC_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{Is_NFKC_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^Is_NFKC_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{Is_NFKC_Quick_Check:   YES}', "");
    Expect(0, 195102, '\p{^Is_NFKC_Quick_Check:   YES}', "");
    Expect(0, 195102, '\P{Is_NFKC_Quick_Check:   YES}', "");
    Expect(1, 195102, '\P{^Is_NFKC_Quick_Check:   YES}', "");
    Expect(0, 195101, '\p{Is_NFKC_Quick_Check:   YES}', "");
    Expect(1, 195101, '\p{^Is_NFKC_Quick_Check:   YES}', "");
    Expect(1, 195101, '\P{Is_NFKC_Quick_Check:   YES}', "");
    Expect(0, 195101, '\P{^Is_NFKC_Quick_Check:   YES}', "");
    Error('\p{Is_NFKC_QC=/a/- Y}');
    Error('\P{Is_NFKC_QC=/a/- Y}');
    Expect(1, 195102, '\p{Is_NFKC_QC:   y}', "");
    Expect(0, 195102, '\p{^Is_NFKC_QC:   y}', "");
    Expect(0, 195102, '\P{Is_NFKC_QC:   y}', "");
    Expect(1, 195102, '\P{^Is_NFKC_QC:   y}', "");
    Expect(0, 195101, '\p{Is_NFKC_QC:   y}', "");
    Expect(1, 195101, '\p{^Is_NFKC_QC:   y}', "");
    Expect(1, 195101, '\P{Is_NFKC_QC:   y}', "");
    Expect(0, 195101, '\P{^Is_NFKC_QC:   y}', "");
    Expect(1, 195102, '\p{Is_NFKC_QC:   Y}', "");
    Expect(0, 195102, '\p{^Is_NFKC_QC:   Y}', "");
    Expect(0, 195102, '\P{Is_NFKC_QC:   Y}', "");
    Expect(1, 195102, '\P{^Is_NFKC_QC:   Y}', "");
    Expect(0, 195101, '\p{Is_NFKC_QC:   Y}', "");
    Expect(1, 195101, '\p{^Is_NFKC_QC:   Y}', "");
    Expect(1, 195101, '\P{Is_NFKC_QC:   Y}', "");
    Expect(0, 195101, '\P{^Is_NFKC_QC:   Y}', "");
    Error('\p{nfkdquickcheck}');
    Error('\P{nfkdquickcheck}');
    Error('\p{nfkdqc}');
    Error('\P{nfkdqc}');
    Error('\p{NFKD_Quick_Check=/a/  no}');
    Error('\P{NFKD_Quick_Check=/a/  no}');
    Expect(1, 195101, '\p{NFKD_Quick_Check=:\ANo\z:}', "");;
    Expect(0, 195102, '\p{NFKD_Quick_Check=:\ANo\z:}', "");;
    Expect(1, 195101, '\p{NFKD_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^NFKD_Quick_Check=no}', "");
    Expect(0, 195101, '\P{NFKD_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^NFKD_Quick_Check=no}', "");
    Expect(0, 195102, '\p{NFKD_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^NFKD_Quick_Check=no}', "");
    Expect(1, 195102, '\P{NFKD_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^NFKD_Quick_Check=no}', "");
    Expect(1, 195101, '\p{NFKD_Quick_Check=:\Ano\z:}', "");;
    Expect(0, 195102, '\p{NFKD_Quick_Check=:\Ano\z:}', "");;
    Expect(1, 195101, '\p{NFKD_Quick_Check:   		No}', "");
    Expect(0, 195101, '\p{^NFKD_Quick_Check:   		No}', "");
    Expect(0, 195101, '\P{NFKD_Quick_Check:   		No}', "");
    Expect(1, 195101, '\P{^NFKD_Quick_Check:   		No}', "");
    Expect(0, 195102, '\p{NFKD_Quick_Check:   		No}', "");
    Expect(1, 195102, '\p{^NFKD_Quick_Check:   		No}', "");
    Expect(1, 195102, '\P{NFKD_Quick_Check:   		No}', "");
    Expect(0, 195102, '\P{^NFKD_Quick_Check:   		No}', "");
    Error('\p{NFKD_QC:		-N/a/}');
    Error('\P{NFKD_QC:		-N/a/}');
    Expect(1, 195101, '\p{NFKD_QC=:\AN\z:}', "");;
    Expect(0, 195102, '\p{NFKD_QC=:\AN\z:}', "");;
    Expect(1, 195101, '\p{NFKD_QC=n}', "");
    Expect(0, 195101, '\p{^NFKD_QC=n}', "");
    Expect(0, 195101, '\P{NFKD_QC=n}', "");
    Expect(1, 195101, '\P{^NFKD_QC=n}', "");
    Expect(0, 195102, '\p{NFKD_QC=n}', "");
    Expect(1, 195102, '\p{^NFKD_QC=n}', "");
    Expect(1, 195102, '\P{NFKD_QC=n}', "");
    Expect(0, 195102, '\P{^NFKD_QC=n}', "");
    Expect(1, 195101, '\p{NFKD_QC=:\An\z:}', "");;
    Expect(0, 195102, '\p{NFKD_QC=:\An\z:}', "");;
    Expect(1, 195101, '\p{NFKD_QC=--N}', "");
    Expect(0, 195101, '\p{^NFKD_QC=--N}', "");
    Expect(0, 195101, '\P{NFKD_QC=--N}', "");
    Expect(1, 195101, '\P{^NFKD_QC=--N}', "");
    Expect(0, 195102, '\p{NFKD_QC=--N}', "");
    Expect(1, 195102, '\p{^NFKD_QC=--N}', "");
    Expect(1, 195102, '\P{NFKD_QC=--N}', "");
    Expect(0, 195102, '\P{^NFKD_QC=--N}', "");
    Error('\p{Is_NFKD_Quick_Check=/a/_no}');
    Error('\P{Is_NFKD_Quick_Check=/a/_no}');
    Expect(1, 195101, '\p{Is_NFKD_Quick_Check=no}', "");
    Expect(0, 195101, '\p{^Is_NFKD_Quick_Check=no}', "");
    Expect(0, 195101, '\P{Is_NFKD_Quick_Check=no}', "");
    Expect(1, 195101, '\P{^Is_NFKD_Quick_Check=no}', "");
    Expect(0, 195102, '\p{Is_NFKD_Quick_Check=no}', "");
    Expect(1, 195102, '\p{^Is_NFKD_Quick_Check=no}', "");
    Expect(1, 195102, '\P{Is_NFKD_Quick_Check=no}', "");
    Expect(0, 195102, '\P{^Is_NFKD_Quick_Check=no}', "");
    Expect(1, 195101, '\p{Is_NFKD_Quick_Check= 	no}', "");
    Expect(0, 195101, '\p{^Is_NFKD_Quick_Check= 	no}', "");
    Expect(0, 195101, '\P{Is_NFKD_Quick_Check= 	no}', "");
    Expect(1, 195101, '\P{^Is_NFKD_Quick_Check= 	no}', "");
    Expect(0, 195102, '\p{Is_NFKD_Quick_Check= 	no}', "");
    Expect(1, 195102, '\p{^Is_NFKD_Quick_Check= 	no}', "");
    Expect(1, 195102, '\P{Is_NFKD_Quick_Check= 	no}', "");
    Expect(0, 195102, '\P{^Is_NFKD_Quick_Check= 	no}', "");
    Error('\p{Is_NFKD_QC=-:=N}');
    Error('\P{Is_NFKD_QC=-:=N}');
    Expect(1, 195101, '\p{Is_NFKD_QC=n}', "");
    Expect(0, 195101, '\p{^Is_NFKD_QC=n}', "");
    Expect(0, 195101, '\P{Is_NFKD_QC=n}', "");
    Expect(1, 195101, '\P{^Is_NFKD_QC=n}', "");
    Expect(0, 195102, '\p{Is_NFKD_QC=n}', "");
    Expect(1, 195102, '\p{^Is_NFKD_QC=n}', "");
    Expect(1, 195102, '\P{Is_NFKD_QC=n}', "");
    Expect(0, 195102, '\P{^Is_NFKD_QC=n}', "");
    Expect(1, 195101, '\p{Is_NFKD_QC=-	N}', "");
    Expect(0, 195101, '\p{^Is_NFKD_QC=-	N}', "");
    Expect(0, 195101, '\P{Is_NFKD_QC=-	N}', "");
    Expect(1, 195101, '\P{^Is_NFKD_QC=-	N}', "");
    Expect(0, 195102, '\p{Is_NFKD_QC=-	N}', "");
    Expect(1, 195102, '\p{^Is_NFKD_QC=-	N}', "");
    Expect(1, 195102, '\P{Is_NFKD_QC=-	N}', "");
    Expect(0, 195102, '\P{^Is_NFKD_QC=-	N}', "");
    Error('\p{NFKD_Quick_Check:/a/_yes}');
    Error('\P{NFKD_Quick_Check:/a/_yes}');
    Expect(1, 195102, '\p{NFKD_Quick_Check=:\AYes\z:}', "");;
    Expect(0, 195101, '\p{NFKD_Quick_Check=:\AYes\z:}', "");;
    Expect(1, 195102, '\p{NFKD_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^NFKD_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{NFKD_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^NFKD_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{NFKD_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^NFKD_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{NFKD_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^NFKD_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{NFKD_Quick_Check=:\Ayes\z:}', "");;
    Expect(0, 195101, '\p{NFKD_Quick_Check=:\Ayes\z:}', "");;
    Expect(1, 195102, '\p{NFKD_Quick_Check=-_yes}', "");
    Expect(0, 195102, '\p{^NFKD_Quick_Check=-_yes}', "");
    Expect(0, 195102, '\P{NFKD_Quick_Check=-_yes}', "");
    Expect(1, 195102, '\P{^NFKD_Quick_Check=-_yes}', "");
    Expect(0, 195101, '\p{NFKD_Quick_Check=-_yes}', "");
    Expect(1, 195101, '\p{^NFKD_Quick_Check=-_yes}', "");
    Expect(1, 195101, '\P{NFKD_Quick_Check=-_yes}', "");
    Expect(0, 195101, '\P{^NFKD_Quick_Check=-_yes}', "");
    Error('\p{NFKD_QC= :=Y}');
    Error('\P{NFKD_QC= :=Y}');
    Expect(1, 195102, '\p{NFKD_QC=:\AY\z:}', "");;
    Expect(0, 195101, '\p{NFKD_QC=:\AY\z:}', "");;
    Expect(1, 195102, '\p{NFKD_QC=y}', "");
    Expect(0, 195102, '\p{^NFKD_QC=y}', "");
    Expect(0, 195102, '\P{NFKD_QC=y}', "");
    Expect(1, 195102, '\P{^NFKD_QC=y}', "");
    Expect(0, 195101, '\p{NFKD_QC=y}', "");
    Expect(1, 195101, '\p{^NFKD_QC=y}', "");
    Expect(1, 195101, '\P{NFKD_QC=y}', "");
    Expect(0, 195101, '\P{^NFKD_QC=y}', "");
    Expect(1, 195102, '\p{NFKD_QC=:\Ay\z:}', "");;
    Expect(0, 195101, '\p{NFKD_QC=:\Ay\z:}', "");;
    Expect(1, 195102, '\p{NFKD_QC:    _Y}', "");
    Expect(0, 195102, '\p{^NFKD_QC:    _Y}', "");
    Expect(0, 195102, '\P{NFKD_QC:    _Y}', "");
    Expect(1, 195102, '\P{^NFKD_QC:    _Y}', "");
    Expect(0, 195101, '\p{NFKD_QC:    _Y}', "");
    Expect(1, 195101, '\p{^NFKD_QC:    _Y}', "");
    Expect(1, 195101, '\P{NFKD_QC:    _Y}', "");
    Expect(0, 195101, '\P{^NFKD_QC:    _Y}', "");
    Error('\p{Is_NFKD_Quick_Check:	-:=Yes}');
    Error('\P{Is_NFKD_Quick_Check:	-:=Yes}');
    Expect(1, 195102, '\p{Is_NFKD_Quick_Check=yes}', "");
    Expect(0, 195102, '\p{^Is_NFKD_Quick_Check=yes}', "");
    Expect(0, 195102, '\P{Is_NFKD_Quick_Check=yes}', "");
    Expect(1, 195102, '\P{^Is_NFKD_Quick_Check=yes}', "");
    Expect(0, 195101, '\p{Is_NFKD_Quick_Check=yes}', "");
    Expect(1, 195101, '\p{^Is_NFKD_Quick_Check=yes}', "");
    Expect(1, 195101, '\P{Is_NFKD_Quick_Check=yes}', "");
    Expect(0, 195101, '\P{^Is_NFKD_Quick_Check=yes}', "");
    Expect(1, 195102, '\p{Is_NFKD_Quick_Check= yes}', "");
    Expect(0, 195102, '\p{^Is_NFKD_Quick_Check= yes}', "");
    Expect(0, 195102, '\P{Is_NFKD_Quick_Check= yes}', "");
    Expect(1, 195102, '\P{^Is_NFKD_Quick_Check= yes}', "");
    Expect(0, 195101, '\p{Is_NFKD_Quick_Check= yes}', "");
    Expect(1, 195101, '\p{^Is_NFKD_Quick_Check= yes}', "");
    Expect(1, 195101, '\P{Is_NFKD_Quick_Check= yes}', "");
    Expect(0, 195101, '\P{^Is_NFKD_Quick_Check= yes}', "");
    Error('\p{Is_NFKD_QC=/a/	-y}');
    Error('\P{Is_NFKD_QC=/a/	-y}');
    Expect(1, 195102, '\p{Is_NFKD_QC=y}', "");
    Expect(0, 195102, '\p{^Is_NFKD_QC=y}', "");
    Expect(0, 195102, '\P{Is_NFKD_QC=y}', "");
    Expect(1, 195102, '\P{^Is_NFKD_QC=y}', "");
    Expect(0, 195101, '\p{Is_NFKD_QC=y}', "");
    Expect(1, 195101, '\p{^Is_NFKD_QC=y}', "");
    Expect(1, 195101, '\P{Is_NFKD_QC=y}', "");
    Expect(0, 195101, '\P{^Is_NFKD_QC=y}', "");
    Expect(1, 195102, '\p{Is_NFKD_QC=_Y}', "");
    Expect(0, 195102, '\p{^Is_NFKD_QC=_Y}', "");
    Expect(0, 195102, '\P{Is_NFKD_QC=_Y}', "");
    Expect(1, 195102, '\P{^Is_NFKD_QC=_Y}', "");
    Expect(0, 195101, '\p{Is_NFKD_QC=_Y}', "");
    Expect(1, 195101, '\p{^Is_NFKD_QC=_Y}', "");
    Expect(1, 195101, '\P{Is_NFKD_QC=_Y}', "");
    Expect(0, 195101, '\P{^Is_NFKD_QC=_Y}', "");
    Error('\p{numerictype}');
    Error('\P{numerictype}');
    Error('\p{nt}');
    Error('\P{nt}');
    Error('\p{Numeric_Type:    -DECIMAL:=}');
    Error('\P{Numeric_Type:    -DECIMAL:=}');
    Expect(1, 125273, '\p{Numeric_Type=:\ADecimal\z:}', "");;
    Expect(0, 125274, '\p{Numeric_Type=:\ADecimal\z:}', "");;
    Expect(1, 125273, '\p{Numeric_Type=decimal}', "");
    Expect(0, 125273, '\p{^Numeric_Type=decimal}', "");
    Expect(0, 125273, '\P{Numeric_Type=decimal}', "");
    Expect(1, 125273, '\P{^Numeric_Type=decimal}', "");
    Expect(0, 125274, '\p{Numeric_Type=decimal}', "");
    Expect(1, 125274, '\p{^Numeric_Type=decimal}', "");
    Expect(1, 125274, '\P{Numeric_Type=decimal}', "");
    Expect(0, 125274, '\P{^Numeric_Type=decimal}', "");
    Expect(1, 125273, '\p{Numeric_Type=:\Adecimal\z:}', "");;
    Expect(0, 125274, '\p{Numeric_Type=:\Adecimal\z:}', "");;
    Expect(1, 125273, '\p{Numeric_Type=	-Decimal}', "");
    Expect(0, 125273, '\p{^Numeric_Type=	-Decimal}', "");
    Expect(0, 125273, '\P{Numeric_Type=	-Decimal}', "");
    Expect(1, 125273, '\P{^Numeric_Type=	-Decimal}', "");
    Expect(0, 125274, '\p{Numeric_Type=	-Decimal}', "");
    Expect(1, 125274, '\p{^Numeric_Type=	-Decimal}', "");
    Expect(1, 125274, '\P{Numeric_Type=	-Decimal}', "");
    Expect(0, 125274, '\P{^Numeric_Type=	-Decimal}', "");
    Error('\p{Nt=:= de}');
    Error('\P{Nt=:= de}');
    Expect(1, 125273, '\p{Nt=:\ADe\z:}', "");;
    Expect(0, 125274, '\p{Nt=:\ADe\z:}', "");;
    Expect(1, 125273, '\p{Nt=de}', "");
    Expect(0, 125273, '\p{^Nt=de}', "");
    Expect(0, 125273, '\P{Nt=de}', "");
    Expect(1, 125273, '\P{^Nt=de}', "");
    Expect(0, 125274, '\p{Nt=de}', "");
    Expect(1, 125274, '\p{^Nt=de}', "");
    Expect(1, 125274, '\P{Nt=de}', "");
    Expect(0, 125274, '\P{^Nt=de}', "");
    Expect(1, 125273, '\p{Nt=:\Ade\z:}', "");;
    Expect(0, 125274, '\p{Nt=:\Ade\z:}', "");;
    Expect(1, 125273, '\p{Nt=-_De}', "");
    Expect(0, 125273, '\p{^Nt=-_De}', "");
    Expect(0, 125273, '\P{Nt=-_De}', "");
    Expect(1, 125273, '\P{^Nt=-_De}', "");
    Expect(0, 125274, '\p{Nt=-_De}', "");
    Expect(1, 125274, '\p{^Nt=-_De}', "");
    Expect(1, 125274, '\P{Nt=-_De}', "");
    Expect(0, 125274, '\P{^Nt=-_De}', "");
    Error('\p{Is_Numeric_Type=:= decimal}');
    Error('\P{Is_Numeric_Type=:= decimal}');
    Expect(1, 125273, '\p{Is_Numeric_Type=decimal}', "");
    Expect(0, 125273, '\p{^Is_Numeric_Type=decimal}', "");
    Expect(0, 125273, '\P{Is_Numeric_Type=decimal}', "");
    Expect(1, 125273, '\P{^Is_Numeric_Type=decimal}', "");
    Expect(0, 125274, '\p{Is_Numeric_Type=decimal}', "");
    Expect(1, 125274, '\p{^Is_Numeric_Type=decimal}', "");
    Expect(1, 125274, '\P{Is_Numeric_Type=decimal}', "");
    Expect(0, 125274, '\P{^Is_Numeric_Type=decimal}', "");
    Expect(1, 125273, '\p{Is_Numeric_Type=-_Decimal}', "");
    Expect(0, 125273, '\p{^Is_Numeric_Type=-_Decimal}', "");
    Expect(0, 125273, '\P{Is_Numeric_Type=-_Decimal}', "");
    Expect(1, 125273, '\P{^Is_Numeric_Type=-_Decimal}', "");
    Expect(0, 125274, '\p{Is_Numeric_Type=-_Decimal}', "");
    Expect(1, 125274, '\p{^Is_Numeric_Type=-_Decimal}', "");
    Expect(1, 125274, '\P{Is_Numeric_Type=-_Decimal}', "");
    Expect(0, 125274, '\P{^Is_Numeric_Type=-_Decimal}', "");
    Error('\p{Is_Nt=_:=DE}');
    Error('\P{Is_Nt=_:=DE}');
    Expect(1, 125273, '\p{Is_Nt=de}', "");
    Expect(0, 125273, '\p{^Is_Nt=de}', "");
    Expect(0, 125273, '\P{Is_Nt=de}', "");
    Expect(1, 125273, '\P{^Is_Nt=de}', "");
    Expect(0, 125274, '\p{Is_Nt=de}', "");
    Expect(1, 125274, '\p{^Is_Nt=de}', "");
    Expect(1, 125274, '\P{Is_Nt=de}', "");
    Expect(0, 125274, '\P{^Is_Nt=de}', "");
    Expect(1, 125273, '\p{Is_Nt=-	de}', "");
    Expect(0, 125273, '\p{^Is_Nt=-	de}', "");
    Expect(0, 125273, '\P{Is_Nt=-	de}', "");
    Expect(1, 125273, '\P{^Is_Nt=-	de}', "");
    Expect(0, 125274, '\p{Is_Nt=-	de}', "");
    Expect(1, 125274, '\p{^Is_Nt=-	de}', "");
    Expect(1, 125274, '\P{Is_Nt=-	de}', "");
    Expect(0, 125274, '\P{^Is_Nt=-	de}', "");
    Error('\p{Numeric_Type=_-Digit/a/}');
    Error('\P{Numeric_Type=_-Digit/a/}');
    Expect(1, 127242, '\p{Numeric_Type=:\ADigit\z:}', "");;
    Expect(0, 127243, '\p{Numeric_Type=:\ADigit\z:}', "");;
    Expect(1, 127242, '\p{Numeric_Type=digit}', "");
    Expect(0, 127242, '\p{^Numeric_Type=digit}', "");
    Expect(0, 127242, '\P{Numeric_Type=digit}', "");
    Expect(1, 127242, '\P{^Numeric_Type=digit}', "");
    Expect(0, 127243, '\p{Numeric_Type=digit}', "");
    Expect(1, 127243, '\p{^Numeric_Type=digit}', "");
    Expect(1, 127243, '\P{Numeric_Type=digit}', "");
    Expect(0, 127243, '\P{^Numeric_Type=digit}', "");
    Expect(1, 127242, '\p{Numeric_Type=:\Adigit\z:}', "");;
    Expect(0, 127243, '\p{Numeric_Type=:\Adigit\z:}', "");;
    Expect(1, 127242, '\p{Numeric_Type= _Digit}', "");
    Expect(0, 127242, '\p{^Numeric_Type= _Digit}', "");
    Expect(0, 127242, '\P{Numeric_Type= _Digit}', "");
    Expect(1, 127242, '\P{^Numeric_Type= _Digit}', "");
    Expect(0, 127243, '\p{Numeric_Type= _Digit}', "");
    Expect(1, 127243, '\p{^Numeric_Type= _Digit}', "");
    Expect(1, 127243, '\P{Numeric_Type= _Digit}', "");
    Expect(0, 127243, '\P{^Numeric_Type= _Digit}', "");
    Error('\p{Nt=/a/ Di}');
    Error('\P{Nt=/a/ Di}');
    Expect(1, 127242, '\p{Nt=:\ADi\z:}', "");;
    Expect(0, 127243, '\p{Nt=:\ADi\z:}', "");;
    Expect(1, 127242, '\p{Nt=di}', "");
    Expect(0, 127242, '\p{^Nt=di}', "");
    Expect(0, 127242, '\P{Nt=di}', "");
    Expect(1, 127242, '\P{^Nt=di}', "");
    Expect(0, 127243, '\p{Nt=di}', "");
    Expect(1, 127243, '\p{^Nt=di}', "");
    Expect(1, 127243, '\P{Nt=di}', "");
    Expect(0, 127243, '\P{^Nt=di}', "");
    Expect(1, 127242, '\p{Nt=:\Adi\z:}', "");;
    Expect(0, 127243, '\p{Nt=:\Adi\z:}', "");;
    Expect(1, 127242, '\p{Nt= -di}', "");
    Expect(0, 127242, '\p{^Nt= -di}', "");
    Expect(0, 127242, '\P{Nt= -di}', "");
    Expect(1, 127242, '\P{^Nt= -di}', "");
    Expect(0, 127243, '\p{Nt= -di}', "");
    Expect(1, 127243, '\p{^Nt= -di}', "");
    Expect(1, 127243, '\P{Nt= -di}', "");
    Expect(0, 127243, '\P{^Nt= -di}', "");
    Error('\p{Is_Numeric_Type=- digit/a/}');
    Error('\P{Is_Numeric_Type=- digit/a/}');
    Expect(1, 127242, '\p{Is_Numeric_Type=digit}', "");
    Expect(0, 127242, '\p{^Is_Numeric_Type=digit}', "");
    Expect(0, 127242, '\P{Is_Numeric_Type=digit}', "");
    Expect(1, 127242, '\P{^Is_Numeric_Type=digit}', "");
    Expect(0, 127243, '\p{Is_Numeric_Type=digit}', "");
    Expect(1, 127243, '\p{^Is_Numeric_Type=digit}', "");
    Expect(1, 127243, '\P{Is_Numeric_Type=digit}', "");
    Expect(0, 127243, '\P{^Is_Numeric_Type=digit}', "");
    Expect(1, 127242, '\p{Is_Numeric_Type=  digit}', "");
    Expect(0, 127242, '\p{^Is_Numeric_Type=  digit}', "");
    Expect(0, 127242, '\P{Is_Numeric_Type=  digit}', "");
    Expect(1, 127242, '\P{^Is_Numeric_Type=  digit}', "");
    Expect(0, 127243, '\p{Is_Numeric_Type=  digit}', "");
    Expect(1, 127243, '\p{^Is_Numeric_Type=  digit}', "");
    Expect(1, 127243, '\P{Is_Numeric_Type=  digit}', "");
    Expect(0, 127243, '\P{^Is_Numeric_Type=  digit}', "");
    Error('\p{Is_Nt=-/a/DI}');
    Error('\P{Is_Nt=-/a/DI}');
    Expect(1, 127242, '\p{Is_Nt=di}', "");
    Expect(0, 127242, '\p{^Is_Nt=di}', "");
    Expect(0, 127242, '\P{Is_Nt=di}', "");
    Expect(1, 127242, '\P{^Is_Nt=di}', "");
    Expect(0, 127243, '\p{Is_Nt=di}', "");
    Expect(1, 127243, '\p{^Is_Nt=di}', "");
    Expect(1, 127243, '\P{Is_Nt=di}', "");
    Expect(0, 127243, '\P{^Is_Nt=di}', "");
    Expect(1, 127242, '\p{Is_Nt=	_Di}', "");
    Expect(0, 127242, '\p{^Is_Nt=	_Di}', "");
    Expect(0, 127242, '\P{Is_Nt=	_Di}', "");
    Expect(1, 127242, '\P{^Is_Nt=	_Di}', "");
    Expect(0, 127243, '\p{Is_Nt=	_Di}', "");
    Expect(1, 127243, '\p{^Is_Nt=	_Di}', "");
    Expect(1, 127243, '\P{Is_Nt=	_Di}', "");
    Expect(0, 127243, '\P{^Is_Nt=	_Di}', "");
    Error('\p{Numeric_Type=	-None/a/}');
    Error('\P{Numeric_Type=	-None/a/}');
    Expect(1, 194705, '\p{Numeric_Type=:\ANone\z:}', "");;
    Expect(0, 194704, '\p{Numeric_Type=:\ANone\z:}', "");;
    Expect(1, 194705, '\p{Numeric_Type=none}', "");
    Expect(0, 194705, '\p{^Numeric_Type=none}', "");
    Expect(0, 194705, '\P{Numeric_Type=none}', "");
    Expect(1, 194705, '\P{^Numeric_Type=none}', "");
    Expect(0, 194704, '\p{Numeric_Type=none}', "");
    Expect(1, 194704, '\p{^Numeric_Type=none}', "");
    Expect(1, 194704, '\P{Numeric_Type=none}', "");
    Expect(0, 194704, '\P{^Numeric_Type=none}', "");
    Expect(1, 194705, '\p{Numeric_Type=:\Anone\z:}', "");;
    Expect(0, 194704, '\p{Numeric_Type=:\Anone\z:}', "");;
    Expect(1, 194705, '\p{Numeric_Type=	_none}', "");
    Expect(0, 194705, '\p{^Numeric_Type=	_none}', "");
    Expect(0, 194705, '\P{Numeric_Type=	_none}', "");
    Expect(1, 194705, '\P{^Numeric_Type=	_none}', "");
    Expect(0, 194704, '\p{Numeric_Type=	_none}', "");
    Expect(1, 194704, '\p{^Numeric_Type=	_none}', "");
    Expect(1, 194704, '\P{Numeric_Type=	_none}', "");
    Expect(0, 194704, '\P{^Numeric_Type=	_none}', "");
    Error('\p{Nt=	None:=}');
    Error('\P{Nt=	None:=}');
    Expect(1, 194705, '\p{Nt=:\ANone\z:}', "");;
    Expect(0, 194704, '\p{Nt=:\ANone\z:}', "");;
    Expect(1, 194705, '\p{Nt=none}', "");
    Expect(0, 194705, '\p{^Nt=none}', "");
    Expect(0, 194705, '\P{Nt=none}', "");
    Expect(1, 194705, '\P{^Nt=none}', "");
    Expect(0, 194704, '\p{Nt=none}', "");
    Expect(1, 194704, '\p{^Nt=none}', "");
    Expect(1, 194704, '\P{Nt=none}', "");
    Expect(0, 194704, '\P{^Nt=none}', "");
    Expect(1, 194705, '\p{Nt=:\Anone\z:}', "");;
    Expect(0, 194704, '\p{Nt=:\Anone\z:}', "");;
    Expect(1, 194705, '\p{Nt=	None}', "");
    Expect(0, 194705, '\p{^Nt=	None}', "");
    Expect(0, 194705, '\P{Nt=	None}', "");
    Expect(1, 194705, '\P{^Nt=	None}', "");
    Expect(0, 194704, '\p{Nt=	None}', "");
    Expect(1, 194704, '\p{^Nt=	None}', "");
    Expect(1, 194704, '\P{Nt=	None}', "");
    Expect(0, 194704, '\P{^Nt=	None}', "");
    Error('\p{Is_Numeric_Type= /a/None}');
    Error('\P{Is_Numeric_Type= /a/None}');
    Expect(1, 194705, '\p{Is_Numeric_Type=none}', "");
    Expect(0, 194705, '\p{^Is_Numeric_Type=none}', "");
    Expect(0, 194705, '\P{Is_Numeric_Type=none}', "");
    Expect(1, 194705, '\P{^Is_Numeric_Type=none}', "");
    Expect(0, 194704, '\p{Is_Numeric_Type=none}', "");
    Expect(1, 194704, '\p{^Is_Numeric_Type=none}', "");
    Expect(1, 194704, '\P{Is_Numeric_Type=none}', "");
    Expect(0, 194704, '\P{^Is_Numeric_Type=none}', "");
    Expect(1, 194705, '\p{Is_Numeric_Type= 	None}', "");
    Expect(0, 194705, '\p{^Is_Numeric_Type= 	None}', "");
    Expect(0, 194705, '\P{Is_Numeric_Type= 	None}', "");
    Expect(1, 194705, '\P{^Is_Numeric_Type= 	None}', "");
    Expect(0, 194704, '\p{Is_Numeric_Type= 	None}', "");
    Expect(1, 194704, '\p{^Is_Numeric_Type= 	None}', "");
    Expect(1, 194704, '\P{Is_Numeric_Type= 	None}', "");
    Expect(0, 194704, '\P{^Is_Numeric_Type= 	None}', "");
    Error('\p{Is_Nt=:=NONE}');
    Error('\P{Is_Nt=:=NONE}');
    Expect(1, 194705, '\p{Is_Nt=none}', "");
    Expect(0, 194705, '\p{^Is_Nt=none}', "");
    Expect(0, 194705, '\P{Is_Nt=none}', "");
    Expect(1, 194705, '\P{^Is_Nt=none}', "");
    Expect(0, 194704, '\p{Is_Nt=none}', "");
    Expect(1, 194704, '\p{^Is_Nt=none}', "");
    Expect(1, 194704, '\P{Is_Nt=none}', "");
    Expect(0, 194704, '\P{^Is_Nt=none}', "");
    Expect(1, 194705, '\p{Is_Nt=-NONE}', "");
    Expect(0, 194705, '\p{^Is_Nt=-NONE}', "");
    Expect(0, 194705, '\P{Is_Nt=-NONE}', "");
    Expect(1, 194705, '\P{^Is_Nt=-NONE}', "");
    Expect(0, 194704, '\p{Is_Nt=-NONE}', "");
    Expect(1, 194704, '\p{^Is_Nt=-NONE}', "");
    Expect(1, 194704, '\P{Is_Nt=-NONE}', "");
    Expect(0, 194704, '\P{^Is_Nt=-NONE}', "");
    Error('\p{Numeric_Type=-Numeric/a/}');
    Error('\P{Numeric_Type=-Numeric/a/}');
    Expect(1, 194704, '\p{Numeric_Type=:\ANumeric\z:}', "");;
    Expect(0, 194705, '\p{Numeric_Type=:\ANumeric\z:}', "");;
    Expect(1, 194704, '\p{Numeric_Type:	numeric}', "");
    Expect(0, 194704, '\p{^Numeric_Type:	numeric}', "");
    Expect(0, 194704, '\P{Numeric_Type:	numeric}', "");
    Expect(1, 194704, '\P{^Numeric_Type:	numeric}', "");
    Expect(0, 194705, '\p{Numeric_Type:	numeric}', "");
    Expect(1, 194705, '\p{^Numeric_Type:	numeric}', "");
    Expect(1, 194705, '\P{Numeric_Type:	numeric}', "");
    Expect(0, 194705, '\P{^Numeric_Type:	numeric}', "");
    Expect(1, 194704, '\p{Numeric_Type=:\Anumeric\z:}', "");;
    Expect(0, 194705, '\p{Numeric_Type=:\Anumeric\z:}', "");;
    Expect(1, 194704, '\p{Numeric_Type: -_numeric}', "");
    Expect(0, 194704, '\p{^Numeric_Type: -_numeric}', "");
    Expect(0, 194704, '\P{Numeric_Type: -_numeric}', "");
    Expect(1, 194704, '\P{^Numeric_Type: -_numeric}', "");
    Expect(0, 194705, '\p{Numeric_Type: -_numeric}', "");
    Expect(1, 194705, '\p{^Numeric_Type: -_numeric}', "");
    Expect(1, 194705, '\P{Numeric_Type: -_numeric}', "");
    Expect(0, 194705, '\P{^Numeric_Type: -_numeric}', "");
    Error('\p{Nt=:=NU}');
    Error('\P{Nt=:=NU}');
    Expect(1, 194704, '\p{Nt=:\ANu\z:}', "");;
    Expect(0, 194705, '\p{Nt=:\ANu\z:}', "");;
    Expect(1, 194704, '\p{Nt=nu}', "");
    Expect(0, 194704, '\p{^Nt=nu}', "");
    Expect(0, 194704, '\P{Nt=nu}', "");
    Expect(1, 194704, '\P{^Nt=nu}', "");
    Expect(0, 194705, '\p{Nt=nu}', "");
    Expect(1, 194705, '\p{^Nt=nu}', "");
    Expect(1, 194705, '\P{Nt=nu}', "");
    Expect(0, 194705, '\P{^Nt=nu}', "");
    Expect(1, 194704, '\p{Nt=:\Anu\z:}', "");;
    Expect(0, 194705, '\p{Nt=:\Anu\z:}', "");;
    Expect(1, 194704, '\p{Nt=-nu}', "");
    Expect(0, 194704, '\p{^Nt=-nu}', "");
    Expect(0, 194704, '\P{Nt=-nu}', "");
    Expect(1, 194704, '\P{^Nt=-nu}', "");
    Expect(0, 194705, '\p{Nt=-nu}', "");
    Expect(1, 194705, '\p{^Nt=-nu}', "");
    Expect(1, 194705, '\P{Nt=-nu}', "");
    Expect(0, 194705, '\P{^Nt=-nu}', "");
    Error('\p{Is_Numeric_Type:   /a/	 NUMERIC}');
    Error('\P{Is_Numeric_Type:   /a/	 NUMERIC}');
    Expect(1, 194704, '\p{Is_Numeric_Type:   numeric}', "");
    Expect(0, 194704, '\p{^Is_Numeric_Type:   numeric}', "");
    Expect(0, 194704, '\P{Is_Numeric_Type:   numeric}', "");
    Expect(1, 194704, '\P{^Is_Numeric_Type:   numeric}', "");
    Expect(0, 194705, '\p{Is_Numeric_Type:   numeric}', "");
    Expect(1, 194705, '\p{^Is_Numeric_Type:   numeric}', "");
    Expect(1, 194705, '\P{Is_Numeric_Type:   numeric}', "");
    Expect(0, 194705, '\P{^Is_Numeric_Type:   numeric}', "");
    Expect(1, 194704, '\p{Is_Numeric_Type=	_NUMERIC}', "");
    Expect(0, 194704, '\p{^Is_Numeric_Type=	_NUMERIC}', "");
    Expect(0, 194704, '\P{Is_Numeric_Type=	_NUMERIC}', "");
    Expect(1, 194704, '\P{^Is_Numeric_Type=	_NUMERIC}', "");
    Expect(0, 194705, '\p{Is_Numeric_Type=	_NUMERIC}', "");
    Expect(1, 194705, '\p{^Is_Numeric_Type=	_NUMERIC}', "");
    Expect(1, 194705, '\P{Is_Numeric_Type=	_NUMERIC}', "");
    Expect(0, 194705, '\P{^Is_Numeric_Type=	_NUMERIC}', "");
    Error('\p{Is_Nt=/a/Nu}');
    Error('\P{Is_Nt=/a/Nu}');
    Expect(1, 194704, '\p{Is_Nt=nu}', "");
    Expect(0, 194704, '\p{^Is_Nt=nu}', "");
    Expect(0, 194704, '\P{Is_Nt=nu}', "");
    Expect(1, 194704, '\P{^Is_Nt=nu}', "");
    Expect(0, 194705, '\p{Is_Nt=nu}', "");
    Expect(1, 194705, '\p{^Is_Nt=nu}', "");
    Expect(1, 194705, '\P{Is_Nt=nu}', "");
    Expect(0, 194705, '\P{^Is_Nt=nu}', "");
    Expect(1, 194704, '\p{Is_Nt=__Nu}', "");
    Expect(0, 194704, '\p{^Is_Nt=__Nu}', "");
    Expect(0, 194704, '\P{Is_Nt=__Nu}', "");
    Expect(1, 194704, '\P{^Is_Nt=__Nu}', "");
    Expect(0, 194705, '\p{Is_Nt=__Nu}', "");
    Expect(1, 194705, '\p{^Is_Nt=__Nu}', "");
    Expect(1, 194705, '\P{Is_Nt=__Nu}', "");
    Expect(0, 194705, '\P{^Is_Nt=__Nu}', "");
    Error('\p{numericvalue}');
    Error('\P{numericvalue}');
    Error('\p{nv}');
    Error('\P{nv}');
    Error('\p{Numeric_Value=	/a/-001/2}');
    Error('\P{Numeric_Value=	/a/-001/2}');
    Expect(1, 3891, '\p{Numeric_Value=:\A-1/2\z:}', "");;
    Expect(0, 3892, '\p{Numeric_Value=:\A-1/2\z:}', "");;
    Expect(1, 3891, '\p{Numeric_Value=-01/00002}', "");
    Expect(0, 3891, '\p{^Numeric_Value=-01/00002}', "");
    Expect(0, 3891, '\P{Numeric_Value=-01/00002}', "");
    Expect(1, 3891, '\P{^Numeric_Value=-01/00002}', "");
    Expect(0, 3892, '\p{Numeric_Value=-01/00002}', "");
    Expect(1, 3892, '\p{^Numeric_Value=-01/00002}', "");
    Expect(1, 3892, '\P{Numeric_Value=-01/00002}', "");
    Expect(0, 3892, '\P{^Numeric_Value=-01/00002}', "");
    Expect(1, 3891, '\p{Numeric_Value=-60/120}', "");
    Expect(0, 3891, '\p{^Numeric_Value=-60/120}', "");
    Expect(0, 3891, '\P{Numeric_Value=-60/120}', "");
    Expect(1, 3891, '\P{^Numeric_Value=-60/120}', "");
    Expect(0, 3892, '\p{Numeric_Value=-60/120}', "");
    Expect(1, 3892, '\p{^Numeric_Value=-60/120}', "");
    Expect(1, 3892, '\P{Numeric_Value=-60/120}', "");
    Expect(0, 3892, '\P{^Numeric_Value=-60/120}', "");
    Expect(1, 3891, '\p{Numeric_Value=-5.0e-01}', "");
    Expect(0, 3891, '\p{^Numeric_Value=-5.0e-01}', "");
    Expect(0, 3891, '\P{Numeric_Value=-5.0e-01}', "");
    Expect(1, 3891, '\P{^Numeric_Value=-5.0e-01}', "");
    Expect(0, 3892, '\p{Numeric_Value=-5.0e-01}', "");
    Expect(1, 3892, '\p{^Numeric_Value=-5.0e-01}', "");
    Expect(1, 3892, '\P{Numeric_Value=-5.0e-01}', "");
    Expect(0, 3892, '\P{^Numeric_Value=-5.0e-01}', "");
    Expect(1, 3891, '\p{Numeric_Value=-0.5}', "");
    Expect(0, 3891, '\p{^Numeric_Value=-0.5}', "");
    Expect(0, 3891, '\P{Numeric_Value=-0.5}', "");
    Expect(1, 3891, '\P{^Numeric_Value=-0.5}', "");
    Expect(0, 3892, '\p{Numeric_Value=-0.5}', "");
    Expect(1, 3892, '\p{^Numeric_Value=-0.5}', "");
    Expect(1, 3892, '\P{Numeric_Value=-0.5}', "");
    Expect(0, 3892, '\P{^Numeric_Value=-0.5}', "");
    Expect(1, 3891, '\p{Numeric_Value=-5.00e-01}', "");
    Expect(0, 3891, '\p{^Numeric_Value=-5.00e-01}', "");
    Expect(0, 3891, '\P{Numeric_Value=-5.00e-01}', "");
    Expect(1, 3891, '\P{^Numeric_Value=-5.00e-01}', "");
    Expect(0, 3892, '\p{Numeric_Value=-5.00e-01}', "");
    Expect(1, 3892, '\p{^Numeric_Value=-5.00e-01}', "");
    Expect(1, 3892, '\P{Numeric_Value=-5.00e-01}', "");
    Expect(0, 3892, '\P{^Numeric_Value=-5.00e-01}', "");
    Expect(1, 3891, '\p{Numeric_Value=-0.50}', "");
    Expect(0, 3891, '\p{^Numeric_Value=-0.50}', "");
    Expect(0, 3891, '\P{Numeric_Value=-0.50}', "");
    Expect(1, 3891, '\P{^Numeric_Value=-0.50}', "");
    Expect(0, 3892, '\p{Numeric_Value=-0.50}', "");
    Expect(1, 3892, '\p{^Numeric_Value=-0.50}', "");
    Expect(1, 3892, '\P{Numeric_Value=-0.50}', "");
    Expect(0, 3892, '\P{^Numeric_Value=-0.50}', "");
    Error('\p{Nv=:=-000001/00000002}');
    Error('\P{Nv=:=-000001/00000002}');
    Expect(1, 3891, '\p{Nv=:\A-1/2\z:}', "");;
    Expect(0, 3892, '\p{Nv=:\A-1/2\z:}', "");;
    Expect(1, 3891, '\p{Nv=-0001/000002}', "");
    Expect(0, 3891, '\p{^Nv=-0001/000002}', "");
    Expect(0, 3891, '\P{Nv=-0001/000002}', "");
    Expect(1, 3891, '\P{^Nv=-0001/000002}', "");
    Expect(0, 3892, '\p{Nv=-0001/000002}', "");
    Expect(1, 3892, '\p{^Nv=-0001/000002}', "");
    Expect(1, 3892, '\P{Nv=-0001/000002}', "");
    Expect(0, 3892, '\P{^Nv=-0001/000002}', "");
    Expect(1, 3891, '\p{Nv=-60/120}', "");
    Expect(0, 3891, '\p{^Nv=-60/120}', "");
    Expect(0, 3891, '\P{Nv=-60/120}', "");
    Expect(1, 3891, '\P{^Nv=-60/120}', "");
    Expect(0, 3892, '\p{Nv=-60/120}', "");
    Expect(1, 3892, '\p{^Nv=-60/120}', "");
    Expect(1, 3892, '\P{Nv=-60/120}', "");
    Expect(0, 3892, '\P{^Nv=-60/120}', "");
    Expect(1, 3891, '\p{Nv=-5.0e-01}', "");
    Expect(0, 3891, '\p{^Nv=-5.0e-01}', "");
    Expect(0, 3891, '\P{Nv=-5.0e-01}', "");
    Expect(1, 3891, '\P{^Nv=-5.0e-01}', "");
    Expect(0, 3892, '\p{Nv=-5.0e-01}', "");
    Expect(1, 3892, '\p{^Nv=-5.0e-01}', "");
    Expect(1, 3892, '\P{Nv=-5.0e-01}', "");
    Expect(0, 3892, '\P{^Nv=-5.0e-01}', "");
    Expect(1, 3891, '\p{Nv=-0.5}', "");
    Expect(0, 3891, '\p{^Nv=-0.5}', "");
    Expect(0, 3891, '\P{Nv=-0.5}', "");
    Expect(1, 3891, '\P{^Nv=-0.5}', "");
    Expect(0, 3892, '\p{Nv=-0.5}', "");
    Expect(1, 3892, '\p{^Nv=-0.5}', "");
    Expect(1, 3892, '\P{Nv=-0.5}', "");
    Expect(0, 3892, '\P{^Nv=-0.5}', "");
    Expect(1, 3891, '\p{Nv=-5.00e-01}', "");
    Expect(0, 3891, '\p{^Nv=-5.00e-01}', "");
    Expect(0, 3891, '\P{Nv=-5.00e-01}', "");
    Expect(1, 3891, '\P{^Nv=-5.00e-01}', "");
    Expect(0, 3892, '\p{Nv=-5.00e-01}', "");
    Expect(1, 3892, '\p{^Nv=-5.00e-01}', "");
    Expect(1, 3892, '\P{Nv=-5.00e-01}', "");
    Expect(0, 3892, '\P{^Nv=-5.00e-01}', "");
    Expect(1, 3891, '\p{Nv=-0.50}', "");
    Expect(0, 3891, '\p{^Nv=-0.50}', "");
    Expect(0, 3891, '\P{Nv=-0.50}', "");
    Expect(1, 3891, '\P{^Nv=-0.50}', "");
    Expect(0, 3892, '\p{Nv=-0.50}', "");
    Expect(1, 3892, '\p{^Nv=-0.50}', "");
    Expect(1, 3892, '\P{Nv=-0.50}', "");
    Expect(0, 3892, '\P{^Nv=-0.50}', "");
    Error('\p{Is_Numeric_Value=:=-	-01/2}');
    Error('\P{Is_Numeric_Value=:=-	-01/2}');
    Expect(1, 3891, '\p{Is_Numeric_Value=-0000000001/000002}', "");
    Expect(0, 3891, '\p{^Is_Numeric_Value=-0000000001/000002}', "");
    Expect(0, 3891, '\P{Is_Numeric_Value=-0000000001/000002}', "");
    Expect(1, 3891, '\P{^Is_Numeric_Value=-0000000001/000002}', "");
    Expect(0, 3892, '\p{Is_Numeric_Value=-0000000001/000002}', "");
    Expect(1, 3892, '\p{^Is_Numeric_Value=-0000000001/000002}', "");
    Expect(1, 3892, '\P{Is_Numeric_Value=-0000000001/000002}', "");
    Expect(0, 3892, '\P{^Is_Numeric_Value=-0000000001/000002}', "");
    Expect(1, 3891, '\p{Is_Numeric_Value=-60/120}', "");
    Expect(0, 3891, '\p{^Is_Numeric_Value=-60/120}', "");
    Expect(0, 3891, '\P{Is_Numeric_Value=-60/120}', "");
    Expect(1, 3891, '\P{^Is_Numeric_Value=-60/120}', "");
    Expect(0, 3892, '\p{Is_Numeric_Value=-60/120}', "");
    Expect(1, 3892, '\p{^Is_Numeric_Value=-60/120}', "");
    Expect(1, 3892, '\P{Is_Numeric_Value=-60/120}', "");
    Expect(0, 3892, '\P{^Is_Numeric_Value=-60/120}', "");
    Expect(1, 3891, '\p{Is_Numeric_Value=-5.0e-01}', "");
    Expect(0, 3891, '\p{^Is_Numeric_Value=-5.0e-01}', "");
    Expect(0, 3891, '\P{Is_Numeric_Value=-5.0e-01}', "");
    Expect(1, 3891, '\P{^Is_Numeric_Value=-5.0e-01}', "");
    Expect(0, 3892, '\p{Is_Numeric_Value=-5.0e-01}', "");
    Expect(1, 3892, '\p{^Is_Numeric_Value=-5.0e-01}', "");
    Expect(1, 3892, '\P{Is_Numeric_Value=-5.0e-01}', "");
    Expect(0, 3892, '\P{^Is_Numeric_Value=-5.0e-01}', "");
    Expect(1, 3891, '\p{Is_Numeric_Value=-0.5}', "");
    Expect(0, 3891, '\p{^Is_Numeric_Value=-0.5}', "");
    Expect(0, 3891, '\P{Is_Numeric_Value=-0.5}', "");
    Expect(1, 3891, '\P{^Is_Numeric_Value=-0.5}', "");
    Expect(0, 3892, '\p{Is_Numeric_Value=-0.5}', "");
    Expect(1, 3892, '\p{^Is_Numeric_Value=-0.5}', "");
    Expect(1, 3892, '\P{Is_Numeric_Value=-0.5}', "");
    Expect(0, 3892, '\P{^Is_Numeric_Value=-0.5}', "");
    Expect(1, 3891, '\p{Is_Numeric_Value:   -5.00e-01}', "");
    Expect(0, 3891, '\p{^Is_Numeric_Value:   -5.00e-01}', "");
    Expect(0, 3891, '\P{Is_Numeric_Value:   -5.00e-01}', "");
    Expect(1, 3891, '\P{^Is_Numeric_Value:   -5.00e-01}', "");
    Expect(0, 3892, '\p{Is_Numeric_Value:   -5.00e-01}', "");
    Expect(1, 3892, '\p{^Is_Numeric_Value:   -5.00e-01}', "");
    Expect(1, 3892, '\P{Is_Numeric_Value:   -5.00e-01}', "");
    Expect(0, 3892, '\P{^Is_Numeric_Value:   -5.00e-01}', "");
    Expect(1, 3891, '\p{Is_Numeric_Value=-0.50}', "");
    Expect(0, 3891, '\p{^Is_Numeric_Value=-0.50}', "");
    Expect(0, 3891, '\P{Is_Numeric_Value=-0.50}', "");
    Expect(1, 3891, '\P{^Is_Numeric_Value=-0.50}', "");
    Expect(0, 3892, '\p{Is_Numeric_Value=-0.50}', "");
    Expect(1, 3892, '\p{^Is_Numeric_Value=-0.50}', "");
    Expect(1, 3892, '\P{Is_Numeric_Value=-0.50}', "");
    Expect(0, 3892, '\P{^Is_Numeric_Value=-0.50}', "");
    Error('\p{Is_Nv=:=  -000000001/02}');
    Error('\P{Is_Nv=:=  -000000001/02}');
    Expect(1, 3891, '\p{Is_Nv=-01/000000002}', "");
    Expect(0, 3891, '\p{^Is_Nv=-01/000000002}', "");
    Expect(0, 3891, '\P{Is_Nv=-01/000000002}', "");
    Expect(1, 3891, '\P{^Is_Nv=-01/000000002}', "");
    Expect(0, 3892, '\p{Is_Nv=-01/000000002}', "");
    Expect(1, 3892, '\p{^Is_Nv=-01/000000002}', "");
    Expect(1, 3892, '\P{Is_Nv=-01/000000002}', "");
    Expect(0, 3892, '\P{^Is_Nv=-01/000000002}', "");
    Expect(1, 3891, '\p{Is_Nv=-60/120}', "");
    Expect(0, 3891, '\p{^Is_Nv=-60/120}', "");
    Expect(0, 3891, '\P{Is_Nv=-60/120}', "");
    Expect(1, 3891, '\P{^Is_Nv=-60/120}', "");
    Expect(0, 3892, '\p{Is_Nv=-60/120}', "");
    Expect(1, 3892, '\p{^Is_Nv=-60/120}', "");
    Expect(1, 3892, '\P{Is_Nv=-60/120}', "");
    Expect(0, 3892, '\P{^Is_Nv=-60/120}', "");
    Expect(1, 3891, '\p{Is_Nv=-5.0e-01}', "");
    Expect(0, 3891, '\p{^Is_Nv=-5.0e-01}', "");
    Expect(0, 3891, '\P{Is_Nv=-5.0e-01}', "");
    Expect(1, 3891, '\P{^Is_Nv=-5.0e-01}', "");
    Expect(0, 3892, '\p{Is_Nv=-5.0e-01}', "");
    Expect(1, 3892, '\p{^Is_Nv=-5.0e-01}', "");
    Expect(1, 3892, '\P{Is_Nv=-5.0e-01}', "");
    Expect(0, 3892, '\P{^Is_Nv=-5.0e-01}', "");
    Expect(1, 3891, '\p{Is_Nv=-0.5}', "");
    Expect(0, 3891, '\p{^Is_Nv=-0.5}', "");
    Expect(0, 3891, '\P{Is_Nv=-0.5}', "");
    Expect(1, 3891, '\P{^Is_Nv=-0.5}', "");
    Expect(0, 3892, '\p{Is_Nv=-0.5}', "");
    Expect(1, 3892, '\p{^Is_Nv=-0.5}', "");
    Expect(1, 3892, '\P{Is_Nv=-0.5}', "");
    Expect(0, 3892, '\P{^Is_Nv=-0.5}', "");
    Expect(1, 3891, '\p{Is_Nv=-5.00e-01}', "");
    Expect(0, 3891, '\p{^Is_Nv=-5.00e-01}', "");
    Expect(0, 3891, '\P{Is_Nv=-5.00e-01}', "");
    Expect(1, 3891, '\P{^Is_Nv=-5.00e-01}', "");
    Expect(0, 3892, '\p{Is_Nv=-5.00e-01}', "");
    Expect(1, 3892, '\p{^Is_Nv=-5.00e-01}', "");
    Expect(1, 3892, '\P{Is_Nv=-5.00e-01}', "");
    Expect(0, 3892, '\P{^Is_Nv=-5.00e-01}', "");
    Expect(1, 3891, '\p{Is_Nv=-0.50}', "");
    Expect(0, 3891, '\p{^Is_Nv=-0.50}', "");
    Expect(0, 3891, '\P{Is_Nv=-0.50}', "");
    Expect(1, 3891, '\P{^Is_Nv=-0.50}', "");
    Expect(0, 3892, '\p{Is_Nv=-0.50}', "");
    Expect(1, 3892, '\p{^Is_Nv=-0.50}', "");
    Expect(1, 3892, '\P{Is_Nv=-0.50}', "");
    Expect(0, 3892, '\P{^Is_Nv=-0.50}', "");
    Error('\p{Numeric_Value=/a/0_0_0_0_00}');
    Error('\P{Numeric_Value=/a/0_0_0_0_00}');
    Expect(1, 127244, '\p{Numeric_Value=:\A0\z:}', "");;
    Expect(0, 127245, '\p{Numeric_Value=:\A0\z:}', "");;
    Expect(1, 127244, '\p{Numeric_Value=0}', "");
    Expect(0, 127244, '\p{^Numeric_Value=0}', "");
    Expect(0, 127244, '\P{Numeric_Value=0}', "");
    Expect(1, 127244, '\P{^Numeric_Value=0}', "");
    Expect(0, 127245, '\p{Numeric_Value=0}', "");
    Expect(1, 127245, '\p{^Numeric_Value=0}', "");
    Expect(1, 127245, '\P{Numeric_Value=0}', "");
    Expect(0, 127245, '\P{^Numeric_Value=0}', "");
    Expect(1, 127244, '\p{Numeric_Value=0.000000000000000e+00}', "");
    Expect(0, 127244, '\p{^Numeric_Value=0.000000000000000e+00}', "");
    Expect(0, 127244, '\P{Numeric_Value=0.000000000000000e+00}', "");
    Expect(1, 127244, '\P{^Numeric_Value=0.000000000000000e+00}', "");
    Expect(0, 127245, '\p{Numeric_Value=0.000000000000000e+00}', "");
    Expect(1, 127245, '\p{^Numeric_Value=0.000000000000000e+00}', "");
    Expect(1, 127245, '\P{Numeric_Value=0.000000000000000e+00}', "");
    Expect(0, 127245, '\P{^Numeric_Value=0.000000000000000e+00}', "");
    Error('\p{Nv=	/a/+0_0_00}');
    Error('\P{Nv=	/a/+0_0_00}');
    Expect(1, 127244, '\p{Nv=:\A0\z:}', "");;
    Expect(0, 127245, '\p{Nv=:\A0\z:}', "");;
    Expect(1, 127244, '\p{Nv=0000}', "");
    Expect(0, 127244, '\p{^Nv=0000}', "");
    Expect(0, 127244, '\P{Nv=0000}', "");
    Expect(1, 127244, '\P{^Nv=0000}', "");
    Expect(0, 127245, '\p{Nv=0000}', "");
    Expect(1, 127245, '\p{^Nv=0000}', "");
    Expect(1, 127245, '\P{Nv=0000}', "");
    Expect(0, 127245, '\P{^Nv=0000}', "");
    Expect(1, 127244, '\p{Nv=0.000000000000000e+00}', "");
    Expect(0, 127244, '\p{^Nv=0.000000000000000e+00}', "");
    Expect(0, 127244, '\P{Nv=0.000000000000000e+00}', "");
    Expect(1, 127244, '\P{^Nv=0.000000000000000e+00}', "");
    Expect(0, 127245, '\p{Nv=0.000000000000000e+00}', "");
    Expect(1, 127245, '\p{^Nv=0.000000000000000e+00}', "");
    Expect(1, 127245, '\P{Nv=0.000000000000000e+00}', "");
    Expect(0, 127245, '\P{^Nv=0.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value=_0_0_0_000/a/}');
    Error('\P{Is_Numeric_Value=_0_0_0_000/a/}');
    Expect(1, 127244, '\p{Is_Numeric_Value=000000}', "");
    Expect(0, 127244, '\p{^Is_Numeric_Value=000000}', "");
    Expect(0, 127244, '\P{Is_Numeric_Value=000000}', "");
    Expect(1, 127244, '\P{^Is_Numeric_Value=000000}', "");
    Expect(0, 127245, '\p{Is_Numeric_Value=000000}', "");
    Expect(1, 127245, '\p{^Is_Numeric_Value=000000}', "");
    Expect(1, 127245, '\P{Is_Numeric_Value=000000}', "");
    Expect(0, 127245, '\P{^Is_Numeric_Value=000000}', "");
    Expect(1, 127244, '\p{Is_Numeric_Value=0.000000000000000e+00}', "");
    Expect(0, 127244, '\p{^Is_Numeric_Value=0.000000000000000e+00}', "");
    Expect(0, 127244, '\P{Is_Numeric_Value=0.000000000000000e+00}', "");
    Expect(1, 127244, '\P{^Is_Numeric_Value=0.000000000000000e+00}', "");
    Expect(0, 127245, '\p{Is_Numeric_Value=0.000000000000000e+00}', "");
    Expect(1, 127245, '\p{^Is_Numeric_Value=0.000000000000000e+00}', "");
    Expect(1, 127245, '\P{Is_Numeric_Value=0.000000000000000e+00}', "");
    Expect(0, 127245, '\P{^Is_Numeric_Value=0.000000000000000e+00}', "");
    Error('\p{Is_Nv=/a/000000}');
    Error('\P{Is_Nv=/a/000000}');
    Expect(1, 127244, '\p{Is_Nv=0_0_0_0_0_000}', "");
    Expect(0, 127244, '\p{^Is_Nv=0_0_0_0_0_000}', "");
    Expect(0, 127244, '\P{Is_Nv=0_0_0_0_0_000}', "");
    Expect(1, 127244, '\P{^Is_Nv=0_0_0_0_0_000}', "");
    Expect(0, 127245, '\p{Is_Nv=0_0_0_0_0_000}', "");
    Expect(1, 127245, '\p{^Is_Nv=0_0_0_0_0_000}', "");
    Expect(1, 127245, '\P{Is_Nv=0_0_0_0_0_000}', "");
    Expect(0, 127245, '\P{^Is_Nv=0_0_0_0_0_000}', "");
    Expect(1, 127244, '\p{Is_Nv: 0.000000000000000e+00}', "");
    Expect(0, 127244, '\p{^Is_Nv: 0.000000000000000e+00}', "");
    Expect(0, 127244, '\P{Is_Nv: 0.000000000000000e+00}', "");
    Expect(1, 127244, '\P{^Is_Nv: 0.000000000000000e+00}', "");
    Expect(0, 127245, '\p{Is_Nv: 0.000000000000000e+00}', "");
    Expect(1, 127245, '\p{^Is_Nv: 0.000000000000000e+00}', "");
    Expect(1, 127245, '\P{Is_Nv: 0.000000000000000e+00}', "");
    Expect(0, 127245, '\P{^Is_Nv: 0.000000000000000e+00}', "");
    Error('\p{Numeric_Value:	-0_0_0_0_0_001:=}');
    Error('\P{Numeric_Value:	-0_0_0_0_0_001:=}');
    Expect(1, 133418, '\p{Numeric_Value=:\A1\z:}', "");;
    Expect(0, 133419, '\p{Numeric_Value=:\A1\z:}', "");;
    Expect(1, 133418, '\p{Numeric_Value=00001}', "");
    Expect(0, 133418, '\p{^Numeric_Value=00001}', "");
    Expect(0, 133418, '\P{Numeric_Value=00001}', "");
    Expect(1, 133418, '\P{^Numeric_Value=00001}', "");
    Expect(0, 133419, '\p{Numeric_Value=00001}', "");
    Expect(1, 133419, '\p{^Numeric_Value=00001}', "");
    Expect(1, 133419, '\P{Numeric_Value=00001}', "");
    Expect(0, 133419, '\P{^Numeric_Value=00001}', "");
    Expect(1, 133418, '\p{Numeric_Value=1.000000000000000e+00}', "");
    Expect(0, 133418, '\p{^Numeric_Value=1.000000000000000e+00}', "");
    Expect(0, 133418, '\P{Numeric_Value=1.000000000000000e+00}', "");
    Expect(1, 133418, '\P{^Numeric_Value=1.000000000000000e+00}', "");
    Expect(0, 133419, '\p{Numeric_Value=1.000000000000000e+00}', "");
    Expect(1, 133419, '\p{^Numeric_Value=1.000000000000000e+00}', "");
    Expect(1, 133419, '\P{Numeric_Value=1.000000000000000e+00}', "");
    Expect(0, 133419, '\P{^Numeric_Value=1.000000000000000e+00}', "");
    Error('\p{Nv=_:=0_0_01}');
    Error('\P{Nv=_:=0_0_01}');
    Expect(1, 133418, '\p{Nv=:\A1\z:}', "");;
    Expect(0, 133419, '\p{Nv=:\A1\z:}', "");;
    Expect(1, 133418, '\p{Nv=0_0_0_0_0_0_0_0_01}', "");
    Expect(0, 133418, '\p{^Nv=0_0_0_0_0_0_0_0_01}', "");
    Expect(0, 133418, '\P{Nv=0_0_0_0_0_0_0_0_01}', "");
    Expect(1, 133418, '\P{^Nv=0_0_0_0_0_0_0_0_01}', "");
    Expect(0, 133419, '\p{Nv=0_0_0_0_0_0_0_0_01}', "");
    Expect(1, 133419, '\p{^Nv=0_0_0_0_0_0_0_0_01}', "");
    Expect(1, 133419, '\P{Nv=0_0_0_0_0_0_0_0_01}', "");
    Expect(0, 133419, '\P{^Nv=0_0_0_0_0_0_0_0_01}', "");
    Expect(1, 133418, '\p{Nv=1.000000000000000e+00}', "");
    Expect(0, 133418, '\p{^Nv=1.000000000000000e+00}', "");
    Expect(0, 133418, '\P{Nv=1.000000000000000e+00}', "");
    Expect(1, 133418, '\P{^Nv=1.000000000000000e+00}', "");
    Expect(0, 133419, '\p{Nv=1.000000000000000e+00}', "");
    Expect(1, 133419, '\p{^Nv=1.000000000000000e+00}', "");
    Expect(1, 133419, '\P{Nv=1.000000000000000e+00}', "");
    Expect(0, 133419, '\P{^Nv=1.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value=:=1}');
    Error('\P{Is_Numeric_Value=:=1}');
    Expect(1, 133418, '\p{Is_Numeric_Value:	0_0_0_01}', "");
    Expect(0, 133418, '\p{^Is_Numeric_Value:	0_0_0_01}', "");
    Expect(0, 133418, '\P{Is_Numeric_Value:	0_0_0_01}', "");
    Expect(1, 133418, '\P{^Is_Numeric_Value:	0_0_0_01}', "");
    Expect(0, 133419, '\p{Is_Numeric_Value:	0_0_0_01}', "");
    Expect(1, 133419, '\p{^Is_Numeric_Value:	0_0_0_01}', "");
    Expect(1, 133419, '\P{Is_Numeric_Value:	0_0_0_01}', "");
    Expect(0, 133419, '\P{^Is_Numeric_Value:	0_0_0_01}', "");
    Expect(1, 133418, '\p{Is_Numeric_Value=1.000000000000000e+00}', "");
    Expect(0, 133418, '\p{^Is_Numeric_Value=1.000000000000000e+00}', "");
    Expect(0, 133418, '\P{Is_Numeric_Value=1.000000000000000e+00}', "");
    Expect(1, 133418, '\P{^Is_Numeric_Value=1.000000000000000e+00}', "");
    Expect(0, 133419, '\p{Is_Numeric_Value=1.000000000000000e+00}', "");
    Expect(1, 133419, '\p{^Is_Numeric_Value=1.000000000000000e+00}', "");
    Expect(1, 133419, '\P{Is_Numeric_Value=1.000000000000000e+00}', "");
    Expect(0, 133419, '\P{^Is_Numeric_Value=1.000000000000000e+00}', "");
    Error('\p{Is_Nv=000000001/a/}');
    Error('\P{Is_Nv=000000001/a/}');
    Expect(1, 133418, '\p{Is_Nv=1}', "");
    Expect(0, 133418, '\p{^Is_Nv=1}', "");
    Expect(0, 133418, '\P{Is_Nv=1}', "");
    Expect(1, 133418, '\P{^Is_Nv=1}', "");
    Expect(0, 133419, '\p{Is_Nv=1}', "");
    Expect(1, 133419, '\p{^Is_Nv=1}', "");
    Expect(1, 133419, '\P{Is_Nv=1}', "");
    Expect(0, 133419, '\P{^Is_Nv=1}', "");
    Expect(1, 133418, '\p{Is_Nv=1.000000000000000e+00}', "");
    Expect(0, 133418, '\p{^Is_Nv=1.000000000000000e+00}', "");
    Expect(0, 133418, '\P{Is_Nv=1.000000000000000e+00}', "");
    Expect(1, 133418, '\P{^Is_Nv=1.000000000000000e+00}', "");
    Expect(0, 133419, '\p{Is_Nv=1.000000000000000e+00}', "");
    Expect(1, 133419, '\p{^Is_Nv=1.000000000000000e+00}', "");
    Expect(1, 133419, '\P{Is_Nv=1.000000000000000e+00}', "");
    Expect(0, 133419, '\P{^Is_Nv=1.000000000000000e+00}', "");
    Error('\p{Numeric_Value=:=_	00000001/10}');
    Error('\P{Numeric_Value=:=_	00000001/10}');
    Expect(1, 73675, '\p{Numeric_Value=:\A1/10\z:}', "");;
    Expect(0, 73676, '\p{Numeric_Value=:\A1/10\z:}', "");;
    Expect(1, 73675, '\p{Numeric_Value=000000001/10}', "");
    Expect(0, 73675, '\p{^Numeric_Value=000000001/10}', "");
    Expect(0, 73675, '\P{Numeric_Value=000000001/10}', "");
    Expect(1, 73675, '\P{^Numeric_Value=000000001/10}', "");
    Expect(0, 73676, '\p{Numeric_Value=000000001/10}', "");
    Expect(1, 73676, '\p{^Numeric_Value=000000001/10}', "");
    Expect(1, 73676, '\P{Numeric_Value=000000001/10}', "");
    Expect(0, 73676, '\P{^Numeric_Value=000000001/10}', "");
    Expect(1, 73675, '\p{Numeric_Value=60/600}', "");
    Expect(0, 73675, '\p{^Numeric_Value=60/600}', "");
    Expect(0, 73675, '\P{Numeric_Value=60/600}', "");
    Expect(1, 73675, '\P{^Numeric_Value=60/600}', "");
    Expect(0, 73676, '\p{Numeric_Value=60/600}', "");
    Expect(1, 73676, '\p{^Numeric_Value=60/600}', "");
    Expect(1, 73676, '\P{Numeric_Value=60/600}', "");
    Expect(0, 73676, '\P{^Numeric_Value=60/600}', "");
    Expect(1, 73675, '\p{Numeric_Value=1.0e-01}', "");
    Expect(0, 73675, '\p{^Numeric_Value=1.0e-01}', "");
    Expect(0, 73675, '\P{Numeric_Value=1.0e-01}', "");
    Expect(1, 73675, '\P{^Numeric_Value=1.0e-01}', "");
    Expect(0, 73676, '\p{Numeric_Value=1.0e-01}', "");
    Expect(1, 73676, '\p{^Numeric_Value=1.0e-01}', "");
    Expect(1, 73676, '\P{Numeric_Value=1.0e-01}', "");
    Expect(0, 73676, '\P{^Numeric_Value=1.0e-01}', "");
    Expect(1, 73675, '\p{Numeric_Value=0.1}', "");
    Expect(0, 73675, '\p{^Numeric_Value=0.1}', "");
    Expect(0, 73675, '\P{Numeric_Value=0.1}', "");
    Expect(1, 73675, '\P{^Numeric_Value=0.1}', "");
    Expect(0, 73676, '\p{Numeric_Value=0.1}', "");
    Expect(1, 73676, '\p{^Numeric_Value=0.1}', "");
    Expect(1, 73676, '\P{Numeric_Value=0.1}', "");
    Expect(0, 73676, '\P{^Numeric_Value=0.1}', "");
    Expect(1, 73675, '\p{Numeric_Value:	1.00e-01}', "");
    Expect(0, 73675, '\p{^Numeric_Value:	1.00e-01}', "");
    Expect(0, 73675, '\P{Numeric_Value:	1.00e-01}', "");
    Expect(1, 73675, '\P{^Numeric_Value:	1.00e-01}', "");
    Expect(0, 73676, '\p{Numeric_Value:	1.00e-01}', "");
    Expect(1, 73676, '\p{^Numeric_Value:	1.00e-01}', "");
    Expect(1, 73676, '\P{Numeric_Value:	1.00e-01}', "");
    Expect(0, 73676, '\P{^Numeric_Value:	1.00e-01}', "");
    Expect(1, 73675, '\p{Numeric_Value: 0.10}', "");
    Expect(0, 73675, '\p{^Numeric_Value: 0.10}', "");
    Expect(0, 73675, '\P{Numeric_Value: 0.10}', "");
    Expect(1, 73675, '\P{^Numeric_Value: 0.10}', "");
    Expect(0, 73676, '\p{Numeric_Value: 0.10}', "");
    Expect(1, 73676, '\p{^Numeric_Value: 0.10}', "");
    Expect(1, 73676, '\P{Numeric_Value: 0.10}', "");
    Expect(0, 73676, '\P{^Numeric_Value: 0.10}', "");
    Error('\p{Nv::= 00001/010}');
    Error('\P{Nv::= 00001/010}');
    Expect(1, 73675, '\p{Nv=:\A1/10\z:}', "");;
    Expect(0, 73676, '\p{Nv=:\A1/10\z:}', "");;
    Expect(1, 73675, '\p{Nv:   0000001/000000010}', "");
    Expect(0, 73675, '\p{^Nv:   0000001/000000010}', "");
    Expect(0, 73675, '\P{Nv:   0000001/000000010}', "");
    Expect(1, 73675, '\P{^Nv:   0000001/000000010}', "");
    Expect(0, 73676, '\p{Nv:   0000001/000000010}', "");
    Expect(1, 73676, '\p{^Nv:   0000001/000000010}', "");
    Expect(1, 73676, '\P{Nv:   0000001/000000010}', "");
    Expect(0, 73676, '\P{^Nv:   0000001/000000010}', "");
    Expect(1, 73675, '\p{Nv=60/600}', "");
    Expect(0, 73675, '\p{^Nv=60/600}', "");
    Expect(0, 73675, '\P{Nv=60/600}', "");
    Expect(1, 73675, '\P{^Nv=60/600}', "");
    Expect(0, 73676, '\p{Nv=60/600}', "");
    Expect(1, 73676, '\p{^Nv=60/600}', "");
    Expect(1, 73676, '\P{Nv=60/600}', "");
    Expect(0, 73676, '\P{^Nv=60/600}', "");
    Expect(1, 73675, '\p{Nv=1.0e-01}', "");
    Expect(0, 73675, '\p{^Nv=1.0e-01}', "");
    Expect(0, 73675, '\P{Nv=1.0e-01}', "");
    Expect(1, 73675, '\P{^Nv=1.0e-01}', "");
    Expect(0, 73676, '\p{Nv=1.0e-01}', "");
    Expect(1, 73676, '\p{^Nv=1.0e-01}', "");
    Expect(1, 73676, '\P{Nv=1.0e-01}', "");
    Expect(0, 73676, '\P{^Nv=1.0e-01}', "");
    Expect(1, 73675, '\p{Nv=0.1}', "");
    Expect(0, 73675, '\p{^Nv=0.1}', "");
    Expect(0, 73675, '\P{Nv=0.1}', "");
    Expect(1, 73675, '\P{^Nv=0.1}', "");
    Expect(0, 73676, '\p{Nv=0.1}', "");
    Expect(1, 73676, '\p{^Nv=0.1}', "");
    Expect(1, 73676, '\P{Nv=0.1}', "");
    Expect(0, 73676, '\P{^Nv=0.1}', "");
    Expect(1, 73675, '\p{Nv=1.00e-01}', "");
    Expect(0, 73675, '\p{^Nv=1.00e-01}', "");
    Expect(0, 73675, '\P{Nv=1.00e-01}', "");
    Expect(1, 73675, '\P{^Nv=1.00e-01}', "");
    Expect(0, 73676, '\p{Nv=1.00e-01}', "");
    Expect(1, 73676, '\p{^Nv=1.00e-01}', "");
    Expect(1, 73676, '\P{Nv=1.00e-01}', "");
    Expect(0, 73676, '\P{^Nv=1.00e-01}', "");
    Expect(1, 73675, '\p{Nv:0.10}', "");
    Expect(0, 73675, '\p{^Nv:0.10}', "");
    Expect(0, 73675, '\P{Nv:0.10}', "");
    Expect(1, 73675, '\P{^Nv:0.10}', "");
    Expect(0, 73676, '\p{Nv:0.10}', "");
    Expect(1, 73676, '\p{^Nv:0.10}', "");
    Expect(1, 73676, '\P{Nv:0.10}', "");
    Expect(0, 73676, '\P{^Nv:0.10}', "");
    Error('\p{Is_Numeric_Value::=	0000000001/000000010}');
    Error('\P{Is_Numeric_Value::=	0000000001/000000010}');
    Expect(1, 73675, '\p{Is_Numeric_Value=0000000001/00010}', "");
    Expect(0, 73675, '\p{^Is_Numeric_Value=0000000001/00010}', "");
    Expect(0, 73675, '\P{Is_Numeric_Value=0000000001/00010}', "");
    Expect(1, 73675, '\P{^Is_Numeric_Value=0000000001/00010}', "");
    Expect(0, 73676, '\p{Is_Numeric_Value=0000000001/00010}', "");
    Expect(1, 73676, '\p{^Is_Numeric_Value=0000000001/00010}', "");
    Expect(1, 73676, '\P{Is_Numeric_Value=0000000001/00010}', "");
    Expect(0, 73676, '\P{^Is_Numeric_Value=0000000001/00010}', "");
    Expect(1, 73675, '\p{Is_Numeric_Value=60/600}', "");
    Expect(0, 73675, '\p{^Is_Numeric_Value=60/600}', "");
    Expect(0, 73675, '\P{Is_Numeric_Value=60/600}', "");
    Expect(1, 73675, '\P{^Is_Numeric_Value=60/600}', "");
    Expect(0, 73676, '\p{Is_Numeric_Value=60/600}', "");
    Expect(1, 73676, '\p{^Is_Numeric_Value=60/600}', "");
    Expect(1, 73676, '\P{Is_Numeric_Value=60/600}', "");
    Expect(0, 73676, '\P{^Is_Numeric_Value=60/600}', "");
    Expect(1, 73675, '\p{Is_Numeric_Value=1.0e-01}', "");
    Expect(0, 73675, '\p{^Is_Numeric_Value=1.0e-01}', "");
    Expect(0, 73675, '\P{Is_Numeric_Value=1.0e-01}', "");
    Expect(1, 73675, '\P{^Is_Numeric_Value=1.0e-01}', "");
    Expect(0, 73676, '\p{Is_Numeric_Value=1.0e-01}', "");
    Expect(1, 73676, '\p{^Is_Numeric_Value=1.0e-01}', "");
    Expect(1, 73676, '\P{Is_Numeric_Value=1.0e-01}', "");
    Expect(0, 73676, '\P{^Is_Numeric_Value=1.0e-01}', "");
    Expect(1, 73675, '\p{Is_Numeric_Value=0.1}', "");
    Expect(0, 73675, '\p{^Is_Numeric_Value=0.1}', "");
    Expect(0, 73675, '\P{Is_Numeric_Value=0.1}', "");
    Expect(1, 73675, '\P{^Is_Numeric_Value=0.1}', "");
    Expect(0, 73676, '\p{Is_Numeric_Value=0.1}', "");
    Expect(1, 73676, '\p{^Is_Numeric_Value=0.1}', "");
    Expect(1, 73676, '\P{Is_Numeric_Value=0.1}', "");
    Expect(0, 73676, '\P{^Is_Numeric_Value=0.1}', "");
    Expect(1, 73675, '\p{Is_Numeric_Value=1.00e-01}', "");
    Expect(0, 73675, '\p{^Is_Numeric_Value=1.00e-01}', "");
    Expect(0, 73675, '\P{Is_Numeric_Value=1.00e-01}', "");
    Expect(1, 73675, '\P{^Is_Numeric_Value=1.00e-01}', "");
    Expect(0, 73676, '\p{Is_Numeric_Value=1.00e-01}', "");
    Expect(1, 73676, '\p{^Is_Numeric_Value=1.00e-01}', "");
    Expect(1, 73676, '\P{Is_Numeric_Value=1.00e-01}', "");
    Expect(0, 73676, '\P{^Is_Numeric_Value=1.00e-01}', "");
    Expect(1, 73675, '\p{Is_Numeric_Value=0.10}', "");
    Expect(0, 73675, '\p{^Is_Numeric_Value=0.10}', "");
    Expect(0, 73675, '\P{Is_Numeric_Value=0.10}', "");
    Expect(1, 73675, '\P{^Is_Numeric_Value=0.10}', "");
    Expect(0, 73676, '\p{Is_Numeric_Value=0.10}', "");
    Expect(1, 73676, '\p{^Is_Numeric_Value=0.10}', "");
    Expect(1, 73676, '\P{Is_Numeric_Value=0.10}', "");
    Expect(0, 73676, '\P{^Is_Numeric_Value=0.10}', "");
    Error('\p{Is_Nv=:=_ 0000000001/010}');
    Error('\P{Is_Nv=:=_ 0000000001/010}');
    Expect(1, 73675, '\p{Is_Nv:   00001/000010}', "");
    Expect(0, 73675, '\p{^Is_Nv:   00001/000010}', "");
    Expect(0, 73675, '\P{Is_Nv:   00001/000010}', "");
    Expect(1, 73675, '\P{^Is_Nv:   00001/000010}', "");
    Expect(0, 73676, '\p{Is_Nv:   00001/000010}', "");
    Expect(1, 73676, '\p{^Is_Nv:   00001/000010}', "");
    Expect(1, 73676, '\P{Is_Nv:   00001/000010}', "");
    Expect(0, 73676, '\P{^Is_Nv:   00001/000010}', "");
    Expect(1, 73675, '\p{Is_Nv=60/600}', "");
    Expect(0, 73675, '\p{^Is_Nv=60/600}', "");
    Expect(0, 73675, '\P{Is_Nv=60/600}', "");
    Expect(1, 73675, '\P{^Is_Nv=60/600}', "");
    Expect(0, 73676, '\p{Is_Nv=60/600}', "");
    Expect(1, 73676, '\p{^Is_Nv=60/600}', "");
    Expect(1, 73676, '\P{Is_Nv=60/600}', "");
    Expect(0, 73676, '\P{^Is_Nv=60/600}', "");
    Expect(1, 73675, '\p{Is_Nv: 1.0e-01}', "");
    Expect(0, 73675, '\p{^Is_Nv: 1.0e-01}', "");
    Expect(0, 73675, '\P{Is_Nv: 1.0e-01}', "");
    Expect(1, 73675, '\P{^Is_Nv: 1.0e-01}', "");
    Expect(0, 73676, '\p{Is_Nv: 1.0e-01}', "");
    Expect(1, 73676, '\p{^Is_Nv: 1.0e-01}', "");
    Expect(1, 73676, '\P{Is_Nv: 1.0e-01}', "");
    Expect(0, 73676, '\P{^Is_Nv: 1.0e-01}', "");
    Expect(1, 73675, '\p{Is_Nv=0.1}', "");
    Expect(0, 73675, '\p{^Is_Nv=0.1}', "");
    Expect(0, 73675, '\P{Is_Nv=0.1}', "");
    Expect(1, 73675, '\P{^Is_Nv=0.1}', "");
    Expect(0, 73676, '\p{Is_Nv=0.1}', "");
    Expect(1, 73676, '\p{^Is_Nv=0.1}', "");
    Expect(1, 73676, '\P{Is_Nv=0.1}', "");
    Expect(0, 73676, '\P{^Is_Nv=0.1}', "");
    Expect(1, 73675, '\p{Is_Nv:1.00e-01}', "");
    Expect(0, 73675, '\p{^Is_Nv:1.00e-01}', "");
    Expect(0, 73675, '\P{Is_Nv:1.00e-01}', "");
    Expect(1, 73675, '\P{^Is_Nv:1.00e-01}', "");
    Expect(0, 73676, '\p{Is_Nv:1.00e-01}', "");
    Expect(1, 73676, '\p{^Is_Nv:1.00e-01}', "");
    Expect(1, 73676, '\P{Is_Nv:1.00e-01}', "");
    Expect(0, 73676, '\P{^Is_Nv:1.00e-01}', "");
    Expect(1, 73675, '\p{Is_Nv=0.10}', "");
    Expect(0, 73675, '\p{^Is_Nv=0.10}', "");
    Expect(0, 73675, '\P{Is_Nv=0.10}', "");
    Expect(1, 73675, '\P{^Is_Nv=0.10}', "");
    Expect(0, 73676, '\p{Is_Nv=0.10}', "");
    Expect(1, 73676, '\p{^Is_Nv=0.10}', "");
    Expect(1, 73676, '\P{Is_Nv=0.10}', "");
    Expect(0, 73676, '\P{^Is_Nv=0.10}', "");
    Error('\p{Numeric_Value=/a/ _00000001/00000000012}');
    Error('\P{Numeric_Value=/a/ _00000001/00000000012}');
    Expect(1, 68086, '\p{Numeric_Value=:\A1/12\z:}', "");;
    Expect(0, 68087, '\p{Numeric_Value=:\A1/12\z:}', "");;
    Expect(1, 68086, '\p{Numeric_Value:	0001/0000000012}', "");
    Expect(0, 68086, '\p{^Numeric_Value:	0001/0000000012}', "");
    Expect(0, 68086, '\P{Numeric_Value:	0001/0000000012}', "");
    Expect(1, 68086, '\P{^Numeric_Value:	0001/0000000012}', "");
    Expect(0, 68087, '\p{Numeric_Value:	0001/0000000012}', "");
    Expect(1, 68087, '\p{^Numeric_Value:	0001/0000000012}', "");
    Expect(1, 68087, '\P{Numeric_Value:	0001/0000000012}', "");
    Expect(0, 68087, '\P{^Numeric_Value:	0001/0000000012}', "");
    Expect(1, 68086, '\p{Numeric_Value=60/720}', "");
    Expect(0, 68086, '\p{^Numeric_Value=60/720}', "");
    Expect(0, 68086, '\P{Numeric_Value=60/720}', "");
    Expect(1, 68086, '\P{^Numeric_Value=60/720}', "");
    Expect(0, 68087, '\p{Numeric_Value=60/720}', "");
    Expect(1, 68087, '\p{^Numeric_Value=60/720}', "");
    Expect(1, 68087, '\P{Numeric_Value=60/720}', "");
    Expect(0, 68087, '\P{^Numeric_Value=60/720}', "");
    Error('\p{Numeric_Value:	8.3e-02}');
    Error('\P{Numeric_Value:	8.3e-02}');
    Expect(1, 68086, '\p{Numeric_Value=8.33e-02}', "");
    Expect(0, 68086, '\p{^Numeric_Value=8.33e-02}', "");
    Expect(0, 68086, '\P{Numeric_Value=8.33e-02}', "");
    Expect(1, 68086, '\P{^Numeric_Value=8.33e-02}', "");
    Expect(0, 68087, '\p{Numeric_Value=8.33e-02}', "");
    Expect(1, 68087, '\p{^Numeric_Value=8.33e-02}', "");
    Expect(1, 68087, '\P{Numeric_Value=8.33e-02}', "");
    Expect(0, 68087, '\P{^Numeric_Value=8.33e-02}', "");
    Error('\p{Numeric_Value=0.08}');
    Error('\P{Numeric_Value=0.08}');
    Expect(1, 68086, '\p{Numeric_Value=8.333e-02}', "");
    Expect(0, 68086, '\p{^Numeric_Value=8.333e-02}', "");
    Expect(0, 68086, '\P{Numeric_Value=8.333e-02}', "");
    Expect(1, 68086, '\P{^Numeric_Value=8.333e-02}', "");
    Expect(0, 68087, '\p{Numeric_Value=8.333e-02}', "");
    Expect(1, 68087, '\p{^Numeric_Value=8.333e-02}', "");
    Expect(1, 68087, '\P{Numeric_Value=8.333e-02}', "");
    Expect(0, 68087, '\P{^Numeric_Value=8.333e-02}', "");
    Error('\p{Numeric_Value=0.083}');
    Error('\P{Numeric_Value=0.083}');
    Expect(1, 68086, '\p{Numeric_Value=8.3333e-02}', "");
    Expect(0, 68086, '\p{^Numeric_Value=8.3333e-02}', "");
    Expect(0, 68086, '\P{Numeric_Value=8.3333e-02}', "");
    Expect(1, 68086, '\P{^Numeric_Value=8.3333e-02}', "");
    Expect(0, 68087, '\p{Numeric_Value=8.3333e-02}', "");
    Expect(1, 68087, '\p{^Numeric_Value=8.3333e-02}', "");
    Expect(1, 68087, '\P{Numeric_Value=8.3333e-02}', "");
    Expect(0, 68087, '\P{^Numeric_Value=8.3333e-02}', "");
    Expect(1, 68086, '\p{Numeric_Value: 0.0833}', "");
    Expect(0, 68086, '\p{^Numeric_Value: 0.0833}', "");
    Expect(0, 68086, '\P{Numeric_Value: 0.0833}', "");
    Expect(1, 68086, '\P{^Numeric_Value: 0.0833}', "");
    Expect(0, 68087, '\p{Numeric_Value: 0.0833}', "");
    Expect(1, 68087, '\p{^Numeric_Value: 0.0833}', "");
    Expect(1, 68087, '\P{Numeric_Value: 0.0833}', "");
    Expect(0, 68087, '\P{^Numeric_Value: 0.0833}', "");
    Expect(1, 68086, '\p{Numeric_Value=8.33333e-02}', "");
    Expect(0, 68086, '\p{^Numeric_Value=8.33333e-02}', "");
    Expect(0, 68086, '\P{Numeric_Value=8.33333e-02}', "");
    Expect(1, 68086, '\P{^Numeric_Value=8.33333e-02}', "");
    Expect(0, 68087, '\p{Numeric_Value=8.33333e-02}', "");
    Expect(1, 68087, '\p{^Numeric_Value=8.33333e-02}', "");
    Expect(1, 68087, '\P{Numeric_Value=8.33333e-02}', "");
    Expect(0, 68087, '\P{^Numeric_Value=8.33333e-02}', "");
    Expect(1, 68086, '\p{Numeric_Value=0.08333}', "");
    Expect(0, 68086, '\p{^Numeric_Value=0.08333}', "");
    Expect(0, 68086, '\P{Numeric_Value=0.08333}', "");
    Expect(1, 68086, '\P{^Numeric_Value=0.08333}', "");
    Expect(0, 68087, '\p{Numeric_Value=0.08333}', "");
    Expect(1, 68087, '\p{^Numeric_Value=0.08333}', "");
    Expect(1, 68087, '\P{Numeric_Value=0.08333}', "");
    Expect(0, 68087, '\P{^Numeric_Value=0.08333}', "");
    Error('\p{Nv=:=__00001/00000000012}');
    Error('\P{Nv=:=__00001/00000000012}');
    Expect(1, 68086, '\p{Nv=:\A1/12\z:}', "");;
    Expect(0, 68087, '\p{Nv=:\A1/12\z:}', "");;
    Expect(1, 68086, '\p{Nv=0000000001/0000000012}', "");
    Expect(0, 68086, '\p{^Nv=0000000001/0000000012}', "");
    Expect(0, 68086, '\P{Nv=0000000001/0000000012}', "");
    Expect(1, 68086, '\P{^Nv=0000000001/0000000012}', "");
    Expect(0, 68087, '\p{Nv=0000000001/0000000012}', "");
    Expect(1, 68087, '\p{^Nv=0000000001/0000000012}', "");
    Expect(1, 68087, '\P{Nv=0000000001/0000000012}', "");
    Expect(0, 68087, '\P{^Nv=0000000001/0000000012}', "");
    Expect(1, 68086, '\p{Nv=60/720}', "");
    Expect(0, 68086, '\p{^Nv=60/720}', "");
    Expect(0, 68086, '\P{Nv=60/720}', "");
    Expect(1, 68086, '\P{^Nv=60/720}', "");
    Expect(0, 68087, '\p{Nv=60/720}', "");
    Expect(1, 68087, '\p{^Nv=60/720}', "");
    Expect(1, 68087, '\P{Nv=60/720}', "");
    Expect(0, 68087, '\P{^Nv=60/720}', "");
    Error('\p{Nv=8.3e-02}');
    Error('\P{Nv=8.3e-02}');
    Expect(1, 68086, '\p{Nv:   8.33e-02}', "");
    Expect(0, 68086, '\p{^Nv:   8.33e-02}', "");
    Expect(0, 68086, '\P{Nv:   8.33e-02}', "");
    Expect(1, 68086, '\P{^Nv:   8.33e-02}', "");
    Expect(0, 68087, '\p{Nv:   8.33e-02}', "");
    Expect(1, 68087, '\p{^Nv:   8.33e-02}', "");
    Expect(1, 68087, '\P{Nv:   8.33e-02}', "");
    Expect(0, 68087, '\P{^Nv:   8.33e-02}', "");
    Error('\p{Nv=0.08}');
    Error('\P{Nv=0.08}');
    Expect(1, 68086, '\p{Nv=8.333e-02}', "");
    Expect(0, 68086, '\p{^Nv=8.333e-02}', "");
    Expect(0, 68086, '\P{Nv=8.333e-02}', "");
    Expect(1, 68086, '\P{^Nv=8.333e-02}', "");
    Expect(0, 68087, '\p{Nv=8.333e-02}', "");
    Expect(1, 68087, '\p{^Nv=8.333e-02}', "");
    Expect(1, 68087, '\P{Nv=8.333e-02}', "");
    Expect(0, 68087, '\P{^Nv=8.333e-02}', "");
    Error('\p{Nv=0.083}');
    Error('\P{Nv=0.083}');
    Expect(1, 68086, '\p{Nv=8.3333e-02}', "");
    Expect(0, 68086, '\p{^Nv=8.3333e-02}', "");
    Expect(0, 68086, '\P{Nv=8.3333e-02}', "");
    Expect(1, 68086, '\P{^Nv=8.3333e-02}', "");
    Expect(0, 68087, '\p{Nv=8.3333e-02}', "");
    Expect(1, 68087, '\p{^Nv=8.3333e-02}', "");
    Expect(1, 68087, '\P{Nv=8.3333e-02}', "");
    Expect(0, 68087, '\P{^Nv=8.3333e-02}', "");
    Expect(1, 68086, '\p{Nv=0.0833}', "");
    Expect(0, 68086, '\p{^Nv=0.0833}', "");
    Expect(0, 68086, '\P{Nv=0.0833}', "");
    Expect(1, 68086, '\P{^Nv=0.0833}', "");
    Expect(0, 68087, '\p{Nv=0.0833}', "");
    Expect(1, 68087, '\p{^Nv=0.0833}', "");
    Expect(1, 68087, '\P{Nv=0.0833}', "");
    Expect(0, 68087, '\P{^Nv=0.0833}', "");
    Expect(1, 68086, '\p{Nv=8.33333e-02}', "");
    Expect(0, 68086, '\p{^Nv=8.33333e-02}', "");
    Expect(0, 68086, '\P{Nv=8.33333e-02}', "");
    Expect(1, 68086, '\P{^Nv=8.33333e-02}', "");
    Expect(0, 68087, '\p{Nv=8.33333e-02}', "");
    Expect(1, 68087, '\p{^Nv=8.33333e-02}', "");
    Expect(1, 68087, '\P{Nv=8.33333e-02}', "");
    Expect(0, 68087, '\P{^Nv=8.33333e-02}', "");
    Expect(1, 68086, '\p{Nv=0.08333}', "");
    Expect(0, 68086, '\p{^Nv=0.08333}', "");
    Expect(0, 68086, '\P{Nv=0.08333}', "");
    Expect(1, 68086, '\P{^Nv=0.08333}', "");
    Expect(0, 68087, '\p{Nv=0.08333}', "");
    Expect(1, 68087, '\p{^Nv=0.08333}', "");
    Expect(1, 68087, '\P{Nv=0.08333}', "");
    Expect(0, 68087, '\P{^Nv=0.08333}', "");
    Error('\p{Is_Numeric_Value=  000001/000012/a/}');
    Error('\P{Is_Numeric_Value=  000001/000012/a/}');
    Expect(1, 68086, '\p{Is_Numeric_Value=+00001/12}', "");
    Expect(0, 68086, '\p{^Is_Numeric_Value=+00001/12}', "");
    Expect(0, 68086, '\P{Is_Numeric_Value=+00001/12}', "");
    Expect(1, 68086, '\P{^Is_Numeric_Value=+00001/12}', "");
    Expect(0, 68087, '\p{Is_Numeric_Value=+00001/12}', "");
    Expect(1, 68087, '\p{^Is_Numeric_Value=+00001/12}', "");
    Expect(1, 68087, '\P{Is_Numeric_Value=+00001/12}', "");
    Expect(0, 68087, '\P{^Is_Numeric_Value=+00001/12}', "");
    Expect(1, 68086, '\p{Is_Numeric_Value=60/720}', "");
    Expect(0, 68086, '\p{^Is_Numeric_Value=60/720}', "");
    Expect(0, 68086, '\P{Is_Numeric_Value=60/720}', "");
    Expect(1, 68086, '\P{^Is_Numeric_Value=60/720}', "");
    Expect(0, 68087, '\p{Is_Numeric_Value=60/720}', "");
    Expect(1, 68087, '\p{^Is_Numeric_Value=60/720}', "");
    Expect(1, 68087, '\P{Is_Numeric_Value=60/720}', "");
    Expect(0, 68087, '\P{^Is_Numeric_Value=60/720}', "");
    Error('\p{Is_Numeric_Value=8.3e-02}');
    Error('\P{Is_Numeric_Value=8.3e-02}');
    Expect(1, 68086, '\p{Is_Numeric_Value=8.33e-02}', "");
    Expect(0, 68086, '\p{^Is_Numeric_Value=8.33e-02}', "");
    Expect(0, 68086, '\P{Is_Numeric_Value=8.33e-02}', "");
    Expect(1, 68086, '\P{^Is_Numeric_Value=8.33e-02}', "");
    Expect(0, 68087, '\p{Is_Numeric_Value=8.33e-02}', "");
    Expect(1, 68087, '\p{^Is_Numeric_Value=8.33e-02}', "");
    Expect(1, 68087, '\P{Is_Numeric_Value=8.33e-02}', "");
    Expect(0, 68087, '\P{^Is_Numeric_Value=8.33e-02}', "");
    Error('\p{Is_Numeric_Value:   0.08}');
    Error('\P{Is_Numeric_Value:   0.08}');
    Expect(1, 68086, '\p{Is_Numeric_Value=8.333e-02}', "");
    Expect(0, 68086, '\p{^Is_Numeric_Value=8.333e-02}', "");
    Expect(0, 68086, '\P{Is_Numeric_Value=8.333e-02}', "");
    Expect(1, 68086, '\P{^Is_Numeric_Value=8.333e-02}', "");
    Expect(0, 68087, '\p{Is_Numeric_Value=8.333e-02}', "");
    Expect(1, 68087, '\p{^Is_Numeric_Value=8.333e-02}', "");
    Expect(1, 68087, '\P{Is_Numeric_Value=8.333e-02}', "");
    Expect(0, 68087, '\P{^Is_Numeric_Value=8.333e-02}', "");
    Error('\p{Is_Numeric_Value=0.083}');
    Error('\P{Is_Numeric_Value=0.083}');
    Expect(1, 68086, '\p{Is_Numeric_Value=8.3333e-02}', "");
    Expect(0, 68086, '\p{^Is_Numeric_Value=8.3333e-02}', "");
    Expect(0, 68086, '\P{Is_Numeric_Value=8.3333e-02}', "");
    Expect(1, 68086, '\P{^Is_Numeric_Value=8.3333e-02}', "");
    Expect(0, 68087, '\p{Is_Numeric_Value=8.3333e-02}', "");
    Expect(1, 68087, '\p{^Is_Numeric_Value=8.3333e-02}', "");
    Expect(1, 68087, '\P{Is_Numeric_Value=8.3333e-02}', "");
    Expect(0, 68087, '\P{^Is_Numeric_Value=8.3333e-02}', "");
    Expect(1, 68086, '\p{Is_Numeric_Value=0.0833}', "");
    Expect(0, 68086, '\p{^Is_Numeric_Value=0.0833}', "");
    Expect(0, 68086, '\P{Is_Numeric_Value=0.0833}', "");
    Expect(1, 68086, '\P{^Is_Numeric_Value=0.0833}', "");
    Expect(0, 68087, '\p{Is_Numeric_Value=0.0833}', "");
    Expect(1, 68087, '\p{^Is_Numeric_Value=0.0833}', "");
    Expect(1, 68087, '\P{Is_Numeric_Value=0.0833}', "");
    Expect(0, 68087, '\P{^Is_Numeric_Value=0.0833}', "");
    Expect(1, 68086, '\p{Is_Numeric_Value=8.33333e-02}', "");
    Expect(0, 68086, '\p{^Is_Numeric_Value=8.33333e-02}', "");
    Expect(0, 68086, '\P{Is_Numeric_Value=8.33333e-02}', "");
    Expect(1, 68086, '\P{^Is_Numeric_Value=8.33333e-02}', "");
    Expect(0, 68087, '\p{Is_Numeric_Value=8.33333e-02}', "");
    Expect(1, 68087, '\p{^Is_Numeric_Value=8.33333e-02}', "");
    Expect(1, 68087, '\P{Is_Numeric_Value=8.33333e-02}', "");
    Expect(0, 68087, '\P{^Is_Numeric_Value=8.33333e-02}', "");
    Expect(1, 68086, '\p{Is_Numeric_Value:   0.08333}', "");
    Expect(0, 68086, '\p{^Is_Numeric_Value:   0.08333}', "");
    Expect(0, 68086, '\P{Is_Numeric_Value:   0.08333}', "");
    Expect(1, 68086, '\P{^Is_Numeric_Value:   0.08333}', "");
    Expect(0, 68087, '\p{Is_Numeric_Value:   0.08333}', "");
    Expect(1, 68087, '\p{^Is_Numeric_Value:   0.08333}', "");
    Expect(1, 68087, '\P{Is_Numeric_Value:   0.08333}', "");
    Expect(0, 68087, '\P{^Is_Numeric_Value:   0.08333}', "");
    Error('\p{Is_Nv=	000001/012:=}');
    Error('\P{Is_Nv=	000001/012:=}');
    Expect(1, 68086, '\p{Is_Nv=1/000012}', "");
    Expect(0, 68086, '\p{^Is_Nv=1/000012}', "");
    Expect(0, 68086, '\P{Is_Nv=1/000012}', "");
    Expect(1, 68086, '\P{^Is_Nv=1/000012}', "");
    Expect(0, 68087, '\p{Is_Nv=1/000012}', "");
    Expect(1, 68087, '\p{^Is_Nv=1/000012}', "");
    Expect(1, 68087, '\P{Is_Nv=1/000012}', "");
    Expect(0, 68087, '\P{^Is_Nv=1/000012}', "");
    Expect(1, 68086, '\p{Is_Nv:	60/720}', "");
    Expect(0, 68086, '\p{^Is_Nv:	60/720}', "");
    Expect(0, 68086, '\P{Is_Nv:	60/720}', "");
    Expect(1, 68086, '\P{^Is_Nv:	60/720}', "");
    Expect(0, 68087, '\p{Is_Nv:	60/720}', "");
    Expect(1, 68087, '\p{^Is_Nv:	60/720}', "");
    Expect(1, 68087, '\P{Is_Nv:	60/720}', "");
    Expect(0, 68087, '\P{^Is_Nv:	60/720}', "");
    Error('\p{Is_Nv=8.3e-02}');
    Error('\P{Is_Nv=8.3e-02}');
    Expect(1, 68086, '\p{Is_Nv: 8.33e-02}', "");
    Expect(0, 68086, '\p{^Is_Nv: 8.33e-02}', "");
    Expect(0, 68086, '\P{Is_Nv: 8.33e-02}', "");
    Expect(1, 68086, '\P{^Is_Nv: 8.33e-02}', "");
    Expect(0, 68087, '\p{Is_Nv: 8.33e-02}', "");
    Expect(1, 68087, '\p{^Is_Nv: 8.33e-02}', "");
    Expect(1, 68087, '\P{Is_Nv: 8.33e-02}', "");
    Expect(0, 68087, '\P{^Is_Nv: 8.33e-02}', "");
    Error('\p{Is_Nv=0.08}');
    Error('\P{Is_Nv=0.08}');
    Expect(1, 68086, '\p{Is_Nv=8.333e-02}', "");
    Expect(0, 68086, '\p{^Is_Nv=8.333e-02}', "");
    Expect(0, 68086, '\P{Is_Nv=8.333e-02}', "");
    Expect(1, 68086, '\P{^Is_Nv=8.333e-02}', "");
    Expect(0, 68087, '\p{Is_Nv=8.333e-02}', "");
    Expect(1, 68087, '\p{^Is_Nv=8.333e-02}', "");
    Expect(1, 68087, '\P{Is_Nv=8.333e-02}', "");
    Expect(0, 68087, '\P{^Is_Nv=8.333e-02}', "");
    Error('\p{Is_Nv=0.083}');
    Error('\P{Is_Nv=0.083}');
    Expect(1, 68086, '\p{Is_Nv=8.3333e-02}', "");
    Expect(0, 68086, '\p{^Is_Nv=8.3333e-02}', "");
    Expect(0, 68086, '\P{Is_Nv=8.3333e-02}', "");
    Expect(1, 68086, '\P{^Is_Nv=8.3333e-02}', "");
    Expect(0, 68087, '\p{Is_Nv=8.3333e-02}', "");
    Expect(1, 68087, '\p{^Is_Nv=8.3333e-02}', "");
    Expect(1, 68087, '\P{Is_Nv=8.3333e-02}', "");
    Expect(0, 68087, '\P{^Is_Nv=8.3333e-02}', "");
    Expect(1, 68086, '\p{Is_Nv=0.0833}', "");
    Expect(0, 68086, '\p{^Is_Nv=0.0833}', "");
    Expect(0, 68086, '\P{Is_Nv=0.0833}', "");
    Expect(1, 68086, '\P{^Is_Nv=0.0833}', "");
    Expect(0, 68087, '\p{Is_Nv=0.0833}', "");
    Expect(1, 68087, '\p{^Is_Nv=0.0833}', "");
    Expect(1, 68087, '\P{Is_Nv=0.0833}', "");
    Expect(0, 68087, '\P{^Is_Nv=0.0833}', "");
    Expect(1, 68086, '\p{Is_Nv=8.33333e-02}', "");
    Expect(0, 68086, '\p{^Is_Nv=8.33333e-02}', "");
    Expect(0, 68086, '\P{Is_Nv=8.33333e-02}', "");
    Expect(1, 68086, '\P{^Is_Nv=8.33333e-02}', "");
    Expect(0, 68087, '\p{Is_Nv=8.33333e-02}', "");
    Expect(1, 68087, '\p{^Is_Nv=8.33333e-02}', "");
    Expect(1, 68087, '\P{Is_Nv=8.33333e-02}', "");
    Expect(0, 68087, '\P{^Is_Nv=8.33333e-02}', "");
    Expect(1, 68086, '\p{Is_Nv=0.08333}', "");
    Expect(0, 68086, '\p{^Is_Nv=0.08333}', "");
    Expect(0, 68086, '\P{Is_Nv=0.08333}', "");
    Expect(1, 68086, '\P{^Is_Nv=0.08333}', "");
    Expect(0, 68087, '\p{Is_Nv=0.08333}', "");
    Expect(1, 68087, '\p{^Is_Nv=0.08333}', "");
    Expect(1, 68087, '\P{Is_Nv=0.08333}', "");
    Expect(0, 68087, '\P{^Is_Nv=0.08333}', "");
    Error('\p{Numeric_Value:	_-+0001/000000016/a/}');
    Error('\P{Numeric_Value:	_-+0001/000000016/a/}');
    Expect(1, 73674, '\p{Numeric_Value=:\A1/16\z:}', "");;
    Expect(0, 73675, '\p{Numeric_Value=:\A1/16\z:}', "");;
    Expect(1, 73674, '\p{Numeric_Value=001/000000016}', "");
    Expect(0, 73674, '\p{^Numeric_Value=001/000000016}', "");
    Expect(0, 73674, '\P{Numeric_Value=001/000000016}', "");
    Expect(1, 73674, '\P{^Numeric_Value=001/000000016}', "");
    Expect(0, 73675, '\p{Numeric_Value=001/000000016}', "");
    Expect(1, 73675, '\p{^Numeric_Value=001/000000016}', "");
    Expect(1, 73675, '\P{Numeric_Value=001/000000016}', "");
    Expect(0, 73675, '\P{^Numeric_Value=001/000000016}', "");
    Expect(1, 73674, '\p{Numeric_Value=60/960}', "");
    Expect(0, 73674, '\p{^Numeric_Value=60/960}', "");
    Expect(0, 73674, '\P{Numeric_Value=60/960}', "");
    Expect(1, 73674, '\P{^Numeric_Value=60/960}', "");
    Expect(0, 73675, '\p{Numeric_Value=60/960}', "");
    Expect(1, 73675, '\p{^Numeric_Value=60/960}', "");
    Expect(1, 73675, '\P{Numeric_Value=60/960}', "");
    Expect(0, 73675, '\P{^Numeric_Value=60/960}', "");
    Error('\p{Numeric_Value=6.2e-02}');
    Error('\P{Numeric_Value=6.2e-02}');
    Expect(1, 73674, '\p{Numeric_Value=6.25e-02}', "");
    Expect(0, 73674, '\p{^Numeric_Value=6.25e-02}', "");
    Expect(0, 73674, '\P{Numeric_Value=6.25e-02}', "");
    Expect(1, 73674, '\P{^Numeric_Value=6.25e-02}', "");
    Expect(0, 73675, '\p{Numeric_Value=6.25e-02}', "");
    Expect(1, 73675, '\p{^Numeric_Value=6.25e-02}', "");
    Expect(1, 73675, '\P{Numeric_Value=6.25e-02}', "");
    Expect(0, 73675, '\P{^Numeric_Value=6.25e-02}', "");
    Error('\p{Numeric_Value=0.06}');
    Error('\P{Numeric_Value=0.06}');
    Expect(1, 73674, '\p{Numeric_Value=6.250e-02}', "");
    Expect(0, 73674, '\p{^Numeric_Value=6.250e-02}', "");
    Expect(0, 73674, '\P{Numeric_Value=6.250e-02}', "");
    Expect(1, 73674, '\P{^Numeric_Value=6.250e-02}', "");
    Expect(0, 73675, '\p{Numeric_Value=6.250e-02}', "");
    Expect(1, 73675, '\p{^Numeric_Value=6.250e-02}', "");
    Expect(1, 73675, '\P{Numeric_Value=6.250e-02}', "");
    Expect(0, 73675, '\P{^Numeric_Value=6.250e-02}', "");
    Error('\p{Numeric_Value:	0.062}');
    Error('\P{Numeric_Value:	0.062}');
    Expect(1, 73674, '\p{Numeric_Value=6.2500e-02}', "");
    Expect(0, 73674, '\p{^Numeric_Value=6.2500e-02}', "");
    Expect(0, 73674, '\P{Numeric_Value=6.2500e-02}', "");
    Expect(1, 73674, '\P{^Numeric_Value=6.2500e-02}', "");
    Expect(0, 73675, '\p{Numeric_Value=6.2500e-02}', "");
    Expect(1, 73675, '\p{^Numeric_Value=6.2500e-02}', "");
    Expect(1, 73675, '\P{Numeric_Value=6.2500e-02}', "");
    Expect(0, 73675, '\P{^Numeric_Value=6.2500e-02}', "");
    Expect(1, 73674, '\p{Numeric_Value=0.0625}', "");
    Expect(0, 73674, '\p{^Numeric_Value=0.0625}', "");
    Expect(0, 73674, '\P{Numeric_Value=0.0625}', "");
    Expect(1, 73674, '\P{^Numeric_Value=0.0625}', "");
    Expect(0, 73675, '\p{Numeric_Value=0.0625}', "");
    Expect(1, 73675, '\p{^Numeric_Value=0.0625}', "");
    Expect(1, 73675, '\P{Numeric_Value=0.0625}', "");
    Expect(0, 73675, '\P{^Numeric_Value=0.0625}', "");
    Expect(1, 73674, '\p{Numeric_Value=6.25000e-02}', "");
    Expect(0, 73674, '\p{^Numeric_Value=6.25000e-02}', "");
    Expect(0, 73674, '\P{Numeric_Value=6.25000e-02}', "");
    Expect(1, 73674, '\P{^Numeric_Value=6.25000e-02}', "");
    Expect(0, 73675, '\p{Numeric_Value=6.25000e-02}', "");
    Expect(1, 73675, '\p{^Numeric_Value=6.25000e-02}', "");
    Expect(1, 73675, '\P{Numeric_Value=6.25000e-02}', "");
    Expect(0, 73675, '\P{^Numeric_Value=6.25000e-02}', "");
    Expect(1, 73674, '\p{Numeric_Value:   0.06250}', "");
    Expect(0, 73674, '\p{^Numeric_Value:   0.06250}', "");
    Expect(0, 73674, '\P{Numeric_Value:   0.06250}', "");
    Expect(1, 73674, '\P{^Numeric_Value:   0.06250}', "");
    Expect(0, 73675, '\p{Numeric_Value:   0.06250}', "");
    Expect(1, 73675, '\p{^Numeric_Value:   0.06250}', "");
    Expect(1, 73675, '\P{Numeric_Value:   0.06250}', "");
    Expect(0, 73675, '\P{^Numeric_Value:   0.06250}', "");
    Error('\p{Nv= _+1/0000016/a/}');
    Error('\P{Nv= _+1/0000016/a/}');
    Expect(1, 73674, '\p{Nv=:\A1/16\z:}', "");;
    Expect(0, 73675, '\p{Nv=:\A1/16\z:}', "");;
    Expect(1, 73674, '\p{Nv=0001/00000000016}', "");
    Expect(0, 73674, '\p{^Nv=0001/00000000016}', "");
    Expect(0, 73674, '\P{Nv=0001/00000000016}', "");
    Expect(1, 73674, '\P{^Nv=0001/00000000016}', "");
    Expect(0, 73675, '\p{Nv=0001/00000000016}', "");
    Expect(1, 73675, '\p{^Nv=0001/00000000016}', "");
    Expect(1, 73675, '\P{Nv=0001/00000000016}', "");
    Expect(0, 73675, '\P{^Nv=0001/00000000016}', "");
    Expect(1, 73674, '\p{Nv=60/960}', "");
    Expect(0, 73674, '\p{^Nv=60/960}', "");
    Expect(0, 73674, '\P{Nv=60/960}', "");
    Expect(1, 73674, '\P{^Nv=60/960}', "");
    Expect(0, 73675, '\p{Nv=60/960}', "");
    Expect(1, 73675, '\p{^Nv=60/960}', "");
    Expect(1, 73675, '\P{Nv=60/960}', "");
    Expect(0, 73675, '\P{^Nv=60/960}', "");
    Error('\p{Nv=6.2e-02}');
    Error('\P{Nv=6.2e-02}');
    Expect(1, 73674, '\p{Nv:   6.25e-02}', "");
    Expect(0, 73674, '\p{^Nv:   6.25e-02}', "");
    Expect(0, 73674, '\P{Nv:   6.25e-02}', "");
    Expect(1, 73674, '\P{^Nv:   6.25e-02}', "");
    Expect(0, 73675, '\p{Nv:   6.25e-02}', "");
    Expect(1, 73675, '\p{^Nv:   6.25e-02}', "");
    Expect(1, 73675, '\P{Nv:   6.25e-02}', "");
    Expect(0, 73675, '\P{^Nv:   6.25e-02}', "");
    Error('\p{Nv=0.06}');
    Error('\P{Nv=0.06}');
    Expect(1, 73674, '\p{Nv=6.250e-02}', "");
    Expect(0, 73674, '\p{^Nv=6.250e-02}', "");
    Expect(0, 73674, '\P{Nv=6.250e-02}', "");
    Expect(1, 73674, '\P{^Nv=6.250e-02}', "");
    Expect(0, 73675, '\p{Nv=6.250e-02}', "");
    Expect(1, 73675, '\p{^Nv=6.250e-02}', "");
    Expect(1, 73675, '\P{Nv=6.250e-02}', "");
    Expect(0, 73675, '\P{^Nv=6.250e-02}', "");
    Error('\p{Nv=0.062}');
    Error('\P{Nv=0.062}');
    Expect(1, 73674, '\p{Nv:	6.2500e-02}', "");
    Expect(0, 73674, '\p{^Nv:	6.2500e-02}', "");
    Expect(0, 73674, '\P{Nv:	6.2500e-02}', "");
    Expect(1, 73674, '\P{^Nv:	6.2500e-02}', "");
    Expect(0, 73675, '\p{Nv:	6.2500e-02}', "");
    Expect(1, 73675, '\p{^Nv:	6.2500e-02}', "");
    Expect(1, 73675, '\P{Nv:	6.2500e-02}', "");
    Expect(0, 73675, '\P{^Nv:	6.2500e-02}', "");
    Expect(1, 73674, '\p{Nv=0.0625}', "");
    Expect(0, 73674, '\p{^Nv=0.0625}', "");
    Expect(0, 73674, '\P{Nv=0.0625}', "");
    Expect(1, 73674, '\P{^Nv=0.0625}', "");
    Expect(0, 73675, '\p{Nv=0.0625}', "");
    Expect(1, 73675, '\p{^Nv=0.0625}', "");
    Expect(1, 73675, '\P{Nv=0.0625}', "");
    Expect(0, 73675, '\P{^Nv=0.0625}', "");
    Expect(1, 73674, '\p{Nv=6.25000e-02}', "");
    Expect(0, 73674, '\p{^Nv=6.25000e-02}', "");
    Expect(0, 73674, '\P{Nv=6.25000e-02}', "");
    Expect(1, 73674, '\P{^Nv=6.25000e-02}', "");
    Expect(0, 73675, '\p{Nv=6.25000e-02}', "");
    Expect(1, 73675, '\p{^Nv=6.25000e-02}', "");
    Expect(1, 73675, '\P{Nv=6.25000e-02}', "");
    Expect(0, 73675, '\P{^Nv=6.25000e-02}', "");
    Expect(1, 73674, '\p{Nv=0.06250}', "");
    Expect(0, 73674, '\p{^Nv=0.06250}', "");
    Expect(0, 73674, '\P{Nv=0.06250}', "");
    Expect(1, 73674, '\P{^Nv=0.06250}', "");
    Expect(0, 73675, '\p{Nv=0.06250}', "");
    Expect(1, 73675, '\p{^Nv=0.06250}', "");
    Expect(1, 73675, '\P{Nv=0.06250}', "");
    Expect(0, 73675, '\P{^Nv=0.06250}', "");
    Error('\p{Is_Numeric_Value=-:=0001/0000016}');
    Error('\P{Is_Numeric_Value=-:=0001/0000016}');
    Expect(1, 73674, '\p{Is_Numeric_Value=00001/00016}', "");
    Expect(0, 73674, '\p{^Is_Numeric_Value=00001/00016}', "");
    Expect(0, 73674, '\P{Is_Numeric_Value=00001/00016}', "");
    Expect(1, 73674, '\P{^Is_Numeric_Value=00001/00016}', "");
    Expect(0, 73675, '\p{Is_Numeric_Value=00001/00016}', "");
    Expect(1, 73675, '\p{^Is_Numeric_Value=00001/00016}', "");
    Expect(1, 73675, '\P{Is_Numeric_Value=00001/00016}', "");
    Expect(0, 73675, '\P{^Is_Numeric_Value=00001/00016}', "");
    Expect(1, 73674, '\p{Is_Numeric_Value=60/960}', "");
    Expect(0, 73674, '\p{^Is_Numeric_Value=60/960}', "");
    Expect(0, 73674, '\P{Is_Numeric_Value=60/960}', "");
    Expect(1, 73674, '\P{^Is_Numeric_Value=60/960}', "");
    Expect(0, 73675, '\p{Is_Numeric_Value=60/960}', "");
    Expect(1, 73675, '\p{^Is_Numeric_Value=60/960}', "");
    Expect(1, 73675, '\P{Is_Numeric_Value=60/960}', "");
    Expect(0, 73675, '\P{^Is_Numeric_Value=60/960}', "");
    Error('\p{Is_Numeric_Value: 6.2e-02}');
    Error('\P{Is_Numeric_Value: 6.2e-02}');
    Expect(1, 73674, '\p{Is_Numeric_Value=6.25e-02}', "");
    Expect(0, 73674, '\p{^Is_Numeric_Value=6.25e-02}', "");
    Expect(0, 73674, '\P{Is_Numeric_Value=6.25e-02}', "");
    Expect(1, 73674, '\P{^Is_Numeric_Value=6.25e-02}', "");
    Expect(0, 73675, '\p{Is_Numeric_Value=6.25e-02}', "");
    Expect(1, 73675, '\p{^Is_Numeric_Value=6.25e-02}', "");
    Expect(1, 73675, '\P{Is_Numeric_Value=6.25e-02}', "");
    Expect(0, 73675, '\P{^Is_Numeric_Value=6.25e-02}', "");
    Error('\p{Is_Numeric_Value: 0.06}');
    Error('\P{Is_Numeric_Value: 0.06}');
    Expect(1, 73674, '\p{Is_Numeric_Value=6.250e-02}', "");
    Expect(0, 73674, '\p{^Is_Numeric_Value=6.250e-02}', "");
    Expect(0, 73674, '\P{Is_Numeric_Value=6.250e-02}', "");
    Expect(1, 73674, '\P{^Is_Numeric_Value=6.250e-02}', "");
    Expect(0, 73675, '\p{Is_Numeric_Value=6.250e-02}', "");
    Expect(1, 73675, '\p{^Is_Numeric_Value=6.250e-02}', "");
    Expect(1, 73675, '\P{Is_Numeric_Value=6.250e-02}', "");
    Expect(0, 73675, '\P{^Is_Numeric_Value=6.250e-02}', "");
    Error('\p{Is_Numeric_Value=0.062}');
    Error('\P{Is_Numeric_Value=0.062}');
    Expect(1, 73674, '\p{Is_Numeric_Value=6.2500e-02}', "");
    Expect(0, 73674, '\p{^Is_Numeric_Value=6.2500e-02}', "");
    Expect(0, 73674, '\P{Is_Numeric_Value=6.2500e-02}', "");
    Expect(1, 73674, '\P{^Is_Numeric_Value=6.2500e-02}', "");
    Expect(0, 73675, '\p{Is_Numeric_Value=6.2500e-02}', "");
    Expect(1, 73675, '\p{^Is_Numeric_Value=6.2500e-02}', "");
    Expect(1, 73675, '\P{Is_Numeric_Value=6.2500e-02}', "");
    Expect(0, 73675, '\P{^Is_Numeric_Value=6.2500e-02}', "");
    Expect(1, 73674, '\p{Is_Numeric_Value=0.0625}', "");
    Expect(0, 73674, '\p{^Is_Numeric_Value=0.0625}', "");
    Expect(0, 73674, '\P{Is_Numeric_Value=0.0625}', "");
    Expect(1, 73674, '\P{^Is_Numeric_Value=0.0625}', "");
    Expect(0, 73675, '\p{Is_Numeric_Value=0.0625}', "");
    Expect(1, 73675, '\p{^Is_Numeric_Value=0.0625}', "");
    Expect(1, 73675, '\P{Is_Numeric_Value=0.0625}', "");
    Expect(0, 73675, '\P{^Is_Numeric_Value=0.0625}', "");
    Expect(1, 73674, '\p{Is_Numeric_Value=6.25000e-02}', "");
    Expect(0, 73674, '\p{^Is_Numeric_Value=6.25000e-02}', "");
    Expect(0, 73674, '\P{Is_Numeric_Value=6.25000e-02}', "");
    Expect(1, 73674, '\P{^Is_Numeric_Value=6.25000e-02}', "");
    Expect(0, 73675, '\p{Is_Numeric_Value=6.25000e-02}', "");
    Expect(1, 73675, '\p{^Is_Numeric_Value=6.25000e-02}', "");
    Expect(1, 73675, '\P{Is_Numeric_Value=6.25000e-02}', "");
    Expect(0, 73675, '\P{^Is_Numeric_Value=6.25000e-02}', "");
    Expect(1, 73674, '\p{Is_Numeric_Value=0.06250}', "");
    Expect(0, 73674, '\p{^Is_Numeric_Value=0.06250}', "");
    Expect(0, 73674, '\P{Is_Numeric_Value=0.06250}', "");
    Expect(1, 73674, '\P{^Is_Numeric_Value=0.06250}', "");
    Expect(0, 73675, '\p{Is_Numeric_Value=0.06250}', "");
    Expect(1, 73675, '\p{^Is_Numeric_Value=0.06250}', "");
    Expect(1, 73675, '\P{Is_Numeric_Value=0.06250}', "");
    Expect(0, 73675, '\P{^Is_Numeric_Value=0.06250}', "");
    Error('\p{Is_Nv=:=-_+01/16}');
    Error('\P{Is_Nv=:=-_+01/16}');
    Expect(1, 73674, '\p{Is_Nv=+00001/0016}', "");
    Expect(0, 73674, '\p{^Is_Nv=+00001/0016}', "");
    Expect(0, 73674, '\P{Is_Nv=+00001/0016}', "");
    Expect(1, 73674, '\P{^Is_Nv=+00001/0016}', "");
    Expect(0, 73675, '\p{Is_Nv=+00001/0016}', "");
    Expect(1, 73675, '\p{^Is_Nv=+00001/0016}', "");
    Expect(1, 73675, '\P{Is_Nv=+00001/0016}', "");
    Expect(0, 73675, '\P{^Is_Nv=+00001/0016}', "");
    Expect(1, 73674, '\p{Is_Nv=60/960}', "");
    Expect(0, 73674, '\p{^Is_Nv=60/960}', "");
    Expect(0, 73674, '\P{Is_Nv=60/960}', "");
    Expect(1, 73674, '\P{^Is_Nv=60/960}', "");
    Expect(0, 73675, '\p{Is_Nv=60/960}', "");
    Expect(1, 73675, '\p{^Is_Nv=60/960}', "");
    Expect(1, 73675, '\P{Is_Nv=60/960}', "");
    Expect(0, 73675, '\P{^Is_Nv=60/960}', "");
    Error('\p{Is_Nv=6.2e-02}');
    Error('\P{Is_Nv=6.2e-02}');
    Expect(1, 73674, '\p{Is_Nv=6.25e-02}', "");
    Expect(0, 73674, '\p{^Is_Nv=6.25e-02}', "");
    Expect(0, 73674, '\P{Is_Nv=6.25e-02}', "");
    Expect(1, 73674, '\P{^Is_Nv=6.25e-02}', "");
    Expect(0, 73675, '\p{Is_Nv=6.25e-02}', "");
    Expect(1, 73675, '\p{^Is_Nv=6.25e-02}', "");
    Expect(1, 73675, '\P{Is_Nv=6.25e-02}', "");
    Expect(0, 73675, '\P{^Is_Nv=6.25e-02}', "");
    Error('\p{Is_Nv=0.06}');
    Error('\P{Is_Nv=0.06}');
    Expect(1, 73674, '\p{Is_Nv=6.250e-02}', "");
    Expect(0, 73674, '\p{^Is_Nv=6.250e-02}', "");
    Expect(0, 73674, '\P{Is_Nv=6.250e-02}', "");
    Expect(1, 73674, '\P{^Is_Nv=6.250e-02}', "");
    Expect(0, 73675, '\p{Is_Nv=6.250e-02}', "");
    Expect(1, 73675, '\p{^Is_Nv=6.250e-02}', "");
    Expect(1, 73675, '\P{Is_Nv=6.250e-02}', "");
    Expect(0, 73675, '\P{^Is_Nv=6.250e-02}', "");
    Error('\p{Is_Nv=0.062}');
    Error('\P{Is_Nv=0.062}');
    Expect(1, 73674, '\p{Is_Nv:6.2500e-02}', "");
    Expect(0, 73674, '\p{^Is_Nv:6.2500e-02}', "");
    Expect(0, 73674, '\P{Is_Nv:6.2500e-02}', "");
    Expect(1, 73674, '\P{^Is_Nv:6.2500e-02}', "");
    Expect(0, 73675, '\p{Is_Nv:6.2500e-02}', "");
    Expect(1, 73675, '\p{^Is_Nv:6.2500e-02}', "");
    Expect(1, 73675, '\P{Is_Nv:6.2500e-02}', "");
    Expect(0, 73675, '\P{^Is_Nv:6.2500e-02}', "");
    Expect(1, 73674, '\p{Is_Nv=0.0625}', "");
    Expect(0, 73674, '\p{^Is_Nv=0.0625}', "");
    Expect(0, 73674, '\P{Is_Nv=0.0625}', "");
    Expect(1, 73674, '\P{^Is_Nv=0.0625}', "");
    Expect(0, 73675, '\p{Is_Nv=0.0625}', "");
    Expect(1, 73675, '\p{^Is_Nv=0.0625}', "");
    Expect(1, 73675, '\P{Is_Nv=0.0625}', "");
    Expect(0, 73675, '\P{^Is_Nv=0.0625}', "");
    Expect(1, 73674, '\p{Is_Nv:	6.25000e-02}', "");
    Expect(0, 73674, '\p{^Is_Nv:	6.25000e-02}', "");
    Expect(0, 73674, '\P{Is_Nv:	6.25000e-02}', "");
    Expect(1, 73674, '\P{^Is_Nv:	6.25000e-02}', "");
    Expect(0, 73675, '\p{Is_Nv:	6.25000e-02}', "");
    Expect(1, 73675, '\p{^Is_Nv:	6.25000e-02}', "");
    Expect(1, 73675, '\P{Is_Nv:	6.25000e-02}', "");
    Expect(0, 73675, '\P{^Is_Nv:	6.25000e-02}', "");
    Expect(1, 73674, '\p{Is_Nv=0.06250}', "");
    Expect(0, 73674, '\p{^Is_Nv=0.06250}', "");
    Expect(0, 73674, '\P{Is_Nv=0.06250}', "");
    Expect(1, 73674, '\P{^Is_Nv=0.06250}', "");
    Expect(0, 73675, '\p{Is_Nv=0.06250}', "");
    Expect(1, 73675, '\p{^Is_Nv=0.06250}', "");
    Expect(1, 73675, '\P{Is_Nv=0.06250}', "");
    Expect(0, 73675, '\P{^Is_Nv=0.06250}', "");
    Error('\p{Numeric_Value=:=_	+0000000001/0160}');
    Error('\P{Numeric_Value=:=_	+0000000001/0160}');
    Expect(1, 73665, '\p{Numeric_Value=:\A1/160\z:}', "");;
    Expect(0, 73666, '\p{Numeric_Value=:\A1/160\z:}', "");;
    Expect(1, 73665, '\p{Numeric_Value: +000001/160}', "");
    Expect(0, 73665, '\p{^Numeric_Value: +000001/160}', "");
    Expect(0, 73665, '\P{Numeric_Value: +000001/160}', "");
    Expect(1, 73665, '\P{^Numeric_Value: +000001/160}', "");
    Expect(0, 73666, '\p{Numeric_Value: +000001/160}', "");
    Expect(1, 73666, '\p{^Numeric_Value: +000001/160}', "");
    Expect(1, 73666, '\P{Numeric_Value: +000001/160}', "");
    Expect(0, 73666, '\P{^Numeric_Value: +000001/160}', "");
    Expect(1, 73665, '\p{Numeric_Value=60/9600}', "");
    Expect(0, 73665, '\p{^Numeric_Value=60/9600}', "");
    Expect(0, 73665, '\P{Numeric_Value=60/9600}', "");
    Expect(1, 73665, '\P{^Numeric_Value=60/9600}', "");
    Expect(0, 73666, '\p{Numeric_Value=60/9600}', "");
    Expect(1, 73666, '\p{^Numeric_Value=60/9600}', "");
    Expect(1, 73666, '\P{Numeric_Value=60/9600}', "");
    Expect(0, 73666, '\P{^Numeric_Value=60/9600}', "");
    Error('\p{Numeric_Value=6.3e-03}');
    Error('\P{Numeric_Value=6.3e-03}');
    Expect(1, 73665, '\p{Numeric_Value=6.25e-03}', "");
    Expect(0, 73665, '\p{^Numeric_Value=6.25e-03}', "");
    Expect(0, 73665, '\P{Numeric_Value=6.25e-03}', "");
    Expect(1, 73665, '\P{^Numeric_Value=6.25e-03}', "");
    Expect(0, 73666, '\p{Numeric_Value=6.25e-03}', "");
    Expect(1, 73666, '\p{^Numeric_Value=6.25e-03}', "");
    Expect(1, 73666, '\P{Numeric_Value=6.25e-03}', "");
    Expect(0, 73666, '\P{^Numeric_Value=6.25e-03}', "");
    Error('\p{Numeric_Value:   0.01}');
    Error('\P{Numeric_Value:   0.01}');
    Expect(1, 73665, '\p{Numeric_Value:   6.250e-03}', "");
    Expect(0, 73665, '\p{^Numeric_Value:   6.250e-03}', "");
    Expect(0, 73665, '\P{Numeric_Value:   6.250e-03}', "");
    Expect(1, 73665, '\P{^Numeric_Value:   6.250e-03}', "");
    Expect(0, 73666, '\p{Numeric_Value:   6.250e-03}', "");
    Expect(1, 73666, '\p{^Numeric_Value:   6.250e-03}', "");
    Expect(1, 73666, '\P{Numeric_Value:   6.250e-03}', "");
    Expect(0, 73666, '\P{^Numeric_Value:   6.250e-03}', "");
    Error('\p{Numeric_Value=0.006}');
    Error('\P{Numeric_Value=0.006}');
    Expect(1, 73665, '\p{Numeric_Value=6.2500e-03}', "");
    Expect(0, 73665, '\p{^Numeric_Value=6.2500e-03}', "");
    Expect(0, 73665, '\P{Numeric_Value=6.2500e-03}', "");
    Expect(1, 73665, '\P{^Numeric_Value=6.2500e-03}', "");
    Expect(0, 73666, '\p{Numeric_Value=6.2500e-03}', "");
    Expect(1, 73666, '\p{^Numeric_Value=6.2500e-03}', "");
    Expect(1, 73666, '\P{Numeric_Value=6.2500e-03}', "");
    Expect(0, 73666, '\P{^Numeric_Value=6.2500e-03}', "");
    Error('\p{Numeric_Value=0.0063}');
    Error('\P{Numeric_Value=0.0063}');
    Expect(1, 73665, '\p{Numeric_Value=6.25000e-03}', "");
    Expect(0, 73665, '\p{^Numeric_Value=6.25000e-03}', "");
    Expect(0, 73665, '\P{Numeric_Value=6.25000e-03}', "");
    Expect(1, 73665, '\P{^Numeric_Value=6.25000e-03}', "");
    Expect(0, 73666, '\p{Numeric_Value=6.25000e-03}', "");
    Expect(1, 73666, '\p{^Numeric_Value=6.25000e-03}', "");
    Expect(1, 73666, '\P{Numeric_Value=6.25000e-03}', "");
    Expect(0, 73666, '\P{^Numeric_Value=6.25000e-03}', "");
    Expect(1, 73665, '\p{Numeric_Value=0.00625}', "");
    Expect(0, 73665, '\p{^Numeric_Value=0.00625}', "");
    Expect(0, 73665, '\P{Numeric_Value=0.00625}', "");
    Expect(1, 73665, '\P{^Numeric_Value=0.00625}', "");
    Expect(0, 73666, '\p{Numeric_Value=0.00625}', "");
    Expect(1, 73666, '\p{^Numeric_Value=0.00625}', "");
    Expect(1, 73666, '\P{Numeric_Value=0.00625}', "");
    Expect(0, 73666, '\P{^Numeric_Value=0.00625}', "");
    Expect(1, 73665, '\p{Numeric_Value=6.250000e-03}', "");
    Expect(0, 73665, '\p{^Numeric_Value=6.250000e-03}', "");
    Expect(0, 73665, '\P{Numeric_Value=6.250000e-03}', "");
    Expect(1, 73665, '\P{^Numeric_Value=6.250000e-03}', "");
    Expect(0, 73666, '\p{Numeric_Value=6.250000e-03}', "");
    Expect(1, 73666, '\p{^Numeric_Value=6.250000e-03}', "");
    Expect(1, 73666, '\P{Numeric_Value=6.250000e-03}', "");
    Expect(0, 73666, '\P{^Numeric_Value=6.250000e-03}', "");
    Expect(1, 73665, '\p{Numeric_Value=0.006250}', "");
    Expect(0, 73665, '\p{^Numeric_Value=0.006250}', "");
    Expect(0, 73665, '\P{Numeric_Value=0.006250}', "");
    Expect(1, 73665, '\P{^Numeric_Value=0.006250}', "");
    Expect(0, 73666, '\p{Numeric_Value=0.006250}', "");
    Expect(1, 73666, '\p{^Numeric_Value=0.006250}', "");
    Expect(1, 73666, '\P{Numeric_Value=0.006250}', "");
    Expect(0, 73666, '\P{^Numeric_Value=0.006250}', "");
    Error('\p{Nv= 0000000001/00160/a/}');
    Error('\P{Nv= 0000000001/00160/a/}');
    Expect(1, 73665, '\p{Nv=:\A1/160\z:}', "");;
    Expect(0, 73666, '\p{Nv=:\A1/160\z:}', "");;
    Expect(1, 73665, '\p{Nv=0001/00160}', "");
    Expect(0, 73665, '\p{^Nv=0001/00160}', "");
    Expect(0, 73665, '\P{Nv=0001/00160}', "");
    Expect(1, 73665, '\P{^Nv=0001/00160}', "");
    Expect(0, 73666, '\p{Nv=0001/00160}', "");
    Expect(1, 73666, '\p{^Nv=0001/00160}', "");
    Expect(1, 73666, '\P{Nv=0001/00160}', "");
    Expect(0, 73666, '\P{^Nv=0001/00160}', "");
    Expect(1, 73665, '\p{Nv=60/9600}', "");
    Expect(0, 73665, '\p{^Nv=60/9600}', "");
    Expect(0, 73665, '\P{Nv=60/9600}', "");
    Expect(1, 73665, '\P{^Nv=60/9600}', "");
    Expect(0, 73666, '\p{Nv=60/9600}', "");
    Expect(1, 73666, '\p{^Nv=60/9600}', "");
    Expect(1, 73666, '\P{Nv=60/9600}', "");
    Expect(0, 73666, '\P{^Nv=60/9600}', "");
    Error('\p{Nv=6.3e-03}');
    Error('\P{Nv=6.3e-03}');
    Expect(1, 73665, '\p{Nv=6.25e-03}', "");
    Expect(0, 73665, '\p{^Nv=6.25e-03}', "");
    Expect(0, 73665, '\P{Nv=6.25e-03}', "");
    Expect(1, 73665, '\P{^Nv=6.25e-03}', "");
    Expect(0, 73666, '\p{Nv=6.25e-03}', "");
    Expect(1, 73666, '\p{^Nv=6.25e-03}', "");
    Expect(1, 73666, '\P{Nv=6.25e-03}', "");
    Expect(0, 73666, '\P{^Nv=6.25e-03}', "");
    Error('\p{Nv=0.01}');
    Error('\P{Nv=0.01}');
    Expect(1, 73665, '\p{Nv: 6.250e-03}', "");
    Expect(0, 73665, '\p{^Nv: 6.250e-03}', "");
    Expect(0, 73665, '\P{Nv: 6.250e-03}', "");
    Expect(1, 73665, '\P{^Nv: 6.250e-03}', "");
    Expect(0, 73666, '\p{Nv: 6.250e-03}', "");
    Expect(1, 73666, '\p{^Nv: 6.250e-03}', "");
    Expect(1, 73666, '\P{Nv: 6.250e-03}', "");
    Expect(0, 73666, '\P{^Nv: 6.250e-03}', "");
    Error('\p{Nv=0.006}');
    Error('\P{Nv=0.006}');
    Expect(1, 73665, '\p{Nv=6.2500e-03}', "");
    Expect(0, 73665, '\p{^Nv=6.2500e-03}', "");
    Expect(0, 73665, '\P{Nv=6.2500e-03}', "");
    Expect(1, 73665, '\P{^Nv=6.2500e-03}', "");
    Expect(0, 73666, '\p{Nv=6.2500e-03}', "");
    Expect(1, 73666, '\p{^Nv=6.2500e-03}', "");
    Expect(1, 73666, '\P{Nv=6.2500e-03}', "");
    Expect(0, 73666, '\P{^Nv=6.2500e-03}', "");
    Error('\p{Nv=0.0063}');
    Error('\P{Nv=0.0063}');
    Expect(1, 73665, '\p{Nv=6.25000e-03}', "");
    Expect(0, 73665, '\p{^Nv=6.25000e-03}', "");
    Expect(0, 73665, '\P{Nv=6.25000e-03}', "");
    Expect(1, 73665, '\P{^Nv=6.25000e-03}', "");
    Expect(0, 73666, '\p{Nv=6.25000e-03}', "");
    Expect(1, 73666, '\p{^Nv=6.25000e-03}', "");
    Expect(1, 73666, '\P{Nv=6.25000e-03}', "");
    Expect(0, 73666, '\P{^Nv=6.25000e-03}', "");
    Expect(1, 73665, '\p{Nv=0.00625}', "");
    Expect(0, 73665, '\p{^Nv=0.00625}', "");
    Expect(0, 73665, '\P{Nv=0.00625}', "");
    Expect(1, 73665, '\P{^Nv=0.00625}', "");
    Expect(0, 73666, '\p{Nv=0.00625}', "");
    Expect(1, 73666, '\p{^Nv=0.00625}', "");
    Expect(1, 73666, '\P{Nv=0.00625}', "");
    Expect(0, 73666, '\P{^Nv=0.00625}', "");
    Expect(1, 73665, '\p{Nv:   6.250000e-03}', "");
    Expect(0, 73665, '\p{^Nv:   6.250000e-03}', "");
    Expect(0, 73665, '\P{Nv:   6.250000e-03}', "");
    Expect(1, 73665, '\P{^Nv:   6.250000e-03}', "");
    Expect(0, 73666, '\p{Nv:   6.250000e-03}', "");
    Expect(1, 73666, '\p{^Nv:   6.250000e-03}', "");
    Expect(1, 73666, '\P{Nv:   6.250000e-03}', "");
    Expect(0, 73666, '\P{^Nv:   6.250000e-03}', "");
    Expect(1, 73665, '\p{Nv=0.006250}', "");
    Expect(0, 73665, '\p{^Nv=0.006250}', "");
    Expect(0, 73665, '\P{Nv=0.006250}', "");
    Expect(1, 73665, '\P{^Nv=0.006250}', "");
    Expect(0, 73666, '\p{Nv=0.006250}', "");
    Expect(1, 73666, '\p{^Nv=0.006250}', "");
    Expect(1, 73666, '\P{Nv=0.006250}', "");
    Expect(0, 73666, '\P{^Nv=0.006250}', "");
    Error('\p{Is_Numeric_Value=-:=000001/00160}');
    Error('\P{Is_Numeric_Value=-:=000001/00160}');
    Expect(1, 73665, '\p{Is_Numeric_Value=+00000001/00000000160}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value=+00000001/00000000160}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value=+00000001/00000000160}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value=+00000001/00000000160}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value=+00000001/00000000160}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value=+00000001/00000000160}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value=+00000001/00000000160}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value=+00000001/00000000160}', "");
    Expect(1, 73665, '\p{Is_Numeric_Value=60/9600}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value=60/9600}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value=60/9600}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value=60/9600}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value=60/9600}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value=60/9600}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value=60/9600}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value=60/9600}', "");
    Error('\p{Is_Numeric_Value:	6.3e-03}');
    Error('\P{Is_Numeric_Value:	6.3e-03}');
    Expect(1, 73665, '\p{Is_Numeric_Value=6.25e-03}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value=6.25e-03}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value=6.25e-03}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value=6.25e-03}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value=6.25e-03}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value=6.25e-03}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value=6.25e-03}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value=6.25e-03}', "");
    Error('\p{Is_Numeric_Value=0.01}');
    Error('\P{Is_Numeric_Value=0.01}');
    Expect(1, 73665, '\p{Is_Numeric_Value=6.250e-03}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value=6.250e-03}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value=6.250e-03}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value=6.250e-03}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value=6.250e-03}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value=6.250e-03}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value=6.250e-03}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value=6.250e-03}', "");
    Error('\p{Is_Numeric_Value=0.006}');
    Error('\P{Is_Numeric_Value=0.006}');
    Expect(1, 73665, '\p{Is_Numeric_Value=6.2500e-03}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value=6.2500e-03}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value=6.2500e-03}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value=6.2500e-03}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value=6.2500e-03}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value=6.2500e-03}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value=6.2500e-03}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value=6.2500e-03}', "");
    Error('\p{Is_Numeric_Value=0.0063}');
    Error('\P{Is_Numeric_Value=0.0063}');
    Expect(1, 73665, '\p{Is_Numeric_Value=6.25000e-03}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value=6.25000e-03}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value=6.25000e-03}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value=6.25000e-03}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value=6.25000e-03}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value=6.25000e-03}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value=6.25000e-03}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value=6.25000e-03}', "");
    Expect(1, 73665, '\p{Is_Numeric_Value:0.00625}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value:0.00625}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value:0.00625}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value:0.00625}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value:0.00625}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value:0.00625}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value:0.00625}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value:0.00625}', "");
    Expect(1, 73665, '\p{Is_Numeric_Value=6.250000e-03}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value=6.250000e-03}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value=6.250000e-03}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value=6.250000e-03}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value=6.250000e-03}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value=6.250000e-03}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value=6.250000e-03}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value=6.250000e-03}', "");
    Expect(1, 73665, '\p{Is_Numeric_Value=0.006250}', "");
    Expect(0, 73665, '\p{^Is_Numeric_Value=0.006250}', "");
    Expect(0, 73665, '\P{Is_Numeric_Value=0.006250}', "");
    Expect(1, 73665, '\P{^Is_Numeric_Value=0.006250}', "");
    Expect(0, 73666, '\p{Is_Numeric_Value=0.006250}', "");
    Expect(1, 73666, '\p{^Is_Numeric_Value=0.006250}', "");
    Expect(1, 73666, '\P{Is_Numeric_Value=0.006250}', "");
    Expect(0, 73666, '\P{^Is_Numeric_Value=0.006250}', "");
    Error('\p{Is_Nv=/a/	_+0001/0000000160}');
    Error('\P{Is_Nv=/a/	_+0001/0000000160}');
    Expect(1, 73665, '\p{Is_Nv=1/0160}', "");
    Expect(0, 73665, '\p{^Is_Nv=1/0160}', "");
    Expect(0, 73665, '\P{Is_Nv=1/0160}', "");
    Expect(1, 73665, '\P{^Is_Nv=1/0160}', "");
    Expect(0, 73666, '\p{Is_Nv=1/0160}', "");
    Expect(1, 73666, '\p{^Is_Nv=1/0160}', "");
    Expect(1, 73666, '\P{Is_Nv=1/0160}', "");
    Expect(0, 73666, '\P{^Is_Nv=1/0160}', "");
    Expect(1, 73665, '\p{Is_Nv=60/9600}', "");
    Expect(0, 73665, '\p{^Is_Nv=60/9600}', "");
    Expect(0, 73665, '\P{Is_Nv=60/9600}', "");
    Expect(1, 73665, '\P{^Is_Nv=60/9600}', "");
    Expect(0, 73666, '\p{Is_Nv=60/9600}', "");
    Expect(1, 73666, '\p{^Is_Nv=60/9600}', "");
    Expect(1, 73666, '\P{Is_Nv=60/9600}', "");
    Expect(0, 73666, '\P{^Is_Nv=60/9600}', "");
    Error('\p{Is_Nv=6.3e-03}');
    Error('\P{Is_Nv=6.3e-03}');
    Expect(1, 73665, '\p{Is_Nv=6.25e-03}', "");
    Expect(0, 73665, '\p{^Is_Nv=6.25e-03}', "");
    Expect(0, 73665, '\P{Is_Nv=6.25e-03}', "");
    Expect(1, 73665, '\P{^Is_Nv=6.25e-03}', "");
    Expect(0, 73666, '\p{Is_Nv=6.25e-03}', "");
    Expect(1, 73666, '\p{^Is_Nv=6.25e-03}', "");
    Expect(1, 73666, '\P{Is_Nv=6.25e-03}', "");
    Expect(0, 73666, '\P{^Is_Nv=6.25e-03}', "");
    Error('\p{Is_Nv=0.01}');
    Error('\P{Is_Nv=0.01}');
    Expect(1, 73665, '\p{Is_Nv=6.250e-03}', "");
    Expect(0, 73665, '\p{^Is_Nv=6.250e-03}', "");
    Expect(0, 73665, '\P{Is_Nv=6.250e-03}', "");
    Expect(1, 73665, '\P{^Is_Nv=6.250e-03}', "");
    Expect(0, 73666, '\p{Is_Nv=6.250e-03}', "");
    Expect(1, 73666, '\p{^Is_Nv=6.250e-03}', "");
    Expect(1, 73666, '\P{Is_Nv=6.250e-03}', "");
    Expect(0, 73666, '\P{^Is_Nv=6.250e-03}', "");
    Error('\p{Is_Nv=0.006}');
    Error('\P{Is_Nv=0.006}');
    Expect(1, 73665, '\p{Is_Nv=6.2500e-03}', "");
    Expect(0, 73665, '\p{^Is_Nv=6.2500e-03}', "");
    Expect(0, 73665, '\P{Is_Nv=6.2500e-03}', "");
    Expect(1, 73665, '\P{^Is_Nv=6.2500e-03}', "");
    Expect(0, 73666, '\p{Is_Nv=6.2500e-03}', "");
    Expect(1, 73666, '\p{^Is_Nv=6.2500e-03}', "");
    Expect(1, 73666, '\P{Is_Nv=6.2500e-03}', "");
    Expect(0, 73666, '\P{^Is_Nv=6.2500e-03}', "");
    Error('\p{Is_Nv=0.0063}');
    Error('\P{Is_Nv=0.0063}');
    Expect(1, 73665, '\p{Is_Nv:	6.25000e-03}', "");
    Expect(0, 73665, '\p{^Is_Nv:	6.25000e-03}', "");
    Expect(0, 73665, '\P{Is_Nv:	6.25000e-03}', "");
    Expect(1, 73665, '\P{^Is_Nv:	6.25000e-03}', "");
    Expect(0, 73666, '\p{Is_Nv:	6.25000e-03}', "");
    Expect(1, 73666, '\p{^Is_Nv:	6.25000e-03}', "");
    Expect(1, 73666, '\P{Is_Nv:	6.25000e-03}', "");
    Expect(0, 73666, '\P{^Is_Nv:	6.25000e-03}', "");
    Expect(1, 73665, '\p{Is_Nv=0.00625}', "");
    Expect(0, 73665, '\p{^Is_Nv=0.00625}', "");
    Expect(0, 73665, '\P{Is_Nv=0.00625}', "");
    Expect(1, 73665, '\P{^Is_Nv=0.00625}', "");
    Expect(0, 73666, '\p{Is_Nv=0.00625}', "");
    Expect(1, 73666, '\p{^Is_Nv=0.00625}', "");
    Expect(1, 73666, '\P{Is_Nv=0.00625}', "");
    Expect(0, 73666, '\P{^Is_Nv=0.00625}', "");
    Expect(1, 73665, '\p{Is_Nv:	6.250000e-03}', "");
    Expect(0, 73665, '\p{^Is_Nv:	6.250000e-03}', "");
    Expect(0, 73665, '\P{Is_Nv:	6.250000e-03}', "");
    Expect(1, 73665, '\P{^Is_Nv:	6.250000e-03}', "");
    Expect(0, 73666, '\p{Is_Nv:	6.250000e-03}', "");
    Expect(1, 73666, '\p{^Is_Nv:	6.250000e-03}', "");
    Expect(1, 73666, '\P{Is_Nv:	6.250000e-03}', "");
    Expect(0, 73666, '\P{^Is_Nv:	6.250000e-03}', "");
    Expect(1, 73665, '\p{Is_Nv=0.006250}', "");
    Expect(0, 73665, '\p{^Is_Nv=0.006250}', "");
    Expect(0, 73665, '\P{Is_Nv=0.006250}', "");
    Expect(1, 73665, '\P{^Is_Nv=0.006250}', "");
    Expect(0, 73666, '\p{Is_Nv=0.006250}', "");
    Expect(1, 73666, '\p{^Is_Nv=0.006250}', "");
    Expect(1, 73666, '\P{Is_Nv=0.006250}', "");
    Expect(0, 73666, '\P{^Is_Nv=0.006250}', "");
    Error('\p{Numeric_Value=:=0001/02}');
    Error('\P{Numeric_Value=:=0001/02}');
    Expect(1, 126268, '\p{Numeric_Value=:\A1/2\z:}', "");;
    Expect(0, 126269, '\p{Numeric_Value=:\A1/2\z:}', "");;
    Expect(1, 126268, '\p{Numeric_Value=+000000001/002}', "");
    Expect(0, 126268, '\p{^Numeric_Value=+000000001/002}', "");
    Expect(0, 126268, '\P{Numeric_Value=+000000001/002}', "");
    Expect(1, 126268, '\P{^Numeric_Value=+000000001/002}', "");
    Expect(0, 126269, '\p{Numeric_Value=+000000001/002}', "");
    Expect(1, 126269, '\p{^Numeric_Value=+000000001/002}', "");
    Expect(1, 126269, '\P{Numeric_Value=+000000001/002}', "");
    Expect(0, 126269, '\P{^Numeric_Value=+000000001/002}', "");
    Expect(1, 126268, '\p{Numeric_Value=60/120}', "");
    Expect(0, 126268, '\p{^Numeric_Value=60/120}', "");
    Expect(0, 126268, '\P{Numeric_Value=60/120}', "");
    Expect(1, 126268, '\P{^Numeric_Value=60/120}', "");
    Expect(0, 126269, '\p{Numeric_Value=60/120}', "");
    Expect(1, 126269, '\p{^Numeric_Value=60/120}', "");
    Expect(1, 126269, '\P{Numeric_Value=60/120}', "");
    Expect(0, 126269, '\P{^Numeric_Value=60/120}', "");
    Expect(1, 126268, '\p{Numeric_Value=5.0e-01}', "");
    Expect(0, 126268, '\p{^Numeric_Value=5.0e-01}', "");
    Expect(0, 126268, '\P{Numeric_Value=5.0e-01}', "");
    Expect(1, 126268, '\P{^Numeric_Value=5.0e-01}', "");
    Expect(0, 126269, '\p{Numeric_Value=5.0e-01}', "");
    Expect(1, 126269, '\p{^Numeric_Value=5.0e-01}', "");
    Expect(1, 126269, '\P{Numeric_Value=5.0e-01}', "");
    Expect(0, 126269, '\P{^Numeric_Value=5.0e-01}', "");
    Expect(1, 126268, '\p{Numeric_Value=0.5}', "");
    Expect(0, 126268, '\p{^Numeric_Value=0.5}', "");
    Expect(0, 126268, '\P{Numeric_Value=0.5}', "");
    Expect(1, 126268, '\P{^Numeric_Value=0.5}', "");
    Expect(0, 126269, '\p{Numeric_Value=0.5}', "");
    Expect(1, 126269, '\p{^Numeric_Value=0.5}', "");
    Expect(1, 126269, '\P{Numeric_Value=0.5}', "");
    Expect(0, 126269, '\P{^Numeric_Value=0.5}', "");
    Expect(1, 126268, '\p{Numeric_Value: 5.00e-01}', "");
    Expect(0, 126268, '\p{^Numeric_Value: 5.00e-01}', "");
    Expect(0, 126268, '\P{Numeric_Value: 5.00e-01}', "");
    Expect(1, 126268, '\P{^Numeric_Value: 5.00e-01}', "");
    Expect(0, 126269, '\p{Numeric_Value: 5.00e-01}', "");
    Expect(1, 126269, '\p{^Numeric_Value: 5.00e-01}', "");
    Expect(1, 126269, '\P{Numeric_Value: 5.00e-01}', "");
    Expect(0, 126269, '\P{^Numeric_Value: 5.00e-01}', "");
    Expect(1, 126268, '\p{Numeric_Value=0.50}', "");
    Expect(0, 126268, '\p{^Numeric_Value=0.50}', "");
    Expect(0, 126268, '\P{Numeric_Value=0.50}', "");
    Expect(1, 126268, '\P{^Numeric_Value=0.50}', "");
    Expect(0, 126269, '\p{Numeric_Value=0.50}', "");
    Expect(1, 126269, '\p{^Numeric_Value=0.50}', "");
    Expect(1, 126269, '\P{Numeric_Value=0.50}', "");
    Expect(0, 126269, '\P{^Numeric_Value=0.50}', "");
    Error('\p{Nv:   - +0000001/00000002:=}');
    Error('\P{Nv:   - +0000001/00000002:=}');
    Expect(1, 126268, '\p{Nv=:\A1/2\z:}', "");;
    Expect(0, 126269, '\p{Nv=:\A1/2\z:}', "");;
    Expect(1, 126268, '\p{Nv=00001/02}', "");
    Expect(0, 126268, '\p{^Nv=00001/02}', "");
    Expect(0, 126268, '\P{Nv=00001/02}', "");
    Expect(1, 126268, '\P{^Nv=00001/02}', "");
    Expect(0, 126269, '\p{Nv=00001/02}', "");
    Expect(1, 126269, '\p{^Nv=00001/02}', "");
    Expect(1, 126269, '\P{Nv=00001/02}', "");
    Expect(0, 126269, '\P{^Nv=00001/02}', "");
    Expect(1, 126268, '\p{Nv=60/120}', "");
    Expect(0, 126268, '\p{^Nv=60/120}', "");
    Expect(0, 126268, '\P{Nv=60/120}', "");
    Expect(1, 126268, '\P{^Nv=60/120}', "");
    Expect(0, 126269, '\p{Nv=60/120}', "");
    Expect(1, 126269, '\p{^Nv=60/120}', "");
    Expect(1, 126269, '\P{Nv=60/120}', "");
    Expect(0, 126269, '\P{^Nv=60/120}', "");
    Expect(1, 126268, '\p{Nv=5.0e-01}', "");
    Expect(0, 126268, '\p{^Nv=5.0e-01}', "");
    Expect(0, 126268, '\P{Nv=5.0e-01}', "");
    Expect(1, 126268, '\P{^Nv=5.0e-01}', "");
    Expect(0, 126269, '\p{Nv=5.0e-01}', "");
    Expect(1, 126269, '\p{^Nv=5.0e-01}', "");
    Expect(1, 126269, '\P{Nv=5.0e-01}', "");
    Expect(0, 126269, '\P{^Nv=5.0e-01}', "");
    Expect(1, 126268, '\p{Nv=0.5}', "");
    Expect(0, 126268, '\p{^Nv=0.5}', "");
    Expect(0, 126268, '\P{Nv=0.5}', "");
    Expect(1, 126268, '\P{^Nv=0.5}', "");
    Expect(0, 126269, '\p{Nv=0.5}', "");
    Expect(1, 126269, '\p{^Nv=0.5}', "");
    Expect(1, 126269, '\P{Nv=0.5}', "");
    Expect(0, 126269, '\P{^Nv=0.5}', "");
    Expect(1, 126268, '\p{Nv=5.00e-01}', "");
    Expect(0, 126268, '\p{^Nv=5.00e-01}', "");
    Expect(0, 126268, '\P{Nv=5.00e-01}', "");
    Expect(1, 126268, '\P{^Nv=5.00e-01}', "");
    Expect(0, 126269, '\p{Nv=5.00e-01}', "");
    Expect(1, 126269, '\p{^Nv=5.00e-01}', "");
    Expect(1, 126269, '\P{Nv=5.00e-01}', "");
    Expect(0, 126269, '\P{^Nv=5.00e-01}', "");
    Expect(1, 126268, '\p{Nv:	0.50}', "");
    Expect(0, 126268, '\p{^Nv:	0.50}', "");
    Expect(0, 126268, '\P{Nv:	0.50}', "");
    Expect(1, 126268, '\P{^Nv:	0.50}', "");
    Expect(0, 126269, '\p{Nv:	0.50}', "");
    Expect(1, 126269, '\p{^Nv:	0.50}', "");
    Expect(1, 126269, '\P{Nv:	0.50}', "");
    Expect(0, 126269, '\P{^Nv:	0.50}', "");
    Error('\p{Is_Numeric_Value=/a/_-+000001/02}');
    Error('\P{Is_Numeric_Value=/a/_-+000001/02}');
    Expect(1, 126268, '\p{Is_Numeric_Value=00001/002}', "");
    Expect(0, 126268, '\p{^Is_Numeric_Value=00001/002}', "");
    Expect(0, 126268, '\P{Is_Numeric_Value=00001/002}', "");
    Expect(1, 126268, '\P{^Is_Numeric_Value=00001/002}', "");
    Expect(0, 126269, '\p{Is_Numeric_Value=00001/002}', "");
    Expect(1, 126269, '\p{^Is_Numeric_Value=00001/002}', "");
    Expect(1, 126269, '\P{Is_Numeric_Value=00001/002}', "");
    Expect(0, 126269, '\P{^Is_Numeric_Value=00001/002}', "");
    Expect(1, 126268, '\p{Is_Numeric_Value=60/120}', "");
    Expect(0, 126268, '\p{^Is_Numeric_Value=60/120}', "");
    Expect(0, 126268, '\P{Is_Numeric_Value=60/120}', "");
    Expect(1, 126268, '\P{^Is_Numeric_Value=60/120}', "");
    Expect(0, 126269, '\p{Is_Numeric_Value=60/120}', "");
    Expect(1, 126269, '\p{^Is_Numeric_Value=60/120}', "");
    Expect(1, 126269, '\P{Is_Numeric_Value=60/120}', "");
    Expect(0, 126269, '\P{^Is_Numeric_Value=60/120}', "");
    Expect(1, 126268, '\p{Is_Numeric_Value=5.0e-01}', "");
    Expect(0, 126268, '\p{^Is_Numeric_Value=5.0e-01}', "");
    Expect(0, 126268, '\P{Is_Numeric_Value=5.0e-01}', "");
    Expect(1, 126268, '\P{^Is_Numeric_Value=5.0e-01}', "");
    Expect(0, 126269, '\p{Is_Numeric_Value=5.0e-01}', "");
    Expect(1, 126269, '\p{^Is_Numeric_Value=5.0e-01}', "");
    Expect(1, 126269, '\P{Is_Numeric_Value=5.0e-01}', "");
    Expect(0, 126269, '\P{^Is_Numeric_Value=5.0e-01}', "");
    Expect(1, 126268, '\p{Is_Numeric_Value=0.5}', "");
    Expect(0, 126268, '\p{^Is_Numeric_Value=0.5}', "");
    Expect(0, 126268, '\P{Is_Numeric_Value=0.5}', "");
    Expect(1, 126268, '\P{^Is_Numeric_Value=0.5}', "");
    Expect(0, 126269, '\p{Is_Numeric_Value=0.5}', "");
    Expect(1, 126269, '\p{^Is_Numeric_Value=0.5}', "");
    Expect(1, 126269, '\P{Is_Numeric_Value=0.5}', "");
    Expect(0, 126269, '\P{^Is_Numeric_Value=0.5}', "");
    Expect(1, 126268, '\p{Is_Numeric_Value=5.00e-01}', "");
    Expect(0, 126268, '\p{^Is_Numeric_Value=5.00e-01}', "");
    Expect(0, 126268, '\P{Is_Numeric_Value=5.00e-01}', "");
    Expect(1, 126268, '\P{^Is_Numeric_Value=5.00e-01}', "");
    Expect(0, 126269, '\p{Is_Numeric_Value=5.00e-01}', "");
    Expect(1, 126269, '\p{^Is_Numeric_Value=5.00e-01}', "");
    Expect(1, 126269, '\P{Is_Numeric_Value=5.00e-01}', "");
    Expect(0, 126269, '\P{^Is_Numeric_Value=5.00e-01}', "");
    Expect(1, 126268, '\p{Is_Numeric_Value:0.50}', "");
    Expect(0, 126268, '\p{^Is_Numeric_Value:0.50}', "");
    Expect(0, 126268, '\P{Is_Numeric_Value:0.50}', "");
    Expect(1, 126268, '\P{^Is_Numeric_Value:0.50}', "");
    Expect(0, 126269, '\p{Is_Numeric_Value:0.50}', "");
    Expect(1, 126269, '\p{^Is_Numeric_Value:0.50}', "");
    Expect(1, 126269, '\P{Is_Numeric_Value:0.50}', "");
    Expect(0, 126269, '\P{^Is_Numeric_Value:0.50}', "");
    Error('\p{Is_Nv=:=_	000001/0002}');
    Error('\P{Is_Nv=:=_	000001/0002}');
    Expect(1, 126268, '\p{Is_Nv=00001/002}', "");
    Expect(0, 126268, '\p{^Is_Nv=00001/002}', "");
    Expect(0, 126268, '\P{Is_Nv=00001/002}', "");
    Expect(1, 126268, '\P{^Is_Nv=00001/002}', "");
    Expect(0, 126269, '\p{Is_Nv=00001/002}', "");
    Expect(1, 126269, '\p{^Is_Nv=00001/002}', "");
    Expect(1, 126269, '\P{Is_Nv=00001/002}', "");
    Expect(0, 126269, '\P{^Is_Nv=00001/002}', "");
    Expect(1, 126268, '\p{Is_Nv=60/120}', "");
    Expect(0, 126268, '\p{^Is_Nv=60/120}', "");
    Expect(0, 126268, '\P{Is_Nv=60/120}', "");
    Expect(1, 126268, '\P{^Is_Nv=60/120}', "");
    Expect(0, 126269, '\p{Is_Nv=60/120}', "");
    Expect(1, 126269, '\p{^Is_Nv=60/120}', "");
    Expect(1, 126269, '\P{Is_Nv=60/120}', "");
    Expect(0, 126269, '\P{^Is_Nv=60/120}', "");
    Expect(1, 126268, '\p{Is_Nv=5.0e-01}', "");
    Expect(0, 126268, '\p{^Is_Nv=5.0e-01}', "");
    Expect(0, 126268, '\P{Is_Nv=5.0e-01}', "");
    Expect(1, 126268, '\P{^Is_Nv=5.0e-01}', "");
    Expect(0, 126269, '\p{Is_Nv=5.0e-01}', "");
    Expect(1, 126269, '\p{^Is_Nv=5.0e-01}', "");
    Expect(1, 126269, '\P{Is_Nv=5.0e-01}', "");
    Expect(0, 126269, '\P{^Is_Nv=5.0e-01}', "");
    Expect(1, 126268, '\p{Is_Nv=0.5}', "");
    Expect(0, 126268, '\p{^Is_Nv=0.5}', "");
    Expect(0, 126268, '\P{Is_Nv=0.5}', "");
    Expect(1, 126268, '\P{^Is_Nv=0.5}', "");
    Expect(0, 126269, '\p{Is_Nv=0.5}', "");
    Expect(1, 126269, '\p{^Is_Nv=0.5}', "");
    Expect(1, 126269, '\P{Is_Nv=0.5}', "");
    Expect(0, 126269, '\P{^Is_Nv=0.5}', "");
    Expect(1, 126268, '\p{Is_Nv=5.00e-01}', "");
    Expect(0, 126268, '\p{^Is_Nv=5.00e-01}', "");
    Expect(0, 126268, '\P{Is_Nv=5.00e-01}', "");
    Expect(1, 126268, '\P{^Is_Nv=5.00e-01}', "");
    Expect(0, 126269, '\p{Is_Nv=5.00e-01}', "");
    Expect(1, 126269, '\p{^Is_Nv=5.00e-01}', "");
    Expect(1, 126269, '\P{Is_Nv=5.00e-01}', "");
    Expect(0, 126269, '\P{^Is_Nv=5.00e-01}', "");
    Expect(1, 126268, '\p{Is_Nv=0.50}', "");
    Expect(0, 126268, '\p{^Is_Nv=0.50}', "");
    Expect(0, 126268, '\P{Is_Nv=0.50}', "");
    Expect(1, 126268, '\P{^Is_Nv=0.50}', "");
    Expect(0, 126269, '\p{Is_Nv=0.50}', "");
    Expect(1, 126269, '\p{^Is_Nv=0.50}', "");
    Expect(1, 126269, '\P{Is_Nv=0.50}', "");
    Expect(0, 126269, '\P{^Is_Nv=0.50}', "");
    Error('\p{Numeric_Value= 	0000000001/000020:=}');
    Error('\P{Numeric_Value= 	0000000001/000020:=}');
    Expect(1, 73672, '\p{Numeric_Value=:\A1/20\z:}', "");;
    Expect(0, 73673, '\p{Numeric_Value=:\A1/20\z:}', "");;
    Expect(1, 73672, '\p{Numeric_Value=+01/00020}', "");
    Expect(0, 73672, '\p{^Numeric_Value=+01/00020}', "");
    Expect(0, 73672, '\P{Numeric_Value=+01/00020}', "");
    Expect(1, 73672, '\P{^Numeric_Value=+01/00020}', "");
    Expect(0, 73673, '\p{Numeric_Value=+01/00020}', "");
    Expect(1, 73673, '\p{^Numeric_Value=+01/00020}', "");
    Expect(1, 73673, '\P{Numeric_Value=+01/00020}', "");
    Expect(0, 73673, '\P{^Numeric_Value=+01/00020}', "");
    Expect(1, 73672, '\p{Numeric_Value=60/1200}', "");
    Expect(0, 73672, '\p{^Numeric_Value=60/1200}', "");
    Expect(0, 73672, '\P{Numeric_Value=60/1200}', "");
    Expect(1, 73672, '\P{^Numeric_Value=60/1200}', "");
    Expect(0, 73673, '\p{Numeric_Value=60/1200}', "");
    Expect(1, 73673, '\p{^Numeric_Value=60/1200}', "");
    Expect(1, 73673, '\P{Numeric_Value=60/1200}', "");
    Expect(0, 73673, '\P{^Numeric_Value=60/1200}', "");
    Expect(1, 73672, '\p{Numeric_Value=5.0e-02}', "");
    Expect(0, 73672, '\p{^Numeric_Value=5.0e-02}', "");
    Expect(0, 73672, '\P{Numeric_Value=5.0e-02}', "");
    Expect(1, 73672, '\P{^Numeric_Value=5.0e-02}', "");
    Expect(0, 73673, '\p{Numeric_Value=5.0e-02}', "");
    Expect(1, 73673, '\p{^Numeric_Value=5.0e-02}', "");
    Expect(1, 73673, '\P{Numeric_Value=5.0e-02}', "");
    Expect(0, 73673, '\P{^Numeric_Value=5.0e-02}', "");
    Expect(1, 73672, '\p{Numeric_Value=5.00e-02}', "");
    Expect(0, 73672, '\p{^Numeric_Value=5.00e-02}', "");
    Expect(0, 73672, '\P{Numeric_Value=5.00e-02}', "");
    Expect(1, 73672, '\P{^Numeric_Value=5.00e-02}', "");
    Expect(0, 73673, '\p{Numeric_Value=5.00e-02}', "");
    Expect(1, 73673, '\p{^Numeric_Value=5.00e-02}', "");
    Expect(1, 73673, '\P{Numeric_Value=5.00e-02}', "");
    Expect(0, 73673, '\P{^Numeric_Value=5.00e-02}', "");
    Expect(1, 73672, '\p{Numeric_Value=0.05}', "");
    Expect(0, 73672, '\p{^Numeric_Value=0.05}', "");
    Expect(0, 73672, '\P{Numeric_Value=0.05}', "");
    Expect(1, 73672, '\P{^Numeric_Value=0.05}', "");
    Expect(0, 73673, '\p{Numeric_Value=0.05}', "");
    Expect(1, 73673, '\p{^Numeric_Value=0.05}', "");
    Expect(1, 73673, '\P{Numeric_Value=0.05}', "");
    Expect(0, 73673, '\P{^Numeric_Value=0.05}', "");
    Expect(1, 73672, '\p{Numeric_Value=5.000e-02}', "");
    Expect(0, 73672, '\p{^Numeric_Value=5.000e-02}', "");
    Expect(0, 73672, '\P{Numeric_Value=5.000e-02}', "");
    Expect(1, 73672, '\P{^Numeric_Value=5.000e-02}', "");
    Expect(0, 73673, '\p{Numeric_Value=5.000e-02}', "");
    Expect(1, 73673, '\p{^Numeric_Value=5.000e-02}', "");
    Expect(1, 73673, '\P{Numeric_Value=5.000e-02}', "");
    Expect(0, 73673, '\P{^Numeric_Value=5.000e-02}', "");
    Expect(1, 73672, '\p{Numeric_Value=0.050}', "");
    Expect(0, 73672, '\p{^Numeric_Value=0.050}', "");
    Expect(0, 73672, '\P{Numeric_Value=0.050}', "");
    Expect(1, 73672, '\P{^Numeric_Value=0.050}', "");
    Expect(0, 73673, '\p{Numeric_Value=0.050}', "");
    Expect(1, 73673, '\p{^Numeric_Value=0.050}', "");
    Expect(1, 73673, '\P{Numeric_Value=0.050}', "");
    Expect(0, 73673, '\P{^Numeric_Value=0.050}', "");
    Error('\p{Nv=:=  01/20}');
    Error('\P{Nv=:=  01/20}');
    Expect(1, 73672, '\p{Nv=:\A1/20\z:}', "");;
    Expect(0, 73673, '\p{Nv=:\A1/20\z:}', "");;
    Expect(1, 73672, '\p{Nv=000001/20}', "");
    Expect(0, 73672, '\p{^Nv=000001/20}', "");
    Expect(0, 73672, '\P{Nv=000001/20}', "");
    Expect(1, 73672, '\P{^Nv=000001/20}', "");
    Expect(0, 73673, '\p{Nv=000001/20}', "");
    Expect(1, 73673, '\p{^Nv=000001/20}', "");
    Expect(1, 73673, '\P{Nv=000001/20}', "");
    Expect(0, 73673, '\P{^Nv=000001/20}', "");
    Expect(1, 73672, '\p{Nv=60/1200}', "");
    Expect(0, 73672, '\p{^Nv=60/1200}', "");
    Expect(0, 73672, '\P{Nv=60/1200}', "");
    Expect(1, 73672, '\P{^Nv=60/1200}', "");
    Expect(0, 73673, '\p{Nv=60/1200}', "");
    Expect(1, 73673, '\p{^Nv=60/1200}', "");
    Expect(1, 73673, '\P{Nv=60/1200}', "");
    Expect(0, 73673, '\P{^Nv=60/1200}', "");
    Expect(1, 73672, '\p{Nv=5.0e-02}', "");
    Expect(0, 73672, '\p{^Nv=5.0e-02}', "");
    Expect(0, 73672, '\P{Nv=5.0e-02}', "");
    Expect(1, 73672, '\P{^Nv=5.0e-02}', "");
    Expect(0, 73673, '\p{Nv=5.0e-02}', "");
    Expect(1, 73673, '\p{^Nv=5.0e-02}', "");
    Expect(1, 73673, '\P{Nv=5.0e-02}', "");
    Expect(0, 73673, '\P{^Nv=5.0e-02}', "");
    Expect(1, 73672, '\p{Nv=5.00e-02}', "");
    Expect(0, 73672, '\p{^Nv=5.00e-02}', "");
    Expect(0, 73672, '\P{Nv=5.00e-02}', "");
    Expect(1, 73672, '\P{^Nv=5.00e-02}', "");
    Expect(0, 73673, '\p{Nv=5.00e-02}', "");
    Expect(1, 73673, '\p{^Nv=5.00e-02}', "");
    Expect(1, 73673, '\P{Nv=5.00e-02}', "");
    Expect(0, 73673, '\P{^Nv=5.00e-02}', "");
    Expect(1, 73672, '\p{Nv=0.05}', "");
    Expect(0, 73672, '\p{^Nv=0.05}', "");
    Expect(0, 73672, '\P{Nv=0.05}', "");
    Expect(1, 73672, '\P{^Nv=0.05}', "");
    Expect(0, 73673, '\p{Nv=0.05}', "");
    Expect(1, 73673, '\p{^Nv=0.05}', "");
    Expect(1, 73673, '\P{Nv=0.05}', "");
    Expect(0, 73673, '\P{^Nv=0.05}', "");
    Expect(1, 73672, '\p{Nv=5.000e-02}', "");
    Expect(0, 73672, '\p{^Nv=5.000e-02}', "");
    Expect(0, 73672, '\P{Nv=5.000e-02}', "");
    Expect(1, 73672, '\P{^Nv=5.000e-02}', "");
    Expect(0, 73673, '\p{Nv=5.000e-02}', "");
    Expect(1, 73673, '\p{^Nv=5.000e-02}', "");
    Expect(1, 73673, '\P{Nv=5.000e-02}', "");
    Expect(0, 73673, '\P{^Nv=5.000e-02}', "");
    Expect(1, 73672, '\p{Nv=0.050}', "");
    Expect(0, 73672, '\p{^Nv=0.050}', "");
    Expect(0, 73672, '\P{Nv=0.050}', "");
    Expect(1, 73672, '\P{^Nv=0.050}', "");
    Expect(0, 73673, '\p{Nv=0.050}', "");
    Expect(1, 73673, '\p{^Nv=0.050}', "");
    Expect(1, 73673, '\P{Nv=0.050}', "");
    Expect(0, 73673, '\P{^Nv=0.050}', "");
    Error('\p{Is_Numeric_Value=_:=1/000000020}');
    Error('\P{Is_Numeric_Value=_:=1/000000020}');
    Expect(1, 73672, '\p{Is_Numeric_Value=+0000000001/00000020}', "");
    Expect(0, 73672, '\p{^Is_Numeric_Value=+0000000001/00000020}', "");
    Expect(0, 73672, '\P{Is_Numeric_Value=+0000000001/00000020}', "");
    Expect(1, 73672, '\P{^Is_Numeric_Value=+0000000001/00000020}', "");
    Expect(0, 73673, '\p{Is_Numeric_Value=+0000000001/00000020}', "");
    Expect(1, 73673, '\p{^Is_Numeric_Value=+0000000001/00000020}', "");
    Expect(1, 73673, '\P{Is_Numeric_Value=+0000000001/00000020}', "");
    Expect(0, 73673, '\P{^Is_Numeric_Value=+0000000001/00000020}', "");
    Expect(1, 73672, '\p{Is_Numeric_Value=60/1200}', "");
    Expect(0, 73672, '\p{^Is_Numeric_Value=60/1200}', "");
    Expect(0, 73672, '\P{Is_Numeric_Value=60/1200}', "");
    Expect(1, 73672, '\P{^Is_Numeric_Value=60/1200}', "");
    Expect(0, 73673, '\p{Is_Numeric_Value=60/1200}', "");
    Expect(1, 73673, '\p{^Is_Numeric_Value=60/1200}', "");
    Expect(1, 73673, '\P{Is_Numeric_Value=60/1200}', "");
    Expect(0, 73673, '\P{^Is_Numeric_Value=60/1200}', "");
    Expect(1, 73672, '\p{Is_Numeric_Value=5.0e-02}', "");
    Expect(0, 73672, '\p{^Is_Numeric_Value=5.0e-02}', "");
    Expect(0, 73672, '\P{Is_Numeric_Value=5.0e-02}', "");
    Expect(1, 73672, '\P{^Is_Numeric_Value=5.0e-02}', "");
    Expect(0, 73673, '\p{Is_Numeric_Value=5.0e-02}', "");
    Expect(1, 73673, '\p{^Is_Numeric_Value=5.0e-02}', "");
    Expect(1, 73673, '\P{Is_Numeric_Value=5.0e-02}', "");
    Expect(0, 73673, '\P{^Is_Numeric_Value=5.0e-02}', "");
    Expect(1, 73672, '\p{Is_Numeric_Value=5.00e-02}', "");
    Expect(0, 73672, '\p{^Is_Numeric_Value=5.00e-02}', "");
    Expect(0, 73672, '\P{Is_Numeric_Value=5.00e-02}', "");
    Expect(1, 73672, '\P{^Is_Numeric_Value=5.00e-02}', "");
    Expect(0, 73673, '\p{Is_Numeric_Value=5.00e-02}', "");
    Expect(1, 73673, '\p{^Is_Numeric_Value=5.00e-02}', "");
    Expect(1, 73673, '\P{Is_Numeric_Value=5.00e-02}', "");
    Expect(0, 73673, '\P{^Is_Numeric_Value=5.00e-02}', "");
    Expect(1, 73672, '\p{Is_Numeric_Value=0.05}', "");
    Expect(0, 73672, '\p{^Is_Numeric_Value=0.05}', "");
    Expect(0, 73672, '\P{Is_Numeric_Value=0.05}', "");
    Expect(1, 73672, '\P{^Is_Numeric_Value=0.05}', "");
    Expect(0, 73673, '\p{Is_Numeric_Value=0.05}', "");
    Expect(1, 73673, '\p{^Is_Numeric_Value=0.05}', "");
    Expect(1, 73673, '\P{Is_Numeric_Value=0.05}', "");
    Expect(0, 73673, '\P{^Is_Numeric_Value=0.05}', "");
    Expect(1, 73672, '\p{Is_Numeric_Value=5.000e-02}', "");
    Expect(0, 73672, '\p{^Is_Numeric_Value=5.000e-02}', "");
    Expect(0, 73672, '\P{Is_Numeric_Value=5.000e-02}', "");
    Expect(1, 73672, '\P{^Is_Numeric_Value=5.000e-02}', "");
    Expect(0, 73673, '\p{Is_Numeric_Value=5.000e-02}', "");
    Expect(1, 73673, '\p{^Is_Numeric_Value=5.000e-02}', "");
    Expect(1, 73673, '\P{Is_Numeric_Value=5.000e-02}', "");
    Expect(0, 73673, '\P{^Is_Numeric_Value=5.000e-02}', "");
    Expect(1, 73672, '\p{Is_Numeric_Value: 0.050}', "");
    Expect(0, 73672, '\p{^Is_Numeric_Value: 0.050}', "");
    Expect(0, 73672, '\P{Is_Numeric_Value: 0.050}', "");
    Expect(1, 73672, '\P{^Is_Numeric_Value: 0.050}', "");
    Expect(0, 73673, '\p{Is_Numeric_Value: 0.050}', "");
    Expect(1, 73673, '\p{^Is_Numeric_Value: 0.050}', "");
    Expect(1, 73673, '\P{Is_Numeric_Value: 0.050}', "");
    Expect(0, 73673, '\P{^Is_Numeric_Value: 0.050}', "");
    Error('\p{Is_Nv=-/a/0000001/20}');
    Error('\P{Is_Nv=-/a/0000001/20}');
    Expect(1, 73672, '\p{Is_Nv=000001/020}', "");
    Expect(0, 73672, '\p{^Is_Nv=000001/020}', "");
    Expect(0, 73672, '\P{Is_Nv=000001/020}', "");
    Expect(1, 73672, '\P{^Is_Nv=000001/020}', "");
    Expect(0, 73673, '\p{Is_Nv=000001/020}', "");
    Expect(1, 73673, '\p{^Is_Nv=000001/020}', "");
    Expect(1, 73673, '\P{Is_Nv=000001/020}', "");
    Expect(0, 73673, '\P{^Is_Nv=000001/020}', "");
    Expect(1, 73672, '\p{Is_Nv=60/1200}', "");
    Expect(0, 73672, '\p{^Is_Nv=60/1200}', "");
    Expect(0, 73672, '\P{Is_Nv=60/1200}', "");
    Expect(1, 73672, '\P{^Is_Nv=60/1200}', "");
    Expect(0, 73673, '\p{Is_Nv=60/1200}', "");
    Expect(1, 73673, '\p{^Is_Nv=60/1200}', "");
    Expect(1, 73673, '\P{Is_Nv=60/1200}', "");
    Expect(0, 73673, '\P{^Is_Nv=60/1200}', "");
    Expect(1, 73672, '\p{Is_Nv:   5.0e-02}', "");
    Expect(0, 73672, '\p{^Is_Nv:   5.0e-02}', "");
    Expect(0, 73672, '\P{Is_Nv:   5.0e-02}', "");
    Expect(1, 73672, '\P{^Is_Nv:   5.0e-02}', "");
    Expect(0, 73673, '\p{Is_Nv:   5.0e-02}', "");
    Expect(1, 73673, '\p{^Is_Nv:   5.0e-02}', "");
    Expect(1, 73673, '\P{Is_Nv:   5.0e-02}', "");
    Expect(0, 73673, '\P{^Is_Nv:   5.0e-02}', "");
    Expect(1, 73672, '\p{Is_Nv=5.00e-02}', "");
    Expect(0, 73672, '\p{^Is_Nv=5.00e-02}', "");
    Expect(0, 73672, '\P{Is_Nv=5.00e-02}', "");
    Expect(1, 73672, '\P{^Is_Nv=5.00e-02}', "");
    Expect(0, 73673, '\p{Is_Nv=5.00e-02}', "");
    Expect(1, 73673, '\p{^Is_Nv=5.00e-02}', "");
    Expect(1, 73673, '\P{Is_Nv=5.00e-02}', "");
    Expect(0, 73673, '\P{^Is_Nv=5.00e-02}', "");
    Expect(1, 73672, '\p{Is_Nv=0.05}', "");
    Expect(0, 73672, '\p{^Is_Nv=0.05}', "");
    Expect(0, 73672, '\P{Is_Nv=0.05}', "");
    Expect(1, 73672, '\P{^Is_Nv=0.05}', "");
    Expect(0, 73673, '\p{Is_Nv=0.05}', "");
    Expect(1, 73673, '\p{^Is_Nv=0.05}', "");
    Expect(1, 73673, '\P{Is_Nv=0.05}', "");
    Expect(0, 73673, '\P{^Is_Nv=0.05}', "");
    Expect(1, 73672, '\p{Is_Nv=5.000e-02}', "");
    Expect(0, 73672, '\p{^Is_Nv=5.000e-02}', "");
    Expect(0, 73672, '\P{Is_Nv=5.000e-02}', "");
    Expect(1, 73672, '\P{^Is_Nv=5.000e-02}', "");
    Expect(0, 73673, '\p{Is_Nv=5.000e-02}', "");
    Expect(1, 73673, '\p{^Is_Nv=5.000e-02}', "");
    Expect(1, 73673, '\P{Is_Nv=5.000e-02}', "");
    Expect(0, 73673, '\P{^Is_Nv=5.000e-02}', "");
    Expect(1, 73672, '\p{Is_Nv: 0.050}', "");
    Expect(0, 73672, '\p{^Is_Nv: 0.050}', "");
    Expect(0, 73672, '\P{Is_Nv: 0.050}', "");
    Expect(1, 73672, '\P{^Is_Nv: 0.050}', "");
    Expect(0, 73673, '\p{Is_Nv: 0.050}', "");
    Expect(1, 73673, '\p{^Is_Nv: 0.050}', "");
    Expect(1, 73673, '\P{Is_Nv: 0.050}', "");
    Expect(0, 73673, '\P{^Is_Nv: 0.050}', "");
    Error('\p{Numeric_Value= /a/1/000003}');
    Error('\P{Numeric_Value= /a/1/000003}');
    Expect(1, 74853, '\p{Numeric_Value=:\A1/3\z:}', "");;
    Expect(0, 74854, '\p{Numeric_Value=:\A1/3\z:}', "");;
    Expect(1, 74853, '\p{Numeric_Value=00000001/00000003}', "");
    Expect(0, 74853, '\p{^Numeric_Value=00000001/00000003}', "");
    Expect(0, 74853, '\P{Numeric_Value=00000001/00000003}', "");
    Expect(1, 74853, '\P{^Numeric_Value=00000001/00000003}', "");
    Expect(0, 74854, '\p{Numeric_Value=00000001/00000003}', "");
    Expect(1, 74854, '\p{^Numeric_Value=00000001/00000003}', "");
    Expect(1, 74854, '\P{Numeric_Value=00000001/00000003}', "");
    Expect(0, 74854, '\P{^Numeric_Value=00000001/00000003}', "");
    Expect(1, 74853, '\p{Numeric_Value=60/180}', "");
    Expect(0, 74853, '\p{^Numeric_Value=60/180}', "");
    Expect(0, 74853, '\P{Numeric_Value=60/180}', "");
    Expect(1, 74853, '\P{^Numeric_Value=60/180}', "");
    Expect(0, 74854, '\p{Numeric_Value=60/180}', "");
    Expect(1, 74854, '\p{^Numeric_Value=60/180}', "");
    Expect(1, 74854, '\P{Numeric_Value=60/180}', "");
    Expect(0, 74854, '\P{^Numeric_Value=60/180}', "");
    Error('\p{Numeric_Value=3.3e-01}');
    Error('\P{Numeric_Value=3.3e-01}');
    Error('\p{Numeric_Value:0.3}');
    Error('\P{Numeric_Value:0.3}');
    Expect(1, 74853, '\p{Numeric_Value=3.33e-01}', "");
    Expect(0, 74853, '\p{^Numeric_Value=3.33e-01}', "");
    Expect(0, 74853, '\P{Numeric_Value=3.33e-01}', "");
    Expect(1, 74853, '\P{^Numeric_Value=3.33e-01}', "");
    Expect(0, 74854, '\p{Numeric_Value=3.33e-01}', "");
    Expect(1, 74854, '\p{^Numeric_Value=3.33e-01}', "");
    Expect(1, 74854, '\P{Numeric_Value=3.33e-01}', "");
    Expect(0, 74854, '\P{^Numeric_Value=3.33e-01}', "");
    Error('\p{Numeric_Value=0.33}');
    Error('\P{Numeric_Value=0.33}');
    Expect(1, 74853, '\p{Numeric_Value:	3.333e-01}', "");
    Expect(0, 74853, '\p{^Numeric_Value:	3.333e-01}', "");
    Expect(0, 74853, '\P{Numeric_Value:	3.333e-01}', "");
    Expect(1, 74853, '\P{^Numeric_Value:	3.333e-01}', "");
    Expect(0, 74854, '\p{Numeric_Value:	3.333e-01}', "");
    Expect(1, 74854, '\p{^Numeric_Value:	3.333e-01}', "");
    Expect(1, 74854, '\P{Numeric_Value:	3.333e-01}', "");
    Expect(0, 74854, '\P{^Numeric_Value:	3.333e-01}', "");
    Expect(1, 74853, '\p{Numeric_Value=0.333}', "");
    Expect(0, 74853, '\p{^Numeric_Value=0.333}', "");
    Expect(0, 74853, '\P{Numeric_Value=0.333}', "");
    Expect(1, 74853, '\P{^Numeric_Value=0.333}', "");
    Expect(0, 74854, '\p{Numeric_Value=0.333}', "");
    Expect(1, 74854, '\p{^Numeric_Value=0.333}', "");
    Expect(1, 74854, '\P{Numeric_Value=0.333}', "");
    Expect(0, 74854, '\P{^Numeric_Value=0.333}', "");
    Expect(1, 74853, '\p{Numeric_Value=3.3333e-01}', "");
    Expect(0, 74853, '\p{^Numeric_Value=3.3333e-01}', "");
    Expect(0, 74853, '\P{Numeric_Value=3.3333e-01}', "");
    Expect(1, 74853, '\P{^Numeric_Value=3.3333e-01}', "");
    Expect(0, 74854, '\p{Numeric_Value=3.3333e-01}', "");
    Expect(1, 74854, '\p{^Numeric_Value=3.3333e-01}', "");
    Expect(1, 74854, '\P{Numeric_Value=3.3333e-01}', "");
    Expect(0, 74854, '\P{^Numeric_Value=3.3333e-01}', "");
    Expect(1, 74853, '\p{Numeric_Value=0.3333}', "");
    Expect(0, 74853, '\p{^Numeric_Value=0.3333}', "");
    Expect(0, 74853, '\P{Numeric_Value=0.3333}', "");
    Expect(1, 74853, '\P{^Numeric_Value=0.3333}', "");
    Expect(0, 74854, '\p{Numeric_Value=0.3333}', "");
    Expect(1, 74854, '\p{^Numeric_Value=0.3333}', "");
    Expect(1, 74854, '\P{Numeric_Value=0.3333}', "");
    Expect(0, 74854, '\P{^Numeric_Value=0.3333}', "");
    Error('\p{Nv=-+000001/0003/a/}');
    Error('\P{Nv=-+000001/0003/a/}');
    Expect(1, 74853, '\p{Nv=:\A1/3\z:}', "");;
    Expect(0, 74854, '\p{Nv=:\A1/3\z:}', "");;
    Expect(1, 74853, '\p{Nv=+000001/0000000003}', "");
    Expect(0, 74853, '\p{^Nv=+000001/0000000003}', "");
    Expect(0, 74853, '\P{Nv=+000001/0000000003}', "");
    Expect(1, 74853, '\P{^Nv=+000001/0000000003}', "");
    Expect(0, 74854, '\p{Nv=+000001/0000000003}', "");
    Expect(1, 74854, '\p{^Nv=+000001/0000000003}', "");
    Expect(1, 74854, '\P{Nv=+000001/0000000003}', "");
    Expect(0, 74854, '\P{^Nv=+000001/0000000003}', "");
    Expect(1, 74853, '\p{Nv=60/180}', "");
    Expect(0, 74853, '\p{^Nv=60/180}', "");
    Expect(0, 74853, '\P{Nv=60/180}', "");
    Expect(1, 74853, '\P{^Nv=60/180}', "");
    Expect(0, 74854, '\p{Nv=60/180}', "");
    Expect(1, 74854, '\p{^Nv=60/180}', "");
    Expect(1, 74854, '\P{Nv=60/180}', "");
    Expect(0, 74854, '\P{^Nv=60/180}', "");
    Error('\p{Nv=3.3e-01}');
    Error('\P{Nv=3.3e-01}');
    Error('\p{Nv: 0.3}');
    Error('\P{Nv: 0.3}');
    Expect(1, 74853, '\p{Nv:3.33e-01}', "");
    Expect(0, 74853, '\p{^Nv:3.33e-01}', "");
    Expect(0, 74853, '\P{Nv:3.33e-01}', "");
    Expect(1, 74853, '\P{^Nv:3.33e-01}', "");
    Expect(0, 74854, '\p{Nv:3.33e-01}', "");
    Expect(1, 74854, '\p{^Nv:3.33e-01}', "");
    Expect(1, 74854, '\P{Nv:3.33e-01}', "");
    Expect(0, 74854, '\P{^Nv:3.33e-01}', "");
    Error('\p{Nv=0.33}');
    Error('\P{Nv=0.33}');
    Expect(1, 74853, '\p{Nv=3.333e-01}', "");
    Expect(0, 74853, '\p{^Nv=3.333e-01}', "");
    Expect(0, 74853, '\P{Nv=3.333e-01}', "");
    Expect(1, 74853, '\P{^Nv=3.333e-01}', "");
    Expect(0, 74854, '\p{Nv=3.333e-01}', "");
    Expect(1, 74854, '\p{^Nv=3.333e-01}', "");
    Expect(1, 74854, '\P{Nv=3.333e-01}', "");
    Expect(0, 74854, '\P{^Nv=3.333e-01}', "");
    Expect(1, 74853, '\p{Nv=0.333}', "");
    Expect(0, 74853, '\p{^Nv=0.333}', "");
    Expect(0, 74853, '\P{Nv=0.333}', "");
    Expect(1, 74853, '\P{^Nv=0.333}', "");
    Expect(0, 74854, '\p{Nv=0.333}', "");
    Expect(1, 74854, '\p{^Nv=0.333}', "");
    Expect(1, 74854, '\P{Nv=0.333}', "");
    Expect(0, 74854, '\P{^Nv=0.333}', "");
    Expect(1, 74853, '\p{Nv=3.3333e-01}', "");
    Expect(0, 74853, '\p{^Nv=3.3333e-01}', "");
    Expect(0, 74853, '\P{Nv=3.3333e-01}', "");
    Expect(1, 74853, '\P{^Nv=3.3333e-01}', "");
    Expect(0, 74854, '\p{Nv=3.3333e-01}', "");
    Expect(1, 74854, '\p{^Nv=3.3333e-01}', "");
    Expect(1, 74854, '\P{Nv=3.3333e-01}', "");
    Expect(0, 74854, '\P{^Nv=3.3333e-01}', "");
    Expect(1, 74853, '\p{Nv=0.3333}', "");
    Expect(0, 74853, '\p{^Nv=0.3333}', "");
    Expect(0, 74853, '\P{Nv=0.3333}', "");
    Expect(1, 74853, '\P{^Nv=0.3333}', "");
    Expect(0, 74854, '\p{Nv=0.3333}', "");
    Expect(1, 74854, '\p{^Nv=0.3333}', "");
    Expect(1, 74854, '\P{Nv=0.3333}', "");
    Expect(0, 74854, '\P{^Nv=0.3333}', "");
    Error('\p{Is_Numeric_Value=-:=+000000001/000003}');
    Error('\P{Is_Numeric_Value=-:=+000000001/000003}');
    Expect(1, 74853, '\p{Is_Numeric_Value=0000001/000003}', "");
    Expect(0, 74853, '\p{^Is_Numeric_Value=0000001/000003}', "");
    Expect(0, 74853, '\P{Is_Numeric_Value=0000001/000003}', "");
    Expect(1, 74853, '\P{^Is_Numeric_Value=0000001/000003}', "");
    Expect(0, 74854, '\p{Is_Numeric_Value=0000001/000003}', "");
    Expect(1, 74854, '\p{^Is_Numeric_Value=0000001/000003}', "");
    Expect(1, 74854, '\P{Is_Numeric_Value=0000001/000003}', "");
    Expect(0, 74854, '\P{^Is_Numeric_Value=0000001/000003}', "");
    Expect(1, 74853, '\p{Is_Numeric_Value: 60/180}', "");
    Expect(0, 74853, '\p{^Is_Numeric_Value: 60/180}', "");
    Expect(0, 74853, '\P{Is_Numeric_Value: 60/180}', "");
    Expect(1, 74853, '\P{^Is_Numeric_Value: 60/180}', "");
    Expect(0, 74854, '\p{Is_Numeric_Value: 60/180}', "");
    Expect(1, 74854, '\p{^Is_Numeric_Value: 60/180}', "");
    Expect(1, 74854, '\P{Is_Numeric_Value: 60/180}', "");
    Expect(0, 74854, '\P{^Is_Numeric_Value: 60/180}', "");
    Error('\p{Is_Numeric_Value=3.3e-01}');
    Error('\P{Is_Numeric_Value=3.3e-01}');
    Error('\p{Is_Numeric_Value:	0.3}');
    Error('\P{Is_Numeric_Value:	0.3}');
    Expect(1, 74853, '\p{Is_Numeric_Value=3.33e-01}', "");
    Expect(0, 74853, '\p{^Is_Numeric_Value=3.33e-01}', "");
    Expect(0, 74853, '\P{Is_Numeric_Value=3.33e-01}', "");
    Expect(1, 74853, '\P{^Is_Numeric_Value=3.33e-01}', "");
    Expect(0, 74854, '\p{Is_Numeric_Value=3.33e-01}', "");
    Expect(1, 74854, '\p{^Is_Numeric_Value=3.33e-01}', "");
    Expect(1, 74854, '\P{Is_Numeric_Value=3.33e-01}', "");
    Expect(0, 74854, '\P{^Is_Numeric_Value=3.33e-01}', "");
    Error('\p{Is_Numeric_Value=0.33}');
    Error('\P{Is_Numeric_Value=0.33}');
    Expect(1, 74853, '\p{Is_Numeric_Value=3.333e-01}', "");
    Expect(0, 74853, '\p{^Is_Numeric_Value=3.333e-01}', "");
    Expect(0, 74853, '\P{Is_Numeric_Value=3.333e-01}', "");
    Expect(1, 74853, '\P{^Is_Numeric_Value=3.333e-01}', "");
    Expect(0, 74854, '\p{Is_Numeric_Value=3.333e-01}', "");
    Expect(1, 74854, '\p{^Is_Numeric_Value=3.333e-01}', "");
    Expect(1, 74854, '\P{Is_Numeric_Value=3.333e-01}', "");
    Expect(0, 74854, '\P{^Is_Numeric_Value=3.333e-01}', "");
    Expect(1, 74853, '\p{Is_Numeric_Value=0.333}', "");
    Expect(0, 74853, '\p{^Is_Numeric_Value=0.333}', "");
    Expect(0, 74853, '\P{Is_Numeric_Value=0.333}', "");
    Expect(1, 74853, '\P{^Is_Numeric_Value=0.333}', "");
    Expect(0, 74854, '\p{Is_Numeric_Value=0.333}', "");
    Expect(1, 74854, '\p{^Is_Numeric_Value=0.333}', "");
    Expect(1, 74854, '\P{Is_Numeric_Value=0.333}', "");
    Expect(0, 74854, '\P{^Is_Numeric_Value=0.333}', "");
    Expect(1, 74853, '\p{Is_Numeric_Value=3.3333e-01}', "");
    Expect(0, 74853, '\p{^Is_Numeric_Value=3.3333e-01}', "");
    Expect(0, 74853, '\P{Is_Numeric_Value=3.3333e-01}', "");
    Expect(1, 74853, '\P{^Is_Numeric_Value=3.3333e-01}', "");
    Expect(0, 74854, '\p{Is_Numeric_Value=3.3333e-01}', "");
    Expect(1, 74854, '\p{^Is_Numeric_Value=3.3333e-01}', "");
    Expect(1, 74854, '\P{Is_Numeric_Value=3.3333e-01}', "");
    Expect(0, 74854, '\P{^Is_Numeric_Value=3.3333e-01}', "");
    Expect(1, 74853, '\p{Is_Numeric_Value:   0.3333}', "");
    Expect(0, 74853, '\p{^Is_Numeric_Value:   0.3333}', "");
    Expect(0, 74853, '\P{Is_Numeric_Value:   0.3333}', "");
    Expect(1, 74853, '\P{^Is_Numeric_Value:   0.3333}', "");
    Expect(0, 74854, '\p{Is_Numeric_Value:   0.3333}', "");
    Expect(1, 74854, '\p{^Is_Numeric_Value:   0.3333}', "");
    Expect(1, 74854, '\P{Is_Numeric_Value:   0.3333}', "");
    Expect(0, 74854, '\P{^Is_Numeric_Value:   0.3333}', "");
    Error('\p{Is_Nv=:=_00001/00003}');
    Error('\P{Is_Nv=:=_00001/00003}');
    Expect(1, 74853, '\p{Is_Nv=00001/000000003}', "");
    Expect(0, 74853, '\p{^Is_Nv=00001/000000003}', "");
    Expect(0, 74853, '\P{Is_Nv=00001/000000003}', "");
    Expect(1, 74853, '\P{^Is_Nv=00001/000000003}', "");
    Expect(0, 74854, '\p{Is_Nv=00001/000000003}', "");
    Expect(1, 74854, '\p{^Is_Nv=00001/000000003}', "");
    Expect(1, 74854, '\P{Is_Nv=00001/000000003}', "");
    Expect(0, 74854, '\P{^Is_Nv=00001/000000003}', "");
    Expect(1, 74853, '\p{Is_Nv=60/180}', "");
    Expect(0, 74853, '\p{^Is_Nv=60/180}', "");
    Expect(0, 74853, '\P{Is_Nv=60/180}', "");
    Expect(1, 74853, '\P{^Is_Nv=60/180}', "");
    Expect(0, 74854, '\p{Is_Nv=60/180}', "");
    Expect(1, 74854, '\p{^Is_Nv=60/180}', "");
    Expect(1, 74854, '\P{Is_Nv=60/180}', "");
    Expect(0, 74854, '\P{^Is_Nv=60/180}', "");
    Error('\p{Is_Nv=3.3e-01}');
    Error('\P{Is_Nv=3.3e-01}');
    Error('\p{Is_Nv=0.3}');
    Error('\P{Is_Nv=0.3}');
    Expect(1, 74853, '\p{Is_Nv=3.33e-01}', "");
    Expect(0, 74853, '\p{^Is_Nv=3.33e-01}', "");
    Expect(0, 74853, '\P{Is_Nv=3.33e-01}', "");
    Expect(1, 74853, '\P{^Is_Nv=3.33e-01}', "");
    Expect(0, 74854, '\p{Is_Nv=3.33e-01}', "");
    Expect(1, 74854, '\p{^Is_Nv=3.33e-01}', "");
    Expect(1, 74854, '\P{Is_Nv=3.33e-01}', "");
    Expect(0, 74854, '\P{^Is_Nv=3.33e-01}', "");
    Error('\p{Is_Nv:0.33}');
    Error('\P{Is_Nv:0.33}');
    Expect(1, 74853, '\p{Is_Nv=3.333e-01}', "");
    Expect(0, 74853, '\p{^Is_Nv=3.333e-01}', "");
    Expect(0, 74853, '\P{Is_Nv=3.333e-01}', "");
    Expect(1, 74853, '\P{^Is_Nv=3.333e-01}', "");
    Expect(0, 74854, '\p{Is_Nv=3.333e-01}', "");
    Expect(1, 74854, '\p{^Is_Nv=3.333e-01}', "");
    Expect(1, 74854, '\P{Is_Nv=3.333e-01}', "");
    Expect(0, 74854, '\P{^Is_Nv=3.333e-01}', "");
    Expect(1, 74853, '\p{Is_Nv=0.333}', "");
    Expect(0, 74853, '\p{^Is_Nv=0.333}', "");
    Expect(0, 74853, '\P{Is_Nv=0.333}', "");
    Expect(1, 74853, '\P{^Is_Nv=0.333}', "");
    Expect(0, 74854, '\p{Is_Nv=0.333}', "");
    Expect(1, 74854, '\p{^Is_Nv=0.333}', "");
    Expect(1, 74854, '\P{Is_Nv=0.333}', "");
    Expect(0, 74854, '\P{^Is_Nv=0.333}', "");
    Expect(1, 74853, '\p{Is_Nv=3.3333e-01}', "");
    Expect(0, 74853, '\p{^Is_Nv=3.3333e-01}', "");
    Expect(0, 74853, '\P{Is_Nv=3.3333e-01}', "");
    Expect(1, 74853, '\P{^Is_Nv=3.3333e-01}', "");
    Expect(0, 74854, '\p{Is_Nv=3.3333e-01}', "");
    Expect(1, 74854, '\p{^Is_Nv=3.3333e-01}', "");
    Expect(1, 74854, '\P{Is_Nv=3.3333e-01}', "");
    Expect(0, 74854, '\P{^Is_Nv=3.3333e-01}', "");
    Expect(1, 74853, '\p{Is_Nv=0.3333}', "");
    Expect(0, 74853, '\p{^Is_Nv=0.3333}', "");
    Expect(0, 74853, '\P{Is_Nv=0.3333}', "");
    Expect(1, 74853, '\P{^Is_Nv=0.3333}', "");
    Expect(0, 74854, '\p{Is_Nv=0.3333}', "");
    Expect(1, 74854, '\p{^Is_Nv=0.3333}', "");
    Expect(1, 74854, '\P{Is_Nv=0.3333}', "");
    Expect(0, 74854, '\P{^Is_Nv=0.3333}', "");
    Error('\p{Numeric_Value: /a/+00000001/000032}');
    Error('\P{Numeric_Value: /a/+00000001/000032}');
    Expect(1, 73669, '\p{Numeric_Value=:\A1/32\z:}', "");;
    Expect(0, 73670, '\p{Numeric_Value=:\A1/32\z:}', "");;
    Expect(1, 73669, '\p{Numeric_Value=00001/00000000032}', "");
    Expect(0, 73669, '\p{^Numeric_Value=00001/00000000032}', "");
    Expect(0, 73669, '\P{Numeric_Value=00001/00000000032}', "");
    Expect(1, 73669, '\P{^Numeric_Value=00001/00000000032}', "");
    Expect(0, 73670, '\p{Numeric_Value=00001/00000000032}', "");
    Expect(1, 73670, '\p{^Numeric_Value=00001/00000000032}', "");
    Expect(1, 73670, '\P{Numeric_Value=00001/00000000032}', "");
    Expect(0, 73670, '\P{^Numeric_Value=00001/00000000032}', "");
    Expect(1, 73669, '\p{Numeric_Value=60/1920}', "");
    Expect(0, 73669, '\p{^Numeric_Value=60/1920}', "");
    Expect(0, 73669, '\P{Numeric_Value=60/1920}', "");
    Expect(1, 73669, '\P{^Numeric_Value=60/1920}', "");
    Expect(0, 73670, '\p{Numeric_Value=60/1920}', "");
    Expect(1, 73670, '\p{^Numeric_Value=60/1920}', "");
    Expect(1, 73670, '\P{Numeric_Value=60/1920}', "");
    Expect(0, 73670, '\P{^Numeric_Value=60/1920}', "");
    Error('\p{Numeric_Value=3.1e-02}');
    Error('\P{Numeric_Value=3.1e-02}');
    Expect(1, 73669, '\p{Numeric_Value=3.12e-02}', "");
    Expect(0, 73669, '\p{^Numeric_Value=3.12e-02}', "");
    Expect(0, 73669, '\P{Numeric_Value=3.12e-02}', "");
    Expect(1, 73669, '\P{^Numeric_Value=3.12e-02}', "");
    Expect(0, 73670, '\p{Numeric_Value=3.12e-02}', "");
    Expect(1, 73670, '\p{^Numeric_Value=3.12e-02}', "");
    Expect(1, 73670, '\P{Numeric_Value=3.12e-02}', "");
    Expect(0, 73670, '\P{^Numeric_Value=3.12e-02}', "");
    Error('\p{Numeric_Value=0.03}');
    Error('\P{Numeric_Value=0.03}');
    Expect(1, 73669, '\p{Numeric_Value=3.125e-02}', "");
    Expect(0, 73669, '\p{^Numeric_Value=3.125e-02}', "");
    Expect(0, 73669, '\P{Numeric_Value=3.125e-02}', "");
    Expect(1, 73669, '\P{^Numeric_Value=3.125e-02}', "");
    Expect(0, 73670, '\p{Numeric_Value=3.125e-02}', "");
    Expect(1, 73670, '\p{^Numeric_Value=3.125e-02}', "");
    Expect(1, 73670, '\P{Numeric_Value=3.125e-02}', "");
    Expect(0, 73670, '\P{^Numeric_Value=3.125e-02}', "");
    Error('\p{Numeric_Value:	0.031}');
    Error('\P{Numeric_Value:	0.031}');
    Expect(1, 73669, '\p{Numeric_Value=3.1250e-02}', "");
    Expect(0, 73669, '\p{^Numeric_Value=3.1250e-02}', "");
    Expect(0, 73669, '\P{Numeric_Value=3.1250e-02}', "");
    Expect(1, 73669, '\P{^Numeric_Value=3.1250e-02}', "");
    Expect(0, 73670, '\p{Numeric_Value=3.1250e-02}', "");
    Expect(1, 73670, '\p{^Numeric_Value=3.1250e-02}', "");
    Expect(1, 73670, '\P{Numeric_Value=3.1250e-02}', "");
    Expect(0, 73670, '\P{^Numeric_Value=3.1250e-02}', "");
    Expect(1, 73669, '\p{Numeric_Value=0.0312}', "");
    Expect(0, 73669, '\p{^Numeric_Value=0.0312}', "");
    Expect(0, 73669, '\P{Numeric_Value=0.0312}', "");
    Expect(1, 73669, '\P{^Numeric_Value=0.0312}', "");
    Expect(0, 73670, '\p{Numeric_Value=0.0312}', "");
    Expect(1, 73670, '\p{^Numeric_Value=0.0312}', "");
    Expect(1, 73670, '\P{Numeric_Value=0.0312}', "");
    Expect(0, 73670, '\P{^Numeric_Value=0.0312}', "");
    Expect(1, 73669, '\p{Numeric_Value=3.12500e-02}', "");
    Expect(0, 73669, '\p{^Numeric_Value=3.12500e-02}', "");
    Expect(0, 73669, '\P{Numeric_Value=3.12500e-02}', "");
    Expect(1, 73669, '\P{^Numeric_Value=3.12500e-02}', "");
    Expect(0, 73670, '\p{Numeric_Value=3.12500e-02}', "");
    Expect(1, 73670, '\p{^Numeric_Value=3.12500e-02}', "");
    Expect(1, 73670, '\P{Numeric_Value=3.12500e-02}', "");
    Expect(0, 73670, '\P{^Numeric_Value=3.12500e-02}', "");
    Expect(1, 73669, '\p{Numeric_Value=0.03125}', "");
    Expect(0, 73669, '\p{^Numeric_Value=0.03125}', "");
    Expect(0, 73669, '\P{Numeric_Value=0.03125}', "");
    Expect(1, 73669, '\P{^Numeric_Value=0.03125}', "");
    Expect(0, 73670, '\p{Numeric_Value=0.03125}', "");
    Expect(1, 73670, '\p{^Numeric_Value=0.03125}', "");
    Expect(1, 73670, '\P{Numeric_Value=0.03125}', "");
    Expect(0, 73670, '\P{^Numeric_Value=0.03125}', "");
    Error('\p{Nv=:=+0001/0000032}');
    Error('\P{Nv=:=+0001/0000032}');
    Expect(1, 73669, '\p{Nv=:\A1/32\z:}', "");;
    Expect(0, 73670, '\p{Nv=:\A1/32\z:}', "");;
    Expect(1, 73669, '\p{Nv=+001/0032}', "");
    Expect(0, 73669, '\p{^Nv=+001/0032}', "");
    Expect(0, 73669, '\P{Nv=+001/0032}', "");
    Expect(1, 73669, '\P{^Nv=+001/0032}', "");
    Expect(0, 73670, '\p{Nv=+001/0032}', "");
    Expect(1, 73670, '\p{^Nv=+001/0032}', "");
    Expect(1, 73670, '\P{Nv=+001/0032}', "");
    Expect(0, 73670, '\P{^Nv=+001/0032}', "");
    Expect(1, 73669, '\p{Nv=60/1920}', "");
    Expect(0, 73669, '\p{^Nv=60/1920}', "");
    Expect(0, 73669, '\P{Nv=60/1920}', "");
    Expect(1, 73669, '\P{^Nv=60/1920}', "");
    Expect(0, 73670, '\p{Nv=60/1920}', "");
    Expect(1, 73670, '\p{^Nv=60/1920}', "");
    Expect(1, 73670, '\P{Nv=60/1920}', "");
    Expect(0, 73670, '\P{^Nv=60/1920}', "");
    Error('\p{Nv=3.1e-02}');
    Error('\P{Nv=3.1e-02}');
    Expect(1, 73669, '\p{Nv=3.12e-02}', "");
    Expect(0, 73669, '\p{^Nv=3.12e-02}', "");
    Expect(0, 73669, '\P{Nv=3.12e-02}', "");
    Expect(1, 73669, '\P{^Nv=3.12e-02}', "");
    Expect(0, 73670, '\p{Nv=3.12e-02}', "");
    Expect(1, 73670, '\p{^Nv=3.12e-02}', "");
    Expect(1, 73670, '\P{Nv=3.12e-02}', "");
    Expect(0, 73670, '\P{^Nv=3.12e-02}', "");
    Error('\p{Nv=0.03}');
    Error('\P{Nv=0.03}');
    Expect(1, 73669, '\p{Nv=3.125e-02}', "");
    Expect(0, 73669, '\p{^Nv=3.125e-02}', "");
    Expect(0, 73669, '\P{Nv=3.125e-02}', "");
    Expect(1, 73669, '\P{^Nv=3.125e-02}', "");
    Expect(0, 73670, '\p{Nv=3.125e-02}', "");
    Expect(1, 73670, '\p{^Nv=3.125e-02}', "");
    Expect(1, 73670, '\P{Nv=3.125e-02}', "");
    Expect(0, 73670, '\P{^Nv=3.125e-02}', "");
    Error('\p{Nv=0.031}');
    Error('\P{Nv=0.031}');
    Expect(1, 73669, '\p{Nv:3.1250e-02}', "");
    Expect(0, 73669, '\p{^Nv:3.1250e-02}', "");
    Expect(0, 73669, '\P{Nv:3.1250e-02}', "");
    Expect(1, 73669, '\P{^Nv:3.1250e-02}', "");
    Expect(0, 73670, '\p{Nv:3.1250e-02}', "");
    Expect(1, 73670, '\p{^Nv:3.1250e-02}', "");
    Expect(1, 73670, '\P{Nv:3.1250e-02}', "");
    Expect(0, 73670, '\P{^Nv:3.1250e-02}', "");
    Expect(1, 73669, '\p{Nv=0.0312}', "");
    Expect(0, 73669, '\p{^Nv=0.0312}', "");
    Expect(0, 73669, '\P{Nv=0.0312}', "");
    Expect(1, 73669, '\P{^Nv=0.0312}', "");
    Expect(0, 73670, '\p{Nv=0.0312}', "");
    Expect(1, 73670, '\p{^Nv=0.0312}', "");
    Expect(1, 73670, '\P{Nv=0.0312}', "");
    Expect(0, 73670, '\P{^Nv=0.0312}', "");
    Expect(1, 73669, '\p{Nv=3.12500e-02}', "");
    Expect(0, 73669, '\p{^Nv=3.12500e-02}', "");
    Expect(0, 73669, '\P{Nv=3.12500e-02}', "");
    Expect(1, 73669, '\P{^Nv=3.12500e-02}', "");
    Expect(0, 73670, '\p{Nv=3.12500e-02}', "");
    Expect(1, 73670, '\p{^Nv=3.12500e-02}', "");
    Expect(1, 73670, '\P{Nv=3.12500e-02}', "");
    Expect(0, 73670, '\P{^Nv=3.12500e-02}', "");
    Expect(1, 73669, '\p{Nv=0.03125}', "");
    Expect(0, 73669, '\p{^Nv=0.03125}', "");
    Expect(0, 73669, '\P{Nv=0.03125}', "");
    Expect(1, 73669, '\P{^Nv=0.03125}', "");
    Expect(0, 73670, '\p{Nv=0.03125}', "");
    Expect(1, 73670, '\p{^Nv=0.03125}', "");
    Expect(1, 73670, '\P{Nv=0.03125}', "");
    Expect(0, 73670, '\P{^Nv=0.03125}', "");
    Error('\p{Is_Numeric_Value=/a/ 1/32}');
    Error('\P{Is_Numeric_Value=/a/ 1/32}');
    Expect(1, 73669, '\p{Is_Numeric_Value=01/000032}', "");
    Expect(0, 73669, '\p{^Is_Numeric_Value=01/000032}', "");
    Expect(0, 73669, '\P{Is_Numeric_Value=01/000032}', "");
    Expect(1, 73669, '\P{^Is_Numeric_Value=01/000032}', "");
    Expect(0, 73670, '\p{Is_Numeric_Value=01/000032}', "");
    Expect(1, 73670, '\p{^Is_Numeric_Value=01/000032}', "");
    Expect(1, 73670, '\P{Is_Numeric_Value=01/000032}', "");
    Expect(0, 73670, '\P{^Is_Numeric_Value=01/000032}', "");
    Expect(1, 73669, '\p{Is_Numeric_Value: 60/1920}', "");
    Expect(0, 73669, '\p{^Is_Numeric_Value: 60/1920}', "");
    Expect(0, 73669, '\P{Is_Numeric_Value: 60/1920}', "");
    Expect(1, 73669, '\P{^Is_Numeric_Value: 60/1920}', "");
    Expect(0, 73670, '\p{Is_Numeric_Value: 60/1920}', "");
    Expect(1, 73670, '\p{^Is_Numeric_Value: 60/1920}', "");
    Expect(1, 73670, '\P{Is_Numeric_Value: 60/1920}', "");
    Expect(0, 73670, '\P{^Is_Numeric_Value: 60/1920}', "");
    Error('\p{Is_Numeric_Value=3.1e-02}');
    Error('\P{Is_Numeric_Value=3.1e-02}');
    Expect(1, 73669, '\p{Is_Numeric_Value=3.12e-02}', "");
    Expect(0, 73669, '\p{^Is_Numeric_Value=3.12e-02}', "");
    Expect(0, 73669, '\P{Is_Numeric_Value=3.12e-02}', "");
    Expect(1, 73669, '\P{^Is_Numeric_Value=3.12e-02}', "");
    Expect(0, 73670, '\p{Is_Numeric_Value=3.12e-02}', "");
    Expect(1, 73670, '\p{^Is_Numeric_Value=3.12e-02}', "");
    Expect(1, 73670, '\P{Is_Numeric_Value=3.12e-02}', "");
    Expect(0, 73670, '\P{^Is_Numeric_Value=3.12e-02}', "");
    Error('\p{Is_Numeric_Value=0.03}');
    Error('\P{Is_Numeric_Value=0.03}');
    Expect(1, 73669, '\p{Is_Numeric_Value:3.125e-02}', "");
    Expect(0, 73669, '\p{^Is_Numeric_Value:3.125e-02}', "");
    Expect(0, 73669, '\P{Is_Numeric_Value:3.125e-02}', "");
    Expect(1, 73669, '\P{^Is_Numeric_Value:3.125e-02}', "");
    Expect(0, 73670, '\p{Is_Numeric_Value:3.125e-02}', "");
    Expect(1, 73670, '\p{^Is_Numeric_Value:3.125e-02}', "");
    Expect(1, 73670, '\P{Is_Numeric_Value:3.125e-02}', "");
    Expect(0, 73670, '\P{^Is_Numeric_Value:3.125e-02}', "");
    Error('\p{Is_Numeric_Value=0.031}');
    Error('\P{Is_Numeric_Value=0.031}');
    Expect(1, 73669, '\p{Is_Numeric_Value=3.1250e-02}', "");
    Expect(0, 73669, '\p{^Is_Numeric_Value=3.1250e-02}', "");
    Expect(0, 73669, '\P{Is_Numeric_Value=3.1250e-02}', "");
    Expect(1, 73669, '\P{^Is_Numeric_Value=3.1250e-02}', "");
    Expect(0, 73670, '\p{Is_Numeric_Value=3.1250e-02}', "");
    Expect(1, 73670, '\p{^Is_Numeric_Value=3.1250e-02}', "");
    Expect(1, 73670, '\P{Is_Numeric_Value=3.1250e-02}', "");
    Expect(0, 73670, '\P{^Is_Numeric_Value=3.1250e-02}', "");
    Expect(1, 73669, '\p{Is_Numeric_Value=0.0312}', "");
    Expect(0, 73669, '\p{^Is_Numeric_Value=0.0312}', "");
    Expect(0, 73669, '\P{Is_Numeric_Value=0.0312}', "");
    Expect(1, 73669, '\P{^Is_Numeric_Value=0.0312}', "");
    Expect(0, 73670, '\p{Is_Numeric_Value=0.0312}', "");
    Expect(1, 73670, '\p{^Is_Numeric_Value=0.0312}', "");
    Expect(1, 73670, '\P{Is_Numeric_Value=0.0312}', "");
    Expect(0, 73670, '\P{^Is_Numeric_Value=0.0312}', "");
    Expect(1, 73669, '\p{Is_Numeric_Value=3.12500e-02}', "");
    Expect(0, 73669, '\p{^Is_Numeric_Value=3.12500e-02}', "");
    Expect(0, 73669, '\P{Is_Numeric_Value=3.12500e-02}', "");
    Expect(1, 73669, '\P{^Is_Numeric_Value=3.12500e-02}', "");
    Expect(0, 73670, '\p{Is_Numeric_Value=3.12500e-02}', "");
    Expect(1, 73670, '\p{^Is_Numeric_Value=3.12500e-02}', "");
    Expect(1, 73670, '\P{Is_Numeric_Value=3.12500e-02}', "");
    Expect(0, 73670, '\P{^Is_Numeric_Value=3.12500e-02}', "");
    Expect(1, 73669, '\p{Is_Numeric_Value=0.03125}', "");
    Expect(0, 73669, '\p{^Is_Numeric_Value=0.03125}', "");
    Expect(0, 73669, '\P{Is_Numeric_Value=0.03125}', "");
    Expect(1, 73669, '\P{^Is_Numeric_Value=0.03125}', "");
    Expect(0, 73670, '\p{Is_Numeric_Value=0.03125}', "");
    Expect(1, 73670, '\p{^Is_Numeric_Value=0.03125}', "");
    Expect(1, 73670, '\P{Is_Numeric_Value=0.03125}', "");
    Expect(0, 73670, '\P{^Is_Numeric_Value=0.03125}', "");
    Error('\p{Is_Nv=:=_ 00001/032}');
    Error('\P{Is_Nv=:=_ 00001/032}');
    Expect(1, 73669, '\p{Is_Nv=+0001/32}', "");
    Expect(0, 73669, '\p{^Is_Nv=+0001/32}', "");
    Expect(0, 73669, '\P{Is_Nv=+0001/32}', "");
    Expect(1, 73669, '\P{^Is_Nv=+0001/32}', "");
    Expect(0, 73670, '\p{Is_Nv=+0001/32}', "");
    Expect(1, 73670, '\p{^Is_Nv=+0001/32}', "");
    Expect(1, 73670, '\P{Is_Nv=+0001/32}', "");
    Expect(0, 73670, '\P{^Is_Nv=+0001/32}', "");
    Expect(1, 73669, '\p{Is_Nv=60/1920}', "");
    Expect(0, 73669, '\p{^Is_Nv=60/1920}', "");
    Expect(0, 73669, '\P{Is_Nv=60/1920}', "");
    Expect(1, 73669, '\P{^Is_Nv=60/1920}', "");
    Expect(0, 73670, '\p{Is_Nv=60/1920}', "");
    Expect(1, 73670, '\p{^Is_Nv=60/1920}', "");
    Expect(1, 73670, '\P{Is_Nv=60/1920}', "");
    Expect(0, 73670, '\P{^Is_Nv=60/1920}', "");
    Error('\p{Is_Nv=3.1e-02}');
    Error('\P{Is_Nv=3.1e-02}');
    Expect(1, 73669, '\p{Is_Nv=3.12e-02}', "");
    Expect(0, 73669, '\p{^Is_Nv=3.12e-02}', "");
    Expect(0, 73669, '\P{Is_Nv=3.12e-02}', "");
    Expect(1, 73669, '\P{^Is_Nv=3.12e-02}', "");
    Expect(0, 73670, '\p{Is_Nv=3.12e-02}', "");
    Expect(1, 73670, '\p{^Is_Nv=3.12e-02}', "");
    Expect(1, 73670, '\P{Is_Nv=3.12e-02}', "");
    Expect(0, 73670, '\P{^Is_Nv=3.12e-02}', "");
    Error('\p{Is_Nv=0.03}');
    Error('\P{Is_Nv=0.03}');
    Expect(1, 73669, '\p{Is_Nv=3.125e-02}', "");
    Expect(0, 73669, '\p{^Is_Nv=3.125e-02}', "");
    Expect(0, 73669, '\P{Is_Nv=3.125e-02}', "");
    Expect(1, 73669, '\P{^Is_Nv=3.125e-02}', "");
    Expect(0, 73670, '\p{Is_Nv=3.125e-02}', "");
    Expect(1, 73670, '\p{^Is_Nv=3.125e-02}', "");
    Expect(1, 73670, '\P{Is_Nv=3.125e-02}', "");
    Expect(0, 73670, '\P{^Is_Nv=3.125e-02}', "");
    Error('\p{Is_Nv=0.031}');
    Error('\P{Is_Nv=0.031}');
    Expect(1, 73669, '\p{Is_Nv=3.1250e-02}', "");
    Expect(0, 73669, '\p{^Is_Nv=3.1250e-02}', "");
    Expect(0, 73669, '\P{Is_Nv=3.1250e-02}', "");
    Expect(1, 73669, '\P{^Is_Nv=3.1250e-02}', "");
    Expect(0, 73670, '\p{Is_Nv=3.1250e-02}', "");
    Expect(1, 73670, '\p{^Is_Nv=3.1250e-02}', "");
    Expect(1, 73670, '\P{Is_Nv=3.1250e-02}', "");
    Expect(0, 73670, '\P{^Is_Nv=3.1250e-02}', "");
    Expect(1, 73669, '\p{Is_Nv=0.0312}', "");
    Expect(0, 73669, '\p{^Is_Nv=0.0312}', "");
    Expect(0, 73669, '\P{Is_Nv=0.0312}', "");
    Expect(1, 73669, '\P{^Is_Nv=0.0312}', "");
    Expect(0, 73670, '\p{Is_Nv=0.0312}', "");
    Expect(1, 73670, '\p{^Is_Nv=0.0312}', "");
    Expect(1, 73670, '\P{Is_Nv=0.0312}', "");
    Expect(0, 73670, '\P{^Is_Nv=0.0312}', "");
    Expect(1, 73669, '\p{Is_Nv=3.12500e-02}', "");
    Expect(0, 73669, '\p{^Is_Nv=3.12500e-02}', "");
    Expect(0, 73669, '\P{Is_Nv=3.12500e-02}', "");
    Expect(1, 73669, '\P{^Is_Nv=3.12500e-02}', "");
    Expect(0, 73670, '\p{Is_Nv=3.12500e-02}', "");
    Expect(1, 73670, '\p{^Is_Nv=3.12500e-02}', "");
    Expect(1, 73670, '\P{Is_Nv=3.12500e-02}', "");
    Expect(0, 73670, '\P{^Is_Nv=3.12500e-02}', "");
    Expect(1, 73669, '\p{Is_Nv=0.03125}', "");
    Expect(0, 73669, '\p{^Is_Nv=0.03125}', "");
    Expect(0, 73669, '\P{Is_Nv=0.03125}', "");
    Expect(1, 73669, '\P{^Is_Nv=0.03125}', "");
    Expect(0, 73670, '\p{Is_Nv=0.03125}', "");
    Expect(1, 73670, '\p{^Is_Nv=0.03125}', "");
    Expect(1, 73670, '\P{Is_Nv=0.03125}', "");
    Expect(0, 73670, '\P{^Is_Nv=0.03125}', "");
    Error('\p{Numeric_Value=	0001/00320/a/}');
    Error('\P{Numeric_Value=	0001/00320/a/}');
    Expect(1, 73684, '\p{Numeric_Value=:\A1/320\z:}', "");;
    Expect(0, 73685, '\p{Numeric_Value=:\A1/320\z:}', "");;
    Expect(1, 73684, '\p{Numeric_Value=0001/0320}', "");
    Expect(0, 73684, '\p{^Numeric_Value=0001/0320}', "");
    Expect(0, 73684, '\P{Numeric_Value=0001/0320}', "");
    Expect(1, 73684, '\P{^Numeric_Value=0001/0320}', "");
    Expect(0, 73685, '\p{Numeric_Value=0001/0320}', "");
    Expect(1, 73685, '\p{^Numeric_Value=0001/0320}', "");
    Expect(1, 73685, '\P{Numeric_Value=0001/0320}', "");
    Expect(0, 73685, '\P{^Numeric_Value=0001/0320}', "");
    Expect(1, 73684, '\p{Numeric_Value=60/19200}', "");
    Expect(0, 73684, '\p{^Numeric_Value=60/19200}', "");
    Expect(0, 73684, '\P{Numeric_Value=60/19200}', "");
    Expect(1, 73684, '\P{^Numeric_Value=60/19200}', "");
    Expect(0, 73685, '\p{Numeric_Value=60/19200}', "");
    Expect(1, 73685, '\p{^Numeric_Value=60/19200}', "");
    Expect(1, 73685, '\P{Numeric_Value=60/19200}', "");
    Expect(0, 73685, '\P{^Numeric_Value=60/19200}', "");
    Error('\p{Numeric_Value: 3.1e-03}');
    Error('\P{Numeric_Value: 3.1e-03}');
    Expect(1, 73684, '\p{Numeric_Value=3.13e-03}', "");
    Expect(0, 73684, '\p{^Numeric_Value=3.13e-03}', "");
    Expect(0, 73684, '\P{Numeric_Value=3.13e-03}', "");
    Expect(1, 73684, '\P{^Numeric_Value=3.13e-03}', "");
    Expect(0, 73685, '\p{Numeric_Value=3.13e-03}', "");
    Expect(1, 73685, '\p{^Numeric_Value=3.13e-03}', "");
    Expect(1, 73685, '\P{Numeric_Value=3.13e-03}', "");
    Expect(0, 73685, '\P{^Numeric_Value=3.13e-03}', "");
    Expect(1, 73684, '\p{Numeric_Value: 3.125e-03}', "");
    Expect(0, 73684, '\p{^Numeric_Value: 3.125e-03}', "");
    Expect(0, 73684, '\P{Numeric_Value: 3.125e-03}', "");
    Expect(1, 73684, '\P{^Numeric_Value: 3.125e-03}', "");
    Expect(0, 73685, '\p{Numeric_Value: 3.125e-03}', "");
    Expect(1, 73685, '\p{^Numeric_Value: 3.125e-03}', "");
    Expect(1, 73685, '\P{Numeric_Value: 3.125e-03}', "");
    Expect(0, 73685, '\P{^Numeric_Value: 3.125e-03}', "");
    Error('\p{Numeric_Value=0.003}');
    Error('\P{Numeric_Value=0.003}');
    Expect(1, 73684, '\p{Numeric_Value=3.1250e-03}', "");
    Expect(0, 73684, '\p{^Numeric_Value=3.1250e-03}', "");
    Expect(0, 73684, '\P{Numeric_Value=3.1250e-03}', "");
    Expect(1, 73684, '\P{^Numeric_Value=3.1250e-03}', "");
    Expect(0, 73685, '\p{Numeric_Value=3.1250e-03}', "");
    Expect(1, 73685, '\p{^Numeric_Value=3.1250e-03}', "");
    Expect(1, 73685, '\P{Numeric_Value=3.1250e-03}', "");
    Expect(0, 73685, '\P{^Numeric_Value=3.1250e-03}', "");
    Error('\p{Numeric_Value=0.0031}');
    Error('\P{Numeric_Value=0.0031}');
    Expect(1, 73684, '\p{Numeric_Value=3.12500e-03}', "");
    Expect(0, 73684, '\p{^Numeric_Value=3.12500e-03}', "");
    Expect(0, 73684, '\P{Numeric_Value=3.12500e-03}', "");
    Expect(1, 73684, '\P{^Numeric_Value=3.12500e-03}', "");
    Expect(0, 73685, '\p{Numeric_Value=3.12500e-03}', "");
    Expect(1, 73685, '\p{^Numeric_Value=3.12500e-03}', "");
    Expect(1, 73685, '\P{Numeric_Value=3.12500e-03}', "");
    Expect(0, 73685, '\P{^Numeric_Value=3.12500e-03}', "");
    Expect(1, 73684, '\p{Numeric_Value=0.00313}', "");
    Expect(0, 73684, '\p{^Numeric_Value=0.00313}', "");
    Expect(0, 73684, '\P{Numeric_Value=0.00313}', "");
    Expect(1, 73684, '\P{^Numeric_Value=0.00313}', "");
    Expect(0, 73685, '\p{Numeric_Value=0.00313}', "");
    Expect(1, 73685, '\p{^Numeric_Value=0.00313}', "");
    Expect(1, 73685, '\P{Numeric_Value=0.00313}', "");
    Expect(0, 73685, '\P{^Numeric_Value=0.00313}', "");
    Expect(1, 73684, '\p{Numeric_Value=3.125000e-03}', "");
    Expect(0, 73684, '\p{^Numeric_Value=3.125000e-03}', "");
    Expect(0, 73684, '\P{Numeric_Value=3.125000e-03}', "");
    Expect(1, 73684, '\P{^Numeric_Value=3.125000e-03}', "");
    Expect(0, 73685, '\p{Numeric_Value=3.125000e-03}', "");
    Expect(1, 73685, '\p{^Numeric_Value=3.125000e-03}', "");
    Expect(1, 73685, '\P{Numeric_Value=3.125000e-03}', "");
    Expect(0, 73685, '\P{^Numeric_Value=3.125000e-03}', "");
    Expect(1, 73684, '\p{Numeric_Value=0.003125}', "");
    Expect(0, 73684, '\p{^Numeric_Value=0.003125}', "");
    Expect(0, 73684, '\P{Numeric_Value=0.003125}', "");
    Expect(1, 73684, '\P{^Numeric_Value=0.003125}', "");
    Expect(0, 73685, '\p{Numeric_Value=0.003125}', "");
    Expect(1, 73685, '\p{^Numeric_Value=0.003125}', "");
    Expect(1, 73685, '\P{Numeric_Value=0.003125}', "");
    Expect(0, 73685, '\P{^Numeric_Value=0.003125}', "");
    Error('\p{Nv:_	000001/00000320/a/}');
    Error('\P{Nv:_	000001/00000320/a/}');
    Expect(1, 73684, '\p{Nv=:\A1/320\z:}', "");;
    Expect(0, 73685, '\p{Nv=:\A1/320\z:}', "");;
    Expect(1, 73684, '\p{Nv=0000001/000000320}', "");
    Expect(0, 73684, '\p{^Nv=0000001/000000320}', "");
    Expect(0, 73684, '\P{Nv=0000001/000000320}', "");
    Expect(1, 73684, '\P{^Nv=0000001/000000320}', "");
    Expect(0, 73685, '\p{Nv=0000001/000000320}', "");
    Expect(1, 73685, '\p{^Nv=0000001/000000320}', "");
    Expect(1, 73685, '\P{Nv=0000001/000000320}', "");
    Expect(0, 73685, '\P{^Nv=0000001/000000320}', "");
    Expect(1, 73684, '\p{Nv=60/19200}', "");
    Expect(0, 73684, '\p{^Nv=60/19200}', "");
    Expect(0, 73684, '\P{Nv=60/19200}', "");
    Expect(1, 73684, '\P{^Nv=60/19200}', "");
    Expect(0, 73685, '\p{Nv=60/19200}', "");
    Expect(1, 73685, '\p{^Nv=60/19200}', "");
    Expect(1, 73685, '\P{Nv=60/19200}', "");
    Expect(0, 73685, '\P{^Nv=60/19200}', "");
    Error('\p{Nv=3.1e-03}');
    Error('\P{Nv=3.1e-03}');
    Expect(1, 73684, '\p{Nv=3.13e-03}', "");
    Expect(0, 73684, '\p{^Nv=3.13e-03}', "");
    Expect(0, 73684, '\P{Nv=3.13e-03}', "");
    Expect(1, 73684, '\P{^Nv=3.13e-03}', "");
    Expect(0, 73685, '\p{Nv=3.13e-03}', "");
    Expect(1, 73685, '\p{^Nv=3.13e-03}', "");
    Expect(1, 73685, '\P{Nv=3.13e-03}', "");
    Expect(0, 73685, '\P{^Nv=3.13e-03}', "");
    Expect(1, 73684, '\p{Nv=3.125e-03}', "");
    Expect(0, 73684, '\p{^Nv=3.125e-03}', "");
    Expect(0, 73684, '\P{Nv=3.125e-03}', "");
    Expect(1, 73684, '\P{^Nv=3.125e-03}', "");
    Expect(0, 73685, '\p{Nv=3.125e-03}', "");
    Expect(1, 73685, '\p{^Nv=3.125e-03}', "");
    Expect(1, 73685, '\P{Nv=3.125e-03}', "");
    Expect(0, 73685, '\P{^Nv=3.125e-03}', "");
    Error('\p{Nv=0.003}');
    Error('\P{Nv=0.003}');
    Expect(1, 73684, '\p{Nv=3.1250e-03}', "");
    Expect(0, 73684, '\p{^Nv=3.1250e-03}', "");
    Expect(0, 73684, '\P{Nv=3.1250e-03}', "");
    Expect(1, 73684, '\P{^Nv=3.1250e-03}', "");
    Expect(0, 73685, '\p{Nv=3.1250e-03}', "");
    Expect(1, 73685, '\p{^Nv=3.1250e-03}', "");
    Expect(1, 73685, '\P{Nv=3.1250e-03}', "");
    Expect(0, 73685, '\P{^Nv=3.1250e-03}', "");
    Error('\p{Nv=0.0031}');
    Error('\P{Nv=0.0031}');
    Expect(1, 73684, '\p{Nv=3.12500e-03}', "");
    Expect(0, 73684, '\p{^Nv=3.12500e-03}', "");
    Expect(0, 73684, '\P{Nv=3.12500e-03}', "");
    Expect(1, 73684, '\P{^Nv=3.12500e-03}', "");
    Expect(0, 73685, '\p{Nv=3.12500e-03}', "");
    Expect(1, 73685, '\p{^Nv=3.12500e-03}', "");
    Expect(1, 73685, '\P{Nv=3.12500e-03}', "");
    Expect(0, 73685, '\P{^Nv=3.12500e-03}', "");
    Expect(1, 73684, '\p{Nv=0.00313}', "");
    Expect(0, 73684, '\p{^Nv=0.00313}', "");
    Expect(0, 73684, '\P{Nv=0.00313}', "");
    Expect(1, 73684, '\P{^Nv=0.00313}', "");
    Expect(0, 73685, '\p{Nv=0.00313}', "");
    Expect(1, 73685, '\p{^Nv=0.00313}', "");
    Expect(1, 73685, '\P{Nv=0.00313}', "");
    Expect(0, 73685, '\P{^Nv=0.00313}', "");
    Expect(1, 73684, '\p{Nv=3.125000e-03}', "");
    Expect(0, 73684, '\p{^Nv=3.125000e-03}', "");
    Expect(0, 73684, '\P{Nv=3.125000e-03}', "");
    Expect(1, 73684, '\P{^Nv=3.125000e-03}', "");
    Expect(0, 73685, '\p{Nv=3.125000e-03}', "");
    Expect(1, 73685, '\p{^Nv=3.125000e-03}', "");
    Expect(1, 73685, '\P{Nv=3.125000e-03}', "");
    Expect(0, 73685, '\P{^Nv=3.125000e-03}', "");
    Expect(1, 73684, '\p{Nv=0.003125}', "");
    Expect(0, 73684, '\p{^Nv=0.003125}', "");
    Expect(0, 73684, '\P{Nv=0.003125}', "");
    Expect(1, 73684, '\P{^Nv=0.003125}', "");
    Expect(0, 73685, '\p{Nv=0.003125}', "");
    Expect(1, 73685, '\p{^Nv=0.003125}', "");
    Expect(1, 73685, '\P{Nv=0.003125}', "");
    Expect(0, 73685, '\P{^Nv=0.003125}', "");
    Error('\p{Is_Numeric_Value: +0001/00000000320:=}');
    Error('\P{Is_Numeric_Value: +0001/00000000320:=}');
    Expect(1, 73684, '\p{Is_Numeric_Value=+00000001/0000000320}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value=+00000001/0000000320}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value=+00000001/0000000320}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value=+00000001/0000000320}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value=+00000001/0000000320}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value=+00000001/0000000320}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value=+00000001/0000000320}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value=+00000001/0000000320}', "");
    Expect(1, 73684, '\p{Is_Numeric_Value:60/19200}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value:60/19200}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value:60/19200}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value:60/19200}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value:60/19200}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value:60/19200}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value:60/19200}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value:60/19200}', "");
    Error('\p{Is_Numeric_Value=3.1e-03}');
    Error('\P{Is_Numeric_Value=3.1e-03}');
    Expect(1, 73684, '\p{Is_Numeric_Value=3.13e-03}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value=3.13e-03}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value=3.13e-03}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value=3.13e-03}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value=3.13e-03}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value=3.13e-03}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value=3.13e-03}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value=3.13e-03}', "");
    Expect(1, 73684, '\p{Is_Numeric_Value=3.125e-03}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value=3.125e-03}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value=3.125e-03}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value=3.125e-03}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value=3.125e-03}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value=3.125e-03}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value=3.125e-03}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value=3.125e-03}', "");
    Error('\p{Is_Numeric_Value=0.003}');
    Error('\P{Is_Numeric_Value=0.003}');
    Expect(1, 73684, '\p{Is_Numeric_Value=3.1250e-03}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value=3.1250e-03}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value=3.1250e-03}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value=3.1250e-03}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value=3.1250e-03}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value=3.1250e-03}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value=3.1250e-03}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value=3.1250e-03}', "");
    Error('\p{Is_Numeric_Value=0.0031}');
    Error('\P{Is_Numeric_Value=0.0031}');
    Expect(1, 73684, '\p{Is_Numeric_Value=3.12500e-03}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value=3.12500e-03}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value=3.12500e-03}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value=3.12500e-03}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value=3.12500e-03}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value=3.12500e-03}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value=3.12500e-03}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value=3.12500e-03}', "");
    Expect(1, 73684, '\p{Is_Numeric_Value=0.00313}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value=0.00313}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value=0.00313}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value=0.00313}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value=0.00313}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value=0.00313}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value=0.00313}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value=0.00313}', "");
    Expect(1, 73684, '\p{Is_Numeric_Value=3.125000e-03}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value=3.125000e-03}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value=3.125000e-03}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value=3.125000e-03}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value=3.125000e-03}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value=3.125000e-03}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value=3.125000e-03}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value=3.125000e-03}', "");
    Expect(1, 73684, '\p{Is_Numeric_Value=0.003125}', "");
    Expect(0, 73684, '\p{^Is_Numeric_Value=0.003125}', "");
    Expect(0, 73684, '\P{Is_Numeric_Value=0.003125}', "");
    Expect(1, 73684, '\P{^Is_Numeric_Value=0.003125}', "");
    Expect(0, 73685, '\p{Is_Numeric_Value=0.003125}', "");
    Expect(1, 73685, '\p{^Is_Numeric_Value=0.003125}', "");
    Expect(1, 73685, '\P{Is_Numeric_Value=0.003125}', "");
    Expect(0, 73685, '\P{^Is_Numeric_Value=0.003125}', "");
    Error('\p{Is_Nv=/a/ -00001/320}');
    Error('\P{Is_Nv=/a/ -00001/320}');
    Expect(1, 73684, '\p{Is_Nv=000001/00000000320}', "");
    Expect(0, 73684, '\p{^Is_Nv=000001/00000000320}', "");
    Expect(0, 73684, '\P{Is_Nv=000001/00000000320}', "");
    Expect(1, 73684, '\P{^Is_Nv=000001/00000000320}', "");
    Expect(0, 73685, '\p{Is_Nv=000001/00000000320}', "");
    Expect(1, 73685, '\p{^Is_Nv=000001/00000000320}', "");
    Expect(1, 73685, '\P{Is_Nv=000001/00000000320}', "");
    Expect(0, 73685, '\P{^Is_Nv=000001/00000000320}', "");
    Expect(1, 73684, '\p{Is_Nv=60/19200}', "");
    Expect(0, 73684, '\p{^Is_Nv=60/19200}', "");
    Expect(0, 73684, '\P{Is_Nv=60/19200}', "");
    Expect(1, 73684, '\P{^Is_Nv=60/19200}', "");
    Expect(0, 73685, '\p{Is_Nv=60/19200}', "");
    Expect(1, 73685, '\p{^Is_Nv=60/19200}', "");
    Expect(1, 73685, '\P{Is_Nv=60/19200}', "");
    Expect(0, 73685, '\P{^Is_Nv=60/19200}', "");
    Error('\p{Is_Nv:3.1e-03}');
    Error('\P{Is_Nv:3.1e-03}');
    Expect(1, 73684, '\p{Is_Nv=3.13e-03}', "");
    Expect(0, 73684, '\p{^Is_Nv=3.13e-03}', "");
    Expect(0, 73684, '\P{Is_Nv=3.13e-03}', "");
    Expect(1, 73684, '\P{^Is_Nv=3.13e-03}', "");
    Expect(0, 73685, '\p{Is_Nv=3.13e-03}', "");
    Expect(1, 73685, '\p{^Is_Nv=3.13e-03}', "");
    Expect(1, 73685, '\P{Is_Nv=3.13e-03}', "");
    Expect(0, 73685, '\P{^Is_Nv=3.13e-03}', "");
    Expect(1, 73684, '\p{Is_Nv:	3.125e-03}', "");
    Expect(0, 73684, '\p{^Is_Nv:	3.125e-03}', "");
    Expect(0, 73684, '\P{Is_Nv:	3.125e-03}', "");
    Expect(1, 73684, '\P{^Is_Nv:	3.125e-03}', "");
    Expect(0, 73685, '\p{Is_Nv:	3.125e-03}', "");
    Expect(1, 73685, '\p{^Is_Nv:	3.125e-03}', "");
    Expect(1, 73685, '\P{Is_Nv:	3.125e-03}', "");
    Expect(0, 73685, '\P{^Is_Nv:	3.125e-03}', "");
    Error('\p{Is_Nv=0.003}');
    Error('\P{Is_Nv=0.003}');
    Expect(1, 73684, '\p{Is_Nv=3.1250e-03}', "");
    Expect(0, 73684, '\p{^Is_Nv=3.1250e-03}', "");
    Expect(0, 73684, '\P{Is_Nv=3.1250e-03}', "");
    Expect(1, 73684, '\P{^Is_Nv=3.1250e-03}', "");
    Expect(0, 73685, '\p{Is_Nv=3.1250e-03}', "");
    Expect(1, 73685, '\p{^Is_Nv=3.1250e-03}', "");
    Expect(1, 73685, '\P{Is_Nv=3.1250e-03}', "");
    Expect(0, 73685, '\P{^Is_Nv=3.1250e-03}', "");
    Error('\p{Is_Nv=0.0031}');
    Error('\P{Is_Nv=0.0031}');
    Expect(1, 73684, '\p{Is_Nv=3.12500e-03}', "");
    Expect(0, 73684, '\p{^Is_Nv=3.12500e-03}', "");
    Expect(0, 73684, '\P{Is_Nv=3.12500e-03}', "");
    Expect(1, 73684, '\P{^Is_Nv=3.12500e-03}', "");
    Expect(0, 73685, '\p{Is_Nv=3.12500e-03}', "");
    Expect(1, 73685, '\p{^Is_Nv=3.12500e-03}', "");
    Expect(1, 73685, '\P{Is_Nv=3.12500e-03}', "");
    Expect(0, 73685, '\P{^Is_Nv=3.12500e-03}', "");
    Expect(1, 73684, '\p{Is_Nv=0.00313}', "");
    Expect(0, 73684, '\p{^Is_Nv=0.00313}', "");
    Expect(0, 73684, '\P{Is_Nv=0.00313}', "");
    Expect(1, 73684, '\P{^Is_Nv=0.00313}', "");
    Expect(0, 73685, '\p{Is_Nv=0.00313}', "");
    Expect(1, 73685, '\p{^Is_Nv=0.00313}', "");
    Expect(1, 73685, '\P{Is_Nv=0.00313}', "");
    Expect(0, 73685, '\P{^Is_Nv=0.00313}', "");
    Expect(1, 73684, '\p{Is_Nv=3.125000e-03}', "");
    Expect(0, 73684, '\p{^Is_Nv=3.125000e-03}', "");
    Expect(0, 73684, '\P{Is_Nv=3.125000e-03}', "");
    Expect(1, 73684, '\P{^Is_Nv=3.125000e-03}', "");
    Expect(0, 73685, '\p{Is_Nv=3.125000e-03}', "");
    Expect(1, 73685, '\p{^Is_Nv=3.125000e-03}', "");
    Expect(1, 73685, '\P{Is_Nv=3.125000e-03}', "");
    Expect(0, 73685, '\P{^Is_Nv=3.125000e-03}', "");
    Expect(1, 73684, '\p{Is_Nv=0.003125}', "");
    Expect(0, 73684, '\p{^Is_Nv=0.003125}', "");
    Expect(0, 73684, '\P{Is_Nv=0.003125}', "");
    Expect(1, 73684, '\P{^Is_Nv=0.003125}', "");
    Expect(0, 73685, '\p{Is_Nv=0.003125}', "");
    Expect(1, 73685, '\p{^Is_Nv=0.003125}', "");
    Expect(1, 73685, '\P{Is_Nv=0.003125}', "");
    Expect(0, 73685, '\P{^Is_Nv=0.003125}', "");
    Error('\p{Numeric_Value= 01/4:=}');
    Error('\P{Numeric_Value= 01/4:=}');
    Expect(1, 126125, '\p{Numeric_Value=:\A1/4\z:}', "");;
    Expect(0, 126126, '\p{Numeric_Value=:\A1/4\z:}', "");;
    Expect(1, 126125, '\p{Numeric_Value=+00001/00000004}', "");
    Expect(0, 126125, '\p{^Numeric_Value=+00001/00000004}', "");
    Expect(0, 126125, '\P{Numeric_Value=+00001/00000004}', "");
    Expect(1, 126125, '\P{^Numeric_Value=+00001/00000004}', "");
    Expect(0, 126126, '\p{Numeric_Value=+00001/00000004}', "");
    Expect(1, 126126, '\p{^Numeric_Value=+00001/00000004}', "");
    Expect(1, 126126, '\P{Numeric_Value=+00001/00000004}', "");
    Expect(0, 126126, '\P{^Numeric_Value=+00001/00000004}', "");
    Expect(1, 126125, '\p{Numeric_Value=60/240}', "");
    Expect(0, 126125, '\p{^Numeric_Value=60/240}', "");
    Expect(0, 126125, '\P{Numeric_Value=60/240}', "");
    Expect(1, 126125, '\P{^Numeric_Value=60/240}', "");
    Expect(0, 126126, '\p{Numeric_Value=60/240}', "");
    Expect(1, 126126, '\p{^Numeric_Value=60/240}', "");
    Expect(1, 126126, '\P{Numeric_Value=60/240}', "");
    Expect(0, 126126, '\P{^Numeric_Value=60/240}', "");
    Expect(1, 126125, '\p{Numeric_Value=2.5e-01}', "");
    Expect(0, 126125, '\p{^Numeric_Value=2.5e-01}', "");
    Expect(0, 126125, '\P{Numeric_Value=2.5e-01}', "");
    Expect(1, 126125, '\P{^Numeric_Value=2.5e-01}', "");
    Expect(0, 126126, '\p{Numeric_Value=2.5e-01}', "");
    Expect(1, 126126, '\p{^Numeric_Value=2.5e-01}', "");
    Expect(1, 126126, '\P{Numeric_Value=2.5e-01}', "");
    Expect(0, 126126, '\P{^Numeric_Value=2.5e-01}', "");
    Expect(1, 126125, '\p{Numeric_Value=2.50e-01}', "");
    Expect(0, 126125, '\p{^Numeric_Value=2.50e-01}', "");
    Expect(0, 126125, '\P{Numeric_Value=2.50e-01}', "");
    Expect(1, 126125, '\P{^Numeric_Value=2.50e-01}', "");
    Expect(0, 126126, '\p{Numeric_Value=2.50e-01}', "");
    Expect(1, 126126, '\p{^Numeric_Value=2.50e-01}', "");
    Expect(1, 126126, '\P{Numeric_Value=2.50e-01}', "");
    Expect(0, 126126, '\P{^Numeric_Value=2.50e-01}', "");
    Expect(1, 126125, '\p{Numeric_Value=0.25}', "");
    Expect(0, 126125, '\p{^Numeric_Value=0.25}', "");
    Expect(0, 126125, '\P{Numeric_Value=0.25}', "");
    Expect(1, 126125, '\P{^Numeric_Value=0.25}', "");
    Expect(0, 126126, '\p{Numeric_Value=0.25}', "");
    Expect(1, 126126, '\p{^Numeric_Value=0.25}', "");
    Expect(1, 126126, '\P{Numeric_Value=0.25}', "");
    Expect(0, 126126, '\P{^Numeric_Value=0.25}', "");
    Expect(1, 126125, '\p{Numeric_Value:2.500e-01}', "");
    Expect(0, 126125, '\p{^Numeric_Value:2.500e-01}', "");
    Expect(0, 126125, '\P{Numeric_Value:2.500e-01}', "");
    Expect(1, 126125, '\P{^Numeric_Value:2.500e-01}', "");
    Expect(0, 126126, '\p{Numeric_Value:2.500e-01}', "");
    Expect(1, 126126, '\p{^Numeric_Value:2.500e-01}', "");
    Expect(1, 126126, '\P{Numeric_Value:2.500e-01}', "");
    Expect(0, 126126, '\P{^Numeric_Value:2.500e-01}', "");
    Expect(1, 126125, '\p{Numeric_Value=0.250}', "");
    Expect(0, 126125, '\p{^Numeric_Value=0.250}', "");
    Expect(0, 126125, '\P{Numeric_Value=0.250}', "");
    Expect(1, 126125, '\P{^Numeric_Value=0.250}', "");
    Expect(0, 126126, '\p{Numeric_Value=0.250}', "");
    Expect(1, 126126, '\p{^Numeric_Value=0.250}', "");
    Expect(1, 126126, '\P{Numeric_Value=0.250}', "");
    Expect(0, 126126, '\P{^Numeric_Value=0.250}', "");
    Error('\p{Nv=	:=000000001/04}');
    Error('\P{Nv=	:=000000001/04}');
    Expect(1, 126125, '\p{Nv=:\A1/4\z:}', "");;
    Expect(0, 126126, '\p{Nv=:\A1/4\z:}', "");;
    Expect(1, 126125, '\p{Nv=000000001/000004}', "");
    Expect(0, 126125, '\p{^Nv=000000001/000004}', "");
    Expect(0, 126125, '\P{Nv=000000001/000004}', "");
    Expect(1, 126125, '\P{^Nv=000000001/000004}', "");
    Expect(0, 126126, '\p{Nv=000000001/000004}', "");
    Expect(1, 126126, '\p{^Nv=000000001/000004}', "");
    Expect(1, 126126, '\P{Nv=000000001/000004}', "");
    Expect(0, 126126, '\P{^Nv=000000001/000004}', "");
    Expect(1, 126125, '\p{Nv=60/240}', "");
    Expect(0, 126125, '\p{^Nv=60/240}', "");
    Expect(0, 126125, '\P{Nv=60/240}', "");
    Expect(1, 126125, '\P{^Nv=60/240}', "");
    Expect(0, 126126, '\p{Nv=60/240}', "");
    Expect(1, 126126, '\p{^Nv=60/240}', "");
    Expect(1, 126126, '\P{Nv=60/240}', "");
    Expect(0, 126126, '\P{^Nv=60/240}', "");
    Expect(1, 126125, '\p{Nv=2.5e-01}', "");
    Expect(0, 126125, '\p{^Nv=2.5e-01}', "");
    Expect(0, 126125, '\P{Nv=2.5e-01}', "");
    Expect(1, 126125, '\P{^Nv=2.5e-01}', "");
    Expect(0, 126126, '\p{Nv=2.5e-01}', "");
    Expect(1, 126126, '\p{^Nv=2.5e-01}', "");
    Expect(1, 126126, '\P{Nv=2.5e-01}', "");
    Expect(0, 126126, '\P{^Nv=2.5e-01}', "");
    Expect(1, 126125, '\p{Nv=2.50e-01}', "");
    Expect(0, 126125, '\p{^Nv=2.50e-01}', "");
    Expect(0, 126125, '\P{Nv=2.50e-01}', "");
    Expect(1, 126125, '\P{^Nv=2.50e-01}', "");
    Expect(0, 126126, '\p{Nv=2.50e-01}', "");
    Expect(1, 126126, '\p{^Nv=2.50e-01}', "");
    Expect(1, 126126, '\P{Nv=2.50e-01}', "");
    Expect(0, 126126, '\P{^Nv=2.50e-01}', "");
    Expect(1, 126125, '\p{Nv=0.25}', "");
    Expect(0, 126125, '\p{^Nv=0.25}', "");
    Expect(0, 126125, '\P{Nv=0.25}', "");
    Expect(1, 126125, '\P{^Nv=0.25}', "");
    Expect(0, 126126, '\p{Nv=0.25}', "");
    Expect(1, 126126, '\p{^Nv=0.25}', "");
    Expect(1, 126126, '\P{Nv=0.25}', "");
    Expect(0, 126126, '\P{^Nv=0.25}', "");
    Expect(1, 126125, '\p{Nv=2.500e-01}', "");
    Expect(0, 126125, '\p{^Nv=2.500e-01}', "");
    Expect(0, 126125, '\P{Nv=2.500e-01}', "");
    Expect(1, 126125, '\P{^Nv=2.500e-01}', "");
    Expect(0, 126126, '\p{Nv=2.500e-01}', "");
    Expect(1, 126126, '\p{^Nv=2.500e-01}', "");
    Expect(1, 126126, '\P{Nv=2.500e-01}', "");
    Expect(0, 126126, '\P{^Nv=2.500e-01}', "");
    Expect(1, 126125, '\p{Nv: 0.250}', "");
    Expect(0, 126125, '\p{^Nv: 0.250}', "");
    Expect(0, 126125, '\P{Nv: 0.250}', "");
    Expect(1, 126125, '\P{^Nv: 0.250}', "");
    Expect(0, 126126, '\p{Nv: 0.250}', "");
    Expect(1, 126126, '\p{^Nv: 0.250}', "");
    Expect(1, 126126, '\P{Nv: 0.250}', "");
    Expect(0, 126126, '\P{^Nv: 0.250}', "");
    Error('\p{Is_Numeric_Value=/a/0000000001/004}');
    Error('\P{Is_Numeric_Value=/a/0000000001/004}');
    Expect(1, 126125, '\p{Is_Numeric_Value=0001/0004}', "");
    Expect(0, 126125, '\p{^Is_Numeric_Value=0001/0004}', "");
    Expect(0, 126125, '\P{Is_Numeric_Value=0001/0004}', "");
    Expect(1, 126125, '\P{^Is_Numeric_Value=0001/0004}', "");
    Expect(0, 126126, '\p{Is_Numeric_Value=0001/0004}', "");
    Expect(1, 126126, '\p{^Is_Numeric_Value=0001/0004}', "");
    Expect(1, 126126, '\P{Is_Numeric_Value=0001/0004}', "");
    Expect(0, 126126, '\P{^Is_Numeric_Value=0001/0004}', "");
    Expect(1, 126125, '\p{Is_Numeric_Value=60/240}', "");
    Expect(0, 126125, '\p{^Is_Numeric_Value=60/240}', "");
    Expect(0, 126125, '\P{Is_Numeric_Value=60/240}', "");
    Expect(1, 126125, '\P{^Is_Numeric_Value=60/240}', "");
    Expect(0, 126126, '\p{Is_Numeric_Value=60/240}', "");
    Expect(1, 126126, '\p{^Is_Numeric_Value=60/240}', "");
    Expect(1, 126126, '\P{Is_Numeric_Value=60/240}', "");
    Expect(0, 126126, '\P{^Is_Numeric_Value=60/240}', "");
    Expect(1, 126125, '\p{Is_Numeric_Value=2.5e-01}', "");
    Expect(0, 126125, '\p{^Is_Numeric_Value=2.5e-01}', "");
    Expect(0, 126125, '\P{Is_Numeric_Value=2.5e-01}', "");
    Expect(1, 126125, '\P{^Is_Numeric_Value=2.5e-01}', "");
    Expect(0, 126126, '\p{Is_Numeric_Value=2.5e-01}', "");
    Expect(1, 126126, '\p{^Is_Numeric_Value=2.5e-01}', "");
    Expect(1, 126126, '\P{Is_Numeric_Value=2.5e-01}', "");
    Expect(0, 126126, '\P{^Is_Numeric_Value=2.5e-01}', "");
    Expect(1, 126125, '\p{Is_Numeric_Value=2.50e-01}', "");
    Expect(0, 126125, '\p{^Is_Numeric_Value=2.50e-01}', "");
    Expect(0, 126125, '\P{Is_Numeric_Value=2.50e-01}', "");
    Expect(1, 126125, '\P{^Is_Numeric_Value=2.50e-01}', "");
    Expect(0, 126126, '\p{Is_Numeric_Value=2.50e-01}', "");
    Expect(1, 126126, '\p{^Is_Numeric_Value=2.50e-01}', "");
    Expect(1, 126126, '\P{Is_Numeric_Value=2.50e-01}', "");
    Expect(0, 126126, '\P{^Is_Numeric_Value=2.50e-01}', "");
    Expect(1, 126125, '\p{Is_Numeric_Value=0.25}', "");
    Expect(0, 126125, '\p{^Is_Numeric_Value=0.25}', "");
    Expect(0, 126125, '\P{Is_Numeric_Value=0.25}', "");
    Expect(1, 126125, '\P{^Is_Numeric_Value=0.25}', "");
    Expect(0, 126126, '\p{Is_Numeric_Value=0.25}', "");
    Expect(1, 126126, '\p{^Is_Numeric_Value=0.25}', "");
    Expect(1, 126126, '\P{Is_Numeric_Value=0.25}', "");
    Expect(0, 126126, '\P{^Is_Numeric_Value=0.25}', "");
    Expect(1, 126125, '\p{Is_Numeric_Value=2.500e-01}', "");
    Expect(0, 126125, '\p{^Is_Numeric_Value=2.500e-01}', "");
    Expect(0, 126125, '\P{Is_Numeric_Value=2.500e-01}', "");
    Expect(1, 126125, '\P{^Is_Numeric_Value=2.500e-01}', "");
    Expect(0, 126126, '\p{Is_Numeric_Value=2.500e-01}', "");
    Expect(1, 126126, '\p{^Is_Numeric_Value=2.500e-01}', "");
    Expect(1, 126126, '\P{Is_Numeric_Value=2.500e-01}', "");
    Expect(0, 126126, '\P{^Is_Numeric_Value=2.500e-01}', "");
    Expect(1, 126125, '\p{Is_Numeric_Value=0.250}', "");
    Expect(0, 126125, '\p{^Is_Numeric_Value=0.250}', "");
    Expect(0, 126125, '\P{Is_Numeric_Value=0.250}', "");
    Expect(1, 126125, '\P{^Is_Numeric_Value=0.250}', "");
    Expect(0, 126126, '\p{Is_Numeric_Value=0.250}', "");
    Expect(1, 126126, '\p{^Is_Numeric_Value=0.250}', "");
    Expect(1, 126126, '\P{Is_Numeric_Value=0.250}', "");
    Expect(0, 126126, '\P{^Is_Numeric_Value=0.250}', "");
    Error('\p{Is_Nv=_:=+000001/4}');
    Error('\P{Is_Nv=_:=+000001/4}');
    Expect(1, 126125, '\p{Is_Nv:   0000000001/00004}', "");
    Expect(0, 126125, '\p{^Is_Nv:   0000000001/00004}', "");
    Expect(0, 126125, '\P{Is_Nv:   0000000001/00004}', "");
    Expect(1, 126125, '\P{^Is_Nv:   0000000001/00004}', "");
    Expect(0, 126126, '\p{Is_Nv:   0000000001/00004}', "");
    Expect(1, 126126, '\p{^Is_Nv:   0000000001/00004}', "");
    Expect(1, 126126, '\P{Is_Nv:   0000000001/00004}', "");
    Expect(0, 126126, '\P{^Is_Nv:   0000000001/00004}', "");
    Expect(1, 126125, '\p{Is_Nv: 60/240}', "");
    Expect(0, 126125, '\p{^Is_Nv: 60/240}', "");
    Expect(0, 126125, '\P{Is_Nv: 60/240}', "");
    Expect(1, 126125, '\P{^Is_Nv: 60/240}', "");
    Expect(0, 126126, '\p{Is_Nv: 60/240}', "");
    Expect(1, 126126, '\p{^Is_Nv: 60/240}', "");
    Expect(1, 126126, '\P{Is_Nv: 60/240}', "");
    Expect(0, 126126, '\P{^Is_Nv: 60/240}', "");
    Expect(1, 126125, '\p{Is_Nv=2.5e-01}', "");
    Expect(0, 126125, '\p{^Is_Nv=2.5e-01}', "");
    Expect(0, 126125, '\P{Is_Nv=2.5e-01}', "");
    Expect(1, 126125, '\P{^Is_Nv=2.5e-01}', "");
    Expect(0, 126126, '\p{Is_Nv=2.5e-01}', "");
    Expect(1, 126126, '\p{^Is_Nv=2.5e-01}', "");
    Expect(1, 126126, '\P{Is_Nv=2.5e-01}', "");
    Expect(0, 126126, '\P{^Is_Nv=2.5e-01}', "");
    Expect(1, 126125, '\p{Is_Nv=2.50e-01}', "");
    Expect(0, 126125, '\p{^Is_Nv=2.50e-01}', "");
    Expect(0, 126125, '\P{Is_Nv=2.50e-01}', "");
    Expect(1, 126125, '\P{^Is_Nv=2.50e-01}', "");
    Expect(0, 126126, '\p{Is_Nv=2.50e-01}', "");
    Expect(1, 126126, '\p{^Is_Nv=2.50e-01}', "");
    Expect(1, 126126, '\P{Is_Nv=2.50e-01}', "");
    Expect(0, 126126, '\P{^Is_Nv=2.50e-01}', "");
    Expect(1, 126125, '\p{Is_Nv=0.25}', "");
    Expect(0, 126125, '\p{^Is_Nv=0.25}', "");
    Expect(0, 126125, '\P{Is_Nv=0.25}', "");
    Expect(1, 126125, '\P{^Is_Nv=0.25}', "");
    Expect(0, 126126, '\p{Is_Nv=0.25}', "");
    Expect(1, 126126, '\p{^Is_Nv=0.25}', "");
    Expect(1, 126126, '\P{Is_Nv=0.25}', "");
    Expect(0, 126126, '\P{^Is_Nv=0.25}', "");
    Expect(1, 126125, '\p{Is_Nv=2.500e-01}', "");
    Expect(0, 126125, '\p{^Is_Nv=2.500e-01}', "");
    Expect(0, 126125, '\P{Is_Nv=2.500e-01}', "");
    Expect(1, 126125, '\P{^Is_Nv=2.500e-01}', "");
    Expect(0, 126126, '\p{Is_Nv=2.500e-01}', "");
    Expect(1, 126126, '\p{^Is_Nv=2.500e-01}', "");
    Expect(1, 126126, '\P{Is_Nv=2.500e-01}', "");
    Expect(0, 126126, '\P{^Is_Nv=2.500e-01}', "");
    Expect(1, 126125, '\p{Is_Nv=0.250}', "");
    Expect(0, 126125, '\p{^Is_Nv=0.250}', "");
    Expect(0, 126125, '\P{Is_Nv=0.250}', "");
    Expect(1, 126125, '\P{^Is_Nv=0.250}', "");
    Expect(0, 126126, '\p{Is_Nv=0.250}', "");
    Expect(1, 126126, '\p{^Is_Nv=0.250}', "");
    Expect(1, 126126, '\P{Is_Nv=0.250}', "");
    Expect(0, 126126, '\P{^Is_Nv=0.250}', "");
    Error('\p{Numeric_Value=/a/	 0000001/000040}');
    Error('\P{Numeric_Value=/a/	 0000001/000040}');
    Expect(1, 73668, '\p{Numeric_Value=:\A1/40\z:}', "");;
    Expect(0, 73669, '\p{Numeric_Value=:\A1/40\z:}', "");;
    Expect(1, 73668, '\p{Numeric_Value=00001/00000000040}', "");
    Expect(0, 73668, '\p{^Numeric_Value=00001/00000000040}', "");
    Expect(0, 73668, '\P{Numeric_Value=00001/00000000040}', "");
    Expect(1, 73668, '\P{^Numeric_Value=00001/00000000040}', "");
    Expect(0, 73669, '\p{Numeric_Value=00001/00000000040}', "");
    Expect(1, 73669, '\p{^Numeric_Value=00001/00000000040}', "");
    Expect(1, 73669, '\P{Numeric_Value=00001/00000000040}', "");
    Expect(0, 73669, '\P{^Numeric_Value=00001/00000000040}', "");
    Expect(1, 73668, '\p{Numeric_Value=60/2400}', "");
    Expect(0, 73668, '\p{^Numeric_Value=60/2400}', "");
    Expect(0, 73668, '\P{Numeric_Value=60/2400}', "");
    Expect(1, 73668, '\P{^Numeric_Value=60/2400}', "");
    Expect(0, 73669, '\p{Numeric_Value=60/2400}', "");
    Expect(1, 73669, '\p{^Numeric_Value=60/2400}', "");
    Expect(1, 73669, '\P{Numeric_Value=60/2400}', "");
    Expect(0, 73669, '\P{^Numeric_Value=60/2400}', "");
    Expect(1, 73668, '\p{Numeric_Value=2.5e-02}', "");
    Expect(0, 73668, '\p{^Numeric_Value=2.5e-02}', "");
    Expect(0, 73668, '\P{Numeric_Value=2.5e-02}', "");
    Expect(1, 73668, '\P{^Numeric_Value=2.5e-02}', "");
    Expect(0, 73669, '\p{Numeric_Value=2.5e-02}', "");
    Expect(1, 73669, '\p{^Numeric_Value=2.5e-02}', "");
    Expect(1, 73669, '\P{Numeric_Value=2.5e-02}', "");
    Expect(0, 73669, '\P{^Numeric_Value=2.5e-02}', "");
    Expect(1, 73668, '\p{Numeric_Value=2.50e-02}', "");
    Expect(0, 73668, '\p{^Numeric_Value=2.50e-02}', "");
    Expect(0, 73668, '\P{Numeric_Value=2.50e-02}', "");
    Expect(1, 73668, '\P{^Numeric_Value=2.50e-02}', "");
    Expect(0, 73669, '\p{Numeric_Value=2.50e-02}', "");
    Expect(1, 73669, '\p{^Numeric_Value=2.50e-02}', "");
    Expect(1, 73669, '\P{Numeric_Value=2.50e-02}', "");
    Expect(0, 73669, '\P{^Numeric_Value=2.50e-02}', "");
    Error('\p{Numeric_Value=0.03}');
    Error('\P{Numeric_Value=0.03}');
    Expect(1, 73668, '\p{Numeric_Value=2.500e-02}', "");
    Expect(0, 73668, '\p{^Numeric_Value=2.500e-02}', "");
    Expect(0, 73668, '\P{Numeric_Value=2.500e-02}', "");
    Expect(1, 73668, '\P{^Numeric_Value=2.500e-02}', "");
    Expect(0, 73669, '\p{Numeric_Value=2.500e-02}', "");
    Expect(1, 73669, '\p{^Numeric_Value=2.500e-02}', "");
    Expect(1, 73669, '\P{Numeric_Value=2.500e-02}', "");
    Expect(0, 73669, '\P{^Numeric_Value=2.500e-02}', "");
    Expect(1, 73668, '\p{Numeric_Value=0.025}', "");
    Expect(0, 73668, '\p{^Numeric_Value=0.025}', "");
    Expect(0, 73668, '\P{Numeric_Value=0.025}', "");
    Expect(1, 73668, '\P{^Numeric_Value=0.025}', "");
    Expect(0, 73669, '\p{Numeric_Value=0.025}', "");
    Expect(1, 73669, '\p{^Numeric_Value=0.025}', "");
    Expect(1, 73669, '\P{Numeric_Value=0.025}', "");
    Expect(0, 73669, '\P{^Numeric_Value=0.025}', "");
    Expect(1, 73668, '\p{Numeric_Value=2.5000e-02}', "");
    Expect(0, 73668, '\p{^Numeric_Value=2.5000e-02}', "");
    Expect(0, 73668, '\P{Numeric_Value=2.5000e-02}', "");
    Expect(1, 73668, '\P{^Numeric_Value=2.5000e-02}', "");
    Expect(0, 73669, '\p{Numeric_Value=2.5000e-02}', "");
    Expect(1, 73669, '\p{^Numeric_Value=2.5000e-02}', "");
    Expect(1, 73669, '\P{Numeric_Value=2.5000e-02}', "");
    Expect(0, 73669, '\P{^Numeric_Value=2.5000e-02}', "");
    Expect(1, 73668, '\p{Numeric_Value=0.0250}', "");
    Expect(0, 73668, '\p{^Numeric_Value=0.0250}', "");
    Expect(0, 73668, '\P{Numeric_Value=0.0250}', "");
    Expect(1, 73668, '\P{^Numeric_Value=0.0250}', "");
    Expect(0, 73669, '\p{Numeric_Value=0.0250}', "");
    Expect(1, 73669, '\p{^Numeric_Value=0.0250}', "");
    Expect(1, 73669, '\P{Numeric_Value=0.0250}', "");
    Expect(0, 73669, '\P{^Numeric_Value=0.0250}', "");
    Error('\p{Nv=/a/- 0000000001/0000000040}');
    Error('\P{Nv=/a/- 0000000001/0000000040}');
    Expect(1, 73668, '\p{Nv=:\A1/40\z:}', "");;
    Expect(0, 73669, '\p{Nv=:\A1/40\z:}', "");;
    Expect(1, 73668, '\p{Nv=+00001/0000040}', "");
    Expect(0, 73668, '\p{^Nv=+00001/0000040}', "");
    Expect(0, 73668, '\P{Nv=+00001/0000040}', "");
    Expect(1, 73668, '\P{^Nv=+00001/0000040}', "");
    Expect(0, 73669, '\p{Nv=+00001/0000040}', "");
    Expect(1, 73669, '\p{^Nv=+00001/0000040}', "");
    Expect(1, 73669, '\P{Nv=+00001/0000040}', "");
    Expect(0, 73669, '\P{^Nv=+00001/0000040}', "");
    Expect(1, 73668, '\p{Nv=60/2400}', "");
    Expect(0, 73668, '\p{^Nv=60/2400}', "");
    Expect(0, 73668, '\P{Nv=60/2400}', "");
    Expect(1, 73668, '\P{^Nv=60/2400}', "");
    Expect(0, 73669, '\p{Nv=60/2400}', "");
    Expect(1, 73669, '\p{^Nv=60/2400}', "");
    Expect(1, 73669, '\P{Nv=60/2400}', "");
    Expect(0, 73669, '\P{^Nv=60/2400}', "");
    Expect(1, 73668, '\p{Nv=2.5e-02}', "");
    Expect(0, 73668, '\p{^Nv=2.5e-02}', "");
    Expect(0, 73668, '\P{Nv=2.5e-02}', "");
    Expect(1, 73668, '\P{^Nv=2.5e-02}', "");
    Expect(0, 73669, '\p{Nv=2.5e-02}', "");
    Expect(1, 73669, '\p{^Nv=2.5e-02}', "");
    Expect(1, 73669, '\P{Nv=2.5e-02}', "");
    Expect(0, 73669, '\P{^Nv=2.5e-02}', "");
    Expect(1, 73668, '\p{Nv=2.50e-02}', "");
    Expect(0, 73668, '\p{^Nv=2.50e-02}', "");
    Expect(0, 73668, '\P{Nv=2.50e-02}', "");
    Expect(1, 73668, '\P{^Nv=2.50e-02}', "");
    Expect(0, 73669, '\p{Nv=2.50e-02}', "");
    Expect(1, 73669, '\p{^Nv=2.50e-02}', "");
    Expect(1, 73669, '\P{Nv=2.50e-02}', "");
    Expect(0, 73669, '\P{^Nv=2.50e-02}', "");
    Error('\p{Nv=0.03}');
    Error('\P{Nv=0.03}');
    Expect(1, 73668, '\p{Nv=2.500e-02}', "");
    Expect(0, 73668, '\p{^Nv=2.500e-02}', "");
    Expect(0, 73668, '\P{Nv=2.500e-02}', "");
    Expect(1, 73668, '\P{^Nv=2.500e-02}', "");
    Expect(0, 73669, '\p{Nv=2.500e-02}', "");
    Expect(1, 73669, '\p{^Nv=2.500e-02}', "");
    Expect(1, 73669, '\P{Nv=2.500e-02}', "");
    Expect(0, 73669, '\P{^Nv=2.500e-02}', "");
    Expect(1, 73668, '\p{Nv:0.025}', "");
    Expect(0, 73668, '\p{^Nv:0.025}', "");
    Expect(0, 73668, '\P{Nv:0.025}', "");
    Expect(1, 73668, '\P{^Nv:0.025}', "");
    Expect(0, 73669, '\p{Nv:0.025}', "");
    Expect(1, 73669, '\p{^Nv:0.025}', "");
    Expect(1, 73669, '\P{Nv:0.025}', "");
    Expect(0, 73669, '\P{^Nv:0.025}', "");
    Expect(1, 73668, '\p{Nv=2.5000e-02}', "");
    Expect(0, 73668, '\p{^Nv=2.5000e-02}', "");
    Expect(0, 73668, '\P{Nv=2.5000e-02}', "");
    Expect(1, 73668, '\P{^Nv=2.5000e-02}', "");
    Expect(0, 73669, '\p{Nv=2.5000e-02}', "");
    Expect(1, 73669, '\p{^Nv=2.5000e-02}', "");
    Expect(1, 73669, '\P{Nv=2.5000e-02}', "");
    Expect(0, 73669, '\P{^Nv=2.5000e-02}', "");
    Expect(1, 73668, '\p{Nv=0.0250}', "");
    Expect(0, 73668, '\p{^Nv=0.0250}', "");
    Expect(0, 73668, '\P{Nv=0.0250}', "");
    Expect(1, 73668, '\P{^Nv=0.0250}', "");
    Expect(0, 73669, '\p{Nv=0.0250}', "");
    Expect(1, 73669, '\p{^Nv=0.0250}', "");
    Expect(1, 73669, '\P{Nv=0.0250}', "");
    Expect(0, 73669, '\P{^Nv=0.0250}', "");
    Error('\p{Is_Numeric_Value=-/a/0000001/000040}');
    Error('\P{Is_Numeric_Value=-/a/0000001/000040}');
    Expect(1, 73668, '\p{Is_Numeric_Value=1/00040}', "");
    Expect(0, 73668, '\p{^Is_Numeric_Value=1/00040}', "");
    Expect(0, 73668, '\P{Is_Numeric_Value=1/00040}', "");
    Expect(1, 73668, '\P{^Is_Numeric_Value=1/00040}', "");
    Expect(0, 73669, '\p{Is_Numeric_Value=1/00040}', "");
    Expect(1, 73669, '\p{^Is_Numeric_Value=1/00040}', "");
    Expect(1, 73669, '\P{Is_Numeric_Value=1/00040}', "");
    Expect(0, 73669, '\P{^Is_Numeric_Value=1/00040}', "");
    Expect(1, 73668, '\p{Is_Numeric_Value=60/2400}', "");
    Expect(0, 73668, '\p{^Is_Numeric_Value=60/2400}', "");
    Expect(0, 73668, '\P{Is_Numeric_Value=60/2400}', "");
    Expect(1, 73668, '\P{^Is_Numeric_Value=60/2400}', "");
    Expect(0, 73669, '\p{Is_Numeric_Value=60/2400}', "");
    Expect(1, 73669, '\p{^Is_Numeric_Value=60/2400}', "");
    Expect(1, 73669, '\P{Is_Numeric_Value=60/2400}', "");
    Expect(0, 73669, '\P{^Is_Numeric_Value=60/2400}', "");
    Expect(1, 73668, '\p{Is_Numeric_Value=2.5e-02}', "");
    Expect(0, 73668, '\p{^Is_Numeric_Value=2.5e-02}', "");
    Expect(0, 73668, '\P{Is_Numeric_Value=2.5e-02}', "");
    Expect(1, 73668, '\P{^Is_Numeric_Value=2.5e-02}', "");
    Expect(0, 73669, '\p{Is_Numeric_Value=2.5e-02}', "");
    Expect(1, 73669, '\p{^Is_Numeric_Value=2.5e-02}', "");
    Expect(1, 73669, '\P{Is_Numeric_Value=2.5e-02}', "");
    Expect(0, 73669, '\P{^Is_Numeric_Value=2.5e-02}', "");
    Expect(1, 73668, '\p{Is_Numeric_Value=2.50e-02}', "");
    Expect(0, 73668, '\p{^Is_Numeric_Value=2.50e-02}', "");
    Expect(0, 73668, '\P{Is_Numeric_Value=2.50e-02}', "");
    Expect(1, 73668, '\P{^Is_Numeric_Value=2.50e-02}', "");
    Expect(0, 73669, '\p{Is_Numeric_Value=2.50e-02}', "");
    Expect(1, 73669, '\p{^Is_Numeric_Value=2.50e-02}', "");
    Expect(1, 73669, '\P{Is_Numeric_Value=2.50e-02}', "");
    Expect(0, 73669, '\P{^Is_Numeric_Value=2.50e-02}', "");
    Error('\p{Is_Numeric_Value:	0.03}');
    Error('\P{Is_Numeric_Value:	0.03}');
    Expect(1, 73668, '\p{Is_Numeric_Value=2.500e-02}', "");
    Expect(0, 73668, '\p{^Is_Numeric_Value=2.500e-02}', "");
    Expect(0, 73668, '\P{Is_Numeric_Value=2.500e-02}', "");
    Expect(1, 73668, '\P{^Is_Numeric_Value=2.500e-02}', "");
    Expect(0, 73669, '\p{Is_Numeric_Value=2.500e-02}', "");
    Expect(1, 73669, '\p{^Is_Numeric_Value=2.500e-02}', "");
    Expect(1, 73669, '\P{Is_Numeric_Value=2.500e-02}', "");
    Expect(0, 73669, '\P{^Is_Numeric_Value=2.500e-02}', "");
    Expect(1, 73668, '\p{Is_Numeric_Value=0.025}', "");
    Expect(0, 73668, '\p{^Is_Numeric_Value=0.025}', "");
    Expect(0, 73668, '\P{Is_Numeric_Value=0.025}', "");
    Expect(1, 73668, '\P{^Is_Numeric_Value=0.025}', "");
    Expect(0, 73669, '\p{Is_Numeric_Value=0.025}', "");
    Expect(1, 73669, '\p{^Is_Numeric_Value=0.025}', "");
    Expect(1, 73669, '\P{Is_Numeric_Value=0.025}', "");
    Expect(0, 73669, '\P{^Is_Numeric_Value=0.025}', "");
    Expect(1, 73668, '\p{Is_Numeric_Value=2.5000e-02}', "");
    Expect(0, 73668, '\p{^Is_Numeric_Value=2.5000e-02}', "");
    Expect(0, 73668, '\P{Is_Numeric_Value=2.5000e-02}', "");
    Expect(1, 73668, '\P{^Is_Numeric_Value=2.5000e-02}', "");
    Expect(0, 73669, '\p{Is_Numeric_Value=2.5000e-02}', "");
    Expect(1, 73669, '\p{^Is_Numeric_Value=2.5000e-02}', "");
    Expect(1, 73669, '\P{Is_Numeric_Value=2.5000e-02}', "");
    Expect(0, 73669, '\P{^Is_Numeric_Value=2.5000e-02}', "");
    Expect(1, 73668, '\p{Is_Numeric_Value=0.0250}', "");
    Expect(0, 73668, '\p{^Is_Numeric_Value=0.0250}', "");
    Expect(0, 73668, '\P{Is_Numeric_Value=0.0250}', "");
    Expect(1, 73668, '\P{^Is_Numeric_Value=0.0250}', "");
    Expect(0, 73669, '\p{Is_Numeric_Value=0.0250}', "");
    Expect(1, 73669, '\p{^Is_Numeric_Value=0.0250}', "");
    Expect(1, 73669, '\P{Is_Numeric_Value=0.0250}', "");
    Expect(0, 73669, '\P{^Is_Numeric_Value=0.0250}', "");
    Error('\p{Is_Nv=	/a/0001/00040}');
    Error('\P{Is_Nv=	/a/0001/00040}');
    Expect(1, 73668, '\p{Is_Nv=000001/00000000040}', "");
    Expect(0, 73668, '\p{^Is_Nv=000001/00000000040}', "");
    Expect(0, 73668, '\P{Is_Nv=000001/00000000040}', "");
    Expect(1, 73668, '\P{^Is_Nv=000001/00000000040}', "");
    Expect(0, 73669, '\p{Is_Nv=000001/00000000040}', "");
    Expect(1, 73669, '\p{^Is_Nv=000001/00000000040}', "");
    Expect(1, 73669, '\P{Is_Nv=000001/00000000040}', "");
    Expect(0, 73669, '\P{^Is_Nv=000001/00000000040}', "");
    Expect(1, 73668, '\p{Is_Nv=60/2400}', "");
    Expect(0, 73668, '\p{^Is_Nv=60/2400}', "");
    Expect(0, 73668, '\P{Is_Nv=60/2400}', "");
    Expect(1, 73668, '\P{^Is_Nv=60/2400}', "");
    Expect(0, 73669, '\p{Is_Nv=60/2400}', "");
    Expect(1, 73669, '\p{^Is_Nv=60/2400}', "");
    Expect(1, 73669, '\P{Is_Nv=60/2400}', "");
    Expect(0, 73669, '\P{^Is_Nv=60/2400}', "");
    Expect(1, 73668, '\p{Is_Nv=2.5e-02}', "");
    Expect(0, 73668, '\p{^Is_Nv=2.5e-02}', "");
    Expect(0, 73668, '\P{Is_Nv=2.5e-02}', "");
    Expect(1, 73668, '\P{^Is_Nv=2.5e-02}', "");
    Expect(0, 73669, '\p{Is_Nv=2.5e-02}', "");
    Expect(1, 73669, '\p{^Is_Nv=2.5e-02}', "");
    Expect(1, 73669, '\P{Is_Nv=2.5e-02}', "");
    Expect(0, 73669, '\P{^Is_Nv=2.5e-02}', "");
    Expect(1, 73668, '\p{Is_Nv=2.50e-02}', "");
    Expect(0, 73668, '\p{^Is_Nv=2.50e-02}', "");
    Expect(0, 73668, '\P{Is_Nv=2.50e-02}', "");
    Expect(1, 73668, '\P{^Is_Nv=2.50e-02}', "");
    Expect(0, 73669, '\p{Is_Nv=2.50e-02}', "");
    Expect(1, 73669, '\p{^Is_Nv=2.50e-02}', "");
    Expect(1, 73669, '\P{Is_Nv=2.50e-02}', "");
    Expect(0, 73669, '\P{^Is_Nv=2.50e-02}', "");
    Error('\p{Is_Nv=0.03}');
    Error('\P{Is_Nv=0.03}');
    Expect(1, 73668, '\p{Is_Nv=2.500e-02}', "");
    Expect(0, 73668, '\p{^Is_Nv=2.500e-02}', "");
    Expect(0, 73668, '\P{Is_Nv=2.500e-02}', "");
    Expect(1, 73668, '\P{^Is_Nv=2.500e-02}', "");
    Expect(0, 73669, '\p{Is_Nv=2.500e-02}', "");
    Expect(1, 73669, '\p{^Is_Nv=2.500e-02}', "");
    Expect(1, 73669, '\P{Is_Nv=2.500e-02}', "");
    Expect(0, 73669, '\P{^Is_Nv=2.500e-02}', "");
    Expect(1, 73668, '\p{Is_Nv=0.025}', "");
    Expect(0, 73668, '\p{^Is_Nv=0.025}', "");
    Expect(0, 73668, '\P{Is_Nv=0.025}', "");
    Expect(1, 73668, '\P{^Is_Nv=0.025}', "");
    Expect(0, 73669, '\p{Is_Nv=0.025}', "");
    Expect(1, 73669, '\p{^Is_Nv=0.025}', "");
    Expect(1, 73669, '\P{Is_Nv=0.025}', "");
    Expect(0, 73669, '\P{^Is_Nv=0.025}', "");
    Expect(1, 73668, '\p{Is_Nv=2.5000e-02}', "");
    Expect(0, 73668, '\p{^Is_Nv=2.5000e-02}', "");
    Expect(0, 73668, '\P{Is_Nv=2.5000e-02}', "");
    Expect(1, 73668, '\P{^Is_Nv=2.5000e-02}', "");
    Expect(0, 73669, '\p{Is_Nv=2.5000e-02}', "");
    Expect(1, 73669, '\p{^Is_Nv=2.5000e-02}', "");
    Expect(1, 73669, '\P{Is_Nv=2.5000e-02}', "");
    Expect(0, 73669, '\P{^Is_Nv=2.5000e-02}', "");
    Expect(1, 73668, '\p{Is_Nv=0.0250}', "");
    Expect(0, 73668, '\p{^Is_Nv=0.0250}', "");
    Expect(0, 73668, '\P{Is_Nv=0.0250}', "");
    Expect(1, 73668, '\P{^Is_Nv=0.0250}', "");
    Expect(0, 73669, '\p{Is_Nv=0.0250}', "");
    Expect(1, 73669, '\p{^Is_Nv=0.0250}', "");
    Expect(1, 73669, '\P{Is_Nv=0.0250}', "");
    Expect(0, 73669, '\P{^Is_Nv=0.0250}', "");
    Error('\p{Numeric_Value=_/a/000001/0000005}');
    Error('\P{Numeric_Value=_/a/000001/0000005}');
    Expect(1, 73679, '\p{Numeric_Value=:\A1/5\z:}', "");;
    Expect(0, 73680, '\p{Numeric_Value=:\A1/5\z:}', "");;
    Expect(1, 73679, '\p{Numeric_Value=+0001/000000005}', "");
    Expect(0, 73679, '\p{^Numeric_Value=+0001/000000005}', "");
    Expect(0, 73679, '\P{Numeric_Value=+0001/000000005}', "");
    Expect(1, 73679, '\P{^Numeric_Value=+0001/000000005}', "");
    Expect(0, 73680, '\p{Numeric_Value=+0001/000000005}', "");
    Expect(1, 73680, '\p{^Numeric_Value=+0001/000000005}', "");
    Expect(1, 73680, '\P{Numeric_Value=+0001/000000005}', "");
    Expect(0, 73680, '\P{^Numeric_Value=+0001/000000005}', "");
    Expect(1, 73679, '\p{Numeric_Value=60/300}', "");
    Expect(0, 73679, '\p{^Numeric_Value=60/300}', "");
    Expect(0, 73679, '\P{Numeric_Value=60/300}', "");
    Expect(1, 73679, '\P{^Numeric_Value=60/300}', "");
    Expect(0, 73680, '\p{Numeric_Value=60/300}', "");
    Expect(1, 73680, '\p{^Numeric_Value=60/300}', "");
    Expect(1, 73680, '\P{Numeric_Value=60/300}', "");
    Expect(0, 73680, '\P{^Numeric_Value=60/300}', "");
    Expect(1, 73679, '\p{Numeric_Value: 2.0e-01}', "");
    Expect(0, 73679, '\p{^Numeric_Value: 2.0e-01}', "");
    Expect(0, 73679, '\P{Numeric_Value: 2.0e-01}', "");
    Expect(1, 73679, '\P{^Numeric_Value: 2.0e-01}', "");
    Expect(0, 73680, '\p{Numeric_Value: 2.0e-01}', "");
    Expect(1, 73680, '\p{^Numeric_Value: 2.0e-01}', "");
    Expect(1, 73680, '\P{Numeric_Value: 2.0e-01}', "");
    Expect(0, 73680, '\P{^Numeric_Value: 2.0e-01}', "");
    Expect(1, 73679, '\p{Numeric_Value=0.2}', "");
    Expect(0, 73679, '\p{^Numeric_Value=0.2}', "");
    Expect(0, 73679, '\P{Numeric_Value=0.2}', "");
    Expect(1, 73679, '\P{^Numeric_Value=0.2}', "");
    Expect(0, 73680, '\p{Numeric_Value=0.2}', "");
    Expect(1, 73680, '\p{^Numeric_Value=0.2}', "");
    Expect(1, 73680, '\P{Numeric_Value=0.2}', "");
    Expect(0, 73680, '\P{^Numeric_Value=0.2}', "");
    Expect(1, 73679, '\p{Numeric_Value:   2.00e-01}', "");
    Expect(0, 73679, '\p{^Numeric_Value:   2.00e-01}', "");
    Expect(0, 73679, '\P{Numeric_Value:   2.00e-01}', "");
    Expect(1, 73679, '\P{^Numeric_Value:   2.00e-01}', "");
    Expect(0, 73680, '\p{Numeric_Value:   2.00e-01}', "");
    Expect(1, 73680, '\p{^Numeric_Value:   2.00e-01}', "");
    Expect(1, 73680, '\P{Numeric_Value:   2.00e-01}', "");
    Expect(0, 73680, '\P{^Numeric_Value:   2.00e-01}', "");
    Expect(1, 73679, '\p{Numeric_Value=0.20}', "");
    Expect(0, 73679, '\p{^Numeric_Value=0.20}', "");
    Expect(0, 73679, '\P{Numeric_Value=0.20}', "");
    Expect(1, 73679, '\P{^Numeric_Value=0.20}', "");
    Expect(0, 73680, '\p{Numeric_Value=0.20}', "");
    Expect(1, 73680, '\p{^Numeric_Value=0.20}', "");
    Expect(1, 73680, '\P{Numeric_Value=0.20}', "");
    Expect(0, 73680, '\P{^Numeric_Value=0.20}', "");
    Error('\p{Nv=- 1/05/a/}');
    Error('\P{Nv=- 1/05/a/}');
    Expect(1, 73679, '\p{Nv=:\A1/5\z:}', "");;
    Expect(0, 73680, '\p{Nv=:\A1/5\z:}', "");;
    Expect(1, 73679, '\p{Nv=0001/5}', "");
    Expect(0, 73679, '\p{^Nv=0001/5}', "");
    Expect(0, 73679, '\P{Nv=0001/5}', "");
    Expect(1, 73679, '\P{^Nv=0001/5}', "");
    Expect(0, 73680, '\p{Nv=0001/5}', "");
    Expect(1, 73680, '\p{^Nv=0001/5}', "");
    Expect(1, 73680, '\P{Nv=0001/5}', "");
    Expect(0, 73680, '\P{^Nv=0001/5}', "");
    Expect(1, 73679, '\p{Nv=60/300}', "");
    Expect(0, 73679, '\p{^Nv=60/300}', "");
    Expect(0, 73679, '\P{Nv=60/300}', "");
    Expect(1, 73679, '\P{^Nv=60/300}', "");
    Expect(0, 73680, '\p{Nv=60/300}', "");
    Expect(1, 73680, '\p{^Nv=60/300}', "");
    Expect(1, 73680, '\P{Nv=60/300}', "");
    Expect(0, 73680, '\P{^Nv=60/300}', "");
    Expect(1, 73679, '\p{Nv:	2.0e-01}', "");
    Expect(0, 73679, '\p{^Nv:	2.0e-01}', "");
    Expect(0, 73679, '\P{Nv:	2.0e-01}', "");
    Expect(1, 73679, '\P{^Nv:	2.0e-01}', "");
    Expect(0, 73680, '\p{Nv:	2.0e-01}', "");
    Expect(1, 73680, '\p{^Nv:	2.0e-01}', "");
    Expect(1, 73680, '\P{Nv:	2.0e-01}', "");
    Expect(0, 73680, '\P{^Nv:	2.0e-01}', "");
    Expect(1, 73679, '\p{Nv=0.2}', "");
    Expect(0, 73679, '\p{^Nv=0.2}', "");
    Expect(0, 73679, '\P{Nv=0.2}', "");
    Expect(1, 73679, '\P{^Nv=0.2}', "");
    Expect(0, 73680, '\p{Nv=0.2}', "");
    Expect(1, 73680, '\p{^Nv=0.2}', "");
    Expect(1, 73680, '\P{Nv=0.2}', "");
    Expect(0, 73680, '\P{^Nv=0.2}', "");
    Expect(1, 73679, '\p{Nv=2.00e-01}', "");
    Expect(0, 73679, '\p{^Nv=2.00e-01}', "");
    Expect(0, 73679, '\P{Nv=2.00e-01}', "");
    Expect(1, 73679, '\P{^Nv=2.00e-01}', "");
    Expect(0, 73680, '\p{Nv=2.00e-01}', "");
    Expect(1, 73680, '\p{^Nv=2.00e-01}', "");
    Expect(1, 73680, '\P{Nv=2.00e-01}', "");
    Expect(0, 73680, '\P{^Nv=2.00e-01}', "");
    Expect(1, 73679, '\p{Nv=0.20}', "");
    Expect(0, 73679, '\p{^Nv=0.20}', "");
    Expect(0, 73679, '\P{Nv=0.20}', "");
    Expect(1, 73679, '\P{^Nv=0.20}', "");
    Expect(0, 73680, '\p{Nv=0.20}', "");
    Expect(1, 73680, '\p{^Nv=0.20}', "");
    Expect(1, 73680, '\P{Nv=0.20}', "");
    Expect(0, 73680, '\P{^Nv=0.20}', "");
    Error('\p{Is_Numeric_Value=  +001/000000005:=}');
    Error('\P{Is_Numeric_Value=  +001/000000005:=}');
    Expect(1, 73679, '\p{Is_Numeric_Value=0000000001/000005}', "");
    Expect(0, 73679, '\p{^Is_Numeric_Value=0000000001/000005}', "");
    Expect(0, 73679, '\P{Is_Numeric_Value=0000000001/000005}', "");
    Expect(1, 73679, '\P{^Is_Numeric_Value=0000000001/000005}', "");
    Expect(0, 73680, '\p{Is_Numeric_Value=0000000001/000005}', "");
    Expect(1, 73680, '\p{^Is_Numeric_Value=0000000001/000005}', "");
    Expect(1, 73680, '\P{Is_Numeric_Value=0000000001/000005}', "");
    Expect(0, 73680, '\P{^Is_Numeric_Value=0000000001/000005}', "");
    Expect(1, 73679, '\p{Is_Numeric_Value=60/300}', "");
    Expect(0, 73679, '\p{^Is_Numeric_Value=60/300}', "");
    Expect(0, 73679, '\P{Is_Numeric_Value=60/300}', "");
    Expect(1, 73679, '\P{^Is_Numeric_Value=60/300}', "");
    Expect(0, 73680, '\p{Is_Numeric_Value=60/300}', "");
    Expect(1, 73680, '\p{^Is_Numeric_Value=60/300}', "");
    Expect(1, 73680, '\P{Is_Numeric_Value=60/300}', "");
    Expect(0, 73680, '\P{^Is_Numeric_Value=60/300}', "");
    Expect(1, 73679, '\p{Is_Numeric_Value=2.0e-01}', "");
    Expect(0, 73679, '\p{^Is_Numeric_Value=2.0e-01}', "");
    Expect(0, 73679, '\P{Is_Numeric_Value=2.0e-01}', "");
    Expect(1, 73679, '\P{^Is_Numeric_Value=2.0e-01}', "");
    Expect(0, 73680, '\p{Is_Numeric_Value=2.0e-01}', "");
    Expect(1, 73680, '\p{^Is_Numeric_Value=2.0e-01}', "");
    Expect(1, 73680, '\P{Is_Numeric_Value=2.0e-01}', "");
    Expect(0, 73680, '\P{^Is_Numeric_Value=2.0e-01}', "");
    Expect(1, 73679, '\p{Is_Numeric_Value=0.2}', "");
    Expect(0, 73679, '\p{^Is_Numeric_Value=0.2}', "");
    Expect(0, 73679, '\P{Is_Numeric_Value=0.2}', "");
    Expect(1, 73679, '\P{^Is_Numeric_Value=0.2}', "");
    Expect(0, 73680, '\p{Is_Numeric_Value=0.2}', "");
    Expect(1, 73680, '\p{^Is_Numeric_Value=0.2}', "");
    Expect(1, 73680, '\P{Is_Numeric_Value=0.2}', "");
    Expect(0, 73680, '\P{^Is_Numeric_Value=0.2}', "");
    Expect(1, 73679, '\p{Is_Numeric_Value=2.00e-01}', "");
    Expect(0, 73679, '\p{^Is_Numeric_Value=2.00e-01}', "");
    Expect(0, 73679, '\P{Is_Numeric_Value=2.00e-01}', "");
    Expect(1, 73679, '\P{^Is_Numeric_Value=2.00e-01}', "");
    Expect(0, 73680, '\p{Is_Numeric_Value=2.00e-01}', "");
    Expect(1, 73680, '\p{^Is_Numeric_Value=2.00e-01}', "");
    Expect(1, 73680, '\P{Is_Numeric_Value=2.00e-01}', "");
    Expect(0, 73680, '\P{^Is_Numeric_Value=2.00e-01}', "");
    Expect(1, 73679, '\p{Is_Numeric_Value=0.20}', "");
    Expect(0, 73679, '\p{^Is_Numeric_Value=0.20}', "");
    Expect(0, 73679, '\P{Is_Numeric_Value=0.20}', "");
    Expect(1, 73679, '\P{^Is_Numeric_Value=0.20}', "");
    Expect(0, 73680, '\p{Is_Numeric_Value=0.20}', "");
    Expect(1, 73680, '\p{^Is_Numeric_Value=0.20}', "");
    Expect(1, 73680, '\P{Is_Numeric_Value=0.20}', "");
    Expect(0, 73680, '\P{^Is_Numeric_Value=0.20}', "");
    Error('\p{Is_Nv=_:=001/05}');
    Error('\P{Is_Nv=_:=001/05}');
    Expect(1, 73679, '\p{Is_Nv=0000001/5}', "");
    Expect(0, 73679, '\p{^Is_Nv=0000001/5}', "");
    Expect(0, 73679, '\P{Is_Nv=0000001/5}', "");
    Expect(1, 73679, '\P{^Is_Nv=0000001/5}', "");
    Expect(0, 73680, '\p{Is_Nv=0000001/5}', "");
    Expect(1, 73680, '\p{^Is_Nv=0000001/5}', "");
    Expect(1, 73680, '\P{Is_Nv=0000001/5}', "");
    Expect(0, 73680, '\P{^Is_Nv=0000001/5}', "");
    Expect(1, 73679, '\p{Is_Nv=60/300}', "");
    Expect(0, 73679, '\p{^Is_Nv=60/300}', "");
    Expect(0, 73679, '\P{Is_Nv=60/300}', "");
    Expect(1, 73679, '\P{^Is_Nv=60/300}', "");
    Expect(0, 73680, '\p{Is_Nv=60/300}', "");
    Expect(1, 73680, '\p{^Is_Nv=60/300}', "");
    Expect(1, 73680, '\P{Is_Nv=60/300}', "");
    Expect(0, 73680, '\P{^Is_Nv=60/300}', "");
    Expect(1, 73679, '\p{Is_Nv=2.0e-01}', "");
    Expect(0, 73679, '\p{^Is_Nv=2.0e-01}', "");
    Expect(0, 73679, '\P{Is_Nv=2.0e-01}', "");
    Expect(1, 73679, '\P{^Is_Nv=2.0e-01}', "");
    Expect(0, 73680, '\p{Is_Nv=2.0e-01}', "");
    Expect(1, 73680, '\p{^Is_Nv=2.0e-01}', "");
    Expect(1, 73680, '\P{Is_Nv=2.0e-01}', "");
    Expect(0, 73680, '\P{^Is_Nv=2.0e-01}', "");
    Expect(1, 73679, '\p{Is_Nv=0.2}', "");
    Expect(0, 73679, '\p{^Is_Nv=0.2}', "");
    Expect(0, 73679, '\P{Is_Nv=0.2}', "");
    Expect(1, 73679, '\P{^Is_Nv=0.2}', "");
    Expect(0, 73680, '\p{Is_Nv=0.2}', "");
    Expect(1, 73680, '\p{^Is_Nv=0.2}', "");
    Expect(1, 73680, '\P{Is_Nv=0.2}', "");
    Expect(0, 73680, '\P{^Is_Nv=0.2}', "");
    Expect(1, 73679, '\p{Is_Nv=2.00e-01}', "");
    Expect(0, 73679, '\p{^Is_Nv=2.00e-01}', "");
    Expect(0, 73679, '\P{Is_Nv=2.00e-01}', "");
    Expect(1, 73679, '\P{^Is_Nv=2.00e-01}', "");
    Expect(0, 73680, '\p{Is_Nv=2.00e-01}', "");
    Expect(1, 73680, '\p{^Is_Nv=2.00e-01}', "");
    Expect(1, 73680, '\P{Is_Nv=2.00e-01}', "");
    Expect(0, 73680, '\P{^Is_Nv=2.00e-01}', "");
    Expect(1, 73679, '\p{Is_Nv=0.20}', "");
    Expect(0, 73679, '\p{^Is_Nv=0.20}', "");
    Expect(0, 73679, '\P{Is_Nv=0.20}', "");
    Expect(1, 73679, '\P{^Is_Nv=0.20}', "");
    Expect(0, 73680, '\p{Is_Nv=0.20}', "");
    Expect(1, 73680, '\p{^Is_Nv=0.20}', "");
    Expect(1, 73680, '\P{Is_Nv=0.20}', "");
    Expect(0, 73680, '\P{^Is_Nv=0.20}', "");
    Error('\p{Numeric_Value= _+000001/00006:=}');
    Error('\P{Numeric_Value= _+000001/00006:=}');
    Expect(1, 126269, '\p{Numeric_Value=:\A1/6\z:}', "");;
    Expect(0, 126270, '\p{Numeric_Value=:\A1/6\z:}', "");;
    Expect(1, 126269, '\p{Numeric_Value=000000001/00000006}', "");
    Expect(0, 126269, '\p{^Numeric_Value=000000001/00000006}', "");
    Expect(0, 126269, '\P{Numeric_Value=000000001/00000006}', "");
    Expect(1, 126269, '\P{^Numeric_Value=000000001/00000006}', "");
    Expect(0, 126270, '\p{Numeric_Value=000000001/00000006}', "");
    Expect(1, 126270, '\p{^Numeric_Value=000000001/00000006}', "");
    Expect(1, 126270, '\P{Numeric_Value=000000001/00000006}', "");
    Expect(0, 126270, '\P{^Numeric_Value=000000001/00000006}', "");
    Expect(1, 126269, '\p{Numeric_Value=60/360}', "");
    Expect(0, 126269, '\p{^Numeric_Value=60/360}', "");
    Expect(0, 126269, '\P{Numeric_Value=60/360}', "");
    Expect(1, 126269, '\P{^Numeric_Value=60/360}', "");
    Expect(0, 126270, '\p{Numeric_Value=60/360}', "");
    Expect(1, 126270, '\p{^Numeric_Value=60/360}', "");
    Expect(1, 126270, '\P{Numeric_Value=60/360}', "");
    Expect(0, 126270, '\P{^Numeric_Value=60/360}', "");
    Error('\p{Numeric_Value=1.7e-01}');
    Error('\P{Numeric_Value=1.7e-01}');
    Expect(1, 126269, '\p{Numeric_Value=1.67e-01}', "");
    Expect(0, 126269, '\p{^Numeric_Value=1.67e-01}', "");
    Expect(0, 126269, '\P{Numeric_Value=1.67e-01}', "");
    Expect(1, 126269, '\P{^Numeric_Value=1.67e-01}', "");
    Expect(0, 126270, '\p{Numeric_Value=1.67e-01}', "");
    Expect(1, 126270, '\p{^Numeric_Value=1.67e-01}', "");
    Expect(1, 126270, '\P{Numeric_Value=1.67e-01}', "");
    Expect(0, 126270, '\P{^Numeric_Value=1.67e-01}', "");
    Error('\p{Numeric_Value=0.17}');
    Error('\P{Numeric_Value=0.17}');
    Expect(1, 126269, '\p{Numeric_Value=1.667e-01}', "");
    Expect(0, 126269, '\p{^Numeric_Value=1.667e-01}', "");
    Expect(0, 126269, '\P{Numeric_Value=1.667e-01}', "");
    Expect(1, 126269, '\P{^Numeric_Value=1.667e-01}', "");
    Expect(0, 126270, '\p{Numeric_Value=1.667e-01}', "");
    Expect(1, 126270, '\p{^Numeric_Value=1.667e-01}', "");
    Expect(1, 126270, '\P{Numeric_Value=1.667e-01}', "");
    Expect(0, 126270, '\P{^Numeric_Value=1.667e-01}', "");
    Expect(1, 126269, '\p{Numeric_Value: 0.167}', "");
    Expect(0, 126269, '\p{^Numeric_Value: 0.167}', "");
    Expect(0, 126269, '\P{Numeric_Value: 0.167}', "");
    Expect(1, 126269, '\P{^Numeric_Value: 0.167}', "");
    Expect(0, 126270, '\p{Numeric_Value: 0.167}', "");
    Expect(1, 126270, '\p{^Numeric_Value: 0.167}', "");
    Expect(1, 126270, '\P{Numeric_Value: 0.167}', "");
    Expect(0, 126270, '\P{^Numeric_Value: 0.167}', "");
    Expect(1, 126269, '\p{Numeric_Value:   1.6667e-01}', "");
    Expect(0, 126269, '\p{^Numeric_Value:   1.6667e-01}', "");
    Expect(0, 126269, '\P{Numeric_Value:   1.6667e-01}', "");
    Expect(1, 126269, '\P{^Numeric_Value:   1.6667e-01}', "");
    Expect(0, 126270, '\p{Numeric_Value:   1.6667e-01}', "");
    Expect(1, 126270, '\p{^Numeric_Value:   1.6667e-01}', "");
    Expect(1, 126270, '\P{Numeric_Value:   1.6667e-01}', "");
    Expect(0, 126270, '\P{^Numeric_Value:   1.6667e-01}', "");
    Expect(1, 126269, '\p{Numeric_Value=0.1667}', "");
    Expect(0, 126269, '\p{^Numeric_Value=0.1667}', "");
    Expect(0, 126269, '\P{Numeric_Value=0.1667}', "");
    Expect(1, 126269, '\P{^Numeric_Value=0.1667}', "");
    Expect(0, 126270, '\p{Numeric_Value=0.1667}', "");
    Expect(1, 126270, '\p{^Numeric_Value=0.1667}', "");
    Expect(1, 126270, '\P{Numeric_Value=0.1667}', "");
    Expect(0, 126270, '\P{^Numeric_Value=0.1667}', "");
    Error('\p{Nv=/a/01/6}');
    Error('\P{Nv=/a/01/6}');
    Expect(1, 126269, '\p{Nv=:\A1/6\z:}', "");;
    Expect(0, 126270, '\p{Nv=:\A1/6\z:}', "");;
    Expect(1, 126269, '\p{Nv=000000001/06}', "");
    Expect(0, 126269, '\p{^Nv=000000001/06}', "");
    Expect(0, 126269, '\P{Nv=000000001/06}', "");
    Expect(1, 126269, '\P{^Nv=000000001/06}', "");
    Expect(0, 126270, '\p{Nv=000000001/06}', "");
    Expect(1, 126270, '\p{^Nv=000000001/06}', "");
    Expect(1, 126270, '\P{Nv=000000001/06}', "");
    Expect(0, 126270, '\P{^Nv=000000001/06}', "");
    Expect(1, 126269, '\p{Nv=60/360}', "");
    Expect(0, 126269, '\p{^Nv=60/360}', "");
    Expect(0, 126269, '\P{Nv=60/360}', "");
    Expect(1, 126269, '\P{^Nv=60/360}', "");
    Expect(0, 126270, '\p{Nv=60/360}', "");
    Expect(1, 126270, '\p{^Nv=60/360}', "");
    Expect(1, 126270, '\P{Nv=60/360}', "");
    Expect(0, 126270, '\P{^Nv=60/360}', "");
    Error('\p{Nv=1.7e-01}');
    Error('\P{Nv=1.7e-01}');
    Expect(1, 126269, '\p{Nv=1.67e-01}', "");
    Expect(0, 126269, '\p{^Nv=1.67e-01}', "");
    Expect(0, 126269, '\P{Nv=1.67e-01}', "");
    Expect(1, 126269, '\P{^Nv=1.67e-01}', "");
    Expect(0, 126270, '\p{Nv=1.67e-01}', "");
    Expect(1, 126270, '\p{^Nv=1.67e-01}', "");
    Expect(1, 126270, '\P{Nv=1.67e-01}', "");
    Expect(0, 126270, '\P{^Nv=1.67e-01}', "");
    Error('\p{Nv=0.17}');
    Error('\P{Nv=0.17}');
    Expect(1, 126269, '\p{Nv=1.667e-01}', "");
    Expect(0, 126269, '\p{^Nv=1.667e-01}', "");
    Expect(0, 126269, '\P{Nv=1.667e-01}', "");
    Expect(1, 126269, '\P{^Nv=1.667e-01}', "");
    Expect(0, 126270, '\p{Nv=1.667e-01}', "");
    Expect(1, 126270, '\p{^Nv=1.667e-01}', "");
    Expect(1, 126270, '\P{Nv=1.667e-01}', "");
    Expect(0, 126270, '\P{^Nv=1.667e-01}', "");
    Expect(1, 126269, '\p{Nv=0.167}', "");
    Expect(0, 126269, '\p{^Nv=0.167}', "");
    Expect(0, 126269, '\P{Nv=0.167}', "");
    Expect(1, 126269, '\P{^Nv=0.167}', "");
    Expect(0, 126270, '\p{Nv=0.167}', "");
    Expect(1, 126270, '\p{^Nv=0.167}', "");
    Expect(1, 126270, '\P{Nv=0.167}', "");
    Expect(0, 126270, '\P{^Nv=0.167}', "");
    Expect(1, 126269, '\p{Nv=1.6667e-01}', "");
    Expect(0, 126269, '\p{^Nv=1.6667e-01}', "");
    Expect(0, 126269, '\P{Nv=1.6667e-01}', "");
    Expect(1, 126269, '\P{^Nv=1.6667e-01}', "");
    Expect(0, 126270, '\p{Nv=1.6667e-01}', "");
    Expect(1, 126270, '\p{^Nv=1.6667e-01}', "");
    Expect(1, 126270, '\P{Nv=1.6667e-01}', "");
    Expect(0, 126270, '\P{^Nv=1.6667e-01}', "");
    Expect(1, 126269, '\p{Nv=0.1667}', "");
    Expect(0, 126269, '\p{^Nv=0.1667}', "");
    Expect(0, 126269, '\P{Nv=0.1667}', "");
    Expect(1, 126269, '\P{^Nv=0.1667}', "");
    Expect(0, 126270, '\p{Nv=0.1667}', "");
    Expect(1, 126270, '\p{^Nv=0.1667}', "");
    Expect(1, 126270, '\P{Nv=0.1667}', "");
    Expect(0, 126270, '\P{^Nv=0.1667}', "");
    Error('\p{Is_Numeric_Value:   001/0000000006:=}');
    Error('\P{Is_Numeric_Value:   001/0000000006:=}');
    Expect(1, 126269, '\p{Is_Numeric_Value=001/000000006}', "");
    Expect(0, 126269, '\p{^Is_Numeric_Value=001/000000006}', "");
    Expect(0, 126269, '\P{Is_Numeric_Value=001/000000006}', "");
    Expect(1, 126269, '\P{^Is_Numeric_Value=001/000000006}', "");
    Expect(0, 126270, '\p{Is_Numeric_Value=001/000000006}', "");
    Expect(1, 126270, '\p{^Is_Numeric_Value=001/000000006}', "");
    Expect(1, 126270, '\P{Is_Numeric_Value=001/000000006}', "");
    Expect(0, 126270, '\P{^Is_Numeric_Value=001/000000006}', "");
    Expect(1, 126269, '\p{Is_Numeric_Value=60/360}', "");
    Expect(0, 126269, '\p{^Is_Numeric_Value=60/360}', "");
    Expect(0, 126269, '\P{Is_Numeric_Value=60/360}', "");
    Expect(1, 126269, '\P{^Is_Numeric_Value=60/360}', "");
    Expect(0, 126270, '\p{Is_Numeric_Value=60/360}', "");
    Expect(1, 126270, '\p{^Is_Numeric_Value=60/360}', "");
    Expect(1, 126270, '\P{Is_Numeric_Value=60/360}', "");
    Expect(0, 126270, '\P{^Is_Numeric_Value=60/360}', "");
    Error('\p{Is_Numeric_Value:   1.7e-01}');
    Error('\P{Is_Numeric_Value:   1.7e-01}');
    Expect(1, 126269, '\p{Is_Numeric_Value=1.67e-01}', "");
    Expect(0, 126269, '\p{^Is_Numeric_Value=1.67e-01}', "");
    Expect(0, 126269, '\P{Is_Numeric_Value=1.67e-01}', "");
    Expect(1, 126269, '\P{^Is_Numeric_Value=1.67e-01}', "");
    Expect(0, 126270, '\p{Is_Numeric_Value=1.67e-01}', "");
    Expect(1, 126270, '\p{^Is_Numeric_Value=1.67e-01}', "");
    Expect(1, 126270, '\P{Is_Numeric_Value=1.67e-01}', "");
    Expect(0, 126270, '\P{^Is_Numeric_Value=1.67e-01}', "");
    Error('\p{Is_Numeric_Value=0.17}');
    Error('\P{Is_Numeric_Value=0.17}');
    Expect(1, 126269, '\p{Is_Numeric_Value=1.667e-01}', "");
    Expect(0, 126269, '\p{^Is_Numeric_Value=1.667e-01}', "");
    Expect(0, 126269, '\P{Is_Numeric_Value=1.667e-01}', "");
    Expect(1, 126269, '\P{^Is_Numeric_Value=1.667e-01}', "");
    Expect(0, 126270, '\p{Is_Numeric_Value=1.667e-01}', "");
    Expect(1, 126270, '\p{^Is_Numeric_Value=1.667e-01}', "");
    Expect(1, 126270, '\P{Is_Numeric_Value=1.667e-01}', "");
    Expect(0, 126270, '\P{^Is_Numeric_Value=1.667e-01}', "");
    Expect(1, 126269, '\p{Is_Numeric_Value=0.167}', "");
    Expect(0, 126269, '\p{^Is_Numeric_Value=0.167}', "");
    Expect(0, 126269, '\P{Is_Numeric_Value=0.167}', "");
    Expect(1, 126269, '\P{^Is_Numeric_Value=0.167}', "");
    Expect(0, 126270, '\p{Is_Numeric_Value=0.167}', "");
    Expect(1, 126270, '\p{^Is_Numeric_Value=0.167}', "");
    Expect(1, 126270, '\P{Is_Numeric_Value=0.167}', "");
    Expect(0, 126270, '\P{^Is_Numeric_Value=0.167}', "");
    Expect(1, 126269, '\p{Is_Numeric_Value=1.6667e-01}', "");
    Expect(0, 126269, '\p{^Is_Numeric_Value=1.6667e-01}', "");
    Expect(0, 126269, '\P{Is_Numeric_Value=1.6667e-01}', "");
    Expect(1, 126269, '\P{^Is_Numeric_Value=1.6667e-01}', "");
    Expect(0, 126270, '\p{Is_Numeric_Value=1.6667e-01}', "");
    Expect(1, 126270, '\p{^Is_Numeric_Value=1.6667e-01}', "");
    Expect(1, 126270, '\P{Is_Numeric_Value=1.6667e-01}', "");
    Expect(0, 126270, '\P{^Is_Numeric_Value=1.6667e-01}', "");
    Expect(1, 126269, '\p{Is_Numeric_Value=0.1667}', "");
    Expect(0, 126269, '\p{^Is_Numeric_Value=0.1667}', "");
    Expect(0, 126269, '\P{Is_Numeric_Value=0.1667}', "");
    Expect(1, 126269, '\P{^Is_Numeric_Value=0.1667}', "");
    Expect(0, 126270, '\p{Is_Numeric_Value=0.1667}', "");
    Expect(1, 126270, '\p{^Is_Numeric_Value=0.1667}', "");
    Expect(1, 126270, '\P{Is_Numeric_Value=0.1667}', "");
    Expect(0, 126270, '\P{^Is_Numeric_Value=0.1667}', "");
    Error('\p{Is_Nv=/a/_-01/000006}');
    Error('\P{Is_Nv=/a/_-01/000006}');
    Expect(1, 126269, '\p{Is_Nv=+000000001/0006}', "");
    Expect(0, 126269, '\p{^Is_Nv=+000000001/0006}', "");
    Expect(0, 126269, '\P{Is_Nv=+000000001/0006}', "");
    Expect(1, 126269, '\P{^Is_Nv=+000000001/0006}', "");
    Expect(0, 126270, '\p{Is_Nv=+000000001/0006}', "");
    Expect(1, 126270, '\p{^Is_Nv=+000000001/0006}', "");
    Expect(1, 126270, '\P{Is_Nv=+000000001/0006}', "");
    Expect(0, 126270, '\P{^Is_Nv=+000000001/0006}', "");
    Expect(1, 126269, '\p{Is_Nv=60/360}', "");
    Expect(0, 126269, '\p{^Is_Nv=60/360}', "");
    Expect(0, 126269, '\P{Is_Nv=60/360}', "");
    Expect(1, 126269, '\P{^Is_Nv=60/360}', "");
    Expect(0, 126270, '\p{Is_Nv=60/360}', "");
    Expect(1, 126270, '\p{^Is_Nv=60/360}', "");
    Expect(1, 126270, '\P{Is_Nv=60/360}', "");
    Expect(0, 126270, '\P{^Is_Nv=60/360}', "");
    Error('\p{Is_Nv=1.7e-01}');
    Error('\P{Is_Nv=1.7e-01}');
    Expect(1, 126269, '\p{Is_Nv:1.67e-01}', "");
    Expect(0, 126269, '\p{^Is_Nv:1.67e-01}', "");
    Expect(0, 126269, '\P{Is_Nv:1.67e-01}', "");
    Expect(1, 126269, '\P{^Is_Nv:1.67e-01}', "");
    Expect(0, 126270, '\p{Is_Nv:1.67e-01}', "");
    Expect(1, 126270, '\p{^Is_Nv:1.67e-01}', "");
    Expect(1, 126270, '\P{Is_Nv:1.67e-01}', "");
    Expect(0, 126270, '\P{^Is_Nv:1.67e-01}', "");
    Error('\p{Is_Nv=0.17}');
    Error('\P{Is_Nv=0.17}');
    Expect(1, 126269, '\p{Is_Nv=1.667e-01}', "");
    Expect(0, 126269, '\p{^Is_Nv=1.667e-01}', "");
    Expect(0, 126269, '\P{Is_Nv=1.667e-01}', "");
    Expect(1, 126269, '\P{^Is_Nv=1.667e-01}', "");
    Expect(0, 126270, '\p{Is_Nv=1.667e-01}', "");
    Expect(1, 126270, '\p{^Is_Nv=1.667e-01}', "");
    Expect(1, 126270, '\P{Is_Nv=1.667e-01}', "");
    Expect(0, 126270, '\P{^Is_Nv=1.667e-01}', "");
    Expect(1, 126269, '\p{Is_Nv:	0.167}', "");
    Expect(0, 126269, '\p{^Is_Nv:	0.167}', "");
    Expect(0, 126269, '\P{Is_Nv:	0.167}', "");
    Expect(1, 126269, '\P{^Is_Nv:	0.167}', "");
    Expect(0, 126270, '\p{Is_Nv:	0.167}', "");
    Expect(1, 126270, '\p{^Is_Nv:	0.167}', "");
    Expect(1, 126270, '\P{Is_Nv:	0.167}', "");
    Expect(0, 126270, '\P{^Is_Nv:	0.167}', "");
    Expect(1, 126269, '\p{Is_Nv=1.6667e-01}', "");
    Expect(0, 126269, '\p{^Is_Nv=1.6667e-01}', "");
    Expect(0, 126269, '\P{Is_Nv=1.6667e-01}', "");
    Expect(1, 126269, '\P{^Is_Nv=1.6667e-01}', "");
    Expect(0, 126270, '\p{Is_Nv=1.6667e-01}', "");
    Expect(1, 126270, '\p{^Is_Nv=1.6667e-01}', "");
    Expect(1, 126270, '\P{Is_Nv=1.6667e-01}', "");
    Expect(0, 126270, '\P{^Is_Nv=1.6667e-01}', "");
    Expect(1, 126269, '\p{Is_Nv=0.1667}', "");
    Expect(0, 126269, '\p{^Is_Nv=0.1667}', "");
    Expect(0, 126269, '\P{Is_Nv=0.1667}', "");
    Expect(1, 126269, '\P{^Is_Nv=0.1667}', "");
    Expect(0, 126270, '\p{Is_Nv=0.1667}', "");
    Expect(1, 126270, '\p{^Is_Nv=0.1667}', "");
    Expect(1, 126270, '\P{Is_Nv=0.1667}', "");
    Expect(0, 126270, '\P{^Is_Nv=0.1667}', "");
    Error('\p{Numeric_Value=:= +00001/0000000064}');
    Error('\P{Numeric_Value=:= +00001/0000000064}');
    Expect(1, 73667, '\p{Numeric_Value=:\A1/64\z:}', "");;
    Expect(0, 73668, '\p{Numeric_Value=:\A1/64\z:}', "");;
    Expect(1, 73667, '\p{Numeric_Value=+0000000001/00064}', "");
    Expect(0, 73667, '\p{^Numeric_Value=+0000000001/00064}', "");
    Expect(0, 73667, '\P{Numeric_Value=+0000000001/00064}', "");
    Expect(1, 73667, '\P{^Numeric_Value=+0000000001/00064}', "");
    Expect(0, 73668, '\p{Numeric_Value=+0000000001/00064}', "");
    Expect(1, 73668, '\p{^Numeric_Value=+0000000001/00064}', "");
    Expect(1, 73668, '\P{Numeric_Value=+0000000001/00064}', "");
    Expect(0, 73668, '\P{^Numeric_Value=+0000000001/00064}', "");
    Expect(1, 73667, '\p{Numeric_Value=60/3840}', "");
    Expect(0, 73667, '\p{^Numeric_Value=60/3840}', "");
    Expect(0, 73667, '\P{Numeric_Value=60/3840}', "");
    Expect(1, 73667, '\P{^Numeric_Value=60/3840}', "");
    Expect(0, 73668, '\p{Numeric_Value=60/3840}', "");
    Expect(1, 73668, '\p{^Numeric_Value=60/3840}', "");
    Expect(1, 73668, '\P{Numeric_Value=60/3840}', "");
    Expect(0, 73668, '\P{^Numeric_Value=60/3840}', "");
    Error('\p{Numeric_Value=1.6e-02}');
    Error('\P{Numeric_Value=1.6e-02}');
    Expect(1, 73667, '\p{Numeric_Value=1.56e-02}', "");
    Expect(0, 73667, '\p{^Numeric_Value=1.56e-02}', "");
    Expect(0, 73667, '\P{Numeric_Value=1.56e-02}', "");
    Expect(1, 73667, '\P{^Numeric_Value=1.56e-02}', "");
    Expect(0, 73668, '\p{Numeric_Value=1.56e-02}', "");
    Expect(1, 73668, '\p{^Numeric_Value=1.56e-02}', "");
    Expect(1, 73668, '\P{Numeric_Value=1.56e-02}', "");
    Expect(0, 73668, '\P{^Numeric_Value=1.56e-02}', "");
    Error('\p{Numeric_Value=0.02}');
    Error('\P{Numeric_Value=0.02}');
    Expect(1, 73667, '\p{Numeric_Value:	1.562e-02}', "");
    Expect(0, 73667, '\p{^Numeric_Value:	1.562e-02}', "");
    Expect(0, 73667, '\P{Numeric_Value:	1.562e-02}', "");
    Expect(1, 73667, '\P{^Numeric_Value:	1.562e-02}', "");
    Expect(0, 73668, '\p{Numeric_Value:	1.562e-02}', "");
    Expect(1, 73668, '\p{^Numeric_Value:	1.562e-02}', "");
    Expect(1, 73668, '\P{Numeric_Value:	1.562e-02}', "");
    Expect(0, 73668, '\P{^Numeric_Value:	1.562e-02}', "");
    Error('\p{Numeric_Value=0.016}');
    Error('\P{Numeric_Value=0.016}');
    Expect(1, 73667, '\p{Numeric_Value=1.5625e-02}', "");
    Expect(0, 73667, '\p{^Numeric_Value=1.5625e-02}', "");
    Expect(0, 73667, '\P{Numeric_Value=1.5625e-02}', "");
    Expect(1, 73667, '\P{^Numeric_Value=1.5625e-02}', "");
    Expect(0, 73668, '\p{Numeric_Value=1.5625e-02}', "");
    Expect(1, 73668, '\p{^Numeric_Value=1.5625e-02}', "");
    Expect(1, 73668, '\P{Numeric_Value=1.5625e-02}', "");
    Expect(0, 73668, '\P{^Numeric_Value=1.5625e-02}', "");
    Expect(1, 73667, '\p{Numeric_Value=0.0156}', "");
    Expect(0, 73667, '\p{^Numeric_Value=0.0156}', "");
    Expect(0, 73667, '\P{Numeric_Value=0.0156}', "");
    Expect(1, 73667, '\P{^Numeric_Value=0.0156}', "");
    Expect(0, 73668, '\p{Numeric_Value=0.0156}', "");
    Expect(1, 73668, '\p{^Numeric_Value=0.0156}', "");
    Expect(1, 73668, '\P{Numeric_Value=0.0156}', "");
    Expect(0, 73668, '\P{^Numeric_Value=0.0156}', "");
    Expect(1, 73667, '\p{Numeric_Value=1.56250e-02}', "");
    Expect(0, 73667, '\p{^Numeric_Value=1.56250e-02}', "");
    Expect(0, 73667, '\P{Numeric_Value=1.56250e-02}', "");
    Expect(1, 73667, '\P{^Numeric_Value=1.56250e-02}', "");
    Expect(0, 73668, '\p{Numeric_Value=1.56250e-02}', "");
    Expect(1, 73668, '\p{^Numeric_Value=1.56250e-02}', "");
    Expect(1, 73668, '\P{Numeric_Value=1.56250e-02}', "");
    Expect(0, 73668, '\P{^Numeric_Value=1.56250e-02}', "");
    Expect(1, 73667, '\p{Numeric_Value=0.01562}', "");
    Expect(0, 73667, '\p{^Numeric_Value=0.01562}', "");
    Expect(0, 73667, '\P{Numeric_Value=0.01562}', "");
    Expect(1, 73667, '\P{^Numeric_Value=0.01562}', "");
    Expect(0, 73668, '\p{Numeric_Value=0.01562}', "");
    Expect(1, 73668, '\p{^Numeric_Value=0.01562}', "");
    Expect(1, 73668, '\P{Numeric_Value=0.01562}', "");
    Expect(0, 73668, '\P{^Numeric_Value=0.01562}', "");
    Error('\p{Nv:   	_000000001/0000000064/a/}');
    Error('\P{Nv:   	_000000001/0000000064/a/}');
    Expect(1, 73667, '\p{Nv=:\A1/64\z:}', "");;
    Expect(0, 73668, '\p{Nv=:\A1/64\z:}', "");;
    Expect(1, 73667, '\p{Nv:   00001/0000000064}', "");
    Expect(0, 73667, '\p{^Nv:   00001/0000000064}', "");
    Expect(0, 73667, '\P{Nv:   00001/0000000064}', "");
    Expect(1, 73667, '\P{^Nv:   00001/0000000064}', "");
    Expect(0, 73668, '\p{Nv:   00001/0000000064}', "");
    Expect(1, 73668, '\p{^Nv:   00001/0000000064}', "");
    Expect(1, 73668, '\P{Nv:   00001/0000000064}', "");
    Expect(0, 73668, '\P{^Nv:   00001/0000000064}', "");
    Expect(1, 73667, '\p{Nv=60/3840}', "");
    Expect(0, 73667, '\p{^Nv=60/3840}', "");
    Expect(0, 73667, '\P{Nv=60/3840}', "");
    Expect(1, 73667, '\P{^Nv=60/3840}', "");
    Expect(0, 73668, '\p{Nv=60/3840}', "");
    Expect(1, 73668, '\p{^Nv=60/3840}', "");
    Expect(1, 73668, '\P{Nv=60/3840}', "");
    Expect(0, 73668, '\P{^Nv=60/3840}', "");
    Error('\p{Nv=1.6e-02}');
    Error('\P{Nv=1.6e-02}');
    Expect(1, 73667, '\p{Nv: 1.56e-02}', "");
    Expect(0, 73667, '\p{^Nv: 1.56e-02}', "");
    Expect(0, 73667, '\P{Nv: 1.56e-02}', "");
    Expect(1, 73667, '\P{^Nv: 1.56e-02}', "");
    Expect(0, 73668, '\p{Nv: 1.56e-02}', "");
    Expect(1, 73668, '\p{^Nv: 1.56e-02}', "");
    Expect(1, 73668, '\P{Nv: 1.56e-02}', "");
    Expect(0, 73668, '\P{^Nv: 1.56e-02}', "");
    Error('\p{Nv=0.02}');
    Error('\P{Nv=0.02}');
    Expect(1, 73667, '\p{Nv=1.562e-02}', "");
    Expect(0, 73667, '\p{^Nv=1.562e-02}', "");
    Expect(0, 73667, '\P{Nv=1.562e-02}', "");
    Expect(1, 73667, '\P{^Nv=1.562e-02}', "");
    Expect(0, 73668, '\p{Nv=1.562e-02}', "");
    Expect(1, 73668, '\p{^Nv=1.562e-02}', "");
    Expect(1, 73668, '\P{Nv=1.562e-02}', "");
    Expect(0, 73668, '\P{^Nv=1.562e-02}', "");
    Error('\p{Nv=0.016}');
    Error('\P{Nv=0.016}');
    Expect(1, 73667, '\p{Nv=1.5625e-02}', "");
    Expect(0, 73667, '\p{^Nv=1.5625e-02}', "");
    Expect(0, 73667, '\P{Nv=1.5625e-02}', "");
    Expect(1, 73667, '\P{^Nv=1.5625e-02}', "");
    Expect(0, 73668, '\p{Nv=1.5625e-02}', "");
    Expect(1, 73668, '\p{^Nv=1.5625e-02}', "");
    Expect(1, 73668, '\P{Nv=1.5625e-02}', "");
    Expect(0, 73668, '\P{^Nv=1.5625e-02}', "");
    Expect(1, 73667, '\p{Nv: 0.0156}', "");
    Expect(0, 73667, '\p{^Nv: 0.0156}', "");
    Expect(0, 73667, '\P{Nv: 0.0156}', "");
    Expect(1, 73667, '\P{^Nv: 0.0156}', "");
    Expect(0, 73668, '\p{Nv: 0.0156}', "");
    Expect(1, 73668, '\p{^Nv: 0.0156}', "");
    Expect(1, 73668, '\P{Nv: 0.0156}', "");
    Expect(0, 73668, '\P{^Nv: 0.0156}', "");
    Expect(1, 73667, '\p{Nv=1.56250e-02}', "");
    Expect(0, 73667, '\p{^Nv=1.56250e-02}', "");
    Expect(0, 73667, '\P{Nv=1.56250e-02}', "");
    Expect(1, 73667, '\P{^Nv=1.56250e-02}', "");
    Expect(0, 73668, '\p{Nv=1.56250e-02}', "");
    Expect(1, 73668, '\p{^Nv=1.56250e-02}', "");
    Expect(1, 73668, '\P{Nv=1.56250e-02}', "");
    Expect(0, 73668, '\P{^Nv=1.56250e-02}', "");
    Expect(1, 73667, '\p{Nv=0.01562}', "");
    Expect(0, 73667, '\p{^Nv=0.01562}', "");
    Expect(0, 73667, '\P{Nv=0.01562}', "");
    Expect(1, 73667, '\P{^Nv=0.01562}', "");
    Expect(0, 73668, '\p{Nv=0.01562}', "");
    Expect(1, 73668, '\p{^Nv=0.01562}', "");
    Expect(1, 73668, '\P{Nv=0.01562}', "");
    Expect(0, 73668, '\P{^Nv=0.01562}', "");
    Error('\p{Is_Numeric_Value:	/a/ 00000001/0000064}');
    Error('\P{Is_Numeric_Value:	/a/ 00000001/0000064}');
    Expect(1, 73667, '\p{Is_Numeric_Value=0001/064}', "");
    Expect(0, 73667, '\p{^Is_Numeric_Value=0001/064}', "");
    Expect(0, 73667, '\P{Is_Numeric_Value=0001/064}', "");
    Expect(1, 73667, '\P{^Is_Numeric_Value=0001/064}', "");
    Expect(0, 73668, '\p{Is_Numeric_Value=0001/064}', "");
    Expect(1, 73668, '\p{^Is_Numeric_Value=0001/064}', "");
    Expect(1, 73668, '\P{Is_Numeric_Value=0001/064}', "");
    Expect(0, 73668, '\P{^Is_Numeric_Value=0001/064}', "");
    Expect(1, 73667, '\p{Is_Numeric_Value=60/3840}', "");
    Expect(0, 73667, '\p{^Is_Numeric_Value=60/3840}', "");
    Expect(0, 73667, '\P{Is_Numeric_Value=60/3840}', "");
    Expect(1, 73667, '\P{^Is_Numeric_Value=60/3840}', "");
    Expect(0, 73668, '\p{Is_Numeric_Value=60/3840}', "");
    Expect(1, 73668, '\p{^Is_Numeric_Value=60/3840}', "");
    Expect(1, 73668, '\P{Is_Numeric_Value=60/3840}', "");
    Expect(0, 73668, '\P{^Is_Numeric_Value=60/3840}', "");
    Error('\p{Is_Numeric_Value=1.6e-02}');
    Error('\P{Is_Numeric_Value=1.6e-02}');
    Expect(1, 73667, '\p{Is_Numeric_Value=1.56e-02}', "");
    Expect(0, 73667, '\p{^Is_Numeric_Value=1.56e-02}', "");
    Expect(0, 73667, '\P{Is_Numeric_Value=1.56e-02}', "");
    Expect(1, 73667, '\P{^Is_Numeric_Value=1.56e-02}', "");
    Expect(0, 73668, '\p{Is_Numeric_Value=1.56e-02}', "");
    Expect(1, 73668, '\p{^Is_Numeric_Value=1.56e-02}', "");
    Expect(1, 73668, '\P{Is_Numeric_Value=1.56e-02}', "");
    Expect(0, 73668, '\P{^Is_Numeric_Value=1.56e-02}', "");
    Error('\p{Is_Numeric_Value=0.02}');
    Error('\P{Is_Numeric_Value=0.02}');
    Expect(1, 73667, '\p{Is_Numeric_Value=1.562e-02}', "");
    Expect(0, 73667, '\p{^Is_Numeric_Value=1.562e-02}', "");
    Expect(0, 73667, '\P{Is_Numeric_Value=1.562e-02}', "");
    Expect(1, 73667, '\P{^Is_Numeric_Value=1.562e-02}', "");
    Expect(0, 73668, '\p{Is_Numeric_Value=1.562e-02}', "");
    Expect(1, 73668, '\p{^Is_Numeric_Value=1.562e-02}', "");
    Expect(1, 73668, '\P{Is_Numeric_Value=1.562e-02}', "");
    Expect(0, 73668, '\P{^Is_Numeric_Value=1.562e-02}', "");
    Error('\p{Is_Numeric_Value=0.016}');
    Error('\P{Is_Numeric_Value=0.016}');
    Expect(1, 73667, '\p{Is_Numeric_Value:1.5625e-02}', "");
    Expect(0, 73667, '\p{^Is_Numeric_Value:1.5625e-02}', "");
    Expect(0, 73667, '\P{Is_Numeric_Value:1.5625e-02}', "");
    Expect(1, 73667, '\P{^Is_Numeric_Value:1.5625e-02}', "");
    Expect(0, 73668, '\p{Is_Numeric_Value:1.5625e-02}', "");
    Expect(1, 73668, '\p{^Is_Numeric_Value:1.5625e-02}', "");
    Expect(1, 73668, '\P{Is_Numeric_Value:1.5625e-02}', "");
    Expect(0, 73668, '\P{^Is_Numeric_Value:1.5625e-02}', "");
    Expect(1, 73667, '\p{Is_Numeric_Value=0.0156}', "");
    Expect(0, 73667, '\p{^Is_Numeric_Value=0.0156}', "");
    Expect(0, 73667, '\P{Is_Numeric_Value=0.0156}', "");
    Expect(1, 73667, '\P{^Is_Numeric_Value=0.0156}', "");
    Expect(0, 73668, '\p{Is_Numeric_Value=0.0156}', "");
    Expect(1, 73668, '\p{^Is_Numeric_Value=0.0156}', "");
    Expect(1, 73668, '\P{Is_Numeric_Value=0.0156}', "");
    Expect(0, 73668, '\P{^Is_Numeric_Value=0.0156}', "");
    Expect(1, 73667, '\p{Is_Numeric_Value=1.56250e-02}', "");
    Expect(0, 73667, '\p{^Is_Numeric_Value=1.56250e-02}', "");
    Expect(0, 73667, '\P{Is_Numeric_Value=1.56250e-02}', "");
    Expect(1, 73667, '\P{^Is_Numeric_Value=1.56250e-02}', "");
    Expect(0, 73668, '\p{Is_Numeric_Value=1.56250e-02}', "");
    Expect(1, 73668, '\p{^Is_Numeric_Value=1.56250e-02}', "");
    Expect(1, 73668, '\P{Is_Numeric_Value=1.56250e-02}', "");
    Expect(0, 73668, '\P{^Is_Numeric_Value=1.56250e-02}', "");
    Expect(1, 73667, '\p{Is_Numeric_Value=0.01562}', "");
    Expect(0, 73667, '\p{^Is_Numeric_Value=0.01562}', "");
    Expect(0, 73667, '\P{Is_Numeric_Value=0.01562}', "");
    Expect(1, 73667, '\P{^Is_Numeric_Value=0.01562}', "");
    Expect(0, 73668, '\p{Is_Numeric_Value=0.01562}', "");
    Expect(1, 73668, '\p{^Is_Numeric_Value=0.01562}', "");
    Expect(1, 73668, '\P{Is_Numeric_Value=0.01562}', "");
    Expect(0, 73668, '\P{^Is_Numeric_Value=0.01562}', "");
    Error('\p{Is_Nv:   /a/_000001/00000064}');
    Error('\P{Is_Nv:   /a/_000001/00000064}');
    Expect(1, 73667, '\p{Is_Nv=01/00064}', "");
    Expect(0, 73667, '\p{^Is_Nv=01/00064}', "");
    Expect(0, 73667, '\P{Is_Nv=01/00064}', "");
    Expect(1, 73667, '\P{^Is_Nv=01/00064}', "");
    Expect(0, 73668, '\p{Is_Nv=01/00064}', "");
    Expect(1, 73668, '\p{^Is_Nv=01/00064}', "");
    Expect(1, 73668, '\P{Is_Nv=01/00064}', "");
    Expect(0, 73668, '\P{^Is_Nv=01/00064}', "");
    Expect(1, 73667, '\p{Is_Nv=60/3840}', "");
    Expect(0, 73667, '\p{^Is_Nv=60/3840}', "");
    Expect(0, 73667, '\P{Is_Nv=60/3840}', "");
    Expect(1, 73667, '\P{^Is_Nv=60/3840}', "");
    Expect(0, 73668, '\p{Is_Nv=60/3840}', "");
    Expect(1, 73668, '\p{^Is_Nv=60/3840}', "");
    Expect(1, 73668, '\P{Is_Nv=60/3840}', "");
    Expect(0, 73668, '\P{^Is_Nv=60/3840}', "");
    Error('\p{Is_Nv=1.6e-02}');
    Error('\P{Is_Nv=1.6e-02}');
    Expect(1, 73667, '\p{Is_Nv=1.56e-02}', "");
    Expect(0, 73667, '\p{^Is_Nv=1.56e-02}', "");
    Expect(0, 73667, '\P{Is_Nv=1.56e-02}', "");
    Expect(1, 73667, '\P{^Is_Nv=1.56e-02}', "");
    Expect(0, 73668, '\p{Is_Nv=1.56e-02}', "");
    Expect(1, 73668, '\p{^Is_Nv=1.56e-02}', "");
    Expect(1, 73668, '\P{Is_Nv=1.56e-02}', "");
    Expect(0, 73668, '\P{^Is_Nv=1.56e-02}', "");
    Error('\p{Is_Nv=0.02}');
    Error('\P{Is_Nv=0.02}');
    Expect(1, 73667, '\p{Is_Nv=1.562e-02}', "");
    Expect(0, 73667, '\p{^Is_Nv=1.562e-02}', "");
    Expect(0, 73667, '\P{Is_Nv=1.562e-02}', "");
    Expect(1, 73667, '\P{^Is_Nv=1.562e-02}', "");
    Expect(0, 73668, '\p{Is_Nv=1.562e-02}', "");
    Expect(1, 73668, '\p{^Is_Nv=1.562e-02}', "");
    Expect(1, 73668, '\P{Is_Nv=1.562e-02}', "");
    Expect(0, 73668, '\P{^Is_Nv=1.562e-02}', "");
    Error('\p{Is_Nv=0.016}');
    Error('\P{Is_Nv=0.016}');
    Expect(1, 73667, '\p{Is_Nv=1.5625e-02}', "");
    Expect(0, 73667, '\p{^Is_Nv=1.5625e-02}', "");
    Expect(0, 73667, '\P{Is_Nv=1.5625e-02}', "");
    Expect(1, 73667, '\P{^Is_Nv=1.5625e-02}', "");
    Expect(0, 73668, '\p{Is_Nv=1.5625e-02}', "");
    Expect(1, 73668, '\p{^Is_Nv=1.5625e-02}', "");
    Expect(1, 73668, '\P{Is_Nv=1.5625e-02}', "");
    Expect(0, 73668, '\P{^Is_Nv=1.5625e-02}', "");
    Expect(1, 73667, '\p{Is_Nv=0.0156}', "");
    Expect(0, 73667, '\p{^Is_Nv=0.0156}', "");
    Expect(0, 73667, '\P{Is_Nv=0.0156}', "");
    Expect(1, 73667, '\P{^Is_Nv=0.0156}', "");
    Expect(0, 73668, '\p{Is_Nv=0.0156}', "");
    Expect(1, 73668, '\p{^Is_Nv=0.0156}', "");
    Expect(1, 73668, '\P{Is_Nv=0.0156}', "");
    Expect(0, 73668, '\P{^Is_Nv=0.0156}', "");
    Expect(1, 73667, '\p{Is_Nv=1.56250e-02}', "");
    Expect(0, 73667, '\p{^Is_Nv=1.56250e-02}', "");
    Expect(0, 73667, '\P{Is_Nv=1.56250e-02}', "");
    Expect(1, 73667, '\P{^Is_Nv=1.56250e-02}', "");
    Expect(0, 73668, '\p{Is_Nv=1.56250e-02}', "");
    Expect(1, 73668, '\p{^Is_Nv=1.56250e-02}', "");
    Expect(1, 73668, '\P{Is_Nv=1.56250e-02}', "");
    Expect(0, 73668, '\P{^Is_Nv=1.56250e-02}', "");
    Expect(1, 73667, '\p{Is_Nv=0.01562}', "");
    Expect(0, 73667, '\p{^Is_Nv=0.01562}', "");
    Expect(0, 73667, '\P{Is_Nv=0.01562}', "");
    Expect(1, 73667, '\P{^Is_Nv=0.01562}', "");
    Expect(0, 73668, '\p{Is_Nv=0.01562}', "");
    Expect(1, 73668, '\p{^Is_Nv=0.01562}', "");
    Expect(1, 73668, '\P{Is_Nv=0.01562}', "");
    Expect(0, 73668, '\P{^Is_Nv=0.01562}', "");
    Error('\p{Numeric_Value=:=000001/000007}');
    Error('\P{Numeric_Value=:=000001/000007}');
    Expect(1, 8528, '\p{Numeric_Value=:\A1/7\z:}', "");;
    Expect(0, 8529, '\p{Numeric_Value=:\A1/7\z:}', "");;
    Expect(1, 8528, '\p{Numeric_Value=001/007}', "");
    Expect(0, 8528, '\p{^Numeric_Value=001/007}', "");
    Expect(0, 8528, '\P{Numeric_Value=001/007}', "");
    Expect(1, 8528, '\P{^Numeric_Value=001/007}', "");
    Expect(0, 8529, '\p{Numeric_Value=001/007}', "");
    Expect(1, 8529, '\p{^Numeric_Value=001/007}', "");
    Expect(1, 8529, '\P{Numeric_Value=001/007}', "");
    Expect(0, 8529, '\P{^Numeric_Value=001/007}', "");
    Expect(1, 8528, '\p{Numeric_Value=60/420}', "");
    Expect(0, 8528, '\p{^Numeric_Value=60/420}', "");
    Expect(0, 8528, '\P{Numeric_Value=60/420}', "");
    Expect(1, 8528, '\P{^Numeric_Value=60/420}', "");
    Expect(0, 8529, '\p{Numeric_Value=60/420}', "");
    Expect(1, 8529, '\p{^Numeric_Value=60/420}', "");
    Expect(1, 8529, '\P{Numeric_Value=60/420}', "");
    Expect(0, 8529, '\P{^Numeric_Value=60/420}', "");
    Error('\p{Numeric_Value=1.4e-01}');
    Error('\P{Numeric_Value=1.4e-01}');
    Expect(1, 8528, '\p{Numeric_Value=1.43e-01}', "");
    Expect(0, 8528, '\p{^Numeric_Value=1.43e-01}', "");
    Expect(0, 8528, '\P{Numeric_Value=1.43e-01}', "");
    Expect(1, 8528, '\P{^Numeric_Value=1.43e-01}', "");
    Expect(0, 8529, '\p{Numeric_Value=1.43e-01}', "");
    Expect(1, 8529, '\p{^Numeric_Value=1.43e-01}', "");
    Expect(1, 8529, '\P{Numeric_Value=1.43e-01}', "");
    Expect(0, 8529, '\P{^Numeric_Value=1.43e-01}', "");
    Error('\p{Numeric_Value=0.14}');
    Error('\P{Numeric_Value=0.14}');
    Expect(1, 8528, '\p{Numeric_Value=1.429e-01}', "");
    Expect(0, 8528, '\p{^Numeric_Value=1.429e-01}', "");
    Expect(0, 8528, '\P{Numeric_Value=1.429e-01}', "");
    Expect(1, 8528, '\P{^Numeric_Value=1.429e-01}', "");
    Expect(0, 8529, '\p{Numeric_Value=1.429e-01}', "");
    Expect(1, 8529, '\p{^Numeric_Value=1.429e-01}', "");
    Expect(1, 8529, '\P{Numeric_Value=1.429e-01}', "");
    Expect(0, 8529, '\P{^Numeric_Value=1.429e-01}', "");
    Expect(1, 8528, '\p{Numeric_Value=0.143}', "");
    Expect(0, 8528, '\p{^Numeric_Value=0.143}', "");
    Expect(0, 8528, '\P{Numeric_Value=0.143}', "");
    Expect(1, 8528, '\P{^Numeric_Value=0.143}', "");
    Expect(0, 8529, '\p{Numeric_Value=0.143}', "");
    Expect(1, 8529, '\p{^Numeric_Value=0.143}', "");
    Expect(1, 8529, '\P{Numeric_Value=0.143}', "");
    Expect(0, 8529, '\P{^Numeric_Value=0.143}', "");
    Expect(1, 8528, '\p{Numeric_Value=1.4286e-01}', "");
    Expect(0, 8528, '\p{^Numeric_Value=1.4286e-01}', "");
    Expect(0, 8528, '\P{Numeric_Value=1.4286e-01}', "");
    Expect(1, 8528, '\P{^Numeric_Value=1.4286e-01}', "");
    Expect(0, 8529, '\p{Numeric_Value=1.4286e-01}', "");
    Expect(1, 8529, '\p{^Numeric_Value=1.4286e-01}', "");
    Expect(1, 8529, '\P{Numeric_Value=1.4286e-01}', "");
    Expect(0, 8529, '\P{^Numeric_Value=1.4286e-01}', "");
    Expect(1, 8528, '\p{Numeric_Value=0.1429}', "");
    Expect(0, 8528, '\p{^Numeric_Value=0.1429}', "");
    Expect(0, 8528, '\P{Numeric_Value=0.1429}', "");
    Expect(1, 8528, '\P{^Numeric_Value=0.1429}', "");
    Expect(0, 8529, '\p{Numeric_Value=0.1429}', "");
    Expect(1, 8529, '\p{^Numeric_Value=0.1429}', "");
    Expect(1, 8529, '\P{Numeric_Value=0.1429}', "");
    Expect(0, 8529, '\P{^Numeric_Value=0.1429}', "");
    Error('\p{Nv=_ +00000001/007/a/}');
    Error('\P{Nv=_ +00000001/007/a/}');
    Expect(1, 8528, '\p{Nv=:\A1/7\z:}', "");;
    Expect(0, 8529, '\p{Nv=:\A1/7\z:}', "");;
    Expect(1, 8528, '\p{Nv=000000001/00007}', "");
    Expect(0, 8528, '\p{^Nv=000000001/00007}', "");
    Expect(0, 8528, '\P{Nv=000000001/00007}', "");
    Expect(1, 8528, '\P{^Nv=000000001/00007}', "");
    Expect(0, 8529, '\p{Nv=000000001/00007}', "");
    Expect(1, 8529, '\p{^Nv=000000001/00007}', "");
    Expect(1, 8529, '\P{Nv=000000001/00007}', "");
    Expect(0, 8529, '\P{^Nv=000000001/00007}', "");
    Expect(1, 8528, '\p{Nv=60/420}', "");
    Expect(0, 8528, '\p{^Nv=60/420}', "");
    Expect(0, 8528, '\P{Nv=60/420}', "");
    Expect(1, 8528, '\P{^Nv=60/420}', "");
    Expect(0, 8529, '\p{Nv=60/420}', "");
    Expect(1, 8529, '\p{^Nv=60/420}', "");
    Expect(1, 8529, '\P{Nv=60/420}', "");
    Expect(0, 8529, '\P{^Nv=60/420}', "");
    Error('\p{Nv:   1.4e-01}');
    Error('\P{Nv:   1.4e-01}');
    Expect(1, 8528, '\p{Nv=1.43e-01}', "");
    Expect(0, 8528, '\p{^Nv=1.43e-01}', "");
    Expect(0, 8528, '\P{Nv=1.43e-01}', "");
    Expect(1, 8528, '\P{^Nv=1.43e-01}', "");
    Expect(0, 8529, '\p{Nv=1.43e-01}', "");
    Expect(1, 8529, '\p{^Nv=1.43e-01}', "");
    Expect(1, 8529, '\P{Nv=1.43e-01}', "");
    Expect(0, 8529, '\P{^Nv=1.43e-01}', "");
    Error('\p{Nv=0.14}');
    Error('\P{Nv=0.14}');
    Expect(1, 8528, '\p{Nv=1.429e-01}', "");
    Expect(0, 8528, '\p{^Nv=1.429e-01}', "");
    Expect(0, 8528, '\P{Nv=1.429e-01}', "");
    Expect(1, 8528, '\P{^Nv=1.429e-01}', "");
    Expect(0, 8529, '\p{Nv=1.429e-01}', "");
    Expect(1, 8529, '\p{^Nv=1.429e-01}', "");
    Expect(1, 8529, '\P{Nv=1.429e-01}', "");
    Expect(0, 8529, '\P{^Nv=1.429e-01}', "");
    Expect(1, 8528, '\p{Nv: 0.143}', "");
    Expect(0, 8528, '\p{^Nv: 0.143}', "");
    Expect(0, 8528, '\P{Nv: 0.143}', "");
    Expect(1, 8528, '\P{^Nv: 0.143}', "");
    Expect(0, 8529, '\p{Nv: 0.143}', "");
    Expect(1, 8529, '\p{^Nv: 0.143}', "");
    Expect(1, 8529, '\P{Nv: 0.143}', "");
    Expect(0, 8529, '\P{^Nv: 0.143}', "");
    Expect(1, 8528, '\p{Nv=1.4286e-01}', "");
    Expect(0, 8528, '\p{^Nv=1.4286e-01}', "");
    Expect(0, 8528, '\P{Nv=1.4286e-01}', "");
    Expect(1, 8528, '\P{^Nv=1.4286e-01}', "");
    Expect(0, 8529, '\p{Nv=1.4286e-01}', "");
    Expect(1, 8529, '\p{^Nv=1.4286e-01}', "");
    Expect(1, 8529, '\P{Nv=1.4286e-01}', "");
    Expect(0, 8529, '\P{^Nv=1.4286e-01}', "");
    Expect(1, 8528, '\p{Nv=0.1429}', "");
    Expect(0, 8528, '\p{^Nv=0.1429}', "");
    Expect(0, 8528, '\P{Nv=0.1429}', "");
    Expect(1, 8528, '\P{^Nv=0.1429}', "");
    Expect(0, 8529, '\p{Nv=0.1429}', "");
    Expect(1, 8529, '\p{^Nv=0.1429}', "");
    Expect(1, 8529, '\P{Nv=0.1429}', "");
    Expect(0, 8529, '\P{^Nv=0.1429}', "");
    Error('\p{Is_Numeric_Value=-	+000000001/000000007:=}');
    Error('\P{Is_Numeric_Value=-	+000000001/000000007:=}');
    Expect(1, 8528, '\p{Is_Numeric_Value=001/00007}', "");
    Expect(0, 8528, '\p{^Is_Numeric_Value=001/00007}', "");
    Expect(0, 8528, '\P{Is_Numeric_Value=001/00007}', "");
    Expect(1, 8528, '\P{^Is_Numeric_Value=001/00007}', "");
    Expect(0, 8529, '\p{Is_Numeric_Value=001/00007}', "");
    Expect(1, 8529, '\p{^Is_Numeric_Value=001/00007}', "");
    Expect(1, 8529, '\P{Is_Numeric_Value=001/00007}', "");
    Expect(0, 8529, '\P{^Is_Numeric_Value=001/00007}', "");
    Expect(1, 8528, '\p{Is_Numeric_Value=60/420}', "");
    Expect(0, 8528, '\p{^Is_Numeric_Value=60/420}', "");
    Expect(0, 8528, '\P{Is_Numeric_Value=60/420}', "");
    Expect(1, 8528, '\P{^Is_Numeric_Value=60/420}', "");
    Expect(0, 8529, '\p{Is_Numeric_Value=60/420}', "");
    Expect(1, 8529, '\p{^Is_Numeric_Value=60/420}', "");
    Expect(1, 8529, '\P{Is_Numeric_Value=60/420}', "");
    Expect(0, 8529, '\P{^Is_Numeric_Value=60/420}', "");
    Error('\p{Is_Numeric_Value=1.4e-01}');
    Error('\P{Is_Numeric_Value=1.4e-01}');
    Expect(1, 8528, '\p{Is_Numeric_Value=1.43e-01}', "");
    Expect(0, 8528, '\p{^Is_Numeric_Value=1.43e-01}', "");
    Expect(0, 8528, '\P{Is_Numeric_Value=1.43e-01}', "");
    Expect(1, 8528, '\P{^Is_Numeric_Value=1.43e-01}', "");
    Expect(0, 8529, '\p{Is_Numeric_Value=1.43e-01}', "");
    Expect(1, 8529, '\p{^Is_Numeric_Value=1.43e-01}', "");
    Expect(1, 8529, '\P{Is_Numeric_Value=1.43e-01}', "");
    Expect(0, 8529, '\P{^Is_Numeric_Value=1.43e-01}', "");
    Error('\p{Is_Numeric_Value=0.14}');
    Error('\P{Is_Numeric_Value=0.14}');
    Expect(1, 8528, '\p{Is_Numeric_Value=1.429e-01}', "");
    Expect(0, 8528, '\p{^Is_Numeric_Value=1.429e-01}', "");
    Expect(0, 8528, '\P{Is_Numeric_Value=1.429e-01}', "");
    Expect(1, 8528, '\P{^Is_Numeric_Value=1.429e-01}', "");
    Expect(0, 8529, '\p{Is_Numeric_Value=1.429e-01}', "");
    Expect(1, 8529, '\p{^Is_Numeric_Value=1.429e-01}', "");
    Expect(1, 8529, '\P{Is_Numeric_Value=1.429e-01}', "");
    Expect(0, 8529, '\P{^Is_Numeric_Value=1.429e-01}', "");
    Expect(1, 8528, '\p{Is_Numeric_Value=0.143}', "");
    Expect(0, 8528, '\p{^Is_Numeric_Value=0.143}', "");
    Expect(0, 8528, '\P{Is_Numeric_Value=0.143}', "");
    Expect(1, 8528, '\P{^Is_Numeric_Value=0.143}', "");
    Expect(0, 8529, '\p{Is_Numeric_Value=0.143}', "");
    Expect(1, 8529, '\p{^Is_Numeric_Value=0.143}', "");
    Expect(1, 8529, '\P{Is_Numeric_Value=0.143}', "");
    Expect(0, 8529, '\P{^Is_Numeric_Value=0.143}', "");
    Expect(1, 8528, '\p{Is_Numeric_Value=1.4286e-01}', "");
    Expect(0, 8528, '\p{^Is_Numeric_Value=1.4286e-01}', "");
    Expect(0, 8528, '\P{Is_Numeric_Value=1.4286e-01}', "");
    Expect(1, 8528, '\P{^Is_Numeric_Value=1.4286e-01}', "");
    Expect(0, 8529, '\p{Is_Numeric_Value=1.4286e-01}', "");
    Expect(1, 8529, '\p{^Is_Numeric_Value=1.4286e-01}', "");
    Expect(1, 8529, '\P{Is_Numeric_Value=1.4286e-01}', "");
    Expect(0, 8529, '\P{^Is_Numeric_Value=1.4286e-01}', "");
    Expect(1, 8528, '\p{Is_Numeric_Value=0.1429}', "");
    Expect(0, 8528, '\p{^Is_Numeric_Value=0.1429}', "");
    Expect(0, 8528, '\P{Is_Numeric_Value=0.1429}', "");
    Expect(1, 8528, '\P{^Is_Numeric_Value=0.1429}', "");
    Expect(0, 8529, '\p{Is_Numeric_Value=0.1429}', "");
    Expect(1, 8529, '\p{^Is_Numeric_Value=0.1429}', "");
    Expect(1, 8529, '\P{Is_Numeric_Value=0.1429}', "");
    Expect(0, 8529, '\P{^Is_Numeric_Value=0.1429}', "");
    Error('\p{Is_Nv= /a/+000000001/007}');
    Error('\P{Is_Nv= /a/+000000001/007}');
    Expect(1, 8528, '\p{Is_Nv=000000001/007}', "");
    Expect(0, 8528, '\p{^Is_Nv=000000001/007}', "");
    Expect(0, 8528, '\P{Is_Nv=000000001/007}', "");
    Expect(1, 8528, '\P{^Is_Nv=000000001/007}', "");
    Expect(0, 8529, '\p{Is_Nv=000000001/007}', "");
    Expect(1, 8529, '\p{^Is_Nv=000000001/007}', "");
    Expect(1, 8529, '\P{Is_Nv=000000001/007}', "");
    Expect(0, 8529, '\P{^Is_Nv=000000001/007}', "");
    Expect(1, 8528, '\p{Is_Nv=60/420}', "");
    Expect(0, 8528, '\p{^Is_Nv=60/420}', "");
    Expect(0, 8528, '\P{Is_Nv=60/420}', "");
    Expect(1, 8528, '\P{^Is_Nv=60/420}', "");
    Expect(0, 8529, '\p{Is_Nv=60/420}', "");
    Expect(1, 8529, '\p{^Is_Nv=60/420}', "");
    Expect(1, 8529, '\P{Is_Nv=60/420}', "");
    Expect(0, 8529, '\P{^Is_Nv=60/420}', "");
    Error('\p{Is_Nv: 1.4e-01}');
    Error('\P{Is_Nv: 1.4e-01}');
    Expect(1, 8528, '\p{Is_Nv=1.43e-01}', "");
    Expect(0, 8528, '\p{^Is_Nv=1.43e-01}', "");
    Expect(0, 8528, '\P{Is_Nv=1.43e-01}', "");
    Expect(1, 8528, '\P{^Is_Nv=1.43e-01}', "");
    Expect(0, 8529, '\p{Is_Nv=1.43e-01}', "");
    Expect(1, 8529, '\p{^Is_Nv=1.43e-01}', "");
    Expect(1, 8529, '\P{Is_Nv=1.43e-01}', "");
    Expect(0, 8529, '\P{^Is_Nv=1.43e-01}', "");
    Error('\p{Is_Nv=0.14}');
    Error('\P{Is_Nv=0.14}');
    Expect(1, 8528, '\p{Is_Nv=1.429e-01}', "");
    Expect(0, 8528, '\p{^Is_Nv=1.429e-01}', "");
    Expect(0, 8528, '\P{Is_Nv=1.429e-01}', "");
    Expect(1, 8528, '\P{^Is_Nv=1.429e-01}', "");
    Expect(0, 8529, '\p{Is_Nv=1.429e-01}', "");
    Expect(1, 8529, '\p{^Is_Nv=1.429e-01}', "");
    Expect(1, 8529, '\P{Is_Nv=1.429e-01}', "");
    Expect(0, 8529, '\P{^Is_Nv=1.429e-01}', "");
    Expect(1, 8528, '\p{Is_Nv=0.143}', "");
    Expect(0, 8528, '\p{^Is_Nv=0.143}', "");
    Expect(0, 8528, '\P{Is_Nv=0.143}', "");
    Expect(1, 8528, '\P{^Is_Nv=0.143}', "");
    Expect(0, 8529, '\p{Is_Nv=0.143}', "");
    Expect(1, 8529, '\p{^Is_Nv=0.143}', "");
    Expect(1, 8529, '\P{Is_Nv=0.143}', "");
    Expect(0, 8529, '\P{^Is_Nv=0.143}', "");
    Expect(1, 8528, '\p{Is_Nv=1.4286e-01}', "");
    Expect(0, 8528, '\p{^Is_Nv=1.4286e-01}', "");
    Expect(0, 8528, '\P{Is_Nv=1.4286e-01}', "");
    Expect(1, 8528, '\P{^Is_Nv=1.4286e-01}', "");
    Expect(0, 8529, '\p{Is_Nv=1.4286e-01}', "");
    Expect(1, 8529, '\p{^Is_Nv=1.4286e-01}', "");
    Expect(1, 8529, '\P{Is_Nv=1.4286e-01}', "");
    Expect(0, 8529, '\P{^Is_Nv=1.4286e-01}', "");
    Expect(1, 8528, '\p{Is_Nv=0.1429}', "");
    Expect(0, 8528, '\p{^Is_Nv=0.1429}', "");
    Expect(0, 8528, '\P{Is_Nv=0.1429}', "");
    Expect(1, 8528, '\P{^Is_Nv=0.1429}', "");
    Expect(0, 8529, '\p{Is_Nv=0.1429}', "");
    Expect(1, 8529, '\p{^Is_Nv=0.1429}', "");
    Expect(1, 8529, '\P{Is_Nv=0.1429}', "");
    Expect(0, 8529, '\P{^Is_Nv=0.1429}', "");
    Error('\p{Numeric_Value=--001/00000008:=}');
    Error('\P{Numeric_Value=--001/00000008:=}');
    Expect(1, 74847, '\p{Numeric_Value=:\A1/8\z:}', "");;
    Expect(0, 74848, '\p{Numeric_Value=:\A1/8\z:}', "");;
    Expect(1, 74847, '\p{Numeric_Value=+001/0000008}', "");
    Expect(0, 74847, '\p{^Numeric_Value=+001/0000008}', "");
    Expect(0, 74847, '\P{Numeric_Value=+001/0000008}', "");
    Expect(1, 74847, '\P{^Numeric_Value=+001/0000008}', "");
    Expect(0, 74848, '\p{Numeric_Value=+001/0000008}', "");
    Expect(1, 74848, '\p{^Numeric_Value=+001/0000008}', "");
    Expect(1, 74848, '\P{Numeric_Value=+001/0000008}', "");
    Expect(0, 74848, '\P{^Numeric_Value=+001/0000008}', "");
    Expect(1, 74847, '\p{Numeric_Value=60/480}', "");
    Expect(0, 74847, '\p{^Numeric_Value=60/480}', "");
    Expect(0, 74847, '\P{Numeric_Value=60/480}', "");
    Expect(1, 74847, '\P{^Numeric_Value=60/480}', "");
    Expect(0, 74848, '\p{Numeric_Value=60/480}', "");
    Expect(1, 74848, '\p{^Numeric_Value=60/480}', "");
    Expect(1, 74848, '\P{Numeric_Value=60/480}', "");
    Expect(0, 74848, '\P{^Numeric_Value=60/480}', "");
    Error('\p{Numeric_Value=1.2e-01}');
    Error('\P{Numeric_Value=1.2e-01}');
    Expect(1, 74847, '\p{Numeric_Value=1.25e-01}', "");
    Expect(0, 74847, '\p{^Numeric_Value=1.25e-01}', "");
    Expect(0, 74847, '\P{Numeric_Value=1.25e-01}', "");
    Expect(1, 74847, '\P{^Numeric_Value=1.25e-01}', "");
    Expect(0, 74848, '\p{Numeric_Value=1.25e-01}', "");
    Expect(1, 74848, '\p{^Numeric_Value=1.25e-01}', "");
    Expect(1, 74848, '\P{Numeric_Value=1.25e-01}', "");
    Expect(0, 74848, '\P{^Numeric_Value=1.25e-01}', "");
    Error('\p{Numeric_Value=0.12}');
    Error('\P{Numeric_Value=0.12}');
    Expect(1, 74847, '\p{Numeric_Value=1.250e-01}', "");
    Expect(0, 74847, '\p{^Numeric_Value=1.250e-01}', "");
    Expect(0, 74847, '\P{Numeric_Value=1.250e-01}', "");
    Expect(1, 74847, '\P{^Numeric_Value=1.250e-01}', "");
    Expect(0, 74848, '\p{Numeric_Value=1.250e-01}', "");
    Expect(1, 74848, '\p{^Numeric_Value=1.250e-01}', "");
    Expect(1, 74848, '\P{Numeric_Value=1.250e-01}', "");
    Expect(0, 74848, '\P{^Numeric_Value=1.250e-01}', "");
    Expect(1, 74847, '\p{Numeric_Value: 0.125}', "");
    Expect(0, 74847, '\p{^Numeric_Value: 0.125}', "");
    Expect(0, 74847, '\P{Numeric_Value: 0.125}', "");
    Expect(1, 74847, '\P{^Numeric_Value: 0.125}', "");
    Expect(0, 74848, '\p{Numeric_Value: 0.125}', "");
    Expect(1, 74848, '\p{^Numeric_Value: 0.125}', "");
    Expect(1, 74848, '\P{Numeric_Value: 0.125}', "");
    Expect(0, 74848, '\P{^Numeric_Value: 0.125}', "");
    Expect(1, 74847, '\p{Numeric_Value=1.2500e-01}', "");
    Expect(0, 74847, '\p{^Numeric_Value=1.2500e-01}', "");
    Expect(0, 74847, '\P{Numeric_Value=1.2500e-01}', "");
    Expect(1, 74847, '\P{^Numeric_Value=1.2500e-01}', "");
    Expect(0, 74848, '\p{Numeric_Value=1.2500e-01}', "");
    Expect(1, 74848, '\p{^Numeric_Value=1.2500e-01}', "");
    Expect(1, 74848, '\P{Numeric_Value=1.2500e-01}', "");
    Expect(0, 74848, '\P{^Numeric_Value=1.2500e-01}', "");
    Expect(1, 74847, '\p{Numeric_Value:0.1250}', "");
    Expect(0, 74847, '\p{^Numeric_Value:0.1250}', "");
    Expect(0, 74847, '\P{Numeric_Value:0.1250}', "");
    Expect(1, 74847, '\P{^Numeric_Value:0.1250}', "");
    Expect(0, 74848, '\p{Numeric_Value:0.1250}', "");
    Expect(1, 74848, '\p{^Numeric_Value:0.1250}', "");
    Expect(1, 74848, '\P{Numeric_Value:0.1250}', "");
    Expect(0, 74848, '\P{^Numeric_Value:0.1250}', "");
    Error('\p{Nv=	0000001/08:=}');
    Error('\P{Nv=	0000001/08:=}');
    Expect(1, 74847, '\p{Nv=:\A1/8\z:}', "");;
    Expect(0, 74848, '\p{Nv=:\A1/8\z:}', "");;
    Expect(1, 74847, '\p{Nv=+00001/0000000008}', "");
    Expect(0, 74847, '\p{^Nv=+00001/0000000008}', "");
    Expect(0, 74847, '\P{Nv=+00001/0000000008}', "");
    Expect(1, 74847, '\P{^Nv=+00001/0000000008}', "");
    Expect(0, 74848, '\p{Nv=+00001/0000000008}', "");
    Expect(1, 74848, '\p{^Nv=+00001/0000000008}', "");
    Expect(1, 74848, '\P{Nv=+00001/0000000008}', "");
    Expect(0, 74848, '\P{^Nv=+00001/0000000008}', "");
    Expect(1, 74847, '\p{Nv=60/480}', "");
    Expect(0, 74847, '\p{^Nv=60/480}', "");
    Expect(0, 74847, '\P{Nv=60/480}', "");
    Expect(1, 74847, '\P{^Nv=60/480}', "");
    Expect(0, 74848, '\p{Nv=60/480}', "");
    Expect(1, 74848, '\p{^Nv=60/480}', "");
    Expect(1, 74848, '\P{Nv=60/480}', "");
    Expect(0, 74848, '\P{^Nv=60/480}', "");
    Error('\p{Nv=1.2e-01}');
    Error('\P{Nv=1.2e-01}');
    Expect(1, 74847, '\p{Nv=1.25e-01}', "");
    Expect(0, 74847, '\p{^Nv=1.25e-01}', "");
    Expect(0, 74847, '\P{Nv=1.25e-01}', "");
    Expect(1, 74847, '\P{^Nv=1.25e-01}', "");
    Expect(0, 74848, '\p{Nv=1.25e-01}', "");
    Expect(1, 74848, '\p{^Nv=1.25e-01}', "");
    Expect(1, 74848, '\P{Nv=1.25e-01}', "");
    Expect(0, 74848, '\P{^Nv=1.25e-01}', "");
    Error('\p{Nv=0.12}');
    Error('\P{Nv=0.12}');
    Expect(1, 74847, '\p{Nv=1.250e-01}', "");
    Expect(0, 74847, '\p{^Nv=1.250e-01}', "");
    Expect(0, 74847, '\P{Nv=1.250e-01}', "");
    Expect(1, 74847, '\P{^Nv=1.250e-01}', "");
    Expect(0, 74848, '\p{Nv=1.250e-01}', "");
    Expect(1, 74848, '\p{^Nv=1.250e-01}', "");
    Expect(1, 74848, '\P{Nv=1.250e-01}', "");
    Expect(0, 74848, '\P{^Nv=1.250e-01}', "");
    Expect(1, 74847, '\p{Nv=0.125}', "");
    Expect(0, 74847, '\p{^Nv=0.125}', "");
    Expect(0, 74847, '\P{Nv=0.125}', "");
    Expect(1, 74847, '\P{^Nv=0.125}', "");
    Expect(0, 74848, '\p{Nv=0.125}', "");
    Expect(1, 74848, '\p{^Nv=0.125}', "");
    Expect(1, 74848, '\P{Nv=0.125}', "");
    Expect(0, 74848, '\P{^Nv=0.125}', "");
    Expect(1, 74847, '\p{Nv=1.2500e-01}', "");
    Expect(0, 74847, '\p{^Nv=1.2500e-01}', "");
    Expect(0, 74847, '\P{Nv=1.2500e-01}', "");
    Expect(1, 74847, '\P{^Nv=1.2500e-01}', "");
    Expect(0, 74848, '\p{Nv=1.2500e-01}', "");
    Expect(1, 74848, '\p{^Nv=1.2500e-01}', "");
    Expect(1, 74848, '\P{Nv=1.2500e-01}', "");
    Expect(0, 74848, '\P{^Nv=1.2500e-01}', "");
    Expect(1, 74847, '\p{Nv=0.1250}', "");
    Expect(0, 74847, '\p{^Nv=0.1250}', "");
    Expect(0, 74847, '\P{Nv=0.1250}', "");
    Expect(1, 74847, '\P{^Nv=0.1250}', "");
    Expect(0, 74848, '\p{Nv=0.1250}', "");
    Expect(1, 74848, '\p{^Nv=0.1250}', "");
    Expect(1, 74848, '\P{Nv=0.1250}', "");
    Expect(0, 74848, '\P{^Nv=0.1250}', "");
    Error('\p{Is_Numeric_Value=-/a/+000000001/008}');
    Error('\P{Is_Numeric_Value=-/a/+000000001/008}');
    Expect(1, 74847, '\p{Is_Numeric_Value=0000000001/8}', "");
    Expect(0, 74847, '\p{^Is_Numeric_Value=0000000001/8}', "");
    Expect(0, 74847, '\P{Is_Numeric_Value=0000000001/8}', "");
    Expect(1, 74847, '\P{^Is_Numeric_Value=0000000001/8}', "");
    Expect(0, 74848, '\p{Is_Numeric_Value=0000000001/8}', "");
    Expect(1, 74848, '\p{^Is_Numeric_Value=0000000001/8}', "");
    Expect(1, 74848, '\P{Is_Numeric_Value=0000000001/8}', "");
    Expect(0, 74848, '\P{^Is_Numeric_Value=0000000001/8}', "");
    Expect(1, 74847, '\p{Is_Numeric_Value=60/480}', "");
    Expect(0, 74847, '\p{^Is_Numeric_Value=60/480}', "");
    Expect(0, 74847, '\P{Is_Numeric_Value=60/480}', "");
    Expect(1, 74847, '\P{^Is_Numeric_Value=60/480}', "");
    Expect(0, 74848, '\p{Is_Numeric_Value=60/480}', "");
    Expect(1, 74848, '\p{^Is_Numeric_Value=60/480}', "");
    Expect(1, 74848, '\P{Is_Numeric_Value=60/480}', "");
    Expect(0, 74848, '\P{^Is_Numeric_Value=60/480}', "");
    Error('\p{Is_Numeric_Value=1.2e-01}');
    Error('\P{Is_Numeric_Value=1.2e-01}');
    Expect(1, 74847, '\p{Is_Numeric_Value=1.25e-01}', "");
    Expect(0, 74847, '\p{^Is_Numeric_Value=1.25e-01}', "");
    Expect(0, 74847, '\P{Is_Numeric_Value=1.25e-01}', "");
    Expect(1, 74847, '\P{^Is_Numeric_Value=1.25e-01}', "");
    Expect(0, 74848, '\p{Is_Numeric_Value=1.25e-01}', "");
    Expect(1, 74848, '\p{^Is_Numeric_Value=1.25e-01}', "");
    Expect(1, 74848, '\P{Is_Numeric_Value=1.25e-01}', "");
    Expect(0, 74848, '\P{^Is_Numeric_Value=1.25e-01}', "");
    Error('\p{Is_Numeric_Value=0.12}');
    Error('\P{Is_Numeric_Value=0.12}');
    Expect(1, 74847, '\p{Is_Numeric_Value=1.250e-01}', "");
    Expect(0, 74847, '\p{^Is_Numeric_Value=1.250e-01}', "");
    Expect(0, 74847, '\P{Is_Numeric_Value=1.250e-01}', "");
    Expect(1, 74847, '\P{^Is_Numeric_Value=1.250e-01}', "");
    Expect(0, 74848, '\p{Is_Numeric_Value=1.250e-01}', "");
    Expect(1, 74848, '\p{^Is_Numeric_Value=1.250e-01}', "");
    Expect(1, 74848, '\P{Is_Numeric_Value=1.250e-01}', "");
    Expect(0, 74848, '\P{^Is_Numeric_Value=1.250e-01}', "");
    Expect(1, 74847, '\p{Is_Numeric_Value=0.125}', "");
    Expect(0, 74847, '\p{^Is_Numeric_Value=0.125}', "");
    Expect(0, 74847, '\P{Is_Numeric_Value=0.125}', "");
    Expect(1, 74847, '\P{^Is_Numeric_Value=0.125}', "");
    Expect(0, 74848, '\p{Is_Numeric_Value=0.125}', "");
    Expect(1, 74848, '\p{^Is_Numeric_Value=0.125}', "");
    Expect(1, 74848, '\P{Is_Numeric_Value=0.125}', "");
    Expect(0, 74848, '\P{^Is_Numeric_Value=0.125}', "");
    Expect(1, 74847, '\p{Is_Numeric_Value:	1.2500e-01}', "");
    Expect(0, 74847, '\p{^Is_Numeric_Value:	1.2500e-01}', "");
    Expect(0, 74847, '\P{Is_Numeric_Value:	1.2500e-01}', "");
    Expect(1, 74847, '\P{^Is_Numeric_Value:	1.2500e-01}', "");
    Expect(0, 74848, '\p{Is_Numeric_Value:	1.2500e-01}', "");
    Expect(1, 74848, '\p{^Is_Numeric_Value:	1.2500e-01}', "");
    Expect(1, 74848, '\P{Is_Numeric_Value:	1.2500e-01}', "");
    Expect(0, 74848, '\P{^Is_Numeric_Value:	1.2500e-01}', "");
    Expect(1, 74847, '\p{Is_Numeric_Value=0.1250}', "");
    Expect(0, 74847, '\p{^Is_Numeric_Value=0.1250}', "");
    Expect(0, 74847, '\P{Is_Numeric_Value=0.1250}', "");
    Expect(1, 74847, '\P{^Is_Numeric_Value=0.1250}', "");
    Expect(0, 74848, '\p{Is_Numeric_Value=0.1250}', "");
    Expect(1, 74848, '\p{^Is_Numeric_Value=0.1250}', "");
    Expect(1, 74848, '\P{Is_Numeric_Value=0.1250}', "");
    Expect(0, 74848, '\P{^Is_Numeric_Value=0.1250}', "");
    Error('\p{Is_Nv=-_1/00000008:=}');
    Error('\P{Is_Nv=-_1/00000008:=}');
    Expect(1, 74847, '\p{Is_Nv=0000000001/000008}', "");
    Expect(0, 74847, '\p{^Is_Nv=0000000001/000008}', "");
    Expect(0, 74847, '\P{Is_Nv=0000000001/000008}', "");
    Expect(1, 74847, '\P{^Is_Nv=0000000001/000008}', "");
    Expect(0, 74848, '\p{Is_Nv=0000000001/000008}', "");
    Expect(1, 74848, '\p{^Is_Nv=0000000001/000008}', "");
    Expect(1, 74848, '\P{Is_Nv=0000000001/000008}', "");
    Expect(0, 74848, '\P{^Is_Nv=0000000001/000008}', "");
    Expect(1, 74847, '\p{Is_Nv=60/480}', "");
    Expect(0, 74847, '\p{^Is_Nv=60/480}', "");
    Expect(0, 74847, '\P{Is_Nv=60/480}', "");
    Expect(1, 74847, '\P{^Is_Nv=60/480}', "");
    Expect(0, 74848, '\p{Is_Nv=60/480}', "");
    Expect(1, 74848, '\p{^Is_Nv=60/480}', "");
    Expect(1, 74848, '\P{Is_Nv=60/480}', "");
    Expect(0, 74848, '\P{^Is_Nv=60/480}', "");
    Error('\p{Is_Nv=1.2e-01}');
    Error('\P{Is_Nv=1.2e-01}');
    Expect(1, 74847, '\p{Is_Nv=1.25e-01}', "");
    Expect(0, 74847, '\p{^Is_Nv=1.25e-01}', "");
    Expect(0, 74847, '\P{Is_Nv=1.25e-01}', "");
    Expect(1, 74847, '\P{^Is_Nv=1.25e-01}', "");
    Expect(0, 74848, '\p{Is_Nv=1.25e-01}', "");
    Expect(1, 74848, '\p{^Is_Nv=1.25e-01}', "");
    Expect(1, 74848, '\P{Is_Nv=1.25e-01}', "");
    Expect(0, 74848, '\P{^Is_Nv=1.25e-01}', "");
    Error('\p{Is_Nv:   0.12}');
    Error('\P{Is_Nv:   0.12}');
    Expect(1, 74847, '\p{Is_Nv=1.250e-01}', "");
    Expect(0, 74847, '\p{^Is_Nv=1.250e-01}', "");
    Expect(0, 74847, '\P{Is_Nv=1.250e-01}', "");
    Expect(1, 74847, '\P{^Is_Nv=1.250e-01}', "");
    Expect(0, 74848, '\p{Is_Nv=1.250e-01}', "");
    Expect(1, 74848, '\p{^Is_Nv=1.250e-01}', "");
    Expect(1, 74848, '\P{Is_Nv=1.250e-01}', "");
    Expect(0, 74848, '\P{^Is_Nv=1.250e-01}', "");
    Expect(1, 74847, '\p{Is_Nv=0.125}', "");
    Expect(0, 74847, '\p{^Is_Nv=0.125}', "");
    Expect(0, 74847, '\P{Is_Nv=0.125}', "");
    Expect(1, 74847, '\P{^Is_Nv=0.125}', "");
    Expect(0, 74848, '\p{Is_Nv=0.125}', "");
    Expect(1, 74848, '\p{^Is_Nv=0.125}', "");
    Expect(1, 74848, '\P{Is_Nv=0.125}', "");
    Expect(0, 74848, '\P{^Is_Nv=0.125}', "");
    Expect(1, 74847, '\p{Is_Nv=1.2500e-01}', "");
    Expect(0, 74847, '\p{^Is_Nv=1.2500e-01}', "");
    Expect(0, 74847, '\P{Is_Nv=1.2500e-01}', "");
    Expect(1, 74847, '\P{^Is_Nv=1.2500e-01}', "");
    Expect(0, 74848, '\p{Is_Nv=1.2500e-01}', "");
    Expect(1, 74848, '\p{^Is_Nv=1.2500e-01}', "");
    Expect(1, 74848, '\P{Is_Nv=1.2500e-01}', "");
    Expect(0, 74848, '\P{^Is_Nv=1.2500e-01}', "");
    Expect(1, 74847, '\p{Is_Nv=0.1250}', "");
    Expect(0, 74847, '\p{^Is_Nv=0.1250}', "");
    Expect(0, 74847, '\P{Is_Nv=0.1250}', "");
    Expect(1, 74847, '\P{^Is_Nv=0.1250}', "");
    Expect(0, 74848, '\p{Is_Nv=0.1250}', "");
    Expect(1, 74848, '\p{^Is_Nv=0.1250}', "");
    Expect(1, 74848, '\P{Is_Nv=0.1250}', "");
    Expect(0, 74848, '\P{^Is_Nv=0.1250}', "");
    Error('\p{Numeric_Value= :=+00000001/00000000080}');
    Error('\P{Numeric_Value= :=+00000001/00000000080}');
    Expect(1, 73666, '\p{Numeric_Value=:\A1/80\z:}', "");;
    Expect(0, 73667, '\p{Numeric_Value=:\A1/80\z:}', "");;
    Expect(1, 73666, '\p{Numeric_Value=0000001/0080}', "");
    Expect(0, 73666, '\p{^Numeric_Value=0000001/0080}', "");
    Expect(0, 73666, '\P{Numeric_Value=0000001/0080}', "");
    Expect(1, 73666, '\P{^Numeric_Value=0000001/0080}', "");
    Expect(0, 73667, '\p{Numeric_Value=0000001/0080}', "");
    Expect(1, 73667, '\p{^Numeric_Value=0000001/0080}', "");
    Expect(1, 73667, '\P{Numeric_Value=0000001/0080}', "");
    Expect(0, 73667, '\P{^Numeric_Value=0000001/0080}', "");
    Expect(1, 73666, '\p{Numeric_Value:	60/4800}', "");
    Expect(0, 73666, '\p{^Numeric_Value:	60/4800}', "");
    Expect(0, 73666, '\P{Numeric_Value:	60/4800}', "");
    Expect(1, 73666, '\P{^Numeric_Value:	60/4800}', "");
    Expect(0, 73667, '\p{Numeric_Value:	60/4800}', "");
    Expect(1, 73667, '\p{^Numeric_Value:	60/4800}', "");
    Expect(1, 73667, '\P{Numeric_Value:	60/4800}', "");
    Expect(0, 73667, '\P{^Numeric_Value:	60/4800}', "");
    Error('\p{Numeric_Value=1.3e-02}');
    Error('\P{Numeric_Value=1.3e-02}');
    Expect(1, 73666, '\p{Numeric_Value=1.25e-02}', "");
    Expect(0, 73666, '\p{^Numeric_Value=1.25e-02}', "");
    Expect(0, 73666, '\P{Numeric_Value=1.25e-02}', "");
    Expect(1, 73666, '\P{^Numeric_Value=1.25e-02}', "");
    Expect(0, 73667, '\p{Numeric_Value=1.25e-02}', "");
    Expect(1, 73667, '\p{^Numeric_Value=1.25e-02}', "");
    Expect(1, 73667, '\P{Numeric_Value=1.25e-02}', "");
    Expect(0, 73667, '\P{^Numeric_Value=1.25e-02}', "");
    Error('\p{Numeric_Value=0.01}');
    Error('\P{Numeric_Value=0.01}');
    Expect(1, 73666, '\p{Numeric_Value=1.250e-02}', "");
    Expect(0, 73666, '\p{^Numeric_Value=1.250e-02}', "");
    Expect(0, 73666, '\P{Numeric_Value=1.250e-02}', "");
    Expect(1, 73666, '\P{^Numeric_Value=1.250e-02}', "");
    Expect(0, 73667, '\p{Numeric_Value=1.250e-02}', "");
    Expect(1, 73667, '\p{^Numeric_Value=1.250e-02}', "");
    Expect(1, 73667, '\P{Numeric_Value=1.250e-02}', "");
    Expect(0, 73667, '\P{^Numeric_Value=1.250e-02}', "");
    Error('\p{Numeric_Value=0.013}');
    Error('\P{Numeric_Value=0.013}');
    Expect(1, 73666, '\p{Numeric_Value=1.2500e-02}', "");
    Expect(0, 73666, '\p{^Numeric_Value=1.2500e-02}', "");
    Expect(0, 73666, '\P{Numeric_Value=1.2500e-02}', "");
    Expect(1, 73666, '\P{^Numeric_Value=1.2500e-02}', "");
    Expect(0, 73667, '\p{Numeric_Value=1.2500e-02}', "");
    Expect(1, 73667, '\p{^Numeric_Value=1.2500e-02}', "");
    Expect(1, 73667, '\P{Numeric_Value=1.2500e-02}', "");
    Expect(0, 73667, '\P{^Numeric_Value=1.2500e-02}', "");
    Expect(1, 73666, '\p{Numeric_Value=0.0125}', "");
    Expect(0, 73666, '\p{^Numeric_Value=0.0125}', "");
    Expect(0, 73666, '\P{Numeric_Value=0.0125}', "");
    Expect(1, 73666, '\P{^Numeric_Value=0.0125}', "");
    Expect(0, 73667, '\p{Numeric_Value=0.0125}', "");
    Expect(1, 73667, '\p{^Numeric_Value=0.0125}', "");
    Expect(1, 73667, '\P{Numeric_Value=0.0125}', "");
    Expect(0, 73667, '\P{^Numeric_Value=0.0125}', "");
    Expect(1, 73666, '\p{Numeric_Value:	1.25000e-02}', "");
    Expect(0, 73666, '\p{^Numeric_Value:	1.25000e-02}', "");
    Expect(0, 73666, '\P{Numeric_Value:	1.25000e-02}', "");
    Expect(1, 73666, '\P{^Numeric_Value:	1.25000e-02}', "");
    Expect(0, 73667, '\p{Numeric_Value:	1.25000e-02}', "");
    Expect(1, 73667, '\p{^Numeric_Value:	1.25000e-02}', "");
    Expect(1, 73667, '\P{Numeric_Value:	1.25000e-02}', "");
    Expect(0, 73667, '\P{^Numeric_Value:	1.25000e-02}', "");
    Expect(1, 73666, '\p{Numeric_Value=0.01250}', "");
    Expect(0, 73666, '\p{^Numeric_Value=0.01250}', "");
    Expect(0, 73666, '\P{Numeric_Value=0.01250}', "");
    Expect(1, 73666, '\P{^Numeric_Value=0.01250}', "");
    Expect(0, 73667, '\p{Numeric_Value=0.01250}', "");
    Expect(1, 73667, '\p{^Numeric_Value=0.01250}', "");
    Expect(1, 73667, '\P{Numeric_Value=0.01250}', "");
    Expect(0, 73667, '\P{^Numeric_Value=0.01250}', "");
    Error('\p{Nv=:=	-00000001/80}');
    Error('\P{Nv=:=	-00000001/80}');
    Expect(1, 73666, '\p{Nv=:\A1/80\z:}', "");;
    Expect(0, 73667, '\p{Nv=:\A1/80\z:}', "");;
    Expect(1, 73666, '\p{Nv=0000000001/80}', "");
    Expect(0, 73666, '\p{^Nv=0000000001/80}', "");
    Expect(0, 73666, '\P{Nv=0000000001/80}', "");
    Expect(1, 73666, '\P{^Nv=0000000001/80}', "");
    Expect(0, 73667, '\p{Nv=0000000001/80}', "");
    Expect(1, 73667, '\p{^Nv=0000000001/80}', "");
    Expect(1, 73667, '\P{Nv=0000000001/80}', "");
    Expect(0, 73667, '\P{^Nv=0000000001/80}', "");
    Expect(1, 73666, '\p{Nv=60/4800}', "");
    Expect(0, 73666, '\p{^Nv=60/4800}', "");
    Expect(0, 73666, '\P{Nv=60/4800}', "");
    Expect(1, 73666, '\P{^Nv=60/4800}', "");
    Expect(0, 73667, '\p{Nv=60/4800}', "");
    Expect(1, 73667, '\p{^Nv=60/4800}', "");
    Expect(1, 73667, '\P{Nv=60/4800}', "");
    Expect(0, 73667, '\P{^Nv=60/4800}', "");
    Error('\p{Nv:1.3e-02}');
    Error('\P{Nv:1.3e-02}');
    Expect(1, 73666, '\p{Nv=1.25e-02}', "");
    Expect(0, 73666, '\p{^Nv=1.25e-02}', "");
    Expect(0, 73666, '\P{Nv=1.25e-02}', "");
    Expect(1, 73666, '\P{^Nv=1.25e-02}', "");
    Expect(0, 73667, '\p{Nv=1.25e-02}', "");
    Expect(1, 73667, '\p{^Nv=1.25e-02}', "");
    Expect(1, 73667, '\P{Nv=1.25e-02}', "");
    Expect(0, 73667, '\P{^Nv=1.25e-02}', "");
    Error('\p{Nv:0.01}');
    Error('\P{Nv:0.01}');
    Expect(1, 73666, '\p{Nv:	1.250e-02}', "");
    Expect(0, 73666, '\p{^Nv:	1.250e-02}', "");
    Expect(0, 73666, '\P{Nv:	1.250e-02}', "");
    Expect(1, 73666, '\P{^Nv:	1.250e-02}', "");
    Expect(0, 73667, '\p{Nv:	1.250e-02}', "");
    Expect(1, 73667, '\p{^Nv:	1.250e-02}', "");
    Expect(1, 73667, '\P{Nv:	1.250e-02}', "");
    Expect(0, 73667, '\P{^Nv:	1.250e-02}', "");
    Error('\p{Nv=0.013}');
    Error('\P{Nv=0.013}');
    Expect(1, 73666, '\p{Nv=1.2500e-02}', "");
    Expect(0, 73666, '\p{^Nv=1.2500e-02}', "");
    Expect(0, 73666, '\P{Nv=1.2500e-02}', "");
    Expect(1, 73666, '\P{^Nv=1.2500e-02}', "");
    Expect(0, 73667, '\p{Nv=1.2500e-02}', "");
    Expect(1, 73667, '\p{^Nv=1.2500e-02}', "");
    Expect(1, 73667, '\P{Nv=1.2500e-02}', "");
    Expect(0, 73667, '\P{^Nv=1.2500e-02}', "");
    Expect(1, 73666, '\p{Nv=0.0125}', "");
    Expect(0, 73666, '\p{^Nv=0.0125}', "");
    Expect(0, 73666, '\P{Nv=0.0125}', "");
    Expect(1, 73666, '\P{^Nv=0.0125}', "");
    Expect(0, 73667, '\p{Nv=0.0125}', "");
    Expect(1, 73667, '\p{^Nv=0.0125}', "");
    Expect(1, 73667, '\P{Nv=0.0125}', "");
    Expect(0, 73667, '\P{^Nv=0.0125}', "");
    Expect(1, 73666, '\p{Nv=1.25000e-02}', "");
    Expect(0, 73666, '\p{^Nv=1.25000e-02}', "");
    Expect(0, 73666, '\P{Nv=1.25000e-02}', "");
    Expect(1, 73666, '\P{^Nv=1.25000e-02}', "");
    Expect(0, 73667, '\p{Nv=1.25000e-02}', "");
    Expect(1, 73667, '\p{^Nv=1.25000e-02}', "");
    Expect(1, 73667, '\P{Nv=1.25000e-02}', "");
    Expect(0, 73667, '\P{^Nv=1.25000e-02}', "");
    Expect(1, 73666, '\p{Nv=0.01250}', "");
    Expect(0, 73666, '\p{^Nv=0.01250}', "");
    Expect(0, 73666, '\P{Nv=0.01250}', "");
    Expect(1, 73666, '\P{^Nv=0.01250}', "");
    Expect(0, 73667, '\p{Nv=0.01250}', "");
    Expect(1, 73667, '\p{^Nv=0.01250}', "");
    Expect(1, 73667, '\P{Nv=0.01250}', "");
    Expect(0, 73667, '\P{^Nv=0.01250}', "");
    Error('\p{Is_Numeric_Value=-:=001/0000000080}');
    Error('\P{Is_Numeric_Value=-:=001/0000000080}');
    Expect(1, 73666, '\p{Is_Numeric_Value=+0001/080}', "");
    Expect(0, 73666, '\p{^Is_Numeric_Value=+0001/080}', "");
    Expect(0, 73666, '\P{Is_Numeric_Value=+0001/080}', "");
    Expect(1, 73666, '\P{^Is_Numeric_Value=+0001/080}', "");
    Expect(0, 73667, '\p{Is_Numeric_Value=+0001/080}', "");
    Expect(1, 73667, '\p{^Is_Numeric_Value=+0001/080}', "");
    Expect(1, 73667, '\P{Is_Numeric_Value=+0001/080}', "");
    Expect(0, 73667, '\P{^Is_Numeric_Value=+0001/080}', "");
    Expect(1, 73666, '\p{Is_Numeric_Value=60/4800}', "");
    Expect(0, 73666, '\p{^Is_Numeric_Value=60/4800}', "");
    Expect(0, 73666, '\P{Is_Numeric_Value=60/4800}', "");
    Expect(1, 73666, '\P{^Is_Numeric_Value=60/4800}', "");
    Expect(0, 73667, '\p{Is_Numeric_Value=60/4800}', "");
    Expect(1, 73667, '\p{^Is_Numeric_Value=60/4800}', "");
    Expect(1, 73667, '\P{Is_Numeric_Value=60/4800}', "");
    Expect(0, 73667, '\P{^Is_Numeric_Value=60/4800}', "");
    Error('\p{Is_Numeric_Value=1.3e-02}');
    Error('\P{Is_Numeric_Value=1.3e-02}');
    Expect(1, 73666, '\p{Is_Numeric_Value=1.25e-02}', "");
    Expect(0, 73666, '\p{^Is_Numeric_Value=1.25e-02}', "");
    Expect(0, 73666, '\P{Is_Numeric_Value=1.25e-02}', "");
    Expect(1, 73666, '\P{^Is_Numeric_Value=1.25e-02}', "");
    Expect(0, 73667, '\p{Is_Numeric_Value=1.25e-02}', "");
    Expect(1, 73667, '\p{^Is_Numeric_Value=1.25e-02}', "");
    Expect(1, 73667, '\P{Is_Numeric_Value=1.25e-02}', "");
    Expect(0, 73667, '\P{^Is_Numeric_Value=1.25e-02}', "");
    Error('\p{Is_Numeric_Value:0.01}');
    Error('\P{Is_Numeric_Value:0.01}');
    Expect(1, 73666, '\p{Is_Numeric_Value=1.250e-02}', "");
    Expect(0, 73666, '\p{^Is_Numeric_Value=1.250e-02}', "");
    Expect(0, 73666, '\P{Is_Numeric_Value=1.250e-02}', "");
    Expect(1, 73666, '\P{^Is_Numeric_Value=1.250e-02}', "");
    Expect(0, 73667, '\p{Is_Numeric_Value=1.250e-02}', "");
    Expect(1, 73667, '\p{^Is_Numeric_Value=1.250e-02}', "");
    Expect(1, 73667, '\P{Is_Numeric_Value=1.250e-02}', "");
    Expect(0, 73667, '\P{^Is_Numeric_Value=1.250e-02}', "");
    Error('\p{Is_Numeric_Value:0.013}');
    Error('\P{Is_Numeric_Value:0.013}');
    Expect(1, 73666, '\p{Is_Numeric_Value=1.2500e-02}', "");
    Expect(0, 73666, '\p{^Is_Numeric_Value=1.2500e-02}', "");
    Expect(0, 73666, '\P{Is_Numeric_Value=1.2500e-02}', "");
    Expect(1, 73666, '\P{^Is_Numeric_Value=1.2500e-02}', "");
    Expect(0, 73667, '\p{Is_Numeric_Value=1.2500e-02}', "");
    Expect(1, 73667, '\p{^Is_Numeric_Value=1.2500e-02}', "");
    Expect(1, 73667, '\P{Is_Numeric_Value=1.2500e-02}', "");
    Expect(0, 73667, '\P{^Is_Numeric_Value=1.2500e-02}', "");
    Expect(1, 73666, '\p{Is_Numeric_Value: 0.0125}', "");
    Expect(0, 73666, '\p{^Is_Numeric_Value: 0.0125}', "");
    Expect(0, 73666, '\P{Is_Numeric_Value: 0.0125}', "");
    Expect(1, 73666, '\P{^Is_Numeric_Value: 0.0125}', "");
    Expect(0, 73667, '\p{Is_Numeric_Value: 0.0125}', "");
    Expect(1, 73667, '\p{^Is_Numeric_Value: 0.0125}', "");
    Expect(1, 73667, '\P{Is_Numeric_Value: 0.0125}', "");
    Expect(0, 73667, '\P{^Is_Numeric_Value: 0.0125}', "");
    Expect(1, 73666, '\p{Is_Numeric_Value=1.25000e-02}', "");
    Expect(0, 73666, '\p{^Is_Numeric_Value=1.25000e-02}', "");
    Expect(0, 73666, '\P{Is_Numeric_Value=1.25000e-02}', "");
    Expect(1, 73666, '\P{^Is_Numeric_Value=1.25000e-02}', "");
    Expect(0, 73667, '\p{Is_Numeric_Value=1.25000e-02}', "");
    Expect(1, 73667, '\p{^Is_Numeric_Value=1.25000e-02}', "");
    Expect(1, 73667, '\P{Is_Numeric_Value=1.25000e-02}', "");
    Expect(0, 73667, '\P{^Is_Numeric_Value=1.25000e-02}', "");
    Expect(1, 73666, '\p{Is_Numeric_Value=0.01250}', "");
    Expect(0, 73666, '\p{^Is_Numeric_Value=0.01250}', "");
    Expect(0, 73666, '\P{Is_Numeric_Value=0.01250}', "");
    Expect(1, 73666, '\P{^Is_Numeric_Value=0.01250}', "");
    Expect(0, 73667, '\p{Is_Numeric_Value=0.01250}', "");
    Expect(1, 73667, '\p{^Is_Numeric_Value=0.01250}', "");
    Expect(1, 73667, '\P{Is_Numeric_Value=0.01250}', "");
    Expect(0, 73667, '\P{^Is_Numeric_Value=0.01250}', "");
    Error('\p{Is_Nv= _000001/00000080:=}');
    Error('\P{Is_Nv= _000001/00000080:=}');
    Expect(1, 73666, '\p{Is_Nv: 00001/0000080}', "");
    Expect(0, 73666, '\p{^Is_Nv: 00001/0000080}', "");
    Expect(0, 73666, '\P{Is_Nv: 00001/0000080}', "");
    Expect(1, 73666, '\P{^Is_Nv: 00001/0000080}', "");
    Expect(0, 73667, '\p{Is_Nv: 00001/0000080}', "");
    Expect(1, 73667, '\p{^Is_Nv: 00001/0000080}', "");
    Expect(1, 73667, '\P{Is_Nv: 00001/0000080}', "");
    Expect(0, 73667, '\P{^Is_Nv: 00001/0000080}', "");
    Expect(1, 73666, '\p{Is_Nv=60/4800}', "");
    Expect(0, 73666, '\p{^Is_Nv=60/4800}', "");
    Expect(0, 73666, '\P{Is_Nv=60/4800}', "");
    Expect(1, 73666, '\P{^Is_Nv=60/4800}', "");
    Expect(0, 73667, '\p{Is_Nv=60/4800}', "");
    Expect(1, 73667, '\p{^Is_Nv=60/4800}', "");
    Expect(1, 73667, '\P{Is_Nv=60/4800}', "");
    Expect(0, 73667, '\P{^Is_Nv=60/4800}', "");
    Error('\p{Is_Nv=1.3e-02}');
    Error('\P{Is_Nv=1.3e-02}');
    Expect(1, 73666, '\p{Is_Nv:	1.25e-02}', "");
    Expect(0, 73666, '\p{^Is_Nv:	1.25e-02}', "");
    Expect(0, 73666, '\P{Is_Nv:	1.25e-02}', "");
    Expect(1, 73666, '\P{^Is_Nv:	1.25e-02}', "");
    Expect(0, 73667, '\p{Is_Nv:	1.25e-02}', "");
    Expect(1, 73667, '\p{^Is_Nv:	1.25e-02}', "");
    Expect(1, 73667, '\P{Is_Nv:	1.25e-02}', "");
    Expect(0, 73667, '\P{^Is_Nv:	1.25e-02}', "");
    Error('\p{Is_Nv=0.01}');
    Error('\P{Is_Nv=0.01}');
    Expect(1, 73666, '\p{Is_Nv=1.250e-02}', "");
    Expect(0, 73666, '\p{^Is_Nv=1.250e-02}', "");
    Expect(0, 73666, '\P{Is_Nv=1.250e-02}', "");
    Expect(1, 73666, '\P{^Is_Nv=1.250e-02}', "");
    Expect(0, 73667, '\p{Is_Nv=1.250e-02}', "");
    Expect(1, 73667, '\p{^Is_Nv=1.250e-02}', "");
    Expect(1, 73667, '\P{Is_Nv=1.250e-02}', "");
    Expect(0, 73667, '\P{^Is_Nv=1.250e-02}', "");
    Error('\p{Is_Nv=0.013}');
    Error('\P{Is_Nv=0.013}');
    Expect(1, 73666, '\p{Is_Nv=1.2500e-02}', "");
    Expect(0, 73666, '\p{^Is_Nv=1.2500e-02}', "");
    Expect(0, 73666, '\P{Is_Nv=1.2500e-02}', "");
    Expect(1, 73666, '\P{^Is_Nv=1.2500e-02}', "");
    Expect(0, 73667, '\p{Is_Nv=1.2500e-02}', "");
    Expect(1, 73667, '\p{^Is_Nv=1.2500e-02}', "");
    Expect(1, 73667, '\P{Is_Nv=1.2500e-02}', "");
    Expect(0, 73667, '\P{^Is_Nv=1.2500e-02}', "");
    Expect(1, 73666, '\p{Is_Nv:0.0125}', "");
    Expect(0, 73666, '\p{^Is_Nv:0.0125}', "");
    Expect(0, 73666, '\P{Is_Nv:0.0125}', "");
    Expect(1, 73666, '\P{^Is_Nv:0.0125}', "");
    Expect(0, 73667, '\p{Is_Nv:0.0125}', "");
    Expect(1, 73667, '\p{^Is_Nv:0.0125}', "");
    Expect(1, 73667, '\P{Is_Nv:0.0125}', "");
    Expect(0, 73667, '\P{^Is_Nv:0.0125}', "");
    Expect(1, 73666, '\p{Is_Nv=1.25000e-02}', "");
    Expect(0, 73666, '\p{^Is_Nv=1.25000e-02}', "");
    Expect(0, 73666, '\P{Is_Nv=1.25000e-02}', "");
    Expect(1, 73666, '\P{^Is_Nv=1.25000e-02}', "");
    Expect(0, 73667, '\p{Is_Nv=1.25000e-02}', "");
    Expect(1, 73667, '\p{^Is_Nv=1.25000e-02}', "");
    Expect(1, 73667, '\P{Is_Nv=1.25000e-02}', "");
    Expect(0, 73667, '\P{^Is_Nv=1.25000e-02}', "");
    Expect(1, 73666, '\p{Is_Nv=0.01250}', "");
    Expect(0, 73666, '\p{^Is_Nv=0.01250}', "");
    Expect(0, 73666, '\P{Is_Nv=0.01250}', "");
    Expect(1, 73666, '\P{^Is_Nv=0.01250}', "");
    Expect(0, 73667, '\p{Is_Nv=0.01250}', "");
    Expect(1, 73667, '\p{^Is_Nv=0.01250}', "");
    Expect(1, 73667, '\P{Is_Nv=0.01250}', "");
    Expect(0, 73667, '\P{^Is_Nv=0.01250}', "");
    Error('\p{Numeric_Value=-1/09/a/}');
    Error('\P{Numeric_Value=-1/09/a/}');
    Expect(1, 8529, '\p{Numeric_Value=:\A1/9\z:}', "");;
    Expect(0, 8530, '\p{Numeric_Value=:\A1/9\z:}', "");;
    Expect(1, 8529, '\p{Numeric_Value=1/000000009}', "");
    Expect(0, 8529, '\p{^Numeric_Value=1/000000009}', "");
    Expect(0, 8529, '\P{Numeric_Value=1/000000009}', "");
    Expect(1, 8529, '\P{^Numeric_Value=1/000000009}', "");
    Expect(0, 8530, '\p{Numeric_Value=1/000000009}', "");
    Expect(1, 8530, '\p{^Numeric_Value=1/000000009}', "");
    Expect(1, 8530, '\P{Numeric_Value=1/000000009}', "");
    Expect(0, 8530, '\P{^Numeric_Value=1/000000009}', "");
    Expect(1, 8529, '\p{Numeric_Value=60/540}', "");
    Expect(0, 8529, '\p{^Numeric_Value=60/540}', "");
    Expect(0, 8529, '\P{Numeric_Value=60/540}', "");
    Expect(1, 8529, '\P{^Numeric_Value=60/540}', "");
    Expect(0, 8530, '\p{Numeric_Value=60/540}', "");
    Expect(1, 8530, '\p{^Numeric_Value=60/540}', "");
    Expect(1, 8530, '\P{Numeric_Value=60/540}', "");
    Expect(0, 8530, '\P{^Numeric_Value=60/540}', "");
    Error('\p{Numeric_Value=1.1e-01}');
    Error('\P{Numeric_Value=1.1e-01}');
    Expect(1, 8529, '\p{Numeric_Value=1.11e-01}', "");
    Expect(0, 8529, '\p{^Numeric_Value=1.11e-01}', "");
    Expect(0, 8529, '\P{Numeric_Value=1.11e-01}', "");
    Expect(1, 8529, '\P{^Numeric_Value=1.11e-01}', "");
    Expect(0, 8530, '\p{Numeric_Value=1.11e-01}', "");
    Expect(1, 8530, '\p{^Numeric_Value=1.11e-01}', "");
    Expect(1, 8530, '\P{Numeric_Value=1.11e-01}', "");
    Expect(0, 8530, '\P{^Numeric_Value=1.11e-01}', "");
    Error('\p{Numeric_Value=0.11}');
    Error('\P{Numeric_Value=0.11}');
    Expect(1, 8529, '\p{Numeric_Value=1.111e-01}', "");
    Expect(0, 8529, '\p{^Numeric_Value=1.111e-01}', "");
    Expect(0, 8529, '\P{Numeric_Value=1.111e-01}', "");
    Expect(1, 8529, '\P{^Numeric_Value=1.111e-01}', "");
    Expect(0, 8530, '\p{Numeric_Value=1.111e-01}', "");
    Expect(1, 8530, '\p{^Numeric_Value=1.111e-01}', "");
    Expect(1, 8530, '\P{Numeric_Value=1.111e-01}', "");
    Expect(0, 8530, '\P{^Numeric_Value=1.111e-01}', "");
    Expect(1, 8529, '\p{Numeric_Value=0.111}', "");
    Expect(0, 8529, '\p{^Numeric_Value=0.111}', "");
    Expect(0, 8529, '\P{Numeric_Value=0.111}', "");
    Expect(1, 8529, '\P{^Numeric_Value=0.111}', "");
    Expect(0, 8530, '\p{Numeric_Value=0.111}', "");
    Expect(1, 8530, '\p{^Numeric_Value=0.111}', "");
    Expect(1, 8530, '\P{Numeric_Value=0.111}', "");
    Expect(0, 8530, '\P{^Numeric_Value=0.111}', "");
    Expect(1, 8529, '\p{Numeric_Value=1.1111e-01}', "");
    Expect(0, 8529, '\p{^Numeric_Value=1.1111e-01}', "");
    Expect(0, 8529, '\P{Numeric_Value=1.1111e-01}', "");
    Expect(1, 8529, '\P{^Numeric_Value=1.1111e-01}', "");
    Expect(0, 8530, '\p{Numeric_Value=1.1111e-01}', "");
    Expect(1, 8530, '\p{^Numeric_Value=1.1111e-01}', "");
    Expect(1, 8530, '\P{Numeric_Value=1.1111e-01}', "");
    Expect(0, 8530, '\P{^Numeric_Value=1.1111e-01}', "");
    Expect(1, 8529, '\p{Numeric_Value:0.1111}', "");
    Expect(0, 8529, '\p{^Numeric_Value:0.1111}', "");
    Expect(0, 8529, '\P{Numeric_Value:0.1111}', "");
    Expect(1, 8529, '\P{^Numeric_Value:0.1111}', "");
    Expect(0, 8530, '\p{Numeric_Value:0.1111}', "");
    Expect(1, 8530, '\p{^Numeric_Value:0.1111}', "");
    Expect(1, 8530, '\P{Numeric_Value:0.1111}', "");
    Expect(0, 8530, '\P{^Numeric_Value:0.1111}', "");
    Error('\p{Nv=:=	0000001/0000000009}');
    Error('\P{Nv=:=	0000001/0000000009}');
    Expect(1, 8529, '\p{Nv=:\A1/9\z:}', "");;
    Expect(0, 8530, '\p{Nv=:\A1/9\z:}', "");;
    Expect(1, 8529, '\p{Nv=+0000000001/009}', "");
    Expect(0, 8529, '\p{^Nv=+0000000001/009}', "");
    Expect(0, 8529, '\P{Nv=+0000000001/009}', "");
    Expect(1, 8529, '\P{^Nv=+0000000001/009}', "");
    Expect(0, 8530, '\p{Nv=+0000000001/009}', "");
    Expect(1, 8530, '\p{^Nv=+0000000001/009}', "");
    Expect(1, 8530, '\P{Nv=+0000000001/009}', "");
    Expect(0, 8530, '\P{^Nv=+0000000001/009}', "");
    Expect(1, 8529, '\p{Nv=60/540}', "");
    Expect(0, 8529, '\p{^Nv=60/540}', "");
    Expect(0, 8529, '\P{Nv=60/540}', "");
    Expect(1, 8529, '\P{^Nv=60/540}', "");
    Expect(0, 8530, '\p{Nv=60/540}', "");
    Expect(1, 8530, '\p{^Nv=60/540}', "");
    Expect(1, 8530, '\P{Nv=60/540}', "");
    Expect(0, 8530, '\P{^Nv=60/540}', "");
    Error('\p{Nv=1.1e-01}');
    Error('\P{Nv=1.1e-01}');
    Expect(1, 8529, '\p{Nv:1.11e-01}', "");
    Expect(0, 8529, '\p{^Nv:1.11e-01}', "");
    Expect(0, 8529, '\P{Nv:1.11e-01}', "");
    Expect(1, 8529, '\P{^Nv:1.11e-01}', "");
    Expect(0, 8530, '\p{Nv:1.11e-01}', "");
    Expect(1, 8530, '\p{^Nv:1.11e-01}', "");
    Expect(1, 8530, '\P{Nv:1.11e-01}', "");
    Expect(0, 8530, '\P{^Nv:1.11e-01}', "");
    Error('\p{Nv=0.11}');
    Error('\P{Nv=0.11}');
    Expect(1, 8529, '\p{Nv=1.111e-01}', "");
    Expect(0, 8529, '\p{^Nv=1.111e-01}', "");
    Expect(0, 8529, '\P{Nv=1.111e-01}', "");
    Expect(1, 8529, '\P{^Nv=1.111e-01}', "");
    Expect(0, 8530, '\p{Nv=1.111e-01}', "");
    Expect(1, 8530, '\p{^Nv=1.111e-01}', "");
    Expect(1, 8530, '\P{Nv=1.111e-01}', "");
    Expect(0, 8530, '\P{^Nv=1.111e-01}', "");
    Expect(1, 8529, '\p{Nv=0.111}', "");
    Expect(0, 8529, '\p{^Nv=0.111}', "");
    Expect(0, 8529, '\P{Nv=0.111}', "");
    Expect(1, 8529, '\P{^Nv=0.111}', "");
    Expect(0, 8530, '\p{Nv=0.111}', "");
    Expect(1, 8530, '\p{^Nv=0.111}', "");
    Expect(1, 8530, '\P{Nv=0.111}', "");
    Expect(0, 8530, '\P{^Nv=0.111}', "");
    Expect(1, 8529, '\p{Nv=1.1111e-01}', "");
    Expect(0, 8529, '\p{^Nv=1.1111e-01}', "");
    Expect(0, 8529, '\P{Nv=1.1111e-01}', "");
    Expect(1, 8529, '\P{^Nv=1.1111e-01}', "");
    Expect(0, 8530, '\p{Nv=1.1111e-01}', "");
    Expect(1, 8530, '\p{^Nv=1.1111e-01}', "");
    Expect(1, 8530, '\P{Nv=1.1111e-01}', "");
    Expect(0, 8530, '\P{^Nv=1.1111e-01}', "");
    Expect(1, 8529, '\p{Nv:0.1111}', "");
    Expect(0, 8529, '\p{^Nv:0.1111}', "");
    Expect(0, 8529, '\P{Nv:0.1111}', "");
    Expect(1, 8529, '\P{^Nv:0.1111}', "");
    Expect(0, 8530, '\p{Nv:0.1111}', "");
    Expect(1, 8530, '\p{^Nv:0.1111}', "");
    Expect(1, 8530, '\P{Nv:0.1111}', "");
    Expect(0, 8530, '\P{^Nv:0.1111}', "");
    Error('\p{Is_Numeric_Value=	:=001/009}');
    Error('\P{Is_Numeric_Value=	:=001/009}');
    Expect(1, 8529, '\p{Is_Numeric_Value=00001/09}', "");
    Expect(0, 8529, '\p{^Is_Numeric_Value=00001/09}', "");
    Expect(0, 8529, '\P{Is_Numeric_Value=00001/09}', "");
    Expect(1, 8529, '\P{^Is_Numeric_Value=00001/09}', "");
    Expect(0, 8530, '\p{Is_Numeric_Value=00001/09}', "");
    Expect(1, 8530, '\p{^Is_Numeric_Value=00001/09}', "");
    Expect(1, 8530, '\P{Is_Numeric_Value=00001/09}', "");
    Expect(0, 8530, '\P{^Is_Numeric_Value=00001/09}', "");
    Expect(1, 8529, '\p{Is_Numeric_Value=60/540}', "");
    Expect(0, 8529, '\p{^Is_Numeric_Value=60/540}', "");
    Expect(0, 8529, '\P{Is_Numeric_Value=60/540}', "");
    Expect(1, 8529, '\P{^Is_Numeric_Value=60/540}', "");
    Expect(0, 8530, '\p{Is_Numeric_Value=60/540}', "");
    Expect(1, 8530, '\p{^Is_Numeric_Value=60/540}', "");
    Expect(1, 8530, '\P{Is_Numeric_Value=60/540}', "");
    Expect(0, 8530, '\P{^Is_Numeric_Value=60/540}', "");
    Error('\p{Is_Numeric_Value=1.1e-01}');
    Error('\P{Is_Numeric_Value=1.1e-01}');
    Expect(1, 8529, '\p{Is_Numeric_Value=1.11e-01}', "");
    Expect(0, 8529, '\p{^Is_Numeric_Value=1.11e-01}', "");
    Expect(0, 8529, '\P{Is_Numeric_Value=1.11e-01}', "");
    Expect(1, 8529, '\P{^Is_Numeric_Value=1.11e-01}', "");
    Expect(0, 8530, '\p{Is_Numeric_Value=1.11e-01}', "");
    Expect(1, 8530, '\p{^Is_Numeric_Value=1.11e-01}', "");
    Expect(1, 8530, '\P{Is_Numeric_Value=1.11e-01}', "");
    Expect(0, 8530, '\P{^Is_Numeric_Value=1.11e-01}', "");
    Error('\p{Is_Numeric_Value=0.11}');
    Error('\P{Is_Numeric_Value=0.11}');
    Expect(1, 8529, '\p{Is_Numeric_Value=1.111e-01}', "");
    Expect(0, 8529, '\p{^Is_Numeric_Value=1.111e-01}', "");
    Expect(0, 8529, '\P{Is_Numeric_Value=1.111e-01}', "");
    Expect(1, 8529, '\P{^Is_Numeric_Value=1.111e-01}', "");
    Expect(0, 8530, '\p{Is_Numeric_Value=1.111e-01}', "");
    Expect(1, 8530, '\p{^Is_Numeric_Value=1.111e-01}', "");
    Expect(1, 8530, '\P{Is_Numeric_Value=1.111e-01}', "");
    Expect(0, 8530, '\P{^Is_Numeric_Value=1.111e-01}', "");
    Expect(1, 8529, '\p{Is_Numeric_Value=0.111}', "");
    Expect(0, 8529, '\p{^Is_Numeric_Value=0.111}', "");
    Expect(0, 8529, '\P{Is_Numeric_Value=0.111}', "");
    Expect(1, 8529, '\P{^Is_Numeric_Value=0.111}', "");
    Expect(0, 8530, '\p{Is_Numeric_Value=0.111}', "");
    Expect(1, 8530, '\p{^Is_Numeric_Value=0.111}', "");
    Expect(1, 8530, '\P{Is_Numeric_Value=0.111}', "");
    Expect(0, 8530, '\P{^Is_Numeric_Value=0.111}', "");
    Expect(1, 8529, '\p{Is_Numeric_Value=1.1111e-01}', "");
    Expect(0, 8529, '\p{^Is_Numeric_Value=1.1111e-01}', "");
    Expect(0, 8529, '\P{Is_Numeric_Value=1.1111e-01}', "");
    Expect(1, 8529, '\P{^Is_Numeric_Value=1.1111e-01}', "");
    Expect(0, 8530, '\p{Is_Numeric_Value=1.1111e-01}', "");
    Expect(1, 8530, '\p{^Is_Numeric_Value=1.1111e-01}', "");
    Expect(1, 8530, '\P{Is_Numeric_Value=1.1111e-01}', "");
    Expect(0, 8530, '\P{^Is_Numeric_Value=1.1111e-01}', "");
    Expect(1, 8529, '\p{Is_Numeric_Value=0.1111}', "");
    Expect(0, 8529, '\p{^Is_Numeric_Value=0.1111}', "");
    Expect(0, 8529, '\P{Is_Numeric_Value=0.1111}', "");
    Expect(1, 8529, '\P{^Is_Numeric_Value=0.1111}', "");
    Expect(0, 8530, '\p{Is_Numeric_Value=0.1111}', "");
    Expect(1, 8530, '\p{^Is_Numeric_Value=0.1111}', "");
    Expect(1, 8530, '\P{Is_Numeric_Value=0.1111}', "");
    Expect(0, 8530, '\P{^Is_Numeric_Value=0.1111}', "");
    Error('\p{Is_Nv= /a/001/00000009}');
    Error('\P{Is_Nv= /a/001/00000009}');
    Expect(1, 8529, '\p{Is_Nv=0000001/0000009}', "");
    Expect(0, 8529, '\p{^Is_Nv=0000001/0000009}', "");
    Expect(0, 8529, '\P{Is_Nv=0000001/0000009}', "");
    Expect(1, 8529, '\P{^Is_Nv=0000001/0000009}', "");
    Expect(0, 8530, '\p{Is_Nv=0000001/0000009}', "");
    Expect(1, 8530, '\p{^Is_Nv=0000001/0000009}', "");
    Expect(1, 8530, '\P{Is_Nv=0000001/0000009}', "");
    Expect(0, 8530, '\P{^Is_Nv=0000001/0000009}', "");
    Expect(1, 8529, '\p{Is_Nv=60/540}', "");
    Expect(0, 8529, '\p{^Is_Nv=60/540}', "");
    Expect(0, 8529, '\P{Is_Nv=60/540}', "");
    Expect(1, 8529, '\P{^Is_Nv=60/540}', "");
    Expect(0, 8530, '\p{Is_Nv=60/540}', "");
    Expect(1, 8530, '\p{^Is_Nv=60/540}', "");
    Expect(1, 8530, '\P{Is_Nv=60/540}', "");
    Expect(0, 8530, '\P{^Is_Nv=60/540}', "");
    Error('\p{Is_Nv=1.1e-01}');
    Error('\P{Is_Nv=1.1e-01}');
    Expect(1, 8529, '\p{Is_Nv=1.11e-01}', "");
    Expect(0, 8529, '\p{^Is_Nv=1.11e-01}', "");
    Expect(0, 8529, '\P{Is_Nv=1.11e-01}', "");
    Expect(1, 8529, '\P{^Is_Nv=1.11e-01}', "");
    Expect(0, 8530, '\p{Is_Nv=1.11e-01}', "");
    Expect(1, 8530, '\p{^Is_Nv=1.11e-01}', "");
    Expect(1, 8530, '\P{Is_Nv=1.11e-01}', "");
    Expect(0, 8530, '\P{^Is_Nv=1.11e-01}', "");
    Error('\p{Is_Nv:   0.11}');
    Error('\P{Is_Nv:   0.11}');
    Expect(1, 8529, '\p{Is_Nv=1.111e-01}', "");
    Expect(0, 8529, '\p{^Is_Nv=1.111e-01}', "");
    Expect(0, 8529, '\P{Is_Nv=1.111e-01}', "");
    Expect(1, 8529, '\P{^Is_Nv=1.111e-01}', "");
    Expect(0, 8530, '\p{Is_Nv=1.111e-01}', "");
    Expect(1, 8530, '\p{^Is_Nv=1.111e-01}', "");
    Expect(1, 8530, '\P{Is_Nv=1.111e-01}', "");
    Expect(0, 8530, '\P{^Is_Nv=1.111e-01}', "");
    Expect(1, 8529, '\p{Is_Nv=0.111}', "");
    Expect(0, 8529, '\p{^Is_Nv=0.111}', "");
    Expect(0, 8529, '\P{Is_Nv=0.111}', "");
    Expect(1, 8529, '\P{^Is_Nv=0.111}', "");
    Expect(0, 8530, '\p{Is_Nv=0.111}', "");
    Expect(1, 8530, '\p{^Is_Nv=0.111}', "");
    Expect(1, 8530, '\P{Is_Nv=0.111}', "");
    Expect(0, 8530, '\P{^Is_Nv=0.111}', "");
    Expect(1, 8529, '\p{Is_Nv=1.1111e-01}', "");
    Expect(0, 8529, '\p{^Is_Nv=1.1111e-01}', "");
    Expect(0, 8529, '\P{Is_Nv=1.1111e-01}', "");
    Expect(1, 8529, '\P{^Is_Nv=1.1111e-01}', "");
    Expect(0, 8530, '\p{Is_Nv=1.1111e-01}', "");
    Expect(1, 8530, '\p{^Is_Nv=1.1111e-01}', "");
    Expect(1, 8530, '\P{Is_Nv=1.1111e-01}', "");
    Expect(0, 8530, '\P{^Is_Nv=1.1111e-01}', "");
    Expect(1, 8529, '\p{Is_Nv=0.1111}', "");
    Expect(0, 8529, '\p{^Is_Nv=0.1111}', "");
    Expect(0, 8529, '\P{Is_Nv=0.1111}', "");
    Expect(1, 8529, '\P{^Is_Nv=0.1111}', "");
    Expect(0, 8530, '\p{Is_Nv=0.1111}', "");
    Expect(1, 8530, '\p{^Is_Nv=0.1111}', "");
    Expect(1, 8530, '\P{Is_Nv=0.1111}', "");
    Expect(0, 8530, '\P{^Is_Nv=0.1111}', "");
    Error('\p{Numeric_Value=/a/10}');
    Error('\P{Numeric_Value=/a/10}');
    Expect(1, 126263, '\p{Numeric_Value=:\A10\z:}', "");;
    Expect(0, 126264, '\p{Numeric_Value=:\A10\z:}', "");;
    Expect(1, 126263, '\p{Numeric_Value=+00_00_10}', "");
    Expect(0, 126263, '\p{^Numeric_Value=+00_00_10}', "");
    Expect(0, 126263, '\P{Numeric_Value=+00_00_10}', "");
    Expect(1, 126263, '\P{^Numeric_Value=+00_00_10}', "");
    Expect(0, 126264, '\p{Numeric_Value=+00_00_10}', "");
    Expect(1, 126264, '\p{^Numeric_Value=+00_00_10}', "");
    Expect(1, 126264, '\P{Numeric_Value=+00_00_10}', "");
    Expect(0, 126264, '\P{^Numeric_Value=+00_00_10}', "");
    Expect(1, 126263, '\p{Numeric_Value=1.000000000000000e+01}', "");
    Expect(0, 126263, '\p{^Numeric_Value=1.000000000000000e+01}', "");
    Expect(0, 126263, '\P{Numeric_Value=1.000000000000000e+01}', "");
    Expect(1, 126263, '\P{^Numeric_Value=1.000000000000000e+01}', "");
    Expect(0, 126264, '\p{Numeric_Value=1.000000000000000e+01}', "");
    Expect(1, 126264, '\p{^Numeric_Value=1.000000000000000e+01}', "");
    Expect(1, 126264, '\P{Numeric_Value=1.000000000000000e+01}', "");
    Expect(0, 126264, '\P{^Numeric_Value=1.000000000000000e+01}', "");
    Error('\p{Nv= :=+001_0}');
    Error('\P{Nv= :=+001_0}');
    Expect(1, 126263, '\p{Nv=:\A10\z:}', "");;
    Expect(0, 126264, '\p{Nv=:\A10\z:}', "");;
    Expect(1, 126263, '\p{Nv=00000010}', "");
    Expect(0, 126263, '\p{^Nv=00000010}', "");
    Expect(0, 126263, '\P{Nv=00000010}', "");
    Expect(1, 126263, '\P{^Nv=00000010}', "");
    Expect(0, 126264, '\p{Nv=00000010}', "");
    Expect(1, 126264, '\p{^Nv=00000010}', "");
    Expect(1, 126264, '\P{Nv=00000010}', "");
    Expect(0, 126264, '\P{^Nv=00000010}', "");
    Expect(1, 126263, '\p{Nv=1.000000000000000e+01}', "");
    Expect(0, 126263, '\p{^Nv=1.000000000000000e+01}', "");
    Expect(0, 126263, '\P{Nv=1.000000000000000e+01}', "");
    Expect(1, 126263, '\P{^Nv=1.000000000000000e+01}', "");
    Expect(0, 126264, '\p{Nv=1.000000000000000e+01}', "");
    Expect(1, 126264, '\p{^Nv=1.000000000000000e+01}', "");
    Expect(1, 126264, '\P{Nv=1.000000000000000e+01}', "");
    Expect(0, 126264, '\P{^Nv=1.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value:   00000000010:=}');
    Error('\P{Is_Numeric_Value:   00000000010:=}');
    Expect(1, 126263, '\p{Is_Numeric_Value=0_0_0_0_10}', "");
    Expect(0, 126263, '\p{^Is_Numeric_Value=0_0_0_0_10}', "");
    Expect(0, 126263, '\P{Is_Numeric_Value=0_0_0_0_10}', "");
    Expect(1, 126263, '\P{^Is_Numeric_Value=0_0_0_0_10}', "");
    Expect(0, 126264, '\p{Is_Numeric_Value=0_0_0_0_10}', "");
    Expect(1, 126264, '\p{^Is_Numeric_Value=0_0_0_0_10}', "");
    Expect(1, 126264, '\P{Is_Numeric_Value=0_0_0_0_10}', "");
    Expect(0, 126264, '\P{^Is_Numeric_Value=0_0_0_0_10}', "");
    Expect(1, 126263, '\p{Is_Numeric_Value: 1.000000000000000e+01}', "");
    Expect(0, 126263, '\p{^Is_Numeric_Value: 1.000000000000000e+01}', "");
    Expect(0, 126263, '\P{Is_Numeric_Value: 1.000000000000000e+01}', "");
    Expect(1, 126263, '\P{^Is_Numeric_Value: 1.000000000000000e+01}', "");
    Expect(0, 126264, '\p{Is_Numeric_Value: 1.000000000000000e+01}', "");
    Expect(1, 126264, '\p{^Is_Numeric_Value: 1.000000000000000e+01}', "");
    Expect(1, 126264, '\P{Is_Numeric_Value: 1.000000000000000e+01}', "");
    Expect(0, 126264, '\P{^Is_Numeric_Value: 1.000000000000000e+01}', "");
    Error('\p{Is_Nv=/a/--+00000000010}');
    Error('\P{Is_Nv=/a/--+00000000010}');
    Expect(1, 126263, '\p{Is_Nv=0000000010}', "");
    Expect(0, 126263, '\p{^Is_Nv=0000000010}', "");
    Expect(0, 126263, '\P{Is_Nv=0000000010}', "");
    Expect(1, 126263, '\P{^Is_Nv=0000000010}', "");
    Expect(0, 126264, '\p{Is_Nv=0000000010}', "");
    Expect(1, 126264, '\p{^Is_Nv=0000000010}', "");
    Expect(1, 126264, '\P{Is_Nv=0000000010}', "");
    Expect(0, 126264, '\P{^Is_Nv=0000000010}', "");
    Expect(1, 126263, '\p{Is_Nv=1.000000000000000e+01}', "");
    Expect(0, 126263, '\p{^Is_Nv=1.000000000000000e+01}', "");
    Expect(0, 126263, '\P{Is_Nv=1.000000000000000e+01}', "");
    Expect(1, 126263, '\P{^Is_Nv=1.000000000000000e+01}', "");
    Expect(0, 126264, '\p{Is_Nv=1.000000000000000e+01}', "");
    Expect(1, 126264, '\p{^Is_Nv=1.000000000000000e+01}', "");
    Expect(1, 126264, '\P{Is_Nv=1.000000000000000e+01}', "");
    Expect(0, 126264, '\P{^Is_Nv=1.000000000000000e+01}', "");
    Error('\p{Numeric_Value=-+000100:=}');
    Error('\P{Numeric_Value=-+000100:=}');
    Expect(1, 126227, '\p{Numeric_Value=:\A100\z:}', "");;
    Expect(0, 126228, '\p{Numeric_Value=:\A100\z:}', "");;
    Expect(1, 126227, '\p{Numeric_Value=+000100}', "");
    Expect(0, 126227, '\p{^Numeric_Value=+000100}', "");
    Expect(0, 126227, '\P{Numeric_Value=+000100}', "");
    Expect(1, 126227, '\P{^Numeric_Value=+000100}', "");
    Expect(0, 126228, '\p{Numeric_Value=+000100}', "");
    Expect(1, 126228, '\p{^Numeric_Value=+000100}', "");
    Expect(1, 126228, '\P{Numeric_Value=+000100}', "");
    Expect(0, 126228, '\P{^Numeric_Value=+000100}', "");
    Expect(1, 126227, '\p{Numeric_Value=1.000000000000000e+02}', "");
    Expect(0, 126227, '\p{^Numeric_Value=1.000000000000000e+02}', "");
    Expect(0, 126227, '\P{Numeric_Value=1.000000000000000e+02}', "");
    Expect(1, 126227, '\P{^Numeric_Value=1.000000000000000e+02}', "");
    Expect(0, 126228, '\p{Numeric_Value=1.000000000000000e+02}', "");
    Expect(1, 126228, '\p{^Numeric_Value=1.000000000000000e+02}', "");
    Expect(1, 126228, '\P{Numeric_Value=1.000000000000000e+02}', "");
    Expect(0, 126228, '\P{^Numeric_Value=1.000000000000000e+02}', "");
    Error('\p{Nv=/a/+00010_0}');
    Error('\P{Nv=/a/+00010_0}');
    Expect(1, 126227, '\p{Nv=:\A100\z:}', "");;
    Expect(0, 126228, '\p{Nv=:\A100\z:}', "");;
    Expect(1, 126227, '\p{Nv=00000000100}', "");
    Expect(0, 126227, '\p{^Nv=00000000100}', "");
    Expect(0, 126227, '\P{Nv=00000000100}', "");
    Expect(1, 126227, '\P{^Nv=00000000100}', "");
    Expect(0, 126228, '\p{Nv=00000000100}', "");
    Expect(1, 126228, '\p{^Nv=00000000100}', "");
    Expect(1, 126228, '\P{Nv=00000000100}', "");
    Expect(0, 126228, '\P{^Nv=00000000100}', "");
    Expect(1, 126227, '\p{Nv=1.000000000000000e+02}', "");
    Expect(0, 126227, '\p{^Nv=1.000000000000000e+02}', "");
    Expect(0, 126227, '\P{Nv=1.000000000000000e+02}', "");
    Expect(1, 126227, '\P{^Nv=1.000000000000000e+02}', "");
    Expect(0, 126228, '\p{Nv=1.000000000000000e+02}', "");
    Expect(1, 126228, '\p{^Nv=1.000000000000000e+02}', "");
    Expect(1, 126228, '\P{Nv=1.000000000000000e+02}', "");
    Expect(0, 126228, '\P{^Nv=1.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value= /a/+10_0}');
    Error('\P{Is_Numeric_Value= /a/+10_0}');
    Expect(1, 126227, '\p{Is_Numeric_Value=010_0}', "");
    Expect(0, 126227, '\p{^Is_Numeric_Value=010_0}', "");
    Expect(0, 126227, '\P{Is_Numeric_Value=010_0}', "");
    Expect(1, 126227, '\P{^Is_Numeric_Value=010_0}', "");
    Expect(0, 126228, '\p{Is_Numeric_Value=010_0}', "");
    Expect(1, 126228, '\p{^Is_Numeric_Value=010_0}', "");
    Expect(1, 126228, '\P{Is_Numeric_Value=010_0}', "");
    Expect(0, 126228, '\P{^Is_Numeric_Value=010_0}', "");
    Expect(1, 126227, '\p{Is_Numeric_Value=1.000000000000000e+02}', "");
    Expect(0, 126227, '\p{^Is_Numeric_Value=1.000000000000000e+02}', "");
    Expect(0, 126227, '\P{Is_Numeric_Value=1.000000000000000e+02}', "");
    Expect(1, 126227, '\P{^Is_Numeric_Value=1.000000000000000e+02}', "");
    Expect(0, 126228, '\p{Is_Numeric_Value=1.000000000000000e+02}', "");
    Expect(1, 126228, '\p{^Is_Numeric_Value=1.000000000000000e+02}', "");
    Expect(1, 126228, '\P{Is_Numeric_Value=1.000000000000000e+02}', "");
    Expect(0, 126228, '\P{^Is_Numeric_Value=1.000000000000000e+02}', "");
    Error('\p{Is_Nv=/a/-_00_00_00_01_00}');
    Error('\P{Is_Nv=/a/-_00_00_00_01_00}');
    Expect(1, 126227, '\p{Is_Nv=+010_0}', "");
    Expect(0, 126227, '\p{^Is_Nv=+010_0}', "");
    Expect(0, 126227, '\P{Is_Nv=+010_0}', "");
    Expect(1, 126227, '\P{^Is_Nv=+010_0}', "");
    Expect(0, 126228, '\p{Is_Nv=+010_0}', "");
    Expect(1, 126228, '\p{^Is_Nv=+010_0}', "");
    Expect(1, 126228, '\P{Is_Nv=+010_0}', "");
    Expect(0, 126228, '\P{^Is_Nv=+010_0}', "");
    Expect(1, 126227, '\p{Is_Nv=1.000000000000000e+02}', "");
    Expect(0, 126227, '\p{^Is_Nv=1.000000000000000e+02}', "");
    Expect(0, 126227, '\P{Is_Nv=1.000000000000000e+02}', "");
    Expect(1, 126227, '\P{^Is_Nv=1.000000000000000e+02}', "");
    Expect(0, 126228, '\p{Is_Nv=1.000000000000000e+02}', "");
    Expect(1, 126228, '\p{^Is_Nv=1.000000000000000e+02}', "");
    Expect(1, 126228, '\P{Is_Nv=1.000000000000000e+02}', "");
    Expect(0, 126228, '\P{^Is_Nv=1.000000000000000e+02}', "");
    Error('\p{Numeric_Value=:=_+000000100_0}');
    Error('\P{Numeric_Value=:=_+000000100_0}');
    Expect(1, 126236, '\p{Numeric_Value=:\A1000\z:}', "");;
    Expect(0, 126237, '\p{Numeric_Value=:\A1000\z:}', "");;
    Expect(1, 126236, '\p{Numeric_Value=0_0_1_0_00}', "");
    Expect(0, 126236, '\p{^Numeric_Value=0_0_1_0_00}', "");
    Expect(0, 126236, '\P{Numeric_Value=0_0_1_0_00}', "");
    Expect(1, 126236, '\P{^Numeric_Value=0_0_1_0_00}', "");
    Expect(0, 126237, '\p{Numeric_Value=0_0_1_0_00}', "");
    Expect(1, 126237, '\p{^Numeric_Value=0_0_1_0_00}', "");
    Expect(1, 126237, '\P{Numeric_Value=0_0_1_0_00}', "");
    Expect(0, 126237, '\P{^Numeric_Value=0_0_1_0_00}', "");
    Expect(1, 126236, '\p{Numeric_Value=1.000000000000000e+03}', "");
    Expect(0, 126236, '\p{^Numeric_Value=1.000000000000000e+03}', "");
    Expect(0, 126236, '\P{Numeric_Value=1.000000000000000e+03}', "");
    Expect(1, 126236, '\P{^Numeric_Value=1.000000000000000e+03}', "");
    Expect(0, 126237, '\p{Numeric_Value=1.000000000000000e+03}', "");
    Expect(1, 126237, '\p{^Numeric_Value=1.000000000000000e+03}', "");
    Expect(1, 126237, '\P{Numeric_Value=1.000000000000000e+03}', "");
    Expect(0, 126237, '\P{^Numeric_Value=1.000000000000000e+03}', "");
    Error('\p{Nv=	:=00000001000}');
    Error('\P{Nv=	:=00000001000}');
    Expect(1, 126236, '\p{Nv=:\A1000\z:}', "");;
    Expect(0, 126237, '\p{Nv=:\A1000\z:}', "");;
    Expect(1, 126236, '\p{Nv=+0000_0100_0}', "");
    Expect(0, 126236, '\p{^Nv=+0000_0100_0}', "");
    Expect(0, 126236, '\P{Nv=+0000_0100_0}', "");
    Expect(1, 126236, '\P{^Nv=+0000_0100_0}', "");
    Expect(0, 126237, '\p{Nv=+0000_0100_0}', "");
    Expect(1, 126237, '\p{^Nv=+0000_0100_0}', "");
    Expect(1, 126237, '\P{Nv=+0000_0100_0}', "");
    Expect(0, 126237, '\P{^Nv=+0000_0100_0}', "");
    Expect(1, 126236, '\p{Nv=1.000000000000000e+03}', "");
    Expect(0, 126236, '\p{^Nv=1.000000000000000e+03}', "");
    Expect(0, 126236, '\P{Nv=1.000000000000000e+03}', "");
    Expect(1, 126236, '\P{^Nv=1.000000000000000e+03}', "");
    Expect(0, 126237, '\p{Nv=1.000000000000000e+03}', "");
    Expect(1, 126237, '\p{^Nv=1.000000000000000e+03}', "");
    Expect(1, 126237, '\P{Nv=1.000000000000000e+03}', "");
    Expect(0, 126237, '\P{^Nv=1.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value: _:=0_0_0_0_0_1000}');
    Error('\P{Is_Numeric_Value: _:=0_0_0_0_0_1000}');
    Expect(1, 126236, '\p{Is_Numeric_Value=0000001000}', "");
    Expect(0, 126236, '\p{^Is_Numeric_Value=0000001000}', "");
    Expect(0, 126236, '\P{Is_Numeric_Value=0000001000}', "");
    Expect(1, 126236, '\P{^Is_Numeric_Value=0000001000}', "");
    Expect(0, 126237, '\p{Is_Numeric_Value=0000001000}', "");
    Expect(1, 126237, '\p{^Is_Numeric_Value=0000001000}', "");
    Expect(1, 126237, '\P{Is_Numeric_Value=0000001000}', "");
    Expect(0, 126237, '\P{^Is_Numeric_Value=0000001000}', "");
    Expect(1, 126236, '\p{Is_Numeric_Value=1.000000000000000e+03}', "");
    Expect(0, 126236, '\p{^Is_Numeric_Value=1.000000000000000e+03}', "");
    Expect(0, 126236, '\P{Is_Numeric_Value=1.000000000000000e+03}', "");
    Expect(1, 126236, '\P{^Is_Numeric_Value=1.000000000000000e+03}', "");
    Expect(0, 126237, '\p{Is_Numeric_Value=1.000000000000000e+03}', "");
    Expect(1, 126237, '\p{^Is_Numeric_Value=1.000000000000000e+03}', "");
    Expect(1, 126237, '\P{Is_Numeric_Value=1.000000000000000e+03}', "");
    Expect(0, 126237, '\P{^Is_Numeric_Value=1.000000000000000e+03}', "");
    Error('\p{Is_Nv=__0000001000:=}');
    Error('\P{Is_Nv=__0000001000:=}');
    Expect(1, 126236, '\p{Is_Nv=0001000}', "");
    Expect(0, 126236, '\p{^Is_Nv=0001000}', "");
    Expect(0, 126236, '\P{Is_Nv=0001000}', "");
    Expect(1, 126236, '\P{^Is_Nv=0001000}', "");
    Expect(0, 126237, '\p{Is_Nv=0001000}', "");
    Expect(1, 126237, '\p{^Is_Nv=0001000}', "");
    Expect(1, 126237, '\P{Is_Nv=0001000}', "");
    Expect(0, 126237, '\P{^Is_Nv=0001000}', "");
    Expect(1, 126236, '\p{Is_Nv=1.000000000000000e+03}', "");
    Expect(0, 126236, '\p{^Is_Nv=1.000000000000000e+03}', "");
    Expect(0, 126236, '\P{Is_Nv=1.000000000000000e+03}', "");
    Expect(1, 126236, '\P{^Is_Nv=1.000000000000000e+03}', "");
    Expect(0, 126237, '\p{Is_Nv=1.000000000000000e+03}', "");
    Expect(1, 126237, '\p{^Is_Nv=1.000000000000000e+03}', "");
    Expect(1, 126237, '\P{Is_Nv=1.000000000000000e+03}', "");
    Expect(0, 126237, '\P{^Is_Nv=1.000000000000000e+03}', "");
    Error('\p{Numeric_Value=:=000_100_00}');
    Error('\P{Numeric_Value=:=000_100_00}');
    Expect(1, 126267, '\p{Numeric_Value=:\A10000\z:}', "");;
    Expect(0, 126268, '\p{Numeric_Value=:\A10000\z:}', "");;
    Expect(1, 126267, '\p{Numeric_Value=+0000_0000_0100_00}', "");
    Expect(0, 126267, '\p{^Numeric_Value=+0000_0000_0100_00}', "");
    Expect(0, 126267, '\P{Numeric_Value=+0000_0000_0100_00}', "");
    Expect(1, 126267, '\P{^Numeric_Value=+0000_0000_0100_00}', "");
    Expect(0, 126268, '\p{Numeric_Value=+0000_0000_0100_00}', "");
    Expect(1, 126268, '\p{^Numeric_Value=+0000_0000_0100_00}', "");
    Expect(1, 126268, '\P{Numeric_Value=+0000_0000_0100_00}', "");
    Expect(0, 126268, '\P{^Numeric_Value=+0000_0000_0100_00}', "");
    Expect(1, 126267, '\p{Numeric_Value:   1.000000000000000e+04}', "");
    Expect(0, 126267, '\p{^Numeric_Value:   1.000000000000000e+04}', "");
    Expect(0, 126267, '\P{Numeric_Value:   1.000000000000000e+04}', "");
    Expect(1, 126267, '\P{^Numeric_Value:   1.000000000000000e+04}', "");
    Expect(0, 126268, '\p{Numeric_Value:   1.000000000000000e+04}', "");
    Expect(1, 126268, '\p{^Numeric_Value:   1.000000000000000e+04}', "");
    Expect(1, 126268, '\P{Numeric_Value:   1.000000000000000e+04}', "");
    Expect(0, 126268, '\P{^Numeric_Value:   1.000000000000000e+04}', "");
    Error('\p{Nv=_00_00_00_01_00_00:=}');
    Error('\P{Nv=_00_00_00_01_00_00:=}');
    Expect(1, 126267, '\p{Nv=:\A10000\z:}', "");;
    Expect(0, 126268, '\p{Nv=:\A10000\z:}', "");;
    Expect(1, 126267, '\p{Nv=+1_0_0_00}', "");
    Expect(0, 126267, '\p{^Nv=+1_0_0_00}', "");
    Expect(0, 126267, '\P{Nv=+1_0_0_00}', "");
    Expect(1, 126267, '\P{^Nv=+1_0_0_00}', "");
    Expect(0, 126268, '\p{Nv=+1_0_0_00}', "");
    Expect(1, 126268, '\p{^Nv=+1_0_0_00}', "");
    Expect(1, 126268, '\P{Nv=+1_0_0_00}', "");
    Expect(0, 126268, '\P{^Nv=+1_0_0_00}', "");
    Expect(1, 126267, '\p{Nv=1.000000000000000e+04}', "");
    Expect(0, 126267, '\p{^Nv=1.000000000000000e+04}', "");
    Expect(0, 126267, '\P{Nv=1.000000000000000e+04}', "");
    Expect(1, 126267, '\P{^Nv=1.000000000000000e+04}', "");
    Expect(0, 126268, '\p{Nv=1.000000000000000e+04}', "");
    Expect(1, 126268, '\p{^Nv=1.000000000000000e+04}', "");
    Expect(1, 126268, '\P{Nv=1.000000000000000e+04}', "");
    Expect(0, 126268, '\P{^Nv=1.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value:   :=  0_0_1_0_0_00}');
    Error('\P{Is_Numeric_Value:   :=  0_0_1_0_0_00}');
    Expect(1, 126267, '\p{Is_Numeric_Value=1000_0}', "");
    Expect(0, 126267, '\p{^Is_Numeric_Value=1000_0}', "");
    Expect(0, 126267, '\P{Is_Numeric_Value=1000_0}', "");
    Expect(1, 126267, '\P{^Is_Numeric_Value=1000_0}', "");
    Expect(0, 126268, '\p{Is_Numeric_Value=1000_0}', "");
    Expect(1, 126268, '\p{^Is_Numeric_Value=1000_0}', "");
    Expect(1, 126268, '\P{Is_Numeric_Value=1000_0}', "");
    Expect(0, 126268, '\P{^Is_Numeric_Value=1000_0}', "");
    Expect(1, 126267, '\p{Is_Numeric_Value=1.000000000000000e+04}', "");
    Expect(0, 126267, '\p{^Is_Numeric_Value=1.000000000000000e+04}', "");
    Expect(0, 126267, '\P{Is_Numeric_Value=1.000000000000000e+04}', "");
    Expect(1, 126267, '\P{^Is_Numeric_Value=1.000000000000000e+04}', "");
    Expect(0, 126268, '\p{Is_Numeric_Value=1.000000000000000e+04}', "");
    Expect(1, 126268, '\p{^Is_Numeric_Value=1.000000000000000e+04}', "");
    Expect(1, 126268, '\P{Is_Numeric_Value=1.000000000000000e+04}', "");
    Expect(0, 126268, '\P{^Is_Numeric_Value=1.000000000000000e+04}', "");
    Error('\p{Is_Nv=-00_10_00_0/a/}');
    Error('\P{Is_Nv=-00_10_00_0/a/}');
    Expect(1, 126267, '\p{Is_Nv=0_0_1_0_0_00}', "");
    Expect(0, 126267, '\p{^Is_Nv=0_0_1_0_0_00}', "");
    Expect(0, 126267, '\P{Is_Nv=0_0_1_0_0_00}', "");
    Expect(1, 126267, '\P{^Is_Nv=0_0_1_0_0_00}', "");
    Expect(0, 126268, '\p{Is_Nv=0_0_1_0_0_00}', "");
    Expect(1, 126268, '\p{^Is_Nv=0_0_1_0_0_00}', "");
    Expect(1, 126268, '\P{Is_Nv=0_0_1_0_0_00}', "");
    Expect(0, 126268, '\P{^Is_Nv=0_0_1_0_0_00}', "");
    Expect(1, 126267, '\p{Is_Nv=1.000000000000000e+04}', "");
    Expect(0, 126267, '\p{^Is_Nv=1.000000000000000e+04}', "");
    Expect(0, 126267, '\P{Is_Nv=1.000000000000000e+04}', "");
    Expect(1, 126267, '\P{^Is_Nv=1.000000000000000e+04}', "");
    Expect(0, 126268, '\p{Is_Nv=1.000000000000000e+04}', "");
    Expect(1, 126268, '\p{^Is_Nv=1.000000000000000e+04}', "");
    Expect(1, 126268, '\P{Is_Nv=1.000000000000000e+04}', "");
    Expect(0, 126268, '\P{^Is_Nv=1.000000000000000e+04}', "");
    Error('\p{Numeric_Value=:=_ 000_000_100_000}');
    Error('\P{Numeric_Value=:=_ 000_000_100_000}');
    Expect(1, 126132, '\p{Numeric_Value=:\A100000\z:}', "");;
    Expect(0, 126133, '\p{Numeric_Value=:\A100000\z:}', "");;
    Expect(1, 126132, '\p{Numeric_Value=+000100000}', "");
    Expect(0, 126132, '\p{^Numeric_Value=+000100000}', "");
    Expect(0, 126132, '\P{Numeric_Value=+000100000}', "");
    Expect(1, 126132, '\P{^Numeric_Value=+000100000}', "");
    Expect(0, 126133, '\p{Numeric_Value=+000100000}', "");
    Expect(1, 126133, '\p{^Numeric_Value=+000100000}', "");
    Expect(1, 126133, '\P{Numeric_Value=+000100000}', "");
    Expect(0, 126133, '\P{^Numeric_Value=+000100000}', "");
    Expect(1, 126132, '\p{Numeric_Value=1.000000000000000e+05}', "");
    Expect(0, 126132, '\p{^Numeric_Value=1.000000000000000e+05}', "");
    Expect(0, 126132, '\P{Numeric_Value=1.000000000000000e+05}', "");
    Expect(1, 126132, '\P{^Numeric_Value=1.000000000000000e+05}', "");
    Expect(0, 126133, '\p{Numeric_Value=1.000000000000000e+05}', "");
    Expect(1, 126133, '\p{^Numeric_Value=1.000000000000000e+05}', "");
    Expect(1, 126133, '\P{Numeric_Value=1.000000000000000e+05}', "");
    Expect(0, 126133, '\P{^Numeric_Value=1.000000000000000e+05}', "");
    Error('\p{Nv=/a/	_000100000}');
    Error('\P{Nv=/a/	_000100000}');
    Expect(1, 126132, '\p{Nv=:\A100000\z:}', "");;
    Expect(0, 126133, '\p{Nv=:\A100000\z:}', "");;
    Expect(1, 126132, '\p{Nv=0_0_0_0_0_0_0_100000}', "");
    Expect(0, 126132, '\p{^Nv=0_0_0_0_0_0_0_100000}', "");
    Expect(0, 126132, '\P{Nv=0_0_0_0_0_0_0_100000}', "");
    Expect(1, 126132, '\P{^Nv=0_0_0_0_0_0_0_100000}', "");
    Expect(0, 126133, '\p{Nv=0_0_0_0_0_0_0_100000}', "");
    Expect(1, 126133, '\p{^Nv=0_0_0_0_0_0_0_100000}', "");
    Expect(1, 126133, '\P{Nv=0_0_0_0_0_0_0_100000}', "");
    Expect(0, 126133, '\P{^Nv=0_0_0_0_0_0_0_100000}', "");
    Expect(1, 126132, '\p{Nv=1.000000000000000e+05}', "");
    Expect(0, 126132, '\p{^Nv=1.000000000000000e+05}', "");
    Expect(0, 126132, '\P{Nv=1.000000000000000e+05}', "");
    Expect(1, 126132, '\P{^Nv=1.000000000000000e+05}', "");
    Expect(0, 126133, '\p{Nv=1.000000000000000e+05}', "");
    Expect(1, 126133, '\p{^Nv=1.000000000000000e+05}', "");
    Expect(1, 126133, '\P{Nv=1.000000000000000e+05}', "");
    Expect(0, 126133, '\P{^Nv=1.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value: 	:=+000100000}');
    Error('\P{Is_Numeric_Value: 	:=+000100000}');
    Expect(1, 126132, '\p{Is_Numeric_Value=000000000100000}', "");
    Expect(0, 126132, '\p{^Is_Numeric_Value=000000000100000}', "");
    Expect(0, 126132, '\P{Is_Numeric_Value=000000000100000}', "");
    Expect(1, 126132, '\P{^Is_Numeric_Value=000000000100000}', "");
    Expect(0, 126133, '\p{Is_Numeric_Value=000000000100000}', "");
    Expect(1, 126133, '\p{^Is_Numeric_Value=000000000100000}', "");
    Expect(1, 126133, '\P{Is_Numeric_Value=000000000100000}', "");
    Expect(0, 126133, '\P{^Is_Numeric_Value=000000000100000}', "");
    Expect(1, 126132, '\p{Is_Numeric_Value=1.000000000000000e+05}', "");
    Expect(0, 126132, '\p{^Is_Numeric_Value=1.000000000000000e+05}', "");
    Expect(0, 126132, '\P{Is_Numeric_Value=1.000000000000000e+05}', "");
    Expect(1, 126132, '\P{^Is_Numeric_Value=1.000000000000000e+05}', "");
    Expect(0, 126133, '\p{Is_Numeric_Value=1.000000000000000e+05}', "");
    Expect(1, 126133, '\p{^Is_Numeric_Value=1.000000000000000e+05}', "");
    Expect(1, 126133, '\P{Is_Numeric_Value=1.000000000000000e+05}', "");
    Expect(0, 126133, '\P{^Is_Numeric_Value=1.000000000000000e+05}', "");
    Error('\p{Is_Nv:-	+000000000100000:=}');
    Error('\P{Is_Nv:-	+000000000100000:=}');
    Expect(1, 126132, '\p{Is_Nv=100000}', "");
    Expect(0, 126132, '\p{^Is_Nv=100000}', "");
    Expect(0, 126132, '\P{Is_Nv=100000}', "");
    Expect(1, 126132, '\P{^Is_Nv=100000}', "");
    Expect(0, 126133, '\p{Is_Nv=100000}', "");
    Expect(1, 126133, '\p{^Is_Nv=100000}', "");
    Expect(1, 126133, '\P{Is_Nv=100000}', "");
    Expect(0, 126133, '\P{^Is_Nv=100000}', "");
    Expect(1, 126132, '\p{Is_Nv=1.000000000000000e+05}', "");
    Expect(0, 126132, '\p{^Is_Nv=1.000000000000000e+05}', "");
    Expect(0, 126132, '\P{Is_Nv=1.000000000000000e+05}', "");
    Expect(1, 126132, '\P{^Is_Nv=1.000000000000000e+05}', "");
    Expect(0, 126133, '\p{Is_Nv=1.000000000000000e+05}', "");
    Expect(1, 126133, '\p{^Is_Nv=1.000000000000000e+05}', "");
    Expect(1, 126133, '\P{Is_Nv=1.000000000000000e+05}', "");
    Expect(0, 126133, '\P{^Is_Nv=1.000000000000000e+05}', "");
    Error('\p{Numeric_Value=:=01000000}');
    Error('\P{Numeric_Value=:=01000000}');
    Expect(1, 93022, '\p{Numeric_Value=:\A1000000\z:}', "");;
    Expect(0, 93023, '\p{Numeric_Value=:\A1000000\z:}', "");;
    Expect(1, 93022, '\p{Numeric_Value=10_00_00_0}', "");
    Expect(0, 93022, '\p{^Numeric_Value=10_00_00_0}', "");
    Expect(0, 93022, '\P{Numeric_Value=10_00_00_0}', "");
    Expect(1, 93022, '\P{^Numeric_Value=10_00_00_0}', "");
    Expect(0, 93023, '\p{Numeric_Value=10_00_00_0}', "");
    Expect(1, 93023, '\p{^Numeric_Value=10_00_00_0}', "");
    Expect(1, 93023, '\P{Numeric_Value=10_00_00_0}', "");
    Expect(0, 93023, '\P{^Numeric_Value=10_00_00_0}', "");
    Expect(1, 93022, '\p{Numeric_Value=1.000000000000000e+06}', "");
    Expect(0, 93022, '\p{^Numeric_Value=1.000000000000000e+06}', "");
    Expect(0, 93022, '\P{Numeric_Value=1.000000000000000e+06}', "");
    Expect(1, 93022, '\P{^Numeric_Value=1.000000000000000e+06}', "");
    Expect(0, 93023, '\p{Numeric_Value=1.000000000000000e+06}', "");
    Expect(1, 93023, '\p{^Numeric_Value=1.000000000000000e+06}', "");
    Expect(1, 93023, '\P{Numeric_Value=1.000000000000000e+06}', "");
    Expect(0, 93023, '\P{^Numeric_Value=1.000000000000000e+06}', "");
    Error('\p{Nv=-_0000001000000:=}');
    Error('\P{Nv=-_0000001000000:=}');
    Expect(1, 93022, '\p{Nv=:\A1000000\z:}', "");;
    Expect(0, 93023, '\p{Nv=:\A1000000\z:}', "");;
    Expect(1, 93022, '\p{Nv=00_00_00_10_00_000}', "");
    Expect(0, 93022, '\p{^Nv=00_00_00_10_00_000}', "");
    Expect(0, 93022, '\P{Nv=00_00_00_10_00_000}', "");
    Expect(1, 93022, '\P{^Nv=00_00_00_10_00_000}', "");
    Expect(0, 93023, '\p{Nv=00_00_00_10_00_000}', "");
    Expect(1, 93023, '\p{^Nv=00_00_00_10_00_000}', "");
    Expect(1, 93023, '\P{Nv=00_00_00_10_00_000}', "");
    Expect(0, 93023, '\P{^Nv=00_00_00_10_00_000}', "");
    Expect(1, 93022, '\p{Nv=1.000000000000000e+06}', "");
    Expect(0, 93022, '\p{^Nv=1.000000000000000e+06}', "");
    Expect(0, 93022, '\P{Nv=1.000000000000000e+06}', "");
    Expect(1, 93022, '\P{^Nv=1.000000000000000e+06}', "");
    Expect(0, 93023, '\p{Nv=1.000000000000000e+06}', "");
    Expect(1, 93023, '\p{^Nv=1.000000000000000e+06}', "");
    Expect(1, 93023, '\P{Nv=1.000000000000000e+06}', "");
    Expect(0, 93023, '\P{^Nv=1.000000000000000e+06}', "");
    Error('\p{Is_Numeric_Value= _0000000001000000/a/}');
    Error('\P{Is_Numeric_Value= _0000000001000000/a/}');
    Expect(1, 93022, '\p{Is_Numeric_Value:	0_0_0_1_0_00000}', "");
    Expect(0, 93022, '\p{^Is_Numeric_Value:	0_0_0_1_0_00000}', "");
    Expect(0, 93022, '\P{Is_Numeric_Value:	0_0_0_1_0_00000}', "");
    Expect(1, 93022, '\P{^Is_Numeric_Value:	0_0_0_1_0_00000}', "");
    Expect(0, 93023, '\p{Is_Numeric_Value:	0_0_0_1_0_00000}', "");
    Expect(1, 93023, '\p{^Is_Numeric_Value:	0_0_0_1_0_00000}', "");
    Expect(1, 93023, '\P{Is_Numeric_Value:	0_0_0_1_0_00000}', "");
    Expect(0, 93023, '\P{^Is_Numeric_Value:	0_0_0_1_0_00000}', "");
    Expect(1, 93022, '\p{Is_Numeric_Value=1.000000000000000e+06}', "");
    Expect(0, 93022, '\p{^Is_Numeric_Value=1.000000000000000e+06}', "");
    Expect(0, 93022, '\P{Is_Numeric_Value=1.000000000000000e+06}', "");
    Expect(1, 93022, '\P{^Is_Numeric_Value=1.000000000000000e+06}', "");
    Expect(0, 93023, '\p{Is_Numeric_Value=1.000000000000000e+06}', "");
    Expect(1, 93023, '\p{^Is_Numeric_Value=1.000000000000000e+06}', "");
    Expect(1, 93023, '\P{Is_Numeric_Value=1.000000000000000e+06}', "");
    Expect(0, 93023, '\P{^Is_Numeric_Value=1.000000000000000e+06}', "");
    Error('\p{Is_Nv=/a/+00_00_00_00_10_00_000}');
    Error('\P{Is_Nv=/a/+00_00_00_00_10_00_000}');
    Expect(1, 93022, '\p{Is_Nv=+000_100_000_0}', "");
    Expect(0, 93022, '\p{^Is_Nv=+000_100_000_0}', "");
    Expect(0, 93022, '\P{Is_Nv=+000_100_000_0}', "");
    Expect(1, 93022, '\P{^Is_Nv=+000_100_000_0}', "");
    Expect(0, 93023, '\p{Is_Nv=+000_100_000_0}', "");
    Expect(1, 93023, '\p{^Is_Nv=+000_100_000_0}', "");
    Expect(1, 93023, '\P{Is_Nv=+000_100_000_0}', "");
    Expect(0, 93023, '\P{^Is_Nv=+000_100_000_0}', "");
    Expect(1, 93022, '\p{Is_Nv=1.000000000000000e+06}', "");
    Expect(0, 93022, '\p{^Is_Nv=1.000000000000000e+06}', "");
    Expect(0, 93022, '\P{Is_Nv=1.000000000000000e+06}', "");
    Expect(1, 93022, '\P{^Is_Nv=1.000000000000000e+06}', "");
    Expect(0, 93023, '\p{Is_Nv=1.000000000000000e+06}', "");
    Expect(1, 93023, '\p{^Is_Nv=1.000000000000000e+06}', "");
    Expect(1, 93023, '\P{Is_Nv=1.000000000000000e+06}', "");
    Expect(0, 93023, '\P{^Is_Nv=1.000000000000000e+06}', "");
    Error('\p{Numeric_Value=/a/  00000010000000}');
    Error('\P{Numeric_Value=/a/  00000010000000}');
    Expect(1, 126113, '\p{Numeric_Value=:\A10000000\z:}', "");;
    Expect(0, 126114, '\p{Numeric_Value=:\A10000000\z:}', "");;
    Expect(1, 126113, '\p{Numeric_Value=000000010000000}', "");
    Expect(0, 126113, '\p{^Numeric_Value=000000010000000}', "");
    Expect(0, 126113, '\P{Numeric_Value=000000010000000}', "");
    Expect(1, 126113, '\P{^Numeric_Value=000000010000000}', "");
    Expect(0, 126114, '\p{Numeric_Value=000000010000000}', "");
    Expect(1, 126114, '\p{^Numeric_Value=000000010000000}', "");
    Expect(1, 126114, '\P{Numeric_Value=000000010000000}', "");
    Expect(0, 126114, '\P{^Numeric_Value=000000010000000}', "");
    Expect(1, 126113, '\p{Numeric_Value:	1.000000000000000e+07}', "");
    Expect(0, 126113, '\p{^Numeric_Value:	1.000000000000000e+07}', "");
    Expect(0, 126113, '\P{Numeric_Value:	1.000000000000000e+07}', "");
    Expect(1, 126113, '\P{^Numeric_Value:	1.000000000000000e+07}', "");
    Expect(0, 126114, '\p{Numeric_Value:	1.000000000000000e+07}', "");
    Expect(1, 126114, '\p{^Numeric_Value:	1.000000000000000e+07}', "");
    Expect(1, 126114, '\P{Numeric_Value:	1.000000000000000e+07}', "");
    Expect(0, 126114, '\P{^Numeric_Value:	1.000000000000000e+07}', "");
    Error('\p{Nv=_/a/0000010000000}');
    Error('\P{Nv=_/a/0000010000000}');
    Expect(1, 126113, '\p{Nv=:\A10000000\z:}', "");;
    Expect(0, 126114, '\p{Nv=:\A10000000\z:}', "");;
    Expect(1, 126113, '\p{Nv:1000000_0}', "");
    Expect(0, 126113, '\p{^Nv:1000000_0}', "");
    Expect(0, 126113, '\P{Nv:1000000_0}', "");
    Expect(1, 126113, '\P{^Nv:1000000_0}', "");
    Expect(0, 126114, '\p{Nv:1000000_0}', "");
    Expect(1, 126114, '\p{^Nv:1000000_0}', "");
    Expect(1, 126114, '\P{Nv:1000000_0}', "");
    Expect(0, 126114, '\P{^Nv:1000000_0}', "");
    Expect(1, 126113, '\p{Nv=1.000000000000000e+07}', "");
    Expect(0, 126113, '\p{^Nv=1.000000000000000e+07}', "");
    Expect(0, 126113, '\P{Nv=1.000000000000000e+07}', "");
    Expect(1, 126113, '\P{^Nv=1.000000000000000e+07}', "");
    Expect(0, 126114, '\p{Nv=1.000000000000000e+07}', "");
    Expect(1, 126114, '\p{^Nv=1.000000000000000e+07}', "");
    Expect(1, 126114, '\P{Nv=1.000000000000000e+07}', "");
    Expect(0, 126114, '\P{^Nv=1.000000000000000e+07}', "");
    Error('\p{Is_Numeric_Value=-/a/000000010000000}');
    Error('\P{Is_Numeric_Value=-/a/000000010000000}');
    Expect(1, 126113, '\p{Is_Numeric_Value=0_0_0_0_0_0_0_0_1_0_0_0_0_0_00}', "");
    Expect(0, 126113, '\p{^Is_Numeric_Value=0_0_0_0_0_0_0_0_1_0_0_0_0_0_00}', "");
    Expect(0, 126113, '\P{Is_Numeric_Value=0_0_0_0_0_0_0_0_1_0_0_0_0_0_00}', "");
    Expect(1, 126113, '\P{^Is_Numeric_Value=0_0_0_0_0_0_0_0_1_0_0_0_0_0_00}', "");
    Expect(0, 126114, '\p{Is_Numeric_Value=0_0_0_0_0_0_0_0_1_0_0_0_0_0_00}', "");
    Expect(1, 126114, '\p{^Is_Numeric_Value=0_0_0_0_0_0_0_0_1_0_0_0_0_0_00}', "");
    Expect(1, 126114, '\P{Is_Numeric_Value=0_0_0_0_0_0_0_0_1_0_0_0_0_0_00}', "");
    Expect(0, 126114, '\P{^Is_Numeric_Value=0_0_0_0_0_0_0_0_1_0_0_0_0_0_00}', "");
    Expect(1, 126113, '\p{Is_Numeric_Value=1.000000000000000e+07}', "");
    Expect(0, 126113, '\p{^Is_Numeric_Value=1.000000000000000e+07}', "");
    Expect(0, 126113, '\P{Is_Numeric_Value=1.000000000000000e+07}', "");
    Expect(1, 126113, '\P{^Is_Numeric_Value=1.000000000000000e+07}', "");
    Expect(0, 126114, '\p{Is_Numeric_Value=1.000000000000000e+07}', "");
    Expect(1, 126114, '\p{^Is_Numeric_Value=1.000000000000000e+07}', "");
    Expect(1, 126114, '\P{Is_Numeric_Value=1.000000000000000e+07}', "");
    Expect(0, 126114, '\P{^Is_Numeric_Value=1.000000000000000e+07}', "");
    Error('\p{Is_Nv=-000_001_000_000_0:=}');
    Error('\P{Is_Nv=-000_001_000_000_0:=}');
    Expect(1, 126113, '\p{Is_Nv=0010000000}', "");
    Expect(0, 126113, '\p{^Is_Nv=0010000000}', "");
    Expect(0, 126113, '\P{Is_Nv=0010000000}', "");
    Expect(1, 126113, '\P{^Is_Nv=0010000000}', "");
    Expect(0, 126114, '\p{Is_Nv=0010000000}', "");
    Expect(1, 126114, '\p{^Is_Nv=0010000000}', "");
    Expect(1, 126114, '\P{Is_Nv=0010000000}', "");
    Expect(0, 126114, '\P{^Is_Nv=0010000000}', "");
    Expect(1, 126113, '\p{Is_Nv=1.000000000000000e+07}', "");
    Expect(0, 126113, '\p{^Is_Nv=1.000000000000000e+07}', "");
    Expect(0, 126113, '\P{Is_Nv=1.000000000000000e+07}', "");
    Expect(1, 126113, '\P{^Is_Nv=1.000000000000000e+07}', "");
    Expect(0, 126114, '\p{Is_Nv=1.000000000000000e+07}', "");
    Expect(1, 126114, '\p{^Is_Nv=1.000000000000000e+07}', "");
    Expect(1, 126114, '\P{Is_Nv=1.000000000000000e+07}', "");
    Expect(0, 126114, '\P{^Is_Nv=1.000000000000000e+07}', "");
    Error('\p{Numeric_Value=/a/ -000000100000000}');
    Error('\P{Numeric_Value=/a/ -000000100000000}');
    Expect(1, 93023, '\p{Numeric_Value=:\A100000000\z:}', "");;
    Expect(0, 93024, '\p{Numeric_Value=:\A100000000\z:}', "");;
    Expect(1, 93023, '\p{Numeric_Value=0100000000}', "");
    Expect(0, 93023, '\p{^Numeric_Value=0100000000}', "");
    Expect(0, 93023, '\P{Numeric_Value=0100000000}', "");
    Expect(1, 93023, '\P{^Numeric_Value=0100000000}', "");
    Expect(0, 93024, '\p{Numeric_Value=0100000000}', "");
    Expect(1, 93024, '\p{^Numeric_Value=0100000000}', "");
    Expect(1, 93024, '\P{Numeric_Value=0100000000}', "");
    Expect(0, 93024, '\P{^Numeric_Value=0100000000}', "");
    Expect(1, 93023, '\p{Numeric_Value=1.000000000000000e+08}', "");
    Expect(0, 93023, '\p{^Numeric_Value=1.000000000000000e+08}', "");
    Expect(0, 93023, '\P{Numeric_Value=1.000000000000000e+08}', "");
    Expect(1, 93023, '\P{^Numeric_Value=1.000000000000000e+08}', "");
    Expect(0, 93024, '\p{Numeric_Value=1.000000000000000e+08}', "");
    Expect(1, 93024, '\p{^Numeric_Value=1.000000000000000e+08}', "");
    Expect(1, 93024, '\P{Numeric_Value=1.000000000000000e+08}', "");
    Expect(0, 93024, '\P{^Numeric_Value=1.000000000000000e+08}', "");
    Error('\p{Nv=/a/	000100000000}');
    Error('\P{Nv=/a/	000100000000}');
    Expect(1, 93023, '\p{Nv=:\A100000000\z:}', "");;
    Expect(0, 93024, '\p{Nv=:\A100000000\z:}', "");;
    Expect(1, 93023, '\p{Nv=+00_00_10_00_00_000}', "");
    Expect(0, 93023, '\p{^Nv=+00_00_10_00_00_000}', "");
    Expect(0, 93023, '\P{Nv=+00_00_10_00_00_000}', "");
    Expect(1, 93023, '\P{^Nv=+00_00_10_00_00_000}', "");
    Expect(0, 93024, '\p{Nv=+00_00_10_00_00_000}', "");
    Expect(1, 93024, '\p{^Nv=+00_00_10_00_00_000}', "");
    Expect(1, 93024, '\P{Nv=+00_00_10_00_00_000}', "");
    Expect(0, 93024, '\P{^Nv=+00_00_10_00_00_000}', "");
    Expect(1, 93023, '\p{Nv=1.000000000000000e+08}', "");
    Expect(0, 93023, '\p{^Nv=1.000000000000000e+08}', "");
    Expect(0, 93023, '\P{Nv=1.000000000000000e+08}', "");
    Expect(1, 93023, '\P{^Nv=1.000000000000000e+08}', "");
    Expect(0, 93024, '\p{Nv=1.000000000000000e+08}', "");
    Expect(1, 93024, '\p{^Nv=1.000000000000000e+08}', "");
    Expect(1, 93024, '\P{Nv=1.000000000000000e+08}', "");
    Expect(0, 93024, '\P{^Nv=1.000000000000000e+08}', "");
    Error('\p{Is_Numeric_Value:	:=		+0100_0000_00}');
    Error('\P{Is_Numeric_Value:	:=		+0100_0000_00}');
    Expect(1, 93023, '\p{Is_Numeric_Value=+00_00_00_00_01_00_00_00_00}', "");
    Expect(0, 93023, '\p{^Is_Numeric_Value=+00_00_00_00_01_00_00_00_00}', "");
    Expect(0, 93023, '\P{Is_Numeric_Value=+00_00_00_00_01_00_00_00_00}', "");
    Expect(1, 93023, '\P{^Is_Numeric_Value=+00_00_00_00_01_00_00_00_00}', "");
    Expect(0, 93024, '\p{Is_Numeric_Value=+00_00_00_00_01_00_00_00_00}', "");
    Expect(1, 93024, '\p{^Is_Numeric_Value=+00_00_00_00_01_00_00_00_00}', "");
    Expect(1, 93024, '\P{Is_Numeric_Value=+00_00_00_00_01_00_00_00_00}', "");
    Expect(0, 93024, '\P{^Is_Numeric_Value=+00_00_00_00_01_00_00_00_00}', "");
    Expect(1, 93023, '\p{Is_Numeric_Value=1.000000000000000e+08}', "");
    Expect(0, 93023, '\p{^Is_Numeric_Value=1.000000000000000e+08}', "");
    Expect(0, 93023, '\P{Is_Numeric_Value=1.000000000000000e+08}', "");
    Expect(1, 93023, '\P{^Is_Numeric_Value=1.000000000000000e+08}', "");
    Expect(0, 93024, '\p{Is_Numeric_Value=1.000000000000000e+08}', "");
    Expect(1, 93024, '\p{^Is_Numeric_Value=1.000000000000000e+08}', "");
    Expect(1, 93024, '\P{Is_Numeric_Value=1.000000000000000e+08}', "");
    Expect(0, 93024, '\P{^Is_Numeric_Value=1.000000000000000e+08}', "");
    Error('\p{Is_Nv=/a/000100000000}');
    Error('\P{Is_Nv=/a/000100000000}');
    Expect(1, 93023, '\p{Is_Nv=+00_01_00_00_00_00}', "");
    Expect(0, 93023, '\p{^Is_Nv=+00_01_00_00_00_00}', "");
    Expect(0, 93023, '\P{Is_Nv=+00_01_00_00_00_00}', "");
    Expect(1, 93023, '\P{^Is_Nv=+00_01_00_00_00_00}', "");
    Expect(0, 93024, '\p{Is_Nv=+00_01_00_00_00_00}', "");
    Expect(1, 93024, '\p{^Is_Nv=+00_01_00_00_00_00}', "");
    Expect(1, 93024, '\P{Is_Nv=+00_01_00_00_00_00}', "");
    Expect(0, 93024, '\P{^Is_Nv=+00_01_00_00_00_00}', "");
    Expect(1, 93023, '\p{Is_Nv:1.000000000000000e+08}', "");
    Expect(0, 93023, '\p{^Is_Nv:1.000000000000000e+08}', "");
    Expect(0, 93023, '\P{Is_Nv:1.000000000000000e+08}', "");
    Expect(1, 93023, '\P{^Is_Nv:1.000000000000000e+08}', "");
    Expect(0, 93024, '\p{Is_Nv:1.000000000000000e+08}', "");
    Expect(1, 93024, '\p{^Is_Nv:1.000000000000000e+08}', "");
    Expect(1, 93024, '\P{Is_Nv:1.000000000000000e+08}', "");
    Expect(0, 93024, '\P{^Is_Nv:1.000000000000000e+08}', "");
    Error('\p{Numeric_Value=/a/__00_00_00_00_01_00_00_000000}');
    Error('\P{Numeric_Value=/a/__00_00_00_00_01_00_00_000000}');
    Expect(1, 93024, '\p{Numeric_Value=:\A10000000000\z:}', "");;
    Expect(0, 93025, '\p{Numeric_Value=:\A10000000000\z:}', "");;
    Expect(1, 93024, '\p{Numeric_Value=10000000000}', "");
    Expect(0, 93024, '\p{^Numeric_Value=10000000000}', "");
    Expect(0, 93024, '\P{Numeric_Value=10000000000}', "");
    Expect(1, 93024, '\P{^Numeric_Value=10000000000}', "");
    Expect(0, 93025, '\p{Numeric_Value=10000000000}', "");
    Expect(1, 93025, '\p{^Numeric_Value=10000000000}', "");
    Expect(1, 93025, '\P{Numeric_Value=10000000000}', "");
    Expect(0, 93025, '\P{^Numeric_Value=10000000000}', "");
    Expect(1, 93024, '\p{Numeric_Value=1.000000000000000e+10}', "");
    Expect(0, 93024, '\p{^Numeric_Value=1.000000000000000e+10}', "");
    Expect(0, 93024, '\P{Numeric_Value=1.000000000000000e+10}', "");
    Expect(1, 93024, '\P{^Numeric_Value=1.000000000000000e+10}', "");
    Expect(0, 93025, '\p{Numeric_Value=1.000000000000000e+10}', "");
    Expect(1, 93025, '\p{^Numeric_Value=1.000000000000000e+10}', "");
    Expect(1, 93025, '\P{Numeric_Value=1.000000000000000e+10}', "");
    Expect(0, 93025, '\P{^Numeric_Value=1.000000000000000e+10}', "");
    Error('\p{Nv=	/a/+0_0_1_0_0_0_0_000000}');
    Error('\P{Nv=	/a/+0_0_1_0_0_0_0_000000}');
    Expect(1, 93024, '\p{Nv=:\A10000000000\z:}', "");;
    Expect(0, 93025, '\p{Nv=:\A10000000000\z:}', "");;
    Expect(1, 93024, '\p{Nv=0_0_0_1_0_0_0_0_0_0_0_000}', "");
    Expect(0, 93024, '\p{^Nv=0_0_0_1_0_0_0_0_0_0_0_000}', "");
    Expect(0, 93024, '\P{Nv=0_0_0_1_0_0_0_0_0_0_0_000}', "");
    Expect(1, 93024, '\P{^Nv=0_0_0_1_0_0_0_0_0_0_0_000}', "");
    Expect(0, 93025, '\p{Nv=0_0_0_1_0_0_0_0_0_0_0_000}', "");
    Expect(1, 93025, '\p{^Nv=0_0_0_1_0_0_0_0_0_0_0_000}', "");
    Expect(1, 93025, '\P{Nv=0_0_0_1_0_0_0_0_0_0_0_000}', "");
    Expect(0, 93025, '\P{^Nv=0_0_0_1_0_0_0_0_0_0_0_000}', "");
    Expect(1, 93024, '\p{Nv=1.000000000000000e+10}', "");
    Expect(0, 93024, '\p{^Nv=1.000000000000000e+10}', "");
    Expect(0, 93024, '\P{Nv=1.000000000000000e+10}', "");
    Expect(1, 93024, '\P{^Nv=1.000000000000000e+10}', "");
    Expect(0, 93025, '\p{Nv=1.000000000000000e+10}', "");
    Expect(1, 93025, '\p{^Nv=1.000000000000000e+10}', "");
    Expect(1, 93025, '\P{Nv=1.000000000000000e+10}', "");
    Expect(0, 93025, '\P{^Nv=1.000000000000000e+10}', "");
    Error('\p{Is_Numeric_Value= /a/1000000000_0}');
    Error('\P{Is_Numeric_Value= /a/1000000000_0}');
    Expect(1, 93024, '\p{Is_Numeric_Value=1_0_0_0_0_0_0_0000}', "");
    Expect(0, 93024, '\p{^Is_Numeric_Value=1_0_0_0_0_0_0_0000}', "");
    Expect(0, 93024, '\P{Is_Numeric_Value=1_0_0_0_0_0_0_0000}', "");
    Expect(1, 93024, '\P{^Is_Numeric_Value=1_0_0_0_0_0_0_0000}', "");
    Expect(0, 93025, '\p{Is_Numeric_Value=1_0_0_0_0_0_0_0000}', "");
    Expect(1, 93025, '\p{^Is_Numeric_Value=1_0_0_0_0_0_0_0000}', "");
    Expect(1, 93025, '\P{Is_Numeric_Value=1_0_0_0_0_0_0_0000}', "");
    Expect(0, 93025, '\P{^Is_Numeric_Value=1_0_0_0_0_0_0_0000}', "");
    Expect(1, 93024, '\p{Is_Numeric_Value=1.000000000000000e+10}', "");
    Expect(0, 93024, '\p{^Is_Numeric_Value=1.000000000000000e+10}', "");
    Expect(0, 93024, '\P{Is_Numeric_Value=1.000000000000000e+10}', "");
    Expect(1, 93024, '\P{^Is_Numeric_Value=1.000000000000000e+10}', "");
    Expect(0, 93025, '\p{Is_Numeric_Value=1.000000000000000e+10}', "");
    Expect(1, 93025, '\p{^Is_Numeric_Value=1.000000000000000e+10}', "");
    Expect(1, 93025, '\P{Is_Numeric_Value=1.000000000000000e+10}', "");
    Expect(0, 93025, '\P{^Is_Numeric_Value=1.000000000000000e+10}', "");
    Error('\p{Is_Nv:-_010000000000:=}');
    Error('\P{Is_Nv:-_010000000000:=}');
    Expect(1, 93024, '\p{Is_Nv:	000010000000000}', "");
    Expect(0, 93024, '\p{^Is_Nv:	000010000000000}', "");
    Expect(0, 93024, '\P{Is_Nv:	000010000000000}', "");
    Expect(1, 93024, '\P{^Is_Nv:	000010000000000}', "");
    Expect(0, 93025, '\p{Is_Nv:	000010000000000}', "");
    Expect(1, 93025, '\p{^Is_Nv:	000010000000000}', "");
    Expect(1, 93025, '\P{Is_Nv:	000010000000000}', "");
    Expect(0, 93025, '\P{^Is_Nv:	000010000000000}', "");
    Expect(1, 93024, '\p{Is_Nv=1.000000000000000e+10}', "");
    Expect(0, 93024, '\p{^Is_Nv=1.000000000000000e+10}', "");
    Expect(0, 93024, '\P{Is_Nv=1.000000000000000e+10}', "");
    Expect(1, 93024, '\P{^Is_Nv=1.000000000000000e+10}', "");
    Expect(0, 93025, '\p{Is_Nv=1.000000000000000e+10}', "");
    Expect(1, 93025, '\p{^Is_Nv=1.000000000000000e+10}', "");
    Expect(1, 93025, '\P{Is_Nv=1.000000000000000e+10}', "");
    Expect(0, 93025, '\P{^Is_Nv=1.000000000000000e+10}', "");
    Error('\p{Numeric_Value=  0_0_0_0_1_0_0_0_0_0_0_0_0_0000/a/}');
    Error('\P{Numeric_Value=  0_0_0_0_1_0_0_0_0_0_0_0_0_0000/a/}');
    Expect(1, 93025, '\p{Numeric_Value=:\A1000000000000\z:}', "");;
    Expect(0, 93026, '\p{Numeric_Value=:\A1000000000000\z:}', "");;
    Expect(1, 93025, '\p{Numeric_Value:   +0_0_0_0_1_0_0_0_0_00000000}', "");
    Expect(0, 93025, '\p{^Numeric_Value:   +0_0_0_0_1_0_0_0_0_00000000}', "");
    Expect(0, 93025, '\P{Numeric_Value:   +0_0_0_0_1_0_0_0_0_00000000}', "");
    Expect(1, 93025, '\P{^Numeric_Value:   +0_0_0_0_1_0_0_0_0_00000000}', "");
    Expect(0, 93026, '\p{Numeric_Value:   +0_0_0_0_1_0_0_0_0_00000000}', "");
    Expect(1, 93026, '\p{^Numeric_Value:   +0_0_0_0_1_0_0_0_0_00000000}', "");
    Expect(1, 93026, '\P{Numeric_Value:   +0_0_0_0_1_0_0_0_0_00000000}', "");
    Expect(0, 93026, '\P{^Numeric_Value:   +0_0_0_0_1_0_0_0_0_00000000}', "");
    Expect(1, 93025, '\p{Numeric_Value=1.000000000000000e+12}', "");
    Expect(0, 93025, '\p{^Numeric_Value=1.000000000000000e+12}', "");
    Expect(0, 93025, '\P{Numeric_Value=1.000000000000000e+12}', "");
    Expect(1, 93025, '\P{^Numeric_Value=1.000000000000000e+12}', "");
    Expect(0, 93026, '\p{Numeric_Value=1.000000000000000e+12}', "");
    Expect(1, 93026, '\p{^Numeric_Value=1.000000000000000e+12}', "");
    Expect(1, 93026, '\P{Numeric_Value=1.000000000000000e+12}', "");
    Expect(0, 93026, '\P{^Numeric_Value=1.000000000000000e+12}', "");
    Error('\p{Nv:	_ 000000001000000000000:=}');
    Error('\P{Nv:	_ 000000001000000000000:=}');
    Expect(1, 93025, '\p{Nv=:\A1000000000000\z:}', "");;
    Expect(0, 93026, '\p{Nv=:\A1000000000000\z:}', "");;
    Expect(1, 93025, '\p{Nv: 000000100000000000_0}', "");
    Expect(0, 93025, '\p{^Nv: 000000100000000000_0}', "");
    Expect(0, 93025, '\P{Nv: 000000100000000000_0}', "");
    Expect(1, 93025, '\P{^Nv: 000000100000000000_0}', "");
    Expect(0, 93026, '\p{Nv: 000000100000000000_0}', "");
    Expect(1, 93026, '\p{^Nv: 000000100000000000_0}', "");
    Expect(1, 93026, '\P{Nv: 000000100000000000_0}', "");
    Expect(0, 93026, '\P{^Nv: 000000100000000000_0}', "");
    Expect(1, 93025, '\p{Nv=1.000000000000000e+12}', "");
    Expect(0, 93025, '\p{^Nv=1.000000000000000e+12}', "");
    Expect(0, 93025, '\P{Nv=1.000000000000000e+12}', "");
    Expect(1, 93025, '\P{^Nv=1.000000000000000e+12}', "");
    Expect(0, 93026, '\p{Nv=1.000000000000000e+12}', "");
    Expect(1, 93026, '\p{^Nv=1.000000000000000e+12}', "");
    Expect(1, 93026, '\P{Nv=1.000000000000000e+12}', "");
    Expect(0, 93026, '\P{^Nv=1.000000000000000e+12}', "");
    Error('\p{Is_Numeric_Value:   	00000001000000000000:=}');
    Error('\P{Is_Numeric_Value:   	00000001000000000000:=}');
    Expect(1, 93025, '\p{Is_Numeric_Value=+000_100_000_000_0000}', "");
    Expect(0, 93025, '\p{^Is_Numeric_Value=+000_100_000_000_0000}', "");
    Expect(0, 93025, '\P{Is_Numeric_Value=+000_100_000_000_0000}', "");
    Expect(1, 93025, '\P{^Is_Numeric_Value=+000_100_000_000_0000}', "");
    Expect(0, 93026, '\p{Is_Numeric_Value=+000_100_000_000_0000}', "");
    Expect(1, 93026, '\p{^Is_Numeric_Value=+000_100_000_000_0000}', "");
    Expect(1, 93026, '\P{Is_Numeric_Value=+000_100_000_000_0000}', "");
    Expect(0, 93026, '\P{^Is_Numeric_Value=+000_100_000_000_0000}', "");
    Expect(1, 93025, '\p{Is_Numeric_Value=1.000000000000000e+12}', "");
    Expect(0, 93025, '\p{^Is_Numeric_Value=1.000000000000000e+12}', "");
    Expect(0, 93025, '\P{Is_Numeric_Value=1.000000000000000e+12}', "");
    Expect(1, 93025, '\P{^Is_Numeric_Value=1.000000000000000e+12}', "");
    Expect(0, 93026, '\p{Is_Numeric_Value=1.000000000000000e+12}', "");
    Expect(1, 93026, '\p{^Is_Numeric_Value=1.000000000000000e+12}', "");
    Expect(1, 93026, '\P{Is_Numeric_Value=1.000000000000000e+12}', "");
    Expect(0, 93026, '\P{^Is_Numeric_Value=1.000000000000000e+12}', "");
    Error('\p{Is_Nv=/a/	-+0_1_0_0_0_0_0_0_0_00000}');
    Error('\P{Is_Nv=/a/	-+0_1_0_0_0_0_0_0_0_00000}');
    Expect(1, 93025, '\p{Is_Nv=0_0_0_0_0_0_0_0_1_0_0_0_0_0_0_0_0_0_000}', "");
    Expect(0, 93025, '\p{^Is_Nv=0_0_0_0_0_0_0_0_1_0_0_0_0_0_0_0_0_0_000}', "");
    Expect(0, 93025, '\P{Is_Nv=0_0_0_0_0_0_0_0_1_0_0_0_0_0_0_0_0_0_000}', "");
    Expect(1, 93025, '\P{^Is_Nv=0_0_0_0_0_0_0_0_1_0_0_0_0_0_0_0_0_0_000}', "");
    Expect(0, 93026, '\p{Is_Nv=0_0_0_0_0_0_0_0_1_0_0_0_0_0_0_0_0_0_000}', "");
    Expect(1, 93026, '\p{^Is_Nv=0_0_0_0_0_0_0_0_1_0_0_0_0_0_0_0_0_0_000}', "");
    Expect(1, 93026, '\P{Is_Nv=0_0_0_0_0_0_0_0_1_0_0_0_0_0_0_0_0_0_000}', "");
    Expect(0, 93026, '\P{^Is_Nv=0_0_0_0_0_0_0_0_1_0_0_0_0_0_0_0_0_0_000}', "");
    Expect(1, 93025, '\p{Is_Nv=1.000000000000000e+12}', "");
    Expect(0, 93025, '\p{^Is_Nv=1.000000000000000e+12}', "");
    Expect(0, 93025, '\P{Is_Nv=1.000000000000000e+12}', "");
    Expect(1, 93025, '\P{^Is_Nv=1.000000000000000e+12}', "");
    Expect(0, 93026, '\p{Is_Nv=1.000000000000000e+12}', "");
    Expect(1, 93026, '\p{^Is_Nv=1.000000000000000e+12}', "");
    Expect(1, 93026, '\P{Is_Nv=1.000000000000000e+12}', "");
    Expect(0, 93026, '\P{^Is_Nv=1.000000000000000e+12}', "");
    Error('\p{Numeric_Value:   -:=001_1}');
    Error('\P{Numeric_Value:   -:=001_1}');
    Expect(1, 119531, '\p{Numeric_Value=:\A11\z:}', "");;
    Expect(0, 119532, '\p{Numeric_Value=:\A11\z:}', "");;
    Expect(1, 119531, '\p{Numeric_Value=0000001_1}', "");
    Expect(0, 119531, '\p{^Numeric_Value=0000001_1}', "");
    Expect(0, 119531, '\P{Numeric_Value=0000001_1}', "");
    Expect(1, 119531, '\P{^Numeric_Value=0000001_1}', "");
    Expect(0, 119532, '\p{Numeric_Value=0000001_1}', "");
    Expect(1, 119532, '\p{^Numeric_Value=0000001_1}', "");
    Expect(1, 119532, '\P{Numeric_Value=0000001_1}', "");
    Expect(0, 119532, '\P{^Numeric_Value=0000001_1}', "");
    Expect(1, 119531, '\p{Numeric_Value=1.100000000000000e+01}', "");
    Expect(0, 119531, '\p{^Numeric_Value=1.100000000000000e+01}', "");
    Expect(0, 119531, '\P{Numeric_Value=1.100000000000000e+01}', "");
    Expect(1, 119531, '\P{^Numeric_Value=1.100000000000000e+01}', "");
    Expect(0, 119532, '\p{Numeric_Value=1.100000000000000e+01}', "");
    Expect(1, 119532, '\p{^Numeric_Value=1.100000000000000e+01}', "");
    Expect(1, 119532, '\P{Numeric_Value=1.100000000000000e+01}', "");
    Expect(0, 119532, '\P{^Numeric_Value=1.100000000000000e+01}', "");
    Error('\p{Nv=/a/- 0_0_0_0_0_0011}');
    Error('\P{Nv=/a/- 0_0_0_0_0_0011}');
    Expect(1, 119531, '\p{Nv=:\A11\z:}', "");;
    Expect(0, 119532, '\p{Nv=:\A11\z:}', "");;
    Expect(1, 119531, '\p{Nv=11}', "");
    Expect(0, 119531, '\p{^Nv=11}', "");
    Expect(0, 119531, '\P{Nv=11}', "");
    Expect(1, 119531, '\P{^Nv=11}', "");
    Expect(0, 119532, '\p{Nv=11}', "");
    Expect(1, 119532, '\p{^Nv=11}', "");
    Expect(1, 119532, '\P{Nv=11}', "");
    Expect(0, 119532, '\P{^Nv=11}', "");
    Expect(1, 119531, '\p{Nv=1.100000000000000e+01}', "");
    Expect(0, 119531, '\p{^Nv=1.100000000000000e+01}', "");
    Expect(0, 119531, '\P{Nv=1.100000000000000e+01}', "");
    Expect(1, 119531, '\P{^Nv=1.100000000000000e+01}', "");
    Expect(0, 119532, '\p{Nv=1.100000000000000e+01}', "");
    Expect(1, 119532, '\p{^Nv=1.100000000000000e+01}', "");
    Expect(1, 119532, '\P{Nv=1.100000000000000e+01}', "");
    Expect(0, 119532, '\P{^Nv=1.100000000000000e+01}', "");
    Error('\p{Is_Numeric_Value= 00_01_1/a/}');
    Error('\P{Is_Numeric_Value= 00_01_1/a/}');
    Expect(1, 119531, '\p{Is_Numeric_Value:	0_0_0_0_0_11}', "");
    Expect(0, 119531, '\p{^Is_Numeric_Value:	0_0_0_0_0_11}', "");
    Expect(0, 119531, '\P{Is_Numeric_Value:	0_0_0_0_0_11}', "");
    Expect(1, 119531, '\P{^Is_Numeric_Value:	0_0_0_0_0_11}', "");
    Expect(0, 119532, '\p{Is_Numeric_Value:	0_0_0_0_0_11}', "");
    Expect(1, 119532, '\p{^Is_Numeric_Value:	0_0_0_0_0_11}', "");
    Expect(1, 119532, '\P{Is_Numeric_Value:	0_0_0_0_0_11}', "");
    Expect(0, 119532, '\P{^Is_Numeric_Value:	0_0_0_0_0_11}', "");
    Expect(1, 119531, '\p{Is_Numeric_Value=1.100000000000000e+01}', "");
    Expect(0, 119531, '\p{^Is_Numeric_Value=1.100000000000000e+01}', "");
    Expect(0, 119531, '\P{Is_Numeric_Value=1.100000000000000e+01}', "");
    Expect(1, 119531, '\P{^Is_Numeric_Value=1.100000000000000e+01}', "");
    Expect(0, 119532, '\p{Is_Numeric_Value=1.100000000000000e+01}', "");
    Expect(1, 119532, '\p{^Is_Numeric_Value=1.100000000000000e+01}', "");
    Expect(1, 119532, '\P{Is_Numeric_Value=1.100000000000000e+01}', "");
    Expect(0, 119532, '\P{^Is_Numeric_Value=1.100000000000000e+01}', "");
    Error('\p{Is_Nv= 0000011/a/}');
    Error('\P{Is_Nv= 0000011/a/}');
    Expect(1, 119531, '\p{Is_Nv: 000000011}', "");
    Expect(0, 119531, '\p{^Is_Nv: 000000011}', "");
    Expect(0, 119531, '\P{Is_Nv: 000000011}', "");
    Expect(1, 119531, '\P{^Is_Nv: 000000011}', "");
    Expect(0, 119532, '\p{Is_Nv: 000000011}', "");
    Expect(1, 119532, '\p{^Is_Nv: 000000011}', "");
    Expect(1, 119532, '\P{Is_Nv: 000000011}', "");
    Expect(0, 119532, '\P{^Is_Nv: 000000011}', "");
    Expect(1, 119531, '\p{Is_Nv=1.100000000000000e+01}', "");
    Expect(0, 119531, '\p{^Is_Nv=1.100000000000000e+01}', "");
    Expect(0, 119531, '\P{Is_Nv=1.100000000000000e+01}', "");
    Expect(1, 119531, '\P{^Is_Nv=1.100000000000000e+01}', "");
    Expect(0, 119532, '\p{Is_Nv=1.100000000000000e+01}', "");
    Expect(1, 119532, '\p{^Is_Nv=1.100000000000000e+01}', "");
    Expect(1, 119532, '\P{Is_Nv=1.100000000000000e+01}', "");
    Expect(0, 119532, '\P{^Is_Nv=1.100000000000000e+01}', "");
    Error('\p{Numeric_Value=-+0011/000000012/a/}');
    Error('\P{Numeric_Value=-+0011/000000012/a/}');
    Expect(1, 68028, '\p{Numeric_Value=:\A11/12\z:}', "");;
    Expect(0, 68029, '\p{Numeric_Value=:\A11/12\z:}', "");;
    Expect(1, 68028, '\p{Numeric_Value=+000011/0000000012}', "");
    Expect(0, 68028, '\p{^Numeric_Value=+000011/0000000012}', "");
    Expect(0, 68028, '\P{Numeric_Value=+000011/0000000012}', "");
    Expect(1, 68028, '\P{^Numeric_Value=+000011/0000000012}', "");
    Expect(0, 68029, '\p{Numeric_Value=+000011/0000000012}', "");
    Expect(1, 68029, '\p{^Numeric_Value=+000011/0000000012}', "");
    Expect(1, 68029, '\P{Numeric_Value=+000011/0000000012}', "");
    Expect(0, 68029, '\P{^Numeric_Value=+000011/0000000012}', "");
    Expect(1, 68028, '\p{Numeric_Value=660/720}', "");
    Expect(0, 68028, '\p{^Numeric_Value=660/720}', "");
    Expect(0, 68028, '\P{Numeric_Value=660/720}', "");
    Expect(1, 68028, '\P{^Numeric_Value=660/720}', "");
    Expect(0, 68029, '\p{Numeric_Value=660/720}', "");
    Expect(1, 68029, '\p{^Numeric_Value=660/720}', "");
    Expect(1, 68029, '\P{Numeric_Value=660/720}', "");
    Expect(0, 68029, '\P{^Numeric_Value=660/720}', "");
    Error('\p{Numeric_Value=9.2e-01}');
    Error('\P{Numeric_Value=9.2e-01}');
    Error('\p{Numeric_Value=0.9}');
    Error('\P{Numeric_Value=0.9}');
    Expect(1, 68028, '\p{Numeric_Value=9.17e-01}', "");
    Expect(0, 68028, '\p{^Numeric_Value=9.17e-01}', "");
    Expect(0, 68028, '\P{Numeric_Value=9.17e-01}', "");
    Expect(1, 68028, '\P{^Numeric_Value=9.17e-01}', "");
    Expect(0, 68029, '\p{Numeric_Value=9.17e-01}', "");
    Expect(1, 68029, '\p{^Numeric_Value=9.17e-01}', "");
    Expect(1, 68029, '\P{Numeric_Value=9.17e-01}', "");
    Expect(0, 68029, '\P{^Numeric_Value=9.17e-01}', "");
    Error('\p{Numeric_Value:	0.92}');
    Error('\P{Numeric_Value:	0.92}');
    Expect(1, 68028, '\p{Numeric_Value=9.167e-01}', "");
    Expect(0, 68028, '\p{^Numeric_Value=9.167e-01}', "");
    Expect(0, 68028, '\P{Numeric_Value=9.167e-01}', "");
    Expect(1, 68028, '\P{^Numeric_Value=9.167e-01}', "");
    Expect(0, 68029, '\p{Numeric_Value=9.167e-01}', "");
    Expect(1, 68029, '\p{^Numeric_Value=9.167e-01}', "");
    Expect(1, 68029, '\P{Numeric_Value=9.167e-01}', "");
    Expect(0, 68029, '\P{^Numeric_Value=9.167e-01}', "");
    Expect(1, 68028, '\p{Numeric_Value=0.917}', "");
    Expect(0, 68028, '\p{^Numeric_Value=0.917}', "");
    Expect(0, 68028, '\P{Numeric_Value=0.917}', "");
    Expect(1, 68028, '\P{^Numeric_Value=0.917}', "");
    Expect(0, 68029, '\p{Numeric_Value=0.917}', "");
    Expect(1, 68029, '\p{^Numeric_Value=0.917}', "");
    Expect(1, 68029, '\P{Numeric_Value=0.917}', "");
    Expect(0, 68029, '\P{^Numeric_Value=0.917}', "");
    Expect(1, 68028, '\p{Numeric_Value=9.1667e-01}', "");
    Expect(0, 68028, '\p{^Numeric_Value=9.1667e-01}', "");
    Expect(0, 68028, '\P{Numeric_Value=9.1667e-01}', "");
    Expect(1, 68028, '\P{^Numeric_Value=9.1667e-01}', "");
    Expect(0, 68029, '\p{Numeric_Value=9.1667e-01}', "");
    Expect(1, 68029, '\p{^Numeric_Value=9.1667e-01}', "");
    Expect(1, 68029, '\P{Numeric_Value=9.1667e-01}', "");
    Expect(0, 68029, '\P{^Numeric_Value=9.1667e-01}', "");
    Expect(1, 68028, '\p{Numeric_Value=0.9167}', "");
    Expect(0, 68028, '\p{^Numeric_Value=0.9167}', "");
    Expect(0, 68028, '\P{Numeric_Value=0.9167}', "");
    Expect(1, 68028, '\P{^Numeric_Value=0.9167}', "");
    Expect(0, 68029, '\p{Numeric_Value=0.9167}', "");
    Expect(1, 68029, '\p{^Numeric_Value=0.9167}', "");
    Expect(1, 68029, '\P{Numeric_Value=0.9167}', "");
    Expect(0, 68029, '\P{^Numeric_Value=0.9167}', "");
    Error('\p{Nv= :=0011/0012}');
    Error('\P{Nv= :=0011/0012}');
    Expect(1, 68028, '\p{Nv=:\A11/12\z:}', "");;
    Expect(0, 68029, '\p{Nv=:\A11/12\z:}', "");;
    Expect(1, 68028, '\p{Nv:   0000000011/0000000012}', "");
    Expect(0, 68028, '\p{^Nv:   0000000011/0000000012}', "");
    Expect(0, 68028, '\P{Nv:   0000000011/0000000012}', "");
    Expect(1, 68028, '\P{^Nv:   0000000011/0000000012}', "");
    Expect(0, 68029, '\p{Nv:   0000000011/0000000012}', "");
    Expect(1, 68029, '\p{^Nv:   0000000011/0000000012}', "");
    Expect(1, 68029, '\P{Nv:   0000000011/0000000012}', "");
    Expect(0, 68029, '\P{^Nv:   0000000011/0000000012}', "");
    Expect(1, 68028, '\p{Nv=660/720}', "");
    Expect(0, 68028, '\p{^Nv=660/720}', "");
    Expect(0, 68028, '\P{Nv=660/720}', "");
    Expect(1, 68028, '\P{^Nv=660/720}', "");
    Expect(0, 68029, '\p{Nv=660/720}', "");
    Expect(1, 68029, '\p{^Nv=660/720}', "");
    Expect(1, 68029, '\P{Nv=660/720}', "");
    Expect(0, 68029, '\P{^Nv=660/720}', "");
    Error('\p{Nv=9.2e-01}');
    Error('\P{Nv=9.2e-01}');
    Error('\p{Nv:0.9}');
    Error('\P{Nv:0.9}');
    Expect(1, 68028, '\p{Nv=9.17e-01}', "");
    Expect(0, 68028, '\p{^Nv=9.17e-01}', "");
    Expect(0, 68028, '\P{Nv=9.17e-01}', "");
    Expect(1, 68028, '\P{^Nv=9.17e-01}', "");
    Expect(0, 68029, '\p{Nv=9.17e-01}', "");
    Expect(1, 68029, '\p{^Nv=9.17e-01}', "");
    Expect(1, 68029, '\P{Nv=9.17e-01}', "");
    Expect(0, 68029, '\P{^Nv=9.17e-01}', "");
    Error('\p{Nv=0.92}');
    Error('\P{Nv=0.92}');
    Expect(1, 68028, '\p{Nv=9.167e-01}', "");
    Expect(0, 68028, '\p{^Nv=9.167e-01}', "");
    Expect(0, 68028, '\P{Nv=9.167e-01}', "");
    Expect(1, 68028, '\P{^Nv=9.167e-01}', "");
    Expect(0, 68029, '\p{Nv=9.167e-01}', "");
    Expect(1, 68029, '\p{^Nv=9.167e-01}', "");
    Expect(1, 68029, '\P{Nv=9.167e-01}', "");
    Expect(0, 68029, '\P{^Nv=9.167e-01}', "");
    Expect(1, 68028, '\p{Nv=0.917}', "");
    Expect(0, 68028, '\p{^Nv=0.917}', "");
    Expect(0, 68028, '\P{Nv=0.917}', "");
    Expect(1, 68028, '\P{^Nv=0.917}', "");
    Expect(0, 68029, '\p{Nv=0.917}', "");
    Expect(1, 68029, '\p{^Nv=0.917}', "");
    Expect(1, 68029, '\P{Nv=0.917}', "");
    Expect(0, 68029, '\P{^Nv=0.917}', "");
    Expect(1, 68028, '\p{Nv=9.1667e-01}', "");
    Expect(0, 68028, '\p{^Nv=9.1667e-01}', "");
    Expect(0, 68028, '\P{Nv=9.1667e-01}', "");
    Expect(1, 68028, '\P{^Nv=9.1667e-01}', "");
    Expect(0, 68029, '\p{Nv=9.1667e-01}', "");
    Expect(1, 68029, '\p{^Nv=9.1667e-01}', "");
    Expect(1, 68029, '\P{Nv=9.1667e-01}', "");
    Expect(0, 68029, '\P{^Nv=9.1667e-01}', "");
    Expect(1, 68028, '\p{Nv=0.9167}', "");
    Expect(0, 68028, '\p{^Nv=0.9167}', "");
    Expect(0, 68028, '\P{Nv=0.9167}', "");
    Expect(1, 68028, '\P{^Nv=0.9167}', "");
    Expect(0, 68029, '\p{Nv=0.9167}', "");
    Expect(1, 68029, '\p{^Nv=0.9167}', "");
    Expect(1, 68029, '\P{Nv=0.9167}', "");
    Expect(0, 68029, '\P{^Nv=0.9167}', "");
    Error('\p{Is_Numeric_Value=	:=+000011/000012}');
    Error('\P{Is_Numeric_Value=	:=+000011/000012}');
    Expect(1, 68028, '\p{Is_Numeric_Value=00000000011/000012}', "");
    Expect(0, 68028, '\p{^Is_Numeric_Value=00000000011/000012}', "");
    Expect(0, 68028, '\P{Is_Numeric_Value=00000000011/000012}', "");
    Expect(1, 68028, '\P{^Is_Numeric_Value=00000000011/000012}', "");
    Expect(0, 68029, '\p{Is_Numeric_Value=00000000011/000012}', "");
    Expect(1, 68029, '\p{^Is_Numeric_Value=00000000011/000012}', "");
    Expect(1, 68029, '\P{Is_Numeric_Value=00000000011/000012}', "");
    Expect(0, 68029, '\P{^Is_Numeric_Value=00000000011/000012}', "");
    Expect(1, 68028, '\p{Is_Numeric_Value=660/720}', "");
    Expect(0, 68028, '\p{^Is_Numeric_Value=660/720}', "");
    Expect(0, 68028, '\P{Is_Numeric_Value=660/720}', "");
    Expect(1, 68028, '\P{^Is_Numeric_Value=660/720}', "");
    Expect(0, 68029, '\p{Is_Numeric_Value=660/720}', "");
    Expect(1, 68029, '\p{^Is_Numeric_Value=660/720}', "");
    Expect(1, 68029, '\P{Is_Numeric_Value=660/720}', "");
    Expect(0, 68029, '\P{^Is_Numeric_Value=660/720}', "");
    Error('\p{Is_Numeric_Value=9.2e-01}');
    Error('\P{Is_Numeric_Value=9.2e-01}');
    Error('\p{Is_Numeric_Value=0.9}');
    Error('\P{Is_Numeric_Value=0.9}');
    Expect(1, 68028, '\p{Is_Numeric_Value=9.17e-01}', "");
    Expect(0, 68028, '\p{^Is_Numeric_Value=9.17e-01}', "");
    Expect(0, 68028, '\P{Is_Numeric_Value=9.17e-01}', "");
    Expect(1, 68028, '\P{^Is_Numeric_Value=9.17e-01}', "");
    Expect(0, 68029, '\p{Is_Numeric_Value=9.17e-01}', "");
    Expect(1, 68029, '\p{^Is_Numeric_Value=9.17e-01}', "");
    Expect(1, 68029, '\P{Is_Numeric_Value=9.17e-01}', "");
    Expect(0, 68029, '\P{^Is_Numeric_Value=9.17e-01}', "");
    Error('\p{Is_Numeric_Value=0.92}');
    Error('\P{Is_Numeric_Value=0.92}');
    Expect(1, 68028, '\p{Is_Numeric_Value=9.167e-01}', "");
    Expect(0, 68028, '\p{^Is_Numeric_Value=9.167e-01}', "");
    Expect(0, 68028, '\P{Is_Numeric_Value=9.167e-01}', "");
    Expect(1, 68028, '\P{^Is_Numeric_Value=9.167e-01}', "");
    Expect(0, 68029, '\p{Is_Numeric_Value=9.167e-01}', "");
    Expect(1, 68029, '\p{^Is_Numeric_Value=9.167e-01}', "");
    Expect(1, 68029, '\P{Is_Numeric_Value=9.167e-01}', "");
    Expect(0, 68029, '\P{^Is_Numeric_Value=9.167e-01}', "");
    Expect(1, 68028, '\p{Is_Numeric_Value=0.917}', "");
    Expect(0, 68028, '\p{^Is_Numeric_Value=0.917}', "");
    Expect(0, 68028, '\P{Is_Numeric_Value=0.917}', "");
    Expect(1, 68028, '\P{^Is_Numeric_Value=0.917}', "");
    Expect(0, 68029, '\p{Is_Numeric_Value=0.917}', "");
    Expect(1, 68029, '\p{^Is_Numeric_Value=0.917}', "");
    Expect(1, 68029, '\P{Is_Numeric_Value=0.917}', "");
    Expect(0, 68029, '\P{^Is_Numeric_Value=0.917}', "");
    Expect(1, 68028, '\p{Is_Numeric_Value=9.1667e-01}', "");
    Expect(0, 68028, '\p{^Is_Numeric_Value=9.1667e-01}', "");
    Expect(0, 68028, '\P{Is_Numeric_Value=9.1667e-01}', "");
    Expect(1, 68028, '\P{^Is_Numeric_Value=9.1667e-01}', "");
    Expect(0, 68029, '\p{Is_Numeric_Value=9.1667e-01}', "");
    Expect(1, 68029, '\p{^Is_Numeric_Value=9.1667e-01}', "");
    Expect(1, 68029, '\P{Is_Numeric_Value=9.1667e-01}', "");
    Expect(0, 68029, '\P{^Is_Numeric_Value=9.1667e-01}', "");
    Expect(1, 68028, '\p{Is_Numeric_Value:0.9167}', "");
    Expect(0, 68028, '\p{^Is_Numeric_Value:0.9167}', "");
    Expect(0, 68028, '\P{Is_Numeric_Value:0.9167}', "");
    Expect(1, 68028, '\P{^Is_Numeric_Value:0.9167}', "");
    Expect(0, 68029, '\p{Is_Numeric_Value:0.9167}', "");
    Expect(1, 68029, '\p{^Is_Numeric_Value:0.9167}', "");
    Expect(1, 68029, '\P{Is_Numeric_Value:0.9167}', "");
    Expect(0, 68029, '\P{^Is_Numeric_Value:0.9167}', "");
    Error('\p{Is_Nv=/a/0000000011/0012}');
    Error('\P{Is_Nv=/a/0000000011/0012}');
    Expect(1, 68028, '\p{Is_Nv=0000000011/12}', "");
    Expect(0, 68028, '\p{^Is_Nv=0000000011/12}', "");
    Expect(0, 68028, '\P{Is_Nv=0000000011/12}', "");
    Expect(1, 68028, '\P{^Is_Nv=0000000011/12}', "");
    Expect(0, 68029, '\p{Is_Nv=0000000011/12}', "");
    Expect(1, 68029, '\p{^Is_Nv=0000000011/12}', "");
    Expect(1, 68029, '\P{Is_Nv=0000000011/12}', "");
    Expect(0, 68029, '\P{^Is_Nv=0000000011/12}', "");
    Expect(1, 68028, '\p{Is_Nv=660/720}', "");
    Expect(0, 68028, '\p{^Is_Nv=660/720}', "");
    Expect(0, 68028, '\P{Is_Nv=660/720}', "");
    Expect(1, 68028, '\P{^Is_Nv=660/720}', "");
    Expect(0, 68029, '\p{Is_Nv=660/720}', "");
    Expect(1, 68029, '\p{^Is_Nv=660/720}', "");
    Expect(1, 68029, '\P{Is_Nv=660/720}', "");
    Expect(0, 68029, '\P{^Is_Nv=660/720}', "");
    Error('\p{Is_Nv=9.2e-01}');
    Error('\P{Is_Nv=9.2e-01}');
    Error('\p{Is_Nv=0.9}');
    Error('\P{Is_Nv=0.9}');
    Expect(1, 68028, '\p{Is_Nv=9.17e-01}', "");
    Expect(0, 68028, '\p{^Is_Nv=9.17e-01}', "");
    Expect(0, 68028, '\P{Is_Nv=9.17e-01}', "");
    Expect(1, 68028, '\P{^Is_Nv=9.17e-01}', "");
    Expect(0, 68029, '\p{Is_Nv=9.17e-01}', "");
    Expect(1, 68029, '\p{^Is_Nv=9.17e-01}', "");
    Expect(1, 68029, '\P{Is_Nv=9.17e-01}', "");
    Expect(0, 68029, '\P{^Is_Nv=9.17e-01}', "");
    Error('\p{Is_Nv=0.92}');
    Error('\P{Is_Nv=0.92}');
    Expect(1, 68028, '\p{Is_Nv:   9.167e-01}', "");
    Expect(0, 68028, '\p{^Is_Nv:   9.167e-01}', "");
    Expect(0, 68028, '\P{Is_Nv:   9.167e-01}', "");
    Expect(1, 68028, '\P{^Is_Nv:   9.167e-01}', "");
    Expect(0, 68029, '\p{Is_Nv:   9.167e-01}', "");
    Expect(1, 68029, '\p{^Is_Nv:   9.167e-01}', "");
    Expect(1, 68029, '\P{Is_Nv:   9.167e-01}', "");
    Expect(0, 68029, '\P{^Is_Nv:   9.167e-01}', "");
    Expect(1, 68028, '\p{Is_Nv=0.917}', "");
    Expect(0, 68028, '\p{^Is_Nv=0.917}', "");
    Expect(0, 68028, '\P{Is_Nv=0.917}', "");
    Expect(1, 68028, '\P{^Is_Nv=0.917}', "");
    Expect(0, 68029, '\p{Is_Nv=0.917}', "");
    Expect(1, 68029, '\p{^Is_Nv=0.917}', "");
    Expect(1, 68029, '\P{Is_Nv=0.917}', "");
    Expect(0, 68029, '\P{^Is_Nv=0.917}', "");
    Expect(1, 68028, '\p{Is_Nv=9.1667e-01}', "");
    Expect(0, 68028, '\p{^Is_Nv=9.1667e-01}', "");
    Expect(0, 68028, '\P{Is_Nv=9.1667e-01}', "");
    Expect(1, 68028, '\P{^Is_Nv=9.1667e-01}', "");
    Expect(0, 68029, '\p{Is_Nv=9.1667e-01}', "");
    Expect(1, 68029, '\p{^Is_Nv=9.1667e-01}', "");
    Expect(1, 68029, '\P{Is_Nv=9.1667e-01}', "");
    Expect(0, 68029, '\P{^Is_Nv=9.1667e-01}', "");
    Expect(1, 68028, '\p{Is_Nv: 0.9167}', "");
    Expect(0, 68028, '\p{^Is_Nv: 0.9167}', "");
    Expect(0, 68028, '\P{Is_Nv: 0.9167}', "");
    Expect(1, 68028, '\P{^Is_Nv: 0.9167}', "");
    Expect(0, 68029, '\p{Is_Nv: 0.9167}', "");
    Expect(1, 68029, '\p{^Is_Nv: 0.9167}', "");
    Expect(1, 68029, '\P{Is_Nv: 0.9167}', "");
    Expect(0, 68029, '\P{^Is_Nv: 0.9167}', "");
    Error('\p{Numeric_Value: /a/ +11/0002}');
    Error('\P{Numeric_Value: /a/ +11/0002}');
    Expect(1, 3887, '\p{Numeric_Value=:\A11/2\z:}', "");;
    Expect(0, 3888, '\p{Numeric_Value=:\A11/2\z:}', "");;
    Expect(1, 3887, '\p{Numeric_Value=000000011/0002}', "");
    Expect(0, 3887, '\p{^Numeric_Value=000000011/0002}', "");
    Expect(0, 3887, '\P{Numeric_Value=000000011/0002}', "");
    Expect(1, 3887, '\P{^Numeric_Value=000000011/0002}', "");
    Expect(0, 3888, '\p{Numeric_Value=000000011/0002}', "");
    Expect(1, 3888, '\p{^Numeric_Value=000000011/0002}', "");
    Expect(1, 3888, '\P{Numeric_Value=000000011/0002}', "");
    Expect(0, 3888, '\P{^Numeric_Value=000000011/0002}', "");
    Expect(1, 3887, '\p{Numeric_Value=660/120}', "");
    Expect(0, 3887, '\p{^Numeric_Value=660/120}', "");
    Expect(0, 3887, '\P{Numeric_Value=660/120}', "");
    Expect(1, 3887, '\P{^Numeric_Value=660/120}', "");
    Expect(0, 3888, '\p{Numeric_Value=660/120}', "");
    Expect(1, 3888, '\p{^Numeric_Value=660/120}', "");
    Expect(1, 3888, '\P{Numeric_Value=660/120}', "");
    Expect(0, 3888, '\P{^Numeric_Value=660/120}', "");
    Expect(1, 3887, '\p{Numeric_Value=5.5e+00}', "");
    Expect(0, 3887, '\p{^Numeric_Value=5.5e+00}', "");
    Expect(0, 3887, '\P{Numeric_Value=5.5e+00}', "");
    Expect(1, 3887, '\P{^Numeric_Value=5.5e+00}', "");
    Expect(0, 3888, '\p{Numeric_Value=5.5e+00}', "");
    Expect(1, 3888, '\p{^Numeric_Value=5.5e+00}', "");
    Expect(1, 3888, '\P{Numeric_Value=5.5e+00}', "");
    Expect(0, 3888, '\P{^Numeric_Value=5.5e+00}', "");
    Expect(1, 3887, '\p{Numeric_Value=5.5}', "");
    Expect(0, 3887, '\p{^Numeric_Value=5.5}', "");
    Expect(0, 3887, '\P{Numeric_Value=5.5}', "");
    Expect(1, 3887, '\P{^Numeric_Value=5.5}', "");
    Expect(0, 3888, '\p{Numeric_Value=5.5}', "");
    Expect(1, 3888, '\p{^Numeric_Value=5.5}', "");
    Expect(1, 3888, '\P{Numeric_Value=5.5}', "");
    Expect(0, 3888, '\P{^Numeric_Value=5.5}', "");
    Expect(1, 3887, '\p{Numeric_Value=5.50e+00}', "");
    Expect(0, 3887, '\p{^Numeric_Value=5.50e+00}', "");
    Expect(0, 3887, '\P{Numeric_Value=5.50e+00}', "");
    Expect(1, 3887, '\P{^Numeric_Value=5.50e+00}', "");
    Expect(0, 3888, '\p{Numeric_Value=5.50e+00}', "");
    Expect(1, 3888, '\p{^Numeric_Value=5.50e+00}', "");
    Expect(1, 3888, '\P{Numeric_Value=5.50e+00}', "");
    Expect(0, 3888, '\P{^Numeric_Value=5.50e+00}', "");
    Expect(1, 3887, '\p{Numeric_Value=5.50}', "");
    Expect(0, 3887, '\p{^Numeric_Value=5.50}', "");
    Expect(0, 3887, '\P{Numeric_Value=5.50}', "");
    Expect(1, 3887, '\P{^Numeric_Value=5.50}', "");
    Expect(0, 3888, '\p{Numeric_Value=5.50}', "");
    Expect(1, 3888, '\p{^Numeric_Value=5.50}', "");
    Expect(1, 3888, '\P{Numeric_Value=5.50}', "");
    Expect(0, 3888, '\P{^Numeric_Value=5.50}', "");
    Error('\p{Nv= :=00011/000002}');
    Error('\P{Nv= :=00011/000002}');
    Expect(1, 3887, '\p{Nv=:\A11/2\z:}', "");;
    Expect(0, 3888, '\p{Nv=:\A11/2\z:}', "");;
    Expect(1, 3887, '\p{Nv=0011/02}', "");
    Expect(0, 3887, '\p{^Nv=0011/02}', "");
    Expect(0, 3887, '\P{Nv=0011/02}', "");
    Expect(1, 3887, '\P{^Nv=0011/02}', "");
    Expect(0, 3888, '\p{Nv=0011/02}', "");
    Expect(1, 3888, '\p{^Nv=0011/02}', "");
    Expect(1, 3888, '\P{Nv=0011/02}', "");
    Expect(0, 3888, '\P{^Nv=0011/02}', "");
    Expect(1, 3887, '\p{Nv=660/120}', "");
    Expect(0, 3887, '\p{^Nv=660/120}', "");
    Expect(0, 3887, '\P{Nv=660/120}', "");
    Expect(1, 3887, '\P{^Nv=660/120}', "");
    Expect(0, 3888, '\p{Nv=660/120}', "");
    Expect(1, 3888, '\p{^Nv=660/120}', "");
    Expect(1, 3888, '\P{Nv=660/120}', "");
    Expect(0, 3888, '\P{^Nv=660/120}', "");
    Expect(1, 3887, '\p{Nv=5.5e+00}', "");
    Expect(0, 3887, '\p{^Nv=5.5e+00}', "");
    Expect(0, 3887, '\P{Nv=5.5e+00}', "");
    Expect(1, 3887, '\P{^Nv=5.5e+00}', "");
    Expect(0, 3888, '\p{Nv=5.5e+00}', "");
    Expect(1, 3888, '\p{^Nv=5.5e+00}', "");
    Expect(1, 3888, '\P{Nv=5.5e+00}', "");
    Expect(0, 3888, '\P{^Nv=5.5e+00}', "");
    Expect(1, 3887, '\p{Nv=5.5}', "");
    Expect(0, 3887, '\p{^Nv=5.5}', "");
    Expect(0, 3887, '\P{Nv=5.5}', "");
    Expect(1, 3887, '\P{^Nv=5.5}', "");
    Expect(0, 3888, '\p{Nv=5.5}', "");
    Expect(1, 3888, '\p{^Nv=5.5}', "");
    Expect(1, 3888, '\P{Nv=5.5}', "");
    Expect(0, 3888, '\P{^Nv=5.5}', "");
    Expect(1, 3887, '\p{Nv=5.50e+00}', "");
    Expect(0, 3887, '\p{^Nv=5.50e+00}', "");
    Expect(0, 3887, '\P{Nv=5.50e+00}', "");
    Expect(1, 3887, '\P{^Nv=5.50e+00}', "");
    Expect(0, 3888, '\p{Nv=5.50e+00}', "");
    Expect(1, 3888, '\p{^Nv=5.50e+00}', "");
    Expect(1, 3888, '\P{Nv=5.50e+00}', "");
    Expect(0, 3888, '\P{^Nv=5.50e+00}', "");
    Expect(1, 3887, '\p{Nv=5.50}', "");
    Expect(0, 3887, '\p{^Nv=5.50}', "");
    Expect(0, 3887, '\P{Nv=5.50}', "");
    Expect(1, 3887, '\P{^Nv=5.50}', "");
    Expect(0, 3888, '\p{Nv=5.50}', "");
    Expect(1, 3888, '\p{^Nv=5.50}', "");
    Expect(1, 3888, '\P{Nv=5.50}', "");
    Expect(0, 3888, '\P{^Nv=5.50}', "");
    Error('\p{Is_Numeric_Value=	11/02/a/}');
    Error('\P{Is_Numeric_Value=	11/02/a/}');
    Expect(1, 3887, '\p{Is_Numeric_Value=+00000000011/000000002}', "");
    Expect(0, 3887, '\p{^Is_Numeric_Value=+00000000011/000000002}', "");
    Expect(0, 3887, '\P{Is_Numeric_Value=+00000000011/000000002}', "");
    Expect(1, 3887, '\P{^Is_Numeric_Value=+00000000011/000000002}', "");
    Expect(0, 3888, '\p{Is_Numeric_Value=+00000000011/000000002}', "");
    Expect(1, 3888, '\p{^Is_Numeric_Value=+00000000011/000000002}', "");
    Expect(1, 3888, '\P{Is_Numeric_Value=+00000000011/000000002}', "");
    Expect(0, 3888, '\P{^Is_Numeric_Value=+00000000011/000000002}', "");
    Expect(1, 3887, '\p{Is_Numeric_Value:	660/120}', "");
    Expect(0, 3887, '\p{^Is_Numeric_Value:	660/120}', "");
    Expect(0, 3887, '\P{Is_Numeric_Value:	660/120}', "");
    Expect(1, 3887, '\P{^Is_Numeric_Value:	660/120}', "");
    Expect(0, 3888, '\p{Is_Numeric_Value:	660/120}', "");
    Expect(1, 3888, '\p{^Is_Numeric_Value:	660/120}', "");
    Expect(1, 3888, '\P{Is_Numeric_Value:	660/120}', "");
    Expect(0, 3888, '\P{^Is_Numeric_Value:	660/120}', "");
    Expect(1, 3887, '\p{Is_Numeric_Value:	5.5e+00}', "");
    Expect(0, 3887, '\p{^Is_Numeric_Value:	5.5e+00}', "");
    Expect(0, 3887, '\P{Is_Numeric_Value:	5.5e+00}', "");
    Expect(1, 3887, '\P{^Is_Numeric_Value:	5.5e+00}', "");
    Expect(0, 3888, '\p{Is_Numeric_Value:	5.5e+00}', "");
    Expect(1, 3888, '\p{^Is_Numeric_Value:	5.5e+00}', "");
    Expect(1, 3888, '\P{Is_Numeric_Value:	5.5e+00}', "");
    Expect(0, 3888, '\P{^Is_Numeric_Value:	5.5e+00}', "");
    Expect(1, 3887, '\p{Is_Numeric_Value=5.5}', "");
    Expect(0, 3887, '\p{^Is_Numeric_Value=5.5}', "");
    Expect(0, 3887, '\P{Is_Numeric_Value=5.5}', "");
    Expect(1, 3887, '\P{^Is_Numeric_Value=5.5}', "");
    Expect(0, 3888, '\p{Is_Numeric_Value=5.5}', "");
    Expect(1, 3888, '\p{^Is_Numeric_Value=5.5}', "");
    Expect(1, 3888, '\P{Is_Numeric_Value=5.5}', "");
    Expect(0, 3888, '\P{^Is_Numeric_Value=5.5}', "");
    Expect(1, 3887, '\p{Is_Numeric_Value=5.50e+00}', "");
    Expect(0, 3887, '\p{^Is_Numeric_Value=5.50e+00}', "");
    Expect(0, 3887, '\P{Is_Numeric_Value=5.50e+00}', "");
    Expect(1, 3887, '\P{^Is_Numeric_Value=5.50e+00}', "");
    Expect(0, 3888, '\p{Is_Numeric_Value=5.50e+00}', "");
    Expect(1, 3888, '\p{^Is_Numeric_Value=5.50e+00}', "");
    Expect(1, 3888, '\P{Is_Numeric_Value=5.50e+00}', "");
    Expect(0, 3888, '\P{^Is_Numeric_Value=5.50e+00}', "");
    Expect(1, 3887, '\p{Is_Numeric_Value=5.50}', "");
    Expect(0, 3887, '\p{^Is_Numeric_Value=5.50}', "");
    Expect(0, 3887, '\P{Is_Numeric_Value=5.50}', "");
    Expect(1, 3887, '\P{^Is_Numeric_Value=5.50}', "");
    Expect(0, 3888, '\p{Is_Numeric_Value=5.50}', "");
    Expect(1, 3888, '\p{^Is_Numeric_Value=5.50}', "");
    Expect(1, 3888, '\P{Is_Numeric_Value=5.50}', "");
    Expect(0, 3888, '\P{^Is_Numeric_Value=5.50}', "");
    Error('\p{Is_Nv=-	00011/002/a/}');
    Error('\P{Is_Nv=-	00011/002/a/}');
    Expect(1, 3887, '\p{Is_Nv=00000000011/02}', "");
    Expect(0, 3887, '\p{^Is_Nv=00000000011/02}', "");
    Expect(0, 3887, '\P{Is_Nv=00000000011/02}', "");
    Expect(1, 3887, '\P{^Is_Nv=00000000011/02}', "");
    Expect(0, 3888, '\p{Is_Nv=00000000011/02}', "");
    Expect(1, 3888, '\p{^Is_Nv=00000000011/02}', "");
    Expect(1, 3888, '\P{Is_Nv=00000000011/02}', "");
    Expect(0, 3888, '\P{^Is_Nv=00000000011/02}', "");
    Expect(1, 3887, '\p{Is_Nv=660/120}', "");
    Expect(0, 3887, '\p{^Is_Nv=660/120}', "");
    Expect(0, 3887, '\P{Is_Nv=660/120}', "");
    Expect(1, 3887, '\P{^Is_Nv=660/120}', "");
    Expect(0, 3888, '\p{Is_Nv=660/120}', "");
    Expect(1, 3888, '\p{^Is_Nv=660/120}', "");
    Expect(1, 3888, '\P{Is_Nv=660/120}', "");
    Expect(0, 3888, '\P{^Is_Nv=660/120}', "");
    Expect(1, 3887, '\p{Is_Nv=5.5e+00}', "");
    Expect(0, 3887, '\p{^Is_Nv=5.5e+00}', "");
    Expect(0, 3887, '\P{Is_Nv=5.5e+00}', "");
    Expect(1, 3887, '\P{^Is_Nv=5.5e+00}', "");
    Expect(0, 3888, '\p{Is_Nv=5.5e+00}', "");
    Expect(1, 3888, '\p{^Is_Nv=5.5e+00}', "");
    Expect(1, 3888, '\P{Is_Nv=5.5e+00}', "");
    Expect(0, 3888, '\P{^Is_Nv=5.5e+00}', "");
    Expect(1, 3887, '\p{Is_Nv=5.5}', "");
    Expect(0, 3887, '\p{^Is_Nv=5.5}', "");
    Expect(0, 3887, '\P{Is_Nv=5.5}', "");
    Expect(1, 3887, '\P{^Is_Nv=5.5}', "");
    Expect(0, 3888, '\p{Is_Nv=5.5}', "");
    Expect(1, 3888, '\p{^Is_Nv=5.5}', "");
    Expect(1, 3888, '\P{Is_Nv=5.5}', "");
    Expect(0, 3888, '\P{^Is_Nv=5.5}', "");
    Expect(1, 3887, '\p{Is_Nv=5.50e+00}', "");
    Expect(0, 3887, '\p{^Is_Nv=5.50e+00}', "");
    Expect(0, 3887, '\P{Is_Nv=5.50e+00}', "");
    Expect(1, 3887, '\P{^Is_Nv=5.50e+00}', "");
    Expect(0, 3888, '\p{Is_Nv=5.50e+00}', "");
    Expect(1, 3888, '\p{^Is_Nv=5.50e+00}', "");
    Expect(1, 3888, '\P{Is_Nv=5.50e+00}', "");
    Expect(0, 3888, '\P{^Is_Nv=5.50e+00}', "");
    Expect(1, 3887, '\p{Is_Nv=5.50}', "");
    Expect(0, 3887, '\p{^Is_Nv=5.50}', "");
    Expect(0, 3887, '\P{Is_Nv=5.50}', "");
    Expect(1, 3887, '\P{^Is_Nv=5.50}', "");
    Expect(0, 3888, '\p{Is_Nv=5.50}', "");
    Expect(1, 3888, '\p{^Is_Nv=5.50}', "");
    Expect(1, 3888, '\P{Is_Nv=5.50}', "");
    Expect(0, 3888, '\P{^Is_Nv=5.50}', "");
    Error('\p{Numeric_Value=--0001_2/a/}');
    Error('\P{Numeric_Value=--0001_2/a/}');
    Expect(1, 119532, '\p{Numeric_Value=:\A12\z:}', "");;
    Expect(0, 119533, '\p{Numeric_Value=:\A12\z:}', "");;
    Expect(1, 119532, '\p{Numeric_Value=0000012}', "");
    Expect(0, 119532, '\p{^Numeric_Value=0000012}', "");
    Expect(0, 119532, '\P{Numeric_Value=0000012}', "");
    Expect(1, 119532, '\P{^Numeric_Value=0000012}', "");
    Expect(0, 119533, '\p{Numeric_Value=0000012}', "");
    Expect(1, 119533, '\p{^Numeric_Value=0000012}', "");
    Expect(1, 119533, '\P{Numeric_Value=0000012}', "");
    Expect(0, 119533, '\P{^Numeric_Value=0000012}', "");
    Expect(1, 119532, '\p{Numeric_Value=1.200000000000000e+01}', "");
    Expect(0, 119532, '\p{^Numeric_Value=1.200000000000000e+01}', "");
    Expect(0, 119532, '\P{Numeric_Value=1.200000000000000e+01}', "");
    Expect(1, 119532, '\P{^Numeric_Value=1.200000000000000e+01}', "");
    Expect(0, 119533, '\p{Numeric_Value=1.200000000000000e+01}', "");
    Expect(1, 119533, '\p{^Numeric_Value=1.200000000000000e+01}', "");
    Expect(1, 119533, '\P{Numeric_Value=1.200000000000000e+01}', "");
    Expect(0, 119533, '\P{^Numeric_Value=1.200000000000000e+01}', "");
    Error('\p{Nv=/a/_00000_00001_2}');
    Error('\P{Nv=/a/_00000_00001_2}');
    Expect(1, 119532, '\p{Nv=:\A12\z:}', "");;
    Expect(0, 119533, '\p{Nv=:\A12\z:}', "");;
    Expect(1, 119532, '\p{Nv=0_0_0_0_0_0_12}', "");
    Expect(0, 119532, '\p{^Nv=0_0_0_0_0_0_12}', "");
    Expect(0, 119532, '\P{Nv=0_0_0_0_0_0_12}', "");
    Expect(1, 119532, '\P{^Nv=0_0_0_0_0_0_12}', "");
    Expect(0, 119533, '\p{Nv=0_0_0_0_0_0_12}', "");
    Expect(1, 119533, '\p{^Nv=0_0_0_0_0_0_12}', "");
    Expect(1, 119533, '\P{Nv=0_0_0_0_0_0_12}', "");
    Expect(0, 119533, '\P{^Nv=0_0_0_0_0_0_12}', "");
    Expect(1, 119532, '\p{Nv=1.200000000000000e+01}', "");
    Expect(0, 119532, '\p{^Nv=1.200000000000000e+01}', "");
    Expect(0, 119532, '\P{Nv=1.200000000000000e+01}', "");
    Expect(1, 119532, '\P{^Nv=1.200000000000000e+01}', "");
    Expect(0, 119533, '\p{Nv=1.200000000000000e+01}', "");
    Expect(1, 119533, '\p{^Nv=1.200000000000000e+01}', "");
    Expect(1, 119533, '\P{Nv=1.200000000000000e+01}', "");
    Expect(0, 119533, '\P{^Nv=1.200000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=-:=01_2}');
    Error('\P{Is_Numeric_Value=-:=01_2}');
    Expect(1, 119532, '\p{Is_Numeric_Value: +00_00_01_2}', "");
    Expect(0, 119532, '\p{^Is_Numeric_Value: +00_00_01_2}', "");
    Expect(0, 119532, '\P{Is_Numeric_Value: +00_00_01_2}', "");
    Expect(1, 119532, '\P{^Is_Numeric_Value: +00_00_01_2}', "");
    Expect(0, 119533, '\p{Is_Numeric_Value: +00_00_01_2}', "");
    Expect(1, 119533, '\p{^Is_Numeric_Value: +00_00_01_2}', "");
    Expect(1, 119533, '\P{Is_Numeric_Value: +00_00_01_2}', "");
    Expect(0, 119533, '\P{^Is_Numeric_Value: +00_00_01_2}', "");
    Expect(1, 119532, '\p{Is_Numeric_Value=1.200000000000000e+01}', "");
    Expect(0, 119532, '\p{^Is_Numeric_Value=1.200000000000000e+01}', "");
    Expect(0, 119532, '\P{Is_Numeric_Value=1.200000000000000e+01}', "");
    Expect(1, 119532, '\P{^Is_Numeric_Value=1.200000000000000e+01}', "");
    Expect(0, 119533, '\p{Is_Numeric_Value=1.200000000000000e+01}', "");
    Expect(1, 119533, '\p{^Is_Numeric_Value=1.200000000000000e+01}', "");
    Expect(1, 119533, '\P{Is_Numeric_Value=1.200000000000000e+01}', "");
    Expect(0, 119533, '\P{^Is_Numeric_Value=1.200000000000000e+01}', "");
    Error('\p{Is_Nv=_	+0001_2:=}');
    Error('\P{Is_Nv=_	+0001_2:=}');
    Expect(1, 119532, '\p{Is_Nv=+000000012}', "");
    Expect(0, 119532, '\p{^Is_Nv=+000000012}', "");
    Expect(0, 119532, '\P{Is_Nv=+000000012}', "");
    Expect(1, 119532, '\P{^Is_Nv=+000000012}', "");
    Expect(0, 119533, '\p{Is_Nv=+000000012}', "");
    Expect(1, 119533, '\p{^Is_Nv=+000000012}', "");
    Expect(1, 119533, '\P{Is_Nv=+000000012}', "");
    Expect(0, 119533, '\P{^Is_Nv=+000000012}', "");
    Expect(1, 119532, '\p{Is_Nv:   1.200000000000000e+01}', "");
    Expect(0, 119532, '\p{^Is_Nv:   1.200000000000000e+01}', "");
    Expect(0, 119532, '\P{Is_Nv:   1.200000000000000e+01}', "");
    Expect(1, 119532, '\P{^Is_Nv:   1.200000000000000e+01}', "");
    Expect(0, 119533, '\p{Is_Nv:   1.200000000000000e+01}', "");
    Expect(1, 119533, '\p{^Is_Nv:   1.200000000000000e+01}', "");
    Expect(1, 119533, '\P{Is_Nv:   1.200000000000000e+01}', "");
    Expect(0, 119533, '\P{^Is_Nv:   1.200000000000000e+01}', "");
    Error('\p{Numeric_Value=-0_0_0_13:=}');
    Error('\P{Numeric_Value=-0_0_0_13:=}');
    Expect(1, 119533, '\p{Numeric_Value=:\A13\z:}', "");;
    Expect(0, 119534, '\p{Numeric_Value=:\A13\z:}', "");;
    Expect(1, 119533, '\p{Numeric_Value=13}', "");
    Expect(0, 119533, '\p{^Numeric_Value=13}', "");
    Expect(0, 119533, '\P{Numeric_Value=13}', "");
    Expect(1, 119533, '\P{^Numeric_Value=13}', "");
    Expect(0, 119534, '\p{Numeric_Value=13}', "");
    Expect(1, 119534, '\p{^Numeric_Value=13}', "");
    Expect(1, 119534, '\P{Numeric_Value=13}', "");
    Expect(0, 119534, '\P{^Numeric_Value=13}', "");
    Expect(1, 119533, '\p{Numeric_Value=1.300000000000000e+01}', "");
    Expect(0, 119533, '\p{^Numeric_Value=1.300000000000000e+01}', "");
    Expect(0, 119533, '\P{Numeric_Value=1.300000000000000e+01}', "");
    Expect(1, 119533, '\P{^Numeric_Value=1.300000000000000e+01}', "");
    Expect(0, 119534, '\p{Numeric_Value=1.300000000000000e+01}', "");
    Expect(1, 119534, '\p{^Numeric_Value=1.300000000000000e+01}', "");
    Expect(1, 119534, '\P{Numeric_Value=1.300000000000000e+01}', "");
    Expect(0, 119534, '\P{^Numeric_Value=1.300000000000000e+01}', "");
    Error('\p{Nv=_-000013:=}');
    Error('\P{Nv=_-000013:=}');
    Expect(1, 119533, '\p{Nv=:\A13\z:}', "");;
    Expect(0, 119534, '\p{Nv=:\A13\z:}', "");;
    Expect(1, 119533, '\p{Nv=+00000000013}', "");
    Expect(0, 119533, '\p{^Nv=+00000000013}', "");
    Expect(0, 119533, '\P{Nv=+00000000013}', "");
    Expect(1, 119533, '\P{^Nv=+00000000013}', "");
    Expect(0, 119534, '\p{Nv=+00000000013}', "");
    Expect(1, 119534, '\p{^Nv=+00000000013}', "");
    Expect(1, 119534, '\P{Nv=+00000000013}', "");
    Expect(0, 119534, '\P{^Nv=+00000000013}', "");
    Expect(1, 119533, '\p{Nv=1.300000000000000e+01}', "");
    Expect(0, 119533, '\p{^Nv=1.300000000000000e+01}', "");
    Expect(0, 119533, '\P{Nv=1.300000000000000e+01}', "");
    Expect(1, 119533, '\P{^Nv=1.300000000000000e+01}', "");
    Expect(0, 119534, '\p{Nv=1.300000000000000e+01}', "");
    Expect(1, 119534, '\p{^Nv=1.300000000000000e+01}', "");
    Expect(1, 119534, '\P{Nv=1.300000000000000e+01}', "");
    Expect(0, 119534, '\P{^Nv=1.300000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=-	0000000013/a/}');
    Error('\P{Is_Numeric_Value=-	0000000013/a/}');
    Expect(1, 119533, '\p{Is_Numeric_Value:   0013}', "");
    Expect(0, 119533, '\p{^Is_Numeric_Value:   0013}', "");
    Expect(0, 119533, '\P{Is_Numeric_Value:   0013}', "");
    Expect(1, 119533, '\P{^Is_Numeric_Value:   0013}', "");
    Expect(0, 119534, '\p{Is_Numeric_Value:   0013}', "");
    Expect(1, 119534, '\p{^Is_Numeric_Value:   0013}', "");
    Expect(1, 119534, '\P{Is_Numeric_Value:   0013}', "");
    Expect(0, 119534, '\P{^Is_Numeric_Value:   0013}', "");
    Expect(1, 119533, '\p{Is_Numeric_Value: 1.300000000000000e+01}', "");
    Expect(0, 119533, '\p{^Is_Numeric_Value: 1.300000000000000e+01}', "");
    Expect(0, 119533, '\P{Is_Numeric_Value: 1.300000000000000e+01}', "");
    Expect(1, 119533, '\P{^Is_Numeric_Value: 1.300000000000000e+01}', "");
    Expect(0, 119534, '\p{Is_Numeric_Value: 1.300000000000000e+01}', "");
    Expect(1, 119534, '\p{^Is_Numeric_Value: 1.300000000000000e+01}', "");
    Expect(1, 119534, '\P{Is_Numeric_Value: 1.300000000000000e+01}', "");
    Expect(0, 119534, '\P{^Is_Numeric_Value: 1.300000000000000e+01}', "");
    Error('\p{Is_Nv=:=_+00013}');
    Error('\P{Is_Nv=:=_+00013}');
    Expect(1, 119533, '\p{Is_Nv=000001_3}', "");
    Expect(0, 119533, '\p{^Is_Nv=000001_3}', "");
    Expect(0, 119533, '\P{Is_Nv=000001_3}', "");
    Expect(1, 119533, '\P{^Is_Nv=000001_3}', "");
    Expect(0, 119534, '\p{Is_Nv=000001_3}', "");
    Expect(1, 119534, '\p{^Is_Nv=000001_3}', "");
    Expect(1, 119534, '\P{Is_Nv=000001_3}', "");
    Expect(0, 119534, '\P{^Is_Nv=000001_3}', "");
    Expect(1, 119533, '\p{Is_Nv=1.300000000000000e+01}', "");
    Expect(0, 119533, '\p{^Is_Nv=1.300000000000000e+01}', "");
    Expect(0, 119533, '\P{Is_Nv=1.300000000000000e+01}', "");
    Expect(1, 119533, '\P{^Is_Nv=1.300000000000000e+01}', "");
    Expect(0, 119534, '\p{Is_Nv=1.300000000000000e+01}', "");
    Expect(1, 119534, '\p{^Is_Nv=1.300000000000000e+01}', "");
    Expect(1, 119534, '\P{Is_Nv=1.300000000000000e+01}', "");
    Expect(0, 119534, '\P{^Is_Nv=1.300000000000000e+01}', "");
    Error('\p{Numeric_Value=		13/0000002/a/}');
    Error('\P{Numeric_Value=		13/0000002/a/}');
    Expect(1, 3888, '\p{Numeric_Value=:\A13/2\z:}', "");;
    Expect(0, 3889, '\p{Numeric_Value=:\A13/2\z:}', "");;
    Expect(1, 3888, '\p{Numeric_Value=+0000000013/2}', "");
    Expect(0, 3888, '\p{^Numeric_Value=+0000000013/2}', "");
    Expect(0, 3888, '\P{Numeric_Value=+0000000013/2}', "");
    Expect(1, 3888, '\P{^Numeric_Value=+0000000013/2}', "");
    Expect(0, 3889, '\p{Numeric_Value=+0000000013/2}', "");
    Expect(1, 3889, '\p{^Numeric_Value=+0000000013/2}', "");
    Expect(1, 3889, '\P{Numeric_Value=+0000000013/2}', "");
    Expect(0, 3889, '\P{^Numeric_Value=+0000000013/2}', "");
    Expect(1, 3888, '\p{Numeric_Value=780/120}', "");
    Expect(0, 3888, '\p{^Numeric_Value=780/120}', "");
    Expect(0, 3888, '\P{Numeric_Value=780/120}', "");
    Expect(1, 3888, '\P{^Numeric_Value=780/120}', "");
    Expect(0, 3889, '\p{Numeric_Value=780/120}', "");
    Expect(1, 3889, '\p{^Numeric_Value=780/120}', "");
    Expect(1, 3889, '\P{Numeric_Value=780/120}', "");
    Expect(0, 3889, '\P{^Numeric_Value=780/120}', "");
    Expect(1, 3888, '\p{Numeric_Value=6.5e+00}', "");
    Expect(0, 3888, '\p{^Numeric_Value=6.5e+00}', "");
    Expect(0, 3888, '\P{Numeric_Value=6.5e+00}', "");
    Expect(1, 3888, '\P{^Numeric_Value=6.5e+00}', "");
    Expect(0, 3889, '\p{Numeric_Value=6.5e+00}', "");
    Expect(1, 3889, '\p{^Numeric_Value=6.5e+00}', "");
    Expect(1, 3889, '\P{Numeric_Value=6.5e+00}', "");
    Expect(0, 3889, '\P{^Numeric_Value=6.5e+00}', "");
    Expect(1, 3888, '\p{Numeric_Value=6.5}', "");
    Expect(0, 3888, '\p{^Numeric_Value=6.5}', "");
    Expect(0, 3888, '\P{Numeric_Value=6.5}', "");
    Expect(1, 3888, '\P{^Numeric_Value=6.5}', "");
    Expect(0, 3889, '\p{Numeric_Value=6.5}', "");
    Expect(1, 3889, '\p{^Numeric_Value=6.5}', "");
    Expect(1, 3889, '\P{Numeric_Value=6.5}', "");
    Expect(0, 3889, '\P{^Numeric_Value=6.5}', "");
    Expect(1, 3888, '\p{Numeric_Value=6.50e+00}', "");
    Expect(0, 3888, '\p{^Numeric_Value=6.50e+00}', "");
    Expect(0, 3888, '\P{Numeric_Value=6.50e+00}', "");
    Expect(1, 3888, '\P{^Numeric_Value=6.50e+00}', "");
    Expect(0, 3889, '\p{Numeric_Value=6.50e+00}', "");
    Expect(1, 3889, '\p{^Numeric_Value=6.50e+00}', "");
    Expect(1, 3889, '\P{Numeric_Value=6.50e+00}', "");
    Expect(0, 3889, '\P{^Numeric_Value=6.50e+00}', "");
    Expect(1, 3888, '\p{Numeric_Value=6.50}', "");
    Expect(0, 3888, '\p{^Numeric_Value=6.50}', "");
    Expect(0, 3888, '\P{Numeric_Value=6.50}', "");
    Expect(1, 3888, '\P{^Numeric_Value=6.50}', "");
    Expect(0, 3889, '\p{Numeric_Value=6.50}', "");
    Expect(1, 3889, '\p{^Numeric_Value=6.50}', "");
    Expect(1, 3889, '\P{Numeric_Value=6.50}', "");
    Expect(0, 3889, '\P{^Numeric_Value=6.50}', "");
    Error('\p{Nv=:=		+0013/2}');
    Error('\P{Nv=:=		+0013/2}');
    Expect(1, 3888, '\p{Nv=:\A13/2\z:}', "");;
    Expect(0, 3889, '\p{Nv=:\A13/2\z:}', "");;
    Expect(1, 3888, '\p{Nv=00000013/00002}', "");
    Expect(0, 3888, '\p{^Nv=00000013/00002}', "");
    Expect(0, 3888, '\P{Nv=00000013/00002}', "");
    Expect(1, 3888, '\P{^Nv=00000013/00002}', "");
    Expect(0, 3889, '\p{Nv=00000013/00002}', "");
    Expect(1, 3889, '\p{^Nv=00000013/00002}', "");
    Expect(1, 3889, '\P{Nv=00000013/00002}', "");
    Expect(0, 3889, '\P{^Nv=00000013/00002}', "");
    Expect(1, 3888, '\p{Nv=780/120}', "");
    Expect(0, 3888, '\p{^Nv=780/120}', "");
    Expect(0, 3888, '\P{Nv=780/120}', "");
    Expect(1, 3888, '\P{^Nv=780/120}', "");
    Expect(0, 3889, '\p{Nv=780/120}', "");
    Expect(1, 3889, '\p{^Nv=780/120}', "");
    Expect(1, 3889, '\P{Nv=780/120}', "");
    Expect(0, 3889, '\P{^Nv=780/120}', "");
    Expect(1, 3888, '\p{Nv=6.5e+00}', "");
    Expect(0, 3888, '\p{^Nv=6.5e+00}', "");
    Expect(0, 3888, '\P{Nv=6.5e+00}', "");
    Expect(1, 3888, '\P{^Nv=6.5e+00}', "");
    Expect(0, 3889, '\p{Nv=6.5e+00}', "");
    Expect(1, 3889, '\p{^Nv=6.5e+00}', "");
    Expect(1, 3889, '\P{Nv=6.5e+00}', "");
    Expect(0, 3889, '\P{^Nv=6.5e+00}', "");
    Expect(1, 3888, '\p{Nv: 6.5}', "");
    Expect(0, 3888, '\p{^Nv: 6.5}', "");
    Expect(0, 3888, '\P{Nv: 6.5}', "");
    Expect(1, 3888, '\P{^Nv: 6.5}', "");
    Expect(0, 3889, '\p{Nv: 6.5}', "");
    Expect(1, 3889, '\p{^Nv: 6.5}', "");
    Expect(1, 3889, '\P{Nv: 6.5}', "");
    Expect(0, 3889, '\P{^Nv: 6.5}', "");
    Expect(1, 3888, '\p{Nv:	6.50e+00}', "");
    Expect(0, 3888, '\p{^Nv:	6.50e+00}', "");
    Expect(0, 3888, '\P{Nv:	6.50e+00}', "");
    Expect(1, 3888, '\P{^Nv:	6.50e+00}', "");
    Expect(0, 3889, '\p{Nv:	6.50e+00}', "");
    Expect(1, 3889, '\p{^Nv:	6.50e+00}', "");
    Expect(1, 3889, '\P{Nv:	6.50e+00}', "");
    Expect(0, 3889, '\P{^Nv:	6.50e+00}', "");
    Expect(1, 3888, '\p{Nv=6.50}', "");
    Expect(0, 3888, '\p{^Nv=6.50}', "");
    Expect(0, 3888, '\P{Nv=6.50}', "");
    Expect(1, 3888, '\P{^Nv=6.50}', "");
    Expect(0, 3889, '\p{Nv=6.50}', "");
    Expect(1, 3889, '\p{^Nv=6.50}', "");
    Expect(1, 3889, '\P{Nv=6.50}', "");
    Expect(0, 3889, '\P{^Nv=6.50}', "");
    Error('\p{Is_Numeric_Value=-013/0002/a/}');
    Error('\P{Is_Numeric_Value=-013/0002/a/}');
    Expect(1, 3888, '\p{Is_Numeric_Value=+013/02}', "");
    Expect(0, 3888, '\p{^Is_Numeric_Value=+013/02}', "");
    Expect(0, 3888, '\P{Is_Numeric_Value=+013/02}', "");
    Expect(1, 3888, '\P{^Is_Numeric_Value=+013/02}', "");
    Expect(0, 3889, '\p{Is_Numeric_Value=+013/02}', "");
    Expect(1, 3889, '\p{^Is_Numeric_Value=+013/02}', "");
    Expect(1, 3889, '\P{Is_Numeric_Value=+013/02}', "");
    Expect(0, 3889, '\P{^Is_Numeric_Value=+013/02}', "");
    Expect(1, 3888, '\p{Is_Numeric_Value=780/120}', "");
    Expect(0, 3888, '\p{^Is_Numeric_Value=780/120}', "");
    Expect(0, 3888, '\P{Is_Numeric_Value=780/120}', "");
    Expect(1, 3888, '\P{^Is_Numeric_Value=780/120}', "");
    Expect(0, 3889, '\p{Is_Numeric_Value=780/120}', "");
    Expect(1, 3889, '\p{^Is_Numeric_Value=780/120}', "");
    Expect(1, 3889, '\P{Is_Numeric_Value=780/120}', "");
    Expect(0, 3889, '\P{^Is_Numeric_Value=780/120}', "");
    Expect(1, 3888, '\p{Is_Numeric_Value=6.5e+00}', "");
    Expect(0, 3888, '\p{^Is_Numeric_Value=6.5e+00}', "");
    Expect(0, 3888, '\P{Is_Numeric_Value=6.5e+00}', "");
    Expect(1, 3888, '\P{^Is_Numeric_Value=6.5e+00}', "");
    Expect(0, 3889, '\p{Is_Numeric_Value=6.5e+00}', "");
    Expect(1, 3889, '\p{^Is_Numeric_Value=6.5e+00}', "");
    Expect(1, 3889, '\P{Is_Numeric_Value=6.5e+00}', "");
    Expect(0, 3889, '\P{^Is_Numeric_Value=6.5e+00}', "");
    Expect(1, 3888, '\p{Is_Numeric_Value=6.5}', "");
    Expect(0, 3888, '\p{^Is_Numeric_Value=6.5}', "");
    Expect(0, 3888, '\P{Is_Numeric_Value=6.5}', "");
    Expect(1, 3888, '\P{^Is_Numeric_Value=6.5}', "");
    Expect(0, 3889, '\p{Is_Numeric_Value=6.5}', "");
    Expect(1, 3889, '\p{^Is_Numeric_Value=6.5}', "");
    Expect(1, 3889, '\P{Is_Numeric_Value=6.5}', "");
    Expect(0, 3889, '\P{^Is_Numeric_Value=6.5}', "");
    Expect(1, 3888, '\p{Is_Numeric_Value=6.50e+00}', "");
    Expect(0, 3888, '\p{^Is_Numeric_Value=6.50e+00}', "");
    Expect(0, 3888, '\P{Is_Numeric_Value=6.50e+00}', "");
    Expect(1, 3888, '\P{^Is_Numeric_Value=6.50e+00}', "");
    Expect(0, 3889, '\p{Is_Numeric_Value=6.50e+00}', "");
    Expect(1, 3889, '\p{^Is_Numeric_Value=6.50e+00}', "");
    Expect(1, 3889, '\P{Is_Numeric_Value=6.50e+00}', "");
    Expect(0, 3889, '\P{^Is_Numeric_Value=6.50e+00}', "");
    Expect(1, 3888, '\p{Is_Numeric_Value=6.50}', "");
    Expect(0, 3888, '\p{^Is_Numeric_Value=6.50}', "");
    Expect(0, 3888, '\P{Is_Numeric_Value=6.50}', "");
    Expect(1, 3888, '\P{^Is_Numeric_Value=6.50}', "");
    Expect(0, 3889, '\p{Is_Numeric_Value=6.50}', "");
    Expect(1, 3889, '\p{^Is_Numeric_Value=6.50}', "");
    Expect(1, 3889, '\P{Is_Numeric_Value=6.50}', "");
    Expect(0, 3889, '\P{^Is_Numeric_Value=6.50}', "");
    Error('\p{Is_Nv=-/a/000000013/000002}');
    Error('\P{Is_Nv=-/a/000000013/000002}');
    Expect(1, 3888, '\p{Is_Nv=00000013/00002}', "");
    Expect(0, 3888, '\p{^Is_Nv=00000013/00002}', "");
    Expect(0, 3888, '\P{Is_Nv=00000013/00002}', "");
    Expect(1, 3888, '\P{^Is_Nv=00000013/00002}', "");
    Expect(0, 3889, '\p{Is_Nv=00000013/00002}', "");
    Expect(1, 3889, '\p{^Is_Nv=00000013/00002}', "");
    Expect(1, 3889, '\P{Is_Nv=00000013/00002}', "");
    Expect(0, 3889, '\P{^Is_Nv=00000013/00002}', "");
    Expect(1, 3888, '\p{Is_Nv=780/120}', "");
    Expect(0, 3888, '\p{^Is_Nv=780/120}', "");
    Expect(0, 3888, '\P{Is_Nv=780/120}', "");
    Expect(1, 3888, '\P{^Is_Nv=780/120}', "");
    Expect(0, 3889, '\p{Is_Nv=780/120}', "");
    Expect(1, 3889, '\p{^Is_Nv=780/120}', "");
    Expect(1, 3889, '\P{Is_Nv=780/120}', "");
    Expect(0, 3889, '\P{^Is_Nv=780/120}', "");
    Expect(1, 3888, '\p{Is_Nv=6.5e+00}', "");
    Expect(0, 3888, '\p{^Is_Nv=6.5e+00}', "");
    Expect(0, 3888, '\P{Is_Nv=6.5e+00}', "");
    Expect(1, 3888, '\P{^Is_Nv=6.5e+00}', "");
    Expect(0, 3889, '\p{Is_Nv=6.5e+00}', "");
    Expect(1, 3889, '\p{^Is_Nv=6.5e+00}', "");
    Expect(1, 3889, '\P{Is_Nv=6.5e+00}', "");
    Expect(0, 3889, '\P{^Is_Nv=6.5e+00}', "");
    Expect(1, 3888, '\p{Is_Nv=6.5}', "");
    Expect(0, 3888, '\p{^Is_Nv=6.5}', "");
    Expect(0, 3888, '\P{Is_Nv=6.5}', "");
    Expect(1, 3888, '\P{^Is_Nv=6.5}', "");
    Expect(0, 3889, '\p{Is_Nv=6.5}', "");
    Expect(1, 3889, '\p{^Is_Nv=6.5}', "");
    Expect(1, 3889, '\P{Is_Nv=6.5}', "");
    Expect(0, 3889, '\P{^Is_Nv=6.5}', "");
    Expect(1, 3888, '\p{Is_Nv=6.50e+00}', "");
    Expect(0, 3888, '\p{^Is_Nv=6.50e+00}', "");
    Expect(0, 3888, '\P{Is_Nv=6.50e+00}', "");
    Expect(1, 3888, '\P{^Is_Nv=6.50e+00}', "");
    Expect(0, 3889, '\p{Is_Nv=6.50e+00}', "");
    Expect(1, 3889, '\p{^Is_Nv=6.50e+00}', "");
    Expect(1, 3889, '\P{Is_Nv=6.50e+00}', "");
    Expect(0, 3889, '\P{^Is_Nv=6.50e+00}', "");
    Expect(1, 3888, '\p{Is_Nv=6.50}', "");
    Expect(0, 3888, '\p{^Is_Nv=6.50}', "");
    Expect(0, 3888, '\P{Is_Nv=6.50}', "");
    Expect(1, 3888, '\P{^Is_Nv=6.50}', "");
    Expect(0, 3889, '\p{Is_Nv=6.50}', "");
    Expect(1, 3889, '\p{^Is_Nv=6.50}', "");
    Expect(1, 3889, '\P{Is_Nv=6.50}', "");
    Expect(0, 3889, '\P{^Is_Nv=6.50}', "");
    Error('\p{Numeric_Value=-:=00_00_00_00_14}');
    Error('\P{Numeric_Value=-:=00_00_00_00_14}');
    Expect(1, 119534, '\p{Numeric_Value=:\A14\z:}', "");;
    Expect(0, 119535, '\p{Numeric_Value=:\A14\z:}', "");;
    Expect(1, 119534, '\p{Numeric_Value=00_00_00_01_4}', "");
    Expect(0, 119534, '\p{^Numeric_Value=00_00_00_01_4}', "");
    Expect(0, 119534, '\P{Numeric_Value=00_00_00_01_4}', "");
    Expect(1, 119534, '\P{^Numeric_Value=00_00_00_01_4}', "");
    Expect(0, 119535, '\p{Numeric_Value=00_00_00_01_4}', "");
    Expect(1, 119535, '\p{^Numeric_Value=00_00_00_01_4}', "");
    Expect(1, 119535, '\P{Numeric_Value=00_00_00_01_4}', "");
    Expect(0, 119535, '\P{^Numeric_Value=00_00_00_01_4}', "");
    Expect(1, 119534, '\p{Numeric_Value=1.400000000000000e+01}', "");
    Expect(0, 119534, '\p{^Numeric_Value=1.400000000000000e+01}', "");
    Expect(0, 119534, '\P{Numeric_Value=1.400000000000000e+01}', "");
    Expect(1, 119534, '\P{^Numeric_Value=1.400000000000000e+01}', "");
    Expect(0, 119535, '\p{Numeric_Value=1.400000000000000e+01}', "");
    Expect(1, 119535, '\p{^Numeric_Value=1.400000000000000e+01}', "");
    Expect(1, 119535, '\P{Numeric_Value=1.400000000000000e+01}', "");
    Expect(0, 119535, '\P{^Numeric_Value=1.400000000000000e+01}', "");
    Error('\p{Nv=_:=00_00_00_014}');
    Error('\P{Nv=_:=00_00_00_014}');
    Expect(1, 119534, '\p{Nv=:\A14\z:}', "");;
    Expect(0, 119535, '\p{Nv=:\A14\z:}', "");;
    Expect(1, 119534, '\p{Nv=0_0_0_0_014}', "");
    Expect(0, 119534, '\p{^Nv=0_0_0_0_014}', "");
    Expect(0, 119534, '\P{Nv=0_0_0_0_014}', "");
    Expect(1, 119534, '\P{^Nv=0_0_0_0_014}', "");
    Expect(0, 119535, '\p{Nv=0_0_0_0_014}', "");
    Expect(1, 119535, '\p{^Nv=0_0_0_0_014}', "");
    Expect(1, 119535, '\P{Nv=0_0_0_0_014}', "");
    Expect(0, 119535, '\P{^Nv=0_0_0_0_014}', "");
    Expect(1, 119534, '\p{Nv=1.400000000000000e+01}', "");
    Expect(0, 119534, '\p{^Nv=1.400000000000000e+01}', "");
    Expect(0, 119534, '\P{Nv=1.400000000000000e+01}', "");
    Expect(1, 119534, '\P{^Nv=1.400000000000000e+01}', "");
    Expect(0, 119535, '\p{Nv=1.400000000000000e+01}', "");
    Expect(1, 119535, '\p{^Nv=1.400000000000000e+01}', "");
    Expect(1, 119535, '\P{Nv=1.400000000000000e+01}', "");
    Expect(0, 119535, '\P{^Nv=1.400000000000000e+01}', "");
    Error('\p{Is_Numeric_Value= :=00_01_4}');
    Error('\P{Is_Numeric_Value= :=00_01_4}');
    Expect(1, 119534, '\p{Is_Numeric_Value=00000000014}', "");
    Expect(0, 119534, '\p{^Is_Numeric_Value=00000000014}', "");
    Expect(0, 119534, '\P{Is_Numeric_Value=00000000014}', "");
    Expect(1, 119534, '\P{^Is_Numeric_Value=00000000014}', "");
    Expect(0, 119535, '\p{Is_Numeric_Value=00000000014}', "");
    Expect(1, 119535, '\p{^Is_Numeric_Value=00000000014}', "");
    Expect(1, 119535, '\P{Is_Numeric_Value=00000000014}', "");
    Expect(0, 119535, '\P{^Is_Numeric_Value=00000000014}', "");
    Expect(1, 119534, '\p{Is_Numeric_Value=1.400000000000000e+01}', "");
    Expect(0, 119534, '\p{^Is_Numeric_Value=1.400000000000000e+01}', "");
    Expect(0, 119534, '\P{Is_Numeric_Value=1.400000000000000e+01}', "");
    Expect(1, 119534, '\P{^Is_Numeric_Value=1.400000000000000e+01}', "");
    Expect(0, 119535, '\p{Is_Numeric_Value=1.400000000000000e+01}', "");
    Expect(1, 119535, '\p{^Is_Numeric_Value=1.400000000000000e+01}', "");
    Expect(1, 119535, '\P{Is_Numeric_Value=1.400000000000000e+01}', "");
    Expect(0, 119535, '\P{^Is_Numeric_Value=1.400000000000000e+01}', "");
    Error('\p{Is_Nv=/a/- 0_0_0_0_0014}');
    Error('\P{Is_Nv=/a/- 0_0_0_0_0014}');
    Expect(1, 119534, '\p{Is_Nv=01_4}', "");
    Expect(0, 119534, '\p{^Is_Nv=01_4}', "");
    Expect(0, 119534, '\P{Is_Nv=01_4}', "");
    Expect(1, 119534, '\P{^Is_Nv=01_4}', "");
    Expect(0, 119535, '\p{Is_Nv=01_4}', "");
    Expect(1, 119535, '\p{^Is_Nv=01_4}', "");
    Expect(1, 119535, '\P{Is_Nv=01_4}', "");
    Expect(0, 119535, '\P{^Is_Nv=01_4}', "");
    Expect(1, 119534, '\p{Is_Nv=1.400000000000000e+01}', "");
    Expect(0, 119534, '\p{^Is_Nv=1.400000000000000e+01}', "");
    Expect(0, 119534, '\P{Is_Nv=1.400000000000000e+01}', "");
    Expect(1, 119534, '\P{^Is_Nv=1.400000000000000e+01}', "");
    Expect(0, 119535, '\p{Is_Nv=1.400000000000000e+01}', "");
    Expect(1, 119535, '\p{^Is_Nv=1.400000000000000e+01}', "");
    Expect(1, 119535, '\P{Is_Nv=1.400000000000000e+01}', "");
    Expect(0, 119535, '\P{^Is_Nv=1.400000000000000e+01}', "");
    Error('\p{Numeric_Value= /a/+1_5}');
    Error('\P{Numeric_Value= /a/+1_5}');
    Expect(1, 119535, '\p{Numeric_Value=:\A15\z:}', "");;
    Expect(0, 119536, '\p{Numeric_Value=:\A15\z:}', "");;
    Expect(1, 119535, '\p{Numeric_Value=000_000_15}', "");
    Expect(0, 119535, '\p{^Numeric_Value=000_000_15}', "");
    Expect(0, 119535, '\P{Numeric_Value=000_000_15}', "");
    Expect(1, 119535, '\P{^Numeric_Value=000_000_15}', "");
    Expect(0, 119536, '\p{Numeric_Value=000_000_15}', "");
    Expect(1, 119536, '\p{^Numeric_Value=000_000_15}', "");
    Expect(1, 119536, '\P{Numeric_Value=000_000_15}', "");
    Expect(0, 119536, '\P{^Numeric_Value=000_000_15}', "");
    Expect(1, 119535, '\p{Numeric_Value=1.500000000000000e+01}', "");
    Expect(0, 119535, '\p{^Numeric_Value=1.500000000000000e+01}', "");
    Expect(0, 119535, '\P{Numeric_Value=1.500000000000000e+01}', "");
    Expect(1, 119535, '\P{^Numeric_Value=1.500000000000000e+01}', "");
    Expect(0, 119536, '\p{Numeric_Value=1.500000000000000e+01}', "");
    Expect(1, 119536, '\p{^Numeric_Value=1.500000000000000e+01}', "");
    Expect(1, 119536, '\P{Numeric_Value=1.500000000000000e+01}', "");
    Expect(0, 119536, '\P{^Numeric_Value=1.500000000000000e+01}', "");
    Error('\p{Nv=/a/-15}');
    Error('\P{Nv=/a/-15}');
    Expect(1, 119535, '\p{Nv=:\A15\z:}', "");;
    Expect(0, 119536, '\p{Nv=:\A15\z:}', "");;
    Expect(1, 119535, '\p{Nv=0_0_0_0_0_0_00015}', "");
    Expect(0, 119535, '\p{^Nv=0_0_0_0_0_0_00015}', "");
    Expect(0, 119535, '\P{Nv=0_0_0_0_0_0_00015}', "");
    Expect(1, 119535, '\P{^Nv=0_0_0_0_0_0_00015}', "");
    Expect(0, 119536, '\p{Nv=0_0_0_0_0_0_00015}', "");
    Expect(1, 119536, '\p{^Nv=0_0_0_0_0_0_00015}', "");
    Expect(1, 119536, '\P{Nv=0_0_0_0_0_0_00015}', "");
    Expect(0, 119536, '\P{^Nv=0_0_0_0_0_0_00015}', "");
    Expect(1, 119535, '\p{Nv:1.500000000000000e+01}', "");
    Expect(0, 119535, '\p{^Nv:1.500000000000000e+01}', "");
    Expect(0, 119535, '\P{Nv:1.500000000000000e+01}', "");
    Expect(1, 119535, '\P{^Nv:1.500000000000000e+01}', "");
    Expect(0, 119536, '\p{Nv:1.500000000000000e+01}', "");
    Expect(1, 119536, '\p{^Nv:1.500000000000000e+01}', "");
    Expect(1, 119536, '\P{Nv:1.500000000000000e+01}', "");
    Expect(0, 119536, '\P{^Nv:1.500000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=/a/_+0_0_0_0_0_015}');
    Error('\P{Is_Numeric_Value=/a/_+0_0_0_0_0_015}');
    Expect(1, 119535, '\p{Is_Numeric_Value=00000000015}', "");
    Expect(0, 119535, '\p{^Is_Numeric_Value=00000000015}', "");
    Expect(0, 119535, '\P{Is_Numeric_Value=00000000015}', "");
    Expect(1, 119535, '\P{^Is_Numeric_Value=00000000015}', "");
    Expect(0, 119536, '\p{Is_Numeric_Value=00000000015}', "");
    Expect(1, 119536, '\p{^Is_Numeric_Value=00000000015}', "");
    Expect(1, 119536, '\P{Is_Numeric_Value=00000000015}', "");
    Expect(0, 119536, '\P{^Is_Numeric_Value=00000000015}', "");
    Expect(1, 119535, '\p{Is_Numeric_Value=1.500000000000000e+01}', "");
    Expect(0, 119535, '\p{^Is_Numeric_Value=1.500000000000000e+01}', "");
    Expect(0, 119535, '\P{Is_Numeric_Value=1.500000000000000e+01}', "");
    Expect(1, 119535, '\P{^Is_Numeric_Value=1.500000000000000e+01}', "");
    Expect(0, 119536, '\p{Is_Numeric_Value=1.500000000000000e+01}', "");
    Expect(1, 119536, '\p{^Is_Numeric_Value=1.500000000000000e+01}', "");
    Expect(1, 119536, '\P{Is_Numeric_Value=1.500000000000000e+01}', "");
    Expect(0, 119536, '\P{^Is_Numeric_Value=1.500000000000000e+01}', "");
    Error('\p{Is_Nv: -:=+0_0_0_15}');
    Error('\P{Is_Nv: -:=+0_0_0_15}');
    Expect(1, 119535, '\p{Is_Nv=000015}', "");
    Expect(0, 119535, '\p{^Is_Nv=000015}', "");
    Expect(0, 119535, '\P{Is_Nv=000015}', "");
    Expect(1, 119535, '\P{^Is_Nv=000015}', "");
    Expect(0, 119536, '\p{Is_Nv=000015}', "");
    Expect(1, 119536, '\p{^Is_Nv=000015}', "");
    Expect(1, 119536, '\P{Is_Nv=000015}', "");
    Expect(0, 119536, '\P{^Is_Nv=000015}', "");
    Expect(1, 119535, '\p{Is_Nv=1.500000000000000e+01}', "");
    Expect(0, 119535, '\p{^Is_Nv=1.500000000000000e+01}', "");
    Expect(0, 119535, '\P{Is_Nv=1.500000000000000e+01}', "");
    Expect(1, 119535, '\P{^Is_Nv=1.500000000000000e+01}', "");
    Expect(0, 119536, '\p{Is_Nv=1.500000000000000e+01}', "");
    Expect(1, 119536, '\p{^Is_Nv=1.500000000000000e+01}', "");
    Expect(1, 119536, '\P{Is_Nv=1.500000000000000e+01}', "");
    Expect(0, 119536, '\P{^Is_Nv=1.500000000000000e+01}', "");
    Error('\p{Numeric_Value=_	015/00002:=}');
    Error('\P{Numeric_Value=_	015/00002:=}');
    Expect(1, 3889, '\p{Numeric_Value=:\A15/2\z:}', "");;
    Expect(0, 3890, '\p{Numeric_Value=:\A15/2\z:}', "");;
    Expect(1, 3889, '\p{Numeric_Value=+0000000015/002}', "");
    Expect(0, 3889, '\p{^Numeric_Value=+0000000015/002}', "");
    Expect(0, 3889, '\P{Numeric_Value=+0000000015/002}', "");
    Expect(1, 3889, '\P{^Numeric_Value=+0000000015/002}', "");
    Expect(0, 3890, '\p{Numeric_Value=+0000000015/002}', "");
    Expect(1, 3890, '\p{^Numeric_Value=+0000000015/002}', "");
    Expect(1, 3890, '\P{Numeric_Value=+0000000015/002}', "");
    Expect(0, 3890, '\P{^Numeric_Value=+0000000015/002}', "");
    Expect(1, 3889, '\p{Numeric_Value=900/120}', "");
    Expect(0, 3889, '\p{^Numeric_Value=900/120}', "");
    Expect(0, 3889, '\P{Numeric_Value=900/120}', "");
    Expect(1, 3889, '\P{^Numeric_Value=900/120}', "");
    Expect(0, 3890, '\p{Numeric_Value=900/120}', "");
    Expect(1, 3890, '\p{^Numeric_Value=900/120}', "");
    Expect(1, 3890, '\P{Numeric_Value=900/120}', "");
    Expect(0, 3890, '\P{^Numeric_Value=900/120}', "");
    Expect(1, 3889, '\p{Numeric_Value=7.5e+00}', "");
    Expect(0, 3889, '\p{^Numeric_Value=7.5e+00}', "");
    Expect(0, 3889, '\P{Numeric_Value=7.5e+00}', "");
    Expect(1, 3889, '\P{^Numeric_Value=7.5e+00}', "");
    Expect(0, 3890, '\p{Numeric_Value=7.5e+00}', "");
    Expect(1, 3890, '\p{^Numeric_Value=7.5e+00}', "");
    Expect(1, 3890, '\P{Numeric_Value=7.5e+00}', "");
    Expect(0, 3890, '\P{^Numeric_Value=7.5e+00}', "");
    Expect(1, 3889, '\p{Numeric_Value=7.5}', "");
    Expect(0, 3889, '\p{^Numeric_Value=7.5}', "");
    Expect(0, 3889, '\P{Numeric_Value=7.5}', "");
    Expect(1, 3889, '\P{^Numeric_Value=7.5}', "");
    Expect(0, 3890, '\p{Numeric_Value=7.5}', "");
    Expect(1, 3890, '\p{^Numeric_Value=7.5}', "");
    Expect(1, 3890, '\P{Numeric_Value=7.5}', "");
    Expect(0, 3890, '\P{^Numeric_Value=7.5}', "");
    Expect(1, 3889, '\p{Numeric_Value: 7.50e+00}', "");
    Expect(0, 3889, '\p{^Numeric_Value: 7.50e+00}', "");
    Expect(0, 3889, '\P{Numeric_Value: 7.50e+00}', "");
    Expect(1, 3889, '\P{^Numeric_Value: 7.50e+00}', "");
    Expect(0, 3890, '\p{Numeric_Value: 7.50e+00}', "");
    Expect(1, 3890, '\p{^Numeric_Value: 7.50e+00}', "");
    Expect(1, 3890, '\P{Numeric_Value: 7.50e+00}', "");
    Expect(0, 3890, '\P{^Numeric_Value: 7.50e+00}', "");
    Expect(1, 3889, '\p{Numeric_Value=7.50}', "");
    Expect(0, 3889, '\p{^Numeric_Value=7.50}', "");
    Expect(0, 3889, '\P{Numeric_Value=7.50}', "");
    Expect(1, 3889, '\P{^Numeric_Value=7.50}', "");
    Expect(0, 3890, '\p{Numeric_Value=7.50}', "");
    Expect(1, 3890, '\p{^Numeric_Value=7.50}', "");
    Expect(1, 3890, '\P{Numeric_Value=7.50}', "");
    Expect(0, 3890, '\P{^Numeric_Value=7.50}', "");
    Error('\p{Nv= 	00015/000000002:=}');
    Error('\P{Nv= 	00015/000000002:=}');
    Expect(1, 3889, '\p{Nv=:\A15/2\z:}', "");;
    Expect(0, 3890, '\p{Nv=:\A15/2\z:}', "");;
    Expect(1, 3889, '\p{Nv:	+0000000015/0000002}', "");
    Expect(0, 3889, '\p{^Nv:	+0000000015/0000002}', "");
    Expect(0, 3889, '\P{Nv:	+0000000015/0000002}', "");
    Expect(1, 3889, '\P{^Nv:	+0000000015/0000002}', "");
    Expect(0, 3890, '\p{Nv:	+0000000015/0000002}', "");
    Expect(1, 3890, '\p{^Nv:	+0000000015/0000002}', "");
    Expect(1, 3890, '\P{Nv:	+0000000015/0000002}', "");
    Expect(0, 3890, '\P{^Nv:	+0000000015/0000002}', "");
    Expect(1, 3889, '\p{Nv=900/120}', "");
    Expect(0, 3889, '\p{^Nv=900/120}', "");
    Expect(0, 3889, '\P{Nv=900/120}', "");
    Expect(1, 3889, '\P{^Nv=900/120}', "");
    Expect(0, 3890, '\p{Nv=900/120}', "");
    Expect(1, 3890, '\p{^Nv=900/120}', "");
    Expect(1, 3890, '\P{Nv=900/120}', "");
    Expect(0, 3890, '\P{^Nv=900/120}', "");
    Expect(1, 3889, '\p{Nv=7.5e+00}', "");
    Expect(0, 3889, '\p{^Nv=7.5e+00}', "");
    Expect(0, 3889, '\P{Nv=7.5e+00}', "");
    Expect(1, 3889, '\P{^Nv=7.5e+00}', "");
    Expect(0, 3890, '\p{Nv=7.5e+00}', "");
    Expect(1, 3890, '\p{^Nv=7.5e+00}', "");
    Expect(1, 3890, '\P{Nv=7.5e+00}', "");
    Expect(0, 3890, '\P{^Nv=7.5e+00}', "");
    Expect(1, 3889, '\p{Nv=7.5}', "");
    Expect(0, 3889, '\p{^Nv=7.5}', "");
    Expect(0, 3889, '\P{Nv=7.5}', "");
    Expect(1, 3889, '\P{^Nv=7.5}', "");
    Expect(0, 3890, '\p{Nv=7.5}', "");
    Expect(1, 3890, '\p{^Nv=7.5}', "");
    Expect(1, 3890, '\P{Nv=7.5}', "");
    Expect(0, 3890, '\P{^Nv=7.5}', "");
    Expect(1, 3889, '\p{Nv=7.50e+00}', "");
    Expect(0, 3889, '\p{^Nv=7.50e+00}', "");
    Expect(0, 3889, '\P{Nv=7.50e+00}', "");
    Expect(1, 3889, '\P{^Nv=7.50e+00}', "");
    Expect(0, 3890, '\p{Nv=7.50e+00}', "");
    Expect(1, 3890, '\p{^Nv=7.50e+00}', "");
    Expect(1, 3890, '\P{Nv=7.50e+00}', "");
    Expect(0, 3890, '\P{^Nv=7.50e+00}', "");
    Expect(1, 3889, '\p{Nv=7.50}', "");
    Expect(0, 3889, '\p{^Nv=7.50}', "");
    Expect(0, 3889, '\P{Nv=7.50}', "");
    Expect(1, 3889, '\P{^Nv=7.50}', "");
    Expect(0, 3890, '\p{Nv=7.50}', "");
    Expect(1, 3890, '\p{^Nv=7.50}', "");
    Expect(1, 3890, '\P{Nv=7.50}', "");
    Expect(0, 3890, '\P{^Nv=7.50}', "");
    Error('\p{Is_Numeric_Value=- +015/00002:=}');
    Error('\P{Is_Numeric_Value=- +015/00002:=}');
    Expect(1, 3889, '\p{Is_Numeric_Value=000015/000000002}', "");
    Expect(0, 3889, '\p{^Is_Numeric_Value=000015/000000002}', "");
    Expect(0, 3889, '\P{Is_Numeric_Value=000015/000000002}', "");
    Expect(1, 3889, '\P{^Is_Numeric_Value=000015/000000002}', "");
    Expect(0, 3890, '\p{Is_Numeric_Value=000015/000000002}', "");
    Expect(1, 3890, '\p{^Is_Numeric_Value=000015/000000002}', "");
    Expect(1, 3890, '\P{Is_Numeric_Value=000015/000000002}', "");
    Expect(0, 3890, '\P{^Is_Numeric_Value=000015/000000002}', "");
    Expect(1, 3889, '\p{Is_Numeric_Value=900/120}', "");
    Expect(0, 3889, '\p{^Is_Numeric_Value=900/120}', "");
    Expect(0, 3889, '\P{Is_Numeric_Value=900/120}', "");
    Expect(1, 3889, '\P{^Is_Numeric_Value=900/120}', "");
    Expect(0, 3890, '\p{Is_Numeric_Value=900/120}', "");
    Expect(1, 3890, '\p{^Is_Numeric_Value=900/120}', "");
    Expect(1, 3890, '\P{Is_Numeric_Value=900/120}', "");
    Expect(0, 3890, '\P{^Is_Numeric_Value=900/120}', "");
    Expect(1, 3889, '\p{Is_Numeric_Value=7.5e+00}', "");
    Expect(0, 3889, '\p{^Is_Numeric_Value=7.5e+00}', "");
    Expect(0, 3889, '\P{Is_Numeric_Value=7.5e+00}', "");
    Expect(1, 3889, '\P{^Is_Numeric_Value=7.5e+00}', "");
    Expect(0, 3890, '\p{Is_Numeric_Value=7.5e+00}', "");
    Expect(1, 3890, '\p{^Is_Numeric_Value=7.5e+00}', "");
    Expect(1, 3890, '\P{Is_Numeric_Value=7.5e+00}', "");
    Expect(0, 3890, '\P{^Is_Numeric_Value=7.5e+00}', "");
    Expect(1, 3889, '\p{Is_Numeric_Value=7.5}', "");
    Expect(0, 3889, '\p{^Is_Numeric_Value=7.5}', "");
    Expect(0, 3889, '\P{Is_Numeric_Value=7.5}', "");
    Expect(1, 3889, '\P{^Is_Numeric_Value=7.5}', "");
    Expect(0, 3890, '\p{Is_Numeric_Value=7.5}', "");
    Expect(1, 3890, '\p{^Is_Numeric_Value=7.5}', "");
    Expect(1, 3890, '\P{Is_Numeric_Value=7.5}', "");
    Expect(0, 3890, '\P{^Is_Numeric_Value=7.5}', "");
    Expect(1, 3889, '\p{Is_Numeric_Value=7.50e+00}', "");
    Expect(0, 3889, '\p{^Is_Numeric_Value=7.50e+00}', "");
    Expect(0, 3889, '\P{Is_Numeric_Value=7.50e+00}', "");
    Expect(1, 3889, '\P{^Is_Numeric_Value=7.50e+00}', "");
    Expect(0, 3890, '\p{Is_Numeric_Value=7.50e+00}', "");
    Expect(1, 3890, '\p{^Is_Numeric_Value=7.50e+00}', "");
    Expect(1, 3890, '\P{Is_Numeric_Value=7.50e+00}', "");
    Expect(0, 3890, '\P{^Is_Numeric_Value=7.50e+00}', "");
    Expect(1, 3889, '\p{Is_Numeric_Value=7.50}', "");
    Expect(0, 3889, '\p{^Is_Numeric_Value=7.50}', "");
    Expect(0, 3889, '\P{Is_Numeric_Value=7.50}', "");
    Expect(1, 3889, '\P{^Is_Numeric_Value=7.50}', "");
    Expect(0, 3890, '\p{Is_Numeric_Value=7.50}', "");
    Expect(1, 3890, '\p{^Is_Numeric_Value=7.50}', "");
    Expect(1, 3890, '\P{Is_Numeric_Value=7.50}', "");
    Expect(0, 3890, '\P{^Is_Numeric_Value=7.50}', "");
    Error('\p{Is_Nv=-000015/2:=}');
    Error('\P{Is_Nv=-000015/2:=}');
    Expect(1, 3889, '\p{Is_Nv=0015/00000002}', "");
    Expect(0, 3889, '\p{^Is_Nv=0015/00000002}', "");
    Expect(0, 3889, '\P{Is_Nv=0015/00000002}', "");
    Expect(1, 3889, '\P{^Is_Nv=0015/00000002}', "");
    Expect(0, 3890, '\p{Is_Nv=0015/00000002}', "");
    Expect(1, 3890, '\p{^Is_Nv=0015/00000002}', "");
    Expect(1, 3890, '\P{Is_Nv=0015/00000002}', "");
    Expect(0, 3890, '\P{^Is_Nv=0015/00000002}', "");
    Expect(1, 3889, '\p{Is_Nv=900/120}', "");
    Expect(0, 3889, '\p{^Is_Nv=900/120}', "");
    Expect(0, 3889, '\P{Is_Nv=900/120}', "");
    Expect(1, 3889, '\P{^Is_Nv=900/120}', "");
    Expect(0, 3890, '\p{Is_Nv=900/120}', "");
    Expect(1, 3890, '\p{^Is_Nv=900/120}', "");
    Expect(1, 3890, '\P{Is_Nv=900/120}', "");
    Expect(0, 3890, '\P{^Is_Nv=900/120}', "");
    Expect(1, 3889, '\p{Is_Nv=7.5e+00}', "");
    Expect(0, 3889, '\p{^Is_Nv=7.5e+00}', "");
    Expect(0, 3889, '\P{Is_Nv=7.5e+00}', "");
    Expect(1, 3889, '\P{^Is_Nv=7.5e+00}', "");
    Expect(0, 3890, '\p{Is_Nv=7.5e+00}', "");
    Expect(1, 3890, '\p{^Is_Nv=7.5e+00}', "");
    Expect(1, 3890, '\P{Is_Nv=7.5e+00}', "");
    Expect(0, 3890, '\P{^Is_Nv=7.5e+00}', "");
    Expect(1, 3889, '\p{Is_Nv=7.5}', "");
    Expect(0, 3889, '\p{^Is_Nv=7.5}', "");
    Expect(0, 3889, '\P{Is_Nv=7.5}', "");
    Expect(1, 3889, '\P{^Is_Nv=7.5}', "");
    Expect(0, 3890, '\p{Is_Nv=7.5}', "");
    Expect(1, 3890, '\p{^Is_Nv=7.5}', "");
    Expect(1, 3890, '\P{Is_Nv=7.5}', "");
    Expect(0, 3890, '\P{^Is_Nv=7.5}', "");
    Expect(1, 3889, '\p{Is_Nv=7.50e+00}', "");
    Expect(0, 3889, '\p{^Is_Nv=7.50e+00}', "");
    Expect(0, 3889, '\P{Is_Nv=7.50e+00}', "");
    Expect(1, 3889, '\P{^Is_Nv=7.50e+00}', "");
    Expect(0, 3890, '\p{Is_Nv=7.50e+00}', "");
    Expect(1, 3890, '\p{^Is_Nv=7.50e+00}', "");
    Expect(1, 3890, '\P{Is_Nv=7.50e+00}', "");
    Expect(0, 3890, '\P{^Is_Nv=7.50e+00}', "");
    Expect(1, 3889, '\p{Is_Nv=7.50}', "");
    Expect(0, 3889, '\p{^Is_Nv=7.50}', "");
    Expect(0, 3889, '\P{Is_Nv=7.50}', "");
    Expect(1, 3889, '\P{^Is_Nv=7.50}', "");
    Expect(0, 3890, '\p{Is_Nv=7.50}', "");
    Expect(1, 3890, '\p{^Is_Nv=7.50}', "");
    Expect(1, 3890, '\P{Is_Nv=7.50}', "");
    Expect(0, 3890, '\P{^Is_Nv=7.50}', "");
    Error('\p{Numeric_Value=:=_00016}');
    Error('\P{Numeric_Value=:=_00016}');
    Expect(1, 119536, '\p{Numeric_Value=:\A16\z:}', "");;
    Expect(0, 119537, '\p{Numeric_Value=:\A16\z:}', "");;
    Expect(1, 119536, '\p{Numeric_Value=0_0_16}', "");
    Expect(0, 119536, '\p{^Numeric_Value=0_0_16}', "");
    Expect(0, 119536, '\P{Numeric_Value=0_0_16}', "");
    Expect(1, 119536, '\P{^Numeric_Value=0_0_16}', "");
    Expect(0, 119537, '\p{Numeric_Value=0_0_16}', "");
    Expect(1, 119537, '\p{^Numeric_Value=0_0_16}', "");
    Expect(1, 119537, '\P{Numeric_Value=0_0_16}', "");
    Expect(0, 119537, '\P{^Numeric_Value=0_0_16}', "");
    Expect(1, 119536, '\p{Numeric_Value=1.600000000000000e+01}', "");
    Expect(0, 119536, '\p{^Numeric_Value=1.600000000000000e+01}', "");
    Expect(0, 119536, '\P{Numeric_Value=1.600000000000000e+01}', "");
    Expect(1, 119536, '\P{^Numeric_Value=1.600000000000000e+01}', "");
    Expect(0, 119537, '\p{Numeric_Value=1.600000000000000e+01}', "");
    Expect(1, 119537, '\p{^Numeric_Value=1.600000000000000e+01}', "");
    Expect(1, 119537, '\P{Numeric_Value=1.600000000000000e+01}', "");
    Expect(0, 119537, '\P{^Numeric_Value=1.600000000000000e+01}', "");
    Error('\p{Nv=	00000000016/a/}');
    Error('\P{Nv=	00000000016/a/}');
    Expect(1, 119536, '\p{Nv=:\A16\z:}', "");;
    Expect(0, 119537, '\p{Nv=:\A16\z:}', "");;
    Expect(1, 119536, '\p{Nv=+0_0_0_016}', "");
    Expect(0, 119536, '\p{^Nv=+0_0_0_016}', "");
    Expect(0, 119536, '\P{Nv=+0_0_0_016}', "");
    Expect(1, 119536, '\P{^Nv=+0_0_0_016}', "");
    Expect(0, 119537, '\p{Nv=+0_0_0_016}', "");
    Expect(1, 119537, '\p{^Nv=+0_0_0_016}', "");
    Expect(1, 119537, '\P{Nv=+0_0_0_016}', "");
    Expect(0, 119537, '\P{^Nv=+0_0_0_016}', "");
    Expect(1, 119536, '\p{Nv=1.600000000000000e+01}', "");
    Expect(0, 119536, '\p{^Nv=1.600000000000000e+01}', "");
    Expect(0, 119536, '\P{Nv=1.600000000000000e+01}', "");
    Expect(1, 119536, '\P{^Nv=1.600000000000000e+01}', "");
    Expect(0, 119537, '\p{Nv=1.600000000000000e+01}', "");
    Expect(1, 119537, '\p{^Nv=1.600000000000000e+01}', "");
    Expect(1, 119537, '\P{Nv=1.600000000000000e+01}', "");
    Expect(0, 119537, '\P{^Nv=1.600000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=		0_0_0_0_0_016:=}');
    Error('\P{Is_Numeric_Value=		0_0_0_0_0_016:=}');
    Expect(1, 119536, '\p{Is_Numeric_Value=16}', "");
    Expect(0, 119536, '\p{^Is_Numeric_Value=16}', "");
    Expect(0, 119536, '\P{Is_Numeric_Value=16}', "");
    Expect(1, 119536, '\P{^Is_Numeric_Value=16}', "");
    Expect(0, 119537, '\p{Is_Numeric_Value=16}', "");
    Expect(1, 119537, '\p{^Is_Numeric_Value=16}', "");
    Expect(1, 119537, '\P{Is_Numeric_Value=16}', "");
    Expect(0, 119537, '\P{^Is_Numeric_Value=16}', "");
    Expect(1, 119536, '\p{Is_Numeric_Value=1.600000000000000e+01}', "");
    Expect(0, 119536, '\p{^Is_Numeric_Value=1.600000000000000e+01}', "");
    Expect(0, 119536, '\P{Is_Numeric_Value=1.600000000000000e+01}', "");
    Expect(1, 119536, '\P{^Is_Numeric_Value=1.600000000000000e+01}', "");
    Expect(0, 119537, '\p{Is_Numeric_Value=1.600000000000000e+01}', "");
    Expect(1, 119537, '\p{^Is_Numeric_Value=1.600000000000000e+01}', "");
    Expect(1, 119537, '\P{Is_Numeric_Value=1.600000000000000e+01}', "");
    Expect(0, 119537, '\P{^Is_Numeric_Value=1.600000000000000e+01}', "");
    Error('\p{Is_Nv=_:=0000016}');
    Error('\P{Is_Nv=_:=0000016}');
    Expect(1, 119536, '\p{Is_Nv=000001_6}', "");
    Expect(0, 119536, '\p{^Is_Nv=000001_6}', "");
    Expect(0, 119536, '\P{Is_Nv=000001_6}', "");
    Expect(1, 119536, '\P{^Is_Nv=000001_6}', "");
    Expect(0, 119537, '\p{Is_Nv=000001_6}', "");
    Expect(1, 119537, '\p{^Is_Nv=000001_6}', "");
    Expect(1, 119537, '\P{Is_Nv=000001_6}', "");
    Expect(0, 119537, '\P{^Is_Nv=000001_6}', "");
    Expect(1, 119536, '\p{Is_Nv:1.600000000000000e+01}', "");
    Expect(0, 119536, '\p{^Is_Nv:1.600000000000000e+01}', "");
    Expect(0, 119536, '\P{Is_Nv:1.600000000000000e+01}', "");
    Expect(1, 119536, '\P{^Is_Nv:1.600000000000000e+01}', "");
    Expect(0, 119537, '\p{Is_Nv:1.600000000000000e+01}', "");
    Expect(1, 119537, '\p{^Is_Nv:1.600000000000000e+01}', "");
    Expect(1, 119537, '\P{Is_Nv:1.600000000000000e+01}', "");
    Expect(0, 119537, '\P{^Is_Nv:1.600000000000000e+01}', "");
    Error('\p{Numeric_Value=_:=17}');
    Error('\P{Numeric_Value=_:=17}');
    Expect(1, 119537, '\p{Numeric_Value=:\A17\z:}', "");;
    Expect(0, 119538, '\p{Numeric_Value=:\A17\z:}', "");;
    Expect(1, 119537, '\p{Numeric_Value:	000000017}', "");
    Expect(0, 119537, '\p{^Numeric_Value:	000000017}', "");
    Expect(0, 119537, '\P{Numeric_Value:	000000017}', "");
    Expect(1, 119537, '\P{^Numeric_Value:	000000017}', "");
    Expect(0, 119538, '\p{Numeric_Value:	000000017}', "");
    Expect(1, 119538, '\p{^Numeric_Value:	000000017}', "");
    Expect(1, 119538, '\P{Numeric_Value:	000000017}', "");
    Expect(0, 119538, '\P{^Numeric_Value:	000000017}', "");
    Expect(1, 119537, '\p{Numeric_Value=1.700000000000000e+01}', "");
    Expect(0, 119537, '\p{^Numeric_Value=1.700000000000000e+01}', "");
    Expect(0, 119537, '\P{Numeric_Value=1.700000000000000e+01}', "");
    Expect(1, 119537, '\P{^Numeric_Value=1.700000000000000e+01}', "");
    Expect(0, 119538, '\p{Numeric_Value=1.700000000000000e+01}', "");
    Expect(1, 119538, '\p{^Numeric_Value=1.700000000000000e+01}', "");
    Expect(1, 119538, '\P{Numeric_Value=1.700000000000000e+01}', "");
    Expect(0, 119538, '\P{^Numeric_Value=1.700000000000000e+01}', "");
    Error('\p{Nv:/a/ 	00000000017}');
    Error('\P{Nv:/a/ 	00000000017}');
    Expect(1, 119537, '\p{Nv=:\A17\z:}', "");;
    Expect(0, 119538, '\p{Nv=:\A17\z:}', "");;
    Expect(1, 119537, '\p{Nv=+017}', "");
    Expect(0, 119537, '\p{^Nv=+017}', "");
    Expect(0, 119537, '\P{Nv=+017}', "");
    Expect(1, 119537, '\P{^Nv=+017}', "");
    Expect(0, 119538, '\p{Nv=+017}', "");
    Expect(1, 119538, '\p{^Nv=+017}', "");
    Expect(1, 119538, '\P{Nv=+017}', "");
    Expect(0, 119538, '\P{^Nv=+017}', "");
    Expect(1, 119537, '\p{Nv=1.700000000000000e+01}', "");
    Expect(0, 119537, '\p{^Nv=1.700000000000000e+01}', "");
    Expect(0, 119537, '\P{Nv=1.700000000000000e+01}', "");
    Expect(1, 119537, '\P{^Nv=1.700000000000000e+01}', "");
    Expect(0, 119538, '\p{Nv=1.700000000000000e+01}', "");
    Expect(1, 119538, '\p{^Nv=1.700000000000000e+01}', "");
    Expect(1, 119538, '\P{Nv=1.700000000000000e+01}', "");
    Expect(0, 119538, '\P{^Nv=1.700000000000000e+01}', "");
    Error('\p{Is_Numeric_Value= /a/017}');
    Error('\P{Is_Numeric_Value= /a/017}');
    Expect(1, 119537, '\p{Is_Numeric_Value=+0_0_0_0_0_0_0_0017}', "");
    Expect(0, 119537, '\p{^Is_Numeric_Value=+0_0_0_0_0_0_0_0017}', "");
    Expect(0, 119537, '\P{Is_Numeric_Value=+0_0_0_0_0_0_0_0017}', "");
    Expect(1, 119537, '\P{^Is_Numeric_Value=+0_0_0_0_0_0_0_0017}', "");
    Expect(0, 119538, '\p{Is_Numeric_Value=+0_0_0_0_0_0_0_0017}', "");
    Expect(1, 119538, '\p{^Is_Numeric_Value=+0_0_0_0_0_0_0_0017}', "");
    Expect(1, 119538, '\P{Is_Numeric_Value=+0_0_0_0_0_0_0_0017}', "");
    Expect(0, 119538, '\P{^Is_Numeric_Value=+0_0_0_0_0_0_0_0017}', "");
    Expect(1, 119537, '\p{Is_Numeric_Value=1.700000000000000e+01}', "");
    Expect(0, 119537, '\p{^Is_Numeric_Value=1.700000000000000e+01}', "");
    Expect(0, 119537, '\P{Is_Numeric_Value=1.700000000000000e+01}', "");
    Expect(1, 119537, '\P{^Is_Numeric_Value=1.700000000000000e+01}', "");
    Expect(0, 119538, '\p{Is_Numeric_Value=1.700000000000000e+01}', "");
    Expect(1, 119538, '\p{^Is_Numeric_Value=1.700000000000000e+01}', "");
    Expect(1, 119538, '\P{Is_Numeric_Value=1.700000000000000e+01}', "");
    Expect(0, 119538, '\P{^Is_Numeric_Value=1.700000000000000e+01}', "");
    Error('\p{Is_Nv=:= -00_00_00_00_17}');
    Error('\P{Is_Nv=:= -00_00_00_00_17}');
    Expect(1, 119537, '\p{Is_Nv=00017}', "");
    Expect(0, 119537, '\p{^Is_Nv=00017}', "");
    Expect(0, 119537, '\P{Is_Nv=00017}', "");
    Expect(1, 119537, '\P{^Is_Nv=00017}', "");
    Expect(0, 119538, '\p{Is_Nv=00017}', "");
    Expect(1, 119538, '\p{^Is_Nv=00017}', "");
    Expect(1, 119538, '\P{Is_Nv=00017}', "");
    Expect(0, 119538, '\P{^Is_Nv=00017}', "");
    Expect(1, 119537, '\p{Is_Nv=1.700000000000000e+01}', "");
    Expect(0, 119537, '\p{^Is_Nv=1.700000000000000e+01}', "");
    Expect(0, 119537, '\P{Is_Nv=1.700000000000000e+01}', "");
    Expect(1, 119537, '\P{^Is_Nv=1.700000000000000e+01}', "");
    Expect(0, 119538, '\p{Is_Nv=1.700000000000000e+01}', "");
    Expect(1, 119538, '\p{^Is_Nv=1.700000000000000e+01}', "");
    Expect(1, 119538, '\P{Is_Nv=1.700000000000000e+01}', "");
    Expect(0, 119538, '\P{^Is_Nv=1.700000000000000e+01}', "");
    Error('\p{Numeric_Value:	_/a/0000017/00002}');
    Error('\P{Numeric_Value:	_/a/0000017/00002}');
    Expect(1, 3890, '\p{Numeric_Value=:\A17/2\z:}', "");;
    Expect(0, 3891, '\p{Numeric_Value=:\A17/2\z:}', "");;
    Expect(1, 3890, '\p{Numeric_Value:	017/0002}', "");
    Expect(0, 3890, '\p{^Numeric_Value:	017/0002}', "");
    Expect(0, 3890, '\P{Numeric_Value:	017/0002}', "");
    Expect(1, 3890, '\P{^Numeric_Value:	017/0002}', "");
    Expect(0, 3891, '\p{Numeric_Value:	017/0002}', "");
    Expect(1, 3891, '\p{^Numeric_Value:	017/0002}', "");
    Expect(1, 3891, '\P{Numeric_Value:	017/0002}', "");
    Expect(0, 3891, '\P{^Numeric_Value:	017/0002}', "");
    Expect(1, 3890, '\p{Numeric_Value=1020/120}', "");
    Expect(0, 3890, '\p{^Numeric_Value=1020/120}', "");
    Expect(0, 3890, '\P{Numeric_Value=1020/120}', "");
    Expect(1, 3890, '\P{^Numeric_Value=1020/120}', "");
    Expect(0, 3891, '\p{Numeric_Value=1020/120}', "");
    Expect(1, 3891, '\p{^Numeric_Value=1020/120}', "");
    Expect(1, 3891, '\P{Numeric_Value=1020/120}', "");
    Expect(0, 3891, '\P{^Numeric_Value=1020/120}', "");
    Expect(1, 3890, '\p{Numeric_Value=8.5e+00}', "");
    Expect(0, 3890, '\p{^Numeric_Value=8.5e+00}', "");
    Expect(0, 3890, '\P{Numeric_Value=8.5e+00}', "");
    Expect(1, 3890, '\P{^Numeric_Value=8.5e+00}', "");
    Expect(0, 3891, '\p{Numeric_Value=8.5e+00}', "");
    Expect(1, 3891, '\p{^Numeric_Value=8.5e+00}', "");
    Expect(1, 3891, '\P{Numeric_Value=8.5e+00}', "");
    Expect(0, 3891, '\P{^Numeric_Value=8.5e+00}', "");
    Expect(1, 3890, '\p{Numeric_Value=8.5}', "");
    Expect(0, 3890, '\p{^Numeric_Value=8.5}', "");
    Expect(0, 3890, '\P{Numeric_Value=8.5}', "");
    Expect(1, 3890, '\P{^Numeric_Value=8.5}', "");
    Expect(0, 3891, '\p{Numeric_Value=8.5}', "");
    Expect(1, 3891, '\p{^Numeric_Value=8.5}', "");
    Expect(1, 3891, '\P{Numeric_Value=8.5}', "");
    Expect(0, 3891, '\P{^Numeric_Value=8.5}', "");
    Expect(1, 3890, '\p{Numeric_Value:	8.50e+00}', "");
    Expect(0, 3890, '\p{^Numeric_Value:	8.50e+00}', "");
    Expect(0, 3890, '\P{Numeric_Value:	8.50e+00}', "");
    Expect(1, 3890, '\P{^Numeric_Value:	8.50e+00}', "");
    Expect(0, 3891, '\p{Numeric_Value:	8.50e+00}', "");
    Expect(1, 3891, '\p{^Numeric_Value:	8.50e+00}', "");
    Expect(1, 3891, '\P{Numeric_Value:	8.50e+00}', "");
    Expect(0, 3891, '\P{^Numeric_Value:	8.50e+00}', "");
    Expect(1, 3890, '\p{Numeric_Value=8.50}', "");
    Expect(0, 3890, '\p{^Numeric_Value=8.50}', "");
    Expect(0, 3890, '\P{Numeric_Value=8.50}', "");
    Expect(1, 3890, '\P{^Numeric_Value=8.50}', "");
    Expect(0, 3891, '\p{Numeric_Value=8.50}', "");
    Expect(1, 3891, '\p{^Numeric_Value=8.50}', "");
    Expect(1, 3891, '\P{Numeric_Value=8.50}', "");
    Expect(0, 3891, '\P{^Numeric_Value=8.50}', "");
    Error('\p{Nv:   /a/_-17/0000002}');
    Error('\P{Nv:   /a/_-17/0000002}');
    Expect(1, 3890, '\p{Nv=:\A17/2\z:}', "");;
    Expect(0, 3891, '\p{Nv=:\A17/2\z:}', "");;
    Expect(1, 3890, '\p{Nv=000000017/002}', "");
    Expect(0, 3890, '\p{^Nv=000000017/002}', "");
    Expect(0, 3890, '\P{Nv=000000017/002}', "");
    Expect(1, 3890, '\P{^Nv=000000017/002}', "");
    Expect(0, 3891, '\p{Nv=000000017/002}', "");
    Expect(1, 3891, '\p{^Nv=000000017/002}', "");
    Expect(1, 3891, '\P{Nv=000000017/002}', "");
    Expect(0, 3891, '\P{^Nv=000000017/002}', "");
    Expect(1, 3890, '\p{Nv=1020/120}', "");
    Expect(0, 3890, '\p{^Nv=1020/120}', "");
    Expect(0, 3890, '\P{Nv=1020/120}', "");
    Expect(1, 3890, '\P{^Nv=1020/120}', "");
    Expect(0, 3891, '\p{Nv=1020/120}', "");
    Expect(1, 3891, '\p{^Nv=1020/120}', "");
    Expect(1, 3891, '\P{Nv=1020/120}', "");
    Expect(0, 3891, '\P{^Nv=1020/120}', "");
    Expect(1, 3890, '\p{Nv=8.5e+00}', "");
    Expect(0, 3890, '\p{^Nv=8.5e+00}', "");
    Expect(0, 3890, '\P{Nv=8.5e+00}', "");
    Expect(1, 3890, '\P{^Nv=8.5e+00}', "");
    Expect(0, 3891, '\p{Nv=8.5e+00}', "");
    Expect(1, 3891, '\p{^Nv=8.5e+00}', "");
    Expect(1, 3891, '\P{Nv=8.5e+00}', "");
    Expect(0, 3891, '\P{^Nv=8.5e+00}', "");
    Expect(1, 3890, '\p{Nv:8.5}', "");
    Expect(0, 3890, '\p{^Nv:8.5}', "");
    Expect(0, 3890, '\P{Nv:8.5}', "");
    Expect(1, 3890, '\P{^Nv:8.5}', "");
    Expect(0, 3891, '\p{Nv:8.5}', "");
    Expect(1, 3891, '\p{^Nv:8.5}', "");
    Expect(1, 3891, '\P{Nv:8.5}', "");
    Expect(0, 3891, '\P{^Nv:8.5}', "");
    Expect(1, 3890, '\p{Nv=8.50e+00}', "");
    Expect(0, 3890, '\p{^Nv=8.50e+00}', "");
    Expect(0, 3890, '\P{Nv=8.50e+00}', "");
    Expect(1, 3890, '\P{^Nv=8.50e+00}', "");
    Expect(0, 3891, '\p{Nv=8.50e+00}', "");
    Expect(1, 3891, '\p{^Nv=8.50e+00}', "");
    Expect(1, 3891, '\P{Nv=8.50e+00}', "");
    Expect(0, 3891, '\P{^Nv=8.50e+00}', "");
    Expect(1, 3890, '\p{Nv=8.50}', "");
    Expect(0, 3890, '\p{^Nv=8.50}', "");
    Expect(0, 3890, '\P{Nv=8.50}', "");
    Expect(1, 3890, '\P{^Nv=8.50}', "");
    Expect(0, 3891, '\p{Nv=8.50}', "");
    Expect(1, 3891, '\p{^Nv=8.50}', "");
    Expect(1, 3891, '\P{Nv=8.50}', "");
    Expect(0, 3891, '\P{^Nv=8.50}', "");
    Error('\p{Is_Numeric_Value=/a/ _0000017/00002}');
    Error('\P{Is_Numeric_Value=/a/ _0000017/00002}');
    Expect(1, 3890, '\p{Is_Numeric_Value=+0000000017/0000002}', "");
    Expect(0, 3890, '\p{^Is_Numeric_Value=+0000000017/0000002}', "");
    Expect(0, 3890, '\P{Is_Numeric_Value=+0000000017/0000002}', "");
    Expect(1, 3890, '\P{^Is_Numeric_Value=+0000000017/0000002}', "");
    Expect(0, 3891, '\p{Is_Numeric_Value=+0000000017/0000002}', "");
    Expect(1, 3891, '\p{^Is_Numeric_Value=+0000000017/0000002}', "");
    Expect(1, 3891, '\P{Is_Numeric_Value=+0000000017/0000002}', "");
    Expect(0, 3891, '\P{^Is_Numeric_Value=+0000000017/0000002}', "");
    Expect(1, 3890, '\p{Is_Numeric_Value=1020/120}', "");
    Expect(0, 3890, '\p{^Is_Numeric_Value=1020/120}', "");
    Expect(0, 3890, '\P{Is_Numeric_Value=1020/120}', "");
    Expect(1, 3890, '\P{^Is_Numeric_Value=1020/120}', "");
    Expect(0, 3891, '\p{Is_Numeric_Value=1020/120}', "");
    Expect(1, 3891, '\p{^Is_Numeric_Value=1020/120}', "");
    Expect(1, 3891, '\P{Is_Numeric_Value=1020/120}', "");
    Expect(0, 3891, '\P{^Is_Numeric_Value=1020/120}', "");
    Expect(1, 3890, '\p{Is_Numeric_Value=8.5e+00}', "");
    Expect(0, 3890, '\p{^Is_Numeric_Value=8.5e+00}', "");
    Expect(0, 3890, '\P{Is_Numeric_Value=8.5e+00}', "");
    Expect(1, 3890, '\P{^Is_Numeric_Value=8.5e+00}', "");
    Expect(0, 3891, '\p{Is_Numeric_Value=8.5e+00}', "");
    Expect(1, 3891, '\p{^Is_Numeric_Value=8.5e+00}', "");
    Expect(1, 3891, '\P{Is_Numeric_Value=8.5e+00}', "");
    Expect(0, 3891, '\P{^Is_Numeric_Value=8.5e+00}', "");
    Expect(1, 3890, '\p{Is_Numeric_Value=8.5}', "");
    Expect(0, 3890, '\p{^Is_Numeric_Value=8.5}', "");
    Expect(0, 3890, '\P{Is_Numeric_Value=8.5}', "");
    Expect(1, 3890, '\P{^Is_Numeric_Value=8.5}', "");
    Expect(0, 3891, '\p{Is_Numeric_Value=8.5}', "");
    Expect(1, 3891, '\p{^Is_Numeric_Value=8.5}', "");
    Expect(1, 3891, '\P{Is_Numeric_Value=8.5}', "");
    Expect(0, 3891, '\P{^Is_Numeric_Value=8.5}', "");
    Expect(1, 3890, '\p{Is_Numeric_Value=8.50e+00}', "");
    Expect(0, 3890, '\p{^Is_Numeric_Value=8.50e+00}', "");
    Expect(0, 3890, '\P{Is_Numeric_Value=8.50e+00}', "");
    Expect(1, 3890, '\P{^Is_Numeric_Value=8.50e+00}', "");
    Expect(0, 3891, '\p{Is_Numeric_Value=8.50e+00}', "");
    Expect(1, 3891, '\p{^Is_Numeric_Value=8.50e+00}', "");
    Expect(1, 3891, '\P{Is_Numeric_Value=8.50e+00}', "");
    Expect(0, 3891, '\P{^Is_Numeric_Value=8.50e+00}', "");
    Expect(1, 3890, '\p{Is_Numeric_Value=8.50}', "");
    Expect(0, 3890, '\p{^Is_Numeric_Value=8.50}', "");
    Expect(0, 3890, '\P{Is_Numeric_Value=8.50}', "");
    Expect(1, 3890, '\P{^Is_Numeric_Value=8.50}', "");
    Expect(0, 3891, '\p{Is_Numeric_Value=8.50}', "");
    Expect(1, 3891, '\p{^Is_Numeric_Value=8.50}', "");
    Expect(1, 3891, '\P{Is_Numeric_Value=8.50}', "");
    Expect(0, 3891, '\P{^Is_Numeric_Value=8.50}', "");
    Error('\p{Is_Nv=:=-_00017/002}');
    Error('\P{Is_Nv=:=-_00017/002}');
    Expect(1, 3890, '\p{Is_Nv=00017/000002}', "");
    Expect(0, 3890, '\p{^Is_Nv=00017/000002}', "");
    Expect(0, 3890, '\P{Is_Nv=00017/000002}', "");
    Expect(1, 3890, '\P{^Is_Nv=00017/000002}', "");
    Expect(0, 3891, '\p{Is_Nv=00017/000002}', "");
    Expect(1, 3891, '\p{^Is_Nv=00017/000002}', "");
    Expect(1, 3891, '\P{Is_Nv=00017/000002}', "");
    Expect(0, 3891, '\P{^Is_Nv=00017/000002}', "");
    Expect(1, 3890, '\p{Is_Nv=1020/120}', "");
    Expect(0, 3890, '\p{^Is_Nv=1020/120}', "");
    Expect(0, 3890, '\P{Is_Nv=1020/120}', "");
    Expect(1, 3890, '\P{^Is_Nv=1020/120}', "");
    Expect(0, 3891, '\p{Is_Nv=1020/120}', "");
    Expect(1, 3891, '\p{^Is_Nv=1020/120}', "");
    Expect(1, 3891, '\P{Is_Nv=1020/120}', "");
    Expect(0, 3891, '\P{^Is_Nv=1020/120}', "");
    Expect(1, 3890, '\p{Is_Nv=8.5e+00}', "");
    Expect(0, 3890, '\p{^Is_Nv=8.5e+00}', "");
    Expect(0, 3890, '\P{Is_Nv=8.5e+00}', "");
    Expect(1, 3890, '\P{^Is_Nv=8.5e+00}', "");
    Expect(0, 3891, '\p{Is_Nv=8.5e+00}', "");
    Expect(1, 3891, '\p{^Is_Nv=8.5e+00}', "");
    Expect(1, 3891, '\P{Is_Nv=8.5e+00}', "");
    Expect(0, 3891, '\P{^Is_Nv=8.5e+00}', "");
    Expect(1, 3890, '\p{Is_Nv=8.5}', "");
    Expect(0, 3890, '\p{^Is_Nv=8.5}', "");
    Expect(0, 3890, '\P{Is_Nv=8.5}', "");
    Expect(1, 3890, '\P{^Is_Nv=8.5}', "");
    Expect(0, 3891, '\p{Is_Nv=8.5}', "");
    Expect(1, 3891, '\p{^Is_Nv=8.5}', "");
    Expect(1, 3891, '\P{Is_Nv=8.5}', "");
    Expect(0, 3891, '\P{^Is_Nv=8.5}', "");
    Expect(1, 3890, '\p{Is_Nv:8.50e+00}', "");
    Expect(0, 3890, '\p{^Is_Nv:8.50e+00}', "");
    Expect(0, 3890, '\P{Is_Nv:8.50e+00}', "");
    Expect(1, 3890, '\P{^Is_Nv:8.50e+00}', "");
    Expect(0, 3891, '\p{Is_Nv:8.50e+00}', "");
    Expect(1, 3891, '\p{^Is_Nv:8.50e+00}', "");
    Expect(1, 3891, '\P{Is_Nv:8.50e+00}', "");
    Expect(0, 3891, '\P{^Is_Nv:8.50e+00}', "");
    Expect(1, 3890, '\p{Is_Nv=8.50}', "");
    Expect(0, 3890, '\p{^Is_Nv=8.50}', "");
    Expect(0, 3890, '\P{Is_Nv=8.50}', "");
    Expect(1, 3890, '\P{^Is_Nv=8.50}', "");
    Expect(0, 3891, '\p{Is_Nv=8.50}', "");
    Expect(1, 3891, '\p{^Is_Nv=8.50}', "");
    Expect(1, 3891, '\P{Is_Nv=8.50}', "");
    Expect(0, 3891, '\P{^Is_Nv=8.50}', "");
    Error('\p{Numeric_Value= _000000018:=}');
    Error('\P{Numeric_Value= _000000018:=}');
    Expect(1, 119538, '\p{Numeric_Value=:\A18\z:}', "");;
    Expect(0, 119539, '\p{Numeric_Value=:\A18\z:}', "");;
    Expect(1, 119538, '\p{Numeric_Value: +00000018}', "");
    Expect(0, 119538, '\p{^Numeric_Value: +00000018}', "");
    Expect(0, 119538, '\P{Numeric_Value: +00000018}', "");
    Expect(1, 119538, '\P{^Numeric_Value: +00000018}', "");
    Expect(0, 119539, '\p{Numeric_Value: +00000018}', "");
    Expect(1, 119539, '\p{^Numeric_Value: +00000018}', "");
    Expect(1, 119539, '\P{Numeric_Value: +00000018}', "");
    Expect(0, 119539, '\P{^Numeric_Value: +00000018}', "");
    Expect(1, 119538, '\p{Numeric_Value=1.800000000000000e+01}', "");
    Expect(0, 119538, '\p{^Numeric_Value=1.800000000000000e+01}', "");
    Expect(0, 119538, '\P{Numeric_Value=1.800000000000000e+01}', "");
    Expect(1, 119538, '\P{^Numeric_Value=1.800000000000000e+01}', "");
    Expect(0, 119539, '\p{Numeric_Value=1.800000000000000e+01}', "");
    Expect(1, 119539, '\p{^Numeric_Value=1.800000000000000e+01}', "");
    Expect(1, 119539, '\P{Numeric_Value=1.800000000000000e+01}', "");
    Expect(0, 119539, '\P{^Numeric_Value=1.800000000000000e+01}', "");
    Error('\p{Nv=_:=0018}');
    Error('\P{Nv=_:=0018}');
    Expect(1, 119538, '\p{Nv=:\A18\z:}', "");;
    Expect(0, 119539, '\p{Nv=:\A18\z:}', "");;
    Expect(1, 119538, '\p{Nv=+0000_0000_18}', "");
    Expect(0, 119538, '\p{^Nv=+0000_0000_18}', "");
    Expect(0, 119538, '\P{Nv=+0000_0000_18}', "");
    Expect(1, 119538, '\P{^Nv=+0000_0000_18}', "");
    Expect(0, 119539, '\p{Nv=+0000_0000_18}', "");
    Expect(1, 119539, '\p{^Nv=+0000_0000_18}', "");
    Expect(1, 119539, '\P{Nv=+0000_0000_18}', "");
    Expect(0, 119539, '\P{^Nv=+0000_0000_18}', "");
    Expect(1, 119538, '\p{Nv=1.800000000000000e+01}', "");
    Expect(0, 119538, '\p{^Nv=1.800000000000000e+01}', "");
    Expect(0, 119538, '\P{Nv=1.800000000000000e+01}', "");
    Expect(1, 119538, '\P{^Nv=1.800000000000000e+01}', "");
    Expect(0, 119539, '\p{Nv=1.800000000000000e+01}', "");
    Expect(1, 119539, '\p{^Nv=1.800000000000000e+01}', "");
    Expect(1, 119539, '\P{Nv=1.800000000000000e+01}', "");
    Expect(0, 119539, '\P{^Nv=1.800000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=:=-_00000000018}');
    Error('\P{Is_Numeric_Value=:=-_00000000018}');
    Expect(1, 119538, '\p{Is_Numeric_Value=01_8}', "");
    Expect(0, 119538, '\p{^Is_Numeric_Value=01_8}', "");
    Expect(0, 119538, '\P{Is_Numeric_Value=01_8}', "");
    Expect(1, 119538, '\P{^Is_Numeric_Value=01_8}', "");
    Expect(0, 119539, '\p{Is_Numeric_Value=01_8}', "");
    Expect(1, 119539, '\p{^Is_Numeric_Value=01_8}', "");
    Expect(1, 119539, '\P{Is_Numeric_Value=01_8}', "");
    Expect(0, 119539, '\P{^Is_Numeric_Value=01_8}', "");
    Expect(1, 119538, '\p{Is_Numeric_Value=1.800000000000000e+01}', "");
    Expect(0, 119538, '\p{^Is_Numeric_Value=1.800000000000000e+01}', "");
    Expect(0, 119538, '\P{Is_Numeric_Value=1.800000000000000e+01}', "");
    Expect(1, 119538, '\P{^Is_Numeric_Value=1.800000000000000e+01}', "");
    Expect(0, 119539, '\p{Is_Numeric_Value=1.800000000000000e+01}', "");
    Expect(1, 119539, '\p{^Is_Numeric_Value=1.800000000000000e+01}', "");
    Expect(1, 119539, '\P{Is_Numeric_Value=1.800000000000000e+01}', "");
    Expect(0, 119539, '\P{^Is_Numeric_Value=1.800000000000000e+01}', "");
    Error('\p{Is_Nv=:=_0_0_0_0_0_018}');
    Error('\P{Is_Nv=:=_0_0_0_0_0_018}');
    Expect(1, 119538, '\p{Is_Nv=00000001_8}', "");
    Expect(0, 119538, '\p{^Is_Nv=00000001_8}', "");
    Expect(0, 119538, '\P{Is_Nv=00000001_8}', "");
    Expect(1, 119538, '\P{^Is_Nv=00000001_8}', "");
    Expect(0, 119539, '\p{Is_Nv=00000001_8}', "");
    Expect(1, 119539, '\p{^Is_Nv=00000001_8}', "");
    Expect(1, 119539, '\P{Is_Nv=00000001_8}', "");
    Expect(0, 119539, '\P{^Is_Nv=00000001_8}', "");
    Expect(1, 119538, '\p{Is_Nv=1.800000000000000e+01}', "");
    Expect(0, 119538, '\p{^Is_Nv=1.800000000000000e+01}', "");
    Expect(0, 119538, '\P{Is_Nv=1.800000000000000e+01}', "");
    Expect(1, 119538, '\P{^Is_Nv=1.800000000000000e+01}', "");
    Expect(0, 119539, '\p{Is_Nv=1.800000000000000e+01}', "");
    Expect(1, 119539, '\p{^Is_Nv=1.800000000000000e+01}', "");
    Expect(1, 119539, '\P{Is_Nv=1.800000000000000e+01}', "");
    Expect(0, 119539, '\P{^Is_Nv=1.800000000000000e+01}', "");
    Error('\p{Numeric_Value=-:=19}');
    Error('\P{Numeric_Value=-:=19}');
    Expect(1, 119539, '\p{Numeric_Value=:\A19\z:}', "");;
    Expect(0, 119540, '\p{Numeric_Value=:\A19\z:}', "");;
    Expect(1, 119539, '\p{Numeric_Value=0019}', "");
    Expect(0, 119539, '\p{^Numeric_Value=0019}', "");
    Expect(0, 119539, '\P{Numeric_Value=0019}', "");
    Expect(1, 119539, '\P{^Numeric_Value=0019}', "");
    Expect(0, 119540, '\p{Numeric_Value=0019}', "");
    Expect(1, 119540, '\p{^Numeric_Value=0019}', "");
    Expect(1, 119540, '\P{Numeric_Value=0019}', "");
    Expect(0, 119540, '\P{^Numeric_Value=0019}', "");
    Expect(1, 119539, '\p{Numeric_Value: 1.900000000000000e+01}', "");
    Expect(0, 119539, '\p{^Numeric_Value: 1.900000000000000e+01}', "");
    Expect(0, 119539, '\P{Numeric_Value: 1.900000000000000e+01}', "");
    Expect(1, 119539, '\P{^Numeric_Value: 1.900000000000000e+01}', "");
    Expect(0, 119540, '\p{Numeric_Value: 1.900000000000000e+01}', "");
    Expect(1, 119540, '\p{^Numeric_Value: 1.900000000000000e+01}', "");
    Expect(1, 119540, '\P{Numeric_Value: 1.900000000000000e+01}', "");
    Expect(0, 119540, '\P{^Numeric_Value: 1.900000000000000e+01}', "");
    Error('\p{Nv=	+0000019/a/}');
    Error('\P{Nv=	+0000019/a/}');
    Expect(1, 119539, '\p{Nv=:\A19\z:}', "");;
    Expect(0, 119540, '\p{Nv=:\A19\z:}', "");;
    Expect(1, 119539, '\p{Nv=+019}', "");
    Expect(0, 119539, '\p{^Nv=+019}', "");
    Expect(0, 119539, '\P{Nv=+019}', "");
    Expect(1, 119539, '\P{^Nv=+019}', "");
    Expect(0, 119540, '\p{Nv=+019}', "");
    Expect(1, 119540, '\p{^Nv=+019}', "");
    Expect(1, 119540, '\P{Nv=+019}', "");
    Expect(0, 119540, '\P{^Nv=+019}', "");
    Expect(1, 119539, '\p{Nv=1.900000000000000e+01}', "");
    Expect(0, 119539, '\p{^Nv=1.900000000000000e+01}', "");
    Expect(0, 119539, '\P{Nv=1.900000000000000e+01}', "");
    Expect(1, 119539, '\P{^Nv=1.900000000000000e+01}', "");
    Expect(0, 119540, '\p{Nv=1.900000000000000e+01}', "");
    Expect(1, 119540, '\p{^Nv=1.900000000000000e+01}', "");
    Expect(1, 119540, '\P{Nv=1.900000000000000e+01}', "");
    Expect(0, 119540, '\P{^Nv=1.900000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=/a/-1_9}');
    Error('\P{Is_Numeric_Value=/a/-1_9}');
    Expect(1, 119539, '\p{Is_Numeric_Value:0000001_9}', "");
    Expect(0, 119539, '\p{^Is_Numeric_Value:0000001_9}', "");
    Expect(0, 119539, '\P{Is_Numeric_Value:0000001_9}', "");
    Expect(1, 119539, '\P{^Is_Numeric_Value:0000001_9}', "");
    Expect(0, 119540, '\p{Is_Numeric_Value:0000001_9}', "");
    Expect(1, 119540, '\p{^Is_Numeric_Value:0000001_9}', "");
    Expect(1, 119540, '\P{Is_Numeric_Value:0000001_9}', "");
    Expect(0, 119540, '\P{^Is_Numeric_Value:0000001_9}', "");
    Expect(1, 119539, '\p{Is_Numeric_Value: 1.900000000000000e+01}', "");
    Expect(0, 119539, '\p{^Is_Numeric_Value: 1.900000000000000e+01}', "");
    Expect(0, 119539, '\P{Is_Numeric_Value: 1.900000000000000e+01}', "");
    Expect(1, 119539, '\P{^Is_Numeric_Value: 1.900000000000000e+01}', "");
    Expect(0, 119540, '\p{Is_Numeric_Value: 1.900000000000000e+01}', "");
    Expect(1, 119540, '\p{^Is_Numeric_Value: 1.900000000000000e+01}', "");
    Expect(1, 119540, '\P{Is_Numeric_Value: 1.900000000000000e+01}', "");
    Expect(0, 119540, '\P{^Is_Numeric_Value: 1.900000000000000e+01}', "");
    Error('\p{Is_Nv=:=01_9}');
    Error('\P{Is_Nv=:=01_9}');
    Expect(1, 119539, '\p{Is_Nv=+0_0_0_0_0_19}', "");
    Expect(0, 119539, '\p{^Is_Nv=+0_0_0_0_0_19}', "");
    Expect(0, 119539, '\P{Is_Nv=+0_0_0_0_0_19}', "");
    Expect(1, 119539, '\P{^Is_Nv=+0_0_0_0_0_19}', "");
    Expect(0, 119540, '\p{Is_Nv=+0_0_0_0_0_19}', "");
    Expect(1, 119540, '\p{^Is_Nv=+0_0_0_0_0_19}', "");
    Expect(1, 119540, '\P{Is_Nv=+0_0_0_0_0_19}', "");
    Expect(0, 119540, '\P{^Is_Nv=+0_0_0_0_0_19}', "");
    Expect(1, 119539, '\p{Is_Nv=1.900000000000000e+01}', "");
    Expect(0, 119539, '\p{^Is_Nv=1.900000000000000e+01}', "");
    Expect(0, 119539, '\P{Is_Nv=1.900000000000000e+01}', "");
    Expect(1, 119539, '\P{^Is_Nv=1.900000000000000e+01}', "");
    Expect(0, 119540, '\p{Is_Nv=1.900000000000000e+01}', "");
    Expect(1, 119540, '\p{^Is_Nv=1.900000000000000e+01}', "");
    Expect(1, 119540, '\P{Is_Nv=1.900000000000000e+01}', "");
    Expect(0, 119540, '\P{^Is_Nv=1.900000000000000e+01}', "");
    Error('\p{Numeric_Value=_	000000002/a/}');
    Error('\P{Numeric_Value=_	000000002/a/}');
    Expect(1, 140176, '\p{Numeric_Value=:\A2\z:}', "");;
    Expect(0, 140177, '\p{Numeric_Value=:\A2\z:}', "");;
    Expect(1, 140176, '\p{Numeric_Value=+000000002}', "");
    Expect(0, 140176, '\p{^Numeric_Value=+000000002}', "");
    Expect(0, 140176, '\P{Numeric_Value=+000000002}', "");
    Expect(1, 140176, '\P{^Numeric_Value=+000000002}', "");
    Expect(0, 140177, '\p{Numeric_Value=+000000002}', "");
    Expect(1, 140177, '\p{^Numeric_Value=+000000002}', "");
    Expect(1, 140177, '\P{Numeric_Value=+000000002}', "");
    Expect(0, 140177, '\P{^Numeric_Value=+000000002}', "");
    Expect(1, 140176, '\p{Numeric_Value=2.000000000000000e+00}', "");
    Expect(0, 140176, '\p{^Numeric_Value=2.000000000000000e+00}', "");
    Expect(0, 140176, '\P{Numeric_Value=2.000000000000000e+00}', "");
    Expect(1, 140176, '\P{^Numeric_Value=2.000000000000000e+00}', "");
    Expect(0, 140177, '\p{Numeric_Value=2.000000000000000e+00}', "");
    Expect(1, 140177, '\p{^Numeric_Value=2.000000000000000e+00}', "");
    Expect(1, 140177, '\P{Numeric_Value=2.000000000000000e+00}', "");
    Expect(0, 140177, '\P{^Numeric_Value=2.000000000000000e+00}', "");
    Error('\p{Nv=:=-002}');
    Error('\P{Nv=:=-002}');
    Expect(1, 140176, '\p{Nv=:\A2\z:}', "");;
    Expect(0, 140177, '\p{Nv=:\A2\z:}', "");;
    Expect(1, 140176, '\p{Nv=+0000002}', "");
    Expect(0, 140176, '\p{^Nv=+0000002}', "");
    Expect(0, 140176, '\P{Nv=+0000002}', "");
    Expect(1, 140176, '\P{^Nv=+0000002}', "");
    Expect(0, 140177, '\p{Nv=+0000002}', "");
    Expect(1, 140177, '\p{^Nv=+0000002}', "");
    Expect(1, 140177, '\P{Nv=+0000002}', "");
    Expect(0, 140177, '\P{^Nv=+0000002}', "");
    Expect(1, 140176, '\p{Nv=2.000000000000000e+00}', "");
    Expect(0, 140176, '\p{^Nv=2.000000000000000e+00}', "");
    Expect(0, 140176, '\P{Nv=2.000000000000000e+00}', "");
    Expect(1, 140176, '\P{^Nv=2.000000000000000e+00}', "");
    Expect(0, 140177, '\p{Nv=2.000000000000000e+00}', "");
    Expect(1, 140177, '\p{^Nv=2.000000000000000e+00}', "");
    Expect(1, 140177, '\P{Nv=2.000000000000000e+00}', "");
    Expect(0, 140177, '\P{^Nv=2.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value=/a/--002}');
    Error('\P{Is_Numeric_Value=/a/--002}');
    Expect(1, 140176, '\p{Is_Numeric_Value=000000002}', "");
    Expect(0, 140176, '\p{^Is_Numeric_Value=000000002}', "");
    Expect(0, 140176, '\P{Is_Numeric_Value=000000002}', "");
    Expect(1, 140176, '\P{^Is_Numeric_Value=000000002}', "");
    Expect(0, 140177, '\p{Is_Numeric_Value=000000002}', "");
    Expect(1, 140177, '\p{^Is_Numeric_Value=000000002}', "");
    Expect(1, 140177, '\P{Is_Numeric_Value=000000002}', "");
    Expect(0, 140177, '\P{^Is_Numeric_Value=000000002}', "");
    Expect(1, 140176, '\p{Is_Numeric_Value=2.000000000000000e+00}', "");
    Expect(0, 140176, '\p{^Is_Numeric_Value=2.000000000000000e+00}', "");
    Expect(0, 140176, '\P{Is_Numeric_Value=2.000000000000000e+00}', "");
    Expect(1, 140176, '\P{^Is_Numeric_Value=2.000000000000000e+00}', "");
    Expect(0, 140177, '\p{Is_Numeric_Value=2.000000000000000e+00}', "");
    Expect(1, 140177, '\p{^Is_Numeric_Value=2.000000000000000e+00}', "");
    Expect(1, 140177, '\P{Is_Numeric_Value=2.000000000000000e+00}', "");
    Expect(0, 140177, '\P{^Is_Numeric_Value=2.000000000000000e+00}', "");
    Error('\p{Is_Nv:	 0_0_0_0_0_0_02:=}');
    Error('\P{Is_Nv:	 0_0_0_0_0_0_02:=}');
    Expect(1, 140176, '\p{Is_Nv=+0_0_0_02}', "");
    Expect(0, 140176, '\p{^Is_Nv=+0_0_0_02}', "");
    Expect(0, 140176, '\P{Is_Nv=+0_0_0_02}', "");
    Expect(1, 140176, '\P{^Is_Nv=+0_0_0_02}', "");
    Expect(0, 140177, '\p{Is_Nv=+0_0_0_02}', "");
    Expect(1, 140177, '\p{^Is_Nv=+0_0_0_02}', "");
    Expect(1, 140177, '\P{Is_Nv=+0_0_0_02}', "");
    Expect(0, 140177, '\P{^Is_Nv=+0_0_0_02}', "");
    Expect(1, 140176, '\p{Is_Nv=2.000000000000000e+00}', "");
    Expect(0, 140176, '\p{^Is_Nv=2.000000000000000e+00}', "");
    Expect(0, 140176, '\P{Is_Nv=2.000000000000000e+00}', "");
    Expect(1, 140176, '\P{^Is_Nv=2.000000000000000e+00}', "");
    Expect(0, 140177, '\p{Is_Nv=2.000000000000000e+00}', "");
    Expect(1, 140177, '\p{^Is_Nv=2.000000000000000e+00}', "");
    Expect(1, 140177, '\P{Is_Nv=2.000000000000000e+00}', "");
    Expect(0, 140177, '\P{^Is_Nv=2.000000000000000e+00}', "");
    Error('\p{Numeric_Value=:=02/3}');
    Error('\P{Numeric_Value=:=02/3}');
    Expect(1, 74854, '\p{Numeric_Value=:\A2/3\z:}', "");;
    Expect(0, 74855, '\p{Numeric_Value=:\A2/3\z:}', "");;
    Expect(1, 74854, '\p{Numeric_Value=00000002/03}', "");
    Expect(0, 74854, '\p{^Numeric_Value=00000002/03}', "");
    Expect(0, 74854, '\P{Numeric_Value=00000002/03}', "");
    Expect(1, 74854, '\P{^Numeric_Value=00000002/03}', "");
    Expect(0, 74855, '\p{Numeric_Value=00000002/03}', "");
    Expect(1, 74855, '\p{^Numeric_Value=00000002/03}', "");
    Expect(1, 74855, '\P{Numeric_Value=00000002/03}', "");
    Expect(0, 74855, '\P{^Numeric_Value=00000002/03}', "");
    Expect(1, 74854, '\p{Numeric_Value=120/180}', "");
    Expect(0, 74854, '\p{^Numeric_Value=120/180}', "");
    Expect(0, 74854, '\P{Numeric_Value=120/180}', "");
    Expect(1, 74854, '\P{^Numeric_Value=120/180}', "");
    Expect(0, 74855, '\p{Numeric_Value=120/180}', "");
    Expect(1, 74855, '\p{^Numeric_Value=120/180}', "");
    Expect(1, 74855, '\P{Numeric_Value=120/180}', "");
    Expect(0, 74855, '\P{^Numeric_Value=120/180}', "");
    Error('\p{Numeric_Value=6.7e-01}');
    Error('\P{Numeric_Value=6.7e-01}');
    Error('\p{Numeric_Value=0.7}');
    Error('\P{Numeric_Value=0.7}');
    Expect(1, 74854, '\p{Numeric_Value:	6.67e-01}', "");
    Expect(0, 74854, '\p{^Numeric_Value:	6.67e-01}', "");
    Expect(0, 74854, '\P{Numeric_Value:	6.67e-01}', "");
    Expect(1, 74854, '\P{^Numeric_Value:	6.67e-01}', "");
    Expect(0, 74855, '\p{Numeric_Value:	6.67e-01}', "");
    Expect(1, 74855, '\p{^Numeric_Value:	6.67e-01}', "");
    Expect(1, 74855, '\P{Numeric_Value:	6.67e-01}', "");
    Expect(0, 74855, '\P{^Numeric_Value:	6.67e-01}', "");
    Error('\p{Numeric_Value=0.67}');
    Error('\P{Numeric_Value=0.67}');
    Expect(1, 74854, '\p{Numeric_Value=6.667e-01}', "");
    Expect(0, 74854, '\p{^Numeric_Value=6.667e-01}', "");
    Expect(0, 74854, '\P{Numeric_Value=6.667e-01}', "");
    Expect(1, 74854, '\P{^Numeric_Value=6.667e-01}', "");
    Expect(0, 74855, '\p{Numeric_Value=6.667e-01}', "");
    Expect(1, 74855, '\p{^Numeric_Value=6.667e-01}', "");
    Expect(1, 74855, '\P{Numeric_Value=6.667e-01}', "");
    Expect(0, 74855, '\P{^Numeric_Value=6.667e-01}', "");
    Expect(1, 74854, '\p{Numeric_Value:   0.667}', "");
    Expect(0, 74854, '\p{^Numeric_Value:   0.667}', "");
    Expect(0, 74854, '\P{Numeric_Value:   0.667}', "");
    Expect(1, 74854, '\P{^Numeric_Value:   0.667}', "");
    Expect(0, 74855, '\p{Numeric_Value:   0.667}', "");
    Expect(1, 74855, '\p{^Numeric_Value:   0.667}', "");
    Expect(1, 74855, '\P{Numeric_Value:   0.667}', "");
    Expect(0, 74855, '\P{^Numeric_Value:   0.667}', "");
    Expect(1, 74854, '\p{Numeric_Value:	6.6667e-01}', "");
    Expect(0, 74854, '\p{^Numeric_Value:	6.6667e-01}', "");
    Expect(0, 74854, '\P{Numeric_Value:	6.6667e-01}', "");
    Expect(1, 74854, '\P{^Numeric_Value:	6.6667e-01}', "");
    Expect(0, 74855, '\p{Numeric_Value:	6.6667e-01}', "");
    Expect(1, 74855, '\p{^Numeric_Value:	6.6667e-01}', "");
    Expect(1, 74855, '\P{Numeric_Value:	6.6667e-01}', "");
    Expect(0, 74855, '\P{^Numeric_Value:	6.6667e-01}', "");
    Expect(1, 74854, '\p{Numeric_Value=0.6667}', "");
    Expect(0, 74854, '\p{^Numeric_Value=0.6667}', "");
    Expect(0, 74854, '\P{Numeric_Value=0.6667}', "");
    Expect(1, 74854, '\P{^Numeric_Value=0.6667}', "");
    Expect(0, 74855, '\p{Numeric_Value=0.6667}', "");
    Expect(1, 74855, '\p{^Numeric_Value=0.6667}', "");
    Expect(1, 74855, '\P{Numeric_Value=0.6667}', "");
    Expect(0, 74855, '\P{^Numeric_Value=0.6667}', "");
    Error('\p{Nv: /a/	 0002/00000003}');
    Error('\P{Nv: /a/	 0002/00000003}');
    Expect(1, 74854, '\p{Nv=:\A2/3\z:}', "");;
    Expect(0, 74855, '\p{Nv=:\A2/3\z:}', "");;
    Expect(1, 74854, '\p{Nv=00002/3}', "");
    Expect(0, 74854, '\p{^Nv=00002/3}', "");
    Expect(0, 74854, '\P{Nv=00002/3}', "");
    Expect(1, 74854, '\P{^Nv=00002/3}', "");
    Expect(0, 74855, '\p{Nv=00002/3}', "");
    Expect(1, 74855, '\p{^Nv=00002/3}', "");
    Expect(1, 74855, '\P{Nv=00002/3}', "");
    Expect(0, 74855, '\P{^Nv=00002/3}', "");
    Expect(1, 74854, '\p{Nv=120/180}', "");
    Expect(0, 74854, '\p{^Nv=120/180}', "");
    Expect(0, 74854, '\P{Nv=120/180}', "");
    Expect(1, 74854, '\P{^Nv=120/180}', "");
    Expect(0, 74855, '\p{Nv=120/180}', "");
    Expect(1, 74855, '\p{^Nv=120/180}', "");
    Expect(1, 74855, '\P{Nv=120/180}', "");
    Expect(0, 74855, '\P{^Nv=120/180}', "");
    Error('\p{Nv=6.7e-01}');
    Error('\P{Nv=6.7e-01}');
    Error('\p{Nv=0.7}');
    Error('\P{Nv=0.7}');
    Expect(1, 74854, '\p{Nv=6.67e-01}', "");
    Expect(0, 74854, '\p{^Nv=6.67e-01}', "");
    Expect(0, 74854, '\P{Nv=6.67e-01}', "");
    Expect(1, 74854, '\P{^Nv=6.67e-01}', "");
    Expect(0, 74855, '\p{Nv=6.67e-01}', "");
    Expect(1, 74855, '\p{^Nv=6.67e-01}', "");
    Expect(1, 74855, '\P{Nv=6.67e-01}', "");
    Expect(0, 74855, '\P{^Nv=6.67e-01}', "");
    Error('\p{Nv=0.67}');
    Error('\P{Nv=0.67}');
    Expect(1, 74854, '\p{Nv=6.667e-01}', "");
    Expect(0, 74854, '\p{^Nv=6.667e-01}', "");
    Expect(0, 74854, '\P{Nv=6.667e-01}', "");
    Expect(1, 74854, '\P{^Nv=6.667e-01}', "");
    Expect(0, 74855, '\p{Nv=6.667e-01}', "");
    Expect(1, 74855, '\p{^Nv=6.667e-01}', "");
    Expect(1, 74855, '\P{Nv=6.667e-01}', "");
    Expect(0, 74855, '\P{^Nv=6.667e-01}', "");
    Expect(1, 74854, '\p{Nv=0.667}', "");
    Expect(0, 74854, '\p{^Nv=0.667}', "");
    Expect(0, 74854, '\P{Nv=0.667}', "");
    Expect(1, 74854, '\P{^Nv=0.667}', "");
    Expect(0, 74855, '\p{Nv=0.667}', "");
    Expect(1, 74855, '\p{^Nv=0.667}', "");
    Expect(1, 74855, '\P{Nv=0.667}', "");
    Expect(0, 74855, '\P{^Nv=0.667}', "");
    Expect(1, 74854, '\p{Nv=6.6667e-01}', "");
    Expect(0, 74854, '\p{^Nv=6.6667e-01}', "");
    Expect(0, 74854, '\P{Nv=6.6667e-01}', "");
    Expect(1, 74854, '\P{^Nv=6.6667e-01}', "");
    Expect(0, 74855, '\p{Nv=6.6667e-01}', "");
    Expect(1, 74855, '\p{^Nv=6.6667e-01}', "");
    Expect(1, 74855, '\P{Nv=6.6667e-01}', "");
    Expect(0, 74855, '\P{^Nv=6.6667e-01}', "");
    Expect(1, 74854, '\p{Nv=0.6667}', "");
    Expect(0, 74854, '\p{^Nv=0.6667}', "");
    Expect(0, 74854, '\P{Nv=0.6667}', "");
    Expect(1, 74854, '\P{^Nv=0.6667}', "");
    Expect(0, 74855, '\p{Nv=0.6667}', "");
    Expect(1, 74855, '\p{^Nv=0.6667}', "");
    Expect(1, 74855, '\P{Nv=0.6667}', "");
    Expect(0, 74855, '\P{^Nv=0.6667}', "");
    Error('\p{Is_Numeric_Value:   :=- +0000002/0000000003}');
    Error('\P{Is_Numeric_Value:   :=- +0000002/0000000003}');
    Expect(1, 74854, '\p{Is_Numeric_Value=000000002/00000003}', "");
    Expect(0, 74854, '\p{^Is_Numeric_Value=000000002/00000003}', "");
    Expect(0, 74854, '\P{Is_Numeric_Value=000000002/00000003}', "");
    Expect(1, 74854, '\P{^Is_Numeric_Value=000000002/00000003}', "");
    Expect(0, 74855, '\p{Is_Numeric_Value=000000002/00000003}', "");
    Expect(1, 74855, '\p{^Is_Numeric_Value=000000002/00000003}', "");
    Expect(1, 74855, '\P{Is_Numeric_Value=000000002/00000003}', "");
    Expect(0, 74855, '\P{^Is_Numeric_Value=000000002/00000003}', "");
    Expect(1, 74854, '\p{Is_Numeric_Value=120/180}', "");
    Expect(0, 74854, '\p{^Is_Numeric_Value=120/180}', "");
    Expect(0, 74854, '\P{Is_Numeric_Value=120/180}', "");
    Expect(1, 74854, '\P{^Is_Numeric_Value=120/180}', "");
    Expect(0, 74855, '\p{Is_Numeric_Value=120/180}', "");
    Expect(1, 74855, '\p{^Is_Numeric_Value=120/180}', "");
    Expect(1, 74855, '\P{Is_Numeric_Value=120/180}', "");
    Expect(0, 74855, '\P{^Is_Numeric_Value=120/180}', "");
    Error('\p{Is_Numeric_Value=6.7e-01}');
    Error('\P{Is_Numeric_Value=6.7e-01}');
    Error('\p{Is_Numeric_Value: 0.7}');
    Error('\P{Is_Numeric_Value: 0.7}');
    Expect(1, 74854, '\p{Is_Numeric_Value:   6.67e-01}', "");
    Expect(0, 74854, '\p{^Is_Numeric_Value:   6.67e-01}', "");
    Expect(0, 74854, '\P{Is_Numeric_Value:   6.67e-01}', "");
    Expect(1, 74854, '\P{^Is_Numeric_Value:   6.67e-01}', "");
    Expect(0, 74855, '\p{Is_Numeric_Value:   6.67e-01}', "");
    Expect(1, 74855, '\p{^Is_Numeric_Value:   6.67e-01}', "");
    Expect(1, 74855, '\P{Is_Numeric_Value:   6.67e-01}', "");
    Expect(0, 74855, '\P{^Is_Numeric_Value:   6.67e-01}', "");
    Error('\p{Is_Numeric_Value=0.67}');
    Error('\P{Is_Numeric_Value=0.67}');
    Expect(1, 74854, '\p{Is_Numeric_Value=6.667e-01}', "");
    Expect(0, 74854, '\p{^Is_Numeric_Value=6.667e-01}', "");
    Expect(0, 74854, '\P{Is_Numeric_Value=6.667e-01}', "");
    Expect(1, 74854, '\P{^Is_Numeric_Value=6.667e-01}', "");
    Expect(0, 74855, '\p{Is_Numeric_Value=6.667e-01}', "");
    Expect(1, 74855, '\p{^Is_Numeric_Value=6.667e-01}', "");
    Expect(1, 74855, '\P{Is_Numeric_Value=6.667e-01}', "");
    Expect(0, 74855, '\P{^Is_Numeric_Value=6.667e-01}', "");
    Expect(1, 74854, '\p{Is_Numeric_Value=0.667}', "");
    Expect(0, 74854, '\p{^Is_Numeric_Value=0.667}', "");
    Expect(0, 74854, '\P{Is_Numeric_Value=0.667}', "");
    Expect(1, 74854, '\P{^Is_Numeric_Value=0.667}', "");
    Expect(0, 74855, '\p{Is_Numeric_Value=0.667}', "");
    Expect(1, 74855, '\p{^Is_Numeric_Value=0.667}', "");
    Expect(1, 74855, '\P{Is_Numeric_Value=0.667}', "");
    Expect(0, 74855, '\P{^Is_Numeric_Value=0.667}', "");
    Expect(1, 74854, '\p{Is_Numeric_Value=6.6667e-01}', "");
    Expect(0, 74854, '\p{^Is_Numeric_Value=6.6667e-01}', "");
    Expect(0, 74854, '\P{Is_Numeric_Value=6.6667e-01}', "");
    Expect(1, 74854, '\P{^Is_Numeric_Value=6.6667e-01}', "");
    Expect(0, 74855, '\p{Is_Numeric_Value=6.6667e-01}', "");
    Expect(1, 74855, '\p{^Is_Numeric_Value=6.6667e-01}', "");
    Expect(1, 74855, '\P{Is_Numeric_Value=6.6667e-01}', "");
    Expect(0, 74855, '\P{^Is_Numeric_Value=6.6667e-01}', "");
    Expect(1, 74854, '\p{Is_Numeric_Value:	0.6667}', "");
    Expect(0, 74854, '\p{^Is_Numeric_Value:	0.6667}', "");
    Expect(0, 74854, '\P{Is_Numeric_Value:	0.6667}', "");
    Expect(1, 74854, '\P{^Is_Numeric_Value:	0.6667}', "");
    Expect(0, 74855, '\p{Is_Numeric_Value:	0.6667}', "");
    Expect(1, 74855, '\p{^Is_Numeric_Value:	0.6667}', "");
    Expect(1, 74855, '\P{Is_Numeric_Value:	0.6667}', "");
    Expect(0, 74855, '\P{^Is_Numeric_Value:	0.6667}', "");
    Error('\p{Is_Nv:/a/-0002/000003}');
    Error('\P{Is_Nv:/a/-0002/000003}');
    Expect(1, 74854, '\p{Is_Nv=+00000002/000003}', "");
    Expect(0, 74854, '\p{^Is_Nv=+00000002/000003}', "");
    Expect(0, 74854, '\P{Is_Nv=+00000002/000003}', "");
    Expect(1, 74854, '\P{^Is_Nv=+00000002/000003}', "");
    Expect(0, 74855, '\p{Is_Nv=+00000002/000003}', "");
    Expect(1, 74855, '\p{^Is_Nv=+00000002/000003}', "");
    Expect(1, 74855, '\P{Is_Nv=+00000002/000003}', "");
    Expect(0, 74855, '\P{^Is_Nv=+00000002/000003}', "");
    Expect(1, 74854, '\p{Is_Nv=120/180}', "");
    Expect(0, 74854, '\p{^Is_Nv=120/180}', "");
    Expect(0, 74854, '\P{Is_Nv=120/180}', "");
    Expect(1, 74854, '\P{^Is_Nv=120/180}', "");
    Expect(0, 74855, '\p{Is_Nv=120/180}', "");
    Expect(1, 74855, '\p{^Is_Nv=120/180}', "");
    Expect(1, 74855, '\P{Is_Nv=120/180}', "");
    Expect(0, 74855, '\P{^Is_Nv=120/180}', "");
    Error('\p{Is_Nv: 6.7e-01}');
    Error('\P{Is_Nv: 6.7e-01}');
    Error('\p{Is_Nv=0.7}');
    Error('\P{Is_Nv=0.7}');
    Expect(1, 74854, '\p{Is_Nv: 6.67e-01}', "");
    Expect(0, 74854, '\p{^Is_Nv: 6.67e-01}', "");
    Expect(0, 74854, '\P{Is_Nv: 6.67e-01}', "");
    Expect(1, 74854, '\P{^Is_Nv: 6.67e-01}', "");
    Expect(0, 74855, '\p{Is_Nv: 6.67e-01}', "");
    Expect(1, 74855, '\p{^Is_Nv: 6.67e-01}', "");
    Expect(1, 74855, '\P{Is_Nv: 6.67e-01}', "");
    Expect(0, 74855, '\P{^Is_Nv: 6.67e-01}', "");
    Error('\p{Is_Nv=0.67}');
    Error('\P{Is_Nv=0.67}');
    Expect(1, 74854, '\p{Is_Nv=6.667e-01}', "");
    Expect(0, 74854, '\p{^Is_Nv=6.667e-01}', "");
    Expect(0, 74854, '\P{Is_Nv=6.667e-01}', "");
    Expect(1, 74854, '\P{^Is_Nv=6.667e-01}', "");
    Expect(0, 74855, '\p{Is_Nv=6.667e-01}', "");
    Expect(1, 74855, '\p{^Is_Nv=6.667e-01}', "");
    Expect(1, 74855, '\P{Is_Nv=6.667e-01}', "");
    Expect(0, 74855, '\P{^Is_Nv=6.667e-01}', "");
    Expect(1, 74854, '\p{Is_Nv:	0.667}', "");
    Expect(0, 74854, '\p{^Is_Nv:	0.667}', "");
    Expect(0, 74854, '\P{Is_Nv:	0.667}', "");
    Expect(1, 74854, '\P{^Is_Nv:	0.667}', "");
    Expect(0, 74855, '\p{Is_Nv:	0.667}', "");
    Expect(1, 74855, '\p{^Is_Nv:	0.667}', "");
    Expect(1, 74855, '\P{Is_Nv:	0.667}', "");
    Expect(0, 74855, '\P{^Is_Nv:	0.667}', "");
    Expect(1, 74854, '\p{Is_Nv=6.6667e-01}', "");
    Expect(0, 74854, '\p{^Is_Nv=6.6667e-01}', "");
    Expect(0, 74854, '\P{Is_Nv=6.6667e-01}', "");
    Expect(1, 74854, '\P{^Is_Nv=6.6667e-01}', "");
    Expect(0, 74855, '\p{Is_Nv=6.6667e-01}', "");
    Expect(1, 74855, '\p{^Is_Nv=6.6667e-01}', "");
    Expect(1, 74855, '\P{Is_Nv=6.6667e-01}', "");
    Expect(0, 74855, '\P{^Is_Nv=6.6667e-01}', "");
    Expect(1, 74854, '\p{Is_Nv: 0.6667}', "");
    Expect(0, 74854, '\p{^Is_Nv: 0.6667}', "");
    Expect(0, 74854, '\P{Is_Nv: 0.6667}', "");
    Expect(1, 74854, '\P{^Is_Nv: 0.6667}', "");
    Expect(0, 74855, '\p{Is_Nv: 0.6667}', "");
    Expect(1, 74855, '\p{^Is_Nv: 0.6667}', "");
    Expect(1, 74855, '\P{Is_Nv: 0.6667}', "");
    Expect(0, 74855, '\P{^Is_Nv: 0.6667}', "");
    Error('\p{Numeric_Value=-/a/0000002/0005}');
    Error('\P{Numeric_Value=-/a/0000002/0005}');
    Expect(1, 8534, '\p{Numeric_Value=:\A2/5\z:}', "");;
    Expect(0, 8535, '\p{Numeric_Value=:\A2/5\z:}', "");;
    Expect(1, 8534, '\p{Numeric_Value=0000000002/0000000005}', "");
    Expect(0, 8534, '\p{^Numeric_Value=0000000002/0000000005}', "");
    Expect(0, 8534, '\P{Numeric_Value=0000000002/0000000005}', "");
    Expect(1, 8534, '\P{^Numeric_Value=0000000002/0000000005}', "");
    Expect(0, 8535, '\p{Numeric_Value=0000000002/0000000005}', "");
    Expect(1, 8535, '\p{^Numeric_Value=0000000002/0000000005}', "");
    Expect(1, 8535, '\P{Numeric_Value=0000000002/0000000005}', "");
    Expect(0, 8535, '\P{^Numeric_Value=0000000002/0000000005}', "");
    Expect(1, 8534, '\p{Numeric_Value=120/300}', "");
    Expect(0, 8534, '\p{^Numeric_Value=120/300}', "");
    Expect(0, 8534, '\P{Numeric_Value=120/300}', "");
    Expect(1, 8534, '\P{^Numeric_Value=120/300}', "");
    Expect(0, 8535, '\p{Numeric_Value=120/300}', "");
    Expect(1, 8535, '\p{^Numeric_Value=120/300}', "");
    Expect(1, 8535, '\P{Numeric_Value=120/300}', "");
    Expect(0, 8535, '\P{^Numeric_Value=120/300}', "");
    Expect(1, 8534, '\p{Numeric_Value=4.0e-01}', "");
    Expect(0, 8534, '\p{^Numeric_Value=4.0e-01}', "");
    Expect(0, 8534, '\P{Numeric_Value=4.0e-01}', "");
    Expect(1, 8534, '\P{^Numeric_Value=4.0e-01}', "");
    Expect(0, 8535, '\p{Numeric_Value=4.0e-01}', "");
    Expect(1, 8535, '\p{^Numeric_Value=4.0e-01}', "");
    Expect(1, 8535, '\P{Numeric_Value=4.0e-01}', "");
    Expect(0, 8535, '\P{^Numeric_Value=4.0e-01}', "");
    Expect(1, 8534, '\p{Numeric_Value=0.4}', "");
    Expect(0, 8534, '\p{^Numeric_Value=0.4}', "");
    Expect(0, 8534, '\P{Numeric_Value=0.4}', "");
    Expect(1, 8534, '\P{^Numeric_Value=0.4}', "");
    Expect(0, 8535, '\p{Numeric_Value=0.4}', "");
    Expect(1, 8535, '\p{^Numeric_Value=0.4}', "");
    Expect(1, 8535, '\P{Numeric_Value=0.4}', "");
    Expect(0, 8535, '\P{^Numeric_Value=0.4}', "");
    Expect(1, 8534, '\p{Numeric_Value=4.00e-01}', "");
    Expect(0, 8534, '\p{^Numeric_Value=4.00e-01}', "");
    Expect(0, 8534, '\P{Numeric_Value=4.00e-01}', "");
    Expect(1, 8534, '\P{^Numeric_Value=4.00e-01}', "");
    Expect(0, 8535, '\p{Numeric_Value=4.00e-01}', "");
    Expect(1, 8535, '\p{^Numeric_Value=4.00e-01}', "");
    Expect(1, 8535, '\P{Numeric_Value=4.00e-01}', "");
    Expect(0, 8535, '\P{^Numeric_Value=4.00e-01}', "");
    Expect(1, 8534, '\p{Numeric_Value: 0.40}', "");
    Expect(0, 8534, '\p{^Numeric_Value: 0.40}', "");
    Expect(0, 8534, '\P{Numeric_Value: 0.40}', "");
    Expect(1, 8534, '\P{^Numeric_Value: 0.40}', "");
    Expect(0, 8535, '\p{Numeric_Value: 0.40}', "");
    Expect(1, 8535, '\p{^Numeric_Value: 0.40}', "");
    Expect(1, 8535, '\P{Numeric_Value: 0.40}', "");
    Expect(0, 8535, '\P{^Numeric_Value: 0.40}', "");
    Error('\p{Nv=__000000002/00000005:=}');
    Error('\P{Nv=__000000002/00000005:=}');
    Expect(1, 8534, '\p{Nv=:\A2/5\z:}', "");;
    Expect(0, 8535, '\p{Nv=:\A2/5\z:}', "");;
    Expect(1, 8534, '\p{Nv=00002/005}', "");
    Expect(0, 8534, '\p{^Nv=00002/005}', "");
    Expect(0, 8534, '\P{Nv=00002/005}', "");
    Expect(1, 8534, '\P{^Nv=00002/005}', "");
    Expect(0, 8535, '\p{Nv=00002/005}', "");
    Expect(1, 8535, '\p{^Nv=00002/005}', "");
    Expect(1, 8535, '\P{Nv=00002/005}', "");
    Expect(0, 8535, '\P{^Nv=00002/005}', "");
    Expect(1, 8534, '\p{Nv=120/300}', "");
    Expect(0, 8534, '\p{^Nv=120/300}', "");
    Expect(0, 8534, '\P{Nv=120/300}', "");
    Expect(1, 8534, '\P{^Nv=120/300}', "");
    Expect(0, 8535, '\p{Nv=120/300}', "");
    Expect(1, 8535, '\p{^Nv=120/300}', "");
    Expect(1, 8535, '\P{Nv=120/300}', "");
    Expect(0, 8535, '\P{^Nv=120/300}', "");
    Expect(1, 8534, '\p{Nv=4.0e-01}', "");
    Expect(0, 8534, '\p{^Nv=4.0e-01}', "");
    Expect(0, 8534, '\P{Nv=4.0e-01}', "");
    Expect(1, 8534, '\P{^Nv=4.0e-01}', "");
    Expect(0, 8535, '\p{Nv=4.0e-01}', "");
    Expect(1, 8535, '\p{^Nv=4.0e-01}', "");
    Expect(1, 8535, '\P{Nv=4.0e-01}', "");
    Expect(0, 8535, '\P{^Nv=4.0e-01}', "");
    Expect(1, 8534, '\p{Nv:0.4}', "");
    Expect(0, 8534, '\p{^Nv:0.4}', "");
    Expect(0, 8534, '\P{Nv:0.4}', "");
    Expect(1, 8534, '\P{^Nv:0.4}', "");
    Expect(0, 8535, '\p{Nv:0.4}', "");
    Expect(1, 8535, '\p{^Nv:0.4}', "");
    Expect(1, 8535, '\P{Nv:0.4}', "");
    Expect(0, 8535, '\P{^Nv:0.4}', "");
    Expect(1, 8534, '\p{Nv=4.00e-01}', "");
    Expect(0, 8534, '\p{^Nv=4.00e-01}', "");
    Expect(0, 8534, '\P{Nv=4.00e-01}', "");
    Expect(1, 8534, '\P{^Nv=4.00e-01}', "");
    Expect(0, 8535, '\p{Nv=4.00e-01}', "");
    Expect(1, 8535, '\p{^Nv=4.00e-01}', "");
    Expect(1, 8535, '\P{Nv=4.00e-01}', "");
    Expect(0, 8535, '\P{^Nv=4.00e-01}', "");
    Expect(1, 8534, '\p{Nv=0.40}', "");
    Expect(0, 8534, '\p{^Nv=0.40}', "");
    Expect(0, 8534, '\P{Nv=0.40}', "");
    Expect(1, 8534, '\P{^Nv=0.40}', "");
    Expect(0, 8535, '\p{Nv=0.40}', "");
    Expect(1, 8535, '\p{^Nv=0.40}', "");
    Expect(1, 8535, '\P{Nv=0.40}', "");
    Expect(0, 8535, '\P{^Nv=0.40}', "");
    Error('\p{Is_Numeric_Value=__02/005:=}');
    Error('\P{Is_Numeric_Value=__02/005:=}');
    Expect(1, 8534, '\p{Is_Numeric_Value=00000002/000000005}', "");
    Expect(0, 8534, '\p{^Is_Numeric_Value=00000002/000000005}', "");
    Expect(0, 8534, '\P{Is_Numeric_Value=00000002/000000005}', "");
    Expect(1, 8534, '\P{^Is_Numeric_Value=00000002/000000005}', "");
    Expect(0, 8535, '\p{Is_Numeric_Value=00000002/000000005}', "");
    Expect(1, 8535, '\p{^Is_Numeric_Value=00000002/000000005}', "");
    Expect(1, 8535, '\P{Is_Numeric_Value=00000002/000000005}', "");
    Expect(0, 8535, '\P{^Is_Numeric_Value=00000002/000000005}', "");
    Expect(1, 8534, '\p{Is_Numeric_Value: 120/300}', "");
    Expect(0, 8534, '\p{^Is_Numeric_Value: 120/300}', "");
    Expect(0, 8534, '\P{Is_Numeric_Value: 120/300}', "");
    Expect(1, 8534, '\P{^Is_Numeric_Value: 120/300}', "");
    Expect(0, 8535, '\p{Is_Numeric_Value: 120/300}', "");
    Expect(1, 8535, '\p{^Is_Numeric_Value: 120/300}', "");
    Expect(1, 8535, '\P{Is_Numeric_Value: 120/300}', "");
    Expect(0, 8535, '\P{^Is_Numeric_Value: 120/300}', "");
    Expect(1, 8534, '\p{Is_Numeric_Value=4.0e-01}', "");
    Expect(0, 8534, '\p{^Is_Numeric_Value=4.0e-01}', "");
    Expect(0, 8534, '\P{Is_Numeric_Value=4.0e-01}', "");
    Expect(1, 8534, '\P{^Is_Numeric_Value=4.0e-01}', "");
    Expect(0, 8535, '\p{Is_Numeric_Value=4.0e-01}', "");
    Expect(1, 8535, '\p{^Is_Numeric_Value=4.0e-01}', "");
    Expect(1, 8535, '\P{Is_Numeric_Value=4.0e-01}', "");
    Expect(0, 8535, '\P{^Is_Numeric_Value=4.0e-01}', "");
    Expect(1, 8534, '\p{Is_Numeric_Value=0.4}', "");
    Expect(0, 8534, '\p{^Is_Numeric_Value=0.4}', "");
    Expect(0, 8534, '\P{Is_Numeric_Value=0.4}', "");
    Expect(1, 8534, '\P{^Is_Numeric_Value=0.4}', "");
    Expect(0, 8535, '\p{Is_Numeric_Value=0.4}', "");
    Expect(1, 8535, '\p{^Is_Numeric_Value=0.4}', "");
    Expect(1, 8535, '\P{Is_Numeric_Value=0.4}', "");
    Expect(0, 8535, '\P{^Is_Numeric_Value=0.4}', "");
    Expect(1, 8534, '\p{Is_Numeric_Value=4.00e-01}', "");
    Expect(0, 8534, '\p{^Is_Numeric_Value=4.00e-01}', "");
    Expect(0, 8534, '\P{Is_Numeric_Value=4.00e-01}', "");
    Expect(1, 8534, '\P{^Is_Numeric_Value=4.00e-01}', "");
    Expect(0, 8535, '\p{Is_Numeric_Value=4.00e-01}', "");
    Expect(1, 8535, '\p{^Is_Numeric_Value=4.00e-01}', "");
    Expect(1, 8535, '\P{Is_Numeric_Value=4.00e-01}', "");
    Expect(0, 8535, '\P{^Is_Numeric_Value=4.00e-01}', "");
    Expect(1, 8534, '\p{Is_Numeric_Value=0.40}', "");
    Expect(0, 8534, '\p{^Is_Numeric_Value=0.40}', "");
    Expect(0, 8534, '\P{Is_Numeric_Value=0.40}', "");
    Expect(1, 8534, '\P{^Is_Numeric_Value=0.40}', "");
    Expect(0, 8535, '\p{Is_Numeric_Value=0.40}', "");
    Expect(1, 8535, '\p{^Is_Numeric_Value=0.40}', "");
    Expect(1, 8535, '\P{Is_Numeric_Value=0.40}', "");
    Expect(0, 8535, '\P{^Is_Numeric_Value=0.40}', "");
    Error('\p{Is_Nv= 	+2/00005:=}');
    Error('\P{Is_Nv= 	+2/00005:=}');
    Expect(1, 8534, '\p{Is_Nv=000002/00000005}', "");
    Expect(0, 8534, '\p{^Is_Nv=000002/00000005}', "");
    Expect(0, 8534, '\P{Is_Nv=000002/00000005}', "");
    Expect(1, 8534, '\P{^Is_Nv=000002/00000005}', "");
    Expect(0, 8535, '\p{Is_Nv=000002/00000005}', "");
    Expect(1, 8535, '\p{^Is_Nv=000002/00000005}', "");
    Expect(1, 8535, '\P{Is_Nv=000002/00000005}', "");
    Expect(0, 8535, '\P{^Is_Nv=000002/00000005}', "");
    Expect(1, 8534, '\p{Is_Nv=120/300}', "");
    Expect(0, 8534, '\p{^Is_Nv=120/300}', "");
    Expect(0, 8534, '\P{Is_Nv=120/300}', "");
    Expect(1, 8534, '\P{^Is_Nv=120/300}', "");
    Expect(0, 8535, '\p{Is_Nv=120/300}', "");
    Expect(1, 8535, '\p{^Is_Nv=120/300}', "");
    Expect(1, 8535, '\P{Is_Nv=120/300}', "");
    Expect(0, 8535, '\P{^Is_Nv=120/300}', "");
    Expect(1, 8534, '\p{Is_Nv=4.0e-01}', "");
    Expect(0, 8534, '\p{^Is_Nv=4.0e-01}', "");
    Expect(0, 8534, '\P{Is_Nv=4.0e-01}', "");
    Expect(1, 8534, '\P{^Is_Nv=4.0e-01}', "");
    Expect(0, 8535, '\p{Is_Nv=4.0e-01}', "");
    Expect(1, 8535, '\p{^Is_Nv=4.0e-01}', "");
    Expect(1, 8535, '\P{Is_Nv=4.0e-01}', "");
    Expect(0, 8535, '\P{^Is_Nv=4.0e-01}', "");
    Expect(1, 8534, '\p{Is_Nv: 0.4}', "");
    Expect(0, 8534, '\p{^Is_Nv: 0.4}', "");
    Expect(0, 8534, '\P{Is_Nv: 0.4}', "");
    Expect(1, 8534, '\P{^Is_Nv: 0.4}', "");
    Expect(0, 8535, '\p{Is_Nv: 0.4}', "");
    Expect(1, 8535, '\p{^Is_Nv: 0.4}', "");
    Expect(1, 8535, '\P{Is_Nv: 0.4}', "");
    Expect(0, 8535, '\P{^Is_Nv: 0.4}', "");
    Expect(1, 8534, '\p{Is_Nv=4.00e-01}', "");
    Expect(0, 8534, '\p{^Is_Nv=4.00e-01}', "");
    Expect(0, 8534, '\P{Is_Nv=4.00e-01}', "");
    Expect(1, 8534, '\P{^Is_Nv=4.00e-01}', "");
    Expect(0, 8535, '\p{Is_Nv=4.00e-01}', "");
    Expect(1, 8535, '\p{^Is_Nv=4.00e-01}', "");
    Expect(1, 8535, '\P{Is_Nv=4.00e-01}', "");
    Expect(0, 8535, '\P{^Is_Nv=4.00e-01}', "");
    Expect(1, 8534, '\p{Is_Nv=0.40}', "");
    Expect(0, 8534, '\p{^Is_Nv=0.40}', "");
    Expect(0, 8534, '\P{Is_Nv=0.40}', "");
    Expect(1, 8534, '\P{^Is_Nv=0.40}', "");
    Expect(0, 8535, '\p{Is_Nv=0.40}', "");
    Expect(1, 8535, '\p{^Is_Nv=0.40}', "");
    Expect(1, 8535, '\P{Is_Nv=0.40}', "");
    Expect(0, 8535, '\P{^Is_Nv=0.40}', "");
    Error('\p{Numeric_Value= /a/00020}');
    Error('\P{Numeric_Value= /a/00020}');
    Expect(1, 126219, '\p{Numeric_Value=:\A20\z:}', "");;
    Expect(0, 126220, '\p{Numeric_Value=:\A20\z:}', "");;
    Expect(1, 126219, '\p{Numeric_Value=0_0_0_0_0_0_20}', "");
    Expect(0, 126219, '\p{^Numeric_Value=0_0_0_0_0_0_20}', "");
    Expect(0, 126219, '\P{Numeric_Value=0_0_0_0_0_0_20}', "");
    Expect(1, 126219, '\P{^Numeric_Value=0_0_0_0_0_0_20}', "");
    Expect(0, 126220, '\p{Numeric_Value=0_0_0_0_0_0_20}', "");
    Expect(1, 126220, '\p{^Numeric_Value=0_0_0_0_0_0_20}', "");
    Expect(1, 126220, '\P{Numeric_Value=0_0_0_0_0_0_20}', "");
    Expect(0, 126220, '\P{^Numeric_Value=0_0_0_0_0_0_20}', "");
    Expect(1, 126219, '\p{Numeric_Value=2.000000000000000e+01}', "");
    Expect(0, 126219, '\p{^Numeric_Value=2.000000000000000e+01}', "");
    Expect(0, 126219, '\P{Numeric_Value=2.000000000000000e+01}', "");
    Expect(1, 126219, '\P{^Numeric_Value=2.000000000000000e+01}', "");
    Expect(0, 126220, '\p{Numeric_Value=2.000000000000000e+01}', "");
    Expect(1, 126220, '\p{^Numeric_Value=2.000000000000000e+01}', "");
    Expect(1, 126220, '\P{Numeric_Value=2.000000000000000e+01}', "");
    Expect(0, 126220, '\P{^Numeric_Value=2.000000000000000e+01}', "");
    Error('\p{Nv=/a/00000000020}');
    Error('\P{Nv=/a/00000000020}');
    Expect(1, 126219, '\p{Nv=:\A20\z:}', "");;
    Expect(0, 126220, '\p{Nv=:\A20\z:}', "");;
    Expect(1, 126219, '\p{Nv=00_00_00_00_20}', "");
    Expect(0, 126219, '\p{^Nv=00_00_00_00_20}', "");
    Expect(0, 126219, '\P{Nv=00_00_00_00_20}', "");
    Expect(1, 126219, '\P{^Nv=00_00_00_00_20}', "");
    Expect(0, 126220, '\p{Nv=00_00_00_00_20}', "");
    Expect(1, 126220, '\p{^Nv=00_00_00_00_20}', "");
    Expect(1, 126220, '\P{Nv=00_00_00_00_20}', "");
    Expect(0, 126220, '\P{^Nv=00_00_00_00_20}', "");
    Expect(1, 126219, '\p{Nv=2.000000000000000e+01}', "");
    Expect(0, 126219, '\p{^Nv=2.000000000000000e+01}', "");
    Expect(0, 126219, '\P{Nv=2.000000000000000e+01}', "");
    Expect(1, 126219, '\P{^Nv=2.000000000000000e+01}', "");
    Expect(0, 126220, '\p{Nv=2.000000000000000e+01}', "");
    Expect(1, 126220, '\p{^Nv=2.000000000000000e+01}', "");
    Expect(1, 126220, '\P{Nv=2.000000000000000e+01}', "");
    Expect(0, 126220, '\P{^Nv=2.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value:    -0_0_0_0_0_0_0020:=}');
    Error('\P{Is_Numeric_Value:    -0_0_0_0_0_0_0020:=}');
    Expect(1, 126219, '\p{Is_Numeric_Value: 000000020}', "");
    Expect(0, 126219, '\p{^Is_Numeric_Value: 000000020}', "");
    Expect(0, 126219, '\P{Is_Numeric_Value: 000000020}', "");
    Expect(1, 126219, '\P{^Is_Numeric_Value: 000000020}', "");
    Expect(0, 126220, '\p{Is_Numeric_Value: 000000020}', "");
    Expect(1, 126220, '\p{^Is_Numeric_Value: 000000020}', "");
    Expect(1, 126220, '\P{Is_Numeric_Value: 000000020}', "");
    Expect(0, 126220, '\P{^Is_Numeric_Value: 000000020}', "");
    Expect(1, 126219, '\p{Is_Numeric_Value:	2.000000000000000e+01}', "");
    Expect(0, 126219, '\p{^Is_Numeric_Value:	2.000000000000000e+01}', "");
    Expect(0, 126219, '\P{Is_Numeric_Value:	2.000000000000000e+01}', "");
    Expect(1, 126219, '\P{^Is_Numeric_Value:	2.000000000000000e+01}', "");
    Expect(0, 126220, '\p{Is_Numeric_Value:	2.000000000000000e+01}', "");
    Expect(1, 126220, '\p{^Is_Numeric_Value:	2.000000000000000e+01}', "");
    Expect(1, 126220, '\P{Is_Numeric_Value:	2.000000000000000e+01}', "");
    Expect(0, 126220, '\P{^Is_Numeric_Value:	2.000000000000000e+01}', "");
    Error('\p{Is_Nv=	20/a/}');
    Error('\P{Is_Nv=	20/a/}');
    Expect(1, 126219, '\p{Is_Nv=00000000020}', "");
    Expect(0, 126219, '\p{^Is_Nv=00000000020}', "");
    Expect(0, 126219, '\P{Is_Nv=00000000020}', "");
    Expect(1, 126219, '\P{^Is_Nv=00000000020}', "");
    Expect(0, 126220, '\p{Is_Nv=00000000020}', "");
    Expect(1, 126220, '\p{^Is_Nv=00000000020}', "");
    Expect(1, 126220, '\P{Is_Nv=00000000020}', "");
    Expect(0, 126220, '\P{^Is_Nv=00000000020}', "");
    Expect(1, 126219, '\p{Is_Nv=2.000000000000000e+01}', "");
    Expect(0, 126219, '\p{^Is_Nv=2.000000000000000e+01}', "");
    Expect(0, 126219, '\P{Is_Nv=2.000000000000000e+01}', "");
    Expect(1, 126219, '\P{^Is_Nv=2.000000000000000e+01}', "");
    Expect(0, 126220, '\p{Is_Nv=2.000000000000000e+01}', "");
    Expect(1, 126220, '\p{^Is_Nv=2.000000000000000e+01}', "");
    Expect(1, 126220, '\P{Is_Nv=2.000000000000000e+01}', "");
    Expect(0, 126220, '\P{^Is_Nv=2.000000000000000e+01}', "");
    Error('\p{Numeric_Value=_/a/0_0_0_200}');
    Error('\P{Numeric_Value=_/a/0_0_0_200}');
    Expect(1, 126228, '\p{Numeric_Value=:\A200\z:}', "");;
    Expect(0, 126229, '\p{Numeric_Value=:\A200\z:}', "");;
    Expect(1, 126228, '\p{Numeric_Value:   000200}', "");
    Expect(0, 126228, '\p{^Numeric_Value:   000200}', "");
    Expect(0, 126228, '\P{Numeric_Value:   000200}', "");
    Expect(1, 126228, '\P{^Numeric_Value:   000200}', "");
    Expect(0, 126229, '\p{Numeric_Value:   000200}', "");
    Expect(1, 126229, '\p{^Numeric_Value:   000200}', "");
    Expect(1, 126229, '\P{Numeric_Value:   000200}', "");
    Expect(0, 126229, '\P{^Numeric_Value:   000200}', "");
    Expect(1, 126228, '\p{Numeric_Value=2.000000000000000e+02}', "");
    Expect(0, 126228, '\p{^Numeric_Value=2.000000000000000e+02}', "");
    Expect(0, 126228, '\P{Numeric_Value=2.000000000000000e+02}', "");
    Expect(1, 126228, '\P{^Numeric_Value=2.000000000000000e+02}', "");
    Expect(0, 126229, '\p{Numeric_Value=2.000000000000000e+02}', "");
    Expect(1, 126229, '\p{^Numeric_Value=2.000000000000000e+02}', "");
    Expect(1, 126229, '\P{Numeric_Value=2.000000000000000e+02}', "");
    Expect(0, 126229, '\P{^Numeric_Value=2.000000000000000e+02}', "");
    Error('\p{Nv=	/a/+000200}');
    Error('\P{Nv=	/a/+000200}');
    Expect(1, 126228, '\p{Nv=:\A200\z:}', "");;
    Expect(0, 126229, '\p{Nv=:\A200\z:}', "");;
    Expect(1, 126228, '\p{Nv=200}', "");
    Expect(0, 126228, '\p{^Nv=200}', "");
    Expect(0, 126228, '\P{Nv=200}', "");
    Expect(1, 126228, '\P{^Nv=200}', "");
    Expect(0, 126229, '\p{Nv=200}', "");
    Expect(1, 126229, '\p{^Nv=200}', "");
    Expect(1, 126229, '\P{Nv=200}', "");
    Expect(0, 126229, '\P{^Nv=200}', "");
    Expect(1, 126228, '\p{Nv=2.000000000000000e+02}', "");
    Expect(0, 126228, '\p{^Nv=2.000000000000000e+02}', "");
    Expect(0, 126228, '\P{Nv=2.000000000000000e+02}', "");
    Expect(1, 126228, '\P{^Nv=2.000000000000000e+02}', "");
    Expect(0, 126229, '\p{Nv=2.000000000000000e+02}', "");
    Expect(1, 126229, '\p{^Nv=2.000000000000000e+02}', "");
    Expect(1, 126229, '\P{Nv=2.000000000000000e+02}', "");
    Expect(0, 126229, '\P{^Nv=2.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value=/a/__0_0_0_0_0_0_0_0_0_200}');
    Error('\P{Is_Numeric_Value=/a/__0_0_0_0_0_0_0_0_0_200}');
    Expect(1, 126228, '\p{Is_Numeric_Value=00200}', "");
    Expect(0, 126228, '\p{^Is_Numeric_Value=00200}', "");
    Expect(0, 126228, '\P{Is_Numeric_Value=00200}', "");
    Expect(1, 126228, '\P{^Is_Numeric_Value=00200}', "");
    Expect(0, 126229, '\p{Is_Numeric_Value=00200}', "");
    Expect(1, 126229, '\p{^Is_Numeric_Value=00200}', "");
    Expect(1, 126229, '\P{Is_Numeric_Value=00200}', "");
    Expect(0, 126229, '\P{^Is_Numeric_Value=00200}', "");
    Expect(1, 126228, '\p{Is_Numeric_Value=2.000000000000000e+02}', "");
    Expect(0, 126228, '\p{^Is_Numeric_Value=2.000000000000000e+02}', "");
    Expect(0, 126228, '\P{Is_Numeric_Value=2.000000000000000e+02}', "");
    Expect(1, 126228, '\P{^Is_Numeric_Value=2.000000000000000e+02}', "");
    Expect(0, 126229, '\p{Is_Numeric_Value=2.000000000000000e+02}', "");
    Expect(1, 126229, '\p{^Is_Numeric_Value=2.000000000000000e+02}', "");
    Expect(1, 126229, '\P{Is_Numeric_Value=2.000000000000000e+02}', "");
    Expect(0, 126229, '\P{^Is_Numeric_Value=2.000000000000000e+02}', "");
    Error('\p{Is_Nv=-/a/00000020_0}');
    Error('\P{Is_Nv=-/a/00000020_0}');
    Expect(1, 126228, '\p{Is_Nv=0200}', "");
    Expect(0, 126228, '\p{^Is_Nv=0200}', "");
    Expect(0, 126228, '\P{Is_Nv=0200}', "");
    Expect(1, 126228, '\P{^Is_Nv=0200}', "");
    Expect(0, 126229, '\p{Is_Nv=0200}', "");
    Expect(1, 126229, '\p{^Is_Nv=0200}', "");
    Expect(1, 126229, '\P{Is_Nv=0200}', "");
    Expect(0, 126229, '\P{^Is_Nv=0200}', "");
    Expect(1, 126228, '\p{Is_Nv=2.000000000000000e+02}', "");
    Expect(0, 126228, '\p{^Is_Nv=2.000000000000000e+02}', "");
    Expect(0, 126228, '\P{Is_Nv=2.000000000000000e+02}', "");
    Expect(1, 126228, '\P{^Is_Nv=2.000000000000000e+02}', "");
    Expect(0, 126229, '\p{Is_Nv=2.000000000000000e+02}', "");
    Expect(1, 126229, '\p{^Is_Nv=2.000000000000000e+02}', "");
    Expect(1, 126229, '\P{Is_Nv=2.000000000000000e+02}', "");
    Expect(0, 126229, '\P{^Is_Nv=2.000000000000000e+02}', "");
    Error('\p{Numeric_Value=/a/000000002000}');
    Error('\P{Numeric_Value=/a/000000002000}');
    Expect(1, 126266, '\p{Numeric_Value=:\A2000\z:}', "");;
    Expect(0, 126267, '\p{Numeric_Value=:\A2000\z:}', "");;
    Expect(1, 126266, '\p{Numeric_Value=0000000002000}', "");
    Expect(0, 126266, '\p{^Numeric_Value=0000000002000}', "");
    Expect(0, 126266, '\P{Numeric_Value=0000000002000}', "");
    Expect(1, 126266, '\P{^Numeric_Value=0000000002000}', "");
    Expect(0, 126267, '\p{Numeric_Value=0000000002000}', "");
    Expect(1, 126267, '\p{^Numeric_Value=0000000002000}', "");
    Expect(1, 126267, '\P{Numeric_Value=0000000002000}', "");
    Expect(0, 126267, '\P{^Numeric_Value=0000000002000}', "");
    Expect(1, 126266, '\p{Numeric_Value=2.000000000000000e+03}', "");
    Expect(0, 126266, '\p{^Numeric_Value=2.000000000000000e+03}', "");
    Expect(0, 126266, '\P{Numeric_Value=2.000000000000000e+03}', "");
    Expect(1, 126266, '\P{^Numeric_Value=2.000000000000000e+03}', "");
    Expect(0, 126267, '\p{Numeric_Value=2.000000000000000e+03}', "");
    Expect(1, 126267, '\p{^Numeric_Value=2.000000000000000e+03}', "");
    Expect(1, 126267, '\P{Numeric_Value=2.000000000000000e+03}', "");
    Expect(0, 126267, '\P{^Numeric_Value=2.000000000000000e+03}', "");
    Error('\p{Nv=_/a/0002000}');
    Error('\P{Nv=_/a/0002000}');
    Expect(1, 126266, '\p{Nv=:\A2000\z:}', "");;
    Expect(0, 126267, '\p{Nv=:\A2000\z:}', "");;
    Expect(1, 126266, '\p{Nv=+002000}', "");
    Expect(0, 126266, '\p{^Nv=+002000}', "");
    Expect(0, 126266, '\P{Nv=+002000}', "");
    Expect(1, 126266, '\P{^Nv=+002000}', "");
    Expect(0, 126267, '\p{Nv=+002000}', "");
    Expect(1, 126267, '\p{^Nv=+002000}', "");
    Expect(1, 126267, '\P{Nv=+002000}', "");
    Expect(0, 126267, '\P{^Nv=+002000}', "");
    Expect(1, 126266, '\p{Nv=2.000000000000000e+03}', "");
    Expect(0, 126266, '\p{^Nv=2.000000000000000e+03}', "");
    Expect(0, 126266, '\P{Nv=2.000000000000000e+03}', "");
    Expect(1, 126266, '\P{^Nv=2.000000000000000e+03}', "");
    Expect(0, 126267, '\p{Nv=2.000000000000000e+03}', "");
    Expect(1, 126267, '\p{^Nv=2.000000000000000e+03}', "");
    Expect(1, 126267, '\P{Nv=2.000000000000000e+03}', "");
    Expect(0, 126267, '\P{^Nv=2.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value=	/a/000000000200_0}');
    Error('\P{Is_Numeric_Value=	/a/000000000200_0}');
    Expect(1, 126266, '\p{Is_Numeric_Value=00_20_00}', "");
    Expect(0, 126266, '\p{^Is_Numeric_Value=00_20_00}', "");
    Expect(0, 126266, '\P{Is_Numeric_Value=00_20_00}', "");
    Expect(1, 126266, '\P{^Is_Numeric_Value=00_20_00}', "");
    Expect(0, 126267, '\p{Is_Numeric_Value=00_20_00}', "");
    Expect(1, 126267, '\p{^Is_Numeric_Value=00_20_00}', "");
    Expect(1, 126267, '\P{Is_Numeric_Value=00_20_00}', "");
    Expect(0, 126267, '\P{^Is_Numeric_Value=00_20_00}', "");
    Expect(1, 126266, '\p{Is_Numeric_Value=2.000000000000000e+03}', "");
    Expect(0, 126266, '\p{^Is_Numeric_Value=2.000000000000000e+03}', "");
    Expect(0, 126266, '\P{Is_Numeric_Value=2.000000000000000e+03}', "");
    Expect(1, 126266, '\P{^Is_Numeric_Value=2.000000000000000e+03}', "");
    Expect(0, 126267, '\p{Is_Numeric_Value=2.000000000000000e+03}', "");
    Expect(1, 126267, '\p{^Is_Numeric_Value=2.000000000000000e+03}', "");
    Expect(1, 126267, '\P{Is_Numeric_Value=2.000000000000000e+03}', "");
    Expect(0, 126267, '\P{^Is_Numeric_Value=2.000000000000000e+03}', "");
    Error('\p{Is_Nv= /a/+200_0}');
    Error('\P{Is_Nv= /a/+200_0}');
    Expect(1, 126266, '\p{Is_Nv=0200_0}', "");
    Expect(0, 126266, '\p{^Is_Nv=0200_0}', "");
    Expect(0, 126266, '\P{Is_Nv=0200_0}', "");
    Expect(1, 126266, '\P{^Is_Nv=0200_0}', "");
    Expect(0, 126267, '\p{Is_Nv=0200_0}', "");
    Expect(1, 126267, '\p{^Is_Nv=0200_0}', "");
    Expect(1, 126267, '\P{Is_Nv=0200_0}', "");
    Expect(0, 126267, '\P{^Is_Nv=0200_0}', "");
    Expect(1, 126266, '\p{Is_Nv=2.000000000000000e+03}', "");
    Expect(0, 126266, '\p{^Is_Nv=2.000000000000000e+03}', "");
    Expect(0, 126266, '\P{Is_Nv=2.000000000000000e+03}', "");
    Expect(1, 126266, '\P{^Is_Nv=2.000000000000000e+03}', "");
    Expect(0, 126267, '\p{Is_Nv=2.000000000000000e+03}', "");
    Expect(1, 126267, '\p{^Is_Nv=2.000000000000000e+03}', "");
    Expect(1, 126267, '\P{Is_Nv=2.000000000000000e+03}', "");
    Expect(0, 126267, '\P{^Is_Nv=2.000000000000000e+03}', "");
    Error('\p{Numeric_Value=_-20000:=}');
    Error('\P{Numeric_Value=_-20000:=}');
    Expect(1, 126246, '\p{Numeric_Value=:\A20000\z:}', "");;
    Expect(0, 126247, '\p{Numeric_Value=:\A20000\z:}', "");;
    Expect(1, 126246, '\p{Numeric_Value=2000_0}', "");
    Expect(0, 126246, '\p{^Numeric_Value=2000_0}', "");
    Expect(0, 126246, '\P{Numeric_Value=2000_0}', "");
    Expect(1, 126246, '\P{^Numeric_Value=2000_0}', "");
    Expect(0, 126247, '\p{Numeric_Value=2000_0}', "");
    Expect(1, 126247, '\p{^Numeric_Value=2000_0}', "");
    Expect(1, 126247, '\P{Numeric_Value=2000_0}', "");
    Expect(0, 126247, '\P{^Numeric_Value=2000_0}', "");
    Expect(1, 126246, '\p{Numeric_Value=2.000000000000000e+04}', "");
    Expect(0, 126246, '\p{^Numeric_Value=2.000000000000000e+04}', "");
    Expect(0, 126246, '\P{Numeric_Value=2.000000000000000e+04}', "");
    Expect(1, 126246, '\P{^Numeric_Value=2.000000000000000e+04}', "");
    Expect(0, 126247, '\p{Numeric_Value=2.000000000000000e+04}', "");
    Expect(1, 126247, '\p{^Numeric_Value=2.000000000000000e+04}', "");
    Expect(1, 126247, '\P{Numeric_Value=2.000000000000000e+04}', "");
    Expect(0, 126247, '\P{^Numeric_Value=2.000000000000000e+04}', "");
    Error('\p{Nv=-	0000020000/a/}');
    Error('\P{Nv=-	0000020000/a/}');
    Expect(1, 126246, '\p{Nv=:\A20000\z:}', "");;
    Expect(0, 126247, '\p{Nv=:\A20000\z:}', "");;
    Expect(1, 126246, '\p{Nv=+0_0_0_0_0_0_0_020000}', "");
    Expect(0, 126246, '\p{^Nv=+0_0_0_0_0_0_0_020000}', "");
    Expect(0, 126246, '\P{Nv=+0_0_0_0_0_0_0_020000}', "");
    Expect(1, 126246, '\P{^Nv=+0_0_0_0_0_0_0_020000}', "");
    Expect(0, 126247, '\p{Nv=+0_0_0_0_0_0_0_020000}', "");
    Expect(1, 126247, '\p{^Nv=+0_0_0_0_0_0_0_020000}', "");
    Expect(1, 126247, '\P{Nv=+0_0_0_0_0_0_0_020000}', "");
    Expect(0, 126247, '\P{^Nv=+0_0_0_0_0_0_0_020000}', "");
    Expect(1, 126246, '\p{Nv=2.000000000000000e+04}', "");
    Expect(0, 126246, '\p{^Nv=2.000000000000000e+04}', "");
    Expect(0, 126246, '\P{Nv=2.000000000000000e+04}', "");
    Expect(1, 126246, '\P{^Nv=2.000000000000000e+04}', "");
    Expect(0, 126247, '\p{Nv=2.000000000000000e+04}', "");
    Expect(1, 126247, '\p{^Nv=2.000000000000000e+04}', "");
    Expect(1, 126247, '\P{Nv=2.000000000000000e+04}', "");
    Expect(0, 126247, '\P{^Nv=2.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value=--+000000_002000_0/a/}');
    Error('\P{Is_Numeric_Value=--+000000_002000_0/a/}');
    Expect(1, 126246, '\p{Is_Numeric_Value=0_0_0_0_2_0000}', "");
    Expect(0, 126246, '\p{^Is_Numeric_Value=0_0_0_0_2_0000}', "");
    Expect(0, 126246, '\P{Is_Numeric_Value=0_0_0_0_2_0000}', "");
    Expect(1, 126246, '\P{^Is_Numeric_Value=0_0_0_0_2_0000}', "");
    Expect(0, 126247, '\p{Is_Numeric_Value=0_0_0_0_2_0000}', "");
    Expect(1, 126247, '\p{^Is_Numeric_Value=0_0_0_0_2_0000}', "");
    Expect(1, 126247, '\P{Is_Numeric_Value=0_0_0_0_2_0000}', "");
    Expect(0, 126247, '\P{^Is_Numeric_Value=0_0_0_0_2_0000}', "");
    Expect(1, 126246, '\p{Is_Numeric_Value=2.000000000000000e+04}', "");
    Expect(0, 126246, '\p{^Is_Numeric_Value=2.000000000000000e+04}', "");
    Expect(0, 126246, '\P{Is_Numeric_Value=2.000000000000000e+04}', "");
    Expect(1, 126246, '\P{^Is_Numeric_Value=2.000000000000000e+04}', "");
    Expect(0, 126247, '\p{Is_Numeric_Value=2.000000000000000e+04}', "");
    Expect(1, 126247, '\p{^Is_Numeric_Value=2.000000000000000e+04}', "");
    Expect(1, 126247, '\P{Is_Numeric_Value=2.000000000000000e+04}', "");
    Expect(0, 126247, '\P{^Is_Numeric_Value=2.000000000000000e+04}', "");
    Error('\p{Is_Nv=_/a/000000020000}');
    Error('\P{Is_Nv=_/a/000000020000}');
    Expect(1, 126246, '\p{Is_Nv=+20000}', "");
    Expect(0, 126246, '\p{^Is_Nv=+20000}', "");
    Expect(0, 126246, '\P{Is_Nv=+20000}', "");
    Expect(1, 126246, '\P{^Is_Nv=+20000}', "");
    Expect(0, 126247, '\p{Is_Nv=+20000}', "");
    Expect(1, 126247, '\p{^Is_Nv=+20000}', "");
    Expect(1, 126247, '\P{Is_Nv=+20000}', "");
    Expect(0, 126247, '\P{^Is_Nv=+20000}', "");
    Expect(1, 126246, '\p{Is_Nv=2.000000000000000e+04}', "");
    Expect(0, 126246, '\p{^Is_Nv=2.000000000000000e+04}', "");
    Expect(0, 126246, '\P{Is_Nv=2.000000000000000e+04}', "");
    Expect(1, 126246, '\P{^Is_Nv=2.000000000000000e+04}', "");
    Expect(0, 126247, '\p{Is_Nv=2.000000000000000e+04}', "");
    Expect(1, 126247, '\p{^Is_Nv=2.000000000000000e+04}', "");
    Expect(1, 126247, '\P{Is_Nv=2.000000000000000e+04}', "");
    Expect(0, 126247, '\P{^Is_Nv=2.000000000000000e+04}', "");
    Error('\p{Numeric_Value=_:=0_0_0_0_2_0_0_0_00}');
    Error('\P{Numeric_Value=_:=0_0_0_0_2_0_0_0_00}');
    Expect(1, 126111, '\p{Numeric_Value=:\A200000\z:}', "");;
    Expect(0, 126112, '\p{Numeric_Value=:\A200000\z:}', "");;
    Expect(1, 126111, '\p{Numeric_Value=+02_00_00_0}', "");
    Expect(0, 126111, '\p{^Numeric_Value=+02_00_00_0}', "");
    Expect(0, 126111, '\P{Numeric_Value=+02_00_00_0}', "");
    Expect(1, 126111, '\P{^Numeric_Value=+02_00_00_0}', "");
    Expect(0, 126112, '\p{Numeric_Value=+02_00_00_0}', "");
    Expect(1, 126112, '\p{^Numeric_Value=+02_00_00_0}', "");
    Expect(1, 126112, '\P{Numeric_Value=+02_00_00_0}', "");
    Expect(0, 126112, '\P{^Numeric_Value=+02_00_00_0}', "");
    Expect(1, 126111, '\p{Numeric_Value=2.000000000000000e+05}', "");
    Expect(0, 126111, '\p{^Numeric_Value=2.000000000000000e+05}', "");
    Expect(0, 126111, '\P{Numeric_Value=2.000000000000000e+05}', "");
    Expect(1, 126111, '\P{^Numeric_Value=2.000000000000000e+05}', "");
    Expect(0, 126112, '\p{Numeric_Value=2.000000000000000e+05}', "");
    Expect(1, 126112, '\p{^Numeric_Value=2.000000000000000e+05}', "");
    Expect(1, 126112, '\P{Numeric_Value=2.000000000000000e+05}', "");
    Expect(0, 126112, '\P{^Numeric_Value=2.000000000000000e+05}', "");
    Error('\p{Nv:-:=000020000_0}');
    Error('\P{Nv:-:=000020000_0}');
    Expect(1, 126111, '\p{Nv=:\A200000\z:}', "");;
    Expect(0, 126112, '\p{Nv=:\A200000\z:}', "");;
    Expect(1, 126111, '\p{Nv=0_0_0_0_0_2_0_0_000}', "");
    Expect(0, 126111, '\p{^Nv=0_0_0_0_0_2_0_0_000}', "");
    Expect(0, 126111, '\P{Nv=0_0_0_0_0_2_0_0_000}', "");
    Expect(1, 126111, '\P{^Nv=0_0_0_0_0_2_0_0_000}', "");
    Expect(0, 126112, '\p{Nv=0_0_0_0_0_2_0_0_000}', "");
    Expect(1, 126112, '\p{^Nv=0_0_0_0_0_2_0_0_000}', "");
    Expect(1, 126112, '\P{Nv=0_0_0_0_0_2_0_0_000}', "");
    Expect(0, 126112, '\P{^Nv=0_0_0_0_0_2_0_0_000}', "");
    Expect(1, 126111, '\p{Nv=2.000000000000000e+05}', "");
    Expect(0, 126111, '\p{^Nv=2.000000000000000e+05}', "");
    Expect(0, 126111, '\P{Nv=2.000000000000000e+05}', "");
    Expect(1, 126111, '\P{^Nv=2.000000000000000e+05}', "");
    Expect(0, 126112, '\p{Nv=2.000000000000000e+05}', "");
    Expect(1, 126112, '\p{^Nv=2.000000000000000e+05}', "");
    Expect(1, 126112, '\P{Nv=2.000000000000000e+05}', "");
    Expect(0, 126112, '\P{^Nv=2.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value=:=+00000000200000}');
    Error('\P{Is_Numeric_Value=:=+00000000200000}');
    Expect(1, 126111, '\p{Is_Numeric_Value=+00_00_00_00_02_00000}', "");
    Expect(0, 126111, '\p{^Is_Numeric_Value=+00_00_00_00_02_00000}', "");
    Expect(0, 126111, '\P{Is_Numeric_Value=+00_00_00_00_02_00000}', "");
    Expect(1, 126111, '\P{^Is_Numeric_Value=+00_00_00_00_02_00000}', "");
    Expect(0, 126112, '\p{Is_Numeric_Value=+00_00_00_00_02_00000}', "");
    Expect(1, 126112, '\p{^Is_Numeric_Value=+00_00_00_00_02_00000}', "");
    Expect(1, 126112, '\P{Is_Numeric_Value=+00_00_00_00_02_00000}', "");
    Expect(0, 126112, '\P{^Is_Numeric_Value=+00_00_00_00_02_00000}', "");
    Expect(1, 126111, '\p{Is_Numeric_Value=2.000000000000000e+05}', "");
    Expect(0, 126111, '\p{^Is_Numeric_Value=2.000000000000000e+05}', "");
    Expect(0, 126111, '\P{Is_Numeric_Value=2.000000000000000e+05}', "");
    Expect(1, 126111, '\P{^Is_Numeric_Value=2.000000000000000e+05}', "");
    Expect(0, 126112, '\p{Is_Numeric_Value=2.000000000000000e+05}', "");
    Expect(1, 126112, '\p{^Is_Numeric_Value=2.000000000000000e+05}', "");
    Expect(1, 126112, '\P{Is_Numeric_Value=2.000000000000000e+05}', "");
    Expect(0, 126112, '\P{^Is_Numeric_Value=2.000000000000000e+05}', "");
    Error('\p{Is_Nv=:=00000000200000}');
    Error('\P{Is_Nv=:=00000000200000}');
    Expect(1, 126111, '\p{Is_Nv:	000200000}', "");
    Expect(0, 126111, '\p{^Is_Nv:	000200000}', "");
    Expect(0, 126111, '\P{Is_Nv:	000200000}', "");
    Expect(1, 126111, '\P{^Is_Nv:	000200000}', "");
    Expect(0, 126112, '\p{Is_Nv:	000200000}', "");
    Expect(1, 126112, '\p{^Is_Nv:	000200000}', "");
    Expect(1, 126112, '\P{Is_Nv:	000200000}', "");
    Expect(0, 126112, '\P{^Is_Nv:	000200000}', "");
    Expect(1, 126111, '\p{Is_Nv=2.000000000000000e+05}', "");
    Expect(0, 126111, '\p{^Is_Nv=2.000000000000000e+05}', "");
    Expect(0, 126111, '\P{Is_Nv=2.000000000000000e+05}', "");
    Expect(1, 126111, '\P{^Is_Nv=2.000000000000000e+05}', "");
    Expect(0, 126112, '\p{Is_Nv=2.000000000000000e+05}', "");
    Expect(1, 126112, '\p{^Is_Nv=2.000000000000000e+05}', "");
    Expect(1, 126112, '\P{Is_Nv=2.000000000000000e+05}', "");
    Expect(0, 126112, '\P{^Is_Nv=2.000000000000000e+05}', "");
    Error('\p{Numeric_Value=:=	+0002000000_0}');
    Error('\P{Numeric_Value=:=	+0002000000_0}');
    Expect(1, 126114, '\p{Numeric_Value=:\A20000000\z:}', "");;
    Expect(0, 126115, '\p{Numeric_Value=:\A20000000\z:}', "");;
    Expect(1, 126114, '\p{Numeric_Value=0_0_0_0_0_0_0_0_2_0000000}', "");
    Expect(0, 126114, '\p{^Numeric_Value=0_0_0_0_0_0_0_0_2_0000000}', "");
    Expect(0, 126114, '\P{Numeric_Value=0_0_0_0_0_0_0_0_2_0000000}', "");
    Expect(1, 126114, '\P{^Numeric_Value=0_0_0_0_0_0_0_0_2_0000000}', "");
    Expect(0, 126115, '\p{Numeric_Value=0_0_0_0_0_0_0_0_2_0000000}', "");
    Expect(1, 126115, '\p{^Numeric_Value=0_0_0_0_0_0_0_0_2_0000000}', "");
    Expect(1, 126115, '\P{Numeric_Value=0_0_0_0_0_0_0_0_2_0000000}', "");
    Expect(0, 126115, '\P{^Numeric_Value=0_0_0_0_0_0_0_0_2_0000000}', "");
    Expect(1, 126114, '\p{Numeric_Value=2.000000000000000e+07}', "");
    Expect(0, 126114, '\p{^Numeric_Value=2.000000000000000e+07}', "");
    Expect(0, 126114, '\P{Numeric_Value=2.000000000000000e+07}', "");
    Expect(1, 126114, '\P{^Numeric_Value=2.000000000000000e+07}', "");
    Expect(0, 126115, '\p{Numeric_Value=2.000000000000000e+07}', "");
    Expect(1, 126115, '\p{^Numeric_Value=2.000000000000000e+07}', "");
    Expect(1, 126115, '\P{Numeric_Value=2.000000000000000e+07}', "");
    Expect(0, 126115, '\P{^Numeric_Value=2.000000000000000e+07}', "");
    Error('\p{Nv=00_00_02_00_00_00_0:=}');
    Error('\P{Nv=00_00_02_00_00_00_0:=}');
    Expect(1, 126114, '\p{Nv=:\A20000000\z:}', "");;
    Expect(0, 126115, '\p{Nv=:\A20000000\z:}', "");;
    Expect(1, 126114, '\p{Nv=000020000000}', "");
    Expect(0, 126114, '\p{^Nv=000020000000}', "");
    Expect(0, 126114, '\P{Nv=000020000000}', "");
    Expect(1, 126114, '\P{^Nv=000020000000}', "");
    Expect(0, 126115, '\p{Nv=000020000000}', "");
    Expect(1, 126115, '\p{^Nv=000020000000}', "");
    Expect(1, 126115, '\P{Nv=000020000000}', "");
    Expect(0, 126115, '\P{^Nv=000020000000}', "");
    Expect(1, 126114, '\p{Nv=2.000000000000000e+07}', "");
    Expect(0, 126114, '\p{^Nv=2.000000000000000e+07}', "");
    Expect(0, 126114, '\P{Nv=2.000000000000000e+07}', "");
    Expect(1, 126114, '\P{^Nv=2.000000000000000e+07}', "");
    Expect(0, 126115, '\p{Nv=2.000000000000000e+07}', "");
    Expect(1, 126115, '\p{^Nv=2.000000000000000e+07}', "");
    Expect(1, 126115, '\P{Nv=2.000000000000000e+07}', "");
    Expect(0, 126115, '\P{^Nv=2.000000000000000e+07}', "");
    Error('\p{Is_Numeric_Value=- 000_000_002_000_0000/a/}');
    Error('\P{Is_Numeric_Value=- 000_000_002_000_0000/a/}');
    Expect(1, 126114, '\p{Is_Numeric_Value=020000000}', "");
    Expect(0, 126114, '\p{^Is_Numeric_Value=020000000}', "");
    Expect(0, 126114, '\P{Is_Numeric_Value=020000000}', "");
    Expect(1, 126114, '\P{^Is_Numeric_Value=020000000}', "");
    Expect(0, 126115, '\p{Is_Numeric_Value=020000000}', "");
    Expect(1, 126115, '\p{^Is_Numeric_Value=020000000}', "");
    Expect(1, 126115, '\P{Is_Numeric_Value=020000000}', "");
    Expect(0, 126115, '\P{^Is_Numeric_Value=020000000}', "");
    Expect(1, 126114, '\p{Is_Numeric_Value=2.000000000000000e+07}', "");
    Expect(0, 126114, '\p{^Is_Numeric_Value=2.000000000000000e+07}', "");
    Expect(0, 126114, '\P{Is_Numeric_Value=2.000000000000000e+07}', "");
    Expect(1, 126114, '\P{^Is_Numeric_Value=2.000000000000000e+07}', "");
    Expect(0, 126115, '\p{Is_Numeric_Value=2.000000000000000e+07}', "");
    Expect(1, 126115, '\p{^Is_Numeric_Value=2.000000000000000e+07}', "");
    Expect(1, 126115, '\P{Is_Numeric_Value=2.000000000000000e+07}', "");
    Expect(0, 126115, '\P{^Is_Numeric_Value=2.000000000000000e+07}', "");
    Error('\p{Is_Nv=:= 00020000000}');
    Error('\P{Is_Nv=:= 00020000000}');
    Expect(1, 126114, '\p{Is_Nv=+00_00_00_00_02_00_00_00_0}', "");
    Expect(0, 126114, '\p{^Is_Nv=+00_00_00_00_02_00_00_00_0}', "");
    Expect(0, 126114, '\P{Is_Nv=+00_00_00_00_02_00_00_00_0}', "");
    Expect(1, 126114, '\P{^Is_Nv=+00_00_00_00_02_00_00_00_0}', "");
    Expect(0, 126115, '\p{Is_Nv=+00_00_00_00_02_00_00_00_0}', "");
    Expect(1, 126115, '\p{^Is_Nv=+00_00_00_00_02_00_00_00_0}', "");
    Expect(1, 126115, '\P{Is_Nv=+00_00_00_00_02_00_00_00_0}', "");
    Expect(0, 126115, '\P{^Is_Nv=+00_00_00_00_02_00_00_00_0}', "");
    Expect(1, 126114, '\p{Is_Nv=2.000000000000000e+07}', "");
    Expect(0, 126114, '\p{^Is_Nv=2.000000000000000e+07}', "");
    Expect(0, 126114, '\P{Is_Nv=2.000000000000000e+07}', "");
    Expect(1, 126114, '\P{^Is_Nv=2.000000000000000e+07}', "");
    Expect(0, 126115, '\p{Is_Nv=2.000000000000000e+07}', "");
    Expect(1, 126115, '\p{^Is_Nv=2.000000000000000e+07}', "");
    Expect(1, 126115, '\P{Is_Nv=2.000000000000000e+07}', "");
    Expect(0, 126115, '\P{^Is_Nv=2.000000000000000e+07}', "");
    Error('\p{Numeric_Value=_:=000000021}');
    Error('\P{Numeric_Value=_:=000000021}');
    Expect(1, 12881, '\p{Numeric_Value=:\A21\z:}', "");;
    Expect(0, 12882, '\p{Numeric_Value=:\A21\z:}', "");;
    Expect(1, 12881, '\p{Numeric_Value=002_1}', "");
    Expect(0, 12881, '\p{^Numeric_Value=002_1}', "");
    Expect(0, 12881, '\P{Numeric_Value=002_1}', "");
    Expect(1, 12881, '\P{^Numeric_Value=002_1}', "");
    Expect(0, 12882, '\p{Numeric_Value=002_1}', "");
    Expect(1, 12882, '\p{^Numeric_Value=002_1}', "");
    Expect(1, 12882, '\P{Numeric_Value=002_1}', "");
    Expect(0, 12882, '\P{^Numeric_Value=002_1}', "");
    Expect(1, 12881, '\p{Numeric_Value=2.100000000000000e+01}', "");
    Expect(0, 12881, '\p{^Numeric_Value=2.100000000000000e+01}', "");
    Expect(0, 12881, '\P{Numeric_Value=2.100000000000000e+01}', "");
    Expect(1, 12881, '\P{^Numeric_Value=2.100000000000000e+01}', "");
    Expect(0, 12882, '\p{Numeric_Value=2.100000000000000e+01}', "");
    Expect(1, 12882, '\p{^Numeric_Value=2.100000000000000e+01}', "");
    Expect(1, 12882, '\P{Numeric_Value=2.100000000000000e+01}', "");
    Expect(0, 12882, '\P{^Numeric_Value=2.100000000000000e+01}', "");
    Error('\p{Nv=_-0_0_21/a/}');
    Error('\P{Nv=_-0_0_21/a/}');
    Expect(1, 12881, '\p{Nv=:\A21\z:}', "");;
    Expect(0, 12882, '\p{Nv=:\A21\z:}', "");;
    Expect(1, 12881, '\p{Nv=0021}', "");
    Expect(0, 12881, '\p{^Nv=0021}', "");
    Expect(0, 12881, '\P{Nv=0021}', "");
    Expect(1, 12881, '\P{^Nv=0021}', "");
    Expect(0, 12882, '\p{Nv=0021}', "");
    Expect(1, 12882, '\p{^Nv=0021}', "");
    Expect(1, 12882, '\P{Nv=0021}', "");
    Expect(0, 12882, '\P{^Nv=0021}', "");
    Expect(1, 12881, '\p{Nv=2.100000000000000e+01}', "");
    Expect(0, 12881, '\p{^Nv=2.100000000000000e+01}', "");
    Expect(0, 12881, '\P{Nv=2.100000000000000e+01}', "");
    Expect(1, 12881, '\P{^Nv=2.100000000000000e+01}', "");
    Expect(0, 12882, '\p{Nv=2.100000000000000e+01}', "");
    Expect(1, 12882, '\p{^Nv=2.100000000000000e+01}', "");
    Expect(1, 12882, '\P{Nv=2.100000000000000e+01}', "");
    Expect(0, 12882, '\P{^Nv=2.100000000000000e+01}', "");
    Error('\p{Is_Numeric_Value= /a/+0002_1}');
    Error('\P{Is_Numeric_Value= /a/+0002_1}');
    Expect(1, 12881, '\p{Is_Numeric_Value=0_0_0_0_0_0_0_21}', "");
    Expect(0, 12881, '\p{^Is_Numeric_Value=0_0_0_0_0_0_0_21}', "");
    Expect(0, 12881, '\P{Is_Numeric_Value=0_0_0_0_0_0_0_21}', "");
    Expect(1, 12881, '\P{^Is_Numeric_Value=0_0_0_0_0_0_0_21}', "");
    Expect(0, 12882, '\p{Is_Numeric_Value=0_0_0_0_0_0_0_21}', "");
    Expect(1, 12882, '\p{^Is_Numeric_Value=0_0_0_0_0_0_0_21}', "");
    Expect(1, 12882, '\P{Is_Numeric_Value=0_0_0_0_0_0_0_21}', "");
    Expect(0, 12882, '\P{^Is_Numeric_Value=0_0_0_0_0_0_0_21}', "");
    Expect(1, 12881, '\p{Is_Numeric_Value=2.100000000000000e+01}', "");
    Expect(0, 12881, '\p{^Is_Numeric_Value=2.100000000000000e+01}', "");
    Expect(0, 12881, '\P{Is_Numeric_Value=2.100000000000000e+01}', "");
    Expect(1, 12881, '\P{^Is_Numeric_Value=2.100000000000000e+01}', "");
    Expect(0, 12882, '\p{Is_Numeric_Value=2.100000000000000e+01}', "");
    Expect(1, 12882, '\p{^Is_Numeric_Value=2.100000000000000e+01}', "");
    Expect(1, 12882, '\P{Is_Numeric_Value=2.100000000000000e+01}', "");
    Expect(0, 12882, '\P{^Is_Numeric_Value=2.100000000000000e+01}', "");
    Error('\p{Is_Nv=_/a/+00_02_1}');
    Error('\P{Is_Nv=_/a/+00_02_1}');
    Expect(1, 12881, '\p{Is_Nv=021}', "");
    Expect(0, 12881, '\p{^Is_Nv=021}', "");
    Expect(0, 12881, '\P{Is_Nv=021}', "");
    Expect(1, 12881, '\P{^Is_Nv=021}', "");
    Expect(0, 12882, '\p{Is_Nv=021}', "");
    Expect(1, 12882, '\p{^Is_Nv=021}', "");
    Expect(1, 12882, '\P{Is_Nv=021}', "");
    Expect(0, 12882, '\P{^Is_Nv=021}', "");
    Expect(1, 12881, '\p{Is_Nv: 2.100000000000000e+01}', "");
    Expect(0, 12881, '\p{^Is_Nv: 2.100000000000000e+01}', "");
    Expect(0, 12881, '\P{Is_Nv: 2.100000000000000e+01}', "");
    Expect(1, 12881, '\P{^Is_Nv: 2.100000000000000e+01}', "");
    Expect(0, 12882, '\p{Is_Nv: 2.100000000000000e+01}', "");
    Expect(1, 12882, '\p{^Is_Nv: 2.100000000000000e+01}', "");
    Expect(1, 12882, '\P{Is_Nv: 2.100000000000000e+01}', "");
    Expect(0, 12882, '\P{^Is_Nv: 2.100000000000000e+01}', "");
    Error('\p{Numeric_Value=		00000021600_0/a/}');
    Error('\P{Numeric_Value=		00000021600_0/a/}');
    Expect(1, 74802, '\p{Numeric_Value=:\A216000\z:}', "");;
    Expect(0, 74803, '\p{Numeric_Value=:\A216000\z:}', "");;
    Expect(1, 74802, '\p{Numeric_Value=0_0_2_1_6000}', "");
    Expect(0, 74802, '\p{^Numeric_Value=0_0_2_1_6000}', "");
    Expect(0, 74802, '\P{Numeric_Value=0_0_2_1_6000}', "");
    Expect(1, 74802, '\P{^Numeric_Value=0_0_2_1_6000}', "");
    Expect(0, 74803, '\p{Numeric_Value=0_0_2_1_6000}', "");
    Expect(1, 74803, '\p{^Numeric_Value=0_0_2_1_6000}', "");
    Expect(1, 74803, '\P{Numeric_Value=0_0_2_1_6000}', "");
    Expect(0, 74803, '\P{^Numeric_Value=0_0_2_1_6000}', "");
    Expect(1, 74802, '\p{Numeric_Value:	2.160000000000000e+05}', "");
    Expect(0, 74802, '\p{^Numeric_Value:	2.160000000000000e+05}', "");
    Expect(0, 74802, '\P{Numeric_Value:	2.160000000000000e+05}', "");
    Expect(1, 74802, '\P{^Numeric_Value:	2.160000000000000e+05}', "");
    Expect(0, 74803, '\p{Numeric_Value:	2.160000000000000e+05}', "");
    Expect(1, 74803, '\p{^Numeric_Value:	2.160000000000000e+05}', "");
    Expect(1, 74803, '\P{Numeric_Value:	2.160000000000000e+05}', "");
    Expect(0, 74803, '\P{^Numeric_Value:	2.160000000000000e+05}', "");
    Error('\p{Nv= 	0021600_0/a/}');
    Error('\P{Nv= 	0021600_0/a/}');
    Expect(1, 74802, '\p{Nv=:\A216000\z:}', "");;
    Expect(0, 74803, '\p{Nv=:\A216000\z:}', "");;
    Expect(1, 74802, '\p{Nv=0000216000}', "");
    Expect(0, 74802, '\p{^Nv=0000216000}', "");
    Expect(0, 74802, '\P{Nv=0000216000}', "");
    Expect(1, 74802, '\P{^Nv=0000216000}', "");
    Expect(0, 74803, '\p{Nv=0000216000}', "");
    Expect(1, 74803, '\p{^Nv=0000216000}', "");
    Expect(1, 74803, '\P{Nv=0000216000}', "");
    Expect(0, 74803, '\P{^Nv=0000216000}', "");
    Expect(1, 74802, '\p{Nv=2.160000000000000e+05}', "");
    Expect(0, 74802, '\p{^Nv=2.160000000000000e+05}', "");
    Expect(0, 74802, '\P{Nv=2.160000000000000e+05}', "");
    Expect(1, 74802, '\P{^Nv=2.160000000000000e+05}', "");
    Expect(0, 74803, '\p{Nv=2.160000000000000e+05}', "");
    Expect(1, 74803, '\p{^Nv=2.160000000000000e+05}', "");
    Expect(1, 74803, '\P{Nv=2.160000000000000e+05}', "");
    Expect(0, 74803, '\P{^Nv=2.160000000000000e+05}', "");
    Error('\p{Is_Numeric_Value= /a/000216000}');
    Error('\P{Is_Numeric_Value= /a/000216000}');
    Expect(1, 74802, '\p{Is_Numeric_Value=00_02_16_000}', "");
    Expect(0, 74802, '\p{^Is_Numeric_Value=00_02_16_000}', "");
    Expect(0, 74802, '\P{Is_Numeric_Value=00_02_16_000}', "");
    Expect(1, 74802, '\P{^Is_Numeric_Value=00_02_16_000}', "");
    Expect(0, 74803, '\p{Is_Numeric_Value=00_02_16_000}', "");
    Expect(1, 74803, '\p{^Is_Numeric_Value=00_02_16_000}', "");
    Expect(1, 74803, '\P{Is_Numeric_Value=00_02_16_000}', "");
    Expect(0, 74803, '\P{^Is_Numeric_Value=00_02_16_000}', "");
    Expect(1, 74802, '\p{Is_Numeric_Value=2.160000000000000e+05}', "");
    Expect(0, 74802, '\p{^Is_Numeric_Value=2.160000000000000e+05}', "");
    Expect(0, 74802, '\P{Is_Numeric_Value=2.160000000000000e+05}', "");
    Expect(1, 74802, '\P{^Is_Numeric_Value=2.160000000000000e+05}', "");
    Expect(0, 74803, '\p{Is_Numeric_Value=2.160000000000000e+05}', "");
    Expect(1, 74803, '\p{^Is_Numeric_Value=2.160000000000000e+05}', "");
    Expect(1, 74803, '\P{Is_Numeric_Value=2.160000000000000e+05}', "");
    Expect(0, 74803, '\P{^Is_Numeric_Value=2.160000000000000e+05}', "");
    Error('\p{Is_Nv=+00216000/a/}');
    Error('\P{Is_Nv=+00216000/a/}');
    Expect(1, 74802, '\p{Is_Nv=0_0_0_2_1_6_000}', "");
    Expect(0, 74802, '\p{^Is_Nv=0_0_0_2_1_6_000}', "");
    Expect(0, 74802, '\P{Is_Nv=0_0_0_2_1_6_000}', "");
    Expect(1, 74802, '\P{^Is_Nv=0_0_0_2_1_6_000}', "");
    Expect(0, 74803, '\p{Is_Nv=0_0_0_2_1_6_000}', "");
    Expect(1, 74803, '\p{^Is_Nv=0_0_0_2_1_6_000}', "");
    Expect(1, 74803, '\P{Is_Nv=0_0_0_2_1_6_000}', "");
    Expect(0, 74803, '\P{^Is_Nv=0_0_0_2_1_6_000}', "");
    Expect(1, 74802, '\p{Is_Nv=2.160000000000000e+05}', "");
    Expect(0, 74802, '\p{^Is_Nv=2.160000000000000e+05}', "");
    Expect(0, 74802, '\P{Is_Nv=2.160000000000000e+05}', "");
    Expect(1, 74802, '\P{^Is_Nv=2.160000000000000e+05}', "");
    Expect(0, 74803, '\p{Is_Nv=2.160000000000000e+05}', "");
    Expect(1, 74803, '\p{^Is_Nv=2.160000000000000e+05}', "");
    Expect(1, 74803, '\P{Is_Nv=2.160000000000000e+05}', "");
    Expect(0, 74803, '\P{^Is_Nv=2.160000000000000e+05}', "");
    Error('\p{Numeric_Value=:= +0022}');
    Error('\P{Numeric_Value=:= +0022}');
    Expect(1, 12882, '\p{Numeric_Value=:\A22\z:}', "");;
    Expect(0, 12883, '\p{Numeric_Value=:\A22\z:}', "");;
    Expect(1, 12882, '\p{Numeric_Value=0000_0000_22}', "");
    Expect(0, 12882, '\p{^Numeric_Value=0000_0000_22}', "");
    Expect(0, 12882, '\P{Numeric_Value=0000_0000_22}', "");
    Expect(1, 12882, '\P{^Numeric_Value=0000_0000_22}', "");
    Expect(0, 12883, '\p{Numeric_Value=0000_0000_22}', "");
    Expect(1, 12883, '\p{^Numeric_Value=0000_0000_22}', "");
    Expect(1, 12883, '\P{Numeric_Value=0000_0000_22}', "");
    Expect(0, 12883, '\P{^Numeric_Value=0000_0000_22}', "");
    Expect(1, 12882, '\p{Numeric_Value=2.200000000000000e+01}', "");
    Expect(0, 12882, '\p{^Numeric_Value=2.200000000000000e+01}', "");
    Expect(0, 12882, '\P{Numeric_Value=2.200000000000000e+01}', "");
    Expect(1, 12882, '\P{^Numeric_Value=2.200000000000000e+01}', "");
    Expect(0, 12883, '\p{Numeric_Value=2.200000000000000e+01}', "");
    Expect(1, 12883, '\p{^Numeric_Value=2.200000000000000e+01}', "");
    Expect(1, 12883, '\P{Numeric_Value=2.200000000000000e+01}', "");
    Expect(0, 12883, '\P{^Numeric_Value=2.200000000000000e+01}', "");
    Error('\p{Nv=:=0022}');
    Error('\P{Nv=:=0022}');
    Expect(1, 12882, '\p{Nv=:\A22\z:}', "");;
    Expect(0, 12883, '\p{Nv=:\A22\z:}', "");;
    Expect(1, 12882, '\p{Nv=+00_00_02_2}', "");
    Expect(0, 12882, '\p{^Nv=+00_00_02_2}', "");
    Expect(0, 12882, '\P{Nv=+00_00_02_2}', "");
    Expect(1, 12882, '\P{^Nv=+00_00_02_2}', "");
    Expect(0, 12883, '\p{Nv=+00_00_02_2}', "");
    Expect(1, 12883, '\p{^Nv=+00_00_02_2}', "");
    Expect(1, 12883, '\P{Nv=+00_00_02_2}', "");
    Expect(0, 12883, '\P{^Nv=+00_00_02_2}', "");
    Expect(1, 12882, '\p{Nv=2.200000000000000e+01}', "");
    Expect(0, 12882, '\p{^Nv=2.200000000000000e+01}', "");
    Expect(0, 12882, '\P{Nv=2.200000000000000e+01}', "");
    Expect(1, 12882, '\P{^Nv=2.200000000000000e+01}', "");
    Expect(0, 12883, '\p{Nv=2.200000000000000e+01}', "");
    Expect(1, 12883, '\p{^Nv=2.200000000000000e+01}', "");
    Expect(1, 12883, '\P{Nv=2.200000000000000e+01}', "");
    Expect(0, 12883, '\P{^Nv=2.200000000000000e+01}', "");
    Error('\p{Is_Numeric_Value: 	 +000022:=}');
    Error('\P{Is_Numeric_Value: 	 +000022:=}');
    Expect(1, 12882, '\p{Is_Numeric_Value=00000022}', "");
    Expect(0, 12882, '\p{^Is_Numeric_Value=00000022}', "");
    Expect(0, 12882, '\P{Is_Numeric_Value=00000022}', "");
    Expect(1, 12882, '\P{^Is_Numeric_Value=00000022}', "");
    Expect(0, 12883, '\p{Is_Numeric_Value=00000022}', "");
    Expect(1, 12883, '\p{^Is_Numeric_Value=00000022}', "");
    Expect(1, 12883, '\P{Is_Numeric_Value=00000022}', "");
    Expect(0, 12883, '\P{^Is_Numeric_Value=00000022}', "");
    Expect(1, 12882, '\p{Is_Numeric_Value=2.200000000000000e+01}', "");
    Expect(0, 12882, '\p{^Is_Numeric_Value=2.200000000000000e+01}', "");
    Expect(0, 12882, '\P{Is_Numeric_Value=2.200000000000000e+01}', "");
    Expect(1, 12882, '\P{^Is_Numeric_Value=2.200000000000000e+01}', "");
    Expect(0, 12883, '\p{Is_Numeric_Value=2.200000000000000e+01}', "");
    Expect(1, 12883, '\p{^Is_Numeric_Value=2.200000000000000e+01}', "");
    Expect(1, 12883, '\P{Is_Numeric_Value=2.200000000000000e+01}', "");
    Expect(0, 12883, '\P{^Is_Numeric_Value=2.200000000000000e+01}', "");
    Error('\p{Is_Nv=:= 0_0_0_22}');
    Error('\P{Is_Nv=:= 0_0_0_22}');
    Expect(1, 12882, '\p{Is_Nv=00_02_2}', "");
    Expect(0, 12882, '\p{^Is_Nv=00_02_2}', "");
    Expect(0, 12882, '\P{Is_Nv=00_02_2}', "");
    Expect(1, 12882, '\P{^Is_Nv=00_02_2}', "");
    Expect(0, 12883, '\p{Is_Nv=00_02_2}', "");
    Expect(1, 12883, '\p{^Is_Nv=00_02_2}', "");
    Expect(1, 12883, '\P{Is_Nv=00_02_2}', "");
    Expect(0, 12883, '\P{^Is_Nv=00_02_2}', "");
    Expect(1, 12882, '\p{Is_Nv: 2.200000000000000e+01}', "");
    Expect(0, 12882, '\p{^Is_Nv: 2.200000000000000e+01}', "");
    Expect(0, 12882, '\P{Is_Nv: 2.200000000000000e+01}', "");
    Expect(1, 12882, '\P{^Is_Nv: 2.200000000000000e+01}', "");
    Expect(0, 12883, '\p{Is_Nv: 2.200000000000000e+01}', "");
    Expect(1, 12883, '\p{^Is_Nv: 2.200000000000000e+01}', "");
    Expect(1, 12883, '\P{Is_Nv: 2.200000000000000e+01}', "");
    Expect(0, 12883, '\P{^Is_Nv: 2.200000000000000e+01}', "");
    Error('\p{Numeric_Value:_0_0_0_0_023/a/}');
    Error('\P{Numeric_Value:_0_0_0_0_023/a/}');
    Expect(1, 12883, '\p{Numeric_Value=:\A23\z:}', "");;
    Expect(0, 12884, '\p{Numeric_Value=:\A23\z:}', "");;
    Expect(1, 12883, '\p{Numeric_Value=+0023}', "");
    Expect(0, 12883, '\p{^Numeric_Value=+0023}', "");
    Expect(0, 12883, '\P{Numeric_Value=+0023}', "");
    Expect(1, 12883, '\P{^Numeric_Value=+0023}', "");
    Expect(0, 12884, '\p{Numeric_Value=+0023}', "");
    Expect(1, 12884, '\p{^Numeric_Value=+0023}', "");
    Expect(1, 12884, '\P{Numeric_Value=+0023}', "");
    Expect(0, 12884, '\P{^Numeric_Value=+0023}', "");
    Expect(1, 12883, '\p{Numeric_Value:	2.300000000000000e+01}', "");
    Expect(0, 12883, '\p{^Numeric_Value:	2.300000000000000e+01}', "");
    Expect(0, 12883, '\P{Numeric_Value:	2.300000000000000e+01}', "");
    Expect(1, 12883, '\P{^Numeric_Value:	2.300000000000000e+01}', "");
    Expect(0, 12884, '\p{Numeric_Value:	2.300000000000000e+01}', "");
    Expect(1, 12884, '\p{^Numeric_Value:	2.300000000000000e+01}', "");
    Expect(1, 12884, '\P{Numeric_Value:	2.300000000000000e+01}', "");
    Expect(0, 12884, '\P{^Numeric_Value:	2.300000000000000e+01}', "");
    Error('\p{Nv: :=_-00023}');
    Error('\P{Nv: :=_-00023}');
    Expect(1, 12883, '\p{Nv=:\A23\z:}', "");;
    Expect(0, 12884, '\p{Nv=:\A23\z:}', "");;
    Expect(1, 12883, '\p{Nv=23}', "");
    Expect(0, 12883, '\p{^Nv=23}', "");
    Expect(0, 12883, '\P{Nv=23}', "");
    Expect(1, 12883, '\P{^Nv=23}', "");
    Expect(0, 12884, '\p{Nv=23}', "");
    Expect(1, 12884, '\p{^Nv=23}', "");
    Expect(1, 12884, '\P{Nv=23}', "");
    Expect(0, 12884, '\P{^Nv=23}', "");
    Expect(1, 12883, '\p{Nv:2.300000000000000e+01}', "");
    Expect(0, 12883, '\p{^Nv:2.300000000000000e+01}', "");
    Expect(0, 12883, '\P{Nv:2.300000000000000e+01}', "");
    Expect(1, 12883, '\P{^Nv:2.300000000000000e+01}', "");
    Expect(0, 12884, '\p{Nv:2.300000000000000e+01}', "");
    Expect(1, 12884, '\p{^Nv:2.300000000000000e+01}', "");
    Expect(1, 12884, '\P{Nv:2.300000000000000e+01}', "");
    Expect(0, 12884, '\P{^Nv:2.300000000000000e+01}', "");
    Error('\p{Is_Numeric_Value:/a/_2_3}');
    Error('\P{Is_Numeric_Value:/a/_2_3}');
    Expect(1, 12883, '\p{Is_Numeric_Value:	00000023}', "");
    Expect(0, 12883, '\p{^Is_Numeric_Value:	00000023}', "");
    Expect(0, 12883, '\P{Is_Numeric_Value:	00000023}', "");
    Expect(1, 12883, '\P{^Is_Numeric_Value:	00000023}', "");
    Expect(0, 12884, '\p{Is_Numeric_Value:	00000023}', "");
    Expect(1, 12884, '\p{^Is_Numeric_Value:	00000023}', "");
    Expect(1, 12884, '\P{Is_Numeric_Value:	00000023}', "");
    Expect(0, 12884, '\P{^Is_Numeric_Value:	00000023}', "");
    Expect(1, 12883, '\p{Is_Numeric_Value=2.300000000000000e+01}', "");
    Expect(0, 12883, '\p{^Is_Numeric_Value=2.300000000000000e+01}', "");
    Expect(0, 12883, '\P{Is_Numeric_Value=2.300000000000000e+01}', "");
    Expect(1, 12883, '\P{^Is_Numeric_Value=2.300000000000000e+01}', "");
    Expect(0, 12884, '\p{Is_Numeric_Value=2.300000000000000e+01}', "");
    Expect(1, 12884, '\p{^Is_Numeric_Value=2.300000000000000e+01}', "");
    Expect(1, 12884, '\P{Is_Numeric_Value=2.300000000000000e+01}', "");
    Expect(0, 12884, '\P{^Is_Numeric_Value=2.300000000000000e+01}', "");
    Error('\p{Is_Nv: /a/000002_3}');
    Error('\P{Is_Nv: /a/000002_3}');
    Expect(1, 12883, '\p{Is_Nv=023}', "");
    Expect(0, 12883, '\p{^Is_Nv=023}', "");
    Expect(0, 12883, '\P{Is_Nv=023}', "");
    Expect(1, 12883, '\P{^Is_Nv=023}', "");
    Expect(0, 12884, '\p{Is_Nv=023}', "");
    Expect(1, 12884, '\p{^Is_Nv=023}', "");
    Expect(1, 12884, '\P{Is_Nv=023}', "");
    Expect(0, 12884, '\P{^Is_Nv=023}', "");
    Expect(1, 12883, '\p{Is_Nv=2.300000000000000e+01}', "");
    Expect(0, 12883, '\p{^Is_Nv=2.300000000000000e+01}', "");
    Expect(0, 12883, '\P{Is_Nv=2.300000000000000e+01}', "");
    Expect(1, 12883, '\P{^Is_Nv=2.300000000000000e+01}', "");
    Expect(0, 12884, '\p{Is_Nv=2.300000000000000e+01}', "");
    Expect(1, 12884, '\p{^Is_Nv=2.300000000000000e+01}', "");
    Expect(1, 12884, '\P{Is_Nv=2.300000000000000e+01}', "");
    Expect(0, 12884, '\P{^Is_Nv=2.300000000000000e+01}', "");
    Error('\p{Numeric_Value=:=__+000024}');
    Error('\P{Numeric_Value=:=__+000024}');
    Expect(1, 12884, '\p{Numeric_Value=:\A24\z:}', "");;
    Expect(0, 12885, '\p{Numeric_Value=:\A24\z:}', "");;
    Expect(1, 12884, '\p{Numeric_Value=0000002_4}', "");
    Expect(0, 12884, '\p{^Numeric_Value=0000002_4}', "");
    Expect(0, 12884, '\P{Numeric_Value=0000002_4}', "");
    Expect(1, 12884, '\P{^Numeric_Value=0000002_4}', "");
    Expect(0, 12885, '\p{Numeric_Value=0000002_4}', "");
    Expect(1, 12885, '\p{^Numeric_Value=0000002_4}', "");
    Expect(1, 12885, '\P{Numeric_Value=0000002_4}', "");
    Expect(0, 12885, '\P{^Numeric_Value=0000002_4}', "");
    Expect(1, 12884, '\p{Numeric_Value=2.400000000000000e+01}', "");
    Expect(0, 12884, '\p{^Numeric_Value=2.400000000000000e+01}', "");
    Expect(0, 12884, '\P{Numeric_Value=2.400000000000000e+01}', "");
    Expect(1, 12884, '\P{^Numeric_Value=2.400000000000000e+01}', "");
    Expect(0, 12885, '\p{Numeric_Value=2.400000000000000e+01}', "");
    Expect(1, 12885, '\p{^Numeric_Value=2.400000000000000e+01}', "");
    Expect(1, 12885, '\P{Numeric_Value=2.400000000000000e+01}', "");
    Expect(0, 12885, '\P{^Numeric_Value=2.400000000000000e+01}', "");
    Error('\p{Nv=:=-_00000024}');
    Error('\P{Nv=:=-_00000024}');
    Expect(1, 12884, '\p{Nv=:\A24\z:}', "");;
    Expect(0, 12885, '\p{Nv=:\A24\z:}', "");;
    Expect(1, 12884, '\p{Nv=000024}', "");
    Expect(0, 12884, '\p{^Nv=000024}', "");
    Expect(0, 12884, '\P{Nv=000024}', "");
    Expect(1, 12884, '\P{^Nv=000024}', "");
    Expect(0, 12885, '\p{Nv=000024}', "");
    Expect(1, 12885, '\p{^Nv=000024}', "");
    Expect(1, 12885, '\P{Nv=000024}', "");
    Expect(0, 12885, '\P{^Nv=000024}', "");
    Expect(1, 12884, '\p{Nv=2.400000000000000e+01}', "");
    Expect(0, 12884, '\p{^Nv=2.400000000000000e+01}', "");
    Expect(0, 12884, '\P{Nv=2.400000000000000e+01}', "");
    Expect(1, 12884, '\P{^Nv=2.400000000000000e+01}', "");
    Expect(0, 12885, '\p{Nv=2.400000000000000e+01}', "");
    Expect(1, 12885, '\p{^Nv=2.400000000000000e+01}', "");
    Expect(1, 12885, '\P{Nv=2.400000000000000e+01}', "");
    Expect(0, 12885, '\P{^Nv=2.400000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=_/a/+0_0_0_0_24}');
    Error('\P{Is_Numeric_Value=_/a/+0_0_0_0_24}');
    Expect(1, 12884, '\p{Is_Numeric_Value=000024}', "");
    Expect(0, 12884, '\p{^Is_Numeric_Value=000024}', "");
    Expect(0, 12884, '\P{Is_Numeric_Value=000024}', "");
    Expect(1, 12884, '\P{^Is_Numeric_Value=000024}', "");
    Expect(0, 12885, '\p{Is_Numeric_Value=000024}', "");
    Expect(1, 12885, '\p{^Is_Numeric_Value=000024}', "");
    Expect(1, 12885, '\P{Is_Numeric_Value=000024}', "");
    Expect(0, 12885, '\P{^Is_Numeric_Value=000024}', "");
    Expect(1, 12884, '\p{Is_Numeric_Value=2.400000000000000e+01}', "");
    Expect(0, 12884, '\p{^Is_Numeric_Value=2.400000000000000e+01}', "");
    Expect(0, 12884, '\P{Is_Numeric_Value=2.400000000000000e+01}', "");
    Expect(1, 12884, '\P{^Is_Numeric_Value=2.400000000000000e+01}', "");
    Expect(0, 12885, '\p{Is_Numeric_Value=2.400000000000000e+01}', "");
    Expect(1, 12885, '\p{^Is_Numeric_Value=2.400000000000000e+01}', "");
    Expect(1, 12885, '\P{Is_Numeric_Value=2.400000000000000e+01}', "");
    Expect(0, 12885, '\P{^Is_Numeric_Value=2.400000000000000e+01}', "");
    Error('\p{Is_Nv=:=_	+00000024}');
    Error('\P{Is_Nv=:=_	+00000024}');
    Expect(1, 12884, '\p{Is_Nv=+0024}', "");
    Expect(0, 12884, '\p{^Is_Nv=+0024}', "");
    Expect(0, 12884, '\P{Is_Nv=+0024}', "");
    Expect(1, 12884, '\P{^Is_Nv=+0024}', "");
    Expect(0, 12885, '\p{Is_Nv=+0024}', "");
    Expect(1, 12885, '\p{^Is_Nv=+0024}', "");
    Expect(1, 12885, '\P{Is_Nv=+0024}', "");
    Expect(0, 12885, '\P{^Is_Nv=+0024}', "");
    Expect(1, 12884, '\p{Is_Nv=2.400000000000000e+01}', "");
    Expect(0, 12884, '\p{^Is_Nv=2.400000000000000e+01}', "");
    Expect(0, 12884, '\P{Is_Nv=2.400000000000000e+01}', "");
    Expect(1, 12884, '\P{^Is_Nv=2.400000000000000e+01}', "");
    Expect(0, 12885, '\p{Is_Nv=2.400000000000000e+01}', "");
    Expect(1, 12885, '\p{^Is_Nv=2.400000000000000e+01}', "");
    Expect(1, 12885, '\P{Is_Nv=2.400000000000000e+01}', "");
    Expect(0, 12885, '\P{^Is_Nv=2.400000000000000e+01}', "");
    Error('\p{Numeric_Value=_/a/0_0_0_0_0_025}');
    Error('\P{Numeric_Value=_/a/0_0_0_0_0_025}');
    Expect(1, 12885, '\p{Numeric_Value=:\A25\z:}', "");;
    Expect(0, 12886, '\p{Numeric_Value=:\A25\z:}', "");;
    Expect(1, 12885, '\p{Numeric_Value=00000000025}', "");
    Expect(0, 12885, '\p{^Numeric_Value=00000000025}', "");
    Expect(0, 12885, '\P{Numeric_Value=00000000025}', "");
    Expect(1, 12885, '\P{^Numeric_Value=00000000025}', "");
    Expect(0, 12886, '\p{Numeric_Value=00000000025}', "");
    Expect(1, 12886, '\p{^Numeric_Value=00000000025}', "");
    Expect(1, 12886, '\P{Numeric_Value=00000000025}', "");
    Expect(0, 12886, '\P{^Numeric_Value=00000000025}', "");
    Expect(1, 12885, '\p{Numeric_Value=2.500000000000000e+01}', "");
    Expect(0, 12885, '\p{^Numeric_Value=2.500000000000000e+01}', "");
    Expect(0, 12885, '\P{Numeric_Value=2.500000000000000e+01}', "");
    Expect(1, 12885, '\P{^Numeric_Value=2.500000000000000e+01}', "");
    Expect(0, 12886, '\p{Numeric_Value=2.500000000000000e+01}', "");
    Expect(1, 12886, '\p{^Numeric_Value=2.500000000000000e+01}', "");
    Expect(1, 12886, '\P{Numeric_Value=2.500000000000000e+01}', "");
    Expect(0, 12886, '\P{^Numeric_Value=2.500000000000000e+01}', "");
    Error('\p{Nv=	-00000000025/a/}');
    Error('\P{Nv=	-00000000025/a/}');
    Expect(1, 12885, '\p{Nv=:\A25\z:}', "");;
    Expect(0, 12886, '\p{Nv=:\A25\z:}', "");;
    Expect(1, 12885, '\p{Nv=00_00_00_00_02_5}', "");
    Expect(0, 12885, '\p{^Nv=00_00_00_00_02_5}', "");
    Expect(0, 12885, '\P{Nv=00_00_00_00_02_5}', "");
    Expect(1, 12885, '\P{^Nv=00_00_00_00_02_5}', "");
    Expect(0, 12886, '\p{Nv=00_00_00_00_02_5}', "");
    Expect(1, 12886, '\p{^Nv=00_00_00_00_02_5}', "");
    Expect(1, 12886, '\P{Nv=00_00_00_00_02_5}', "");
    Expect(0, 12886, '\P{^Nv=00_00_00_00_02_5}', "");
    Expect(1, 12885, '\p{Nv=2.500000000000000e+01}', "");
    Expect(0, 12885, '\p{^Nv=2.500000000000000e+01}', "");
    Expect(0, 12885, '\P{Nv=2.500000000000000e+01}', "");
    Expect(1, 12885, '\P{^Nv=2.500000000000000e+01}', "");
    Expect(0, 12886, '\p{Nv=2.500000000000000e+01}', "");
    Expect(1, 12886, '\p{^Nv=2.500000000000000e+01}', "");
    Expect(1, 12886, '\P{Nv=2.500000000000000e+01}', "");
    Expect(0, 12886, '\P{^Nv=2.500000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=000000025:=}');
    Error('\P{Is_Numeric_Value=000000025:=}');
    Expect(1, 12885, '\p{Is_Numeric_Value=+002_5}', "");
    Expect(0, 12885, '\p{^Is_Numeric_Value=+002_5}', "");
    Expect(0, 12885, '\P{Is_Numeric_Value=+002_5}', "");
    Expect(1, 12885, '\P{^Is_Numeric_Value=+002_5}', "");
    Expect(0, 12886, '\p{Is_Numeric_Value=+002_5}', "");
    Expect(1, 12886, '\p{^Is_Numeric_Value=+002_5}', "");
    Expect(1, 12886, '\P{Is_Numeric_Value=+002_5}', "");
    Expect(0, 12886, '\P{^Is_Numeric_Value=+002_5}', "");
    Expect(1, 12885, '\p{Is_Numeric_Value=2.500000000000000e+01}', "");
    Expect(0, 12885, '\p{^Is_Numeric_Value=2.500000000000000e+01}', "");
    Expect(0, 12885, '\P{Is_Numeric_Value=2.500000000000000e+01}', "");
    Expect(1, 12885, '\P{^Is_Numeric_Value=2.500000000000000e+01}', "");
    Expect(0, 12886, '\p{Is_Numeric_Value=2.500000000000000e+01}', "");
    Expect(1, 12886, '\p{^Is_Numeric_Value=2.500000000000000e+01}', "");
    Expect(1, 12886, '\P{Is_Numeric_Value=2.500000000000000e+01}', "");
    Expect(0, 12886, '\P{^Is_Numeric_Value=2.500000000000000e+01}', "");
    Error('\p{Is_Nv=- 000_000_000_25/a/}');
    Error('\P{Is_Nv=- 000_000_000_25/a/}');
    Expect(1, 12885, '\p{Is_Nv=00_00_25}', "");
    Expect(0, 12885, '\p{^Is_Nv=00_00_25}', "");
    Expect(0, 12885, '\P{Is_Nv=00_00_25}', "");
    Expect(1, 12885, '\P{^Is_Nv=00_00_25}', "");
    Expect(0, 12886, '\p{Is_Nv=00_00_25}', "");
    Expect(1, 12886, '\p{^Is_Nv=00_00_25}', "");
    Expect(1, 12886, '\P{Is_Nv=00_00_25}', "");
    Expect(0, 12886, '\P{^Is_Nv=00_00_25}', "");
    Expect(1, 12885, '\p{Is_Nv:   2.500000000000000e+01}', "");
    Expect(0, 12885, '\p{^Is_Nv:   2.500000000000000e+01}', "");
    Expect(0, 12885, '\P{Is_Nv:   2.500000000000000e+01}', "");
    Expect(1, 12885, '\P{^Is_Nv:   2.500000000000000e+01}', "");
    Expect(0, 12886, '\p{Is_Nv:   2.500000000000000e+01}', "");
    Expect(1, 12886, '\p{^Is_Nv:   2.500000000000000e+01}', "");
    Expect(1, 12886, '\P{Is_Nv:   2.500000000000000e+01}', "");
    Expect(0, 12886, '\P{^Is_Nv:   2.500000000000000e+01}', "");
    Error('\p{Numeric_Value=:=_-+0002_6}');
    Error('\P{Numeric_Value=:=_-+0002_6}');
    Expect(1, 12886, '\p{Numeric_Value=:\A26\z:}', "");;
    Expect(0, 12887, '\p{Numeric_Value=:\A26\z:}', "");;
    Expect(1, 12886, '\p{Numeric_Value=+000000026}', "");
    Expect(0, 12886, '\p{^Numeric_Value=+000000026}', "");
    Expect(0, 12886, '\P{Numeric_Value=+000000026}', "");
    Expect(1, 12886, '\P{^Numeric_Value=+000000026}', "");
    Expect(0, 12887, '\p{Numeric_Value=+000000026}', "");
    Expect(1, 12887, '\p{^Numeric_Value=+000000026}', "");
    Expect(1, 12887, '\P{Numeric_Value=+000000026}', "");
    Expect(0, 12887, '\P{^Numeric_Value=+000000026}', "");
    Expect(1, 12886, '\p{Numeric_Value=2.600000000000000e+01}', "");
    Expect(0, 12886, '\p{^Numeric_Value=2.600000000000000e+01}', "");
    Expect(0, 12886, '\P{Numeric_Value=2.600000000000000e+01}', "");
    Expect(1, 12886, '\P{^Numeric_Value=2.600000000000000e+01}', "");
    Expect(0, 12887, '\p{Numeric_Value=2.600000000000000e+01}', "");
    Expect(1, 12887, '\p{^Numeric_Value=2.600000000000000e+01}', "");
    Expect(1, 12887, '\P{Numeric_Value=2.600000000000000e+01}', "");
    Expect(0, 12887, '\P{^Numeric_Value=2.600000000000000e+01}', "");
    Error('\p{Nv=-0000026:=}');
    Error('\P{Nv=-0000026:=}');
    Expect(1, 12886, '\p{Nv=:\A26\z:}', "");;
    Expect(0, 12887, '\p{Nv=:\A26\z:}', "");;
    Expect(1, 12886, '\p{Nv:	00000000026}', "");
    Expect(0, 12886, '\p{^Nv:	00000000026}', "");
    Expect(0, 12886, '\P{Nv:	00000000026}', "");
    Expect(1, 12886, '\P{^Nv:	00000000026}', "");
    Expect(0, 12887, '\p{Nv:	00000000026}', "");
    Expect(1, 12887, '\p{^Nv:	00000000026}', "");
    Expect(1, 12887, '\P{Nv:	00000000026}', "");
    Expect(0, 12887, '\P{^Nv:	00000000026}', "");
    Expect(1, 12886, '\p{Nv=2.600000000000000e+01}', "");
    Expect(0, 12886, '\p{^Nv=2.600000000000000e+01}', "");
    Expect(0, 12886, '\P{Nv=2.600000000000000e+01}', "");
    Expect(1, 12886, '\P{^Nv=2.600000000000000e+01}', "");
    Expect(0, 12887, '\p{Nv=2.600000000000000e+01}', "");
    Expect(1, 12887, '\p{^Nv=2.600000000000000e+01}', "");
    Expect(1, 12887, '\P{Nv=2.600000000000000e+01}', "");
    Expect(0, 12887, '\P{^Nv=2.600000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=_-00026/a/}');
    Error('\P{Is_Numeric_Value=_-00026/a/}');
    Expect(1, 12886, '\p{Is_Numeric_Value=0000000026}', "");
    Expect(0, 12886, '\p{^Is_Numeric_Value=0000000026}', "");
    Expect(0, 12886, '\P{Is_Numeric_Value=0000000026}', "");
    Expect(1, 12886, '\P{^Is_Numeric_Value=0000000026}', "");
    Expect(0, 12887, '\p{Is_Numeric_Value=0000000026}', "");
    Expect(1, 12887, '\p{^Is_Numeric_Value=0000000026}', "");
    Expect(1, 12887, '\P{Is_Numeric_Value=0000000026}', "");
    Expect(0, 12887, '\P{^Is_Numeric_Value=0000000026}', "");
    Expect(1, 12886, '\p{Is_Numeric_Value=2.600000000000000e+01}', "");
    Expect(0, 12886, '\p{^Is_Numeric_Value=2.600000000000000e+01}', "");
    Expect(0, 12886, '\P{Is_Numeric_Value=2.600000000000000e+01}', "");
    Expect(1, 12886, '\P{^Is_Numeric_Value=2.600000000000000e+01}', "");
    Expect(0, 12887, '\p{Is_Numeric_Value=2.600000000000000e+01}', "");
    Expect(1, 12887, '\p{^Is_Numeric_Value=2.600000000000000e+01}', "");
    Expect(1, 12887, '\P{Is_Numeric_Value=2.600000000000000e+01}', "");
    Expect(0, 12887, '\P{^Is_Numeric_Value=2.600000000000000e+01}', "");
    Error('\p{Is_Nv=	:=+0_0_0_26}');
    Error('\P{Is_Nv=	:=+0_0_0_26}');
    Expect(1, 12886, '\p{Is_Nv: 0_0_0_0_0_0_26}', "");
    Expect(0, 12886, '\p{^Is_Nv: 0_0_0_0_0_0_26}', "");
    Expect(0, 12886, '\P{Is_Nv: 0_0_0_0_0_0_26}', "");
    Expect(1, 12886, '\P{^Is_Nv: 0_0_0_0_0_0_26}', "");
    Expect(0, 12887, '\p{Is_Nv: 0_0_0_0_0_0_26}', "");
    Expect(1, 12887, '\p{^Is_Nv: 0_0_0_0_0_0_26}', "");
    Expect(1, 12887, '\P{Is_Nv: 0_0_0_0_0_0_26}', "");
    Expect(0, 12887, '\P{^Is_Nv: 0_0_0_0_0_0_26}', "");
    Expect(1, 12886, '\p{Is_Nv=2.600000000000000e+01}', "");
    Expect(0, 12886, '\p{^Is_Nv=2.600000000000000e+01}', "");
    Expect(0, 12886, '\P{Is_Nv=2.600000000000000e+01}', "");
    Expect(1, 12886, '\P{^Is_Nv=2.600000000000000e+01}', "");
    Expect(0, 12887, '\p{Is_Nv=2.600000000000000e+01}', "");
    Expect(1, 12887, '\p{^Is_Nv=2.600000000000000e+01}', "");
    Expect(1, 12887, '\P{Is_Nv=2.600000000000000e+01}', "");
    Expect(0, 12887, '\P{^Is_Nv=2.600000000000000e+01}', "");
    Error('\p{Numeric_Value=/a/-0_0_0_0_0_0_0_0_027}');
    Error('\P{Numeric_Value=/a/-0_0_0_0_0_0_0_0_027}');
    Expect(1, 12887, '\p{Numeric_Value=:\A27\z:}', "");;
    Expect(0, 12888, '\p{Numeric_Value=:\A27\z:}', "");;
    Expect(1, 12887, '\p{Numeric_Value=+00000000027}', "");
    Expect(0, 12887, '\p{^Numeric_Value=+00000000027}', "");
    Expect(0, 12887, '\P{Numeric_Value=+00000000027}', "");
    Expect(1, 12887, '\P{^Numeric_Value=+00000000027}', "");
    Expect(0, 12888, '\p{Numeric_Value=+00000000027}', "");
    Expect(1, 12888, '\p{^Numeric_Value=+00000000027}', "");
    Expect(1, 12888, '\P{Numeric_Value=+00000000027}', "");
    Expect(0, 12888, '\P{^Numeric_Value=+00000000027}', "");
    Expect(1, 12887, '\p{Numeric_Value=2.700000000000000e+01}', "");
    Expect(0, 12887, '\p{^Numeric_Value=2.700000000000000e+01}', "");
    Expect(0, 12887, '\P{Numeric_Value=2.700000000000000e+01}', "");
    Expect(1, 12887, '\P{^Numeric_Value=2.700000000000000e+01}', "");
    Expect(0, 12888, '\p{Numeric_Value=2.700000000000000e+01}', "");
    Expect(1, 12888, '\p{^Numeric_Value=2.700000000000000e+01}', "");
    Expect(1, 12888, '\P{Numeric_Value=2.700000000000000e+01}', "");
    Expect(0, 12888, '\P{^Numeric_Value=2.700000000000000e+01}', "");
    Error('\p{Nv=-/a/00027}');
    Error('\P{Nv=-/a/00027}');
    Expect(1, 12887, '\p{Nv=:\A27\z:}', "");;
    Expect(0, 12888, '\p{Nv=:\A27\z:}', "");;
    Expect(1, 12887, '\p{Nv=2_7}', "");
    Expect(0, 12887, '\p{^Nv=2_7}', "");
    Expect(0, 12887, '\P{Nv=2_7}', "");
    Expect(1, 12887, '\P{^Nv=2_7}', "");
    Expect(0, 12888, '\p{Nv=2_7}', "");
    Expect(1, 12888, '\p{^Nv=2_7}', "");
    Expect(1, 12888, '\P{Nv=2_7}', "");
    Expect(0, 12888, '\P{^Nv=2_7}', "");
    Expect(1, 12887, '\p{Nv=2.700000000000000e+01}', "");
    Expect(0, 12887, '\p{^Nv=2.700000000000000e+01}', "");
    Expect(0, 12887, '\P{Nv=2.700000000000000e+01}', "");
    Expect(1, 12887, '\P{^Nv=2.700000000000000e+01}', "");
    Expect(0, 12888, '\p{Nv=2.700000000000000e+01}', "");
    Expect(1, 12888, '\p{^Nv=2.700000000000000e+01}', "");
    Expect(1, 12888, '\P{Nv=2.700000000000000e+01}', "");
    Expect(0, 12888, '\P{^Nv=2.700000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=-000000027/a/}');
    Error('\P{Is_Numeric_Value=-000000027/a/}');
    Expect(1, 12887, '\p{Is_Numeric_Value=02_7}', "");
    Expect(0, 12887, '\p{^Is_Numeric_Value=02_7}', "");
    Expect(0, 12887, '\P{Is_Numeric_Value=02_7}', "");
    Expect(1, 12887, '\P{^Is_Numeric_Value=02_7}', "");
    Expect(0, 12888, '\p{Is_Numeric_Value=02_7}', "");
    Expect(1, 12888, '\p{^Is_Numeric_Value=02_7}', "");
    Expect(1, 12888, '\P{Is_Numeric_Value=02_7}', "");
    Expect(0, 12888, '\P{^Is_Numeric_Value=02_7}', "");
    Expect(1, 12887, '\p{Is_Numeric_Value=2.700000000000000e+01}', "");
    Expect(0, 12887, '\p{^Is_Numeric_Value=2.700000000000000e+01}', "");
    Expect(0, 12887, '\P{Is_Numeric_Value=2.700000000000000e+01}', "");
    Expect(1, 12887, '\P{^Is_Numeric_Value=2.700000000000000e+01}', "");
    Expect(0, 12888, '\p{Is_Numeric_Value=2.700000000000000e+01}', "");
    Expect(1, 12888, '\p{^Is_Numeric_Value=2.700000000000000e+01}', "");
    Expect(1, 12888, '\P{Is_Numeric_Value=2.700000000000000e+01}', "");
    Expect(0, 12888, '\P{^Is_Numeric_Value=2.700000000000000e+01}', "");
    Error('\p{Is_Nv= 027:=}');
    Error('\P{Is_Nv= 027:=}');
    Expect(1, 12887, '\p{Is_Nv=0_0_0_27}', "");
    Expect(0, 12887, '\p{^Is_Nv=0_0_0_27}', "");
    Expect(0, 12887, '\P{Is_Nv=0_0_0_27}', "");
    Expect(1, 12887, '\P{^Is_Nv=0_0_0_27}', "");
    Expect(0, 12888, '\p{Is_Nv=0_0_0_27}', "");
    Expect(1, 12888, '\p{^Is_Nv=0_0_0_27}', "");
    Expect(1, 12888, '\P{Is_Nv=0_0_0_27}', "");
    Expect(0, 12888, '\P{^Is_Nv=0_0_0_27}', "");
    Expect(1, 12887, '\p{Is_Nv=2.700000000000000e+01}', "");
    Expect(0, 12887, '\p{^Is_Nv=2.700000000000000e+01}', "");
    Expect(0, 12887, '\P{Is_Nv=2.700000000000000e+01}', "");
    Expect(1, 12887, '\P{^Is_Nv=2.700000000000000e+01}', "");
    Expect(0, 12888, '\p{Is_Nv=2.700000000000000e+01}', "");
    Expect(1, 12888, '\p{^Is_Nv=2.700000000000000e+01}', "");
    Expect(1, 12888, '\P{Is_Nv=2.700000000000000e+01}', "");
    Expect(0, 12888, '\P{^Is_Nv=2.700000000000000e+01}', "");
    Error('\p{Numeric_Value=/a/ 	0_0_0_0_0_028}');
    Error('\P{Numeric_Value=/a/ 	0_0_0_0_0_028}');
    Expect(1, 12888, '\p{Numeric_Value=:\A28\z:}', "");;
    Expect(0, 12889, '\p{Numeric_Value=:\A28\z:}', "");;
    Expect(1, 12888, '\p{Numeric_Value=+00002_8}', "");
    Expect(0, 12888, '\p{^Numeric_Value=+00002_8}', "");
    Expect(0, 12888, '\P{Numeric_Value=+00002_8}', "");
    Expect(1, 12888, '\P{^Numeric_Value=+00002_8}', "");
    Expect(0, 12889, '\p{Numeric_Value=+00002_8}', "");
    Expect(1, 12889, '\p{^Numeric_Value=+00002_8}', "");
    Expect(1, 12889, '\P{Numeric_Value=+00002_8}', "");
    Expect(0, 12889, '\P{^Numeric_Value=+00002_8}', "");
    Expect(1, 12888, '\p{Numeric_Value:	2.800000000000000e+01}', "");
    Expect(0, 12888, '\p{^Numeric_Value:	2.800000000000000e+01}', "");
    Expect(0, 12888, '\P{Numeric_Value:	2.800000000000000e+01}', "");
    Expect(1, 12888, '\P{^Numeric_Value:	2.800000000000000e+01}', "");
    Expect(0, 12889, '\p{Numeric_Value:	2.800000000000000e+01}', "");
    Expect(1, 12889, '\p{^Numeric_Value:	2.800000000000000e+01}', "");
    Expect(1, 12889, '\P{Numeric_Value:	2.800000000000000e+01}', "");
    Expect(0, 12889, '\P{^Numeric_Value:	2.800000000000000e+01}', "");
    Error('\p{Nv=:= 000028}');
    Error('\P{Nv=:= 000028}');
    Expect(1, 12888, '\p{Nv=:\A28\z:}', "");;
    Expect(0, 12889, '\p{Nv=:\A28\z:}', "");;
    Expect(1, 12888, '\p{Nv=0028}', "");
    Expect(0, 12888, '\p{^Nv=0028}', "");
    Expect(0, 12888, '\P{Nv=0028}', "");
    Expect(1, 12888, '\P{^Nv=0028}', "");
    Expect(0, 12889, '\p{Nv=0028}', "");
    Expect(1, 12889, '\p{^Nv=0028}', "");
    Expect(1, 12889, '\P{Nv=0028}', "");
    Expect(0, 12889, '\P{^Nv=0028}', "");
    Expect(1, 12888, '\p{Nv=2.800000000000000e+01}', "");
    Expect(0, 12888, '\p{^Nv=2.800000000000000e+01}', "");
    Expect(0, 12888, '\P{Nv=2.800000000000000e+01}', "");
    Expect(1, 12888, '\P{^Nv=2.800000000000000e+01}', "");
    Expect(0, 12889, '\p{Nv=2.800000000000000e+01}', "");
    Expect(1, 12889, '\p{^Nv=2.800000000000000e+01}', "");
    Expect(1, 12889, '\P{Nv=2.800000000000000e+01}', "");
    Expect(0, 12889, '\P{^Nv=2.800000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=-_028/a/}');
    Error('\P{Is_Numeric_Value=-_028/a/}');
    Expect(1, 12888, '\p{Is_Numeric_Value=+02_8}', "");
    Expect(0, 12888, '\p{^Is_Numeric_Value=+02_8}', "");
    Expect(0, 12888, '\P{Is_Numeric_Value=+02_8}', "");
    Expect(1, 12888, '\P{^Is_Numeric_Value=+02_8}', "");
    Expect(0, 12889, '\p{Is_Numeric_Value=+02_8}', "");
    Expect(1, 12889, '\p{^Is_Numeric_Value=+02_8}', "");
    Expect(1, 12889, '\P{Is_Numeric_Value=+02_8}', "");
    Expect(0, 12889, '\P{^Is_Numeric_Value=+02_8}', "");
    Expect(1, 12888, '\p{Is_Numeric_Value=2.800000000000000e+01}', "");
    Expect(0, 12888, '\p{^Is_Numeric_Value=2.800000000000000e+01}', "");
    Expect(0, 12888, '\P{Is_Numeric_Value=2.800000000000000e+01}', "");
    Expect(1, 12888, '\P{^Is_Numeric_Value=2.800000000000000e+01}', "");
    Expect(0, 12889, '\p{Is_Numeric_Value=2.800000000000000e+01}', "");
    Expect(1, 12889, '\p{^Is_Numeric_Value=2.800000000000000e+01}', "");
    Expect(1, 12889, '\P{Is_Numeric_Value=2.800000000000000e+01}', "");
    Expect(0, 12889, '\P{^Is_Numeric_Value=2.800000000000000e+01}', "");
    Error('\p{Is_Nv=_ 28/a/}');
    Error('\P{Is_Nv=_ 28/a/}');
    Expect(1, 12888, '\p{Is_Nv=+00000000028}', "");
    Expect(0, 12888, '\p{^Is_Nv=+00000000028}', "");
    Expect(0, 12888, '\P{Is_Nv=+00000000028}', "");
    Expect(1, 12888, '\P{^Is_Nv=+00000000028}', "");
    Expect(0, 12889, '\p{Is_Nv=+00000000028}', "");
    Expect(1, 12889, '\p{^Is_Nv=+00000000028}', "");
    Expect(1, 12889, '\P{Is_Nv=+00000000028}', "");
    Expect(0, 12889, '\P{^Is_Nv=+00000000028}', "");
    Expect(1, 12888, '\p{Is_Nv=2.800000000000000e+01}', "");
    Expect(0, 12888, '\p{^Is_Nv=2.800000000000000e+01}', "");
    Expect(0, 12888, '\P{Is_Nv=2.800000000000000e+01}', "");
    Expect(1, 12888, '\P{^Is_Nv=2.800000000000000e+01}', "");
    Expect(0, 12889, '\p{Is_Nv=2.800000000000000e+01}', "");
    Expect(1, 12889, '\p{^Is_Nv=2.800000000000000e+01}', "");
    Expect(1, 12889, '\P{Is_Nv=2.800000000000000e+01}', "");
    Expect(0, 12889, '\P{^Is_Nv=2.800000000000000e+01}', "");
    Error('\p{Numeric_Value=:=	_000029}');
    Error('\P{Numeric_Value=:=	_000029}');
    Expect(1, 12889, '\p{Numeric_Value=:\A29\z:}', "");;
    Expect(0, 12890, '\p{Numeric_Value=:\A29\z:}', "");;
    Expect(1, 12889, '\p{Numeric_Value=+00029}', "");
    Expect(0, 12889, '\p{^Numeric_Value=+00029}', "");
    Expect(0, 12889, '\P{Numeric_Value=+00029}', "");
    Expect(1, 12889, '\P{^Numeric_Value=+00029}', "");
    Expect(0, 12890, '\p{Numeric_Value=+00029}', "");
    Expect(1, 12890, '\p{^Numeric_Value=+00029}', "");
    Expect(1, 12890, '\P{Numeric_Value=+00029}', "");
    Expect(0, 12890, '\P{^Numeric_Value=+00029}', "");
    Expect(1, 12889, '\p{Numeric_Value=2.900000000000000e+01}', "");
    Expect(0, 12889, '\p{^Numeric_Value=2.900000000000000e+01}', "");
    Expect(0, 12889, '\P{Numeric_Value=2.900000000000000e+01}', "");
    Expect(1, 12889, '\P{^Numeric_Value=2.900000000000000e+01}', "");
    Expect(0, 12890, '\p{Numeric_Value=2.900000000000000e+01}', "");
    Expect(1, 12890, '\p{^Numeric_Value=2.900000000000000e+01}', "");
    Expect(1, 12890, '\P{Numeric_Value=2.900000000000000e+01}', "");
    Expect(0, 12890, '\P{^Numeric_Value=2.900000000000000e+01}', "");
    Error('\p{Nv=	-0_0_0_0_29:=}');
    Error('\P{Nv=	-0_0_0_0_29:=}');
    Expect(1, 12889, '\p{Nv=:\A29\z:}', "");;
    Expect(0, 12890, '\p{Nv=:\A29\z:}', "");;
    Expect(1, 12889, '\p{Nv=0000002_9}', "");
    Expect(0, 12889, '\p{^Nv=0000002_9}', "");
    Expect(0, 12889, '\P{Nv=0000002_9}', "");
    Expect(1, 12889, '\P{^Nv=0000002_9}', "");
    Expect(0, 12890, '\p{Nv=0000002_9}', "");
    Expect(1, 12890, '\p{^Nv=0000002_9}', "");
    Expect(1, 12890, '\P{Nv=0000002_9}', "");
    Expect(0, 12890, '\P{^Nv=0000002_9}', "");
    Expect(1, 12889, '\p{Nv=2.900000000000000e+01}', "");
    Expect(0, 12889, '\p{^Nv=2.900000000000000e+01}', "");
    Expect(0, 12889, '\P{Nv=2.900000000000000e+01}', "");
    Expect(1, 12889, '\P{^Nv=2.900000000000000e+01}', "");
    Expect(0, 12890, '\p{Nv=2.900000000000000e+01}', "");
    Expect(1, 12890, '\p{^Nv=2.900000000000000e+01}', "");
    Expect(1, 12890, '\P{Nv=2.900000000000000e+01}', "");
    Expect(0, 12890, '\P{^Nv=2.900000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=/a/ _0000_0000_29}');
    Error('\P{Is_Numeric_Value=/a/ _0000_0000_29}');
    Expect(1, 12889, '\p{Is_Numeric_Value: +29}', "");
    Expect(0, 12889, '\p{^Is_Numeric_Value: +29}', "");
    Expect(0, 12889, '\P{Is_Numeric_Value: +29}', "");
    Expect(1, 12889, '\P{^Is_Numeric_Value: +29}', "");
    Expect(0, 12890, '\p{Is_Numeric_Value: +29}', "");
    Expect(1, 12890, '\p{^Is_Numeric_Value: +29}', "");
    Expect(1, 12890, '\P{Is_Numeric_Value: +29}', "");
    Expect(0, 12890, '\P{^Is_Numeric_Value: +29}', "");
    Expect(1, 12889, '\p{Is_Numeric_Value=2.900000000000000e+01}', "");
    Expect(0, 12889, '\p{^Is_Numeric_Value=2.900000000000000e+01}', "");
    Expect(0, 12889, '\P{Is_Numeric_Value=2.900000000000000e+01}', "");
    Expect(1, 12889, '\P{^Is_Numeric_Value=2.900000000000000e+01}', "");
    Expect(0, 12890, '\p{Is_Numeric_Value=2.900000000000000e+01}', "");
    Expect(1, 12890, '\p{^Is_Numeric_Value=2.900000000000000e+01}', "");
    Expect(1, 12890, '\P{Is_Numeric_Value=2.900000000000000e+01}', "");
    Expect(0, 12890, '\P{^Is_Numeric_Value=2.900000000000000e+01}', "");
    Error('\p{Is_Nv= +0_0_0_0_0_029/a/}');
    Error('\P{Is_Nv= +0_0_0_0_0_029/a/}');
    Expect(1, 12889, '\p{Is_Nv=0029}', "");
    Expect(0, 12889, '\p{^Is_Nv=0029}', "");
    Expect(0, 12889, '\P{Is_Nv=0029}', "");
    Expect(1, 12889, '\P{^Is_Nv=0029}', "");
    Expect(0, 12890, '\p{Is_Nv=0029}', "");
    Expect(1, 12890, '\p{^Is_Nv=0029}', "");
    Expect(1, 12890, '\P{Is_Nv=0029}', "");
    Expect(0, 12890, '\P{^Is_Nv=0029}', "");
    Expect(1, 12889, '\p{Is_Nv=2.900000000000000e+01}', "");
    Expect(0, 12889, '\p{^Is_Nv=2.900000000000000e+01}', "");
    Expect(0, 12889, '\P{Is_Nv=2.900000000000000e+01}', "");
    Expect(1, 12889, '\P{^Is_Nv=2.900000000000000e+01}', "");
    Expect(0, 12890, '\p{Is_Nv=2.900000000000000e+01}', "");
    Expect(1, 12890, '\p{^Is_Nv=2.900000000000000e+01}', "");
    Expect(1, 12890, '\P{Is_Nv=2.900000000000000e+01}', "");
    Expect(0, 12890, '\P{^Is_Nv=2.900000000000000e+01}', "");
    Error('\p{Numeric_Value= :=00_3}');
    Error('\P{Numeric_Value= :=00_3}');
    Expect(1, 146203, '\p{Numeric_Value=:\A3\z:}', "");;
    Expect(0, 146204, '\p{Numeric_Value=:\A3\z:}', "");;
    Expect(1, 146203, '\p{Numeric_Value=000_000_3}', "");
    Expect(0, 146203, '\p{^Numeric_Value=000_000_3}', "");
    Expect(0, 146203, '\P{Numeric_Value=000_000_3}', "");
    Expect(1, 146203, '\P{^Numeric_Value=000_000_3}', "");
    Expect(0, 146204, '\p{Numeric_Value=000_000_3}', "");
    Expect(1, 146204, '\p{^Numeric_Value=000_000_3}', "");
    Expect(1, 146204, '\P{Numeric_Value=000_000_3}', "");
    Expect(0, 146204, '\P{^Numeric_Value=000_000_3}', "");
    Expect(1, 146203, '\p{Numeric_Value=3.000000000000000e+00}', "");
    Expect(0, 146203, '\p{^Numeric_Value=3.000000000000000e+00}', "");
    Expect(0, 146203, '\P{Numeric_Value=3.000000000000000e+00}', "");
    Expect(1, 146203, '\P{^Numeric_Value=3.000000000000000e+00}', "");
    Expect(0, 146204, '\p{Numeric_Value=3.000000000000000e+00}', "");
    Expect(1, 146204, '\p{^Numeric_Value=3.000000000000000e+00}', "");
    Expect(1, 146204, '\P{Numeric_Value=3.000000000000000e+00}', "");
    Expect(0, 146204, '\P{^Numeric_Value=3.000000000000000e+00}', "");
    Error('\p{Nv=/a/ _0000000003}');
    Error('\P{Nv=/a/ _0000000003}');
    Expect(1, 146203, '\p{Nv=:\A3\z:}', "");;
    Expect(0, 146204, '\p{Nv=:\A3\z:}', "");;
    Expect(1, 146203, '\p{Nv=0_3}', "");
    Expect(0, 146203, '\p{^Nv=0_3}', "");
    Expect(0, 146203, '\P{Nv=0_3}', "");
    Expect(1, 146203, '\P{^Nv=0_3}', "");
    Expect(0, 146204, '\p{Nv=0_3}', "");
    Expect(1, 146204, '\p{^Nv=0_3}', "");
    Expect(1, 146204, '\P{Nv=0_3}', "");
    Expect(0, 146204, '\P{^Nv=0_3}', "");
    Expect(1, 146203, '\p{Nv=3.000000000000000e+00}', "");
    Expect(0, 146203, '\p{^Nv=3.000000000000000e+00}', "");
    Expect(0, 146203, '\P{Nv=3.000000000000000e+00}', "");
    Expect(1, 146203, '\P{^Nv=3.000000000000000e+00}', "");
    Expect(0, 146204, '\p{Nv=3.000000000000000e+00}', "");
    Expect(1, 146204, '\p{^Nv=3.000000000000000e+00}', "");
    Expect(1, 146204, '\P{Nv=3.000000000000000e+00}', "");
    Expect(0, 146204, '\P{^Nv=3.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value= /a/00_3}');
    Error('\P{Is_Numeric_Value= /a/00_3}');
    Expect(1, 146203, '\p{Is_Numeric_Value:   +0_0_0_0_03}', "");
    Expect(0, 146203, '\p{^Is_Numeric_Value:   +0_0_0_0_03}', "");
    Expect(0, 146203, '\P{Is_Numeric_Value:   +0_0_0_0_03}', "");
    Expect(1, 146203, '\P{^Is_Numeric_Value:   +0_0_0_0_03}', "");
    Expect(0, 146204, '\p{Is_Numeric_Value:   +0_0_0_0_03}', "");
    Expect(1, 146204, '\p{^Is_Numeric_Value:   +0_0_0_0_03}', "");
    Expect(1, 146204, '\P{Is_Numeric_Value:   +0_0_0_0_03}', "");
    Expect(0, 146204, '\P{^Is_Numeric_Value:   +0_0_0_0_03}', "");
    Expect(1, 146203, '\p{Is_Numeric_Value:	3.000000000000000e+00}', "");
    Expect(0, 146203, '\p{^Is_Numeric_Value:	3.000000000000000e+00}', "");
    Expect(0, 146203, '\P{Is_Numeric_Value:	3.000000000000000e+00}', "");
    Expect(1, 146203, '\P{^Is_Numeric_Value:	3.000000000000000e+00}', "");
    Expect(0, 146204, '\p{Is_Numeric_Value:	3.000000000000000e+00}', "");
    Expect(1, 146204, '\p{^Is_Numeric_Value:	3.000000000000000e+00}', "");
    Expect(1, 146204, '\P{Is_Numeric_Value:	3.000000000000000e+00}', "");
    Expect(0, 146204, '\P{^Is_Numeric_Value:	3.000000000000000e+00}', "");
    Error('\p{Is_Nv:   :=_0000003}');
    Error('\P{Is_Nv:   :=_0000003}');
    Expect(1, 146203, '\p{Is_Nv=0003}', "");
    Expect(0, 146203, '\p{^Is_Nv=0003}', "");
    Expect(0, 146203, '\P{Is_Nv=0003}', "");
    Expect(1, 146203, '\P{^Is_Nv=0003}', "");
    Expect(0, 146204, '\p{Is_Nv=0003}', "");
    Expect(1, 146204, '\p{^Is_Nv=0003}', "");
    Expect(1, 146204, '\P{Is_Nv=0003}', "");
    Expect(0, 146204, '\P{^Is_Nv=0003}', "");
    Expect(1, 146203, '\p{Is_Nv=3.000000000000000e+00}', "");
    Expect(0, 146203, '\p{^Is_Nv=3.000000000000000e+00}', "");
    Expect(0, 146203, '\P{Is_Nv=3.000000000000000e+00}', "");
    Expect(1, 146203, '\P{^Is_Nv=3.000000000000000e+00}', "");
    Expect(0, 146204, '\p{Is_Nv=3.000000000000000e+00}', "");
    Expect(1, 146204, '\p{^Is_Nv=3.000000000000000e+00}', "");
    Expect(1, 146204, '\P{Is_Nv=3.000000000000000e+00}', "");
    Expect(0, 146204, '\P{^Is_Nv=3.000000000000000e+00}', "");
    Error('\p{Numeric_Value=- 3/0016/a/}');
    Error('\P{Numeric_Value=- 3/0016/a/}');
    Expect(1, 73678, '\p{Numeric_Value=:\A3/16\z:}', "");;
    Expect(0, 73679, '\p{Numeric_Value=:\A3/16\z:}', "");;
    Expect(1, 73678, '\p{Numeric_Value=00003/000000016}', "");
    Expect(0, 73678, '\p{^Numeric_Value=00003/000000016}', "");
    Expect(0, 73678, '\P{Numeric_Value=00003/000000016}', "");
    Expect(1, 73678, '\P{^Numeric_Value=00003/000000016}', "");
    Expect(0, 73679, '\p{Numeric_Value=00003/000000016}', "");
    Expect(1, 73679, '\p{^Numeric_Value=00003/000000016}', "");
    Expect(1, 73679, '\P{Numeric_Value=00003/000000016}', "");
    Expect(0, 73679, '\P{^Numeric_Value=00003/000000016}', "");
    Expect(1, 73678, '\p{Numeric_Value=180/960}', "");
    Expect(0, 73678, '\p{^Numeric_Value=180/960}', "");
    Expect(0, 73678, '\P{Numeric_Value=180/960}', "");
    Expect(1, 73678, '\P{^Numeric_Value=180/960}', "");
    Expect(0, 73679, '\p{Numeric_Value=180/960}', "");
    Expect(1, 73679, '\p{^Numeric_Value=180/960}', "");
    Expect(1, 73679, '\P{Numeric_Value=180/960}', "");
    Expect(0, 73679, '\P{^Numeric_Value=180/960}', "");
    Error('\p{Numeric_Value=1.9e-01}');
    Error('\P{Numeric_Value=1.9e-01}');
    Expect(1, 73678, '\p{Numeric_Value:	1.88e-01}', "");
    Expect(0, 73678, '\p{^Numeric_Value:	1.88e-01}', "");
    Expect(0, 73678, '\P{Numeric_Value:	1.88e-01}', "");
    Expect(1, 73678, '\P{^Numeric_Value:	1.88e-01}', "");
    Expect(0, 73679, '\p{Numeric_Value:	1.88e-01}', "");
    Expect(1, 73679, '\p{^Numeric_Value:	1.88e-01}', "");
    Expect(1, 73679, '\P{Numeric_Value:	1.88e-01}', "");
    Expect(0, 73679, '\P{^Numeric_Value:	1.88e-01}', "");
    Error('\p{Numeric_Value=0.19}');
    Error('\P{Numeric_Value=0.19}');
    Expect(1, 73678, '\p{Numeric_Value:1.875e-01}', "");
    Expect(0, 73678, '\p{^Numeric_Value:1.875e-01}', "");
    Expect(0, 73678, '\P{Numeric_Value:1.875e-01}', "");
    Expect(1, 73678, '\P{^Numeric_Value:1.875e-01}', "");
    Expect(0, 73679, '\p{Numeric_Value:1.875e-01}', "");
    Expect(1, 73679, '\p{^Numeric_Value:1.875e-01}', "");
    Expect(1, 73679, '\P{Numeric_Value:1.875e-01}', "");
    Expect(0, 73679, '\P{^Numeric_Value:1.875e-01}', "");
    Expect(1, 73678, '\p{Numeric_Value=0.188}', "");
    Expect(0, 73678, '\p{^Numeric_Value=0.188}', "");
    Expect(0, 73678, '\P{Numeric_Value=0.188}', "");
    Expect(1, 73678, '\P{^Numeric_Value=0.188}', "");
    Expect(0, 73679, '\p{Numeric_Value=0.188}', "");
    Expect(1, 73679, '\p{^Numeric_Value=0.188}', "");
    Expect(1, 73679, '\P{Numeric_Value=0.188}', "");
    Expect(0, 73679, '\P{^Numeric_Value=0.188}', "");
    Expect(1, 73678, '\p{Numeric_Value=1.8750e-01}', "");
    Expect(0, 73678, '\p{^Numeric_Value=1.8750e-01}', "");
    Expect(0, 73678, '\P{Numeric_Value=1.8750e-01}', "");
    Expect(1, 73678, '\P{^Numeric_Value=1.8750e-01}', "");
    Expect(0, 73679, '\p{Numeric_Value=1.8750e-01}', "");
    Expect(1, 73679, '\p{^Numeric_Value=1.8750e-01}', "");
    Expect(1, 73679, '\P{Numeric_Value=1.8750e-01}', "");
    Expect(0, 73679, '\P{^Numeric_Value=1.8750e-01}', "");
    Expect(1, 73678, '\p{Numeric_Value=0.1875}', "");
    Expect(0, 73678, '\p{^Numeric_Value=0.1875}', "");
    Expect(0, 73678, '\P{Numeric_Value=0.1875}', "");
    Expect(1, 73678, '\P{^Numeric_Value=0.1875}', "");
    Expect(0, 73679, '\p{Numeric_Value=0.1875}', "");
    Expect(1, 73679, '\p{^Numeric_Value=0.1875}', "");
    Expect(1, 73679, '\P{Numeric_Value=0.1875}', "");
    Expect(0, 73679, '\P{^Numeric_Value=0.1875}', "");
    Error('\p{Nv=		+00000003/00000016:=}');
    Error('\P{Nv=		+00000003/00000016:=}');
    Expect(1, 73678, '\p{Nv=:\A3/16\z:}', "");;
    Expect(0, 73679, '\p{Nv=:\A3/16\z:}', "");;
    Expect(1, 73678, '\p{Nv=000003/0000000016}', "");
    Expect(0, 73678, '\p{^Nv=000003/0000000016}', "");
    Expect(0, 73678, '\P{Nv=000003/0000000016}', "");
    Expect(1, 73678, '\P{^Nv=000003/0000000016}', "");
    Expect(0, 73679, '\p{Nv=000003/0000000016}', "");
    Expect(1, 73679, '\p{^Nv=000003/0000000016}', "");
    Expect(1, 73679, '\P{Nv=000003/0000000016}', "");
    Expect(0, 73679, '\P{^Nv=000003/0000000016}', "");
    Expect(1, 73678, '\p{Nv=180/960}', "");
    Expect(0, 73678, '\p{^Nv=180/960}', "");
    Expect(0, 73678, '\P{Nv=180/960}', "");
    Expect(1, 73678, '\P{^Nv=180/960}', "");
    Expect(0, 73679, '\p{Nv=180/960}', "");
    Expect(1, 73679, '\p{^Nv=180/960}', "");
    Expect(1, 73679, '\P{Nv=180/960}', "");
    Expect(0, 73679, '\P{^Nv=180/960}', "");
    Error('\p{Nv=1.9e-01}');
    Error('\P{Nv=1.9e-01}');
    Expect(1, 73678, '\p{Nv:   1.88e-01}', "");
    Expect(0, 73678, '\p{^Nv:   1.88e-01}', "");
    Expect(0, 73678, '\P{Nv:   1.88e-01}', "");
    Expect(1, 73678, '\P{^Nv:   1.88e-01}', "");
    Expect(0, 73679, '\p{Nv:   1.88e-01}', "");
    Expect(1, 73679, '\p{^Nv:   1.88e-01}', "");
    Expect(1, 73679, '\P{Nv:   1.88e-01}', "");
    Expect(0, 73679, '\P{^Nv:   1.88e-01}', "");
    Error('\p{Nv=0.19}');
    Error('\P{Nv=0.19}');
    Expect(1, 73678, '\p{Nv=1.875e-01}', "");
    Expect(0, 73678, '\p{^Nv=1.875e-01}', "");
    Expect(0, 73678, '\P{Nv=1.875e-01}', "");
    Expect(1, 73678, '\P{^Nv=1.875e-01}', "");
    Expect(0, 73679, '\p{Nv=1.875e-01}', "");
    Expect(1, 73679, '\p{^Nv=1.875e-01}', "");
    Expect(1, 73679, '\P{Nv=1.875e-01}', "");
    Expect(0, 73679, '\P{^Nv=1.875e-01}', "");
    Expect(1, 73678, '\p{Nv=0.188}', "");
    Expect(0, 73678, '\p{^Nv=0.188}', "");
    Expect(0, 73678, '\P{Nv=0.188}', "");
    Expect(1, 73678, '\P{^Nv=0.188}', "");
    Expect(0, 73679, '\p{Nv=0.188}', "");
    Expect(1, 73679, '\p{^Nv=0.188}', "");
    Expect(1, 73679, '\P{Nv=0.188}', "");
    Expect(0, 73679, '\P{^Nv=0.188}', "");
    Expect(1, 73678, '\p{Nv=1.8750e-01}', "");
    Expect(0, 73678, '\p{^Nv=1.8750e-01}', "");
    Expect(0, 73678, '\P{Nv=1.8750e-01}', "");
    Expect(1, 73678, '\P{^Nv=1.8750e-01}', "");
    Expect(0, 73679, '\p{Nv=1.8750e-01}', "");
    Expect(1, 73679, '\p{^Nv=1.8750e-01}', "");
    Expect(1, 73679, '\P{Nv=1.8750e-01}', "");
    Expect(0, 73679, '\P{^Nv=1.8750e-01}', "");
    Expect(1, 73678, '\p{Nv=0.1875}', "");
    Expect(0, 73678, '\p{^Nv=0.1875}', "");
    Expect(0, 73678, '\P{Nv=0.1875}', "");
    Expect(1, 73678, '\P{^Nv=0.1875}', "");
    Expect(0, 73679, '\p{Nv=0.1875}', "");
    Expect(1, 73679, '\p{^Nv=0.1875}', "");
    Expect(1, 73679, '\P{Nv=0.1875}', "");
    Expect(0, 73679, '\P{^Nv=0.1875}', "");
    Error('\p{Is_Numeric_Value=	-0000003/16:=}');
    Error('\P{Is_Numeric_Value=	-0000003/16:=}');
    Expect(1, 73678, '\p{Is_Numeric_Value=0003/016}', "");
    Expect(0, 73678, '\p{^Is_Numeric_Value=0003/016}', "");
    Expect(0, 73678, '\P{Is_Numeric_Value=0003/016}', "");
    Expect(1, 73678, '\P{^Is_Numeric_Value=0003/016}', "");
    Expect(0, 73679, '\p{Is_Numeric_Value=0003/016}', "");
    Expect(1, 73679, '\p{^Is_Numeric_Value=0003/016}', "");
    Expect(1, 73679, '\P{Is_Numeric_Value=0003/016}', "");
    Expect(0, 73679, '\P{^Is_Numeric_Value=0003/016}', "");
    Expect(1, 73678, '\p{Is_Numeric_Value:	180/960}', "");
    Expect(0, 73678, '\p{^Is_Numeric_Value:	180/960}', "");
    Expect(0, 73678, '\P{Is_Numeric_Value:	180/960}', "");
    Expect(1, 73678, '\P{^Is_Numeric_Value:	180/960}', "");
    Expect(0, 73679, '\p{Is_Numeric_Value:	180/960}', "");
    Expect(1, 73679, '\p{^Is_Numeric_Value:	180/960}', "");
    Expect(1, 73679, '\P{Is_Numeric_Value:	180/960}', "");
    Expect(0, 73679, '\P{^Is_Numeric_Value:	180/960}', "");
    Error('\p{Is_Numeric_Value=1.9e-01}');
    Error('\P{Is_Numeric_Value=1.9e-01}');
    Expect(1, 73678, '\p{Is_Numeric_Value=1.88e-01}', "");
    Expect(0, 73678, '\p{^Is_Numeric_Value=1.88e-01}', "");
    Expect(0, 73678, '\P{Is_Numeric_Value=1.88e-01}', "");
    Expect(1, 73678, '\P{^Is_Numeric_Value=1.88e-01}', "");
    Expect(0, 73679, '\p{Is_Numeric_Value=1.88e-01}', "");
    Expect(1, 73679, '\p{^Is_Numeric_Value=1.88e-01}', "");
    Expect(1, 73679, '\P{Is_Numeric_Value=1.88e-01}', "");
    Expect(0, 73679, '\P{^Is_Numeric_Value=1.88e-01}', "");
    Error('\p{Is_Numeric_Value=0.19}');
    Error('\P{Is_Numeric_Value=0.19}');
    Expect(1, 73678, '\p{Is_Numeric_Value=1.875e-01}', "");
    Expect(0, 73678, '\p{^Is_Numeric_Value=1.875e-01}', "");
    Expect(0, 73678, '\P{Is_Numeric_Value=1.875e-01}', "");
    Expect(1, 73678, '\P{^Is_Numeric_Value=1.875e-01}', "");
    Expect(0, 73679, '\p{Is_Numeric_Value=1.875e-01}', "");
    Expect(1, 73679, '\p{^Is_Numeric_Value=1.875e-01}', "");
    Expect(1, 73679, '\P{Is_Numeric_Value=1.875e-01}', "");
    Expect(0, 73679, '\P{^Is_Numeric_Value=1.875e-01}', "");
    Expect(1, 73678, '\p{Is_Numeric_Value=0.188}', "");
    Expect(0, 73678, '\p{^Is_Numeric_Value=0.188}', "");
    Expect(0, 73678, '\P{Is_Numeric_Value=0.188}', "");
    Expect(1, 73678, '\P{^Is_Numeric_Value=0.188}', "");
    Expect(0, 73679, '\p{Is_Numeric_Value=0.188}', "");
    Expect(1, 73679, '\p{^Is_Numeric_Value=0.188}', "");
    Expect(1, 73679, '\P{Is_Numeric_Value=0.188}', "");
    Expect(0, 73679, '\P{^Is_Numeric_Value=0.188}', "");
    Expect(1, 73678, '\p{Is_Numeric_Value:   1.8750e-01}', "");
    Expect(0, 73678, '\p{^Is_Numeric_Value:   1.8750e-01}', "");
    Expect(0, 73678, '\P{Is_Numeric_Value:   1.8750e-01}', "");
    Expect(1, 73678, '\P{^Is_Numeric_Value:   1.8750e-01}', "");
    Expect(0, 73679, '\p{Is_Numeric_Value:   1.8750e-01}', "");
    Expect(1, 73679, '\p{^Is_Numeric_Value:   1.8750e-01}', "");
    Expect(1, 73679, '\P{Is_Numeric_Value:   1.8750e-01}', "");
    Expect(0, 73679, '\P{^Is_Numeric_Value:   1.8750e-01}', "");
    Expect(1, 73678, '\p{Is_Numeric_Value=0.1875}', "");
    Expect(0, 73678, '\p{^Is_Numeric_Value=0.1875}', "");
    Expect(0, 73678, '\P{Is_Numeric_Value=0.1875}', "");
    Expect(1, 73678, '\P{^Is_Numeric_Value=0.1875}', "");
    Expect(0, 73679, '\p{Is_Numeric_Value=0.1875}', "");
    Expect(1, 73679, '\p{^Is_Numeric_Value=0.1875}', "");
    Expect(1, 73679, '\P{Is_Numeric_Value=0.1875}', "");
    Expect(0, 73679, '\P{^Is_Numeric_Value=0.1875}', "");
    Error('\p{Is_Nv= +000003/0000016:=}');
    Error('\P{Is_Nv= +000003/0000016:=}');
    Expect(1, 73678, '\p{Is_Nv=0000003/016}', "");
    Expect(0, 73678, '\p{^Is_Nv=0000003/016}', "");
    Expect(0, 73678, '\P{Is_Nv=0000003/016}', "");
    Expect(1, 73678, '\P{^Is_Nv=0000003/016}', "");
    Expect(0, 73679, '\p{Is_Nv=0000003/016}', "");
    Expect(1, 73679, '\p{^Is_Nv=0000003/016}', "");
    Expect(1, 73679, '\P{Is_Nv=0000003/016}', "");
    Expect(0, 73679, '\P{^Is_Nv=0000003/016}', "");
    Expect(1, 73678, '\p{Is_Nv=180/960}', "");
    Expect(0, 73678, '\p{^Is_Nv=180/960}', "");
    Expect(0, 73678, '\P{Is_Nv=180/960}', "");
    Expect(1, 73678, '\P{^Is_Nv=180/960}', "");
    Expect(0, 73679, '\p{Is_Nv=180/960}', "");
    Expect(1, 73679, '\p{^Is_Nv=180/960}', "");
    Expect(1, 73679, '\P{Is_Nv=180/960}', "");
    Expect(0, 73679, '\P{^Is_Nv=180/960}', "");
    Error('\p{Is_Nv=1.9e-01}');
    Error('\P{Is_Nv=1.9e-01}');
    Expect(1, 73678, '\p{Is_Nv=1.88e-01}', "");
    Expect(0, 73678, '\p{^Is_Nv=1.88e-01}', "");
    Expect(0, 73678, '\P{Is_Nv=1.88e-01}', "");
    Expect(1, 73678, '\P{^Is_Nv=1.88e-01}', "");
    Expect(0, 73679, '\p{Is_Nv=1.88e-01}', "");
    Expect(1, 73679, '\p{^Is_Nv=1.88e-01}', "");
    Expect(1, 73679, '\P{Is_Nv=1.88e-01}', "");
    Expect(0, 73679, '\P{^Is_Nv=1.88e-01}', "");
    Error('\p{Is_Nv=0.19}');
    Error('\P{Is_Nv=0.19}');
    Expect(1, 73678, '\p{Is_Nv: 1.875e-01}', "");
    Expect(0, 73678, '\p{^Is_Nv: 1.875e-01}', "");
    Expect(0, 73678, '\P{Is_Nv: 1.875e-01}', "");
    Expect(1, 73678, '\P{^Is_Nv: 1.875e-01}', "");
    Expect(0, 73679, '\p{Is_Nv: 1.875e-01}', "");
    Expect(1, 73679, '\p{^Is_Nv: 1.875e-01}', "");
    Expect(1, 73679, '\P{Is_Nv: 1.875e-01}', "");
    Expect(0, 73679, '\P{^Is_Nv: 1.875e-01}', "");
    Expect(1, 73678, '\p{Is_Nv=0.188}', "");
    Expect(0, 73678, '\p{^Is_Nv=0.188}', "");
    Expect(0, 73678, '\P{Is_Nv=0.188}', "");
    Expect(1, 73678, '\P{^Is_Nv=0.188}', "");
    Expect(0, 73679, '\p{Is_Nv=0.188}', "");
    Expect(1, 73679, '\p{^Is_Nv=0.188}', "");
    Expect(1, 73679, '\P{Is_Nv=0.188}', "");
    Expect(0, 73679, '\P{^Is_Nv=0.188}', "");
    Expect(1, 73678, '\p{Is_Nv=1.8750e-01}', "");
    Expect(0, 73678, '\p{^Is_Nv=1.8750e-01}', "");
    Expect(0, 73678, '\P{Is_Nv=1.8750e-01}', "");
    Expect(1, 73678, '\P{^Is_Nv=1.8750e-01}', "");
    Expect(0, 73679, '\p{Is_Nv=1.8750e-01}', "");
    Expect(1, 73679, '\p{^Is_Nv=1.8750e-01}', "");
    Expect(1, 73679, '\P{Is_Nv=1.8750e-01}', "");
    Expect(0, 73679, '\P{^Is_Nv=1.8750e-01}', "");
    Expect(1, 73678, '\p{Is_Nv=0.1875}', "");
    Expect(0, 73678, '\p{^Is_Nv=0.1875}', "");
    Expect(0, 73678, '\P{Is_Nv=0.1875}', "");
    Expect(1, 73678, '\P{^Is_Nv=0.1875}', "");
    Expect(0, 73679, '\p{Is_Nv=0.1875}', "");
    Expect(1, 73679, '\p{^Is_Nv=0.1875}', "");
    Expect(1, 73679, '\P{Is_Nv=0.1875}', "");
    Expect(0, 73679, '\P{^Is_Nv=0.1875}', "");
    Error('\p{Numeric_Value=:=_-00003/000002}');
    Error('\P{Numeric_Value=:=_-00003/000002}');
    Expect(1, 3883, '\p{Numeric_Value=:\A3/2\z:}', "");;
    Expect(0, 3884, '\p{Numeric_Value=:\A3/2\z:}', "");;
    Expect(1, 3883, '\p{Numeric_Value=+3/000002}', "");
    Expect(0, 3883, '\p{^Numeric_Value=+3/000002}', "");
    Expect(0, 3883, '\P{Numeric_Value=+3/000002}', "");
    Expect(1, 3883, '\P{^Numeric_Value=+3/000002}', "");
    Expect(0, 3884, '\p{Numeric_Value=+3/000002}', "");
    Expect(1, 3884, '\p{^Numeric_Value=+3/000002}', "");
    Expect(1, 3884, '\P{Numeric_Value=+3/000002}', "");
    Expect(0, 3884, '\P{^Numeric_Value=+3/000002}', "");
    Expect(1, 3883, '\p{Numeric_Value=180/120}', "");
    Expect(0, 3883, '\p{^Numeric_Value=180/120}', "");
    Expect(0, 3883, '\P{Numeric_Value=180/120}', "");
    Expect(1, 3883, '\P{^Numeric_Value=180/120}', "");
    Expect(0, 3884, '\p{Numeric_Value=180/120}', "");
    Expect(1, 3884, '\p{^Numeric_Value=180/120}', "");
    Expect(1, 3884, '\P{Numeric_Value=180/120}', "");
    Expect(0, 3884, '\P{^Numeric_Value=180/120}', "");
    Expect(1, 3883, '\p{Numeric_Value=1.5e+00}', "");
    Expect(0, 3883, '\p{^Numeric_Value=1.5e+00}', "");
    Expect(0, 3883, '\P{Numeric_Value=1.5e+00}', "");
    Expect(1, 3883, '\P{^Numeric_Value=1.5e+00}', "");
    Expect(0, 3884, '\p{Numeric_Value=1.5e+00}', "");
    Expect(1, 3884, '\p{^Numeric_Value=1.5e+00}', "");
    Expect(1, 3884, '\P{Numeric_Value=1.5e+00}', "");
    Expect(0, 3884, '\P{^Numeric_Value=1.5e+00}', "");
    Expect(1, 3883, '\p{Numeric_Value=1.5}', "");
    Expect(0, 3883, '\p{^Numeric_Value=1.5}', "");
    Expect(0, 3883, '\P{Numeric_Value=1.5}', "");
    Expect(1, 3883, '\P{^Numeric_Value=1.5}', "");
    Expect(0, 3884, '\p{Numeric_Value=1.5}', "");
    Expect(1, 3884, '\p{^Numeric_Value=1.5}', "");
    Expect(1, 3884, '\P{Numeric_Value=1.5}', "");
    Expect(0, 3884, '\P{^Numeric_Value=1.5}', "");
    Expect(1, 3883, '\p{Numeric_Value=1.50e+00}', "");
    Expect(0, 3883, '\p{^Numeric_Value=1.50e+00}', "");
    Expect(0, 3883, '\P{Numeric_Value=1.50e+00}', "");
    Expect(1, 3883, '\P{^Numeric_Value=1.50e+00}', "");
    Expect(0, 3884, '\p{Numeric_Value=1.50e+00}', "");
    Expect(1, 3884, '\p{^Numeric_Value=1.50e+00}', "");
    Expect(1, 3884, '\P{Numeric_Value=1.50e+00}', "");
    Expect(0, 3884, '\P{^Numeric_Value=1.50e+00}', "");
    Expect(1, 3883, '\p{Numeric_Value=1.50}', "");
    Expect(0, 3883, '\p{^Numeric_Value=1.50}', "");
    Expect(0, 3883, '\P{Numeric_Value=1.50}', "");
    Expect(1, 3883, '\P{^Numeric_Value=1.50}', "");
    Expect(0, 3884, '\p{Numeric_Value=1.50}', "");
    Expect(1, 3884, '\p{^Numeric_Value=1.50}', "");
    Expect(1, 3884, '\P{Numeric_Value=1.50}', "");
    Expect(0, 3884, '\P{^Numeric_Value=1.50}', "");
    Error('\p{Nv=_ 000000003/0002/a/}');
    Error('\P{Nv=_ 000000003/0002/a/}');
    Expect(1, 3883, '\p{Nv=:\A3/2\z:}', "");;
    Expect(0, 3884, '\p{Nv=:\A3/2\z:}', "");;
    Expect(1, 3883, '\p{Nv=00003/2}', "");
    Expect(0, 3883, '\p{^Nv=00003/2}', "");
    Expect(0, 3883, '\P{Nv=00003/2}', "");
    Expect(1, 3883, '\P{^Nv=00003/2}', "");
    Expect(0, 3884, '\p{Nv=00003/2}', "");
    Expect(1, 3884, '\p{^Nv=00003/2}', "");
    Expect(1, 3884, '\P{Nv=00003/2}', "");
    Expect(0, 3884, '\P{^Nv=00003/2}', "");
    Expect(1, 3883, '\p{Nv=180/120}', "");
    Expect(0, 3883, '\p{^Nv=180/120}', "");
    Expect(0, 3883, '\P{Nv=180/120}', "");
    Expect(1, 3883, '\P{^Nv=180/120}', "");
    Expect(0, 3884, '\p{Nv=180/120}', "");
    Expect(1, 3884, '\p{^Nv=180/120}', "");
    Expect(1, 3884, '\P{Nv=180/120}', "");
    Expect(0, 3884, '\P{^Nv=180/120}', "");
    Expect(1, 3883, '\p{Nv=1.5e+00}', "");
    Expect(0, 3883, '\p{^Nv=1.5e+00}', "");
    Expect(0, 3883, '\P{Nv=1.5e+00}', "");
    Expect(1, 3883, '\P{^Nv=1.5e+00}', "");
    Expect(0, 3884, '\p{Nv=1.5e+00}', "");
    Expect(1, 3884, '\p{^Nv=1.5e+00}', "");
    Expect(1, 3884, '\P{Nv=1.5e+00}', "");
    Expect(0, 3884, '\P{^Nv=1.5e+00}', "");
    Expect(1, 3883, '\p{Nv=1.5}', "");
    Expect(0, 3883, '\p{^Nv=1.5}', "");
    Expect(0, 3883, '\P{Nv=1.5}', "");
    Expect(1, 3883, '\P{^Nv=1.5}', "");
    Expect(0, 3884, '\p{Nv=1.5}', "");
    Expect(1, 3884, '\p{^Nv=1.5}', "");
    Expect(1, 3884, '\P{Nv=1.5}', "");
    Expect(0, 3884, '\P{^Nv=1.5}', "");
    Expect(1, 3883, '\p{Nv=1.50e+00}', "");
    Expect(0, 3883, '\p{^Nv=1.50e+00}', "");
    Expect(0, 3883, '\P{Nv=1.50e+00}', "");
    Expect(1, 3883, '\P{^Nv=1.50e+00}', "");
    Expect(0, 3884, '\p{Nv=1.50e+00}', "");
    Expect(1, 3884, '\p{^Nv=1.50e+00}', "");
    Expect(1, 3884, '\P{Nv=1.50e+00}', "");
    Expect(0, 3884, '\P{^Nv=1.50e+00}', "");
    Expect(1, 3883, '\p{Nv=1.50}', "");
    Expect(0, 3883, '\p{^Nv=1.50}', "");
    Expect(0, 3883, '\P{Nv=1.50}', "");
    Expect(1, 3883, '\P{^Nv=1.50}', "");
    Expect(0, 3884, '\p{Nv=1.50}', "");
    Expect(1, 3884, '\p{^Nv=1.50}', "");
    Expect(1, 3884, '\P{Nv=1.50}', "");
    Expect(0, 3884, '\P{^Nv=1.50}', "");
    Error('\p{Is_Numeric_Value=	-00000003/02:=}');
    Error('\P{Is_Numeric_Value=	-00000003/02:=}');
    Expect(1, 3883, '\p{Is_Numeric_Value=0000003/000002}', "");
    Expect(0, 3883, '\p{^Is_Numeric_Value=0000003/000002}', "");
    Expect(0, 3883, '\P{Is_Numeric_Value=0000003/000002}', "");
    Expect(1, 3883, '\P{^Is_Numeric_Value=0000003/000002}', "");
    Expect(0, 3884, '\p{Is_Numeric_Value=0000003/000002}', "");
    Expect(1, 3884, '\p{^Is_Numeric_Value=0000003/000002}', "");
    Expect(1, 3884, '\P{Is_Numeric_Value=0000003/000002}', "");
    Expect(0, 3884, '\P{^Is_Numeric_Value=0000003/000002}', "");
    Expect(1, 3883, '\p{Is_Numeric_Value=180/120}', "");
    Expect(0, 3883, '\p{^Is_Numeric_Value=180/120}', "");
    Expect(0, 3883, '\P{Is_Numeric_Value=180/120}', "");
    Expect(1, 3883, '\P{^Is_Numeric_Value=180/120}', "");
    Expect(0, 3884, '\p{Is_Numeric_Value=180/120}', "");
    Expect(1, 3884, '\p{^Is_Numeric_Value=180/120}', "");
    Expect(1, 3884, '\P{Is_Numeric_Value=180/120}', "");
    Expect(0, 3884, '\P{^Is_Numeric_Value=180/120}', "");
    Expect(1, 3883, '\p{Is_Numeric_Value=1.5e+00}', "");
    Expect(0, 3883, '\p{^Is_Numeric_Value=1.5e+00}', "");
    Expect(0, 3883, '\P{Is_Numeric_Value=1.5e+00}', "");
    Expect(1, 3883, '\P{^Is_Numeric_Value=1.5e+00}', "");
    Expect(0, 3884, '\p{Is_Numeric_Value=1.5e+00}', "");
    Expect(1, 3884, '\p{^Is_Numeric_Value=1.5e+00}', "");
    Expect(1, 3884, '\P{Is_Numeric_Value=1.5e+00}', "");
    Expect(0, 3884, '\P{^Is_Numeric_Value=1.5e+00}', "");
    Expect(1, 3883, '\p{Is_Numeric_Value=1.5}', "");
    Expect(0, 3883, '\p{^Is_Numeric_Value=1.5}', "");
    Expect(0, 3883, '\P{Is_Numeric_Value=1.5}', "");
    Expect(1, 3883, '\P{^Is_Numeric_Value=1.5}', "");
    Expect(0, 3884, '\p{Is_Numeric_Value=1.5}', "");
    Expect(1, 3884, '\p{^Is_Numeric_Value=1.5}', "");
    Expect(1, 3884, '\P{Is_Numeric_Value=1.5}', "");
    Expect(0, 3884, '\P{^Is_Numeric_Value=1.5}', "");
    Expect(1, 3883, '\p{Is_Numeric_Value=1.50e+00}', "");
    Expect(0, 3883, '\p{^Is_Numeric_Value=1.50e+00}', "");
    Expect(0, 3883, '\P{Is_Numeric_Value=1.50e+00}', "");
    Expect(1, 3883, '\P{^Is_Numeric_Value=1.50e+00}', "");
    Expect(0, 3884, '\p{Is_Numeric_Value=1.50e+00}', "");
    Expect(1, 3884, '\p{^Is_Numeric_Value=1.50e+00}', "");
    Expect(1, 3884, '\P{Is_Numeric_Value=1.50e+00}', "");
    Expect(0, 3884, '\P{^Is_Numeric_Value=1.50e+00}', "");
    Expect(1, 3883, '\p{Is_Numeric_Value=1.50}', "");
    Expect(0, 3883, '\p{^Is_Numeric_Value=1.50}', "");
    Expect(0, 3883, '\P{Is_Numeric_Value=1.50}', "");
    Expect(1, 3883, '\P{^Is_Numeric_Value=1.50}', "");
    Expect(0, 3884, '\p{Is_Numeric_Value=1.50}', "");
    Expect(1, 3884, '\p{^Is_Numeric_Value=1.50}', "");
    Expect(1, 3884, '\P{Is_Numeric_Value=1.50}', "");
    Expect(0, 3884, '\P{^Is_Numeric_Value=1.50}', "");
    Error('\p{Is_Nv=/a/+003/000000002}');
    Error('\P{Is_Nv=/a/+003/000000002}');
    Expect(1, 3883, '\p{Is_Nv=3/0000000002}', "");
    Expect(0, 3883, '\p{^Is_Nv=3/0000000002}', "");
    Expect(0, 3883, '\P{Is_Nv=3/0000000002}', "");
    Expect(1, 3883, '\P{^Is_Nv=3/0000000002}', "");
    Expect(0, 3884, '\p{Is_Nv=3/0000000002}', "");
    Expect(1, 3884, '\p{^Is_Nv=3/0000000002}', "");
    Expect(1, 3884, '\P{Is_Nv=3/0000000002}', "");
    Expect(0, 3884, '\P{^Is_Nv=3/0000000002}', "");
    Expect(1, 3883, '\p{Is_Nv=180/120}', "");
    Expect(0, 3883, '\p{^Is_Nv=180/120}', "");
    Expect(0, 3883, '\P{Is_Nv=180/120}', "");
    Expect(1, 3883, '\P{^Is_Nv=180/120}', "");
    Expect(0, 3884, '\p{Is_Nv=180/120}', "");
    Expect(1, 3884, '\p{^Is_Nv=180/120}', "");
    Expect(1, 3884, '\P{Is_Nv=180/120}', "");
    Expect(0, 3884, '\P{^Is_Nv=180/120}', "");
    Expect(1, 3883, '\p{Is_Nv=1.5e+00}', "");
    Expect(0, 3883, '\p{^Is_Nv=1.5e+00}', "");
    Expect(0, 3883, '\P{Is_Nv=1.5e+00}', "");
    Expect(1, 3883, '\P{^Is_Nv=1.5e+00}', "");
    Expect(0, 3884, '\p{Is_Nv=1.5e+00}', "");
    Expect(1, 3884, '\p{^Is_Nv=1.5e+00}', "");
    Expect(1, 3884, '\P{Is_Nv=1.5e+00}', "");
    Expect(0, 3884, '\P{^Is_Nv=1.5e+00}', "");
    Expect(1, 3883, '\p{Is_Nv=1.5}', "");
    Expect(0, 3883, '\p{^Is_Nv=1.5}', "");
    Expect(0, 3883, '\P{Is_Nv=1.5}', "");
    Expect(1, 3883, '\P{^Is_Nv=1.5}', "");
    Expect(0, 3884, '\p{Is_Nv=1.5}', "");
    Expect(1, 3884, '\p{^Is_Nv=1.5}', "");
    Expect(1, 3884, '\P{Is_Nv=1.5}', "");
    Expect(0, 3884, '\P{^Is_Nv=1.5}', "");
    Expect(1, 3883, '\p{Is_Nv=1.50e+00}', "");
    Expect(0, 3883, '\p{^Is_Nv=1.50e+00}', "");
    Expect(0, 3883, '\P{Is_Nv=1.50e+00}', "");
    Expect(1, 3883, '\P{^Is_Nv=1.50e+00}', "");
    Expect(0, 3884, '\p{Is_Nv=1.50e+00}', "");
    Expect(1, 3884, '\p{^Is_Nv=1.50e+00}', "");
    Expect(1, 3884, '\P{Is_Nv=1.50e+00}', "");
    Expect(0, 3884, '\P{^Is_Nv=1.50e+00}', "");
    Expect(1, 3883, '\p{Is_Nv=1.50}', "");
    Expect(0, 3883, '\p{^Is_Nv=1.50}', "");
    Expect(0, 3883, '\P{Is_Nv=1.50}', "");
    Expect(1, 3883, '\P{^Is_Nv=1.50}', "");
    Expect(0, 3884, '\p{Is_Nv=1.50}', "");
    Expect(1, 3884, '\p{^Is_Nv=1.50}', "");
    Expect(1, 3884, '\P{Is_Nv=1.50}', "");
    Expect(0, 3884, '\P{^Is_Nv=1.50}', "");
    Error('\p{Numeric_Value=	:=+000003/00000020}');
    Error('\P{Numeric_Value=	:=+000003/00000020}');
    Expect(1, 73677, '\p{Numeric_Value=:\A3/20\z:}', "");;
    Expect(0, 73678, '\p{Numeric_Value=:\A3/20\z:}', "");;
    Expect(1, 73677, '\p{Numeric_Value=3/0000020}', "");
    Expect(0, 73677, '\p{^Numeric_Value=3/0000020}', "");
    Expect(0, 73677, '\P{Numeric_Value=3/0000020}', "");
    Expect(1, 73677, '\P{^Numeric_Value=3/0000020}', "");
    Expect(0, 73678, '\p{Numeric_Value=3/0000020}', "");
    Expect(1, 73678, '\p{^Numeric_Value=3/0000020}', "");
    Expect(1, 73678, '\P{Numeric_Value=3/0000020}', "");
    Expect(0, 73678, '\P{^Numeric_Value=3/0000020}', "");
    Expect(1, 73677, '\p{Numeric_Value=180/1200}', "");
    Expect(0, 73677, '\p{^Numeric_Value=180/1200}', "");
    Expect(0, 73677, '\P{Numeric_Value=180/1200}', "");
    Expect(1, 73677, '\P{^Numeric_Value=180/1200}', "");
    Expect(0, 73678, '\p{Numeric_Value=180/1200}', "");
    Expect(1, 73678, '\p{^Numeric_Value=180/1200}', "");
    Expect(1, 73678, '\P{Numeric_Value=180/1200}', "");
    Expect(0, 73678, '\P{^Numeric_Value=180/1200}', "");
    Expect(1, 73677, '\p{Numeric_Value=1.5e-01}', "");
    Expect(0, 73677, '\p{^Numeric_Value=1.5e-01}', "");
    Expect(0, 73677, '\P{Numeric_Value=1.5e-01}', "");
    Expect(1, 73677, '\P{^Numeric_Value=1.5e-01}', "");
    Expect(0, 73678, '\p{Numeric_Value=1.5e-01}', "");
    Expect(1, 73678, '\p{^Numeric_Value=1.5e-01}', "");
    Expect(1, 73678, '\P{Numeric_Value=1.5e-01}', "");
    Expect(0, 73678, '\P{^Numeric_Value=1.5e-01}', "");
    Expect(1, 73677, '\p{Numeric_Value=1.50e-01}', "");
    Expect(0, 73677, '\p{^Numeric_Value=1.50e-01}', "");
    Expect(0, 73677, '\P{Numeric_Value=1.50e-01}', "");
    Expect(1, 73677, '\P{^Numeric_Value=1.50e-01}', "");
    Expect(0, 73678, '\p{Numeric_Value=1.50e-01}', "");
    Expect(1, 73678, '\p{^Numeric_Value=1.50e-01}', "");
    Expect(1, 73678, '\P{Numeric_Value=1.50e-01}', "");
    Expect(0, 73678, '\P{^Numeric_Value=1.50e-01}', "");
    Expect(1, 73677, '\p{Numeric_Value: 0.15}', "");
    Expect(0, 73677, '\p{^Numeric_Value: 0.15}', "");
    Expect(0, 73677, '\P{Numeric_Value: 0.15}', "");
    Expect(1, 73677, '\P{^Numeric_Value: 0.15}', "");
    Expect(0, 73678, '\p{Numeric_Value: 0.15}', "");
    Expect(1, 73678, '\p{^Numeric_Value: 0.15}', "");
    Expect(1, 73678, '\P{Numeric_Value: 0.15}', "");
    Expect(0, 73678, '\P{^Numeric_Value: 0.15}', "");
    Expect(1, 73677, '\p{Numeric_Value=1.500e-01}', "");
    Expect(0, 73677, '\p{^Numeric_Value=1.500e-01}', "");
    Expect(0, 73677, '\P{Numeric_Value=1.500e-01}', "");
    Expect(1, 73677, '\P{^Numeric_Value=1.500e-01}', "");
    Expect(0, 73678, '\p{Numeric_Value=1.500e-01}', "");
    Expect(1, 73678, '\p{^Numeric_Value=1.500e-01}', "");
    Expect(1, 73678, '\P{Numeric_Value=1.500e-01}', "");
    Expect(0, 73678, '\P{^Numeric_Value=1.500e-01}', "");
    Expect(1, 73677, '\p{Numeric_Value=0.150}', "");
    Expect(0, 73677, '\p{^Numeric_Value=0.150}', "");
    Expect(0, 73677, '\P{Numeric_Value=0.150}', "");
    Expect(1, 73677, '\P{^Numeric_Value=0.150}', "");
    Expect(0, 73678, '\p{Numeric_Value=0.150}', "");
    Expect(1, 73678, '\p{^Numeric_Value=0.150}', "");
    Expect(1, 73678, '\P{Numeric_Value=0.150}', "");
    Expect(0, 73678, '\P{^Numeric_Value=0.150}', "");
    Error('\p{Nv=/a/	-3/020}');
    Error('\P{Nv=/a/	-3/020}');
    Expect(1, 73677, '\p{Nv=:\A3/20\z:}', "");;
    Expect(0, 73678, '\p{Nv=:\A3/20\z:}', "");;
    Expect(1, 73677, '\p{Nv=000003/20}', "");
    Expect(0, 73677, '\p{^Nv=000003/20}', "");
    Expect(0, 73677, '\P{Nv=000003/20}', "");
    Expect(1, 73677, '\P{^Nv=000003/20}', "");
    Expect(0, 73678, '\p{Nv=000003/20}', "");
    Expect(1, 73678, '\p{^Nv=000003/20}', "");
    Expect(1, 73678, '\P{Nv=000003/20}', "");
    Expect(0, 73678, '\P{^Nv=000003/20}', "");
    Expect(1, 73677, '\p{Nv=180/1200}', "");
    Expect(0, 73677, '\p{^Nv=180/1200}', "");
    Expect(0, 73677, '\P{Nv=180/1200}', "");
    Expect(1, 73677, '\P{^Nv=180/1200}', "");
    Expect(0, 73678, '\p{Nv=180/1200}', "");
    Expect(1, 73678, '\p{^Nv=180/1200}', "");
    Expect(1, 73678, '\P{Nv=180/1200}', "");
    Expect(0, 73678, '\P{^Nv=180/1200}', "");
    Expect(1, 73677, '\p{Nv=1.5e-01}', "");
    Expect(0, 73677, '\p{^Nv=1.5e-01}', "");
    Expect(0, 73677, '\P{Nv=1.5e-01}', "");
    Expect(1, 73677, '\P{^Nv=1.5e-01}', "");
    Expect(0, 73678, '\p{Nv=1.5e-01}', "");
    Expect(1, 73678, '\p{^Nv=1.5e-01}', "");
    Expect(1, 73678, '\P{Nv=1.5e-01}', "");
    Expect(0, 73678, '\P{^Nv=1.5e-01}', "");
    Expect(1, 73677, '\p{Nv=1.50e-01}', "");
    Expect(0, 73677, '\p{^Nv=1.50e-01}', "");
    Expect(0, 73677, '\P{Nv=1.50e-01}', "");
    Expect(1, 73677, '\P{^Nv=1.50e-01}', "");
    Expect(0, 73678, '\p{Nv=1.50e-01}', "");
    Expect(1, 73678, '\p{^Nv=1.50e-01}', "");
    Expect(1, 73678, '\P{Nv=1.50e-01}', "");
    Expect(0, 73678, '\P{^Nv=1.50e-01}', "");
    Expect(1, 73677, '\p{Nv=0.15}', "");
    Expect(0, 73677, '\p{^Nv=0.15}', "");
    Expect(0, 73677, '\P{Nv=0.15}', "");
    Expect(1, 73677, '\P{^Nv=0.15}', "");
    Expect(0, 73678, '\p{Nv=0.15}', "");
    Expect(1, 73678, '\p{^Nv=0.15}', "");
    Expect(1, 73678, '\P{Nv=0.15}', "");
    Expect(0, 73678, '\P{^Nv=0.15}', "");
    Expect(1, 73677, '\p{Nv=1.500e-01}', "");
    Expect(0, 73677, '\p{^Nv=1.500e-01}', "");
    Expect(0, 73677, '\P{Nv=1.500e-01}', "");
    Expect(1, 73677, '\P{^Nv=1.500e-01}', "");
    Expect(0, 73678, '\p{Nv=1.500e-01}', "");
    Expect(1, 73678, '\p{^Nv=1.500e-01}', "");
    Expect(1, 73678, '\P{Nv=1.500e-01}', "");
    Expect(0, 73678, '\P{^Nv=1.500e-01}', "");
    Expect(1, 73677, '\p{Nv=0.150}', "");
    Expect(0, 73677, '\p{^Nv=0.150}', "");
    Expect(0, 73677, '\P{Nv=0.150}', "");
    Expect(1, 73677, '\P{^Nv=0.150}', "");
    Expect(0, 73678, '\p{Nv=0.150}', "");
    Expect(1, 73678, '\p{^Nv=0.150}', "");
    Expect(1, 73678, '\P{Nv=0.150}', "");
    Expect(0, 73678, '\P{^Nv=0.150}', "");
    Error('\p{Is_Numeric_Value=  003/00000000020:=}');
    Error('\P{Is_Numeric_Value=  003/00000000020:=}');
    Expect(1, 73677, '\p{Is_Numeric_Value=03/00000020}', "");
    Expect(0, 73677, '\p{^Is_Numeric_Value=03/00000020}', "");
    Expect(0, 73677, '\P{Is_Numeric_Value=03/00000020}', "");
    Expect(1, 73677, '\P{^Is_Numeric_Value=03/00000020}', "");
    Expect(0, 73678, '\p{Is_Numeric_Value=03/00000020}', "");
    Expect(1, 73678, '\p{^Is_Numeric_Value=03/00000020}', "");
    Expect(1, 73678, '\P{Is_Numeric_Value=03/00000020}', "");
    Expect(0, 73678, '\P{^Is_Numeric_Value=03/00000020}', "");
    Expect(1, 73677, '\p{Is_Numeric_Value=180/1200}', "");
    Expect(0, 73677, '\p{^Is_Numeric_Value=180/1200}', "");
    Expect(0, 73677, '\P{Is_Numeric_Value=180/1200}', "");
    Expect(1, 73677, '\P{^Is_Numeric_Value=180/1200}', "");
    Expect(0, 73678, '\p{Is_Numeric_Value=180/1200}', "");
    Expect(1, 73678, '\p{^Is_Numeric_Value=180/1200}', "");
    Expect(1, 73678, '\P{Is_Numeric_Value=180/1200}', "");
    Expect(0, 73678, '\P{^Is_Numeric_Value=180/1200}', "");
    Expect(1, 73677, '\p{Is_Numeric_Value=1.5e-01}', "");
    Expect(0, 73677, '\p{^Is_Numeric_Value=1.5e-01}', "");
    Expect(0, 73677, '\P{Is_Numeric_Value=1.5e-01}', "");
    Expect(1, 73677, '\P{^Is_Numeric_Value=1.5e-01}', "");
    Expect(0, 73678, '\p{Is_Numeric_Value=1.5e-01}', "");
    Expect(1, 73678, '\p{^Is_Numeric_Value=1.5e-01}', "");
    Expect(1, 73678, '\P{Is_Numeric_Value=1.5e-01}', "");
    Expect(0, 73678, '\P{^Is_Numeric_Value=1.5e-01}', "");
    Expect(1, 73677, '\p{Is_Numeric_Value=1.50e-01}', "");
    Expect(0, 73677, '\p{^Is_Numeric_Value=1.50e-01}', "");
    Expect(0, 73677, '\P{Is_Numeric_Value=1.50e-01}', "");
    Expect(1, 73677, '\P{^Is_Numeric_Value=1.50e-01}', "");
    Expect(0, 73678, '\p{Is_Numeric_Value=1.50e-01}', "");
    Expect(1, 73678, '\p{^Is_Numeric_Value=1.50e-01}', "");
    Expect(1, 73678, '\P{Is_Numeric_Value=1.50e-01}', "");
    Expect(0, 73678, '\P{^Is_Numeric_Value=1.50e-01}', "");
    Expect(1, 73677, '\p{Is_Numeric_Value:	0.15}', "");
    Expect(0, 73677, '\p{^Is_Numeric_Value:	0.15}', "");
    Expect(0, 73677, '\P{Is_Numeric_Value:	0.15}', "");
    Expect(1, 73677, '\P{^Is_Numeric_Value:	0.15}', "");
    Expect(0, 73678, '\p{Is_Numeric_Value:	0.15}', "");
    Expect(1, 73678, '\p{^Is_Numeric_Value:	0.15}', "");
    Expect(1, 73678, '\P{Is_Numeric_Value:	0.15}', "");
    Expect(0, 73678, '\P{^Is_Numeric_Value:	0.15}', "");
    Expect(1, 73677, '\p{Is_Numeric_Value=1.500e-01}', "");
    Expect(0, 73677, '\p{^Is_Numeric_Value=1.500e-01}', "");
    Expect(0, 73677, '\P{Is_Numeric_Value=1.500e-01}', "");
    Expect(1, 73677, '\P{^Is_Numeric_Value=1.500e-01}', "");
    Expect(0, 73678, '\p{Is_Numeric_Value=1.500e-01}', "");
    Expect(1, 73678, '\p{^Is_Numeric_Value=1.500e-01}', "");
    Expect(1, 73678, '\P{Is_Numeric_Value=1.500e-01}', "");
    Expect(0, 73678, '\P{^Is_Numeric_Value=1.500e-01}', "");
    Expect(1, 73677, '\p{Is_Numeric_Value=0.150}', "");
    Expect(0, 73677, '\p{^Is_Numeric_Value=0.150}', "");
    Expect(0, 73677, '\P{Is_Numeric_Value=0.150}', "");
    Expect(1, 73677, '\P{^Is_Numeric_Value=0.150}', "");
    Expect(0, 73678, '\p{Is_Numeric_Value=0.150}', "");
    Expect(1, 73678, '\p{^Is_Numeric_Value=0.150}', "");
    Expect(1, 73678, '\P{Is_Numeric_Value=0.150}', "");
    Expect(0, 73678, '\P{^Is_Numeric_Value=0.150}', "");
    Error('\p{Is_Nv:	- +0000003/00000020:=}');
    Error('\P{Is_Nv:	- +0000003/00000020:=}');
    Expect(1, 73677, '\p{Is_Nv=03/00000020}', "");
    Expect(0, 73677, '\p{^Is_Nv=03/00000020}', "");
    Expect(0, 73677, '\P{Is_Nv=03/00000020}', "");
    Expect(1, 73677, '\P{^Is_Nv=03/00000020}', "");
    Expect(0, 73678, '\p{Is_Nv=03/00000020}', "");
    Expect(1, 73678, '\p{^Is_Nv=03/00000020}', "");
    Expect(1, 73678, '\P{Is_Nv=03/00000020}', "");
    Expect(0, 73678, '\P{^Is_Nv=03/00000020}', "");
    Expect(1, 73677, '\p{Is_Nv=180/1200}', "");
    Expect(0, 73677, '\p{^Is_Nv=180/1200}', "");
    Expect(0, 73677, '\P{Is_Nv=180/1200}', "");
    Expect(1, 73677, '\P{^Is_Nv=180/1200}', "");
    Expect(0, 73678, '\p{Is_Nv=180/1200}', "");
    Expect(1, 73678, '\p{^Is_Nv=180/1200}', "");
    Expect(1, 73678, '\P{Is_Nv=180/1200}', "");
    Expect(0, 73678, '\P{^Is_Nv=180/1200}', "");
    Expect(1, 73677, '\p{Is_Nv=1.5e-01}', "");
    Expect(0, 73677, '\p{^Is_Nv=1.5e-01}', "");
    Expect(0, 73677, '\P{Is_Nv=1.5e-01}', "");
    Expect(1, 73677, '\P{^Is_Nv=1.5e-01}', "");
    Expect(0, 73678, '\p{Is_Nv=1.5e-01}', "");
    Expect(1, 73678, '\p{^Is_Nv=1.5e-01}', "");
    Expect(1, 73678, '\P{Is_Nv=1.5e-01}', "");
    Expect(0, 73678, '\P{^Is_Nv=1.5e-01}', "");
    Expect(1, 73677, '\p{Is_Nv=1.50e-01}', "");
    Expect(0, 73677, '\p{^Is_Nv=1.50e-01}', "");
    Expect(0, 73677, '\P{Is_Nv=1.50e-01}', "");
    Expect(1, 73677, '\P{^Is_Nv=1.50e-01}', "");
    Expect(0, 73678, '\p{Is_Nv=1.50e-01}', "");
    Expect(1, 73678, '\p{^Is_Nv=1.50e-01}', "");
    Expect(1, 73678, '\P{Is_Nv=1.50e-01}', "");
    Expect(0, 73678, '\P{^Is_Nv=1.50e-01}', "");
    Expect(1, 73677, '\p{Is_Nv=0.15}', "");
    Expect(0, 73677, '\p{^Is_Nv=0.15}', "");
    Expect(0, 73677, '\P{Is_Nv=0.15}', "");
    Expect(1, 73677, '\P{^Is_Nv=0.15}', "");
    Expect(0, 73678, '\p{Is_Nv=0.15}', "");
    Expect(1, 73678, '\p{^Is_Nv=0.15}', "");
    Expect(1, 73678, '\P{Is_Nv=0.15}', "");
    Expect(0, 73678, '\P{^Is_Nv=0.15}', "");
    Expect(1, 73677, '\p{Is_Nv:1.500e-01}', "");
    Expect(0, 73677, '\p{^Is_Nv:1.500e-01}', "");
    Expect(0, 73677, '\P{Is_Nv:1.500e-01}', "");
    Expect(1, 73677, '\P{^Is_Nv:1.500e-01}', "");
    Expect(0, 73678, '\p{Is_Nv:1.500e-01}', "");
    Expect(1, 73678, '\p{^Is_Nv:1.500e-01}', "");
    Expect(1, 73678, '\P{Is_Nv:1.500e-01}', "");
    Expect(0, 73678, '\P{^Is_Nv:1.500e-01}', "");
    Expect(1, 73677, '\p{Is_Nv=0.150}', "");
    Expect(0, 73677, '\p{^Is_Nv=0.150}', "");
    Expect(0, 73677, '\P{Is_Nv=0.150}', "");
    Expect(1, 73677, '\P{^Is_Nv=0.150}', "");
    Expect(0, 73678, '\p{Is_Nv=0.150}', "");
    Expect(1, 73678, '\p{^Is_Nv=0.150}', "");
    Expect(1, 73678, '\P{Is_Nv=0.150}', "");
    Expect(0, 73678, '\P{^Is_Nv=0.150}', "");
    Error('\p{Numeric_Value= +00003/0000000004/a/}');
    Error('\P{Numeric_Value= +00003/0000000004/a/}');
    Expect(1, 126127, '\p{Numeric_Value=:\A3/4\z:}', "");;
    Expect(0, 126128, '\p{Numeric_Value=:\A3/4\z:}', "");;
    Expect(1, 126127, '\p{Numeric_Value=0003/00000004}', "");
    Expect(0, 126127, '\p{^Numeric_Value=0003/00000004}', "");
    Expect(0, 126127, '\P{Numeric_Value=0003/00000004}', "");
    Expect(1, 126127, '\P{^Numeric_Value=0003/00000004}', "");
    Expect(0, 126128, '\p{Numeric_Value=0003/00000004}', "");
    Expect(1, 126128, '\p{^Numeric_Value=0003/00000004}', "");
    Expect(1, 126128, '\P{Numeric_Value=0003/00000004}', "");
    Expect(0, 126128, '\P{^Numeric_Value=0003/00000004}', "");
    Expect(1, 126127, '\p{Numeric_Value=180/240}', "");
    Expect(0, 126127, '\p{^Numeric_Value=180/240}', "");
    Expect(0, 126127, '\P{Numeric_Value=180/240}', "");
    Expect(1, 126127, '\P{^Numeric_Value=180/240}', "");
    Expect(0, 126128, '\p{Numeric_Value=180/240}', "");
    Expect(1, 126128, '\p{^Numeric_Value=180/240}', "");
    Expect(1, 126128, '\P{Numeric_Value=180/240}', "");
    Expect(0, 126128, '\P{^Numeric_Value=180/240}', "");
    Expect(1, 126127, '\p{Numeric_Value=7.5e-01}', "");
    Expect(0, 126127, '\p{^Numeric_Value=7.5e-01}', "");
    Expect(0, 126127, '\P{Numeric_Value=7.5e-01}', "");
    Expect(1, 126127, '\P{^Numeric_Value=7.5e-01}', "");
    Expect(0, 126128, '\p{Numeric_Value=7.5e-01}', "");
    Expect(1, 126128, '\p{^Numeric_Value=7.5e-01}', "");
    Expect(1, 126128, '\P{Numeric_Value=7.5e-01}', "");
    Expect(0, 126128, '\P{^Numeric_Value=7.5e-01}', "");
    Expect(1, 126127, '\p{Numeric_Value: 7.50e-01}', "");
    Expect(0, 126127, '\p{^Numeric_Value: 7.50e-01}', "");
    Expect(0, 126127, '\P{Numeric_Value: 7.50e-01}', "");
    Expect(1, 126127, '\P{^Numeric_Value: 7.50e-01}', "");
    Expect(0, 126128, '\p{Numeric_Value: 7.50e-01}', "");
    Expect(1, 126128, '\p{^Numeric_Value: 7.50e-01}', "");
    Expect(1, 126128, '\P{Numeric_Value: 7.50e-01}', "");
    Expect(0, 126128, '\P{^Numeric_Value: 7.50e-01}', "");
    Expect(1, 126127, '\p{Numeric_Value=0.75}', "");
    Expect(0, 126127, '\p{^Numeric_Value=0.75}', "");
    Expect(0, 126127, '\P{Numeric_Value=0.75}', "");
    Expect(1, 126127, '\P{^Numeric_Value=0.75}', "");
    Expect(0, 126128, '\p{Numeric_Value=0.75}', "");
    Expect(1, 126128, '\p{^Numeric_Value=0.75}', "");
    Expect(1, 126128, '\P{Numeric_Value=0.75}', "");
    Expect(0, 126128, '\P{^Numeric_Value=0.75}', "");
    Expect(1, 126127, '\p{Numeric_Value=7.500e-01}', "");
    Expect(0, 126127, '\p{^Numeric_Value=7.500e-01}', "");
    Expect(0, 126127, '\P{Numeric_Value=7.500e-01}', "");
    Expect(1, 126127, '\P{^Numeric_Value=7.500e-01}', "");
    Expect(0, 126128, '\p{Numeric_Value=7.500e-01}', "");
    Expect(1, 126128, '\p{^Numeric_Value=7.500e-01}', "");
    Expect(1, 126128, '\P{Numeric_Value=7.500e-01}', "");
    Expect(0, 126128, '\P{^Numeric_Value=7.500e-01}', "");
    Expect(1, 126127, '\p{Numeric_Value=0.750}', "");
    Expect(0, 126127, '\p{^Numeric_Value=0.750}', "");
    Expect(0, 126127, '\P{Numeric_Value=0.750}', "");
    Expect(1, 126127, '\P{^Numeric_Value=0.750}', "");
    Expect(0, 126128, '\p{Numeric_Value=0.750}', "");
    Expect(1, 126128, '\p{^Numeric_Value=0.750}', "");
    Expect(1, 126128, '\P{Numeric_Value=0.750}', "");
    Expect(0, 126128, '\P{^Numeric_Value=0.750}', "");
    Error('\p{Nv=-/a/00003/0004}');
    Error('\P{Nv=-/a/00003/0004}');
    Expect(1, 126127, '\p{Nv=:\A3/4\z:}', "");;
    Expect(0, 126128, '\p{Nv=:\A3/4\z:}', "");;
    Expect(1, 126127, '\p{Nv=+000000003/000000004}', "");
    Expect(0, 126127, '\p{^Nv=+000000003/000000004}', "");
    Expect(0, 126127, '\P{Nv=+000000003/000000004}', "");
    Expect(1, 126127, '\P{^Nv=+000000003/000000004}', "");
    Expect(0, 126128, '\p{Nv=+000000003/000000004}', "");
    Expect(1, 126128, '\p{^Nv=+000000003/000000004}', "");
    Expect(1, 126128, '\P{Nv=+000000003/000000004}', "");
    Expect(0, 126128, '\P{^Nv=+000000003/000000004}', "");
    Expect(1, 126127, '\p{Nv=180/240}', "");
    Expect(0, 126127, '\p{^Nv=180/240}', "");
    Expect(0, 126127, '\P{Nv=180/240}', "");
    Expect(1, 126127, '\P{^Nv=180/240}', "");
    Expect(0, 126128, '\p{Nv=180/240}', "");
    Expect(1, 126128, '\p{^Nv=180/240}', "");
    Expect(1, 126128, '\P{Nv=180/240}', "");
    Expect(0, 126128, '\P{^Nv=180/240}', "");
    Expect(1, 126127, '\p{Nv=7.5e-01}', "");
    Expect(0, 126127, '\p{^Nv=7.5e-01}', "");
    Expect(0, 126127, '\P{Nv=7.5e-01}', "");
    Expect(1, 126127, '\P{^Nv=7.5e-01}', "");
    Expect(0, 126128, '\p{Nv=7.5e-01}', "");
    Expect(1, 126128, '\p{^Nv=7.5e-01}', "");
    Expect(1, 126128, '\P{Nv=7.5e-01}', "");
    Expect(0, 126128, '\P{^Nv=7.5e-01}', "");
    Expect(1, 126127, '\p{Nv=7.50e-01}', "");
    Expect(0, 126127, '\p{^Nv=7.50e-01}', "");
    Expect(0, 126127, '\P{Nv=7.50e-01}', "");
    Expect(1, 126127, '\P{^Nv=7.50e-01}', "");
    Expect(0, 126128, '\p{Nv=7.50e-01}', "");
    Expect(1, 126128, '\p{^Nv=7.50e-01}', "");
    Expect(1, 126128, '\P{Nv=7.50e-01}', "");
    Expect(0, 126128, '\P{^Nv=7.50e-01}', "");
    Expect(1, 126127, '\p{Nv=0.75}', "");
    Expect(0, 126127, '\p{^Nv=0.75}', "");
    Expect(0, 126127, '\P{Nv=0.75}', "");
    Expect(1, 126127, '\P{^Nv=0.75}', "");
    Expect(0, 126128, '\p{Nv=0.75}', "");
    Expect(1, 126128, '\p{^Nv=0.75}', "");
    Expect(1, 126128, '\P{Nv=0.75}', "");
    Expect(0, 126128, '\P{^Nv=0.75}', "");
    Expect(1, 126127, '\p{Nv=7.500e-01}', "");
    Expect(0, 126127, '\p{^Nv=7.500e-01}', "");
    Expect(0, 126127, '\P{Nv=7.500e-01}', "");
    Expect(1, 126127, '\P{^Nv=7.500e-01}', "");
    Expect(0, 126128, '\p{Nv=7.500e-01}', "");
    Expect(1, 126128, '\p{^Nv=7.500e-01}', "");
    Expect(1, 126128, '\P{Nv=7.500e-01}', "");
    Expect(0, 126128, '\P{^Nv=7.500e-01}', "");
    Expect(1, 126127, '\p{Nv=0.750}', "");
    Expect(0, 126127, '\p{^Nv=0.750}', "");
    Expect(0, 126127, '\P{Nv=0.750}', "");
    Expect(1, 126127, '\P{^Nv=0.750}', "");
    Expect(0, 126128, '\p{Nv=0.750}', "");
    Expect(1, 126128, '\p{^Nv=0.750}', "");
    Expect(1, 126128, '\P{Nv=0.750}', "");
    Expect(0, 126128, '\P{^Nv=0.750}', "");
    Error('\p{Is_Numeric_Value=:=_ +000000003/0000004}');
    Error('\P{Is_Numeric_Value=:=_ +000000003/0000004}');
    Expect(1, 126127, '\p{Is_Numeric_Value=0000000003/0000000004}', "");
    Expect(0, 126127, '\p{^Is_Numeric_Value=0000000003/0000000004}', "");
    Expect(0, 126127, '\P{Is_Numeric_Value=0000000003/0000000004}', "");
    Expect(1, 126127, '\P{^Is_Numeric_Value=0000000003/0000000004}', "");
    Expect(0, 126128, '\p{Is_Numeric_Value=0000000003/0000000004}', "");
    Expect(1, 126128, '\p{^Is_Numeric_Value=0000000003/0000000004}', "");
    Expect(1, 126128, '\P{Is_Numeric_Value=0000000003/0000000004}', "");
    Expect(0, 126128, '\P{^Is_Numeric_Value=0000000003/0000000004}', "");
    Expect(1, 126127, '\p{Is_Numeric_Value=180/240}', "");
    Expect(0, 126127, '\p{^Is_Numeric_Value=180/240}', "");
    Expect(0, 126127, '\P{Is_Numeric_Value=180/240}', "");
    Expect(1, 126127, '\P{^Is_Numeric_Value=180/240}', "");
    Expect(0, 126128, '\p{Is_Numeric_Value=180/240}', "");
    Expect(1, 126128, '\p{^Is_Numeric_Value=180/240}', "");
    Expect(1, 126128, '\P{Is_Numeric_Value=180/240}', "");
    Expect(0, 126128, '\P{^Is_Numeric_Value=180/240}', "");
    Expect(1, 126127, '\p{Is_Numeric_Value=7.5e-01}', "");
    Expect(0, 126127, '\p{^Is_Numeric_Value=7.5e-01}', "");
    Expect(0, 126127, '\P{Is_Numeric_Value=7.5e-01}', "");
    Expect(1, 126127, '\P{^Is_Numeric_Value=7.5e-01}', "");
    Expect(0, 126128, '\p{Is_Numeric_Value=7.5e-01}', "");
    Expect(1, 126128, '\p{^Is_Numeric_Value=7.5e-01}', "");
    Expect(1, 126128, '\P{Is_Numeric_Value=7.5e-01}', "");
    Expect(0, 126128, '\P{^Is_Numeric_Value=7.5e-01}', "");
    Expect(1, 126127, '\p{Is_Numeric_Value=7.50e-01}', "");
    Expect(0, 126127, '\p{^Is_Numeric_Value=7.50e-01}', "");
    Expect(0, 126127, '\P{Is_Numeric_Value=7.50e-01}', "");
    Expect(1, 126127, '\P{^Is_Numeric_Value=7.50e-01}', "");
    Expect(0, 126128, '\p{Is_Numeric_Value=7.50e-01}', "");
    Expect(1, 126128, '\p{^Is_Numeric_Value=7.50e-01}', "");
    Expect(1, 126128, '\P{Is_Numeric_Value=7.50e-01}', "");
    Expect(0, 126128, '\P{^Is_Numeric_Value=7.50e-01}', "");
    Expect(1, 126127, '\p{Is_Numeric_Value=0.75}', "");
    Expect(0, 126127, '\p{^Is_Numeric_Value=0.75}', "");
    Expect(0, 126127, '\P{Is_Numeric_Value=0.75}', "");
    Expect(1, 126127, '\P{^Is_Numeric_Value=0.75}', "");
    Expect(0, 126128, '\p{Is_Numeric_Value=0.75}', "");
    Expect(1, 126128, '\p{^Is_Numeric_Value=0.75}', "");
    Expect(1, 126128, '\P{Is_Numeric_Value=0.75}', "");
    Expect(0, 126128, '\P{^Is_Numeric_Value=0.75}', "");
    Expect(1, 126127, '\p{Is_Numeric_Value=7.500e-01}', "");
    Expect(0, 126127, '\p{^Is_Numeric_Value=7.500e-01}', "");
    Expect(0, 126127, '\P{Is_Numeric_Value=7.500e-01}', "");
    Expect(1, 126127, '\P{^Is_Numeric_Value=7.500e-01}', "");
    Expect(0, 126128, '\p{Is_Numeric_Value=7.500e-01}', "");
    Expect(1, 126128, '\p{^Is_Numeric_Value=7.500e-01}', "");
    Expect(1, 126128, '\P{Is_Numeric_Value=7.500e-01}', "");
    Expect(0, 126128, '\P{^Is_Numeric_Value=7.500e-01}', "");
    Expect(1, 126127, '\p{Is_Numeric_Value=0.750}', "");
    Expect(0, 126127, '\p{^Is_Numeric_Value=0.750}', "");
    Expect(0, 126127, '\P{Is_Numeric_Value=0.750}', "");
    Expect(1, 126127, '\P{^Is_Numeric_Value=0.750}', "");
    Expect(0, 126128, '\p{Is_Numeric_Value=0.750}', "");
    Expect(1, 126128, '\p{^Is_Numeric_Value=0.750}', "");
    Expect(1, 126128, '\P{Is_Numeric_Value=0.750}', "");
    Expect(0, 126128, '\P{^Is_Numeric_Value=0.750}', "");
    Error('\p{Is_Nv=_	000003/00004/a/}');
    Error('\P{Is_Nv=_	000003/00004/a/}');
    Expect(1, 126127, '\p{Is_Nv=03/4}', "");
    Expect(0, 126127, '\p{^Is_Nv=03/4}', "");
    Expect(0, 126127, '\P{Is_Nv=03/4}', "");
    Expect(1, 126127, '\P{^Is_Nv=03/4}', "");
    Expect(0, 126128, '\p{Is_Nv=03/4}', "");
    Expect(1, 126128, '\p{^Is_Nv=03/4}', "");
    Expect(1, 126128, '\P{Is_Nv=03/4}', "");
    Expect(0, 126128, '\P{^Is_Nv=03/4}', "");
    Expect(1, 126127, '\p{Is_Nv=180/240}', "");
    Expect(0, 126127, '\p{^Is_Nv=180/240}', "");
    Expect(0, 126127, '\P{Is_Nv=180/240}', "");
    Expect(1, 126127, '\P{^Is_Nv=180/240}', "");
    Expect(0, 126128, '\p{Is_Nv=180/240}', "");
    Expect(1, 126128, '\p{^Is_Nv=180/240}', "");
    Expect(1, 126128, '\P{Is_Nv=180/240}', "");
    Expect(0, 126128, '\P{^Is_Nv=180/240}', "");
    Expect(1, 126127, '\p{Is_Nv=7.5e-01}', "");
    Expect(0, 126127, '\p{^Is_Nv=7.5e-01}', "");
    Expect(0, 126127, '\P{Is_Nv=7.5e-01}', "");
    Expect(1, 126127, '\P{^Is_Nv=7.5e-01}', "");
    Expect(0, 126128, '\p{Is_Nv=7.5e-01}', "");
    Expect(1, 126128, '\p{^Is_Nv=7.5e-01}', "");
    Expect(1, 126128, '\P{Is_Nv=7.5e-01}', "");
    Expect(0, 126128, '\P{^Is_Nv=7.5e-01}', "");
    Expect(1, 126127, '\p{Is_Nv=7.50e-01}', "");
    Expect(0, 126127, '\p{^Is_Nv=7.50e-01}', "");
    Expect(0, 126127, '\P{Is_Nv=7.50e-01}', "");
    Expect(1, 126127, '\P{^Is_Nv=7.50e-01}', "");
    Expect(0, 126128, '\p{Is_Nv=7.50e-01}', "");
    Expect(1, 126128, '\p{^Is_Nv=7.50e-01}', "");
    Expect(1, 126128, '\P{Is_Nv=7.50e-01}', "");
    Expect(0, 126128, '\P{^Is_Nv=7.50e-01}', "");
    Expect(1, 126127, '\p{Is_Nv=0.75}', "");
    Expect(0, 126127, '\p{^Is_Nv=0.75}', "");
    Expect(0, 126127, '\P{Is_Nv=0.75}', "");
    Expect(1, 126127, '\P{^Is_Nv=0.75}', "");
    Expect(0, 126128, '\p{Is_Nv=0.75}', "");
    Expect(1, 126128, '\p{^Is_Nv=0.75}', "");
    Expect(1, 126128, '\P{Is_Nv=0.75}', "");
    Expect(0, 126128, '\P{^Is_Nv=0.75}', "");
    Expect(1, 126127, '\p{Is_Nv=7.500e-01}', "");
    Expect(0, 126127, '\p{^Is_Nv=7.500e-01}', "");
    Expect(0, 126127, '\P{Is_Nv=7.500e-01}', "");
    Expect(1, 126127, '\P{^Is_Nv=7.500e-01}', "");
    Expect(0, 126128, '\p{Is_Nv=7.500e-01}', "");
    Expect(1, 126128, '\p{^Is_Nv=7.500e-01}', "");
    Expect(1, 126128, '\P{Is_Nv=7.500e-01}', "");
    Expect(0, 126128, '\P{^Is_Nv=7.500e-01}', "");
    Expect(1, 126127, '\p{Is_Nv=0.750}', "");
    Expect(0, 126127, '\p{^Is_Nv=0.750}', "");
    Expect(0, 126127, '\P{Is_Nv=0.750}', "");
    Expect(1, 126127, '\P{^Is_Nv=0.750}', "");
    Expect(0, 126128, '\p{Is_Nv=0.750}', "");
    Expect(1, 126128, '\p{^Is_Nv=0.750}', "");
    Expect(1, 126128, '\P{Is_Nv=0.750}', "");
    Expect(0, 126128, '\P{^Is_Nv=0.750}', "");
    Error('\p{Numeric_Value=:=+03/005}');
    Error('\P{Numeric_Value=:=+03/005}');
    Expect(1, 8535, '\p{Numeric_Value=:\A3/5\z:}', "");;
    Expect(0, 8536, '\p{Numeric_Value=:\A3/5\z:}', "");;
    Expect(1, 8535, '\p{Numeric_Value=00003/005}', "");
    Expect(0, 8535, '\p{^Numeric_Value=00003/005}', "");
    Expect(0, 8535, '\P{Numeric_Value=00003/005}', "");
    Expect(1, 8535, '\P{^Numeric_Value=00003/005}', "");
    Expect(0, 8536, '\p{Numeric_Value=00003/005}', "");
    Expect(1, 8536, '\p{^Numeric_Value=00003/005}', "");
    Expect(1, 8536, '\P{Numeric_Value=00003/005}', "");
    Expect(0, 8536, '\P{^Numeric_Value=00003/005}', "");
    Expect(1, 8535, '\p{Numeric_Value=180/300}', "");
    Expect(0, 8535, '\p{^Numeric_Value=180/300}', "");
    Expect(0, 8535, '\P{Numeric_Value=180/300}', "");
    Expect(1, 8535, '\P{^Numeric_Value=180/300}', "");
    Expect(0, 8536, '\p{Numeric_Value=180/300}', "");
    Expect(1, 8536, '\p{^Numeric_Value=180/300}', "");
    Expect(1, 8536, '\P{Numeric_Value=180/300}', "");
    Expect(0, 8536, '\P{^Numeric_Value=180/300}', "");
    Expect(1, 8535, '\p{Numeric_Value=6.0e-01}', "");
    Expect(0, 8535, '\p{^Numeric_Value=6.0e-01}', "");
    Expect(0, 8535, '\P{Numeric_Value=6.0e-01}', "");
    Expect(1, 8535, '\P{^Numeric_Value=6.0e-01}', "");
    Expect(0, 8536, '\p{Numeric_Value=6.0e-01}', "");
    Expect(1, 8536, '\p{^Numeric_Value=6.0e-01}', "");
    Expect(1, 8536, '\P{Numeric_Value=6.0e-01}', "");
    Expect(0, 8536, '\P{^Numeric_Value=6.0e-01}', "");
    Expect(1, 8535, '\p{Numeric_Value=0.6}', "");
    Expect(0, 8535, '\p{^Numeric_Value=0.6}', "");
    Expect(0, 8535, '\P{Numeric_Value=0.6}', "");
    Expect(1, 8535, '\P{^Numeric_Value=0.6}', "");
    Expect(0, 8536, '\p{Numeric_Value=0.6}', "");
    Expect(1, 8536, '\p{^Numeric_Value=0.6}', "");
    Expect(1, 8536, '\P{Numeric_Value=0.6}', "");
    Expect(0, 8536, '\P{^Numeric_Value=0.6}', "");
    Expect(1, 8535, '\p{Numeric_Value=6.00e-01}', "");
    Expect(0, 8535, '\p{^Numeric_Value=6.00e-01}', "");
    Expect(0, 8535, '\P{Numeric_Value=6.00e-01}', "");
    Expect(1, 8535, '\P{^Numeric_Value=6.00e-01}', "");
    Expect(0, 8536, '\p{Numeric_Value=6.00e-01}', "");
    Expect(1, 8536, '\p{^Numeric_Value=6.00e-01}', "");
    Expect(1, 8536, '\P{Numeric_Value=6.00e-01}', "");
    Expect(0, 8536, '\P{^Numeric_Value=6.00e-01}', "");
    Expect(1, 8535, '\p{Numeric_Value=0.60}', "");
    Expect(0, 8535, '\p{^Numeric_Value=0.60}', "");
    Expect(0, 8535, '\P{Numeric_Value=0.60}', "");
    Expect(1, 8535, '\P{^Numeric_Value=0.60}', "");
    Expect(0, 8536, '\p{Numeric_Value=0.60}', "");
    Expect(1, 8536, '\p{^Numeric_Value=0.60}', "");
    Expect(1, 8536, '\P{Numeric_Value=0.60}', "");
    Expect(0, 8536, '\P{^Numeric_Value=0.60}', "");
    Error('\p{Nv=	/a/0003/5}');
    Error('\P{Nv=	/a/0003/5}');
    Expect(1, 8535, '\p{Nv=:\A3/5\z:}', "");;
    Expect(0, 8536, '\p{Nv=:\A3/5\z:}', "");;
    Expect(1, 8535, '\p{Nv=+000003/0000005}', "");
    Expect(0, 8535, '\p{^Nv=+000003/0000005}', "");
    Expect(0, 8535, '\P{Nv=+000003/0000005}', "");
    Expect(1, 8535, '\P{^Nv=+000003/0000005}', "");
    Expect(0, 8536, '\p{Nv=+000003/0000005}', "");
    Expect(1, 8536, '\p{^Nv=+000003/0000005}', "");
    Expect(1, 8536, '\P{Nv=+000003/0000005}', "");
    Expect(0, 8536, '\P{^Nv=+000003/0000005}', "");
    Expect(1, 8535, '\p{Nv=180/300}', "");
    Expect(0, 8535, '\p{^Nv=180/300}', "");
    Expect(0, 8535, '\P{Nv=180/300}', "");
    Expect(1, 8535, '\P{^Nv=180/300}', "");
    Expect(0, 8536, '\p{Nv=180/300}', "");
    Expect(1, 8536, '\p{^Nv=180/300}', "");
    Expect(1, 8536, '\P{Nv=180/300}', "");
    Expect(0, 8536, '\P{^Nv=180/300}', "");
    Expect(1, 8535, '\p{Nv=6.0e-01}', "");
    Expect(0, 8535, '\p{^Nv=6.0e-01}', "");
    Expect(0, 8535, '\P{Nv=6.0e-01}', "");
    Expect(1, 8535, '\P{^Nv=6.0e-01}', "");
    Expect(0, 8536, '\p{Nv=6.0e-01}', "");
    Expect(1, 8536, '\p{^Nv=6.0e-01}', "");
    Expect(1, 8536, '\P{Nv=6.0e-01}', "");
    Expect(0, 8536, '\P{^Nv=6.0e-01}', "");
    Expect(1, 8535, '\p{Nv=0.6}', "");
    Expect(0, 8535, '\p{^Nv=0.6}', "");
    Expect(0, 8535, '\P{Nv=0.6}', "");
    Expect(1, 8535, '\P{^Nv=0.6}', "");
    Expect(0, 8536, '\p{Nv=0.6}', "");
    Expect(1, 8536, '\p{^Nv=0.6}', "");
    Expect(1, 8536, '\P{Nv=0.6}', "");
    Expect(0, 8536, '\P{^Nv=0.6}', "");
    Expect(1, 8535, '\p{Nv=6.00e-01}', "");
    Expect(0, 8535, '\p{^Nv=6.00e-01}', "");
    Expect(0, 8535, '\P{Nv=6.00e-01}', "");
    Expect(1, 8535, '\P{^Nv=6.00e-01}', "");
    Expect(0, 8536, '\p{Nv=6.00e-01}', "");
    Expect(1, 8536, '\p{^Nv=6.00e-01}', "");
    Expect(1, 8536, '\P{Nv=6.00e-01}', "");
    Expect(0, 8536, '\P{^Nv=6.00e-01}', "");
    Expect(1, 8535, '\p{Nv=0.60}', "");
    Expect(0, 8535, '\p{^Nv=0.60}', "");
    Expect(0, 8535, '\P{Nv=0.60}', "");
    Expect(1, 8535, '\P{^Nv=0.60}', "");
    Expect(0, 8536, '\p{Nv=0.60}', "");
    Expect(1, 8536, '\p{^Nv=0.60}', "");
    Expect(1, 8536, '\P{Nv=0.60}', "");
    Expect(0, 8536, '\P{^Nv=0.60}', "");
    Error('\p{Is_Numeric_Value=- +003/00000005:=}');
    Error('\P{Is_Numeric_Value=- +003/00000005:=}');
    Expect(1, 8535, '\p{Is_Numeric_Value=0000003/05}', "");
    Expect(0, 8535, '\p{^Is_Numeric_Value=0000003/05}', "");
    Expect(0, 8535, '\P{Is_Numeric_Value=0000003/05}', "");
    Expect(1, 8535, '\P{^Is_Numeric_Value=0000003/05}', "");
    Expect(0, 8536, '\p{Is_Numeric_Value=0000003/05}', "");
    Expect(1, 8536, '\p{^Is_Numeric_Value=0000003/05}', "");
    Expect(1, 8536, '\P{Is_Numeric_Value=0000003/05}', "");
    Expect(0, 8536, '\P{^Is_Numeric_Value=0000003/05}', "");
    Expect(1, 8535, '\p{Is_Numeric_Value: 180/300}', "");
    Expect(0, 8535, '\p{^Is_Numeric_Value: 180/300}', "");
    Expect(0, 8535, '\P{Is_Numeric_Value: 180/300}', "");
    Expect(1, 8535, '\P{^Is_Numeric_Value: 180/300}', "");
    Expect(0, 8536, '\p{Is_Numeric_Value: 180/300}', "");
    Expect(1, 8536, '\p{^Is_Numeric_Value: 180/300}', "");
    Expect(1, 8536, '\P{Is_Numeric_Value: 180/300}', "");
    Expect(0, 8536, '\P{^Is_Numeric_Value: 180/300}', "");
    Expect(1, 8535, '\p{Is_Numeric_Value=6.0e-01}', "");
    Expect(0, 8535, '\p{^Is_Numeric_Value=6.0e-01}', "");
    Expect(0, 8535, '\P{Is_Numeric_Value=6.0e-01}', "");
    Expect(1, 8535, '\P{^Is_Numeric_Value=6.0e-01}', "");
    Expect(0, 8536, '\p{Is_Numeric_Value=6.0e-01}', "");
    Expect(1, 8536, '\p{^Is_Numeric_Value=6.0e-01}', "");
    Expect(1, 8536, '\P{Is_Numeric_Value=6.0e-01}', "");
    Expect(0, 8536, '\P{^Is_Numeric_Value=6.0e-01}', "");
    Expect(1, 8535, '\p{Is_Numeric_Value=0.6}', "");
    Expect(0, 8535, '\p{^Is_Numeric_Value=0.6}', "");
    Expect(0, 8535, '\P{Is_Numeric_Value=0.6}', "");
    Expect(1, 8535, '\P{^Is_Numeric_Value=0.6}', "");
    Expect(0, 8536, '\p{Is_Numeric_Value=0.6}', "");
    Expect(1, 8536, '\p{^Is_Numeric_Value=0.6}', "");
    Expect(1, 8536, '\P{Is_Numeric_Value=0.6}', "");
    Expect(0, 8536, '\P{^Is_Numeric_Value=0.6}', "");
    Expect(1, 8535, '\p{Is_Numeric_Value=6.00e-01}', "");
    Expect(0, 8535, '\p{^Is_Numeric_Value=6.00e-01}', "");
    Expect(0, 8535, '\P{Is_Numeric_Value=6.00e-01}', "");
    Expect(1, 8535, '\P{^Is_Numeric_Value=6.00e-01}', "");
    Expect(0, 8536, '\p{Is_Numeric_Value=6.00e-01}', "");
    Expect(1, 8536, '\p{^Is_Numeric_Value=6.00e-01}', "");
    Expect(1, 8536, '\P{Is_Numeric_Value=6.00e-01}', "");
    Expect(0, 8536, '\P{^Is_Numeric_Value=6.00e-01}', "");
    Expect(1, 8535, '\p{Is_Numeric_Value=0.60}', "");
    Expect(0, 8535, '\p{^Is_Numeric_Value=0.60}', "");
    Expect(0, 8535, '\P{Is_Numeric_Value=0.60}', "");
    Expect(1, 8535, '\P{^Is_Numeric_Value=0.60}', "");
    Expect(0, 8536, '\p{Is_Numeric_Value=0.60}', "");
    Expect(1, 8536, '\p{^Is_Numeric_Value=0.60}', "");
    Expect(1, 8536, '\P{Is_Numeric_Value=0.60}', "");
    Expect(0, 8536, '\P{^Is_Numeric_Value=0.60}', "");
    Error('\p{Is_Nv:	 _+0000000003/005:=}');
    Error('\P{Is_Nv:	 _+0000000003/005:=}');
    Expect(1, 8535, '\p{Is_Nv=003/005}', "");
    Expect(0, 8535, '\p{^Is_Nv=003/005}', "");
    Expect(0, 8535, '\P{Is_Nv=003/005}', "");
    Expect(1, 8535, '\P{^Is_Nv=003/005}', "");
    Expect(0, 8536, '\p{Is_Nv=003/005}', "");
    Expect(1, 8536, '\p{^Is_Nv=003/005}', "");
    Expect(1, 8536, '\P{Is_Nv=003/005}', "");
    Expect(0, 8536, '\P{^Is_Nv=003/005}', "");
    Expect(1, 8535, '\p{Is_Nv=180/300}', "");
    Expect(0, 8535, '\p{^Is_Nv=180/300}', "");
    Expect(0, 8535, '\P{Is_Nv=180/300}', "");
    Expect(1, 8535, '\P{^Is_Nv=180/300}', "");
    Expect(0, 8536, '\p{Is_Nv=180/300}', "");
    Expect(1, 8536, '\p{^Is_Nv=180/300}', "");
    Expect(1, 8536, '\P{Is_Nv=180/300}', "");
    Expect(0, 8536, '\P{^Is_Nv=180/300}', "");
    Expect(1, 8535, '\p{Is_Nv=6.0e-01}', "");
    Expect(0, 8535, '\p{^Is_Nv=6.0e-01}', "");
    Expect(0, 8535, '\P{Is_Nv=6.0e-01}', "");
    Expect(1, 8535, '\P{^Is_Nv=6.0e-01}', "");
    Expect(0, 8536, '\p{Is_Nv=6.0e-01}', "");
    Expect(1, 8536, '\p{^Is_Nv=6.0e-01}', "");
    Expect(1, 8536, '\P{Is_Nv=6.0e-01}', "");
    Expect(0, 8536, '\P{^Is_Nv=6.0e-01}', "");
    Expect(1, 8535, '\p{Is_Nv=0.6}', "");
    Expect(0, 8535, '\p{^Is_Nv=0.6}', "");
    Expect(0, 8535, '\P{Is_Nv=0.6}', "");
    Expect(1, 8535, '\P{^Is_Nv=0.6}', "");
    Expect(0, 8536, '\p{Is_Nv=0.6}', "");
    Expect(1, 8536, '\p{^Is_Nv=0.6}', "");
    Expect(1, 8536, '\P{Is_Nv=0.6}', "");
    Expect(0, 8536, '\P{^Is_Nv=0.6}', "");
    Expect(1, 8535, '\p{Is_Nv:   6.00e-01}', "");
    Expect(0, 8535, '\p{^Is_Nv:   6.00e-01}', "");
    Expect(0, 8535, '\P{Is_Nv:   6.00e-01}', "");
    Expect(1, 8535, '\P{^Is_Nv:   6.00e-01}', "");
    Expect(0, 8536, '\p{Is_Nv:   6.00e-01}', "");
    Expect(1, 8536, '\p{^Is_Nv:   6.00e-01}', "");
    Expect(1, 8536, '\P{Is_Nv:   6.00e-01}', "");
    Expect(0, 8536, '\P{^Is_Nv:   6.00e-01}', "");
    Expect(1, 8535, '\p{Is_Nv=0.60}', "");
    Expect(0, 8535, '\p{^Is_Nv=0.60}', "");
    Expect(0, 8535, '\P{Is_Nv=0.60}', "");
    Expect(1, 8535, '\P{^Is_Nv=0.60}', "");
    Expect(0, 8536, '\p{Is_Nv=0.60}', "");
    Expect(1, 8536, '\p{^Is_Nv=0.60}', "");
    Expect(1, 8536, '\P{Is_Nv=0.60}', "");
    Expect(0, 8536, '\P{^Is_Nv=0.60}', "");
    Error('\p{Numeric_Value=	-003/0000064:=}');
    Error('\P{Numeric_Value=	-003/0000064:=}');
    Expect(1, 73671, '\p{Numeric_Value=:\A3/64\z:}', "");;
    Expect(0, 73672, '\p{Numeric_Value=:\A3/64\z:}', "");;
    Expect(1, 73671, '\p{Numeric_Value=+0000000003/000000064}', "");
    Expect(0, 73671, '\p{^Numeric_Value=+0000000003/000000064}', "");
    Expect(0, 73671, '\P{Numeric_Value=+0000000003/000000064}', "");
    Expect(1, 73671, '\P{^Numeric_Value=+0000000003/000000064}', "");
    Expect(0, 73672, '\p{Numeric_Value=+0000000003/000000064}', "");
    Expect(1, 73672, '\p{^Numeric_Value=+0000000003/000000064}', "");
    Expect(1, 73672, '\P{Numeric_Value=+0000000003/000000064}', "");
    Expect(0, 73672, '\P{^Numeric_Value=+0000000003/000000064}', "");
    Expect(1, 73671, '\p{Numeric_Value=180/3840}', "");
    Expect(0, 73671, '\p{^Numeric_Value=180/3840}', "");
    Expect(0, 73671, '\P{Numeric_Value=180/3840}', "");
    Expect(1, 73671, '\P{^Numeric_Value=180/3840}', "");
    Expect(0, 73672, '\p{Numeric_Value=180/3840}', "");
    Expect(1, 73672, '\p{^Numeric_Value=180/3840}', "");
    Expect(1, 73672, '\P{Numeric_Value=180/3840}', "");
    Expect(0, 73672, '\P{^Numeric_Value=180/3840}', "");
    Error('\p{Numeric_Value: 4.7e-02}');
    Error('\P{Numeric_Value: 4.7e-02}');
    Expect(1, 73671, '\p{Numeric_Value=4.69e-02}', "");
    Expect(0, 73671, '\p{^Numeric_Value=4.69e-02}', "");
    Expect(0, 73671, '\P{Numeric_Value=4.69e-02}', "");
    Expect(1, 73671, '\P{^Numeric_Value=4.69e-02}', "");
    Expect(0, 73672, '\p{Numeric_Value=4.69e-02}', "");
    Expect(1, 73672, '\p{^Numeric_Value=4.69e-02}', "");
    Expect(1, 73672, '\P{Numeric_Value=4.69e-02}', "");
    Expect(0, 73672, '\P{^Numeric_Value=4.69e-02}', "");
    Expect(1, 73671, '\p{Numeric_Value=4.688e-02}', "");
    Expect(0, 73671, '\p{^Numeric_Value=4.688e-02}', "");
    Expect(0, 73671, '\P{Numeric_Value=4.688e-02}', "");
    Expect(1, 73671, '\P{^Numeric_Value=4.688e-02}', "");
    Expect(0, 73672, '\p{Numeric_Value=4.688e-02}', "");
    Expect(1, 73672, '\p{^Numeric_Value=4.688e-02}', "");
    Expect(1, 73672, '\P{Numeric_Value=4.688e-02}', "");
    Expect(0, 73672, '\P{^Numeric_Value=4.688e-02}', "");
    Error('\p{Numeric_Value=0.047}');
    Error('\P{Numeric_Value=0.047}');
    Expect(1, 73671, '\p{Numeric_Value=4.6875e-02}', "");
    Expect(0, 73671, '\p{^Numeric_Value=4.6875e-02}', "");
    Expect(0, 73671, '\P{Numeric_Value=4.6875e-02}', "");
    Expect(1, 73671, '\P{^Numeric_Value=4.6875e-02}', "");
    Expect(0, 73672, '\p{Numeric_Value=4.6875e-02}', "");
    Expect(1, 73672, '\p{^Numeric_Value=4.6875e-02}', "");
    Expect(1, 73672, '\P{Numeric_Value=4.6875e-02}', "");
    Expect(0, 73672, '\P{^Numeric_Value=4.6875e-02}', "");
    Expect(1, 73671, '\p{Numeric_Value=0.0469}', "");
    Expect(0, 73671, '\p{^Numeric_Value=0.0469}', "");
    Expect(0, 73671, '\P{Numeric_Value=0.0469}', "");
    Expect(1, 73671, '\P{^Numeric_Value=0.0469}', "");
    Expect(0, 73672, '\p{Numeric_Value=0.0469}', "");
    Expect(1, 73672, '\p{^Numeric_Value=0.0469}', "");
    Expect(1, 73672, '\P{Numeric_Value=0.0469}', "");
    Expect(0, 73672, '\P{^Numeric_Value=0.0469}', "");
    Expect(1, 73671, '\p{Numeric_Value:	4.68750e-02}', "");
    Expect(0, 73671, '\p{^Numeric_Value:	4.68750e-02}', "");
    Expect(0, 73671, '\P{Numeric_Value:	4.68750e-02}', "");
    Expect(1, 73671, '\P{^Numeric_Value:	4.68750e-02}', "");
    Expect(0, 73672, '\p{Numeric_Value:	4.68750e-02}', "");
    Expect(1, 73672, '\p{^Numeric_Value:	4.68750e-02}', "");
    Expect(1, 73672, '\P{Numeric_Value:	4.68750e-02}', "");
    Expect(0, 73672, '\P{^Numeric_Value:	4.68750e-02}', "");
    Expect(1, 73671, '\p{Numeric_Value=0.04688}', "");
    Expect(0, 73671, '\p{^Numeric_Value=0.04688}', "");
    Expect(0, 73671, '\P{Numeric_Value=0.04688}', "");
    Expect(1, 73671, '\P{^Numeric_Value=0.04688}', "");
    Expect(0, 73672, '\p{Numeric_Value=0.04688}', "");
    Expect(1, 73672, '\p{^Numeric_Value=0.04688}', "");
    Expect(1, 73672, '\P{Numeric_Value=0.04688}', "");
    Expect(0, 73672, '\P{^Numeric_Value=0.04688}', "");
    Error('\p{Nv=	-0000000003/000064/a/}');
    Error('\P{Nv=	-0000000003/000064/a/}');
    Expect(1, 73671, '\p{Nv=:\A3/64\z:}', "");;
    Expect(0, 73672, '\p{Nv=:\A3/64\z:}', "");;
    Expect(1, 73671, '\p{Nv=00003/0000000064}', "");
    Expect(0, 73671, '\p{^Nv=00003/0000000064}', "");
    Expect(0, 73671, '\P{Nv=00003/0000000064}', "");
    Expect(1, 73671, '\P{^Nv=00003/0000000064}', "");
    Expect(0, 73672, '\p{Nv=00003/0000000064}', "");
    Expect(1, 73672, '\p{^Nv=00003/0000000064}', "");
    Expect(1, 73672, '\P{Nv=00003/0000000064}', "");
    Expect(0, 73672, '\P{^Nv=00003/0000000064}', "");
    Expect(1, 73671, '\p{Nv=180/3840}', "");
    Expect(0, 73671, '\p{^Nv=180/3840}', "");
    Expect(0, 73671, '\P{Nv=180/3840}', "");
    Expect(1, 73671, '\P{^Nv=180/3840}', "");
    Expect(0, 73672, '\p{Nv=180/3840}', "");
    Expect(1, 73672, '\p{^Nv=180/3840}', "");
    Expect(1, 73672, '\P{Nv=180/3840}', "");
    Expect(0, 73672, '\P{^Nv=180/3840}', "");
    Error('\p{Nv=4.7e-02}');
    Error('\P{Nv=4.7e-02}');
    Expect(1, 73671, '\p{Nv: 4.69e-02}', "");
    Expect(0, 73671, '\p{^Nv: 4.69e-02}', "");
    Expect(0, 73671, '\P{Nv: 4.69e-02}', "");
    Expect(1, 73671, '\P{^Nv: 4.69e-02}', "");
    Expect(0, 73672, '\p{Nv: 4.69e-02}', "");
    Expect(1, 73672, '\p{^Nv: 4.69e-02}', "");
    Expect(1, 73672, '\P{Nv: 4.69e-02}', "");
    Expect(0, 73672, '\P{^Nv: 4.69e-02}', "");
    Expect(1, 73671, '\p{Nv=4.688e-02}', "");
    Expect(0, 73671, '\p{^Nv=4.688e-02}', "");
    Expect(0, 73671, '\P{Nv=4.688e-02}', "");
    Expect(1, 73671, '\P{^Nv=4.688e-02}', "");
    Expect(0, 73672, '\p{Nv=4.688e-02}', "");
    Expect(1, 73672, '\p{^Nv=4.688e-02}', "");
    Expect(1, 73672, '\P{Nv=4.688e-02}', "");
    Expect(0, 73672, '\P{^Nv=4.688e-02}', "");
    Error('\p{Nv=0.047}');
    Error('\P{Nv=0.047}');
    Expect(1, 73671, '\p{Nv=4.6875e-02}', "");
    Expect(0, 73671, '\p{^Nv=4.6875e-02}', "");
    Expect(0, 73671, '\P{Nv=4.6875e-02}', "");
    Expect(1, 73671, '\P{^Nv=4.6875e-02}', "");
    Expect(0, 73672, '\p{Nv=4.6875e-02}', "");
    Expect(1, 73672, '\p{^Nv=4.6875e-02}', "");
    Expect(1, 73672, '\P{Nv=4.6875e-02}', "");
    Expect(0, 73672, '\P{^Nv=4.6875e-02}', "");
    Expect(1, 73671, '\p{Nv:0.0469}', "");
    Expect(0, 73671, '\p{^Nv:0.0469}', "");
    Expect(0, 73671, '\P{Nv:0.0469}', "");
    Expect(1, 73671, '\P{^Nv:0.0469}', "");
    Expect(0, 73672, '\p{Nv:0.0469}', "");
    Expect(1, 73672, '\p{^Nv:0.0469}', "");
    Expect(1, 73672, '\P{Nv:0.0469}', "");
    Expect(0, 73672, '\P{^Nv:0.0469}', "");
    Expect(1, 73671, '\p{Nv=4.68750e-02}', "");
    Expect(0, 73671, '\p{^Nv=4.68750e-02}', "");
    Expect(0, 73671, '\P{Nv=4.68750e-02}', "");
    Expect(1, 73671, '\P{^Nv=4.68750e-02}', "");
    Expect(0, 73672, '\p{Nv=4.68750e-02}', "");
    Expect(1, 73672, '\p{^Nv=4.68750e-02}', "");
    Expect(1, 73672, '\P{Nv=4.68750e-02}', "");
    Expect(0, 73672, '\P{^Nv=4.68750e-02}', "");
    Expect(1, 73671, '\p{Nv=0.04688}', "");
    Expect(0, 73671, '\p{^Nv=0.04688}', "");
    Expect(0, 73671, '\P{Nv=0.04688}', "");
    Expect(1, 73671, '\P{^Nv=0.04688}', "");
    Expect(0, 73672, '\p{Nv=0.04688}', "");
    Expect(1, 73672, '\p{^Nv=0.04688}', "");
    Expect(1, 73672, '\P{Nv=0.04688}', "");
    Expect(0, 73672, '\P{^Nv=0.04688}', "");
    Error('\p{Is_Numeric_Value:	/a/+00003/064}');
    Error('\P{Is_Numeric_Value:	/a/+00003/064}');
    Expect(1, 73671, '\p{Is_Numeric_Value=0000003/00064}', "");
    Expect(0, 73671, '\p{^Is_Numeric_Value=0000003/00064}', "");
    Expect(0, 73671, '\P{Is_Numeric_Value=0000003/00064}', "");
    Expect(1, 73671, '\P{^Is_Numeric_Value=0000003/00064}', "");
    Expect(0, 73672, '\p{Is_Numeric_Value=0000003/00064}', "");
    Expect(1, 73672, '\p{^Is_Numeric_Value=0000003/00064}', "");
    Expect(1, 73672, '\P{Is_Numeric_Value=0000003/00064}', "");
    Expect(0, 73672, '\P{^Is_Numeric_Value=0000003/00064}', "");
    Expect(1, 73671, '\p{Is_Numeric_Value=180/3840}', "");
    Expect(0, 73671, '\p{^Is_Numeric_Value=180/3840}', "");
    Expect(0, 73671, '\P{Is_Numeric_Value=180/3840}', "");
    Expect(1, 73671, '\P{^Is_Numeric_Value=180/3840}', "");
    Expect(0, 73672, '\p{Is_Numeric_Value=180/3840}', "");
    Expect(1, 73672, '\p{^Is_Numeric_Value=180/3840}', "");
    Expect(1, 73672, '\P{Is_Numeric_Value=180/3840}', "");
    Expect(0, 73672, '\P{^Is_Numeric_Value=180/3840}', "");
    Error('\p{Is_Numeric_Value: 4.7e-02}');
    Error('\P{Is_Numeric_Value: 4.7e-02}');
    Expect(1, 73671, '\p{Is_Numeric_Value=4.69e-02}', "");
    Expect(0, 73671, '\p{^Is_Numeric_Value=4.69e-02}', "");
    Expect(0, 73671, '\P{Is_Numeric_Value=4.69e-02}', "");
    Expect(1, 73671, '\P{^Is_Numeric_Value=4.69e-02}', "");
    Expect(0, 73672, '\p{Is_Numeric_Value=4.69e-02}', "");
    Expect(1, 73672, '\p{^Is_Numeric_Value=4.69e-02}', "");
    Expect(1, 73672, '\P{Is_Numeric_Value=4.69e-02}', "");
    Expect(0, 73672, '\P{^Is_Numeric_Value=4.69e-02}', "");
    Expect(1, 73671, '\p{Is_Numeric_Value:	4.688e-02}', "");
    Expect(0, 73671, '\p{^Is_Numeric_Value:	4.688e-02}', "");
    Expect(0, 73671, '\P{Is_Numeric_Value:	4.688e-02}', "");
    Expect(1, 73671, '\P{^Is_Numeric_Value:	4.688e-02}', "");
    Expect(0, 73672, '\p{Is_Numeric_Value:	4.688e-02}', "");
    Expect(1, 73672, '\p{^Is_Numeric_Value:	4.688e-02}', "");
    Expect(1, 73672, '\P{Is_Numeric_Value:	4.688e-02}', "");
    Expect(0, 73672, '\P{^Is_Numeric_Value:	4.688e-02}', "");
    Error('\p{Is_Numeric_Value: 0.047}');
    Error('\P{Is_Numeric_Value: 0.047}');
    Expect(1, 73671, '\p{Is_Numeric_Value:   4.6875e-02}', "");
    Expect(0, 73671, '\p{^Is_Numeric_Value:   4.6875e-02}', "");
    Expect(0, 73671, '\P{Is_Numeric_Value:   4.6875e-02}', "");
    Expect(1, 73671, '\P{^Is_Numeric_Value:   4.6875e-02}', "");
    Expect(0, 73672, '\p{Is_Numeric_Value:   4.6875e-02}', "");
    Expect(1, 73672, '\p{^Is_Numeric_Value:   4.6875e-02}', "");
    Expect(1, 73672, '\P{Is_Numeric_Value:   4.6875e-02}', "");
    Expect(0, 73672, '\P{^Is_Numeric_Value:   4.6875e-02}', "");
    Expect(1, 73671, '\p{Is_Numeric_Value=0.0469}', "");
    Expect(0, 73671, '\p{^Is_Numeric_Value=0.0469}', "");
    Expect(0, 73671, '\P{Is_Numeric_Value=0.0469}', "");
    Expect(1, 73671, '\P{^Is_Numeric_Value=0.0469}', "");
    Expect(0, 73672, '\p{Is_Numeric_Value=0.0469}', "");
    Expect(1, 73672, '\p{^Is_Numeric_Value=0.0469}', "");
    Expect(1, 73672, '\P{Is_Numeric_Value=0.0469}', "");
    Expect(0, 73672, '\P{^Is_Numeric_Value=0.0469}', "");
    Expect(1, 73671, '\p{Is_Numeric_Value=4.68750e-02}', "");
    Expect(0, 73671, '\p{^Is_Numeric_Value=4.68750e-02}', "");
    Expect(0, 73671, '\P{Is_Numeric_Value=4.68750e-02}', "");
    Expect(1, 73671, '\P{^Is_Numeric_Value=4.68750e-02}', "");
    Expect(0, 73672, '\p{Is_Numeric_Value=4.68750e-02}', "");
    Expect(1, 73672, '\p{^Is_Numeric_Value=4.68750e-02}', "");
    Expect(1, 73672, '\P{Is_Numeric_Value=4.68750e-02}', "");
    Expect(0, 73672, '\P{^Is_Numeric_Value=4.68750e-02}', "");
    Expect(1, 73671, '\p{Is_Numeric_Value=0.04688}', "");
    Expect(0, 73671, '\p{^Is_Numeric_Value=0.04688}', "");
    Expect(0, 73671, '\P{Is_Numeric_Value=0.04688}', "");
    Expect(1, 73671, '\P{^Is_Numeric_Value=0.04688}', "");
    Expect(0, 73672, '\p{Is_Numeric_Value=0.04688}', "");
    Expect(1, 73672, '\p{^Is_Numeric_Value=0.04688}', "");
    Expect(1, 73672, '\P{Is_Numeric_Value=0.04688}', "");
    Expect(0, 73672, '\P{^Is_Numeric_Value=0.04688}', "");
    Error('\p{Is_Nv=003/00000064/a/}');
    Error('\P{Is_Nv=003/00000064/a/}');
    Expect(1, 73671, '\p{Is_Nv=+03/00000000064}', "");
    Expect(0, 73671, '\p{^Is_Nv=+03/00000000064}', "");
    Expect(0, 73671, '\P{Is_Nv=+03/00000000064}', "");
    Expect(1, 73671, '\P{^Is_Nv=+03/00000000064}', "");
    Expect(0, 73672, '\p{Is_Nv=+03/00000000064}', "");
    Expect(1, 73672, '\p{^Is_Nv=+03/00000000064}', "");
    Expect(1, 73672, '\P{Is_Nv=+03/00000000064}', "");
    Expect(0, 73672, '\P{^Is_Nv=+03/00000000064}', "");
    Expect(1, 73671, '\p{Is_Nv=180/3840}', "");
    Expect(0, 73671, '\p{^Is_Nv=180/3840}', "");
    Expect(0, 73671, '\P{Is_Nv=180/3840}', "");
    Expect(1, 73671, '\P{^Is_Nv=180/3840}', "");
    Expect(0, 73672, '\p{Is_Nv=180/3840}', "");
    Expect(1, 73672, '\p{^Is_Nv=180/3840}', "");
    Expect(1, 73672, '\P{Is_Nv=180/3840}', "");
    Expect(0, 73672, '\P{^Is_Nv=180/3840}', "");
    Error('\p{Is_Nv:	4.7e-02}');
    Error('\P{Is_Nv:	4.7e-02}');
    Expect(1, 73671, '\p{Is_Nv=4.69e-02}', "");
    Expect(0, 73671, '\p{^Is_Nv=4.69e-02}', "");
    Expect(0, 73671, '\P{Is_Nv=4.69e-02}', "");
    Expect(1, 73671, '\P{^Is_Nv=4.69e-02}', "");
    Expect(0, 73672, '\p{Is_Nv=4.69e-02}', "");
    Expect(1, 73672, '\p{^Is_Nv=4.69e-02}', "");
    Expect(1, 73672, '\P{Is_Nv=4.69e-02}', "");
    Expect(0, 73672, '\P{^Is_Nv=4.69e-02}', "");
    Expect(1, 73671, '\p{Is_Nv:   4.688e-02}', "");
    Expect(0, 73671, '\p{^Is_Nv:   4.688e-02}', "");
    Expect(0, 73671, '\P{Is_Nv:   4.688e-02}', "");
    Expect(1, 73671, '\P{^Is_Nv:   4.688e-02}', "");
    Expect(0, 73672, '\p{Is_Nv:   4.688e-02}', "");
    Expect(1, 73672, '\p{^Is_Nv:   4.688e-02}', "");
    Expect(1, 73672, '\P{Is_Nv:   4.688e-02}', "");
    Expect(0, 73672, '\P{^Is_Nv:   4.688e-02}', "");
    Error('\p{Is_Nv=0.047}');
    Error('\P{Is_Nv=0.047}');
    Expect(1, 73671, '\p{Is_Nv=4.6875e-02}', "");
    Expect(0, 73671, '\p{^Is_Nv=4.6875e-02}', "");
    Expect(0, 73671, '\P{Is_Nv=4.6875e-02}', "");
    Expect(1, 73671, '\P{^Is_Nv=4.6875e-02}', "");
    Expect(0, 73672, '\p{Is_Nv=4.6875e-02}', "");
    Expect(1, 73672, '\p{^Is_Nv=4.6875e-02}', "");
    Expect(1, 73672, '\P{Is_Nv=4.6875e-02}', "");
    Expect(0, 73672, '\P{^Is_Nv=4.6875e-02}', "");
    Expect(1, 73671, '\p{Is_Nv=0.0469}', "");
    Expect(0, 73671, '\p{^Is_Nv=0.0469}', "");
    Expect(0, 73671, '\P{Is_Nv=0.0469}', "");
    Expect(1, 73671, '\P{^Is_Nv=0.0469}', "");
    Expect(0, 73672, '\p{Is_Nv=0.0469}', "");
    Expect(1, 73672, '\p{^Is_Nv=0.0469}', "");
    Expect(1, 73672, '\P{Is_Nv=0.0469}', "");
    Expect(0, 73672, '\P{^Is_Nv=0.0469}', "");
    Expect(1, 73671, '\p{Is_Nv=4.68750e-02}', "");
    Expect(0, 73671, '\p{^Is_Nv=4.68750e-02}', "");
    Expect(0, 73671, '\P{Is_Nv=4.68750e-02}', "");
    Expect(1, 73671, '\P{^Is_Nv=4.68750e-02}', "");
    Expect(0, 73672, '\p{Is_Nv=4.68750e-02}', "");
    Expect(1, 73672, '\p{^Is_Nv=4.68750e-02}', "");
    Expect(1, 73672, '\P{Is_Nv=4.68750e-02}', "");
    Expect(0, 73672, '\P{^Is_Nv=4.68750e-02}', "");
    Expect(1, 73671, '\p{Is_Nv=0.04688}', "");
    Expect(0, 73671, '\p{^Is_Nv=0.04688}', "");
    Expect(0, 73671, '\P{Is_Nv=0.04688}', "");
    Expect(1, 73671, '\P{^Is_Nv=0.04688}', "");
    Expect(0, 73672, '\p{Is_Nv=0.04688}', "");
    Expect(1, 73672, '\p{^Is_Nv=0.04688}', "");
    Expect(1, 73672, '\P{Is_Nv=0.04688}', "");
    Expect(0, 73672, '\P{^Is_Nv=0.04688}', "");
    Error('\p{Numeric_Value:   /a/-	0000000003/00000008}');
    Error('\P{Numeric_Value:   /a/-	0000000003/00000008}');
    Expect(1, 8540, '\p{Numeric_Value=:\A3/8\z:}', "");;
    Expect(0, 8541, '\p{Numeric_Value=:\A3/8\z:}', "");;
    Expect(1, 8540, '\p{Numeric_Value:	00003/000000008}', "");
    Expect(0, 8540, '\p{^Numeric_Value:	00003/000000008}', "");
    Expect(0, 8540, '\P{Numeric_Value:	00003/000000008}', "");
    Expect(1, 8540, '\P{^Numeric_Value:	00003/000000008}', "");
    Expect(0, 8541, '\p{Numeric_Value:	00003/000000008}', "");
    Expect(1, 8541, '\p{^Numeric_Value:	00003/000000008}', "");
    Expect(1, 8541, '\P{Numeric_Value:	00003/000000008}', "");
    Expect(0, 8541, '\P{^Numeric_Value:	00003/000000008}', "");
    Expect(1, 8540, '\p{Numeric_Value=180/480}', "");
    Expect(0, 8540, '\p{^Numeric_Value=180/480}', "");
    Expect(0, 8540, '\P{Numeric_Value=180/480}', "");
    Expect(1, 8540, '\P{^Numeric_Value=180/480}', "");
    Expect(0, 8541, '\p{Numeric_Value=180/480}', "");
    Expect(1, 8541, '\p{^Numeric_Value=180/480}', "");
    Expect(1, 8541, '\P{Numeric_Value=180/480}', "");
    Expect(0, 8541, '\P{^Numeric_Value=180/480}', "");
    Error('\p{Numeric_Value=3.8e-01}');
    Error('\P{Numeric_Value=3.8e-01}');
    Expect(1, 8540, '\p{Numeric_Value=3.75e-01}', "");
    Expect(0, 8540, '\p{^Numeric_Value=3.75e-01}', "");
    Expect(0, 8540, '\P{Numeric_Value=3.75e-01}', "");
    Expect(1, 8540, '\P{^Numeric_Value=3.75e-01}', "");
    Expect(0, 8541, '\p{Numeric_Value=3.75e-01}', "");
    Expect(1, 8541, '\p{^Numeric_Value=3.75e-01}', "");
    Expect(1, 8541, '\P{Numeric_Value=3.75e-01}', "");
    Expect(0, 8541, '\P{^Numeric_Value=3.75e-01}', "");
    Error('\p{Numeric_Value=0.38}');
    Error('\P{Numeric_Value=0.38}');
    Expect(1, 8540, '\p{Numeric_Value=3.750e-01}', "");
    Expect(0, 8540, '\p{^Numeric_Value=3.750e-01}', "");
    Expect(0, 8540, '\P{Numeric_Value=3.750e-01}', "");
    Expect(1, 8540, '\P{^Numeric_Value=3.750e-01}', "");
    Expect(0, 8541, '\p{Numeric_Value=3.750e-01}', "");
    Expect(1, 8541, '\p{^Numeric_Value=3.750e-01}', "");
    Expect(1, 8541, '\P{Numeric_Value=3.750e-01}', "");
    Expect(0, 8541, '\P{^Numeric_Value=3.750e-01}', "");
    Expect(1, 8540, '\p{Numeric_Value=0.375}', "");
    Expect(0, 8540, '\p{^Numeric_Value=0.375}', "");
    Expect(0, 8540, '\P{Numeric_Value=0.375}', "");
    Expect(1, 8540, '\P{^Numeric_Value=0.375}', "");
    Expect(0, 8541, '\p{Numeric_Value=0.375}', "");
    Expect(1, 8541, '\p{^Numeric_Value=0.375}', "");
    Expect(1, 8541, '\P{Numeric_Value=0.375}', "");
    Expect(0, 8541, '\P{^Numeric_Value=0.375}', "");
    Expect(1, 8540, '\p{Numeric_Value=3.7500e-01}', "");
    Expect(0, 8540, '\p{^Numeric_Value=3.7500e-01}', "");
    Expect(0, 8540, '\P{Numeric_Value=3.7500e-01}', "");
    Expect(1, 8540, '\P{^Numeric_Value=3.7500e-01}', "");
    Expect(0, 8541, '\p{Numeric_Value=3.7500e-01}', "");
    Expect(1, 8541, '\p{^Numeric_Value=3.7500e-01}', "");
    Expect(1, 8541, '\P{Numeric_Value=3.7500e-01}', "");
    Expect(0, 8541, '\P{^Numeric_Value=3.7500e-01}', "");
    Expect(1, 8540, '\p{Numeric_Value:   0.3750}', "");
    Expect(0, 8540, '\p{^Numeric_Value:   0.3750}', "");
    Expect(0, 8540, '\P{Numeric_Value:   0.3750}', "");
    Expect(1, 8540, '\P{^Numeric_Value:   0.3750}', "");
    Expect(0, 8541, '\p{Numeric_Value:   0.3750}', "");
    Expect(1, 8541, '\p{^Numeric_Value:   0.3750}', "");
    Expect(1, 8541, '\P{Numeric_Value:   0.3750}', "");
    Expect(0, 8541, '\P{^Numeric_Value:   0.3750}', "");
    Error('\p{Nv=:=-003/8}');
    Error('\P{Nv=:=-003/8}');
    Expect(1, 8540, '\p{Nv=:\A3/8\z:}', "");;
    Expect(0, 8541, '\p{Nv=:\A3/8\z:}', "");;
    Expect(1, 8540, '\p{Nv=+000003/8}', "");
    Expect(0, 8540, '\p{^Nv=+000003/8}', "");
    Expect(0, 8540, '\P{Nv=+000003/8}', "");
    Expect(1, 8540, '\P{^Nv=+000003/8}', "");
    Expect(0, 8541, '\p{Nv=+000003/8}', "");
    Expect(1, 8541, '\p{^Nv=+000003/8}', "");
    Expect(1, 8541, '\P{Nv=+000003/8}', "");
    Expect(0, 8541, '\P{^Nv=+000003/8}', "");
    Expect(1, 8540, '\p{Nv=180/480}', "");
    Expect(0, 8540, '\p{^Nv=180/480}', "");
    Expect(0, 8540, '\P{Nv=180/480}', "");
    Expect(1, 8540, '\P{^Nv=180/480}', "");
    Expect(0, 8541, '\p{Nv=180/480}', "");
    Expect(1, 8541, '\p{^Nv=180/480}', "");
    Expect(1, 8541, '\P{Nv=180/480}', "");
    Expect(0, 8541, '\P{^Nv=180/480}', "");
    Error('\p{Nv=3.8e-01}');
    Error('\P{Nv=3.8e-01}');
    Expect(1, 8540, '\p{Nv=3.75e-01}', "");
    Expect(0, 8540, '\p{^Nv=3.75e-01}', "");
    Expect(0, 8540, '\P{Nv=3.75e-01}', "");
    Expect(1, 8540, '\P{^Nv=3.75e-01}', "");
    Expect(0, 8541, '\p{Nv=3.75e-01}', "");
    Expect(1, 8541, '\p{^Nv=3.75e-01}', "");
    Expect(1, 8541, '\P{Nv=3.75e-01}', "");
    Expect(0, 8541, '\P{^Nv=3.75e-01}', "");
    Error('\p{Nv=0.38}');
    Error('\P{Nv=0.38}');
    Expect(1, 8540, '\p{Nv=3.750e-01}', "");
    Expect(0, 8540, '\p{^Nv=3.750e-01}', "");
    Expect(0, 8540, '\P{Nv=3.750e-01}', "");
    Expect(1, 8540, '\P{^Nv=3.750e-01}', "");
    Expect(0, 8541, '\p{Nv=3.750e-01}', "");
    Expect(1, 8541, '\p{^Nv=3.750e-01}', "");
    Expect(1, 8541, '\P{Nv=3.750e-01}', "");
    Expect(0, 8541, '\P{^Nv=3.750e-01}', "");
    Expect(1, 8540, '\p{Nv=0.375}', "");
    Expect(0, 8540, '\p{^Nv=0.375}', "");
    Expect(0, 8540, '\P{Nv=0.375}', "");
    Expect(1, 8540, '\P{^Nv=0.375}', "");
    Expect(0, 8541, '\p{Nv=0.375}', "");
    Expect(1, 8541, '\p{^Nv=0.375}', "");
    Expect(1, 8541, '\P{Nv=0.375}', "");
    Expect(0, 8541, '\P{^Nv=0.375}', "");
    Expect(1, 8540, '\p{Nv=3.7500e-01}', "");
    Expect(0, 8540, '\p{^Nv=3.7500e-01}', "");
    Expect(0, 8540, '\P{Nv=3.7500e-01}', "");
    Expect(1, 8540, '\P{^Nv=3.7500e-01}', "");
    Expect(0, 8541, '\p{Nv=3.7500e-01}', "");
    Expect(1, 8541, '\p{^Nv=3.7500e-01}', "");
    Expect(1, 8541, '\P{Nv=3.7500e-01}', "");
    Expect(0, 8541, '\P{^Nv=3.7500e-01}', "");
    Expect(1, 8540, '\p{Nv:   0.3750}', "");
    Expect(0, 8540, '\p{^Nv:   0.3750}', "");
    Expect(0, 8540, '\P{Nv:   0.3750}', "");
    Expect(1, 8540, '\P{^Nv:   0.3750}', "");
    Expect(0, 8541, '\p{Nv:   0.3750}', "");
    Expect(1, 8541, '\p{^Nv:   0.3750}', "");
    Expect(1, 8541, '\P{Nv:   0.3750}', "");
    Expect(0, 8541, '\P{^Nv:   0.3750}', "");
    Error('\p{Is_Numeric_Value=/a/		+0000000003/00008}');
    Error('\P{Is_Numeric_Value=/a/		+0000000003/00008}');
    Expect(1, 8540, '\p{Is_Numeric_Value=+003/000000008}', "");
    Expect(0, 8540, '\p{^Is_Numeric_Value=+003/000000008}', "");
    Expect(0, 8540, '\P{Is_Numeric_Value=+003/000000008}', "");
    Expect(1, 8540, '\P{^Is_Numeric_Value=+003/000000008}', "");
    Expect(0, 8541, '\p{Is_Numeric_Value=+003/000000008}', "");
    Expect(1, 8541, '\p{^Is_Numeric_Value=+003/000000008}', "");
    Expect(1, 8541, '\P{Is_Numeric_Value=+003/000000008}', "");
    Expect(0, 8541, '\P{^Is_Numeric_Value=+003/000000008}', "");
    Expect(1, 8540, '\p{Is_Numeric_Value=180/480}', "");
    Expect(0, 8540, '\p{^Is_Numeric_Value=180/480}', "");
    Expect(0, 8540, '\P{Is_Numeric_Value=180/480}', "");
    Expect(1, 8540, '\P{^Is_Numeric_Value=180/480}', "");
    Expect(0, 8541, '\p{Is_Numeric_Value=180/480}', "");
    Expect(1, 8541, '\p{^Is_Numeric_Value=180/480}', "");
    Expect(1, 8541, '\P{Is_Numeric_Value=180/480}', "");
    Expect(0, 8541, '\P{^Is_Numeric_Value=180/480}', "");
    Error('\p{Is_Numeric_Value=3.8e-01}');
    Error('\P{Is_Numeric_Value=3.8e-01}');
    Expect(1, 8540, '\p{Is_Numeric_Value=3.75e-01}', "");
    Expect(0, 8540, '\p{^Is_Numeric_Value=3.75e-01}', "");
    Expect(0, 8540, '\P{Is_Numeric_Value=3.75e-01}', "");
    Expect(1, 8540, '\P{^Is_Numeric_Value=3.75e-01}', "");
    Expect(0, 8541, '\p{Is_Numeric_Value=3.75e-01}', "");
    Expect(1, 8541, '\p{^Is_Numeric_Value=3.75e-01}', "");
    Expect(1, 8541, '\P{Is_Numeric_Value=3.75e-01}', "");
    Expect(0, 8541, '\P{^Is_Numeric_Value=3.75e-01}', "");
    Error('\p{Is_Numeric_Value=0.38}');
    Error('\P{Is_Numeric_Value=0.38}');
    Expect(1, 8540, '\p{Is_Numeric_Value: 3.750e-01}', "");
    Expect(0, 8540, '\p{^Is_Numeric_Value: 3.750e-01}', "");
    Expect(0, 8540, '\P{Is_Numeric_Value: 3.750e-01}', "");
    Expect(1, 8540, '\P{^Is_Numeric_Value: 3.750e-01}', "");
    Expect(0, 8541, '\p{Is_Numeric_Value: 3.750e-01}', "");
    Expect(1, 8541, '\p{^Is_Numeric_Value: 3.750e-01}', "");
    Expect(1, 8541, '\P{Is_Numeric_Value: 3.750e-01}', "");
    Expect(0, 8541, '\P{^Is_Numeric_Value: 3.750e-01}', "");
    Expect(1, 8540, '\p{Is_Numeric_Value=0.375}', "");
    Expect(0, 8540, '\p{^Is_Numeric_Value=0.375}', "");
    Expect(0, 8540, '\P{Is_Numeric_Value=0.375}', "");
    Expect(1, 8540, '\P{^Is_Numeric_Value=0.375}', "");
    Expect(0, 8541, '\p{Is_Numeric_Value=0.375}', "");
    Expect(1, 8541, '\p{^Is_Numeric_Value=0.375}', "");
    Expect(1, 8541, '\P{Is_Numeric_Value=0.375}', "");
    Expect(0, 8541, '\P{^Is_Numeric_Value=0.375}', "");
    Expect(1, 8540, '\p{Is_Numeric_Value:3.7500e-01}', "");
    Expect(0, 8540, '\p{^Is_Numeric_Value:3.7500e-01}', "");
    Expect(0, 8540, '\P{Is_Numeric_Value:3.7500e-01}', "");
    Expect(1, 8540, '\P{^Is_Numeric_Value:3.7500e-01}', "");
    Expect(0, 8541, '\p{Is_Numeric_Value:3.7500e-01}', "");
    Expect(1, 8541, '\p{^Is_Numeric_Value:3.7500e-01}', "");
    Expect(1, 8541, '\P{Is_Numeric_Value:3.7500e-01}', "");
    Expect(0, 8541, '\P{^Is_Numeric_Value:3.7500e-01}', "");
    Expect(1, 8540, '\p{Is_Numeric_Value=0.3750}', "");
    Expect(0, 8540, '\p{^Is_Numeric_Value=0.3750}', "");
    Expect(0, 8540, '\P{Is_Numeric_Value=0.3750}', "");
    Expect(1, 8540, '\P{^Is_Numeric_Value=0.3750}', "");
    Expect(0, 8541, '\p{Is_Numeric_Value=0.3750}', "");
    Expect(1, 8541, '\p{^Is_Numeric_Value=0.3750}', "");
    Expect(1, 8541, '\P{Is_Numeric_Value=0.3750}', "");
    Expect(0, 8541, '\P{^Is_Numeric_Value=0.3750}', "");
    Error('\p{Is_Nv=-:=+00000003/008}');
    Error('\P{Is_Nv=-:=+00000003/008}');
    Expect(1, 8540, '\p{Is_Nv=+03/08}', "");
    Expect(0, 8540, '\p{^Is_Nv=+03/08}', "");
    Expect(0, 8540, '\P{Is_Nv=+03/08}', "");
    Expect(1, 8540, '\P{^Is_Nv=+03/08}', "");
    Expect(0, 8541, '\p{Is_Nv=+03/08}', "");
    Expect(1, 8541, '\p{^Is_Nv=+03/08}', "");
    Expect(1, 8541, '\P{Is_Nv=+03/08}', "");
    Expect(0, 8541, '\P{^Is_Nv=+03/08}', "");
    Expect(1, 8540, '\p{Is_Nv=180/480}', "");
    Expect(0, 8540, '\p{^Is_Nv=180/480}', "");
    Expect(0, 8540, '\P{Is_Nv=180/480}', "");
    Expect(1, 8540, '\P{^Is_Nv=180/480}', "");
    Expect(0, 8541, '\p{Is_Nv=180/480}', "");
    Expect(1, 8541, '\p{^Is_Nv=180/480}', "");
    Expect(1, 8541, '\P{Is_Nv=180/480}', "");
    Expect(0, 8541, '\P{^Is_Nv=180/480}', "");
    Error('\p{Is_Nv:   3.8e-01}');
    Error('\P{Is_Nv:   3.8e-01}');
    Expect(1, 8540, '\p{Is_Nv=3.75e-01}', "");
    Expect(0, 8540, '\p{^Is_Nv=3.75e-01}', "");
    Expect(0, 8540, '\P{Is_Nv=3.75e-01}', "");
    Expect(1, 8540, '\P{^Is_Nv=3.75e-01}', "");
    Expect(0, 8541, '\p{Is_Nv=3.75e-01}', "");
    Expect(1, 8541, '\p{^Is_Nv=3.75e-01}', "");
    Expect(1, 8541, '\P{Is_Nv=3.75e-01}', "");
    Expect(0, 8541, '\P{^Is_Nv=3.75e-01}', "");
    Error('\p{Is_Nv=0.38}');
    Error('\P{Is_Nv=0.38}');
    Expect(1, 8540, '\p{Is_Nv=3.750e-01}', "");
    Expect(0, 8540, '\p{^Is_Nv=3.750e-01}', "");
    Expect(0, 8540, '\P{Is_Nv=3.750e-01}', "");
    Expect(1, 8540, '\P{^Is_Nv=3.750e-01}', "");
    Expect(0, 8541, '\p{Is_Nv=3.750e-01}', "");
    Expect(1, 8541, '\p{^Is_Nv=3.750e-01}', "");
    Expect(1, 8541, '\P{Is_Nv=3.750e-01}', "");
    Expect(0, 8541, '\P{^Is_Nv=3.750e-01}', "");
    Expect(1, 8540, '\p{Is_Nv=0.375}', "");
    Expect(0, 8540, '\p{^Is_Nv=0.375}', "");
    Expect(0, 8540, '\P{Is_Nv=0.375}', "");
    Expect(1, 8540, '\P{^Is_Nv=0.375}', "");
    Expect(0, 8541, '\p{Is_Nv=0.375}', "");
    Expect(1, 8541, '\p{^Is_Nv=0.375}', "");
    Expect(1, 8541, '\P{Is_Nv=0.375}', "");
    Expect(0, 8541, '\P{^Is_Nv=0.375}', "");
    Expect(1, 8540, '\p{Is_Nv=3.7500e-01}', "");
    Expect(0, 8540, '\p{^Is_Nv=3.7500e-01}', "");
    Expect(0, 8540, '\P{Is_Nv=3.7500e-01}', "");
    Expect(1, 8540, '\P{^Is_Nv=3.7500e-01}', "");
    Expect(0, 8541, '\p{Is_Nv=3.7500e-01}', "");
    Expect(1, 8541, '\p{^Is_Nv=3.7500e-01}', "");
    Expect(1, 8541, '\P{Is_Nv=3.7500e-01}', "");
    Expect(0, 8541, '\P{^Is_Nv=3.7500e-01}', "");
    Expect(1, 8540, '\p{Is_Nv=0.3750}', "");
    Expect(0, 8540, '\p{^Is_Nv=0.3750}', "");
    Expect(0, 8540, '\P{Is_Nv=0.3750}', "");
    Expect(1, 8540, '\P{^Is_Nv=0.3750}', "");
    Expect(0, 8541, '\p{Is_Nv=0.3750}', "");
    Expect(1, 8541, '\p{^Is_Nv=0.3750}', "");
    Expect(1, 8541, '\P{Is_Nv=0.3750}', "");
    Expect(0, 8541, '\P{^Is_Nv=0.3750}', "");
    Error('\p{Numeric_Value:   		+0000003/80/a/}');
    Error('\P{Numeric_Value:   		+0000003/80/a/}');
    Expect(1, 73670, '\p{Numeric_Value=:\A3/80\z:}', "");;
    Expect(0, 73671, '\p{Numeric_Value=:\A3/80\z:}', "");;
    Expect(1, 73670, '\p{Numeric_Value=+0000003/0000000080}', "");
    Expect(0, 73670, '\p{^Numeric_Value=+0000003/0000000080}', "");
    Expect(0, 73670, '\P{Numeric_Value=+0000003/0000000080}', "");
    Expect(1, 73670, '\P{^Numeric_Value=+0000003/0000000080}', "");
    Expect(0, 73671, '\p{Numeric_Value=+0000003/0000000080}', "");
    Expect(1, 73671, '\p{^Numeric_Value=+0000003/0000000080}', "");
    Expect(1, 73671, '\P{Numeric_Value=+0000003/0000000080}', "");
    Expect(0, 73671, '\P{^Numeric_Value=+0000003/0000000080}', "");
    Expect(1, 73670, '\p{Numeric_Value=180/4800}', "");
    Expect(0, 73670, '\p{^Numeric_Value=180/4800}', "");
    Expect(0, 73670, '\P{Numeric_Value=180/4800}', "");
    Expect(1, 73670, '\P{^Numeric_Value=180/4800}', "");
    Expect(0, 73671, '\p{Numeric_Value=180/4800}', "");
    Expect(1, 73671, '\p{^Numeric_Value=180/4800}', "");
    Expect(1, 73671, '\P{Numeric_Value=180/4800}', "");
    Expect(0, 73671, '\P{^Numeric_Value=180/4800}', "");
    Error('\p{Numeric_Value=3.7e-02}');
    Error('\P{Numeric_Value=3.7e-02}');
    Expect(1, 73670, '\p{Numeric_Value=3.75e-02}', "");
    Expect(0, 73670, '\p{^Numeric_Value=3.75e-02}', "");
    Expect(0, 73670, '\P{Numeric_Value=3.75e-02}', "");
    Expect(1, 73670, '\P{^Numeric_Value=3.75e-02}', "");
    Expect(0, 73671, '\p{Numeric_Value=3.75e-02}', "");
    Expect(1, 73671, '\p{^Numeric_Value=3.75e-02}', "");
    Expect(1, 73671, '\P{Numeric_Value=3.75e-02}', "");
    Expect(0, 73671, '\P{^Numeric_Value=3.75e-02}', "");
    Error('\p{Numeric_Value=0.04}');
    Error('\P{Numeric_Value=0.04}');
    Expect(1, 73670, '\p{Numeric_Value=3.750e-02}', "");
    Expect(0, 73670, '\p{^Numeric_Value=3.750e-02}', "");
    Expect(0, 73670, '\P{Numeric_Value=3.750e-02}', "");
    Expect(1, 73670, '\P{^Numeric_Value=3.750e-02}', "");
    Expect(0, 73671, '\p{Numeric_Value=3.750e-02}', "");
    Expect(1, 73671, '\p{^Numeric_Value=3.750e-02}', "");
    Expect(1, 73671, '\P{Numeric_Value=3.750e-02}', "");
    Expect(0, 73671, '\P{^Numeric_Value=3.750e-02}', "");
    Error('\p{Numeric_Value:   0.037}');
    Error('\P{Numeric_Value:   0.037}');
    Expect(1, 73670, '\p{Numeric_Value=3.7500e-02}', "");
    Expect(0, 73670, '\p{^Numeric_Value=3.7500e-02}', "");
    Expect(0, 73670, '\P{Numeric_Value=3.7500e-02}', "");
    Expect(1, 73670, '\P{^Numeric_Value=3.7500e-02}', "");
    Expect(0, 73671, '\p{Numeric_Value=3.7500e-02}', "");
    Expect(1, 73671, '\p{^Numeric_Value=3.7500e-02}', "");
    Expect(1, 73671, '\P{Numeric_Value=3.7500e-02}', "");
    Expect(0, 73671, '\P{^Numeric_Value=3.7500e-02}', "");
    Expect(1, 73670, '\p{Numeric_Value=0.0375}', "");
    Expect(0, 73670, '\p{^Numeric_Value=0.0375}', "");
    Expect(0, 73670, '\P{Numeric_Value=0.0375}', "");
    Expect(1, 73670, '\P{^Numeric_Value=0.0375}', "");
    Expect(0, 73671, '\p{Numeric_Value=0.0375}', "");
    Expect(1, 73671, '\p{^Numeric_Value=0.0375}', "");
    Expect(1, 73671, '\P{Numeric_Value=0.0375}', "");
    Expect(0, 73671, '\P{^Numeric_Value=0.0375}', "");
    Expect(1, 73670, '\p{Numeric_Value=3.75000e-02}', "");
    Expect(0, 73670, '\p{^Numeric_Value=3.75000e-02}', "");
    Expect(0, 73670, '\P{Numeric_Value=3.75000e-02}', "");
    Expect(1, 73670, '\P{^Numeric_Value=3.75000e-02}', "");
    Expect(0, 73671, '\p{Numeric_Value=3.75000e-02}', "");
    Expect(1, 73671, '\p{^Numeric_Value=3.75000e-02}', "");
    Expect(1, 73671, '\P{Numeric_Value=3.75000e-02}', "");
    Expect(0, 73671, '\P{^Numeric_Value=3.75000e-02}', "");
    Expect(1, 73670, '\p{Numeric_Value=0.03750}', "");
    Expect(0, 73670, '\p{^Numeric_Value=0.03750}', "");
    Expect(0, 73670, '\P{Numeric_Value=0.03750}', "");
    Expect(1, 73670, '\P{^Numeric_Value=0.03750}', "");
    Expect(0, 73671, '\p{Numeric_Value=0.03750}', "");
    Expect(1, 73671, '\p{^Numeric_Value=0.03750}', "");
    Expect(1, 73671, '\P{Numeric_Value=0.03750}', "");
    Expect(0, 73671, '\P{^Numeric_Value=0.03750}', "");
    Error('\p{Nv=:=_+0000000003/00000080}');
    Error('\P{Nv=:=_+0000000003/00000080}');
    Expect(1, 73670, '\p{Nv=:\A3/80\z:}', "");;
    Expect(0, 73671, '\p{Nv=:\A3/80\z:}', "");;
    Expect(1, 73670, '\p{Nv=+03/00000080}', "");
    Expect(0, 73670, '\p{^Nv=+03/00000080}', "");
    Expect(0, 73670, '\P{Nv=+03/00000080}', "");
    Expect(1, 73670, '\P{^Nv=+03/00000080}', "");
    Expect(0, 73671, '\p{Nv=+03/00000080}', "");
    Expect(1, 73671, '\p{^Nv=+03/00000080}', "");
    Expect(1, 73671, '\P{Nv=+03/00000080}', "");
    Expect(0, 73671, '\P{^Nv=+03/00000080}', "");
    Expect(1, 73670, '\p{Nv=180/4800}', "");
    Expect(0, 73670, '\p{^Nv=180/4800}', "");
    Expect(0, 73670, '\P{Nv=180/4800}', "");
    Expect(1, 73670, '\P{^Nv=180/4800}', "");
    Expect(0, 73671, '\p{Nv=180/4800}', "");
    Expect(1, 73671, '\p{^Nv=180/4800}', "");
    Expect(1, 73671, '\P{Nv=180/4800}', "");
    Expect(0, 73671, '\P{^Nv=180/4800}', "");
    Error('\p{Nv=3.7e-02}');
    Error('\P{Nv=3.7e-02}');
    Expect(1, 73670, '\p{Nv=3.75e-02}', "");
    Expect(0, 73670, '\p{^Nv=3.75e-02}', "");
    Expect(0, 73670, '\P{Nv=3.75e-02}', "");
    Expect(1, 73670, '\P{^Nv=3.75e-02}', "");
    Expect(0, 73671, '\p{Nv=3.75e-02}', "");
    Expect(1, 73671, '\p{^Nv=3.75e-02}', "");
    Expect(1, 73671, '\P{Nv=3.75e-02}', "");
    Expect(0, 73671, '\P{^Nv=3.75e-02}', "");
    Error('\p{Nv=0.04}');
    Error('\P{Nv=0.04}');
    Expect(1, 73670, '\p{Nv=3.750e-02}', "");
    Expect(0, 73670, '\p{^Nv=3.750e-02}', "");
    Expect(0, 73670, '\P{Nv=3.750e-02}', "");
    Expect(1, 73670, '\P{^Nv=3.750e-02}', "");
    Expect(0, 73671, '\p{Nv=3.750e-02}', "");
    Expect(1, 73671, '\p{^Nv=3.750e-02}', "");
    Expect(1, 73671, '\P{Nv=3.750e-02}', "");
    Expect(0, 73671, '\P{^Nv=3.750e-02}', "");
    Error('\p{Nv=0.037}');
    Error('\P{Nv=0.037}');
    Expect(1, 73670, '\p{Nv=3.7500e-02}', "");
    Expect(0, 73670, '\p{^Nv=3.7500e-02}', "");
    Expect(0, 73670, '\P{Nv=3.7500e-02}', "");
    Expect(1, 73670, '\P{^Nv=3.7500e-02}', "");
    Expect(0, 73671, '\p{Nv=3.7500e-02}', "");
    Expect(1, 73671, '\p{^Nv=3.7500e-02}', "");
    Expect(1, 73671, '\P{Nv=3.7500e-02}', "");
    Expect(0, 73671, '\P{^Nv=3.7500e-02}', "");
    Expect(1, 73670, '\p{Nv:   0.0375}', "");
    Expect(0, 73670, '\p{^Nv:   0.0375}', "");
    Expect(0, 73670, '\P{Nv:   0.0375}', "");
    Expect(1, 73670, '\P{^Nv:   0.0375}', "");
    Expect(0, 73671, '\p{Nv:   0.0375}', "");
    Expect(1, 73671, '\p{^Nv:   0.0375}', "");
    Expect(1, 73671, '\P{Nv:   0.0375}', "");
    Expect(0, 73671, '\P{^Nv:   0.0375}', "");
    Expect(1, 73670, '\p{Nv=3.75000e-02}', "");
    Expect(0, 73670, '\p{^Nv=3.75000e-02}', "");
    Expect(0, 73670, '\P{Nv=3.75000e-02}', "");
    Expect(1, 73670, '\P{^Nv=3.75000e-02}', "");
    Expect(0, 73671, '\p{Nv=3.75000e-02}', "");
    Expect(1, 73671, '\p{^Nv=3.75000e-02}', "");
    Expect(1, 73671, '\P{Nv=3.75000e-02}', "");
    Expect(0, 73671, '\P{^Nv=3.75000e-02}', "");
    Expect(1, 73670, '\p{Nv=0.03750}', "");
    Expect(0, 73670, '\p{^Nv=0.03750}', "");
    Expect(0, 73670, '\P{Nv=0.03750}', "");
    Expect(1, 73670, '\P{^Nv=0.03750}', "");
    Expect(0, 73671, '\p{Nv=0.03750}', "");
    Expect(1, 73671, '\p{^Nv=0.03750}', "");
    Expect(1, 73671, '\P{Nv=0.03750}', "");
    Expect(0, 73671, '\P{^Nv=0.03750}', "");
    Error('\p{Is_Numeric_Value=_/a/+0000003/00080}');
    Error('\P{Is_Numeric_Value=_/a/+0000003/00080}');
    Expect(1, 73670, '\p{Is_Numeric_Value=0000003/80}', "");
    Expect(0, 73670, '\p{^Is_Numeric_Value=0000003/80}', "");
    Expect(0, 73670, '\P{Is_Numeric_Value=0000003/80}', "");
    Expect(1, 73670, '\P{^Is_Numeric_Value=0000003/80}', "");
    Expect(0, 73671, '\p{Is_Numeric_Value=0000003/80}', "");
    Expect(1, 73671, '\p{^Is_Numeric_Value=0000003/80}', "");
    Expect(1, 73671, '\P{Is_Numeric_Value=0000003/80}', "");
    Expect(0, 73671, '\P{^Is_Numeric_Value=0000003/80}', "");
    Expect(1, 73670, '\p{Is_Numeric_Value=180/4800}', "");
    Expect(0, 73670, '\p{^Is_Numeric_Value=180/4800}', "");
    Expect(0, 73670, '\P{Is_Numeric_Value=180/4800}', "");
    Expect(1, 73670, '\P{^Is_Numeric_Value=180/4800}', "");
    Expect(0, 73671, '\p{Is_Numeric_Value=180/4800}', "");
    Expect(1, 73671, '\p{^Is_Numeric_Value=180/4800}', "");
    Expect(1, 73671, '\P{Is_Numeric_Value=180/4800}', "");
    Expect(0, 73671, '\P{^Is_Numeric_Value=180/4800}', "");
    Error('\p{Is_Numeric_Value=3.7e-02}');
    Error('\P{Is_Numeric_Value=3.7e-02}');
    Expect(1, 73670, '\p{Is_Numeric_Value=3.75e-02}', "");
    Expect(0, 73670, '\p{^Is_Numeric_Value=3.75e-02}', "");
    Expect(0, 73670, '\P{Is_Numeric_Value=3.75e-02}', "");
    Expect(1, 73670, '\P{^Is_Numeric_Value=3.75e-02}', "");
    Expect(0, 73671, '\p{Is_Numeric_Value=3.75e-02}', "");
    Expect(1, 73671, '\p{^Is_Numeric_Value=3.75e-02}', "");
    Expect(1, 73671, '\P{Is_Numeric_Value=3.75e-02}', "");
    Expect(0, 73671, '\P{^Is_Numeric_Value=3.75e-02}', "");
    Error('\p{Is_Numeric_Value=0.04}');
    Error('\P{Is_Numeric_Value=0.04}');
    Expect(1, 73670, '\p{Is_Numeric_Value=3.750e-02}', "");
    Expect(0, 73670, '\p{^Is_Numeric_Value=3.750e-02}', "");
    Expect(0, 73670, '\P{Is_Numeric_Value=3.750e-02}', "");
    Expect(1, 73670, '\P{^Is_Numeric_Value=3.750e-02}', "");
    Expect(0, 73671, '\p{Is_Numeric_Value=3.750e-02}', "");
    Expect(1, 73671, '\p{^Is_Numeric_Value=3.750e-02}', "");
    Expect(1, 73671, '\P{Is_Numeric_Value=3.750e-02}', "");
    Expect(0, 73671, '\P{^Is_Numeric_Value=3.750e-02}', "");
    Error('\p{Is_Numeric_Value:   0.037}');
    Error('\P{Is_Numeric_Value:   0.037}');
    Expect(1, 73670, '\p{Is_Numeric_Value=3.7500e-02}', "");
    Expect(0, 73670, '\p{^Is_Numeric_Value=3.7500e-02}', "");
    Expect(0, 73670, '\P{Is_Numeric_Value=3.7500e-02}', "");
    Expect(1, 73670, '\P{^Is_Numeric_Value=3.7500e-02}', "");
    Expect(0, 73671, '\p{Is_Numeric_Value=3.7500e-02}', "");
    Expect(1, 73671, '\p{^Is_Numeric_Value=3.7500e-02}', "");
    Expect(1, 73671, '\P{Is_Numeric_Value=3.7500e-02}', "");
    Expect(0, 73671, '\P{^Is_Numeric_Value=3.7500e-02}', "");
    Expect(1, 73670, '\p{Is_Numeric_Value=0.0375}', "");
    Expect(0, 73670, '\p{^Is_Numeric_Value=0.0375}', "");
    Expect(0, 73670, '\P{Is_Numeric_Value=0.0375}', "");
    Expect(1, 73670, '\P{^Is_Numeric_Value=0.0375}', "");
    Expect(0, 73671, '\p{Is_Numeric_Value=0.0375}', "");
    Expect(1, 73671, '\p{^Is_Numeric_Value=0.0375}', "");
    Expect(1, 73671, '\P{Is_Numeric_Value=0.0375}', "");
    Expect(0, 73671, '\P{^Is_Numeric_Value=0.0375}', "");
    Expect(1, 73670, '\p{Is_Numeric_Value:   3.75000e-02}', "");
    Expect(0, 73670, '\p{^Is_Numeric_Value:   3.75000e-02}', "");
    Expect(0, 73670, '\P{Is_Numeric_Value:   3.75000e-02}', "");
    Expect(1, 73670, '\P{^Is_Numeric_Value:   3.75000e-02}', "");
    Expect(0, 73671, '\p{Is_Numeric_Value:   3.75000e-02}', "");
    Expect(1, 73671, '\p{^Is_Numeric_Value:   3.75000e-02}', "");
    Expect(1, 73671, '\P{Is_Numeric_Value:   3.75000e-02}', "");
    Expect(0, 73671, '\P{^Is_Numeric_Value:   3.75000e-02}', "");
    Expect(1, 73670, '\p{Is_Numeric_Value=0.03750}', "");
    Expect(0, 73670, '\p{^Is_Numeric_Value=0.03750}', "");
    Expect(0, 73670, '\P{Is_Numeric_Value=0.03750}', "");
    Expect(1, 73670, '\P{^Is_Numeric_Value=0.03750}', "");
    Expect(0, 73671, '\p{Is_Numeric_Value=0.03750}', "");
    Expect(1, 73671, '\p{^Is_Numeric_Value=0.03750}', "");
    Expect(1, 73671, '\P{Is_Numeric_Value=0.03750}', "");
    Expect(0, 73671, '\P{^Is_Numeric_Value=0.03750}', "");
    Error('\p{Is_Nv:	0000003/00080:=}');
    Error('\P{Is_Nv:	0000003/00080:=}');
    Expect(1, 73670, '\p{Is_Nv=+000003/00000000080}', "");
    Expect(0, 73670, '\p{^Is_Nv=+000003/00000000080}', "");
    Expect(0, 73670, '\P{Is_Nv=+000003/00000000080}', "");
    Expect(1, 73670, '\P{^Is_Nv=+000003/00000000080}', "");
    Expect(0, 73671, '\p{Is_Nv=+000003/00000000080}', "");
    Expect(1, 73671, '\p{^Is_Nv=+000003/00000000080}', "");
    Expect(1, 73671, '\P{Is_Nv=+000003/00000000080}', "");
    Expect(0, 73671, '\P{^Is_Nv=+000003/00000000080}', "");
    Expect(1, 73670, '\p{Is_Nv=180/4800}', "");
    Expect(0, 73670, '\p{^Is_Nv=180/4800}', "");
    Expect(0, 73670, '\P{Is_Nv=180/4800}', "");
    Expect(1, 73670, '\P{^Is_Nv=180/4800}', "");
    Expect(0, 73671, '\p{Is_Nv=180/4800}', "");
    Expect(1, 73671, '\p{^Is_Nv=180/4800}', "");
    Expect(1, 73671, '\P{Is_Nv=180/4800}', "");
    Expect(0, 73671, '\P{^Is_Nv=180/4800}', "");
    Error('\p{Is_Nv=3.7e-02}');
    Error('\P{Is_Nv=3.7e-02}');
    Expect(1, 73670, '\p{Is_Nv=3.75e-02}', "");
    Expect(0, 73670, '\p{^Is_Nv=3.75e-02}', "");
    Expect(0, 73670, '\P{Is_Nv=3.75e-02}', "");
    Expect(1, 73670, '\P{^Is_Nv=3.75e-02}', "");
    Expect(0, 73671, '\p{Is_Nv=3.75e-02}', "");
    Expect(1, 73671, '\p{^Is_Nv=3.75e-02}', "");
    Expect(1, 73671, '\P{Is_Nv=3.75e-02}', "");
    Expect(0, 73671, '\P{^Is_Nv=3.75e-02}', "");
    Error('\p{Is_Nv=0.04}');
    Error('\P{Is_Nv=0.04}');
    Expect(1, 73670, '\p{Is_Nv=3.750e-02}', "");
    Expect(0, 73670, '\p{^Is_Nv=3.750e-02}', "");
    Expect(0, 73670, '\P{Is_Nv=3.750e-02}', "");
    Expect(1, 73670, '\P{^Is_Nv=3.750e-02}', "");
    Expect(0, 73671, '\p{Is_Nv=3.750e-02}', "");
    Expect(1, 73671, '\p{^Is_Nv=3.750e-02}', "");
    Expect(1, 73671, '\P{Is_Nv=3.750e-02}', "");
    Expect(0, 73671, '\P{^Is_Nv=3.750e-02}', "");
    Error('\p{Is_Nv=0.037}');
    Error('\P{Is_Nv=0.037}');
    Expect(1, 73670, '\p{Is_Nv=3.7500e-02}', "");
    Expect(0, 73670, '\p{^Is_Nv=3.7500e-02}', "");
    Expect(0, 73670, '\P{Is_Nv=3.7500e-02}', "");
    Expect(1, 73670, '\P{^Is_Nv=3.7500e-02}', "");
    Expect(0, 73671, '\p{Is_Nv=3.7500e-02}', "");
    Expect(1, 73671, '\p{^Is_Nv=3.7500e-02}', "");
    Expect(1, 73671, '\P{Is_Nv=3.7500e-02}', "");
    Expect(0, 73671, '\P{^Is_Nv=3.7500e-02}', "");
    Expect(1, 73670, '\p{Is_Nv=0.0375}', "");
    Expect(0, 73670, '\p{^Is_Nv=0.0375}', "");
    Expect(0, 73670, '\P{Is_Nv=0.0375}', "");
    Expect(1, 73670, '\P{^Is_Nv=0.0375}', "");
    Expect(0, 73671, '\p{Is_Nv=0.0375}', "");
    Expect(1, 73671, '\p{^Is_Nv=0.0375}', "");
    Expect(1, 73671, '\P{Is_Nv=0.0375}', "");
    Expect(0, 73671, '\P{^Is_Nv=0.0375}', "");
    Expect(1, 73670, '\p{Is_Nv=3.75000e-02}', "");
    Expect(0, 73670, '\p{^Is_Nv=3.75000e-02}', "");
    Expect(0, 73670, '\P{Is_Nv=3.75000e-02}', "");
    Expect(1, 73670, '\P{^Is_Nv=3.75000e-02}', "");
    Expect(0, 73671, '\p{Is_Nv=3.75000e-02}', "");
    Expect(1, 73671, '\p{^Is_Nv=3.75000e-02}', "");
    Expect(1, 73671, '\P{Is_Nv=3.75000e-02}', "");
    Expect(0, 73671, '\P{^Is_Nv=3.75000e-02}', "");
    Expect(1, 73670, '\p{Is_Nv:	0.03750}', "");
    Expect(0, 73670, '\p{^Is_Nv:	0.03750}', "");
    Expect(0, 73670, '\P{Is_Nv:	0.03750}', "");
    Expect(1, 73670, '\P{^Is_Nv:	0.03750}', "");
    Expect(0, 73671, '\p{Is_Nv:	0.03750}', "");
    Expect(1, 73671, '\p{^Is_Nv:	0.03750}', "");
    Expect(1, 73671, '\P{Is_Nv:	0.03750}', "");
    Expect(0, 73671, '\P{^Is_Nv:	0.03750}', "");
    Error('\p{Numeric_Value=/a/ 000_003_0}');
    Error('\P{Numeric_Value=/a/ 000_003_0}');
    Expect(1, 133507, '\p{Numeric_Value=:\A30\z:}', "");;
    Expect(0, 133508, '\p{Numeric_Value=:\A30\z:}', "");;
    Expect(1, 133507, '\p{Numeric_Value=03_0}', "");
    Expect(0, 133507, '\p{^Numeric_Value=03_0}', "");
    Expect(0, 133507, '\P{Numeric_Value=03_0}', "");
    Expect(1, 133507, '\P{^Numeric_Value=03_0}', "");
    Expect(0, 133508, '\p{Numeric_Value=03_0}', "");
    Expect(1, 133508, '\p{^Numeric_Value=03_0}', "");
    Expect(1, 133508, '\P{Numeric_Value=03_0}', "");
    Expect(0, 133508, '\P{^Numeric_Value=03_0}', "");
    Expect(1, 133507, '\p{Numeric_Value=3.000000000000000e+01}', "");
    Expect(0, 133507, '\p{^Numeric_Value=3.000000000000000e+01}', "");
    Expect(0, 133507, '\P{Numeric_Value=3.000000000000000e+01}', "");
    Expect(1, 133507, '\P{^Numeric_Value=3.000000000000000e+01}', "");
    Expect(0, 133508, '\p{Numeric_Value=3.000000000000000e+01}', "");
    Expect(1, 133508, '\p{^Numeric_Value=3.000000000000000e+01}', "");
    Expect(1, 133508, '\P{Numeric_Value=3.000000000000000e+01}', "");
    Expect(0, 133508, '\P{^Numeric_Value=3.000000000000000e+01}', "");
    Error('\p{Nv=  000000030:=}');
    Error('\P{Nv=  000000030:=}');
    Expect(1, 133507, '\p{Nv=:\A30\z:}', "");;
    Expect(0, 133508, '\p{Nv=:\A30\z:}', "");;
    Expect(1, 133507, '\p{Nv=3_0}', "");
    Expect(0, 133507, '\p{^Nv=3_0}', "");
    Expect(0, 133507, '\P{Nv=3_0}', "");
    Expect(1, 133507, '\P{^Nv=3_0}', "");
    Expect(0, 133508, '\p{Nv=3_0}', "");
    Expect(1, 133508, '\p{^Nv=3_0}', "");
    Expect(1, 133508, '\P{Nv=3_0}', "");
    Expect(0, 133508, '\P{^Nv=3_0}', "");
    Expect(1, 133507, '\p{Nv=3.000000000000000e+01}', "");
    Expect(0, 133507, '\p{^Nv=3.000000000000000e+01}', "");
    Expect(0, 133507, '\P{Nv=3.000000000000000e+01}', "");
    Expect(1, 133507, '\P{^Nv=3.000000000000000e+01}', "");
    Expect(0, 133508, '\p{Nv=3.000000000000000e+01}', "");
    Expect(1, 133508, '\p{^Nv=3.000000000000000e+01}', "");
    Expect(1, 133508, '\P{Nv=3.000000000000000e+01}', "");
    Expect(0, 133508, '\P{^Nv=3.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value= 030:=}');
    Error('\P{Is_Numeric_Value= 030:=}');
    Expect(1, 133507, '\p{Is_Numeric_Value=+003_0}', "");
    Expect(0, 133507, '\p{^Is_Numeric_Value=+003_0}', "");
    Expect(0, 133507, '\P{Is_Numeric_Value=+003_0}', "");
    Expect(1, 133507, '\P{^Is_Numeric_Value=+003_0}', "");
    Expect(0, 133508, '\p{Is_Numeric_Value=+003_0}', "");
    Expect(1, 133508, '\p{^Is_Numeric_Value=+003_0}', "");
    Expect(1, 133508, '\P{Is_Numeric_Value=+003_0}', "");
    Expect(0, 133508, '\P{^Is_Numeric_Value=+003_0}', "");
    Expect(1, 133507, '\p{Is_Numeric_Value=3.000000000000000e+01}', "");
    Expect(0, 133507, '\p{^Is_Numeric_Value=3.000000000000000e+01}', "");
    Expect(0, 133507, '\P{Is_Numeric_Value=3.000000000000000e+01}', "");
    Expect(1, 133507, '\P{^Is_Numeric_Value=3.000000000000000e+01}', "");
    Expect(0, 133508, '\p{Is_Numeric_Value=3.000000000000000e+01}', "");
    Expect(1, 133508, '\p{^Is_Numeric_Value=3.000000000000000e+01}', "");
    Expect(1, 133508, '\P{Is_Numeric_Value=3.000000000000000e+01}', "");
    Expect(0, 133508, '\P{^Is_Numeric_Value=3.000000000000000e+01}', "");
    Error('\p{Is_Nv=		00_00_03_0/a/}');
    Error('\P{Is_Nv=		00_00_03_0/a/}');
    Expect(1, 133507, '\p{Is_Nv=0000030}', "");
    Expect(0, 133507, '\p{^Is_Nv=0000030}', "");
    Expect(0, 133507, '\P{Is_Nv=0000030}', "");
    Expect(1, 133507, '\P{^Is_Nv=0000030}', "");
    Expect(0, 133508, '\p{Is_Nv=0000030}', "");
    Expect(1, 133508, '\p{^Is_Nv=0000030}', "");
    Expect(1, 133508, '\P{Is_Nv=0000030}', "");
    Expect(0, 133508, '\P{^Is_Nv=0000030}', "");
    Expect(1, 133507, '\p{Is_Nv=3.000000000000000e+01}', "");
    Expect(0, 133507, '\p{^Is_Nv=3.000000000000000e+01}', "");
    Expect(0, 133507, '\P{Is_Nv=3.000000000000000e+01}', "");
    Expect(1, 133507, '\P{^Is_Nv=3.000000000000000e+01}', "");
    Expect(0, 133508, '\p{Is_Nv=3.000000000000000e+01}', "");
    Expect(1, 133508, '\p{^Is_Nv=3.000000000000000e+01}', "");
    Expect(1, 133508, '\P{Is_Nv=3.000000000000000e+01}', "");
    Expect(0, 133508, '\P{^Is_Nv=3.000000000000000e+01}', "");
    Error('\p{Numeric_Value: /a/	 0000300}');
    Error('\P{Numeric_Value: /a/	 0000300}');
    Expect(1, 126229, '\p{Numeric_Value=:\A300\z:}', "");;
    Expect(0, 126230, '\p{Numeric_Value=:\A300\z:}', "");;
    Expect(1, 126229, '\p{Numeric_Value=+00000_00003_00}', "");
    Expect(0, 126229, '\p{^Numeric_Value=+00000_00003_00}', "");
    Expect(0, 126229, '\P{Numeric_Value=+00000_00003_00}', "");
    Expect(1, 126229, '\P{^Numeric_Value=+00000_00003_00}', "");
    Expect(0, 126230, '\p{Numeric_Value=+00000_00003_00}', "");
    Expect(1, 126230, '\p{^Numeric_Value=+00000_00003_00}', "");
    Expect(1, 126230, '\P{Numeric_Value=+00000_00003_00}', "");
    Expect(0, 126230, '\P{^Numeric_Value=+00000_00003_00}', "");
    Expect(1, 126229, '\p{Numeric_Value=3.000000000000000e+02}', "");
    Expect(0, 126229, '\p{^Numeric_Value=3.000000000000000e+02}', "");
    Expect(0, 126229, '\P{Numeric_Value=3.000000000000000e+02}', "");
    Expect(1, 126229, '\P{^Numeric_Value=3.000000000000000e+02}', "");
    Expect(0, 126230, '\p{Numeric_Value=3.000000000000000e+02}', "");
    Expect(1, 126230, '\p{^Numeric_Value=3.000000000000000e+02}', "");
    Expect(1, 126230, '\P{Numeric_Value=3.000000000000000e+02}', "");
    Expect(0, 126230, '\P{^Numeric_Value=3.000000000000000e+02}', "");
    Error('\p{Nv=		00000300:=}');
    Error('\P{Nv=		00000300:=}');
    Expect(1, 126229, '\p{Nv=:\A300\z:}', "");;
    Expect(0, 126230, '\p{Nv=:\A300\z:}', "");;
    Expect(1, 126229, '\p{Nv=0_0_0_0_0_0_0_0300}', "");
    Expect(0, 126229, '\p{^Nv=0_0_0_0_0_0_0_0300}', "");
    Expect(0, 126229, '\P{Nv=0_0_0_0_0_0_0_0300}', "");
    Expect(1, 126229, '\P{^Nv=0_0_0_0_0_0_0_0300}', "");
    Expect(0, 126230, '\p{Nv=0_0_0_0_0_0_0_0300}', "");
}
if (!$::TESTCHUNK or $::TESTCHUNK == 3) {
    Expect(1, 126230, '\p{^Nv=0_0_0_0_0_0_0_0300}', "");
    Expect(1, 126230, '\P{Nv=0_0_0_0_0_0_0_0300}', "");
    Expect(0, 126230, '\P{^Nv=0_0_0_0_0_0_0_0300}', "");
    Expect(1, 126229, '\p{Nv=3.000000000000000e+02}', "");
    Expect(0, 126229, '\p{^Nv=3.000000000000000e+02}', "");
    Expect(0, 126229, '\P{Nv=3.000000000000000e+02}', "");
    Expect(1, 126229, '\P{^Nv=3.000000000000000e+02}', "");
    Expect(0, 126230, '\p{Nv=3.000000000000000e+02}', "");
    Expect(1, 126230, '\p{^Nv=3.000000000000000e+02}', "");
    Expect(1, 126230, '\P{Nv=3.000000000000000e+02}', "");
    Expect(0, 126230, '\P{^Nv=3.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value:   -	0000300:=}');
    Error('\P{Is_Numeric_Value:   -	0000300:=}');
    Expect(1, 126229, '\p{Is_Numeric_Value=300}', "");
    Expect(0, 126229, '\p{^Is_Numeric_Value=300}', "");
    Expect(0, 126229, '\P{Is_Numeric_Value=300}', "");
    Expect(1, 126229, '\P{^Is_Numeric_Value=300}', "");
    Expect(0, 126230, '\p{Is_Numeric_Value=300}', "");
    Expect(1, 126230, '\p{^Is_Numeric_Value=300}', "");
    Expect(1, 126230, '\P{Is_Numeric_Value=300}', "");
    Expect(0, 126230, '\P{^Is_Numeric_Value=300}', "");
    Expect(1, 126229, '\p{Is_Numeric_Value=3.000000000000000e+02}', "");
    Expect(0, 126229, '\p{^Is_Numeric_Value=3.000000000000000e+02}', "");
    Expect(0, 126229, '\P{Is_Numeric_Value=3.000000000000000e+02}', "");
    Expect(1, 126229, '\P{^Is_Numeric_Value=3.000000000000000e+02}', "");
    Expect(0, 126230, '\p{Is_Numeric_Value=3.000000000000000e+02}', "");
    Expect(1, 126230, '\p{^Is_Numeric_Value=3.000000000000000e+02}', "");
    Expect(1, 126230, '\P{Is_Numeric_Value=3.000000000000000e+02}', "");
    Expect(0, 126230, '\P{^Is_Numeric_Value=3.000000000000000e+02}', "");
    Error('\p{Is_Nv=-000_030_0/a/}');
    Error('\P{Is_Nv=-000_030_0/a/}');
    Expect(1, 126229, '\p{Is_Nv=0_0_0_0_0_0_0_3_00}', "");
    Expect(0, 126229, '\p{^Is_Nv=0_0_0_0_0_0_0_3_00}', "");
    Expect(0, 126229, '\P{Is_Nv=0_0_0_0_0_0_0_3_00}', "");
    Expect(1, 126229, '\P{^Is_Nv=0_0_0_0_0_0_0_3_00}', "");
    Expect(0, 126230, '\p{Is_Nv=0_0_0_0_0_0_0_3_00}', "");
    Expect(1, 126230, '\p{^Is_Nv=0_0_0_0_0_0_0_3_00}', "");
    Expect(1, 126230, '\P{Is_Nv=0_0_0_0_0_0_0_3_00}', "");
    Expect(0, 126230, '\P{^Is_Nv=0_0_0_0_0_0_0_3_00}', "");
    Expect(1, 126229, '\p{Is_Nv=3.000000000000000e+02}', "");
    Expect(0, 126229, '\p{^Is_Nv=3.000000000000000e+02}', "");
    Expect(0, 126229, '\P{Is_Nv=3.000000000000000e+02}', "");
    Expect(1, 126229, '\P{^Is_Nv=3.000000000000000e+02}', "");
    Expect(0, 126230, '\p{Is_Nv=3.000000000000000e+02}', "");
    Expect(1, 126230, '\p{^Is_Nv=3.000000000000000e+02}', "");
    Expect(1, 126230, '\P{Is_Nv=3.000000000000000e+02}', "");
    Expect(0, 126230, '\P{^Is_Nv=3.000000000000000e+02}', "");
    Error('\p{Numeric_Value= -+00_00_00_00_03_00_0/a/}');
    Error('\P{Numeric_Value= -+00_00_00_00_03_00_0/a/}');
    Expect(1, 126238, '\p{Numeric_Value=:\A3000\z:}', "");;
    Expect(0, 126239, '\p{Numeric_Value=:\A3000\z:}', "");;
    Expect(1, 126238, '\p{Numeric_Value=+0000003000}', "");
    Expect(0, 126238, '\p{^Numeric_Value=+0000003000}', "");
    Expect(0, 126238, '\P{Numeric_Value=+0000003000}', "");
    Expect(1, 126238, '\P{^Numeric_Value=+0000003000}', "");
    Expect(0, 126239, '\p{Numeric_Value=+0000003000}', "");
    Expect(1, 126239, '\p{^Numeric_Value=+0000003000}', "");
    Expect(1, 126239, '\P{Numeric_Value=+0000003000}', "");
    Expect(0, 126239, '\P{^Numeric_Value=+0000003000}', "");
    Expect(1, 126238, '\p{Numeric_Value=3.000000000000000e+03}', "");
    Expect(0, 126238, '\p{^Numeric_Value=3.000000000000000e+03}', "");
    Expect(0, 126238, '\P{Numeric_Value=3.000000000000000e+03}', "");
    Expect(1, 126238, '\P{^Numeric_Value=3.000000000000000e+03}', "");
    Expect(0, 126239, '\p{Numeric_Value=3.000000000000000e+03}', "");
    Expect(1, 126239, '\p{^Numeric_Value=3.000000000000000e+03}', "");
    Expect(1, 126239, '\P{Numeric_Value=3.000000000000000e+03}', "");
    Expect(0, 126239, '\P{^Numeric_Value=3.000000000000000e+03}', "");
    Error('\p{Nv=/a/ 	00000003000}');
    Error('\P{Nv=/a/ 	00000003000}');
    Expect(1, 126238, '\p{Nv=:\A3000\z:}', "");;
    Expect(0, 126239, '\p{Nv=:\A3000\z:}', "");;
    Expect(1, 126238, '\p{Nv=00_00_03_00_0}', "");
    Expect(0, 126238, '\p{^Nv=00_00_03_00_0}', "");
    Expect(0, 126238, '\P{Nv=00_00_03_00_0}', "");
    Expect(1, 126238, '\P{^Nv=00_00_03_00_0}', "");
    Expect(0, 126239, '\p{Nv=00_00_03_00_0}', "");
    Expect(1, 126239, '\p{^Nv=00_00_03_00_0}', "");
    Expect(1, 126239, '\P{Nv=00_00_03_00_0}', "");
    Expect(0, 126239, '\P{^Nv=00_00_03_00_0}', "");
    Expect(1, 126238, '\p{Nv=3.000000000000000e+03}', "");
    Expect(0, 126238, '\p{^Nv=3.000000000000000e+03}', "");
    Expect(0, 126238, '\P{Nv=3.000000000000000e+03}', "");
    Expect(1, 126238, '\P{^Nv=3.000000000000000e+03}', "");
    Expect(0, 126239, '\p{Nv=3.000000000000000e+03}', "");
    Expect(1, 126239, '\p{^Nv=3.000000000000000e+03}', "");
    Expect(1, 126239, '\P{Nv=3.000000000000000e+03}', "");
    Expect(0, 126239, '\P{^Nv=3.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value=/a/_-00_00_30_00}');
    Error('\P{Is_Numeric_Value=/a/_-00_00_30_00}');
    Expect(1, 126238, '\p{Is_Numeric_Value=03000}', "");
    Expect(0, 126238, '\p{^Is_Numeric_Value=03000}', "");
    Expect(0, 126238, '\P{Is_Numeric_Value=03000}', "");
    Expect(1, 126238, '\P{^Is_Numeric_Value=03000}', "");
    Expect(0, 126239, '\p{Is_Numeric_Value=03000}', "");
    Expect(1, 126239, '\p{^Is_Numeric_Value=03000}', "");
    Expect(1, 126239, '\P{Is_Numeric_Value=03000}', "");
    Expect(0, 126239, '\P{^Is_Numeric_Value=03000}', "");
    Expect(1, 126238, '\p{Is_Numeric_Value=3.000000000000000e+03}', "");
    Expect(0, 126238, '\p{^Is_Numeric_Value=3.000000000000000e+03}', "");
    Expect(0, 126238, '\P{Is_Numeric_Value=3.000000000000000e+03}', "");
    Expect(1, 126238, '\P{^Is_Numeric_Value=3.000000000000000e+03}', "");
    Expect(0, 126239, '\p{Is_Numeric_Value=3.000000000000000e+03}', "");
    Expect(1, 126239, '\p{^Is_Numeric_Value=3.000000000000000e+03}', "");
    Expect(1, 126239, '\P{Is_Numeric_Value=3.000000000000000e+03}', "");
    Expect(0, 126239, '\P{^Is_Numeric_Value=3.000000000000000e+03}', "");
    Error('\p{Is_Nv= +0_0_0_0_0_0_0_3000/a/}');
    Error('\P{Is_Nv= +0_0_0_0_0_0_0_3000/a/}');
    Expect(1, 126238, '\p{Is_Nv:	+3000}', "");
    Expect(0, 126238, '\p{^Is_Nv:	+3000}', "");
    Expect(0, 126238, '\P{Is_Nv:	+3000}', "");
    Expect(1, 126238, '\P{^Is_Nv:	+3000}', "");
    Expect(0, 126239, '\p{Is_Nv:	+3000}', "");
    Expect(1, 126239, '\p{^Is_Nv:	+3000}', "");
    Expect(1, 126239, '\P{Is_Nv:	+3000}', "");
    Expect(0, 126239, '\P{^Is_Nv:	+3000}', "");
    Expect(1, 126238, '\p{Is_Nv=3.000000000000000e+03}', "");
    Expect(0, 126238, '\p{^Is_Nv=3.000000000000000e+03}', "");
    Expect(0, 126238, '\P{Is_Nv=3.000000000000000e+03}', "");
    Expect(1, 126238, '\P{^Is_Nv=3.000000000000000e+03}', "");
    Expect(0, 126239, '\p{Is_Nv=3.000000000000000e+03}', "");
    Expect(1, 126239, '\p{^Is_Nv=3.000000000000000e+03}', "");
    Expect(1, 126239, '\P{Is_Nv=3.000000000000000e+03}', "");
    Expect(0, 126239, '\P{^Is_Nv=3.000000000000000e+03}', "");
    Error('\p{Numeric_Value=-/a/+0000000030000}');
    Error('\P{Numeric_Value=-/a/+0000000030000}');
    Expect(1, 126247, '\p{Numeric_Value=:\A30000\z:}', "");;
    Expect(0, 126248, '\p{Numeric_Value=:\A30000\z:}', "");;
    Expect(1, 126247, '\p{Numeric_Value=0000030000}', "");
    Expect(0, 126247, '\p{^Numeric_Value=0000030000}', "");
    Expect(0, 126247, '\P{Numeric_Value=0000030000}', "");
    Expect(1, 126247, '\P{^Numeric_Value=0000030000}', "");
    Expect(0, 126248, '\p{Numeric_Value=0000030000}', "");
    Expect(1, 126248, '\p{^Numeric_Value=0000030000}', "");
    Expect(1, 126248, '\P{Numeric_Value=0000030000}', "");
    Expect(0, 126248, '\P{^Numeric_Value=0000030000}', "");
    Expect(1, 126247, '\p{Numeric_Value=3.000000000000000e+04}', "");
    Expect(0, 126247, '\p{^Numeric_Value=3.000000000000000e+04}', "");
    Expect(0, 126247, '\P{Numeric_Value=3.000000000000000e+04}', "");
    Expect(1, 126247, '\P{^Numeric_Value=3.000000000000000e+04}', "");
    Expect(0, 126248, '\p{Numeric_Value=3.000000000000000e+04}', "");
    Expect(1, 126248, '\p{^Numeric_Value=3.000000000000000e+04}', "");
    Expect(1, 126248, '\P{Numeric_Value=3.000000000000000e+04}', "");
    Expect(0, 126248, '\P{^Numeric_Value=3.000000000000000e+04}', "");
    Error('\p{Nv:	 /a/+00_00_00_30_000}');
    Error('\P{Nv:	 /a/+00_00_00_30_000}');
    Expect(1, 126247, '\p{Nv=:\A30000\z:}', "");;
    Expect(0, 126248, '\p{Nv=:\A30000\z:}', "");;
    Expect(1, 126247, '\p{Nv=00_30_00_0}', "");
    Expect(0, 126247, '\p{^Nv=00_30_00_0}', "");
    Expect(0, 126247, '\P{Nv=00_30_00_0}', "");
    Expect(1, 126247, '\P{^Nv=00_30_00_0}', "");
    Expect(0, 126248, '\p{Nv=00_30_00_0}', "");
    Expect(1, 126248, '\p{^Nv=00_30_00_0}', "");
    Expect(1, 126248, '\P{Nv=00_30_00_0}', "");
    Expect(0, 126248, '\P{^Nv=00_30_00_0}', "");
    Expect(1, 126247, '\p{Nv=3.000000000000000e+04}', "");
    Expect(0, 126247, '\p{^Nv=3.000000000000000e+04}', "");
    Expect(0, 126247, '\P{Nv=3.000000000000000e+04}', "");
    Expect(1, 126247, '\P{^Nv=3.000000000000000e+04}', "");
    Expect(0, 126248, '\p{Nv=3.000000000000000e+04}', "");
    Expect(1, 126248, '\p{^Nv=3.000000000000000e+04}', "");
    Expect(1, 126248, '\P{Nv=3.000000000000000e+04}', "");
    Expect(0, 126248, '\P{^Nv=3.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value=:=-+003000_0}');
    Error('\P{Is_Numeric_Value=:=-+003000_0}');
    Expect(1, 126247, '\p{Is_Numeric_Value=30000}', "");
    Expect(0, 126247, '\p{^Is_Numeric_Value=30000}', "");
    Expect(0, 126247, '\P{Is_Numeric_Value=30000}', "");
    Expect(1, 126247, '\P{^Is_Numeric_Value=30000}', "");
    Expect(0, 126248, '\p{Is_Numeric_Value=30000}', "");
    Expect(1, 126248, '\p{^Is_Numeric_Value=30000}', "");
    Expect(1, 126248, '\P{Is_Numeric_Value=30000}', "");
    Expect(0, 126248, '\P{^Is_Numeric_Value=30000}', "");
    Expect(1, 126247, '\p{Is_Numeric_Value=3.000000000000000e+04}', "");
    Expect(0, 126247, '\p{^Is_Numeric_Value=3.000000000000000e+04}', "");
    Expect(0, 126247, '\P{Is_Numeric_Value=3.000000000000000e+04}', "");
    Expect(1, 126247, '\P{^Is_Numeric_Value=3.000000000000000e+04}', "");
    Expect(0, 126248, '\p{Is_Numeric_Value=3.000000000000000e+04}', "");
    Expect(1, 126248, '\p{^Is_Numeric_Value=3.000000000000000e+04}', "");
    Expect(1, 126248, '\P{Is_Numeric_Value=3.000000000000000e+04}', "");
    Expect(0, 126248, '\P{^Is_Numeric_Value=3.000000000000000e+04}', "");
    Error('\p{Is_Nv=:= -00030000}');
    Error('\P{Is_Nv=:= -00030000}');
    Expect(1, 126247, '\p{Is_Nv=030000}', "");
    Expect(0, 126247, '\p{^Is_Nv=030000}', "");
    Expect(0, 126247, '\P{Is_Nv=030000}', "");
    Expect(1, 126247, '\P{^Is_Nv=030000}', "");
    Expect(0, 126248, '\p{Is_Nv=030000}', "");
    Expect(1, 126248, '\p{^Is_Nv=030000}', "");
    Expect(1, 126248, '\P{Is_Nv=030000}', "");
    Expect(0, 126248, '\P{^Is_Nv=030000}', "");
    Expect(1, 126247, '\p{Is_Nv=3.000000000000000e+04}', "");
    Expect(0, 126247, '\p{^Is_Nv=3.000000000000000e+04}', "");
    Expect(0, 126247, '\P{Is_Nv=3.000000000000000e+04}', "");
    Expect(1, 126247, '\P{^Is_Nv=3.000000000000000e+04}', "");
    Expect(0, 126248, '\p{Is_Nv=3.000000000000000e+04}', "");
    Expect(1, 126248, '\p{^Is_Nv=3.000000000000000e+04}', "");
    Expect(1, 126248, '\P{Is_Nv=3.000000000000000e+04}', "");
    Expect(0, 126248, '\P{^Is_Nv=3.000000000000000e+04}', "");
    Error('\p{Numeric_Value=	/a/00000_03000_00}');
    Error('\P{Numeric_Value=	/a/00000_03000_00}');
    Expect(1, 68079, '\p{Numeric_Value=:\A300000\z:}', "");;
    Expect(0, 68080, '\p{Numeric_Value=:\A300000\z:}', "");;
    Expect(1, 68079, '\p{Numeric_Value=000000_003000_00}', "");
    Expect(0, 68079, '\p{^Numeric_Value=000000_003000_00}', "");
    Expect(0, 68079, '\P{Numeric_Value=000000_003000_00}', "");
    Expect(1, 68079, '\P{^Numeric_Value=000000_003000_00}', "");
    Expect(0, 68080, '\p{Numeric_Value=000000_003000_00}', "");
    Expect(1, 68080, '\p{^Numeric_Value=000000_003000_00}', "");
    Expect(1, 68080, '\P{Numeric_Value=000000_003000_00}', "");
    Expect(0, 68080, '\P{^Numeric_Value=000000_003000_00}', "");
    Expect(1, 68079, '\p{Numeric_Value=3.000000000000000e+05}', "");
    Expect(0, 68079, '\p{^Numeric_Value=3.000000000000000e+05}', "");
    Expect(0, 68079, '\P{Numeric_Value=3.000000000000000e+05}', "");
    Expect(1, 68079, '\P{^Numeric_Value=3.000000000000000e+05}', "");
    Expect(0, 68080, '\p{Numeric_Value=3.000000000000000e+05}', "");
    Expect(1, 68080, '\p{^Numeric_Value=3.000000000000000e+05}', "");
    Expect(1, 68080, '\P{Numeric_Value=3.000000000000000e+05}', "");
    Expect(0, 68080, '\P{^Numeric_Value=3.000000000000000e+05}', "");
    Error('\p{Nv=_0030000_0/a/}');
    Error('\P{Nv=_0030000_0/a/}');
    Expect(1, 68079, '\p{Nv=:\A300000\z:}', "");;
    Expect(0, 68080, '\p{Nv=:\A300000\z:}', "");;
    Expect(1, 68079, '\p{Nv: +0_0_0_0_3_0_0_000}', "");
    Expect(0, 68079, '\p{^Nv: +0_0_0_0_3_0_0_000}', "");
    Expect(0, 68079, '\P{Nv: +0_0_0_0_3_0_0_000}', "");
    Expect(1, 68079, '\P{^Nv: +0_0_0_0_3_0_0_000}', "");
    Expect(0, 68080, '\p{Nv: +0_0_0_0_3_0_0_000}', "");
    Expect(1, 68080, '\p{^Nv: +0_0_0_0_3_0_0_000}', "");
    Expect(1, 68080, '\P{Nv: +0_0_0_0_3_0_0_000}', "");
    Expect(0, 68080, '\P{^Nv: +0_0_0_0_3_0_0_000}', "");
    Expect(1, 68079, '\p{Nv=3.000000000000000e+05}', "");
    Expect(0, 68079, '\p{^Nv=3.000000000000000e+05}', "");
    Expect(0, 68079, '\P{Nv=3.000000000000000e+05}', "");
    Expect(1, 68079, '\P{^Nv=3.000000000000000e+05}', "");
    Expect(0, 68080, '\p{Nv=3.000000000000000e+05}', "");
    Expect(1, 68080, '\p{^Nv=3.000000000000000e+05}', "");
    Expect(1, 68080, '\P{Nv=3.000000000000000e+05}', "");
    Expect(0, 68080, '\P{^Nv=3.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value=:= 	00000000300000}');
    Error('\P{Is_Numeric_Value=:= 	00000000300000}');
    Expect(1, 68079, '\p{Is_Numeric_Value:	300000}', "");
    Expect(0, 68079, '\p{^Is_Numeric_Value:	300000}', "");
    Expect(0, 68079, '\P{Is_Numeric_Value:	300000}', "");
    Expect(1, 68079, '\P{^Is_Numeric_Value:	300000}', "");
    Expect(0, 68080, '\p{Is_Numeric_Value:	300000}', "");
    Expect(1, 68080, '\p{^Is_Numeric_Value:	300000}', "");
    Expect(1, 68080, '\P{Is_Numeric_Value:	300000}', "");
    Expect(0, 68080, '\P{^Is_Numeric_Value:	300000}', "");
    Expect(1, 68079, '\p{Is_Numeric_Value=3.000000000000000e+05}', "");
    Expect(0, 68079, '\p{^Is_Numeric_Value=3.000000000000000e+05}', "");
    Expect(0, 68079, '\P{Is_Numeric_Value=3.000000000000000e+05}', "");
    Expect(1, 68079, '\P{^Is_Numeric_Value=3.000000000000000e+05}', "");
    Expect(0, 68080, '\p{Is_Numeric_Value=3.000000000000000e+05}', "");
    Expect(1, 68080, '\p{^Is_Numeric_Value=3.000000000000000e+05}', "");
    Expect(1, 68080, '\P{Is_Numeric_Value=3.000000000000000e+05}', "");
    Expect(0, 68080, '\P{^Is_Numeric_Value=3.000000000000000e+05}', "");
    Error('\p{Is_Nv= -000300000:=}');
    Error('\P{Is_Nv= -000300000:=}');
    Expect(1, 68079, '\p{Is_Nv=+0_0_0_0_3_0_0_0_00}', "");
    Expect(0, 68079, '\p{^Is_Nv=+0_0_0_0_3_0_0_0_00}', "");
    Expect(0, 68079, '\P{Is_Nv=+0_0_0_0_3_0_0_0_00}', "");
    Expect(1, 68079, '\P{^Is_Nv=+0_0_0_0_3_0_0_0_00}', "");
    Expect(0, 68080, '\p{Is_Nv=+0_0_0_0_3_0_0_0_00}', "");
    Expect(1, 68080, '\p{^Is_Nv=+0_0_0_0_3_0_0_0_00}', "");
    Expect(1, 68080, '\P{Is_Nv=+0_0_0_0_3_0_0_0_00}', "");
    Expect(0, 68080, '\P{^Is_Nv=+0_0_0_0_3_0_0_0_00}', "");
    Expect(1, 68079, '\p{Is_Nv=3.000000000000000e+05}', "");
    Expect(0, 68079, '\p{^Is_Nv=3.000000000000000e+05}', "");
    Expect(0, 68079, '\P{Is_Nv=3.000000000000000e+05}', "");
    Expect(1, 68079, '\P{^Is_Nv=3.000000000000000e+05}', "");
    Expect(0, 68080, '\p{Is_Nv=3.000000000000000e+05}', "");
    Expect(1, 68080, '\p{^Is_Nv=3.000000000000000e+05}', "");
    Expect(1, 68080, '\P{Is_Nv=3.000000000000000e+05}', "");
    Expect(0, 68080, '\P{^Is_Nv=3.000000000000000e+05}', "");
    Error('\p{Numeric_Value=:=_+3_1}');
    Error('\P{Numeric_Value=:=_+3_1}');
    Expect(1, 12891, '\p{Numeric_Value=:\A31\z:}', "");;
    Expect(0, 12892, '\p{Numeric_Value=:\A31\z:}', "");;
    Expect(1, 12891, '\p{Numeric_Value=+00000000031}', "");
    Expect(0, 12891, '\p{^Numeric_Value=+00000000031}', "");
    Expect(0, 12891, '\P{Numeric_Value=+00000000031}', "");
    Expect(1, 12891, '\P{^Numeric_Value=+00000000031}', "");
    Expect(0, 12892, '\p{Numeric_Value=+00000000031}', "");
    Expect(1, 12892, '\p{^Numeric_Value=+00000000031}', "");
    Expect(1, 12892, '\P{Numeric_Value=+00000000031}', "");
    Expect(0, 12892, '\P{^Numeric_Value=+00000000031}', "");
    Expect(1, 12891, '\p{Numeric_Value=3.100000000000000e+01}', "");
    Expect(0, 12891, '\p{^Numeric_Value=3.100000000000000e+01}', "");
    Expect(0, 12891, '\P{Numeric_Value=3.100000000000000e+01}', "");
    Expect(1, 12891, '\P{^Numeric_Value=3.100000000000000e+01}', "");
    Expect(0, 12892, '\p{Numeric_Value=3.100000000000000e+01}', "");
    Expect(1, 12892, '\p{^Numeric_Value=3.100000000000000e+01}', "");
    Expect(1, 12892, '\P{Numeric_Value=3.100000000000000e+01}', "");
    Expect(0, 12892, '\P{^Numeric_Value=3.100000000000000e+01}', "");
    Error('\p{Nv=-:=+0000000031}');
    Error('\P{Nv=-:=+0000000031}');
    Expect(1, 12891, '\p{Nv=:\A31\z:}', "");;
    Expect(0, 12892, '\p{Nv=:\A31\z:}', "");;
    Expect(1, 12891, '\p{Nv: +0000031}', "");
    Expect(0, 12891, '\p{^Nv: +0000031}', "");
    Expect(0, 12891, '\P{Nv: +0000031}', "");
    Expect(1, 12891, '\P{^Nv: +0000031}', "");
    Expect(0, 12892, '\p{Nv: +0000031}', "");
    Expect(1, 12892, '\p{^Nv: +0000031}', "");
    Expect(1, 12892, '\P{Nv: +0000031}', "");
    Expect(0, 12892, '\P{^Nv: +0000031}', "");
    Expect(1, 12891, '\p{Nv=3.100000000000000e+01}', "");
    Expect(0, 12891, '\p{^Nv=3.100000000000000e+01}', "");
    Expect(0, 12891, '\P{Nv=3.100000000000000e+01}', "");
    Expect(1, 12891, '\P{^Nv=3.100000000000000e+01}', "");
    Expect(0, 12892, '\p{Nv=3.100000000000000e+01}', "");
    Expect(1, 12892, '\p{^Nv=3.100000000000000e+01}', "");
    Expect(1, 12892, '\P{Nv=3.100000000000000e+01}', "");
    Expect(0, 12892, '\P{^Nv=3.100000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=-/a/+0_0_0_0_0_0_0_031}');
    Error('\P{Is_Numeric_Value=-/a/+0_0_0_0_0_0_0_031}');
    Expect(1, 12891, '\p{Is_Numeric_Value=3_1}', "");
    Expect(0, 12891, '\p{^Is_Numeric_Value=3_1}', "");
    Expect(0, 12891, '\P{Is_Numeric_Value=3_1}', "");
    Expect(1, 12891, '\P{^Is_Numeric_Value=3_1}', "");
    Expect(0, 12892, '\p{Is_Numeric_Value=3_1}', "");
    Expect(1, 12892, '\p{^Is_Numeric_Value=3_1}', "");
    Expect(1, 12892, '\P{Is_Numeric_Value=3_1}', "");
    Expect(0, 12892, '\P{^Is_Numeric_Value=3_1}', "");
    Expect(1, 12891, '\p{Is_Numeric_Value=3.100000000000000e+01}', "");
    Expect(0, 12891, '\p{^Is_Numeric_Value=3.100000000000000e+01}', "");
    Expect(0, 12891, '\P{Is_Numeric_Value=3.100000000000000e+01}', "");
    Expect(1, 12891, '\P{^Is_Numeric_Value=3.100000000000000e+01}', "");
    Expect(0, 12892, '\p{Is_Numeric_Value=3.100000000000000e+01}', "");
    Expect(1, 12892, '\p{^Is_Numeric_Value=3.100000000000000e+01}', "");
    Expect(1, 12892, '\P{Is_Numeric_Value=3.100000000000000e+01}', "");
    Expect(0, 12892, '\P{^Is_Numeric_Value=3.100000000000000e+01}', "");
    Error('\p{Is_Nv=:=+00031}');
    Error('\P{Is_Nv=:=+00031}');
    Expect(1, 12891, '\p{Is_Nv=03_1}', "");
    Expect(0, 12891, '\p{^Is_Nv=03_1}', "");
    Expect(0, 12891, '\P{Is_Nv=03_1}', "");
    Expect(1, 12891, '\P{^Is_Nv=03_1}', "");
    Expect(0, 12892, '\p{Is_Nv=03_1}', "");
    Expect(1, 12892, '\p{^Is_Nv=03_1}', "");
    Expect(1, 12892, '\P{Is_Nv=03_1}', "");
    Expect(0, 12892, '\P{^Is_Nv=03_1}', "");
    Expect(1, 12891, '\p{Is_Nv:3.100000000000000e+01}', "");
    Expect(0, 12891, '\p{^Is_Nv:3.100000000000000e+01}', "");
    Expect(0, 12891, '\P{Is_Nv:3.100000000000000e+01}', "");
    Expect(1, 12891, '\P{^Is_Nv:3.100000000000000e+01}', "");
    Expect(0, 12892, '\p{Is_Nv:3.100000000000000e+01}', "");
    Expect(1, 12892, '\p{^Is_Nv:3.100000000000000e+01}', "");
    Expect(1, 12892, '\P{Is_Nv:3.100000000000000e+01}', "");
    Expect(0, 12892, '\P{^Is_Nv:3.100000000000000e+01}', "");
    Error('\p{Numeric_Value=	:=3_2}');
    Error('\P{Numeric_Value=	:=3_2}');
    Expect(1, 12892, '\p{Numeric_Value=:\A32\z:}', "");;
    Expect(0, 12893, '\p{Numeric_Value=:\A32\z:}', "");;
    Expect(1, 12892, '\p{Numeric_Value=003_2}', "");
    Expect(0, 12892, '\p{^Numeric_Value=003_2}', "");
    Expect(0, 12892, '\P{Numeric_Value=003_2}', "");
    Expect(1, 12892, '\P{^Numeric_Value=003_2}', "");
    Expect(0, 12893, '\p{Numeric_Value=003_2}', "");
    Expect(1, 12893, '\p{^Numeric_Value=003_2}', "");
    Expect(1, 12893, '\P{Numeric_Value=003_2}', "");
    Expect(0, 12893, '\P{^Numeric_Value=003_2}', "");
    Expect(1, 12892, '\p{Numeric_Value=3.200000000000000e+01}', "");
    Expect(0, 12892, '\p{^Numeric_Value=3.200000000000000e+01}', "");
    Expect(0, 12892, '\P{Numeric_Value=3.200000000000000e+01}', "");
    Expect(1, 12892, '\P{^Numeric_Value=3.200000000000000e+01}', "");
    Expect(0, 12893, '\p{Numeric_Value=3.200000000000000e+01}', "");
    Expect(1, 12893, '\p{^Numeric_Value=3.200000000000000e+01}', "");
    Expect(1, 12893, '\P{Numeric_Value=3.200000000000000e+01}', "");
    Expect(0, 12893, '\P{^Numeric_Value=3.200000000000000e+01}', "");
    Error('\p{Nv=:=-032}');
    Error('\P{Nv=:=-032}');
    Expect(1, 12892, '\p{Nv=:\A32\z:}', "");;
    Expect(0, 12893, '\p{Nv=:\A32\z:}', "");;
    Expect(1, 12892, '\p{Nv=3_2}', "");
    Expect(0, 12892, '\p{^Nv=3_2}', "");
    Expect(0, 12892, '\P{Nv=3_2}', "");
    Expect(1, 12892, '\P{^Nv=3_2}', "");
    Expect(0, 12893, '\p{Nv=3_2}', "");
    Expect(1, 12893, '\p{^Nv=3_2}', "");
    Expect(1, 12893, '\P{Nv=3_2}', "");
    Expect(0, 12893, '\P{^Nv=3_2}', "");
    Expect(1, 12892, '\p{Nv=3.200000000000000e+01}', "");
    Expect(0, 12892, '\p{^Nv=3.200000000000000e+01}', "");
    Expect(0, 12892, '\P{Nv=3.200000000000000e+01}', "");
    Expect(1, 12892, '\P{^Nv=3.200000000000000e+01}', "");
    Expect(0, 12893, '\p{Nv=3.200000000000000e+01}', "");
    Expect(1, 12893, '\p{^Nv=3.200000000000000e+01}', "");
    Expect(1, 12893, '\P{Nv=3.200000000000000e+01}', "");
    Expect(0, 12893, '\P{^Nv=3.200000000000000e+01}', "");
    Error('\p{Is_Numeric_Value:		_3_2:=}');
    Error('\P{Is_Numeric_Value:		_3_2:=}');
    Expect(1, 12892, '\p{Is_Numeric_Value:   +000032}', "");
    Expect(0, 12892, '\p{^Is_Numeric_Value:   +000032}', "");
    Expect(0, 12892, '\P{Is_Numeric_Value:   +000032}', "");
    Expect(1, 12892, '\P{^Is_Numeric_Value:   +000032}', "");
    Expect(0, 12893, '\p{Is_Numeric_Value:   +000032}', "");
    Expect(1, 12893, '\p{^Is_Numeric_Value:   +000032}', "");
    Expect(1, 12893, '\P{Is_Numeric_Value:   +000032}', "");
    Expect(0, 12893, '\P{^Is_Numeric_Value:   +000032}', "");
    Expect(1, 12892, '\p{Is_Numeric_Value=3.200000000000000e+01}', "");
    Expect(0, 12892, '\p{^Is_Numeric_Value=3.200000000000000e+01}', "");
    Expect(0, 12892, '\P{Is_Numeric_Value=3.200000000000000e+01}', "");
    Expect(1, 12892, '\P{^Is_Numeric_Value=3.200000000000000e+01}', "");
    Expect(0, 12893, '\p{Is_Numeric_Value=3.200000000000000e+01}', "");
    Expect(1, 12893, '\p{^Is_Numeric_Value=3.200000000000000e+01}', "");
    Expect(1, 12893, '\P{Is_Numeric_Value=3.200000000000000e+01}', "");
    Expect(0, 12893, '\P{^Is_Numeric_Value=3.200000000000000e+01}', "");
    Error('\p{Is_Nv=--0000000032:=}');
    Error('\P{Is_Nv=--0000000032:=}');
    Expect(1, 12892, '\p{Is_Nv=3_2}', "");
    Expect(0, 12892, '\p{^Is_Nv=3_2}', "");
    Expect(0, 12892, '\P{Is_Nv=3_2}', "");
    Expect(1, 12892, '\P{^Is_Nv=3_2}', "");
    Expect(0, 12893, '\p{Is_Nv=3_2}', "");
    Expect(1, 12893, '\p{^Is_Nv=3_2}', "");
    Expect(1, 12893, '\P{Is_Nv=3_2}', "");
    Expect(0, 12893, '\P{^Is_Nv=3_2}', "");
    Expect(1, 12892, '\p{Is_Nv=3.200000000000000e+01}', "");
    Expect(0, 12892, '\p{^Is_Nv=3.200000000000000e+01}', "");
    Expect(0, 12892, '\P{Is_Nv=3.200000000000000e+01}', "");
    Expect(1, 12892, '\P{^Is_Nv=3.200000000000000e+01}', "");
    Expect(0, 12893, '\p{Is_Nv=3.200000000000000e+01}', "");
    Expect(1, 12893, '\p{^Is_Nv=3.200000000000000e+01}', "");
    Expect(1, 12893, '\P{Is_Nv=3.200000000000000e+01}', "");
    Expect(0, 12893, '\P{^Is_Nv=3.200000000000000e+01}', "");
    Error('\p{Numeric_Value=	/a/+0000033}');
    Error('\P{Numeric_Value=	/a/+0000033}');
    Expect(1, 12893, '\p{Numeric_Value=:\A33\z:}', "");;
    Expect(0, 12894, '\p{Numeric_Value=:\A33\z:}', "");;
    Expect(1, 12893, '\p{Numeric_Value=+3_3}', "");
    Expect(0, 12893, '\p{^Numeric_Value=+3_3}', "");
    Expect(0, 12893, '\P{Numeric_Value=+3_3}', "");
    Expect(1, 12893, '\P{^Numeric_Value=+3_3}', "");
    Expect(0, 12894, '\p{Numeric_Value=+3_3}', "");
    Expect(1, 12894, '\p{^Numeric_Value=+3_3}', "");
    Expect(1, 12894, '\P{Numeric_Value=+3_3}', "");
    Expect(0, 12894, '\P{^Numeric_Value=+3_3}', "");
    Expect(1, 12893, '\p{Numeric_Value=3.300000000000000e+01}', "");
    Expect(0, 12893, '\p{^Numeric_Value=3.300000000000000e+01}', "");
    Expect(0, 12893, '\P{Numeric_Value=3.300000000000000e+01}', "");
    Expect(1, 12893, '\P{^Numeric_Value=3.300000000000000e+01}', "");
    Expect(0, 12894, '\p{Numeric_Value=3.300000000000000e+01}', "");
    Expect(1, 12894, '\p{^Numeric_Value=3.300000000000000e+01}', "");
    Expect(1, 12894, '\P{Numeric_Value=3.300000000000000e+01}', "");
    Expect(0, 12894, '\P{^Numeric_Value=3.300000000000000e+01}', "");
    Error('\p{Nv=:=	_+00000000033}');
    Error('\P{Nv=:=	_+00000000033}');
    Expect(1, 12893, '\p{Nv=:\A33\z:}', "");;
    Expect(0, 12894, '\p{Nv=:\A33\z:}', "");;
    Expect(1, 12893, '\p{Nv=00003_3}', "");
    Expect(0, 12893, '\p{^Nv=00003_3}', "");
    Expect(0, 12893, '\P{Nv=00003_3}', "");
    Expect(1, 12893, '\P{^Nv=00003_3}', "");
    Expect(0, 12894, '\p{Nv=00003_3}', "");
    Expect(1, 12894, '\p{^Nv=00003_3}', "");
    Expect(1, 12894, '\P{Nv=00003_3}', "");
    Expect(0, 12894, '\P{^Nv=00003_3}', "");
    Expect(1, 12893, '\p{Nv=3.300000000000000e+01}', "");
    Expect(0, 12893, '\p{^Nv=3.300000000000000e+01}', "");
    Expect(0, 12893, '\P{Nv=3.300000000000000e+01}', "");
    Expect(1, 12893, '\P{^Nv=3.300000000000000e+01}', "");
    Expect(0, 12894, '\p{Nv=3.300000000000000e+01}', "");
    Expect(1, 12894, '\p{^Nv=3.300000000000000e+01}', "");
    Expect(1, 12894, '\P{Nv=3.300000000000000e+01}', "");
    Expect(0, 12894, '\P{^Nv=3.300000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=:=		0000_0003_3}');
    Error('\P{Is_Numeric_Value=:=		0000_0003_3}');
    Expect(1, 12893, '\p{Is_Numeric_Value: 00033}', "");
    Expect(0, 12893, '\p{^Is_Numeric_Value: 00033}', "");
    Expect(0, 12893, '\P{Is_Numeric_Value: 00033}', "");
    Expect(1, 12893, '\P{^Is_Numeric_Value: 00033}', "");
    Expect(0, 12894, '\p{Is_Numeric_Value: 00033}', "");
    Expect(1, 12894, '\p{^Is_Numeric_Value: 00033}', "");
    Expect(1, 12894, '\P{Is_Numeric_Value: 00033}', "");
    Expect(0, 12894, '\P{^Is_Numeric_Value: 00033}', "");
    Expect(1, 12893, '\p{Is_Numeric_Value=3.300000000000000e+01}', "");
    Expect(0, 12893, '\p{^Is_Numeric_Value=3.300000000000000e+01}', "");
    Expect(0, 12893, '\P{Is_Numeric_Value=3.300000000000000e+01}', "");
    Expect(1, 12893, '\P{^Is_Numeric_Value=3.300000000000000e+01}', "");
    Expect(0, 12894, '\p{Is_Numeric_Value=3.300000000000000e+01}', "");
    Expect(1, 12894, '\p{^Is_Numeric_Value=3.300000000000000e+01}', "");
    Expect(1, 12894, '\P{Is_Numeric_Value=3.300000000000000e+01}', "");
    Expect(0, 12894, '\P{^Is_Numeric_Value=3.300000000000000e+01}', "");
    Error('\p{Is_Nv=/a/	+0_0_0_0_0033}');
    Error('\P{Is_Nv=/a/	+0_0_0_0_0033}');
    Expect(1, 12893, '\p{Is_Nv=+0033}', "");
    Expect(0, 12893, '\p{^Is_Nv=+0033}', "");
    Expect(0, 12893, '\P{Is_Nv=+0033}', "");
    Expect(1, 12893, '\P{^Is_Nv=+0033}', "");
    Expect(0, 12894, '\p{Is_Nv=+0033}', "");
    Expect(1, 12894, '\p{^Is_Nv=+0033}', "");
    Expect(1, 12894, '\P{Is_Nv=+0033}', "");
    Expect(0, 12894, '\P{^Is_Nv=+0033}', "");
    Expect(1, 12893, '\p{Is_Nv=3.300000000000000e+01}', "");
    Expect(0, 12893, '\p{^Is_Nv=3.300000000000000e+01}', "");
    Expect(0, 12893, '\P{Is_Nv=3.300000000000000e+01}', "");
    Expect(1, 12893, '\P{^Is_Nv=3.300000000000000e+01}', "");
    Expect(0, 12894, '\p{Is_Nv=3.300000000000000e+01}', "");
    Expect(1, 12894, '\p{^Is_Nv=3.300000000000000e+01}', "");
    Expect(1, 12894, '\P{Is_Nv=3.300000000000000e+01}', "");
    Expect(0, 12894, '\P{^Is_Nv=3.300000000000000e+01}', "");
    Error('\p{Numeric_Value: :=  000000034}');
    Error('\P{Numeric_Value: :=  000000034}');
    Expect(1, 12894, '\p{Numeric_Value=:\A34\z:}', "");;
    Expect(0, 12895, '\p{Numeric_Value=:\A34\z:}', "");;
    Expect(1, 12894, '\p{Numeric_Value=+0003_4}', "");
    Expect(0, 12894, '\p{^Numeric_Value=+0003_4}', "");
    Expect(0, 12894, '\P{Numeric_Value=+0003_4}', "");
    Expect(1, 12894, '\P{^Numeric_Value=+0003_4}', "");
    Expect(0, 12895, '\p{Numeric_Value=+0003_4}', "");
    Expect(1, 12895, '\p{^Numeric_Value=+0003_4}', "");
    Expect(1, 12895, '\P{Numeric_Value=+0003_4}', "");
    Expect(0, 12895, '\P{^Numeric_Value=+0003_4}', "");
    Expect(1, 12894, '\p{Numeric_Value=3.400000000000000e+01}', "");
    Expect(0, 12894, '\p{^Numeric_Value=3.400000000000000e+01}', "");
    Expect(0, 12894, '\P{Numeric_Value=3.400000000000000e+01}', "");
    Expect(1, 12894, '\P{^Numeric_Value=3.400000000000000e+01}', "");
    Expect(0, 12895, '\p{Numeric_Value=3.400000000000000e+01}', "");
    Expect(1, 12895, '\p{^Numeric_Value=3.400000000000000e+01}', "");
    Expect(1, 12895, '\P{Numeric_Value=3.400000000000000e+01}', "");
    Expect(0, 12895, '\P{^Numeric_Value=3.400000000000000e+01}', "");
    Error('\p{Nv=/a/000000003_4}');
    Error('\P{Nv=/a/000000003_4}');
    Expect(1, 12894, '\p{Nv=:\A34\z:}', "");;
    Expect(0, 12895, '\p{Nv=:\A34\z:}', "");;
    Expect(1, 12894, '\p{Nv=00003_4}', "");
    Expect(0, 12894, '\p{^Nv=00003_4}', "");
    Expect(0, 12894, '\P{Nv=00003_4}', "");
    Expect(1, 12894, '\P{^Nv=00003_4}', "");
    Expect(0, 12895, '\p{Nv=00003_4}', "");
    Expect(1, 12895, '\p{^Nv=00003_4}', "");
    Expect(1, 12895, '\P{Nv=00003_4}', "");
    Expect(0, 12895, '\P{^Nv=00003_4}', "");
    Expect(1, 12894, '\p{Nv=3.400000000000000e+01}', "");
    Expect(0, 12894, '\p{^Nv=3.400000000000000e+01}', "");
    Expect(0, 12894, '\P{Nv=3.400000000000000e+01}', "");
    Expect(1, 12894, '\P{^Nv=3.400000000000000e+01}', "");
    Expect(0, 12895, '\p{Nv=3.400000000000000e+01}', "");
    Expect(1, 12895, '\p{^Nv=3.400000000000000e+01}', "");
    Expect(1, 12895, '\P{Nv=3.400000000000000e+01}', "");
    Expect(0, 12895, '\P{^Nv=3.400000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=:=-	+034}');
    Error('\P{Is_Numeric_Value=:=-	+034}');
    Expect(1, 12894, '\p{Is_Numeric_Value=+3_4}', "");
    Expect(0, 12894, '\p{^Is_Numeric_Value=+3_4}', "");
    Expect(0, 12894, '\P{Is_Numeric_Value=+3_4}', "");
    Expect(1, 12894, '\P{^Is_Numeric_Value=+3_4}', "");
    Expect(0, 12895, '\p{Is_Numeric_Value=+3_4}', "");
    Expect(1, 12895, '\p{^Is_Numeric_Value=+3_4}', "");
    Expect(1, 12895, '\P{Is_Numeric_Value=+3_4}', "");
    Expect(0, 12895, '\P{^Is_Numeric_Value=+3_4}', "");
    Expect(1, 12894, '\p{Is_Numeric_Value=3.400000000000000e+01}', "");
    Expect(0, 12894, '\p{^Is_Numeric_Value=3.400000000000000e+01}', "");
    Expect(0, 12894, '\P{Is_Numeric_Value=3.400000000000000e+01}', "");
    Expect(1, 12894, '\P{^Is_Numeric_Value=3.400000000000000e+01}', "");
    Expect(0, 12895, '\p{Is_Numeric_Value=3.400000000000000e+01}', "");
    Expect(1, 12895, '\p{^Is_Numeric_Value=3.400000000000000e+01}', "");
    Expect(1, 12895, '\P{Is_Numeric_Value=3.400000000000000e+01}', "");
    Expect(0, 12895, '\P{^Is_Numeric_Value=3.400000000000000e+01}', "");
    Error('\p{Is_Nv=/a/	_+0003_4}');
    Error('\P{Is_Nv=/a/	_+0003_4}');
    Expect(1, 12894, '\p{Is_Nv:00_03_4}', "");
    Expect(0, 12894, '\p{^Is_Nv:00_03_4}', "");
    Expect(0, 12894, '\P{Is_Nv:00_03_4}', "");
    Expect(1, 12894, '\P{^Is_Nv:00_03_4}', "");
    Expect(0, 12895, '\p{Is_Nv:00_03_4}', "");
    Expect(1, 12895, '\p{^Is_Nv:00_03_4}', "");
    Expect(1, 12895, '\P{Is_Nv:00_03_4}', "");
    Expect(0, 12895, '\P{^Is_Nv:00_03_4}', "");
    Expect(1, 12894, '\p{Is_Nv=3.400000000000000e+01}', "");
    Expect(0, 12894, '\p{^Is_Nv=3.400000000000000e+01}', "");
    Expect(0, 12894, '\P{Is_Nv=3.400000000000000e+01}', "");
    Expect(1, 12894, '\P{^Is_Nv=3.400000000000000e+01}', "");
    Expect(0, 12895, '\p{Is_Nv=3.400000000000000e+01}', "");
    Expect(1, 12895, '\p{^Is_Nv=3.400000000000000e+01}', "");
    Expect(1, 12895, '\P{Is_Nv=3.400000000000000e+01}', "");
    Expect(0, 12895, '\P{^Is_Nv=3.400000000000000e+01}', "");
    Error('\p{Numeric_Value= /a/035}');
    Error('\P{Numeric_Value= /a/035}');
    Expect(1, 12895, '\p{Numeric_Value=:\A35\z:}', "");;
    Expect(0, 12896, '\p{Numeric_Value=:\A35\z:}', "");;
    Expect(1, 12895, '\p{Numeric_Value:   +0000000035}', "");
    Expect(0, 12895, '\p{^Numeric_Value:   +0000000035}', "");
    Expect(0, 12895, '\P{Numeric_Value:   +0000000035}', "");
    Expect(1, 12895, '\P{^Numeric_Value:   +0000000035}', "");
    Expect(0, 12896, '\p{Numeric_Value:   +0000000035}', "");
    Expect(1, 12896, '\p{^Numeric_Value:   +0000000035}', "");
    Expect(1, 12896, '\P{Numeric_Value:   +0000000035}', "");
    Expect(0, 12896, '\P{^Numeric_Value:   +0000000035}', "");
    Expect(1, 12895, '\p{Numeric_Value=3.500000000000000e+01}', "");
    Expect(0, 12895, '\p{^Numeric_Value=3.500000000000000e+01}', "");
    Expect(0, 12895, '\P{Numeric_Value=3.500000000000000e+01}', "");
    Expect(1, 12895, '\P{^Numeric_Value=3.500000000000000e+01}', "");
    Expect(0, 12896, '\p{Numeric_Value=3.500000000000000e+01}', "");
    Expect(1, 12896, '\p{^Numeric_Value=3.500000000000000e+01}', "");
    Expect(1, 12896, '\P{Numeric_Value=3.500000000000000e+01}', "");
    Expect(0, 12896, '\P{^Numeric_Value=3.500000000000000e+01}', "");
    Error('\p{Nv= /a/035}');
    Error('\P{Nv= /a/035}');
    Expect(1, 12895, '\p{Nv=:\A35\z:}', "");;
    Expect(0, 12896, '\p{Nv=:\A35\z:}', "");;
    Expect(1, 12895, '\p{Nv=00000000035}', "");
    Expect(0, 12895, '\p{^Nv=00000000035}', "");
    Expect(0, 12895, '\P{Nv=00000000035}', "");
    Expect(1, 12895, '\P{^Nv=00000000035}', "");
    Expect(0, 12896, '\p{Nv=00000000035}', "");
    Expect(1, 12896, '\p{^Nv=00000000035}', "");
    Expect(1, 12896, '\P{Nv=00000000035}', "");
    Expect(0, 12896, '\P{^Nv=00000000035}', "");
    Expect(1, 12895, '\p{Nv=3.500000000000000e+01}', "");
    Expect(0, 12895, '\p{^Nv=3.500000000000000e+01}', "");
    Expect(0, 12895, '\P{Nv=3.500000000000000e+01}', "");
    Expect(1, 12895, '\P{^Nv=3.500000000000000e+01}', "");
    Expect(0, 12896, '\p{Nv=3.500000000000000e+01}', "");
    Expect(1, 12896, '\p{^Nv=3.500000000000000e+01}', "");
    Expect(1, 12896, '\P{Nv=3.500000000000000e+01}', "");
    Expect(0, 12896, '\P{^Nv=3.500000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=	0035/a/}');
    Error('\P{Is_Numeric_Value=	0035/a/}');
    Expect(1, 12895, '\p{Is_Numeric_Value=00000035}', "");
    Expect(0, 12895, '\p{^Is_Numeric_Value=00000035}', "");
    Expect(0, 12895, '\P{Is_Numeric_Value=00000035}', "");
    Expect(1, 12895, '\P{^Is_Numeric_Value=00000035}', "");
    Expect(0, 12896, '\p{Is_Numeric_Value=00000035}', "");
    Expect(1, 12896, '\p{^Is_Numeric_Value=00000035}', "");
    Expect(1, 12896, '\P{Is_Numeric_Value=00000035}', "");
    Expect(0, 12896, '\P{^Is_Numeric_Value=00000035}', "");
    Expect(1, 12895, '\p{Is_Numeric_Value=3.500000000000000e+01}', "");
    Expect(0, 12895, '\p{^Is_Numeric_Value=3.500000000000000e+01}', "");
    Expect(0, 12895, '\P{Is_Numeric_Value=3.500000000000000e+01}', "");
    Expect(1, 12895, '\P{^Is_Numeric_Value=3.500000000000000e+01}', "");
    Expect(0, 12896, '\p{Is_Numeric_Value=3.500000000000000e+01}', "");
    Expect(1, 12896, '\p{^Is_Numeric_Value=3.500000000000000e+01}', "");
    Expect(1, 12896, '\P{Is_Numeric_Value=3.500000000000000e+01}', "");
    Expect(0, 12896, '\P{^Is_Numeric_Value=3.500000000000000e+01}', "");
    Error('\p{Is_Nv=-00_00_35:=}');
    Error('\P{Is_Nv=-00_00_35:=}');
    Expect(1, 12895, '\p{Is_Nv=+0035}', "");
    Expect(0, 12895, '\p{^Is_Nv=+0035}', "");
    Expect(0, 12895, '\P{Is_Nv=+0035}', "");
    Expect(1, 12895, '\P{^Is_Nv=+0035}', "");
    Expect(0, 12896, '\p{Is_Nv=+0035}', "");
    Expect(1, 12896, '\p{^Is_Nv=+0035}', "");
    Expect(1, 12896, '\P{Is_Nv=+0035}', "");
    Expect(0, 12896, '\P{^Is_Nv=+0035}', "");
    Expect(1, 12895, '\p{Is_Nv=3.500000000000000e+01}', "");
    Expect(0, 12895, '\p{^Is_Nv=3.500000000000000e+01}', "");
    Expect(0, 12895, '\P{Is_Nv=3.500000000000000e+01}', "");
    Expect(1, 12895, '\P{^Is_Nv=3.500000000000000e+01}', "");
    Expect(0, 12896, '\p{Is_Nv=3.500000000000000e+01}', "");
    Expect(1, 12896, '\p{^Is_Nv=3.500000000000000e+01}', "");
    Expect(1, 12896, '\P{Is_Nv=3.500000000000000e+01}', "");
    Expect(0, 12896, '\P{^Is_Nv=3.500000000000000e+01}', "");
    Error('\p{Numeric_Value=-:=0000000036}');
    Error('\P{Numeric_Value=-:=0000000036}');
    Expect(1, 12977, '\p{Numeric_Value=:\A36\z:}', "");;
    Expect(0, 12978, '\p{Numeric_Value=:\A36\z:}', "");;
    Expect(1, 12977, '\p{Numeric_Value=0000000036}', "");
    Expect(0, 12977, '\p{^Numeric_Value=0000000036}', "");
    Expect(0, 12977, '\P{Numeric_Value=0000000036}', "");
    Expect(1, 12977, '\P{^Numeric_Value=0000000036}', "");
    Expect(0, 12978, '\p{Numeric_Value=0000000036}', "");
    Expect(1, 12978, '\p{^Numeric_Value=0000000036}', "");
    Expect(1, 12978, '\P{Numeric_Value=0000000036}', "");
    Expect(0, 12978, '\P{^Numeric_Value=0000000036}', "");
    Expect(1, 12977, '\p{Numeric_Value=3.600000000000000e+01}', "");
    Expect(0, 12977, '\p{^Numeric_Value=3.600000000000000e+01}', "");
    Expect(0, 12977, '\P{Numeric_Value=3.600000000000000e+01}', "");
    Expect(1, 12977, '\P{^Numeric_Value=3.600000000000000e+01}', "");
    Expect(0, 12978, '\p{Numeric_Value=3.600000000000000e+01}', "");
    Expect(1, 12978, '\p{^Numeric_Value=3.600000000000000e+01}', "");
    Expect(1, 12978, '\P{Numeric_Value=3.600000000000000e+01}', "");
    Expect(0, 12978, '\P{^Numeric_Value=3.600000000000000e+01}', "");
    Error('\p{Nv=		+03_6:=}');
    Error('\P{Nv=		+03_6:=}');
    Expect(1, 12977, '\p{Nv=:\A36\z:}', "");;
    Expect(0, 12978, '\p{Nv=:\A36\z:}', "");;
    Expect(1, 12977, '\p{Nv=+00000000036}', "");
    Expect(0, 12977, '\p{^Nv=+00000000036}', "");
    Expect(0, 12977, '\P{Nv=+00000000036}', "");
    Expect(1, 12977, '\P{^Nv=+00000000036}', "");
    Expect(0, 12978, '\p{Nv=+00000000036}', "");
    Expect(1, 12978, '\p{^Nv=+00000000036}', "");
    Expect(1, 12978, '\P{Nv=+00000000036}', "");
    Expect(0, 12978, '\P{^Nv=+00000000036}', "");
    Expect(1, 12977, '\p{Nv=3.600000000000000e+01}', "");
    Expect(0, 12977, '\p{^Nv=3.600000000000000e+01}', "");
    Expect(0, 12977, '\P{Nv=3.600000000000000e+01}', "");
    Expect(1, 12977, '\P{^Nv=3.600000000000000e+01}', "");
    Expect(0, 12978, '\p{Nv=3.600000000000000e+01}', "");
    Expect(1, 12978, '\p{^Nv=3.600000000000000e+01}', "");
    Expect(1, 12978, '\P{Nv=3.600000000000000e+01}', "");
    Expect(0, 12978, '\P{^Nv=3.600000000000000e+01}', "");
    Error('\p{Is_Numeric_Value:		0_0_0_036/a/}');
    Error('\P{Is_Numeric_Value:		0_0_0_036/a/}');
    Expect(1, 12977, '\p{Is_Numeric_Value=0_0_0_0_0_00036}', "");
    Expect(0, 12977, '\p{^Is_Numeric_Value=0_0_0_0_0_00036}', "");
    Expect(0, 12977, '\P{Is_Numeric_Value=0_0_0_0_0_00036}', "");
    Expect(1, 12977, '\P{^Is_Numeric_Value=0_0_0_0_0_00036}', "");
    Expect(0, 12978, '\p{Is_Numeric_Value=0_0_0_0_0_00036}', "");
    Expect(1, 12978, '\p{^Is_Numeric_Value=0_0_0_0_0_00036}', "");
    Expect(1, 12978, '\P{Is_Numeric_Value=0_0_0_0_0_00036}', "");
    Expect(0, 12978, '\P{^Is_Numeric_Value=0_0_0_0_0_00036}', "");
    Expect(1, 12977, '\p{Is_Numeric_Value=3.600000000000000e+01}', "");
    Expect(0, 12977, '\p{^Is_Numeric_Value=3.600000000000000e+01}', "");
    Expect(0, 12977, '\P{Is_Numeric_Value=3.600000000000000e+01}', "");
    Expect(1, 12977, '\P{^Is_Numeric_Value=3.600000000000000e+01}', "");
    Expect(0, 12978, '\p{Is_Numeric_Value=3.600000000000000e+01}', "");
    Expect(1, 12978, '\p{^Is_Numeric_Value=3.600000000000000e+01}', "");
    Expect(1, 12978, '\P{Is_Numeric_Value=3.600000000000000e+01}', "");
    Expect(0, 12978, '\P{^Is_Numeric_Value=3.600000000000000e+01}', "");
    Error('\p{Is_Nv:   -_3_6:=}');
    Error('\P{Is_Nv:   -_3_6:=}');
    Expect(1, 12977, '\p{Is_Nv=+0036}', "");
    Expect(0, 12977, '\p{^Is_Nv=+0036}', "");
    Expect(0, 12977, '\P{Is_Nv=+0036}', "");
    Expect(1, 12977, '\P{^Is_Nv=+0036}', "");
    Expect(0, 12978, '\p{Is_Nv=+0036}', "");
    Expect(1, 12978, '\p{^Is_Nv=+0036}', "");
    Expect(1, 12978, '\P{Is_Nv=+0036}', "");
    Expect(0, 12978, '\P{^Is_Nv=+0036}', "");
    Expect(1, 12977, '\p{Is_Nv=3.600000000000000e+01}', "");
    Expect(0, 12977, '\p{^Is_Nv=3.600000000000000e+01}', "");
    Expect(0, 12977, '\P{Is_Nv=3.600000000000000e+01}', "");
    Expect(1, 12977, '\P{^Is_Nv=3.600000000000000e+01}', "");
    Expect(0, 12978, '\p{Is_Nv=3.600000000000000e+01}', "");
    Expect(1, 12978, '\p{^Is_Nv=3.600000000000000e+01}', "");
    Expect(1, 12978, '\P{Is_Nv=3.600000000000000e+01}', "");
    Expect(0, 12978, '\P{^Is_Nv=3.600000000000000e+01}', "");
    Error('\p{Numeric_Value:		:=00_00_37}');
    Error('\P{Numeric_Value:		:=00_00_37}');
    Expect(1, 12978, '\p{Numeric_Value=:\A37\z:}', "");;
    Expect(0, 12979, '\p{Numeric_Value=:\A37\z:}', "");;
    Expect(1, 12978, '\p{Numeric_Value=+00_00_03_7}', "");
    Expect(0, 12978, '\p{^Numeric_Value=+00_00_03_7}', "");
    Expect(0, 12978, '\P{Numeric_Value=+00_00_03_7}', "");
    Expect(1, 12978, '\P{^Numeric_Value=+00_00_03_7}', "");
    Expect(0, 12979, '\p{Numeric_Value=+00_00_03_7}', "");
    Expect(1, 12979, '\p{^Numeric_Value=+00_00_03_7}', "");
    Expect(1, 12979, '\P{Numeric_Value=+00_00_03_7}', "");
    Expect(0, 12979, '\P{^Numeric_Value=+00_00_03_7}', "");
    Expect(1, 12978, '\p{Numeric_Value=3.700000000000000e+01}', "");
    Expect(0, 12978, '\p{^Numeric_Value=3.700000000000000e+01}', "");
    Expect(0, 12978, '\P{Numeric_Value=3.700000000000000e+01}', "");
    Expect(1, 12978, '\P{^Numeric_Value=3.700000000000000e+01}', "");
    Expect(0, 12979, '\p{Numeric_Value=3.700000000000000e+01}', "");
    Expect(1, 12979, '\p{^Numeric_Value=3.700000000000000e+01}', "");
    Expect(1, 12979, '\P{Numeric_Value=3.700000000000000e+01}', "");
    Expect(0, 12979, '\P{^Numeric_Value=3.700000000000000e+01}', "");
    Error('\p{Nv=:=_-+0037}');
    Error('\P{Nv=:=_-+0037}');
    Expect(1, 12978, '\p{Nv=:\A37\z:}', "");;
    Expect(0, 12979, '\p{Nv=:\A37\z:}', "");;
    Expect(1, 12978, '\p{Nv=03_7}', "");
    Expect(0, 12978, '\p{^Nv=03_7}', "");
    Expect(0, 12978, '\P{Nv=03_7}', "");
    Expect(1, 12978, '\P{^Nv=03_7}', "");
    Expect(0, 12979, '\p{Nv=03_7}', "");
    Expect(1, 12979, '\p{^Nv=03_7}', "");
    Expect(1, 12979, '\P{Nv=03_7}', "");
    Expect(0, 12979, '\P{^Nv=03_7}', "");
    Expect(1, 12978, '\p{Nv=3.700000000000000e+01}', "");
    Expect(0, 12978, '\p{^Nv=3.700000000000000e+01}', "");
    Expect(0, 12978, '\P{Nv=3.700000000000000e+01}', "");
    Expect(1, 12978, '\P{^Nv=3.700000000000000e+01}', "");
    Expect(0, 12979, '\p{Nv=3.700000000000000e+01}', "");
    Expect(1, 12979, '\p{^Nv=3.700000000000000e+01}', "");
    Expect(1, 12979, '\P{Nv=3.700000000000000e+01}', "");
    Expect(0, 12979, '\P{^Nv=3.700000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=	0000000037:=}');
    Error('\P{Is_Numeric_Value=	0000000037:=}');
    Expect(1, 12978, '\p{Is_Numeric_Value=0_0_0_0_0_00037}', "");
    Expect(0, 12978, '\p{^Is_Numeric_Value=0_0_0_0_0_00037}', "");
    Expect(0, 12978, '\P{Is_Numeric_Value=0_0_0_0_0_00037}', "");
    Expect(1, 12978, '\P{^Is_Numeric_Value=0_0_0_0_0_00037}', "");
    Expect(0, 12979, '\p{Is_Numeric_Value=0_0_0_0_0_00037}', "");
    Expect(1, 12979, '\p{^Is_Numeric_Value=0_0_0_0_0_00037}', "");
    Expect(1, 12979, '\P{Is_Numeric_Value=0_0_0_0_0_00037}', "");
    Expect(0, 12979, '\P{^Is_Numeric_Value=0_0_0_0_0_00037}', "");
    Expect(1, 12978, '\p{Is_Numeric_Value=3.700000000000000e+01}', "");
    Expect(0, 12978, '\p{^Is_Numeric_Value=3.700000000000000e+01}', "");
    Expect(0, 12978, '\P{Is_Numeric_Value=3.700000000000000e+01}', "");
    Expect(1, 12978, '\P{^Is_Numeric_Value=3.700000000000000e+01}', "");
    Expect(0, 12979, '\p{Is_Numeric_Value=3.700000000000000e+01}', "");
    Expect(1, 12979, '\p{^Is_Numeric_Value=3.700000000000000e+01}', "");
    Expect(1, 12979, '\P{Is_Numeric_Value=3.700000000000000e+01}', "");
    Expect(0, 12979, '\P{^Is_Numeric_Value=3.700000000000000e+01}', "");
    Error('\p{Is_Nv:	 :=0000000037}');
    Error('\P{Is_Nv:	 :=0000000037}');
    Expect(1, 12978, '\p{Is_Nv=0_0_0_0_0_0_37}', "");
    Expect(0, 12978, '\p{^Is_Nv=0_0_0_0_0_0_37}', "");
    Expect(0, 12978, '\P{Is_Nv=0_0_0_0_0_0_37}', "");
    Expect(1, 12978, '\P{^Is_Nv=0_0_0_0_0_0_37}', "");
    Expect(0, 12979, '\p{Is_Nv=0_0_0_0_0_0_37}', "");
    Expect(1, 12979, '\p{^Is_Nv=0_0_0_0_0_0_37}', "");
    Expect(1, 12979, '\P{Is_Nv=0_0_0_0_0_0_37}', "");
    Expect(0, 12979, '\P{^Is_Nv=0_0_0_0_0_0_37}', "");
    Expect(1, 12978, '\p{Is_Nv=3.700000000000000e+01}', "");
    Expect(0, 12978, '\p{^Is_Nv=3.700000000000000e+01}', "");
    Expect(0, 12978, '\P{Is_Nv=3.700000000000000e+01}', "");
    Expect(1, 12978, '\P{^Is_Nv=3.700000000000000e+01}', "");
    Expect(0, 12979, '\p{Is_Nv=3.700000000000000e+01}', "");
    Expect(1, 12979, '\p{^Is_Nv=3.700000000000000e+01}', "");
    Expect(1, 12979, '\P{Is_Nv=3.700000000000000e+01}', "");
    Expect(0, 12979, '\P{^Is_Nv=3.700000000000000e+01}', "");
    Error('\p{Numeric_Value=	:=03_8}');
    Error('\P{Numeric_Value=	:=03_8}');
    Expect(1, 12979, '\p{Numeric_Value=:\A38\z:}', "");;
    Expect(0, 12980, '\p{Numeric_Value=:\A38\z:}', "");;
    Expect(1, 12979, '\p{Numeric_Value=038}', "");
    Expect(0, 12979, '\p{^Numeric_Value=038}', "");
    Expect(0, 12979, '\P{Numeric_Value=038}', "");
    Expect(1, 12979, '\P{^Numeric_Value=038}', "");
    Expect(0, 12980, '\p{Numeric_Value=038}', "");
    Expect(1, 12980, '\p{^Numeric_Value=038}', "");
    Expect(1, 12980, '\P{Numeric_Value=038}', "");
    Expect(0, 12980, '\P{^Numeric_Value=038}', "");
    Expect(1, 12979, '\p{Numeric_Value=3.800000000000000e+01}', "");
    Expect(0, 12979, '\p{^Numeric_Value=3.800000000000000e+01}', "");
    Expect(0, 12979, '\P{Numeric_Value=3.800000000000000e+01}', "");
    Expect(1, 12979, '\P{^Numeric_Value=3.800000000000000e+01}', "");
    Expect(0, 12980, '\p{Numeric_Value=3.800000000000000e+01}', "");
    Expect(1, 12980, '\p{^Numeric_Value=3.800000000000000e+01}', "");
    Expect(1, 12980, '\P{Numeric_Value=3.800000000000000e+01}', "");
    Expect(0, 12980, '\P{^Numeric_Value=3.800000000000000e+01}', "");
    Error('\p{Nv=  0_0_0_0_0_0_0_0_38/a/}');
    Error('\P{Nv=  0_0_0_0_0_0_0_0_38/a/}');
    Expect(1, 12979, '\p{Nv=:\A38\z:}', "");;
    Expect(0, 12980, '\p{Nv=:\A38\z:}', "");;
    Expect(1, 12979, '\p{Nv=00_00_00_00_38}', "");
    Expect(0, 12979, '\p{^Nv=00_00_00_00_38}', "");
    Expect(0, 12979, '\P{Nv=00_00_00_00_38}', "");
    Expect(1, 12979, '\P{^Nv=00_00_00_00_38}', "");
    Expect(0, 12980, '\p{Nv=00_00_00_00_38}', "");
    Expect(1, 12980, '\p{^Nv=00_00_00_00_38}', "");
    Expect(1, 12980, '\P{Nv=00_00_00_00_38}', "");
    Expect(0, 12980, '\P{^Nv=00_00_00_00_38}', "");
    Expect(1, 12979, '\p{Nv=3.800000000000000e+01}', "");
    Expect(0, 12979, '\p{^Nv=3.800000000000000e+01}', "");
    Expect(0, 12979, '\P{Nv=3.800000000000000e+01}', "");
    Expect(1, 12979, '\P{^Nv=3.800000000000000e+01}', "");
    Expect(0, 12980, '\p{Nv=3.800000000000000e+01}', "");
    Expect(1, 12980, '\p{^Nv=3.800000000000000e+01}', "");
    Expect(1, 12980, '\P{Nv=3.800000000000000e+01}', "");
    Expect(0, 12980, '\P{^Nv=3.800000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=	_0_0_0_0_0_0038:=}');
    Error('\P{Is_Numeric_Value=	_0_0_0_0_0_0038:=}');
    Expect(1, 12979, '\p{Is_Numeric_Value=000038}', "");
    Expect(0, 12979, '\p{^Is_Numeric_Value=000038}', "");
    Expect(0, 12979, '\P{Is_Numeric_Value=000038}', "");
    Expect(1, 12979, '\P{^Is_Numeric_Value=000038}', "");
    Expect(0, 12980, '\p{Is_Numeric_Value=000038}', "");
    Expect(1, 12980, '\p{^Is_Numeric_Value=000038}', "");
    Expect(1, 12980, '\P{Is_Numeric_Value=000038}', "");
    Expect(0, 12980, '\P{^Is_Numeric_Value=000038}', "");
    Expect(1, 12979, '\p{Is_Numeric_Value=3.800000000000000e+01}', "");
    Expect(0, 12979, '\p{^Is_Numeric_Value=3.800000000000000e+01}', "");
    Expect(0, 12979, '\P{Is_Numeric_Value=3.800000000000000e+01}', "");
    Expect(1, 12979, '\P{^Is_Numeric_Value=3.800000000000000e+01}', "");
    Expect(0, 12980, '\p{Is_Numeric_Value=3.800000000000000e+01}', "");
    Expect(1, 12980, '\p{^Is_Numeric_Value=3.800000000000000e+01}', "");
    Expect(1, 12980, '\P{Is_Numeric_Value=3.800000000000000e+01}', "");
    Expect(0, 12980, '\P{^Is_Numeric_Value=3.800000000000000e+01}', "");
    Error('\p{Is_Nv=_/a/3_8}');
    Error('\P{Is_Nv=_/a/3_8}');
    Expect(1, 12979, '\p{Is_Nv=000000038}', "");
    Expect(0, 12979, '\p{^Is_Nv=000000038}', "");
    Expect(0, 12979, '\P{Is_Nv=000000038}', "");
    Expect(1, 12979, '\P{^Is_Nv=000000038}', "");
    Expect(0, 12980, '\p{Is_Nv=000000038}', "");
    Expect(1, 12980, '\p{^Is_Nv=000000038}', "");
    Expect(1, 12980, '\P{Is_Nv=000000038}', "");
    Expect(0, 12980, '\P{^Is_Nv=000000038}', "");
    Expect(1, 12979, '\p{Is_Nv=3.800000000000000e+01}', "");
    Expect(0, 12979, '\p{^Is_Nv=3.800000000000000e+01}', "");
    Expect(0, 12979, '\P{Is_Nv=3.800000000000000e+01}', "");
    Expect(1, 12979, '\P{^Is_Nv=3.800000000000000e+01}', "");
    Expect(0, 12980, '\p{Is_Nv=3.800000000000000e+01}', "");
    Expect(1, 12980, '\p{^Is_Nv=3.800000000000000e+01}', "");
    Expect(1, 12980, '\P{Is_Nv=3.800000000000000e+01}', "");
    Expect(0, 12980, '\P{^Is_Nv=3.800000000000000e+01}', "");
    Error('\p{Numeric_Value=_ 003_9/a/}');
    Error('\P{Numeric_Value=_ 003_9/a/}');
    Expect(1, 12980, '\p{Numeric_Value=:\A39\z:}', "");;
    Expect(0, 12981, '\p{Numeric_Value=:\A39\z:}', "");;
    Expect(1, 12980, '\p{Numeric_Value=+0_0_39}', "");
    Expect(0, 12980, '\p{^Numeric_Value=+0_0_39}', "");
    Expect(0, 12980, '\P{Numeric_Value=+0_0_39}', "");
    Expect(1, 12980, '\P{^Numeric_Value=+0_0_39}', "");
    Expect(0, 12981, '\p{Numeric_Value=+0_0_39}', "");
    Expect(1, 12981, '\p{^Numeric_Value=+0_0_39}', "");
    Expect(1, 12981, '\P{Numeric_Value=+0_0_39}', "");
    Expect(0, 12981, '\P{^Numeric_Value=+0_0_39}', "");
    Expect(1, 12980, '\p{Numeric_Value=3.900000000000000e+01}', "");
    Expect(0, 12980, '\p{^Numeric_Value=3.900000000000000e+01}', "");
    Expect(0, 12980, '\P{Numeric_Value=3.900000000000000e+01}', "");
    Expect(1, 12980, '\P{^Numeric_Value=3.900000000000000e+01}', "");
    Expect(0, 12981, '\p{Numeric_Value=3.900000000000000e+01}', "");
    Expect(1, 12981, '\p{^Numeric_Value=3.900000000000000e+01}', "");
    Expect(1, 12981, '\P{Numeric_Value=3.900000000000000e+01}', "");
    Expect(0, 12981, '\P{^Numeric_Value=3.900000000000000e+01}', "");
    Error('\p{Nv=/a/-_0003_9}');
    Error('\P{Nv=/a/-_0003_9}');
    Expect(1, 12980, '\p{Nv=:\A39\z:}', "");;
    Expect(0, 12981, '\p{Nv=:\A39\z:}', "");;
    Expect(1, 12980, '\p{Nv=000039}', "");
    Expect(0, 12980, '\p{^Nv=000039}', "");
    Expect(0, 12980, '\P{Nv=000039}', "");
    Expect(1, 12980, '\P{^Nv=000039}', "");
    Expect(0, 12981, '\p{Nv=000039}', "");
    Expect(1, 12981, '\p{^Nv=000039}', "");
    Expect(1, 12981, '\P{Nv=000039}', "");
    Expect(0, 12981, '\P{^Nv=000039}', "");
    Expect(1, 12980, '\p{Nv:	3.900000000000000e+01}', "");
    Expect(0, 12980, '\p{^Nv:	3.900000000000000e+01}', "");
    Expect(0, 12980, '\P{Nv:	3.900000000000000e+01}', "");
    Expect(1, 12980, '\P{^Nv:	3.900000000000000e+01}', "");
    Expect(0, 12981, '\p{Nv:	3.900000000000000e+01}', "");
    Expect(1, 12981, '\p{^Nv:	3.900000000000000e+01}', "");
    Expect(1, 12981, '\P{Nv:	3.900000000000000e+01}', "");
    Expect(0, 12981, '\P{^Nv:	3.900000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=	 0_0_0_0_0_0_00039:=}');
    Error('\P{Is_Numeric_Value=	 0_0_0_0_0_0_00039:=}');
    Expect(1, 12980, '\p{Is_Numeric_Value=+00039}', "");
    Expect(0, 12980, '\p{^Is_Numeric_Value=+00039}', "");
    Expect(0, 12980, '\P{Is_Numeric_Value=+00039}', "");
    Expect(1, 12980, '\P{^Is_Numeric_Value=+00039}', "");
    Expect(0, 12981, '\p{Is_Numeric_Value=+00039}', "");
    Expect(1, 12981, '\p{^Is_Numeric_Value=+00039}', "");
    Expect(1, 12981, '\P{Is_Numeric_Value=+00039}', "");
    Expect(0, 12981, '\P{^Is_Numeric_Value=+00039}', "");
    Expect(1, 12980, '\p{Is_Numeric_Value: 3.900000000000000e+01}', "");
    Expect(0, 12980, '\p{^Is_Numeric_Value: 3.900000000000000e+01}', "");
    Expect(0, 12980, '\P{Is_Numeric_Value: 3.900000000000000e+01}', "");
    Expect(1, 12980, '\P{^Is_Numeric_Value: 3.900000000000000e+01}', "");
    Expect(0, 12981, '\p{Is_Numeric_Value: 3.900000000000000e+01}', "");
    Expect(1, 12981, '\p{^Is_Numeric_Value: 3.900000000000000e+01}', "");
    Expect(1, 12981, '\P{Is_Numeric_Value: 3.900000000000000e+01}', "");
    Expect(0, 12981, '\P{^Is_Numeric_Value: 3.900000000000000e+01}', "");
    Error('\p{Is_Nv=:=0000000039}');
    Error('\P{Is_Nv=:=0000000039}');
    Expect(1, 12980, '\p{Is_Nv=+0000000003_9}', "");
    Expect(0, 12980, '\p{^Is_Nv=+0000000003_9}', "");
    Expect(0, 12980, '\P{Is_Nv=+0000000003_9}', "");
    Expect(1, 12980, '\P{^Is_Nv=+0000000003_9}', "");
    Expect(0, 12981, '\p{Is_Nv=+0000000003_9}', "");
    Expect(1, 12981, '\p{^Is_Nv=+0000000003_9}', "");
    Expect(1, 12981, '\P{Is_Nv=+0000000003_9}', "");
    Expect(0, 12981, '\P{^Is_Nv=+0000000003_9}', "");
    Expect(1, 12980, '\p{Is_Nv=3.900000000000000e+01}', "");
    Expect(0, 12980, '\p{^Is_Nv=3.900000000000000e+01}', "");
    Expect(0, 12980, '\P{Is_Nv=3.900000000000000e+01}', "");
    Expect(1, 12980, '\P{^Is_Nv=3.900000000000000e+01}', "");
    Expect(0, 12981, '\p{Is_Nv=3.900000000000000e+01}', "");
    Expect(1, 12981, '\p{^Is_Nv=3.900000000000000e+01}', "");
    Expect(1, 12981, '\P{Is_Nv=3.900000000000000e+01}', "");
    Expect(0, 12981, '\P{^Is_Nv=3.900000000000000e+01}', "");
    Error('\p{Numeric_Value=	:=+0_0_0_04}');
    Error('\P{Numeric_Value=	:=+0_0_0_04}');
    Expect(1, 156269, '\p{Numeric_Value=:\A4\z:}', "");;
    Expect(0, 156270, '\p{Numeric_Value=:\A4\z:}', "");;
    Expect(1, 156269, '\p{Numeric_Value=000_4}', "");
    Expect(0, 156269, '\p{^Numeric_Value=000_4}', "");
    Expect(0, 156269, '\P{Numeric_Value=000_4}', "");
    Expect(1, 156269, '\P{^Numeric_Value=000_4}', "");
    Expect(0, 156270, '\p{Numeric_Value=000_4}', "");
    Expect(1, 156270, '\p{^Numeric_Value=000_4}', "");
    Expect(1, 156270, '\P{Numeric_Value=000_4}', "");
    Expect(0, 156270, '\P{^Numeric_Value=000_4}', "");
    Expect(1, 156269, '\p{Numeric_Value=4.000000000000000e+00}', "");
    Expect(0, 156269, '\p{^Numeric_Value=4.000000000000000e+00}', "");
    Expect(0, 156269, '\P{Numeric_Value=4.000000000000000e+00}', "");
    Expect(1, 156269, '\P{^Numeric_Value=4.000000000000000e+00}', "");
    Expect(0, 156270, '\p{Numeric_Value=4.000000000000000e+00}', "");
    Expect(1, 156270, '\p{^Numeric_Value=4.000000000000000e+00}', "");
    Expect(1, 156270, '\P{Numeric_Value=4.000000000000000e+00}', "");
    Expect(0, 156270, '\P{^Numeric_Value=4.000000000000000e+00}', "");
    Error('\p{Nv=--0004:=}');
    Error('\P{Nv=--0004:=}');
    Expect(1, 156269, '\p{Nv=:\A4\z:}', "");;
    Expect(0, 156270, '\p{Nv=:\A4\z:}', "");;
    Expect(1, 156269, '\p{Nv=4}', "");
    Expect(0, 156269, '\p{^Nv=4}', "");
    Expect(0, 156269, '\P{Nv=4}', "");
    Expect(1, 156269, '\P{^Nv=4}', "");
    Expect(0, 156270, '\p{Nv=4}', "");
    Expect(1, 156270, '\p{^Nv=4}', "");
    Expect(1, 156270, '\P{Nv=4}', "");
    Expect(0, 156270, '\P{^Nv=4}', "");
    Expect(1, 156269, '\p{Nv=4.000000000000000e+00}', "");
    Expect(0, 156269, '\p{^Nv=4.000000000000000e+00}', "");
    Expect(0, 156269, '\P{Nv=4.000000000000000e+00}', "");
    Expect(1, 156269, '\P{^Nv=4.000000000000000e+00}', "");
    Expect(0, 156270, '\p{Nv=4.000000000000000e+00}', "");
    Expect(1, 156270, '\p{^Nv=4.000000000000000e+00}', "");
    Expect(1, 156270, '\P{Nv=4.000000000000000e+00}', "");
    Expect(0, 156270, '\P{^Nv=4.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value: :=  00000004}');
    Error('\P{Is_Numeric_Value: :=  00000004}');
    Expect(1, 156269, '\p{Is_Numeric_Value=+000_000_4}', "");
    Expect(0, 156269, '\p{^Is_Numeric_Value=+000_000_4}', "");
    Expect(0, 156269, '\P{Is_Numeric_Value=+000_000_4}', "");
    Expect(1, 156269, '\P{^Is_Numeric_Value=+000_000_4}', "");
    Expect(0, 156270, '\p{Is_Numeric_Value=+000_000_4}', "");
    Expect(1, 156270, '\p{^Is_Numeric_Value=+000_000_4}', "");
    Expect(1, 156270, '\P{Is_Numeric_Value=+000_000_4}', "");
    Expect(0, 156270, '\P{^Is_Numeric_Value=+000_000_4}', "");
    Expect(1, 156269, '\p{Is_Numeric_Value=4.000000000000000e+00}', "");
    Expect(0, 156269, '\p{^Is_Numeric_Value=4.000000000000000e+00}', "");
    Expect(0, 156269, '\P{Is_Numeric_Value=4.000000000000000e+00}', "");
    Expect(1, 156269, '\P{^Is_Numeric_Value=4.000000000000000e+00}', "");
    Expect(0, 156270, '\p{Is_Numeric_Value=4.000000000000000e+00}', "");
    Expect(1, 156270, '\p{^Is_Numeric_Value=4.000000000000000e+00}', "");
    Expect(1, 156270, '\P{Is_Numeric_Value=4.000000000000000e+00}', "");
    Expect(0, 156270, '\P{^Is_Numeric_Value=4.000000000000000e+00}', "");
    Error('\p{Is_Nv=:=0_0_0_004}');
    Error('\P{Is_Nv=:=0_0_0_004}');
    Expect(1, 156269, '\p{Is_Nv=004}', "");
    Expect(0, 156269, '\p{^Is_Nv=004}', "");
    Expect(0, 156269, '\P{Is_Nv=004}', "");
    Expect(1, 156269, '\P{^Is_Nv=004}', "");
    Expect(0, 156270, '\p{Is_Nv=004}', "");
    Expect(1, 156270, '\p{^Is_Nv=004}', "");
    Expect(1, 156270, '\P{Is_Nv=004}', "");
    Expect(0, 156270, '\P{^Is_Nv=004}', "");
    Expect(1, 156269, '\p{Is_Nv=4.000000000000000e+00}', "");
    Expect(0, 156269, '\p{^Is_Nv=4.000000000000000e+00}', "");
    Expect(0, 156269, '\P{Is_Nv=4.000000000000000e+00}', "");
    Expect(1, 156269, '\P{^Is_Nv=4.000000000000000e+00}', "");
    Expect(0, 156270, '\p{Is_Nv=4.000000000000000e+00}', "");
    Expect(1, 156270, '\p{^Is_Nv=4.000000000000000e+00}', "");
    Expect(1, 156270, '\P{Is_Nv=4.000000000000000e+00}', "");
    Expect(0, 156270, '\P{^Is_Nv=4.000000000000000e+00}', "");
    Error('\p{Numeric_Value=/a/--4/00000005}');
    Error('\P{Numeric_Value=/a/--4/00000005}');
    Expect(1, 8536, '\p{Numeric_Value=:\A4/5\z:}', "");;
    Expect(0, 8537, '\p{Numeric_Value=:\A4/5\z:}', "");;
    Expect(1, 8536, '\p{Numeric_Value=000004/005}', "");
    Expect(0, 8536, '\p{^Numeric_Value=000004/005}', "");
    Expect(0, 8536, '\P{Numeric_Value=000004/005}', "");
    Expect(1, 8536, '\P{^Numeric_Value=000004/005}', "");
    Expect(0, 8537, '\p{Numeric_Value=000004/005}', "");
    Expect(1, 8537, '\p{^Numeric_Value=000004/005}', "");
    Expect(1, 8537, '\P{Numeric_Value=000004/005}', "");
    Expect(0, 8537, '\P{^Numeric_Value=000004/005}', "");
    Expect(1, 8536, '\p{Numeric_Value:	240/300}', "");
    Expect(0, 8536, '\p{^Numeric_Value:	240/300}', "");
    Expect(0, 8536, '\P{Numeric_Value:	240/300}', "");
    Expect(1, 8536, '\P{^Numeric_Value:	240/300}', "");
    Expect(0, 8537, '\p{Numeric_Value:	240/300}', "");
    Expect(1, 8537, '\p{^Numeric_Value:	240/300}', "");
    Expect(1, 8537, '\P{Numeric_Value:	240/300}', "");
    Expect(0, 8537, '\P{^Numeric_Value:	240/300}', "");
    Expect(1, 8536, '\p{Numeric_Value=8.0e-01}', "");
    Expect(0, 8536, '\p{^Numeric_Value=8.0e-01}', "");
    Expect(0, 8536, '\P{Numeric_Value=8.0e-01}', "");
    Expect(1, 8536, '\P{^Numeric_Value=8.0e-01}', "");
    Expect(0, 8537, '\p{Numeric_Value=8.0e-01}', "");
    Expect(1, 8537, '\p{^Numeric_Value=8.0e-01}', "");
    Expect(1, 8537, '\P{Numeric_Value=8.0e-01}', "");
    Expect(0, 8537, '\P{^Numeric_Value=8.0e-01}', "");
    Expect(1, 8536, '\p{Numeric_Value=0.8}', "");
    Expect(0, 8536, '\p{^Numeric_Value=0.8}', "");
    Expect(0, 8536, '\P{Numeric_Value=0.8}', "");
    Expect(1, 8536, '\P{^Numeric_Value=0.8}', "");
    Expect(0, 8537, '\p{Numeric_Value=0.8}', "");
    Expect(1, 8537, '\p{^Numeric_Value=0.8}', "");
    Expect(1, 8537, '\P{Numeric_Value=0.8}', "");
    Expect(0, 8537, '\P{^Numeric_Value=0.8}', "");
    Expect(1, 8536, '\p{Numeric_Value=8.00e-01}', "");
    Expect(0, 8536, '\p{^Numeric_Value=8.00e-01}', "");
    Expect(0, 8536, '\P{Numeric_Value=8.00e-01}', "");
    Expect(1, 8536, '\P{^Numeric_Value=8.00e-01}', "");
    Expect(0, 8537, '\p{Numeric_Value=8.00e-01}', "");
    Expect(1, 8537, '\p{^Numeric_Value=8.00e-01}', "");
    Expect(1, 8537, '\P{Numeric_Value=8.00e-01}', "");
    Expect(0, 8537, '\P{^Numeric_Value=8.00e-01}', "");
    Expect(1, 8536, '\p{Numeric_Value: 0.80}', "");
    Expect(0, 8536, '\p{^Numeric_Value: 0.80}', "");
    Expect(0, 8536, '\P{Numeric_Value: 0.80}', "");
    Expect(1, 8536, '\P{^Numeric_Value: 0.80}', "");
    Expect(0, 8537, '\p{Numeric_Value: 0.80}', "");
    Expect(1, 8537, '\p{^Numeric_Value: 0.80}', "");
    Expect(1, 8537, '\P{Numeric_Value: 0.80}', "");
    Expect(0, 8537, '\P{^Numeric_Value: 0.80}', "");
    Error('\p{Nv=  +4/05:=}');
    Error('\P{Nv=  +4/05:=}');
    Expect(1, 8536, '\p{Nv=:\A4/5\z:}', "");;
    Expect(0, 8537, '\p{Nv=:\A4/5\z:}', "");;
    Expect(1, 8536, '\p{Nv=00000004/000000005}', "");
    Expect(0, 8536, '\p{^Nv=00000004/000000005}', "");
    Expect(0, 8536, '\P{Nv=00000004/000000005}', "");
    Expect(1, 8536, '\P{^Nv=00000004/000000005}', "");
    Expect(0, 8537, '\p{Nv=00000004/000000005}', "");
    Expect(1, 8537, '\p{^Nv=00000004/000000005}', "");
    Expect(1, 8537, '\P{Nv=00000004/000000005}', "");
    Expect(0, 8537, '\P{^Nv=00000004/000000005}', "");
    Expect(1, 8536, '\p{Nv=240/300}', "");
    Expect(0, 8536, '\p{^Nv=240/300}', "");
    Expect(0, 8536, '\P{Nv=240/300}', "");
    Expect(1, 8536, '\P{^Nv=240/300}', "");
    Expect(0, 8537, '\p{Nv=240/300}', "");
    Expect(1, 8537, '\p{^Nv=240/300}', "");
    Expect(1, 8537, '\P{Nv=240/300}', "");
    Expect(0, 8537, '\P{^Nv=240/300}', "");
    Expect(1, 8536, '\p{Nv=8.0e-01}', "");
    Expect(0, 8536, '\p{^Nv=8.0e-01}', "");
    Expect(0, 8536, '\P{Nv=8.0e-01}', "");
    Expect(1, 8536, '\P{^Nv=8.0e-01}', "");
    Expect(0, 8537, '\p{Nv=8.0e-01}', "");
    Expect(1, 8537, '\p{^Nv=8.0e-01}', "");
    Expect(1, 8537, '\P{Nv=8.0e-01}', "");
    Expect(0, 8537, '\P{^Nv=8.0e-01}', "");
    Expect(1, 8536, '\p{Nv=0.8}', "");
    Expect(0, 8536, '\p{^Nv=0.8}', "");
    Expect(0, 8536, '\P{Nv=0.8}', "");
    Expect(1, 8536, '\P{^Nv=0.8}', "");
    Expect(0, 8537, '\p{Nv=0.8}', "");
    Expect(1, 8537, '\p{^Nv=0.8}', "");
    Expect(1, 8537, '\P{Nv=0.8}', "");
    Expect(0, 8537, '\P{^Nv=0.8}', "");
    Expect(1, 8536, '\p{Nv=8.00e-01}', "");
    Expect(0, 8536, '\p{^Nv=8.00e-01}', "");
    Expect(0, 8536, '\P{Nv=8.00e-01}', "");
    Expect(1, 8536, '\P{^Nv=8.00e-01}', "");
    Expect(0, 8537, '\p{Nv=8.00e-01}', "");
    Expect(1, 8537, '\p{^Nv=8.00e-01}', "");
    Expect(1, 8537, '\P{Nv=8.00e-01}', "");
    Expect(0, 8537, '\P{^Nv=8.00e-01}', "");
    Expect(1, 8536, '\p{Nv=0.80}', "");
    Expect(0, 8536, '\p{^Nv=0.80}', "");
    Expect(0, 8536, '\P{Nv=0.80}', "");
    Expect(1, 8536, '\P{^Nv=0.80}', "");
    Expect(0, 8537, '\p{Nv=0.80}', "");
    Expect(1, 8537, '\p{^Nv=0.80}', "");
    Expect(1, 8537, '\P{Nv=0.80}', "");
    Expect(0, 8537, '\P{^Nv=0.80}', "");
    Error('\p{Is_Numeric_Value= :=0000000004/005}');
    Error('\P{Is_Numeric_Value= :=0000000004/005}');
    Expect(1, 8536, '\p{Is_Numeric_Value=+04/0000000005}', "");
    Expect(0, 8536, '\p{^Is_Numeric_Value=+04/0000000005}', "");
    Expect(0, 8536, '\P{Is_Numeric_Value=+04/0000000005}', "");
    Expect(1, 8536, '\P{^Is_Numeric_Value=+04/0000000005}', "");
    Expect(0, 8537, '\p{Is_Numeric_Value=+04/0000000005}', "");
    Expect(1, 8537, '\p{^Is_Numeric_Value=+04/0000000005}', "");
    Expect(1, 8537, '\P{Is_Numeric_Value=+04/0000000005}', "");
    Expect(0, 8537, '\P{^Is_Numeric_Value=+04/0000000005}', "");
    Expect(1, 8536, '\p{Is_Numeric_Value=240/300}', "");
    Expect(0, 8536, '\p{^Is_Numeric_Value=240/300}', "");
    Expect(0, 8536, '\P{Is_Numeric_Value=240/300}', "");
    Expect(1, 8536, '\P{^Is_Numeric_Value=240/300}', "");
    Expect(0, 8537, '\p{Is_Numeric_Value=240/300}', "");
    Expect(1, 8537, '\p{^Is_Numeric_Value=240/300}', "");
    Expect(1, 8537, '\P{Is_Numeric_Value=240/300}', "");
    Expect(0, 8537, '\P{^Is_Numeric_Value=240/300}', "");
    Expect(1, 8536, '\p{Is_Numeric_Value=8.0e-01}', "");
    Expect(0, 8536, '\p{^Is_Numeric_Value=8.0e-01}', "");
    Expect(0, 8536, '\P{Is_Numeric_Value=8.0e-01}', "");
    Expect(1, 8536, '\P{^Is_Numeric_Value=8.0e-01}', "");
    Expect(0, 8537, '\p{Is_Numeric_Value=8.0e-01}', "");
    Expect(1, 8537, '\p{^Is_Numeric_Value=8.0e-01}', "");
    Expect(1, 8537, '\P{Is_Numeric_Value=8.0e-01}', "");
    Expect(0, 8537, '\P{^Is_Numeric_Value=8.0e-01}', "");
    Expect(1, 8536, '\p{Is_Numeric_Value=0.8}', "");
    Expect(0, 8536, '\p{^Is_Numeric_Value=0.8}', "");
    Expect(0, 8536, '\P{Is_Numeric_Value=0.8}', "");
    Expect(1, 8536, '\P{^Is_Numeric_Value=0.8}', "");
    Expect(0, 8537, '\p{Is_Numeric_Value=0.8}', "");
    Expect(1, 8537, '\p{^Is_Numeric_Value=0.8}', "");
    Expect(1, 8537, '\P{Is_Numeric_Value=0.8}', "");
    Expect(0, 8537, '\P{^Is_Numeric_Value=0.8}', "");
    Expect(1, 8536, '\p{Is_Numeric_Value=8.00e-01}', "");
    Expect(0, 8536, '\p{^Is_Numeric_Value=8.00e-01}', "");
    Expect(0, 8536, '\P{Is_Numeric_Value=8.00e-01}', "");
    Expect(1, 8536, '\P{^Is_Numeric_Value=8.00e-01}', "");
    Expect(0, 8537, '\p{Is_Numeric_Value=8.00e-01}', "");
    Expect(1, 8537, '\p{^Is_Numeric_Value=8.00e-01}', "");
    Expect(1, 8537, '\P{Is_Numeric_Value=8.00e-01}', "");
    Expect(0, 8537, '\P{^Is_Numeric_Value=8.00e-01}', "");
    Expect(1, 8536, '\p{Is_Numeric_Value=0.80}', "");
    Expect(0, 8536, '\p{^Is_Numeric_Value=0.80}', "");
    Expect(0, 8536, '\P{Is_Numeric_Value=0.80}', "");
    Expect(1, 8536, '\P{^Is_Numeric_Value=0.80}', "");
    Expect(0, 8537, '\p{Is_Numeric_Value=0.80}', "");
    Expect(1, 8537, '\p{^Is_Numeric_Value=0.80}', "");
    Expect(1, 8537, '\P{Is_Numeric_Value=0.80}', "");
    Expect(0, 8537, '\P{^Is_Numeric_Value=0.80}', "");
    Error('\p{Is_Nv= 0000000004/00005:=}');
    Error('\P{Is_Nv= 0000000004/00005:=}');
    Expect(1, 8536, '\p{Is_Nv=000004/5}', "");
    Expect(0, 8536, '\p{^Is_Nv=000004/5}', "");
    Expect(0, 8536, '\P{Is_Nv=000004/5}', "");
    Expect(1, 8536, '\P{^Is_Nv=000004/5}', "");
    Expect(0, 8537, '\p{Is_Nv=000004/5}', "");
    Expect(1, 8537, '\p{^Is_Nv=000004/5}', "");
    Expect(1, 8537, '\P{Is_Nv=000004/5}', "");
    Expect(0, 8537, '\P{^Is_Nv=000004/5}', "");
    Expect(1, 8536, '\p{Is_Nv=240/300}', "");
    Expect(0, 8536, '\p{^Is_Nv=240/300}', "");
    Expect(0, 8536, '\P{Is_Nv=240/300}', "");
    Expect(1, 8536, '\P{^Is_Nv=240/300}', "");
    Expect(0, 8537, '\p{Is_Nv=240/300}', "");
    Expect(1, 8537, '\p{^Is_Nv=240/300}', "");
    Expect(1, 8537, '\P{Is_Nv=240/300}', "");
    Expect(0, 8537, '\P{^Is_Nv=240/300}', "");
    Expect(1, 8536, '\p{Is_Nv=8.0e-01}', "");
    Expect(0, 8536, '\p{^Is_Nv=8.0e-01}', "");
    Expect(0, 8536, '\P{Is_Nv=8.0e-01}', "");
    Expect(1, 8536, '\P{^Is_Nv=8.0e-01}', "");
    Expect(0, 8537, '\p{Is_Nv=8.0e-01}', "");
    Expect(1, 8537, '\p{^Is_Nv=8.0e-01}', "");
    Expect(1, 8537, '\P{Is_Nv=8.0e-01}', "");
    Expect(0, 8537, '\P{^Is_Nv=8.0e-01}', "");
    Expect(1, 8536, '\p{Is_Nv=0.8}', "");
    Expect(0, 8536, '\p{^Is_Nv=0.8}', "");
    Expect(0, 8536, '\P{Is_Nv=0.8}', "");
    Expect(1, 8536, '\P{^Is_Nv=0.8}', "");
    Expect(0, 8537, '\p{Is_Nv=0.8}', "");
    Expect(1, 8537, '\p{^Is_Nv=0.8}', "");
    Expect(1, 8537, '\P{Is_Nv=0.8}', "");
    Expect(0, 8537, '\P{^Is_Nv=0.8}', "");
    Expect(1, 8536, '\p{Is_Nv=8.00e-01}', "");
    Expect(0, 8536, '\p{^Is_Nv=8.00e-01}', "");
    Expect(0, 8536, '\P{Is_Nv=8.00e-01}', "");
    Expect(1, 8536, '\P{^Is_Nv=8.00e-01}', "");
    Expect(0, 8537, '\p{Is_Nv=8.00e-01}', "");
    Expect(1, 8537, '\p{^Is_Nv=8.00e-01}', "");
    Expect(1, 8537, '\P{Is_Nv=8.00e-01}', "");
    Expect(0, 8537, '\P{^Is_Nv=8.00e-01}', "");
    Expect(1, 8536, '\p{Is_Nv=0.80}', "");
    Expect(0, 8536, '\p{^Is_Nv=0.80}', "");
    Expect(0, 8536, '\P{Is_Nv=0.80}', "");
    Expect(1, 8536, '\P{^Is_Nv=0.80}', "");
    Expect(0, 8537, '\p{Is_Nv=0.80}', "");
    Expect(1, 8537, '\p{^Is_Nv=0.80}', "");
    Expect(1, 8537, '\P{Is_Nv=0.80}', "");
    Expect(0, 8537, '\P{^Is_Nv=0.80}', "");
    Error('\p{Numeric_Value=:=00000000040}');
    Error('\P{Numeric_Value=:=00000000040}');
    Expect(1, 133532, '\p{Numeric_Value=:\A40\z:}', "");;
    Expect(0, 133533, '\p{Numeric_Value=:\A40\z:}', "");;
    Expect(1, 133532, '\p{Numeric_Value=+0_0_0_0_0_0_0_0_040}', "");
    Expect(0, 133532, '\p{^Numeric_Value=+0_0_0_0_0_0_0_0_040}', "");
    Expect(0, 133532, '\P{Numeric_Value=+0_0_0_0_0_0_0_0_040}', "");
    Expect(1, 133532, '\P{^Numeric_Value=+0_0_0_0_0_0_0_0_040}', "");
    Expect(0, 133533, '\p{Numeric_Value=+0_0_0_0_0_0_0_0_040}', "");
    Expect(1, 133533, '\p{^Numeric_Value=+0_0_0_0_0_0_0_0_040}', "");
    Expect(1, 133533, '\P{Numeric_Value=+0_0_0_0_0_0_0_0_040}', "");
    Expect(0, 133533, '\P{^Numeric_Value=+0_0_0_0_0_0_0_0_040}', "");
    Expect(1, 133532, '\p{Numeric_Value=4.000000000000000e+01}', "");
    Expect(0, 133532, '\p{^Numeric_Value=4.000000000000000e+01}', "");
    Expect(0, 133532, '\P{Numeric_Value=4.000000000000000e+01}', "");
    Expect(1, 133532, '\P{^Numeric_Value=4.000000000000000e+01}', "");
    Expect(0, 133533, '\p{Numeric_Value=4.000000000000000e+01}', "");
    Expect(1, 133533, '\p{^Numeric_Value=4.000000000000000e+01}', "");
    Expect(1, 133533, '\P{Numeric_Value=4.000000000000000e+01}', "");
    Expect(0, 133533, '\P{^Numeric_Value=4.000000000000000e+01}', "");
    Error('\p{Nv=	 0_0_40/a/}');
    Error('\P{Nv=	 0_0_40/a/}');
    Expect(1, 133532, '\p{Nv=:\A40\z:}', "");;
    Expect(0, 133533, '\p{Nv=:\A40\z:}', "");;
    Expect(1, 133532, '\p{Nv=000040}', "");
    Expect(0, 133532, '\p{^Nv=000040}', "");
    Expect(0, 133532, '\P{Nv=000040}', "");
    Expect(1, 133532, '\P{^Nv=000040}', "");
    Expect(0, 133533, '\p{Nv=000040}', "");
    Expect(1, 133533, '\p{^Nv=000040}', "");
    Expect(1, 133533, '\P{Nv=000040}', "");
    Expect(0, 133533, '\P{^Nv=000040}', "");
    Expect(1, 133532, '\p{Nv=4.000000000000000e+01}', "");
    Expect(0, 133532, '\p{^Nv=4.000000000000000e+01}', "");
    Expect(0, 133532, '\P{Nv=4.000000000000000e+01}', "");
    Expect(1, 133532, '\P{^Nv=4.000000000000000e+01}', "");
    Expect(0, 133533, '\p{Nv=4.000000000000000e+01}', "");
    Expect(1, 133533, '\p{^Nv=4.000000000000000e+01}', "");
    Expect(1, 133533, '\P{Nv=4.000000000000000e+01}', "");
    Expect(0, 133533, '\P{^Nv=4.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=-0_0_0_0_0_0_0_040:=}');
    Error('\P{Is_Numeric_Value=-0_0_0_0_0_0_0_040:=}');
    Expect(1, 133532, '\p{Is_Numeric_Value:   004_0}', "");
    Expect(0, 133532, '\p{^Is_Numeric_Value:   004_0}', "");
    Expect(0, 133532, '\P{Is_Numeric_Value:   004_0}', "");
    Expect(1, 133532, '\P{^Is_Numeric_Value:   004_0}', "");
    Expect(0, 133533, '\p{Is_Numeric_Value:   004_0}', "");
    Expect(1, 133533, '\p{^Is_Numeric_Value:   004_0}', "");
    Expect(1, 133533, '\P{Is_Numeric_Value:   004_0}', "");
    Expect(0, 133533, '\P{^Is_Numeric_Value:   004_0}', "");
    Expect(1, 133532, '\p{Is_Numeric_Value=4.000000000000000e+01}', "");
    Expect(0, 133532, '\p{^Is_Numeric_Value=4.000000000000000e+01}', "");
    Expect(0, 133532, '\P{Is_Numeric_Value=4.000000000000000e+01}', "");
    Expect(1, 133532, '\P{^Is_Numeric_Value=4.000000000000000e+01}', "");
    Expect(0, 133533, '\p{Is_Numeric_Value=4.000000000000000e+01}', "");
    Expect(1, 133533, '\p{^Is_Numeric_Value=4.000000000000000e+01}', "");
    Expect(1, 133533, '\P{Is_Numeric_Value=4.000000000000000e+01}', "");
    Expect(0, 133533, '\P{^Is_Numeric_Value=4.000000000000000e+01}', "");
    Error('\p{Is_Nv=	/a/00_04_0}');
    Error('\P{Is_Nv=	/a/00_04_0}');
    Expect(1, 133532, '\p{Is_Nv=00040}', "");
    Expect(0, 133532, '\p{^Is_Nv=00040}', "");
    Expect(0, 133532, '\P{Is_Nv=00040}', "");
    Expect(1, 133532, '\P{^Is_Nv=00040}', "");
    Expect(0, 133533, '\p{Is_Nv=00040}', "");
    Expect(1, 133533, '\p{^Is_Nv=00040}', "");
    Expect(1, 133533, '\P{Is_Nv=00040}', "");
    Expect(0, 133533, '\P{^Is_Nv=00040}', "");
    Expect(1, 133532, '\p{Is_Nv=4.000000000000000e+01}', "");
    Expect(0, 133532, '\p{^Is_Nv=4.000000000000000e+01}', "");
    Expect(0, 133532, '\P{Is_Nv=4.000000000000000e+01}', "");
    Expect(1, 133532, '\P{^Is_Nv=4.000000000000000e+01}', "");
    Expect(0, 133533, '\p{Is_Nv=4.000000000000000e+01}', "");
    Expect(1, 133533, '\p{^Is_Nv=4.000000000000000e+01}', "");
    Expect(1, 133533, '\P{Is_Nv=4.000000000000000e+01}', "");
    Expect(0, 133533, '\P{^Is_Nv=4.000000000000000e+01}', "");
    Error('\p{Numeric_Value=/a/--00_40_0}');
    Error('\P{Numeric_Value=/a/--00_40_0}');
    Expect(1, 126264, '\p{Numeric_Value=:\A400\z:}', "");;
    Expect(0, 126265, '\p{Numeric_Value=:\A400\z:}', "");;
    Expect(1, 126264, '\p{Numeric_Value:   +0_0_0_0_400}', "");
    Expect(0, 126264, '\p{^Numeric_Value:   +0_0_0_0_400}', "");
    Expect(0, 126264, '\P{Numeric_Value:   +0_0_0_0_400}', "");
    Expect(1, 126264, '\P{^Numeric_Value:   +0_0_0_0_400}', "");
    Expect(0, 126265, '\p{Numeric_Value:   +0_0_0_0_400}', "");
    Expect(1, 126265, '\p{^Numeric_Value:   +0_0_0_0_400}', "");
    Expect(1, 126265, '\P{Numeric_Value:   +0_0_0_0_400}', "");
    Expect(0, 126265, '\P{^Numeric_Value:   +0_0_0_0_400}', "");
    Expect(1, 126264, '\p{Numeric_Value=4.000000000000000e+02}', "");
    Expect(0, 126264, '\p{^Numeric_Value=4.000000000000000e+02}', "");
    Expect(0, 126264, '\P{Numeric_Value=4.000000000000000e+02}', "");
    Expect(1, 126264, '\P{^Numeric_Value=4.000000000000000e+02}', "");
    Expect(0, 126265, '\p{Numeric_Value=4.000000000000000e+02}', "");
    Expect(1, 126265, '\p{^Numeric_Value=4.000000000000000e+02}', "");
    Expect(1, 126265, '\P{Numeric_Value=4.000000000000000e+02}', "");
    Expect(0, 126265, '\P{^Numeric_Value=4.000000000000000e+02}', "");
    Error('\p{Nv=/a/_+000000400}');
    Error('\P{Nv=/a/_+000000400}');
    Expect(1, 126264, '\p{Nv=:\A400\z:}', "");;
    Expect(0, 126265, '\p{Nv=:\A400\z:}', "");;
    Expect(1, 126264, '\p{Nv=00400}', "");
    Expect(0, 126264, '\p{^Nv=00400}', "");
    Expect(0, 126264, '\P{Nv=00400}', "");
    Expect(1, 126264, '\P{^Nv=00400}', "");
    Expect(0, 126265, '\p{Nv=00400}', "");
    Expect(1, 126265, '\p{^Nv=00400}', "");
    Expect(1, 126265, '\P{Nv=00400}', "");
    Expect(0, 126265, '\P{^Nv=00400}', "");
    Expect(1, 126264, '\p{Nv=4.000000000000000e+02}', "");
    Expect(0, 126264, '\p{^Nv=4.000000000000000e+02}', "");
    Expect(0, 126264, '\P{Nv=4.000000000000000e+02}', "");
    Expect(1, 126264, '\P{^Nv=4.000000000000000e+02}', "");
    Expect(0, 126265, '\p{Nv=4.000000000000000e+02}', "");
    Expect(1, 126265, '\p{^Nv=4.000000000000000e+02}', "");
    Expect(1, 126265, '\P{Nv=4.000000000000000e+02}', "");
    Expect(0, 126265, '\P{^Nv=4.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value=-/a/0_0_0_0_0_0_0_0400}');
    Error('\P{Is_Numeric_Value=-/a/0_0_0_0_0_0_0_0400}');
    Expect(1, 126264, '\p{Is_Numeric_Value=0000000400}', "");
    Expect(0, 126264, '\p{^Is_Numeric_Value=0000000400}', "");
    Expect(0, 126264, '\P{Is_Numeric_Value=0000000400}', "");
    Expect(1, 126264, '\P{^Is_Numeric_Value=0000000400}', "");
    Expect(0, 126265, '\p{Is_Numeric_Value=0000000400}', "");
    Expect(1, 126265, '\p{^Is_Numeric_Value=0000000400}', "");
    Expect(1, 126265, '\P{Is_Numeric_Value=0000000400}', "");
    Expect(0, 126265, '\P{^Is_Numeric_Value=0000000400}', "");
    Expect(1, 126264, '\p{Is_Numeric_Value=4.000000000000000e+02}', "");
    Expect(0, 126264, '\p{^Is_Numeric_Value=4.000000000000000e+02}', "");
    Expect(0, 126264, '\P{Is_Numeric_Value=4.000000000000000e+02}', "");
    Expect(1, 126264, '\P{^Is_Numeric_Value=4.000000000000000e+02}', "");
    Expect(0, 126265, '\p{Is_Numeric_Value=4.000000000000000e+02}', "");
    Expect(1, 126265, '\p{^Is_Numeric_Value=4.000000000000000e+02}', "");
    Expect(1, 126265, '\P{Is_Numeric_Value=4.000000000000000e+02}', "");
    Expect(0, 126265, '\P{^Is_Numeric_Value=4.000000000000000e+02}', "");
    Error('\p{Is_Nv=_-000040_0:=}');
    Error('\P{Is_Nv=_-000040_0:=}');
    Expect(1, 126264, '\p{Is_Nv=+0000000400}', "");
    Expect(0, 126264, '\p{^Is_Nv=+0000000400}', "");
    Expect(0, 126264, '\P{Is_Nv=+0000000400}', "");
    Expect(1, 126264, '\P{^Is_Nv=+0000000400}', "");
    Expect(0, 126265, '\p{Is_Nv=+0000000400}', "");
    Expect(1, 126265, '\p{^Is_Nv=+0000000400}', "");
    Expect(1, 126265, '\P{Is_Nv=+0000000400}', "");
    Expect(0, 126265, '\P{^Is_Nv=+0000000400}', "");
    Expect(1, 126264, '\p{Is_Nv:   4.000000000000000e+02}', "");
    Expect(0, 126264, '\p{^Is_Nv:   4.000000000000000e+02}', "");
    Expect(0, 126264, '\P{Is_Nv:   4.000000000000000e+02}', "");
    Expect(1, 126264, '\P{^Is_Nv:   4.000000000000000e+02}', "");
    Expect(0, 126265, '\p{Is_Nv:   4.000000000000000e+02}', "");
    Expect(1, 126265, '\p{^Is_Nv:   4.000000000000000e+02}', "");
    Expect(1, 126265, '\P{Is_Nv:   4.000000000000000e+02}', "");
    Expect(0, 126265, '\P{^Is_Nv:   4.000000000000000e+02}', "");
    Error('\p{Numeric_Value=/a/ 	0_0_0_0_0_0_0_0_4_000}');
    Error('\P{Numeric_Value=/a/ 	0_0_0_0_0_0_0_0_4_000}');
    Expect(1, 126239, '\p{Numeric_Value=:\A4000\z:}', "");;
    Expect(0, 126240, '\p{Numeric_Value=:\A4000\z:}', "");;
    Expect(1, 126239, '\p{Numeric_Value:0400_0}', "");
    Expect(0, 126239, '\p{^Numeric_Value:0400_0}', "");
    Expect(0, 126239, '\P{Numeric_Value:0400_0}', "");
    Expect(1, 126239, '\P{^Numeric_Value:0400_0}', "");
    Expect(0, 126240, '\p{Numeric_Value:0400_0}', "");
    Expect(1, 126240, '\p{^Numeric_Value:0400_0}', "");
    Expect(1, 126240, '\P{Numeric_Value:0400_0}', "");
    Expect(0, 126240, '\P{^Numeric_Value:0400_0}', "");
    Expect(1, 126239, '\p{Numeric_Value=4.000000000000000e+03}', "");
    Expect(0, 126239, '\p{^Numeric_Value=4.000000000000000e+03}', "");
    Expect(0, 126239, '\P{Numeric_Value=4.000000000000000e+03}', "");
    Expect(1, 126239, '\P{^Numeric_Value=4.000000000000000e+03}', "");
    Expect(0, 126240, '\p{Numeric_Value=4.000000000000000e+03}', "");
    Expect(1, 126240, '\p{^Numeric_Value=4.000000000000000e+03}', "");
    Expect(1, 126240, '\P{Numeric_Value=4.000000000000000e+03}', "");
    Expect(0, 126240, '\P{^Numeric_Value=4.000000000000000e+03}', "");
    Error('\p{Nv=_ 0_0_0_4_0_00:=}');
    Error('\P{Nv=_ 0_0_0_4_0_00:=}');
    Expect(1, 126239, '\p{Nv=:\A4000\z:}', "");;
    Expect(0, 126240, '\p{Nv=:\A4000\z:}', "");;
    Expect(1, 126239, '\p{Nv=0_0_0_0_0_0_0_04000}', "");
    Expect(0, 126239, '\p{^Nv=0_0_0_0_0_0_0_04000}', "");
    Expect(0, 126239, '\P{Nv=0_0_0_0_0_0_0_04000}', "");
    Expect(1, 126239, '\P{^Nv=0_0_0_0_0_0_0_04000}', "");
    Expect(0, 126240, '\p{Nv=0_0_0_0_0_0_0_04000}', "");
    Expect(1, 126240, '\p{^Nv=0_0_0_0_0_0_0_04000}', "");
    Expect(1, 126240, '\P{Nv=0_0_0_0_0_0_0_04000}', "");
    Expect(0, 126240, '\P{^Nv=0_0_0_0_0_0_0_04000}', "");
    Expect(1, 126239, '\p{Nv=4.000000000000000e+03}', "");
    Expect(0, 126239, '\p{^Nv=4.000000000000000e+03}', "");
    Expect(0, 126239, '\P{Nv=4.000000000000000e+03}', "");
    Expect(1, 126239, '\P{^Nv=4.000000000000000e+03}', "");
    Expect(0, 126240, '\p{Nv=4.000000000000000e+03}', "");
    Expect(1, 126240, '\p{^Nv=4.000000000000000e+03}', "");
    Expect(1, 126240, '\P{Nv=4.000000000000000e+03}', "");
    Expect(0, 126240, '\P{^Nv=4.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value=_00004000/a/}');
    Error('\P{Is_Numeric_Value=_00004000/a/}');
    Expect(1, 126239, '\p{Is_Numeric_Value=000000004000}', "");
    Expect(0, 126239, '\p{^Is_Numeric_Value=000000004000}', "");
    Expect(0, 126239, '\P{Is_Numeric_Value=000000004000}', "");
    Expect(1, 126239, '\P{^Is_Numeric_Value=000000004000}', "");
    Expect(0, 126240, '\p{Is_Numeric_Value=000000004000}', "");
    Expect(1, 126240, '\p{^Is_Numeric_Value=000000004000}', "");
    Expect(1, 126240, '\P{Is_Numeric_Value=000000004000}', "");
    Expect(0, 126240, '\P{^Is_Numeric_Value=000000004000}', "");
    Expect(1, 126239, '\p{Is_Numeric_Value=4.000000000000000e+03}', "");
    Expect(0, 126239, '\p{^Is_Numeric_Value=4.000000000000000e+03}', "");
    Expect(0, 126239, '\P{Is_Numeric_Value=4.000000000000000e+03}', "");
    Expect(1, 126239, '\P{^Is_Numeric_Value=4.000000000000000e+03}', "");
    Expect(0, 126240, '\p{Is_Numeric_Value=4.000000000000000e+03}', "");
    Expect(1, 126240, '\p{^Is_Numeric_Value=4.000000000000000e+03}', "");
    Expect(1, 126240, '\P{Is_Numeric_Value=4.000000000000000e+03}', "");
    Expect(0, 126240, '\P{^Is_Numeric_Value=4.000000000000000e+03}', "");
    Error('\p{Is_Nv=:=		0000_0400_0}');
    Error('\P{Is_Nv=:=		0000_0400_0}');
    Expect(1, 126239, '\p{Is_Nv=0000000004000}', "");
    Expect(0, 126239, '\p{^Is_Nv=0000000004000}', "");
    Expect(0, 126239, '\P{Is_Nv=0000000004000}', "");
    Expect(1, 126239, '\P{^Is_Nv=0000000004000}', "");
    Expect(0, 126240, '\p{Is_Nv=0000000004000}', "");
    Expect(1, 126240, '\p{^Is_Nv=0000000004000}', "");
    Expect(1, 126240, '\P{Is_Nv=0000000004000}', "");
    Expect(0, 126240, '\P{^Is_Nv=0000000004000}', "");
    Expect(1, 126239, '\p{Is_Nv:4.000000000000000e+03}', "");
    Expect(0, 126239, '\p{^Is_Nv:4.000000000000000e+03}', "");
    Expect(0, 126239, '\P{Is_Nv:4.000000000000000e+03}', "");
    Expect(1, 126239, '\P{^Is_Nv:4.000000000000000e+03}', "");
    Expect(0, 126240, '\p{Is_Nv:4.000000000000000e+03}', "");
    Expect(1, 126240, '\p{^Is_Nv:4.000000000000000e+03}', "");
    Expect(1, 126240, '\P{Is_Nv:4.000000000000000e+03}', "");
    Expect(0, 126240, '\P{^Is_Nv:4.000000000000000e+03}', "");
    Error('\p{Numeric_Value=/a/_-0_0_0_0_0_0_040000}');
    Error('\P{Numeric_Value=/a/_-0_0_0_0_0_0_040000}');
    Expect(1, 126248, '\p{Numeric_Value=:\A40000\z:}', "");;
    Expect(0, 126249, '\p{Numeric_Value=:\A40000\z:}', "");;
    Expect(1, 126248, '\p{Numeric_Value=0_0_0_0_0_0_0_040000}', "");
    Expect(0, 126248, '\p{^Numeric_Value=0_0_0_0_0_0_0_040000}', "");
    Expect(0, 126248, '\P{Numeric_Value=0_0_0_0_0_0_0_040000}', "");
    Expect(1, 126248, '\P{^Numeric_Value=0_0_0_0_0_0_0_040000}', "");
    Expect(0, 126249, '\p{Numeric_Value=0_0_0_0_0_0_0_040000}', "");
    Expect(1, 126249, '\p{^Numeric_Value=0_0_0_0_0_0_0_040000}', "");
    Expect(1, 126249, '\P{Numeric_Value=0_0_0_0_0_0_0_040000}', "");
    Expect(0, 126249, '\P{^Numeric_Value=0_0_0_0_0_0_0_040000}', "");
    Expect(1, 126248, '\p{Numeric_Value=4.000000000000000e+04}', "");
    Expect(0, 126248, '\p{^Numeric_Value=4.000000000000000e+04}', "");
    Expect(0, 126248, '\P{Numeric_Value=4.000000000000000e+04}', "");
    Expect(1, 126248, '\P{^Numeric_Value=4.000000000000000e+04}', "");
    Expect(0, 126249, '\p{Numeric_Value=4.000000000000000e+04}', "");
    Expect(1, 126249, '\p{^Numeric_Value=4.000000000000000e+04}', "");
    Expect(1, 126249, '\P{Numeric_Value=4.000000000000000e+04}', "");
    Expect(0, 126249, '\P{^Numeric_Value=4.000000000000000e+04}', "");
    Error('\p{Nv=/a/000040000}');
    Error('\P{Nv=/a/000040000}');
    Expect(1, 126248, '\p{Nv=:\A40000\z:}', "");;
    Expect(0, 126249, '\p{Nv=:\A40000\z:}', "");;
    Expect(1, 126248, '\p{Nv=0_0_0_0_0_0_4_0_000}', "");
    Expect(0, 126248, '\p{^Nv=0_0_0_0_0_0_4_0_000}', "");
    Expect(0, 126248, '\P{Nv=0_0_0_0_0_0_4_0_000}', "");
    Expect(1, 126248, '\P{^Nv=0_0_0_0_0_0_4_0_000}', "");
    Expect(0, 126249, '\p{Nv=0_0_0_0_0_0_4_0_000}', "");
    Expect(1, 126249, '\p{^Nv=0_0_0_0_0_0_4_0_000}', "");
    Expect(1, 126249, '\P{Nv=0_0_0_0_0_0_4_0_000}', "");
    Expect(0, 126249, '\P{^Nv=0_0_0_0_0_0_4_0_000}', "");
    Expect(1, 126248, '\p{Nv=4.000000000000000e+04}', "");
    Expect(0, 126248, '\p{^Nv=4.000000000000000e+04}', "");
    Expect(0, 126248, '\P{Nv=4.000000000000000e+04}', "");
    Expect(1, 126248, '\P{^Nv=4.000000000000000e+04}', "");
    Expect(0, 126249, '\p{Nv=4.000000000000000e+04}', "");
    Expect(1, 126249, '\p{^Nv=4.000000000000000e+04}', "");
    Expect(1, 126249, '\P{Nv=4.000000000000000e+04}', "");
    Expect(0, 126249, '\P{^Nv=4.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value= 	+000_400_00:=}');
    Error('\P{Is_Numeric_Value= 	+000_400_00:=}');
    Expect(1, 126248, '\p{Is_Numeric_Value=+00000004000_0}', "");
    Expect(0, 126248, '\p{^Is_Numeric_Value=+00000004000_0}', "");
    Expect(0, 126248, '\P{Is_Numeric_Value=+00000004000_0}', "");
    Expect(1, 126248, '\P{^Is_Numeric_Value=+00000004000_0}', "");
    Expect(0, 126249, '\p{Is_Numeric_Value=+00000004000_0}', "");
    Expect(1, 126249, '\p{^Is_Numeric_Value=+00000004000_0}', "");
    Expect(1, 126249, '\P{Is_Numeric_Value=+00000004000_0}', "");
    Expect(0, 126249, '\P{^Is_Numeric_Value=+00000004000_0}', "");
    Expect(1, 126248, '\p{Is_Numeric_Value=4.000000000000000e+04}', "");
    Expect(0, 126248, '\p{^Is_Numeric_Value=4.000000000000000e+04}', "");
    Expect(0, 126248, '\P{Is_Numeric_Value=4.000000000000000e+04}', "");
    Expect(1, 126248, '\P{^Is_Numeric_Value=4.000000000000000e+04}', "");
    Expect(0, 126249, '\p{Is_Numeric_Value=4.000000000000000e+04}', "");
    Expect(1, 126249, '\p{^Is_Numeric_Value=4.000000000000000e+04}', "");
    Expect(1, 126249, '\P{Is_Numeric_Value=4.000000000000000e+04}', "");
    Expect(0, 126249, '\P{^Is_Numeric_Value=4.000000000000000e+04}', "");
    Error('\p{Is_Nv=	/a/000000040000}');
    Error('\P{Is_Nv=	/a/000000040000}');
    Expect(1, 126248, '\p{Is_Nv=0_0_0_0_0_0_4_0_0_00}', "");
    Expect(0, 126248, '\p{^Is_Nv=0_0_0_0_0_0_4_0_0_00}', "");
    Expect(0, 126248, '\P{Is_Nv=0_0_0_0_0_0_4_0_0_00}', "");
    Expect(1, 126248, '\P{^Is_Nv=0_0_0_0_0_0_4_0_0_00}', "");
    Expect(0, 126249, '\p{Is_Nv=0_0_0_0_0_0_4_0_0_00}', "");
    Expect(1, 126249, '\p{^Is_Nv=0_0_0_0_0_0_4_0_0_00}', "");
    Expect(1, 126249, '\P{Is_Nv=0_0_0_0_0_0_4_0_0_00}', "");
    Expect(0, 126249, '\P{^Is_Nv=0_0_0_0_0_0_4_0_0_00}', "");
    Expect(1, 126248, '\p{Is_Nv=4.000000000000000e+04}', "");
    Expect(0, 126248, '\p{^Is_Nv=4.000000000000000e+04}', "");
    Expect(0, 126248, '\P{Is_Nv=4.000000000000000e+04}', "");
    Expect(1, 126248, '\P{^Is_Nv=4.000000000000000e+04}', "");
    Expect(0, 126249, '\p{Is_Nv=4.000000000000000e+04}', "");
    Expect(1, 126249, '\p{^Is_Nv=4.000000000000000e+04}', "");
    Expect(1, 126249, '\P{Is_Nv=4.000000000000000e+04}', "");
    Expect(0, 126249, '\P{^Is_Nv=4.000000000000000e+04}', "");
    Error('\p{Numeric_Value:		 +00000400000:=}');
    Error('\P{Numeric_Value:		 +00000400000:=}');
    Expect(1, 68080, '\p{Numeric_Value=:\A400000\z:}', "");;
    Expect(0, 68081, '\p{Numeric_Value=:\A400000\z:}', "");;
    Expect(1, 68080, '\p{Numeric_Value=+00400000}', "");
    Expect(0, 68080, '\p{^Numeric_Value=+00400000}', "");
    Expect(0, 68080, '\P{Numeric_Value=+00400000}', "");
    Expect(1, 68080, '\P{^Numeric_Value=+00400000}', "");
    Expect(0, 68081, '\p{Numeric_Value=+00400000}', "");
    Expect(1, 68081, '\p{^Numeric_Value=+00400000}', "");
    Expect(1, 68081, '\P{Numeric_Value=+00400000}', "");
    Expect(0, 68081, '\P{^Numeric_Value=+00400000}', "");
    Expect(1, 68080, '\p{Numeric_Value=4.000000000000000e+05}', "");
    Expect(0, 68080, '\p{^Numeric_Value=4.000000000000000e+05}', "");
    Expect(0, 68080, '\P{Numeric_Value=4.000000000000000e+05}', "");
    Expect(1, 68080, '\P{^Numeric_Value=4.000000000000000e+05}', "");
    Expect(0, 68081, '\p{Numeric_Value=4.000000000000000e+05}', "");
    Expect(1, 68081, '\p{^Numeric_Value=4.000000000000000e+05}', "");
    Expect(1, 68081, '\P{Numeric_Value=4.000000000000000e+05}', "");
    Expect(0, 68081, '\P{^Numeric_Value=4.000000000000000e+05}', "");
    Error('\p{Nv=/a/ 	+4_0_0_0_00}');
    Error('\P{Nv=/a/ 	+4_0_0_0_00}');
    Expect(1, 68080, '\p{Nv=:\A400000\z:}', "");;
    Expect(0, 68081, '\p{Nv=:\A400000\z:}', "");;
    Expect(1, 68080, '\p{Nv=+000000000400000}', "");
    Expect(0, 68080, '\p{^Nv=+000000000400000}', "");
    Expect(0, 68080, '\P{Nv=+000000000400000}', "");
    Expect(1, 68080, '\P{^Nv=+000000000400000}', "");
    Expect(0, 68081, '\p{Nv=+000000000400000}', "");
    Expect(1, 68081, '\p{^Nv=+000000000400000}', "");
    Expect(1, 68081, '\P{Nv=+000000000400000}', "");
    Expect(0, 68081, '\P{^Nv=+000000000400000}', "");
    Expect(1, 68080, '\p{Nv=4.000000000000000e+05}', "");
    Expect(0, 68080, '\p{^Nv=4.000000000000000e+05}', "");
    Expect(0, 68080, '\P{Nv=4.000000000000000e+05}', "");
    Expect(1, 68080, '\P{^Nv=4.000000000000000e+05}', "");
    Expect(0, 68081, '\p{Nv=4.000000000000000e+05}', "");
    Expect(1, 68081, '\p{^Nv=4.000000000000000e+05}', "");
    Expect(1, 68081, '\P{Nv=4.000000000000000e+05}', "");
    Expect(0, 68081, '\P{^Nv=4.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value=-:=0400000}');
    Error('\P{Is_Numeric_Value=-:=0400000}');
    Expect(1, 68080, '\p{Is_Numeric_Value=0000400000}', "");
    Expect(0, 68080, '\p{^Is_Numeric_Value=0000400000}', "");
    Expect(0, 68080, '\P{Is_Numeric_Value=0000400000}', "");
    Expect(1, 68080, '\P{^Is_Numeric_Value=0000400000}', "");
    Expect(0, 68081, '\p{Is_Numeric_Value=0000400000}', "");
    Expect(1, 68081, '\p{^Is_Numeric_Value=0000400000}', "");
    Expect(1, 68081, '\P{Is_Numeric_Value=0000400000}', "");
    Expect(0, 68081, '\P{^Is_Numeric_Value=0000400000}', "");
    Expect(1, 68080, '\p{Is_Numeric_Value=4.000000000000000e+05}', "");
    Expect(0, 68080, '\p{^Is_Numeric_Value=4.000000000000000e+05}', "");
    Expect(0, 68080, '\P{Is_Numeric_Value=4.000000000000000e+05}', "");
    Expect(1, 68080, '\P{^Is_Numeric_Value=4.000000000000000e+05}', "");
    Expect(0, 68081, '\p{Is_Numeric_Value=4.000000000000000e+05}', "");
    Expect(1, 68081, '\p{^Is_Numeric_Value=4.000000000000000e+05}', "");
    Expect(1, 68081, '\P{Is_Numeric_Value=4.000000000000000e+05}', "");
    Expect(0, 68081, '\P{^Is_Numeric_Value=4.000000000000000e+05}', "");
    Error('\p{Is_Nv=:= 	00000400000}');
    Error('\P{Is_Nv=:= 	00000400000}');
    Expect(1, 68080, '\p{Is_Nv=000400000}', "");
    Expect(0, 68080, '\p{^Is_Nv=000400000}', "");
    Expect(0, 68080, '\P{Is_Nv=000400000}', "");
    Expect(1, 68080, '\P{^Is_Nv=000400000}', "");
    Expect(0, 68081, '\p{Is_Nv=000400000}', "");
    Expect(1, 68081, '\p{^Is_Nv=000400000}', "");
    Expect(1, 68081, '\P{Is_Nv=000400000}', "");
    Expect(0, 68081, '\P{^Is_Nv=000400000}', "");
    Expect(1, 68080, '\p{Is_Nv=4.000000000000000e+05}', "");
    Expect(0, 68080, '\p{^Is_Nv=4.000000000000000e+05}', "");
    Expect(0, 68080, '\P{Is_Nv=4.000000000000000e+05}', "");
    Expect(1, 68080, '\P{^Is_Nv=4.000000000000000e+05}', "");
    Expect(0, 68081, '\p{Is_Nv=4.000000000000000e+05}', "");
    Expect(1, 68081, '\p{^Is_Nv=4.000000000000000e+05}', "");
    Expect(1, 68081, '\P{Is_Nv=4.000000000000000e+05}', "");
    Expect(0, 68081, '\P{^Is_Nv=4.000000000000000e+05}', "");
    Error('\p{Numeric_Value=-_0_0_0_0_41:=}');
    Error('\P{Numeric_Value=-_0_0_0_0_41:=}');
    Expect(1, 12982, '\p{Numeric_Value=:\A41\z:}', "");;
    Expect(0, 12983, '\p{Numeric_Value=:\A41\z:}', "");;
    Expect(1, 12982, '\p{Numeric_Value=0000000041}', "");
    Expect(0, 12982, '\p{^Numeric_Value=0000000041}', "");
    Expect(0, 12982, '\P{Numeric_Value=0000000041}', "");
    Expect(1, 12982, '\P{^Numeric_Value=0000000041}', "");
    Expect(0, 12983, '\p{Numeric_Value=0000000041}', "");
    Expect(1, 12983, '\p{^Numeric_Value=0000000041}', "");
    Expect(1, 12983, '\P{Numeric_Value=0000000041}', "");
    Expect(0, 12983, '\P{^Numeric_Value=0000000041}', "");
    Expect(1, 12982, '\p{Numeric_Value=4.100000000000000e+01}', "");
    Expect(0, 12982, '\p{^Numeric_Value=4.100000000000000e+01}', "");
    Expect(0, 12982, '\P{Numeric_Value=4.100000000000000e+01}', "");
    Expect(1, 12982, '\P{^Numeric_Value=4.100000000000000e+01}', "");
    Expect(0, 12983, '\p{Numeric_Value=4.100000000000000e+01}', "");
    Expect(1, 12983, '\p{^Numeric_Value=4.100000000000000e+01}', "");
    Expect(1, 12983, '\P{Numeric_Value=4.100000000000000e+01}', "");
    Expect(0, 12983, '\P{^Numeric_Value=4.100000000000000e+01}', "");
    Error('\p{Nv=/a/	-+0_0_0_0_0_41}');
    Error('\P{Nv=/a/	-+0_0_0_0_0_41}');
    Expect(1, 12982, '\p{Nv=:\A41\z:}', "");;
    Expect(0, 12983, '\p{Nv=:\A41\z:}', "");;
    Expect(1, 12982, '\p{Nv=+000000041}', "");
    Expect(0, 12982, '\p{^Nv=+000000041}', "");
    Expect(0, 12982, '\P{Nv=+000000041}', "");
    Expect(1, 12982, '\P{^Nv=+000000041}', "");
    Expect(0, 12983, '\p{Nv=+000000041}', "");
    Expect(1, 12983, '\p{^Nv=+000000041}', "");
    Expect(1, 12983, '\P{Nv=+000000041}', "");
    Expect(0, 12983, '\P{^Nv=+000000041}', "");
    Expect(1, 12982, '\p{Nv=4.100000000000000e+01}', "");
    Expect(0, 12982, '\p{^Nv=4.100000000000000e+01}', "");
    Expect(0, 12982, '\P{Nv=4.100000000000000e+01}', "");
    Expect(1, 12982, '\P{^Nv=4.100000000000000e+01}', "");
    Expect(0, 12983, '\p{Nv=4.100000000000000e+01}', "");
    Expect(1, 12983, '\p{^Nv=4.100000000000000e+01}', "");
    Expect(1, 12983, '\P{Nv=4.100000000000000e+01}', "");
    Expect(0, 12983, '\P{^Nv=4.100000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=:= +000000041}');
    Error('\P{Is_Numeric_Value=:= +000000041}');
    Expect(1, 12982, '\p{Is_Numeric_Value=+04_1}', "");
    Expect(0, 12982, '\p{^Is_Numeric_Value=+04_1}', "");
    Expect(0, 12982, '\P{Is_Numeric_Value=+04_1}', "");
    Expect(1, 12982, '\P{^Is_Numeric_Value=+04_1}', "");
    Expect(0, 12983, '\p{Is_Numeric_Value=+04_1}', "");
    Expect(1, 12983, '\p{^Is_Numeric_Value=+04_1}', "");
    Expect(1, 12983, '\P{Is_Numeric_Value=+04_1}', "");
    Expect(0, 12983, '\P{^Is_Numeric_Value=+04_1}', "");
    Expect(1, 12982, '\p{Is_Numeric_Value:	4.100000000000000e+01}', "");
    Expect(0, 12982, '\p{^Is_Numeric_Value:	4.100000000000000e+01}', "");
    Expect(0, 12982, '\P{Is_Numeric_Value:	4.100000000000000e+01}', "");
    Expect(1, 12982, '\P{^Is_Numeric_Value:	4.100000000000000e+01}', "");
    Expect(0, 12983, '\p{Is_Numeric_Value:	4.100000000000000e+01}', "");
    Expect(1, 12983, '\p{^Is_Numeric_Value:	4.100000000000000e+01}', "");
    Expect(1, 12983, '\P{Is_Numeric_Value:	4.100000000000000e+01}', "");
    Expect(0, 12983, '\P{^Is_Numeric_Value:	4.100000000000000e+01}', "");
    Error('\p{Is_Nv=/a/ 0_0_41}');
    Error('\P{Is_Nv=/a/ 0_0_41}');
    Expect(1, 12982, '\p{Is_Nv=00000000041}', "");
    Expect(0, 12982, '\p{^Is_Nv=00000000041}', "");
    Expect(0, 12982, '\P{Is_Nv=00000000041}', "");
    Expect(1, 12982, '\P{^Is_Nv=00000000041}', "");
    Expect(0, 12983, '\p{Is_Nv=00000000041}', "");
    Expect(1, 12983, '\p{^Is_Nv=00000000041}', "");
    Expect(1, 12983, '\P{Is_Nv=00000000041}', "");
    Expect(0, 12983, '\P{^Is_Nv=00000000041}', "");
    Expect(1, 12982, '\p{Is_Nv=4.100000000000000e+01}', "");
    Expect(0, 12982, '\p{^Is_Nv=4.100000000000000e+01}', "");
    Expect(0, 12982, '\P{Is_Nv=4.100000000000000e+01}', "");
    Expect(1, 12982, '\P{^Is_Nv=4.100000000000000e+01}', "");
    Expect(0, 12983, '\p{Is_Nv=4.100000000000000e+01}', "");
    Expect(1, 12983, '\p{^Is_Nv=4.100000000000000e+01}', "");
    Expect(1, 12983, '\P{Is_Nv=4.100000000000000e+01}', "");
    Expect(0, 12983, '\P{^Is_Nv=4.100000000000000e+01}', "");
    Error('\p{Numeric_Value= /a/00_04_2}');
    Error('\P{Numeric_Value= /a/00_04_2}');
    Expect(1, 12983, '\p{Numeric_Value=:\A42\z:}', "");;
    Expect(0, 12984, '\p{Numeric_Value=:\A42\z:}', "");;
    Expect(1, 12983, '\p{Numeric_Value=+000000042}', "");
    Expect(0, 12983, '\p{^Numeric_Value=+000000042}', "");
    Expect(0, 12983, '\P{Numeric_Value=+000000042}', "");
    Expect(1, 12983, '\P{^Numeric_Value=+000000042}', "");
    Expect(0, 12984, '\p{Numeric_Value=+000000042}', "");
    Expect(1, 12984, '\p{^Numeric_Value=+000000042}', "");
    Expect(1, 12984, '\P{Numeric_Value=+000000042}', "");
    Expect(0, 12984, '\P{^Numeric_Value=+000000042}', "");
    Expect(1, 12983, '\p{Numeric_Value=4.200000000000000e+01}', "");
    Expect(0, 12983, '\p{^Numeric_Value=4.200000000000000e+01}', "");
    Expect(0, 12983, '\P{Numeric_Value=4.200000000000000e+01}', "");
    Expect(1, 12983, '\P{^Numeric_Value=4.200000000000000e+01}', "");
    Expect(0, 12984, '\p{Numeric_Value=4.200000000000000e+01}', "");
    Expect(1, 12984, '\p{^Numeric_Value=4.200000000000000e+01}', "");
    Expect(1, 12984, '\P{Numeric_Value=4.200000000000000e+01}', "");
    Expect(0, 12984, '\P{^Numeric_Value=4.200000000000000e+01}', "");
    Error('\p{Nv=:=+00000042}');
    Error('\P{Nv=:=+00000042}');
    Expect(1, 12983, '\p{Nv=:\A42\z:}', "");;
    Expect(0, 12984, '\p{Nv=:\A42\z:}', "");;
    Expect(1, 12983, '\p{Nv:   00000042}', "");
    Expect(0, 12983, '\p{^Nv:   00000042}', "");
    Expect(0, 12983, '\P{Nv:   00000042}', "");
    Expect(1, 12983, '\P{^Nv:   00000042}', "");
    Expect(0, 12984, '\p{Nv:   00000042}', "");
    Expect(1, 12984, '\p{^Nv:   00000042}', "");
    Expect(1, 12984, '\P{Nv:   00000042}', "");
    Expect(0, 12984, '\P{^Nv:   00000042}', "");
    Expect(1, 12983, '\p{Nv=4.200000000000000e+01}', "");
    Expect(0, 12983, '\p{^Nv=4.200000000000000e+01}', "");
    Expect(0, 12983, '\P{Nv=4.200000000000000e+01}', "");
    Expect(1, 12983, '\P{^Nv=4.200000000000000e+01}', "");
    Expect(0, 12984, '\p{Nv=4.200000000000000e+01}', "");
    Expect(1, 12984, '\p{^Nv=4.200000000000000e+01}', "");
    Expect(1, 12984, '\P{Nv=4.200000000000000e+01}', "");
    Expect(0, 12984, '\P{^Nv=4.200000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=/a/--0000000042}');
    Error('\P{Is_Numeric_Value=/a/--0000000042}');
    Expect(1, 12983, '\p{Is_Numeric_Value=42}', "");
    Expect(0, 12983, '\p{^Is_Numeric_Value=42}', "");
    Expect(0, 12983, '\P{Is_Numeric_Value=42}', "");
    Expect(1, 12983, '\P{^Is_Numeric_Value=42}', "");
    Expect(0, 12984, '\p{Is_Numeric_Value=42}', "");
    Expect(1, 12984, '\p{^Is_Numeric_Value=42}', "");
    Expect(1, 12984, '\P{Is_Numeric_Value=42}', "");
    Expect(0, 12984, '\P{^Is_Numeric_Value=42}', "");
    Expect(1, 12983, '\p{Is_Numeric_Value=4.200000000000000e+01}', "");
    Expect(0, 12983, '\p{^Is_Numeric_Value=4.200000000000000e+01}', "");
    Expect(0, 12983, '\P{Is_Numeric_Value=4.200000000000000e+01}', "");
    Expect(1, 12983, '\P{^Is_Numeric_Value=4.200000000000000e+01}', "");
    Expect(0, 12984, '\p{Is_Numeric_Value=4.200000000000000e+01}', "");
    Expect(1, 12984, '\p{^Is_Numeric_Value=4.200000000000000e+01}', "");
    Expect(1, 12984, '\P{Is_Numeric_Value=4.200000000000000e+01}', "");
    Expect(0, 12984, '\P{^Is_Numeric_Value=4.200000000000000e+01}', "");
    Error('\p{Is_Nv=-00_04_2:=}');
    Error('\P{Is_Nv=-00_04_2:=}');
    Expect(1, 12983, '\p{Is_Nv=4_2}', "");
    Expect(0, 12983, '\p{^Is_Nv=4_2}', "");
    Expect(0, 12983, '\P{Is_Nv=4_2}', "");
    Expect(1, 12983, '\P{^Is_Nv=4_2}', "");
    Expect(0, 12984, '\p{Is_Nv=4_2}', "");
    Expect(1, 12984, '\p{^Is_Nv=4_2}', "");
    Expect(1, 12984, '\P{Is_Nv=4_2}', "");
    Expect(0, 12984, '\P{^Is_Nv=4_2}', "");
    Expect(1, 12983, '\p{Is_Nv=4.200000000000000e+01}', "");
    Expect(0, 12983, '\p{^Is_Nv=4.200000000000000e+01}', "");
    Expect(0, 12983, '\P{Is_Nv=4.200000000000000e+01}', "");
    Expect(1, 12983, '\P{^Is_Nv=4.200000000000000e+01}', "");
    Expect(0, 12984, '\p{Is_Nv=4.200000000000000e+01}', "");
    Expect(1, 12984, '\p{^Is_Nv=4.200000000000000e+01}', "");
    Expect(1, 12984, '\P{Is_Nv=4.200000000000000e+01}', "");
    Expect(0, 12984, '\P{^Is_Nv=4.200000000000000e+01}', "");
    Error('\p{Numeric_Value=	-00000043/a/}');
    Error('\P{Numeric_Value=	-00000043/a/}');
    Expect(1, 12984, '\p{Numeric_Value=:\A43\z:}', "");;
    Expect(0, 12985, '\p{Numeric_Value=:\A43\z:}', "");;
    Expect(1, 12984, '\p{Numeric_Value=+00043}', "");
    Expect(0, 12984, '\p{^Numeric_Value=+00043}', "");
    Expect(0, 12984, '\P{Numeric_Value=+00043}', "");
    Expect(1, 12984, '\P{^Numeric_Value=+00043}', "");
    Expect(0, 12985, '\p{Numeric_Value=+00043}', "");
    Expect(1, 12985, '\p{^Numeric_Value=+00043}', "");
    Expect(1, 12985, '\P{Numeric_Value=+00043}', "");
    Expect(0, 12985, '\P{^Numeric_Value=+00043}', "");
    Expect(1, 12984, '\p{Numeric_Value=4.300000000000000e+01}', "");
    Expect(0, 12984, '\p{^Numeric_Value=4.300000000000000e+01}', "");
    Expect(0, 12984, '\P{Numeric_Value=4.300000000000000e+01}', "");
    Expect(1, 12984, '\P{^Numeric_Value=4.300000000000000e+01}', "");
    Expect(0, 12985, '\p{Numeric_Value=4.300000000000000e+01}', "");
    Expect(1, 12985, '\p{^Numeric_Value=4.300000000000000e+01}', "");
    Expect(1, 12985, '\P{Numeric_Value=4.300000000000000e+01}', "");
    Expect(0, 12985, '\P{^Numeric_Value=4.300000000000000e+01}', "");
    Error('\p{Nv=_0043/a/}');
    Error('\P{Nv=_0043/a/}');
    Expect(1, 12984, '\p{Nv=:\A43\z:}', "");;
    Expect(0, 12985, '\p{Nv=:\A43\z:}', "");;
    Expect(1, 12984, '\p{Nv=43}', "");
    Expect(0, 12984, '\p{^Nv=43}', "");
    Expect(0, 12984, '\P{Nv=43}', "");
    Expect(1, 12984, '\P{^Nv=43}', "");
    Expect(0, 12985, '\p{Nv=43}', "");
    Expect(1, 12985, '\p{^Nv=43}', "");
    Expect(1, 12985, '\P{Nv=43}', "");
    Expect(0, 12985, '\P{^Nv=43}', "");
    Expect(1, 12984, '\p{Nv=4.300000000000000e+01}', "");
    Expect(0, 12984, '\p{^Nv=4.300000000000000e+01}', "");
    Expect(0, 12984, '\P{Nv=4.300000000000000e+01}', "");
    Expect(1, 12984, '\P{^Nv=4.300000000000000e+01}', "");
    Expect(0, 12985, '\p{Nv=4.300000000000000e+01}', "");
    Expect(1, 12985, '\p{^Nv=4.300000000000000e+01}', "");
    Expect(1, 12985, '\P{Nv=4.300000000000000e+01}', "");
    Expect(0, 12985, '\P{^Nv=4.300000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=/a/+04_3}');
    Error('\P{Is_Numeric_Value=/a/+04_3}');
    Expect(1, 12984, '\p{Is_Numeric_Value: 0000000043}', "");
    Expect(0, 12984, '\p{^Is_Numeric_Value: 0000000043}', "");
    Expect(0, 12984, '\P{Is_Numeric_Value: 0000000043}', "");
    Expect(1, 12984, '\P{^Is_Numeric_Value: 0000000043}', "");
    Expect(0, 12985, '\p{Is_Numeric_Value: 0000000043}', "");
    Expect(1, 12985, '\p{^Is_Numeric_Value: 0000000043}', "");
    Expect(1, 12985, '\P{Is_Numeric_Value: 0000000043}', "");
    Expect(0, 12985, '\P{^Is_Numeric_Value: 0000000043}', "");
    Expect(1, 12984, '\p{Is_Numeric_Value=4.300000000000000e+01}', "");
    Expect(0, 12984, '\p{^Is_Numeric_Value=4.300000000000000e+01}', "");
    Expect(0, 12984, '\P{Is_Numeric_Value=4.300000000000000e+01}', "");
    Expect(1, 12984, '\P{^Is_Numeric_Value=4.300000000000000e+01}', "");
    Expect(0, 12985, '\p{Is_Numeric_Value=4.300000000000000e+01}', "");
    Expect(1, 12985, '\p{^Is_Numeric_Value=4.300000000000000e+01}', "");
    Expect(1, 12985, '\P{Is_Numeric_Value=4.300000000000000e+01}', "");
    Expect(0, 12985, '\P{^Is_Numeric_Value=4.300000000000000e+01}', "");
    Error('\p{Is_Nv=	/a/4_3}');
    Error('\P{Is_Nv=	/a/4_3}');
    Expect(1, 12984, '\p{Is_Nv=+0000043}', "");
    Expect(0, 12984, '\p{^Is_Nv=+0000043}', "");
    Expect(0, 12984, '\P{Is_Nv=+0000043}', "");
    Expect(1, 12984, '\P{^Is_Nv=+0000043}', "");
    Expect(0, 12985, '\p{Is_Nv=+0000043}', "");
    Expect(1, 12985, '\p{^Is_Nv=+0000043}', "");
    Expect(1, 12985, '\P{Is_Nv=+0000043}', "");
    Expect(0, 12985, '\P{^Is_Nv=+0000043}', "");
    Expect(1, 12984, '\p{Is_Nv:   4.300000000000000e+01}', "");
    Expect(0, 12984, '\p{^Is_Nv:   4.300000000000000e+01}', "");
    Expect(0, 12984, '\P{Is_Nv:   4.300000000000000e+01}', "");
    Expect(1, 12984, '\P{^Is_Nv:   4.300000000000000e+01}', "");
    Expect(0, 12985, '\p{Is_Nv:   4.300000000000000e+01}', "");
    Expect(1, 12985, '\p{^Is_Nv:   4.300000000000000e+01}', "");
    Expect(1, 12985, '\P{Is_Nv:   4.300000000000000e+01}', "");
    Expect(0, 12985, '\P{^Is_Nv:   4.300000000000000e+01}', "");
    Error('\p{Numeric_Value=	-+00_04_32_00_0:=}');
    Error('\P{Numeric_Value=	-+00_04_32_00_0:=}');
    Expect(1, 74803, '\p{Numeric_Value=:\A432000\z:}', "");;
    Expect(0, 74804, '\p{Numeric_Value=:\A432000\z:}', "");;
    Expect(1, 74803, '\p{Numeric_Value=0_0_0_0_0_0_0_0_4_3_2_000}', "");
    Expect(0, 74803, '\p{^Numeric_Value=0_0_0_0_0_0_0_0_4_3_2_000}', "");
    Expect(0, 74803, '\P{Numeric_Value=0_0_0_0_0_0_0_0_4_3_2_000}', "");
    Expect(1, 74803, '\P{^Numeric_Value=0_0_0_0_0_0_0_0_4_3_2_000}', "");
    Expect(0, 74804, '\p{Numeric_Value=0_0_0_0_0_0_0_0_4_3_2_000}', "");
    Expect(1, 74804, '\p{^Numeric_Value=0_0_0_0_0_0_0_0_4_3_2_000}', "");
    Expect(1, 74804, '\P{Numeric_Value=0_0_0_0_0_0_0_0_4_3_2_000}', "");
    Expect(0, 74804, '\P{^Numeric_Value=0_0_0_0_0_0_0_0_4_3_2_000}', "");
    Expect(1, 74803, '\p{Numeric_Value=4.320000000000000e+05}', "");
    Expect(0, 74803, '\p{^Numeric_Value=4.320000000000000e+05}', "");
    Expect(0, 74803, '\P{Numeric_Value=4.320000000000000e+05}', "");
    Expect(1, 74803, '\P{^Numeric_Value=4.320000000000000e+05}', "");
    Expect(0, 74804, '\p{Numeric_Value=4.320000000000000e+05}', "");
    Expect(1, 74804, '\p{^Numeric_Value=4.320000000000000e+05}', "");
    Expect(1, 74804, '\P{Numeric_Value=4.320000000000000e+05}', "");
    Expect(0, 74804, '\P{^Numeric_Value=4.320000000000000e+05}', "");
    Error('\p{Nv=_/a/+00000000432000}');
    Error('\P{Nv=_/a/+00000000432000}');
    Expect(1, 74803, '\p{Nv=:\A432000\z:}', "");;
    Expect(0, 74804, '\p{Nv=:\A432000\z:}', "");;
    Expect(1, 74803, '\p{Nv=+4_3_2_000}', "");
    Expect(0, 74803, '\p{^Nv=+4_3_2_000}', "");
    Expect(0, 74803, '\P{Nv=+4_3_2_000}', "");
    Expect(1, 74803, '\P{^Nv=+4_3_2_000}', "");
    Expect(0, 74804, '\p{Nv=+4_3_2_000}', "");
    Expect(1, 74804, '\p{^Nv=+4_3_2_000}', "");
    Expect(1, 74804, '\P{Nv=+4_3_2_000}', "");
    Expect(0, 74804, '\P{^Nv=+4_3_2_000}', "");
    Expect(1, 74803, '\p{Nv:4.320000000000000e+05}', "");
    Expect(0, 74803, '\p{^Nv:4.320000000000000e+05}', "");
    Expect(0, 74803, '\P{Nv:4.320000000000000e+05}', "");
    Expect(1, 74803, '\P{^Nv:4.320000000000000e+05}', "");
    Expect(0, 74804, '\p{Nv:4.320000000000000e+05}', "");
    Expect(1, 74804, '\p{^Nv:4.320000000000000e+05}', "");
    Expect(1, 74804, '\P{Nv:4.320000000000000e+05}', "");
    Expect(0, 74804, '\P{^Nv:4.320000000000000e+05}', "");
    Error('\p{Is_Numeric_Value=	-+00_00_00_00_04_32_00_0/a/}');
    Error('\P{Is_Numeric_Value=	-+00_00_00_00_04_32_00_0/a/}');
    Expect(1, 74803, '\p{Is_Numeric_Value=000000432000}', "");
    Expect(0, 74803, '\p{^Is_Numeric_Value=000000432000}', "");
    Expect(0, 74803, '\P{Is_Numeric_Value=000000432000}', "");
    Expect(1, 74803, '\P{^Is_Numeric_Value=000000432000}', "");
    Expect(0, 74804, '\p{Is_Numeric_Value=000000432000}', "");
    Expect(1, 74804, '\p{^Is_Numeric_Value=000000432000}', "");
    Expect(1, 74804, '\P{Is_Numeric_Value=000000432000}', "");
    Expect(0, 74804, '\P{^Is_Numeric_Value=000000432000}', "");
    Expect(1, 74803, '\p{Is_Numeric_Value=4.320000000000000e+05}', "");
    Expect(0, 74803, '\p{^Is_Numeric_Value=4.320000000000000e+05}', "");
    Expect(0, 74803, '\P{Is_Numeric_Value=4.320000000000000e+05}', "");
    Expect(1, 74803, '\P{^Is_Numeric_Value=4.320000000000000e+05}', "");
    Expect(0, 74804, '\p{Is_Numeric_Value=4.320000000000000e+05}', "");
    Expect(1, 74804, '\p{^Is_Numeric_Value=4.320000000000000e+05}', "");
    Expect(1, 74804, '\P{Is_Numeric_Value=4.320000000000000e+05}', "");
    Expect(0, 74804, '\P{^Is_Numeric_Value=4.320000000000000e+05}', "");
    Error('\p{Is_Nv= -4_3_2_0_00/a/}');
    Error('\P{Is_Nv= -4_3_2_0_00/a/}');
    Expect(1, 74803, '\p{Is_Nv=0000000432000}', "");
    Expect(0, 74803, '\p{^Is_Nv=0000000432000}', "");
    Expect(0, 74803, '\P{Is_Nv=0000000432000}', "");
    Expect(1, 74803, '\P{^Is_Nv=0000000432000}', "");
    Expect(0, 74804, '\p{Is_Nv=0000000432000}', "");
    Expect(1, 74804, '\p{^Is_Nv=0000000432000}', "");
    Expect(1, 74804, '\P{Is_Nv=0000000432000}', "");
    Expect(0, 74804, '\P{^Is_Nv=0000000432000}', "");
    Expect(1, 74803, '\p{Is_Nv=4.320000000000000e+05}', "");
    Expect(0, 74803, '\p{^Is_Nv=4.320000000000000e+05}', "");
    Expect(0, 74803, '\P{Is_Nv=4.320000000000000e+05}', "");
    Expect(1, 74803, '\P{^Is_Nv=4.320000000000000e+05}', "");
    Expect(0, 74804, '\p{Is_Nv=4.320000000000000e+05}', "");
    Expect(1, 74804, '\p{^Is_Nv=4.320000000000000e+05}', "");
    Expect(1, 74804, '\P{Is_Nv=4.320000000000000e+05}', "");
    Expect(0, 74804, '\P{^Is_Nv=4.320000000000000e+05}', "");
    Error('\p{Numeric_Value= +044/a/}');
    Error('\P{Numeric_Value= +044/a/}');
    Expect(1, 12985, '\p{Numeric_Value=:\A44\z:}', "");;
    Expect(0, 12986, '\p{Numeric_Value=:\A44\z:}', "");;
    Expect(1, 12985, '\p{Numeric_Value=0_0_0_44}', "");
    Expect(0, 12985, '\p{^Numeric_Value=0_0_0_44}', "");
    Expect(0, 12985, '\P{Numeric_Value=0_0_0_44}', "");
    Expect(1, 12985, '\P{^Numeric_Value=0_0_0_44}', "");
    Expect(0, 12986, '\p{Numeric_Value=0_0_0_44}', "");
    Expect(1, 12986, '\p{^Numeric_Value=0_0_0_44}', "");
    Expect(1, 12986, '\P{Numeric_Value=0_0_0_44}', "");
    Expect(0, 12986, '\P{^Numeric_Value=0_0_0_44}', "");
    Expect(1, 12985, '\p{Numeric_Value=4.400000000000000e+01}', "");
    Expect(0, 12985, '\p{^Numeric_Value=4.400000000000000e+01}', "");
    Expect(0, 12985, '\P{Numeric_Value=4.400000000000000e+01}', "");
    Expect(1, 12985, '\P{^Numeric_Value=4.400000000000000e+01}', "");
    Expect(0, 12986, '\p{Numeric_Value=4.400000000000000e+01}', "");
    Expect(1, 12986, '\p{^Numeric_Value=4.400000000000000e+01}', "");
    Expect(1, 12986, '\P{Numeric_Value=4.400000000000000e+01}', "");
    Expect(0, 12986, '\P{^Numeric_Value=4.400000000000000e+01}', "");
    Error('\p{Nv=/a/ 0_0_0_0_0044}');
    Error('\P{Nv=/a/ 0_0_0_0_0044}');
    Expect(1, 12985, '\p{Nv=:\A44\z:}', "");;
    Expect(0, 12986, '\p{Nv=:\A44\z:}', "");;
    Expect(1, 12985, '\p{Nv=+000_000_000_44}', "");
    Expect(0, 12985, '\p{^Nv=+000_000_000_44}', "");
    Expect(0, 12985, '\P{Nv=+000_000_000_44}', "");
    Expect(1, 12985, '\P{^Nv=+000_000_000_44}', "");
    Expect(0, 12986, '\p{Nv=+000_000_000_44}', "");
    Expect(1, 12986, '\p{^Nv=+000_000_000_44}', "");
    Expect(1, 12986, '\P{Nv=+000_000_000_44}', "");
    Expect(0, 12986, '\P{^Nv=+000_000_000_44}', "");
    Expect(1, 12985, '\p{Nv=4.400000000000000e+01}', "");
    Expect(0, 12985, '\p{^Nv=4.400000000000000e+01}', "");
    Expect(0, 12985, '\P{Nv=4.400000000000000e+01}', "");
    Expect(1, 12985, '\P{^Nv=4.400000000000000e+01}', "");
    Expect(0, 12986, '\p{Nv=4.400000000000000e+01}', "");
    Expect(1, 12986, '\p{^Nv=4.400000000000000e+01}', "");
    Expect(1, 12986, '\P{Nv=4.400000000000000e+01}', "");
    Expect(0, 12986, '\P{^Nv=4.400000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=/a/__+044}');
    Error('\P{Is_Numeric_Value=/a/__+044}');
    Expect(1, 12985, '\p{Is_Numeric_Value=+004_4}', "");
    Expect(0, 12985, '\p{^Is_Numeric_Value=+004_4}', "");
    Expect(0, 12985, '\P{Is_Numeric_Value=+004_4}', "");
    Expect(1, 12985, '\P{^Is_Numeric_Value=+004_4}', "");
    Expect(0, 12986, '\p{Is_Numeric_Value=+004_4}', "");
    Expect(1, 12986, '\p{^Is_Numeric_Value=+004_4}', "");
    Expect(1, 12986, '\P{Is_Numeric_Value=+004_4}', "");
    Expect(0, 12986, '\P{^Is_Numeric_Value=+004_4}', "");
    Expect(1, 12985, '\p{Is_Numeric_Value=4.400000000000000e+01}', "");
    Expect(0, 12985, '\p{^Is_Numeric_Value=4.400000000000000e+01}', "");
    Expect(0, 12985, '\P{Is_Numeric_Value=4.400000000000000e+01}', "");
    Expect(1, 12985, '\P{^Is_Numeric_Value=4.400000000000000e+01}', "");
    Expect(0, 12986, '\p{Is_Numeric_Value=4.400000000000000e+01}', "");
    Expect(1, 12986, '\p{^Is_Numeric_Value=4.400000000000000e+01}', "");
    Expect(1, 12986, '\P{Is_Numeric_Value=4.400000000000000e+01}', "");
    Expect(0, 12986, '\P{^Is_Numeric_Value=4.400000000000000e+01}', "");
    Error('\p{Is_Nv=/a/+0_0_0_0_0_00044}');
    Error('\P{Is_Nv=/a/+0_0_0_0_0_00044}');
    Expect(1, 12985, '\p{Is_Nv=00044}', "");
    Expect(0, 12985, '\p{^Is_Nv=00044}', "");
    Expect(0, 12985, '\P{Is_Nv=00044}', "");
    Expect(1, 12985, '\P{^Is_Nv=00044}', "");
    Expect(0, 12986, '\p{Is_Nv=00044}', "");
    Expect(1, 12986, '\p{^Is_Nv=00044}', "");
    Expect(1, 12986, '\P{Is_Nv=00044}', "");
    Expect(0, 12986, '\P{^Is_Nv=00044}', "");
    Expect(1, 12985, '\p{Is_Nv=4.400000000000000e+01}', "");
    Expect(0, 12985, '\p{^Is_Nv=4.400000000000000e+01}', "");
    Expect(0, 12985, '\P{Is_Nv=4.400000000000000e+01}', "");
    Expect(1, 12985, '\P{^Is_Nv=4.400000000000000e+01}', "");
    Expect(0, 12986, '\p{Is_Nv=4.400000000000000e+01}', "");
    Expect(1, 12986, '\p{^Is_Nv=4.400000000000000e+01}', "");
    Expect(1, 12986, '\P{Is_Nv=4.400000000000000e+01}', "");
    Expect(0, 12986, '\P{^Is_Nv=4.400000000000000e+01}', "");
    Error('\p{Numeric_Value: /a/	 0004_5}');
    Error('\P{Numeric_Value: /a/	 0004_5}');
    Expect(1, 12986, '\p{Numeric_Value=:\A45\z:}', "");;
    Expect(0, 12987, '\p{Numeric_Value=:\A45\z:}', "");;
    Expect(1, 12986, '\p{Numeric_Value=00_00_04_5}', "");
    Expect(0, 12986, '\p{^Numeric_Value=00_00_04_5}', "");
    Expect(0, 12986, '\P{Numeric_Value=00_00_04_5}', "");
    Expect(1, 12986, '\P{^Numeric_Value=00_00_04_5}', "");
    Expect(0, 12987, '\p{Numeric_Value=00_00_04_5}', "");
    Expect(1, 12987, '\p{^Numeric_Value=00_00_04_5}', "");
    Expect(1, 12987, '\P{Numeric_Value=00_00_04_5}', "");
    Expect(0, 12987, '\P{^Numeric_Value=00_00_04_5}', "");
    Expect(1, 12986, '\p{Numeric_Value=4.500000000000000e+01}', "");
    Expect(0, 12986, '\p{^Numeric_Value=4.500000000000000e+01}', "");
    Expect(0, 12986, '\P{Numeric_Value=4.500000000000000e+01}', "");
    Expect(1, 12986, '\P{^Numeric_Value=4.500000000000000e+01}', "");
    Expect(0, 12987, '\p{Numeric_Value=4.500000000000000e+01}', "");
    Expect(1, 12987, '\p{^Numeric_Value=4.500000000000000e+01}', "");
    Expect(1, 12987, '\P{Numeric_Value=4.500000000000000e+01}', "");
    Expect(0, 12987, '\P{^Numeric_Value=4.500000000000000e+01}', "");
    Error('\p{Nv=-/a/+0004_5}');
    Error('\P{Nv=-/a/+0004_5}');
    Expect(1, 12986, '\p{Nv=:\A45\z:}', "");;
    Expect(0, 12987, '\p{Nv=:\A45\z:}', "");;
    Expect(1, 12986, '\p{Nv:	000000045}', "");
    Expect(0, 12986, '\p{^Nv:	000000045}', "");
    Expect(0, 12986, '\P{Nv:	000000045}', "");
    Expect(1, 12986, '\P{^Nv:	000000045}', "");
    Expect(0, 12987, '\p{Nv:	000000045}', "");
    Expect(1, 12987, '\p{^Nv:	000000045}', "");
    Expect(1, 12987, '\P{Nv:	000000045}', "");
    Expect(0, 12987, '\P{^Nv:	000000045}', "");
    Expect(1, 12986, '\p{Nv=4.500000000000000e+01}', "");
    Expect(0, 12986, '\p{^Nv=4.500000000000000e+01}', "");
    Expect(0, 12986, '\P{Nv=4.500000000000000e+01}', "");
    Expect(1, 12986, '\P{^Nv=4.500000000000000e+01}', "");
    Expect(0, 12987, '\p{Nv=4.500000000000000e+01}', "");
    Expect(1, 12987, '\p{^Nv=4.500000000000000e+01}', "");
    Expect(1, 12987, '\P{Nv=4.500000000000000e+01}', "");
    Expect(0, 12987, '\P{^Nv=4.500000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=:=--45}');
    Error('\P{Is_Numeric_Value=:=--45}');
    Expect(1, 12986, '\p{Is_Numeric_Value=+0_0_0_0_0_0_45}', "");
    Expect(0, 12986, '\p{^Is_Numeric_Value=+0_0_0_0_0_0_45}', "");
    Expect(0, 12986, '\P{Is_Numeric_Value=+0_0_0_0_0_0_45}', "");
    Expect(1, 12986, '\P{^Is_Numeric_Value=+0_0_0_0_0_0_45}', "");
    Expect(0, 12987, '\p{Is_Numeric_Value=+0_0_0_0_0_0_45}', "");
    Expect(1, 12987, '\p{^Is_Numeric_Value=+0_0_0_0_0_0_45}', "");
    Expect(1, 12987, '\P{Is_Numeric_Value=+0_0_0_0_0_0_45}', "");
    Expect(0, 12987, '\P{^Is_Numeric_Value=+0_0_0_0_0_0_45}', "");
    Expect(1, 12986, '\p{Is_Numeric_Value=4.500000000000000e+01}', "");
    Expect(0, 12986, '\p{^Is_Numeric_Value=4.500000000000000e+01}', "");
    Expect(0, 12986, '\P{Is_Numeric_Value=4.500000000000000e+01}', "");
    Expect(1, 12986, '\P{^Is_Numeric_Value=4.500000000000000e+01}', "");
    Expect(0, 12987, '\p{Is_Numeric_Value=4.500000000000000e+01}', "");
    Expect(1, 12987, '\p{^Is_Numeric_Value=4.500000000000000e+01}', "");
    Expect(1, 12987, '\P{Is_Numeric_Value=4.500000000000000e+01}', "");
    Expect(0, 12987, '\P{^Is_Numeric_Value=4.500000000000000e+01}', "");
    Error('\p{Is_Nv=:=0_0_0_0_0_0_0_0_0_45}');
    Error('\P{Is_Nv=:=0_0_0_0_0_0_0_0_0_45}');
    Expect(1, 12986, '\p{Is_Nv=0004_5}', "");
    Expect(0, 12986, '\p{^Is_Nv=0004_5}', "");
    Expect(0, 12986, '\P{Is_Nv=0004_5}', "");
    Expect(1, 12986, '\P{^Is_Nv=0004_5}', "");
    Expect(0, 12987, '\p{Is_Nv=0004_5}', "");
    Expect(1, 12987, '\p{^Is_Nv=0004_5}', "");
    Expect(1, 12987, '\P{Is_Nv=0004_5}', "");
    Expect(0, 12987, '\P{^Is_Nv=0004_5}', "");
    Expect(1, 12986, '\p{Is_Nv=4.500000000000000e+01}', "");
    Expect(0, 12986, '\p{^Is_Nv=4.500000000000000e+01}', "");
    Expect(0, 12986, '\P{Is_Nv=4.500000000000000e+01}', "");
    Expect(1, 12986, '\P{^Is_Nv=4.500000000000000e+01}', "");
    Expect(0, 12987, '\p{Is_Nv=4.500000000000000e+01}', "");
    Expect(1, 12987, '\p{^Is_Nv=4.500000000000000e+01}', "");
    Expect(1, 12987, '\P{Is_Nv=4.500000000000000e+01}', "");
    Expect(0, 12987, '\P{^Is_Nv=4.500000000000000e+01}', "");
    Error('\p{Numeric_Value=_:=0046}');
    Error('\P{Numeric_Value=_:=0046}');
    Expect(1, 12987, '\p{Numeric_Value=:\A46\z:}', "");;
    Expect(0, 12988, '\p{Numeric_Value=:\A46\z:}', "");;
    Expect(1, 12987, '\p{Numeric_Value=04_6}', "");
    Expect(0, 12987, '\p{^Numeric_Value=04_6}', "");
    Expect(0, 12987, '\P{Numeric_Value=04_6}', "");
    Expect(1, 12987, '\P{^Numeric_Value=04_6}', "");
    Expect(0, 12988, '\p{Numeric_Value=04_6}', "");
    Expect(1, 12988, '\p{^Numeric_Value=04_6}', "");
    Expect(1, 12988, '\P{Numeric_Value=04_6}', "");
    Expect(0, 12988, '\P{^Numeric_Value=04_6}', "");
    Expect(1, 12987, '\p{Numeric_Value=4.600000000000000e+01}', "");
    Expect(0, 12987, '\p{^Numeric_Value=4.600000000000000e+01}', "");
    Expect(0, 12987, '\P{Numeric_Value=4.600000000000000e+01}', "");
    Expect(1, 12987, '\P{^Numeric_Value=4.600000000000000e+01}', "");
    Expect(0, 12988, '\p{Numeric_Value=4.600000000000000e+01}', "");
    Expect(1, 12988, '\p{^Numeric_Value=4.600000000000000e+01}', "");
    Expect(1, 12988, '\P{Numeric_Value=4.600000000000000e+01}', "");
    Expect(0, 12988, '\P{^Numeric_Value=4.600000000000000e+01}', "");
    Error('\p{Nv=/a/00000046}');
    Error('\P{Nv=/a/00000046}');
    Expect(1, 12987, '\p{Nv=:\A46\z:}', "");;
    Expect(0, 12988, '\p{Nv=:\A46\z:}', "");;
    Expect(1, 12987, '\p{Nv:   000000046}', "");
    Expect(0, 12987, '\p{^Nv:   000000046}', "");
    Expect(0, 12987, '\P{Nv:   000000046}', "");
    Expect(1, 12987, '\P{^Nv:   000000046}', "");
    Expect(0, 12988, '\p{Nv:   000000046}', "");
    Expect(1, 12988, '\p{^Nv:   000000046}', "");
    Expect(1, 12988, '\P{Nv:   000000046}', "");
    Expect(0, 12988, '\P{^Nv:   000000046}', "");
    Expect(1, 12987, '\p{Nv=4.600000000000000e+01}', "");
    Expect(0, 12987, '\p{^Nv=4.600000000000000e+01}', "");
    Expect(0, 12987, '\P{Nv=4.600000000000000e+01}', "");
    Expect(1, 12987, '\P{^Nv=4.600000000000000e+01}', "");
    Expect(0, 12988, '\p{Nv=4.600000000000000e+01}', "");
    Expect(1, 12988, '\p{^Nv=4.600000000000000e+01}', "");
    Expect(1, 12988, '\P{Nv=4.600000000000000e+01}', "");
    Expect(0, 12988, '\P{^Nv=4.600000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=-/a/0_0_0_0_0046}');
    Error('\P{Is_Numeric_Value=-/a/0_0_0_0_0046}');
    Expect(1, 12987, '\p{Is_Numeric_Value=+04_6}', "");
    Expect(0, 12987, '\p{^Is_Numeric_Value=+04_6}', "");
    Expect(0, 12987, '\P{Is_Numeric_Value=+04_6}', "");
    Expect(1, 12987, '\P{^Is_Numeric_Value=+04_6}', "");
    Expect(0, 12988, '\p{Is_Numeric_Value=+04_6}', "");
    Expect(1, 12988, '\p{^Is_Numeric_Value=+04_6}', "");
    Expect(1, 12988, '\P{Is_Numeric_Value=+04_6}', "");
    Expect(0, 12988, '\P{^Is_Numeric_Value=+04_6}', "");
    Expect(1, 12987, '\p{Is_Numeric_Value:4.600000000000000e+01}', "");
    Expect(0, 12987, '\p{^Is_Numeric_Value:4.600000000000000e+01}', "");
    Expect(0, 12987, '\P{Is_Numeric_Value:4.600000000000000e+01}', "");
    Expect(1, 12987, '\P{^Is_Numeric_Value:4.600000000000000e+01}', "");
    Expect(0, 12988, '\p{Is_Numeric_Value:4.600000000000000e+01}', "");
    Expect(1, 12988, '\p{^Is_Numeric_Value:4.600000000000000e+01}', "");
    Expect(1, 12988, '\P{Is_Numeric_Value:4.600000000000000e+01}', "");
    Expect(0, 12988, '\P{^Is_Numeric_Value:4.600000000000000e+01}', "");
    Error('\p{Is_Nv=	/a/00000004_6}');
    Error('\P{Is_Nv=	/a/00000004_6}');
    Expect(1, 12987, '\p{Is_Nv=000_004_6}', "");
    Expect(0, 12987, '\p{^Is_Nv=000_004_6}', "");
    Expect(0, 12987, '\P{Is_Nv=000_004_6}', "");
    Expect(1, 12987, '\P{^Is_Nv=000_004_6}', "");
    Expect(0, 12988, '\p{Is_Nv=000_004_6}', "");
    Expect(1, 12988, '\p{^Is_Nv=000_004_6}', "");
    Expect(1, 12988, '\P{Is_Nv=000_004_6}', "");
    Expect(0, 12988, '\P{^Is_Nv=000_004_6}', "");
    Expect(1, 12987, '\p{Is_Nv=4.600000000000000e+01}', "");
    Expect(0, 12987, '\p{^Is_Nv=4.600000000000000e+01}', "");
    Expect(0, 12987, '\P{Is_Nv=4.600000000000000e+01}', "");
    Expect(1, 12987, '\P{^Is_Nv=4.600000000000000e+01}', "");
    Expect(0, 12988, '\p{Is_Nv=4.600000000000000e+01}', "");
    Expect(1, 12988, '\p{^Is_Nv=4.600000000000000e+01}', "");
    Expect(1, 12988, '\P{Is_Nv=4.600000000000000e+01}', "");
    Expect(0, 12988, '\P{^Is_Nv=4.600000000000000e+01}', "");
    Error('\p{Numeric_Value=:=__0047}');
    Error('\P{Numeric_Value=:=__0047}');
    Expect(1, 12988, '\p{Numeric_Value=:\A47\z:}', "");;
    Expect(0, 12989, '\p{Numeric_Value=:\A47\z:}', "");;
    Expect(1, 12988, '\p{Numeric_Value=00047}', "");
    Expect(0, 12988, '\p{^Numeric_Value=00047}', "");
    Expect(0, 12988, '\P{Numeric_Value=00047}', "");
    Expect(1, 12988, '\P{^Numeric_Value=00047}', "");
    Expect(0, 12989, '\p{Numeric_Value=00047}', "");
    Expect(1, 12989, '\p{^Numeric_Value=00047}', "");
    Expect(1, 12989, '\P{Numeric_Value=00047}', "");
    Expect(0, 12989, '\P{^Numeric_Value=00047}', "");
    Expect(1, 12988, '\p{Numeric_Value=4.700000000000000e+01}', "");
    Expect(0, 12988, '\p{^Numeric_Value=4.700000000000000e+01}', "");
    Expect(0, 12988, '\P{Numeric_Value=4.700000000000000e+01}', "");
    Expect(1, 12988, '\P{^Numeric_Value=4.700000000000000e+01}', "");
    Expect(0, 12989, '\p{Numeric_Value=4.700000000000000e+01}', "");
    Expect(1, 12989, '\p{^Numeric_Value=4.700000000000000e+01}', "");
    Expect(1, 12989, '\P{Numeric_Value=4.700000000000000e+01}', "");
    Expect(0, 12989, '\P{^Numeric_Value=4.700000000000000e+01}', "");
    Error('\p{Nv=_/a/+04_7}');
    Error('\P{Nv=_/a/+04_7}');
    Expect(1, 12988, '\p{Nv=:\A47\z:}', "");;
    Expect(0, 12989, '\p{Nv=:\A47\z:}', "");;
    Expect(1, 12988, '\p{Nv=0_0_0_0_0_047}', "");
    Expect(0, 12988, '\p{^Nv=0_0_0_0_0_047}', "");
    Expect(0, 12988, '\P{Nv=0_0_0_0_0_047}', "");
    Expect(1, 12988, '\P{^Nv=0_0_0_0_0_047}', "");
    Expect(0, 12989, '\p{Nv=0_0_0_0_0_047}', "");
    Expect(1, 12989, '\p{^Nv=0_0_0_0_0_047}', "");
    Expect(1, 12989, '\P{Nv=0_0_0_0_0_047}', "");
    Expect(0, 12989, '\P{^Nv=0_0_0_0_0_047}', "");
    Expect(1, 12988, '\p{Nv=4.700000000000000e+01}', "");
    Expect(0, 12988, '\p{^Nv=4.700000000000000e+01}', "");
    Expect(0, 12988, '\P{Nv=4.700000000000000e+01}', "");
    Expect(1, 12988, '\P{^Nv=4.700000000000000e+01}', "");
    Expect(0, 12989, '\p{Nv=4.700000000000000e+01}', "");
    Expect(1, 12989, '\p{^Nv=4.700000000000000e+01}', "");
    Expect(1, 12989, '\P{Nv=4.700000000000000e+01}', "");
    Expect(0, 12989, '\P{^Nv=4.700000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=--+00_00_04_7/a/}');
    Error('\P{Is_Numeric_Value=--+00_00_04_7/a/}');
    Expect(1, 12988, '\p{Is_Numeric_Value=000000047}', "");
    Expect(0, 12988, '\p{^Is_Numeric_Value=000000047}', "");
    Expect(0, 12988, '\P{Is_Numeric_Value=000000047}', "");
    Expect(1, 12988, '\P{^Is_Numeric_Value=000000047}', "");
    Expect(0, 12989, '\p{Is_Numeric_Value=000000047}', "");
    Expect(1, 12989, '\p{^Is_Numeric_Value=000000047}', "");
    Expect(1, 12989, '\P{Is_Numeric_Value=000000047}', "");
    Expect(0, 12989, '\P{^Is_Numeric_Value=000000047}', "");
    Expect(1, 12988, '\p{Is_Numeric_Value=4.700000000000000e+01}', "");
    Expect(0, 12988, '\p{^Is_Numeric_Value=4.700000000000000e+01}', "");
    Expect(0, 12988, '\P{Is_Numeric_Value=4.700000000000000e+01}', "");
    Expect(1, 12988, '\P{^Is_Numeric_Value=4.700000000000000e+01}', "");
    Expect(0, 12989, '\p{Is_Numeric_Value=4.700000000000000e+01}', "");
    Expect(1, 12989, '\p{^Is_Numeric_Value=4.700000000000000e+01}', "");
    Expect(1, 12989, '\P{Is_Numeric_Value=4.700000000000000e+01}', "");
    Expect(0, 12989, '\P{^Is_Numeric_Value=4.700000000000000e+01}', "");
    Error('\p{Is_Nv=_	00047:=}');
    Error('\P{Is_Nv=_	00047:=}');
    Expect(1, 12988, '\p{Is_Nv=+0047}', "");
    Expect(0, 12988, '\p{^Is_Nv=+0047}', "");
    Expect(0, 12988, '\P{Is_Nv=+0047}', "");
    Expect(1, 12988, '\P{^Is_Nv=+0047}', "");
    Expect(0, 12989, '\p{Is_Nv=+0047}', "");
    Expect(1, 12989, '\p{^Is_Nv=+0047}', "");
    Expect(1, 12989, '\P{Is_Nv=+0047}', "");
    Expect(0, 12989, '\P{^Is_Nv=+0047}', "");
    Expect(1, 12988, '\p{Is_Nv=4.700000000000000e+01}', "");
    Expect(0, 12988, '\p{^Is_Nv=4.700000000000000e+01}', "");
    Expect(0, 12988, '\P{Is_Nv=4.700000000000000e+01}', "");
    Expect(1, 12988, '\P{^Is_Nv=4.700000000000000e+01}', "");
    Expect(0, 12989, '\p{Is_Nv=4.700000000000000e+01}', "");
    Expect(1, 12989, '\p{^Is_Nv=4.700000000000000e+01}', "");
    Expect(1, 12989, '\P{Is_Nv=4.700000000000000e+01}', "");
    Expect(0, 12989, '\P{^Is_Nv=4.700000000000000e+01}', "");
    Error('\p{Numeric_Value= _0_0_0_0_0_48/a/}');
    Error('\P{Numeric_Value= _0_0_0_0_0_48/a/}');
    Expect(1, 12989, '\p{Numeric_Value=:\A48\z:}', "");;
    Expect(0, 12990, '\p{Numeric_Value=:\A48\z:}', "");;
    Expect(1, 12989, '\p{Numeric_Value=0048}', "");
    Expect(0, 12989, '\p{^Numeric_Value=0048}', "");
    Expect(0, 12989, '\P{Numeric_Value=0048}', "");
    Expect(1, 12989, '\P{^Numeric_Value=0048}', "");
    Expect(0, 12990, '\p{Numeric_Value=0048}', "");
    Expect(1, 12990, '\p{^Numeric_Value=0048}', "");
    Expect(1, 12990, '\P{Numeric_Value=0048}', "");
    Expect(0, 12990, '\P{^Numeric_Value=0048}', "");
    Expect(1, 12989, '\p{Numeric_Value=4.800000000000000e+01}', "");
    Expect(0, 12989, '\p{^Numeric_Value=4.800000000000000e+01}', "");
    Expect(0, 12989, '\P{Numeric_Value=4.800000000000000e+01}', "");
    Expect(1, 12989, '\P{^Numeric_Value=4.800000000000000e+01}', "");
    Expect(0, 12990, '\p{Numeric_Value=4.800000000000000e+01}', "");
    Expect(1, 12990, '\p{^Numeric_Value=4.800000000000000e+01}', "");
    Expect(1, 12990, '\P{Numeric_Value=4.800000000000000e+01}', "");
    Expect(0, 12990, '\P{^Numeric_Value=4.800000000000000e+01}', "");
    Error('\p{Nv=/a/+48}');
    Error('\P{Nv=/a/+48}');
    Expect(1, 12989, '\p{Nv=:\A48\z:}', "");;
    Expect(0, 12990, '\p{Nv=:\A48\z:}', "");;
    Expect(1, 12989, '\p{Nv=000000048}', "");
    Expect(0, 12989, '\p{^Nv=000000048}', "");
    Expect(0, 12989, '\P{Nv=000000048}', "");
    Expect(1, 12989, '\P{^Nv=000000048}', "");
    Expect(0, 12990, '\p{Nv=000000048}', "");
    Expect(1, 12990, '\p{^Nv=000000048}', "");
    Expect(1, 12990, '\P{Nv=000000048}', "");
    Expect(0, 12990, '\P{^Nv=000000048}', "");
    Expect(1, 12989, '\p{Nv=4.800000000000000e+01}', "");
    Expect(0, 12989, '\p{^Nv=4.800000000000000e+01}', "");
    Expect(0, 12989, '\P{Nv=4.800000000000000e+01}', "");
    Expect(1, 12989, '\P{^Nv=4.800000000000000e+01}', "");
    Expect(0, 12990, '\p{Nv=4.800000000000000e+01}', "");
    Expect(1, 12990, '\p{^Nv=4.800000000000000e+01}', "");
    Expect(1, 12990, '\P{Nv=4.800000000000000e+01}', "");
    Expect(0, 12990, '\P{^Nv=4.800000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=:=_	004_8}');
    Error('\P{Is_Numeric_Value=:=_	004_8}');
    Expect(1, 12989, '\p{Is_Numeric_Value=0000048}', "");
    Expect(0, 12989, '\p{^Is_Numeric_Value=0000048}', "");
    Expect(0, 12989, '\P{Is_Numeric_Value=0000048}', "");
    Expect(1, 12989, '\P{^Is_Numeric_Value=0000048}', "");
    Expect(0, 12990, '\p{Is_Numeric_Value=0000048}', "");
    Expect(1, 12990, '\p{^Is_Numeric_Value=0000048}', "");
    Expect(1, 12990, '\P{Is_Numeric_Value=0000048}', "");
    Expect(0, 12990, '\P{^Is_Numeric_Value=0000048}', "");
    Expect(1, 12989, '\p{Is_Numeric_Value=4.800000000000000e+01}', "");
    Expect(0, 12989, '\p{^Is_Numeric_Value=4.800000000000000e+01}', "");
    Expect(0, 12989, '\P{Is_Numeric_Value=4.800000000000000e+01}', "");
    Expect(1, 12989, '\P{^Is_Numeric_Value=4.800000000000000e+01}', "");
    Expect(0, 12990, '\p{Is_Numeric_Value=4.800000000000000e+01}', "");
    Expect(1, 12990, '\p{^Is_Numeric_Value=4.800000000000000e+01}', "");
    Expect(1, 12990, '\P{Is_Numeric_Value=4.800000000000000e+01}', "");
    Expect(0, 12990, '\P{^Is_Numeric_Value=4.800000000000000e+01}', "");
    Error('\p{Is_Nv=:=000004_8}');
    Error('\P{Is_Nv=:=000004_8}');
    Expect(1, 12989, '\p{Is_Nv=00048}', "");
    Expect(0, 12989, '\p{^Is_Nv=00048}', "");
    Expect(0, 12989, '\P{Is_Nv=00048}', "");
    Expect(1, 12989, '\P{^Is_Nv=00048}', "");
    Expect(0, 12990, '\p{Is_Nv=00048}', "");
    Expect(1, 12990, '\p{^Is_Nv=00048}', "");
    Expect(1, 12990, '\P{Is_Nv=00048}', "");
    Expect(0, 12990, '\P{^Is_Nv=00048}', "");
    Expect(1, 12989, '\p{Is_Nv=4.800000000000000e+01}', "");
    Expect(0, 12989, '\p{^Is_Nv=4.800000000000000e+01}', "");
    Expect(0, 12989, '\P{Is_Nv=4.800000000000000e+01}', "");
    Expect(1, 12989, '\P{^Is_Nv=4.800000000000000e+01}', "");
    Expect(0, 12990, '\p{Is_Nv=4.800000000000000e+01}', "");
    Expect(1, 12990, '\p{^Is_Nv=4.800000000000000e+01}', "");
    Expect(1, 12990, '\P{Is_Nv=4.800000000000000e+01}', "");
    Expect(0, 12990, '\P{^Is_Nv=4.800000000000000e+01}', "");
    Error('\p{Numeric_Value=__+049:=}');
    Error('\P{Numeric_Value=__+049:=}');
    Expect(1, 12990, '\p{Numeric_Value=:\A49\z:}', "");;
    Expect(0, 12991, '\p{Numeric_Value=:\A49\z:}', "");;
    Expect(1, 12990, '\p{Numeric_Value=+00000049}', "");
    Expect(0, 12990, '\p{^Numeric_Value=+00000049}', "");
    Expect(0, 12990, '\P{Numeric_Value=+00000049}', "");
    Expect(1, 12990, '\P{^Numeric_Value=+00000049}', "");
    Expect(0, 12991, '\p{Numeric_Value=+00000049}', "");
    Expect(1, 12991, '\p{^Numeric_Value=+00000049}', "");
    Expect(1, 12991, '\P{Numeric_Value=+00000049}', "");
    Expect(0, 12991, '\P{^Numeric_Value=+00000049}', "");
    Expect(1, 12990, '\p{Numeric_Value=4.900000000000000e+01}', "");
    Expect(0, 12990, '\p{^Numeric_Value=4.900000000000000e+01}', "");
    Expect(0, 12990, '\P{Numeric_Value=4.900000000000000e+01}', "");
    Expect(1, 12990, '\P{^Numeric_Value=4.900000000000000e+01}', "");
    Expect(0, 12991, '\p{Numeric_Value=4.900000000000000e+01}', "");
    Expect(1, 12991, '\p{^Numeric_Value=4.900000000000000e+01}', "");
    Expect(1, 12991, '\P{Numeric_Value=4.900000000000000e+01}', "");
    Expect(0, 12991, '\P{^Numeric_Value=4.900000000000000e+01}', "");
    Error('\p{Nv=-:=049}');
    Error('\P{Nv=-:=049}');
    Expect(1, 12990, '\p{Nv=:\A49\z:}', "");;
    Expect(0, 12991, '\p{Nv=:\A49\z:}', "");;
    Expect(1, 12990, '\p{Nv=000049}', "");
    Expect(0, 12990, '\p{^Nv=000049}', "");
    Expect(0, 12990, '\P{Nv=000049}', "");
    Expect(1, 12990, '\P{^Nv=000049}', "");
    Expect(0, 12991, '\p{Nv=000049}', "");
    Expect(1, 12991, '\p{^Nv=000049}', "");
    Expect(1, 12991, '\P{Nv=000049}', "");
    Expect(0, 12991, '\P{^Nv=000049}', "");
    Expect(1, 12990, '\p{Nv:	4.900000000000000e+01}', "");
    Expect(0, 12990, '\p{^Nv:	4.900000000000000e+01}', "");
    Expect(0, 12990, '\P{Nv:	4.900000000000000e+01}', "");
    Expect(1, 12990, '\P{^Nv:	4.900000000000000e+01}', "");
    Expect(0, 12991, '\p{Nv:	4.900000000000000e+01}', "");
    Expect(1, 12991, '\p{^Nv:	4.900000000000000e+01}', "");
    Expect(1, 12991, '\P{Nv:	4.900000000000000e+01}', "");
    Expect(0, 12991, '\P{^Nv:	4.900000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=-:=000000049}');
    Error('\P{Is_Numeric_Value=-:=000000049}');
    Expect(1, 12990, '\p{Is_Numeric_Value=000049}', "");
    Expect(0, 12990, '\p{^Is_Numeric_Value=000049}', "");
    Expect(0, 12990, '\P{Is_Numeric_Value=000049}', "");
    Expect(1, 12990, '\P{^Is_Numeric_Value=000049}', "");
    Expect(0, 12991, '\p{Is_Numeric_Value=000049}', "");
    Expect(1, 12991, '\p{^Is_Numeric_Value=000049}', "");
    Expect(1, 12991, '\P{Is_Numeric_Value=000049}', "");
    Expect(0, 12991, '\P{^Is_Numeric_Value=000049}', "");
    Expect(1, 12990, '\p{Is_Numeric_Value=4.900000000000000e+01}', "");
    Expect(0, 12990, '\p{^Is_Numeric_Value=4.900000000000000e+01}', "");
    Expect(0, 12990, '\P{Is_Numeric_Value=4.900000000000000e+01}', "");
    Expect(1, 12990, '\P{^Is_Numeric_Value=4.900000000000000e+01}', "");
    Expect(0, 12991, '\p{Is_Numeric_Value=4.900000000000000e+01}', "");
    Expect(1, 12991, '\p{^Is_Numeric_Value=4.900000000000000e+01}', "");
    Expect(1, 12991, '\P{Is_Numeric_Value=4.900000000000000e+01}', "");
    Expect(0, 12991, '\P{^Is_Numeric_Value=4.900000000000000e+01}', "");
    Error('\p{Is_Nv=-+00000000049/a/}');
    Error('\P{Is_Nv=-+00000000049/a/}');
    Expect(1, 12990, '\p{Is_Nv=+04_9}', "");
    Expect(0, 12990, '\p{^Is_Nv=+04_9}', "");
    Expect(0, 12990, '\P{Is_Nv=+04_9}', "");
    Expect(1, 12990, '\P{^Is_Nv=+04_9}', "");
    Expect(0, 12991, '\p{Is_Nv=+04_9}', "");
    Expect(1, 12991, '\p{^Is_Nv=+04_9}', "");
    Expect(1, 12991, '\P{Is_Nv=+04_9}', "");
    Expect(0, 12991, '\P{^Is_Nv=+04_9}', "");
    Expect(1, 12990, '\p{Is_Nv=4.900000000000000e+01}', "");
    Expect(0, 12990, '\p{^Is_Nv=4.900000000000000e+01}', "");
    Expect(0, 12990, '\P{Is_Nv=4.900000000000000e+01}', "");
    Expect(1, 12990, '\P{^Is_Nv=4.900000000000000e+01}', "");
    Expect(0, 12991, '\p{Is_Nv=4.900000000000000e+01}', "");
    Expect(1, 12991, '\p{^Is_Nv=4.900000000000000e+01}', "");
    Expect(1, 12991, '\P{Is_Nv=4.900000000000000e+01}', "");
    Expect(0, 12991, '\P{^Is_Nv=4.900000000000000e+01}', "");
    Error('\p{Numeric_Value=		5/a/}');
    Error('\P{Numeric_Value=		5/a/}');
    Expect(1, 131361, '\p{Numeric_Value=:\A5\z:}', "");;
    Expect(0, 131362, '\p{Numeric_Value=:\A5\z:}', "");;
    Expect(1, 131361, '\p{Numeric_Value=+000000005}', "");
    Expect(0, 131361, '\p{^Numeric_Value=+000000005}', "");
    Expect(0, 131361, '\P{Numeric_Value=+000000005}', "");
    Expect(1, 131361, '\P{^Numeric_Value=+000000005}', "");
    Expect(0, 131362, '\p{Numeric_Value=+000000005}', "");
    Expect(1, 131362, '\p{^Numeric_Value=+000000005}', "");
    Expect(1, 131362, '\P{Numeric_Value=+000000005}', "");
    Expect(0, 131362, '\P{^Numeric_Value=+000000005}', "");
    Expect(1, 131361, '\p{Numeric_Value=5.000000000000000e+00}', "");
    Expect(0, 131361, '\p{^Numeric_Value=5.000000000000000e+00}', "");
    Expect(0, 131361, '\P{Numeric_Value=5.000000000000000e+00}', "");
    Expect(1, 131361, '\P{^Numeric_Value=5.000000000000000e+00}', "");
    Expect(0, 131362, '\p{Numeric_Value=5.000000000000000e+00}', "");
    Expect(1, 131362, '\p{^Numeric_Value=5.000000000000000e+00}', "");
    Expect(1, 131362, '\P{Numeric_Value=5.000000000000000e+00}', "");
    Expect(0, 131362, '\P{^Numeric_Value=5.000000000000000e+00}', "");
    Error('\p{Nv=/a/ 	+5}');
    Error('\P{Nv=/a/ 	+5}');
    Expect(1, 131361, '\p{Nv=:\A5\z:}', "");;
    Expect(0, 131362, '\p{Nv=:\A5\z:}', "");;
    Expect(1, 131361, '\p{Nv=0005}', "");
    Expect(0, 131361, '\p{^Nv=0005}', "");
    Expect(0, 131361, '\P{Nv=0005}', "");
    Expect(1, 131361, '\P{^Nv=0005}', "");
    Expect(0, 131362, '\p{Nv=0005}', "");
    Expect(1, 131362, '\p{^Nv=0005}', "");
    Expect(1, 131362, '\P{Nv=0005}', "");
    Expect(0, 131362, '\P{^Nv=0005}', "");
    Expect(1, 131361, '\p{Nv=5.000000000000000e+00}', "");
    Expect(0, 131361, '\p{^Nv=5.000000000000000e+00}', "");
    Expect(0, 131361, '\P{Nv=5.000000000000000e+00}', "");
    Expect(1, 131361, '\P{^Nv=5.000000000000000e+00}', "");
    Expect(0, 131362, '\p{Nv=5.000000000000000e+00}', "");
    Expect(1, 131362, '\p{^Nv=5.000000000000000e+00}', "");
    Expect(1, 131362, '\P{Nv=5.000000000000000e+00}', "");
    Expect(0, 131362, '\P{^Nv=5.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value:		+00000_5/a/}');
    Error('\P{Is_Numeric_Value:		+00000_5/a/}');
    Expect(1, 131361, '\p{Is_Numeric_Value=0000_5}', "");
    Expect(0, 131361, '\p{^Is_Numeric_Value=0000_5}', "");
    Expect(0, 131361, '\P{Is_Numeric_Value=0000_5}', "");
    Expect(1, 131361, '\P{^Is_Numeric_Value=0000_5}', "");
    Expect(0, 131362, '\p{Is_Numeric_Value=0000_5}', "");
    Expect(1, 131362, '\p{^Is_Numeric_Value=0000_5}', "");
    Expect(1, 131362, '\P{Is_Numeric_Value=0000_5}', "");
    Expect(0, 131362, '\P{^Is_Numeric_Value=0000_5}', "");
    Expect(1, 131361, '\p{Is_Numeric_Value=5.000000000000000e+00}', "");
    Expect(0, 131361, '\p{^Is_Numeric_Value=5.000000000000000e+00}', "");
    Expect(0, 131361, '\P{Is_Numeric_Value=5.000000000000000e+00}', "");
    Expect(1, 131361, '\P{^Is_Numeric_Value=5.000000000000000e+00}', "");
    Expect(0, 131362, '\p{Is_Numeric_Value=5.000000000000000e+00}', "");
    Expect(1, 131362, '\p{^Is_Numeric_Value=5.000000000000000e+00}', "");
    Expect(1, 131362, '\P{Is_Numeric_Value=5.000000000000000e+00}', "");
    Expect(0, 131362, '\P{^Is_Numeric_Value=5.000000000000000e+00}', "");
    Error('\p{Is_Nv=/a/		0_0_0_005}');
    Error('\P{Is_Nv=/a/		0_0_0_005}');
    Expect(1, 131361, '\p{Is_Nv=0000000005}', "");
    Expect(0, 131361, '\p{^Is_Nv=0000000005}', "");
    Expect(0, 131361, '\P{Is_Nv=0000000005}', "");
    Expect(1, 131361, '\P{^Is_Nv=0000000005}', "");
    Expect(0, 131362, '\p{Is_Nv=0000000005}', "");
    Expect(1, 131362, '\p{^Is_Nv=0000000005}', "");
    Expect(1, 131362, '\P{Is_Nv=0000000005}', "");
    Expect(0, 131362, '\P{^Is_Nv=0000000005}', "");
    Expect(1, 131361, '\p{Is_Nv:   5.000000000000000e+00}', "");
    Expect(0, 131361, '\p{^Is_Nv:   5.000000000000000e+00}', "");
    Expect(0, 131361, '\P{Is_Nv:   5.000000000000000e+00}', "");
    Expect(1, 131361, '\P{^Is_Nv:   5.000000000000000e+00}', "");
    Expect(0, 131362, '\p{Is_Nv:   5.000000000000000e+00}', "");
    Expect(1, 131362, '\p{^Is_Nv:   5.000000000000000e+00}', "");
    Expect(1, 131362, '\P{Is_Nv:   5.000000000000000e+00}', "");
    Expect(0, 131362, '\P{^Is_Nv:   5.000000000000000e+00}', "");
    Error('\p{Numeric_Value:-/a/05/000012}');
    Error('\P{Numeric_Value:-/a/05/000012}');
    Expect(1, 68090, '\p{Numeric_Value=:\A5/12\z:}', "");;
    Expect(0, 68091, '\p{Numeric_Value=:\A5/12\z:}', "");;
    Expect(1, 68090, '\p{Numeric_Value=5/12}', "");
    Expect(0, 68090, '\p{^Numeric_Value=5/12}', "");
    Expect(0, 68090, '\P{Numeric_Value=5/12}', "");
    Expect(1, 68090, '\P{^Numeric_Value=5/12}', "");
    Expect(0, 68091, '\p{Numeric_Value=5/12}', "");
    Expect(1, 68091, '\p{^Numeric_Value=5/12}', "");
    Expect(1, 68091, '\P{Numeric_Value=5/12}', "");
    Expect(0, 68091, '\P{^Numeric_Value=5/12}', "");
    Expect(1, 68090, '\p{Numeric_Value=300/720}', "");
    Expect(0, 68090, '\p{^Numeric_Value=300/720}', "");
    Expect(0, 68090, '\P{Numeric_Value=300/720}', "");
    Expect(1, 68090, '\P{^Numeric_Value=300/720}', "");
    Expect(0, 68091, '\p{Numeric_Value=300/720}', "");
    Expect(1, 68091, '\p{^Numeric_Value=300/720}', "");
    Expect(1, 68091, '\P{Numeric_Value=300/720}', "");
    Expect(0, 68091, '\P{^Numeric_Value=300/720}', "");
    Error('\p{Numeric_Value=4.2e-01}');
    Error('\P{Numeric_Value=4.2e-01}');
    Expect(1, 68090, '\p{Numeric_Value=4.17e-01}', "");
    Expect(0, 68090, '\p{^Numeric_Value=4.17e-01}', "");
    Expect(0, 68090, '\P{Numeric_Value=4.17e-01}', "");
    Expect(1, 68090, '\P{^Numeric_Value=4.17e-01}', "");
    Expect(0, 68091, '\p{Numeric_Value=4.17e-01}', "");
    Expect(1, 68091, '\p{^Numeric_Value=4.17e-01}', "");
    Expect(1, 68091, '\P{Numeric_Value=4.17e-01}', "");
    Expect(0, 68091, '\P{^Numeric_Value=4.17e-01}', "");
    Error('\p{Numeric_Value=0.42}');
    Error('\P{Numeric_Value=0.42}');
    Expect(1, 68090, '\p{Numeric_Value=4.167e-01}', "");
    Expect(0, 68090, '\p{^Numeric_Value=4.167e-01}', "");
    Expect(0, 68090, '\P{Numeric_Value=4.167e-01}', "");
    Expect(1, 68090, '\P{^Numeric_Value=4.167e-01}', "");
    Expect(0, 68091, '\p{Numeric_Value=4.167e-01}', "");
    Expect(1, 68091, '\p{^Numeric_Value=4.167e-01}', "");
    Expect(1, 68091, '\P{Numeric_Value=4.167e-01}', "");
    Expect(0, 68091, '\P{^Numeric_Value=4.167e-01}', "");
    Expect(1, 68090, '\p{Numeric_Value=0.417}', "");
    Expect(0, 68090, '\p{^Numeric_Value=0.417}', "");
    Expect(0, 68090, '\P{Numeric_Value=0.417}', "");
    Expect(1, 68090, '\P{^Numeric_Value=0.417}', "");
    Expect(0, 68091, '\p{Numeric_Value=0.417}', "");
    Expect(1, 68091, '\p{^Numeric_Value=0.417}', "");
    Expect(1, 68091, '\P{Numeric_Value=0.417}', "");
    Expect(0, 68091, '\P{^Numeric_Value=0.417}', "");
    Expect(1, 68090, '\p{Numeric_Value=4.1667e-01}', "");
    Expect(0, 68090, '\p{^Numeric_Value=4.1667e-01}', "");
    Expect(0, 68090, '\P{Numeric_Value=4.1667e-01}', "");
    Expect(1, 68090, '\P{^Numeric_Value=4.1667e-01}', "");
    Expect(0, 68091, '\p{Numeric_Value=4.1667e-01}', "");
    Expect(1, 68091, '\p{^Numeric_Value=4.1667e-01}', "");
    Expect(1, 68091, '\P{Numeric_Value=4.1667e-01}', "");
    Expect(0, 68091, '\P{^Numeric_Value=4.1667e-01}', "");
    Expect(1, 68090, '\p{Numeric_Value: 0.4167}', "");
    Expect(0, 68090, '\p{^Numeric_Value: 0.4167}', "");
    Expect(0, 68090, '\P{Numeric_Value: 0.4167}', "");
    Expect(1, 68090, '\P{^Numeric_Value: 0.4167}', "");
    Expect(0, 68091, '\p{Numeric_Value: 0.4167}', "");
    Expect(1, 68091, '\p{^Numeric_Value: 0.4167}', "");
    Expect(1, 68091, '\P{Numeric_Value: 0.4167}', "");
    Expect(0, 68091, '\P{^Numeric_Value: 0.4167}', "");
    Error('\p{Nv=:=- 5/0000000012}');
    Error('\P{Nv=:=- 5/0000000012}');
    Expect(1, 68090, '\p{Nv=:\A5/12\z:}', "");;
    Expect(0, 68091, '\p{Nv=:\A5/12\z:}', "");;
    Expect(1, 68090, '\p{Nv=0000000005/00012}', "");
    Expect(0, 68090, '\p{^Nv=0000000005/00012}', "");
    Expect(0, 68090, '\P{Nv=0000000005/00012}', "");
    Expect(1, 68090, '\P{^Nv=0000000005/00012}', "");
    Expect(0, 68091, '\p{Nv=0000000005/00012}', "");
    Expect(1, 68091, '\p{^Nv=0000000005/00012}', "");
    Expect(1, 68091, '\P{Nv=0000000005/00012}', "");
    Expect(0, 68091, '\P{^Nv=0000000005/00012}', "");
    Expect(1, 68090, '\p{Nv=300/720}', "");
    Expect(0, 68090, '\p{^Nv=300/720}', "");
    Expect(0, 68090, '\P{Nv=300/720}', "");
    Expect(1, 68090, '\P{^Nv=300/720}', "");
    Expect(0, 68091, '\p{Nv=300/720}', "");
    Expect(1, 68091, '\p{^Nv=300/720}', "");
    Expect(1, 68091, '\P{Nv=300/720}', "");
    Expect(0, 68091, '\P{^Nv=300/720}', "");
    Error('\p{Nv=4.2e-01}');
    Error('\P{Nv=4.2e-01}');
    Expect(1, 68090, '\p{Nv=4.17e-01}', "");
    Expect(0, 68090, '\p{^Nv=4.17e-01}', "");
    Expect(0, 68090, '\P{Nv=4.17e-01}', "");
    Expect(1, 68090, '\P{^Nv=4.17e-01}', "");
    Expect(0, 68091, '\p{Nv=4.17e-01}', "");
    Expect(1, 68091, '\p{^Nv=4.17e-01}', "");
    Expect(1, 68091, '\P{Nv=4.17e-01}', "");
    Expect(0, 68091, '\P{^Nv=4.17e-01}', "");
    Error('\p{Nv=0.42}');
    Error('\P{Nv=0.42}');
    Expect(1, 68090, '\p{Nv=4.167e-01}', "");
    Expect(0, 68090, '\p{^Nv=4.167e-01}', "");
    Expect(0, 68090, '\P{Nv=4.167e-01}', "");
    Expect(1, 68090, '\P{^Nv=4.167e-01}', "");
    Expect(0, 68091, '\p{Nv=4.167e-01}', "");
    Expect(1, 68091, '\p{^Nv=4.167e-01}', "");
    Expect(1, 68091, '\P{Nv=4.167e-01}', "");
    Expect(0, 68091, '\P{^Nv=4.167e-01}', "");
    Expect(1, 68090, '\p{Nv=0.417}', "");
    Expect(0, 68090, '\p{^Nv=0.417}', "");
    Expect(0, 68090, '\P{Nv=0.417}', "");
    Expect(1, 68090, '\P{^Nv=0.417}', "");
    Expect(0, 68091, '\p{Nv=0.417}', "");
    Expect(1, 68091, '\p{^Nv=0.417}', "");
    Expect(1, 68091, '\P{Nv=0.417}', "");
    Expect(0, 68091, '\P{^Nv=0.417}', "");
    Expect(1, 68090, '\p{Nv=4.1667e-01}', "");
    Expect(0, 68090, '\p{^Nv=4.1667e-01}', "");
    Expect(0, 68090, '\P{Nv=4.1667e-01}', "");
    Expect(1, 68090, '\P{^Nv=4.1667e-01}', "");
    Expect(0, 68091, '\p{Nv=4.1667e-01}', "");
    Expect(1, 68091, '\p{^Nv=4.1667e-01}', "");
    Expect(1, 68091, '\P{Nv=4.1667e-01}', "");
    Expect(0, 68091, '\P{^Nv=4.1667e-01}', "");
    Expect(1, 68090, '\p{Nv: 0.4167}', "");
    Expect(0, 68090, '\p{^Nv: 0.4167}', "");
    Expect(0, 68090, '\P{Nv: 0.4167}', "");
    Expect(1, 68090, '\P{^Nv: 0.4167}', "");
    Expect(0, 68091, '\p{Nv: 0.4167}', "");
    Expect(1, 68091, '\p{^Nv: 0.4167}', "");
    Expect(1, 68091, '\P{Nv: 0.4167}', "");
    Expect(0, 68091, '\P{^Nv: 0.4167}', "");
    Error('\p{Is_Numeric_Value= -000000005/0000012:=}');
    Error('\P{Is_Numeric_Value= -000000005/0000012:=}');
    Expect(1, 68090, '\p{Is_Numeric_Value=05/12}', "");
    Expect(0, 68090, '\p{^Is_Numeric_Value=05/12}', "");
    Expect(0, 68090, '\P{Is_Numeric_Value=05/12}', "");
    Expect(1, 68090, '\P{^Is_Numeric_Value=05/12}', "");
    Expect(0, 68091, '\p{Is_Numeric_Value=05/12}', "");
    Expect(1, 68091, '\p{^Is_Numeric_Value=05/12}', "");
    Expect(1, 68091, '\P{Is_Numeric_Value=05/12}', "");
    Expect(0, 68091, '\P{^Is_Numeric_Value=05/12}', "");
    Expect(1, 68090, '\p{Is_Numeric_Value=300/720}', "");
    Expect(0, 68090, '\p{^Is_Numeric_Value=300/720}', "");
    Expect(0, 68090, '\P{Is_Numeric_Value=300/720}', "");
    Expect(1, 68090, '\P{^Is_Numeric_Value=300/720}', "");
    Expect(0, 68091, '\p{Is_Numeric_Value=300/720}', "");
    Expect(1, 68091, '\p{^Is_Numeric_Value=300/720}', "");
    Expect(1, 68091, '\P{Is_Numeric_Value=300/720}', "");
    Expect(0, 68091, '\P{^Is_Numeric_Value=300/720}', "");
    Error('\p{Is_Numeric_Value=4.2e-01}');
    Error('\P{Is_Numeric_Value=4.2e-01}');
    Expect(1, 68090, '\p{Is_Numeric_Value: 4.17e-01}', "");
    Expect(0, 68090, '\p{^Is_Numeric_Value: 4.17e-01}', "");
    Expect(0, 68090, '\P{Is_Numeric_Value: 4.17e-01}', "");
    Expect(1, 68090, '\P{^Is_Numeric_Value: 4.17e-01}', "");
    Expect(0, 68091, '\p{Is_Numeric_Value: 4.17e-01}', "");
    Expect(1, 68091, '\p{^Is_Numeric_Value: 4.17e-01}', "");
    Expect(1, 68091, '\P{Is_Numeric_Value: 4.17e-01}', "");
    Expect(0, 68091, '\P{^Is_Numeric_Value: 4.17e-01}', "");
    Error('\p{Is_Numeric_Value=0.42}');
    Error('\P{Is_Numeric_Value=0.42}');
    Expect(1, 68090, '\p{Is_Numeric_Value:4.167e-01}', "");
    Expect(0, 68090, '\p{^Is_Numeric_Value:4.167e-01}', "");
    Expect(0, 68090, '\P{Is_Numeric_Value:4.167e-01}', "");
    Expect(1, 68090, '\P{^Is_Numeric_Value:4.167e-01}', "");
    Expect(0, 68091, '\p{Is_Numeric_Value:4.167e-01}', "");
    Expect(1, 68091, '\p{^Is_Numeric_Value:4.167e-01}', "");
    Expect(1, 68091, '\P{Is_Numeric_Value:4.167e-01}', "");
    Expect(0, 68091, '\P{^Is_Numeric_Value:4.167e-01}', "");
    Expect(1, 68090, '\p{Is_Numeric_Value=0.417}', "");
    Expect(0, 68090, '\p{^Is_Numeric_Value=0.417}', "");
    Expect(0, 68090, '\P{Is_Numeric_Value=0.417}', "");
    Expect(1, 68090, '\P{^Is_Numeric_Value=0.417}', "");
    Expect(0, 68091, '\p{Is_Numeric_Value=0.417}', "");
    Expect(1, 68091, '\p{^Is_Numeric_Value=0.417}', "");
    Expect(1, 68091, '\P{Is_Numeric_Value=0.417}', "");
    Expect(0, 68091, '\P{^Is_Numeric_Value=0.417}', "");
    Expect(1, 68090, '\p{Is_Numeric_Value=4.1667e-01}', "");
    Expect(0, 68090, '\p{^Is_Numeric_Value=4.1667e-01}', "");
    Expect(0, 68090, '\P{Is_Numeric_Value=4.1667e-01}', "");
    Expect(1, 68090, '\P{^Is_Numeric_Value=4.1667e-01}', "");
    Expect(0, 68091, '\p{Is_Numeric_Value=4.1667e-01}', "");
    Expect(1, 68091, '\p{^Is_Numeric_Value=4.1667e-01}', "");
    Expect(1, 68091, '\P{Is_Numeric_Value=4.1667e-01}', "");
    Expect(0, 68091, '\P{^Is_Numeric_Value=4.1667e-01}', "");
    Expect(1, 68090, '\p{Is_Numeric_Value=0.4167}', "");
    Expect(0, 68090, '\p{^Is_Numeric_Value=0.4167}', "");
    Expect(0, 68090, '\P{Is_Numeric_Value=0.4167}', "");
    Expect(1, 68090, '\P{^Is_Numeric_Value=0.4167}', "");
    Expect(0, 68091, '\p{Is_Numeric_Value=0.4167}', "");
    Expect(1, 68091, '\p{^Is_Numeric_Value=0.4167}', "");
    Expect(1, 68091, '\P{Is_Numeric_Value=0.4167}', "");
    Expect(0, 68091, '\P{^Is_Numeric_Value=0.4167}', "");
    Error('\p{Is_Nv=_:=00000005/0000012}');
    Error('\P{Is_Nv=_:=00000005/0000012}');
    Expect(1, 68090, '\p{Is_Nv=0000000005/00000012}', "");
    Expect(0, 68090, '\p{^Is_Nv=0000000005/00000012}', "");
    Expect(0, 68090, '\P{Is_Nv=0000000005/00000012}', "");
    Expect(1, 68090, '\P{^Is_Nv=0000000005/00000012}', "");
    Expect(0, 68091, '\p{Is_Nv=0000000005/00000012}', "");
    Expect(1, 68091, '\p{^Is_Nv=0000000005/00000012}', "");
    Expect(1, 68091, '\P{Is_Nv=0000000005/00000012}', "");
    Expect(0, 68091, '\P{^Is_Nv=0000000005/00000012}', "");
    Expect(1, 68090, '\p{Is_Nv=300/720}', "");
    Expect(0, 68090, '\p{^Is_Nv=300/720}', "");
    Expect(0, 68090, '\P{Is_Nv=300/720}', "");
    Expect(1, 68090, '\P{^Is_Nv=300/720}', "");
    Expect(0, 68091, '\p{Is_Nv=300/720}', "");
    Expect(1, 68091, '\p{^Is_Nv=300/720}', "");
    Expect(1, 68091, '\P{Is_Nv=300/720}', "");
    Expect(0, 68091, '\P{^Is_Nv=300/720}', "");
    Error('\p{Is_Nv=4.2e-01}');
    Error('\P{Is_Nv=4.2e-01}');
    Expect(1, 68090, '\p{Is_Nv=4.17e-01}', "");
    Expect(0, 68090, '\p{^Is_Nv=4.17e-01}', "");
    Expect(0, 68090, '\P{Is_Nv=4.17e-01}', "");
    Expect(1, 68090, '\P{^Is_Nv=4.17e-01}', "");
    Expect(0, 68091, '\p{Is_Nv=4.17e-01}', "");
    Expect(1, 68091, '\p{^Is_Nv=4.17e-01}', "");
    Expect(1, 68091, '\P{Is_Nv=4.17e-01}', "");
    Expect(0, 68091, '\P{^Is_Nv=4.17e-01}', "");
    Error('\p{Is_Nv=0.42}');
    Error('\P{Is_Nv=0.42}');
    Expect(1, 68090, '\p{Is_Nv=4.167e-01}', "");
    Expect(0, 68090, '\p{^Is_Nv=4.167e-01}', "");
    Expect(0, 68090, '\P{Is_Nv=4.167e-01}', "");
    Expect(1, 68090, '\P{^Is_Nv=4.167e-01}', "");
    Expect(0, 68091, '\p{Is_Nv=4.167e-01}', "");
    Expect(1, 68091, '\p{^Is_Nv=4.167e-01}', "");
    Expect(1, 68091, '\P{Is_Nv=4.167e-01}', "");
    Expect(0, 68091, '\P{^Is_Nv=4.167e-01}', "");
    Expect(1, 68090, '\p{Is_Nv=0.417}', "");
    Expect(0, 68090, '\p{^Is_Nv=0.417}', "");
    Expect(0, 68090, '\P{Is_Nv=0.417}', "");
    Expect(1, 68090, '\P{^Is_Nv=0.417}', "");
    Expect(0, 68091, '\p{Is_Nv=0.417}', "");
    Expect(1, 68091, '\p{^Is_Nv=0.417}', "");
    Expect(1, 68091, '\P{Is_Nv=0.417}', "");
    Expect(0, 68091, '\P{^Is_Nv=0.417}', "");
    Expect(1, 68090, '\p{Is_Nv=4.1667e-01}', "");
    Expect(0, 68090, '\p{^Is_Nv=4.1667e-01}', "");
    Expect(0, 68090, '\P{Is_Nv=4.1667e-01}', "");
    Expect(1, 68090, '\P{^Is_Nv=4.1667e-01}', "");
    Expect(0, 68091, '\p{Is_Nv=4.1667e-01}', "");
    Expect(1, 68091, '\p{^Is_Nv=4.1667e-01}', "");
    Expect(1, 68091, '\P{Is_Nv=4.1667e-01}', "");
    Expect(0, 68091, '\P{^Is_Nv=4.1667e-01}', "");
    Expect(1, 68090, '\p{Is_Nv:	0.4167}', "");
    Expect(0, 68090, '\p{^Is_Nv:	0.4167}', "");
    Expect(0, 68090, '\P{Is_Nv:	0.4167}', "");
    Expect(1, 68090, '\P{^Is_Nv:	0.4167}', "");
    Expect(0, 68091, '\p{Is_Nv:	0.4167}', "");
    Expect(1, 68091, '\p{^Is_Nv:	0.4167}', "");
    Expect(1, 68091, '\P{Is_Nv:	0.4167}', "");
    Expect(0, 68091, '\P{^Is_Nv:	0.4167}', "");
    Error('\p{Numeric_Value=_0000000005/0000002/a/}');
    Error('\P{Numeric_Value=_0000000005/0000002/a/}');
    Expect(1, 3884, '\p{Numeric_Value=:\A5/2\z:}', "");;
    Expect(0, 3885, '\p{Numeric_Value=:\A5/2\z:}', "");;
    Expect(1, 3884, '\p{Numeric_Value=+000005/000000002}', "");
    Expect(0, 3884, '\p{^Numeric_Value=+000005/000000002}', "");
    Expect(0, 3884, '\P{Numeric_Value=+000005/000000002}', "");
    Expect(1, 3884, '\P{^Numeric_Value=+000005/000000002}', "");
    Expect(0, 3885, '\p{Numeric_Value=+000005/000000002}', "");
    Expect(1, 3885, '\p{^Numeric_Value=+000005/000000002}', "");
    Expect(1, 3885, '\P{Numeric_Value=+000005/000000002}', "");
    Expect(0, 3885, '\P{^Numeric_Value=+000005/000000002}', "");
    Expect(1, 3884, '\p{Numeric_Value=300/120}', "");
    Expect(0, 3884, '\p{^Numeric_Value=300/120}', "");
    Expect(0, 3884, '\P{Numeric_Value=300/120}', "");
    Expect(1, 3884, '\P{^Numeric_Value=300/120}', "");
    Expect(0, 3885, '\p{Numeric_Value=300/120}', "");
    Expect(1, 3885, '\p{^Numeric_Value=300/120}', "");
    Expect(1, 3885, '\P{Numeric_Value=300/120}', "");
    Expect(0, 3885, '\P{^Numeric_Value=300/120}', "");
    Expect(1, 3884, '\p{Numeric_Value=2.5e+00}', "");
    Expect(0, 3884, '\p{^Numeric_Value=2.5e+00}', "");
    Expect(0, 3884, '\P{Numeric_Value=2.5e+00}', "");
    Expect(1, 3884, '\P{^Numeric_Value=2.5e+00}', "");
    Expect(0, 3885, '\p{Numeric_Value=2.5e+00}', "");
    Expect(1, 3885, '\p{^Numeric_Value=2.5e+00}', "");
    Expect(1, 3885, '\P{Numeric_Value=2.5e+00}', "");
    Expect(0, 3885, '\P{^Numeric_Value=2.5e+00}', "");
    Expect(1, 3884, '\p{Numeric_Value=2.5}', "");
    Expect(0, 3884, '\p{^Numeric_Value=2.5}', "");
    Expect(0, 3884, '\P{Numeric_Value=2.5}', "");
    Expect(1, 3884, '\P{^Numeric_Value=2.5}', "");
    Expect(0, 3885, '\p{Numeric_Value=2.5}', "");
    Expect(1, 3885, '\p{^Numeric_Value=2.5}', "");
    Expect(1, 3885, '\P{Numeric_Value=2.5}', "");
    Expect(0, 3885, '\P{^Numeric_Value=2.5}', "");
    Expect(1, 3884, '\p{Numeric_Value:   2.50e+00}', "");
    Expect(0, 3884, '\p{^Numeric_Value:   2.50e+00}', "");
    Expect(0, 3884, '\P{Numeric_Value:   2.50e+00}', "");
    Expect(1, 3884, '\P{^Numeric_Value:   2.50e+00}', "");
    Expect(0, 3885, '\p{Numeric_Value:   2.50e+00}', "");
    Expect(1, 3885, '\p{^Numeric_Value:   2.50e+00}', "");
    Expect(1, 3885, '\P{Numeric_Value:   2.50e+00}', "");
    Expect(0, 3885, '\P{^Numeric_Value:   2.50e+00}', "");
    Expect(1, 3884, '\p{Numeric_Value:2.50}', "");
    Expect(0, 3884, '\p{^Numeric_Value:2.50}', "");
    Expect(0, 3884, '\P{Numeric_Value:2.50}', "");
    Expect(1, 3884, '\P{^Numeric_Value:2.50}', "");
    Expect(0, 3885, '\p{Numeric_Value:2.50}', "");
    Expect(1, 3885, '\p{^Numeric_Value:2.50}', "");
    Expect(1, 3885, '\P{Numeric_Value:2.50}', "");
    Expect(0, 3885, '\P{^Numeric_Value:2.50}', "");
    Error('\p{Nv=	 05/2:=}');
    Error('\P{Nv=	 05/2:=}');
    Expect(1, 3884, '\p{Nv=:\A5/2\z:}', "");;
    Expect(0, 3885, '\p{Nv=:\A5/2\z:}', "");;
    Expect(1, 3884, '\p{Nv=000005/002}', "");
    Expect(0, 3884, '\p{^Nv=000005/002}', "");
    Expect(0, 3884, '\P{Nv=000005/002}', "");
    Expect(1, 3884, '\P{^Nv=000005/002}', "");
    Expect(0, 3885, '\p{Nv=000005/002}', "");
    Expect(1, 3885, '\p{^Nv=000005/002}', "");
    Expect(1, 3885, '\P{Nv=000005/002}', "");
    Expect(0, 3885, '\P{^Nv=000005/002}', "");
    Expect(1, 3884, '\p{Nv=300/120}', "");
    Expect(0, 3884, '\p{^Nv=300/120}', "");
    Expect(0, 3884, '\P{Nv=300/120}', "");
    Expect(1, 3884, '\P{^Nv=300/120}', "");
    Expect(0, 3885, '\p{Nv=300/120}', "");
    Expect(1, 3885, '\p{^Nv=300/120}', "");
    Expect(1, 3885, '\P{Nv=300/120}', "");
    Expect(0, 3885, '\P{^Nv=300/120}', "");
    Expect(1, 3884, '\p{Nv=2.5e+00}', "");
    Expect(0, 3884, '\p{^Nv=2.5e+00}', "");
    Expect(0, 3884, '\P{Nv=2.5e+00}', "");
    Expect(1, 3884, '\P{^Nv=2.5e+00}', "");
    Expect(0, 3885, '\p{Nv=2.5e+00}', "");
    Expect(1, 3885, '\p{^Nv=2.5e+00}', "");
    Expect(1, 3885, '\P{Nv=2.5e+00}', "");
    Expect(0, 3885, '\P{^Nv=2.5e+00}', "");
    Expect(1, 3884, '\p{Nv=2.5}', "");
    Expect(0, 3884, '\p{^Nv=2.5}', "");
    Expect(0, 3884, '\P{Nv=2.5}', "");
    Expect(1, 3884, '\P{^Nv=2.5}', "");
    Expect(0, 3885, '\p{Nv=2.5}', "");
    Expect(1, 3885, '\p{^Nv=2.5}', "");
    Expect(1, 3885, '\P{Nv=2.5}', "");
    Expect(0, 3885, '\P{^Nv=2.5}', "");
    Expect(1, 3884, '\p{Nv=2.50e+00}', "");
    Expect(0, 3884, '\p{^Nv=2.50e+00}', "");
    Expect(0, 3884, '\P{Nv=2.50e+00}', "");
    Expect(1, 3884, '\P{^Nv=2.50e+00}', "");
    Expect(0, 3885, '\p{Nv=2.50e+00}', "");
    Expect(1, 3885, '\p{^Nv=2.50e+00}', "");
    Expect(1, 3885, '\P{Nv=2.50e+00}', "");
    Expect(0, 3885, '\P{^Nv=2.50e+00}', "");
    Expect(1, 3884, '\p{Nv=2.50}', "");
    Expect(0, 3884, '\p{^Nv=2.50}', "");
    Expect(0, 3884, '\P{Nv=2.50}', "");
    Expect(1, 3884, '\P{^Nv=2.50}', "");
    Expect(0, 3885, '\p{Nv=2.50}', "");
    Expect(1, 3885, '\p{^Nv=2.50}', "");
    Expect(1, 3885, '\P{Nv=2.50}', "");
    Expect(0, 3885, '\P{^Nv=2.50}', "");
    Error('\p{Is_Numeric_Value:	  +0000000005/0000000002:=}');
    Error('\P{Is_Numeric_Value:	  +0000000005/0000000002:=}');
    Expect(1, 3884, '\p{Is_Numeric_Value=05/2}', "");
    Expect(0, 3884, '\p{^Is_Numeric_Value=05/2}', "");
    Expect(0, 3884, '\P{Is_Numeric_Value=05/2}', "");
    Expect(1, 3884, '\P{^Is_Numeric_Value=05/2}', "");
    Expect(0, 3885, '\p{Is_Numeric_Value=05/2}', "");
    Expect(1, 3885, '\p{^Is_Numeric_Value=05/2}', "");
    Expect(1, 3885, '\P{Is_Numeric_Value=05/2}', "");
    Expect(0, 3885, '\P{^Is_Numeric_Value=05/2}', "");
    Expect(1, 3884, '\p{Is_Numeric_Value=300/120}', "");
    Expect(0, 3884, '\p{^Is_Numeric_Value=300/120}', "");
    Expect(0, 3884, '\P{Is_Numeric_Value=300/120}', "");
    Expect(1, 3884, '\P{^Is_Numeric_Value=300/120}', "");
    Expect(0, 3885, '\p{Is_Numeric_Value=300/120}', "");
    Expect(1, 3885, '\p{^Is_Numeric_Value=300/120}', "");
    Expect(1, 3885, '\P{Is_Numeric_Value=300/120}', "");
    Expect(0, 3885, '\P{^Is_Numeric_Value=300/120}', "");
    Expect(1, 3884, '\p{Is_Numeric_Value=2.5e+00}', "");
    Expect(0, 3884, '\p{^Is_Numeric_Value=2.5e+00}', "");
    Expect(0, 3884, '\P{Is_Numeric_Value=2.5e+00}', "");
    Expect(1, 3884, '\P{^Is_Numeric_Value=2.5e+00}', "");
    Expect(0, 3885, '\p{Is_Numeric_Value=2.5e+00}', "");
    Expect(1, 3885, '\p{^Is_Numeric_Value=2.5e+00}', "");
    Expect(1, 3885, '\P{Is_Numeric_Value=2.5e+00}', "");
    Expect(0, 3885, '\P{^Is_Numeric_Value=2.5e+00}', "");
    Expect(1, 3884, '\p{Is_Numeric_Value=2.5}', "");
    Expect(0, 3884, '\p{^Is_Numeric_Value=2.5}', "");
    Expect(0, 3884, '\P{Is_Numeric_Value=2.5}', "");
    Expect(1, 3884, '\P{^Is_Numeric_Value=2.5}', "");
    Expect(0, 3885, '\p{Is_Numeric_Value=2.5}', "");
    Expect(1, 3885, '\p{^Is_Numeric_Value=2.5}', "");
    Expect(1, 3885, '\P{Is_Numeric_Value=2.5}', "");
    Expect(0, 3885, '\P{^Is_Numeric_Value=2.5}', "");
    Expect(1, 3884, '\p{Is_Numeric_Value=2.50e+00}', "");
    Expect(0, 3884, '\p{^Is_Numeric_Value=2.50e+00}', "");
    Expect(0, 3884, '\P{Is_Numeric_Value=2.50e+00}', "");
    Expect(1, 3884, '\P{^Is_Numeric_Value=2.50e+00}', "");
    Expect(0, 3885, '\p{Is_Numeric_Value=2.50e+00}', "");
    Expect(1, 3885, '\p{^Is_Numeric_Value=2.50e+00}', "");
    Expect(1, 3885, '\P{Is_Numeric_Value=2.50e+00}', "");
    Expect(0, 3885, '\P{^Is_Numeric_Value=2.50e+00}', "");
    Expect(1, 3884, '\p{Is_Numeric_Value: 2.50}', "");
    Expect(0, 3884, '\p{^Is_Numeric_Value: 2.50}', "");
    Expect(0, 3884, '\P{Is_Numeric_Value: 2.50}', "");
    Expect(1, 3884, '\P{^Is_Numeric_Value: 2.50}', "");
    Expect(0, 3885, '\p{Is_Numeric_Value: 2.50}', "");
    Expect(1, 3885, '\p{^Is_Numeric_Value: 2.50}', "");
    Expect(1, 3885, '\P{Is_Numeric_Value: 2.50}', "");
    Expect(0, 3885, '\P{^Is_Numeric_Value: 2.50}', "");
    Error('\p{Is_Nv: _:=005/000002}');
    Error('\P{Is_Nv: _:=005/000002}');
    Expect(1, 3884, '\p{Is_Nv=000005/00002}', "");
    Expect(0, 3884, '\p{^Is_Nv=000005/00002}', "");
    Expect(0, 3884, '\P{Is_Nv=000005/00002}', "");
    Expect(1, 3884, '\P{^Is_Nv=000005/00002}', "");
    Expect(0, 3885, '\p{Is_Nv=000005/00002}', "");
    Expect(1, 3885, '\p{^Is_Nv=000005/00002}', "");
    Expect(1, 3885, '\P{Is_Nv=000005/00002}', "");
    Expect(0, 3885, '\P{^Is_Nv=000005/00002}', "");
    Expect(1, 3884, '\p{Is_Nv=300/120}', "");
    Expect(0, 3884, '\p{^Is_Nv=300/120}', "");
    Expect(0, 3884, '\P{Is_Nv=300/120}', "");
    Expect(1, 3884, '\P{^Is_Nv=300/120}', "");
    Expect(0, 3885, '\p{Is_Nv=300/120}', "");
    Expect(1, 3885, '\p{^Is_Nv=300/120}', "");
    Expect(1, 3885, '\P{Is_Nv=300/120}', "");
    Expect(0, 3885, '\P{^Is_Nv=300/120}', "");
    Expect(1, 3884, '\p{Is_Nv=2.5e+00}', "");
    Expect(0, 3884, '\p{^Is_Nv=2.5e+00}', "");
    Expect(0, 3884, '\P{Is_Nv=2.5e+00}', "");
    Expect(1, 3884, '\P{^Is_Nv=2.5e+00}', "");
    Expect(0, 3885, '\p{Is_Nv=2.5e+00}', "");
    Expect(1, 3885, '\p{^Is_Nv=2.5e+00}', "");
    Expect(1, 3885, '\P{Is_Nv=2.5e+00}', "");
    Expect(0, 3885, '\P{^Is_Nv=2.5e+00}', "");
    Expect(1, 3884, '\p{Is_Nv:	2.5}', "");
    Expect(0, 3884, '\p{^Is_Nv:	2.5}', "");
    Expect(0, 3884, '\P{Is_Nv:	2.5}', "");
    Expect(1, 3884, '\P{^Is_Nv:	2.5}', "");
    Expect(0, 3885, '\p{Is_Nv:	2.5}', "");
    Expect(1, 3885, '\p{^Is_Nv:	2.5}', "");
    Expect(1, 3885, '\P{Is_Nv:	2.5}', "");
    Expect(0, 3885, '\P{^Is_Nv:	2.5}', "");
    Expect(1, 3884, '\p{Is_Nv=2.50e+00}', "");
    Expect(0, 3884, '\p{^Is_Nv=2.50e+00}', "");
    Expect(0, 3884, '\P{Is_Nv=2.50e+00}', "");
    Expect(1, 3884, '\P{^Is_Nv=2.50e+00}', "");
    Expect(0, 3885, '\p{Is_Nv=2.50e+00}', "");
    Expect(1, 3885, '\p{^Is_Nv=2.50e+00}', "");
    Expect(1, 3885, '\P{Is_Nv=2.50e+00}', "");
    Expect(0, 3885, '\P{^Is_Nv=2.50e+00}', "");
    Expect(1, 3884, '\p{Is_Nv=2.50}', "");
    Expect(0, 3884, '\p{^Is_Nv=2.50}', "");
    Expect(0, 3884, '\P{Is_Nv=2.50}', "");
    Expect(1, 3884, '\P{^Is_Nv=2.50}', "");
    Expect(0, 3885, '\p{Is_Nv=2.50}', "");
    Expect(1, 3885, '\p{^Is_Nv=2.50}', "");
    Expect(1, 3885, '\P{Is_Nv=2.50}', "");
    Expect(0, 3885, '\P{^Is_Nv=2.50}', "");
    Error('\p{Numeric_Value=:=0000000005/006}');
    Error('\P{Numeric_Value=:=0000000005/006}');
    Expect(1, 74844, '\p{Numeric_Value=:\A5/6\z:}', "");;
    Expect(0, 74845, '\p{Numeric_Value=:\A5/6\z:}', "");;
    Expect(1, 74844, '\p{Numeric_Value=000005/000000006}', "");
    Expect(0, 74844, '\p{^Numeric_Value=000005/000000006}', "");
    Expect(0, 74844, '\P{Numeric_Value=000005/000000006}', "");
    Expect(1, 74844, '\P{^Numeric_Value=000005/000000006}', "");
    Expect(0, 74845, '\p{Numeric_Value=000005/000000006}', "");
    Expect(1, 74845, '\p{^Numeric_Value=000005/000000006}', "");
    Expect(1, 74845, '\P{Numeric_Value=000005/000000006}', "");
    Expect(0, 74845, '\P{^Numeric_Value=000005/000000006}', "");
    Expect(1, 74844, '\p{Numeric_Value=300/360}', "");
    Expect(0, 74844, '\p{^Numeric_Value=300/360}', "");
    Expect(0, 74844, '\P{Numeric_Value=300/360}', "");
    Expect(1, 74844, '\P{^Numeric_Value=300/360}', "");
    Expect(0, 74845, '\p{Numeric_Value=300/360}', "");
    Expect(1, 74845, '\p{^Numeric_Value=300/360}', "");
    Expect(1, 74845, '\P{Numeric_Value=300/360}', "");
    Expect(0, 74845, '\P{^Numeric_Value=300/360}', "");
    Error('\p{Numeric_Value=8.3e-01}');
    Error('\P{Numeric_Value=8.3e-01}');
    Expect(1, 74844, '\p{Numeric_Value=8.33e-01}', "");
    Expect(0, 74844, '\p{^Numeric_Value=8.33e-01}', "");
    Expect(0, 74844, '\P{Numeric_Value=8.33e-01}', "");
    Expect(1, 74844, '\P{^Numeric_Value=8.33e-01}', "");
    Expect(0, 74845, '\p{Numeric_Value=8.33e-01}', "");
    Expect(1, 74845, '\p{^Numeric_Value=8.33e-01}', "");
    Expect(1, 74845, '\P{Numeric_Value=8.33e-01}', "");
    Expect(0, 74845, '\P{^Numeric_Value=8.33e-01}', "");
    Error('\p{Numeric_Value=0.83}');
    Error('\P{Numeric_Value=0.83}');
    Expect(1, 74844, '\p{Numeric_Value=8.333e-01}', "");
    Expect(0, 74844, '\p{^Numeric_Value=8.333e-01}', "");
    Expect(0, 74844, '\P{Numeric_Value=8.333e-01}', "");
    Expect(1, 74844, '\P{^Numeric_Value=8.333e-01}', "");
    Expect(0, 74845, '\p{Numeric_Value=8.333e-01}', "");
    Expect(1, 74845, '\p{^Numeric_Value=8.333e-01}', "");
    Expect(1, 74845, '\P{Numeric_Value=8.333e-01}', "");
    Expect(0, 74845, '\P{^Numeric_Value=8.333e-01}', "");
    Expect(1, 74844, '\p{Numeric_Value=0.833}', "");
    Expect(0, 74844, '\p{^Numeric_Value=0.833}', "");
    Expect(0, 74844, '\P{Numeric_Value=0.833}', "");
    Expect(1, 74844, '\P{^Numeric_Value=0.833}', "");
    Expect(0, 74845, '\p{Numeric_Value=0.833}', "");
    Expect(1, 74845, '\p{^Numeric_Value=0.833}', "");
    Expect(1, 74845, '\P{Numeric_Value=0.833}', "");
    Expect(0, 74845, '\P{^Numeric_Value=0.833}', "");
    Expect(1, 74844, '\p{Numeric_Value=8.3333e-01}', "");
    Expect(0, 74844, '\p{^Numeric_Value=8.3333e-01}', "");
    Expect(0, 74844, '\P{Numeric_Value=8.3333e-01}', "");
    Expect(1, 74844, '\P{^Numeric_Value=8.3333e-01}', "");
    Expect(0, 74845, '\p{Numeric_Value=8.3333e-01}', "");
    Expect(1, 74845, '\p{^Numeric_Value=8.3333e-01}', "");
    Expect(1, 74845, '\P{Numeric_Value=8.3333e-01}', "");
    Expect(0, 74845, '\P{^Numeric_Value=8.3333e-01}', "");
    Expect(1, 74844, '\p{Numeric_Value: 0.8333}', "");
    Expect(0, 74844, '\p{^Numeric_Value: 0.8333}', "");
    Expect(0, 74844, '\P{Numeric_Value: 0.8333}', "");
    Expect(1, 74844, '\P{^Numeric_Value: 0.8333}', "");
    Expect(0, 74845, '\p{Numeric_Value: 0.8333}', "");
    Expect(1, 74845, '\p{^Numeric_Value: 0.8333}', "");
    Expect(1, 74845, '\P{Numeric_Value: 0.8333}', "");
    Expect(0, 74845, '\P{^Numeric_Value: 0.8333}', "");
    Error('\p{Nv= /a/0005/00006}');
    Error('\P{Nv= /a/0005/00006}');
    Expect(1, 74844, '\p{Nv=:\A5/6\z:}', "");;
    Expect(0, 74845, '\p{Nv=:\A5/6\z:}', "");;
    Expect(1, 74844, '\p{Nv=0000005/0000000006}', "");
    Expect(0, 74844, '\p{^Nv=0000005/0000000006}', "");
    Expect(0, 74844, '\P{Nv=0000005/0000000006}', "");
    Expect(1, 74844, '\P{^Nv=0000005/0000000006}', "");
    Expect(0, 74845, '\p{Nv=0000005/0000000006}', "");
    Expect(1, 74845, '\p{^Nv=0000005/0000000006}', "");
    Expect(1, 74845, '\P{Nv=0000005/0000000006}', "");
    Expect(0, 74845, '\P{^Nv=0000005/0000000006}', "");
    Expect(1, 74844, '\p{Nv=300/360}', "");
    Expect(0, 74844, '\p{^Nv=300/360}', "");
    Expect(0, 74844, '\P{Nv=300/360}', "");
    Expect(1, 74844, '\P{^Nv=300/360}', "");
    Expect(0, 74845, '\p{Nv=300/360}', "");
    Expect(1, 74845, '\p{^Nv=300/360}', "");
    Expect(1, 74845, '\P{Nv=300/360}', "");
    Expect(0, 74845, '\P{^Nv=300/360}', "");
    Error('\p{Nv=8.3e-01}');
    Error('\P{Nv=8.3e-01}');
    Expect(1, 74844, '\p{Nv=8.33e-01}', "");
    Expect(0, 74844, '\p{^Nv=8.33e-01}', "");
    Expect(0, 74844, '\P{Nv=8.33e-01}', "");
    Expect(1, 74844, '\P{^Nv=8.33e-01}', "");
    Expect(0, 74845, '\p{Nv=8.33e-01}', "");
    Expect(1, 74845, '\p{^Nv=8.33e-01}', "");
    Expect(1, 74845, '\P{Nv=8.33e-01}', "");
    Expect(0, 74845, '\P{^Nv=8.33e-01}', "");
    Error('\p{Nv=0.83}');
    Error('\P{Nv=0.83}');
    Expect(1, 74844, '\p{Nv=8.333e-01}', "");
    Expect(0, 74844, '\p{^Nv=8.333e-01}', "");
    Expect(0, 74844, '\P{Nv=8.333e-01}', "");
    Expect(1, 74844, '\P{^Nv=8.333e-01}', "");
    Expect(0, 74845, '\p{Nv=8.333e-01}', "");
    Expect(1, 74845, '\p{^Nv=8.333e-01}', "");
    Expect(1, 74845, '\P{Nv=8.333e-01}', "");
    Expect(0, 74845, '\P{^Nv=8.333e-01}', "");
    Expect(1, 74844, '\p{Nv: 0.833}', "");
    Expect(0, 74844, '\p{^Nv: 0.833}', "");
    Expect(0, 74844, '\P{Nv: 0.833}', "");
    Expect(1, 74844, '\P{^Nv: 0.833}', "");
    Expect(0, 74845, '\p{Nv: 0.833}', "");
    Expect(1, 74845, '\p{^Nv: 0.833}', "");
    Expect(1, 74845, '\P{Nv: 0.833}', "");
    Expect(0, 74845, '\P{^Nv: 0.833}', "");
    Expect(1, 74844, '\p{Nv=8.3333e-01}', "");
    Expect(0, 74844, '\p{^Nv=8.3333e-01}', "");
    Expect(0, 74844, '\P{Nv=8.3333e-01}', "");
    Expect(1, 74844, '\P{^Nv=8.3333e-01}', "");
    Expect(0, 74845, '\p{Nv=8.3333e-01}', "");
    Expect(1, 74845, '\p{^Nv=8.3333e-01}', "");
    Expect(1, 74845, '\P{Nv=8.3333e-01}', "");
    Expect(0, 74845, '\P{^Nv=8.3333e-01}', "");
    Expect(1, 74844, '\p{Nv=0.8333}', "");
    Expect(0, 74844, '\p{^Nv=0.8333}', "");
    Expect(0, 74844, '\P{Nv=0.8333}', "");
    Expect(1, 74844, '\P{^Nv=0.8333}', "");
    Expect(0, 74845, '\p{Nv=0.8333}', "");
    Expect(1, 74845, '\p{^Nv=0.8333}', "");
    Expect(1, 74845, '\P{Nv=0.8333}', "");
    Expect(0, 74845, '\P{^Nv=0.8333}', "");
    Error('\p{Is_Numeric_Value=	-5/0000000006:=}');
    Error('\P{Is_Numeric_Value=	-5/0000000006:=}');
    Expect(1, 74844, '\p{Is_Numeric_Value=000000005/0006}', "");
    Expect(0, 74844, '\p{^Is_Numeric_Value=000000005/0006}', "");
    Expect(0, 74844, '\P{Is_Numeric_Value=000000005/0006}', "");
    Expect(1, 74844, '\P{^Is_Numeric_Value=000000005/0006}', "");
    Expect(0, 74845, '\p{Is_Numeric_Value=000000005/0006}', "");
    Expect(1, 74845, '\p{^Is_Numeric_Value=000000005/0006}', "");
    Expect(1, 74845, '\P{Is_Numeric_Value=000000005/0006}', "");
    Expect(0, 74845, '\P{^Is_Numeric_Value=000000005/0006}', "");
    Expect(1, 74844, '\p{Is_Numeric_Value=300/360}', "");
    Expect(0, 74844, '\p{^Is_Numeric_Value=300/360}', "");
    Expect(0, 74844, '\P{Is_Numeric_Value=300/360}', "");
    Expect(1, 74844, '\P{^Is_Numeric_Value=300/360}', "");
    Expect(0, 74845, '\p{Is_Numeric_Value=300/360}', "");
    Expect(1, 74845, '\p{^Is_Numeric_Value=300/360}', "");
    Expect(1, 74845, '\P{Is_Numeric_Value=300/360}', "");
    Expect(0, 74845, '\P{^Is_Numeric_Value=300/360}', "");
    Error('\p{Is_Numeric_Value=8.3e-01}');
    Error('\P{Is_Numeric_Value=8.3e-01}');
    Expect(1, 74844, '\p{Is_Numeric_Value=8.33e-01}', "");
    Expect(0, 74844, '\p{^Is_Numeric_Value=8.33e-01}', "");
    Expect(0, 74844, '\P{Is_Numeric_Value=8.33e-01}', "");
    Expect(1, 74844, '\P{^Is_Numeric_Value=8.33e-01}', "");
    Expect(0, 74845, '\p{Is_Numeric_Value=8.33e-01}', "");
    Expect(1, 74845, '\p{^Is_Numeric_Value=8.33e-01}', "");
    Expect(1, 74845, '\P{Is_Numeric_Value=8.33e-01}', "");
    Expect(0, 74845, '\P{^Is_Numeric_Value=8.33e-01}', "");
    Error('\p{Is_Numeric_Value=0.83}');
    Error('\P{Is_Numeric_Value=0.83}');
    Expect(1, 74844, '\p{Is_Numeric_Value=8.333e-01}', "");
    Expect(0, 74844, '\p{^Is_Numeric_Value=8.333e-01}', "");
    Expect(0, 74844, '\P{Is_Numeric_Value=8.333e-01}', "");
    Expect(1, 74844, '\P{^Is_Numeric_Value=8.333e-01}', "");
    Expect(0, 74845, '\p{Is_Numeric_Value=8.333e-01}', "");
    Expect(1, 74845, '\p{^Is_Numeric_Value=8.333e-01}', "");
    Expect(1, 74845, '\P{Is_Numeric_Value=8.333e-01}', "");
    Expect(0, 74845, '\P{^Is_Numeric_Value=8.333e-01}', "");
    Expect(1, 74844, '\p{Is_Numeric_Value=0.833}', "");
    Expect(0, 74844, '\p{^Is_Numeric_Value=0.833}', "");
    Expect(0, 74844, '\P{Is_Numeric_Value=0.833}', "");
    Expect(1, 74844, '\P{^Is_Numeric_Value=0.833}', "");
    Expect(0, 74845, '\p{Is_Numeric_Value=0.833}', "");
    Expect(1, 74845, '\p{^Is_Numeric_Value=0.833}', "");
    Expect(1, 74845, '\P{Is_Numeric_Value=0.833}', "");
    Expect(0, 74845, '\P{^Is_Numeric_Value=0.833}', "");
    Expect(1, 74844, '\p{Is_Numeric_Value=8.3333e-01}', "");
    Expect(0, 74844, '\p{^Is_Numeric_Value=8.3333e-01}', "");
    Expect(0, 74844, '\P{Is_Numeric_Value=8.3333e-01}', "");
    Expect(1, 74844, '\P{^Is_Numeric_Value=8.3333e-01}', "");
    Expect(0, 74845, '\p{Is_Numeric_Value=8.3333e-01}', "");
    Expect(1, 74845, '\p{^Is_Numeric_Value=8.3333e-01}', "");
    Expect(1, 74845, '\P{Is_Numeric_Value=8.3333e-01}', "");
    Expect(0, 74845, '\P{^Is_Numeric_Value=8.3333e-01}', "");
    Expect(1, 74844, '\p{Is_Numeric_Value=0.8333}', "");
    Expect(0, 74844, '\p{^Is_Numeric_Value=0.8333}', "");
    Expect(0, 74844, '\P{Is_Numeric_Value=0.8333}', "");
    Expect(1, 74844, '\P{^Is_Numeric_Value=0.8333}', "");
    Expect(0, 74845, '\p{Is_Numeric_Value=0.8333}', "");
    Expect(1, 74845, '\p{^Is_Numeric_Value=0.8333}', "");
    Expect(1, 74845, '\P{Is_Numeric_Value=0.8333}', "");
    Expect(0, 74845, '\P{^Is_Numeric_Value=0.8333}', "");
    Error('\p{Is_Nv=/a/--00005/006}');
    Error('\P{Is_Nv=/a/--00005/006}');
    Expect(1, 74844, '\p{Is_Nv=000005/06}', "");
    Expect(0, 74844, '\p{^Is_Nv=000005/06}', "");
    Expect(0, 74844, '\P{Is_Nv=000005/06}', "");
    Expect(1, 74844, '\P{^Is_Nv=000005/06}', "");
    Expect(0, 74845, '\p{Is_Nv=000005/06}', "");
    Expect(1, 74845, '\p{^Is_Nv=000005/06}', "");
    Expect(1, 74845, '\P{Is_Nv=000005/06}', "");
    Expect(0, 74845, '\P{^Is_Nv=000005/06}', "");
    Expect(1, 74844, '\p{Is_Nv=300/360}', "");
    Expect(0, 74844, '\p{^Is_Nv=300/360}', "");
    Expect(0, 74844, '\P{Is_Nv=300/360}', "");
    Expect(1, 74844, '\P{^Is_Nv=300/360}', "");
    Expect(0, 74845, '\p{Is_Nv=300/360}', "");
    Expect(1, 74845, '\p{^Is_Nv=300/360}', "");
    Expect(1, 74845, '\P{Is_Nv=300/360}', "");
    Expect(0, 74845, '\P{^Is_Nv=300/360}', "");
    Error('\p{Is_Nv=8.3e-01}');
    Error('\P{Is_Nv=8.3e-01}');
    Expect(1, 74844, '\p{Is_Nv=8.33e-01}', "");
    Expect(0, 74844, '\p{^Is_Nv=8.33e-01}', "");
    Expect(0, 74844, '\P{Is_Nv=8.33e-01}', "");
    Expect(1, 74844, '\P{^Is_Nv=8.33e-01}', "");
    Expect(0, 74845, '\p{Is_Nv=8.33e-01}', "");
    Expect(1, 74845, '\p{^Is_Nv=8.33e-01}', "");
    Expect(1, 74845, '\P{Is_Nv=8.33e-01}', "");
    Expect(0, 74845, '\P{^Is_Nv=8.33e-01}', "");
    Error('\p{Is_Nv=0.83}');
    Error('\P{Is_Nv=0.83}');
    Expect(1, 74844, '\p{Is_Nv=8.333e-01}', "");
    Expect(0, 74844, '\p{^Is_Nv=8.333e-01}', "");
    Expect(0, 74844, '\P{Is_Nv=8.333e-01}', "");
    Expect(1, 74844, '\P{^Is_Nv=8.333e-01}', "");
    Expect(0, 74845, '\p{Is_Nv=8.333e-01}', "");
    Expect(1, 74845, '\p{^Is_Nv=8.333e-01}', "");
    Expect(1, 74845, '\P{Is_Nv=8.333e-01}', "");
    Expect(0, 74845, '\P{^Is_Nv=8.333e-01}', "");
    Expect(1, 74844, '\p{Is_Nv=0.833}', "");
    Expect(0, 74844, '\p{^Is_Nv=0.833}', "");
    Expect(0, 74844, '\P{Is_Nv=0.833}', "");
    Expect(1, 74844, '\P{^Is_Nv=0.833}', "");
    Expect(0, 74845, '\p{Is_Nv=0.833}', "");
    Expect(1, 74845, '\p{^Is_Nv=0.833}', "");
    Expect(1, 74845, '\P{Is_Nv=0.833}', "");
    Expect(0, 74845, '\P{^Is_Nv=0.833}', "");
    Expect(1, 74844, '\p{Is_Nv=8.3333e-01}', "");
    Expect(0, 74844, '\p{^Is_Nv=8.3333e-01}', "");
    Expect(0, 74844, '\P{Is_Nv=8.3333e-01}', "");
    Expect(1, 74844, '\P{^Is_Nv=8.3333e-01}', "");
    Expect(0, 74845, '\p{Is_Nv=8.3333e-01}', "");
    Expect(1, 74845, '\p{^Is_Nv=8.3333e-01}', "");
    Expect(1, 74845, '\P{Is_Nv=8.3333e-01}', "");
    Expect(0, 74845, '\P{^Is_Nv=8.3333e-01}', "");
    Expect(1, 74844, '\p{Is_Nv=0.8333}', "");
    Expect(0, 74844, '\p{^Is_Nv=0.8333}', "");
    Expect(0, 74844, '\P{Is_Nv=0.8333}', "");
    Expect(1, 74844, '\P{^Is_Nv=0.8333}', "");
    Expect(0, 74845, '\p{Is_Nv=0.8333}', "");
    Expect(1, 74845, '\p{^Is_Nv=0.8333}', "");
    Expect(1, 74845, '\P{Is_Nv=0.8333}', "");
    Expect(0, 74845, '\P{^Is_Nv=0.8333}', "");
    Error('\p{Numeric_Value=__+00000005/8:=}');
    Error('\P{Numeric_Value=__+00000005/8:=}');
    Expect(1, 8541, '\p{Numeric_Value=:\A5/8\z:}', "");;
    Expect(0, 8542, '\p{Numeric_Value=:\A5/8\z:}', "");;
    Expect(1, 8541, '\p{Numeric_Value:   0000000005/00000008}', "");
    Expect(0, 8541, '\p{^Numeric_Value:   0000000005/00000008}', "");
    Expect(0, 8541, '\P{Numeric_Value:   0000000005/00000008}', "");
    Expect(1, 8541, '\P{^Numeric_Value:   0000000005/00000008}', "");
    Expect(0, 8542, '\p{Numeric_Value:   0000000005/00000008}', "");
    Expect(1, 8542, '\p{^Numeric_Value:   0000000005/00000008}', "");
    Expect(1, 8542, '\P{Numeric_Value:   0000000005/00000008}', "");
    Expect(0, 8542, '\P{^Numeric_Value:   0000000005/00000008}', "");
    Expect(1, 8541, '\p{Numeric_Value=300/480}', "");
    Expect(0, 8541, '\p{^Numeric_Value=300/480}', "");
    Expect(0, 8541, '\P{Numeric_Value=300/480}', "");
    Expect(1, 8541, '\P{^Numeric_Value=300/480}', "");
    Expect(0, 8542, '\p{Numeric_Value=300/480}', "");
    Expect(1, 8542, '\p{^Numeric_Value=300/480}', "");
    Expect(1, 8542, '\P{Numeric_Value=300/480}', "");
    Expect(0, 8542, '\P{^Numeric_Value=300/480}', "");
    Error('\p{Numeric_Value=6.2e-01}');
    Error('\P{Numeric_Value=6.2e-01}');
    Expect(1, 8541, '\p{Numeric_Value: 6.25e-01}', "");
    Expect(0, 8541, '\p{^Numeric_Value: 6.25e-01}', "");
    Expect(0, 8541, '\P{Numeric_Value: 6.25e-01}', "");
    Expect(1, 8541, '\P{^Numeric_Value: 6.25e-01}', "");
    Expect(0, 8542, '\p{Numeric_Value: 6.25e-01}', "");
    Expect(1, 8542, '\p{^Numeric_Value: 6.25e-01}', "");
    Expect(1, 8542, '\P{Numeric_Value: 6.25e-01}', "");
    Expect(0, 8542, '\P{^Numeric_Value: 6.25e-01}', "");
    Error('\p{Numeric_Value=0.62}');
    Error('\P{Numeric_Value=0.62}');
    Expect(1, 8541, '\p{Numeric_Value=6.250e-01}', "");
    Expect(0, 8541, '\p{^Numeric_Value=6.250e-01}', "");
    Expect(0, 8541, '\P{Numeric_Value=6.250e-01}', "");
    Expect(1, 8541, '\P{^Numeric_Value=6.250e-01}', "");
    Expect(0, 8542, '\p{Numeric_Value=6.250e-01}', "");
    Expect(1, 8542, '\p{^Numeric_Value=6.250e-01}', "");
    Expect(1, 8542, '\P{Numeric_Value=6.250e-01}', "");
    Expect(0, 8542, '\P{^Numeric_Value=6.250e-01}', "");
    Expect(1, 8541, '\p{Numeric_Value=0.625}', "");
    Expect(0, 8541, '\p{^Numeric_Value=0.625}', "");
    Expect(0, 8541, '\P{Numeric_Value=0.625}', "");
    Expect(1, 8541, '\P{^Numeric_Value=0.625}', "");
    Expect(0, 8542, '\p{Numeric_Value=0.625}', "");
    Expect(1, 8542, '\p{^Numeric_Value=0.625}', "");
    Expect(1, 8542, '\P{Numeric_Value=0.625}', "");
    Expect(0, 8542, '\P{^Numeric_Value=0.625}', "");
    Expect(1, 8541, '\p{Numeric_Value=6.2500e-01}', "");
    Expect(0, 8541, '\p{^Numeric_Value=6.2500e-01}', "");
    Expect(0, 8541, '\P{Numeric_Value=6.2500e-01}', "");
    Expect(1, 8541, '\P{^Numeric_Value=6.2500e-01}', "");
    Expect(0, 8542, '\p{Numeric_Value=6.2500e-01}', "");
    Expect(1, 8542, '\p{^Numeric_Value=6.2500e-01}', "");
    Expect(1, 8542, '\P{Numeric_Value=6.2500e-01}', "");
    Expect(0, 8542, '\P{^Numeric_Value=6.2500e-01}', "");
    Expect(1, 8541, '\p{Numeric_Value=0.6250}', "");
    Expect(0, 8541, '\p{^Numeric_Value=0.6250}', "");
    Expect(0, 8541, '\P{Numeric_Value=0.6250}', "");
    Expect(1, 8541, '\P{^Numeric_Value=0.6250}', "");
    Expect(0, 8542, '\p{Numeric_Value=0.6250}', "");
    Expect(1, 8542, '\p{^Numeric_Value=0.6250}', "");
    Expect(1, 8542, '\P{Numeric_Value=0.6250}', "");
    Expect(0, 8542, '\P{^Numeric_Value=0.6250}', "");
    Error('\p{Nv=:=-	+00005/08}');
    Error('\P{Nv=:=-	+00005/08}');
    Expect(1, 8541, '\p{Nv=:\A5/8\z:}', "");;
    Expect(0, 8542, '\p{Nv=:\A5/8\z:}', "");;
    Expect(1, 8541, '\p{Nv=05/0000008}', "");
    Expect(0, 8541, '\p{^Nv=05/0000008}', "");
    Expect(0, 8541, '\P{Nv=05/0000008}', "");
    Expect(1, 8541, '\P{^Nv=05/0000008}', "");
    Expect(0, 8542, '\p{Nv=05/0000008}', "");
    Expect(1, 8542, '\p{^Nv=05/0000008}', "");
    Expect(1, 8542, '\P{Nv=05/0000008}', "");
    Expect(0, 8542, '\P{^Nv=05/0000008}', "");
    Expect(1, 8541, '\p{Nv=300/480}', "");
    Expect(0, 8541, '\p{^Nv=300/480}', "");
    Expect(0, 8541, '\P{Nv=300/480}', "");
    Expect(1, 8541, '\P{^Nv=300/480}', "");
    Expect(0, 8542, '\p{Nv=300/480}', "");
    Expect(1, 8542, '\p{^Nv=300/480}', "");
    Expect(1, 8542, '\P{Nv=300/480}', "");
    Expect(0, 8542, '\P{^Nv=300/480}', "");
    Error('\p{Nv=6.2e-01}');
    Error('\P{Nv=6.2e-01}');
    Expect(1, 8541, '\p{Nv=6.25e-01}', "");
    Expect(0, 8541, '\p{^Nv=6.25e-01}', "");
    Expect(0, 8541, '\P{Nv=6.25e-01}', "");
    Expect(1, 8541, '\P{^Nv=6.25e-01}', "");
    Expect(0, 8542, '\p{Nv=6.25e-01}', "");
    Expect(1, 8542, '\p{^Nv=6.25e-01}', "");
    Expect(1, 8542, '\P{Nv=6.25e-01}', "");
    Expect(0, 8542, '\P{^Nv=6.25e-01}', "");
    Error('\p{Nv=0.62}');
    Error('\P{Nv=0.62}');
    Expect(1, 8541, '\p{Nv=6.250e-01}', "");
    Expect(0, 8541, '\p{^Nv=6.250e-01}', "");
    Expect(0, 8541, '\P{Nv=6.250e-01}', "");
    Expect(1, 8541, '\P{^Nv=6.250e-01}', "");
    Expect(0, 8542, '\p{Nv=6.250e-01}', "");
    Expect(1, 8542, '\p{^Nv=6.250e-01}', "");
    Expect(1, 8542, '\P{Nv=6.250e-01}', "");
    Expect(0, 8542, '\P{^Nv=6.250e-01}', "");
    Expect(1, 8541, '\p{Nv:   0.625}', "");
    Expect(0, 8541, '\p{^Nv:   0.625}', "");
    Expect(0, 8541, '\P{Nv:   0.625}', "");
    Expect(1, 8541, '\P{^Nv:   0.625}', "");
    Expect(0, 8542, '\p{Nv:   0.625}', "");
    Expect(1, 8542, '\p{^Nv:   0.625}', "");
    Expect(1, 8542, '\P{Nv:   0.625}', "");
    Expect(0, 8542, '\P{^Nv:   0.625}', "");
    Expect(1, 8541, '\p{Nv:   6.2500e-01}', "");
    Expect(0, 8541, '\p{^Nv:   6.2500e-01}', "");
    Expect(0, 8541, '\P{Nv:   6.2500e-01}', "");
    Expect(1, 8541, '\P{^Nv:   6.2500e-01}', "");
    Expect(0, 8542, '\p{Nv:   6.2500e-01}', "");
    Expect(1, 8542, '\p{^Nv:   6.2500e-01}', "");
    Expect(1, 8542, '\P{Nv:   6.2500e-01}', "");
    Expect(0, 8542, '\P{^Nv:   6.2500e-01}', "");
    Expect(1, 8541, '\p{Nv=0.6250}', "");
    Expect(0, 8541, '\p{^Nv=0.6250}', "");
    Expect(0, 8541, '\P{Nv=0.6250}', "");
    Expect(1, 8541, '\P{^Nv=0.6250}', "");
    Expect(0, 8542, '\p{Nv=0.6250}', "");
    Expect(1, 8542, '\p{^Nv=0.6250}', "");
    Expect(1, 8542, '\P{Nv=0.6250}', "");
    Expect(0, 8542, '\P{^Nv=0.6250}', "");
    Error('\p{Is_Numeric_Value=:=_-00005/0000008}');
    Error('\P{Is_Numeric_Value=:=_-00005/0000008}');
    Expect(1, 8541, '\p{Is_Numeric_Value:000000005/08}', "");
    Expect(0, 8541, '\p{^Is_Numeric_Value:000000005/08}', "");
    Expect(0, 8541, '\P{Is_Numeric_Value:000000005/08}', "");
    Expect(1, 8541, '\P{^Is_Numeric_Value:000000005/08}', "");
    Expect(0, 8542, '\p{Is_Numeric_Value:000000005/08}', "");
    Expect(1, 8542, '\p{^Is_Numeric_Value:000000005/08}', "");
    Expect(1, 8542, '\P{Is_Numeric_Value:000000005/08}', "");
    Expect(0, 8542, '\P{^Is_Numeric_Value:000000005/08}', "");
    Expect(1, 8541, '\p{Is_Numeric_Value: 300/480}', "");
    Expect(0, 8541, '\p{^Is_Numeric_Value: 300/480}', "");
    Expect(0, 8541, '\P{Is_Numeric_Value: 300/480}', "");
    Expect(1, 8541, '\P{^Is_Numeric_Value: 300/480}', "");
    Expect(0, 8542, '\p{Is_Numeric_Value: 300/480}', "");
    Expect(1, 8542, '\p{^Is_Numeric_Value: 300/480}', "");
    Expect(1, 8542, '\P{Is_Numeric_Value: 300/480}', "");
    Expect(0, 8542, '\P{^Is_Numeric_Value: 300/480}', "");
    Error('\p{Is_Numeric_Value=6.2e-01}');
    Error('\P{Is_Numeric_Value=6.2e-01}');
    Expect(1, 8541, '\p{Is_Numeric_Value=6.25e-01}', "");
    Expect(0, 8541, '\p{^Is_Numeric_Value=6.25e-01}', "");
    Expect(0, 8541, '\P{Is_Numeric_Value=6.25e-01}', "");
    Expect(1, 8541, '\P{^Is_Numeric_Value=6.25e-01}', "");
    Expect(0, 8542, '\p{Is_Numeric_Value=6.25e-01}', "");
    Expect(1, 8542, '\p{^Is_Numeric_Value=6.25e-01}', "");
    Expect(1, 8542, '\P{Is_Numeric_Value=6.25e-01}', "");
    Expect(0, 8542, '\P{^Is_Numeric_Value=6.25e-01}', "");
    Error('\p{Is_Numeric_Value=0.62}');
    Error('\P{Is_Numeric_Value=0.62}');
    Expect(1, 8541, '\p{Is_Numeric_Value=6.250e-01}', "");
    Expect(0, 8541, '\p{^Is_Numeric_Value=6.250e-01}', "");
    Expect(0, 8541, '\P{Is_Numeric_Value=6.250e-01}', "");
    Expect(1, 8541, '\P{^Is_Numeric_Value=6.250e-01}', "");
    Expect(0, 8542, '\p{Is_Numeric_Value=6.250e-01}', "");
    Expect(1, 8542, '\p{^Is_Numeric_Value=6.250e-01}', "");
    Expect(1, 8542, '\P{Is_Numeric_Value=6.250e-01}', "");
    Expect(0, 8542, '\P{^Is_Numeric_Value=6.250e-01}', "");
    Expect(1, 8541, '\p{Is_Numeric_Value:   0.625}', "");
    Expect(0, 8541, '\p{^Is_Numeric_Value:   0.625}', "");
    Expect(0, 8541, '\P{Is_Numeric_Value:   0.625}', "");
    Expect(1, 8541, '\P{^Is_Numeric_Value:   0.625}', "");
    Expect(0, 8542, '\p{Is_Numeric_Value:   0.625}', "");
    Expect(1, 8542, '\p{^Is_Numeric_Value:   0.625}', "");
    Expect(1, 8542, '\P{Is_Numeric_Value:   0.625}', "");
    Expect(0, 8542, '\P{^Is_Numeric_Value:   0.625}', "");
    Expect(1, 8541, '\p{Is_Numeric_Value=6.2500e-01}', "");
    Expect(0, 8541, '\p{^Is_Numeric_Value=6.2500e-01}', "");
    Expect(0, 8541, '\P{Is_Numeric_Value=6.2500e-01}', "");
    Expect(1, 8541, '\P{^Is_Numeric_Value=6.2500e-01}', "");
    Expect(0, 8542, '\p{Is_Numeric_Value=6.2500e-01}', "");
    Expect(1, 8542, '\p{^Is_Numeric_Value=6.2500e-01}', "");
    Expect(1, 8542, '\P{Is_Numeric_Value=6.2500e-01}', "");
    Expect(0, 8542, '\P{^Is_Numeric_Value=6.2500e-01}', "");
    Expect(1, 8541, '\p{Is_Numeric_Value=0.6250}', "");
    Expect(0, 8541, '\p{^Is_Numeric_Value=0.6250}', "");
    Expect(0, 8541, '\P{Is_Numeric_Value=0.6250}', "");
    Expect(1, 8541, '\P{^Is_Numeric_Value=0.6250}', "");
    Expect(0, 8542, '\p{Is_Numeric_Value=0.6250}', "");
    Expect(1, 8542, '\p{^Is_Numeric_Value=0.6250}', "");
    Expect(1, 8542, '\P{Is_Numeric_Value=0.6250}', "");
    Expect(0, 8542, '\P{^Is_Numeric_Value=0.6250}', "");
    Error('\p{Is_Nv= _0005/0000008:=}');
    Error('\P{Is_Nv= _0005/0000008:=}');
    Expect(1, 8541, '\p{Is_Nv=000005/008}', "");
    Expect(0, 8541, '\p{^Is_Nv=000005/008}', "");
    Expect(0, 8541, '\P{Is_Nv=000005/008}', "");
    Expect(1, 8541, '\P{^Is_Nv=000005/008}', "");
    Expect(0, 8542, '\p{Is_Nv=000005/008}', "");
    Expect(1, 8542, '\p{^Is_Nv=000005/008}', "");
    Expect(1, 8542, '\P{Is_Nv=000005/008}', "");
    Expect(0, 8542, '\P{^Is_Nv=000005/008}', "");
    Expect(1, 8541, '\p{Is_Nv=300/480}', "");
    Expect(0, 8541, '\p{^Is_Nv=300/480}', "");
    Expect(0, 8541, '\P{Is_Nv=300/480}', "");
    Expect(1, 8541, '\P{^Is_Nv=300/480}', "");
    Expect(0, 8542, '\p{Is_Nv=300/480}', "");
    Expect(1, 8542, '\p{^Is_Nv=300/480}', "");
    Expect(1, 8542, '\P{Is_Nv=300/480}', "");
    Expect(0, 8542, '\P{^Is_Nv=300/480}', "");
    Error('\p{Is_Nv=6.2e-01}');
    Error('\P{Is_Nv=6.2e-01}');
    Expect(1, 8541, '\p{Is_Nv=6.25e-01}', "");
    Expect(0, 8541, '\p{^Is_Nv=6.25e-01}', "");
    Expect(0, 8541, '\P{Is_Nv=6.25e-01}', "");
    Expect(1, 8541, '\P{^Is_Nv=6.25e-01}', "");
    Expect(0, 8542, '\p{Is_Nv=6.25e-01}', "");
    Expect(1, 8542, '\p{^Is_Nv=6.25e-01}', "");
    Expect(1, 8542, '\P{Is_Nv=6.25e-01}', "");
    Expect(0, 8542, '\P{^Is_Nv=6.25e-01}', "");
    Error('\p{Is_Nv=0.62}');
    Error('\P{Is_Nv=0.62}');
    Expect(1, 8541, '\p{Is_Nv=6.250e-01}', "");
    Expect(0, 8541, '\p{^Is_Nv=6.250e-01}', "");
    Expect(0, 8541, '\P{Is_Nv=6.250e-01}', "");
    Expect(1, 8541, '\P{^Is_Nv=6.250e-01}', "");
    Expect(0, 8542, '\p{Is_Nv=6.250e-01}', "");
    Expect(1, 8542, '\p{^Is_Nv=6.250e-01}', "");
    Expect(1, 8542, '\P{Is_Nv=6.250e-01}', "");
    Expect(0, 8542, '\P{^Is_Nv=6.250e-01}', "");
    Expect(1, 8541, '\p{Is_Nv=0.625}', "");
    Expect(0, 8541, '\p{^Is_Nv=0.625}', "");
    Expect(0, 8541, '\P{Is_Nv=0.625}', "");
    Expect(1, 8541, '\P{^Is_Nv=0.625}', "");
    Expect(0, 8542, '\p{Is_Nv=0.625}', "");
    Expect(1, 8542, '\p{^Is_Nv=0.625}', "");
    Expect(1, 8542, '\P{Is_Nv=0.625}', "");
    Expect(0, 8542, '\P{^Is_Nv=0.625}', "");
    Expect(1, 8541, '\p{Is_Nv=6.2500e-01}', "");
    Expect(0, 8541, '\p{^Is_Nv=6.2500e-01}', "");
    Expect(0, 8541, '\P{Is_Nv=6.2500e-01}', "");
    Expect(1, 8541, '\P{^Is_Nv=6.2500e-01}', "");
    Expect(0, 8542, '\p{Is_Nv=6.2500e-01}', "");
    Expect(1, 8542, '\p{^Is_Nv=6.2500e-01}', "");
    Expect(1, 8542, '\P{Is_Nv=6.2500e-01}', "");
    Expect(0, 8542, '\P{^Is_Nv=6.2500e-01}', "");
    Expect(1, 8541, '\p{Is_Nv=0.6250}', "");
    Expect(0, 8541, '\p{^Is_Nv=0.6250}', "");
    Expect(0, 8541, '\P{Is_Nv=0.6250}', "");
    Expect(1, 8541, '\P{^Is_Nv=0.6250}', "");
    Expect(0, 8542, '\p{Is_Nv=0.6250}', "");
    Expect(1, 8542, '\p{^Is_Nv=0.6250}', "");
    Expect(1, 8542, '\P{Is_Nv=0.6250}', "");
    Expect(0, 8542, '\P{^Is_Nv=0.6250}', "");
    Error('\p{Numeric_Value=	-0_0_0_0_0_0_0_0050:=}');
    Error('\P{Numeric_Value=	-0_0_0_0_0_0_0_0050:=}');
    Expect(1, 126222, '\p{Numeric_Value=:\A50\z:}', "");;
    Expect(0, 126223, '\p{Numeric_Value=:\A50\z:}', "");;
    Expect(1, 126222, '\p{Numeric_Value=05_0}', "");
    Expect(0, 126222, '\p{^Numeric_Value=05_0}', "");
    Expect(0, 126222, '\P{Numeric_Value=05_0}', "");
    Expect(1, 126222, '\P{^Numeric_Value=05_0}', "");
    Expect(0, 126223, '\p{Numeric_Value=05_0}', "");
    Expect(1, 126223, '\p{^Numeric_Value=05_0}', "");
    Expect(1, 126223, '\P{Numeric_Value=05_0}', "");
    Expect(0, 126223, '\P{^Numeric_Value=05_0}', "");
    Expect(1, 126222, '\p{Numeric_Value=5.000000000000000e+01}', "");
    Expect(0, 126222, '\p{^Numeric_Value=5.000000000000000e+01}', "");
    Expect(0, 126222, '\P{Numeric_Value=5.000000000000000e+01}', "");
    Expect(1, 126222, '\P{^Numeric_Value=5.000000000000000e+01}', "");
    Expect(0, 126223, '\p{Numeric_Value=5.000000000000000e+01}', "");
    Expect(1, 126223, '\p{^Numeric_Value=5.000000000000000e+01}', "");
    Expect(1, 126223, '\P{Numeric_Value=5.000000000000000e+01}', "");
    Expect(0, 126223, '\P{^Numeric_Value=5.000000000000000e+01}', "");
    Error('\p{Nv=_:=0_0_50}');
    Error('\P{Nv=_:=0_0_50}');
    Expect(1, 126222, '\p{Nv=:\A50\z:}', "");;
    Expect(0, 126223, '\p{Nv=:\A50\z:}', "");;
    Expect(1, 126222, '\p{Nv:   +00000050}', "");
    Expect(0, 126222, '\p{^Nv:   +00000050}', "");
    Expect(0, 126222, '\P{Nv:   +00000050}', "");
    Expect(1, 126222, '\P{^Nv:   +00000050}', "");
    Expect(0, 126223, '\p{Nv:   +00000050}', "");
    Expect(1, 126223, '\p{^Nv:   +00000050}', "");
    Expect(1, 126223, '\P{Nv:   +00000050}', "");
    Expect(0, 126223, '\P{^Nv:   +00000050}', "");
    Expect(1, 126222, '\p{Nv=5.000000000000000e+01}', "");
    Expect(0, 126222, '\p{^Nv=5.000000000000000e+01}', "");
    Expect(0, 126222, '\P{Nv=5.000000000000000e+01}', "");
    Expect(1, 126222, '\P{^Nv=5.000000000000000e+01}', "");
    Expect(0, 126223, '\p{Nv=5.000000000000000e+01}', "");
    Expect(1, 126223, '\p{^Nv=5.000000000000000e+01}', "");
    Expect(1, 126223, '\P{Nv=5.000000000000000e+01}', "");
    Expect(0, 126223, '\P{^Nv=5.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=/a/_000000050}');
    Error('\P{Is_Numeric_Value=/a/_000000050}');
    Expect(1, 126222, '\p{Is_Numeric_Value=+0050}', "");
    Expect(0, 126222, '\p{^Is_Numeric_Value=+0050}', "");
    Expect(0, 126222, '\P{Is_Numeric_Value=+0050}', "");
    Expect(1, 126222, '\P{^Is_Numeric_Value=+0050}', "");
    Expect(0, 126223, '\p{Is_Numeric_Value=+0050}', "");
    Expect(1, 126223, '\p{^Is_Numeric_Value=+0050}', "");
    Expect(1, 126223, '\P{Is_Numeric_Value=+0050}', "");
    Expect(0, 126223, '\P{^Is_Numeric_Value=+0050}', "");
    Expect(1, 126222, '\p{Is_Numeric_Value=5.000000000000000e+01}', "");
    Expect(0, 126222, '\p{^Is_Numeric_Value=5.000000000000000e+01}', "");
    Expect(0, 126222, '\P{Is_Numeric_Value=5.000000000000000e+01}', "");
    Expect(1, 126222, '\P{^Is_Numeric_Value=5.000000000000000e+01}', "");
    Expect(0, 126223, '\p{Is_Numeric_Value=5.000000000000000e+01}', "");
    Expect(1, 126223, '\p{^Is_Numeric_Value=5.000000000000000e+01}', "");
    Expect(1, 126223, '\P{Is_Numeric_Value=5.000000000000000e+01}', "");
    Expect(0, 126223, '\P{^Is_Numeric_Value=5.000000000000000e+01}', "");
    Error('\p{Is_Nv= _+50:=}');
    Error('\P{Is_Nv= _+50:=}');
    Expect(1, 126222, '\p{Is_Nv:	+50}', "");
    Expect(0, 126222, '\p{^Is_Nv:	+50}', "");
    Expect(0, 126222, '\P{Is_Nv:	+50}', "");
    Expect(1, 126222, '\P{^Is_Nv:	+50}', "");
    Expect(0, 126223, '\p{Is_Nv:	+50}', "");
    Expect(1, 126223, '\p{^Is_Nv:	+50}', "");
    Expect(1, 126223, '\P{Is_Nv:	+50}', "");
    Expect(0, 126223, '\P{^Is_Nv:	+50}', "");
    Expect(1, 126222, '\p{Is_Nv=5.000000000000000e+01}', "");
    Expect(0, 126222, '\p{^Is_Nv=5.000000000000000e+01}', "");
    Expect(0, 126222, '\P{Is_Nv=5.000000000000000e+01}', "");
    Expect(1, 126222, '\P{^Is_Nv=5.000000000000000e+01}', "");
    Expect(0, 126223, '\p{Is_Nv=5.000000000000000e+01}', "");
    Expect(1, 126223, '\p{^Is_Nv=5.000000000000000e+01}', "");
    Expect(1, 126223, '\P{Is_Nv=5.000000000000000e+01}', "");
    Expect(0, 126223, '\P{^Is_Nv=5.000000000000000e+01}', "");
    Error('\p{Numeric_Value=:=--0_0_0_0_0_00500}');
    Error('\P{Numeric_Value=:=--0_0_0_0_0_00500}');
    Expect(1, 126231, '\p{Numeric_Value=:\A500\z:}', "");;
    Expect(0, 126232, '\p{Numeric_Value=:\A500\z:}', "");;
    Expect(1, 126231, '\p{Numeric_Value=00_00_05_00}', "");
    Expect(0, 126231, '\p{^Numeric_Value=00_00_05_00}', "");
    Expect(0, 126231, '\P{Numeric_Value=00_00_05_00}', "");
    Expect(1, 126231, '\P{^Numeric_Value=00_00_05_00}', "");
    Expect(0, 126232, '\p{Numeric_Value=00_00_05_00}', "");
    Expect(1, 126232, '\p{^Numeric_Value=00_00_05_00}', "");
    Expect(1, 126232, '\P{Numeric_Value=00_00_05_00}', "");
    Expect(0, 126232, '\P{^Numeric_Value=00_00_05_00}', "");
    Expect(1, 126231, '\p{Numeric_Value:	5.000000000000000e+02}', "");
    Expect(0, 126231, '\p{^Numeric_Value:	5.000000000000000e+02}', "");
    Expect(0, 126231, '\P{Numeric_Value:	5.000000000000000e+02}', "");
    Expect(1, 126231, '\P{^Numeric_Value:	5.000000000000000e+02}', "");
    Expect(0, 126232, '\p{Numeric_Value:	5.000000000000000e+02}', "");
    Expect(1, 126232, '\p{^Numeric_Value:	5.000000000000000e+02}', "");
    Expect(1, 126232, '\P{Numeric_Value:	5.000000000000000e+02}', "");
    Expect(0, 126232, '\P{^Numeric_Value:	5.000000000000000e+02}', "");
    Error('\p{Nv:    _50_0/a/}');
    Error('\P{Nv:    _50_0/a/}');
    Expect(1, 126231, '\p{Nv=:\A500\z:}', "");;
    Expect(0, 126232, '\p{Nv=:\A500\z:}', "");;
    Expect(1, 126231, '\p{Nv=0_0_0_0_0_0_0_0_0_5_00}', "");
    Expect(0, 126231, '\p{^Nv=0_0_0_0_0_0_0_0_0_5_00}', "");
    Expect(0, 126231, '\P{Nv=0_0_0_0_0_0_0_0_0_5_00}', "");
    Expect(1, 126231, '\P{^Nv=0_0_0_0_0_0_0_0_0_5_00}', "");
    Expect(0, 126232, '\p{Nv=0_0_0_0_0_0_0_0_0_5_00}', "");
    Expect(1, 126232, '\p{^Nv=0_0_0_0_0_0_0_0_0_5_00}', "");
    Expect(1, 126232, '\P{Nv=0_0_0_0_0_0_0_0_0_5_00}', "");
    Expect(0, 126232, '\P{^Nv=0_0_0_0_0_0_0_0_0_5_00}', "");
    Expect(1, 126231, '\p{Nv=5.000000000000000e+02}', "");
    Expect(0, 126231, '\p{^Nv=5.000000000000000e+02}', "");
    Expect(0, 126231, '\P{Nv=5.000000000000000e+02}', "");
    Expect(1, 126231, '\P{^Nv=5.000000000000000e+02}', "");
    Expect(0, 126232, '\p{Nv=5.000000000000000e+02}', "");
    Expect(1, 126232, '\p{^Nv=5.000000000000000e+02}', "");
    Expect(1, 126232, '\P{Nv=5.000000000000000e+02}', "");
    Expect(0, 126232, '\P{^Nv=5.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value=/a/ 050_0}');
    Error('\P{Is_Numeric_Value=/a/ 050_0}');
    Expect(1, 126231, '\p{Is_Numeric_Value=+00000050_0}', "");
    Expect(0, 126231, '\p{^Is_Numeric_Value=+00000050_0}', "");
    Expect(0, 126231, '\P{Is_Numeric_Value=+00000050_0}', "");
    Expect(1, 126231, '\P{^Is_Numeric_Value=+00000050_0}', "");
    Expect(0, 126232, '\p{Is_Numeric_Value=+00000050_0}', "");
    Expect(1, 126232, '\p{^Is_Numeric_Value=+00000050_0}', "");
    Expect(1, 126232, '\P{Is_Numeric_Value=+00000050_0}', "");
    Expect(0, 126232, '\P{^Is_Numeric_Value=+00000050_0}', "");
    Expect(1, 126231, '\p{Is_Numeric_Value=5.000000000000000e+02}', "");
    Expect(0, 126231, '\p{^Is_Numeric_Value=5.000000000000000e+02}', "");
    Expect(0, 126231, '\P{Is_Numeric_Value=5.000000000000000e+02}', "");
    Expect(1, 126231, '\P{^Is_Numeric_Value=5.000000000000000e+02}', "");
    Expect(0, 126232, '\p{Is_Numeric_Value=5.000000000000000e+02}', "");
    Expect(1, 126232, '\p{^Is_Numeric_Value=5.000000000000000e+02}', "");
    Expect(1, 126232, '\P{Is_Numeric_Value=5.000000000000000e+02}', "");
    Expect(0, 126232, '\P{^Is_Numeric_Value=5.000000000000000e+02}', "");
    Error('\p{Is_Nv=:=  +000000000500}');
    Error('\P{Is_Nv=:=  +000000000500}');
    Expect(1, 126231, '\p{Is_Nv=0_0_5_00}', "");
    Expect(0, 126231, '\p{^Is_Nv=0_0_5_00}', "");
    Expect(0, 126231, '\P{Is_Nv=0_0_5_00}', "");
    Expect(1, 126231, '\P{^Is_Nv=0_0_5_00}', "");
    Expect(0, 126232, '\p{Is_Nv=0_0_5_00}', "");
    Expect(1, 126232, '\p{^Is_Nv=0_0_5_00}', "");
    Expect(1, 126232, '\P{Is_Nv=0_0_5_00}', "");
    Expect(0, 126232, '\P{^Is_Nv=0_0_5_00}', "");
    Expect(1, 126231, '\p{Is_Nv=5.000000000000000e+02}', "");
    Expect(0, 126231, '\p{^Is_Nv=5.000000000000000e+02}', "");
    Expect(0, 126231, '\P{Is_Nv=5.000000000000000e+02}', "");
    Expect(1, 126231, '\P{^Is_Nv=5.000000000000000e+02}', "");
    Expect(0, 126232, '\p{Is_Nv=5.000000000000000e+02}', "");
    Expect(1, 126232, '\p{^Is_Nv=5.000000000000000e+02}', "");
    Expect(1, 126232, '\P{Is_Nv=5.000000000000000e+02}', "");
    Expect(0, 126232, '\P{^Is_Nv=5.000000000000000e+02}', "");
    Error('\p{Numeric_Value=	/a/5000}');
    Error('\P{Numeric_Value=	/a/5000}');
    Expect(1, 126240, '\p{Numeric_Value=:\A5000\z:}', "");;
    Expect(0, 126241, '\p{Numeric_Value=:\A5000\z:}', "");;
    Expect(1, 126240, '\p{Numeric_Value=+000000005000}', "");
    Expect(0, 126240, '\p{^Numeric_Value=+000000005000}', "");
    Expect(0, 126240, '\P{Numeric_Value=+000000005000}', "");
    Expect(1, 126240, '\P{^Numeric_Value=+000000005000}', "");
    Expect(0, 126241, '\p{Numeric_Value=+000000005000}', "");
    Expect(1, 126241, '\p{^Numeric_Value=+000000005000}', "");
    Expect(1, 126241, '\P{Numeric_Value=+000000005000}', "");
    Expect(0, 126241, '\P{^Numeric_Value=+000000005000}', "");
    Expect(1, 126240, '\p{Numeric_Value=5.000000000000000e+03}', "");
    Expect(0, 126240, '\p{^Numeric_Value=5.000000000000000e+03}', "");
    Expect(0, 126240, '\P{Numeric_Value=5.000000000000000e+03}', "");
    Expect(1, 126240, '\P{^Numeric_Value=5.000000000000000e+03}', "");
    Expect(0, 126241, '\p{Numeric_Value=5.000000000000000e+03}', "");
    Expect(1, 126241, '\p{^Numeric_Value=5.000000000000000e+03}', "");
    Expect(1, 126241, '\P{Numeric_Value=5.000000000000000e+03}', "");
    Expect(0, 126241, '\P{^Numeric_Value=5.000000000000000e+03}', "");
    Error('\p{Nv=_00_00_05_000:=}');
    Error('\P{Nv=_00_00_05_000:=}');
    Expect(1, 126240, '\p{Nv=:\A5000\z:}', "");;
    Expect(0, 126241, '\p{Nv=:\A5000\z:}', "");;
    Expect(1, 126240, '\p{Nv=+0_0_0_0_5000}', "");
    Expect(0, 126240, '\p{^Nv=+0_0_0_0_5000}', "");
    Expect(0, 126240, '\P{Nv=+0_0_0_0_5000}', "");
    Expect(1, 126240, '\P{^Nv=+0_0_0_0_5000}', "");
    Expect(0, 126241, '\p{Nv=+0_0_0_0_5000}', "");
    Expect(1, 126241, '\p{^Nv=+0_0_0_0_5000}', "");
    Expect(1, 126241, '\P{Nv=+0_0_0_0_5000}', "");
    Expect(0, 126241, '\P{^Nv=+0_0_0_0_5000}', "");
    Expect(1, 126240, '\p{Nv=5.000000000000000e+03}', "");
    Expect(0, 126240, '\p{^Nv=5.000000000000000e+03}', "");
    Expect(0, 126240, '\P{Nv=5.000000000000000e+03}', "");
    Expect(1, 126240, '\P{^Nv=5.000000000000000e+03}', "");
    Expect(0, 126241, '\p{Nv=5.000000000000000e+03}', "");
    Expect(1, 126241, '\p{^Nv=5.000000000000000e+03}', "");
    Expect(1, 126241, '\P{Nv=5.000000000000000e+03}', "");
    Expect(0, 126241, '\P{^Nv=5.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value=/a/	-000005000}');
    Error('\P{Is_Numeric_Value=/a/	-000005000}');
    Expect(1, 126240, '\p{Is_Numeric_Value=+000005000}', "");
    Expect(0, 126240, '\p{^Is_Numeric_Value=+000005000}', "");
    Expect(0, 126240, '\P{Is_Numeric_Value=+000005000}', "");
    Expect(1, 126240, '\P{^Is_Numeric_Value=+000005000}', "");
    Expect(0, 126241, '\p{Is_Numeric_Value=+000005000}', "");
    Expect(1, 126241, '\p{^Is_Numeric_Value=+000005000}', "");
    Expect(1, 126241, '\P{Is_Numeric_Value=+000005000}', "");
    Expect(0, 126241, '\P{^Is_Numeric_Value=+000005000}', "");
    Expect(1, 126240, '\p{Is_Numeric_Value=5.000000000000000e+03}', "");
    Expect(0, 126240, '\p{^Is_Numeric_Value=5.000000000000000e+03}', "");
    Expect(0, 126240, '\P{Is_Numeric_Value=5.000000000000000e+03}', "");
    Expect(1, 126240, '\P{^Is_Numeric_Value=5.000000000000000e+03}', "");
    Expect(0, 126241, '\p{Is_Numeric_Value=5.000000000000000e+03}', "");
    Expect(1, 126241, '\p{^Is_Numeric_Value=5.000000000000000e+03}', "");
    Expect(1, 126241, '\P{Is_Numeric_Value=5.000000000000000e+03}', "");
    Expect(0, 126241, '\P{^Is_Numeric_Value=5.000000000000000e+03}', "");
    Error('\p{Is_Nv=-/a/0_0_0_0_0_5_000}');
    Error('\P{Is_Nv=-/a/0_0_0_0_0_5_000}');
    Expect(1, 126240, '\p{Is_Nv=+00000005000}', "");
    Expect(0, 126240, '\p{^Is_Nv=+00000005000}', "");
    Expect(0, 126240, '\P{Is_Nv=+00000005000}', "");
    Expect(1, 126240, '\P{^Is_Nv=+00000005000}', "");
    Expect(0, 126241, '\p{Is_Nv=+00000005000}', "");
    Expect(1, 126241, '\p{^Is_Nv=+00000005000}', "");
    Expect(1, 126241, '\P{Is_Nv=+00000005000}', "");
    Expect(0, 126241, '\P{^Is_Nv=+00000005000}', "");
    Expect(1, 126240, '\p{Is_Nv=5.000000000000000e+03}', "");
    Expect(0, 126240, '\p{^Is_Nv=5.000000000000000e+03}', "");
    Expect(0, 126240, '\P{Is_Nv=5.000000000000000e+03}', "");
    Expect(1, 126240, '\P{^Is_Nv=5.000000000000000e+03}', "");
    Expect(0, 126241, '\p{Is_Nv=5.000000000000000e+03}', "");
    Expect(1, 126241, '\p{^Is_Nv=5.000000000000000e+03}', "");
    Expect(1, 126241, '\P{Is_Nv=5.000000000000000e+03}', "");
    Expect(0, 126241, '\P{^Is_Nv=5.000000000000000e+03}', "");
    Error('\p{Numeric_Value= _+0_0_0_0_0_0_0_50000:=}');
    Error('\P{Numeric_Value= _+0_0_0_0_0_0_0_50000:=}');
    Expect(1, 126249, '\p{Numeric_Value=:\A50000\z:}', "");;
    Expect(0, 126250, '\p{Numeric_Value=:\A50000\z:}', "");;
    Expect(1, 126249, '\p{Numeric_Value=00000050000}', "");
    Expect(0, 126249, '\p{^Numeric_Value=00000050000}', "");
    Expect(0, 126249, '\P{Numeric_Value=00000050000}', "");
    Expect(1, 126249, '\P{^Numeric_Value=00000050000}', "");
    Expect(0, 126250, '\p{Numeric_Value=00000050000}', "");
    Expect(1, 126250, '\p{^Numeric_Value=00000050000}', "");
    Expect(1, 126250, '\P{Numeric_Value=00000050000}', "");
    Expect(0, 126250, '\P{^Numeric_Value=00000050000}', "");
    Expect(1, 126249, '\p{Numeric_Value=5.000000000000000e+04}', "");
    Expect(0, 126249, '\p{^Numeric_Value=5.000000000000000e+04}', "");
    Expect(0, 126249, '\P{Numeric_Value=5.000000000000000e+04}', "");
    Expect(1, 126249, '\P{^Numeric_Value=5.000000000000000e+04}', "");
    Expect(0, 126250, '\p{Numeric_Value=5.000000000000000e+04}', "");
    Expect(1, 126250, '\p{^Numeric_Value=5.000000000000000e+04}', "");
    Expect(1, 126250, '\P{Numeric_Value=5.000000000000000e+04}', "");
    Expect(0, 126250, '\P{^Numeric_Value=5.000000000000000e+04}', "");
    Error('\p{Nv=:=__00000000050000}');
    Error('\P{Nv=:=__00000000050000}');
    Expect(1, 126249, '\p{Nv=:\A50000\z:}', "");;
    Expect(0, 126250, '\p{Nv=:\A50000\z:}', "");;
    Expect(1, 126249, '\p{Nv=+5_0_0_00}', "");
    Expect(0, 126249, '\p{^Nv=+5_0_0_00}', "");
    Expect(0, 126249, '\P{Nv=+5_0_0_00}', "");
    Expect(1, 126249, '\P{^Nv=+5_0_0_00}', "");
    Expect(0, 126250, '\p{Nv=+5_0_0_00}', "");
    Expect(1, 126250, '\p{^Nv=+5_0_0_00}', "");
    Expect(1, 126250, '\P{Nv=+5_0_0_00}', "");
    Expect(0, 126250, '\P{^Nv=+5_0_0_00}', "");
    Expect(1, 126249, '\p{Nv=5.000000000000000e+04}', "");
    Expect(0, 126249, '\p{^Nv=5.000000000000000e+04}', "");
    Expect(0, 126249, '\P{Nv=5.000000000000000e+04}', "");
    Expect(1, 126249, '\P{^Nv=5.000000000000000e+04}', "");
    Expect(0, 126250, '\p{Nv=5.000000000000000e+04}', "");
    Expect(1, 126250, '\p{^Nv=5.000000000000000e+04}', "");
    Expect(1, 126250, '\P{Nv=5.000000000000000e+04}', "");
    Expect(0, 126250, '\P{^Nv=5.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value=_0_0_0_0_0_5_0_000/a/}');
    Error('\P{Is_Numeric_Value=_0_0_0_0_0_5_0_000/a/}');
    Expect(1, 126249, '\p{Is_Numeric_Value=0000050000}', "");
    Expect(0, 126249, '\p{^Is_Numeric_Value=0000050000}', "");
    Expect(0, 126249, '\P{Is_Numeric_Value=0000050000}', "");
    Expect(1, 126249, '\P{^Is_Numeric_Value=0000050000}', "");
    Expect(0, 126250, '\p{Is_Numeric_Value=0000050000}', "");
    Expect(1, 126250, '\p{^Is_Numeric_Value=0000050000}', "");
    Expect(1, 126250, '\P{Is_Numeric_Value=0000050000}', "");
    Expect(0, 126250, '\P{^Is_Numeric_Value=0000050000}', "");
    Expect(1, 126249, '\p{Is_Numeric_Value=5.000000000000000e+04}', "");
    Expect(0, 126249, '\p{^Is_Numeric_Value=5.000000000000000e+04}', "");
    Expect(0, 126249, '\P{Is_Numeric_Value=5.000000000000000e+04}', "");
    Expect(1, 126249, '\P{^Is_Numeric_Value=5.000000000000000e+04}', "");
    Expect(0, 126250, '\p{Is_Numeric_Value=5.000000000000000e+04}', "");
    Expect(1, 126250, '\p{^Is_Numeric_Value=5.000000000000000e+04}', "");
    Expect(1, 126250, '\P{Is_Numeric_Value=5.000000000000000e+04}', "");
    Expect(0, 126250, '\P{^Is_Numeric_Value=5.000000000000000e+04}', "");
    Error('\p{Is_Nv=:=_	050000}');
    Error('\P{Is_Nv=:=_	050000}');
    Expect(1, 126249, '\p{Is_Nv:	+50_00_0}', "");
    Expect(0, 126249, '\p{^Is_Nv:	+50_00_0}', "");
    Expect(0, 126249, '\P{Is_Nv:	+50_00_0}', "");
    Expect(1, 126249, '\P{^Is_Nv:	+50_00_0}', "");
    Expect(0, 126250, '\p{Is_Nv:	+50_00_0}', "");
    Expect(1, 126250, '\p{^Is_Nv:	+50_00_0}', "");
    Expect(1, 126250, '\P{Is_Nv:	+50_00_0}', "");
    Expect(0, 126250, '\P{^Is_Nv:	+50_00_0}', "");
    Expect(1, 126249, '\p{Is_Nv:   5.000000000000000e+04}', "");
    Expect(0, 126249, '\p{^Is_Nv:   5.000000000000000e+04}', "");
    Expect(0, 126249, '\P{Is_Nv:   5.000000000000000e+04}', "");
    Expect(1, 126249, '\P{^Is_Nv:   5.000000000000000e+04}', "");
    Expect(0, 126250, '\p{Is_Nv:   5.000000000000000e+04}', "");
    Expect(1, 126250, '\p{^Is_Nv:   5.000000000000000e+04}', "");
    Expect(1, 126250, '\P{Is_Nv:   5.000000000000000e+04}', "");
    Expect(0, 126250, '\P{^Is_Nv:   5.000000000000000e+04}', "");
    Error('\p{Numeric_Value=_/a/0_0_0_0_0_0_0_0_500000}');
    Error('\P{Numeric_Value=_/a/0_0_0_0_0_0_0_0_500000}');
    Expect(1, 68081, '\p{Numeric_Value=:\A500000\z:}', "");;
    Expect(0, 68082, '\p{Numeric_Value=:\A500000\z:}', "");;
    Expect(1, 68081, '\p{Numeric_Value=+000500000}', "");
    Expect(0, 68081, '\p{^Numeric_Value=+000500000}', "");
    Expect(0, 68081, '\P{Numeric_Value=+000500000}', "");
    Expect(1, 68081, '\P{^Numeric_Value=+000500000}', "");
    Expect(0, 68082, '\p{Numeric_Value=+000500000}', "");
    Expect(1, 68082, '\p{^Numeric_Value=+000500000}', "");
    Expect(1, 68082, '\P{Numeric_Value=+000500000}', "");
    Expect(0, 68082, '\P{^Numeric_Value=+000500000}', "");
    Expect(1, 68081, '\p{Numeric_Value: 5.000000000000000e+05}', "");
    Expect(0, 68081, '\p{^Numeric_Value: 5.000000000000000e+05}', "");
    Expect(0, 68081, '\P{Numeric_Value: 5.000000000000000e+05}', "");
    Expect(1, 68081, '\P{^Numeric_Value: 5.000000000000000e+05}', "");
    Expect(0, 68082, '\p{Numeric_Value: 5.000000000000000e+05}', "");
    Expect(1, 68082, '\p{^Numeric_Value: 5.000000000000000e+05}', "");
    Expect(1, 68082, '\P{Numeric_Value: 5.000000000000000e+05}', "");
    Expect(0, 68082, '\P{^Numeric_Value: 5.000000000000000e+05}', "");
    Error('\p{Nv=/a/-	+0_0_0_0_0_5_0_0_000}');
    Error('\P{Nv=/a/-	+0_0_0_0_0_5_0_0_000}');
    Expect(1, 68081, '\p{Nv=:\A500000\z:}', "");;
    Expect(0, 68082, '\p{Nv=:\A500000\z:}', "");;
    Expect(1, 68081, '\p{Nv=+0500000}', "");
    Expect(0, 68081, '\p{^Nv=+0500000}', "");
    Expect(0, 68081, '\P{Nv=+0500000}', "");
    Expect(1, 68081, '\P{^Nv=+0500000}', "");
    Expect(0, 68082, '\p{Nv=+0500000}', "");
    Expect(1, 68082, '\p{^Nv=+0500000}', "");
    Expect(1, 68082, '\P{Nv=+0500000}', "");
    Expect(0, 68082, '\P{^Nv=+0500000}', "");
    Expect(1, 68081, '\p{Nv=5.000000000000000e+05}', "");
    Expect(0, 68081, '\p{^Nv=5.000000000000000e+05}', "");
    Expect(0, 68081, '\P{Nv=5.000000000000000e+05}', "");
    Expect(1, 68081, '\P{^Nv=5.000000000000000e+05}', "");
    Expect(0, 68082, '\p{Nv=5.000000000000000e+05}', "");
    Expect(1, 68082, '\p{^Nv=5.000000000000000e+05}', "");
    Expect(1, 68082, '\P{Nv=5.000000000000000e+05}', "");
    Expect(0, 68082, '\P{^Nv=5.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value: -_00_00_50_00_00:=}');
    Error('\P{Is_Numeric_Value: -_00_00_50_00_00:=}');
    Expect(1, 68081, '\p{Is_Numeric_Value=0000000500000}', "");
    Expect(0, 68081, '\p{^Is_Numeric_Value=0000000500000}', "");
    Expect(0, 68081, '\P{Is_Numeric_Value=0000000500000}', "");
    Expect(1, 68081, '\P{^Is_Numeric_Value=0000000500000}', "");
    Expect(0, 68082, '\p{Is_Numeric_Value=0000000500000}', "");
    Expect(1, 68082, '\p{^Is_Numeric_Value=0000000500000}', "");
    Expect(1, 68082, '\P{Is_Numeric_Value=0000000500000}', "");
    Expect(0, 68082, '\P{^Is_Numeric_Value=0000000500000}', "");
    Expect(1, 68081, '\p{Is_Numeric_Value: 5.000000000000000e+05}', "");
    Expect(0, 68081, '\p{^Is_Numeric_Value: 5.000000000000000e+05}', "");
    Expect(0, 68081, '\P{Is_Numeric_Value: 5.000000000000000e+05}', "");
    Expect(1, 68081, '\P{^Is_Numeric_Value: 5.000000000000000e+05}', "");
    Expect(0, 68082, '\p{Is_Numeric_Value: 5.000000000000000e+05}', "");
    Expect(1, 68082, '\p{^Is_Numeric_Value: 5.000000000000000e+05}', "");
    Expect(1, 68082, '\P{Is_Numeric_Value: 5.000000000000000e+05}', "");
    Expect(0, 68082, '\P{^Is_Numeric_Value: 5.000000000000000e+05}', "");
    Error('\p{Is_Nv:	:=0500000}');
    Error('\P{Is_Nv:	:=0500000}');
    Expect(1, 68081, '\p{Is_Nv=+00500000}', "");
    Expect(0, 68081, '\p{^Is_Nv=+00500000}', "");
    Expect(0, 68081, '\P{Is_Nv=+00500000}', "");
    Expect(1, 68081, '\P{^Is_Nv=+00500000}', "");
    Expect(0, 68082, '\p{Is_Nv=+00500000}', "");
    Expect(1, 68082, '\p{^Is_Nv=+00500000}', "");
    Expect(1, 68082, '\P{Is_Nv=+00500000}', "");
    Expect(0, 68082, '\P{^Is_Nv=+00500000}', "");
    Expect(1, 68081, '\p{Is_Nv=5.000000000000000e+05}', "");
    Expect(0, 68081, '\p{^Is_Nv=5.000000000000000e+05}', "");
    Expect(0, 68081, '\P{Is_Nv=5.000000000000000e+05}', "");
    Expect(1, 68081, '\P{^Is_Nv=5.000000000000000e+05}', "");
    Expect(0, 68082, '\p{Is_Nv=5.000000000000000e+05}', "");
    Expect(1, 68082, '\p{^Is_Nv=5.000000000000000e+05}', "");
    Expect(1, 68082, '\P{Is_Nv=5.000000000000000e+05}', "");
    Expect(0, 68082, '\P{^Is_Nv=5.000000000000000e+05}', "");
    Error('\p{Numeric_Value=_:=006}');
    Error('\P{Numeric_Value=_:=006}');
    Expect(1, 133866, '\p{Numeric_Value=:\A6\z:}', "");;
    Expect(0, 133867, '\p{Numeric_Value=:\A6\z:}', "");;
    Expect(1, 133866, '\p{Numeric_Value:   0_0_0_0_0_0_0_006}', "");
    Expect(0, 133866, '\p{^Numeric_Value:   0_0_0_0_0_0_0_006}', "");
    Expect(0, 133866, '\P{Numeric_Value:   0_0_0_0_0_0_0_006}', "");
    Expect(1, 133866, '\P{^Numeric_Value:   0_0_0_0_0_0_0_006}', "");
    Expect(0, 133867, '\p{Numeric_Value:   0_0_0_0_0_0_0_006}', "");
    Expect(1, 133867, '\p{^Numeric_Value:   0_0_0_0_0_0_0_006}', "");
    Expect(1, 133867, '\P{Numeric_Value:   0_0_0_0_0_0_0_006}', "");
    Expect(0, 133867, '\P{^Numeric_Value:   0_0_0_0_0_0_0_006}', "");
    Expect(1, 133866, '\p{Numeric_Value=6.000000000000000e+00}', "");
    Expect(0, 133866, '\p{^Numeric_Value=6.000000000000000e+00}', "");
    Expect(0, 133866, '\P{Numeric_Value=6.000000000000000e+00}', "");
    Expect(1, 133866, '\P{^Numeric_Value=6.000000000000000e+00}', "");
    Expect(0, 133867, '\p{Numeric_Value=6.000000000000000e+00}', "");
    Expect(1, 133867, '\p{^Numeric_Value=6.000000000000000e+00}', "");
    Expect(1, 133867, '\P{Numeric_Value=6.000000000000000e+00}', "");
    Expect(0, 133867, '\P{^Numeric_Value=6.000000000000000e+00}', "");
    Error('\p{Nv=:=	_0_0_0_0_0006}');
    Error('\P{Nv=:=	_0_0_0_0_0006}');
    Expect(1, 133866, '\p{Nv=:\A6\z:}', "");;
    Expect(0, 133867, '\p{Nv=:\A6\z:}', "");;
    Expect(1, 133866, '\p{Nv=6}', "");
    Expect(0, 133866, '\p{^Nv=6}', "");
    Expect(0, 133866, '\P{Nv=6}', "");
    Expect(1, 133866, '\P{^Nv=6}', "");
    Expect(0, 133867, '\p{Nv=6}', "");
    Expect(1, 133867, '\p{^Nv=6}', "");
    Expect(1, 133867, '\P{Nv=6}', "");
    Expect(0, 133867, '\P{^Nv=6}', "");
    Expect(1, 133866, '\p{Nv=6.000000000000000e+00}', "");
    Expect(0, 133866, '\p{^Nv=6.000000000000000e+00}', "");
    Expect(0, 133866, '\P{Nv=6.000000000000000e+00}', "");
    Expect(1, 133866, '\P{^Nv=6.000000000000000e+00}', "");
    Expect(0, 133867, '\p{Nv=6.000000000000000e+00}', "");
    Expect(1, 133867, '\p{^Nv=6.000000000000000e+00}', "");
    Expect(1, 133867, '\P{Nv=6.000000000000000e+00}', "");
    Expect(0, 133867, '\P{^Nv=6.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value=	-0000000_6:=}');
    Error('\P{Is_Numeric_Value=	-0000000_6:=}');
    Expect(1, 133866, '\p{Is_Numeric_Value=00000006}', "");
    Expect(0, 133866, '\p{^Is_Numeric_Value=00000006}', "");
    Expect(0, 133866, '\P{Is_Numeric_Value=00000006}', "");
    Expect(1, 133866, '\P{^Is_Numeric_Value=00000006}', "");
    Expect(0, 133867, '\p{Is_Numeric_Value=00000006}', "");
    Expect(1, 133867, '\p{^Is_Numeric_Value=00000006}', "");
    Expect(1, 133867, '\P{Is_Numeric_Value=00000006}', "");
    Expect(0, 133867, '\P{^Is_Numeric_Value=00000006}', "");
    Expect(1, 133866, '\p{Is_Numeric_Value=6.000000000000000e+00}', "");
    Expect(0, 133866, '\p{^Is_Numeric_Value=6.000000000000000e+00}', "");
    Expect(0, 133866, '\P{Is_Numeric_Value=6.000000000000000e+00}', "");
    Expect(1, 133866, '\P{^Is_Numeric_Value=6.000000000000000e+00}', "");
    Expect(0, 133867, '\p{Is_Numeric_Value=6.000000000000000e+00}', "");
    Expect(1, 133867, '\p{^Is_Numeric_Value=6.000000000000000e+00}', "");
    Expect(1, 133867, '\P{Is_Numeric_Value=6.000000000000000e+00}', "");
    Expect(0, 133867, '\P{^Is_Numeric_Value=6.000000000000000e+00}', "");
    Error('\p{Is_Nv=:=_0006}');
    Error('\P{Is_Nv=:=_0006}');
    Expect(1, 133866, '\p{Is_Nv=00000006}', "");
    Expect(0, 133866, '\p{^Is_Nv=00000006}', "");
    Expect(0, 133866, '\P{Is_Nv=00000006}', "");
    Expect(1, 133866, '\P{^Is_Nv=00000006}', "");
    Expect(0, 133867, '\p{Is_Nv=00000006}', "");
    Expect(1, 133867, '\p{^Is_Nv=00000006}', "");
    Expect(1, 133867, '\P{Is_Nv=00000006}', "");
    Expect(0, 133867, '\P{^Is_Nv=00000006}', "");
    Expect(1, 133866, '\p{Is_Nv=6.000000000000000e+00}', "");
    Expect(0, 133866, '\p{^Is_Nv=6.000000000000000e+00}', "");
    Expect(0, 133866, '\P{Is_Nv=6.000000000000000e+00}', "");
    Expect(1, 133866, '\P{^Is_Nv=6.000000000000000e+00}', "");
    Expect(0, 133867, '\p{Is_Nv=6.000000000000000e+00}', "");
    Expect(1, 133867, '\p{^Is_Nv=6.000000000000000e+00}', "");
    Expect(1, 133867, '\P{Is_Nv=6.000000000000000e+00}', "");
    Expect(0, 133867, '\P{^Is_Nv=6.000000000000000e+00}', "");
    Error('\p{Numeric_Value: /a/	 +0000000060}');
    Error('\P{Numeric_Value: /a/	 +0000000060}');
    Expect(1, 126223, '\p{Numeric_Value=:\A60\z:}', "");;
    Expect(0, 126224, '\p{Numeric_Value=:\A60\z:}', "");;
    Expect(1, 126223, '\p{Numeric_Value:   +0000000060}', "");
    Expect(0, 126223, '\p{^Numeric_Value:   +0000000060}', "");
    Expect(0, 126223, '\P{Numeric_Value:   +0000000060}', "");
    Expect(1, 126223, '\P{^Numeric_Value:   +0000000060}', "");
    Expect(0, 126224, '\p{Numeric_Value:   +0000000060}', "");
    Expect(1, 126224, '\p{^Numeric_Value:   +0000000060}', "");
    Expect(1, 126224, '\P{Numeric_Value:   +0000000060}', "");
    Expect(0, 126224, '\P{^Numeric_Value:   +0000000060}', "");
    Expect(1, 126223, '\p{Numeric_Value: 6.000000000000000e+01}', "");
    Expect(0, 126223, '\p{^Numeric_Value: 6.000000000000000e+01}', "");
    Expect(0, 126223, '\P{Numeric_Value: 6.000000000000000e+01}', "");
    Expect(1, 126223, '\P{^Numeric_Value: 6.000000000000000e+01}', "");
    Expect(0, 126224, '\p{Numeric_Value: 6.000000000000000e+01}', "");
    Expect(1, 126224, '\p{^Numeric_Value: 6.000000000000000e+01}', "");
    Expect(1, 126224, '\P{Numeric_Value: 6.000000000000000e+01}', "");
    Expect(0, 126224, '\P{^Numeric_Value: 6.000000000000000e+01}', "");
    Error('\p{Nv:  _060:=}');
    Error('\P{Nv:  _060:=}');
    Expect(1, 126223, '\p{Nv=:\A60\z:}', "");;
    Expect(0, 126224, '\p{Nv=:\A60\z:}', "");;
    Expect(1, 126223, '\p{Nv=000060}', "");
    Expect(0, 126223, '\p{^Nv=000060}', "");
    Expect(0, 126223, '\P{Nv=000060}', "");
    Expect(1, 126223, '\P{^Nv=000060}', "");
    Expect(0, 126224, '\p{Nv=000060}', "");
    Expect(1, 126224, '\p{^Nv=000060}', "");
    Expect(1, 126224, '\P{Nv=000060}', "");
    Expect(0, 126224, '\P{^Nv=000060}', "");
    Expect(1, 126223, '\p{Nv=6.000000000000000e+01}', "");
    Expect(0, 126223, '\p{^Nv=6.000000000000000e+01}', "");
    Expect(0, 126223, '\P{Nv=6.000000000000000e+01}', "");
    Expect(1, 126223, '\P{^Nv=6.000000000000000e+01}', "");
    Expect(0, 126224, '\p{Nv=6.000000000000000e+01}', "");
    Expect(1, 126224, '\p{^Nv=6.000000000000000e+01}', "");
    Expect(1, 126224, '\P{Nv=6.000000000000000e+01}', "");
    Expect(0, 126224, '\P{^Nv=6.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=	+000060:=}');
    Error('\P{Is_Numeric_Value=	+000060:=}');
    Expect(1, 126223, '\p{Is_Numeric_Value=+060}', "");
    Expect(0, 126223, '\p{^Is_Numeric_Value=+060}', "");
    Expect(0, 126223, '\P{Is_Numeric_Value=+060}', "");
    Expect(1, 126223, '\P{^Is_Numeric_Value=+060}', "");
    Expect(0, 126224, '\p{Is_Numeric_Value=+060}', "");
    Expect(1, 126224, '\p{^Is_Numeric_Value=+060}', "");
    Expect(1, 126224, '\P{Is_Numeric_Value=+060}', "");
    Expect(0, 126224, '\P{^Is_Numeric_Value=+060}', "");
    Expect(1, 126223, '\p{Is_Numeric_Value=6.000000000000000e+01}', "");
    Expect(0, 126223, '\p{^Is_Numeric_Value=6.000000000000000e+01}', "");
    Expect(0, 126223, '\P{Is_Numeric_Value=6.000000000000000e+01}', "");
    Expect(1, 126223, '\P{^Is_Numeric_Value=6.000000000000000e+01}', "");
    Expect(0, 126224, '\p{Is_Numeric_Value=6.000000000000000e+01}', "");
    Expect(1, 126224, '\p{^Is_Numeric_Value=6.000000000000000e+01}', "");
    Expect(1, 126224, '\P{Is_Numeric_Value=6.000000000000000e+01}', "");
    Expect(0, 126224, '\P{^Is_Numeric_Value=6.000000000000000e+01}', "");
    Error('\p{Is_Nv=_:=060}');
    Error('\P{Is_Nv=_:=060}');
    Expect(1, 126223, '\p{Is_Nv:0_0_60}', "");
    Expect(0, 126223, '\p{^Is_Nv:0_0_60}', "");
    Expect(0, 126223, '\P{Is_Nv:0_0_60}', "");
    Expect(1, 126223, '\P{^Is_Nv:0_0_60}', "");
    Expect(0, 126224, '\p{Is_Nv:0_0_60}', "");
    Expect(1, 126224, '\p{^Is_Nv:0_0_60}', "");
    Expect(1, 126224, '\P{Is_Nv:0_0_60}', "");
    Expect(0, 126224, '\P{^Is_Nv:0_0_60}', "");
    Expect(1, 126223, '\p{Is_Nv=6.000000000000000e+01}', "");
    Expect(0, 126223, '\p{^Is_Nv=6.000000000000000e+01}', "");
    Expect(0, 126223, '\P{Is_Nv=6.000000000000000e+01}', "");
    Expect(1, 126223, '\P{^Is_Nv=6.000000000000000e+01}', "");
    Expect(0, 126224, '\p{Is_Nv=6.000000000000000e+01}', "");
    Expect(1, 126224, '\p{^Is_Nv=6.000000000000000e+01}', "");
    Expect(1, 126224, '\P{Is_Nv=6.000000000000000e+01}', "");
    Expect(0, 126224, '\P{^Is_Nv=6.000000000000000e+01}', "");
    Error('\p{Numeric_Value=-/a/0000600}');
    Error('\P{Numeric_Value=-/a/0000600}');
    Expect(1, 126265, '\p{Numeric_Value=:\A600\z:}', "");;
    Expect(0, 126266, '\p{Numeric_Value=:\A600\z:}', "");;
    Expect(1, 126265, '\p{Numeric_Value=0_0_0_6_00}', "");
    Expect(0, 126265, '\p{^Numeric_Value=0_0_0_6_00}', "");
    Expect(0, 126265, '\P{Numeric_Value=0_0_0_6_00}', "");
    Expect(1, 126265, '\P{^Numeric_Value=0_0_0_6_00}', "");
    Expect(0, 126266, '\p{Numeric_Value=0_0_0_6_00}', "");
    Expect(1, 126266, '\p{^Numeric_Value=0_0_0_6_00}', "");
    Expect(1, 126266, '\P{Numeric_Value=0_0_0_6_00}', "");
    Expect(0, 126266, '\P{^Numeric_Value=0_0_0_6_00}', "");
    Expect(1, 126265, '\p{Numeric_Value=6.000000000000000e+02}', "");
    Expect(0, 126265, '\p{^Numeric_Value=6.000000000000000e+02}', "");
    Expect(0, 126265, '\P{Numeric_Value=6.000000000000000e+02}', "");
    Expect(1, 126265, '\P{^Numeric_Value=6.000000000000000e+02}', "");
    Expect(0, 126266, '\p{Numeric_Value=6.000000000000000e+02}', "");
    Expect(1, 126266, '\p{^Numeric_Value=6.000000000000000e+02}', "");
    Expect(1, 126266, '\P{Numeric_Value=6.000000000000000e+02}', "");
    Expect(0, 126266, '\P{^Numeric_Value=6.000000000000000e+02}', "");
    Error('\p{Nv=	-00600:=}');
    Error('\P{Nv=	-00600:=}');
    Expect(1, 126265, '\p{Nv=:\A600\z:}', "");;
    Expect(0, 126266, '\p{Nv=:\A600\z:}', "");;
    Expect(1, 126265, '\p{Nv=600}', "");
    Expect(0, 126265, '\p{^Nv=600}', "");
    Expect(0, 126265, '\P{Nv=600}', "");
    Expect(1, 126265, '\P{^Nv=600}', "");
    Expect(0, 126266, '\p{Nv=600}', "");
    Expect(1, 126266, '\p{^Nv=600}', "");
    Expect(1, 126266, '\P{Nv=600}', "");
    Expect(0, 126266, '\P{^Nv=600}', "");
    Expect(1, 126265, '\p{Nv=6.000000000000000e+02}', "");
    Expect(0, 126265, '\p{^Nv=6.000000000000000e+02}', "");
    Expect(0, 126265, '\P{Nv=6.000000000000000e+02}', "");
    Expect(1, 126265, '\P{^Nv=6.000000000000000e+02}', "");
    Expect(0, 126266, '\p{Nv=6.000000000000000e+02}', "");
    Expect(1, 126266, '\p{^Nv=6.000000000000000e+02}', "");
    Expect(1, 126266, '\P{Nv=6.000000000000000e+02}', "");
    Expect(0, 126266, '\P{^Nv=6.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value=-_0000_0060_0/a/}');
    Error('\P{Is_Numeric_Value=-_0000_0060_0/a/}');
    Expect(1, 126265, '\p{Is_Numeric_Value=+0_0_0_0_0_0_0_0_0_600}', "");
    Expect(0, 126265, '\p{^Is_Numeric_Value=+0_0_0_0_0_0_0_0_0_600}', "");
    Expect(0, 126265, '\P{Is_Numeric_Value=+0_0_0_0_0_0_0_0_0_600}', "");
    Expect(1, 126265, '\P{^Is_Numeric_Value=+0_0_0_0_0_0_0_0_0_600}', "");
    Expect(0, 126266, '\p{Is_Numeric_Value=+0_0_0_0_0_0_0_0_0_600}', "");
    Expect(1, 126266, '\p{^Is_Numeric_Value=+0_0_0_0_0_0_0_0_0_600}', "");
    Expect(1, 126266, '\P{Is_Numeric_Value=+0_0_0_0_0_0_0_0_0_600}', "");
    Expect(0, 126266, '\P{^Is_Numeric_Value=+0_0_0_0_0_0_0_0_0_600}', "");
    Expect(1, 126265, '\p{Is_Numeric_Value=6.000000000000000e+02}', "");
    Expect(0, 126265, '\p{^Is_Numeric_Value=6.000000000000000e+02}', "");
    Expect(0, 126265, '\P{Is_Numeric_Value=6.000000000000000e+02}', "");
    Expect(1, 126265, '\P{^Is_Numeric_Value=6.000000000000000e+02}', "");
    Expect(0, 126266, '\p{Is_Numeric_Value=6.000000000000000e+02}', "");
    Expect(1, 126266, '\p{^Is_Numeric_Value=6.000000000000000e+02}', "");
    Expect(1, 126266, '\P{Is_Numeric_Value=6.000000000000000e+02}', "");
    Expect(0, 126266, '\P{^Is_Numeric_Value=6.000000000000000e+02}', "");
    Error('\p{Is_Nv:    0000000600/a/}');
    Error('\P{Is_Nv:    0000000600/a/}');
    Expect(1, 126265, '\p{Is_Nv=+00_06_00}', "");
    Expect(0, 126265, '\p{^Is_Nv=+00_06_00}', "");
    Expect(0, 126265, '\P{Is_Nv=+00_06_00}', "");
    Expect(1, 126265, '\P{^Is_Nv=+00_06_00}', "");
    Expect(0, 126266, '\p{Is_Nv=+00_06_00}', "");
    Expect(1, 126266, '\p{^Is_Nv=+00_06_00}', "");
    Expect(1, 126266, '\P{Is_Nv=+00_06_00}', "");
    Expect(0, 126266, '\P{^Is_Nv=+00_06_00}', "");
    Expect(1, 126265, '\p{Is_Nv=6.000000000000000e+02}', "");
    Expect(0, 126265, '\p{^Is_Nv=6.000000000000000e+02}', "");
    Expect(0, 126265, '\P{Is_Nv=6.000000000000000e+02}', "");
    Expect(1, 126265, '\P{^Is_Nv=6.000000000000000e+02}', "");
    Expect(0, 126266, '\p{Is_Nv=6.000000000000000e+02}', "");
    Expect(1, 126266, '\p{^Is_Nv=6.000000000000000e+02}', "");
    Expect(1, 126266, '\P{Is_Nv=6.000000000000000e+02}', "");
    Expect(0, 126266, '\P{^Is_Nv=6.000000000000000e+02}', "");
    Error('\p{Numeric_Value:	  0000_0060_00/a/}');
    Error('\P{Numeric_Value:	  0000_0060_00/a/}');
    Expect(1, 126241, '\p{Numeric_Value=:\A6000\z:}', "");;
    Expect(0, 126242, '\p{Numeric_Value=:\A6000\z:}', "");;
    Expect(1, 126241, '\p{Numeric_Value=00000006000}', "");
    Expect(0, 126241, '\p{^Numeric_Value=00000006000}', "");
    Expect(0, 126241, '\P{Numeric_Value=00000006000}', "");
    Expect(1, 126241, '\P{^Numeric_Value=00000006000}', "");
    Expect(0, 126242, '\p{Numeric_Value=00000006000}', "");
    Expect(1, 126242, '\p{^Numeric_Value=00000006000}', "");
    Expect(1, 126242, '\P{Numeric_Value=00000006000}', "");
    Expect(0, 126242, '\P{^Numeric_Value=00000006000}', "");
    Expect(1, 126241, '\p{Numeric_Value:	6.000000000000000e+03}', "");
    Expect(0, 126241, '\p{^Numeric_Value:	6.000000000000000e+03}', "");
    Expect(0, 126241, '\P{Numeric_Value:	6.000000000000000e+03}', "");
    Expect(1, 126241, '\P{^Numeric_Value:	6.000000000000000e+03}', "");
    Expect(0, 126242, '\p{Numeric_Value:	6.000000000000000e+03}', "");
    Expect(1, 126242, '\p{^Numeric_Value:	6.000000000000000e+03}', "");
    Expect(1, 126242, '\P{Numeric_Value:	6.000000000000000e+03}', "");
    Expect(0, 126242, '\P{^Numeric_Value:	6.000000000000000e+03}', "");
    Error('\p{Nv=	-06000:=}');
    Error('\P{Nv=	-06000:=}');
    Expect(1, 126241, '\p{Nv=:\A6000\z:}', "");;
    Expect(0, 126242, '\p{Nv=:\A6000\z:}', "");;
    Expect(1, 126241, '\p{Nv=00000006000}', "");
    Expect(0, 126241, '\p{^Nv=00000006000}', "");
    Expect(0, 126241, '\P{Nv=00000006000}', "");
    Expect(1, 126241, '\P{^Nv=00000006000}', "");
    Expect(0, 126242, '\p{Nv=00000006000}', "");
    Expect(1, 126242, '\p{^Nv=00000006000}', "");
    Expect(1, 126242, '\P{Nv=00000006000}', "");
    Expect(0, 126242, '\P{^Nv=00000006000}', "");
    Expect(1, 126241, '\p{Nv=6.000000000000000e+03}', "");
    Expect(0, 126241, '\p{^Nv=6.000000000000000e+03}', "");
    Expect(0, 126241, '\P{Nv=6.000000000000000e+03}', "");
    Expect(1, 126241, '\P{^Nv=6.000000000000000e+03}', "");
    Expect(0, 126242, '\p{Nv=6.000000000000000e+03}', "");
    Expect(1, 126242, '\p{^Nv=6.000000000000000e+03}', "");
    Expect(1, 126242, '\P{Nv=6.000000000000000e+03}', "");
    Expect(0, 126242, '\P{^Nv=6.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value=:=+0_0_0_0_0_0_0_0_06000}');
    Error('\P{Is_Numeric_Value=:=+0_0_0_0_0_0_0_0_06000}');
    Expect(1, 126241, '\p{Is_Numeric_Value=000600_0}', "");
    Expect(0, 126241, '\p{^Is_Numeric_Value=000600_0}', "");
    Expect(0, 126241, '\P{Is_Numeric_Value=000600_0}', "");
    Expect(1, 126241, '\P{^Is_Numeric_Value=000600_0}', "");
    Expect(0, 126242, '\p{Is_Numeric_Value=000600_0}', "");
    Expect(1, 126242, '\p{^Is_Numeric_Value=000600_0}', "");
    Expect(1, 126242, '\P{Is_Numeric_Value=000600_0}', "");
    Expect(0, 126242, '\P{^Is_Numeric_Value=000600_0}', "");
    Expect(1, 126241, '\p{Is_Numeric_Value=6.000000000000000e+03}', "");
    Expect(0, 126241, '\p{^Is_Numeric_Value=6.000000000000000e+03}', "");
    Expect(0, 126241, '\P{Is_Numeric_Value=6.000000000000000e+03}', "");
    Expect(1, 126241, '\P{^Is_Numeric_Value=6.000000000000000e+03}', "");
    Expect(0, 126242, '\p{Is_Numeric_Value=6.000000000000000e+03}', "");
    Expect(1, 126242, '\p{^Is_Numeric_Value=6.000000000000000e+03}', "");
    Expect(1, 126242, '\P{Is_Numeric_Value=6.000000000000000e+03}', "");
    Expect(0, 126242, '\P{^Is_Numeric_Value=6.000000000000000e+03}', "");
    Error('\p{Is_Nv= /a/0_0_0_0_0_06000}');
    Error('\P{Is_Nv= /a/0_0_0_0_0_06000}');
    Expect(1, 126241, '\p{Is_Nv=+000000006000}', "");
    Expect(0, 126241, '\p{^Is_Nv=+000000006000}', "");
    Expect(0, 126241, '\P{Is_Nv=+000000006000}', "");
    Expect(1, 126241, '\P{^Is_Nv=+000000006000}', "");
    Expect(0, 126242, '\p{Is_Nv=+000000006000}', "");
    Expect(1, 126242, '\p{^Is_Nv=+000000006000}', "");
    Expect(1, 126242, '\P{Is_Nv=+000000006000}', "");
    Expect(0, 126242, '\P{^Is_Nv=+000000006000}', "");
    Expect(1, 126241, '\p{Is_Nv:6.000000000000000e+03}', "");
    Expect(0, 126241, '\p{^Is_Nv:6.000000000000000e+03}', "");
    Expect(0, 126241, '\P{Is_Nv:6.000000000000000e+03}', "");
    Expect(1, 126241, '\P{^Is_Nv:6.000000000000000e+03}', "");
    Expect(0, 126242, '\p{Is_Nv:6.000000000000000e+03}', "");
    Expect(1, 126242, '\p{^Is_Nv:6.000000000000000e+03}', "");
    Expect(1, 126242, '\P{Is_Nv:6.000000000000000e+03}', "");
    Expect(0, 126242, '\P{^Is_Nv:6.000000000000000e+03}', "");
    Error('\p{Numeric_Value=/a/		0_0_0_6_0_000}');
    Error('\P{Numeric_Value=/a/		0_0_0_6_0_000}');
    Expect(1, 126250, '\p{Numeric_Value=:\A60000\z:}', "");;
    Expect(0, 126251, '\p{Numeric_Value=:\A60000\z:}', "");;
    Expect(1, 126250, '\p{Numeric_Value=000000060000}', "");
    Expect(0, 126250, '\p{^Numeric_Value=000000060000}', "");
    Expect(0, 126250, '\P{Numeric_Value=000000060000}', "");
    Expect(1, 126250, '\P{^Numeric_Value=000000060000}', "");
    Expect(0, 126251, '\p{Numeric_Value=000000060000}', "");
    Expect(1, 126251, '\p{^Numeric_Value=000000060000}', "");
    Expect(1, 126251, '\P{Numeric_Value=000000060000}', "");
    Expect(0, 126251, '\P{^Numeric_Value=000000060000}', "");
    Expect(1, 126250, '\p{Numeric_Value: 6.000000000000000e+04}', "");
    Expect(0, 126250, '\p{^Numeric_Value: 6.000000000000000e+04}', "");
    Expect(0, 126250, '\P{Numeric_Value: 6.000000000000000e+04}', "");
    Expect(1, 126250, '\P{^Numeric_Value: 6.000000000000000e+04}', "");
    Expect(0, 126251, '\p{Numeric_Value: 6.000000000000000e+04}', "");
    Expect(1, 126251, '\p{^Numeric_Value: 6.000000000000000e+04}', "");
    Expect(1, 126251, '\P{Numeric_Value: 6.000000000000000e+04}', "");
    Expect(0, 126251, '\P{^Numeric_Value: 6.000000000000000e+04}', "");
    Error('\p{Nv=0000060000:=}');
    Error('\P{Nv=0000060000:=}');
    Expect(1, 126250, '\p{Nv=:\A60000\z:}', "");;
    Expect(0, 126251, '\p{Nv=:\A60000\z:}', "");;
    Expect(1, 126250, '\p{Nv=60000}', "");
    Expect(0, 126250, '\p{^Nv=60000}', "");
    Expect(0, 126250, '\P{Nv=60000}', "");
    Expect(1, 126250, '\P{^Nv=60000}', "");
    Expect(0, 126251, '\p{Nv=60000}', "");
    Expect(1, 126251, '\p{^Nv=60000}', "");
    Expect(1, 126251, '\P{Nv=60000}', "");
    Expect(0, 126251, '\P{^Nv=60000}', "");
    Expect(1, 126250, '\p{Nv=6.000000000000000e+04}', "");
    Expect(0, 126250, '\p{^Nv=6.000000000000000e+04}', "");
    Expect(0, 126250, '\P{Nv=6.000000000000000e+04}', "");
    Expect(1, 126250, '\P{^Nv=6.000000000000000e+04}', "");
    Expect(0, 126251, '\p{Nv=6.000000000000000e+04}', "");
    Expect(1, 126251, '\p{^Nv=6.000000000000000e+04}', "");
    Expect(1, 126251, '\P{Nv=6.000000000000000e+04}', "");
    Expect(0, 126251, '\P{^Nv=6.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value=:= -00_00_60_00_0}');
    Error('\P{Is_Numeric_Value=:= -00_00_60_00_0}');
    Expect(1, 126250, '\p{Is_Numeric_Value=+06000_0}', "");
    Expect(0, 126250, '\p{^Is_Numeric_Value=+06000_0}', "");
    Expect(0, 126250, '\P{Is_Numeric_Value=+06000_0}', "");
    Expect(1, 126250, '\P{^Is_Numeric_Value=+06000_0}', "");
    Expect(0, 126251, '\p{Is_Numeric_Value=+06000_0}', "");
    Expect(1, 126251, '\p{^Is_Numeric_Value=+06000_0}', "");
    Expect(1, 126251, '\P{Is_Numeric_Value=+06000_0}', "");
    Expect(0, 126251, '\P{^Is_Numeric_Value=+06000_0}', "");
    Expect(1, 126250, '\p{Is_Numeric_Value: 6.000000000000000e+04}', "");
    Expect(0, 126250, '\p{^Is_Numeric_Value: 6.000000000000000e+04}', "");
    Expect(0, 126250, '\P{Is_Numeric_Value: 6.000000000000000e+04}', "");
    Expect(1, 126250, '\P{^Is_Numeric_Value: 6.000000000000000e+04}', "");
    Expect(0, 126251, '\p{Is_Numeric_Value: 6.000000000000000e+04}', "");
    Expect(1, 126251, '\p{^Is_Numeric_Value: 6.000000000000000e+04}', "");
    Expect(1, 126251, '\P{Is_Numeric_Value: 6.000000000000000e+04}', "");
    Expect(0, 126251, '\P{^Is_Numeric_Value: 6.000000000000000e+04}', "");
    Error('\p{Is_Nv=	:=000060000}');
    Error('\P{Is_Nv=	:=000060000}');
    Expect(1, 126250, '\p{Is_Nv=60000}', "");
    Expect(0, 126250, '\p{^Is_Nv=60000}', "");
    Expect(0, 126250, '\P{Is_Nv=60000}', "");
    Expect(1, 126250, '\P{^Is_Nv=60000}', "");
    Expect(0, 126251, '\p{Is_Nv=60000}', "");
    Expect(1, 126251, '\p{^Is_Nv=60000}', "");
    Expect(1, 126251, '\P{Is_Nv=60000}', "");
    Expect(0, 126251, '\P{^Is_Nv=60000}', "");
    Expect(1, 126250, '\p{Is_Nv=6.000000000000000e+04}', "");
    Expect(0, 126250, '\p{^Is_Nv=6.000000000000000e+04}', "");
    Expect(0, 126250, '\P{Is_Nv=6.000000000000000e+04}', "");
    Expect(1, 126250, '\P{^Is_Nv=6.000000000000000e+04}', "");
    Expect(0, 126251, '\p{Is_Nv=6.000000000000000e+04}', "");
    Expect(1, 126251, '\p{^Is_Nv=6.000000000000000e+04}', "");
    Expect(1, 126251, '\P{Is_Nv=6.000000000000000e+04}', "");
    Expect(0, 126251, '\P{^Is_Nv=6.000000000000000e+04}', "");
    Error('\p{Numeric_Value=/a/_600000}');
    Error('\P{Numeric_Value=/a/_600000}');
    Expect(1, 68082, '\p{Numeric_Value=:\A600000\z:}', "");;
    Expect(0, 68083, '\p{Numeric_Value=:\A600000\z:}', "");;
    Expect(1, 68082, '\p{Numeric_Value=0600000}', "");
    Expect(0, 68082, '\p{^Numeric_Value=0600000}', "");
    Expect(0, 68082, '\P{Numeric_Value=0600000}', "");
    Expect(1, 68082, '\P{^Numeric_Value=0600000}', "");
    Expect(0, 68083, '\p{Numeric_Value=0600000}', "");
    Expect(1, 68083, '\p{^Numeric_Value=0600000}', "");
    Expect(1, 68083, '\P{Numeric_Value=0600000}', "");
    Expect(0, 68083, '\P{^Numeric_Value=0600000}', "");
    Expect(1, 68082, '\p{Numeric_Value=6.000000000000000e+05}', "");
    Expect(0, 68082, '\p{^Numeric_Value=6.000000000000000e+05}', "");
    Expect(0, 68082, '\P{Numeric_Value=6.000000000000000e+05}', "");
    Expect(1, 68082, '\P{^Numeric_Value=6.000000000000000e+05}', "");
    Expect(0, 68083, '\p{Numeric_Value=6.000000000000000e+05}', "");
    Expect(1, 68083, '\p{^Numeric_Value=6.000000000000000e+05}', "");
    Expect(1, 68083, '\P{Numeric_Value=6.000000000000000e+05}', "");
    Expect(0, 68083, '\P{^Numeric_Value=6.000000000000000e+05}', "");
    Error('\p{Nv=	/a/0600000}');
    Error('\P{Nv=	/a/0600000}');
    Expect(1, 68082, '\p{Nv=:\A600000\z:}', "");;
    Expect(0, 68083, '\p{Nv=:\A600000\z:}', "");;
    Expect(1, 68082, '\p{Nv=+600000}', "");
    Expect(0, 68082, '\p{^Nv=+600000}', "");
    Expect(0, 68082, '\P{Nv=+600000}', "");
    Expect(1, 68082, '\P{^Nv=+600000}', "");
    Expect(0, 68083, '\p{Nv=+600000}', "");
    Expect(1, 68083, '\p{^Nv=+600000}', "");
    Expect(1, 68083, '\P{Nv=+600000}', "");
    Expect(0, 68083, '\P{^Nv=+600000}', "");
    Expect(1, 68082, '\p{Nv:6.000000000000000e+05}', "");
    Expect(0, 68082, '\p{^Nv:6.000000000000000e+05}', "");
    Expect(0, 68082, '\P{Nv:6.000000000000000e+05}', "");
    Expect(1, 68082, '\P{^Nv:6.000000000000000e+05}', "");
    Expect(0, 68083, '\p{Nv:6.000000000000000e+05}', "");
    Expect(1, 68083, '\p{^Nv:6.000000000000000e+05}', "");
    Expect(1, 68083, '\P{Nv:6.000000000000000e+05}', "");
    Expect(0, 68083, '\P{^Nv:6.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value=_00_00_60_00_00:=}');
    Error('\P{Is_Numeric_Value=_00_00_60_00_00:=}');
    Expect(1, 68082, '\p{Is_Numeric_Value=0000000600000}', "");
    Expect(0, 68082, '\p{^Is_Numeric_Value=0000000600000}', "");
    Expect(0, 68082, '\P{Is_Numeric_Value=0000000600000}', "");
    Expect(1, 68082, '\P{^Is_Numeric_Value=0000000600000}', "");
    Expect(0, 68083, '\p{Is_Numeric_Value=0000000600000}', "");
    Expect(1, 68083, '\p{^Is_Numeric_Value=0000000600000}', "");
    Expect(1, 68083, '\P{Is_Numeric_Value=0000000600000}', "");
    Expect(0, 68083, '\P{^Is_Numeric_Value=0000000600000}', "");
    Expect(1, 68082, '\p{Is_Numeric_Value=6.000000000000000e+05}', "");
    Expect(0, 68082, '\p{^Is_Numeric_Value=6.000000000000000e+05}', "");
    Expect(0, 68082, '\P{Is_Numeric_Value=6.000000000000000e+05}', "");
    Expect(1, 68082, '\P{^Is_Numeric_Value=6.000000000000000e+05}', "");
    Expect(0, 68083, '\p{Is_Numeric_Value=6.000000000000000e+05}', "");
    Expect(1, 68083, '\p{^Is_Numeric_Value=6.000000000000000e+05}', "");
    Expect(1, 68083, '\P{Is_Numeric_Value=6.000000000000000e+05}', "");
    Expect(0, 68083, '\P{^Is_Numeric_Value=6.000000000000000e+05}', "");
    Error('\p{Is_Nv=/a/__+0000000600000}');
    Error('\P{Is_Nv=/a/__+0000000600000}');
    Expect(1, 68082, '\p{Is_Nv=+0_0_0_0_0_0_0_0_6_0_0_000}', "");
    Expect(0, 68082, '\p{^Is_Nv=+0_0_0_0_0_0_0_0_6_0_0_000}', "");
    Expect(0, 68082, '\P{Is_Nv=+0_0_0_0_0_0_0_0_6_0_0_000}', "");
    Expect(1, 68082, '\P{^Is_Nv=+0_0_0_0_0_0_0_0_6_0_0_000}', "");
    Expect(0, 68083, '\p{Is_Nv=+0_0_0_0_0_0_0_0_6_0_0_000}', "");
    Expect(1, 68083, '\p{^Is_Nv=+0_0_0_0_0_0_0_0_6_0_0_000}', "");
    Expect(1, 68083, '\P{Is_Nv=+0_0_0_0_0_0_0_0_6_0_0_000}', "");
    Expect(0, 68083, '\P{^Is_Nv=+0_0_0_0_0_0_0_0_6_0_0_000}', "");
    Expect(1, 68082, '\p{Is_Nv=6.000000000000000e+05}', "");
    Expect(0, 68082, '\p{^Is_Nv=6.000000000000000e+05}', "");
    Expect(0, 68082, '\P{Is_Nv=6.000000000000000e+05}', "");
    Expect(1, 68082, '\P{^Is_Nv=6.000000000000000e+05}', "");
    Expect(0, 68083, '\p{Is_Nv=6.000000000000000e+05}', "");
    Expect(1, 68083, '\p{^Is_Nv=6.000000000000000e+05}', "");
    Expect(1, 68083, '\P{Is_Nv=6.000000000000000e+05}', "");
    Expect(0, 68083, '\P{^Is_Nv=6.000000000000000e+05}', "");
    Error('\p{Numeric_Value=	 0007/a/}');
    Error('\P{Numeric_Value=	 0007/a/}');
    Expect(1, 131073, '\p{Numeric_Value=:\A7\z:}', "");;
    Expect(0, 131074, '\p{Numeric_Value=:\A7\z:}', "");;
    Expect(1, 131073, '\p{Numeric_Value=+007}', "");
    Expect(0, 131073, '\p{^Numeric_Value=+007}', "");
    Expect(0, 131073, '\P{Numeric_Value=+007}', "");
    Expect(1, 131073, '\P{^Numeric_Value=+007}', "");
    Expect(0, 131074, '\p{Numeric_Value=+007}', "");
    Expect(1, 131074, '\p{^Numeric_Value=+007}', "");
    Expect(1, 131074, '\P{Numeric_Value=+007}', "");
    Expect(0, 131074, '\P{^Numeric_Value=+007}', "");
    Expect(1, 131073, '\p{Numeric_Value=7.000000000000000e+00}', "");
    Expect(0, 131073, '\p{^Numeric_Value=7.000000000000000e+00}', "");
    Expect(0, 131073, '\P{Numeric_Value=7.000000000000000e+00}', "");
    Expect(1, 131073, '\P{^Numeric_Value=7.000000000000000e+00}', "");
    Expect(0, 131074, '\p{Numeric_Value=7.000000000000000e+00}', "");
    Expect(1, 131074, '\p{^Numeric_Value=7.000000000000000e+00}', "");
    Expect(1, 131074, '\P{Numeric_Value=7.000000000000000e+00}', "");
    Expect(0, 131074, '\P{^Numeric_Value=7.000000000000000e+00}', "");
    Error('\p{Nv=-/a/0007}');
    Error('\P{Nv=-/a/0007}');
    Expect(1, 131073, '\p{Nv=:\A7\z:}', "");;
    Expect(0, 131074, '\p{Nv=:\A7\z:}', "");;
    Expect(1, 131073, '\p{Nv:	7}', "");
    Expect(0, 131073, '\p{^Nv:	7}', "");
    Expect(0, 131073, '\P{Nv:	7}', "");
    Expect(1, 131073, '\P{^Nv:	7}', "");
    Expect(0, 131074, '\p{Nv:	7}', "");
    Expect(1, 131074, '\p{^Nv:	7}', "");
    Expect(1, 131074, '\P{Nv:	7}', "");
    Expect(0, 131074, '\P{^Nv:	7}', "");
    Expect(1, 131073, '\p{Nv=7.000000000000000e+00}', "");
    Expect(0, 131073, '\p{^Nv=7.000000000000000e+00}', "");
    Expect(0, 131073, '\P{Nv=7.000000000000000e+00}', "");
    Expect(1, 131073, '\P{^Nv=7.000000000000000e+00}', "");
    Expect(0, 131074, '\p{Nv=7.000000000000000e+00}', "");
    Expect(1, 131074, '\p{^Nv=7.000000000000000e+00}', "");
    Expect(1, 131074, '\P{Nv=7.000000000000000e+00}', "");
    Expect(0, 131074, '\P{^Nv=7.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value:			0000007:=}');
    Error('\P{Is_Numeric_Value:			0000007:=}');
    Expect(1, 131073, '\p{Is_Numeric_Value=+007}', "");
    Expect(0, 131073, '\p{^Is_Numeric_Value=+007}', "");
    Expect(0, 131073, '\P{Is_Numeric_Value=+007}', "");
    Expect(1, 131073, '\P{^Is_Numeric_Value=+007}', "");
    Expect(0, 131074, '\p{Is_Numeric_Value=+007}', "");
    Expect(1, 131074, '\p{^Is_Numeric_Value=+007}', "");
    Expect(1, 131074, '\P{Is_Numeric_Value=+007}', "");
    Expect(0, 131074, '\P{^Is_Numeric_Value=+007}', "");
    Expect(1, 131073, '\p{Is_Numeric_Value=7.000000000000000e+00}', "");
    Expect(0, 131073, '\p{^Is_Numeric_Value=7.000000000000000e+00}', "");
    Expect(0, 131073, '\P{Is_Numeric_Value=7.000000000000000e+00}', "");
    Expect(1, 131073, '\P{^Is_Numeric_Value=7.000000000000000e+00}', "");
    Expect(0, 131074, '\p{Is_Numeric_Value=7.000000000000000e+00}', "");
    Expect(1, 131074, '\p{^Is_Numeric_Value=7.000000000000000e+00}', "");
    Expect(1, 131074, '\P{Is_Numeric_Value=7.000000000000000e+00}', "");
    Expect(0, 131074, '\P{^Is_Numeric_Value=7.000000000000000e+00}', "");
    Error('\p{Is_Nv=_07:=}');
    Error('\P{Is_Nv=_07:=}');
    Expect(1, 131073, '\p{Is_Nv=0007}', "");
    Expect(0, 131073, '\p{^Is_Nv=0007}', "");
    Expect(0, 131073, '\P{Is_Nv=0007}', "");
    Expect(1, 131073, '\P{^Is_Nv=0007}', "");
    Expect(0, 131074, '\p{Is_Nv=0007}', "");
    Expect(1, 131074, '\p{^Is_Nv=0007}', "");
    Expect(1, 131074, '\P{Is_Nv=0007}', "");
    Expect(0, 131074, '\P{^Is_Nv=0007}', "");
    Expect(1, 131073, '\p{Is_Nv=7.000000000000000e+00}', "");
    Expect(0, 131073, '\p{^Is_Nv=7.000000000000000e+00}', "");
    Expect(0, 131073, '\P{Is_Nv=7.000000000000000e+00}', "");
    Expect(1, 131073, '\P{^Is_Nv=7.000000000000000e+00}', "");
    Expect(0, 131074, '\p{Is_Nv=7.000000000000000e+00}', "");
    Expect(1, 131074, '\p{^Is_Nv=7.000000000000000e+00}', "");
    Expect(1, 131074, '\P{Is_Nv=7.000000000000000e+00}', "");
    Expect(0, 131074, '\P{^Is_Nv=7.000000000000000e+00}', "");
    Error('\p{Numeric_Value= 007/00000012/a/}');
    Error('\P{Numeric_Value= 007/00000012/a/}');
    Expect(1, 68092, '\p{Numeric_Value=:\A7/12\z:}', "");;
    Expect(0, 68093, '\p{Numeric_Value=:\A7/12\z:}', "");;
    Expect(1, 68092, '\p{Numeric_Value:0007/0012}', "");
    Expect(0, 68092, '\p{^Numeric_Value:0007/0012}', "");
    Expect(0, 68092, '\P{Numeric_Value:0007/0012}', "");
    Expect(1, 68092, '\P{^Numeric_Value:0007/0012}', "");
    Expect(0, 68093, '\p{Numeric_Value:0007/0012}', "");
    Expect(1, 68093, '\p{^Numeric_Value:0007/0012}', "");
    Expect(1, 68093, '\P{Numeric_Value:0007/0012}', "");
    Expect(0, 68093, '\P{^Numeric_Value:0007/0012}', "");
    Expect(1, 68092, '\p{Numeric_Value=420/720}', "");
    Expect(0, 68092, '\p{^Numeric_Value=420/720}', "");
    Expect(0, 68092, '\P{Numeric_Value=420/720}', "");
    Expect(1, 68092, '\P{^Numeric_Value=420/720}', "");
    Expect(0, 68093, '\p{Numeric_Value=420/720}', "");
    Expect(1, 68093, '\p{^Numeric_Value=420/720}', "");
    Expect(1, 68093, '\P{Numeric_Value=420/720}', "");
    Expect(0, 68093, '\P{^Numeric_Value=420/720}', "");
    Error('\p{Numeric_Value=5.8e-01}');
    Error('\P{Numeric_Value=5.8e-01}');
    Expect(1, 68092, '\p{Numeric_Value=5.83e-01}', "");
    Expect(0, 68092, '\p{^Numeric_Value=5.83e-01}', "");
    Expect(0, 68092, '\P{Numeric_Value=5.83e-01}', "");
    Expect(1, 68092, '\P{^Numeric_Value=5.83e-01}', "");
    Expect(0, 68093, '\p{Numeric_Value=5.83e-01}', "");
    Expect(1, 68093, '\p{^Numeric_Value=5.83e-01}', "");
    Expect(1, 68093, '\P{Numeric_Value=5.83e-01}', "");
    Expect(0, 68093, '\P{^Numeric_Value=5.83e-01}', "");
    Error('\p{Numeric_Value=0.58}');
    Error('\P{Numeric_Value=0.58}');
    Expect(1, 68092, '\p{Numeric_Value:	5.833e-01}', "");
    Expect(0, 68092, '\p{^Numeric_Value:	5.833e-01}', "");
    Expect(0, 68092, '\P{Numeric_Value:	5.833e-01}', "");
    Expect(1, 68092, '\P{^Numeric_Value:	5.833e-01}', "");
    Expect(0, 68093, '\p{Numeric_Value:	5.833e-01}', "");
    Expect(1, 68093, '\p{^Numeric_Value:	5.833e-01}', "");
    Expect(1, 68093, '\P{Numeric_Value:	5.833e-01}', "");
    Expect(0, 68093, '\P{^Numeric_Value:	5.833e-01}', "");
    Expect(1, 68092, '\p{Numeric_Value=0.583}', "");
    Expect(0, 68092, '\p{^Numeric_Value=0.583}', "");
    Expect(0, 68092, '\P{Numeric_Value=0.583}', "");
    Expect(1, 68092, '\P{^Numeric_Value=0.583}', "");
    Expect(0, 68093, '\p{Numeric_Value=0.583}', "");
    Expect(1, 68093, '\p{^Numeric_Value=0.583}', "");
    Expect(1, 68093, '\P{Numeric_Value=0.583}', "");
    Expect(0, 68093, '\P{^Numeric_Value=0.583}', "");
    Expect(1, 68092, '\p{Numeric_Value=5.8333e-01}', "");
    Expect(0, 68092, '\p{^Numeric_Value=5.8333e-01}', "");
    Expect(0, 68092, '\P{Numeric_Value=5.8333e-01}', "");
    Expect(1, 68092, '\P{^Numeric_Value=5.8333e-01}', "");
    Expect(0, 68093, '\p{Numeric_Value=5.8333e-01}', "");
    Expect(1, 68093, '\p{^Numeric_Value=5.8333e-01}', "");
    Expect(1, 68093, '\P{Numeric_Value=5.8333e-01}', "");
    Expect(0, 68093, '\P{^Numeric_Value=5.8333e-01}', "");
    Expect(1, 68092, '\p{Numeric_Value=0.5833}', "");
    Expect(0, 68092, '\p{^Numeric_Value=0.5833}', "");
    Expect(0, 68092, '\P{Numeric_Value=0.5833}', "");
    Expect(1, 68092, '\P{^Numeric_Value=0.5833}', "");
    Expect(0, 68093, '\p{Numeric_Value=0.5833}', "");
    Expect(1, 68093, '\p{^Numeric_Value=0.5833}', "");
    Expect(1, 68093, '\P{Numeric_Value=0.5833}', "");
    Expect(0, 68093, '\P{^Numeric_Value=0.5833}', "");
    Error('\p{Nv=-/a/+0000007/012}');
    Error('\P{Nv=-/a/+0000007/012}');
    Expect(1, 68092, '\p{Nv=:\A7/12\z:}', "");;
    Expect(0, 68093, '\p{Nv=:\A7/12\z:}', "");;
    Expect(1, 68092, '\p{Nv: 7/00000012}', "");
    Expect(0, 68092, '\p{^Nv: 7/00000012}', "");
    Expect(0, 68092, '\P{Nv: 7/00000012}', "");
    Expect(1, 68092, '\P{^Nv: 7/00000012}', "");
    Expect(0, 68093, '\p{Nv: 7/00000012}', "");
    Expect(1, 68093, '\p{^Nv: 7/00000012}', "");
    Expect(1, 68093, '\P{Nv: 7/00000012}', "");
    Expect(0, 68093, '\P{^Nv: 7/00000012}', "");
    Expect(1, 68092, '\p{Nv=420/720}', "");
    Expect(0, 68092, '\p{^Nv=420/720}', "");
    Expect(0, 68092, '\P{Nv=420/720}', "");
    Expect(1, 68092, '\P{^Nv=420/720}', "");
    Expect(0, 68093, '\p{Nv=420/720}', "");
    Expect(1, 68093, '\p{^Nv=420/720}', "");
    Expect(1, 68093, '\P{Nv=420/720}', "");
    Expect(0, 68093, '\P{^Nv=420/720}', "");
    Error('\p{Nv=5.8e-01}');
    Error('\P{Nv=5.8e-01}');
    Expect(1, 68092, '\p{Nv=5.83e-01}', "");
    Expect(0, 68092, '\p{^Nv=5.83e-01}', "");
    Expect(0, 68092, '\P{Nv=5.83e-01}', "");
    Expect(1, 68092, '\P{^Nv=5.83e-01}', "");
    Expect(0, 68093, '\p{Nv=5.83e-01}', "");
    Expect(1, 68093, '\p{^Nv=5.83e-01}', "");
    Expect(1, 68093, '\P{Nv=5.83e-01}', "");
    Expect(0, 68093, '\P{^Nv=5.83e-01}', "");
    Error('\p{Nv=0.58}');
    Error('\P{Nv=0.58}');
    Expect(1, 68092, '\p{Nv=5.833e-01}', "");
    Expect(0, 68092, '\p{^Nv=5.833e-01}', "");
    Expect(0, 68092, '\P{Nv=5.833e-01}', "");
    Expect(1, 68092, '\P{^Nv=5.833e-01}', "");
    Expect(0, 68093, '\p{Nv=5.833e-01}', "");
    Expect(1, 68093, '\p{^Nv=5.833e-01}', "");
    Expect(1, 68093, '\P{Nv=5.833e-01}', "");
    Expect(0, 68093, '\P{^Nv=5.833e-01}', "");
    Expect(1, 68092, '\p{Nv=0.583}', "");
    Expect(0, 68092, '\p{^Nv=0.583}', "");
    Expect(0, 68092, '\P{Nv=0.583}', "");
    Expect(1, 68092, '\P{^Nv=0.583}', "");
    Expect(0, 68093, '\p{Nv=0.583}', "");
    Expect(1, 68093, '\p{^Nv=0.583}', "");
    Expect(1, 68093, '\P{Nv=0.583}', "");
    Expect(0, 68093, '\P{^Nv=0.583}', "");
    Expect(1, 68092, '\p{Nv=5.8333e-01}', "");
    Expect(0, 68092, '\p{^Nv=5.8333e-01}', "");
    Expect(0, 68092, '\P{Nv=5.8333e-01}', "");
    Expect(1, 68092, '\P{^Nv=5.8333e-01}', "");
    Expect(0, 68093, '\p{Nv=5.8333e-01}', "");
    Expect(1, 68093, '\p{^Nv=5.8333e-01}', "");
    Expect(1, 68093, '\P{Nv=5.8333e-01}', "");
    Expect(0, 68093, '\P{^Nv=5.8333e-01}', "");
    Expect(1, 68092, '\p{Nv=0.5833}', "");
    Expect(0, 68092, '\p{^Nv=0.5833}', "");
    Expect(0, 68092, '\P{Nv=0.5833}', "");
    Expect(1, 68092, '\P{^Nv=0.5833}', "");
    Expect(0, 68093, '\p{Nv=0.5833}', "");
    Expect(1, 68093, '\p{^Nv=0.5833}', "");
    Expect(1, 68093, '\P{Nv=0.5833}', "");
    Expect(0, 68093, '\P{^Nv=0.5833}', "");
    Error('\p{Is_Numeric_Value=_-+007/12:=}');
    Error('\P{Is_Numeric_Value=_-+007/12:=}');
    Expect(1, 68092, '\p{Is_Numeric_Value=007/000012}', "");
    Expect(0, 68092, '\p{^Is_Numeric_Value=007/000012}', "");
    Expect(0, 68092, '\P{Is_Numeric_Value=007/000012}', "");
    Expect(1, 68092, '\P{^Is_Numeric_Value=007/000012}', "");
    Expect(0, 68093, '\p{Is_Numeric_Value=007/000012}', "");
    Expect(1, 68093, '\p{^Is_Numeric_Value=007/000012}', "");
    Expect(1, 68093, '\P{Is_Numeric_Value=007/000012}', "");
    Expect(0, 68093, '\P{^Is_Numeric_Value=007/000012}', "");
    Expect(1, 68092, '\p{Is_Numeric_Value=420/720}', "");
    Expect(0, 68092, '\p{^Is_Numeric_Value=420/720}', "");
    Expect(0, 68092, '\P{Is_Numeric_Value=420/720}', "");
    Expect(1, 68092, '\P{^Is_Numeric_Value=420/720}', "");
    Expect(0, 68093, '\p{Is_Numeric_Value=420/720}', "");
    Expect(1, 68093, '\p{^Is_Numeric_Value=420/720}', "");
    Expect(1, 68093, '\P{Is_Numeric_Value=420/720}', "");
    Expect(0, 68093, '\P{^Is_Numeric_Value=420/720}', "");
    Error('\p{Is_Numeric_Value=5.8e-01}');
    Error('\P{Is_Numeric_Value=5.8e-01}');
    Expect(1, 68092, '\p{Is_Numeric_Value=5.83e-01}', "");
    Expect(0, 68092, '\p{^Is_Numeric_Value=5.83e-01}', "");
    Expect(0, 68092, '\P{Is_Numeric_Value=5.83e-01}', "");
    Expect(1, 68092, '\P{^Is_Numeric_Value=5.83e-01}', "");
    Expect(0, 68093, '\p{Is_Numeric_Value=5.83e-01}', "");
    Expect(1, 68093, '\p{^Is_Numeric_Value=5.83e-01}', "");
    Expect(1, 68093, '\P{Is_Numeric_Value=5.83e-01}', "");
    Expect(0, 68093, '\P{^Is_Numeric_Value=5.83e-01}', "");
    Error('\p{Is_Numeric_Value: 0.58}');
    Error('\P{Is_Numeric_Value: 0.58}');
    Expect(1, 68092, '\p{Is_Numeric_Value=5.833e-01}', "");
    Expect(0, 68092, '\p{^Is_Numeric_Value=5.833e-01}', "");
    Expect(0, 68092, '\P{Is_Numeric_Value=5.833e-01}', "");
    Expect(1, 68092, '\P{^Is_Numeric_Value=5.833e-01}', "");
    Expect(0, 68093, '\p{Is_Numeric_Value=5.833e-01}', "");
    Expect(1, 68093, '\p{^Is_Numeric_Value=5.833e-01}', "");
    Expect(1, 68093, '\P{Is_Numeric_Value=5.833e-01}', "");
    Expect(0, 68093, '\P{^Is_Numeric_Value=5.833e-01}', "");
    Expect(1, 68092, '\p{Is_Numeric_Value=0.583}', "");
    Expect(0, 68092, '\p{^Is_Numeric_Value=0.583}', "");
    Expect(0, 68092, '\P{Is_Numeric_Value=0.583}', "");
    Expect(1, 68092, '\P{^Is_Numeric_Value=0.583}', "");
    Expect(0, 68093, '\p{Is_Numeric_Value=0.583}', "");
    Expect(1, 68093, '\p{^Is_Numeric_Value=0.583}', "");
    Expect(1, 68093, '\P{Is_Numeric_Value=0.583}', "");
    Expect(0, 68093, '\P{^Is_Numeric_Value=0.583}', "");
    Expect(1, 68092, '\p{Is_Numeric_Value=5.8333e-01}', "");
    Expect(0, 68092, '\p{^Is_Numeric_Value=5.8333e-01}', "");
    Expect(0, 68092, '\P{Is_Numeric_Value=5.8333e-01}', "");
    Expect(1, 68092, '\P{^Is_Numeric_Value=5.8333e-01}', "");
    Expect(0, 68093, '\p{Is_Numeric_Value=5.8333e-01}', "");
    Expect(1, 68093, '\p{^Is_Numeric_Value=5.8333e-01}', "");
    Expect(1, 68093, '\P{Is_Numeric_Value=5.8333e-01}', "");
    Expect(0, 68093, '\P{^Is_Numeric_Value=5.8333e-01}', "");
    Expect(1, 68092, '\p{Is_Numeric_Value=0.5833}', "");
    Expect(0, 68092, '\p{^Is_Numeric_Value=0.5833}', "");
    Expect(0, 68092, '\P{Is_Numeric_Value=0.5833}', "");
    Expect(1, 68092, '\P{^Is_Numeric_Value=0.5833}', "");
    Expect(0, 68093, '\p{Is_Numeric_Value=0.5833}', "");
    Expect(1, 68093, '\p{^Is_Numeric_Value=0.5833}', "");
    Expect(1, 68093, '\P{Is_Numeric_Value=0.5833}', "");
    Expect(0, 68093, '\P{^Is_Numeric_Value=0.5833}', "");
    Error('\p{Is_Nv=	_+0007/000000012/a/}');
    Error('\P{Is_Nv=	_+0007/000000012/a/}');
    Expect(1, 68092, '\p{Is_Nv=000000007/00012}', "");
    Expect(0, 68092, '\p{^Is_Nv=000000007/00012}', "");
    Expect(0, 68092, '\P{Is_Nv=000000007/00012}', "");
    Expect(1, 68092, '\P{^Is_Nv=000000007/00012}', "");
    Expect(0, 68093, '\p{Is_Nv=000000007/00012}', "");
    Expect(1, 68093, '\p{^Is_Nv=000000007/00012}', "");
    Expect(1, 68093, '\P{Is_Nv=000000007/00012}', "");
    Expect(0, 68093, '\P{^Is_Nv=000000007/00012}', "");
    Expect(1, 68092, '\p{Is_Nv=420/720}', "");
    Expect(0, 68092, '\p{^Is_Nv=420/720}', "");
    Expect(0, 68092, '\P{Is_Nv=420/720}', "");
    Expect(1, 68092, '\P{^Is_Nv=420/720}', "");
    Expect(0, 68093, '\p{Is_Nv=420/720}', "");
    Expect(1, 68093, '\p{^Is_Nv=420/720}', "");
    Expect(1, 68093, '\P{Is_Nv=420/720}', "");
    Expect(0, 68093, '\P{^Is_Nv=420/720}', "");
    Error('\p{Is_Nv=5.8e-01}');
    Error('\P{Is_Nv=5.8e-01}');
    Expect(1, 68092, '\p{Is_Nv=5.83e-01}', "");
    Expect(0, 68092, '\p{^Is_Nv=5.83e-01}', "");
    Expect(0, 68092, '\P{Is_Nv=5.83e-01}', "");
    Expect(1, 68092, '\P{^Is_Nv=5.83e-01}', "");
    Expect(0, 68093, '\p{Is_Nv=5.83e-01}', "");
    Expect(1, 68093, '\p{^Is_Nv=5.83e-01}', "");
    Expect(1, 68093, '\P{Is_Nv=5.83e-01}', "");
    Expect(0, 68093, '\P{^Is_Nv=5.83e-01}', "");
    Error('\p{Is_Nv: 0.58}');
    Error('\P{Is_Nv: 0.58}');
    Expect(1, 68092, '\p{Is_Nv=5.833e-01}', "");
    Expect(0, 68092, '\p{^Is_Nv=5.833e-01}', "");
    Expect(0, 68092, '\P{Is_Nv=5.833e-01}', "");
    Expect(1, 68092, '\P{^Is_Nv=5.833e-01}', "");
    Expect(0, 68093, '\p{Is_Nv=5.833e-01}', "");
    Expect(1, 68093, '\p{^Is_Nv=5.833e-01}', "");
    Expect(1, 68093, '\P{Is_Nv=5.833e-01}', "");
    Expect(0, 68093, '\P{^Is_Nv=5.833e-01}', "");
    Expect(1, 68092, '\p{Is_Nv=0.583}', "");
    Expect(0, 68092, '\p{^Is_Nv=0.583}', "");
    Expect(0, 68092, '\P{Is_Nv=0.583}', "");
    Expect(1, 68092, '\P{^Is_Nv=0.583}', "");
    Expect(0, 68093, '\p{Is_Nv=0.583}', "");
    Expect(1, 68093, '\p{^Is_Nv=0.583}', "");
    Expect(1, 68093, '\P{Is_Nv=0.583}', "");
    Expect(0, 68093, '\P{^Is_Nv=0.583}', "");
    Expect(1, 68092, '\p{Is_Nv=5.8333e-01}', "");
    Expect(0, 68092, '\p{^Is_Nv=5.8333e-01}', "");
    Expect(0, 68092, '\P{Is_Nv=5.8333e-01}', "");
    Expect(1, 68092, '\P{^Is_Nv=5.8333e-01}', "");
    Expect(0, 68093, '\p{Is_Nv=5.8333e-01}', "");
    Expect(1, 68093, '\p{^Is_Nv=5.8333e-01}', "");
    Expect(1, 68093, '\P{Is_Nv=5.8333e-01}', "");
    Expect(0, 68093, '\P{^Is_Nv=5.8333e-01}', "");
    Expect(1, 68092, '\p{Is_Nv=0.5833}', "");
    Expect(0, 68092, '\p{^Is_Nv=0.5833}', "");
    Expect(0, 68092, '\P{Is_Nv=0.5833}', "");
    Expect(1, 68092, '\P{^Is_Nv=0.5833}', "");
    Expect(0, 68093, '\p{Is_Nv=0.5833}', "");
    Expect(1, 68093, '\p{^Is_Nv=0.5833}', "");
    Expect(1, 68093, '\P{Is_Nv=0.5833}', "");
    Expect(0, 68093, '\P{^Is_Nv=0.5833}', "");
    Error('\p{Numeric_Value=:=_000007/0000002}');
    Error('\P{Numeric_Value=:=_000007/0000002}');
    Expect(1, 3885, '\p{Numeric_Value=:\A7/2\z:}', "");;
    Expect(0, 3886, '\p{Numeric_Value=:\A7/2\z:}', "");;
    Expect(1, 3885, '\p{Numeric_Value=+0007/00000002}', "");
    Expect(0, 3885, '\p{^Numeric_Value=+0007/00000002}', "");
    Expect(0, 3885, '\P{Numeric_Value=+0007/00000002}', "");
    Expect(1, 3885, '\P{^Numeric_Value=+0007/00000002}', "");
    Expect(0, 3886, '\p{Numeric_Value=+0007/00000002}', "");
    Expect(1, 3886, '\p{^Numeric_Value=+0007/00000002}', "");
    Expect(1, 3886, '\P{Numeric_Value=+0007/00000002}', "");
    Expect(0, 3886, '\P{^Numeric_Value=+0007/00000002}', "");
    Expect(1, 3885, '\p{Numeric_Value=420/120}', "");
    Expect(0, 3885, '\p{^Numeric_Value=420/120}', "");
    Expect(0, 3885, '\P{Numeric_Value=420/120}', "");
    Expect(1, 3885, '\P{^Numeric_Value=420/120}', "");
    Expect(0, 3886, '\p{Numeric_Value=420/120}', "");
    Expect(1, 3886, '\p{^Numeric_Value=420/120}', "");
    Expect(1, 3886, '\P{Numeric_Value=420/120}', "");
    Expect(0, 3886, '\P{^Numeric_Value=420/120}', "");
    Expect(1, 3885, '\p{Numeric_Value=3.5e+00}', "");
    Expect(0, 3885, '\p{^Numeric_Value=3.5e+00}', "");
    Expect(0, 3885, '\P{Numeric_Value=3.5e+00}', "");
    Expect(1, 3885, '\P{^Numeric_Value=3.5e+00}', "");
    Expect(0, 3886, '\p{Numeric_Value=3.5e+00}', "");
    Expect(1, 3886, '\p{^Numeric_Value=3.5e+00}', "");
    Expect(1, 3886, '\P{Numeric_Value=3.5e+00}', "");
    Expect(0, 3886, '\P{^Numeric_Value=3.5e+00}', "");
    Expect(1, 3885, '\p{Numeric_Value=3.5}', "");
    Expect(0, 3885, '\p{^Numeric_Value=3.5}', "");
    Expect(0, 3885, '\P{Numeric_Value=3.5}', "");
    Expect(1, 3885, '\P{^Numeric_Value=3.5}', "");
    Expect(0, 3886, '\p{Numeric_Value=3.5}', "");
    Expect(1, 3886, '\p{^Numeric_Value=3.5}', "");
    Expect(1, 3886, '\P{Numeric_Value=3.5}', "");
    Expect(0, 3886, '\P{^Numeric_Value=3.5}', "");
    Expect(1, 3885, '\p{Numeric_Value=3.50e+00}', "");
    Expect(0, 3885, '\p{^Numeric_Value=3.50e+00}', "");
    Expect(0, 3885, '\P{Numeric_Value=3.50e+00}', "");
    Expect(1, 3885, '\P{^Numeric_Value=3.50e+00}', "");
    Expect(0, 3886, '\p{Numeric_Value=3.50e+00}', "");
    Expect(1, 3886, '\p{^Numeric_Value=3.50e+00}', "");
    Expect(1, 3886, '\P{Numeric_Value=3.50e+00}', "");
    Expect(0, 3886, '\P{^Numeric_Value=3.50e+00}', "");
    Expect(1, 3885, '\p{Numeric_Value=3.50}', "");
    Expect(0, 3885, '\p{^Numeric_Value=3.50}', "");
    Expect(0, 3885, '\P{Numeric_Value=3.50}', "");
    Expect(1, 3885, '\P{^Numeric_Value=3.50}', "");
    Expect(0, 3886, '\p{Numeric_Value=3.50}', "");
    Expect(1, 3886, '\p{^Numeric_Value=3.50}', "");
    Expect(1, 3886, '\P{Numeric_Value=3.50}', "");
    Expect(0, 3886, '\P{^Numeric_Value=3.50}', "");
    Error('\p{Nv=:=--+0000000007/02}');
    Error('\P{Nv=:=--+0000000007/02}');
    Expect(1, 3885, '\p{Nv=:\A7/2\z:}', "");;
    Expect(0, 3886, '\p{Nv=:\A7/2\z:}', "");;
    Expect(1, 3885, '\p{Nv=007/000002}', "");
    Expect(0, 3885, '\p{^Nv=007/000002}', "");
    Expect(0, 3885, '\P{Nv=007/000002}', "");
    Expect(1, 3885, '\P{^Nv=007/000002}', "");
    Expect(0, 3886, '\p{Nv=007/000002}', "");
    Expect(1, 3886, '\p{^Nv=007/000002}', "");
    Expect(1, 3886, '\P{Nv=007/000002}', "");
    Expect(0, 3886, '\P{^Nv=007/000002}', "");
    Expect(1, 3885, '\p{Nv=420/120}', "");
    Expect(0, 3885, '\p{^Nv=420/120}', "");
    Expect(0, 3885, '\P{Nv=420/120}', "");
    Expect(1, 3885, '\P{^Nv=420/120}', "");
    Expect(0, 3886, '\p{Nv=420/120}', "");
    Expect(1, 3886, '\p{^Nv=420/120}', "");
    Expect(1, 3886, '\P{Nv=420/120}', "");
    Expect(0, 3886, '\P{^Nv=420/120}', "");
    Expect(1, 3885, '\p{Nv: 3.5e+00}', "");
    Expect(0, 3885, '\p{^Nv: 3.5e+00}', "");
    Expect(0, 3885, '\P{Nv: 3.5e+00}', "");
    Expect(1, 3885, '\P{^Nv: 3.5e+00}', "");
    Expect(0, 3886, '\p{Nv: 3.5e+00}', "");
    Expect(1, 3886, '\p{^Nv: 3.5e+00}', "");
    Expect(1, 3886, '\P{Nv: 3.5e+00}', "");
    Expect(0, 3886, '\P{^Nv: 3.5e+00}', "");
    Expect(1, 3885, '\p{Nv=3.5}', "");
    Expect(0, 3885, '\p{^Nv=3.5}', "");
    Expect(0, 3885, '\P{Nv=3.5}', "");
    Expect(1, 3885, '\P{^Nv=3.5}', "");
    Expect(0, 3886, '\p{Nv=3.5}', "");
    Expect(1, 3886, '\p{^Nv=3.5}', "");
    Expect(1, 3886, '\P{Nv=3.5}', "");
    Expect(0, 3886, '\P{^Nv=3.5}', "");
    Expect(1, 3885, '\p{Nv=3.50e+00}', "");
    Expect(0, 3885, '\p{^Nv=3.50e+00}', "");
    Expect(0, 3885, '\P{Nv=3.50e+00}', "");
    Expect(1, 3885, '\P{^Nv=3.50e+00}', "");
    Expect(0, 3886, '\p{Nv=3.50e+00}', "");
    Expect(1, 3886, '\p{^Nv=3.50e+00}', "");
    Expect(1, 3886, '\P{Nv=3.50e+00}', "");
    Expect(0, 3886, '\P{^Nv=3.50e+00}', "");
    Expect(1, 3885, '\p{Nv:   3.50}', "");
    Expect(0, 3885, '\p{^Nv:   3.50}', "");
    Expect(0, 3885, '\P{Nv:   3.50}', "");
    Expect(1, 3885, '\P{^Nv:   3.50}', "");
    Expect(0, 3886, '\p{Nv:   3.50}', "");
    Expect(1, 3886, '\p{^Nv:   3.50}', "");
    Expect(1, 3886, '\P{Nv:   3.50}', "");
    Expect(0, 3886, '\P{^Nv:   3.50}', "");
    Error('\p{Is_Numeric_Value= _007/0000002:=}');
    Error('\P{Is_Numeric_Value= _007/0000002:=}');
    Expect(1, 3885, '\p{Is_Numeric_Value=+000007/000002}', "");
    Expect(0, 3885, '\p{^Is_Numeric_Value=+000007/000002}', "");
    Expect(0, 3885, '\P{Is_Numeric_Value=+000007/000002}', "");
    Expect(1, 3885, '\P{^Is_Numeric_Value=+000007/000002}', "");
    Expect(0, 3886, '\p{Is_Numeric_Value=+000007/000002}', "");
    Expect(1, 3886, '\p{^Is_Numeric_Value=+000007/000002}', "");
    Expect(1, 3886, '\P{Is_Numeric_Value=+000007/000002}', "");
    Expect(0, 3886, '\P{^Is_Numeric_Value=+000007/000002}', "");
    Expect(1, 3885, '\p{Is_Numeric_Value=420/120}', "");
    Expect(0, 3885, '\p{^Is_Numeric_Value=420/120}', "");
    Expect(0, 3885, '\P{Is_Numeric_Value=420/120}', "");
    Expect(1, 3885, '\P{^Is_Numeric_Value=420/120}', "");
    Expect(0, 3886, '\p{Is_Numeric_Value=420/120}', "");
    Expect(1, 3886, '\p{^Is_Numeric_Value=420/120}', "");
    Expect(1, 3886, '\P{Is_Numeric_Value=420/120}', "");
    Expect(0, 3886, '\P{^Is_Numeric_Value=420/120}', "");
    Expect(1, 3885, '\p{Is_Numeric_Value=3.5e+00}', "");
    Expect(0, 3885, '\p{^Is_Numeric_Value=3.5e+00}', "");
    Expect(0, 3885, '\P{Is_Numeric_Value=3.5e+00}', "");
    Expect(1, 3885, '\P{^Is_Numeric_Value=3.5e+00}', "");
    Expect(0, 3886, '\p{Is_Numeric_Value=3.5e+00}', "");
    Expect(1, 3886, '\p{^Is_Numeric_Value=3.5e+00}', "");
    Expect(1, 3886, '\P{Is_Numeric_Value=3.5e+00}', "");
    Expect(0, 3886, '\P{^Is_Numeric_Value=3.5e+00}', "");
    Expect(1, 3885, '\p{Is_Numeric_Value=3.5}', "");
    Expect(0, 3885, '\p{^Is_Numeric_Value=3.5}', "");
    Expect(0, 3885, '\P{Is_Numeric_Value=3.5}', "");
    Expect(1, 3885, '\P{^Is_Numeric_Value=3.5}', "");
    Expect(0, 3886, '\p{Is_Numeric_Value=3.5}', "");
    Expect(1, 3886, '\p{^Is_Numeric_Value=3.5}', "");
    Expect(1, 3886, '\P{Is_Numeric_Value=3.5}', "");
    Expect(0, 3886, '\P{^Is_Numeric_Value=3.5}', "");
    Expect(1, 3885, '\p{Is_Numeric_Value=3.50e+00}', "");
    Expect(0, 3885, '\p{^Is_Numeric_Value=3.50e+00}', "");
    Expect(0, 3885, '\P{Is_Numeric_Value=3.50e+00}', "");
    Expect(1, 3885, '\P{^Is_Numeric_Value=3.50e+00}', "");
    Expect(0, 3886, '\p{Is_Numeric_Value=3.50e+00}', "");
    Expect(1, 3886, '\p{^Is_Numeric_Value=3.50e+00}', "");
    Expect(1, 3886, '\P{Is_Numeric_Value=3.50e+00}', "");
    Expect(0, 3886, '\P{^Is_Numeric_Value=3.50e+00}', "");
    Expect(1, 3885, '\p{Is_Numeric_Value=3.50}', "");
    Expect(0, 3885, '\p{^Is_Numeric_Value=3.50}', "");
    Expect(0, 3885, '\P{Is_Numeric_Value=3.50}', "");
    Expect(1, 3885, '\P{^Is_Numeric_Value=3.50}', "");
    Expect(0, 3886, '\p{Is_Numeric_Value=3.50}', "");
    Expect(1, 3886, '\p{^Is_Numeric_Value=3.50}', "");
    Expect(1, 3886, '\P{Is_Numeric_Value=3.50}', "");
    Expect(0, 3886, '\P{^Is_Numeric_Value=3.50}', "");
    Error('\p{Is_Nv= /a/000007/002}');
    Error('\P{Is_Nv= /a/000007/002}');
    Expect(1, 3885, '\p{Is_Nv=000007/0000002}', "");
    Expect(0, 3885, '\p{^Is_Nv=000007/0000002}', "");
    Expect(0, 3885, '\P{Is_Nv=000007/0000002}', "");
    Expect(1, 3885, '\P{^Is_Nv=000007/0000002}', "");
    Expect(0, 3886, '\p{Is_Nv=000007/0000002}', "");
    Expect(1, 3886, '\p{^Is_Nv=000007/0000002}', "");
    Expect(1, 3886, '\P{Is_Nv=000007/0000002}', "");
    Expect(0, 3886, '\P{^Is_Nv=000007/0000002}', "");
    Expect(1, 3885, '\p{Is_Nv=420/120}', "");
    Expect(0, 3885, '\p{^Is_Nv=420/120}', "");
    Expect(0, 3885, '\P{Is_Nv=420/120}', "");
    Expect(1, 3885, '\P{^Is_Nv=420/120}', "");
    Expect(0, 3886, '\p{Is_Nv=420/120}', "");
    Expect(1, 3886, '\p{^Is_Nv=420/120}', "");
    Expect(1, 3886, '\P{Is_Nv=420/120}', "");
    Expect(0, 3886, '\P{^Is_Nv=420/120}', "");
    Expect(1, 3885, '\p{Is_Nv=3.5e+00}', "");
    Expect(0, 3885, '\p{^Is_Nv=3.5e+00}', "");
    Expect(0, 3885, '\P{Is_Nv=3.5e+00}', "");
    Expect(1, 3885, '\P{^Is_Nv=3.5e+00}', "");
    Expect(0, 3886, '\p{Is_Nv=3.5e+00}', "");
    Expect(1, 3886, '\p{^Is_Nv=3.5e+00}', "");
    Expect(1, 3886, '\P{Is_Nv=3.5e+00}', "");
    Expect(0, 3886, '\P{^Is_Nv=3.5e+00}', "");
    Expect(1, 3885, '\p{Is_Nv=3.5}', "");
    Expect(0, 3885, '\p{^Is_Nv=3.5}', "");
    Expect(0, 3885, '\P{Is_Nv=3.5}', "");
    Expect(1, 3885, '\P{^Is_Nv=3.5}', "");
    Expect(0, 3886, '\p{Is_Nv=3.5}', "");
    Expect(1, 3886, '\p{^Is_Nv=3.5}', "");
    Expect(1, 3886, '\P{Is_Nv=3.5}', "");
    Expect(0, 3886, '\P{^Is_Nv=3.5}', "");
    Expect(1, 3885, '\p{Is_Nv=3.50e+00}', "");
    Expect(0, 3885, '\p{^Is_Nv=3.50e+00}', "");
    Expect(0, 3885, '\P{Is_Nv=3.50e+00}', "");
    Expect(1, 3885, '\P{^Is_Nv=3.50e+00}', "");
    Expect(0, 3886, '\p{Is_Nv=3.50e+00}', "");
    Expect(1, 3886, '\p{^Is_Nv=3.50e+00}', "");
    Expect(1, 3886, '\P{Is_Nv=3.50e+00}', "");
    Expect(0, 3886, '\P{^Is_Nv=3.50e+00}', "");
    Expect(1, 3885, '\p{Is_Nv=3.50}', "");
    Expect(0, 3885, '\p{^Is_Nv=3.50}', "");
    Expect(0, 3885, '\P{Is_Nv=3.50}', "");
    Expect(1, 3885, '\P{^Is_Nv=3.50}', "");
    Expect(0, 3886, '\p{Is_Nv=3.50}', "");
    Expect(1, 3886, '\p{^Is_Nv=3.50}', "");
    Expect(1, 3886, '\P{Is_Nv=3.50}', "");
    Expect(0, 3886, '\P{^Is_Nv=3.50}', "");
    Error('\p{Numeric_Value=:= _000007/00000008}');
    Error('\P{Numeric_Value=:= _000007/00000008}');
    Expect(1, 8542, '\p{Numeric_Value=:\A7/8\z:}', "");;
    Expect(0, 8543, '\p{Numeric_Value=:\A7/8\z:}', "");;
    Expect(1, 8542, '\p{Numeric_Value=0000007/000000008}', "");
    Expect(0, 8542, '\p{^Numeric_Value=0000007/000000008}', "");
    Expect(0, 8542, '\P{Numeric_Value=0000007/000000008}', "");
    Expect(1, 8542, '\P{^Numeric_Value=0000007/000000008}', "");
    Expect(0, 8543, '\p{Numeric_Value=0000007/000000008}', "");
    Expect(1, 8543, '\p{^Numeric_Value=0000007/000000008}', "");
    Expect(1, 8543, '\P{Numeric_Value=0000007/000000008}', "");
    Expect(0, 8543, '\P{^Numeric_Value=0000007/000000008}', "");
    Expect(1, 8542, '\p{Numeric_Value=420/480}', "");
    Expect(0, 8542, '\p{^Numeric_Value=420/480}', "");
    Expect(0, 8542, '\P{Numeric_Value=420/480}', "");
    Expect(1, 8542, '\P{^Numeric_Value=420/480}', "");
    Expect(0, 8543, '\p{Numeric_Value=420/480}', "");
    Expect(1, 8543, '\p{^Numeric_Value=420/480}', "");
    Expect(1, 8543, '\P{Numeric_Value=420/480}', "");
    Expect(0, 8543, '\P{^Numeric_Value=420/480}', "");
    Error('\p{Numeric_Value=8.8e-01}');
    Error('\P{Numeric_Value=8.8e-01}');
    Error('\p{Numeric_Value=0.9}');
    Error('\P{Numeric_Value=0.9}');
    Expect(1, 8542, '\p{Numeric_Value=8.75e-01}', "");
    Expect(0, 8542, '\p{^Numeric_Value=8.75e-01}', "");
    Expect(0, 8542, '\P{Numeric_Value=8.75e-01}', "");
    Expect(1, 8542, '\P{^Numeric_Value=8.75e-01}', "");
    Expect(0, 8543, '\p{Numeric_Value=8.75e-01}', "");
    Expect(1, 8543, '\p{^Numeric_Value=8.75e-01}', "");
    Expect(1, 8543, '\P{Numeric_Value=8.75e-01}', "");
    Expect(0, 8543, '\P{^Numeric_Value=8.75e-01}', "");
    Error('\p{Numeric_Value=0.88}');
    Error('\P{Numeric_Value=0.88}');
    Expect(1, 8542, '\p{Numeric_Value: 8.750e-01}', "");
    Expect(0, 8542, '\p{^Numeric_Value: 8.750e-01}', "");
    Expect(0, 8542, '\P{Numeric_Value: 8.750e-01}', "");
    Expect(1, 8542, '\P{^Numeric_Value: 8.750e-01}', "");
    Expect(0, 8543, '\p{Numeric_Value: 8.750e-01}', "");
    Expect(1, 8543, '\p{^Numeric_Value: 8.750e-01}', "");
    Expect(1, 8543, '\P{Numeric_Value: 8.750e-01}', "");
    Expect(0, 8543, '\P{^Numeric_Value: 8.750e-01}', "");
    Expect(1, 8542, '\p{Numeric_Value=0.875}', "");
    Expect(0, 8542, '\p{^Numeric_Value=0.875}', "");
    Expect(0, 8542, '\P{Numeric_Value=0.875}', "");
    Expect(1, 8542, '\P{^Numeric_Value=0.875}', "");
    Expect(0, 8543, '\p{Numeric_Value=0.875}', "");
    Expect(1, 8543, '\p{^Numeric_Value=0.875}', "");
    Expect(1, 8543, '\P{Numeric_Value=0.875}', "");
    Expect(0, 8543, '\P{^Numeric_Value=0.875}', "");
    Expect(1, 8542, '\p{Numeric_Value:8.7500e-01}', "");
    Expect(0, 8542, '\p{^Numeric_Value:8.7500e-01}', "");
    Expect(0, 8542, '\P{Numeric_Value:8.7500e-01}', "");
    Expect(1, 8542, '\P{^Numeric_Value:8.7500e-01}', "");
    Expect(0, 8543, '\p{Numeric_Value:8.7500e-01}', "");
    Expect(1, 8543, '\p{^Numeric_Value:8.7500e-01}', "");
    Expect(1, 8543, '\P{Numeric_Value:8.7500e-01}', "");
    Expect(0, 8543, '\P{^Numeric_Value:8.7500e-01}', "");
    Expect(1, 8542, '\p{Numeric_Value=0.8750}', "");
    Expect(0, 8542, '\p{^Numeric_Value=0.8750}', "");
    Expect(0, 8542, '\P{Numeric_Value=0.8750}', "");
    Expect(1, 8542, '\P{^Numeric_Value=0.8750}', "");
    Expect(0, 8543, '\p{Numeric_Value=0.8750}', "");
    Expect(1, 8543, '\p{^Numeric_Value=0.8750}', "");
    Expect(1, 8543, '\P{Numeric_Value=0.8750}', "");
    Expect(0, 8543, '\P{^Numeric_Value=0.8750}', "");
    Error('\p{Nv=:=00007/008}');
    Error('\P{Nv=:=00007/008}');
    Expect(1, 8542, '\p{Nv=:\A7/8\z:}', "");;
    Expect(0, 8543, '\p{Nv=:\A7/8\z:}', "");;
    Expect(1, 8542, '\p{Nv=07/08}', "");
    Expect(0, 8542, '\p{^Nv=07/08}', "");
    Expect(0, 8542, '\P{Nv=07/08}', "");
    Expect(1, 8542, '\P{^Nv=07/08}', "");
    Expect(0, 8543, '\p{Nv=07/08}', "");
    Expect(1, 8543, '\p{^Nv=07/08}', "");
    Expect(1, 8543, '\P{Nv=07/08}', "");
    Expect(0, 8543, '\P{^Nv=07/08}', "");
    Expect(1, 8542, '\p{Nv=420/480}', "");
    Expect(0, 8542, '\p{^Nv=420/480}', "");
    Expect(0, 8542, '\P{Nv=420/480}', "");
    Expect(1, 8542, '\P{^Nv=420/480}', "");
    Expect(0, 8543, '\p{Nv=420/480}', "");
    Expect(1, 8543, '\p{^Nv=420/480}', "");
    Expect(1, 8543, '\P{Nv=420/480}', "");
    Expect(0, 8543, '\P{^Nv=420/480}', "");
    Error('\p{Nv=8.8e-01}');
    Error('\P{Nv=8.8e-01}');
    Error('\p{Nv=0.9}');
    Error('\P{Nv=0.9}');
    Expect(1, 8542, '\p{Nv=8.75e-01}', "");
    Expect(0, 8542, '\p{^Nv=8.75e-01}', "");
    Expect(0, 8542, '\P{Nv=8.75e-01}', "");
    Expect(1, 8542, '\P{^Nv=8.75e-01}', "");
    Expect(0, 8543, '\p{Nv=8.75e-01}', "");
    Expect(1, 8543, '\p{^Nv=8.75e-01}', "");
    Expect(1, 8543, '\P{Nv=8.75e-01}', "");
    Expect(0, 8543, '\P{^Nv=8.75e-01}', "");
    Error('\p{Nv=0.88}');
    Error('\P{Nv=0.88}');
    Expect(1, 8542, '\p{Nv=8.750e-01}', "");
    Expect(0, 8542, '\p{^Nv=8.750e-01}', "");
    Expect(0, 8542, '\P{Nv=8.750e-01}', "");
    Expect(1, 8542, '\P{^Nv=8.750e-01}', "");
    Expect(0, 8543, '\p{Nv=8.750e-01}', "");
    Expect(1, 8543, '\p{^Nv=8.750e-01}', "");
    Expect(1, 8543, '\P{Nv=8.750e-01}', "");
    Expect(0, 8543, '\P{^Nv=8.750e-01}', "");
    Expect(1, 8542, '\p{Nv=0.875}', "");
    Expect(0, 8542, '\p{^Nv=0.875}', "");
    Expect(0, 8542, '\P{Nv=0.875}', "");
    Expect(1, 8542, '\P{^Nv=0.875}', "");
    Expect(0, 8543, '\p{Nv=0.875}', "");
    Expect(1, 8543, '\p{^Nv=0.875}', "");
    Expect(1, 8543, '\P{Nv=0.875}', "");
    Expect(0, 8543, '\P{^Nv=0.875}', "");
    Expect(1, 8542, '\p{Nv=8.7500e-01}', "");
    Expect(0, 8542, '\p{^Nv=8.7500e-01}', "");
    Expect(0, 8542, '\P{Nv=8.7500e-01}', "");
    Expect(1, 8542, '\P{^Nv=8.7500e-01}', "");
    Expect(0, 8543, '\p{Nv=8.7500e-01}', "");
    Expect(1, 8543, '\p{^Nv=8.7500e-01}', "");
    Expect(1, 8543, '\P{Nv=8.7500e-01}', "");
    Expect(0, 8543, '\P{^Nv=8.7500e-01}', "");
    Expect(1, 8542, '\p{Nv=0.8750}', "");
    Expect(0, 8542, '\p{^Nv=0.8750}', "");
    Expect(0, 8542, '\P{Nv=0.8750}', "");
    Expect(1, 8542, '\P{^Nv=0.8750}', "");
    Expect(0, 8543, '\p{Nv=0.8750}', "");
    Expect(1, 8543, '\p{^Nv=0.8750}', "");
    Expect(1, 8543, '\P{Nv=0.8750}', "");
    Expect(0, 8543, '\P{^Nv=0.8750}', "");
    Error('\p{Is_Numeric_Value:	:=__0007/00000008}');
    Error('\P{Is_Numeric_Value:	:=__0007/00000008}');
    Expect(1, 8542, '\p{Is_Numeric_Value=+0000007/0008}', "");
    Expect(0, 8542, '\p{^Is_Numeric_Value=+0000007/0008}', "");
    Expect(0, 8542, '\P{Is_Numeric_Value=+0000007/0008}', "");
    Expect(1, 8542, '\P{^Is_Numeric_Value=+0000007/0008}', "");
    Expect(0, 8543, '\p{Is_Numeric_Value=+0000007/0008}', "");
    Expect(1, 8543, '\p{^Is_Numeric_Value=+0000007/0008}', "");
    Expect(1, 8543, '\P{Is_Numeric_Value=+0000007/0008}', "");
    Expect(0, 8543, '\P{^Is_Numeric_Value=+0000007/0008}', "");
    Expect(1, 8542, '\p{Is_Numeric_Value:   420/480}', "");
    Expect(0, 8542, '\p{^Is_Numeric_Value:   420/480}', "");
    Expect(0, 8542, '\P{Is_Numeric_Value:   420/480}', "");
    Expect(1, 8542, '\P{^Is_Numeric_Value:   420/480}', "");
    Expect(0, 8543, '\p{Is_Numeric_Value:   420/480}', "");
    Expect(1, 8543, '\p{^Is_Numeric_Value:   420/480}', "");
    Expect(1, 8543, '\P{Is_Numeric_Value:   420/480}', "");
    Expect(0, 8543, '\P{^Is_Numeric_Value:   420/480}', "");
    Error('\p{Is_Numeric_Value=8.8e-01}');
    Error('\P{Is_Numeric_Value=8.8e-01}');
    Error('\p{Is_Numeric_Value=0.9}');
    Error('\P{Is_Numeric_Value=0.9}');
    Expect(1, 8542, '\p{Is_Numeric_Value=8.75e-01}', "");
    Expect(0, 8542, '\p{^Is_Numeric_Value=8.75e-01}', "");
    Expect(0, 8542, '\P{Is_Numeric_Value=8.75e-01}', "");
    Expect(1, 8542, '\P{^Is_Numeric_Value=8.75e-01}', "");
    Expect(0, 8543, '\p{Is_Numeric_Value=8.75e-01}', "");
    Expect(1, 8543, '\p{^Is_Numeric_Value=8.75e-01}', "");
    Expect(1, 8543, '\P{Is_Numeric_Value=8.75e-01}', "");
    Expect(0, 8543, '\P{^Is_Numeric_Value=8.75e-01}', "");
    Error('\p{Is_Numeric_Value=0.88}');
    Error('\P{Is_Numeric_Value=0.88}');
    Expect(1, 8542, '\p{Is_Numeric_Value=8.750e-01}', "");
    Expect(0, 8542, '\p{^Is_Numeric_Value=8.750e-01}', "");
    Expect(0, 8542, '\P{Is_Numeric_Value=8.750e-01}', "");
    Expect(1, 8542, '\P{^Is_Numeric_Value=8.750e-01}', "");
    Expect(0, 8543, '\p{Is_Numeric_Value=8.750e-01}', "");
    Expect(1, 8543, '\p{^Is_Numeric_Value=8.750e-01}', "");
    Expect(1, 8543, '\P{Is_Numeric_Value=8.750e-01}', "");
    Expect(0, 8543, '\P{^Is_Numeric_Value=8.750e-01}', "");
    Expect(1, 8542, '\p{Is_Numeric_Value=0.875}', "");
    Expect(0, 8542, '\p{^Is_Numeric_Value=0.875}', "");
    Expect(0, 8542, '\P{Is_Numeric_Value=0.875}', "");
    Expect(1, 8542, '\P{^Is_Numeric_Value=0.875}', "");
    Expect(0, 8543, '\p{Is_Numeric_Value=0.875}', "");
    Expect(1, 8543, '\p{^Is_Numeric_Value=0.875}', "");
    Expect(1, 8543, '\P{Is_Numeric_Value=0.875}', "");
    Expect(0, 8543, '\P{^Is_Numeric_Value=0.875}', "");
    Expect(1, 8542, '\p{Is_Numeric_Value=8.7500e-01}', "");
    Expect(0, 8542, '\p{^Is_Numeric_Value=8.7500e-01}', "");
    Expect(0, 8542, '\P{Is_Numeric_Value=8.7500e-01}', "");
    Expect(1, 8542, '\P{^Is_Numeric_Value=8.7500e-01}', "");
    Expect(0, 8543, '\p{Is_Numeric_Value=8.7500e-01}', "");
    Expect(1, 8543, '\p{^Is_Numeric_Value=8.7500e-01}', "");
    Expect(1, 8543, '\P{Is_Numeric_Value=8.7500e-01}', "");
    Expect(0, 8543, '\P{^Is_Numeric_Value=8.7500e-01}', "");
    Expect(1, 8542, '\p{Is_Numeric_Value:0.8750}', "");
    Expect(0, 8542, '\p{^Is_Numeric_Value:0.8750}', "");
    Expect(0, 8542, '\P{Is_Numeric_Value:0.8750}', "");
    Expect(1, 8542, '\P{^Is_Numeric_Value:0.8750}', "");
    Expect(0, 8543, '\p{Is_Numeric_Value:0.8750}', "");
    Expect(1, 8543, '\p{^Is_Numeric_Value:0.8750}', "");
    Expect(1, 8543, '\P{Is_Numeric_Value:0.8750}', "");
    Expect(0, 8543, '\P{^Is_Numeric_Value:0.8750}', "");
    Error('\p{Is_Nv=:= 007/000008}');
    Error('\P{Is_Nv=:= 007/000008}');
    Expect(1, 8542, '\p{Is_Nv=+0000000007/0000000008}', "");
    Expect(0, 8542, '\p{^Is_Nv=+0000000007/0000000008}', "");
    Expect(0, 8542, '\P{Is_Nv=+0000000007/0000000008}', "");
    Expect(1, 8542, '\P{^Is_Nv=+0000000007/0000000008}', "");
    Expect(0, 8543, '\p{Is_Nv=+0000000007/0000000008}', "");
    Expect(1, 8543, '\p{^Is_Nv=+0000000007/0000000008}', "");
    Expect(1, 8543, '\P{Is_Nv=+0000000007/0000000008}', "");
    Expect(0, 8543, '\P{^Is_Nv=+0000000007/0000000008}', "");
    Expect(1, 8542, '\p{Is_Nv=420/480}', "");
    Expect(0, 8542, '\p{^Is_Nv=420/480}', "");
    Expect(0, 8542, '\P{Is_Nv=420/480}', "");
    Expect(1, 8542, '\P{^Is_Nv=420/480}', "");
    Expect(0, 8543, '\p{Is_Nv=420/480}', "");
    Expect(1, 8543, '\p{^Is_Nv=420/480}', "");
    Expect(1, 8543, '\P{Is_Nv=420/480}', "");
    Expect(0, 8543, '\P{^Is_Nv=420/480}', "");
    Error('\p{Is_Nv=8.8e-01}');
    Error('\P{Is_Nv=8.8e-01}');
    Error('\p{Is_Nv=0.9}');
    Error('\P{Is_Nv=0.9}');
    Expect(1, 8542, '\p{Is_Nv=8.75e-01}', "");
    Expect(0, 8542, '\p{^Is_Nv=8.75e-01}', "");
    Expect(0, 8542, '\P{Is_Nv=8.75e-01}', "");
    Expect(1, 8542, '\P{^Is_Nv=8.75e-01}', "");
    Expect(0, 8543, '\p{Is_Nv=8.75e-01}', "");
    Expect(1, 8543, '\p{^Is_Nv=8.75e-01}', "");
    Expect(1, 8543, '\P{Is_Nv=8.75e-01}', "");
    Expect(0, 8543, '\P{^Is_Nv=8.75e-01}', "");
    Error('\p{Is_Nv=0.88}');
    Error('\P{Is_Nv=0.88}');
    Expect(1, 8542, '\p{Is_Nv=8.750e-01}', "");
    Expect(0, 8542, '\p{^Is_Nv=8.750e-01}', "");
    Expect(0, 8542, '\P{Is_Nv=8.750e-01}', "");
    Expect(1, 8542, '\P{^Is_Nv=8.750e-01}', "");
    Expect(0, 8543, '\p{Is_Nv=8.750e-01}', "");
    Expect(1, 8543, '\p{^Is_Nv=8.750e-01}', "");
    Expect(1, 8543, '\P{Is_Nv=8.750e-01}', "");
    Expect(0, 8543, '\P{^Is_Nv=8.750e-01}', "");
    Expect(1, 8542, '\p{Is_Nv=0.875}', "");
    Expect(0, 8542, '\p{^Is_Nv=0.875}', "");
    Expect(0, 8542, '\P{Is_Nv=0.875}', "");
    Expect(1, 8542, '\P{^Is_Nv=0.875}', "");
    Expect(0, 8543, '\p{Is_Nv=0.875}', "");
    Expect(1, 8543, '\p{^Is_Nv=0.875}', "");
    Expect(1, 8543, '\P{Is_Nv=0.875}', "");
    Expect(0, 8543, '\P{^Is_Nv=0.875}', "");
    Expect(1, 8542, '\p{Is_Nv=8.7500e-01}', "");
    Expect(0, 8542, '\p{^Is_Nv=8.7500e-01}', "");
    Expect(0, 8542, '\P{Is_Nv=8.7500e-01}', "");
    Expect(1, 8542, '\P{^Is_Nv=8.7500e-01}', "");
    Expect(0, 8543, '\p{Is_Nv=8.7500e-01}', "");
    Expect(1, 8543, '\p{^Is_Nv=8.7500e-01}', "");
    Expect(1, 8543, '\P{Is_Nv=8.7500e-01}', "");
    Expect(0, 8543, '\P{^Is_Nv=8.7500e-01}', "");
    Expect(1, 8542, '\p{Is_Nv=0.8750}', "");
    Expect(0, 8542, '\p{^Is_Nv=0.8750}', "");
    Expect(0, 8542, '\P{Is_Nv=0.8750}', "");
    Expect(1, 8542, '\P{^Is_Nv=0.8750}', "");
    Expect(0, 8543, '\p{Is_Nv=0.8750}', "");
    Expect(1, 8543, '\p{^Is_Nv=0.8750}', "");
    Expect(1, 8543, '\P{Is_Nv=0.8750}', "");
    Expect(0, 8543, '\P{^Is_Nv=0.8750}', "");
    Error('\p{Numeric_Value=/a/070}');
    Error('\P{Numeric_Value=/a/070}');
    Expect(1, 126224, '\p{Numeric_Value=:\A70\z:}', "");;
    Expect(0, 126225, '\p{Numeric_Value=:\A70\z:}', "");;
    Expect(1, 126224, '\p{Numeric_Value=+00070}', "");
    Expect(0, 126224, '\p{^Numeric_Value=+00070}', "");
    Expect(0, 126224, '\P{Numeric_Value=+00070}', "");
    Expect(1, 126224, '\P{^Numeric_Value=+00070}', "");
    Expect(0, 126225, '\p{Numeric_Value=+00070}', "");
    Expect(1, 126225, '\p{^Numeric_Value=+00070}', "");
    Expect(1, 126225, '\P{Numeric_Value=+00070}', "");
    Expect(0, 126225, '\P{^Numeric_Value=+00070}', "");
    Expect(1, 126224, '\p{Numeric_Value=7.000000000000000e+01}', "");
    Expect(0, 126224, '\p{^Numeric_Value=7.000000000000000e+01}', "");
    Expect(0, 126224, '\P{Numeric_Value=7.000000000000000e+01}', "");
    Expect(1, 126224, '\P{^Numeric_Value=7.000000000000000e+01}', "");
    Expect(0, 126225, '\p{Numeric_Value=7.000000000000000e+01}', "");
    Expect(1, 126225, '\p{^Numeric_Value=7.000000000000000e+01}', "");
    Expect(1, 126225, '\P{Numeric_Value=7.000000000000000e+01}', "");
    Expect(0, 126225, '\P{^Numeric_Value=7.000000000000000e+01}', "");
    Error('\p{Nv= -07_0:=}');
    Error('\P{Nv= -07_0:=}');
    Expect(1, 126224, '\p{Nv=:\A70\z:}', "");;
    Expect(0, 126225, '\p{Nv=:\A70\z:}', "");;
    Expect(1, 126224, '\p{Nv=7_0}', "");
    Expect(0, 126224, '\p{^Nv=7_0}', "");
    Expect(0, 126224, '\P{Nv=7_0}', "");
    Expect(1, 126224, '\P{^Nv=7_0}', "");
    Expect(0, 126225, '\p{Nv=7_0}', "");
    Expect(1, 126225, '\p{^Nv=7_0}', "");
    Expect(1, 126225, '\P{Nv=7_0}', "");
    Expect(0, 126225, '\P{^Nv=7_0}', "");
    Expect(1, 126224, '\p{Nv=7.000000000000000e+01}', "");
    Expect(0, 126224, '\p{^Nv=7.000000000000000e+01}', "");
    Expect(0, 126224, '\P{Nv=7.000000000000000e+01}', "");
    Expect(1, 126224, '\P{^Nv=7.000000000000000e+01}', "");
    Expect(0, 126225, '\p{Nv=7.000000000000000e+01}', "");
    Expect(1, 126225, '\p{^Nv=7.000000000000000e+01}', "");
    Expect(1, 126225, '\P{Nv=7.000000000000000e+01}', "");
    Expect(0, 126225, '\P{^Nv=7.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=	:=+0000070}');
    Error('\P{Is_Numeric_Value=	:=+0000070}');
    Expect(1, 126224, '\p{Is_Numeric_Value=0070}', "");
    Expect(0, 126224, '\p{^Is_Numeric_Value=0070}', "");
    Expect(0, 126224, '\P{Is_Numeric_Value=0070}', "");
    Expect(1, 126224, '\P{^Is_Numeric_Value=0070}', "");
    Expect(0, 126225, '\p{Is_Numeric_Value=0070}', "");
    Expect(1, 126225, '\p{^Is_Numeric_Value=0070}', "");
    Expect(1, 126225, '\P{Is_Numeric_Value=0070}', "");
    Expect(0, 126225, '\P{^Is_Numeric_Value=0070}', "");
    Expect(1, 126224, '\p{Is_Numeric_Value=7.000000000000000e+01}', "");
    Expect(0, 126224, '\p{^Is_Numeric_Value=7.000000000000000e+01}', "");
    Expect(0, 126224, '\P{Is_Numeric_Value=7.000000000000000e+01}', "");
    Expect(1, 126224, '\P{^Is_Numeric_Value=7.000000000000000e+01}', "");
    Expect(0, 126225, '\p{Is_Numeric_Value=7.000000000000000e+01}', "");
    Expect(1, 126225, '\p{^Is_Numeric_Value=7.000000000000000e+01}', "");
    Expect(1, 126225, '\P{Is_Numeric_Value=7.000000000000000e+01}', "");
    Expect(0, 126225, '\P{^Is_Numeric_Value=7.000000000000000e+01}', "");
    Error('\p{Is_Nv= -0000000070/a/}');
    Error('\P{Is_Nv= -0000000070/a/}');
    Expect(1, 126224, '\p{Is_Nv=00070}', "");
    Expect(0, 126224, '\p{^Is_Nv=00070}', "");
    Expect(0, 126224, '\P{Is_Nv=00070}', "");
    Expect(1, 126224, '\P{^Is_Nv=00070}', "");
    Expect(0, 126225, '\p{Is_Nv=00070}', "");
    Expect(1, 126225, '\p{^Is_Nv=00070}', "");
    Expect(1, 126225, '\P{Is_Nv=00070}', "");
    Expect(0, 126225, '\P{^Is_Nv=00070}', "");
    Expect(1, 126224, '\p{Is_Nv=7.000000000000000e+01}', "");
    Expect(0, 126224, '\p{^Is_Nv=7.000000000000000e+01}', "");
    Expect(0, 126224, '\P{Is_Nv=7.000000000000000e+01}', "");
    Expect(1, 126224, '\P{^Is_Nv=7.000000000000000e+01}', "");
    Expect(0, 126225, '\p{Is_Nv=7.000000000000000e+01}', "");
    Expect(1, 126225, '\p{^Is_Nv=7.000000000000000e+01}', "");
    Expect(1, 126225, '\P{Is_Nv=7.000000000000000e+01}', "");
    Expect(0, 126225, '\P{^Is_Nv=7.000000000000000e+01}', "");
    Error('\p{Numeric_Value=/a/-070_0}');
    Error('\P{Numeric_Value=/a/-070_0}');
    Expect(1, 126233, '\p{Numeric_Value=:\A700\z:}', "");;
    Expect(0, 126234, '\p{Numeric_Value=:\A700\z:}', "");;
    Expect(1, 126233, '\p{Numeric_Value=00000700}', "");
    Expect(0, 126233, '\p{^Numeric_Value=00000700}', "");
    Expect(0, 126233, '\P{Numeric_Value=00000700}', "");
    Expect(1, 126233, '\P{^Numeric_Value=00000700}', "");
    Expect(0, 126234, '\p{Numeric_Value=00000700}', "");
    Expect(1, 126234, '\p{^Numeric_Value=00000700}', "");
    Expect(1, 126234, '\P{Numeric_Value=00000700}', "");
    Expect(0, 126234, '\P{^Numeric_Value=00000700}', "");
    Expect(1, 126233, '\p{Numeric_Value=7.000000000000000e+02}', "");
    Expect(0, 126233, '\p{^Numeric_Value=7.000000000000000e+02}', "");
    Expect(0, 126233, '\P{Numeric_Value=7.000000000000000e+02}', "");
    Expect(1, 126233, '\P{^Numeric_Value=7.000000000000000e+02}', "");
    Expect(0, 126234, '\p{Numeric_Value=7.000000000000000e+02}', "");
    Expect(1, 126234, '\p{^Numeric_Value=7.000000000000000e+02}', "");
    Expect(1, 126234, '\P{Numeric_Value=7.000000000000000e+02}', "");
    Expect(0, 126234, '\P{^Numeric_Value=7.000000000000000e+02}', "");
    Error('\p{Nv=:=_+00000700}');
    Error('\P{Nv=:=_+00000700}');
    Expect(1, 126233, '\p{Nv=:\A700\z:}', "");;
    Expect(0, 126234, '\p{Nv=:\A700\z:}', "");;
    Expect(1, 126233, '\p{Nv=00000070_0}', "");
    Expect(0, 126233, '\p{^Nv=00000070_0}', "");
    Expect(0, 126233, '\P{Nv=00000070_0}', "");
    Expect(1, 126233, '\P{^Nv=00000070_0}', "");
    Expect(0, 126234, '\p{Nv=00000070_0}', "");
    Expect(1, 126234, '\p{^Nv=00000070_0}', "");
    Expect(1, 126234, '\P{Nv=00000070_0}', "");
    Expect(0, 126234, '\P{^Nv=00000070_0}', "");
    Expect(1, 126233, '\p{Nv=7.000000000000000e+02}', "");
    Expect(0, 126233, '\p{^Nv=7.000000000000000e+02}', "");
    Expect(0, 126233, '\P{Nv=7.000000000000000e+02}', "");
    Expect(1, 126233, '\P{^Nv=7.000000000000000e+02}', "");
    Expect(0, 126234, '\p{Nv=7.000000000000000e+02}', "");
    Expect(1, 126234, '\p{^Nv=7.000000000000000e+02}', "");
    Expect(1, 126234, '\P{Nv=7.000000000000000e+02}', "");
    Expect(0, 126234, '\P{^Nv=7.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value=-:=+0_0_0_0_0_0_00700}');
    Error('\P{Is_Numeric_Value=-:=+0_0_0_0_0_0_00700}');
    Expect(1, 126233, '\p{Is_Numeric_Value=00_70_0}', "");
    Expect(0, 126233, '\p{^Is_Numeric_Value=00_70_0}', "");
    Expect(0, 126233, '\P{Is_Numeric_Value=00_70_0}', "");
    Expect(1, 126233, '\P{^Is_Numeric_Value=00_70_0}', "");
    Expect(0, 126234, '\p{Is_Numeric_Value=00_70_0}', "");
    Expect(1, 126234, '\p{^Is_Numeric_Value=00_70_0}', "");
    Expect(1, 126234, '\P{Is_Numeric_Value=00_70_0}', "");
    Expect(0, 126234, '\P{^Is_Numeric_Value=00_70_0}', "");
    Expect(1, 126233, '\p{Is_Numeric_Value=7.000000000000000e+02}', "");
    Expect(0, 126233, '\p{^Is_Numeric_Value=7.000000000000000e+02}', "");
    Expect(0, 126233, '\P{Is_Numeric_Value=7.000000000000000e+02}', "");
    Expect(1, 126233, '\P{^Is_Numeric_Value=7.000000000000000e+02}', "");
    Expect(0, 126234, '\p{Is_Numeric_Value=7.000000000000000e+02}', "");
    Expect(1, 126234, '\p{^Is_Numeric_Value=7.000000000000000e+02}', "");
    Expect(1, 126234, '\P{Is_Numeric_Value=7.000000000000000e+02}', "");
    Expect(0, 126234, '\P{^Is_Numeric_Value=7.000000000000000e+02}', "");
    Error('\p{Is_Nv=/a/-_0_0_0_0_0700}');
    Error('\P{Is_Nv=/a/-_0_0_0_0_0700}');
    Expect(1, 126233, '\p{Is_Nv=0_0_0_0_0_0_700}', "");
    Expect(0, 126233, '\p{^Is_Nv=0_0_0_0_0_0_700}', "");
    Expect(0, 126233, '\P{Is_Nv=0_0_0_0_0_0_700}', "");
    Expect(1, 126233, '\P{^Is_Nv=0_0_0_0_0_0_700}', "");
    Expect(0, 126234, '\p{Is_Nv=0_0_0_0_0_0_700}', "");
    Expect(1, 126234, '\p{^Is_Nv=0_0_0_0_0_0_700}', "");
    Expect(1, 126234, '\P{Is_Nv=0_0_0_0_0_0_700}', "");
    Expect(0, 126234, '\P{^Is_Nv=0_0_0_0_0_0_700}', "");
    Expect(1, 126233, '\p{Is_Nv=7.000000000000000e+02}', "");
    Expect(0, 126233, '\p{^Is_Nv=7.000000000000000e+02}', "");
    Expect(0, 126233, '\P{Is_Nv=7.000000000000000e+02}', "");
    Expect(1, 126233, '\P{^Is_Nv=7.000000000000000e+02}', "");
    Expect(0, 126234, '\p{Is_Nv=7.000000000000000e+02}', "");
    Expect(1, 126234, '\p{^Is_Nv=7.000000000000000e+02}', "");
    Expect(1, 126234, '\P{Is_Nv=7.000000000000000e+02}', "");
    Expect(0, 126234, '\P{^Is_Nv=7.000000000000000e+02}', "");
    Error('\p{Numeric_Value=:=-_+0007000}');
    Error('\P{Numeric_Value=:=-_+0007000}');
    Expect(1, 126242, '\p{Numeric_Value=:\A7000\z:}', "");;
    Expect(0, 126243, '\p{Numeric_Value=:\A7000\z:}', "");;
    Expect(1, 126242, '\p{Numeric_Value=7000}', "");
    Expect(0, 126242, '\p{^Numeric_Value=7000}', "");
    Expect(0, 126242, '\P{Numeric_Value=7000}', "");
    Expect(1, 126242, '\P{^Numeric_Value=7000}', "");
    Expect(0, 126243, '\p{Numeric_Value=7000}', "");
    Expect(1, 126243, '\p{^Numeric_Value=7000}', "");
    Expect(1, 126243, '\P{Numeric_Value=7000}', "");
    Expect(0, 126243, '\P{^Numeric_Value=7000}', "");
    Expect(1, 126242, '\p{Numeric_Value=7.000000000000000e+03}', "");
    Expect(0, 126242, '\p{^Numeric_Value=7.000000000000000e+03}', "");
    Expect(0, 126242, '\P{Numeric_Value=7.000000000000000e+03}', "");
    Expect(1, 126242, '\P{^Numeric_Value=7.000000000000000e+03}', "");
    Expect(0, 126243, '\p{Numeric_Value=7.000000000000000e+03}', "");
    Expect(1, 126243, '\p{^Numeric_Value=7.000000000000000e+03}', "");
    Expect(1, 126243, '\P{Numeric_Value=7.000000000000000e+03}', "");
    Expect(0, 126243, '\P{^Numeric_Value=7.000000000000000e+03}', "");
    Error('\p{Nv=_	+7000:=}');
    Error('\P{Nv=_	+7000:=}');
    Expect(1, 126242, '\p{Nv=:\A7000\z:}', "");;
    Expect(0, 126243, '\p{Nv=:\A7000\z:}', "");;
    Expect(1, 126242, '\p{Nv=7_0_00}', "");
    Expect(0, 126242, '\p{^Nv=7_0_00}', "");
    Expect(0, 126242, '\P{Nv=7_0_00}', "");
    Expect(1, 126242, '\P{^Nv=7_0_00}', "");
    Expect(0, 126243, '\p{Nv=7_0_00}', "");
    Expect(1, 126243, '\p{^Nv=7_0_00}', "");
    Expect(1, 126243, '\P{Nv=7_0_00}', "");
    Expect(0, 126243, '\P{^Nv=7_0_00}', "");
    Expect(1, 126242, '\p{Nv:7.000000000000000e+03}', "");
    Expect(0, 126242, '\p{^Nv:7.000000000000000e+03}', "");
    Expect(0, 126242, '\P{Nv:7.000000000000000e+03}', "");
    Expect(1, 126242, '\P{^Nv:7.000000000000000e+03}', "");
    Expect(0, 126243, '\p{Nv:7.000000000000000e+03}', "");
    Expect(1, 126243, '\p{^Nv:7.000000000000000e+03}', "");
    Expect(1, 126243, '\P{Nv:7.000000000000000e+03}', "");
    Expect(0, 126243, '\P{^Nv:7.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value:	_/a/07000}');
    Error('\P{Is_Numeric_Value:	_/a/07000}');
    Expect(1, 126242, '\p{Is_Numeric_Value=+00_00_00_70_00}', "");
    Expect(0, 126242, '\p{^Is_Numeric_Value=+00_00_00_70_00}', "");
    Expect(0, 126242, '\P{Is_Numeric_Value=+00_00_00_70_00}', "");
    Expect(1, 126242, '\P{^Is_Numeric_Value=+00_00_00_70_00}', "");
    Expect(0, 126243, '\p{Is_Numeric_Value=+00_00_00_70_00}', "");
    Expect(1, 126243, '\p{^Is_Numeric_Value=+00_00_00_70_00}', "");
    Expect(1, 126243, '\P{Is_Numeric_Value=+00_00_00_70_00}', "");
    Expect(0, 126243, '\P{^Is_Numeric_Value=+00_00_00_70_00}', "");
    Expect(1, 126242, '\p{Is_Numeric_Value=7.000000000000000e+03}', "");
    Expect(0, 126242, '\p{^Is_Numeric_Value=7.000000000000000e+03}', "");
    Expect(0, 126242, '\P{Is_Numeric_Value=7.000000000000000e+03}', "");
    Expect(1, 126242, '\P{^Is_Numeric_Value=7.000000000000000e+03}', "");
    Expect(0, 126243, '\p{Is_Numeric_Value=7.000000000000000e+03}', "");
    Expect(1, 126243, '\p{^Is_Numeric_Value=7.000000000000000e+03}', "");
    Expect(1, 126243, '\P{Is_Numeric_Value=7.000000000000000e+03}', "");
    Expect(0, 126243, '\P{^Is_Numeric_Value=7.000000000000000e+03}', "");
    Error('\p{Is_Nv=/a/-	000_070_00}');
    Error('\P{Is_Nv=/a/-	000_070_00}');
    Expect(1, 126242, '\p{Is_Nv=0000000007000}', "");
    Expect(0, 126242, '\p{^Is_Nv=0000000007000}', "");
    Expect(0, 126242, '\P{Is_Nv=0000000007000}', "");
    Expect(1, 126242, '\P{^Is_Nv=0000000007000}', "");
    Expect(0, 126243, '\p{Is_Nv=0000000007000}', "");
    Expect(1, 126243, '\p{^Is_Nv=0000000007000}', "");
    Expect(1, 126243, '\P{Is_Nv=0000000007000}', "");
    Expect(0, 126243, '\P{^Is_Nv=0000000007000}', "");
    Expect(1, 126242, '\p{Is_Nv:   7.000000000000000e+03}', "");
    Expect(0, 126242, '\p{^Is_Nv:   7.000000000000000e+03}', "");
    Expect(0, 126242, '\P{Is_Nv:   7.000000000000000e+03}', "");
    Expect(1, 126242, '\P{^Is_Nv:   7.000000000000000e+03}', "");
    Expect(0, 126243, '\p{Is_Nv:   7.000000000000000e+03}', "");
    Expect(1, 126243, '\p{^Is_Nv:   7.000000000000000e+03}', "");
    Expect(1, 126243, '\P{Is_Nv:   7.000000000000000e+03}', "");
    Expect(0, 126243, '\P{^Is_Nv:   7.000000000000000e+03}', "");
    Error('\p{Numeric_Value:  :=7_0_0_00}');
    Error('\P{Numeric_Value:  :=7_0_0_00}');
    Expect(1, 126251, '\p{Numeric_Value=:\A70000\z:}', "");;
    Expect(0, 126252, '\p{Numeric_Value=:\A70000\z:}', "");;
    Expect(1, 126251, '\p{Numeric_Value=00_00_07_00_00}', "");
    Expect(0, 126251, '\p{^Numeric_Value=00_00_07_00_00}', "");
    Expect(0, 126251, '\P{Numeric_Value=00_00_07_00_00}', "");
    Expect(1, 126251, '\P{^Numeric_Value=00_00_07_00_00}', "");
    Expect(0, 126252, '\p{Numeric_Value=00_00_07_00_00}', "");
    Expect(1, 126252, '\p{^Numeric_Value=00_00_07_00_00}', "");
    Expect(1, 126252, '\P{Numeric_Value=00_00_07_00_00}', "");
    Expect(0, 126252, '\P{^Numeric_Value=00_00_07_00_00}', "");
    Expect(1, 126251, '\p{Numeric_Value=7.000000000000000e+04}', "");
    Expect(0, 126251, '\p{^Numeric_Value=7.000000000000000e+04}', "");
    Expect(0, 126251, '\P{Numeric_Value=7.000000000000000e+04}', "");
    Expect(1, 126251, '\P{^Numeric_Value=7.000000000000000e+04}', "");
    Expect(0, 126252, '\p{Numeric_Value=7.000000000000000e+04}', "");
    Expect(1, 126252, '\p{^Numeric_Value=7.000000000000000e+04}', "");
    Expect(1, 126252, '\P{Numeric_Value=7.000000000000000e+04}', "");
    Expect(0, 126252, '\P{^Numeric_Value=7.000000000000000e+04}', "");
    Error('\p{Nv=	/a/+0_7_0_000}');
    Error('\P{Nv=	/a/+0_7_0_000}');
    Expect(1, 126251, '\p{Nv=:\A70000\z:}', "");;
    Expect(0, 126252, '\p{Nv=:\A70000\z:}', "");;
    Expect(1, 126251, '\p{Nv=+0000007000_0}', "");
    Expect(0, 126251, '\p{^Nv=+0000007000_0}', "");
    Expect(0, 126251, '\P{Nv=+0000007000_0}', "");
    Expect(1, 126251, '\P{^Nv=+0000007000_0}', "");
    Expect(0, 126252, '\p{Nv=+0000007000_0}', "");
    Expect(1, 126252, '\p{^Nv=+0000007000_0}', "");
    Expect(1, 126252, '\P{Nv=+0000007000_0}', "");
    Expect(0, 126252, '\P{^Nv=+0000007000_0}', "");
    Expect(1, 126251, '\p{Nv=7.000000000000000e+04}', "");
    Expect(0, 126251, '\p{^Nv=7.000000000000000e+04}', "");
    Expect(0, 126251, '\P{Nv=7.000000000000000e+04}', "");
    Expect(1, 126251, '\P{^Nv=7.000000000000000e+04}', "");
    Expect(0, 126252, '\p{Nv=7.000000000000000e+04}', "");
    Expect(1, 126252, '\p{^Nv=7.000000000000000e+04}', "");
    Expect(1, 126252, '\P{Nv=7.000000000000000e+04}', "");
    Expect(0, 126252, '\P{^Nv=7.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value=-/a/70000}');
    Error('\P{Is_Numeric_Value=-/a/70000}');
    Expect(1, 126251, '\p{Is_Numeric_Value=00070000}', "");
    Expect(0, 126251, '\p{^Is_Numeric_Value=00070000}', "");
    Expect(0, 126251, '\P{Is_Numeric_Value=00070000}', "");
    Expect(1, 126251, '\P{^Is_Numeric_Value=00070000}', "");
    Expect(0, 126252, '\p{Is_Numeric_Value=00070000}', "");
    Expect(1, 126252, '\p{^Is_Numeric_Value=00070000}', "");
    Expect(1, 126252, '\P{Is_Numeric_Value=00070000}', "");
    Expect(0, 126252, '\P{^Is_Numeric_Value=00070000}', "");
    Expect(1, 126251, '\p{Is_Numeric_Value=7.000000000000000e+04}', "");
    Expect(0, 126251, '\p{^Is_Numeric_Value=7.000000000000000e+04}', "");
    Expect(0, 126251, '\P{Is_Numeric_Value=7.000000000000000e+04}', "");
    Expect(1, 126251, '\P{^Is_Numeric_Value=7.000000000000000e+04}', "");
    Expect(0, 126252, '\p{Is_Numeric_Value=7.000000000000000e+04}', "");
    Expect(1, 126252, '\p{^Is_Numeric_Value=7.000000000000000e+04}', "");
    Expect(1, 126252, '\P{Is_Numeric_Value=7.000000000000000e+04}', "");
    Expect(0, 126252, '\P{^Is_Numeric_Value=7.000000000000000e+04}', "");
    Error('\p{Is_Nv=	:=+00_00_70_00_0}');
    Error('\P{Is_Nv=	:=+00_00_70_00_0}');
    Expect(1, 126251, '\p{Is_Nv=+70000}', "");
    Expect(0, 126251, '\p{^Is_Nv=+70000}', "");
    Expect(0, 126251, '\P{Is_Nv=+70000}', "");
    Expect(1, 126251, '\P{^Is_Nv=+70000}', "");
    Expect(0, 126252, '\p{Is_Nv=+70000}', "");
    Expect(1, 126252, '\p{^Is_Nv=+70000}', "");
    Expect(1, 126252, '\P{Is_Nv=+70000}', "");
    Expect(0, 126252, '\P{^Is_Nv=+70000}', "");
    Expect(1, 126251, '\p{Is_Nv=7.000000000000000e+04}', "");
    Expect(0, 126251, '\p{^Is_Nv=7.000000000000000e+04}', "");
    Expect(0, 126251, '\P{Is_Nv=7.000000000000000e+04}', "");
    Expect(1, 126251, '\P{^Is_Nv=7.000000000000000e+04}', "");
    Expect(0, 126252, '\p{Is_Nv=7.000000000000000e+04}', "");
    Expect(1, 126252, '\p{^Is_Nv=7.000000000000000e+04}', "");
    Expect(1, 126252, '\P{Is_Nv=7.000000000000000e+04}', "");
    Expect(0, 126252, '\P{^Is_Nv=7.000000000000000e+04}', "");
    Error('\p{Numeric_Value=-/a/070_000_0}');
    Error('\P{Numeric_Value=-/a/070_000_0}');
    Expect(1, 68083, '\p{Numeric_Value=:\A700000\z:}', "");;
    Expect(0, 68084, '\p{Numeric_Value=:\A700000\z:}', "");;
    Expect(1, 68083, '\p{Numeric_Value=0_0_0_0_0_0_7_0_0_0_00}', "");
    Expect(0, 68083, '\p{^Numeric_Value=0_0_0_0_0_0_7_0_0_0_00}', "");
    Expect(0, 68083, '\P{Numeric_Value=0_0_0_0_0_0_7_0_0_0_00}', "");
    Expect(1, 68083, '\P{^Numeric_Value=0_0_0_0_0_0_7_0_0_0_00}', "");
    Expect(0, 68084, '\p{Numeric_Value=0_0_0_0_0_0_7_0_0_0_00}', "");
    Expect(1, 68084, '\p{^Numeric_Value=0_0_0_0_0_0_7_0_0_0_00}', "");
    Expect(1, 68084, '\P{Numeric_Value=0_0_0_0_0_0_7_0_0_0_00}', "");
    Expect(0, 68084, '\P{^Numeric_Value=0_0_0_0_0_0_7_0_0_0_00}', "");
    Expect(1, 68083, '\p{Numeric_Value=7.000000000000000e+05}', "");
    Expect(0, 68083, '\p{^Numeric_Value=7.000000000000000e+05}', "");
    Expect(0, 68083, '\P{Numeric_Value=7.000000000000000e+05}', "");
    Expect(1, 68083, '\P{^Numeric_Value=7.000000000000000e+05}', "");
    Expect(0, 68084, '\p{Numeric_Value=7.000000000000000e+05}', "");
    Expect(1, 68084, '\p{^Numeric_Value=7.000000000000000e+05}', "");
    Expect(1, 68084, '\P{Numeric_Value=7.000000000000000e+05}', "");
    Expect(0, 68084, '\P{^Numeric_Value=7.000000000000000e+05}', "");
    Error('\p{Nv=-0000_0007_0000_0/a/}');
    Error('\P{Nv=-0000_0007_0000_0/a/}');
    Expect(1, 68083, '\p{Nv=:\A700000\z:}', "");;
    Expect(0, 68084, '\p{Nv=:\A700000\z:}', "");;
    Expect(1, 68083, '\p{Nv:   0700000}', "");
    Expect(0, 68083, '\p{^Nv:   0700000}', "");
    Expect(0, 68083, '\P{Nv:   0700000}', "");
    Expect(1, 68083, '\P{^Nv:   0700000}', "");
    Expect(0, 68084, '\p{Nv:   0700000}', "");
    Expect(1, 68084, '\p{^Nv:   0700000}', "");
    Expect(1, 68084, '\P{Nv:   0700000}', "");
    Expect(0, 68084, '\P{^Nv:   0700000}', "");
    Expect(1, 68083, '\p{Nv=7.000000000000000e+05}', "");
    Expect(0, 68083, '\p{^Nv=7.000000000000000e+05}', "");
    Expect(0, 68083, '\P{Nv=7.000000000000000e+05}', "");
    Expect(1, 68083, '\P{^Nv=7.000000000000000e+05}', "");
    Expect(0, 68084, '\p{Nv=7.000000000000000e+05}', "");
    Expect(1, 68084, '\p{^Nv=7.000000000000000e+05}', "");
    Expect(1, 68084, '\P{Nv=7.000000000000000e+05}', "");
    Expect(0, 68084, '\P{^Nv=7.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value=		00_00_70_00_00:=}');
    Error('\P{Is_Numeric_Value=		00_00_70_00_00:=}');
    Expect(1, 68083, '\p{Is_Numeric_Value:	+00000700000}', "");
    Expect(0, 68083, '\p{^Is_Numeric_Value:	+00000700000}', "");
    Expect(0, 68083, '\P{Is_Numeric_Value:	+00000700000}', "");
    Expect(1, 68083, '\P{^Is_Numeric_Value:	+00000700000}', "");
    Expect(0, 68084, '\p{Is_Numeric_Value:	+00000700000}', "");
    Expect(1, 68084, '\p{^Is_Numeric_Value:	+00000700000}', "");
    Expect(1, 68084, '\P{Is_Numeric_Value:	+00000700000}', "");
    Expect(0, 68084, '\P{^Is_Numeric_Value:	+00000700000}', "");
    Expect(1, 68083, '\p{Is_Numeric_Value=7.000000000000000e+05}', "");
    Expect(0, 68083, '\p{^Is_Numeric_Value=7.000000000000000e+05}', "");
    Expect(0, 68083, '\P{Is_Numeric_Value=7.000000000000000e+05}', "");
    Expect(1, 68083, '\P{^Is_Numeric_Value=7.000000000000000e+05}', "");
    Expect(0, 68084, '\p{Is_Numeric_Value=7.000000000000000e+05}', "");
    Expect(1, 68084, '\p{^Is_Numeric_Value=7.000000000000000e+05}', "");
    Expect(1, 68084, '\P{Is_Numeric_Value=7.000000000000000e+05}', "");
    Expect(0, 68084, '\P{^Is_Numeric_Value=7.000000000000000e+05}', "");
    Error('\p{Is_Nv=-000700000:=}');
    Error('\P{Is_Nv=-000700000:=}');
    Expect(1, 68083, '\p{Is_Nv=+000_007_000_00}', "");
    Expect(0, 68083, '\p{^Is_Nv=+000_007_000_00}', "");
    Expect(0, 68083, '\P{Is_Nv=+000_007_000_00}', "");
    Expect(1, 68083, '\P{^Is_Nv=+000_007_000_00}', "");
    Expect(0, 68084, '\p{Is_Nv=+000_007_000_00}', "");
    Expect(1, 68084, '\p{^Is_Nv=+000_007_000_00}', "");
    Expect(1, 68084, '\P{Is_Nv=+000_007_000_00}', "");
    Expect(0, 68084, '\P{^Is_Nv=+000_007_000_00}', "");
    Expect(1, 68083, '\p{Is_Nv=7.000000000000000e+05}', "");
    Expect(0, 68083, '\p{^Is_Nv=7.000000000000000e+05}', "");
    Expect(0, 68083, '\P{Is_Nv=7.000000000000000e+05}', "");
    Expect(1, 68083, '\P{^Is_Nv=7.000000000000000e+05}', "");
    Expect(0, 68084, '\p{Is_Nv=7.000000000000000e+05}', "");
    Expect(1, 68084, '\p{^Is_Nv=7.000000000000000e+05}', "");
    Expect(1, 68084, '\P{Is_Nv=7.000000000000000e+05}', "");
    Expect(0, 68084, '\P{^Is_Nv=7.000000000000000e+05}', "");
    Error('\p{Numeric_Value=/a/	000008}');
    Error('\P{Numeric_Value=/a/	000008}');
    Expect(1, 127241, '\p{Numeric_Value=:\A8\z:}', "");;
    Expect(0, 127242, '\p{Numeric_Value=:\A8\z:}', "");;
    Expect(1, 127241, '\p{Numeric_Value=00_00_00_00_08}', "");
    Expect(0, 127241, '\p{^Numeric_Value=00_00_00_00_08}', "");
    Expect(0, 127241, '\P{Numeric_Value=00_00_00_00_08}', "");
    Expect(1, 127241, '\P{^Numeric_Value=00_00_00_00_08}', "");
    Expect(0, 127242, '\p{Numeric_Value=00_00_00_00_08}', "");
    Expect(1, 127242, '\p{^Numeric_Value=00_00_00_00_08}', "");
    Expect(1, 127242, '\P{Numeric_Value=00_00_00_00_08}', "");
    Expect(0, 127242, '\P{^Numeric_Value=00_00_00_00_08}', "");
    Expect(1, 127241, '\p{Numeric_Value=8.000000000000000e+00}', "");
    Expect(0, 127241, '\p{^Numeric_Value=8.000000000000000e+00}', "");
    Expect(0, 127241, '\P{Numeric_Value=8.000000000000000e+00}', "");
    Expect(1, 127241, '\P{^Numeric_Value=8.000000000000000e+00}', "");
    Expect(0, 127242, '\p{Numeric_Value=8.000000000000000e+00}', "");
    Expect(1, 127242, '\p{^Numeric_Value=8.000000000000000e+00}', "");
    Expect(1, 127242, '\P{Numeric_Value=8.000000000000000e+00}', "");
    Expect(0, 127242, '\P{^Numeric_Value=8.000000000000000e+00}', "");
    Error('\p{Nv=:=+0_0_0_0_0_0_0_0_08}');
    Error('\P{Nv=:=+0_0_0_0_0_0_0_0_08}');
    Expect(1, 127241, '\p{Nv=:\A8\z:}', "");;
    Expect(0, 127242, '\p{Nv=:\A8\z:}', "");;
    Expect(1, 127241, '\p{Nv=0000_0000_08}', "");
    Expect(0, 127241, '\p{^Nv=0000_0000_08}', "");
    Expect(0, 127241, '\P{Nv=0000_0000_08}', "");
    Expect(1, 127241, '\P{^Nv=0000_0000_08}', "");
    Expect(0, 127242, '\p{Nv=0000_0000_08}', "");
    Expect(1, 127242, '\p{^Nv=0000_0000_08}', "");
    Expect(1, 127242, '\P{Nv=0000_0000_08}', "");
    Expect(0, 127242, '\P{^Nv=0000_0000_08}', "");
    Expect(1, 127241, '\p{Nv=8.000000000000000e+00}', "");
    Expect(0, 127241, '\p{^Nv=8.000000000000000e+00}', "");
    Expect(0, 127241, '\P{Nv=8.000000000000000e+00}', "");
    Expect(1, 127241, '\P{^Nv=8.000000000000000e+00}', "");
    Expect(0, 127242, '\p{Nv=8.000000000000000e+00}', "");
    Expect(1, 127242, '\p{^Nv=8.000000000000000e+00}', "");
    Expect(1, 127242, '\P{Nv=8.000000000000000e+00}', "");
    Expect(0, 127242, '\P{^Nv=8.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value=_	08/a/}');
    Error('\P{Is_Numeric_Value=_	08/a/}');
    Expect(1, 127241, '\p{Is_Numeric_Value=8}', "");
    Expect(0, 127241, '\p{^Is_Numeric_Value=8}', "");
    Expect(0, 127241, '\P{Is_Numeric_Value=8}', "");
    Expect(1, 127241, '\P{^Is_Numeric_Value=8}', "");
    Expect(0, 127242, '\p{Is_Numeric_Value=8}', "");
    Expect(1, 127242, '\p{^Is_Numeric_Value=8}', "");
    Expect(1, 127242, '\P{Is_Numeric_Value=8}', "");
    Expect(0, 127242, '\P{^Is_Numeric_Value=8}', "");
    Expect(1, 127241, '\p{Is_Numeric_Value=8.000000000000000e+00}', "");
    Expect(0, 127241, '\p{^Is_Numeric_Value=8.000000000000000e+00}', "");
    Expect(0, 127241, '\P{Is_Numeric_Value=8.000000000000000e+00}', "");
    Expect(1, 127241, '\P{^Is_Numeric_Value=8.000000000000000e+00}', "");
    Expect(0, 127242, '\p{Is_Numeric_Value=8.000000000000000e+00}', "");
    Expect(1, 127242, '\p{^Is_Numeric_Value=8.000000000000000e+00}', "");
    Expect(1, 127242, '\P{Is_Numeric_Value=8.000000000000000e+00}', "");
    Expect(0, 127242, '\P{^Is_Numeric_Value=8.000000000000000e+00}', "");
    Error('\p{Is_Nv:		+00_00_8:=}');
    Error('\P{Is_Nv:		+00_00_8:=}');
    Expect(1, 127241, '\p{Is_Nv=+8}', "");
    Expect(0, 127241, '\p{^Is_Nv=+8}', "");
    Expect(0, 127241, '\P{Is_Nv=+8}', "");
    Expect(1, 127241, '\P{^Is_Nv=+8}', "");
    Expect(0, 127242, '\p{Is_Nv=+8}', "");
    Expect(1, 127242, '\p{^Is_Nv=+8}', "");
    Expect(1, 127242, '\P{Is_Nv=+8}', "");
    Expect(0, 127242, '\P{^Is_Nv=+8}', "");
    Expect(1, 127241, '\p{Is_Nv=8.000000000000000e+00}', "");
    Expect(0, 127241, '\p{^Is_Nv=8.000000000000000e+00}', "");
    Expect(0, 127241, '\P{Is_Nv=8.000000000000000e+00}', "");
    Expect(1, 127241, '\P{^Is_Nv=8.000000000000000e+00}', "");
    Expect(0, 127242, '\p{Is_Nv=8.000000000000000e+00}', "");
    Expect(1, 127242, '\p{^Is_Nv=8.000000000000000e+00}', "");
    Expect(1, 127242, '\P{Is_Nv=8.000000000000000e+00}', "");
    Expect(0, 127242, '\P{^Is_Nv=8.000000000000000e+00}', "");
    Error('\p{Numeric_Value=-:=0_0_0_0_0_0_80}');
    Error('\P{Numeric_Value=-:=0_0_0_0_0_0_80}');
    Expect(1, 126225, '\p{Numeric_Value=:\A80\z:}', "");;
    Expect(0, 126226, '\p{Numeric_Value=:\A80\z:}', "");;
    Expect(1, 126225, '\p{Numeric_Value:   +00080}', "");
    Expect(0, 126225, '\p{^Numeric_Value:   +00080}', "");
    Expect(0, 126225, '\P{Numeric_Value:   +00080}', "");
    Expect(1, 126225, '\P{^Numeric_Value:   +00080}', "");
    Expect(0, 126226, '\p{Numeric_Value:   +00080}', "");
    Expect(1, 126226, '\p{^Numeric_Value:   +00080}', "");
    Expect(1, 126226, '\P{Numeric_Value:   +00080}', "");
    Expect(0, 126226, '\P{^Numeric_Value:   +00080}', "");
    Expect(1, 126225, '\p{Numeric_Value=8.000000000000000e+01}', "");
    Expect(0, 126225, '\p{^Numeric_Value=8.000000000000000e+01}', "");
    Expect(0, 126225, '\P{Numeric_Value=8.000000000000000e+01}', "");
    Expect(1, 126225, '\P{^Numeric_Value=8.000000000000000e+01}', "");
    Expect(0, 126226, '\p{Numeric_Value=8.000000000000000e+01}', "");
    Expect(1, 126226, '\p{^Numeric_Value=8.000000000000000e+01}', "");
    Expect(1, 126226, '\P{Numeric_Value=8.000000000000000e+01}', "");
    Expect(0, 126226, '\P{^Numeric_Value=8.000000000000000e+01}', "");
    Error('\p{Nv=-:=0000080}');
    Error('\P{Nv=-:=0000080}');
    Expect(1, 126225, '\p{Nv=:\A80\z:}', "");;
    Expect(0, 126226, '\p{Nv=:\A80\z:}', "");;
    Expect(1, 126225, '\p{Nv=+0_0_0_0_0_0_80}', "");
    Expect(0, 126225, '\p{^Nv=+0_0_0_0_0_0_80}', "");
    Expect(0, 126225, '\P{Nv=+0_0_0_0_0_0_80}', "");
    Expect(1, 126225, '\P{^Nv=+0_0_0_0_0_0_80}', "");
    Expect(0, 126226, '\p{Nv=+0_0_0_0_0_0_80}', "");
    Expect(1, 126226, '\p{^Nv=+0_0_0_0_0_0_80}', "");
    Expect(1, 126226, '\P{Nv=+0_0_0_0_0_0_80}', "");
    Expect(0, 126226, '\P{^Nv=+0_0_0_0_0_0_80}', "");
    Expect(1, 126225, '\p{Nv=8.000000000000000e+01}', "");
    Expect(0, 126225, '\p{^Nv=8.000000000000000e+01}', "");
    Expect(0, 126225, '\P{Nv=8.000000000000000e+01}', "");
    Expect(1, 126225, '\P{^Nv=8.000000000000000e+01}', "");
    Expect(0, 126226, '\p{Nv=8.000000000000000e+01}', "");
    Expect(1, 126226, '\p{^Nv=8.000000000000000e+01}', "");
    Expect(1, 126226, '\P{Nv=8.000000000000000e+01}', "");
    Expect(0, 126226, '\P{^Nv=8.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=/a/	+00_00_00_08_0}');
    Error('\P{Is_Numeric_Value=/a/	+00_00_00_08_0}');
    Expect(1, 126225, '\p{Is_Numeric_Value=0_0_0_080}', "");
    Expect(0, 126225, '\p{^Is_Numeric_Value=0_0_0_080}', "");
    Expect(0, 126225, '\P{Is_Numeric_Value=0_0_0_080}', "");
    Expect(1, 126225, '\P{^Is_Numeric_Value=0_0_0_080}', "");
    Expect(0, 126226, '\p{Is_Numeric_Value=0_0_0_080}', "");
    Expect(1, 126226, '\p{^Is_Numeric_Value=0_0_0_080}', "");
    Expect(1, 126226, '\P{Is_Numeric_Value=0_0_0_080}', "");
    Expect(0, 126226, '\P{^Is_Numeric_Value=0_0_0_080}', "");
    Expect(1, 126225, '\p{Is_Numeric_Value=8.000000000000000e+01}', "");
    Expect(0, 126225, '\p{^Is_Numeric_Value=8.000000000000000e+01}', "");
    Expect(0, 126225, '\P{Is_Numeric_Value=8.000000000000000e+01}', "");
    Expect(1, 126225, '\P{^Is_Numeric_Value=8.000000000000000e+01}', "");
    Expect(0, 126226, '\p{Is_Numeric_Value=8.000000000000000e+01}', "");
    Expect(1, 126226, '\p{^Is_Numeric_Value=8.000000000000000e+01}', "");
    Expect(1, 126226, '\P{Is_Numeric_Value=8.000000000000000e+01}', "");
    Expect(0, 126226, '\P{^Is_Numeric_Value=8.000000000000000e+01}', "");
    Error('\p{Is_Nv=/a/  0008_0}');
    Error('\P{Is_Nv=/a/  0008_0}');
    Expect(1, 126225, '\p{Is_Nv=0_0_0_80}', "");
    Expect(0, 126225, '\p{^Is_Nv=0_0_0_80}', "");
    Expect(0, 126225, '\P{Is_Nv=0_0_0_80}', "");
    Expect(1, 126225, '\P{^Is_Nv=0_0_0_80}', "");
    Expect(0, 126226, '\p{Is_Nv=0_0_0_80}', "");
    Expect(1, 126226, '\p{^Is_Nv=0_0_0_80}', "");
    Expect(1, 126226, '\P{Is_Nv=0_0_0_80}', "");
    Expect(0, 126226, '\P{^Is_Nv=0_0_0_80}', "");
    Expect(1, 126225, '\p{Is_Nv=8.000000000000000e+01}', "");
    Expect(0, 126225, '\p{^Is_Nv=8.000000000000000e+01}', "");
    Expect(0, 126225, '\P{Is_Nv=8.000000000000000e+01}', "");
    Expect(1, 126225, '\P{^Is_Nv=8.000000000000000e+01}', "");
    Expect(0, 126226, '\p{Is_Nv=8.000000000000000e+01}', "");
    Expect(1, 126226, '\p{^Is_Nv=8.000000000000000e+01}', "");
    Expect(1, 126226, '\P{Is_Nv=8.000000000000000e+01}', "");
    Expect(0, 126226, '\P{^Is_Nv=8.000000000000000e+01}', "");
    Error('\p{Numeric_Value=_-0080_0:=}');
    Error('\P{Numeric_Value=_-0080_0:=}');
    Expect(1, 126234, '\p{Numeric_Value=:\A800\z:}', "");;
    Expect(0, 126235, '\p{Numeric_Value=:\A800\z:}', "");;
    Expect(1, 126234, '\p{Numeric_Value=00000000800}', "");
    Expect(0, 126234, '\p{^Numeric_Value=00000000800}', "");
    Expect(0, 126234, '\P{Numeric_Value=00000000800}', "");
    Expect(1, 126234, '\P{^Numeric_Value=00000000800}', "");
    Expect(0, 126235, '\p{Numeric_Value=00000000800}', "");
    Expect(1, 126235, '\p{^Numeric_Value=00000000800}', "");
    Expect(1, 126235, '\P{Numeric_Value=00000000800}', "");
    Expect(0, 126235, '\P{^Numeric_Value=00000000800}', "");
    Expect(1, 126234, '\p{Numeric_Value=8.000000000000000e+02}', "");
    Expect(0, 126234, '\p{^Numeric_Value=8.000000000000000e+02}', "");
    Expect(0, 126234, '\P{Numeric_Value=8.000000000000000e+02}', "");
    Expect(1, 126234, '\P{^Numeric_Value=8.000000000000000e+02}', "");
    Expect(0, 126235, '\p{Numeric_Value=8.000000000000000e+02}', "");
    Expect(1, 126235, '\p{^Numeric_Value=8.000000000000000e+02}', "");
    Expect(1, 126235, '\P{Numeric_Value=8.000000000000000e+02}', "");
    Expect(0, 126235, '\P{^Numeric_Value=8.000000000000000e+02}', "");
    Error('\p{Nv=/a/ +00000800}');
    Error('\P{Nv=/a/ +00000800}');
    Expect(1, 126234, '\p{Nv=:\A800\z:}', "");;
    Expect(0, 126235, '\p{Nv=:\A800\z:}', "");;
    Expect(1, 126234, '\p{Nv=000800}', "");
    Expect(0, 126234, '\p{^Nv=000800}', "");
    Expect(0, 126234, '\P{Nv=000800}', "");
    Expect(1, 126234, '\P{^Nv=000800}', "");
    Expect(0, 126235, '\p{Nv=000800}', "");
    Expect(1, 126235, '\p{^Nv=000800}', "");
    Expect(1, 126235, '\P{Nv=000800}', "");
    Expect(0, 126235, '\P{^Nv=000800}', "");
    Expect(1, 126234, '\p{Nv=8.000000000000000e+02}', "");
    Expect(0, 126234, '\p{^Nv=8.000000000000000e+02}', "");
    Expect(0, 126234, '\P{Nv=8.000000000000000e+02}', "");
    Expect(1, 126234, '\P{^Nv=8.000000000000000e+02}', "");
    Expect(0, 126235, '\p{Nv=8.000000000000000e+02}', "");
    Expect(1, 126235, '\p{^Nv=8.000000000000000e+02}', "");
    Expect(1, 126235, '\P{Nv=8.000000000000000e+02}', "");
    Expect(0, 126235, '\P{^Nv=8.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value= -000800/a/}');
    Error('\P{Is_Numeric_Value= -000800/a/}');
    Expect(1, 126234, '\p{Is_Numeric_Value=+000000800}', "");
    Expect(0, 126234, '\p{^Is_Numeric_Value=+000000800}', "");
    Expect(0, 126234, '\P{Is_Numeric_Value=+000000800}', "");
    Expect(1, 126234, '\P{^Is_Numeric_Value=+000000800}', "");
    Expect(0, 126235, '\p{Is_Numeric_Value=+000000800}', "");
    Expect(1, 126235, '\p{^Is_Numeric_Value=+000000800}', "");
    Expect(1, 126235, '\P{Is_Numeric_Value=+000000800}', "");
    Expect(0, 126235, '\P{^Is_Numeric_Value=+000000800}', "");
    Expect(1, 126234, '\p{Is_Numeric_Value=8.000000000000000e+02}', "");
    Expect(0, 126234, '\p{^Is_Numeric_Value=8.000000000000000e+02}', "");
    Expect(0, 126234, '\P{Is_Numeric_Value=8.000000000000000e+02}', "");
    Expect(1, 126234, '\P{^Is_Numeric_Value=8.000000000000000e+02}', "");
    Expect(0, 126235, '\p{Is_Numeric_Value=8.000000000000000e+02}', "");
    Expect(1, 126235, '\p{^Is_Numeric_Value=8.000000000000000e+02}', "");
    Expect(1, 126235, '\P{Is_Numeric_Value=8.000000000000000e+02}', "");
    Expect(0, 126235, '\P{^Is_Numeric_Value=8.000000000000000e+02}', "");
    Error('\p{Is_Nv=/a/	-00800}');
    Error('\P{Is_Nv=/a/	-00800}');
    Expect(1, 126234, '\p{Is_Nv=000000800}', "");
    Expect(0, 126234, '\p{^Is_Nv=000000800}', "");
    Expect(0, 126234, '\P{Is_Nv=000000800}', "");
    Expect(1, 126234, '\P{^Is_Nv=000000800}', "");
    Expect(0, 126235, '\p{Is_Nv=000000800}', "");
    Expect(1, 126235, '\p{^Is_Nv=000000800}', "");
    Expect(1, 126235, '\P{Is_Nv=000000800}', "");
    Expect(0, 126235, '\P{^Is_Nv=000000800}', "");
    Expect(1, 126234, '\p{Is_Nv=8.000000000000000e+02}', "");
    Expect(0, 126234, '\p{^Is_Nv=8.000000000000000e+02}', "");
    Expect(0, 126234, '\P{Is_Nv=8.000000000000000e+02}', "");
    Expect(1, 126234, '\P{^Is_Nv=8.000000000000000e+02}', "");
    Expect(0, 126235, '\p{Is_Nv=8.000000000000000e+02}', "");
    Expect(1, 126235, '\p{^Is_Nv=8.000000000000000e+02}', "");
    Expect(1, 126235, '\P{Is_Nv=8.000000000000000e+02}', "");
    Expect(0, 126235, '\P{^Is_Nv=8.000000000000000e+02}', "");
    Error('\p{Numeric_Value=_:=+000000008000}');
    Error('\P{Numeric_Value=_:=+000000008000}');
    Expect(1, 126243, '\p{Numeric_Value=:\A8000\z:}', "");;
    Expect(0, 126244, '\p{Numeric_Value=:\A8000\z:}', "");;
    Expect(1, 126243, '\p{Numeric_Value=0000008000}', "");
    Expect(0, 126243, '\p{^Numeric_Value=0000008000}', "");
    Expect(0, 126243, '\P{Numeric_Value=0000008000}', "");
    Expect(1, 126243, '\P{^Numeric_Value=0000008000}', "");
    Expect(0, 126244, '\p{Numeric_Value=0000008000}', "");
    Expect(1, 126244, '\p{^Numeric_Value=0000008000}', "");
    Expect(1, 126244, '\P{Numeric_Value=0000008000}', "");
    Expect(0, 126244, '\P{^Numeric_Value=0000008000}', "");
    Expect(1, 126243, '\p{Numeric_Value=8.000000000000000e+03}', "");
    Expect(0, 126243, '\p{^Numeric_Value=8.000000000000000e+03}', "");
    Expect(0, 126243, '\P{Numeric_Value=8.000000000000000e+03}', "");
    Expect(1, 126243, '\P{^Numeric_Value=8.000000000000000e+03}', "");
    Expect(0, 126244, '\p{Numeric_Value=8.000000000000000e+03}', "");
    Expect(1, 126244, '\p{^Numeric_Value=8.000000000000000e+03}', "");
    Expect(1, 126244, '\P{Numeric_Value=8.000000000000000e+03}', "");
    Expect(0, 126244, '\P{^Numeric_Value=8.000000000000000e+03}', "");
    Error('\p{Nv= 8_0_00:=}');
    Error('\P{Nv= 8_0_00:=}');
    Expect(1, 126243, '\p{Nv=:\A8000\z:}', "");;
    Expect(0, 126244, '\p{Nv=:\A8000\z:}', "");;
    Expect(1, 126243, '\p{Nv=8000}', "");
    Expect(0, 126243, '\p{^Nv=8000}', "");
    Expect(0, 126243, '\P{Nv=8000}', "");
    Expect(1, 126243, '\P{^Nv=8000}', "");
    Expect(0, 126244, '\p{Nv=8000}', "");
    Expect(1, 126244, '\p{^Nv=8000}', "");
    Expect(1, 126244, '\P{Nv=8000}', "");
    Expect(0, 126244, '\P{^Nv=8000}', "");
    Expect(1, 126243, '\p{Nv=8.000000000000000e+03}', "");
    Expect(0, 126243, '\p{^Nv=8.000000000000000e+03}', "");
    Expect(0, 126243, '\P{Nv=8.000000000000000e+03}', "");
    Expect(1, 126243, '\P{^Nv=8.000000000000000e+03}', "");
    Expect(0, 126244, '\p{Nv=8.000000000000000e+03}', "");
    Expect(1, 126244, '\p{^Nv=8.000000000000000e+03}', "");
    Expect(1, 126244, '\P{Nv=8.000000000000000e+03}', "");
    Expect(0, 126244, '\P{^Nv=8.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value=/a/	-0_0_0_0_0_0_0_0_8_0_00}');
    Error('\P{Is_Numeric_Value=/a/	-0_0_0_0_0_0_0_0_8_0_00}');
    Expect(1, 126243, '\p{Is_Numeric_Value=+08000}', "");
    Expect(0, 126243, '\p{^Is_Numeric_Value=+08000}', "");
    Expect(0, 126243, '\P{Is_Numeric_Value=+08000}', "");
    Expect(1, 126243, '\P{^Is_Numeric_Value=+08000}', "");
    Expect(0, 126244, '\p{Is_Numeric_Value=+08000}', "");
    Expect(1, 126244, '\p{^Is_Numeric_Value=+08000}', "");
    Expect(1, 126244, '\P{Is_Numeric_Value=+08000}', "");
    Expect(0, 126244, '\P{^Is_Numeric_Value=+08000}', "");
    Expect(1, 126243, '\p{Is_Numeric_Value=8.000000000000000e+03}', "");
    Expect(0, 126243, '\p{^Is_Numeric_Value=8.000000000000000e+03}', "");
    Expect(0, 126243, '\P{Is_Numeric_Value=8.000000000000000e+03}', "");
    Expect(1, 126243, '\P{^Is_Numeric_Value=8.000000000000000e+03}', "");
    Expect(0, 126244, '\p{Is_Numeric_Value=8.000000000000000e+03}', "");
    Expect(1, 126244, '\p{^Is_Numeric_Value=8.000000000000000e+03}', "");
    Expect(1, 126244, '\P{Is_Numeric_Value=8.000000000000000e+03}', "");
    Expect(0, 126244, '\P{^Is_Numeric_Value=8.000000000000000e+03}', "");
    Error('\p{Is_Nv=_-+8000/a/}');
    Error('\P{Is_Nv=_-+8000/a/}');
    Expect(1, 126243, '\p{Is_Nv=8000}', "");
    Expect(0, 126243, '\p{^Is_Nv=8000}', "");
    Expect(0, 126243, '\P{Is_Nv=8000}', "");
    Expect(1, 126243, '\P{^Is_Nv=8000}', "");
    Expect(0, 126244, '\p{Is_Nv=8000}', "");
    Expect(1, 126244, '\p{^Is_Nv=8000}', "");
    Expect(1, 126244, '\P{Is_Nv=8000}', "");
    Expect(0, 126244, '\P{^Is_Nv=8000}', "");
    Expect(1, 126243, '\p{Is_Nv=8.000000000000000e+03}', "");
    Expect(0, 126243, '\p{^Is_Nv=8.000000000000000e+03}', "");
    Expect(0, 126243, '\P{Is_Nv=8.000000000000000e+03}', "");
    Expect(1, 126243, '\P{^Is_Nv=8.000000000000000e+03}', "");
    Expect(0, 126244, '\p{Is_Nv=8.000000000000000e+03}', "");
    Expect(1, 126244, '\p{^Is_Nv=8.000000000000000e+03}', "");
    Expect(1, 126244, '\P{Is_Nv=8.000000000000000e+03}', "");
    Expect(0, 126244, '\P{^Is_Nv=8.000000000000000e+03}', "");
    Error('\p{Numeric_Value=	-+0_0_0_8_0000/a/}');
    Error('\P{Numeric_Value=	-+0_0_0_8_0000/a/}');
    Expect(1, 126252, '\p{Numeric_Value=:\A80000\z:}', "");;
    Expect(0, 126253, '\p{Numeric_Value=:\A80000\z:}', "");;
    Expect(1, 126252, '\p{Numeric_Value=0000000080000}', "");
    Expect(0, 126252, '\p{^Numeric_Value=0000000080000}', "");
    Expect(0, 126252, '\P{Numeric_Value=0000000080000}', "");
    Expect(1, 126252, '\P{^Numeric_Value=0000000080000}', "");
    Expect(0, 126253, '\p{Numeric_Value=0000000080000}', "");
    Expect(1, 126253, '\p{^Numeric_Value=0000000080000}', "");
    Expect(1, 126253, '\P{Numeric_Value=0000000080000}', "");
    Expect(0, 126253, '\P{^Numeric_Value=0000000080000}', "");
    Expect(1, 126252, '\p{Numeric_Value=8.000000000000000e+04}', "");
    Expect(0, 126252, '\p{^Numeric_Value=8.000000000000000e+04}', "");
    Expect(0, 126252, '\P{Numeric_Value=8.000000000000000e+04}', "");
    Expect(1, 126252, '\P{^Numeric_Value=8.000000000000000e+04}', "");
    Expect(0, 126253, '\p{Numeric_Value=8.000000000000000e+04}', "");
    Expect(1, 126253, '\p{^Numeric_Value=8.000000000000000e+04}', "");
    Expect(1, 126253, '\P{Numeric_Value=8.000000000000000e+04}', "");
    Expect(0, 126253, '\P{^Numeric_Value=8.000000000000000e+04}', "");
    Error('\p{Nv=:= -000000080000}');
    Error('\P{Nv=:= -000000080000}');
    Expect(1, 126252, '\p{Nv=:\A80000\z:}', "");;
    Expect(0, 126253, '\p{Nv=:\A80000\z:}', "");;
    Expect(1, 126252, '\p{Nv=+0_8_0_000}', "");
    Expect(0, 126252, '\p{^Nv=+0_8_0_000}', "");
    Expect(0, 126252, '\P{Nv=+0_8_0_000}', "");
    Expect(1, 126252, '\P{^Nv=+0_8_0_000}', "");
    Expect(0, 126253, '\p{Nv=+0_8_0_000}', "");
    Expect(1, 126253, '\p{^Nv=+0_8_0_000}', "");
    Expect(1, 126253, '\P{Nv=+0_8_0_000}', "");
    Expect(0, 126253, '\P{^Nv=+0_8_0_000}', "");
    Expect(1, 126252, '\p{Nv=8.000000000000000e+04}', "");
    Expect(0, 126252, '\p{^Nv=8.000000000000000e+04}', "");
    Expect(0, 126252, '\P{Nv=8.000000000000000e+04}', "");
    Expect(1, 126252, '\P{^Nv=8.000000000000000e+04}', "");
    Expect(0, 126253, '\p{Nv=8.000000000000000e+04}', "");
    Expect(1, 126253, '\p{^Nv=8.000000000000000e+04}', "");
    Expect(1, 126253, '\P{Nv=8.000000000000000e+04}', "");
    Expect(0, 126253, '\P{^Nv=8.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value=- 000000080000/a/}');
    Error('\P{Is_Numeric_Value=- 000000080000/a/}');
    Expect(1, 126252, '\p{Is_Numeric_Value=0_0_0_8_0_0_00}', "");
    Expect(0, 126252, '\p{^Is_Numeric_Value=0_0_0_8_0_0_00}', "");
    Expect(0, 126252, '\P{Is_Numeric_Value=0_0_0_8_0_0_00}', "");
    Expect(1, 126252, '\P{^Is_Numeric_Value=0_0_0_8_0_0_00}', "");
    Expect(0, 126253, '\p{Is_Numeric_Value=0_0_0_8_0_0_00}', "");
    Expect(1, 126253, '\p{^Is_Numeric_Value=0_0_0_8_0_0_00}', "");
    Expect(1, 126253, '\P{Is_Numeric_Value=0_0_0_8_0_0_00}', "");
    Expect(0, 126253, '\P{^Is_Numeric_Value=0_0_0_8_0_0_00}', "");
    Expect(1, 126252, '\p{Is_Numeric_Value=8.000000000000000e+04}', "");
    Expect(0, 126252, '\p{^Is_Numeric_Value=8.000000000000000e+04}', "");
    Expect(0, 126252, '\P{Is_Numeric_Value=8.000000000000000e+04}', "");
    Expect(1, 126252, '\P{^Is_Numeric_Value=8.000000000000000e+04}', "");
    Expect(0, 126253, '\p{Is_Numeric_Value=8.000000000000000e+04}', "");
    Expect(1, 126253, '\p{^Is_Numeric_Value=8.000000000000000e+04}', "");
    Expect(1, 126253, '\P{Is_Numeric_Value=8.000000000000000e+04}', "");
    Expect(0, 126253, '\P{^Is_Numeric_Value=8.000000000000000e+04}', "");
    Error('\p{Is_Nv=0000000080000:=}');
    Error('\P{Is_Nv=0000000080000:=}');
    Expect(1, 126252, '\p{Is_Nv=080000}', "");
    Expect(0, 126252, '\p{^Is_Nv=080000}', "");
    Expect(0, 126252, '\P{Is_Nv=080000}', "");
    Expect(1, 126252, '\P{^Is_Nv=080000}', "");
    Expect(0, 126253, '\p{Is_Nv=080000}', "");
    Expect(1, 126253, '\p{^Is_Nv=080000}', "");
    Expect(1, 126253, '\P{Is_Nv=080000}', "");
    Expect(0, 126253, '\P{^Is_Nv=080000}', "");
    Expect(1, 126252, '\p{Is_Nv=8.000000000000000e+04}', "");
    Expect(0, 126252, '\p{^Is_Nv=8.000000000000000e+04}', "");
    Expect(0, 126252, '\P{Is_Nv=8.000000000000000e+04}', "");
    Expect(1, 126252, '\P{^Is_Nv=8.000000000000000e+04}', "");
    Expect(0, 126253, '\p{Is_Nv=8.000000000000000e+04}', "");
    Expect(1, 126253, '\p{^Is_Nv=8.000000000000000e+04}', "");
    Expect(1, 126253, '\P{Is_Nv=8.000000000000000e+04}', "");
    Expect(0, 126253, '\P{^Is_Nv=8.000000000000000e+04}', "");
    Error('\p{Numeric_Value= _000800000:=}');
    Error('\P{Numeric_Value= _000800000:=}');
    Expect(1, 68084, '\p{Numeric_Value=:\A800000\z:}', "");;
    Expect(0, 68085, '\p{Numeric_Value=:\A800000\z:}', "");;
    Expect(1, 68084, '\p{Numeric_Value=00_00_00_08_00_000}', "");
    Expect(0, 68084, '\p{^Numeric_Value=00_00_00_08_00_000}', "");
    Expect(0, 68084, '\P{Numeric_Value=00_00_00_08_00_000}', "");
    Expect(1, 68084, '\P{^Numeric_Value=00_00_00_08_00_000}', "");
    Expect(0, 68085, '\p{Numeric_Value=00_00_00_08_00_000}', "");
    Expect(1, 68085, '\p{^Numeric_Value=00_00_00_08_00_000}', "");
    Expect(1, 68085, '\P{Numeric_Value=00_00_00_08_00_000}', "");
    Expect(0, 68085, '\P{^Numeric_Value=00_00_00_08_00_000}', "");
    Expect(1, 68084, '\p{Numeric_Value=8.000000000000000e+05}', "");
    Expect(0, 68084, '\p{^Numeric_Value=8.000000000000000e+05}', "");
    Expect(0, 68084, '\P{Numeric_Value=8.000000000000000e+05}', "");
    Expect(1, 68084, '\P{^Numeric_Value=8.000000000000000e+05}', "");
    Expect(0, 68085, '\p{Numeric_Value=8.000000000000000e+05}', "");
    Expect(1, 68085, '\p{^Numeric_Value=8.000000000000000e+05}', "");
    Expect(1, 68085, '\P{Numeric_Value=8.000000000000000e+05}', "");
    Expect(0, 68085, '\P{^Numeric_Value=8.000000000000000e+05}', "");
    Error('\p{Nv: /a/--000800000}');
    Error('\P{Nv: /a/--000800000}');
    Expect(1, 68084, '\p{Nv=:\A800000\z:}', "");;
    Expect(0, 68085, '\p{Nv=:\A800000\z:}', "");;
    Expect(1, 68084, '\p{Nv=+8_0_0_000}', "");
    Expect(0, 68084, '\p{^Nv=+8_0_0_000}', "");
    Expect(0, 68084, '\P{Nv=+8_0_0_000}', "");
    Expect(1, 68084, '\P{^Nv=+8_0_0_000}', "");
    Expect(0, 68085, '\p{Nv=+8_0_0_000}', "");
    Expect(1, 68085, '\p{^Nv=+8_0_0_000}', "");
    Expect(1, 68085, '\P{Nv=+8_0_0_000}', "");
    Expect(0, 68085, '\P{^Nv=+8_0_0_000}', "");
    Expect(1, 68084, '\p{Nv=8.000000000000000e+05}', "");
    Expect(0, 68084, '\p{^Nv=8.000000000000000e+05}', "");
    Expect(0, 68084, '\P{Nv=8.000000000000000e+05}', "");
    Expect(1, 68084, '\P{^Nv=8.000000000000000e+05}', "");
    Expect(0, 68085, '\p{Nv=8.000000000000000e+05}', "");
    Expect(1, 68085, '\p{^Nv=8.000000000000000e+05}', "");
    Expect(1, 68085, '\P{Nv=8.000000000000000e+05}', "");
    Expect(0, 68085, '\P{^Nv=8.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value=  +000800000:=}');
    Error('\P{Is_Numeric_Value=  +000800000:=}');
    Expect(1, 68084, '\p{Is_Numeric_Value=008_000_00}', "");
    Expect(0, 68084, '\p{^Is_Numeric_Value=008_000_00}', "");
    Expect(0, 68084, '\P{Is_Numeric_Value=008_000_00}', "");
    Expect(1, 68084, '\P{^Is_Numeric_Value=008_000_00}', "");
    Expect(0, 68085, '\p{Is_Numeric_Value=008_000_00}', "");
    Expect(1, 68085, '\p{^Is_Numeric_Value=008_000_00}', "");
    Expect(1, 68085, '\P{Is_Numeric_Value=008_000_00}', "");
    Expect(0, 68085, '\P{^Is_Numeric_Value=008_000_00}', "");
    Expect(1, 68084, '\p{Is_Numeric_Value=8.000000000000000e+05}', "");
    Expect(0, 68084, '\p{^Is_Numeric_Value=8.000000000000000e+05}', "");
    Expect(0, 68084, '\P{Is_Numeric_Value=8.000000000000000e+05}', "");
    Expect(1, 68084, '\P{^Is_Numeric_Value=8.000000000000000e+05}', "");
    Expect(0, 68085, '\p{Is_Numeric_Value=8.000000000000000e+05}', "");
    Expect(1, 68085, '\p{^Is_Numeric_Value=8.000000000000000e+05}', "");
    Expect(1, 68085, '\P{Is_Numeric_Value=8.000000000000000e+05}', "");
    Expect(0, 68085, '\P{^Is_Numeric_Value=8.000000000000000e+05}', "");
    Error('\p{Is_Nv: -:=+00000000800000}');
    Error('\P{Is_Nv: -:=+00000000800000}');
    Expect(1, 68084, '\p{Is_Nv=0800000}', "");
    Expect(0, 68084, '\p{^Is_Nv=0800000}', "");
    Expect(0, 68084, '\P{Is_Nv=0800000}', "");
    Expect(1, 68084, '\P{^Is_Nv=0800000}', "");
    Expect(0, 68085, '\p{Is_Nv=0800000}', "");
    Expect(1, 68085, '\p{^Is_Nv=0800000}', "");
    Expect(1, 68085, '\P{Is_Nv=0800000}', "");
    Expect(0, 68085, '\P{^Is_Nv=0800000}', "");
    Expect(1, 68084, '\p{Is_Nv:	8.000000000000000e+05}', "");
    Expect(0, 68084, '\p{^Is_Nv:	8.000000000000000e+05}', "");
    Expect(0, 68084, '\P{Is_Nv:	8.000000000000000e+05}', "");
    Expect(1, 68084, '\P{^Is_Nv:	8.000000000000000e+05}', "");
    Expect(0, 68085, '\p{Is_Nv:	8.000000000000000e+05}', "");
    Expect(1, 68085, '\p{^Is_Nv:	8.000000000000000e+05}', "");
    Expect(1, 68085, '\P{Is_Nv:	8.000000000000000e+05}', "");
    Expect(0, 68085, '\P{^Is_Nv:	8.000000000000000e+05}', "");
    Error('\p{Numeric_Value:-0000_9/a/}');
    Error('\P{Numeric_Value:-0000_9/a/}');
    Expect(1, 194704, '\p{Numeric_Value=:\A9\z:}', "");;
    Expect(0, 194705, '\p{Numeric_Value=:\A9\z:}', "");;
    Expect(1, 194704, '\p{Numeric_Value=00_9}', "");
    Expect(0, 194704, '\p{^Numeric_Value=00_9}', "");
    Expect(0, 194704, '\P{Numeric_Value=00_9}', "");
    Expect(1, 194704, '\P{^Numeric_Value=00_9}', "");
    Expect(0, 194705, '\p{Numeric_Value=00_9}', "");
    Expect(1, 194705, '\p{^Numeric_Value=00_9}', "");
    Expect(1, 194705, '\P{Numeric_Value=00_9}', "");
    Expect(0, 194705, '\P{^Numeric_Value=00_9}', "");
    Expect(1, 194704, '\p{Numeric_Value=9.000000000000000e+00}', "");
    Expect(0, 194704, '\p{^Numeric_Value=9.000000000000000e+00}', "");
    Expect(0, 194704, '\P{Numeric_Value=9.000000000000000e+00}', "");
    Expect(1, 194704, '\P{^Numeric_Value=9.000000000000000e+00}', "");
    Expect(0, 194705, '\p{Numeric_Value=9.000000000000000e+00}', "");
    Expect(1, 194705, '\p{^Numeric_Value=9.000000000000000e+00}', "");
    Expect(1, 194705, '\P{Numeric_Value=9.000000000000000e+00}', "");
    Expect(0, 194705, '\P{^Numeric_Value=9.000000000000000e+00}', "");
    Error('\p{Nv=/a/000000009}');
    Error('\P{Nv=/a/000000009}');
    Expect(1, 194704, '\p{Nv=:\A9\z:}', "");;
    Expect(0, 194705, '\p{Nv=:\A9\z:}', "");;
    Expect(1, 194704, '\p{Nv=+000000009}', "");
    Expect(0, 194704, '\p{^Nv=+000000009}', "");
    Expect(0, 194704, '\P{Nv=+000000009}', "");
    Expect(1, 194704, '\P{^Nv=+000000009}', "");
    Expect(0, 194705, '\p{Nv=+000000009}', "");
    Expect(1, 194705, '\p{^Nv=+000000009}', "");
    Expect(1, 194705, '\P{Nv=+000000009}', "");
    Expect(0, 194705, '\P{^Nv=+000000009}', "");
    Expect(1, 194704, '\p{Nv=9.000000000000000e+00}', "");
    Expect(0, 194704, '\p{^Nv=9.000000000000000e+00}', "");
    Expect(0, 194704, '\P{Nv=9.000000000000000e+00}', "");
    Expect(1, 194704, '\P{^Nv=9.000000000000000e+00}', "");
    Expect(0, 194705, '\p{Nv=9.000000000000000e+00}', "");
    Expect(1, 194705, '\p{^Nv=9.000000000000000e+00}', "");
    Expect(1, 194705, '\P{Nv=9.000000000000000e+00}', "");
    Expect(0, 194705, '\P{^Nv=9.000000000000000e+00}', "");
    Error('\p{Is_Numeric_Value=-00000009/a/}');
    Error('\P{Is_Numeric_Value=-00000009/a/}');
    Expect(1, 194704, '\p{Is_Numeric_Value=009}', "");
    Expect(0, 194704, '\p{^Is_Numeric_Value=009}', "");
    Expect(0, 194704, '\P{Is_Numeric_Value=009}', "");
    Expect(1, 194704, '\P{^Is_Numeric_Value=009}', "");
    Expect(0, 194705, '\p{Is_Numeric_Value=009}', "");
    Expect(1, 194705, '\p{^Is_Numeric_Value=009}', "");
    Expect(1, 194705, '\P{Is_Numeric_Value=009}', "");
    Expect(0, 194705, '\P{^Is_Numeric_Value=009}', "");
    Expect(1, 194704, '\p{Is_Numeric_Value: 9.000000000000000e+00}', "");
    Expect(0, 194704, '\p{^Is_Numeric_Value: 9.000000000000000e+00}', "");
    Expect(0, 194704, '\P{Is_Numeric_Value: 9.000000000000000e+00}', "");
    Expect(1, 194704, '\P{^Is_Numeric_Value: 9.000000000000000e+00}', "");
    Expect(0, 194705, '\p{Is_Numeric_Value: 9.000000000000000e+00}', "");
    Expect(1, 194705, '\p{^Is_Numeric_Value: 9.000000000000000e+00}', "");
    Expect(1, 194705, '\P{Is_Numeric_Value: 9.000000000000000e+00}', "");
    Expect(0, 194705, '\P{^Is_Numeric_Value: 9.000000000000000e+00}', "");
    Error('\p{Is_Nv=	/a/00009}');
    Error('\P{Is_Nv=	/a/00009}');
    Expect(1, 194704, '\p{Is_Nv=+0_0_0_0_0_09}', "");
    Expect(0, 194704, '\p{^Is_Nv=+0_0_0_0_0_09}', "");
    Expect(0, 194704, '\P{Is_Nv=+0_0_0_0_0_09}', "");
    Expect(1, 194704, '\P{^Is_Nv=+0_0_0_0_0_09}', "");
    Expect(0, 194705, '\p{Is_Nv=+0_0_0_0_0_09}', "");
    Expect(1, 194705, '\p{^Is_Nv=+0_0_0_0_0_09}', "");
    Expect(1, 194705, '\P{Is_Nv=+0_0_0_0_0_09}', "");
    Expect(0, 194705, '\P{^Is_Nv=+0_0_0_0_0_09}', "");
    Expect(1, 194704, '\p{Is_Nv=9.000000000000000e+00}', "");
    Expect(0, 194704, '\p{^Is_Nv=9.000000000000000e+00}', "");
    Expect(0, 194704, '\P{Is_Nv=9.000000000000000e+00}', "");
    Expect(1, 194704, '\P{^Is_Nv=9.000000000000000e+00}', "");
    Expect(0, 194705, '\p{Is_Nv=9.000000000000000e+00}', "");
    Expect(1, 194705, '\p{^Is_Nv=9.000000000000000e+00}', "");
    Expect(1, 194705, '\P{Is_Nv=9.000000000000000e+00}', "");
    Expect(0, 194705, '\P{^Is_Nv=9.000000000000000e+00}', "");
    Error('\p{Numeric_Value= /a/+00009/02}');
    Error('\P{Numeric_Value= /a/+00009/02}');
    Expect(1, 3886, '\p{Numeric_Value=:\A9/2\z:}', "");;
    Expect(0, 3887, '\p{Numeric_Value=:\A9/2\z:}', "");;
    Expect(1, 3886, '\p{Numeric_Value=00000009/00000002}', "");
    Expect(0, 3886, '\p{^Numeric_Value=00000009/00000002}', "");
    Expect(0, 3886, '\P{Numeric_Value=00000009/00000002}', "");
    Expect(1, 3886, '\P{^Numeric_Value=00000009/00000002}', "");
    Expect(0, 3887, '\p{Numeric_Value=00000009/00000002}', "");
    Expect(1, 3887, '\p{^Numeric_Value=00000009/00000002}', "");
    Expect(1, 3887, '\P{Numeric_Value=00000009/00000002}', "");
    Expect(0, 3887, '\P{^Numeric_Value=00000009/00000002}', "");
    Expect(1, 3886, '\p{Numeric_Value=540/120}', "");
    Expect(0, 3886, '\p{^Numeric_Value=540/120}', "");
    Expect(0, 3886, '\P{Numeric_Value=540/120}', "");
    Expect(1, 3886, '\P{^Numeric_Value=540/120}', "");
    Expect(0, 3887, '\p{Numeric_Value=540/120}', "");
    Expect(1, 3887, '\p{^Numeric_Value=540/120}', "");
    Expect(1, 3887, '\P{Numeric_Value=540/120}', "");
    Expect(0, 3887, '\P{^Numeric_Value=540/120}', "");
    Expect(1, 3886, '\p{Numeric_Value=4.5e+00}', "");
    Expect(0, 3886, '\p{^Numeric_Value=4.5e+00}', "");
    Expect(0, 3886, '\P{Numeric_Value=4.5e+00}', "");
    Expect(1, 3886, '\P{^Numeric_Value=4.5e+00}', "");
    Expect(0, 3887, '\p{Numeric_Value=4.5e+00}', "");
    Expect(1, 3887, '\p{^Numeric_Value=4.5e+00}', "");
    Expect(1, 3887, '\P{Numeric_Value=4.5e+00}', "");
    Expect(0, 3887, '\P{^Numeric_Value=4.5e+00}', "");
    Expect(1, 3886, '\p{Numeric_Value=4.5}', "");
    Expect(0, 3886, '\p{^Numeric_Value=4.5}', "");
    Expect(0, 3886, '\P{Numeric_Value=4.5}', "");
    Expect(1, 3886, '\P{^Numeric_Value=4.5}', "");
    Expect(0, 3887, '\p{Numeric_Value=4.5}', "");
    Expect(1, 3887, '\p{^Numeric_Value=4.5}', "");
    Expect(1, 3887, '\P{Numeric_Value=4.5}', "");
    Expect(0, 3887, '\P{^Numeric_Value=4.5}', "");
    Expect(1, 3886, '\p{Numeric_Value=4.50e+00}', "");
    Expect(0, 3886, '\p{^Numeric_Value=4.50e+00}', "");
    Expect(0, 3886, '\P{Numeric_Value=4.50e+00}', "");
    Expect(1, 3886, '\P{^Numeric_Value=4.50e+00}', "");
    Expect(0, 3887, '\p{Numeric_Value=4.50e+00}', "");
    Expect(1, 3887, '\p{^Numeric_Value=4.50e+00}', "");
    Expect(1, 3887, '\P{Numeric_Value=4.50e+00}', "");
    Expect(0, 3887, '\P{^Numeric_Value=4.50e+00}', "");
    Expect(1, 3886, '\p{Numeric_Value=4.50}', "");
    Expect(0, 3886, '\p{^Numeric_Value=4.50}', "");
    Expect(0, 3886, '\P{Numeric_Value=4.50}', "");
    Expect(1, 3886, '\P{^Numeric_Value=4.50}', "");
    Expect(0, 3887, '\p{Numeric_Value=4.50}', "");
    Expect(1, 3887, '\p{^Numeric_Value=4.50}', "");
    Expect(1, 3887, '\P{Numeric_Value=4.50}', "");
    Expect(0, 3887, '\P{^Numeric_Value=4.50}', "");
    Error('\p{Nv=:=  9/002}');
    Error('\P{Nv=:=  9/002}');
    Expect(1, 3886, '\p{Nv=:\A9/2\z:}', "");;
    Expect(0, 3887, '\p{Nv=:\A9/2\z:}', "");;
    Expect(1, 3886, '\p{Nv:00009/00002}', "");
    Expect(0, 3886, '\p{^Nv:00009/00002}', "");
    Expect(0, 3886, '\P{Nv:00009/00002}', "");
    Expect(1, 3886, '\P{^Nv:00009/00002}', "");
    Expect(0, 3887, '\p{Nv:00009/00002}', "");
    Expect(1, 3887, '\p{^Nv:00009/00002}', "");
    Expect(1, 3887, '\P{Nv:00009/00002}', "");
    Expect(0, 3887, '\P{^Nv:00009/00002}', "");
    Expect(1, 3886, '\p{Nv:	540/120}', "");
    Expect(0, 3886, '\p{^Nv:	540/120}', "");
    Expect(0, 3886, '\P{Nv:	540/120}', "");
    Expect(1, 3886, '\P{^Nv:	540/120}', "");
    Expect(0, 3887, '\p{Nv:	540/120}', "");
    Expect(1, 3887, '\p{^Nv:	540/120}', "");
    Expect(1, 3887, '\P{Nv:	540/120}', "");
    Expect(0, 3887, '\P{^Nv:	540/120}', "");
    Expect(1, 3886, '\p{Nv=4.5e+00}', "");
    Expect(0, 3886, '\p{^Nv=4.5e+00}', "");
    Expect(0, 3886, '\P{Nv=4.5e+00}', "");
    Expect(1, 3886, '\P{^Nv=4.5e+00}', "");
    Expect(0, 3887, '\p{Nv=4.5e+00}', "");
    Expect(1, 3887, '\p{^Nv=4.5e+00}', "");
    Expect(1, 3887, '\P{Nv=4.5e+00}', "");
    Expect(0, 3887, '\P{^Nv=4.5e+00}', "");
    Expect(1, 3886, '\p{Nv=4.5}', "");
    Expect(0, 3886, '\p{^Nv=4.5}', "");
    Expect(0, 3886, '\P{Nv=4.5}', "");
    Expect(1, 3886, '\P{^Nv=4.5}', "");
    Expect(0, 3887, '\p{Nv=4.5}', "");
    Expect(1, 3887, '\p{^Nv=4.5}', "");
    Expect(1, 3887, '\P{Nv=4.5}', "");
    Expect(0, 3887, '\P{^Nv=4.5}', "");
    Expect(1, 3886, '\p{Nv=4.50e+00}', "");
    Expect(0, 3886, '\p{^Nv=4.50e+00}', "");
    Expect(0, 3886, '\P{Nv=4.50e+00}', "");
    Expect(1, 3886, '\P{^Nv=4.50e+00}', "");
    Expect(0, 3887, '\p{Nv=4.50e+00}', "");
    Expect(1, 3887, '\p{^Nv=4.50e+00}', "");
    Expect(1, 3887, '\P{Nv=4.50e+00}', "");
    Expect(0, 3887, '\P{^Nv=4.50e+00}', "");
    Expect(1, 3886, '\p{Nv=4.50}', "");
    Expect(0, 3886, '\p{^Nv=4.50}', "");
    Expect(0, 3886, '\P{Nv=4.50}', "");
    Expect(1, 3886, '\P{^Nv=4.50}', "");
    Expect(0, 3887, '\p{Nv=4.50}', "");
    Expect(1, 3887, '\p{^Nv=4.50}', "");
    Expect(1, 3887, '\P{Nv=4.50}', "");
    Expect(0, 3887, '\P{^Nv=4.50}', "");
    Error('\p{Is_Numeric_Value=	/a/00000009/0002}');
    Error('\P{Is_Numeric_Value=	/a/00000009/0002}');
    Expect(1, 3886, '\p{Is_Numeric_Value=000000009/02}', "");
    Expect(0, 3886, '\p{^Is_Numeric_Value=000000009/02}', "");
    Expect(0, 3886, '\P{Is_Numeric_Value=000000009/02}', "");
    Expect(1, 3886, '\P{^Is_Numeric_Value=000000009/02}', "");
    Expect(0, 3887, '\p{Is_Numeric_Value=000000009/02}', "");
    Expect(1, 3887, '\p{^Is_Numeric_Value=000000009/02}', "");
    Expect(1, 3887, '\P{Is_Numeric_Value=000000009/02}', "");
    Expect(0, 3887, '\P{^Is_Numeric_Value=000000009/02}', "");
    Expect(1, 3886, '\p{Is_Numeric_Value=540/120}', "");
    Expect(0, 3886, '\p{^Is_Numeric_Value=540/120}', "");
    Expect(0, 3886, '\P{Is_Numeric_Value=540/120}', "");
    Expect(1, 3886, '\P{^Is_Numeric_Value=540/120}', "");
    Expect(0, 3887, '\p{Is_Numeric_Value=540/120}', "");
    Expect(1, 3887, '\p{^Is_Numeric_Value=540/120}', "");
    Expect(1, 3887, '\P{Is_Numeric_Value=540/120}', "");
    Expect(0, 3887, '\P{^Is_Numeric_Value=540/120}', "");
    Expect(1, 3886, '\p{Is_Numeric_Value:   4.5e+00}', "");
    Expect(0, 3886, '\p{^Is_Numeric_Value:   4.5e+00}', "");
    Expect(0, 3886, '\P{Is_Numeric_Value:   4.5e+00}', "");
    Expect(1, 3886, '\P{^Is_Numeric_Value:   4.5e+00}', "");
    Expect(0, 3887, '\p{Is_Numeric_Value:   4.5e+00}', "");
    Expect(1, 3887, '\p{^Is_Numeric_Value:   4.5e+00}', "");
    Expect(1, 3887, '\P{Is_Numeric_Value:   4.5e+00}', "");
    Expect(0, 3887, '\P{^Is_Numeric_Value:   4.5e+00}', "");
    Expect(1, 3886, '\p{Is_Numeric_Value=4.5}', "");
    Expect(0, 3886, '\p{^Is_Numeric_Value=4.5}', "");
    Expect(0, 3886, '\P{Is_Numeric_Value=4.5}', "");
    Expect(1, 3886, '\P{^Is_Numeric_Value=4.5}', "");
    Expect(0, 3887, '\p{Is_Numeric_Value=4.5}', "");
    Expect(1, 3887, '\p{^Is_Numeric_Value=4.5}', "");
    Expect(1, 3887, '\P{Is_Numeric_Value=4.5}', "");
    Expect(0, 3887, '\P{^Is_Numeric_Value=4.5}', "");
    Expect(1, 3886, '\p{Is_Numeric_Value=4.50e+00}', "");
    Expect(0, 3886, '\p{^Is_Numeric_Value=4.50e+00}', "");
    Expect(0, 3886, '\P{Is_Numeric_Value=4.50e+00}', "");
    Expect(1, 3886, '\P{^Is_Numeric_Value=4.50e+00}', "");
    Expect(0, 3887, '\p{Is_Numeric_Value=4.50e+00}', "");
    Expect(1, 3887, '\p{^Is_Numeric_Value=4.50e+00}', "");
    Expect(1, 3887, '\P{Is_Numeric_Value=4.50e+00}', "");
    Expect(0, 3887, '\P{^Is_Numeric_Value=4.50e+00}', "");
    Expect(1, 3886, '\p{Is_Numeric_Value=4.50}', "");
    Expect(0, 3886, '\p{^Is_Numeric_Value=4.50}', "");
    Expect(0, 3886, '\P{Is_Numeric_Value=4.50}', "");
    Expect(1, 3886, '\P{^Is_Numeric_Value=4.50}', "");
    Expect(0, 3887, '\p{Is_Numeric_Value=4.50}', "");
    Expect(1, 3887, '\p{^Is_Numeric_Value=4.50}', "");
    Expect(1, 3887, '\P{Is_Numeric_Value=4.50}', "");
    Expect(0, 3887, '\P{^Is_Numeric_Value=4.50}', "");
    Error('\p{Is_Nv=/a/9/000002}');
    Error('\P{Is_Nv=/a/9/000002}');
    Expect(1, 3886, '\p{Is_Nv=0009/0000002}', "");
    Expect(0, 3886, '\p{^Is_Nv=0009/0000002}', "");
    Expect(0, 3886, '\P{Is_Nv=0009/0000002}', "");
    Expect(1, 3886, '\P{^Is_Nv=0009/0000002}', "");
    Expect(0, 3887, '\p{Is_Nv=0009/0000002}', "");
    Expect(1, 3887, '\p{^Is_Nv=0009/0000002}', "");
    Expect(1, 3887, '\P{Is_Nv=0009/0000002}', "");
    Expect(0, 3887, '\P{^Is_Nv=0009/0000002}', "");
    Expect(1, 3886, '\p{Is_Nv=540/120}', "");
    Expect(0, 3886, '\p{^Is_Nv=540/120}', "");
    Expect(0, 3886, '\P{Is_Nv=540/120}', "");
    Expect(1, 3886, '\P{^Is_Nv=540/120}', "");
    Expect(0, 3887, '\p{Is_Nv=540/120}', "");
    Expect(1, 3887, '\p{^Is_Nv=540/120}', "");
    Expect(1, 3887, '\P{Is_Nv=540/120}', "");
    Expect(0, 3887, '\P{^Is_Nv=540/120}', "");
    Expect(1, 3886, '\p{Is_Nv=4.5e+00}', "");
    Expect(0, 3886, '\p{^Is_Nv=4.5e+00}', "");
    Expect(0, 3886, '\P{Is_Nv=4.5e+00}', "");
    Expect(1, 3886, '\P{^Is_Nv=4.5e+00}', "");
    Expect(0, 3887, '\p{Is_Nv=4.5e+00}', "");
    Expect(1, 3887, '\p{^Is_Nv=4.5e+00}', "");
    Expect(1, 3887, '\P{Is_Nv=4.5e+00}', "");
    Expect(0, 3887, '\P{^Is_Nv=4.5e+00}', "");
    Expect(1, 3886, '\p{Is_Nv=4.5}', "");
    Expect(0, 3886, '\p{^Is_Nv=4.5}', "");
    Expect(0, 3886, '\P{Is_Nv=4.5}', "");
    Expect(1, 3886, '\P{^Is_Nv=4.5}', "");
    Expect(0, 3887, '\p{Is_Nv=4.5}', "");
    Expect(1, 3887, '\p{^Is_Nv=4.5}', "");
    Expect(1, 3887, '\P{Is_Nv=4.5}', "");
    Expect(0, 3887, '\P{^Is_Nv=4.5}', "");
    Expect(1, 3886, '\p{Is_Nv=4.50e+00}', "");
    Expect(0, 3886, '\p{^Is_Nv=4.50e+00}', "");
    Expect(0, 3886, '\P{Is_Nv=4.50e+00}', "");
    Expect(1, 3886, '\P{^Is_Nv=4.50e+00}', "");
    Expect(0, 3887, '\p{Is_Nv=4.50e+00}', "");
    Expect(1, 3887, '\p{^Is_Nv=4.50e+00}', "");
    Expect(1, 3887, '\P{Is_Nv=4.50e+00}', "");
    Expect(0, 3887, '\P{^Is_Nv=4.50e+00}', "");
    Expect(1, 3886, '\p{Is_Nv=4.50}', "");
    Expect(0, 3886, '\p{^Is_Nv=4.50}', "");
    Expect(0, 3886, '\P{Is_Nv=4.50}', "");
    Expect(1, 3886, '\P{^Is_Nv=4.50}', "");
    Expect(0, 3887, '\p{Is_Nv=4.50}', "");
    Expect(1, 3887, '\p{^Is_Nv=4.50}', "");
    Expect(1, 3887, '\P{Is_Nv=4.50}', "");
    Expect(0, 3887, '\P{^Is_Nv=4.50}', "");
    Error('\p{Numeric_Value: 000000009_0:=}');
    Error('\P{Numeric_Value: 000000009_0:=}');
    Expect(1, 126226, '\p{Numeric_Value=:\A90\z:}', "");;
    Expect(0, 126227, '\p{Numeric_Value=:\A90\z:}', "");;
    Expect(1, 126226, '\p{Numeric_Value=+0_0_0_0_0_0_0_0_0_90}', "");
    Expect(0, 126226, '\p{^Numeric_Value=+0_0_0_0_0_0_0_0_0_90}', "");
    Expect(0, 126226, '\P{Numeric_Value=+0_0_0_0_0_0_0_0_0_90}', "");
    Expect(1, 126226, '\P{^Numeric_Value=+0_0_0_0_0_0_0_0_0_90}', "");
    Expect(0, 126227, '\p{Numeric_Value=+0_0_0_0_0_0_0_0_0_90}', "");
    Expect(1, 126227, '\p{^Numeric_Value=+0_0_0_0_0_0_0_0_0_90}', "");
    Expect(1, 126227, '\P{Numeric_Value=+0_0_0_0_0_0_0_0_0_90}', "");
    Expect(0, 126227, '\P{^Numeric_Value=+0_0_0_0_0_0_0_0_0_90}', "");
    Expect(1, 126226, '\p{Numeric_Value: 9.000000000000000e+01}', "");
    Expect(0, 126226, '\p{^Numeric_Value: 9.000000000000000e+01}', "");
    Expect(0, 126226, '\P{Numeric_Value: 9.000000000000000e+01}', "");
    Expect(1, 126226, '\P{^Numeric_Value: 9.000000000000000e+01}', "");
    Expect(0, 126227, '\p{Numeric_Value: 9.000000000000000e+01}', "");
    Expect(1, 126227, '\p{^Numeric_Value: 9.000000000000000e+01}', "");
    Expect(1, 126227, '\P{Numeric_Value: 9.000000000000000e+01}', "");
    Expect(0, 126227, '\P{^Numeric_Value: 9.000000000000000e+01}', "");
    Error('\p{Nv=	+0_0_0_90/a/}');
    Error('\P{Nv=	+0_0_0_90/a/}');
    Expect(1, 126226, '\p{Nv=:\A90\z:}', "");;
    Expect(0, 126227, '\p{Nv=:\A90\z:}', "");;
    Expect(1, 126226, '\p{Nv=090}', "");
    Expect(0, 126226, '\p{^Nv=090}', "");
    Expect(0, 126226, '\P{Nv=090}', "");
    Expect(1, 126226, '\P{^Nv=090}', "");
    Expect(0, 126227, '\p{Nv=090}', "");
    Expect(1, 126227, '\p{^Nv=090}', "");
    Expect(1, 126227, '\P{Nv=090}', "");
    Expect(0, 126227, '\P{^Nv=090}', "");
    Expect(1, 126226, '\p{Nv=9.000000000000000e+01}', "");
    Expect(0, 126226, '\p{^Nv=9.000000000000000e+01}', "");
    Expect(0, 126226, '\P{Nv=9.000000000000000e+01}', "");
    Expect(1, 126226, '\P{^Nv=9.000000000000000e+01}', "");
    Expect(0, 126227, '\p{Nv=9.000000000000000e+01}', "");
    Expect(1, 126227, '\p{^Nv=9.000000000000000e+01}', "");
    Expect(1, 126227, '\P{Nv=9.000000000000000e+01}', "");
    Expect(0, 126227, '\P{^Nv=9.000000000000000e+01}', "");
    Error('\p{Is_Numeric_Value=:=	+0009_0}');
    Error('\P{Is_Numeric_Value=:=	+0009_0}');
    Expect(1, 126226, '\p{Is_Numeric_Value=0000000090}', "");
    Expect(0, 126226, '\p{^Is_Numeric_Value=0000000090}', "");
    Expect(0, 126226, '\P{Is_Numeric_Value=0000000090}', "");
    Expect(1, 126226, '\P{^Is_Numeric_Value=0000000090}', "");
    Expect(0, 126227, '\p{Is_Numeric_Value=0000000090}', "");
    Expect(1, 126227, '\p{^Is_Numeric_Value=0000000090}', "");
    Expect(1, 126227, '\P{Is_Numeric_Value=0000000090}', "");
    Expect(0, 126227, '\P{^Is_Numeric_Value=0000000090}', "");
    Expect(1, 126226, '\p{Is_Numeric_Value:   9.000000000000000e+01}', "");
    Expect(0, 126226, '\p{^Is_Numeric_Value:   9.000000000000000e+01}', "");
    Expect(0, 126226, '\P{Is_Numeric_Value:   9.000000000000000e+01}', "");
    Expect(1, 126226, '\P{^Is_Numeric_Value:   9.000000000000000e+01}', "");
    Expect(0, 126227, '\p{Is_Numeric_Value:   9.000000000000000e+01}', "");
    Expect(1, 126227, '\p{^Is_Numeric_Value:   9.000000000000000e+01}', "");
    Expect(1, 126227, '\P{Is_Numeric_Value:   9.000000000000000e+01}', "");
    Expect(0, 126227, '\P{^Is_Numeric_Value:   9.000000000000000e+01}', "");
    Error('\p{Is_Nv=_:=0000090}');
    Error('\P{Is_Nv=_:=0000090}');
    Expect(1, 126226, '\p{Is_Nv=000000090}', "");
    Expect(0, 126226, '\p{^Is_Nv=000000090}', "");
    Expect(0, 126226, '\P{Is_Nv=000000090}', "");
    Expect(1, 126226, '\P{^Is_Nv=000000090}', "");
    Expect(0, 126227, '\p{Is_Nv=000000090}', "");
    Expect(1, 126227, '\p{^Is_Nv=000000090}', "");
    Expect(1, 126227, '\P{Is_Nv=000000090}', "");
    Expect(0, 126227, '\P{^Is_Nv=000000090}', "");
    Expect(1, 126226, '\p{Is_Nv=9.000000000000000e+01}', "");
    Expect(0, 126226, '\p{^Is_Nv=9.000000000000000e+01}', "");
    Expect(0, 126226, '\P{Is_Nv=9.000000000000000e+01}', "");
    Expect(1, 126226, '\P{^Is_Nv=9.000000000000000e+01}', "");
    Expect(0, 126227, '\p{Is_Nv=9.000000000000000e+01}', "");
    Expect(1, 126227, '\p{^Is_Nv=9.000000000000000e+01}', "");
    Expect(1, 126227, '\P{Is_Nv=9.000000000000000e+01}', "");
    Expect(0, 126227, '\P{^Is_Nv=9.000000000000000e+01}', "");
    Error('\p{Numeric_Value=--00_09_00:=}');
    Error('\P{Numeric_Value=--00_09_00:=}');
    Expect(1, 126235, '\p{Numeric_Value=:\A900\z:}', "");;
    Expect(0, 126236, '\p{Numeric_Value=:\A900\z:}', "");;
    Expect(1, 126235, '\p{Numeric_Value=000900}', "");
    Expect(0, 126235, '\p{^Numeric_Value=000900}', "");
    Expect(0, 126235, '\P{Numeric_Value=000900}', "");
    Expect(1, 126235, '\P{^Numeric_Value=000900}', "");
    Expect(0, 126236, '\p{Numeric_Value=000900}', "");
    Expect(1, 126236, '\p{^Numeric_Value=000900}', "");
    Expect(1, 126236, '\P{Numeric_Value=000900}', "");
    Expect(0, 126236, '\P{^Numeric_Value=000900}', "");
    Expect(1, 126235, '\p{Numeric_Value=9.000000000000000e+02}', "");
    Expect(0, 126235, '\p{^Numeric_Value=9.000000000000000e+02}', "");
    Expect(0, 126235, '\P{Numeric_Value=9.000000000000000e+02}', "");
    Expect(1, 126235, '\P{^Numeric_Value=9.000000000000000e+02}', "");
    Expect(0, 126236, '\p{Numeric_Value=9.000000000000000e+02}', "");
    Expect(1, 126236, '\p{^Numeric_Value=9.000000000000000e+02}', "");
    Expect(1, 126236, '\P{Numeric_Value=9.000000000000000e+02}', "");
    Expect(0, 126236, '\P{^Numeric_Value=9.000000000000000e+02}', "");
    Error('\p{Nv=:=--+000000000900}');
    Error('\P{Nv=:=--+000000000900}');
    Expect(1, 126235, '\p{Nv=:\A900\z:}', "");;
    Expect(0, 126236, '\p{Nv=:\A900\z:}', "");;
    Expect(1, 126235, '\p{Nv:   000000000900}', "");
    Expect(0, 126235, '\p{^Nv:   000000000900}', "");
    Expect(0, 126235, '\P{Nv:   000000000900}', "");
    Expect(1, 126235, '\P{^Nv:   000000000900}', "");
    Expect(0, 126236, '\p{Nv:   000000000900}', "");
    Expect(1, 126236, '\p{^Nv:   000000000900}', "");
    Expect(1, 126236, '\P{Nv:   000000000900}', "");
    Expect(0, 126236, '\P{^Nv:   000000000900}', "");
    Expect(1, 126235, '\p{Nv=9.000000000000000e+02}', "");
    Expect(0, 126235, '\p{^Nv=9.000000000000000e+02}', "");
    Expect(0, 126235, '\P{Nv=9.000000000000000e+02}', "");
    Expect(1, 126235, '\P{^Nv=9.000000000000000e+02}', "");
    Expect(0, 126236, '\p{Nv=9.000000000000000e+02}', "");
    Expect(1, 126236, '\p{^Nv=9.000000000000000e+02}', "");
    Expect(1, 126236, '\P{Nv=9.000000000000000e+02}', "");
    Expect(0, 126236, '\P{^Nv=9.000000000000000e+02}', "");
    Error('\p{Is_Numeric_Value=	 00900/a/}');
    Error('\P{Is_Numeric_Value=	 00900/a/}');
    Expect(1, 126235, '\p{Is_Numeric_Value=00000900}', "");
    Expect(0, 126235, '\p{^Is_Numeric_Value=00000900}', "");
    Expect(0, 126235, '\P{Is_Numeric_Value=00000900}', "");
    Expect(1, 126235, '\P{^Is_Numeric_Value=00000900}', "");
    Expect(0, 126236, '\p{Is_Numeric_Value=00000900}', "");
    Expect(1, 126236, '\p{^Is_Numeric_Value=00000900}', "");
    Expect(1, 126236, '\P{Is_Numeric_Value=00000900}', "");
    Expect(0, 126236, '\P{^Is_Numeric_Value=00000900}', "");
    Expect(1, 126235, '\p{Is_Numeric_Value=9.000000000000000e+02}', "");
    Expect(0, 126235, '\p{^Is_Numeric_Value=9.000000000000000e+02}', "");
    Expect(0, 126235, '\P{Is_Numeric_Value=9.000000000000000e+02}', "");
    Expect(1, 126235, '\P{^Is_Numeric_Value=9.000000000000000e+02}', "");
    Expect(0, 126236, '\p{Is_Numeric_Value=9.000000000000000e+02}', "");
    Expect(1, 126236, '\p{^Is_Numeric_Value=9.000000000000000e+02}', "");
    Expect(1, 126236, '\P{Is_Numeric_Value=9.000000000000000e+02}', "");
    Expect(0, 126236, '\P{^Is_Numeric_Value=9.000000000000000e+02}', "");
    Error('\p{Is_Nv=:=_ 00000_00090_0}');
    Error('\P{Is_Nv=:=_ 00000_00090_0}');
    Expect(1, 126235, '\p{Is_Nv=+00000900}', "");
    Expect(0, 126235, '\p{^Is_Nv=+00000900}', "");
    Expect(0, 126235, '\P{Is_Nv=+00000900}', "");
    Expect(1, 126235, '\P{^Is_Nv=+00000900}', "");
    Expect(0, 126236, '\p{Is_Nv=+00000900}', "");
    Expect(1, 126236, '\p{^Is_Nv=+00000900}', "");
    Expect(1, 126236, '\P{Is_Nv=+00000900}', "");
    Expect(0, 126236, '\P{^Is_Nv=+00000900}', "");
    Expect(1, 126235, '\p{Is_Nv=9.000000000000000e+02}', "");
    Expect(0, 126235, '\p{^Is_Nv=9.000000000000000e+02}', "");
    Expect(0, 126235, '\P{Is_Nv=9.000000000000000e+02}', "");
    Expect(1, 126235, '\P{^Is_Nv=9.000000000000000e+02}', "");
    Expect(0, 126236, '\p{Is_Nv=9.000000000000000e+02}', "");
    Expect(1, 126236, '\p{^Is_Nv=9.000000000000000e+02}', "");
    Expect(1, 126236, '\P{Is_Nv=9.000000000000000e+02}', "");
    Expect(0, 126236, '\P{^Is_Nv=9.000000000000000e+02}', "");
    Error('\p{Numeric_Value=/a/ 9000}');
    Error('\P{Numeric_Value=/a/ 9000}');
    Expect(1, 126244, '\p{Numeric_Value=:\A9000\z:}', "");;
    Expect(0, 126245, '\p{Numeric_Value=:\A9000\z:}', "");;
    Expect(1, 126244, '\p{Numeric_Value:+000_000_009_000}', "");
    Expect(0, 126244, '\p{^Numeric_Value:+000_000_009_000}', "");
    Expect(0, 126244, '\P{Numeric_Value:+000_000_009_000}', "");
    Expect(1, 126244, '\P{^Numeric_Value:+000_000_009_000}', "");
    Expect(0, 126245, '\p{Numeric_Value:+000_000_009_000}', "");
    Expect(1, 126245, '\p{^Numeric_Value:+000_000_009_000}', "");
    Expect(1, 126245, '\P{Numeric_Value:+000_000_009_000}', "");
    Expect(0, 126245, '\P{^Numeric_Value:+000_000_009_000}', "");
    Expect(1, 126244, '\p{Numeric_Value=9.000000000000000e+03}', "");
    Expect(0, 126244, '\p{^Numeric_Value=9.000000000000000e+03}', "");
    Expect(0, 126244, '\P{Numeric_Value=9.000000000000000e+03}', "");
    Expect(1, 126244, '\P{^Numeric_Value=9.000000000000000e+03}', "");
    Expect(0, 126245, '\p{Numeric_Value=9.000000000000000e+03}', "");
    Expect(1, 126245, '\p{^Numeric_Value=9.000000000000000e+03}', "");
    Expect(1, 126245, '\P{Numeric_Value=9.000000000000000e+03}', "");
    Expect(0, 126245, '\P{^Numeric_Value=9.000000000000000e+03}', "");
    Error('\p{Nv= -9000/a/}');
    Error('\P{Nv= -9000/a/}');
    Expect(1, 126244, '\p{Nv=:\A9000\z:}', "");;
    Expect(0, 126245, '\p{Nv=:\A9000\z:}', "");;
    Expect(1, 126244, '\p{Nv=00009000}', "");
    Expect(0, 126244, '\p{^Nv=00009000}', "");
    Expect(0, 126244, '\P{Nv=00009000}', "");
    Expect(1, 126244, '\P{^Nv=00009000}', "");
    Expect(0, 126245, '\p{Nv=00009000}', "");
    Expect(1, 126245, '\p{^Nv=00009000}', "");
    Expect(1, 126245, '\P{Nv=00009000}', "");
    Expect(0, 126245, '\P{^Nv=00009000}', "");
    Expect(1, 126244, '\p{Nv:   9.000000000000000e+03}', "");
    Expect(0, 126244, '\p{^Nv:   9.000000000000000e+03}', "");
    Expect(0, 126244, '\P{Nv:   9.000000000000000e+03}', "");
    Expect(1, 126244, '\P{^Nv:   9.000000000000000e+03}', "");
    Expect(0, 126245, '\p{Nv:   9.000000000000000e+03}', "");
    Expect(1, 126245, '\p{^Nv:   9.000000000000000e+03}', "");
    Expect(1, 126245, '\P{Nv:   9.000000000000000e+03}', "");
    Expect(0, 126245, '\P{^Nv:   9.000000000000000e+03}', "");
    Error('\p{Is_Numeric_Value=9000/a/}');
    Error('\P{Is_Numeric_Value=9000/a/}');
    Expect(1, 126244, '\p{Is_Numeric_Value=+00_00_00_00_09_00_0}', "");
    Expect(0, 126244, '\p{^Is_Numeric_Value=+00_00_00_00_09_00_0}', "");
    Expect(0, 126244, '\P{Is_Numeric_Value=+00_00_00_00_09_00_0}', "");
    Expect(1, 126244, '\P{^Is_Numeric_Value=+00_00_00_00_09_00_0}', "");
    Expect(0, 126245, '\p{Is_Numeric_Value=+00_00_00_00_09_00_0}', "");
    Expect(1, 126245, '\p{^Is_Numeric_Value=+00_00_00_00_09_00_0}', "");
    Expect(1, 126245, '\P{Is_Numeric_Value=+00_00_00_00_09_00_0}', "");
    Expect(0, 126245, '\P{^Is_Numeric_Value=+00_00_00_00_09_00_0}', "");
    Expect(1, 126244, '\p{Is_Numeric_Value=9.000000000000000e+03}', "");
    Expect(0, 126244, '\p{^Is_Numeric_Value=9.000000000000000e+03}', "");
    Expect(0, 126244, '\P{Is_Numeric_Value=9.000000000000000e+03}', "");
    Expect(1, 126244, '\P{^Is_Numeric_Value=9.000000000000000e+03}', "");
    Expect(0, 126245, '\p{Is_Numeric_Value=9.000000000000000e+03}', "");
    Expect(1, 126245, '\p{^Is_Numeric_Value=9.000000000000000e+03}', "");
    Expect(1, 126245, '\P{Is_Numeric_Value=9.000000000000000e+03}', "");
    Expect(0, 126245, '\P{^Is_Numeric_Value=9.000000000000000e+03}', "");
    Error('\p{Is_Nv=-:=0_0_9_000}');
    Error('\P{Is_Nv=-:=0_0_9_000}');
    Expect(1, 126244, '\p{Is_Nv=+0_0_0_0_0_0_09000}', "");
    Expect(0, 126244, '\p{^Is_Nv=+0_0_0_0_0_0_09000}', "");
    Expect(0, 126244, '\P{Is_Nv=+0_0_0_0_0_0_09000}', "");
    Expect(1, 126244, '\P{^Is_Nv=+0_0_0_0_0_0_09000}', "");
    Expect(0, 126245, '\p{Is_Nv=+0_0_0_0_0_0_09000}', "");
    Expect(1, 126245, '\p{^Is_Nv=+0_0_0_0_0_0_09000}', "");
    Expect(1, 126245, '\P{Is_Nv=+0_0_0_0_0_0_09000}', "");
    Expect(0, 126245, '\P{^Is_Nv=+0_0_0_0_0_0_09000}', "");
    Expect(1, 126244, '\p{Is_Nv=9.000000000000000e+03}', "");
    Expect(0, 126244, '\p{^Is_Nv=9.000000000000000e+03}', "");
    Expect(0, 126244, '\P{Is_Nv=9.000000000000000e+03}', "");
    Expect(1, 126244, '\P{^Is_Nv=9.000000000000000e+03}', "");
    Expect(0, 126245, '\p{Is_Nv=9.000000000000000e+03}', "");
    Expect(1, 126245, '\p{^Is_Nv=9.000000000000000e+03}', "");
    Expect(1, 126245, '\P{Is_Nv=9.000000000000000e+03}', "");
    Expect(0, 126245, '\P{^Is_Nv=9.000000000000000e+03}', "");
    Error('\p{Numeric_Value=	+0_9_0_0_00:=}');
    Error('\P{Numeric_Value=	+0_9_0_0_00:=}');
    Expect(1, 126253, '\p{Numeric_Value=:\A90000\z:}', "");;
    Expect(0, 126254, '\p{Numeric_Value=:\A90000\z:}', "");;
    Expect(1, 126253, '\p{Numeric_Value=0000009000_0}', "");
    Expect(0, 126253, '\p{^Numeric_Value=0000009000_0}', "");
    Expect(0, 126253, '\P{Numeric_Value=0000009000_0}', "");
    Expect(1, 126253, '\P{^Numeric_Value=0000009000_0}', "");
    Expect(0, 126254, '\p{Numeric_Value=0000009000_0}', "");
    Expect(1, 126254, '\p{^Numeric_Value=0000009000_0}', "");
    Expect(1, 126254, '\P{Numeric_Value=0000009000_0}', "");
    Expect(0, 126254, '\P{^Numeric_Value=0000009000_0}', "");
    Expect(1, 126253, '\p{Numeric_Value=9.000000000000000e+04}', "");
    Expect(0, 126253, '\p{^Numeric_Value=9.000000000000000e+04}', "");
    Expect(0, 126253, '\P{Numeric_Value=9.000000000000000e+04}', "");
    Expect(1, 126253, '\P{^Numeric_Value=9.000000000000000e+04}', "");
    Expect(0, 126254, '\p{Numeric_Value=9.000000000000000e+04}', "");
    Expect(1, 126254, '\p{^Numeric_Value=9.000000000000000e+04}', "");
    Expect(1, 126254, '\P{Numeric_Value=9.000000000000000e+04}', "");
    Expect(0, 126254, '\P{^Numeric_Value=9.000000000000000e+04}', "");
    Error('\p{Nv=- 0_0_0_9_0_0_00/a/}');
    Error('\P{Nv=- 0_0_0_9_0_0_00/a/}');
    Expect(1, 126253, '\p{Nv=:\A90000\z:}', "");;
    Expect(0, 126254, '\p{Nv=:\A90000\z:}', "");;
    Expect(1, 126253, '\p{Nv=00_00_90_00_0}', "");
    Expect(0, 126253, '\p{^Nv=00_00_90_00_0}', "");
    Expect(0, 126253, '\P{Nv=00_00_90_00_0}', "");
    Expect(1, 126253, '\P{^Nv=00_00_90_00_0}', "");
    Expect(0, 126254, '\p{Nv=00_00_90_00_0}', "");
    Expect(1, 126254, '\p{^Nv=00_00_90_00_0}', "");
    Expect(1, 126254, '\P{Nv=00_00_90_00_0}', "");
    Expect(0, 126254, '\P{^Nv=00_00_90_00_0}', "");
    Expect(1, 126253, '\p{Nv=9.000000000000000e+04}', "");
    Expect(0, 126253, '\p{^Nv=9.000000000000000e+04}', "");
    Expect(0, 126253, '\P{Nv=9.000000000000000e+04}', "");
    Expect(1, 126253, '\P{^Nv=9.000000000000000e+04}', "");
    Expect(0, 126254, '\p{Nv=9.000000000000000e+04}', "");
    Expect(1, 126254, '\p{^Nv=9.000000000000000e+04}', "");
    Expect(1, 126254, '\P{Nv=9.000000000000000e+04}', "");
    Expect(0, 126254, '\P{^Nv=9.000000000000000e+04}', "");
    Error('\p{Is_Numeric_Value=	/a/0000_9000_0}');
    Error('\P{Is_Numeric_Value=	/a/0000_9000_0}');
    Expect(1, 126253, '\p{Is_Numeric_Value=00_00_90_000}', "");
    Expect(0, 126253, '\p{^Is_Numeric_Value=00_00_90_000}', "");
    Expect(0, 126253, '\P{Is_Numeric_Value=00_00_90_000}', "");
    Expect(1, 126253, '\P{^Is_Numeric_Value=00_00_90_000}', "");
    Expect(0, 126254, '\p{Is_Numeric_Value=00_00_90_000}', "");
    Expect(1, 126254, '\p{^Is_Numeric_Value=00_00_90_000}', "");
    Expect(1, 126254, '\P{Is_Numeric_Value=00_00_90_000}', "");
    Expect(0, 126254, '\P{^Is_Numeric_Value=00_00_90_000}', "");
    Expect(1, 126253, '\p{Is_Numeric_Value=9.000000000000000e+04}', "");
    Expect(0, 126253, '\p{^Is_Numeric_Value=9.000000000000000e+04}', "");
    Expect(0, 126253, '\P{Is_Numeric_Value=9.000000000000000e+04}', "");
    Expect(1, 126253, '\P{^Is_Numeric_Value=9.000000000000000e+04}', "");
    Expect(0, 126254, '\p{Is_Numeric_Value=9.000000000000000e+04}', "");
    Expect(1, 126254, '\p{^Is_Numeric_Value=9.000000000000000e+04}', "");
    Expect(1, 126254, '\P{Is_Numeric_Value=9.000000000000000e+04}', "");
    Expect(0, 126254, '\P{^Is_Numeric_Value=9.000000000000000e+04}', "");
    Error('\p{Is_Nv=	 +0000090000:=}');
    Error('\P{Is_Nv=	 +0000090000:=}');
    Expect(1, 126253, '\p{Is_Nv=0090000}', "");
    Expect(0, 126253, '\p{^Is_Nv=0090000}', "");
    Expect(0, 126253, '\P{Is_Nv=0090000}', "");
    Expect(1, 126253, '\P{^Is_Nv=0090000}', "");
    Expect(0, 126254, '\p{Is_Nv=0090000}', "");
    Expect(1, 126254, '\p{^Is_Nv=0090000}', "");
    Expect(1, 126254, '\P{Is_Nv=0090000}', "");
    Expect(0, 126254, '\P{^Is_Nv=0090000}', "");
    Expect(1, 126253, '\p{Is_Nv=9.000000000000000e+04}', "");
    Expect(0, 126253, '\p{^Is_Nv=9.000000000000000e+04}', "");
    Expect(0, 126253, '\P{Is_Nv=9.000000000000000e+04}', "");
    Expect(1, 126253, '\P{^Is_Nv=9.000000000000000e+04}', "");
    Expect(0, 126254, '\p{Is_Nv=9.000000000000000e+04}', "");
    Expect(1, 126254, '\p{^Is_Nv=9.000000000000000e+04}', "");
    Expect(1, 126254, '\P{Is_Nv=9.000000000000000e+04}', "");
    Expect(0, 126254, '\P{^Is_Nv=9.000000000000000e+04}', "");
    Error('\p{Numeric_Value= /a/00_00_90_00_00}');
    Error('\P{Numeric_Value= /a/00_00_90_00_00}');
    Expect(1, 68085, '\p{Numeric_Value=:\A900000\z:}', "");;
    Expect(0, 68086, '\p{Numeric_Value=:\A900000\z:}', "");;
    Expect(1, 68085, '\p{Numeric_Value=00_09_00_000}', "");
    Expect(0, 68085, '\p{^Numeric_Value=00_09_00_000}', "");
    Expect(0, 68085, '\P{Numeric_Value=00_09_00_000}', "");
    Expect(1, 68085, '\P{^Numeric_Value=00_09_00_000}', "");
    Expect(0, 68086, '\p{Numeric_Value=00_09_00_000}', "");
    Expect(1, 68086, '\p{^Numeric_Value=00_09_00_000}', "");
    Expect(1, 68086, '\P{Numeric_Value=00_09_00_000}', "");
    Expect(0, 68086, '\P{^Numeric_Value=00_09_00_000}', "");
    Expect(1, 68085, '\p{Numeric_Value=9.000000000000000e+05}', "");
    Expect(0, 68085, '\p{^Numeric_Value=9.000000000000000e+05}', "");
    Expect(0, 68085, '\P{Numeric_Value=9.000000000000000e+05}', "");
    Expect(1, 68085, '\P{^Numeric_Value=9.000000000000000e+05}', "");
    Expect(0, 68086, '\p{Numeric_Value=9.000000000000000e+05}', "");
    Expect(1, 68086, '\p{^Numeric_Value=9.000000000000000e+05}', "");
    Expect(1, 68086, '\P{Numeric_Value=9.000000000000000e+05}', "");
    Expect(0, 68086, '\P{^Numeric_Value=9.000000000000000e+05}', "");
    Error('\p{Nv=- +00_00_00_00_09_00000/a/}');
    Error('\P{Nv=- +00_00_00_00_09_00000/a/}');
    Expect(1, 68085, '\p{Nv=:\A900000\z:}', "");;
    Expect(0, 68086, '\p{Nv=:\A900000\z:}', "");;
    Expect(1, 68085, '\p{Nv=0_0_0_0_0_0_0_0_9_0_0000}', "");
    Expect(0, 68085, '\p{^Nv=0_0_0_0_0_0_0_0_9_0_0000}', "");
    Expect(0, 68085, '\P{Nv=0_0_0_0_0_0_0_0_9_0_0000}', "");
    Expect(1, 68085, '\P{^Nv=0_0_0_0_0_0_0_0_9_0_0000}', "");
    Expect(0, 68086, '\p{Nv=0_0_0_0_0_0_0_0_9_0_0000}', "");
    Expect(1, 68086, '\p{^Nv=0_0_0_0_0_0_0_0_9_0_0000}', "");
    Expect(1, 68086, '\P{Nv=0_0_0_0_0_0_0_0_9_0_0000}', "");
    Expect(0, 68086, '\P{^Nv=0_0_0_0_0_0_0_0_9_0_0000}', "");
    Expect(1, 68085, '\p{Nv=9.000000000000000e+05}', "");
    Expect(0, 68085, '\p{^Nv=9.000000000000000e+05}', "");
    Expect(0, 68085, '\P{Nv=9.000000000000000e+05}', "");
    Expect(1, 68085, '\P{^Nv=9.000000000000000e+05}', "");
    Expect(0, 68086, '\p{Nv=9.000000000000000e+05}', "");
    Expect(1, 68086, '\p{^Nv=9.000000000000000e+05}', "");
    Expect(1, 68086, '\P{Nv=9.000000000000000e+05}', "");
    Expect(0, 68086, '\P{^Nv=9.000000000000000e+05}', "");
    Error('\p{Is_Numeric_Value=--00_00_00_00_90_0000/a/}');
    Error('\P{Is_Numeric_Value=--00_00_00_00_90_0000/a/}');
    Expect(1, 68085, '\p{Is_Numeric_Value=0900000}', "");
    Expect(0, 68085, '\p{^Is_Numeric_Value=0900000}', "");
    Expect(0, 68085, '\P{Is_Numeric_Value=0900000}', "");
    Expect(1, 68085, '\P{^Is_Numeric_Value=0900000}', "");
    Expect(0, 68086, '\p{Is_Numeric_Value=0900000}', "");
    Expect(1, 68086, '\p{^Is_Numeric_Value=0900000}', "");
    Expect(1, 68086, '\P{Is_Numeric_Value=0900000}', "");
    Expect(0, 68086, '\P{^Is_Numeric_Value=0900000}', "");
    Expect(1, 68085, '\p{Is_Numeric_Value=9.000000000000000e+05}', "");
    Expect(0, 68085, '\p{^Is_Numeric_Value=9.000000000000000e+05}', "");
    Expect(0, 68085, '\P{Is_Numeric_Value=9.000000000000000e+05}', "");
    Expect(1, 68085, '\P{^Is_Numeric_Value=9.000000000000000e+05}', "");
    Expect(0, 68086, '\p{Is_Numeric_Value=9.000000000000000e+05}', "");
    Expect(1, 68086, '\p{^Is_Numeric_Value=9.000000000000000e+05}', "");
    Expect(1, 68086, '\P{Is_Numeric_Value=9.000000000000000e+05}', "");
    Expect(0, 68086, '\P{^Is_Numeric_Value=9.000000000000000e+05}', "");
    Error('\p{Is_Nv=/a/	 +0900000}');
    Error('\P{Is_Nv=/a/	 +0900000}');
    Expect(1, 68085, '\p{Is_Nv=0900000}', "");
    Expect(0, 68085, '\p{^Is_Nv=0900000}', "");
    Expect(0, 68085, '\P{Is_Nv=0900000}', "");
    Expect(1, 68085, '\P{^Is_Nv=0900000}', "");
    Expect(0, 68086, '\p{Is_Nv=0900000}', "");
    Expect(1, 68086, '\p{^Is_Nv=0900000}', "");
    Expect(1, 68086, '\P{Is_Nv=0900000}', "");
    Expect(0, 68086, '\P{^Is_Nv=0900000}', "");
    Expect(1, 68085, '\p{Is_Nv: 9.000000000000000e+05}', "");
    Expect(0, 68085, '\p{^Is_Nv: 9.000000000000000e+05}', "");
    Expect(0, 68085, '\P{Is_Nv: 9.000000000000000e+05}', "");
    Expect(1, 68085, '\P{^Is_Nv: 9.000000000000000e+05}', "");
    Expect(0, 68086, '\p{Is_Nv: 9.000000000000000e+05}', "");
    Expect(1, 68086, '\p{^Is_Nv: 9.000000000000000e+05}', "");
    Expect(1, 68086, '\P{Is_Nv: 9.000000000000000e+05}', "");
    Expect(0, 68086, '\P{^Is_Nv: 9.000000000000000e+05}', "");
    Error('\p{Numeric_Value=	:=nan}');
    Error('\P{Numeric_Value=	:=nan}');
    Expect(1, 194705, '\p{Numeric_Value=:\ANaN\z:}', "");;
    Expect(0, 194704, '\p{Numeric_Value=:\ANaN\z:}', "");;
    Expect(1, 194705, '\p{Numeric_Value=nan}', "");
    Expect(0, 194705, '\p{^Numeric_Value=nan}', "");
    Expect(0, 194705, '\P{Numeric_Value=nan}', "");
    Expect(1, 194705, '\P{^Numeric_Value=nan}', "");
    Expect(0, 194704, '\p{Numeric_Value=nan}', "");
    Expect(1, 194704, '\p{^Numeric_Value=nan}', "");
    Expect(1, 194704, '\P{Numeric_Value=nan}', "");
    Expect(0, 194704, '\P{^Numeric_Value=nan}', "");
    Expect(1, 194705, '\p{Numeric_Value=:\Anan\z:}', "");;
    Expect(0, 194704, '\p{Numeric_Value=:\Anan\z:}', "");;
    Expect(1, 194705, '\p{Numeric_Value=_NaN}', "");
    Expect(0, 194705, '\p{^Numeric_Value=_NaN}', "");
    Expect(0, 194705, '\P{Numeric_Value=_NaN}', "");
    Expect(1, 194705, '\P{^Numeric_Value=_NaN}', "");
    Expect(0, 194704, '\p{Numeric_Value=_NaN}', "");
    Expect(1, 194704, '\p{^Numeric_Value=_NaN}', "");
    Expect(1, 194704, '\P{Numeric_Value=_NaN}', "");
    Expect(0, 194704, '\P{^Numeric_Value=_NaN}', "");
    Expect(1, 194705, '\p{Numeric_Value=NaN}', "");
    Expect(0, 194705, '\p{^Numeric_Value=NaN}', "");
    Expect(0, 194705, '\P{Numeric_Value=NaN}', "");
    Expect(1, 194705, '\P{^Numeric_Value=NaN}', "");
    Expect(0, 194704, '\p{Numeric_Value=NaN}', "");
    Expect(1, 194704, '\p{^Numeric_Value=NaN}', "");
    Expect(1, 194704, '\P{Numeric_Value=NaN}', "");
    Expect(0, 194704, '\P{^Numeric_Value=NaN}', "");
    Error('\p{Nv=	_NAN:=}');
    Error('\P{Nv=	_NAN:=}');
    Expect(1, 194705, '\p{Nv=:\ANaN\z:}', "");;
    Expect(0, 194704, '\p{Nv=:\ANaN\z:}', "");;
    Expect(1, 194705, '\p{Nv=nan}', "");
    Expect(0, 194705, '\p{^Nv=nan}', "");
    Expect(0, 194705, '\P{Nv=nan}', "");
    Expect(1, 194705, '\P{^Nv=nan}', "");
    Expect(0, 194704, '\p{Nv=nan}', "");
    Expect(1, 194704, '\p{^Nv=nan}', "");
    Expect(1, 194704, '\P{Nv=nan}', "");
    Expect(0, 194704, '\P{^Nv=nan}', "");
    Expect(1, 194705, '\p{Nv=:\Anan\z:}', "");;
    Expect(0, 194704, '\p{Nv=:\Anan\z:}', "");;
    Expect(1, 194705, '\p{Nv:   -_NaN}', "");
    Expect(0, 194705, '\p{^Nv:   -_NaN}', "");
    Expect(0, 194705, '\P{Nv:   -_NaN}', "");
    Expect(1, 194705, '\P{^Nv:   -_NaN}', "");
    Expect(0, 194704, '\p{Nv:   -_NaN}', "");
    Expect(1, 194704, '\p{^Nv:   -_NaN}', "");
    Expect(1, 194704, '\P{Nv:   -_NaN}', "");
    Expect(0, 194704, '\P{^Nv:   -_NaN}', "");
    Expect(1, 194705, '\p{Nv=NaN}', "");
    Expect(0, 194705, '\p{^Nv=NaN}', "");
    Expect(0, 194705, '\P{Nv=NaN}', "");
    Expect(1, 194705, '\P{^Nv=NaN}', "");
    Expect(0, 194704, '\p{Nv=NaN}', "");
    Expect(1, 194704, '\p{^Nv=NaN}', "");
    Expect(1, 194704, '\P{Nv=NaN}', "");
    Expect(0, 194704, '\P{^Nv=NaN}', "");
    Error('\p{Is_Numeric_Value=:= _nan}');
    Error('\P{Is_Numeric_Value=:= _nan}');
    Expect(1, 194705, '\p{Is_Numeric_Value=nan}', "");
    Expect(0, 194705, '\p{^Is_Numeric_Value=nan}', "");
    Expect(0, 194705, '\P{Is_Numeric_Value=nan}', "");
    Expect(1, 194705, '\P{^Is_Numeric_Value=nan}', "");
    Expect(0, 194704, '\p{Is_Numeric_Value=nan}', "");
    Expect(1, 194704, '\p{^Is_Numeric_Value=nan}', "");
    Expect(1, 194704, '\P{Is_Numeric_Value=nan}', "");
    Expect(0, 194704, '\P{^Is_Numeric_Value=nan}', "");
    Expect(1, 194705, '\p{Is_Numeric_Value=_NAN}', "");
    Expect(0, 194705, '\p{^Is_Numeric_Value=_NAN}', "");
    Expect(0, 194705, '\P{Is_Numeric_Value=_NAN}', "");
    Expect(1, 194705, '\P{^Is_Numeric_Value=_NAN}', "");
    Expect(0, 194704, '\p{Is_Numeric_Value=_NAN}', "");
    Expect(1, 194704, '\p{^Is_Numeric_Value=_NAN}', "");
    Expect(1, 194704, '\P{Is_Numeric_Value=_NAN}', "");
    Expect(0, 194704, '\P{^Is_Numeric_Value=_NAN}', "");
    Expect(1, 194705, '\p{Is_Numeric_Value=NaN}', "");
    Expect(0, 194705, '\p{^Is_Numeric_Value=NaN}', "");
    Expect(0, 194705, '\P{Is_Numeric_Value=NaN}', "");
    Expect(1, 194705, '\P{^Is_Numeric_Value=NaN}', "");
    Expect(0, 194704, '\p{Is_Numeric_Value=NaN}', "");
    Expect(1, 194704, '\p{^Is_Numeric_Value=NaN}', "");
    Expect(1, 194704, '\P{Is_Numeric_Value=NaN}', "");
    Expect(0, 194704, '\P{^Is_Numeric_Value=NaN}', "");
    Error('\p{Is_Nv:	_NaN:=}');
    Error('\P{Is_Nv:	_NaN:=}');
    Expect(1, 194705, '\p{Is_Nv=nan}', "");
    Expect(0, 194705, '\p{^Is_Nv=nan}', "");
    Expect(0, 194705, '\P{Is_Nv=nan}', "");
    Expect(1, 194705, '\P{^Is_Nv=nan}', "");
    Expect(0, 194704, '\p{Is_Nv=nan}', "");
    Expect(1, 194704, '\p{^Is_Nv=nan}', "");
    Expect(1, 194704, '\P{Is_Nv=nan}', "");
    Expect(0, 194704, '\P{^Is_Nv=nan}', "");
    Expect(1, 194705, '\p{Is_Nv= 	nan}', "");
    Expect(0, 194705, '\p{^Is_Nv= 	nan}', "");
    Expect(0, 194705, '\P{Is_Nv= 	nan}', "");
    Expect(1, 194705, '\P{^Is_Nv= 	nan}', "");
    Expect(0, 194704, '\p{Is_Nv= 	nan}', "");
    Expect(1, 194704, '\p{^Is_Nv= 	nan}', "");
    Expect(1, 194704, '\P{Is_Nv= 	nan}', "");
    Expect(0, 194704, '\P{^Is_Nv= 	nan}', "");
    Expect(1, 194705, '\p{Is_Nv:	NaN}', "");
    Expect(0, 194705, '\p{^Is_Nv:	NaN}', "");
    Expect(0, 194705, '\P{Is_Nv:	NaN}', "");
    Expect(1, 194705, '\P{^Is_Nv:	NaN}', "");
    Expect(0, 194704, '\p{Is_Nv:	NaN}', "");
    Expect(1, 194704, '\p{^Is_Nv:	NaN}', "");
    Expect(1, 194704, '\P{Is_Nv:	NaN}', "");
    Expect(0, 194704, '\P{^Is_Nv:	NaN}', "");
    Error('\p{Other_Alphabetic: No}');
    Error('\P{Other_Alphabetic: No}');
    Error('\p{OAlpha=N}');
    Error('\P{OAlpha=N}');
    Error('\p{Is_Other_Alphabetic=F}');
    Error('\P{Is_Other_Alphabetic=F}');
    Error('\p{Is_OAlpha=False}');
    Error('\P{Is_OAlpha=False}');
    Error('\p{Other_Alphabetic=Yes}');
    Error('\P{Other_Alphabetic=Yes}');
    Error('\p{OAlpha=Y}');
    Error('\P{OAlpha=Y}');
    Error('\p{Is_Other_Alphabetic=T}');
    Error('\P{Is_Other_Alphabetic=T}');
    Error('\p{Is_OAlpha=True}');
    Error('\P{Is_OAlpha=True}');
    Error('\p{Other_Default_Ignorable_Code_Point=No}');
    Error('\P{Other_Default_Ignorable_Code_Point=No}');
    Error('\p{ODI:N}');
    Error('\P{ODI:N}');
    Error('\p{Is_Other_Default_Ignorable_Code_Point=F}');
    Error('\P{Is_Other_Default_Ignorable_Code_Point=F}');
    Error('\p{Is_ODI=False}');
    Error('\P{Is_ODI=False}');
    Error('\p{Other_Default_Ignorable_Code_Point:Yes}');
    Error('\P{Other_Default_Ignorable_Code_Point:Yes}');
    Error('\p{ODI=Y}');
    Error('\P{ODI=Y}');
    Error('\p{Is_Other_Default_Ignorable_Code_Point=T}');
    Error('\P{Is_Other_Default_Ignorable_Code_Point=T}');
    Error('\p{Is_ODI: True}');
    Error('\P{Is_ODI: True}');
    Error('\p{Other_Grapheme_Extend=No}');
    Error('\P{Other_Grapheme_Extend=No}');
    Error('\p{OGr_Ext=N}');
    Error('\P{OGr_Ext=N}');
    Error('\p{Is_Other_Grapheme_Extend=F}');
    Error('\P{Is_Other_Grapheme_Extend=F}');
    Error('\p{Is_OGr_Ext:   False}');
    Error('\P{Is_OGr_Ext:   False}');
    Error('\p{Other_Grapheme_Extend: Yes}');
    Error('\P{Other_Grapheme_Extend: Yes}');
    Error('\p{OGr_Ext=Y}');
    Error('\P{OGr_Ext=Y}');
    Error('\p{Is_Other_Grapheme_Extend=T}');
    Error('\P{Is_Other_Grapheme_Extend=T}');
    Error('\p{Is_OGr_Ext=True}');
    Error('\P{Is_OGr_Ext=True}');
    Error('\p{Other_ID_Continue=No}');
    Error('\P{Other_ID_Continue=No}');
    Error('\p{OIDC=N}');
    Error('\P{OIDC=N}');
    Error('\p{Is_Other_ID_Continue:   F}');
    Error('\P{Is_Other_ID_Continue:   F}');
    Error('\p{Is_OIDC=False}');
    Error('\P{Is_OIDC=False}');
    Error('\p{Other_ID_Continue=Yes}');
    Error('\P{Other_ID_Continue=Yes}');
    Error('\p{OIDC=Y}');
    Error('\P{OIDC=Y}');
    Error('\p{Is_Other_ID_Continue=T}');
    Error('\P{Is_Other_ID_Continue=T}');
    Error('\p{Is_OIDC=True}');
    Error('\P{Is_OIDC=True}');
    Error('\p{Other_ID_Start=No}');
    Error('\P{Other_ID_Start=No}');
    Error('\p{OIDS=N}');
    Error('\P{OIDS=N}');
    Error('\p{Is_Other_ID_Start=F}');
    Error('\P{Is_Other_ID_Start=F}');
    Error('\p{Is_OIDS=False}');
    Error('\P{Is_OIDS=False}');
    Error('\p{Other_ID_Start=Yes}');
    Error('\P{Other_ID_Start=Yes}');
    Error('\p{OIDS=Y}');
    Error('\P{OIDS=Y}');
    Error('\p{Is_Other_ID_Start=T}');
    Error('\P{Is_Other_ID_Start=T}');
    Error('\p{Is_OIDS=True}');
    Error('\P{Is_OIDS=True}');
    Error('\p{Other_Lowercase=No}');
    Error('\P{Other_Lowercase=No}');
    Error('\p{OLower:   N}');
    Error('\P{OLower:   N}');
    Error('\p{Is_Other_Lowercase: F}');
    Error('\P{Is_Other_Lowercase: F}');
    Error('\p{Is_OLower:	False}');
    Error('\P{Is_OLower:	False}');
    Error('\p{Other_Lowercase=Yes}');
    Error('\P{Other_Lowercase=Yes}');
    Error('\p{OLower=Y}');
    Error('\P{OLower=Y}');
    Error('\p{Is_Other_Lowercase=T}');
    Error('\P{Is_Other_Lowercase=T}');
    Error('\p{Is_OLower=True}');
    Error('\P{Is_OLower=True}');
    Error('\p{Other_Math=No}');
    Error('\P{Other_Math=No}');
    Error('\p{OMath=N}');
    Error('\P{OMath=N}');
    Error('\p{Is_Other_Math:F}');
    Error('\P{Is_Other_Math:F}');
    Error('\p{Is_OMath=False}');
    Error('\P{Is_OMath=False}');
    Error('\p{Other_Math=Yes}');
    Error('\P{Other_Math=Yes}');
    Error('\p{OMath:   Y}');
    Error('\P{OMath:   Y}');
    Error('\p{Is_Other_Math=T}');
    Error('\P{Is_Other_Math=T}');
    Error('\p{Is_OMath=True}');
    Error('\P{Is_OMath=True}');
    Error('\p{Other_Uppercase=No}');
    Error('\P{Other_Uppercase=No}');
    Error('\p{OUpper:   N}');
    Error('\P{OUpper:   N}');
    Error('\p{Is_Other_Uppercase=F}');
    Error('\P{Is_Other_Uppercase=F}');
    Error('\p{Is_OUpper=False}');
    Error('\P{Is_OUpper=False}');
    Error('\p{Other_Uppercase:Yes}');
    Error('\P{Other_Uppercase:Yes}');
    Error('\p{OUpper=Y}');
    Error('\P{OUpper=Y}');
    Error('\p{Is_Other_Uppercase=T}');
    Error('\P{Is_Other_Uppercase=T}');
    Error('\p{Is_OUpper=True}');
    Error('\P{Is_OUpper=True}');
    Error('\p{Pattern_Syntax=-/a/No}');
    Error('\P{Pattern_Syntax=-/a/No}');
    Expect(1, 65095, '\p{Pattern_Syntax=:\ANo\z:}', "");;
    Expect(0, 65094, '\p{Pattern_Syntax=:\ANo\z:}', "");;
    Expect(1, 65095, '\p{Pattern_Syntax=no}', "");
    Expect(0, 65095, '\p{^Pattern_Syntax=no}', "");
    Expect(0, 65095, '\P{Pattern_Syntax=no}', "");
    Expect(1, 65095, '\P{^Pattern_Syntax=no}', "");
    Expect(0, 65094, '\p{Pattern_Syntax=no}', "");
    Expect(1, 65094, '\p{^Pattern_Syntax=no}', "");
    Expect(1, 65094, '\P{Pattern_Syntax=no}', "");
    Expect(0, 65094, '\P{^Pattern_Syntax=no}', "");
    Expect(1, 65095, '\p{Pattern_Syntax=:\Ano\z:}', "");;
    Expect(0, 65094, '\p{Pattern_Syntax=:\Ano\z:}', "");;
    Expect(1, 65095, '\p{Pattern_Syntax=-No}', "");
    Expect(0, 65095, '\p{^Pattern_Syntax=-No}', "");
    Expect(0, 65095, '\P{Pattern_Syntax=-No}', "");
    Expect(1, 65095, '\P{^Pattern_Syntax=-No}', "");
    Expect(0, 65094, '\p{Pattern_Syntax=-No}', "");
    Expect(1, 65094, '\p{^Pattern_Syntax=-No}', "");
    Expect(1, 65094, '\P{Pattern_Syntax=-No}', "");
    Expect(0, 65094, '\P{^Pattern_Syntax=-No}', "");
    Error('\p{Pat_Syn=/a/--n}');
    Error('\P{Pat_Syn=/a/--n}');
    Expect(1, 65095, '\p{Pat_Syn=:\AN\z:}', "");;
    Expect(0, 65094, '\p{Pat_Syn=:\AN\z:}', "");;
    Expect(1, 65095, '\p{Pat_Syn=n}', "");
    Expect(0, 65095, '\p{^Pat_Syn=n}', "");
    Expect(0, 65095, '\P{Pat_Syn=n}', "");
    Expect(1, 65095, '\P{^Pat_Syn=n}', "");
    Expect(0, 65094, '\p{Pat_Syn=n}', "");
    Expect(1, 65094, '\p{^Pat_Syn=n}', "");
    Expect(1, 65094, '\P{Pat_Syn=n}', "");
    Expect(0, 65094, '\P{^Pat_Syn=n}', "");
    Expect(1, 65095, '\p{Pat_Syn=:\An\z:}', "");;
    Expect(0, 65094, '\p{Pat_Syn=:\An\z:}', "");;
    Expect(1, 65095, '\p{Pat_Syn= _N}', "");
    Expect(0, 65095, '\p{^Pat_Syn= _N}', "");
    Expect(0, 65095, '\P{Pat_Syn= _N}', "");
    Expect(1, 65095, '\P{^Pat_Syn= _N}', "");
    Expect(0, 65094, '\p{Pat_Syn= _N}', "");
    Expect(1, 65094, '\p{^Pat_Syn= _N}', "");
    Expect(1, 65094, '\P{Pat_Syn= _N}', "");
    Expect(0, 65094, '\P{^Pat_Syn= _N}', "");
    Error('\p{Is_Pattern_Syntax=/a/--f}');
    Error('\P{Is_Pattern_Syntax=/a/--f}');
    Expect(1, 65095, '\p{Is_Pattern_Syntax=f}', "");
    Expect(0, 65095, '\p{^Is_Pattern_Syntax=f}', "");
    Expect(0, 65095, '\P{Is_Pattern_Syntax=f}', "");
    Expect(1, 65095, '\P{^Is_Pattern_Syntax=f}', "");
    Expect(0, 65094, '\p{Is_Pattern_Syntax=f}', "");
    Expect(1, 65094, '\p{^Is_Pattern_Syntax=f}', "");
    Expect(1, 65094, '\P{Is_Pattern_Syntax=f}', "");
    Expect(0, 65094, '\P{^Is_Pattern_Syntax=f}', "");
    Expect(1, 65095, '\p{Is_Pattern_Syntax=-F}', "");
    Expect(0, 65095, '\p{^Is_Pattern_Syntax=-F}', "");
    Expect(0, 65095, '\P{Is_Pattern_Syntax=-F}', "");
    Expect(1, 65095, '\P{^Is_Pattern_Syntax=-F}', "");
    Expect(0, 65094, '\p{Is_Pattern_Syntax=-F}', "");
    Expect(1, 65094, '\p{^Is_Pattern_Syntax=-F}', "");
    Expect(1, 65094, '\P{Is_Pattern_Syntax=-F}', "");
    Expect(0, 65094, '\P{^Is_Pattern_Syntax=-F}', "");
    Error('\p{Is_Pat_Syn=_false:=}');
    Error('\P{Is_Pat_Syn=_false:=}');
    Expect(1, 65095, '\p{Is_Pat_Syn=false}', "");
    Expect(0, 65095, '\p{^Is_Pat_Syn=false}', "");
    Expect(0, 65095, '\P{Is_Pat_Syn=false}', "");
    Expect(1, 65095, '\P{^Is_Pat_Syn=false}', "");
    Expect(0, 65094, '\p{Is_Pat_Syn=false}', "");
    Expect(1, 65094, '\p{^Is_Pat_Syn=false}', "");
    Expect(1, 65094, '\P{Is_Pat_Syn=false}', "");
    Expect(0, 65094, '\P{^Is_Pat_Syn=false}', "");
    Expect(1, 65095, '\p{Is_Pat_Syn=	false}', "");
    Expect(0, 65095, '\p{^Is_Pat_Syn=	false}', "");
    Expect(0, 65095, '\P{Is_Pat_Syn=	false}', "");
    Expect(1, 65095, '\P{^Is_Pat_Syn=	false}', "");
    Expect(0, 65094, '\p{Is_Pat_Syn=	false}', "");
    Expect(1, 65094, '\p{^Is_Pat_Syn=	false}', "");
    Expect(1, 65094, '\P{Is_Pat_Syn=	false}', "");
    Expect(0, 65094, '\P{^Is_Pat_Syn=	false}', "");
    Error('\p{Pattern_Syntax: := -Yes}');
    Error('\P{Pattern_Syntax: := -Yes}');
    Expect(1, 65094, '\p{Pattern_Syntax=:\AYes\z:}', "");;
    Expect(0, 65095, '\p{Pattern_Syntax=:\AYes\z:}', "");;
    Expect(1, 65094, '\p{Pattern_Syntax=yes}', "");
    Expect(0, 65094, '\p{^Pattern_Syntax=yes}', "");
    Expect(0, 65094, '\P{Pattern_Syntax=yes}', "");
    Expect(1, 65094, '\P{^Pattern_Syntax=yes}', "");
    Expect(0, 65095, '\p{Pattern_Syntax=yes}', "");
    Expect(1, 65095, '\p{^Pattern_Syntax=yes}', "");
    Expect(1, 65095, '\P{Pattern_Syntax=yes}', "");
    Expect(0, 65095, '\P{^Pattern_Syntax=yes}', "");
    Expect(1, 65094, '\p{Pattern_Syntax=:\Ayes\z:}', "");;
    Expect(0, 65095, '\p{Pattern_Syntax=:\Ayes\z:}', "");;
    Expect(1, 65094, '\p{Pattern_Syntax=-	yes}', "");
    Expect(0, 65094, '\p{^Pattern_Syntax=-	yes}', "");
    Expect(0, 65094, '\P{Pattern_Syntax=-	yes}', "");
    Expect(1, 65094, '\P{^Pattern_Syntax=-	yes}', "");
    Expect(0, 65095, '\p{Pattern_Syntax=-	yes}', "");
    Expect(1, 65095, '\p{^Pattern_Syntax=-	yes}', "");
    Expect(1, 65095, '\P{Pattern_Syntax=-	yes}', "");
    Expect(0, 65095, '\P{^Pattern_Syntax=-	yes}', "");
    Error('\p{Pat_Syn=-Y/a/}');
    Error('\P{Pat_Syn=-Y/a/}');
    Expect(1, 65094, '\p{Pat_Syn=:\AY\z:}', "");;
    Expect(0, 65095, '\p{Pat_Syn=:\AY\z:}', "");;
    Expect(1, 65094, '\p{Pat_Syn=y}', "");
    Expect(0, 65094, '\p{^Pat_Syn=y}', "");
    Expect(0, 65094, '\P{Pat_Syn=y}', "");
    Expect(1, 65094, '\P{^Pat_Syn=y}', "");
    Expect(0, 65095, '\p{Pat_Syn=y}', "");
    Expect(1, 65095, '\p{^Pat_Syn=y}', "");
    Expect(1, 65095, '\P{Pat_Syn=y}', "");
    Expect(0, 65095, '\P{^Pat_Syn=y}', "");
    Expect(1, 65094, '\p{Pat_Syn=:\Ay\z:}', "");;
    Expect(0, 65095, '\p{Pat_Syn=:\Ay\z:}', "");;
    Expect(1, 65094, '\p{Pat_Syn=	Y}', "");
    Expect(0, 65094, '\p{^Pat_Syn=	Y}', "");
    Expect(0, 65094, '\P{Pat_Syn=	Y}', "");
    Expect(1, 65094, '\P{^Pat_Syn=	Y}', "");
    Expect(0, 65095, '\p{Pat_Syn=	Y}', "");
    Expect(1, 65095, '\p{^Pat_Syn=	Y}', "");
    Expect(1, 65095, '\P{Pat_Syn=	Y}', "");
    Expect(0, 65095, '\P{^Pat_Syn=	Y}', "");
    Error('\p{Is_Pattern_Syntax=:=  T}');
    Error('\P{Is_Pattern_Syntax=:=  T}');
    Expect(1, 65094, '\p{Is_Pattern_Syntax=t}', "");
    Expect(0, 65094, '\p{^Is_Pattern_Syntax=t}', "");
    Expect(0, 65094, '\P{Is_Pattern_Syntax=t}', "");
    Expect(1, 65094, '\P{^Is_Pattern_Syntax=t}', "");
    Expect(0, 65095, '\p{Is_Pattern_Syntax=t}', "");
    Expect(1, 65095, '\p{^Is_Pattern_Syntax=t}', "");
    Expect(1, 65095, '\P{Is_Pattern_Syntax=t}', "");
    Expect(0, 65095, '\P{^Is_Pattern_Syntax=t}', "");
    Expect(1, 65094, '\p{Is_Pattern_Syntax: 	t}', "");
    Expect(0, 65094, '\p{^Is_Pattern_Syntax: 	t}', "");
    Expect(0, 65094, '\P{Is_Pattern_Syntax: 	t}', "");
    Expect(1, 65094, '\P{^Is_Pattern_Syntax: 	t}', "");
    Expect(0, 65095, '\p{Is_Pattern_Syntax: 	t}', "");
    Expect(1, 65095, '\p{^Is_Pattern_Syntax: 	t}', "");
    Expect(1, 65095, '\P{Is_Pattern_Syntax: 	t}', "");
    Expect(0, 65095, '\P{^Is_Pattern_Syntax: 	t}', "");
    Error('\p{Is_Pat_Syn=	-True:=}');
    Error('\P{Is_Pat_Syn=	-True:=}');
    Expect(1, 65094, '\p{Is_Pat_Syn=true}', "");
    Expect(0, 65094, '\p{^Is_Pat_Syn=true}', "");
    Expect(0, 65094, '\P{Is_Pat_Syn=true}', "");
    Expect(1, 65094, '\P{^Is_Pat_Syn=true}', "");
    Expect(0, 65095, '\p{Is_Pat_Syn=true}', "");
    Expect(1, 65095, '\p{^Is_Pat_Syn=true}', "");
    Expect(1, 65095, '\P{Is_Pat_Syn=true}', "");
    Expect(0, 65095, '\P{^Is_Pat_Syn=true}', "");
    Expect(1, 65094, '\p{Is_Pat_Syn=--TRUE}', "");
    Expect(0, 65094, '\p{^Is_Pat_Syn=--TRUE}', "");
    Expect(0, 65094, '\P{Is_Pat_Syn=--TRUE}', "");
    Expect(1, 65094, '\P{^Is_Pat_Syn=--TRUE}', "");
    Expect(0, 65095, '\p{Is_Pat_Syn=--TRUE}', "");
    Expect(1, 65095, '\p{^Is_Pat_Syn=--TRUE}', "");
    Expect(1, 65095, '\P{Is_Pat_Syn=--TRUE}', "");
    Expect(0, 65095, '\P{^Is_Pat_Syn=--TRUE}', "");
    Error('\p{Pattern_White_Space=:=No}');
    Error('\P{Pattern_White_Space=:=No}');
    Expect(1, 8234, '\p{Pattern_White_Space=:\ANo\z:}', "");;
    Expect(0, 8233, '\p{Pattern_White_Space=:\ANo\z:}', "");;
    Expect(1, 8234, '\p{Pattern_White_Space:no}', "");
    Expect(0, 8234, '\p{^Pattern_White_Space:no}', "");
    Expect(0, 8234, '\P{Pattern_White_Space:no}', "");
    Expect(1, 8234, '\P{^Pattern_White_Space:no}', "");
    Expect(0, 8233, '\p{Pattern_White_Space:no}', "");
    Expect(1, 8233, '\p{^Pattern_White_Space:no}', "");
    Expect(1, 8233, '\P{Pattern_White_Space:no}', "");
    Expect(0, 8233, '\P{^Pattern_White_Space:no}', "");
    Expect(1, 8234, '\p{Pattern_White_Space=:\Ano\z:}', "");;
    Expect(0, 8233, '\p{Pattern_White_Space=:\Ano\z:}', "");;
    Expect(1, 8234, '\p{Pattern_White_Space=	-No}', "");
    Expect(0, 8234, '\p{^Pattern_White_Space=	-No}', "");
    Expect(0, 8234, '\P{Pattern_White_Space=	-No}', "");
    Expect(1, 8234, '\P{^Pattern_White_Space=	-No}', "");
    Expect(0, 8233, '\p{Pattern_White_Space=	-No}', "");
    Expect(1, 8233, '\p{^Pattern_White_Space=	-No}', "");
    Expect(1, 8233, '\P{Pattern_White_Space=	-No}', "");
    Expect(0, 8233, '\P{^Pattern_White_Space=	-No}', "");
    Error('\p{Pat_WS=-:=N}');
    Error('\P{Pat_WS=-:=N}');
    Expect(1, 8234, '\p{Pat_WS=:\AN\z:}', "");;
    Expect(0, 8233, '\p{Pat_WS=:\AN\z:}', "");;
    Expect(1, 8234, '\p{Pat_WS=n}', "");
    Expect(0, 8234, '\p{^Pat_WS=n}', "");
    Expect(0, 8234, '\P{Pat_WS=n}', "");
    Expect(1, 8234, '\P{^Pat_WS=n}', "");
    Expect(0, 8233, '\p{Pat_WS=n}', "");
    Expect(1, 8233, '\p{^Pat_WS=n}', "");
    Expect(1, 8233, '\P{Pat_WS=n}', "");
    Expect(0, 8233, '\P{^Pat_WS=n}', "");
    Expect(1, 8234, '\p{Pat_WS=:\An\z:}', "");;
    Expect(0, 8233, '\p{Pat_WS=:\An\z:}', "");;
    Expect(1, 8234, '\p{Pat_WS= n}', "");
    Expect(0, 8234, '\p{^Pat_WS= n}', "");
    Expect(0, 8234, '\P{Pat_WS= n}', "");
    Expect(1, 8234, '\P{^Pat_WS= n}', "");
    Expect(0, 8233, '\p{Pat_WS= n}', "");
    Expect(1, 8233, '\p{^Pat_WS= n}', "");
    Expect(1, 8233, '\P{Pat_WS= n}', "");
    Expect(0, 8233, '\P{^Pat_WS= n}', "");
    Error('\p{Is_Pattern_White_Space= -F:=}');
    Error('\P{Is_Pattern_White_Space= -F:=}');
    Expect(1, 8234, '\p{Is_Pattern_White_Space=f}', "");
    Expect(0, 8234, '\p{^Is_Pattern_White_Space=f}', "");
    Expect(0, 8234, '\P{Is_Pattern_White_Space=f}', "");
    Expect(1, 8234, '\P{^Is_Pattern_White_Space=f}', "");
    Expect(0, 8233, '\p{Is_Pattern_White_Space=f}', "");
    Expect(1, 8233, '\p{^Is_Pattern_White_Space=f}', "");
    Expect(1, 8233, '\P{Is_Pattern_White_Space=f}', "");
    Expect(0, 8233, '\P{^Is_Pattern_White_Space=f}', "");
    Expect(1, 8234, '\p{Is_Pattern_White_Space=	_F}', "");
    Expect(0, 8234, '\p{^Is_Pattern_White_Space=	_F}', "");
    Expect(0, 8234, '\P{Is_Pattern_White_Space=	_F}', "");
    Expect(1, 8234, '\P{^Is_Pattern_White_Space=	_F}', "");
    Expect(0, 8233, '\p{Is_Pattern_White_Space=	_F}', "");
    Expect(1, 8233, '\p{^Is_Pattern_White_Space=	_F}', "");
    Expect(1, 8233, '\P{Is_Pattern_White_Space=	_F}', "");
    Expect(0, 8233, '\P{^Is_Pattern_White_Space=	_F}', "");
    Error('\p{Is_Pat_WS=	/a/False}');
    Error('\P{Is_Pat_WS=	/a/False}');
    Expect(1, 8234, '\p{Is_Pat_WS=false}', "");
    Expect(0, 8234, '\p{^Is_Pat_WS=false}', "");
    Expect(0, 8234, '\P{Is_Pat_WS=false}', "");
    Expect(1, 8234, '\P{^Is_Pat_WS=false}', "");
    Expect(0, 8233, '\p{Is_Pat_WS=false}', "");
    Expect(1, 8233, '\p{^Is_Pat_WS=false}', "");
    Expect(1, 8233, '\P{Is_Pat_WS=false}', "");
    Expect(0, 8233, '\P{^Is_Pat_WS=false}', "");
    Expect(1, 8234, '\p{Is_Pat_WS=  False}', "");
    Expect(0, 8234, '\p{^Is_Pat_WS=  False}', "");
    Expect(0, 8234, '\P{Is_Pat_WS=  False}', "");
    Expect(1, 8234, '\P{^Is_Pat_WS=  False}', "");
    Expect(0, 8233, '\p{Is_Pat_WS=  False}', "");
    Expect(1, 8233, '\p{^Is_Pat_WS=  False}', "");
    Expect(1, 8233, '\P{Is_Pat_WS=  False}', "");
    Expect(0, 8233, '\P{^Is_Pat_WS=  False}', "");
    Error('\p{Pattern_White_Space= 	Yes:=}');
    Error('\P{Pattern_White_Space= 	Yes:=}');
    Expect(1, 8233, '\p{Pattern_White_Space=:\AYes\z:}', "");;
    Expect(0, 8234, '\p{Pattern_White_Space=:\AYes\z:}', "");;
    Expect(1, 8233, '\p{Pattern_White_Space=yes}', "");
    Expect(0, 8233, '\p{^Pattern_White_Space=yes}', "");
    Expect(0, 8233, '\P{Pattern_White_Space=yes}', "");
    Expect(1, 8233, '\P{^Pattern_White_Space=yes}', "");
    Expect(0, 8234, '\p{Pattern_White_Space=yes}', "");
    Expect(1, 8234, '\p{^Pattern_White_Space=yes}', "");
    Expect(1, 8234, '\P{Pattern_White_Space=yes}', "");
    Expect(0, 8234, '\P{^Pattern_White_Space=yes}', "");
    Expect(1, 8233, '\p{Pattern_White_Space=:\Ayes\z:}', "");;
    Expect(0, 8234, '\p{Pattern_White_Space=:\Ayes\z:}', "");;
    Expect(1, 8233, '\p{Pattern_White_Space=	YES}', "");
    Expect(0, 8233, '\p{^Pattern_White_Space=	YES}', "");
    Expect(0, 8233, '\P{Pattern_White_Space=	YES}', "");
    Expect(1, 8233, '\P{^Pattern_White_Space=	YES}', "");
    Expect(0, 8234, '\p{Pattern_White_Space=	YES}', "");
    Expect(1, 8234, '\p{^Pattern_White_Space=	YES}', "");
    Expect(1, 8234, '\P{Pattern_White_Space=	YES}', "");
    Expect(0, 8234, '\P{^Pattern_White_Space=	YES}', "");
    Error('\p{Pat_WS=__Y:=}');
    Error('\P{Pat_WS=__Y:=}');
    Expect(1, 8233, '\p{Pat_WS=:\AY\z:}', "");;
    Expect(0, 8234, '\p{Pat_WS=:\AY\z:}', "");;
    Expect(1, 8233, '\p{Pat_WS=y}', "");
    Expect(0, 8233, '\p{^Pat_WS=y}', "");
    Expect(0, 8233, '\P{Pat_WS=y}', "");
    Expect(1, 8233, '\P{^Pat_WS=y}', "");
    Expect(0, 8234, '\p{Pat_WS=y}', "");
    Expect(1, 8234, '\p{^Pat_WS=y}', "");
    Expect(1, 8234, '\P{Pat_WS=y}', "");
    Expect(0, 8234, '\P{^Pat_WS=y}', "");
    Expect(1, 8233, '\p{Pat_WS=:\Ay\z:}', "");;
    Expect(0, 8234, '\p{Pat_WS=:\Ay\z:}', "");;
    Expect(1, 8233, '\p{Pat_WS=		Y}', "");
    Expect(0, 8233, '\p{^Pat_WS=		Y}', "");
    Expect(0, 8233, '\P{Pat_WS=		Y}', "");
    Expect(1, 8233, '\P{^Pat_WS=		Y}', "");
    Expect(0, 8234, '\p{Pat_WS=		Y}', "");
    Expect(1, 8234, '\p{^Pat_WS=		Y}', "");
    Expect(1, 8234, '\P{Pat_WS=		Y}', "");
    Expect(0, 8234, '\P{^Pat_WS=		Y}', "");
    Error('\p{Is_Pattern_White_Space=-	T/a/}');
    Error('\P{Is_Pattern_White_Space=-	T/a/}');
    Expect(1, 8233, '\p{Is_Pattern_White_Space=t}', "");
    Expect(0, 8233, '\p{^Is_Pattern_White_Space=t}', "");
    Expect(0, 8233, '\P{Is_Pattern_White_Space=t}', "");
    Expect(1, 8233, '\P{^Is_Pattern_White_Space=t}', "");
    Expect(0, 8234, '\p{Is_Pattern_White_Space=t}', "");
    Expect(1, 8234, '\p{^Is_Pattern_White_Space=t}', "");
    Expect(1, 8234, '\P{Is_Pattern_White_Space=t}', "");
    Expect(0, 8234, '\P{^Is_Pattern_White_Space=t}', "");
    Expect(1, 8233, '\p{Is_Pattern_White_Space=	_t}', "");
    Expect(0, 8233, '\p{^Is_Pattern_White_Space=	_t}', "");
    Expect(0, 8233, '\P{Is_Pattern_White_Space=	_t}', "");
    Expect(1, 8233, '\P{^Is_Pattern_White_Space=	_t}', "");
    Expect(0, 8234, '\p{Is_Pattern_White_Space=	_t}', "");
    Expect(1, 8234, '\p{^Is_Pattern_White_Space=	_t}', "");
    Expect(1, 8234, '\P{Is_Pattern_White_Space=	_t}', "");
    Expect(0, 8234, '\P{^Is_Pattern_White_Space=	_t}', "");
    Error('\p{Is_Pat_WS=/a/-true}');
    Error('\P{Is_Pat_WS=/a/-true}');
    Expect(1, 8233, '\p{Is_Pat_WS=true}', "");
    Expect(0, 8233, '\p{^Is_Pat_WS=true}', "");
    Expect(0, 8233, '\P{Is_Pat_WS=true}', "");
    Expect(1, 8233, '\P{^Is_Pat_WS=true}', "");
    Expect(0, 8234, '\p{Is_Pat_WS=true}', "");
    Expect(1, 8234, '\p{^Is_Pat_WS=true}', "");
    Expect(1, 8234, '\P{Is_Pat_WS=true}', "");
    Expect(0, 8234, '\P{^Is_Pat_WS=true}', "");
    Expect(1, 8233, '\p{Is_Pat_WS:_-true}', "");
    Expect(0, 8233, '\p{^Is_Pat_WS:_-true}', "");
    Expect(0, 8233, '\P{Is_Pat_WS:_-true}', "");
    Expect(1, 8233, '\P{^Is_Pat_WS:_-true}', "");
    Expect(0, 8234, '\p{Is_Pat_WS:_-true}', "");
    Expect(1, 8234, '\p{^Is_Pat_WS:_-true}', "");
    Expect(1, 8234, '\P{Is_Pat_WS:_-true}', "");
    Expect(0, 8234, '\P{^Is_Pat_WS:_-true}', "");
    Error('\p{Prepended_Concatenation_Mark= /a/No}');
    Error('\P{Prepended_Concatenation_Mark= /a/No}');
    Expect(1, 69838, '\p{Prepended_Concatenation_Mark=:\ANo\z:}', "");;
    Expect(0, 69837, '\p{Prepended_Concatenation_Mark=:\ANo\z:}', "");;
    Expect(1, 69838, '\p{Prepended_Concatenation_Mark=no}', "");
    Expect(0, 69838, '\p{^Prepended_Concatenation_Mark=no}', "");
    Expect(0, 69838, '\P{Prepended_Concatenation_Mark=no}', "");
    Expect(1, 69838, '\P{^Prepended_Concatenation_Mark=no}', "");
    Expect(0, 69837, '\p{Prepended_Concatenation_Mark=no}', "");
    Expect(1, 69837, '\p{^Prepended_Concatenation_Mark=no}', "");
    Expect(1, 69837, '\P{Prepended_Concatenation_Mark=no}', "");
    Expect(0, 69837, '\P{^Prepended_Concatenation_Mark=no}', "");
    Expect(1, 69838, '\p{Prepended_Concatenation_Mark=:\Ano\z:}', "");;
    Expect(0, 69837, '\p{Prepended_Concatenation_Mark=:\Ano\z:}', "");;
    Expect(1, 69838, '\p{Prepended_Concatenation_Mark=No}', "");
    Expect(0, 69838, '\p{^Prepended_Concatenation_Mark=No}', "");
    Expect(0, 69838, '\P{Prepended_Concatenation_Mark=No}', "");
    Expect(1, 69838, '\P{^Prepended_Concatenation_Mark=No}', "");
    Expect(0, 69837, '\p{Prepended_Concatenation_Mark=No}', "");
    Expect(1, 69837, '\p{^Prepended_Concatenation_Mark=No}', "");
    Expect(1, 69837, '\P{Prepended_Concatenation_Mark=No}', "");
    Expect(0, 69837, '\P{^Prepended_Concatenation_Mark=No}', "");
    Error('\p{PCM=/a/ _n}');
    Error('\P{PCM=/a/ _n}');
    Expect(1, 69838, '\p{PCM=:\AN\z:}', "");;
    Expect(0, 69837, '\p{PCM=:\AN\z:}', "");;
    Expect(1, 69838, '\p{PCM=n}', "");
    Expect(0, 69838, '\p{^PCM=n}', "");
    Expect(0, 69838, '\P{PCM=n}', "");
    Expect(1, 69838, '\P{^PCM=n}', "");
    Expect(0, 69837, '\p{PCM=n}', "");
    Expect(1, 69837, '\p{^PCM=n}', "");
    Expect(1, 69837, '\P{PCM=n}', "");
    Expect(0, 69837, '\P{^PCM=n}', "");
    Expect(1, 69838, '\p{PCM=:\An\z:}', "");;
    Expect(0, 69837, '\p{PCM=:\An\z:}', "");;
    Expect(1, 69838, '\p{PCM=--N}', "");
    Expect(0, 69838, '\p{^PCM=--N}', "");
    Expect(0, 69838, '\P{PCM=--N}', "");
    Expect(1, 69838, '\P{^PCM=--N}', "");
    Expect(0, 69837, '\p{PCM=--N}', "");
    Expect(1, 69837, '\p{^PCM=--N}', "");
    Expect(1, 69837, '\P{PCM=--N}', "");
    Expect(0, 69837, '\P{^PCM=--N}', "");
    Error('\p{Is_Prepended_Concatenation_Mark=	 f:=}');
    Error('\P{Is_Prepended_Concatenation_Mark=	 f:=}');
    Expect(1, 69838, '\p{Is_Prepended_Concatenation_Mark=f}', "");
    Expect(0, 69838, '\p{^Is_Prepended_Concatenation_Mark=f}', "");
    Expect(0, 69838, '\P{Is_Prepended_Concatenation_Mark=f}', "");
    Expect(1, 69838, '\P{^Is_Prepended_Concatenation_Mark=f}', "");
    Expect(0, 69837, '\p{Is_Prepended_Concatenation_Mark=f}', "");
    Expect(1, 69837, '\p{^Is_Prepended_Concatenation_Mark=f}', "");
    Expect(1, 69837, '\P{Is_Prepended_Concatenation_Mark=f}', "");
    Expect(0, 69837, '\P{^Is_Prepended_Concatenation_Mark=f}', "");
    Expect(1, 69838, '\p{Is_Prepended_Concatenation_Mark=F}', "");
    Expect(0, 69838, '\p{^Is_Prepended_Concatenation_Mark=F}', "");
    Expect(0, 69838, '\P{Is_Prepended_Concatenation_Mark=F}', "");
    Expect(1, 69838, '\P{^Is_Prepended_Concatenation_Mark=F}', "");
    Expect(0, 69837, '\p{Is_Prepended_Concatenation_Mark=F}', "");
    Expect(1, 69837, '\p{^Is_Prepended_Concatenation_Mark=F}', "");
    Expect(1, 69837, '\P{Is_Prepended_Concatenation_Mark=F}', "");
    Expect(0, 69837, '\P{^Is_Prepended_Concatenation_Mark=F}', "");
    Error('\p{Is_PCM: 	false:=}');
    Error('\P{Is_PCM: 	false:=}');
    Expect(1, 69838, '\p{Is_PCM=false}', "");
    Expect(0, 69838, '\p{^Is_PCM=false}', "");
    Expect(0, 69838, '\P{Is_PCM=false}', "");
    Expect(1, 69838, '\P{^Is_PCM=false}', "");
    Expect(0, 69837, '\p{Is_PCM=false}', "");
    Expect(1, 69837, '\p{^Is_PCM=false}', "");
    Expect(1, 69837, '\P{Is_PCM=false}', "");
    Expect(0, 69837, '\P{^Is_PCM=false}', "");
    Expect(1, 69838, '\p{Is_PCM= 	False}', "");
    Expect(0, 69838, '\p{^Is_PCM= 	False}', "");
    Expect(0, 69838, '\P{Is_PCM= 	False}', "");
    Expect(1, 69838, '\P{^Is_PCM= 	False}', "");
    Expect(0, 69837, '\p{Is_PCM= 	False}', "");
    Expect(1, 69837, '\p{^Is_PCM= 	False}', "");
    Expect(1, 69837, '\P{Is_PCM= 	False}', "");
    Expect(0, 69837, '\P{^Is_PCM= 	False}', "");
    Error('\p{Prepended_Concatenation_Mark=:=Yes}');
    Error('\P{Prepended_Concatenation_Mark=:=Yes}');
    Expect(1, 69837, '\p{Prepended_Concatenation_Mark=:\AYes\z:}', "");;
    Expect(0, 69838, '\p{Prepended_Concatenation_Mark=:\AYes\z:}', "");;
    Expect(1, 69837, '\p{Prepended_Concatenation_Mark=yes}', "");
    Expect(0, 69837, '\p{^Prepended_Concatenation_Mark=yes}', "");
    Expect(0, 69837, '\P{Prepended_Concatenation_Mark=yes}', "");
    Expect(1, 69837, '\P{^Prepended_Concatenation_Mark=yes}', "");
    Expect(0, 69838, '\p{Prepended_Concatenation_Mark=yes}', "");
    Expect(1, 69838, '\p{^Prepended_Concatenation_Mark=yes}', "");
    Expect(1, 69838, '\P{Prepended_Concatenation_Mark=yes}', "");
    Expect(0, 69838, '\P{^Prepended_Concatenation_Mark=yes}', "");
    Expect(1, 69837, '\p{Prepended_Concatenation_Mark=:\Ayes\z:}', "");;
    Expect(0, 69838, '\p{Prepended_Concatenation_Mark=:\Ayes\z:}', "");;
    Expect(1, 69837, '\p{Prepended_Concatenation_Mark= -Yes}', "");
    Expect(0, 69837, '\p{^Prepended_Concatenation_Mark= -Yes}', "");
    Expect(0, 69837, '\P{Prepended_Concatenation_Mark= -Yes}', "");
    Expect(1, 69837, '\P{^Prepended_Concatenation_Mark= -Yes}', "");
    Expect(0, 69838, '\p{Prepended_Concatenation_Mark= -Yes}', "");
    Expect(1, 69838, '\p{^Prepended_Concatenation_Mark= -Yes}', "");
    Expect(1, 69838, '\P{Prepended_Concatenation_Mark= -Yes}', "");
    Expect(0, 69838, '\P{^Prepended_Concatenation_Mark= -Yes}', "");
    Error('\p{PCM=:=		Y}');
    Error('\P{PCM=:=		Y}');
    Expect(1, 69837, '\p{PCM=:\AY\z:}', "");;
    Expect(0, 69838, '\p{PCM=:\AY\z:}', "");;
    Expect(1, 69837, '\p{PCM=y}', "");
    Expect(0, 69837, '\p{^PCM=y}', "");
    Expect(0, 69837, '\P{PCM=y}', "");
    Expect(1, 69837, '\P{^PCM=y}', "");
    Expect(0, 69838, '\p{PCM=y}', "");
    Expect(1, 69838, '\p{^PCM=y}', "");
    Expect(1, 69838, '\P{PCM=y}', "");
    Expect(0, 69838, '\P{^PCM=y}', "");
    Expect(1, 69837, '\p{PCM=:\Ay\z:}', "");;
    Expect(0, 69838, '\p{PCM=:\Ay\z:}', "");;
    Expect(1, 69837, '\p{PCM:	 _Y}', "");
    Expect(0, 69837, '\p{^PCM:	 _Y}', "");
    Expect(0, 69837, '\P{PCM:	 _Y}', "");
    Expect(1, 69837, '\P{^PCM:	 _Y}', "");
    Expect(0, 69838, '\p{PCM:	 _Y}', "");
    Expect(1, 69838, '\p{^PCM:	 _Y}', "");
    Expect(1, 69838, '\P{PCM:	 _Y}', "");
    Expect(0, 69838, '\P{^PCM:	 _Y}', "");
    Error('\p{Is_Prepended_Concatenation_Mark=/a/t}');
    Error('\P{Is_Prepended_Concatenation_Mark=/a/t}');
    Expect(1, 69837, '\p{Is_Prepended_Concatenation_Mark=t}', "");
    Expect(0, 69837, '\p{^Is_Prepended_Concatenation_Mark=t}', "");
    Expect(0, 69837, '\P{Is_Prepended_Concatenation_Mark=t}', "");
    Expect(1, 69837, '\P{^Is_Prepended_Concatenation_Mark=t}', "");
    Expect(0, 69838, '\p{Is_Prepended_Concatenation_Mark=t}', "");
    Expect(1, 69838, '\p{^Is_Prepended_Concatenation_Mark=t}', "");
    Expect(1, 69838, '\P{Is_Prepended_Concatenation_Mark=t}', "");
    Expect(0, 69838, '\P{^Is_Prepended_Concatenation_Mark=t}', "");
    Expect(1, 69837, '\p{Is_Prepended_Concatenation_Mark=-T}', "");
    Expect(0, 69837, '\p{^Is_Prepended_Concatenation_Mark=-T}', "");
    Expect(0, 69837, '\P{Is_Prepended_Concatenation_Mark=-T}', "");
    Expect(1, 69837, '\P{^Is_Prepended_Concatenation_Mark=-T}', "");
    Expect(0, 69838, '\p{Is_Prepended_Concatenation_Mark=-T}', "");
    Expect(1, 69838, '\p{^Is_Prepended_Concatenation_Mark=-T}', "");
    Expect(1, 69838, '\P{Is_Prepended_Concatenation_Mark=-T}', "");
    Expect(0, 69838, '\P{^Is_Prepended_Concatenation_Mark=-T}', "");
    Error('\p{Is_PCM=-_True:=}');
    Error('\P{Is_PCM=-_True:=}');
    Expect(1, 69837, '\p{Is_PCM=true}', "");
    Expect(0, 69837, '\p{^Is_PCM=true}', "");
    Expect(0, 69837, '\P{Is_PCM=true}', "");
    Expect(1, 69837, '\P{^Is_PCM=true}', "");
    Expect(0, 69838, '\p{Is_PCM=true}', "");
    Expect(1, 69838, '\p{^Is_PCM=true}', "");
    Expect(1, 69838, '\P{Is_PCM=true}', "");
    Expect(0, 69838, '\P{^Is_PCM=true}', "");
    Expect(1, 69837, '\p{Is_PCM=- True}', "");
    Expect(0, 69837, '\p{^Is_PCM=- True}', "");
    Expect(0, 69837, '\P{Is_PCM=- True}', "");
    Expect(1, 69837, '\P{^Is_PCM=- True}', "");
    Expect(0, 69838, '\p{Is_PCM=- True}', "");
    Expect(1, 69838, '\p{^Is_PCM=- True}', "");
    Expect(1, 69838, '\P{Is_PCM=- True}', "");
    Expect(0, 69838, '\P{^Is_PCM=- True}', "");
    Error('\p{perl}');
    Error('\P{perl}');
    Error('\p{_ Adlam/a/}');
    Error('\P{_ Adlam/a/}');
    Expect(1, 125279, '\p{adlam}', "");
    Expect(0, 125279, '\p{^adlam}', "");
    Expect(0, 125279, '\P{adlam}', "");
    Expect(1, 125279, '\P{^adlam}', "");
    Expect(0, 125280, '\p{adlam}', "");
    Expect(1, 125280, '\p{^adlam}', "");
    Expect(1, 125280, '\P{adlam}', "");
    Expect(0, 125280, '\P{^adlam}', "");
    Expect(1, 125279, '\p{ 	adlam}', "");
    Expect(0, 125279, '\p{^ 	adlam}', "");
    Expect(0, 125279, '\P{ 	adlam}', "");
    Expect(1, 125279, '\P{^ 	adlam}', "");
    Expect(0, 125280, '\p{ 	adlam}', "");
    Expect(1, 125280, '\p{^ 	adlam}', "");
    Expect(1, 125280, '\P{ 	adlam}', "");
    Expect(0, 125280, '\P{^ 	adlam}', "");
    Error('\p{-/a/IS_Adlam}');
    Error('\P{-/a/IS_Adlam}');
    Expect(1, 125279, '\p{isadlam}', "");
    Expect(0, 125279, '\p{^isadlam}', "");
    Expect(0, 125279, '\P{isadlam}', "");
    Expect(1, 125279, '\P{^isadlam}', "");
    Expect(0, 125280, '\p{isadlam}', "");
    Expect(1, 125280, '\p{^isadlam}', "");
    Expect(1, 125280, '\P{isadlam}', "");
    Expect(0, 125280, '\P{^isadlam}', "");
    Expect(1, 125279, '\p{	Is_ADLAM}', "");
    Expect(0, 125279, '\p{^	Is_ADLAM}', "");
    Expect(0, 125279, '\P{	Is_ADLAM}', "");
    Expect(1, 125279, '\P{^	Is_ADLAM}', "");
    Expect(0, 125280, '\p{	Is_ADLAM}', "");
    Expect(1, 125280, '\p{^	Is_ADLAM}', "");
    Expect(1, 125280, '\P{	Is_ADLAM}', "");
    Expect(0, 125280, '\P{^	Is_ADLAM}', "");
    Error('\p{_/a/Adlm}');
    Error('\P{_/a/Adlm}');
    Expect(1, 125279, '\p{adlm}', "");
    Expect(0, 125279, '\p{^adlm}', "");
    Expect(0, 125279, '\P{adlm}', "");
    Expect(1, 125279, '\P{^adlm}', "");
    Expect(0, 125280, '\p{adlm}', "");
    Expect(1, 125280, '\p{^adlm}', "");
    Expect(1, 125280, '\P{adlm}', "");
    Expect(0, 125280, '\P{^adlm}', "");
    Expect(1, 125279, '\p{ _ADLM}', "");
    Expect(0, 125279, '\p{^ _ADLM}', "");
    Expect(0, 125279, '\P{ _ADLM}', "");
    Expect(1, 125279, '\P{^ _ADLM}', "");
    Expect(0, 125280, '\p{ _ADLM}', "");
    Expect(1, 125280, '\p{^ _ADLM}', "");
    Expect(1, 125280, '\P{ _ADLM}', "");
    Expect(0, 125280, '\P{^ _ADLM}', "");
    Error('\p{_/a/Is_Adlm}');
    Error('\P{_/a/Is_Adlm}');
    Expect(1, 125279, '\p{isadlm}', "");
    Expect(0, 125279, '\p{^isadlm}', "");
    Expect(0, 125279, '\P{isadlm}', "");
    Expect(1, 125279, '\P{^isadlm}', "");
    Expect(0, 125280, '\p{isadlm}', "");
    Expect(1, 125280, '\p{^isadlm}', "");
    Expect(1, 125280, '\P{isadlm}', "");
    Expect(0, 125280, '\P{^isadlm}', "");
    Expect(1, 125279, '\p{-_IS_ADLM}', "");
    Expect(0, 125279, '\p{^-_IS_ADLM}', "");
    Expect(0, 125279, '\P{-_IS_ADLM}', "");
    Expect(1, 125279, '\P{^-_IS_ADLM}', "");
    Expect(0, 125280, '\p{-_IS_ADLM}', "");
    Expect(1, 125280, '\p{^-_IS_ADLM}', "");
    Expect(1, 125280, '\P{-_IS_ADLM}', "");
    Expect(0, 125280, '\P{^-_IS_ADLM}', "");
    Error('\p{:=--aegean_Numbers}');
    Error('\P{:=--aegean_Numbers}');
    Expect(1, 65855, '\p{aegeannumbers}', "");
    Expect(0, 65855, '\p{^aegeannumbers}', "");
    Expect(0, 65855, '\P{aegeannumbers}', "");
    Expect(1, 65855, '\P{^aegeannumbers}', "");
    Expect(0, 65856, '\p{aegeannumbers}', "");
    Expect(1, 65856, '\p{^aegeannumbers}', "");
    Expect(1, 65856, '\P{aegeannumbers}', "");
    Expect(0, 65856, '\P{^aegeannumbers}', "");
    Expect(1, 65855, '\p{--Aegean_NUMBERS}', "");
    Expect(0, 65855, '\p{^--Aegean_NUMBERS}', "");
    Expect(0, 65855, '\P{--Aegean_NUMBERS}', "");
    Expect(1, 65855, '\P{^--Aegean_NUMBERS}', "");
    Expect(0, 65856, '\p{--Aegean_NUMBERS}', "");
    Expect(1, 65856, '\p{^--Aegean_NUMBERS}', "");
    Expect(1, 65856, '\P{--Aegean_NUMBERS}', "");
    Expect(0, 65856, '\P{^--Aegean_NUMBERS}', "");
    Error('\p{:=-_IS_AEGEAN_Numbers}');
    Error('\P{:=-_IS_AEGEAN_Numbers}');
    Expect(1, 65855, '\p{isaegeannumbers}', "");
    Expect(0, 65855, '\p{^isaegeannumbers}', "");
    Expect(0, 65855, '\P{isaegeannumbers}', "");
    Expect(1, 65855, '\P{^isaegeannumbers}', "");
    Expect(0, 65856, '\p{isaegeannumbers}', "");
    Expect(1, 65856, '\p{^isaegeannumbers}', "");
    Expect(1, 65856, '\P{isaegeannumbers}', "");
    Expect(0, 65856, '\P{^isaegeannumbers}', "");
    Expect(1, 65855, '\p{ _Is_aegean_Numbers}', "");
    Expect(0, 65855, '\p{^ _Is_aegean_Numbers}', "");
    Expect(0, 65855, '\P{ _Is_aegean_Numbers}', "");
    Expect(1, 65855, '\P{^ _Is_aegean_Numbers}', "");
    Expect(0, 65856, '\p{ _Is_aegean_Numbers}', "");
    Expect(1, 65856, '\p{^ _Is_aegean_Numbers}', "");
    Expect(1, 65856, '\P{ _Is_aegean_Numbers}', "");
    Expect(0, 65856, '\P{^ _Is_aegean_Numbers}', "");
    Error('\p{	_In_AEGEAN_numbers:=}');
    Error('\P{	_In_AEGEAN_numbers:=}');
    Expect(1, 65855, '\p{inaegeannumbers}', "");
    Expect(0, 65855, '\p{^inaegeannumbers}', "");
    Expect(0, 65855, '\P{inaegeannumbers}', "");
    Expect(1, 65855, '\P{^inaegeannumbers}', "");
    Expect(0, 65856, '\p{inaegeannumbers}', "");
    Expect(1, 65856, '\p{^inaegeannumbers}', "");
    Expect(1, 65856, '\P{inaegeannumbers}', "");
    Expect(0, 65856, '\P{^inaegeannumbers}', "");
    Expect(1, 65855, '\p{-	In_Aegean_Numbers}', "");
    Expect(0, 65855, '\p{^-	In_Aegean_Numbers}', "");
    Expect(0, 65855, '\P{-	In_Aegean_Numbers}', "");
    Expect(1, 65855, '\P{^-	In_Aegean_Numbers}', "");
    Expect(0, 65856, '\p{-	In_Aegean_Numbers}', "");
    Expect(1, 65856, '\p{^-	In_Aegean_Numbers}', "");
    Expect(1, 65856, '\P{-	In_Aegean_Numbers}', "");
    Expect(0, 65856, '\P{^-	In_Aegean_Numbers}', "");
    Error('\p{/a/	 Ahom}');
    Error('\P{/a/	 Ahom}');
    Expect(1, 71487, '\p{ahom}', "");
    Expect(0, 71487, '\p{^ahom}', "");
    Expect(0, 71487, '\P{ahom}', "");
    Expect(1, 71487, '\P{^ahom}', "");
    Expect(0, 71488, '\p{ahom}', "");
    Expect(1, 71488, '\p{^ahom}', "");
    Expect(1, 71488, '\P{ahom}', "");
    Expect(0, 71488, '\P{^ahom}', "");
    Expect(1, 71487, '\p{- Ahom}', "");
    Expect(0, 71487, '\p{^- Ahom}', "");
    Expect(0, 71487, '\P{- Ahom}', "");
    Expect(1, 71487, '\P{^- Ahom}', "");
    Expect(0, 71488, '\p{- Ahom}', "");
    Expect(1, 71488, '\p{^- Ahom}', "");
    Expect(1, 71488, '\P{- Ahom}', "");
    Expect(0, 71488, '\P{^- Ahom}', "");
    Error('\p{ :=is_AHOM}');
    Error('\P{ :=is_AHOM}');
    Expect(1, 71487, '\p{isahom}', "");
    Expect(0, 71487, '\p{^isahom}', "");
    Expect(0, 71487, '\P{isahom}', "");
    Expect(1, 71487, '\P{^isahom}', "");
    Expect(0, 71488, '\p{isahom}', "");
    Expect(1, 71488, '\p{^isahom}', "");
    Expect(1, 71488, '\P{isahom}', "");
    Expect(0, 71488, '\P{^isahom}', "");
    Expect(1, 71487, '\p{ _IS_Ahom}', "");
    Expect(0, 71487, '\p{^ _IS_Ahom}', "");
    Expect(0, 71487, '\P{ _IS_Ahom}', "");
    Expect(1, 71487, '\P{^ _IS_Ahom}', "");
    Expect(0, 71488, '\p{ _IS_Ahom}', "");
    Expect(1, 71488, '\p{^ _IS_Ahom}', "");
    Expect(1, 71488, '\P{ _IS_Ahom}', "");
    Expect(0, 71488, '\P{^ _IS_Ahom}', "");
    Error('\p{-:=Alchemical_SYMBOLS}');
    Error('\P{-:=Alchemical_SYMBOLS}');
    Expect(1, 128895, '\p{alchemicalsymbols}', "");
    Expect(0, 128895, '\p{^alchemicalsymbols}', "");
    Expect(0, 128895, '\P{alchemicalsymbols}', "");
    Expect(1, 128895, '\P{^alchemicalsymbols}', "");
    Expect(0, 128896, '\p{alchemicalsymbols}', "");
    Expect(1, 128896, '\p{^alchemicalsymbols}', "");
    Expect(1, 128896, '\P{alchemicalsymbols}', "");
    Expect(0, 128896, '\P{^alchemicalsymbols}', "");
    Expect(1, 128895, '\p{-	alchemical_symbols}', "");
    Expect(0, 128895, '\p{^-	alchemical_symbols}', "");
    Expect(0, 128895, '\P{-	alchemical_symbols}', "");
    Expect(1, 128895, '\P{^-	alchemical_symbols}', "");
    Expect(0, 128896, '\p{-	alchemical_symbols}', "");
    Expect(1, 128896, '\p{^-	alchemical_symbols}', "");
    Expect(1, 128896, '\P{-	alchemical_symbols}', "");
    Expect(0, 128896, '\P{^-	alchemical_symbols}', "");
    Error('\p{/a/Is_alchemical_Symbols}');
    Error('\P{/a/Is_alchemical_Symbols}');
    Expect(1, 128895, '\p{isalchemicalsymbols}', "");
    Expect(0, 128895, '\p{^isalchemicalsymbols}', "");
    Expect(0, 128895, '\P{isalchemicalsymbols}', "");
    Expect(1, 128895, '\P{^isalchemicalsymbols}', "");
    Expect(0, 128896, '\p{isalchemicalsymbols}', "");
    Expect(1, 128896, '\p{^isalchemicalsymbols}', "");
    Expect(1, 128896, '\P{isalchemicalsymbols}', "");
    Expect(0, 128896, '\P{^isalchemicalsymbols}', "");
    Expect(1, 128895, '\p{ Is_alchemical_SYMBOLS}', "");
    Expect(0, 128895, '\p{^ Is_alchemical_SYMBOLS}', "");
    Expect(0, 128895, '\P{ Is_alchemical_SYMBOLS}', "");
    Expect(1, 128895, '\P{^ Is_alchemical_SYMBOLS}', "");
    Expect(0, 128896, '\p{ Is_alchemical_SYMBOLS}', "");
    Expect(1, 128896, '\p{^ Is_alchemical_SYMBOLS}', "");
    Expect(1, 128896, '\P{ Is_alchemical_SYMBOLS}', "");
    Expect(0, 128896, '\P{^ Is_alchemical_SYMBOLS}', "");
    Error('\p{:=in_alchemical_Symbols}');
    Error('\P{:=in_alchemical_Symbols}');
    Expect(1, 128895, '\p{inalchemicalsymbols}', "");
    Expect(0, 128895, '\p{^inalchemicalsymbols}', "");
    Expect(0, 128895, '\P{inalchemicalsymbols}', "");
    Expect(1, 128895, '\P{^inalchemicalsymbols}', "");
    Expect(0, 128896, '\p{inalchemicalsymbols}', "");
    Expect(1, 128896, '\p{^inalchemicalsymbols}', "");
    Expect(1, 128896, '\P{inalchemicalsymbols}', "");
    Expect(0, 128896, '\P{^inalchemicalsymbols}', "");
    Expect(1, 128895, '\p{_in_alchemical_Symbols}', "");
    Expect(0, 128895, '\p{^_in_alchemical_Symbols}', "");
    Expect(0, 128895, '\P{_in_alchemical_Symbols}', "");
    Expect(1, 128895, '\P{^_in_alchemical_Symbols}', "");
    Expect(0, 128896, '\p{_in_alchemical_Symbols}', "");
    Expect(1, 128896, '\p{^_in_alchemical_Symbols}', "");
    Expect(1, 128896, '\P{_in_alchemical_Symbols}', "");
    Expect(0, 128896, '\P{^_in_alchemical_Symbols}', "");
    Error('\p{_	alchemical/a/}');
    Error('\P{_	alchemical/a/}');
    Expect(1, 128895, '\p{alchemical}', "");
    Expect(0, 128895, '\p{^alchemical}', "");
    Expect(0, 128895, '\P{alchemical}', "");
    Expect(1, 128895, '\P{^alchemical}', "");
    Expect(0, 128896, '\p{alchemical}', "");
    Expect(1, 128896, '\p{^alchemical}', "");
    Expect(1, 128896, '\P{alchemical}', "");
    Expect(0, 128896, '\P{^alchemical}', "");
    Expect(1, 128895, '\p{	_Alchemical}', "");
    Expect(0, 128895, '\p{^	_Alchemical}', "");
    Expect(0, 128895, '\P{	_Alchemical}', "");
    Expect(1, 128895, '\P{^	_Alchemical}', "");
    Expect(0, 128896, '\p{	_Alchemical}', "");
    Expect(1, 128896, '\p{^	_Alchemical}', "");
    Expect(1, 128896, '\P{	_Alchemical}', "");
    Expect(0, 128896, '\P{^	_Alchemical}', "");
    Error('\p{ is_alchemical:=}');
    Error('\P{ is_alchemical:=}');
    Expect(1, 128895, '\p{isalchemical}', "");
    Expect(0, 128895, '\p{^isalchemical}', "");
    Expect(0, 128895, '\P{isalchemical}', "");
    Expect(1, 128895, '\P{^isalchemical}', "");
    Expect(0, 128896, '\p{isalchemical}', "");
    Expect(1, 128896, '\p{^isalchemical}', "");
    Expect(1, 128896, '\P{isalchemical}', "");
    Expect(0, 128896, '\P{^isalchemical}', "");
    Expect(1, 128895, '\p{ Is_Alchemical}', "");
    Expect(0, 128895, '\p{^ Is_Alchemical}', "");
    Expect(0, 128895, '\P{ Is_Alchemical}', "");
    Expect(1, 128895, '\P{^ Is_Alchemical}', "");
    Expect(0, 128896, '\p{ Is_Alchemical}', "");
    Expect(1, 128896, '\p{^ Is_Alchemical}', "");
    Expect(1, 128896, '\P{ Is_Alchemical}', "");
    Expect(0, 128896, '\P{^ Is_Alchemical}', "");
    Error('\p{		in_ALCHEMICAL/a/}');
    Error('\P{		in_ALCHEMICAL/a/}');
    Expect(1, 128895, '\p{inalchemical}', "");
    Expect(0, 128895, '\p{^inalchemical}', "");
    Expect(0, 128895, '\P{inalchemical}', "");
    Expect(1, 128895, '\P{^inalchemical}', "");
    Expect(0, 128896, '\p{inalchemical}', "");
    Expect(1, 128896, '\p{^inalchemical}', "");
    Expect(1, 128896, '\P{inalchemical}', "");
    Expect(0, 128896, '\P{^inalchemical}', "");
    Expect(1, 128895, '\p{ In_ALCHEMICAL}', "");
    Expect(0, 128895, '\p{^ In_ALCHEMICAL}', "");
    Expect(0, 128895, '\P{ In_ALCHEMICAL}', "");
    Expect(1, 128895, '\P{^ In_ALCHEMICAL}', "");
    Expect(0, 128896, '\p{ In_ALCHEMICAL}', "");
    Expect(1, 128896, '\p{^ In_ALCHEMICAL}', "");
    Expect(1, 128896, '\P{ In_ALCHEMICAL}', "");
    Expect(0, 128896, '\P{^ In_ALCHEMICAL}', "");
    Error('\p{:=_	All}');
    Error('\P{:=_	All}');
    Expect(1, 1, '\p{all}', "");
    Expect(0, 1, '\p{^all}', "");
    Expect(0, 1, '\P{all}', "");
    Expect(1, 1, '\P{^all}', "");
    Expect(1, 1, '\p{__All}', "");
    Expect(0, 1, '\p{^__All}', "");
    Expect(0, 1, '\P{__All}', "");
    Expect(1, 1, '\P{^__All}', "");
    Error('\p{/a/  Is_all}');
    Error('\P{/a/  Is_all}');
    Expect(1, 1, '\p{isall}', "");
    Expect(0, 1, '\p{^isall}', "");
    Expect(0, 1, '\P{isall}', "");
    Expect(1, 1, '\P{^isall}', "");
    Expect(1, 1, '\p{	Is_ALL}', "");
    Expect(0, 1, '\p{^	Is_ALL}', "");
    Expect(0, 1, '\P{	Is_ALL}', "");
    Expect(1, 1, '\P{^	Is_ALL}', "");
    Error('\p{:=- XPOSIXALNUM}');
    Error('\P{:=- XPOSIXALNUM}');
    Expect(1, 195101, '\p{xposixalnum}', "");
    Expect(0, 195101, '\p{^xposixalnum}', "");
    Expect(0, 195101, '\P{xposixalnum}', "");
    Expect(1, 195101, '\P{^xposixalnum}', "");
    Expect(0, 195102, '\p{xposixalnum}', "");
    Expect(1, 195102, '\p{^xposixalnum}', "");
    Expect(1, 195102, '\P{xposixalnum}', "");
    Expect(0, 195102, '\P{^xposixalnum}', "");
    Expect(1, 195101, '\p{ _XPosixAlnum}', "");
    Expect(0, 195101, '\p{^ _XPosixAlnum}', "");
    Expect(0, 195101, '\P{ _XPosixAlnum}', "");
    Expect(1, 195101, '\P{^ _XPosixAlnum}', "");
    Expect(0, 195102, '\p{ _XPosixAlnum}', "");
    Expect(1, 195102, '\p{^ _XPosixAlnum}', "");
    Expect(1, 195102, '\P{ _XPosixAlnum}', "");
    Expect(0, 195102, '\P{^ _XPosixAlnum}', "");
    Error('\p{:=-Alnum}');
    Error('\P{:=-Alnum}');
    Expect(1, 195101, '\p{alnum}', "");
    Expect(0, 195101, '\p{^alnum}', "");
    Expect(0, 195101, '\P{alnum}', "");
    Expect(1, 195101, '\P{^alnum}', "");
    Expect(0, 195102, '\p{alnum}', "");
    Expect(1, 195102, '\p{^alnum}', "");
    Expect(1, 195102, '\P{alnum}', "");
    Expect(0, 195102, '\P{^alnum}', "");
    Expect(1, 195101, '\p{--ALNUM}', "");
    Expect(0, 195101, '\p{^--ALNUM}', "");
    Expect(0, 195101, '\P{--ALNUM}', "");
    Expect(1, 195101, '\P{^--ALNUM}', "");
    Expect(0, 195102, '\p{--ALNUM}', "");
    Expect(1, 195102, '\p{^--ALNUM}', "");
    Expect(1, 195102, '\P{--ALNUM}', "");
    Expect(0, 195102, '\P{^--ALNUM}', "");
    Error('\p{	:=Is_XPosixAlnum}');
    Error('\P{	:=Is_XPosixAlnum}');
    Expect(1, 195101, '\p{isxposixalnum}', "");
    Expect(0, 195101, '\p{^isxposixalnum}', "");
    Expect(0, 195101, '\P{isxposixalnum}', "");
    Expect(1, 195101, '\P{^isxposixalnum}', "");
    Expect(0, 195102, '\p{isxposixalnum}', "");
    Expect(1, 195102, '\p{^isxposixalnum}', "");
    Expect(1, 195102, '\P{isxposixalnum}', "");
    Expect(0, 195102, '\P{^isxposixalnum}', "");
    Expect(1, 195101, '\p{-	is_xposixalnum}', "");
    Expect(0, 195101, '\p{^-	is_xposixalnum}', "");
    Expect(0, 195101, '\P{-	is_xposixalnum}', "");
    Expect(1, 195101, '\P{^-	is_xposixalnum}', "");
    Expect(0, 195102, '\p{-	is_xposixalnum}', "");
    Expect(1, 195102, '\p{^-	is_xposixalnum}', "");
    Expect(1, 195102, '\P{-	is_xposixalnum}', "");
    Expect(0, 195102, '\P{^-	is_xposixalnum}', "");
    Error('\p{- IS_ALNUM/a/}');
    Error('\P{- IS_ALNUM/a/}');
    Expect(1, 195101, '\p{isalnum}', "");
    Expect(0, 195101, '\p{^isalnum}', "");
    Expect(0, 195101, '\P{isalnum}', "");
    Expect(1, 195101, '\P{^isalnum}', "");
    Expect(0, 195102, '\p{isalnum}', "");
    Expect(1, 195102, '\p{^isalnum}', "");
    Expect(1, 195102, '\P{isalnum}', "");
    Expect(0, 195102, '\P{^isalnum}', "");
    Expect(1, 195101, '\p{  is_Alnum}', "");
    Expect(0, 195101, '\p{^  is_Alnum}', "");
    Expect(0, 195101, '\P{  is_Alnum}', "");
    Expect(1, 195101, '\P{^  is_Alnum}', "");
    Expect(0, 195102, '\p{  is_Alnum}', "");
    Expect(1, 195102, '\p{^  is_Alnum}', "");
    Expect(1, 195102, '\P{  is_Alnum}', "");
    Expect(0, 195102, '\P{^  is_Alnum}', "");
    Error('\p{-/a/Alphabetic_Presentation_FORMS}');
    Error('\P{-/a/Alphabetic_Presentation_FORMS}');
    Expect(1, 64335, '\p{alphabeticpresentationforms}', "");
    Expect(0, 64335, '\p{^alphabeticpresentationforms}', "");
    Expect(0, 64335, '\P{alphabeticpresentationforms}', "");
    Expect(1, 64335, '\P{^alphabeticpresentationforms}', "");
    Expect(0, 64336, '\p{alphabeticpresentationforms}', "");
    Expect(1, 64336, '\p{^alphabeticpresentationforms}', "");
    Expect(1, 64336, '\P{alphabeticpresentationforms}', "");
    Expect(0, 64336, '\P{^alphabeticpresentationforms}', "");
    Expect(1, 64335, '\p{_Alphabetic_PRESENTATION_Forms}', "");
    Expect(0, 64335, '\p{^_Alphabetic_PRESENTATION_Forms}', "");
    Expect(0, 64335, '\P{_Alphabetic_PRESENTATION_Forms}', "");
    Expect(1, 64335, '\P{^_Alphabetic_PRESENTATION_Forms}', "");
    Expect(0, 64336, '\p{_Alphabetic_PRESENTATION_Forms}', "");
    Expect(1, 64336, '\p{^_Alphabetic_PRESENTATION_Forms}', "");
    Expect(1, 64336, '\P{_Alphabetic_PRESENTATION_Forms}', "");
    Expect(0, 64336, '\P{^_Alphabetic_PRESENTATION_Forms}', "");
    Error('\p{:=- is_ALPHABETIC_PRESENTATION_forms}');
    Error('\P{:=- is_ALPHABETIC_PRESENTATION_forms}');
    Expect(1, 64335, '\p{isalphabeticpresentationforms}', "");
    Expect(0, 64335, '\p{^isalphabeticpresentationforms}', "");
    Expect(0, 64335, '\P{isalphabeticpresentationforms}', "");
    Expect(1, 64335, '\P{^isalphabeticpresentationforms}', "");
    Expect(0, 64336, '\p{isalphabeticpresentationforms}', "");
    Expect(1, 64336, '\p{^isalphabeticpresentationforms}', "");
    Expect(1, 64336, '\P{isalphabeticpresentationforms}', "");
    Expect(0, 64336, '\P{^isalphabeticpresentationforms}', "");
    Expect(1, 64335, '\p{_Is_Alphabetic_Presentation_Forms}', "");
    Expect(0, 64335, '\p{^_Is_Alphabetic_Presentation_Forms}', "");
    Expect(0, 64335, '\P{_Is_Alphabetic_Presentation_Forms}', "");
    Expect(1, 64335, '\P{^_Is_Alphabetic_Presentation_Forms}', "");
    Expect(0, 64336, '\p{_Is_Alphabetic_Presentation_Forms}', "");
    Expect(1, 64336, '\p{^_Is_Alphabetic_Presentation_Forms}', "");
    Expect(1, 64336, '\P{_Is_Alphabetic_Presentation_Forms}', "");
    Expect(0, 64336, '\P{^_Is_Alphabetic_Presentation_Forms}', "");
    Error('\p{-IN_alphabetic_Presentation_FORMS:=}');
    Error('\P{-IN_alphabetic_Presentation_FORMS:=}');
    Expect(1, 64335, '\p{inalphabeticpresentationforms}', "");
    Expect(0, 64335, '\p{^inalphabeticpresentationforms}', "");
    Expect(0, 64335, '\P{inalphabeticpresentationforms}', "");
    Expect(1, 64335, '\P{^inalphabeticpresentationforms}', "");
    Expect(0, 64336, '\p{inalphabeticpresentationforms}', "");
    Expect(1, 64336, '\p{^inalphabeticpresentationforms}', "");
    Expect(1, 64336, '\P{inalphabeticpresentationforms}', "");
    Expect(0, 64336, '\P{^inalphabeticpresentationforms}', "");
    Expect(1, 64335, '\p{-In_ALPHABETIC_Presentation_FORMS}', "");
    Expect(0, 64335, '\p{^-In_ALPHABETIC_Presentation_FORMS}', "");
    Expect(0, 64335, '\P{-In_ALPHABETIC_Presentation_FORMS}', "");
    Expect(1, 64335, '\P{^-In_ALPHABETIC_Presentation_FORMS}', "");
    Expect(0, 64336, '\p{-In_ALPHABETIC_Presentation_FORMS}', "");
    Expect(1, 64336, '\p{^-In_ALPHABETIC_Presentation_FORMS}', "");
    Expect(1, 64336, '\P{-In_ALPHABETIC_Presentation_FORMS}', "");
    Expect(0, 64336, '\P{^-In_ALPHABETIC_Presentation_FORMS}', "");
    Error('\p{:=	 ALPHABETIC_PF}');
    Error('\P{:=	 ALPHABETIC_PF}');
    Expect(1, 64335, '\p{alphabeticpf}', "");
    Expect(0, 64335, '\p{^alphabeticpf}', "");
    Expect(0, 64335, '\P{alphabeticpf}', "");
    Expect(1, 64335, '\P{^alphabeticpf}', "");
    Expect(0, 64336, '\p{alphabeticpf}', "");
    Expect(1, 64336, '\p{^alphabeticpf}', "");
    Expect(1, 64336, '\P{alphabeticpf}', "");
    Expect(0, 64336, '\P{^alphabeticpf}', "");
    Expect(1, 64335, '\p{_Alphabetic_pf}', "");
    Expect(0, 64335, '\p{^_Alphabetic_pf}', "");
    Expect(0, 64335, '\P{_Alphabetic_pf}', "");
    Expect(1, 64335, '\P{^_Alphabetic_pf}', "");
    Expect(0, 64336, '\p{_Alphabetic_pf}', "");
    Expect(1, 64336, '\p{^_Alphabetic_pf}', "");
    Expect(1, 64336, '\P{_Alphabetic_pf}', "");
    Expect(0, 64336, '\P{^_Alphabetic_pf}', "");
    Error('\p{	-Is_alphabetic_PF/a/}');
    Error('\P{	-Is_alphabetic_PF/a/}');
    Expect(1, 64335, '\p{isalphabeticpf}', "");
    Expect(0, 64335, '\p{^isalphabeticpf}', "");
    Expect(0, 64335, '\P{isalphabeticpf}', "");
    Expect(1, 64335, '\P{^isalphabeticpf}', "");
    Expect(0, 64336, '\p{isalphabeticpf}', "");
    Expect(1, 64336, '\p{^isalphabeticpf}', "");
    Expect(1, 64336, '\P{isalphabeticpf}', "");
    Expect(0, 64336, '\P{^isalphabeticpf}', "");
    Expect(1, 64335, '\p{- IS_Alphabetic_PF}', "");
    Expect(0, 64335, '\p{^- IS_Alphabetic_PF}', "");
    Expect(0, 64335, '\P{- IS_Alphabetic_PF}', "");
    Expect(1, 64335, '\P{^- IS_Alphabetic_PF}', "");
    Expect(0, 64336, '\p{- IS_Alphabetic_PF}', "");
    Expect(1, 64336, '\p{^- IS_Alphabetic_PF}', "");
    Expect(1, 64336, '\P{- IS_Alphabetic_PF}', "");
    Expect(0, 64336, '\P{^- IS_Alphabetic_PF}', "");
    Error('\p{/a/ -IN_Alphabetic_pf}');
    Error('\P{/a/ -IN_Alphabetic_pf}');
    Expect(1, 64335, '\p{inalphabeticpf}', "");
    Expect(0, 64335, '\p{^inalphabeticpf}', "");
    Expect(0, 64335, '\P{inalphabeticpf}', "");
    Expect(1, 64335, '\P{^inalphabeticpf}', "");
    Expect(0, 64336, '\p{inalphabeticpf}', "");
    Expect(1, 64336, '\p{^inalphabeticpf}', "");
    Expect(1, 64336, '\P{inalphabeticpf}', "");
    Expect(0, 64336, '\P{^inalphabeticpf}', "");
    Expect(1, 64335, '\p{ 	In_Alphabetic_PF}', "");
    Expect(0, 64335, '\p{^ 	In_Alphabetic_PF}', "");
    Expect(0, 64335, '\P{ 	In_Alphabetic_PF}', "");
    Expect(1, 64335, '\P{^ 	In_Alphabetic_PF}', "");
    Expect(0, 64336, '\p{ 	In_Alphabetic_PF}', "");
    Expect(1, 64336, '\p{^ 	In_Alphabetic_PF}', "");
    Expect(1, 64336, '\P{ 	In_Alphabetic_PF}', "");
    Expect(0, 64336, '\P{^ 	In_Alphabetic_PF}', "");
    Error('\p{-_Anatolian_Hieroglyphs:=}');
    Error('\P{-_Anatolian_Hieroglyphs:=}');
    Expect(1, 83526, '\p{anatolianhieroglyphs}', "");
    Expect(0, 83526, '\p{^anatolianhieroglyphs}', "");
    Expect(0, 83526, '\P{anatolianhieroglyphs}', "");
    Expect(1, 83526, '\P{^anatolianhieroglyphs}', "");
    Expect(0, 83527, '\p{anatolianhieroglyphs}', "");
    Expect(1, 83527, '\p{^anatolianhieroglyphs}', "");
    Expect(1, 83527, '\P{anatolianhieroglyphs}', "");
    Expect(0, 83527, '\P{^anatolianhieroglyphs}', "");
    Expect(1, 83526, '\p{- Anatolian_hieroglyphs}', "");
    Expect(0, 83526, '\p{^- Anatolian_hieroglyphs}', "");
    Expect(0, 83526, '\P{- Anatolian_hieroglyphs}', "");
    Expect(1, 83526, '\P{^- Anatolian_hieroglyphs}', "");
    Expect(0, 83527, '\p{- Anatolian_hieroglyphs}', "");
    Expect(1, 83527, '\p{^- Anatolian_hieroglyphs}', "");
    Expect(1, 83527, '\P{- Anatolian_hieroglyphs}', "");
    Expect(0, 83527, '\P{^- Anatolian_hieroglyphs}', "");
    Error('\p{	:=Is_Anatolian_Hieroglyphs}');
    Error('\P{	:=Is_Anatolian_Hieroglyphs}');
    Expect(1, 83526, '\p{isanatolianhieroglyphs}', "");
    Expect(0, 83526, '\p{^isanatolianhieroglyphs}', "");
    Expect(0, 83526, '\P{isanatolianhieroglyphs}', "");
    Expect(1, 83526, '\P{^isanatolianhieroglyphs}', "");
    Expect(0, 83527, '\p{isanatolianhieroglyphs}', "");
    Expect(1, 83527, '\p{^isanatolianhieroglyphs}', "");
    Expect(1, 83527, '\P{isanatolianhieroglyphs}', "");
    Expect(0, 83527, '\P{^isanatolianhieroglyphs}', "");
    Expect(1, 83526, '\p{ IS_ANATOLIAN_hieroglyphs}', "");
    Expect(0, 83526, '\p{^ IS_ANATOLIAN_hieroglyphs}', "");
    Expect(0, 83526, '\P{ IS_ANATOLIAN_hieroglyphs}', "");
    Expect(1, 83526, '\P{^ IS_ANATOLIAN_hieroglyphs}', "");
    Expect(0, 83527, '\p{ IS_ANATOLIAN_hieroglyphs}', "");
    Expect(1, 83527, '\p{^ IS_ANATOLIAN_hieroglyphs}', "");
    Expect(1, 83527, '\P{ IS_ANATOLIAN_hieroglyphs}', "");
    Expect(0, 83527, '\P{^ IS_ANATOLIAN_hieroglyphs}', "");
    Error('\p{ :=HLUW}');
    Error('\P{ :=HLUW}');
    Expect(1, 83526, '\p{hluw}', "");
    Expect(0, 83526, '\p{^hluw}', "");
    Expect(0, 83526, '\P{hluw}', "");
    Expect(1, 83526, '\P{^hluw}', "");
    Expect(0, 83527, '\p{hluw}', "");
    Expect(1, 83527, '\p{^hluw}', "");
    Expect(1, 83527, '\P{hluw}', "");
    Expect(0, 83527, '\P{^hluw}', "");
    Expect(1, 83526, '\p{_-Hluw}', "");
    Expect(0, 83526, '\p{^_-Hluw}', "");
    Expect(0, 83526, '\P{_-Hluw}', "");
    Expect(1, 83526, '\P{^_-Hluw}', "");
    Expect(0, 83527, '\p{_-Hluw}', "");
    Expect(1, 83527, '\p{^_-Hluw}', "");
    Expect(1, 83527, '\P{_-Hluw}', "");
    Expect(0, 83527, '\P{^_-Hluw}', "");
    Error('\p{_:=Is_hluw}');
    Error('\P{_:=Is_hluw}');
    Expect(1, 83526, '\p{ishluw}', "");
    Expect(0, 83526, '\p{^ishluw}', "");
    Expect(0, 83526, '\P{ishluw}', "");
    Expect(1, 83526, '\P{^ishluw}', "");
    Expect(0, 83527, '\p{ishluw}', "");
    Expect(1, 83527, '\p{^ishluw}', "");
    Expect(1, 83527, '\P{ishluw}', "");
    Expect(0, 83527, '\P{^ishluw}', "");
    Expect(1, 83526, '\p{_Is_hluw}', "");
    Expect(0, 83526, '\p{^_Is_hluw}', "");
    Expect(0, 83526, '\P{_Is_hluw}', "");
    Expect(1, 83526, '\P{^_Is_hluw}', "");
    Expect(0, 83527, '\p{_Is_hluw}', "");
    Expect(1, 83527, '\p{^_Is_hluw}', "");
    Expect(1, 83527, '\P{_Is_hluw}', "");
    Expect(0, 83527, '\P{^_Is_hluw}', "");
    Error('\p{ :=ANCIENT_Greek_Musical_notation}');
    Error('\P{ :=ANCIENT_Greek_Musical_notation}');
    Expect(1, 119375, '\p{ancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\p{^ancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\P{ancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\P{^ancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\p{ancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\p{^ancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\P{ancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\P{^ancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\p{ -Ancient_greek_Musical_NOTATION}', "");
    Expect(0, 119375, '\p{^ -Ancient_greek_Musical_NOTATION}', "");
    Expect(0, 119375, '\P{ -Ancient_greek_Musical_NOTATION}', "");
    Expect(1, 119375, '\P{^ -Ancient_greek_Musical_NOTATION}', "");
    Expect(0, 119376, '\p{ -Ancient_greek_Musical_NOTATION}', "");
    Expect(1, 119376, '\p{^ -Ancient_greek_Musical_NOTATION}', "");
    Expect(1, 119376, '\P{ -Ancient_greek_Musical_NOTATION}', "");
    Expect(0, 119376, '\P{^ -Ancient_greek_Musical_NOTATION}', "");
    Error('\p{:=	Is_Ancient_GREEK_Musical_NOTATION}');
    Error('\P{:=	Is_Ancient_GREEK_Musical_NOTATION}');
    Expect(1, 119375, '\p{isancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\p{^isancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\P{isancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\P{^isancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\p{isancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\p{^isancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\P{isancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\P{^isancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\p{	_IS_ancient_greek_musical_Notation}', "");
    Expect(0, 119375, '\p{^	_IS_ancient_greek_musical_Notation}', "");
    Expect(0, 119375, '\P{	_IS_ancient_greek_musical_Notation}', "");
    Expect(1, 119375, '\P{^	_IS_ancient_greek_musical_Notation}', "");
    Expect(0, 119376, '\p{	_IS_ancient_greek_musical_Notation}', "");
    Expect(1, 119376, '\p{^	_IS_ancient_greek_musical_Notation}', "");
    Expect(1, 119376, '\P{	_IS_ancient_greek_musical_Notation}', "");
    Expect(0, 119376, '\P{^	_IS_ancient_greek_musical_Notation}', "");
    Error('\p{_-IN_Ancient_Greek_musical_Notation/a/}');
    Error('\P{_-IN_Ancient_Greek_musical_Notation/a/}');
    Expect(1, 119375, '\p{inancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\p{^inancientgreekmusicalnotation}', "");
    Expect(0, 119375, '\P{inancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\P{^inancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\p{inancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\p{^inancientgreekmusicalnotation}', "");
    Expect(1, 119376, '\P{inancientgreekmusicalnotation}', "");
    Expect(0, 119376, '\P{^inancientgreekmusicalnotation}', "");
    Expect(1, 119375, '\p{--In_ancient_Greek_MUSICAL_NOTATION}', "");
    Expect(0, 119375, '\p{^--In_ancient_Greek_MUSICAL_NOTATION}', "");
    Expect(0, 119375, '\P{--In_ancient_Greek_MUSICAL_NOTATION}', "");
    Expect(1, 119375, '\P{^--In_ancient_Greek_MUSICAL_NOTATION}', "");
    Expect(0, 119376, '\p{--In_ancient_Greek_MUSICAL_NOTATION}', "");
    Expect(1, 119376, '\p{^--In_ancient_Greek_MUSICAL_NOTATION}', "");
    Expect(1, 119376, '\P{--In_ancient_Greek_MUSICAL_NOTATION}', "");
    Expect(0, 119376, '\P{^--In_ancient_Greek_MUSICAL_NOTATION}', "");
    Error('\p{ ancient_GREEK_Music/a/}');
    Error('\P{ ancient_GREEK_Music/a/}');
    Expect(1, 119375, '\p{ancientgreekmusic}', "");
    Expect(0, 119375, '\p{^ancientgreekmusic}', "");
    Expect(0, 119375, '\P{ancientgreekmusic}', "");
    Expect(1, 119375, '\P{^ancientgreekmusic}', "");
    Expect(0, 119376, '\p{ancientgreekmusic}', "");
    Expect(1, 119376, '\p{^ancientgreekmusic}', "");
    Expect(1, 119376, '\P{ancientgreekmusic}', "");
    Expect(0, 119376, '\P{^ancientgreekmusic}', "");
    Expect(1, 119375, '\p{	_ANCIENT_Greek_music}', "");
    Expect(0, 119375, '\p{^	_ANCIENT_Greek_music}', "");
    Expect(0, 119375, '\P{	_ANCIENT_Greek_music}', "");
    Expect(1, 119375, '\P{^	_ANCIENT_Greek_music}', "");
    Expect(0, 119376, '\p{	_ANCIENT_Greek_music}', "");
    Expect(1, 119376, '\p{^	_ANCIENT_Greek_music}', "");
    Expect(1, 119376, '\P{	_ANCIENT_Greek_music}', "");
    Expect(0, 119376, '\P{^	_ANCIENT_Greek_music}', "");
    Error('\p{_-IS_Ancient_Greek_music/a/}');
    Error('\P{_-IS_Ancient_Greek_music/a/}');
    Expect(1, 119375, '\p{isancientgreekmusic}', "");
    Expect(0, 119375, '\p{^isancientgreekmusic}', "");
    Expect(0, 119375, '\P{isancientgreekmusic}', "");
    Expect(1, 119375, '\P{^isancientgreekmusic}', "");
    Expect(0, 119376, '\p{isancientgreekmusic}', "");
    Expect(1, 119376, '\p{^isancientgreekmusic}', "");
    Expect(1, 119376, '\P{isancientgreekmusic}', "");
    Expect(0, 119376, '\P{^isancientgreekmusic}', "");
    Expect(1, 119375, '\p{  IS_Ancient_Greek_Music}', "");
    Expect(0, 119375, '\p{^  IS_Ancient_Greek_Music}', "");
    Expect(0, 119375, '\P{  IS_Ancient_Greek_Music}', "");
    Expect(1, 119375, '\P{^  IS_Ancient_Greek_Music}', "");
    Expect(0, 119376, '\p{  IS_Ancient_Greek_Music}', "");
    Expect(1, 119376, '\p{^  IS_Ancient_Greek_Music}', "");
    Expect(1, 119376, '\P{  IS_Ancient_Greek_Music}', "");
    Expect(0, 119376, '\P{^  IS_Ancient_Greek_Music}', "");
    Error('\p{-IN_Ancient_Greek_MUSIC:=}');
    Error('\P{-IN_Ancient_Greek_MUSIC:=}');
    Expect(1, 119375, '\p{inancientgreekmusic}', "");
    Expect(0, 119375, '\p{^inancientgreekmusic}', "");
    Expect(0, 119375, '\P{inancientgreekmusic}', "");
    Expect(1, 119375, '\P{^inancientgreekmusic}', "");
    Expect(0, 119376, '\p{inancientgreekmusic}', "");
    Expect(1, 119376, '\p{^inancientgreekmusic}', "");
    Expect(1, 119376, '\P{inancientgreekmusic}', "");
    Expect(0, 119376, '\P{^inancientgreekmusic}', "");
    Expect(1, 119375, '\p{	in_ancient_Greek_Music}', "");
    Expect(0, 119375, '\p{^	in_ancient_Greek_Music}', "");
    Expect(0, 119375, '\P{	in_ancient_Greek_Music}', "");
    Expect(1, 119375, '\P{^	in_ancient_Greek_Music}', "");
    Expect(0, 119376, '\p{	in_ancient_Greek_Music}', "");
    Expect(1, 119376, '\p{^	in_ancient_Greek_Music}', "");
    Expect(1, 119376, '\P{	in_ancient_Greek_Music}', "");
    Expect(0, 119376, '\P{^	in_ancient_Greek_Music}', "");
    Error('\p{Ancient_Greek_Numbers/a/}');
    Error('\P{Ancient_Greek_Numbers/a/}');
    Expect(1, 65935, '\p{ancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^ancientgreeknumbers}', "");
    Expect(0, 65935, '\P{ancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^ancientgreeknumbers}', "");
    Expect(0, 65936, '\p{ancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^ancientgreeknumbers}', "");
    Expect(1, 65936, '\P{ancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^ancientgreeknumbers}', "");
    Expect(1, 65935, '\p{-ancient_GREEK_NUMBERS}', "");
    Expect(0, 65935, '\p{^-ancient_GREEK_NUMBERS}', "");
    Expect(0, 65935, '\P{-ancient_GREEK_NUMBERS}', "");
    Expect(1, 65935, '\P{^-ancient_GREEK_NUMBERS}', "");
    Expect(0, 65936, '\p{-ancient_GREEK_NUMBERS}', "");
    Expect(1, 65936, '\p{^-ancient_GREEK_NUMBERS}', "");
    Expect(1, 65936, '\P{-ancient_GREEK_NUMBERS}', "");
    Expect(0, 65936, '\P{^-ancient_GREEK_NUMBERS}', "");
    Error('\p{/a/Is_Ancient_greek_Numbers}');
    Error('\P{/a/Is_Ancient_greek_Numbers}');
    Expect(1, 65935, '\p{isancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^isancientgreeknumbers}', "");
    Expect(0, 65935, '\P{isancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^isancientgreeknumbers}', "");
    Expect(0, 65936, '\p{isancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^isancientgreeknumbers}', "");
    Expect(1, 65936, '\P{isancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^isancientgreeknumbers}', "");
    Expect(1, 65935, '\p{ Is_Ancient_GREEK_Numbers}', "");
    Expect(0, 65935, '\p{^ Is_Ancient_GREEK_Numbers}', "");
    Expect(0, 65935, '\P{ Is_Ancient_GREEK_Numbers}', "");
    Expect(1, 65935, '\P{^ Is_Ancient_GREEK_Numbers}', "");
    Expect(0, 65936, '\p{ Is_Ancient_GREEK_Numbers}', "");
    Expect(1, 65936, '\p{^ Is_Ancient_GREEK_Numbers}', "");
    Expect(1, 65936, '\P{ Is_Ancient_GREEK_Numbers}', "");
    Expect(0, 65936, '\P{^ Is_Ancient_GREEK_Numbers}', "");
    Error('\p{ _in_Ancient_Greek_Numbers:=}');
    Error('\P{ _in_Ancient_Greek_Numbers:=}');
    Expect(1, 65935, '\p{inancientgreeknumbers}', "");
    Expect(0, 65935, '\p{^inancientgreeknumbers}', "");
    Expect(0, 65935, '\P{inancientgreeknumbers}', "");
    Expect(1, 65935, '\P{^inancientgreeknumbers}', "");
    Expect(0, 65936, '\p{inancientgreeknumbers}', "");
    Expect(1, 65936, '\p{^inancientgreeknumbers}', "");
    Expect(1, 65936, '\P{inancientgreeknumbers}', "");
    Expect(0, 65936, '\P{^inancientgreeknumbers}', "");
    Expect(1, 65935, '\p{_in_ancient_Greek_NUMBERS}', "");
    Expect(0, 65935, '\p{^_in_ancient_Greek_NUMBERS}', "");
    Expect(0, 65935, '\P{_in_ancient_Greek_NUMBERS}', "");
    Expect(1, 65935, '\P{^_in_ancient_Greek_NUMBERS}', "");
    Expect(0, 65936, '\p{_in_ancient_Greek_NUMBERS}', "");
    Expect(1, 65936, '\p{^_in_ancient_Greek_NUMBERS}', "");
    Expect(1, 65936, '\P{_in_ancient_Greek_NUMBERS}', "");
    Expect(0, 65936, '\P{^_in_ancient_Greek_NUMBERS}', "");
    Error('\p{ -Ancient_Symbols/a/}');
    Error('\P{ -Ancient_Symbols/a/}');
    Expect(1, 65999, '\p{ancientsymbols}', "");
    Expect(0, 65999, '\p{^ancientsymbols}', "");
    Expect(0, 65999, '\P{ancientsymbols}', "");
    Expect(1, 65999, '\P{^ancientsymbols}', "");
    Expect(0, 66000, '\p{ancientsymbols}', "");
    Expect(1, 66000, '\p{^ancientsymbols}', "");
    Expect(1, 66000, '\P{ancientsymbols}', "");
    Expect(0, 66000, '\P{^ancientsymbols}', "");
    Expect(1, 65999, '\p{--ancient_symbols}', "");
    Expect(0, 65999, '\p{^--ancient_symbols}', "");
    Expect(0, 65999, '\P{--ancient_symbols}', "");
    Expect(1, 65999, '\P{^--ancient_symbols}', "");
    Expect(0, 66000, '\p{--ancient_symbols}', "");
    Expect(1, 66000, '\p{^--ancient_symbols}', "");
    Expect(1, 66000, '\P{--ancient_symbols}', "");
    Expect(0, 66000, '\P{^--ancient_symbols}', "");
    Error('\p{	 Is_Ancient_Symbols:=}');
    Error('\P{	 Is_Ancient_Symbols:=}');
    Expect(1, 65999, '\p{isancientsymbols}', "");
    Expect(0, 65999, '\p{^isancientsymbols}', "");
    Expect(0, 65999, '\P{isancientsymbols}', "");
    Expect(1, 65999, '\P{^isancientsymbols}', "");
    Expect(0, 66000, '\p{isancientsymbols}', "");
    Expect(1, 66000, '\p{^isancientsymbols}', "");
    Expect(1, 66000, '\P{isancientsymbols}', "");
    Expect(0, 66000, '\P{^isancientsymbols}', "");
    Expect(1, 65999, '\p{		is_Ancient_Symbols}', "");
    Expect(0, 65999, '\p{^		is_Ancient_Symbols}', "");
    Expect(0, 65999, '\P{		is_Ancient_Symbols}', "");
    Expect(1, 65999, '\P{^		is_Ancient_Symbols}', "");
    Expect(0, 66000, '\p{		is_Ancient_Symbols}', "");
    Expect(1, 66000, '\p{^		is_Ancient_Symbols}', "");
    Expect(1, 66000, '\P{		is_Ancient_Symbols}', "");
    Expect(0, 66000, '\P{^		is_Ancient_Symbols}', "");
    Error('\p{:=-In_ancient_Symbols}');
    Error('\P{:=-In_ancient_Symbols}');
    Expect(1, 65999, '\p{inancientsymbols}', "");
    Expect(0, 65999, '\p{^inancientsymbols}', "");
    Expect(0, 65999, '\P{inancientsymbols}', "");
    Expect(1, 65999, '\P{^inancientsymbols}', "");
    Expect(0, 66000, '\p{inancientsymbols}', "");
    Expect(1, 66000, '\p{^inancientsymbols}', "");
    Expect(1, 66000, '\P{inancientsymbols}', "");
    Expect(0, 66000, '\P{^inancientsymbols}', "");
    Expect(1, 65999, '\p{		In_Ancient_SYMBOLS}', "");
    Expect(0, 65999, '\p{^		In_Ancient_SYMBOLS}', "");
    Expect(0, 65999, '\P{		In_Ancient_SYMBOLS}', "");
    Expect(1, 65999, '\P{^		In_Ancient_SYMBOLS}', "");
    Expect(0, 66000, '\p{		In_Ancient_SYMBOLS}', "");
    Expect(1, 66000, '\p{^		In_Ancient_SYMBOLS}', "");
    Expect(1, 66000, '\P{		In_Ancient_SYMBOLS}', "");
    Expect(0, 66000, '\P{^		In_Ancient_SYMBOLS}', "");
    Error('\p{ 	Any:=}');
    Error('\P{ 	Any:=}');
    Expect(1, 1, '\p{any}', "");
    Expect(0, 1, '\p{^any}', "");
    Expect(0, 1, '\P{any}', "");
    Expect(1, 1, '\P{^any}', "");
    Expect(0, 8912887, '\p{any}', "");
    Expect(1, 8912887, '\p{^any}', "");
    Expect(1, 8912887, '\P{any}', "");
    Expect(0, 8912887, '\P{^any}', "");
    Expect(1, 1, '\p{	any}', "");
    Expect(0, 1, '\p{^	any}', "");
    Expect(0, 1, '\P{	any}', "");
    Expect(1, 1, '\P{^	any}', "");
    Expect(0, 8912887, '\p{	any}', "");
    Expect(1, 8912887, '\p{^	any}', "");
    Expect(1, 8912887, '\P{	any}', "");
    Expect(0, 8912887, '\P{^	any}', "");
    Error('\p{	/a/unicode}');
    Error('\P{	/a/unicode}');
    Expect(1, 1, '\p{unicode}', "");
    Expect(0, 1, '\p{^unicode}', "");
    Expect(0, 1, '\P{unicode}', "");
    Expect(1, 1, '\P{^unicode}', "");
    Expect(0, 8912887, '\p{unicode}', "");
    Expect(1, 8912887, '\p{^unicode}', "");
    Expect(1, 8912887, '\P{unicode}', "");
    Expect(0, 8912887, '\P{^unicode}', "");
    Expect(1, 1, '\p{		UNICODE}', "");
    Expect(0, 1, '\p{^		UNICODE}', "");
    Expect(0, 1, '\P{		UNICODE}', "");
    Expect(1, 1, '\P{^		UNICODE}', "");
    Expect(0, 8912887, '\p{		UNICODE}', "");
    Expect(1, 8912887, '\p{^		UNICODE}', "");
    Expect(1, 8912887, '\P{		UNICODE}', "");
    Expect(0, 8912887, '\P{^		UNICODE}', "");
    Error('\p{__is_any/a/}');
    Error('\P{__is_any/a/}');
    Expect(1, 1, '\p{isany}', "");
    Expect(0, 1, '\p{^isany}', "");
    Expect(0, 1, '\P{isany}', "");
    Expect(1, 1, '\P{^isany}', "");
    Expect(0, 8912887, '\p{isany}', "");
    Expect(1, 8912887, '\p{^isany}', "");
    Expect(1, 8912887, '\P{isany}', "");
    Expect(0, 8912887, '\P{^isany}', "");
    Expect(1, 1, '\p{ -IS_Any}', "");
    Expect(0, 1, '\p{^ -IS_Any}', "");
    Expect(0, 1, '\P{ -IS_Any}', "");
    Expect(1, 1, '\P{^ -IS_Any}', "");
    Expect(0, 8912887, '\p{ -IS_Any}', "");
    Expect(1, 8912887, '\p{^ -IS_Any}', "");
    Expect(1, 8912887, '\P{ -IS_Any}', "");
    Expect(0, 8912887, '\P{^ -IS_Any}', "");
    Error('\p{ /a/Is_UNICODE}');
    Error('\P{ /a/Is_UNICODE}');
    Expect(1, 1, '\p{isunicode}', "");
    Expect(0, 1, '\p{^isunicode}', "");
    Expect(0, 1, '\P{isunicode}', "");
    Expect(1, 1, '\P{^isunicode}', "");
    Expect(0, 8912887, '\p{isunicode}', "");
    Expect(1, 8912887, '\p{^isunicode}', "");
    Expect(1, 8912887, '\P{isunicode}', "");
    Expect(0, 8912887, '\P{^isunicode}', "");
    Expect(1, 1, '\p{_IS_Unicode}', "");
    Expect(0, 1, '\p{^_IS_Unicode}', "");
    Expect(0, 1, '\P{_IS_Unicode}', "");
    Expect(1, 1, '\P{^_IS_Unicode}', "");
    Expect(0, 8912887, '\p{_IS_Unicode}', "");
    Expect(1, 8912887, '\p{^_IS_Unicode}', "");
    Expect(1, 8912887, '\P{_IS_Unicode}', "");
    Expect(0, 8912887, '\P{^_IS_Unicode}', "");
    Error('\p{ Arabic:=}');
    Error('\P{ Arabic:=}');
    Expect(1, 126705, '\p{arabic}', "");
    Expect(0, 126705, '\p{^arabic}', "");
    Expect(0, 126705, '\P{arabic}', "");
    Expect(1, 126705, '\P{^arabic}', "");
    Expect(0, 126706, '\p{arabic}', "");
    Expect(1, 126706, '\p{^arabic}', "");
    Expect(1, 126706, '\P{arabic}', "");
    Expect(0, 126706, '\P{^arabic}', "");
    Expect(1, 126705, '\p{	Arabic}', "");
    Expect(0, 126705, '\p{^	Arabic}', "");
    Expect(0, 126705, '\P{	Arabic}', "");
    Expect(1, 126705, '\P{^	Arabic}', "");
    Expect(0, 126706, '\p{	Arabic}', "");
    Expect(1, 126706, '\p{^	Arabic}', "");
    Expect(1, 126706, '\P{	Arabic}', "");
    Expect(0, 126706, '\P{^	Arabic}', "");
    Error('\p{/a/ is_arabic}');
    Error('\P{/a/ is_arabic}');
    Expect(1, 126705, '\p{isarabic}', "");
    Expect(0, 126705, '\p{^isarabic}', "");
    Expect(0, 126705, '\P{isarabic}', "");
    Expect(1, 126705, '\P{^isarabic}', "");
    Expect(0, 126706, '\p{isarabic}', "");
    Expect(1, 126706, '\p{^isarabic}', "");
    Expect(1, 126706, '\P{isarabic}', "");
    Expect(0, 126706, '\P{^isarabic}', "");
    Expect(1, 126705, '\p{ IS_ARABIC}', "");
    Expect(0, 126705, '\p{^ IS_ARABIC}', "");
    Expect(0, 126705, '\P{ IS_ARABIC}', "");
    Expect(1, 126705, '\P{^ IS_ARABIC}', "");
    Expect(0, 126706, '\p{ IS_ARABIC}', "");
    Expect(1, 126706, '\p{^ IS_ARABIC}', "");
    Expect(1, 126706, '\P{ IS_ARABIC}', "");
    Expect(0, 126706, '\P{^ IS_ARABIC}', "");
    Error('\p{_/a/Arab}');
    Error('\P{_/a/Arab}');
    Expect(1, 126705, '\p{arab}', "");
    Expect(0, 126705, '\p{^arab}', "");
    Expect(0, 126705, '\P{arab}', "");
    Expect(1, 126705, '\P{^arab}', "");
    Expect(0, 126706, '\p{arab}', "");
    Expect(1, 126706, '\p{^arab}', "");
    Expect(1, 126706, '\P{arab}', "");
    Expect(0, 126706, '\P{^arab}', "");
    Expect(1, 126705, '\p{ _Arab}', "");
    Expect(0, 126705, '\p{^ _Arab}', "");
    Expect(0, 126705, '\P{ _Arab}', "");
    Expect(1, 126705, '\P{^ _Arab}', "");
    Expect(0, 126706, '\p{ _Arab}', "");
    Expect(1, 126706, '\p{^ _Arab}', "");
    Expect(1, 126706, '\P{ _Arab}', "");
    Expect(0, 126706, '\P{^ _Arab}', "");
    Error('\p{/a/IS_Arab}');
    Error('\P{/a/IS_Arab}');
    Expect(1, 126705, '\p{isarab}', "");
    Expect(0, 126705, '\p{^isarab}', "");
    Expect(0, 126705, '\P{isarab}', "");
    Expect(1, 126705, '\P{^isarab}', "");
    Expect(0, 126706, '\p{isarab}', "");
    Expect(1, 126706, '\p{^isarab}', "");
    Expect(1, 126706, '\P{isarab}', "");
    Expect(0, 126706, '\P{^isarab}', "");
    Expect(1, 126705, '\p{-Is_arab}', "");
    Expect(0, 126705, '\p{^-Is_arab}', "");
    Expect(0, 126705, '\P{-Is_arab}', "");
    Expect(1, 126705, '\P{^-Is_arab}', "");
    Expect(0, 126706, '\p{-Is_arab}', "");
    Expect(1, 126706, '\p{^-Is_arab}', "");
    Expect(1, 126706, '\P{-Is_arab}', "");
    Expect(0, 126706, '\P{^-Is_arab}', "");
    Error('\p{/a/ARABIC_Extended_A}');
    Error('\P{/a/ARABIC_Extended_A}');
    Expect(1, 2303, '\p{arabicextendeda}', "");
    Expect(0, 2303, '\p{^arabicextendeda}', "");
    Expect(0, 2303, '\P{arabicextendeda}', "");
    Expect(1, 2303, '\P{^arabicextendeda}', "");
    Expect(0, 2304, '\p{arabicextendeda}', "");
    Expect(1, 2304, '\p{^arabicextendeda}', "");
    Expect(1, 2304, '\P{arabicextendeda}', "");
    Expect(0, 2304, '\P{^arabicextendeda}', "");
    Expect(1, 2303, '\p{-_Arabic_extended_a}', "");
    Expect(0, 2303, '\p{^-_Arabic_extended_a}', "");
    Expect(0, 2303, '\P{-_Arabic_extended_a}', "");
    Expect(1, 2303, '\P{^-_Arabic_extended_a}', "");
    Expect(0, 2304, '\p{-_Arabic_extended_a}', "");
    Expect(1, 2304, '\p{^-_Arabic_extended_a}', "");
    Expect(1, 2304, '\P{-_Arabic_extended_a}', "");
    Expect(0, 2304, '\P{^-_Arabic_extended_a}', "");
    Error('\p{:=IS_Arabic_extended_a}');
    Error('\P{:=IS_Arabic_extended_a}');
    Expect(1, 2303, '\p{isarabicextendeda}', "");
    Expect(0, 2303, '\p{^isarabicextendeda}', "");
    Expect(0, 2303, '\P{isarabicextendeda}', "");
    Expect(1, 2303, '\P{^isarabicextendeda}', "");
    Expect(0, 2304, '\p{isarabicextendeda}', "");
    Expect(1, 2304, '\p{^isarabicextendeda}', "");
    Expect(1, 2304, '\P{isarabicextendeda}', "");
    Expect(0, 2304, '\P{^isarabicextendeda}', "");
    Expect(1, 2303, '\p{	_is_ARABIC_Extended_A}', "");
    Expect(0, 2303, '\p{^	_is_ARABIC_Extended_A}', "");
    Expect(0, 2303, '\P{	_is_ARABIC_Extended_A}', "");
    Expect(1, 2303, '\P{^	_is_ARABIC_Extended_A}', "");
    Expect(0, 2304, '\p{	_is_ARABIC_Extended_A}', "");
    Expect(1, 2304, '\p{^	_is_ARABIC_Extended_A}', "");
    Expect(1, 2304, '\P{	_is_ARABIC_Extended_A}', "");
    Expect(0, 2304, '\P{^	_is_ARABIC_Extended_A}', "");
    Error('\p{_:=In_arabic_Extended_A}');
    Error('\P{_:=In_arabic_Extended_A}');
    Expect(1, 2303, '\p{inarabicextendeda}', "");
    Expect(0, 2303, '\p{^inarabicextendeda}', "");
    Expect(0, 2303, '\P{inarabicextendeda}', "");
    Expect(1, 2303, '\P{^inarabicextendeda}', "");
    Expect(0, 2304, '\p{inarabicextendeda}', "");
    Expect(1, 2304, '\p{^inarabicextendeda}', "");
    Expect(1, 2304, '\P{inarabicextendeda}', "");
    Expect(0, 2304, '\P{^inarabicextendeda}', "");
    Expect(1, 2303, '\p{		In_Arabic_Extended_A}', "");
    Expect(0, 2303, '\p{^		In_Arabic_Extended_A}', "");
    Expect(0, 2303, '\P{		In_Arabic_Extended_A}', "");
    Expect(1, 2303, '\P{^		In_Arabic_Extended_A}', "");
    Expect(0, 2304, '\p{		In_Arabic_Extended_A}', "");
    Expect(1, 2304, '\p{^		In_Arabic_Extended_A}', "");
    Expect(1, 2304, '\P{		In_Arabic_Extended_A}', "");
    Expect(0, 2304, '\P{^		In_Arabic_Extended_A}', "");
    Error('\p{	arabic_Ext_a:=}');
    Error('\P{	arabic_Ext_a:=}');
    Expect(1, 2303, '\p{arabicexta}', "");
    Expect(0, 2303, '\p{^arabicexta}', "");
    Expect(0, 2303, '\P{arabicexta}', "");
    Expect(1, 2303, '\P{^arabicexta}', "");
    Expect(0, 2304, '\p{arabicexta}', "");
    Expect(1, 2304, '\p{^arabicexta}', "");
    Expect(1, 2304, '\P{arabicexta}', "");
    Expect(0, 2304, '\P{^arabicexta}', "");
    Expect(1, 2303, '\p{_Arabic_Ext_A}', "");
    Expect(0, 2303, '\p{^_Arabic_Ext_A}', "");
    Expect(0, 2303, '\P{_Arabic_Ext_A}', "");
    Expect(1, 2303, '\P{^_Arabic_Ext_A}', "");
    Expect(0, 2304, '\p{_Arabic_Ext_A}', "");
    Expect(1, 2304, '\p{^_Arabic_Ext_A}', "");
    Expect(1, 2304, '\P{_Arabic_Ext_A}', "");
    Expect(0, 2304, '\P{^_Arabic_Ext_A}', "");
    Error('\p{_:=Is_Arabic_ext_A}');
    Error('\P{_:=Is_Arabic_ext_A}');
    Expect(1, 2303, '\p{isarabicexta}', "");
    Expect(0, 2303, '\p{^isarabicexta}', "");
    Expect(0, 2303, '\P{isarabicexta}', "");
    Expect(1, 2303, '\P{^isarabicexta}', "");
    Expect(0, 2304, '\p{isarabicexta}', "");
    Expect(1, 2304, '\p{^isarabicexta}', "");
    Expect(1, 2304, '\P{isarabicexta}', "");
    Expect(0, 2304, '\P{^isarabicexta}', "");
    Expect(1, 2303, '\p{-_IS_ARABIC_EXT_A}', "");
    Expect(0, 2303, '\p{^-_IS_ARABIC_EXT_A}', "");
    Expect(0, 2303, '\P{-_IS_ARABIC_EXT_A}', "");
    Expect(1, 2303, '\P{^-_IS_ARABIC_EXT_A}', "");
    Expect(0, 2304, '\p{-_IS_ARABIC_EXT_A}', "");
    Expect(1, 2304, '\p{^-_IS_ARABIC_EXT_A}', "");
    Expect(1, 2304, '\P{-_IS_ARABIC_EXT_A}', "");
    Expect(0, 2304, '\P{^-_IS_ARABIC_EXT_A}', "");
    Error('\p{:=-in_Arabic_EXT_A}');
    Error('\P{:=-in_Arabic_EXT_A}');
    Expect(1, 2303, '\p{inarabicexta}', "");
    Expect(0, 2303, '\p{^inarabicexta}', "");
    Expect(0, 2303, '\P{inarabicexta}', "");
    Expect(1, 2303, '\P{^inarabicexta}', "");
    Expect(0, 2304, '\p{inarabicexta}', "");
    Expect(1, 2304, '\p{^inarabicexta}', "");
    Expect(1, 2304, '\P{inarabicexta}', "");
    Expect(0, 2304, '\P{^inarabicexta}', "");
    Expect(1, 2303, '\p{ In_Arabic_Ext_A}', "");
    Expect(0, 2303, '\p{^ In_Arabic_Ext_A}', "");
    Expect(0, 2303, '\P{ In_Arabic_Ext_A}', "");
    Expect(1, 2303, '\P{^ In_Arabic_Ext_A}', "");
    Expect(0, 2304, '\p{ In_Arabic_Ext_A}', "");
    Expect(1, 2304, '\p{^ In_Arabic_Ext_A}', "");
    Expect(1, 2304, '\P{ In_Arabic_Ext_A}', "");
    Expect(0, 2304, '\P{^ In_Arabic_Ext_A}', "");
    Error('\p{- ARABIC_Mathematical_Alphabetic_symbols/a/}');
    Error('\P{- ARABIC_Mathematical_Alphabetic_symbols/a/}');
    Expect(1, 126719, '\p{arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\p{^arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\P{arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\P{^arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\p{arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\p{^arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\P{arabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\P{^arabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\p{-_arabic_MATHEMATICAL_Alphabetic_symbols}', "");
    Expect(0, 126719, '\p{^-_arabic_MATHEMATICAL_Alphabetic_symbols}', "");
    Expect(0, 126719, '\P{-_arabic_MATHEMATICAL_Alphabetic_symbols}', "");
    Expect(1, 126719, '\P{^-_arabic_MATHEMATICAL_Alphabetic_symbols}', "");
    Expect(0, 126720, '\p{-_arabic_MATHEMATICAL_Alphabetic_symbols}', "");
    Expect(1, 126720, '\p{^-_arabic_MATHEMATICAL_Alphabetic_symbols}', "");
    Expect(1, 126720, '\P{-_arabic_MATHEMATICAL_Alphabetic_symbols}', "");
    Expect(0, 126720, '\P{^-_arabic_MATHEMATICAL_Alphabetic_symbols}', "");
    Error('\p{:= Is_Arabic_mathematical_Alphabetic_Symbols}');
    Error('\P{:= Is_Arabic_mathematical_Alphabetic_Symbols}');
    Expect(1, 126719, '\p{isarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\p{^isarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\P{isarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\P{^isarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\p{isarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\p{^isarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\P{isarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\P{^isarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\p{	IS_arabic_Mathematical_alphabetic_SYMBOLS}', "");
    Expect(0, 126719, '\p{^	IS_arabic_Mathematical_alphabetic_SYMBOLS}', "");
    Expect(0, 126719, '\P{	IS_arabic_Mathematical_alphabetic_SYMBOLS}', "");
    Expect(1, 126719, '\P{^	IS_arabic_Mathematical_alphabetic_SYMBOLS}', "");
    Expect(0, 126720, '\p{	IS_arabic_Mathematical_alphabetic_SYMBOLS}', "");
    Expect(1, 126720, '\p{^	IS_arabic_Mathematical_alphabetic_SYMBOLS}', "");
    Expect(1, 126720, '\P{	IS_arabic_Mathematical_alphabetic_SYMBOLS}', "");
    Expect(0, 126720, '\P{^	IS_arabic_Mathematical_alphabetic_SYMBOLS}', "");
    Error('\p{:=In_ARABIC_Mathematical_Alphabetic_symbols}');
    Error('\P{:=In_ARABIC_Mathematical_Alphabetic_symbols}');
    Expect(1, 126719, '\p{inarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\p{^inarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126719, '\P{inarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\P{^inarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\p{inarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\p{^inarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126720, '\P{inarabicmathematicalalphabeticsymbols}', "");
    Expect(0, 126720, '\P{^inarabicmathematicalalphabeticsymbols}', "");
    Expect(1, 126719, '\p{_In_Arabic_Mathematical_Alphabetic_SYMBOLS}', "");
    Expect(0, 126719, '\p{^_In_Arabic_Mathematical_Alphabetic_SYMBOLS}', "");
    Expect(0, 126719, '\P{_In_Arabic_Mathematical_Alphabetic_SYMBOLS}', "");
    Expect(1, 126719, '\P{^_In_Arabic_Mathematical_Alphabetic_SYMBOLS}', "");
    Expect(0, 126720, '\p{_In_Arabic_Mathematical_Alphabetic_SYMBOLS}', "");
    Expect(1, 126720, '\p{^_In_Arabic_Mathematical_Alphabetic_SYMBOLS}', "");
    Expect(1, 126720, '\P{_In_Arabic_Mathematical_Alphabetic_SYMBOLS}', "");
    Expect(0, 126720, '\P{^_In_Arabic_Mathematical_Alphabetic_SYMBOLS}', "");
    Error('\p{/a/_ARABIC_Math}');
    Error('\P{/a/_ARABIC_Math}');
    Expect(1, 126719, '\p{arabicmath}', "");
    Expect(0, 126719, '\p{^arabicmath}', "");
    Expect(0, 126719, '\P{arabicmath}', "");
    Expect(1, 126719, '\P{^arabicmath}', "");
    Expect(0, 126720, '\p{arabicmath}', "");
    Expect(1, 126720, '\p{^arabicmath}', "");
    Expect(1, 126720, '\P{arabicmath}', "");
    Expect(0, 126720, '\P{^arabicmath}', "");
    Expect(1, 126719, '\p{_-Arabic_MATH}', "");
    Expect(0, 126719, '\p{^_-Arabic_MATH}', "");
    Expect(0, 126719, '\P{_-Arabic_MATH}', "");
    Expect(1, 126719, '\P{^_-Arabic_MATH}', "");
    Expect(0, 126720, '\p{_-Arabic_MATH}', "");
    Expect(1, 126720, '\p{^_-Arabic_MATH}', "");
    Expect(1, 126720, '\P{_-Arabic_MATH}', "");
    Expect(0, 126720, '\P{^_-Arabic_MATH}', "");
    Error('\p{-/a/is_arabic_MATH}');
    Error('\P{-/a/is_arabic_MATH}');
    Expect(1, 126719, '\p{isarabicmath}', "");
    Expect(0, 126719, '\p{^isarabicmath}', "");
    Expect(0, 126719, '\P{isarabicmath}', "");
    Expect(1, 126719, '\P{^isarabicmath}', "");
    Expect(0, 126720, '\p{isarabicmath}', "");
    Expect(1, 126720, '\p{^isarabicmath}', "");
    Expect(1, 126720, '\P{isarabicmath}', "");
    Expect(0, 126720, '\P{^isarabicmath}', "");
    Expect(1, 126719, '\p{-	IS_Arabic_MATH}', "");
    Expect(0, 126719, '\p{^-	IS_Arabic_MATH}', "");
    Expect(0, 126719, '\P{-	IS_Arabic_MATH}', "");
    Expect(1, 126719, '\P{^-	IS_Arabic_MATH}', "");
    Expect(0, 126720, '\p{-	IS_Arabic_MATH}', "");
    Expect(1, 126720, '\p{^-	IS_Arabic_MATH}', "");
    Expect(1, 126720, '\P{-	IS_Arabic_MATH}', "");
    Expect(0, 126720, '\P{^-	IS_Arabic_MATH}', "");
    Error('\p{:= -IN_Arabic_MATH}');
    Error('\P{:= -IN_Arabic_MATH}');
    Expect(1, 126719, '\p{inarabicmath}', "");
    Expect(0, 126719, '\p{^inarabicmath}', "");
    Expect(0, 126719, '\P{inarabicmath}', "");
    Expect(1, 126719, '\P{^inarabicmath}', "");
    Expect(0, 126720, '\p{inarabicmath}', "");
    Expect(1, 126720, '\p{^inarabicmath}', "");
    Expect(1, 126720, '\P{inarabicmath}', "");
    Expect(0, 126720, '\P{^inarabicmath}', "");
    Expect(1, 126719, '\p{- In_Arabic_MATH}', "");
    Expect(0, 126719, '\p{^- In_Arabic_MATH}', "");
    Expect(0, 126719, '\P{- In_Arabic_MATH}', "");
    Expect(1, 126719, '\P{^- In_Arabic_MATH}', "");
    Expect(0, 126720, '\p{- In_Arabic_MATH}', "");
    Expect(1, 126720, '\p{^- In_Arabic_MATH}', "");
    Expect(1, 126720, '\P{- In_Arabic_MATH}', "");
    Expect(0, 126720, '\P{^- In_Arabic_MATH}', "");
    Error('\p{/a/--Arabic_Presentation_forms_A}');
    Error('\P{/a/--Arabic_Presentation_forms_A}');
    Expect(1, 65023, '\p{arabicpresentationformsa}', "");
    Expect(0, 65023, '\p{^arabicpresentationformsa}', "");
    Expect(0, 65023, '\P{arabicpresentationformsa}', "");
    Expect(1, 65023, '\P{^arabicpresentationformsa}', "");
    Expect(0, 65024, '\p{arabicpresentationformsa}', "");
    Expect(1, 65024, '\p{^arabicpresentationformsa}', "");
    Expect(1, 65024, '\P{arabicpresentationformsa}', "");
    Expect(0, 65024, '\P{^arabicpresentationformsa}', "");
    Expect(1, 65023, '\p{		ARABIC_Presentation_Forms_A}', "");
    Expect(0, 65023, '\p{^		ARABIC_Presentation_Forms_A}', "");
    Expect(0, 65023, '\P{		ARABIC_Presentation_Forms_A}', "");
    Expect(1, 65023, '\P{^		ARABIC_Presentation_Forms_A}', "");
    Expect(0, 65024, '\p{		ARABIC_Presentation_Forms_A}', "");
    Expect(1, 65024, '\p{^		ARABIC_Presentation_Forms_A}', "");
    Expect(1, 65024, '\P{		ARABIC_Presentation_Forms_A}', "");
    Expect(0, 65024, '\P{^		ARABIC_Presentation_Forms_A}', "");
    Error('\p{/a/_Is_Arabic_presentation_Forms_a}');
    Error('\P{/a/_Is_Arabic_presentation_Forms_a}');
    Expect(1, 65023, '\p{isarabicpresentationformsa}', "");
    Expect(0, 65023, '\p{^isarabicpresentationformsa}', "");
    Expect(0, 65023, '\P{isarabicpresentationformsa}', "");
    Expect(1, 65023, '\P{^isarabicpresentationformsa}', "");
    Expect(0, 65024, '\p{isarabicpresentationformsa}', "");
    Expect(1, 65024, '\p{^isarabicpresentationformsa}', "");
    Expect(1, 65024, '\P{isarabicpresentationformsa}', "");
    Expect(0, 65024, '\P{^isarabicpresentationformsa}', "");
    Expect(1, 65023, '\p{-IS_Arabic_Presentation_forms_A}', "");
    Expect(0, 65023, '\p{^-IS_Arabic_Presentation_forms_A}', "");
    Expect(0, 65023, '\P{-IS_Arabic_Presentation_forms_A}', "");
    Expect(1, 65023, '\P{^-IS_Arabic_Presentation_forms_A}', "");
    Expect(0, 65024, '\p{-IS_Arabic_Presentation_forms_A}', "");
    Expect(1, 65024, '\p{^-IS_Arabic_Presentation_forms_A}', "");
    Expect(1, 65024, '\P{-IS_Arabic_Presentation_forms_A}', "");
    Expect(0, 65024, '\P{^-IS_Arabic_Presentation_forms_A}', "");
    Error('\p{-in_ARABIC_presentation_forms_a:=}');
    Error('\P{-in_ARABIC_presentation_forms_a:=}');
    Expect(1, 65023, '\p{inarabicpresentationformsa}', "");
    Expect(0, 65023, '\p{^inarabicpresentationformsa}', "");
    Expect(0, 65023, '\P{inarabicpresentationformsa}', "");
    Expect(1, 65023, '\P{^inarabicpresentationformsa}', "");
    Expect(0, 65024, '\p{inarabicpresentationformsa}', "");
    Expect(1, 65024, '\p{^inarabicpresentationformsa}', "");
    Expect(1, 65024, '\P{inarabicpresentationformsa}', "");
    Expect(0, 65024, '\P{^inarabicpresentationformsa}', "");
    Expect(1, 65023, '\p{-	In_ARABIC_Presentation_forms_a}', "");
    Expect(0, 65023, '\p{^-	In_ARABIC_Presentation_forms_a}', "");
    Expect(0, 65023, '\P{-	In_ARABIC_Presentation_forms_a}', "");
    Expect(1, 65023, '\P{^-	In_ARABIC_Presentation_forms_a}', "");
    Expect(0, 65024, '\p{-	In_ARABIC_Presentation_forms_a}', "");
    Expect(1, 65024, '\p{^-	In_ARABIC_Presentation_forms_a}', "");
    Expect(1, 65024, '\P{-	In_ARABIC_Presentation_forms_a}', "");
    Expect(0, 65024, '\P{^-	In_ARABIC_Presentation_forms_a}', "");
    Error('\p{ -ARABIC_pf_a:=}');
    Error('\P{ -ARABIC_pf_a:=}');
    Expect(1, 65023, '\p{arabicpfa}', "");
    Expect(0, 65023, '\p{^arabicpfa}', "");
    Expect(0, 65023, '\P{arabicpfa}', "");
    Expect(1, 65023, '\P{^arabicpfa}', "");
    Expect(0, 65024, '\p{arabicpfa}', "");
    Expect(1, 65024, '\p{^arabicpfa}', "");
    Expect(1, 65024, '\P{arabicpfa}', "");
    Expect(0, 65024, '\P{^arabicpfa}', "");
    Expect(1, 65023, '\p{ -arabic_PF_a}', "");
    Expect(0, 65023, '\p{^ -arabic_PF_a}', "");
    Expect(0, 65023, '\P{ -arabic_PF_a}', "");
    Expect(1, 65023, '\P{^ -arabic_PF_a}', "");
    Expect(0, 65024, '\p{ -arabic_PF_a}', "");
    Expect(1, 65024, '\p{^ -arabic_PF_a}', "");
    Expect(1, 65024, '\P{ -arabic_PF_a}', "");
    Expect(0, 65024, '\P{^ -arabic_PF_a}', "");
    Error('\p{:=Is_arabic_pf_A}');
    Error('\P{:=Is_arabic_pf_A}');
    Expect(1, 65023, '\p{isarabicpfa}', "");
    Expect(0, 65023, '\p{^isarabicpfa}', "");
    Expect(0, 65023, '\P{isarabicpfa}', "");
    Expect(1, 65023, '\P{^isarabicpfa}', "");
    Expect(0, 65024, '\p{isarabicpfa}', "");
    Expect(1, 65024, '\p{^isarabicpfa}', "");
    Expect(1, 65024, '\P{isarabicpfa}', "");
    Expect(0, 65024, '\P{^isarabicpfa}', "");
    Expect(1, 65023, '\p{		Is_Arabic_PF_a}', "");
    Expect(0, 65023, '\p{^		Is_Arabic_PF_a}', "");
    Expect(0, 65023, '\P{		Is_Arabic_PF_a}', "");
    Expect(1, 65023, '\P{^		Is_Arabic_PF_a}', "");
    Expect(0, 65024, '\p{		Is_Arabic_PF_a}', "");
    Expect(1, 65024, '\p{^		Is_Arabic_PF_a}', "");
    Expect(1, 65024, '\P{		Is_Arabic_PF_a}', "");
    Expect(0, 65024, '\P{^		Is_Arabic_PF_a}', "");
    Error('\p{:=In_Arabic_PF_A}');
    Error('\P{:=In_Arabic_PF_A}');
    Expect(1, 65023, '\p{inarabicpfa}', "");
    Expect(0, 65023, '\p{^inarabicpfa}', "");
    Expect(0, 65023, '\P{inarabicpfa}', "");
    Expect(1, 65023, '\P{^inarabicpfa}', "");
    Expect(0, 65024, '\p{inarabicpfa}', "");
    Expect(1, 65024, '\p{^inarabicpfa}', "");
    Expect(1, 65024, '\P{inarabicpfa}', "");
    Expect(0, 65024, '\P{^inarabicpfa}', "");
    Expect(1, 65023, '\p{ 	in_ARABIC_PF_A}', "");
    Expect(0, 65023, '\p{^ 	in_ARABIC_PF_A}', "");
    Expect(0, 65023, '\P{ 	in_ARABIC_PF_A}', "");
    Expect(1, 65023, '\P{^ 	in_ARABIC_PF_A}', "");
    Expect(0, 65024, '\p{ 	in_ARABIC_PF_A}', "");
    Expect(1, 65024, '\p{^ 	in_ARABIC_PF_A}', "");
    Expect(1, 65024, '\P{ 	in_ARABIC_PF_A}', "");
    Expect(0, 65024, '\P{^ 	in_ARABIC_PF_A}', "");
    Error('\p{/a/-arabic_PRESENTATION_forms_b}');
    Error('\P{/a/-arabic_PRESENTATION_forms_b}');
    Expect(1, 65279, '\p{arabicpresentationformsb}', "");
    Expect(0, 65279, '\p{^arabicpresentationformsb}', "");
    Expect(0, 65279, '\P{arabicpresentationformsb}', "");
    Expect(1, 65279, '\P{^arabicpresentationformsb}', "");
    Expect(0, 65280, '\p{arabicpresentationformsb}', "");
    Expect(1, 65280, '\p{^arabicpresentationformsb}', "");
    Expect(1, 65280, '\P{arabicpresentationformsb}', "");
    Expect(0, 65280, '\P{^arabicpresentationformsb}', "");
    Expect(1, 65279, '\p{ARABIC_presentation_FORMS_B}', "");
    Expect(0, 65279, '\p{^ARABIC_presentation_FORMS_B}', "");
    Expect(0, 65279, '\P{ARABIC_presentation_FORMS_B}', "");
    Expect(1, 65279, '\P{^ARABIC_presentation_FORMS_B}', "");
    Expect(0, 65280, '\p{ARABIC_presentation_FORMS_B}', "");
    Expect(1, 65280, '\p{^ARABIC_presentation_FORMS_B}', "");
    Expect(1, 65280, '\P{ARABIC_presentation_FORMS_B}', "");
    Expect(0, 65280, '\P{^ARABIC_presentation_FORMS_B}', "");
    Error('\p{-/a/IS_ARABIC_Presentation_Forms_B}');
    Error('\P{-/a/IS_ARABIC_Presentation_Forms_B}');
    Expect(1, 65279, '\p{isarabicpresentationformsb}', "");
    Expect(0, 65279, '\p{^isarabicpresentationformsb}', "");
    Expect(0, 65279, '\P{isarabicpresentationformsb}', "");
    Expect(1, 65279, '\P{^isarabicpresentationformsb}', "");
    Expect(0, 65280, '\p{isarabicpresentationformsb}', "");
    Expect(1, 65280, '\p{^isarabicpresentationformsb}', "");
    Expect(1, 65280, '\P{isarabicpresentationformsb}', "");
    Expect(0, 65280, '\P{^isarabicpresentationformsb}', "");
    Expect(1, 65279, '\p{ _is_arabic_Presentation_FORMS_B}', "");
    Expect(0, 65279, '\p{^ _is_arabic_Presentation_FORMS_B}', "");
    Expect(0, 65279, '\P{ _is_arabic_Presentation_FORMS_B}', "");
    Expect(1, 65279, '\P{^ _is_arabic_Presentation_FORMS_B}', "");
    Expect(0, 65280, '\p{ _is_arabic_Presentation_FORMS_B}', "");
    Expect(1, 65280, '\p{^ _is_arabic_Presentation_FORMS_B}', "");
    Expect(1, 65280, '\P{ _is_arabic_Presentation_FORMS_B}', "");
    Expect(0, 65280, '\P{^ _is_arabic_Presentation_FORMS_B}', "");
    Error('\p{:=IN_Arabic_PRESENTATION_FORMS_b}');
    Error('\P{:=IN_Arabic_PRESENTATION_FORMS_b}');
    Expect(1, 65279, '\p{inarabicpresentationformsb}', "");
    Expect(0, 65279, '\p{^inarabicpresentationformsb}', "");
    Expect(0, 65279, '\P{inarabicpresentationformsb}', "");
    Expect(1, 65279, '\P{^inarabicpresentationformsb}', "");
    Expect(0, 65280, '\p{inarabicpresentationformsb}', "");
    Expect(1, 65280, '\p{^inarabicpresentationformsb}', "");
    Expect(1, 65280, '\P{inarabicpresentationformsb}', "");
    Expect(0, 65280, '\P{^inarabicpresentationformsb}', "");
    Expect(1, 65279, '\p{_-In_ARABIC_Presentation_Forms_B}', "");
    Expect(0, 65279, '\p{^_-In_ARABIC_Presentation_Forms_B}', "");
    Expect(0, 65279, '\P{_-In_ARABIC_Presentation_Forms_B}', "");
    Expect(1, 65279, '\P{^_-In_ARABIC_Presentation_Forms_B}', "");
    Expect(0, 65280, '\p{_-In_ARABIC_Presentation_Forms_B}', "");
    Expect(1, 65280, '\p{^_-In_ARABIC_Presentation_Forms_B}', "");
    Expect(1, 65280, '\P{_-In_ARABIC_Presentation_Forms_B}', "");
    Expect(0, 65280, '\P{^_-In_ARABIC_Presentation_Forms_B}', "");
    Error('\p{-arabic_PF_B:=}');
    Error('\P{-arabic_PF_B:=}');
    Expect(1, 65279, '\p{arabicpfb}', "");
    Expect(0, 65279, '\p{^arabicpfb}', "");
    Expect(0, 65279, '\P{arabicpfb}', "");
    Expect(1, 65279, '\P{^arabicpfb}', "");
    Expect(0, 65280, '\p{arabicpfb}', "");
    Expect(1, 65280, '\p{^arabicpfb}', "");
    Expect(1, 65280, '\P{arabicpfb}', "");
    Expect(0, 65280, '\P{^arabicpfb}', "");
    Expect(1, 65279, '\p{	Arabic_pf_B}', "");
    Expect(0, 65279, '\p{^	Arabic_pf_B}', "");
    Expect(0, 65279, '\P{	Arabic_pf_B}', "");
    Expect(1, 65279, '\P{^	Arabic_pf_B}', "");
    Expect(0, 65280, '\p{	Arabic_pf_B}', "");
    Expect(1, 65280, '\p{^	Arabic_pf_B}', "");
    Expect(1, 65280, '\P{	Arabic_pf_B}', "");
    Expect(0, 65280, '\P{^	Arabic_pf_B}', "");
    Error('\p{ /a/Is_Arabic_PF_b}');
    Error('\P{ /a/Is_Arabic_PF_b}');
    Expect(1, 65279, '\p{isarabicpfb}', "");
    Expect(0, 65279, '\p{^isarabicpfb}', "");
    Expect(0, 65279, '\P{isarabicpfb}', "");
    Expect(1, 65279, '\P{^isarabicpfb}', "");
    Expect(0, 65280, '\p{isarabicpfb}', "");
    Expect(1, 65280, '\p{^isarabicpfb}', "");
    Expect(1, 65280, '\P{isarabicpfb}', "");
    Expect(0, 65280, '\P{^isarabicpfb}', "");
    Expect(1, 65279, '\p{__is_arabic_PF_b}', "");
    Expect(0, 65279, '\p{^__is_arabic_PF_b}', "");
    Expect(0, 65279, '\P{__is_arabic_PF_b}', "");
    Expect(1, 65279, '\P{^__is_arabic_PF_b}', "");
    Expect(0, 65280, '\p{__is_arabic_PF_b}', "");
    Expect(1, 65280, '\p{^__is_arabic_PF_b}', "");
    Expect(1, 65280, '\P{__is_arabic_PF_b}', "");
    Expect(0, 65280, '\P{^__is_arabic_PF_b}', "");
    Error('\p{/a/	In_arabic_PF_b}');
    Error('\P{/a/	In_arabic_PF_b}');
    Expect(1, 65279, '\p{inarabicpfb}', "");
    Expect(0, 65279, '\p{^inarabicpfb}', "");
    Expect(0, 65279, '\P{inarabicpfb}', "");
    Expect(1, 65279, '\P{^inarabicpfb}', "");
    Expect(0, 65280, '\p{inarabicpfb}', "");
    Expect(1, 65280, '\p{^inarabicpfb}', "");
    Expect(1, 65280, '\P{inarabicpfb}', "");
    Expect(0, 65280, '\P{^inarabicpfb}', "");
    Expect(1, 65279, '\p{	 IN_Arabic_PF_B}', "");
    Expect(0, 65279, '\p{^	 IN_Arabic_PF_B}', "");
    Expect(0, 65279, '\P{	 IN_Arabic_PF_B}', "");
    Expect(1, 65279, '\P{^	 IN_Arabic_PF_B}', "");
    Expect(0, 65280, '\p{	 IN_Arabic_PF_B}', "");
    Expect(1, 65280, '\p{^	 IN_Arabic_PF_B}', "");
    Expect(1, 65280, '\P{	 IN_Arabic_PF_B}', "");
    Expect(0, 65280, '\P{^	 IN_Arabic_PF_B}', "");
    Error('\p{:=_	Arabic_supplement}');
    Error('\P{:=_	Arabic_supplement}');
    Expect(1, 1919, '\p{arabicsupplement}', "");
    Expect(0, 1919, '\p{^arabicsupplement}', "");
    Expect(0, 1919, '\P{arabicsupplement}', "");
    Expect(1, 1919, '\P{^arabicsupplement}', "");
    Expect(0, 1920, '\p{arabicsupplement}', "");
    Expect(1, 1920, '\p{^arabicsupplement}', "");
    Expect(1, 1920, '\P{arabicsupplement}', "");
    Expect(0, 1920, '\P{^arabicsupplement}', "");
    Expect(1, 1919, '\p{	_Arabic_SUPPLEMENT}', "");
    Expect(0, 1919, '\p{^	_Arabic_SUPPLEMENT}', "");
    Expect(0, 1919, '\P{	_Arabic_SUPPLEMENT}', "");
    Expect(1, 1919, '\P{^	_Arabic_SUPPLEMENT}', "");
    Expect(0, 1920, '\p{	_Arabic_SUPPLEMENT}', "");
    Expect(1, 1920, '\p{^	_Arabic_SUPPLEMENT}', "");
    Expect(1, 1920, '\P{	_Arabic_SUPPLEMENT}', "");
    Expect(0, 1920, '\P{^	_Arabic_SUPPLEMENT}', "");
    Error('\p{ :=Is_arabic_Supplement}');
    Error('\P{ :=Is_arabic_Supplement}');
    Expect(1, 1919, '\p{isarabicsupplement}', "");
    Expect(0, 1919, '\p{^isarabicsupplement}', "");
    Expect(0, 1919, '\P{isarabicsupplement}', "");
    Expect(1, 1919, '\P{^isarabicsupplement}', "");
    Expect(0, 1920, '\p{isarabicsupplement}', "");
    Expect(1, 1920, '\p{^isarabicsupplement}', "");
    Expect(1, 1920, '\P{isarabicsupplement}', "");
    Expect(0, 1920, '\P{^isarabicsupplement}', "");
    Expect(1, 1919, '\p{_	Is_Arabic_supplement}', "");
    Expect(0, 1919, '\p{^_	Is_Arabic_supplement}', "");
    Expect(0, 1919, '\P{_	Is_Arabic_supplement}', "");
    Expect(1, 1919, '\P{^_	Is_Arabic_supplement}', "");
    Expect(0, 1920, '\p{_	Is_Arabic_supplement}', "");
    Expect(1, 1920, '\p{^_	Is_Arabic_supplement}', "");
    Expect(1, 1920, '\P{_	Is_Arabic_supplement}', "");
    Expect(0, 1920, '\P{^_	Is_Arabic_supplement}', "");
    Error('\p{-_In_Arabic_SUPPLEMENT:=}');
    Error('\P{-_In_Arabic_SUPPLEMENT:=}');
    Expect(1, 1919, '\p{inarabicsupplement}', "");
    Expect(0, 1919, '\p{^inarabicsupplement}', "");
    Expect(0, 1919, '\P{inarabicsupplement}', "");
    Expect(1, 1919, '\P{^inarabicsupplement}', "");
    Expect(0, 1920, '\p{inarabicsupplement}', "");
    Expect(1, 1920, '\p{^inarabicsupplement}', "");
    Expect(1, 1920, '\P{inarabicsupplement}', "");
    Expect(0, 1920, '\P{^inarabicsupplement}', "");
    Expect(1, 1919, '\p{	In_ARABIC_supplement}', "");
    Expect(0, 1919, '\p{^	In_ARABIC_supplement}', "");
    Expect(0, 1919, '\P{	In_ARABIC_supplement}', "");
    Expect(1, 1919, '\P{^	In_ARABIC_supplement}', "");
    Expect(0, 1920, '\p{	In_ARABIC_supplement}', "");
    Expect(1, 1920, '\p{^	In_ARABIC_supplement}', "");
    Expect(1, 1920, '\P{	In_ARABIC_supplement}', "");
    Expect(0, 1920, '\P{^	In_ARABIC_supplement}', "");
    Error('\p{:= Arabic_sup}');
    Error('\P{:= Arabic_sup}');
    Expect(1, 1919, '\p{arabicsup}', "");
    Expect(0, 1919, '\p{^arabicsup}', "");
    Expect(0, 1919, '\P{arabicsup}', "");
    Expect(1, 1919, '\P{^arabicsup}', "");
    Expect(0, 1920, '\p{arabicsup}', "");
    Expect(1, 1920, '\p{^arabicsup}', "");
    Expect(1, 1920, '\P{arabicsup}', "");
    Expect(0, 1920, '\P{^arabicsup}', "");
    Expect(1, 1919, '\p{	 Arabic_Sup}', "");
    Expect(0, 1919, '\p{^	 Arabic_Sup}', "");
    Expect(0, 1919, '\P{	 Arabic_Sup}', "");
    Expect(1, 1919, '\P{^	 Arabic_Sup}', "");
    Expect(0, 1920, '\p{	 Arabic_Sup}', "");
    Expect(1, 1920, '\p{^	 Arabic_Sup}', "");
    Expect(1, 1920, '\P{	 Arabic_Sup}', "");
    Expect(0, 1920, '\P{^	 Arabic_Sup}', "");
    Error('\p{_	Is_ARABIC_SUP:=}');
    Error('\P{_	Is_ARABIC_SUP:=}');
    Expect(1, 1919, '\p{isarabicsup}', "");
    Expect(0, 1919, '\p{^isarabicsup}', "");
    Expect(0, 1919, '\P{isarabicsup}', "");
    Expect(1, 1919, '\P{^isarabicsup}', "");
    Expect(0, 1920, '\p{isarabicsup}', "");
    Expect(1, 1920, '\p{^isarabicsup}', "");
    Expect(1, 1920, '\P{isarabicsup}', "");
    Expect(0, 1920, '\P{^isarabicsup}', "");
    Expect(1, 1919, '\p{	-Is_arabic_SUP}', "");
    Expect(0, 1919, '\p{^	-Is_arabic_SUP}', "");
    Expect(0, 1919, '\P{	-Is_arabic_SUP}', "");
    Expect(1, 1919, '\P{^	-Is_arabic_SUP}', "");
    Expect(0, 1920, '\p{	-Is_arabic_SUP}', "");
    Expect(1, 1920, '\p{^	-Is_arabic_SUP}', "");
    Expect(1, 1920, '\P{	-Is_arabic_SUP}', "");
    Expect(0, 1920, '\P{^	-Is_arabic_SUP}', "");
    Error('\p{-/a/In_arabic_Sup}');
    Error('\P{-/a/In_arabic_Sup}');
    Expect(1, 1919, '\p{inarabicsup}', "");
    Expect(0, 1919, '\p{^inarabicsup}', "");
    Expect(0, 1919, '\P{inarabicsup}', "");
    Expect(1, 1919, '\P{^inarabicsup}', "");
    Expect(0, 1920, '\p{inarabicsup}', "");
    Expect(1, 1920, '\p{^inarabicsup}', "");
    Expect(1, 1920, '\P{inarabicsup}', "");
    Expect(0, 1920, '\P{^inarabicsup}', "");
    Expect(1, 1919, '\p{	In_Arabic_Sup}', "");
    Expect(0, 1919, '\p{^	In_Arabic_Sup}', "");
    Expect(0, 1919, '\P{	In_Arabic_Sup}', "");
    Expect(1, 1919, '\P{^	In_Arabic_Sup}', "");
    Expect(0, 1920, '\p{	In_Arabic_Sup}', "");
    Expect(1, 1920, '\p{^	In_Arabic_Sup}', "");
    Expect(1, 1920, '\P{	In_Arabic_Sup}', "");
    Expect(0, 1920, '\P{^	In_Arabic_Sup}', "");
    Error('\p{armenian:=}');
    Error('\P{armenian:=}');
    Expect(1, 64279, '\p{armenian}', "");
    Expect(0, 64279, '\p{^armenian}', "");
    Expect(0, 64279, '\P{armenian}', "");
    Expect(1, 64279, '\P{^armenian}', "");
    Expect(0, 64280, '\p{armenian}', "");
    Expect(1, 64280, '\p{^armenian}', "");
    Expect(1, 64280, '\P{armenian}', "");
    Expect(0, 64280, '\P{^armenian}', "");
    Expect(1, 64279, '\p{_	Armenian}', "");
    Expect(0, 64279, '\p{^_	Armenian}', "");
    Expect(0, 64279, '\P{_	Armenian}', "");
    Expect(1, 64279, '\P{^_	Armenian}', "");
    Expect(0, 64280, '\p{_	Armenian}', "");
    Expect(1, 64280, '\p{^_	Armenian}', "");
    Expect(1, 64280, '\P{_	Armenian}', "");
    Expect(0, 64280, '\P{^_	Armenian}', "");
    Error('\p{_-IS_Armenian/a/}');
    Error('\P{_-IS_Armenian/a/}');
    Expect(1, 64279, '\p{isarmenian}', "");
    Expect(0, 64279, '\p{^isarmenian}', "");
    Expect(0, 64279, '\P{isarmenian}', "");
    Expect(1, 64279, '\P{^isarmenian}', "");
    Expect(0, 64280, '\p{isarmenian}', "");
    Expect(1, 64280, '\p{^isarmenian}', "");
    Expect(1, 64280, '\P{isarmenian}', "");
    Expect(0, 64280, '\P{^isarmenian}', "");
    Expect(1, 64279, '\p{_Is_ARMENIAN}', "");
    Expect(0, 64279, '\p{^_Is_ARMENIAN}', "");
    Expect(0, 64279, '\P{_Is_ARMENIAN}', "");
    Expect(1, 64279, '\P{^_Is_ARMENIAN}', "");
    Expect(0, 64280, '\p{_Is_ARMENIAN}', "");
    Expect(1, 64280, '\p{^_Is_ARMENIAN}', "");
    Expect(1, 64280, '\P{_Is_ARMENIAN}', "");
    Expect(0, 64280, '\P{^_Is_ARMENIAN}', "");
    Error('\p{-	Armn:=}');
    Error('\P{-	Armn:=}');
    Expect(1, 64279, '\p{armn}', "");
    Expect(0, 64279, '\p{^armn}', "");
    Expect(0, 64279, '\P{armn}', "");
    Expect(1, 64279, '\P{^armn}', "");
    Expect(0, 64280, '\p{armn}', "");
    Expect(1, 64280, '\p{^armn}', "");
    Expect(1, 64280, '\P{armn}', "");
    Expect(0, 64280, '\P{^armn}', "");
    Expect(1, 64279, '\p{-Armn}', "");
    Expect(0, 64279, '\p{^-Armn}', "");
    Expect(0, 64279, '\P{-Armn}', "");
    Expect(1, 64279, '\P{^-Armn}', "");
    Expect(0, 64280, '\p{-Armn}', "");
    Expect(1, 64280, '\p{^-Armn}', "");
    Expect(1, 64280, '\P{-Armn}', "");
    Expect(0, 64280, '\P{^-Armn}', "");
    Error('\p{ /a/Is_ARMN}');
    Error('\P{ /a/Is_ARMN}');
    Expect(1, 64279, '\p{isarmn}', "");
    Expect(0, 64279, '\p{^isarmn}', "");
    Expect(0, 64279, '\P{isarmn}', "");
    Expect(1, 64279, '\P{^isarmn}', "");
    Expect(0, 64280, '\p{isarmn}', "");
    Expect(1, 64280, '\p{^isarmn}', "");
    Expect(1, 64280, '\P{isarmn}', "");
    Expect(0, 64280, '\P{^isarmn}', "");
    Expect(1, 64279, '\p{_ is_Armn}', "");
    Expect(0, 64279, '\p{^_ is_Armn}', "");
    Expect(0, 64279, '\P{_ is_Armn}', "");
    Expect(1, 64279, '\P{^_ is_Armn}', "");
    Expect(0, 64280, '\p{_ is_Armn}', "");
    Expect(1, 64280, '\p{^_ is_Armn}', "");
    Expect(1, 64280, '\P{_ is_Armn}', "");
    Expect(0, 64280, '\P{^_ is_Armn}', "");
    Error('\p{:= -ARROWS}');
    Error('\P{:= -ARROWS}');
    Expect(1, 8703, '\p{arrows}', "");
    Expect(0, 8703, '\p{^arrows}', "");
    Expect(0, 8703, '\P{arrows}', "");
    Expect(1, 8703, '\P{^arrows}', "");
    Expect(0, 8704, '\p{arrows}', "");
    Expect(1, 8704, '\p{^arrows}', "");
    Expect(1, 8704, '\P{arrows}', "");
    Expect(0, 8704, '\P{^arrows}', "");
    Expect(1, 8703, '\p{	_Arrows}', "");
    Expect(0, 8703, '\p{^	_Arrows}', "");
    Expect(0, 8703, '\P{	_Arrows}', "");
    Expect(1, 8703, '\P{^	_Arrows}', "");
    Expect(0, 8704, '\p{	_Arrows}', "");
    Expect(1, 8704, '\p{^	_Arrows}', "");
    Expect(1, 8704, '\P{	_Arrows}', "");
    Expect(0, 8704, '\P{^	_Arrows}', "");
    Error('\p{:=is_Arrows}');
    Error('\P{:=is_Arrows}');
    Expect(1, 8703, '\p{isarrows}', "");
    Expect(0, 8703, '\p{^isarrows}', "");
    Expect(0, 8703, '\P{isarrows}', "");
    Expect(1, 8703, '\P{^isarrows}', "");
    Expect(0, 8704, '\p{isarrows}', "");
    Expect(1, 8704, '\p{^isarrows}', "");
    Expect(1, 8704, '\P{isarrows}', "");
    Expect(0, 8704, '\P{^isarrows}', "");
    Expect(1, 8703, '\p{-IS_arrows}', "");
    Expect(0, 8703, '\p{^-IS_arrows}', "");
    Expect(0, 8703, '\P{-IS_arrows}', "");
    Expect(1, 8703, '\P{^-IS_arrows}', "");
    Expect(0, 8704, '\p{-IS_arrows}', "");
    Expect(1, 8704, '\p{^-IS_arrows}', "");
    Expect(1, 8704, '\P{-IS_arrows}', "");
    Expect(0, 8704, '\P{^-IS_arrows}', "");
    Error('\p{-/a/In_ARROWS}');
    Error('\P{-/a/In_ARROWS}');
    Expect(1, 8703, '\p{inarrows}', "");
    Expect(0, 8703, '\p{^inarrows}', "");
    Expect(0, 8703, '\P{inarrows}', "");
    Expect(1, 8703, '\P{^inarrows}', "");
    Expect(0, 8704, '\p{inarrows}', "");
    Expect(1, 8704, '\p{^inarrows}', "");
    Expect(1, 8704, '\P{inarrows}', "");
    Expect(0, 8704, '\P{^inarrows}', "");
    Expect(1, 8703, '\p{ In_arrows}', "");
    Expect(0, 8703, '\p{^ In_arrows}', "");
    Expect(0, 8703, '\P{ In_arrows}', "");
    Expect(1, 8703, '\P{^ In_arrows}', "");
    Expect(0, 8704, '\p{ In_arrows}', "");
    Expect(1, 8704, '\p{^ In_arrows}', "");
    Expect(1, 8704, '\P{ In_arrows}', "");
    Expect(0, 8704, '\P{^ In_arrows}', "");
    Error('\p{	:=ascii}');
    Error('\P{	:=ascii}');
    Expect(1, 127, '\p{ascii}', "");
    Expect(0, 127, '\p{^ascii}', "");
    Expect(0, 127, '\P{ascii}', "");
    Expect(1, 127, '\P{^ascii}', "");
    Expect(0, 128, '\p{ascii}', "");
    Expect(1, 128, '\p{^ascii}', "");
    Expect(1, 128, '\P{ascii}', "");
    Expect(0, 128, '\P{^ascii}', "");
    Expect(1, 127, '\p{	ASCII}', "");
    Expect(0, 127, '\p{^	ASCII}', "");
    Expect(0, 127, '\P{	ASCII}', "");
    Expect(1, 127, '\P{^	ASCII}', "");
    Expect(0, 128, '\p{	ASCII}', "");
    Expect(1, 128, '\p{^	ASCII}', "");
    Expect(1, 128, '\P{	ASCII}', "");
    Expect(0, 128, '\P{^	ASCII}', "");
    Error('\p{_ Is_ascii:=}');
    Error('\P{_ Is_ascii:=}');
    Expect(1, 127, '\p{isascii}', "");
    Expect(0, 127, '\p{^isascii}', "");
    Expect(0, 127, '\P{isascii}', "");
    Expect(1, 127, '\P{^isascii}', "");
    Expect(0, 128, '\p{isascii}', "");
    Expect(1, 128, '\p{^isascii}', "");
    Expect(1, 128, '\P{isascii}', "");
    Expect(0, 128, '\P{^isascii}', "");
    Expect(1, 127, '\p{-	is_ASCII}', "");
    Expect(0, 127, '\p{^-	is_ASCII}', "");
    Expect(0, 127, '\P{-	is_ASCII}', "");
    Expect(1, 127, '\P{^-	is_ASCII}', "");
    Expect(0, 128, '\p{-	is_ASCII}', "");
    Expect(1, 128, '\p{^-	is_ASCII}', "");
    Expect(1, 128, '\P{-	is_ASCII}', "");
    Expect(0, 128, '\P{^-	is_ASCII}', "");
    Error('\p{/a/ _BASIC_Latin}');
    Error('\P{/a/ _BASIC_Latin}');
    Expect(1, 127, '\p{basiclatin}', "");
    Expect(0, 127, '\p{^basiclatin}', "");
    Expect(0, 127, '\P{basiclatin}', "");
    Expect(1, 127, '\P{^basiclatin}', "");
    Expect(0, 128, '\p{basiclatin}', "");
    Expect(1, 128, '\p{^basiclatin}', "");
    Expect(1, 128, '\P{basiclatin}', "");
    Expect(0, 128, '\P{^basiclatin}', "");
    Expect(1, 127, '\p{	-basic_latin}', "");
    Expect(0, 127, '\p{^	-basic_latin}', "");
    Expect(0, 127, '\P{	-basic_latin}', "");
    Expect(1, 127, '\P{^	-basic_latin}', "");
    Expect(0, 128, '\p{	-basic_latin}', "");
    Expect(1, 128, '\p{^	-basic_latin}', "");
    Expect(1, 128, '\P{	-basic_latin}', "");
    Expect(0, 128, '\P{^	-basic_latin}', "");
    Error('\p{__Is_Basic_latin/a/}');
    Error('\P{__Is_Basic_latin/a/}');
    Expect(1, 127, '\p{isbasiclatin}', "");
    Expect(0, 127, '\p{^isbasiclatin}', "");
    Expect(0, 127, '\P{isbasiclatin}', "");
    Expect(1, 127, '\P{^isbasiclatin}', "");
    Expect(0, 128, '\p{isbasiclatin}', "");
    Expect(1, 128, '\p{^isbasiclatin}', "");
    Expect(1, 128, '\P{isbasiclatin}', "");
    Expect(0, 128, '\P{^isbasiclatin}', "");
    Expect(1, 127, '\p{_ IS_basic_LATIN}', "");
    Expect(0, 127, '\p{^_ IS_basic_LATIN}', "");
    Expect(0, 127, '\P{_ IS_basic_LATIN}', "");
    Expect(1, 127, '\P{^_ IS_basic_LATIN}', "");
    Expect(0, 128, '\p{_ IS_basic_LATIN}', "");
    Expect(1, 128, '\p{^_ IS_basic_LATIN}', "");
    Expect(1, 128, '\P{_ IS_basic_LATIN}', "");
    Expect(0, 128, '\P{^_ IS_basic_LATIN}', "");
    Error('\p{ 	IN_BASIC_LATIN:=}');
    Error('\P{ 	IN_BASIC_LATIN:=}');
    Expect(1, 127, '\p{inbasiclatin}', "");
    Expect(0, 127, '\p{^inbasiclatin}', "");
    Expect(0, 127, '\P{inbasiclatin}', "");
    Expect(1, 127, '\P{^inbasiclatin}', "");
    Expect(0, 128, '\p{inbasiclatin}', "");
    Expect(1, 128, '\p{^inbasiclatin}', "");
    Expect(1, 128, '\P{inbasiclatin}', "");
    Expect(0, 128, '\P{^inbasiclatin}', "");
    Expect(1, 127, '\p{__in_Basic_Latin}', "");
    Expect(0, 127, '\p{^__in_Basic_Latin}', "");
    Expect(0, 127, '\P{__in_Basic_Latin}', "");
    Expect(1, 127, '\P{^__in_Basic_Latin}', "");
    Expect(0, 128, '\p{__in_Basic_Latin}', "");
    Expect(1, 128, '\p{^__in_Basic_Latin}', "");
    Expect(1, 128, '\P{__in_Basic_Latin}', "");
    Expect(0, 128, '\P{^__in_Basic_Latin}', "");
    Error('\p{ 	in_ASCII/a/}');
    Error('\P{ 	in_ASCII/a/}');
    Expect(1, 127, '\p{inascii}', "");
    Expect(0, 127, '\p{^inascii}', "");
    Expect(0, 127, '\P{inascii}', "");
    Expect(1, 127, '\P{^inascii}', "");
    Expect(0, 128, '\p{inascii}', "");
    Expect(1, 128, '\p{^inascii}', "");
    Expect(1, 128, '\P{inascii}', "");
    Expect(0, 128, '\P{^inascii}', "");
    Expect(1, 127, '\p{	-In_ascii}', "");
    Expect(0, 127, '\p{^	-In_ascii}', "");
    Expect(0, 127, '\P{	-In_ascii}', "");
    Expect(1, 127, '\P{^	-In_ascii}', "");
    Expect(0, 128, '\p{	-In_ascii}', "");
    Expect(1, 128, '\p{^	-In_ascii}', "");
    Expect(1, 128, '\P{	-In_ascii}', "");
    Expect(0, 128, '\P{^	-In_ascii}', "");
    Error('\p{/a/	-Assigned}');
    Error('\P{/a/	-Assigned}');
    Expect(1, 1114109, '\p{assigned}', "");
    Expect(0, 1114109, '\p{^assigned}', "");
    Expect(0, 1114109, '\P{assigned}', "");
    Expect(1, 1114109, '\P{^assigned}', "");
    Expect(0, 918000, '\p{assigned}', "");
    Expect(1, 918000, '\p{^assigned}', "");
    Expect(1, 918000, '\P{assigned}', "");
    Expect(0, 918000, '\P{^assigned}', "");
    Expect(1, 1114109, '\p{-	Assigned}', "");
    Expect(0, 1114109, '\p{^-	Assigned}', "");
    Expect(0, 1114109, '\P{-	Assigned}', "");
    Expect(1, 1114109, '\P{^-	Assigned}', "");
    Expect(0, 918000, '\p{-	Assigned}', "");
    Expect(1, 918000, '\p{^-	Assigned}', "");
    Expect(1, 918000, '\P{-	Assigned}', "");
    Expect(0, 918000, '\P{^-	Assigned}', "");
    Error('\p{ :=Is_Assigned}');
    Error('\P{ :=Is_Assigned}');
    Expect(1, 1114109, '\p{isassigned}', "");
    Expect(0, 1114109, '\p{^isassigned}', "");
    Expect(0, 1114109, '\P{isassigned}', "");
    Expect(1, 1114109, '\P{^isassigned}', "");
    Expect(0, 918000, '\p{isassigned}', "");
    Expect(1, 918000, '\p{^isassigned}', "");
    Expect(1, 918000, '\P{isassigned}', "");
    Expect(0, 918000, '\P{^isassigned}', "");
    Expect(1, 1114109, '\p{__Is_Assigned}', "");
    Expect(0, 1114109, '\p{^__Is_Assigned}', "");
    Expect(0, 1114109, '\P{__Is_Assigned}', "");
    Expect(1, 1114109, '\P{^__Is_Assigned}', "");
    Expect(0, 918000, '\p{__Is_Assigned}', "");
    Expect(1, 918000, '\p{^__Is_Assigned}', "");
    Expect(1, 918000, '\P{__Is_Assigned}', "");
    Expect(0, 918000, '\P{^__Is_Assigned}', "");
    Error('\p{/a/ 	Avestan}');
    Error('\P{/a/ 	Avestan}');
    Expect(1, 68415, '\p{avestan}', "");
    Expect(0, 68415, '\p{^avestan}', "");
    Expect(0, 68415, '\P{avestan}', "");
    Expect(1, 68415, '\P{^avestan}', "");
    Expect(0, 68416, '\p{avestan}', "");
    Expect(1, 68416, '\p{^avestan}', "");
    Expect(1, 68416, '\P{avestan}', "");
    Expect(0, 68416, '\P{^avestan}', "");
    Expect(1, 68415, '\p{ avestan}', "");
    Expect(0, 68415, '\p{^ avestan}', "");
    Expect(0, 68415, '\P{ avestan}', "");
    Expect(1, 68415, '\P{^ avestan}', "");
    Expect(0, 68416, '\p{ avestan}', "");
    Expect(1, 68416, '\p{^ avestan}', "");
    Expect(1, 68416, '\P{ avestan}', "");
    Expect(0, 68416, '\P{^ avestan}', "");
    Error('\p{:= 	Is_Avestan}');
    Error('\P{:= 	Is_Avestan}');
    Expect(1, 68415, '\p{isavestan}', "");
    Expect(0, 68415, '\p{^isavestan}', "");
    Expect(0, 68415, '\P{isavestan}', "");
    Expect(1, 68415, '\P{^isavestan}', "");
    Expect(0, 68416, '\p{isavestan}', "");
    Expect(1, 68416, '\p{^isavestan}', "");
    Expect(1, 68416, '\P{isavestan}', "");
    Expect(0, 68416, '\P{^isavestan}', "");
    Expect(1, 68415, '\p{ 	Is_Avestan}', "");
    Expect(0, 68415, '\p{^ 	Is_Avestan}', "");
    Expect(0, 68415, '\P{ 	Is_Avestan}', "");
    Expect(1, 68415, '\P{^ 	Is_Avestan}', "");
    Expect(0, 68416, '\p{ 	Is_Avestan}', "");
    Expect(1, 68416, '\p{^ 	Is_Avestan}', "");
    Expect(1, 68416, '\P{ 	Is_Avestan}', "");
    Expect(0, 68416, '\P{^ 	Is_Avestan}', "");
    Error('\p{-avst/a/}');
    Error('\P{-avst/a/}');
    Expect(1, 68415, '\p{avst}', "");
    Expect(0, 68415, '\p{^avst}', "");
    Expect(0, 68415, '\P{avst}', "");
    Expect(1, 68415, '\P{^avst}', "");
    Expect(0, 68416, '\p{avst}', "");
    Expect(1, 68416, '\p{^avst}', "");
    Expect(1, 68416, '\P{avst}', "");
    Expect(0, 68416, '\P{^avst}', "");
    Expect(1, 68415, '\p{-avst}', "");
    Expect(0, 68415, '\p{^-avst}', "");
    Expect(0, 68415, '\P{-avst}', "");
    Expect(1, 68415, '\P{^-avst}', "");
    Expect(0, 68416, '\p{-avst}', "");
    Expect(1, 68416, '\p{^-avst}', "");
    Expect(1, 68416, '\P{-avst}', "");
    Expect(0, 68416, '\P{^-avst}', "");
    Error('\p{ -is_avst:=}');
    Error('\P{ -is_avst:=}');
    Expect(1, 68415, '\p{isavst}', "");
    Expect(0, 68415, '\p{^isavst}', "");
    Expect(0, 68415, '\P{isavst}', "");
    Expect(1, 68415, '\P{^isavst}', "");
    Expect(0, 68416, '\p{isavst}', "");
    Expect(1, 68416, '\p{^isavst}', "");
    Expect(1, 68416, '\P{isavst}', "");
    Expect(0, 68416, '\P{^isavst}', "");
    Expect(1, 68415, '\p{	 IS_avst}', "");
    Expect(0, 68415, '\p{^	 IS_avst}', "");
    Expect(0, 68415, '\P{	 IS_avst}', "");
    Expect(1, 68415, '\P{^	 IS_avst}', "");
    Expect(0, 68416, '\p{	 IS_avst}', "");
    Expect(1, 68416, '\p{^	 IS_avst}', "");
    Expect(1, 68416, '\P{	 IS_avst}', "");
    Expect(0, 68416, '\P{^	 IS_avst}', "");
    Error('\p{ BALINESE/a/}');
    Error('\P{ BALINESE/a/}');
    Expect(1, 7036, '\p{balinese}', "");
    Expect(0, 7036, '\p{^balinese}', "");
    Expect(0, 7036, '\P{balinese}', "");
    Expect(1, 7036, '\P{^balinese}', "");
    Expect(0, 7037, '\p{balinese}', "");
    Expect(1, 7037, '\p{^balinese}', "");
    Expect(1, 7037, '\P{balinese}', "");
    Expect(0, 7037, '\P{^balinese}', "");
    Expect(1, 7036, '\p{	-balinese}', "");
    Expect(0, 7036, '\p{^	-balinese}', "");
    Expect(0, 7036, '\P{	-balinese}', "");
    Expect(1, 7036, '\P{^	-balinese}', "");
    Expect(0, 7037, '\p{	-balinese}', "");
    Expect(1, 7037, '\p{^	-balinese}', "");
    Expect(1, 7037, '\P{	-balinese}', "");
    Expect(0, 7037, '\P{^	-balinese}', "");
    Error('\p{_/a/Is_BALINESE}');
    Error('\P{_/a/Is_BALINESE}');
    Expect(1, 7036, '\p{isbalinese}', "");
    Expect(0, 7036, '\p{^isbalinese}', "");
    Expect(0, 7036, '\P{isbalinese}', "");
    Expect(1, 7036, '\P{^isbalinese}', "");
    Expect(0, 7037, '\p{isbalinese}', "");
    Expect(1, 7037, '\p{^isbalinese}', "");
    Expect(1, 7037, '\P{isbalinese}', "");
    Expect(0, 7037, '\P{^isbalinese}', "");
    Expect(1, 7036, '\p{	Is_Balinese}', "");
    Expect(0, 7036, '\p{^	Is_Balinese}', "");
    Expect(0, 7036, '\P{	Is_Balinese}', "");
    Expect(1, 7036, '\P{^	Is_Balinese}', "");
    Expect(0, 7037, '\p{	Is_Balinese}', "");
    Expect(1, 7037, '\p{^	Is_Balinese}', "");
    Expect(1, 7037, '\P{	Is_Balinese}', "");
    Expect(0, 7037, '\P{^	Is_Balinese}', "");
    Error('\p{/a/- Bali}');
    Error('\P{/a/- Bali}');
    Expect(1, 7036, '\p{bali}', "");
    Expect(0, 7036, '\p{^bali}', "");
    Expect(0, 7036, '\P{bali}', "");
    Expect(1, 7036, '\P{^bali}', "");
    Expect(0, 7037, '\p{bali}', "");
    Expect(1, 7037, '\p{^bali}', "");
    Expect(1, 7037, '\P{bali}', "");
    Expect(0, 7037, '\P{^bali}', "");
    Expect(1, 7036, '\p{_Bali}', "");
    Expect(0, 7036, '\p{^_Bali}', "");
    Expect(0, 7036, '\P{_Bali}', "");
    Expect(1, 7036, '\P{^_Bali}', "");
    Expect(0, 7037, '\p{_Bali}', "");
    Expect(1, 7037, '\p{^_Bali}', "");
    Expect(1, 7037, '\P{_Bali}', "");
    Expect(0, 7037, '\P{^_Bali}', "");
    Error('\p{__is_bali:=}');
    Error('\P{__is_bali:=}');
    Expect(1, 7036, '\p{isbali}', "");
    Expect(0, 7036, '\p{^isbali}', "");
    Expect(0, 7036, '\P{isbali}', "");
    Expect(1, 7036, '\P{^isbali}', "");
    Expect(0, 7037, '\p{isbali}', "");
    Expect(1, 7037, '\p{^isbali}', "");
    Expect(1, 7037, '\P{isbali}', "");
    Expect(0, 7037, '\P{^isbali}', "");
    Expect(1, 7036, '\p{  Is_bali}', "");
    Expect(0, 7036, '\p{^  Is_bali}', "");
    Expect(0, 7036, '\P{  Is_bali}', "");
    Expect(1, 7036, '\P{^  Is_bali}', "");
    Expect(0, 7037, '\p{  Is_bali}', "");
    Expect(1, 7037, '\p{^  Is_bali}', "");
    Expect(1, 7037, '\P{  Is_bali}', "");
    Expect(0, 7037, '\P{^  Is_bali}', "");
    Error('\p{:=  Bamum}');
    Error('\P{:=  Bamum}');
    Expect(1, 92728, '\p{bamum}', "");
    Expect(0, 92728, '\p{^bamum}', "");
    Expect(0, 92728, '\P{bamum}', "");
    Expect(1, 92728, '\P{^bamum}', "");
    Expect(0, 92729, '\p{bamum}', "");
    Expect(1, 92729, '\p{^bamum}', "");
    Expect(1, 92729, '\P{bamum}', "");
    Expect(0, 92729, '\P{^bamum}', "");
    Expect(1, 92728, '\p{_-BAMUM}', "");
    Expect(0, 92728, '\p{^_-BAMUM}', "");
    Expect(0, 92728, '\P{_-BAMUM}', "");
    Expect(1, 92728, '\P{^_-BAMUM}', "");
    Expect(0, 92729, '\p{_-BAMUM}', "");
    Expect(1, 92729, '\p{^_-BAMUM}', "");
    Expect(1, 92729, '\P{_-BAMUM}', "");
    Expect(0, 92729, '\P{^_-BAMUM}', "");
    Error('\p{	 Is_BAMUM/a/}');
    Error('\P{	 Is_BAMUM/a/}');
    Expect(1, 92728, '\p{isbamum}', "");
    Expect(0, 92728, '\p{^isbamum}', "");
    Expect(0, 92728, '\P{isbamum}', "");
    Expect(1, 92728, '\P{^isbamum}', "");
    Expect(0, 92729, '\p{isbamum}', "");
    Expect(1, 92729, '\p{^isbamum}', "");
    Expect(1, 92729, '\P{isbamum}', "");
    Expect(0, 92729, '\P{^isbamum}', "");
    Expect(1, 92728, '\p{is_Bamum}', "");
    Expect(0, 92728, '\p{^is_Bamum}', "");
    Expect(0, 92728, '\P{is_Bamum}', "");
    Expect(1, 92728, '\P{^is_Bamum}', "");
    Expect(0, 92729, '\p{is_Bamum}', "");
    Expect(1, 92729, '\p{^is_Bamum}', "");
    Expect(1, 92729, '\P{is_Bamum}', "");
    Expect(0, 92729, '\P{^is_Bamum}', "");
    Error('\p{  Bamu:=}');
    Error('\P{  Bamu:=}');
    Expect(1, 92728, '\p{bamu}', "");
    Expect(0, 92728, '\p{^bamu}', "");
    Expect(0, 92728, '\P{bamu}', "");
    Expect(1, 92728, '\P{^bamu}', "");
    Expect(0, 92729, '\p{bamu}', "");
    Expect(1, 92729, '\p{^bamu}', "");
    Expect(1, 92729, '\P{bamu}', "");
    Expect(0, 92729, '\P{^bamu}', "");
    Expect(1, 92728, '\p{ Bamu}', "");
    Expect(0, 92728, '\p{^ Bamu}', "");
    Expect(0, 92728, '\P{ Bamu}', "");
    Expect(1, 92728, '\P{^ Bamu}', "");
    Expect(0, 92729, '\p{ Bamu}', "");
    Expect(1, 92729, '\p{^ Bamu}', "");
    Expect(1, 92729, '\P{ Bamu}', "");
    Expect(0, 92729, '\P{^ Bamu}', "");
    Error('\p{ :=IS_BAMU}');
    Error('\P{ :=IS_BAMU}');
    Expect(1, 92728, '\p{isbamu}', "");
    Expect(0, 92728, '\p{^isbamu}', "");
    Expect(0, 92728, '\P{isbamu}', "");
    Expect(1, 92728, '\P{^isbamu}', "");
    Expect(0, 92729, '\p{isbamu}', "");
    Expect(1, 92729, '\p{^isbamu}', "");
    Expect(1, 92729, '\P{isbamu}', "");
    Expect(0, 92729, '\P{^isbamu}', "");
    Expect(1, 92728, '\p{-	is_BAMU}', "");
    Expect(0, 92728, '\p{^-	is_BAMU}', "");
    Expect(0, 92728, '\P{-	is_BAMU}', "");
    Expect(1, 92728, '\P{^-	is_BAMU}', "");
    Expect(0, 92729, '\p{-	is_BAMU}', "");
    Expect(1, 92729, '\p{^-	is_BAMU}', "");
    Expect(1, 92729, '\P{-	is_BAMU}', "");
    Expect(0, 92729, '\P{^-	is_BAMU}', "");
    Error('\p{ 	Bamum_Supplement/a/}');
    Error('\P{ 	Bamum_Supplement/a/}');
    Expect(1, 92735, '\p{bamumsupplement}', "");
    Expect(0, 92735, '\p{^bamumsupplement}', "");
    Expect(0, 92735, '\P{bamumsupplement}', "");
    Expect(1, 92735, '\P{^bamumsupplement}', "");
    Expect(0, 92736, '\p{bamumsupplement}', "");
    Expect(1, 92736, '\p{^bamumsupplement}', "");
    Expect(1, 92736, '\P{bamumsupplement}', "");
    Expect(0, 92736, '\P{^bamumsupplement}', "");
    Expect(1, 92735, '\p{bamum_Supplement}', "");
    Expect(0, 92735, '\p{^bamum_Supplement}', "");
    Expect(0, 92735, '\P{bamum_Supplement}', "");
    Expect(1, 92735, '\P{^bamum_Supplement}', "");
    Expect(0, 92736, '\p{bamum_Supplement}', "");
    Expect(1, 92736, '\p{^bamum_Supplement}', "");
    Expect(1, 92736, '\P{bamum_Supplement}', "");
    Expect(0, 92736, '\P{^bamum_Supplement}', "");
    Error('\p{ _Is_bamum_Supplement:=}');
    Error('\P{ _Is_bamum_Supplement:=}');
    Expect(1, 92735, '\p{isbamumsupplement}', "");
    Expect(0, 92735, '\p{^isbamumsupplement}', "");
    Expect(0, 92735, '\P{isbamumsupplement}', "");
    Expect(1, 92735, '\P{^isbamumsupplement}', "");
    Expect(0, 92736, '\p{isbamumsupplement}', "");
    Expect(1, 92736, '\p{^isbamumsupplement}', "");
    Expect(1, 92736, '\P{isbamumsupplement}', "");
    Expect(0, 92736, '\P{^isbamumsupplement}', "");
    Expect(1, 92735, '\p{ -is_Bamum_Supplement}', "");
    Expect(0, 92735, '\p{^ -is_Bamum_Supplement}', "");
    Expect(0, 92735, '\P{ -is_Bamum_Supplement}', "");
    Expect(1, 92735, '\P{^ -is_Bamum_Supplement}', "");
    Expect(0, 92736, '\p{ -is_Bamum_Supplement}', "");
    Expect(1, 92736, '\p{^ -is_Bamum_Supplement}', "");
    Expect(1, 92736, '\P{ -is_Bamum_Supplement}', "");
    Expect(0, 92736, '\P{^ -is_Bamum_Supplement}', "");
    Error('\p{/a/ IN_Bamum_SUPPLEMENT}');
    Error('\P{/a/ IN_Bamum_SUPPLEMENT}');
    Expect(1, 92735, '\p{inbamumsupplement}', "");
    Expect(0, 92735, '\p{^inbamumsupplement}', "");
    Expect(0, 92735, '\P{inbamumsupplement}', "");
    Expect(1, 92735, '\P{^inbamumsupplement}', "");
    Expect(0, 92736, '\p{inbamumsupplement}', "");
    Expect(1, 92736, '\p{^inbamumsupplement}', "");
    Expect(1, 92736, '\P{inbamumsupplement}', "");
    Expect(0, 92736, '\P{^inbamumsupplement}', "");
    Expect(1, 92735, '\p{ 	IN_Bamum_supplement}', "");
    Expect(0, 92735, '\p{^ 	IN_Bamum_supplement}', "");
    Expect(0, 92735, '\P{ 	IN_Bamum_supplement}', "");
    Expect(1, 92735, '\P{^ 	IN_Bamum_supplement}', "");
    Expect(0, 92736, '\p{ 	IN_Bamum_supplement}', "");
    Expect(1, 92736, '\p{^ 	IN_Bamum_supplement}', "");
    Expect(1, 92736, '\P{ 	IN_Bamum_supplement}', "");
    Expect(0, 92736, '\P{^ 	IN_Bamum_supplement}', "");
    Error('\p{	Bamum_Sup/a/}');
    Error('\P{	Bamum_Sup/a/}');
    Expect(1, 92735, '\p{bamumsup}', "");
    Expect(0, 92735, '\p{^bamumsup}', "");
    Expect(0, 92735, '\P{bamumsup}', "");
    Expect(1, 92735, '\P{^bamumsup}', "");
    Expect(0, 92736, '\p{bamumsup}', "");
    Expect(1, 92736, '\p{^bamumsup}', "");
    Expect(1, 92736, '\P{bamumsup}', "");
    Expect(0, 92736, '\P{^bamumsup}', "");
    Expect(1, 92735, '\p{ _Bamum_Sup}', "");
    Expect(0, 92735, '\p{^ _Bamum_Sup}', "");
    Expect(0, 92735, '\P{ _Bamum_Sup}', "");
    Expect(1, 92735, '\P{^ _Bamum_Sup}', "");
    Expect(0, 92736, '\p{ _Bamum_Sup}', "");
    Expect(1, 92736, '\p{^ _Bamum_Sup}', "");
    Expect(1, 92736, '\P{ _Bamum_Sup}', "");
    Expect(0, 92736, '\P{^ _Bamum_Sup}', "");
    Error('\p{ is_Bamum_sup/a/}');
    Error('\P{ is_Bamum_sup/a/}');
    Expect(1, 92735, '\p{isbamumsup}', "");
    Expect(0, 92735, '\p{^isbamumsup}', "");
    Expect(0, 92735, '\P{isbamumsup}', "");
    Expect(1, 92735, '\P{^isbamumsup}', "");
    Expect(0, 92736, '\p{isbamumsup}', "");
    Expect(1, 92736, '\p{^isbamumsup}', "");
    Expect(1, 92736, '\P{isbamumsup}', "");
    Expect(0, 92736, '\P{^isbamumsup}', "");
    Expect(1, 92735, '\p{		is_bamum_Sup}', "");
    Expect(0, 92735, '\p{^		is_bamum_Sup}', "");
    Expect(0, 92735, '\P{		is_bamum_Sup}', "");
    Expect(1, 92735, '\P{^		is_bamum_Sup}', "");
    Expect(0, 92736, '\p{		is_bamum_Sup}', "");
    Expect(1, 92736, '\p{^		is_bamum_Sup}', "");
    Expect(1, 92736, '\P{		is_bamum_Sup}', "");
    Expect(0, 92736, '\P{^		is_bamum_Sup}', "");
    Error('\p{:=- IN_Bamum_SUP}');
    Error('\P{:=- IN_Bamum_SUP}');
    Expect(1, 92735, '\p{inbamumsup}', "");
    Expect(0, 92735, '\p{^inbamumsup}', "");
    Expect(0, 92735, '\P{inbamumsup}', "");
    Expect(1, 92735, '\P{^inbamumsup}', "");
    Expect(0, 92736, '\p{inbamumsup}', "");
    Expect(1, 92736, '\p{^inbamumsup}', "");
    Expect(1, 92736, '\P{inbamumsup}', "");
    Expect(0, 92736, '\P{^inbamumsup}', "");
    Expect(1, 92735, '\p{-_In_Bamum_Sup}', "");
    Expect(0, 92735, '\p{^-_In_Bamum_Sup}', "");
    Expect(0, 92735, '\P{-_In_Bamum_Sup}', "");
    Expect(1, 92735, '\P{^-_In_Bamum_Sup}', "");
    Expect(0, 92736, '\p{-_In_Bamum_Sup}', "");
    Expect(1, 92736, '\p{^-_In_Bamum_Sup}', "");
    Expect(1, 92736, '\P{-_In_Bamum_Sup}', "");
    Expect(0, 92736, '\P{^-_In_Bamum_Sup}', "");
    Error('\p{ _bassa_Vah:=}');
    Error('\P{ _bassa_Vah:=}');
    Expect(1, 92917, '\p{bassavah}', "");
    Expect(0, 92917, '\p{^bassavah}', "");
    Expect(0, 92917, '\P{bassavah}', "");
    Expect(1, 92917, '\P{^bassavah}', "");
    Expect(0, 92918, '\p{bassavah}', "");
    Expect(1, 92918, '\p{^bassavah}', "");
    Expect(1, 92918, '\P{bassavah}', "");
    Expect(0, 92918, '\P{^bassavah}', "");
    Expect(1, 92917, '\p{_ Bassa_VAH}', "");
    Expect(0, 92917, '\p{^_ Bassa_VAH}', "");
    Expect(0, 92917, '\P{_ Bassa_VAH}', "");
    Expect(1, 92917, '\P{^_ Bassa_VAH}', "");
    Expect(0, 92918, '\p{_ Bassa_VAH}', "");
    Expect(1, 92918, '\p{^_ Bassa_VAH}', "");
    Expect(1, 92918, '\P{_ Bassa_VAH}', "");
    Expect(0, 92918, '\P{^_ Bassa_VAH}', "");
    Error('\p{/a/	-Is_Bassa_Vah}');
    Error('\P{/a/	-Is_Bassa_Vah}');
    Expect(1, 92917, '\p{isbassavah}', "");
    Expect(0, 92917, '\p{^isbassavah}', "");
    Expect(0, 92917, '\P{isbassavah}', "");
    Expect(1, 92917, '\P{^isbassavah}', "");
    Expect(0, 92918, '\p{isbassavah}', "");
    Expect(1, 92918, '\p{^isbassavah}', "");
    Expect(1, 92918, '\P{isbassavah}', "");
    Expect(0, 92918, '\P{^isbassavah}', "");
    Expect(1, 92917, '\p{_	Is_Bassa_VAH}', "");
    Expect(0, 92917, '\p{^_	Is_Bassa_VAH}', "");
    Expect(0, 92917, '\P{_	Is_Bassa_VAH}', "");
    Expect(1, 92917, '\P{^_	Is_Bassa_VAH}', "");
    Expect(0, 92918, '\p{_	Is_Bassa_VAH}', "");
    Expect(1, 92918, '\p{^_	Is_Bassa_VAH}', "");
    Expect(1, 92918, '\P{_	Is_Bassa_VAH}', "");
    Expect(0, 92918, '\P{^_	Is_Bassa_VAH}', "");
    Error('\p{-:=BASS}');
    Error('\P{-:=BASS}');
    Expect(1, 92917, '\p{bass}', "");
    Expect(0, 92917, '\p{^bass}', "");
    Expect(0, 92917, '\P{bass}', "");
    Expect(1, 92917, '\P{^bass}', "");
    Expect(0, 92918, '\p{bass}', "");
    Expect(1, 92918, '\p{^bass}', "");
    Expect(1, 92918, '\P{bass}', "");
    Expect(0, 92918, '\P{^bass}', "");
    Expect(1, 92917, '\p{_ BASS}', "");
    Expect(0, 92917, '\p{^_ BASS}', "");
    Expect(0, 92917, '\P{_ BASS}', "");
    Expect(1, 92917, '\P{^_ BASS}', "");
    Expect(0, 92918, '\p{_ BASS}', "");
    Expect(1, 92918, '\p{^_ BASS}', "");
    Expect(1, 92918, '\P{_ BASS}', "");
    Expect(0, 92918, '\P{^_ BASS}', "");
    Error('\p{/a/ Is_Bass}');
    Error('\P{/a/ Is_Bass}');
    Expect(1, 92917, '\p{isbass}', "");
    Expect(0, 92917, '\p{^isbass}', "");
    Expect(0, 92917, '\P{isbass}', "");
    Expect(1, 92917, '\P{^isbass}', "");
    Expect(0, 92918, '\p{isbass}', "");
    Expect(1, 92918, '\p{^isbass}', "");
    Expect(1, 92918, '\P{isbass}', "");
    Expect(0, 92918, '\P{^isbass}', "");
    Expect(1, 92917, '\p{ IS_bass}', "");
    Expect(0, 92917, '\p{^ IS_bass}', "");
    Expect(0, 92917, '\P{ IS_bass}', "");
    Expect(1, 92917, '\P{^ IS_bass}', "");
    Expect(0, 92918, '\p{ IS_bass}', "");
    Expect(1, 92918, '\p{^ IS_bass}', "");
    Expect(1, 92918, '\P{ IS_bass}', "");
    Expect(0, 92918, '\P{^ IS_bass}', "");
    Error('\p{	:=Batak}');
    Error('\P{	:=Batak}');
    Expect(1, 7167, '\p{batak}', "");
    Expect(0, 7167, '\p{^batak}', "");
    Expect(0, 7167, '\P{batak}', "");
    Expect(1, 7167, '\P{^batak}', "");
    Expect(0, 7168, '\p{batak}', "");
    Expect(1, 7168, '\p{^batak}', "");
    Expect(1, 7168, '\P{batak}', "");
    Expect(0, 7168, '\P{^batak}', "");
    Expect(1, 7167, '\p{ batak}', "");
    Expect(0, 7167, '\p{^ batak}', "");
    Expect(0, 7167, '\P{ batak}', "");
    Expect(1, 7167, '\P{^ batak}', "");
    Expect(0, 7168, '\p{ batak}', "");
    Expect(1, 7168, '\p{^ batak}', "");
    Expect(1, 7168, '\P{ batak}', "");
    Expect(0, 7168, '\P{^ batak}', "");
    Error('\p{/a/-is_batak}');
    Error('\P{/a/-is_batak}');
    Expect(1, 7167, '\p{isbatak}', "");
    Expect(0, 7167, '\p{^isbatak}', "");
    Expect(0, 7167, '\P{isbatak}', "");
    Expect(1, 7167, '\P{^isbatak}', "");
    Expect(0, 7168, '\p{isbatak}', "");
    Expect(1, 7168, '\p{^isbatak}', "");
    Expect(1, 7168, '\P{isbatak}', "");
    Expect(0, 7168, '\P{^isbatak}', "");
    Expect(1, 7167, '\p{_ IS_batak}', "");
    Expect(0, 7167, '\p{^_ IS_batak}', "");
    Expect(0, 7167, '\P{_ IS_batak}', "");
    Expect(1, 7167, '\P{^_ IS_batak}', "");
    Expect(0, 7168, '\p{_ IS_batak}', "");
    Expect(1, 7168, '\p{^_ IS_batak}', "");
    Expect(1, 7168, '\P{_ IS_batak}', "");
    Expect(0, 7168, '\P{^_ IS_batak}', "");
    Error('\p{:= _batk}');
    Error('\P{:= _batk}');
    Expect(1, 7167, '\p{batk}', "");
    Expect(0, 7167, '\p{^batk}', "");
    Expect(0, 7167, '\P{batk}', "");
    Expect(1, 7167, '\P{^batk}', "");
    Expect(0, 7168, '\p{batk}', "");
    Expect(1, 7168, '\p{^batk}', "");
    Expect(1, 7168, '\P{batk}', "");
    Expect(0, 7168, '\P{^batk}', "");
    Expect(1, 7167, '\p{ BATK}', "");
    Expect(0, 7167, '\p{^ BATK}', "");
    Expect(0, 7167, '\P{ BATK}', "");
    Expect(1, 7167, '\P{^ BATK}', "");
    Expect(0, 7168, '\p{ BATK}', "");
    Expect(1, 7168, '\p{^ BATK}', "");
    Expect(1, 7168, '\P{ BATK}', "");
    Expect(0, 7168, '\P{^ BATK}', "");
    Error('\p{ is_Batk:=}');
    Error('\P{ is_Batk:=}');
    Expect(1, 7167, '\p{isbatk}', "");
    Expect(0, 7167, '\p{^isbatk}', "");
    Expect(0, 7167, '\P{isbatk}', "");
    Expect(1, 7167, '\P{^isbatk}', "");
    Expect(0, 7168, '\p{isbatk}', "");
    Expect(1, 7168, '\p{^isbatk}', "");
    Expect(1, 7168, '\P{isbatk}', "");
    Expect(0, 7168, '\P{^isbatk}', "");
    Expect(1, 7167, '\p{ _Is_BATK}', "");
    Expect(0, 7167, '\p{^ _Is_BATK}', "");
    Expect(0, 7167, '\P{ _Is_BATK}', "");
    Expect(1, 7167, '\P{^ _Is_BATK}', "");
    Expect(0, 7168, '\p{ _Is_BATK}', "");
    Expect(1, 7168, '\p{^ _Is_BATK}', "");
    Expect(1, 7168, '\P{ _Is_BATK}', "");
    Expect(0, 7168, '\P{^ _Is_BATK}', "");
    Error('\p{_/a/Bengali}');
    Error('\P{_/a/Bengali}');
    Expect(1, 43249, '\p{bengali}', "");
    Expect(0, 43249, '\p{^bengali}', "");
    Expect(0, 43249, '\P{bengali}', "");
    Expect(1, 43249, '\P{^bengali}', "");
    Expect(0, 43250, '\p{bengali}', "");
    Expect(1, 43250, '\p{^bengali}', "");
    Expect(1, 43250, '\P{bengali}', "");
    Expect(0, 43250, '\P{^bengali}', "");
    Expect(1, 43249, '\p{--Bengali}', "");
    Expect(0, 43249, '\p{^--Bengali}', "");
    Expect(0, 43249, '\P{--Bengali}', "");
    Expect(1, 43249, '\P{^--Bengali}', "");
    Expect(0, 43250, '\p{--Bengali}', "");
    Expect(1, 43250, '\p{^--Bengali}', "");
    Expect(1, 43250, '\P{--Bengali}', "");
    Expect(0, 43250, '\P{^--Bengali}', "");
    Error('\p{-:=IS_BENGALI}');
    Error('\P{-:=IS_BENGALI}');
    Expect(1, 43249, '\p{isbengali}', "");
    Expect(0, 43249, '\p{^isbengali}', "");
    Expect(0, 43249, '\P{isbengali}', "");
    Expect(1, 43249, '\P{^isbengali}', "");
    Expect(0, 43250, '\p{isbengali}', "");
    Expect(1, 43250, '\p{^isbengali}', "");
    Expect(1, 43250, '\P{isbengali}', "");
    Expect(0, 43250, '\P{^isbengali}', "");
    Expect(1, 43249, '\p{- is_Bengali}', "");
    Expect(0, 43249, '\p{^- is_Bengali}', "");
    Expect(0, 43249, '\P{- is_Bengali}', "");
    Expect(1, 43249, '\P{^- is_Bengali}', "");
    Expect(0, 43250, '\p{- is_Bengali}', "");
    Expect(1, 43250, '\p{^- is_Bengali}', "");
    Expect(1, 43250, '\P{- is_Bengali}', "");
    Expect(0, 43250, '\P{^- is_Bengali}', "");
    Error('\p{ /a/Beng}');
    Error('\P{ /a/Beng}');
    Expect(1, 43249, '\p{beng}', "");
    Expect(0, 43249, '\p{^beng}', "");
    Expect(0, 43249, '\P{beng}', "");
    Expect(1, 43249, '\P{^beng}', "");
    Expect(0, 43250, '\p{beng}', "");
    Expect(1, 43250, '\p{^beng}', "");
    Expect(1, 43250, '\P{beng}', "");
    Expect(0, 43250, '\P{^beng}', "");
    Expect(1, 43249, '\p{_Beng}', "");
    Expect(0, 43249, '\p{^_Beng}', "");
    Expect(0, 43249, '\P{_Beng}', "");
    Expect(1, 43249, '\P{^_Beng}', "");
    Expect(0, 43250, '\p{_Beng}', "");
    Expect(1, 43250, '\p{^_Beng}', "");
    Expect(1, 43250, '\P{_Beng}', "");
    Expect(0, 43250, '\P{^_Beng}', "");
    Error('\p{-Is_BENG/a/}');
    Error('\P{-Is_BENG/a/}');
    Expect(1, 43249, '\p{isbeng}', "");
    Expect(0, 43249, '\p{^isbeng}', "");
    Expect(0, 43249, '\P{isbeng}', "");
    Expect(1, 43249, '\P{^isbeng}', "");
    Expect(0, 43250, '\p{isbeng}', "");
    Expect(1, 43250, '\p{^isbeng}', "");
    Expect(1, 43250, '\P{isbeng}', "");
    Expect(0, 43250, '\P{^isbeng}', "");
    Expect(1, 43249, '\p{ _IS_Beng}', "");
    Expect(0, 43249, '\p{^ _IS_Beng}', "");
    Expect(0, 43249, '\P{ _IS_Beng}', "");
    Expect(1, 43249, '\P{^ _IS_Beng}', "");
    Expect(0, 43250, '\p{ _IS_Beng}', "");
    Expect(1, 43250, '\p{^ _IS_Beng}', "");
    Expect(1, 43250, '\P{ _IS_Beng}', "");
    Expect(0, 43250, '\P{^ _IS_Beng}', "");
    Error('\p{ :=Bhaiksuki}');
    Error('\P{ :=Bhaiksuki}');
    Expect(1, 72812, '\p{bhaiksuki}', "");
    Expect(0, 72812, '\p{^bhaiksuki}', "");
    Expect(0, 72812, '\P{bhaiksuki}', "");
    Expect(1, 72812, '\P{^bhaiksuki}', "");
    Expect(0, 72813, '\p{bhaiksuki}', "");
    Expect(1, 72813, '\p{^bhaiksuki}', "");
    Expect(1, 72813, '\P{bhaiksuki}', "");
    Expect(0, 72813, '\P{^bhaiksuki}', "");
    Expect(1, 72812, '\p{_bhaiksuki}', "");
    Expect(0, 72812, '\p{^_bhaiksuki}', "");
    Expect(0, 72812, '\P{_bhaiksuki}', "");
    Expect(1, 72812, '\P{^_bhaiksuki}', "");
    Expect(0, 72813, '\p{_bhaiksuki}', "");
    Expect(1, 72813, '\p{^_bhaiksuki}', "");
    Expect(1, 72813, '\P{_bhaiksuki}', "");
    Expect(0, 72813, '\P{^_bhaiksuki}', "");
    Error('\p{	/a/Is_Bhaiksuki}');
    Error('\P{	/a/Is_Bhaiksuki}');
    Expect(1, 72812, '\p{isbhaiksuki}', "");
    Expect(0, 72812, '\p{^isbhaiksuki}', "");
    Expect(0, 72812, '\P{isbhaiksuki}', "");
    Expect(1, 72812, '\P{^isbhaiksuki}', "");
    Expect(0, 72813, '\p{isbhaiksuki}', "");
    Expect(1, 72813, '\p{^isbhaiksuki}', "");
    Expect(1, 72813, '\P{isbhaiksuki}', "");
    Expect(0, 72813, '\P{^isbhaiksuki}', "");
    Expect(1, 72812, '\p{	Is_bhaiksuki}', "");
    Expect(0, 72812, '\p{^	Is_bhaiksuki}', "");
    Expect(0, 72812, '\P{	Is_bhaiksuki}', "");
    Expect(1, 72812, '\P{^	Is_bhaiksuki}', "");
    Expect(0, 72813, '\p{	Is_bhaiksuki}', "");
    Expect(1, 72813, '\p{^	Is_bhaiksuki}', "");
    Expect(1, 72813, '\P{	Is_bhaiksuki}', "");
    Expect(0, 72813, '\P{^	Is_bhaiksuki}', "");
    Error('\p{/a/	BHKS}');
    Error('\P{/a/	BHKS}');
    Expect(1, 72812, '\p{bhks}', "");
    Expect(0, 72812, '\p{^bhks}', "");
    Expect(0, 72812, '\P{bhks}', "");
    Expect(1, 72812, '\P{^bhks}', "");
    Expect(0, 72813, '\p{bhks}', "");
    Expect(1, 72813, '\p{^bhks}', "");
    Expect(1, 72813, '\P{bhks}', "");
    Expect(0, 72813, '\P{^bhks}', "");
    Expect(1, 72812, '\p{_Bhks}', "");
    Expect(0, 72812, '\p{^_Bhks}', "");
    Expect(0, 72812, '\P{_Bhks}', "");
    Expect(1, 72812, '\P{^_Bhks}', "");
    Expect(0, 72813, '\p{_Bhks}', "");
    Expect(1, 72813, '\p{^_Bhks}', "");
    Expect(1, 72813, '\P{_Bhks}', "");
    Expect(0, 72813, '\P{^_Bhks}', "");
    Error('\p{ /a/is_Bhks}');
    Error('\P{ /a/is_Bhks}');
    Expect(1, 72812, '\p{isbhks}', "");
    Expect(0, 72812, '\p{^isbhks}', "");
    Expect(0, 72812, '\P{isbhks}', "");
    Expect(1, 72812, '\P{^isbhks}', "");
    Expect(0, 72813, '\p{isbhks}', "");
    Expect(1, 72813, '\p{^isbhks}', "");
    Expect(1, 72813, '\P{isbhks}', "");
    Expect(0, 72813, '\P{^isbhks}', "");
    Expect(1, 72812, '\p{		is_bhks}', "");
    Expect(0, 72812, '\p{^		is_bhks}', "");
    Expect(0, 72812, '\P{		is_bhks}', "");
    Expect(1, 72812, '\P{^		is_bhks}', "");
    Expect(0, 72813, '\p{		is_bhks}', "");
    Expect(1, 72813, '\p{^		is_bhks}', "");
    Expect(1, 72813, '\P{		is_bhks}', "");
    Expect(0, 72813, '\P{^		is_bhks}', "");
    Error('\p{/a/ Bidi_control}');
    Error('\P{/a/ Bidi_control}');
    Expect(1, 8297, '\p{bidicontrol}', "");
    Expect(0, 8297, '\p{^bidicontrol}', "");
    Expect(0, 8297, '\P{bidicontrol}', "");
    Expect(1, 8297, '\P{^bidicontrol}', "");
    Expect(0, 8298, '\p{bidicontrol}', "");
    Expect(1, 8298, '\p{^bidicontrol}', "");
    Expect(1, 8298, '\P{bidicontrol}', "");
    Expect(0, 8298, '\P{^bidicontrol}', "");
    Expect(1, 8297, '\p{ _bidi_control}', "");
    Expect(0, 8297, '\p{^ _bidi_control}', "");
    Expect(0, 8297, '\P{ _bidi_control}', "");
    Expect(1, 8297, '\P{^ _bidi_control}', "");
    Expect(0, 8298, '\p{ _bidi_control}', "");
    Expect(1, 8298, '\p{^ _bidi_control}', "");
    Expect(1, 8298, '\P{ _bidi_control}', "");
    Expect(0, 8298, '\P{^ _bidi_control}', "");
    Error('\p{-IS_bidi_Control/a/}');
    Error('\P{-IS_bidi_Control/a/}');
    Expect(1, 8297, '\p{isbidicontrol}', "");
    Expect(0, 8297, '\p{^isbidicontrol}', "");
    Expect(0, 8297, '\P{isbidicontrol}', "");
    Expect(1, 8297, '\P{^isbidicontrol}', "");
    Expect(0, 8298, '\p{isbidicontrol}', "");
    Expect(1, 8298, '\p{^isbidicontrol}', "");
    Expect(1, 8298, '\P{isbidicontrol}', "");
    Expect(0, 8298, '\P{^isbidicontrol}', "");
    Expect(1, 8297, '\p{_	Is_Bidi_CONTROL}', "");
    Expect(0, 8297, '\p{^_	Is_Bidi_CONTROL}', "");
    Expect(0, 8297, '\P{_	Is_Bidi_CONTROL}', "");
    Expect(1, 8297, '\P{^_	Is_Bidi_CONTROL}', "");
    Expect(0, 8298, '\p{_	Is_Bidi_CONTROL}', "");
    Expect(1, 8298, '\p{^_	Is_Bidi_CONTROL}', "");
    Expect(1, 8298, '\P{_	Is_Bidi_CONTROL}', "");
    Expect(0, 8298, '\P{^_	Is_Bidi_CONTROL}', "");
    Error('\p{:= _BIDI_c}');
    Error('\P{:= _BIDI_c}');
    Expect(1, 8297, '\p{bidic}', "");
    Expect(0, 8297, '\p{^bidic}', "");
    Expect(0, 8297, '\P{bidic}', "");
    Expect(1, 8297, '\P{^bidic}', "");
    Expect(0, 8298, '\p{bidic}', "");
    Expect(1, 8298, '\p{^bidic}', "");
    Expect(1, 8298, '\P{bidic}', "");
    Expect(0, 8298, '\P{^bidic}', "");
    Expect(1, 8297, '\p{ -BIDI_C}', "");
    Expect(0, 8297, '\p{^ -BIDI_C}', "");
    Expect(0, 8297, '\P{ -BIDI_C}', "");
    Expect(1, 8297, '\P{^ -BIDI_C}', "");
    Expect(0, 8298, '\p{ -BIDI_C}', "");
    Expect(1, 8298, '\p{^ -BIDI_C}', "");
    Expect(1, 8298, '\P{ -BIDI_C}', "");
    Expect(0, 8298, '\P{^ -BIDI_C}', "");
    Error('\p{ Is_Bidi_C:=}');
    Error('\P{ Is_Bidi_C:=}');
    Expect(1, 8297, '\p{isbidic}', "");
    Expect(0, 8297, '\p{^isbidic}', "");
    Expect(0, 8297, '\P{isbidic}', "");
    Expect(1, 8297, '\P{^isbidic}', "");
    Expect(0, 8298, '\p{isbidic}', "");
    Expect(1, 8298, '\p{^isbidic}', "");
    Expect(1, 8298, '\P{isbidic}', "");
    Expect(0, 8298, '\P{^isbidic}', "");
    Expect(1, 8297, '\p{-_Is_Bidi_C}', "");
    Expect(0, 8297, '\p{^-_Is_Bidi_C}', "");
    Expect(0, 8297, '\P{-_Is_Bidi_C}', "");
    Expect(1, 8297, '\P{^-_Is_Bidi_C}', "");
    Expect(0, 8298, '\p{-_Is_Bidi_C}', "");
    Expect(1, 8298, '\p{^-_Is_Bidi_C}', "");
    Expect(1, 8298, '\P{-_Is_Bidi_C}', "");
    Expect(0, 8298, '\P{^-_Is_Bidi_C}', "");
    Error('\p{	/a/bidi_MIRRORED}');
    Error('\P{	/a/bidi_MIRRORED}');
    Expect(1, 120771, '\p{bidimirrored}', "");
    Expect(0, 120771, '\p{^bidimirrored}', "");
    Expect(0, 120771, '\P{bidimirrored}', "");
    Expect(1, 120771, '\P{^bidimirrored}', "");
    Expect(0, 120772, '\p{bidimirrored}', "");
    Expect(1, 120772, '\p{^bidimirrored}', "");
    Expect(1, 120772, '\P{bidimirrored}', "");
    Expect(0, 120772, '\P{^bidimirrored}', "");
    Expect(1, 120771, '\p{-Bidi_mirrored}', "");
    Expect(0, 120771, '\p{^-Bidi_mirrored}', "");
    Expect(0, 120771, '\P{-Bidi_mirrored}', "");
    Expect(1, 120771, '\P{^-Bidi_mirrored}', "");
    Expect(0, 120772, '\p{-Bidi_mirrored}', "");
    Expect(1, 120772, '\p{^-Bidi_mirrored}', "");
    Expect(1, 120772, '\P{-Bidi_mirrored}', "");
    Expect(0, 120772, '\P{^-Bidi_mirrored}', "");
    Error('\p{:=_is_Bidi_Mirrored}');
    Error('\P{:=_is_Bidi_Mirrored}');
    Expect(1, 120771, '\p{isbidimirrored}', "");
    Expect(0, 120771, '\p{^isbidimirrored}', "");
    Expect(0, 120771, '\P{isbidimirrored}', "");
    Expect(1, 120771, '\P{^isbidimirrored}', "");
    Expect(0, 120772, '\p{isbidimirrored}', "");
    Expect(1, 120772, '\p{^isbidimirrored}', "");
    Expect(1, 120772, '\P{isbidimirrored}', "");
    Expect(0, 120772, '\P{^isbidimirrored}', "");
    Expect(1, 120771, '\p{ -is_BIDI_mirrored}', "");
    Expect(0, 120771, '\p{^ -is_BIDI_mirrored}', "");
    Expect(0, 120771, '\P{ -is_BIDI_mirrored}', "");
    Expect(1, 120771, '\P{^ -is_BIDI_mirrored}', "");
    Expect(0, 120772, '\p{ -is_BIDI_mirrored}', "");
    Expect(1, 120772, '\p{^ -is_BIDI_mirrored}', "");
    Expect(1, 120772, '\P{ -is_BIDI_mirrored}', "");
    Expect(0, 120772, '\P{^ -is_BIDI_mirrored}', "");
    Error('\p{-:=bidi_M}');
    Error('\P{-:=bidi_M}');
    Expect(1, 120771, '\p{bidim}', "");
    Expect(0, 120771, '\p{^bidim}', "");
    Expect(0, 120771, '\P{bidim}', "");
    Expect(1, 120771, '\P{^bidim}', "");
    Expect(0, 120772, '\p{bidim}', "");
    Expect(1, 120772, '\p{^bidim}', "");
    Expect(1, 120772, '\P{bidim}', "");
    Expect(0, 120772, '\P{^bidim}', "");
    Expect(1, 120771, '\p{-	Bidi_M}', "");
    Expect(0, 120771, '\p{^-	Bidi_M}', "");
    Expect(0, 120771, '\P{-	Bidi_M}', "");
    Expect(1, 120771, '\P{^-	Bidi_M}', "");
    Expect(0, 120772, '\p{-	Bidi_M}', "");
    Expect(1, 120772, '\p{^-	Bidi_M}', "");
    Expect(1, 120772, '\P{-	Bidi_M}', "");
    Expect(0, 120772, '\P{^-	Bidi_M}', "");
    Error('\p{__Is_bidi_M:=}');
    Error('\P{__Is_bidi_M:=}');
    Expect(1, 120771, '\p{isbidim}', "");
    Expect(0, 120771, '\p{^isbidim}', "");
    Expect(0, 120771, '\P{isbidim}', "");
    Expect(1, 120771, '\P{^isbidim}', "");
    Expect(0, 120772, '\p{isbidim}', "");
    Expect(1, 120772, '\p{^isbidim}', "");
    Expect(1, 120772, '\P{isbidim}', "");
    Expect(0, 120772, '\P{^isbidim}', "");
    Expect(1, 120771, '\p{ -Is_BIDI_M}', "");
    Expect(0, 120771, '\p{^ -Is_BIDI_M}', "");
    Expect(0, 120771, '\P{ -Is_BIDI_M}', "");
    Expect(1, 120771, '\P{^ -Is_BIDI_M}', "");
    Expect(0, 120772, '\p{ -Is_BIDI_M}', "");
    Expect(1, 120772, '\p{^ -Is_BIDI_M}', "");
    Expect(1, 120772, '\P{ -Is_BIDI_M}', "");
    Expect(0, 120772, '\P{^ -Is_BIDI_M}', "");
    Error('\p{-	XPOSIXBLANK/a/}');
    Error('\P{-	XPOSIXBLANK/a/}');
    Expect(1, 12288, '\p{xposixblank}', "");
    Expect(0, 12288, '\p{^xposixblank}', "");
    Expect(0, 12288, '\P{xposixblank}', "");
    Expect(1, 12288, '\P{^xposixblank}', "");
    Expect(0, 12289, '\p{xposixblank}', "");
    Expect(1, 12289, '\p{^xposixblank}', "");
    Expect(1, 12289, '\P{xposixblank}', "");
    Expect(0, 12289, '\P{^xposixblank}', "");
    Expect(1, 12288, '\p{	_xposixblank}', "");
    Expect(0, 12288, '\p{^	_xposixblank}', "");
    Expect(0, 12288, '\P{	_xposixblank}', "");
    Expect(1, 12288, '\P{^	_xposixblank}', "");
    Expect(0, 12289, '\p{	_xposixblank}', "");
    Expect(1, 12289, '\p{^	_xposixblank}', "");
    Expect(1, 12289, '\P{	_xposixblank}', "");
    Expect(0, 12289, '\P{^	_xposixblank}', "");
    Error('\p{:=	 BLANK}');
    Error('\P{:=	 BLANK}');
    Expect(1, 12288, '\p{blank}', "");
    Expect(0, 12288, '\p{^blank}', "");
    Expect(0, 12288, '\P{blank}', "");
    Expect(1, 12288, '\P{^blank}', "");
    Expect(0, 12289, '\p{blank}', "");
    Expect(1, 12289, '\p{^blank}', "");
    Expect(1, 12289, '\P{blank}', "");
    Expect(0, 12289, '\P{^blank}', "");
    Expect(1, 12288, '\p{	-blank}', "");
    Expect(0, 12288, '\p{^	-blank}', "");
    Expect(0, 12288, '\P{	-blank}', "");
    Expect(1, 12288, '\P{^	-blank}', "");
    Expect(0, 12289, '\p{	-blank}', "");
    Expect(1, 12289, '\p{^	-blank}', "");
    Expect(1, 12289, '\P{	-blank}', "");
    Expect(0, 12289, '\P{^	-blank}', "");
    Error('\p{ /a/horizspace}');
    Error('\P{ /a/horizspace}');
    Expect(1, 12288, '\p{horizspace}', "");
    Expect(0, 12288, '\p{^horizspace}', "");
    Expect(0, 12288, '\P{horizspace}', "");
    Expect(1, 12288, '\P{^horizspace}', "");
    Expect(0, 12289, '\p{horizspace}', "");
    Expect(1, 12289, '\p{^horizspace}', "");
    Expect(1, 12289, '\P{horizspace}', "");
    Expect(0, 12289, '\P{^horizspace}', "");
    Expect(1, 12288, '\p{_HorizSpace}', "");
    Expect(0, 12288, '\p{^_HorizSpace}', "");
    Expect(0, 12288, '\P{_HorizSpace}', "");
    Expect(1, 12288, '\P{^_HorizSpace}', "");
    Expect(0, 12289, '\p{_HorizSpace}', "");
    Expect(1, 12289, '\p{^_HorizSpace}', "");
    Expect(1, 12289, '\P{_HorizSpace}', "");
    Expect(0, 12289, '\P{^_HorizSpace}', "");
    Error('\p{_/a/Is_xposixblank}');
    Error('\P{_/a/Is_xposixblank}');
    Expect(1, 12288, '\p{isxposixblank}', "");
    Expect(0, 12288, '\p{^isxposixblank}', "");
    Expect(0, 12288, '\P{isxposixblank}', "");
    Expect(1, 12288, '\P{^isxposixblank}', "");
    Expect(0, 12289, '\p{isxposixblank}', "");
    Expect(1, 12289, '\p{^isxposixblank}', "");
    Expect(1, 12289, '\P{isxposixblank}', "");
    Expect(0, 12289, '\P{^isxposixblank}', "");
    Expect(1, 12288, '\p{ Is_xposixblank}', "");
    Expect(0, 12288, '\p{^ Is_xposixblank}', "");
    Expect(0, 12288, '\P{ Is_xposixblank}', "");
    Expect(1, 12288, '\P{^ Is_xposixblank}', "");
    Expect(0, 12289, '\p{ Is_xposixblank}', "");
    Expect(1, 12289, '\p{^ Is_xposixblank}', "");
    Expect(1, 12289, '\P{ Is_xposixblank}', "");
    Expect(0, 12289, '\P{^ Is_xposixblank}', "");
    Error('\p{-:=Is_Blank}');
    Error('\P{-:=Is_Blank}');
    Expect(1, 12288, '\p{isblank}', "");
    Expect(0, 12288, '\p{^isblank}', "");
    Expect(0, 12288, '\P{isblank}', "");
    Expect(1, 12288, '\P{^isblank}', "");
    Expect(0, 12289, '\p{isblank}', "");
    Expect(1, 12289, '\p{^isblank}', "");
    Expect(1, 12289, '\P{isblank}', "");
    Expect(0, 12289, '\P{^isblank}', "");
    Expect(1, 12288, '\p{- is_blank}', "");
    Expect(0, 12288, '\p{^- is_blank}', "");
    Expect(0, 12288, '\P{- is_blank}', "");
    Expect(1, 12288, '\P{^- is_blank}', "");
    Expect(0, 12289, '\p{- is_blank}', "");
    Expect(1, 12289, '\p{^- is_blank}', "");
    Expect(1, 12289, '\P{- is_blank}', "");
    Expect(0, 12289, '\P{^- is_blank}', "");
    Error('\p{:=IS_HorizSpace}');
    Error('\P{:=IS_HorizSpace}');
    Expect(1, 12288, '\p{ishorizspace}', "");
    Expect(0, 12288, '\p{^ishorizspace}', "");
    Expect(0, 12288, '\P{ishorizspace}', "");
    Expect(1, 12288, '\P{^ishorizspace}', "");
    Expect(0, 12289, '\p{ishorizspace}', "");
    Expect(1, 12289, '\p{^ishorizspace}', "");
    Expect(1, 12289, '\P{ishorizspace}', "");
    Expect(0, 12289, '\P{^ishorizspace}', "");
    Expect(1, 12288, '\p{		Is_HORIZSPACE}', "");
    Expect(0, 12288, '\p{^		Is_HORIZSPACE}', "");
    Expect(0, 12288, '\P{		Is_HORIZSPACE}', "");
    Expect(1, 12288, '\P{^		Is_HORIZSPACE}', "");
    Expect(0, 12289, '\p{		Is_HORIZSPACE}', "");
    Expect(1, 12289, '\p{^		Is_HORIZSPACE}', "");
    Expect(1, 12289, '\P{		Is_HORIZSPACE}', "");
    Expect(0, 12289, '\P{^		Is_HORIZSPACE}', "");
    Error('\p{/a/	 Block_elements}');
    Error('\P{/a/	 Block_elements}');
    Expect(1, 9631, '\p{blockelements}', "");
    Expect(0, 9631, '\p{^blockelements}', "");
    Expect(0, 9631, '\P{blockelements}', "");
    Expect(1, 9631, '\P{^blockelements}', "");
    Expect(0, 9632, '\p{blockelements}', "");
    Expect(1, 9632, '\p{^blockelements}', "");
    Expect(1, 9632, '\P{blockelements}', "");
    Expect(0, 9632, '\P{^blockelements}', "");
    Expect(1, 9631, '\p{_block_ELEMENTS}', "");
    Expect(0, 9631, '\p{^_block_ELEMENTS}', "");
    Expect(0, 9631, '\P{_block_ELEMENTS}', "");
    Expect(1, 9631, '\P{^_block_ELEMENTS}', "");
    Expect(0, 9632, '\p{_block_ELEMENTS}', "");
    Expect(1, 9632, '\p{^_block_ELEMENTS}', "");
    Expect(1, 9632, '\P{_block_ELEMENTS}', "");
    Expect(0, 9632, '\P{^_block_ELEMENTS}', "");
    Error('\p{-:=Is_Block_Elements}');
    Error('\P{-:=Is_Block_Elements}');
    Expect(1, 9631, '\p{isblockelements}', "");
    Expect(0, 9631, '\p{^isblockelements}', "");
    Expect(0, 9631, '\P{isblockelements}', "");
    Expect(1, 9631, '\P{^isblockelements}', "");
    Expect(0, 9632, '\p{isblockelements}', "");
    Expect(1, 9632, '\p{^isblockelements}', "");
    Expect(1, 9632, '\P{isblockelements}', "");
    Expect(0, 9632, '\P{^isblockelements}', "");
    Expect(1, 9631, '\p{_Is_block_ELEMENTS}', "");
    Expect(0, 9631, '\p{^_Is_block_ELEMENTS}', "");
    Expect(0, 9631, '\P{_Is_block_ELEMENTS}', "");
    Expect(1, 9631, '\P{^_Is_block_ELEMENTS}', "");
    Expect(0, 9632, '\p{_Is_block_ELEMENTS}', "");
    Expect(1, 9632, '\p{^_Is_block_ELEMENTS}', "");
    Expect(1, 9632, '\P{_Is_block_ELEMENTS}', "");
    Expect(0, 9632, '\P{^_Is_block_ELEMENTS}', "");
    Error('\p{ 	In_BLOCK_Elements/a/}');
    Error('\P{ 	In_BLOCK_Elements/a/}');
    Expect(1, 9631, '\p{inblockelements}', "");
    Expect(0, 9631, '\p{^inblockelements}', "");
    Expect(0, 9631, '\P{inblockelements}', "");
    Expect(1, 9631, '\P{^inblockelements}', "");
    Expect(0, 9632, '\p{inblockelements}', "");
    Expect(1, 9632, '\p{^inblockelements}', "");
    Expect(1, 9632, '\P{inblockelements}', "");
    Expect(0, 9632, '\P{^inblockelements}', "");
    Expect(1, 9631, '\p{ _IN_block_ELEMENTS}', "");
    Expect(0, 9631, '\p{^ _IN_block_ELEMENTS}', "");
    Expect(0, 9631, '\P{ _IN_block_ELEMENTS}', "");
    Expect(1, 9631, '\P{^ _IN_block_ELEMENTS}', "");
    Expect(0, 9632, '\p{ _IN_block_ELEMENTS}', "");
    Expect(1, 9632, '\p{^ _IN_block_ELEMENTS}', "");
    Expect(1, 9632, '\P{ _IN_block_ELEMENTS}', "");
    Expect(0, 9632, '\P{^ _IN_block_ELEMENTS}', "");
    Error('\p{- Bopomofo/a/}');
    Error('\P{- Bopomofo/a/}');
    Expect(1, 65381, '\p{bopomofo}', "");
    Expect(0, 65381, '\p{^bopomofo}', "");
    Expect(0, 65381, '\P{bopomofo}', "");
    Expect(1, 65381, '\P{^bopomofo}', "");
    Expect(0, 65382, '\p{bopomofo}', "");
    Expect(1, 65382, '\p{^bopomofo}', "");
    Expect(1, 65382, '\P{bopomofo}', "");
    Expect(0, 65382, '\P{^bopomofo}', "");
    Expect(1, 65381, '\p{	-BOPOMOFO}', "");
    Expect(0, 65381, '\p{^	-BOPOMOFO}', "");
    Expect(0, 65381, '\P{	-BOPOMOFO}', "");
    Expect(1, 65381, '\P{^	-BOPOMOFO}', "");
    Expect(0, 65382, '\p{	-BOPOMOFO}', "");
    Expect(1, 65382, '\p{^	-BOPOMOFO}', "");
    Expect(1, 65382, '\P{	-BOPOMOFO}', "");
    Expect(0, 65382, '\P{^	-BOPOMOFO}', "");
    Error('\p{/a/	_Is_Bopomofo}');
    Error('\P{/a/	_Is_Bopomofo}');
    Expect(1, 65381, '\p{isbopomofo}', "");
    Expect(0, 65381, '\p{^isbopomofo}', "");
    Expect(0, 65381, '\P{isbopomofo}', "");
    Expect(1, 65381, '\P{^isbopomofo}', "");
    Expect(0, 65382, '\p{isbopomofo}', "");
    Expect(1, 65382, '\p{^isbopomofo}', "");
    Expect(1, 65382, '\P{isbopomofo}', "");
    Expect(0, 65382, '\P{^isbopomofo}', "");
    Expect(1, 65381, '\p{is_Bopomofo}', "");
    Expect(0, 65381, '\p{^is_Bopomofo}', "");
    Expect(0, 65381, '\P{is_Bopomofo}', "");
    Expect(1, 65381, '\P{^is_Bopomofo}', "");
    Expect(0, 65382, '\p{is_Bopomofo}', "");
    Expect(1, 65382, '\p{^is_Bopomofo}', "");
    Expect(1, 65382, '\P{is_Bopomofo}', "");
    Expect(0, 65382, '\P{^is_Bopomofo}', "");
    Error('\p{	/a/Bopo}');
    Error('\P{	/a/Bopo}');
    Expect(1, 65381, '\p{bopo}', "");
    Expect(0, 65381, '\p{^bopo}', "");
    Expect(0, 65381, '\P{bopo}', "");
    Expect(1, 65381, '\P{^bopo}', "");
    Expect(0, 65382, '\p{bopo}', "");
    Expect(1, 65382, '\p{^bopo}', "");
    Expect(1, 65382, '\P{bopo}', "");
    Expect(0, 65382, '\P{^bopo}', "");
    Expect(1, 65381, '\p{	Bopo}', "");
    Expect(0, 65381, '\p{^	Bopo}', "");
    Expect(0, 65381, '\P{	Bopo}', "");
    Expect(1, 65381, '\P{^	Bopo}', "");
    Expect(0, 65382, '\p{	Bopo}', "");
    Expect(1, 65382, '\p{^	Bopo}', "");
    Expect(1, 65382, '\P{	Bopo}', "");
    Expect(0, 65382, '\P{^	Bopo}', "");
    Error('\p{_:=is_bopo}');
    Error('\P{_:=is_bopo}');
    Expect(1, 65381, '\p{isbopo}', "");
    Expect(0, 65381, '\p{^isbopo}', "");
    Expect(0, 65381, '\P{isbopo}', "");
    Expect(1, 65381, '\P{^isbopo}', "");
    Expect(0, 65382, '\p{isbopo}', "");
    Expect(1, 65382, '\p{^isbopo}', "");
    Expect(1, 65382, '\P{isbopo}', "");
    Expect(0, 65382, '\P{^isbopo}', "");
    Expect(1, 65381, '\p{ -Is_bopo}', "");
    Expect(0, 65381, '\p{^ -Is_bopo}', "");
    Expect(0, 65381, '\P{ -Is_bopo}', "");
    Expect(1, 65381, '\P{^ -Is_bopo}', "");
    Expect(0, 65382, '\p{ -Is_bopo}', "");
    Expect(1, 65382, '\p{^ -Is_bopo}', "");
    Expect(1, 65382, '\P{ -Is_bopo}', "");
    Expect(0, 65382, '\P{^ -Is_bopo}', "");
    Error('\p{_/a/bopomofo_Extended}');
    Error('\P{_/a/bopomofo_Extended}');
    Expect(1, 12735, '\p{bopomofoextended}', "");
    Expect(0, 12735, '\p{^bopomofoextended}', "");
    Expect(0, 12735, '\P{bopomofoextended}', "");
    Expect(1, 12735, '\P{^bopomofoextended}', "");
    Expect(0, 12736, '\p{bopomofoextended}', "");
    Expect(1, 12736, '\p{^bopomofoextended}', "");
    Expect(1, 12736, '\P{bopomofoextended}', "");
    Expect(0, 12736, '\P{^bopomofoextended}', "");
    Expect(1, 12735, '\p{	Bopomofo_EXTENDED}', "");
    Expect(0, 12735, '\p{^	Bopomofo_EXTENDED}', "");
    Expect(0, 12735, '\P{	Bopomofo_EXTENDED}', "");
    Expect(1, 12735, '\P{^	Bopomofo_EXTENDED}', "");
    Expect(0, 12736, '\p{	Bopomofo_EXTENDED}', "");
    Expect(1, 12736, '\p{^	Bopomofo_EXTENDED}', "");
    Expect(1, 12736, '\P{	Bopomofo_EXTENDED}', "");
    Expect(0, 12736, '\P{^	Bopomofo_EXTENDED}', "");
    Error('\p{_is_BOPOMOFO_EXTENDED:=}');
    Error('\P{_is_BOPOMOFO_EXTENDED:=}');
    Expect(1, 12735, '\p{isbopomofoextended}', "");
    Expect(0, 12735, '\p{^isbopomofoextended}', "");
    Expect(0, 12735, '\P{isbopomofoextended}', "");
    Expect(1, 12735, '\P{^isbopomofoextended}', "");
    Expect(0, 12736, '\p{isbopomofoextended}', "");
    Expect(1, 12736, '\p{^isbopomofoextended}', "");
    Expect(1, 12736, '\P{isbopomofoextended}', "");
    Expect(0, 12736, '\P{^isbopomofoextended}', "");
    Expect(1, 12735, '\p{--is_BOPOMOFO_Extended}', "");
    Expect(0, 12735, '\p{^--is_BOPOMOFO_Extended}', "");
    Expect(0, 12735, '\P{--is_BOPOMOFO_Extended}', "");
    Expect(1, 12735, '\P{^--is_BOPOMOFO_Extended}', "");
    Expect(0, 12736, '\p{--is_BOPOMOFO_Extended}', "");
    Expect(1, 12736, '\p{^--is_BOPOMOFO_Extended}', "");
    Expect(1, 12736, '\P{--is_BOPOMOFO_Extended}', "");
    Expect(0, 12736, '\P{^--is_BOPOMOFO_Extended}', "");
    Error('\p{ 	In_bopomofo_Extended:=}');
    Error('\P{ 	In_bopomofo_Extended:=}');
    Expect(1, 12735, '\p{inbopomofoextended}', "");
    Expect(0, 12735, '\p{^inbopomofoextended}', "");
    Expect(0, 12735, '\P{inbopomofoextended}', "");
    Expect(1, 12735, '\P{^inbopomofoextended}', "");
    Expect(0, 12736, '\p{inbopomofoextended}', "");
    Expect(1, 12736, '\p{^inbopomofoextended}', "");
    Expect(1, 12736, '\P{inbopomofoextended}', "");
    Expect(0, 12736, '\P{^inbopomofoextended}', "");
    Expect(1, 12735, '\p{ _In_BOPOMOFO_Extended}', "");
    Expect(0, 12735, '\p{^ _In_BOPOMOFO_Extended}', "");
    Expect(0, 12735, '\P{ _In_BOPOMOFO_Extended}', "");
    Expect(1, 12735, '\P{^ _In_BOPOMOFO_Extended}', "");
    Expect(0, 12736, '\p{ _In_BOPOMOFO_Extended}', "");
    Expect(1, 12736, '\p{^ _In_BOPOMOFO_Extended}', "");
    Expect(1, 12736, '\P{ _In_BOPOMOFO_Extended}', "");
    Expect(0, 12736, '\P{^ _In_BOPOMOFO_Extended}', "");
    Error('\p{:=-Bopomofo_Ext}');
    Error('\P{:=-Bopomofo_Ext}');
    Expect(1, 12735, '\p{bopomofoext}', "");
    Expect(0, 12735, '\p{^bopomofoext}', "");
    Expect(0, 12735, '\P{bopomofoext}', "");
    Expect(1, 12735, '\P{^bopomofoext}', "");
    Expect(0, 12736, '\p{bopomofoext}', "");
    Expect(1, 12736, '\p{^bopomofoext}', "");
    Expect(1, 12736, '\P{bopomofoext}', "");
    Expect(0, 12736, '\P{^bopomofoext}', "");
    Expect(1, 12735, '\p{ 	bopomofo_Ext}', "");
    Expect(0, 12735, '\p{^ 	bopomofo_Ext}', "");
    Expect(0, 12735, '\P{ 	bopomofo_Ext}', "");
    Expect(1, 12735, '\P{^ 	bopomofo_Ext}', "");
    Expect(0, 12736, '\p{ 	bopomofo_Ext}', "");
    Expect(1, 12736, '\p{^ 	bopomofo_Ext}', "");
    Expect(1, 12736, '\P{ 	bopomofo_Ext}', "");
    Expect(0, 12736, '\P{^ 	bopomofo_Ext}', "");
    Error('\p{:=IS_Bopomofo_Ext}');
    Error('\P{:=IS_Bopomofo_Ext}');
    Expect(1, 12735, '\p{isbopomofoext}', "");
    Expect(0, 12735, '\p{^isbopomofoext}', "");
    Expect(0, 12735, '\P{isbopomofoext}', "");
    Expect(1, 12735, '\P{^isbopomofoext}', "");
    Expect(0, 12736, '\p{isbopomofoext}', "");
    Expect(1, 12736, '\p{^isbopomofoext}', "");
    Expect(1, 12736, '\P{isbopomofoext}', "");
    Expect(0, 12736, '\P{^isbopomofoext}', "");
    Expect(1, 12735, '\p{	 IS_bopomofo_ext}', "");
    Expect(0, 12735, '\p{^	 IS_bopomofo_ext}', "");
    Expect(0, 12735, '\P{	 IS_bopomofo_ext}', "");
    Expect(1, 12735, '\P{^	 IS_bopomofo_ext}', "");
    Expect(0, 12736, '\p{	 IS_bopomofo_ext}', "");
    Expect(1, 12736, '\p{^	 IS_bopomofo_ext}', "");
    Expect(1, 12736, '\P{	 IS_bopomofo_ext}', "");
    Expect(0, 12736, '\P{^	 IS_bopomofo_ext}', "");
    Error('\p{/a/	_in_Bopomofo_Ext}');
    Error('\P{/a/	_in_Bopomofo_Ext}');
    Expect(1, 12735, '\p{inbopomofoext}', "");
    Expect(0, 12735, '\p{^inbopomofoext}', "");
    Expect(0, 12735, '\P{inbopomofoext}', "");
    Expect(1, 12735, '\P{^inbopomofoext}', "");
    Expect(0, 12736, '\p{inbopomofoext}', "");
    Expect(1, 12736, '\p{^inbopomofoext}', "");
    Expect(1, 12736, '\P{inbopomofoext}', "");
    Expect(0, 12736, '\P{^inbopomofoext}', "");
    Expect(1, 12735, '\p{	_IN_Bopomofo_EXT}', "");
    Expect(0, 12735, '\p{^	_IN_Bopomofo_EXT}', "");
    Expect(0, 12735, '\P{	_IN_Bopomofo_EXT}', "");
    Expect(1, 12735, '\P{^	_IN_Bopomofo_EXT}', "");
    Expect(0, 12736, '\p{	_IN_Bopomofo_EXT}', "");
    Expect(1, 12736, '\p{^	_IN_Bopomofo_EXT}', "");
    Expect(1, 12736, '\P{	_IN_Bopomofo_EXT}', "");
    Expect(0, 12736, '\P{^	_IN_Bopomofo_EXT}', "");
    Error('\p{-_box_DRAWING:=}');
    Error('\P{-_box_DRAWING:=}');
    Expect(1, 9599, '\p{boxdrawing}', "");
    Expect(0, 9599, '\p{^boxdrawing}', "");
    Expect(0, 9599, '\P{boxdrawing}', "");
    Expect(1, 9599, '\P{^boxdrawing}', "");
    Expect(0, 9600, '\p{boxdrawing}', "");
    Expect(1, 9600, '\p{^boxdrawing}', "");
    Expect(1, 9600, '\P{boxdrawing}', "");
    Expect(0, 9600, '\P{^boxdrawing}', "");
    Expect(1, 9599, '\p{_Box_Drawing}', "");
    Expect(0, 9599, '\p{^_Box_Drawing}', "");
    Expect(0, 9599, '\P{_Box_Drawing}', "");
    Expect(1, 9599, '\P{^_Box_Drawing}', "");
    Expect(0, 9600, '\p{_Box_Drawing}', "");
    Expect(1, 9600, '\p{^_Box_Drawing}', "");
    Expect(1, 9600, '\P{_Box_Drawing}', "");
    Expect(0, 9600, '\P{^_Box_Drawing}', "");
    Error('\p{:=Is_Box_Drawing}');
    Error('\P{:=Is_Box_Drawing}');
    Expect(1, 9599, '\p{isboxdrawing}', "");
    Expect(0, 9599, '\p{^isboxdrawing}', "");
    Expect(0, 9599, '\P{isboxdrawing}', "");
    Expect(1, 9599, '\P{^isboxdrawing}', "");
    Expect(0, 9600, '\p{isboxdrawing}', "");
    Expect(1, 9600, '\p{^isboxdrawing}', "");
    Expect(1, 9600, '\P{isboxdrawing}', "");
    Expect(0, 9600, '\P{^isboxdrawing}', "");
    Expect(1, 9599, '\p{_	IS_box_Drawing}', "");
    Expect(0, 9599, '\p{^_	IS_box_Drawing}', "");
    Expect(0, 9599, '\P{_	IS_box_Drawing}', "");
    Expect(1, 9599, '\P{^_	IS_box_Drawing}', "");
    Expect(0, 9600, '\p{_	IS_box_Drawing}', "");
    Expect(1, 9600, '\p{^_	IS_box_Drawing}', "");
    Expect(1, 9600, '\P{_	IS_box_Drawing}', "");
    Expect(0, 9600, '\P{^_	IS_box_Drawing}', "");
    Error('\p{-IN_box_drawing/a/}');
    Error('\P{-IN_box_drawing/a/}');
    Expect(1, 9599, '\p{inboxdrawing}', "");
    Expect(0, 9599, '\p{^inboxdrawing}', "");
    Expect(0, 9599, '\P{inboxdrawing}', "");
    Expect(1, 9599, '\P{^inboxdrawing}', "");
    Expect(0, 9600, '\p{inboxdrawing}', "");
    Expect(1, 9600, '\p{^inboxdrawing}', "");
    Expect(1, 9600, '\P{inboxdrawing}', "");
    Expect(0, 9600, '\P{^inboxdrawing}', "");
    Expect(1, 9599, '\p{ _IN_BOX_drawing}', "");
    Expect(0, 9599, '\p{^ _IN_BOX_drawing}', "");
    Expect(0, 9599, '\P{ _IN_BOX_drawing}', "");
    Expect(1, 9599, '\P{^ _IN_BOX_drawing}', "");
    Expect(0, 9600, '\p{ _IN_BOX_drawing}', "");
    Expect(1, 9600, '\p{^ _IN_BOX_drawing}', "");
    Expect(1, 9600, '\P{ _IN_BOX_drawing}', "");
    Expect(0, 9600, '\P{^ _IN_BOX_drawing}', "");
    Error('\p{_:=BRAHMI}');
    Error('\P{_:=BRAHMI}');
    Expect(1, 69759, '\p{brahmi}', "");
    Expect(0, 69759, '\p{^brahmi}', "");
    Expect(0, 69759, '\P{brahmi}', "");
    Expect(1, 69759, '\P{^brahmi}', "");
    Expect(0, 69760, '\p{brahmi}', "");
    Expect(1, 69760, '\p{^brahmi}', "");
    Expect(1, 69760, '\P{brahmi}', "");
    Expect(0, 69760, '\P{^brahmi}', "");
    Expect(1, 69759, '\p{ _Brahmi}', "");
    Expect(0, 69759, '\p{^ _Brahmi}', "");
    Expect(0, 69759, '\P{ _Brahmi}', "");
    Expect(1, 69759, '\P{^ _Brahmi}', "");
    Expect(0, 69760, '\p{ _Brahmi}', "");
    Expect(1, 69760, '\p{^ _Brahmi}', "");
    Expect(1, 69760, '\P{ _Brahmi}', "");
    Expect(0, 69760, '\P{^ _Brahmi}', "");
    Error('\p{_:=Is_Brahmi}');
    Error('\P{_:=Is_Brahmi}');
    Expect(1, 69759, '\p{isbrahmi}', "");
    Expect(0, 69759, '\p{^isbrahmi}', "");
    Expect(0, 69759, '\P{isbrahmi}', "");
    Expect(1, 69759, '\P{^isbrahmi}', "");
    Expect(0, 69760, '\p{isbrahmi}', "");
    Expect(1, 69760, '\p{^isbrahmi}', "");
    Expect(1, 69760, '\P{isbrahmi}', "");
    Expect(0, 69760, '\P{^isbrahmi}', "");
    Expect(1, 69759, '\p{ Is_Brahmi}', "");
    Expect(0, 69759, '\p{^ Is_Brahmi}', "");
    Expect(0, 69759, '\P{ Is_Brahmi}', "");
    Expect(1, 69759, '\P{^ Is_Brahmi}', "");
    Expect(0, 69760, '\p{ Is_Brahmi}', "");
    Expect(1, 69760, '\p{^ Is_Brahmi}', "");
    Expect(1, 69760, '\P{ Is_Brahmi}', "");
    Expect(0, 69760, '\P{^ Is_Brahmi}', "");
    Error('\p{ Brah/a/}');
    Error('\P{ Brah/a/}');
    Expect(1, 69759, '\p{brah}', "");
    Expect(0, 69759, '\p{^brah}', "");
    Expect(0, 69759, '\P{brah}', "");
    Expect(1, 69759, '\P{^brah}', "");
    Expect(0, 69760, '\p{brah}', "");
    Expect(1, 69760, '\p{^brah}', "");
    Expect(1, 69760, '\P{brah}', "");
    Expect(0, 69760, '\P{^brah}', "");
    Expect(1, 69759, '\p{ -BRAH}', "");
    Expect(0, 69759, '\p{^ -BRAH}', "");
    Expect(0, 69759, '\P{ -BRAH}', "");
    Expect(1, 69759, '\P{^ -BRAH}', "");
    Expect(0, 69760, '\p{ -BRAH}', "");
    Expect(1, 69760, '\p{^ -BRAH}', "");
    Expect(1, 69760, '\P{ -BRAH}', "");
    Expect(0, 69760, '\P{^ -BRAH}', "");
    Error('\p{:=IS_brah}');
    Error('\P{:=IS_brah}');
    Expect(1, 69759, '\p{isbrah}', "");
    Expect(0, 69759, '\p{^isbrah}', "");
    Expect(0, 69759, '\P{isbrah}', "");
    Expect(1, 69759, '\P{^isbrah}', "");
    Expect(0, 69760, '\p{isbrah}', "");
    Expect(1, 69760, '\p{^isbrah}', "");
    Expect(1, 69760, '\P{isbrah}', "");
    Expect(0, 69760, '\P{^isbrah}', "");
    Expect(1, 69759, '\p{ Is_Brah}', "");
    Expect(0, 69759, '\p{^ Is_Brah}', "");
    Expect(0, 69759, '\P{ Is_Brah}', "");
    Expect(1, 69759, '\P{^ Is_Brah}', "");
    Expect(0, 69760, '\p{ Is_Brah}', "");
    Expect(1, 69760, '\p{^ Is_Brah}', "");
    Expect(1, 69760, '\P{ Is_Brah}', "");
    Expect(0, 69760, '\P{^ Is_Brah}', "");
    Error('\p{/a/	BRAILLE}');
    Error('\P{/a/	BRAILLE}');
    Expect(1, 10495, '\p{braille}', "");
    Expect(0, 10495, '\p{^braille}', "");
    Expect(0, 10495, '\P{braille}', "");
    Expect(1, 10495, '\P{^braille}', "");
    Expect(0, 10496, '\p{braille}', "");
    Expect(1, 10496, '\p{^braille}', "");
    Expect(1, 10496, '\P{braille}', "");
    Expect(0, 10496, '\P{^braille}', "");
    Expect(1, 10495, '\p{  braille}', "");
    Expect(0, 10495, '\p{^  braille}', "");
    Expect(0, 10495, '\P{  braille}', "");
    Expect(1, 10495, '\P{^  braille}', "");
    Expect(0, 10496, '\p{  braille}', "");
    Expect(1, 10496, '\p{^  braille}', "");
    Expect(1, 10496, '\P{  braille}', "");
    Expect(0, 10496, '\P{^  braille}', "");
    Error('\p{_Is_braille/a/}');
    Error('\P{_Is_braille/a/}');
    Expect(1, 10495, '\p{isbraille}', "");
    Expect(0, 10495, '\p{^isbraille}', "");
    Expect(0, 10495, '\P{isbraille}', "");
    Expect(1, 10495, '\P{^isbraille}', "");
    Expect(0, 10496, '\p{isbraille}', "");
    Expect(1, 10496, '\p{^isbraille}', "");
    Expect(1, 10496, '\P{isbraille}', "");
    Expect(0, 10496, '\P{^isbraille}', "");
    Expect(1, 10495, '\p{-is_Braille}', "");
    Expect(0, 10495, '\p{^-is_Braille}', "");
    Expect(0, 10495, '\P{-is_Braille}', "");
    Expect(1, 10495, '\P{^-is_Braille}', "");
    Expect(0, 10496, '\p{-is_Braille}', "");
    Expect(1, 10496, '\p{^-is_Braille}', "");
    Expect(1, 10496, '\P{-is_Braille}', "");
    Expect(0, 10496, '\P{^-is_Braille}', "");
    Error('\p{ :=Brai}');
    Error('\P{ :=Brai}');
    Expect(1, 10495, '\p{brai}', "");
    Expect(0, 10495, '\p{^brai}', "");
    Expect(0, 10495, '\P{brai}', "");
    Expect(1, 10495, '\P{^brai}', "");
    Expect(0, 10496, '\p{brai}', "");
    Expect(1, 10496, '\p{^brai}', "");
    Expect(1, 10496, '\P{brai}', "");
    Expect(0, 10496, '\P{^brai}', "");
    Expect(1, 10495, '\p{ Brai}', "");
    Expect(0, 10495, '\p{^ Brai}', "");
    Expect(0, 10495, '\P{ Brai}', "");
    Expect(1, 10495, '\P{^ Brai}', "");
    Expect(0, 10496, '\p{ Brai}', "");
    Expect(1, 10496, '\p{^ Brai}', "");
    Expect(1, 10496, '\P{ Brai}', "");
    Expect(0, 10496, '\P{^ Brai}', "");
    Error('\p{-_Is_Brai:=}');
    Error('\P{-_Is_Brai:=}');
    Expect(1, 10495, '\p{isbrai}', "");
    Expect(0, 10495, '\p{^isbrai}', "");
    Expect(0, 10495, '\P{isbrai}', "");
    Expect(1, 10495, '\P{^isbrai}', "");
    Expect(0, 10496, '\p{isbrai}', "");
    Expect(1, 10496, '\p{^isbrai}', "");
    Expect(1, 10496, '\P{isbrai}', "");
    Expect(0, 10496, '\P{^isbrai}', "");
    Expect(1, 10495, '\p{_ Is_BRAI}', "");
    Expect(0, 10495, '\p{^_ Is_BRAI}', "");
    Expect(0, 10495, '\P{_ Is_BRAI}', "");
    Expect(1, 10495, '\P{^_ Is_BRAI}', "");
    Expect(0, 10496, '\p{_ Is_BRAI}', "");
    Expect(1, 10496, '\p{^_ Is_BRAI}', "");
    Expect(1, 10496, '\P{_ Is_BRAI}', "");
    Expect(0, 10496, '\P{^_ Is_BRAI}', "");
    Error('\p{:= 	Braille_patterns}');
    Error('\P{:= 	Braille_patterns}');
    Expect(1, 10495, '\p{braillepatterns}', "");
    Expect(0, 10495, '\p{^braillepatterns}', "");
    Expect(0, 10495, '\P{braillepatterns}', "");
    Expect(1, 10495, '\P{^braillepatterns}', "");
    Expect(0, 10496, '\p{braillepatterns}', "");
    Expect(1, 10496, '\p{^braillepatterns}', "");
    Expect(1, 10496, '\P{braillepatterns}', "");
    Expect(0, 10496, '\P{^braillepatterns}', "");
    Expect(1, 10495, '\p{ _Braille_Patterns}', "");
    Expect(0, 10495, '\p{^ _Braille_Patterns}', "");
    Expect(0, 10495, '\P{ _Braille_Patterns}', "");
    Expect(1, 10495, '\P{^ _Braille_Patterns}', "");
    Expect(0, 10496, '\p{ _Braille_Patterns}', "");
    Expect(1, 10496, '\p{^ _Braille_Patterns}', "");
    Expect(1, 10496, '\P{ _Braille_Patterns}', "");
    Expect(0, 10496, '\P{^ _Braille_Patterns}', "");
    Error('\p{:=	Is_BRAILLE_Patterns}');
    Error('\P{:=	Is_BRAILLE_Patterns}');
    Expect(1, 10495, '\p{isbraillepatterns}', "");
    Expect(0, 10495, '\p{^isbraillepatterns}', "");
    Expect(0, 10495, '\P{isbraillepatterns}', "");
    Expect(1, 10495, '\P{^isbraillepatterns}', "");
    Expect(0, 10496, '\p{isbraillepatterns}', "");
    Expect(1, 10496, '\p{^isbraillepatterns}', "");
    Expect(1, 10496, '\P{isbraillepatterns}', "");
    Expect(0, 10496, '\P{^isbraillepatterns}', "");
    Expect(1, 10495, '\p{	 is_braille_PATTERNS}', "");
    Expect(0, 10495, '\p{^	 is_braille_PATTERNS}', "");
    Expect(0, 10495, '\P{	 is_braille_PATTERNS}', "");
    Expect(1, 10495, '\P{^	 is_braille_PATTERNS}', "");
    Expect(0, 10496, '\p{	 is_braille_PATTERNS}', "");
    Expect(1, 10496, '\p{^	 is_braille_PATTERNS}', "");
    Expect(1, 10496, '\P{	 is_braille_PATTERNS}', "");
    Expect(0, 10496, '\P{^	 is_braille_PATTERNS}', "");
    Error('\p{/a/ -In_Braille_patterns}');
    Error('\P{/a/ -In_Braille_patterns}');
    Expect(1, 10495, '\p{inbraillepatterns}', "");
    Expect(0, 10495, '\p{^inbraillepatterns}', "");
    Expect(0, 10495, '\P{inbraillepatterns}', "");
    Expect(1, 10495, '\P{^inbraillepatterns}', "");
    Expect(0, 10496, '\p{inbraillepatterns}', "");
    Expect(1, 10496, '\p{^inbraillepatterns}', "");
    Expect(1, 10496, '\P{inbraillepatterns}', "");
    Expect(0, 10496, '\P{^inbraillepatterns}', "");
    Expect(1, 10495, '\p{- In_braille_PATTERNS}', "");
    Expect(0, 10495, '\p{^- In_braille_PATTERNS}', "");
    Expect(0, 10495, '\P{- In_braille_PATTERNS}', "");
    Expect(1, 10495, '\P{^- In_braille_PATTERNS}', "");
    Expect(0, 10496, '\p{- In_braille_PATTERNS}', "");
    Expect(1, 10496, '\p{^- In_braille_PATTERNS}', "");
    Expect(1, 10496, '\P{- In_braille_PATTERNS}', "");
    Expect(0, 10496, '\P{^- In_braille_PATTERNS}', "");
    Error('\p{ -In_Braille/a/}');
    Error('\P{ -In_Braille/a/}');
    Expect(1, 10495, '\p{inbraille}', "");
    Expect(0, 10495, '\p{^inbraille}', "");
    Expect(0, 10495, '\P{inbraille}', "");
    Expect(1, 10495, '\P{^inbraille}', "");
    Expect(0, 10496, '\p{inbraille}', "");
    Expect(1, 10496, '\p{^inbraille}', "");
    Expect(1, 10496, '\P{inbraille}', "");
    Expect(0, 10496, '\P{^inbraille}', "");
    Expect(1, 10495, '\p{	-In_braille}', "");
    Expect(0, 10495, '\p{^	-In_braille}', "");
    Expect(0, 10495, '\P{	-In_braille}', "");
    Expect(1, 10495, '\P{^	-In_braille}', "");
    Expect(0, 10496, '\p{	-In_braille}', "");
    Expect(1, 10496, '\p{^	-In_braille}', "");
    Expect(1, 10496, '\P{	-In_braille}', "");
    Expect(0, 10496, '\P{^	-In_braille}', "");
    Error('\p{/a/	BUGINESE}');
    Error('\P{/a/	BUGINESE}');
    Expect(1, 43471, '\p{buginese}', "");
    Expect(0, 43471, '\p{^buginese}', "");
    Expect(0, 43471, '\P{buginese}', "");
    Expect(1, 43471, '\P{^buginese}', "");
    Expect(0, 43472, '\p{buginese}', "");
    Expect(1, 43472, '\p{^buginese}', "");
    Expect(1, 43472, '\P{buginese}', "");
    Expect(0, 43472, '\P{^buginese}', "");
    Expect(1, 43471, '\p{-BUGINESE}', "");
    Expect(0, 43471, '\p{^-BUGINESE}', "");
    Expect(0, 43471, '\P{-BUGINESE}', "");
    Expect(1, 43471, '\P{^-BUGINESE}', "");
    Expect(0, 43472, '\p{-BUGINESE}', "");
    Expect(1, 43472, '\p{^-BUGINESE}', "");
    Expect(1, 43472, '\P{-BUGINESE}', "");
    Expect(0, 43472, '\P{^-BUGINESE}', "");
    Error('\p{/a/-_Is_buginese}');
    Error('\P{/a/-_Is_buginese}');
    Expect(1, 43471, '\p{isbuginese}', "");
    Expect(0, 43471, '\p{^isbuginese}', "");
    Expect(0, 43471, '\P{isbuginese}', "");
    Expect(1, 43471, '\P{^isbuginese}', "");
    Expect(0, 43472, '\p{isbuginese}', "");
    Expect(1, 43472, '\p{^isbuginese}', "");
    Expect(1, 43472, '\P{isbuginese}', "");
    Expect(0, 43472, '\P{^isbuginese}', "");
    Expect(1, 43471, '\p{-_Is_Buginese}', "");
    Expect(0, 43471, '\p{^-_Is_Buginese}', "");
    Expect(0, 43471, '\P{-_Is_Buginese}', "");
    Expect(1, 43471, '\P{^-_Is_Buginese}', "");
    Expect(0, 43472, '\p{-_Is_Buginese}', "");
    Expect(1, 43472, '\p{^-_Is_Buginese}', "");
    Expect(1, 43472, '\P{-_Is_Buginese}', "");
    Expect(0, 43472, '\P{^-_Is_Buginese}', "");
    Error('\p{Bugi:=}');
    Error('\P{Bugi:=}');
    Expect(1, 43471, '\p{bugi}', "");
    Expect(0, 43471, '\p{^bugi}', "");
    Expect(0, 43471, '\P{bugi}', "");
    Expect(1, 43471, '\P{^bugi}', "");
    Expect(0, 43472, '\p{bugi}', "");
    Expect(1, 43472, '\p{^bugi}', "");
    Expect(1, 43472, '\P{bugi}', "");
    Expect(0, 43472, '\P{^bugi}', "");
    Expect(1, 43471, '\p{ _BUGI}', "");
    Expect(0, 43471, '\p{^ _BUGI}', "");
    Expect(0, 43471, '\P{ _BUGI}', "");
    Expect(1, 43471, '\P{^ _BUGI}', "");
    Expect(0, 43472, '\p{ _BUGI}', "");
    Expect(1, 43472, '\p{^ _BUGI}', "");
    Expect(1, 43472, '\P{ _BUGI}', "");
    Expect(0, 43472, '\P{^ _BUGI}', "");
    Error('\p{--is_BUGI/a/}');
    Error('\P{--is_BUGI/a/}');
    Expect(1, 43471, '\p{isbugi}', "");
    Expect(0, 43471, '\p{^isbugi}', "");
    Expect(0, 43471, '\P{isbugi}', "");
    Expect(1, 43471, '\P{^isbugi}', "");
    Expect(0, 43472, '\p{isbugi}', "");
    Expect(1, 43472, '\p{^isbugi}', "");
    Expect(1, 43472, '\P{isbugi}', "");
    Expect(0, 43472, '\P{^isbugi}', "");
    Expect(1, 43471, '\p{-_IS_bugi}', "");
    Expect(0, 43471, '\p{^-_IS_bugi}', "");
    Expect(0, 43471, '\P{-_IS_bugi}', "");
    Expect(1, 43471, '\P{^-_IS_bugi}', "");
    Expect(0, 43472, '\p{-_IS_bugi}', "");
    Expect(1, 43472, '\p{^-_IS_bugi}', "");
    Expect(1, 43472, '\P{-_IS_bugi}', "");
    Expect(0, 43472, '\P{^-_IS_bugi}', "");
    Error('\p{:= Buhid}');
    Error('\P{:= Buhid}');
    Expect(1, 5971, '\p{buhid}', "");
    Expect(0, 5971, '\p{^buhid}', "");
    Expect(0, 5971, '\P{buhid}', "");
    Expect(1, 5971, '\P{^buhid}', "");
    Expect(0, 5972, '\p{buhid}', "");
    Expect(1, 5972, '\p{^buhid}', "");
    Expect(1, 5972, '\P{buhid}', "");
    Expect(0, 5972, '\P{^buhid}', "");
    Expect(1, 5971, '\p{ BUHID}', "");
    Expect(0, 5971, '\p{^ BUHID}', "");
    Expect(0, 5971, '\P{ BUHID}', "");
    Expect(1, 5971, '\P{^ BUHID}', "");
    Expect(0, 5972, '\p{ BUHID}', "");
    Expect(1, 5972, '\p{^ BUHID}', "");
    Expect(1, 5972, '\P{ BUHID}', "");
    Expect(0, 5972, '\P{^ BUHID}', "");
    Error('\p{_/a/is_buhid}');
    Error('\P{_/a/is_buhid}');
    Expect(1, 5971, '\p{isbuhid}', "");
    Expect(0, 5971, '\p{^isbuhid}', "");
    Expect(0, 5971, '\P{isbuhid}', "");
    Expect(1, 5971, '\P{^isbuhid}', "");
    Expect(0, 5972, '\p{isbuhid}', "");
    Expect(1, 5972, '\p{^isbuhid}', "");
    Expect(1, 5972, '\P{isbuhid}', "");
    Expect(0, 5972, '\P{^isbuhid}', "");
    Expect(1, 5971, '\p{_is_Buhid}', "");
    Expect(0, 5971, '\p{^_is_Buhid}', "");
    Expect(0, 5971, '\P{_is_Buhid}', "");
    Expect(1, 5971, '\P{^_is_Buhid}', "");
    Expect(0, 5972, '\p{_is_Buhid}', "");
    Expect(1, 5972, '\p{^_is_Buhid}', "");
    Expect(1, 5972, '\P{_is_Buhid}', "");
    Expect(0, 5972, '\P{^_is_Buhid}', "");
    Error('\p{/a/-	buhd}');
    Error('\P{/a/-	buhd}');
    Expect(1, 5971, '\p{buhd}', "");
    Expect(0, 5971, '\p{^buhd}', "");
    Expect(0, 5971, '\P{buhd}', "");
    Expect(1, 5971, '\P{^buhd}', "");
    Expect(0, 5972, '\p{buhd}', "");
    Expect(1, 5972, '\p{^buhd}', "");
    Expect(1, 5972, '\P{buhd}', "");
    Expect(0, 5972, '\P{^buhd}', "");
    Expect(1, 5971, '\p{ buhd}', "");
    Expect(0, 5971, '\p{^ buhd}', "");
    Expect(0, 5971, '\P{ buhd}', "");
    Expect(1, 5971, '\P{^ buhd}', "");
    Expect(0, 5972, '\p{ buhd}', "");
    Expect(1, 5972, '\p{^ buhd}', "");
    Expect(1, 5972, '\P{ buhd}', "");
    Expect(0, 5972, '\P{^ buhd}', "");
    Error('\p{:=_-Is_BUHD}');
    Error('\P{:=_-Is_BUHD}');
    Expect(1, 5971, '\p{isbuhd}', "");
    Expect(0, 5971, '\p{^isbuhd}', "");
    Expect(0, 5971, '\P{isbuhd}', "");
    Expect(1, 5971, '\P{^isbuhd}', "");
    Expect(0, 5972, '\p{isbuhd}', "");
    Expect(1, 5972, '\p{^isbuhd}', "");
    Expect(1, 5972, '\P{isbuhd}', "");
    Expect(0, 5972, '\P{^isbuhd}', "");
    Expect(1, 5971, '\p{		is_buhd}', "");
    Expect(0, 5971, '\p{^		is_buhd}', "");
    Expect(0, 5971, '\P{		is_buhd}', "");
    Expect(1, 5971, '\P{^		is_buhd}', "");
    Expect(0, 5972, '\p{		is_buhd}', "");
    Expect(1, 5972, '\p{^		is_buhd}', "");
    Expect(1, 5972, '\P{		is_buhd}', "");
    Expect(0, 5972, '\P{^		is_buhd}', "");
    Error('\p{_/a/byzantine_MUSICAL_Symbols}');
    Error('\P{_/a/byzantine_MUSICAL_Symbols}');
    Expect(1, 119039, '\p{byzantinemusicalsymbols}', "");
    Expect(0, 119039, '\p{^byzantinemusicalsymbols}', "");
    Expect(0, 119039, '\P{byzantinemusicalsymbols}', "");
    Expect(1, 119039, '\P{^byzantinemusicalsymbols}', "");
    Expect(0, 119040, '\p{byzantinemusicalsymbols}', "");
    Expect(1, 119040, '\p{^byzantinemusicalsymbols}', "");
    Expect(1, 119040, '\P{byzantinemusicalsymbols}', "");
    Expect(0, 119040, '\P{^byzantinemusicalsymbols}', "");
    Expect(1, 119039, '\p{- Byzantine_Musical_symbols}', "");
    Expect(0, 119039, '\p{^- Byzantine_Musical_symbols}', "");
    Expect(0, 119039, '\P{- Byzantine_Musical_symbols}', "");
    Expect(1, 119039, '\P{^- Byzantine_Musical_symbols}', "");
    Expect(0, 119040, '\p{- Byzantine_Musical_symbols}', "");
    Expect(1, 119040, '\p{^- Byzantine_Musical_symbols}', "");
    Expect(1, 119040, '\P{- Byzantine_Musical_symbols}', "");
    Expect(0, 119040, '\P{^- Byzantine_Musical_symbols}', "");
    Error('\p{/a/	is_BYZANTINE_Musical_SYMBOLS}');
    Error('\P{/a/	is_BYZANTINE_Musical_SYMBOLS}');
    Expect(1, 119039, '\p{isbyzantinemusicalsymbols}', "");
    Expect(0, 119039, '\p{^isbyzantinemusicalsymbols}', "");
    Expect(0, 119039, '\P{isbyzantinemusicalsymbols}', "");
    Expect(1, 119039, '\P{^isbyzantinemusicalsymbols}', "");
    Expect(0, 119040, '\p{isbyzantinemusicalsymbols}', "");
    Expect(1, 119040, '\p{^isbyzantinemusicalsymbols}', "");
    Expect(1, 119040, '\P{isbyzantinemusicalsymbols}', "");
    Expect(0, 119040, '\P{^isbyzantinemusicalsymbols}', "");
    Expect(1, 119039, '\p{_-is_byzantine_musical_Symbols}', "");
    Expect(0, 119039, '\p{^_-is_byzantine_musical_Symbols}', "");
    Expect(0, 119039, '\P{_-is_byzantine_musical_Symbols}', "");
    Expect(1, 119039, '\P{^_-is_byzantine_musical_Symbols}', "");
    Expect(0, 119040, '\p{_-is_byzantine_musical_Symbols}', "");
    Expect(1, 119040, '\p{^_-is_byzantine_musical_Symbols}', "");
    Expect(1, 119040, '\P{_-is_byzantine_musical_Symbols}', "");
    Expect(0, 119040, '\P{^_-is_byzantine_musical_Symbols}', "");
    Error('\p{:=	In_byzantine_Musical_SYMBOLS}');
    Error('\P{:=	In_byzantine_Musical_SYMBOLS}');
    Expect(1, 119039, '\p{inbyzantinemusicalsymbols}', "");
    Expect(0, 119039, '\p{^inbyzantinemusicalsymbols}', "");
    Expect(0, 119039, '\P{inbyzantinemusicalsymbols}', "");
    Expect(1, 119039, '\P{^inbyzantinemusicalsymbols}', "");
    Expect(0, 119040, '\p{inbyzantinemusicalsymbols}', "");
    Expect(1, 119040, '\p{^inbyzantinemusicalsymbols}', "");
    Expect(1, 119040, '\P{inbyzantinemusicalsymbols}', "");
    Expect(0, 119040, '\P{^inbyzantinemusicalsymbols}', "");
    Expect(1, 119039, '\p{__In_Byzantine_Musical_Symbols}', "");
    Expect(0, 119039, '\p{^__In_Byzantine_Musical_Symbols}', "");
    Expect(0, 119039, '\P{__In_Byzantine_Musical_Symbols}', "");
    Expect(1, 119039, '\P{^__In_Byzantine_Musical_Symbols}', "");
    Expect(0, 119040, '\p{__In_Byzantine_Musical_Symbols}', "");
    Expect(1, 119040, '\p{^__In_Byzantine_Musical_Symbols}', "");
    Expect(1, 119040, '\P{__In_Byzantine_Musical_Symbols}', "");
    Expect(0, 119040, '\P{^__In_Byzantine_Musical_Symbols}', "");
    Error('\p{	-Byzantine_Music:=}');
    Error('\P{	-Byzantine_Music:=}');
    Expect(1, 119039, '\p{byzantinemusic}', "");
    Expect(0, 119039, '\p{^byzantinemusic}', "");
    Expect(0, 119039, '\P{byzantinemusic}', "");
    Expect(1, 119039, '\P{^byzantinemusic}', "");
    Expect(0, 119040, '\p{byzantinemusic}', "");
    Expect(1, 119040, '\p{^byzantinemusic}', "");
    Expect(1, 119040, '\P{byzantinemusic}', "");
    Expect(0, 119040, '\P{^byzantinemusic}', "");
    Expect(1, 119039, '\p{		byzantine_MUSIC}', "");
    Expect(0, 119039, '\p{^		byzantine_MUSIC}', "");
    Expect(0, 119039, '\P{		byzantine_MUSIC}', "");
    Expect(1, 119039, '\P{^		byzantine_MUSIC}', "");
    Expect(0, 119040, '\p{		byzantine_MUSIC}', "");
    Expect(1, 119040, '\p{^		byzantine_MUSIC}', "");
    Expect(1, 119040, '\P{		byzantine_MUSIC}', "");
    Expect(0, 119040, '\P{^		byzantine_MUSIC}', "");
    Error('\p{_	IS_BYZANTINE_MUSIC/a/}');
    Error('\P{_	IS_BYZANTINE_MUSIC/a/}');
    Expect(1, 119039, '\p{isbyzantinemusic}', "");
    Expect(0, 119039, '\p{^isbyzantinemusic}', "");
    Expect(0, 119039, '\P{isbyzantinemusic}', "");
    Expect(1, 119039, '\P{^isbyzantinemusic}', "");
    Expect(0, 119040, '\p{isbyzantinemusic}', "");
    Expect(1, 119040, '\p{^isbyzantinemusic}', "");
    Expect(1, 119040, '\P{isbyzantinemusic}', "");
    Expect(0, 119040, '\P{^isbyzantinemusic}', "");
    Expect(1, 119039, '\p{	Is_Byzantine_MUSIC}', "");
    Expect(0, 119039, '\p{^	Is_Byzantine_MUSIC}', "");
    Expect(0, 119039, '\P{	Is_Byzantine_MUSIC}', "");
    Expect(1, 119039, '\P{^	Is_Byzantine_MUSIC}', "");
    Expect(0, 119040, '\p{	Is_Byzantine_MUSIC}', "");
    Expect(1, 119040, '\p{^	Is_Byzantine_MUSIC}', "");
    Expect(1, 119040, '\P{	Is_Byzantine_MUSIC}', "");
    Expect(0, 119040, '\P{^	Is_Byzantine_MUSIC}', "");
    Error('\p{	in_BYZANTINE_Music:=}');
    Error('\P{	in_BYZANTINE_Music:=}');
    Expect(1, 119039, '\p{inbyzantinemusic}', "");
    Expect(0, 119039, '\p{^inbyzantinemusic}', "");
    Expect(0, 119039, '\P{inbyzantinemusic}', "");
    Expect(1, 119039, '\P{^inbyzantinemusic}', "");
    Expect(0, 119040, '\p{inbyzantinemusic}', "");
    Expect(1, 119040, '\p{^inbyzantinemusic}', "");
    Expect(1, 119040, '\P{inbyzantinemusic}', "");
    Expect(0, 119040, '\P{^inbyzantinemusic}', "");
    Expect(1, 119039, '\p{	 in_BYZANTINE_Music}', "");
    Expect(0, 119039, '\p{^	 in_BYZANTINE_Music}', "");
    Expect(0, 119039, '\P{	 in_BYZANTINE_Music}', "");
    Expect(1, 119039, '\P{^	 in_BYZANTINE_Music}', "");
    Expect(0, 119040, '\p{	 in_BYZANTINE_Music}', "");
    Expect(1, 119040, '\p{^	 in_BYZANTINE_Music}', "");
    Expect(1, 119040, '\P{	 in_BYZANTINE_Music}', "");
    Expect(0, 119040, '\P{^	 in_BYZANTINE_Music}', "");
    Error('\p{- canadian_aboriginal/a/}');
    Error('\P{- canadian_aboriginal/a/}');
    Expect(1, 6389, '\p{canadianaboriginal}', "");
    Expect(0, 6389, '\p{^canadianaboriginal}', "");
    Expect(0, 6389, '\P{canadianaboriginal}', "");
    Expect(1, 6389, '\P{^canadianaboriginal}', "");
    Expect(0, 6390, '\p{canadianaboriginal}', "");
    Expect(1, 6390, '\p{^canadianaboriginal}', "");
    Expect(1, 6390, '\P{canadianaboriginal}', "");
    Expect(0, 6390, '\P{^canadianaboriginal}', "");
    Expect(1, 6389, '\p{  Canadian_aboriginal}', "");
    Expect(0, 6389, '\p{^  Canadian_aboriginal}', "");
    Expect(0, 6389, '\P{  Canadian_aboriginal}', "");
    Expect(1, 6389, '\P{^  Canadian_aboriginal}', "");
    Expect(0, 6390, '\p{  Canadian_aboriginal}', "");
    Expect(1, 6390, '\p{^  Canadian_aboriginal}', "");
    Expect(1, 6390, '\P{  Canadian_aboriginal}', "");
    Expect(0, 6390, '\P{^  Canadian_aboriginal}', "");
    Error('\p{:= Is_CANADIAN_Aboriginal}');
    Error('\P{:= Is_CANADIAN_Aboriginal}');
    Expect(1, 6389, '\p{iscanadianaboriginal}', "");
    Expect(0, 6389, '\p{^iscanadianaboriginal}', "");
    Expect(0, 6389, '\P{iscanadianaboriginal}', "");
    Expect(1, 6389, '\P{^iscanadianaboriginal}', "");
    Expect(0, 6390, '\p{iscanadianaboriginal}', "");
    Expect(1, 6390, '\p{^iscanadianaboriginal}', "");
    Expect(1, 6390, '\P{iscanadianaboriginal}', "");
    Expect(0, 6390, '\P{^iscanadianaboriginal}', "");
    Expect(1, 6389, '\p{-	Is_Canadian_ABORIGINAL}', "");
    Expect(0, 6389, '\p{^-	Is_Canadian_ABORIGINAL}', "");
    Expect(0, 6389, '\P{-	Is_Canadian_ABORIGINAL}', "");
    Expect(1, 6389, '\P{^-	Is_Canadian_ABORIGINAL}', "");
    Expect(0, 6390, '\p{-	Is_Canadian_ABORIGINAL}', "");
    Expect(1, 6390, '\p{^-	Is_Canadian_ABORIGINAL}', "");
    Expect(1, 6390, '\P{-	Is_Canadian_ABORIGINAL}', "");
    Expect(0, 6390, '\P{^-	Is_Canadian_ABORIGINAL}', "");
    Error('\p{/a/		cans}');
    Error('\P{/a/		cans}');
    Expect(1, 6389, '\p{cans}', "");
    Expect(0, 6389, '\p{^cans}', "");
    Expect(0, 6389, '\P{cans}', "");
    Expect(1, 6389, '\P{^cans}', "");
    Expect(0, 6390, '\p{cans}', "");
    Expect(1, 6390, '\p{^cans}', "");
    Expect(1, 6390, '\P{cans}', "");
    Expect(0, 6390, '\P{^cans}', "");
    Expect(1, 6389, '\p{ Cans}', "");
    Expect(0, 6389, '\p{^ Cans}', "");
    Expect(0, 6389, '\P{ Cans}', "");
    Expect(1, 6389, '\P{^ Cans}', "");
    Expect(0, 6390, '\p{ Cans}', "");
    Expect(1, 6390, '\p{^ Cans}', "");
    Expect(1, 6390, '\P{ Cans}', "");
    Expect(0, 6390, '\P{^ Cans}', "");
    Error('\p{/a/	is_Cans}');
    Error('\P{/a/	is_Cans}');
    Expect(1, 6389, '\p{iscans}', "");
    Expect(0, 6389, '\p{^iscans}', "");
    Expect(0, 6389, '\P{iscans}', "");
    Expect(1, 6389, '\P{^iscans}', "");
    Expect(0, 6390, '\p{iscans}', "");
    Expect(1, 6390, '\p{^iscans}', "");
    Expect(1, 6390, '\P{iscans}', "");
    Expect(0, 6390, '\P{^iscans}', "");
    Expect(1, 6389, '\p{	_Is_CANS}', "");
    Expect(0, 6389, '\p{^	_Is_CANS}', "");
    Expect(0, 6389, '\P{	_Is_CANS}', "");
    Expect(1, 6389, '\P{^	_Is_CANS}', "");
    Expect(0, 6390, '\p{	_Is_CANS}', "");
    Expect(1, 6390, '\p{^	_Is_CANS}', "");
    Expect(1, 6390, '\P{	_Is_CANS}', "");
    Expect(0, 6390, '\P{^	_Is_CANS}', "");
    Error('\p{_:=Carian}');
    Error('\P{_:=Carian}');
    Expect(1, 66256, '\p{carian}', "");
    Expect(0, 66256, '\p{^carian}', "");
    Expect(0, 66256, '\P{carian}', "");
    Expect(1, 66256, '\P{^carian}', "");
    Expect(0, 66257, '\p{carian}', "");
    Expect(1, 66257, '\p{^carian}', "");
    Expect(1, 66257, '\P{carian}', "");
    Expect(0, 66257, '\P{^carian}', "");
    Expect(1, 66256, '\p{	_Carian}', "");
    Expect(0, 66256, '\p{^	_Carian}', "");
    Expect(0, 66256, '\P{	_Carian}', "");
    Expect(1, 66256, '\P{^	_Carian}', "");
    Expect(0, 66257, '\p{	_Carian}', "");
    Expect(1, 66257, '\p{^	_Carian}', "");
    Expect(1, 66257, '\P{	_Carian}', "");
    Expect(0, 66257, '\P{^	_Carian}', "");
    Error('\p{/a/ 	Is_carian}');
    Error('\P{/a/ 	Is_carian}');
    Expect(1, 66256, '\p{iscarian}', "");
    Expect(0, 66256, '\p{^iscarian}', "");
    Expect(0, 66256, '\P{iscarian}', "");
    Expect(1, 66256, '\P{^iscarian}', "");
    Expect(0, 66257, '\p{iscarian}', "");
    Expect(1, 66257, '\p{^iscarian}', "");
    Expect(1, 66257, '\P{iscarian}', "");
    Expect(0, 66257, '\P{^iscarian}', "");
    Expect(1, 66256, '\p{_-is_carian}', "");
    Expect(0, 66256, '\p{^_-is_carian}', "");
    Expect(0, 66256, '\P{_-is_carian}', "");
    Expect(1, 66256, '\P{^_-is_carian}', "");
    Expect(0, 66257, '\p{_-is_carian}', "");
    Expect(1, 66257, '\p{^_-is_carian}', "");
    Expect(1, 66257, '\P{_-is_carian}', "");
    Expect(0, 66257, '\P{^_-is_carian}', "");
    Error('\p{/a/ cari}');
    Error('\P{/a/ cari}');
    Expect(1, 66256, '\p{cari}', "");
    Expect(0, 66256, '\p{^cari}', "");
    Expect(0, 66256, '\P{cari}', "");
    Expect(1, 66256, '\P{^cari}', "");
    Expect(0, 66257, '\p{cari}', "");
    Expect(1, 66257, '\p{^cari}', "");
    Expect(1, 66257, '\P{cari}', "");
    Expect(0, 66257, '\P{^cari}', "");
    Expect(1, 66256, '\p{	Cari}', "");
    Expect(0, 66256, '\p{^	Cari}', "");
    Expect(0, 66256, '\P{	Cari}', "");
    Expect(1, 66256, '\P{^	Cari}', "");
    Expect(0, 66257, '\p{	Cari}', "");
    Expect(1, 66257, '\p{^	Cari}', "");
    Expect(1, 66257, '\P{	Cari}', "");
    Expect(0, 66257, '\P{^	Cari}', "");
    Error('\p{-IS_Cari:=}');
    Error('\P{-IS_Cari:=}');
    Expect(1, 66256, '\p{iscari}', "");
    Expect(0, 66256, '\p{^iscari}', "");
    Expect(0, 66256, '\P{iscari}', "");
    Expect(1, 66256, '\P{^iscari}', "");
    Expect(0, 66257, '\p{iscari}', "");
    Expect(1, 66257, '\p{^iscari}', "");
    Expect(1, 66257, '\P{iscari}', "");
    Expect(0, 66257, '\P{^iscari}', "");
    Expect(1, 66256, '\p{-_is_Cari}', "");
    Expect(0, 66256, '\p{^-_is_Cari}', "");
    Expect(0, 66256, '\P{-_is_Cari}', "");
    Expect(1, 66256, '\P{^-_is_Cari}', "");
    Expect(0, 66257, '\p{-_is_Cari}', "");
    Expect(1, 66257, '\p{^-_is_Cari}', "");
    Expect(1, 66257, '\P{-_is_Cari}', "");
    Expect(0, 66257, '\P{^-_is_Cari}', "");
    Error('\p{:= -CASE_Ignorable}');
    Error('\P{:= -CASE_Ignorable}');
    Expect(1, 917999, '\p{caseignorable}', "");
    Expect(0, 917999, '\p{^caseignorable}', "");
    Expect(0, 917999, '\P{caseignorable}', "");
    Expect(1, 917999, '\P{^caseignorable}', "");
    Expect(0, 918000, '\p{caseignorable}', "");
    Expect(1, 918000, '\p{^caseignorable}', "");
    Expect(1, 918000, '\P{caseignorable}', "");
    Expect(0, 918000, '\P{^caseignorable}', "");
    Expect(1, 917999, '\p{ -Case_Ignorable}', "");
    Expect(0, 917999, '\p{^ -Case_Ignorable}', "");
    Expect(0, 917999, '\P{ -Case_Ignorable}', "");
    Expect(1, 917999, '\P{^ -Case_Ignorable}', "");
    Expect(0, 918000, '\p{ -Case_Ignorable}', "");
    Expect(1, 918000, '\p{^ -Case_Ignorable}', "");
    Expect(1, 918000, '\P{ -Case_Ignorable}', "");
    Expect(0, 918000, '\P{^ -Case_Ignorable}', "");
    Error('\p{_:=IS_Case_IGNORABLE}');
    Error('\P{_:=IS_Case_IGNORABLE}');
    Expect(1, 917999, '\p{iscaseignorable}', "");
    Expect(0, 917999, '\p{^iscaseignorable}', "");
    Expect(0, 917999, '\P{iscaseignorable}', "");
    Expect(1, 917999, '\P{^iscaseignorable}', "");
    Expect(0, 918000, '\p{iscaseignorable}', "");
    Expect(1, 918000, '\p{^iscaseignorable}', "");
    Expect(1, 918000, '\P{iscaseignorable}', "");
    Expect(0, 918000, '\P{^iscaseignorable}', "");
    Expect(1, 917999, '\p{  IS_Case_Ignorable}', "");
    Expect(0, 917999, '\p{^  IS_Case_Ignorable}', "");
    Expect(0, 917999, '\P{  IS_Case_Ignorable}', "");
    Expect(1, 917999, '\P{^  IS_Case_Ignorable}', "");
    Expect(0, 918000, '\p{  IS_Case_Ignorable}', "");
    Expect(1, 918000, '\p{^  IS_Case_Ignorable}', "");
    Expect(1, 918000, '\P{  IS_Case_Ignorable}', "");
    Expect(0, 918000, '\P{^  IS_Case_Ignorable}', "");
    Error('\p{:=  CI}');
    Error('\P{:=  CI}');
    Expect(1, 917999, '\p{ci}', "");
    Expect(0, 917999, '\p{^ci}', "");
    Expect(0, 917999, '\P{ci}', "");
    Expect(1, 917999, '\P{^ci}', "");
    Expect(0, 918000, '\p{ci}', "");
    Expect(1, 918000, '\p{^ci}', "");
    Expect(1, 918000, '\P{ci}', "");
    Expect(0, 918000, '\P{^ci}', "");
    Expect(1, 917999, '\p{ -CI}', "");
    Expect(0, 917999, '\p{^ -CI}', "");
    Expect(0, 917999, '\P{ -CI}', "");
    Expect(1, 917999, '\P{^ -CI}', "");
    Expect(0, 918000, '\p{ -CI}', "");
    Expect(1, 918000, '\p{^ -CI}', "");
    Expect(1, 918000, '\P{ -CI}', "");
    Expect(0, 918000, '\P{^ -CI}', "");
    Error('\p{-_Is_CI/a/}');
    Error('\P{-_Is_CI/a/}');
    Expect(1, 917999, '\p{isci}', "");
    Expect(0, 917999, '\p{^isci}', "");
    Expect(0, 917999, '\P{isci}', "");
    Expect(1, 917999, '\P{^isci}', "");
    Expect(0, 918000, '\p{isci}', "");
    Expect(1, 918000, '\p{^isci}', "");
    Expect(1, 918000, '\P{isci}', "");
    Expect(0, 918000, '\P{^isci}', "");
    Expect(1, 917999, '\p{	is_CI}', "");
    Expect(0, 917999, '\p{^	is_CI}', "");
    Expect(0, 917999, '\P{	is_CI}', "");
    Expect(1, 917999, '\P{^	is_CI}', "");
    Expect(0, 918000, '\p{	is_CI}', "");
    Expect(1, 918000, '\p{^	is_CI}', "");
    Expect(1, 918000, '\P{	is_CI}', "");
    Expect(0, 918000, '\P{^	is_CI}', "");
    Error('\p{:=Cased}');
    Error('\P{:=Cased}');
    Expect(1, 127369, '\p{cased}', "");
    Expect(0, 127369, '\p{^cased}', "");
    Expect(0, 127369, '\P{cased}', "");
    Expect(1, 127369, '\P{^cased}', "");
    Expect(0, 127370, '\p{cased}', "");
    Expect(1, 127370, '\p{^cased}', "");
    Expect(1, 127370, '\P{cased}', "");
    Expect(0, 127370, '\P{^cased}', "");
    Expect(1, 127369, '\p{_Cased}', "");
    Expect(0, 127369, '\p{^_Cased}', "");
    Expect(0, 127369, '\P{_Cased}', "");
    Expect(1, 127369, '\P{^_Cased}', "");
    Expect(0, 127370, '\p{_Cased}', "");
    Expect(1, 127370, '\p{^_Cased}', "");
    Expect(1, 127370, '\P{_Cased}', "");
    Expect(0, 127370, '\P{^_Cased}', "");
    Error('\p{/a/-_is_Cased}');
    Error('\P{/a/-_is_Cased}');
    Expect(1, 127369, '\p{iscased}', "");
    Expect(0, 127369, '\p{^iscased}', "");
    Expect(0, 127369, '\P{iscased}', "");
    Expect(1, 127369, '\P{^iscased}', "");
    Expect(0, 127370, '\p{iscased}', "");
    Expect(1, 127370, '\p{^iscased}', "");
    Expect(1, 127370, '\P{iscased}', "");
    Expect(0, 127370, '\P{^iscased}', "");
    Expect(1, 127369, '\p{is_Cased}', "");
    Expect(0, 127369, '\p{^is_Cased}', "");
    Expect(0, 127369, '\P{is_Cased}', "");
    Expect(1, 127369, '\P{^is_Cased}', "");
    Expect(0, 127370, '\p{is_Cased}', "");
    Expect(1, 127370, '\p{^is_Cased}', "");
    Expect(1, 127370, '\P{is_Cased}', "");
    Expect(0, 127370, '\P{^is_Cased}', "");
    Error('\p{ :=Cased_LETTER}');
    Error('\P{ :=Cased_LETTER}');
    Expect(1, 125251, '\p{casedletter}', "");
    Expect(0, 125251, '\p{^casedletter}', "");
    Expect(0, 125251, '\P{casedletter}', "");
    Expect(1, 125251, '\P{^casedletter}', "");
    Expect(0, 125252, '\p{casedletter}', "");
    Expect(1, 125252, '\p{^casedletter}', "");
    Expect(1, 125252, '\P{casedletter}', "");
    Expect(0, 125252, '\P{^casedletter}', "");
    Expect(1, 125251, '\p{	cased_letter}', "");
    Expect(0, 125251, '\p{^	cased_letter}', "");
    Expect(0, 125251, '\P{	cased_letter}', "");
    Expect(1, 125251, '\P{^	cased_letter}', "");
    Expect(0, 125252, '\p{	cased_letter}', "");
    Expect(1, 125252, '\p{^	cased_letter}', "");
    Expect(1, 125252, '\P{	cased_letter}', "");
    Expect(0, 125252, '\P{^	cased_letter}', "");
    Error('\p{	/a/Is_cased_LETTER}');
    Error('\P{	/a/Is_cased_LETTER}');
    Expect(1, 125251, '\p{iscasedletter}', "");
    Expect(0, 125251, '\p{^iscasedletter}', "");
    Expect(0, 125251, '\P{iscasedletter}', "");
    Expect(1, 125251, '\P{^iscasedletter}', "");
    Expect(0, 125252, '\p{iscasedletter}', "");
    Expect(1, 125252, '\p{^iscasedletter}', "");
    Expect(1, 125252, '\P{iscasedletter}', "");
    Expect(0, 125252, '\P{^iscasedletter}', "");
    Expect(1, 125251, '\p{_Is_Cased_Letter}', "");
    Expect(0, 125251, '\p{^_Is_Cased_Letter}', "");
    Expect(0, 125251, '\P{_Is_Cased_Letter}', "");
    Expect(1, 125251, '\P{^_Is_Cased_Letter}', "");
    Expect(0, 125252, '\p{_Is_Cased_Letter}', "");
    Expect(1, 125252, '\p{^_Is_Cased_Letter}', "");
    Expect(1, 125252, '\P{_Is_Cased_Letter}', "");
    Expect(0, 125252, '\P{^_Is_Cased_Letter}', "");
    Error('\p{-	LC/a/}');
    Error('\P{-	LC/a/}');
    Expect(1, 125251, '\p{lc}', "");
    Expect(0, 125251, '\p{^lc}', "");
    Expect(0, 125251, '\P{lc}', "");
    Expect(1, 125251, '\P{^lc}', "");
    Expect(0, 125252, '\p{lc}', "");
    Expect(1, 125252, '\p{^lc}', "");
    Expect(1, 125252, '\P{lc}', "");
    Expect(0, 125252, '\P{^lc}', "");
    Expect(1, 125251, '\p{ lc}', "");
    Expect(0, 125251, '\p{^ lc}', "");
    Expect(0, 125251, '\P{ lc}', "");
    Expect(1, 125251, '\P{^ lc}', "");
    Expect(0, 125252, '\p{ lc}', "");
    Expect(1, 125252, '\p{^ lc}', "");
    Expect(1, 125252, '\P{ lc}', "");
    Expect(0, 125252, '\P{^ lc}', "");
    Error('\p{ is_LC/a/}');
    Error('\P{ is_LC/a/}');
    Expect(1, 125251, '\p{islc}', "");
    Expect(0, 125251, '\p{^islc}', "");
    Expect(0, 125251, '\P{islc}', "");
    Expect(1, 125251, '\P{^islc}', "");
    Expect(0, 125252, '\p{islc}', "");
    Expect(1, 125252, '\p{^islc}', "");
    Expect(1, 125252, '\P{islc}', "");
    Expect(0, 125252, '\P{^islc}', "");
    Expect(1, 125251, '\p{_-IS_LC}', "");
    Expect(0, 125251, '\p{^_-IS_LC}', "");
    Expect(0, 125251, '\P{_-IS_LC}', "");
    Expect(1, 125251, '\P{^_-IS_LC}', "");
    Expect(0, 125252, '\p{_-IS_LC}', "");
    Expect(1, 125252, '\p{^_-IS_LC}', "");
    Expect(1, 125252, '\P{_-IS_LC}', "");
    Expect(0, 125252, '\P{^_-IS_LC}', "");
    Error('\p{	/a/l_}');
    Error('\P{	/a/l_}');
    Expect(1, 125251, '\p{l_}', "");
    Expect(0, 125251, '\p{^l_}', "");
    Expect(0, 125251, '\P{l_}', "");
    Expect(1, 125251, '\P{^l_}', "");
    Expect(0, 125252, '\p{l_}', "");
    Expect(1, 125252, '\p{^l_}', "");
    Expect(1, 125252, '\P{l_}', "");
    Expect(0, 125252, '\P{^l_}', "");
    Expect(1, 125251, '\p{  L_}', "");
    Expect(0, 125251, '\p{^  L_}', "");
    Expect(0, 125251, '\P{  L_}', "");
    Expect(1, 125251, '\P{^  L_}', "");
    Expect(0, 125252, '\p{  L_}', "");
    Expect(1, 125252, '\p{^  L_}', "");
    Expect(1, 125252, '\P{  L_}', "");
    Expect(0, 125252, '\P{^  L_}', "");
    Error('\p{:=Is_L_}');
    Error('\P{:=Is_L_}');
    Expect(1, 125251, '\p{isl_}', "");
    Expect(0, 125251, '\p{^isl_}', "");
    Expect(0, 125251, '\P{isl_}', "");
    Expect(1, 125251, '\P{^isl_}', "");
    Expect(0, 125252, '\p{isl_}', "");
    Expect(1, 125252, '\p{^isl_}', "");
    Expect(1, 125252, '\P{isl_}', "");
    Expect(0, 125252, '\P{^isl_}', "");
    Expect(1, 125251, '\p{ 	Is_l_}', "");
    Expect(0, 125251, '\p{^ 	Is_l_}', "");
    Expect(0, 125251, '\P{ 	Is_l_}', "");
    Expect(1, 125251, '\P{^ 	Is_l_}', "");
    Expect(0, 125252, '\p{ 	Is_l_}', "");
    Expect(1, 125252, '\p{^ 	Is_l_}', "");
    Expect(1, 125252, '\P{ 	Is_l_}', "");
    Expect(0, 125252, '\P{^ 	Is_l_}', "");
    Error('\p{:=	 l&}');
    Error('\P{:=	 l&}');
    Expect(1, 125251, '\p{l&}', "");
    Expect(0, 125251, '\p{^l&}', "");
    Expect(0, 125251, '\P{l&}', "");
    Expect(1, 125251, '\P{^l&}', "");
    Expect(0, 125252, '\p{l&}', "");
    Expect(1, 125252, '\p{^l&}', "");
    Expect(1, 125252, '\P{l&}', "");
    Expect(0, 125252, '\P{^l&}', "");
    Expect(1, 125251, '\p{	-L&}', "");
    Expect(0, 125251, '\p{^	-L&}', "");
    Expect(0, 125251, '\P{	-L&}', "");
    Expect(1, 125251, '\P{^	-L&}', "");
    Expect(0, 125252, '\p{	-L&}', "");
    Expect(1, 125252, '\p{^	-L&}', "");
    Expect(1, 125252, '\P{	-L&}', "");
    Expect(0, 125252, '\P{^	-L&}', "");
    Error('\p{ Is_l&:=}');
    Error('\P{ Is_l&:=}');
    Expect(1, 125251, '\p{isl&}', "");
    Expect(0, 125251, '\p{^isl&}', "");
    Expect(0, 125251, '\P{isl&}', "");
    Expect(1, 125251, '\P{^isl&}', "");
    Expect(0, 125252, '\p{isl&}', "");
    Expect(1, 125252, '\p{^isl&}', "");
    Expect(1, 125252, '\P{isl&}', "");
    Expect(0, 125252, '\P{^isl&}', "");
    Expect(1, 125251, '\p{ -IS_L&}', "");
    Expect(0, 125251, '\p{^ -IS_L&}', "");
    Expect(0, 125251, '\P{ -IS_L&}', "");
    Expect(1, 125251, '\P{^ -IS_L&}', "");
    Expect(0, 125252, '\p{ -IS_L&}', "");
    Expect(1, 125252, '\p{^ -IS_L&}', "");
    Expect(1, 125252, '\P{ -IS_L&}', "");
    Expect(0, 125252, '\P{^ -IS_L&}', "");
    Error('\p{_:=caucasian_ALBANIAN}');
    Error('\P{_:=caucasian_ALBANIAN}');
    Expect(1, 66927, '\p{caucasianalbanian}', "");
    Expect(0, 66927, '\p{^caucasianalbanian}', "");
    Expect(0, 66927, '\P{caucasianalbanian}', "");
    Expect(1, 66927, '\P{^caucasianalbanian}', "");
    Expect(0, 66928, '\p{caucasianalbanian}', "");
    Expect(1, 66928, '\p{^caucasianalbanian}', "");
    Expect(1, 66928, '\P{caucasianalbanian}', "");
    Expect(0, 66928, '\P{^caucasianalbanian}', "");
    Expect(1, 66927, '\p{_	caucasian_Albanian}', "");
    Expect(0, 66927, '\p{^_	caucasian_Albanian}', "");
    Expect(0, 66927, '\P{_	caucasian_Albanian}', "");
    Expect(1, 66927, '\P{^_	caucasian_Albanian}', "");
    Expect(0, 66928, '\p{_	caucasian_Albanian}', "");
    Expect(1, 66928, '\p{^_	caucasian_Albanian}', "");
    Expect(1, 66928, '\P{_	caucasian_Albanian}', "");
    Expect(0, 66928, '\P{^_	caucasian_Albanian}', "");
    Error('\p{/a/Is_caucasian_ALBANIAN}');
    Error('\P{/a/Is_caucasian_ALBANIAN}');
    Expect(1, 66927, '\p{iscaucasianalbanian}', "");
    Expect(0, 66927, '\p{^iscaucasianalbanian}', "");
    Expect(0, 66927, '\P{iscaucasianalbanian}', "");
    Expect(1, 66927, '\P{^iscaucasianalbanian}', "");
    Expect(0, 66928, '\p{iscaucasianalbanian}', "");
    Expect(1, 66928, '\p{^iscaucasianalbanian}', "");
    Expect(1, 66928, '\P{iscaucasianalbanian}', "");
    Expect(0, 66928, '\P{^iscaucasianalbanian}', "");
    Expect(1, 66927, '\p{ Is_CAUCASIAN_ALBANIAN}', "");
    Expect(0, 66927, '\p{^ Is_CAUCASIAN_ALBANIAN}', "");
    Expect(0, 66927, '\P{ Is_CAUCASIAN_ALBANIAN}', "");
    Expect(1, 66927, '\P{^ Is_CAUCASIAN_ALBANIAN}', "");
    Expect(0, 66928, '\p{ Is_CAUCASIAN_ALBANIAN}', "");
    Expect(1, 66928, '\p{^ Is_CAUCASIAN_ALBANIAN}', "");
    Expect(1, 66928, '\P{ Is_CAUCASIAN_ALBANIAN}', "");
    Expect(0, 66928, '\P{^ Is_CAUCASIAN_ALBANIAN}', "");
    Error('\p{-:=AGHB}');
    Error('\P{-:=AGHB}');
    Expect(1, 66927, '\p{aghb}', "");
    Expect(0, 66927, '\p{^aghb}', "");
    Expect(0, 66927, '\P{aghb}', "");
    Expect(1, 66927, '\P{^aghb}', "");
    Expect(0, 66928, '\p{aghb}', "");
    Expect(1, 66928, '\p{^aghb}', "");
    Expect(1, 66928, '\P{aghb}', "");
    Expect(0, 66928, '\P{^aghb}', "");
    Expect(1, 66927, '\p{ Aghb}', "");
    Expect(0, 66927, '\p{^ Aghb}', "");
    Expect(0, 66927, '\P{ Aghb}', "");
    Expect(1, 66927, '\P{^ Aghb}', "");
    Expect(0, 66928, '\p{ Aghb}', "");
    Expect(1, 66928, '\p{^ Aghb}', "");
    Expect(1, 66928, '\P{ Aghb}', "");
    Expect(0, 66928, '\P{^ Aghb}', "");
    Error('\p{:=	IS_Aghb}');
    Error('\P{:=	IS_Aghb}');
    Expect(1, 66927, '\p{isaghb}', "");
    Expect(0, 66927, '\p{^isaghb}', "");
    Expect(0, 66927, '\P{isaghb}', "");
    Expect(1, 66927, '\P{^isaghb}', "");
    Expect(0, 66928, '\p{isaghb}', "");
    Expect(1, 66928, '\p{^isaghb}', "");
    Expect(1, 66928, '\P{isaghb}', "");
    Expect(0, 66928, '\P{^isaghb}', "");
    Expect(1, 66927, '\p{ _is_aghb}', "");
    Expect(0, 66927, '\p{^ _is_aghb}', "");
    Expect(0, 66927, '\P{ _is_aghb}', "");
    Expect(1, 66927, '\P{^ _is_aghb}', "");
    Expect(0, 66928, '\p{ _is_aghb}', "");
    Expect(1, 66928, '\p{^ _is_aghb}', "");
    Expect(1, 66928, '\P{ _is_aghb}', "");
    Expect(0, 66928, '\P{^ _is_aghb}', "");
    Error('\p{/a/--chakma}');
    Error('\P{/a/--chakma}');
    Expect(1, 69958, '\p{chakma}', "");
    Expect(0, 69958, '\p{^chakma}', "");
    Expect(0, 69958, '\P{chakma}', "");
    Expect(1, 69958, '\P{^chakma}', "");
    Expect(0, 69959, '\p{chakma}', "");
    Expect(1, 69959, '\p{^chakma}', "");
    Expect(1, 69959, '\P{chakma}', "");
    Expect(0, 69959, '\P{^chakma}', "");
    Expect(1, 69958, '\p{  Chakma}', "");
    Expect(0, 69958, '\p{^  Chakma}', "");
    Expect(0, 69958, '\P{  Chakma}', "");
    Expect(1, 69958, '\P{^  Chakma}', "");
    Expect(0, 69959, '\p{  Chakma}', "");
    Expect(1, 69959, '\p{^  Chakma}', "");
    Expect(1, 69959, '\P{  Chakma}', "");
    Expect(0, 69959, '\P{^  Chakma}', "");
    Error('\p{_/a/IS_CHAKMA}');
    Error('\P{_/a/IS_CHAKMA}');
    Expect(1, 69958, '\p{ischakma}', "");
    Expect(0, 69958, '\p{^ischakma}', "");
    Expect(0, 69958, '\P{ischakma}', "");
    Expect(1, 69958, '\P{^ischakma}', "");
    Expect(0, 69959, '\p{ischakma}', "");
    Expect(1, 69959, '\p{^ischakma}', "");
    Expect(1, 69959, '\P{ischakma}', "");
    Expect(0, 69959, '\P{^ischakma}', "");
    Expect(1, 69958, '\p{--is_Chakma}', "");
    Expect(0, 69958, '\p{^--is_Chakma}', "");
    Expect(0, 69958, '\P{--is_Chakma}', "");
    Expect(1, 69958, '\P{^--is_Chakma}', "");
    Expect(0, 69959, '\p{--is_Chakma}', "");
    Expect(1, 69959, '\p{^--is_Chakma}', "");
    Expect(1, 69959, '\P{--is_Chakma}', "");
    Expect(0, 69959, '\P{^--is_Chakma}', "");
    Error('\p{	:=Cakm}');
    Error('\P{	:=Cakm}');
    Expect(1, 69958, '\p{cakm}', "");
    Expect(0, 69958, '\p{^cakm}', "");
    Expect(0, 69958, '\P{cakm}', "");
    Expect(1, 69958, '\P{^cakm}', "");
    Expect(0, 69959, '\p{cakm}', "");
    Expect(1, 69959, '\p{^cakm}', "");
    Expect(1, 69959, '\P{cakm}', "");
    Expect(0, 69959, '\P{^cakm}', "");
    Expect(1, 69958, '\p{		Cakm}', "");
    Expect(0, 69958, '\p{^		Cakm}', "");
    Expect(0, 69958, '\P{		Cakm}', "");
    Expect(1, 69958, '\P{^		Cakm}', "");
    Expect(0, 69959, '\p{		Cakm}', "");
    Expect(1, 69959, '\p{^		Cakm}', "");
    Expect(1, 69959, '\P{		Cakm}', "");
    Expect(0, 69959, '\P{^		Cakm}', "");
    Error('\p{/a/_-Is_Cakm}');
    Error('\P{/a/_-Is_Cakm}');
    Expect(1, 69958, '\p{iscakm}', "");
    Expect(0, 69958, '\p{^iscakm}', "");
    Expect(0, 69958, '\P{iscakm}', "");
    Expect(1, 69958, '\P{^iscakm}', "");
    Expect(0, 69959, '\p{iscakm}', "");
    Expect(1, 69959, '\p{^iscakm}', "");
    Expect(1, 69959, '\P{iscakm}', "");
    Expect(0, 69959, '\P{^iscakm}', "");
    Expect(1, 69958, '\p{-_IS_Cakm}', "");
    Expect(0, 69958, '\p{^-_IS_Cakm}', "");
    Expect(0, 69958, '\P{-_IS_Cakm}', "");
    Expect(1, 69958, '\P{^-_IS_Cakm}', "");
    Expect(0, 69959, '\p{-_IS_Cakm}', "");
    Expect(1, 69959, '\p{^-_IS_Cakm}', "");
    Expect(1, 69959, '\P{-_IS_Cakm}', "");
    Expect(0, 69959, '\P{^-_IS_Cakm}', "");
    Error('\p{		CHAM/a/}');
    Error('\P{		CHAM/a/}');
    Expect(1, 43615, '\p{cham}', "");
    Expect(0, 43615, '\p{^cham}', "");
    Expect(0, 43615, '\P{cham}', "");
    Expect(1, 43615, '\P{^cham}', "");
    Expect(0, 43616, '\p{cham}', "");
    Expect(1, 43616, '\p{^cham}', "");
    Expect(1, 43616, '\P{cham}', "");
    Expect(0, 43616, '\P{^cham}', "");
    Expect(1, 43615, '\p{-Cham}', "");
    Expect(0, 43615, '\p{^-Cham}', "");
    Expect(0, 43615, '\P{-Cham}', "");
    Expect(1, 43615, '\P{^-Cham}', "");
    Expect(0, 43616, '\p{-Cham}', "");
    Expect(1, 43616, '\p{^-Cham}', "");
    Expect(1, 43616, '\P{-Cham}', "");
    Expect(0, 43616, '\P{^-Cham}', "");
    Error('\p{:=-	Is_cham}');
    Error('\P{:=-	Is_cham}');
    Expect(1, 43615, '\p{ischam}', "");
    Expect(0, 43615, '\p{^ischam}', "");
    Expect(0, 43615, '\P{ischam}', "");
    Expect(1, 43615, '\P{^ischam}', "");
    Expect(0, 43616, '\p{ischam}', "");
    Expect(1, 43616, '\p{^ischam}', "");
    Expect(1, 43616, '\P{ischam}', "");
    Expect(0, 43616, '\P{^ischam}', "");
    Expect(1, 43615, '\p{--Is_Cham}', "");
    Expect(0, 43615, '\p{^--Is_Cham}', "");
    Expect(0, 43615, '\P{--Is_Cham}', "");
    Expect(1, 43615, '\P{^--Is_Cham}', "");
    Expect(0, 43616, '\p{--Is_Cham}', "");
    Expect(1, 43616, '\p{^--Is_Cham}', "");
    Expect(1, 43616, '\P{--Is_Cham}', "");
    Expect(0, 43616, '\P{^--Is_Cham}', "");
    Error('\p{ -Changes_When_Casefolded:=}');
    Error('\P{ -Changes_When_Casefolded:=}');
    Expect(1, 125217, '\p{changeswhencasefolded}', "");
    Expect(0, 125217, '\p{^changeswhencasefolded}', "");
    Expect(0, 125217, '\P{changeswhencasefolded}', "");
    Expect(1, 125217, '\P{^changeswhencasefolded}', "");
    Expect(0, 125218, '\p{changeswhencasefolded}', "");
    Expect(1, 125218, '\p{^changeswhencasefolded}', "");
    Expect(1, 125218, '\P{changeswhencasefolded}', "");
    Expect(0, 125218, '\P{^changeswhencasefolded}', "");
    Expect(1, 125217, '\p{_ Changes_When_casefolded}', "");
    Expect(0, 125217, '\p{^_ Changes_When_casefolded}', "");
    Expect(0, 125217, '\P{_ Changes_When_casefolded}', "");
    Expect(1, 125217, '\P{^_ Changes_When_casefolded}', "");
    Expect(0, 125218, '\p{_ Changes_When_casefolded}', "");
    Expect(1, 125218, '\p{^_ Changes_When_casefolded}', "");
    Expect(1, 125218, '\P{_ Changes_When_casefolded}', "");
    Expect(0, 125218, '\P{^_ Changes_When_casefolded}', "");
    Error('\p{__is_changes_When_Casefolded:=}');
    Error('\P{__is_changes_When_Casefolded:=}');
    Expect(1, 125217, '\p{ischangeswhencasefolded}', "");
    Expect(0, 125217, '\p{^ischangeswhencasefolded}', "");
    Expect(0, 125217, '\P{ischangeswhencasefolded}', "");
    Expect(1, 125217, '\P{^ischangeswhencasefolded}', "");
    Expect(0, 125218, '\p{ischangeswhencasefolded}', "");
    Expect(1, 125218, '\p{^ischangeswhencasefolded}', "");
    Expect(1, 125218, '\P{ischangeswhencasefolded}', "");
    Expect(0, 125218, '\P{^ischangeswhencasefolded}', "");
    Expect(1, 125217, '\p{ -is_Changes_when_CASEFOLDED}', "");
    Expect(0, 125217, '\p{^ -is_Changes_when_CASEFOLDED}', "");
    Expect(0, 125217, '\P{ -is_Changes_when_CASEFOLDED}', "");
    Expect(1, 125217, '\P{^ -is_Changes_when_CASEFOLDED}', "");
    Expect(0, 125218, '\p{ -is_Changes_when_CASEFOLDED}', "");
    Expect(1, 125218, '\p{^ -is_Changes_when_CASEFOLDED}', "");
    Expect(1, 125218, '\P{ -is_Changes_when_CASEFOLDED}', "");
    Expect(0, 125218, '\P{^ -is_Changes_when_CASEFOLDED}', "");
    Error('\p{-	cwcf:=}');
    Error('\P{-	cwcf:=}');
    Expect(1, 125217, '\p{cwcf}', "");
    Expect(0, 125217, '\p{^cwcf}', "");
    Expect(0, 125217, '\P{cwcf}', "");
    Expect(1, 125217, '\P{^cwcf}', "");
    Expect(0, 125218, '\p{cwcf}', "");
    Expect(1, 125218, '\p{^cwcf}', "");
    Expect(1, 125218, '\P{cwcf}', "");
    Expect(0, 125218, '\P{^cwcf}', "");
    Expect(1, 125217, '\p{-_CWCF}', "");
    Expect(0, 125217, '\p{^-_CWCF}', "");
    Expect(0, 125217, '\P{-_CWCF}', "");
    Expect(1, 125217, '\P{^-_CWCF}', "");
    Expect(0, 125218, '\p{-_CWCF}', "");
    Expect(1, 125218, '\p{^-_CWCF}', "");
    Expect(1, 125218, '\P{-_CWCF}', "");
    Expect(0, 125218, '\P{^-_CWCF}', "");
    Error('\p{ :=Is_CWCF}');
    Error('\P{ :=Is_CWCF}');
    Expect(1, 125217, '\p{iscwcf}', "");
    Expect(0, 125217, '\p{^iscwcf}', "");
    Expect(0, 125217, '\P{iscwcf}', "");
    Expect(1, 125217, '\P{^iscwcf}', "");
    Expect(0, 125218, '\p{iscwcf}', "");
    Expect(1, 125218, '\p{^iscwcf}', "");
    Expect(1, 125218, '\P{iscwcf}', "");
    Expect(0, 125218, '\P{^iscwcf}', "");
    Expect(1, 125217, '\p{__IS_CWCF}', "");
    Expect(0, 125217, '\p{^__IS_CWCF}', "");
    Expect(0, 125217, '\P{__IS_CWCF}', "");
    Expect(1, 125217, '\P{^__IS_CWCF}', "");
    Expect(0, 125218, '\p{__IS_CWCF}', "");
    Expect(1, 125218, '\p{^__IS_CWCF}', "");
    Expect(1, 125218, '\P{__IS_CWCF}', "");
    Expect(0, 125218, '\P{^__IS_CWCF}', "");
    Error('\p{__Changes_When_CASEMAPPED:=}');
    Error('\P{__Changes_When_CASEMAPPED:=}');
    Expect(1, 125251, '\p{changeswhencasemapped}', "");
    Expect(0, 125251, '\p{^changeswhencasemapped}', "");
    Expect(0, 125251, '\P{changeswhencasemapped}', "");
    Expect(1, 125251, '\P{^changeswhencasemapped}', "");
    Expect(0, 125252, '\p{changeswhencasemapped}', "");
    Expect(1, 125252, '\p{^changeswhencasemapped}', "");
    Expect(1, 125252, '\P{changeswhencasemapped}', "");
    Expect(0, 125252, '\P{^changeswhencasemapped}', "");
    Expect(1, 125251, '\p{  Changes_When_CASEMAPPED}', "");
    Expect(0, 125251, '\p{^  Changes_When_CASEMAPPED}', "");
    Expect(0, 125251, '\P{  Changes_When_CASEMAPPED}', "");
    Expect(1, 125251, '\P{^  Changes_When_CASEMAPPED}', "");
    Expect(0, 125252, '\p{  Changes_When_CASEMAPPED}', "");
    Expect(1, 125252, '\p{^  Changes_When_CASEMAPPED}', "");
    Expect(1, 125252, '\P{  Changes_When_CASEMAPPED}', "");
    Expect(0, 125252, '\P{^  Changes_When_CASEMAPPED}', "");
    Error('\p{:= IS_Changes_WHEN_casemapped}');
    Error('\P{:= IS_Changes_WHEN_casemapped}');
    Expect(1, 125251, '\p{ischangeswhencasemapped}', "");
    Expect(0, 125251, '\p{^ischangeswhencasemapped}', "");
    Expect(0, 125251, '\P{ischangeswhencasemapped}', "");
    Expect(1, 125251, '\P{^ischangeswhencasemapped}', "");
    Expect(0, 125252, '\p{ischangeswhencasemapped}', "");
    Expect(1, 125252, '\p{^ischangeswhencasemapped}', "");
    Expect(1, 125252, '\P{ischangeswhencasemapped}', "");
    Expect(0, 125252, '\P{^ischangeswhencasemapped}', "");
    Expect(1, 125251, '\p{ 	Is_CHANGES_when_Casemapped}', "");
    Expect(0, 125251, '\p{^ 	Is_CHANGES_when_Casemapped}', "");
    Expect(0, 125251, '\P{ 	Is_CHANGES_when_Casemapped}', "");
    Expect(1, 125251, '\P{^ 	Is_CHANGES_when_Casemapped}', "");
    Expect(0, 125252, '\p{ 	Is_CHANGES_when_Casemapped}', "");
    Expect(1, 125252, '\p{^ 	Is_CHANGES_when_Casemapped}', "");
    Expect(1, 125252, '\P{ 	Is_CHANGES_when_Casemapped}', "");
    Expect(0, 125252, '\P{^ 	Is_CHANGES_when_Casemapped}', "");
    Error('\p{ /a/cwcm}');
    Error('\P{ /a/cwcm}');
    Expect(1, 125251, '\p{cwcm}', "");
    Expect(0, 125251, '\p{^cwcm}', "");
    Expect(0, 125251, '\P{cwcm}', "");
    Expect(1, 125251, '\P{^cwcm}', "");
    Expect(0, 125252, '\p{cwcm}', "");
    Expect(1, 125252, '\p{^cwcm}', "");
    Expect(1, 125252, '\P{cwcm}', "");
    Expect(0, 125252, '\P{^cwcm}', "");
    Expect(1, 125251, '\p{	CWCM}', "");
    Expect(0, 125251, '\p{^	CWCM}', "");
    Expect(0, 125251, '\P{	CWCM}', "");
    Expect(1, 125251, '\P{^	CWCM}', "");
    Expect(0, 125252, '\p{	CWCM}', "");
    Expect(1, 125252, '\p{^	CWCM}', "");
    Expect(1, 125252, '\P{	CWCM}', "");
    Expect(0, 125252, '\P{^	CWCM}', "");
    Error('\p{	/a/is_CWCM}');
    Error('\P{	/a/is_CWCM}');
    Expect(1, 125251, '\p{iscwcm}', "");
    Expect(0, 125251, '\p{^iscwcm}', "");
    Expect(0, 125251, '\P{iscwcm}', "");
    Expect(1, 125251, '\P{^iscwcm}', "");
    Expect(0, 125252, '\p{iscwcm}', "");
    Expect(1, 125252, '\p{^iscwcm}', "");
    Expect(1, 125252, '\P{iscwcm}', "");
    Expect(0, 125252, '\P{^iscwcm}', "");
    Expect(1, 125251, '\p{	IS_cwcm}', "");
    Expect(0, 125251, '\p{^	IS_cwcm}', "");
    Expect(0, 125251, '\P{	IS_cwcm}', "");
    Expect(1, 125251, '\P{^	IS_cwcm}', "");
    Expect(0, 125252, '\p{	IS_cwcm}', "");
    Expect(1, 125252, '\p{^	IS_cwcm}', "");
    Expect(1, 125252, '\P{	IS_cwcm}', "");
    Expect(0, 125252, '\P{^	IS_cwcm}', "");
    Error('\p{/a/-Changes_When_Lowercased}');
    Error('\P{/a/-Changes_When_Lowercased}');
    Expect(1, 125217, '\p{changeswhenlowercased}', "");
    Expect(0, 125217, '\p{^changeswhenlowercased}', "");
    Expect(0, 125217, '\P{changeswhenlowercased}', "");
    Expect(1, 125217, '\P{^changeswhenlowercased}', "");
    Expect(0, 125218, '\p{changeswhenlowercased}', "");
    Expect(1, 125218, '\p{^changeswhenlowercased}', "");
    Expect(1, 125218, '\P{changeswhenlowercased}', "");
    Expect(0, 125218, '\P{^changeswhenlowercased}', "");
    Expect(1, 125217, '\p{-	CHANGES_When_LOWERCASED}', "");
    Expect(0, 125217, '\p{^-	CHANGES_When_LOWERCASED}', "");
    Expect(0, 125217, '\P{-	CHANGES_When_LOWERCASED}', "");
    Expect(1, 125217, '\P{^-	CHANGES_When_LOWERCASED}', "");
    Expect(0, 125218, '\p{-	CHANGES_When_LOWERCASED}', "");
    Expect(1, 125218, '\p{^-	CHANGES_When_LOWERCASED}', "");
    Expect(1, 125218, '\P{-	CHANGES_When_LOWERCASED}', "");
    Expect(0, 125218, '\P{^-	CHANGES_When_LOWERCASED}', "");
    Error('\p{	Is_Changes_When_LOWERCASED/a/}');
    Error('\P{	Is_Changes_When_LOWERCASED/a/}');
    Expect(1, 125217, '\p{ischangeswhenlowercased}', "");
    Expect(0, 125217, '\p{^ischangeswhenlowercased}', "");
    Expect(0, 125217, '\P{ischangeswhenlowercased}', "");
    Expect(1, 125217, '\P{^ischangeswhenlowercased}', "");
    Expect(0, 125218, '\p{ischangeswhenlowercased}', "");
    Expect(1, 125218, '\p{^ischangeswhenlowercased}', "");
    Expect(1, 125218, '\P{ischangeswhenlowercased}', "");
    Expect(0, 125218, '\P{^ischangeswhenlowercased}', "");
    Expect(1, 125217, '\p{ Is_changes_when_Lowercased}', "");
    Expect(0, 125217, '\p{^ Is_changes_when_Lowercased}', "");
    Expect(0, 125217, '\P{ Is_changes_when_Lowercased}', "");
    Expect(1, 125217, '\P{^ Is_changes_when_Lowercased}', "");
    Expect(0, 125218, '\p{ Is_changes_when_Lowercased}', "");
    Expect(1, 125218, '\p{^ Is_changes_when_Lowercased}', "");
    Expect(1, 125218, '\P{ Is_changes_when_Lowercased}', "");
    Expect(0, 125218, '\P{^ Is_changes_when_Lowercased}', "");
    Error('\p{/a/-CWL}');
    Error('\P{/a/-CWL}');
    Expect(1, 125217, '\p{cwl}', "");
    Expect(0, 125217, '\p{^cwl}', "");
    Expect(0, 125217, '\P{cwl}', "");
    Expect(1, 125217, '\P{^cwl}', "");
    Expect(0, 125218, '\p{cwl}', "");
    Expect(1, 125218, '\p{^cwl}', "");
    Expect(1, 125218, '\P{cwl}', "");
    Expect(0, 125218, '\P{^cwl}', "");
    Expect(1, 125217, '\p{_CWL}', "");
    Expect(0, 125217, '\p{^_CWL}', "");
    Expect(0, 125217, '\P{_CWL}', "");
    Expect(1, 125217, '\P{^_CWL}', "");
    Expect(0, 125218, '\p{_CWL}', "");
    Expect(1, 125218, '\p{^_CWL}', "");
    Expect(1, 125218, '\P{_CWL}', "");
    Expect(0, 125218, '\P{^_CWL}', "");
    Error('\p{:=	-Is_CWL}');
    Error('\P{:=	-Is_CWL}');
    Expect(1, 125217, '\p{iscwl}', "");
    Expect(0, 125217, '\p{^iscwl}', "");
    Expect(0, 125217, '\P{iscwl}', "");
    Expect(1, 125217, '\P{^iscwl}', "");
    Expect(0, 125218, '\p{iscwl}', "");
    Expect(1, 125218, '\p{^iscwl}', "");
    Expect(1, 125218, '\P{iscwl}', "");
    Expect(0, 125218, '\P{^iscwl}', "");
    Expect(1, 125217, '\p{	 Is_cwl}', "");
    Expect(0, 125217, '\p{^	 Is_cwl}', "");
    Expect(0, 125217, '\P{	 Is_cwl}', "");
    Expect(1, 125217, '\P{^	 Is_cwl}', "");
    Expect(0, 125218, '\p{	 Is_cwl}', "");
    Expect(1, 125218, '\p{^	 Is_cwl}', "");
    Expect(1, 125218, '\P{	 Is_cwl}', "");
    Expect(0, 125218, '\P{^	 Is_cwl}', "");
    Error('\p{-/a/changes_When_NFKC_CASEFOLDED}');
    Error('\P{-/a/changes_When_NFKC_CASEFOLDED}');
    Expect(1, 921599, '\p{changeswhennfkccasefolded}', "");
    Expect(0, 921599, '\p{^changeswhennfkccasefolded}', "");
    Expect(0, 921599, '\P{changeswhennfkccasefolded}', "");
    Expect(1, 921599, '\P{^changeswhennfkccasefolded}', "");
    Expect(0, 921600, '\p{changeswhennfkccasefolded}', "");
    Expect(1, 921600, '\p{^changeswhennfkccasefolded}', "");
    Expect(1, 921600, '\P{changeswhennfkccasefolded}', "");
    Expect(0, 921600, '\P{^changeswhennfkccasefolded}', "");
    Expect(1, 921599, '\p{- Changes_When_NFKC_Casefolded}', "");
    Expect(0, 921599, '\p{^- Changes_When_NFKC_Casefolded}', "");
    Expect(0, 921599, '\P{- Changes_When_NFKC_Casefolded}', "");
    Expect(1, 921599, '\P{^- Changes_When_NFKC_Casefolded}', "");
    Expect(0, 921600, '\p{- Changes_When_NFKC_Casefolded}', "");
    Expect(1, 921600, '\p{^- Changes_When_NFKC_Casefolded}', "");
    Expect(1, 921600, '\P{- Changes_When_NFKC_Casefolded}', "");
    Expect(0, 921600, '\P{^- Changes_When_NFKC_Casefolded}', "");
    Error('\p{	:=Is_Changes_when_nfkc_Casefolded}');
    Error('\P{	:=Is_Changes_when_nfkc_Casefolded}');
    Expect(1, 921599, '\p{ischangeswhennfkccasefolded}', "");
    Expect(0, 921599, '\p{^ischangeswhennfkccasefolded}', "");
    Expect(0, 921599, '\P{ischangeswhennfkccasefolded}', "");
    Expect(1, 921599, '\P{^ischangeswhennfkccasefolded}', "");
    Expect(0, 921600, '\p{ischangeswhennfkccasefolded}', "");
    Expect(1, 921600, '\p{^ischangeswhennfkccasefolded}', "");
    Expect(1, 921600, '\P{ischangeswhennfkccasefolded}', "");
    Expect(0, 921600, '\P{^ischangeswhennfkccasefolded}', "");
    Expect(1, 921599, '\p{-IS_CHANGES_WHEN_NFKC_Casefolded}', "");
    Expect(0, 921599, '\p{^-IS_CHANGES_WHEN_NFKC_Casefolded}', "");
    Expect(0, 921599, '\P{-IS_CHANGES_WHEN_NFKC_Casefolded}', "");
    Expect(1, 921599, '\P{^-IS_CHANGES_WHEN_NFKC_Casefolded}', "");
    Expect(0, 921600, '\p{-IS_CHANGES_WHEN_NFKC_Casefolded}', "");
    Expect(1, 921600, '\p{^-IS_CHANGES_WHEN_NFKC_Casefolded}', "");
    Expect(1, 921600, '\P{-IS_CHANGES_WHEN_NFKC_Casefolded}', "");
    Expect(0, 921600, '\P{^-IS_CHANGES_WHEN_NFKC_Casefolded}', "");
    Error('\p{/a/CWKCF}');
    Error('\P{/a/CWKCF}');
    Expect(1, 921599, '\p{cwkcf}', "");
    Expect(0, 921599, '\p{^cwkcf}', "");
    Expect(0, 921599, '\P{cwkcf}', "");
    Expect(1, 921599, '\P{^cwkcf}', "");
    Expect(0, 921600, '\p{cwkcf}', "");
    Expect(1, 921600, '\p{^cwkcf}', "");
    Expect(1, 921600, '\P{cwkcf}', "");
    Expect(0, 921600, '\P{^cwkcf}', "");
    Expect(1, 921599, '\p{-	CWKCF}', "");
    Expect(0, 921599, '\p{^-	CWKCF}', "");
    Expect(0, 921599, '\P{-	CWKCF}', "");
    Expect(1, 921599, '\P{^-	CWKCF}', "");
    Expect(0, 921600, '\p{-	CWKCF}', "");
    Expect(1, 921600, '\p{^-	CWKCF}', "");
    Expect(1, 921600, '\P{-	CWKCF}', "");
    Expect(0, 921600, '\P{^-	CWKCF}', "");
    Error('\p{:=  Is_cwkcf}');
    Error('\P{:=  Is_cwkcf}');
    Expect(1, 921599, '\p{iscwkcf}', "");
    Expect(0, 921599, '\p{^iscwkcf}', "");
    Expect(0, 921599, '\P{iscwkcf}', "");
    Expect(1, 921599, '\P{^iscwkcf}', "");
    Expect(0, 921600, '\p{iscwkcf}', "");
    Expect(1, 921600, '\p{^iscwkcf}', "");
    Expect(1, 921600, '\P{iscwkcf}', "");
    Expect(0, 921600, '\P{^iscwkcf}', "");
    Expect(1, 921599, '\p{-_Is_CWKCF}', "");
    Expect(0, 921599, '\p{^-_Is_CWKCF}', "");
    Expect(0, 921599, '\P{-_Is_CWKCF}', "");
    Expect(1, 921599, '\P{^-_Is_CWKCF}', "");
    Expect(0, 921600, '\p{-_Is_CWKCF}', "");
    Expect(1, 921600, '\p{^-_Is_CWKCF}', "");
    Expect(1, 921600, '\P{-_Is_CWKCF}', "");
    Expect(0, 921600, '\P{^-_Is_CWKCF}', "");
    Error('\p{changes_When_titlecased:=}');
    Error('\P{changes_When_titlecased:=}');
    Expect(1, 125251, '\p{changeswhentitlecased}', "");
    Expect(0, 125251, '\p{^changeswhentitlecased}', "");
    Expect(0, 125251, '\P{changeswhentitlecased}', "");
    Expect(1, 125251, '\P{^changeswhentitlecased}', "");
    Expect(0, 125252, '\p{changeswhentitlecased}', "");
    Expect(1, 125252, '\p{^changeswhentitlecased}', "");
    Expect(1, 125252, '\P{changeswhentitlecased}', "");
    Expect(0, 125252, '\P{^changeswhentitlecased}', "");
    Expect(1, 125251, '\p{-	Changes_when_Titlecased}', "");
    Expect(0, 125251, '\p{^-	Changes_when_Titlecased}', "");
    Expect(0, 125251, '\P{-	Changes_when_Titlecased}', "");
    Expect(1, 125251, '\P{^-	Changes_when_Titlecased}', "");
    Expect(0, 125252, '\p{-	Changes_when_Titlecased}', "");
    Expect(1, 125252, '\p{^-	Changes_when_Titlecased}', "");
    Expect(1, 125252, '\P{-	Changes_when_Titlecased}', "");
    Expect(0, 125252, '\P{^-	Changes_when_Titlecased}', "");
    Error('\p{ Is_changes_When_Titlecased:=}');
    Error('\P{ Is_changes_When_Titlecased:=}');
    Expect(1, 125251, '\p{ischangeswhentitlecased}', "");
    Expect(0, 125251, '\p{^ischangeswhentitlecased}', "");
    Expect(0, 125251, '\P{ischangeswhentitlecased}', "");
    Expect(1, 125251, '\P{^ischangeswhentitlecased}', "");
    Expect(0, 125252, '\p{ischangeswhentitlecased}', "");
    Expect(1, 125252, '\p{^ischangeswhentitlecased}', "");
    Expect(1, 125252, '\P{ischangeswhentitlecased}', "");
    Expect(0, 125252, '\P{^ischangeswhentitlecased}', "");
    Expect(1, 125251, '\p{ Is_changes_When_titlecased}', "");
    Expect(0, 125251, '\p{^ Is_changes_When_titlecased}', "");
    Expect(0, 125251, '\P{ Is_changes_When_titlecased}', "");
    Expect(1, 125251, '\P{^ Is_changes_When_titlecased}', "");
    Expect(0, 125252, '\p{ Is_changes_When_titlecased}', "");
    Expect(1, 125252, '\p{^ Is_changes_When_titlecased}', "");
    Expect(1, 125252, '\P{ Is_changes_When_titlecased}', "");
    Expect(0, 125252, '\P{^ Is_changes_When_titlecased}', "");
    Error('\p{--cwt:=}');
    Error('\P{--cwt:=}');
    Expect(1, 125251, '\p{cwt}', "");
    Expect(0, 125251, '\p{^cwt}', "");
    Expect(0, 125251, '\P{cwt}', "");
    Expect(1, 125251, '\P{^cwt}', "");
    Expect(0, 125252, '\p{cwt}', "");
    Expect(1, 125252, '\p{^cwt}', "");
    Expect(1, 125252, '\P{cwt}', "");
    Expect(0, 125252, '\P{^cwt}', "");
    Expect(1, 125251, '\p{	 CWT}', "");
    Expect(0, 125251, '\p{^	 CWT}', "");
    Expect(0, 125251, '\P{	 CWT}', "");
    Expect(1, 125251, '\P{^	 CWT}', "");
    Expect(0, 125252, '\p{	 CWT}', "");
    Expect(1, 125252, '\p{^	 CWT}', "");
    Expect(1, 125252, '\P{	 CWT}', "");
    Expect(0, 125252, '\P{^	 CWT}', "");
    Error('\p{-	Is_CWT:=}');
    Error('\P{-	Is_CWT:=}');
    Expect(1, 125251, '\p{iscwt}', "");
    Expect(0, 125251, '\p{^iscwt}', "");
    Expect(0, 125251, '\P{iscwt}', "");
    Expect(1, 125251, '\P{^iscwt}', "");
    Expect(0, 125252, '\p{iscwt}', "");
    Expect(1, 125252, '\p{^iscwt}', "");
    Expect(1, 125252, '\P{iscwt}', "");
    Expect(0, 125252, '\P{^iscwt}', "");
    Expect(1, 125251, '\p{  IS_CWT}', "");
    Expect(0, 125251, '\p{^  IS_CWT}', "");
    Expect(0, 125251, '\P{  IS_CWT}', "");
    Expect(1, 125251, '\P{^  IS_CWT}', "");
    Expect(0, 125252, '\p{  IS_CWT}', "");
    Expect(1, 125252, '\p{^  IS_CWT}', "");
    Expect(1, 125252, '\P{  IS_CWT}', "");
    Expect(0, 125252, '\P{^  IS_CWT}', "");
    Error('\p{	:=CHANGES_WHEN_UPPERCASED}');
    Error('\P{	:=CHANGES_WHEN_UPPERCASED}');
    Expect(1, 125251, '\p{changeswhenuppercased}', "");
    Expect(0, 125251, '\p{^changeswhenuppercased}', "");
    Expect(0, 125251, '\P{changeswhenuppercased}', "");
    Expect(1, 125251, '\P{^changeswhenuppercased}', "");
    Expect(0, 125252, '\p{changeswhenuppercased}', "");
    Expect(1, 125252, '\p{^changeswhenuppercased}', "");
    Expect(1, 125252, '\P{changeswhenuppercased}', "");
    Expect(0, 125252, '\P{^changeswhenuppercased}', "");
    Expect(1, 125251, '\p{ -Changes_When_UPPERCASED}', "");
    Expect(0, 125251, '\p{^ -Changes_When_UPPERCASED}', "");
    Expect(0, 125251, '\P{ -Changes_When_UPPERCASED}', "");
    Expect(1, 125251, '\P{^ -Changes_When_UPPERCASED}', "");
    Expect(0, 125252, '\p{ -Changes_When_UPPERCASED}', "");
    Expect(1, 125252, '\p{^ -Changes_When_UPPERCASED}', "");
    Expect(1, 125252, '\P{ -Changes_When_UPPERCASED}', "");
    Expect(0, 125252, '\P{^ -Changes_When_UPPERCASED}', "");
    Error('\p{:=	-Is_Changes_When_Uppercased}');
    Error('\P{:=	-Is_Changes_When_Uppercased}');
    Expect(1, 125251, '\p{ischangeswhenuppercased}', "");
    Expect(0, 125251, '\p{^ischangeswhenuppercased}', "");
    Expect(0, 125251, '\P{ischangeswhenuppercased}', "");
    Expect(1, 125251, '\P{^ischangeswhenuppercased}', "");
    Expect(0, 125252, '\p{ischangeswhenuppercased}', "");
    Expect(1, 125252, '\p{^ischangeswhenuppercased}', "");
    Expect(1, 125252, '\P{ischangeswhenuppercased}', "");
    Expect(0, 125252, '\P{^ischangeswhenuppercased}', "");
    Expect(1, 125251, '\p{-	is_Changes_WHEN_Uppercased}', "");
    Expect(0, 125251, '\p{^-	is_Changes_WHEN_Uppercased}', "");
    Expect(0, 125251, '\P{-	is_Changes_WHEN_Uppercased}', "");
    Expect(1, 125251, '\P{^-	is_Changes_WHEN_Uppercased}', "");
    Expect(0, 125252, '\p{-	is_Changes_WHEN_Uppercased}', "");
    Expect(1, 125252, '\p{^-	is_Changes_WHEN_Uppercased}', "");
    Expect(1, 125252, '\P{-	is_Changes_WHEN_Uppercased}', "");
    Expect(0, 125252, '\P{^-	is_Changes_WHEN_Uppercased}', "");
    Error('\p{- CWU/a/}');
    Error('\P{- CWU/a/}');
    Expect(1, 125251, '\p{cwu}', "");
    Expect(0, 125251, '\p{^cwu}', "");
    Expect(0, 125251, '\P{cwu}', "");
    Expect(1, 125251, '\P{^cwu}', "");
    Expect(0, 125252, '\p{cwu}', "");
    Expect(1, 125252, '\p{^cwu}', "");
    Expect(1, 125252, '\P{cwu}', "");
    Expect(0, 125252, '\P{^cwu}', "");
    Expect(1, 125251, '\p{__CWU}', "");
    Expect(0, 125251, '\p{^__CWU}', "");
    Expect(0, 125251, '\P{__CWU}', "");
    Expect(1, 125251, '\P{^__CWU}', "");
    Expect(0, 125252, '\p{__CWU}', "");
    Expect(1, 125252, '\p{^__CWU}', "");
    Expect(1, 125252, '\P{__CWU}', "");
    Expect(0, 125252, '\P{^__CWU}', "");
    Error('\p{	:=Is_CWU}');
    Error('\P{	:=Is_CWU}');
    Expect(1, 125251, '\p{iscwu}', "");
    Expect(0, 125251, '\p{^iscwu}', "");
    Expect(0, 125251, '\P{iscwu}', "");
    Expect(1, 125251, '\P{^iscwu}', "");
    Expect(0, 125252, '\p{iscwu}', "");
    Expect(1, 125252, '\p{^iscwu}', "");
    Expect(1, 125252, '\P{iscwu}', "");
    Expect(0, 125252, '\P{^iscwu}', "");
    Expect(1, 125251, '\p{	Is_CWU}', "");
    Expect(0, 125251, '\p{^	Is_CWU}', "");
    Expect(0, 125251, '\P{	Is_CWU}', "");
    Expect(1, 125251, '\P{^	Is_CWU}', "");
    Expect(0, 125252, '\p{	Is_CWU}', "");
    Expect(1, 125252, '\p{^	Is_CWU}', "");
    Expect(1, 125252, '\P{	Is_CWU}', "");
    Expect(0, 125252, '\P{^	Is_CWU}', "");
    Error('\p{-CHEROKEE:=}');
    Error('\P{-CHEROKEE:=}');
    Expect(1, 43967, '\p{cherokee}', "");
    Expect(0, 43967, '\p{^cherokee}', "");
    Expect(0, 43967, '\P{cherokee}', "");
    Expect(1, 43967, '\P{^cherokee}', "");
    Expect(0, 43968, '\p{cherokee}', "");
    Expect(1, 43968, '\p{^cherokee}', "");
    Expect(1, 43968, '\P{cherokee}', "");
    Expect(0, 43968, '\P{^cherokee}', "");
    Expect(1, 43967, '\p{ cherokee}', "");
    Expect(0, 43967, '\p{^ cherokee}', "");
    Expect(0, 43967, '\P{ cherokee}', "");
    Expect(1, 43967, '\P{^ cherokee}', "");
    Expect(0, 43968, '\p{ cherokee}', "");
    Expect(1, 43968, '\p{^ cherokee}', "");
    Expect(1, 43968, '\P{ cherokee}', "");
    Expect(0, 43968, '\P{^ cherokee}', "");
    Error('\p{	:=Is_CHEROKEE}');
    Error('\P{	:=Is_CHEROKEE}');
    Expect(1, 43967, '\p{ischerokee}', "");
    Expect(0, 43967, '\p{^ischerokee}', "");
    Expect(0, 43967, '\P{ischerokee}', "");
    Expect(1, 43967, '\P{^ischerokee}', "");
    Expect(0, 43968, '\p{ischerokee}', "");
    Expect(1, 43968, '\p{^ischerokee}', "");
    Expect(1, 43968, '\P{ischerokee}', "");
    Expect(0, 43968, '\P{^ischerokee}', "");
    Expect(1, 43967, '\p{ -Is_Cherokee}', "");
    Expect(0, 43967, '\p{^ -Is_Cherokee}', "");
    Expect(0, 43967, '\P{ -Is_Cherokee}', "");
    Expect(1, 43967, '\P{^ -Is_Cherokee}', "");
    Expect(0, 43968, '\p{ -Is_Cherokee}', "");
    Expect(1, 43968, '\p{^ -Is_Cherokee}', "");
    Expect(1, 43968, '\P{ -Is_Cherokee}', "");
    Expect(0, 43968, '\P{^ -Is_Cherokee}', "");
    Error('\p{	:=Cher}');
    Error('\P{	:=Cher}');
    Expect(1, 43967, '\p{cher}', "");
    Expect(0, 43967, '\p{^cher}', "");
    Expect(0, 43967, '\P{cher}', "");
    Expect(1, 43967, '\P{^cher}', "");
    Expect(0, 43968, '\p{cher}', "");
    Expect(1, 43968, '\p{^cher}', "");
    Expect(1, 43968, '\P{cher}', "");
    Expect(0, 43968, '\P{^cher}', "");
    Expect(1, 43967, '\p{-Cher}', "");
    Expect(0, 43967, '\p{^-Cher}', "");
    Expect(0, 43967, '\P{-Cher}', "");
    Expect(1, 43967, '\P{^-Cher}', "");
    Expect(0, 43968, '\p{-Cher}', "");
    Expect(1, 43968, '\p{^-Cher}', "");
    Expect(1, 43968, '\P{-Cher}', "");
    Expect(0, 43968, '\P{^-Cher}', "");
    Error('\p{_:=Is_cher}');
    Error('\P{_:=Is_cher}');
    Expect(1, 43967, '\p{ischer}', "");
    Expect(0, 43967, '\p{^ischer}', "");
    Expect(0, 43967, '\P{ischer}', "");
    Expect(1, 43967, '\P{^ischer}', "");
    Expect(0, 43968, '\p{ischer}', "");
    Expect(1, 43968, '\p{^ischer}', "");
    Expect(1, 43968, '\P{ischer}', "");
    Expect(0, 43968, '\P{^ischer}', "");
    Expect(1, 43967, '\p{__Is_Cher}', "");
    Expect(0, 43967, '\p{^__Is_Cher}', "");
    Expect(0, 43967, '\P{__Is_Cher}', "");
    Expect(1, 43967, '\P{^__Is_Cher}', "");
    Expect(0, 43968, '\p{__Is_Cher}', "");
    Expect(1, 43968, '\p{^__Is_Cher}', "");
    Expect(1, 43968, '\P{__Is_Cher}', "");
    Expect(0, 43968, '\P{^__Is_Cher}', "");
    Error('\p{/a/-	CHEROKEE_Supplement}');
    Error('\P{/a/-	CHEROKEE_Supplement}');
    Expect(1, 43967, '\p{cherokeesupplement}', "");
    Expect(0, 43967, '\p{^cherokeesupplement}', "");
    Expect(0, 43967, '\P{cherokeesupplement}', "");
    Expect(1, 43967, '\P{^cherokeesupplement}', "");
    Expect(0, 43968, '\p{cherokeesupplement}', "");
    Expect(1, 43968, '\p{^cherokeesupplement}', "");
    Expect(1, 43968, '\P{cherokeesupplement}', "");
    Expect(0, 43968, '\P{^cherokeesupplement}', "");
    Expect(1, 43967, '\p{--CHEROKEE_supplement}', "");
    Expect(0, 43967, '\p{^--CHEROKEE_supplement}', "");
    Expect(0, 43967, '\P{--CHEROKEE_supplement}', "");
    Expect(1, 43967, '\P{^--CHEROKEE_supplement}', "");
    Expect(0, 43968, '\p{--CHEROKEE_supplement}', "");
    Expect(1, 43968, '\p{^--CHEROKEE_supplement}', "");
    Expect(1, 43968, '\P{--CHEROKEE_supplement}', "");
    Expect(0, 43968, '\P{^--CHEROKEE_supplement}', "");
    Error('\p{_	IS_Cherokee_SUPPLEMENT:=}');
    Error('\P{_	IS_Cherokee_SUPPLEMENT:=}');
    Expect(1, 43967, '\p{ischerokeesupplement}', "");
    Expect(0, 43967, '\p{^ischerokeesupplement}', "");
    Expect(0, 43967, '\P{ischerokeesupplement}', "");
    Expect(1, 43967, '\P{^ischerokeesupplement}', "");
    Expect(0, 43968, '\p{ischerokeesupplement}', "");
    Expect(1, 43968, '\p{^ischerokeesupplement}', "");
    Expect(1, 43968, '\P{ischerokeesupplement}', "");
    Expect(0, 43968, '\P{^ischerokeesupplement}', "");
    Expect(1, 43967, '\p{	-Is_cherokee_Supplement}', "");
    Expect(0, 43967, '\p{^	-Is_cherokee_Supplement}', "");
    Expect(0, 43967, '\P{	-Is_cherokee_Supplement}', "");
    Expect(1, 43967, '\P{^	-Is_cherokee_Supplement}', "");
    Expect(0, 43968, '\p{	-Is_cherokee_Supplement}', "");
    Expect(1, 43968, '\p{^	-Is_cherokee_Supplement}', "");
    Expect(1, 43968, '\P{	-Is_cherokee_Supplement}', "");
    Expect(0, 43968, '\P{^	-Is_cherokee_Supplement}', "");
    Error('\p{:=	-In_CHEROKEE_Supplement}');
    Error('\P{:=	-In_CHEROKEE_Supplement}');
    Expect(1, 43967, '\p{incherokeesupplement}', "");
    Expect(0, 43967, '\p{^incherokeesupplement}', "");
    Expect(0, 43967, '\P{incherokeesupplement}', "");
    Expect(1, 43967, '\P{^incherokeesupplement}', "");
    Expect(0, 43968, '\p{incherokeesupplement}', "");
    Expect(1, 43968, '\p{^incherokeesupplement}', "");
    Expect(1, 43968, '\P{incherokeesupplement}', "");
    Expect(0, 43968, '\P{^incherokeesupplement}', "");
    Expect(1, 43967, '\p{	 in_cherokee_supplement}', "");
    Expect(0, 43967, '\p{^	 in_cherokee_supplement}', "");
    Expect(0, 43967, '\P{	 in_cherokee_supplement}', "");
    Expect(1, 43967, '\P{^	 in_cherokee_supplement}', "");
    Expect(0, 43968, '\p{	 in_cherokee_supplement}', "");
    Expect(1, 43968, '\p{^	 in_cherokee_supplement}', "");
    Expect(1, 43968, '\P{	 in_cherokee_supplement}', "");
    Expect(0, 43968, '\P{^	 in_cherokee_supplement}', "");
    Error('\p{ -Cherokee_sup:=}');
    Error('\P{ -Cherokee_sup:=}');
    Expect(1, 43967, '\p{cherokeesup}', "");
    Expect(0, 43967, '\p{^cherokeesup}', "");
    Expect(0, 43967, '\P{cherokeesup}', "");
    Expect(1, 43967, '\P{^cherokeesup}', "");
    Expect(0, 43968, '\p{cherokeesup}', "");
    Expect(1, 43968, '\p{^cherokeesup}', "");
    Expect(1, 43968, '\P{cherokeesup}', "");
    Expect(0, 43968, '\P{^cherokeesup}', "");
    Expect(1, 43967, '\p{_ cherokee_sup}', "");
    Expect(0, 43967, '\p{^_ cherokee_sup}', "");
    Expect(0, 43967, '\P{_ cherokee_sup}', "");
    Expect(1, 43967, '\P{^_ cherokee_sup}', "");
    Expect(0, 43968, '\p{_ cherokee_sup}', "");
    Expect(1, 43968, '\p{^_ cherokee_sup}', "");
    Expect(1, 43968, '\P{_ cherokee_sup}', "");
    Expect(0, 43968, '\P{^_ cherokee_sup}', "");
    Error('\p{_IS_Cherokee_Sup/a/}');
    Error('\P{_IS_Cherokee_Sup/a/}');
    Expect(1, 43967, '\p{ischerokeesup}', "");
    Expect(0, 43967, '\p{^ischerokeesup}', "");
    Expect(0, 43967, '\P{ischerokeesup}', "");
    Expect(1, 43967, '\P{^ischerokeesup}', "");
    Expect(0, 43968, '\p{ischerokeesup}', "");
    Expect(1, 43968, '\p{^ischerokeesup}', "");
    Expect(1, 43968, '\P{ischerokeesup}', "");
    Expect(0, 43968, '\P{^ischerokeesup}', "");
    Expect(1, 43967, '\p{ is_Cherokee_Sup}', "");
    Expect(0, 43967, '\p{^ is_Cherokee_Sup}', "");
    Expect(0, 43967, '\P{ is_Cherokee_Sup}', "");
    Expect(1, 43967, '\P{^ is_Cherokee_Sup}', "");
    Expect(0, 43968, '\p{ is_Cherokee_Sup}', "");
    Expect(1, 43968, '\p{^ is_Cherokee_Sup}', "");
    Expect(1, 43968, '\P{ is_Cherokee_Sup}', "");
    Expect(0, 43968, '\P{^ is_Cherokee_Sup}', "");
    Error('\p{:=- in_Cherokee_sup}');
    Error('\P{:=- in_Cherokee_sup}');
    Expect(1, 43967, '\p{incherokeesup}', "");
    Expect(0, 43967, '\p{^incherokeesup}', "");
    Expect(0, 43967, '\P{incherokeesup}', "");
    Expect(1, 43967, '\P{^incherokeesup}', "");
    Expect(0, 43968, '\p{incherokeesup}', "");
    Expect(1, 43968, '\p{^incherokeesup}', "");
    Expect(1, 43968, '\P{incherokeesup}', "");
    Expect(0, 43968, '\P{^incherokeesup}', "");
    Expect(1, 43967, '\p{-IN_Cherokee_sup}', "");
    Expect(0, 43967, '\p{^-IN_Cherokee_sup}', "");
    Expect(0, 43967, '\P{-IN_Cherokee_sup}', "");
    Expect(1, 43967, '\P{^-IN_Cherokee_sup}', "");
    Expect(0, 43968, '\p{-IN_Cherokee_sup}', "");
    Expect(1, 43968, '\p{^-IN_Cherokee_sup}', "");
    Expect(1, 43968, '\P{-IN_Cherokee_sup}', "");
    Expect(0, 43968, '\P{^-IN_Cherokee_sup}', "");
    Error('\p{/a/_Chess_Symbols}');
    Error('\P{/a/_Chess_Symbols}');
    Expect(1, 129647, '\p{chesssymbols}', "");
    Expect(0, 129647, '\p{^chesssymbols}', "");
    Expect(0, 129647, '\P{chesssymbols}', "");
    Expect(1, 129647, '\P{^chesssymbols}', "");
    Expect(0, 129648, '\p{chesssymbols}', "");
    Expect(1, 129648, '\p{^chesssymbols}', "");
    Expect(1, 129648, '\P{chesssymbols}', "");
    Expect(0, 129648, '\P{^chesssymbols}', "");
    Expect(1, 129647, '\p{ _Chess_symbols}', "");
    Expect(0, 129647, '\p{^ _Chess_symbols}', "");
    Expect(0, 129647, '\P{ _Chess_symbols}', "");
    Expect(1, 129647, '\P{^ _Chess_symbols}', "");
    Expect(0, 129648, '\p{ _Chess_symbols}', "");
    Expect(1, 129648, '\p{^ _Chess_symbols}', "");
    Expect(1, 129648, '\P{ _Chess_symbols}', "");
    Expect(0, 129648, '\P{^ _Chess_symbols}', "");
    Error('\p{-	Is_chess_symbols:=}');
    Error('\P{-	Is_chess_symbols:=}');
    Expect(1, 129647, '\p{ischesssymbols}', "");
    Expect(0, 129647, '\p{^ischesssymbols}', "");
    Expect(0, 129647, '\P{ischesssymbols}', "");
    Expect(1, 129647, '\P{^ischesssymbols}', "");
    Expect(0, 129648, '\p{ischesssymbols}', "");
    Expect(1, 129648, '\p{^ischesssymbols}', "");
    Expect(1, 129648, '\P{ischesssymbols}', "");
    Expect(0, 129648, '\P{^ischesssymbols}', "");
    Expect(1, 129647, '\p{_	IS_CHESS_SYMBOLS}', "");
    Expect(0, 129647, '\p{^_	IS_CHESS_SYMBOLS}', "");
    Expect(0, 129647, '\P{_	IS_CHESS_SYMBOLS}', "");
    Expect(1, 129647, '\P{^_	IS_CHESS_SYMBOLS}', "");
    Expect(0, 129648, '\p{_	IS_CHESS_SYMBOLS}', "");
    Expect(1, 129648, '\p{^_	IS_CHESS_SYMBOLS}', "");
    Expect(1, 129648, '\P{_	IS_CHESS_SYMBOLS}', "");
    Expect(0, 129648, '\P{^_	IS_CHESS_SYMBOLS}', "");
    Error('\p{--in_chess_Symbols:=}');
    Error('\P{--in_chess_Symbols:=}');
    Expect(1, 129647, '\p{inchesssymbols}', "");
    Expect(0, 129647, '\p{^inchesssymbols}', "");
    Expect(0, 129647, '\P{inchesssymbols}', "");
    Expect(1, 129647, '\P{^inchesssymbols}', "");
    Expect(0, 129648, '\p{inchesssymbols}', "");
    Expect(1, 129648, '\p{^inchesssymbols}', "");
    Expect(1, 129648, '\P{inchesssymbols}', "");
    Expect(0, 129648, '\P{^inchesssymbols}', "");
    Expect(1, 129647, '\p{	In_Chess_Symbols}', "");
    Expect(0, 129647, '\p{^	In_Chess_Symbols}', "");
    Expect(0, 129647, '\P{	In_Chess_Symbols}', "");
    Expect(1, 129647, '\P{^	In_Chess_Symbols}', "");
    Expect(0, 129648, '\p{	In_Chess_Symbols}', "");
    Expect(1, 129648, '\p{^	In_Chess_Symbols}', "");
    Expect(1, 129648, '\P{	In_Chess_Symbols}', "");
    Expect(0, 129648, '\P{^	In_Chess_Symbols}', "");
    Error('\p{__CJK_compatibility:=}');
    Error('\P{__CJK_compatibility:=}');
    Expect(1, 13311, '\p{cjkcompatibility}', "");
    Expect(0, 13311, '\p{^cjkcompatibility}', "");
    Expect(0, 13311, '\P{cjkcompatibility}', "");
    Expect(1, 13311, '\P{^cjkcompatibility}', "");
    Expect(0, 13312, '\p{cjkcompatibility}', "");
    Expect(1, 13312, '\p{^cjkcompatibility}', "");
    Expect(1, 13312, '\P{cjkcompatibility}', "");
    Expect(0, 13312, '\P{^cjkcompatibility}', "");
    Expect(1, 13311, '\p{_-cjk_Compatibility}', "");
    Expect(0, 13311, '\p{^_-cjk_Compatibility}', "");
    Expect(0, 13311, '\P{_-cjk_Compatibility}', "");
    Expect(1, 13311, '\P{^_-cjk_Compatibility}', "");
    Expect(0, 13312, '\p{_-cjk_Compatibility}', "");
    Expect(1, 13312, '\p{^_-cjk_Compatibility}', "");
    Expect(1, 13312, '\P{_-cjk_Compatibility}', "");
    Expect(0, 13312, '\P{^_-cjk_Compatibility}', "");
    Error('\p{/a/ Is_CJK_Compatibility}');
    Error('\P{/a/ Is_CJK_Compatibility}');
    Expect(1, 13311, '\p{iscjkcompatibility}', "");
    Expect(0, 13311, '\p{^iscjkcompatibility}', "");
    Expect(0, 13311, '\P{iscjkcompatibility}', "");
    Expect(1, 13311, '\P{^iscjkcompatibility}', "");
    Expect(0, 13312, '\p{iscjkcompatibility}', "");
    Expect(1, 13312, '\p{^iscjkcompatibility}', "");
    Expect(1, 13312, '\P{iscjkcompatibility}', "");
    Expect(0, 13312, '\P{^iscjkcompatibility}', "");
    Expect(1, 13311, '\p{ 	is_CJK_Compatibility}', "");
    Expect(0, 13311, '\p{^ 	is_CJK_Compatibility}', "");
    Expect(0, 13311, '\P{ 	is_CJK_Compatibility}', "");
    Expect(1, 13311, '\P{^ 	is_CJK_Compatibility}', "");
    Expect(0, 13312, '\p{ 	is_CJK_Compatibility}', "");
    Expect(1, 13312, '\p{^ 	is_CJK_Compatibility}', "");
    Expect(1, 13312, '\P{ 	is_CJK_Compatibility}', "");
    Expect(0, 13312, '\P{^ 	is_CJK_Compatibility}', "");
    Error('\p{-	IN_cjk_Compatibility:=}');
    Error('\P{-	IN_cjk_Compatibility:=}');
    Expect(1, 13311, '\p{incjkcompatibility}', "");
    Expect(0, 13311, '\p{^incjkcompatibility}', "");
    Expect(0, 13311, '\P{incjkcompatibility}', "");
    Expect(1, 13311, '\P{^incjkcompatibility}', "");
    Expect(0, 13312, '\p{incjkcompatibility}', "");
    Expect(1, 13312, '\p{^incjkcompatibility}', "");
    Expect(1, 13312, '\P{incjkcompatibility}', "");
    Expect(0, 13312, '\P{^incjkcompatibility}', "");
    Expect(1, 13311, '\p{	_In_CJK_COMPATIBILITY}', "");
    Expect(0, 13311, '\p{^	_In_CJK_COMPATIBILITY}', "");
    Expect(0, 13311, '\P{	_In_CJK_COMPATIBILITY}', "");
    Expect(1, 13311, '\P{^	_In_CJK_COMPATIBILITY}', "");
    Expect(0, 13312, '\p{	_In_CJK_COMPATIBILITY}', "");
    Expect(1, 13312, '\p{^	_In_CJK_COMPATIBILITY}', "");
    Expect(1, 13312, '\P{	_In_CJK_COMPATIBILITY}', "");
    Expect(0, 13312, '\P{^	_In_CJK_COMPATIBILITY}', "");
    Error('\p{-CJK_Compat:=}');
    Error('\P{-CJK_Compat:=}');
    Expect(1, 13311, '\p{cjkcompat}', "");
    Expect(0, 13311, '\p{^cjkcompat}', "");
    Expect(0, 13311, '\P{cjkcompat}', "");
    Expect(1, 13311, '\P{^cjkcompat}', "");
    Expect(0, 13312, '\p{cjkcompat}', "");
    Expect(1, 13312, '\p{^cjkcompat}', "");
    Expect(1, 13312, '\P{cjkcompat}', "");
    Expect(0, 13312, '\P{^cjkcompat}', "");
    Expect(1, 13311, '\p{	 CJK_compat}', "");
    Expect(0, 13311, '\p{^	 CJK_compat}', "");
    Expect(0, 13311, '\P{	 CJK_compat}', "");
    Expect(1, 13311, '\P{^	 CJK_compat}', "");
    Expect(0, 13312, '\p{	 CJK_compat}', "");
    Expect(1, 13312, '\p{^	 CJK_compat}', "");
    Expect(1, 13312, '\P{	 CJK_compat}', "");
    Expect(0, 13312, '\P{^	 CJK_compat}', "");
    Error('\p{	:=IS_CJK_Compat}');
    Error('\P{	:=IS_CJK_Compat}');
    Expect(1, 13311, '\p{iscjkcompat}', "");
    Expect(0, 13311, '\p{^iscjkcompat}', "");
    Expect(0, 13311, '\P{iscjkcompat}', "");
    Expect(1, 13311, '\P{^iscjkcompat}', "");
    Expect(0, 13312, '\p{iscjkcompat}', "");
    Expect(1, 13312, '\p{^iscjkcompat}', "");
    Expect(1, 13312, '\P{iscjkcompat}', "");
    Expect(0, 13312, '\P{^iscjkcompat}', "");
    Expect(1, 13311, '\p{_	IS_CJK_compat}', "");
    Expect(0, 13311, '\p{^_	IS_CJK_compat}', "");
    Expect(0, 13311, '\P{_	IS_CJK_compat}', "");
    Expect(1, 13311, '\P{^_	IS_CJK_compat}', "");
    Expect(0, 13312, '\p{_	IS_CJK_compat}', "");
    Expect(1, 13312, '\p{^_	IS_CJK_compat}', "");
    Expect(1, 13312, '\P{_	IS_CJK_compat}', "");
    Expect(0, 13312, '\P{^_	IS_CJK_compat}', "");
    Error('\p{:= In_CJK_Compat}');
    Error('\P{:= In_CJK_Compat}');
    Expect(1, 13311, '\p{incjkcompat}', "");
    Expect(0, 13311, '\p{^incjkcompat}', "");
    Expect(0, 13311, '\P{incjkcompat}', "");
    Expect(1, 13311, '\P{^incjkcompat}', "");
    Expect(0, 13312, '\p{incjkcompat}', "");
    Expect(1, 13312, '\p{^incjkcompat}', "");
    Expect(1, 13312, '\P{incjkcompat}', "");
    Expect(0, 13312, '\P{^incjkcompat}', "");
    Expect(1, 13311, '\p{  in_CJK_Compat}', "");
    Expect(0, 13311, '\p{^  in_CJK_Compat}', "");
    Expect(0, 13311, '\P{  in_CJK_Compat}', "");
    Expect(1, 13311, '\P{^  in_CJK_Compat}', "");
    Expect(0, 13312, '\p{  in_CJK_Compat}', "");
    Expect(1, 13312, '\p{^  in_CJK_Compat}', "");
    Expect(1, 13312, '\P{  in_CJK_Compat}', "");
    Expect(0, 13312, '\P{^  in_CJK_Compat}', "");
    Error('\p{_ cjk_Compatibility_Forms:=}');
    Error('\P{_ cjk_Compatibility_Forms:=}');
    Expect(1, 65103, '\p{cjkcompatibilityforms}', "");
    Expect(0, 65103, '\p{^cjkcompatibilityforms}', "");
    Expect(0, 65103, '\P{cjkcompatibilityforms}', "");
    Expect(1, 65103, '\P{^cjkcompatibilityforms}', "");
    Expect(0, 65104, '\p{cjkcompatibilityforms}', "");
    Expect(1, 65104, '\p{^cjkcompatibilityforms}', "");
    Expect(1, 65104, '\P{cjkcompatibilityforms}', "");
    Expect(0, 65104, '\P{^cjkcompatibilityforms}', "");
    Expect(1, 65103, '\p{- CJK_Compatibility_forms}', "");
    Expect(0, 65103, '\p{^- CJK_Compatibility_forms}', "");
    Expect(0, 65103, '\P{- CJK_Compatibility_forms}', "");
    Expect(1, 65103, '\P{^- CJK_Compatibility_forms}', "");
    Expect(0, 65104, '\p{- CJK_Compatibility_forms}', "");
    Expect(1, 65104, '\p{^- CJK_Compatibility_forms}', "");
    Expect(1, 65104, '\P{- CJK_Compatibility_forms}', "");
    Expect(0, 65104, '\P{^- CJK_Compatibility_forms}', "");
    Error('\p{_IS_CJK_Compatibility_Forms:=}');
    Error('\P{_IS_CJK_Compatibility_Forms:=}');
    Expect(1, 65103, '\p{iscjkcompatibilityforms}', "");
    Expect(0, 65103, '\p{^iscjkcompatibilityforms}', "");
    Expect(0, 65103, '\P{iscjkcompatibilityforms}', "");
    Expect(1, 65103, '\P{^iscjkcompatibilityforms}', "");
    Expect(0, 65104, '\p{iscjkcompatibilityforms}', "");
    Expect(1, 65104, '\p{^iscjkcompatibilityforms}', "");
    Expect(1, 65104, '\P{iscjkcompatibilityforms}', "");
    Expect(0, 65104, '\P{^iscjkcompatibilityforms}', "");
    Expect(1, 65103, '\p{__Is_CJK_compatibility_Forms}', "");
    Expect(0, 65103, '\p{^__Is_CJK_compatibility_Forms}', "");
    Expect(0, 65103, '\P{__Is_CJK_compatibility_Forms}', "");
    Expect(1, 65103, '\P{^__Is_CJK_compatibility_Forms}', "");
    Expect(0, 65104, '\p{__Is_CJK_compatibility_Forms}', "");
    Expect(1, 65104, '\p{^__Is_CJK_compatibility_Forms}', "");
    Expect(1, 65104, '\P{__Is_CJK_compatibility_Forms}', "");
    Expect(0, 65104, '\P{^__Is_CJK_compatibility_Forms}', "");
    Error('\p{-:=in_CJK_COMPATIBILITY_FORMS}');
    Error('\P{-:=in_CJK_COMPATIBILITY_FORMS}');
    Expect(1, 65103, '\p{incjkcompatibilityforms}', "");
    Expect(0, 65103, '\p{^incjkcompatibilityforms}', "");
    Expect(0, 65103, '\P{incjkcompatibilityforms}', "");
    Expect(1, 65103, '\P{^incjkcompatibilityforms}', "");
    Expect(0, 65104, '\p{incjkcompatibilityforms}', "");
    Expect(1, 65104, '\p{^incjkcompatibilityforms}', "");
    Expect(1, 65104, '\P{incjkcompatibilityforms}', "");
    Expect(0, 65104, '\P{^incjkcompatibilityforms}', "");
    Expect(1, 65103, '\p{_ In_CJK_Compatibility_Forms}', "");
    Expect(0, 65103, '\p{^_ In_CJK_Compatibility_Forms}', "");
    Expect(0, 65103, '\P{_ In_CJK_Compatibility_Forms}', "");
    Expect(1, 65103, '\P{^_ In_CJK_Compatibility_Forms}', "");
    Expect(0, 65104, '\p{_ In_CJK_Compatibility_Forms}', "");
    Expect(1, 65104, '\p{^_ In_CJK_Compatibility_Forms}', "");
    Expect(1, 65104, '\P{_ In_CJK_Compatibility_Forms}', "");
    Expect(0, 65104, '\P{^_ In_CJK_Compatibility_Forms}', "");
    Error('\p{:=  cjk_COMPAT_Forms}');
    Error('\P{:=  cjk_COMPAT_Forms}');
    Expect(1, 65103, '\p{cjkcompatforms}', "");
    Expect(0, 65103, '\p{^cjkcompatforms}', "");
    Expect(0, 65103, '\P{cjkcompatforms}', "");
    Expect(1, 65103, '\P{^cjkcompatforms}', "");
    Expect(0, 65104, '\p{cjkcompatforms}', "");
    Expect(1, 65104, '\p{^cjkcompatforms}', "");
    Expect(1, 65104, '\P{cjkcompatforms}', "");
    Expect(0, 65104, '\P{^cjkcompatforms}', "");
    Expect(1, 65103, '\p{_-CJK_Compat_forms}', "");
    Expect(0, 65103, '\p{^_-CJK_Compat_forms}', "");
    Expect(0, 65103, '\P{_-CJK_Compat_forms}', "");
    Expect(1, 65103, '\P{^_-CJK_Compat_forms}', "");
    Expect(0, 65104, '\p{_-CJK_Compat_forms}', "");
    Expect(1, 65104, '\p{^_-CJK_Compat_forms}', "");
    Expect(1, 65104, '\P{_-CJK_Compat_forms}', "");
    Expect(0, 65104, '\P{^_-CJK_Compat_forms}', "");
    Error('\p{/a/	-Is_CJK_compat_Forms}');
    Error('\P{/a/	-Is_CJK_compat_Forms}');
    Expect(1, 65103, '\p{iscjkcompatforms}', "");
    Expect(0, 65103, '\p{^iscjkcompatforms}', "");
    Expect(0, 65103, '\P{iscjkcompatforms}', "");
    Expect(1, 65103, '\P{^iscjkcompatforms}', "");
    Expect(0, 65104, '\p{iscjkcompatforms}', "");
    Expect(1, 65104, '\p{^iscjkcompatforms}', "");
    Expect(1, 65104, '\P{iscjkcompatforms}', "");
    Expect(0, 65104, '\P{^iscjkcompatforms}', "");
    Expect(1, 65103, '\p{	IS_CJK_Compat_FORMS}', "");
    Expect(0, 65103, '\p{^	IS_CJK_Compat_FORMS}', "");
    Expect(0, 65103, '\P{	IS_CJK_Compat_FORMS}', "");
    Expect(1, 65103, '\P{^	IS_CJK_Compat_FORMS}', "");
    Expect(0, 65104, '\p{	IS_CJK_Compat_FORMS}', "");
    Expect(1, 65104, '\p{^	IS_CJK_Compat_FORMS}', "");
    Expect(1, 65104, '\P{	IS_CJK_Compat_FORMS}', "");
    Expect(0, 65104, '\P{^	IS_CJK_Compat_FORMS}', "");
    Error('\p{/a/	 IN_CJK_compat_forms}');
    Error('\P{/a/	 IN_CJK_compat_forms}');
    Expect(1, 65103, '\p{incjkcompatforms}', "");
    Expect(0, 65103, '\p{^incjkcompatforms}', "");
    Expect(0, 65103, '\P{incjkcompatforms}', "");
    Expect(1, 65103, '\P{^incjkcompatforms}', "");
    Expect(0, 65104, '\p{incjkcompatforms}', "");
    Expect(1, 65104, '\p{^incjkcompatforms}', "");
    Expect(1, 65104, '\P{incjkcompatforms}', "");
    Expect(0, 65104, '\P{^incjkcompatforms}', "");
    Expect(1, 65103, '\p{  IN_CJK_COMPAT_forms}', "");
    Expect(0, 65103, '\p{^  IN_CJK_COMPAT_forms}', "");
    Expect(0, 65103, '\P{  IN_CJK_COMPAT_forms}', "");
    Expect(1, 65103, '\P{^  IN_CJK_COMPAT_forms}', "");
    Expect(0, 65104, '\p{  IN_CJK_COMPAT_forms}', "");
    Expect(1, 65104, '\p{^  IN_CJK_COMPAT_forms}', "");
    Expect(1, 65104, '\P{  IN_CJK_COMPAT_forms}', "");
    Expect(0, 65104, '\P{^  IN_CJK_COMPAT_forms}', "");
    Error('\p{/a/	-CJK_COMPATIBILITY_Ideographs}');
    Error('\P{/a/	-CJK_COMPATIBILITY_Ideographs}');
    Expect(1, 64255, '\p{cjkcompatibilityideographs}', "");
    Expect(0, 64255, '\p{^cjkcompatibilityideographs}', "");
    Expect(0, 64255, '\P{cjkcompatibilityideographs}', "");
    Expect(1, 64255, '\P{^cjkcompatibilityideographs}', "");
    Expect(0, 64256, '\p{cjkcompatibilityideographs}', "");
    Expect(1, 64256, '\p{^cjkcompatibilityideographs}', "");
    Expect(1, 64256, '\P{cjkcompatibilityideographs}', "");
    Expect(0, 64256, '\P{^cjkcompatibilityideographs}', "");
    Expect(1, 64255, '\p{	-CJK_compatibility_Ideographs}', "");
    Expect(0, 64255, '\p{^	-CJK_compatibility_Ideographs}', "");
    Expect(0, 64255, '\P{	-CJK_compatibility_Ideographs}', "");
    Expect(1, 64255, '\P{^	-CJK_compatibility_Ideographs}', "");
    Expect(0, 64256, '\p{	-CJK_compatibility_Ideographs}', "");
    Expect(1, 64256, '\p{^	-CJK_compatibility_Ideographs}', "");
    Expect(1, 64256, '\P{	-CJK_compatibility_Ideographs}', "");
    Expect(0, 64256, '\P{^	-CJK_compatibility_Ideographs}', "");
    Error('\p{_-Is_CJK_compatibility_IDEOGRAPHS/a/}');
    Error('\P{_-Is_CJK_compatibility_IDEOGRAPHS/a/}');
    Expect(1, 64255, '\p{iscjkcompatibilityideographs}', "");
    Expect(0, 64255, '\p{^iscjkcompatibilityideographs}', "");
    Expect(0, 64255, '\P{iscjkcompatibilityideographs}', "");
    Expect(1, 64255, '\P{^iscjkcompatibilityideographs}', "");
    Expect(0, 64256, '\p{iscjkcompatibilityideographs}', "");
    Expect(1, 64256, '\p{^iscjkcompatibilityideographs}', "");
    Expect(1, 64256, '\P{iscjkcompatibilityideographs}', "");
    Expect(0, 64256, '\P{^iscjkcompatibilityideographs}', "");
    Expect(1, 64255, '\p{  IS_cjk_Compatibility_Ideographs}', "");
    Expect(0, 64255, '\p{^  IS_cjk_Compatibility_Ideographs}', "");
    Expect(0, 64255, '\P{  IS_cjk_Compatibility_Ideographs}', "");
    Expect(1, 64255, '\P{^  IS_cjk_Compatibility_Ideographs}', "");
    Expect(0, 64256, '\p{  IS_cjk_Compatibility_Ideographs}', "");
    Expect(1, 64256, '\p{^  IS_cjk_Compatibility_Ideographs}', "");
    Expect(1, 64256, '\P{  IS_cjk_Compatibility_Ideographs}', "");
    Expect(0, 64256, '\P{^  IS_cjk_Compatibility_Ideographs}', "");
    Error('\p{:=in_cjk_compatibility_Ideographs}');
    Error('\P{:=in_cjk_compatibility_Ideographs}');
    Expect(1, 64255, '\p{incjkcompatibilityideographs}', "");
    Expect(0, 64255, '\p{^incjkcompatibilityideographs}', "");
    Expect(0, 64255, '\P{incjkcompatibilityideographs}', "");
    Expect(1, 64255, '\P{^incjkcompatibilityideographs}', "");
    Expect(0, 64256, '\p{incjkcompatibilityideographs}', "");
    Expect(1, 64256, '\p{^incjkcompatibilityideographs}', "");
    Expect(1, 64256, '\P{incjkcompatibilityideographs}', "");
    Expect(0, 64256, '\P{^incjkcompatibilityideographs}', "");
    Expect(1, 64255, '\p{_ in_cjk_Compatibility_Ideographs}', "");
    Expect(0, 64255, '\p{^_ in_cjk_Compatibility_Ideographs}', "");
    Expect(0, 64255, '\P{_ in_cjk_Compatibility_Ideographs}', "");
    Expect(1, 64255, '\P{^_ in_cjk_Compatibility_Ideographs}', "");
    Expect(0, 64256, '\p{_ in_cjk_Compatibility_Ideographs}', "");
    Expect(1, 64256, '\p{^_ in_cjk_Compatibility_Ideographs}', "");
    Expect(1, 64256, '\P{_ in_cjk_Compatibility_Ideographs}', "");
    Expect(0, 64256, '\P{^_ in_cjk_Compatibility_Ideographs}', "");
    Error('\p{/a/CJK_COMPAT_ideographs}');
    Error('\P{/a/CJK_COMPAT_ideographs}');
    Expect(1, 64255, '\p{cjkcompatideographs}', "");
    Expect(0, 64255, '\p{^cjkcompatideographs}', "");
    Expect(0, 64255, '\P{cjkcompatideographs}', "");
    Expect(1, 64255, '\P{^cjkcompatideographs}', "");
    Expect(0, 64256, '\p{cjkcompatideographs}', "");
    Expect(1, 64256, '\p{^cjkcompatideographs}', "");
    Expect(1, 64256, '\P{cjkcompatideographs}', "");
    Expect(0, 64256, '\P{^cjkcompatideographs}', "");
    Expect(1, 64255, '\p{ -cjk_COMPAT_ideographs}', "");
    Expect(0, 64255, '\p{^ -cjk_COMPAT_ideographs}', "");
    Expect(0, 64255, '\P{ -cjk_COMPAT_ideographs}', "");
    Expect(1, 64255, '\P{^ -cjk_COMPAT_ideographs}', "");
    Expect(0, 64256, '\p{ -cjk_COMPAT_ideographs}', "");
    Expect(1, 64256, '\p{^ -cjk_COMPAT_ideographs}', "");
    Expect(1, 64256, '\P{ -cjk_COMPAT_ideographs}', "");
    Expect(0, 64256, '\P{^ -cjk_COMPAT_ideographs}', "");
    Error('\p{-/a/is_cjk_Compat_IDEOGRAPHS}');
    Error('\P{-/a/is_cjk_Compat_IDEOGRAPHS}');
    Expect(1, 64255, '\p{iscjkcompatideographs}', "");
    Expect(0, 64255, '\p{^iscjkcompatideographs}', "");
    Expect(0, 64255, '\P{iscjkcompatideographs}', "");
    Expect(1, 64255, '\P{^iscjkcompatideographs}', "");
    Expect(0, 64256, '\p{iscjkcompatideographs}', "");
    Expect(1, 64256, '\p{^iscjkcompatideographs}', "");
    Expect(1, 64256, '\P{iscjkcompatideographs}', "");
    Expect(0, 64256, '\P{^iscjkcompatideographs}', "");
    Expect(1, 64255, '\p{ is_CJK_COMPAT_IDEOGRAPHS}', "");
    Expect(0, 64255, '\p{^ is_CJK_COMPAT_IDEOGRAPHS}', "");
    Expect(0, 64255, '\P{ is_CJK_COMPAT_IDEOGRAPHS}', "");
    Expect(1, 64255, '\P{^ is_CJK_COMPAT_IDEOGRAPHS}', "");
    Expect(0, 64256, '\p{ is_CJK_COMPAT_IDEOGRAPHS}', "");
    Expect(1, 64256, '\p{^ is_CJK_COMPAT_IDEOGRAPHS}', "");
    Expect(1, 64256, '\P{ is_CJK_COMPAT_IDEOGRAPHS}', "");
    Expect(0, 64256, '\P{^ is_CJK_COMPAT_IDEOGRAPHS}', "");
    Error('\p{/a/- In_CJK_COMPAT_Ideographs}');
    Error('\P{/a/- In_CJK_COMPAT_Ideographs}');
    Expect(1, 64255, '\p{incjkcompatideographs}', "");
    Expect(0, 64255, '\p{^incjkcompatideographs}', "");
    Expect(0, 64255, '\P{incjkcompatideographs}', "");
    Expect(1, 64255, '\P{^incjkcompatideographs}', "");
    Expect(0, 64256, '\p{incjkcompatideographs}', "");
    Expect(1, 64256, '\p{^incjkcompatideographs}', "");
    Expect(1, 64256, '\P{incjkcompatideographs}', "");
    Expect(0, 64256, '\P{^incjkcompatideographs}', "");
    Expect(1, 64255, '\p{	 IN_CJK_Compat_IDEOGRAPHS}', "");
    Expect(0, 64255, '\p{^	 IN_CJK_Compat_IDEOGRAPHS}', "");
    Expect(0, 64255, '\P{	 IN_CJK_Compat_IDEOGRAPHS}', "");
    Expect(1, 64255, '\P{^	 IN_CJK_Compat_IDEOGRAPHS}', "");
    Expect(0, 64256, '\p{	 IN_CJK_Compat_IDEOGRAPHS}', "");
    Expect(1, 64256, '\p{^	 IN_CJK_Compat_IDEOGRAPHS}', "");
    Expect(1, 64256, '\P{	 IN_CJK_Compat_IDEOGRAPHS}', "");
    Expect(0, 64256, '\P{^	 IN_CJK_Compat_IDEOGRAPHS}', "");
    Error('\p{/a/-	CJK_Compatibility_Ideographs_Supplement}');
    Error('\P{/a/-	CJK_Compatibility_Ideographs_Supplement}');
    Expect(1, 195103, '\p{cjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\p{^cjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\P{cjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\P{^cjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\p{cjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\p{^cjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\P{cjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\P{^cjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\p{CJK_COMPATIBILITY_ideographs_Supplement}', "");
    Expect(0, 195103, '\p{^CJK_COMPATIBILITY_ideographs_Supplement}', "");
    Expect(0, 195103, '\P{CJK_COMPATIBILITY_ideographs_Supplement}', "");
    Expect(1, 195103, '\P{^CJK_COMPATIBILITY_ideographs_Supplement}', "");
    Expect(0, 195104, '\p{CJK_COMPATIBILITY_ideographs_Supplement}', "");
    Expect(1, 195104, '\p{^CJK_COMPATIBILITY_ideographs_Supplement}', "");
    Expect(1, 195104, '\P{CJK_COMPATIBILITY_ideographs_Supplement}', "");
    Expect(0, 195104, '\P{^CJK_COMPATIBILITY_ideographs_Supplement}', "");
    Error('\p{_:=Is_cjk_Compatibility_Ideographs_Supplement}');
    Error('\P{_:=Is_cjk_Compatibility_Ideographs_Supplement}');
    Expect(1, 195103, '\p{iscjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\p{^iscjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\P{iscjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\P{^iscjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\p{iscjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\p{^iscjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\P{iscjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\P{^iscjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\p{-Is_CJK_COMPATIBILITY_IDEOGRAPHS_Supplement}', "");
    Expect(0, 195103, '\p{^-Is_CJK_COMPATIBILITY_IDEOGRAPHS_Supplement}', "");
    Expect(0, 195103, '\P{-Is_CJK_COMPATIBILITY_IDEOGRAPHS_Supplement}', "");
    Expect(1, 195103, '\P{^-Is_CJK_COMPATIBILITY_IDEOGRAPHS_Supplement}', "");
    Expect(0, 195104, '\p{-Is_CJK_COMPATIBILITY_IDEOGRAPHS_Supplement}', "");
    Expect(1, 195104, '\p{^-Is_CJK_COMPATIBILITY_IDEOGRAPHS_Supplement}', "");
    Expect(1, 195104, '\P{-Is_CJK_COMPATIBILITY_IDEOGRAPHS_Supplement}', "");
    Expect(0, 195104, '\P{^-Is_CJK_COMPATIBILITY_IDEOGRAPHS_Supplement}', "");
    Error('\p{/a/	-in_CJK_Compatibility_ideographs_supplement}');
    Error('\P{/a/	-in_CJK_Compatibility_ideographs_supplement}');
    Expect(1, 195103, '\p{incjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\p{^incjkcompatibilityideographssupplement}', "");
    Expect(0, 195103, '\P{incjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\P{^incjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\p{incjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\p{^incjkcompatibilityideographssupplement}', "");
    Expect(1, 195104, '\P{incjkcompatibilityideographssupplement}', "");
    Expect(0, 195104, '\P{^incjkcompatibilityideographssupplement}', "");
    Expect(1, 195103, '\p{ _IN_CJK_compatibility_ideographs_Supplement}', "");
    Expect(0, 195103, '\p{^ _IN_CJK_compatibility_ideographs_Supplement}', "");
    Expect(0, 195103, '\P{ _IN_CJK_compatibility_ideographs_Supplement}', "");
    Expect(1, 195103, '\P{^ _IN_CJK_compatibility_ideographs_Supplement}', "");
    Expect(0, 195104, '\p{ _IN_CJK_compatibility_ideographs_Supplement}', "");
    Expect(1, 195104, '\p{^ _IN_CJK_compatibility_ideographs_Supplement}', "");
    Expect(1, 195104, '\P{ _IN_CJK_compatibility_ideographs_Supplement}', "");
    Expect(0, 195104, '\P{^ _IN_CJK_compatibility_ideographs_Supplement}', "");
    Error('\p{	-CJK_Compat_ideographs_SUP:=}');
    Error('\P{	-CJK_Compat_ideographs_SUP:=}');
    Expect(1, 195103, '\p{cjkcompatideographssup}', "");
    Expect(0, 195103, '\p{^cjkcompatideographssup}', "");
    Expect(0, 195103, '\P{cjkcompatideographssup}', "");
    Expect(1, 195103, '\P{^cjkcompatideographssup}', "");
    Expect(0, 195104, '\p{cjkcompatideographssup}', "");
    Expect(1, 195104, '\p{^cjkcompatideographssup}', "");
    Expect(1, 195104, '\P{cjkcompatideographssup}', "");
    Expect(0, 195104, '\P{^cjkcompatideographssup}', "");
    Expect(1, 195103, '\p{ _CJK_compat_ideographs_SUP}', "");
    Expect(0, 195103, '\p{^ _CJK_compat_ideographs_SUP}', "");
    Expect(0, 195103, '\P{ _CJK_compat_ideographs_SUP}', "");
    Expect(1, 195103, '\P{^ _CJK_compat_ideographs_SUP}', "");
    Expect(0, 195104, '\p{ _CJK_compat_ideographs_SUP}', "");
    Expect(1, 195104, '\p{^ _CJK_compat_ideographs_SUP}', "");
    Expect(1, 195104, '\P{ _CJK_compat_ideographs_SUP}', "");
    Expect(0, 195104, '\P{^ _CJK_compat_ideographs_SUP}', "");
    Error('\p{/a/-Is_CJK_Compat_ideographs_SUP}');
    Error('\P{/a/-Is_CJK_Compat_ideographs_SUP}');
    Expect(1, 195103, '\p{iscjkcompatideographssup}', "");
    Expect(0, 195103, '\p{^iscjkcompatideographssup}', "");
    Expect(0, 195103, '\P{iscjkcompatideographssup}', "");
    Expect(1, 195103, '\P{^iscjkcompatideographssup}', "");
    Expect(0, 195104, '\p{iscjkcompatideographssup}', "");
    Expect(1, 195104, '\p{^iscjkcompatideographssup}', "");
    Expect(1, 195104, '\P{iscjkcompatideographssup}', "");
    Expect(0, 195104, '\P{^iscjkcompatideographssup}', "");
    Expect(1, 195103, '\p{ _Is_CJK_Compat_Ideographs_sup}', "");
    Expect(0, 195103, '\p{^ _Is_CJK_Compat_Ideographs_sup}', "");
    Expect(0, 195103, '\P{ _Is_CJK_Compat_Ideographs_sup}', "");
    Expect(1, 195103, '\P{^ _Is_CJK_Compat_Ideographs_sup}', "");
    Expect(0, 195104, '\p{ _Is_CJK_Compat_Ideographs_sup}', "");
    Expect(1, 195104, '\p{^ _Is_CJK_Compat_Ideographs_sup}', "");
    Expect(1, 195104, '\P{ _Is_CJK_Compat_Ideographs_sup}', "");
    Expect(0, 195104, '\P{^ _Is_CJK_Compat_Ideographs_sup}', "");
    Error('\p{	:=in_cjk_compat_IDEOGRAPHS_sup}');
    Error('\P{	:=in_cjk_compat_IDEOGRAPHS_sup}');
    Expect(1, 195103, '\p{incjkcompatideographssup}', "");
    Expect(0, 195103, '\p{^incjkcompatideographssup}', "");
    Expect(0, 195103, '\P{incjkcompatideographssup}', "");
    Expect(1, 195103, '\P{^incjkcompatideographssup}', "");
    Expect(0, 195104, '\p{incjkcompatideographssup}', "");
    Expect(1, 195104, '\p{^incjkcompatideographssup}', "");
    Expect(1, 195104, '\P{incjkcompatideographssup}', "");
    Expect(0, 195104, '\P{^incjkcompatideographssup}', "");
    Expect(1, 195103, '\p{_-IN_cjk_Compat_Ideographs_Sup}', "");
    Expect(0, 195103, '\p{^_-IN_cjk_Compat_Ideographs_Sup}', "");
    Expect(0, 195103, '\P{_-IN_cjk_Compat_Ideographs_Sup}', "");
    Expect(1, 195103, '\P{^_-IN_cjk_Compat_Ideographs_Sup}', "");
    Expect(0, 195104, '\p{_-IN_cjk_Compat_Ideographs_Sup}', "");
    Expect(1, 195104, '\p{^_-IN_cjk_Compat_Ideographs_Sup}', "");
    Expect(1, 195104, '\P{_-IN_cjk_Compat_Ideographs_Sup}', "");
    Expect(0, 195104, '\P{^_-IN_cjk_Compat_Ideographs_Sup}', "");
    Error('\p{	:=CJK_Radicals_SUPPLEMENT}');
    Error('\P{	:=CJK_Radicals_SUPPLEMENT}');
    Expect(1, 12031, '\p{cjkradicalssupplement}', "");
    Expect(0, 12031, '\p{^cjkradicalssupplement}', "");
    Expect(0, 12031, '\P{cjkradicalssupplement}', "");
    Expect(1, 12031, '\P{^cjkradicalssupplement}', "");
    Expect(0, 12032, '\p{cjkradicalssupplement}', "");
    Expect(1, 12032, '\p{^cjkradicalssupplement}', "");
    Expect(1, 12032, '\P{cjkradicalssupplement}', "");
    Expect(0, 12032, '\P{^cjkradicalssupplement}', "");
    Expect(1, 12031, '\p{	CJK_Radicals_Supplement}', "");
    Expect(0, 12031, '\p{^	CJK_Radicals_Supplement}', "");
    Expect(0, 12031, '\P{	CJK_Radicals_Supplement}', "");
    Expect(1, 12031, '\P{^	CJK_Radicals_Supplement}', "");
    Expect(0, 12032, '\p{	CJK_Radicals_Supplement}', "");
    Expect(1, 12032, '\p{^	CJK_Radicals_Supplement}', "");
    Expect(1, 12032, '\P{	CJK_Radicals_Supplement}', "");
    Expect(0, 12032, '\P{^	CJK_Radicals_Supplement}', "");
    Error('\p{	/a/Is_cjk_Radicals_SUPPLEMENT}');
    Error('\P{	/a/Is_cjk_Radicals_SUPPLEMENT}');
    Expect(1, 12031, '\p{iscjkradicalssupplement}', "");
    Expect(0, 12031, '\p{^iscjkradicalssupplement}', "");
    Expect(0, 12031, '\P{iscjkradicalssupplement}', "");
    Expect(1, 12031, '\P{^iscjkradicalssupplement}', "");
    Expect(0, 12032, '\p{iscjkradicalssupplement}', "");
    Expect(1, 12032, '\p{^iscjkradicalssupplement}', "");
    Expect(1, 12032, '\P{iscjkradicalssupplement}', "");
    Expect(0, 12032, '\P{^iscjkradicalssupplement}', "");
    Expect(1, 12031, '\p{	Is_CJK_Radicals_Supplement}', "");
    Expect(0, 12031, '\p{^	Is_CJK_Radicals_Supplement}', "");
    Expect(0, 12031, '\P{	Is_CJK_Radicals_Supplement}', "");
    Expect(1, 12031, '\P{^	Is_CJK_Radicals_Supplement}', "");
    Expect(0, 12032, '\p{	Is_CJK_Radicals_Supplement}', "");
    Expect(1, 12032, '\p{^	Is_CJK_Radicals_Supplement}', "");
    Expect(1, 12032, '\P{	Is_CJK_Radicals_Supplement}', "");
    Expect(0, 12032, '\P{^	Is_CJK_Radicals_Supplement}', "");
    Error('\p{:=- IN_cjk_Radicals_supplement}');
    Error('\P{:=- IN_cjk_Radicals_supplement}');
    Expect(1, 12031, '\p{incjkradicalssupplement}', "");
    Expect(0, 12031, '\p{^incjkradicalssupplement}', "");
    Expect(0, 12031, '\P{incjkradicalssupplement}', "");
    Expect(1, 12031, '\P{^incjkradicalssupplement}', "");
    Expect(0, 12032, '\p{incjkradicalssupplement}', "");
    Expect(1, 12032, '\p{^incjkradicalssupplement}', "");
    Expect(1, 12032, '\P{incjkradicalssupplement}', "");
    Expect(0, 12032, '\P{^incjkradicalssupplement}', "");
    Expect(1, 12031, '\p{  In_cjk_RADICALS_supplement}', "");
    Expect(0, 12031, '\p{^  In_cjk_RADICALS_supplement}', "");
    Expect(0, 12031, '\P{  In_cjk_RADICALS_supplement}', "");
    Expect(1, 12031, '\P{^  In_cjk_RADICALS_supplement}', "");
    Expect(0, 12032, '\p{  In_cjk_RADICALS_supplement}', "");
    Expect(1, 12032, '\p{^  In_cjk_RADICALS_supplement}', "");
    Expect(1, 12032, '\P{  In_cjk_RADICALS_supplement}', "");
    Expect(0, 12032, '\P{^  In_cjk_RADICALS_supplement}', "");
    Error('\p{:= _CJK_radicals_SUP}');
    Error('\P{:= _CJK_radicals_SUP}');
    Expect(1, 12031, '\p{cjkradicalssup}', "");
    Expect(0, 12031, '\p{^cjkradicalssup}', "");
    Expect(0, 12031, '\P{cjkradicalssup}', "");
    Expect(1, 12031, '\P{^cjkradicalssup}', "");
    Expect(0, 12032, '\p{cjkradicalssup}', "");
    Expect(1, 12032, '\p{^cjkradicalssup}', "");
    Expect(1, 12032, '\P{cjkradicalssup}', "");
    Expect(0, 12032, '\P{^cjkradicalssup}', "");
    Expect(1, 12031, '\p{- cjk_Radicals_Sup}', "");
    Expect(0, 12031, '\p{^- cjk_Radicals_Sup}', "");
    Expect(0, 12031, '\P{- cjk_Radicals_Sup}', "");
    Expect(1, 12031, '\P{^- cjk_Radicals_Sup}', "");
    Expect(0, 12032, '\p{- cjk_Radicals_Sup}', "");
    Expect(1, 12032, '\p{^- cjk_Radicals_Sup}', "");
    Expect(1, 12032, '\P{- cjk_Radicals_Sup}', "");
    Expect(0, 12032, '\P{^- cjk_Radicals_Sup}', "");
    Error('\p{:=--Is_CJK_Radicals_sup}');
    Error('\P{:=--Is_CJK_Radicals_sup}');
    Expect(1, 12031, '\p{iscjkradicalssup}', "");
    Expect(0, 12031, '\p{^iscjkradicalssup}', "");
    Expect(0, 12031, '\P{iscjkradicalssup}', "");
    Expect(1, 12031, '\P{^iscjkradicalssup}', "");
    Expect(0, 12032, '\p{iscjkradicalssup}', "");
    Expect(1, 12032, '\p{^iscjkradicalssup}', "");
    Expect(1, 12032, '\P{iscjkradicalssup}', "");
    Expect(0, 12032, '\P{^iscjkradicalssup}', "");
    Expect(1, 12031, '\p{-IS_cjk_RADICALS_Sup}', "");
    Expect(0, 12031, '\p{^-IS_cjk_RADICALS_Sup}', "");
    Expect(0, 12031, '\P{-IS_cjk_RADICALS_Sup}', "");
    Expect(1, 12031, '\P{^-IS_cjk_RADICALS_Sup}', "");
    Expect(0, 12032, '\p{-IS_cjk_RADICALS_Sup}', "");
    Expect(1, 12032, '\p{^-IS_cjk_RADICALS_Sup}', "");
    Expect(1, 12032, '\P{-IS_cjk_RADICALS_Sup}', "");
    Expect(0, 12032, '\P{^-IS_cjk_RADICALS_Sup}', "");
    Error('\p{/a/_IN_CJK_radicals_Sup}');
    Error('\P{/a/_IN_CJK_radicals_Sup}');
    Expect(1, 12031, '\p{incjkradicalssup}', "");
    Expect(0, 12031, '\p{^incjkradicalssup}', "");
    Expect(0, 12031, '\P{incjkradicalssup}', "");
    Expect(1, 12031, '\P{^incjkradicalssup}', "");
    Expect(0, 12032, '\p{incjkradicalssup}', "");
    Expect(1, 12032, '\p{^incjkradicalssup}', "");
    Expect(1, 12032, '\P{incjkradicalssup}', "");
    Expect(0, 12032, '\P{^incjkradicalssup}', "");
    Expect(1, 12031, '\p{-	in_CJK_Radicals_Sup}', "");
    Expect(0, 12031, '\p{^-	in_CJK_Radicals_Sup}', "");
    Expect(0, 12031, '\P{-	in_CJK_Radicals_Sup}', "");
    Expect(1, 12031, '\P{^-	in_CJK_Radicals_Sup}', "");
    Expect(0, 12032, '\p{-	in_CJK_Radicals_Sup}', "");
    Expect(1, 12032, '\p{^-	in_CJK_Radicals_Sup}', "");
    Expect(1, 12032, '\P{-	in_CJK_Radicals_Sup}', "");
    Expect(0, 12032, '\P{^-	in_CJK_Radicals_Sup}', "");
    Error('\p{/a/-cjk_STROKES}');
    Error('\P{/a/-cjk_STROKES}');
    Expect(1, 12783, '\p{cjkstrokes}', "");
    Expect(0, 12783, '\p{^cjkstrokes}', "");
    Expect(0, 12783, '\P{cjkstrokes}', "");
    Expect(1, 12783, '\P{^cjkstrokes}', "");
    Expect(0, 12784, '\p{cjkstrokes}', "");
    Expect(1, 12784, '\p{^cjkstrokes}', "");
    Expect(1, 12784, '\P{cjkstrokes}', "");
    Expect(0, 12784, '\P{^cjkstrokes}', "");
    Expect(1, 12783, '\p{ cjk_STROKES}', "");
    Expect(0, 12783, '\p{^ cjk_STROKES}', "");
    Expect(0, 12783, '\P{ cjk_STROKES}', "");
    Expect(1, 12783, '\P{^ cjk_STROKES}', "");
    Expect(0, 12784, '\p{ cjk_STROKES}', "");
    Expect(1, 12784, '\p{^ cjk_STROKES}', "");
    Expect(1, 12784, '\P{ cjk_STROKES}', "");
    Expect(0, 12784, '\P{^ cjk_STROKES}', "");
    Error('\p{_ Is_cjk_STROKES/a/}');
    Error('\P{_ Is_cjk_STROKES/a/}');
    Expect(1, 12783, '\p{iscjkstrokes}', "");
    Expect(0, 12783, '\p{^iscjkstrokes}', "");
    Expect(0, 12783, '\P{iscjkstrokes}', "");
    Expect(1, 12783, '\P{^iscjkstrokes}', "");
    Expect(0, 12784, '\p{iscjkstrokes}', "");
    Expect(1, 12784, '\p{^iscjkstrokes}', "");
    Expect(1, 12784, '\P{iscjkstrokes}', "");
    Expect(0, 12784, '\P{^iscjkstrokes}', "");
    Expect(1, 12783, '\p{	_is_CJK_STROKES}', "");
    Expect(0, 12783, '\p{^	_is_CJK_STROKES}', "");
    Expect(0, 12783, '\P{	_is_CJK_STROKES}', "");
    Expect(1, 12783, '\P{^	_is_CJK_STROKES}', "");
    Expect(0, 12784, '\p{	_is_CJK_STROKES}', "");
    Expect(1, 12784, '\p{^	_is_CJK_STROKES}', "");
    Expect(1, 12784, '\P{	_is_CJK_STROKES}', "");
    Expect(0, 12784, '\P{^	_is_CJK_STROKES}', "");
    Error('\p{-IN_CJK_Strokes:=}');
    Error('\P{-IN_CJK_Strokes:=}');
    Expect(1, 12783, '\p{incjkstrokes}', "");
    Expect(0, 12783, '\p{^incjkstrokes}', "");
    Expect(0, 12783, '\P{incjkstrokes}', "");
    Expect(1, 12783, '\P{^incjkstrokes}', "");
    Expect(0, 12784, '\p{incjkstrokes}', "");
    Expect(1, 12784, '\p{^incjkstrokes}', "");
    Expect(1, 12784, '\P{incjkstrokes}', "");
    Expect(0, 12784, '\P{^incjkstrokes}', "");
    Expect(1, 12783, '\p{ IN_cjk_Strokes}', "");
    Expect(0, 12783, '\p{^ IN_cjk_Strokes}', "");
    Expect(0, 12783, '\P{ IN_cjk_Strokes}', "");
    Expect(1, 12783, '\P{^ IN_cjk_Strokes}', "");
    Expect(0, 12784, '\p{ IN_cjk_Strokes}', "");
    Expect(1, 12784, '\p{^ IN_cjk_Strokes}', "");
    Expect(1, 12784, '\P{ IN_cjk_Strokes}', "");
    Expect(0, 12784, '\P{^ IN_cjk_Strokes}', "");
    Error('\p{:=__CJK_Symbols_And_PUNCTUATION}');
    Error('\P{:=__CJK_Symbols_And_PUNCTUATION}');
    Expect(1, 12351, '\p{cjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\p{^cjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\P{cjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\P{^cjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\p{cjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\p{^cjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\P{cjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\P{^cjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\p{- CJK_SYMBOLS_and_PUNCTUATION}', "");
    Expect(0, 12351, '\p{^- CJK_SYMBOLS_and_PUNCTUATION}', "");
    Expect(0, 12351, '\P{- CJK_SYMBOLS_and_PUNCTUATION}', "");
    Expect(1, 12351, '\P{^- CJK_SYMBOLS_and_PUNCTUATION}', "");
    Expect(0, 12352, '\p{- CJK_SYMBOLS_and_PUNCTUATION}', "");
    Expect(1, 12352, '\p{^- CJK_SYMBOLS_and_PUNCTUATION}', "");
    Expect(1, 12352, '\P{- CJK_SYMBOLS_and_PUNCTUATION}', "");
    Expect(0, 12352, '\P{^- CJK_SYMBOLS_and_PUNCTUATION}', "");
    Error('\p{-Is_CJK_Symbols_AND_Punctuation/a/}');
    Error('\P{-Is_CJK_Symbols_AND_Punctuation/a/}');
    Expect(1, 12351, '\p{iscjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\p{^iscjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\P{iscjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\P{^iscjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\p{iscjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\p{^iscjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\P{iscjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\P{^iscjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\p{ 	IS_CJK_Symbols_AND_Punctuation}', "");
    Expect(0, 12351, '\p{^ 	IS_CJK_Symbols_AND_Punctuation}', "");
    Expect(0, 12351, '\P{ 	IS_CJK_Symbols_AND_Punctuation}', "");
    Expect(1, 12351, '\P{^ 	IS_CJK_Symbols_AND_Punctuation}', "");
    Expect(0, 12352, '\p{ 	IS_CJK_Symbols_AND_Punctuation}', "");
    Expect(1, 12352, '\p{^ 	IS_CJK_Symbols_AND_Punctuation}', "");
    Expect(1, 12352, '\P{ 	IS_CJK_Symbols_AND_Punctuation}', "");
    Expect(0, 12352, '\P{^ 	IS_CJK_Symbols_AND_Punctuation}', "");
    Error('\p{/a/_-IN_CJK_Symbols_And_Punctuation}');
    Error('\P{/a/_-IN_CJK_Symbols_And_Punctuation}');
    Expect(1, 12351, '\p{incjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\p{^incjksymbolsandpunctuation}', "");
    Expect(0, 12351, '\P{incjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\P{^incjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\p{incjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\p{^incjksymbolsandpunctuation}', "");
    Expect(1, 12352, '\P{incjksymbolsandpunctuation}', "");
    Expect(0, 12352, '\P{^incjksymbolsandpunctuation}', "");
    Expect(1, 12351, '\p{-_In_cjk_symbols_And_Punctuation}', "");
    Expect(0, 12351, '\p{^-_In_cjk_symbols_And_Punctuation}', "");
    Expect(0, 12351, '\P{-_In_cjk_symbols_And_Punctuation}', "");
    Expect(1, 12351, '\P{^-_In_cjk_symbols_And_Punctuation}', "");
    Expect(0, 12352, '\p{-_In_cjk_symbols_And_Punctuation}', "");
    Expect(1, 12352, '\p{^-_In_cjk_symbols_And_Punctuation}', "");
    Expect(1, 12352, '\P{-_In_cjk_symbols_And_Punctuation}', "");
    Expect(0, 12352, '\P{^-_In_cjk_symbols_And_Punctuation}', "");
    Error('\p{-CJK_SYMBOLS:=}');
    Error('\P{-CJK_SYMBOLS:=}');
    Expect(1, 12351, '\p{cjksymbols}', "");
    Expect(0, 12351, '\p{^cjksymbols}', "");
    Expect(0, 12351, '\P{cjksymbols}', "");
    Expect(1, 12351, '\P{^cjksymbols}', "");
    Expect(0, 12352, '\p{cjksymbols}', "");
    Expect(1, 12352, '\p{^cjksymbols}', "");
    Expect(1, 12352, '\P{cjksymbols}', "");
    Expect(0, 12352, '\P{^cjksymbols}', "");
    Expect(1, 12351, '\p{-cjk_symbols}', "");
    Expect(0, 12351, '\p{^-cjk_symbols}', "");
    Expect(0, 12351, '\P{-cjk_symbols}', "");
    Expect(1, 12351, '\P{^-cjk_symbols}', "");
    Expect(0, 12352, '\p{-cjk_symbols}', "");
    Expect(1, 12352, '\p{^-cjk_symbols}', "");
    Expect(1, 12352, '\P{-cjk_symbols}', "");
    Expect(0, 12352, '\P{^-cjk_symbols}', "");
    Error('\p{/a/_ IS_CJK_Symbols}');
    Error('\P{/a/_ IS_CJK_Symbols}');
    Expect(1, 12351, '\p{iscjksymbols}', "");
    Expect(0, 12351, '\p{^iscjksymbols}', "");
    Expect(0, 12351, '\P{iscjksymbols}', "");
    Expect(1, 12351, '\P{^iscjksymbols}', "");
    Expect(0, 12352, '\p{iscjksymbols}', "");
    Expect(1, 12352, '\p{^iscjksymbols}', "");
    Expect(1, 12352, '\P{iscjksymbols}', "");
    Expect(0, 12352, '\P{^iscjksymbols}', "");
    Expect(1, 12351, '\p{  is_CJK_Symbols}', "");
    Expect(0, 12351, '\p{^  is_CJK_Symbols}', "");
    Expect(0, 12351, '\P{  is_CJK_Symbols}', "");
    Expect(1, 12351, '\P{^  is_CJK_Symbols}', "");
    Expect(0, 12352, '\p{  is_CJK_Symbols}', "");
    Expect(1, 12352, '\p{^  is_CJK_Symbols}', "");
    Expect(1, 12352, '\P{  is_CJK_Symbols}', "");
    Expect(0, 12352, '\P{^  is_CJK_Symbols}', "");
    Error('\p{ in_cjk_SYMBOLS/a/}');
    Error('\P{ in_cjk_SYMBOLS/a/}');
    Expect(1, 12351, '\p{incjksymbols}', "");
    Expect(0, 12351, '\p{^incjksymbols}', "");
    Expect(0, 12351, '\P{incjksymbols}', "");
    Expect(1, 12351, '\P{^incjksymbols}', "");
    Expect(0, 12352, '\p{incjksymbols}', "");
    Expect(1, 12352, '\p{^incjksymbols}', "");
    Expect(1, 12352, '\P{incjksymbols}', "");
    Expect(0, 12352, '\P{^incjksymbols}', "");
    Expect(1, 12351, '\p{_	in_CJK_Symbols}', "");
    Expect(0, 12351, '\p{^_	in_CJK_Symbols}', "");
    Expect(0, 12351, '\P{_	in_CJK_Symbols}', "");
    Expect(1, 12351, '\P{^_	in_CJK_Symbols}', "");
    Expect(0, 12352, '\p{_	in_CJK_Symbols}', "");
    Expect(1, 12352, '\p{^_	in_CJK_Symbols}', "");
    Expect(1, 12352, '\P{_	in_CJK_Symbols}', "");
    Expect(0, 12352, '\P{^_	in_CJK_Symbols}', "");
    Error('\p{_:=cjk_UNIFIED_IDEOGRAPHS}');
    Error('\P{_:=cjk_UNIFIED_IDEOGRAPHS}');
    Expect(1, 40959, '\p{cjkunifiedideographs}', "");
    Expect(0, 40959, '\p{^cjkunifiedideographs}', "");
    Expect(0, 40959, '\P{cjkunifiedideographs}', "");
    Expect(1, 40959, '\P{^cjkunifiedideographs}', "");
    Expect(0, 40960, '\p{cjkunifiedideographs}', "");
    Expect(1, 40960, '\p{^cjkunifiedideographs}', "");
    Expect(1, 40960, '\P{cjkunifiedideographs}', "");
    Expect(0, 40960, '\P{^cjkunifiedideographs}', "");
    Expect(1, 40959, '\p{_	CJK_Unified_ideographs}', "");
    Expect(0, 40959, '\p{^_	CJK_Unified_ideographs}', "");
    Expect(0, 40959, '\P{_	CJK_Unified_ideographs}', "");
    Expect(1, 40959, '\P{^_	CJK_Unified_ideographs}', "");
    Expect(0, 40960, '\p{_	CJK_Unified_ideographs}', "");
    Expect(1, 40960, '\p{^_	CJK_Unified_ideographs}', "");
    Expect(1, 40960, '\P{_	CJK_Unified_ideographs}', "");
    Expect(0, 40960, '\P{^_	CJK_Unified_ideographs}', "");
    Error('\p{_IS_CJK_Unified_IDEOGRAPHS/a/}');
    Error('\P{_IS_CJK_Unified_IDEOGRAPHS/a/}');
    Expect(1, 40959, '\p{iscjkunifiedideographs}', "");
    Expect(0, 40959, '\p{^iscjkunifiedideographs}', "");
    Expect(0, 40959, '\P{iscjkunifiedideographs}', "");
    Expect(1, 40959, '\P{^iscjkunifiedideographs}', "");
    Expect(0, 40960, '\p{iscjkunifiedideographs}', "");
    Expect(1, 40960, '\p{^iscjkunifiedideographs}', "");
    Expect(1, 40960, '\P{iscjkunifiedideographs}', "");
    Expect(0, 40960, '\P{^iscjkunifiedideographs}', "");
    Expect(1, 40959, '\p{	is_CJK_unified_IDEOGRAPHS}', "");
    Expect(0, 40959, '\p{^	is_CJK_unified_IDEOGRAPHS}', "");
    Expect(0, 40959, '\P{	is_CJK_unified_IDEOGRAPHS}', "");
    Expect(1, 40959, '\P{^	is_CJK_unified_IDEOGRAPHS}', "");
    Expect(0, 40960, '\p{	is_CJK_unified_IDEOGRAPHS}', "");
    Expect(1, 40960, '\p{^	is_CJK_unified_IDEOGRAPHS}', "");
    Expect(1, 40960, '\P{	is_CJK_unified_IDEOGRAPHS}', "");
    Expect(0, 40960, '\P{^	is_CJK_unified_IDEOGRAPHS}', "");
    Error('\p{	-in_CJK_unified_Ideographs:=}');
    Error('\P{	-in_CJK_unified_Ideographs:=}');
    Expect(1, 40959, '\p{incjkunifiedideographs}', "");
    Expect(0, 40959, '\p{^incjkunifiedideographs}', "");
    Expect(0, 40959, '\P{incjkunifiedideographs}', "");
    Expect(1, 40959, '\P{^incjkunifiedideographs}', "");
    Expect(0, 40960, '\p{incjkunifiedideographs}', "");
    Expect(1, 40960, '\p{^incjkunifiedideographs}', "");
    Expect(1, 40960, '\P{incjkunifiedideographs}', "");
    Expect(0, 40960, '\P{^incjkunifiedideographs}', "");
    Expect(1, 40959, '\p{ in_CJK_Unified_Ideographs}', "");
    Expect(0, 40959, '\p{^ in_CJK_Unified_Ideographs}', "");
    Expect(0, 40959, '\P{ in_CJK_Unified_Ideographs}', "");
    Expect(1, 40959, '\P{^ in_CJK_Unified_Ideographs}', "");
    Expect(0, 40960, '\p{ in_CJK_Unified_Ideographs}', "");
    Expect(1, 40960, '\p{^ in_CJK_Unified_Ideographs}', "");
    Expect(1, 40960, '\P{ in_CJK_Unified_Ideographs}', "");
    Expect(0, 40960, '\P{^ in_CJK_Unified_Ideographs}', "");
    Error('\p{-CJK:=}');
    Error('\P{-CJK:=}');
    Expect(1, 40959, '\p{cjk}', "");
    Expect(0, 40959, '\p{^cjk}', "");
    Expect(0, 40959, '\P{cjk}', "");
    Expect(1, 40959, '\P{^cjk}', "");
    Expect(0, 40960, '\p{cjk}', "");
    Expect(1, 40960, '\p{^cjk}', "");
    Expect(1, 40960, '\P{cjk}', "");
    Expect(0, 40960, '\P{^cjk}', "");
    Expect(1, 40959, '\p{_	cjk}', "");
    Expect(0, 40959, '\p{^_	cjk}', "");
    Expect(0, 40959, '\P{_	cjk}', "");
    Expect(1, 40959, '\P{^_	cjk}', "");
    Expect(0, 40960, '\p{_	cjk}', "");
    Expect(1, 40960, '\p{^_	cjk}', "");
    Expect(1, 40960, '\P{_	cjk}', "");
    Expect(0, 40960, '\P{^_	cjk}', "");
    Error('\p{_/a/IS_CJK}');
    Error('\P{_/a/IS_CJK}');
    Expect(1, 40959, '\p{iscjk}', "");
    Expect(0, 40959, '\p{^iscjk}', "");
    Expect(0, 40959, '\P{iscjk}', "");
    Expect(1, 40959, '\P{^iscjk}', "");
    Expect(0, 40960, '\p{iscjk}', "");
    Expect(1, 40960, '\p{^iscjk}', "");
    Expect(1, 40960, '\P{iscjk}', "");
    Expect(0, 40960, '\P{^iscjk}', "");
    Expect(1, 40959, '\p{  is_CJK}', "");
    Expect(0, 40959, '\p{^  is_CJK}', "");
    Expect(0, 40959, '\P{  is_CJK}', "");
    Expect(1, 40959, '\P{^  is_CJK}', "");
    Expect(0, 40960, '\p{  is_CJK}', "");
    Expect(1, 40960, '\p{^  is_CJK}', "");
    Expect(1, 40960, '\P{  is_CJK}', "");
    Expect(0, 40960, '\P{^  is_CJK}', "");
    Error('\p{ _In_CJK/a/}');
    Error('\P{ _In_CJK/a/}');
    Expect(1, 40959, '\p{incjk}', "");
    Expect(0, 40959, '\p{^incjk}', "");
    Expect(0, 40959, '\P{incjk}', "");
    Expect(1, 40959, '\P{^incjk}', "");
    Expect(0, 40960, '\p{incjk}', "");
    Expect(1, 40960, '\p{^incjk}', "");
    Expect(1, 40960, '\P{incjk}', "");
    Expect(0, 40960, '\P{^incjk}', "");
    Expect(1, 40959, '\p{_ In_CJK}', "");
    Expect(0, 40959, '\p{^_ In_CJK}', "");
    Expect(0, 40959, '\P{_ In_CJK}', "");
    Expect(1, 40959, '\P{^_ In_CJK}', "");
    Expect(0, 40960, '\p{_ In_CJK}', "");
    Expect(1, 40960, '\p{^_ In_CJK}', "");
    Expect(1, 40960, '\P{_ In_CJK}', "");
    Expect(0, 40960, '\P{^_ In_CJK}', "");
    Error('\p{:=CJK_UNIFIED_Ideographs_EXTENSION_A}');
    Error('\P{:=CJK_UNIFIED_Ideographs_EXTENSION_A}');
    Expect(1, 19903, '\p{cjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\p{^cjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\P{cjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\P{^cjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\p{cjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\p{^cjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\P{cjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\P{^cjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\p{	_CJK_Unified_Ideographs_Extension_A}', "");
    Expect(0, 19903, '\p{^	_CJK_Unified_Ideographs_Extension_A}', "");
    Expect(0, 19903, '\P{	_CJK_Unified_Ideographs_Extension_A}', "");
    Expect(1, 19903, '\P{^	_CJK_Unified_Ideographs_Extension_A}', "");
    Expect(0, 19904, '\p{	_CJK_Unified_Ideographs_Extension_A}', "");
    Expect(1, 19904, '\p{^	_CJK_Unified_Ideographs_Extension_A}', "");
    Expect(1, 19904, '\P{	_CJK_Unified_Ideographs_Extension_A}', "");
    Expect(0, 19904, '\P{^	_CJK_Unified_Ideographs_Extension_A}', "");
    Error('\p{-is_CJK_unified_ideographs_Extension_A/a/}');
    Error('\P{-is_CJK_unified_ideographs_Extension_A/a/}');
    Expect(1, 19903, '\p{iscjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\p{^iscjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\P{iscjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\P{^iscjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\p{iscjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\p{^iscjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\P{iscjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\P{^iscjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\p{ _is_CJK_UNIFIED_ideographs_EXTENSION_A}', "");
    Expect(0, 19903, '\p{^ _is_CJK_UNIFIED_ideographs_EXTENSION_A}', "");
    Expect(0, 19903, '\P{ _is_CJK_UNIFIED_ideographs_EXTENSION_A}', "");
    Expect(1, 19903, '\P{^ _is_CJK_UNIFIED_ideographs_EXTENSION_A}', "");
    Expect(0, 19904, '\p{ _is_CJK_UNIFIED_ideographs_EXTENSION_A}', "");
    Expect(1, 19904, '\p{^ _is_CJK_UNIFIED_ideographs_EXTENSION_A}', "");
    Expect(1, 19904, '\P{ _is_CJK_UNIFIED_ideographs_EXTENSION_A}', "");
    Expect(0, 19904, '\P{^ _is_CJK_UNIFIED_ideographs_EXTENSION_A}', "");
    Error('\p{In_CJK_Unified_IDEOGRAPHS_extension_A:=}');
    Error('\P{In_CJK_Unified_IDEOGRAPHS_extension_A:=}');
    Expect(1, 19903, '\p{incjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\p{^incjkunifiedideographsextensiona}', "");
    Expect(0, 19903, '\P{incjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\P{^incjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\p{incjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\p{^incjkunifiedideographsextensiona}', "");
    Expect(1, 19904, '\P{incjkunifiedideographsextensiona}', "");
    Expect(0, 19904, '\P{^incjkunifiedideographsextensiona}', "");
    Expect(1, 19903, '\p{-_In_CJK_UNIFIED_Ideographs_Extension_A}', "");
    Expect(0, 19903, '\p{^-_In_CJK_UNIFIED_Ideographs_Extension_A}', "");
    Expect(0, 19903, '\P{-_In_CJK_UNIFIED_Ideographs_Extension_A}', "");
    Expect(1, 19903, '\P{^-_In_CJK_UNIFIED_Ideographs_Extension_A}', "");
    Expect(0, 19904, '\p{-_In_CJK_UNIFIED_Ideographs_Extension_A}', "");
    Expect(1, 19904, '\p{^-_In_CJK_UNIFIED_Ideographs_Extension_A}', "");
    Expect(1, 19904, '\P{-_In_CJK_UNIFIED_Ideographs_Extension_A}', "");
    Expect(0, 19904, '\P{^-_In_CJK_UNIFIED_Ideographs_Extension_A}', "");
    Error('\p{:=_	CJK_EXT_A}');
    Error('\P{:=_	CJK_EXT_A}');
    Expect(1, 19903, '\p{cjkexta}', "");
    Expect(0, 19903, '\p{^cjkexta}', "");
    Expect(0, 19903, '\P{cjkexta}', "");
    Expect(1, 19903, '\P{^cjkexta}', "");
    Expect(0, 19904, '\p{cjkexta}', "");
    Expect(1, 19904, '\p{^cjkexta}', "");
    Expect(1, 19904, '\P{cjkexta}', "");
    Expect(0, 19904, '\P{^cjkexta}', "");
    Expect(1, 19903, '\p{_ CJK_EXT_A}', "");
    Expect(0, 19903, '\p{^_ CJK_EXT_A}', "");
    Expect(0, 19903, '\P{_ CJK_EXT_A}', "");
    Expect(1, 19903, '\P{^_ CJK_EXT_A}', "");
    Expect(0, 19904, '\p{_ CJK_EXT_A}', "");
    Expect(1, 19904, '\p{^_ CJK_EXT_A}', "");
    Expect(1, 19904, '\P{_ CJK_EXT_A}', "");
    Expect(0, 19904, '\P{^_ CJK_EXT_A}', "");
    Error('\p{	/a/is_CJK_ext_A}');
    Error('\P{	/a/is_CJK_ext_A}');
    Expect(1, 19903, '\p{iscjkexta}', "");
    Expect(0, 19903, '\p{^iscjkexta}', "");
    Expect(0, 19903, '\P{iscjkexta}', "");
    Expect(1, 19903, '\P{^iscjkexta}', "");
    Expect(0, 19904, '\p{iscjkexta}', "");
    Expect(1, 19904, '\p{^iscjkexta}', "");
    Expect(1, 19904, '\P{iscjkexta}', "");
    Expect(0, 19904, '\P{^iscjkexta}', "");
    Expect(1, 19903, '\p{ _Is_cjk_Ext_a}', "");
    Expect(0, 19903, '\p{^ _Is_cjk_Ext_a}', "");
    Expect(0, 19903, '\P{ _Is_cjk_Ext_a}', "");
    Expect(1, 19903, '\P{^ _Is_cjk_Ext_a}', "");
    Expect(0, 19904, '\p{ _Is_cjk_Ext_a}', "");
    Expect(1, 19904, '\p{^ _Is_cjk_Ext_a}', "");
    Expect(1, 19904, '\P{ _Is_cjk_Ext_a}', "");
    Expect(0, 19904, '\P{^ _Is_cjk_Ext_a}', "");
    Error('\p{:=		in_CJK_ext_A}');
    Error('\P{:=		in_CJK_ext_A}');
    Expect(1, 19903, '\p{incjkexta}', "");
    Expect(0, 19903, '\p{^incjkexta}', "");
    Expect(0, 19903, '\P{incjkexta}', "");
    Expect(1, 19903, '\P{^incjkexta}', "");
    Expect(0, 19904, '\p{incjkexta}', "");
    Expect(1, 19904, '\p{^incjkexta}', "");
    Expect(1, 19904, '\P{incjkexta}', "");
    Expect(0, 19904, '\P{^incjkexta}', "");
    Expect(1, 19903, '\p{_-In_CJK_Ext_A}', "");
    Expect(0, 19903, '\p{^_-In_CJK_Ext_A}', "");
    Expect(0, 19903, '\P{_-In_CJK_Ext_A}', "");
    Expect(1, 19903, '\P{^_-In_CJK_Ext_A}', "");
    Expect(0, 19904, '\p{_-In_CJK_Ext_A}', "");
    Expect(1, 19904, '\p{^_-In_CJK_Ext_A}', "");
    Expect(1, 19904, '\P{_-In_CJK_Ext_A}', "");
    Expect(0, 19904, '\P{^_-In_CJK_Ext_A}', "");
    Error('\p{-CJK_Unified_IDEOGRAPHS_EXTENSION_b/a/}');
    Error('\P{-CJK_Unified_IDEOGRAPHS_EXTENSION_b/a/}');
    Expect(1, 173791, '\p{cjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\p{^cjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\P{cjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\P{^cjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\p{cjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\p{^cjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\P{cjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\P{^cjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\p{	 CJK_Unified_Ideographs_EXTENSION_B}', "");
    Expect(0, 173791, '\p{^	 CJK_Unified_Ideographs_EXTENSION_B}', "");
    Expect(0, 173791, '\P{	 CJK_Unified_Ideographs_EXTENSION_B}', "");
    Expect(1, 173791, '\P{^	 CJK_Unified_Ideographs_EXTENSION_B}', "");
    Expect(0, 173792, '\p{	 CJK_Unified_Ideographs_EXTENSION_B}', "");
    Expect(1, 173792, '\p{^	 CJK_Unified_Ideographs_EXTENSION_B}', "");
    Expect(1, 173792, '\P{	 CJK_Unified_Ideographs_EXTENSION_B}', "");
    Expect(0, 173792, '\P{^	 CJK_Unified_Ideographs_EXTENSION_B}', "");
    Error('\p{_ Is_CJK_unified_Ideographs_EXTENSION_B/a/}');
    Error('\P{_ Is_CJK_unified_Ideographs_EXTENSION_B/a/}');
    Expect(1, 173791, '\p{iscjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\p{^iscjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\P{iscjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\P{^iscjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\p{iscjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\p{^iscjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\P{iscjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\P{^iscjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\p{ -IS_CJK_Unified_Ideographs_Extension_B}', "");
    Expect(0, 173791, '\p{^ -IS_CJK_Unified_Ideographs_Extension_B}', "");
    Expect(0, 173791, '\P{ -IS_CJK_Unified_Ideographs_Extension_B}', "");
    Expect(1, 173791, '\P{^ -IS_CJK_Unified_Ideographs_Extension_B}', "");
    Expect(0, 173792, '\p{ -IS_CJK_Unified_Ideographs_Extension_B}', "");
    Expect(1, 173792, '\p{^ -IS_CJK_Unified_Ideographs_Extension_B}', "");
    Expect(1, 173792, '\P{ -IS_CJK_Unified_Ideographs_Extension_B}', "");
    Expect(0, 173792, '\P{^ -IS_CJK_Unified_Ideographs_Extension_B}', "");
    Error('\p{/a/	 In_CJK_unified_IDEOGRAPHS_EXTENSION_B}');
    Error('\P{/a/	 In_CJK_unified_IDEOGRAPHS_EXTENSION_B}');
    Expect(1, 173791, '\p{incjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\p{^incjkunifiedideographsextensionb}', "");
    Expect(0, 173791, '\P{incjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\P{^incjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\p{incjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\p{^incjkunifiedideographsextensionb}', "");
    Expect(1, 173792, '\P{incjkunifiedideographsextensionb}', "");
    Expect(0, 173792, '\P{^incjkunifiedideographsextensionb}', "");
    Expect(1, 173791, '\p{- In_CJK_UNIFIED_IDEOGRAPHS_Extension_B}', "");
    Expect(0, 173791, '\p{^- In_CJK_UNIFIED_IDEOGRAPHS_Extension_B}', "");
    Expect(0, 173791, '\P{- In_CJK_UNIFIED_IDEOGRAPHS_Extension_B}', "");
    Expect(1, 173791, '\P{^- In_CJK_UNIFIED_IDEOGRAPHS_Extension_B}', "");
    Expect(0, 173792, '\p{- In_CJK_UNIFIED_IDEOGRAPHS_Extension_B}', "");
    Expect(1, 173792, '\p{^- In_CJK_UNIFIED_IDEOGRAPHS_Extension_B}', "");
    Expect(1, 173792, '\P{- In_CJK_UNIFIED_IDEOGRAPHS_Extension_B}', "");
    Expect(0, 173792, '\P{^- In_CJK_UNIFIED_IDEOGRAPHS_Extension_B}', "");
    Error('\p{/a/CJK_ext_B}');
    Error('\P{/a/CJK_ext_B}');
    Expect(1, 173791, '\p{cjkextb}', "");
    Expect(0, 173791, '\p{^cjkextb}', "");
    Expect(0, 173791, '\P{cjkextb}', "");
    Expect(1, 173791, '\P{^cjkextb}', "");
    Expect(0, 173792, '\p{cjkextb}', "");
    Expect(1, 173792, '\p{^cjkextb}', "");
    Expect(1, 173792, '\P{cjkextb}', "");
    Expect(0, 173792, '\P{^cjkextb}', "");
    Expect(1, 173791, '\p{-CJK_Ext_B}', "");
    Expect(0, 173791, '\p{^-CJK_Ext_B}', "");
    Expect(0, 173791, '\P{-CJK_Ext_B}', "");
    Expect(1, 173791, '\P{^-CJK_Ext_B}', "");
    Expect(0, 173792, '\p{-CJK_Ext_B}', "");
    Expect(1, 173792, '\p{^-CJK_Ext_B}', "");
    Expect(1, 173792, '\P{-CJK_Ext_B}', "");
    Expect(0, 173792, '\P{^-CJK_Ext_B}', "");
    Error('\p{/a/Is_CJK_EXT_B}');
    Error('\P{/a/Is_CJK_EXT_B}');
    Expect(1, 173791, '\p{iscjkextb}', "");
    Expect(0, 173791, '\p{^iscjkextb}', "");
    Expect(0, 173791, '\P{iscjkextb}', "");
    Expect(1, 173791, '\P{^iscjkextb}', "");
    Expect(0, 173792, '\p{iscjkextb}', "");
    Expect(1, 173792, '\p{^iscjkextb}', "");
    Expect(1, 173792, '\P{iscjkextb}', "");
    Expect(0, 173792, '\P{^iscjkextb}', "");
    Expect(1, 173791, '\p{		IS_CJK_EXT_B}', "");
    Expect(0, 173791, '\p{^		IS_CJK_EXT_B}', "");
    Expect(0, 173791, '\P{		IS_CJK_EXT_B}', "");
    Expect(1, 173791, '\P{^		IS_CJK_EXT_B}', "");
    Expect(0, 173792, '\p{		IS_CJK_EXT_B}', "");
    Expect(1, 173792, '\p{^		IS_CJK_EXT_B}', "");
    Expect(1, 173792, '\P{		IS_CJK_EXT_B}', "");
    Expect(0, 173792, '\P{^		IS_CJK_EXT_B}', "");
    Error('\p{-_In_CJK_Ext_B:=}');
    Error('\P{-_In_CJK_Ext_B:=}');
    Expect(1, 173791, '\p{incjkextb}', "");
    Expect(0, 173791, '\p{^incjkextb}', "");
    Expect(0, 173791, '\P{incjkextb}', "");
    Expect(1, 173791, '\P{^incjkextb}', "");
    Expect(0, 173792, '\p{incjkextb}', "");
    Expect(1, 173792, '\p{^incjkextb}', "");
    Expect(1, 173792, '\P{incjkextb}', "");
    Expect(0, 173792, '\P{^incjkextb}', "");
    Expect(1, 173791, '\p{_in_CJK_Ext_B}', "");
    Expect(0, 173791, '\p{^_in_CJK_Ext_B}', "");
    Expect(0, 173791, '\P{_in_CJK_Ext_B}', "");
    Expect(1, 173791, '\P{^_in_CJK_Ext_B}', "");
    Expect(0, 173792, '\p{_in_CJK_Ext_B}', "");
    Expect(1, 173792, '\p{^_in_CJK_Ext_B}', "");
    Expect(1, 173792, '\P{_in_CJK_Ext_B}', "");
    Expect(0, 173792, '\P{^_in_CJK_Ext_B}', "");
    Error('\p{_-CJK_UNIFIED_Ideographs_Extension_C/a/}');
    Error('\P{_-CJK_UNIFIED_Ideographs_Extension_C/a/}');
    Expect(1, 177983, '\p{cjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\p{^cjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\P{cjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\P{^cjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\p{cjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\p{^cjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\P{cjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\P{^cjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\p{-	CJK_Unified_ideographs_Extension_C}', "");
    Expect(0, 177983, '\p{^-	CJK_Unified_ideographs_Extension_C}', "");
    Expect(0, 177983, '\P{-	CJK_Unified_ideographs_Extension_C}', "");
    Expect(1, 177983, '\P{^-	CJK_Unified_ideographs_Extension_C}', "");
    Expect(0, 177984, '\p{-	CJK_Unified_ideographs_Extension_C}', "");
    Expect(1, 177984, '\p{^-	CJK_Unified_ideographs_Extension_C}', "");
    Expect(1, 177984, '\P{-	CJK_Unified_ideographs_Extension_C}', "");
    Expect(0, 177984, '\P{^-	CJK_Unified_ideographs_Extension_C}', "");
    Error('\p{:=-IS_cjk_Unified_Ideographs_Extension_C}');
    Error('\P{:=-IS_cjk_Unified_Ideographs_Extension_C}');
    Expect(1, 177983, '\p{iscjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\p{^iscjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\P{iscjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\P{^iscjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\p{iscjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\p{^iscjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\P{iscjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\P{^iscjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\p{-Is_CJK_Unified_Ideographs_Extension_C}', "");
    Expect(0, 177983, '\p{^-Is_CJK_Unified_Ideographs_Extension_C}', "");
    Expect(0, 177983, '\P{-Is_CJK_Unified_Ideographs_Extension_C}', "");
    Expect(1, 177983, '\P{^-Is_CJK_Unified_Ideographs_Extension_C}', "");
    Expect(0, 177984, '\p{-Is_CJK_Unified_Ideographs_Extension_C}', "");
    Expect(1, 177984, '\p{^-Is_CJK_Unified_Ideographs_Extension_C}', "");
    Expect(1, 177984, '\P{-Is_CJK_Unified_Ideographs_Extension_C}', "");
    Expect(0, 177984, '\P{^-Is_CJK_Unified_Ideographs_Extension_C}', "");
    Error('\p{	 In_CJK_Unified_IDEOGRAPHS_extension_C/a/}');
    Error('\P{	 In_CJK_Unified_IDEOGRAPHS_extension_C/a/}');
    Expect(1, 177983, '\p{incjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\p{^incjkunifiedideographsextensionc}', "");
    Expect(0, 177983, '\P{incjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\P{^incjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\p{incjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\p{^incjkunifiedideographsextensionc}', "");
    Expect(1, 177984, '\P{incjkunifiedideographsextensionc}', "");
    Expect(0, 177984, '\P{^incjkunifiedideographsextensionc}', "");
    Expect(1, 177983, '\p{- In_CJK_Unified_Ideographs_Extension_c}', "");
    Expect(0, 177983, '\p{^- In_CJK_Unified_Ideographs_Extension_c}', "");
    Expect(0, 177983, '\P{- In_CJK_Unified_Ideographs_Extension_c}', "");
    Expect(1, 177983, '\P{^- In_CJK_Unified_Ideographs_Extension_c}', "");
    Expect(0, 177984, '\p{- In_CJK_Unified_Ideographs_Extension_c}', "");
    Expect(1, 177984, '\p{^- In_CJK_Unified_Ideographs_Extension_c}', "");
    Expect(1, 177984, '\P{- In_CJK_Unified_Ideographs_Extension_c}', "");
    Expect(0, 177984, '\P{^- In_CJK_Unified_Ideographs_Extension_c}', "");
    Error('\p{ /a/CJK_Ext_C}');
    Error('\P{ /a/CJK_Ext_C}');
    Expect(1, 177983, '\p{cjkextc}', "");
    Expect(0, 177983, '\p{^cjkextc}', "");
    Expect(0, 177983, '\P{cjkextc}', "");
    Expect(1, 177983, '\P{^cjkextc}', "");
    Expect(0, 177984, '\p{cjkextc}', "");
    Expect(1, 177984, '\p{^cjkextc}', "");
    Expect(1, 177984, '\P{cjkextc}', "");
    Expect(0, 177984, '\P{^cjkextc}', "");
    Expect(1, 177983, '\p{_CJK_ext_C}', "");
    Expect(0, 177983, '\p{^_CJK_ext_C}', "");
    Expect(0, 177983, '\P{_CJK_ext_C}', "");
    Expect(1, 177983, '\P{^_CJK_ext_C}', "");
    Expect(0, 177984, '\p{_CJK_ext_C}', "");
    Expect(1, 177984, '\p{^_CJK_ext_C}', "");
    Expect(1, 177984, '\P{_CJK_ext_C}', "");
    Expect(0, 177984, '\P{^_CJK_ext_C}', "");
    Error('\p{ /a/is_CJK_Ext_c}');
    Error('\P{ /a/is_CJK_Ext_c}');
    Expect(1, 177983, '\p{iscjkextc}', "");
    Expect(0, 177983, '\p{^iscjkextc}', "");
    Expect(0, 177983, '\P{iscjkextc}', "");
    Expect(1, 177983, '\P{^iscjkextc}', "");
    Expect(0, 177984, '\p{iscjkextc}', "");
    Expect(1, 177984, '\p{^iscjkextc}', "");
    Expect(1, 177984, '\P{iscjkextc}', "");
    Expect(0, 177984, '\P{^iscjkextc}', "");
    Expect(1, 177983, '\p{--Is_CJK_ext_C}', "");
    Expect(0, 177983, '\p{^--Is_CJK_ext_C}', "");
    Expect(0, 177983, '\P{--Is_CJK_ext_C}', "");
    Expect(1, 177983, '\P{^--Is_CJK_ext_C}', "");
    Expect(0, 177984, '\p{--Is_CJK_ext_C}', "");
    Expect(1, 177984, '\p{^--Is_CJK_ext_C}', "");
    Expect(1, 177984, '\P{--Is_CJK_ext_C}', "");
    Expect(0, 177984, '\P{^--Is_CJK_ext_C}', "");
    Error('\p{-:=in_CJK_Ext_C}');
    Error('\P{-:=in_CJK_Ext_C}');
    Expect(1, 177983, '\p{incjkextc}', "");
    Expect(0, 177983, '\p{^incjkextc}', "");
    Expect(0, 177983, '\P{incjkextc}', "");
    Expect(1, 177983, '\P{^incjkextc}', "");
    Expect(0, 177984, '\p{incjkextc}', "");
    Expect(1, 177984, '\p{^incjkextc}', "");
    Expect(1, 177984, '\P{incjkextc}', "");
    Expect(0, 177984, '\P{^incjkextc}', "");
    Expect(1, 177983, '\p{__In_CJK_Ext_C}', "");
    Expect(0, 177983, '\p{^__In_CJK_Ext_C}', "");
    Expect(0, 177983, '\P{__In_CJK_Ext_C}', "");
    Expect(1, 177983, '\P{^__In_CJK_Ext_C}', "");
    Expect(0, 177984, '\p{__In_CJK_Ext_C}', "");
    Expect(1, 177984, '\p{^__In_CJK_Ext_C}', "");
    Expect(1, 177984, '\P{__In_CJK_Ext_C}', "");
    Expect(0, 177984, '\P{^__In_CJK_Ext_C}', "");
    Error('\p{ _CJK_UNIFIED_ideographs_EXTENSION_d/a/}');
    Error('\P{ _CJK_UNIFIED_ideographs_EXTENSION_d/a/}');
    Expect(1, 178207, '\p{cjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\p{^cjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\P{cjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\P{^cjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\p{cjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\p{^cjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\P{cjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\P{^cjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\p{	 CJK_Unified_ideographs_Extension_D}', "");
    Expect(0, 178207, '\p{^	 CJK_Unified_ideographs_Extension_D}', "");
    Expect(0, 178207, '\P{	 CJK_Unified_ideographs_Extension_D}', "");
    Expect(1, 178207, '\P{^	 CJK_Unified_ideographs_Extension_D}', "");
    Expect(0, 178208, '\p{	 CJK_Unified_ideographs_Extension_D}', "");
    Expect(1, 178208, '\p{^	 CJK_Unified_ideographs_Extension_D}', "");
    Expect(1, 178208, '\P{	 CJK_Unified_ideographs_Extension_D}', "");
    Expect(0, 178208, '\P{^	 CJK_Unified_ideographs_Extension_D}', "");
    Error('\p{/a/_-is_cjk_unified_Ideographs_Extension_D}');
    Error('\P{/a/_-is_cjk_unified_Ideographs_Extension_D}');
    Expect(1, 178207, '\p{iscjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\p{^iscjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\P{iscjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\P{^iscjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\p{iscjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\p{^iscjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\P{iscjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\P{^iscjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\p{_Is_CJK_Unified_IDEOGRAPHS_Extension_D}', "");
    Expect(0, 178207, '\p{^_Is_CJK_Unified_IDEOGRAPHS_Extension_D}', "");
    Expect(0, 178207, '\P{_Is_CJK_Unified_IDEOGRAPHS_Extension_D}', "");
    Expect(1, 178207, '\P{^_Is_CJK_Unified_IDEOGRAPHS_Extension_D}', "");
    Expect(0, 178208, '\p{_Is_CJK_Unified_IDEOGRAPHS_Extension_D}', "");
    Expect(1, 178208, '\p{^_Is_CJK_Unified_IDEOGRAPHS_Extension_D}', "");
    Expect(1, 178208, '\P{_Is_CJK_Unified_IDEOGRAPHS_Extension_D}', "");
    Expect(0, 178208, '\P{^_Is_CJK_Unified_IDEOGRAPHS_Extension_D}', "");
    Error('\p{/a/		In_CJK_Unified_IDEOGRAPHS_Extension_d}');
    Error('\P{/a/		In_CJK_Unified_IDEOGRAPHS_Extension_d}');
    Expect(1, 178207, '\p{incjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\p{^incjkunifiedideographsextensiond}', "");
    Expect(0, 178207, '\P{incjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\P{^incjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\p{incjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\p{^incjkunifiedideographsextensiond}', "");
    Expect(1, 178208, '\P{incjkunifiedideographsextensiond}', "");
    Expect(0, 178208, '\P{^incjkunifiedideographsextensiond}', "");
    Expect(1, 178207, '\p{-	In_CJK_Unified_Ideographs_Extension_D}', "");
    Expect(0, 178207, '\p{^-	In_CJK_Unified_Ideographs_Extension_D}', "");
    Expect(0, 178207, '\P{-	In_CJK_Unified_Ideographs_Extension_D}', "");
    Expect(1, 178207, '\P{^-	In_CJK_Unified_Ideographs_Extension_D}', "");
    Expect(0, 178208, '\p{-	In_CJK_Unified_Ideographs_Extension_D}', "");
    Expect(1, 178208, '\p{^-	In_CJK_Unified_Ideographs_Extension_D}', "");
    Expect(1, 178208, '\P{-	In_CJK_Unified_Ideographs_Extension_D}', "");
    Expect(0, 178208, '\P{^-	In_CJK_Unified_Ideographs_Extension_D}', "");
    Error('\p{_:=CJK_EXT_D}');
    Error('\P{_:=CJK_EXT_D}');
    Expect(1, 178207, '\p{cjkextd}', "");
    Expect(0, 178207, '\p{^cjkextd}', "");
    Expect(0, 178207, '\P{cjkextd}', "");
    Expect(1, 178207, '\P{^cjkextd}', "");
    Expect(0, 178208, '\p{cjkextd}', "");
    Expect(1, 178208, '\p{^cjkextd}', "");
    Expect(1, 178208, '\P{cjkextd}', "");
    Expect(0, 178208, '\P{^cjkextd}', "");
    Expect(1, 178207, '\p{- CJK_Ext_D}', "");
    Expect(0, 178207, '\p{^- CJK_Ext_D}', "");
    Expect(0, 178207, '\P{- CJK_Ext_D}', "");
    Expect(1, 178207, '\P{^- CJK_Ext_D}', "");
    Expect(0, 178208, '\p{- CJK_Ext_D}', "");
    Expect(1, 178208, '\p{^- CJK_Ext_D}', "");
    Expect(1, 178208, '\P{- CJK_Ext_D}', "");
    Expect(0, 178208, '\P{^- CJK_Ext_D}', "");
    Error('\p{	/a/IS_CJK_Ext_D}');
    Error('\P{	/a/IS_CJK_Ext_D}');
    Expect(1, 178207, '\p{iscjkextd}', "");
    Expect(0, 178207, '\p{^iscjkextd}', "");
    Expect(0, 178207, '\P{iscjkextd}', "");
    Expect(1, 178207, '\P{^iscjkextd}', "");
    Expect(0, 178208, '\p{iscjkextd}', "");
    Expect(1, 178208, '\p{^iscjkextd}', "");
    Expect(1, 178208, '\P{iscjkextd}', "");
    Expect(0, 178208, '\P{^iscjkextd}', "");
    Expect(1, 178207, '\p{ _Is_CJK_Ext_D}', "");
    Expect(0, 178207, '\p{^ _Is_CJK_Ext_D}', "");
    Expect(0, 178207, '\P{ _Is_CJK_Ext_D}', "");
    Expect(1, 178207, '\P{^ _Is_CJK_Ext_D}', "");
    Expect(0, 178208, '\p{ _Is_CJK_Ext_D}', "");
    Expect(1, 178208, '\p{^ _Is_CJK_Ext_D}', "");
    Expect(1, 178208, '\P{ _Is_CJK_Ext_D}', "");
    Expect(0, 178208, '\P{^ _Is_CJK_Ext_D}', "");
    Error('\p{	 in_cjk_Ext_D/a/}');
    Error('\P{	 in_cjk_Ext_D/a/}');
    Expect(1, 178207, '\p{incjkextd}', "");
    Expect(0, 178207, '\p{^incjkextd}', "");
    Expect(0, 178207, '\P{incjkextd}', "");
    Expect(1, 178207, '\P{^incjkextd}', "");
    Expect(0, 178208, '\p{incjkextd}', "");
    Expect(1, 178208, '\p{^incjkextd}', "");
    Expect(1, 178208, '\P{incjkextd}', "");
    Expect(0, 178208, '\P{^incjkextd}', "");
    Expect(1, 178207, '\p{	-IN_CJK_ext_D}', "");
    Expect(0, 178207, '\p{^	-IN_CJK_ext_D}', "");
    Expect(0, 178207, '\P{	-IN_CJK_ext_D}', "");
    Expect(1, 178207, '\P{^	-IN_CJK_ext_D}', "");
    Expect(0, 178208, '\p{	-IN_CJK_ext_D}', "");
    Expect(1, 178208, '\p{^	-IN_CJK_ext_D}', "");
    Expect(1, 178208, '\P{	-IN_CJK_ext_D}', "");
    Expect(0, 178208, '\P{^	-IN_CJK_ext_D}', "");
    Error('\p{:=-CJK_Unified_Ideographs_Extension_e}');
    Error('\P{:=-CJK_Unified_Ideographs_Extension_e}');
    Expect(1, 183983, '\p{cjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\p{^cjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\P{cjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\P{^cjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\p{cjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\p{^cjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\P{cjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\P{^cjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\p{_cjk_Unified_IDEOGRAPHS_Extension_E}', "");
    Expect(0, 183983, '\p{^_cjk_Unified_IDEOGRAPHS_Extension_E}', "");
    Expect(0, 183983, '\P{_cjk_Unified_IDEOGRAPHS_Extension_E}', "");
    Expect(1, 183983, '\P{^_cjk_Unified_IDEOGRAPHS_Extension_E}', "");
    Expect(0, 183984, '\p{_cjk_Unified_IDEOGRAPHS_Extension_E}', "");
    Expect(1, 183984, '\p{^_cjk_Unified_IDEOGRAPHS_Extension_E}', "");
    Expect(1, 183984, '\P{_cjk_Unified_IDEOGRAPHS_Extension_E}', "");
    Expect(0, 183984, '\P{^_cjk_Unified_IDEOGRAPHS_Extension_E}', "");
    Error('\p{  Is_CJK_UNIFIED_Ideographs_Extension_E/a/}');
    Error('\P{  Is_CJK_UNIFIED_Ideographs_Extension_E/a/}');
    Expect(1, 183983, '\p{iscjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\p{^iscjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\P{iscjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\P{^iscjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\p{iscjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\p{^iscjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\P{iscjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\P{^iscjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\p{ 	IS_CJK_unified_Ideographs_extension_E}', "");
    Expect(0, 183983, '\p{^ 	IS_CJK_unified_Ideographs_extension_E}', "");
    Expect(0, 183983, '\P{ 	IS_CJK_unified_Ideographs_extension_E}', "");
    Expect(1, 183983, '\P{^ 	IS_CJK_unified_Ideographs_extension_E}', "");
    Expect(0, 183984, '\p{ 	IS_CJK_unified_Ideographs_extension_E}', "");
    Expect(1, 183984, '\p{^ 	IS_CJK_unified_Ideographs_extension_E}', "");
    Expect(1, 183984, '\P{ 	IS_CJK_unified_Ideographs_extension_E}', "");
    Expect(0, 183984, '\P{^ 	IS_CJK_unified_Ideographs_extension_E}', "");
    Error('\p{ :=In_cjk_unified_IDEOGRAPHS_EXTENSION_e}');
    Error('\P{ :=In_cjk_unified_IDEOGRAPHS_EXTENSION_e}');
    Expect(1, 183983, '\p{incjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\p{^incjkunifiedideographsextensione}', "");
    Expect(0, 183983, '\P{incjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\P{^incjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\p{incjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\p{^incjkunifiedideographsextensione}', "");
    Expect(1, 183984, '\P{incjkunifiedideographsextensione}', "");
    Expect(0, 183984, '\P{^incjkunifiedideographsextensione}', "");
    Expect(1, 183983, '\p{	_IN_cjk_Unified_IDEOGRAPHS_Extension_E}', "");
    Expect(0, 183983, '\p{^	_IN_cjk_Unified_IDEOGRAPHS_Extension_E}', "");
    Expect(0, 183983, '\P{	_IN_cjk_Unified_IDEOGRAPHS_Extension_E}', "");
    Expect(1, 183983, '\P{^	_IN_cjk_Unified_IDEOGRAPHS_Extension_E}', "");
    Expect(0, 183984, '\p{	_IN_cjk_Unified_IDEOGRAPHS_Extension_E}', "");
    Expect(1, 183984, '\p{^	_IN_cjk_Unified_IDEOGRAPHS_Extension_E}', "");
    Expect(1, 183984, '\P{	_IN_cjk_Unified_IDEOGRAPHS_Extension_E}', "");
    Expect(0, 183984, '\P{^	_IN_cjk_Unified_IDEOGRAPHS_Extension_E}', "");
    Error('\p{:=	-cjk_Ext_E}');
    Error('\P{:=	-cjk_Ext_E}');
    Expect(1, 183983, '\p{cjkexte}', "");
    Expect(0, 183983, '\p{^cjkexte}', "");
    Expect(0, 183983, '\P{cjkexte}', "");
    Expect(1, 183983, '\P{^cjkexte}', "");
    Expect(0, 183984, '\p{cjkexte}', "");
    Expect(1, 183984, '\p{^cjkexte}', "");
    Expect(1, 183984, '\P{cjkexte}', "");
    Expect(0, 183984, '\P{^cjkexte}', "");
    Expect(1, 183983, '\p{-CJK_Ext_E}', "");
    Expect(0, 183983, '\p{^-CJK_Ext_E}', "");
    Expect(0, 183983, '\P{-CJK_Ext_E}', "");
    Expect(1, 183983, '\P{^-CJK_Ext_E}', "");
    Expect(0, 183984, '\p{-CJK_Ext_E}', "");
    Expect(1, 183984, '\p{^-CJK_Ext_E}', "");
    Expect(1, 183984, '\P{-CJK_Ext_E}', "");
    Expect(0, 183984, '\P{^-CJK_Ext_E}', "");
    Error('\p{/a/-is_CJK_ext_E}');
    Error('\P{/a/-is_CJK_ext_E}');
    Expect(1, 183983, '\p{iscjkexte}', "");
    Expect(0, 183983, '\p{^iscjkexte}', "");
    Expect(0, 183983, '\P{iscjkexte}', "");
    Expect(1, 183983, '\P{^iscjkexte}', "");
    Expect(0, 183984, '\p{iscjkexte}', "");
    Expect(1, 183984, '\p{^iscjkexte}', "");
    Expect(1, 183984, '\P{iscjkexte}', "");
    Expect(0, 183984, '\P{^iscjkexte}', "");
    Expect(1, 183983, '\p{		is_CJK_Ext_e}', "");
    Expect(0, 183983, '\p{^		is_CJK_Ext_e}', "");
    Expect(0, 183983, '\P{		is_CJK_Ext_e}', "");
    Expect(1, 183983, '\P{^		is_CJK_Ext_e}', "");
    Expect(0, 183984, '\p{		is_CJK_Ext_e}', "");
    Expect(1, 183984, '\p{^		is_CJK_Ext_e}', "");
    Expect(1, 183984, '\P{		is_CJK_Ext_e}', "");
    Expect(0, 183984, '\P{^		is_CJK_Ext_e}', "");
    Error('\p{	:=In_CJK_Ext_E}');
    Error('\P{	:=In_CJK_Ext_E}');
    Expect(1, 183983, '\p{incjkexte}', "");
    Expect(0, 183983, '\p{^incjkexte}', "");
    Expect(0, 183983, '\P{incjkexte}', "");
    Expect(1, 183983, '\P{^incjkexte}', "");
    Expect(0, 183984, '\p{incjkexte}', "");
    Expect(1, 183984, '\p{^incjkexte}', "");
    Expect(1, 183984, '\P{incjkexte}', "");
    Expect(0, 183984, '\P{^incjkexte}', "");
    Expect(1, 183983, '\p{-	IN_CJK_Ext_e}', "");
    Expect(0, 183983, '\p{^-	IN_CJK_Ext_e}', "");
    Expect(0, 183983, '\P{-	IN_CJK_Ext_e}', "");
    Expect(1, 183983, '\P{^-	IN_CJK_Ext_e}', "");
    Expect(0, 183984, '\p{-	IN_CJK_Ext_e}', "");
    Expect(1, 183984, '\p{^-	IN_CJK_Ext_e}', "");
    Expect(1, 183984, '\P{-	IN_CJK_Ext_e}', "");
    Expect(0, 183984, '\P{^-	IN_CJK_Ext_e}', "");
    Error('\p{-_CJK_UNIFIED_ideographs_Extension_F/a/}');
    Error('\P{-_CJK_UNIFIED_ideographs_Extension_F/a/}');
    Expect(1, 191471, '\p{cjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\p{^cjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\P{cjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\P{^cjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\p{cjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\p{^cjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\P{cjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\P{^cjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\p{		CJK_UNIFIED_Ideographs_extension_F}', "");
    Expect(0, 191471, '\p{^		CJK_UNIFIED_Ideographs_extension_F}', "");
    Expect(0, 191471, '\P{		CJK_UNIFIED_Ideographs_extension_F}', "");
    Expect(1, 191471, '\P{^		CJK_UNIFIED_Ideographs_extension_F}', "");
    Expect(0, 191472, '\p{		CJK_UNIFIED_Ideographs_extension_F}', "");
    Expect(1, 191472, '\p{^		CJK_UNIFIED_Ideographs_extension_F}', "");
    Expect(1, 191472, '\P{		CJK_UNIFIED_Ideographs_extension_F}', "");
    Expect(0, 191472, '\P{^		CJK_UNIFIED_Ideographs_extension_F}', "");
    Error('\p{:=	-IS_cjk_UNIFIED_IDEOGRAPHS_Extension_F}');
    Error('\P{:=	-IS_cjk_UNIFIED_IDEOGRAPHS_Extension_F}');
    Expect(1, 191471, '\p{iscjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\p{^iscjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\P{iscjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\P{^iscjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\p{iscjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\p{^iscjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\P{iscjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\P{^iscjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\p{_ is_CJK_Unified_IDEOGRAPHS_EXTENSION_f}', "");
    Expect(0, 191471, '\p{^_ is_CJK_Unified_IDEOGRAPHS_EXTENSION_f}', "");
    Expect(0, 191471, '\P{_ is_CJK_Unified_IDEOGRAPHS_EXTENSION_f}', "");
    Expect(1, 191471, '\P{^_ is_CJK_Unified_IDEOGRAPHS_EXTENSION_f}', "");
    Expect(0, 191472, '\p{_ is_CJK_Unified_IDEOGRAPHS_EXTENSION_f}', "");
    Expect(1, 191472, '\p{^_ is_CJK_Unified_IDEOGRAPHS_EXTENSION_f}', "");
    Expect(1, 191472, '\P{_ is_CJK_Unified_IDEOGRAPHS_EXTENSION_f}', "");
    Expect(0, 191472, '\P{^_ is_CJK_Unified_IDEOGRAPHS_EXTENSION_f}', "");
    Error('\p{	:=in_cjk_Unified_Ideographs_extension_F}');
    Error('\P{	:=in_cjk_Unified_Ideographs_extension_F}');
    Expect(1, 191471, '\p{incjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\p{^incjkunifiedideographsextensionf}', "");
    Expect(0, 191471, '\P{incjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\P{^incjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\p{incjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\p{^incjkunifiedideographsextensionf}', "");
    Expect(1, 191472, '\P{incjkunifiedideographsextensionf}', "");
    Expect(0, 191472, '\P{^incjkunifiedideographsextensionf}', "");
    Expect(1, 191471, '\p{ -in_CJK_UNIFIED_Ideographs_Extension_F}', "");
    Expect(0, 191471, '\p{^ -in_CJK_UNIFIED_Ideographs_Extension_F}', "");
    Expect(0, 191471, '\P{ -in_CJK_UNIFIED_Ideographs_Extension_F}', "");
    Expect(1, 191471, '\P{^ -in_CJK_UNIFIED_Ideographs_Extension_F}', "");
    Expect(0, 191472, '\p{ -in_CJK_UNIFIED_Ideographs_Extension_F}', "");
    Expect(1, 191472, '\p{^ -in_CJK_UNIFIED_Ideographs_Extension_F}', "");
    Expect(1, 191472, '\P{ -in_CJK_UNIFIED_Ideographs_Extension_F}', "");
    Expect(0, 191472, '\P{^ -in_CJK_UNIFIED_Ideographs_Extension_F}', "");
    Error('\p{_:=cjk_Ext_F}');
    Error('\P{_:=cjk_Ext_F}');
    Expect(1, 191471, '\p{cjkextf}', "");
    Expect(0, 191471, '\p{^cjkextf}', "");
    Expect(0, 191471, '\P{cjkextf}', "");
    Expect(1, 191471, '\P{^cjkextf}', "");
    Expect(0, 191472, '\p{cjkextf}', "");
    Expect(1, 191472, '\p{^cjkextf}', "");
    Expect(1, 191472, '\P{cjkextf}', "");
    Expect(0, 191472, '\P{^cjkextf}', "");
    Expect(1, 191471, '\p{-_CJK_EXT_F}', "");
    Expect(0, 191471, '\p{^-_CJK_EXT_F}', "");
    Expect(0, 191471, '\P{-_CJK_EXT_F}', "");
    Expect(1, 191471, '\P{^-_CJK_EXT_F}', "");
    Expect(0, 191472, '\p{-_CJK_EXT_F}', "");
    Expect(1, 191472, '\p{^-_CJK_EXT_F}', "");
    Expect(1, 191472, '\P{-_CJK_EXT_F}', "");
    Expect(0, 191472, '\P{^-_CJK_EXT_F}', "");
    Error('\p{-:=Is_CJK_Ext_F}');
    Error('\P{-:=Is_CJK_Ext_F}');
    Expect(1, 191471, '\p{iscjkextf}', "");
    Expect(0, 191471, '\p{^iscjkextf}', "");
    Expect(0, 191471, '\P{iscjkextf}', "");
    Expect(1, 191471, '\P{^iscjkextf}', "");
    Expect(0, 191472, '\p{iscjkextf}', "");
    Expect(1, 191472, '\p{^iscjkextf}', "");
    Expect(1, 191472, '\P{iscjkextf}', "");
    Expect(0, 191472, '\P{^iscjkextf}', "");
    Expect(1, 191471, '\p{-	Is_CJK_EXT_F}', "");
    Expect(0, 191471, '\p{^-	Is_CJK_EXT_F}', "");
    Expect(0, 191471, '\P{-	Is_CJK_EXT_F}', "");
    Expect(1, 191471, '\P{^-	Is_CJK_EXT_F}', "");
    Expect(0, 191472, '\p{-	Is_CJK_EXT_F}', "");
    Expect(1, 191472, '\p{^-	Is_CJK_EXT_F}', "");
    Expect(1, 191472, '\P{-	Is_CJK_EXT_F}', "");
    Expect(0, 191472, '\P{^-	Is_CJK_EXT_F}', "");
    Error('\p{-/a/IN_cjk_Ext_F}');
    Error('\P{-/a/IN_cjk_Ext_F}');
    Expect(1, 191471, '\p{incjkextf}', "");
    Expect(0, 191471, '\p{^incjkextf}', "");
    Expect(0, 191471, '\P{incjkextf}', "");
    Expect(1, 191471, '\P{^incjkextf}', "");
    Expect(0, 191472, '\p{incjkextf}', "");
    Expect(1, 191472, '\p{^incjkextf}', "");
    Expect(1, 191472, '\P{incjkextf}', "");
    Expect(0, 191472, '\P{^incjkextf}', "");
    Expect(1, 191471, '\p{	in_CJK_Ext_F}', "");
    Expect(0, 191471, '\p{^	in_CJK_Ext_F}', "");
    Expect(0, 191471, '\P{	in_CJK_Ext_F}', "");
    Expect(1, 191471, '\P{^	in_CJK_Ext_F}', "");
    Expect(0, 191472, '\p{	in_CJK_Ext_F}', "");
    Expect(1, 191472, '\p{^	in_CJK_Ext_F}', "");
    Expect(1, 191472, '\P{	in_CJK_Ext_F}', "");
    Expect(0, 191472, '\P{^	in_CJK_Ext_F}', "");
    Error('\p{-/a/Close_Punctuation}');
    Error('\P{-/a/Close_Punctuation}');
    Expect(1, 65379, '\p{closepunctuation}', "");
    Expect(0, 65379, '\p{^closepunctuation}', "");
    Expect(0, 65379, '\P{closepunctuation}', "");
    Expect(1, 65379, '\P{^closepunctuation}', "");
    Expect(0, 65380, '\p{closepunctuation}', "");
    Expect(1, 65380, '\p{^closepunctuation}', "");
    Expect(1, 65380, '\P{closepunctuation}', "");
    Expect(0, 65380, '\P{^closepunctuation}', "");
    Expect(1, 65379, '\p{	CLOSE_Punctuation}', "");
    Expect(0, 65379, '\p{^	CLOSE_Punctuation}', "");
    Expect(0, 65379, '\P{	CLOSE_Punctuation}', "");
    Expect(1, 65379, '\P{^	CLOSE_Punctuation}', "");
    Expect(0, 65380, '\p{	CLOSE_Punctuation}', "");
    Expect(1, 65380, '\p{^	CLOSE_Punctuation}', "");
    Expect(1, 65380, '\P{	CLOSE_Punctuation}', "");
    Expect(0, 65380, '\P{^	CLOSE_Punctuation}', "");
    Error('\p{_Is_close_Punctuation:=}');
    Error('\P{_Is_close_Punctuation:=}');
    Expect(1, 65379, '\p{isclosepunctuation}', "");
    Expect(0, 65379, '\p{^isclosepunctuation}', "");
    Expect(0, 65379, '\P{isclosepunctuation}', "");
    Expect(1, 65379, '\P{^isclosepunctuation}', "");
    Expect(0, 65380, '\p{isclosepunctuation}', "");
    Expect(1, 65380, '\p{^isclosepunctuation}', "");
    Expect(1, 65380, '\P{isclosepunctuation}', "");
    Expect(0, 65380, '\P{^isclosepunctuation}', "");
    Expect(1, 65379, '\p{_Is_CLOSE_PUNCTUATION}', "");
    Expect(0, 65379, '\p{^_Is_CLOSE_PUNCTUATION}', "");
    Expect(0, 65379, '\P{_Is_CLOSE_PUNCTUATION}', "");
    Expect(1, 65379, '\P{^_Is_CLOSE_PUNCTUATION}', "");
    Expect(0, 65380, '\p{_Is_CLOSE_PUNCTUATION}', "");
    Expect(1, 65380, '\p{^_Is_CLOSE_PUNCTUATION}', "");
    Expect(1, 65380, '\P{_Is_CLOSE_PUNCTUATION}', "");
    Expect(0, 65380, '\P{^_Is_CLOSE_PUNCTUATION}', "");
    Error('\p{/a/--pe}');
    Error('\P{/a/--pe}');
    Expect(1, 65379, '\p{pe}', "");
    Expect(0, 65379, '\p{^pe}', "");
    Expect(0, 65379, '\P{pe}', "");
    Expect(1, 65379, '\P{^pe}', "");
    Expect(0, 65380, '\p{pe}', "");
    Expect(1, 65380, '\p{^pe}', "");
    Expect(1, 65380, '\P{pe}', "");
    Expect(0, 65380, '\P{^pe}', "");
    Expect(1, 65379, '\p{__pe}', "");
    Expect(0, 65379, '\p{^__pe}', "");
    Expect(0, 65379, '\P{__pe}', "");
    Expect(1, 65379, '\P{^__pe}', "");
    Expect(0, 65380, '\p{__pe}', "");
    Expect(1, 65380, '\p{^__pe}', "");
    Expect(1, 65380, '\P{__pe}', "");
    Expect(0, 65380, '\P{^__pe}', "");
    Error('\p{	:=Is_Pe}');
    Error('\P{	:=Is_Pe}');
    Expect(1, 65379, '\p{ispe}', "");
    Expect(0, 65379, '\p{^ispe}', "");
    Expect(0, 65379, '\P{ispe}', "");
    Expect(1, 65379, '\P{^ispe}', "");
    Expect(0, 65380, '\p{ispe}', "");
    Expect(1, 65380, '\p{^ispe}', "");
    Expect(1, 65380, '\P{ispe}', "");
    Expect(0, 65380, '\P{^ispe}', "");
    Expect(1, 65379, '\p{ 	is_pe}', "");
    Expect(0, 65379, '\p{^ 	is_pe}', "");
    Expect(0, 65379, '\P{ 	is_pe}', "");
    Expect(1, 65379, '\P{^ 	is_pe}', "");
    Expect(0, 65380, '\p{ 	is_pe}', "");
    Expect(1, 65380, '\p{^ 	is_pe}', "");
    Expect(1, 65380, '\P{ 	is_pe}', "");
    Expect(0, 65380, '\P{^ 	is_pe}', "");
    Error('\p{:=  XPosixCntrl}');
    Error('\P{:=  XPosixCntrl}');
    Expect(1, 159, '\p{xposixcntrl}', "");
    Expect(0, 159, '\p{^xposixcntrl}', "");
    Expect(0, 159, '\P{xposixcntrl}', "");
    Expect(1, 159, '\P{^xposixcntrl}', "");
    Expect(0, 160, '\p{xposixcntrl}', "");
    Expect(1, 160, '\p{^xposixcntrl}', "");
    Expect(1, 160, '\P{xposixcntrl}', "");
    Expect(0, 160, '\P{^xposixcntrl}', "");
    Expect(1, 159, '\p{_XPOSIXCNTRL}', "");
    Expect(0, 159, '\p{^_XPOSIXCNTRL}', "");
    Expect(0, 159, '\P{_XPOSIXCNTRL}', "");
    Expect(1, 159, '\P{^_XPOSIXCNTRL}', "");
    Expect(0, 160, '\p{_XPOSIXCNTRL}', "");
    Expect(1, 160, '\p{^_XPOSIXCNTRL}', "");
    Expect(1, 160, '\P{_XPOSIXCNTRL}', "");
    Expect(0, 160, '\P{^_XPOSIXCNTRL}', "");
    Error('\p{- Cntrl/a/}');
    Error('\P{- Cntrl/a/}');
    Expect(1, 159, '\p{cntrl}', "");
    Expect(0, 159, '\p{^cntrl}', "");
    Expect(0, 159, '\P{cntrl}', "");
    Expect(1, 159, '\P{^cntrl}', "");
    Expect(0, 160, '\p{cntrl}', "");
    Expect(1, 160, '\p{^cntrl}', "");
    Expect(1, 160, '\P{cntrl}', "");
    Expect(0, 160, '\P{^cntrl}', "");
    Expect(1, 159, '\p{ 	Cntrl}', "");
    Expect(0, 159, '\p{^ 	Cntrl}', "");
    Expect(0, 159, '\P{ 	Cntrl}', "");
    Expect(1, 159, '\P{^ 	Cntrl}', "");
    Expect(0, 160, '\p{ 	Cntrl}', "");
    Expect(1, 160, '\p{^ 	Cntrl}', "");
    Expect(1, 160, '\P{ 	Cntrl}', "");
    Expect(0, 160, '\P{^ 	Cntrl}', "");
    Error('\p{ :=is_XPosixCntrl}');
    Error('\P{ :=is_XPosixCntrl}');
    Expect(1, 159, '\p{isxposixcntrl}', "");
    Expect(0, 159, '\p{^isxposixcntrl}', "");
    Expect(0, 159, '\P{isxposixcntrl}', "");
    Expect(1, 159, '\P{^isxposixcntrl}', "");
    Expect(0, 160, '\p{isxposixcntrl}', "");
    Expect(1, 160, '\p{^isxposixcntrl}', "");
    Expect(1, 160, '\P{isxposixcntrl}', "");
    Expect(0, 160, '\P{^isxposixcntrl}', "");
    Expect(1, 159, '\p{_	Is_XPOSIXCNTRL}', "");
    Expect(0, 159, '\p{^_	Is_XPOSIXCNTRL}', "");
    Expect(0, 159, '\P{_	Is_XPOSIXCNTRL}', "");
    Expect(1, 159, '\P{^_	Is_XPOSIXCNTRL}', "");
    Expect(0, 160, '\p{_	Is_XPOSIXCNTRL}', "");
    Expect(1, 160, '\p{^_	Is_XPOSIXCNTRL}', "");
    Expect(1, 160, '\P{_	Is_XPOSIXCNTRL}', "");
    Expect(0, 160, '\P{^_	Is_XPOSIXCNTRL}', "");
    Error('\p{-:=is_CNTRL}');
    Error('\P{-:=is_CNTRL}');
    Expect(1, 159, '\p{iscntrl}', "");
    Expect(0, 159, '\p{^iscntrl}', "");
    Expect(0, 159, '\P{iscntrl}', "");
    Expect(1, 159, '\P{^iscntrl}', "");
    Expect(0, 160, '\p{iscntrl}', "");
    Expect(1, 160, '\p{^iscntrl}', "");
    Expect(1, 160, '\P{iscntrl}', "");
    Expect(0, 160, '\P{^iscntrl}', "");
    Expect(1, 159, '\p{__IS_cntrl}', "");
    Expect(0, 159, '\p{^__IS_cntrl}', "");
    Expect(0, 159, '\P{__IS_cntrl}', "");
    Expect(1, 159, '\P{^__IS_cntrl}', "");
    Expect(0, 160, '\p{__IS_cntrl}', "");
    Expect(1, 160, '\p{^__IS_cntrl}', "");
    Expect(1, 160, '\P{__IS_cntrl}', "");
    Expect(0, 160, '\P{^__IS_cntrl}', "");
    Error('\p{ :=CONTROL}');
    Error('\P{ :=CONTROL}');
    Expect(1, 159, '\p{control}', "");
    Expect(0, 159, '\p{^control}', "");
    Expect(0, 159, '\P{control}', "");
    Expect(1, 159, '\P{^control}', "");
    Expect(0, 160, '\p{control}', "");
    Expect(1, 160, '\p{^control}', "");
    Expect(1, 160, '\P{control}', "");
    Expect(0, 160, '\P{^control}', "");
    Expect(1, 159, '\p{	Control}', "");
    Expect(0, 159, '\p{^	Control}', "");
    Expect(0, 159, '\P{	Control}', "");
    Expect(1, 159, '\P{^	Control}', "");
    Expect(0, 160, '\p{	Control}', "");
    Expect(1, 160, '\p{^	Control}', "");
    Expect(1, 160, '\P{	Control}', "");
    Expect(0, 160, '\P{^	Control}', "");
    Error('\p{_/a/IS_control}');
    Error('\P{_/a/IS_control}');
    Expect(1, 159, '\p{iscontrol}', "");
    Expect(0, 159, '\p{^iscontrol}', "");
    Expect(0, 159, '\P{iscontrol}', "");
    Expect(1, 159, '\P{^iscontrol}', "");
    Expect(0, 160, '\p{iscontrol}', "");
    Expect(1, 160, '\p{^iscontrol}', "");
    Expect(1, 160, '\P{iscontrol}', "");
    Expect(0, 160, '\P{^iscontrol}', "");
    Expect(1, 159, '\p{-Is_Control}', "");
    Expect(0, 159, '\p{^-Is_Control}', "");
    Expect(0, 159, '\P{-Is_Control}', "");
    Expect(1, 159, '\P{^-Is_Control}', "");
    Expect(0, 160, '\p{-Is_Control}', "");
    Expect(1, 160, '\p{^-Is_Control}', "");
    Expect(1, 160, '\P{-Is_Control}', "");
    Expect(0, 160, '\P{^-Is_Control}', "");
    Error('\p{cc:=}');
    Error('\P{cc:=}');
    Expect(1, 159, '\p{cc}', "");
    Expect(0, 159, '\p{^cc}', "");
    Expect(0, 159, '\P{cc}', "");
    Expect(1, 159, '\P{^cc}', "");
    Expect(0, 160, '\p{cc}', "");
    Expect(1, 160, '\p{^cc}', "");
    Expect(1, 160, '\P{cc}', "");
    Expect(0, 160, '\P{^cc}', "");
    Expect(1, 159, '\p{ _Cc}', "");
    Expect(0, 159, '\p{^ _Cc}', "");
    Expect(0, 159, '\P{ _Cc}', "");
    Expect(1, 159, '\P{^ _Cc}', "");
    Expect(0, 160, '\p{ _Cc}', "");
    Expect(1, 160, '\p{^ _Cc}', "");
    Expect(1, 160, '\P{ _Cc}', "");
    Expect(0, 160, '\P{^ _Cc}', "");
    Error('\p{:=Is_Cc}');
    Error('\P{:=Is_Cc}');
    Expect(1, 159, '\p{iscc}', "");
    Expect(0, 159, '\p{^iscc}', "");
    Expect(0, 159, '\P{iscc}', "");
    Expect(1, 159, '\P{^iscc}', "");
    Expect(0, 160, '\p{iscc}', "");
    Expect(1, 160, '\p{^iscc}', "");
    Expect(1, 160, '\P{iscc}', "");
    Expect(0, 160, '\P{^iscc}', "");
    Expect(1, 159, '\p{-Is_Cc}', "");
    Expect(0, 159, '\p{^-Is_Cc}', "");
    Expect(0, 159, '\P{-Is_Cc}', "");
    Expect(1, 159, '\P{^-Is_Cc}', "");
    Expect(0, 160, '\p{-Is_Cc}', "");
    Expect(1, 160, '\p{^-Is_Cc}', "");
    Expect(1, 160, '\P{-Is_Cc}', "");
    Expect(0, 160, '\P{^-Is_Cc}', "");
    Error('\p{/a/	_COMBINING_diacritical_Marks}');
    Error('\P{/a/	_COMBINING_diacritical_Marks}');
    Expect(1, 879, '\p{combiningdiacriticalmarks}', "");
    Expect(0, 879, '\p{^combiningdiacriticalmarks}', "");
    Expect(0, 879, '\P{combiningdiacriticalmarks}', "");
    Expect(1, 879, '\P{^combiningdiacriticalmarks}', "");
    Expect(0, 880, '\p{combiningdiacriticalmarks}', "");
    Expect(1, 880, '\p{^combiningdiacriticalmarks}', "");
    Expect(1, 880, '\P{combiningdiacriticalmarks}', "");
    Expect(0, 880, '\P{^combiningdiacriticalmarks}', "");
    Expect(1, 879, '\p{--Combining_Diacritical_Marks}', "");
    Expect(0, 879, '\p{^--Combining_Diacritical_Marks}', "");
    Expect(0, 879, '\P{--Combining_Diacritical_Marks}', "");
    Expect(1, 879, '\P{^--Combining_Diacritical_Marks}', "");
    Expect(0, 880, '\p{--Combining_Diacritical_Marks}', "");
    Expect(1, 880, '\p{^--Combining_Diacritical_Marks}', "");
    Expect(1, 880, '\P{--Combining_Diacritical_Marks}', "");
    Expect(0, 880, '\P{^--Combining_Diacritical_Marks}', "");
    Error('\p{	:=IS_combining_DIACRITICAL_MARKS}');
    Error('\P{	:=IS_combining_DIACRITICAL_MARKS}');
    Expect(1, 879, '\p{iscombiningdiacriticalmarks}', "");
    Expect(0, 879, '\p{^iscombiningdiacriticalmarks}', "");
    Expect(0, 879, '\P{iscombiningdiacriticalmarks}', "");
    Expect(1, 879, '\P{^iscombiningdiacriticalmarks}', "");
    Expect(0, 880, '\p{iscombiningdiacriticalmarks}', "");
    Expect(1, 880, '\p{^iscombiningdiacriticalmarks}', "");
    Expect(1, 880, '\P{iscombiningdiacriticalmarks}', "");
    Expect(0, 880, '\P{^iscombiningdiacriticalmarks}', "");
    Expect(1, 879, '\p{  Is_Combining_DIACRITICAL_marks}', "");
    Expect(0, 879, '\p{^  Is_Combining_DIACRITICAL_marks}', "");
    Expect(0, 879, '\P{  Is_Combining_DIACRITICAL_marks}', "");
    Expect(1, 879, '\P{^  Is_Combining_DIACRITICAL_marks}', "");
    Expect(0, 880, '\p{  Is_Combining_DIACRITICAL_marks}', "");
    Expect(1, 880, '\p{^  Is_Combining_DIACRITICAL_marks}', "");
    Expect(1, 880, '\P{  Is_Combining_DIACRITICAL_marks}', "");
    Expect(0, 880, '\P{^  Is_Combining_DIACRITICAL_marks}', "");
    Error('\p{IN_Combining_diacritical_Marks:=}');
    Error('\P{IN_Combining_diacritical_Marks:=}');
    Expect(1, 879, '\p{incombiningdiacriticalmarks}', "");
    Expect(0, 879, '\p{^incombiningdiacriticalmarks}', "");
    Expect(0, 879, '\P{incombiningdiacriticalmarks}', "");
    Expect(1, 879, '\P{^incombiningdiacriticalmarks}', "");
    Expect(0, 880, '\p{incombiningdiacriticalmarks}', "");
    Expect(1, 880, '\p{^incombiningdiacriticalmarks}', "");
    Expect(1, 880, '\P{incombiningdiacriticalmarks}', "");
    Expect(0, 880, '\P{^incombiningdiacriticalmarks}', "");
    Expect(1, 879, '\p{- IN_COMBINING_Diacritical_Marks}', "");
    Expect(0, 879, '\p{^- IN_COMBINING_Diacritical_Marks}', "");
    Expect(0, 879, '\P{- IN_COMBINING_Diacritical_Marks}', "");
    Expect(1, 879, '\P{^- IN_COMBINING_Diacritical_Marks}', "");
    Expect(0, 880, '\p{- IN_COMBINING_Diacritical_Marks}', "");
    Expect(1, 880, '\p{^- IN_COMBINING_Diacritical_Marks}', "");
    Expect(1, 880, '\P{- IN_COMBINING_Diacritical_Marks}', "");
    Expect(0, 880, '\P{^- IN_COMBINING_Diacritical_Marks}', "");
    Error('\p{	Diacriticals/a/}');
    Error('\P{	Diacriticals/a/}');
    Expect(1, 879, '\p{diacriticals}', "");
    Expect(0, 879, '\p{^diacriticals}', "");
    Expect(0, 879, '\P{diacriticals}', "");
    Expect(1, 879, '\P{^diacriticals}', "");
    Expect(0, 880, '\p{diacriticals}', "");
    Expect(1, 880, '\p{^diacriticals}', "");
    Expect(1, 880, '\P{diacriticals}', "");
    Expect(0, 880, '\P{^diacriticals}', "");
    Expect(1, 879, '\p{-Diacriticals}', "");
    Expect(0, 879, '\p{^-Diacriticals}', "");
    Expect(0, 879, '\P{-Diacriticals}', "");
    Expect(1, 879, '\P{^-Diacriticals}', "");
    Expect(0, 880, '\p{-Diacriticals}', "");
    Expect(1, 880, '\p{^-Diacriticals}', "");
    Expect(1, 880, '\P{-Diacriticals}', "");
    Expect(0, 880, '\P{^-Diacriticals}', "");
    Error('\p{ IS_Diacriticals/a/}');
    Error('\P{ IS_Diacriticals/a/}');
    Expect(1, 879, '\p{isdiacriticals}', "");
    Expect(0, 879, '\p{^isdiacriticals}', "");
    Expect(0, 879, '\P{isdiacriticals}', "");
    Expect(1, 879, '\P{^isdiacriticals}', "");
    Expect(0, 880, '\p{isdiacriticals}', "");
    Expect(1, 880, '\p{^isdiacriticals}', "");
    Expect(1, 880, '\P{isdiacriticals}', "");
    Expect(0, 880, '\P{^isdiacriticals}', "");
    Expect(1, 879, '\p{-_Is_Diacriticals}', "");
    Expect(0, 879, '\p{^-_Is_Diacriticals}', "");
    Expect(0, 879, '\P{-_Is_Diacriticals}', "");
    Expect(1, 879, '\P{^-_Is_Diacriticals}', "");
    Expect(0, 880, '\p{-_Is_Diacriticals}', "");
    Expect(1, 880, '\p{^-_Is_Diacriticals}', "");
    Expect(1, 880, '\P{-_Is_Diacriticals}', "");
    Expect(0, 880, '\P{^-_Is_Diacriticals}', "");
    Error('\p{_in_Diacriticals/a/}');
    Error('\P{_in_Diacriticals/a/}');
    Expect(1, 879, '\p{indiacriticals}', "");
    Expect(0, 879, '\p{^indiacriticals}', "");
    Expect(0, 879, '\P{indiacriticals}', "");
    Expect(1, 879, '\P{^indiacriticals}', "");
    Expect(0, 880, '\p{indiacriticals}', "");
    Expect(1, 880, '\p{^indiacriticals}', "");
    Expect(1, 880, '\P{indiacriticals}', "");
    Expect(0, 880, '\P{^indiacriticals}', "");
    Expect(1, 879, '\p{	In_Diacriticals}', "");
    Expect(0, 879, '\p{^	In_Diacriticals}', "");
    Expect(0, 879, '\P{	In_Diacriticals}', "");
    Expect(1, 879, '\P{^	In_Diacriticals}', "");
    Expect(0, 880, '\p{	In_Diacriticals}', "");
    Expect(1, 880, '\p{^	In_Diacriticals}', "");
    Expect(1, 880, '\P{	In_Diacriticals}', "");
    Expect(0, 880, '\P{^	In_Diacriticals}', "");
    Error('\p{_ COMBINING_diacritical_MARKS_Extended/a/}');
    Error('\P{_ COMBINING_diacritical_MARKS_Extended/a/}');
    Expect(1, 6911, '\p{combiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\p{^combiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\P{combiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\P{^combiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\p{combiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\p{^combiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\P{combiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\P{^combiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\p{-Combining_Diacritical_Marks_Extended}', "");
    Expect(0, 6911, '\p{^-Combining_Diacritical_Marks_Extended}', "");
    Expect(0, 6911, '\P{-Combining_Diacritical_Marks_Extended}', "");
    Expect(1, 6911, '\P{^-Combining_Diacritical_Marks_Extended}', "");
    Expect(0, 6912, '\p{-Combining_Diacritical_Marks_Extended}', "");
    Expect(1, 6912, '\p{^-Combining_Diacritical_Marks_Extended}', "");
    Expect(1, 6912, '\P{-Combining_Diacritical_Marks_Extended}', "");
    Expect(0, 6912, '\P{^-Combining_Diacritical_Marks_Extended}', "");
    Error('\p{:=  Is_Combining_Diacritical_MARKS_EXTENDED}');
    Error('\P{:=  Is_Combining_Diacritical_MARKS_EXTENDED}');
    Expect(1, 6911, '\p{iscombiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\p{^iscombiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\P{iscombiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\P{^iscombiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\p{iscombiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\p{^iscombiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\P{iscombiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\P{^iscombiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\p{	-IS_combining_Diacritical_MARKS_Extended}', "");
    Expect(0, 6911, '\p{^	-IS_combining_Diacritical_MARKS_Extended}', "");
    Expect(0, 6911, '\P{	-IS_combining_Diacritical_MARKS_Extended}', "");
    Expect(1, 6911, '\P{^	-IS_combining_Diacritical_MARKS_Extended}', "");
    Expect(0, 6912, '\p{	-IS_combining_Diacritical_MARKS_Extended}', "");
    Expect(1, 6912, '\p{^	-IS_combining_Diacritical_MARKS_Extended}', "");
    Expect(1, 6912, '\P{	-IS_combining_Diacritical_MARKS_Extended}', "");
    Expect(0, 6912, '\P{^	-IS_combining_Diacritical_MARKS_Extended}', "");
    Error('\p{:=_	In_combining_diacritical_Marks_EXTENDED}');
    Error('\P{:=_	In_combining_diacritical_Marks_EXTENDED}');
    Expect(1, 6911, '\p{incombiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\p{^incombiningdiacriticalmarksextended}', "");
    Expect(0, 6911, '\P{incombiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\P{^incombiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\p{incombiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\p{^incombiningdiacriticalmarksextended}', "");
    Expect(1, 6912, '\P{incombiningdiacriticalmarksextended}', "");
    Expect(0, 6912, '\P{^incombiningdiacriticalmarksextended}', "");
    Expect(1, 6911, '\p{_In_COMBINING_Diacritical_Marks_Extended}', "");
    Expect(0, 6911, '\p{^_In_COMBINING_Diacritical_Marks_Extended}', "");
    Expect(0, 6911, '\P{_In_COMBINING_Diacritical_Marks_Extended}', "");
    Expect(1, 6911, '\P{^_In_COMBINING_Diacritical_Marks_Extended}', "");
    Expect(0, 6912, '\p{_In_COMBINING_Diacritical_Marks_Extended}', "");
    Expect(1, 6912, '\p{^_In_COMBINING_Diacritical_Marks_Extended}', "");
    Expect(1, 6912, '\P{_In_COMBINING_Diacritical_Marks_Extended}', "");
    Expect(0, 6912, '\P{^_In_COMBINING_Diacritical_Marks_Extended}', "");
    Error('\p{:=-Diacriticals_Ext}');
    Error('\P{:=-Diacriticals_Ext}');
    Expect(1, 6911, '\p{diacriticalsext}', "");
    Expect(0, 6911, '\p{^diacriticalsext}', "");
    Expect(0, 6911, '\P{diacriticalsext}', "");
    Expect(1, 6911, '\P{^diacriticalsext}', "");
    Expect(0, 6912, '\p{diacriticalsext}', "");
    Expect(1, 6912, '\p{^diacriticalsext}', "");
    Expect(1, 6912, '\P{diacriticalsext}', "");
    Expect(0, 6912, '\P{^diacriticalsext}', "");
    Expect(1, 6911, '\p{ -Diacriticals_ext}', "");
    Expect(0, 6911, '\p{^ -Diacriticals_ext}', "");
    Expect(0, 6911, '\P{ -Diacriticals_ext}', "");
    Expect(1, 6911, '\P{^ -Diacriticals_ext}', "");
    Expect(0, 6912, '\p{ -Diacriticals_ext}', "");
    Expect(1, 6912, '\p{^ -Diacriticals_ext}', "");
    Expect(1, 6912, '\P{ -Diacriticals_ext}', "");
    Expect(0, 6912, '\P{^ -Diacriticals_ext}', "");
    Error('\p{/a/ _is_Diacriticals_EXT}');
    Error('\P{/a/ _is_Diacriticals_EXT}');
    Expect(1, 6911, '\p{isdiacriticalsext}', "");
    Expect(0, 6911, '\p{^isdiacriticalsext}', "");
    Expect(0, 6911, '\P{isdiacriticalsext}', "");
    Expect(1, 6911, '\P{^isdiacriticalsext}', "");
    Expect(0, 6912, '\p{isdiacriticalsext}', "");
    Expect(1, 6912, '\p{^isdiacriticalsext}', "");
    Expect(1, 6912, '\P{isdiacriticalsext}', "");
    Expect(0, 6912, '\P{^isdiacriticalsext}', "");
    Expect(1, 6911, '\p{	 Is_diacriticals_Ext}', "");
    Expect(0, 6911, '\p{^	 Is_diacriticals_Ext}', "");
    Expect(0, 6911, '\P{	 Is_diacriticals_Ext}', "");
    Expect(1, 6911, '\P{^	 Is_diacriticals_Ext}', "");
    Expect(0, 6912, '\p{	 Is_diacriticals_Ext}', "");
    Expect(1, 6912, '\p{^	 Is_diacriticals_Ext}', "");
    Expect(1, 6912, '\P{	 Is_diacriticals_Ext}', "");
    Expect(0, 6912, '\P{^	 Is_diacriticals_Ext}', "");
    Error('\p{-	In_DIACRITICALS_ext/a/}');
    Error('\P{-	In_DIACRITICALS_ext/a/}');
    Expect(1, 6911, '\p{indiacriticalsext}', "");
    Expect(0, 6911, '\p{^indiacriticalsext}', "");
    Expect(0, 6911, '\P{indiacriticalsext}', "");
    Expect(1, 6911, '\P{^indiacriticalsext}', "");
    Expect(0, 6912, '\p{indiacriticalsext}', "");
    Expect(1, 6912, '\p{^indiacriticalsext}', "");
    Expect(1, 6912, '\P{indiacriticalsext}', "");
    Expect(0, 6912, '\P{^indiacriticalsext}', "");
    Expect(1, 6911, '\p{--In_DIACRITICALS_Ext}', "");
    Expect(0, 6911, '\p{^--In_DIACRITICALS_Ext}', "");
    Expect(0, 6911, '\P{--In_DIACRITICALS_Ext}', "");
    Expect(1, 6911, '\P{^--In_DIACRITICALS_Ext}', "");
    Expect(0, 6912, '\p{--In_DIACRITICALS_Ext}', "");
    Expect(1, 6912, '\p{^--In_DIACRITICALS_Ext}', "");
    Expect(1, 6912, '\P{--In_DIACRITICALS_Ext}', "");
    Expect(0, 6912, '\P{^--In_DIACRITICALS_Ext}', "");
    Error('\p{:=__COMBINING_DIACRITICAL_Marks_For_Symbols}');
    Error('\P{:=__COMBINING_DIACRITICAL_Marks_For_Symbols}');
    Expect(1, 8447, '\p{combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\p{^combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\P{combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\P{^combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\p{combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\p{^combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\P{combiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\P{^combiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\p{	COMBINING_DIACRITICAL_marks_for_Symbols}', "");
    Expect(0, 8447, '\p{^	COMBINING_DIACRITICAL_marks_for_Symbols}', "");
    Expect(0, 8447, '\P{	COMBINING_DIACRITICAL_marks_for_Symbols}', "");
    Expect(1, 8447, '\P{^	COMBINING_DIACRITICAL_marks_for_Symbols}', "");
    Expect(0, 8448, '\p{	COMBINING_DIACRITICAL_marks_for_Symbols}', "");
    Expect(1, 8448, '\p{^	COMBINING_DIACRITICAL_marks_for_Symbols}', "");
    Expect(1, 8448, '\P{	COMBINING_DIACRITICAL_marks_for_Symbols}', "");
    Expect(0, 8448, '\P{^	COMBINING_DIACRITICAL_marks_for_Symbols}', "");
    Error('\p{	/a/IS_combining_diacritical_marks_For_Symbols}');
    Error('\P{	/a/IS_combining_diacritical_marks_For_Symbols}');
    Expect(1, 8447, '\p{iscombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\p{^iscombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\P{iscombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\P{^iscombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\p{iscombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\p{^iscombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\P{iscombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\P{^iscombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\p{IS_Combining_DIACRITICAL_Marks_for_Symbols}', "");
    Expect(0, 8447, '\p{^IS_Combining_DIACRITICAL_Marks_for_Symbols}', "");
    Expect(0, 8447, '\P{IS_Combining_DIACRITICAL_Marks_for_Symbols}', "");
    Expect(1, 8447, '\P{^IS_Combining_DIACRITICAL_Marks_for_Symbols}', "");
    Expect(0, 8448, '\p{IS_Combining_DIACRITICAL_Marks_for_Symbols}', "");
    Expect(1, 8448, '\p{^IS_Combining_DIACRITICAL_Marks_for_Symbols}', "");
    Expect(1, 8448, '\P{IS_Combining_DIACRITICAL_Marks_for_Symbols}', "");
    Expect(0, 8448, '\P{^IS_Combining_DIACRITICAL_Marks_for_Symbols}', "");
    Error('\p{_/a/In_combining_DIACRITICAL_Marks_For_Symbols}');
    Error('\P{_/a/In_combining_DIACRITICAL_Marks_For_Symbols}');
    Expect(1, 8447, '\p{incombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\p{^incombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8447, '\P{incombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\P{^incombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\p{incombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\p{^incombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8448, '\P{incombiningdiacriticalmarksforsymbols}', "");
    Expect(0, 8448, '\P{^incombiningdiacriticalmarksforsymbols}', "");
    Expect(1, 8447, '\p{-_In_combining_Diacritical_MARKS_For_Symbols}', "");
    Expect(0, 8447, '\p{^-_In_combining_Diacritical_MARKS_For_Symbols}', "");
    Expect(0, 8447, '\P{-_In_combining_Diacritical_MARKS_For_Symbols}', "");
    Expect(1, 8447, '\P{^-_In_combining_Diacritical_MARKS_For_Symbols}', "");
    Expect(0, 8448, '\p{-_In_combining_Diacritical_MARKS_For_Symbols}', "");
    Expect(1, 8448, '\p{^-_In_combining_Diacritical_MARKS_For_Symbols}', "");
    Expect(1, 8448, '\P{-_In_combining_Diacritical_MARKS_For_Symbols}', "");
    Expect(0, 8448, '\P{^-_In_combining_Diacritical_MARKS_For_Symbols}', "");
    Error('\p{:=--DIACRITICALS_for_symbols}');
    Error('\P{:=--DIACRITICALS_for_symbols}');
    Expect(1, 8447, '\p{diacriticalsforsymbols}', "");
    Expect(0, 8447, '\p{^diacriticalsforsymbols}', "");
    Expect(0, 8447, '\P{diacriticalsforsymbols}', "");
    Expect(1, 8447, '\P{^diacriticalsforsymbols}', "");
    Expect(0, 8448, '\p{diacriticalsforsymbols}', "");
    Expect(1, 8448, '\p{^diacriticalsforsymbols}', "");
    Expect(1, 8448, '\P{diacriticalsforsymbols}', "");
    Expect(0, 8448, '\P{^diacriticalsforsymbols}', "");
    Expect(1, 8447, '\p{__DIACRITICALS_For_Symbols}', "");
    Expect(0, 8447, '\p{^__DIACRITICALS_For_Symbols}', "");
    Expect(0, 8447, '\P{__DIACRITICALS_For_Symbols}', "");
    Expect(1, 8447, '\P{^__DIACRITICALS_For_Symbols}', "");
    Expect(0, 8448, '\p{__DIACRITICALS_For_Symbols}', "");
    Expect(1, 8448, '\p{^__DIACRITICALS_For_Symbols}', "");
    Expect(1, 8448, '\P{__DIACRITICALS_For_Symbols}', "");
    Expect(0, 8448, '\P{^__DIACRITICALS_For_Symbols}', "");
    Error('\p{	Is_Diacriticals_for_SYMBOLS/a/}');
    Error('\P{	Is_Diacriticals_for_SYMBOLS/a/}');
    Expect(1, 8447, '\p{isdiacriticalsforsymbols}', "");
    Expect(0, 8447, '\p{^isdiacriticalsforsymbols}', "");
    Expect(0, 8447, '\P{isdiacriticalsforsymbols}', "");
    Expect(1, 8447, '\P{^isdiacriticalsforsymbols}', "");
    Expect(0, 8448, '\p{isdiacriticalsforsymbols}', "");
    Expect(1, 8448, '\p{^isdiacriticalsforsymbols}', "");
    Expect(1, 8448, '\P{isdiacriticalsforsymbols}', "");
    Expect(0, 8448, '\P{^isdiacriticalsforsymbols}', "");
    Expect(1, 8447, '\p{-is_DIACRITICALS_FOR_Symbols}', "");
    Expect(0, 8447, '\p{^-is_DIACRITICALS_FOR_Symbols}', "");
    Expect(0, 8447, '\P{-is_DIACRITICALS_FOR_Symbols}', "");
    Expect(1, 8447, '\P{^-is_DIACRITICALS_FOR_Symbols}', "");
    Expect(0, 8448, '\p{-is_DIACRITICALS_FOR_Symbols}', "");
    Expect(1, 8448, '\p{^-is_DIACRITICALS_FOR_Symbols}', "");
    Expect(1, 8448, '\P{-is_DIACRITICALS_FOR_Symbols}', "");
    Expect(0, 8448, '\P{^-is_DIACRITICALS_FOR_Symbols}', "");
    Error('\p{/a/_In_Diacriticals_For_Symbols}');
    Error('\P{/a/_In_Diacriticals_For_Symbols}');
    Expect(1, 8447, '\p{indiacriticalsforsymbols}', "");
    Expect(0, 8447, '\p{^indiacriticalsforsymbols}', "");
    Expect(0, 8447, '\P{indiacriticalsforsymbols}', "");
    Expect(1, 8447, '\P{^indiacriticalsforsymbols}', "");
    Expect(0, 8448, '\p{indiacriticalsforsymbols}', "");
    Expect(1, 8448, '\p{^indiacriticalsforsymbols}', "");
    Expect(1, 8448, '\P{indiacriticalsforsymbols}', "");
    Expect(0, 8448, '\P{^indiacriticalsforsymbols}', "");
    Expect(1, 8447, '\p{--IN_diacriticals_FOR_SYMBOLS}', "");
    Expect(0, 8447, '\p{^--IN_diacriticals_FOR_SYMBOLS}', "");
    Expect(0, 8447, '\P{--IN_diacriticals_FOR_SYMBOLS}', "");
    Expect(1, 8447, '\P{^--IN_diacriticals_FOR_SYMBOLS}', "");
    Expect(0, 8448, '\p{--IN_diacriticals_FOR_SYMBOLS}', "");
    Expect(1, 8448, '\p{^--IN_diacriticals_FOR_SYMBOLS}', "");
    Expect(1, 8448, '\P{--IN_diacriticals_FOR_SYMBOLS}', "");
    Expect(0, 8448, '\P{^--IN_diacriticals_FOR_SYMBOLS}', "");
    Error('\p{_/a/Combining_marks_FOR_Symbols}');
    Error('\P{_/a/Combining_marks_FOR_Symbols}');
    Expect(1, 8447, '\p{combiningmarksforsymbols}', "");
    Expect(0, 8447, '\p{^combiningmarksforsymbols}', "");
    Expect(0, 8447, '\P{combiningmarksforsymbols}', "");
    Expect(1, 8447, '\P{^combiningmarksforsymbols}', "");
    Expect(0, 8448, '\p{combiningmarksforsymbols}', "");
    Expect(1, 8448, '\p{^combiningmarksforsymbols}', "");
    Expect(1, 8448, '\P{combiningmarksforsymbols}', "");
    Expect(0, 8448, '\P{^combiningmarksforsymbols}', "");
    Expect(1, 8447, '\p{_Combining_marks_FOR_SYMBOLS}', "");
    Expect(0, 8447, '\p{^_Combining_marks_FOR_SYMBOLS}', "");
    Expect(0, 8447, '\P{_Combining_marks_FOR_SYMBOLS}', "");
    Expect(1, 8447, '\P{^_Combining_marks_FOR_SYMBOLS}', "");
    Expect(0, 8448, '\p{_Combining_marks_FOR_SYMBOLS}', "");
    Expect(1, 8448, '\p{^_Combining_marks_FOR_SYMBOLS}', "");
    Expect(1, 8448, '\P{_Combining_marks_FOR_SYMBOLS}', "");
    Expect(0, 8448, '\P{^_Combining_marks_FOR_SYMBOLS}', "");
    Error('\p{	/a/is_combining_marks_For_SYMBOLS}');
    Error('\P{	/a/is_combining_marks_For_SYMBOLS}');
    Expect(1, 8447, '\p{iscombiningmarksforsymbols}', "");
    Expect(0, 8447, '\p{^iscombiningmarksforsymbols}', "");
    Expect(0, 8447, '\P{iscombiningmarksforsymbols}', "");
    Expect(1, 8447, '\P{^iscombiningmarksforsymbols}', "");
    Expect(0, 8448, '\p{iscombiningmarksforsymbols}', "");
    Expect(1, 8448, '\p{^iscombiningmarksforsymbols}', "");
    Expect(1, 8448, '\P{iscombiningmarksforsymbols}', "");
    Expect(0, 8448, '\P{^iscombiningmarksforsymbols}', "");
    Expect(1, 8447, '\p{ 	Is_Combining_marks_for_symbols}', "");
    Expect(0, 8447, '\p{^ 	Is_Combining_marks_for_symbols}', "");
    Expect(0, 8447, '\P{ 	Is_Combining_marks_for_symbols}', "");
    Expect(1, 8447, '\P{^ 	Is_Combining_marks_for_symbols}', "");
    Expect(0, 8448, '\p{ 	Is_Combining_marks_for_symbols}', "");
    Expect(1, 8448, '\p{^ 	Is_Combining_marks_for_symbols}', "");
    Expect(1, 8448, '\P{ 	Is_Combining_marks_for_symbols}', "");
    Expect(0, 8448, '\P{^ 	Is_Combining_marks_for_symbols}', "");
    Error('\p{_-IN_Combining_Marks_for_symbols:=}');
    Error('\P{_-IN_Combining_Marks_for_symbols:=}');
    Expect(1, 8447, '\p{incombiningmarksforsymbols}', "");
    Expect(0, 8447, '\p{^incombiningmarksforsymbols}', "");
    Expect(0, 8447, '\P{incombiningmarksforsymbols}', "");
    Expect(1, 8447, '\P{^incombiningmarksforsymbols}', "");
    Expect(0, 8448, '\p{incombiningmarksforsymbols}', "");
    Expect(1, 8448, '\p{^incombiningmarksforsymbols}', "");
    Expect(1, 8448, '\P{incombiningmarksforsymbols}', "");
    Expect(0, 8448, '\P{^incombiningmarksforsymbols}', "");
    Expect(1, 8447, '\p{_-IN_combining_Marks_for_symbols}', "");
    Expect(0, 8447, '\p{^_-IN_combining_Marks_for_symbols}', "");
    Expect(0, 8447, '\P{_-IN_combining_Marks_for_symbols}', "");
    Expect(1, 8447, '\P{^_-IN_combining_Marks_for_symbols}', "");
    Expect(0, 8448, '\p{_-IN_combining_Marks_for_symbols}', "");
    Expect(1, 8448, '\p{^_-IN_combining_Marks_for_symbols}', "");
    Expect(1, 8448, '\P{_-IN_combining_Marks_for_symbols}', "");
    Expect(0, 8448, '\P{^_-IN_combining_Marks_for_symbols}', "");
    Error('\p{		Combining_Diacritical_marks_supplement/a/}');
    Error('\P{		Combining_Diacritical_marks_supplement/a/}');
    Expect(1, 7679, '\p{combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\p{^combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\P{combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\P{^combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\p{combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\p{^combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\P{combiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\P{^combiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\p{ -Combining_Diacritical_marks_Supplement}', "");
    Expect(0, 7679, '\p{^ -Combining_Diacritical_marks_Supplement}', "");
    Expect(0, 7679, '\P{ -Combining_Diacritical_marks_Supplement}', "");
    Expect(1, 7679, '\P{^ -Combining_Diacritical_marks_Supplement}', "");
    Expect(0, 7680, '\p{ -Combining_Diacritical_marks_Supplement}', "");
    Expect(1, 7680, '\p{^ -Combining_Diacritical_marks_Supplement}', "");
    Expect(1, 7680, '\P{ -Combining_Diacritical_marks_Supplement}', "");
    Expect(0, 7680, '\P{^ -Combining_Diacritical_marks_Supplement}', "");
    Error('\p{	/a/IS_combining_DIACRITICAL_Marks_SUPPLEMENT}');
    Error('\P{	/a/IS_combining_DIACRITICAL_Marks_SUPPLEMENT}');
    Expect(1, 7679, '\p{iscombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\p{^iscombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\P{iscombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\P{^iscombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\p{iscombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\p{^iscombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\P{iscombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\P{^iscombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\p{	_Is_Combining_Diacritical_marks_supplement}', "");
    Expect(0, 7679, '\p{^	_Is_Combining_Diacritical_marks_supplement}', "");
    Expect(0, 7679, '\P{	_Is_Combining_Diacritical_marks_supplement}', "");
    Expect(1, 7679, '\P{^	_Is_Combining_Diacritical_marks_supplement}', "");
    Expect(0, 7680, '\p{	_Is_Combining_Diacritical_marks_supplement}', "");
    Expect(1, 7680, '\p{^	_Is_Combining_Diacritical_marks_supplement}', "");
    Expect(1, 7680, '\P{	_Is_Combining_Diacritical_marks_supplement}', "");
    Expect(0, 7680, '\P{^	_Is_Combining_Diacritical_marks_supplement}', "");
    Error('\p{-/a/in_combining_Diacritical_MARKS_SUPPLEMENT}');
    Error('\P{-/a/in_combining_Diacritical_MARKS_SUPPLEMENT}');
    Expect(1, 7679, '\p{incombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\p{^incombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7679, '\P{incombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\P{^incombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\p{incombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\p{^incombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7680, '\P{incombiningdiacriticalmarkssupplement}', "");
    Expect(0, 7680, '\P{^incombiningdiacriticalmarkssupplement}', "");
    Expect(1, 7679, '\p{_-In_Combining_Diacritical_Marks_Supplement}', "");
    Expect(0, 7679, '\p{^_-In_Combining_Diacritical_Marks_Supplement}', "");
    Expect(0, 7679, '\P{_-In_Combining_Diacritical_Marks_Supplement}', "");
    Expect(1, 7679, '\P{^_-In_Combining_Diacritical_Marks_Supplement}', "");
    Expect(0, 7680, '\p{_-In_Combining_Diacritical_Marks_Supplement}', "");
    Expect(1, 7680, '\p{^_-In_Combining_Diacritical_Marks_Supplement}', "");
    Expect(1, 7680, '\P{_-In_Combining_Diacritical_Marks_Supplement}', "");
    Expect(0, 7680, '\P{^_-In_Combining_Diacritical_Marks_Supplement}', "");
    Error('\p{_:=Diacriticals_Sup}');
    Error('\P{_:=Diacriticals_Sup}');
    Expect(1, 7679, '\p{diacriticalssup}', "");
    Expect(0, 7679, '\p{^diacriticalssup}', "");
    Expect(0, 7679, '\P{diacriticalssup}', "");
    Expect(1, 7679, '\P{^diacriticalssup}', "");
    Expect(0, 7680, '\p{diacriticalssup}', "");
    Expect(1, 7680, '\p{^diacriticalssup}', "");
    Expect(1, 7680, '\P{diacriticalssup}', "");
    Expect(0, 7680, '\P{^diacriticalssup}', "");
    Expect(1, 7679, '\p{-_Diacriticals_sup}', "");
    Expect(0, 7679, '\p{^-_Diacriticals_sup}', "");
    Expect(0, 7679, '\P{-_Diacriticals_sup}', "");
    Expect(1, 7679, '\P{^-_Diacriticals_sup}', "");
    Expect(0, 7680, '\p{-_Diacriticals_sup}', "");
    Expect(1, 7680, '\p{^-_Diacriticals_sup}', "");
    Expect(1, 7680, '\P{-_Diacriticals_sup}', "");
    Expect(0, 7680, '\P{^-_Diacriticals_sup}', "");
    Error('\p{		is_diacriticals_SUP/a/}');
    Error('\P{		is_diacriticals_SUP/a/}');
    Expect(1, 7679, '\p{isdiacriticalssup}', "");
    Expect(0, 7679, '\p{^isdiacriticalssup}', "");
    Expect(0, 7679, '\P{isdiacriticalssup}', "");
    Expect(1, 7679, '\P{^isdiacriticalssup}', "");
    Expect(0, 7680, '\p{isdiacriticalssup}', "");
    Expect(1, 7680, '\p{^isdiacriticalssup}', "");
    Expect(1, 7680, '\P{isdiacriticalssup}', "");
    Expect(0, 7680, '\P{^isdiacriticalssup}', "");
    Expect(1, 7679, '\p{		is_Diacriticals_Sup}', "");
    Expect(0, 7679, '\p{^		is_Diacriticals_Sup}', "");
    Expect(0, 7679, '\P{		is_Diacriticals_Sup}', "");
    Expect(1, 7679, '\P{^		is_Diacriticals_Sup}', "");
    Expect(0, 7680, '\p{		is_Diacriticals_Sup}', "");
    Expect(1, 7680, '\p{^		is_Diacriticals_Sup}', "");
    Expect(1, 7680, '\P{		is_Diacriticals_Sup}', "");
    Expect(0, 7680, '\P{^		is_Diacriticals_Sup}', "");
    Error('\p{:=	_In_DIACRITICALS_Sup}');
    Error('\P{:=	_In_DIACRITICALS_Sup}');
    Expect(1, 7679, '\p{indiacriticalssup}', "");
    Expect(0, 7679, '\p{^indiacriticalssup}', "");
    Expect(0, 7679, '\P{indiacriticalssup}', "");
    Expect(1, 7679, '\P{^indiacriticalssup}', "");
    Expect(0, 7680, '\p{indiacriticalssup}', "");
    Expect(1, 7680, '\p{^indiacriticalssup}', "");
    Expect(1, 7680, '\P{indiacriticalssup}', "");
    Expect(0, 7680, '\P{^indiacriticalssup}', "");
    Expect(1, 7679, '\p{	-IN_Diacriticals_SUP}', "");
    Expect(0, 7679, '\p{^	-IN_Diacriticals_SUP}', "");
    Expect(0, 7679, '\P{	-IN_Diacriticals_SUP}', "");
    Expect(1, 7679, '\P{^	-IN_Diacriticals_SUP}', "");
    Expect(0, 7680, '\p{	-IN_Diacriticals_SUP}', "");
    Expect(1, 7680, '\p{^	-IN_Diacriticals_SUP}', "");
    Expect(1, 7680, '\P{	-IN_Diacriticals_SUP}', "");
    Expect(0, 7680, '\P{^	-IN_Diacriticals_SUP}', "");
    Error('\p{:=Combining_Half_Marks}');
    Error('\P{:=Combining_Half_Marks}');
    Expect(1, 65071, '\p{combininghalfmarks}', "");
    Expect(0, 65071, '\p{^combininghalfmarks}', "");
    Expect(0, 65071, '\P{combininghalfmarks}', "");
    Expect(1, 65071, '\P{^combininghalfmarks}', "");
    Expect(0, 65072, '\p{combininghalfmarks}', "");
    Expect(1, 65072, '\p{^combininghalfmarks}', "");
    Expect(1, 65072, '\P{combininghalfmarks}', "");
    Expect(0, 65072, '\P{^combininghalfmarks}', "");
    Expect(1, 65071, '\p{--Combining_Half_MARKS}', "");
    Expect(0, 65071, '\p{^--Combining_Half_MARKS}', "");
    Expect(0, 65071, '\P{--Combining_Half_MARKS}', "");
    Expect(1, 65071, '\P{^--Combining_Half_MARKS}', "");
    Expect(0, 65072, '\p{--Combining_Half_MARKS}', "");
    Expect(1, 65072, '\p{^--Combining_Half_MARKS}', "");
    Expect(1, 65072, '\P{--Combining_Half_MARKS}', "");
    Expect(0, 65072, '\P{^--Combining_Half_MARKS}', "");
    Error('\p{:=_Is_COMBINING_Half_marks}');
    Error('\P{:=_Is_COMBINING_Half_marks}');
    Expect(1, 65071, '\p{iscombininghalfmarks}', "");
    Expect(0, 65071, '\p{^iscombininghalfmarks}', "");
    Expect(0, 65071, '\P{iscombininghalfmarks}', "");
    Expect(1, 65071, '\P{^iscombininghalfmarks}', "");
    Expect(0, 65072, '\p{iscombininghalfmarks}', "");
    Expect(1, 65072, '\p{^iscombininghalfmarks}', "");
    Expect(1, 65072, '\P{iscombininghalfmarks}', "");
    Expect(0, 65072, '\P{^iscombininghalfmarks}', "");
    Expect(1, 65071, '\p{	_Is_COMBINING_HALF_Marks}', "");
    Expect(0, 65071, '\p{^	_Is_COMBINING_HALF_Marks}', "");
    Expect(0, 65071, '\P{	_Is_COMBINING_HALF_Marks}', "");
    Expect(1, 65071, '\P{^	_Is_COMBINING_HALF_Marks}', "");
    Expect(0, 65072, '\p{	_Is_COMBINING_HALF_Marks}', "");
    Expect(1, 65072, '\p{^	_Is_COMBINING_HALF_Marks}', "");
    Expect(1, 65072, '\P{	_Is_COMBINING_HALF_Marks}', "");
    Expect(0, 65072, '\P{^	_Is_COMBINING_HALF_Marks}', "");
    Error('\p{IN_COMBINING_Half_Marks:=}');
    Error('\P{IN_COMBINING_Half_Marks:=}');
    Expect(1, 65071, '\p{incombininghalfmarks}', "");
    Expect(0, 65071, '\p{^incombininghalfmarks}', "");
    Expect(0, 65071, '\P{incombininghalfmarks}', "");
    Expect(1, 65071, '\P{^incombininghalfmarks}', "");
    Expect(0, 65072, '\p{incombininghalfmarks}', "");
    Expect(1, 65072, '\p{^incombininghalfmarks}', "");
    Expect(1, 65072, '\P{incombininghalfmarks}', "");
    Expect(0, 65072, '\P{^incombininghalfmarks}', "");
    Expect(1, 65071, '\p{_-in_COMBINING_half_MARKS}', "");
    Expect(0, 65071, '\p{^_-in_COMBINING_half_MARKS}', "");
    Expect(0, 65071, '\P{_-in_COMBINING_half_MARKS}', "");
    Expect(1, 65071, '\P{^_-in_COMBINING_half_MARKS}', "");
    Expect(0, 65072, '\p{_-in_COMBINING_half_MARKS}', "");
    Expect(1, 65072, '\p{^_-in_COMBINING_half_MARKS}', "");
    Expect(1, 65072, '\P{_-in_COMBINING_half_MARKS}', "");
    Expect(0, 65072, '\P{^_-in_COMBINING_half_MARKS}', "");
    Error('\p{:=Half_Marks}');
    Error('\P{:=Half_Marks}');
    Expect(1, 65071, '\p{halfmarks}', "");
    Expect(0, 65071, '\p{^halfmarks}', "");
    Expect(0, 65071, '\P{halfmarks}', "");
    Expect(1, 65071, '\P{^halfmarks}', "");
    Expect(0, 65072, '\p{halfmarks}', "");
    Expect(1, 65072, '\p{^halfmarks}', "");
    Expect(1, 65072, '\P{halfmarks}', "");
    Expect(0, 65072, '\P{^halfmarks}', "");
    Expect(1, 65071, '\p{ Half_marks}', "");
    Expect(0, 65071, '\p{^ Half_marks}', "");
    Expect(0, 65071, '\P{ Half_marks}', "");
    Expect(1, 65071, '\P{^ Half_marks}', "");
    Expect(0, 65072, '\p{ Half_marks}', "");
    Expect(1, 65072, '\p{^ Half_marks}', "");
    Expect(1, 65072, '\P{ Half_marks}', "");
    Expect(0, 65072, '\P{^ Half_marks}', "");
    Error('\p{/a/ 	Is_Half_Marks}');
    Error('\P{/a/ 	Is_Half_Marks}');
    Expect(1, 65071, '\p{ishalfmarks}', "");
    Expect(0, 65071, '\p{^ishalfmarks}', "");
    Expect(0, 65071, '\P{ishalfmarks}', "");
    Expect(1, 65071, '\P{^ishalfmarks}', "");
    Expect(0, 65072, '\p{ishalfmarks}', "");
    Expect(1, 65072, '\p{^ishalfmarks}', "");
    Expect(1, 65072, '\P{ishalfmarks}', "");
    Expect(0, 65072, '\P{^ishalfmarks}', "");
    Expect(1, 65071, '\p{- IS_Half_MARKS}', "");
    Expect(0, 65071, '\p{^- IS_Half_MARKS}', "");
    Expect(0, 65071, '\P{- IS_Half_MARKS}', "");
    Expect(1, 65071, '\P{^- IS_Half_MARKS}', "");
    Expect(0, 65072, '\p{- IS_Half_MARKS}', "");
    Expect(1, 65072, '\p{^- IS_Half_MARKS}', "");
    Expect(1, 65072, '\P{- IS_Half_MARKS}', "");
    Expect(0, 65072, '\P{^- IS_Half_MARKS}', "");
    Error('\p{:=__IN_HALF_MARKS}');
    Error('\P{:=__IN_HALF_MARKS}');
    Expect(1, 65071, '\p{inhalfmarks}', "");
    Expect(0, 65071, '\p{^inhalfmarks}', "");
    Expect(0, 65071, '\P{inhalfmarks}', "");
    Expect(1, 65071, '\P{^inhalfmarks}', "");
    Expect(0, 65072, '\p{inhalfmarks}', "");
    Expect(1, 65072, '\p{^inhalfmarks}', "");
    Expect(1, 65072, '\P{inhalfmarks}', "");
    Expect(0, 65072, '\P{^inhalfmarks}', "");
    Expect(1, 65071, '\p{_	In_Half_marks}', "");
    Expect(0, 65071, '\p{^_	In_Half_marks}', "");
    Expect(0, 65071, '\P{_	In_Half_marks}', "");
    Expect(1, 65071, '\P{^_	In_Half_marks}', "");
    Expect(0, 65072, '\p{_	In_Half_marks}', "");
    Expect(1, 65072, '\p{^_	In_Half_marks}', "");
    Expect(1, 65072, '\P{_	In_Half_marks}', "");
    Expect(0, 65072, '\P{^_	In_Half_marks}', "");
    Error('\p{/a/common}');
    Error('\P{/a/common}');
    Expect(1, 917631, '\p{common}', "");
    Expect(0, 917631, '\p{^common}', "");
    Expect(0, 917631, '\P{common}', "");
    Expect(1, 917631, '\P{^common}', "");
    Expect(0, 917632, '\p{common}', "");
    Expect(1, 917632, '\p{^common}', "");
    Expect(1, 917632, '\P{common}', "");
    Expect(0, 917632, '\P{^common}', "");
    Expect(1, 917631, '\p{		COMMON}', "");
    Expect(0, 917631, '\p{^		COMMON}', "");
    Expect(0, 917631, '\P{		COMMON}', "");
    Expect(1, 917631, '\P{^		COMMON}', "");
    Expect(0, 917632, '\p{		COMMON}', "");
    Expect(1, 917632, '\p{^		COMMON}', "");
    Expect(1, 917632, '\P{		COMMON}', "");
    Expect(0, 917632, '\P{^		COMMON}', "");
    Error('\p{/a/_-is_Common}');
    Error('\P{/a/_-is_Common}');
    Expect(1, 917631, '\p{iscommon}', "");
    Expect(0, 917631, '\p{^iscommon}', "");
    Expect(0, 917631, '\P{iscommon}', "");
    Expect(1, 917631, '\P{^iscommon}', "");
    Expect(0, 917632, '\p{iscommon}', "");
    Expect(1, 917632, '\p{^iscommon}', "");
    Expect(1, 917632, '\P{iscommon}', "");
    Expect(0, 917632, '\P{^iscommon}', "");
    Expect(1, 917631, '\p{ is_Common}', "");
    Expect(0, 917631, '\p{^ is_Common}', "");
    Expect(0, 917631, '\P{ is_Common}', "");
    Expect(1, 917631, '\P{^ is_Common}', "");
    Expect(0, 917632, '\p{ is_Common}', "");
    Expect(1, 917632, '\p{^ is_Common}', "");
    Expect(1, 917632, '\P{ is_Common}', "");
    Expect(0, 917632, '\P{^ is_Common}', "");
    Error('\p{_Zyyy:=}');
    Error('\P{_Zyyy:=}');
    Expect(1, 917631, '\p{zyyy}', "");
    Expect(0, 917631, '\p{^zyyy}', "");
    Expect(0, 917631, '\P{zyyy}', "");
    Expect(1, 917631, '\P{^zyyy}', "");
    Expect(0, 917632, '\p{zyyy}', "");
    Expect(1, 917632, '\p{^zyyy}', "");
    Expect(1, 917632, '\P{zyyy}', "");
    Expect(0, 917632, '\P{^zyyy}', "");
    Expect(1, 917631, '\p{ZYYY}', "");
    Expect(0, 917631, '\p{^ZYYY}', "");
    Expect(0, 917631, '\P{ZYYY}', "");
    Expect(1, 917631, '\P{^ZYYY}', "");
    Expect(0, 917632, '\p{ZYYY}', "");
    Expect(1, 917632, '\p{^ZYYY}', "");
    Expect(1, 917632, '\P{ZYYY}', "");
    Expect(0, 917632, '\P{^ZYYY}', "");
    Error('\p{-is_Zyyy:=}');
    Error('\P{-is_Zyyy:=}');
    Expect(1, 917631, '\p{iszyyy}', "");
    Expect(0, 917631, '\p{^iszyyy}', "");
    Expect(0, 917631, '\P{iszyyy}', "");
    Expect(1, 917631, '\P{^iszyyy}', "");
    Expect(0, 917632, '\p{iszyyy}', "");
    Expect(1, 917632, '\p{^iszyyy}', "");
    Expect(1, 917632, '\P{iszyyy}', "");
    Expect(0, 917632, '\P{^iszyyy}', "");
    Expect(1, 917631, '\p{  IS_Zyyy}', "");
    Expect(0, 917631, '\p{^  IS_Zyyy}', "");
    Expect(0, 917631, '\P{  IS_Zyyy}', "");
    Expect(1, 917631, '\P{^  IS_Zyyy}', "");
    Expect(0, 917632, '\p{  IS_Zyyy}', "");
    Expect(1, 917632, '\p{^  IS_Zyyy}', "");
    Expect(1, 917632, '\P{  IS_Zyyy}', "");
    Expect(0, 917632, '\P{^  IS_Zyyy}', "");
    Error('\p{:=		Common_Indic_Number_forms}');
    Error('\P{:=		Common_Indic_Number_forms}');
    Expect(1, 43071, '\p{commonindicnumberforms}', "");
    Expect(0, 43071, '\p{^commonindicnumberforms}', "");
    Expect(0, 43071, '\P{commonindicnumberforms}', "");
    Expect(1, 43071, '\P{^commonindicnumberforms}', "");
    Expect(0, 43072, '\p{commonindicnumberforms}', "");
    Expect(1, 43072, '\p{^commonindicnumberforms}', "");
    Expect(1, 43072, '\P{commonindicnumberforms}', "");
    Expect(0, 43072, '\P{^commonindicnumberforms}', "");
    Expect(1, 43071, '\p{	COMMON_Indic_NUMBER_Forms}', "");
    Expect(0, 43071, '\p{^	COMMON_Indic_NUMBER_Forms}', "");
    Expect(0, 43071, '\P{	COMMON_Indic_NUMBER_Forms}', "");
    Expect(1, 43071, '\P{^	COMMON_Indic_NUMBER_Forms}', "");
    Expect(0, 43072, '\p{	COMMON_Indic_NUMBER_Forms}', "");
    Expect(1, 43072, '\p{^	COMMON_Indic_NUMBER_Forms}', "");
    Expect(1, 43072, '\P{	COMMON_Indic_NUMBER_Forms}', "");
    Expect(0, 43072, '\P{^	COMMON_Indic_NUMBER_Forms}', "");
    Error('\p{_-IS_Common_Indic_NUMBER_FORMS/a/}');
    Error('\P{_-IS_Common_Indic_NUMBER_FORMS/a/}');
    Expect(1, 43071, '\p{iscommonindicnumberforms}', "");
    Expect(0, 43071, '\p{^iscommonindicnumberforms}', "");
    Expect(0, 43071, '\P{iscommonindicnumberforms}', "");
    Expect(1, 43071, '\P{^iscommonindicnumberforms}', "");
    Expect(0, 43072, '\p{iscommonindicnumberforms}', "");
    Expect(1, 43072, '\p{^iscommonindicnumberforms}', "");
    Expect(1, 43072, '\P{iscommonindicnumberforms}', "");
    Expect(0, 43072, '\P{^iscommonindicnumberforms}', "");
    Expect(1, 43071, '\p{_ is_Common_Indic_number_FORMS}', "");
    Expect(0, 43071, '\p{^_ is_Common_Indic_number_FORMS}', "");
    Expect(0, 43071, '\P{_ is_Common_Indic_number_FORMS}', "");
    Expect(1, 43071, '\P{^_ is_Common_Indic_number_FORMS}', "");
    Expect(0, 43072, '\p{_ is_Common_Indic_number_FORMS}', "");
    Expect(1, 43072, '\p{^_ is_Common_Indic_number_FORMS}', "");
    Expect(1, 43072, '\P{_ is_Common_Indic_number_FORMS}', "");
    Expect(0, 43072, '\P{^_ is_Common_Indic_number_FORMS}', "");
    Error('\p{:= In_Common_Indic_Number_forms}');
    Error('\P{:= In_Common_Indic_Number_forms}');
    Expect(1, 43071, '\p{incommonindicnumberforms}', "");
    Expect(0, 43071, '\p{^incommonindicnumberforms}', "");
    Expect(0, 43071, '\P{incommonindicnumberforms}', "");
    Expect(1, 43071, '\P{^incommonindicnumberforms}', "");
    Expect(0, 43072, '\p{incommonindicnumberforms}', "");
    Expect(1, 43072, '\p{^incommonindicnumberforms}', "");
    Expect(1, 43072, '\P{incommonindicnumberforms}', "");
    Expect(0, 43072, '\P{^incommonindicnumberforms}', "");
    Expect(1, 43071, '\p{-IN_common_INDIC_Number_Forms}', "");
    Expect(0, 43071, '\p{^-IN_common_INDIC_Number_Forms}', "");
    Expect(0, 43071, '\P{-IN_common_INDIC_Number_Forms}', "");
    Expect(1, 43071, '\P{^-IN_common_INDIC_Number_Forms}', "");
    Expect(0, 43072, '\p{-IN_common_INDIC_Number_Forms}', "");
    Expect(1, 43072, '\p{^-IN_common_INDIC_Number_Forms}', "");
    Expect(1, 43072, '\P{-IN_common_INDIC_Number_Forms}', "");
    Expect(0, 43072, '\P{^-IN_common_INDIC_Number_Forms}', "");
    Error('\p{:=Indic_number_FORMS}');
    Error('\P{:=Indic_number_FORMS}');
    Expect(1, 43071, '\p{indicnumberforms}', "");
    Expect(0, 43071, '\p{^indicnumberforms}', "");
    Expect(0, 43071, '\P{indicnumberforms}', "");
    Expect(1, 43071, '\P{^indicnumberforms}', "");
    Expect(0, 43072, '\p{indicnumberforms}', "");
    Expect(1, 43072, '\p{^indicnumberforms}', "");
    Expect(1, 43072, '\P{indicnumberforms}', "");
    Expect(0, 43072, '\P{^indicnumberforms}', "");
    Expect(1, 43071, '\p{-Indic_Number_FORMS}', "");
    Expect(0, 43071, '\p{^-Indic_Number_FORMS}', "");
    Expect(0, 43071, '\P{-Indic_Number_FORMS}', "");
    Expect(1, 43071, '\P{^-Indic_Number_FORMS}', "");
    Expect(0, 43072, '\p{-Indic_Number_FORMS}', "");
    Expect(1, 43072, '\p{^-Indic_Number_FORMS}', "");
    Expect(1, 43072, '\P{-Indic_Number_FORMS}', "");
    Expect(0, 43072, '\P{^-Indic_Number_FORMS}', "");
    Error('\p{_	Is_indic_Number_forms:=}');
    Error('\P{_	Is_indic_Number_forms:=}');
    Expect(1, 43071, '\p{isindicnumberforms}', "");
    Expect(0, 43071, '\p{^isindicnumberforms}', "");
    Expect(0, 43071, '\P{isindicnumberforms}', "");
    Expect(1, 43071, '\P{^isindicnumberforms}', "");
    Expect(0, 43072, '\p{isindicnumberforms}', "");
    Expect(1, 43072, '\p{^isindicnumberforms}', "");
    Expect(1, 43072, '\P{isindicnumberforms}', "");
    Expect(0, 43072, '\P{^isindicnumberforms}', "");
    Expect(1, 43071, '\p{		Is_Indic_Number_FORMS}', "");
    Expect(0, 43071, '\p{^		Is_Indic_Number_FORMS}', "");
    Expect(0, 43071, '\P{		Is_Indic_Number_FORMS}', "");
    Expect(1, 43071, '\P{^		Is_Indic_Number_FORMS}', "");
    Expect(0, 43072, '\p{		Is_Indic_Number_FORMS}', "");
    Expect(1, 43072, '\p{^		Is_Indic_Number_FORMS}', "");
    Expect(1, 43072, '\P{		Is_Indic_Number_FORMS}', "");
    Expect(0, 43072, '\P{^		Is_Indic_Number_FORMS}', "");
    Error('\p{ _In_indic_NUMBER_forms/a/}');
    Error('\P{ _In_indic_NUMBER_forms/a/}');
    Expect(1, 43071, '\p{inindicnumberforms}', "");
    Expect(0, 43071, '\p{^inindicnumberforms}', "");
    Expect(0, 43071, '\P{inindicnumberforms}', "");
    Expect(1, 43071, '\P{^inindicnumberforms}', "");
    Expect(0, 43072, '\p{inindicnumberforms}', "");
    Expect(1, 43072, '\p{^inindicnumberforms}', "");
    Expect(1, 43072, '\P{inindicnumberforms}', "");
    Expect(0, 43072, '\P{^inindicnumberforms}', "");
    Expect(1, 43071, '\p{	-in_Indic_Number_forms}', "");
    Expect(0, 43071, '\p{^	-in_Indic_Number_forms}', "");
    Expect(0, 43071, '\P{	-in_Indic_Number_forms}', "");
    Expect(1, 43071, '\P{^	-in_Indic_Number_forms}', "");
    Expect(0, 43072, '\p{	-in_Indic_Number_forms}', "");
    Expect(1, 43072, '\p{^	-in_Indic_Number_forms}', "");
    Expect(1, 43072, '\P{	-in_Indic_Number_forms}', "");
    Expect(0, 43072, '\P{^	-in_Indic_Number_forms}', "");
    Error('\p{-	composition_Exclusion:=}');
    Error('\P{-	composition_Exclusion:=}');
    Expect(1, 119232, '\p{compositionexclusion}', "");
    Expect(0, 119232, '\p{^compositionexclusion}', "");
    Expect(0, 119232, '\P{compositionexclusion}', "");
    Expect(1, 119232, '\P{^compositionexclusion}', "");
    Expect(0, 119233, '\p{compositionexclusion}', "");
    Expect(1, 119233, '\p{^compositionexclusion}', "");
    Expect(1, 119233, '\P{compositionexclusion}', "");
    Expect(0, 119233, '\P{^compositionexclusion}', "");
    Expect(1, 119232, '\p{		COMPOSITION_EXCLUSION}', "");
    Expect(0, 119232, '\p{^		COMPOSITION_EXCLUSION}', "");
    Expect(0, 119232, '\P{		COMPOSITION_EXCLUSION}', "");
    Expect(1, 119232, '\P{^		COMPOSITION_EXCLUSION}', "");
    Expect(0, 119233, '\p{		COMPOSITION_EXCLUSION}', "");
    Expect(1, 119233, '\p{^		COMPOSITION_EXCLUSION}', "");
    Expect(1, 119233, '\P{		COMPOSITION_EXCLUSION}', "");
    Expect(0, 119233, '\P{^		COMPOSITION_EXCLUSION}', "");
    Error('\p{:=_Is_Composition_Exclusion}');
    Error('\P{:=_Is_Composition_Exclusion}');
    Expect(1, 119232, '\p{iscompositionexclusion}', "");
    Expect(0, 119232, '\p{^iscompositionexclusion}', "");
    Expect(0, 119232, '\P{iscompositionexclusion}', "");
    Expect(1, 119232, '\P{^iscompositionexclusion}', "");
    Expect(0, 119233, '\p{iscompositionexclusion}', "");
    Expect(1, 119233, '\p{^iscompositionexclusion}', "");
    Expect(1, 119233, '\P{iscompositionexclusion}', "");
    Expect(0, 119233, '\P{^iscompositionexclusion}', "");
    Expect(1, 119232, '\p{-Is_Composition_Exclusion}', "");
    Expect(0, 119232, '\p{^-Is_Composition_Exclusion}', "");
    Expect(0, 119232, '\P{-Is_Composition_Exclusion}', "");
    Expect(1, 119232, '\P{^-Is_Composition_Exclusion}', "");
    Expect(0, 119233, '\p{-Is_Composition_Exclusion}', "");
    Expect(1, 119233, '\p{^-Is_Composition_Exclusion}', "");
    Expect(1, 119233, '\P{-Is_Composition_Exclusion}', "");
    Expect(0, 119233, '\P{^-Is_Composition_Exclusion}', "");
    Error('\p{_:=CE}');
    Error('\P{_:=CE}');
    Expect(1, 119232, '\p{ce}', "");
    Expect(0, 119232, '\p{^ce}', "");
    Expect(0, 119232, '\P{ce}', "");
    Expect(1, 119232, '\P{^ce}', "");
    Expect(0, 119233, '\p{ce}', "");
    Expect(1, 119233, '\p{^ce}', "");
    Expect(1, 119233, '\P{ce}', "");
    Expect(0, 119233, '\P{^ce}', "");
    Expect(1, 119232, '\p{-	CE}', "");
    Expect(0, 119232, '\p{^-	CE}', "");
    Expect(0, 119232, '\P{-	CE}', "");
    Expect(1, 119232, '\P{^-	CE}', "");
    Expect(0, 119233, '\p{-	CE}', "");
    Expect(1, 119233, '\p{^-	CE}', "");
    Expect(1, 119233, '\P{-	CE}', "");
    Expect(0, 119233, '\P{^-	CE}', "");
    Error('\p{/a/  Is_CE}');
    Error('\P{/a/  Is_CE}');
    Expect(1, 119232, '\p{isce}', "");
    Expect(0, 119232, '\p{^isce}', "");
    Expect(0, 119232, '\P{isce}', "");
    Expect(1, 119232, '\P{^isce}', "");
    Expect(0, 119233, '\p{isce}', "");
    Expect(1, 119233, '\p{^isce}', "");
    Expect(1, 119233, '\P{isce}', "");
    Expect(0, 119233, '\P{^isce}', "");
    Expect(1, 119232, '\p{  Is_CE}', "");
    Expect(0, 119232, '\p{^  Is_CE}', "");
    Expect(0, 119232, '\P{  Is_CE}', "");
    Expect(1, 119232, '\P{^  Is_CE}', "");
    Expect(0, 119233, '\p{  Is_CE}', "");
    Expect(1, 119233, '\p{^  Is_CE}', "");
    Expect(1, 119233, '\P{  Is_CE}', "");
    Expect(0, 119233, '\P{^  Is_CE}', "");
    Error('\p{:=Connector_Punctuation}');
    Error('\P{:=Connector_Punctuation}');
    Expect(1, 65343, '\p{connectorpunctuation}', "");
    Expect(0, 65343, '\p{^connectorpunctuation}', "");
    Expect(0, 65343, '\P{connectorpunctuation}', "");
    Expect(1, 65343, '\P{^connectorpunctuation}', "");
    Expect(0, 65344, '\p{connectorpunctuation}', "");
    Expect(1, 65344, '\p{^connectorpunctuation}', "");
    Expect(1, 65344, '\P{connectorpunctuation}', "");
    Expect(0, 65344, '\P{^connectorpunctuation}', "");
    Expect(1, 65343, '\p{		Connector_Punctuation}', "");
    Expect(0, 65343, '\p{^		Connector_Punctuation}', "");
    Expect(0, 65343, '\P{		Connector_Punctuation}', "");
    Expect(1, 65343, '\P{^		Connector_Punctuation}', "");
    Expect(0, 65344, '\p{		Connector_Punctuation}', "");
    Expect(1, 65344, '\p{^		Connector_Punctuation}', "");
    Expect(1, 65344, '\P{		Connector_Punctuation}', "");
    Expect(0, 65344, '\P{^		Connector_Punctuation}', "");
    Error('\p{ Is_CONNECTOR_PUNCTUATION:=}');
    Error('\P{ Is_CONNECTOR_PUNCTUATION:=}');
    Expect(1, 65343, '\p{isconnectorpunctuation}', "");
    Expect(0, 65343, '\p{^isconnectorpunctuation}', "");
    Expect(0, 65343, '\P{isconnectorpunctuation}', "");
    Expect(1, 65343, '\P{^isconnectorpunctuation}', "");
    Expect(0, 65344, '\p{isconnectorpunctuation}', "");
    Expect(1, 65344, '\p{^isconnectorpunctuation}', "");
    Expect(1, 65344, '\P{isconnectorpunctuation}', "");
    Expect(0, 65344, '\P{^isconnectorpunctuation}', "");
    Expect(1, 65343, '\p{--Is_CONNECTOR_punctuation}', "");
    Expect(0, 65343, '\p{^--Is_CONNECTOR_punctuation}', "");
    Expect(0, 65343, '\P{--Is_CONNECTOR_punctuation}', "");
    Expect(1, 65343, '\P{^--Is_CONNECTOR_punctuation}', "");
    Expect(0, 65344, '\p{--Is_CONNECTOR_punctuation}', "");
    Expect(1, 65344, '\p{^--Is_CONNECTOR_punctuation}', "");
    Expect(1, 65344, '\P{--Is_CONNECTOR_punctuation}', "");
    Expect(0, 65344, '\P{^--Is_CONNECTOR_punctuation}', "");
    Error('\p{_:=Pc}');
    Error('\P{_:=Pc}');
    Expect(1, 65343, '\p{pc}', "");
    Expect(0, 65343, '\p{^pc}', "");
    Expect(0, 65343, '\P{pc}', "");
    Expect(1, 65343, '\P{^pc}', "");
    Expect(0, 65344, '\p{pc}', "");
    Expect(1, 65344, '\p{^pc}', "");
    Expect(1, 65344, '\P{pc}', "");
    Expect(0, 65344, '\P{^pc}', "");
    Expect(1, 65343, '\p{Pc}', "");
    Expect(0, 65343, '\p{^Pc}', "");
    Expect(0, 65343, '\P{Pc}', "");
    Expect(1, 65343, '\P{^Pc}', "");
    Expect(0, 65344, '\p{Pc}', "");
    Expect(1, 65344, '\p{^Pc}', "");
    Expect(1, 65344, '\P{Pc}', "");
    Expect(0, 65344, '\P{^Pc}', "");
    Error('\p{/a/__IS_Pc}');
    Error('\P{/a/__IS_Pc}');
    Expect(1, 65343, '\p{ispc}', "");
    Expect(0, 65343, '\p{^ispc}', "");
    Expect(0, 65343, '\P{ispc}', "");
    Expect(1, 65343, '\P{^ispc}', "");
    Expect(0, 65344, '\p{ispc}', "");
    Expect(1, 65344, '\p{^ispc}', "");
    Expect(1, 65344, '\P{ispc}', "");
    Expect(0, 65344, '\P{^ispc}', "");
    Expect(1, 65343, '\p{__is_PC}', "");
    Expect(0, 65343, '\p{^__is_PC}', "");
    Expect(0, 65343, '\P{__is_PC}', "");
    Expect(1, 65343, '\P{^__is_PC}', "");
    Expect(0, 65344, '\p{__is_PC}', "");
    Expect(1, 65344, '\p{^__is_PC}', "");
    Expect(1, 65344, '\P{__is_PC}', "");
    Expect(0, 65344, '\P{^__is_PC}', "");
    Error('\p{:=control_Pictures}');
    Error('\P{:=control_Pictures}');
    Expect(1, 9279, '\p{controlpictures}', "");
    Expect(0, 9279, '\p{^controlpictures}', "");
    Expect(0, 9279, '\P{controlpictures}', "");
    Expect(1, 9279, '\P{^controlpictures}', "");
    Expect(0, 9280, '\p{controlpictures}', "");
    Expect(1, 9280, '\p{^controlpictures}', "");
    Expect(1, 9280, '\P{controlpictures}', "");
    Expect(0, 9280, '\P{^controlpictures}', "");
    Expect(1, 9279, '\p{-_control_PICTURES}', "");
    Expect(0, 9279, '\p{^-_control_PICTURES}', "");
    Expect(0, 9279, '\P{-_control_PICTURES}', "");
    Expect(1, 9279, '\P{^-_control_PICTURES}', "");
    Expect(0, 9280, '\p{-_control_PICTURES}', "");
    Expect(1, 9280, '\p{^-_control_PICTURES}', "");
    Expect(1, 9280, '\P{-_control_PICTURES}', "");
    Expect(0, 9280, '\P{^-_control_PICTURES}', "");
    Error('\p{_IS_CONTROL_PICTURES/a/}');
    Error('\P{_IS_CONTROL_PICTURES/a/}');
    Expect(1, 9279, '\p{iscontrolpictures}', "");
    Expect(0, 9279, '\p{^iscontrolpictures}', "");
    Expect(0, 9279, '\P{iscontrolpictures}', "");
    Expect(1, 9279, '\P{^iscontrolpictures}', "");
    Expect(0, 9280, '\p{iscontrolpictures}', "");
    Expect(1, 9280, '\p{^iscontrolpictures}', "");
    Expect(1, 9280, '\P{iscontrolpictures}', "");
    Expect(0, 9280, '\P{^iscontrolpictures}', "");
    Expect(1, 9279, '\p{-_is_Control_Pictures}', "");
    Expect(0, 9279, '\p{^-_is_Control_Pictures}', "");
    Expect(0, 9279, '\P{-_is_Control_Pictures}', "");
    Expect(1, 9279, '\P{^-_is_Control_Pictures}', "");
    Expect(0, 9280, '\p{-_is_Control_Pictures}', "");
    Expect(1, 9280, '\p{^-_is_Control_Pictures}', "");
    Expect(1, 9280, '\P{-_is_Control_Pictures}', "");
    Expect(0, 9280, '\P{^-_is_Control_Pictures}', "");
    Error('\p{	:=In_control_Pictures}');
    Error('\P{	:=In_control_Pictures}');
    Expect(1, 9279, '\p{incontrolpictures}', "");
    Expect(0, 9279, '\p{^incontrolpictures}', "");
    Expect(0, 9279, '\P{incontrolpictures}', "");
    Expect(1, 9279, '\P{^incontrolpictures}', "");
    Expect(0, 9280, '\p{incontrolpictures}', "");
    Expect(1, 9280, '\p{^incontrolpictures}', "");
    Expect(1, 9280, '\P{incontrolpictures}', "");
    Expect(0, 9280, '\P{^incontrolpictures}', "");
    Expect(1, 9279, '\p{  In_control_Pictures}', "");
    Expect(0, 9279, '\p{^  In_control_Pictures}', "");
    Expect(0, 9279, '\P{  In_control_Pictures}', "");
    Expect(1, 9279, '\P{^  In_control_Pictures}', "");
    Expect(0, 9280, '\p{  In_control_Pictures}', "");
    Expect(1, 9280, '\p{^  In_control_Pictures}', "");
    Expect(1, 9280, '\P{  In_control_Pictures}', "");
    Expect(0, 9280, '\P{^  In_control_Pictures}', "");
    Error('\p{/a/ coptic}');
    Error('\P{/a/ coptic}');
    Expect(1, 66299, '\p{coptic}', "");
    Expect(0, 66299, '\p{^coptic}', "");
    Expect(0, 66299, '\P{coptic}', "");
    Expect(1, 66299, '\P{^coptic}', "");
    Expect(0, 66300, '\p{coptic}', "");
    Expect(1, 66300, '\p{^coptic}', "");
    Expect(1, 66300, '\P{coptic}', "");
    Expect(0, 66300, '\P{^coptic}', "");
    Expect(1, 66299, '\p{Coptic}', "");
    Expect(0, 66299, '\p{^Coptic}', "");
    Expect(0, 66299, '\P{Coptic}', "");
    Expect(1, 66299, '\P{^Coptic}', "");
    Expect(0, 66300, '\p{Coptic}', "");
    Expect(1, 66300, '\p{^Coptic}', "");
    Expect(1, 66300, '\P{Coptic}', "");
    Expect(0, 66300, '\P{^Coptic}', "");
    Error('\p{ 	Is_Coptic:=}');
    Error('\P{ 	Is_Coptic:=}');
    Expect(1, 66299, '\p{iscoptic}', "");
    Expect(0, 66299, '\p{^iscoptic}', "");
    Expect(0, 66299, '\P{iscoptic}', "");
    Expect(1, 66299, '\P{^iscoptic}', "");
    Expect(0, 66300, '\p{iscoptic}', "");
    Expect(1, 66300, '\p{^iscoptic}', "");
    Expect(1, 66300, '\P{iscoptic}', "");
    Expect(0, 66300, '\P{^iscoptic}', "");
    Expect(1, 66299, '\p{_Is_Coptic}', "");
    Expect(0, 66299, '\p{^_Is_Coptic}', "");
    Expect(0, 66299, '\P{_Is_Coptic}', "");
    Expect(1, 66299, '\P{^_Is_Coptic}', "");
    Expect(0, 66300, '\p{_Is_Coptic}', "");
    Expect(1, 66300, '\p{^_Is_Coptic}', "");
    Expect(1, 66300, '\P{_Is_Coptic}', "");
    Expect(0, 66300, '\P{^_Is_Coptic}', "");
    Error('\p{ COPT:=}');
    Error('\P{ COPT:=}');
    Expect(1, 66299, '\p{copt}', "");
    Expect(0, 66299, '\p{^copt}', "");
    Expect(0, 66299, '\P{copt}', "");
    Expect(1, 66299, '\P{^copt}', "");
    Expect(0, 66300, '\p{copt}', "");
    Expect(1, 66300, '\p{^copt}', "");
    Expect(1, 66300, '\P{copt}', "");
    Expect(0, 66300, '\P{^copt}', "");
    Expect(1, 66299, '\p{	 Copt}', "");
    Expect(0, 66299, '\p{^	 Copt}', "");
    Expect(0, 66299, '\P{	 Copt}', "");
    Expect(1, 66299, '\P{^	 Copt}', "");
    Expect(0, 66300, '\p{	 Copt}', "");
    Expect(1, 66300, '\p{^	 Copt}', "");
    Expect(1, 66300, '\P{	 Copt}', "");
    Expect(0, 66300, '\P{^	 Copt}', "");
    Error('\p{_/a/is_copt}');
    Error('\P{_/a/is_copt}');
    Expect(1, 66299, '\p{iscopt}', "");
    Expect(0, 66299, '\p{^iscopt}', "");
    Expect(0, 66299, '\P{iscopt}', "");
    Expect(1, 66299, '\P{^iscopt}', "");
    Expect(0, 66300, '\p{iscopt}', "");
    Expect(1, 66300, '\p{^iscopt}', "");
    Expect(1, 66300, '\P{iscopt}', "");
    Expect(0, 66300, '\P{^iscopt}', "");
    Expect(1, 66299, '\p{	IS_Copt}', "");
    Expect(0, 66299, '\p{^	IS_Copt}', "");
    Expect(0, 66299, '\P{	IS_Copt}', "");
    Expect(1, 66299, '\P{^	IS_Copt}', "");
    Expect(0, 66300, '\p{	IS_Copt}', "");
    Expect(1, 66300, '\p{^	IS_Copt}', "");
    Expect(1, 66300, '\P{	IS_Copt}', "");
    Expect(0, 66300, '\P{^	IS_Copt}', "");
    Error('\p{:=	 qaac}');
    Error('\P{:=	 qaac}');
    Expect(1, 66299, '\p{qaac}', "");
    Expect(0, 66299, '\p{^qaac}', "");
    Expect(0, 66299, '\P{qaac}', "");
    Expect(1, 66299, '\P{^qaac}', "");
    Expect(0, 66300, '\p{qaac}', "");
    Expect(1, 66300, '\p{^qaac}', "");
    Expect(1, 66300, '\P{qaac}', "");
    Expect(0, 66300, '\P{^qaac}', "");
    Expect(1, 66299, '\p{-Qaac}', "");
    Expect(0, 66299, '\p{^-Qaac}', "");
    Expect(0, 66299, '\P{-Qaac}', "");
    Expect(1, 66299, '\P{^-Qaac}', "");
    Expect(0, 66300, '\p{-Qaac}', "");
    Expect(1, 66300, '\p{^-Qaac}', "");
    Expect(1, 66300, '\P{-Qaac}', "");
    Expect(0, 66300, '\P{^-Qaac}', "");
    Error('\p{	:=is_Qaac}');
    Error('\P{	:=is_Qaac}');
    Expect(1, 66299, '\p{isqaac}', "");
    Expect(0, 66299, '\p{^isqaac}', "");
    Expect(0, 66299, '\P{isqaac}', "");
    Expect(1, 66299, '\P{^isqaac}', "");
    Expect(0, 66300, '\p{isqaac}', "");
    Expect(1, 66300, '\p{^isqaac}', "");
    Expect(1, 66300, '\P{isqaac}', "");
    Expect(0, 66300, '\P{^isqaac}', "");
    Expect(1, 66299, '\p{ 	IS_qaac}', "");
    Expect(0, 66299, '\p{^ 	IS_qaac}', "");
    Expect(0, 66299, '\P{ 	IS_qaac}', "");
    Expect(1, 66299, '\P{^ 	IS_qaac}', "");
    Expect(0, 66300, '\p{ 	IS_qaac}', "");
    Expect(1, 66300, '\p{^ 	IS_qaac}', "");
    Expect(1, 66300, '\P{ 	IS_qaac}', "");
    Expect(0, 66300, '\P{^ 	IS_qaac}', "");
    Error('\p{:= Coptic_Epact_Numbers}');
    Error('\P{:= Coptic_Epact_Numbers}');
    Expect(1, 66303, '\p{copticepactnumbers}', "");
    Expect(0, 66303, '\p{^copticepactnumbers}', "");
    Expect(0, 66303, '\P{copticepactnumbers}', "");
    Expect(1, 66303, '\P{^copticepactnumbers}', "");
    Expect(0, 66304, '\p{copticepactnumbers}', "");
    Expect(1, 66304, '\p{^copticepactnumbers}', "");
    Expect(1, 66304, '\P{copticepactnumbers}', "");
    Expect(0, 66304, '\P{^copticepactnumbers}', "");
    Expect(1, 66303, '\p{		coptic_EPACT_numbers}', "");
    Expect(0, 66303, '\p{^		coptic_EPACT_numbers}', "");
    Expect(0, 66303, '\P{		coptic_EPACT_numbers}', "");
    Expect(1, 66303, '\P{^		coptic_EPACT_numbers}', "");
    Expect(0, 66304, '\p{		coptic_EPACT_numbers}', "");
    Expect(1, 66304, '\p{^		coptic_EPACT_numbers}', "");
    Expect(1, 66304, '\P{		coptic_EPACT_numbers}', "");
    Expect(0, 66304, '\P{^		coptic_EPACT_numbers}', "");
    Error('\p{:=	IS_COPTIC_epact_NUMBERS}');
    Error('\P{:=	IS_COPTIC_epact_NUMBERS}');
    Expect(1, 66303, '\p{iscopticepactnumbers}', "");
    Expect(0, 66303, '\p{^iscopticepactnumbers}', "");
    Expect(0, 66303, '\P{iscopticepactnumbers}', "");
    Expect(1, 66303, '\P{^iscopticepactnumbers}', "");
    Expect(0, 66304, '\p{iscopticepactnumbers}', "");
    Expect(1, 66304, '\p{^iscopticepactnumbers}', "");
    Expect(1, 66304, '\P{iscopticepactnumbers}', "");
    Expect(0, 66304, '\P{^iscopticepactnumbers}', "");
    Expect(1, 66303, '\p{ _is_coptic_epact_Numbers}', "");
    Expect(0, 66303, '\p{^ _is_coptic_epact_Numbers}', "");
    Expect(0, 66303, '\P{ _is_coptic_epact_Numbers}', "");
    Expect(1, 66303, '\P{^ _is_coptic_epact_Numbers}', "");
    Expect(0, 66304, '\p{ _is_coptic_epact_Numbers}', "");
    Expect(1, 66304, '\p{^ _is_coptic_epact_Numbers}', "");
    Expect(1, 66304, '\P{ _is_coptic_epact_Numbers}', "");
    Expect(0, 66304, '\P{^ _is_coptic_epact_Numbers}', "");
    Error('\p{ in_Coptic_epact_numbers/a/}');
    Error('\P{ in_Coptic_epact_numbers/a/}');
    Expect(1, 66303, '\p{incopticepactnumbers}', "");
    Expect(0, 66303, '\p{^incopticepactnumbers}', "");
    Expect(0, 66303, '\P{incopticepactnumbers}', "");
    Expect(1, 66303, '\P{^incopticepactnumbers}', "");
    Expect(0, 66304, '\p{incopticepactnumbers}', "");
    Expect(1, 66304, '\p{^incopticepactnumbers}', "");
    Expect(1, 66304, '\P{incopticepactnumbers}', "");
    Expect(0, 66304, '\P{^incopticepactnumbers}', "");
    Expect(1, 66303, '\p{	_In_coptic_epact_NUMBERS}', "");
    Expect(0, 66303, '\p{^	_In_coptic_epact_NUMBERS}', "");
    Expect(0, 66303, '\P{	_In_coptic_epact_NUMBERS}', "");
    Expect(1, 66303, '\P{^	_In_coptic_epact_NUMBERS}', "");
    Expect(0, 66304, '\p{	_In_coptic_epact_NUMBERS}', "");
    Expect(1, 66304, '\p{^	_In_coptic_epact_NUMBERS}', "");
    Expect(1, 66304, '\P{	_In_coptic_epact_NUMBERS}', "");
    Expect(0, 66304, '\P{^	_In_coptic_epact_NUMBERS}', "");
    Error('\p{ /a/Counting_ROD_Numerals}');
    Error('\P{ /a/Counting_ROD_Numerals}');
    Expect(1, 119679, '\p{countingrodnumerals}', "");
    Expect(0, 119679, '\p{^countingrodnumerals}', "");
    Expect(0, 119679, '\P{countingrodnumerals}', "");
    Expect(1, 119679, '\P{^countingrodnumerals}', "");
    Expect(0, 119680, '\p{countingrodnumerals}', "");
    Expect(1, 119680, '\p{^countingrodnumerals}', "");
    Expect(1, 119680, '\P{countingrodnumerals}', "");
    Expect(0, 119680, '\P{^countingrodnumerals}', "");
    Expect(1, 119679, '\p{	Counting_ROD_Numerals}', "");
    Expect(0, 119679, '\p{^	Counting_ROD_Numerals}', "");
    Expect(0, 119679, '\P{	Counting_ROD_Numerals}', "");
    Expect(1, 119679, '\P{^	Counting_ROD_Numerals}', "");
    Expect(0, 119680, '\p{	Counting_ROD_Numerals}', "");
    Expect(1, 119680, '\p{^	Counting_ROD_Numerals}', "");
    Expect(1, 119680, '\P{	Counting_ROD_Numerals}', "");
    Expect(0, 119680, '\P{^	Counting_ROD_Numerals}', "");
    Error('\p{_Is_counting_Rod_Numerals/a/}');
    Error('\P{_Is_counting_Rod_Numerals/a/}');
    Expect(1, 119679, '\p{iscountingrodnumerals}', "");
    Expect(0, 119679, '\p{^iscountingrodnumerals}', "");
    Expect(0, 119679, '\P{iscountingrodnumerals}', "");
    Expect(1, 119679, '\P{^iscountingrodnumerals}', "");
    Expect(0, 119680, '\p{iscountingrodnumerals}', "");
    Expect(1, 119680, '\p{^iscountingrodnumerals}', "");
    Expect(1, 119680, '\P{iscountingrodnumerals}', "");
    Expect(0, 119680, '\P{^iscountingrodnumerals}', "");
    Expect(1, 119679, '\p{ 	Is_Counting_rod_numerals}', "");
    Expect(0, 119679, '\p{^ 	Is_Counting_rod_numerals}', "");
    Expect(0, 119679, '\P{ 	Is_Counting_rod_numerals}', "");
    Expect(1, 119679, '\P{^ 	Is_Counting_rod_numerals}', "");
    Expect(0, 119680, '\p{ 	Is_Counting_rod_numerals}', "");
    Expect(1, 119680, '\p{^ 	Is_Counting_rod_numerals}', "");
    Expect(1, 119680, '\P{ 	Is_Counting_rod_numerals}', "");
    Expect(0, 119680, '\P{^ 	Is_Counting_rod_numerals}', "");
    Error('\p{  In_COUNTING_Rod_NUMERALS/a/}');
    Error('\P{  In_COUNTING_Rod_NUMERALS/a/}');
    Expect(1, 119679, '\p{incountingrodnumerals}', "");
    Expect(0, 119679, '\p{^incountingrodnumerals}', "");
    Expect(0, 119679, '\P{incountingrodnumerals}', "");
    Expect(1, 119679, '\P{^incountingrodnumerals}', "");
    Expect(0, 119680, '\p{incountingrodnumerals}', "");
    Expect(1, 119680, '\p{^incountingrodnumerals}', "");
    Expect(1, 119680, '\P{incountingrodnumerals}', "");
    Expect(0, 119680, '\P{^incountingrodnumerals}', "");
    Expect(1, 119679, '\p{-	in_counting_ROD_NUMERALS}', "");
    Expect(0, 119679, '\p{^-	in_counting_ROD_NUMERALS}', "");
    Expect(0, 119679, '\P{-	in_counting_ROD_NUMERALS}', "");
    Expect(1, 119679, '\P{^-	in_counting_ROD_NUMERALS}', "");
    Expect(0, 119680, '\p{-	in_counting_ROD_NUMERALS}', "");
    Expect(1, 119680, '\p{^-	in_counting_ROD_NUMERALS}', "");
    Expect(1, 119680, '\P{-	in_counting_ROD_NUMERALS}', "");
    Expect(0, 119680, '\P{^-	in_counting_ROD_NUMERALS}', "");
    Error('\p{-:=counting_Rod}');
    Error('\P{-:=counting_Rod}');
    Expect(1, 119679, '\p{countingrod}', "");
    Expect(0, 119679, '\p{^countingrod}', "");
    Expect(0, 119679, '\P{countingrod}', "");
    Expect(1, 119679, '\P{^countingrod}', "");
    Expect(0, 119680, '\p{countingrod}', "");
    Expect(1, 119680, '\p{^countingrod}', "");
    Expect(1, 119680, '\P{countingrod}', "");
    Expect(0, 119680, '\P{^countingrod}', "");
    Expect(1, 119679, '\p{	Counting_Rod}', "");
    Expect(0, 119679, '\p{^	Counting_Rod}', "");
    Expect(0, 119679, '\P{	Counting_Rod}', "");
    Expect(1, 119679, '\P{^	Counting_Rod}', "");
    Expect(0, 119680, '\p{	Counting_Rod}', "");
    Expect(1, 119680, '\p{^	Counting_Rod}', "");
    Expect(1, 119680, '\P{	Counting_Rod}', "");
    Expect(0, 119680, '\P{^	Counting_Rod}', "");
    Error('\p{ Is_Counting_ROD/a/}');
    Error('\P{ Is_Counting_ROD/a/}');
    Expect(1, 119679, '\p{iscountingrod}', "");
    Expect(0, 119679, '\p{^iscountingrod}', "");
    Expect(0, 119679, '\P{iscountingrod}', "");
    Expect(1, 119679, '\P{^iscountingrod}', "");
    Expect(0, 119680, '\p{iscountingrod}', "");
    Expect(1, 119680, '\p{^iscountingrod}', "");
    Expect(1, 119680, '\P{iscountingrod}', "");
    Expect(0, 119680, '\P{^iscountingrod}', "");
    Expect(1, 119679, '\p{	Is_COUNTING_rod}', "");
    Expect(0, 119679, '\p{^	Is_COUNTING_rod}', "");
    Expect(0, 119679, '\P{	Is_COUNTING_rod}', "");
    Expect(1, 119679, '\P{^	Is_COUNTING_rod}', "");
    Expect(0, 119680, '\p{	Is_COUNTING_rod}', "");
    Expect(1, 119680, '\p{^	Is_COUNTING_rod}', "");
    Expect(1, 119680, '\P{	Is_COUNTING_rod}', "");
    Expect(0, 119680, '\P{^	Is_COUNTING_rod}', "");
    Error('\p{_-In_Counting_ROD/a/}');
    Error('\P{_-In_Counting_ROD/a/}');
    Expect(1, 119679, '\p{incountingrod}', "");
    Expect(0, 119679, '\p{^incountingrod}', "");
    Expect(0, 119679, '\P{incountingrod}', "");
    Expect(1, 119679, '\P{^incountingrod}', "");
    Expect(0, 119680, '\p{incountingrod}', "");
    Expect(1, 119680, '\p{^incountingrod}', "");
    Expect(1, 119680, '\P{incountingrod}', "");
    Expect(0, 119680, '\P{^incountingrod}', "");
    Expect(1, 119679, '\p{-In_COUNTING_Rod}', "");
    Expect(0, 119679, '\p{^-In_COUNTING_Rod}', "");
    Expect(0, 119679, '\P{-In_COUNTING_Rod}', "");
    Expect(1, 119679, '\P{^-In_COUNTING_Rod}', "");
    Expect(0, 119680, '\p{-In_COUNTING_Rod}', "");
    Expect(1, 119680, '\p{^-In_COUNTING_Rod}', "");
    Expect(1, 119680, '\P{-In_COUNTING_Rod}', "");
    Expect(0, 119680, '\P{^-In_COUNTING_Rod}', "");
    Error('\p{:=Cuneiform}');
    Error('\P{:=Cuneiform}');
    Expect(1, 75075, '\p{cuneiform}', "");
    Expect(0, 75075, '\p{^cuneiform}', "");
    Expect(0, 75075, '\P{cuneiform}', "");
    Expect(1, 75075, '\P{^cuneiform}', "");
    Expect(0, 75076, '\p{cuneiform}', "");
    Expect(1, 75076, '\p{^cuneiform}', "");
    Expect(1, 75076, '\P{cuneiform}', "");
    Expect(0, 75076, '\P{^cuneiform}', "");
    Expect(1, 75075, '\p{ _CUNEIFORM}', "");
    Expect(0, 75075, '\p{^ _CUNEIFORM}', "");
    Expect(0, 75075, '\P{ _CUNEIFORM}', "");
    Expect(1, 75075, '\P{^ _CUNEIFORM}', "");
    Expect(0, 75076, '\p{ _CUNEIFORM}', "");
    Expect(1, 75076, '\p{^ _CUNEIFORM}', "");
    Expect(1, 75076, '\P{ _CUNEIFORM}', "");
    Expect(0, 75076, '\P{^ _CUNEIFORM}', "");
    Error('\p{	-IS_cuneiform:=}');
    Error('\P{	-IS_cuneiform:=}');
    Expect(1, 75075, '\p{iscuneiform}', "");
    Expect(0, 75075, '\p{^iscuneiform}', "");
    Expect(0, 75075, '\P{iscuneiform}', "");
    Expect(1, 75075, '\P{^iscuneiform}', "");
    Expect(0, 75076, '\p{iscuneiform}', "");
    Expect(1, 75076, '\p{^iscuneiform}', "");
    Expect(1, 75076, '\P{iscuneiform}', "");
    Expect(0, 75076, '\P{^iscuneiform}', "");
    Expect(1, 75075, '\p{-_Is_CUNEIFORM}', "");
    Expect(0, 75075, '\p{^-_Is_CUNEIFORM}', "");
    Expect(0, 75075, '\P{-_Is_CUNEIFORM}', "");
    Expect(1, 75075, '\P{^-_Is_CUNEIFORM}', "");
    Expect(0, 75076, '\p{-_Is_CUNEIFORM}', "");
    Expect(1, 75076, '\p{^-_Is_CUNEIFORM}', "");
    Expect(1, 75076, '\P{-_Is_CUNEIFORM}', "");
    Expect(0, 75076, '\P{^-_Is_CUNEIFORM}', "");
    Error('\p{:=	 Xsux}');
    Error('\P{:=	 Xsux}');
    Expect(1, 75075, '\p{xsux}', "");
    Expect(0, 75075, '\p{^xsux}', "");
    Expect(0, 75075, '\P{xsux}', "");
    Expect(1, 75075, '\P{^xsux}', "");
    Expect(0, 75076, '\p{xsux}', "");
    Expect(1, 75076, '\p{^xsux}', "");
    Expect(1, 75076, '\P{xsux}', "");
    Expect(0, 75076, '\P{^xsux}', "");
    Expect(1, 75075, '\p{	_XSUX}', "");
    Expect(0, 75075, '\p{^	_XSUX}', "");
    Expect(0, 75075, '\P{	_XSUX}', "");
    Expect(1, 75075, '\P{^	_XSUX}', "");
    Expect(0, 75076, '\p{	_XSUX}', "");
    Expect(1, 75076, '\p{^	_XSUX}', "");
    Expect(1, 75076, '\P{	_XSUX}', "");
    Expect(0, 75076, '\P{^	_XSUX}', "");
    Error('\p{- Is_Xsux/a/}');
    Error('\P{- Is_Xsux/a/}');
    Expect(1, 75075, '\p{isxsux}', "");
    Expect(0, 75075, '\p{^isxsux}', "");
    Expect(0, 75075, '\P{isxsux}', "");
    Expect(1, 75075, '\P{^isxsux}', "");
    Expect(0, 75076, '\p{isxsux}', "");
    Expect(1, 75076, '\p{^isxsux}', "");
    Expect(1, 75076, '\P{isxsux}', "");
    Expect(0, 75076, '\P{^isxsux}', "");
    Expect(1, 75075, '\p{ -IS_XSUX}', "");
    Expect(0, 75075, '\p{^ -IS_XSUX}', "");
    Expect(0, 75075, '\P{ -IS_XSUX}', "");
    Expect(1, 75075, '\P{^ -IS_XSUX}', "");
    Expect(0, 75076, '\p{ -IS_XSUX}', "");
    Expect(1, 75076, '\p{^ -IS_XSUX}', "");
    Expect(1, 75076, '\P{ -IS_XSUX}', "");
    Expect(0, 75076, '\P{^ -IS_XSUX}', "");
    Error('\p{/a/_-CUNEIFORM_Numbers_And_Punctuation}');
    Error('\P{/a/_-CUNEIFORM_Numbers_And_Punctuation}');
    Expect(1, 74879, '\p{cuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\p{^cuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\P{cuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\P{^cuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\p{cuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\p{^cuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\P{cuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\P{^cuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\p{ 	Cuneiform_NUMBERS_And_PUNCTUATION}', "");
    Expect(0, 74879, '\p{^ 	Cuneiform_NUMBERS_And_PUNCTUATION}', "");
    Expect(0, 74879, '\P{ 	Cuneiform_NUMBERS_And_PUNCTUATION}', "");
    Expect(1, 74879, '\P{^ 	Cuneiform_NUMBERS_And_PUNCTUATION}', "");
    Expect(0, 74880, '\p{ 	Cuneiform_NUMBERS_And_PUNCTUATION}', "");
    Expect(1, 74880, '\p{^ 	Cuneiform_NUMBERS_And_PUNCTUATION}', "");
    Expect(1, 74880, '\P{ 	Cuneiform_NUMBERS_And_PUNCTUATION}', "");
    Expect(0, 74880, '\P{^ 	Cuneiform_NUMBERS_And_PUNCTUATION}', "");
    Error('\p{:=is_cuneiform_Numbers_And_Punctuation}');
    Error('\P{:=is_cuneiform_Numbers_And_Punctuation}');
    Expect(1, 74879, '\p{iscuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\p{^iscuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\P{iscuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\P{^iscuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\p{iscuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\p{^iscuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\P{iscuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\P{^iscuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\p{ 	Is_cuneiform_Numbers_And_Punctuation}', "");
    Expect(0, 74879, '\p{^ 	Is_cuneiform_Numbers_And_Punctuation}', "");
    Expect(0, 74879, '\P{ 	Is_cuneiform_Numbers_And_Punctuation}', "");
    Expect(1, 74879, '\P{^ 	Is_cuneiform_Numbers_And_Punctuation}', "");
    Expect(0, 74880, '\p{ 	Is_cuneiform_Numbers_And_Punctuation}', "");
    Expect(1, 74880, '\p{^ 	Is_cuneiform_Numbers_And_Punctuation}', "");
    Expect(1, 74880, '\P{ 	Is_cuneiform_Numbers_And_Punctuation}', "");
    Expect(0, 74880, '\P{^ 	Is_cuneiform_Numbers_And_Punctuation}', "");
    Error('\p{	/a/IN_cuneiform_NUMBERS_and_Punctuation}');
    Error('\P{	/a/IN_cuneiform_NUMBERS_and_Punctuation}');
    Expect(1, 74879, '\p{incuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\p{^incuneiformnumbersandpunctuation}', "");
    Expect(0, 74879, '\P{incuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\P{^incuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\p{incuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\p{^incuneiformnumbersandpunctuation}', "");
    Expect(1, 74880, '\P{incuneiformnumbersandpunctuation}', "");
    Expect(0, 74880, '\P{^incuneiformnumbersandpunctuation}', "");
    Expect(1, 74879, '\p{_ In_cuneiform_numbers_AND_punctuation}', "");
    Expect(0, 74879, '\p{^_ In_cuneiform_numbers_AND_punctuation}', "");
    Expect(0, 74879, '\P{_ In_cuneiform_numbers_AND_punctuation}', "");
    Expect(1, 74879, '\P{^_ In_cuneiform_numbers_AND_punctuation}', "");
    Expect(0, 74880, '\p{_ In_cuneiform_numbers_AND_punctuation}', "");
    Expect(1, 74880, '\p{^_ In_cuneiform_numbers_AND_punctuation}', "");
    Expect(1, 74880, '\P{_ In_cuneiform_numbers_AND_punctuation}', "");
    Expect(0, 74880, '\P{^_ In_cuneiform_numbers_AND_punctuation}', "");
    Error('\p{-	cuneiform_numbers:=}');
    Error('\P{-	cuneiform_numbers:=}');
    Expect(1, 74879, '\p{cuneiformnumbers}', "");
    Expect(0, 74879, '\p{^cuneiformnumbers}', "");
    Expect(0, 74879, '\P{cuneiformnumbers}', "");
    Expect(1, 74879, '\P{^cuneiformnumbers}', "");
    Expect(0, 74880, '\p{cuneiformnumbers}', "");
    Expect(1, 74880, '\p{^cuneiformnumbers}', "");
    Expect(1, 74880, '\P{cuneiformnumbers}', "");
    Expect(0, 74880, '\P{^cuneiformnumbers}', "");
    Expect(1, 74879, '\p{_cuneiform_Numbers}', "");
    Expect(0, 74879, '\p{^_cuneiform_Numbers}', "");
    Expect(0, 74879, '\P{_cuneiform_Numbers}', "");
    Expect(1, 74879, '\P{^_cuneiform_Numbers}', "");
    Expect(0, 74880, '\p{_cuneiform_Numbers}', "");
    Expect(1, 74880, '\p{^_cuneiform_Numbers}', "");
    Expect(1, 74880, '\P{_cuneiform_Numbers}', "");
    Expect(0, 74880, '\P{^_cuneiform_Numbers}', "");
    Error('\p{_	Is_cuneiform_Numbers:=}');
    Error('\P{_	Is_cuneiform_Numbers:=}');
    Expect(1, 74879, '\p{iscuneiformnumbers}', "");
    Expect(0, 74879, '\p{^iscuneiformnumbers}', "");
    Expect(0, 74879, '\P{iscuneiformnumbers}', "");
    Expect(1, 74879, '\P{^iscuneiformnumbers}', "");
    Expect(0, 74880, '\p{iscuneiformnumbers}', "");
    Expect(1, 74880, '\p{^iscuneiformnumbers}', "");
    Expect(1, 74880, '\P{iscuneiformnumbers}', "");
    Expect(0, 74880, '\P{^iscuneiformnumbers}', "");
    Expect(1, 74879, '\p{ 	IS_cuneiform_Numbers}', "");
    Expect(0, 74879, '\p{^ 	IS_cuneiform_Numbers}', "");
    Expect(0, 74879, '\P{ 	IS_cuneiform_Numbers}', "");
    Expect(1, 74879, '\P{^ 	IS_cuneiform_Numbers}', "");
    Expect(0, 74880, '\p{ 	IS_cuneiform_Numbers}', "");
    Expect(1, 74880, '\p{^ 	IS_cuneiform_Numbers}', "");
    Expect(1, 74880, '\P{ 	IS_cuneiform_Numbers}', "");
    Expect(0, 74880, '\P{^ 	IS_cuneiform_Numbers}', "");
    Error('\p{-:=IN_cuneiform_Numbers}');
    Error('\P{-:=IN_cuneiform_Numbers}');
    Expect(1, 74879, '\p{incuneiformnumbers}', "");
    Expect(0, 74879, '\p{^incuneiformnumbers}', "");
    Expect(0, 74879, '\P{incuneiformnumbers}', "");
    Expect(1, 74879, '\P{^incuneiformnumbers}', "");
    Expect(0, 74880, '\p{incuneiformnumbers}', "");
    Expect(1, 74880, '\p{^incuneiformnumbers}', "");
    Expect(1, 74880, '\P{incuneiformnumbers}', "");
    Expect(0, 74880, '\P{^incuneiformnumbers}', "");
    Expect(1, 74879, '\p{ -In_Cuneiform_numbers}', "");
    Expect(0, 74879, '\p{^ -In_Cuneiform_numbers}', "");
    Expect(0, 74879, '\P{ -In_Cuneiform_numbers}', "");
    Expect(1, 74879, '\P{^ -In_Cuneiform_numbers}', "");
    Expect(0, 74880, '\p{ -In_Cuneiform_numbers}', "");
    Expect(1, 74880, '\p{^ -In_Cuneiform_numbers}', "");
    Expect(1, 74880, '\P{ -In_Cuneiform_numbers}', "");
    Expect(0, 74880, '\P{^ -In_Cuneiform_numbers}', "");
    Error('\p{:=CURRENCY_Symbol}');
    Error('\P{:=CURRENCY_Symbol}');
    Expect(1, 126128, '\p{currencysymbol}', "");
    Expect(0, 126128, '\p{^currencysymbol}', "");
    Expect(0, 126128, '\P{currencysymbol}', "");
    Expect(1, 126128, '\P{^currencysymbol}', "");
    Expect(0, 126129, '\p{currencysymbol}', "");
    Expect(1, 126129, '\p{^currencysymbol}', "");
    Expect(1, 126129, '\P{currencysymbol}', "");
    Expect(0, 126129, '\P{^currencysymbol}', "");
    Expect(1, 126128, '\p{-Currency_SYMBOL}', "");
    Expect(0, 126128, '\p{^-Currency_SYMBOL}', "");
    Expect(0, 126128, '\P{-Currency_SYMBOL}', "");
    Expect(1, 126128, '\P{^-Currency_SYMBOL}', "");
    Expect(0, 126129, '\p{-Currency_SYMBOL}', "");
    Expect(1, 126129, '\p{^-Currency_SYMBOL}', "");
    Expect(1, 126129, '\P{-Currency_SYMBOL}', "");
    Expect(0, 126129, '\P{^-Currency_SYMBOL}', "");
    Error('\p{_ IS_CURRENCY_Symbol:=}');
    Error('\P{_ IS_CURRENCY_Symbol:=}');
    Expect(1, 126128, '\p{iscurrencysymbol}', "");
    Expect(0, 126128, '\p{^iscurrencysymbol}', "");
    Expect(0, 126128, '\P{iscurrencysymbol}', "");
    Expect(1, 126128, '\P{^iscurrencysymbol}', "");
    Expect(0, 126129, '\p{iscurrencysymbol}', "");
    Expect(1, 126129, '\p{^iscurrencysymbol}', "");
    Expect(1, 126129, '\P{iscurrencysymbol}', "");
    Expect(0, 126129, '\P{^iscurrencysymbol}', "");
    Expect(1, 126128, '\p{	 is_currency_Symbol}', "");
    Expect(0, 126128, '\p{^	 is_currency_Symbol}', "");
    Expect(0, 126128, '\P{	 is_currency_Symbol}', "");
    Expect(1, 126128, '\P{^	 is_currency_Symbol}', "");
    Expect(0, 126129, '\p{	 is_currency_Symbol}', "");
    Expect(1, 126129, '\p{^	 is_currency_Symbol}', "");
    Expect(1, 126129, '\P{	 is_currency_Symbol}', "");
    Expect(0, 126129, '\P{^	 is_currency_Symbol}', "");
    Error('\p{ _Sc:=}');
    Error('\P{ _Sc:=}');
    Expect(1, 126128, '\p{sc}', "");
    Expect(0, 126128, '\p{^sc}', "");
    Expect(0, 126128, '\P{sc}', "");
    Expect(1, 126128, '\P{^sc}', "");
    Expect(0, 126129, '\p{sc}', "");
    Expect(1, 126129, '\p{^sc}', "");
    Expect(1, 126129, '\P{sc}', "");
    Expect(0, 126129, '\P{^sc}', "");
    Expect(1, 126128, '\p{-SC}', "");
    Expect(0, 126128, '\p{^-SC}', "");
    Expect(0, 126128, '\P{-SC}', "");
    Expect(1, 126128, '\P{^-SC}', "");
    Expect(0, 126129, '\p{-SC}', "");
    Expect(1, 126129, '\p{^-SC}', "");
    Expect(1, 126129, '\P{-SC}', "");
    Expect(0, 126129, '\P{^-SC}', "");
    Error('\p{ -Is_Sc:=}');
    Error('\P{ -Is_Sc:=}');
    Expect(1, 126128, '\p{issc}', "");
    Expect(0, 126128, '\p{^issc}', "");
    Expect(0, 126128, '\P{issc}', "");
    Expect(1, 126128, '\P{^issc}', "");
    Expect(0, 126129, '\p{issc}', "");
    Expect(1, 126129, '\p{^issc}', "");
    Expect(1, 126129, '\P{issc}', "");
    Expect(0, 126129, '\P{^issc}', "");
    Expect(1, 126128, '\p{_-Is_sc}', "");
    Expect(0, 126128, '\p{^_-Is_sc}', "");
    Expect(0, 126128, '\P{_-Is_sc}', "");
    Expect(1, 126128, '\P{^_-Is_sc}', "");
    Expect(0, 126129, '\p{_-Is_sc}', "");
    Expect(1, 126129, '\p{^_-Is_sc}', "");
    Expect(1, 126129, '\P{_-Is_sc}', "");
    Expect(0, 126129, '\P{^_-Is_sc}', "");
    Error('\p{-	currency_SYMBOLS:=}');
    Error('\P{-	currency_SYMBOLS:=}');
    Expect(1, 8399, '\p{currencysymbols}', "");
    Expect(0, 8399, '\p{^currencysymbols}', "");
    Expect(0, 8399, '\P{currencysymbols}', "");
    Expect(1, 8399, '\P{^currencysymbols}', "");
    Expect(0, 8400, '\p{currencysymbols}', "");
    Expect(1, 8400, '\p{^currencysymbols}', "");
    Expect(1, 8400, '\P{currencysymbols}', "");
    Expect(0, 8400, '\P{^currencysymbols}', "");
    Expect(1, 8399, '\p{-currency_Symbols}', "");
    Expect(0, 8399, '\p{^-currency_Symbols}', "");
    Expect(0, 8399, '\P{-currency_Symbols}', "");
    Expect(1, 8399, '\P{^-currency_Symbols}', "");
    Expect(0, 8400, '\p{-currency_Symbols}', "");
    Expect(1, 8400, '\p{^-currency_Symbols}', "");
    Expect(1, 8400, '\P{-currency_Symbols}', "");
    Expect(0, 8400, '\P{^-currency_Symbols}', "");
    Error('\p{ 	Is_CURRENCY_symbols/a/}');
    Error('\P{ 	Is_CURRENCY_symbols/a/}');
    Expect(1, 8399, '\p{iscurrencysymbols}', "");
    Expect(0, 8399, '\p{^iscurrencysymbols}', "");
    Expect(0, 8399, '\P{iscurrencysymbols}', "");
    Expect(1, 8399, '\P{^iscurrencysymbols}', "");
    Expect(0, 8400, '\p{iscurrencysymbols}', "");
    Expect(1, 8400, '\p{^iscurrencysymbols}', "");
    Expect(1, 8400, '\P{iscurrencysymbols}', "");
    Expect(0, 8400, '\P{^iscurrencysymbols}', "");
    Expect(1, 8399, '\p{-Is_CURRENCY_Symbols}', "");
    Expect(0, 8399, '\p{^-Is_CURRENCY_Symbols}', "");
    Expect(0, 8399, '\P{-Is_CURRENCY_Symbols}', "");
    Expect(1, 8399, '\P{^-Is_CURRENCY_Symbols}', "");
    Expect(0, 8400, '\p{-Is_CURRENCY_Symbols}', "");
    Expect(1, 8400, '\p{^-Is_CURRENCY_Symbols}', "");
    Expect(1, 8400, '\P{-Is_CURRENCY_Symbols}', "");
    Expect(0, 8400, '\P{^-Is_CURRENCY_Symbols}', "");
    Error('\p{:=-_In_CURRENCY_Symbols}');
    Error('\P{:=-_In_CURRENCY_Symbols}');
    Expect(1, 8399, '\p{incurrencysymbols}', "");
    Expect(0, 8399, '\p{^incurrencysymbols}', "");
    Expect(0, 8399, '\P{incurrencysymbols}', "");
    Expect(1, 8399, '\P{^incurrencysymbols}', "");
    Expect(0, 8400, '\p{incurrencysymbols}', "");
    Expect(1, 8400, '\p{^incurrencysymbols}', "");
    Expect(1, 8400, '\P{incurrencysymbols}', "");
    Expect(0, 8400, '\P{^incurrencysymbols}', "");
    Expect(1, 8399, '\p{- IN_CURRENCY_symbols}', "");
    Expect(0, 8399, '\p{^- IN_CURRENCY_symbols}', "");
    Expect(0, 8399, '\P{- IN_CURRENCY_symbols}', "");
    Expect(1, 8399, '\P{^- IN_CURRENCY_symbols}', "");
    Expect(0, 8400, '\p{- IN_CURRENCY_symbols}', "");
    Expect(1, 8400, '\p{^- IN_CURRENCY_symbols}', "");
    Expect(1, 8400, '\P{- IN_CURRENCY_symbols}', "");
    Expect(0, 8400, '\P{^- IN_CURRENCY_symbols}', "");
    Error('\p{-_CYPRIOT:=}');
    Error('\P{-_CYPRIOT:=}');
    Expect(1, 67647, '\p{cypriot}', "");
    Expect(0, 67647, '\p{^cypriot}', "");
    Expect(0, 67647, '\P{cypriot}', "");
    Expect(1, 67647, '\P{^cypriot}', "");
    Expect(0, 67648, '\p{cypriot}', "");
    Expect(1, 67648, '\p{^cypriot}', "");
    Expect(1, 67648, '\P{cypriot}', "");
    Expect(0, 67648, '\P{^cypriot}', "");
    Expect(1, 67647, '\p{_cypriot}', "");
    Expect(0, 67647, '\p{^_cypriot}', "");
    Expect(0, 67647, '\P{_cypriot}', "");
    Expect(1, 67647, '\P{^_cypriot}', "");
    Expect(0, 67648, '\p{_cypriot}', "");
    Expect(1, 67648, '\p{^_cypriot}', "");
    Expect(1, 67648, '\P{_cypriot}', "");
    Expect(0, 67648, '\P{^_cypriot}', "");
    Error('\p{:= _is_Cypriot}');
    Error('\P{:= _is_Cypriot}');
    Expect(1, 67647, '\p{iscypriot}', "");
    Expect(0, 67647, '\p{^iscypriot}', "");
    Expect(0, 67647, '\P{iscypriot}', "");
    Expect(1, 67647, '\P{^iscypriot}', "");
    Expect(0, 67648, '\p{iscypriot}', "");
    Expect(1, 67648, '\p{^iscypriot}', "");
    Expect(1, 67648, '\P{iscypriot}', "");
    Expect(0, 67648, '\P{^iscypriot}', "");
    Expect(1, 67647, '\p{_Is_Cypriot}', "");
    Expect(0, 67647, '\p{^_Is_Cypriot}', "");
    Expect(0, 67647, '\P{_Is_Cypriot}', "");
    Expect(1, 67647, '\P{^_Is_Cypriot}', "");
    Expect(0, 67648, '\p{_Is_Cypriot}', "");
    Expect(1, 67648, '\p{^_Is_Cypriot}', "");
    Expect(1, 67648, '\P{_Is_Cypriot}', "");
    Expect(0, 67648, '\P{^_Is_Cypriot}', "");
    Error('\p{:=-	Cprt}');
    Error('\P{:=-	Cprt}');
    Expect(1, 67647, '\p{cprt}', "");
    Expect(0, 67647, '\p{^cprt}', "");
    Expect(0, 67647, '\P{cprt}', "");
    Expect(1, 67647, '\P{^cprt}', "");
    Expect(0, 67648, '\p{cprt}', "");
    Expect(1, 67648, '\p{^cprt}', "");
    Expect(1, 67648, '\P{cprt}', "");
    Expect(0, 67648, '\P{^cprt}', "");
    Expect(1, 67647, '\p{ 	Cprt}', "");
    Expect(0, 67647, '\p{^ 	Cprt}', "");
    Expect(0, 67647, '\P{ 	Cprt}', "");
    Expect(1, 67647, '\P{^ 	Cprt}', "");
    Expect(0, 67648, '\p{ 	Cprt}', "");
    Expect(1, 67648, '\p{^ 	Cprt}', "");
    Expect(1, 67648, '\P{ 	Cprt}', "");
    Expect(0, 67648, '\P{^ 	Cprt}', "");
    Error('\p{ Is_Cprt/a/}');
    Error('\P{ Is_Cprt/a/}');
    Expect(1, 67647, '\p{iscprt}', "");
    Expect(0, 67647, '\p{^iscprt}', "");
    Expect(0, 67647, '\P{iscprt}', "");
    Expect(1, 67647, '\P{^iscprt}', "");
    Expect(0, 67648, '\p{iscprt}', "");
    Expect(1, 67648, '\p{^iscprt}', "");
    Expect(1, 67648, '\P{iscprt}', "");
    Expect(0, 67648, '\P{^iscprt}', "");
    Expect(1, 67647, '\p{_Is_cprt}', "");
    Expect(0, 67647, '\p{^_Is_cprt}', "");
    Expect(0, 67647, '\P{_Is_cprt}', "");
    Expect(1, 67647, '\P{^_Is_cprt}', "");
    Expect(0, 67648, '\p{_Is_cprt}', "");
    Expect(1, 67648, '\p{^_Is_cprt}', "");
    Expect(1, 67648, '\P{_Is_cprt}', "");
    Expect(0, 67648, '\P{^_Is_cprt}', "");
    Error('\p{	/a/cypriot_SYLLABARY}');
    Error('\P{	/a/cypriot_SYLLABARY}');
    Expect(1, 67647, '\p{cypriotsyllabary}', "");
    Expect(0, 67647, '\p{^cypriotsyllabary}', "");
    Expect(0, 67647, '\P{cypriotsyllabary}', "");
    Expect(1, 67647, '\P{^cypriotsyllabary}', "");
    Expect(0, 67648, '\p{cypriotsyllabary}', "");
    Expect(1, 67648, '\p{^cypriotsyllabary}', "");
    Expect(1, 67648, '\P{cypriotsyllabary}', "");
    Expect(0, 67648, '\P{^cypriotsyllabary}', "");
    Expect(1, 67647, '\p{__cypriot_SYLLABARY}', "");
    Expect(0, 67647, '\p{^__cypriot_SYLLABARY}', "");
    Expect(0, 67647, '\P{__cypriot_SYLLABARY}', "");
    Expect(1, 67647, '\P{^__cypriot_SYLLABARY}', "");
    Expect(0, 67648, '\p{__cypriot_SYLLABARY}', "");
    Expect(1, 67648, '\p{^__cypriot_SYLLABARY}', "");
    Expect(1, 67648, '\P{__cypriot_SYLLABARY}', "");
    Expect(0, 67648, '\P{^__cypriot_SYLLABARY}', "");
    Error('\p{:= -Is_Cypriot_syllabary}');
    Error('\P{:= -Is_Cypriot_syllabary}');
    Expect(1, 67647, '\p{iscypriotsyllabary}', "");
    Expect(0, 67647, '\p{^iscypriotsyllabary}', "");
    Expect(0, 67647, '\P{iscypriotsyllabary}', "");
    Expect(1, 67647, '\P{^iscypriotsyllabary}', "");
    Expect(0, 67648, '\p{iscypriotsyllabary}', "");
    Expect(1, 67648, '\p{^iscypriotsyllabary}', "");
    Expect(1, 67648, '\P{iscypriotsyllabary}', "");
    Expect(0, 67648, '\P{^iscypriotsyllabary}', "");
    Expect(1, 67647, '\p{_	IS_Cypriot_Syllabary}', "");
    Expect(0, 67647, '\p{^_	IS_Cypriot_Syllabary}', "");
    Expect(0, 67647, '\P{_	IS_Cypriot_Syllabary}', "");
    Expect(1, 67647, '\P{^_	IS_Cypriot_Syllabary}', "");
    Expect(0, 67648, '\p{_	IS_Cypriot_Syllabary}', "");
    Expect(1, 67648, '\p{^_	IS_Cypriot_Syllabary}', "");
    Expect(1, 67648, '\P{_	IS_Cypriot_Syllabary}', "");
    Expect(0, 67648, '\P{^_	IS_Cypriot_Syllabary}', "");
    Error('\p{/a/in_Cypriot_SYLLABARY}');
    Error('\P{/a/in_Cypriot_SYLLABARY}');
    Expect(1, 67647, '\p{incypriotsyllabary}', "");
    Expect(0, 67647, '\p{^incypriotsyllabary}', "");
    Expect(0, 67647, '\P{incypriotsyllabary}', "");
    Expect(1, 67647, '\P{^incypriotsyllabary}', "");
    Expect(0, 67648, '\p{incypriotsyllabary}', "");
    Expect(1, 67648, '\p{^incypriotsyllabary}', "");
    Expect(1, 67648, '\P{incypriotsyllabary}', "");
    Expect(0, 67648, '\P{^incypriotsyllabary}', "");
    Expect(1, 67647, '\p{	in_CYPRIOT_Syllabary}', "");
    Expect(0, 67647, '\p{^	in_CYPRIOT_Syllabary}', "");
    Expect(0, 67647, '\P{	in_CYPRIOT_Syllabary}', "");
    Expect(1, 67647, '\P{^	in_CYPRIOT_Syllabary}', "");
    Expect(0, 67648, '\p{	in_CYPRIOT_Syllabary}', "");
    Expect(1, 67648, '\p{^	in_CYPRIOT_Syllabary}', "");
    Expect(1, 67648, '\P{	in_CYPRIOT_Syllabary}', "");
    Expect(0, 67648, '\P{^	in_CYPRIOT_Syllabary}', "");
    Error('\p{:= _cyrillic}');
    Error('\P{:= _cyrillic}');
    Expect(1, 65071, '\p{cyrillic}', "");
    Expect(0, 65071, '\p{^cyrillic}', "");
    Expect(0, 65071, '\P{cyrillic}', "");
    Expect(1, 65071, '\P{^cyrillic}', "");
    Expect(0, 65072, '\p{cyrillic}', "");
    Expect(1, 65072, '\p{^cyrillic}', "");
    Expect(1, 65072, '\P{cyrillic}', "");
    Expect(0, 65072, '\P{^cyrillic}', "");
    Expect(1, 65071, '\p{CYRILLIC}', "");
    Expect(0, 65071, '\p{^CYRILLIC}', "");
    Expect(0, 65071, '\P{CYRILLIC}', "");
    Expect(1, 65071, '\P{^CYRILLIC}', "");
    Expect(0, 65072, '\p{CYRILLIC}', "");
    Expect(1, 65072, '\p{^CYRILLIC}', "");
    Expect(1, 65072, '\P{CYRILLIC}', "");
    Expect(0, 65072, '\P{^CYRILLIC}', "");
    Error('\p{__IS_Cyrillic:=}');
    Error('\P{__IS_Cyrillic:=}');
    Expect(1, 65071, '\p{iscyrillic}', "");
    Expect(0, 65071, '\p{^iscyrillic}', "");
    Expect(0, 65071, '\P{iscyrillic}', "");
    Expect(1, 65071, '\P{^iscyrillic}', "");
    Expect(0, 65072, '\p{iscyrillic}', "");
    Expect(1, 65072, '\p{^iscyrillic}', "");
    Expect(1, 65072, '\P{iscyrillic}', "");
    Expect(0, 65072, '\P{^iscyrillic}', "");
    Expect(1, 65071, '\p{_ Is_CYRILLIC}', "");
    Expect(0, 65071, '\p{^_ Is_CYRILLIC}', "");
    Expect(0, 65071, '\P{_ Is_CYRILLIC}', "");
    Expect(1, 65071, '\P{^_ Is_CYRILLIC}', "");
    Expect(0, 65072, '\p{_ Is_CYRILLIC}', "");
    Expect(1, 65072, '\p{^_ Is_CYRILLIC}', "");
    Expect(1, 65072, '\P{_ Is_CYRILLIC}', "");
    Expect(0, 65072, '\P{^_ Is_CYRILLIC}', "");
    Error('\p{_/a/CYRL}');
    Error('\P{_/a/CYRL}');
    Expect(1, 65071, '\p{cyrl}', "");
    Expect(0, 65071, '\p{^cyrl}', "");
    Expect(0, 65071, '\P{cyrl}', "");
    Expect(1, 65071, '\P{^cyrl}', "");
    Expect(0, 65072, '\p{cyrl}', "");
    Expect(1, 65072, '\p{^cyrl}', "");
    Expect(1, 65072, '\P{cyrl}', "");
    Expect(0, 65072, '\P{^cyrl}', "");
    Expect(1, 65071, '\p{ 	CYRL}', "");
    Expect(0, 65071, '\p{^ 	CYRL}', "");
    Expect(0, 65071, '\P{ 	CYRL}', "");
    Expect(1, 65071, '\P{^ 	CYRL}', "");
    Expect(0, 65072, '\p{ 	CYRL}', "");
    Expect(1, 65072, '\p{^ 	CYRL}', "");
    Expect(1, 65072, '\P{ 	CYRL}', "");
    Expect(0, 65072, '\P{^ 	CYRL}', "");
    Error('\p{	/a/is_cyrl}');
    Error('\P{	/a/is_cyrl}');
    Expect(1, 65071, '\p{iscyrl}', "");
    Expect(0, 65071, '\p{^iscyrl}', "");
    Expect(0, 65071, '\P{iscyrl}', "");
    Expect(1, 65071, '\P{^iscyrl}', "");
    Expect(0, 65072, '\p{iscyrl}', "");
    Expect(1, 65072, '\p{^iscyrl}', "");
    Expect(1, 65072, '\P{iscyrl}', "");
    Expect(0, 65072, '\P{^iscyrl}', "");
    Expect(1, 65071, '\p{_Is_CYRL}', "");
    Expect(0, 65071, '\p{^_Is_CYRL}', "");
    Expect(0, 65071, '\P{_Is_CYRL}', "");
    Expect(1, 65071, '\P{^_Is_CYRL}', "");
    Expect(0, 65072, '\p{_Is_CYRL}', "");
    Expect(1, 65072, '\p{^_Is_CYRL}', "");
    Expect(1, 65072, '\P{_Is_CYRL}', "");
    Expect(0, 65072, '\P{^_Is_CYRL}', "");
    Error('\p{/a/cyrillic_EXTENDED_a}');
    Error('\P{/a/cyrillic_EXTENDED_a}');
    Expect(1, 11775, '\p{cyrillicextendeda}', "");
    Expect(0, 11775, '\p{^cyrillicextendeda}', "");
    Expect(0, 11775, '\P{cyrillicextendeda}', "");
    Expect(1, 11775, '\P{^cyrillicextendeda}', "");
    Expect(0, 11776, '\p{cyrillicextendeda}', "");
    Expect(1, 11776, '\p{^cyrillicextendeda}', "");
    Expect(1, 11776, '\P{cyrillicextendeda}', "");
    Expect(0, 11776, '\P{^cyrillicextendeda}', "");
    Expect(1, 11775, '\p{-_cyrillic_EXTENDED_A}', "");
    Expect(0, 11775, '\p{^-_cyrillic_EXTENDED_A}', "");
    Expect(0, 11775, '\P{-_cyrillic_EXTENDED_A}', "");
    Expect(1, 11775, '\P{^-_cyrillic_EXTENDED_A}', "");
    Expect(0, 11776, '\p{-_cyrillic_EXTENDED_A}', "");
    Expect(1, 11776, '\p{^-_cyrillic_EXTENDED_A}', "");
    Expect(1, 11776, '\P{-_cyrillic_EXTENDED_A}', "");
    Expect(0, 11776, '\P{^-_cyrillic_EXTENDED_A}', "");
    Error('\p{-Is_Cyrillic_Extended_A/a/}');
    Error('\P{-Is_Cyrillic_Extended_A/a/}');
    Expect(1, 11775, '\p{iscyrillicextendeda}', "");
    Expect(0, 11775, '\p{^iscyrillicextendeda}', "");
    Expect(0, 11775, '\P{iscyrillicextendeda}', "");
    Expect(1, 11775, '\P{^iscyrillicextendeda}', "");
    Expect(0, 11776, '\p{iscyrillicextendeda}', "");
    Expect(1, 11776, '\p{^iscyrillicextendeda}', "");
    Expect(1, 11776, '\P{iscyrillicextendeda}', "");
    Expect(0, 11776, '\P{^iscyrillicextendeda}', "");
    Expect(1, 11775, '\p{  IS_cyrillic_extended_a}', "");
    Expect(0, 11775, '\p{^  IS_cyrillic_extended_a}', "");
    Expect(0, 11775, '\P{  IS_cyrillic_extended_a}', "");
    Expect(1, 11775, '\P{^  IS_cyrillic_extended_a}', "");
    Expect(0, 11776, '\p{  IS_cyrillic_extended_a}', "");
    Expect(1, 11776, '\p{^  IS_cyrillic_extended_a}', "");
    Expect(1, 11776, '\P{  IS_cyrillic_extended_a}', "");
    Expect(0, 11776, '\P{^  IS_cyrillic_extended_a}', "");
    Error('\p{ /a/In_CYRILLIC_extended_a}');
    Error('\P{ /a/In_CYRILLIC_extended_a}');
    Expect(1, 11775, '\p{incyrillicextendeda}', "");
    Expect(0, 11775, '\p{^incyrillicextendeda}', "");
    Expect(0, 11775, '\P{incyrillicextendeda}', "");
    Expect(1, 11775, '\P{^incyrillicextendeda}', "");
    Expect(0, 11776, '\p{incyrillicextendeda}', "");
    Expect(1, 11776, '\p{^incyrillicextendeda}', "");
    Expect(1, 11776, '\P{incyrillicextendeda}', "");
    Expect(0, 11776, '\P{^incyrillicextendeda}', "");
    Expect(1, 11775, '\p{	in_Cyrillic_EXTENDED_A}', "");
    Expect(0, 11775, '\p{^	in_Cyrillic_EXTENDED_A}', "");
    Expect(0, 11775, '\P{	in_Cyrillic_EXTENDED_A}', "");
    Expect(1, 11775, '\P{^	in_Cyrillic_EXTENDED_A}', "");
    Expect(0, 11776, '\p{	in_Cyrillic_EXTENDED_A}', "");
    Expect(1, 11776, '\p{^	in_Cyrillic_EXTENDED_A}', "");
    Expect(1, 11776, '\P{	in_Cyrillic_EXTENDED_A}', "");
    Expect(0, 11776, '\P{^	in_Cyrillic_EXTENDED_A}', "");
    Error('\p{/a/-CYRILLIC_Ext_A}');
    Error('\P{/a/-CYRILLIC_Ext_A}');
    Expect(1, 11775, '\p{cyrillicexta}', "");
    Expect(0, 11775, '\p{^cyrillicexta}', "");
    Expect(0, 11775, '\P{cyrillicexta}', "");
    Expect(1, 11775, '\P{^cyrillicexta}', "");
    Expect(0, 11776, '\p{cyrillicexta}', "");
    Expect(1, 11776, '\p{^cyrillicexta}', "");
    Expect(1, 11776, '\P{cyrillicexta}', "");
    Expect(0, 11776, '\P{^cyrillicexta}', "");
    Expect(1, 11775, '\p{	Cyrillic_EXT_A}', "");
    Expect(0, 11775, '\p{^	Cyrillic_EXT_A}', "");
    Expect(0, 11775, '\P{	Cyrillic_EXT_A}', "");
    Expect(1, 11775, '\P{^	Cyrillic_EXT_A}', "");
    Expect(0, 11776, '\p{	Cyrillic_EXT_A}', "");
    Expect(1, 11776, '\p{^	Cyrillic_EXT_A}', "");
    Expect(1, 11776, '\P{	Cyrillic_EXT_A}', "");
    Expect(0, 11776, '\P{^	Cyrillic_EXT_A}', "");
    Error('\p{- Is_CYRILLIC_Ext_A/a/}');
    Error('\P{- Is_CYRILLIC_Ext_A/a/}');
    Expect(1, 11775, '\p{iscyrillicexta}', "");
    Expect(0, 11775, '\p{^iscyrillicexta}', "");
    Expect(0, 11775, '\P{iscyrillicexta}', "");
    Expect(1, 11775, '\P{^iscyrillicexta}', "");
    Expect(0, 11776, '\p{iscyrillicexta}', "");
    Expect(1, 11776, '\p{^iscyrillicexta}', "");
    Expect(1, 11776, '\P{iscyrillicexta}', "");
    Expect(0, 11776, '\P{^iscyrillicexta}', "");
    Expect(1, 11775, '\p{-IS_cyrillic_EXT_A}', "");
    Expect(0, 11775, '\p{^-IS_cyrillic_EXT_A}', "");
    Expect(0, 11775, '\P{-IS_cyrillic_EXT_A}', "");
    Expect(1, 11775, '\P{^-IS_cyrillic_EXT_A}', "");
    Expect(0, 11776, '\p{-IS_cyrillic_EXT_A}', "");
    Expect(1, 11776, '\p{^-IS_cyrillic_EXT_A}', "");
    Expect(1, 11776, '\P{-IS_cyrillic_EXT_A}', "");
    Expect(0, 11776, '\P{^-IS_cyrillic_EXT_A}', "");
    Error('\p{	/a/In_cyrillic_Ext_A}');
    Error('\P{	/a/In_cyrillic_Ext_A}');
    Expect(1, 11775, '\p{incyrillicexta}', "");
    Expect(0, 11775, '\p{^incyrillicexta}', "");
    Expect(0, 11775, '\P{incyrillicexta}', "");
    Expect(1, 11775, '\P{^incyrillicexta}', "");
    Expect(0, 11776, '\p{incyrillicexta}', "");
    Expect(1, 11776, '\p{^incyrillicexta}', "");
    Expect(1, 11776, '\P{incyrillicexta}', "");
    Expect(0, 11776, '\P{^incyrillicexta}', "");
    Expect(1, 11775, '\p{--In_CYRILLIC_Ext_A}', "");
    Expect(0, 11775, '\p{^--In_CYRILLIC_Ext_A}', "");
    Expect(0, 11775, '\P{--In_CYRILLIC_Ext_A}', "");
    Expect(1, 11775, '\P{^--In_CYRILLIC_Ext_A}', "");
    Expect(0, 11776, '\p{--In_CYRILLIC_Ext_A}', "");
    Expect(1, 11776, '\p{^--In_CYRILLIC_Ext_A}', "");
    Expect(1, 11776, '\P{--In_CYRILLIC_Ext_A}', "");
    Expect(0, 11776, '\P{^--In_CYRILLIC_Ext_A}', "");
    Error('\p{/a/Cyrillic_Extended_b}');
    Error('\P{/a/Cyrillic_Extended_b}');
    Expect(1, 42655, '\p{cyrillicextendedb}', "");
    Expect(0, 42655, '\p{^cyrillicextendedb}', "");
    Expect(0, 42655, '\P{cyrillicextendedb}', "");
    Expect(1, 42655, '\P{^cyrillicextendedb}', "");
    Expect(0, 42656, '\p{cyrillicextendedb}', "");
    Expect(1, 42656, '\p{^cyrillicextendedb}', "");
    Expect(1, 42656, '\P{cyrillicextendedb}', "");
    Expect(0, 42656, '\P{^cyrillicextendedb}', "");
    Expect(1, 42655, '\p{ Cyrillic_extended_B}', "");
    Expect(0, 42655, '\p{^ Cyrillic_extended_B}', "");
    Expect(0, 42655, '\P{ Cyrillic_extended_B}', "");
    Expect(1, 42655, '\P{^ Cyrillic_extended_B}', "");
    Expect(0, 42656, '\p{ Cyrillic_extended_B}', "");
    Expect(1, 42656, '\p{^ Cyrillic_extended_B}', "");
    Expect(1, 42656, '\P{ Cyrillic_extended_B}', "");
    Expect(0, 42656, '\P{^ Cyrillic_extended_B}', "");
    Error('\p{	-is_Cyrillic_Extended_b/a/}');
    Error('\P{	-is_Cyrillic_Extended_b/a/}');
    Expect(1, 42655, '\p{iscyrillicextendedb}', "");
    Expect(0, 42655, '\p{^iscyrillicextendedb}', "");
    Expect(0, 42655, '\P{iscyrillicextendedb}', "");
    Expect(1, 42655, '\P{^iscyrillicextendedb}', "");
    Expect(0, 42656, '\p{iscyrillicextendedb}', "");
    Expect(1, 42656, '\p{^iscyrillicextendedb}', "");
    Expect(1, 42656, '\P{iscyrillicextendedb}', "");
    Expect(0, 42656, '\P{^iscyrillicextendedb}', "");
    Expect(1, 42655, '\p{_Is_cyrillic_Extended_B}', "");
    Expect(0, 42655, '\p{^_Is_cyrillic_Extended_B}', "");
    Expect(0, 42655, '\P{_Is_cyrillic_Extended_B}', "");
    Expect(1, 42655, '\P{^_Is_cyrillic_Extended_B}', "");
    Expect(0, 42656, '\p{_Is_cyrillic_Extended_B}', "");
    Expect(1, 42656, '\p{^_Is_cyrillic_Extended_B}', "");
    Expect(1, 42656, '\P{_Is_cyrillic_Extended_B}', "");
    Expect(0, 42656, '\P{^_Is_cyrillic_Extended_B}', "");
    Error('\p{:=-In_CYRILLIC_extended_B}');
    Error('\P{:=-In_CYRILLIC_extended_B}');
    Expect(1, 42655, '\p{incyrillicextendedb}', "");
    Expect(0, 42655, '\p{^incyrillicextendedb}', "");
    Expect(0, 42655, '\P{incyrillicextendedb}', "");
    Expect(1, 42655, '\P{^incyrillicextendedb}', "");
    Expect(0, 42656, '\p{incyrillicextendedb}', "");
    Expect(1, 42656, '\p{^incyrillicextendedb}', "");
    Expect(1, 42656, '\P{incyrillicextendedb}', "");
    Expect(0, 42656, '\P{^incyrillicextendedb}', "");
    Expect(1, 42655, '\p{_-in_CYRILLIC_EXTENDED_b}', "");
    Expect(0, 42655, '\p{^_-in_CYRILLIC_EXTENDED_b}', "");
    Expect(0, 42655, '\P{_-in_CYRILLIC_EXTENDED_b}', "");
    Expect(1, 42655, '\P{^_-in_CYRILLIC_EXTENDED_b}', "");
    Expect(0, 42656, '\p{_-in_CYRILLIC_EXTENDED_b}', "");
    Expect(1, 42656, '\p{^_-in_CYRILLIC_EXTENDED_b}', "");
    Expect(1, 42656, '\P{_-in_CYRILLIC_EXTENDED_b}', "");
    Expect(0, 42656, '\P{^_-in_CYRILLIC_EXTENDED_b}', "");
    Error('\p{  CYRILLIC_ext_B:=}');
    Error('\P{  CYRILLIC_ext_B:=}');
    Expect(1, 42655, '\p{cyrillicextb}', "");
    Expect(0, 42655, '\p{^cyrillicextb}', "");
    Expect(0, 42655, '\P{cyrillicextb}', "");
    Expect(1, 42655, '\P{^cyrillicextb}', "");
    Expect(0, 42656, '\p{cyrillicextb}', "");
    Expect(1, 42656, '\p{^cyrillicextb}', "");
    Expect(1, 42656, '\P{cyrillicextb}', "");
    Expect(0, 42656, '\P{^cyrillicextb}', "");
    Expect(1, 42655, '\p{-cyrillic_Ext_b}', "");
    Expect(0, 42655, '\p{^-cyrillic_Ext_b}', "");
    Expect(0, 42655, '\P{-cyrillic_Ext_b}', "");
    Expect(1, 42655, '\P{^-cyrillic_Ext_b}', "");
    Expect(0, 42656, '\p{-cyrillic_Ext_b}', "");
    Expect(1, 42656, '\p{^-cyrillic_Ext_b}', "");
    Expect(1, 42656, '\P{-cyrillic_Ext_b}', "");
    Expect(0, 42656, '\P{^-cyrillic_Ext_b}', "");
    Error('\p{	:=is_Cyrillic_ext_B}');
    Error('\P{	:=is_Cyrillic_ext_B}');
    Expect(1, 42655, '\p{iscyrillicextb}', "");
    Expect(0, 42655, '\p{^iscyrillicextb}', "");
    Expect(0, 42655, '\P{iscyrillicextb}', "");
    Expect(1, 42655, '\P{^iscyrillicextb}', "");
    Expect(0, 42656, '\p{iscyrillicextb}', "");
    Expect(1, 42656, '\p{^iscyrillicextb}', "");
    Expect(1, 42656, '\P{iscyrillicextb}', "");
    Expect(0, 42656, '\P{^iscyrillicextb}', "");
    Expect(1, 42655, '\p{_IS_cyrillic_Ext_B}', "");
    Expect(0, 42655, '\p{^_IS_cyrillic_Ext_B}', "");
    Expect(0, 42655, '\P{_IS_cyrillic_Ext_B}', "");
    Expect(1, 42655, '\P{^_IS_cyrillic_Ext_B}', "");
    Expect(0, 42656, '\p{_IS_cyrillic_Ext_B}', "");
    Expect(1, 42656, '\p{^_IS_cyrillic_Ext_B}', "");
    Expect(1, 42656, '\P{_IS_cyrillic_Ext_B}', "");
    Expect(0, 42656, '\P{^_IS_cyrillic_Ext_B}', "");
    Error('\p{/a/_In_Cyrillic_ext_B}');
    Error('\P{/a/_In_Cyrillic_ext_B}');
    Expect(1, 42655, '\p{incyrillicextb}', "");
    Expect(0, 42655, '\p{^incyrillicextb}', "");
    Expect(0, 42655, '\P{incyrillicextb}', "");
    Expect(1, 42655, '\P{^incyrillicextb}', "");
    Expect(0, 42656, '\p{incyrillicextb}', "");
    Expect(1, 42656, '\p{^incyrillicextb}', "");
    Expect(1, 42656, '\P{incyrillicextb}', "");
    Expect(0, 42656, '\P{^incyrillicextb}', "");
    Expect(1, 42655, '\p{ In_Cyrillic_EXT_B}', "");
    Expect(0, 42655, '\p{^ In_Cyrillic_EXT_B}', "");
    Expect(0, 42655, '\P{ In_Cyrillic_EXT_B}', "");
    Expect(1, 42655, '\P{^ In_Cyrillic_EXT_B}', "");
    Expect(0, 42656, '\p{ In_Cyrillic_EXT_B}', "");
    Expect(1, 42656, '\p{^ In_Cyrillic_EXT_B}', "");
    Expect(1, 42656, '\P{ In_Cyrillic_EXT_B}', "");
    Expect(0, 42656, '\P{^ In_Cyrillic_EXT_B}', "");
    Error('\p{- Cyrillic_extended_C/a/}');
    Error('\P{- Cyrillic_extended_C/a/}');
    Expect(1, 7311, '\p{cyrillicextendedc}', "");
    Expect(0, 7311, '\p{^cyrillicextendedc}', "");
    Expect(0, 7311, '\P{cyrillicextendedc}', "");
    Expect(1, 7311, '\P{^cyrillicextendedc}', "");
    Expect(0, 7312, '\p{cyrillicextendedc}', "");
    Expect(1, 7312, '\p{^cyrillicextendedc}', "");
    Expect(1, 7312, '\P{cyrillicextendedc}', "");
    Expect(0, 7312, '\P{^cyrillicextendedc}', "");
    Expect(1, 7311, '\p{	_Cyrillic_Extended_c}', "");
    Expect(0, 7311, '\p{^	_Cyrillic_Extended_c}', "");
    Expect(0, 7311, '\P{	_Cyrillic_Extended_c}', "");
    Expect(1, 7311, '\P{^	_Cyrillic_Extended_c}', "");
    Expect(0, 7312, '\p{	_Cyrillic_Extended_c}', "");
    Expect(1, 7312, '\p{^	_Cyrillic_Extended_c}', "");
    Expect(1, 7312, '\P{	_Cyrillic_Extended_c}', "");
    Expect(0, 7312, '\P{^	_Cyrillic_Extended_c}', "");
    Error('\p{/a/_Is_Cyrillic_extended_c}');
    Error('\P{/a/_Is_Cyrillic_extended_c}');
    Expect(1, 7311, '\p{iscyrillicextendedc}', "");
    Expect(0, 7311, '\p{^iscyrillicextendedc}', "");
    Expect(0, 7311, '\P{iscyrillicextendedc}', "");
    Expect(1, 7311, '\P{^iscyrillicextendedc}', "");
    Expect(0, 7312, '\p{iscyrillicextendedc}', "");
    Expect(1, 7312, '\p{^iscyrillicextendedc}', "");
    Expect(1, 7312, '\P{iscyrillicextendedc}', "");
    Expect(0, 7312, '\P{^iscyrillicextendedc}', "");
    Expect(1, 7311, '\p{  is_CYRILLIC_EXTENDED_c}', "");
    Expect(0, 7311, '\p{^  is_CYRILLIC_EXTENDED_c}', "");
    Expect(0, 7311, '\P{  is_CYRILLIC_EXTENDED_c}', "");
    Expect(1, 7311, '\P{^  is_CYRILLIC_EXTENDED_c}', "");
    Expect(0, 7312, '\p{  is_CYRILLIC_EXTENDED_c}', "");
    Expect(1, 7312, '\p{^  is_CYRILLIC_EXTENDED_c}', "");
    Expect(1, 7312, '\P{  is_CYRILLIC_EXTENDED_c}', "");
    Expect(0, 7312, '\P{^  is_CYRILLIC_EXTENDED_c}', "");
    Error('\p{	:=in_CYRILLIC_Extended_C}');
    Error('\P{	:=in_CYRILLIC_Extended_C}');
    Expect(1, 7311, '\p{incyrillicextendedc}', "");
    Expect(0, 7311, '\p{^incyrillicextendedc}', "");
    Expect(0, 7311, '\P{incyrillicextendedc}', "");
    Expect(1, 7311, '\P{^incyrillicextendedc}', "");
    Expect(0, 7312, '\p{incyrillicextendedc}', "");
    Expect(1, 7312, '\p{^incyrillicextendedc}', "");
    Expect(1, 7312, '\P{incyrillicextendedc}', "");
    Expect(0, 7312, '\P{^incyrillicextendedc}', "");
    Expect(1, 7311, '\p{in_Cyrillic_EXTENDED_C}', "");
    Expect(0, 7311, '\p{^in_Cyrillic_EXTENDED_C}', "");
    Expect(0, 7311, '\P{in_Cyrillic_EXTENDED_C}', "");
    Expect(1, 7311, '\P{^in_Cyrillic_EXTENDED_C}', "");
    Expect(0, 7312, '\p{in_Cyrillic_EXTENDED_C}', "");
    Expect(1, 7312, '\p{^in_Cyrillic_EXTENDED_C}', "");
    Expect(1, 7312, '\P{in_Cyrillic_EXTENDED_C}', "");
    Expect(0, 7312, '\P{^in_Cyrillic_EXTENDED_C}', "");
    Error('\p{	Cyrillic_Ext_C/a/}');
    Error('\P{	Cyrillic_Ext_C/a/}');
    Expect(1, 7311, '\p{cyrillicextc}', "");
    Expect(0, 7311, '\p{^cyrillicextc}', "");
    Expect(0, 7311, '\P{cyrillicextc}', "");
    Expect(1, 7311, '\P{^cyrillicextc}', "");
    Expect(0, 7312, '\p{cyrillicextc}', "");
    Expect(1, 7312, '\p{^cyrillicextc}', "");
    Expect(1, 7312, '\P{cyrillicextc}', "");
    Expect(0, 7312, '\P{^cyrillicextc}', "");
    Expect(1, 7311, '\p{	_Cyrillic_EXT_c}', "");
    Expect(0, 7311, '\p{^	_Cyrillic_EXT_c}', "");
    Expect(0, 7311, '\P{	_Cyrillic_EXT_c}', "");
    Expect(1, 7311, '\P{^	_Cyrillic_EXT_c}', "");
    Expect(0, 7312, '\p{	_Cyrillic_EXT_c}', "");
    Expect(1, 7312, '\p{^	_Cyrillic_EXT_c}', "");
    Expect(1, 7312, '\P{	_Cyrillic_EXT_c}', "");
    Expect(0, 7312, '\P{^	_Cyrillic_EXT_c}', "");
    Error('\p{:=-Is_cyrillic_Ext_C}');
    Error('\P{:=-Is_cyrillic_Ext_C}');
    Expect(1, 7311, '\p{iscyrillicextc}', "");
    Expect(0, 7311, '\p{^iscyrillicextc}', "");
    Expect(0, 7311, '\P{iscyrillicextc}', "");
    Expect(1, 7311, '\P{^iscyrillicextc}', "");
    Expect(0, 7312, '\p{iscyrillicextc}', "");
    Expect(1, 7312, '\p{^iscyrillicextc}', "");
    Expect(1, 7312, '\P{iscyrillicextc}', "");
    Expect(0, 7312, '\P{^iscyrillicextc}', "");
    Expect(1, 7311, '\p{	 Is_Cyrillic_Ext_C}', "");
    Expect(0, 7311, '\p{^	 Is_Cyrillic_Ext_C}', "");
    Expect(0, 7311, '\P{	 Is_Cyrillic_Ext_C}', "");
    Expect(1, 7311, '\P{^	 Is_Cyrillic_Ext_C}', "");
    Expect(0, 7312, '\p{	 Is_Cyrillic_Ext_C}', "");
    Expect(1, 7312, '\p{^	 Is_Cyrillic_Ext_C}', "");
    Expect(1, 7312, '\P{	 Is_Cyrillic_Ext_C}', "");
    Expect(0, 7312, '\P{^	 Is_Cyrillic_Ext_C}', "");
    Error('\p{/a/_-in_Cyrillic_ext_C}');
    Error('\P{/a/_-in_Cyrillic_ext_C}');
    Expect(1, 7311, '\p{incyrillicextc}', "");
    Expect(0, 7311, '\p{^incyrillicextc}', "");
    Expect(0, 7311, '\P{incyrillicextc}', "");
    Expect(1, 7311, '\P{^incyrillicextc}', "");
    Expect(0, 7312, '\p{incyrillicextc}', "");
    Expect(1, 7312, '\p{^incyrillicextc}', "");
    Expect(1, 7312, '\P{incyrillicextc}', "");
    Expect(0, 7312, '\P{^incyrillicextc}', "");
    Expect(1, 7311, '\p{__in_CYRILLIC_Ext_C}', "");
    Expect(0, 7311, '\p{^__in_CYRILLIC_Ext_C}', "");
    Expect(0, 7311, '\P{__in_CYRILLIC_Ext_C}', "");
    Expect(1, 7311, '\P{^__in_CYRILLIC_Ext_C}', "");
    Expect(0, 7312, '\p{__in_CYRILLIC_Ext_C}', "");
    Expect(1, 7312, '\p{^__in_CYRILLIC_Ext_C}', "");
    Expect(1, 7312, '\P{__in_CYRILLIC_Ext_C}', "");
    Expect(0, 7312, '\P{^__in_CYRILLIC_Ext_C}', "");
    Error('\p{_/a/Cyrillic_Supplement}');
    Error('\P{_/a/Cyrillic_Supplement}');
    Expect(1, 1327, '\p{cyrillicsupplement}', "");
    Expect(0, 1327, '\p{^cyrillicsupplement}', "");
    Expect(0, 1327, '\P{cyrillicsupplement}', "");
    Expect(1, 1327, '\P{^cyrillicsupplement}', "");
    Expect(0, 1328, '\p{cyrillicsupplement}', "");
    Expect(1, 1328, '\p{^cyrillicsupplement}', "");
    Expect(1, 1328, '\P{cyrillicsupplement}', "");
    Expect(0, 1328, '\P{^cyrillicsupplement}', "");
    Expect(1, 1327, '\p{_ Cyrillic_Supplement}', "");
    Expect(0, 1327, '\p{^_ Cyrillic_Supplement}', "");
    Expect(0, 1327, '\P{_ Cyrillic_Supplement}', "");
    Expect(1, 1327, '\P{^_ Cyrillic_Supplement}', "");
    Expect(0, 1328, '\p{_ Cyrillic_Supplement}', "");
    Expect(1, 1328, '\p{^_ Cyrillic_Supplement}', "");
    Expect(1, 1328, '\P{_ Cyrillic_Supplement}', "");
    Expect(0, 1328, '\P{^_ Cyrillic_Supplement}', "");
    Error('\p{/a/		IS_Cyrillic_Supplement}');
    Error('\P{/a/		IS_Cyrillic_Supplement}');
    Expect(1, 1327, '\p{iscyrillicsupplement}', "");
    Expect(0, 1327, '\p{^iscyrillicsupplement}', "");
    Expect(0, 1327, '\P{iscyrillicsupplement}', "");
    Expect(1, 1327, '\P{^iscyrillicsupplement}', "");
    Expect(0, 1328, '\p{iscyrillicsupplement}', "");
    Expect(1, 1328, '\p{^iscyrillicsupplement}', "");
    Expect(1, 1328, '\P{iscyrillicsupplement}', "");
    Expect(0, 1328, '\P{^iscyrillicsupplement}', "");
    Expect(1, 1327, '\p{__IS_Cyrillic_Supplement}', "");
    Expect(0, 1327, '\p{^__IS_Cyrillic_Supplement}', "");
    Expect(0, 1327, '\P{__IS_Cyrillic_Supplement}', "");
    Expect(1, 1327, '\P{^__IS_Cyrillic_Supplement}', "");
    Expect(0, 1328, '\p{__IS_Cyrillic_Supplement}', "");
    Expect(1, 1328, '\p{^__IS_Cyrillic_Supplement}', "");
    Expect(1, 1328, '\P{__IS_Cyrillic_Supplement}', "");
    Expect(0, 1328, '\P{^__IS_Cyrillic_Supplement}', "");
    Error('\p{_In_CYRILLIC_Supplement/a/}');
    Error('\P{_In_CYRILLIC_Supplement/a/}');
    Expect(1, 1327, '\p{incyrillicsupplement}', "");
    Expect(0, 1327, '\p{^incyrillicsupplement}', "");
    Expect(0, 1327, '\P{incyrillicsupplement}', "");
    Expect(1, 1327, '\P{^incyrillicsupplement}', "");
    Expect(0, 1328, '\p{incyrillicsupplement}', "");
    Expect(1, 1328, '\p{^incyrillicsupplement}', "");
    Expect(1, 1328, '\P{incyrillicsupplement}', "");
    Expect(0, 1328, '\P{^incyrillicsupplement}', "");
    Expect(1, 1327, '\p{ 	in_CYRILLIC_SUPPLEMENT}', "");
    Expect(0, 1327, '\p{^ 	in_CYRILLIC_SUPPLEMENT}', "");
    Expect(0, 1327, '\P{ 	in_CYRILLIC_SUPPLEMENT}', "");
    Expect(1, 1327, '\P{^ 	in_CYRILLIC_SUPPLEMENT}', "");
    Expect(0, 1328, '\p{ 	in_CYRILLIC_SUPPLEMENT}', "");
    Expect(1, 1328, '\p{^ 	in_CYRILLIC_SUPPLEMENT}', "");
    Expect(1, 1328, '\P{ 	in_CYRILLIC_SUPPLEMENT}', "");
    Expect(0, 1328, '\P{^ 	in_CYRILLIC_SUPPLEMENT}', "");
    Error('\p{/a/_ cyrillic_SUP}');
    Error('\P{/a/_ cyrillic_SUP}');
    Expect(1, 1327, '\p{cyrillicsup}', "");
    Expect(0, 1327, '\p{^cyrillicsup}', "");
    Expect(0, 1327, '\P{cyrillicsup}', "");
    Expect(1, 1327, '\P{^cyrillicsup}', "");
    Expect(0, 1328, '\p{cyrillicsup}', "");
    Expect(1, 1328, '\p{^cyrillicsup}', "");
    Expect(1, 1328, '\P{cyrillicsup}', "");
    Expect(0, 1328, '\P{^cyrillicsup}', "");
    Expect(1, 1327, '\p{ -CYRILLIC_sup}', "");
    Expect(0, 1327, '\p{^ -CYRILLIC_sup}', "");
    Expect(0, 1327, '\P{ -CYRILLIC_sup}', "");
    Expect(1, 1327, '\P{^ -CYRILLIC_sup}', "");
    Expect(0, 1328, '\p{ -CYRILLIC_sup}', "");
    Expect(1, 1328, '\p{^ -CYRILLIC_sup}', "");
    Expect(1, 1328, '\P{ -CYRILLIC_sup}', "");
    Expect(0, 1328, '\P{^ -CYRILLIC_sup}', "");
    Error('\p{_/a/is_Cyrillic_SUP}');
    Error('\P{_/a/is_Cyrillic_SUP}');
    Expect(1, 1327, '\p{iscyrillicsup}', "");
    Expect(0, 1327, '\p{^iscyrillicsup}', "");
    Expect(0, 1327, '\P{iscyrillicsup}', "");
    Expect(1, 1327, '\P{^iscyrillicsup}', "");
    Expect(0, 1328, '\p{iscyrillicsup}', "");
    Expect(1, 1328, '\p{^iscyrillicsup}', "");
    Expect(1, 1328, '\P{iscyrillicsup}', "");
    Expect(0, 1328, '\P{^iscyrillicsup}', "");
    Expect(1, 1327, '\p{-_is_Cyrillic_sup}', "");
    Expect(0, 1327, '\p{^-_is_Cyrillic_sup}', "");
    Expect(0, 1327, '\P{-_is_Cyrillic_sup}', "");
    Expect(1, 1327, '\P{^-_is_Cyrillic_sup}', "");
    Expect(0, 1328, '\p{-_is_Cyrillic_sup}', "");
    Expect(1, 1328, '\p{^-_is_Cyrillic_sup}', "");
    Expect(1, 1328, '\P{-_is_Cyrillic_sup}', "");
    Expect(0, 1328, '\P{^-_is_Cyrillic_sup}', "");
    Error('\p{:=-_In_cyrillic_Sup}');
    Error('\P{:=-_In_cyrillic_Sup}');
    Expect(1, 1327, '\p{incyrillicsup}', "");
    Expect(0, 1327, '\p{^incyrillicsup}', "");
    Expect(0, 1327, '\P{incyrillicsup}', "");
    Expect(1, 1327, '\P{^incyrillicsup}', "");
    Expect(0, 1328, '\p{incyrillicsup}', "");
    Expect(1, 1328, '\p{^incyrillicsup}', "");
    Expect(1, 1328, '\P{incyrillicsup}', "");
    Expect(0, 1328, '\P{^incyrillicsup}', "");
    Expect(1, 1327, '\p{	IN_CYRILLIC_Sup}', "");
    Expect(0, 1327, '\p{^	IN_CYRILLIC_Sup}', "");
    Expect(0, 1327, '\P{	IN_CYRILLIC_Sup}', "");
    Expect(1, 1327, '\P{^	IN_CYRILLIC_Sup}', "");
    Expect(0, 1328, '\p{	IN_CYRILLIC_Sup}', "");
    Expect(1, 1328, '\p{^	IN_CYRILLIC_Sup}', "");
    Expect(1, 1328, '\P{	IN_CYRILLIC_Sup}', "");
    Expect(0, 1328, '\P{^	IN_CYRILLIC_Sup}', "");
    Error('\p{:= CYRILLIC_supplementary}');
    Error('\P{:= CYRILLIC_supplementary}');
    Expect(1, 1327, '\p{cyrillicsupplementary}', "");
    Expect(0, 1327, '\p{^cyrillicsupplementary}', "");
    Expect(0, 1327, '\P{cyrillicsupplementary}', "");
    Expect(1, 1327, '\P{^cyrillicsupplementary}', "");
    Expect(0, 1328, '\p{cyrillicsupplementary}', "");
    Expect(1, 1328, '\p{^cyrillicsupplementary}', "");
    Expect(1, 1328, '\P{cyrillicsupplementary}', "");
    Expect(0, 1328, '\P{^cyrillicsupplementary}', "");
    Expect(1, 1327, '\p{	_Cyrillic_Supplementary}', "");
    Expect(0, 1327, '\p{^	_Cyrillic_Supplementary}', "");
    Expect(0, 1327, '\P{	_Cyrillic_Supplementary}', "");
    Expect(1, 1327, '\P{^	_Cyrillic_Supplementary}', "");
    Expect(0, 1328, '\p{	_Cyrillic_Supplementary}', "");
    Expect(1, 1328, '\p{^	_Cyrillic_Supplementary}', "");
    Expect(1, 1328, '\P{	_Cyrillic_Supplementary}', "");
    Expect(0, 1328, '\P{^	_Cyrillic_Supplementary}', "");
    Error('\p{  IS_Cyrillic_Supplementary:=}');
    Error('\P{  IS_Cyrillic_Supplementary:=}');
    Expect(1, 1327, '\p{iscyrillicsupplementary}', "");
    Expect(0, 1327, '\p{^iscyrillicsupplementary}', "");
    Expect(0, 1327, '\P{iscyrillicsupplementary}', "");
    Expect(1, 1327, '\P{^iscyrillicsupplementary}', "");
    Expect(0, 1328, '\p{iscyrillicsupplementary}', "");
    Expect(1, 1328, '\p{^iscyrillicsupplementary}', "");
    Expect(1, 1328, '\P{iscyrillicsupplementary}', "");
    Expect(0, 1328, '\P{^iscyrillicsupplementary}', "");
    Expect(1, 1327, '\p{Is_Cyrillic_SUPPLEMENTARY}', "");
    Expect(0, 1327, '\p{^Is_Cyrillic_SUPPLEMENTARY}', "");
    Expect(0, 1327, '\P{Is_Cyrillic_SUPPLEMENTARY}', "");
    Expect(1, 1327, '\P{^Is_Cyrillic_SUPPLEMENTARY}', "");
    Expect(0, 1328, '\p{Is_Cyrillic_SUPPLEMENTARY}', "");
    Expect(1, 1328, '\p{^Is_Cyrillic_SUPPLEMENTARY}', "");
    Expect(1, 1328, '\P{Is_Cyrillic_SUPPLEMENTARY}', "");
    Expect(0, 1328, '\P{^Is_Cyrillic_SUPPLEMENTARY}', "");
    Error('\p{ 	in_Cyrillic_SUPPLEMENTARY/a/}');
    Error('\P{ 	in_Cyrillic_SUPPLEMENTARY/a/}');
    Expect(1, 1327, '\p{incyrillicsupplementary}', "");
    Expect(0, 1327, '\p{^incyrillicsupplementary}', "");
    Expect(0, 1327, '\P{incyrillicsupplementary}', "");
    Expect(1, 1327, '\P{^incyrillicsupplementary}', "");
    Expect(0, 1328, '\p{incyrillicsupplementary}', "");
    Expect(1, 1328, '\p{^incyrillicsupplementary}', "");
    Expect(1, 1328, '\P{incyrillicsupplementary}', "");
    Expect(0, 1328, '\P{^incyrillicsupplementary}', "");
    Expect(1, 1327, '\p{	 in_Cyrillic_SUPPLEMENTARY}', "");
    Expect(0, 1327, '\p{^	 in_Cyrillic_SUPPLEMENTARY}', "");
    Expect(0, 1327, '\P{	 in_Cyrillic_SUPPLEMENTARY}', "");
    Expect(1, 1327, '\P{^	 in_Cyrillic_SUPPLEMENTARY}', "");
    Expect(0, 1328, '\p{	 in_Cyrillic_SUPPLEMENTARY}', "");
    Expect(1, 1328, '\p{^	 in_Cyrillic_SUPPLEMENTARY}', "");
    Expect(1, 1328, '\P{	 in_Cyrillic_SUPPLEMENTARY}', "");
    Expect(0, 1328, '\P{^	 in_Cyrillic_SUPPLEMENTARY}', "");
    Error('\p{ /a/Dash}');
    Error('\P{ /a/Dash}');
    Expect(1, 65293, '\p{dash}', "");
    Expect(0, 65293, '\p{^dash}', "");
    Expect(0, 65293, '\P{dash}', "");
    Expect(1, 65293, '\P{^dash}', "");
    Expect(0, 65294, '\p{dash}', "");
    Expect(1, 65294, '\p{^dash}', "");
    Expect(1, 65294, '\P{dash}', "");
    Expect(0, 65294, '\P{^dash}', "");
    Expect(1, 65293, '\p{  dash}', "");
    Expect(0, 65293, '\p{^  dash}', "");
    Expect(0, 65293, '\P{  dash}', "");
    Expect(1, 65293, '\P{^  dash}', "");
    Expect(0, 65294, '\p{  dash}', "");
    Expect(1, 65294, '\p{^  dash}', "");
    Expect(1, 65294, '\P{  dash}', "");
    Expect(0, 65294, '\P{^  dash}', "");
    Error('\p{  Is_Dash:=}');
    Error('\P{  Is_Dash:=}');
    Expect(1, 65293, '\p{isdash}', "");
    Expect(0, 65293, '\p{^isdash}', "");
    Expect(0, 65293, '\P{isdash}', "");
    Expect(1, 65293, '\P{^isdash}', "");
    Expect(0, 65294, '\p{isdash}', "");
    Expect(1, 65294, '\p{^isdash}', "");
    Expect(1, 65294, '\P{isdash}', "");
    Expect(0, 65294, '\P{^isdash}', "");
    Expect(1, 65293, '\p{Is_dash}', "");
    Expect(0, 65293, '\p{^Is_dash}', "");
    Expect(0, 65293, '\P{Is_dash}', "");
    Expect(1, 65293, '\P{^Is_dash}', "");
    Expect(0, 65294, '\p{Is_dash}', "");
    Expect(1, 65294, '\p{^Is_dash}', "");
    Expect(1, 65294, '\P{Is_dash}', "");
    Expect(0, 65294, '\P{^Is_dash}', "");
    Error('\p{-:=Dash_Punctuation}');
    Error('\P{-:=Dash_Punctuation}');
    Expect(1, 65293, '\p{dashpunctuation}', "");
    Expect(0, 65293, '\p{^dashpunctuation}', "");
    Expect(0, 65293, '\P{dashpunctuation}', "");
    Expect(1, 65293, '\P{^dashpunctuation}', "");
    Expect(0, 65294, '\p{dashpunctuation}', "");
    Expect(1, 65294, '\p{^dashpunctuation}', "");
    Expect(1, 65294, '\P{dashpunctuation}', "");
    Expect(0, 65294, '\P{^dashpunctuation}', "");
    Expect(1, 65293, '\p{ _Dash_Punctuation}', "");
    Expect(0, 65293, '\p{^ _Dash_Punctuation}', "");
    Expect(0, 65293, '\P{ _Dash_Punctuation}', "");
    Expect(1, 65293, '\P{^ _Dash_Punctuation}', "");
    Expect(0, 65294, '\p{ _Dash_Punctuation}', "");
    Expect(1, 65294, '\p{^ _Dash_Punctuation}', "");
    Expect(1, 65294, '\P{ _Dash_Punctuation}', "");
    Expect(0, 65294, '\P{^ _Dash_Punctuation}', "");
    Error('\p{__is_DASH_punctuation/a/}');
    Error('\P{__is_DASH_punctuation/a/}');
    Expect(1, 65293, '\p{isdashpunctuation}', "");
    Expect(0, 65293, '\p{^isdashpunctuation}', "");
    Expect(0, 65293, '\P{isdashpunctuation}', "");
    Expect(1, 65293, '\P{^isdashpunctuation}', "");
    Expect(0, 65294, '\p{isdashpunctuation}', "");
    Expect(1, 65294, '\p{^isdashpunctuation}', "");
    Expect(1, 65294, '\P{isdashpunctuation}', "");
    Expect(0, 65294, '\P{^isdashpunctuation}', "");
    Expect(1, 65293, '\p{--Is_DASH_Punctuation}', "");
    Expect(0, 65293, '\p{^--Is_DASH_Punctuation}', "");
    Expect(0, 65293, '\P{--Is_DASH_Punctuation}', "");
    Expect(1, 65293, '\P{^--Is_DASH_Punctuation}', "");
    Expect(0, 65294, '\p{--Is_DASH_Punctuation}', "");
    Expect(1, 65294, '\p{^--Is_DASH_Punctuation}', "");
    Expect(1, 65294, '\P{--Is_DASH_Punctuation}', "");
    Expect(0, 65294, '\P{^--Is_DASH_Punctuation}', "");
    Error('\p{_:=Pd}');
    Error('\P{_:=Pd}');
    Expect(1, 65293, '\p{pd}', "");
    Expect(0, 65293, '\p{^pd}', "");
    Expect(0, 65293, '\P{pd}', "");
    Expect(1, 65293, '\P{^pd}', "");
    Expect(0, 65294, '\p{pd}', "");
    Expect(1, 65294, '\p{^pd}', "");
    Expect(1, 65294, '\P{pd}', "");
    Expect(0, 65294, '\P{^pd}', "");
    Expect(1, 65293, '\p{_pd}', "");
    Expect(0, 65293, '\p{^_pd}', "");
    Expect(0, 65293, '\P{_pd}', "");
    Expect(1, 65293, '\P{^_pd}', "");
    Expect(0, 65294, '\p{_pd}', "");
    Expect(1, 65294, '\p{^_pd}', "");
    Expect(1, 65294, '\P{_pd}', "");
    Expect(0, 65294, '\P{^_pd}', "");
    Error('\p{	:=Is_PD}');
    Error('\P{	:=Is_PD}');
    Expect(1, 65293, '\p{ispd}', "");
    Expect(0, 65293, '\p{^ispd}', "");
    Expect(0, 65293, '\P{ispd}', "");
    Expect(1, 65293, '\P{^ispd}', "");
    Expect(0, 65294, '\p{ispd}', "");
    Expect(1, 65294, '\p{^ispd}', "");
    Expect(1, 65294, '\P{ispd}', "");
    Expect(0, 65294, '\P{^ispd}', "");
    Expect(1, 65293, '\p{-_IS_Pd}', "");
    Expect(0, 65293, '\p{^-_IS_Pd}', "");
    Expect(0, 65293, '\P{-_IS_Pd}', "");
    Expect(1, 65293, '\P{^-_IS_Pd}', "");
    Expect(0, 65294, '\p{-_IS_Pd}', "");
    Expect(1, 65294, '\p{^-_IS_Pd}', "");
    Expect(1, 65294, '\P{-_IS_Pd}', "");
    Expect(0, 65294, '\P{^-_IS_Pd}', "");
    Error('\p{- Default_Ignorable_code_Point:=}');
    Error('\P{- Default_Ignorable_code_Point:=}');
    Expect(1, 921599, '\p{defaultignorablecodepoint}', "");
    Expect(0, 921599, '\p{^defaultignorablecodepoint}', "");
    Expect(0, 921599, '\P{defaultignorablecodepoint}', "");
    Expect(1, 921599, '\P{^defaultignorablecodepoint}', "");
    Expect(0, 921600, '\p{defaultignorablecodepoint}', "");
    Expect(1, 921600, '\p{^defaultignorablecodepoint}', "");
    Expect(1, 921600, '\P{defaultignorablecodepoint}', "");
    Expect(0, 921600, '\P{^defaultignorablecodepoint}', "");
    Expect(1, 921599, '\p{ _Default_ignorable_code_point}', "");
    Expect(0, 921599, '\p{^ _Default_ignorable_code_point}', "");
    Expect(0, 921599, '\P{ _Default_ignorable_code_point}', "");
    Expect(1, 921599, '\P{^ _Default_ignorable_code_point}', "");
    Expect(0, 921600, '\p{ _Default_ignorable_code_point}', "");
    Expect(1, 921600, '\p{^ _Default_ignorable_code_point}', "");
    Expect(1, 921600, '\P{ _Default_ignorable_code_point}', "");
    Expect(0, 921600, '\P{^ _Default_ignorable_code_point}', "");
    Error('\p{:= -Is_default_IGNORABLE_CODE_POINT}');
    Error('\P{:= -Is_default_IGNORABLE_CODE_POINT}');
    Expect(1, 921599, '\p{isdefaultignorablecodepoint}', "");
    Expect(0, 921599, '\p{^isdefaultignorablecodepoint}', "");
    Expect(0, 921599, '\P{isdefaultignorablecodepoint}', "");
    Expect(1, 921599, '\P{^isdefaultignorablecodepoint}', "");
    Expect(0, 921600, '\p{isdefaultignorablecodepoint}', "");
    Expect(1, 921600, '\p{^isdefaultignorablecodepoint}', "");
    Expect(1, 921600, '\P{isdefaultignorablecodepoint}', "");
    Expect(0, 921600, '\P{^isdefaultignorablecodepoint}', "");
    Expect(1, 921599, '\p{	_Is_default_ignorable_Code_Point}', "");
    Expect(0, 921599, '\p{^	_Is_default_ignorable_Code_Point}', "");
    Expect(0, 921599, '\P{	_Is_default_ignorable_Code_Point}', "");
    Expect(1, 921599, '\P{^	_Is_default_ignorable_Code_Point}', "");
    Expect(0, 921600, '\p{	_Is_default_ignorable_Code_Point}', "");
    Expect(1, 921600, '\p{^	_Is_default_ignorable_Code_Point}', "");
    Expect(1, 921600, '\P{	_Is_default_ignorable_Code_Point}', "");
    Expect(0, 921600, '\P{^	_Is_default_ignorable_Code_Point}', "");
    Error('\p{/a/__di}');
    Error('\P{/a/__di}');
    Expect(1, 921599, '\p{di}', "");
    Expect(0, 921599, '\p{^di}', "");
    Expect(0, 921599, '\P{di}', "");
    Expect(1, 921599, '\P{^di}', "");
    Expect(0, 921600, '\p{di}', "");
    Expect(1, 921600, '\p{^di}', "");
    Expect(1, 921600, '\P{di}', "");
    Expect(0, 921600, '\P{^di}', "");
    Expect(1, 921599, '\p{ 	DI}', "");
    Expect(0, 921599, '\p{^ 	DI}', "");
    Expect(0, 921599, '\P{ 	DI}', "");
    Expect(1, 921599, '\P{^ 	DI}', "");
    Expect(0, 921600, '\p{ 	DI}', "");
    Expect(1, 921600, '\p{^ 	DI}', "");
    Expect(1, 921600, '\P{ 	DI}', "");
    Expect(0, 921600, '\P{^ 	DI}', "");
    Error('\p{-_Is_di:=}');
    Error('\P{-_Is_di:=}');
    Expect(1, 921599, '\p{isdi}', "");
    Expect(0, 921599, '\p{^isdi}', "");
    Expect(0, 921599, '\P{isdi}', "");
    Expect(1, 921599, '\P{^isdi}', "");
    Expect(0, 921600, '\p{isdi}', "");
    Expect(1, 921600, '\p{^isdi}', "");
    Expect(1, 921600, '\P{isdi}', "");
    Expect(0, 921600, '\P{^isdi}', "");
    Expect(1, 921599, '\p{_	Is_DI}', "");
    Expect(0, 921599, '\p{^_	Is_DI}', "");
    Expect(0, 921599, '\P{_	Is_DI}', "");
    Expect(1, 921599, '\P{^_	Is_DI}', "");
    Expect(0, 921600, '\p{_	Is_DI}', "");
    Expect(1, 921600, '\p{^_	Is_DI}', "");
    Expect(1, 921600, '\P{_	Is_DI}', "");
    Expect(0, 921600, '\P{^_	Is_DI}', "");
    Error('\p{/a/	_deprecated}');
    Error('\P{/a/	_deprecated}');
    Expect(1, 917505, '\p{deprecated}', "");
    Expect(0, 917505, '\p{^deprecated}', "");
    Expect(0, 917505, '\P{deprecated}', "");
    Expect(1, 917505, '\P{^deprecated}', "");
    Expect(0, 917506, '\p{deprecated}', "");
    Expect(1, 917506, '\p{^deprecated}', "");
    Expect(1, 917506, '\P{deprecated}', "");
    Expect(0, 917506, '\P{^deprecated}', "");
    Expect(1, 917505, '\p{-deprecated}', "");
    Expect(0, 917505, '\p{^-deprecated}', "");
    Expect(0, 917505, '\P{-deprecated}', "");
    Expect(1, 917505, '\P{^-deprecated}', "");
    Expect(0, 917506, '\p{-deprecated}', "");
    Expect(1, 917506, '\p{^-deprecated}', "");
    Expect(1, 917506, '\P{-deprecated}', "");
    Expect(0, 917506, '\P{^-deprecated}', "");
    Error('\p{ :=Is_Deprecated}');
    Error('\P{ :=Is_Deprecated}');
    Expect(1, 917505, '\p{isdeprecated}', "");
    Expect(0, 917505, '\p{^isdeprecated}', "");
    Expect(0, 917505, '\P{isdeprecated}', "");
    Expect(1, 917505, '\P{^isdeprecated}', "");
    Expect(0, 917506, '\p{isdeprecated}', "");
    Expect(1, 917506, '\p{^isdeprecated}', "");
    Expect(1, 917506, '\P{isdeprecated}', "");
    Expect(0, 917506, '\P{^isdeprecated}', "");
    Expect(1, 917505, '\p{_is_DEPRECATED}', "");
    Expect(0, 917505, '\p{^_is_DEPRECATED}', "");
    Expect(0, 917505, '\P{_is_DEPRECATED}', "");
    Expect(1, 917505, '\P{^_is_DEPRECATED}', "");
    Expect(0, 917506, '\p{_is_DEPRECATED}', "");
    Expect(1, 917506, '\p{^_is_DEPRECATED}', "");
    Expect(1, 917506, '\P{_is_DEPRECATED}', "");
    Expect(0, 917506, '\P{^_is_DEPRECATED}', "");
    Error('\p{	:=DEP}');
    Error('\P{	:=DEP}');
    Expect(1, 917505, '\p{dep}', "");
    Expect(0, 917505, '\p{^dep}', "");
    Expect(0, 917505, '\P{dep}', "");
    Expect(1, 917505, '\P{^dep}', "");
    Expect(0, 917506, '\p{dep}', "");
    Expect(1, 917506, '\p{^dep}', "");
    Expect(1, 917506, '\P{dep}', "");
    Expect(0, 917506, '\P{^dep}', "");
    Expect(1, 917505, '\p{_Dep}', "");
    Expect(0, 917505, '\p{^_Dep}', "");
    Expect(0, 917505, '\P{_Dep}', "");
    Expect(1, 917505, '\P{^_Dep}', "");
    Expect(0, 917506, '\p{_Dep}', "");
    Expect(1, 917506, '\p{^_Dep}', "");
    Expect(1, 917506, '\P{_Dep}', "");
    Expect(0, 917506, '\P{^_Dep}', "");
    Error('\p{ /a/IS_DEP}');
    Error('\P{ /a/IS_DEP}');
    Expect(1, 917505, '\p{isdep}', "");
    Expect(0, 917505, '\p{^isdep}', "");
    Expect(0, 917505, '\P{isdep}', "");
    Expect(1, 917505, '\P{^isdep}', "");
    Expect(0, 917506, '\p{isdep}', "");
    Expect(1, 917506, '\p{^isdep}', "");
    Expect(1, 917506, '\P{isdep}', "");
    Expect(0, 917506, '\P{^isdep}', "");
    Expect(1, 917505, '\p{	_IS_DEP}', "");
    Expect(0, 917505, '\p{^	_IS_DEP}', "");
    Expect(0, 917505, '\P{	_IS_DEP}', "");
    Expect(1, 917505, '\P{^	_IS_DEP}', "");
    Expect(0, 917506, '\p{	_IS_DEP}', "");
    Expect(1, 917506, '\p{^	_IS_DEP}', "");
    Expect(1, 917506, '\P{	_IS_DEP}', "");
    Expect(0, 917506, '\P{^	_IS_DEP}', "");
    Error('\p{	:=deseret}');
    Error('\P{	:=deseret}');
    Expect(1, 66639, '\p{deseret}', "");
    Expect(0, 66639, '\p{^deseret}', "");
    Expect(0, 66639, '\P{deseret}', "");
    Expect(1, 66639, '\P{^deseret}', "");
    Expect(0, 66640, '\p{deseret}', "");
    Expect(1, 66640, '\p{^deseret}', "");
    Expect(1, 66640, '\P{deseret}', "");
    Expect(0, 66640, '\P{^deseret}', "");
    Expect(1, 66639, '\p{ _DESERET}', "");
    Expect(0, 66639, '\p{^ _DESERET}', "");
    Expect(0, 66639, '\P{ _DESERET}', "");
    Expect(1, 66639, '\P{^ _DESERET}', "");
    Expect(0, 66640, '\p{ _DESERET}', "");
    Expect(1, 66640, '\p{^ _DESERET}', "");
    Expect(1, 66640, '\P{ _DESERET}', "");
    Expect(0, 66640, '\P{^ _DESERET}', "");
    Error('\p{-	Is_DESERET:=}');
    Error('\P{-	Is_DESERET:=}');
    Expect(1, 66639, '\p{isdeseret}', "");
    Expect(0, 66639, '\p{^isdeseret}', "");
    Expect(0, 66639, '\P{isdeseret}', "");
    Expect(1, 66639, '\P{^isdeseret}', "");
    Expect(0, 66640, '\p{isdeseret}', "");
    Expect(1, 66640, '\p{^isdeseret}', "");
    Expect(1, 66640, '\P{isdeseret}', "");
    Expect(0, 66640, '\P{^isdeseret}', "");
    Expect(1, 66639, '\p{-Is_deseret}', "");
    Expect(0, 66639, '\p{^-Is_deseret}', "");
    Expect(0, 66639, '\P{-Is_deseret}', "");
    Expect(1, 66639, '\P{^-Is_deseret}', "");
    Expect(0, 66640, '\p{-Is_deseret}', "");
    Expect(1, 66640, '\p{^-Is_deseret}', "");
    Expect(1, 66640, '\P{-Is_deseret}', "");
    Expect(0, 66640, '\P{^-Is_deseret}', "");
    Error('\p{	DSRT/a/}');
    Error('\P{	DSRT/a/}');
    Expect(1, 66639, '\p{dsrt}', "");
    Expect(0, 66639, '\p{^dsrt}', "");
    Expect(0, 66639, '\P{dsrt}', "");
    Expect(1, 66639, '\P{^dsrt}', "");
    Expect(0, 66640, '\p{dsrt}', "");
    Expect(1, 66640, '\p{^dsrt}', "");
    Expect(1, 66640, '\P{dsrt}', "");
    Expect(0, 66640, '\P{^dsrt}', "");
    Expect(1, 66639, '\p{ Dsrt}', "");
    Expect(0, 66639, '\p{^ Dsrt}', "");
    Expect(0, 66639, '\P{ Dsrt}', "");
    Expect(1, 66639, '\P{^ Dsrt}', "");
    Expect(0, 66640, '\p{ Dsrt}', "");
    Expect(1, 66640, '\p{^ Dsrt}', "");
    Expect(1, 66640, '\P{ Dsrt}', "");
    Expect(0, 66640, '\P{^ Dsrt}', "");
    Error('\p{	 IS_DSRT/a/}');
    Error('\P{	 IS_DSRT/a/}');
    Expect(1, 66639, '\p{isdsrt}', "");
    Expect(0, 66639, '\p{^isdsrt}', "");
    Expect(0, 66639, '\P{isdsrt}', "");
    Expect(1, 66639, '\P{^isdsrt}', "");
    Expect(0, 66640, '\p{isdsrt}', "");
    Expect(1, 66640, '\p{^isdsrt}', "");
    Expect(1, 66640, '\P{isdsrt}', "");
    Expect(0, 66640, '\P{^isdsrt}', "");
    Expect(1, 66639, '\p{ _IS_dsrt}', "");
    Expect(0, 66639, '\p{^ _IS_dsrt}', "");
    Expect(0, 66639, '\P{ _IS_dsrt}', "");
    Expect(1, 66639, '\P{^ _IS_dsrt}', "");
    Expect(0, 66640, '\p{ _IS_dsrt}', "");
    Expect(1, 66640, '\p{^ _IS_dsrt}', "");
    Expect(1, 66640, '\P{ _IS_dsrt}', "");
    Expect(0, 66640, '\P{^ _IS_dsrt}', "");
    Error('\p{:=	 Devanagari}');
    Error('\P{:=	 Devanagari}');
    Expect(1, 43263, '\p{devanagari}', "");
    Expect(0, 43263, '\p{^devanagari}', "");
    Expect(0, 43263, '\P{devanagari}', "");
    Expect(1, 43263, '\P{^devanagari}', "");
    Expect(0, 43264, '\p{devanagari}', "");
    Expect(1, 43264, '\p{^devanagari}', "");
    Expect(1, 43264, '\P{devanagari}', "");
    Expect(0, 43264, '\P{^devanagari}', "");
    Expect(1, 43263, '\p{ -devanagari}', "");
    Expect(0, 43263, '\p{^ -devanagari}', "");
    Expect(0, 43263, '\P{ -devanagari}', "");
    Expect(1, 43263, '\P{^ -devanagari}', "");
    Expect(0, 43264, '\p{ -devanagari}', "");
    Expect(1, 43264, '\p{^ -devanagari}', "");
    Expect(1, 43264, '\P{ -devanagari}', "");
    Expect(0, 43264, '\P{^ -devanagari}', "");
    Error('\p{	:=Is_DEVANAGARI}');
    Error('\P{	:=Is_DEVANAGARI}');
    Expect(1, 43263, '\p{isdevanagari}', "");
    Expect(0, 43263, '\p{^isdevanagari}', "");
    Expect(0, 43263, '\P{isdevanagari}', "");
    Expect(1, 43263, '\P{^isdevanagari}', "");
    Expect(0, 43264, '\p{isdevanagari}', "");
    Expect(1, 43264, '\p{^isdevanagari}', "");
    Expect(1, 43264, '\P{isdevanagari}', "");
    Expect(0, 43264, '\P{^isdevanagari}', "");
    Expect(1, 43263, '\p{- IS_Devanagari}', "");
    Expect(0, 43263, '\p{^- IS_Devanagari}', "");
    Expect(0, 43263, '\P{- IS_Devanagari}', "");
    Expect(1, 43263, '\P{^- IS_Devanagari}', "");
    Expect(0, 43264, '\p{- IS_Devanagari}', "");
    Expect(1, 43264, '\p{^- IS_Devanagari}', "");
    Expect(1, 43264, '\P{- IS_Devanagari}', "");
    Expect(0, 43264, '\P{^- IS_Devanagari}', "");
    Error('\p{-:=DEVA}');
    Error('\P{-:=DEVA}');
    Expect(1, 43263, '\p{deva}', "");
    Expect(0, 43263, '\p{^deva}', "");
    Expect(0, 43263, '\P{deva}', "");
    Expect(1, 43263, '\P{^deva}', "");
    Expect(0, 43264, '\p{deva}', "");
    Expect(1, 43264, '\p{^deva}', "");
    Expect(1, 43264, '\P{deva}', "");
    Expect(0, 43264, '\P{^deva}', "");
    Expect(1, 43263, '\p{ -Deva}', "");
    Expect(0, 43263, '\p{^ -Deva}', "");
    Expect(0, 43263, '\P{ -Deva}', "");
    Expect(1, 43263, '\P{^ -Deva}', "");
    Expect(0, 43264, '\p{ -Deva}', "");
    Expect(1, 43264, '\p{^ -Deva}', "");
    Expect(1, 43264, '\P{ -Deva}', "");
    Expect(0, 43264, '\P{^ -Deva}', "");
    Error('\p{:= Is_Deva}');
    Error('\P{:= Is_Deva}');
    Expect(1, 43263, '\p{isdeva}', "");
    Expect(0, 43263, '\p{^isdeva}', "");
    Expect(0, 43263, '\P{isdeva}', "");
    Expect(1, 43263, '\P{^isdeva}', "");
    Expect(0, 43264, '\p{isdeva}', "");
    Expect(1, 43264, '\p{^isdeva}', "");
    Expect(1, 43264, '\P{isdeva}', "");
    Expect(0, 43264, '\P{^isdeva}', "");
    Expect(1, 43263, '\p{_Is_deva}', "");
    Expect(0, 43263, '\p{^_Is_deva}', "");
    Expect(0, 43263, '\P{_Is_deva}', "");
    Expect(1, 43263, '\P{^_Is_deva}', "");
    Expect(0, 43264, '\p{_Is_deva}', "");
    Expect(1, 43264, '\p{^_Is_deva}', "");
    Expect(1, 43264, '\P{_Is_deva}', "");
    Expect(0, 43264, '\P{^_Is_deva}', "");
    Error('\p{_ devanagari_Extended/a/}');
    Error('\P{_ devanagari_Extended/a/}');
    Expect(1, 43263, '\p{devanagariextended}', "");
    Expect(0, 43263, '\p{^devanagariextended}', "");
    Expect(0, 43263, '\P{devanagariextended}', "");
    Expect(1, 43263, '\P{^devanagariextended}', "");
    Expect(0, 43264, '\p{devanagariextended}', "");
    Expect(1, 43264, '\p{^devanagariextended}', "");
    Expect(1, 43264, '\P{devanagariextended}', "");
    Expect(0, 43264, '\P{^devanagariextended}', "");
    Expect(1, 43263, '\p{_Devanagari_EXTENDED}', "");
    Expect(0, 43263, '\p{^_Devanagari_EXTENDED}', "");
    Expect(0, 43263, '\P{_Devanagari_EXTENDED}', "");
    Expect(1, 43263, '\P{^_Devanagari_EXTENDED}', "");
    Expect(0, 43264, '\p{_Devanagari_EXTENDED}', "");
    Expect(1, 43264, '\p{^_Devanagari_EXTENDED}', "");
    Expect(1, 43264, '\P{_Devanagari_EXTENDED}', "");
    Expect(0, 43264, '\P{^_Devanagari_EXTENDED}', "");
    Error('\p{-Is_devanagari_Extended:=}');
    Error('\P{-Is_devanagari_Extended:=}');
    Expect(1, 43263, '\p{isdevanagariextended}', "");
    Expect(0, 43263, '\p{^isdevanagariextended}', "");
    Expect(0, 43263, '\P{isdevanagariextended}', "");
    Expect(1, 43263, '\P{^isdevanagariextended}', "");
    Expect(0, 43264, '\p{isdevanagariextended}', "");
    Expect(1, 43264, '\p{^isdevanagariextended}', "");
    Expect(1, 43264, '\P{isdevanagariextended}', "");
    Expect(0, 43264, '\P{^isdevanagariextended}', "");
    Expect(1, 43263, '\p{-Is_DEVANAGARI_Extended}', "");
    Expect(0, 43263, '\p{^-Is_DEVANAGARI_Extended}', "");
    Expect(0, 43263, '\P{-Is_DEVANAGARI_Extended}', "");
    Expect(1, 43263, '\P{^-Is_DEVANAGARI_Extended}', "");
    Expect(0, 43264, '\p{-Is_DEVANAGARI_Extended}', "");
    Expect(1, 43264, '\p{^-Is_DEVANAGARI_Extended}', "");
    Expect(1, 43264, '\P{-Is_DEVANAGARI_Extended}', "");
    Expect(0, 43264, '\P{^-Is_DEVANAGARI_Extended}', "");
    Error('\p{:=_-in_devanagari_extended}');
    Error('\P{:=_-in_devanagari_extended}');
    Expect(1, 43263, '\p{indevanagariextended}', "");
    Expect(0, 43263, '\p{^indevanagariextended}', "");
    Expect(0, 43263, '\P{indevanagariextended}', "");
    Expect(1, 43263, '\P{^indevanagariextended}', "");
    Expect(0, 43264, '\p{indevanagariextended}', "");
    Expect(1, 43264, '\p{^indevanagariextended}', "");
    Expect(1, 43264, '\P{indevanagariextended}', "");
    Expect(0, 43264, '\P{^indevanagariextended}', "");
    Expect(1, 43263, '\p{- IN_Devanagari_EXTENDED}', "");
    Expect(0, 43263, '\p{^- IN_Devanagari_EXTENDED}', "");
    Expect(0, 43263, '\P{- IN_Devanagari_EXTENDED}', "");
    Expect(1, 43263, '\P{^- IN_Devanagari_EXTENDED}', "");
    Expect(0, 43264, '\p{- IN_Devanagari_EXTENDED}', "");
    Expect(1, 43264, '\p{^- IN_Devanagari_EXTENDED}', "");
    Expect(1, 43264, '\P{- IN_Devanagari_EXTENDED}', "");
    Expect(0, 43264, '\P{^- IN_Devanagari_EXTENDED}', "");
    Error('\p{_-DEVANAGARI_Ext/a/}');
    Error('\P{_-DEVANAGARI_Ext/a/}');
    Expect(1, 43263, '\p{devanagariext}', "");
    Expect(0, 43263, '\p{^devanagariext}', "");
    Expect(0, 43263, '\P{devanagariext}', "");
    Expect(1, 43263, '\P{^devanagariext}', "");
    Expect(0, 43264, '\p{devanagariext}', "");
    Expect(1, 43264, '\p{^devanagariext}', "");
    Expect(1, 43264, '\P{devanagariext}', "");
    Expect(0, 43264, '\P{^devanagariext}', "");
    Expect(1, 43263, '\p{DEVANAGARI_ext}', "");
    Expect(0, 43263, '\p{^DEVANAGARI_ext}', "");
    Expect(0, 43263, '\P{DEVANAGARI_ext}', "");
    Expect(1, 43263, '\P{^DEVANAGARI_ext}', "");
    Expect(0, 43264, '\p{DEVANAGARI_ext}', "");
    Expect(1, 43264, '\p{^DEVANAGARI_ext}', "");
    Expect(1, 43264, '\P{DEVANAGARI_ext}', "");
    Expect(0, 43264, '\P{^DEVANAGARI_ext}', "");
    Error('\p{/a/Is_devanagari_ext}');
    Error('\P{/a/Is_devanagari_ext}');
    Expect(1, 43263, '\p{isdevanagariext}', "");
    Expect(0, 43263, '\p{^isdevanagariext}', "");
    Expect(0, 43263, '\P{isdevanagariext}', "");
    Expect(1, 43263, '\P{^isdevanagariext}', "");
    Expect(0, 43264, '\p{isdevanagariext}', "");
    Expect(1, 43264, '\p{^isdevanagariext}', "");
    Expect(1, 43264, '\P{isdevanagariext}', "");
    Expect(0, 43264, '\P{^isdevanagariext}', "");
    Expect(1, 43263, '\p{_	Is_DEVANAGARI_ext}', "");
    Expect(0, 43263, '\p{^_	Is_DEVANAGARI_ext}', "");
    Expect(0, 43263, '\P{_	Is_DEVANAGARI_ext}', "");
    Expect(1, 43263, '\P{^_	Is_DEVANAGARI_ext}', "");
    Expect(0, 43264, '\p{_	Is_DEVANAGARI_ext}', "");
    Expect(1, 43264, '\p{^_	Is_DEVANAGARI_ext}', "");
    Expect(1, 43264, '\P{_	Is_DEVANAGARI_ext}', "");
    Expect(0, 43264, '\P{^_	Is_DEVANAGARI_ext}', "");
    Error('\p{	:=In_Devanagari_EXT}');
    Error('\P{	:=In_Devanagari_EXT}');
    Expect(1, 43263, '\p{indevanagariext}', "");
    Expect(0, 43263, '\p{^indevanagariext}', "");
    Expect(0, 43263, '\P{indevanagariext}', "");
    Expect(1, 43263, '\P{^indevanagariext}', "");
    Expect(0, 43264, '\p{indevanagariext}', "");
    Expect(1, 43264, '\p{^indevanagariext}', "");
    Expect(1, 43264, '\P{indevanagariext}', "");
    Expect(0, 43264, '\P{^indevanagariext}', "");
    Expect(1, 43263, '\p{_In_Devanagari_ext}', "");
    Expect(0, 43263, '\p{^_In_Devanagari_ext}', "");
    Expect(0, 43263, '\P{_In_Devanagari_ext}', "");
    Expect(1, 43263, '\P{^_In_Devanagari_ext}', "");
    Expect(0, 43264, '\p{_In_Devanagari_ext}', "");
    Expect(1, 43264, '\p{^_In_Devanagari_ext}', "");
    Expect(1, 43264, '\P{_In_Devanagari_ext}', "");
    Expect(0, 43264, '\P{^_In_Devanagari_ext}', "");
    Error('\p{:= diacritic}');
    Error('\P{:= diacritic}');
    Expect(1, 125258, '\p{diacritic}', "");
    Expect(0, 125258, '\p{^diacritic}', "");
    Expect(0, 125258, '\P{diacritic}', "");
    Expect(1, 125258, '\P{^diacritic}', "");
    Expect(0, 125259, '\p{diacritic}', "");
    Expect(1, 125259, '\p{^diacritic}', "");
    Expect(1, 125259, '\P{diacritic}', "");
    Expect(0, 125259, '\P{^diacritic}', "");
    Expect(1, 125258, '\p{  diacritic}', "");
    Expect(0, 125258, '\p{^  diacritic}', "");
    Expect(0, 125258, '\P{  diacritic}', "");
    Expect(1, 125258, '\P{^  diacritic}', "");
    Expect(0, 125259, '\p{  diacritic}', "");
    Expect(1, 125259, '\p{^  diacritic}', "");
    Expect(1, 125259, '\P{  diacritic}', "");
    Expect(0, 125259, '\P{^  diacritic}', "");
    Error('\p{:= Is_diacritic}');
    Error('\P{:= Is_diacritic}');
    Expect(1, 125258, '\p{isdiacritic}', "");
    Expect(0, 125258, '\p{^isdiacritic}', "");
    Expect(0, 125258, '\P{isdiacritic}', "");
    Expect(1, 125258, '\P{^isdiacritic}', "");
    Expect(0, 125259, '\p{isdiacritic}', "");
    Expect(1, 125259, '\p{^isdiacritic}', "");
    Expect(1, 125259, '\P{isdiacritic}', "");
    Expect(0, 125259, '\P{^isdiacritic}', "");
    Expect(1, 125258, '\p{is_Diacritic}', "");
    Expect(0, 125258, '\p{^is_Diacritic}', "");
    Expect(0, 125258, '\P{is_Diacritic}', "");
    Expect(1, 125258, '\P{^is_Diacritic}', "");
    Expect(0, 125259, '\p{is_Diacritic}', "");
    Expect(1, 125259, '\p{^is_Diacritic}', "");
    Expect(1, 125259, '\P{is_Diacritic}', "");
    Expect(0, 125259, '\P{^is_Diacritic}', "");
    Error('\p{_:=DIA}');
    Error('\P{_:=DIA}');
    Expect(1, 125258, '\p{dia}', "");
    Expect(0, 125258, '\p{^dia}', "");
    Expect(0, 125258, '\P{dia}', "");
    Expect(1, 125258, '\P{^dia}', "");
    Expect(0, 125259, '\p{dia}', "");
    Expect(1, 125259, '\p{^dia}', "");
    Expect(1, 125259, '\P{dia}', "");
    Expect(0, 125259, '\P{^dia}', "");
    Expect(1, 125258, '\p{-Dia}', "");
    Expect(0, 125258, '\p{^-Dia}', "");
    Expect(0, 125258, '\P{-Dia}', "");
    Expect(1, 125258, '\P{^-Dia}', "");
    Expect(0, 125259, '\p{-Dia}', "");
    Expect(1, 125259, '\p{^-Dia}', "");
    Expect(1, 125259, '\P{-Dia}', "");
    Expect(0, 125259, '\P{^-Dia}', "");
    Error('\p{:=_-is_DIA}');
    Error('\P{:=_-is_DIA}');
    Expect(1, 125258, '\p{isdia}', "");
    Expect(0, 125258, '\p{^isdia}', "");
    Expect(0, 125258, '\P{isdia}', "");
    Expect(1, 125258, '\P{^isdia}', "");
    Expect(0, 125259, '\p{isdia}', "");
    Expect(1, 125259, '\p{^isdia}', "");
    Expect(1, 125259, '\P{isdia}', "");
    Expect(0, 125259, '\P{^isdia}', "");
    Expect(1, 125258, '\p{  IS_Dia}', "");
    Expect(0, 125258, '\p{^  IS_Dia}', "");
    Expect(0, 125258, '\P{  IS_Dia}', "");
    Expect(1, 125258, '\P{^  IS_Dia}', "");
    Expect(0, 125259, '\p{  IS_Dia}', "");
    Expect(1, 125259, '\p{^  IS_Dia}', "");
    Expect(1, 125259, '\P{  IS_Dia}', "");
    Expect(0, 125259, '\P{^  IS_Dia}', "");
    Error('\p{ XPOSIXDIGIT/a/}');
    Error('\P{ XPOSIXDIGIT/a/}');
    Expect(1, 125273, '\p{xposixdigit}', "");
    Expect(0, 125273, '\p{^xposixdigit}', "");
    Expect(0, 125273, '\P{xposixdigit}', "");
    Expect(1, 125273, '\P{^xposixdigit}', "");
    Expect(0, 125274, '\p{xposixdigit}', "");
    Expect(1, 125274, '\p{^xposixdigit}', "");
    Expect(1, 125274, '\P{xposixdigit}', "");
    Expect(0, 125274, '\P{^xposixdigit}', "");
    Expect(1, 125273, '\p{-XPOSIXDIGIT}', "");
    Expect(0, 125273, '\p{^-XPOSIXDIGIT}', "");
    Expect(0, 125273, '\P{-XPOSIXDIGIT}', "");
    Expect(1, 125273, '\P{^-XPOSIXDIGIT}', "");
    Expect(0, 125274, '\p{-XPOSIXDIGIT}', "");
    Expect(1, 125274, '\p{^-XPOSIXDIGIT}', "");
    Expect(1, 125274, '\P{-XPOSIXDIGIT}', "");
    Expect(0, 125274, '\P{^-XPOSIXDIGIT}', "");
    Error('\p{	DIGIT:=}');
    Error('\P{	DIGIT:=}');
    Expect(1, 125273, '\p{digit}', "");
    Expect(0, 125273, '\p{^digit}', "");
    Expect(0, 125273, '\P{digit}', "");
    Expect(1, 125273, '\P{^digit}', "");
    Expect(0, 125274, '\p{digit}', "");
    Expect(1, 125274, '\p{^digit}', "");
    Expect(1, 125274, '\P{digit}', "");
    Expect(0, 125274, '\P{^digit}', "");
    Expect(1, 125273, '\p{-	digit}', "");
    Expect(0, 125273, '\p{^-	digit}', "");
    Expect(0, 125273, '\P{-	digit}', "");
    Expect(1, 125273, '\P{^-	digit}', "");
    Expect(0, 125274, '\p{-	digit}', "");
    Expect(1, 125274, '\p{^-	digit}', "");
    Expect(1, 125274, '\P{-	digit}', "");
    Expect(0, 125274, '\P{^-	digit}', "");
    Error('\p{	-Is_XPOSIXDIGIT/a/}');
    Error('\P{	-Is_XPOSIXDIGIT/a/}');
    Expect(1, 125273, '\p{isxposixdigit}', "");
    Expect(0, 125273, '\p{^isxposixdigit}', "");
    Expect(0, 125273, '\P{isxposixdigit}', "");
    Expect(1, 125273, '\P{^isxposixdigit}', "");
    Expect(0, 125274, '\p{isxposixdigit}', "");
    Expect(1, 125274, '\p{^isxposixdigit}', "");
    Expect(1, 125274, '\P{isxposixdigit}', "");
    Expect(0, 125274, '\P{^isxposixdigit}', "");
    Expect(1, 125273, '\p{	_IS_XPOSIXDIGIT}', "");
    Expect(0, 125273, '\p{^	_IS_XPOSIXDIGIT}', "");
    Expect(0, 125273, '\P{	_IS_XPOSIXDIGIT}', "");
    Expect(1, 125273, '\P{^	_IS_XPOSIXDIGIT}', "");
    Expect(0, 125274, '\p{	_IS_XPOSIXDIGIT}', "");
    Expect(1, 125274, '\p{^	_IS_XPOSIXDIGIT}', "");
    Expect(1, 125274, '\P{	_IS_XPOSIXDIGIT}', "");
    Expect(0, 125274, '\P{^	_IS_XPOSIXDIGIT}', "");
    Error('\p{	Is_Digit/a/}');
    Error('\P{	Is_Digit/a/}');
    Expect(1, 125273, '\p{isdigit}', "");
    Expect(0, 125273, '\p{^isdigit}', "");
    Expect(0, 125273, '\P{isdigit}', "");
    Expect(1, 125273, '\P{^isdigit}', "");
    Expect(0, 125274, '\p{isdigit}', "");
    Expect(1, 125274, '\p{^isdigit}', "");
    Expect(1, 125274, '\P{isdigit}', "");
    Expect(0, 125274, '\P{^isdigit}', "");
    Expect(1, 125273, '\p{		is_digit}', "");
    Expect(0, 125273, '\p{^		is_digit}', "");
    Expect(0, 125273, '\P{		is_digit}', "");
    Expect(1, 125273, '\P{^		is_digit}', "");
    Expect(0, 125274, '\p{		is_digit}', "");
    Expect(1, 125274, '\p{^		is_digit}', "");
    Expect(1, 125274, '\P{		is_digit}', "");
    Expect(0, 125274, '\P{^		is_digit}', "");
    Error('\p{/a/ -Decimal_NUMBER}');
    Error('\P{/a/ -Decimal_NUMBER}');
    Expect(1, 125273, '\p{decimalnumber}', "");
    Expect(0, 125273, '\p{^decimalnumber}', "");
    Expect(0, 125273, '\P{decimalnumber}', "");
    Expect(1, 125273, '\P{^decimalnumber}', "");
    Expect(0, 125274, '\p{decimalnumber}', "");
    Expect(1, 125274, '\p{^decimalnumber}', "");
    Expect(1, 125274, '\P{decimalnumber}', "");
    Expect(0, 125274, '\P{^decimalnumber}', "");
    Expect(1, 125273, '\p{	Decimal_Number}', "");
    Expect(0, 125273, '\p{^	Decimal_Number}', "");
    Expect(0, 125273, '\P{	Decimal_Number}', "");
    Expect(1, 125273, '\P{^	Decimal_Number}', "");
    Expect(0, 125274, '\p{	Decimal_Number}', "");
    Expect(1, 125274, '\p{^	Decimal_Number}', "");
    Expect(1, 125274, '\P{	Decimal_Number}', "");
    Expect(0, 125274, '\P{^	Decimal_Number}', "");
    Error('\p{-/a/Is_DECIMAL_Number}');
    Error('\P{-/a/Is_DECIMAL_Number}');
    Expect(1, 125273, '\p{isdecimalnumber}', "");
    Expect(0, 125273, '\p{^isdecimalnumber}', "");
    Expect(0, 125273, '\P{isdecimalnumber}', "");
    Expect(1, 125273, '\P{^isdecimalnumber}', "");
    Expect(0, 125274, '\p{isdecimalnumber}', "");
    Expect(1, 125274, '\p{^isdecimalnumber}', "");
    Expect(1, 125274, '\P{isdecimalnumber}', "");
    Expect(0, 125274, '\P{^isdecimalnumber}', "");
    Expect(1, 125273, '\p{	_Is_Decimal_Number}', "");
    Expect(0, 125273, '\p{^	_Is_Decimal_Number}', "");
    Expect(0, 125273, '\P{	_Is_Decimal_Number}', "");
    Expect(1, 125273, '\P{^	_Is_Decimal_Number}', "");
    Expect(0, 125274, '\p{	_Is_Decimal_Number}', "");
    Expect(1, 125274, '\p{^	_Is_Decimal_Number}', "");
    Expect(1, 125274, '\P{	_Is_Decimal_Number}', "");
    Expect(0, 125274, '\P{^	_Is_Decimal_Number}', "");
    Error('\p{:= _nd}');
    Error('\P{:= _nd}');
    Expect(1, 125273, '\p{nd}', "");
    Expect(0, 125273, '\p{^nd}', "");
    Expect(0, 125273, '\P{nd}', "");
    Expect(1, 125273, '\P{^nd}', "");
    Expect(0, 125274, '\p{nd}', "");
    Expect(1, 125274, '\p{^nd}', "");
    Expect(1, 125274, '\P{nd}', "");
    Expect(0, 125274, '\P{^nd}', "");
    Expect(1, 125273, '\p{	Nd}', "");
    Expect(0, 125273, '\p{^	Nd}', "");
    Expect(0, 125273, '\P{	Nd}', "");
    Expect(1, 125273, '\P{^	Nd}', "");
    Expect(0, 125274, '\p{	Nd}', "");
    Expect(1, 125274, '\p{^	Nd}', "");
    Expect(1, 125274, '\P{	Nd}', "");
    Expect(0, 125274, '\P{^	Nd}', "");
    Error('\p{_:=is_Nd}');
    Error('\P{_:=is_Nd}');
    Expect(1, 125273, '\p{isnd}', "");
    Expect(0, 125273, '\p{^isnd}', "");
    Expect(0, 125273, '\P{isnd}', "");
    Expect(1, 125273, '\P{^isnd}', "");
    Expect(0, 125274, '\p{isnd}', "");
    Expect(1, 125274, '\p{^isnd}', "");
    Expect(1, 125274, '\P{isnd}', "");
    Expect(0, 125274, '\P{^isnd}', "");
    Expect(1, 125273, '\p{_Is_nd}', "");
    Expect(0, 125273, '\p{^_Is_nd}', "");
    Expect(0, 125273, '\P{_Is_nd}', "");
    Expect(1, 125273, '\P{^_Is_nd}', "");
    Expect(0, 125274, '\p{_Is_nd}', "");
    Expect(1, 125274, '\p{^_Is_nd}', "");
    Expect(1, 125274, '\P{_Is_nd}', "");
    Expect(0, 125274, '\P{^_Is_nd}', "");
    Error('\p{/a/dingbats}');
    Error('\P{/a/dingbats}');
    Expect(1, 10175, '\p{dingbats}', "");
    Expect(0, 10175, '\p{^dingbats}', "");
    Expect(0, 10175, '\P{dingbats}', "");
    Expect(1, 10175, '\P{^dingbats}', "");
    Expect(0, 10176, '\p{dingbats}', "");
    Expect(1, 10176, '\p{^dingbats}', "");
    Expect(1, 10176, '\P{dingbats}', "");
    Expect(0, 10176, '\P{^dingbats}', "");
    Expect(1, 10175, '\p{	-Dingbats}', "");
    Expect(0, 10175, '\p{^	-Dingbats}', "");
    Expect(0, 10175, '\P{	-Dingbats}', "");
    Expect(1, 10175, '\P{^	-Dingbats}', "");
    Expect(0, 10176, '\p{	-Dingbats}', "");
    Expect(1, 10176, '\p{^	-Dingbats}', "");
    Expect(1, 10176, '\P{	-Dingbats}', "");
    Expect(0, 10176, '\P{^	-Dingbats}', "");
    Error('\p{_IS_DINGBATS:=}');
    Error('\P{_IS_DINGBATS:=}');
    Expect(1, 10175, '\p{isdingbats}', "");
    Expect(0, 10175, '\p{^isdingbats}', "");
    Expect(0, 10175, '\P{isdingbats}', "");
    Expect(1, 10175, '\P{^isdingbats}', "");
    Expect(0, 10176, '\p{isdingbats}', "");
    Expect(1, 10176, '\p{^isdingbats}', "");
    Expect(1, 10176, '\P{isdingbats}', "");
    Expect(0, 10176, '\P{^isdingbats}', "");
    Expect(1, 10175, '\p{	 Is_dingbats}', "");
    Expect(0, 10175, '\p{^	 Is_dingbats}', "");
    Expect(0, 10175, '\P{	 Is_dingbats}', "");
    Expect(1, 10175, '\P{^	 Is_dingbats}', "");
    Expect(0, 10176, '\p{	 Is_dingbats}', "");
    Expect(1, 10176, '\p{^	 Is_dingbats}', "");
    Expect(1, 10176, '\P{	 Is_dingbats}', "");
    Expect(0, 10176, '\P{^	 Is_dingbats}', "");
    Error('\p{/a/In_Dingbats}');
    Error('\P{/a/In_Dingbats}');
    Expect(1, 10175, '\p{indingbats}', "");
    Expect(0, 10175, '\p{^indingbats}', "");
    Expect(0, 10175, '\P{indingbats}', "");
    Expect(1, 10175, '\P{^indingbats}', "");
    Expect(0, 10176, '\p{indingbats}', "");
    Expect(1, 10176, '\p{^indingbats}', "");
    Expect(1, 10176, '\P{indingbats}', "");
    Expect(0, 10176, '\P{^indingbats}', "");
    Expect(1, 10175, '\p{		in_Dingbats}', "");
    Expect(0, 10175, '\p{^		in_Dingbats}', "");
    Expect(0, 10175, '\P{		in_Dingbats}', "");
    Expect(1, 10175, '\P{^		in_Dingbats}', "");
    Expect(0, 10176, '\p{		in_Dingbats}', "");
    Expect(1, 10176, '\p{^		in_Dingbats}', "");
    Expect(1, 10176, '\P{		in_Dingbats}', "");
    Expect(0, 10176, '\P{^		in_Dingbats}', "");
    Error('\p{-/a/dogra}');
    Error('\P{-/a/dogra}');
    Expect(1, 71739, '\p{dogra}', "");
    Expect(0, 71739, '\p{^dogra}', "");
    Expect(0, 71739, '\P{dogra}', "");
    Expect(1, 71739, '\P{^dogra}', "");
    Expect(0, 71740, '\p{dogra}', "");
    Expect(1, 71740, '\p{^dogra}', "");
    Expect(1, 71740, '\P{dogra}', "");
    Expect(0, 71740, '\P{^dogra}', "");
    Expect(1, 71739, '\p{	-DOGRA}', "");
    Expect(0, 71739, '\p{^	-DOGRA}', "");
    Expect(0, 71739, '\P{	-DOGRA}', "");
    Expect(1, 71739, '\P{^	-DOGRA}', "");
    Expect(0, 71740, '\p{	-DOGRA}', "");
    Expect(1, 71740, '\p{^	-DOGRA}', "");
    Expect(1, 71740, '\P{	-DOGRA}', "");
    Expect(0, 71740, '\P{^	-DOGRA}', "");
    Error('\p{	is_Dogra/a/}');
    Error('\P{	is_Dogra/a/}');
    Expect(1, 71739, '\p{isdogra}', "");
    Expect(0, 71739, '\p{^isdogra}', "");
    Expect(0, 71739, '\P{isdogra}', "");
    Expect(1, 71739, '\P{^isdogra}', "");
    Expect(0, 71740, '\p{isdogra}', "");
    Expect(1, 71740, '\p{^isdogra}', "");
    Expect(1, 71740, '\P{isdogra}', "");
    Expect(0, 71740, '\P{^isdogra}', "");
    Expect(1, 71739, '\p{	_Is_dogra}', "");
    Expect(0, 71739, '\p{^	_Is_dogra}', "");
    Expect(0, 71739, '\P{	_Is_dogra}', "");
    Expect(1, 71739, '\P{^	_Is_dogra}', "");
    Expect(0, 71740, '\p{	_Is_dogra}', "");
    Expect(1, 71740, '\p{^	_Is_dogra}', "");
    Expect(1, 71740, '\P{	_Is_dogra}', "");
    Expect(0, 71740, '\P{^	_Is_dogra}', "");
    Error('\p{:=-	Dogr}');
    Error('\P{:=-	Dogr}');
    Expect(1, 71739, '\p{dogr}', "");
    Expect(0, 71739, '\p{^dogr}', "");
    Expect(0, 71739, '\P{dogr}', "");
    Expect(1, 71739, '\P{^dogr}', "");
    Expect(0, 71740, '\p{dogr}', "");
    Expect(1, 71740, '\p{^dogr}', "");
    Expect(1, 71740, '\P{dogr}', "");
    Expect(0, 71740, '\P{^dogr}', "");
    Expect(1, 71739, '\p{	Dogr}', "");
    Expect(0, 71739, '\p{^	Dogr}', "");
    Expect(0, 71739, '\P{	Dogr}', "");
    Expect(1, 71739, '\P{^	Dogr}', "");
    Expect(0, 71740, '\p{	Dogr}', "");
    Expect(1, 71740, '\p{^	Dogr}', "");
    Expect(1, 71740, '\P{	Dogr}', "");
    Expect(0, 71740, '\P{^	Dogr}', "");
    Error('\p{ :=Is_DOGR}');
    Error('\P{ :=Is_DOGR}');
    Expect(1, 71739, '\p{isdogr}', "");
    Expect(0, 71739, '\p{^isdogr}', "");
    Expect(0, 71739, '\P{isdogr}', "");
    Expect(1, 71739, '\P{^isdogr}', "");
    Expect(0, 71740, '\p{isdogr}', "");
    Expect(1, 71740, '\p{^isdogr}', "");
    Expect(1, 71740, '\P{isdogr}', "");
    Expect(0, 71740, '\P{^isdogr}', "");
    Expect(1, 71739, '\p{	_Is_DOGR}', "");
    Expect(0, 71739, '\p{^	_Is_DOGR}', "");
    Expect(0, 71739, '\P{	_Is_DOGR}', "");
    Expect(1, 71739, '\P{^	_Is_DOGR}', "");
    Expect(0, 71740, '\p{	_Is_DOGR}', "");
    Expect(1, 71740, '\p{^	_Is_DOGR}', "");
    Expect(1, 71740, '\P{	_Is_DOGR}', "");
    Expect(0, 71740, '\P{^	_Is_DOGR}', "");
    Error('\p{:=_	Domino_Tiles}');
    Error('\P{:=_	Domino_Tiles}');
    Expect(1, 127135, '\p{dominotiles}', "");
    Expect(0, 127135, '\p{^dominotiles}', "");
    Expect(0, 127135, '\P{dominotiles}', "");
    Expect(1, 127135, '\P{^dominotiles}', "");
    Expect(0, 127136, '\p{dominotiles}', "");
    Expect(1, 127136, '\p{^dominotiles}', "");
    Expect(1, 127136, '\P{dominotiles}', "");
    Expect(0, 127136, '\P{^dominotiles}', "");
    Expect(1, 127135, '\p{- Domino_Tiles}', "");
    Expect(0, 127135, '\p{^- Domino_Tiles}', "");
    Expect(0, 127135, '\P{- Domino_Tiles}', "");
    Expect(1, 127135, '\P{^- Domino_Tiles}', "");
    Expect(0, 127136, '\p{- Domino_Tiles}', "");
    Expect(1, 127136, '\p{^- Domino_Tiles}', "");
    Expect(1, 127136, '\P{- Domino_Tiles}', "");
    Expect(0, 127136, '\P{^- Domino_Tiles}', "");
    Error('\p{-/a/is_Domino_Tiles}');
    Error('\P{-/a/is_Domino_Tiles}');
    Expect(1, 127135, '\p{isdominotiles}', "");
    Expect(0, 127135, '\p{^isdominotiles}', "");
    Expect(0, 127135, '\P{isdominotiles}', "");
    Expect(1, 127135, '\P{^isdominotiles}', "");
    Expect(0, 127136, '\p{isdominotiles}', "");
    Expect(1, 127136, '\p{^isdominotiles}', "");
    Expect(1, 127136, '\P{isdominotiles}', "");
    Expect(0, 127136, '\P{^isdominotiles}', "");
    Expect(1, 127135, '\p{ IS_DOMINO_TILES}', "");
    Expect(0, 127135, '\p{^ IS_DOMINO_TILES}', "");
    Expect(0, 127135, '\P{ IS_DOMINO_TILES}', "");
    Expect(1, 127135, '\P{^ IS_DOMINO_TILES}', "");
    Expect(0, 127136, '\p{ IS_DOMINO_TILES}', "");
    Expect(1, 127136, '\p{^ IS_DOMINO_TILES}', "");
    Expect(1, 127136, '\P{ IS_DOMINO_TILES}', "");
    Expect(0, 127136, '\P{^ IS_DOMINO_TILES}', "");
    Error('\p{/a/_	In_Domino_Tiles}');
    Error('\P{/a/_	In_Domino_Tiles}');
    Expect(1, 127135, '\p{indominotiles}', "");
    Expect(0, 127135, '\p{^indominotiles}', "");
    Expect(0, 127135, '\P{indominotiles}', "");
    Expect(1, 127135, '\P{^indominotiles}', "");
    Expect(0, 127136, '\p{indominotiles}', "");
    Expect(1, 127136, '\p{^indominotiles}', "");
    Expect(1, 127136, '\P{indominotiles}', "");
    Expect(0, 127136, '\P{^indominotiles}', "");
    Expect(1, 127135, '\p{	_In_Domino_Tiles}', "");
    Expect(0, 127135, '\p{^	_In_Domino_Tiles}', "");
    Expect(0, 127135, '\P{	_In_Domino_Tiles}', "");
    Expect(1, 127135, '\P{^	_In_Domino_Tiles}', "");
    Expect(0, 127136, '\p{	_In_Domino_Tiles}', "");
    Expect(1, 127136, '\p{^	_In_Domino_Tiles}', "");
    Expect(1, 127136, '\P{	_In_Domino_Tiles}', "");
    Expect(0, 127136, '\P{^	_In_Domino_Tiles}', "");
    Error('\p{ 	Domino:=}');
    Error('\P{ 	Domino:=}');
    Expect(1, 127135, '\p{domino}', "");
    Expect(0, 127135, '\p{^domino}', "");
    Expect(0, 127135, '\P{domino}', "");
    Expect(1, 127135, '\P{^domino}', "");
    Expect(0, 127136, '\p{domino}', "");
    Expect(1, 127136, '\p{^domino}', "");
    Expect(1, 127136, '\P{domino}', "");
    Expect(0, 127136, '\P{^domino}', "");
    Expect(1, 127135, '\p{_	Domino}', "");
    Expect(0, 127135, '\p{^_	Domino}', "");
    Expect(0, 127135, '\P{_	Domino}', "");
    Expect(1, 127135, '\P{^_	Domino}', "");
    Expect(0, 127136, '\p{_	Domino}', "");
    Expect(1, 127136, '\p{^_	Domino}', "");
    Expect(1, 127136, '\P{_	Domino}', "");
    Expect(0, 127136, '\P{^_	Domino}', "");
    Error('\p{/a/Is_Domino}');
    Error('\P{/a/Is_Domino}');
    Expect(1, 127135, '\p{isdomino}', "");
    Expect(0, 127135, '\p{^isdomino}', "");
    Expect(0, 127135, '\P{isdomino}', "");
    Expect(1, 127135, '\P{^isdomino}', "");
    Expect(0, 127136, '\p{isdomino}', "");
    Expect(1, 127136, '\p{^isdomino}', "");
    Expect(1, 127136, '\P{isdomino}', "");
    Expect(0, 127136, '\P{^isdomino}', "");
    Expect(1, 127135, '\p{--Is_domino}', "");
    Expect(0, 127135, '\p{^--Is_domino}', "");
    Expect(0, 127135, '\P{--Is_domino}', "");
    Expect(1, 127135, '\P{^--Is_domino}', "");
    Expect(0, 127136, '\p{--Is_domino}', "");
    Expect(1, 127136, '\p{^--Is_domino}', "");
    Expect(1, 127136, '\P{--Is_domino}', "");
    Expect(0, 127136, '\P{^--Is_domino}', "");
    Error('\p{_ IN_Domino/a/}');
    Error('\P{_ IN_Domino/a/}');
    Expect(1, 127135, '\p{indomino}', "");
    Expect(0, 127135, '\p{^indomino}', "");
    Expect(0, 127135, '\P{indomino}', "");
    Expect(1, 127135, '\P{^indomino}', "");
    Expect(0, 127136, '\p{indomino}', "");
    Expect(1, 127136, '\p{^indomino}', "");
    Expect(1, 127136, '\P{indomino}', "");
    Expect(0, 127136, '\P{^indomino}', "");
    Expect(1, 127135, '\p{	 IN_Domino}', "");
    Expect(0, 127135, '\p{^	 IN_Domino}', "");
    Expect(0, 127135, '\P{	 IN_Domino}', "");
    Expect(1, 127135, '\P{^	 IN_Domino}', "");
    Expect(0, 127136, '\p{	 IN_Domino}', "");
    Expect(1, 127136, '\p{^	 IN_Domino}', "");
    Expect(1, 127136, '\P{	 IN_Domino}', "");
    Expect(0, 127136, '\P{^	 IN_Domino}', "");
    Error('\p{_:=DUPLOYAN}');
    Error('\P{_:=DUPLOYAN}');
    Expect(1, 113827, '\p{duployan}', "");
    Expect(0, 113827, '\p{^duployan}', "");
    Expect(0, 113827, '\P{duployan}', "");
    Expect(1, 113827, '\P{^duployan}', "");
    Expect(0, 113828, '\p{duployan}', "");
    Expect(1, 113828, '\p{^duployan}', "");
    Expect(1, 113828, '\P{duployan}', "");
    Expect(0, 113828, '\P{^duployan}', "");
    Expect(1, 113827, '\p{-duployan}', "");
    Expect(0, 113827, '\p{^-duployan}', "");
    Expect(0, 113827, '\P{-duployan}', "");
    Expect(1, 113827, '\P{^-duployan}', "");
    Expect(0, 113828, '\p{-duployan}', "");
    Expect(1, 113828, '\p{^-duployan}', "");
    Expect(1, 113828, '\P{-duployan}', "");
    Expect(0, 113828, '\P{^-duployan}', "");
    Error('\p{_Is_Duployan/a/}');
    Error('\P{_Is_Duployan/a/}');
    Expect(1, 113827, '\p{isduployan}', "");
    Expect(0, 113827, '\p{^isduployan}', "");
    Expect(0, 113827, '\P{isduployan}', "");
    Expect(1, 113827, '\P{^isduployan}', "");
    Expect(0, 113828, '\p{isduployan}', "");
    Expect(1, 113828, '\p{^isduployan}', "");
    Expect(1, 113828, '\P{isduployan}', "");
    Expect(0, 113828, '\P{^isduployan}', "");
    Expect(1, 113827, '\p{ is_Duployan}', "");
    Expect(0, 113827, '\p{^ is_Duployan}', "");
    Expect(0, 113827, '\P{ is_Duployan}', "");
    Expect(1, 113827, '\P{^ is_Duployan}', "");
    Expect(0, 113828, '\p{ is_Duployan}', "");
    Expect(1, 113828, '\p{^ is_Duployan}', "");
    Expect(1, 113828, '\P{ is_Duployan}', "");
    Expect(0, 113828, '\P{^ is_Duployan}', "");
    Error('\p{_ Dupl:=}');
    Error('\P{_ Dupl:=}');
    Expect(1, 113827, '\p{dupl}', "");
    Expect(0, 113827, '\p{^dupl}', "");
    Expect(0, 113827, '\P{dupl}', "");
    Expect(1, 113827, '\P{^dupl}', "");
    Expect(0, 113828, '\p{dupl}', "");
    Expect(1, 113828, '\p{^dupl}', "");
    Expect(1, 113828, '\P{dupl}', "");
    Expect(0, 113828, '\P{^dupl}', "");
    Expect(1, 113827, '\p{	 Dupl}', "");
    Expect(0, 113827, '\p{^	 Dupl}', "");
    Expect(0, 113827, '\P{	 Dupl}', "");
    Expect(1, 113827, '\P{^	 Dupl}', "");
    Expect(0, 113828, '\p{	 Dupl}', "");
    Expect(1, 113828, '\p{^	 Dupl}', "");
    Expect(1, 113828, '\P{	 Dupl}', "");
    Expect(0, 113828, '\P{^	 Dupl}', "");
    Error('\p{:=is_Dupl}');
    Error('\P{:=is_Dupl}');
    Expect(1, 113827, '\p{isdupl}', "");
    Expect(0, 113827, '\p{^isdupl}', "");
    Expect(0, 113827, '\P{isdupl}', "");
    Expect(1, 113827, '\P{^isdupl}', "");
    Expect(0, 113828, '\p{isdupl}', "");
    Expect(1, 113828, '\p{^isdupl}', "");
    Expect(1, 113828, '\P{isdupl}', "");
    Expect(0, 113828, '\P{^isdupl}', "");
    Expect(1, 113827, '\p{__is_dupl}', "");
    Expect(0, 113827, '\p{^__is_dupl}', "");
    Expect(0, 113827, '\P{__is_dupl}', "");
    Expect(1, 113827, '\P{^__is_dupl}', "");
    Expect(0, 113828, '\p{__is_dupl}', "");
    Expect(1, 113828, '\p{^__is_dupl}', "");
    Expect(1, 113828, '\P{__is_dupl}', "");
    Expect(0, 113828, '\P{^__is_dupl}', "");
    Error('\p{/a/ early_dynastic_Cuneiform}');
    Error('\P{/a/ early_dynastic_Cuneiform}');
    Expect(1, 75087, '\p{earlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^earlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{earlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^earlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{earlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^earlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{earlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^earlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{ 	Early_DYNASTIC_CUNEIFORM}', "");
    Expect(0, 75087, '\p{^ 	Early_DYNASTIC_CUNEIFORM}', "");
    Expect(0, 75087, '\P{ 	Early_DYNASTIC_CUNEIFORM}', "");
    Expect(1, 75087, '\P{^ 	Early_DYNASTIC_CUNEIFORM}', "");
    Expect(0, 75088, '\p{ 	Early_DYNASTIC_CUNEIFORM}', "");
    Expect(1, 75088, '\p{^ 	Early_DYNASTIC_CUNEIFORM}', "");
    Expect(1, 75088, '\P{ 	Early_DYNASTIC_CUNEIFORM}', "");
    Expect(0, 75088, '\P{^ 	Early_DYNASTIC_CUNEIFORM}', "");
    Error('\p{--IS_early_DYNASTIC_Cuneiform/a/}');
    Error('\P{--IS_early_DYNASTIC_Cuneiform/a/}');
    Expect(1, 75087, '\p{isearlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^isearlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{isearlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^isearlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{isearlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^isearlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{isearlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^isearlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{-Is_Early_DYNASTIC_Cuneiform}', "");
    Expect(0, 75087, '\p{^-Is_Early_DYNASTIC_Cuneiform}', "");
    Expect(0, 75087, '\P{-Is_Early_DYNASTIC_Cuneiform}', "");
    Expect(1, 75087, '\P{^-Is_Early_DYNASTIC_Cuneiform}', "");
    Expect(0, 75088, '\p{-Is_Early_DYNASTIC_Cuneiform}', "");
    Expect(1, 75088, '\p{^-Is_Early_DYNASTIC_Cuneiform}', "");
    Expect(1, 75088, '\P{-Is_Early_DYNASTIC_Cuneiform}', "");
    Expect(0, 75088, '\P{^-Is_Early_DYNASTIC_Cuneiform}', "");
    Error('\p{/a/-	In_early_Dynastic_Cuneiform}');
    Error('\P{/a/-	In_early_Dynastic_Cuneiform}');
    Expect(1, 75087, '\p{inearlydynasticcuneiform}', "");
    Expect(0, 75087, '\p{^inearlydynasticcuneiform}', "");
    Expect(0, 75087, '\P{inearlydynasticcuneiform}', "");
    Expect(1, 75087, '\P{^inearlydynasticcuneiform}', "");
    Expect(0, 75088, '\p{inearlydynasticcuneiform}', "");
    Expect(1, 75088, '\p{^inearlydynasticcuneiform}', "");
    Expect(1, 75088, '\P{inearlydynasticcuneiform}', "");
    Expect(0, 75088, '\P{^inearlydynasticcuneiform}', "");
    Expect(1, 75087, '\p{ IN_Early_DYNASTIC_cuneiform}', "");
    Expect(0, 75087, '\p{^ IN_Early_DYNASTIC_cuneiform}', "");
    Expect(0, 75087, '\P{ IN_Early_DYNASTIC_cuneiform}', "");
    Expect(1, 75087, '\P{^ IN_Early_DYNASTIC_cuneiform}', "");
    Expect(0, 75088, '\p{ IN_Early_DYNASTIC_cuneiform}', "");
    Expect(1, 75088, '\p{^ IN_Early_DYNASTIC_cuneiform}', "");
    Expect(1, 75088, '\P{ IN_Early_DYNASTIC_cuneiform}', "");
    Expect(0, 75088, '\P{^ IN_Early_DYNASTIC_cuneiform}', "");
    Error('\p{	/a/EGYPTIAN_HIEROGLYPH_Format_controls}');
    Error('\P{	/a/EGYPTIAN_HIEROGLYPH_Format_controls}');
    Expect(1, 78911, '\p{egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\p{^egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\P{egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\P{^egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\p{egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\p{^egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\P{egyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\P{^egyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\p{	 EGYPTIAN_Hieroglyph_FORMAT_Controls}', "");
    Expect(0, 78911, '\p{^	 EGYPTIAN_Hieroglyph_FORMAT_Controls}', "");
    Expect(0, 78911, '\P{	 EGYPTIAN_Hieroglyph_FORMAT_Controls}', "");
    Expect(1, 78911, '\P{^	 EGYPTIAN_Hieroglyph_FORMAT_Controls}', "");
    Expect(0, 78912, '\p{	 EGYPTIAN_Hieroglyph_FORMAT_Controls}', "");
    Expect(1, 78912, '\p{^	 EGYPTIAN_Hieroglyph_FORMAT_Controls}', "");
    Expect(1, 78912, '\P{	 EGYPTIAN_Hieroglyph_FORMAT_Controls}', "");
    Expect(0, 78912, '\P{^	 EGYPTIAN_Hieroglyph_FORMAT_Controls}', "");
    Error('\p{		Is_Egyptian_HIEROGLYPH_FORMAT_CONTROLS/a/}');
    Error('\P{		Is_Egyptian_HIEROGLYPH_FORMAT_CONTROLS/a/}');
    Expect(1, 78911, '\p{isegyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\p{^isegyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\P{isegyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\P{^isegyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\p{isegyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\p{^isegyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\P{isegyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\P{^isegyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\p{-_Is_egyptian_Hieroglyph_FORMAT_CONTROLS}', "");
    Expect(0, 78911, '\p{^-_Is_egyptian_Hieroglyph_FORMAT_CONTROLS}', "");
    Expect(0, 78911, '\P{-_Is_egyptian_Hieroglyph_FORMAT_CONTROLS}', "");
    Expect(1, 78911, '\P{^-_Is_egyptian_Hieroglyph_FORMAT_CONTROLS}', "");
    Expect(0, 78912, '\p{-_Is_egyptian_Hieroglyph_FORMAT_CONTROLS}', "");
    Expect(1, 78912, '\p{^-_Is_egyptian_Hieroglyph_FORMAT_CONTROLS}', "");
    Expect(1, 78912, '\P{-_Is_egyptian_Hieroglyph_FORMAT_CONTROLS}', "");
    Expect(0, 78912, '\P{^-_Is_egyptian_Hieroglyph_FORMAT_CONTROLS}', "");
    Error('\p{:=	in_Egyptian_hieroglyph_FORMAT_CONTROLS}');
    Error('\P{:=	in_Egyptian_hieroglyph_FORMAT_CONTROLS}');
    Expect(1, 78911, '\p{inegyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\p{^inegyptianhieroglyphformatcontrols}', "");
    Expect(0, 78911, '\P{inegyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\P{^inegyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\p{inegyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\p{^inegyptianhieroglyphformatcontrols}', "");
    Expect(1, 78912, '\P{inegyptianhieroglyphformatcontrols}', "");
    Expect(0, 78912, '\P{^inegyptianhieroglyphformatcontrols}', "");
    Expect(1, 78911, '\p{In_egyptian_hieroglyph_format_Controls}', "");
    Expect(0, 78911, '\p{^In_egyptian_hieroglyph_format_Controls}', "");
    Expect(0, 78911, '\P{In_egyptian_hieroglyph_format_Controls}', "");
    Expect(1, 78911, '\P{^In_egyptian_hieroglyph_format_Controls}', "");
    Expect(0, 78912, '\p{In_egyptian_hieroglyph_format_Controls}', "");
    Expect(1, 78912, '\p{^In_egyptian_hieroglyph_format_Controls}', "");
    Expect(1, 78912, '\P{In_egyptian_hieroglyph_format_Controls}', "");
    Expect(0, 78912, '\P{^In_egyptian_hieroglyph_format_Controls}', "");
    Error('\p{/a/  egyptian_Hieroglyphs}');
    Error('\P{/a/  egyptian_Hieroglyphs}');
    Expect(1, 78904, '\p{egyptianhieroglyphs}', "");
    Expect(0, 78904, '\p{^egyptianhieroglyphs}', "");
    Expect(0, 78904, '\P{egyptianhieroglyphs}', "");
    Expect(1, 78904, '\P{^egyptianhieroglyphs}', "");
    Expect(0, 78905, '\p{egyptianhieroglyphs}', "");
    Expect(1, 78905, '\p{^egyptianhieroglyphs}', "");
    Expect(1, 78905, '\P{egyptianhieroglyphs}', "");
    Expect(0, 78905, '\P{^egyptianhieroglyphs}', "");
    Expect(1, 78904, '\p{ 	egyptian_Hieroglyphs}', "");
    Expect(0, 78904, '\p{^ 	egyptian_Hieroglyphs}', "");
    Expect(0, 78904, '\P{ 	egyptian_Hieroglyphs}', "");
    Expect(1, 78904, '\P{^ 	egyptian_Hieroglyphs}', "");
    Expect(0, 78905, '\p{ 	egyptian_Hieroglyphs}', "");
    Expect(1, 78905, '\p{^ 	egyptian_Hieroglyphs}', "");
    Expect(1, 78905, '\P{ 	egyptian_Hieroglyphs}', "");
    Expect(0, 78905, '\P{^ 	egyptian_Hieroglyphs}', "");
    Error('\p{_/a/is_EGYPTIAN_hieroglyphs}');
    Error('\P{_/a/is_EGYPTIAN_hieroglyphs}');
    Expect(1, 78904, '\p{isegyptianhieroglyphs}', "");
    Expect(0, 78904, '\p{^isegyptianhieroglyphs}', "");
    Expect(0, 78904, '\P{isegyptianhieroglyphs}', "");
    Expect(1, 78904, '\P{^isegyptianhieroglyphs}', "");
    Expect(0, 78905, '\p{isegyptianhieroglyphs}', "");
    Expect(1, 78905, '\p{^isegyptianhieroglyphs}', "");
    Expect(1, 78905, '\P{isegyptianhieroglyphs}', "");
    Expect(0, 78905, '\P{^isegyptianhieroglyphs}', "");
    Expect(1, 78904, '\p{- is_Egyptian_Hieroglyphs}', "");
    Expect(0, 78904, '\p{^- is_Egyptian_Hieroglyphs}', "");
    Expect(0, 78904, '\P{- is_Egyptian_Hieroglyphs}', "");
    Expect(1, 78904, '\P{^- is_Egyptian_Hieroglyphs}', "");
    Expect(0, 78905, '\p{- is_Egyptian_Hieroglyphs}', "");
    Expect(1, 78905, '\p{^- is_Egyptian_Hieroglyphs}', "");
    Expect(1, 78905, '\P{- is_Egyptian_Hieroglyphs}', "");
    Expect(0, 78905, '\P{^- is_Egyptian_Hieroglyphs}', "");
    Error('\p{:=--egyp}');
    Error('\P{:=--egyp}');
    Expect(1, 78904, '\p{egyp}', "");
    Expect(0, 78904, '\p{^egyp}', "");
    Expect(0, 78904, '\P{egyp}', "");
    Expect(1, 78904, '\P{^egyp}', "");
    Expect(0, 78905, '\p{egyp}', "");
    Expect(1, 78905, '\p{^egyp}', "");
    Expect(1, 78905, '\P{egyp}', "");
    Expect(0, 78905, '\P{^egyp}', "");
    Expect(1, 78904, '\p{	 Egyp}', "");
    Expect(0, 78904, '\p{^	 Egyp}', "");
    Expect(0, 78904, '\P{	 Egyp}', "");
    Expect(1, 78904, '\P{^	 Egyp}', "");
    Expect(0, 78905, '\p{	 Egyp}', "");
    Expect(1, 78905, '\p{^	 Egyp}', "");
    Expect(1, 78905, '\P{	 Egyp}', "");
    Expect(0, 78905, '\P{^	 Egyp}', "");
    Error('\p{/a/ Is_Egyp}');
    Error('\P{/a/ Is_Egyp}');
    Expect(1, 78904, '\p{isegyp}', "");
    Expect(0, 78904, '\p{^isegyp}', "");
    Expect(0, 78904, '\P{isegyp}', "");
    Expect(1, 78904, '\P{^isegyp}', "");
    Expect(0, 78905, '\p{isegyp}', "");
    Expect(1, 78905, '\p{^isegyp}', "");
    Expect(1, 78905, '\P{isegyp}', "");
    Expect(0, 78905, '\P{^isegyp}', "");
    Expect(1, 78904, '\p{-_Is_EGYP}', "");
    Expect(0, 78904, '\p{^-_Is_EGYP}', "");
    Expect(0, 78904, '\P{-_Is_EGYP}', "");
    Expect(1, 78904, '\P{^-_Is_EGYP}', "");
    Expect(0, 78905, '\p{-_Is_EGYP}', "");
    Expect(1, 78905, '\p{^-_Is_EGYP}', "");
    Expect(1, 78905, '\P{-_Is_EGYP}', "");
    Expect(0, 78905, '\P{^-_Is_EGYP}', "");
    Error('\p{/a/_ ELBASAN}');
    Error('\P{/a/_ ELBASAN}');
    Expect(1, 66855, '\p{elbasan}', "");
    Expect(0, 66855, '\p{^elbasan}', "");
    Expect(0, 66855, '\P{elbasan}', "");
    Expect(1, 66855, '\P{^elbasan}', "");
    Expect(0, 66856, '\p{elbasan}', "");
    Expect(1, 66856, '\p{^elbasan}', "");
    Expect(1, 66856, '\P{elbasan}', "");
    Expect(0, 66856, '\P{^elbasan}', "");
    Expect(1, 66855, '\p{_-Elbasan}', "");
    Expect(0, 66855, '\p{^_-Elbasan}', "");
    Expect(0, 66855, '\P{_-Elbasan}', "");
    Expect(1, 66855, '\P{^_-Elbasan}', "");
    Expect(0, 66856, '\p{_-Elbasan}', "");
    Expect(1, 66856, '\p{^_-Elbasan}', "");
    Expect(1, 66856, '\P{_-Elbasan}', "");
    Expect(0, 66856, '\P{^_-Elbasan}', "");
    Error('\p{ is_Elbasan:=}');
    Error('\P{ is_Elbasan:=}');
    Expect(1, 66855, '\p{iselbasan}', "");
    Expect(0, 66855, '\p{^iselbasan}', "");
    Expect(0, 66855, '\P{iselbasan}', "");
    Expect(1, 66855, '\P{^iselbasan}', "");
    Expect(0, 66856, '\p{iselbasan}', "");
    Expect(1, 66856, '\p{^iselbasan}', "");
    Expect(1, 66856, '\P{iselbasan}', "");
    Expect(0, 66856, '\P{^iselbasan}', "");
    Expect(1, 66855, '\p{	-IS_ELBASAN}', "");
    Expect(0, 66855, '\p{^	-IS_ELBASAN}', "");
    Expect(0, 66855, '\P{	-IS_ELBASAN}', "");
    Expect(1, 66855, '\P{^	-IS_ELBASAN}', "");
    Expect(0, 66856, '\p{	-IS_ELBASAN}', "");
    Expect(1, 66856, '\p{^	-IS_ELBASAN}', "");
    Expect(1, 66856, '\P{	-IS_ELBASAN}', "");
    Expect(0, 66856, '\P{^	-IS_ELBASAN}', "");
    Error('\p{/a/- Elba}');
    Error('\P{/a/- Elba}');
    Expect(1, 66855, '\p{elba}', "");
    Expect(0, 66855, '\p{^elba}', "");
    Expect(0, 66855, '\P{elba}', "");
    Expect(1, 66855, '\P{^elba}', "");
    Expect(0, 66856, '\p{elba}', "");
    Expect(1, 66856, '\p{^elba}', "");
    Expect(1, 66856, '\P{elba}', "");
    Expect(0, 66856, '\P{^elba}', "");
    Expect(1, 66855, '\p{ elba}', "");
    Expect(0, 66855, '\p{^ elba}', "");
    Expect(0, 66855, '\P{ elba}', "");
    Expect(1, 66855, '\P{^ elba}', "");
    Expect(0, 66856, '\p{ elba}', "");
    Expect(1, 66856, '\p{^ elba}', "");
    Expect(1, 66856, '\P{ elba}', "");
    Expect(0, 66856, '\P{^ elba}', "");
    Error('\p{-IS_Elba:=}');
    Error('\P{-IS_Elba:=}');
    Expect(1, 66855, '\p{iselba}', "");
    Expect(0, 66855, '\p{^iselba}', "");
    Expect(0, 66855, '\P{iselba}', "");
    Expect(1, 66855, '\P{^iselba}', "");
    Expect(0, 66856, '\p{iselba}', "");
    Expect(1, 66856, '\p{^iselba}', "");
    Expect(1, 66856, '\P{iselba}', "");
    Expect(0, 66856, '\P{^iselba}', "");
    Expect(1, 66855, '\p{-Is_elba}', "");
    Expect(0, 66855, '\p{^-Is_elba}', "");
    Expect(0, 66855, '\P{-Is_elba}', "");
    Expect(1, 66855, '\P{^-Is_elba}', "");
    Expect(0, 66856, '\p{-Is_elba}', "");
    Expect(1, 66856, '\p{^-Is_elba}', "");
    Expect(1, 66856, '\P{-Is_elba}', "");
    Expect(0, 66856, '\P{^-Is_elba}', "");
    Error('\p{ /a/ELYMAIC}');
    Error('\P{ /a/ELYMAIC}');
    Expect(1, 69622, '\p{elymaic}', "");
    Expect(0, 69622, '\p{^elymaic}', "");
    Expect(0, 69622, '\P{elymaic}', "");
    Expect(1, 69622, '\P{^elymaic}', "");
    Expect(0, 69623, '\p{elymaic}', "");
    Expect(1, 69623, '\p{^elymaic}', "");
    Expect(1, 69623, '\P{elymaic}', "");
    Expect(0, 69623, '\P{^elymaic}', "");
    Expect(1, 69622, '\p{--Elymaic}', "");
    Expect(0, 69622, '\p{^--Elymaic}', "");
    Expect(0, 69622, '\P{--Elymaic}', "");
    Expect(1, 69622, '\P{^--Elymaic}', "");
    Expect(0, 69623, '\p{--Elymaic}', "");
    Expect(1, 69623, '\p{^--Elymaic}', "");
    Expect(1, 69623, '\P{--Elymaic}', "");
    Expect(0, 69623, '\P{^--Elymaic}', "");
    Error('\p{:= _is_elymaic}');
    Error('\P{:= _is_elymaic}');
    Expect(1, 69622, '\p{iselymaic}', "");
    Expect(0, 69622, '\p{^iselymaic}', "");
    Expect(0, 69622, '\P{iselymaic}', "");
    Expect(1, 69622, '\P{^iselymaic}', "");
    Expect(0, 69623, '\p{iselymaic}', "");
    Expect(1, 69623, '\p{^iselymaic}', "");
    Expect(1, 69623, '\P{iselymaic}', "");
    Expect(0, 69623, '\P{^iselymaic}', "");
    Expect(1, 69622, '\p{		is_ELYMAIC}', "");
    Expect(0, 69622, '\p{^		is_ELYMAIC}', "");
    Expect(0, 69622, '\P{		is_ELYMAIC}', "");
    Expect(1, 69622, '\P{^		is_ELYMAIC}', "");
    Expect(0, 69623, '\p{		is_ELYMAIC}', "");
    Expect(1, 69623, '\p{^		is_ELYMAIC}', "");
    Expect(1, 69623, '\P{		is_ELYMAIC}', "");
    Expect(0, 69623, '\P{^		is_ELYMAIC}', "");
    Error('\p{	ELYM/a/}');
    Error('\P{	ELYM/a/}');
    Expect(1, 69622, '\p{elym}', "");
    Expect(0, 69622, '\p{^elym}', "");
    Expect(0, 69622, '\P{elym}', "");
    Expect(1, 69622, '\P{^elym}', "");
    Expect(0, 69623, '\p{elym}', "");
    Expect(1, 69623, '\p{^elym}', "");
    Expect(1, 69623, '\P{elym}', "");
    Expect(0, 69623, '\P{^elym}', "");
    Expect(1, 69622, '\p{ _Elym}', "");
    Expect(0, 69622, '\p{^ _Elym}', "");
    Expect(0, 69622, '\P{ _Elym}', "");
    Expect(1, 69622, '\P{^ _Elym}', "");
    Expect(0, 69623, '\p{ _Elym}', "");
    Expect(1, 69623, '\p{^ _Elym}', "");
    Expect(1, 69623, '\P{ _Elym}', "");
    Expect(0, 69623, '\P{^ _Elym}', "");
    Error('\p{_:=is_ELYM}');
    Error('\P{_:=is_ELYM}');
    Expect(1, 69622, '\p{iselym}', "");
    Expect(0, 69622, '\p{^iselym}', "");
    Expect(0, 69622, '\P{iselym}', "");
    Expect(1, 69622, '\P{^iselym}', "");
    Expect(0, 69623, '\p{iselym}', "");
    Expect(1, 69623, '\p{^iselym}', "");
    Expect(1, 69623, '\P{iselym}', "");
    Expect(0, 69623, '\P{^iselym}', "");
    Expect(1, 69622, '\p{-	is_Elym}', "");
    Expect(0, 69622, '\p{^-	is_Elym}', "");
    Expect(0, 69622, '\P{-	is_Elym}', "");
    Expect(1, 69622, '\P{^-	is_Elym}', "");
    Expect(0, 69623, '\p{-	is_Elym}', "");
    Expect(1, 69623, '\p{^-	is_Elym}', "");
    Expect(1, 69623, '\P{-	is_Elym}', "");
    Expect(0, 69623, '\P{^-	is_Elym}', "");
    Error('\p{emoticons/a/}');
    Error('\P{emoticons/a/}');
    Expect(1, 128591, '\p{emoticons}', "");
    Expect(0, 128591, '\p{^emoticons}', "");
    Expect(0, 128591, '\P{emoticons}', "");
    Expect(1, 128591, '\P{^emoticons}', "");
    Expect(0, 128592, '\p{emoticons}', "");
    Expect(1, 128592, '\p{^emoticons}', "");
    Expect(1, 128592, '\P{emoticons}', "");
    Expect(0, 128592, '\P{^emoticons}', "");
    Expect(1, 128591, '\p{- Emoticons}', "");
    Expect(0, 128591, '\p{^- Emoticons}', "");
    Expect(0, 128591, '\P{- Emoticons}', "");
    Expect(1, 128591, '\P{^- Emoticons}', "");
    Expect(0, 128592, '\p{- Emoticons}', "");
    Expect(1, 128592, '\p{^- Emoticons}', "");
    Expect(1, 128592, '\P{- Emoticons}', "");
    Expect(0, 128592, '\P{^- Emoticons}', "");
    Error('\p{-/a/is_Emoticons}');
    Error('\P{-/a/is_Emoticons}');
    Expect(1, 128591, '\p{isemoticons}', "");
    Expect(0, 128591, '\p{^isemoticons}', "");
    Expect(0, 128591, '\P{isemoticons}', "");
    Expect(1, 128591, '\P{^isemoticons}', "");
    Expect(0, 128592, '\p{isemoticons}', "");
    Expect(1, 128592, '\p{^isemoticons}', "");
    Expect(1, 128592, '\P{isemoticons}', "");
    Expect(0, 128592, '\P{^isemoticons}', "");
    Expect(1, 128591, '\p{Is_Emoticons}', "");
    Expect(0, 128591, '\p{^Is_Emoticons}', "");
    Expect(0, 128591, '\P{Is_Emoticons}', "");
    Expect(1, 128591, '\P{^Is_Emoticons}', "");
    Expect(0, 128592, '\p{Is_Emoticons}', "");
    Expect(1, 128592, '\p{^Is_Emoticons}', "");
    Expect(1, 128592, '\P{Is_Emoticons}', "");
    Expect(0, 128592, '\P{^Is_Emoticons}', "");
    Error('\p{/a/ _IN_EMOTICONS}');
    Error('\P{/a/ _IN_EMOTICONS}');
    Expect(1, 128591, '\p{inemoticons}', "");
    Expect(0, 128591, '\p{^inemoticons}', "");
    Expect(0, 128591, '\P{inemoticons}', "");
    Expect(1, 128591, '\P{^inemoticons}', "");
    Expect(0, 128592, '\p{inemoticons}', "");
    Expect(1, 128592, '\p{^inemoticons}', "");
    Expect(1, 128592, '\P{inemoticons}', "");
    Expect(0, 128592, '\P{^inemoticons}', "");
    Expect(1, 128591, '\p{	-in_Emoticons}', "");
    Expect(0, 128591, '\p{^	-in_Emoticons}', "");
    Expect(0, 128591, '\P{	-in_Emoticons}', "");
    Expect(1, 128591, '\P{^	-in_Emoticons}', "");
    Expect(0, 128592, '\p{	-in_Emoticons}', "");
    Expect(1, 128592, '\p{^	-in_Emoticons}', "");
    Expect(1, 128592, '\P{	-in_Emoticons}', "");
    Expect(0, 128592, '\P{^	-in_Emoticons}', "");
    Error('\p{_ ENCLOSED_Alphanumeric_SUPPLEMENT/a/}');
    Error('\P{_ ENCLOSED_Alphanumeric_SUPPLEMENT/a/}');
    Expect(1, 127487, '\p{enclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\p{^enclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\P{enclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\P{^enclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\p{enclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\p{^enclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\P{enclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\P{^enclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\p{-Enclosed_alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127487, '\p{^-Enclosed_alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127487, '\P{-Enclosed_alphanumeric_SUPPLEMENT}', "");
    Expect(1, 127487, '\P{^-Enclosed_alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127488, '\p{-Enclosed_alphanumeric_SUPPLEMENT}', "");
    Expect(1, 127488, '\p{^-Enclosed_alphanumeric_SUPPLEMENT}', "");
    Expect(1, 127488, '\P{-Enclosed_alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127488, '\P{^-Enclosed_alphanumeric_SUPPLEMENT}', "");
    Error('\p{/a/ Is_enclosed_Alphanumeric_Supplement}');
    Error('\P{/a/ Is_enclosed_Alphanumeric_Supplement}');
    Expect(1, 127487, '\p{isenclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\p{^isenclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\P{isenclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\P{^isenclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\p{isenclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\p{^isenclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\P{isenclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\P{^isenclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\p{_	Is_Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127487, '\p{^_	Is_Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127487, '\P{_	Is_Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(1, 127487, '\P{^_	Is_Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127488, '\p{_	Is_Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(1, 127488, '\p{^_	Is_Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(1, 127488, '\P{_	Is_Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Expect(0, 127488, '\P{^_	Is_Enclosed_Alphanumeric_SUPPLEMENT}', "");
    Error('\p{:=-IN_ENCLOSED_Alphanumeric_SUPPLEMENT}');
    Error('\P{:=-IN_ENCLOSED_Alphanumeric_SUPPLEMENT}');
    Expect(1, 127487, '\p{inenclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\p{^inenclosedalphanumericsupplement}', "");
    Expect(0, 127487, '\P{inenclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\P{^inenclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\p{inenclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\p{^inenclosedalphanumericsupplement}', "");
    Expect(1, 127488, '\P{inenclosedalphanumericsupplement}', "");
    Expect(0, 127488, '\P{^inenclosedalphanumericsupplement}', "");
    Expect(1, 127487, '\p{_In_Enclosed_alphanumeric_supplement}', "");
    Expect(0, 127487, '\p{^_In_Enclosed_alphanumeric_supplement}', "");
    Expect(0, 127487, '\P{_In_Enclosed_alphanumeric_supplement}', "");
    Expect(1, 127487, '\P{^_In_Enclosed_alphanumeric_supplement}', "");
    Expect(0, 127488, '\p{_In_Enclosed_alphanumeric_supplement}', "");
    Expect(1, 127488, '\p{^_In_Enclosed_alphanumeric_supplement}', "");
    Expect(1, 127488, '\P{_In_Enclosed_alphanumeric_supplement}', "");
    Expect(0, 127488, '\P{^_In_Enclosed_alphanumeric_supplement}', "");
    Error('\p{/a/ _ENCLOSED_Alphanum_Sup}');
    Error('\P{/a/ _ENCLOSED_Alphanum_Sup}');
    Expect(1, 127487, '\p{enclosedalphanumsup}', "");
    Expect(0, 127487, '\p{^enclosedalphanumsup}', "");
    Expect(0, 127487, '\P{enclosedalphanumsup}', "");
    Expect(1, 127487, '\P{^enclosedalphanumsup}', "");
    Expect(0, 127488, '\p{enclosedalphanumsup}', "");
    Expect(1, 127488, '\p{^enclosedalphanumsup}', "");
    Expect(1, 127488, '\P{enclosedalphanumsup}', "");
    Expect(0, 127488, '\P{^enclosedalphanumsup}', "");
    Expect(1, 127487, '\p{-	Enclosed_alphanum_SUP}', "");
    Expect(0, 127487, '\p{^-	Enclosed_alphanum_SUP}', "");
    Expect(0, 127487, '\P{-	Enclosed_alphanum_SUP}', "");
    Expect(1, 127487, '\P{^-	Enclosed_alphanum_SUP}', "");
    Expect(0, 127488, '\p{-	Enclosed_alphanum_SUP}', "");
    Expect(1, 127488, '\p{^-	Enclosed_alphanum_SUP}', "");
    Expect(1, 127488, '\P{-	Enclosed_alphanum_SUP}', "");
    Expect(0, 127488, '\P{^-	Enclosed_alphanum_SUP}', "");
    Error('\p{/a/_Is_ENCLOSED_Alphanum_Sup}');
    Error('\P{/a/_Is_ENCLOSED_Alphanum_Sup}');
    Expect(1, 127487, '\p{isenclosedalphanumsup}', "");
    Expect(0, 127487, '\p{^isenclosedalphanumsup}', "");
    Expect(0, 127487, '\P{isenclosedalphanumsup}', "");
    Expect(1, 127487, '\P{^isenclosedalphanumsup}', "");
    Expect(0, 127488, '\p{isenclosedalphanumsup}', "");
    Expect(1, 127488, '\p{^isenclosedalphanumsup}', "");
    Expect(1, 127488, '\P{isenclosedalphanumsup}', "");
    Expect(0, 127488, '\P{^isenclosedalphanumsup}', "");
    Expect(1, 127487, '\p{- is_ENCLOSED_Alphanum_sup}', "");
    Expect(0, 127487, '\p{^- is_ENCLOSED_Alphanum_sup}', "");
    Expect(0, 127487, '\P{- is_ENCLOSED_Alphanum_sup}', "");
    Expect(1, 127487, '\P{^- is_ENCLOSED_Alphanum_sup}', "");
    Expect(0, 127488, '\p{- is_ENCLOSED_Alphanum_sup}', "");
    Expect(1, 127488, '\p{^- is_ENCLOSED_Alphanum_sup}', "");
    Expect(1, 127488, '\P{- is_ENCLOSED_Alphanum_sup}', "");
    Expect(0, 127488, '\P{^- is_ENCLOSED_Alphanum_sup}', "");
    Error('\p{/a/IN_enclosed_alphanum_Sup}');
    Error('\P{/a/IN_enclosed_alphanum_Sup}');
    Expect(1, 127487, '\p{inenclosedalphanumsup}', "");
    Expect(0, 127487, '\p{^inenclosedalphanumsup}', "");
    Expect(0, 127487, '\P{inenclosedalphanumsup}', "");
    Expect(1, 127487, '\P{^inenclosedalphanumsup}', "");
    Expect(0, 127488, '\p{inenclosedalphanumsup}', "");
    Expect(1, 127488, '\p{^inenclosedalphanumsup}', "");
    Expect(1, 127488, '\P{inenclosedalphanumsup}', "");
    Expect(0, 127488, '\P{^inenclosedalphanumsup}', "");
    Expect(1, 127487, '\p{_ IN_enclosed_Alphanum_Sup}', "");
    Expect(0, 127487, '\p{^_ IN_enclosed_Alphanum_Sup}', "");
    Expect(0, 127487, '\P{_ IN_enclosed_Alphanum_Sup}', "");
    Expect(1, 127487, '\P{^_ IN_enclosed_Alphanum_Sup}', "");
    Expect(0, 127488, '\p{_ IN_enclosed_Alphanum_Sup}', "");
    Expect(1, 127488, '\p{^_ IN_enclosed_Alphanum_Sup}', "");
    Expect(1, 127488, '\P{_ IN_enclosed_Alphanum_Sup}', "");
    Expect(0, 127488, '\P{^_ IN_enclosed_Alphanum_Sup}', "");
    Error('\p{	-enclosed_ALPHANUMERICS/a/}');
    Error('\P{	-enclosed_ALPHANUMERICS/a/}');
    Expect(1, 9471, '\p{enclosedalphanumerics}', "");
    Expect(0, 9471, '\p{^enclosedalphanumerics}', "");
    Expect(0, 9471, '\P{enclosedalphanumerics}', "");
    Expect(1, 9471, '\P{^enclosedalphanumerics}', "");
    Expect(0, 9472, '\p{enclosedalphanumerics}', "");
    Expect(1, 9472, '\p{^enclosedalphanumerics}', "");
    Expect(1, 9472, '\P{enclosedalphanumerics}', "");
    Expect(0, 9472, '\P{^enclosedalphanumerics}', "");
    Expect(1, 9471, '\p{-Enclosed_alphanumerics}', "");
    Expect(0, 9471, '\p{^-Enclosed_alphanumerics}', "");
    Expect(0, 9471, '\P{-Enclosed_alphanumerics}', "");
    Expect(1, 9471, '\P{^-Enclosed_alphanumerics}', "");
    Expect(0, 9472, '\p{-Enclosed_alphanumerics}', "");
    Expect(1, 9472, '\p{^-Enclosed_alphanumerics}', "");
    Expect(1, 9472, '\P{-Enclosed_alphanumerics}', "");
    Expect(0, 9472, '\P{^-Enclosed_alphanumerics}', "");
    Error('\p{__IS_Enclosed_Alphanumerics/a/}');
    Error('\P{__IS_Enclosed_Alphanumerics/a/}');
    Expect(1, 9471, '\p{isenclosedalphanumerics}', "");
    Expect(0, 9471, '\p{^isenclosedalphanumerics}', "");
    Expect(0, 9471, '\P{isenclosedalphanumerics}', "");
    Expect(1, 9471, '\P{^isenclosedalphanumerics}', "");
    Expect(0, 9472, '\p{isenclosedalphanumerics}', "");
    Expect(1, 9472, '\p{^isenclosedalphanumerics}', "");
    Expect(1, 9472, '\P{isenclosedalphanumerics}', "");
    Expect(0, 9472, '\P{^isenclosedalphanumerics}', "");
    Expect(1, 9471, '\p{_-Is_enclosed_alphanumerics}', "");
    Expect(0, 9471, '\p{^_-Is_enclosed_alphanumerics}', "");
    Expect(0, 9471, '\P{_-Is_enclosed_alphanumerics}', "");
    Expect(1, 9471, '\P{^_-Is_enclosed_alphanumerics}', "");
    Expect(0, 9472, '\p{_-Is_enclosed_alphanumerics}', "");
    Expect(1, 9472, '\p{^_-Is_enclosed_alphanumerics}', "");
    Expect(1, 9472, '\P{_-Is_enclosed_alphanumerics}', "");
    Expect(0, 9472, '\P{^_-Is_enclosed_alphanumerics}', "");
    Error('\p{/a/	_in_Enclosed_Alphanumerics}');
    Error('\P{/a/	_in_Enclosed_Alphanumerics}');
    Expect(1, 9471, '\p{inenclosedalphanumerics}', "");
    Expect(0, 9471, '\p{^inenclosedalphanumerics}', "");
    Expect(0, 9471, '\P{inenclosedalphanumerics}', "");
    Expect(1, 9471, '\P{^inenclosedalphanumerics}', "");
    Expect(0, 9472, '\p{inenclosedalphanumerics}', "");
    Expect(1, 9472, '\p{^inenclosedalphanumerics}', "");
    Expect(1, 9472, '\P{inenclosedalphanumerics}', "");
    Expect(0, 9472, '\P{^inenclosedalphanumerics}', "");
    Expect(1, 9471, '\p{  in_Enclosed_alphanumerics}', "");
    Expect(0, 9471, '\p{^  in_Enclosed_alphanumerics}', "");
    Expect(0, 9471, '\P{  in_Enclosed_alphanumerics}', "");
    Expect(1, 9471, '\P{^  in_Enclosed_alphanumerics}', "");
    Expect(0, 9472, '\p{  in_Enclosed_alphanumerics}', "");
    Expect(1, 9472, '\p{^  in_Enclosed_alphanumerics}', "");
    Expect(1, 9472, '\P{  in_Enclosed_alphanumerics}', "");
    Expect(0, 9472, '\P{^  in_Enclosed_alphanumerics}', "");
    Error('\p{_ enclosed_alphanum:=}');
    Error('\P{_ enclosed_alphanum:=}');
    Expect(1, 9471, '\p{enclosedalphanum}', "");
    Expect(0, 9471, '\p{^enclosedalphanum}', "");
    Expect(0, 9471, '\P{enclosedalphanum}', "");
    Expect(1, 9471, '\P{^enclosedalphanum}', "");
    Expect(0, 9472, '\p{enclosedalphanum}', "");
    Expect(1, 9472, '\p{^enclosedalphanum}', "");
    Expect(1, 9472, '\P{enclosedalphanum}', "");
    Expect(0, 9472, '\P{^enclosedalphanum}', "");
    Expect(1, 9471, '\p{ enclosed_alphanum}', "");
    Expect(0, 9471, '\p{^ enclosed_alphanum}', "");
    Expect(0, 9471, '\P{ enclosed_alphanum}', "");
    Expect(1, 9471, '\P{^ enclosed_alphanum}', "");
    Expect(0, 9472, '\p{ enclosed_alphanum}', "");
    Expect(1, 9472, '\p{^ enclosed_alphanum}', "");
    Expect(1, 9472, '\P{ enclosed_alphanum}', "");
    Expect(0, 9472, '\P{^ enclosed_alphanum}', "");
    Error('\p{	 Is_Enclosed_Alphanum/a/}');
    Error('\P{	 Is_Enclosed_Alphanum/a/}');
    Expect(1, 9471, '\p{isenclosedalphanum}', "");
    Expect(0, 9471, '\p{^isenclosedalphanum}', "");
    Expect(0, 9471, '\P{isenclosedalphanum}', "");
    Expect(1, 9471, '\P{^isenclosedalphanum}', "");
    Expect(0, 9472, '\p{isenclosedalphanum}', "");
    Expect(1, 9472, '\p{^isenclosedalphanum}', "");
    Expect(1, 9472, '\P{isenclosedalphanum}', "");
    Expect(0, 9472, '\P{^isenclosedalphanum}', "");
    Expect(1, 9471, '\p{_-Is_enclosed_alphanum}', "");
    Expect(0, 9471, '\p{^_-Is_enclosed_alphanum}', "");
    Expect(0, 9471, '\P{_-Is_enclosed_alphanum}', "");
    Expect(1, 9471, '\P{^_-Is_enclosed_alphanum}', "");
    Expect(0, 9472, '\p{_-Is_enclosed_alphanum}', "");
    Expect(1, 9472, '\p{^_-Is_enclosed_alphanum}', "");
    Expect(1, 9472, '\P{_-Is_enclosed_alphanum}', "");
    Expect(0, 9472, '\P{^_-Is_enclosed_alphanum}', "");
    Error('\p{ In_Enclosed_alphanum/a/}');
    Error('\P{ In_Enclosed_alphanum/a/}');
    Expect(1, 9471, '\p{inenclosedalphanum}', "");
    Expect(0, 9471, '\p{^inenclosedalphanum}', "");
    Expect(0, 9471, '\P{inenclosedalphanum}', "");
    Expect(1, 9471, '\P{^inenclosedalphanum}', "");
    Expect(0, 9472, '\p{inenclosedalphanum}', "");
    Expect(1, 9472, '\p{^inenclosedalphanum}', "");
    Expect(1, 9472, '\P{inenclosedalphanum}', "");
    Expect(0, 9472, '\P{^inenclosedalphanum}', "");
    Expect(1, 9471, '\p{_-in_Enclosed_Alphanum}', "");
    Expect(0, 9471, '\p{^_-in_Enclosed_Alphanum}', "");
    Expect(0, 9471, '\P{_-in_Enclosed_Alphanum}', "");
    Expect(1, 9471, '\P{^_-in_Enclosed_Alphanum}', "");
    Expect(0, 9472, '\p{_-in_Enclosed_Alphanum}', "");
    Expect(1, 9472, '\p{^_-in_Enclosed_Alphanum}', "");
    Expect(1, 9472, '\P{_-in_Enclosed_Alphanum}', "");
    Expect(0, 9472, '\P{^_-in_Enclosed_Alphanum}', "");
    Error('\p{_:=enclosed_CJK_Letters_and_Months}');
    Error('\P{_:=enclosed_CJK_Letters_and_Months}');
    Expect(1, 13055, '\p{enclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\p{^enclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\P{enclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\P{^enclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\p{enclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\p{^enclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\P{enclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\P{^enclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\p{  ENCLOSED_CJK_Letters_And_months}', "");
    Expect(0, 13055, '\p{^  ENCLOSED_CJK_Letters_And_months}', "");
    Expect(0, 13055, '\P{  ENCLOSED_CJK_Letters_And_months}', "");
    Expect(1, 13055, '\P{^  ENCLOSED_CJK_Letters_And_months}', "");
    Expect(0, 13056, '\p{  ENCLOSED_CJK_Letters_And_months}', "");
    Expect(1, 13056, '\p{^  ENCLOSED_CJK_Letters_And_months}', "");
    Expect(1, 13056, '\P{  ENCLOSED_CJK_Letters_And_months}', "");
    Expect(0, 13056, '\P{^  ENCLOSED_CJK_Letters_And_months}', "");
    Error('\p{-_is_enclosed_CJK_Letters_And_MONTHS/a/}');
    Error('\P{-_is_enclosed_CJK_Letters_And_MONTHS/a/}');
    Expect(1, 13055, '\p{isenclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\p{^isenclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\P{isenclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\P{^isenclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\p{isenclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\p{^isenclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\P{isenclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\P{^isenclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\p{		Is_Enclosed_CJK_letters_and_Months}', "");
    Expect(0, 13055, '\p{^		Is_Enclosed_CJK_letters_and_Months}', "");
    Expect(0, 13055, '\P{		Is_Enclosed_CJK_letters_and_Months}', "");
    Expect(1, 13055, '\P{^		Is_Enclosed_CJK_letters_and_Months}', "");
    Expect(0, 13056, '\p{		Is_Enclosed_CJK_letters_and_Months}', "");
    Expect(1, 13056, '\p{^		Is_Enclosed_CJK_letters_and_Months}', "");
    Expect(1, 13056, '\P{		Is_Enclosed_CJK_letters_and_Months}', "");
    Expect(0, 13056, '\P{^		Is_Enclosed_CJK_letters_and_Months}', "");
    Error('\p{-:=In_ENCLOSED_CJK_LETTERS_and_Months}');
    Error('\P{-:=In_ENCLOSED_CJK_LETTERS_and_Months}');
    Expect(1, 13055, '\p{inenclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\p{^inenclosedcjklettersandmonths}', "");
    Expect(0, 13055, '\P{inenclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\P{^inenclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\p{inenclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\p{^inenclosedcjklettersandmonths}', "");
    Expect(1, 13056, '\P{inenclosedcjklettersandmonths}', "");
    Expect(0, 13056, '\P{^inenclosedcjklettersandmonths}', "");
    Expect(1, 13055, '\p{ In_enclosed_CJK_letters_And_Months}', "");
    Expect(0, 13055, '\p{^ In_enclosed_CJK_letters_And_Months}', "");
    Expect(0, 13055, '\P{ In_enclosed_CJK_letters_And_Months}', "");
    Expect(1, 13055, '\P{^ In_enclosed_CJK_letters_And_Months}', "");
    Expect(0, 13056, '\p{ In_enclosed_CJK_letters_And_Months}', "");
    Expect(1, 13056, '\p{^ In_enclosed_CJK_letters_And_Months}', "");
    Expect(1, 13056, '\P{ In_enclosed_CJK_letters_And_Months}', "");
    Expect(0, 13056, '\P{^ In_enclosed_CJK_letters_And_Months}', "");
    Error('\p{-/a/Enclosed_CJK}');
    Error('\P{-/a/Enclosed_CJK}');
    Expect(1, 13055, '\p{enclosedcjk}', "");
    Expect(0, 13055, '\p{^enclosedcjk}', "");
    Expect(0, 13055, '\P{enclosedcjk}', "");
    Expect(1, 13055, '\P{^enclosedcjk}', "");
    Expect(0, 13056, '\p{enclosedcjk}', "");
    Expect(1, 13056, '\p{^enclosedcjk}', "");
    Expect(1, 13056, '\P{enclosedcjk}', "");
    Expect(0, 13056, '\P{^enclosedcjk}', "");
    Expect(1, 13055, '\p{-_Enclosed_cjk}', "");
    Expect(0, 13055, '\p{^-_Enclosed_cjk}', "");
    Expect(0, 13055, '\P{-_Enclosed_cjk}', "");
    Expect(1, 13055, '\P{^-_Enclosed_cjk}', "");
    Expect(0, 13056, '\p{-_Enclosed_cjk}', "");
    Expect(1, 13056, '\p{^-_Enclosed_cjk}', "");
    Expect(1, 13056, '\P{-_Enclosed_cjk}', "");
    Expect(0, 13056, '\P{^-_Enclosed_cjk}', "");
    Error('\p{		IS_Enclosed_CJK/a/}');
    Error('\P{		IS_Enclosed_CJK/a/}');
    Expect(1, 13055, '\p{isenclosedcjk}', "");
    Expect(0, 13055, '\p{^isenclosedcjk}', "");
    Expect(0, 13055, '\P{isenclosedcjk}', "");
    Expect(1, 13055, '\P{^isenclosedcjk}', "");
    Expect(0, 13056, '\p{isenclosedcjk}', "");
    Expect(1, 13056, '\p{^isenclosedcjk}', "");
    Expect(1, 13056, '\P{isenclosedcjk}', "");
    Expect(0, 13056, '\P{^isenclosedcjk}', "");
    Expect(1, 13055, '\p{-Is_ENCLOSED_CJK}', "");
    Expect(0, 13055, '\p{^-Is_ENCLOSED_CJK}', "");
    Expect(0, 13055, '\P{-Is_ENCLOSED_CJK}', "");
    Expect(1, 13055, '\P{^-Is_ENCLOSED_CJK}', "");
    Expect(0, 13056, '\p{-Is_ENCLOSED_CJK}', "");
    Expect(1, 13056, '\p{^-Is_ENCLOSED_CJK}', "");
    Expect(1, 13056, '\P{-Is_ENCLOSED_CJK}', "");
    Expect(0, 13056, '\P{^-Is_ENCLOSED_CJK}', "");
    Error('\p{_:=In_enclosed_CJK}');
    Error('\P{_:=In_enclosed_CJK}');
    Expect(1, 13055, '\p{inenclosedcjk}', "");
    Expect(0, 13055, '\p{^inenclosedcjk}', "");
    Expect(0, 13055, '\P{inenclosedcjk}', "");
    Expect(1, 13055, '\P{^inenclosedcjk}', "");
    Expect(0, 13056, '\p{inenclosedcjk}', "");
    Expect(1, 13056, '\p{^inenclosedcjk}', "");
    Expect(1, 13056, '\P{inenclosedcjk}', "");
    Expect(0, 13056, '\P{^inenclosedcjk}', "");
    Expect(1, 13055, '\p{ -in_enclosed_cjk}', "");
    Expect(0, 13055, '\p{^ -in_enclosed_cjk}', "");
    Expect(0, 13055, '\P{ -in_enclosed_cjk}', "");
    Expect(1, 13055, '\P{^ -in_enclosed_cjk}', "");
    Expect(0, 13056, '\p{ -in_enclosed_cjk}', "");
    Expect(1, 13056, '\p{^ -in_enclosed_cjk}', "");
    Expect(1, 13056, '\P{ -in_enclosed_cjk}', "");
    Expect(0, 13056, '\P{^ -in_enclosed_cjk}', "");
    Error('\p{:=- Enclosed_Ideographic_Supplement}');
    Error('\P{:=- Enclosed_Ideographic_Supplement}');
    Expect(1, 127743, '\p{enclosedideographicsupplement}', "");
    Expect(0, 127743, '\p{^enclosedideographicsupplement}', "");
    Expect(0, 127743, '\P{enclosedideographicsupplement}', "");
    Expect(1, 127743, '\P{^enclosedideographicsupplement}', "");
    Expect(0, 127744, '\p{enclosedideographicsupplement}', "");
    Expect(1, 127744, '\p{^enclosedideographicsupplement}', "");
    Expect(1, 127744, '\P{enclosedideographicsupplement}', "");
    Expect(0, 127744, '\P{^enclosedideographicsupplement}', "");
    Expect(1, 127743, '\p{	-Enclosed_ideographic_Supplement}', "");
    Expect(0, 127743, '\p{^	-Enclosed_ideographic_Supplement}', "");
    Expect(0, 127743, '\P{	-Enclosed_ideographic_Supplement}', "");
    Expect(1, 127743, '\P{^	-Enclosed_ideographic_Supplement}', "");
    Expect(0, 127744, '\p{	-Enclosed_ideographic_Supplement}', "");
    Expect(1, 127744, '\p{^	-Enclosed_ideographic_Supplement}', "");
    Expect(1, 127744, '\P{	-Enclosed_ideographic_Supplement}', "");
    Expect(0, 127744, '\P{^	-Enclosed_ideographic_Supplement}', "");
    Error('\p{/a/__is_ENCLOSED_IDEOGRAPHIC_supplement}');
    Error('\P{/a/__is_ENCLOSED_IDEOGRAPHIC_supplement}');
    Expect(1, 127743, '\p{isenclosedideographicsupplement}', "");
    Expect(0, 127743, '\p{^isenclosedideographicsupplement}', "");
    Expect(0, 127743, '\P{isenclosedideographicsupplement}', "");
    Expect(1, 127743, '\P{^isenclosedideographicsupplement}', "");
    Expect(0, 127744, '\p{isenclosedideographicsupplement}', "");
    Expect(1, 127744, '\p{^isenclosedideographicsupplement}', "");
    Expect(1, 127744, '\P{isenclosedideographicsupplement}', "");
    Expect(0, 127744, '\P{^isenclosedideographicsupplement}', "");
    Expect(1, 127743, '\p{ _is_ENCLOSED_IDEOGRAPHIC_Supplement}', "");
    Expect(0, 127743, '\p{^ _is_ENCLOSED_IDEOGRAPHIC_Supplement}', "");
    Expect(0, 127743, '\P{ _is_ENCLOSED_IDEOGRAPHIC_Supplement}', "");
    Expect(1, 127743, '\P{^ _is_ENCLOSED_IDEOGRAPHIC_Supplement}', "");
    Expect(0, 127744, '\p{ _is_ENCLOSED_IDEOGRAPHIC_Supplement}', "");
    Expect(1, 127744, '\p{^ _is_ENCLOSED_IDEOGRAPHIC_Supplement}', "");
    Expect(1, 127744, '\P{ _is_ENCLOSED_IDEOGRAPHIC_Supplement}', "");
    Expect(0, 127744, '\P{^ _is_ENCLOSED_IDEOGRAPHIC_Supplement}', "");
    Error('\p{_/a/In_ENCLOSED_IDEOGRAPHIC_supplement}');
    Error('\P{_/a/In_ENCLOSED_IDEOGRAPHIC_supplement}');
    Expect(1, 127743, '\p{inenclosedideographicsupplement}', "");
    Expect(0, 127743, '\p{^inenclosedideographicsupplement}', "");
    Expect(0, 127743, '\P{inenclosedideographicsupplement}', "");
    Expect(1, 127743, '\P{^inenclosedideographicsupplement}', "");
    Expect(0, 127744, '\p{inenclosedideographicsupplement}', "");
    Expect(1, 127744, '\p{^inenclosedideographicsupplement}', "");
    Expect(1, 127744, '\P{inenclosedideographicsupplement}', "");
    Expect(0, 127744, '\P{^inenclosedideographicsupplement}', "");
    Expect(1, 127743, '\p{_In_ENCLOSED_IDEOGRAPHIC_supplement}', "");
    Expect(0, 127743, '\p{^_In_ENCLOSED_IDEOGRAPHIC_supplement}', "");
    Expect(0, 127743, '\P{_In_ENCLOSED_IDEOGRAPHIC_supplement}', "");
    Expect(1, 127743, '\P{^_In_ENCLOSED_IDEOGRAPHIC_supplement}', "");
    Expect(0, 127744, '\p{_In_ENCLOSED_IDEOGRAPHIC_supplement}', "");
    Expect(1, 127744, '\p{^_In_ENCLOSED_IDEOGRAPHIC_supplement}', "");
    Expect(1, 127744, '\P{_In_ENCLOSED_IDEOGRAPHIC_supplement}', "");
    Expect(0, 127744, '\P{^_In_ENCLOSED_IDEOGRAPHIC_supplement}', "");
    Error('\p{ -Enclosed_IDEOGRAPHIC_Sup:=}');
    Error('\P{ -Enclosed_IDEOGRAPHIC_Sup:=}');
    Expect(1, 127743, '\p{enclosedideographicsup}', "");
    Expect(0, 127743, '\p{^enclosedideographicsup}', "");
    Expect(0, 127743, '\P{enclosedideographicsup}', "");
    Expect(1, 127743, '\P{^enclosedideographicsup}', "");
    Expect(0, 127744, '\p{enclosedideographicsup}', "");
    Expect(1, 127744, '\p{^enclosedideographicsup}', "");
    Expect(1, 127744, '\P{enclosedideographicsup}', "");
    Expect(0, 127744, '\P{^enclosedideographicsup}', "");
    Expect(1, 127743, '\p{	-ENCLOSED_Ideographic_Sup}', "");
    Expect(0, 127743, '\p{^	-ENCLOSED_Ideographic_Sup}', "");
    Expect(0, 127743, '\P{	-ENCLOSED_Ideographic_Sup}', "");
    Expect(1, 127743, '\P{^	-ENCLOSED_Ideographic_Sup}', "");
    Expect(0, 127744, '\p{	-ENCLOSED_Ideographic_Sup}', "");
    Expect(1, 127744, '\p{^	-ENCLOSED_Ideographic_Sup}', "");
    Expect(1, 127744, '\P{	-ENCLOSED_Ideographic_Sup}', "");
    Expect(0, 127744, '\P{^	-ENCLOSED_Ideographic_Sup}', "");
    Error('\p{ :=IS_enclosed_ideographic_SUP}');
    Error('\P{ :=IS_enclosed_ideographic_SUP}');
    Expect(1, 127743, '\p{isenclosedideographicsup}', "");
    Expect(0, 127743, '\p{^isenclosedideographicsup}', "");
    Expect(0, 127743, '\P{isenclosedideographicsup}', "");
    Expect(1, 127743, '\P{^isenclosedideographicsup}', "");
    Expect(0, 127744, '\p{isenclosedideographicsup}', "");
    Expect(1, 127744, '\p{^isenclosedideographicsup}', "");
    Expect(1, 127744, '\P{isenclosedideographicsup}', "");
    Expect(0, 127744, '\P{^isenclosedideographicsup}', "");
    Expect(1, 127743, '\p{ Is_Enclosed_Ideographic_Sup}', "");
    Expect(0, 127743, '\p{^ Is_Enclosed_Ideographic_Sup}', "");
    Expect(0, 127743, '\P{ Is_Enclosed_Ideographic_Sup}', "");
    Expect(1, 127743, '\P{^ Is_Enclosed_Ideographic_Sup}', "");
    Expect(0, 127744, '\p{ Is_Enclosed_Ideographic_Sup}', "");
    Expect(1, 127744, '\p{^ Is_Enclosed_Ideographic_Sup}', "");
    Expect(1, 127744, '\P{ Is_Enclosed_Ideographic_Sup}', "");
    Expect(0, 127744, '\P{^ Is_Enclosed_Ideographic_Sup}', "");
    Error('\p{	_In_Enclosed_ideographic_Sup:=}');
    Error('\P{	_In_Enclosed_ideographic_Sup:=}');
    Expect(1, 127743, '\p{inenclosedideographicsup}', "");
    Expect(0, 127743, '\p{^inenclosedideographicsup}', "");
    Expect(0, 127743, '\P{inenclosedideographicsup}', "");
    Expect(1, 127743, '\P{^inenclosedideographicsup}', "");
    Expect(0, 127744, '\p{inenclosedideographicsup}', "");
    Expect(1, 127744, '\p{^inenclosedideographicsup}', "");
    Expect(1, 127744, '\P{inenclosedideographicsup}', "");
    Expect(0, 127744, '\P{^inenclosedideographicsup}', "");
    Expect(1, 127743, '\p{		In_ENCLOSED_Ideographic_Sup}', "");
    Expect(0, 127743, '\p{^		In_ENCLOSED_Ideographic_Sup}', "");
    Expect(0, 127743, '\P{		In_ENCLOSED_Ideographic_Sup}', "");
    Expect(1, 127743, '\P{^		In_ENCLOSED_Ideographic_Sup}', "");
    Expect(0, 127744, '\p{		In_ENCLOSED_Ideographic_Sup}', "");
    Expect(1, 127744, '\p{^		In_ENCLOSED_Ideographic_Sup}', "");
    Expect(1, 127744, '\P{		In_ENCLOSED_Ideographic_Sup}', "");
    Expect(0, 127744, '\P{^		In_ENCLOSED_Ideographic_Sup}', "");
    Error('\p{:=--enclosing_Mark}');
    Error('\P{:=--enclosing_Mark}');
    Expect(1, 42610, '\p{enclosingmark}', "");
    Expect(0, 42610, '\p{^enclosingmark}', "");
    Expect(0, 42610, '\P{enclosingmark}', "");
    Expect(1, 42610, '\P{^enclosingmark}', "");
    Expect(0, 42611, '\p{enclosingmark}', "");
    Expect(1, 42611, '\p{^enclosingmark}', "");
    Expect(1, 42611, '\P{enclosingmark}', "");
    Expect(0, 42611, '\P{^enclosingmark}', "");
    Expect(1, 42610, '\p{	 ENCLOSING_mark}', "");
    Expect(0, 42610, '\p{^	 ENCLOSING_mark}', "");
    Expect(0, 42610, '\P{	 ENCLOSING_mark}', "");
    Expect(1, 42610, '\P{^	 ENCLOSING_mark}', "");
    Expect(0, 42611, '\p{	 ENCLOSING_mark}', "");
    Expect(1, 42611, '\p{^	 ENCLOSING_mark}', "");
    Expect(1, 42611, '\P{	 ENCLOSING_mark}', "");
    Expect(0, 42611, '\P{^	 ENCLOSING_mark}', "");
    Error('\p{	IS_enclosing_mark/a/}');
    Error('\P{	IS_enclosing_mark/a/}');
    Expect(1, 42610, '\p{isenclosingmark}', "");
    Expect(0, 42610, '\p{^isenclosingmark}', "");
    Expect(0, 42610, '\P{isenclosingmark}', "");
    Expect(1, 42610, '\P{^isenclosingmark}', "");
    Expect(0, 42611, '\p{isenclosingmark}', "");
    Expect(1, 42611, '\p{^isenclosingmark}', "");
    Expect(1, 42611, '\P{isenclosingmark}', "");
    Expect(0, 42611, '\P{^isenclosingmark}', "");
    Expect(1, 42610, '\p{_	IS_Enclosing_Mark}', "");
    Expect(0, 42610, '\p{^_	IS_Enclosing_Mark}', "");
    Expect(0, 42610, '\P{_	IS_Enclosing_Mark}', "");
    Expect(1, 42610, '\P{^_	IS_Enclosing_Mark}', "");
    Expect(0, 42611, '\p{_	IS_Enclosing_Mark}', "");
    Expect(1, 42611, '\p{^_	IS_Enclosing_Mark}', "");
    Expect(1, 42611, '\P{_	IS_Enclosing_Mark}', "");
    Expect(0, 42611, '\P{^_	IS_Enclosing_Mark}', "");
    Error('\p{_ME:=}');
    Error('\P{_ME:=}');
    Expect(1, 42610, '\p{me}', "");
    Expect(0, 42610, '\p{^me}', "");
    Expect(0, 42610, '\P{me}', "");
    Expect(1, 42610, '\P{^me}', "");
    Expect(0, 42611, '\p{me}', "");
    Expect(1, 42611, '\p{^me}', "");
    Expect(1, 42611, '\P{me}', "");
    Expect(0, 42611, '\P{^me}', "");
    Expect(1, 42610, '\p{--Me}', "");
    Expect(0, 42610, '\p{^--Me}', "");
    Expect(0, 42610, '\P{--Me}', "");
    Expect(1, 42610, '\P{^--Me}', "");
    Expect(0, 42611, '\p{--Me}', "");
    Expect(1, 42611, '\p{^--Me}', "");
    Expect(1, 42611, '\P{--Me}', "");
    Expect(0, 42611, '\P{^--Me}', "");
    Error('\p{	_IS_Me:=}');
    Error('\P{	_IS_Me:=}');
    Expect(1, 42610, '\p{isme}', "");
    Expect(0, 42610, '\p{^isme}', "");
    Expect(0, 42610, '\P{isme}', "");
    Expect(1, 42610, '\P{^isme}', "");
    Expect(0, 42611, '\p{isme}', "");
    Expect(1, 42611, '\p{^isme}', "");
    Expect(1, 42611, '\P{isme}', "");
    Expect(0, 42611, '\P{^isme}', "");
    Expect(1, 42610, '\p{ _IS_ME}', "");
    Expect(0, 42610, '\p{^ _IS_ME}', "");
    Expect(0, 42610, '\P{ _IS_ME}', "");
    Expect(1, 42610, '\P{^ _IS_ME}', "");
    Expect(0, 42611, '\p{ _IS_ME}', "");
    Expect(1, 42611, '\p{^ _IS_ME}', "");
    Expect(1, 42611, '\P{ _IS_ME}', "");
    Expect(0, 42611, '\P{^ _IS_ME}', "");
    Error('\p{	ETHIOPIC/a/}');
    Error('\P{	ETHIOPIC/a/}');
    Expect(1, 43822, '\p{ethiopic}', "");
    Expect(0, 43822, '\p{^ethiopic}', "");
    Expect(0, 43822, '\P{ethiopic}', "");
    Expect(1, 43822, '\P{^ethiopic}', "");
    Expect(0, 43823, '\p{ethiopic}', "");
    Expect(1, 43823, '\p{^ethiopic}', "");
    Expect(1, 43823, '\P{ethiopic}', "");
    Expect(0, 43823, '\P{^ethiopic}', "");
    Expect(1, 43822, '\p{ Ethiopic}', "");
    Expect(0, 43822, '\p{^ Ethiopic}', "");
    Expect(0, 43822, '\P{ Ethiopic}', "");
    Expect(1, 43822, '\P{^ Ethiopic}', "");
    Expect(0, 43823, '\p{ Ethiopic}', "");
    Expect(1, 43823, '\p{^ Ethiopic}', "");
    Expect(1, 43823, '\P{ Ethiopic}', "");
    Expect(0, 43823, '\P{^ Ethiopic}', "");
    Error('\p{_:=is_Ethiopic}');
    Error('\P{_:=is_Ethiopic}');
    Expect(1, 43822, '\p{isethiopic}', "");
    Expect(0, 43822, '\p{^isethiopic}', "");
    Expect(0, 43822, '\P{isethiopic}', "");
    Expect(1, 43822, '\P{^isethiopic}', "");
    Expect(0, 43823, '\p{isethiopic}', "");
    Expect(1, 43823, '\p{^isethiopic}', "");
    Expect(1, 43823, '\P{isethiopic}', "");
    Expect(0, 43823, '\P{^isethiopic}', "");
    Expect(1, 43822, '\p{ Is_Ethiopic}', "");
    Expect(0, 43822, '\p{^ Is_Ethiopic}', "");
    Expect(0, 43822, '\P{ Is_Ethiopic}', "");
    Expect(1, 43822, '\P{^ Is_Ethiopic}', "");
    Expect(0, 43823, '\p{ Is_Ethiopic}', "");
    Expect(1, 43823, '\p{^ Is_Ethiopic}', "");
    Expect(1, 43823, '\P{ Is_Ethiopic}', "");
    Expect(0, 43823, '\P{^ Is_Ethiopic}', "");
    Error('\p{_	Ethi/a/}');
    Error('\P{_	Ethi/a/}');
    Expect(1, 43822, '\p{ethi}', "");
    Expect(0, 43822, '\p{^ethi}', "");
    Expect(0, 43822, '\P{ethi}', "");
    Expect(1, 43822, '\P{^ethi}', "");
    Expect(0, 43823, '\p{ethi}', "");
    Expect(1, 43823, '\p{^ethi}', "");
    Expect(1, 43823, '\P{ethi}', "");
    Expect(0, 43823, '\P{^ethi}', "");
    Expect(1, 43822, '\p{	-Ethi}', "");
    Expect(0, 43822, '\p{^	-Ethi}', "");
    Expect(0, 43822, '\P{	-Ethi}', "");
    Expect(1, 43822, '\P{^	-Ethi}', "");
    Expect(0, 43823, '\p{	-Ethi}', "");
    Expect(1, 43823, '\p{^	-Ethi}', "");
    Expect(1, 43823, '\P{	-Ethi}', "");
    Expect(0, 43823, '\P{^	-Ethi}', "");
    Error('\p{	Is_Ethi:=}');
    Error('\P{	Is_Ethi:=}');
    Expect(1, 43822, '\p{isethi}', "");
    Expect(0, 43822, '\p{^isethi}', "");
    Expect(0, 43822, '\P{isethi}', "");
    Expect(1, 43822, '\P{^isethi}', "");
    Expect(0, 43823, '\p{isethi}', "");
    Expect(1, 43823, '\p{^isethi}', "");
    Expect(1, 43823, '\P{isethi}', "");
    Expect(0, 43823, '\P{^isethi}', "");
    Expect(1, 43822, '\p{-_Is_ethi}', "");
    Expect(0, 43822, '\p{^-_Is_ethi}', "");
    Expect(0, 43822, '\P{-_Is_ethi}', "");
    Expect(1, 43822, '\P{^-_Is_ethi}', "");
    Expect(0, 43823, '\p{-_Is_ethi}', "");
    Expect(1, 43823, '\p{^-_Is_ethi}', "");
    Expect(1, 43823, '\P{-_Is_ethi}', "");
    Expect(0, 43823, '\P{^-_Is_ethi}', "");
    Error('\p{  Ethiopic_extended:=}');
    Error('\P{  Ethiopic_extended:=}');
    Expect(1, 11743, '\p{ethiopicextended}', "");
    Expect(0, 11743, '\p{^ethiopicextended}', "");
    Expect(0, 11743, '\P{ethiopicextended}', "");
    Expect(1, 11743, '\P{^ethiopicextended}', "");
    Expect(0, 11744, '\p{ethiopicextended}', "");
    Expect(1, 11744, '\p{^ethiopicextended}', "");
    Expect(1, 11744, '\P{ethiopicextended}', "");
    Expect(0, 11744, '\P{^ethiopicextended}', "");
    Expect(1, 11743, '\p{_Ethiopic_Extended}', "");
    Expect(0, 11743, '\p{^_Ethiopic_Extended}', "");
    Expect(0, 11743, '\P{_Ethiopic_Extended}', "");
    Expect(1, 11743, '\P{^_Ethiopic_Extended}', "");
    Expect(0, 11744, '\p{_Ethiopic_Extended}', "");
    Expect(1, 11744, '\p{^_Ethiopic_Extended}', "");
    Expect(1, 11744, '\P{_Ethiopic_Extended}', "");
    Expect(0, 11744, '\P{^_Ethiopic_Extended}', "");
    Error('\p{:= Is_Ethiopic_EXTENDED}');
    Error('\P{:= Is_Ethiopic_EXTENDED}');
    Expect(1, 11743, '\p{isethiopicextended}', "");
    Expect(0, 11743, '\p{^isethiopicextended}', "");
    Expect(0, 11743, '\P{isethiopicextended}', "");
    Expect(1, 11743, '\P{^isethiopicextended}', "");
    Expect(0, 11744, '\p{isethiopicextended}', "");
    Expect(1, 11744, '\p{^isethiopicextended}', "");
    Expect(1, 11744, '\P{isethiopicextended}', "");
    Expect(0, 11744, '\P{^isethiopicextended}', "");
    Expect(1, 11743, '\p{ -IS_ethiopic_Extended}', "");
    Expect(0, 11743, '\p{^ -IS_ethiopic_Extended}', "");
    Expect(0, 11743, '\P{ -IS_ethiopic_Extended}', "");
    Expect(1, 11743, '\P{^ -IS_ethiopic_Extended}', "");
    Expect(0, 11744, '\p{ -IS_ethiopic_Extended}', "");
    Expect(1, 11744, '\p{^ -IS_ethiopic_Extended}', "");
    Expect(1, 11744, '\P{ -IS_ethiopic_Extended}', "");
    Expect(0, 11744, '\P{^ -IS_ethiopic_Extended}', "");
    Error('\p{-/a/In_ethiopic_Extended}');
    Error('\P{-/a/In_ethiopic_Extended}');
    Expect(1, 11743, '\p{inethiopicextended}', "");
    Expect(0, 11743, '\p{^inethiopicextended}', "");
    Expect(0, 11743, '\P{inethiopicextended}', "");
    Expect(1, 11743, '\P{^inethiopicextended}', "");
    Expect(0, 11744, '\p{inethiopicextended}', "");
    Expect(1, 11744, '\p{^inethiopicextended}', "");
    Expect(1, 11744, '\P{inethiopicextended}', "");
    Expect(0, 11744, '\P{^inethiopicextended}', "");
    Expect(1, 11743, '\p{	IN_Ethiopic_EXTENDED}', "");
    Expect(0, 11743, '\p{^	IN_Ethiopic_EXTENDED}', "");
    Expect(0, 11743, '\P{	IN_Ethiopic_EXTENDED}', "");
    Expect(1, 11743, '\P{^	IN_Ethiopic_EXTENDED}', "");
    Expect(0, 11744, '\p{	IN_Ethiopic_EXTENDED}', "");
    Expect(1, 11744, '\p{^	IN_Ethiopic_EXTENDED}', "");
    Expect(1, 11744, '\P{	IN_Ethiopic_EXTENDED}', "");
    Expect(0, 11744, '\P{^	IN_Ethiopic_EXTENDED}', "");
    Error('\p{ -ETHIOPIC_Ext:=}');
    Error('\P{ -ETHIOPIC_Ext:=}');
    Expect(1, 11743, '\p{ethiopicext}', "");
    Expect(0, 11743, '\p{^ethiopicext}', "");
    Expect(0, 11743, '\P{ethiopicext}', "");
    Expect(1, 11743, '\P{^ethiopicext}', "");
    Expect(0, 11744, '\p{ethiopicext}', "");
    Expect(1, 11744, '\p{^ethiopicext}', "");
    Expect(1, 11744, '\P{ethiopicext}', "");
    Expect(0, 11744, '\P{^ethiopicext}', "");
    Expect(1, 11743, '\p{	ethiopic_Ext}', "");
    Expect(0, 11743, '\p{^	ethiopic_Ext}', "");
    Expect(0, 11743, '\P{	ethiopic_Ext}', "");
    Expect(1, 11743, '\P{^	ethiopic_Ext}', "");
    Expect(0, 11744, '\p{	ethiopic_Ext}', "");
    Expect(1, 11744, '\p{^	ethiopic_Ext}', "");
    Expect(1, 11744, '\P{	ethiopic_Ext}', "");
    Expect(0, 11744, '\P{^	ethiopic_Ext}', "");
    Error('\p{		Is_ethiopic_ext:=}');
    Error('\P{		Is_ethiopic_ext:=}');
    Expect(1, 11743, '\p{isethiopicext}', "");
    Expect(0, 11743, '\p{^isethiopicext}', "");
    Expect(0, 11743, '\P{isethiopicext}', "");
    Expect(1, 11743, '\P{^isethiopicext}', "");
    Expect(0, 11744, '\p{isethiopicext}', "");
    Expect(1, 11744, '\p{^isethiopicext}', "");
    Expect(1, 11744, '\P{isethiopicext}', "");
    Expect(0, 11744, '\P{^isethiopicext}', "");
    Expect(1, 11743, '\p{--IS_Ethiopic_Ext}', "");
    Expect(0, 11743, '\p{^--IS_Ethiopic_Ext}', "");
    Expect(0, 11743, '\P{--IS_Ethiopic_Ext}', "");
    Expect(1, 11743, '\P{^--IS_Ethiopic_Ext}', "");
    Expect(0, 11744, '\p{--IS_Ethiopic_Ext}', "");
    Expect(1, 11744, '\p{^--IS_Ethiopic_Ext}', "");
    Expect(1, 11744, '\P{--IS_Ethiopic_Ext}', "");
    Expect(0, 11744, '\P{^--IS_Ethiopic_Ext}', "");
    Error('\p{_-In_Ethiopic_Ext/a/}');
    Error('\P{_-In_Ethiopic_Ext/a/}');
    Expect(1, 11743, '\p{inethiopicext}', "");
    Expect(0, 11743, '\p{^inethiopicext}', "");
    Expect(0, 11743, '\P{inethiopicext}', "");
    Expect(1, 11743, '\P{^inethiopicext}', "");
    Expect(0, 11744, '\p{inethiopicext}', "");
    Expect(1, 11744, '\p{^inethiopicext}', "");
    Expect(1, 11744, '\P{inethiopicext}', "");
    Expect(0, 11744, '\P{^inethiopicext}', "");
    Expect(1, 11743, '\p{_-In_Ethiopic_EXT}', "");
    Expect(0, 11743, '\p{^_-In_Ethiopic_EXT}', "");
    Expect(0, 11743, '\P{_-In_Ethiopic_EXT}', "");
    Expect(1, 11743, '\P{^_-In_Ethiopic_EXT}', "");
    Expect(0, 11744, '\p{_-In_Ethiopic_EXT}', "");
    Expect(1, 11744, '\p{^_-In_Ethiopic_EXT}', "");
    Expect(1, 11744, '\P{_-In_Ethiopic_EXT}', "");
    Expect(0, 11744, '\P{^_-In_Ethiopic_EXT}', "");
    Error('\p{:=__Ethiopic_Extended_A}');
    Error('\P{:=__Ethiopic_Extended_A}');
    Expect(1, 43823, '\p{ethiopicextendeda}', "");
    Expect(0, 43823, '\p{^ethiopicextendeda}', "");
    Expect(0, 43823, '\P{ethiopicextendeda}', "");
    Expect(1, 43823, '\P{^ethiopicextendeda}', "");
    Expect(0, 43824, '\p{ethiopicextendeda}', "");
    Expect(1, 43824, '\p{^ethiopicextendeda}', "");
    Expect(1, 43824, '\P{ethiopicextendeda}', "");
    Expect(0, 43824, '\P{^ethiopicextendeda}', "");
    Expect(1, 43823, '\p{-_ethiopic_Extended_A}', "");
    Expect(0, 43823, '\p{^-_ethiopic_Extended_A}', "");
    Expect(0, 43823, '\P{-_ethiopic_Extended_A}', "");
    Expect(1, 43823, '\P{^-_ethiopic_Extended_A}', "");
    Expect(0, 43824, '\p{-_ethiopic_Extended_A}', "");
    Expect(1, 43824, '\p{^-_ethiopic_Extended_A}', "");
    Expect(1, 43824, '\P{-_ethiopic_Extended_A}', "");
    Expect(0, 43824, '\P{^-_ethiopic_Extended_A}', "");
    Error('\p{:=-IS_Ethiopic_Extended_A}');
    Error('\P{:=-IS_Ethiopic_Extended_A}');
    Expect(1, 43823, '\p{isethiopicextendeda}', "");
    Expect(0, 43823, '\p{^isethiopicextendeda}', "");
    Expect(0, 43823, '\P{isethiopicextendeda}', "");
    Expect(1, 43823, '\P{^isethiopicextendeda}', "");
    Expect(0, 43824, '\p{isethiopicextendeda}', "");
    Expect(1, 43824, '\p{^isethiopicextendeda}', "");
    Expect(1, 43824, '\P{isethiopicextendeda}', "");
    Expect(0, 43824, '\P{^isethiopicextendeda}', "");
    Expect(1, 43823, '\p{ -Is_Ethiopic_EXTENDED_a}', "");
    Expect(0, 43823, '\p{^ -Is_Ethiopic_EXTENDED_a}', "");
    Expect(0, 43823, '\P{ -Is_Ethiopic_EXTENDED_a}', "");
    Expect(1, 43823, '\P{^ -Is_Ethiopic_EXTENDED_a}', "");
    Expect(0, 43824, '\p{ -Is_Ethiopic_EXTENDED_a}', "");
    Expect(1, 43824, '\p{^ -Is_Ethiopic_EXTENDED_a}', "");
    Expect(1, 43824, '\P{ -Is_Ethiopic_EXTENDED_a}', "");
    Expect(0, 43824, '\P{^ -Is_Ethiopic_EXTENDED_a}', "");
    Error('\p{:= _IN_Ethiopic_Extended_a}');
    Error('\P{:= _IN_Ethiopic_Extended_a}');
    Expect(1, 43823, '\p{inethiopicextendeda}', "");
    Expect(0, 43823, '\p{^inethiopicextendeda}', "");
    Expect(0, 43823, '\P{inethiopicextendeda}', "");
    Expect(1, 43823, '\P{^inethiopicextendeda}', "");
    Expect(0, 43824, '\p{inethiopicextendeda}', "");
    Expect(1, 43824, '\p{^inethiopicextendeda}', "");
    Expect(1, 43824, '\P{inethiopicextendeda}', "");
    Expect(0, 43824, '\P{^inethiopicextendeda}', "");
    Expect(1, 43823, '\p{--in_Ethiopic_EXTENDED_A}', "");
    Expect(0, 43823, '\p{^--in_Ethiopic_EXTENDED_A}', "");
    Expect(0, 43823, '\P{--in_Ethiopic_EXTENDED_A}', "");
    Expect(1, 43823, '\P{^--in_Ethiopic_EXTENDED_A}', "");
    Expect(0, 43824, '\p{--in_Ethiopic_EXTENDED_A}', "");
    Expect(1, 43824, '\p{^--in_Ethiopic_EXTENDED_A}', "");
    Expect(1, 43824, '\P{--in_Ethiopic_EXTENDED_A}', "");
    Expect(0, 43824, '\P{^--in_Ethiopic_EXTENDED_A}', "");
    Error('\p{ _Ethiopic_Ext_A:=}');
    Error('\P{ _Ethiopic_Ext_A:=}');
    Expect(1, 43823, '\p{ethiopicexta}', "");
    Expect(0, 43823, '\p{^ethiopicexta}', "");
    Expect(0, 43823, '\P{ethiopicexta}', "");
    Expect(1, 43823, '\P{^ethiopicexta}', "");
    Expect(0, 43824, '\p{ethiopicexta}', "");
    Expect(1, 43824, '\p{^ethiopicexta}', "");
    Expect(1, 43824, '\P{ethiopicexta}', "");
    Expect(0, 43824, '\P{^ethiopicexta}', "");
    Expect(1, 43823, '\p{ _ethiopic_Ext_A}', "");
    Expect(0, 43823, '\p{^ _ethiopic_Ext_A}', "");
    Expect(0, 43823, '\P{ _ethiopic_Ext_A}', "");
    Expect(1, 43823, '\P{^ _ethiopic_Ext_A}', "");
    Expect(0, 43824, '\p{ _ethiopic_Ext_A}', "");
    Expect(1, 43824, '\p{^ _ethiopic_Ext_A}', "");
    Expect(1, 43824, '\P{ _ethiopic_Ext_A}', "");
    Expect(0, 43824, '\P{^ _ethiopic_Ext_A}', "");
    Error('\p{__is_Ethiopic_ext_A:=}');
    Error('\P{__is_Ethiopic_ext_A:=}');
    Expect(1, 43823, '\p{isethiopicexta}', "");
    Expect(0, 43823, '\p{^isethiopicexta}', "");
    Expect(0, 43823, '\P{isethiopicexta}', "");
    Expect(1, 43823, '\P{^isethiopicexta}', "");
    Expect(0, 43824, '\p{isethiopicexta}', "");
    Expect(1, 43824, '\p{^isethiopicexta}', "");
    Expect(1, 43824, '\P{isethiopicexta}', "");
    Expect(0, 43824, '\P{^isethiopicexta}', "");
    Expect(1, 43823, '\p{-is_Ethiopic_EXT_A}', "");
    Expect(0, 43823, '\p{^-is_Ethiopic_EXT_A}', "");
    Expect(0, 43823, '\P{-is_Ethiopic_EXT_A}', "");
    Expect(1, 43823, '\P{^-is_Ethiopic_EXT_A}', "");
    Expect(0, 43824, '\p{-is_Ethiopic_EXT_A}', "");
    Expect(1, 43824, '\p{^-is_Ethiopic_EXT_A}', "");
    Expect(1, 43824, '\P{-is_Ethiopic_EXT_A}', "");
    Expect(0, 43824, '\P{^-is_Ethiopic_EXT_A}', "");
    Error('\p{ In_ethiopic_ext_A:=}');
    Error('\P{ In_ethiopic_ext_A:=}');
    Expect(1, 43823, '\p{inethiopicexta}', "");
    Expect(0, 43823, '\p{^inethiopicexta}', "");
    Expect(0, 43823, '\P{inethiopicexta}', "");
    Expect(1, 43823, '\P{^inethiopicexta}', "");
    Expect(0, 43824, '\p{inethiopicexta}', "");
    Expect(1, 43824, '\p{^inethiopicexta}', "");
    Expect(1, 43824, '\P{inethiopicexta}', "");
    Expect(0, 43824, '\P{^inethiopicexta}', "");
    Expect(1, 43823, '\p{--IN_ETHIOPIC_EXT_A}', "");
    Expect(0, 43823, '\p{^--IN_ETHIOPIC_EXT_A}', "");
    Expect(0, 43823, '\P{--IN_ETHIOPIC_EXT_A}', "");
    Expect(1, 43823, '\P{^--IN_ETHIOPIC_EXT_A}', "");
    Expect(0, 43824, '\p{--IN_ETHIOPIC_EXT_A}', "");
    Expect(1, 43824, '\p{^--IN_ETHIOPIC_EXT_A}', "");
    Expect(1, 43824, '\P{--IN_ETHIOPIC_EXT_A}', "");
    Expect(0, 43824, '\P{^--IN_ETHIOPIC_EXT_A}', "");
    Error('\p{/a/		ethiopic_SUPPLEMENT}');
    Error('\P{/a/		ethiopic_SUPPLEMENT}');
    Expect(1, 5023, '\p{ethiopicsupplement}', "");
    Expect(0, 5023, '\p{^ethiopicsupplement}', "");
    Expect(0, 5023, '\P{ethiopicsupplement}', "");
    Expect(1, 5023, '\P{^ethiopicsupplement}', "");
    Expect(0, 5024, '\p{ethiopicsupplement}', "");
    Expect(1, 5024, '\p{^ethiopicsupplement}', "");
    Expect(1, 5024, '\P{ethiopicsupplement}', "");
    Expect(0, 5024, '\P{^ethiopicsupplement}', "");
    Expect(1, 5023, '\p{		ethiopic_supplement}', "");
    Expect(0, 5023, '\p{^		ethiopic_supplement}', "");
    Expect(0, 5023, '\P{		ethiopic_supplement}', "");
    Expect(1, 5023, '\P{^		ethiopic_supplement}', "");
    Expect(0, 5024, '\p{		ethiopic_supplement}', "");
    Expect(1, 5024, '\p{^		ethiopic_supplement}', "");
    Expect(1, 5024, '\P{		ethiopic_supplement}', "");
    Expect(0, 5024, '\P{^		ethiopic_supplement}', "");
    Error('\p{-Is_ethiopic_SUPPLEMENT:=}');
    Error('\P{-Is_ethiopic_SUPPLEMENT:=}');
    Expect(1, 5023, '\p{isethiopicsupplement}', "");
    Expect(0, 5023, '\p{^isethiopicsupplement}', "");
    Expect(0, 5023, '\P{isethiopicsupplement}', "");
    Expect(1, 5023, '\P{^isethiopicsupplement}', "");
    Expect(0, 5024, '\p{isethiopicsupplement}', "");
    Expect(1, 5024, '\p{^isethiopicsupplement}', "");
    Expect(1, 5024, '\P{isethiopicsupplement}', "");
    Expect(0, 5024, '\P{^isethiopicsupplement}', "");
    Expect(1, 5023, '\p{ -Is_ethiopic_supplement}', "");
    Expect(0, 5023, '\p{^ -Is_ethiopic_supplement}', "");
    Expect(0, 5023, '\P{ -Is_ethiopic_supplement}', "");
    Expect(1, 5023, '\P{^ -Is_ethiopic_supplement}', "");
    Expect(0, 5024, '\p{ -Is_ethiopic_supplement}', "");
    Expect(1, 5024, '\p{^ -Is_ethiopic_supplement}', "");
    Expect(1, 5024, '\P{ -Is_ethiopic_supplement}', "");
    Expect(0, 5024, '\P{^ -Is_ethiopic_supplement}', "");
    Error('\p{/a/_in_ethiopic_Supplement}');
    Error('\P{/a/_in_ethiopic_Supplement}');
    Expect(1, 5023, '\p{inethiopicsupplement}', "");
    Expect(0, 5023, '\p{^inethiopicsupplement}', "");
    Expect(0, 5023, '\P{inethiopicsupplement}', "");
    Expect(1, 5023, '\P{^inethiopicsupplement}', "");
    Expect(0, 5024, '\p{inethiopicsupplement}', "");
    Expect(1, 5024, '\p{^inethiopicsupplement}', "");
    Expect(1, 5024, '\P{inethiopicsupplement}', "");
    Expect(0, 5024, '\P{^inethiopicsupplement}', "");
    Expect(1, 5023, '\p{__in_Ethiopic_supplement}', "");
    Expect(0, 5023, '\p{^__in_Ethiopic_supplement}', "");
    Expect(0, 5023, '\P{__in_Ethiopic_supplement}', "");
    Expect(1, 5023, '\P{^__in_Ethiopic_supplement}', "");
    Expect(0, 5024, '\p{__in_Ethiopic_supplement}', "");
    Expect(1, 5024, '\p{^__in_Ethiopic_supplement}', "");
    Expect(1, 5024, '\P{__in_Ethiopic_supplement}', "");
    Expect(0, 5024, '\P{^__in_Ethiopic_supplement}', "");
    Error('\p{ :=Ethiopic_SUP}');
    Error('\P{ :=Ethiopic_SUP}');
    Expect(1, 5023, '\p{ethiopicsup}', "");
    Expect(0, 5023, '\p{^ethiopicsup}', "");
    Expect(0, 5023, '\P{ethiopicsup}', "");
    Expect(1, 5023, '\P{^ethiopicsup}', "");
    Expect(0, 5024, '\p{ethiopicsup}', "");
    Expect(1, 5024, '\p{^ethiopicsup}', "");
    Expect(1, 5024, '\P{ethiopicsup}', "");
    Expect(0, 5024, '\P{^ethiopicsup}', "");
    Expect(1, 5023, '\p{__Ethiopic_Sup}', "");
    Expect(0, 5023, '\p{^__Ethiopic_Sup}', "");
    Expect(0, 5023, '\P{__Ethiopic_Sup}', "");
    Expect(1, 5023, '\P{^__Ethiopic_Sup}', "");
    Expect(0, 5024, '\p{__Ethiopic_Sup}', "");
    Expect(1, 5024, '\p{^__Ethiopic_Sup}', "");
    Expect(1, 5024, '\P{__Ethiopic_Sup}', "");
    Expect(0, 5024, '\P{^__Ethiopic_Sup}', "");
    Error('\p{-/a/is_ETHIOPIC_Sup}');
    Error('\P{-/a/is_ETHIOPIC_Sup}');
    Expect(1, 5023, '\p{isethiopicsup}', "");
    Expect(0, 5023, '\p{^isethiopicsup}', "");
    Expect(0, 5023, '\P{isethiopicsup}', "");
    Expect(1, 5023, '\P{^isethiopicsup}', "");
    Expect(0, 5024, '\p{isethiopicsup}', "");
    Expect(1, 5024, '\p{^isethiopicsup}', "");
    Expect(1, 5024, '\P{isethiopicsup}', "");
    Expect(0, 5024, '\P{^isethiopicsup}', "");
    Expect(1, 5023, '\p{ _Is_Ethiopic_Sup}', "");
    Expect(0, 5023, '\p{^ _Is_Ethiopic_Sup}', "");
    Expect(0, 5023, '\P{ _Is_Ethiopic_Sup}', "");
    Expect(1, 5023, '\P{^ _Is_Ethiopic_Sup}', "");
    Expect(0, 5024, '\p{ _Is_Ethiopic_Sup}', "");
    Expect(1, 5024, '\p{^ _Is_Ethiopic_Sup}', "");
    Expect(1, 5024, '\P{ _Is_Ethiopic_Sup}', "");
    Expect(0, 5024, '\P{^ _Is_Ethiopic_Sup}', "");
    Error('\p{:=__In_ethiopic_sup}');
    Error('\P{:=__In_ethiopic_sup}');
    Expect(1, 5023, '\p{inethiopicsup}', "");
    Expect(0, 5023, '\p{^inethiopicsup}', "");
    Expect(0, 5023, '\P{inethiopicsup}', "");
    Expect(1, 5023, '\P{^inethiopicsup}', "");
    Expect(0, 5024, '\p{inethiopicsup}', "");
    Expect(1, 5024, '\p{^inethiopicsup}', "");
    Expect(1, 5024, '\P{inethiopicsup}', "");
    Expect(0, 5024, '\P{^inethiopicsup}', "");
    Expect(1, 5023, '\p{- in_Ethiopic_Sup}', "");
    Expect(0, 5023, '\p{^- in_Ethiopic_Sup}', "");
    Expect(0, 5023, '\P{- in_Ethiopic_Sup}', "");
    Expect(1, 5023, '\P{^- in_Ethiopic_Sup}', "");
    Expect(0, 5024, '\p{- in_Ethiopic_Sup}', "");
    Expect(1, 5024, '\p{^- in_Ethiopic_Sup}', "");
    Expect(1, 5024, '\P{- in_Ethiopic_Sup}', "");
    Expect(0, 5024, '\P{^- in_Ethiopic_Sup}', "");
    Error('\p{Expands_On_NFC}');
    Error('\P{Expands_On_NFC}');
    Error('\p{XO_NFC}');
    Error('\P{XO_NFC}');
    Error('\p{Expands_On_NFD}');
    Error('\P{Expands_On_NFD}');
    Error('\p{XO_NFD}');
    Error('\P{XO_NFD}');
    Error('\p{Expands_On_NFKC}');
    Error('\P{Expands_On_NFKC}');
    Error('\p{XO_NFKC}');
    Error('\P{XO_NFKC}');
    Error('\p{Expands_On_NFKD}');
    Error('\P{Expands_On_NFKD}');
    Error('\p{XO_NFKD}');
    Error('\P{XO_NFKD}');
    Error('\p{Extended_Pictographic}');
    Error('\P{Extended_Pictographic}');
    Error('\p{XPG}');
    Error('\P{XPG}');
    Error('\p{:=  Extender}');
    Error('\P{:=  Extender}');
    Expect(1, 125254, '\p{extender}', "");
    Expect(0, 125254, '\p{^extender}', "");
    Expect(0, 125254, '\P{extender}', "");
    Expect(1, 125254, '\P{^extender}', "");
    Expect(0, 125255, '\p{extender}', "");
    Expect(1, 125255, '\p{^extender}', "");
    Expect(1, 125255, '\P{extender}', "");
    Expect(0, 125255, '\P{^extender}', "");
    Expect(1, 125254, '\p{ -Extender}', "");
    Expect(0, 125254, '\p{^ -Extender}', "");
    Expect(0, 125254, '\P{ -Extender}', "");
    Expect(1, 125254, '\P{^ -Extender}', "");
    Expect(0, 125255, '\p{ -Extender}', "");
    Expect(1, 125255, '\p{^ -Extender}', "");
    Expect(1, 125255, '\P{ -Extender}', "");
    Expect(0, 125255, '\P{^ -Extender}', "");
    Error('\p{/a/	Is_extender}');
    Error('\P{/a/	Is_extender}');
    Expect(1, 125254, '\p{isextender}', "");
    Expect(0, 125254, '\p{^isextender}', "");
    Expect(0, 125254, '\P{isextender}', "");
    Expect(1, 125254, '\P{^isextender}', "");
    Expect(0, 125255, '\p{isextender}', "");
    Expect(1, 125255, '\p{^isextender}', "");
    Expect(1, 125255, '\P{isextender}', "");
    Expect(0, 125255, '\P{^isextender}', "");
    Expect(1, 125254, '\p{_IS_Extender}', "");
    Expect(0, 125254, '\p{^_IS_Extender}', "");
    Expect(0, 125254, '\P{_IS_Extender}', "");
    Expect(1, 125254, '\P{^_IS_Extender}', "");
    Expect(0, 125255, '\p{_IS_Extender}', "");
    Expect(1, 125255, '\p{^_IS_Extender}', "");
    Expect(1, 125255, '\P{_IS_Extender}', "");
    Expect(0, 125255, '\P{^_IS_Extender}', "");
    Error('\p{Ext:=}');
    Error('\P{Ext:=}');
    Expect(1, 125254, '\p{ext}', "");
    Expect(0, 125254, '\p{^ext}', "");
    Expect(0, 125254, '\P{ext}', "");
    Expect(1, 125254, '\P{^ext}', "");
    Expect(0, 125255, '\p{ext}', "");
    Expect(1, 125255, '\p{^ext}', "");
    Expect(1, 125255, '\P{ext}', "");
    Expect(0, 125255, '\P{^ext}', "");
    Expect(1, 125254, '\p{__EXT}', "");
    Expect(0, 125254, '\p{^__EXT}', "");
    Expect(0, 125254, '\P{__EXT}', "");
    Expect(1, 125254, '\P{^__EXT}', "");
    Expect(0, 125255, '\p{__EXT}', "");
    Expect(1, 125255, '\p{^__EXT}', "");
    Expect(1, 125255, '\P{__EXT}', "");
    Expect(0, 125255, '\P{^__EXT}', "");
    Error('\p{:=Is_ext}');
    Error('\P{:=Is_ext}');
    Expect(1, 125254, '\p{isext}', "");
    Expect(0, 125254, '\p{^isext}', "");
    Expect(0, 125254, '\P{isext}', "");
    Expect(1, 125254, '\P{^isext}', "");
    Expect(0, 125255, '\p{isext}', "");
    Expect(1, 125255, '\p{^isext}', "");
    Expect(1, 125255, '\P{isext}', "");
    Expect(0, 125255, '\P{^isext}', "");
    Expect(1, 125254, '\p{Is_ext}', "");
    Expect(0, 125254, '\p{^Is_ext}', "");
    Expect(0, 125254, '\P{Is_ext}', "");
    Expect(1, 125254, '\P{^Is_ext}', "");
    Expect(0, 125255, '\p{Is_ext}', "");
    Expect(1, 125255, '\p{^Is_ext}', "");
    Expect(1, 125255, '\P{Is_ext}', "");
    Expect(0, 125255, '\P{^Is_ext}', "");
    Error('\p{:=		final_Punctuation}');
    Error('\P{:=		final_Punctuation}');
    Expect(1, 11809, '\p{finalpunctuation}', "");
    Expect(0, 11809, '\p{^finalpunctuation}', "");
    Expect(0, 11809, '\P{finalpunctuation}', "");
    Expect(1, 11809, '\P{^finalpunctuation}', "");
    Expect(0, 11810, '\p{finalpunctuation}', "");
    Expect(1, 11810, '\p{^finalpunctuation}', "");
    Expect(1, 11810, '\P{finalpunctuation}', "");
    Expect(0, 11810, '\P{^finalpunctuation}', "");
    Expect(1, 11809, '\p{-Final_Punctuation}', "");
    Expect(0, 11809, '\p{^-Final_Punctuation}', "");
    Expect(0, 11809, '\P{-Final_Punctuation}', "");
    Expect(1, 11809, '\P{^-Final_Punctuation}', "");
    Expect(0, 11810, '\p{-Final_Punctuation}', "");
    Expect(1, 11810, '\p{^-Final_Punctuation}', "");
    Expect(1, 11810, '\P{-Final_Punctuation}', "");
    Expect(0, 11810, '\P{^-Final_Punctuation}', "");
    Error('\p{:= _is_FINAL_punctuation}');
    Error('\P{:= _is_FINAL_punctuation}');
    Expect(1, 11809, '\p{isfinalpunctuation}', "");
    Expect(0, 11809, '\p{^isfinalpunctuation}', "");
    Expect(0, 11809, '\P{isfinalpunctuation}', "");
    Expect(1, 11809, '\P{^isfinalpunctuation}', "");
    Expect(0, 11810, '\p{isfinalpunctuation}', "");
    Expect(1, 11810, '\p{^isfinalpunctuation}', "");
    Expect(1, 11810, '\P{isfinalpunctuation}', "");
    Expect(0, 11810, '\P{^isfinalpunctuation}', "");
    Expect(1, 11809, '\p{__Is_Final_punctuation}', "");
    Expect(0, 11809, '\p{^__Is_Final_punctuation}', "");
    Expect(0, 11809, '\P{__Is_Final_punctuation}', "");
    Expect(1, 11809, '\P{^__Is_Final_punctuation}', "");
    Expect(0, 11810, '\p{__Is_Final_punctuation}', "");
    Expect(1, 11810, '\p{^__Is_Final_punctuation}', "");
    Expect(1, 11810, '\P{__Is_Final_punctuation}', "");
    Expect(0, 11810, '\P{^__Is_Final_punctuation}', "");
    Error('\p{:=	 Pf}');
    Error('\P{:=	 Pf}');
    Expect(1, 11809, '\p{pf}', "");
    Expect(0, 11809, '\p{^pf}', "");
    Expect(0, 11809, '\P{pf}', "");
    Expect(1, 11809, '\P{^pf}', "");
    Expect(0, 11810, '\p{pf}', "");
    Expect(1, 11810, '\p{^pf}', "");
    Expect(1, 11810, '\P{pf}', "");
    Expect(0, 11810, '\P{^pf}', "");
    Expect(1, 11809, '\p{_Pf}', "");
    Expect(0, 11809, '\p{^_Pf}', "");
    Expect(0, 11809, '\P{_Pf}', "");
    Expect(1, 11809, '\P{^_Pf}', "");
    Expect(0, 11810, '\p{_Pf}', "");
    Expect(1, 11810, '\p{^_Pf}', "");
    Expect(1, 11810, '\P{_Pf}', "");
    Expect(0, 11810, '\P{^_Pf}', "");
    Error('\p{_/a/is_pf}');
    Error('\P{_/a/is_pf}');
    Expect(1, 11809, '\p{ispf}', "");
    Expect(0, 11809, '\p{^ispf}', "");
    Expect(0, 11809, '\P{ispf}', "");
    Expect(1, 11809, '\P{^ispf}', "");
    Expect(0, 11810, '\p{ispf}', "");
    Expect(1, 11810, '\p{^ispf}', "");
    Expect(1, 11810, '\P{ispf}', "");
    Expect(0, 11810, '\P{^ispf}', "");
    Expect(1, 11809, '\p{ is_Pf}', "");
    Expect(0, 11809, '\p{^ is_Pf}', "");
    Expect(0, 11809, '\P{ is_Pf}', "");
    Expect(1, 11809, '\P{^ is_Pf}', "");
    Expect(0, 11810, '\p{ is_Pf}', "");
    Expect(1, 11810, '\p{^ is_Pf}', "");
    Expect(1, 11810, '\P{ is_Pf}', "");
    Expect(0, 11810, '\P{^ is_Pf}', "");
    Error('\p{:=	Format}');
    Error('\P{:=	Format}');
    Expect(1, 917631, '\p{format}', "");
    Expect(0, 917631, '\p{^format}', "");
    Expect(0, 917631, '\P{format}', "");
    Expect(1, 917631, '\P{^format}', "");
    Expect(0, 917632, '\p{format}', "");
    Expect(1, 917632, '\p{^format}', "");
    Expect(1, 917632, '\P{format}', "");
    Expect(0, 917632, '\P{^format}', "");
    Expect(1, 917631, '\p{ -format}', "");
    Expect(0, 917631, '\p{^ -format}', "");
    Expect(0, 917631, '\P{ -format}', "");
    Expect(1, 917631, '\P{^ -format}', "");
    Expect(0, 917632, '\p{ -format}', "");
    Expect(1, 917632, '\p{^ -format}', "");
    Expect(1, 917632, '\P{ -format}', "");
    Expect(0, 917632, '\P{^ -format}', "");
    Error('\p{/a/-_IS_Format}');
    Error('\P{/a/-_IS_Format}');
    Expect(1, 917631, '\p{isformat}', "");
    Expect(0, 917631, '\p{^isformat}', "");
    Expect(0, 917631, '\P{isformat}', "");
    Expect(1, 917631, '\P{^isformat}', "");
    Expect(0, 917632, '\p{isformat}', "");
    Expect(1, 917632, '\p{^isformat}', "");
    Expect(1, 917632, '\P{isformat}', "");
    Expect(0, 917632, '\P{^isformat}', "");
    Expect(1, 917631, '\p{		is_Format}', "");
    Expect(0, 917631, '\p{^		is_Format}', "");
    Expect(0, 917631, '\P{		is_Format}', "");
    Expect(1, 917631, '\P{^		is_Format}', "");
    Expect(0, 917632, '\p{		is_Format}', "");
    Expect(1, 917632, '\p{^		is_Format}', "");
    Expect(1, 917632, '\P{		is_Format}', "");
    Expect(0, 917632, '\P{^		is_Format}', "");
    Error('\p{ /a/CF}');
    Error('\P{ /a/CF}');
    Expect(1, 917631, '\p{cf}', "");
    Expect(0, 917631, '\p{^cf}', "");
    Expect(0, 917631, '\P{cf}', "");
    Expect(1, 917631, '\P{^cf}', "");
    Expect(0, 917632, '\p{cf}', "");
    Expect(1, 917632, '\p{^cf}', "");
    Expect(1, 917632, '\P{cf}', "");
    Expect(0, 917632, '\P{^cf}', "");
    Expect(1, 917631, '\p{	Cf}', "");
    Expect(0, 917631, '\p{^	Cf}', "");
    Expect(0, 917631, '\P{	Cf}', "");
    Expect(1, 917631, '\P{^	Cf}', "");
    Expect(0, 917632, '\p{	Cf}', "");
    Expect(1, 917632, '\p{^	Cf}', "");
    Expect(1, 917632, '\P{	Cf}', "");
    Expect(0, 917632, '\P{^	Cf}', "");
    Error('\p{/a/	-IS_CF}');
    Error('\P{/a/	-IS_CF}');
    Expect(1, 917631, '\p{iscf}', "");
    Expect(0, 917631, '\p{^iscf}', "");
    Expect(0, 917631, '\P{iscf}', "");
    Expect(1, 917631, '\P{^iscf}', "");
    Expect(0, 917632, '\p{iscf}', "");
    Expect(1, 917632, '\p{^iscf}', "");
    Expect(1, 917632, '\P{iscf}', "");
    Expect(0, 917632, '\P{^iscf}', "");
    Expect(1, 917631, '\p{	-Is_Cf}', "");
    Expect(0, 917631, '\p{^	-Is_Cf}', "");
    Expect(0, 917631, '\P{	-Is_Cf}', "");
    Expect(1, 917631, '\P{^	-Is_Cf}', "");
    Expect(0, 917632, '\p{	-Is_Cf}', "");
    Expect(1, 917632, '\p{^	-Is_Cf}', "");
    Expect(1, 917632, '\P{	-Is_Cf}', "");
    Expect(0, 917632, '\P{^	-Is_Cf}', "");
    Error('\p{:=_full_Composition_Exclusion}');
    Error('\P{:=_full_Composition_Exclusion}');
    Expect(1, 195101, '\p{fullcompositionexclusion}', "");
    Expect(0, 195101, '\p{^fullcompositionexclusion}', "");
    Expect(0, 195101, '\P{fullcompositionexclusion}', "");
    Expect(1, 195101, '\P{^fullcompositionexclusion}', "");
    Expect(0, 195102, '\p{fullcompositionexclusion}', "");
    Expect(1, 195102, '\p{^fullcompositionexclusion}', "");
    Expect(1, 195102, '\P{fullcompositionexclusion}', "");
    Expect(0, 195102, '\P{^fullcompositionexclusion}', "");
    Expect(1, 195101, '\p{_ Full_Composition_exclusion}', "");
    Expect(0, 195101, '\p{^_ Full_Composition_exclusion}', "");
    Expect(0, 195101, '\P{_ Full_Composition_exclusion}', "");
    Expect(1, 195101, '\P{^_ Full_Composition_exclusion}', "");
    Expect(0, 195102, '\p{_ Full_Composition_exclusion}', "");
    Expect(1, 195102, '\p{^_ Full_Composition_exclusion}', "");
    Expect(1, 195102, '\P{_ Full_Composition_exclusion}', "");
    Expect(0, 195102, '\P{^_ Full_Composition_exclusion}', "");
    Error('\p{-:=Is_FULL_Composition_Exclusion}');
    Error('\P{-:=Is_FULL_Composition_Exclusion}');
    Expect(1, 195101, '\p{isfullcompositionexclusion}', "");
    Expect(0, 195101, '\p{^isfullcompositionexclusion}', "");
    Expect(0, 195101, '\P{isfullcompositionexclusion}', "");
    Expect(1, 195101, '\P{^isfullcompositionexclusion}', "");
    Expect(0, 195102, '\p{isfullcompositionexclusion}', "");
    Expect(1, 195102, '\p{^isfullcompositionexclusion}', "");
    Expect(1, 195102, '\P{isfullcompositionexclusion}', "");
    Expect(0, 195102, '\P{^isfullcompositionexclusion}', "");
    Expect(1, 195101, '\p{ 	Is_FULL_Composition_Exclusion}', "");
    Expect(0, 195101, '\p{^ 	Is_FULL_Composition_Exclusion}', "");
    Expect(0, 195101, '\P{ 	Is_FULL_Composition_Exclusion}', "");
    Expect(1, 195101, '\P{^ 	Is_FULL_Composition_Exclusion}', "");
    Expect(0, 195102, '\p{ 	Is_FULL_Composition_Exclusion}', "");
    Expect(1, 195102, '\p{^ 	Is_FULL_Composition_Exclusion}', "");
    Expect(1, 195102, '\P{ 	Is_FULL_Composition_Exclusion}', "");
    Expect(0, 195102, '\P{^ 	Is_FULL_Composition_Exclusion}', "");
    Error('\p{ comp_Ex/a/}');
    Error('\P{ comp_Ex/a/}');
    Expect(1, 195101, '\p{compex}', "");
    Expect(0, 195101, '\p{^compex}', "");
    Expect(0, 195101, '\P{compex}', "");
    Expect(1, 195101, '\P{^compex}', "");
    Expect(0, 195102, '\p{compex}', "");
    Expect(1, 195102, '\p{^compex}', "");
    Expect(1, 195102, '\P{compex}', "");
    Expect(0, 195102, '\P{^compex}', "");
    Expect(1, 195101, '\p{ -comp_EX}', "");
    Expect(0, 195101, '\p{^ -comp_EX}', "");
    Expect(0, 195101, '\P{ -comp_EX}', "");
    Expect(1, 195101, '\P{^ -comp_EX}', "");
    Expect(0, 195102, '\p{ -comp_EX}', "");
    Expect(1, 195102, '\p{^ -comp_EX}', "");
    Expect(1, 195102, '\P{ -comp_EX}', "");
    Expect(0, 195102, '\P{^ -comp_EX}', "");
    Error('\p{-/a/Is_COMP_Ex}');
    Error('\P{-/a/Is_COMP_Ex}');
    Expect(1, 195101, '\p{iscompex}', "");
    Expect(0, 195101, '\p{^iscompex}', "");
    Expect(0, 195101, '\P{iscompex}', "");
    Expect(1, 195101, '\P{^iscompex}', "");
    Expect(0, 195102, '\p{iscompex}', "");
    Expect(1, 195102, '\p{^iscompex}', "");
    Expect(1, 195102, '\P{iscompex}', "");
    Expect(0, 195102, '\P{^iscompex}', "");
    Expect(1, 195101, '\p{	IS_Comp_Ex}', "");
    Expect(0, 195101, '\p{^	IS_Comp_Ex}', "");
    Expect(0, 195101, '\P{	IS_Comp_Ex}', "");
    Expect(1, 195101, '\P{^	IS_Comp_Ex}', "");
    Expect(0, 195102, '\p{	IS_Comp_Ex}', "");
    Expect(1, 195102, '\p{^	IS_Comp_Ex}', "");
    Expect(1, 195102, '\P{	IS_Comp_Ex}', "");
    Expect(0, 195102, '\P{^	IS_Comp_Ex}', "");
    Error('\p{/a/general_Punctuation}');
    Error('\P{/a/general_Punctuation}');
    Expect(1, 8303, '\p{generalpunctuation}', "");
    Expect(0, 8303, '\p{^generalpunctuation}', "");
    Expect(0, 8303, '\P{generalpunctuation}', "");
    Expect(1, 8303, '\P{^generalpunctuation}', "");
    Expect(0, 8304, '\p{generalpunctuation}', "");
    Expect(1, 8304, '\p{^generalpunctuation}', "");
    Expect(1, 8304, '\P{generalpunctuation}', "");
    Expect(0, 8304, '\P{^generalpunctuation}', "");
    Expect(1, 8303, '\p{_-General_Punctuation}', "");
    Expect(0, 8303, '\p{^_-General_Punctuation}', "");
    Expect(0, 8303, '\P{_-General_Punctuation}', "");
    Expect(1, 8303, '\P{^_-General_Punctuation}', "");
    Expect(0, 8304, '\p{_-General_Punctuation}', "");
    Expect(1, 8304, '\p{^_-General_Punctuation}', "");
    Expect(1, 8304, '\P{_-General_Punctuation}', "");
    Expect(0, 8304, '\P{^_-General_Punctuation}', "");
    Error('\p{_Is_General_Punctuation:=}');
    Error('\P{_Is_General_Punctuation:=}');
    Expect(1, 8303, '\p{isgeneralpunctuation}', "");
    Expect(0, 8303, '\p{^isgeneralpunctuation}', "");
    Expect(0, 8303, '\P{isgeneralpunctuation}', "");
    Expect(1, 8303, '\P{^isgeneralpunctuation}', "");
    Expect(0, 8304, '\p{isgeneralpunctuation}', "");
    Expect(1, 8304, '\p{^isgeneralpunctuation}', "");
    Expect(1, 8304, '\P{isgeneralpunctuation}', "");
    Expect(0, 8304, '\P{^isgeneralpunctuation}', "");
    Expect(1, 8303, '\p{- Is_General_punctuation}', "");
    Expect(0, 8303, '\p{^- Is_General_punctuation}', "");
    Expect(0, 8303, '\P{- Is_General_punctuation}', "");
    Expect(1, 8303, '\P{^- Is_General_punctuation}', "");
    Expect(0, 8304, '\p{- Is_General_punctuation}', "");
    Expect(1, 8304, '\p{^- Is_General_punctuation}', "");
    Expect(1, 8304, '\P{- Is_General_punctuation}', "");
    Expect(0, 8304, '\P{^- Is_General_punctuation}', "");
    Error('\p{/a/In_GENERAL_Punctuation}');
    Error('\P{/a/In_GENERAL_Punctuation}');
    Expect(1, 8303, '\p{ingeneralpunctuation}', "");
    Expect(0, 8303, '\p{^ingeneralpunctuation}', "");
    Expect(0, 8303, '\P{ingeneralpunctuation}', "");
    Expect(1, 8303, '\P{^ingeneralpunctuation}', "");
    Expect(0, 8304, '\p{ingeneralpunctuation}', "");
    Expect(1, 8304, '\p{^ingeneralpunctuation}', "");
    Expect(1, 8304, '\P{ingeneralpunctuation}', "");
    Expect(0, 8304, '\P{^ingeneralpunctuation}', "");
    Expect(1, 8303, '\p{_In_General_Punctuation}', "");
    Expect(0, 8303, '\p{^_In_General_Punctuation}', "");
    Expect(0, 8303, '\P{_In_General_Punctuation}', "");
    Expect(1, 8303, '\P{^_In_General_Punctuation}', "");
    Expect(0, 8304, '\p{_In_General_Punctuation}', "");
    Expect(1, 8304, '\p{^_In_General_Punctuation}', "");
    Expect(1, 8304, '\P{_In_General_Punctuation}', "");
    Expect(0, 8304, '\P{^_In_General_Punctuation}', "");
    Error('\p{	in_Punctuation/a/}');
    Error('\P{	in_Punctuation/a/}');
    Expect(1, 8303, '\p{inpunctuation}', "");
    Expect(0, 8303, '\p{^inpunctuation}', "");
    Expect(0, 8303, '\P{inpunctuation}', "");
    Expect(1, 8303, '\P{^inpunctuation}', "");
    Expect(0, 8304, '\p{inpunctuation}', "");
    Expect(1, 8304, '\p{^inpunctuation}', "");
    Expect(1, 8304, '\P{inpunctuation}', "");
    Expect(0, 8304, '\P{^inpunctuation}', "");
    Expect(1, 8303, '\p{ _In_Punctuation}', "");
    Expect(0, 8303, '\p{^ _In_Punctuation}', "");
    Expect(0, 8303, '\P{ _In_Punctuation}', "");
    Expect(1, 8303, '\P{^ _In_Punctuation}', "");
    Expect(0, 8304, '\p{ _In_Punctuation}', "");
    Expect(1, 8304, '\p{^ _In_Punctuation}', "");
    Expect(1, 8304, '\P{ _In_Punctuation}', "");
    Expect(0, 8304, '\P{^ _In_Punctuation}', "");
    Error('\p{	/a/geometric_SHAPES}');
    Error('\P{	/a/geometric_SHAPES}');
    Expect(1, 9727, '\p{geometricshapes}', "");
    Expect(0, 9727, '\p{^geometricshapes}', "");
    Expect(0, 9727, '\P{geometricshapes}', "");
    Expect(1, 9727, '\P{^geometricshapes}', "");
    Expect(0, 9728, '\p{geometricshapes}', "");
    Expect(1, 9728, '\p{^geometricshapes}', "");
    Expect(1, 9728, '\P{geometricshapes}', "");
    Expect(0, 9728, '\P{^geometricshapes}', "");
    Expect(1, 9727, '\p{ geometric_shapes}', "");
    Expect(0, 9727, '\p{^ geometric_shapes}', "");
    Expect(0, 9727, '\P{ geometric_shapes}', "");
    Expect(1, 9727, '\P{^ geometric_shapes}', "");
    Expect(0, 9728, '\p{ geometric_shapes}', "");
    Expect(1, 9728, '\p{^ geometric_shapes}', "");
    Expect(1, 9728, '\P{ geometric_shapes}', "");
    Expect(0, 9728, '\P{^ geometric_shapes}', "");
    Error('\p{ /a/Is_Geometric_SHAPES}');
    Error('\P{ /a/Is_Geometric_SHAPES}');
    Expect(1, 9727, '\p{isgeometricshapes}', "");
    Expect(0, 9727, '\p{^isgeometricshapes}', "");
    Expect(0, 9727, '\P{isgeometricshapes}', "");
    Expect(1, 9727, '\P{^isgeometricshapes}', "");
    Expect(0, 9728, '\p{isgeometricshapes}', "");
    Expect(1, 9728, '\p{^isgeometricshapes}', "");
    Expect(1, 9728, '\P{isgeometricshapes}', "");
    Expect(0, 9728, '\P{^isgeometricshapes}', "");
    Expect(1, 9727, '\p{-Is_Geometric_Shapes}', "");
    Expect(0, 9727, '\p{^-Is_Geometric_Shapes}', "");
    Expect(0, 9727, '\P{-Is_Geometric_Shapes}', "");
    Expect(1, 9727, '\P{^-Is_Geometric_Shapes}', "");
    Expect(0, 9728, '\p{-Is_Geometric_Shapes}', "");
    Expect(1, 9728, '\p{^-Is_Geometric_Shapes}', "");
    Expect(1, 9728, '\P{-Is_Geometric_Shapes}', "");
    Expect(0, 9728, '\P{^-Is_Geometric_Shapes}', "");
    Error('\p{- In_Geometric_Shapes:=}');
    Error('\P{- In_Geometric_Shapes:=}');
    Expect(1, 9727, '\p{ingeometricshapes}', "");
    Expect(0, 9727, '\p{^ingeometricshapes}', "");
    Expect(0, 9727, '\P{ingeometricshapes}', "");
    Expect(1, 9727, '\P{^ingeometricshapes}', "");
    Expect(0, 9728, '\p{ingeometricshapes}', "");
    Expect(1, 9728, '\p{^ingeometricshapes}', "");
    Expect(1, 9728, '\P{ingeometricshapes}', "");
    Expect(0, 9728, '\P{^ingeometricshapes}', "");
    Expect(1, 9727, '\p{  In_geometric_Shapes}', "");
    Expect(0, 9727, '\p{^  In_geometric_Shapes}', "");
    Expect(0, 9727, '\P{  In_geometric_Shapes}', "");
    Expect(1, 9727, '\P{^  In_geometric_Shapes}', "");
    Expect(0, 9728, '\p{  In_geometric_Shapes}', "");
    Expect(1, 9728, '\p{^  In_geometric_Shapes}', "");
    Expect(1, 9728, '\P{  In_geometric_Shapes}', "");
    Expect(0, 9728, '\P{^  In_geometric_Shapes}', "");
    Error('\p{/a/Geometric_Shapes_EXTENDED}');
    Error('\P{/a/Geometric_Shapes_EXTENDED}');
    Expect(1, 129023, '\p{geometricshapesextended}', "");
    Expect(0, 129023, '\p{^geometricshapesextended}', "");
    Expect(0, 129023, '\P{geometricshapesextended}', "");
    Expect(1, 129023, '\P{^geometricshapesextended}', "");
    Expect(0, 129024, '\p{geometricshapesextended}', "");
    Expect(1, 129024, '\p{^geometricshapesextended}', "");
    Expect(1, 129024, '\P{geometricshapesextended}', "");
    Expect(0, 129024, '\P{^geometricshapesextended}', "");
    Expect(1, 129023, '\p{-_geometric_Shapes_extended}', "");
    Expect(0, 129023, '\p{^-_geometric_Shapes_extended}', "");
    Expect(0, 129023, '\P{-_geometric_Shapes_extended}', "");
    Expect(1, 129023, '\P{^-_geometric_Shapes_extended}', "");
    Expect(0, 129024, '\p{-_geometric_Shapes_extended}', "");
    Expect(1, 129024, '\p{^-_geometric_Shapes_extended}', "");
    Expect(1, 129024, '\P{-_geometric_Shapes_extended}', "");
    Expect(0, 129024, '\P{^-_geometric_Shapes_extended}', "");
    Error('\p{-:=IS_Geometric_Shapes_Extended}');
    Error('\P{-:=IS_Geometric_Shapes_Extended}');
    Expect(1, 129023, '\p{isgeometricshapesextended}', "");
    Expect(0, 129023, '\p{^isgeometricshapesextended}', "");
    Expect(0, 129023, '\P{isgeometricshapesextended}', "");
    Expect(1, 129023, '\P{^isgeometricshapesextended}', "");
    Expect(0, 129024, '\p{isgeometricshapesextended}', "");
    Expect(1, 129024, '\p{^isgeometricshapesextended}', "");
    Expect(1, 129024, '\P{isgeometricshapesextended}', "");
    Expect(0, 129024, '\P{^isgeometricshapesextended}', "");
    Expect(1, 129023, '\p{_Is_Geometric_Shapes_Extended}', "");
    Expect(0, 129023, '\p{^_Is_Geometric_Shapes_Extended}', "");
    Expect(0, 129023, '\P{_Is_Geometric_Shapes_Extended}', "");
    Expect(1, 129023, '\P{^_Is_Geometric_Shapes_Extended}', "");
    Expect(0, 129024, '\p{_Is_Geometric_Shapes_Extended}', "");
    Expect(1, 129024, '\p{^_Is_Geometric_Shapes_Extended}', "");
    Expect(1, 129024, '\P{_Is_Geometric_Shapes_Extended}', "");
    Expect(0, 129024, '\P{^_Is_Geometric_Shapes_Extended}', "");
    Error('\p{:=	_IN_Geometric_SHAPES_EXTENDED}');
    Error('\P{:=	_IN_Geometric_SHAPES_EXTENDED}');
    Expect(1, 129023, '\p{ingeometricshapesextended}', "");
    Expect(0, 129023, '\p{^ingeometricshapesextended}', "");
    Expect(0, 129023, '\P{ingeometricshapesextended}', "");
    Expect(1, 129023, '\P{^ingeometricshapesextended}', "");
    Expect(0, 129024, '\p{ingeometricshapesextended}', "");
    Expect(1, 129024, '\p{^ingeometricshapesextended}', "");
    Expect(1, 129024, '\P{ingeometricshapesextended}', "");
    Expect(0, 129024, '\P{^ingeometricshapesextended}', "");
    Expect(1, 129023, '\p{	_In_Geometric_shapes_Extended}', "");
    Expect(0, 129023, '\p{^	_In_Geometric_shapes_Extended}', "");
    Expect(0, 129023, '\P{	_In_Geometric_shapes_Extended}', "");
    Expect(1, 129023, '\P{^	_In_Geometric_shapes_Extended}', "");
    Expect(0, 129024, '\p{	_In_Geometric_shapes_Extended}', "");
    Expect(1, 129024, '\p{^	_In_Geometric_shapes_Extended}', "");
    Expect(1, 129024, '\P{	_In_Geometric_shapes_Extended}', "");
    Expect(0, 129024, '\P{^	_In_Geometric_shapes_Extended}', "");
    Error('\p{GEOMETRIC_shapes_ext:=}');
    Error('\P{GEOMETRIC_shapes_ext:=}');
    Expect(1, 129023, '\p{geometricshapesext}', "");
    Expect(0, 129023, '\p{^geometricshapesext}', "");
    Expect(0, 129023, '\P{geometricshapesext}', "");
    Expect(1, 129023, '\P{^geometricshapesext}', "");
    Expect(0, 129024, '\p{geometricshapesext}', "");
    Expect(1, 129024, '\p{^geometricshapesext}', "");
    Expect(1, 129024, '\P{geometricshapesext}', "");
    Expect(0, 129024, '\P{^geometricshapesext}', "");
    Expect(1, 129023, '\p{	_Geometric_SHAPES_EXT}', "");
    Expect(0, 129023, '\p{^	_Geometric_SHAPES_EXT}', "");
    Expect(0, 129023, '\P{	_Geometric_SHAPES_EXT}', "");
    Expect(1, 129023, '\P{^	_Geometric_SHAPES_EXT}', "");
    Expect(0, 129024, '\p{	_Geometric_SHAPES_EXT}', "");
    Expect(1, 129024, '\p{^	_Geometric_SHAPES_EXT}', "");
    Expect(1, 129024, '\P{	_Geometric_SHAPES_EXT}', "");
    Expect(0, 129024, '\P{^	_Geometric_SHAPES_EXT}', "");
    Error('\p{_	IS_GEOMETRIC_shapes_EXT/a/}');
    Error('\P{_	IS_GEOMETRIC_shapes_EXT/a/}');
    Expect(1, 129023, '\p{isgeometricshapesext}', "");
    Expect(0, 129023, '\p{^isgeometricshapesext}', "");
    Expect(0, 129023, '\P{isgeometricshapesext}', "");
    Expect(1, 129023, '\P{^isgeometricshapesext}', "");
    Expect(0, 129024, '\p{isgeometricshapesext}', "");
    Expect(1, 129024, '\p{^isgeometricshapesext}', "");
    Expect(1, 129024, '\P{isgeometricshapesext}', "");
    Expect(0, 129024, '\P{^isgeometricshapesext}', "");
    Expect(1, 129023, '\p{IS_geometric_Shapes_ext}', "");
    Expect(0, 129023, '\p{^IS_geometric_Shapes_ext}', "");
    Expect(0, 129023, '\P{IS_geometric_Shapes_ext}', "");
    Expect(1, 129023, '\P{^IS_geometric_Shapes_ext}', "");
    Expect(0, 129024, '\p{IS_geometric_Shapes_ext}', "");
    Expect(1, 129024, '\p{^IS_geometric_Shapes_ext}', "");
    Expect(1, 129024, '\P{IS_geometric_Shapes_ext}', "");
    Expect(0, 129024, '\P{^IS_geometric_Shapes_ext}', "");
    Error('\p{_/a/in_geometric_SHAPES_ext}');
    Error('\P{_/a/in_geometric_SHAPES_ext}');
    Expect(1, 129023, '\p{ingeometricshapesext}', "");
    Expect(0, 129023, '\p{^ingeometricshapesext}', "");
    Expect(0, 129023, '\P{ingeometricshapesext}', "");
    Expect(1, 129023, '\P{^ingeometricshapesext}', "");
    Expect(0, 129024, '\p{ingeometricshapesext}', "");
    Expect(1, 129024, '\p{^ingeometricshapesext}', "");
    Expect(1, 129024, '\P{ingeometricshapesext}', "");
    Expect(0, 129024, '\P{^ingeometricshapesext}', "");
    Expect(1, 129023, '\p{  In_Geometric_shapes_Ext}', "");
    Expect(0, 129023, '\p{^  In_Geometric_shapes_Ext}', "");
    Expect(0, 129023, '\P{  In_Geometric_shapes_Ext}', "");
    Expect(1, 129023, '\P{^  In_Geometric_shapes_Ext}', "");
    Expect(0, 129024, '\p{  In_Geometric_shapes_Ext}', "");
    Expect(1, 129024, '\p{^  In_Geometric_shapes_Ext}', "");
    Expect(1, 129024, '\P{  In_Geometric_shapes_Ext}', "");
    Expect(0, 129024, '\P{^  In_Geometric_shapes_Ext}', "");
    Error('\p{- Georgian:=}');
    Error('\P{- Georgian:=}');
    Expect(1, 11565, '\p{georgian}', "");
    Expect(0, 11565, '\p{^georgian}', "");
    Expect(0, 11565, '\P{georgian}', "");
    Expect(1, 11565, '\P{^georgian}', "");
    Expect(0, 11566, '\p{georgian}', "");
    Expect(1, 11566, '\p{^georgian}', "");
    Expect(1, 11566, '\P{georgian}', "");
    Expect(0, 11566, '\P{^georgian}', "");
    Expect(1, 11565, '\p{-	Georgian}', "");
    Expect(0, 11565, '\p{^-	Georgian}', "");
    Expect(0, 11565, '\P{-	Georgian}', "");
    Expect(1, 11565, '\P{^-	Georgian}', "");
    Expect(0, 11566, '\p{-	Georgian}', "");
    Expect(1, 11566, '\p{^-	Georgian}', "");
    Expect(1, 11566, '\P{-	Georgian}', "");
    Expect(0, 11566, '\P{^-	Georgian}', "");
    Error('\p{  is_georgian:=}');
    Error('\P{  is_georgian:=}');
    Expect(1, 11565, '\p{isgeorgian}', "");
    Expect(0, 11565, '\p{^isgeorgian}', "");
    Expect(0, 11565, '\P{isgeorgian}', "");
    Expect(1, 11565, '\P{^isgeorgian}', "");
    Expect(0, 11566, '\p{isgeorgian}', "");
    Expect(1, 11566, '\p{^isgeorgian}', "");
    Expect(1, 11566, '\P{isgeorgian}', "");
    Expect(0, 11566, '\P{^isgeorgian}', "");
    Expect(1, 11565, '\p{	_is_GEORGIAN}', "");
    Expect(0, 11565, '\p{^	_is_GEORGIAN}', "");
    Expect(0, 11565, '\P{	_is_GEORGIAN}', "");
    Expect(1, 11565, '\P{^	_is_GEORGIAN}', "");
    Expect(0, 11566, '\p{	_is_GEORGIAN}', "");
    Expect(1, 11566, '\p{^	_is_GEORGIAN}', "");
    Expect(1, 11566, '\P{	_is_GEORGIAN}', "");
    Expect(0, 11566, '\P{^	_is_GEORGIAN}', "");
    Error('\p{ :=geor}');
    Error('\P{ :=geor}');
    Expect(1, 11565, '\p{geor}', "");
    Expect(0, 11565, '\p{^geor}', "");
    Expect(0, 11565, '\P{geor}', "");
    Expect(1, 11565, '\P{^geor}', "");
    Expect(0, 11566, '\p{geor}', "");
    Expect(1, 11566, '\p{^geor}', "");
    Expect(1, 11566, '\P{geor}', "");
    Expect(0, 11566, '\P{^geor}', "");
    Expect(1, 11565, '\p{ -geor}', "");
    Expect(0, 11565, '\p{^ -geor}', "");
    Expect(0, 11565, '\P{ -geor}', "");
    Expect(1, 11565, '\P{^ -geor}', "");
    Expect(0, 11566, '\p{ -geor}', "");
    Expect(1, 11566, '\p{^ -geor}', "");
    Expect(1, 11566, '\P{ -geor}', "");
    Expect(0, 11566, '\P{^ -geor}', "");
    Error('\p{_	IS_Geor/a/}');
    Error('\P{_	IS_Geor/a/}');
    Expect(1, 11565, '\p{isgeor}', "");
    Expect(0, 11565, '\p{^isgeor}', "");
    Expect(0, 11565, '\P{isgeor}', "");
    Expect(1, 11565, '\P{^isgeor}', "");
    Expect(0, 11566, '\p{isgeor}', "");
    Expect(1, 11566, '\p{^isgeor}', "");
    Expect(1, 11566, '\P{isgeor}', "");
    Expect(0, 11566, '\P{^isgeor}', "");
    Expect(1, 11565, '\p{_	Is_Geor}', "");
    Expect(0, 11565, '\p{^_	Is_Geor}', "");
    Expect(0, 11565, '\P{_	Is_Geor}', "");
    Expect(1, 11565, '\P{^_	Is_Geor}', "");
    Expect(0, 11566, '\p{_	Is_Geor}', "");
    Expect(1, 11566, '\p{^_	Is_Geor}', "");
    Expect(1, 11566, '\P{_	Is_Geor}', "");
    Expect(0, 11566, '\P{^_	Is_Geor}', "");
    Error('\p{	_Georgian_EXTENDED:=}');
    Error('\P{	_Georgian_EXTENDED:=}');
    Expect(1, 7359, '\p{georgianextended}', "");
    Expect(0, 7359, '\p{^georgianextended}', "");
    Expect(0, 7359, '\P{georgianextended}', "");
    Expect(1, 7359, '\P{^georgianextended}', "");
    Expect(0, 7360, '\p{georgianextended}', "");
    Expect(1, 7360, '\p{^georgianextended}', "");
    Expect(1, 7360, '\P{georgianextended}', "");
    Expect(0, 7360, '\P{^georgianextended}', "");
    Expect(1, 7359, '\p{_georgian_EXTENDED}', "");
    Expect(0, 7359, '\p{^_georgian_EXTENDED}', "");
    Expect(0, 7359, '\P{_georgian_EXTENDED}', "");
    Expect(1, 7359, '\P{^_georgian_EXTENDED}', "");
    Expect(0, 7360, '\p{_georgian_EXTENDED}', "");
    Expect(1, 7360, '\p{^_georgian_EXTENDED}', "");
    Expect(1, 7360, '\P{_georgian_EXTENDED}', "");
    Expect(0, 7360, '\P{^_georgian_EXTENDED}', "");
    Error('\p{/a/-	IS_Georgian_Extended}');
    Error('\P{/a/-	IS_Georgian_Extended}');
    Expect(1, 7359, '\p{isgeorgianextended}', "");
    Expect(0, 7359, '\p{^isgeorgianextended}', "");
    Expect(0, 7359, '\P{isgeorgianextended}', "");
    Expect(1, 7359, '\P{^isgeorgianextended}', "");
    Expect(0, 7360, '\p{isgeorgianextended}', "");
    Expect(1, 7360, '\p{^isgeorgianextended}', "");
    Expect(1, 7360, '\P{isgeorgianextended}', "");
    Expect(0, 7360, '\P{^isgeorgianextended}', "");
    Expect(1, 7359, '\p{ 	IS_Georgian_EXTENDED}', "");
    Expect(0, 7359, '\p{^ 	IS_Georgian_EXTENDED}', "");
    Expect(0, 7359, '\P{ 	IS_Georgian_EXTENDED}', "");
    Expect(1, 7359, '\P{^ 	IS_Georgian_EXTENDED}', "");
    Expect(0, 7360, '\p{ 	IS_Georgian_EXTENDED}', "");
    Expect(1, 7360, '\p{^ 	IS_Georgian_EXTENDED}', "");
    Expect(1, 7360, '\P{ 	IS_Georgian_EXTENDED}', "");
    Expect(0, 7360, '\P{^ 	IS_Georgian_EXTENDED}', "");
    Error('\p{/a/ 	IN_GEORGIAN_extended}');
    Error('\P{/a/ 	IN_GEORGIAN_extended}');
    Expect(1, 7359, '\p{ingeorgianextended}', "");
    Expect(0, 7359, '\p{^ingeorgianextended}', "");
    Expect(0, 7359, '\P{ingeorgianextended}', "");
    Expect(1, 7359, '\P{^ingeorgianextended}', "");
    Expect(0, 7360, '\p{ingeorgianextended}', "");
    Expect(1, 7360, '\p{^ingeorgianextended}', "");
    Expect(1, 7360, '\P{ingeorgianextended}', "");
    Expect(0, 7360, '\P{^ingeorgianextended}', "");
    Expect(1, 7359, '\p{	_In_Georgian_extended}', "");
    Expect(0, 7359, '\p{^	_In_Georgian_extended}', "");
    Expect(0, 7359, '\P{	_In_Georgian_extended}', "");
    Expect(1, 7359, '\P{^	_In_Georgian_extended}', "");
    Expect(0, 7360, '\p{	_In_Georgian_extended}', "");
    Expect(1, 7360, '\p{^	_In_Georgian_extended}', "");
    Expect(1, 7360, '\P{	_In_Georgian_extended}', "");
    Expect(0, 7360, '\P{^	_In_Georgian_extended}', "");
    Error('\p{:=	Georgian_EXT}');
    Error('\P{:=	Georgian_EXT}');
    Expect(1, 7359, '\p{georgianext}', "");
    Expect(0, 7359, '\p{^georgianext}', "");
    Expect(0, 7359, '\P{georgianext}', "");
    Expect(1, 7359, '\P{^georgianext}', "");
    Expect(0, 7360, '\p{georgianext}', "");
    Expect(1, 7360, '\p{^georgianext}', "");
    Expect(1, 7360, '\P{georgianext}', "");
    Expect(0, 7360, '\P{^georgianext}', "");
    Expect(1, 7359, '\p{ GEORGIAN_EXT}', "");
    Expect(0, 7359, '\p{^ GEORGIAN_EXT}', "");
    Expect(0, 7359, '\P{ GEORGIAN_EXT}', "");
    Expect(1, 7359, '\P{^ GEORGIAN_EXT}', "");
    Expect(0, 7360, '\p{ GEORGIAN_EXT}', "");
    Expect(1, 7360, '\p{^ GEORGIAN_EXT}', "");
    Expect(1, 7360, '\P{ GEORGIAN_EXT}', "");
    Expect(0, 7360, '\P{^ GEORGIAN_EXT}', "");
    Error('\p{:=	_IS_georgian_Ext}');
    Error('\P{:=	_IS_georgian_Ext}');
    Expect(1, 7359, '\p{isgeorgianext}', "");
    Expect(0, 7359, '\p{^isgeorgianext}', "");
    Expect(0, 7359, '\P{isgeorgianext}', "");
    Expect(1, 7359, '\P{^isgeorgianext}', "");
    Expect(0, 7360, '\p{isgeorgianext}', "");
    Expect(1, 7360, '\p{^isgeorgianext}', "");
    Expect(1, 7360, '\P{isgeorgianext}', "");
    Expect(0, 7360, '\P{^isgeorgianext}', "");
    Expect(1, 7359, '\p{--Is_Georgian_Ext}', "");
    Expect(0, 7359, '\p{^--Is_Georgian_Ext}', "");
    Expect(0, 7359, '\P{--Is_Georgian_Ext}', "");
    Expect(1, 7359, '\P{^--Is_Georgian_Ext}', "");
    Expect(0, 7360, '\p{--Is_Georgian_Ext}', "");
    Expect(1, 7360, '\p{^--Is_Georgian_Ext}', "");
    Expect(1, 7360, '\P{--Is_Georgian_Ext}', "");
    Expect(0, 7360, '\P{^--Is_Georgian_Ext}', "");
    Error('\p{:=- IN_Georgian_Ext}');
    Error('\P{:=- IN_Georgian_Ext}');
    Expect(1, 7359, '\p{ingeorgianext}', "");
    Expect(0, 7359, '\p{^ingeorgianext}', "");
    Expect(0, 7359, '\P{ingeorgianext}', "");
    Expect(1, 7359, '\P{^ingeorgianext}', "");
    Expect(0, 7360, '\p{ingeorgianext}', "");
    Expect(1, 7360, '\p{^ingeorgianext}', "");
    Expect(1, 7360, '\P{ingeorgianext}', "");
    Expect(0, 7360, '\P{^ingeorgianext}', "");
    Expect(1, 7359, '\p{	In_georgian_ext}', "");
    Expect(0, 7359, '\p{^	In_georgian_ext}', "");
    Expect(0, 7359, '\P{	In_georgian_ext}', "");
    Expect(1, 7359, '\P{^	In_georgian_ext}', "");
    Expect(0, 7360, '\p{	In_georgian_ext}', "");
    Expect(1, 7360, '\p{^	In_georgian_ext}', "");
    Expect(1, 7360, '\P{	In_georgian_ext}', "");
    Expect(0, 7360, '\P{^	In_georgian_ext}', "");
    Error('\p{	Georgian_Supplement:=}');
    Error('\P{	Georgian_Supplement:=}');
    Expect(1, 11567, '\p{georgiansupplement}', "");
    Expect(0, 11567, '\p{^georgiansupplement}', "");
    Expect(0, 11567, '\P{georgiansupplement}', "");
    Expect(1, 11567, '\P{^georgiansupplement}', "");
    Expect(0, 11568, '\p{georgiansupplement}', "");
    Expect(1, 11568, '\p{^georgiansupplement}', "");
    Expect(1, 11568, '\P{georgiansupplement}', "");
    Expect(0, 11568, '\P{^georgiansupplement}', "");
    Expect(1, 11567, '\p{georgian_SUPPLEMENT}', "");
    Expect(0, 11567, '\p{^georgian_SUPPLEMENT}', "");
    Expect(0, 11567, '\P{georgian_SUPPLEMENT}', "");
    Expect(1, 11567, '\P{^georgian_SUPPLEMENT}', "");
    Expect(0, 11568, '\p{georgian_SUPPLEMENT}', "");
    Expect(1, 11568, '\p{^georgian_SUPPLEMENT}', "");
    Expect(1, 11568, '\P{georgian_SUPPLEMENT}', "");
    Expect(0, 11568, '\P{^georgian_SUPPLEMENT}', "");
    Error('\p{- Is_Georgian_Supplement:=}');
    Error('\P{- Is_Georgian_Supplement:=}');
    Expect(1, 11567, '\p{isgeorgiansupplement}', "");
    Expect(0, 11567, '\p{^isgeorgiansupplement}', "");
    Expect(0, 11567, '\P{isgeorgiansupplement}', "");
    Expect(1, 11567, '\P{^isgeorgiansupplement}', "");
    Expect(0, 11568, '\p{isgeorgiansupplement}', "");
    Expect(1, 11568, '\p{^isgeorgiansupplement}', "");
    Expect(1, 11568, '\P{isgeorgiansupplement}', "");
    Expect(0, 11568, '\P{^isgeorgiansupplement}', "");
    Expect(1, 11567, '\p{- is_georgian_SUPPLEMENT}', "");
    Expect(0, 11567, '\p{^- is_georgian_SUPPLEMENT}', "");
    Expect(0, 11567, '\P{- is_georgian_SUPPLEMENT}', "");
    Expect(1, 11567, '\P{^- is_georgian_SUPPLEMENT}', "");
    Expect(0, 11568, '\p{- is_georgian_SUPPLEMENT}', "");
    Expect(1, 11568, '\p{^- is_georgian_SUPPLEMENT}', "");
    Expect(1, 11568, '\P{- is_georgian_SUPPLEMENT}', "");
    Expect(0, 11568, '\P{^- is_georgian_SUPPLEMENT}', "");
    Error('\p{ In_Georgian_Supplement/a/}');
    Error('\P{ In_Georgian_Supplement/a/}');
    Expect(1, 11567, '\p{ingeorgiansupplement}', "");
    Expect(0, 11567, '\p{^ingeorgiansupplement}', "");
    Expect(0, 11567, '\P{ingeorgiansupplement}', "");
    Expect(1, 11567, '\P{^ingeorgiansupplement}', "");
    Expect(0, 11568, '\p{ingeorgiansupplement}', "");
    Expect(1, 11568, '\p{^ingeorgiansupplement}', "");
    Expect(1, 11568, '\P{ingeorgiansupplement}', "");
    Expect(0, 11568, '\P{^ingeorgiansupplement}', "");
    Expect(1, 11567, '\p{	-IN_Georgian_supplement}', "");
    Expect(0, 11567, '\p{^	-IN_Georgian_supplement}', "");
    Expect(0, 11567, '\P{	-IN_Georgian_supplement}', "");
    Expect(1, 11567, '\P{^	-IN_Georgian_supplement}', "");
    Expect(0, 11568, '\p{	-IN_Georgian_supplement}', "");
    Expect(1, 11568, '\p{^	-IN_Georgian_supplement}', "");
    Expect(1, 11568, '\P{	-IN_Georgian_supplement}', "");
    Expect(0, 11568, '\P{^	-IN_Georgian_supplement}', "");
    Error('\p{	Georgian_Sup:=}');
    Error('\P{	Georgian_Sup:=}');
    Expect(1, 11567, '\p{georgiansup}', "");
    Expect(0, 11567, '\p{^georgiansup}', "");
    Expect(0, 11567, '\P{georgiansup}', "");
    Expect(1, 11567, '\P{^georgiansup}', "");
    Expect(0, 11568, '\p{georgiansup}', "");
    Expect(1, 11568, '\p{^georgiansup}', "");
    Expect(1, 11568, '\P{georgiansup}', "");
    Expect(0, 11568, '\P{^georgiansup}', "");
    Expect(1, 11567, '\p{	GEORGIAN_sup}', "");
    Expect(0, 11567, '\p{^	GEORGIAN_sup}', "");
    Expect(0, 11567, '\P{	GEORGIAN_sup}', "");
    Expect(1, 11567, '\P{^	GEORGIAN_sup}', "");
    Expect(0, 11568, '\p{	GEORGIAN_sup}', "");
    Expect(1, 11568, '\p{^	GEORGIAN_sup}', "");
    Expect(1, 11568, '\P{	GEORGIAN_sup}', "");
    Expect(0, 11568, '\P{^	GEORGIAN_sup}', "");
    Error('\p{	_IS_Georgian_sup:=}');
    Error('\P{	_IS_Georgian_sup:=}');
    Expect(1, 11567, '\p{isgeorgiansup}', "");
    Expect(0, 11567, '\p{^isgeorgiansup}', "");
    Expect(0, 11567, '\P{isgeorgiansup}', "");
    Expect(1, 11567, '\P{^isgeorgiansup}', "");
    Expect(0, 11568, '\p{isgeorgiansup}', "");
    Expect(1, 11568, '\p{^isgeorgiansup}', "");
    Expect(1, 11568, '\P{isgeorgiansup}', "");
    Expect(0, 11568, '\P{^isgeorgiansup}', "");
    Expect(1, 11567, '\p{	_IS_georgian_Sup}', "");
    Expect(0, 11567, '\p{^	_IS_georgian_Sup}', "");
    Expect(0, 11567, '\P{	_IS_georgian_Sup}', "");
    Expect(1, 11567, '\P{^	_IS_georgian_Sup}', "");
    Expect(0, 11568, '\p{	_IS_georgian_Sup}', "");
    Expect(1, 11568, '\p{^	_IS_georgian_Sup}', "");
    Expect(1, 11568, '\P{	_IS_georgian_Sup}', "");
    Expect(0, 11568, '\P{^	_IS_georgian_Sup}', "");
    Error('\p{/a/  In_Georgian_sup}');
    Error('\P{/a/  In_Georgian_sup}');
    Expect(1, 11567, '\p{ingeorgiansup}', "");
    Expect(0, 11567, '\p{^ingeorgiansup}', "");
    Expect(0, 11567, '\P{ingeorgiansup}', "");
    Expect(1, 11567, '\P{^ingeorgiansup}', "");
    Expect(0, 11568, '\p{ingeorgiansup}', "");
    Expect(1, 11568, '\p{^ingeorgiansup}', "");
    Expect(1, 11568, '\P{ingeorgiansup}', "");
    Expect(0, 11568, '\P{^ingeorgiansup}', "");
    Expect(1, 11567, '\p{ 	In_GEORGIAN_sup}', "");
    Expect(0, 11567, '\p{^ 	In_GEORGIAN_sup}', "");
    Expect(0, 11567, '\P{ 	In_GEORGIAN_sup}', "");
    Expect(1, 11567, '\P{^ 	In_GEORGIAN_sup}', "");
    Expect(0, 11568, '\p{ 	In_GEORGIAN_sup}', "");
    Expect(1, 11568, '\p{^ 	In_GEORGIAN_sup}', "");
    Expect(1, 11568, '\P{ 	In_GEORGIAN_sup}', "");
    Expect(0, 11568, '\P{^ 	In_GEORGIAN_sup}', "");
    Error('\p{/a/	glagolitic}');
    Error('\P{/a/	glagolitic}');
    Expect(1, 122922, '\p{glagolitic}', "");
    Expect(0, 122922, '\p{^glagolitic}', "");
    Expect(0, 122922, '\P{glagolitic}', "");
    Expect(1, 122922, '\P{^glagolitic}', "");
    Expect(0, 122923, '\p{glagolitic}', "");
    Expect(1, 122923, '\p{^glagolitic}', "");
    Expect(1, 122923, '\P{glagolitic}', "");
    Expect(0, 122923, '\P{^glagolitic}', "");
    Expect(1, 122922, '\p{	 glagolitic}', "");
    Expect(0, 122922, '\p{^	 glagolitic}', "");
    Expect(0, 122922, '\P{	 glagolitic}', "");
    Expect(1, 122922, '\P{^	 glagolitic}', "");
    Expect(0, 122923, '\p{	 glagolitic}', "");
    Expect(1, 122923, '\p{^	 glagolitic}', "");
    Expect(1, 122923, '\P{	 glagolitic}', "");
    Expect(0, 122923, '\P{^	 glagolitic}', "");
    Error('\p{  Is_Glagolitic:=}');
    Error('\P{  Is_Glagolitic:=}');
    Expect(1, 122922, '\p{isglagolitic}', "");
    Expect(0, 122922, '\p{^isglagolitic}', "");
    Expect(0, 122922, '\P{isglagolitic}', "");
    Expect(1, 122922, '\P{^isglagolitic}', "");
    Expect(0, 122923, '\p{isglagolitic}', "");
    Expect(1, 122923, '\p{^isglagolitic}', "");
    Expect(1, 122923, '\P{isglagolitic}', "");
    Expect(0, 122923, '\P{^isglagolitic}', "");
    Expect(1, 122922, '\p{ _Is_GLAGOLITIC}', "");
    Expect(0, 122922, '\p{^ _Is_GLAGOLITIC}', "");
    Expect(0, 122922, '\P{ _Is_GLAGOLITIC}', "");
    Expect(1, 122922, '\P{^ _Is_GLAGOLITIC}', "");
    Expect(0, 122923, '\p{ _Is_GLAGOLITIC}', "");
    Expect(1, 122923, '\p{^ _Is_GLAGOLITIC}', "");
    Expect(1, 122923, '\P{ _Is_GLAGOLITIC}', "");
    Expect(0, 122923, '\P{^ _Is_GLAGOLITIC}', "");
    Error('\p{:= Glag}');
    Error('\P{:= Glag}');
    Expect(1, 122922, '\p{glag}', "");
    Expect(0, 122922, '\p{^glag}', "");
    Expect(0, 122922, '\P{glag}', "");
    Expect(1, 122922, '\P{^glag}', "");
    Expect(0, 122923, '\p{glag}', "");
    Expect(1, 122923, '\p{^glag}', "");
    Expect(1, 122923, '\P{glag}', "");
    Expect(0, 122923, '\P{^glag}', "");
    Expect(1, 122922, '\p{_GLAG}', "");
    Expect(0, 122922, '\p{^_GLAG}', "");
    Expect(0, 122922, '\P{_GLAG}', "");
    Expect(1, 122922, '\P{^_GLAG}', "");
    Expect(0, 122923, '\p{_GLAG}', "");
    Expect(1, 122923, '\p{^_GLAG}', "");
    Expect(1, 122923, '\P{_GLAG}', "");
    Expect(0, 122923, '\P{^_GLAG}', "");
    Error('\p{_IS_Glag:=}');
    Error('\P{_IS_Glag:=}');
    Expect(1, 122922, '\p{isglag}', "");
    Expect(0, 122922, '\p{^isglag}', "");
    Expect(0, 122922, '\P{isglag}', "");
    Expect(1, 122922, '\P{^isglag}', "");
    Expect(0, 122923, '\p{isglag}', "");
    Expect(1, 122923, '\p{^isglag}', "");
    Expect(1, 122923, '\P{isglag}', "");
    Expect(0, 122923, '\P{^isglag}', "");
    Expect(1, 122922, '\p{ Is_glag}', "");
    Expect(0, 122922, '\p{^ Is_glag}', "");
    Expect(0, 122922, '\P{ Is_glag}', "");
    Expect(1, 122922, '\P{^ Is_glag}', "");
    Expect(0, 122923, '\p{ Is_glag}', "");
    Expect(1, 122923, '\p{^ Is_glag}', "");
    Expect(1, 122923, '\P{ Is_glag}', "");
    Expect(0, 122923, '\P{^ Is_glag}', "");
    Error('\p{/a/  glagolitic_supplement}');
    Error('\P{/a/  glagolitic_supplement}');
    Expect(1, 122927, '\p{glagoliticsupplement}', "");
    Expect(0, 122927, '\p{^glagoliticsupplement}', "");
    Expect(0, 122927, '\P{glagoliticsupplement}', "");
    Expect(1, 122927, '\P{^glagoliticsupplement}', "");
    Expect(0, 122928, '\p{glagoliticsupplement}', "");
    Expect(1, 122928, '\p{^glagoliticsupplement}', "");
    Expect(1, 122928, '\P{glagoliticsupplement}', "");
    Expect(0, 122928, '\P{^glagoliticsupplement}', "");
    Expect(1, 122927, '\p{glagolitic_SUPPLEMENT}', "");
    Expect(0, 122927, '\p{^glagolitic_SUPPLEMENT}', "");
    Expect(0, 122927, '\P{glagolitic_SUPPLEMENT}', "");
    Expect(1, 122927, '\P{^glagolitic_SUPPLEMENT}', "");
    Expect(0, 122928, '\p{glagolitic_SUPPLEMENT}', "");
    Expect(1, 122928, '\p{^glagolitic_SUPPLEMENT}', "");
    Expect(1, 122928, '\P{glagolitic_SUPPLEMENT}', "");
    Expect(0, 122928, '\P{^glagolitic_SUPPLEMENT}', "");
    Error('\p{/a/-	Is_Glagolitic_supplement}');
    Error('\P{/a/-	Is_Glagolitic_supplement}');
    Expect(1, 122927, '\p{isglagoliticsupplement}', "");
    Expect(0, 122927, '\p{^isglagoliticsupplement}', "");
    Expect(0, 122927, '\P{isglagoliticsupplement}', "");
    Expect(1, 122927, '\P{^isglagoliticsupplement}', "");
    Expect(0, 122928, '\p{isglagoliticsupplement}', "");
    Expect(1, 122928, '\p{^isglagoliticsupplement}', "");
    Expect(1, 122928, '\P{isglagoliticsupplement}', "");
    Expect(0, 122928, '\P{^isglagoliticsupplement}', "");
    Expect(1, 122927, '\p{_ Is_glagolitic_SUPPLEMENT}', "");
    Expect(0, 122927, '\p{^_ Is_glagolitic_SUPPLEMENT}', "");
    Expect(0, 122927, '\P{_ Is_glagolitic_SUPPLEMENT}', "");
    Expect(1, 122927, '\P{^_ Is_glagolitic_SUPPLEMENT}', "");
    Expect(0, 122928, '\p{_ Is_glagolitic_SUPPLEMENT}', "");
    Expect(1, 122928, '\p{^_ Is_glagolitic_SUPPLEMENT}', "");
    Expect(1, 122928, '\P{_ Is_glagolitic_SUPPLEMENT}', "");
    Expect(0, 122928, '\P{^_ Is_glagolitic_SUPPLEMENT}', "");
    Error('\p{/a/IN_Glagolitic_Supplement}');
    Error('\P{/a/IN_Glagolitic_Supplement}');
    Expect(1, 122927, '\p{inglagoliticsupplement}', "");
    Expect(0, 122927, '\p{^inglagoliticsupplement}', "");
    Expect(0, 122927, '\P{inglagoliticsupplement}', "");
    Expect(1, 122927, '\P{^inglagoliticsupplement}', "");
    Expect(0, 122928, '\p{inglagoliticsupplement}', "");
    Expect(1, 122928, '\p{^inglagoliticsupplement}', "");
    Expect(1, 122928, '\P{inglagoliticsupplement}', "");
    Expect(0, 122928, '\P{^inglagoliticsupplement}', "");
    Expect(1, 122927, '\p{		In_Glagolitic_SUPPLEMENT}', "");
    Expect(0, 122927, '\p{^		In_Glagolitic_SUPPLEMENT}', "");
    Expect(0, 122927, '\P{		In_Glagolitic_SUPPLEMENT}', "");
    Expect(1, 122927, '\P{^		In_Glagolitic_SUPPLEMENT}', "");
    Expect(0, 122928, '\p{		In_Glagolitic_SUPPLEMENT}', "");
    Expect(1, 122928, '\p{^		In_Glagolitic_SUPPLEMENT}', "");
    Expect(1, 122928, '\P{		In_Glagolitic_SUPPLEMENT}', "");
    Expect(0, 122928, '\P{^		In_Glagolitic_SUPPLEMENT}', "");
    Error('\p{:=glagolitic_SUP}');
    Error('\P{:=glagolitic_SUP}');
    Expect(1, 122927, '\p{glagoliticsup}', "");
    Expect(0, 122927, '\p{^glagoliticsup}', "");
    Expect(0, 122927, '\P{glagoliticsup}', "");
    Expect(1, 122927, '\P{^glagoliticsup}', "");
    Expect(0, 122928, '\p{glagoliticsup}', "");
    Expect(1, 122928, '\p{^glagoliticsup}', "");
    Expect(1, 122928, '\P{glagoliticsup}', "");
    Expect(0, 122928, '\P{^glagoliticsup}', "");
    Expect(1, 122927, '\p{ _Glagolitic_Sup}', "");
    Expect(0, 122927, '\p{^ _Glagolitic_Sup}', "");
    Expect(0, 122927, '\P{ _Glagolitic_Sup}', "");
    Expect(1, 122927, '\P{^ _Glagolitic_Sup}', "");
    Expect(0, 122928, '\p{ _Glagolitic_Sup}', "");
    Expect(1, 122928, '\p{^ _Glagolitic_Sup}', "");
    Expect(1, 122928, '\P{ _Glagolitic_Sup}', "");
    Expect(0, 122928, '\P{^ _Glagolitic_Sup}', "");
    Error('\p{_Is_GLAGOLITIC_Sup/a/}');
    Error('\P{_Is_GLAGOLITIC_Sup/a/}');
    Expect(1, 122927, '\p{isglagoliticsup}', "");
    Expect(0, 122927, '\p{^isglagoliticsup}', "");
    Expect(0, 122927, '\P{isglagoliticsup}', "");
    Expect(1, 122927, '\P{^isglagoliticsup}', "");
    Expect(0, 122928, '\p{isglagoliticsup}', "");
    Expect(1, 122928, '\p{^isglagoliticsup}', "");
    Expect(1, 122928, '\P{isglagoliticsup}', "");
    Expect(0, 122928, '\P{^isglagoliticsup}', "");
    Expect(1, 122927, '\p{	Is_Glagolitic_sup}', "");
    Expect(0, 122927, '\p{^	Is_Glagolitic_sup}', "");
    Expect(0, 122927, '\P{	Is_Glagolitic_sup}', "");
    Expect(1, 122927, '\P{^	Is_Glagolitic_sup}', "");
    Expect(0, 122928, '\p{	Is_Glagolitic_sup}', "");
    Expect(1, 122928, '\p{^	Is_Glagolitic_sup}', "");
    Expect(1, 122928, '\P{	Is_Glagolitic_sup}', "");
    Expect(0, 122928, '\P{^	Is_Glagolitic_sup}', "");
    Error('\p{ /a/In_GLAGOLITIC_Sup}');
    Error('\P{ /a/In_GLAGOLITIC_Sup}');
    Expect(1, 122927, '\p{inglagoliticsup}', "");
    Expect(0, 122927, '\p{^inglagoliticsup}', "");
    Expect(0, 122927, '\P{inglagoliticsup}', "");
    Expect(1, 122927, '\P{^inglagoliticsup}', "");
    Expect(0, 122928, '\p{inglagoliticsup}', "");
    Expect(1, 122928, '\p{^inglagoliticsup}', "");
    Expect(1, 122928, '\P{inglagoliticsup}', "");
    Expect(0, 122928, '\P{^inglagoliticsup}', "");
    Expect(1, 122927, '\p{ _IN_Glagolitic_Sup}', "");
    Expect(0, 122927, '\p{^ _IN_Glagolitic_Sup}', "");
    Expect(0, 122927, '\P{ _IN_Glagolitic_Sup}', "");
    Expect(1, 122927, '\P{^ _IN_Glagolitic_Sup}', "");
    Expect(0, 122928, '\p{ _IN_Glagolitic_Sup}', "");
    Expect(1, 122928, '\p{^ _IN_Glagolitic_Sup}', "");
    Expect(1, 122928, '\P{ _IN_Glagolitic_Sup}', "");
    Expect(0, 122928, '\P{^ _IN_Glagolitic_Sup}', "");
    Error('\p{__gothic/a/}');
    Error('\P{__gothic/a/}');
    Expect(1, 66378, '\p{gothic}', "");
    Expect(0, 66378, '\p{^gothic}', "");
    Expect(0, 66378, '\P{gothic}', "");
    Expect(1, 66378, '\P{^gothic}', "");
    Expect(0, 66379, '\p{gothic}', "");
    Expect(1, 66379, '\p{^gothic}', "");
    Expect(1, 66379, '\P{gothic}', "");
    Expect(0, 66379, '\P{^gothic}', "");
    Expect(1, 66378, '\p{ 	GOTHIC}', "");
    Expect(0, 66378, '\p{^ 	GOTHIC}', "");
    Expect(0, 66378, '\P{ 	GOTHIC}', "");
    Expect(1, 66378, '\P{^ 	GOTHIC}', "");
    Expect(0, 66379, '\p{ 	GOTHIC}', "");
    Expect(1, 66379, '\p{^ 	GOTHIC}', "");
    Expect(1, 66379, '\P{ 	GOTHIC}', "");
    Expect(0, 66379, '\P{^ 	GOTHIC}', "");
    Error('\p{-Is_GOTHIC/a/}');
    Error('\P{-Is_GOTHIC/a/}');
    Expect(1, 66378, '\p{isgothic}', "");
    Expect(0, 66378, '\p{^isgothic}', "");
    Expect(0, 66378, '\P{isgothic}', "");
    Expect(1, 66378, '\P{^isgothic}', "");
    Expect(0, 66379, '\p{isgothic}', "");
    Expect(1, 66379, '\p{^isgothic}', "");
    Expect(1, 66379, '\P{isgothic}', "");
    Expect(0, 66379, '\P{^isgothic}', "");
    Expect(1, 66378, '\p{ _is_Gothic}', "");
    Expect(0, 66378, '\p{^ _is_Gothic}', "");
    Expect(0, 66378, '\P{ _is_Gothic}', "");
    Expect(1, 66378, '\P{^ _is_Gothic}', "");
    Expect(0, 66379, '\p{ _is_Gothic}', "");
    Expect(1, 66379, '\p{^ _is_Gothic}', "");
    Expect(1, 66379, '\P{ _is_Gothic}', "");
    Expect(0, 66379, '\P{^ _is_Gothic}', "");
    Error('\p{		GOTH:=}');
    Error('\P{		GOTH:=}');
    Expect(1, 66378, '\p{goth}', "");
    Expect(0, 66378, '\p{^goth}', "");
    Expect(0, 66378, '\P{goth}', "");
    Expect(1, 66378, '\P{^goth}', "");
    Expect(0, 66379, '\p{goth}', "");
    Expect(1, 66379, '\p{^goth}', "");
    Expect(1, 66379, '\P{goth}', "");
    Expect(0, 66379, '\P{^goth}', "");
    Expect(1, 66378, '\p{ _Goth}', "");
    Expect(0, 66378, '\p{^ _Goth}', "");
    Expect(0, 66378, '\P{ _Goth}', "");
    Expect(1, 66378, '\P{^ _Goth}', "");
    Expect(0, 66379, '\p{ _Goth}', "");
    Expect(1, 66379, '\p{^ _Goth}', "");
    Expect(1, 66379, '\P{ _Goth}', "");
    Expect(0, 66379, '\P{^ _Goth}', "");
    Error('\p{	Is_GOTH:=}');
    Error('\P{	Is_GOTH:=}');
    Expect(1, 66378, '\p{isgoth}', "");
    Expect(0, 66378, '\p{^isgoth}', "");
    Expect(0, 66378, '\P{isgoth}', "");
    Expect(1, 66378, '\P{^isgoth}', "");
    Expect(0, 66379, '\p{isgoth}', "");
    Expect(1, 66379, '\p{^isgoth}', "");
    Expect(1, 66379, '\P{isgoth}', "");
    Expect(0, 66379, '\P{^isgoth}', "");
    Expect(1, 66378, '\p{Is_Goth}', "");
    Expect(0, 66378, '\p{^Is_Goth}', "");
    Expect(0, 66378, '\P{Is_Goth}', "");
    Expect(1, 66378, '\P{^Is_Goth}', "");
    Expect(0, 66379, '\p{Is_Goth}', "");
    Expect(1, 66379, '\p{^Is_Goth}', "");
    Expect(1, 66379, '\P{Is_Goth}', "");
    Expect(0, 66379, '\P{^Is_Goth}', "");
    Error('\p{ GRANTHA/a/}');
    Error('\P{ GRANTHA/a/}');
    Expect(1, 73683, '\p{grantha}', "");
    Expect(0, 73683, '\p{^grantha}', "");
    Expect(0, 73683, '\P{grantha}', "");
    Expect(1, 73683, '\P{^grantha}', "");
    Expect(0, 73684, '\p{grantha}', "");
    Expect(1, 73684, '\p{^grantha}', "");
    Expect(1, 73684, '\P{grantha}', "");
    Expect(0, 73684, '\P{^grantha}', "");
    Expect(1, 73683, '\p{--GRANTHA}', "");
    Expect(0, 73683, '\p{^--GRANTHA}', "");
    Expect(0, 73683, '\P{--GRANTHA}', "");
    Expect(1, 73683, '\P{^--GRANTHA}', "");
    Expect(0, 73684, '\p{--GRANTHA}', "");
    Expect(1, 73684, '\p{^--GRANTHA}', "");
    Expect(1, 73684, '\P{--GRANTHA}', "");
    Expect(0, 73684, '\P{^--GRANTHA}', "");
    Error('\p{:=-	Is_Grantha}');
    Error('\P{:=-	Is_Grantha}');
    Expect(1, 73683, '\p{isgrantha}', "");
    Expect(0, 73683, '\p{^isgrantha}', "");
    Expect(0, 73683, '\P{isgrantha}', "");
    Expect(1, 73683, '\P{^isgrantha}', "");
    Expect(0, 73684, '\p{isgrantha}', "");
    Expect(1, 73684, '\p{^isgrantha}', "");
    Expect(1, 73684, '\P{isgrantha}', "");
    Expect(0, 73684, '\P{^isgrantha}', "");
    Expect(1, 73683, '\p{__Is_grantha}', "");
    Expect(0, 73683, '\p{^__Is_grantha}', "");
    Expect(0, 73683, '\P{__Is_grantha}', "");
    Expect(1, 73683, '\P{^__Is_grantha}', "");
    Expect(0, 73684, '\p{__Is_grantha}', "");
    Expect(1, 73684, '\p{^__Is_grantha}', "");
    Expect(1, 73684, '\P{__Is_grantha}', "");
    Expect(0, 73684, '\P{^__Is_grantha}', "");
    Error('\p{-Gran/a/}');
    Error('\P{-Gran/a/}');
    Expect(1, 73683, '\p{gran}', "");
    Expect(0, 73683, '\p{^gran}', "");
    Expect(0, 73683, '\P{gran}', "");
    Expect(1, 73683, '\P{^gran}', "");
    Expect(0, 73684, '\p{gran}', "");
    Expect(1, 73684, '\p{^gran}', "");
    Expect(1, 73684, '\P{gran}', "");
    Expect(0, 73684, '\P{^gran}', "");
    Expect(1, 73683, '\p{ -gran}', "");
    Expect(0, 73683, '\p{^ -gran}', "");
    Expect(0, 73683, '\P{ -gran}', "");
    Expect(1, 73683, '\P{^ -gran}', "");
    Expect(0, 73684, '\p{ -gran}', "");
    Expect(1, 73684, '\p{^ -gran}', "");
    Expect(1, 73684, '\P{ -gran}', "");
    Expect(0, 73684, '\P{^ -gran}', "");
    Error('\p{	:=is_GRAN}');
    Error('\P{	:=is_GRAN}');
    Expect(1, 73683, '\p{isgran}', "");
    Expect(0, 73683, '\p{^isgran}', "");
    Expect(0, 73683, '\P{isgran}', "");
    Expect(1, 73683, '\P{^isgran}', "");
    Expect(0, 73684, '\p{isgran}', "");
    Expect(1, 73684, '\p{^isgran}', "");
    Expect(1, 73684, '\P{isgran}', "");
    Expect(0, 73684, '\P{^isgran}', "");
    Expect(1, 73683, '\p{-IS_Gran}', "");
    Expect(0, 73683, '\p{^-IS_Gran}', "");
    Expect(0, 73683, '\P{-IS_Gran}', "");
    Expect(1, 73683, '\P{^-IS_Gran}', "");
    Expect(0, 73684, '\p{-IS_Gran}', "");
    Expect(1, 73684, '\p{^-IS_Gran}', "");
    Expect(1, 73684, '\P{-IS_Gran}', "");
    Expect(0, 73684, '\P{^-IS_Gran}', "");
    Error('\p{ :=XPosixGraph}');
    Error('\P{ :=XPosixGraph}');
    Expect(1, 1114109, '\p{xposixgraph}', "");
    Expect(0, 1114109, '\p{^xposixgraph}', "");
    Expect(0, 1114109, '\P{xposixgraph}', "");
    Expect(1, 1114109, '\P{^xposixgraph}', "");
    Expect(0, 918000, '\p{xposixgraph}', "");
    Expect(1, 918000, '\p{^xposixgraph}', "");
    Expect(1, 918000, '\P{xposixgraph}', "");
    Expect(0, 918000, '\P{^xposixgraph}', "");
    Expect(1, 1114109, '\p{-_xposixgraph}', "");
    Expect(0, 1114109, '\p{^-_xposixgraph}', "");
    Expect(0, 1114109, '\P{-_xposixgraph}', "");
    Expect(1, 1114109, '\P{^-_xposixgraph}', "");
    Expect(0, 918000, '\p{-_xposixgraph}', "");
    Expect(1, 918000, '\p{^-_xposixgraph}', "");
    Expect(1, 918000, '\P{-_xposixgraph}', "");
    Expect(0, 918000, '\P{^-_xposixgraph}', "");
    Error('\p{-/a/GRAPH}');
    Error('\P{-/a/GRAPH}');
    Expect(1, 1114109, '\p{graph}', "");
    Expect(0, 1114109, '\p{^graph}', "");
    Expect(0, 1114109, '\P{graph}', "");
    Expect(1, 1114109, '\P{^graph}', "");
    Expect(0, 918000, '\p{graph}', "");
    Expect(1, 918000, '\p{^graph}', "");
    Expect(1, 918000, '\P{graph}', "");
    Expect(0, 918000, '\P{^graph}', "");
    Expect(1, 1114109, '\p{		GRAPH}', "");
    Expect(0, 1114109, '\p{^		GRAPH}', "");
    Expect(0, 1114109, '\P{		GRAPH}', "");
    Expect(1, 1114109, '\P{^		GRAPH}', "");
    Expect(0, 918000, '\p{		GRAPH}', "");
    Expect(1, 918000, '\p{^		GRAPH}', "");
    Expect(1, 918000, '\P{		GRAPH}', "");
    Expect(0, 918000, '\P{^		GRAPH}', "");
    Error('\p{/a/  IS_XPOSIXGRAPH}');
    Error('\P{/a/  IS_XPOSIXGRAPH}');
    Expect(1, 1114109, '\p{isxposixgraph}', "");
    Expect(0, 1114109, '\p{^isxposixgraph}', "");
    Expect(0, 1114109, '\P{isxposixgraph}', "");
    Expect(1, 1114109, '\P{^isxposixgraph}', "");
    Expect(0, 918000, '\p{isxposixgraph}', "");
    Expect(1, 918000, '\p{^isxposixgraph}', "");
    Expect(1, 918000, '\P{isxposixgraph}', "");
    Expect(0, 918000, '\P{^isxposixgraph}', "");
    Expect(1, 1114109, '\p{	 Is_XPOSIXGRAPH}', "");
    Expect(0, 1114109, '\p{^	 Is_XPOSIXGRAPH}', "");
    Expect(0, 1114109, '\P{	 Is_XPOSIXGRAPH}', "");
    Expect(1, 1114109, '\P{^	 Is_XPOSIXGRAPH}', "");
    Expect(0, 918000, '\p{	 Is_XPOSIXGRAPH}', "");
    Expect(1, 918000, '\p{^	 Is_XPOSIXGRAPH}', "");
    Expect(1, 918000, '\P{	 Is_XPOSIXGRAPH}', "");
    Expect(0, 918000, '\P{^	 Is_XPOSIXGRAPH}', "");
    Error('\p{:=--Is_graph}');
    Error('\P{:=--Is_graph}');
    Expect(1, 1114109, '\p{isgraph}', "");
    Expect(0, 1114109, '\p{^isgraph}', "");
    Expect(0, 1114109, '\P{isgraph}', "");
    Expect(1, 1114109, '\P{^isgraph}', "");
    Expect(0, 918000, '\p{isgraph}', "");
    Expect(1, 918000, '\p{^isgraph}', "");
    Expect(1, 918000, '\P{isgraph}', "");
    Expect(0, 918000, '\P{^isgraph}', "");
    Expect(1, 1114109, '\p{-IS_GRAPH}', "");
    Expect(0, 1114109, '\p{^-IS_GRAPH}', "");
    Expect(0, 1114109, '\P{-IS_GRAPH}', "");
    Expect(1, 1114109, '\P{^-IS_GRAPH}', "");
    Expect(0, 918000, '\p{-IS_GRAPH}', "");
    Expect(1, 918000, '\p{^-IS_GRAPH}', "");
    Expect(1, 918000, '\P{-IS_GRAPH}', "");
    Expect(0, 918000, '\P{^-IS_GRAPH}', "");
    Error('\p{/a/grapheme_base}');
    Error('\P{/a/grapheme_base}');
    Expect(1, 195101, '\p{graphemebase}', "");
    Expect(0, 195101, '\p{^graphemebase}', "");
    Expect(0, 195101, '\P{graphemebase}', "");
    Expect(1, 195101, '\P{^graphemebase}', "");
    Expect(0, 195102, '\p{graphemebase}', "");
    Expect(1, 195102, '\p{^graphemebase}', "");
    Expect(1, 195102, '\P{graphemebase}', "");
    Expect(0, 195102, '\P{^graphemebase}', "");
    Expect(1, 195101, '\p{	grapheme_BASE}', "");
    Expect(0, 195101, '\p{^	grapheme_BASE}', "");
    Expect(0, 195101, '\P{	grapheme_BASE}', "");
    Expect(1, 195101, '\P{^	grapheme_BASE}', "");
    Expect(0, 195102, '\p{	grapheme_BASE}', "");
    Expect(1, 195102, '\p{^	grapheme_BASE}', "");
    Expect(1, 195102, '\P{	grapheme_BASE}', "");
    Expect(0, 195102, '\P{^	grapheme_BASE}', "");
    Error('\p{		Is_GRAPHEME_BASE/a/}');
    Error('\P{		Is_GRAPHEME_BASE/a/}');
    Expect(1, 195101, '\p{isgraphemebase}', "");
    Expect(0, 195101, '\p{^isgraphemebase}', "");
    Expect(0, 195101, '\P{isgraphemebase}', "");
    Expect(1, 195101, '\P{^isgraphemebase}', "");
    Expect(0, 195102, '\p{isgraphemebase}', "");
    Expect(1, 195102, '\p{^isgraphemebase}', "");
    Expect(1, 195102, '\P{isgraphemebase}', "");
    Expect(0, 195102, '\P{^isgraphemebase}', "");
    Expect(1, 195101, '\p{--IS_GRAPHEME_BASE}', "");
    Expect(0, 195101, '\p{^--IS_GRAPHEME_BASE}', "");
    Expect(0, 195101, '\P{--IS_GRAPHEME_BASE}', "");
    Expect(1, 195101, '\P{^--IS_GRAPHEME_BASE}', "");
    Expect(0, 195102, '\p{--IS_GRAPHEME_BASE}', "");
    Expect(1, 195102, '\p{^--IS_GRAPHEME_BASE}', "");
    Expect(1, 195102, '\P{--IS_GRAPHEME_BASE}', "");
    Expect(0, 195102, '\P{^--IS_GRAPHEME_BASE}', "");
    Error('\p{/a/ -Gr_base}');
    Error('\P{/a/ -Gr_base}');
    Expect(1, 195101, '\p{grbase}', "");
    Expect(0, 195101, '\p{^grbase}', "");
    Expect(0, 195101, '\P{grbase}', "");
    Expect(1, 195101, '\P{^grbase}', "");
    Expect(0, 195102, '\p{grbase}', "");
    Expect(1, 195102, '\p{^grbase}', "");
    Expect(1, 195102, '\P{grbase}', "");
    Expect(0, 195102, '\P{^grbase}', "");
    Expect(1, 195101, '\p{ 	Gr_base}', "");
    Expect(0, 195101, '\p{^ 	Gr_base}', "");
    Expect(0, 195101, '\P{ 	Gr_base}', "");
    Expect(1, 195101, '\P{^ 	Gr_base}', "");
    Expect(0, 195102, '\p{ 	Gr_base}', "");
    Expect(1, 195102, '\p{^ 	Gr_base}', "");
    Expect(1, 195102, '\P{ 	Gr_base}', "");
    Expect(0, 195102, '\P{^ 	Gr_base}', "");
    Error('\p{  Is_Gr_Base/a/}');
    Error('\P{  Is_Gr_Base/a/}');
    Expect(1, 195101, '\p{isgrbase}', "");
    Expect(0, 195101, '\p{^isgrbase}', "");
    Expect(0, 195101, '\P{isgrbase}', "");
    Expect(1, 195101, '\P{^isgrbase}', "");
    Expect(0, 195102, '\p{isgrbase}', "");
    Expect(1, 195102, '\p{^isgrbase}', "");
    Expect(1, 195102, '\P{isgrbase}', "");
    Expect(0, 195102, '\P{^isgrbase}', "");
    Expect(1, 195101, '\p{--Is_Gr_Base}', "");
    Expect(0, 195101, '\p{^--Is_Gr_Base}', "");
    Expect(0, 195101, '\P{--Is_Gr_Base}', "");
    Expect(1, 195101, '\P{^--Is_Gr_Base}', "");
    Expect(0, 195102, '\p{--Is_Gr_Base}', "");
    Expect(1, 195102, '\p{^--Is_Gr_Base}', "");
    Expect(1, 195102, '\P{--Is_Gr_Base}', "");
    Expect(0, 195102, '\P{^--Is_Gr_Base}', "");
    Error('\p{ 	grapheme_Extend/a/}');
    Error('\P{ 	grapheme_Extend/a/}');
    Expect(1, 917999, '\p{graphemeextend}', "");
    Expect(0, 917999, '\p{^graphemeextend}', "");
    Expect(0, 917999, '\P{graphemeextend}', "");
    Expect(1, 917999, '\P{^graphemeextend}', "");
    Expect(0, 918000, '\p{graphemeextend}', "");
    Expect(1, 918000, '\p{^graphemeextend}', "");
    Expect(1, 918000, '\P{graphemeextend}', "");
    Expect(0, 918000, '\P{^graphemeextend}', "");
    Expect(1, 917999, '\p{ grapheme_Extend}', "");
    Expect(0, 917999, '\p{^ grapheme_Extend}', "");
    Expect(0, 917999, '\P{ grapheme_Extend}', "");
    Expect(1, 917999, '\P{^ grapheme_Extend}', "");
    Expect(0, 918000, '\p{ grapheme_Extend}', "");
    Expect(1, 918000, '\p{^ grapheme_Extend}', "");
    Expect(1, 918000, '\P{ grapheme_Extend}', "");
    Expect(0, 918000, '\P{^ grapheme_Extend}', "");
    Error('\p{:=	IS_GRAPHEME_EXTEND}');
    Error('\P{:=	IS_GRAPHEME_EXTEND}');
    Expect(1, 917999, '\p{isgraphemeextend}', "");
    Expect(0, 917999, '\p{^isgraphemeextend}', "");
    Expect(0, 917999, '\P{isgraphemeextend}', "");
    Expect(1, 917999, '\P{^isgraphemeextend}', "");
    Expect(0, 918000, '\p{isgraphemeextend}', "");
    Expect(1, 918000, '\p{^isgraphemeextend}', "");
    Expect(1, 918000, '\P{isgraphemeextend}', "");
    Expect(0, 918000, '\P{^isgraphemeextend}', "");
    Expect(1, 917999, '\p{ 	Is_GRAPHEME_Extend}', "");
    Expect(0, 917999, '\p{^ 	Is_GRAPHEME_Extend}', "");
    Expect(0, 917999, '\P{ 	Is_GRAPHEME_Extend}', "");
    Expect(1, 917999, '\P{^ 	Is_GRAPHEME_Extend}', "");
    Expect(0, 918000, '\p{ 	Is_GRAPHEME_Extend}', "");
    Expect(1, 918000, '\p{^ 	Is_GRAPHEME_Extend}', "");
    Expect(1, 918000, '\P{ 	Is_GRAPHEME_Extend}', "");
    Expect(0, 918000, '\P{^ 	Is_GRAPHEME_Extend}', "");
    Error('\p{/a/	gr_ext}');
    Error('\P{/a/	gr_ext}');
    Expect(1, 917999, '\p{grext}', "");
    Expect(0, 917999, '\p{^grext}', "");
    Expect(0, 917999, '\P{grext}', "");
    Expect(1, 917999, '\P{^grext}', "");
    Expect(0, 918000, '\p{grext}', "");
    Expect(1, 918000, '\p{^grext}', "");
    Expect(1, 918000, '\P{grext}', "");
    Expect(0, 918000, '\P{^grext}', "");
    Expect(1, 917999, '\p{_gr_Ext}', "");
    Expect(0, 917999, '\p{^_gr_Ext}', "");
    Expect(0, 917999, '\P{_gr_Ext}', "");
    Expect(1, 917999, '\P{^_gr_Ext}', "");
    Expect(0, 918000, '\p{_gr_Ext}', "");
    Expect(1, 918000, '\p{^_gr_Ext}', "");
    Expect(1, 918000, '\P{_gr_Ext}', "");
    Expect(0, 918000, '\P{^_gr_Ext}', "");
    Error('\p{	:=Is_Gr_ext}');
    Error('\P{	:=Is_Gr_ext}');
    Expect(1, 917999, '\p{isgrext}', "");
    Expect(0, 917999, '\p{^isgrext}', "");
    Expect(0, 917999, '\P{isgrext}', "");
    Expect(1, 917999, '\P{^isgrext}', "");
    Expect(0, 918000, '\p{isgrext}', "");
    Expect(1, 918000, '\p{^isgrext}', "");
    Expect(1, 918000, '\P{isgrext}', "");
    Expect(0, 918000, '\P{^isgrext}', "");
    Expect(1, 917999, '\p{ _Is_GR_Ext}', "");
    Expect(0, 917999, '\p{^ _Is_GR_Ext}', "");
    Expect(0, 917999, '\P{ _Is_GR_Ext}', "");
    Expect(1, 917999, '\P{^ _Is_GR_Ext}', "");
    Expect(0, 918000, '\p{ _Is_GR_Ext}', "");
    Expect(1, 918000, '\p{^ _Is_GR_Ext}', "");
    Expect(1, 918000, '\P{ _Is_GR_Ext}', "");
    Expect(0, 918000, '\P{^ _Is_GR_Ext}', "");
    Error('\p{Grapheme_Link}');
    Error('\P{Grapheme_Link}');
    Error('\p{Gr_Link}');
    Error('\P{Gr_Link}');
    Error('\p{ /a/greek}');
    Error('\P{ /a/greek}');
    Expect(1, 119365, '\p{greek}', "");
    Expect(0, 119365, '\p{^greek}', "");
    Expect(0, 119365, '\P{greek}', "");
    Expect(1, 119365, '\P{^greek}', "");
    Expect(0, 119366, '\p{greek}', "");
    Expect(1, 119366, '\p{^greek}', "");
    Expect(1, 119366, '\P{greek}', "");
    Expect(0, 119366, '\P{^greek}', "");
    Expect(1, 119365, '\p{	 Greek}', "");
    Expect(0, 119365, '\p{^	 Greek}', "");
    Expect(0, 119365, '\P{	 Greek}', "");
    Expect(1, 119365, '\P{^	 Greek}', "");
    Expect(0, 119366, '\p{	 Greek}', "");
    Expect(1, 119366, '\p{^	 Greek}', "");
    Expect(1, 119366, '\P{	 Greek}', "");
    Expect(0, 119366, '\P{^	 Greek}', "");
    Error('\p{:=__IS_Greek}');
    Error('\P{:=__IS_Greek}');
    Expect(1, 119365, '\p{isgreek}', "");
    Expect(0, 119365, '\p{^isgreek}', "");
    Expect(0, 119365, '\P{isgreek}', "");
    Expect(1, 119365, '\P{^isgreek}', "");
    Expect(0, 119366, '\p{isgreek}', "");
    Expect(1, 119366, '\p{^isgreek}', "");
    Expect(1, 119366, '\P{isgreek}', "");
    Expect(0, 119366, '\P{^isgreek}', "");
    Expect(1, 119365, '\p{	-IS_Greek}', "");
    Expect(0, 119365, '\p{^	-IS_Greek}', "");
    Expect(0, 119365, '\P{	-IS_Greek}', "");
    Expect(1, 119365, '\P{^	-IS_Greek}', "");
    Expect(0, 119366, '\p{	-IS_Greek}', "");
    Expect(1, 119366, '\p{^	-IS_Greek}', "");
    Expect(1, 119366, '\P{	-IS_Greek}', "");
    Expect(0, 119366, '\P{^	-IS_Greek}', "");
    Error('\p{	/a/Grek}');
    Error('\P{	/a/Grek}');
    Expect(1, 119365, '\p{grek}', "");
    Expect(0, 119365, '\p{^grek}', "");
    Expect(0, 119365, '\P{grek}', "");
    Expect(1, 119365, '\P{^grek}', "");
    Expect(0, 119366, '\p{grek}', "");
    Expect(1, 119366, '\p{^grek}', "");
    Expect(1, 119366, '\P{grek}', "");
    Expect(0, 119366, '\P{^grek}', "");
    Expect(1, 119365, '\p{-_GREK}', "");
    Expect(0, 119365, '\p{^-_GREK}', "");
    Expect(0, 119365, '\P{-_GREK}', "");
    Expect(1, 119365, '\P{^-_GREK}', "");
    Expect(0, 119366, '\p{-_GREK}', "");
    Expect(1, 119366, '\p{^-_GREK}', "");
    Expect(1, 119366, '\P{-_GREK}', "");
    Expect(0, 119366, '\P{^-_GREK}', "");
    Error('\p{-/a/Is_Grek}');
    Error('\P{-/a/Is_Grek}');
    Expect(1, 119365, '\p{isgrek}', "");
    Expect(0, 119365, '\p{^isgrek}', "");
    Expect(0, 119365, '\P{isgrek}', "");
    Expect(1, 119365, '\P{^isgrek}', "");
    Expect(0, 119366, '\p{isgrek}', "");
    Expect(1, 119366, '\p{^isgrek}', "");
    Expect(1, 119366, '\P{isgrek}', "");
    Expect(0, 119366, '\P{^isgrek}', "");
    Expect(1, 119365, '\p{ is_grek}', "");
    Expect(0, 119365, '\p{^ is_grek}', "");
    Expect(0, 119365, '\P{ is_grek}', "");
    Expect(1, 119365, '\P{^ is_grek}', "");
    Expect(0, 119366, '\p{ is_grek}', "");
    Expect(1, 119366, '\p{^ is_grek}', "");
    Expect(1, 119366, '\P{ is_grek}', "");
    Expect(0, 119366, '\P{^ is_grek}', "");
    Error('\p{ _GREEK_And_Coptic:=}');
    Error('\P{ _GREEK_And_Coptic:=}');
    Expect(1, 1023, '\p{greekandcoptic}', "");
    Expect(0, 1023, '\p{^greekandcoptic}', "");
    Expect(0, 1023, '\P{greekandcoptic}', "");
    Expect(1, 1023, '\P{^greekandcoptic}', "");
    Expect(0, 1024, '\p{greekandcoptic}', "");
    Expect(1, 1024, '\p{^greekandcoptic}', "");
    Expect(1, 1024, '\P{greekandcoptic}', "");
    Expect(0, 1024, '\P{^greekandcoptic}', "");
    Expect(1, 1023, '\p{ -greek_AND_coptic}', "");
    Expect(0, 1023, '\p{^ -greek_AND_coptic}', "");
    Expect(0, 1023, '\P{ -greek_AND_coptic}', "");
    Expect(1, 1023, '\P{^ -greek_AND_coptic}', "");
    Expect(0, 1024, '\p{ -greek_AND_coptic}', "");
    Expect(1, 1024, '\p{^ -greek_AND_coptic}', "");
    Expect(1, 1024, '\P{ -greek_AND_coptic}', "");
    Expect(0, 1024, '\P{^ -greek_AND_coptic}', "");
    Error('\p{__Is_greek_And_COPTIC/a/}');
    Error('\P{__Is_greek_And_COPTIC/a/}');
    Expect(1, 1023, '\p{isgreekandcoptic}', "");
    Expect(0, 1023, '\p{^isgreekandcoptic}', "");
    Expect(0, 1023, '\P{isgreekandcoptic}', "");
    Expect(1, 1023, '\P{^isgreekandcoptic}', "");
    Expect(0, 1024, '\p{isgreekandcoptic}', "");
    Expect(1, 1024, '\p{^isgreekandcoptic}', "");
    Expect(1, 1024, '\P{isgreekandcoptic}', "");
    Expect(0, 1024, '\P{^isgreekandcoptic}', "");
    Expect(1, 1023, '\p{ -Is_GREEK_and_COPTIC}', "");
    Expect(0, 1023, '\p{^ -Is_GREEK_and_COPTIC}', "");
    Expect(0, 1023, '\P{ -Is_GREEK_and_COPTIC}', "");
    Expect(1, 1023, '\P{^ -Is_GREEK_and_COPTIC}', "");
    Expect(0, 1024, '\p{ -Is_GREEK_and_COPTIC}', "");
    Expect(1, 1024, '\p{^ -Is_GREEK_and_COPTIC}', "");
    Expect(1, 1024, '\P{ -Is_GREEK_and_COPTIC}', "");
    Expect(0, 1024, '\P{^ -Is_GREEK_and_COPTIC}', "");
    Error('\p{_:=In_GREEK_And_Coptic}');
    Error('\P{_:=In_GREEK_And_Coptic}');
    Expect(1, 1023, '\p{ingreekandcoptic}', "");
    Expect(0, 1023, '\p{^ingreekandcoptic}', "");
    Expect(0, 1023, '\P{ingreekandcoptic}', "");
    Expect(1, 1023, '\P{^ingreekandcoptic}', "");
    Expect(0, 1024, '\p{ingreekandcoptic}', "");
    Expect(1, 1024, '\p{^ingreekandcoptic}', "");
    Expect(1, 1024, '\P{ingreekandcoptic}', "");
    Expect(0, 1024, '\P{^ingreekandcoptic}', "");
    Expect(1, 1023, '\p{	_In_GREEK_And_COPTIC}', "");
    Expect(0, 1023, '\p{^	_In_GREEK_And_COPTIC}', "");
    Expect(0, 1023, '\P{	_In_GREEK_And_COPTIC}', "");
    Expect(1, 1023, '\P{^	_In_GREEK_And_COPTIC}', "");
    Expect(0, 1024, '\p{	_In_GREEK_And_COPTIC}', "");
    Expect(1, 1024, '\p{^	_In_GREEK_And_COPTIC}', "");
    Expect(1, 1024, '\P{	_In_GREEK_And_COPTIC}', "");
    Expect(0, 1024, '\P{^	_In_GREEK_And_COPTIC}', "");
    Error('\p{_ In_Greek:=}');
    Error('\P{_ In_Greek:=}');
    Expect(1, 1023, '\p{ingreek}', "");
    Expect(0, 1023, '\p{^ingreek}', "");
    Expect(0, 1023, '\P{ingreek}', "");
    Expect(1, 1023, '\P{^ingreek}', "");
    Expect(0, 1024, '\p{ingreek}', "");
    Expect(1, 1024, '\p{^ingreek}', "");
    Expect(1, 1024, '\P{ingreek}', "");
    Expect(0, 1024, '\P{^ingreek}', "");
    Expect(1, 1023, '\p{	 In_greek}', "");
    Expect(0, 1023, '\p{^	 In_greek}', "");
    Expect(0, 1023, '\P{	 In_greek}', "");
    Expect(1, 1023, '\P{^	 In_greek}', "");
    Expect(0, 1024, '\p{	 In_greek}', "");
    Expect(1, 1024, '\p{^	 In_greek}', "");
    Expect(1, 1024, '\P{	 In_greek}', "");
    Expect(0, 1024, '\P{^	 In_greek}', "");
    Error('\p{:=greek_Extended}');
    Error('\P{:=greek_Extended}');
    Expect(1, 8191, '\p{greekextended}', "");
    Expect(0, 8191, '\p{^greekextended}', "");
    Expect(0, 8191, '\P{greekextended}', "");
    Expect(1, 8191, '\P{^greekextended}', "");
    Expect(0, 8192, '\p{greekextended}', "");
    Expect(1, 8192, '\p{^greekextended}', "");
    Expect(1, 8192, '\P{greekextended}', "");
    Expect(0, 8192, '\P{^greekextended}', "");
    Expect(1, 8191, '\p{	_Greek_EXTENDED}', "");
    Expect(0, 8191, '\p{^	_Greek_EXTENDED}', "");
    Expect(0, 8191, '\P{	_Greek_EXTENDED}', "");
    Expect(1, 8191, '\P{^	_Greek_EXTENDED}', "");
    Expect(0, 8192, '\p{	_Greek_EXTENDED}', "");
    Expect(1, 8192, '\p{^	_Greek_EXTENDED}', "");
    Expect(1, 8192, '\P{	_Greek_EXTENDED}', "");
    Expect(0, 8192, '\P{^	_Greek_EXTENDED}', "");
    Error('\p{/a/-Is_GREEK_extended}');
    Error('\P{/a/-Is_GREEK_extended}');
    Expect(1, 8191, '\p{isgreekextended}', "");
    Expect(0, 8191, '\p{^isgreekextended}', "");
    Expect(0, 8191, '\P{isgreekextended}', "");
    Expect(1, 8191, '\P{^isgreekextended}', "");
    Expect(0, 8192, '\p{isgreekextended}', "");
    Expect(1, 8192, '\p{^isgreekextended}', "");
    Expect(1, 8192, '\P{isgreekextended}', "");
    Expect(0, 8192, '\P{^isgreekextended}', "");
    Expect(1, 8191, '\p{-_is_Greek_Extended}', "");
    Expect(0, 8191, '\p{^-_is_Greek_Extended}', "");
    Expect(0, 8191, '\P{-_is_Greek_Extended}', "");
    Expect(1, 8191, '\P{^-_is_Greek_Extended}', "");
    Expect(0, 8192, '\p{-_is_Greek_Extended}', "");
    Expect(1, 8192, '\p{^-_is_Greek_Extended}', "");
    Expect(1, 8192, '\P{-_is_Greek_Extended}', "");
    Expect(0, 8192, '\P{^-_is_Greek_Extended}', "");
    Error('\p{_in_GREEK_Extended/a/}');
    Error('\P{_in_GREEK_Extended/a/}');
    Expect(1, 8191, '\p{ingreekextended}', "");
    Expect(0, 8191, '\p{^ingreekextended}', "");
    Expect(0, 8191, '\P{ingreekextended}', "");
    Expect(1, 8191, '\P{^ingreekextended}', "");
    Expect(0, 8192, '\p{ingreekextended}', "");
    Expect(1, 8192, '\p{^ingreekextended}', "");
    Expect(1, 8192, '\P{ingreekextended}', "");
    Expect(0, 8192, '\P{^ingreekextended}', "");
    Expect(1, 8191, '\p{	 in_Greek_Extended}', "");
    Expect(0, 8191, '\p{^	 in_Greek_Extended}', "");
    Expect(0, 8191, '\P{	 in_Greek_Extended}', "");
    Expect(1, 8191, '\P{^	 in_Greek_Extended}', "");
    Expect(0, 8192, '\p{	 in_Greek_Extended}', "");
    Expect(1, 8192, '\p{^	 in_Greek_Extended}', "");
    Expect(1, 8192, '\P{	 in_Greek_Extended}', "");
    Expect(0, 8192, '\P{^	 in_Greek_Extended}', "");
    Error('\p{_:=Greek_EXT}');
    Error('\P{_:=Greek_EXT}');
    Expect(1, 8191, '\p{greekext}', "");
    Expect(0, 8191, '\p{^greekext}', "");
    Expect(0, 8191, '\P{greekext}', "");
    Expect(1, 8191, '\P{^greekext}', "");
    Expect(0, 8192, '\p{greekext}', "");
    Expect(1, 8192, '\p{^greekext}', "");
    Expect(1, 8192, '\P{greekext}', "");
    Expect(0, 8192, '\P{^greekext}', "");
    Expect(1, 8191, '\p{	Greek_Ext}', "");
    Expect(0, 8191, '\p{^	Greek_Ext}', "");
    Expect(0, 8191, '\P{	Greek_Ext}', "");
    Expect(1, 8191, '\P{^	Greek_Ext}', "");
    Expect(0, 8192, '\p{	Greek_Ext}', "");
    Expect(1, 8192, '\p{^	Greek_Ext}', "");
    Expect(1, 8192, '\P{	Greek_Ext}', "");
    Expect(0, 8192, '\P{^	Greek_Ext}', "");
    Error('\p{	 is_greek_Ext/a/}');
    Error('\P{	 is_greek_Ext/a/}');
    Expect(1, 8191, '\p{isgreekext}', "");
    Expect(0, 8191, '\p{^isgreekext}', "");
    Expect(0, 8191, '\P{isgreekext}', "");
    Expect(1, 8191, '\P{^isgreekext}', "");
    Expect(0, 8192, '\p{isgreekext}', "");
    Expect(1, 8192, '\p{^isgreekext}', "");
    Expect(1, 8192, '\P{isgreekext}', "");
    Expect(0, 8192, '\P{^isgreekext}', "");
    Expect(1, 8191, '\p{-Is_GREEK_EXT}', "");
    Expect(0, 8191, '\p{^-Is_GREEK_EXT}', "");
    Expect(0, 8191, '\P{-Is_GREEK_EXT}', "");
    Expect(1, 8191, '\P{^-Is_GREEK_EXT}', "");
    Expect(0, 8192, '\p{-Is_GREEK_EXT}', "");
    Expect(1, 8192, '\p{^-Is_GREEK_EXT}', "");
    Expect(1, 8192, '\P{-Is_GREEK_EXT}', "");
    Expect(0, 8192, '\P{^-Is_GREEK_EXT}', "");
    Error('\p{:=IN_greek_Ext}');
    Error('\P{:=IN_greek_Ext}');
    Expect(1, 8191, '\p{ingreekext}', "");
    Expect(0, 8191, '\p{^ingreekext}', "");
    Expect(0, 8191, '\P{ingreekext}', "");
    Expect(1, 8191, '\P{^ingreekext}', "");
    Expect(0, 8192, '\p{ingreekext}', "");
    Expect(1, 8192, '\p{^ingreekext}', "");
    Expect(1, 8192, '\P{ingreekext}', "");
    Expect(0, 8192, '\P{^ingreekext}', "");
    Expect(1, 8191, '\p{_ In_Greek_EXT}', "");
    Expect(0, 8191, '\p{^_ In_Greek_EXT}', "");
    Expect(0, 8191, '\P{_ In_Greek_EXT}', "");
    Expect(1, 8191, '\P{^_ In_Greek_EXT}', "");
    Expect(0, 8192, '\p{_ In_Greek_EXT}', "");
    Expect(1, 8192, '\p{^_ In_Greek_EXT}', "");
    Expect(1, 8192, '\P{_ In_Greek_EXT}', "");
    Expect(0, 8192, '\P{^_ In_Greek_EXT}', "");
    Error('\p{/a/ gujarati}');
    Error('\P{/a/ gujarati}');
    Expect(1, 43065, '\p{gujarati}', "");
    Expect(0, 43065, '\p{^gujarati}', "");
    Expect(0, 43065, '\P{gujarati}', "");
    Expect(1, 43065, '\P{^gujarati}', "");
    Expect(0, 43066, '\p{gujarati}', "");
    Expect(1, 43066, '\p{^gujarati}', "");
    Expect(1, 43066, '\P{gujarati}', "");
    Expect(0, 43066, '\P{^gujarati}', "");
    Expect(1, 43065, '\p{  Gujarati}', "");
    Expect(0, 43065, '\p{^  Gujarati}', "");
    Expect(0, 43065, '\P{  Gujarati}', "");
    Expect(1, 43065, '\P{^  Gujarati}', "");
    Expect(0, 43066, '\p{  Gujarati}', "");
    Expect(1, 43066, '\p{^  Gujarati}', "");
    Expect(1, 43066, '\P{  Gujarati}', "");
    Expect(0, 43066, '\P{^  Gujarati}', "");
    Error('\p{/a/--IS_GUJARATI}');
    Error('\P{/a/--IS_GUJARATI}');
    Expect(1, 43065, '\p{isgujarati}', "");
    Expect(0, 43065, '\p{^isgujarati}', "");
    Expect(0, 43065, '\P{isgujarati}', "");
    Expect(1, 43065, '\P{^isgujarati}', "");
    Expect(0, 43066, '\p{isgujarati}', "");
    Expect(1, 43066, '\p{^isgujarati}', "");
    Expect(1, 43066, '\P{isgujarati}', "");
    Expect(0, 43066, '\P{^isgujarati}', "");
    Expect(1, 43065, '\p{__Is_Gujarati}', "");
    Expect(0, 43065, '\p{^__Is_Gujarati}', "");
    Expect(0, 43065, '\P{__Is_Gujarati}', "");
    Expect(1, 43065, '\P{^__Is_Gujarati}', "");
    Expect(0, 43066, '\p{__Is_Gujarati}', "");
    Expect(1, 43066, '\p{^__Is_Gujarati}', "");
    Expect(1, 43066, '\P{__Is_Gujarati}', "");
    Expect(0, 43066, '\P{^__Is_Gujarati}', "");
    Error('\p{ -GUJR:=}');
    Error('\P{ -GUJR:=}');
    Expect(1, 43065, '\p{gujr}', "");
    Expect(0, 43065, '\p{^gujr}', "");
    Expect(0, 43065, '\P{gujr}', "");
    Expect(1, 43065, '\P{^gujr}', "");
    Expect(0, 43066, '\p{gujr}', "");
    Expect(1, 43066, '\p{^gujr}', "");
    Expect(1, 43066, '\P{gujr}', "");
    Expect(0, 43066, '\P{^gujr}', "");
    Expect(1, 43065, '\p{--gujr}', "");
    Expect(0, 43065, '\p{^--gujr}', "");
    Expect(0, 43065, '\P{--gujr}', "");
    Expect(1, 43065, '\P{^--gujr}', "");
    Expect(0, 43066, '\p{--gujr}', "");
    Expect(1, 43066, '\p{^--gujr}', "");
    Expect(1, 43066, '\P{--gujr}', "");
    Expect(0, 43066, '\P{^--gujr}', "");
    Error('\p{/a/-Is_Gujr}');
    Error('\P{/a/-Is_Gujr}');
    Expect(1, 43065, '\p{isgujr}', "");
    Expect(0, 43065, '\p{^isgujr}', "");
    Expect(0, 43065, '\P{isgujr}', "");
    Expect(1, 43065, '\P{^isgujr}', "");
    Expect(0, 43066, '\p{isgujr}', "");
    Expect(1, 43066, '\p{^isgujr}', "");
    Expect(1, 43066, '\P{isgujr}', "");
    Expect(0, 43066, '\P{^isgujr}', "");
    Expect(1, 43065, '\p{IS_Gujr}', "");
    Expect(0, 43065, '\p{^IS_Gujr}', "");
    Expect(0, 43065, '\P{IS_Gujr}', "");
    Expect(1, 43065, '\P{^IS_Gujr}', "");
    Expect(0, 43066, '\p{IS_Gujr}', "");
    Expect(1, 43066, '\p{^IS_Gujr}', "");
    Expect(1, 43066, '\P{IS_Gujr}', "");
    Expect(0, 43066, '\P{^IS_Gujr}', "");
    Error('\p{__Gunjala_Gondi:=}');
    Error('\P{__Gunjala_Gondi:=}');
    Expect(1, 73129, '\p{gunjalagondi}', "");
    Expect(0, 73129, '\p{^gunjalagondi}', "");
    Expect(0, 73129, '\P{gunjalagondi}', "");
    Expect(1, 73129, '\P{^gunjalagondi}', "");
    Expect(0, 73130, '\p{gunjalagondi}', "");
    Expect(1, 73130, '\p{^gunjalagondi}', "");
    Expect(1, 73130, '\P{gunjalagondi}', "");
    Expect(0, 73130, '\P{^gunjalagondi}', "");
    Expect(1, 73129, '\p{_GUNJALA_Gondi}', "");
    Expect(0, 73129, '\p{^_GUNJALA_Gondi}', "");
    Expect(0, 73129, '\P{_GUNJALA_Gondi}', "");
    Expect(1, 73129, '\P{^_GUNJALA_Gondi}', "");
    Expect(0, 73130, '\p{_GUNJALA_Gondi}', "");
    Expect(1, 73130, '\p{^_GUNJALA_Gondi}', "");
    Expect(1, 73130, '\P{_GUNJALA_Gondi}', "");
    Expect(0, 73130, '\P{^_GUNJALA_Gondi}', "");
    Error('\p{:=	 IS_gunjala_Gondi}');
    Error('\P{:=	 IS_gunjala_Gondi}');
    Expect(1, 73129, '\p{isgunjalagondi}', "");
    Expect(0, 73129, '\p{^isgunjalagondi}', "");
    Expect(0, 73129, '\P{isgunjalagondi}', "");
    Expect(1, 73129, '\P{^isgunjalagondi}', "");
    Expect(0, 73130, '\p{isgunjalagondi}', "");
    Expect(1, 73130, '\p{^isgunjalagondi}', "");
    Expect(1, 73130, '\P{isgunjalagondi}', "");
    Expect(0, 73130, '\P{^isgunjalagondi}', "");
    Expect(1, 73129, '\p{_-Is_gunjala_gondi}', "");
    Expect(0, 73129, '\p{^_-Is_gunjala_gondi}', "");
    Expect(0, 73129, '\P{_-Is_gunjala_gondi}', "");
    Expect(1, 73129, '\P{^_-Is_gunjala_gondi}', "");
    Expect(0, 73130, '\p{_-Is_gunjala_gondi}', "");
    Expect(1, 73130, '\p{^_-Is_gunjala_gondi}', "");
    Expect(1, 73130, '\P{_-Is_gunjala_gondi}', "");
    Expect(0, 73130, '\P{^_-Is_gunjala_gondi}', "");
    Error('\p{:=GONG}');
    Error('\P{:=GONG}');
    Expect(1, 73129, '\p{gong}', "");
    Expect(0, 73129, '\p{^gong}', "");
    Expect(0, 73129, '\P{gong}', "");
    Expect(1, 73129, '\P{^gong}', "");
    Expect(0, 73130, '\p{gong}', "");
    Expect(1, 73130, '\p{^gong}', "");
    Expect(1, 73130, '\P{gong}', "");
    Expect(0, 73130, '\P{^gong}', "");
    Expect(1, 73129, '\p{- GONG}', "");
    Expect(0, 73129, '\p{^- GONG}', "");
    Expect(0, 73129, '\P{- GONG}', "");
    Expect(1, 73129, '\P{^- GONG}', "");
    Expect(0, 73130, '\p{- GONG}', "");
    Expect(1, 73130, '\p{^- GONG}', "");
    Expect(1, 73130, '\P{- GONG}', "");
    Expect(0, 73130, '\P{^- GONG}', "");
    Error('\p{/a/_	Is_GONG}');
    Error('\P{/a/_	Is_GONG}');
    Expect(1, 73129, '\p{isgong}', "");
    Expect(0, 73129, '\p{^isgong}', "");
    Expect(0, 73129, '\P{isgong}', "");
    Expect(1, 73129, '\P{^isgong}', "");
    Expect(0, 73130, '\p{isgong}', "");
    Expect(1, 73130, '\p{^isgong}', "");
    Expect(1, 73130, '\P{isgong}', "");
    Expect(0, 73130, '\P{^isgong}', "");
    Expect(1, 73129, '\p{-_is_GONG}', "");
    Expect(0, 73129, '\p{^-_is_GONG}', "");
    Expect(0, 73129, '\P{-_is_GONG}', "");
    Expect(1, 73129, '\P{^-_is_GONG}', "");
    Expect(0, 73130, '\p{-_is_GONG}', "");
    Expect(1, 73130, '\p{^-_is_GONG}', "");
    Expect(1, 73130, '\P{-_is_GONG}', "");
    Expect(0, 73130, '\P{^-_is_GONG}', "");
    Error('\p{:=__Gurmukhi}');
    Error('\P{:=__Gurmukhi}');
    Expect(1, 43065, '\p{gurmukhi}', "");
    Expect(0, 43065, '\p{^gurmukhi}', "");
    Expect(0, 43065, '\P{gurmukhi}', "");
    Expect(1, 43065, '\P{^gurmukhi}', "");
    Expect(0, 43066, '\p{gurmukhi}', "");
    Expect(1, 43066, '\p{^gurmukhi}', "");
    Expect(1, 43066, '\P{gurmukhi}', "");
    Expect(0, 43066, '\P{^gurmukhi}', "");
    Expect(1, 43065, '\p{_	GURMUKHI}', "");
    Expect(0, 43065, '\p{^_	GURMUKHI}', "");
    Expect(0, 43065, '\P{_	GURMUKHI}', "");
    Expect(1, 43065, '\P{^_	GURMUKHI}', "");
    Expect(0, 43066, '\p{_	GURMUKHI}', "");
    Expect(1, 43066, '\p{^_	GURMUKHI}', "");
    Expect(1, 43066, '\P{_	GURMUKHI}', "");
    Expect(0, 43066, '\P{^_	GURMUKHI}', "");
    Error('\p{_Is_Gurmukhi:=}');
    Error('\P{_Is_Gurmukhi:=}');
    Expect(1, 43065, '\p{isgurmukhi}', "");
    Expect(0, 43065, '\p{^isgurmukhi}', "");
    Expect(0, 43065, '\P{isgurmukhi}', "");
    Expect(1, 43065, '\P{^isgurmukhi}', "");
    Expect(0, 43066, '\p{isgurmukhi}', "");
    Expect(1, 43066, '\p{^isgurmukhi}', "");
    Expect(1, 43066, '\P{isgurmukhi}', "");
    Expect(0, 43066, '\P{^isgurmukhi}', "");
    Expect(1, 43065, '\p{__IS_Gurmukhi}', "");
    Expect(0, 43065, '\p{^__IS_Gurmukhi}', "");
    Expect(0, 43065, '\P{__IS_Gurmukhi}', "");
    Expect(1, 43065, '\P{^__IS_Gurmukhi}', "");
    Expect(0, 43066, '\p{__IS_Gurmukhi}', "");
    Expect(1, 43066, '\p{^__IS_Gurmukhi}', "");
    Expect(1, 43066, '\P{__IS_Gurmukhi}', "");
    Expect(0, 43066, '\P{^__IS_Gurmukhi}', "");
    Error('\p{	/a/guru}');
    Error('\P{	/a/guru}');
    Expect(1, 43065, '\p{guru}', "");
    Expect(0, 43065, '\p{^guru}', "");
    Expect(0, 43065, '\P{guru}', "");
    Expect(1, 43065, '\P{^guru}', "");
    Expect(0, 43066, '\p{guru}', "");
    Expect(1, 43066, '\p{^guru}', "");
    Expect(1, 43066, '\P{guru}', "");
    Expect(0, 43066, '\P{^guru}', "");
    Expect(1, 43065, '\p{--GURU}', "");
    Expect(0, 43065, '\p{^--GURU}', "");
    Expect(0, 43065, '\P{--GURU}', "");
    Expect(1, 43065, '\P{^--GURU}', "");
    Expect(0, 43066, '\p{--GURU}', "");
    Expect(1, 43066, '\p{^--GURU}', "");
    Expect(1, 43066, '\P{--GURU}', "");
    Expect(0, 43066, '\P{^--GURU}', "");
    Error('\p{	 Is_Guru/a/}');
    Error('\P{	 Is_Guru/a/}');
    Expect(1, 43065, '\p{isguru}', "");
    Expect(0, 43065, '\p{^isguru}', "");
    Expect(0, 43065, '\P{isguru}', "");
    Expect(1, 43065, '\P{^isguru}', "");
    Expect(0, 43066, '\p{isguru}', "");
    Expect(1, 43066, '\p{^isguru}', "");
    Expect(1, 43066, '\P{isguru}', "");
    Expect(0, 43066, '\P{^isguru}', "");
    Expect(1, 43065, '\p{_IS_guru}', "");
    Expect(0, 43065, '\p{^_IS_guru}', "");
    Expect(0, 43065, '\P{_IS_guru}', "");
    Expect(1, 43065, '\P{^_IS_guru}', "");
    Expect(0, 43066, '\p{_IS_guru}', "");
    Expect(1, 43066, '\p{^_IS_guru}', "");
    Expect(1, 43066, '\P{_IS_guru}', "");
    Expect(0, 43066, '\P{^_IS_guru}', "");
    Error('\p{ Halfwidth_AND_Fullwidth_forms/a/}');
    Error('\P{ Halfwidth_AND_Fullwidth_forms/a/}');
    Expect(1, 65519, '\p{halfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\p{^halfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\P{halfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\P{^halfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\p{halfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\p{^halfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\P{halfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\P{^halfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\p{_ HALFWIDTH_AND_fullwidth_Forms}', "");
    Expect(0, 65519, '\p{^_ HALFWIDTH_AND_fullwidth_Forms}', "");
    Expect(0, 65519, '\P{_ HALFWIDTH_AND_fullwidth_Forms}', "");
    Expect(1, 65519, '\P{^_ HALFWIDTH_AND_fullwidth_Forms}', "");
    Expect(0, 65520, '\p{_ HALFWIDTH_AND_fullwidth_Forms}', "");
    Expect(1, 65520, '\p{^_ HALFWIDTH_AND_fullwidth_Forms}', "");
    Expect(1, 65520, '\P{_ HALFWIDTH_AND_fullwidth_Forms}', "");
    Expect(0, 65520, '\P{^_ HALFWIDTH_AND_fullwidth_Forms}', "");
    Error('\p{Is_HALFWIDTH_AND_FULLWIDTH_forms/a/}');
    Error('\P{Is_HALFWIDTH_AND_FULLWIDTH_forms/a/}');
    Expect(1, 65519, '\p{ishalfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\p{^ishalfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\P{ishalfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\P{^ishalfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\p{ishalfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\p{^ishalfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\P{ishalfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\P{^ishalfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\p{--Is_halfwidth_And_Fullwidth_FORMS}', "");
    Expect(0, 65519, '\p{^--Is_halfwidth_And_Fullwidth_FORMS}', "");
    Expect(0, 65519, '\P{--Is_halfwidth_And_Fullwidth_FORMS}', "");
    Expect(1, 65519, '\P{^--Is_halfwidth_And_Fullwidth_FORMS}', "");
    Expect(0, 65520, '\p{--Is_halfwidth_And_Fullwidth_FORMS}', "");
    Expect(1, 65520, '\p{^--Is_halfwidth_And_Fullwidth_FORMS}', "");
    Expect(1, 65520, '\P{--Is_halfwidth_And_Fullwidth_FORMS}', "");
    Expect(0, 65520, '\P{^--Is_halfwidth_And_Fullwidth_FORMS}', "");
    Error('\p{/a/_IN_HALFWIDTH_And_Fullwidth_FORMS}');
    Error('\P{/a/_IN_HALFWIDTH_And_Fullwidth_FORMS}');
    Expect(1, 65519, '\p{inhalfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\p{^inhalfwidthandfullwidthforms}', "");
    Expect(0, 65519, '\P{inhalfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\P{^inhalfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\p{inhalfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\p{^inhalfwidthandfullwidthforms}', "");
    Expect(1, 65520, '\P{inhalfwidthandfullwidthforms}', "");
    Expect(0, 65520, '\P{^inhalfwidthandfullwidthforms}', "");
    Expect(1, 65519, '\p{ _in_halfwidth_And_Fullwidth_Forms}', "");
    Expect(0, 65519, '\p{^ _in_halfwidth_And_Fullwidth_Forms}', "");
    Expect(0, 65519, '\P{ _in_halfwidth_And_Fullwidth_Forms}', "");
    Expect(1, 65519, '\P{^ _in_halfwidth_And_Fullwidth_Forms}', "");
    Expect(0, 65520, '\p{ _in_halfwidth_And_Fullwidth_Forms}', "");
    Expect(1, 65520, '\p{^ _in_halfwidth_And_Fullwidth_Forms}', "");
    Expect(1, 65520, '\P{ _in_halfwidth_And_Fullwidth_Forms}', "");
    Expect(0, 65520, '\P{^ _in_halfwidth_And_Fullwidth_Forms}', "");
    Error('\p{/a/	 Half_and_Full_forms}');
    Error('\P{/a/	 Half_and_Full_forms}');
    Expect(1, 65519, '\p{halfandfullforms}', "");
    Expect(0, 65519, '\p{^halfandfullforms}', "");
    Expect(0, 65519, '\P{halfandfullforms}', "");
    Expect(1, 65519, '\P{^halfandfullforms}', "");
    Expect(0, 65520, '\p{halfandfullforms}', "");
    Expect(1, 65520, '\p{^halfandfullforms}', "");
    Expect(1, 65520, '\P{halfandfullforms}', "");
    Expect(0, 65520, '\P{^halfandfullforms}', "");
    Expect(1, 65519, '\p{	 half_And_full_FORMS}', "");
    Expect(0, 65519, '\p{^	 half_And_full_FORMS}', "");
    Expect(0, 65519, '\P{	 half_And_full_FORMS}', "");
    Expect(1, 65519, '\P{^	 half_And_full_FORMS}', "");
    Expect(0, 65520, '\p{	 half_And_full_FORMS}', "");
    Expect(1, 65520, '\p{^	 half_And_full_FORMS}', "");
    Expect(1, 65520, '\P{	 half_And_full_FORMS}', "");
    Expect(0, 65520, '\P{^	 half_And_full_FORMS}', "");
    Error('\p{ -Is_Half_And_Full_FORMS/a/}');
    Error('\P{ -Is_Half_And_Full_FORMS/a/}');
    Expect(1, 65519, '\p{ishalfandfullforms}', "");
    Expect(0, 65519, '\p{^ishalfandfullforms}', "");
    Expect(0, 65519, '\P{ishalfandfullforms}', "");
    Expect(1, 65519, '\P{^ishalfandfullforms}', "");
    Expect(0, 65520, '\p{ishalfandfullforms}', "");
    Expect(1, 65520, '\p{^ishalfandfullforms}', "");
    Expect(1, 65520, '\P{ishalfandfullforms}', "");
    Expect(0, 65520, '\P{^ishalfandfullforms}', "");
    Expect(1, 65519, '\p{-IS_half_And_Full_Forms}', "");
    Expect(0, 65519, '\p{^-IS_half_And_Full_Forms}', "");
    Expect(0, 65519, '\P{-IS_half_And_Full_Forms}', "");
    Expect(1, 65519, '\P{^-IS_half_And_Full_Forms}', "");
    Expect(0, 65520, '\p{-IS_half_And_Full_Forms}', "");
    Expect(1, 65520, '\p{^-IS_half_And_Full_Forms}', "");
    Expect(1, 65520, '\P{-IS_half_And_Full_Forms}', "");
    Expect(0, 65520, '\P{^-IS_half_And_Full_Forms}', "");
    Error('\p{_/a/In_Half_And_FULL_Forms}');
    Error('\P{_/a/In_Half_And_FULL_Forms}');
    Expect(1, 65519, '\p{inhalfandfullforms}', "");
    Expect(0, 65519, '\p{^inhalfandfullforms}', "");
    Expect(0, 65519, '\P{inhalfandfullforms}', "");
    Expect(1, 65519, '\P{^inhalfandfullforms}', "");
    Expect(0, 65520, '\p{inhalfandfullforms}', "");
    Expect(1, 65520, '\p{^inhalfandfullforms}', "");
    Expect(1, 65520, '\P{inhalfandfullforms}', "");
    Expect(0, 65520, '\P{^inhalfandfullforms}', "");
    Expect(1, 65519, '\p{ 	In_HALF_AND_Full_Forms}', "");
    Expect(0, 65519, '\p{^ 	In_HALF_AND_Full_Forms}', "");
    Expect(0, 65519, '\P{ 	In_HALF_AND_Full_Forms}', "");
    Expect(1, 65519, '\P{^ 	In_HALF_AND_Full_Forms}', "");
    Expect(0, 65520, '\p{ 	In_HALF_AND_Full_Forms}', "");
    Expect(1, 65520, '\p{^ 	In_HALF_AND_Full_Forms}', "");
    Expect(1, 65520, '\P{ 	In_HALF_AND_Full_Forms}', "");
    Expect(0, 65520, '\P{^ 	In_HALF_AND_Full_Forms}', "");
    Error('\p{-HAN/a/}');
    Error('\P{-HAN/a/}');
    Expect(1, 195101, '\p{han}', "");
    Expect(0, 195101, '\p{^han}', "");
    Expect(0, 195101, '\P{han}', "");
    Expect(1, 195101, '\P{^han}', "");
    Expect(0, 195102, '\p{han}', "");
    Expect(1, 195102, '\p{^han}', "");
    Expect(1, 195102, '\P{han}', "");
    Expect(0, 195102, '\P{^han}', "");
    Expect(1, 195101, '\p{- HAN}', "");
    Expect(0, 195101, '\p{^- HAN}', "");
    Expect(0, 195101, '\P{- HAN}', "");
    Expect(1, 195101, '\P{^- HAN}', "");
    Expect(0, 195102, '\p{- HAN}', "");
    Expect(1, 195102, '\p{^- HAN}', "");
    Expect(1, 195102, '\P{- HAN}', "");
    Expect(0, 195102, '\P{^- HAN}', "");
    Error('\p{	Is_Han/a/}');
    Error('\P{	Is_Han/a/}');
    Expect(1, 195101, '\p{ishan}', "");
    Expect(0, 195101, '\p{^ishan}', "");
    Expect(0, 195101, '\P{ishan}', "");
    Expect(1, 195101, '\P{^ishan}', "");
    Expect(0, 195102, '\p{ishan}', "");
    Expect(1, 195102, '\p{^ishan}', "");
    Expect(1, 195102, '\P{ishan}', "");
    Expect(0, 195102, '\P{^ishan}', "");
    Expect(1, 195101, '\p{_Is_han}', "");
    Expect(0, 195101, '\p{^_Is_han}', "");
    Expect(0, 195101, '\P{_Is_han}', "");
    Expect(1, 195101, '\P{^_Is_han}', "");
    Expect(0, 195102, '\p{_Is_han}', "");
    Expect(1, 195102, '\p{^_Is_han}', "");
    Expect(1, 195102, '\P{_Is_han}', "");
    Expect(0, 195102, '\P{^_Is_han}', "");
    Error('\p{_	hani:=}');
    Error('\P{_	hani:=}');
    Expect(1, 195101, '\p{hani}', "");
    Expect(0, 195101, '\p{^hani}', "");
    Expect(0, 195101, '\P{hani}', "");
    Expect(1, 195101, '\P{^hani}', "");
    Expect(0, 195102, '\p{hani}', "");
    Expect(1, 195102, '\p{^hani}', "");
    Expect(1, 195102, '\P{hani}', "");
    Expect(0, 195102, '\P{^hani}', "");
    Expect(1, 195101, '\p{_HANI}', "");
    Expect(0, 195101, '\p{^_HANI}', "");
    Expect(0, 195101, '\P{_HANI}', "");
    Expect(1, 195101, '\P{^_HANI}', "");
    Expect(0, 195102, '\p{_HANI}', "");
    Expect(1, 195102, '\p{^_HANI}', "");
    Expect(1, 195102, '\P{_HANI}', "");
    Expect(0, 195102, '\P{^_HANI}', "");
    Error('\p{:=		Is_HANI}');
    Error('\P{:=		Is_HANI}');
    Expect(1, 195101, '\p{ishani}', "");
    Expect(0, 195101, '\p{^ishani}', "");
    Expect(0, 195101, '\P{ishani}', "");
    Expect(1, 195101, '\P{^ishani}', "");
    Expect(0, 195102, '\p{ishani}', "");
    Expect(1, 195102, '\p{^ishani}', "");
    Expect(1, 195102, '\P{ishani}', "");
    Expect(0, 195102, '\P{^ishani}', "");
    Expect(1, 195101, '\p{	_is_HANI}', "");
    Expect(0, 195101, '\p{^	_is_HANI}', "");
    Expect(0, 195101, '\P{	_is_HANI}', "");
    Expect(1, 195101, '\P{^	_is_HANI}', "");
    Expect(0, 195102, '\p{	_is_HANI}', "");
    Expect(1, 195102, '\p{^	_is_HANI}', "");
    Expect(1, 195102, '\P{	_is_HANI}', "");
    Expect(0, 195102, '\P{^	_is_HANI}', "");
    Error('\p{/a/ 	HANGUL}');
    Error('\P{/a/ 	HANGUL}');
    Expect(1, 65500, '\p{hangul}', "");
    Expect(0, 65500, '\p{^hangul}', "");
    Expect(0, 65500, '\P{hangul}', "");
    Expect(1, 65500, '\P{^hangul}', "");
    Expect(0, 65501, '\p{hangul}', "");
    Expect(1, 65501, '\p{^hangul}', "");
    Expect(1, 65501, '\P{hangul}', "");
    Expect(0, 65501, '\P{^hangul}', "");
    Expect(1, 65500, '\p{  Hangul}', "");
    Expect(0, 65500, '\p{^  Hangul}', "");
    Expect(0, 65500, '\P{  Hangul}', "");
    Expect(1, 65500, '\P{^  Hangul}', "");
    Expect(0, 65501, '\p{  Hangul}', "");
    Expect(1, 65501, '\p{^  Hangul}', "");
    Expect(1, 65501, '\P{  Hangul}', "");
    Expect(0, 65501, '\P{^  Hangul}', "");
    Error('\p{  Is_Hangul:=}');
    Error('\P{  Is_Hangul:=}');
    Expect(1, 65500, '\p{ishangul}', "");
    Expect(0, 65500, '\p{^ishangul}', "");
    Expect(0, 65500, '\P{ishangul}', "");
    Expect(1, 65500, '\P{^ishangul}', "");
    Expect(0, 65501, '\p{ishangul}', "");
    Expect(1, 65501, '\p{^ishangul}', "");
    Expect(1, 65501, '\P{ishangul}', "");
    Expect(0, 65501, '\P{^ishangul}', "");
    Expect(1, 65500, '\p{	 Is_hangul}', "");
    Expect(0, 65500, '\p{^	 Is_hangul}', "");
    Expect(0, 65500, '\P{	 Is_hangul}', "");
    Expect(1, 65500, '\P{^	 Is_hangul}', "");
    Expect(0, 65501, '\p{	 Is_hangul}', "");
    Expect(1, 65501, '\p{^	 Is_hangul}', "");
    Expect(1, 65501, '\P{	 Is_hangul}', "");
    Expect(0, 65501, '\P{^	 Is_hangul}', "");
    Error('\p{ 	Hang:=}');
    Error('\P{ 	Hang:=}');
    Expect(1, 65500, '\p{hang}', "");
    Expect(0, 65500, '\p{^hang}', "");
    Expect(0, 65500, '\P{hang}', "");
    Expect(1, 65500, '\P{^hang}', "");
    Expect(0, 65501, '\p{hang}', "");
    Expect(1, 65501, '\p{^hang}', "");
    Expect(1, 65501, '\P{hang}', "");
    Expect(0, 65501, '\P{^hang}', "");
    Expect(1, 65500, '\p{ -Hang}', "");
    Expect(0, 65500, '\p{^ -Hang}', "");
    Expect(0, 65500, '\P{ -Hang}', "");
    Expect(1, 65500, '\P{^ -Hang}', "");
    Expect(0, 65501, '\p{ -Hang}', "");
    Expect(1, 65501, '\p{^ -Hang}', "");
    Expect(1, 65501, '\P{ -Hang}', "");
    Expect(0, 65501, '\P{^ -Hang}', "");
    Error('\p{	:=Is_Hang}');
    Error('\P{	:=Is_Hang}');
    Expect(1, 65500, '\p{ishang}', "");
    Expect(0, 65500, '\p{^ishang}', "");
    Expect(0, 65500, '\P{ishang}', "");
    Expect(1, 65500, '\P{^ishang}', "");
    Expect(0, 65501, '\p{ishang}', "");
    Expect(1, 65501, '\p{^ishang}', "");
    Expect(1, 65501, '\P{ishang}', "");
    Expect(0, 65501, '\P{^ishang}', "");
    Expect(1, 65500, '\p{	 is_Hang}', "");
    Expect(0, 65500, '\p{^	 is_Hang}', "");
    Expect(0, 65500, '\P{	 is_Hang}', "");
    Expect(1, 65500, '\P{^	 is_Hang}', "");
    Expect(0, 65501, '\p{	 is_Hang}', "");
    Expect(1, 65501, '\p{^	 is_Hang}', "");
    Expect(1, 65501, '\P{	 is_Hang}', "");
    Expect(0, 65501, '\P{^	 is_Hang}', "");
    Error('\p{	/a/hangul_Compatibility_Jamo}');
    Error('\P{	/a/hangul_Compatibility_Jamo}');
    Expect(1, 12687, '\p{hangulcompatibilityjamo}', "");
    Expect(0, 12687, '\p{^hangulcompatibilityjamo}', "");
    Expect(0, 12687, '\P{hangulcompatibilityjamo}', "");
    Expect(1, 12687, '\P{^hangulcompatibilityjamo}', "");
    Expect(0, 12688, '\p{hangulcompatibilityjamo}', "");
    Expect(1, 12688, '\p{^hangulcompatibilityjamo}', "");
    Expect(1, 12688, '\P{hangulcompatibilityjamo}', "");
    Expect(0, 12688, '\P{^hangulcompatibilityjamo}', "");
    Expect(1, 12687, '\p{	Hangul_COMPATIBILITY_Jamo}', "");
    Expect(0, 12687, '\p{^	Hangul_COMPATIBILITY_Jamo}', "");
    Expect(0, 12687, '\P{	Hangul_COMPATIBILITY_Jamo}', "");
    Expect(1, 12687, '\P{^	Hangul_COMPATIBILITY_Jamo}', "");
    Expect(0, 12688, '\p{	Hangul_COMPATIBILITY_Jamo}', "");
    Expect(1, 12688, '\p{^	Hangul_COMPATIBILITY_Jamo}', "");
    Expect(1, 12688, '\P{	Hangul_COMPATIBILITY_Jamo}', "");
    Expect(0, 12688, '\P{^	Hangul_COMPATIBILITY_Jamo}', "");
    Error('\p{:=	IS_hangul_Compatibility_jamo}');
    Error('\P{:=	IS_hangul_Compatibility_jamo}');
    Expect(1, 12687, '\p{ishangulcompatibilityjamo}', "");
    Expect(0, 12687, '\p{^ishangulcompatibilityjamo}', "");
    Expect(0, 12687, '\P{ishangulcompatibilityjamo}', "");
    Expect(1, 12687, '\P{^ishangulcompatibilityjamo}', "");
    Expect(0, 12688, '\p{ishangulcompatibilityjamo}', "");
    Expect(1, 12688, '\p{^ishangulcompatibilityjamo}', "");
    Expect(1, 12688, '\P{ishangulcompatibilityjamo}', "");
    Expect(0, 12688, '\P{^ishangulcompatibilityjamo}', "");
    Expect(1, 12687, '\p{		Is_Hangul_Compatibility_Jamo}', "");
    Expect(0, 12687, '\p{^		Is_Hangul_Compatibility_Jamo}', "");
    Expect(0, 12687, '\P{		Is_Hangul_Compatibility_Jamo}', "");
    Expect(1, 12687, '\P{^		Is_Hangul_Compatibility_Jamo}', "");
    Expect(0, 12688, '\p{		Is_Hangul_Compatibility_Jamo}', "");
    Expect(1, 12688, '\p{^		Is_Hangul_Compatibility_Jamo}', "");
    Expect(1, 12688, '\P{		Is_Hangul_Compatibility_Jamo}', "");
    Expect(0, 12688, '\P{^		Is_Hangul_Compatibility_Jamo}', "");
    Error('\p{ /a/in_Hangul_compatibility_Jamo}');
    Error('\P{ /a/in_Hangul_compatibility_Jamo}');
    Expect(1, 12687, '\p{inhangulcompatibilityjamo}', "");
    Expect(0, 12687, '\p{^inhangulcompatibilityjamo}', "");
    Expect(0, 12687, '\P{inhangulcompatibilityjamo}', "");
    Expect(1, 12687, '\P{^inhangulcompatibilityjamo}', "");
    Expect(0, 12688, '\p{inhangulcompatibilityjamo}', "");
    Expect(1, 12688, '\p{^inhangulcompatibilityjamo}', "");
    Expect(1, 12688, '\P{inhangulcompatibilityjamo}', "");
    Expect(0, 12688, '\P{^inhangulcompatibilityjamo}', "");
    Expect(1, 12687, '\p{ 	IN_Hangul_Compatibility_Jamo}', "");
    Expect(0, 12687, '\p{^ 	IN_Hangul_Compatibility_Jamo}', "");
    Expect(0, 12687, '\P{ 	IN_Hangul_Compatibility_Jamo}', "");
    Expect(1, 12687, '\P{^ 	IN_Hangul_Compatibility_Jamo}', "");
    Expect(0, 12688, '\p{ 	IN_Hangul_Compatibility_Jamo}', "");
    Expect(1, 12688, '\p{^ 	IN_Hangul_Compatibility_Jamo}', "");
    Expect(1, 12688, '\P{ 	IN_Hangul_Compatibility_Jamo}', "");
    Expect(0, 12688, '\P{^ 	IN_Hangul_Compatibility_Jamo}', "");
    Error('\p{-:=compat_Jamo}');
    Error('\P{-:=compat_Jamo}');
    Expect(1, 12687, '\p{compatjamo}', "");
    Expect(0, 12687, '\p{^compatjamo}', "");
    Expect(0, 12687, '\P{compatjamo}', "");
    Expect(1, 12687, '\P{^compatjamo}', "");
    Expect(0, 12688, '\p{compatjamo}', "");
    Expect(1, 12688, '\p{^compatjamo}', "");
    Expect(1, 12688, '\P{compatjamo}', "");
    Expect(0, 12688, '\P{^compatjamo}', "");
    Expect(1, 12687, '\p{-COMPAT_Jamo}', "");
    Expect(0, 12687, '\p{^-COMPAT_Jamo}', "");
    Expect(0, 12687, '\P{-COMPAT_Jamo}', "");
    Expect(1, 12687, '\P{^-COMPAT_Jamo}', "");
    Expect(0, 12688, '\p{-COMPAT_Jamo}', "");
    Expect(1, 12688, '\p{^-COMPAT_Jamo}', "");
    Expect(1, 12688, '\P{-COMPAT_Jamo}', "");
    Expect(0, 12688, '\P{^-COMPAT_Jamo}', "");
    Error('\p{	:=is_Compat_JAMO}');
    Error('\P{	:=is_Compat_JAMO}');
    Expect(1, 12687, '\p{iscompatjamo}', "");
    Expect(0, 12687, '\p{^iscompatjamo}', "");
    Expect(0, 12687, '\P{iscompatjamo}', "");
    Expect(1, 12687, '\P{^iscompatjamo}', "");
    Expect(0, 12688, '\p{iscompatjamo}', "");
    Expect(1, 12688, '\p{^iscompatjamo}', "");
    Expect(1, 12688, '\P{iscompatjamo}', "");
    Expect(0, 12688, '\P{^iscompatjamo}', "");
    Expect(1, 12687, '\p{ IS_Compat_JAMO}', "");
    Expect(0, 12687, '\p{^ IS_Compat_JAMO}', "");
    Expect(0, 12687, '\P{ IS_Compat_JAMO}', "");
    Expect(1, 12687, '\P{^ IS_Compat_JAMO}', "");
    Expect(0, 12688, '\p{ IS_Compat_JAMO}', "");
    Expect(1, 12688, '\p{^ IS_Compat_JAMO}', "");
    Expect(1, 12688, '\P{ IS_Compat_JAMO}', "");
    Expect(0, 12688, '\P{^ IS_Compat_JAMO}', "");
    Error('\p{	IN_compat_jamo:=}');
    Error('\P{	IN_compat_jamo:=}');
    Expect(1, 12687, '\p{incompatjamo}', "");
    Expect(0, 12687, '\p{^incompatjamo}', "");
    Expect(0, 12687, '\P{incompatjamo}', "");
    Expect(1, 12687, '\P{^incompatjamo}', "");
    Expect(0, 12688, '\p{incompatjamo}', "");
    Expect(1, 12688, '\p{^incompatjamo}', "");
    Expect(1, 12688, '\P{incompatjamo}', "");
    Expect(0, 12688, '\P{^incompatjamo}', "");
    Expect(1, 12687, '\p{- in_compat_Jamo}', "");
    Expect(0, 12687, '\p{^- in_compat_Jamo}', "");
    Expect(0, 12687, '\P{- in_compat_Jamo}', "");
    Expect(1, 12687, '\P{^- in_compat_Jamo}', "");
    Expect(0, 12688, '\p{- in_compat_Jamo}', "");
    Expect(1, 12688, '\p{^- in_compat_Jamo}', "");
    Expect(1, 12688, '\P{- in_compat_Jamo}', "");
    Expect(0, 12688, '\P{^- in_compat_Jamo}', "");
    Error('\p{/a/	_HANGUL_JAMO}');
    Error('\P{/a/	_HANGUL_JAMO}');
    Expect(1, 4607, '\p{hanguljamo}', "");
    Expect(0, 4607, '\p{^hanguljamo}', "");
    Expect(0, 4607, '\P{hanguljamo}', "");
    Expect(1, 4607, '\P{^hanguljamo}', "");
    Expect(0, 4608, '\p{hanguljamo}', "");
    Expect(1, 4608, '\p{^hanguljamo}', "");
    Expect(1, 4608, '\P{hanguljamo}', "");
    Expect(0, 4608, '\P{^hanguljamo}', "");
    Expect(1, 4607, '\p{-hangul_JAMO}', "");
    Expect(0, 4607, '\p{^-hangul_JAMO}', "");
    Expect(0, 4607, '\P{-hangul_JAMO}', "");
    Expect(1, 4607, '\P{^-hangul_JAMO}', "");
    Expect(0, 4608, '\p{-hangul_JAMO}', "");
    Expect(1, 4608, '\p{^-hangul_JAMO}', "");
    Expect(1, 4608, '\P{-hangul_JAMO}', "");
    Expect(0, 4608, '\P{^-hangul_JAMO}', "");
    Error('\p{:=-_Is_HANGUL_JAMO}');
    Error('\P{:=-_Is_HANGUL_JAMO}');
    Expect(1, 4607, '\p{ishanguljamo}', "");
    Expect(0, 4607, '\p{^ishanguljamo}', "");
    Expect(0, 4607, '\P{ishanguljamo}', "");
    Expect(1, 4607, '\P{^ishanguljamo}', "");
    Expect(0, 4608, '\p{ishanguljamo}', "");
    Expect(1, 4608, '\p{^ishanguljamo}', "");
    Expect(1, 4608, '\P{ishanguljamo}', "");
    Expect(0, 4608, '\P{^ishanguljamo}', "");
    Expect(1, 4607, '\p{	-is_HANGUL_Jamo}', "");
    Expect(0, 4607, '\p{^	-is_HANGUL_Jamo}', "");
    Expect(0, 4607, '\P{	-is_HANGUL_Jamo}', "");
    Expect(1, 4607, '\P{^	-is_HANGUL_Jamo}', "");
    Expect(0, 4608, '\p{	-is_HANGUL_Jamo}', "");
    Expect(1, 4608, '\p{^	-is_HANGUL_Jamo}', "");
    Expect(1, 4608, '\P{	-is_HANGUL_Jamo}', "");
    Expect(0, 4608, '\P{^	-is_HANGUL_Jamo}', "");
    Error('\p{:=-In_Hangul_Jamo}');
    Error('\P{:=-In_Hangul_Jamo}');
    Expect(1, 4607, '\p{inhanguljamo}', "");
    Expect(0, 4607, '\p{^inhanguljamo}', "");
    Expect(0, 4607, '\P{inhanguljamo}', "");
    Expect(1, 4607, '\P{^inhanguljamo}', "");
    Expect(0, 4608, '\p{inhanguljamo}', "");
    Expect(1, 4608, '\p{^inhanguljamo}', "");
    Expect(1, 4608, '\P{inhanguljamo}', "");
    Expect(0, 4608, '\P{^inhanguljamo}', "");
    Expect(1, 4607, '\p{-	in_Hangul_JAMO}', "");
    Expect(0, 4607, '\p{^-	in_Hangul_JAMO}', "");
    Expect(0, 4607, '\P{-	in_Hangul_JAMO}', "");
    Expect(1, 4607, '\P{^-	in_Hangul_JAMO}', "");
    Expect(0, 4608, '\p{-	in_Hangul_JAMO}', "");
    Expect(1, 4608, '\p{^-	in_Hangul_JAMO}', "");
    Expect(1, 4608, '\P{-	in_Hangul_JAMO}', "");
    Expect(0, 4608, '\P{^-	in_Hangul_JAMO}', "");
    Error('\p{/a/_Jamo}');
    Error('\P{/a/_Jamo}');
    Expect(1, 4607, '\p{jamo}', "");
    Expect(0, 4607, '\p{^jamo}', "");
    Expect(0, 4607, '\P{jamo}', "");
    Expect(1, 4607, '\P{^jamo}', "");
    Expect(0, 4608, '\p{jamo}', "");
    Expect(1, 4608, '\p{^jamo}', "");
    Expect(1, 4608, '\P{jamo}', "");
    Expect(0, 4608, '\P{^jamo}', "");
    Expect(1, 4607, '\p{--jamo}', "");
    Expect(0, 4607, '\p{^--jamo}', "");
    Expect(0, 4607, '\P{--jamo}', "");
    Expect(1, 4607, '\P{^--jamo}', "");
    Expect(0, 4608, '\p{--jamo}', "");
    Expect(1, 4608, '\p{^--jamo}', "");
    Expect(1, 4608, '\P{--jamo}', "");
    Expect(0, 4608, '\P{^--jamo}', "");
    Error('\p{ :=Is_JAMO}');
    Error('\P{ :=Is_JAMO}');
    Expect(1, 4607, '\p{isjamo}', "");
    Expect(0, 4607, '\p{^isjamo}', "");
    Expect(0, 4607, '\P{isjamo}', "");
    Expect(1, 4607, '\P{^isjamo}', "");
    Expect(0, 4608, '\p{isjamo}', "");
    Expect(1, 4608, '\p{^isjamo}', "");
    Expect(1, 4608, '\P{isjamo}', "");
    Expect(0, 4608, '\P{^isjamo}', "");
    Expect(1, 4607, '\p{_ is_jamo}', "");
    Expect(0, 4607, '\p{^_ is_jamo}', "");
    Expect(0, 4607, '\P{_ is_jamo}', "");
    Expect(1, 4607, '\P{^_ is_jamo}', "");
    Expect(0, 4608, '\p{_ is_jamo}', "");
    Expect(1, 4608, '\p{^_ is_jamo}', "");
    Expect(1, 4608, '\P{_ is_jamo}', "");
    Expect(0, 4608, '\P{^_ is_jamo}', "");
    Error('\p{_	IN_jamo:=}');
    Error('\P{_	IN_jamo:=}');
    Expect(1, 4607, '\p{injamo}', "");
    Expect(0, 4607, '\p{^injamo}', "");
    Expect(0, 4607, '\P{injamo}', "");
    Expect(1, 4607, '\P{^injamo}', "");
    Expect(0, 4608, '\p{injamo}', "");
    Expect(1, 4608, '\p{^injamo}', "");
    Expect(1, 4608, '\P{injamo}', "");
    Expect(0, 4608, '\P{^injamo}', "");
    Expect(1, 4607, '\p{-In_JAMO}', "");
    Expect(0, 4607, '\p{^-In_JAMO}', "");
    Expect(0, 4607, '\P{-In_JAMO}', "");
    Expect(1, 4607, '\P{^-In_JAMO}', "");
    Expect(0, 4608, '\p{-In_JAMO}', "");
    Expect(1, 4608, '\p{^-In_JAMO}', "");
    Expect(1, 4608, '\P{-In_JAMO}', "");
    Expect(0, 4608, '\P{^-In_JAMO}', "");
    Error('\p{ /a/Hangul_Jamo_Extended_A}');
    Error('\P{ /a/Hangul_Jamo_Extended_A}');
    Expect(1, 43391, '\p{hanguljamoextendeda}', "");
    Expect(0, 43391, '\p{^hanguljamoextendeda}', "");
    Expect(0, 43391, '\P{hanguljamoextendeda}', "");
    Expect(1, 43391, '\P{^hanguljamoextendeda}', "");
    Expect(0, 43392, '\p{hanguljamoextendeda}', "");
    Expect(1, 43392, '\p{^hanguljamoextendeda}', "");
    Expect(1, 43392, '\P{hanguljamoextendeda}', "");
    Expect(0, 43392, '\P{^hanguljamoextendeda}', "");
    Expect(1, 43391, '\p{-	hangul_Jamo_Extended_A}', "");
    Expect(0, 43391, '\p{^-	hangul_Jamo_Extended_A}', "");
    Expect(0, 43391, '\P{-	hangul_Jamo_Extended_A}', "");
    Expect(1, 43391, '\P{^-	hangul_Jamo_Extended_A}', "");
    Expect(0, 43392, '\p{-	hangul_Jamo_Extended_A}', "");
    Expect(1, 43392, '\p{^-	hangul_Jamo_Extended_A}', "");
    Expect(1, 43392, '\P{-	hangul_Jamo_Extended_A}', "");
    Expect(0, 43392, '\P{^-	hangul_Jamo_Extended_A}', "");
    Error('\p{- is_Hangul_jamo_EXTENDED_A/a/}');
    Error('\P{- is_Hangul_jamo_EXTENDED_A/a/}');
    Expect(1, 43391, '\p{ishanguljamoextendeda}', "");
    Expect(0, 43391, '\p{^ishanguljamoextendeda}', "");
    Expect(0, 43391, '\P{ishanguljamoextendeda}', "");
    Expect(1, 43391, '\P{^ishanguljamoextendeda}', "");
    Expect(0, 43392, '\p{ishanguljamoextendeda}', "");
    Expect(1, 43392, '\p{^ishanguljamoextendeda}', "");
    Expect(1, 43392, '\P{ishanguljamoextendeda}', "");
    Expect(0, 43392, '\P{^ishanguljamoextendeda}', "");
    Expect(1, 43391, '\p{_Is_Hangul_JAMO_EXTENDED_a}', "");
    Expect(0, 43391, '\p{^_Is_Hangul_JAMO_EXTENDED_a}', "");
    Expect(0, 43391, '\P{_Is_Hangul_JAMO_EXTENDED_a}', "");
    Expect(1, 43391, '\P{^_Is_Hangul_JAMO_EXTENDED_a}', "");
    Expect(0, 43392, '\p{_Is_Hangul_JAMO_EXTENDED_a}', "");
    Expect(1, 43392, '\p{^_Is_Hangul_JAMO_EXTENDED_a}', "");
    Expect(1, 43392, '\P{_Is_Hangul_JAMO_EXTENDED_a}', "");
    Expect(0, 43392, '\P{^_Is_Hangul_JAMO_EXTENDED_a}', "");
    Error('\p{/a/IN_Hangul_JAMO_Extended_A}');
    Error('\P{/a/IN_Hangul_JAMO_Extended_A}');
    Expect(1, 43391, '\p{inhanguljamoextendeda}', "");
    Expect(0, 43391, '\p{^inhanguljamoextendeda}', "");
    Expect(0, 43391, '\P{inhanguljamoextendeda}', "");
    Expect(1, 43391, '\P{^inhanguljamoextendeda}', "");
    Expect(0, 43392, '\p{inhanguljamoextendeda}', "");
    Expect(1, 43392, '\p{^inhanguljamoextendeda}', "");
    Expect(1, 43392, '\P{inhanguljamoextendeda}', "");
    Expect(0, 43392, '\P{^inhanguljamoextendeda}', "");
    Expect(1, 43391, '\p{--in_hangul_Jamo_extended_a}', "");
    Expect(0, 43391, '\p{^--in_hangul_Jamo_extended_a}', "");
    Expect(0, 43391, '\P{--in_hangul_Jamo_extended_a}', "");
    Expect(1, 43391, '\P{^--in_hangul_Jamo_extended_a}', "");
    Expect(0, 43392, '\p{--in_hangul_Jamo_extended_a}', "");
    Expect(1, 43392, '\p{^--in_hangul_Jamo_extended_a}', "");
    Expect(1, 43392, '\P{--in_hangul_Jamo_extended_a}', "");
    Expect(0, 43392, '\P{^--in_hangul_Jamo_extended_a}', "");
    Error('\p{ 	jamo_Ext_a:=}');
    Error('\P{ 	jamo_Ext_a:=}');
    Expect(1, 43391, '\p{jamoexta}', "");
    Expect(0, 43391, '\p{^jamoexta}', "");
    Expect(0, 43391, '\P{jamoexta}', "");
    Expect(1, 43391, '\P{^jamoexta}', "");
    Expect(0, 43392, '\p{jamoexta}', "");
    Expect(1, 43392, '\p{^jamoexta}', "");
    Expect(1, 43392, '\P{jamoexta}', "");
    Expect(0, 43392, '\P{^jamoexta}', "");
    Expect(1, 43391, '\p{	jamo_ext_A}', "");
    Expect(0, 43391, '\p{^	jamo_ext_A}', "");
    Expect(0, 43391, '\P{	jamo_ext_A}', "");
    Expect(1, 43391, '\P{^	jamo_ext_A}', "");
    Expect(0, 43392, '\p{	jamo_ext_A}', "");
    Expect(1, 43392, '\p{^	jamo_ext_A}', "");
    Expect(1, 43392, '\P{	jamo_ext_A}', "");
    Expect(0, 43392, '\P{^	jamo_ext_A}', "");
    Error('\p{ _Is_jamo_EXT_A:=}');
    Error('\P{ _Is_jamo_EXT_A:=}');
    Expect(1, 43391, '\p{isjamoexta}', "");
    Expect(0, 43391, '\p{^isjamoexta}', "");
    Expect(0, 43391, '\P{isjamoexta}', "");
    Expect(1, 43391, '\P{^isjamoexta}', "");
    Expect(0, 43392, '\p{isjamoexta}', "");
    Expect(1, 43392, '\p{^isjamoexta}', "");
    Expect(1, 43392, '\P{isjamoexta}', "");
    Expect(0, 43392, '\P{^isjamoexta}', "");
    Expect(1, 43391, '\p{ is_Jamo_ext_a}', "");
    Expect(0, 43391, '\p{^ is_Jamo_ext_a}', "");
    Expect(0, 43391, '\P{ is_Jamo_ext_a}', "");
    Expect(1, 43391, '\P{^ is_Jamo_ext_a}', "");
    Expect(0, 43392, '\p{ is_Jamo_ext_a}', "");
    Expect(1, 43392, '\p{^ is_Jamo_ext_a}', "");
    Expect(1, 43392, '\P{ is_Jamo_ext_a}', "");
    Expect(0, 43392, '\P{^ is_Jamo_ext_a}', "");
    Error('\p{_	In_jamo_EXT_a:=}');
    Error('\P{_	In_jamo_EXT_a:=}');
    Expect(1, 43391, '\p{injamoexta}', "");
    Expect(0, 43391, '\p{^injamoexta}', "");
    Expect(0, 43391, '\P{injamoexta}', "");
    Expect(1, 43391, '\P{^injamoexta}', "");
    Expect(0, 43392, '\p{injamoexta}', "");
    Expect(1, 43392, '\p{^injamoexta}', "");
    Expect(1, 43392, '\P{injamoexta}', "");
    Expect(0, 43392, '\P{^injamoexta}', "");
    Expect(1, 43391, '\p{ -IN_jamo_ext_A}', "");
    Expect(0, 43391, '\p{^ -IN_jamo_ext_A}', "");
    Expect(0, 43391, '\P{ -IN_jamo_ext_A}', "");
    Expect(1, 43391, '\P{^ -IN_jamo_ext_A}', "");
    Expect(0, 43392, '\p{ -IN_jamo_ext_A}', "");
    Expect(1, 43392, '\p{^ -IN_jamo_ext_A}', "");
    Expect(1, 43392, '\P{ -IN_jamo_ext_A}', "");
    Expect(0, 43392, '\P{^ -IN_jamo_ext_A}', "");
    Error('\p{HANGUL_JAMO_Extended_B:=}');
    Error('\P{HANGUL_JAMO_Extended_B:=}');
    Expect(1, 55295, '\p{hanguljamoextendedb}', "");
    Expect(0, 55295, '\p{^hanguljamoextendedb}', "");
    Expect(0, 55295, '\P{hanguljamoextendedb}', "");
    Expect(1, 55295, '\P{^hanguljamoextendedb}', "");
    Expect(0, 57344, '\p{hanguljamoextendedb}', "");
    Expect(1, 57344, '\p{^hanguljamoextendedb}', "");
    Expect(1, 57344, '\P{hanguljamoextendedb}', "");
    Expect(0, 57344, '\P{^hanguljamoextendedb}', "");
    Expect(1, 55295, '\p{_HANGUL_JAMO_EXTENDED_B}', "");
    Expect(0, 55295, '\p{^_HANGUL_JAMO_EXTENDED_B}', "");
    Expect(0, 55295, '\P{_HANGUL_JAMO_EXTENDED_B}', "");
    Expect(1, 55295, '\P{^_HANGUL_JAMO_EXTENDED_B}', "");
    Expect(0, 57344, '\p{_HANGUL_JAMO_EXTENDED_B}', "");
    Expect(1, 57344, '\p{^_HANGUL_JAMO_EXTENDED_B}', "");
    Expect(1, 57344, '\P{_HANGUL_JAMO_EXTENDED_B}', "");
    Expect(0, 57344, '\P{^_HANGUL_JAMO_EXTENDED_B}', "");
    Error('\p{/a/  is_hangul_jamo_EXTENDED_B}');
    Error('\P{/a/  is_hangul_jamo_EXTENDED_B}');
    Expect(1, 55295, '\p{ishanguljamoextendedb}', "");
    Expect(0, 55295, '\p{^ishanguljamoextendedb}', "");
    Expect(0, 55295, '\P{ishanguljamoextendedb}', "");
    Expect(1, 55295, '\P{^ishanguljamoextendedb}', "");
    Expect(0, 57344, '\p{ishanguljamoextendedb}', "");
    Expect(1, 57344, '\p{^ishanguljamoextendedb}', "");
    Expect(1, 57344, '\P{ishanguljamoextendedb}', "");
    Expect(0, 57344, '\P{^ishanguljamoextendedb}', "");
    Expect(1, 55295, '\p{		is_HANGUL_jamo_Extended_B}', "");
    Expect(0, 55295, '\p{^		is_HANGUL_jamo_Extended_B}', "");
    Expect(0, 55295, '\P{		is_HANGUL_jamo_Extended_B}', "");
    Expect(1, 55295, '\P{^		is_HANGUL_jamo_Extended_B}', "");
    Expect(0, 57344, '\p{		is_HANGUL_jamo_Extended_B}', "");
    Expect(1, 57344, '\p{^		is_HANGUL_jamo_Extended_B}', "");
    Expect(1, 57344, '\P{		is_HANGUL_jamo_Extended_B}', "");
    Expect(0, 57344, '\P{^		is_HANGUL_jamo_Extended_B}', "");
    Error('\p{	-IN_Hangul_Jamo_Extended_B/a/}');
    Error('\P{	-IN_Hangul_Jamo_Extended_B/a/}');
    Expect(1, 55295, '\p{inhanguljamoextendedb}', "");
    Expect(0, 55295, '\p{^inhanguljamoextendedb}', "");
    Expect(0, 55295, '\P{inhanguljamoextendedb}', "");
    Expect(1, 55295, '\P{^inhanguljamoextendedb}', "");
    Expect(0, 57344, '\p{inhanguljamoextendedb}', "");
    Expect(1, 57344, '\p{^inhanguljamoextendedb}', "");
    Expect(1, 57344, '\P{inhanguljamoextendedb}', "");
    Expect(0, 57344, '\P{^inhanguljamoextendedb}', "");
    Expect(1, 55295, '\p{		IN_hangul_Jamo_Extended_B}', "");
    Expect(0, 55295, '\p{^		IN_hangul_Jamo_Extended_B}', "");
    Expect(0, 55295, '\P{		IN_hangul_Jamo_Extended_B}', "");
    Expect(1, 55295, '\P{^		IN_hangul_Jamo_Extended_B}', "");
    Expect(0, 57344, '\p{		IN_hangul_Jamo_Extended_B}', "");
    Expect(1, 57344, '\p{^		IN_hangul_Jamo_Extended_B}', "");
    Expect(1, 57344, '\P{		IN_hangul_Jamo_Extended_B}', "");
    Expect(0, 57344, '\P{^		IN_hangul_Jamo_Extended_B}', "");
    Error('\p{_/a/Jamo_EXT_B}');
    Error('\P{_/a/Jamo_EXT_B}');
    Expect(1, 55295, '\p{jamoextb}', "");
    Expect(0, 55295, '\p{^jamoextb}', "");
    Expect(0, 55295, '\P{jamoextb}', "");
    Expect(1, 55295, '\P{^jamoextb}', "");
    Expect(0, 57344, '\p{jamoextb}', "");
    Expect(1, 57344, '\p{^jamoextb}', "");
    Expect(1, 57344, '\P{jamoextb}', "");
    Expect(0, 57344, '\P{^jamoextb}', "");
    Expect(1, 55295, '\p{_JAMO_EXT_B}', "");
    Expect(0, 55295, '\p{^_JAMO_EXT_B}', "");
    Expect(0, 55295, '\P{_JAMO_EXT_B}', "");
    Expect(1, 55295, '\P{^_JAMO_EXT_B}', "");
    Expect(0, 57344, '\p{_JAMO_EXT_B}', "");
    Expect(1, 57344, '\p{^_JAMO_EXT_B}', "");
    Expect(1, 57344, '\P{_JAMO_EXT_B}', "");
    Expect(0, 57344, '\P{^_JAMO_EXT_B}', "");
    Error('\p{/a/Is_Jamo_Ext_b}');
    Error('\P{/a/Is_Jamo_Ext_b}');
    Expect(1, 55295, '\p{isjamoextb}', "");
    Expect(0, 55295, '\p{^isjamoextb}', "");
    Expect(0, 55295, '\P{isjamoextb}', "");
    Expect(1, 55295, '\P{^isjamoextb}', "");
    Expect(0, 57344, '\p{isjamoextb}', "");
    Expect(1, 57344, '\p{^isjamoextb}', "");
    Expect(1, 57344, '\P{isjamoextb}', "");
    Expect(0, 57344, '\P{^isjamoextb}', "");
    Expect(1, 55295, '\p{-_is_JAMO_ext_b}', "");
    Expect(0, 55295, '\p{^-_is_JAMO_ext_b}', "");
    Expect(0, 55295, '\P{-_is_JAMO_ext_b}', "");
    Expect(1, 55295, '\P{^-_is_JAMO_ext_b}', "");
    Expect(0, 57344, '\p{-_is_JAMO_ext_b}', "");
    Expect(1, 57344, '\p{^-_is_JAMO_ext_b}', "");
    Expect(1, 57344, '\P{-_is_JAMO_ext_b}', "");
    Expect(0, 57344, '\P{^-_is_JAMO_ext_b}', "");
    Error('\p{IN_Jamo_ext_b:=}');
    Error('\P{IN_Jamo_ext_b:=}');
    Expect(1, 55295, '\p{injamoextb}', "");
    Expect(0, 55295, '\p{^injamoextb}', "");
    Expect(0, 55295, '\P{injamoextb}', "");
    Expect(1, 55295, '\P{^injamoextb}', "");
    Expect(0, 57344, '\p{injamoextb}', "");
    Expect(1, 57344, '\p{^injamoextb}', "");
    Expect(1, 57344, '\P{injamoextb}', "");
    Expect(0, 57344, '\P{^injamoextb}', "");
    Expect(1, 55295, '\p{ 	In_JAMO_Ext_B}', "");
    Expect(0, 55295, '\p{^ 	In_JAMO_Ext_B}', "");
    Expect(0, 55295, '\P{ 	In_JAMO_Ext_B}', "");
    Expect(1, 55295, '\P{^ 	In_JAMO_Ext_B}', "");
    Expect(0, 57344, '\p{ 	In_JAMO_Ext_B}', "");
    Expect(1, 57344, '\p{^ 	In_JAMO_Ext_B}', "");
    Expect(1, 57344, '\P{ 	In_JAMO_Ext_B}', "");
    Expect(0, 57344, '\P{^ 	In_JAMO_Ext_B}', "");
    Error('\p{/a/	Hangul_Syllables}');
    Error('\P{/a/	Hangul_Syllables}');
    Expect(1, 55215, '\p{hangulsyllables}', "");
    Expect(0, 55215, '\p{^hangulsyllables}', "");
    Expect(0, 55215, '\P{hangulsyllables}', "");
    Expect(1, 55215, '\P{^hangulsyllables}', "");
    Expect(0, 55216, '\p{hangulsyllables}', "");
    Expect(1, 55216, '\p{^hangulsyllables}', "");
    Expect(1, 55216, '\P{hangulsyllables}', "");
    Expect(0, 55216, '\P{^hangulsyllables}', "");
    Expect(1, 55215, '\p{ HANGUL_Syllables}', "");
    Expect(0, 55215, '\p{^ HANGUL_Syllables}', "");
    Expect(0, 55215, '\P{ HANGUL_Syllables}', "");
    Expect(1, 55215, '\P{^ HANGUL_Syllables}', "");
    Expect(0, 55216, '\p{ HANGUL_Syllables}', "");
    Expect(1, 55216, '\p{^ HANGUL_Syllables}', "");
    Expect(1, 55216, '\P{ HANGUL_Syllables}', "");
    Expect(0, 55216, '\P{^ HANGUL_Syllables}', "");
    Error('\p{ :=Is_HANGUL_Syllables}');
    Error('\P{ :=Is_HANGUL_Syllables}');
    Expect(1, 55215, '\p{ishangulsyllables}', "");
    Expect(0, 55215, '\p{^ishangulsyllables}', "");
    Expect(0, 55215, '\P{ishangulsyllables}', "");
    Expect(1, 55215, '\P{^ishangulsyllables}', "");
    Expect(0, 55216, '\p{ishangulsyllables}', "");
    Expect(1, 55216, '\p{^ishangulsyllables}', "");
    Expect(1, 55216, '\P{ishangulsyllables}', "");
    Expect(0, 55216, '\P{^ishangulsyllables}', "");
    Expect(1, 55215, '\p{_ IS_HANGUL_syllables}', "");
    Expect(0, 55215, '\p{^_ IS_HANGUL_syllables}', "");
    Expect(0, 55215, '\P{_ IS_HANGUL_syllables}', "");
    Expect(1, 55215, '\P{^_ IS_HANGUL_syllables}', "");
    Expect(0, 55216, '\p{_ IS_HANGUL_syllables}', "");
    Expect(1, 55216, '\p{^_ IS_HANGUL_syllables}', "");
    Expect(1, 55216, '\P{_ IS_HANGUL_syllables}', "");
    Expect(0, 55216, '\P{^_ IS_HANGUL_syllables}', "");
    Error('\p{  In_HANGUL_Syllables/a/}');
    Error('\P{  In_HANGUL_Syllables/a/}');
    Expect(1, 55215, '\p{inhangulsyllables}', "");
    Expect(0, 55215, '\p{^inhangulsyllables}', "");
    Expect(0, 55215, '\P{inhangulsyllables}', "");
    Expect(1, 55215, '\P{^inhangulsyllables}', "");
    Expect(0, 55216, '\p{inhangulsyllables}', "");
    Expect(1, 55216, '\p{^inhangulsyllables}', "");
    Expect(1, 55216, '\P{inhangulsyllables}', "");
    Expect(0, 55216, '\P{^inhangulsyllables}', "");
    Expect(1, 55215, '\p{In_hangul_Syllables}', "");
    Expect(0, 55215, '\p{^In_hangul_Syllables}', "");
    Expect(0, 55215, '\P{In_hangul_Syllables}', "");
    Expect(1, 55215, '\P{^In_hangul_Syllables}', "");
    Expect(0, 55216, '\p{In_hangul_Syllables}', "");
    Expect(1, 55216, '\p{^In_hangul_Syllables}', "");
    Expect(1, 55216, '\P{In_hangul_Syllables}', "");
    Expect(0, 55216, '\P{^In_hangul_Syllables}', "");
    Error('\p{/a/	 In_Hangul}');
    Error('\P{/a/	 In_Hangul}');
    Expect(1, 55215, '\p{inhangul}', "");
    Expect(0, 55215, '\p{^inhangul}', "");
    Expect(0, 55215, '\P{inhangul}', "");
    Expect(1, 55215, '\P{^inhangul}', "");
    Expect(0, 55216, '\p{inhangul}', "");
    Expect(1, 55216, '\p{^inhangul}', "");
    Expect(1, 55216, '\P{inhangul}', "");
    Expect(0, 55216, '\P{^inhangul}', "");
    Expect(1, 55215, '\p{		In_hangul}', "");
    Expect(0, 55215, '\p{^		In_hangul}', "");
    Expect(0, 55215, '\P{		In_hangul}', "");
    Expect(1, 55215, '\P{^		In_hangul}', "");
    Expect(0, 55216, '\p{		In_hangul}', "");
    Expect(1, 55216, '\p{^		In_hangul}', "");
    Expect(1, 55216, '\P{		In_hangul}', "");
    Expect(0, 55216, '\P{^		In_hangul}', "");
    Error('\p{:= _Hanifi_ROHINGYA}');
    Error('\P{:= _Hanifi_ROHINGYA}');
    Expect(1, 68921, '\p{hanifirohingya}', "");
    Expect(0, 68921, '\p{^hanifirohingya}', "");
    Expect(0, 68921, '\P{hanifirohingya}', "");
    Expect(1, 68921, '\P{^hanifirohingya}', "");
    Expect(0, 68922, '\p{hanifirohingya}', "");
    Expect(1, 68922, '\p{^hanifirohingya}', "");
    Expect(1, 68922, '\P{hanifirohingya}', "");
    Expect(0, 68922, '\P{^hanifirohingya}', "");
    Expect(1, 68921, '\p{-	hanifi_ROHINGYA}', "");
    Expect(0, 68921, '\p{^-	hanifi_ROHINGYA}', "");
    Expect(0, 68921, '\P{-	hanifi_ROHINGYA}', "");
    Expect(1, 68921, '\P{^-	hanifi_ROHINGYA}', "");
    Expect(0, 68922, '\p{-	hanifi_ROHINGYA}', "");
    Expect(1, 68922, '\p{^-	hanifi_ROHINGYA}', "");
    Expect(1, 68922, '\P{-	hanifi_ROHINGYA}', "");
    Expect(0, 68922, '\P{^-	hanifi_ROHINGYA}', "");
    Error('\p{_ IS_Hanifi_ROHINGYA/a/}');
    Error('\P{_ IS_Hanifi_ROHINGYA/a/}');
    Expect(1, 68921, '\p{ishanifirohingya}', "");
    Expect(0, 68921, '\p{^ishanifirohingya}', "");
    Expect(0, 68921, '\P{ishanifirohingya}', "");
    Expect(1, 68921, '\P{^ishanifirohingya}', "");
    Expect(0, 68922, '\p{ishanifirohingya}', "");
    Expect(1, 68922, '\p{^ishanifirohingya}', "");
    Expect(1, 68922, '\P{ishanifirohingya}', "");
    Expect(0, 68922, '\P{^ishanifirohingya}', "");
    Expect(1, 68921, '\p{- Is_hanifi_ROHINGYA}', "");
    Expect(0, 68921, '\p{^- Is_hanifi_ROHINGYA}', "");
    Expect(0, 68921, '\P{- Is_hanifi_ROHINGYA}', "");
    Expect(1, 68921, '\P{^- Is_hanifi_ROHINGYA}', "");
    Expect(0, 68922, '\p{- Is_hanifi_ROHINGYA}', "");
    Expect(1, 68922, '\p{^- Is_hanifi_ROHINGYA}', "");
    Expect(1, 68922, '\P{- Is_hanifi_ROHINGYA}', "");
    Expect(0, 68922, '\P{^- Is_hanifi_ROHINGYA}', "");
    Error('\p{:=_ rohg}');
    Error('\P{:=_ rohg}');
    Expect(1, 68921, '\p{rohg}', "");
    Expect(0, 68921, '\p{^rohg}', "");
    Expect(0, 68921, '\P{rohg}', "");
    Expect(1, 68921, '\P{^rohg}', "");
    Expect(0, 68922, '\p{rohg}', "");
    Expect(1, 68922, '\p{^rohg}', "");
    Expect(1, 68922, '\P{rohg}', "");
    Expect(0, 68922, '\P{^rohg}', "");
    Expect(1, 68921, '\p{_ rohg}', "");
    Expect(0, 68921, '\p{^_ rohg}', "");
    Expect(0, 68921, '\P{_ rohg}', "");
    Expect(1, 68921, '\P{^_ rohg}', "");
    Expect(0, 68922, '\p{_ rohg}', "");
    Expect(1, 68922, '\p{^_ rohg}', "");
    Expect(1, 68922, '\P{_ rohg}', "");
    Expect(0, 68922, '\P{^_ rohg}', "");
    Error('\p{:=Is_ROHG}');
    Error('\P{:=Is_ROHG}');
    Expect(1, 68921, '\p{isrohg}', "");
    Expect(0, 68921, '\p{^isrohg}', "");
    Expect(0, 68921, '\P{isrohg}', "");
    Expect(1, 68921, '\P{^isrohg}', "");
    Expect(0, 68922, '\p{isrohg}', "");
    Expect(1, 68922, '\p{^isrohg}', "");
    Expect(1, 68922, '\P{isrohg}', "");
    Expect(0, 68922, '\P{^isrohg}', "");
    Expect(1, 68921, '\p{__IS_rohg}', "");
    Expect(0, 68921, '\p{^__IS_rohg}', "");
    Expect(0, 68921, '\P{__IS_rohg}', "");
    Expect(1, 68921, '\P{^__IS_rohg}', "");
    Expect(0, 68922, '\p{__IS_rohg}', "");
    Expect(1, 68922, '\p{^__IS_rohg}', "");
    Expect(1, 68922, '\P{__IS_rohg}', "");
    Expect(0, 68922, '\P{^__IS_rohg}', "");
    Error('\p{	Hanunoo/a/}');
    Error('\P{	Hanunoo/a/}');
    Expect(1, 5942, '\p{hanunoo}', "");
    Expect(0, 5942, '\p{^hanunoo}', "");
    Expect(0, 5942, '\P{hanunoo}', "");
    Expect(1, 5942, '\P{^hanunoo}', "");
    Expect(0, 5943, '\p{hanunoo}', "");
    Expect(1, 5943, '\p{^hanunoo}', "");
    Expect(1, 5943, '\P{hanunoo}', "");
    Expect(0, 5943, '\P{^hanunoo}', "");
    Expect(1, 5942, '\p{- hanunoo}', "");
    Expect(0, 5942, '\p{^- hanunoo}', "");
    Expect(0, 5942, '\P{- hanunoo}', "");
    Expect(1, 5942, '\P{^- hanunoo}', "");
    Expect(0, 5943, '\p{- hanunoo}', "");
    Expect(1, 5943, '\p{^- hanunoo}', "");
    Expect(1, 5943, '\P{- hanunoo}', "");
    Expect(0, 5943, '\P{^- hanunoo}', "");
    Error('\p{is_Hanunoo/a/}');
    Error('\P{is_Hanunoo/a/}');
    Expect(1, 5942, '\p{ishanunoo}', "");
    Expect(0, 5942, '\p{^ishanunoo}', "");
    Expect(0, 5942, '\P{ishanunoo}', "");
    Expect(1, 5942, '\P{^ishanunoo}', "");
    Expect(0, 5943, '\p{ishanunoo}', "");
    Expect(1, 5943, '\p{^ishanunoo}', "");
    Expect(1, 5943, '\P{ishanunoo}', "");
    Expect(0, 5943, '\P{^ishanunoo}', "");
    Expect(1, 5942, '\p{		Is_Hanunoo}', "");
    Expect(0, 5942, '\p{^		Is_Hanunoo}', "");
    Expect(0, 5942, '\P{		Is_Hanunoo}', "");
    Expect(1, 5942, '\P{^		Is_Hanunoo}', "");
    Expect(0, 5943, '\p{		Is_Hanunoo}', "");
    Expect(1, 5943, '\p{^		Is_Hanunoo}', "");
    Expect(1, 5943, '\P{		Is_Hanunoo}', "");
    Expect(0, 5943, '\P{^		Is_Hanunoo}', "");
    Error('\p{-	hano/a/}');
    Error('\P{-	hano/a/}');
    Expect(1, 5942, '\p{hano}', "");
    Expect(0, 5942, '\p{^hano}', "");
    Expect(0, 5942, '\P{hano}', "");
    Expect(1, 5942, '\P{^hano}', "");
    Expect(0, 5943, '\p{hano}', "");
    Expect(1, 5943, '\p{^hano}', "");
    Expect(1, 5943, '\P{hano}', "");
    Expect(0, 5943, '\P{^hano}', "");
    Expect(1, 5942, '\p{-hano}', "");
    Expect(0, 5942, '\p{^-hano}', "");
    Expect(0, 5942, '\P{-hano}', "");
    Expect(1, 5942, '\P{^-hano}', "");
    Expect(0, 5943, '\p{-hano}', "");
    Expect(1, 5943, '\p{^-hano}', "");
    Expect(1, 5943, '\P{-hano}', "");
    Expect(0, 5943, '\P{^-hano}', "");
    Error('\p{__is_Hano:=}');
    Error('\P{__is_Hano:=}');
    Expect(1, 5942, '\p{ishano}', "");
    Expect(0, 5942, '\p{^ishano}', "");
    Expect(0, 5942, '\P{ishano}', "");
    Expect(1, 5942, '\P{^ishano}', "");
    Expect(0, 5943, '\p{ishano}', "");
    Expect(1, 5943, '\p{^ishano}', "");
    Expect(1, 5943, '\P{ishano}', "");
    Expect(0, 5943, '\P{^ishano}', "");
    Expect(1, 5942, '\p{_	Is_HANO}', "");
    Expect(0, 5942, '\p{^_	Is_HANO}', "");
    Expect(0, 5942, '\P{_	Is_HANO}', "");
    Expect(1, 5942, '\P{^_	Is_HANO}', "");
    Expect(0, 5943, '\p{_	Is_HANO}', "");
    Expect(1, 5943, '\p{^_	Is_HANO}', "");
    Expect(1, 5943, '\P{_	Is_HANO}', "");
    Expect(0, 5943, '\P{^_	Is_HANO}', "");
    Error('\p{	:=Hatran}');
    Error('\P{	:=Hatran}');
    Expect(1, 67839, '\p{hatran}', "");
    Expect(0, 67839, '\p{^hatran}', "");
    Expect(0, 67839, '\P{hatran}', "");
    Expect(1, 67839, '\P{^hatran}', "");
    Expect(0, 67840, '\p{hatran}', "");
    Expect(1, 67840, '\p{^hatran}', "");
    Expect(1, 67840, '\P{hatran}', "");
    Expect(0, 67840, '\P{^hatran}', "");
    Expect(1, 67839, '\p{- HATRAN}', "");
    Expect(0, 67839, '\p{^- HATRAN}', "");
    Expect(0, 67839, '\P{- HATRAN}', "");
    Expect(1, 67839, '\P{^- HATRAN}', "");
    Expect(0, 67840, '\p{- HATRAN}', "");
    Expect(1, 67840, '\p{^- HATRAN}', "");
    Expect(1, 67840, '\P{- HATRAN}', "");
    Expect(0, 67840, '\P{^- HATRAN}', "");
    Error('\p{	 IS_Hatran/a/}');
    Error('\P{	 IS_Hatran/a/}');
    Expect(1, 67839, '\p{ishatran}', "");
    Expect(0, 67839, '\p{^ishatran}', "");
    Expect(0, 67839, '\P{ishatran}', "");
    Expect(1, 67839, '\P{^ishatran}', "");
    Expect(0, 67840, '\p{ishatran}', "");
    Expect(1, 67840, '\p{^ishatran}', "");
    Expect(1, 67840, '\P{ishatran}', "");
    Expect(0, 67840, '\P{^ishatran}', "");
    Expect(1, 67839, '\p{	 Is_hatran}', "");
    Expect(0, 67839, '\p{^	 Is_hatran}', "");
    Expect(0, 67839, '\P{	 Is_hatran}', "");
    Expect(1, 67839, '\P{^	 Is_hatran}', "");
    Expect(0, 67840, '\p{	 Is_hatran}', "");
    Expect(1, 67840, '\p{^	 Is_hatran}', "");
    Expect(1, 67840, '\P{	 Is_hatran}', "");
    Expect(0, 67840, '\P{^	 Is_hatran}', "");
    Error('\p{ /a/Hatr}');
    Error('\P{ /a/Hatr}');
    Expect(1, 67839, '\p{hatr}', "");
    Expect(0, 67839, '\p{^hatr}', "");
    Expect(0, 67839, '\P{hatr}', "");
    Expect(1, 67839, '\P{^hatr}', "");
    Expect(0, 67840, '\p{hatr}', "");
    Expect(1, 67840, '\p{^hatr}', "");
    Expect(1, 67840, '\P{hatr}', "");
    Expect(0, 67840, '\P{^hatr}', "");
    Expect(1, 67839, '\p{	-hatr}', "");
    Expect(0, 67839, '\p{^	-hatr}', "");
    Expect(0, 67839, '\P{	-hatr}', "");
    Expect(1, 67839, '\P{^	-hatr}', "");
    Expect(0, 67840, '\p{	-hatr}', "");
    Expect(1, 67840, '\p{^	-hatr}', "");
    Expect(1, 67840, '\P{	-hatr}', "");
    Expect(0, 67840, '\P{^	-hatr}', "");
    Error('\p{- IS_hatr/a/}');
    Error('\P{- IS_hatr/a/}');
    Expect(1, 67839, '\p{ishatr}', "");
    Expect(0, 67839, '\p{^ishatr}', "");
    Expect(0, 67839, '\P{ishatr}', "");
    Expect(1, 67839, '\P{^ishatr}', "");
    Expect(0, 67840, '\p{ishatr}', "");
    Expect(1, 67840, '\p{^ishatr}', "");
    Expect(1, 67840, '\P{ishatr}', "");
    Expect(0, 67840, '\P{^ishatr}', "");
    Expect(1, 67839, '\p{	IS_Hatr}', "");
    Expect(0, 67839, '\p{^	IS_Hatr}', "");
    Expect(0, 67839, '\P{	IS_Hatr}', "");
    Expect(1, 67839, '\P{^	IS_Hatr}', "");
    Expect(0, 67840, '\p{	IS_Hatr}', "");
    Expect(1, 67840, '\p{^	IS_Hatr}', "");
    Expect(1, 67840, '\P{	IS_Hatr}', "");
    Expect(0, 67840, '\P{^	IS_Hatr}', "");
    Error('\p{/a/-	HEBREW}');
    Error('\P{/a/-	HEBREW}');
    Expect(1, 64335, '\p{hebrew}', "");
    Expect(0, 64335, '\p{^hebrew}', "");
    Expect(0, 64335, '\P{hebrew}', "");
    Expect(1, 64335, '\P{^hebrew}', "");
    Expect(0, 64336, '\p{hebrew}', "");
    Expect(1, 64336, '\p{^hebrew}', "");
    Expect(1, 64336, '\P{hebrew}', "");
    Expect(0, 64336, '\P{^hebrew}', "");
    Expect(1, 64335, '\p{	 Hebrew}', "");
    Expect(0, 64335, '\p{^	 Hebrew}', "");
    Expect(0, 64335, '\P{	 Hebrew}', "");
    Expect(1, 64335, '\P{^	 Hebrew}', "");
    Expect(0, 64336, '\p{	 Hebrew}', "");
    Expect(1, 64336, '\p{^	 Hebrew}', "");
    Expect(1, 64336, '\P{	 Hebrew}', "");
    Expect(0, 64336, '\P{^	 Hebrew}', "");
    Error('\p{-Is_Hebrew/a/}');
    Error('\P{-Is_Hebrew/a/}');
    Expect(1, 64335, '\p{ishebrew}', "");
    Expect(0, 64335, '\p{^ishebrew}', "");
    Expect(0, 64335, '\P{ishebrew}', "");
    Expect(1, 64335, '\P{^ishebrew}', "");
    Expect(0, 64336, '\p{ishebrew}', "");
    Expect(1, 64336, '\p{^ishebrew}', "");
    Expect(1, 64336, '\P{ishebrew}', "");
    Expect(0, 64336, '\P{^ishebrew}', "");
    Expect(1, 64335, '\p{	Is_Hebrew}', "");
    Expect(0, 64335, '\p{^	Is_Hebrew}', "");
    Expect(0, 64335, '\P{	Is_Hebrew}', "");
    Expect(1, 64335, '\P{^	Is_Hebrew}', "");
    Expect(0, 64336, '\p{	Is_Hebrew}', "");
    Expect(1, 64336, '\p{^	Is_Hebrew}', "");
    Expect(1, 64336, '\P{	Is_Hebrew}', "");
    Expect(0, 64336, '\P{^	Is_Hebrew}', "");
    Error('\p{:=	-HEBR}');
    Error('\P{:=	-HEBR}');
    Expect(1, 64335, '\p{hebr}', "");
    Expect(0, 64335, '\p{^hebr}', "");
    Expect(0, 64335, '\P{hebr}', "");
    Expect(1, 64335, '\P{^hebr}', "");
    Expect(0, 64336, '\p{hebr}', "");
    Expect(1, 64336, '\p{^hebr}', "");
    Expect(1, 64336, '\P{hebr}', "");
    Expect(0, 64336, '\P{^hebr}', "");
    Expect(1, 64335, '\p{ 	Hebr}', "");
    Expect(0, 64335, '\p{^ 	Hebr}', "");
    Expect(0, 64335, '\P{ 	Hebr}', "");
    Expect(1, 64335, '\P{^ 	Hebr}', "");
    Expect(0, 64336, '\p{ 	Hebr}', "");
    Expect(1, 64336, '\p{^ 	Hebr}', "");
    Expect(1, 64336, '\P{ 	Hebr}', "");
    Expect(0, 64336, '\P{^ 	Hebr}', "");
    Error('\p{-:=is_Hebr}');
    Error('\P{-:=is_Hebr}');
    Expect(1, 64335, '\p{ishebr}', "");
    Expect(0, 64335, '\p{^ishebr}', "");
    Expect(0, 64335, '\P{ishebr}', "");
    Expect(1, 64335, '\P{^ishebr}', "");
    Expect(0, 64336, '\p{ishebr}', "");
    Expect(1, 64336, '\p{^ishebr}', "");
    Expect(1, 64336, '\P{ishebr}', "");
    Expect(0, 64336, '\P{^ishebr}', "");
    Expect(1, 64335, '\p{_ IS_Hebr}', "");
    Expect(0, 64335, '\p{^_ IS_Hebr}', "");
    Expect(0, 64335, '\P{_ IS_Hebr}', "");
    Expect(1, 64335, '\P{^_ IS_Hebr}', "");
    Expect(0, 64336, '\p{_ IS_Hebr}', "");
    Expect(1, 64336, '\p{^_ IS_Hebr}', "");
    Expect(1, 64336, '\P{_ IS_Hebr}', "");
    Expect(0, 64336, '\P{^_ IS_Hebr}', "");
    Error('\p{:=_	high_Private_Use_SURROGATES}');
    Error('\P{:=_	high_Private_Use_SURROGATES}');
    Expect(1, 56319, '\p{highprivateusesurrogates}', "");
    Expect(0, 56319, '\p{^highprivateusesurrogates}', "");
    Expect(0, 56319, '\P{highprivateusesurrogates}', "");
    Expect(1, 56319, '\P{^highprivateusesurrogates}', "");
    Expect(0, 57344, '\p{highprivateusesurrogates}', "");
    Expect(1, 57344, '\p{^highprivateusesurrogates}', "");
    Expect(1, 57344, '\P{highprivateusesurrogates}', "");
    Expect(0, 57344, '\P{^highprivateusesurrogates}', "");
    Expect(1, 56319, '\p{	-High_private_Use_SURROGATES}', "");
    Expect(0, 56319, '\p{^	-High_private_Use_SURROGATES}', "");
    Expect(0, 56319, '\P{	-High_private_Use_SURROGATES}', "");
    Expect(1, 56319, '\P{^	-High_private_Use_SURROGATES}', "");
    Expect(0, 57344, '\p{	-High_private_Use_SURROGATES}', "");
    Expect(1, 57344, '\p{^	-High_private_Use_SURROGATES}', "");
    Expect(1, 57344, '\P{	-High_private_Use_SURROGATES}', "");
    Expect(0, 57344, '\P{^	-High_private_Use_SURROGATES}', "");
    Error('\p{_-Is_high_Private_use_SURROGATES/a/}');
    Error('\P{_-Is_high_Private_use_SURROGATES/a/}');
    Expect(1, 56319, '\p{ishighprivateusesurrogates}', "");
    Expect(0, 56319, '\p{^ishighprivateusesurrogates}', "");
    Expect(0, 56319, '\P{ishighprivateusesurrogates}', "");
    Expect(1, 56319, '\P{^ishighprivateusesurrogates}', "");
    Expect(0, 57344, '\p{ishighprivateusesurrogates}', "");
    Expect(1, 57344, '\p{^ishighprivateusesurrogates}', "");
    Expect(1, 57344, '\P{ishighprivateusesurrogates}', "");
    Expect(0, 57344, '\P{^ishighprivateusesurrogates}', "");
    Expect(1, 56319, '\p{ 	is_HIGH_PRIVATE_Use_SURROGATES}', "");
    Expect(0, 56319, '\p{^ 	is_HIGH_PRIVATE_Use_SURROGATES}', "");
    Expect(0, 56319, '\P{ 	is_HIGH_PRIVATE_Use_SURROGATES}', "");
    Expect(1, 56319, '\P{^ 	is_HIGH_PRIVATE_Use_SURROGATES}', "");
    Expect(0, 57344, '\p{ 	is_HIGH_PRIVATE_Use_SURROGATES}', "");
    Expect(1, 57344, '\p{^ 	is_HIGH_PRIVATE_Use_SURROGATES}', "");
    Expect(1, 57344, '\P{ 	is_HIGH_PRIVATE_Use_SURROGATES}', "");
    Expect(0, 57344, '\P{^ 	is_HIGH_PRIVATE_Use_SURROGATES}', "");
    Error('\p{/a/In_HIGH_Private_USE_Surrogates}');
    Error('\P{/a/In_HIGH_Private_USE_Surrogates}');
    Expect(1, 56319, '\p{inhighprivateusesurrogates}', "");
    Expect(0, 56319, '\p{^inhighprivateusesurrogates}', "");
    Expect(0, 56319, '\P{inhighprivateusesurrogates}', "");
    Expect(1, 56319, '\P{^inhighprivateusesurrogates}', "");
    Expect(0, 57344, '\p{inhighprivateusesurrogates}', "");
    Expect(1, 57344, '\p{^inhighprivateusesurrogates}', "");
    Expect(1, 57344, '\P{inhighprivateusesurrogates}', "");
    Expect(0, 57344, '\P{^inhighprivateusesurrogates}', "");
    Expect(1, 56319, '\p{	in_High_PRIVATE_USE_Surrogates}', "");
    Expect(0, 56319, '\p{^	in_High_PRIVATE_USE_Surrogates}', "");
    Expect(0, 56319, '\P{	in_High_PRIVATE_USE_Surrogates}', "");
    Expect(1, 56319, '\P{^	in_High_PRIVATE_USE_Surrogates}', "");
    Expect(0, 57344, '\p{	in_High_PRIVATE_USE_Surrogates}', "");
    Expect(1, 57344, '\p{^	in_High_PRIVATE_USE_Surrogates}', "");
    Expect(1, 57344, '\P{	in_High_PRIVATE_USE_Surrogates}', "");
    Expect(0, 57344, '\P{^	in_High_PRIVATE_USE_Surrogates}', "");
    Error('\p{		High_PU_surrogates:=}');
    Error('\P{		High_PU_surrogates:=}');
    Expect(1, 56319, '\p{highpusurrogates}', "");
    Expect(0, 56319, '\p{^highpusurrogates}', "");
    Expect(0, 56319, '\P{highpusurrogates}', "");
    Expect(1, 56319, '\P{^highpusurrogates}', "");
    Expect(0, 57344, '\p{highpusurrogates}', "");
    Expect(1, 57344, '\p{^highpusurrogates}', "");
    Expect(1, 57344, '\P{highpusurrogates}', "");
    Expect(0, 57344, '\P{^highpusurrogates}', "");
    Expect(1, 56319, '\p{ high_PU_surrogates}', "");
    Expect(0, 56319, '\p{^ high_PU_surrogates}', "");
    Expect(0, 56319, '\P{ high_PU_surrogates}', "");
    Expect(1, 56319, '\P{^ high_PU_surrogates}', "");
    Expect(0, 57344, '\p{ high_PU_surrogates}', "");
    Expect(1, 57344, '\p{^ high_PU_surrogates}', "");
    Expect(1, 57344, '\P{ high_PU_surrogates}', "");
    Expect(0, 57344, '\P{^ high_PU_surrogates}', "");
    Error('\p{/a/_ Is_high_PU_Surrogates}');
    Error('\P{/a/_ Is_high_PU_Surrogates}');
    Expect(1, 56319, '\p{ishighpusurrogates}', "");
    Expect(0, 56319, '\p{^ishighpusurrogates}', "");
    Expect(0, 56319, '\P{ishighpusurrogates}', "");
    Expect(1, 56319, '\P{^ishighpusurrogates}', "");
    Expect(0, 57344, '\p{ishighpusurrogates}', "");
    Expect(1, 57344, '\p{^ishighpusurrogates}', "");
    Expect(1, 57344, '\P{ishighpusurrogates}', "");
    Expect(0, 57344, '\P{^ishighpusurrogates}', "");
    Expect(1, 56319, '\p{-Is_High_pu_SURROGATES}', "");
    Expect(0, 56319, '\p{^-Is_High_pu_SURROGATES}', "");
    Expect(0, 56319, '\P{-Is_High_pu_SURROGATES}', "");
    Expect(1, 56319, '\P{^-Is_High_pu_SURROGATES}', "");
    Expect(0, 57344, '\p{-Is_High_pu_SURROGATES}', "");
    Expect(1, 57344, '\p{^-Is_High_pu_SURROGATES}', "");
    Expect(1, 57344, '\P{-Is_High_pu_SURROGATES}', "");
    Expect(0, 57344, '\P{^-Is_High_pu_SURROGATES}', "");
    Error('\p{/a/	in_HIGH_PU_SURROGATES}');
    Error('\P{/a/	in_HIGH_PU_SURROGATES}');
    Expect(1, 56319, '\p{inhighpusurrogates}', "");
    Expect(0, 56319, '\p{^inhighpusurrogates}', "");
    Expect(0, 56319, '\P{inhighpusurrogates}', "");
    Expect(1, 56319, '\P{^inhighpusurrogates}', "");
    Expect(0, 57344, '\p{inhighpusurrogates}', "");
    Expect(1, 57344, '\p{^inhighpusurrogates}', "");
    Expect(1, 57344, '\P{inhighpusurrogates}', "");
    Expect(0, 57344, '\P{^inhighpusurrogates}', "");
    Expect(1, 56319, '\p{ _In_High_PU_Surrogates}', "");
    Expect(0, 56319, '\p{^ _In_High_PU_Surrogates}', "");
    Expect(0, 56319, '\P{ _In_High_PU_Surrogates}', "");
    Expect(1, 56319, '\P{^ _In_High_PU_Surrogates}', "");
    Expect(0, 57344, '\p{ _In_High_PU_Surrogates}', "");
    Expect(1, 57344, '\p{^ _In_High_PU_Surrogates}', "");
    Expect(1, 57344, '\P{ _In_High_PU_Surrogates}', "");
    Expect(0, 57344, '\P{^ _In_High_PU_Surrogates}', "");
    Error('\p{_high_Surrogates:=}');
    Error('\P{_high_Surrogates:=}');
    Expect(1, 56191, '\p{highsurrogates}', "");
    Expect(0, 56191, '\p{^highsurrogates}', "");
    Expect(0, 56191, '\P{highsurrogates}', "");
    Expect(1, 56191, '\P{^highsurrogates}', "");
    Expect(0, 57344, '\p{highsurrogates}', "");
    Expect(1, 57344, '\p{^highsurrogates}', "");
    Expect(1, 57344, '\P{highsurrogates}', "");
    Expect(0, 57344, '\P{^highsurrogates}', "");
    Expect(1, 56191, '\p{ 	high_surrogates}', "");
    Expect(0, 56191, '\p{^ 	high_surrogates}', "");
    Expect(0, 56191, '\P{ 	high_surrogates}', "");
    Expect(1, 56191, '\P{^ 	high_surrogates}', "");
    Expect(0, 57344, '\p{ 	high_surrogates}', "");
    Expect(1, 57344, '\p{^ 	high_surrogates}', "");
    Expect(1, 57344, '\P{ 	high_surrogates}', "");
    Expect(0, 57344, '\P{^ 	high_surrogates}', "");
    Error('\p{/a/_is_high_Surrogates}');
    Error('\P{/a/_is_high_Surrogates}');
    Expect(1, 56191, '\p{ishighsurrogates}', "");
    Expect(0, 56191, '\p{^ishighsurrogates}', "");
    Expect(0, 56191, '\P{ishighsurrogates}', "");
    Expect(1, 56191, '\P{^ishighsurrogates}', "");
    Expect(0, 57344, '\p{ishighsurrogates}', "");
    Expect(1, 57344, '\p{^ishighsurrogates}', "");
    Expect(1, 57344, '\P{ishighsurrogates}', "");
    Expect(0, 57344, '\P{^ishighsurrogates}', "");
    Expect(1, 56191, '\p{ -Is_High_surrogates}', "");
    Expect(0, 56191, '\p{^ -Is_High_surrogates}', "");
    Expect(0, 56191, '\P{ -Is_High_surrogates}', "");
    Expect(1, 56191, '\P{^ -Is_High_surrogates}', "");
    Expect(0, 57344, '\p{ -Is_High_surrogates}', "");
    Expect(1, 57344, '\p{^ -Is_High_surrogates}', "");
    Expect(1, 57344, '\P{ -Is_High_surrogates}', "");
    Expect(0, 57344, '\P{^ -Is_High_surrogates}', "");
    Error('\p{:=	In_High_surrogates}');
    Error('\P{:=	In_High_surrogates}');
    Expect(1, 56191, '\p{inhighsurrogates}', "");
    Expect(0, 56191, '\p{^inhighsurrogates}', "");
    Expect(0, 56191, '\P{inhighsurrogates}', "");
    Expect(1, 56191, '\P{^inhighsurrogates}', "");
    Expect(0, 57344, '\p{inhighsurrogates}', "");
    Expect(1, 57344, '\p{^inhighsurrogates}', "");
    Expect(1, 57344, '\P{inhighsurrogates}', "");
    Expect(0, 57344, '\P{^inhighsurrogates}', "");
    Expect(1, 56191, '\p{_ In_high_surrogates}', "");
    Expect(0, 56191, '\p{^_ In_high_surrogates}', "");
    Expect(0, 56191, '\P{_ In_high_surrogates}', "");
    Expect(1, 56191, '\P{^_ In_high_surrogates}', "");
    Expect(0, 57344, '\p{_ In_high_surrogates}', "");
    Expect(1, 57344, '\p{^_ In_high_surrogates}', "");
    Expect(1, 57344, '\P{_ In_high_surrogates}', "");
    Expect(0, 57344, '\P{^_ In_high_surrogates}', "");
    Error('\p{/a/ 	Hiragana}');
    Error('\P{/a/ 	Hiragana}');
    Expect(1, 127488, '\p{hiragana}', "");
    Expect(0, 127488, '\p{^hiragana}', "");
    Expect(0, 127488, '\P{hiragana}', "");
    Expect(1, 127488, '\P{^hiragana}', "");
    Expect(0, 127489, '\p{hiragana}', "");
    Expect(1, 127489, '\p{^hiragana}', "");
    Expect(1, 127489, '\P{hiragana}', "");
    Expect(0, 127489, '\P{^hiragana}', "");
    Expect(1, 127488, '\p{-HIRAGANA}', "");
    Expect(0, 127488, '\p{^-HIRAGANA}', "");
    Expect(0, 127488, '\P{-HIRAGANA}', "");
    Expect(1, 127488, '\P{^-HIRAGANA}', "");
    Expect(0, 127489, '\p{-HIRAGANA}', "");
    Expect(1, 127489, '\p{^-HIRAGANA}', "");
    Expect(1, 127489, '\P{-HIRAGANA}', "");
    Expect(0, 127489, '\P{^-HIRAGANA}', "");
    Error('\p{	Is_HIRAGANA:=}');
    Error('\P{	Is_HIRAGANA:=}');
    Expect(1, 127488, '\p{ishiragana}', "");
    Expect(0, 127488, '\p{^ishiragana}', "");
    Expect(0, 127488, '\P{ishiragana}', "");
    Expect(1, 127488, '\P{^ishiragana}', "");
    Expect(0, 127489, '\p{ishiragana}', "");
    Expect(1, 127489, '\p{^ishiragana}', "");
    Expect(1, 127489, '\P{ishiragana}', "");
    Expect(0, 127489, '\P{^ishiragana}', "");
    Expect(1, 127488, '\p{-	Is_Hiragana}', "");
    Expect(0, 127488, '\p{^-	Is_Hiragana}', "");
    Expect(0, 127488, '\P{-	Is_Hiragana}', "");
    Expect(1, 127488, '\P{^-	Is_Hiragana}', "");
    Expect(0, 127489, '\p{-	Is_Hiragana}', "");
    Expect(1, 127489, '\p{^-	Is_Hiragana}', "");
    Expect(1, 127489, '\P{-	Is_Hiragana}', "");
    Expect(0, 127489, '\P{^-	Is_Hiragana}', "");
    Error('\p{-_Hira:=}');
    Error('\P{-_Hira:=}');
    Expect(1, 127488, '\p{hira}', "");
    Expect(0, 127488, '\p{^hira}', "");
    Expect(0, 127488, '\P{hira}', "");
    Expect(1, 127488, '\P{^hira}', "");
    Expect(0, 127489, '\p{hira}', "");
    Expect(1, 127489, '\p{^hira}', "");
    Expect(1, 127489, '\P{hira}', "");
    Expect(0, 127489, '\P{^hira}', "");
    Expect(1, 127488, '\p{ _Hira}', "");
    Expect(0, 127488, '\p{^ _Hira}', "");
    Expect(0, 127488, '\P{ _Hira}', "");
    Expect(1, 127488, '\P{^ _Hira}', "");
    Expect(0, 127489, '\p{ _Hira}', "");
    Expect(1, 127489, '\p{^ _Hira}', "");
    Expect(1, 127489, '\P{ _Hira}', "");
    Expect(0, 127489, '\P{^ _Hira}', "");
    Error('\p{/a/_	Is_Hira}');
    Error('\P{/a/_	Is_Hira}');
    Expect(1, 127488, '\p{ishira}', "");
    Expect(0, 127488, '\p{^ishira}', "");
    Expect(0, 127488, '\P{ishira}', "");
    Expect(1, 127488, '\P{^ishira}', "");
    Expect(0, 127489, '\p{ishira}', "");
    Expect(1, 127489, '\p{^ishira}', "");
    Expect(1, 127489, '\P{ishira}', "");
    Expect(0, 127489, '\P{^ishira}', "");
    Expect(1, 127488, '\p{_	IS_Hira}', "");
    Expect(0, 127488, '\p{^_	IS_Hira}', "");
    Expect(0, 127488, '\P{_	IS_Hira}', "");
    Expect(1, 127488, '\P{^_	IS_Hira}', "");
    Expect(0, 127489, '\p{_	IS_Hira}', "");
    Expect(1, 127489, '\p{^_	IS_Hira}', "");
    Expect(1, 127489, '\P{_	IS_Hira}', "");
    Expect(0, 127489, '\P{^_	IS_Hira}', "");
    Error('\p{:=		Hyphen}');
    Error('\P{:=		Hyphen}');
    Expect(1, 65381, '\p{hyphen}', 'deprecated');
    Expect(0, 65381, '\p{^hyphen}', 'deprecated');
    Expect(0, 65381, '\P{hyphen}', 'deprecated');
    Expect(1, 65381, '\P{^hyphen}', 'deprecated');
    Expect(0, 65382, '\p{hyphen}', 'deprecated');
    Expect(1, 65382, '\p{^hyphen}', 'deprecated');
    Expect(1, 65382, '\P{hyphen}', 'deprecated');
    Expect(0, 65382, '\P{^hyphen}', 'deprecated');
    Expect(1, 65381, '\p{ -Hyphen}', 'deprecated');
    Expect(0, 65381, '\p{^ -Hyphen}', 'deprecated');
    Expect(0, 65381, '\P{ -Hyphen}', 'deprecated');
    Expect(1, 65381, '\P{^ -Hyphen}', 'deprecated');
    Expect(0, 65382, '\p{ -Hyphen}', 'deprecated');
    Expect(1, 65382, '\p{^ -Hyphen}', 'deprecated');
    Expect(1, 65382, '\P{ -Hyphen}', 'deprecated');
    Expect(0, 65382, '\P{^ -Hyphen}', 'deprecated');
    Error('\p{	/a/Is_Hyphen}');
    Error('\P{	/a/Is_Hyphen}');
    Expect(1, 65381, '\p{ishyphen}', 'deprecated');
    Expect(0, 65381, '\p{^ishyphen}', 'deprecated');
    Expect(0, 65381, '\P{ishyphen}', 'deprecated');
    Expect(1, 65381, '\P{^ishyphen}', 'deprecated');
    Expect(0, 65382, '\p{ishyphen}', 'deprecated');
    Expect(1, 65382, '\p{^ishyphen}', 'deprecated');
    Expect(1, 65382, '\P{ishyphen}', 'deprecated');
    Expect(0, 65382, '\P{^ishyphen}', 'deprecated');
    Expect(1, 65381, '\p{	IS_Hyphen}', 'deprecated');
    Expect(0, 65381, '\p{^	IS_Hyphen}', 'deprecated');
    Expect(0, 65381, '\P{	IS_Hyphen}', 'deprecated');
    Expect(1, 65381, '\P{^	IS_Hyphen}', 'deprecated');
    Expect(0, 65382, '\p{	IS_Hyphen}', 'deprecated');
    Expect(1, 65382, '\p{^	IS_Hyphen}', 'deprecated');
    Expect(1, 65382, '\P{	IS_Hyphen}', 'deprecated');
    Expect(0, 65382, '\P{^	IS_Hyphen}', 'deprecated');
    Error('\p{	-ID_CONTINUE:=}');
    Error('\P{	-ID_CONTINUE:=}');
    Expect(1, 917999, '\p{idcontinue}', "");
    Expect(0, 917999, '\p{^idcontinue}', "");
    Expect(0, 917999, '\P{idcontinue}', "");
    Expect(1, 917999, '\P{^idcontinue}', "");
    Expect(0, 918000, '\p{idcontinue}', "");
    Expect(1, 918000, '\p{^idcontinue}', "");
    Expect(1, 918000, '\P{idcontinue}', "");
    Expect(0, 918000, '\P{^idcontinue}', "");
    Expect(1, 917999, '\p{_ ID_Continue}', "");
    Expect(0, 917999, '\p{^_ ID_Continue}', "");
    Expect(0, 917999, '\P{_ ID_Continue}', "");
    Expect(1, 917999, '\P{^_ ID_Continue}', "");
    Expect(0, 918000, '\p{_ ID_Continue}', "");
    Expect(1, 918000, '\p{^_ ID_Continue}', "");
    Expect(1, 918000, '\P{_ ID_Continue}', "");
    Expect(0, 918000, '\P{^_ ID_Continue}', "");
    Error('\p{	/a/Is_ID_continue}');
    Error('\P{	/a/Is_ID_continue}');
    Expect(1, 917999, '\p{isidcontinue}', "");
    Expect(0, 917999, '\p{^isidcontinue}', "");
    Expect(0, 917999, '\P{isidcontinue}', "");
    Expect(1, 917999, '\P{^isidcontinue}', "");
    Expect(0, 918000, '\p{isidcontinue}', "");
    Expect(1, 918000, '\p{^isidcontinue}', "");
    Expect(1, 918000, '\P{isidcontinue}', "");
    Expect(0, 918000, '\P{^isidcontinue}', "");
    Expect(1, 917999, '\p{  is_ID_continue}', "");
    Expect(0, 917999, '\p{^  is_ID_continue}', "");
    Expect(0, 917999, '\P{  is_ID_continue}', "");
    Expect(1, 917999, '\P{^  is_ID_continue}', "");
    Expect(0, 918000, '\p{  is_ID_continue}', "");
    Expect(1, 918000, '\p{^  is_ID_continue}', "");
    Expect(1, 918000, '\P{  is_ID_continue}', "");
    Expect(0, 918000, '\P{^  is_ID_continue}', "");
    Error('\p{/a/_-IDC}');
    Error('\P{/a/_-IDC}');
    Expect(1, 917999, '\p{idc}', "");
    Expect(0, 917999, '\p{^idc}', "");
    Expect(0, 917999, '\P{idc}', "");
    Expect(1, 917999, '\P{^idc}', "");
    Expect(0, 918000, '\p{idc}', "");
    Expect(1, 918000, '\p{^idc}', "");
    Expect(1, 918000, '\P{idc}', "");
    Expect(0, 918000, '\P{^idc}', "");
    Expect(1, 917999, '\p{_IDC}', "");
    Expect(0, 917999, '\p{^_IDC}', "");
    Expect(0, 917999, '\P{_IDC}', "");
    Expect(1, 917999, '\P{^_IDC}', "");
    Expect(0, 918000, '\p{_IDC}', "");
    Expect(1, 918000, '\p{^_IDC}', "");
    Expect(1, 918000, '\P{_IDC}', "");
    Expect(0, 918000, '\P{^_IDC}', "");
    Error('\p{:=_IS_IDC}');
    Error('\P{:=_IS_IDC}');
    Expect(1, 917999, '\p{isidc}', "");
    Expect(0, 917999, '\p{^isidc}', "");
    Expect(0, 917999, '\P{isidc}', "");
    Expect(1, 917999, '\P{^isidc}', "");
    Expect(0, 918000, '\p{isidc}', "");
    Expect(1, 918000, '\p{^isidc}', "");
    Expect(1, 918000, '\P{isidc}', "");
    Expect(0, 918000, '\P{^isidc}', "");
    Expect(1, 917999, '\p{-_Is_IDC}', "");
    Expect(0, 917999, '\p{^-_Is_IDC}', "");
    Expect(0, 917999, '\P{-_Is_IDC}', "");
    Expect(1, 917999, '\P{^-_Is_IDC}', "");
    Expect(0, 918000, '\p{-_Is_IDC}', "");
    Expect(1, 918000, '\p{^-_Is_IDC}', "");
    Expect(1, 918000, '\P{-_Is_IDC}', "");
    Expect(0, 918000, '\P{^-_Is_IDC}', "");
    Error('\p{_ id_start:=}');
    Error('\P{_ id_start:=}');
    Expect(1, 195101, '\p{idstart}', "");
    Expect(0, 195101, '\p{^idstart}', "");
    Expect(0, 195101, '\P{idstart}', "");
    Expect(1, 195101, '\P{^idstart}', "");
    Expect(0, 195102, '\p{idstart}', "");
    Expect(1, 195102, '\p{^idstart}', "");
    Expect(1, 195102, '\P{idstart}', "");
    Expect(0, 195102, '\P{^idstart}', "");
    Expect(1, 195101, '\p{	id_START}', "");
    Expect(0, 195101, '\p{^	id_START}', "");
    Expect(0, 195101, '\P{	id_START}', "");
    Expect(1, 195101, '\P{^	id_START}', "");
    Expect(0, 195102, '\p{	id_START}', "");
    Expect(1, 195102, '\p{^	id_START}', "");
    Expect(1, 195102, '\P{	id_START}', "");
    Expect(0, 195102, '\P{^	id_START}', "");
    Error('\p{-is_ID_Start/a/}');
    Error('\P{-is_ID_Start/a/}');
    Expect(1, 195101, '\p{isidstart}', "");
    Expect(0, 195101, '\p{^isidstart}', "");
    Expect(0, 195101, '\P{isidstart}', "");
    Expect(1, 195101, '\P{^isidstart}', "");
    Expect(0, 195102, '\p{isidstart}', "");
    Expect(1, 195102, '\p{^isidstart}', "");
    Expect(1, 195102, '\P{isidstart}', "");
    Expect(0, 195102, '\P{^isidstart}', "");
    Expect(1, 195101, '\p{__Is_ID_START}', "");
    Expect(0, 195101, '\p{^__Is_ID_START}', "");
    Expect(0, 195101, '\P{__Is_ID_START}', "");
    Expect(1, 195101, '\P{^__Is_ID_START}', "");
    Expect(0, 195102, '\p{__Is_ID_START}', "");
    Expect(1, 195102, '\p{^__Is_ID_START}', "");
    Expect(1, 195102, '\P{__Is_ID_START}', "");
    Expect(0, 195102, '\P{^__Is_ID_START}', "");
    Error('\p{/a/ids}');
    Error('\P{/a/ids}');
    Expect(1, 195101, '\p{ids}', "");
    Expect(0, 195101, '\p{^ids}', "");
    Expect(0, 195101, '\P{ids}', "");
    Expect(1, 195101, '\P{^ids}', "");
    Expect(0, 195102, '\p{ids}', "");
    Expect(1, 195102, '\p{^ids}', "");
    Expect(1, 195102, '\P{ids}', "");
    Expect(0, 195102, '\P{^ids}', "");
    Expect(1, 195101, '\p{_ IDS}', "");
    Expect(0, 195101, '\p{^_ IDS}', "");
    Expect(0, 195101, '\P{_ IDS}', "");
    Expect(1, 195101, '\P{^_ IDS}', "");
    Expect(0, 195102, '\p{_ IDS}', "");
    Expect(1, 195102, '\p{^_ IDS}', "");
    Expect(1, 195102, '\P{_ IDS}', "");
    Expect(0, 195102, '\P{^_ IDS}', "");
    Error('\p{	:=IS_ids}');
    Error('\P{	:=IS_ids}');
    Expect(1, 195101, '\p{isids}', "");
    Expect(0, 195101, '\p{^isids}', "");
    Expect(0, 195101, '\P{isids}', "");
    Expect(1, 195101, '\P{^isids}', "");
    Expect(0, 195102, '\p{isids}', "");
    Expect(1, 195102, '\p{^isids}', "");
    Expect(1, 195102, '\P{isids}', "");
    Expect(0, 195102, '\P{^isids}', "");
    Expect(1, 195101, '\p{--Is_IDS}', "");
    Expect(0, 195101, '\p{^--Is_IDS}', "");
    Expect(0, 195101, '\P{--Is_IDS}', "");
    Expect(1, 195101, '\P{^--Is_IDS}', "");
    Expect(0, 195102, '\p{--Is_IDS}', "");
    Expect(1, 195102, '\p{^--Is_IDS}', "");
    Expect(1, 195102, '\P{--Is_IDS}', "");
    Expect(0, 195102, '\P{^--Is_IDS}', "");
    Error('\p{ /a/Ideographic}');
    Error('\P{ /a/Ideographic}');
    Expect(1, 195101, '\p{ideographic}', "");
    Expect(0, 195101, '\p{^ideographic}', "");
    Expect(0, 195101, '\P{ideographic}', "");
    Expect(1, 195101, '\P{^ideographic}', "");
    Expect(0, 195102, '\p{ideographic}', "");
    Expect(1, 195102, '\p{^ideographic}', "");
    Expect(1, 195102, '\P{ideographic}', "");
    Expect(0, 195102, '\P{^ideographic}', "");
    Expect(1, 195101, '\p{-Ideographic}', "");
    Expect(0, 195101, '\p{^-Ideographic}', "");
    Expect(0, 195101, '\P{-Ideographic}', "");
    Expect(1, 195101, '\P{^-Ideographic}', "");
    Expect(0, 195102, '\p{-Ideographic}', "");
    Expect(1, 195102, '\p{^-Ideographic}', "");
    Expect(1, 195102, '\P{-Ideographic}', "");
    Expect(0, 195102, '\P{^-Ideographic}', "");
    Error('\p{/a/__Is_Ideographic}');
    Error('\P{/a/__Is_Ideographic}');
    Expect(1, 195101, '\p{isideographic}', "");
    Expect(0, 195101, '\p{^isideographic}', "");
    Expect(0, 195101, '\P{isideographic}', "");
    Expect(1, 195101, '\P{^isideographic}', "");
    Expect(0, 195102, '\p{isideographic}', "");
    Expect(1, 195102, '\p{^isideographic}', "");
    Expect(1, 195102, '\P{isideographic}', "");
    Expect(0, 195102, '\P{^isideographic}', "");
    Expect(1, 195101, '\p{-Is_ideographic}', "");
    Expect(0, 195101, '\p{^-Is_ideographic}', "");
    Expect(0, 195101, '\P{-Is_ideographic}', "");
    Expect(1, 195101, '\P{^-Is_ideographic}', "");
    Expect(0, 195102, '\p{-Is_ideographic}', "");
    Expect(1, 195102, '\p{^-Is_ideographic}', "");
    Expect(1, 195102, '\P{-Is_ideographic}', "");
    Expect(0, 195102, '\P{^-Is_ideographic}', "");
    Error('\p{--Ideo:=}');
    Error('\P{--Ideo:=}');
    Expect(1, 195101, '\p{ideo}', "");
    Expect(0, 195101, '\p{^ideo}', "");
    Expect(0, 195101, '\P{ideo}', "");
    Expect(1, 195101, '\P{^ideo}', "");
    Expect(0, 195102, '\p{ideo}', "");
    Expect(1, 195102, '\p{^ideo}', "");
    Expect(1, 195102, '\P{ideo}', "");
    Expect(0, 195102, '\P{^ideo}', "");
    Expect(1, 195101, '\p{  IDEO}', "");
    Expect(0, 195101, '\p{^  IDEO}', "");
    Expect(0, 195101, '\P{  IDEO}', "");
    Expect(1, 195101, '\P{^  IDEO}', "");
    Expect(0, 195102, '\p{  IDEO}', "");
    Expect(1, 195102, '\p{^  IDEO}', "");
    Expect(1, 195102, '\P{  IDEO}', "");
    Expect(0, 195102, '\P{^  IDEO}', "");
    Error('\p{/a/_Is_Ideo}');
    Error('\P{/a/_Is_Ideo}');
    Expect(1, 195101, '\p{isideo}', "");
    Expect(0, 195101, '\p{^isideo}', "");
    Expect(0, 195101, '\P{isideo}', "");
    Expect(1, 195101, '\P{^isideo}', "");
    Expect(0, 195102, '\p{isideo}', "");
    Expect(1, 195102, '\p{^isideo}', "");
    Expect(1, 195102, '\P{isideo}', "");
    Expect(0, 195102, '\P{^isideo}', "");
    Expect(1, 195101, '\p{-IS_ideo}', "");
    Expect(0, 195101, '\p{^-IS_ideo}', "");
    Expect(0, 195101, '\P{-IS_ideo}', "");
    Expect(1, 195101, '\P{^-IS_ideo}', "");
    Expect(0, 195102, '\p{-IS_ideo}', "");
    Expect(1, 195102, '\p{^-IS_ideo}', "");
    Expect(1, 195102, '\P{-IS_ideo}', "");
    Expect(0, 195102, '\P{^-IS_ideo}', "");
    Error('\p{:= IDEOGRAPHIC_Description_CHARACTERS}');
    Error('\P{:= IDEOGRAPHIC_Description_CHARACTERS}');
    Expect(1, 12287, '\p{ideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\p{^ideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\P{ideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\P{^ideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\p{ideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\p{^ideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\P{ideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\P{^ideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\p{-Ideographic_DESCRIPTION_Characters}', "");
    Expect(0, 12287, '\p{^-Ideographic_DESCRIPTION_Characters}', "");
    Expect(0, 12287, '\P{-Ideographic_DESCRIPTION_Characters}', "");
    Expect(1, 12287, '\P{^-Ideographic_DESCRIPTION_Characters}', "");
    Expect(0, 12288, '\p{-Ideographic_DESCRIPTION_Characters}', "");
    Expect(1, 12288, '\p{^-Ideographic_DESCRIPTION_Characters}', "");
    Expect(1, 12288, '\P{-Ideographic_DESCRIPTION_Characters}', "");
    Expect(0, 12288, '\P{^-Ideographic_DESCRIPTION_Characters}', "");
    Error('\p{	/a/Is_IDEOGRAPHIC_Description_characters}');
    Error('\P{	/a/Is_IDEOGRAPHIC_Description_characters}');
    Expect(1, 12287, '\p{isideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\p{^isideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\P{isideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\P{^isideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\p{isideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\p{^isideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\P{isideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\P{^isideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\p{_Is_Ideographic_DESCRIPTION_CHARACTERS}', "");
    Expect(0, 12287, '\p{^_Is_Ideographic_DESCRIPTION_CHARACTERS}', "");
    Expect(0, 12287, '\P{_Is_Ideographic_DESCRIPTION_CHARACTERS}', "");
    Expect(1, 12287, '\P{^_Is_Ideographic_DESCRIPTION_CHARACTERS}', "");
    Expect(0, 12288, '\p{_Is_Ideographic_DESCRIPTION_CHARACTERS}', "");
    Expect(1, 12288, '\p{^_Is_Ideographic_DESCRIPTION_CHARACTERS}', "");
    Expect(1, 12288, '\P{_Is_Ideographic_DESCRIPTION_CHARACTERS}', "");
    Expect(0, 12288, '\P{^_Is_Ideographic_DESCRIPTION_CHARACTERS}', "");
    Error('\p{	:=in_Ideographic_description_Characters}');
    Error('\P{	:=in_Ideographic_description_Characters}');
    Expect(1, 12287, '\p{inideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\p{^inideographicdescriptioncharacters}', "");
    Expect(0, 12287, '\P{inideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\P{^inideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\p{inideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\p{^inideographicdescriptioncharacters}', "");
    Expect(1, 12288, '\P{inideographicdescriptioncharacters}', "");
    Expect(0, 12288, '\P{^inideographicdescriptioncharacters}', "");
    Expect(1, 12287, '\p{-	In_Ideographic_description_Characters}', "");
    Expect(0, 12287, '\p{^-	In_Ideographic_description_Characters}', "");
    Expect(0, 12287, '\P{-	In_Ideographic_description_Characters}', "");
    Expect(1, 12287, '\P{^-	In_Ideographic_description_Characters}', "");
    Expect(0, 12288, '\p{-	In_Ideographic_description_Characters}', "");
    Expect(1, 12288, '\p{^-	In_Ideographic_description_Characters}', "");
    Expect(1, 12288, '\P{-	In_Ideographic_description_Characters}', "");
    Expect(0, 12288, '\P{^-	In_Ideographic_description_Characters}', "");
    Error('\p{	_IN_idc/a/}');
    Error('\P{	_IN_idc/a/}');
    Expect(1, 12287, '\p{inidc}', "");
    Expect(0, 12287, '\p{^inidc}', "");
    Expect(0, 12287, '\P{inidc}', "");
    Expect(1, 12287, '\P{^inidc}', "");
    Expect(0, 12288, '\p{inidc}', "");
    Expect(1, 12288, '\p{^inidc}', "");
    Expect(1, 12288, '\P{inidc}', "");
    Expect(0, 12288, '\P{^inidc}', "");
    Expect(1, 12287, '\p{	-In_IDC}', "");
    Expect(0, 12287, '\p{^	-In_IDC}', "");
    Expect(0, 12287, '\P{	-In_IDC}', "");
    Expect(1, 12287, '\P{^	-In_IDC}', "");
    Expect(0, 12288, '\p{	-In_IDC}', "");
    Expect(1, 12288, '\p{^	-In_IDC}', "");
    Expect(1, 12288, '\P{	-In_IDC}', "");
    Expect(0, 12288, '\P{^	-In_IDC}', "");
    Error('\p{:= _Ideographic_Symbols_and_Punctuation}');
    Error('\P{:= _Ideographic_Symbols_and_Punctuation}');
    Expect(1, 94207, '\p{ideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\p{^ideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\P{ideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\P{^ideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\p{ideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\p{^ideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\P{ideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\P{^ideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\p{ 	Ideographic_SYMBOLS_AND_punctuation}', "");
    Expect(0, 94207, '\p{^ 	Ideographic_SYMBOLS_AND_punctuation}', "");
    Expect(0, 94207, '\P{ 	Ideographic_SYMBOLS_AND_punctuation}', "");
    Expect(1, 94207, '\P{^ 	Ideographic_SYMBOLS_AND_punctuation}', "");
    Expect(0, 94208, '\p{ 	Ideographic_SYMBOLS_AND_punctuation}', "");
    Expect(1, 94208, '\p{^ 	Ideographic_SYMBOLS_AND_punctuation}', "");
    Expect(1, 94208, '\P{ 	Ideographic_SYMBOLS_AND_punctuation}', "");
    Expect(0, 94208, '\P{^ 	Ideographic_SYMBOLS_AND_punctuation}', "");
    Error('\p{:=-_Is_Ideographic_SYMBOLS_And_Punctuation}');
    Error('\P{:=-_Is_Ideographic_SYMBOLS_And_Punctuation}');
    Expect(1, 94207, '\p{isideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\p{^isideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\P{isideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\P{^isideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\p{isideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\p{^isideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\P{isideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\P{^isideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\p{_	Is_ideographic_SYMBOLS_AND_punctuation}', "");
    Expect(0, 94207, '\p{^_	Is_ideographic_SYMBOLS_AND_punctuation}', "");
    Expect(0, 94207, '\P{_	Is_ideographic_SYMBOLS_AND_punctuation}', "");
    Expect(1, 94207, '\P{^_	Is_ideographic_SYMBOLS_AND_punctuation}', "");
    Expect(0, 94208, '\p{_	Is_ideographic_SYMBOLS_AND_punctuation}', "");
    Expect(1, 94208, '\p{^_	Is_ideographic_SYMBOLS_AND_punctuation}', "");
    Expect(1, 94208, '\P{_	Is_ideographic_SYMBOLS_AND_punctuation}', "");
    Expect(0, 94208, '\P{^_	Is_ideographic_SYMBOLS_AND_punctuation}', "");
    Error('\p{		In_IDEOGRAPHIC_SYMBOLS_And_PUNCTUATION:=}');
    Error('\P{		In_IDEOGRAPHIC_SYMBOLS_And_PUNCTUATION:=}');
    Expect(1, 94207, '\p{inideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\p{^inideographicsymbolsandpunctuation}', "");
    Expect(0, 94207, '\P{inideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\P{^inideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\p{inideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\p{^inideographicsymbolsandpunctuation}', "");
    Expect(1, 94208, '\P{inideographicsymbolsandpunctuation}', "");
    Expect(0, 94208, '\P{^inideographicsymbolsandpunctuation}', "");
    Expect(1, 94207, '\p{	-In_IDEOGRAPHIC_Symbols_AND_PUNCTUATION}', "");
    Expect(0, 94207, '\p{^	-In_IDEOGRAPHIC_Symbols_AND_PUNCTUATION}', "");
    Expect(0, 94207, '\P{	-In_IDEOGRAPHIC_Symbols_AND_PUNCTUATION}', "");
    Expect(1, 94207, '\P{^	-In_IDEOGRAPHIC_Symbols_AND_PUNCTUATION}', "");
    Expect(0, 94208, '\p{	-In_IDEOGRAPHIC_Symbols_AND_PUNCTUATION}', "");
    Expect(1, 94208, '\p{^	-In_IDEOGRAPHIC_Symbols_AND_PUNCTUATION}', "");
    Expect(1, 94208, '\P{	-In_IDEOGRAPHIC_Symbols_AND_PUNCTUATION}', "");
    Expect(0, 94208, '\P{^	-In_IDEOGRAPHIC_Symbols_AND_PUNCTUATION}', "");
    Error('\p{:=		Ideographic_SYMBOLS}');
    Error('\P{:=		Ideographic_SYMBOLS}');
    Expect(1, 94207, '\p{ideographicsymbols}', "");
    Expect(0, 94207, '\p{^ideographicsymbols}', "");
    Expect(0, 94207, '\P{ideographicsymbols}', "");
    Expect(1, 94207, '\P{^ideographicsymbols}', "");
    Expect(0, 94208, '\p{ideographicsymbols}', "");
    Expect(1, 94208, '\p{^ideographicsymbols}', "");
    Expect(1, 94208, '\P{ideographicsymbols}', "");
    Expect(0, 94208, '\P{^ideographicsymbols}', "");
    Expect(1, 94207, '\p{	 IDEOGRAPHIC_SYMBOLS}', "");
    Expect(0, 94207, '\p{^	 IDEOGRAPHIC_SYMBOLS}', "");
    Expect(0, 94207, '\P{	 IDEOGRAPHIC_SYMBOLS}', "");
    Expect(1, 94207, '\P{^	 IDEOGRAPHIC_SYMBOLS}', "");
    Expect(0, 94208, '\p{	 IDEOGRAPHIC_SYMBOLS}', "");
    Expect(1, 94208, '\p{^	 IDEOGRAPHIC_SYMBOLS}', "");
    Expect(1, 94208, '\P{	 IDEOGRAPHIC_SYMBOLS}', "");
    Expect(0, 94208, '\P{^	 IDEOGRAPHIC_SYMBOLS}', "");
    Error('\p{  is_IDEOGRAPHIC_Symbols:=}');
    Error('\P{  is_IDEOGRAPHIC_Symbols:=}');
    Expect(1, 94207, '\p{isideographicsymbols}', "");
    Expect(0, 94207, '\p{^isideographicsymbols}', "");
    Expect(0, 94207, '\P{isideographicsymbols}', "");
    Expect(1, 94207, '\P{^isideographicsymbols}', "");
    Expect(0, 94208, '\p{isideographicsymbols}', "");
    Expect(1, 94208, '\p{^isideographicsymbols}', "");
    Expect(1, 94208, '\P{isideographicsymbols}', "");
    Expect(0, 94208, '\P{^isideographicsymbols}', "");
    Expect(1, 94207, '\p{_is_Ideographic_Symbols}', "");
    Expect(0, 94207, '\p{^_is_Ideographic_Symbols}', "");
    Expect(0, 94207, '\P{_is_Ideographic_Symbols}', "");
    Expect(1, 94207, '\P{^_is_Ideographic_Symbols}', "");
    Expect(0, 94208, '\p{_is_Ideographic_Symbols}', "");
    Expect(1, 94208, '\p{^_is_Ideographic_Symbols}', "");
    Expect(1, 94208, '\P{_is_Ideographic_Symbols}', "");
    Expect(0, 94208, '\P{^_is_Ideographic_Symbols}', "");
    Error('\p{	-in_Ideographic_SYMBOLS/a/}');
    Error('\P{	-in_Ideographic_SYMBOLS/a/}');
    Expect(1, 94207, '\p{inideographicsymbols}', "");
    Expect(0, 94207, '\p{^inideographicsymbols}', "");
    Expect(0, 94207, '\P{inideographicsymbols}', "");
    Expect(1, 94207, '\P{^inideographicsymbols}', "");
    Expect(0, 94208, '\p{inideographicsymbols}', "");
    Expect(1, 94208, '\p{^inideographicsymbols}', "");
    Expect(1, 94208, '\P{inideographicsymbols}', "");
    Expect(0, 94208, '\P{^inideographicsymbols}', "");
    Expect(1, 94207, '\p{-In_Ideographic_symbols}', "");
    Expect(0, 94207, '\p{^-In_Ideographic_symbols}', "");
    Expect(0, 94207, '\P{-In_Ideographic_symbols}', "");
    Expect(1, 94207, '\P{^-In_Ideographic_symbols}', "");
    Expect(0, 94208, '\p{-In_Ideographic_symbols}', "");
    Expect(1, 94208, '\p{^-In_Ideographic_symbols}', "");
    Expect(1, 94208, '\P{-In_Ideographic_symbols}', "");
    Expect(0, 94208, '\P{^-In_Ideographic_symbols}', "");
    Error('\p{/a/  ids_BINARY_Operator}');
    Error('\P{/a/  ids_BINARY_Operator}');
    Expect(1, 12283, '\p{idsbinaryoperator}', "");
    Expect(0, 12283, '\p{^idsbinaryoperator}', "");
    Expect(0, 12283, '\P{idsbinaryoperator}', "");
    Expect(1, 12283, '\P{^idsbinaryoperator}', "");
    Expect(0, 12284, '\p{idsbinaryoperator}', "");
    Expect(1, 12284, '\p{^idsbinaryoperator}', "");
    Expect(1, 12284, '\P{idsbinaryoperator}', "");
    Expect(0, 12284, '\P{^idsbinaryoperator}', "");
    Expect(1, 12283, '\p{ _ids_binary_Operator}', "");
    Expect(0, 12283, '\p{^ _ids_binary_Operator}', "");
    Expect(0, 12283, '\P{ _ids_binary_Operator}', "");
    Expect(1, 12283, '\P{^ _ids_binary_Operator}', "");
    Expect(0, 12284, '\p{ _ids_binary_Operator}', "");
    Expect(1, 12284, '\p{^ _ids_binary_Operator}', "");
    Expect(1, 12284, '\P{ _ids_binary_Operator}', "");
    Expect(0, 12284, '\P{^ _ids_binary_Operator}', "");
    Error('\p{:=	is_IDS_BINARY_Operator}');
    Error('\P{:=	is_IDS_BINARY_Operator}');
    Expect(1, 12283, '\p{isidsbinaryoperator}', "");
    Expect(0, 12283, '\p{^isidsbinaryoperator}', "");
    Expect(0, 12283, '\P{isidsbinaryoperator}', "");
    Expect(1, 12283, '\P{^isidsbinaryoperator}', "");
    Expect(0, 12284, '\p{isidsbinaryoperator}', "");
    Expect(1, 12284, '\p{^isidsbinaryoperator}', "");
    Expect(1, 12284, '\P{isidsbinaryoperator}', "");
    Expect(0, 12284, '\P{^isidsbinaryoperator}', "");
    Expect(1, 12283, '\p{	is_IDS_Binary_OPERATOR}', "");
    Expect(0, 12283, '\p{^	is_IDS_Binary_OPERATOR}', "");
    Expect(0, 12283, '\P{	is_IDS_Binary_OPERATOR}', "");
    Expect(1, 12283, '\P{^	is_IDS_Binary_OPERATOR}', "");
    Expect(0, 12284, '\p{	is_IDS_Binary_OPERATOR}', "");
    Expect(1, 12284, '\p{^	is_IDS_Binary_OPERATOR}', "");
    Expect(1, 12284, '\P{	is_IDS_Binary_OPERATOR}', "");
    Expect(0, 12284, '\P{^	is_IDS_Binary_OPERATOR}', "");
    Error('\p{-IDSB/a/}');
    Error('\P{-IDSB/a/}');
    Expect(1, 12283, '\p{idsb}', "");
    Expect(0, 12283, '\p{^idsb}', "");
    Expect(0, 12283, '\P{idsb}', "");
    Expect(1, 12283, '\P{^idsb}', "");
    Expect(0, 12284, '\p{idsb}', "");
    Expect(1, 12284, '\p{^idsb}', "");
    Expect(1, 12284, '\P{idsb}', "");
    Expect(0, 12284, '\P{^idsb}', "");
    Expect(1, 12283, '\p{	-IDSB}', "");
    Expect(0, 12283, '\p{^	-IDSB}', "");
    Expect(0, 12283, '\P{	-IDSB}', "");
    Expect(1, 12283, '\P{^	-IDSB}', "");
    Expect(0, 12284, '\p{	-IDSB}', "");
    Expect(1, 12284, '\p{^	-IDSB}', "");
    Expect(1, 12284, '\P{	-IDSB}', "");
    Expect(0, 12284, '\P{^	-IDSB}', "");
    Error('\p{/a/_	Is_IDSB}');
    Error('\P{/a/_	Is_IDSB}');
    Expect(1, 12283, '\p{isidsb}', "");
    Expect(0, 12283, '\p{^isidsb}', "");
    Expect(0, 12283, '\P{isidsb}', "");
    Expect(1, 12283, '\P{^isidsb}', "");
    Expect(0, 12284, '\p{isidsb}', "");
    Expect(1, 12284, '\p{^isidsb}', "");
    Expect(1, 12284, '\P{isidsb}', "");
    Expect(0, 12284, '\P{^isidsb}', "");
    Expect(1, 12283, '\p{	Is_idsb}', "");
    Expect(0, 12283, '\p{^	Is_idsb}', "");
    Expect(0, 12283, '\P{	Is_idsb}', "");
    Expect(1, 12283, '\P{^	Is_idsb}', "");
    Expect(0, 12284, '\p{	Is_idsb}', "");
    Expect(1, 12284, '\p{^	Is_idsb}', "");
    Expect(1, 12284, '\P{	Is_idsb}', "");
    Expect(0, 12284, '\P{^	Is_idsb}', "");
    Error('\p{/a/--IDS_Trinary_Operator}');
    Error('\P{/a/--IDS_Trinary_Operator}');
    Expect(1, 12275, '\p{idstrinaryoperator}', "");
    Expect(0, 12275, '\p{^idstrinaryoperator}', "");
    Expect(0, 12275, '\P{idstrinaryoperator}', "");
    Expect(1, 12275, '\P{^idstrinaryoperator}', "");
    Expect(0, 12276, '\p{idstrinaryoperator}', "");
    Expect(1, 12276, '\p{^idstrinaryoperator}', "");
    Expect(1, 12276, '\P{idstrinaryoperator}', "");
    Expect(0, 12276, '\P{^idstrinaryoperator}', "");
    Expect(1, 12275, '\p{-IDS_TRINARY_operator}', "");
    Expect(0, 12275, '\p{^-IDS_TRINARY_operator}', "");
    Expect(0, 12275, '\P{-IDS_TRINARY_operator}', "");
    Expect(1, 12275, '\P{^-IDS_TRINARY_operator}', "");
    Expect(0, 12276, '\p{-IDS_TRINARY_operator}', "");
    Expect(1, 12276, '\p{^-IDS_TRINARY_operator}', "");
    Expect(1, 12276, '\P{-IDS_TRINARY_operator}', "");
    Expect(0, 12276, '\P{^-IDS_TRINARY_operator}', "");
    Error('\p{:=-Is_IDS_TRINARY_OPERATOR}');
    Error('\P{:=-Is_IDS_TRINARY_OPERATOR}');
    Expect(1, 12275, '\p{isidstrinaryoperator}', "");
    Expect(0, 12275, '\p{^isidstrinaryoperator}', "");
    Expect(0, 12275, '\P{isidstrinaryoperator}', "");
    Expect(1, 12275, '\P{^isidstrinaryoperator}', "");
    Expect(0, 12276, '\p{isidstrinaryoperator}', "");
    Expect(1, 12276, '\p{^isidstrinaryoperator}', "");
    Expect(1, 12276, '\P{isidstrinaryoperator}', "");
    Expect(0, 12276, '\P{^isidstrinaryoperator}', "");
    Expect(1, 12275, '\p{ IS_IDS_Trinary_Operator}', "");
    Expect(0, 12275, '\p{^ IS_IDS_Trinary_Operator}', "");
    Expect(0, 12275, '\P{ IS_IDS_Trinary_Operator}', "");
    Expect(1, 12275, '\P{^ IS_IDS_Trinary_Operator}', "");
    Expect(0, 12276, '\p{ IS_IDS_Trinary_Operator}', "");
    Expect(1, 12276, '\p{^ IS_IDS_Trinary_Operator}', "");
    Expect(1, 12276, '\P{ IS_IDS_Trinary_Operator}', "");
    Expect(0, 12276, '\P{^ IS_IDS_Trinary_Operator}', "");
    Error('\p{/a/-_IDST}');
    Error('\P{/a/-_IDST}');
    Expect(1, 12275, '\p{idst}', "");
    Expect(0, 12275, '\p{^idst}', "");
    Expect(0, 12275, '\P{idst}', "");
    Expect(1, 12275, '\P{^idst}', "");
    Expect(0, 12276, '\p{idst}', "");
    Expect(1, 12276, '\p{^idst}', "");
    Expect(1, 12276, '\P{idst}', "");
    Expect(0, 12276, '\P{^idst}', "");
    Expect(1, 12275, '\p{  IDST}', "");
    Expect(0, 12275, '\p{^  IDST}', "");
    Expect(0, 12275, '\P{  IDST}', "");
    Expect(1, 12275, '\P{^  IDST}', "");
    Expect(0, 12276, '\p{  IDST}', "");
    Expect(1, 12276, '\p{^  IDST}', "");
    Expect(1, 12276, '\P{  IDST}', "");
    Expect(0, 12276, '\P{^  IDST}', "");
    Error('\p{-:=Is_IDST}');
    Error('\P{-:=Is_IDST}');
    Expect(1, 12275, '\p{isidst}', "");
    Expect(0, 12275, '\p{^isidst}', "");
    Expect(0, 12275, '\P{isidst}', "");
    Expect(1, 12275, '\P{^isidst}', "");
    Expect(0, 12276, '\p{isidst}', "");
    Expect(1, 12276, '\p{^isidst}', "");
    Expect(1, 12276, '\P{isidst}', "");
    Expect(0, 12276, '\P{^isidst}', "");
    Expect(1, 12275, '\p{- IS_idst}', "");
    Expect(0, 12275, '\p{^- IS_idst}', "");
    Expect(0, 12275, '\P{- IS_idst}', "");
    Expect(1, 12275, '\P{^- IS_idst}', "");
    Expect(0, 12276, '\p{- IS_idst}', "");
    Expect(1, 12276, '\p{^- IS_idst}', "");
    Expect(1, 12276, '\P{- IS_idst}', "");
    Expect(0, 12276, '\P{^- IS_idst}', "");
    Error('\p{	 Imperial_Aramaic/a/}');
    Error('\P{	 Imperial_Aramaic/a/}');
    Expect(1, 67679, '\p{imperialaramaic}', "");
    Expect(0, 67679, '\p{^imperialaramaic}', "");
    Expect(0, 67679, '\P{imperialaramaic}', "");
    Expect(1, 67679, '\P{^imperialaramaic}', "");
    Expect(0, 67680, '\p{imperialaramaic}', "");
    Expect(1, 67680, '\p{^imperialaramaic}', "");
    Expect(1, 67680, '\P{imperialaramaic}', "");
    Expect(0, 67680, '\P{^imperialaramaic}', "");
    Expect(1, 67679, '\p{  Imperial_aramaic}', "");
    Expect(0, 67679, '\p{^  Imperial_aramaic}', "");
    Expect(0, 67679, '\P{  Imperial_aramaic}', "");
    Expect(1, 67679, '\P{^  Imperial_aramaic}', "");
    Expect(0, 67680, '\p{  Imperial_aramaic}', "");
    Expect(1, 67680, '\p{^  Imperial_aramaic}', "");
    Expect(1, 67680, '\P{  Imperial_aramaic}', "");
    Expect(0, 67680, '\P{^  Imperial_aramaic}', "");
    Error('\p{_/a/Is_imperial_aramaic}');
    Error('\P{_/a/Is_imperial_aramaic}');
    Expect(1, 67679, '\p{isimperialaramaic}', "");
    Expect(0, 67679, '\p{^isimperialaramaic}', "");
    Expect(0, 67679, '\P{isimperialaramaic}', "");
    Expect(1, 67679, '\P{^isimperialaramaic}', "");
    Expect(0, 67680, '\p{isimperialaramaic}', "");
    Expect(1, 67680, '\p{^isimperialaramaic}', "");
    Expect(1, 67680, '\P{isimperialaramaic}', "");
    Expect(0, 67680, '\P{^isimperialaramaic}', "");
    Expect(1, 67679, '\p{		IS_Imperial_aramaic}', "");
    Expect(0, 67679, '\p{^		IS_Imperial_aramaic}', "");
    Expect(0, 67679, '\P{		IS_Imperial_aramaic}', "");
    Expect(1, 67679, '\P{^		IS_Imperial_aramaic}', "");
    Expect(0, 67680, '\p{		IS_Imperial_aramaic}', "");
    Expect(1, 67680, '\p{^		IS_Imperial_aramaic}', "");
    Expect(1, 67680, '\P{		IS_Imperial_aramaic}', "");
    Expect(0, 67680, '\P{^		IS_Imperial_aramaic}', "");
    Error('\p{:=		armi}');
    Error('\P{:=		armi}');
    Expect(1, 67679, '\p{armi}', "");
    Expect(0, 67679, '\p{^armi}', "");
    Expect(0, 67679, '\P{armi}', "");
    Expect(1, 67679, '\P{^armi}', "");
    Expect(0, 67680, '\p{armi}', "");
    Expect(1, 67680, '\p{^armi}', "");
    Expect(1, 67680, '\P{armi}', "");
    Expect(0, 67680, '\P{^armi}', "");
    Expect(1, 67679, '\p{_Armi}', "");
    Expect(0, 67679, '\p{^_Armi}', "");
    Expect(0, 67679, '\P{_Armi}', "");
    Expect(1, 67679, '\P{^_Armi}', "");
    Expect(0, 67680, '\p{_Armi}', "");
    Expect(1, 67680, '\p{^_Armi}', "");
    Expect(1, 67680, '\P{_Armi}', "");
    Expect(0, 67680, '\P{^_Armi}', "");
    Error('\p{_/a/Is_Armi}');
    Error('\P{_/a/Is_Armi}');
    Expect(1, 67679, '\p{isarmi}', "");
    Expect(0, 67679, '\p{^isarmi}', "");
    Expect(0, 67679, '\P{isarmi}', "");
    Expect(1, 67679, '\P{^isarmi}', "");
    Expect(0, 67680, '\p{isarmi}', "");
    Expect(1, 67680, '\p{^isarmi}', "");
    Expect(1, 67680, '\P{isarmi}', "");
    Expect(0, 67680, '\P{^isarmi}', "");
    Expect(1, 67679, '\p{__Is_ARMI}', "");
    Expect(0, 67679, '\p{^__Is_ARMI}', "");
    Expect(0, 67679, '\P{__Is_ARMI}', "");
    Expect(1, 67679, '\P{^__Is_ARMI}', "");
    Expect(0, 67680, '\p{__Is_ARMI}', "");
    Expect(1, 67680, '\p{^__Is_ARMI}', "");
    Expect(1, 67680, '\P{__Is_ARMI}', "");
    Expect(0, 67680, '\P{^__Is_ARMI}', "");
    Error('\p{		In_adlam/a/}');
    Error('\P{		In_adlam/a/}');
    Expect(1, 125279, '\p{inadlam}', "");
    Expect(0, 125279, '\p{^inadlam}', "");
    Expect(0, 125279, '\P{inadlam}', "");
    Expect(1, 125279, '\P{^inadlam}', "");
    Expect(0, 125280, '\p{inadlam}', "");
    Expect(1, 125280, '\p{^inadlam}', "");
    Expect(1, 125280, '\P{inadlam}', "");
    Expect(0, 125280, '\P{^inadlam}', "");
    Expect(1, 125279, '\p{_in_adlam}', "");
    Expect(0, 125279, '\p{^_in_adlam}', "");
    Expect(0, 125279, '\P{_in_adlam}', "");
    Expect(1, 125279, '\P{^_in_adlam}', "");
    Expect(0, 125280, '\p{_in_adlam}', "");
    Expect(1, 125280, '\p{^_in_adlam}', "");
    Expect(1, 125280, '\P{_in_adlam}', "");
    Expect(0, 125280, '\P{^_in_adlam}', "");
    Error('\p{-:=in_Adlam}');
    Error('\P{-:=in_Adlam}');
    Expect(1, 125279, '\p{ -In_Adlam}', "");
    Expect(0, 125279, '\p{^ -In_Adlam}', "");
    Expect(0, 125279, '\P{ -In_Adlam}', "");
    Expect(1, 125279, '\P{^ -In_Adlam}', "");
    Expect(0, 125280, '\p{ -In_Adlam}', "");
    Expect(1, 125280, '\p{^ -In_Adlam}', "");
    Expect(1, 125280, '\P{ -In_Adlam}', "");
    Expect(0, 125280, '\P{^ -In_Adlam}', "");
    Error('\p{:= In_Ahom}');
    Error('\P{:= In_Ahom}');
    Expect(1, 71487, '\p{inahom}', "");
    Expect(0, 71487, '\p{^inahom}', "");
    Expect(0, 71487, '\P{inahom}', "");
    Expect(1, 71487, '\P{^inahom}', "");
    Expect(0, 71488, '\p{inahom}', "");
    Expect(1, 71488, '\p{^inahom}', "");
    Expect(1, 71488, '\P{inahom}', "");
    Expect(0, 71488, '\P{^inahom}', "");
    Expect(1, 71487, '\p{ In_ahom}', "");
    Expect(0, 71487, '\p{^ In_ahom}', "");
    Expect(0, 71487, '\P{ In_ahom}', "");
    Expect(1, 71487, '\P{^ In_ahom}', "");
    Expect(0, 71488, '\p{ In_ahom}', "");
    Expect(1, 71488, '\p{^ In_ahom}', "");
    Expect(1, 71488, '\P{ In_ahom}', "");
    Expect(0, 71488, '\P{^ In_ahom}', "");
    Error('\p{ /a/In_Ahom}');
    Error('\P{ /a/In_Ahom}');
    Expect(1, 71487, '\p{-in_AHOM}', "");
    Expect(0, 71487, '\p{^-in_AHOM}', "");
    Expect(0, 71487, '\P{-in_AHOM}', "");
    Expect(1, 71487, '\P{^-in_AHOM}', "");
    Expect(0, 71488, '\p{-in_AHOM}', "");
    Expect(1, 71488, '\p{^-in_AHOM}', "");
    Expect(1, 71488, '\P{-in_AHOM}', "");
    Expect(0, 71488, '\P{^-in_AHOM}', "");
    Error('\p{ 	In_ANATOLIAN_hieroglyphs:=}');
    Error('\P{ 	In_ANATOLIAN_hieroglyphs:=}');
    Expect(1, 83583, '\p{inanatolianhieroglyphs}', "");
    Expect(0, 83583, '\p{^inanatolianhieroglyphs}', "");
    Expect(0, 83583, '\P{inanatolianhieroglyphs}', "");
    Expect(1, 83583, '\P{^inanatolianhieroglyphs}', "");
    Expect(0, 83584, '\p{inanatolianhieroglyphs}', "");
    Expect(1, 83584, '\p{^inanatolianhieroglyphs}', "");
    Expect(1, 83584, '\P{inanatolianhieroglyphs}', "");
    Expect(0, 83584, '\P{^inanatolianhieroglyphs}', "");
    Expect(1, 83583, '\p{In_anatolian_Hieroglyphs}', "");
    Expect(0, 83583, '\p{^In_anatolian_Hieroglyphs}', "");
    Expect(0, 83583, '\P{In_anatolian_Hieroglyphs}', "");
    Expect(1, 83583, '\P{^In_anatolian_Hieroglyphs}', "");
    Expect(0, 83584, '\p{In_anatolian_Hieroglyphs}', "");
    Expect(1, 83584, '\p{^In_anatolian_Hieroglyphs}', "");
    Expect(1, 83584, '\P{In_anatolian_Hieroglyphs}', "");
    Expect(0, 83584, '\P{^In_anatolian_Hieroglyphs}', "");
    Error('\p{:=  In_Anatolian_hieroglyphs}');
    Error('\P{:=  In_Anatolian_hieroglyphs}');
    Expect(1, 83583, '\p{ IN_anatolian_Hieroglyphs}', "");
    Expect(0, 83583, '\p{^ IN_anatolian_Hieroglyphs}', "");
    Expect(0, 83583, '\P{ IN_anatolian_Hieroglyphs}', "");
    Expect(1, 83583, '\P{^ IN_anatolian_Hieroglyphs}', "");
    Expect(0, 83584, '\p{ IN_anatolian_Hieroglyphs}', "");
    Expect(1, 83584, '\p{^ IN_anatolian_Hieroglyphs}', "");
    Expect(1, 83584, '\P{ IN_anatolian_Hieroglyphs}', "");
    Expect(0, 83584, '\P{^ IN_anatolian_Hieroglyphs}', "");
    Error('\p{-:=IN_Arabic}');
    Error('\P{-:=IN_Arabic}');
    Expect(1, 1791, '\p{inarabic}', "");
    Expect(0, 1791, '\p{^inarabic}', "");
    Expect(0, 1791, '\P{inarabic}', "");
    Expect(1, 1791, '\P{^inarabic}', "");
    Expect(0, 1792, '\p{inarabic}', "");
    Expect(1, 1792, '\p{^inarabic}', "");
    Expect(1, 1792, '\P{inarabic}', "");
    Expect(0, 1792, '\P{^inarabic}', "");
    Expect(1, 1791, '\p{_	In_Arabic}', "");
    Expect(0, 1791, '\p{^_	In_Arabic}', "");
    Expect(0, 1791, '\P{_	In_Arabic}', "");
    Expect(1, 1791, '\P{^_	In_Arabic}', "");
    Expect(0, 1792, '\p{_	In_Arabic}', "");
    Expect(1, 1792, '\p{^_	In_Arabic}', "");
    Expect(1, 1792, '\P{_	In_Arabic}', "");
    Expect(0, 1792, '\P{^_	In_Arabic}', "");
    Error('\p{-:=In_ARABIC}');
    Error('\P{-:=In_ARABIC}');
    Expect(1, 1791, '\p{ 	IN_arabic}', "");
    Expect(0, 1791, '\p{^ 	IN_arabic}', "");
    Expect(0, 1791, '\P{ 	IN_arabic}', "");
    Expect(1, 1791, '\P{^ 	IN_arabic}', "");
    Expect(0, 1792, '\p{ 	IN_arabic}', "");
    Expect(1, 1792, '\p{^ 	IN_arabic}', "");
    Expect(1, 1792, '\P{ 	IN_arabic}', "");
    Expect(0, 1792, '\P{^ 	IN_arabic}', "");
    Error('\p{:=		IN_ARMENIAN}');
    Error('\P{:=		IN_ARMENIAN}');
    Expect(1, 1423, '\p{inarmenian}', "");
    Expect(0, 1423, '\p{^inarmenian}', "");
    Expect(0, 1423, '\P{inarmenian}', "");
    Expect(1, 1423, '\P{^inarmenian}', "");
    Expect(0, 1424, '\p{inarmenian}', "");
    Expect(1, 1424, '\p{^inarmenian}', "");
    Expect(1, 1424, '\P{inarmenian}', "");
    Expect(0, 1424, '\P{^inarmenian}', "");
    Expect(1, 1423, '\p{	-In_Armenian}', "");
    Expect(0, 1423, '\p{^	-In_Armenian}', "");
    Expect(0, 1423, '\P{	-In_Armenian}', "");
    Expect(1, 1423, '\P{^	-In_Armenian}', "");
    Expect(0, 1424, '\p{	-In_Armenian}', "");
    Expect(1, 1424, '\p{^	-In_Armenian}', "");
    Expect(1, 1424, '\P{	-In_Armenian}', "");
    Expect(0, 1424, '\P{^	-In_Armenian}', "");
    Error('\p{-	In_Armenian/a/}');
    Error('\P{-	In_Armenian/a/}');
    Expect(1, 1423, '\p{_ In_Armenian}', "");
    Expect(0, 1423, '\p{^_ In_Armenian}', "");
    Expect(0, 1423, '\P{_ In_Armenian}', "");
    Expect(1, 1423, '\P{^_ In_Armenian}', "");
    Expect(0, 1424, '\p{_ In_Armenian}', "");
    Expect(1, 1424, '\p{^_ In_Armenian}', "");
    Expect(1, 1424, '\P{_ In_Armenian}', "");
    Expect(0, 1424, '\P{^_ In_Armenian}', "");
    Error('\p{/a/In_avestan}');
    Error('\P{/a/In_avestan}');
    Expect(1, 68415, '\p{inavestan}', "");
    Expect(0, 68415, '\p{^inavestan}', "");
    Expect(0, 68415, '\P{inavestan}', "");
    Expect(1, 68415, '\P{^inavestan}', "");
    Expect(0, 68416, '\p{inavestan}', "");
    Expect(1, 68416, '\p{^inavestan}', "");
    Expect(1, 68416, '\P{inavestan}', "");
    Expect(0, 68416, '\P{^inavestan}', "");
    Expect(1, 68415, '\p{__In_Avestan}', "");
    Expect(0, 68415, '\p{^__In_Avestan}', "");
    Expect(0, 68415, '\P{__In_Avestan}', "");
    Expect(1, 68415, '\P{^__In_Avestan}', "");
    Expect(0, 68416, '\p{__In_Avestan}', "");
    Expect(1, 68416, '\p{^__In_Avestan}', "");
    Expect(1, 68416, '\P{__In_Avestan}', "");
    Expect(0, 68416, '\P{^__In_Avestan}', "");
    Error('\p{_/a/In_Avestan}');
    Error('\P{_/a/In_Avestan}');
    Expect(1, 68415, '\p{-_In_Avestan}', "");
    Expect(0, 68415, '\p{^-_In_Avestan}', "");
    Expect(0, 68415, '\P{-_In_Avestan}', "");
    Expect(1, 68415, '\P{^-_In_Avestan}', "");
    Expect(0, 68416, '\p{-_In_Avestan}', "");
    Expect(1, 68416, '\p{^-_In_Avestan}', "");
    Expect(1, 68416, '\P{-_In_Avestan}', "");
    Expect(0, 68416, '\P{^-_In_Avestan}', "");
    Error('\p{	/a/in_Balinese}');
    Error('\P{	/a/in_Balinese}');
    Expect(1, 7039, '\p{inbalinese}', "");
    Expect(0, 7039, '\p{^inbalinese}', "");
    Expect(0, 7039, '\P{inbalinese}', "");
    Expect(1, 7039, '\P{^inbalinese}', "");
    Expect(0, 7040, '\p{inbalinese}', "");
    Expect(1, 7040, '\p{^inbalinese}', "");
    Expect(1, 7040, '\P{inbalinese}', "");
    Expect(0, 7040, '\P{^inbalinese}', "");
    Expect(1, 7039, '\p{  In_BALINESE}', "");
    Expect(0, 7039, '\p{^  In_BALINESE}', "");
    Expect(0, 7039, '\P{  In_BALINESE}', "");
    Expect(1, 7039, '\P{^  In_BALINESE}', "");
    Expect(0, 7040, '\p{  In_BALINESE}', "");
    Expect(1, 7040, '\p{^  In_BALINESE}', "");
    Expect(1, 7040, '\P{  In_BALINESE}', "");
    Expect(0, 7040, '\P{^  In_BALINESE}', "");
    Error('\p{_IN_Balinese/a/}');
    Error('\P{_IN_Balinese/a/}');
    Expect(1, 7039, '\p{	In_Balinese}', "");
    Expect(0, 7039, '\p{^	In_Balinese}', "");
    Expect(0, 7039, '\P{	In_Balinese}', "");
    Expect(1, 7039, '\P{^	In_Balinese}', "");
    Expect(0, 7040, '\p{	In_Balinese}', "");
    Expect(1, 7040, '\p{^	In_Balinese}', "");
    Expect(1, 7040, '\P{	In_Balinese}', "");
    Expect(0, 7040, '\P{^	In_Balinese}', "");
    Error('\p{:=		In_Bamum}');
    Error('\P{:=		In_Bamum}');
    Expect(1, 42751, '\p{inbamum}', "");
    Expect(0, 42751, '\p{^inbamum}', "");
    Expect(0, 42751, '\P{inbamum}', "");
    Expect(1, 42751, '\P{^inbamum}', "");
    Expect(0, 42752, '\p{inbamum}', "");
    Expect(1, 42752, '\p{^inbamum}', "");
    Expect(1, 42752, '\P{inbamum}', "");
    Expect(0, 42752, '\P{^inbamum}', "");
    Expect(1, 42751, '\p{_-In_Bamum}', "");
    Expect(0, 42751, '\p{^_-In_Bamum}', "");
    Expect(0, 42751, '\P{_-In_Bamum}', "");
    Expect(1, 42751, '\P{^_-In_Bamum}', "");
    Expect(0, 42752, '\p{_-In_Bamum}', "");
    Expect(1, 42752, '\p{^_-In_Bamum}', "");
    Expect(1, 42752, '\P{_-In_Bamum}', "");
    Expect(0, 42752, '\P{^_-In_Bamum}', "");
    Error('\p{	/a/IN_Bamum}');
    Error('\P{	/a/IN_Bamum}');
    Expect(1, 42751, '\p{	_IN_BAMUM}', "");
    Expect(0, 42751, '\p{^	_IN_BAMUM}', "");
    Expect(0, 42751, '\P{	_IN_BAMUM}', "");
    Expect(1, 42751, '\P{^	_IN_BAMUM}', "");
    Expect(0, 42752, '\p{	_IN_BAMUM}', "");
    Expect(1, 42752, '\p{^	_IN_BAMUM}', "");
    Expect(1, 42752, '\P{	_IN_BAMUM}', "");
    Expect(0, 42752, '\P{^	_IN_BAMUM}', "");
    Error('\p{/a/__In_BASSA_VAH}');
    Error('\P{/a/__In_BASSA_VAH}');
    Expect(1, 92927, '\p{inbassavah}', "");
    Expect(0, 92927, '\p{^inbassavah}', "");
    Expect(0, 92927, '\P{inbassavah}', "");
    Expect(1, 92927, '\P{^inbassavah}', "");
    Expect(0, 92928, '\p{inbassavah}', "");
    Expect(1, 92928, '\p{^inbassavah}', "");
    Expect(1, 92928, '\P{inbassavah}', "");
    Expect(0, 92928, '\P{^inbassavah}', "");
    Expect(1, 92927, '\p{		In_bassa_vah}', "");
    Expect(0, 92927, '\p{^		In_bassa_vah}', "");
    Expect(0, 92927, '\P{		In_bassa_vah}', "");
    Expect(1, 92927, '\P{^		In_bassa_vah}', "");
    Expect(0, 92928, '\p{		In_bassa_vah}', "");
    Expect(1, 92928, '\p{^		In_bassa_vah}', "");
    Expect(1, 92928, '\P{		In_bassa_vah}', "");
    Expect(0, 92928, '\P{^		In_bassa_vah}', "");
    Error('\p{/a/-In_Bassa_vah}');
    Error('\P{/a/-In_Bassa_vah}');
    Expect(1, 92927, '\p{		IN_Bassa_VAH}', "");
    Expect(0, 92927, '\p{^		IN_Bassa_VAH}', "");
    Expect(0, 92927, '\P{		IN_Bassa_VAH}', "");
    Expect(1, 92927, '\P{^		IN_Bassa_VAH}', "");
    Expect(0, 92928, '\p{		IN_Bassa_VAH}', "");
    Expect(1, 92928, '\p{^		IN_Bassa_VAH}', "");
    Expect(1, 92928, '\P{		IN_Bassa_VAH}', "");
    Expect(0, 92928, '\P{^		IN_Bassa_VAH}', "");
    Error('\p{  In_BATAK/a/}');
    Error('\P{  In_BATAK/a/}');
    Expect(1, 7167, '\p{inbatak}', "");
    Expect(0, 7167, '\p{^inbatak}', "");
    Expect(0, 7167, '\P{inbatak}', "");
    Expect(1, 7167, '\P{^inbatak}', "");
    Expect(0, 7168, '\p{inbatak}', "");
    Expect(1, 7168, '\p{^inbatak}', "");
    Expect(1, 7168, '\P{inbatak}', "");
    Expect(0, 7168, '\P{^inbatak}', "");
    Expect(1, 7167, '\p{ In_Batak}', "");
    Expect(0, 7167, '\p{^ In_Batak}', "");
    Expect(0, 7167, '\P{ In_Batak}', "");
    Expect(1, 7167, '\P{^ In_Batak}', "");
    Expect(0, 7168, '\p{ In_Batak}', "");
    Expect(1, 7168, '\p{^ In_Batak}', "");
    Expect(1, 7168, '\P{ In_Batak}', "");
    Expect(0, 7168, '\P{^ In_Batak}', "");
    Error('\p{/a/		IN_batak}');
    Error('\P{/a/		IN_batak}');
    Error('\p{-/a/In_BENGALI}');
    Error('\P{-/a/In_BENGALI}');
    Expect(1, 2559, '\p{inbengali}', "");
    Expect(0, 2559, '\p{^inbengali}', "");
    Expect(0, 2559, '\P{inbengali}', "");
    Expect(1, 2559, '\P{^inbengali}', "");
    Expect(0, 2560, '\p{inbengali}', "");
    Expect(1, 2560, '\p{^inbengali}', "");
    Expect(1, 2560, '\P{inbengali}', "");
    Expect(0, 2560, '\P{^inbengali}', "");
    Expect(1, 2559, '\p{ In_Bengali}', "");
    Expect(0, 2559, '\p{^ In_Bengali}', "");
    Expect(0, 2559, '\P{ In_Bengali}', "");
    Expect(1, 2559, '\P{^ In_Bengali}', "");
    Expect(0, 2560, '\p{ In_Bengali}', "");
    Expect(1, 2560, '\p{^ In_Bengali}', "");
    Expect(1, 2560, '\P{ In_Bengali}', "");
    Expect(0, 2560, '\P{^ In_Bengali}', "");
    Error('\p{_In_Bengali/a/}');
    Error('\P{_In_Bengali/a/}');
    Expect(1, 2559, '\p{- In_bengali}', "");
    Expect(0, 2559, '\p{^- In_bengali}', "");
    Expect(0, 2559, '\P{- In_bengali}', "");
    Expect(1, 2559, '\P{^- In_bengali}', "");
    Expect(0, 2560, '\p{- In_bengali}', "");
    Expect(1, 2560, '\p{^- In_bengali}', "");
    Expect(1, 2560, '\P{- In_bengali}', "");
    Expect(0, 2560, '\P{^- In_bengali}', "");
    Error('\p{- IN_Bhaiksuki:=}');
    Error('\P{- IN_Bhaiksuki:=}');
    Expect(1, 72815, '\p{inbhaiksuki}', "");
    Expect(0, 72815, '\p{^inbhaiksuki}', "");
    Expect(0, 72815, '\P{inbhaiksuki}', "");
    Expect(1, 72815, '\P{^inbhaiksuki}', "");
    Expect(0, 72816, '\p{inbhaiksuki}', "");
    Expect(1, 72816, '\p{^inbhaiksuki}', "");
    Expect(1, 72816, '\P{inbhaiksuki}', "");
    Expect(0, 72816, '\P{^inbhaiksuki}', "");
    Expect(1, 72815, '\p{ _In_bhaiksuki}', "");
    Expect(0, 72815, '\p{^ _In_bhaiksuki}', "");
    Expect(0, 72815, '\P{ _In_bhaiksuki}', "");
    Expect(1, 72815, '\P{^ _In_bhaiksuki}', "");
    Expect(0, 72816, '\p{ _In_bhaiksuki}', "");
    Expect(1, 72816, '\p{^ _In_bhaiksuki}', "");
    Expect(1, 72816, '\P{ _In_bhaiksuki}', "");
    Expect(0, 72816, '\P{^ _In_bhaiksuki}', "");
    Error('\p{:=_IN_bhaiksuki}');
    Error('\P{:=_IN_bhaiksuki}');
    Expect(1, 72815, '\p{ 	IN_Bhaiksuki}', "");
    Expect(0, 72815, '\p{^ 	IN_Bhaiksuki}', "");
    Expect(0, 72815, '\P{ 	IN_Bhaiksuki}', "");
    Expect(1, 72815, '\P{^ 	IN_Bhaiksuki}', "");
    Expect(0, 72816, '\p{ 	IN_Bhaiksuki}', "");
    Expect(1, 72816, '\p{^ 	IN_Bhaiksuki}', "");
    Expect(1, 72816, '\P{ 	IN_Bhaiksuki}', "");
    Expect(0, 72816, '\P{^ 	IN_Bhaiksuki}', "");
    Error('\p{/a/	 IN_Bopomofo}');
    Error('\P{/a/	 IN_Bopomofo}');
    Expect(1, 12591, '\p{inbopomofo}', "");
    Expect(0, 12591, '\p{^inbopomofo}', "");
    Expect(0, 12591, '\P{inbopomofo}', "");
    Expect(1, 12591, '\P{^inbopomofo}', "");
    Expect(0, 12592, '\p{inbopomofo}', "");
    Expect(1, 12592, '\p{^inbopomofo}', "");
    Expect(1, 12592, '\P{inbopomofo}', "");
    Expect(0, 12592, '\P{^inbopomofo}', "");
    Expect(1, 12591, '\p{	 IN_Bopomofo}', "");
    Expect(0, 12591, '\p{^	 IN_Bopomofo}', "");
    Expect(0, 12591, '\P{	 IN_Bopomofo}', "");
    Expect(1, 12591, '\P{^	 IN_Bopomofo}', "");
    Expect(0, 12592, '\p{	 IN_Bopomofo}', "");
    Expect(1, 12592, '\p{^	 IN_Bopomofo}', "");
    Expect(1, 12592, '\P{	 IN_Bopomofo}', "");
    Expect(0, 12592, '\P{^	 IN_Bopomofo}', "");
    Error('\p{	IN_Bopomofo/a/}');
    Error('\P{	IN_Bopomofo/a/}');
    Expect(1, 12591, '\p{_In_Bopomofo}', "");
    Expect(0, 12591, '\p{^_In_Bopomofo}', "");
    Expect(0, 12591, '\P{_In_Bopomofo}', "");
    Expect(1, 12591, '\P{^_In_Bopomofo}', "");
    Expect(0, 12592, '\p{_In_Bopomofo}', "");
    Expect(1, 12592, '\p{^_In_Bopomofo}', "");
    Expect(1, 12592, '\P{_In_Bopomofo}', "");
    Expect(0, 12592, '\P{^_In_Bopomofo}', "");
    Error('\p{_:=in_Brahmi}');
    Error('\P{_:=in_Brahmi}');
    Expect(1, 69759, '\p{inbrahmi}', "");
    Expect(0, 69759, '\p{^inbrahmi}', "");
    Expect(0, 69759, '\P{inbrahmi}', "");
    Expect(1, 69759, '\P{^inbrahmi}', "");
    Expect(0, 69760, '\p{inbrahmi}', "");
    Expect(1, 69760, '\p{^inbrahmi}', "");
    Expect(1, 69760, '\P{inbrahmi}', "");
    Expect(0, 69760, '\P{^inbrahmi}', "");
    Expect(1, 69759, '\p{ 	in_brahmi}', "");
    Expect(0, 69759, '\p{^ 	in_brahmi}', "");
    Expect(0, 69759, '\P{ 	in_brahmi}', "");
    Expect(1, 69759, '\P{^ 	in_brahmi}', "");
    Expect(0, 69760, '\p{ 	in_brahmi}', "");
    Expect(1, 69760, '\p{^ 	in_brahmi}', "");
    Expect(1, 69760, '\P{ 	in_brahmi}', "");
    Expect(0, 69760, '\P{^ 	in_brahmi}', "");
    Error('\p{_In_Brahmi/a/}');
    Error('\P{_In_Brahmi/a/}');
    Expect(1, 69759, '\p{_in_brahmi}', "");
    Expect(0, 69759, '\p{^_in_brahmi}', "");
    Expect(0, 69759, '\P{_in_brahmi}', "");
    Expect(1, 69759, '\P{^_in_brahmi}', "");
    Expect(0, 69760, '\p{_in_brahmi}', "");
    Expect(1, 69760, '\p{^_in_brahmi}', "");
    Expect(1, 69760, '\P{_in_brahmi}', "");
    Expect(0, 69760, '\P{^_in_brahmi}', "");
    Error('\p{	 In_BUGINESE/a/}');
    Error('\P{	 In_BUGINESE/a/}');
    Expect(1, 6687, '\p{inbuginese}', "");
    Expect(0, 6687, '\p{^inbuginese}', "");
    Expect(0, 6687, '\P{inbuginese}', "");
    Expect(1, 6687, '\P{^inbuginese}', "");
    Expect(0, 6688, '\p{inbuginese}', "");
    Expect(1, 6688, '\p{^inbuginese}', "");
    Expect(1, 6688, '\P{inbuginese}', "");
    Expect(0, 6688, '\P{^inbuginese}', "");
    Expect(1, 6687, '\p{- IN_Buginese}', "");
    Expect(0, 6687, '\p{^- IN_Buginese}', "");
    Expect(0, 6687, '\P{- IN_Buginese}', "");
    Expect(1, 6687, '\P{^- IN_Buginese}', "");
    Expect(0, 6688, '\p{- IN_Buginese}', "");
    Expect(1, 6688, '\p{^- IN_Buginese}', "");
    Expect(1, 6688, '\P{- IN_Buginese}', "");
    Expect(0, 6688, '\P{^- IN_Buginese}', "");
    Error('\p{/a/- in_Buginese}');
    Error('\P{/a/- in_Buginese}');
    Expect(1, 6687, '\p{	IN_Buginese}', "");
    Expect(0, 6687, '\p{^	IN_Buginese}', "");
    Expect(0, 6687, '\P{	IN_Buginese}', "");
    Expect(1, 6687, '\P{^	IN_Buginese}', "");
    Expect(0, 6688, '\p{	IN_Buginese}', "");
    Expect(1, 6688, '\p{^	IN_Buginese}', "");
    Expect(1, 6688, '\P{	IN_Buginese}', "");
    Expect(0, 6688, '\P{^	IN_Buginese}', "");
    Error('\p{:=	-In_buhid}');
    Error('\P{:=	-In_buhid}');
    Expect(1, 5983, '\p{inbuhid}', "");
    Expect(0, 5983, '\p{^inbuhid}', "");
    Expect(0, 5983, '\P{inbuhid}', "");
    Expect(1, 5983, '\P{^inbuhid}', "");
    Expect(0, 5984, '\p{inbuhid}', "");
    Expect(1, 5984, '\p{^inbuhid}', "");
    Expect(1, 5984, '\P{inbuhid}', "");
    Expect(0, 5984, '\P{^inbuhid}', "");
    Expect(1, 5983, '\p{__In_BUHID}', "");
    Expect(0, 5983, '\p{^__In_BUHID}', "");
    Expect(0, 5983, '\P{__In_BUHID}', "");
    Expect(1, 5983, '\P{^__In_BUHID}', "");
    Expect(0, 5984, '\p{__In_BUHID}', "");
    Expect(1, 5984, '\p{^__In_BUHID}', "");
    Expect(1, 5984, '\P{__In_BUHID}', "");
    Expect(0, 5984, '\P{^__In_BUHID}', "");
    Error('\p{/a/In_Buhid}');
    Error('\P{/a/In_Buhid}');
    Expect(1, 5983, '\p{ _In_Buhid}', "");
    Expect(0, 5983, '\p{^ _In_Buhid}', "");
    Expect(0, 5983, '\P{ _In_Buhid}', "");
    Expect(1, 5983, '\P{^ _In_Buhid}', "");
    Expect(0, 5984, '\p{ _In_Buhid}', "");
    Expect(1, 5984, '\p{^ _In_Buhid}', "");
    Expect(1, 5984, '\P{ _In_Buhid}', "");
    Expect(0, 5984, '\P{^ _In_Buhid}', "");
    Error('\p{In_Carian:=}');
    Error('\P{In_Carian:=}');
    Expect(1, 66271, '\p{incarian}', "");
    Expect(0, 66271, '\p{^incarian}', "");
    Expect(0, 66271, '\P{incarian}', "");
    Expect(1, 66271, '\P{^incarian}', "");
    Expect(0, 66272, '\p{incarian}', "");
    Expect(1, 66272, '\p{^incarian}', "");
    Expect(1, 66272, '\P{incarian}', "");
    Expect(0, 66272, '\P{^incarian}', "");
    Expect(1, 66271, '\p{-In_Carian}', "");
    Expect(0, 66271, '\p{^-In_Carian}', "");
    Expect(0, 66271, '\P{-In_Carian}', "");
    Expect(1, 66271, '\P{^-In_Carian}', "");
    Expect(0, 66272, '\p{-In_Carian}', "");
    Expect(1, 66272, '\p{^-In_Carian}', "");
    Expect(1, 66272, '\P{-In_Carian}', "");
    Expect(0, 66272, '\P{^-In_Carian}', "");
    Error('\p{_/a/In_carian}');
    Error('\P{_/a/In_carian}');
    Expect(1, 66271, '\p{-	in_CARIAN}', "");
    Expect(0, 66271, '\p{^-	in_CARIAN}', "");
    Expect(0, 66271, '\P{-	in_CARIAN}', "");
    Expect(1, 66271, '\P{^-	in_CARIAN}', "");
    Expect(0, 66272, '\p{-	in_CARIAN}', "");
    Expect(1, 66272, '\p{^-	in_CARIAN}', "");
    Expect(1, 66272, '\P{-	in_CARIAN}', "");
    Expect(0, 66272, '\P{^-	in_CARIAN}', "");
    Error('\p{_/a/In_Caucasian_Albanian}');
    Error('\P{_/a/In_Caucasian_Albanian}');
    Expect(1, 66927, '\p{incaucasianalbanian}', "");
    Expect(0, 66927, '\p{^incaucasianalbanian}', "");
    Expect(0, 66927, '\P{incaucasianalbanian}', "");
    Expect(1, 66927, '\P{^incaucasianalbanian}', "");
    Expect(0, 66928, '\p{incaucasianalbanian}', "");
    Expect(1, 66928, '\p{^incaucasianalbanian}', "");
    Expect(1, 66928, '\P{incaucasianalbanian}', "");
    Expect(0, 66928, '\P{^incaucasianalbanian}', "");
    Expect(1, 66927, '\p{-	In_Caucasian_ALBANIAN}', "");
    Expect(0, 66927, '\p{^-	In_Caucasian_ALBANIAN}', "");
    Expect(0, 66927, '\P{-	In_Caucasian_ALBANIAN}', "");
    Expect(1, 66927, '\P{^-	In_Caucasian_ALBANIAN}', "");
    Expect(0, 66928, '\p{-	In_Caucasian_ALBANIAN}', "");
    Expect(1, 66928, '\p{^-	In_Caucasian_ALBANIAN}', "");
    Expect(1, 66928, '\P{-	In_Caucasian_ALBANIAN}', "");
    Expect(0, 66928, '\P{^-	In_Caucasian_ALBANIAN}', "");
    Error('\p{ :=IN_CAUCASIAN_ALBANIAN}');
    Error('\P{ :=IN_CAUCASIAN_ALBANIAN}');
    Expect(1, 66927, '\p{-	In_Caucasian_Albanian}', "");
    Expect(0, 66927, '\p{^-	In_Caucasian_Albanian}', "");
    Expect(0, 66927, '\P{-	In_Caucasian_Albanian}', "");
    Expect(1, 66927, '\P{^-	In_Caucasian_Albanian}', "");
    Expect(0, 66928, '\p{-	In_Caucasian_Albanian}', "");
    Expect(1, 66928, '\p{^-	In_Caucasian_Albanian}', "");
    Expect(1, 66928, '\P{-	In_Caucasian_Albanian}', "");
    Expect(0, 66928, '\P{^-	In_Caucasian_Albanian}', "");
    Error('\p{/a/ -in_CHAKMA}');
    Error('\P{/a/ -in_CHAKMA}');
    Expect(1, 69967, '\p{inchakma}', "");
    Expect(0, 69967, '\p{^inchakma}', "");
    Expect(0, 69967, '\P{inchakma}', "");
    Expect(1, 69967, '\P{^inchakma}', "");
    Expect(0, 69968, '\p{inchakma}', "");
    Expect(1, 69968, '\p{^inchakma}', "");
    Expect(1, 69968, '\P{inchakma}', "");
    Expect(0, 69968, '\P{^inchakma}', "");
    Expect(1, 69967, '\p{_-In_CHAKMA}', "");
    Expect(0, 69967, '\p{^_-In_CHAKMA}', "");
    Expect(0, 69967, '\P{_-In_CHAKMA}', "");
    Expect(1, 69967, '\P{^_-In_CHAKMA}', "");
    Expect(0, 69968, '\p{_-In_CHAKMA}', "");
    Expect(1, 69968, '\p{^_-In_CHAKMA}', "");
    Expect(1, 69968, '\P{_-In_CHAKMA}', "");
    Expect(0, 69968, '\P{^_-In_CHAKMA}', "");
    Error('\p{-:=in_Chakma}');
    Error('\P{-:=in_Chakma}');
    Expect(1, 69967, '\p{		IN_Chakma}', "");
    Expect(0, 69967, '\p{^		IN_Chakma}', "");
    Expect(0, 69967, '\P{		IN_Chakma}', "");
    Expect(1, 69967, '\P{^		IN_Chakma}', "");
    Expect(0, 69968, '\p{		IN_Chakma}', "");
    Expect(1, 69968, '\p{^		IN_Chakma}', "");
    Expect(1, 69968, '\P{		IN_Chakma}', "");
    Expect(0, 69968, '\P{^		IN_Chakma}', "");
    Error('\p{_/a/IN_cham}');
    Error('\P{_/a/IN_cham}');
    Expect(1, 43615, '\p{incham}', "");
    Expect(0, 43615, '\p{^incham}', "");
    Expect(0, 43615, '\P{incham}', "");
    Expect(1, 43615, '\P{^incham}', "");
    Expect(0, 43616, '\p{incham}', "");
    Expect(1, 43616, '\p{^incham}', "");
    Expect(1, 43616, '\P{incham}', "");
    Expect(0, 43616, '\P{^incham}', "");
    Expect(1, 43615, '\p{_In_CHAM}', "");
    Expect(0, 43615, '\p{^_In_CHAM}', "");
    Expect(0, 43615, '\P{_In_CHAM}', "");
    Expect(1, 43615, '\P{^_In_CHAM}', "");
    Expect(0, 43616, '\p{_In_CHAM}', "");
    Expect(1, 43616, '\p{^_In_CHAM}', "");
    Expect(1, 43616, '\P{_In_CHAM}', "");
    Expect(0, 43616, '\P{^_In_CHAM}', "");
    Error('\p{_/a/IN_CHAM}');
    Error('\P{_/a/IN_CHAM}');
    Expect(1, 43615, '\p{- In_cham}', "");
    Expect(0, 43615, '\p{^- In_cham}', "");
    Expect(0, 43615, '\P{- In_cham}', "");
    Expect(1, 43615, '\P{^- In_cham}', "");
    Expect(0, 43616, '\p{- In_cham}', "");
    Expect(1, 43616, '\p{^- In_cham}', "");
    Expect(1, 43616, '\P{- In_cham}', "");
    Expect(0, 43616, '\P{^- In_cham}', "");
    Error('\p{:=_	In_Cherokee}');
    Error('\P{:=_	In_Cherokee}');
    Expect(1, 5119, '\p{incherokee}', "");
    Expect(0, 5119, '\p{^incherokee}', "");
    Expect(0, 5119, '\P{incherokee}', "");
    Expect(1, 5119, '\P{^incherokee}', "");
    Expect(0, 5120, '\p{incherokee}', "");
    Expect(1, 5120, '\p{^incherokee}', "");
    Expect(1, 5120, '\P{incherokee}', "");
    Expect(0, 5120, '\P{^incherokee}', "");
    Expect(1, 5119, '\p{	 IN_Cherokee}', "");
    Expect(0, 5119, '\p{^	 IN_Cherokee}', "");
    Expect(0, 5119, '\P{	 IN_Cherokee}', "");
    Expect(1, 5119, '\P{^	 IN_Cherokee}', "");
    Expect(0, 5120, '\p{	 IN_Cherokee}', "");
    Expect(1, 5120, '\p{^	 IN_Cherokee}', "");
    Expect(1, 5120, '\P{	 IN_Cherokee}', "");
    Expect(0, 5120, '\P{^	 IN_Cherokee}', "");
    Error('\p{/a/-	IN_Cherokee}');
    Error('\P{/a/-	IN_Cherokee}');
    Expect(1, 5119, '\p{_ IN_cherokee}', "");
    Expect(0, 5119, '\p{^_ IN_cherokee}', "");
    Expect(0, 5119, '\P{_ IN_cherokee}', "");
    Expect(1, 5119, '\P{^_ IN_cherokee}', "");
    Expect(0, 5120, '\p{_ IN_cherokee}', "");
    Expect(1, 5120, '\p{^_ IN_cherokee}', "");
    Expect(1, 5120, '\P{_ IN_cherokee}', "");
    Expect(0, 5120, '\P{^_ IN_cherokee}', "");
    Error('\p{_	In_Coptic/a/}');
    Error('\P{_	In_Coptic/a/}');
    Expect(1, 11519, '\p{incoptic}', "");
    Expect(0, 11519, '\p{^incoptic}', "");
    Expect(0, 11519, '\P{incoptic}', "");
    Expect(1, 11519, '\P{^incoptic}', "");
    Expect(0, 11520, '\p{incoptic}', "");
    Expect(1, 11520, '\p{^incoptic}', "");
    Expect(1, 11520, '\P{incoptic}', "");
    Expect(0, 11520, '\P{^incoptic}', "");
    Expect(1, 11519, '\p{IN_Coptic}', "");
    Expect(0, 11519, '\p{^IN_Coptic}', "");
    Expect(0, 11519, '\P{IN_Coptic}', "");
    Expect(1, 11519, '\P{^IN_Coptic}', "");
    Expect(0, 11520, '\p{IN_Coptic}', "");
    Expect(1, 11520, '\p{^IN_Coptic}', "");
    Expect(1, 11520, '\P{IN_Coptic}', "");
    Expect(0, 11520, '\P{^IN_Coptic}', "");
    Error('\p{-	in_Coptic/a/}');
    Error('\P{-	in_Coptic/a/}');
    Expect(1, 11519, '\p{-_In_Coptic}', "");
    Expect(0, 11519, '\p{^-_In_Coptic}', "");
    Expect(0, 11519, '\P{-_In_Coptic}', "");
    Expect(1, 11519, '\P{^-_In_Coptic}', "");
    Expect(0, 11520, '\p{-_In_Coptic}', "");
    Expect(1, 11520, '\p{^-_In_Coptic}', "");
    Expect(1, 11520, '\P{-_In_Coptic}', "");
    Expect(0, 11520, '\P{^-_In_Coptic}', "");
    Error('\p{_:=In_CUNEIFORM}');
    Error('\P{_:=In_CUNEIFORM}');
    Expect(1, 74751, '\p{incuneiform}', "");
    Expect(0, 74751, '\p{^incuneiform}', "");
    Expect(0, 74751, '\P{incuneiform}', "");
    Expect(1, 74751, '\P{^incuneiform}', "");
    Expect(0, 74752, '\p{incuneiform}', "");
    Expect(1, 74752, '\p{^incuneiform}', "");
    Expect(1, 74752, '\P{incuneiform}', "");
    Expect(0, 74752, '\P{^incuneiform}', "");
    Expect(1, 74751, '\p{__In_Cuneiform}', "");
    Expect(0, 74751, '\p{^__In_Cuneiform}', "");
    Expect(0, 74751, '\P{__In_Cuneiform}', "");
    Expect(1, 74751, '\P{^__In_Cuneiform}', "");
    Expect(0, 74752, '\p{__In_Cuneiform}', "");
    Expect(1, 74752, '\p{^__In_Cuneiform}', "");
    Expect(1, 74752, '\P{__In_Cuneiform}', "");
    Expect(0, 74752, '\P{^__In_Cuneiform}', "");
    Error('\p{ :=in_cuneiform}');
    Error('\P{ :=in_cuneiform}');
    Expect(1, 74751, '\p{ in_CUNEIFORM}', "");
    Expect(0, 74751, '\p{^ in_CUNEIFORM}', "");
    Expect(0, 74751, '\P{ in_CUNEIFORM}', "");
    Expect(1, 74751, '\P{^ in_CUNEIFORM}', "");
    Expect(0, 74752, '\p{ in_CUNEIFORM}', "");
    Expect(1, 74752, '\p{^ in_CUNEIFORM}', "");
    Expect(1, 74752, '\P{ in_CUNEIFORM}', "");
    Expect(0, 74752, '\P{^ in_CUNEIFORM}', "");
    Error('\p{_	In_CYRILLIC/a/}');
    Error('\P{_	In_CYRILLIC/a/}');
    Expect(1, 1279, '\p{incyrillic}', "");
    Expect(0, 1279, '\p{^incyrillic}', "");
    Expect(0, 1279, '\P{incyrillic}', "");
    Expect(1, 1279, '\P{^incyrillic}', "");
    Expect(0, 1280, '\p{incyrillic}', "");
    Expect(1, 1280, '\p{^incyrillic}', "");
    Expect(1, 1280, '\P{incyrillic}', "");
    Expect(0, 1280, '\P{^incyrillic}', "");
    Expect(1, 1279, '\p{-_IN_Cyrillic}', "");
    Expect(0, 1279, '\p{^-_IN_Cyrillic}', "");
    Expect(0, 1279, '\P{-_IN_Cyrillic}', "");
    Expect(1, 1279, '\P{^-_IN_Cyrillic}', "");
    Expect(0, 1280, '\p{-_IN_Cyrillic}', "");
    Expect(1, 1280, '\p{^-_IN_Cyrillic}', "");
    Expect(1, 1280, '\P{-_IN_Cyrillic}', "");
    Expect(0, 1280, '\P{^-_IN_Cyrillic}', "");
    Error('\p{:=In_Cyrillic}');
    Error('\P{:=In_Cyrillic}');
    Expect(1, 1279, '\p{ 	In_Cyrillic}', "");
    Expect(0, 1279, '\p{^ 	In_Cyrillic}', "");
    Expect(0, 1279, '\P{ 	In_Cyrillic}', "");
    Expect(1, 1279, '\P{^ 	In_Cyrillic}', "");
    Expect(0, 1280, '\p{ 	In_Cyrillic}', "");
    Expect(1, 1280, '\p{^ 	In_Cyrillic}', "");
    Expect(1, 1280, '\P{ 	In_Cyrillic}', "");
    Expect(0, 1280, '\P{^ 	In_Cyrillic}', "");
    Error('\p{/a/-_In_deseret}');
    Error('\P{/a/-_In_deseret}');
    Expect(1, 66639, '\p{indeseret}', "");
    Expect(0, 66639, '\p{^indeseret}', "");
    Expect(0, 66639, '\P{indeseret}', "");
    Expect(1, 66639, '\P{^indeseret}', "");
    Expect(0, 66640, '\p{indeseret}', "");
    Expect(1, 66640, '\p{^indeseret}', "");
    Expect(1, 66640, '\P{indeseret}', "");
    Expect(0, 66640, '\P{^indeseret}', "");
    Expect(1, 66639, '\p{	-IN_DESERET}', "");
    Expect(0, 66639, '\p{^	-IN_DESERET}', "");
    Expect(0, 66639, '\P{	-IN_DESERET}', "");
    Expect(1, 66639, '\P{^	-IN_DESERET}', "");
    Expect(0, 66640, '\p{	-IN_DESERET}', "");
    Expect(1, 66640, '\p{^	-IN_DESERET}', "");
    Expect(1, 66640, '\P{	-IN_DESERET}', "");
    Expect(0, 66640, '\P{^	-IN_DESERET}', "");
    Error('\p{ In_Deseret:=}');
    Error('\P{ In_Deseret:=}');
    Expect(1, 66639, '\p{-IN_Deseret}', "");
    Expect(0, 66639, '\p{^-IN_Deseret}', "");
    Expect(0, 66639, '\P{-IN_Deseret}', "");
    Expect(1, 66639, '\P{^-IN_Deseret}', "");
    Expect(0, 66640, '\p{-IN_Deseret}', "");
    Expect(1, 66640, '\p{^-IN_Deseret}', "");
    Expect(1, 66640, '\P{-IN_Deseret}', "");
    Expect(0, 66640, '\P{^-IN_Deseret}', "");
    Error('\p{_	In_DEVANAGARI:=}');
    Error('\P{_	In_DEVANAGARI:=}');
    Expect(1, 2431, '\p{indevanagari}', "");
    Expect(0, 2431, '\p{^indevanagari}', "");
    Expect(0, 2431, '\P{indevanagari}', "");
    Expect(1, 2431, '\P{^indevanagari}', "");
    Expect(0, 2432, '\p{indevanagari}', "");
    Expect(1, 2432, '\p{^indevanagari}', "");
    Expect(1, 2432, '\P{indevanagari}', "");
    Expect(0, 2432, '\P{^indevanagari}', "");
    Expect(1, 2431, '\p{ in_DEVANAGARI}', "");
    Expect(0, 2431, '\p{^ in_DEVANAGARI}', "");
    Expect(0, 2431, '\P{ in_DEVANAGARI}', "");
    Expect(1, 2431, '\P{^ in_DEVANAGARI}', "");
    Expect(0, 2432, '\p{ in_DEVANAGARI}', "");
    Expect(1, 2432, '\p{^ in_DEVANAGARI}', "");
    Expect(1, 2432, '\P{ in_DEVANAGARI}', "");
    Expect(0, 2432, '\P{^ in_DEVANAGARI}', "");
    Error('\p{ :=in_Devanagari}');
    Error('\P{ :=in_Devanagari}');
    Expect(1, 2431, '\p{	in_Devanagari}', "");
    Expect(0, 2431, '\p{^	in_Devanagari}', "");
    Expect(0, 2431, '\P{	in_Devanagari}', "");
    Expect(1, 2431, '\P{^	in_Devanagari}', "");
    Expect(0, 2432, '\p{	in_Devanagari}', "");
    Expect(1, 2432, '\p{^	in_Devanagari}', "");
    Expect(1, 2432, '\P{	in_Devanagari}', "");
    Expect(0, 2432, '\P{^	in_Devanagari}', "");
    Error('\p{	 In_DOGRA/a/}');
    Error('\P{	 In_DOGRA/a/}');
    Expect(1, 71759, '\p{indogra}', "");
    Expect(0, 71759, '\p{^indogra}', "");
    Expect(0, 71759, '\P{indogra}', "");
    Expect(1, 71759, '\P{^indogra}', "");
    Expect(0, 71760, '\p{indogra}', "");
    Expect(1, 71760, '\p{^indogra}', "");
    Expect(1, 71760, '\P{indogra}', "");
    Expect(0, 71760, '\P{^indogra}', "");
    Expect(1, 71759, '\p{IN_dogra}', "");
    Expect(0, 71759, '\p{^IN_dogra}', "");
    Expect(0, 71759, '\P{IN_dogra}', "");
    Expect(1, 71759, '\P{^IN_dogra}', "");
    Expect(0, 71760, '\p{IN_dogra}', "");
    Expect(1, 71760, '\p{^IN_dogra}', "");
    Expect(1, 71760, '\P{IN_dogra}', "");
    Expect(0, 71760, '\P{^IN_dogra}', "");
    Error('\p{:= In_dogra}');
    Error('\P{:= In_dogra}');
    Expect(1, 71759, '\p{	In_dogra}', "");
    Expect(0, 71759, '\p{^	In_dogra}', "");
    Expect(0, 71759, '\P{	In_dogra}', "");
    Expect(1, 71759, '\P{^	In_dogra}', "");
    Expect(0, 71760, '\p{	In_dogra}', "");
    Expect(1, 71760, '\p{^	In_dogra}', "");
    Expect(1, 71760, '\P{	In_dogra}', "");
    Expect(0, 71760, '\P{^	In_dogra}', "");
    Error('\p{/a/-IN_DUPLOYAN}');
    Error('\P{/a/-IN_DUPLOYAN}');
    Expect(1, 113823, '\p{induployan}', "");
    Expect(0, 113823, '\p{^induployan}', "");
    Expect(0, 113823, '\P{induployan}', "");
    Expect(1, 113823, '\P{^induployan}', "");
    Expect(0, 113824, '\p{induployan}', "");
    Expect(1, 113824, '\p{^induployan}', "");
    Expect(1, 113824, '\P{induployan}', "");
    Expect(0, 113824, '\P{^induployan}', "");
    Expect(1, 113823, '\p{ IN_duployan}', "");
    Expect(0, 113823, '\p{^ IN_duployan}', "");
    Expect(0, 113823, '\P{ IN_duployan}', "");
    Expect(1, 113823, '\P{^ IN_duployan}', "");
    Expect(0, 113824, '\p{ IN_duployan}', "");
    Expect(1, 113824, '\p{^ IN_duployan}', "");
    Expect(1, 113824, '\P{ IN_duployan}', "");
    Expect(0, 113824, '\P{^ IN_duployan}', "");
    Error('\p{ /a/in_Duployan}');
    Error('\P{ /a/in_Duployan}');
    Expect(1, 113823, '\p{_-In_Duployan}', "");
    Expect(0, 113823, '\p{^_-In_Duployan}', "");
    Expect(0, 113823, '\P{_-In_Duployan}', "");
    Expect(1, 113823, '\P{^_-In_Duployan}', "");
    Expect(0, 113824, '\p{_-In_Duployan}', "");
    Expect(1, 113824, '\p{^_-In_Duployan}', "");
    Expect(1, 113824, '\P{_-In_Duployan}', "");
    Expect(0, 113824, '\P{^_-In_Duployan}', "");
    Error('\p{		In_egyptian_Hieroglyphs:=}');
    Error('\P{		In_egyptian_Hieroglyphs:=}');
    Expect(1, 78895, '\p{inegyptianhieroglyphs}', "");
    Expect(0, 78895, '\p{^inegyptianhieroglyphs}', "");
    Expect(0, 78895, '\P{inegyptianhieroglyphs}', "");
    Expect(1, 78895, '\P{^inegyptianhieroglyphs}', "");
    Expect(0, 78896, '\p{inegyptianhieroglyphs}', "");
    Expect(1, 78896, '\p{^inegyptianhieroglyphs}', "");
    Expect(1, 78896, '\P{inegyptianhieroglyphs}', "");
    Expect(0, 78896, '\P{^inegyptianhieroglyphs}', "");
    Expect(1, 78895, '\p{ In_Egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\p{^ In_Egyptian_Hieroglyphs}', "");
    Expect(0, 78895, '\P{ In_Egyptian_Hieroglyphs}', "");
    Expect(1, 78895, '\P{^ In_Egyptian_Hieroglyphs}', "");
    Expect(0, 78896, '\p{ In_Egyptian_Hieroglyphs}', "");
    Expect(1, 78896, '\p{^ In_Egyptian_Hieroglyphs}', "");
    Expect(1, 78896, '\P{ In_Egyptian_Hieroglyphs}', "");
    Expect(0, 78896, '\P{^ In_Egyptian_Hieroglyphs}', "");
    Error('\p{/a/  In_Egyptian_Hieroglyphs}');
    Error('\P{/a/  In_Egyptian_Hieroglyphs}');
    Expect(1, 78895, '\p{	 In_egyptian_HIEROGLYPHS}', "");
    Expect(0, 78895, '\p{^	 In_egyptian_HIEROGLYPHS}', "");
    Expect(0, 78895, '\P{	 In_egyptian_HIEROGLYPHS}', "");
    Expect(1, 78895, '\P{^	 In_egyptian_HIEROGLYPHS}', "");
    Expect(0, 78896, '\p{	 In_egyptian_HIEROGLYPHS}', "");
    Expect(1, 78896, '\p{^	 In_egyptian_HIEROGLYPHS}', "");
    Expect(1, 78896, '\P{	 In_egyptian_HIEROGLYPHS}', "");
    Expect(0, 78896, '\P{^	 In_egyptian_HIEROGLYPHS}', "");
    Error('\p{ -In_Elbasan/a/}');
    Error('\P{ -In_Elbasan/a/}');
    Expect(1, 66863, '\p{inelbasan}', "");
    Expect(0, 66863, '\p{^inelbasan}', "");
    Expect(0, 66863, '\P{inelbasan}', "");
    Expect(1, 66863, '\P{^inelbasan}', "");
    Expect(0, 66864, '\p{inelbasan}', "");
    Expect(1, 66864, '\p{^inelbasan}', "");
    Expect(1, 66864, '\P{inelbasan}', "");
    Expect(0, 66864, '\P{^inelbasan}', "");
    Expect(1, 66863, '\p{		In_Elbasan}', "");
    Expect(0, 66863, '\p{^		In_Elbasan}', "");
    Expect(0, 66863, '\P{		In_Elbasan}', "");
    Expect(1, 66863, '\P{^		In_Elbasan}', "");
    Expect(0, 66864, '\p{		In_Elbasan}', "");
    Expect(1, 66864, '\p{^		In_Elbasan}', "");
    Expect(1, 66864, '\P{		In_Elbasan}', "");
    Expect(0, 66864, '\P{^		In_Elbasan}', "");
    Error('\p{_/a/in_elbasan}');
    Error('\P{_/a/in_elbasan}');
    Expect(1, 66863, '\p{ _In_elbasan}', "");
    Expect(0, 66863, '\p{^ _In_elbasan}', "");
    Expect(0, 66863, '\P{ _In_elbasan}', "");
    Expect(1, 66863, '\P{^ _In_elbasan}', "");
    Expect(0, 66864, '\p{ _In_elbasan}', "");
    Expect(1, 66864, '\p{^ _In_elbasan}', "");
    Expect(1, 66864, '\P{ _In_elbasan}', "");
    Expect(0, 66864, '\P{^ _In_elbasan}', "");
    Error('\p{	:=In_Elymaic}');
    Error('\P{	:=In_Elymaic}');
    Expect(1, 69631, '\p{inelymaic}', "");
    Expect(0, 69631, '\p{^inelymaic}', "");
    Expect(0, 69631, '\P{inelymaic}', "");
    Expect(1, 69631, '\P{^inelymaic}', "");
    Expect(0, 69632, '\p{inelymaic}', "");
    Expect(1, 69632, '\p{^inelymaic}', "");
    Expect(1, 69632, '\P{inelymaic}', "");
    Expect(0, 69632, '\P{^inelymaic}', "");
    Expect(1, 69631, '\p{	In_Elymaic}', "");
    Expect(0, 69631, '\p{^	In_Elymaic}', "");
    Expect(0, 69631, '\P{	In_Elymaic}', "");
    Expect(1, 69631, '\P{^	In_Elymaic}', "");
    Expect(0, 69632, '\p{	In_Elymaic}', "");
    Expect(1, 69632, '\p{^	In_Elymaic}', "");
    Expect(1, 69632, '\P{	In_Elymaic}', "");
    Expect(0, 69632, '\P{^	In_Elymaic}', "");
    Error('\p{:=_ IN_elymaic}');
    Error('\P{:=_ IN_elymaic}');
    Expect(1, 69631, '\p{_In_ELYMAIC}', "");
    Expect(0, 69631, '\p{^_In_ELYMAIC}', "");
    Expect(0, 69631, '\P{_In_ELYMAIC}', "");
    Expect(1, 69631, '\P{^_In_ELYMAIC}', "");
    Expect(0, 69632, '\p{_In_ELYMAIC}', "");
    Expect(1, 69632, '\p{^_In_ELYMAIC}', "");
    Expect(1, 69632, '\P{_In_ELYMAIC}', "");
    Expect(0, 69632, '\P{^_In_ELYMAIC}', "");
    Error('\p{:= -IN_ETHIOPIC}');
    Error('\P{:= -IN_ETHIOPIC}');
    Expect(1, 4991, '\p{inethiopic}', "");
    Expect(0, 4991, '\p{^inethiopic}', "");
    Expect(0, 4991, '\P{inethiopic}', "");
    Expect(1, 4991, '\P{^inethiopic}', "");
    Expect(0, 4992, '\p{inethiopic}', "");
    Expect(1, 4992, '\p{^inethiopic}', "");
    Expect(1, 4992, '\P{inethiopic}', "");
    Expect(0, 4992, '\P{^inethiopic}', "");
    Expect(1, 4991, '\p{--in_ETHIOPIC}', "");
    Expect(0, 4991, '\p{^--in_ETHIOPIC}', "");
    Expect(0, 4991, '\P{--in_ETHIOPIC}', "");
    Expect(1, 4991, '\P{^--in_ETHIOPIC}', "");
    Expect(0, 4992, '\p{--in_ETHIOPIC}', "");
    Expect(1, 4992, '\p{^--in_ETHIOPIC}', "");
    Expect(1, 4992, '\P{--in_ETHIOPIC}', "");
    Expect(0, 4992, '\P{^--in_ETHIOPIC}', "");
    Error('\p{ -IN_Ethiopic/a/}');
    Error('\P{ -IN_Ethiopic/a/}');
    Expect(1, 4991, '\p{- In_ethiopic}', "");
    Expect(0, 4991, '\p{^- In_ethiopic}', "");
    Expect(0, 4991, '\P{- In_ethiopic}', "");
    Expect(1, 4991, '\P{^- In_ethiopic}', "");
    Expect(0, 4992, '\p{- In_ethiopic}', "");
    Expect(1, 4992, '\p{^- In_ethiopic}', "");
    Expect(1, 4992, '\P{- In_ethiopic}', "");
    Expect(0, 4992, '\P{^- In_ethiopic}', "");
    Error('\p{ /a/in_Georgian}');
    Error('\P{ /a/in_Georgian}');
    Expect(1, 4351, '\p{ingeorgian}', "");
    Expect(0, 4351, '\p{^ingeorgian}', "");
    Expect(0, 4351, '\P{ingeorgian}', "");
    Expect(1, 4351, '\P{^ingeorgian}', "");
    Expect(0, 4352, '\p{ingeorgian}', "");
    Expect(1, 4352, '\p{^ingeorgian}', "");
    Expect(1, 4352, '\P{ingeorgian}', "");
    Expect(0, 4352, '\P{^ingeorgian}', "");
    Expect(1, 4351, '\p{ -In_Georgian}', "");
    Expect(0, 4351, '\p{^ -In_Georgian}', "");
    Expect(0, 4351, '\P{ -In_Georgian}', "");
    Expect(1, 4351, '\P{^ -In_Georgian}', "");
    Expect(0, 4352, '\p{ -In_Georgian}', "");
    Expect(1, 4352, '\p{^ -In_Georgian}', "");
    Expect(1, 4352, '\P{ -In_Georgian}', "");
    Expect(0, 4352, '\P{^ -In_Georgian}', "");
    Error('\p{-_In_GEORGIAN:=}');
    Error('\P{-_In_GEORGIAN:=}');
    Expect(1, 4351, '\p{In_georgian}', "");
    Expect(0, 4351, '\p{^In_georgian}', "");
    Expect(0, 4351, '\P{In_georgian}', "");
    Expect(1, 4351, '\P{^In_georgian}', "");
    Expect(0, 4352, '\p{In_georgian}', "");
    Expect(1, 4352, '\p{^In_georgian}', "");
    Expect(1, 4352, '\P{In_georgian}', "");
    Expect(0, 4352, '\P{^In_georgian}', "");
    Error('\p{_-IN_GLAGOLITIC:=}');
    Error('\P{_-IN_GLAGOLITIC:=}');
    Expect(1, 11359, '\p{inglagolitic}', "");
    Expect(0, 11359, '\p{^inglagolitic}', "");
    Expect(0, 11359, '\P{inglagolitic}', "");
    Expect(1, 11359, '\P{^inglagolitic}', "");
    Expect(0, 11360, '\p{inglagolitic}', "");
    Expect(1, 11360, '\p{^inglagolitic}', "");
    Expect(1, 11360, '\P{inglagolitic}', "");
    Expect(0, 11360, '\P{^inglagolitic}', "");
    Expect(1, 11359, '\p{	IN_GLAGOLITIC}', "");
    Expect(0, 11359, '\p{^	IN_GLAGOLITIC}', "");
    Expect(0, 11359, '\P{	IN_GLAGOLITIC}', "");
    Expect(1, 11359, '\P{^	IN_GLAGOLITIC}', "");
    Expect(0, 11360, '\p{	IN_GLAGOLITIC}', "");
    Expect(1, 11360, '\p{^	IN_GLAGOLITIC}', "");
    Expect(1, 11360, '\P{	IN_GLAGOLITIC}', "");
    Expect(0, 11360, '\P{^	IN_GLAGOLITIC}', "");
    Error('\p{ :=in_Glagolitic}');
    Error('\P{ :=in_Glagolitic}');
    Expect(1, 11359, '\p{	-IN_Glagolitic}', "");
    Expect(0, 11359, '\p{^	-IN_Glagolitic}', "");
    Expect(0, 11359, '\P{	-IN_Glagolitic}', "");
    Expect(1, 11359, '\P{^	-IN_Glagolitic}', "");
    Expect(0, 11360, '\p{	-IN_Glagolitic}', "");
    Expect(1, 11360, '\p{^	-IN_Glagolitic}', "");
    Expect(1, 11360, '\P{	-IN_Glagolitic}', "");
    Expect(0, 11360, '\P{^	-IN_Glagolitic}', "");
    Error('\p{-_IN_gothic:=}');
    Error('\P{-_IN_gothic:=}');
    Expect(1, 66383, '\p{ingothic}', "");
    Expect(0, 66383, '\p{^ingothic}', "");
    Expect(0, 66383, '\P{ingothic}', "");
    Expect(1, 66383, '\P{^ingothic}', "");
    Expect(0, 66384, '\p{ingothic}', "");
    Expect(1, 66384, '\p{^ingothic}', "");
    Expect(1, 66384, '\P{ingothic}', "");
    Expect(0, 66384, '\P{^ingothic}', "");
    Expect(1, 66383, '\p{-IN_Gothic}', "");
    Expect(0, 66383, '\p{^-IN_Gothic}', "");
    Expect(0, 66383, '\P{-IN_Gothic}', "");
    Expect(1, 66383, '\P{^-IN_Gothic}', "");
    Expect(0, 66384, '\p{-IN_Gothic}', "");
    Expect(1, 66384, '\p{^-IN_Gothic}', "");
    Expect(1, 66384, '\P{-IN_Gothic}', "");
    Expect(0, 66384, '\P{^-IN_Gothic}', "");
    Error('\p{ :=IN_gothic}');
    Error('\P{ :=IN_gothic}');
    Expect(1, 66383, '\p{ _IN_GOTHIC}', "");
    Expect(0, 66383, '\p{^ _IN_GOTHIC}', "");
    Expect(0, 66383, '\P{ _IN_GOTHIC}', "");
    Expect(1, 66383, '\P{^ _IN_GOTHIC}', "");
    Expect(0, 66384, '\p{ _IN_GOTHIC}', "");
    Expect(1, 66384, '\p{^ _IN_GOTHIC}', "");
    Expect(1, 66384, '\P{ _IN_GOTHIC}', "");
    Expect(0, 66384, '\P{^ _IN_GOTHIC}', "");
    Error('\p{/a/	 In_grantha}');
    Error('\P{/a/	 In_grantha}');
    Expect(1, 70527, '\p{ingrantha}', "");
    Expect(0, 70527, '\p{^ingrantha}', "");
    Expect(0, 70527, '\P{ingrantha}', "");
    Expect(1, 70527, '\P{^ingrantha}', "");
    Expect(0, 70528, '\p{ingrantha}', "");
    Expect(1, 70528, '\p{^ingrantha}', "");
    Expect(1, 70528, '\P{ingrantha}', "");
    Expect(0, 70528, '\P{^ingrantha}', "");
    Expect(1, 70527, '\p{__In_Grantha}', "");
    Expect(0, 70527, '\p{^__In_Grantha}', "");
    Expect(0, 70527, '\P{__In_Grantha}', "");
    Expect(1, 70527, '\P{^__In_Grantha}', "");
    Expect(0, 70528, '\p{__In_Grantha}', "");
    Expect(1, 70528, '\p{^__In_Grantha}', "");
    Expect(1, 70528, '\P{__In_Grantha}', "");
    Expect(0, 70528, '\P{^__In_Grantha}', "");
    Error('\p{	/a/In_GRANTHA}');
    Error('\P{	/a/In_GRANTHA}');
    Expect(1, 70527, '\p{ In_Grantha}', "");
    Expect(0, 70527, '\p{^ In_Grantha}', "");
    Expect(0, 70527, '\P{ In_Grantha}', "");
    Expect(1, 70527, '\P{^ In_Grantha}', "");
    Expect(0, 70528, '\p{ In_Grantha}', "");
    Expect(1, 70528, '\p{^ In_Grantha}', "");
    Expect(1, 70528, '\P{ In_Grantha}', "");
    Expect(0, 70528, '\P{^ In_Grantha}', "");
    Error('\p{  in_GUJARATI:=}');
    Error('\P{  in_GUJARATI:=}');
    Expect(1, 2815, '\p{ingujarati}', "");
    Expect(0, 2815, '\p{^ingujarati}', "");
    Expect(0, 2815, '\P{ingujarati}', "");
    Expect(1, 2815, '\P{^ingujarati}', "");
    Expect(0, 2816, '\p{ingujarati}', "");
    Expect(1, 2816, '\p{^ingujarati}', "");
    Expect(1, 2816, '\P{ingujarati}', "");
    Expect(0, 2816, '\P{^ingujarati}', "");
    Expect(1, 2815, '\p{- In_Gujarati}', "");
    Expect(0, 2815, '\p{^- In_Gujarati}', "");
    Expect(0, 2815, '\P{- In_Gujarati}', "");
    Expect(1, 2815, '\P{^- In_Gujarati}', "");
    Expect(0, 2816, '\p{- In_Gujarati}', "");
    Expect(1, 2816, '\p{^- In_Gujarati}', "");
    Expect(1, 2816, '\P{- In_Gujarati}', "");
    Expect(0, 2816, '\P{^- In_Gujarati}', "");
    Error('\p{	 in_Gujarati:=}');
    Error('\P{	 in_Gujarati:=}');
    Expect(1, 2815, '\p{_-IN_gujarati}', "");
    Expect(0, 2815, '\p{^_-IN_gujarati}', "");
    Expect(0, 2815, '\P{_-IN_gujarati}', "");
    Expect(1, 2815, '\P{^_-IN_gujarati}', "");
    Expect(0, 2816, '\p{_-IN_gujarati}', "");
    Expect(1, 2816, '\p{^_-IN_gujarati}', "");
    Expect(1, 2816, '\P{_-IN_gujarati}', "");
    Expect(0, 2816, '\P{^_-IN_gujarati}', "");
    Error('\p{_	In_Gunjala_Gondi:=}');
    Error('\P{_	In_Gunjala_Gondi:=}');
    Expect(1, 73135, '\p{ingunjalagondi}', "");
    Expect(0, 73135, '\p{^ingunjalagondi}', "");
    Expect(0, 73135, '\P{ingunjalagondi}', "");
    Expect(1, 73135, '\P{^ingunjalagondi}', "");
    Expect(0, 73136, '\p{ingunjalagondi}', "");
    Expect(1, 73136, '\p{^ingunjalagondi}', "");
    Expect(1, 73136, '\P{ingunjalagondi}', "");
    Expect(0, 73136, '\P{^ingunjalagondi}', "");
    Expect(1, 73135, '\p{__In_Gunjala_GONDI}', "");
    Expect(0, 73135, '\p{^__In_Gunjala_GONDI}', "");
    Expect(0, 73135, '\P{__In_Gunjala_GONDI}', "");
    Expect(1, 73135, '\P{^__In_Gunjala_GONDI}', "");
    Expect(0, 73136, '\p{__In_Gunjala_GONDI}', "");
    Expect(1, 73136, '\p{^__In_Gunjala_GONDI}', "");
    Expect(1, 73136, '\P{__In_Gunjala_GONDI}', "");
    Expect(0, 73136, '\P{^__In_Gunjala_GONDI}', "");
    Error('\p{:=_-In_GUNJALA_gondi}');
    Error('\P{:=_-In_GUNJALA_gondi}');
    Expect(1, 73135, '\p{-	in_gunjala_GONDI}', "");
    Expect(0, 73135, '\p{^-	in_gunjala_GONDI}', "");
    Expect(0, 73135, '\P{-	in_gunjala_GONDI}', "");
    Expect(1, 73135, '\P{^-	in_gunjala_GONDI}', "");
    Expect(0, 73136, '\p{-	in_gunjala_GONDI}', "");
    Expect(1, 73136, '\p{^-	in_gunjala_GONDI}', "");
    Expect(1, 73136, '\P{-	in_gunjala_GONDI}', "");
    Expect(0, 73136, '\P{^-	in_gunjala_GONDI}', "");
    Error('\p{:=-In_Gurmukhi}');
    Error('\P{:=-In_Gurmukhi}');
    Expect(1, 2687, '\p{ingurmukhi}', "");
    Expect(0, 2687, '\p{^ingurmukhi}', "");
    Expect(0, 2687, '\P{ingurmukhi}', "");
    Expect(1, 2687, '\P{^ingurmukhi}', "");
    Expect(0, 2688, '\p{ingurmukhi}', "");
    Expect(1, 2688, '\p{^ingurmukhi}', "");
    Expect(1, 2688, '\P{ingurmukhi}', "");
    Expect(0, 2688, '\P{^ingurmukhi}', "");
    Expect(1, 2687, '\p{IN_gurmukhi}', "");
    Expect(0, 2687, '\p{^IN_gurmukhi}', "");
    Expect(0, 2687, '\P{IN_gurmukhi}', "");
    Expect(1, 2687, '\P{^IN_gurmukhi}', "");
    Expect(0, 2688, '\p{IN_gurmukhi}', "");
    Expect(1, 2688, '\p{^IN_gurmukhi}', "");
    Expect(1, 2688, '\P{IN_gurmukhi}', "");
    Expect(0, 2688, '\P{^IN_gurmukhi}', "");
    Error('\p{:=-_IN_Gurmukhi}');
    Error('\P{:=-_IN_Gurmukhi}');
    Expect(1, 2687, '\p{ In_gurmukhi}', "");
    Expect(0, 2687, '\p{^ In_gurmukhi}', "");
    Expect(0, 2687, '\P{ In_gurmukhi}', "");
    Expect(1, 2687, '\P{^ In_gurmukhi}', "");
    Expect(0, 2688, '\p{ In_gurmukhi}', "");
    Expect(1, 2688, '\p{^ In_gurmukhi}', "");
    Expect(1, 2688, '\P{ In_gurmukhi}', "");
    Expect(0, 2688, '\P{^ In_gurmukhi}', "");
    Error('\p{ _in_Hanifi_ROHINGYA/a/}');
    Error('\P{ _in_Hanifi_ROHINGYA/a/}');
    Expect(1, 68927, '\p{inhanifirohingya}', "");
    Expect(0, 68927, '\p{^inhanifirohingya}', "");
    Expect(0, 68927, '\P{inhanifirohingya}', "");
    Expect(1, 68927, '\P{^inhanifirohingya}', "");
    Expect(0, 68928, '\p{inhanifirohingya}', "");
    Expect(1, 68928, '\p{^inhanifirohingya}', "");
    Expect(1, 68928, '\P{inhanifirohingya}', "");
    Expect(0, 68928, '\P{^inhanifirohingya}', "");
    Expect(1, 68927, '\p{__In_Hanifi_Rohingya}', "");
    Expect(0, 68927, '\p{^__In_Hanifi_Rohingya}', "");
    Expect(0, 68927, '\P{__In_Hanifi_Rohingya}', "");
    Expect(1, 68927, '\P{^__In_Hanifi_Rohingya}', "");
    Expect(0, 68928, '\p{__In_Hanifi_Rohingya}', "");
    Expect(1, 68928, '\p{^__In_Hanifi_Rohingya}', "");
    Expect(1, 68928, '\P{__In_Hanifi_Rohingya}', "");
    Expect(0, 68928, '\P{^__In_Hanifi_Rohingya}', "");
    Error('\p{:=In_Hanifi_Rohingya}');
    Error('\P{:=In_Hanifi_Rohingya}');
    Expect(1, 68927, '\p{ 	in_Hanifi_rohingya}', "");
    Expect(0, 68927, '\p{^ 	in_Hanifi_rohingya}', "");
    Expect(0, 68927, '\P{ 	in_Hanifi_rohingya}', "");
    Expect(1, 68927, '\P{^ 	in_Hanifi_rohingya}', "");
    Expect(0, 68928, '\p{ 	in_Hanifi_rohingya}', "");
    Expect(1, 68928, '\p{^ 	in_Hanifi_rohingya}', "");
    Expect(1, 68928, '\P{ 	in_Hanifi_rohingya}', "");
    Expect(0, 68928, '\P{^ 	in_Hanifi_rohingya}', "");
    Error('\p{	:=IN_HANUNOO}');
    Error('\P{	:=IN_HANUNOO}');
    Expect(1, 5951, '\p{inhanunoo}', "");
    Expect(0, 5951, '\p{^inhanunoo}', "");
    Expect(0, 5951, '\P{inhanunoo}', "");
    Expect(1, 5951, '\P{^inhanunoo}', "");
    Expect(0, 5952, '\p{inhanunoo}', "");
    Expect(1, 5952, '\p{^inhanunoo}', "");
    Expect(1, 5952, '\P{inhanunoo}', "");
    Expect(0, 5952, '\P{^inhanunoo}', "");
    Expect(1, 5951, '\p{- in_HANUNOO}', "");
    Expect(0, 5951, '\p{^- in_HANUNOO}', "");
    Expect(0, 5951, '\P{- in_HANUNOO}', "");
    Expect(1, 5951, '\P{^- in_HANUNOO}', "");
    Expect(0, 5952, '\p{- in_HANUNOO}', "");
    Expect(1, 5952, '\p{^- in_HANUNOO}', "");
    Expect(1, 5952, '\P{- in_HANUNOO}', "");
    Expect(0, 5952, '\P{^- in_HANUNOO}', "");
    Error('\p{/a/_ in_hanunoo}');
    Error('\P{/a/_ in_hanunoo}');
    Expect(1, 5951, '\p{ 	IN_hanunoo}', "");
    Expect(0, 5951, '\p{^ 	IN_hanunoo}', "");
    Expect(0, 5951, '\P{ 	IN_hanunoo}', "");
    Expect(1, 5951, '\P{^ 	IN_hanunoo}', "");
    Expect(0, 5952, '\p{ 	IN_hanunoo}', "");
    Expect(1, 5952, '\p{^ 	IN_hanunoo}', "");
    Expect(1, 5952, '\P{ 	IN_hanunoo}', "");
    Expect(0, 5952, '\P{^ 	IN_hanunoo}', "");
    Error('\p{-in_Hatran:=}');
    Error('\P{-in_Hatran:=}');
    Expect(1, 67839, '\p{inhatran}', "");
    Expect(0, 67839, '\p{^inhatran}', "");
    Expect(0, 67839, '\P{inhatran}', "");
    Expect(1, 67839, '\P{^inhatran}', "");
    Expect(0, 67840, '\p{inhatran}', "");
    Expect(1, 67840, '\p{^inhatran}', "");
    Expect(1, 67840, '\P{inhatran}', "");
    Expect(0, 67840, '\P{^inhatran}', "");
    Expect(1, 67839, '\p{ IN_Hatran}', "");
    Expect(0, 67839, '\p{^ IN_Hatran}', "");
    Expect(0, 67839, '\P{ IN_Hatran}', "");
    Expect(1, 67839, '\P{^ IN_Hatran}', "");
    Expect(0, 67840, '\p{ IN_Hatran}', "");
    Expect(1, 67840, '\p{^ IN_Hatran}', "");
    Expect(1, 67840, '\P{ IN_Hatran}', "");
    Expect(0, 67840, '\P{^ IN_Hatran}', "");
    Error('\p{ in_Hatran/a/}');
    Error('\P{ in_Hatran/a/}');
    Expect(1, 67839, '\p{ -in_Hatran}', "");
    Expect(0, 67839, '\p{^ -in_Hatran}', "");
    Expect(0, 67839, '\P{ -in_Hatran}', "");
    Expect(1, 67839, '\P{^ -in_Hatran}', "");
    Expect(0, 67840, '\p{ -in_Hatran}', "");
    Expect(1, 67840, '\p{^ -in_Hatran}', "");
    Expect(1, 67840, '\P{ -in_Hatran}', "");
    Expect(0, 67840, '\P{^ -in_Hatran}', "");
    Error('\p{		IN_Hebrew:=}');
    Error('\P{		IN_Hebrew:=}');
    Expect(1, 1535, '\p{inhebrew}', "");
    Expect(0, 1535, '\p{^inhebrew}', "");
    Expect(0, 1535, '\P{inhebrew}', "");
    Expect(1, 1535, '\P{^inhebrew}', "");
    Expect(0, 1536, '\p{inhebrew}', "");
    Expect(1, 1536, '\p{^inhebrew}', "");
    Expect(1, 1536, '\P{inhebrew}', "");
    Expect(0, 1536, '\P{^inhebrew}', "");
    Expect(1, 1535, '\p{	 IN_hebrew}', "");
    Expect(0, 1535, '\p{^	 IN_hebrew}', "");
    Expect(0, 1535, '\P{	 IN_hebrew}', "");
    Expect(1, 1535, '\P{^	 IN_hebrew}', "");
    Expect(0, 1536, '\p{	 IN_hebrew}', "");
    Expect(1, 1536, '\p{^	 IN_hebrew}', "");
    Expect(1, 1536, '\P{	 IN_hebrew}', "");
    Expect(0, 1536, '\P{^	 IN_hebrew}', "");
    Error('\p{:=__in_Hebrew}');
    Error('\P{:=__in_Hebrew}');
    Expect(1, 1535, '\p{_ In_Hebrew}', "");
    Expect(0, 1535, '\p{^_ In_Hebrew}', "");
    Expect(0, 1535, '\P{_ In_Hebrew}', "");
    Expect(1, 1535, '\P{^_ In_Hebrew}', "");
    Expect(0, 1536, '\p{_ In_Hebrew}', "");
    Expect(1, 1536, '\p{^_ In_Hebrew}', "");
    Expect(1, 1536, '\P{_ In_Hebrew}', "");
    Expect(0, 1536, '\P{^_ In_Hebrew}', "");
    Error('\p{-/a/In_Hiragana}');
    Error('\P{-/a/In_Hiragana}');
    Expect(1, 12447, '\p{inhiragana}', "");
    Expect(0, 12447, '\p{^inhiragana}', "");
    Expect(0, 12447, '\P{inhiragana}', "");
    Expect(1, 12447, '\P{^inhiragana}', "");
    Expect(0, 12448, '\p{inhiragana}', "");
    Expect(1, 12448, '\p{^inhiragana}', "");
    Expect(1, 12448, '\P{inhiragana}', "");
    Expect(0, 12448, '\P{^inhiragana}', "");
    Expect(1, 12447, '\p{_IN_Hiragana}', "");
    Expect(0, 12447, '\p{^_IN_Hiragana}', "");
    Expect(0, 12447, '\P{_IN_Hiragana}', "");
    Expect(1, 12447, '\P{^_IN_Hiragana}', "");
    Expect(0, 12448, '\p{_IN_Hiragana}', "");
    Expect(1, 12448, '\p{^_IN_Hiragana}', "");
    Expect(1, 12448, '\P{_IN_Hiragana}', "");
    Expect(0, 12448, '\P{^_IN_Hiragana}', "");
    Error('\p{:=  In_hiragana}');
    Error('\P{:=  In_hiragana}');
    Expect(1, 12447, '\p{_-In_Hiragana}', "");
    Expect(0, 12447, '\p{^_-In_Hiragana}', "");
    Expect(0, 12447, '\P{_-In_Hiragana}', "");
    Expect(1, 12447, '\P{^_-In_Hiragana}', "");
    Expect(0, 12448, '\p{_-In_Hiragana}', "");
    Expect(1, 12448, '\p{^_-In_Hiragana}', "");
    Expect(1, 12448, '\P{_-In_Hiragana}', "");
    Expect(0, 12448, '\P{^_-In_Hiragana}', "");
    Error('\p{	In_Imperial_ARAMAIC/a/}');
    Error('\P{	In_Imperial_ARAMAIC/a/}');
    Expect(1, 67679, '\p{inimperialaramaic}', "");
    Expect(0, 67679, '\p{^inimperialaramaic}', "");
    Expect(0, 67679, '\P{inimperialaramaic}', "");
    Expect(1, 67679, '\P{^inimperialaramaic}', "");
    Expect(0, 67680, '\p{inimperialaramaic}', "");
    Expect(1, 67680, '\p{^inimperialaramaic}', "");
    Expect(1, 67680, '\P{inimperialaramaic}', "");
    Expect(0, 67680, '\P{^inimperialaramaic}', "");
    Expect(1, 67679, '\p{-	In_imperial_Aramaic}', "");
    Expect(0, 67679, '\p{^-	In_imperial_Aramaic}', "");
    Expect(0, 67679, '\P{-	In_imperial_Aramaic}', "");
    Expect(1, 67679, '\P{^-	In_imperial_Aramaic}', "");
    Expect(0, 67680, '\p{-	In_imperial_Aramaic}', "");
    Expect(1, 67680, '\p{^-	In_imperial_Aramaic}', "");
    Expect(1, 67680, '\P{-	In_imperial_Aramaic}', "");
    Expect(0, 67680, '\P{^-	In_imperial_Aramaic}', "");
    Error('\p{_/a/IN_Imperial_ARAMAIC}');
    Error('\P{_/a/IN_Imperial_ARAMAIC}');
    Expect(1, 67679, '\p{ -in_IMPERIAL_Aramaic}', "");
    Expect(0, 67679, '\p{^ -in_IMPERIAL_Aramaic}', "");
    Expect(0, 67679, '\P{ -in_IMPERIAL_Aramaic}', "");
    Expect(1, 67679, '\P{^ -in_IMPERIAL_Aramaic}', "");
    Expect(0, 67680, '\p{ -in_IMPERIAL_Aramaic}', "");
    Expect(1, 67680, '\p{^ -in_IMPERIAL_Aramaic}', "");
    Expect(1, 67680, '\P{ -in_IMPERIAL_Aramaic}', "");
    Expect(0, 67680, '\P{^ -in_IMPERIAL_Aramaic}', "");
    Error('\p{/a/-_IN_Inscriptional_PAHLAVI}');
    Error('\P{/a/-_IN_Inscriptional_PAHLAVI}');
    Expect(1, 68479, '\p{ininscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^ininscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{ininscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^ininscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{ininscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^ininscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{ininscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^ininscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{		In_inscriptional_pahlavi}', "");
    Expect(0, 68479, '\p{^		In_inscriptional_pahlavi}', "");
    Expect(0, 68479, '\P{		In_inscriptional_pahlavi}', "");
    Expect(1, 68479, '\P{^		In_inscriptional_pahlavi}', "");
    Expect(0, 68480, '\p{		In_inscriptional_pahlavi}', "");
    Expect(1, 68480, '\p{^		In_inscriptional_pahlavi}', "");
    Expect(1, 68480, '\P{		In_inscriptional_pahlavi}', "");
    Expect(0, 68480, '\P{^		In_inscriptional_pahlavi}', "");
    Error('\p{:=-_In_INSCRIPTIONAL_pahlavi}');
    Error('\P{:=-_In_INSCRIPTIONAL_pahlavi}');
    Expect(1, 68479, '\p{--In_inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\p{^--In_inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\P{--In_inscriptional_Pahlavi}', "");
    Expect(1, 68479, '\P{^--In_inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\p{--In_inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\p{^--In_inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\P{--In_inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\P{^--In_inscriptional_Pahlavi}', "");
    Error('\p{	In_Inscriptional_PARTHIAN:=}');
    Error('\P{	In_Inscriptional_PARTHIAN:=}');
    Expect(1, 68447, '\p{ininscriptionalparthian}', "");
    Expect(0, 68447, '\p{^ininscriptionalparthian}', "");
    Expect(0, 68447, '\P{ininscriptionalparthian}', "");
    Expect(1, 68447, '\P{^ininscriptionalparthian}', "");
    Expect(0, 68448, '\p{ininscriptionalparthian}', "");
    Expect(1, 68448, '\p{^ininscriptionalparthian}', "");
    Expect(1, 68448, '\P{ininscriptionalparthian}', "");
    Expect(0, 68448, '\P{^ininscriptionalparthian}', "");
    Expect(1, 68447, '\p{ -in_inscriptional_PARTHIAN}', "");
    Expect(0, 68447, '\p{^ -in_inscriptional_PARTHIAN}', "");
    Expect(0, 68447, '\P{ -in_inscriptional_PARTHIAN}', "");
    Expect(1, 68447, '\P{^ -in_inscriptional_PARTHIAN}', "");
    Expect(0, 68448, '\p{ -in_inscriptional_PARTHIAN}', "");
    Expect(1, 68448, '\p{^ -in_inscriptional_PARTHIAN}', "");
    Expect(1, 68448, '\P{ -in_inscriptional_PARTHIAN}', "");
    Expect(0, 68448, '\P{^ -in_inscriptional_PARTHIAN}', "");
    Error('\p{ In_Inscriptional_Parthian/a/}');
    Error('\P{ In_Inscriptional_Parthian/a/}');
    Expect(1, 68447, '\p{_	In_inscriptional_Parthian}', "");
    Expect(0, 68447, '\p{^_	In_inscriptional_Parthian}', "");
    Expect(0, 68447, '\P{_	In_inscriptional_Parthian}', "");
    Expect(1, 68447, '\P{^_	In_inscriptional_Parthian}', "");
    Expect(0, 68448, '\p{_	In_inscriptional_Parthian}', "");
    Expect(1, 68448, '\p{^_	In_inscriptional_Parthian}', "");
    Expect(1, 68448, '\P{_	In_inscriptional_Parthian}', "");
    Expect(0, 68448, '\P{^_	In_inscriptional_Parthian}', "");
    Error('\p{  In_javanese:=}');
    Error('\P{  In_javanese:=}');
    Expect(1, 43487, '\p{injavanese}', "");
    Expect(0, 43487, '\p{^injavanese}', "");
    Expect(0, 43487, '\P{injavanese}', "");
    Expect(1, 43487, '\P{^injavanese}', "");
    Expect(0, 43488, '\p{injavanese}', "");
    Expect(1, 43488, '\p{^injavanese}', "");
    Expect(1, 43488, '\P{injavanese}', "");
    Expect(0, 43488, '\P{^injavanese}', "");
    Expect(1, 43487, '\p{_-In_Javanese}', "");
    Expect(0, 43487, '\p{^_-In_Javanese}', "");
    Expect(0, 43487, '\P{_-In_Javanese}', "");
    Expect(1, 43487, '\P{^_-In_Javanese}', "");
    Expect(0, 43488, '\p{_-In_Javanese}', "");
    Expect(1, 43488, '\p{^_-In_Javanese}', "");
    Expect(1, 43488, '\P{_-In_Javanese}', "");
    Expect(0, 43488, '\P{^_-In_Javanese}', "");
    Error('\p{ In_JAVANESE/a/}');
    Error('\P{ In_JAVANESE/a/}');
    Expect(1, 43487, '\p{ _In_JAVANESE}', "");
    Expect(0, 43487, '\p{^ _In_JAVANESE}', "");
    Expect(0, 43487, '\P{ _In_JAVANESE}', "");
    Expect(1, 43487, '\P{^ _In_JAVANESE}', "");
    Expect(0, 43488, '\p{ _In_JAVANESE}', "");
    Expect(1, 43488, '\p{^ _In_JAVANESE}', "");
    Expect(1, 43488, '\P{ _In_JAVANESE}', "");
    Expect(0, 43488, '\P{^ _In_JAVANESE}', "");
    Error('\p{_:=In_Kaithi}');
    Error('\P{_:=In_Kaithi}');
    Expect(1, 69839, '\p{inkaithi}', "");
    Expect(0, 69839, '\p{^inkaithi}', "");
    Expect(0, 69839, '\P{inkaithi}', "");
    Expect(1, 69839, '\P{^inkaithi}', "");
    Expect(0, 69840, '\p{inkaithi}', "");
    Expect(1, 69840, '\p{^inkaithi}', "");
    Expect(1, 69840, '\P{inkaithi}', "");
    Expect(0, 69840, '\P{^inkaithi}', "");
    Expect(1, 69839, '\p{in_kaithi}', "");
    Expect(0, 69839, '\p{^in_kaithi}', "");
    Expect(0, 69839, '\P{in_kaithi}', "");
    Expect(1, 69839, '\P{^in_kaithi}', "");
    Expect(0, 69840, '\p{in_kaithi}', "");
    Expect(1, 69840, '\p{^in_kaithi}', "");
    Expect(1, 69840, '\P{in_kaithi}', "");
    Expect(0, 69840, '\P{^in_kaithi}', "");
    Error('\p{ _in_Kaithi/a/}');
    Error('\P{ _in_Kaithi/a/}');
    Expect(1, 69839, '\p{	In_Kaithi}', "");
    Expect(0, 69839, '\p{^	In_Kaithi}', "");
    Expect(0, 69839, '\P{	In_Kaithi}', "");
    Expect(1, 69839, '\P{^	In_Kaithi}', "");
    Expect(0, 69840, '\p{	In_Kaithi}', "");
    Expect(1, 69840, '\p{^	In_Kaithi}', "");
    Expect(1, 69840, '\P{	In_Kaithi}', "");
    Expect(0, 69840, '\P{^	In_Kaithi}', "");
    Error('\p{-In_KANNADA/a/}');
    Error('\P{-In_KANNADA/a/}');
    Expect(1, 3327, '\p{inkannada}', "");
    Expect(0, 3327, '\p{^inkannada}', "");
    Expect(0, 3327, '\P{inkannada}', "");
    Expect(1, 3327, '\P{^inkannada}', "");
    Expect(0, 3328, '\p{inkannada}', "");
    Expect(1, 3328, '\p{^inkannada}', "");
    Expect(1, 3328, '\P{inkannada}', "");
    Expect(0, 3328, '\P{^inkannada}', "");
    Expect(1, 3327, '\p{__in_KANNADA}', "");
    Expect(0, 3327, '\p{^__in_KANNADA}', "");
    Expect(0, 3327, '\P{__in_KANNADA}', "");
    Expect(1, 3327, '\P{^__in_KANNADA}', "");
    Expect(0, 3328, '\p{__in_KANNADA}', "");
    Expect(1, 3328, '\p{^__in_KANNADA}', "");
    Expect(1, 3328, '\P{__in_KANNADA}', "");
    Expect(0, 3328, '\P{^__in_KANNADA}', "");
    Error('\p{:=  In_Kannada}');
    Error('\P{:=  In_Kannada}');
    Expect(1, 3327, '\p{--IN_kannada}', "");
    Expect(0, 3327, '\p{^--IN_kannada}', "");
    Expect(0, 3327, '\P{--IN_kannada}', "");
    Expect(1, 3327, '\P{^--IN_kannada}', "");
    Expect(0, 3328, '\p{--IN_kannada}', "");
    Expect(1, 3328, '\p{^--IN_kannada}', "");
    Expect(1, 3328, '\P{--IN_kannada}', "");
    Expect(0, 3328, '\P{^--IN_kannada}', "");
    Error('\p{ IN_KATAKANA/a/}');
    Error('\P{ IN_KATAKANA/a/}');
    Expect(1, 12543, '\p{inkatakana}', "");
    Expect(0, 12543, '\p{^inkatakana}', "");
    Expect(0, 12543, '\P{inkatakana}', "");
    Expect(1, 12543, '\P{^inkatakana}', "");
    Expect(0, 12544, '\p{inkatakana}', "");
    Expect(1, 12544, '\p{^inkatakana}', "");
    Expect(1, 12544, '\P{inkatakana}', "");
    Expect(0, 12544, '\P{^inkatakana}', "");
    Expect(1, 12543, '\p{		in_Katakana}', "");
    Expect(0, 12543, '\p{^		in_Katakana}', "");
    Expect(0, 12543, '\P{		in_Katakana}', "");
    Expect(1, 12543, '\P{^		in_Katakana}', "");
    Expect(0, 12544, '\p{		in_Katakana}', "");
    Expect(1, 12544, '\p{^		in_Katakana}', "");
    Expect(1, 12544, '\P{		in_Katakana}', "");
    Expect(0, 12544, '\P{^		in_Katakana}', "");
    Error('\p{	/a/IN_Katakana}');
    Error('\P{	/a/IN_Katakana}');
    Expect(1, 12543, '\p{- IN_Katakana}', "");
    Expect(0, 12543, '\p{^- IN_Katakana}', "");
    Expect(0, 12543, '\P{- IN_Katakana}', "");
    Expect(1, 12543, '\P{^- IN_Katakana}', "");
    Expect(0, 12544, '\p{- IN_Katakana}', "");
    Expect(1, 12544, '\p{^- IN_Katakana}', "");
    Expect(1, 12544, '\P{- IN_Katakana}', "");
    Expect(0, 12544, '\P{^- IN_Katakana}', "");
    Error('\p{:=  in_KAYAH_Li}');
    Error('\P{:=  in_KAYAH_Li}');
    Expect(1, 43311, '\p{inkayahli}', "");
    Expect(0, 43311, '\p{^inkayahli}', "");
    Expect(0, 43311, '\P{inkayahli}', "");
    Expect(1, 43311, '\P{^inkayahli}', "");
    Expect(0, 43312, '\p{inkayahli}', "");
    Expect(1, 43312, '\p{^inkayahli}', "");
    Expect(1, 43312, '\P{inkayahli}', "");
    Expect(0, 43312, '\P{^inkayahli}', "");
    Expect(1, 43311, '\p{ -in_Kayah_Li}', "");
    Expect(0, 43311, '\p{^ -in_Kayah_Li}', "");
    Expect(0, 43311, '\P{ -in_Kayah_Li}', "");
    Expect(1, 43311, '\P{^ -in_Kayah_Li}', "");
    Expect(0, 43312, '\p{ -in_Kayah_Li}', "");
    Expect(1, 43312, '\p{^ -in_Kayah_Li}', "");
    Expect(1, 43312, '\P{ -in_Kayah_Li}', "");
    Expect(0, 43312, '\P{^ -in_Kayah_Li}', "");
    Error('\p{:=IN_Kayah_LI}');
    Error('\P{:=IN_Kayah_LI}');
    Expect(1, 43311, '\p{	 In_kayah_Li}', "");
    Expect(0, 43311, '\p{^	 In_kayah_Li}', "");
    Expect(0, 43311, '\P{	 In_kayah_Li}', "");
    Expect(1, 43311, '\P{^	 In_kayah_Li}', "");
    Expect(0, 43312, '\p{	 In_kayah_Li}', "");
    Expect(1, 43312, '\p{^	 In_kayah_Li}', "");
    Expect(1, 43312, '\P{	 In_kayah_Li}', "");
    Expect(0, 43312, '\P{^	 In_kayah_Li}', "");
    Error('\p{ /a/In_kharoshthi}');
    Error('\P{ /a/In_kharoshthi}');
    Expect(1, 68191, '\p{inkharoshthi}', "");
    Expect(0, 68191, '\p{^inkharoshthi}', "");
    Expect(0, 68191, '\P{inkharoshthi}', "");
    Expect(1, 68191, '\P{^inkharoshthi}', "");
    Expect(0, 68192, '\p{inkharoshthi}', "");
    Expect(1, 68192, '\p{^inkharoshthi}', "");
    Expect(1, 68192, '\P{inkharoshthi}', "");
    Expect(0, 68192, '\P{^inkharoshthi}', "");
    Expect(1, 68191, '\p{ 	IN_Kharoshthi}', "");
    Expect(0, 68191, '\p{^ 	IN_Kharoshthi}', "");
    Expect(0, 68191, '\P{ 	IN_Kharoshthi}', "");
    Expect(1, 68191, '\P{^ 	IN_Kharoshthi}', "");
    Expect(0, 68192, '\p{ 	IN_Kharoshthi}', "");
    Expect(1, 68192, '\p{^ 	IN_Kharoshthi}', "");
    Expect(1, 68192, '\P{ 	IN_Kharoshthi}', "");
    Expect(0, 68192, '\P{^ 	IN_Kharoshthi}', "");
    Error('\p{  In_kharoshthi:=}');
    Error('\P{  In_kharoshthi:=}');
    Expect(1, 68191, '\p{	 In_Kharoshthi}', "");
    Expect(0, 68191, '\p{^	 In_Kharoshthi}', "");
    Expect(0, 68191, '\P{	 In_Kharoshthi}', "");
    Expect(1, 68191, '\P{^	 In_Kharoshthi}', "");
    Expect(0, 68192, '\p{	 In_Kharoshthi}', "");
    Expect(1, 68192, '\p{^	 In_Kharoshthi}', "");
    Expect(1, 68192, '\P{	 In_Kharoshthi}', "");
    Expect(0, 68192, '\P{^	 In_Kharoshthi}', "");
    Error('\p{ 	In_Khmer/a/}');
    Error('\P{ 	In_Khmer/a/}');
    Expect(1, 6143, '\p{inkhmer}', "");
    Expect(0, 6143, '\p{^inkhmer}', "");
    Expect(0, 6143, '\P{inkhmer}', "");
    Expect(1, 6143, '\P{^inkhmer}', "");
    Expect(0, 6144, '\p{inkhmer}', "");
    Expect(1, 6144, '\p{^inkhmer}', "");
    Expect(1, 6144, '\P{inkhmer}', "");
    Expect(0, 6144, '\P{^inkhmer}', "");
    Expect(1, 6143, '\p{	In_khmer}', "");
    Expect(0, 6143, '\p{^	In_khmer}', "");
    Expect(0, 6143, '\P{	In_khmer}', "");
    Expect(1, 6143, '\P{^	In_khmer}', "");
    Expect(0, 6144, '\p{	In_khmer}', "");
    Expect(1, 6144, '\p{^	In_khmer}', "");
    Expect(1, 6144, '\P{	In_khmer}', "");
    Expect(0, 6144, '\P{^	In_khmer}', "");
    Error('\p{_-in_KHMER:=}');
    Error('\P{_-in_KHMER:=}');
    Expect(1, 6143, '\p{_-In_Khmer}', "");
    Expect(0, 6143, '\p{^_-In_Khmer}', "");
    Expect(0, 6143, '\P{_-In_Khmer}', "");
    Expect(1, 6143, '\P{^_-In_Khmer}', "");
    Expect(0, 6144, '\p{_-In_Khmer}', "");
    Expect(1, 6144, '\p{^_-In_Khmer}', "");
    Expect(1, 6144, '\P{_-In_Khmer}', "");
    Expect(0, 6144, '\P{^_-In_Khmer}', "");
    Error('\p{_/a/In_khojki}');
    Error('\P{_/a/In_khojki}');
    Expect(1, 70223, '\p{inkhojki}', "");
    Expect(0, 70223, '\p{^inkhojki}', "");
    Expect(0, 70223, '\P{inkhojki}', "");
    Expect(1, 70223, '\P{^inkhojki}', "");
    Expect(0, 70224, '\p{inkhojki}', "");
    Expect(1, 70224, '\p{^inkhojki}', "");
    Expect(1, 70224, '\P{inkhojki}', "");
    Expect(0, 70224, '\P{^inkhojki}', "");
    Expect(1, 70223, '\p{ 	In_KHOJKI}', "");
    Expect(0, 70223, '\p{^ 	In_KHOJKI}', "");
    Expect(0, 70223, '\P{ 	In_KHOJKI}', "");
    Expect(1, 70223, '\P{^ 	In_KHOJKI}', "");
    Expect(0, 70224, '\p{ 	In_KHOJKI}', "");
    Expect(1, 70224, '\p{^ 	In_KHOJKI}', "");
    Expect(1, 70224, '\P{ 	In_KHOJKI}', "");
    Expect(0, 70224, '\P{^ 	In_KHOJKI}', "");
    Error('\p{	:=IN_KHOJKI}');
    Error('\P{	:=IN_KHOJKI}');
    Expect(1, 70223, '\p{-_In_khojki}', "");
    Expect(0, 70223, '\p{^-_In_khojki}', "");
    Expect(0, 70223, '\P{-_In_khojki}', "");
    Expect(1, 70223, '\P{^-_In_khojki}', "");
    Expect(0, 70224, '\p{-_In_khojki}', "");
    Expect(1, 70224, '\p{^-_In_khojki}', "");
    Expect(1, 70224, '\P{-_In_khojki}', "");
    Expect(0, 70224, '\P{^-_In_khojki}', "");
    Error('\p{/a/_-in_khudawadi}');
    Error('\P{/a/_-in_khudawadi}');
    Expect(1, 70399, '\p{inkhudawadi}', "");
    Expect(0, 70399, '\p{^inkhudawadi}', "");
    Expect(0, 70399, '\P{inkhudawadi}', "");
    Expect(1, 70399, '\P{^inkhudawadi}', "");
    Expect(0, 70400, '\p{inkhudawadi}', "");
    Expect(1, 70400, '\p{^inkhudawadi}', "");
    Expect(1, 70400, '\P{inkhudawadi}', "");
    Expect(0, 70400, '\P{^inkhudawadi}', "");
    Expect(1, 70399, '\p{in_khudawadi}', "");
    Expect(0, 70399, '\p{^in_khudawadi}', "");
    Expect(0, 70399, '\P{in_khudawadi}', "");
    Expect(1, 70399, '\P{^in_khudawadi}', "");
    Expect(0, 70400, '\p{in_khudawadi}', "");
    Expect(1, 70400, '\p{^in_khudawadi}', "");
    Expect(1, 70400, '\P{in_khudawadi}', "");
    Expect(0, 70400, '\P{^in_khudawadi}', "");
    Error('\p{ In_khudawadi/a/}');
    Error('\P{ In_khudawadi/a/}');
    Expect(1, 70399, '\p{-	In_Khudawadi}', "");
    Expect(0, 70399, '\p{^-	In_Khudawadi}', "");
    Expect(0, 70399, '\P{-	In_Khudawadi}', "");
    Expect(1, 70399, '\P{^-	In_Khudawadi}', "");
    Expect(0, 70400, '\p{-	In_Khudawadi}', "");
    Expect(1, 70400, '\p{^-	In_Khudawadi}', "");
    Expect(1, 70400, '\P{-	In_Khudawadi}', "");
    Expect(0, 70400, '\P{^-	In_Khudawadi}', "");
    Error('\p{ :=in_Lao}');
    Error('\P{ :=in_Lao}');
    Expect(1, 3839, '\p{inlao}', "");
    Expect(0, 3839, '\p{^inlao}', "");
    Expect(0, 3839, '\P{inlao}', "");
    Expect(1, 3839, '\P{^inlao}', "");
    Expect(0, 3840, '\p{inlao}', "");
    Expect(1, 3840, '\p{^inlao}', "");
    Expect(1, 3840, '\P{inlao}', "");
    Expect(0, 3840, '\P{^inlao}', "");
    Expect(1, 3839, '\p{-In_Lao}', "");
    Expect(0, 3839, '\p{^-In_Lao}', "");
    Expect(0, 3839, '\P{-In_Lao}', "");
    Expect(1, 3839, '\P{^-In_Lao}', "");
    Expect(0, 3840, '\p{-In_Lao}', "");
    Expect(1, 3840, '\p{^-In_Lao}', "");
    Expect(1, 3840, '\P{-In_Lao}', "");
    Expect(0, 3840, '\P{^-In_Lao}', "");
    Error('\p{	In_Lao/a/}');
    Error('\P{	In_Lao/a/}');
    Expect(1, 3839, '\p{--In_lao}', "");
    Expect(0, 3839, '\p{^--In_lao}', "");
    Expect(0, 3839, '\P{--In_lao}', "");
    Expect(1, 3839, '\P{^--In_lao}', "");
    Expect(0, 3840, '\p{--In_lao}', "");
    Expect(1, 3840, '\p{^--In_lao}', "");
    Expect(1, 3840, '\P{--In_lao}', "");
    Expect(0, 3840, '\P{^--In_lao}', "");
    Error('\p{:=-In_LEPCHA}');
    Error('\P{:=-In_LEPCHA}');
    Expect(1, 7247, '\p{inlepcha}', "");
    Expect(0, 7247, '\p{^inlepcha}', "");
    Expect(0, 7247, '\P{inlepcha}', "");
    Expect(1, 7247, '\P{^inlepcha}', "");
    Expect(0, 7248, '\p{inlepcha}', "");
    Expect(1, 7248, '\p{^inlepcha}', "");
    Expect(1, 7248, '\P{inlepcha}', "");
    Expect(0, 7248, '\P{^inlepcha}', "");
    Expect(1, 7247, '\p{_ In_LEPCHA}', "");
    Expect(0, 7247, '\p{^_ In_LEPCHA}', "");
    Expect(0, 7247, '\P{_ In_LEPCHA}', "");
    Expect(1, 7247, '\P{^_ In_LEPCHA}', "");
    Expect(0, 7248, '\p{_ In_LEPCHA}', "");
    Expect(1, 7248, '\p{^_ In_LEPCHA}', "");
    Expect(1, 7248, '\P{_ In_LEPCHA}', "");
    Expect(0, 7248, '\P{^_ In_LEPCHA}', "");
    Error('\p{/a/	 in_Lepcha}');
    Error('\P{/a/	 in_Lepcha}');
    Expect(1, 7247, '\p{IN_LEPCHA}', "");
    Expect(0, 7247, '\p{^IN_LEPCHA}', "");
    Expect(0, 7247, '\P{IN_LEPCHA}', "");
    Expect(1, 7247, '\P{^IN_LEPCHA}', "");
    Expect(0, 7248, '\p{IN_LEPCHA}', "");
    Expect(1, 7248, '\p{^IN_LEPCHA}', "");
    Expect(1, 7248, '\P{IN_LEPCHA}', "");
    Expect(0, 7248, '\P{^IN_LEPCHA}', "");
    Error('\p{/a/-	IN_Limbu}');
    Error('\P{/a/-	IN_Limbu}');
    Expect(1, 6479, '\p{inlimbu}', "");
    Expect(0, 6479, '\p{^inlimbu}', "");
    Expect(0, 6479, '\P{inlimbu}', "");
    Expect(1, 6479, '\P{^inlimbu}', "");
    Expect(0, 6480, '\p{inlimbu}', "");
    Expect(1, 6480, '\p{^inlimbu}', "");
    Expect(1, 6480, '\P{inlimbu}', "");
    Expect(0, 6480, '\P{^inlimbu}', "");
    Expect(1, 6479, '\p{-_IN_Limbu}', "");
    Expect(0, 6479, '\p{^-_IN_Limbu}', "");
    Expect(0, 6479, '\P{-_IN_Limbu}', "");
    Expect(1, 6479, '\P{^-_IN_Limbu}', "");
    Expect(0, 6480, '\p{-_IN_Limbu}', "");
    Expect(1, 6480, '\p{^-_IN_Limbu}', "");
    Expect(1, 6480, '\P{-_IN_Limbu}', "");
    Expect(0, 6480, '\P{^-_IN_Limbu}', "");
    Error('\p{_/a/in_Limbu}');
    Error('\P{_/a/in_Limbu}');
    Expect(1, 6479, '\p{  IN_limbu}', "");
    Expect(0, 6479, '\p{^  IN_limbu}', "");
    Expect(0, 6479, '\P{  IN_limbu}', "");
    Expect(1, 6479, '\P{^  IN_limbu}', "");
    Expect(0, 6480, '\p{  IN_limbu}', "");
    Expect(1, 6480, '\p{^  IN_limbu}', "");
    Expect(1, 6480, '\P{  IN_limbu}', "");
    Expect(0, 6480, '\P{^  IN_limbu}', "");
    Error('\p{	:=In_Linear_A}');
    Error('\P{	:=In_Linear_A}');
    Expect(1, 67455, '\p{inlineara}', "");
    Expect(0, 67455, '\p{^inlineara}', "");
    Expect(0, 67455, '\P{inlineara}', "");
    Expect(1, 67455, '\P{^inlineara}', "");
    Expect(0, 67456, '\p{inlineara}', "");
    Expect(1, 67456, '\p{^inlineara}', "");
    Expect(1, 67456, '\P{inlineara}', "");
    Expect(0, 67456, '\P{^inlineara}', "");
    Expect(1, 67455, '\p{_In_LINEAR_A}', "");
    Expect(0, 67455, '\p{^_In_LINEAR_A}', "");
    Expect(0, 67455, '\P{_In_LINEAR_A}', "");
    Expect(1, 67455, '\P{^_In_LINEAR_A}', "");
    Expect(0, 67456, '\p{_In_LINEAR_A}', "");
    Expect(1, 67456, '\p{^_In_LINEAR_A}', "");
    Expect(1, 67456, '\P{_In_LINEAR_A}', "");
    Expect(0, 67456, '\P{^_In_LINEAR_A}', "");
    Error('\p{	 IN_Linear_A:=}');
    Error('\P{	 IN_Linear_A:=}');
    Expect(1, 67455, '\p{-	IN_LINEAR_A}', "");
    Expect(0, 67455, '\p{^-	IN_LINEAR_A}', "");
    Expect(0, 67455, '\P{-	IN_LINEAR_A}', "");
    Expect(1, 67455, '\P{^-	IN_LINEAR_A}', "");
    Expect(0, 67456, '\p{-	IN_LINEAR_A}', "");
    Expect(1, 67456, '\p{^-	IN_LINEAR_A}', "");
    Expect(1, 67456, '\P{-	IN_LINEAR_A}', "");
    Expect(0, 67456, '\P{^-	IN_LINEAR_A}', "");
    Error('\p{/a/--In_Lisu}');
    Error('\P{/a/--In_Lisu}');
    Expect(1, 42239, '\p{inlisu}', "");
    Expect(0, 42239, '\p{^inlisu}', "");
    Expect(0, 42239, '\P{inlisu}', "");
    Expect(1, 42239, '\P{^inlisu}', "");
    Expect(0, 42240, '\p{inlisu}', "");
    Expect(1, 42240, '\p{^inlisu}', "");
    Expect(1, 42240, '\P{inlisu}', "");
    Expect(0, 42240, '\P{^inlisu}', "");
    Expect(1, 42239, '\p{ In_Lisu}', "");
    Expect(0, 42239, '\p{^ In_Lisu}', "");
    Expect(0, 42239, '\P{ In_Lisu}', "");
    Expect(1, 42239, '\P{^ In_Lisu}', "");
    Expect(0, 42240, '\p{ In_Lisu}', "");
    Expect(1, 42240, '\p{^ In_Lisu}', "");
    Expect(1, 42240, '\P{ In_Lisu}', "");
    Expect(0, 42240, '\P{^ In_Lisu}', "");
    Error('\p{	:=in_lisu}');
    Error('\P{	:=in_lisu}');
    Expect(1, 42239, '\p{-_in_LISU}', "");
    Expect(0, 42239, '\p{^-_in_LISU}', "");
    Expect(0, 42239, '\P{-_in_LISU}', "");
    Expect(1, 42239, '\P{^-_in_LISU}', "");
    Expect(0, 42240, '\p{-_in_LISU}', "");
    Expect(1, 42240, '\p{^-_in_LISU}', "");
    Expect(1, 42240, '\P{-_in_LISU}', "");
    Expect(0, 42240, '\P{^-_in_LISU}', "");
    Error('\p{	:=in_Lycian}');
    Error('\P{	:=in_Lycian}');
    Expect(1, 66207, '\p{inlycian}', "");
    Expect(0, 66207, '\p{^inlycian}', "");
    Expect(0, 66207, '\P{inlycian}', "");
    Expect(1, 66207, '\P{^inlycian}', "");
    Expect(0, 66208, '\p{inlycian}', "");
    Expect(1, 66208, '\p{^inlycian}', "");
    Expect(1, 66208, '\P{inlycian}', "");
    Expect(0, 66208, '\P{^inlycian}', "");
    Expect(1, 66207, '\p{-_In_Lycian}', "");
    Expect(0, 66207, '\p{^-_In_Lycian}', "");
    Expect(0, 66207, '\P{-_In_Lycian}', "");
    Expect(1, 66207, '\P{^-_In_Lycian}', "");
    Expect(0, 66208, '\p{-_In_Lycian}', "");
    Expect(1, 66208, '\p{^-_In_Lycian}', "");
    Expect(1, 66208, '\P{-_In_Lycian}', "");
    Expect(0, 66208, '\P{^-_In_Lycian}', "");
    Error('\p{-IN_Lycian/a/}');
    Error('\P{-IN_Lycian/a/}');
    Expect(1, 66207, '\p{_-in_Lycian}', "");
    Expect(0, 66207, '\p{^_-in_Lycian}', "");
    Expect(0, 66207, '\P{_-in_Lycian}', "");
    Expect(1, 66207, '\P{^_-in_Lycian}', "");
    Expect(0, 66208, '\p{_-in_Lycian}', "");
    Expect(1, 66208, '\p{^_-in_Lycian}', "");
    Expect(1, 66208, '\P{_-in_Lycian}', "");
    Expect(0, 66208, '\P{^_-in_Lycian}', "");
    Error('\p{/a/_	In_Lydian}');
    Error('\P{/a/_	In_Lydian}');
    Expect(1, 67903, '\p{inlydian}', "");
    Expect(0, 67903, '\p{^inlydian}', "");
    Expect(0, 67903, '\P{inlydian}', "");
    Expect(1, 67903, '\P{^inlydian}', "");
    Expect(0, 67904, '\p{inlydian}', "");
    Expect(1, 67904, '\p{^inlydian}', "");
    Expect(1, 67904, '\P{inlydian}', "");
    Expect(0, 67904, '\P{^inlydian}', "");
    Expect(1, 67903, '\p{	_in_lydian}', "");
    Expect(0, 67903, '\p{^	_in_lydian}', "");
    Expect(0, 67903, '\P{	_in_lydian}', "");
    Expect(1, 67903, '\P{^	_in_lydian}', "");
    Expect(0, 67904, '\p{	_in_lydian}', "");
    Expect(1, 67904, '\p{^	_in_lydian}', "");
    Expect(1, 67904, '\P{	_in_lydian}', "");
    Expect(0, 67904, '\P{^	_in_lydian}', "");
    Error('\p{:=- IN_LYDIAN}');
    Error('\P{:=- IN_LYDIAN}');
    Expect(1, 67903, '\p{	_in_LYDIAN}', "");
    Expect(0, 67903, '\p{^	_in_LYDIAN}', "");
    Expect(0, 67903, '\P{	_in_LYDIAN}', "");
    Expect(1, 67903, '\P{^	_in_LYDIAN}', "");
    Expect(0, 67904, '\p{	_in_LYDIAN}', "");
    Expect(1, 67904, '\p{^	_in_LYDIAN}', "");
    Expect(1, 67904, '\P{	_in_LYDIAN}', "");
    Expect(0, 67904, '\P{^	_in_LYDIAN}', "");
    Error('\p{:=_	In_MAHAJANI}');
    Error('\P{:=_	In_MAHAJANI}');
    Expect(1, 70015, '\p{inmahajani}', "");
    Expect(0, 70015, '\p{^inmahajani}', "");
    Expect(0, 70015, '\P{inmahajani}', "");
    Expect(1, 70015, '\P{^inmahajani}', "");
    Expect(0, 70016, '\p{inmahajani}', "");
    Expect(1, 70016, '\p{^inmahajani}', "");
    Expect(1, 70016, '\P{inmahajani}', "");
    Expect(0, 70016, '\P{^inmahajani}', "");
    Expect(1, 70015, '\p{in_Mahajani}', "");
    Expect(0, 70015, '\p{^in_Mahajani}', "");
    Expect(0, 70015, '\P{in_Mahajani}', "");
    Expect(1, 70015, '\P{^in_Mahajani}', "");
    Expect(0, 70016, '\p{in_Mahajani}', "");
    Expect(1, 70016, '\p{^in_Mahajani}', "");
    Expect(1, 70016, '\P{in_Mahajani}', "");
    Expect(0, 70016, '\P{^in_Mahajani}', "");
    Error('\p{/a/  In_Mahajani}');
    Error('\P{/a/  In_Mahajani}');
    Expect(1, 70015, '\p{  In_Mahajani}', "");
    Expect(0, 70015, '\p{^  In_Mahajani}', "");
    Expect(0, 70015, '\P{  In_Mahajani}', "");
    Expect(1, 70015, '\P{^  In_Mahajani}', "");
    Expect(0, 70016, '\p{  In_Mahajani}', "");
    Expect(1, 70016, '\p{^  In_Mahajani}', "");
    Expect(1, 70016, '\P{  In_Mahajani}', "");
    Expect(0, 70016, '\P{^  In_Mahajani}', "");
    Error('\p{	:=In_Makasar}');
    Error('\P{	:=In_Makasar}');
    Expect(1, 73471, '\p{inmakasar}', "");
    Expect(0, 73471, '\p{^inmakasar}', "");
    Expect(0, 73471, '\P{inmakasar}', "");
    Expect(1, 73471, '\P{^inmakasar}', "");
    Expect(0, 73472, '\p{inmakasar}', "");
    Expect(1, 73472, '\p{^inmakasar}', "");
    Expect(1, 73472, '\P{inmakasar}', "");
    Expect(0, 73472, '\P{^inmakasar}', "");
    Expect(1, 73471, '\p{	in_makasar}', "");
    Expect(0, 73471, '\p{^	in_makasar}', "");
    Expect(0, 73471, '\P{	in_makasar}', "");
    Expect(1, 73471, '\P{^	in_makasar}', "");
    Expect(0, 73472, '\p{	in_makasar}', "");
    Expect(1, 73472, '\p{^	in_makasar}', "");
    Expect(1, 73472, '\P{	in_makasar}', "");
    Expect(0, 73472, '\P{^	in_makasar}', "");
    Error('\p{ :=in_makasar}');
    Error('\P{ :=in_makasar}');
    Expect(1, 73471, '\p{_ In_Makasar}', "");
    Expect(0, 73471, '\p{^_ In_Makasar}', "");
    Expect(0, 73471, '\P{_ In_Makasar}', "");
    Expect(1, 73471, '\P{^_ In_Makasar}', "");
    Expect(0, 73472, '\p{_ In_Makasar}', "");
    Expect(1, 73472, '\p{^_ In_Makasar}', "");
    Expect(1, 73472, '\P{_ In_Makasar}', "");
    Expect(0, 73472, '\P{^_ In_Makasar}', "");
    Error('\p{:= In_Malayalam}');
    Error('\P{:= In_Malayalam}');
    Expect(1, 3455, '\p{inmalayalam}', "");
    Expect(0, 3455, '\p{^inmalayalam}', "");
    Expect(0, 3455, '\P{inmalayalam}', "");
    Expect(1, 3455, '\P{^inmalayalam}', "");
    Expect(0, 3456, '\p{inmalayalam}', "");
    Expect(1, 3456, '\p{^inmalayalam}', "");
    Expect(1, 3456, '\P{inmalayalam}', "");
    Expect(0, 3456, '\P{^inmalayalam}', "");
    Expect(1, 3455, '\p{	 IN_Malayalam}', "");
    Expect(0, 3455, '\p{^	 IN_Malayalam}', "");
    Expect(0, 3455, '\P{	 IN_Malayalam}', "");
    Expect(1, 3455, '\P{^	 IN_Malayalam}', "");
    Expect(0, 3456, '\p{	 IN_Malayalam}', "");
    Expect(1, 3456, '\p{^	 IN_Malayalam}', "");
    Expect(1, 3456, '\P{	 IN_Malayalam}', "");
    Expect(0, 3456, '\P{^	 IN_Malayalam}', "");
    Error('\p{- In_malayalam:=}');
    Error('\P{- In_malayalam:=}');
    Error('\p{:=		IN_Mandaic}');
    Error('\P{:=		IN_Mandaic}');
    Expect(1, 2143, '\p{inmandaic}', "");
    Expect(0, 2143, '\p{^inmandaic}', "");
    Expect(0, 2143, '\P{inmandaic}', "");
    Expect(1, 2143, '\P{^inmandaic}', "");
    Expect(0, 2144, '\p{inmandaic}', "");
    Expect(1, 2144, '\p{^inmandaic}', "");
    Expect(1, 2144, '\P{inmandaic}', "");
    Expect(0, 2144, '\P{^inmandaic}', "");
    Expect(1, 2143, '\p{ 	In_MANDAIC}', "");
    Expect(0, 2143, '\p{^ 	In_MANDAIC}', "");
    Expect(0, 2143, '\P{ 	In_MANDAIC}', "");
    Expect(1, 2143, '\P{^ 	In_MANDAIC}', "");
    Expect(0, 2144, '\p{ 	In_MANDAIC}', "");
    Expect(1, 2144, '\p{^ 	In_MANDAIC}', "");
    Expect(1, 2144, '\P{ 	In_MANDAIC}', "");
    Expect(0, 2144, '\P{^ 	In_MANDAIC}', "");
    Error('\p{--IN_Mandaic/a/}');
    Error('\P{--IN_Mandaic/a/}');
    Expect(1, 2143, '\p{	-In_mandaic}', "");
    Expect(0, 2143, '\p{^	-In_mandaic}', "");
    Expect(0, 2143, '\P{	-In_mandaic}', "");
    Expect(1, 2143, '\P{^	-In_mandaic}', "");
    Expect(0, 2144, '\p{	-In_mandaic}', "");
    Expect(1, 2144, '\p{^	-In_mandaic}', "");
    Expect(1, 2144, '\P{	-In_mandaic}', "");
    Expect(0, 2144, '\P{^	-In_mandaic}', "");
    Error('\p{:=	 In_Manichaean}');
    Error('\P{:=	 In_Manichaean}');
    Expect(1, 68351, '\p{inmanichaean}', "");
    Expect(0, 68351, '\p{^inmanichaean}', "");
    Expect(0, 68351, '\P{inmanichaean}', "");
    Expect(1, 68351, '\P{^inmanichaean}', "");
    Expect(0, 68352, '\p{inmanichaean}', "");
    Expect(1, 68352, '\p{^inmanichaean}', "");
    Expect(1, 68352, '\P{inmanichaean}', "");
    Expect(0, 68352, '\P{^inmanichaean}', "");
    Expect(1, 68351, '\p{-	IN_Manichaean}', "");
    Expect(0, 68351, '\p{^-	IN_Manichaean}', "");
    Expect(0, 68351, '\P{-	IN_Manichaean}', "");
    Expect(1, 68351, '\P{^-	IN_Manichaean}', "");
    Expect(0, 68352, '\p{-	IN_Manichaean}', "");
    Expect(1, 68352, '\p{^-	IN_Manichaean}', "");
    Expect(1, 68352, '\P{-	IN_Manichaean}', "");
    Expect(0, 68352, '\P{^-	IN_Manichaean}', "");
    Error('\p{	/a/In_MANICHAEAN}');
    Error('\P{	/a/In_MANICHAEAN}');
    Expect(1, 68351, '\p{	_in_manichaean}', "");
    Expect(0, 68351, '\p{^	_in_manichaean}', "");
    Expect(0, 68351, '\P{	_in_manichaean}', "");
    Expect(1, 68351, '\P{^	_in_manichaean}', "");
    Expect(0, 68352, '\p{	_in_manichaean}', "");
    Expect(1, 68352, '\p{^	_in_manichaean}', "");
    Expect(1, 68352, '\P{	_in_manichaean}', "");
    Expect(0, 68352, '\P{^	_in_manichaean}', "");
    Error('\p{:=_in_Marchen}');
    Error('\P{:=_in_Marchen}');
    Expect(1, 72895, '\p{inmarchen}', "");
    Expect(0, 72895, '\p{^inmarchen}', "");
    Expect(0, 72895, '\P{inmarchen}', "");
    Expect(1, 72895, '\P{^inmarchen}', "");
    Expect(0, 72896, '\p{inmarchen}', "");
    Expect(1, 72896, '\p{^inmarchen}', "");
    Expect(1, 72896, '\P{inmarchen}', "");
    Expect(0, 72896, '\P{^inmarchen}', "");
    Expect(1, 72895, '\p{_-in_marchen}', "");
    Expect(0, 72895, '\p{^_-in_marchen}', "");
    Expect(0, 72895, '\P{_-in_marchen}', "");
    Expect(1, 72895, '\P{^_-in_marchen}', "");
    Expect(0, 72896, '\p{_-in_marchen}', "");
    Expect(1, 72896, '\p{^_-in_marchen}', "");
    Expect(1, 72896, '\P{_-in_marchen}', "");
    Expect(0, 72896, '\P{^_-in_marchen}', "");
    Error('\p{In_Marchen/a/}');
    Error('\P{In_Marchen/a/}');
    Expect(1, 72895, '\p{_In_Marchen}', "");
    Expect(0, 72895, '\p{^_In_Marchen}', "");
    Expect(0, 72895, '\P{_In_Marchen}', "");
    Expect(1, 72895, '\P{^_In_Marchen}', "");
    Expect(0, 72896, '\p{_In_Marchen}', "");
    Expect(1, 72896, '\p{^_In_Marchen}', "");
    Expect(1, 72896, '\P{_In_Marchen}', "");
    Expect(0, 72896, '\P{^_In_Marchen}', "");
    Error('\p{ 	In_MASARAM_Gondi:=}');
    Error('\P{ 	In_MASARAM_Gondi:=}');
    Expect(1, 73055, '\p{inmasaramgondi}', "");
    Expect(0, 73055, '\p{^inmasaramgondi}', "");
    Expect(0, 73055, '\P{inmasaramgondi}', "");
    Expect(1, 73055, '\P{^inmasaramgondi}', "");
    Expect(0, 73056, '\p{inmasaramgondi}', "");
    Expect(1, 73056, '\p{^inmasaramgondi}', "");
    Expect(1, 73056, '\P{inmasaramgondi}', "");
    Expect(0, 73056, '\P{^inmasaramgondi}', "");
    Expect(1, 73055, '\p{-In_Masaram_gondi}', "");
    Expect(0, 73055, '\p{^-In_Masaram_gondi}', "");
    Expect(0, 73055, '\P{-In_Masaram_gondi}', "");
    Expect(1, 73055, '\P{^-In_Masaram_gondi}', "");
    Expect(0, 73056, '\p{-In_Masaram_gondi}', "");
    Expect(1, 73056, '\p{^-In_Masaram_gondi}', "");
    Expect(1, 73056, '\P{-In_Masaram_gondi}', "");
    Expect(0, 73056, '\P{^-In_Masaram_gondi}', "");
    Error('\p{/a/-IN_masaram_GONDI}');
    Error('\P{/a/-IN_masaram_GONDI}');
    Expect(1, 73055, '\p{	-IN_Masaram_gondi}', "");
    Expect(0, 73055, '\p{^	-IN_Masaram_gondi}', "");
    Expect(0, 73055, '\P{	-IN_Masaram_gondi}', "");
    Expect(1, 73055, '\P{^	-IN_Masaram_gondi}', "");
    Expect(0, 73056, '\p{	-IN_Masaram_gondi}', "");
    Expect(1, 73056, '\p{^	-IN_Masaram_gondi}', "");
    Expect(1, 73056, '\P{	-IN_Masaram_gondi}', "");
    Expect(0, 73056, '\P{^	-IN_Masaram_gondi}', "");
    Error('\p{:=	in_medefaidrin}');
    Error('\P{:=	in_medefaidrin}');
    Expect(1, 93855, '\p{inmedefaidrin}', "");
    Expect(0, 93855, '\p{^inmedefaidrin}', "");
    Expect(0, 93855, '\P{inmedefaidrin}', "");
    Expect(1, 93855, '\P{^inmedefaidrin}', "");
    Expect(0, 93856, '\p{inmedefaidrin}', "");
    Expect(1, 93856, '\p{^inmedefaidrin}', "");
    Expect(1, 93856, '\P{inmedefaidrin}', "");
    Expect(0, 93856, '\P{^inmedefaidrin}', "");
    Expect(1, 93855, '\p{_	IN_Medefaidrin}', "");
    Expect(0, 93855, '\p{^_	IN_Medefaidrin}', "");
    Expect(0, 93855, '\P{_	IN_Medefaidrin}', "");
    Expect(1, 93855, '\P{^_	IN_Medefaidrin}', "");
    Expect(0, 93856, '\p{_	IN_Medefaidrin}', "");
    Expect(1, 93856, '\p{^_	IN_Medefaidrin}', "");
    Expect(1, 93856, '\P{_	IN_Medefaidrin}', "");
    Expect(0, 93856, '\P{^_	IN_Medefaidrin}', "");
    Error('\p{-	In_MEDEFAIDRIN/a/}');
    Error('\P{-	In_MEDEFAIDRIN/a/}');
    Expect(1, 93855, '\p{-In_MEDEFAIDRIN}', "");
    Expect(0, 93855, '\p{^-In_MEDEFAIDRIN}', "");
    Expect(0, 93855, '\P{-In_MEDEFAIDRIN}', "");
    Expect(1, 93855, '\P{^-In_MEDEFAIDRIN}', "");
    Expect(0, 93856, '\p{-In_MEDEFAIDRIN}', "");
    Expect(1, 93856, '\p{^-In_MEDEFAIDRIN}', "");
    Expect(1, 93856, '\P{-In_MEDEFAIDRIN}', "");
    Expect(0, 93856, '\P{^-In_MEDEFAIDRIN}', "");
    Error('\p{	/a/In_meetei_MAYEK}');
    Error('\P{	/a/In_meetei_MAYEK}');
    Expect(1, 44031, '\p{inmeeteimayek}', "");
    Expect(0, 44031, '\p{^inmeeteimayek}', "");
    Expect(0, 44031, '\P{inmeeteimayek}', "");
    Expect(1, 44031, '\P{^inmeeteimayek}', "");
    Expect(0, 44032, '\p{inmeeteimayek}', "");
    Expect(1, 44032, '\p{^inmeeteimayek}', "");
    Expect(1, 44032, '\P{inmeeteimayek}', "");
    Expect(0, 44032, '\P{^inmeeteimayek}', "");
    Expect(1, 44031, '\p{-	In_Meetei_Mayek}', "");
    Expect(0, 44031, '\p{^-	In_Meetei_Mayek}', "");
    Expect(0, 44031, '\P{-	In_Meetei_Mayek}', "");
    Expect(1, 44031, '\P{^-	In_Meetei_Mayek}', "");
    Expect(0, 44032, '\p{-	In_Meetei_Mayek}', "");
    Expect(1, 44032, '\p{^-	In_Meetei_Mayek}', "");
    Expect(1, 44032, '\P{-	In_Meetei_Mayek}', "");
    Expect(0, 44032, '\P{^-	In_Meetei_Mayek}', "");
    Error('\p{:=_In_Meetei_MAYEK}');
    Error('\P{:=_In_Meetei_MAYEK}');
    Expect(1, 44031, '\p{- In_Meetei_Mayek}', "");
    Expect(0, 44031, '\p{^- In_Meetei_Mayek}', "");
    Expect(0, 44031, '\P{- In_Meetei_Mayek}', "");
    Expect(1, 44031, '\P{^- In_Meetei_Mayek}', "");
    Expect(0, 44032, '\p{- In_Meetei_Mayek}', "");
    Expect(1, 44032, '\p{^- In_Meetei_Mayek}', "");
    Expect(1, 44032, '\P{- In_Meetei_Mayek}', "");
    Expect(0, 44032, '\P{^- In_Meetei_Mayek}', "");
    Error('\p{	in_MENDE_kikakui/a/}');
    Error('\P{	in_MENDE_kikakui/a/}');
    Expect(1, 125151, '\p{inmendekikakui}', "");
    Expect(0, 125151, '\p{^inmendekikakui}', "");
    Expect(0, 125151, '\P{inmendekikakui}', "");
    Expect(1, 125151, '\P{^inmendekikakui}', "");
    Expect(0, 125152, '\p{inmendekikakui}', "");
    Expect(1, 125152, '\p{^inmendekikakui}', "");
    Expect(1, 125152, '\P{inmendekikakui}', "");
    Expect(0, 125152, '\P{^inmendekikakui}', "");
    Expect(1, 125151, '\p{ in_MENDE_Kikakui}', "");
    Expect(0, 125151, '\p{^ in_MENDE_Kikakui}', "");
    Expect(0, 125151, '\P{ in_MENDE_Kikakui}', "");
    Expect(1, 125151, '\P{^ in_MENDE_Kikakui}', "");
    Expect(0, 125152, '\p{ in_MENDE_Kikakui}', "");
    Expect(1, 125152, '\p{^ in_MENDE_Kikakui}', "");
    Expect(1, 125152, '\P{ in_MENDE_Kikakui}', "");
    Expect(0, 125152, '\P{^ in_MENDE_Kikakui}', "");
    Error('\p{/a/		IN_Mende_KIKAKUI}');
    Error('\P{/a/		IN_Mende_KIKAKUI}');
    Expect(1, 125151, '\p{ in_mende_Kikakui}', "");
    Expect(0, 125151, '\p{^ in_mende_Kikakui}', "");
    Expect(0, 125151, '\P{ in_mende_Kikakui}', "");
    Expect(1, 125151, '\P{^ in_mende_Kikakui}', "");
    Expect(0, 125152, '\p{ in_mende_Kikakui}', "");
    Expect(1, 125152, '\p{^ in_mende_Kikakui}', "");
    Expect(1, 125152, '\P{ in_mende_Kikakui}', "");
    Expect(0, 125152, '\P{^ in_mende_Kikakui}', "");
    Error('\p{_/a/in_Meroitic_Cursive}');
    Error('\P{_/a/in_Meroitic_Cursive}');
    Expect(1, 68095, '\p{inmeroiticcursive}', "");
    Expect(0, 68095, '\p{^inmeroiticcursive}', "");
    Expect(0, 68095, '\P{inmeroiticcursive}', "");
    Expect(1, 68095, '\P{^inmeroiticcursive}', "");
    Expect(0, 68096, '\p{inmeroiticcursive}', "");
    Expect(1, 68096, '\p{^inmeroiticcursive}', "");
    Expect(1, 68096, '\P{inmeroiticcursive}', "");
    Expect(0, 68096, '\P{^inmeroiticcursive}', "");
    Expect(1, 68095, '\p{  IN_Meroitic_CURSIVE}', "");
    Expect(0, 68095, '\p{^  IN_Meroitic_CURSIVE}', "");
    Expect(0, 68095, '\P{  IN_Meroitic_CURSIVE}', "");
    Expect(1, 68095, '\P{^  IN_Meroitic_CURSIVE}', "");
    Expect(0, 68096, '\p{  IN_Meroitic_CURSIVE}', "");
    Expect(1, 68096, '\p{^  IN_Meroitic_CURSIVE}', "");
    Expect(1, 68096, '\P{  IN_Meroitic_CURSIVE}', "");
    Expect(0, 68096, '\P{^  IN_Meroitic_CURSIVE}', "");
    Error('\p{- in_Meroitic_Cursive:=}');
    Error('\P{- in_Meroitic_Cursive:=}');
    Expect(1, 68095, '\p{		IN_meroitic_Cursive}', "");
    Expect(0, 68095, '\p{^		IN_meroitic_Cursive}', "");
    Expect(0, 68095, '\P{		IN_meroitic_Cursive}', "");
    Expect(1, 68095, '\P{^		IN_meroitic_Cursive}', "");
    Expect(0, 68096, '\p{		IN_meroitic_Cursive}', "");
    Expect(1, 68096, '\p{^		IN_meroitic_Cursive}', "");
    Expect(1, 68096, '\P{		IN_meroitic_Cursive}', "");
    Expect(0, 68096, '\P{^		IN_meroitic_Cursive}', "");
    Error('\p{_/a/in_Meroitic_hieroglyphs}');
    Error('\P{_/a/in_Meroitic_hieroglyphs}');
    Expect(1, 67999, '\p{inmeroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^inmeroitichieroglyphs}', "");
    Expect(0, 67999, '\P{inmeroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^inmeroitichieroglyphs}', "");
    Expect(0, 68000, '\p{inmeroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^inmeroitichieroglyphs}', "");
    Expect(1, 68000, '\P{inmeroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^inmeroitichieroglyphs}', "");
    Expect(1, 67999, '\p{-in_meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^-in_meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\P{-in_meroitic_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^-in_meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\p{-in_meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^-in_meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\P{-in_meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^-in_meroitic_Hieroglyphs}', "");
    Error('\p{/a/	 IN_meroitic_Hieroglyphs}');
    Error('\P{/a/	 IN_meroitic_Hieroglyphs}');
    Expect(1, 67999, '\p{	In_Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^	In_Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\P{	In_Meroitic_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^	In_Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\p{	In_Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^	In_Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\P{	In_Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^	In_Meroitic_Hieroglyphs}', "");
    Error('\p{/a/- In_MIAO}');
    Error('\P{/a/- In_MIAO}');
    Expect(1, 94111, '\p{inmiao}', "");
    Expect(0, 94111, '\p{^inmiao}', "");
    Expect(0, 94111, '\P{inmiao}', "");
    Expect(1, 94111, '\P{^inmiao}', "");
    Expect(0, 94112, '\p{inmiao}', "");
    Expect(1, 94112, '\p{^inmiao}', "");
    Expect(1, 94112, '\P{inmiao}', "");
    Expect(0, 94112, '\P{^inmiao}', "");
    Expect(1, 94111, '\p{	_In_Miao}', "");
    Expect(0, 94111, '\p{^	_In_Miao}', "");
    Expect(0, 94111, '\P{	_In_Miao}', "");
    Expect(1, 94111, '\P{^	_In_Miao}', "");
    Expect(0, 94112, '\p{	_In_Miao}', "");
    Expect(1, 94112, '\p{^	_In_Miao}', "");
    Expect(1, 94112, '\P{	_In_Miao}', "");
    Expect(0, 94112, '\P{^	_In_Miao}', "");
    Error('\p{in_miao/a/}');
    Error('\P{in_miao/a/}');
    Expect(1, 94111, '\p{-	in_MIAO}', "");
    Expect(0, 94111, '\p{^-	in_MIAO}', "");
    Expect(0, 94111, '\P{-	in_MIAO}', "");
    Expect(1, 94111, '\P{^-	in_MIAO}', "");
    Expect(0, 94112, '\p{-	in_MIAO}', "");
    Expect(1, 94112, '\p{^-	in_MIAO}', "");
    Expect(1, 94112, '\P{-	in_MIAO}', "");
    Expect(0, 94112, '\P{^-	in_MIAO}', "");
    Error('\p{:= 	IN_Modi}');
    Error('\P{:= 	IN_Modi}');
    Expect(1, 71263, '\p{inmodi}', "");
    Expect(0, 71263, '\p{^inmodi}', "");
    Expect(0, 71263, '\P{inmodi}', "");
    Expect(1, 71263, '\P{^inmodi}', "");
    Expect(0, 71264, '\p{inmodi}', "");
    Expect(1, 71264, '\p{^inmodi}', "");
    Expect(1, 71264, '\P{inmodi}', "");
    Expect(0, 71264, '\P{^inmodi}', "");
    Expect(1, 71263, '\p{- in_Modi}', "");
    Expect(0, 71263, '\p{^- in_Modi}', "");
    Expect(0, 71263, '\P{- in_Modi}', "");
    Expect(1, 71263, '\P{^- in_Modi}', "");
    Expect(0, 71264, '\p{- in_Modi}', "");
    Expect(1, 71264, '\p{^- in_Modi}', "");
    Expect(1, 71264, '\P{- in_Modi}', "");
    Expect(0, 71264, '\P{^- in_Modi}', "");
    Error('\p{_In_MODI:=}');
    Error('\P{_In_MODI:=}');
    Expect(1, 71263, '\p{	In_modi}', "");
    Expect(0, 71263, '\p{^	In_modi}', "");
    Expect(0, 71263, '\P{	In_modi}', "");
    Expect(1, 71263, '\P{^	In_modi}', "");
    Expect(0, 71264, '\p{	In_modi}', "");
    Expect(1, 71264, '\p{^	In_modi}', "");
    Expect(1, 71264, '\P{	In_modi}', "");
    Expect(0, 71264, '\P{^	In_modi}', "");
    Error('\p{-In_Mongolian:=}');
    Error('\P{-In_Mongolian:=}');
    Expect(1, 6319, '\p{inmongolian}', "");
    Expect(0, 6319, '\p{^inmongolian}', "");
    Expect(0, 6319, '\P{inmongolian}', "");
    Expect(1, 6319, '\P{^inmongolian}', "");
    Expect(0, 6320, '\p{inmongolian}', "");
    Expect(1, 6320, '\p{^inmongolian}', "");
    Expect(1, 6320, '\P{inmongolian}', "");
    Expect(0, 6320, '\P{^inmongolian}', "");
    Expect(1, 6319, '\p{- In_MONGOLIAN}', "");
    Expect(0, 6319, '\p{^- In_MONGOLIAN}', "");
    Expect(0, 6319, '\P{- In_MONGOLIAN}', "");
    Expect(1, 6319, '\P{^- In_MONGOLIAN}', "");
    Expect(0, 6320, '\p{- In_MONGOLIAN}', "");
    Expect(1, 6320, '\p{^- In_MONGOLIAN}', "");
    Expect(1, 6320, '\P{- In_MONGOLIAN}', "");
    Expect(0, 6320, '\P{^- In_MONGOLIAN}', "");
    Error('\p{	/a/In_mongolian}');
    Error('\P{	/a/In_mongolian}');
    Expect(1, 6319, '\p{_IN_mongolian}', "");
    Expect(0, 6319, '\p{^_IN_mongolian}', "");
    Expect(0, 6319, '\P{_IN_mongolian}', "");
    Expect(1, 6319, '\P{^_IN_mongolian}', "");
    Expect(0, 6320, '\p{_IN_mongolian}', "");
    Expect(1, 6320, '\p{^_IN_mongolian}', "");
    Expect(1, 6320, '\P{_IN_mongolian}', "");
    Expect(0, 6320, '\P{^_IN_mongolian}', "");
    Error('\p{_IN_MRO/a/}');
    Error('\P{_IN_MRO/a/}');
    Expect(1, 92783, '\p{inmro}', "");
    Expect(0, 92783, '\p{^inmro}', "");
    Expect(0, 92783, '\P{inmro}', "");
    Expect(1, 92783, '\P{^inmro}', "");
    Expect(0, 92784, '\p{inmro}', "");
    Expect(1, 92784, '\p{^inmro}', "");
    Expect(1, 92784, '\P{inmro}', "");
    Expect(0, 92784, '\P{^inmro}', "");
    Expect(1, 92783, '\p{-In_Mro}', "");
    Expect(0, 92783, '\p{^-In_Mro}', "");
    Expect(0, 92783, '\P{-In_Mro}', "");
    Expect(1, 92783, '\P{^-In_Mro}', "");
    Expect(0, 92784, '\p{-In_Mro}', "");
    Expect(1, 92784, '\p{^-In_Mro}', "");
    Expect(1, 92784, '\P{-In_Mro}', "");
    Expect(0, 92784, '\P{^-In_Mro}', "");
    Error('\p{_/a/IN_Mro}');
    Error('\P{_/a/IN_Mro}');
    Expect(1, 92783, '\p{ -in_Mro}', "");
    Expect(0, 92783, '\p{^ -in_Mro}', "");
    Expect(0, 92783, '\P{ -in_Mro}', "");
    Expect(1, 92783, '\P{^ -in_Mro}', "");
    Expect(0, 92784, '\p{ -in_Mro}', "");
    Expect(1, 92784, '\p{^ -in_Mro}', "");
    Expect(1, 92784, '\P{ -in_Mro}', "");
    Expect(0, 92784, '\P{^ -in_Mro}', "");
    Error('\p{/a/	IN_MULTANI}');
    Error('\P{/a/	IN_MULTANI}');
    Expect(1, 70319, '\p{inmultani}', "");
    Expect(0, 70319, '\p{^inmultani}', "");
    Expect(0, 70319, '\P{inmultani}', "");
    Expect(1, 70319, '\P{^inmultani}', "");
    Expect(0, 70320, '\p{inmultani}', "");
    Expect(1, 70320, '\p{^inmultani}', "");
    Expect(1, 70320, '\P{inmultani}', "");
    Expect(0, 70320, '\P{^inmultani}', "");
    Expect(1, 70319, '\p{_	In_multani}', "");
    Expect(0, 70319, '\p{^_	In_multani}', "");
    Expect(0, 70319, '\P{_	In_multani}', "");
    Expect(1, 70319, '\P{^_	In_multani}', "");
    Expect(0, 70320, '\p{_	In_multani}', "");
    Expect(1, 70320, '\p{^_	In_multani}', "");
    Expect(1, 70320, '\P{_	In_multani}', "");
    Expect(0, 70320, '\P{^_	In_multani}', "");
    Error('\p{:=		In_multani}');
    Error('\P{:=		In_multani}');
    Expect(1, 70319, '\p{- IN_Multani}', "");
    Expect(0, 70319, '\p{^- IN_Multani}', "");
    Expect(0, 70319, '\P{- IN_Multani}', "");
    Expect(1, 70319, '\P{^- IN_Multani}', "");
    Expect(0, 70320, '\p{- IN_Multani}', "");
    Expect(1, 70320, '\p{^- IN_Multani}', "");
    Expect(1, 70320, '\P{- IN_Multani}', "");
    Expect(0, 70320, '\P{^- IN_Multani}', "");
    Error('\p{:=-in_Myanmar}');
    Error('\P{:=-in_Myanmar}');
    Expect(1, 4255, '\p{inmyanmar}', "");
    Expect(0, 4255, '\p{^inmyanmar}', "");
    Expect(0, 4255, '\P{inmyanmar}', "");
    Expect(1, 4255, '\P{^inmyanmar}', "");
    Expect(0, 4256, '\p{inmyanmar}', "");
    Expect(1, 4256, '\p{^inmyanmar}', "");
    Expect(1, 4256, '\P{inmyanmar}', "");
    Expect(0, 4256, '\P{^inmyanmar}', "");
    Expect(1, 4255, '\p{-	IN_myanmar}', "");
    Expect(0, 4255, '\p{^-	IN_myanmar}', "");
    Expect(0, 4255, '\P{-	IN_myanmar}', "");
    Expect(1, 4255, '\P{^-	IN_myanmar}', "");
    Expect(0, 4256, '\p{-	IN_myanmar}', "");
    Expect(1, 4256, '\p{^-	IN_myanmar}', "");
    Expect(1, 4256, '\P{-	IN_myanmar}', "");
    Expect(0, 4256, '\P{^-	IN_myanmar}', "");
    Error('\p{ In_Myanmar/a/}');
    Error('\P{ In_Myanmar/a/}');
    Expect(1, 4255, '\p{	-In_Myanmar}', "");
    Expect(0, 4255, '\p{^	-In_Myanmar}', "");
    Expect(0, 4255, '\P{	-In_Myanmar}', "");
    Expect(1, 4255, '\P{^	-In_Myanmar}', "");
    Expect(0, 4256, '\p{	-In_Myanmar}', "");
    Expect(1, 4256, '\p{^	-In_Myanmar}', "");
    Expect(1, 4256, '\P{	-In_Myanmar}', "");
    Expect(0, 4256, '\P{^	-In_Myanmar}', "");
    Error('\p{:=in_NABATAEAN}');
    Error('\P{:=in_NABATAEAN}');
    Expect(1, 67759, '\p{innabataean}', "");
    Expect(0, 67759, '\p{^innabataean}', "");
    Expect(0, 67759, '\P{innabataean}', "");
    Expect(1, 67759, '\P{^innabataean}', "");
    Expect(0, 67760, '\p{innabataean}', "");
    Expect(1, 67760, '\p{^innabataean}', "");
    Expect(1, 67760, '\P{innabataean}', "");
    Expect(0, 67760, '\P{^innabataean}', "");
    Expect(1, 67759, '\p{__in_Nabataean}', "");
    Expect(0, 67759, '\p{^__in_Nabataean}', "");
    Expect(0, 67759, '\P{__in_Nabataean}', "");
    Expect(1, 67759, '\P{^__in_Nabataean}', "");
    Expect(0, 67760, '\p{__in_Nabataean}', "");
    Expect(1, 67760, '\p{^__in_Nabataean}', "");
    Expect(1, 67760, '\P{__in_Nabataean}', "");
    Expect(0, 67760, '\P{^__in_Nabataean}', "");
    Error('\p{:= in_NABATAEAN}');
    Error('\P{:= in_NABATAEAN}');
    Expect(1, 67759, '\p{_In_Nabataean}', "");
    Expect(0, 67759, '\p{^_In_Nabataean}', "");
    Expect(0, 67759, '\P{_In_Nabataean}', "");
    Expect(1, 67759, '\P{^_In_Nabataean}', "");
    Expect(0, 67760, '\p{_In_Nabataean}', "");
    Expect(1, 67760, '\p{^_In_Nabataean}', "");
    Expect(1, 67760, '\P{_In_Nabataean}', "");
    Expect(0, 67760, '\P{^_In_Nabataean}', "");
    Error('\p{	In_nandinagari:=}');
    Error('\P{	In_nandinagari:=}');
    Expect(1, 72191, '\p{innandinagari}', "");
    Expect(0, 72191, '\p{^innandinagari}', "");
    Expect(0, 72191, '\P{innandinagari}', "");
    Expect(1, 72191, '\P{^innandinagari}', "");
    Expect(0, 72192, '\p{innandinagari}', "");
    Expect(1, 72192, '\p{^innandinagari}', "");
    Expect(1, 72192, '\P{innandinagari}', "");
    Expect(0, 72192, '\P{^innandinagari}', "");
    Expect(1, 72191, '\p{ -in_nandinagari}', "");
    Expect(0, 72191, '\p{^ -in_nandinagari}', "");
    Expect(0, 72191, '\P{ -in_nandinagari}', "");
    Expect(1, 72191, '\P{^ -in_nandinagari}', "");
    Expect(0, 72192, '\p{ -in_nandinagari}', "");
    Expect(1, 72192, '\p{^ -in_nandinagari}', "");
    Expect(1, 72192, '\P{ -in_nandinagari}', "");
    Expect(0, 72192, '\P{^ -in_nandinagari}', "");
    Error('\p{:=	IN_NANDINAGARI}');
    Error('\P{:=	IN_NANDINAGARI}');
    Expect(1, 72191, '\p{	IN_NANDINAGARI}', "");
    Expect(0, 72191, '\p{^	IN_NANDINAGARI}', "");
    Expect(0, 72191, '\P{	IN_NANDINAGARI}', "");
    Expect(1, 72191, '\P{^	IN_NANDINAGARI}', "");
    Expect(0, 72192, '\p{	IN_NANDINAGARI}', "");
    Expect(1, 72192, '\p{^	IN_NANDINAGARI}', "");
    Expect(1, 72192, '\P{	IN_NANDINAGARI}', "");
    Expect(0, 72192, '\P{^	IN_NANDINAGARI}', "");
    Error('\p{-/a/In_New_Tai_lue}');
    Error('\P{-/a/In_New_Tai_lue}');
    Expect(1, 6623, '\p{innewtailue}', "");
    Expect(0, 6623, '\p{^innewtailue}', "");
    Expect(0, 6623, '\P{innewtailue}', "");
    Expect(1, 6623, '\P{^innewtailue}', "");
    Expect(0, 6624, '\p{innewtailue}', "");
    Expect(1, 6624, '\p{^innewtailue}', "");
    Expect(1, 6624, '\P{innewtailue}', "");
    Expect(0, 6624, '\P{^innewtailue}', "");
    Expect(1, 6623, '\p{	-In_NEW_Tai_Lue}', "");
    Expect(0, 6623, '\p{^	-In_NEW_Tai_Lue}', "");
    Expect(0, 6623, '\P{	-In_NEW_Tai_Lue}', "");
    Expect(1, 6623, '\P{^	-In_NEW_Tai_Lue}', "");
    Expect(0, 6624, '\p{	-In_NEW_Tai_Lue}', "");
    Expect(1, 6624, '\p{^	-In_NEW_Tai_Lue}', "");
    Expect(1, 6624, '\P{	-In_NEW_Tai_Lue}', "");
    Expect(0, 6624, '\P{^	-In_NEW_Tai_Lue}', "");
    Error('\p{_In_New_Tai_Lue/a/}');
    Error('\P{_In_New_Tai_Lue/a/}');
    Expect(1, 6623, '\p{-	In_New_tai_Lue}', "");
    Expect(0, 6623, '\p{^-	In_New_tai_Lue}', "");
    Expect(0, 6623, '\P{-	In_New_tai_Lue}', "");
    Expect(1, 6623, '\P{^-	In_New_tai_Lue}', "");
    Expect(0, 6624, '\p{-	In_New_tai_Lue}', "");
    Expect(1, 6624, '\p{^-	In_New_tai_Lue}', "");
    Expect(1, 6624, '\P{-	In_New_tai_Lue}', "");
    Expect(0, 6624, '\P{^-	In_New_tai_Lue}', "");
    Error('\p{/a/__in_newa}');
    Error('\P{/a/__in_newa}');
    Expect(1, 70783, '\p{innewa}', "");
    Expect(0, 70783, '\p{^innewa}', "");
    Expect(0, 70783, '\P{innewa}', "");
    Expect(1, 70783, '\P{^innewa}', "");
    Expect(0, 70784, '\p{innewa}', "");
    Expect(1, 70784, '\p{^innewa}', "");
    Expect(1, 70784, '\P{innewa}', "");
    Expect(0, 70784, '\P{^innewa}', "");
    Expect(1, 70783, '\p{	 IN_NEWA}', "");
    Expect(0, 70783, '\p{^	 IN_NEWA}', "");
    Expect(0, 70783, '\P{	 IN_NEWA}', "");
    Expect(1, 70783, '\P{^	 IN_NEWA}', "");
    Expect(0, 70784, '\p{	 IN_NEWA}', "");
    Expect(1, 70784, '\p{^	 IN_NEWA}', "");
    Expect(1, 70784, '\P{	 IN_NEWA}', "");
    Expect(0, 70784, '\P{^	 IN_NEWA}', "");
    Error('\p{-/a/In_newa}');
    Error('\P{-/a/In_newa}');
    Expect(1, 70783, '\p{_-In_Newa}', "");
    Expect(0, 70783, '\p{^_-In_Newa}', "");
    Expect(0, 70783, '\P{_-In_Newa}', "");
    Expect(1, 70783, '\P{^_-In_Newa}', "");
    Expect(0, 70784, '\p{_-In_Newa}', "");
    Expect(1, 70784, '\p{^_-In_Newa}', "");
    Expect(1, 70784, '\P{_-In_Newa}', "");
    Expect(0, 70784, '\P{^_-In_Newa}', "");
    Error('\p{/a/-In_NKo}');
    Error('\P{/a/-In_NKo}');
    Expect(1, 2047, '\p{innko}', "");
    Expect(0, 2047, '\p{^innko}', "");
    Expect(0, 2047, '\P{innko}', "");
    Expect(1, 2047, '\P{^innko}', "");
    Expect(0, 2048, '\p{innko}', "");
    Expect(1, 2048, '\p{^innko}', "");
    Expect(1, 2048, '\P{innko}', "");
    Expect(0, 2048, '\P{^innko}', "");
    Expect(1, 2047, '\p{--In_NKo}', "");
    Expect(0, 2047, '\p{^--In_NKo}', "");
    Expect(0, 2047, '\P{--In_NKo}', "");
    Expect(1, 2047, '\P{^--In_NKo}', "");
    Expect(0, 2048, '\p{--In_NKo}', "");
    Expect(1, 2048, '\p{^--In_NKo}', "");
    Expect(1, 2048, '\P{--In_NKo}', "");
    Expect(0, 2048, '\P{^--In_NKo}', "");
    Error('\p{		IN_NKo:=}');
    Error('\P{		IN_NKo:=}');
    Expect(1, 2047, '\p{ in_NKo}', "");
    Expect(0, 2047, '\p{^ in_NKo}', "");
    Expect(0, 2047, '\P{ in_NKo}', "");
    Expect(1, 2047, '\P{^ in_NKo}', "");
    Expect(0, 2048, '\p{ in_NKo}', "");
    Expect(1, 2048, '\p{^ in_NKo}', "");
    Expect(1, 2048, '\P{ in_NKo}', "");
    Expect(0, 2048, '\P{^ in_NKo}', "");
    Error('\p{_:=In_nushu}');
    Error('\P{_:=In_nushu}');
    Expect(1, 111359, '\p{innushu}', "");
    Expect(0, 111359, '\p{^innushu}', "");
    Expect(0, 111359, '\P{innushu}', "");
    Expect(1, 111359, '\P{^innushu}', "");
    Expect(0, 111360, '\p{innushu}', "");
    Expect(1, 111360, '\p{^innushu}', "");
    Expect(1, 111360, '\P{innushu}', "");
    Expect(0, 111360, '\P{^innushu}', "");
    Expect(1, 111359, '\p{	-in_NUSHU}', "");
    Expect(0, 111359, '\p{^	-in_NUSHU}', "");
    Expect(0, 111359, '\P{	-in_NUSHU}', "");
    Expect(1, 111359, '\P{^	-in_NUSHU}', "");
    Expect(0, 111360, '\p{	-in_NUSHU}', "");
    Expect(1, 111360, '\p{^	-in_NUSHU}', "");
    Expect(1, 111360, '\P{	-in_NUSHU}', "");
    Expect(0, 111360, '\P{^	-in_NUSHU}', "");
    Error('\p{-_in_NUSHU:=}');
    Error('\P{-_in_NUSHU:=}');
    Expect(1, 111359, '\p{ In_NUSHU}', "");
    Expect(0, 111359, '\p{^ In_NUSHU}', "");
    Expect(0, 111359, '\P{ In_NUSHU}', "");
    Expect(1, 111359, '\P{^ In_NUSHU}', "");
    Expect(0, 111360, '\p{ In_NUSHU}', "");
    Expect(1, 111360, '\p{^ In_NUSHU}', "");
    Expect(1, 111360, '\P{ In_NUSHU}', "");
    Expect(0, 111360, '\P{^ In_NUSHU}', "");
    Error('\p{/a/ 	IN_NYIAKENG_PUACHUE_HMONG}');
    Error('\P{/a/ 	IN_NYIAKENG_PUACHUE_HMONG}');
    Expect(1, 123215, '\p{innyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^innyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{innyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^innyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{innyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^innyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{innyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^innyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{-	in_Nyiakeng_puachue_Hmong}', "");
    Expect(0, 123215, '\p{^-	in_Nyiakeng_puachue_Hmong}', "");
    Expect(0, 123215, '\P{-	in_Nyiakeng_puachue_Hmong}', "");
    Expect(1, 123215, '\P{^-	in_Nyiakeng_puachue_Hmong}', "");
    Expect(0, 123216, '\p{-	in_Nyiakeng_puachue_Hmong}', "");
    Expect(1, 123216, '\p{^-	in_Nyiakeng_puachue_Hmong}', "");
    Expect(1, 123216, '\P{-	in_Nyiakeng_puachue_Hmong}', "");
    Expect(0, 123216, '\P{^-	in_Nyiakeng_puachue_Hmong}', "");
    Error('\p{/a/ 	IN_Nyiakeng_Puachue_Hmong}');
    Error('\P{/a/ 	IN_Nyiakeng_Puachue_Hmong}');
    Expect(1, 123215, '\p{	IN_nyiakeng_puachue_Hmong}', "");
    Expect(0, 123215, '\p{^	IN_nyiakeng_puachue_Hmong}', "");
    Expect(0, 123215, '\P{	IN_nyiakeng_puachue_Hmong}', "");
    Expect(1, 123215, '\P{^	IN_nyiakeng_puachue_Hmong}', "");
    Expect(0, 123216, '\p{	IN_nyiakeng_puachue_Hmong}', "");
    Expect(1, 123216, '\p{^	IN_nyiakeng_puachue_Hmong}', "");
    Expect(1, 123216, '\P{	IN_nyiakeng_puachue_Hmong}', "");
    Expect(0, 123216, '\P{^	IN_nyiakeng_puachue_Hmong}', "");
    Error('\p{-In_ogham:=}');
    Error('\P{-In_ogham:=}');
    Expect(1, 5791, '\p{inogham}', "");
    Expect(0, 5791, '\p{^inogham}', "");
    Expect(0, 5791, '\P{inogham}', "");
    Expect(1, 5791, '\P{^inogham}', "");
    Expect(0, 5792, '\p{inogham}', "");
    Expect(1, 5792, '\p{^inogham}', "");
    Expect(1, 5792, '\P{inogham}', "");
    Expect(0, 5792, '\P{^inogham}', "");
    Expect(1, 5791, '\p{ 	IN_Ogham}', "");
    Expect(0, 5791, '\p{^ 	IN_Ogham}', "");
    Expect(0, 5791, '\P{ 	IN_Ogham}', "");
    Expect(1, 5791, '\P{^ 	IN_Ogham}', "");
    Expect(0, 5792, '\p{ 	IN_Ogham}', "");
    Expect(1, 5792, '\p{^ 	IN_Ogham}', "");
    Expect(1, 5792, '\P{ 	IN_Ogham}', "");
    Expect(0, 5792, '\P{^ 	IN_Ogham}', "");
    Error('\p{/a/--In_Ogham}');
    Error('\P{/a/--In_Ogham}');
    Expect(1, 5791, '\p{		in_Ogham}', "");
    Expect(0, 5791, '\p{^		in_Ogham}', "");
    Expect(0, 5791, '\P{		in_Ogham}', "");
    Expect(1, 5791, '\P{^		in_Ogham}', "");
    Expect(0, 5792, '\p{		in_Ogham}', "");
    Expect(1, 5792, '\p{^		in_Ogham}', "");
    Expect(1, 5792, '\P{		in_Ogham}', "");
    Expect(0, 5792, '\P{^		in_Ogham}', "");
    Error('\p{ _IN_Ol_Chiki/a/}');
    Error('\P{ _IN_Ol_Chiki/a/}');
    Expect(1, 7295, '\p{inolchiki}', "");
    Expect(0, 7295, '\p{^inolchiki}', "");
    Expect(0, 7295, '\P{inolchiki}', "");
    Expect(1, 7295, '\P{^inolchiki}', "");
    Expect(0, 7296, '\p{inolchiki}', "");
    Expect(1, 7296, '\p{^inolchiki}', "");
    Expect(1, 7296, '\P{inolchiki}', "");
    Expect(0, 7296, '\P{^inolchiki}', "");
    Expect(1, 7295, '\p{	in_OL_Chiki}', "");
    Expect(0, 7295, '\p{^	in_OL_Chiki}', "");
    Expect(0, 7295, '\P{	in_OL_Chiki}', "");
    Expect(1, 7295, '\P{^	in_OL_Chiki}', "");
    Expect(0, 7296, '\p{	in_OL_Chiki}', "");
    Expect(1, 7296, '\p{^	in_OL_Chiki}', "");
    Expect(1, 7296, '\P{	in_OL_Chiki}', "");
    Expect(0, 7296, '\P{^	in_OL_Chiki}', "");
    Error('\p{:=IN_ol_CHIKI}');
    Error('\P{:=IN_ol_CHIKI}');
    Expect(1, 7295, '\p{_In_Ol_chiki}', "");
    Expect(0, 7295, '\p{^_In_Ol_chiki}', "");
    Expect(0, 7295, '\P{_In_Ol_chiki}', "");
    Expect(1, 7295, '\P{^_In_Ol_chiki}', "");
    Expect(0, 7296, '\p{_In_Ol_chiki}', "");
    Expect(1, 7296, '\p{^_In_Ol_chiki}', "");
    Expect(1, 7296, '\P{_In_Ol_chiki}', "");
    Expect(0, 7296, '\P{^_In_Ol_chiki}', "");
    Error('\p{/a/--In_Old_Hungarian}');
    Error('\P{/a/--In_Old_Hungarian}');
    Expect(1, 68863, '\p{inoldhungarian}', "");
    Expect(0, 68863, '\p{^inoldhungarian}', "");
    Expect(0, 68863, '\P{inoldhungarian}', "");
    Expect(1, 68863, '\P{^inoldhungarian}', "");
    Expect(0, 68864, '\p{inoldhungarian}', "");
    Expect(1, 68864, '\p{^inoldhungarian}', "");
    Expect(1, 68864, '\P{inoldhungarian}', "");
    Expect(0, 68864, '\P{^inoldhungarian}', "");
    Expect(1, 68863, '\p{_in_old_Hungarian}', "");
    Expect(0, 68863, '\p{^_in_old_Hungarian}', "");
    Expect(0, 68863, '\P{_in_old_Hungarian}', "");
    Expect(1, 68863, '\P{^_in_old_Hungarian}', "");
    Expect(0, 68864, '\p{_in_old_Hungarian}', "");
    Expect(1, 68864, '\p{^_in_old_Hungarian}', "");
    Expect(1, 68864, '\P{_in_old_Hungarian}', "");
    Expect(0, 68864, '\P{^_in_old_Hungarian}', "");
    Error('\p{/a/		IN_OLD_Hungarian}');
    Error('\P{/a/		IN_OLD_Hungarian}');
    Expect(1, 68863, '\p{		in_Old_Hungarian}', "");
    Expect(0, 68863, '\p{^		in_Old_Hungarian}', "");
    Expect(0, 68863, '\P{		in_Old_Hungarian}', "");
    Expect(1, 68863, '\P{^		in_Old_Hungarian}', "");
    Expect(0, 68864, '\p{		in_Old_Hungarian}', "");
    Expect(1, 68864, '\p{^		in_Old_Hungarian}', "");
    Expect(1, 68864, '\P{		in_Old_Hungarian}', "");
    Expect(0, 68864, '\P{^		in_Old_Hungarian}', "");
    Error('\p{/a/In_Old_italic}');
    Error('\P{/a/In_Old_italic}');
    Expect(1, 66351, '\p{inolditalic}', "");
    Expect(0, 66351, '\p{^inolditalic}', "");
    Expect(0, 66351, '\P{inolditalic}', "");
    Expect(1, 66351, '\P{^inolditalic}', "");
    Expect(0, 66352, '\p{inolditalic}', "");
    Expect(1, 66352, '\p{^inolditalic}', "");
    Expect(1, 66352, '\P{inolditalic}', "");
    Expect(0, 66352, '\P{^inolditalic}', "");
    Expect(1, 66351, '\p{__In_Old_Italic}', "");
    Expect(0, 66351, '\p{^__In_Old_Italic}', "");
    Expect(0, 66351, '\P{__In_Old_Italic}', "");
    Expect(1, 66351, '\P{^__In_Old_Italic}', "");
    Expect(0, 66352, '\p{__In_Old_Italic}', "");
    Expect(1, 66352, '\p{^__In_Old_Italic}', "");
    Expect(1, 66352, '\P{__In_Old_Italic}', "");
    Expect(0, 66352, '\P{^__In_Old_Italic}', "");
    Error('\p{-	IN_OLD_ITALIC:=}');
    Error('\P{-	IN_OLD_ITALIC:=}');
    Expect(1, 66351, '\p{_in_old_Italic}', "");
    Expect(0, 66351, '\p{^_in_old_Italic}', "");
    Expect(0, 66351, '\P{_in_old_Italic}', "");
    Expect(1, 66351, '\P{^_in_old_Italic}', "");
    Expect(0, 66352, '\p{_in_old_Italic}', "");
    Expect(1, 66352, '\p{^_in_old_Italic}', "");
    Expect(1, 66352, '\P{_in_old_Italic}', "");
    Expect(0, 66352, '\P{^_in_old_Italic}', "");
    Error('\p{/a/  In_OLD_north_Arabian}');
    Error('\P{/a/  In_OLD_north_Arabian}');
    Expect(1, 68255, '\p{inoldnortharabian}', "");
    Expect(0, 68255, '\p{^inoldnortharabian}', "");
    Expect(0, 68255, '\P{inoldnortharabian}', "");
    Expect(1, 68255, '\P{^inoldnortharabian}', "");
    Expect(0, 68256, '\p{inoldnortharabian}', "");
    Expect(1, 68256, '\p{^inoldnortharabian}', "");
    Expect(1, 68256, '\P{inoldnortharabian}', "");
    Expect(0, 68256, '\P{^inoldnortharabian}', "");
    Expect(1, 68255, '\p{	 In_Old_North_ARABIAN}', "");
    Expect(0, 68255, '\p{^	 In_Old_North_ARABIAN}', "");
    Expect(0, 68255, '\P{	 In_Old_North_ARABIAN}', "");
    Expect(1, 68255, '\P{^	 In_Old_North_ARABIAN}', "");
    Expect(0, 68256, '\p{	 In_Old_North_ARABIAN}', "");
    Expect(1, 68256, '\p{^	 In_Old_North_ARABIAN}', "");
    Expect(1, 68256, '\P{	 In_Old_North_ARABIAN}', "");
    Expect(0, 68256, '\P{^	 In_Old_North_ARABIAN}', "");
    Error('\p{	in_old_North_Arabian/a/}');
    Error('\P{	in_old_North_Arabian/a/}');
    Expect(1, 68255, '\p{ _In_Old_north_ARABIAN}', "");
    Expect(0, 68255, '\p{^ _In_Old_north_ARABIAN}', "");
    Expect(0, 68255, '\P{ _In_Old_north_ARABIAN}', "");
    Expect(1, 68255, '\P{^ _In_Old_north_ARABIAN}', "");
    Expect(0, 68256, '\p{ _In_Old_north_ARABIAN}', "");
    Expect(1, 68256, '\p{^ _In_Old_north_ARABIAN}', "");
    Expect(1, 68256, '\P{ _In_Old_north_ARABIAN}', "");
    Expect(0, 68256, '\P{^ _In_Old_north_ARABIAN}', "");
    Error('\p{	in_Old_PERMIC:=}');
    Error('\P{	in_Old_PERMIC:=}');
    Expect(1, 66431, '\p{inoldpermic}', "");
    Expect(0, 66431, '\p{^inoldpermic}', "");
    Expect(0, 66431, '\P{inoldpermic}', "");
    Expect(1, 66431, '\P{^inoldpermic}', "");
    Expect(0, 66432, '\p{inoldpermic}', "");
    Expect(1, 66432, '\p{^inoldpermic}', "");
    Expect(1, 66432, '\P{inoldpermic}', "");
    Expect(0, 66432, '\P{^inoldpermic}', "");
    Expect(1, 66431, '\p{_ In_Old_Permic}', "");
    Expect(0, 66431, '\p{^_ In_Old_Permic}', "");
    Expect(0, 66431, '\P{_ In_Old_Permic}', "");
    Expect(1, 66431, '\P{^_ In_Old_Permic}', "");
    Expect(0, 66432, '\p{_ In_Old_Permic}', "");
    Expect(1, 66432, '\p{^_ In_Old_Permic}', "");
    Expect(1, 66432, '\P{_ In_Old_Permic}', "");
    Expect(0, 66432, '\P{^_ In_Old_Permic}', "");
    Error('\p{ :=IN_Old_Permic}');
    Error('\P{ :=IN_Old_Permic}');
    Expect(1, 66431, '\p{	In_Old_PERMIC}', "");
    Expect(0, 66431, '\p{^	In_Old_PERMIC}', "");
    Expect(0, 66431, '\P{	In_Old_PERMIC}', "");
    Expect(1, 66431, '\P{^	In_Old_PERMIC}', "");
    Expect(0, 66432, '\p{	In_Old_PERMIC}', "");
    Expect(1, 66432, '\p{^	In_Old_PERMIC}', "");
    Expect(1, 66432, '\P{	In_Old_PERMIC}', "");
    Expect(0, 66432, '\P{^	In_Old_PERMIC}', "");
    Error('\p{- In_OLD_Persian:=}');
    Error('\P{- In_OLD_Persian:=}');
    Expect(1, 66527, '\p{inoldpersian}', "");
    Expect(0, 66527, '\p{^inoldpersian}', "");
    Expect(0, 66527, '\P{inoldpersian}', "");
    Expect(1, 66527, '\P{^inoldpersian}', "");
    Expect(0, 66528, '\p{inoldpersian}', "");
    Expect(1, 66528, '\p{^inoldpersian}', "");
    Expect(1, 66528, '\P{inoldpersian}', "");
    Expect(0, 66528, '\P{^inoldpersian}', "");
    Expect(1, 66527, '\p{-_in_Old_Persian}', "");
    Expect(0, 66527, '\p{^-_in_Old_Persian}', "");
    Expect(0, 66527, '\P{-_in_Old_Persian}', "");
    Expect(1, 66527, '\P{^-_in_Old_Persian}', "");
    Expect(0, 66528, '\p{-_in_Old_Persian}', "");
    Expect(1, 66528, '\p{^-_in_Old_Persian}', "");
    Expect(1, 66528, '\P{-_in_Old_Persian}', "");
    Expect(0, 66528, '\P{^-_in_Old_Persian}', "");
    Error('\p{		IN_old_PERSIAN/a/}');
    Error('\P{		IN_old_PERSIAN/a/}');
    Expect(1, 66527, '\p{	In_Old_Persian}', "");
    Expect(0, 66527, '\p{^	In_Old_Persian}', "");
    Expect(0, 66527, '\P{	In_Old_Persian}', "");
    Expect(1, 66527, '\P{^	In_Old_Persian}', "");
    Expect(0, 66528, '\p{	In_Old_Persian}', "");
    Expect(1, 66528, '\p{^	In_Old_Persian}', "");
    Expect(1, 66528, '\P{	In_Old_Persian}', "");
    Expect(0, 66528, '\P{^	In_Old_Persian}', "");
    Error('\p{--In_old_SOGDIAN:=}');
    Error('\P{--In_old_SOGDIAN:=}');
    Expect(1, 69423, '\p{inoldsogdian}', "");
    Expect(0, 69423, '\p{^inoldsogdian}', "");
    Expect(0, 69423, '\P{inoldsogdian}', "");
    Expect(1, 69423, '\P{^inoldsogdian}', "");
    Expect(0, 69424, '\p{inoldsogdian}', "");
    Expect(1, 69424, '\p{^inoldsogdian}', "");
    Expect(1, 69424, '\P{inoldsogdian}', "");
    Expect(0, 69424, '\P{^inoldsogdian}', "");
    Expect(1, 69423, '\p{	_In_Old_Sogdian}', "");
    Expect(0, 69423, '\p{^	_In_Old_Sogdian}', "");
    Expect(0, 69423, '\P{	_In_Old_Sogdian}', "");
    Expect(1, 69423, '\P{^	_In_Old_Sogdian}', "");
    Expect(0, 69424, '\p{	_In_Old_Sogdian}', "");
    Expect(1, 69424, '\p{^	_In_Old_Sogdian}', "");
    Expect(1, 69424, '\P{	_In_Old_Sogdian}', "");
    Expect(0, 69424, '\P{^	_In_Old_Sogdian}', "");
    Error('\p{--In_old_Sogdian:=}');
    Error('\P{--In_old_Sogdian:=}');
    Expect(1, 69423, '\p{  In_old_Sogdian}', "");
    Expect(0, 69423, '\p{^  In_old_Sogdian}', "");
    Expect(0, 69423, '\P{  In_old_Sogdian}', "");
    Expect(1, 69423, '\P{^  In_old_Sogdian}', "");
    Expect(0, 69424, '\p{  In_old_Sogdian}', "");
    Expect(1, 69424, '\p{^  In_old_Sogdian}', "");
    Expect(1, 69424, '\P{  In_old_Sogdian}', "");
    Expect(0, 69424, '\P{^  In_old_Sogdian}', "");
    Error('\p{__In_Old_South_Arabian/a/}');
    Error('\P{__In_Old_South_Arabian/a/}');
    Expect(1, 68223, '\p{inoldsoutharabian}', "");
    Expect(0, 68223, '\p{^inoldsoutharabian}', "");
    Expect(0, 68223, '\P{inoldsoutharabian}', "");
    Expect(1, 68223, '\P{^inoldsoutharabian}', "");
    Expect(0, 68224, '\p{inoldsoutharabian}', "");
    Expect(1, 68224, '\p{^inoldsoutharabian}', "");
    Expect(1, 68224, '\P{inoldsoutharabian}', "");
    Expect(0, 68224, '\P{^inoldsoutharabian}', "");
    Expect(1, 68223, '\p{_IN_OLD_south_arabian}', "");
    Expect(0, 68223, '\p{^_IN_OLD_south_arabian}', "");
    Expect(0, 68223, '\P{_IN_OLD_south_arabian}', "");
    Expect(1, 68223, '\P{^_IN_OLD_south_arabian}', "");
    Expect(0, 68224, '\p{_IN_OLD_south_arabian}', "");
    Expect(1, 68224, '\p{^_IN_OLD_south_arabian}', "");
    Expect(1, 68224, '\P{_IN_OLD_south_arabian}', "");
    Expect(0, 68224, '\P{^_IN_OLD_south_arabian}', "");
    Error('\p{:=-_In_OLD_south_ARABIAN}');
    Error('\P{:=-_In_OLD_south_ARABIAN}');
    Expect(1, 68223, '\p{_IN_Old_SOUTH_Arabian}', "");
    Expect(0, 68223, '\p{^_IN_Old_SOUTH_Arabian}', "");
    Expect(0, 68223, '\P{_IN_Old_SOUTH_Arabian}', "");
    Expect(1, 68223, '\P{^_IN_Old_SOUTH_Arabian}', "");
    Expect(0, 68224, '\p{_IN_Old_SOUTH_Arabian}', "");
    Expect(1, 68224, '\p{^_IN_Old_SOUTH_Arabian}', "");
    Expect(1, 68224, '\P{_IN_Old_SOUTH_Arabian}', "");
    Expect(0, 68224, '\P{^_IN_Old_SOUTH_Arabian}', "");
    Error('\p{	:=In_Old_TURKIC}');
    Error('\P{	:=In_Old_TURKIC}');
    Expect(1, 68687, '\p{inoldturkic}', "");
    Expect(0, 68687, '\p{^inoldturkic}', "");
    Expect(0, 68687, '\P{inoldturkic}', "");
    Expect(1, 68687, '\P{^inoldturkic}', "");
    Expect(0, 68688, '\p{inoldturkic}', "");
    Expect(1, 68688, '\p{^inoldturkic}', "");
    Expect(1, 68688, '\P{inoldturkic}', "");
    Expect(0, 68688, '\P{^inoldturkic}', "");
    Expect(1, 68687, '\p{_In_old_turkic}', "");
    Expect(0, 68687, '\p{^_In_old_turkic}', "");
    Expect(0, 68687, '\P{_In_old_turkic}', "");
    Expect(1, 68687, '\P{^_In_old_turkic}', "");
    Expect(0, 68688, '\p{_In_old_turkic}', "");
    Expect(1, 68688, '\p{^_In_old_turkic}', "");
    Expect(1, 68688, '\P{_In_old_turkic}', "");
    Expect(0, 68688, '\P{^_In_old_turkic}', "");
    Error('\p{	in_old_Turkic:=}');
    Error('\P{	in_old_Turkic:=}');
    Expect(1, 68687, '\p{ in_Old_turkic}', "");
    Expect(0, 68687, '\p{^ in_Old_turkic}', "");
    Expect(0, 68687, '\P{ in_Old_turkic}', "");
    Expect(1, 68687, '\P{^ in_Old_turkic}', "");
    Expect(0, 68688, '\p{ in_Old_turkic}', "");
    Expect(1, 68688, '\p{^ in_Old_turkic}', "");
    Expect(1, 68688, '\P{ in_Old_turkic}', "");
    Expect(0, 68688, '\P{^ in_Old_turkic}', "");
    Error('\p{/a/ In_Oriya}');
    Error('\P{/a/ In_Oriya}');
    Expect(1, 2943, '\p{inoriya}', "");
    Expect(0, 2943, '\p{^inoriya}', "");
    Expect(0, 2943, '\P{inoriya}', "");
    Expect(1, 2943, '\P{^inoriya}', "");
    Expect(0, 2944, '\p{inoriya}', "");
    Expect(1, 2944, '\p{^inoriya}', "");
    Expect(1, 2944, '\P{inoriya}', "");
    Expect(0, 2944, '\P{^inoriya}', "");
    Expect(1, 2943, '\p{_IN_ORIYA}', "");
    Expect(0, 2943, '\p{^_IN_ORIYA}', "");
    Expect(0, 2943, '\P{_IN_ORIYA}', "");
    Expect(1, 2943, '\P{^_IN_ORIYA}', "");
    Expect(0, 2944, '\p{_IN_ORIYA}', "");
    Expect(1, 2944, '\p{^_IN_ORIYA}', "");
    Expect(1, 2944, '\P{_IN_ORIYA}', "");
    Expect(0, 2944, '\P{^_IN_ORIYA}', "");
    Error('\p{ in_Oriya:=}');
    Error('\P{ in_Oriya:=}');
    Expect(1, 2943, '\p{_IN_Oriya}', "");
    Expect(0, 2943, '\p{^_IN_Oriya}', "");
    Expect(0, 2943, '\P{_IN_Oriya}', "");
    Expect(1, 2943, '\P{^_IN_Oriya}', "");
    Expect(0, 2944, '\p{_IN_Oriya}', "");
    Expect(1, 2944, '\p{^_IN_Oriya}', "");
    Expect(1, 2944, '\P{_IN_Oriya}', "");
    Expect(0, 2944, '\P{^_IN_Oriya}', "");
    Error('\p{:=	IN_osage}');
    Error('\P{:=	IN_osage}');
    Expect(1, 66815, '\p{inosage}', "");
    Expect(0, 66815, '\p{^inosage}', "");
    Expect(0, 66815, '\P{inosage}', "");
    Expect(1, 66815, '\P{^inosage}', "");
    Expect(0, 66816, '\p{inosage}', "");
    Expect(1, 66816, '\p{^inosage}', "");
    Expect(1, 66816, '\P{inosage}', "");
    Expect(0, 66816, '\P{^inosage}', "");
    Expect(1, 66815, '\p{ 	in_osage}', "");
    Expect(0, 66815, '\p{^ 	in_osage}', "");
    Expect(0, 66815, '\P{ 	in_osage}', "");
    Expect(1, 66815, '\P{^ 	in_osage}', "");
    Expect(0, 66816, '\p{ 	in_osage}', "");
    Expect(1, 66816, '\p{^ 	in_osage}', "");
    Expect(1, 66816, '\P{ 	in_osage}', "");
    Expect(0, 66816, '\P{^ 	in_osage}', "");
    Error('\p{:=In_Osage}');
    Error('\P{:=In_Osage}');
    Expect(1, 66815, '\p{-IN_Osage}', "");
    Expect(0, 66815, '\p{^-IN_Osage}', "");
    Expect(0, 66815, '\P{-IN_Osage}', "");
    Expect(1, 66815, '\P{^-IN_Osage}', "");
    Expect(0, 66816, '\p{-IN_Osage}', "");
    Expect(1, 66816, '\p{^-IN_Osage}', "");
    Expect(1, 66816, '\P{-IN_Osage}', "");
    Expect(0, 66816, '\P{^-IN_Osage}', "");
    Error('\p{/a/	 IN_Osmanya}');
    Error('\P{/a/	 IN_Osmanya}');
    Expect(1, 66735, '\p{inosmanya}', "");
    Expect(0, 66735, '\p{^inosmanya}', "");
    Expect(0, 66735, '\P{inosmanya}', "");
    Expect(1, 66735, '\P{^inosmanya}', "");
    Expect(0, 66736, '\p{inosmanya}', "");
    Expect(1, 66736, '\p{^inosmanya}', "");
    Expect(1, 66736, '\P{inosmanya}', "");
    Expect(0, 66736, '\P{^inosmanya}', "");
    Expect(1, 66735, '\p{_ In_Osmanya}', "");
    Expect(0, 66735, '\p{^_ In_Osmanya}', "");
    Expect(0, 66735, '\P{_ In_Osmanya}', "");
    Expect(1, 66735, '\P{^_ In_Osmanya}', "");
    Expect(0, 66736, '\p{_ In_Osmanya}', "");
    Expect(1, 66736, '\p{^_ In_Osmanya}', "");
    Expect(1, 66736, '\P{_ In_Osmanya}', "");
    Expect(0, 66736, '\P{^_ In_Osmanya}', "");
    Error('\p{/a/-IN_Osmanya}');
    Error('\P{/a/-IN_Osmanya}');
    Expect(1, 66735, '\p{_-In_osmanya}', "");
    Expect(0, 66735, '\p{^_-In_osmanya}', "");
    Expect(0, 66735, '\P{_-In_osmanya}', "");
    Expect(1, 66735, '\P{^_-In_osmanya}', "");
    Expect(0, 66736, '\p{_-In_osmanya}', "");
    Expect(1, 66736, '\p{^_-In_osmanya}', "");
    Expect(1, 66736, '\P{_-In_osmanya}', "");
    Expect(0, 66736, '\P{^_-In_osmanya}', "");
    Error('\p{	In_pahawh_Hmong/a/}');
    Error('\P{	In_pahawh_Hmong/a/}');
    Expect(1, 93071, '\p{inpahawhhmong}', "");
    Expect(0, 93071, '\p{^inpahawhhmong}', "");
    Expect(0, 93071, '\P{inpahawhhmong}', "");
    Expect(1, 93071, '\P{^inpahawhhmong}', "");
    Expect(0, 93072, '\p{inpahawhhmong}', "");
    Expect(1, 93072, '\p{^inpahawhhmong}', "");
    Expect(1, 93072, '\P{inpahawhhmong}', "");
    Expect(0, 93072, '\P{^inpahawhhmong}', "");
    Expect(1, 93071, '\p{__In_Pahawh_Hmong}', "");
    Expect(0, 93071, '\p{^__In_Pahawh_Hmong}', "");
    Expect(0, 93071, '\P{__In_Pahawh_Hmong}', "");
    Expect(1, 93071, '\P{^__In_Pahawh_Hmong}', "");
    Expect(0, 93072, '\p{__In_Pahawh_Hmong}', "");
    Expect(1, 93072, '\p{^__In_Pahawh_Hmong}', "");
    Expect(1, 93072, '\P{__In_Pahawh_Hmong}', "");
    Expect(0, 93072, '\P{^__In_Pahawh_Hmong}', "");
    Error('\p{_In_PAHAWH_hmong/a/}');
    Error('\P{_In_PAHAWH_hmong/a/}');
    Expect(1, 93071, '\p{_	IN_Pahawh_HMONG}', "");
    Expect(0, 93071, '\p{^_	IN_Pahawh_HMONG}', "");
    Expect(0, 93071, '\P{_	IN_Pahawh_HMONG}', "");
    Expect(1, 93071, '\P{^_	IN_Pahawh_HMONG}', "");
    Expect(0, 93072, '\p{_	IN_Pahawh_HMONG}', "");
    Expect(1, 93072, '\p{^_	IN_Pahawh_HMONG}', "");
    Expect(1, 93072, '\P{_	IN_Pahawh_HMONG}', "");
    Expect(0, 93072, '\P{^_	IN_Pahawh_HMONG}', "");
    Error('\p{_in_palmyrene/a/}');
    Error('\P{_in_palmyrene/a/}');
    Expect(1, 67711, '\p{inpalmyrene}', "");
    Expect(0, 67711, '\p{^inpalmyrene}', "");
    Expect(0, 67711, '\P{inpalmyrene}', "");
    Expect(1, 67711, '\P{^inpalmyrene}', "");
    Expect(0, 67712, '\p{inpalmyrene}', "");
    Expect(1, 67712, '\p{^inpalmyrene}', "");
    Expect(1, 67712, '\P{inpalmyrene}', "");
    Expect(0, 67712, '\P{^inpalmyrene}', "");
    Expect(1, 67711, '\p{- In_palmyrene}', "");
    Expect(0, 67711, '\p{^- In_palmyrene}', "");
    Expect(0, 67711, '\P{- In_palmyrene}', "");
    Expect(1, 67711, '\P{^- In_palmyrene}', "");
    Expect(0, 67712, '\p{- In_palmyrene}', "");
    Expect(1, 67712, '\p{^- In_palmyrene}', "");
    Expect(1, 67712, '\P{- In_palmyrene}', "");
    Expect(0, 67712, '\P{^- In_palmyrene}', "");
    Error('\p{ /a/In_Palmyrene}');
    Error('\P{ /a/In_Palmyrene}');
    Expect(1, 67711, '\p{ IN_Palmyrene}', "");
    Expect(0, 67711, '\p{^ IN_Palmyrene}', "");
    Expect(0, 67711, '\P{ IN_Palmyrene}', "");
    Expect(1, 67711, '\P{^ IN_Palmyrene}', "");
    Expect(0, 67712, '\p{ IN_Palmyrene}', "");
    Expect(1, 67712, '\p{^ IN_Palmyrene}', "");
    Expect(1, 67712, '\P{ IN_Palmyrene}', "");
    Expect(0, 67712, '\P{^ IN_Palmyrene}', "");
    Error('\p{ /a/IN_Pau_cin_Hau}');
    Error('\P{ /a/IN_Pau_cin_Hau}');
    Expect(1, 72447, '\p{inpaucinhau}', "");
    Expect(0, 72447, '\p{^inpaucinhau}', "");
    Expect(0, 72447, '\P{inpaucinhau}', "");
    Expect(1, 72447, '\P{^inpaucinhau}', "");
    Expect(0, 72448, '\p{inpaucinhau}', "");
    Expect(1, 72448, '\p{^inpaucinhau}', "");
    Expect(1, 72448, '\P{inpaucinhau}', "");
    Expect(0, 72448, '\P{^inpaucinhau}', "");
    Expect(1, 72447, '\p{In_Pau_CIN_Hau}', "");
    Expect(0, 72447, '\p{^In_Pau_CIN_Hau}', "");
    Expect(0, 72447, '\P{In_Pau_CIN_Hau}', "");
    Expect(1, 72447, '\P{^In_Pau_CIN_Hau}', "");
    Expect(0, 72448, '\p{In_Pau_CIN_Hau}', "");
    Expect(1, 72448, '\p{^In_Pau_CIN_Hau}', "");
    Expect(1, 72448, '\P{In_Pau_CIN_Hau}', "");
    Expect(0, 72448, '\P{^In_Pau_CIN_Hau}', "");
    Error('\p{/a/-_IN_Pau_Cin_Hau}');
    Error('\P{/a/-_IN_Pau_Cin_Hau}');
    Expect(1, 72447, '\p{ In_Pau_Cin_Hau}', "");
    Expect(0, 72447, '\p{^ In_Pau_Cin_Hau}', "");
    Expect(0, 72447, '\P{ In_Pau_Cin_Hau}', "");
    Expect(1, 72447, '\P{^ In_Pau_Cin_Hau}', "");
    Expect(0, 72448, '\p{ In_Pau_Cin_Hau}', "");
    Expect(1, 72448, '\p{^ In_Pau_Cin_Hau}', "");
    Expect(1, 72448, '\P{ In_Pau_Cin_Hau}', "");
    Expect(0, 72448, '\P{^ In_Pau_Cin_Hau}', "");
    Error('\p{_:=In_Phags_Pa}');
    Error('\P{_:=In_Phags_Pa}');
    Expect(1, 43135, '\p{inphagspa}', "");
    Expect(0, 43135, '\p{^inphagspa}', "");
    Expect(0, 43135, '\P{inphagspa}', "");
    Expect(1, 43135, '\P{^inphagspa}', "");
    Expect(0, 43136, '\p{inphagspa}', "");
    Expect(1, 43136, '\p{^inphagspa}', "");
    Expect(1, 43136, '\P{inphagspa}', "");
    Expect(0, 43136, '\P{^inphagspa}', "");
    Expect(1, 43135, '\p{ _In_phags_PA}', "");
    Expect(0, 43135, '\p{^ _In_phags_PA}', "");
    Expect(0, 43135, '\P{ _In_phags_PA}', "");
    Expect(1, 43135, '\P{^ _In_phags_PA}', "");
    Expect(0, 43136, '\p{ _In_phags_PA}', "");
    Expect(1, 43136, '\p{^ _In_phags_PA}', "");
    Expect(1, 43136, '\P{ _In_phags_PA}', "");
    Expect(0, 43136, '\P{^ _In_phags_PA}', "");
    Error('\p{/a/-_In_PHAGS_PA}');
    Error('\P{/a/-_In_PHAGS_PA}');
    Expect(1, 43135, '\p{ 	IN_PHAGS_pa}', "");
    Expect(0, 43135, '\p{^ 	IN_PHAGS_pa}', "");
    Expect(0, 43135, '\P{ 	IN_PHAGS_pa}', "");
    Expect(1, 43135, '\P{^ 	IN_PHAGS_pa}', "");
    Expect(0, 43136, '\p{ 	IN_PHAGS_pa}', "");
    Expect(1, 43136, '\p{^ 	IN_PHAGS_pa}', "");
    Expect(1, 43136, '\P{ 	IN_PHAGS_pa}', "");
    Expect(0, 43136, '\P{^ 	IN_PHAGS_pa}', "");
    Error('\p{:=	_In_PHOENICIAN}');
    Error('\P{:=	_In_PHOENICIAN}');
    Expect(1, 67871, '\p{inphoenician}', "");
    Expect(0, 67871, '\p{^inphoenician}', "");
    Expect(0, 67871, '\P{inphoenician}', "");
    Expect(1, 67871, '\P{^inphoenician}', "");
    Expect(0, 67872, '\p{inphoenician}', "");
    Expect(1, 67872, '\p{^inphoenician}', "");
    Expect(1, 67872, '\P{inphoenician}', "");
    Expect(0, 67872, '\P{^inphoenician}', "");
    Expect(1, 67871, '\p{-in_phoenician}', "");
    Expect(0, 67871, '\p{^-in_phoenician}', "");
    Expect(0, 67871, '\P{-in_phoenician}', "");
    Expect(1, 67871, '\P{^-in_phoenician}', "");
    Expect(0, 67872, '\p{-in_phoenician}', "");
    Expect(1, 67872, '\p{^-in_phoenician}', "");
    Expect(1, 67872, '\P{-in_phoenician}', "");
    Expect(0, 67872, '\P{^-in_phoenician}', "");
    Error('\p{:=	-IN_Phoenician}');
    Error('\P{:=	-IN_Phoenician}');
    Expect(1, 67871, '\p{	_In_Phoenician}', "");
    Expect(0, 67871, '\p{^	_In_Phoenician}', "");
    Expect(0, 67871, '\P{	_In_Phoenician}', "");
    Expect(1, 67871, '\P{^	_In_Phoenician}', "");
    Expect(0, 67872, '\p{	_In_Phoenician}', "");
    Expect(1, 67872, '\p{^	_In_Phoenician}', "");
    Expect(1, 67872, '\P{	_In_Phoenician}', "");
    Expect(0, 67872, '\P{^	_In_Phoenician}', "");
    Error('\p{:=_	In_PSALTER_Pahlavi}');
    Error('\P{:=_	In_PSALTER_Pahlavi}');
    Expect(1, 68527, '\p{inpsalterpahlavi}', "");
    Expect(0, 68527, '\p{^inpsalterpahlavi}', "");
    Expect(0, 68527, '\P{inpsalterpahlavi}', "");
    Expect(1, 68527, '\P{^inpsalterpahlavi}', "");
    Expect(0, 68528, '\p{inpsalterpahlavi}', "");
    Expect(1, 68528, '\p{^inpsalterpahlavi}', "");
    Expect(1, 68528, '\P{inpsalterpahlavi}', "");
    Expect(0, 68528, '\P{^inpsalterpahlavi}', "");
    Expect(1, 68527, '\p{ in_Psalter_Pahlavi}', "");
    Expect(0, 68527, '\p{^ in_Psalter_Pahlavi}', "");
    Expect(0, 68527, '\P{ in_Psalter_Pahlavi}', "");
    Expect(1, 68527, '\P{^ in_Psalter_Pahlavi}', "");
    Expect(0, 68528, '\p{ in_Psalter_Pahlavi}', "");
    Expect(1, 68528, '\p{^ in_Psalter_Pahlavi}', "");
    Expect(1, 68528, '\P{ in_Psalter_Pahlavi}', "");
    Expect(0, 68528, '\P{^ in_Psalter_Pahlavi}', "");
    Error('\p{:=_	In_PSALTER_Pahlavi}');
    Error('\P{:=_	In_PSALTER_Pahlavi}');
    Expect(1, 68527, '\p{__In_Psalter_PAHLAVI}', "");
    Expect(0, 68527, '\p{^__In_Psalter_PAHLAVI}', "");
    Expect(0, 68527, '\P{__In_Psalter_PAHLAVI}', "");
    Expect(1, 68527, '\P{^__In_Psalter_PAHLAVI}', "");
    Expect(0, 68528, '\p{__In_Psalter_PAHLAVI}', "");
    Expect(1, 68528, '\p{^__In_Psalter_PAHLAVI}', "");
    Expect(1, 68528, '\P{__In_Psalter_PAHLAVI}', "");
    Expect(0, 68528, '\P{^__In_Psalter_PAHLAVI}', "");
    Error('\p{_ IN_REJANG:=}');
    Error('\P{_ IN_REJANG:=}');
    Expect(1, 43359, '\p{inrejang}', "");
    Expect(0, 43359, '\p{^inrejang}', "");
    Expect(0, 43359, '\P{inrejang}', "");
    Expect(1, 43359, '\P{^inrejang}', "");
    Expect(0, 43360, '\p{inrejang}', "");
    Expect(1, 43360, '\p{^inrejang}', "");
    Expect(1, 43360, '\P{inrejang}', "");
    Expect(0, 43360, '\P{^inrejang}', "");
    Expect(1, 43359, '\p{-_in_rejang}', "");
    Expect(0, 43359, '\p{^-_in_rejang}', "");
    Expect(0, 43359, '\P{-_in_rejang}', "");
    Expect(1, 43359, '\P{^-_in_rejang}', "");
    Expect(0, 43360, '\p{-_in_rejang}', "");
    Expect(1, 43360, '\p{^-_in_rejang}', "");
    Expect(1, 43360, '\P{-_in_rejang}', "");
    Expect(0, 43360, '\P{^-_in_rejang}', "");
    Error('\p{In_Rejang:=}');
    Error('\P{In_Rejang:=}');
    Expect(1, 43359, '\p{ In_Rejang}', "");
    Expect(0, 43359, '\p{^ In_Rejang}', "");
    Expect(0, 43359, '\P{ In_Rejang}', "");
    Expect(1, 43359, '\P{^ In_Rejang}', "");
    Expect(0, 43360, '\p{ In_Rejang}', "");
    Expect(1, 43360, '\p{^ In_Rejang}', "");
    Expect(1, 43360, '\P{ In_Rejang}', "");
    Expect(0, 43360, '\P{^ In_Rejang}', "");
    Error('\p{_ In_Runic:=}');
    Error('\P{_ In_Runic:=}');
    Expect(1, 5887, '\p{inrunic}', "");
    Expect(0, 5887, '\p{^inrunic}', "");
    Expect(0, 5887, '\P{inrunic}', "");
    Expect(1, 5887, '\P{^inrunic}', "");
    Expect(0, 5888, '\p{inrunic}', "");
    Expect(1, 5888, '\p{^inrunic}', "");
    Expect(1, 5888, '\P{inrunic}', "");
    Expect(0, 5888, '\P{^inrunic}', "");
    Expect(1, 5887, '\p{-	In_runic}', "");
    Expect(0, 5887, '\p{^-	In_runic}', "");
    Expect(0, 5887, '\P{-	In_runic}', "");
    Expect(1, 5887, '\P{^-	In_runic}', "");
    Expect(0, 5888, '\p{-	In_runic}', "");
    Expect(1, 5888, '\p{^-	In_runic}', "");
    Expect(1, 5888, '\P{-	In_runic}', "");
    Expect(0, 5888, '\P{^-	In_runic}', "");
    Error('\p{-:=In_runic}');
    Error('\P{-:=In_runic}');
    Expect(1, 5887, '\p{	 In_RUNIC}', "");
    Expect(0, 5887, '\p{^	 In_RUNIC}', "");
    Expect(0, 5887, '\P{	 In_RUNIC}', "");
    Expect(1, 5887, '\P{^	 In_RUNIC}', "");
    Expect(0, 5888, '\p{	 In_RUNIC}', "");
    Expect(1, 5888, '\p{^	 In_RUNIC}', "");
    Expect(1, 5888, '\P{	 In_RUNIC}', "");
    Expect(0, 5888, '\P{^	 In_RUNIC}', "");
    Error('\p{	:=IN_SAMARITAN}');
    Error('\P{	:=IN_SAMARITAN}');
    Expect(1, 2111, '\p{insamaritan}', "");
    Expect(0, 2111, '\p{^insamaritan}', "");
    Expect(0, 2111, '\P{insamaritan}', "");
    Expect(1, 2111, '\P{^insamaritan}', "");
    Expect(0, 2112, '\p{insamaritan}', "");
    Expect(1, 2112, '\p{^insamaritan}', "");
    Expect(1, 2112, '\P{insamaritan}', "");
    Expect(0, 2112, '\P{^insamaritan}', "");
    Expect(1, 2111, '\p{ -IN_samaritan}', "");
    Expect(0, 2111, '\p{^ -IN_samaritan}', "");
    Expect(0, 2111, '\P{ -IN_samaritan}', "");
    Expect(1, 2111, '\P{^ -IN_samaritan}', "");
    Expect(0, 2112, '\p{ -IN_samaritan}', "");
    Expect(1, 2112, '\p{^ -IN_samaritan}', "");
    Expect(1, 2112, '\P{ -IN_samaritan}', "");
    Expect(0, 2112, '\P{^ -IN_samaritan}', "");
    Error('\p{__In_Samaritan/a/}');
    Error('\P{__In_Samaritan/a/}');
    Expect(1, 2111, '\p{__In_Samaritan}', "");
    Expect(0, 2111, '\p{^__In_Samaritan}', "");
    Expect(0, 2111, '\P{__In_Samaritan}', "");
    Expect(1, 2111, '\P{^__In_Samaritan}', "");
    Expect(0, 2112, '\p{__In_Samaritan}', "");
    Expect(1, 2112, '\p{^__In_Samaritan}', "");
    Expect(1, 2112, '\P{__In_Samaritan}', "");
    Expect(0, 2112, '\P{^__In_Samaritan}', "");
    Error('\p{_/a/in_Saurashtra}');
    Error('\P{_/a/in_Saurashtra}');
    Expect(1, 43231, '\p{insaurashtra}', "");
    Expect(0, 43231, '\p{^insaurashtra}', "");
    Expect(0, 43231, '\P{insaurashtra}', "");
    Expect(1, 43231, '\P{^insaurashtra}', "");
    Expect(0, 43232, '\p{insaurashtra}', "");
    Expect(1, 43232, '\p{^insaurashtra}', "");
    Expect(1, 43232, '\P{insaurashtra}', "");
    Expect(0, 43232, '\P{^insaurashtra}', "");
    Expect(1, 43231, '\p{ in_Saurashtra}', "");
    Expect(0, 43231, '\p{^ in_Saurashtra}', "");
    Expect(0, 43231, '\P{ in_Saurashtra}', "");
    Expect(1, 43231, '\P{^ in_Saurashtra}', "");
    Expect(0, 43232, '\p{ in_Saurashtra}', "");
    Expect(1, 43232, '\p{^ in_Saurashtra}', "");
    Expect(1, 43232, '\P{ in_Saurashtra}', "");
    Expect(0, 43232, '\P{^ in_Saurashtra}', "");
    Error('\p{/a/  In_Saurashtra}');
    Error('\P{/a/  In_Saurashtra}');
    Expect(1, 43231, '\p{_ in_saurashtra}', "");
    Expect(0, 43231, '\p{^_ in_saurashtra}', "");
    Expect(0, 43231, '\P{_ in_saurashtra}', "");
    Expect(1, 43231, '\P{^_ in_saurashtra}', "");
    Expect(0, 43232, '\p{_ in_saurashtra}', "");
    Expect(1, 43232, '\p{^_ in_saurashtra}', "");
    Expect(1, 43232, '\P{_ in_saurashtra}', "");
    Expect(0, 43232, '\P{^_ in_saurashtra}', "");
    Error('\p{:=in_Sharada}');
    Error('\P{:=in_Sharada}');
    Expect(1, 70111, '\p{insharada}', "");
    Expect(0, 70111, '\p{^insharada}', "");
    Expect(0, 70111, '\P{insharada}', "");
    Expect(1, 70111, '\P{^insharada}', "");
    Expect(0, 70112, '\p{insharada}', "");
    Expect(1, 70112, '\p{^insharada}', "");
    Expect(1, 70112, '\P{insharada}', "");
    Expect(0, 70112, '\P{^insharada}', "");
    Expect(1, 70111, '\p{_IN_Sharada}', "");
    Expect(0, 70111, '\p{^_IN_Sharada}', "");
    Expect(0, 70111, '\P{_IN_Sharada}', "");
    Expect(1, 70111, '\P{^_IN_Sharada}', "");
    Expect(0, 70112, '\p{_IN_Sharada}', "");
    Expect(1, 70112, '\p{^_IN_Sharada}', "");
    Expect(1, 70112, '\P{_IN_Sharada}', "");
    Expect(0, 70112, '\P{^_IN_Sharada}', "");
    Error('\p{	-In_Sharada:=}');
    Error('\P{	-In_Sharada:=}');
    Expect(1, 70111, '\p{-In_Sharada}', "");
    Expect(0, 70111, '\p{^-In_Sharada}', "");
    Expect(0, 70111, '\P{-In_Sharada}', "");
    Expect(1, 70111, '\P{^-In_Sharada}', "");
    Expect(0, 70112, '\p{-In_Sharada}', "");
    Expect(1, 70112, '\p{^-In_Sharada}', "");
    Expect(1, 70112, '\P{-In_Sharada}', "");
    Expect(0, 70112, '\P{^-In_Sharada}', "");
    Error('\p{--In_SHAVIAN:=}');
    Error('\P{--In_SHAVIAN:=}');
    Expect(1, 66687, '\p{inshavian}', "");
    Expect(0, 66687, '\p{^inshavian}', "");
    Expect(0, 66687, '\P{inshavian}', "");
    Expect(1, 66687, '\P{^inshavian}', "");
    Expect(0, 66688, '\p{inshavian}', "");
    Expect(1, 66688, '\p{^inshavian}', "");
    Expect(1, 66688, '\P{inshavian}', "");
    Expect(0, 66688, '\P{^inshavian}', "");
    Expect(1, 66687, '\p{ In_Shavian}', "");
    Expect(0, 66687, '\p{^ In_Shavian}', "");
    Expect(0, 66687, '\P{ In_Shavian}', "");
    Expect(1, 66687, '\P{^ In_Shavian}', "");
    Expect(0, 66688, '\p{ In_Shavian}', "");
    Expect(1, 66688, '\p{^ In_Shavian}', "");
    Expect(1, 66688, '\P{ In_Shavian}', "");
    Expect(0, 66688, '\P{^ In_Shavian}', "");
    Error('\p{:=	_in_Shavian}');
    Error('\P{:=	_in_Shavian}');
    Expect(1, 66687, '\p{	-IN_Shavian}', "");
    Expect(0, 66687, '\p{^	-IN_Shavian}', "");
    Expect(0, 66687, '\P{	-IN_Shavian}', "");
    Expect(1, 66687, '\P{^	-IN_Shavian}', "");
    Expect(0, 66688, '\p{	-IN_Shavian}', "");
    Expect(1, 66688, '\p{^	-IN_Shavian}', "");
    Expect(1, 66688, '\P{	-IN_Shavian}', "");
    Expect(0, 66688, '\P{^	-IN_Shavian}', "");
    Error('\p{	/a/in_siddham}');
    Error('\P{	/a/in_siddham}');
    Expect(1, 71167, '\p{insiddham}', "");
    Expect(0, 71167, '\p{^insiddham}', "");
    Expect(0, 71167, '\P{insiddham}', "");
    Expect(1, 71167, '\P{^insiddham}', "");
    Expect(0, 71168, '\p{insiddham}', "");
    Expect(1, 71168, '\p{^insiddham}', "");
    Expect(1, 71168, '\P{insiddham}', "");
    Expect(0, 71168, '\P{^insiddham}', "");
    Expect(1, 71167, '\p{_ In_Siddham}', "");
    Expect(0, 71167, '\p{^_ In_Siddham}', "");
    Expect(0, 71167, '\P{_ In_Siddham}', "");
    Expect(1, 71167, '\P{^_ In_Siddham}', "");
    Expect(0, 71168, '\p{_ In_Siddham}', "");
    Expect(1, 71168, '\p{^_ In_Siddham}', "");
    Expect(1, 71168, '\P{_ In_Siddham}', "");
    Expect(0, 71168, '\P{^_ In_Siddham}', "");
    Error('\p{:= _In_siddham}');
    Error('\P{:= _In_siddham}');
    Expect(1, 71167, '\p{- In_Siddham}', "");
    Expect(0, 71167, '\p{^- In_Siddham}', "");
    Expect(0, 71167, '\P{- In_Siddham}', "");
    Expect(1, 71167, '\P{^- In_Siddham}', "");
    Expect(0, 71168, '\p{- In_Siddham}', "");
    Expect(1, 71168, '\p{^- In_Siddham}', "");
    Expect(1, 71168, '\P{- In_Siddham}', "");
    Expect(0, 71168, '\P{^- In_Siddham}', "");
    Error('\p{ :=in_Sinhala}');
    Error('\P{ :=in_Sinhala}');
    Expect(1, 3583, '\p{insinhala}', "");
    Expect(0, 3583, '\p{^insinhala}', "");
    Expect(0, 3583, '\P{insinhala}', "");
    Expect(1, 3583, '\P{^insinhala}', "");
    Expect(0, 3584, '\p{insinhala}', "");
    Expect(1, 3584, '\p{^insinhala}', "");
    Expect(1, 3584, '\P{insinhala}', "");
    Expect(0, 3584, '\P{^insinhala}', "");
    Expect(1, 3583, '\p{_	In_sinhala}', "");
    Expect(0, 3583, '\p{^_	In_sinhala}', "");
    Expect(0, 3583, '\P{_	In_sinhala}', "");
    Expect(1, 3583, '\P{^_	In_sinhala}', "");
    Expect(0, 3584, '\p{_	In_sinhala}', "");
    Expect(1, 3584, '\p{^_	In_sinhala}', "");
    Expect(1, 3584, '\P{_	In_sinhala}', "");
    Expect(0, 3584, '\P{^_	In_sinhala}', "");
    Error('\p{:=		IN_SINHALA}');
    Error('\P{:=		IN_SINHALA}');
    Expect(1, 3583, '\p{_	In_Sinhala}', "");
    Expect(0, 3583, '\p{^_	In_Sinhala}', "");
    Expect(0, 3583, '\P{_	In_Sinhala}', "");
    Expect(1, 3583, '\P{^_	In_Sinhala}', "");
    Expect(0, 3584, '\p{_	In_Sinhala}', "");
    Expect(1, 3584, '\p{^_	In_Sinhala}', "");
    Expect(1, 3584, '\P{_	In_Sinhala}', "");
    Expect(0, 3584, '\P{^_	In_Sinhala}', "");
    Error('\p{:= -In_sogdian}');
    Error('\P{:= -In_sogdian}');
    Expect(1, 69487, '\p{insogdian}', "");
    Expect(0, 69487, '\p{^insogdian}', "");
    Expect(0, 69487, '\P{insogdian}', "");
    Expect(1, 69487, '\P{^insogdian}', "");
    Expect(0, 69488, '\p{insogdian}', "");
    Expect(1, 69488, '\p{^insogdian}', "");
    Expect(1, 69488, '\P{insogdian}', "");
    Expect(0, 69488, '\P{^insogdian}', "");
    Expect(1, 69487, '\p{__IN_SOGDIAN}', "");
    Expect(0, 69487, '\p{^__IN_SOGDIAN}', "");
    Expect(0, 69487, '\P{__IN_SOGDIAN}', "");
    Expect(1, 69487, '\P{^__IN_SOGDIAN}', "");
    Expect(0, 69488, '\p{__IN_SOGDIAN}', "");
    Expect(1, 69488, '\p{^__IN_SOGDIAN}', "");
    Expect(1, 69488, '\P{__IN_SOGDIAN}', "");
    Expect(0, 69488, '\P{^__IN_SOGDIAN}', "");
    Error('\p{/a/-_in_SOGDIAN}');
    Error('\P{/a/-_in_SOGDIAN}');
    Expect(1, 69487, '\p{- In_sogdian}', "");
    Expect(0, 69487, '\p{^- In_sogdian}', "");
    Expect(0, 69487, '\P{- In_sogdian}', "");
    Expect(1, 69487, '\P{^- In_sogdian}', "");
    Expect(0, 69488, '\p{- In_sogdian}', "");
    Expect(1, 69488, '\p{^- In_sogdian}', "");
    Expect(1, 69488, '\P{- In_sogdian}', "");
    Expect(0, 69488, '\P{^- In_sogdian}', "");
    Error('\p{  IN_SORA_sompeng:=}');
    Error('\P{  IN_SORA_sompeng:=}');
    Expect(1, 69887, '\p{insorasompeng}', "");
    Expect(0, 69887, '\p{^insorasompeng}', "");
    Expect(0, 69887, '\P{insorasompeng}', "");
    Expect(1, 69887, '\P{^insorasompeng}', "");
    Expect(0, 69888, '\p{insorasompeng}', "");
    Expect(1, 69888, '\p{^insorasompeng}', "");
    Expect(1, 69888, '\P{insorasompeng}', "");
    Expect(0, 69888, '\P{^insorasompeng}', "");
    Expect(1, 69887, '\p{	In_Sora_SOMPENG}', "");
    Expect(0, 69887, '\p{^	In_Sora_SOMPENG}', "");
    Expect(0, 69887, '\P{	In_Sora_SOMPENG}', "");
    Expect(1, 69887, '\P{^	In_Sora_SOMPENG}', "");
    Expect(0, 69888, '\p{	In_Sora_SOMPENG}', "");
    Expect(1, 69888, '\p{^	In_Sora_SOMPENG}', "");
    Expect(1, 69888, '\P{	In_Sora_SOMPENG}', "");
    Expect(0, 69888, '\P{^	In_Sora_SOMPENG}', "");
    Error('\p{:=	In_sora_SOMPENG}');
    Error('\P{:=	In_sora_SOMPENG}');
    Expect(1, 69887, '\p{-_IN_Sora_sompeng}', "");
    Expect(0, 69887, '\p{^-_IN_Sora_sompeng}', "");
    Expect(0, 69887, '\P{-_IN_Sora_sompeng}', "");
    Expect(1, 69887, '\P{^-_IN_Sora_sompeng}', "");
    Expect(0, 69888, '\p{-_IN_Sora_sompeng}', "");
    Expect(1, 69888, '\p{^-_IN_Sora_sompeng}', "");
    Expect(1, 69888, '\P{-_IN_Sora_sompeng}', "");
    Expect(0, 69888, '\P{^-_IN_Sora_sompeng}', "");
    Error('\p{	_in_Soyombo:=}');
    Error('\P{	_in_Soyombo:=}');
    Expect(1, 72367, '\p{insoyombo}', "");
    Expect(0, 72367, '\p{^insoyombo}', "");
    Expect(0, 72367, '\P{insoyombo}', "");
    Expect(1, 72367, '\P{^insoyombo}', "");
    Expect(0, 72368, '\p{insoyombo}', "");
    Expect(1, 72368, '\p{^insoyombo}', "");
    Expect(1, 72368, '\P{insoyombo}', "");
    Expect(0, 72368, '\P{^insoyombo}', "");
    Expect(1, 72367, '\p{  In_Soyombo}', "");
    Expect(0, 72367, '\p{^  In_Soyombo}', "");
    Expect(0, 72367, '\P{  In_Soyombo}', "");
    Expect(1, 72367, '\P{^  In_Soyombo}', "");
    Expect(0, 72368, '\p{  In_Soyombo}', "");
    Expect(1, 72368, '\p{^  In_Soyombo}', "");
    Expect(1, 72368, '\P{  In_Soyombo}', "");
    Expect(0, 72368, '\P{^  In_Soyombo}', "");
    Error('\p{:=	In_SOYOMBO}');
    Error('\P{:=	In_SOYOMBO}');
    Expect(1, 72367, '\p{-_in_SOYOMBO}', "");
    Expect(0, 72367, '\p{^-_in_SOYOMBO}', "");
    Expect(0, 72367, '\P{-_in_SOYOMBO}', "");
    Expect(1, 72367, '\P{^-_in_SOYOMBO}', "");
    Expect(0, 72368, '\p{-_in_SOYOMBO}', "");
    Expect(1, 72368, '\p{^-_in_SOYOMBO}', "");
    Expect(1, 72368, '\P{-_in_SOYOMBO}', "");
    Expect(0, 72368, '\P{^-_in_SOYOMBO}', "");
    Error('\p{	In_Sundanese/a/}');
    Error('\P{	In_Sundanese/a/}');
    Expect(1, 7103, '\p{insundanese}', "");
    Expect(0, 7103, '\p{^insundanese}', "");
    Expect(0, 7103, '\P{insundanese}', "");
    Expect(1, 7103, '\P{^insundanese}', "");
    Expect(0, 7104, '\p{insundanese}', "");
    Expect(1, 7104, '\p{^insundanese}', "");
    Expect(1, 7104, '\P{insundanese}', "");
    Expect(0, 7104, '\P{^insundanese}', "");
    Expect(1, 7103, '\p{	in_Sundanese}', "");
    Expect(0, 7103, '\p{^	in_Sundanese}', "");
    Expect(0, 7103, '\P{	in_Sundanese}', "");
    Expect(1, 7103, '\P{^	in_Sundanese}', "");
    Expect(0, 7104, '\p{	in_Sundanese}', "");
    Expect(1, 7104, '\p{^	in_Sundanese}', "");
    Expect(1, 7104, '\P{	in_Sundanese}', "");
    Expect(0, 7104, '\P{^	in_Sundanese}', "");
    Error('\p{ /a/IN_SUNDANESE}');
    Error('\P{ /a/IN_SUNDANESE}');
    Expect(1, 7103, '\p{_ IN_Sundanese}', "");
    Expect(0, 7103, '\p{^_ IN_Sundanese}', "");
    Expect(0, 7103, '\P{_ IN_Sundanese}', "");
    Expect(1, 7103, '\P{^_ IN_Sundanese}', "");
    Expect(0, 7104, '\p{_ IN_Sundanese}', "");
    Expect(1, 7104, '\p{^_ IN_Sundanese}', "");
    Expect(1, 7104, '\P{_ IN_Sundanese}', "");
    Expect(0, 7104, '\P{^_ IN_Sundanese}', "");
    Error('\p{-In_Syloti_Nagri:=}');
    Error('\P{-In_Syloti_Nagri:=}');
    Expect(1, 43055, '\p{insylotinagri}', "");
    Expect(0, 43055, '\p{^insylotinagri}', "");
    Expect(0, 43055, '\P{insylotinagri}', "");
    Expect(1, 43055, '\P{^insylotinagri}', "");
    Expect(0, 43056, '\p{insylotinagri}', "");
    Expect(1, 43056, '\p{^insylotinagri}', "");
    Expect(1, 43056, '\P{insylotinagri}', "");
    Expect(0, 43056, '\P{^insylotinagri}', "");
    Expect(1, 43055, '\p{-	In_syloti_NAGRI}', "");
    Expect(0, 43055, '\p{^-	In_syloti_NAGRI}', "");
    Expect(0, 43055, '\P{-	In_syloti_NAGRI}', "");
    Expect(1, 43055, '\P{^-	In_syloti_NAGRI}', "");
    Expect(0, 43056, '\p{-	In_syloti_NAGRI}', "");
    Expect(1, 43056, '\p{^-	In_syloti_NAGRI}', "");
    Expect(1, 43056, '\P{-	In_syloti_NAGRI}', "");
    Expect(0, 43056, '\P{^-	In_syloti_NAGRI}', "");
    Error('\p{/a/_in_syloti_NAGRI}');
    Error('\P{/a/_in_syloti_NAGRI}');
    Expect(1, 43055, '\p{ 	In_Syloti_Nagri}', "");
    Expect(0, 43055, '\p{^ 	In_Syloti_Nagri}', "");
    Expect(0, 43055, '\P{ 	In_Syloti_Nagri}', "");
    Expect(1, 43055, '\P{^ 	In_Syloti_Nagri}', "");
    Expect(0, 43056, '\p{ 	In_Syloti_Nagri}', "");
    Expect(1, 43056, '\p{^ 	In_Syloti_Nagri}', "");
    Expect(1, 43056, '\P{ 	In_Syloti_Nagri}', "");
    Expect(0, 43056, '\P{^ 	In_Syloti_Nagri}', "");
    Error('\p{ In_Syriac:=}');
    Error('\P{ In_Syriac:=}');
    Expect(1, 1871, '\p{insyriac}', "");
    Expect(0, 1871, '\p{^insyriac}', "");
    Expect(0, 1871, '\P{insyriac}', "");
    Expect(1, 1871, '\P{^insyriac}', "");
    Expect(0, 1872, '\p{insyriac}', "");
    Expect(1, 1872, '\p{^insyriac}', "");
    Expect(1, 1872, '\P{insyriac}', "");
    Expect(0, 1872, '\P{^insyriac}', "");
    Expect(1, 1871, '\p{__In_SYRIAC}', "");
    Expect(0, 1871, '\p{^__In_SYRIAC}', "");
    Expect(0, 1871, '\P{__In_SYRIAC}', "");
    Expect(1, 1871, '\P{^__In_SYRIAC}', "");
    Expect(0, 1872, '\p{__In_SYRIAC}', "");
    Expect(1, 1872, '\p{^__In_SYRIAC}', "");
    Expect(1, 1872, '\P{__In_SYRIAC}', "");
    Expect(0, 1872, '\P{^__In_SYRIAC}', "");
    Error('\p{:=	_IN_Syriac}');
    Error('\P{:=	_IN_Syriac}');
    Expect(1, 1871, '\p{-In_syriac}', "");
    Expect(0, 1871, '\p{^-In_syriac}', "");
    Expect(0, 1871, '\P{-In_syriac}', "");
    Expect(1, 1871, '\P{^-In_syriac}', "");
    Expect(0, 1872, '\p{-In_syriac}', "");
    Expect(1, 1872, '\p{^-In_syriac}', "");
    Expect(1, 1872, '\P{-In_syriac}', "");
    Expect(0, 1872, '\P{^-In_syriac}', "");
    Error('\p{-/a/IN_Tagalog}');
    Error('\P{-/a/IN_Tagalog}');
    Expect(1, 5919, '\p{intagalog}', "");
    Expect(0, 5919, '\p{^intagalog}', "");
    Expect(0, 5919, '\P{intagalog}', "");
    Expect(1, 5919, '\P{^intagalog}', "");
    Expect(0, 5920, '\p{intagalog}', "");
    Expect(1, 5920, '\p{^intagalog}', "");
    Expect(1, 5920, '\P{intagalog}', "");
    Expect(0, 5920, '\P{^intagalog}', "");
    Expect(1, 5919, '\p{__in_Tagalog}', "");
    Expect(0, 5919, '\p{^__in_Tagalog}', "");
    Expect(0, 5919, '\P{__in_Tagalog}', "");
    Expect(1, 5919, '\P{^__in_Tagalog}', "");
    Expect(0, 5920, '\p{__in_Tagalog}', "");
    Expect(1, 5920, '\p{^__in_Tagalog}', "");
    Expect(1, 5920, '\P{__in_Tagalog}', "");
    Expect(0, 5920, '\P{^__in_Tagalog}', "");
    Error('\p{/a/	IN_Tagalog}');
    Error('\P{/a/	IN_Tagalog}');
    Expect(1, 5919, '\p{_-IN_tagalog}', "");
    Expect(0, 5919, '\p{^_-IN_tagalog}', "");
    Expect(0, 5919, '\P{_-IN_tagalog}', "");
    Expect(1, 5919, '\P{^_-IN_tagalog}', "");
    Expect(0, 5920, '\p{_-IN_tagalog}', "");
    Expect(1, 5920, '\p{^_-IN_tagalog}', "");
    Expect(1, 5920, '\P{_-IN_tagalog}', "");
    Expect(0, 5920, '\P{^_-IN_tagalog}', "");
    Error('\p{	:=In_Tagbanwa}');
    Error('\P{	:=In_Tagbanwa}');
    Expect(1, 6015, '\p{intagbanwa}', "");
    Expect(0, 6015, '\p{^intagbanwa}', "");
    Expect(0, 6015, '\P{intagbanwa}', "");
    Expect(1, 6015, '\P{^intagbanwa}', "");
    Expect(0, 6016, '\p{intagbanwa}', "");
    Expect(1, 6016, '\p{^intagbanwa}', "");
    Expect(1, 6016, '\P{intagbanwa}', "");
    Expect(0, 6016, '\P{^intagbanwa}', "");
    Expect(1, 6015, '\p{		IN_Tagbanwa}', "");
    Expect(0, 6015, '\p{^		IN_Tagbanwa}', "");
    Expect(0, 6015, '\P{		IN_Tagbanwa}', "");
    Expect(1, 6015, '\P{^		IN_Tagbanwa}', "");
    Expect(0, 6016, '\p{		IN_Tagbanwa}', "");
    Expect(1, 6016, '\p{^		IN_Tagbanwa}', "");
    Expect(1, 6016, '\P{		IN_Tagbanwa}', "");
    Expect(0, 6016, '\P{^		IN_Tagbanwa}', "");
    Error('\p{ :=In_Tagbanwa}');
    Error('\P{ :=In_Tagbanwa}');
    Expect(1, 6015, '\p{-In_TAGBANWA}', "");
    Expect(0, 6015, '\p{^-In_TAGBANWA}', "");
    Expect(0, 6015, '\P{-In_TAGBANWA}', "");
    Expect(1, 6015, '\P{^-In_TAGBANWA}', "");
    Expect(0, 6016, '\p{-In_TAGBANWA}', "");
    Expect(1, 6016, '\p{^-In_TAGBANWA}', "");
    Expect(1, 6016, '\P{-In_TAGBANWA}', "");
    Expect(0, 6016, '\P{^-In_TAGBANWA}', "");
    Error('\p{:=_-IN_TAI_Le}');
    Error('\P{:=_-IN_TAI_Le}');
    Expect(1, 6527, '\p{intaile}', "");
    Expect(0, 6527, '\p{^intaile}', "");
    Expect(0, 6527, '\P{intaile}', "");
    Expect(1, 6527, '\P{^intaile}', "");
    Expect(0, 6528, '\p{intaile}', "");
    Expect(1, 6528, '\p{^intaile}', "");
    Expect(1, 6528, '\P{intaile}', "");
    Expect(0, 6528, '\P{^intaile}', "");
    Expect(1, 6527, '\p{--in_TAI_LE}', "");
    Expect(0, 6527, '\p{^--in_TAI_LE}', "");
    Expect(0, 6527, '\P{--in_TAI_LE}', "");
    Expect(1, 6527, '\P{^--in_TAI_LE}', "");
    Expect(0, 6528, '\p{--in_TAI_LE}', "");
    Expect(1, 6528, '\p{^--in_TAI_LE}', "");
    Expect(1, 6528, '\P{--in_TAI_LE}', "");
    Expect(0, 6528, '\P{^--in_TAI_LE}', "");
    Error('\p{  In_Tai_Le/a/}');
    Error('\P{  In_Tai_Le/a/}');
    Expect(1, 6527, '\p{_ IN_Tai_Le}', "");
    Expect(0, 6527, '\p{^_ IN_Tai_Le}', "");
    Expect(0, 6527, '\P{_ IN_Tai_Le}', "");
    Expect(1, 6527, '\P{^_ IN_Tai_Le}', "");
    Expect(0, 6528, '\p{_ IN_Tai_Le}', "");
    Expect(1, 6528, '\p{^_ IN_Tai_Le}', "");
    Expect(1, 6528, '\P{_ IN_Tai_Le}', "");
    Expect(0, 6528, '\P{^_ IN_Tai_Le}', "");
    Error('\p{_:=In_tai_Tham}');
    Error('\P{_:=In_tai_Tham}');
    Expect(1, 6831, '\p{intaitham}', "");
    Expect(0, 6831, '\p{^intaitham}', "");
    Expect(0, 6831, '\P{intaitham}', "");
    Expect(1, 6831, '\P{^intaitham}', "");
    Expect(0, 6832, '\p{intaitham}', "");
    Expect(1, 6832, '\p{^intaitham}', "");
    Expect(1, 6832, '\P{intaitham}', "");
    Expect(0, 6832, '\P{^intaitham}', "");
    Expect(1, 6831, '\p{ IN_Tai_Tham}', "");
    Expect(0, 6831, '\p{^ IN_Tai_Tham}', "");
    Expect(0, 6831, '\P{ IN_Tai_Tham}', "");
    Expect(1, 6831, '\P{^ IN_Tai_Tham}', "");
    Expect(0, 6832, '\p{ IN_Tai_Tham}', "");
    Expect(1, 6832, '\p{^ IN_Tai_Tham}', "");
    Expect(1, 6832, '\P{ IN_Tai_Tham}', "");
    Expect(0, 6832, '\P{^ IN_Tai_Tham}', "");
    Error('\p{_:=In_Tai_THAM}');
    Error('\P{_:=In_Tai_THAM}');
    Expect(1, 6831, '\p{_-IN_TAI_Tham}', "");
    Expect(0, 6831, '\p{^_-IN_TAI_Tham}', "");
    Expect(0, 6831, '\P{_-IN_TAI_Tham}', "");
    Expect(1, 6831, '\P{^_-IN_TAI_Tham}', "");
    Expect(0, 6832, '\p{_-IN_TAI_Tham}', "");
    Expect(1, 6832, '\p{^_-IN_TAI_Tham}', "");
    Expect(1, 6832, '\P{_-IN_TAI_Tham}', "");
    Expect(0, 6832, '\P{^_-IN_TAI_Tham}', "");
    Error('\p{	 IN_tai_Viet/a/}');
    Error('\P{	 IN_tai_Viet/a/}');
    Expect(1, 43743, '\p{intaiviet}', "");
    Expect(0, 43743, '\p{^intaiviet}', "");
    Expect(0, 43743, '\P{intaiviet}', "");
    Expect(1, 43743, '\P{^intaiviet}', "");
    Expect(0, 43744, '\p{intaiviet}', "");
    Expect(1, 43744, '\p{^intaiviet}', "");
    Expect(1, 43744, '\P{intaiviet}', "");
    Expect(0, 43744, '\P{^intaiviet}', "");
    Expect(1, 43743, '\p{_-in_TAI_Viet}', "");
    Expect(0, 43743, '\p{^_-in_TAI_Viet}', "");
    Expect(0, 43743, '\P{_-in_TAI_Viet}', "");
    Expect(1, 43743, '\P{^_-in_TAI_Viet}', "");
    Expect(0, 43744, '\p{_-in_TAI_Viet}', "");
    Expect(1, 43744, '\p{^_-in_TAI_Viet}', "");
    Expect(1, 43744, '\P{_-in_TAI_Viet}', "");
    Expect(0, 43744, '\P{^_-in_TAI_Viet}', "");
    Error('\p{-_in_tai_viet:=}');
    Error('\P{-_in_tai_viet:=}');
    Expect(1, 43743, '\p{_In_Tai_VIET}', "");
    Expect(0, 43743, '\p{^_In_Tai_VIET}', "");
    Expect(0, 43743, '\P{_In_Tai_VIET}', "");
    Expect(1, 43743, '\P{^_In_Tai_VIET}', "");
    Expect(0, 43744, '\p{_In_Tai_VIET}', "");
    Expect(1, 43744, '\p{^_In_Tai_VIET}', "");
    Expect(1, 43744, '\P{_In_Tai_VIET}', "");
    Expect(0, 43744, '\P{^_In_Tai_VIET}', "");
    Error('\p{:= 	IN_Takri}');
    Error('\P{:= 	IN_Takri}');
    Expect(1, 71375, '\p{intakri}', "");
    Expect(0, 71375, '\p{^intakri}', "");
    Expect(0, 71375, '\P{intakri}', "");
    Expect(1, 71375, '\P{^intakri}', "");
    Expect(0, 71376, '\p{intakri}', "");
    Expect(1, 71376, '\p{^intakri}', "");
    Expect(1, 71376, '\P{intakri}', "");
    Expect(0, 71376, '\P{^intakri}', "");
    Expect(1, 71375, '\p{-In_Takri}', "");
    Expect(0, 71375, '\p{^-In_Takri}', "");
    Expect(0, 71375, '\P{-In_Takri}', "");
    Expect(1, 71375, '\P{^-In_Takri}', "");
    Expect(0, 71376, '\p{-In_Takri}', "");
    Expect(1, 71376, '\p{^-In_Takri}', "");
    Expect(1, 71376, '\P{-In_Takri}', "");
    Expect(0, 71376, '\P{^-In_Takri}', "");
    Error('\p{/a/ _IN_Takri}');
    Error('\P{/a/ _IN_Takri}');
    Expect(1, 71375, '\p{ 	In_Takri}', "");
    Expect(0, 71375, '\p{^ 	In_Takri}', "");
    Expect(0, 71375, '\P{ 	In_Takri}', "");
    Expect(1, 71375, '\P{^ 	In_Takri}', "");
    Expect(0, 71376, '\p{ 	In_Takri}', "");
    Expect(1, 71376, '\p{^ 	In_Takri}', "");
    Expect(1, 71376, '\P{ 	In_Takri}', "");
    Expect(0, 71376, '\P{^ 	In_Takri}', "");
    Error('\p{ :=IN_TAMIL}');
    Error('\P{ :=IN_TAMIL}');
    Expect(1, 3071, '\p{intamil}', "");
    Expect(0, 3071, '\p{^intamil}', "");
    Expect(0, 3071, '\P{intamil}', "");
    Expect(1, 3071, '\P{^intamil}', "");
    Expect(0, 3072, '\p{intamil}', "");
    Expect(1, 3072, '\p{^intamil}', "");
    Expect(1, 3072, '\P{intamil}', "");
    Expect(0, 3072, '\P{^intamil}', "");
    Expect(1, 3071, '\p{_-IN_tamil}', "");
    Expect(0, 3071, '\p{^_-IN_tamil}', "");
    Expect(0, 3071, '\P{_-IN_tamil}', "");
    Expect(1, 3071, '\P{^_-IN_tamil}', "");
    Expect(0, 3072, '\p{_-IN_tamil}', "");
    Expect(1, 3072, '\p{^_-IN_tamil}', "");
    Expect(1, 3072, '\P{_-IN_tamil}', "");
    Expect(0, 3072, '\P{^_-IN_tamil}', "");
    Error('\p{_	In_Tamil:=}');
    Error('\P{_	In_Tamil:=}');
    Expect(1, 3071, '\p{ -In_tamil}', "");
    Expect(0, 3071, '\p{^ -In_tamil}', "");
    Expect(0, 3071, '\P{ -In_tamil}', "");
    Expect(1, 3071, '\P{^ -In_tamil}', "");
    Expect(0, 3072, '\p{ -In_tamil}', "");
    Expect(1, 3072, '\p{^ -In_tamil}', "");
    Expect(1, 3072, '\P{ -In_tamil}', "");
    Expect(0, 3072, '\P{^ -In_tamil}', "");
    Error('\p{  In_tangut/a/}');
    Error('\P{  In_tangut/a/}');
    Expect(1, 100351, '\p{intangut}', "");
    Expect(0, 100351, '\p{^intangut}', "");
    Expect(0, 100351, '\P{intangut}', "");
    Expect(1, 100351, '\P{^intangut}', "");
    Expect(0, 100352, '\p{intangut}', "");
    Expect(1, 100352, '\p{^intangut}', "");
    Expect(1, 100352, '\P{intangut}', "");
    Expect(0, 100352, '\P{^intangut}', "");
    Expect(1, 100351, '\p{		in_tangut}', "");
    Expect(0, 100351, '\p{^		in_tangut}', "");
    Expect(0, 100351, '\P{		in_tangut}', "");
    Expect(1, 100351, '\P{^		in_tangut}', "");
    Expect(0, 100352, '\p{		in_tangut}', "");
    Expect(1, 100352, '\p{^		in_tangut}', "");
    Expect(1, 100352, '\P{		in_tangut}', "");
    Expect(0, 100352, '\P{^		in_tangut}', "");
    Error('\p{_:=IN_Tangut}');
    Error('\P{_:=IN_Tangut}');
    Expect(1, 100351, '\p{_	In_Tangut}', "");
    Expect(0, 100351, '\p{^_	In_Tangut}', "");
    Expect(0, 100351, '\P{_	In_Tangut}', "");
    Expect(1, 100351, '\P{^_	In_Tangut}', "");
    Expect(0, 100352, '\p{_	In_Tangut}', "");
    Expect(1, 100352, '\p{^_	In_Tangut}', "");
    Expect(1, 100352, '\P{_	In_Tangut}', "");
    Expect(0, 100352, '\P{^_	In_Tangut}', "");
    Error('\p{ IN_TELUGU/a/}');
    Error('\P{ IN_TELUGU/a/}');
    Expect(1, 3199, '\p{intelugu}', "");
    Expect(0, 3199, '\p{^intelugu}', "");
    Expect(0, 3199, '\P{intelugu}', "");
    Expect(1, 3199, '\P{^intelugu}', "");
    Expect(0, 3200, '\p{intelugu}', "");
    Expect(1, 3200, '\p{^intelugu}', "");
    Expect(1, 3200, '\P{intelugu}', "");
    Expect(0, 3200, '\P{^intelugu}', "");
    Expect(1, 3199, '\p{	In_TELUGU}', "");
    Expect(0, 3199, '\p{^	In_TELUGU}', "");
    Expect(0, 3199, '\P{	In_TELUGU}', "");
    Expect(1, 3199, '\P{^	In_TELUGU}', "");
    Expect(0, 3200, '\p{	In_TELUGU}', "");
    Expect(1, 3200, '\p{^	In_TELUGU}', "");
    Expect(1, 3200, '\P{	In_TELUGU}', "");
    Expect(0, 3200, '\P{^	In_TELUGU}', "");
    Error('\p{:= -IN_Telugu}');
    Error('\P{:= -IN_Telugu}');
    Expect(1, 3199, '\p{--in_TELUGU}', "");
    Expect(0, 3199, '\p{^--in_TELUGU}', "");
    Expect(0, 3199, '\P{--in_TELUGU}', "");
    Expect(1, 3199, '\P{^--in_TELUGU}', "");
    Expect(0, 3200, '\p{--in_TELUGU}', "");
    Expect(1, 3200, '\p{^--in_TELUGU}', "");
    Expect(1, 3200, '\P{--in_TELUGU}', "");
    Expect(0, 3200, '\P{^--in_TELUGU}', "");
    Error('\p{_	IN_Thaana:=}');
    Error('\P{_	IN_Thaana:=}');
    Expect(1, 1983, '\p{inthaana}', "");
    Expect(0, 1983, '\p{^inthaana}', "");
    Expect(0, 1983, '\P{inthaana}', "");
    Expect(1, 1983, '\P{^inthaana}', "");
    Expect(0, 1984, '\p{inthaana}', "");
    Expect(1, 1984, '\p{^inthaana}', "");
    Expect(1, 1984, '\P{inthaana}', "");
    Expect(0, 1984, '\P{^inthaana}', "");
    Expect(1, 1983, '\p{-in_thaana}', "");
    Expect(0, 1983, '\p{^-in_thaana}', "");
    Expect(0, 1983, '\P{-in_thaana}', "");
    Expect(1, 1983, '\P{^-in_thaana}', "");
    Expect(0, 1984, '\p{-in_thaana}', "");
    Expect(1, 1984, '\p{^-in_thaana}', "");
    Expect(1, 1984, '\P{-in_thaana}', "");
    Expect(0, 1984, '\P{^-in_thaana}', "");
    Error('\p{/a/ _In_Thaana}');
    Error('\P{/a/ _In_Thaana}');
    Expect(1, 1983, '\p{-	IN_thaana}', "");
    Expect(0, 1983, '\p{^-	IN_thaana}', "");
    Expect(0, 1983, '\P{-	IN_thaana}', "");
    Expect(1, 1983, '\P{^-	IN_thaana}', "");
    Expect(0, 1984, '\p{-	IN_thaana}', "");
    Expect(1, 1984, '\p{^-	IN_thaana}', "");
    Expect(1, 1984, '\P{-	IN_thaana}', "");
    Expect(0, 1984, '\P{^-	IN_thaana}', "");
    Error('\p{:=_In_thai}');
    Error('\P{:=_In_thai}');
    Expect(1, 3711, '\p{inthai}', "");
    Expect(0, 3711, '\p{^inthai}', "");
    Expect(0, 3711, '\P{inthai}', "");
    Expect(1, 3711, '\P{^inthai}', "");
    Expect(0, 3712, '\p{inthai}', "");
    Expect(1, 3712, '\p{^inthai}', "");
    Expect(1, 3712, '\P{inthai}', "");
    Expect(0, 3712, '\P{^inthai}', "");
    Expect(1, 3711, '\p{ In_Thai}', "");
    Expect(0, 3711, '\p{^ In_Thai}', "");
    Expect(0, 3711, '\P{ In_Thai}', "");
    Expect(1, 3711, '\P{^ In_Thai}', "");
    Expect(0, 3712, '\p{ In_Thai}', "");
    Expect(1, 3712, '\p{^ In_Thai}', "");
    Expect(1, 3712, '\P{ In_Thai}', "");
    Expect(0, 3712, '\P{^ In_Thai}', "");
    Error('\p{_:=In_THAI}');
    Error('\P{_:=In_THAI}');
    Expect(1, 3711, '\p{  in_thai}', "");
    Expect(0, 3711, '\p{^  in_thai}', "");
    Expect(0, 3711, '\P{  in_thai}', "");
    Expect(1, 3711, '\P{^  in_thai}', "");
    Expect(0, 3712, '\p{  in_thai}', "");
    Expect(1, 3712, '\p{^  in_thai}', "");
    Expect(1, 3712, '\P{  in_thai}', "");
    Expect(0, 3712, '\P{^  in_thai}', "");
    Error('\p{/a/ In_TIBETAN}');
    Error('\P{/a/ In_TIBETAN}');
    Expect(1, 4095, '\p{intibetan}', "");
    Expect(0, 4095, '\p{^intibetan}', "");
    Expect(0, 4095, '\P{intibetan}', "");
    Expect(1, 4095, '\P{^intibetan}', "");
    Expect(0, 4096, '\p{intibetan}', "");
    Expect(1, 4096, '\p{^intibetan}', "");
    Expect(1, 4096, '\P{intibetan}', "");
    Expect(0, 4096, '\P{^intibetan}', "");
    Expect(1, 4095, '\p{_	In_TIBETAN}', "");
    Expect(0, 4095, '\p{^_	In_TIBETAN}', "");
    Expect(0, 4095, '\P{_	In_TIBETAN}', "");
    Expect(1, 4095, '\P{^_	In_TIBETAN}', "");
    Expect(0, 4096, '\p{_	In_TIBETAN}', "");
    Expect(1, 4096, '\p{^_	In_TIBETAN}', "");
    Expect(1, 4096, '\P{_	In_TIBETAN}', "");
    Expect(0, 4096, '\P{^_	In_TIBETAN}', "");
    Error('\p{/a/-	In_Tibetan}');
    Error('\P{/a/-	In_Tibetan}');
    Expect(1, 4095, '\p{- IN_Tibetan}', "");
    Expect(0, 4095, '\p{^- IN_Tibetan}', "");
    Expect(0, 4095, '\P{- IN_Tibetan}', "");
    Expect(1, 4095, '\P{^- IN_Tibetan}', "");
    Expect(0, 4096, '\p{- IN_Tibetan}', "");
    Expect(1, 4096, '\p{^- IN_Tibetan}', "");
    Expect(1, 4096, '\P{- IN_Tibetan}', "");
    Expect(0, 4096, '\P{^- IN_Tibetan}', "");
    Error('\p{/a/in_tifinagh}');
    Error('\P{/a/in_tifinagh}');
    Expect(1, 11647, '\p{intifinagh}', "");
    Expect(0, 11647, '\p{^intifinagh}', "");
    Expect(0, 11647, '\P{intifinagh}', "");
    Expect(1, 11647, '\P{^intifinagh}', "");
    Expect(0, 11648, '\p{intifinagh}', "");
    Expect(1, 11648, '\p{^intifinagh}', "");
    Expect(1, 11648, '\P{intifinagh}', "");
    Expect(0, 11648, '\P{^intifinagh}', "");
    Expect(1, 11647, '\p{-_in_Tifinagh}', "");
    Expect(0, 11647, '\p{^-_in_Tifinagh}', "");
    Expect(0, 11647, '\P{-_in_Tifinagh}', "");
    Expect(1, 11647, '\P{^-_in_Tifinagh}', "");
    Expect(0, 11648, '\p{-_in_Tifinagh}', "");
    Expect(1, 11648, '\p{^-_in_Tifinagh}', "");
    Expect(1, 11648, '\P{-_in_Tifinagh}', "");
    Expect(0, 11648, '\P{^-_in_Tifinagh}', "");
    Error('\p{:=_-in_tifinagh}');
    Error('\P{:=_-in_tifinagh}');
    Expect(1, 11647, '\p{	_in_Tifinagh}', "");
    Expect(0, 11647, '\p{^	_in_Tifinagh}', "");
    Expect(0, 11647, '\P{	_in_Tifinagh}', "");
    Expect(1, 11647, '\P{^	_in_Tifinagh}', "");
    Expect(0, 11648, '\p{	_in_Tifinagh}', "");
    Expect(1, 11648, '\p{^	_in_Tifinagh}', "");
    Expect(1, 11648, '\P{	_in_Tifinagh}', "");
    Expect(0, 11648, '\P{^	_in_Tifinagh}', "");
    Error('\p{_:=In_Tirhuta}');
    Error('\P{_:=In_Tirhuta}');
    Expect(1, 70879, '\p{intirhuta}', "");
    Expect(0, 70879, '\p{^intirhuta}', "");
    Expect(0, 70879, '\P{intirhuta}', "");
    Expect(1, 70879, '\P{^intirhuta}', "");
    Expect(0, 70880, '\p{intirhuta}', "");
    Expect(1, 70880, '\p{^intirhuta}', "");
    Expect(1, 70880, '\P{intirhuta}', "");
    Expect(0, 70880, '\P{^intirhuta}', "");
    Expect(1, 70879, '\p{	in_tirhuta}', "");
    Expect(0, 70879, '\p{^	in_tirhuta}', "");
    Expect(0, 70879, '\P{	in_tirhuta}', "");
    Expect(1, 70879, '\P{^	in_tirhuta}', "");
    Expect(0, 70880, '\p{	in_tirhuta}', "");
    Expect(1, 70880, '\p{^	in_tirhuta}', "");
    Expect(1, 70880, '\P{	in_tirhuta}', "");
    Expect(0, 70880, '\P{^	in_tirhuta}', "");
    Error('\p{:=	in_Tirhuta}');
    Error('\P{:=	in_Tirhuta}');
    Expect(1, 70879, '\p{_-In_Tirhuta}', "");
    Expect(0, 70879, '\p{^_-In_Tirhuta}', "");
    Expect(0, 70879, '\P{_-In_Tirhuta}', "");
    Expect(1, 70879, '\P{^_-In_Tirhuta}', "");
    Expect(0, 70880, '\p{_-In_Tirhuta}', "");
    Expect(1, 70880, '\p{^_-In_Tirhuta}', "");
    Expect(1, 70880, '\P{_-In_Tirhuta}', "");
    Expect(0, 70880, '\P{^_-In_Tirhuta}', "");
    Error('\p{:= _In_Ugaritic}');
    Error('\P{:= _In_Ugaritic}');
    Expect(1, 66463, '\p{inugaritic}', "");
    Expect(0, 66463, '\p{^inugaritic}', "");
    Expect(0, 66463, '\P{inugaritic}', "");
    Expect(1, 66463, '\P{^inugaritic}', "");
    Expect(0, 66464, '\p{inugaritic}', "");
    Expect(1, 66464, '\p{^inugaritic}', "");
    Expect(1, 66464, '\P{inugaritic}', "");
    Expect(0, 66464, '\P{^inugaritic}', "");
    Expect(1, 66463, '\p{in_UGARITIC}', "");
    Expect(0, 66463, '\p{^in_UGARITIC}', "");
    Expect(0, 66463, '\P{in_UGARITIC}', "");
    Expect(1, 66463, '\P{^in_UGARITIC}', "");
    Expect(0, 66464, '\p{in_UGARITIC}', "");
    Expect(1, 66464, '\p{^in_UGARITIC}', "");
    Expect(1, 66464, '\P{in_UGARITIC}', "");
    Expect(0, 66464, '\P{^in_UGARITIC}', "");
    Error('\p{	 In_Ugaritic/a/}');
    Error('\P{	 In_Ugaritic/a/}');
    Expect(1, 66463, '\p{-_In_Ugaritic}', "");
    Expect(0, 66463, '\p{^-_In_Ugaritic}', "");
    Expect(0, 66463, '\P{-_In_Ugaritic}', "");
    Expect(1, 66463, '\P{^-_In_Ugaritic}', "");
    Expect(0, 66464, '\p{-_In_Ugaritic}', "");
    Expect(1, 66464, '\p{^-_In_Ugaritic}', "");
    Expect(1, 66464, '\P{-_In_Ugaritic}', "");
    Expect(0, 66464, '\P{^-_In_Ugaritic}', "");
    Error('\p{_/a/in_Vai}');
    Error('\P{_/a/in_Vai}');
    Expect(1, 42559, '\p{invai}', "");
    Expect(0, 42559, '\p{^invai}', "");
    Expect(0, 42559, '\P{invai}', "");
    Expect(1, 42559, '\P{^invai}', "");
    Expect(0, 42560, '\p{invai}', "");
    Expect(1, 42560, '\p{^invai}', "");
    Expect(1, 42560, '\P{invai}', "");
    Expect(0, 42560, '\P{^invai}', "");
    Expect(1, 42559, '\p{	_in_Vai}', "");
    Expect(0, 42559, '\p{^	_in_Vai}', "");
    Expect(0, 42559, '\P{	_in_Vai}', "");
    Expect(1, 42559, '\P{^	_in_Vai}', "");
    Expect(0, 42560, '\p{	_in_Vai}', "");
    Expect(1, 42560, '\p{^	_in_Vai}', "");
    Expect(1, 42560, '\P{	_in_Vai}', "");
    Expect(0, 42560, '\P{^	_in_Vai}', "");
    Error('\p{/a/ -IN_VAI}');
    Error('\P{/a/ -IN_VAI}');
    Expect(1, 42559, '\p{-_In_Vai}', "");
    Expect(0, 42559, '\p{^-_In_Vai}', "");
    Expect(0, 42559, '\P{-_In_Vai}', "");
    Expect(1, 42559, '\P{^-_In_Vai}', "");
    Expect(0, 42560, '\p{-_In_Vai}', "");
    Expect(1, 42560, '\p{^-_In_Vai}', "");
    Expect(1, 42560, '\P{-_In_Vai}', "");
    Expect(0, 42560, '\P{^-_In_Vai}', "");
    Error('\p{-/a/IN_Wancho}');
    Error('\P{-/a/IN_Wancho}');
    Expect(1, 123647, '\p{inwancho}', "");
    Expect(0, 123647, '\p{^inwancho}', "");
    Expect(0, 123647, '\P{inwancho}', "");
    Expect(1, 123647, '\P{^inwancho}', "");
    Expect(0, 123648, '\p{inwancho}', "");
    Expect(1, 123648, '\p{^inwancho}', "");
    Expect(1, 123648, '\P{inwancho}', "");
    Expect(0, 123648, '\P{^inwancho}', "");
    Expect(1, 123647, '\p{	 In_WANCHO}', "");
    Expect(0, 123647, '\p{^	 In_WANCHO}', "");
    Expect(0, 123647, '\P{	 In_WANCHO}', "");
    Expect(1, 123647, '\P{^	 In_WANCHO}', "");
    Expect(0, 123648, '\p{	 In_WANCHO}', "");
    Expect(1, 123648, '\p{^	 In_WANCHO}', "");
    Expect(1, 123648, '\P{	 In_WANCHO}', "");
    Expect(0, 123648, '\P{^	 In_WANCHO}', "");
    Error('\p{ /a/in_Wancho}');
    Error('\P{ /a/in_Wancho}');
    Expect(1, 123647, '\p{ In_wancho}', "");
    Expect(0, 123647, '\p{^ In_wancho}', "");
    Expect(0, 123647, '\P{ In_wancho}', "");
    Expect(1, 123647, '\P{^ In_wancho}', "");
    Expect(0, 123648, '\p{ In_wancho}', "");
    Expect(1, 123648, '\p{^ In_wancho}', "");
    Expect(1, 123648, '\P{ In_wancho}', "");
    Expect(0, 123648, '\P{^ In_wancho}', "");
    Error('\p{:=_-In_WARANG_Citi}');
    Error('\P{:=_-In_WARANG_Citi}');
    Expect(1, 71935, '\p{inwarangciti}', "");
    Expect(0, 71935, '\p{^inwarangciti}', "");
    Expect(0, 71935, '\P{inwarangciti}', "");
    Expect(1, 71935, '\P{^inwarangciti}', "");
    Expect(0, 71936, '\p{inwarangciti}', "");
    Expect(1, 71936, '\p{^inwarangciti}', "");
    Expect(1, 71936, '\P{inwarangciti}', "");
    Expect(0, 71936, '\P{^inwarangciti}', "");
    Expect(1, 71935, '\p{		IN_Warang_citi}', "");
    Expect(0, 71935, '\p{^		IN_Warang_citi}', "");
    Expect(0, 71935, '\P{		IN_Warang_citi}', "");
    Expect(1, 71935, '\P{^		IN_Warang_citi}', "");
    Expect(0, 71936, '\p{		IN_Warang_citi}', "");
    Expect(1, 71936, '\p{^		IN_Warang_citi}', "");
    Expect(1, 71936, '\P{		IN_Warang_citi}', "");
    Expect(0, 71936, '\P{^		IN_Warang_citi}', "");
    Error('\p{-:=IN_warang_Citi}');
    Error('\P{-:=IN_warang_Citi}');
    Expect(1, 71935, '\p{_-In_Warang_Citi}', "");
    Expect(0, 71935, '\p{^_-In_Warang_Citi}', "");
    Expect(0, 71935, '\P{_-In_Warang_Citi}', "");
    Expect(1, 71935, '\P{^_-In_Warang_Citi}', "");
    Expect(0, 71936, '\p{_-In_Warang_Citi}', "");
    Expect(1, 71936, '\p{^_-In_Warang_Citi}', "");
    Expect(1, 71936, '\P{_-In_Warang_Citi}', "");
    Expect(0, 71936, '\P{^_-In_Warang_Citi}', "");
    Error('\p{ :=In_Zanabazar_SQUARE}');
    Error('\P{ :=In_Zanabazar_SQUARE}');
    Expect(1, 72271, '\p{inzanabazarsquare}', "");
    Expect(0, 72271, '\p{^inzanabazarsquare}', "");
    Expect(0, 72271, '\P{inzanabazarsquare}', "");
    Expect(1, 72271, '\P{^inzanabazarsquare}', "");
    Expect(0, 72272, '\p{inzanabazarsquare}', "");
    Expect(1, 72272, '\p{^inzanabazarsquare}', "");
    Expect(1, 72272, '\P{inzanabazarsquare}', "");
    Expect(0, 72272, '\P{^inzanabazarsquare}', "");
    Expect(1, 72271, '\p{_	in_ZANABAZAR_SQUARE}', "");
    Expect(0, 72271, '\p{^_	in_ZANABAZAR_SQUARE}', "");
    Expect(0, 72271, '\P{_	in_ZANABAZAR_SQUARE}', "");
    Expect(1, 72271, '\P{^_	in_ZANABAZAR_SQUARE}', "");
    Expect(0, 72272, '\p{_	in_ZANABAZAR_SQUARE}', "");
    Expect(1, 72272, '\p{^_	in_ZANABAZAR_SQUARE}', "");
    Expect(1, 72272, '\P{_	in_ZANABAZAR_SQUARE}', "");
    Expect(0, 72272, '\P{^_	in_ZANABAZAR_SQUARE}', "");
    Error('\p{_/a/In_zanabazar_square}');
    Error('\P{_/a/In_zanabazar_square}');
    Expect(1, 72271, '\p{-	in_Zanabazar_square}', "");
    Expect(0, 72271, '\p{^-	in_Zanabazar_square}', "");
    Expect(0, 72271, '\P{-	in_Zanabazar_square}', "");
    Expect(1, 72271, '\P{^-	in_Zanabazar_square}', "");
    Expect(0, 72272, '\p{-	in_Zanabazar_square}', "");
    Expect(1, 72272, '\p{^-	in_Zanabazar_square}', "");
    Expect(1, 72272, '\P{-	in_Zanabazar_square}', "");
    Expect(0, 72272, '\P{^-	in_Zanabazar_square}', "");
    Error('\p{		Indic_Siyaq_Numbers:=}');
    Error('\P{		Indic_Siyaq_Numbers:=}');
    Expect(1, 126143, '\p{indicsiyaqnumbers}', "");
    Expect(0, 126143, '\p{^indicsiyaqnumbers}', "");
    Expect(0, 126143, '\P{indicsiyaqnumbers}', "");
    Expect(1, 126143, '\P{^indicsiyaqnumbers}', "");
    Expect(0, 126144, '\p{indicsiyaqnumbers}', "");
    Expect(1, 126144, '\p{^indicsiyaqnumbers}', "");
    Expect(1, 126144, '\P{indicsiyaqnumbers}', "");
    Expect(0, 126144, '\P{^indicsiyaqnumbers}', "");
    Expect(1, 126143, '\p{-	INDIC_Siyaq_Numbers}', "");
    Expect(0, 126143, '\p{^-	INDIC_Siyaq_Numbers}', "");
    Expect(0, 126143, '\P{-	INDIC_Siyaq_Numbers}', "");
    Expect(1, 126143, '\P{^-	INDIC_Siyaq_Numbers}', "");
    Expect(0, 126144, '\p{-	INDIC_Siyaq_Numbers}', "");
    Expect(1, 126144, '\p{^-	INDIC_Siyaq_Numbers}', "");
    Expect(1, 126144, '\P{-	INDIC_Siyaq_Numbers}', "");
    Expect(0, 126144, '\P{^-	INDIC_Siyaq_Numbers}', "");
    Error('\p{/a/_ IS_indic_siyaq_Numbers}');
    Error('\P{/a/_ IS_indic_siyaq_Numbers}');
    Expect(1, 126143, '\p{isindicsiyaqnumbers}', "");
    Expect(0, 126143, '\p{^isindicsiyaqnumbers}', "");
    Expect(0, 126143, '\P{isindicsiyaqnumbers}', "");
    Expect(1, 126143, '\P{^isindicsiyaqnumbers}', "");
    Expect(0, 126144, '\p{isindicsiyaqnumbers}', "");
    Expect(1, 126144, '\p{^isindicsiyaqnumbers}', "");
    Expect(1, 126144, '\P{isindicsiyaqnumbers}', "");
    Expect(0, 126144, '\P{^isindicsiyaqnumbers}', "");
    Expect(1, 126143, '\p{	_Is_Indic_siyaq_Numbers}', "");
    Expect(0, 126143, '\p{^	_Is_Indic_siyaq_Numbers}', "");
    Expect(0, 126143, '\P{	_Is_Indic_siyaq_Numbers}', "");
    Expect(1, 126143, '\P{^	_Is_Indic_siyaq_Numbers}', "");
    Expect(0, 126144, '\p{	_Is_Indic_siyaq_Numbers}', "");
    Expect(1, 126144, '\p{^	_Is_Indic_siyaq_Numbers}', "");
    Expect(1, 126144, '\P{	_Is_Indic_siyaq_Numbers}', "");
    Expect(0, 126144, '\P{^	_Is_Indic_siyaq_Numbers}', "");
    Error('\p{--IN_INDIC_SIYAQ_Numbers:=}');
    Error('\P{--IN_INDIC_SIYAQ_Numbers:=}');
    Expect(1, 126143, '\p{inindicsiyaqnumbers}', "");
    Expect(0, 126143, '\p{^inindicsiyaqnumbers}', "");
    Expect(0, 126143, '\P{inindicsiyaqnumbers}', "");
    Expect(1, 126143, '\P{^inindicsiyaqnumbers}', "");
    Expect(0, 126144, '\p{inindicsiyaqnumbers}', "");
    Expect(1, 126144, '\p{^inindicsiyaqnumbers}', "");
    Expect(1, 126144, '\P{inindicsiyaqnumbers}', "");
    Expect(0, 126144, '\P{^inindicsiyaqnumbers}', "");
    Expect(1, 126143, '\p{--In_Indic_siyaq_Numbers}', "");
    Expect(0, 126143, '\p{^--In_Indic_siyaq_Numbers}', "");
    Expect(0, 126143, '\P{--In_Indic_siyaq_Numbers}', "");
    Expect(1, 126143, '\P{^--In_Indic_siyaq_Numbers}', "");
    Expect(0, 126144, '\p{--In_Indic_siyaq_Numbers}', "");
    Expect(1, 126144, '\p{^--In_Indic_siyaq_Numbers}', "");
    Expect(1, 126144, '\P{--In_Indic_siyaq_Numbers}', "");
    Expect(0, 126144, '\P{^--In_Indic_siyaq_Numbers}', "");
    Error('\p{	:=Inherited}');
    Error('\P{	:=Inherited}');
    Expect(1, 917999, '\p{inherited}', "");
    Expect(0, 917999, '\p{^inherited}', "");
    Expect(0, 917999, '\P{inherited}', "");
    Expect(1, 917999, '\P{^inherited}', "");
    Expect(0, 918000, '\p{inherited}', "");
    Expect(1, 918000, '\p{^inherited}', "");
    Expect(1, 918000, '\P{inherited}', "");
    Expect(0, 918000, '\P{^inherited}', "");
    Expect(1, 917999, '\p{ inherited}', "");
    Expect(0, 917999, '\p{^ inherited}', "");
    Expect(0, 917999, '\P{ inherited}', "");
    Expect(1, 917999, '\P{^ inherited}', "");
    Expect(0, 918000, '\p{ inherited}', "");
    Expect(1, 918000, '\p{^ inherited}', "");
    Expect(1, 918000, '\P{ inherited}', "");
    Expect(0, 918000, '\P{^ inherited}', "");
    Error('\p{ 	Is_inherited:=}');
    Error('\P{ 	Is_inherited:=}');
    Expect(1, 917999, '\p{isinherited}', "");
    Expect(0, 917999, '\p{^isinherited}', "");
    Expect(0, 917999, '\P{isinherited}', "");
    Expect(1, 917999, '\P{^isinherited}', "");
    Expect(0, 918000, '\p{isinherited}', "");
    Expect(1, 918000, '\p{^isinherited}', "");
    Expect(1, 918000, '\P{isinherited}', "");
    Expect(0, 918000, '\P{^isinherited}', "");
    Expect(1, 917999, '\p{ _IS_Inherited}', "");
    Expect(0, 917999, '\p{^ _IS_Inherited}', "");
    Expect(0, 917999, '\P{ _IS_Inherited}', "");
    Expect(1, 917999, '\P{^ _IS_Inherited}', "");
    Expect(0, 918000, '\p{ _IS_Inherited}', "");
    Expect(1, 918000, '\p{^ _IS_Inherited}', "");
    Expect(1, 918000, '\P{ _IS_Inherited}', "");
    Expect(0, 918000, '\P{^ _IS_Inherited}', "");
    Error('\p{- Zinh:=}');
    Error('\P{- Zinh:=}');
    Expect(1, 917999, '\p{zinh}', "");
    Expect(0, 917999, '\p{^zinh}', "");
    Expect(0, 917999, '\P{zinh}', "");
    Expect(1, 917999, '\P{^zinh}', "");
    Expect(0, 918000, '\p{zinh}', "");
    Expect(1, 918000, '\p{^zinh}', "");
    Expect(1, 918000, '\P{zinh}', "");
    Expect(0, 918000, '\P{^zinh}', "");
    Expect(1, 917999, '\p{		Zinh}', "");
    Expect(0, 917999, '\p{^		Zinh}', "");
    Expect(0, 917999, '\P{		Zinh}', "");
    Expect(1, 917999, '\P{^		Zinh}', "");
    Expect(0, 918000, '\p{		Zinh}', "");
    Expect(1, 918000, '\p{^		Zinh}', "");
    Expect(1, 918000, '\P{		Zinh}', "");
    Expect(0, 918000, '\P{^		Zinh}', "");
    Error('\p{_ is_zinh:=}');
    Error('\P{_ is_zinh:=}');
    Expect(1, 917999, '\p{iszinh}', "");
    Expect(0, 917999, '\p{^iszinh}', "");
    Expect(0, 917999, '\P{iszinh}', "");
    Expect(1, 917999, '\P{^iszinh}', "");
    Expect(0, 918000, '\p{iszinh}', "");
    Expect(1, 918000, '\p{^iszinh}', "");
    Expect(1, 918000, '\P{iszinh}', "");
    Expect(0, 918000, '\P{^iszinh}', "");
    Expect(1, 917999, '\p{ IS_zinh}', "");
    Expect(0, 917999, '\p{^ IS_zinh}', "");
    Expect(0, 917999, '\P{ IS_zinh}', "");
    Expect(1, 917999, '\P{^ IS_zinh}', "");
    Expect(0, 918000, '\p{ IS_zinh}', "");
    Expect(1, 918000, '\p{^ IS_zinh}', "");
    Expect(1, 918000, '\P{ IS_zinh}', "");
    Expect(0, 918000, '\P{^ IS_zinh}', "");
    Error('\p{-:=Qaai}');
    Error('\P{-:=Qaai}');
    Expect(1, 917999, '\p{qaai}', "");
    Expect(0, 917999, '\p{^qaai}', "");
    Expect(0, 917999, '\P{qaai}', "");
    Expect(1, 917999, '\P{^qaai}', "");
    Expect(0, 918000, '\p{qaai}', "");
    Expect(1, 918000, '\p{^qaai}', "");
    Expect(1, 918000, '\P{qaai}', "");
    Expect(0, 918000, '\P{^qaai}', "");
    Expect(1, 917999, '\p{  qaai}', "");
    Expect(0, 917999, '\p{^  qaai}', "");
    Expect(0, 917999, '\P{  qaai}', "");
    Expect(1, 917999, '\P{^  qaai}', "");
    Expect(0, 918000, '\p{  qaai}', "");
    Expect(1, 918000, '\p{^  qaai}', "");
    Expect(1, 918000, '\P{  qaai}', "");
    Expect(0, 918000, '\P{^  qaai}', "");
    Error('\p{-Is_Qaai/a/}');
    Error('\P{-Is_Qaai/a/}');
    Expect(1, 917999, '\p{isqaai}', "");
    Expect(0, 917999, '\p{^isqaai}', "");
    Expect(0, 917999, '\P{isqaai}', "");
    Expect(1, 917999, '\P{^isqaai}', "");
    Expect(0, 918000, '\p{isqaai}', "");
    Expect(1, 918000, '\p{^isqaai}', "");
    Expect(1, 918000, '\P{isqaai}', "");
    Expect(0, 918000, '\P{^isqaai}', "");
    Expect(1, 917999, '\p{ is_Qaai}', "");
    Expect(0, 917999, '\p{^ is_Qaai}', "");
    Expect(0, 917999, '\P{ is_Qaai}', "");
    Expect(1, 917999, '\P{^ is_Qaai}', "");
    Expect(0, 918000, '\p{ is_Qaai}', "");
    Expect(1, 918000, '\p{^ is_Qaai}', "");
    Expect(1, 918000, '\P{ is_Qaai}', "");
    Expect(0, 918000, '\P{^ is_Qaai}', "");
    Error('\p{/a/	_Initial_Punctuation}');
    Error('\P{/a/	_Initial_Punctuation}');
    Expect(1, 11808, '\p{initialpunctuation}', "");
    Expect(0, 11808, '\p{^initialpunctuation}', "");
    Expect(0, 11808, '\P{initialpunctuation}', "");
    Expect(1, 11808, '\P{^initialpunctuation}', "");
    Expect(0, 11809, '\p{initialpunctuation}', "");
    Expect(1, 11809, '\p{^initialpunctuation}', "");
    Expect(1, 11809, '\P{initialpunctuation}', "");
    Expect(0, 11809, '\P{^initialpunctuation}', "");
    Expect(1, 11808, '\p{ 	INITIAL_Punctuation}', "");
    Expect(0, 11808, '\p{^ 	INITIAL_Punctuation}', "");
    Expect(0, 11808, '\P{ 	INITIAL_Punctuation}', "");
    Expect(1, 11808, '\P{^ 	INITIAL_Punctuation}', "");
    Expect(0, 11809, '\p{ 	INITIAL_Punctuation}', "");
    Expect(1, 11809, '\p{^ 	INITIAL_Punctuation}', "");
    Expect(1, 11809, '\P{ 	INITIAL_Punctuation}', "");
    Expect(0, 11809, '\P{^ 	INITIAL_Punctuation}', "");
    Error('\p{/a/ -is_Initial_punctuation}');
    Error('\P{/a/ -is_Initial_punctuation}');
    Expect(1, 11808, '\p{isinitialpunctuation}', "");
    Expect(0, 11808, '\p{^isinitialpunctuation}', "");
    Expect(0, 11808, '\P{isinitialpunctuation}', "");
    Expect(1, 11808, '\P{^isinitialpunctuation}', "");
    Expect(0, 11809, '\p{isinitialpunctuation}', "");
    Expect(1, 11809, '\p{^isinitialpunctuation}', "");
    Expect(1, 11809, '\P{isinitialpunctuation}', "");
    Expect(0, 11809, '\P{^isinitialpunctuation}', "");
    Expect(1, 11808, '\p{-_is_Initial_Punctuation}', "");
    Expect(0, 11808, '\p{^-_is_Initial_Punctuation}', "");
    Expect(0, 11808, '\P{-_is_Initial_Punctuation}', "");
    Expect(1, 11808, '\P{^-_is_Initial_Punctuation}', "");
    Expect(0, 11809, '\p{-_is_Initial_Punctuation}', "");
    Expect(1, 11809, '\p{^-_is_Initial_Punctuation}', "");
    Expect(1, 11809, '\P{-_is_Initial_Punctuation}', "");
    Expect(0, 11809, '\P{^-_is_Initial_Punctuation}', "");
    Error('\p{	:=Pi}');
    Error('\P{	:=Pi}');
    Expect(1, 11808, '\p{pi}', "");
    Expect(0, 11808, '\p{^pi}', "");
    Expect(0, 11808, '\P{pi}', "");
    Expect(1, 11808, '\P{^pi}', "");
    Expect(0, 11809, '\p{pi}', "");
    Expect(1, 11809, '\p{^pi}', "");
    Expect(1, 11809, '\P{pi}', "");
    Expect(0, 11809, '\P{^pi}', "");
    Expect(1, 11808, '\p{ _pi}', "");
    Expect(0, 11808, '\p{^ _pi}', "");
    Expect(0, 11808, '\P{ _pi}', "");
    Expect(1, 11808, '\P{^ _pi}', "");
    Expect(0, 11809, '\p{ _pi}', "");
    Expect(1, 11809, '\p{^ _pi}', "");
    Expect(1, 11809, '\P{ _pi}', "");
    Expect(0, 11809, '\P{^ _pi}', "");
    Error('\p{_Is_PI/a/}');
    Error('\P{_Is_PI/a/}');
    Expect(1, 11808, '\p{ispi}', "");
    Expect(0, 11808, '\p{^ispi}', "");
    Expect(0, 11808, '\P{ispi}', "");
    Expect(1, 11808, '\P{^ispi}', "");
    Expect(0, 11809, '\p{ispi}', "");
    Expect(1, 11809, '\p{^ispi}', "");
    Expect(1, 11809, '\P{ispi}', "");
    Expect(0, 11809, '\P{^ispi}', "");
    Expect(1, 11808, '\p{-Is_Pi}', "");
    Expect(0, 11808, '\p{^-Is_Pi}', "");
    Expect(0, 11808, '\P{-Is_Pi}', "");
    Expect(1, 11808, '\P{^-Is_Pi}', "");
    Expect(0, 11809, '\p{-Is_Pi}', "");
    Expect(1, 11809, '\p{^-Is_Pi}', "");
    Expect(1, 11809, '\P{-Is_Pi}', "");
    Expect(0, 11809, '\P{^-Is_Pi}', "");
    Error('\p{-/a/Inscriptional_Pahlavi}');
    Error('\P{-/a/Inscriptional_Pahlavi}');
    Expect(1, 68479, '\p{inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{	inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\p{^	inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\P{	inscriptional_Pahlavi}', "");
    Expect(1, 68479, '\P{^	inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\p{	inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\p{^	inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\P{	inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\P{^	inscriptional_Pahlavi}', "");
    Error('\p{:=	 is_Inscriptional_Pahlavi}');
    Error('\P{:=	 is_Inscriptional_Pahlavi}');
    Expect(1, 68479, '\p{isinscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^isinscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{isinscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^isinscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{isinscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^isinscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{isinscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^isinscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{-_IS_Inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\p{^-_IS_Inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\P{-_IS_Inscriptional_Pahlavi}', "");
    Expect(1, 68479, '\P{^-_IS_Inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\p{-_IS_Inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\p{^-_IS_Inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\P{-_IS_Inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\P{^-_IS_Inscriptional_Pahlavi}', "");
    Error('\p{/a/ 	Phli}');
    Error('\P{/a/ 	Phli}');
    Expect(1, 68479, '\p{phli}', "");
    Expect(0, 68479, '\p{^phli}', "");
    Expect(0, 68479, '\P{phli}', "");
    Expect(1, 68479, '\P{^phli}', "");
    Expect(0, 68480, '\p{phli}', "");
    Expect(1, 68480, '\p{^phli}', "");
    Expect(1, 68480, '\P{phli}', "");
    Expect(0, 68480, '\P{^phli}', "");
    Expect(1, 68479, '\p{-_phli}', "");
    Expect(0, 68479, '\p{^-_phli}', "");
    Expect(0, 68479, '\P{-_phli}', "");
    Expect(1, 68479, '\P{^-_phli}', "");
    Expect(0, 68480, '\p{-_phli}', "");
    Expect(1, 68480, '\p{^-_phli}', "");
    Expect(1, 68480, '\P{-_phli}', "");
    Expect(0, 68480, '\P{^-_phli}', "");
    Error('\p{ Is_Phli:=}');
    Error('\P{ Is_Phli:=}');
    Expect(1, 68479, '\p{isphli}', "");
    Expect(0, 68479, '\p{^isphli}', "");
    Expect(0, 68479, '\P{isphli}', "");
    Expect(1, 68479, '\P{^isphli}', "");
    Expect(0, 68480, '\p{isphli}', "");
    Expect(1, 68480, '\p{^isphli}', "");
    Expect(1, 68480, '\P{isphli}', "");
    Expect(0, 68480, '\P{^isphli}', "");
    Expect(1, 68479, '\p{	Is_Phli}', "");
    Expect(0, 68479, '\p{^	Is_Phli}', "");
    Expect(0, 68479, '\P{	Is_Phli}', "");
    Expect(1, 68479, '\P{^	Is_Phli}', "");
    Expect(0, 68480, '\p{	Is_Phli}', "");
    Expect(1, 68480, '\p{^	Is_Phli}', "");
    Expect(1, 68480, '\P{	Is_Phli}', "");
    Expect(0, 68480, '\P{^	Is_Phli}', "");
    Error('\p{:=inscriptional_PARTHIAN}');
    Error('\P{:=inscriptional_PARTHIAN}');
    Expect(1, 68447, '\p{inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^inscriptionalparthian}', "");
    Expect(0, 68447, '\P{inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^inscriptionalparthian}', "");
    Expect(0, 68448, '\p{inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^inscriptionalparthian}', "");
    Expect(1, 68448, '\P{inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^inscriptionalparthian}', "");
    Expect(1, 68447, '\p{_-INSCRIPTIONAL_parthian}', "");
    Expect(0, 68447, '\p{^_-INSCRIPTIONAL_parthian}', "");
    Expect(0, 68447, '\P{_-INSCRIPTIONAL_parthian}', "");
    Expect(1, 68447, '\P{^_-INSCRIPTIONAL_parthian}', "");
    Expect(0, 68448, '\p{_-INSCRIPTIONAL_parthian}', "");
    Expect(1, 68448, '\p{^_-INSCRIPTIONAL_parthian}', "");
    Expect(1, 68448, '\P{_-INSCRIPTIONAL_parthian}', "");
    Expect(0, 68448, '\P{^_-INSCRIPTIONAL_parthian}', "");
    Error('\p{_:=is_inscriptional_Parthian}');
    Error('\P{_:=is_inscriptional_Parthian}');
    Expect(1, 68447, '\p{isinscriptionalparthian}', "");
    Expect(0, 68447, '\p{^isinscriptionalparthian}', "");
    Expect(0, 68447, '\P{isinscriptionalparthian}', "");
    Expect(1, 68447, '\P{^isinscriptionalparthian}', "");
    Expect(0, 68448, '\p{isinscriptionalparthian}', "");
    Expect(1, 68448, '\p{^isinscriptionalparthian}', "");
    Expect(1, 68448, '\P{isinscriptionalparthian}', "");
    Expect(0, 68448, '\P{^isinscriptionalparthian}', "");
    Expect(1, 68447, '\p{-_Is_INSCRIPTIONAL_parthian}', "");
    Expect(0, 68447, '\p{^-_Is_INSCRIPTIONAL_parthian}', "");
    Expect(0, 68447, '\P{-_Is_INSCRIPTIONAL_parthian}', "");
    Expect(1, 68447, '\P{^-_Is_INSCRIPTIONAL_parthian}', "");
    Expect(0, 68448, '\p{-_Is_INSCRIPTIONAL_parthian}', "");
    Expect(1, 68448, '\p{^-_Is_INSCRIPTIONAL_parthian}', "");
    Expect(1, 68448, '\P{-_Is_INSCRIPTIONAL_parthian}', "");
    Expect(0, 68448, '\P{^-_Is_INSCRIPTIONAL_parthian}', "");
    Error('\p{_Prti:=}');
    Error('\P{_Prti:=}');
    Expect(1, 68447, '\p{prti}', "");
    Expect(0, 68447, '\p{^prti}', "");
    Expect(0, 68447, '\P{prti}', "");
    Expect(1, 68447, '\P{^prti}', "");
    Expect(0, 68448, '\p{prti}', "");
    Expect(1, 68448, '\p{^prti}', "");
    Expect(1, 68448, '\P{prti}', "");
    Expect(0, 68448, '\P{^prti}', "");
    Expect(1, 68447, '\p{	PRTI}', "");
    Expect(0, 68447, '\p{^	PRTI}', "");
    Expect(0, 68447, '\P{	PRTI}', "");
    Expect(1, 68447, '\P{^	PRTI}', "");
    Expect(0, 68448, '\p{	PRTI}', "");
    Expect(1, 68448, '\p{^	PRTI}', "");
    Expect(1, 68448, '\P{	PRTI}', "");
    Expect(0, 68448, '\P{^	PRTI}', "");
    Error('\p{-/a/IS_Prti}');
    Error('\P{-/a/IS_Prti}');
    Expect(1, 68447, '\p{isprti}', "");
    Expect(0, 68447, '\p{^isprti}', "");
    Expect(0, 68447, '\P{isprti}', "");
    Expect(1, 68447, '\P{^isprti}', "");
    Expect(0, 68448, '\p{isprti}', "");
    Expect(1, 68448, '\p{^isprti}', "");
    Expect(1, 68448, '\P{isprti}', "");
    Expect(0, 68448, '\P{^isprti}', "");
    Expect(1, 68447, '\p{--Is_PRTI}', "");
    Expect(0, 68447, '\p{^--Is_PRTI}', "");
    Expect(0, 68447, '\P{--Is_PRTI}', "");
    Expect(1, 68447, '\P{^--Is_PRTI}', "");
    Expect(0, 68448, '\p{--Is_PRTI}', "");
    Expect(1, 68448, '\p{^--Is_PRTI}', "");
    Expect(1, 68448, '\P{--Is_PRTI}', "");
    Expect(0, 68448, '\P{^--Is_PRTI}', "");
    Error('\p{-:=IPA_Extensions}');
    Error('\P{-:=IPA_Extensions}');
    Expect(1, 687, '\p{ipaextensions}', "");
    Expect(0, 687, '\p{^ipaextensions}', "");
    Expect(0, 687, '\P{ipaextensions}', "");
    Expect(1, 687, '\P{^ipaextensions}', "");
    Expect(0, 688, '\p{ipaextensions}', "");
    Expect(1, 688, '\p{^ipaextensions}', "");
    Expect(1, 688, '\P{ipaextensions}', "");
    Expect(0, 688, '\P{^ipaextensions}', "");
    Expect(1, 687, '\p{		IPA_Extensions}', "");
    Expect(0, 687, '\p{^		IPA_Extensions}', "");
    Expect(0, 687, '\P{		IPA_Extensions}', "");
    Expect(1, 687, '\P{^		IPA_Extensions}', "");
    Expect(0, 688, '\p{		IPA_Extensions}', "");
    Expect(1, 688, '\p{^		IPA_Extensions}', "");
    Expect(1, 688, '\P{		IPA_Extensions}', "");
    Expect(0, 688, '\P{^		IPA_Extensions}', "");
    Error('\p{:=	is_IPA_EXTENSIONS}');
    Error('\P{:=	is_IPA_EXTENSIONS}');
    Expect(1, 687, '\p{isipaextensions}', "");
    Expect(0, 687, '\p{^isipaextensions}', "");
    Expect(0, 687, '\P{isipaextensions}', "");
    Expect(1, 687, '\P{^isipaextensions}', "");
    Expect(0, 688, '\p{isipaextensions}', "");
    Expect(1, 688, '\p{^isipaextensions}', "");
    Expect(1, 688, '\P{isipaextensions}', "");
    Expect(0, 688, '\P{^isipaextensions}', "");
    Expect(1, 687, '\p{	 Is_ipa_EXTENSIONS}', "");
    Expect(0, 687, '\p{^	 Is_ipa_EXTENSIONS}', "");
    Expect(0, 687, '\P{	 Is_ipa_EXTENSIONS}', "");
    Expect(1, 687, '\P{^	 Is_ipa_EXTENSIONS}', "");
    Expect(0, 688, '\p{	 Is_ipa_EXTENSIONS}', "");
    Expect(1, 688, '\p{^	 Is_ipa_EXTENSIONS}', "");
    Expect(1, 688, '\P{	 Is_ipa_EXTENSIONS}', "");
    Expect(0, 688, '\P{^	 Is_ipa_EXTENSIONS}', "");
    Error('\p{:=	-In_IPA_Extensions}');
    Error('\P{:=	-In_IPA_Extensions}');
    Expect(1, 687, '\p{inipaextensions}', "");
    Expect(0, 687, '\p{^inipaextensions}', "");
    Expect(0, 687, '\P{inipaextensions}', "");
    Expect(1, 687, '\P{^inipaextensions}', "");
    Expect(0, 688, '\p{inipaextensions}', "");
    Expect(1, 688, '\p{^inipaextensions}', "");
    Expect(1, 688, '\P{inipaextensions}', "");
    Expect(0, 688, '\P{^inipaextensions}', "");
    Expect(1, 687, '\p{	In_IPA_Extensions}', "");
    Expect(0, 687, '\p{^	In_IPA_Extensions}', "");
    Expect(0, 687, '\P{	In_IPA_Extensions}', "");
    Expect(1, 687, '\P{^	In_IPA_Extensions}', "");
    Expect(0, 688, '\p{	In_IPA_Extensions}', "");
    Expect(1, 688, '\p{^	In_IPA_Extensions}', "");
    Expect(1, 688, '\P{	In_IPA_Extensions}', "");
    Expect(0, 688, '\P{^	In_IPA_Extensions}', "");
    Error('\p{_	ipa_Ext/a/}');
    Error('\P{_	ipa_Ext/a/}');
    Expect(1, 687, '\p{ipaext}', "");
    Expect(0, 687, '\p{^ipaext}', "");
    Expect(0, 687, '\P{ipaext}', "");
    Expect(1, 687, '\P{^ipaext}', "");
    Expect(0, 688, '\p{ipaext}', "");
    Expect(1, 688, '\p{^ipaext}', "");
    Expect(1, 688, '\P{ipaext}', "");
    Expect(0, 688, '\P{^ipaext}', "");
    Expect(1, 687, '\p{ IPA_ext}', "");
    Expect(0, 687, '\p{^ IPA_ext}', "");
    Expect(0, 687, '\P{ IPA_ext}', "");
    Expect(1, 687, '\P{^ IPA_ext}', "");
    Expect(0, 688, '\p{ IPA_ext}', "");
    Expect(1, 688, '\p{^ IPA_ext}', "");
    Expect(1, 688, '\P{ IPA_ext}', "");
    Expect(0, 688, '\P{^ IPA_ext}', "");
    Error('\p{/a/IS_ipa_Ext}');
    Error('\P{/a/IS_ipa_Ext}');
    Expect(1, 687, '\p{isipaext}', "");
    Expect(0, 687, '\p{^isipaext}', "");
    Expect(0, 687, '\P{isipaext}', "");
    Expect(1, 687, '\P{^isipaext}', "");
    Expect(0, 688, '\p{isipaext}', "");
    Expect(1, 688, '\p{^isipaext}', "");
    Expect(1, 688, '\P{isipaext}', "");
    Expect(0, 688, '\P{^isipaext}', "");
    Expect(1, 687, '\p{ IS_IPA_Ext}', "");
    Expect(0, 687, '\p{^ IS_IPA_Ext}', "");
    Expect(0, 687, '\P{ IS_IPA_Ext}', "");
    Expect(1, 687, '\P{^ IS_IPA_Ext}', "");
    Expect(0, 688, '\p{ IS_IPA_Ext}', "");
    Expect(1, 688, '\p{^ IS_IPA_Ext}', "");
    Expect(1, 688, '\P{ IS_IPA_Ext}', "");
    Expect(0, 688, '\P{^ IS_IPA_Ext}', "");
    Error('\p{	:=In_ipa_Ext}');
    Error('\P{	:=In_ipa_Ext}');
    Expect(1, 687, '\p{inipaext}', "");
    Expect(0, 687, '\p{^inipaext}', "");
    Expect(0, 687, '\P{inipaext}', "");
    Expect(1, 687, '\P{^inipaext}', "");
    Expect(0, 688, '\p{inipaext}', "");
    Expect(1, 688, '\p{^inipaext}', "");
    Expect(1, 688, '\P{inipaext}', "");
    Expect(0, 688, '\P{^inipaext}', "");
    Expect(1, 687, '\p{_IN_ipa_Ext}', "");
    Expect(0, 687, '\p{^_IN_ipa_Ext}', "");
    Expect(0, 687, '\P{_IN_ipa_Ext}', "");
    Expect(1, 687, '\P{^_IN_ipa_Ext}', "");
    Expect(0, 688, '\p{_IN_ipa_Ext}', "");
    Expect(1, 688, '\p{^_IN_ipa_Ext}', "");
    Expect(1, 688, '\P{_IN_ipa_Ext}', "");
    Expect(0, 688, '\P{^_IN_ipa_Ext}', "");
    Error('\p{	:=Javanese}');
    Error('\P{	:=Javanese}');
    Expect(1, 43487, '\p{javanese}', "");
    Expect(0, 43487, '\p{^javanese}', "");
    Expect(0, 43487, '\P{javanese}', "");
    Expect(1, 43487, '\P{^javanese}', "");
    Expect(0, 43488, '\p{javanese}', "");
    Expect(1, 43488, '\p{^javanese}', "");
    Expect(1, 43488, '\P{javanese}', "");
    Expect(0, 43488, '\P{^javanese}', "");
    Expect(1, 43487, '\p{-Javanese}', "");
    Expect(0, 43487, '\p{^-Javanese}', "");
    Expect(0, 43487, '\P{-Javanese}', "");
    Expect(1, 43487, '\P{^-Javanese}', "");
    Expect(0, 43488, '\p{-Javanese}', "");
    Expect(1, 43488, '\p{^-Javanese}', "");
    Expect(1, 43488, '\P{-Javanese}', "");
    Expect(0, 43488, '\P{^-Javanese}', "");
    Error('\p{_IS_JAVANESE:=}');
    Error('\P{_IS_JAVANESE:=}');
    Expect(1, 43487, '\p{isjavanese}', "");
    Expect(0, 43487, '\p{^isjavanese}', "");
    Expect(0, 43487, '\P{isjavanese}', "");
    Expect(1, 43487, '\P{^isjavanese}', "");
    Expect(0, 43488, '\p{isjavanese}', "");
    Expect(1, 43488, '\p{^isjavanese}', "");
    Expect(1, 43488, '\P{isjavanese}', "");
    Expect(0, 43488, '\P{^isjavanese}', "");
    Expect(1, 43487, '\p{ IS_Javanese}', "");
    Expect(0, 43487, '\p{^ IS_Javanese}', "");
    Expect(0, 43487, '\P{ IS_Javanese}', "");
    Expect(1, 43487, '\P{^ IS_Javanese}', "");
    Expect(0, 43488, '\p{ IS_Javanese}', "");
    Expect(1, 43488, '\p{^ IS_Javanese}', "");
    Expect(1, 43488, '\P{ IS_Javanese}', "");
    Expect(0, 43488, '\P{^ IS_Javanese}', "");
    Error('\p{_:=Java}');
    Error('\P{_:=Java}');
    Expect(1, 43487, '\p{java}', "");
    Expect(0, 43487, '\p{^java}', "");
    Expect(0, 43487, '\P{java}', "");
    Expect(1, 43487, '\P{^java}', "");
    Expect(0, 43488, '\p{java}', "");
    Expect(1, 43488, '\p{^java}', "");
    Expect(1, 43488, '\P{java}', "");
    Expect(0, 43488, '\P{^java}', "");
    Expect(1, 43487, '\p{_Java}', "");
    Expect(0, 43487, '\p{^_Java}', "");
    Expect(0, 43487, '\P{_Java}', "");
    Expect(1, 43487, '\P{^_Java}', "");
    Expect(0, 43488, '\p{_Java}', "");
    Expect(1, 43488, '\p{^_Java}', "");
    Expect(1, 43488, '\P{_Java}', "");
    Expect(0, 43488, '\P{^_Java}', "");
    Error('\p{	:=IS_Java}');
    Error('\P{	:=IS_Java}');
    Expect(1, 43487, '\p{isjava}', "");
    Expect(0, 43487, '\p{^isjava}', "");
    Expect(0, 43487, '\P{isjava}', "");
    Expect(1, 43487, '\P{^isjava}', "");
    Expect(0, 43488, '\p{isjava}', "");
    Expect(1, 43488, '\p{^isjava}', "");
    Expect(1, 43488, '\P{isjava}', "");
    Expect(0, 43488, '\P{^isjava}', "");
    Expect(1, 43487, '\p{ 	Is_Java}', "");
    Expect(0, 43487, '\p{^ 	Is_Java}', "");
    Expect(0, 43487, '\P{ 	Is_Java}', "");
    Expect(1, 43487, '\P{^ 	Is_Java}', "");
    Expect(0, 43488, '\p{ 	Is_Java}', "");
    Expect(1, 43488, '\p{^ 	Is_Java}', "");
    Expect(1, 43488, '\P{ 	Is_Java}', "");
    Expect(0, 43488, '\P{^ 	Is_Java}', "");
    Error('\p{:=	_Join_CONTROL}');
    Error('\P{:=	_Join_CONTROL}');
    Expect(1, 8205, '\p{joincontrol}', "");
    Expect(0, 8205, '\p{^joincontrol}', "");
    Expect(0, 8205, '\P{joincontrol}', "");
    Expect(1, 8205, '\P{^joincontrol}', "");
    Expect(0, 8206, '\p{joincontrol}', "");
    Expect(1, 8206, '\p{^joincontrol}', "");
    Expect(1, 8206, '\P{joincontrol}', "");
    Expect(0, 8206, '\P{^joincontrol}', "");
    Expect(1, 8205, '\p{	 Join_Control}', "");
    Expect(0, 8205, '\p{^	 Join_Control}', "");
    Expect(0, 8205, '\P{	 Join_Control}', "");
    Expect(1, 8205, '\P{^	 Join_Control}', "");
    Expect(0, 8206, '\p{	 Join_Control}', "");
    Expect(1, 8206, '\p{^	 Join_Control}', "");
    Expect(1, 8206, '\P{	 Join_Control}', "");
    Expect(0, 8206, '\P{^	 Join_Control}', "");
    Error('\p{ /a/Is_Join_control}');
    Error('\P{ /a/Is_Join_control}');
    Expect(1, 8205, '\p{isjoincontrol}', "");
    Expect(0, 8205, '\p{^isjoincontrol}', "");
    Expect(0, 8205, '\P{isjoincontrol}', "");
    Expect(1, 8205, '\P{^isjoincontrol}', "");
    Expect(0, 8206, '\p{isjoincontrol}', "");
    Expect(1, 8206, '\p{^isjoincontrol}', "");
    Expect(1, 8206, '\P{isjoincontrol}', "");
    Expect(0, 8206, '\P{^isjoincontrol}', "");
    Expect(1, 8205, '\p{-IS_JOIN_control}', "");
    Expect(0, 8205, '\p{^-IS_JOIN_control}', "");
    Expect(0, 8205, '\P{-IS_JOIN_control}', "");
    Expect(1, 8205, '\P{^-IS_JOIN_control}', "");
    Expect(0, 8206, '\p{-IS_JOIN_control}', "");
    Expect(1, 8206, '\p{^-IS_JOIN_control}', "");
    Expect(1, 8206, '\P{-IS_JOIN_control}', "");
    Expect(0, 8206, '\P{^-IS_JOIN_control}', "");
    Error('\p{ _join_C:=}');
    Error('\P{ _join_C:=}');
    Expect(1, 8205, '\p{joinc}', "");
    Expect(0, 8205, '\p{^joinc}', "");
    Expect(0, 8205, '\P{joinc}', "");
    Expect(1, 8205, '\P{^joinc}', "");
    Expect(0, 8206, '\p{joinc}', "");
    Expect(1, 8206, '\p{^joinc}', "");
    Expect(1, 8206, '\P{joinc}', "");
    Expect(0, 8206, '\P{^joinc}', "");
    Expect(1, 8205, '\p{_Join_C}', "");
    Expect(0, 8205, '\p{^_Join_C}', "");
    Expect(0, 8205, '\P{_Join_C}', "");
    Expect(1, 8205, '\P{^_Join_C}', "");
    Expect(0, 8206, '\p{_Join_C}', "");
    Expect(1, 8206, '\p{^_Join_C}', "");
    Expect(1, 8206, '\P{_Join_C}', "");
    Expect(0, 8206, '\P{^_Join_C}', "");
    Error('\p{:=IS_join_C}');
    Error('\P{:=IS_join_C}');
    Expect(1, 8205, '\p{isjoinc}', "");
    Expect(0, 8205, '\p{^isjoinc}', "");
    Expect(0, 8205, '\P{isjoinc}', "");
    Expect(1, 8205, '\P{^isjoinc}', "");
    Expect(0, 8206, '\p{isjoinc}', "");
    Expect(1, 8206, '\p{^isjoinc}', "");
    Expect(1, 8206, '\P{isjoinc}', "");
    Expect(0, 8206, '\P{^isjoinc}', "");
    Expect(1, 8205, '\p{--is_join_c}', "");
    Expect(0, 8205, '\p{^--is_join_c}', "");
    Expect(0, 8205, '\P{--is_join_c}', "");
    Expect(1, 8205, '\P{^--is_join_c}', "");
    Expect(0, 8206, '\p{--is_join_c}', "");
    Expect(1, 8206, '\p{^--is_join_c}', "");
    Expect(1, 8206, '\P{--is_join_c}', "");
    Expect(0, 8206, '\P{^--is_join_c}', "");
    Error('\p{-_KAITHI/a/}');
    Error('\P{-_KAITHI/a/}');
    Expect(1, 69837, '\p{kaithi}', "");
    Expect(0, 69837, '\p{^kaithi}', "");
    Expect(0, 69837, '\P{kaithi}', "");
    Expect(1, 69837, '\P{^kaithi}', "");
    Expect(0, 69838, '\p{kaithi}', "");
    Expect(1, 69838, '\p{^kaithi}', "");
    Expect(1, 69838, '\P{kaithi}', "");
    Expect(0, 69838, '\P{^kaithi}', "");
    Expect(1, 69837, '\p{	-Kaithi}', "");
    Expect(0, 69837, '\p{^	-Kaithi}', "");
    Expect(0, 69837, '\P{	-Kaithi}', "");
    Expect(1, 69837, '\P{^	-Kaithi}', "");
    Expect(0, 69838, '\p{	-Kaithi}', "");
    Expect(1, 69838, '\p{^	-Kaithi}', "");
    Expect(1, 69838, '\P{	-Kaithi}', "");
    Expect(0, 69838, '\P{^	-Kaithi}', "");
    Error('\p{:=-_is_kaithi}');
    Error('\P{:=-_is_kaithi}');
    Expect(1, 69837, '\p{iskaithi}', "");
    Expect(0, 69837, '\p{^iskaithi}', "");
    Expect(0, 69837, '\P{iskaithi}', "");
    Expect(1, 69837, '\P{^iskaithi}', "");
    Expect(0, 69838, '\p{iskaithi}', "");
    Expect(1, 69838, '\p{^iskaithi}', "");
    Expect(1, 69838, '\P{iskaithi}', "");
    Expect(0, 69838, '\P{^iskaithi}', "");
    Expect(1, 69837, '\p{		Is_kaithi}', "");
    Expect(0, 69837, '\p{^		Is_kaithi}', "");
    Expect(0, 69837, '\P{		Is_kaithi}', "");
    Expect(1, 69837, '\P{^		Is_kaithi}', "");
    Expect(0, 69838, '\p{		Is_kaithi}', "");
    Expect(1, 69838, '\p{^		Is_kaithi}', "");
    Expect(1, 69838, '\P{		Is_kaithi}', "");
    Expect(0, 69838, '\P{^		Is_kaithi}', "");
    Error('\p{ /a/kthi}');
    Error('\P{ /a/kthi}');
    Expect(1, 69837, '\p{kthi}', "");
    Expect(0, 69837, '\p{^kthi}', "");
    Expect(0, 69837, '\P{kthi}', "");
    Expect(1, 69837, '\P{^kthi}', "");
    Expect(0, 69838, '\p{kthi}', "");
    Expect(1, 69838, '\p{^kthi}', "");
    Expect(1, 69838, '\P{kthi}', "");
    Expect(0, 69838, '\P{^kthi}', "");
    Expect(1, 69837, '\p{__Kthi}', "");
    Expect(0, 69837, '\p{^__Kthi}', "");
    Expect(0, 69837, '\P{__Kthi}', "");
    Expect(1, 69837, '\P{^__Kthi}', "");
    Expect(0, 69838, '\p{__Kthi}', "");
    Expect(1, 69838, '\p{^__Kthi}', "");
    Expect(1, 69838, '\P{__Kthi}', "");
    Expect(0, 69838, '\P{^__Kthi}', "");
    Error('\p{	is_Kthi:=}');
    Error('\P{	is_Kthi:=}');
    Expect(1, 69837, '\p{iskthi}', "");
    Expect(0, 69837, '\p{^iskthi}', "");
    Expect(0, 69837, '\P{iskthi}', "");
    Expect(1, 69837, '\P{^iskthi}', "");
    Expect(0, 69838, '\p{iskthi}', "");
    Expect(1, 69838, '\p{^iskthi}', "");
    Expect(1, 69838, '\P{iskthi}', "");
    Expect(0, 69838, '\P{^iskthi}', "");
    Expect(1, 69837, '\p{	is_KTHI}', "");
    Expect(0, 69837, '\p{^	is_KTHI}', "");
    Expect(0, 69837, '\P{	is_KTHI}', "");
    Expect(1, 69837, '\P{^	is_KTHI}', "");
    Expect(0, 69838, '\p{	is_KTHI}', "");
    Expect(1, 69838, '\p{^	is_KTHI}', "");
    Expect(1, 69838, '\P{	is_KTHI}', "");
    Expect(0, 69838, '\P{^	is_KTHI}', "");
    Error('\p{:=--Kana_Extended_A}');
    Error('\P{:=--Kana_Extended_A}');
    Expect(1, 110895, '\p{kanaextendeda}', "");
    Expect(0, 110895, '\p{^kanaextendeda}', "");
    Expect(0, 110895, '\P{kanaextendeda}', "");
    Expect(1, 110895, '\P{^kanaextendeda}', "");
    Expect(0, 110896, '\p{kanaextendeda}', "");
    Expect(1, 110896, '\p{^kanaextendeda}', "");
    Expect(1, 110896, '\P{kanaextendeda}', "");
    Expect(0, 110896, '\P{^kanaextendeda}', "");
    Expect(1, 110895, '\p{__Kana_Extended_A}', "");
    Expect(0, 110895, '\p{^__Kana_Extended_A}', "");
    Expect(0, 110895, '\P{__Kana_Extended_A}', "");
    Expect(1, 110895, '\P{^__Kana_Extended_A}', "");
    Expect(0, 110896, '\p{__Kana_Extended_A}', "");
    Expect(1, 110896, '\p{^__Kana_Extended_A}', "");
    Expect(1, 110896, '\P{__Kana_Extended_A}', "");
    Expect(0, 110896, '\P{^__Kana_Extended_A}', "");
    Error('\p{	:=Is_Kana_extended_A}');
    Error('\P{	:=Is_Kana_extended_A}');
    Expect(1, 110895, '\p{iskanaextendeda}', "");
    Expect(0, 110895, '\p{^iskanaextendeda}', "");
    Expect(0, 110895, '\P{iskanaextendeda}', "");
    Expect(1, 110895, '\P{^iskanaextendeda}', "");
    Expect(0, 110896, '\p{iskanaextendeda}', "");
    Expect(1, 110896, '\p{^iskanaextendeda}', "");
    Expect(1, 110896, '\P{iskanaextendeda}', "");
    Expect(0, 110896, '\P{^iskanaextendeda}', "");
    Expect(1, 110895, '\p{ Is_KANA_extended_A}', "");
    Expect(0, 110895, '\p{^ Is_KANA_extended_A}', "");
    Expect(0, 110895, '\P{ Is_KANA_extended_A}', "");
    Expect(1, 110895, '\P{^ Is_KANA_extended_A}', "");
    Expect(0, 110896, '\p{ Is_KANA_extended_A}', "");
    Expect(1, 110896, '\p{^ Is_KANA_extended_A}', "");
    Expect(1, 110896, '\P{ Is_KANA_extended_A}', "");
    Expect(0, 110896, '\P{^ Is_KANA_extended_A}', "");
    Error('\p{ IN_Kana_EXTENDED_A:=}');
    Error('\P{ IN_Kana_EXTENDED_A:=}');
    Expect(1, 110895, '\p{inkanaextendeda}', "");
    Expect(0, 110895, '\p{^inkanaextendeda}', "");
    Expect(0, 110895, '\P{inkanaextendeda}', "");
    Expect(1, 110895, '\P{^inkanaextendeda}', "");
    Expect(0, 110896, '\p{inkanaextendeda}', "");
    Expect(1, 110896, '\p{^inkanaextendeda}', "");
    Expect(1, 110896, '\P{inkanaextendeda}', "");
    Expect(0, 110896, '\P{^inkanaextendeda}', "");
    Expect(1, 110895, '\p{		In_Kana_Extended_a}', "");
    Expect(0, 110895, '\p{^		In_Kana_Extended_a}', "");
    Expect(0, 110895, '\P{		In_Kana_Extended_a}', "");
    Expect(1, 110895, '\P{^		In_Kana_Extended_a}', "");
    Expect(0, 110896, '\p{		In_Kana_Extended_a}', "");
    Expect(1, 110896, '\p{^		In_Kana_Extended_a}', "");
    Expect(1, 110896, '\P{		In_Kana_Extended_a}', "");
    Expect(0, 110896, '\P{^		In_Kana_Extended_a}', "");
    Error('\p{:=	-kana_EXT_A}');
    Error('\P{:=	-kana_EXT_A}');
    Expect(1, 110895, '\p{kanaexta}', "");
    Expect(0, 110895, '\p{^kanaexta}', "");
    Expect(0, 110895, '\P{kanaexta}', "");
    Expect(1, 110895, '\P{^kanaexta}', "");
    Expect(0, 110896, '\p{kanaexta}', "");
    Expect(1, 110896, '\p{^kanaexta}', "");
    Expect(1, 110896, '\P{kanaexta}', "");
    Expect(0, 110896, '\P{^kanaexta}', "");
    Expect(1, 110895, '\p{ 	Kana_Ext_A}', "");
    Expect(0, 110895, '\p{^ 	Kana_Ext_A}', "");
    Expect(0, 110895, '\P{ 	Kana_Ext_A}', "");
    Expect(1, 110895, '\P{^ 	Kana_Ext_A}', "");
    Expect(0, 110896, '\p{ 	Kana_Ext_A}', "");
    Expect(1, 110896, '\p{^ 	Kana_Ext_A}', "");
    Expect(1, 110896, '\P{ 	Kana_Ext_A}', "");
    Expect(0, 110896, '\P{^ 	Kana_Ext_A}', "");
    Error('\p{-:=Is_Kana_Ext_A}');
    Error('\P{-:=Is_Kana_Ext_A}');
    Expect(1, 110895, '\p{iskanaexta}', "");
    Expect(0, 110895, '\p{^iskanaexta}', "");
    Expect(0, 110895, '\P{iskanaexta}', "");
    Expect(1, 110895, '\P{^iskanaexta}', "");
    Expect(0, 110896, '\p{iskanaexta}', "");
    Expect(1, 110896, '\p{^iskanaexta}', "");
    Expect(1, 110896, '\P{iskanaexta}', "");
    Expect(0, 110896, '\P{^iskanaexta}', "");
    Expect(1, 110895, '\p{_Is_Kana_ext_A}', "");
    Expect(0, 110895, '\p{^_Is_Kana_ext_A}', "");
    Expect(0, 110895, '\P{_Is_Kana_ext_A}', "");
    Expect(1, 110895, '\P{^_Is_Kana_ext_A}', "");
    Expect(0, 110896, '\p{_Is_Kana_ext_A}', "");
    Expect(1, 110896, '\p{^_Is_Kana_ext_A}', "");
    Expect(1, 110896, '\P{_Is_Kana_ext_A}', "");
    Expect(0, 110896, '\P{^_Is_Kana_ext_A}', "");
    Error('\p{:=in_kana_Ext_A}');
    Error('\P{:=in_kana_Ext_A}');
    Expect(1, 110895, '\p{inkanaexta}', "");
    Expect(0, 110895, '\p{^inkanaexta}', "");
    Expect(0, 110895, '\P{inkanaexta}', "");
    Expect(1, 110895, '\P{^inkanaexta}', "");
    Expect(0, 110896, '\p{inkanaexta}', "");
    Expect(1, 110896, '\p{^inkanaexta}', "");
    Expect(1, 110896, '\P{inkanaexta}', "");
    Expect(0, 110896, '\P{^inkanaexta}', "");
    Expect(1, 110895, '\p{	-In_kana_ext_A}', "");
    Expect(0, 110895, '\p{^	-In_kana_ext_A}', "");
    Expect(0, 110895, '\P{	-In_kana_ext_A}', "");
    Expect(1, 110895, '\P{^	-In_kana_ext_A}', "");
    Expect(0, 110896, '\p{	-In_kana_ext_A}', "");
    Expect(1, 110896, '\p{^	-In_kana_ext_A}', "");
    Expect(1, 110896, '\P{	-In_kana_ext_A}', "");
    Expect(0, 110896, '\P{^	-In_kana_ext_A}', "");
    Error('\p{/a/_Kana_supplement}');
    Error('\P{/a/_Kana_supplement}');
    Expect(1, 110847, '\p{kanasupplement}', "");
    Expect(0, 110847, '\p{^kanasupplement}', "");
    Expect(0, 110847, '\P{kanasupplement}', "");
    Expect(1, 110847, '\P{^kanasupplement}', "");
    Expect(0, 110848, '\p{kanasupplement}', "");
    Expect(1, 110848, '\p{^kanasupplement}', "");
    Expect(1, 110848, '\P{kanasupplement}', "");
    Expect(0, 110848, '\P{^kanasupplement}', "");
    Expect(1, 110847, '\p{-Kana_Supplement}', "");
    Expect(0, 110847, '\p{^-Kana_Supplement}', "");
    Expect(0, 110847, '\P{-Kana_Supplement}', "");
    Expect(1, 110847, '\P{^-Kana_Supplement}', "");
    Expect(0, 110848, '\p{-Kana_Supplement}', "");
    Expect(1, 110848, '\p{^-Kana_Supplement}', "");
    Expect(1, 110848, '\P{-Kana_Supplement}', "");
    Expect(0, 110848, '\P{^-Kana_Supplement}', "");
    Error('\p{_:=is_Kana_Supplement}');
    Error('\P{_:=is_Kana_Supplement}');
    Expect(1, 110847, '\p{iskanasupplement}', "");
    Expect(0, 110847, '\p{^iskanasupplement}', "");
    Expect(0, 110847, '\P{iskanasupplement}', "");
    Expect(1, 110847, '\P{^iskanasupplement}', "");
    Expect(0, 110848, '\p{iskanasupplement}', "");
    Expect(1, 110848, '\p{^iskanasupplement}', "");
    Expect(1, 110848, '\P{iskanasupplement}', "");
    Expect(0, 110848, '\P{^iskanasupplement}', "");
    Expect(1, 110847, '\p{__is_Kana_SUPPLEMENT}', "");
    Expect(0, 110847, '\p{^__is_Kana_SUPPLEMENT}', "");
    Expect(0, 110847, '\P{__is_Kana_SUPPLEMENT}', "");
    Expect(1, 110847, '\P{^__is_Kana_SUPPLEMENT}', "");
    Expect(0, 110848, '\p{__is_Kana_SUPPLEMENT}', "");
    Expect(1, 110848, '\p{^__is_Kana_SUPPLEMENT}', "");
    Expect(1, 110848, '\P{__is_Kana_SUPPLEMENT}', "");
    Expect(0, 110848, '\P{^__is_Kana_SUPPLEMENT}', "");
    Error('\p{	:=In_kana_Supplement}');
    Error('\P{	:=In_kana_Supplement}');
    Expect(1, 110847, '\p{inkanasupplement}', "");
    Expect(0, 110847, '\p{^inkanasupplement}', "");
    Expect(0, 110847, '\P{inkanasupplement}', "");
    Expect(1, 110847, '\P{^inkanasupplement}', "");
    Expect(0, 110848, '\p{inkanasupplement}', "");
    Expect(1, 110848, '\p{^inkanasupplement}', "");
    Expect(1, 110848, '\P{inkanasupplement}', "");
    Expect(0, 110848, '\P{^inkanasupplement}', "");
    Expect(1, 110847, '\p{ 	IN_KANA_Supplement}', "");
    Expect(0, 110847, '\p{^ 	IN_KANA_Supplement}', "");
    Expect(0, 110847, '\P{ 	IN_KANA_Supplement}', "");
    Expect(1, 110847, '\P{^ 	IN_KANA_Supplement}', "");
    Expect(0, 110848, '\p{ 	IN_KANA_Supplement}', "");
    Expect(1, 110848, '\p{^ 	IN_KANA_Supplement}', "");
    Expect(1, 110848, '\P{ 	IN_KANA_Supplement}', "");
    Expect(0, 110848, '\P{^ 	IN_KANA_Supplement}', "");
    Error('\p{ /a/kana_sup}');
    Error('\P{ /a/kana_sup}');
    Expect(1, 110847, '\p{kanasup}', "");
    Expect(0, 110847, '\p{^kanasup}', "");
    Expect(0, 110847, '\P{kanasup}', "");
    Expect(1, 110847, '\P{^kanasup}', "");
    Expect(0, 110848, '\p{kanasup}', "");
    Expect(1, 110848, '\p{^kanasup}', "");
    Expect(1, 110848, '\P{kanasup}', "");
    Expect(0, 110848, '\P{^kanasup}', "");
    Expect(1, 110847, '\p{_ kana_sup}', "");
    Expect(0, 110847, '\p{^_ kana_sup}', "");
    Expect(0, 110847, '\P{_ kana_sup}', "");
    Expect(1, 110847, '\P{^_ kana_sup}', "");
    Expect(0, 110848, '\p{_ kana_sup}', "");
    Expect(1, 110848, '\p{^_ kana_sup}', "");
    Expect(1, 110848, '\P{_ kana_sup}', "");
    Expect(0, 110848, '\P{^_ kana_sup}', "");
    Error('\p{		Is_Kana_Sup:=}');
    Error('\P{		Is_Kana_Sup:=}');
    Expect(1, 110847, '\p{iskanasup}', "");
    Expect(0, 110847, '\p{^iskanasup}', "");
    Expect(0, 110847, '\P{iskanasup}', "");
    Expect(1, 110847, '\P{^iskanasup}', "");
    Expect(0, 110848, '\p{iskanasup}', "");
    Expect(1, 110848, '\p{^iskanasup}', "");
    Expect(1, 110848, '\P{iskanasup}', "");
    Expect(0, 110848, '\P{^iskanasup}', "");
    Expect(1, 110847, '\p{__Is_Kana_Sup}', "");
    Expect(0, 110847, '\p{^__Is_Kana_Sup}', "");
    Expect(0, 110847, '\P{__Is_Kana_Sup}', "");
    Expect(1, 110847, '\P{^__Is_Kana_Sup}', "");
    Expect(0, 110848, '\p{__Is_Kana_Sup}', "");
    Expect(1, 110848, '\p{^__Is_Kana_Sup}', "");
    Expect(1, 110848, '\P{__Is_Kana_Sup}', "");
    Expect(0, 110848, '\P{^__Is_Kana_Sup}', "");
    Error('\p{-:=in_Kana_sup}');
    Error('\P{-:=in_Kana_sup}');
    Expect(1, 110847, '\p{inkanasup}', "");
    Expect(0, 110847, '\p{^inkanasup}', "");
    Expect(0, 110847, '\P{inkanasup}', "");
    Expect(1, 110847, '\P{^inkanasup}', "");
    Expect(0, 110848, '\p{inkanasup}', "");
    Expect(1, 110848, '\p{^inkanasup}', "");
    Expect(1, 110848, '\P{inkanasup}', "");
    Expect(0, 110848, '\P{^inkanasup}', "");
    Expect(1, 110847, '\p{IN_KANA_Sup}', "");
    Expect(0, 110847, '\p{^IN_KANA_Sup}', "");
    Expect(0, 110847, '\P{IN_KANA_Sup}', "");
    Expect(1, 110847, '\P{^IN_KANA_Sup}', "");
    Expect(0, 110848, '\p{IN_KANA_Sup}', "");
    Expect(1, 110848, '\p{^IN_KANA_Sup}', "");
    Expect(1, 110848, '\P{IN_KANA_Sup}', "");
    Expect(0, 110848, '\P{^IN_KANA_Sup}', "");
    Error('\p{/a/ -Kanbun}');
    Error('\P{/a/ -Kanbun}');
    Expect(1, 12703, '\p{kanbun}', "");
    Expect(0, 12703, '\p{^kanbun}', "");
    Expect(0, 12703, '\P{kanbun}', "");
    Expect(1, 12703, '\P{^kanbun}', "");
    Expect(0, 12704, '\p{kanbun}', "");
    Expect(1, 12704, '\p{^kanbun}', "");
    Expect(1, 12704, '\P{kanbun}', "");
    Expect(0, 12704, '\P{^kanbun}', "");
    Expect(1, 12703, '\p{		kanbun}', "");
    Expect(0, 12703, '\p{^		kanbun}', "");
    Expect(0, 12703, '\P{		kanbun}', "");
    Expect(1, 12703, '\P{^		kanbun}', "");
    Expect(0, 12704, '\p{		kanbun}', "");
    Expect(1, 12704, '\p{^		kanbun}', "");
    Expect(1, 12704, '\P{		kanbun}', "");
    Expect(0, 12704, '\P{^		kanbun}', "");
    Error('\p{	:=Is_KANBUN}');
    Error('\P{	:=Is_KANBUN}');
    Expect(1, 12703, '\p{iskanbun}', "");
    Expect(0, 12703, '\p{^iskanbun}', "");
    Expect(0, 12703, '\P{iskanbun}', "");
    Expect(1, 12703, '\P{^iskanbun}', "");
    Expect(0, 12704, '\p{iskanbun}', "");
    Expect(1, 12704, '\p{^iskanbun}', "");
    Expect(1, 12704, '\P{iskanbun}', "");
    Expect(0, 12704, '\P{^iskanbun}', "");
    Expect(1, 12703, '\p{-IS_Kanbun}', "");
    Expect(0, 12703, '\p{^-IS_Kanbun}', "");
    Expect(0, 12703, '\P{-IS_Kanbun}', "");
    Expect(1, 12703, '\P{^-IS_Kanbun}', "");
    Expect(0, 12704, '\p{-IS_Kanbun}', "");
    Expect(1, 12704, '\p{^-IS_Kanbun}', "");
    Expect(1, 12704, '\P{-IS_Kanbun}', "");
    Expect(0, 12704, '\P{^-IS_Kanbun}', "");
    Error('\p{ :=IN_kanbun}');
    Error('\P{ :=IN_kanbun}');
    Expect(1, 12703, '\p{inkanbun}', "");
    Expect(0, 12703, '\p{^inkanbun}', "");
    Expect(0, 12703, '\P{inkanbun}', "");
    Expect(1, 12703, '\P{^inkanbun}', "");
    Expect(0, 12704, '\p{inkanbun}', "");
    Expect(1, 12704, '\p{^inkanbun}', "");
    Expect(1, 12704, '\P{inkanbun}', "");
    Expect(0, 12704, '\P{^inkanbun}', "");
    Expect(1, 12703, '\p{	-IN_Kanbun}', "");
    Expect(0, 12703, '\p{^	-IN_Kanbun}', "");
    Expect(0, 12703, '\P{	-IN_Kanbun}', "");
    Expect(1, 12703, '\P{^	-IN_Kanbun}', "");
    Expect(0, 12704, '\p{	-IN_Kanbun}', "");
    Expect(1, 12704, '\p{^	-IN_Kanbun}', "");
    Expect(1, 12704, '\P{	-IN_Kanbun}', "");
    Expect(0, 12704, '\P{^	-IN_Kanbun}', "");
    Error('\p{:=  kangxi_radicals}');
    Error('\P{:=  kangxi_radicals}');
    Expect(1, 12255, '\p{kangxiradicals}', "");
    Expect(0, 12255, '\p{^kangxiradicals}', "");
    Expect(0, 12255, '\P{kangxiradicals}', "");
    Expect(1, 12255, '\P{^kangxiradicals}', "");
    Expect(0, 12256, '\p{kangxiradicals}', "");
    Expect(1, 12256, '\p{^kangxiradicals}', "");
    Expect(1, 12256, '\P{kangxiradicals}', "");
    Expect(0, 12256, '\P{^kangxiradicals}', "");
    Expect(1, 12255, '\p{	Kangxi_Radicals}', "");
    Expect(0, 12255, '\p{^	Kangxi_Radicals}', "");
    Expect(0, 12255, '\P{	Kangxi_Radicals}', "");
    Expect(1, 12255, '\P{^	Kangxi_Radicals}', "");
    Expect(0, 12256, '\p{	Kangxi_Radicals}', "");
    Expect(1, 12256, '\p{^	Kangxi_Radicals}', "");
    Expect(1, 12256, '\P{	Kangxi_Radicals}', "");
    Expect(0, 12256, '\P{^	Kangxi_Radicals}', "");
    Error('\p{ Is_Kangxi_radicals:=}');
    Error('\P{ Is_Kangxi_radicals:=}');
    Expect(1, 12255, '\p{iskangxiradicals}', "");
    Expect(0, 12255, '\p{^iskangxiradicals}', "");
    Expect(0, 12255, '\P{iskangxiradicals}', "");
    Expect(1, 12255, '\P{^iskangxiradicals}', "");
    Expect(0, 12256, '\p{iskangxiradicals}', "");
    Expect(1, 12256, '\p{^iskangxiradicals}', "");
    Expect(1, 12256, '\P{iskangxiradicals}', "");
    Expect(0, 12256, '\P{^iskangxiradicals}', "");
    Expect(1, 12255, '\p{	Is_Kangxi_Radicals}', "");
    Expect(0, 12255, '\p{^	Is_Kangxi_Radicals}', "");
    Expect(0, 12255, '\P{	Is_Kangxi_Radicals}', "");
    Expect(1, 12255, '\P{^	Is_Kangxi_Radicals}', "");
    Expect(0, 12256, '\p{	Is_Kangxi_Radicals}', "");
    Expect(1, 12256, '\p{^	Is_Kangxi_Radicals}', "");
    Expect(1, 12256, '\P{	Is_Kangxi_Radicals}', "");
    Expect(0, 12256, '\P{^	Is_Kangxi_Radicals}', "");
    Error('\p{--IN_Kangxi_Radicals:=}');
    Error('\P{--IN_Kangxi_Radicals:=}');
    Expect(1, 12255, '\p{inkangxiradicals}', "");
    Expect(0, 12255, '\p{^inkangxiradicals}', "");
    Expect(0, 12255, '\P{inkangxiradicals}', "");
    Expect(1, 12255, '\P{^inkangxiradicals}', "");
    Expect(0, 12256, '\p{inkangxiradicals}', "");
    Expect(1, 12256, '\p{^inkangxiradicals}', "");
    Expect(1, 12256, '\P{inkangxiradicals}', "");
    Expect(0, 12256, '\P{^inkangxiradicals}', "");
    Expect(1, 12255, '\p{	in_Kangxi_RADICALS}', "");
    Expect(0, 12255, '\p{^	in_Kangxi_RADICALS}', "");
    Expect(0, 12255, '\P{	in_Kangxi_RADICALS}', "");
    Expect(1, 12255, '\P{^	in_Kangxi_RADICALS}', "");
    Expect(0, 12256, '\p{	in_Kangxi_RADICALS}', "");
    Expect(1, 12256, '\p{^	in_Kangxi_RADICALS}', "");
    Expect(1, 12256, '\P{	in_Kangxi_RADICALS}', "");
    Expect(0, 12256, '\P{^	in_Kangxi_RADICALS}', "");
    Error('\p{ :=Kangxi}');
    Error('\P{ :=Kangxi}');
    Expect(1, 12255, '\p{kangxi}', "");
    Expect(0, 12255, '\p{^kangxi}', "");
    Expect(0, 12255, '\P{kangxi}', "");
    Expect(1, 12255, '\P{^kangxi}', "");
    Expect(0, 12256, '\p{kangxi}', "");
    Expect(1, 12256, '\p{^kangxi}', "");
    Expect(1, 12256, '\P{kangxi}', "");
    Expect(0, 12256, '\P{^kangxi}', "");
    Expect(1, 12255, '\p{ Kangxi}', "");
    Expect(0, 12255, '\p{^ Kangxi}', "");
    Expect(0, 12255, '\P{ Kangxi}', "");
    Expect(1, 12255, '\P{^ Kangxi}', "");
    Expect(0, 12256, '\p{ Kangxi}', "");
    Expect(1, 12256, '\p{^ Kangxi}', "");
    Expect(1, 12256, '\P{ Kangxi}', "");
    Expect(0, 12256, '\P{^ Kangxi}', "");
    Error('\p{/a/- IS_kangxi}');
    Error('\P{/a/- IS_kangxi}');
    Expect(1, 12255, '\p{iskangxi}', "");
    Expect(0, 12255, '\p{^iskangxi}', "");
    Expect(0, 12255, '\P{iskangxi}', "");
    Expect(1, 12255, '\P{^iskangxi}', "");
    Expect(0, 12256, '\p{iskangxi}', "");
    Expect(1, 12256, '\p{^iskangxi}', "");
    Expect(1, 12256, '\P{iskangxi}', "");
    Expect(0, 12256, '\P{^iskangxi}', "");
    Expect(1, 12255, '\p{_ Is_kangxi}', "");
    Expect(0, 12255, '\p{^_ Is_kangxi}', "");
    Expect(0, 12255, '\P{_ Is_kangxi}', "");
    Expect(1, 12255, '\P{^_ Is_kangxi}', "");
    Expect(0, 12256, '\p{_ Is_kangxi}', "");
    Expect(1, 12256, '\p{^_ Is_kangxi}', "");
    Expect(1, 12256, '\P{_ Is_kangxi}', "");
    Expect(0, 12256, '\P{^_ Is_kangxi}', "");
    Error('\p{/a/IN_Kangxi}');
    Error('\P{/a/IN_Kangxi}');
    Expect(1, 12255, '\p{inkangxi}', "");
    Expect(0, 12255, '\p{^inkangxi}', "");
    Expect(0, 12255, '\P{inkangxi}', "");
    Expect(1, 12255, '\P{^inkangxi}', "");
    Expect(0, 12256, '\p{inkangxi}', "");
    Expect(1, 12256, '\p{^inkangxi}', "");
    Expect(1, 12256, '\P{inkangxi}', "");
    Expect(0, 12256, '\P{^inkangxi}', "");
    Expect(1, 12255, '\p{	In_kangxi}', "");
    Expect(0, 12255, '\p{^	In_kangxi}', "");
    Expect(0, 12255, '\P{	In_kangxi}', "");
    Expect(1, 12255, '\P{^	In_kangxi}', "");
    Expect(0, 12256, '\p{	In_kangxi}', "");
    Expect(1, 12256, '\p{^	In_kangxi}', "");
    Expect(1, 12256, '\P{	In_kangxi}', "");
    Expect(0, 12256, '\P{^	In_kangxi}', "");
    Error('\p{/a/_-KANNADA}');
    Error('\P{/a/_-KANNADA}');
    Expect(1, 43061, '\p{kannada}', "");
    Expect(0, 43061, '\p{^kannada}', "");
    Expect(0, 43061, '\P{kannada}', "");
    Expect(1, 43061, '\P{^kannada}', "");
    Expect(0, 43062, '\p{kannada}', "");
    Expect(1, 43062, '\p{^kannada}', "");
    Expect(1, 43062, '\P{kannada}', "");
    Expect(0, 43062, '\P{^kannada}', "");
    Expect(1, 43061, '\p{_Kannada}', "");
    Expect(0, 43061, '\p{^_Kannada}', "");
    Expect(0, 43061, '\P{_Kannada}', "");
    Expect(1, 43061, '\P{^_Kannada}', "");
    Expect(0, 43062, '\p{_Kannada}', "");
    Expect(1, 43062, '\p{^_Kannada}', "");
    Expect(1, 43062, '\P{_Kannada}', "");
    Expect(0, 43062, '\P{^_Kannada}', "");
    Error('\p{:= Is_KANNADA}');
    Error('\P{:= Is_KANNADA}');
    Expect(1, 43061, '\p{iskannada}', "");
    Expect(0, 43061, '\p{^iskannada}', "");
    Expect(0, 43061, '\P{iskannada}', "");
    Expect(1, 43061, '\P{^iskannada}', "");
    Expect(0, 43062, '\p{iskannada}', "");
    Expect(1, 43062, '\p{^iskannada}', "");
    Expect(1, 43062, '\P{iskannada}', "");
    Expect(0, 43062, '\P{^iskannada}', "");
    Expect(1, 43061, '\p{_Is_Kannada}', "");
    Expect(0, 43061, '\p{^_Is_Kannada}', "");
    Expect(0, 43061, '\P{_Is_Kannada}', "");
    Expect(1, 43061, '\P{^_Is_Kannada}', "");
    Expect(0, 43062, '\p{_Is_Kannada}', "");
    Expect(1, 43062, '\p{^_Is_Kannada}', "");
    Expect(1, 43062, '\P{_Is_Kannada}', "");
    Expect(0, 43062, '\P{^_Is_Kannada}', "");
    Error('\p{_-Knda/a/}');
    Error('\P{_-Knda/a/}');
    Expect(1, 43061, '\p{knda}', "");
    Expect(0, 43061, '\p{^knda}', "");
    Expect(0, 43061, '\P{knda}', "");
    Expect(1, 43061, '\P{^knda}', "");
    Expect(0, 43062, '\p{knda}', "");
    Expect(1, 43062, '\p{^knda}', "");
    Expect(1, 43062, '\P{knda}', "");
    Expect(0, 43062, '\P{^knda}', "");
    Expect(1, 43061, '\p{--knda}', "");
    Expect(0, 43061, '\p{^--knda}', "");
    Expect(0, 43061, '\P{--knda}', "");
    Expect(1, 43061, '\P{^--knda}', "");
    Expect(0, 43062, '\p{--knda}', "");
    Expect(1, 43062, '\p{^--knda}', "");
    Expect(1, 43062, '\P{--knda}', "");
    Expect(0, 43062, '\P{^--knda}', "");
    Error('\p{  Is_Knda:=}');
    Error('\P{  Is_Knda:=}');
    Expect(1, 43061, '\p{isknda}', "");
    Expect(0, 43061, '\p{^isknda}', "");
    Expect(0, 43061, '\P{isknda}', "");
    Expect(1, 43061, '\P{^isknda}', "");
    Expect(0, 43062, '\p{isknda}', "");
    Expect(1, 43062, '\p{^isknda}', "");
    Expect(1, 43062, '\P{isknda}', "");
    Expect(0, 43062, '\P{^isknda}', "");
    Expect(1, 43061, '\p{	 IS_knda}', "");
    Expect(0, 43061, '\p{^	 IS_knda}', "");
    Expect(0, 43061, '\P{	 IS_knda}', "");
    Expect(1, 43061, '\P{^	 IS_knda}', "");
    Expect(0, 43062, '\p{	 IS_knda}', "");
    Expect(1, 43062, '\p{^	 IS_knda}', "");
    Expect(1, 43062, '\P{	 IS_knda}', "");
    Expect(0, 43062, '\P{^	 IS_knda}', "");
    Error('\p{ :=Katakana}');
    Error('\P{ :=Katakana}');
    Expect(1, 110951, '\p{katakana}', "");
    Expect(0, 110951, '\p{^katakana}', "");
    Expect(0, 110951, '\P{katakana}', "");
    Expect(1, 110951, '\P{^katakana}', "");
    Expect(0, 110952, '\p{katakana}', "");
    Expect(1, 110952, '\p{^katakana}', "");
    Expect(1, 110952, '\P{katakana}', "");
    Expect(0, 110952, '\P{^katakana}', "");
    Expect(1, 110951, '\p{-katakana}', "");
    Expect(0, 110951, '\p{^-katakana}', "");
    Expect(0, 110951, '\P{-katakana}', "");
    Expect(1, 110951, '\P{^-katakana}', "");
    Expect(0, 110952, '\p{-katakana}', "");
    Expect(1, 110952, '\p{^-katakana}', "");
    Expect(1, 110952, '\P{-katakana}', "");
    Expect(0, 110952, '\P{^-katakana}', "");
    Error('\p{ :=Is_Katakana}');
    Error('\P{ :=Is_Katakana}');
    Expect(1, 110951, '\p{iskatakana}', "");
    Expect(0, 110951, '\p{^iskatakana}', "");
    Expect(0, 110951, '\P{iskatakana}', "");
    Expect(1, 110951, '\P{^iskatakana}', "");
    Expect(0, 110952, '\p{iskatakana}', "");
    Expect(1, 110952, '\p{^iskatakana}', "");
    Expect(1, 110952, '\P{iskatakana}', "");
    Expect(0, 110952, '\P{^iskatakana}', "");
    Expect(1, 110951, '\p{-	IS_Katakana}', "");
    Expect(0, 110951, '\p{^-	IS_Katakana}', "");
    Expect(0, 110951, '\P{-	IS_Katakana}', "");
    Expect(1, 110951, '\P{^-	IS_Katakana}', "");
    Expect(0, 110952, '\p{-	IS_Katakana}', "");
    Expect(1, 110952, '\p{^-	IS_Katakana}', "");
    Expect(1, 110952, '\P{-	IS_Katakana}', "");
    Expect(0, 110952, '\P{^-	IS_Katakana}', "");
    Error('\p{/a/kana}');
    Error('\P{/a/kana}');
    Expect(1, 110951, '\p{kana}', "");
    Expect(0, 110951, '\p{^kana}', "");
    Expect(0, 110951, '\P{kana}', "");
    Expect(1, 110951, '\P{^kana}', "");
    Expect(0, 110952, '\p{kana}', "");
    Expect(1, 110952, '\p{^kana}', "");
    Expect(1, 110952, '\P{kana}', "");
    Expect(0, 110952, '\P{^kana}', "");
    Expect(1, 110951, '\p{-KANA}', "");
    Expect(0, 110951, '\p{^-KANA}', "");
    Expect(0, 110951, '\P{-KANA}', "");
    Expect(1, 110951, '\P{^-KANA}', "");
    Expect(0, 110952, '\p{-KANA}', "");
    Expect(1, 110952, '\p{^-KANA}', "");
    Expect(1, 110952, '\P{-KANA}', "");
    Expect(0, 110952, '\P{^-KANA}', "");
    Error('\p{ :=Is_Kana}');
    Error('\P{ :=Is_Kana}');
    Expect(1, 110951, '\p{iskana}', "");
    Expect(0, 110951, '\p{^iskana}', "");
    Expect(0, 110951, '\P{iskana}', "");
    Expect(1, 110951, '\P{^iskana}', "");
    Expect(0, 110952, '\p{iskana}', "");
    Expect(1, 110952, '\p{^iskana}', "");
    Expect(1, 110952, '\P{iskana}', "");
    Expect(0, 110952, '\P{^iskana}', "");
    Expect(1, 110951, '\p{--IS_Kana}', "");
    Expect(0, 110951, '\p{^--IS_Kana}', "");
    Expect(0, 110951, '\P{--IS_Kana}', "");
    Expect(1, 110951, '\P{^--IS_Kana}', "");
    Expect(0, 110952, '\p{--IS_Kana}', "");
    Expect(1, 110952, '\p{^--IS_Kana}', "");
    Expect(1, 110952, '\P{--IS_Kana}', "");
    Expect(0, 110952, '\P{^--IS_Kana}', "");
    Error('\p{Katakana_Or_Hiragana}');
    Error('\P{Katakana_Or_Hiragana}');
    Error('\p{Hrkt}');
    Error('\P{Hrkt}');
    Error('\p{_Katakana_PHONETIC_extensions/a/}');
    Error('\P{_Katakana_PHONETIC_extensions/a/}');
    Expect(1, 12799, '\p{katakanaphoneticextensions}', "");
    Expect(0, 12799, '\p{^katakanaphoneticextensions}', "");
    Expect(0, 12799, '\P{katakanaphoneticextensions}', "");
    Expect(1, 12799, '\P{^katakanaphoneticextensions}', "");
    Expect(0, 12800, '\p{katakanaphoneticextensions}', "");
    Expect(1, 12800, '\p{^katakanaphoneticextensions}', "");
    Expect(1, 12800, '\P{katakanaphoneticextensions}', "");
    Expect(0, 12800, '\P{^katakanaphoneticextensions}', "");
    Expect(1, 12799, '\p{ Katakana_Phonetic_Extensions}', "");
    Expect(0, 12799, '\p{^ Katakana_Phonetic_Extensions}', "");
    Expect(0, 12799, '\P{ Katakana_Phonetic_Extensions}', "");
    Expect(1, 12799, '\P{^ Katakana_Phonetic_Extensions}', "");
    Expect(0, 12800, '\p{ Katakana_Phonetic_Extensions}', "");
    Expect(1, 12800, '\p{^ Katakana_Phonetic_Extensions}', "");
    Expect(1, 12800, '\P{ Katakana_Phonetic_Extensions}', "");
    Expect(0, 12800, '\P{^ Katakana_Phonetic_Extensions}', "");
    Error('\p{_ IS_KATAKANA_Phonetic_Extensions:=}');
    Error('\P{_ IS_KATAKANA_Phonetic_Extensions:=}');
    Expect(1, 12799, '\p{iskatakanaphoneticextensions}', "");
    Expect(0, 12799, '\p{^iskatakanaphoneticextensions}', "");
    Expect(0, 12799, '\P{iskatakanaphoneticextensions}', "");
    Expect(1, 12799, '\P{^iskatakanaphoneticextensions}', "");
    Expect(0, 12800, '\p{iskatakanaphoneticextensions}', "");
    Expect(1, 12800, '\p{^iskatakanaphoneticextensions}', "");
    Expect(1, 12800, '\P{iskatakanaphoneticextensions}', "");
    Expect(0, 12800, '\P{^iskatakanaphoneticextensions}', "");
    Expect(1, 12799, '\p{Is_Katakana_phonetic_EXTENSIONS}', "");
    Expect(0, 12799, '\p{^Is_Katakana_phonetic_EXTENSIONS}', "");
    Expect(0, 12799, '\P{Is_Katakana_phonetic_EXTENSIONS}', "");
    Expect(1, 12799, '\P{^Is_Katakana_phonetic_EXTENSIONS}', "");
    Expect(0, 12800, '\p{Is_Katakana_phonetic_EXTENSIONS}', "");
    Expect(1, 12800, '\p{^Is_Katakana_phonetic_EXTENSIONS}', "");
    Expect(1, 12800, '\P{Is_Katakana_phonetic_EXTENSIONS}', "");
    Expect(0, 12800, '\P{^Is_Katakana_phonetic_EXTENSIONS}', "");
    Error('\p{/a/-IN_katakana_phonetic_EXTENSIONS}');
    Error('\P{/a/-IN_katakana_phonetic_EXTENSIONS}');
    Expect(1, 12799, '\p{inkatakanaphoneticextensions}', "");
    Expect(0, 12799, '\p{^inkatakanaphoneticextensions}', "");
    Expect(0, 12799, '\P{inkatakanaphoneticextensions}', "");
    Expect(1, 12799, '\P{^inkatakanaphoneticextensions}', "");
    Expect(0, 12800, '\p{inkatakanaphoneticextensions}', "");
    Expect(1, 12800, '\p{^inkatakanaphoneticextensions}', "");
    Expect(1, 12800, '\P{inkatakanaphoneticextensions}', "");
    Expect(0, 12800, '\P{^inkatakanaphoneticextensions}', "");
    Expect(1, 12799, '\p{_IN_katakana_Phonetic_Extensions}', "");
    Expect(0, 12799, '\p{^_IN_katakana_Phonetic_Extensions}', "");
    Expect(0, 12799, '\P{_IN_katakana_Phonetic_Extensions}', "");
    Expect(1, 12799, '\P{^_IN_katakana_Phonetic_Extensions}', "");
    Expect(0, 12800, '\p{_IN_katakana_Phonetic_Extensions}', "");
    Expect(1, 12800, '\p{^_IN_katakana_Phonetic_Extensions}', "");
    Expect(1, 12800, '\P{_IN_katakana_Phonetic_Extensions}', "");
    Expect(0, 12800, '\P{^_IN_katakana_Phonetic_Extensions}', "");
    Error('\p{ /a/katakana_Ext}');
    Error('\P{ /a/katakana_Ext}');
    Expect(1, 12799, '\p{katakanaext}', "");
    Expect(0, 12799, '\p{^katakanaext}', "");
    Expect(0, 12799, '\P{katakanaext}', "");
    Expect(1, 12799, '\P{^katakanaext}', "");
    Expect(0, 12800, '\p{katakanaext}', "");
    Expect(1, 12800, '\p{^katakanaext}', "");
    Expect(1, 12800, '\P{katakanaext}', "");
    Expect(0, 12800, '\P{^katakanaext}', "");
    Expect(1, 12799, '\p{ 	KATAKANA_EXT}', "");
    Expect(0, 12799, '\p{^ 	KATAKANA_EXT}', "");
    Expect(0, 12799, '\P{ 	KATAKANA_EXT}', "");
    Expect(1, 12799, '\P{^ 	KATAKANA_EXT}', "");
    Expect(0, 12800, '\p{ 	KATAKANA_EXT}', "");
    Expect(1, 12800, '\p{^ 	KATAKANA_EXT}', "");
    Expect(1, 12800, '\P{ 	KATAKANA_EXT}', "");
    Expect(0, 12800, '\P{^ 	KATAKANA_EXT}', "");
    Error('\p{ is_Katakana_ext/a/}');
    Error('\P{ is_Katakana_ext/a/}');
    Expect(1, 12799, '\p{iskatakanaext}', "");
    Expect(0, 12799, '\p{^iskatakanaext}', "");
    Expect(0, 12799, '\P{iskatakanaext}', "");
    Expect(1, 12799, '\P{^iskatakanaext}', "");
    Expect(0, 12800, '\p{iskatakanaext}', "");
    Expect(1, 12800, '\p{^iskatakanaext}', "");
    Expect(1, 12800, '\P{iskatakanaext}', "");
    Expect(0, 12800, '\P{^iskatakanaext}', "");
    Expect(1, 12799, '\p{_ Is_Katakana_EXT}', "");
    Expect(0, 12799, '\p{^_ Is_Katakana_EXT}', "");
    Expect(0, 12799, '\P{_ Is_Katakana_EXT}', "");
    Expect(1, 12799, '\P{^_ Is_Katakana_EXT}', "");
    Expect(0, 12800, '\p{_ Is_Katakana_EXT}', "");
    Expect(1, 12800, '\p{^_ Is_Katakana_EXT}', "");
    Expect(1, 12800, '\P{_ Is_Katakana_EXT}', "");
    Expect(0, 12800, '\P{^_ Is_Katakana_EXT}', "");
    Error('\p{/a/__In_Katakana_Ext}');
    Error('\P{/a/__In_Katakana_Ext}');
    Expect(1, 12799, '\p{inkatakanaext}', "");
    Expect(0, 12799, '\p{^inkatakanaext}', "");
    Expect(0, 12799, '\P{inkatakanaext}', "");
    Expect(1, 12799, '\P{^inkatakanaext}', "");
    Expect(0, 12800, '\p{inkatakanaext}', "");
    Expect(1, 12800, '\p{^inkatakanaext}', "");
    Expect(1, 12800, '\P{inkatakanaext}', "");
    Expect(0, 12800, '\P{^inkatakanaext}', "");
    Expect(1, 12799, '\p{	in_Katakana_Ext}', "");
    Expect(0, 12799, '\p{^	in_Katakana_Ext}', "");
    Expect(0, 12799, '\P{	in_Katakana_Ext}', "");
    Expect(1, 12799, '\P{^	in_Katakana_Ext}', "");
    Expect(0, 12800, '\p{	in_Katakana_Ext}', "");
    Expect(1, 12800, '\p{^	in_Katakana_Ext}', "");
    Expect(1, 12800, '\P{	in_Katakana_Ext}', "");
    Expect(0, 12800, '\P{^	in_Katakana_Ext}', "");
    Error('\p{-/a/Kayah_Li}');
    Error('\P{-/a/Kayah_Li}');
    Expect(1, 43311, '\p{kayahli}', "");
    Expect(0, 43311, '\p{^kayahli}', "");
    Expect(0, 43311, '\P{kayahli}', "");
    Expect(1, 43311, '\P{^kayahli}', "");
    Expect(0, 43312, '\p{kayahli}', "");
    Expect(1, 43312, '\p{^kayahli}', "");
    Expect(1, 43312, '\P{kayahli}', "");
    Expect(0, 43312, '\P{^kayahli}', "");
    Expect(1, 43311, '\p{ 	Kayah_Li}', "");
    Expect(0, 43311, '\p{^ 	Kayah_Li}', "");
    Expect(0, 43311, '\P{ 	Kayah_Li}', "");
    Expect(1, 43311, '\P{^ 	Kayah_Li}', "");
    Expect(0, 43312, '\p{ 	Kayah_Li}', "");
    Expect(1, 43312, '\p{^ 	Kayah_Li}', "");
    Expect(1, 43312, '\P{ 	Kayah_Li}', "");
    Expect(0, 43312, '\P{^ 	Kayah_Li}', "");
    Error('\p{:=  Is_KAYAH_LI}');
    Error('\P{:=  Is_KAYAH_LI}');
    Expect(1, 43311, '\p{iskayahli}', "");
    Expect(0, 43311, '\p{^iskayahli}', "");
    Expect(0, 43311, '\P{iskayahli}', "");
    Expect(1, 43311, '\P{^iskayahli}', "");
    Expect(0, 43312, '\p{iskayahli}', "");
    Expect(1, 43312, '\p{^iskayahli}', "");
    Expect(1, 43312, '\P{iskayahli}', "");
    Expect(0, 43312, '\P{^iskayahli}', "");
    Expect(1, 43311, '\p{-	is_kayah_li}', "");
    Expect(0, 43311, '\p{^-	is_kayah_li}', "");
    Expect(0, 43311, '\P{-	is_kayah_li}', "");
    Expect(1, 43311, '\P{^-	is_kayah_li}', "");
    Expect(0, 43312, '\p{-	is_kayah_li}', "");
    Expect(1, 43312, '\p{^-	is_kayah_li}', "");
    Expect(1, 43312, '\P{-	is_kayah_li}', "");
    Expect(0, 43312, '\P{^-	is_kayah_li}', "");
    Error('\p{:= _Kali}');
    Error('\P{:= _Kali}');
    Expect(1, 43311, '\p{kali}', "");
    Expect(0, 43311, '\p{^kali}', "");
    Expect(0, 43311, '\P{kali}', "");
    Expect(1, 43311, '\P{^kali}', "");
    Expect(0, 43312, '\p{kali}', "");
    Expect(1, 43312, '\p{^kali}', "");
    Expect(1, 43312, '\P{kali}', "");
    Expect(0, 43312, '\P{^kali}', "");
    Expect(1, 43311, '\p{ -kali}', "");
    Expect(0, 43311, '\p{^ -kali}', "");
    Expect(0, 43311, '\P{ -kali}', "");
    Expect(1, 43311, '\P{^ -kali}', "");
    Expect(0, 43312, '\p{ -kali}', "");
    Expect(1, 43312, '\p{^ -kali}', "");
    Expect(1, 43312, '\P{ -kali}', "");
    Expect(0, 43312, '\P{^ -kali}', "");
    Error('\p{_Is_KALI:=}');
    Error('\P{_Is_KALI:=}');
    Expect(1, 43311, '\p{iskali}', "");
    Expect(0, 43311, '\p{^iskali}', "");
    Expect(0, 43311, '\P{iskali}', "");
    Expect(1, 43311, '\P{^iskali}', "");
    Expect(0, 43312, '\p{iskali}', "");
    Expect(1, 43312, '\p{^iskali}', "");
    Expect(1, 43312, '\P{iskali}', "");
    Expect(0, 43312, '\P{^iskali}', "");
    Expect(1, 43311, '\p{ Is_KALI}', "");
    Expect(0, 43311, '\p{^ Is_KALI}', "");
    Expect(0, 43311, '\P{ Is_KALI}', "");
    Expect(1, 43311, '\P{^ Is_KALI}', "");
    Expect(0, 43312, '\p{ Is_KALI}', "");
    Expect(1, 43312, '\p{^ Is_KALI}', "");
    Expect(1, 43312, '\P{ Is_KALI}', "");
    Expect(0, 43312, '\P{^ Is_KALI}', "");
    Error('\p{_kharoshthi:=}');
    Error('\P{_kharoshthi:=}');
    Expect(1, 68184, '\p{kharoshthi}', "");
    Expect(0, 68184, '\p{^kharoshthi}', "");
    Expect(0, 68184, '\P{kharoshthi}', "");
    Expect(1, 68184, '\P{^kharoshthi}', "");
    Expect(0, 68185, '\p{kharoshthi}', "");
    Expect(1, 68185, '\p{^kharoshthi}', "");
    Expect(1, 68185, '\P{kharoshthi}', "");
    Expect(0, 68185, '\P{^kharoshthi}', "");
    Expect(1, 68184, '\p{ 	kharoshthi}', "");
    Expect(0, 68184, '\p{^ 	kharoshthi}', "");
    Expect(0, 68184, '\P{ 	kharoshthi}', "");
    Expect(1, 68184, '\P{^ 	kharoshthi}', "");
    Expect(0, 68185, '\p{ 	kharoshthi}', "");
    Expect(1, 68185, '\p{^ 	kharoshthi}', "");
    Expect(1, 68185, '\P{ 	kharoshthi}', "");
    Expect(0, 68185, '\P{^ 	kharoshthi}', "");
    Error('\p{:=-_Is_kharoshthi}');
    Error('\P{:=-_Is_kharoshthi}');
    Expect(1, 68184, '\p{iskharoshthi}', "");
    Expect(0, 68184, '\p{^iskharoshthi}', "");
    Expect(0, 68184, '\P{iskharoshthi}', "");
    Expect(1, 68184, '\P{^iskharoshthi}', "");
    Expect(0, 68185, '\p{iskharoshthi}', "");
    Expect(1, 68185, '\p{^iskharoshthi}', "");
    Expect(1, 68185, '\P{iskharoshthi}', "");
    Expect(0, 68185, '\P{^iskharoshthi}', "");
    Expect(1, 68184, '\p{_ is_Kharoshthi}', "");
    Expect(0, 68184, '\p{^_ is_Kharoshthi}', "");
    Expect(0, 68184, '\P{_ is_Kharoshthi}', "");
    Expect(1, 68184, '\P{^_ is_Kharoshthi}', "");
    Expect(0, 68185, '\p{_ is_Kharoshthi}', "");
    Expect(1, 68185, '\p{^_ is_Kharoshthi}', "");
    Expect(1, 68185, '\P{_ is_Kharoshthi}', "");
    Expect(0, 68185, '\P{^_ is_Kharoshthi}', "");
    Error('\p{-:=Khar}');
    Error('\P{-:=Khar}');
    Expect(1, 68184, '\p{khar}', "");
    Expect(0, 68184, '\p{^khar}', "");
    Expect(0, 68184, '\P{khar}', "");
    Expect(1, 68184, '\P{^khar}', "");
    Expect(0, 68185, '\p{khar}', "");
    Expect(1, 68185, '\p{^khar}', "");
    Expect(1, 68185, '\P{khar}', "");
    Expect(0, 68185, '\P{^khar}', "");
    Expect(1, 68184, '\p{__Khar}', "");
    Expect(0, 68184, '\p{^__Khar}', "");
    Expect(0, 68184, '\P{__Khar}', "");
    Expect(1, 68184, '\P{^__Khar}', "");
    Expect(0, 68185, '\p{__Khar}', "");
    Expect(1, 68185, '\p{^__Khar}', "");
    Expect(1, 68185, '\P{__Khar}', "");
    Expect(0, 68185, '\P{^__Khar}', "");
    Error('\p{-/a/IS_khar}');
    Error('\P{-/a/IS_khar}');
    Expect(1, 68184, '\p{iskhar}', "");
    Expect(0, 68184, '\p{^iskhar}', "");
    Expect(0, 68184, '\P{iskhar}', "");
    Expect(1, 68184, '\P{^iskhar}', "");
    Expect(0, 68185, '\p{iskhar}', "");
    Expect(1, 68185, '\p{^iskhar}', "");
    Expect(1, 68185, '\P{iskhar}', "");
    Expect(0, 68185, '\P{^iskhar}', "");
    Expect(1, 68184, '\p{ is_khar}', "");
    Expect(0, 68184, '\p{^ is_khar}', "");
    Expect(0, 68184, '\P{ is_khar}', "");
    Expect(1, 68184, '\P{^ is_khar}', "");
    Expect(0, 68185, '\p{ is_khar}', "");
    Expect(1, 68185, '\p{^ is_khar}', "");
    Expect(1, 68185, '\P{ is_khar}', "");
    Expect(0, 68185, '\P{^ is_khar}', "");
    Error('\p{ -Khmer:=}');
    Error('\P{ -Khmer:=}');
    Expect(1, 6655, '\p{khmer}', "");
    Expect(0, 6655, '\p{^khmer}', "");
    Expect(0, 6655, '\P{khmer}', "");
    Expect(1, 6655, '\P{^khmer}', "");
    Expect(0, 6656, '\p{khmer}', "");
    Expect(1, 6656, '\p{^khmer}', "");
    Expect(1, 6656, '\P{khmer}', "");
    Expect(0, 6656, '\P{^khmer}', "");
    Expect(1, 6655, '\p{-Khmer}', "");
    Expect(0, 6655, '\p{^-Khmer}', "");
    Expect(0, 6655, '\P{-Khmer}', "");
    Expect(1, 6655, '\P{^-Khmer}', "");
    Expect(0, 6656, '\p{-Khmer}', "");
    Expect(1, 6656, '\p{^-Khmer}', "");
    Expect(1, 6656, '\P{-Khmer}', "");
    Expect(0, 6656, '\P{^-Khmer}', "");
    Error('\p{:=_	Is_KHMER}');
    Error('\P{:=_	Is_KHMER}');
    Expect(1, 6655, '\p{iskhmer}', "");
    Expect(0, 6655, '\p{^iskhmer}', "");
    Expect(0, 6655, '\P{iskhmer}', "");
    Expect(1, 6655, '\P{^iskhmer}', "");
    Expect(0, 6656, '\p{iskhmer}', "");
    Expect(1, 6656, '\p{^iskhmer}', "");
    Expect(1, 6656, '\P{iskhmer}', "");
    Expect(0, 6656, '\P{^iskhmer}', "");
    Expect(1, 6655, '\p{	_is_Khmer}', "");
    Expect(0, 6655, '\p{^	_is_Khmer}', "");
    Expect(0, 6655, '\P{	_is_Khmer}', "");
    Expect(1, 6655, '\P{^	_is_Khmer}', "");
    Expect(0, 6656, '\p{	_is_Khmer}', "");
    Expect(1, 6656, '\p{^	_is_Khmer}', "");
    Expect(1, 6656, '\P{	_is_Khmer}', "");
    Expect(0, 6656, '\P{^	_is_Khmer}', "");
    Error('\p{		Khmr/a/}');
    Error('\P{		Khmr/a/}');
    Expect(1, 6655, '\p{khmr}', "");
    Expect(0, 6655, '\p{^khmr}', "");
    Expect(0, 6655, '\P{khmr}', "");
    Expect(1, 6655, '\P{^khmr}', "");
    Expect(0, 6656, '\p{khmr}', "");
    Expect(1, 6656, '\p{^khmr}', "");
    Expect(1, 6656, '\P{khmr}', "");
    Expect(0, 6656, '\P{^khmr}', "");
    Expect(1, 6655, '\p{-khmr}', "");
    Expect(0, 6655, '\p{^-khmr}', "");
    Expect(0, 6655, '\P{-khmr}', "");
    Expect(1, 6655, '\P{^-khmr}', "");
    Expect(0, 6656, '\p{-khmr}', "");
    Expect(1, 6656, '\p{^-khmr}', "");
    Expect(1, 6656, '\P{-khmr}', "");
    Expect(0, 6656, '\P{^-khmr}', "");
    Error('\p{	-is_Khmr:=}');
    Error('\P{	-is_Khmr:=}');
    Expect(1, 6655, '\p{iskhmr}', "");
    Expect(0, 6655, '\p{^iskhmr}', "");
    Expect(0, 6655, '\P{iskhmr}', "");
    Expect(1, 6655, '\P{^iskhmr}', "");
    Expect(0, 6656, '\p{iskhmr}', "");
    Expect(1, 6656, '\p{^iskhmr}', "");
    Expect(1, 6656, '\P{iskhmr}', "");
    Expect(0, 6656, '\P{^iskhmr}', "");
    Expect(1, 6655, '\p{ Is_Khmr}', "");
    Expect(0, 6655, '\p{^ Is_Khmr}', "");
    Expect(0, 6655, '\P{ Is_Khmr}', "");
    Expect(1, 6655, '\P{^ Is_Khmr}', "");
    Expect(0, 6656, '\p{ Is_Khmr}', "");
    Expect(1, 6656, '\p{^ Is_Khmr}', "");
    Expect(1, 6656, '\P{ Is_Khmr}', "");
    Expect(0, 6656, '\P{^ Is_Khmr}', "");
    Error('\p{_	KHMER_SYMBOLS/a/}');
    Error('\P{_	KHMER_SYMBOLS/a/}');
    Expect(1, 6655, '\p{khmersymbols}', "");
    Expect(0, 6655, '\p{^khmersymbols}', "");
    Expect(0, 6655, '\P{khmersymbols}', "");
    Expect(1, 6655, '\P{^khmersymbols}', "");
    Expect(0, 6656, '\p{khmersymbols}', "");
    Expect(1, 6656, '\p{^khmersymbols}', "");
    Expect(1, 6656, '\P{khmersymbols}', "");
    Expect(0, 6656, '\P{^khmersymbols}', "");
    Expect(1, 6655, '\p{-khmer_Symbols}', "");
    Expect(0, 6655, '\p{^-khmer_Symbols}', "");
    Expect(0, 6655, '\P{-khmer_Symbols}', "");
    Expect(1, 6655, '\P{^-khmer_Symbols}', "");
    Expect(0, 6656, '\p{-khmer_Symbols}', "");
    Expect(1, 6656, '\p{^-khmer_Symbols}', "");
    Expect(1, 6656, '\P{-khmer_Symbols}', "");
    Expect(0, 6656, '\P{^-khmer_Symbols}', "");
    Error('\p{:= 	Is_Khmer_Symbols}');
    Error('\P{:= 	Is_Khmer_Symbols}');
    Expect(1, 6655, '\p{iskhmersymbols}', "");
    Expect(0, 6655, '\p{^iskhmersymbols}', "");
    Expect(0, 6655, '\P{iskhmersymbols}', "");
    Expect(1, 6655, '\P{^iskhmersymbols}', "");
    Expect(0, 6656, '\p{iskhmersymbols}', "");
    Expect(1, 6656, '\p{^iskhmersymbols}', "");
    Expect(1, 6656, '\P{iskhmersymbols}', "");
    Expect(0, 6656, '\P{^iskhmersymbols}', "");
    Expect(1, 6655, '\p{	is_khmer_SYMBOLS}', "");
    Expect(0, 6655, '\p{^	is_khmer_SYMBOLS}', "");
    Expect(0, 6655, '\P{	is_khmer_SYMBOLS}', "");
    Expect(1, 6655, '\P{^	is_khmer_SYMBOLS}', "");
    Expect(0, 6656, '\p{	is_khmer_SYMBOLS}', "");
    Expect(1, 6656, '\p{^	is_khmer_SYMBOLS}', "");
    Expect(1, 6656, '\P{	is_khmer_SYMBOLS}', "");
    Expect(0, 6656, '\P{^	is_khmer_SYMBOLS}', "");
    Error('\p{- In_Khmer_SYMBOLS:=}');
    Error('\P{- In_Khmer_SYMBOLS:=}');
    Expect(1, 6655, '\p{inkhmersymbols}', "");
    Expect(0, 6655, '\p{^inkhmersymbols}', "");
    Expect(0, 6655, '\P{inkhmersymbols}', "");
    Expect(1, 6655, '\P{^inkhmersymbols}', "");
    Expect(0, 6656, '\p{inkhmersymbols}', "");
    Expect(1, 6656, '\p{^inkhmersymbols}', "");
    Expect(1, 6656, '\P{inkhmersymbols}', "");
    Expect(0, 6656, '\P{^inkhmersymbols}', "");
    Expect(1, 6655, '\p{- In_khmer_SYMBOLS}', "");
    Expect(0, 6655, '\p{^- In_khmer_SYMBOLS}', "");
    Expect(0, 6655, '\P{- In_khmer_SYMBOLS}', "");
    Expect(1, 6655, '\P{^- In_khmer_SYMBOLS}', "");
    Expect(0, 6656, '\p{- In_khmer_SYMBOLS}', "");
    Expect(1, 6656, '\p{^- In_khmer_SYMBOLS}', "");
    Expect(1, 6656, '\P{- In_khmer_SYMBOLS}', "");
    Expect(0, 6656, '\P{^- In_khmer_SYMBOLS}', "");
    Error('\p{KHOJKI:=}');
    Error('\P{KHOJKI:=}');
    Expect(1, 70206, '\p{khojki}', "");
    Expect(0, 70206, '\p{^khojki}', "");
    Expect(0, 70206, '\P{khojki}', "");
    Expect(1, 70206, '\P{^khojki}', "");
    Expect(0, 70207, '\p{khojki}', "");
    Expect(1, 70207, '\p{^khojki}', "");
    Expect(1, 70207, '\P{khojki}', "");
    Expect(0, 70207, '\P{^khojki}', "");
    Expect(1, 70206, '\p{	-khojki}', "");
    Expect(0, 70206, '\p{^	-khojki}', "");
    Expect(0, 70206, '\P{	-khojki}', "");
    Expect(1, 70206, '\P{^	-khojki}', "");
    Expect(0, 70207, '\p{	-khojki}', "");
    Expect(1, 70207, '\p{^	-khojki}', "");
    Expect(1, 70207, '\P{	-khojki}', "");
    Expect(0, 70207, '\P{^	-khojki}', "");
    Error('\p{/a/- IS_KHOJKI}');
    Error('\P{/a/- IS_KHOJKI}');
    Expect(1, 70206, '\p{iskhojki}', "");
    Expect(0, 70206, '\p{^iskhojki}', "");
    Expect(0, 70206, '\P{iskhojki}', "");
    Expect(1, 70206, '\P{^iskhojki}', "");
    Expect(0, 70207, '\p{iskhojki}', "");
    Expect(1, 70207, '\p{^iskhojki}', "");
    Expect(1, 70207, '\P{iskhojki}', "");
    Expect(0, 70207, '\P{^iskhojki}', "");
    Expect(1, 70206, '\p{- Is_Khojki}', "");
    Expect(0, 70206, '\p{^- Is_Khojki}', "");
    Expect(0, 70206, '\P{- Is_Khojki}', "");
    Expect(1, 70206, '\P{^- Is_Khojki}', "");
    Expect(0, 70207, '\p{- Is_Khojki}', "");
    Expect(1, 70207, '\p{^- Is_Khojki}', "");
    Expect(1, 70207, '\P{- Is_Khojki}', "");
    Expect(0, 70207, '\P{^- Is_Khojki}', "");
    Error('\p{Khoj/a/}');
    Error('\P{Khoj/a/}');
    Expect(1, 70206, '\p{khoj}', "");
    Expect(0, 70206, '\p{^khoj}', "");
    Expect(0, 70206, '\P{khoj}', "");
    Expect(1, 70206, '\P{^khoj}', "");
    Expect(0, 70207, '\p{khoj}', "");
    Expect(1, 70207, '\p{^khoj}', "");
    Expect(1, 70207, '\P{khoj}', "");
    Expect(0, 70207, '\P{^khoj}', "");
    Expect(1, 70206, '\p{ -Khoj}', "");
    Expect(0, 70206, '\p{^ -Khoj}', "");
    Expect(0, 70206, '\P{ -Khoj}', "");
    Expect(1, 70206, '\P{^ -Khoj}', "");
    Expect(0, 70207, '\p{ -Khoj}', "");
    Expect(1, 70207, '\p{^ -Khoj}', "");
    Expect(1, 70207, '\P{ -Khoj}', "");
    Expect(0, 70207, '\P{^ -Khoj}', "");
    Error('\p{:=-_Is_Khoj}');
    Error('\P{:=-_Is_Khoj}');
    Expect(1, 70206, '\p{iskhoj}', "");
    Expect(0, 70206, '\p{^iskhoj}', "");
    Expect(0, 70206, '\P{iskhoj}', "");
    Expect(1, 70206, '\P{^iskhoj}', "");
    Expect(0, 70207, '\p{iskhoj}', "");
    Expect(1, 70207, '\p{^iskhoj}', "");
    Expect(1, 70207, '\P{iskhoj}', "");
    Expect(0, 70207, '\P{^iskhoj}', "");
    Expect(1, 70206, '\p{-	IS_Khoj}', "");
    Expect(0, 70206, '\p{^-	IS_Khoj}', "");
    Expect(0, 70206, '\P{-	IS_Khoj}', "");
    Expect(1, 70206, '\P{^-	IS_Khoj}', "");
    Expect(0, 70207, '\p{-	IS_Khoj}', "");
    Expect(1, 70207, '\p{^-	IS_Khoj}', "");
    Expect(1, 70207, '\P{-	IS_Khoj}', "");
    Expect(0, 70207, '\P{^-	IS_Khoj}', "");
    Error('\p{ /a/KHUDAWADI}');
    Error('\P{ /a/KHUDAWADI}');
    Expect(1, 70393, '\p{khudawadi}', "");
    Expect(0, 70393, '\p{^khudawadi}', "");
    Expect(0, 70393, '\P{khudawadi}', "");
    Expect(1, 70393, '\P{^khudawadi}', "");
    Expect(0, 70394, '\p{khudawadi}', "");
    Expect(1, 70394, '\p{^khudawadi}', "");
    Expect(1, 70394, '\P{khudawadi}', "");
    Expect(0, 70394, '\P{^khudawadi}', "");
    Expect(1, 70393, '\p{	Khudawadi}', "");
    Expect(0, 70393, '\p{^	Khudawadi}', "");
    Expect(0, 70393, '\P{	Khudawadi}', "");
    Expect(1, 70393, '\P{^	Khudawadi}', "");
    Expect(0, 70394, '\p{	Khudawadi}', "");
    Expect(1, 70394, '\p{^	Khudawadi}', "");
    Expect(1, 70394, '\P{	Khudawadi}', "");
    Expect(0, 70394, '\P{^	Khudawadi}', "");
    Error('\p{:=	Is_khudawadi}');
    Error('\P{:=	Is_khudawadi}');
    Expect(1, 70393, '\p{iskhudawadi}', "");
    Expect(0, 70393, '\p{^iskhudawadi}', "");
    Expect(0, 70393, '\P{iskhudawadi}', "");
    Expect(1, 70393, '\P{^iskhudawadi}', "");
    Expect(0, 70394, '\p{iskhudawadi}', "");
    Expect(1, 70394, '\p{^iskhudawadi}', "");
    Expect(1, 70394, '\P{iskhudawadi}', "");
    Expect(0, 70394, '\P{^iskhudawadi}', "");
    Expect(1, 70393, '\p{ Is_Khudawadi}', "");
    Expect(0, 70393, '\p{^ Is_Khudawadi}', "");
    Expect(0, 70393, '\P{ Is_Khudawadi}', "");
    Expect(1, 70393, '\P{^ Is_Khudawadi}', "");
    Expect(0, 70394, '\p{ Is_Khudawadi}', "");
    Expect(1, 70394, '\p{^ Is_Khudawadi}', "");
    Expect(1, 70394, '\P{ Is_Khudawadi}', "");
    Expect(0, 70394, '\P{^ Is_Khudawadi}', "");
    Error('\p{/a/_Sind}');
    Error('\P{/a/_Sind}');
    Expect(1, 70393, '\p{sind}', "");
    Expect(0, 70393, '\p{^sind}', "");
    Expect(0, 70393, '\P{sind}', "");
    Expect(1, 70393, '\P{^sind}', "");
    Expect(0, 70394, '\p{sind}', "");
    Expect(1, 70394, '\p{^sind}', "");
    Expect(1, 70394, '\P{sind}', "");
    Expect(0, 70394, '\P{^sind}', "");
    Expect(1, 70393, '\p{	SIND}', "");
    Expect(0, 70393, '\p{^	SIND}', "");
    Expect(0, 70393, '\P{	SIND}', "");
    Expect(1, 70393, '\P{^	SIND}', "");
    Expect(0, 70394, '\p{	SIND}', "");
    Expect(1, 70394, '\p{^	SIND}', "");
    Expect(1, 70394, '\P{	SIND}', "");
    Expect(0, 70394, '\P{^	SIND}', "");
    Error('\p{ is_sind:=}');
    Error('\P{ is_sind:=}');
    Expect(1, 70393, '\p{issind}', "");
    Expect(0, 70393, '\p{^issind}', "");
    Expect(0, 70393, '\P{issind}', "");
    Expect(1, 70393, '\P{^issind}', "");
    Expect(0, 70394, '\p{issind}', "");
    Expect(1, 70394, '\p{^issind}', "");
    Expect(1, 70394, '\P{issind}', "");
    Expect(0, 70394, '\P{^issind}', "");
    Expect(1, 70393, '\p{	IS_sind}', "");
    Expect(0, 70393, '\p{^	IS_sind}', "");
    Expect(0, 70393, '\P{	IS_sind}', "");
    Expect(1, 70393, '\P{^	IS_sind}', "");
    Expect(0, 70394, '\p{	IS_sind}', "");
    Expect(1, 70394, '\p{^	IS_sind}', "");
    Expect(1, 70394, '\P{	IS_sind}', "");
    Expect(0, 70394, '\P{^	IS_sind}', "");
    Error('\p{ /a/lao}');
    Error('\P{ /a/lao}');
    Expect(1, 3807, '\p{lao}', "");
    Expect(0, 3807, '\p{^lao}', "");
    Expect(0, 3807, '\P{lao}', "");
    Expect(1, 3807, '\P{^lao}', "");
    Expect(0, 3808, '\p{lao}', "");
    Expect(1, 3808, '\p{^lao}', "");
    Expect(1, 3808, '\P{lao}', "");
    Expect(0, 3808, '\P{^lao}', "");
    Expect(1, 3807, '\p{--Lao}', "");
    Expect(0, 3807, '\p{^--Lao}', "");
    Expect(0, 3807, '\P{--Lao}', "");
    Expect(1, 3807, '\P{^--Lao}', "");
    Expect(0, 3808, '\p{--Lao}', "");
    Expect(1, 3808, '\p{^--Lao}', "");
    Expect(1, 3808, '\P{--Lao}', "");
    Expect(0, 3808, '\P{^--Lao}', "");
    Error('\p{ /a/is_Lao}');
    Error('\P{ /a/is_Lao}');
    Expect(1, 3807, '\p{islao}', "");
    Expect(0, 3807, '\p{^islao}', "");
    Expect(0, 3807, '\P{islao}', "");
    Expect(1, 3807, '\P{^islao}', "");
    Expect(0, 3808, '\p{islao}', "");
    Expect(1, 3808, '\p{^islao}', "");
    Expect(1, 3808, '\P{islao}', "");
    Expect(0, 3808, '\P{^islao}', "");
    Expect(1, 3807, '\p{Is_LAO}', "");
    Expect(0, 3807, '\p{^Is_LAO}', "");
    Expect(0, 3807, '\P{Is_LAO}', "");
    Expect(1, 3807, '\P{^Is_LAO}', "");
    Expect(0, 3808, '\p{Is_LAO}', "");
    Expect(1, 3808, '\p{^Is_LAO}', "");
    Expect(1, 3808, '\P{Is_LAO}', "");
    Expect(0, 3808, '\P{^Is_LAO}', "");
    Error('\p{/a/-Laoo}');
    Error('\P{/a/-Laoo}');
    Expect(1, 3807, '\p{laoo}', "");
    Expect(0, 3807, '\p{^laoo}', "");
    Expect(0, 3807, '\P{laoo}', "");
    Expect(1, 3807, '\P{^laoo}', "");
    Expect(0, 3808, '\p{laoo}', "");
    Expect(1, 3808, '\p{^laoo}', "");
    Expect(1, 3808, '\P{laoo}', "");
    Expect(0, 3808, '\P{^laoo}', "");
    Expect(1, 3807, '\p{__LAOO}', "");
    Expect(0, 3807, '\p{^__LAOO}', "");
    Expect(0, 3807, '\P{__LAOO}', "");
    Expect(1, 3807, '\P{^__LAOO}', "");
    Expect(0, 3808, '\p{__LAOO}', "");
    Expect(1, 3808, '\p{^__LAOO}', "");
    Expect(1, 3808, '\P{__LAOO}', "");
    Expect(0, 3808, '\P{^__LAOO}', "");
    Error('\p{-IS_laoo/a/}');
    Error('\P{-IS_laoo/a/}');
    Expect(1, 3807, '\p{islaoo}', "");
    Expect(0, 3807, '\p{^islaoo}', "");
    Expect(0, 3807, '\P{islaoo}', "");
    Expect(1, 3807, '\P{^islaoo}', "");
    Expect(0, 3808, '\p{islaoo}', "");
    Expect(1, 3808, '\p{^islaoo}', "");
    Expect(1, 3808, '\P{islaoo}', "");
    Expect(0, 3808, '\P{^islaoo}', "");
    Expect(1, 3807, '\p{- is_laoo}', "");
    Expect(0, 3807, '\p{^- is_laoo}', "");
    Expect(0, 3807, '\P{- is_laoo}', "");
    Expect(1, 3807, '\P{^- is_laoo}', "");
    Expect(0, 3808, '\p{- is_laoo}', "");
    Expect(1, 3808, '\p{^- is_laoo}', "");
    Expect(1, 3808, '\P{- is_laoo}', "");
    Expect(0, 3808, '\P{^- is_laoo}', "");
    Error('\p{__LATIN:=}');
    Error('\P{__LATIN:=}');
    Expect(1, 65370, '\p{latin}', "");
    Expect(0, 65370, '\p{^latin}', "");
    Expect(0, 65370, '\P{latin}', "");
    Expect(1, 65370, '\P{^latin}', "");
    Expect(0, 65371, '\p{latin}', "");
    Expect(1, 65371, '\p{^latin}', "");
    Expect(1, 65371, '\P{latin}', "");
    Expect(0, 65371, '\P{^latin}', "");
    Expect(1, 65370, '\p{ -LATIN}', "");
    Expect(0, 65370, '\p{^ -LATIN}', "");
    Expect(0, 65370, '\P{ -LATIN}', "");
    Expect(1, 65370, '\P{^ -LATIN}', "");
    Expect(0, 65371, '\p{ -LATIN}', "");
    Expect(1, 65371, '\p{^ -LATIN}', "");
    Expect(1, 65371, '\P{ -LATIN}', "");
    Expect(0, 65371, '\P{^ -LATIN}', "");
    Error('\p{/a/-	Is_LATIN}');
    Error('\P{/a/-	Is_LATIN}');
    Expect(1, 65370, '\p{islatin}', "");
    Expect(0, 65370, '\p{^islatin}', "");
    Expect(0, 65370, '\P{islatin}', "");
    Expect(1, 65370, '\P{^islatin}', "");
    Expect(0, 65371, '\p{islatin}', "");
    Expect(1, 65371, '\p{^islatin}', "");
    Expect(1, 65371, '\P{islatin}', "");
    Expect(0, 65371, '\P{^islatin}', "");
    Expect(1, 65370, '\p{IS_Latin}', "");
    Expect(0, 65370, '\p{^IS_Latin}', "");
    Expect(0, 65370, '\P{IS_Latin}', "");
    Expect(1, 65370, '\P{^IS_Latin}', "");
    Expect(0, 65371, '\p{IS_Latin}', "");
    Expect(1, 65371, '\p{^IS_Latin}', "");
    Expect(1, 65371, '\P{IS_Latin}', "");
    Expect(0, 65371, '\P{^IS_Latin}', "");
    Error('\p{ /a/Latn}');
    Error('\P{ /a/Latn}');
    Expect(1, 65370, '\p{latn}', "");
    Expect(0, 65370, '\p{^latn}', "");
    Expect(0, 65370, '\P{latn}', "");
    Expect(1, 65370, '\P{^latn}', "");
    Expect(0, 65371, '\p{latn}', "");
    Expect(1, 65371, '\p{^latn}', "");
    Expect(1, 65371, '\P{latn}', "");
    Expect(0, 65371, '\P{^latn}', "");
    Expect(1, 65370, '\p{ LATN}', "");
    Expect(0, 65370, '\p{^ LATN}', "");
    Expect(0, 65370, '\P{ LATN}', "");
    Expect(1, 65370, '\P{^ LATN}', "");
    Expect(0, 65371, '\p{ LATN}', "");
    Expect(1, 65371, '\p{^ LATN}', "");
    Expect(1, 65371, '\P{ LATN}', "");
    Expect(0, 65371, '\P{^ LATN}', "");
    Error('\p{/a/	_IS_Latn}');
    Error('\P{/a/	_IS_Latn}');
    Expect(1, 65370, '\p{islatn}', "");
    Expect(0, 65370, '\p{^islatn}', "");
    Expect(0, 65370, '\P{islatn}', "");
    Expect(1, 65370, '\P{^islatn}', "");
    Expect(0, 65371, '\p{islatn}', "");
    Expect(1, 65371, '\p{^islatn}', "");
    Expect(1, 65371, '\P{islatn}', "");
    Expect(0, 65371, '\P{^islatn}', "");
    Expect(1, 65370, '\p{is_Latn}', "");
    Expect(0, 65370, '\p{^is_Latn}', "");
    Expect(0, 65370, '\P{is_Latn}', "");
    Expect(1, 65370, '\P{^is_Latn}', "");
    Expect(0, 65371, '\p{is_Latn}', "");
    Expect(1, 65371, '\p{^is_Latn}', "");
    Expect(1, 65371, '\P{is_Latn}', "");
    Expect(0, 65371, '\P{^is_Latn}', "");
    Error('\p{-/a/Latin_1_Supplement}');
    Error('\P{-/a/Latin_1_Supplement}');
    Expect(1, 255, '\p{latin1supplement}', "");
    Expect(0, 255, '\p{^latin1supplement}', "");
    Expect(0, 255, '\P{latin1supplement}', "");
    Expect(1, 255, '\P{^latin1supplement}', "");
    Expect(0, 256, '\p{latin1supplement}', "");
    Expect(1, 256, '\p{^latin1supplement}', "");
    Expect(1, 256, '\P{latin1supplement}', "");
    Expect(0, 256, '\P{^latin1supplement}', "");
    Expect(1, 255, '\p{_-LATIN_1_supplement}', "");
    Expect(0, 255, '\p{^_-LATIN_1_supplement}', "");
    Expect(0, 255, '\P{_-LATIN_1_supplement}', "");
    Expect(1, 255, '\P{^_-LATIN_1_supplement}', "");
    Expect(0, 256, '\p{_-LATIN_1_supplement}', "");
    Expect(1, 256, '\p{^_-LATIN_1_supplement}', "");
    Expect(1, 256, '\P{_-LATIN_1_supplement}', "");
    Expect(0, 256, '\P{^_-LATIN_1_supplement}', "");
    Error('\p{ :=IS_Latin_1_Supplement}');
    Error('\P{ :=IS_Latin_1_Supplement}');
    Expect(1, 255, '\p{islatin1supplement}', "");
    Expect(0, 255, '\p{^islatin1supplement}', "");
    Expect(0, 255, '\P{islatin1supplement}', "");
    Expect(1, 255, '\P{^islatin1supplement}', "");
    Expect(0, 256, '\p{islatin1supplement}', "");
    Expect(1, 256, '\p{^islatin1supplement}', "");
    Expect(1, 256, '\P{islatin1supplement}', "");
    Expect(0, 256, '\P{^islatin1supplement}', "");
    Expect(1, 255, '\p{-	IS_LATIN_1_Supplement}', "");
    Expect(0, 255, '\p{^-	IS_LATIN_1_Supplement}', "");
    Expect(0, 255, '\P{-	IS_LATIN_1_Supplement}', "");
    Expect(1, 255, '\P{^-	IS_LATIN_1_Supplement}', "");
    Expect(0, 256, '\p{-	IS_LATIN_1_Supplement}', "");
    Expect(1, 256, '\p{^-	IS_LATIN_1_Supplement}', "");
    Expect(1, 256, '\P{-	IS_LATIN_1_Supplement}', "");
    Expect(0, 256, '\P{^-	IS_LATIN_1_Supplement}', "");
    Error('\p{:=In_Latin_1_Supplement}');
    Error('\P{:=In_Latin_1_Supplement}');
    Expect(1, 255, '\p{inlatin1supplement}', "");
    Expect(0, 255, '\p{^inlatin1supplement}', "");
    Expect(0, 255, '\P{inlatin1supplement}', "");
    Expect(1, 255, '\P{^inlatin1supplement}', "");
    Expect(0, 256, '\p{inlatin1supplement}', "");
    Expect(1, 256, '\p{^inlatin1supplement}', "");
    Expect(1, 256, '\P{inlatin1supplement}', "");
    Expect(0, 256, '\P{^inlatin1supplement}', "");
    Expect(1, 255, '\p{_In_LATIN_1_SUPPLEMENT}', "");
    Expect(0, 255, '\p{^_In_LATIN_1_SUPPLEMENT}', "");
    Expect(0, 255, '\P{_In_LATIN_1_SUPPLEMENT}', "");
    Expect(1, 255, '\P{^_In_LATIN_1_SUPPLEMENT}', "");
    Expect(0, 256, '\p{_In_LATIN_1_SUPPLEMENT}', "");
    Expect(1, 256, '\p{^_In_LATIN_1_SUPPLEMENT}', "");
    Expect(1, 256, '\P{_In_LATIN_1_SUPPLEMENT}', "");
    Expect(0, 256, '\P{^_In_LATIN_1_SUPPLEMENT}', "");
    Error('\p{/a/-	LATIN_1_SUP}');
    Error('\P{/a/-	LATIN_1_SUP}');
    Expect(1, 255, '\p{latin1sup}', "");
    Expect(0, 255, '\p{^latin1sup}', "");
    Expect(0, 255, '\P{latin1sup}', "");
    Expect(1, 255, '\P{^latin1sup}', "");
    Expect(0, 256, '\p{latin1sup}', "");
    Expect(1, 256, '\p{^latin1sup}', "");
    Expect(1, 256, '\P{latin1sup}', "");
    Expect(0, 256, '\P{^latin1sup}', "");
    Expect(1, 255, '\p{ _LATIN_1_SUP}', "");
    Expect(0, 255, '\p{^ _LATIN_1_SUP}', "");
    Expect(0, 255, '\P{ _LATIN_1_SUP}', "");
    Expect(1, 255, '\P{^ _LATIN_1_SUP}', "");
    Expect(0, 256, '\p{ _LATIN_1_SUP}', "");
    Expect(1, 256, '\p{^ _LATIN_1_SUP}', "");
    Expect(1, 256, '\P{ _LATIN_1_SUP}', "");
    Expect(0, 256, '\P{^ _LATIN_1_SUP}', "");
    Error('\p{-_Is_LATIN_1_SUP/a/}');
    Error('\P{-_Is_LATIN_1_SUP/a/}');
    Expect(1, 255, '\p{islatin1sup}', "");
    Expect(0, 255, '\p{^islatin1sup}', "");
    Expect(0, 255, '\P{islatin1sup}', "");
    Expect(1, 255, '\P{^islatin1sup}', "");
    Expect(0, 256, '\p{islatin1sup}', "");
    Expect(1, 256, '\p{^islatin1sup}', "");
    Expect(1, 256, '\P{islatin1sup}', "");
    Expect(0, 256, '\P{^islatin1sup}', "");
    Expect(1, 255, '\p{--Is_latin_1_sup}', "");
    Expect(0, 255, '\p{^--Is_latin_1_sup}', "");
    Expect(0, 255, '\P{--Is_latin_1_sup}', "");
    Expect(1, 255, '\P{^--Is_latin_1_sup}', "");
    Expect(0, 256, '\p{--Is_latin_1_sup}', "");
    Expect(1, 256, '\p{^--Is_latin_1_sup}', "");
    Expect(1, 256, '\P{--Is_latin_1_sup}', "");
    Expect(0, 256, '\P{^--Is_latin_1_sup}', "");
    Error('\p{/a/- In_Latin_1_Sup}');
    Error('\P{/a/- In_Latin_1_Sup}');
    Expect(1, 255, '\p{inlatin1sup}', "");
    Expect(0, 255, '\p{^inlatin1sup}', "");
    Expect(0, 255, '\P{inlatin1sup}', "");
    Expect(1, 255, '\P{^inlatin1sup}', "");
    Expect(0, 256, '\p{inlatin1sup}', "");
    Expect(1, 256, '\p{^inlatin1sup}', "");
    Expect(1, 256, '\P{inlatin1sup}', "");
    Expect(0, 256, '\P{^inlatin1sup}', "");
    Expect(1, 255, '\p{- In_Latin_1_SUP}', "");
    Expect(0, 255, '\p{^- In_Latin_1_SUP}', "");
    Expect(0, 255, '\P{- In_Latin_1_SUP}', "");
    Expect(1, 255, '\P{^- In_Latin_1_SUP}', "");
    Expect(0, 256, '\p{- In_Latin_1_SUP}', "");
    Expect(1, 256, '\p{^- In_Latin_1_SUP}', "");
    Expect(1, 256, '\P{- In_Latin_1_SUP}', "");
    Expect(0, 256, '\P{^- In_Latin_1_SUP}', "");
    Error('\p{-Latin_1:=}');
    Error('\P{-Latin_1:=}');
    Expect(1, 255, '\p{latin1}', "");
    Expect(0, 255, '\p{^latin1}', "");
    Expect(0, 255, '\P{latin1}', "");
    Expect(1, 255, '\P{^latin1}', "");
    Expect(0, 256, '\p{latin1}', "");
    Expect(1, 256, '\p{^latin1}', "");
    Expect(1, 256, '\P{latin1}', "");
    Expect(0, 256, '\P{^latin1}', "");
    Expect(1, 255, '\p{LATIN_1}', "");
    Expect(0, 255, '\p{^LATIN_1}', "");
    Expect(0, 255, '\P{LATIN_1}', "");
    Expect(1, 255, '\P{^LATIN_1}', "");
    Expect(0, 256, '\p{LATIN_1}', "");
    Expect(1, 256, '\p{^LATIN_1}', "");
    Expect(1, 256, '\P{LATIN_1}', "");
    Expect(0, 256, '\P{^LATIN_1}', "");
    Error('\p{_ IS_Latin_1/a/}');
    Error('\P{_ IS_Latin_1/a/}');
    Expect(1, 255, '\p{islatin1}', "");
    Expect(0, 255, '\p{^islatin1}', "");
    Expect(0, 255, '\P{islatin1}', "");
    Expect(1, 255, '\P{^islatin1}', "");
    Expect(0, 256, '\p{islatin1}', "");
    Expect(1, 256, '\p{^islatin1}', "");
    Expect(1, 256, '\P{islatin1}', "");
    Expect(0, 256, '\P{^islatin1}', "");
    Expect(1, 255, '\p{		IS_Latin_1}', "");
    Expect(0, 255, '\p{^		IS_Latin_1}', "");
    Expect(0, 255, '\P{		IS_Latin_1}', "");
    Expect(1, 255, '\P{^		IS_Latin_1}', "");
    Expect(0, 256, '\p{		IS_Latin_1}', "");
    Expect(1, 256, '\p{^		IS_Latin_1}', "");
    Expect(1, 256, '\P{		IS_Latin_1}', "");
    Expect(0, 256, '\P{^		IS_Latin_1}', "");
    Error('\p{_ In_Latin_1/a/}');
    Error('\P{_ In_Latin_1/a/}');
    Expect(1, 255, '\p{inlatin1}', "");
    Expect(0, 255, '\p{^inlatin1}', "");
    Expect(0, 255, '\P{inlatin1}', "");
    Expect(1, 255, '\P{^inlatin1}', "");
    Expect(0, 256, '\p{inlatin1}', "");
    Expect(1, 256, '\p{^inlatin1}', "");
    Expect(1, 256, '\P{inlatin1}', "");
    Expect(0, 256, '\P{^inlatin1}', "");
    Expect(1, 255, '\p{	-In_Latin_1}', "");
    Expect(0, 255, '\p{^	-In_Latin_1}', "");
    Expect(0, 255, '\P{	-In_Latin_1}', "");
    Expect(1, 255, '\P{^	-In_Latin_1}', "");
    Expect(0, 256, '\p{	-In_Latin_1}', "");
    Expect(1, 256, '\p{^	-In_Latin_1}', "");
    Expect(1, 256, '\P{	-In_Latin_1}', "");
    Expect(0, 256, '\P{^	-In_Latin_1}', "");
    Error('\p{_LATIN_extended_A:=}');
    Error('\P{_LATIN_extended_A:=}');
    Expect(1, 383, '\p{latinextendeda}', "");
    Expect(0, 383, '\p{^latinextendeda}', "");
    Expect(0, 383, '\P{latinextendeda}', "");
    Expect(1, 383, '\P{^latinextendeda}', "");
    Expect(0, 384, '\p{latinextendeda}', "");
    Expect(1, 384, '\p{^latinextendeda}', "");
    Expect(1, 384, '\P{latinextendeda}', "");
    Expect(0, 384, '\P{^latinextendeda}', "");
    Expect(1, 383, '\p{	latin_extended_a}', "");
    Expect(0, 383, '\p{^	latin_extended_a}', "");
    Expect(0, 383, '\P{	latin_extended_a}', "");
    Expect(1, 383, '\P{^	latin_extended_a}', "");
    Expect(0, 384, '\p{	latin_extended_a}', "");
    Expect(1, 384, '\p{^	latin_extended_a}', "");
    Expect(1, 384, '\P{	latin_extended_a}', "");
    Expect(0, 384, '\P{^	latin_extended_a}', "");
    Error('\p{ :=Is_Latin_Extended_A}');
    Error('\P{ :=Is_Latin_Extended_A}');
    Expect(1, 383, '\p{islatinextendeda}', "");
    Expect(0, 383, '\p{^islatinextendeda}', "");
    Expect(0, 383, '\P{islatinextendeda}', "");
    Expect(1, 383, '\P{^islatinextendeda}', "");
    Expect(0, 384, '\p{islatinextendeda}', "");
    Expect(1, 384, '\p{^islatinextendeda}', "");
    Expect(1, 384, '\P{islatinextendeda}', "");
    Expect(0, 384, '\P{^islatinextendeda}', "");
    Expect(1, 383, '\p{	_Is_latin_EXTENDED_a}', "");
    Expect(0, 383, '\p{^	_Is_latin_EXTENDED_a}', "");
    Expect(0, 383, '\P{	_Is_latin_EXTENDED_a}', "");
    Expect(1, 383, '\P{^	_Is_latin_EXTENDED_a}', "");
    Expect(0, 384, '\p{	_Is_latin_EXTENDED_a}', "");
    Expect(1, 384, '\p{^	_Is_latin_EXTENDED_a}', "");
    Expect(1, 384, '\P{	_Is_latin_EXTENDED_a}', "");
    Expect(0, 384, '\P{^	_Is_latin_EXTENDED_a}', "");
    Error('\p{:= _in_LATIN_Extended_A}');
    Error('\P{:= _in_LATIN_Extended_A}');
    Expect(1, 383, '\p{inlatinextendeda}', "");
    Expect(0, 383, '\p{^inlatinextendeda}', "");
    Expect(0, 383, '\P{inlatinextendeda}', "");
    Expect(1, 383, '\P{^inlatinextendeda}', "");
    Expect(0, 384, '\p{inlatinextendeda}', "");
    Expect(1, 384, '\p{^inlatinextendeda}', "");
    Expect(1, 384, '\P{inlatinextendeda}', "");
    Expect(0, 384, '\P{^inlatinextendeda}', "");
    Expect(1, 383, '\p{	IN_Latin_Extended_A}', "");
    Expect(0, 383, '\p{^	IN_Latin_Extended_A}', "");
    Expect(0, 383, '\P{	IN_Latin_Extended_A}', "");
    Expect(1, 383, '\P{^	IN_Latin_Extended_A}', "");
    Expect(0, 384, '\p{	IN_Latin_Extended_A}', "");
    Expect(1, 384, '\p{^	IN_Latin_Extended_A}', "");
    Expect(1, 384, '\P{	IN_Latin_Extended_A}', "");
    Expect(0, 384, '\P{^	IN_Latin_Extended_A}', "");
    Error('\p{	/a/latin_EXT_a}');
    Error('\P{	/a/latin_EXT_a}');
    Expect(1, 383, '\p{latinexta}', "");
    Expect(0, 383, '\p{^latinexta}', "");
    Expect(0, 383, '\P{latinexta}', "");
    Expect(1, 383, '\P{^latinexta}', "");
    Expect(0, 384, '\p{latinexta}', "");
    Expect(1, 384, '\p{^latinexta}', "");
    Expect(1, 384, '\P{latinexta}', "");
    Expect(0, 384, '\P{^latinexta}', "");
    Expect(1, 383, '\p{ _Latin_EXT_a}', "");
    Expect(0, 383, '\p{^ _Latin_EXT_a}', "");
    Expect(0, 383, '\P{ _Latin_EXT_a}', "");
    Expect(1, 383, '\P{^ _Latin_EXT_a}', "");
    Expect(0, 384, '\p{ _Latin_EXT_a}', "");
    Expect(1, 384, '\p{^ _Latin_EXT_a}', "");
    Expect(1, 384, '\P{ _Latin_EXT_a}', "");
    Expect(0, 384, '\P{^ _Latin_EXT_a}', "");
    Error('\p{-IS_latin_ext_A:=}');
    Error('\P{-IS_latin_ext_A:=}');
    Expect(1, 383, '\p{islatinexta}', "");
    Expect(0, 383, '\p{^islatinexta}', "");
    Expect(0, 383, '\P{islatinexta}', "");
    Expect(1, 383, '\P{^islatinexta}', "");
    Expect(0, 384, '\p{islatinexta}', "");
    Expect(1, 384, '\p{^islatinexta}', "");
    Expect(1, 384, '\P{islatinexta}', "");
    Expect(0, 384, '\P{^islatinexta}', "");
    Expect(1, 383, '\p{-_Is_latin_Ext_A}', "");
    Expect(0, 383, '\p{^-_Is_latin_Ext_A}', "");
    Expect(0, 383, '\P{-_Is_latin_Ext_A}', "");
    Expect(1, 383, '\P{^-_Is_latin_Ext_A}', "");
    Expect(0, 384, '\p{-_Is_latin_Ext_A}', "");
    Expect(1, 384, '\p{^-_Is_latin_Ext_A}', "");
    Expect(1, 384, '\P{-_Is_latin_Ext_A}', "");
    Expect(0, 384, '\P{^-_Is_latin_Ext_A}', "");
    Error('\p{:=_	In_Latin_Ext_a}');
    Error('\P{:=_	In_Latin_Ext_a}');
    Expect(1, 383, '\p{inlatinexta}', "");
    Expect(0, 383, '\p{^inlatinexta}', "");
    Expect(0, 383, '\P{inlatinexta}', "");
    Expect(1, 383, '\P{^inlatinexta}', "");
    Expect(0, 384, '\p{inlatinexta}', "");
    Expect(1, 384, '\p{^inlatinexta}', "");
    Expect(1, 384, '\P{inlatinexta}', "");
    Expect(0, 384, '\P{^inlatinexta}', "");
    Expect(1, 383, '\p{_In_Latin_EXT_a}', "");
    Expect(0, 383, '\p{^_In_Latin_EXT_a}', "");
    Expect(0, 383, '\P{_In_Latin_EXT_a}', "");
    Expect(1, 383, '\P{^_In_Latin_EXT_a}', "");
    Expect(0, 384, '\p{_In_Latin_EXT_a}', "");
    Expect(1, 384, '\p{^_In_Latin_EXT_a}', "");
    Expect(1, 384, '\P{_In_Latin_EXT_a}', "");
    Expect(0, 384, '\P{^_In_Latin_EXT_a}', "");
    Error('\p{- latin_Extended_Additional/a/}');
    Error('\P{- latin_Extended_Additional/a/}');
    Expect(1, 7935, '\p{latinextendedadditional}', "");
    Expect(0, 7935, '\p{^latinextendedadditional}', "");
    Expect(0, 7935, '\P{latinextendedadditional}', "");
    Expect(1, 7935, '\P{^latinextendedadditional}', "");
    Expect(0, 7936, '\p{latinextendedadditional}', "");
    Expect(1, 7936, '\p{^latinextendedadditional}', "");
    Expect(1, 7936, '\P{latinextendedadditional}', "");
    Expect(0, 7936, '\P{^latinextendedadditional}', "");
    Expect(1, 7935, '\p{_latin_Extended_ADDITIONAL}', "");
    Expect(0, 7935, '\p{^_latin_Extended_ADDITIONAL}', "");
    Expect(0, 7935, '\P{_latin_Extended_ADDITIONAL}', "");
    Expect(1, 7935, '\P{^_latin_Extended_ADDITIONAL}', "");
    Expect(0, 7936, '\p{_latin_Extended_ADDITIONAL}', "");
    Expect(1, 7936, '\p{^_latin_Extended_ADDITIONAL}', "");
    Expect(1, 7936, '\P{_latin_Extended_ADDITIONAL}', "");
    Expect(0, 7936, '\P{^_latin_Extended_ADDITIONAL}', "");
    Error('\p{IS_latin_EXTENDED_Additional:=}');
    Error('\P{IS_latin_EXTENDED_Additional:=}');
    Expect(1, 7935, '\p{islatinextendedadditional}', "");
    Expect(0, 7935, '\p{^islatinextendedadditional}', "");
    Expect(0, 7935, '\P{islatinextendedadditional}', "");
    Expect(1, 7935, '\P{^islatinextendedadditional}', "");
    Expect(0, 7936, '\p{islatinextendedadditional}', "");
    Expect(1, 7936, '\p{^islatinextendedadditional}', "");
    Expect(1, 7936, '\P{islatinextendedadditional}', "");
    Expect(0, 7936, '\P{^islatinextendedadditional}', "");
    Expect(1, 7935, '\p{ Is_LATIN_extended_ADDITIONAL}', "");
    Expect(0, 7935, '\p{^ Is_LATIN_extended_ADDITIONAL}', "");
    Expect(0, 7935, '\P{ Is_LATIN_extended_ADDITIONAL}', "");
    Expect(1, 7935, '\P{^ Is_LATIN_extended_ADDITIONAL}', "");
    Expect(0, 7936, '\p{ Is_LATIN_extended_ADDITIONAL}', "");
    Expect(1, 7936, '\p{^ Is_LATIN_extended_ADDITIONAL}', "");
    Expect(1, 7936, '\P{ Is_LATIN_extended_ADDITIONAL}', "");
    Expect(0, 7936, '\P{^ Is_LATIN_extended_ADDITIONAL}', "");
    Error('\p{-:=In_LATIN_Extended_Additional}');
    Error('\P{-:=In_LATIN_Extended_Additional}');
    Expect(1, 7935, '\p{inlatinextendedadditional}', "");
    Expect(0, 7935, '\p{^inlatinextendedadditional}', "");
    Expect(0, 7935, '\P{inlatinextendedadditional}', "");
    Expect(1, 7935, '\P{^inlatinextendedadditional}', "");
    Expect(0, 7936, '\p{inlatinextendedadditional}', "");
    Expect(1, 7936, '\p{^inlatinextendedadditional}', "");
    Expect(1, 7936, '\P{inlatinextendedadditional}', "");
    Expect(0, 7936, '\P{^inlatinextendedadditional}', "");
    Expect(1, 7935, '\p{-	In_Latin_EXTENDED_Additional}', "");
    Expect(0, 7935, '\p{^-	In_Latin_EXTENDED_Additional}', "");
    Expect(0, 7935, '\P{-	In_Latin_EXTENDED_Additional}', "");
    Expect(1, 7935, '\P{^-	In_Latin_EXTENDED_Additional}', "");
    Expect(0, 7936, '\p{-	In_Latin_EXTENDED_Additional}', "");
    Expect(1, 7936, '\p{^-	In_Latin_EXTENDED_Additional}', "");
    Expect(1, 7936, '\P{-	In_Latin_EXTENDED_Additional}', "");
    Expect(0, 7936, '\P{^-	In_Latin_EXTENDED_Additional}', "");
    Error('\p{	latin_EXT_additional:=}');
    Error('\P{	latin_EXT_additional:=}');
    Expect(1, 7935, '\p{latinextadditional}', "");
    Expect(0, 7935, '\p{^latinextadditional}', "");
    Expect(0, 7935, '\P{latinextadditional}', "");
    Expect(1, 7935, '\P{^latinextadditional}', "");
    Expect(0, 7936, '\p{latinextadditional}', "");
    Expect(1, 7936, '\p{^latinextadditional}', "");
    Expect(1, 7936, '\P{latinextadditional}', "");
    Expect(0, 7936, '\P{^latinextadditional}', "");
    Expect(1, 7935, '\p{_-Latin_Ext_Additional}', "");
    Expect(0, 7935, '\p{^_-Latin_Ext_Additional}', "");
    Expect(0, 7935, '\P{_-Latin_Ext_Additional}', "");
    Expect(1, 7935, '\P{^_-Latin_Ext_Additional}', "");
    Expect(0, 7936, '\p{_-Latin_Ext_Additional}', "");
    Expect(1, 7936, '\p{^_-Latin_Ext_Additional}', "");
    Expect(1, 7936, '\P{_-Latin_Ext_Additional}', "");
    Expect(0, 7936, '\P{^_-Latin_Ext_Additional}', "");
    Error('\p{:=__is_LATIN_Ext_ADDITIONAL}');
    Error('\P{:=__is_LATIN_Ext_ADDITIONAL}');
    Expect(1, 7935, '\p{islatinextadditional}', "");
    Expect(0, 7935, '\p{^islatinextadditional}', "");
    Expect(0, 7935, '\P{islatinextadditional}', "");
    Expect(1, 7935, '\P{^islatinextadditional}', "");
    Expect(0, 7936, '\p{islatinextadditional}', "");
    Expect(1, 7936, '\p{^islatinextadditional}', "");
    Expect(1, 7936, '\P{islatinextadditional}', "");
    Expect(0, 7936, '\P{^islatinextadditional}', "");
    Expect(1, 7935, '\p{__Is_Latin_Ext_Additional}', "");
    Expect(0, 7935, '\p{^__Is_Latin_Ext_Additional}', "");
    Expect(0, 7935, '\P{__Is_Latin_Ext_Additional}', "");
    Expect(1, 7935, '\P{^__Is_Latin_Ext_Additional}', "");
    Expect(0, 7936, '\p{__Is_Latin_Ext_Additional}', "");
    Expect(1, 7936, '\p{^__Is_Latin_Ext_Additional}', "");
    Expect(1, 7936, '\P{__Is_Latin_Ext_Additional}', "");
    Expect(0, 7936, '\P{^__Is_Latin_Ext_Additional}', "");
    Error('\p{	/a/IN_LATIN_Ext_additional}');
    Error('\P{	/a/IN_LATIN_Ext_additional}');
    Expect(1, 7935, '\p{inlatinextadditional}', "");
    Expect(0, 7935, '\p{^inlatinextadditional}', "");
    Expect(0, 7935, '\P{inlatinextadditional}', "");
    Expect(1, 7935, '\P{^inlatinextadditional}', "");
    Expect(0, 7936, '\p{inlatinextadditional}', "");
    Expect(1, 7936, '\p{^inlatinextadditional}', "");
    Expect(1, 7936, '\P{inlatinextadditional}', "");
    Expect(0, 7936, '\P{^inlatinextadditional}', "");
    Expect(1, 7935, '\p{ IN_latin_EXT_additional}', "");
    Expect(0, 7935, '\p{^ IN_latin_EXT_additional}', "");
    Expect(0, 7935, '\P{ IN_latin_EXT_additional}', "");
    Expect(1, 7935, '\P{^ IN_latin_EXT_additional}', "");
    Expect(0, 7936, '\p{ IN_latin_EXT_additional}', "");
    Expect(1, 7936, '\p{^ IN_latin_EXT_additional}', "");
    Expect(1, 7936, '\P{ IN_latin_EXT_additional}', "");
    Expect(0, 7936, '\P{^ IN_latin_EXT_additional}', "");
    Error('\p{:=	 latin_EXTENDED_B}');
    Error('\P{:=	 latin_EXTENDED_B}');
    Expect(1, 591, '\p{latinextendedb}', "");
    Expect(0, 591, '\p{^latinextendedb}', "");
    Expect(0, 591, '\P{latinextendedb}', "");
    Expect(1, 591, '\P{^latinextendedb}', "");
    Expect(0, 592, '\p{latinextendedb}', "");
    Expect(1, 592, '\p{^latinextendedb}', "");
    Expect(1, 592, '\P{latinextendedb}', "");
    Expect(0, 592, '\P{^latinextendedb}', "");
    Expect(1, 591, '\p{	latin_extended_b}', "");
    Expect(0, 591, '\p{^	latin_extended_b}', "");
    Expect(0, 591, '\P{	latin_extended_b}', "");
    Expect(1, 591, '\P{^	latin_extended_b}', "");
    Expect(0, 592, '\p{	latin_extended_b}', "");
    Expect(1, 592, '\p{^	latin_extended_b}', "");
    Expect(1, 592, '\P{	latin_extended_b}', "");
    Expect(0, 592, '\P{^	latin_extended_b}', "");
    Error('\p{_-Is_Latin_Extended_B/a/}');
    Error('\P{_-Is_Latin_Extended_B/a/}');
    Expect(1, 591, '\p{islatinextendedb}', "");
    Expect(0, 591, '\p{^islatinextendedb}', "");
    Expect(0, 591, '\P{islatinextendedb}', "");
    Expect(1, 591, '\P{^islatinextendedb}', "");
    Expect(0, 592, '\p{islatinextendedb}', "");
    Expect(1, 592, '\p{^islatinextendedb}', "");
    Expect(1, 592, '\P{islatinextendedb}', "");
    Expect(0, 592, '\P{^islatinextendedb}', "");
    Expect(1, 591, '\p{- Is_Latin_EXTENDED_b}', "");
    Expect(0, 591, '\p{^- Is_Latin_EXTENDED_b}', "");
    Expect(0, 591, '\P{- Is_Latin_EXTENDED_b}', "");
    Expect(1, 591, '\P{^- Is_Latin_EXTENDED_b}', "");
    Expect(0, 592, '\p{- Is_Latin_EXTENDED_b}', "");
    Expect(1, 592, '\p{^- Is_Latin_EXTENDED_b}', "");
    Expect(1, 592, '\P{- Is_Latin_EXTENDED_b}', "");
    Expect(0, 592, '\P{^- Is_Latin_EXTENDED_b}', "");
    Error('\p{	/a/IN_LATIN_Extended_B}');
    Error('\P{	/a/IN_LATIN_Extended_B}');
    Expect(1, 591, '\p{inlatinextendedb}', "");
    Expect(0, 591, '\p{^inlatinextendedb}', "");
    Expect(0, 591, '\P{inlatinextendedb}', "");
    Expect(1, 591, '\P{^inlatinextendedb}', "");
    Expect(0, 592, '\p{inlatinextendedb}', "");
    Expect(1, 592, '\p{^inlatinextendedb}', "");
    Expect(1, 592, '\P{inlatinextendedb}', "");
    Expect(0, 592, '\P{^inlatinextendedb}', "");
    Expect(1, 591, '\p{	in_Latin_Extended_B}', "");
    Expect(0, 591, '\p{^	in_Latin_Extended_B}', "");
    Expect(0, 591, '\P{	in_Latin_Extended_B}', "");
    Expect(1, 591, '\P{^	in_Latin_Extended_B}', "");
    Expect(0, 592, '\p{	in_Latin_Extended_B}', "");
    Expect(1, 592, '\p{^	in_Latin_Extended_B}', "");
    Expect(1, 592, '\P{	in_Latin_Extended_B}', "");
    Expect(0, 592, '\P{^	in_Latin_Extended_B}', "");
    Error('\p{ _latin_Ext_B/a/}');
    Error('\P{ _latin_Ext_B/a/}');
    Expect(1, 591, '\p{latinextb}', "");
    Expect(0, 591, '\p{^latinextb}', "");
    Expect(0, 591, '\P{latinextb}', "");
    Expect(1, 591, '\P{^latinextb}', "");
    Expect(0, 592, '\p{latinextb}', "");
    Expect(1, 592, '\p{^latinextb}', "");
    Expect(1, 592, '\P{latinextb}', "");
    Expect(0, 592, '\P{^latinextb}', "");
    Expect(1, 591, '\p{Latin_Ext_B}', "");
    Expect(0, 591, '\p{^Latin_Ext_B}', "");
    Expect(0, 591, '\P{Latin_Ext_B}', "");
    Expect(1, 591, '\P{^Latin_Ext_B}', "");
    Expect(0, 592, '\p{Latin_Ext_B}', "");
    Expect(1, 592, '\p{^Latin_Ext_B}', "");
    Expect(1, 592, '\P{Latin_Ext_B}', "");
    Expect(0, 592, '\P{^Latin_Ext_B}', "");
    Error('\p{_:=Is_latin_ext_B}');
    Error('\P{_:=Is_latin_ext_B}');
    Expect(1, 591, '\p{islatinextb}', "");
    Expect(0, 591, '\p{^islatinextb}', "");
    Expect(0, 591, '\P{islatinextb}', "");
    Expect(1, 591, '\P{^islatinextb}', "");
    Expect(0, 592, '\p{islatinextb}', "");
    Expect(1, 592, '\p{^islatinextb}', "");
    Expect(1, 592, '\P{islatinextb}', "");
    Expect(0, 592, '\P{^islatinextb}', "");
    Expect(1, 591, '\p{ _is_Latin_Ext_B}', "");
    Expect(0, 591, '\p{^ _is_Latin_Ext_B}', "");
    Expect(0, 591, '\P{ _is_Latin_Ext_B}', "");
    Expect(1, 591, '\P{^ _is_Latin_Ext_B}', "");
    Expect(0, 592, '\p{ _is_Latin_Ext_B}', "");
    Expect(1, 592, '\p{^ _is_Latin_Ext_B}', "");
    Expect(1, 592, '\P{ _is_Latin_Ext_B}', "");
    Expect(0, 592, '\P{^ _is_Latin_Ext_B}', "");
    Error('\p{	 In_latin_Ext_B/a/}');
    Error('\P{	 In_latin_Ext_B/a/}');
    Expect(1, 591, '\p{inlatinextb}', "");
    Expect(0, 591, '\p{^inlatinextb}', "");
    Expect(0, 591, '\P{inlatinextb}', "");
    Expect(1, 591, '\P{^inlatinextb}', "");
    Expect(0, 592, '\p{inlatinextb}', "");
    Expect(1, 592, '\p{^inlatinextb}', "");
    Expect(1, 592, '\P{inlatinextb}', "");
    Expect(0, 592, '\P{^inlatinextb}', "");
    Expect(1, 591, '\p{-	in_Latin_EXT_B}', "");
    Expect(0, 591, '\p{^-	in_Latin_EXT_B}', "");
    Expect(0, 591, '\P{-	in_Latin_EXT_B}', "");
    Expect(1, 591, '\P{^-	in_Latin_EXT_B}', "");
    Expect(0, 592, '\p{-	in_Latin_EXT_B}', "");
    Expect(1, 592, '\p{^-	in_Latin_EXT_B}', "");
    Expect(1, 592, '\P{-	in_Latin_EXT_B}', "");
    Expect(0, 592, '\P{^-	in_Latin_EXT_B}', "");
    Error('\p{ -Latin_EXTENDED_C/a/}');
    Error('\P{ -Latin_EXTENDED_C/a/}');
    Expect(1, 11391, '\p{latinextendedc}', "");
    Expect(0, 11391, '\p{^latinextendedc}', "");
    Expect(0, 11391, '\P{latinextendedc}', "");
    Expect(1, 11391, '\P{^latinextendedc}', "");
    Expect(0, 11392, '\p{latinextendedc}', "");
    Expect(1, 11392, '\p{^latinextendedc}', "");
    Expect(1, 11392, '\P{latinextendedc}', "");
    Expect(0, 11392, '\P{^latinextendedc}', "");
    Expect(1, 11391, '\p{	_LATIN_extended_c}', "");
    Expect(0, 11391, '\p{^	_LATIN_extended_c}', "");
    Expect(0, 11391, '\P{	_LATIN_extended_c}', "");
    Expect(1, 11391, '\P{^	_LATIN_extended_c}', "");
    Expect(0, 11392, '\p{	_LATIN_extended_c}', "");
    Expect(1, 11392, '\p{^	_LATIN_extended_c}', "");
    Expect(1, 11392, '\P{	_LATIN_extended_c}', "");
    Expect(0, 11392, '\P{^	_LATIN_extended_c}', "");
    Error('\p{/a/	IS_Latin_EXTENDED_C}');
    Error('\P{/a/	IS_Latin_EXTENDED_C}');
    Expect(1, 11391, '\p{islatinextendedc}', "");
    Expect(0, 11391, '\p{^islatinextendedc}', "");
    Expect(0, 11391, '\P{islatinextendedc}', "");
    Expect(1, 11391, '\P{^islatinextendedc}', "");
    Expect(0, 11392, '\p{islatinextendedc}', "");
    Expect(1, 11392, '\p{^islatinextendedc}', "");
    Expect(1, 11392, '\P{islatinextendedc}', "");
    Expect(0, 11392, '\P{^islatinextendedc}', "");
    Expect(1, 11391, '\p{ IS_LATIN_extended_c}', "");
    Expect(0, 11391, '\p{^ IS_LATIN_extended_c}', "");
    Expect(0, 11391, '\P{ IS_LATIN_extended_c}', "");
    Expect(1, 11391, '\P{^ IS_LATIN_extended_c}', "");
    Expect(0, 11392, '\p{ IS_LATIN_extended_c}', "");
    Expect(1, 11392, '\p{^ IS_LATIN_extended_c}', "");
    Expect(1, 11392, '\P{ IS_LATIN_extended_c}', "");
    Expect(0, 11392, '\P{^ IS_LATIN_extended_c}', "");
    Error('\p{:=_ In_LATIN_EXTENDED_c}');
    Error('\P{:=_ In_LATIN_EXTENDED_c}');
    Expect(1, 11391, '\p{inlatinextendedc}', "");
    Expect(0, 11391, '\p{^inlatinextendedc}', "");
    Expect(0, 11391, '\P{inlatinextendedc}', "");
    Expect(1, 11391, '\P{^inlatinextendedc}', "");
    Expect(0, 11392, '\p{inlatinextendedc}', "");
    Expect(1, 11392, '\p{^inlatinextendedc}', "");
    Expect(1, 11392, '\P{inlatinextendedc}', "");
    Expect(0, 11392, '\P{^inlatinextendedc}', "");
    Expect(1, 11391, '\p{-In_Latin_Extended_C}', "");
    Expect(0, 11391, '\p{^-In_Latin_Extended_C}', "");
    Expect(0, 11391, '\P{-In_Latin_Extended_C}', "");
    Expect(1, 11391, '\P{^-In_Latin_Extended_C}', "");
    Expect(0, 11392, '\p{-In_Latin_Extended_C}', "");
    Expect(1, 11392, '\p{^-In_Latin_Extended_C}', "");
    Expect(1, 11392, '\P{-In_Latin_Extended_C}', "");
    Expect(0, 11392, '\P{^-In_Latin_Extended_C}', "");
    Error('\p{_:=Latin_Ext_c}');
    Error('\P{_:=Latin_Ext_c}');
    Expect(1, 11391, '\p{latinextc}', "");
    Expect(0, 11391, '\p{^latinextc}', "");
    Expect(0, 11391, '\P{latinextc}', "");
    Expect(1, 11391, '\P{^latinextc}', "");
    Expect(0, 11392, '\p{latinextc}', "");
    Expect(1, 11392, '\p{^latinextc}', "");
    Expect(1, 11392, '\P{latinextc}', "");
    Expect(0, 11392, '\P{^latinextc}', "");
    Expect(1, 11391, '\p{ -Latin_ext_c}', "");
    Expect(0, 11391, '\p{^ -Latin_ext_c}', "");
    Expect(0, 11391, '\P{ -Latin_ext_c}', "");
    Expect(1, 11391, '\P{^ -Latin_ext_c}', "");
    Expect(0, 11392, '\p{ -Latin_ext_c}', "");
    Expect(1, 11392, '\p{^ -Latin_ext_c}', "");
    Expect(1, 11392, '\P{ -Latin_ext_c}', "");
    Expect(0, 11392, '\P{^ -Latin_ext_c}', "");
    Error('\p{ Is_Latin_Ext_C:=}');
    Error('\P{ Is_Latin_Ext_C:=}');
    Expect(1, 11391, '\p{islatinextc}', "");
    Expect(0, 11391, '\p{^islatinextc}', "");
    Expect(0, 11391, '\P{islatinextc}', "");
    Expect(1, 11391, '\P{^islatinextc}', "");
    Expect(0, 11392, '\p{islatinextc}', "");
    Expect(1, 11392, '\p{^islatinextc}', "");
    Expect(1, 11392, '\P{islatinextc}', "");
    Expect(0, 11392, '\P{^islatinextc}', "");
    Expect(1, 11391, '\p{-	is_Latin_ext_C}', "");
    Expect(0, 11391, '\p{^-	is_Latin_ext_C}', "");
    Expect(0, 11391, '\P{-	is_Latin_ext_C}', "");
    Expect(1, 11391, '\P{^-	is_Latin_ext_C}', "");
    Expect(0, 11392, '\p{-	is_Latin_ext_C}', "");
    Expect(1, 11392, '\p{^-	is_Latin_ext_C}', "");
    Expect(1, 11392, '\P{-	is_Latin_ext_C}', "");
    Expect(0, 11392, '\P{^-	is_Latin_ext_C}', "");
    Error('\p{/a/		In_latin_ext_C}');
    Error('\P{/a/		In_latin_ext_C}');
    Expect(1, 11391, '\p{inlatinextc}', "");
    Expect(0, 11391, '\p{^inlatinextc}', "");
    Expect(0, 11391, '\P{inlatinextc}', "");
    Expect(1, 11391, '\P{^inlatinextc}', "");
    Expect(0, 11392, '\p{inlatinextc}', "");
    Expect(1, 11392, '\p{^inlatinextc}', "");
    Expect(1, 11392, '\P{inlatinextc}', "");
    Expect(0, 11392, '\P{^inlatinextc}', "");
    Expect(1, 11391, '\p{	_In_Latin_ext_c}', "");
    Expect(0, 11391, '\p{^	_In_Latin_ext_c}', "");
    Expect(0, 11391, '\P{	_In_Latin_ext_c}', "");
    Expect(1, 11391, '\P{^	_In_Latin_ext_c}', "");
    Expect(0, 11392, '\p{	_In_Latin_ext_c}', "");
    Expect(1, 11392, '\p{^	_In_Latin_ext_c}', "");
    Expect(1, 11392, '\P{	_In_Latin_ext_c}', "");
    Expect(0, 11392, '\P{^	_In_Latin_ext_c}', "");
    Error('\p{:=--Latin_extended_D}');
    Error('\P{:=--Latin_extended_D}');
    Expect(1, 43007, '\p{latinextendedd}', "");
    Expect(0, 43007, '\p{^latinextendedd}', "");
    Expect(0, 43007, '\P{latinextendedd}', "");
    Expect(1, 43007, '\P{^latinextendedd}', "");
    Expect(0, 43008, '\p{latinextendedd}', "");
    Expect(1, 43008, '\p{^latinextendedd}', "");
    Expect(1, 43008, '\P{latinextendedd}', "");
    Expect(0, 43008, '\P{^latinextendedd}', "");
    Expect(1, 43007, '\p{- Latin_EXTENDED_D}', "");
    Expect(0, 43007, '\p{^- Latin_EXTENDED_D}', "");
    Expect(0, 43007, '\P{- Latin_EXTENDED_D}', "");
    Expect(1, 43007, '\P{^- Latin_EXTENDED_D}', "");
    Expect(0, 43008, '\p{- Latin_EXTENDED_D}', "");
    Expect(1, 43008, '\p{^- Latin_EXTENDED_D}', "");
    Expect(1, 43008, '\P{- Latin_EXTENDED_D}', "");
    Expect(0, 43008, '\P{^- Latin_EXTENDED_D}', "");
    Error('\p{:=	is_latin_Extended_D}');
    Error('\P{:=	is_latin_Extended_D}');
    Expect(1, 43007, '\p{islatinextendedd}', "");
    Expect(0, 43007, '\p{^islatinextendedd}', "");
    Expect(0, 43007, '\P{islatinextendedd}', "");
    Expect(1, 43007, '\P{^islatinextendedd}', "");
    Expect(0, 43008, '\p{islatinextendedd}', "");
    Expect(1, 43008, '\p{^islatinextendedd}', "");
    Expect(1, 43008, '\P{islatinextendedd}', "");
    Expect(0, 43008, '\P{^islatinextendedd}', "");
    Expect(1, 43007, '\p{ -Is_LATIN_extended_D}', "");
    Expect(0, 43007, '\p{^ -Is_LATIN_extended_D}', "");
    Expect(0, 43007, '\P{ -Is_LATIN_extended_D}', "");
    Expect(1, 43007, '\P{^ -Is_LATIN_extended_D}', "");
    Expect(0, 43008, '\p{ -Is_LATIN_extended_D}', "");
    Expect(1, 43008, '\p{^ -Is_LATIN_extended_D}', "");
    Expect(1, 43008, '\P{ -Is_LATIN_extended_D}', "");
    Expect(0, 43008, '\P{^ -Is_LATIN_extended_D}', "");
    Error('\p{:=_	In_Latin_Extended_d}');
    Error('\P{:=_	In_Latin_Extended_d}');
    Expect(1, 43007, '\p{inlatinextendedd}', "");
    Expect(0, 43007, '\p{^inlatinextendedd}', "");
    Expect(0, 43007, '\P{inlatinextendedd}', "");
    Expect(1, 43007, '\P{^inlatinextendedd}', "");
    Expect(0, 43008, '\p{inlatinextendedd}', "");
    Expect(1, 43008, '\p{^inlatinextendedd}', "");
    Expect(1, 43008, '\P{inlatinextendedd}', "");
    Expect(0, 43008, '\P{^inlatinextendedd}', "");
    Expect(1, 43007, '\p{ In_latin_Extended_d}', "");
    Expect(0, 43007, '\p{^ In_latin_Extended_d}', "");
    Expect(0, 43007, '\P{ In_latin_Extended_d}', "");
    Expect(1, 43007, '\P{^ In_latin_Extended_d}', "");
    Expect(0, 43008, '\p{ In_latin_Extended_d}', "");
    Expect(1, 43008, '\p{^ In_latin_Extended_d}', "");
    Expect(1, 43008, '\P{ In_latin_Extended_d}', "");
    Expect(0, 43008, '\P{^ In_latin_Extended_d}', "");
    Error('\p{_ Latin_Ext_D/a/}');
    Error('\P{_ Latin_Ext_D/a/}');
    Expect(1, 43007, '\p{latinextd}', "");
    Expect(0, 43007, '\p{^latinextd}', "");
    Expect(0, 43007, '\P{latinextd}', "");
    Expect(1, 43007, '\P{^latinextd}', "");
    Expect(0, 43008, '\p{latinextd}', "");
    Expect(1, 43008, '\p{^latinextd}', "");
    Expect(1, 43008, '\P{latinextd}', "");
    Expect(0, 43008, '\P{^latinextd}', "");
    Expect(1, 43007, '\p{	-LATIN_Ext_D}', "");
    Expect(0, 43007, '\p{^	-LATIN_Ext_D}', "");
    Expect(0, 43007, '\P{	-LATIN_Ext_D}', "");
    Expect(1, 43007, '\P{^	-LATIN_Ext_D}', "");
    Expect(0, 43008, '\p{	-LATIN_Ext_D}', "");
    Expect(1, 43008, '\p{^	-LATIN_Ext_D}', "");
    Expect(1, 43008, '\P{	-LATIN_Ext_D}', "");
    Expect(0, 43008, '\P{^	-LATIN_Ext_D}', "");
    Error('\p{__Is_Latin_Ext_D:=}');
    Error('\P{__Is_Latin_Ext_D:=}');
    Expect(1, 43007, '\p{islatinextd}', "");
    Expect(0, 43007, '\p{^islatinextd}', "");
    Expect(0, 43007, '\P{islatinextd}', "");
    Expect(1, 43007, '\P{^islatinextd}', "");
    Expect(0, 43008, '\p{islatinextd}', "");
    Expect(1, 43008, '\p{^islatinextd}', "");
    Expect(1, 43008, '\P{islatinextd}', "");
    Expect(0, 43008, '\P{^islatinextd}', "");
    Expect(1, 43007, '\p{	-Is_LATIN_EXT_D}', "");
    Expect(0, 43007, '\p{^	-Is_LATIN_EXT_D}', "");
    Expect(0, 43007, '\P{	-Is_LATIN_EXT_D}', "");
    Expect(1, 43007, '\P{^	-Is_LATIN_EXT_D}', "");
    Expect(0, 43008, '\p{	-Is_LATIN_EXT_D}', "");
    Expect(1, 43008, '\p{^	-Is_LATIN_EXT_D}', "");
    Expect(1, 43008, '\P{	-Is_LATIN_EXT_D}', "");
    Expect(0, 43008, '\P{^	-Is_LATIN_EXT_D}', "");
    Error('\p{ _In_Latin_Ext_D:=}');
    Error('\P{ _In_Latin_Ext_D:=}');
    Expect(1, 43007, '\p{inlatinextd}', "");
    Expect(0, 43007, '\p{^inlatinextd}', "");
    Expect(0, 43007, '\P{inlatinextd}', "");
    Expect(1, 43007, '\P{^inlatinextd}', "");
    Expect(0, 43008, '\p{inlatinextd}', "");
    Expect(1, 43008, '\p{^inlatinextd}', "");
    Expect(1, 43008, '\P{inlatinextd}', "");
    Expect(0, 43008, '\P{^inlatinextd}', "");
    Expect(1, 43007, '\p{- In_LATIN_EXT_D}', "");
    Expect(0, 43007, '\p{^- In_LATIN_EXT_D}', "");
    Expect(0, 43007, '\P{- In_LATIN_EXT_D}', "");
    Expect(1, 43007, '\P{^- In_LATIN_EXT_D}', "");
    Expect(0, 43008, '\p{- In_LATIN_EXT_D}', "");
    Expect(1, 43008, '\p{^- In_LATIN_EXT_D}', "");
    Expect(1, 43008, '\P{- In_LATIN_EXT_D}', "");
    Expect(0, 43008, '\P{^- In_LATIN_EXT_D}', "");
    Error('\p{ /a/LATIN_EXTENDED_E}');
    Error('\P{ /a/LATIN_EXTENDED_E}');
    Expect(1, 43887, '\p{latinextendede}', "");
    Expect(0, 43887, '\p{^latinextendede}', "");
    Expect(0, 43887, '\P{latinextendede}', "");
    Expect(1, 43887, '\P{^latinextendede}', "");
    Expect(0, 43888, '\p{latinextendede}', "");
    Expect(1, 43888, '\p{^latinextendede}', "");
    Expect(1, 43888, '\P{latinextendede}', "");
    Expect(0, 43888, '\P{^latinextendede}', "");
    Expect(1, 43887, '\p{_	LATIN_Extended_E}', "");
    Expect(0, 43887, '\p{^_	LATIN_Extended_E}', "");
    Expect(0, 43887, '\P{_	LATIN_Extended_E}', "");
    Expect(1, 43887, '\P{^_	LATIN_Extended_E}', "");
    Expect(0, 43888, '\p{_	LATIN_Extended_E}', "");
    Expect(1, 43888, '\p{^_	LATIN_Extended_E}', "");
    Expect(1, 43888, '\P{_	LATIN_Extended_E}', "");
    Expect(0, 43888, '\P{^_	LATIN_Extended_E}', "");
    Error('\p{:=		Is_LATIN_Extended_E}');
    Error('\P{:=		Is_LATIN_Extended_E}');
    Expect(1, 43887, '\p{islatinextendede}', "");
    Expect(0, 43887, '\p{^islatinextendede}', "");
    Expect(0, 43887, '\P{islatinextendede}', "");
    Expect(1, 43887, '\P{^islatinextendede}', "");
    Expect(0, 43888, '\p{islatinextendede}', "");
    Expect(1, 43888, '\p{^islatinextendede}', "");
    Expect(1, 43888, '\P{islatinextendede}', "");
    Expect(0, 43888, '\P{^islatinextendede}', "");
    Expect(1, 43887, '\p{	_Is_latin_Extended_E}', "");
    Expect(0, 43887, '\p{^	_Is_latin_Extended_E}', "");
    Expect(0, 43887, '\P{	_Is_latin_Extended_E}', "");
    Expect(1, 43887, '\P{^	_Is_latin_Extended_E}', "");
    Expect(0, 43888, '\p{	_Is_latin_Extended_E}', "");
    Expect(1, 43888, '\p{^	_Is_latin_Extended_E}', "");
    Expect(1, 43888, '\P{	_Is_latin_Extended_E}', "");
    Expect(0, 43888, '\P{^	_Is_latin_Extended_E}', "");
    Error('\p{-	in_LATIN_EXTENDED_e/a/}');
    Error('\P{-	in_LATIN_EXTENDED_e/a/}');
    Expect(1, 43887, '\p{inlatinextendede}', "");
    Expect(0, 43887, '\p{^inlatinextendede}', "");
    Expect(0, 43887, '\P{inlatinextendede}', "");
    Expect(1, 43887, '\P{^inlatinextendede}', "");
    Expect(0, 43888, '\p{inlatinextendede}', "");
    Expect(1, 43888, '\p{^inlatinextendede}', "");
    Expect(1, 43888, '\P{inlatinextendede}', "");
    Expect(0, 43888, '\P{^inlatinextendede}', "");
    Expect(1, 43887, '\p{-	In_LATIN_EXTENDED_E}', "");
    Expect(0, 43887, '\p{^-	In_LATIN_EXTENDED_E}', "");
    Expect(0, 43887, '\P{-	In_LATIN_EXTENDED_E}', "");
    Expect(1, 43887, '\P{^-	In_LATIN_EXTENDED_E}', "");
    Expect(0, 43888, '\p{-	In_LATIN_EXTENDED_E}', "");
    Expect(1, 43888, '\p{^-	In_LATIN_EXTENDED_E}', "");
    Expect(1, 43888, '\P{-	In_LATIN_EXTENDED_E}', "");
    Expect(0, 43888, '\P{^-	In_LATIN_EXTENDED_E}', "");
    Error('\p{/a/_latin_Ext_E}');
    Error('\P{/a/_latin_Ext_E}');
    Expect(1, 43887, '\p{latinexte}', "");
    Expect(0, 43887, '\p{^latinexte}', "");
    Expect(0, 43887, '\P{latinexte}', "");
    Expect(1, 43887, '\P{^latinexte}', "");
    Expect(0, 43888, '\p{latinexte}', "");
    Expect(1, 43888, '\p{^latinexte}', "");
    Expect(1, 43888, '\P{latinexte}', "");
    Expect(0, 43888, '\P{^latinexte}', "");
    Expect(1, 43887, '\p{__Latin_Ext_e}', "");
    Expect(0, 43887, '\p{^__Latin_Ext_e}', "");
    Expect(0, 43887, '\P{__Latin_Ext_e}', "");
    Expect(1, 43887, '\P{^__Latin_Ext_e}', "");
    Expect(0, 43888, '\p{__Latin_Ext_e}', "");
    Expect(1, 43888, '\p{^__Latin_Ext_e}', "");
    Expect(1, 43888, '\P{__Latin_Ext_e}', "");
    Expect(0, 43888, '\P{^__Latin_Ext_e}', "");
    Error('\p{/a/		IS_Latin_ext_E}');
    Error('\P{/a/		IS_Latin_ext_E}');
    Expect(1, 43887, '\p{islatinexte}', "");
    Expect(0, 43887, '\p{^islatinexte}', "");
    Expect(0, 43887, '\P{islatinexte}', "");
    Expect(1, 43887, '\P{^islatinexte}', "");
    Expect(0, 43888, '\p{islatinexte}', "");
    Expect(1, 43888, '\p{^islatinexte}', "");
    Expect(1, 43888, '\P{islatinexte}', "");
    Expect(0, 43888, '\P{^islatinexte}', "");
    Expect(1, 43887, '\p{	_is_Latin_EXT_e}', "");
    Expect(0, 43887, '\p{^	_is_Latin_EXT_e}', "");
    Expect(0, 43887, '\P{	_is_Latin_EXT_e}', "");
    Expect(1, 43887, '\P{^	_is_Latin_EXT_e}', "");
    Expect(0, 43888, '\p{	_is_Latin_EXT_e}', "");
    Expect(1, 43888, '\p{^	_is_Latin_EXT_e}', "");
    Expect(1, 43888, '\P{	_is_Latin_EXT_e}', "");
    Expect(0, 43888, '\P{^	_is_Latin_EXT_e}', "");
    Error('\p{-:=In_Latin_EXT_E}');
    Error('\P{-:=In_Latin_EXT_E}');
    Expect(1, 43887, '\p{inlatinexte}', "");
    Expect(0, 43887, '\p{^inlatinexte}', "");
    Expect(0, 43887, '\P{inlatinexte}', "");
    Expect(1, 43887, '\P{^inlatinexte}', "");
    Expect(0, 43888, '\p{inlatinexte}', "");
    Expect(1, 43888, '\p{^inlatinexte}', "");
    Expect(1, 43888, '\P{inlatinexte}', "");
    Expect(0, 43888, '\P{^inlatinexte}', "");
    Expect(1, 43887, '\p{	 In_latin_ext_e}', "");
    Expect(0, 43887, '\p{^	 In_latin_ext_e}', "");
    Expect(0, 43887, '\P{	 In_latin_ext_e}', "");
    Expect(1, 43887, '\P{^	 In_latin_ext_e}', "");
    Expect(0, 43888, '\p{	 In_latin_ext_e}', "");
    Expect(1, 43888, '\p{^	 In_latin_ext_e}', "");
    Expect(1, 43888, '\P{	 In_latin_ext_e}', "");
    Expect(0, 43888, '\P{^	 In_latin_ext_e}', "");
    Error('\p{__lepcha:=}');
    Error('\P{__lepcha:=}');
    Expect(1, 7247, '\p{lepcha}', "");
    Expect(0, 7247, '\p{^lepcha}', "");
    Expect(0, 7247, '\P{lepcha}', "");
    Expect(1, 7247, '\P{^lepcha}', "");
    Expect(0, 7248, '\p{lepcha}', "");
    Expect(1, 7248, '\p{^lepcha}', "");
    Expect(1, 7248, '\P{lepcha}', "");
    Expect(0, 7248, '\P{^lepcha}', "");
    Expect(1, 7247, '\p{Lepcha}', "");
    Expect(0, 7247, '\p{^Lepcha}', "");
    Expect(0, 7247, '\P{Lepcha}', "");
    Expect(1, 7247, '\P{^Lepcha}', "");
    Expect(0, 7248, '\p{Lepcha}', "");
    Expect(1, 7248, '\p{^Lepcha}', "");
    Expect(1, 7248, '\P{Lepcha}', "");
    Expect(0, 7248, '\P{^Lepcha}', "");
    Error('\p{  Is_LEPCHA/a/}');
    Error('\P{  Is_LEPCHA/a/}');
    Expect(1, 7247, '\p{islepcha}', "");
    Expect(0, 7247, '\p{^islepcha}', "");
    Expect(0, 7247, '\P{islepcha}', "");
    Expect(1, 7247, '\P{^islepcha}', "");
    Expect(0, 7248, '\p{islepcha}', "");
    Expect(1, 7248, '\p{^islepcha}', "");
    Expect(1, 7248, '\P{islepcha}', "");
    Expect(0, 7248, '\P{^islepcha}', "");
    Expect(1, 7247, '\p{_ is_LEPCHA}', "");
    Expect(0, 7247, '\p{^_ is_LEPCHA}', "");
    Expect(0, 7247, '\P{_ is_LEPCHA}', "");
    Expect(1, 7247, '\P{^_ is_LEPCHA}', "");
    Expect(0, 7248, '\p{_ is_LEPCHA}', "");
    Expect(1, 7248, '\p{^_ is_LEPCHA}', "");
    Expect(1, 7248, '\P{_ is_LEPCHA}', "");
    Expect(0, 7248, '\P{^_ is_LEPCHA}', "");
    Error('\p{	lepc/a/}');
    Error('\P{	lepc/a/}');
    Expect(1, 7247, '\p{lepc}', "");
    Expect(0, 7247, '\p{^lepc}', "");
    Expect(0, 7247, '\P{lepc}', "");
    Expect(1, 7247, '\P{^lepc}', "");
    Expect(0, 7248, '\p{lepc}', "");
    Expect(1, 7248, '\p{^lepc}', "");
    Expect(1, 7248, '\P{lepc}', "");
    Expect(0, 7248, '\P{^lepc}', "");
    Expect(1, 7247, '\p{  Lepc}', "");
    Expect(0, 7247, '\p{^  Lepc}', "");
    Expect(0, 7247, '\P{  Lepc}', "");
    Expect(1, 7247, '\P{^  Lepc}', "");
    Expect(0, 7248, '\p{  Lepc}', "");
    Expect(1, 7248, '\p{^  Lepc}', "");
    Expect(1, 7248, '\P{  Lepc}', "");
    Expect(0, 7248, '\P{^  Lepc}', "");
    Error('\p{	/a/is_LEPC}');
    Error('\P{	/a/is_LEPC}');
    Expect(1, 7247, '\p{islepc}', "");
    Expect(0, 7247, '\p{^islepc}', "");
    Expect(0, 7247, '\P{islepc}', "");
    Expect(1, 7247, '\P{^islepc}', "");
    Expect(0, 7248, '\p{islepc}', "");
    Expect(1, 7248, '\p{^islepc}', "");
    Expect(1, 7248, '\P{islepc}', "");
    Expect(0, 7248, '\P{^islepc}', "");
    Expect(1, 7247, '\p{ is_Lepc}', "");
    Expect(0, 7247, '\p{^ is_Lepc}', "");
    Expect(0, 7247, '\P{ is_Lepc}', "");
    Expect(1, 7247, '\P{^ is_Lepc}', "");
    Expect(0, 7248, '\p{ is_Lepc}', "");
    Expect(1, 7248, '\p{^ is_Lepc}', "");
    Expect(1, 7248, '\P{ is_Lepc}', "");
    Expect(0, 7248, '\P{^ is_Lepc}', "");
    Error('\p{:=  letter}');
    Error('\P{:=  letter}');
    Expect(1, 195101, '\p{letter}', "");
    Expect(0, 195101, '\p{^letter}', "");
    Expect(0, 195101, '\P{letter}', "");
    Expect(1, 195101, '\P{^letter}', "");
    Expect(0, 195102, '\p{letter}', "");
    Expect(1, 195102, '\p{^letter}', "");
    Expect(1, 195102, '\P{letter}', "");
    Expect(0, 195102, '\P{^letter}', "");
    Expect(1, 195101, '\p{-LETTER}', "");
    Expect(0, 195101, '\p{^-LETTER}', "");
    Expect(0, 195101, '\P{-LETTER}', "");
    Expect(1, 195101, '\P{^-LETTER}', "");
    Expect(0, 195102, '\p{-LETTER}', "");
    Expect(1, 195102, '\p{^-LETTER}', "");
    Expect(1, 195102, '\P{-LETTER}', "");
    Expect(0, 195102, '\P{^-LETTER}', "");
    Error('\p{-_is_Letter:=}');
    Error('\P{-_is_Letter:=}');
    Expect(1, 195101, '\p{isletter}', "");
    Expect(0, 195101, '\p{^isletter}', "");
    Expect(0, 195101, '\P{isletter}', "");
    Expect(1, 195101, '\P{^isletter}', "");
    Expect(0, 195102, '\p{isletter}', "");
    Expect(1, 195102, '\p{^isletter}', "");
    Expect(1, 195102, '\P{isletter}', "");
    Expect(0, 195102, '\P{^isletter}', "");
    Expect(1, 195101, '\p{ 	is_LETTER}', "");
    Expect(0, 195101, '\p{^ 	is_LETTER}', "");
    Expect(0, 195101, '\P{ 	is_LETTER}', "");
    Expect(1, 195101, '\P{^ 	is_LETTER}', "");
    Expect(0, 195102, '\p{ 	is_LETTER}', "");
    Expect(1, 195102, '\p{^ 	is_LETTER}', "");
    Expect(1, 195102, '\P{ 	is_LETTER}', "");
    Expect(0, 195102, '\P{^ 	is_LETTER}', "");
    Error('\p{ _L:=}');
    Error('\P{ _L:=}');
    Expect(1, 195101, '\p{l}', "");
    Expect(0, 195101, '\p{^l}', "");
    Expect(0, 195101, '\P{l}', "");
    Expect(1, 195101, '\P{^l}', "");
    Expect(0, 195102, '\p{l}', "");
    Expect(1, 195102, '\p{^l}', "");
    Expect(1, 195102, '\P{l}', "");
    Expect(0, 195102, '\P{^l}', "");
    Expect(1, 195101, '\p{-l}', "");
    Expect(0, 195101, '\p{^-l}', "");
    Expect(0, 195101, '\P{-l}', "");
    Expect(1, 195101, '\P{^-l}', "");
    Expect(0, 195102, '\p{-l}', "");
    Expect(1, 195102, '\p{^-l}', "");
    Expect(1, 195102, '\P{-l}', "");
    Expect(0, 195102, '\P{^-l}', "");
    Error('\p{_:=Is_L}');
    Error('\P{_:=Is_L}');
    Expect(1, 195101, '\p{isl}', "");
    Expect(0, 195101, '\p{^isl}', "");
    Expect(0, 195101, '\P{isl}', "");
    Expect(1, 195101, '\P{^isl}', "");
    Expect(0, 195102, '\p{isl}', "");
    Expect(1, 195102, '\p{^isl}', "");
    Expect(1, 195102, '\P{isl}', "");
    Expect(0, 195102, '\P{^isl}', "");
    Expect(1, 195101, '\p{  IS_L}', "");
    Expect(0, 195101, '\p{^  IS_L}', "");
    Expect(0, 195101, '\P{  IS_L}', "");
    Expect(1, 195101, '\P{^  IS_L}', "");
    Expect(0, 195102, '\p{  IS_L}', "");
    Expect(1, 195102, '\p{^  IS_L}', "");
    Expect(1, 195102, '\P{  IS_L}', "");
    Expect(0, 195102, '\P{^  IS_L}', "");
    Error('\p{:=__Letter_Number}');
    Error('\P{:=__Letter_Number}');
    Expect(1, 74862, '\p{letternumber}', "");
    Expect(0, 74862, '\p{^letternumber}', "");
    Expect(0, 74862, '\P{letternumber}', "");
    Expect(1, 74862, '\P{^letternumber}', "");
    Expect(0, 74863, '\p{letternumber}', "");
    Expect(1, 74863, '\p{^letternumber}', "");
    Expect(1, 74863, '\P{letternumber}', "");
    Expect(0, 74863, '\P{^letternumber}', "");
    Expect(1, 74862, '\p{__Letter_Number}', "");
    Expect(0, 74862, '\p{^__Letter_Number}', "");
    Expect(0, 74862, '\P{__Letter_Number}', "");
    Expect(1, 74862, '\P{^__Letter_Number}', "");
    Expect(0, 74863, '\p{__Letter_Number}', "");
    Expect(1, 74863, '\p{^__Letter_Number}', "");
    Expect(1, 74863, '\P{__Letter_Number}', "");
    Expect(0, 74863, '\P{^__Letter_Number}', "");
    Error('\p{:=is_Letter_NUMBER}');
    Error('\P{:=is_Letter_NUMBER}');
    Expect(1, 74862, '\p{isletternumber}', "");
    Expect(0, 74862, '\p{^isletternumber}', "");
    Expect(0, 74862, '\P{isletternumber}', "");
    Expect(1, 74862, '\P{^isletternumber}', "");
    Expect(0, 74863, '\p{isletternumber}', "");
    Expect(1, 74863, '\p{^isletternumber}', "");
    Expect(1, 74863, '\P{isletternumber}', "");
    Expect(0, 74863, '\P{^isletternumber}', "");
    Expect(1, 74862, '\p{-	IS_letter_Number}', "");
    Expect(0, 74862, '\p{^-	IS_letter_Number}', "");
    Expect(0, 74862, '\P{-	IS_letter_Number}', "");
    Expect(1, 74862, '\P{^-	IS_letter_Number}', "");
    Expect(0, 74863, '\p{-	IS_letter_Number}', "");
    Expect(1, 74863, '\p{^-	IS_letter_Number}', "");
    Expect(1, 74863, '\P{-	IS_letter_Number}', "");
    Expect(0, 74863, '\P{^-	IS_letter_Number}', "");
    Error('\p{/a/NL}');
    Error('\P{/a/NL}');
    Expect(1, 74862, '\p{nl}', "");
    Expect(0, 74862, '\p{^nl}', "");
    Expect(0, 74862, '\P{nl}', "");
    Expect(1, 74862, '\P{^nl}', "");
    Expect(0, 74863, '\p{nl}', "");
    Expect(1, 74863, '\p{^nl}', "");
    Expect(1, 74863, '\P{nl}', "");
    Expect(0, 74863, '\P{^nl}', "");
    Expect(1, 74862, '\p{-nl}', "");
    Expect(0, 74862, '\p{^-nl}', "");
    Expect(0, 74862, '\P{-nl}', "");
    Expect(1, 74862, '\P{^-nl}', "");
    Expect(0, 74863, '\p{-nl}', "");
    Expect(1, 74863, '\p{^-nl}', "");
    Expect(1, 74863, '\P{-nl}', "");
    Expect(0, 74863, '\P{^-nl}', "");
    Error('\p{	_Is_nl:=}');
    Error('\P{	_Is_nl:=}');
    Expect(1, 74862, '\p{isnl}', "");
    Expect(0, 74862, '\p{^isnl}', "");
    Expect(0, 74862, '\P{isnl}', "");
    Expect(1, 74862, '\P{^isnl}', "");
    Expect(0, 74863, '\p{isnl}', "");
    Expect(1, 74863, '\p{^isnl}', "");
    Expect(1, 74863, '\P{isnl}', "");
    Expect(0, 74863, '\P{^isnl}', "");
    Expect(1, 74862, '\p{	_IS_nl}', "");
    Expect(0, 74862, '\p{^	_IS_nl}', "");
    Expect(0, 74862, '\P{	_IS_nl}', "");
    Expect(1, 74862, '\P{^	_IS_nl}', "");
    Expect(0, 74863, '\p{	_IS_nl}', "");
    Expect(1, 74863, '\p{^	_IS_nl}', "");
    Expect(1, 74863, '\P{	_IS_nl}', "");
    Expect(0, 74863, '\P{^	_IS_nl}', "");
    Error('\p{		Letterlike_Symbols:=}');
    Error('\P{		Letterlike_Symbols:=}');
    Expect(1, 8527, '\p{letterlikesymbols}', "");
    Expect(0, 8527, '\p{^letterlikesymbols}', "");
    Expect(0, 8527, '\P{letterlikesymbols}', "");
    Expect(1, 8527, '\P{^letterlikesymbols}', "");
    Expect(0, 8528, '\p{letterlikesymbols}', "");
    Expect(1, 8528, '\p{^letterlikesymbols}', "");
    Expect(1, 8528, '\P{letterlikesymbols}', "");
    Expect(0, 8528, '\P{^letterlikesymbols}', "");
    Expect(1, 8527, '\p{	Letterlike_SYMBOLS}', "");
    Expect(0, 8527, '\p{^	Letterlike_SYMBOLS}', "");
    Expect(0, 8527, '\P{	Letterlike_SYMBOLS}', "");
    Expect(1, 8527, '\P{^	Letterlike_SYMBOLS}', "");
    Expect(0, 8528, '\p{	Letterlike_SYMBOLS}', "");
    Expect(1, 8528, '\p{^	Letterlike_SYMBOLS}', "");
    Expect(1, 8528, '\P{	Letterlike_SYMBOLS}', "");
    Expect(0, 8528, '\P{^	Letterlike_SYMBOLS}', "");
    Error('\p{_IS_LETTERLIKE_SYMBOLS:=}');
    Error('\P{_IS_LETTERLIKE_SYMBOLS:=}');
    Expect(1, 8527, '\p{isletterlikesymbols}', "");
    Expect(0, 8527, '\p{^isletterlikesymbols}', "");
    Expect(0, 8527, '\P{isletterlikesymbols}', "");
    Expect(1, 8527, '\P{^isletterlikesymbols}', "");
    Expect(0, 8528, '\p{isletterlikesymbols}', "");
    Expect(1, 8528, '\p{^isletterlikesymbols}', "");
    Expect(1, 8528, '\P{isletterlikesymbols}', "");
    Expect(0, 8528, '\P{^isletterlikesymbols}', "");
    Expect(1, 8527, '\p{	 Is_LETTERLIKE_Symbols}', "");
    Expect(0, 8527, '\p{^	 Is_LETTERLIKE_Symbols}', "");
    Expect(0, 8527, '\P{	 Is_LETTERLIKE_Symbols}', "");
    Expect(1, 8527, '\P{^	 Is_LETTERLIKE_Symbols}', "");
    Expect(0, 8528, '\p{	 Is_LETTERLIKE_Symbols}', "");
    Expect(1, 8528, '\p{^	 Is_LETTERLIKE_Symbols}', "");
    Expect(1, 8528, '\P{	 Is_LETTERLIKE_Symbols}', "");
    Expect(0, 8528, '\P{^	 Is_LETTERLIKE_Symbols}', "");
    Error('\p{_/a/IN_letterlike_Symbols}');
    Error('\P{_/a/IN_letterlike_Symbols}');
    Expect(1, 8527, '\p{inletterlikesymbols}', "");
    Expect(0, 8527, '\p{^inletterlikesymbols}', "");
    Expect(0, 8527, '\P{inletterlikesymbols}', "");
    Expect(1, 8527, '\P{^inletterlikesymbols}', "");
    Expect(0, 8528, '\p{inletterlikesymbols}', "");
    Expect(1, 8528, '\p{^inletterlikesymbols}', "");
    Expect(1, 8528, '\P{inletterlikesymbols}', "");
    Expect(0, 8528, '\P{^inletterlikesymbols}', "");
    Expect(1, 8527, '\p{ 	In_Letterlike_Symbols}', "");
    Expect(0, 8527, '\p{^ 	In_Letterlike_Symbols}', "");
    Expect(0, 8527, '\P{ 	In_Letterlike_Symbols}', "");
    Expect(1, 8527, '\P{^ 	In_Letterlike_Symbols}', "");
    Expect(0, 8528, '\p{ 	In_Letterlike_Symbols}', "");
    Expect(1, 8528, '\p{^ 	In_Letterlike_Symbols}', "");
    Expect(1, 8528, '\P{ 	In_Letterlike_Symbols}', "");
    Expect(0, 8528, '\P{^ 	In_Letterlike_Symbols}', "");
    Error('\p{	_Limbu:=}');
    Error('\P{	_Limbu:=}');
    Expect(1, 6479, '\p{limbu}', "");
    Expect(0, 6479, '\p{^limbu}', "");
    Expect(0, 6479, '\P{limbu}', "");
    Expect(1, 6479, '\P{^limbu}', "");
    Expect(0, 6480, '\p{limbu}', "");
    Expect(1, 6480, '\p{^limbu}', "");
    Expect(1, 6480, '\P{limbu}', "");
    Expect(0, 6480, '\P{^limbu}', "");
    Expect(1, 6479, '\p{_	Limbu}', "");
    Expect(0, 6479, '\p{^_	Limbu}', "");
    Expect(0, 6479, '\P{_	Limbu}', "");
    Expect(1, 6479, '\P{^_	Limbu}', "");
    Expect(0, 6480, '\p{_	Limbu}', "");
    Expect(1, 6480, '\p{^_	Limbu}', "");
    Expect(1, 6480, '\P{_	Limbu}', "");
    Expect(0, 6480, '\P{^_	Limbu}', "");
    Error('\p{:=	_Is_LIMBU}');
    Error('\P{:=	_Is_LIMBU}');
    Expect(1, 6479, '\p{islimbu}', "");
    Expect(0, 6479, '\p{^islimbu}', "");
    Expect(0, 6479, '\P{islimbu}', "");
    Expect(1, 6479, '\P{^islimbu}', "");
    Expect(0, 6480, '\p{islimbu}', "");
    Expect(1, 6480, '\p{^islimbu}', "");
    Expect(1, 6480, '\P{islimbu}', "");
    Expect(0, 6480, '\P{^islimbu}', "");
    Expect(1, 6479, '\p{--Is_Limbu}', "");
    Expect(0, 6479, '\p{^--Is_Limbu}', "");
    Expect(0, 6479, '\P{--Is_Limbu}', "");
    Expect(1, 6479, '\P{^--Is_Limbu}', "");
    Expect(0, 6480, '\p{--Is_Limbu}', "");
    Expect(1, 6480, '\p{^--Is_Limbu}', "");
    Expect(1, 6480, '\P{--Is_Limbu}', "");
    Expect(0, 6480, '\P{^--Is_Limbu}', "");
    Error('\p{-/a/Limb}');
    Error('\P{-/a/Limb}');
    Expect(1, 6479, '\p{limb}', "");
    Expect(0, 6479, '\p{^limb}', "");
    Expect(0, 6479, '\P{limb}', "");
    Expect(1, 6479, '\P{^limb}', "");
    Expect(0, 6480, '\p{limb}', "");
    Expect(1, 6480, '\p{^limb}', "");
    Expect(1, 6480, '\P{limb}', "");
    Expect(0, 6480, '\P{^limb}', "");
    Expect(1, 6479, '\p{-_Limb}', "");
    Expect(0, 6479, '\p{^-_Limb}', "");
    Expect(0, 6479, '\P{-_Limb}', "");
    Expect(1, 6479, '\P{^-_Limb}', "");
    Expect(0, 6480, '\p{-_Limb}', "");
    Expect(1, 6480, '\p{^-_Limb}', "");
    Expect(1, 6480, '\P{-_Limb}', "");
    Expect(0, 6480, '\P{^-_Limb}', "");
    Error('\p{is_Limb:=}');
    Error('\P{is_Limb:=}');
    Expect(1, 6479, '\p{islimb}', "");
    Expect(0, 6479, '\p{^islimb}', "");
    Expect(0, 6479, '\P{islimb}', "");
    Expect(1, 6479, '\P{^islimb}', "");
    Expect(0, 6480, '\p{islimb}', "");
    Expect(1, 6480, '\p{^islimb}', "");
    Expect(1, 6480, '\P{islimb}', "");
    Expect(0, 6480, '\P{^islimb}', "");
    Expect(1, 6479, '\p{  Is_Limb}', "");
    Expect(0, 6479, '\p{^  Is_Limb}', "");
    Expect(0, 6479, '\P{  Is_Limb}', "");
    Expect(1, 6479, '\P{^  Is_Limb}', "");
    Expect(0, 6480, '\p{  Is_Limb}', "");
    Expect(1, 6480, '\p{^  Is_Limb}', "");
    Expect(1, 6480, '\P{  Is_Limb}', "");
    Expect(0, 6480, '\P{^  Is_Limb}', "");
    Error('\p{/a/line_Separator}');
    Error('\P{/a/line_Separator}');
    Expect(1, 8232, '\p{lineseparator}', "");
    Expect(0, 8232, '\p{^lineseparator}', "");
    Expect(0, 8232, '\P{lineseparator}', "");
    Expect(1, 8232, '\P{^lineseparator}', "");
    Expect(0, 8233, '\p{lineseparator}', "");
    Expect(1, 8233, '\p{^lineseparator}', "");
    Expect(1, 8233, '\P{lineseparator}', "");
    Expect(0, 8233, '\P{^lineseparator}', "");
    Expect(1, 8232, '\p{	-line_separator}', "");
    Expect(0, 8232, '\p{^	-line_separator}', "");
    Expect(0, 8232, '\P{	-line_separator}', "");
    Expect(1, 8232, '\P{^	-line_separator}', "");
    Expect(0, 8233, '\p{	-line_separator}', "");
    Expect(1, 8233, '\p{^	-line_separator}', "");
    Expect(1, 8233, '\P{	-line_separator}', "");
    Expect(0, 8233, '\P{^	-line_separator}', "");
    Error('\p{/a/_-Is_line_SEPARATOR}');
    Error('\P{/a/_-Is_line_SEPARATOR}');
    Expect(1, 8232, '\p{islineseparator}', "");
    Expect(0, 8232, '\p{^islineseparator}', "");
    Expect(0, 8232, '\P{islineseparator}', "");
    Expect(1, 8232, '\P{^islineseparator}', "");
    Expect(0, 8233, '\p{islineseparator}', "");
    Expect(1, 8233, '\p{^islineseparator}', "");
    Expect(1, 8233, '\P{islineseparator}', "");
    Expect(0, 8233, '\P{^islineseparator}', "");
    Expect(1, 8232, '\p{	 Is_Line_SEPARATOR}', "");
    Expect(0, 8232, '\p{^	 Is_Line_SEPARATOR}', "");
    Expect(0, 8232, '\P{	 Is_Line_SEPARATOR}', "");
    Expect(1, 8232, '\P{^	 Is_Line_SEPARATOR}', "");
    Expect(0, 8233, '\p{	 Is_Line_SEPARATOR}', "");
    Expect(1, 8233, '\p{^	 Is_Line_SEPARATOR}', "");
    Expect(1, 8233, '\P{	 Is_Line_SEPARATOR}', "");
    Expect(0, 8233, '\P{^	 Is_Line_SEPARATOR}', "");
    Error('\p{/a/	-Zl}');
    Error('\P{/a/	-Zl}');
    Expect(1, 8232, '\p{zl}', "");
    Expect(0, 8232, '\p{^zl}', "");
    Expect(0, 8232, '\P{zl}', "");
    Expect(1, 8232, '\P{^zl}', "");
    Expect(0, 8233, '\p{zl}', "");
    Expect(1, 8233, '\p{^zl}', "");
    Expect(1, 8233, '\P{zl}', "");
    Expect(0, 8233, '\P{^zl}', "");
    Expect(1, 8232, '\p{		Zl}', "");
    Expect(0, 8232, '\p{^		Zl}', "");
    Expect(0, 8232, '\P{		Zl}', "");
    Expect(1, 8232, '\P{^		Zl}', "");
    Expect(0, 8233, '\p{		Zl}', "");
    Expect(1, 8233, '\p{^		Zl}', "");
    Expect(1, 8233, '\P{		Zl}', "");
    Expect(0, 8233, '\P{^		Zl}', "");
    Error('\p{:=_ Is_zl}');
    Error('\P{:=_ Is_zl}');
    Expect(1, 8232, '\p{iszl}', "");
    Expect(0, 8232, '\p{^iszl}', "");
    Expect(0, 8232, '\P{iszl}', "");
    Expect(1, 8232, '\P{^iszl}', "");
    Expect(0, 8233, '\p{iszl}', "");
    Expect(1, 8233, '\p{^iszl}', "");
    Expect(1, 8233, '\P{iszl}', "");
    Expect(0, 8233, '\P{^iszl}', "");
    Expect(1, 8232, '\p{_ Is_Zl}', "");
    Expect(0, 8232, '\p{^_ Is_Zl}', "");
    Expect(0, 8232, '\P{_ Is_Zl}', "");
    Expect(1, 8232, '\P{^_ Is_Zl}', "");
    Expect(0, 8233, '\p{_ Is_Zl}', "");
    Expect(1, 8233, '\p{^_ Is_Zl}', "");
    Expect(1, 8233, '\P{_ Is_Zl}', "");
    Expect(0, 8233, '\P{^_ Is_Zl}', "");
    Error('\p{	/a/Linear_A}');
    Error('\P{	/a/Linear_A}');
    Expect(1, 67431, '\p{lineara}', "");
    Expect(0, 67431, '\p{^lineara}', "");
    Expect(0, 67431, '\P{lineara}', "");
    Expect(1, 67431, '\P{^lineara}', "");
    Expect(0, 67432, '\p{lineara}', "");
    Expect(1, 67432, '\p{^lineara}', "");
    Expect(1, 67432, '\P{lineara}', "");
    Expect(0, 67432, '\P{^lineara}', "");
    Expect(1, 67431, '\p{_Linear_A}', "");
    Expect(0, 67431, '\p{^_Linear_A}', "");
    Expect(0, 67431, '\P{_Linear_A}', "");
    Expect(1, 67431, '\P{^_Linear_A}', "");
    Expect(0, 67432, '\p{_Linear_A}', "");
    Expect(1, 67432, '\p{^_Linear_A}', "");
    Expect(1, 67432, '\P{_Linear_A}', "");
    Expect(0, 67432, '\P{^_Linear_A}', "");
    Error('\p{:=- is_LINEAR_A}');
    Error('\P{:=- is_LINEAR_A}');
    Expect(1, 67431, '\p{islineara}', "");
    Expect(0, 67431, '\p{^islineara}', "");
    Expect(0, 67431, '\P{islineara}', "");
    Expect(1, 67431, '\P{^islineara}', "");
    Expect(0, 67432, '\p{islineara}', "");
    Expect(1, 67432, '\p{^islineara}', "");
    Expect(1, 67432, '\P{islineara}', "");
    Expect(0, 67432, '\P{^islineara}', "");
    Expect(1, 67431, '\p{_Is_Linear_A}', "");
    Expect(0, 67431, '\p{^_Is_Linear_A}', "");
    Expect(0, 67431, '\P{_Is_Linear_A}', "");
    Expect(1, 67431, '\P{^_Is_Linear_A}', "");
    Expect(0, 67432, '\p{_Is_Linear_A}', "");
    Expect(1, 67432, '\p{^_Is_Linear_A}', "");
    Expect(1, 67432, '\P{_Is_Linear_A}', "");
    Expect(0, 67432, '\P{^_Is_Linear_A}', "");
    Error('\p{/a/	LINA}');
    Error('\P{/a/	LINA}');
    Expect(1, 67431, '\p{lina}', "");
    Expect(0, 67431, '\p{^lina}', "");
    Expect(0, 67431, '\P{lina}', "");
    Expect(1, 67431, '\P{^lina}', "");
    Expect(0, 67432, '\p{lina}', "");
    Expect(1, 67432, '\p{^lina}', "");
    Expect(1, 67432, '\P{lina}', "");
    Expect(0, 67432, '\P{^lina}', "");
    Expect(1, 67431, '\p{__Lina}', "");
    Expect(0, 67431, '\p{^__Lina}', "");
    Expect(0, 67431, '\P{__Lina}', "");
    Expect(1, 67431, '\P{^__Lina}', "");
    Expect(0, 67432, '\p{__Lina}', "");
    Expect(1, 67432, '\p{^__Lina}', "");
    Expect(1, 67432, '\P{__Lina}', "");
    Expect(0, 67432, '\P{^__Lina}', "");
    Error('\p{_-Is_lina:=}');
    Error('\P{_-Is_lina:=}');
    Expect(1, 67431, '\p{islina}', "");
    Expect(0, 67431, '\p{^islina}', "");
    Expect(0, 67431, '\P{islina}', "");
    Expect(1, 67431, '\P{^islina}', "");
    Expect(0, 67432, '\p{islina}', "");
    Expect(1, 67432, '\p{^islina}', "");
    Expect(1, 67432, '\P{islina}', "");
    Expect(0, 67432, '\P{^islina}', "");
    Expect(1, 67431, '\p{_	Is_Lina}', "");
    Expect(0, 67431, '\p{^_	Is_Lina}', "");
    Expect(0, 67431, '\P{_	Is_Lina}', "");
    Expect(1, 67431, '\P{^_	Is_Lina}', "");
    Expect(0, 67432, '\p{_	Is_Lina}', "");
    Expect(1, 67432, '\p{^_	Is_Lina}', "");
    Expect(1, 67432, '\P{_	Is_Lina}', "");
    Expect(0, 67432, '\P{^_	Is_Lina}', "");
    Error('\p{:=-Linear_B}');
    Error('\P{:=-Linear_B}');
    Expect(1, 65855, '\p{linearb}', "");
    Expect(0, 65855, '\p{^linearb}', "");
    Expect(0, 65855, '\P{linearb}', "");
    Expect(1, 65855, '\P{^linearb}', "");
    Expect(0, 65856, '\p{linearb}', "");
    Expect(1, 65856, '\p{^linearb}', "");
    Expect(1, 65856, '\P{linearb}', "");
    Expect(0, 65856, '\P{^linearb}', "");
    Expect(1, 65855, '\p{LINEAR_b}', "");
    Expect(0, 65855, '\p{^LINEAR_b}', "");
    Expect(0, 65855, '\P{LINEAR_b}', "");
    Expect(1, 65855, '\P{^LINEAR_b}', "");
    Expect(0, 65856, '\p{LINEAR_b}', "");
    Expect(1, 65856, '\p{^LINEAR_b}', "");
    Expect(1, 65856, '\P{LINEAR_b}', "");
    Expect(0, 65856, '\P{^LINEAR_b}', "");
    Error('\p{ Is_LINEAR_b/a/}');
    Error('\P{ Is_LINEAR_b/a/}');
    Expect(1, 65855, '\p{islinearb}', "");
    Expect(0, 65855, '\p{^islinearb}', "");
    Expect(0, 65855, '\P{islinearb}', "");
    Expect(1, 65855, '\P{^islinearb}', "");
    Expect(0, 65856, '\p{islinearb}', "");
    Expect(1, 65856, '\p{^islinearb}', "");
    Expect(1, 65856, '\P{islinearb}', "");
    Expect(0, 65856, '\P{^islinearb}', "");
    Expect(1, 65855, '\p{_	is_Linear_B}', "");
    Expect(0, 65855, '\p{^_	is_Linear_B}', "");
    Expect(0, 65855, '\P{_	is_Linear_B}', "");
    Expect(1, 65855, '\P{^_	is_Linear_B}', "");
    Expect(0, 65856, '\p{_	is_Linear_B}', "");
    Expect(1, 65856, '\p{^_	is_Linear_B}', "");
    Expect(1, 65856, '\P{_	is_Linear_B}', "");
    Expect(0, 65856, '\P{^_	is_Linear_B}', "");
    Error('\p{_-Linb/a/}');
    Error('\P{_-Linb/a/}');
    Expect(1, 65855, '\p{linb}', "");
    Expect(0, 65855, '\p{^linb}', "");
    Expect(0, 65855, '\P{linb}', "");
    Expect(1, 65855, '\P{^linb}', "");
    Expect(0, 65856, '\p{linb}', "");
    Expect(1, 65856, '\p{^linb}', "");
    Expect(1, 65856, '\P{linb}', "");
    Expect(0, 65856, '\P{^linb}', "");
    Expect(1, 65855, '\p{		Linb}', "");
    Expect(0, 65855, '\p{^		Linb}', "");
    Expect(0, 65855, '\P{		Linb}', "");
    Expect(1, 65855, '\P{^		Linb}', "");
    Expect(0, 65856, '\p{		Linb}', "");
    Expect(1, 65856, '\p{^		Linb}', "");
    Expect(1, 65856, '\P{		Linb}', "");
    Expect(0, 65856, '\P{^		Linb}', "");
    Error('\p{Is_LINB/a/}');
    Error('\P{Is_LINB/a/}');
    Expect(1, 65855, '\p{islinb}', "");
    Expect(0, 65855, '\p{^islinb}', "");
    Expect(0, 65855, '\P{islinb}', "");
    Expect(1, 65855, '\P{^islinb}', "");
    Expect(0, 65856, '\p{islinb}', "");
    Expect(1, 65856, '\p{^islinb}', "");
    Expect(1, 65856, '\P{islinb}', "");
    Expect(0, 65856, '\P{^islinb}', "");
    Expect(1, 65855, '\p{__Is_LINB}', "");
    Expect(0, 65855, '\p{^__Is_LINB}', "");
    Expect(0, 65855, '\P{__Is_LINB}', "");
    Expect(1, 65855, '\P{^__Is_LINB}', "");
    Expect(0, 65856, '\p{__Is_LINB}', "");
    Expect(1, 65856, '\p{^__Is_LINB}', "");
    Expect(1, 65856, '\P{__Is_LINB}', "");
    Expect(0, 65856, '\P{^__Is_LINB}', "");
    Error('\p{_-Linear_b_Ideograms:=}');
    Error('\P{_-Linear_b_Ideograms:=}');
    Expect(1, 65791, '\p{linearbideograms}', "");
    Expect(0, 65791, '\p{^linearbideograms}', "");
    Expect(0, 65791, '\P{linearbideograms}', "");
    Expect(1, 65791, '\P{^linearbideograms}', "");
    Expect(0, 65792, '\p{linearbideograms}', "");
    Expect(1, 65792, '\p{^linearbideograms}', "");
    Expect(1, 65792, '\P{linearbideograms}', "");
    Expect(0, 65792, '\P{^linearbideograms}', "");
    Expect(1, 65791, '\p{_ Linear_B_Ideograms}', "");
    Expect(0, 65791, '\p{^_ Linear_B_Ideograms}', "");
    Expect(0, 65791, '\P{_ Linear_B_Ideograms}', "");
    Expect(1, 65791, '\P{^_ Linear_B_Ideograms}', "");
    Expect(0, 65792, '\p{_ Linear_B_Ideograms}', "");
    Expect(1, 65792, '\p{^_ Linear_B_Ideograms}', "");
    Expect(1, 65792, '\P{_ Linear_B_Ideograms}', "");
    Expect(0, 65792, '\P{^_ Linear_B_Ideograms}', "");
    Error('\p{:=Is_Linear_B_ideograms}');
    Error('\P{:=Is_Linear_B_ideograms}');
    Expect(1, 65791, '\p{islinearbideograms}', "");
    Expect(0, 65791, '\p{^islinearbideograms}', "");
    Expect(0, 65791, '\P{islinearbideograms}', "");
    Expect(1, 65791, '\P{^islinearbideograms}', "");
    Expect(0, 65792, '\p{islinearbideograms}', "");
    Expect(1, 65792, '\p{^islinearbideograms}', "");
    Expect(1, 65792, '\P{islinearbideograms}', "");
    Expect(0, 65792, '\P{^islinearbideograms}', "");
    Expect(1, 65791, '\p{		Is_linear_B_Ideograms}', "");
    Expect(0, 65791, '\p{^		Is_linear_B_Ideograms}', "");
    Expect(0, 65791, '\P{		Is_linear_B_Ideograms}', "");
    Expect(1, 65791, '\P{^		Is_linear_B_Ideograms}', "");
    Expect(0, 65792, '\p{		Is_linear_B_Ideograms}', "");
    Expect(1, 65792, '\p{^		Is_linear_B_Ideograms}', "");
    Expect(1, 65792, '\P{		Is_linear_B_Ideograms}', "");
    Expect(0, 65792, '\P{^		Is_linear_B_Ideograms}', "");
    Error('\p{ IN_Linear_B_Ideograms:=}');
    Error('\P{ IN_Linear_B_Ideograms:=}');
    Expect(1, 65791, '\p{inlinearbideograms}', "");
    Expect(0, 65791, '\p{^inlinearbideograms}', "");
    Expect(0, 65791, '\P{inlinearbideograms}', "");
    Expect(1, 65791, '\P{^inlinearbideograms}', "");
    Expect(0, 65792, '\p{inlinearbideograms}', "");
    Expect(1, 65792, '\p{^inlinearbideograms}', "");
    Expect(1, 65792, '\P{inlinearbideograms}', "");
    Expect(0, 65792, '\P{^inlinearbideograms}', "");
    Expect(1, 65791, '\p{		in_Linear_B_IDEOGRAMS}', "");
    Expect(0, 65791, '\p{^		in_Linear_B_IDEOGRAMS}', "");
    Expect(0, 65791, '\P{		in_Linear_B_IDEOGRAMS}', "");
    Expect(1, 65791, '\P{^		in_Linear_B_IDEOGRAMS}', "");
    Expect(0, 65792, '\p{		in_Linear_B_IDEOGRAMS}', "");
    Expect(1, 65792, '\p{^		in_Linear_B_IDEOGRAMS}', "");
    Expect(1, 65792, '\P{		in_Linear_B_IDEOGRAMS}', "");
    Expect(0, 65792, '\P{^		in_Linear_B_IDEOGRAMS}', "");
    Error('\p{/a/Linear_B_SYLLABARY}');
    Error('\P{/a/Linear_B_SYLLABARY}');
    Expect(1, 65663, '\p{linearbsyllabary}', "");
    Expect(0, 65663, '\p{^linearbsyllabary}', "");
    Expect(0, 65663, '\P{linearbsyllabary}', "");
    Expect(1, 65663, '\P{^linearbsyllabary}', "");
    Expect(0, 65664, '\p{linearbsyllabary}', "");
    Expect(1, 65664, '\p{^linearbsyllabary}', "");
    Expect(1, 65664, '\P{linearbsyllabary}', "");
    Expect(0, 65664, '\P{^linearbsyllabary}', "");
    Expect(1, 65663, '\p{	Linear_B_Syllabary}', "");
    Expect(0, 65663, '\p{^	Linear_B_Syllabary}', "");
    Expect(0, 65663, '\P{	Linear_B_Syllabary}', "");
    Expect(1, 65663, '\P{^	Linear_B_Syllabary}', "");
    Expect(0, 65664, '\p{	Linear_B_Syllabary}', "");
    Expect(1, 65664, '\p{^	Linear_B_Syllabary}', "");
    Expect(1, 65664, '\P{	Linear_B_Syllabary}', "");
    Expect(0, 65664, '\P{^	Linear_B_Syllabary}', "");
    Error('\p{	 IS_Linear_B_SYLLABARY:=}');
    Error('\P{	 IS_Linear_B_SYLLABARY:=}');
    Expect(1, 65663, '\p{islinearbsyllabary}', "");
    Expect(0, 65663, '\p{^islinearbsyllabary}', "");
    Expect(0, 65663, '\P{islinearbsyllabary}', "");
    Expect(1, 65663, '\P{^islinearbsyllabary}', "");
    Expect(0, 65664, '\p{islinearbsyllabary}', "");
    Expect(1, 65664, '\p{^islinearbsyllabary}', "");
    Expect(1, 65664, '\P{islinearbsyllabary}', "");
    Expect(0, 65664, '\P{^islinearbsyllabary}', "");
    Expect(1, 65663, '\p{-Is_Linear_B_Syllabary}', "");
    Expect(0, 65663, '\p{^-Is_Linear_B_Syllabary}', "");
    Expect(0, 65663, '\P{-Is_Linear_B_Syllabary}', "");
    Expect(1, 65663, '\P{^-Is_Linear_B_Syllabary}', "");
    Expect(0, 65664, '\p{-Is_Linear_B_Syllabary}', "");
    Expect(1, 65664, '\p{^-Is_Linear_B_Syllabary}', "");
    Expect(1, 65664, '\P{-Is_Linear_B_Syllabary}', "");
    Expect(0, 65664, '\P{^-Is_Linear_B_Syllabary}', "");
    Error('\p{_In_Linear_B_SYLLABARY:=}');
    Error('\P{_In_Linear_B_SYLLABARY:=}');
    Expect(1, 65663, '\p{inlinearbsyllabary}', "");
    Expect(0, 65663, '\p{^inlinearbsyllabary}', "");
    Expect(0, 65663, '\P{inlinearbsyllabary}', "");
    Expect(1, 65663, '\P{^inlinearbsyllabary}', "");
    Expect(0, 65664, '\p{inlinearbsyllabary}', "");
    Expect(1, 65664, '\p{^inlinearbsyllabary}', "");
    Expect(1, 65664, '\P{inlinearbsyllabary}', "");
    Expect(0, 65664, '\P{^inlinearbsyllabary}', "");
    Expect(1, 65663, '\p{-In_LINEAR_B_Syllabary}', "");
    Expect(0, 65663, '\p{^-In_LINEAR_B_Syllabary}', "");
    Expect(0, 65663, '\P{-In_LINEAR_B_Syllabary}', "");
    Expect(1, 65663, '\P{^-In_LINEAR_B_Syllabary}', "");
    Expect(0, 65664, '\p{-In_LINEAR_B_Syllabary}', "");
    Expect(1, 65664, '\p{^-In_LINEAR_B_Syllabary}', "");
    Expect(1, 65664, '\P{-In_LINEAR_B_Syllabary}', "");
    Expect(0, 65664, '\P{^-In_LINEAR_B_Syllabary}', "");
    Error('\p{	-lisu:=}');
    Error('\P{	-lisu:=}');
    Expect(1, 42239, '\p{lisu}', "");
    Expect(0, 42239, '\p{^lisu}', "");
    Expect(0, 42239, '\P{lisu}', "");
    Expect(1, 42239, '\P{^lisu}', "");
    Expect(0, 42240, '\p{lisu}', "");
    Expect(1, 42240, '\p{^lisu}', "");
    Expect(1, 42240, '\P{lisu}', "");
    Expect(0, 42240, '\P{^lisu}', "");
    Expect(1, 42239, '\p{-	Lisu}', "");
    Expect(0, 42239, '\p{^-	Lisu}', "");
    Expect(0, 42239, '\P{-	Lisu}', "");
    Expect(1, 42239, '\P{^-	Lisu}', "");
    Expect(0, 42240, '\p{-	Lisu}', "");
    Expect(1, 42240, '\p{^-	Lisu}', "");
    Expect(1, 42240, '\P{-	Lisu}', "");
    Expect(0, 42240, '\P{^-	Lisu}', "");
    Error('\p{-is_Lisu:=}');
    Error('\P{-is_Lisu:=}');
    Expect(1, 42239, '\p{islisu}', "");
    Expect(0, 42239, '\p{^islisu}', "");
    Expect(0, 42239, '\P{islisu}', "");
    Expect(1, 42239, '\P{^islisu}', "");
    Expect(0, 42240, '\p{islisu}', "");
    Expect(1, 42240, '\p{^islisu}', "");
    Expect(1, 42240, '\P{islisu}', "");
    Expect(0, 42240, '\P{^islisu}', "");
    Expect(1, 42239, '\p{  Is_Lisu}', "");
    Expect(0, 42239, '\p{^  Is_Lisu}', "");
    Expect(0, 42239, '\P{  Is_Lisu}', "");
    Expect(1, 42239, '\P{^  Is_Lisu}', "");
    Expect(0, 42240, '\p{  Is_Lisu}', "");
    Expect(1, 42240, '\p{^  Is_Lisu}', "");
    Expect(1, 42240, '\P{  Is_Lisu}', "");
    Expect(0, 42240, '\P{^  Is_Lisu}', "");
    Error('\p{:=-LOGICAL_Order_EXCEPTION}');
    Error('\P{:=-LOGICAL_Order_EXCEPTION}');
    Expect(1, 43708, '\p{logicalorderexception}', "");
    Expect(0, 43708, '\p{^logicalorderexception}', "");
    Expect(0, 43708, '\P{logicalorderexception}', "");
    Expect(1, 43708, '\P{^logicalorderexception}', "");
    Expect(0, 43709, '\p{logicalorderexception}', "");
    Expect(1, 43709, '\p{^logicalorderexception}', "");
    Expect(1, 43709, '\P{logicalorderexception}', "");
    Expect(0, 43709, '\P{^logicalorderexception}', "");
    Expect(1, 43708, '\p{ LOGICAL_order_exception}', "");
    Expect(0, 43708, '\p{^ LOGICAL_order_exception}', "");
    Expect(0, 43708, '\P{ LOGICAL_order_exception}', "");
    Expect(1, 43708, '\P{^ LOGICAL_order_exception}', "");
    Expect(0, 43709, '\p{ LOGICAL_order_exception}', "");
    Expect(1, 43709, '\p{^ LOGICAL_order_exception}', "");
    Expect(1, 43709, '\P{ LOGICAL_order_exception}', "");
    Expect(0, 43709, '\P{^ LOGICAL_order_exception}', "");
    Error('\p{/a/-_Is_LOGICAL_Order_Exception}');
    Error('\P{/a/-_Is_LOGICAL_Order_Exception}');
    Expect(1, 43708, '\p{islogicalorderexception}', "");
    Expect(0, 43708, '\p{^islogicalorderexception}', "");
    Expect(0, 43708, '\P{islogicalorderexception}', "");
    Expect(1, 43708, '\P{^islogicalorderexception}', "");
    Expect(0, 43709, '\p{islogicalorderexception}', "");
    Expect(1, 43709, '\p{^islogicalorderexception}', "");
    Expect(1, 43709, '\P{islogicalorderexception}', "");
    Expect(0, 43709, '\P{^islogicalorderexception}', "");
    Expect(1, 43708, '\p{_	IS_logical_ORDER_Exception}', "");
    Expect(0, 43708, '\p{^_	IS_logical_ORDER_Exception}', "");
    Expect(0, 43708, '\P{_	IS_logical_ORDER_Exception}', "");
    Expect(1, 43708, '\P{^_	IS_logical_ORDER_Exception}', "");
    Expect(0, 43709, '\p{_	IS_logical_ORDER_Exception}', "");
    Expect(1, 43709, '\p{^_	IS_logical_ORDER_Exception}', "");
    Expect(1, 43709, '\P{_	IS_logical_ORDER_Exception}', "");
    Expect(0, 43709, '\P{^_	IS_logical_ORDER_Exception}', "");
    Error('\p{LOE/a/}');
    Error('\P{LOE/a/}');
    Expect(1, 43708, '\p{loe}', "");
    Expect(0, 43708, '\p{^loe}', "");
    Expect(0, 43708, '\P{loe}', "");
    Expect(1, 43708, '\P{^loe}', "");
    Expect(0, 43709, '\p{loe}', "");
    Expect(1, 43709, '\p{^loe}', "");
    Expect(1, 43709, '\P{loe}', "");
    Expect(0, 43709, '\P{^loe}', "");
    Expect(1, 43708, '\p{_LOE}', "");
    Expect(0, 43708, '\p{^_LOE}', "");
    Expect(0, 43708, '\P{_LOE}', "");
    Expect(1, 43708, '\P{^_LOE}', "");
    Expect(0, 43709, '\p{_LOE}', "");
    Expect(1, 43709, '\p{^_LOE}', "");
    Expect(1, 43709, '\P{_LOE}', "");
    Expect(0, 43709, '\P{^_LOE}', "");
    Error('\p{	 Is_LOE:=}');
    Error('\P{	 Is_LOE:=}');
    Expect(1, 43708, '\p{isloe}', "");
    Expect(0, 43708, '\p{^isloe}', "");
    Expect(0, 43708, '\P{isloe}', "");
    Expect(1, 43708, '\P{^isloe}', "");
    Expect(0, 43709, '\p{isloe}', "");
    Expect(1, 43709, '\p{^isloe}', "");
    Expect(1, 43709, '\P{isloe}', "");
    Expect(0, 43709, '\P{^isloe}', "");
    Expect(1, 43708, '\p{ _is_LOE}', "");
    Expect(0, 43708, '\p{^ _is_LOE}', "");
    Expect(0, 43708, '\P{ _is_LOE}', "");
    Expect(1, 43708, '\P{^ _is_LOE}', "");
    Expect(0, 43709, '\p{ _is_LOE}', "");
    Expect(1, 43709, '\p{^ _is_LOE}', "");
    Expect(1, 43709, '\P{ _is_LOE}', "");
    Expect(0, 43709, '\P{^ _is_LOE}', "");
    Error('\p{ :=LOW_surrogates}');
    Error('\P{ :=LOW_surrogates}');
    Expect(1, 57343, '\p{lowsurrogates}', "");
    Expect(0, 57343, '\p{^lowsurrogates}', "");
    Expect(0, 57343, '\P{lowsurrogates}', "");
    Expect(1, 57343, '\P{^lowsurrogates}', "");
    Expect(0, 57344, '\p{lowsurrogates}', "");
    Expect(1, 57344, '\p{^lowsurrogates}', "");
    Expect(1, 57344, '\P{lowsurrogates}', "");
    Expect(0, 57344, '\P{^lowsurrogates}', "");
    Expect(1, 57343, '\p{_ low_surrogates}', "");
    Expect(0, 57343, '\p{^_ low_surrogates}', "");
    Expect(0, 57343, '\P{_ low_surrogates}', "");
    Expect(1, 57343, '\P{^_ low_surrogates}', "");
    Expect(0, 57344, '\p{_ low_surrogates}', "");
    Expect(1, 57344, '\p{^_ low_surrogates}', "");
    Expect(1, 57344, '\P{_ low_surrogates}', "");
    Expect(0, 57344, '\P{^_ low_surrogates}', "");
    Error('\p{	:=IS_LOW_Surrogates}');
    Error('\P{	:=IS_LOW_Surrogates}');
    Expect(1, 57343, '\p{islowsurrogates}', "");
    Expect(0, 57343, '\p{^islowsurrogates}', "");
    Expect(0, 57343, '\P{islowsurrogates}', "");
    Expect(1, 57343, '\P{^islowsurrogates}', "");
    Expect(0, 57344, '\p{islowsurrogates}', "");
    Expect(1, 57344, '\p{^islowsurrogates}', "");
    Expect(1, 57344, '\P{islowsurrogates}', "");
    Expect(0, 57344, '\P{^islowsurrogates}', "");
    Expect(1, 57343, '\p{ -is_Low_surrogates}', "");
    Expect(0, 57343, '\p{^ -is_Low_surrogates}', "");
    Expect(0, 57343, '\P{ -is_Low_surrogates}', "");
    Expect(1, 57343, '\P{^ -is_Low_surrogates}', "");
    Expect(0, 57344, '\p{ -is_Low_surrogates}', "");
    Expect(1, 57344, '\p{^ -is_Low_surrogates}', "");
    Expect(1, 57344, '\P{ -is_Low_surrogates}', "");
    Expect(0, 57344, '\P{^ -is_Low_surrogates}', "");
    Error('\p{ :=In_Low_Surrogates}');
    Error('\P{ :=In_Low_Surrogates}');
    Expect(1, 57343, '\p{inlowsurrogates}', "");
    Expect(0, 57343, '\p{^inlowsurrogates}', "");
    Expect(0, 57343, '\P{inlowsurrogates}', "");
    Expect(1, 57343, '\P{^inlowsurrogates}', "");
    Expect(0, 57344, '\p{inlowsurrogates}', "");
    Expect(1, 57344, '\p{^inlowsurrogates}', "");
    Expect(1, 57344, '\P{inlowsurrogates}', "");
    Expect(0, 57344, '\P{^inlowsurrogates}', "");
    Expect(1, 57343, '\p{-	in_Low_SURROGATES}', "");
    Expect(0, 57343, '\p{^-	in_Low_SURROGATES}', "");
    Expect(0, 57343, '\P{-	in_Low_SURROGATES}', "");
    Expect(1, 57343, '\P{^-	in_Low_SURROGATES}', "");
    Expect(0, 57344, '\p{-	in_Low_SURROGATES}', "");
    Expect(1, 57344, '\p{^-	in_Low_SURROGATES}', "");
    Expect(1, 57344, '\P{-	in_Low_SURROGATES}', "");
    Expect(0, 57344, '\P{^-	in_Low_SURROGATES}', "");
    Error('\p{:=--lowercase_letter}');
    Error('\P{:=--lowercase_letter}');
    Expect(1, 125251, '\p{lowercaseletter}', "");
    Expect(0, 125251, '\p{^lowercaseletter}', "");
    Expect(0, 125251, '\P{lowercaseletter}', "");
    Expect(1, 125251, '\P{^lowercaseletter}', "");
    Expect(0, 125252, '\p{lowercaseletter}', "");
    Expect(1, 125252, '\p{^lowercaseletter}', "");
    Expect(1, 125252, '\P{lowercaseletter}', "");
    Expect(0, 125252, '\P{^lowercaseletter}', "");
    Expect(1, 125251, '\p{	_Lowercase_Letter}', "");
    Expect(0, 125251, '\p{^	_Lowercase_Letter}', "");
    Expect(0, 125251, '\P{	_Lowercase_Letter}', "");
    Expect(1, 125251, '\P{^	_Lowercase_Letter}', "");
    Expect(0, 125252, '\p{	_Lowercase_Letter}', "");
    Expect(1, 125252, '\p{^	_Lowercase_Letter}', "");
    Expect(1, 125252, '\P{	_Lowercase_Letter}', "");
    Expect(0, 125252, '\P{^	_Lowercase_Letter}', "");
    Error('\p{	-Is_Lowercase_letter/a/}');
    Error('\P{	-Is_Lowercase_letter/a/}');
    Expect(1, 125251, '\p{islowercaseletter}', "");
    Expect(0, 125251, '\p{^islowercaseletter}', "");
    Expect(0, 125251, '\P{islowercaseletter}', "");
    Expect(1, 125251, '\P{^islowercaseletter}', "");
    Expect(0, 125252, '\p{islowercaseletter}', "");
    Expect(1, 125252, '\p{^islowercaseletter}', "");
    Expect(1, 125252, '\P{islowercaseletter}', "");
    Expect(0, 125252, '\P{^islowercaseletter}', "");
    Expect(1, 125251, '\p{	IS_LOWERCASE_LETTER}', "");
    Expect(0, 125251, '\p{^	IS_LOWERCASE_LETTER}', "");
    Expect(0, 125251, '\P{	IS_LOWERCASE_LETTER}', "");
    Expect(1, 125251, '\P{^	IS_LOWERCASE_LETTER}', "");
    Expect(0, 125252, '\p{	IS_LOWERCASE_LETTER}', "");
    Expect(1, 125252, '\p{^	IS_LOWERCASE_LETTER}', "");
    Expect(1, 125252, '\P{	IS_LOWERCASE_LETTER}', "");
    Expect(0, 125252, '\P{^	IS_LOWERCASE_LETTER}', "");
    Error('\p{:=-ll}');
    Error('\P{:=-ll}');
    Expect(1, 125251, '\p{ll}', "");
    Expect(0, 125251, '\p{^ll}', "");
    Expect(0, 125251, '\P{ll}', "");
    Expect(1, 125251, '\P{^ll}', "");
    Expect(0, 125252, '\p{ll}', "");
    Expect(1, 125252, '\p{^ll}', "");
    Expect(1, 125252, '\P{ll}', "");
    Expect(0, 125252, '\P{^ll}', "");
    Expect(1, 125251, '\p{_-Ll}', "");
    Expect(0, 125251, '\p{^_-Ll}', "");
    Expect(0, 125251, '\P{_-Ll}', "");
    Expect(1, 125251, '\P{^_-Ll}', "");
    Expect(0, 125252, '\p{_-Ll}', "");
    Expect(1, 125252, '\p{^_-Ll}', "");
    Expect(1, 125252, '\P{_-Ll}', "");
    Expect(0, 125252, '\P{^_-Ll}', "");
    Error('\p{/a/	_Is_Ll}');
    Error('\P{/a/	_Is_Ll}');
    Expect(1, 125251, '\p{isll}', "");
    Expect(0, 125251, '\p{^isll}', "");
    Expect(0, 125251, '\P{isll}', "");
    Expect(1, 125251, '\P{^isll}', "");
    Expect(0, 125252, '\p{isll}', "");
    Expect(1, 125252, '\p{^isll}', "");
    Expect(1, 125252, '\P{isll}', "");
    Expect(0, 125252, '\P{^isll}', "");
    Expect(1, 125251, '\p{		IS_LL}', "");
    Expect(0, 125251, '\p{^		IS_LL}', "");
    Expect(0, 125251, '\P{		IS_LL}', "");
    Expect(1, 125251, '\P{^		IS_LL}', "");
    Expect(0, 125252, '\p{		IS_LL}', "");
    Expect(1, 125252, '\p{^		IS_LL}', "");
    Expect(1, 125252, '\P{		IS_LL}', "");
    Expect(0, 125252, '\P{^		IS_LL}', "");
    Error('\p{__Lycian/a/}');
    Error('\P{__Lycian/a/}');
    Expect(1, 66204, '\p{lycian}', "");
    Expect(0, 66204, '\p{^lycian}', "");
    Expect(0, 66204, '\P{lycian}', "");
    Expect(1, 66204, '\P{^lycian}', "");
    Expect(0, 66205, '\p{lycian}', "");
    Expect(1, 66205, '\p{^lycian}', "");
    Expect(1, 66205, '\P{lycian}', "");
    Expect(0, 66205, '\P{^lycian}', "");
    Expect(1, 66204, '\p{	 LYCIAN}', "");
    Expect(0, 66204, '\p{^	 LYCIAN}', "");
    Expect(0, 66204, '\P{	 LYCIAN}', "");
    Expect(1, 66204, '\P{^	 LYCIAN}', "");
    Expect(0, 66205, '\p{	 LYCIAN}', "");
    Expect(1, 66205, '\p{^	 LYCIAN}', "");
    Expect(1, 66205, '\P{	 LYCIAN}', "");
    Expect(0, 66205, '\P{^	 LYCIAN}', "");
    Error('\p{/a/ Is_LYCIAN}');
    Error('\P{/a/ Is_LYCIAN}');
    Expect(1, 66204, '\p{islycian}', "");
    Expect(0, 66204, '\p{^islycian}', "");
    Expect(0, 66204, '\P{islycian}', "");
    Expect(1, 66204, '\P{^islycian}', "");
    Expect(0, 66205, '\p{islycian}', "");
    Expect(1, 66205, '\p{^islycian}', "");
    Expect(1, 66205, '\P{islycian}', "");
    Expect(0, 66205, '\P{^islycian}', "");
    Expect(1, 66204, '\p{_	is_lycian}', "");
    Expect(0, 66204, '\p{^_	is_lycian}', "");
    Expect(0, 66204, '\P{_	is_lycian}', "");
    Expect(1, 66204, '\P{^_	is_lycian}', "");
    Expect(0, 66205, '\p{_	is_lycian}', "");
    Expect(1, 66205, '\p{^_	is_lycian}', "");
    Expect(1, 66205, '\P{_	is_lycian}', "");
    Expect(0, 66205, '\P{^_	is_lycian}', "");
    Error('\p{:= 	Lyci}');
    Error('\P{:= 	Lyci}');
    Expect(1, 66204, '\p{lyci}', "");
    Expect(0, 66204, '\p{^lyci}', "");
    Expect(0, 66204, '\P{lyci}', "");
    Expect(1, 66204, '\P{^lyci}', "");
    Expect(0, 66205, '\p{lyci}', "");
    Expect(1, 66205, '\p{^lyci}', "");
    Expect(1, 66205, '\P{lyci}', "");
    Expect(0, 66205, '\P{^lyci}', "");
    Expect(1, 66204, '\p{  lyci}', "");
    Expect(0, 66204, '\p{^  lyci}', "");
    Expect(0, 66204, '\P{  lyci}', "");
    Expect(1, 66204, '\P{^  lyci}', "");
    Expect(0, 66205, '\p{  lyci}', "");
    Expect(1, 66205, '\p{^  lyci}', "");
    Expect(1, 66205, '\P{  lyci}', "");
    Expect(0, 66205, '\P{^  lyci}', "");
    Error('\p{ IS_Lyci/a/}');
    Error('\P{ IS_Lyci/a/}');
    Expect(1, 66204, '\p{islyci}', "");
    Expect(0, 66204, '\p{^islyci}', "");
    Expect(0, 66204, '\P{islyci}', "");
    Expect(1, 66204, '\P{^islyci}', "");
    Expect(0, 66205, '\p{islyci}', "");
    Expect(1, 66205, '\p{^islyci}', "");
    Expect(1, 66205, '\P{islyci}', "");
    Expect(0, 66205, '\P{^islyci}', "");
    Expect(1, 66204, '\p{ _Is_Lyci}', "");
    Expect(0, 66204, '\p{^ _Is_Lyci}', "");
    Expect(0, 66204, '\P{ _Is_Lyci}', "");
    Expect(1, 66204, '\P{^ _Is_Lyci}', "");
    Expect(0, 66205, '\p{ _Is_Lyci}', "");
    Expect(1, 66205, '\p{^ _Is_Lyci}', "");
    Expect(1, 66205, '\P{ _Is_Lyci}', "");
    Expect(0, 66205, '\P{^ _Is_Lyci}', "");
    Error('\p{:=_Lydian}');
    Error('\P{:=_Lydian}');
    Expect(1, 67903, '\p{lydian}', "");
    Expect(0, 67903, '\p{^lydian}', "");
    Expect(0, 67903, '\P{lydian}', "");
    Expect(1, 67903, '\P{^lydian}', "");
    Expect(0, 67904, '\p{lydian}', "");
    Expect(1, 67904, '\p{^lydian}', "");
    Expect(1, 67904, '\P{lydian}', "");
    Expect(0, 67904, '\P{^lydian}', "");
    Expect(1, 67903, '\p{_Lydian}', "");
    Expect(0, 67903, '\p{^_Lydian}', "");
    Expect(0, 67903, '\P{_Lydian}', "");
    Expect(1, 67903, '\P{^_Lydian}', "");
    Expect(0, 67904, '\p{_Lydian}', "");
    Expect(1, 67904, '\p{^_Lydian}', "");
    Expect(1, 67904, '\P{_Lydian}', "");
    Expect(0, 67904, '\P{^_Lydian}', "");
    Error('\p{--is_LYDIAN/a/}');
    Error('\P{--is_LYDIAN/a/}');
    Expect(1, 67903, '\p{islydian}', "");
    Expect(0, 67903, '\p{^islydian}', "");
    Expect(0, 67903, '\P{islydian}', "");
    Expect(1, 67903, '\P{^islydian}', "");
    Expect(0, 67904, '\p{islydian}', "");
    Expect(1, 67904, '\p{^islydian}', "");
    Expect(1, 67904, '\P{islydian}', "");
    Expect(0, 67904, '\P{^islydian}', "");
    Expect(1, 67903, '\p{_IS_Lydian}', "");
    Expect(0, 67903, '\p{^_IS_Lydian}', "");
    Expect(0, 67903, '\P{_IS_Lydian}', "");
    Expect(1, 67903, '\P{^_IS_Lydian}', "");
    Expect(0, 67904, '\p{_IS_Lydian}', "");
    Expect(1, 67904, '\p{^_IS_Lydian}', "");
    Expect(1, 67904, '\P{_IS_Lydian}', "");
    Expect(0, 67904, '\P{^_IS_Lydian}', "");
    Error('\p{:=__Lydi}');
    Error('\P{:=__Lydi}');
    Expect(1, 67903, '\p{lydi}', "");
    Expect(0, 67903, '\p{^lydi}', "");
    Expect(0, 67903, '\P{lydi}', "");
    Expect(1, 67903, '\P{^lydi}', "");
    Expect(0, 67904, '\p{lydi}', "");
    Expect(1, 67904, '\p{^lydi}', "");
    Expect(1, 67904, '\P{lydi}', "");
    Expect(0, 67904, '\P{^lydi}', "");
    Expect(1, 67903, '\p{ 	Lydi}', "");
    Expect(0, 67903, '\p{^ 	Lydi}', "");
    Expect(0, 67903, '\P{ 	Lydi}', "");
    Expect(1, 67903, '\P{^ 	Lydi}', "");
    Expect(0, 67904, '\p{ 	Lydi}', "");
    Expect(1, 67904, '\p{^ 	Lydi}', "");
    Expect(1, 67904, '\P{ 	Lydi}', "");
    Expect(0, 67904, '\P{^ 	Lydi}', "");
    Error('\p{/a/IS_lydi}');
    Error('\P{/a/IS_lydi}');
    Expect(1, 67903, '\p{islydi}', "");
    Expect(0, 67903, '\p{^islydi}', "");
    Expect(0, 67903, '\P{islydi}', "");
    Expect(1, 67903, '\P{^islydi}', "");
    Expect(0, 67904, '\p{islydi}', "");
    Expect(1, 67904, '\p{^islydi}', "");
    Expect(1, 67904, '\P{islydi}', "");
    Expect(0, 67904, '\P{^islydi}', "");
    Expect(1, 67903, '\p{-	is_Lydi}', "");
    Expect(0, 67903, '\p{^-	is_Lydi}', "");
    Expect(0, 67903, '\P{-	is_Lydi}', "");
    Expect(1, 67903, '\P{^-	is_Lydi}', "");
    Expect(0, 67904, '\p{-	is_Lydi}', "");
    Expect(1, 67904, '\p{^-	is_Lydi}', "");
    Expect(1, 67904, '\P{-	is_Lydi}', "");
    Expect(0, 67904, '\P{^-	is_Lydi}', "");
    Error('\p{/a/Mahajani}');
    Error('\P{/a/Mahajani}');
    Expect(1, 70006, '\p{mahajani}', "");
    Expect(0, 70006, '\p{^mahajani}', "");
    Expect(0, 70006, '\P{mahajani}', "");
    Expect(1, 70006, '\P{^mahajani}', "");
    Expect(0, 70007, '\p{mahajani}', "");
    Expect(1, 70007, '\p{^mahajani}', "");
    Expect(1, 70007, '\P{mahajani}', "");
    Expect(0, 70007, '\P{^mahajani}', "");
    Expect(1, 70006, '\p{		MAHAJANI}', "");
    Expect(0, 70006, '\p{^		MAHAJANI}', "");
    Expect(0, 70006, '\P{		MAHAJANI}', "");
    Expect(1, 70006, '\P{^		MAHAJANI}', "");
    Expect(0, 70007, '\p{		MAHAJANI}', "");
    Expect(1, 70007, '\p{^		MAHAJANI}', "");
    Expect(1, 70007, '\P{		MAHAJANI}', "");
    Expect(0, 70007, '\P{^		MAHAJANI}', "");
    Error('\p{	/a/Is_MAHAJANI}');
    Error('\P{	/a/Is_MAHAJANI}');
    Expect(1, 70006, '\p{ismahajani}', "");
    Expect(0, 70006, '\p{^ismahajani}', "");
    Expect(0, 70006, '\P{ismahajani}', "");
    Expect(1, 70006, '\P{^ismahajani}', "");
    Expect(0, 70007, '\p{ismahajani}', "");
    Expect(1, 70007, '\p{^ismahajani}', "");
    Expect(1, 70007, '\P{ismahajani}', "");
    Expect(0, 70007, '\P{^ismahajani}', "");
    Expect(1, 70006, '\p{ 	IS_MAHAJANI}', "");
    Expect(0, 70006, '\p{^ 	IS_MAHAJANI}', "");
    Expect(0, 70006, '\P{ 	IS_MAHAJANI}', "");
    Expect(1, 70006, '\P{^ 	IS_MAHAJANI}', "");
    Expect(0, 70007, '\p{ 	IS_MAHAJANI}', "");
    Expect(1, 70007, '\p{^ 	IS_MAHAJANI}', "");
    Expect(1, 70007, '\P{ 	IS_MAHAJANI}', "");
    Expect(0, 70007, '\P{^ 	IS_MAHAJANI}', "");
    Error('\p{-/a/Mahj}');
    Error('\P{-/a/Mahj}');
    Expect(1, 70006, '\p{mahj}', "");
    Expect(0, 70006, '\p{^mahj}', "");
    Expect(0, 70006, '\P{mahj}', "");
    Expect(1, 70006, '\P{^mahj}', "");
    Expect(0, 70007, '\p{mahj}', "");
    Expect(1, 70007, '\p{^mahj}', "");
    Expect(1, 70007, '\P{mahj}', "");
    Expect(0, 70007, '\P{^mahj}', "");
    Expect(1, 70006, '\p{-	mahj}', "");
    Expect(0, 70006, '\p{^-	mahj}', "");
    Expect(0, 70006, '\P{-	mahj}', "");
    Expect(1, 70006, '\P{^-	mahj}', "");
    Expect(0, 70007, '\p{-	mahj}', "");
    Expect(1, 70007, '\p{^-	mahj}', "");
    Expect(1, 70007, '\P{-	mahj}', "");
    Expect(0, 70007, '\P{^-	mahj}', "");
    Error('\p{/a/	Is_Mahj}');
    Error('\P{/a/	Is_Mahj}');
    Expect(1, 70006, '\p{ismahj}', "");
    Expect(0, 70006, '\p{^ismahj}', "");
    Expect(0, 70006, '\P{ismahj}', "");
    Expect(1, 70006, '\P{^ismahj}', "");
    Expect(0, 70007, '\p{ismahj}', "");
    Expect(1, 70007, '\p{^ismahj}', "");
    Expect(1, 70007, '\P{ismahj}', "");
    Expect(0, 70007, '\P{^ismahj}', "");
    Expect(1, 70006, '\p{-	Is_MAHJ}', "");
    Expect(0, 70006, '\p{^-	Is_MAHJ}', "");
    Expect(0, 70006, '\P{-	Is_MAHJ}', "");
    Expect(1, 70006, '\P{^-	Is_MAHJ}', "");
    Expect(0, 70007, '\p{-	Is_MAHJ}', "");
    Expect(1, 70007, '\p{^-	Is_MAHJ}', "");
    Expect(1, 70007, '\P{-	Is_MAHJ}', "");
    Expect(0, 70007, '\P{^-	Is_MAHJ}', "");
    Error('\p{  Mahjong_TILES/a/}');
    Error('\P{  Mahjong_TILES/a/}');
    Expect(1, 127023, '\p{mahjongtiles}', "");
    Expect(0, 127023, '\p{^mahjongtiles}', "");
    Expect(0, 127023, '\P{mahjongtiles}', "");
    Expect(1, 127023, '\P{^mahjongtiles}', "");
    Expect(0, 127024, '\p{mahjongtiles}', "");
    Expect(1, 127024, '\p{^mahjongtiles}', "");
    Expect(1, 127024, '\P{mahjongtiles}', "");
    Expect(0, 127024, '\P{^mahjongtiles}', "");
    Expect(1, 127023, '\p{_Mahjong_Tiles}', "");
    Expect(0, 127023, '\p{^_Mahjong_Tiles}', "");
    Expect(0, 127023, '\P{_Mahjong_Tiles}', "");
    Expect(1, 127023, '\P{^_Mahjong_Tiles}', "");
    Expect(0, 127024, '\p{_Mahjong_Tiles}', "");
    Expect(1, 127024, '\p{^_Mahjong_Tiles}', "");
    Expect(1, 127024, '\P{_Mahjong_Tiles}', "");
    Expect(0, 127024, '\P{^_Mahjong_Tiles}', "");
    Error('\p{_is_Mahjong_tiles:=}');
    Error('\P{_is_Mahjong_tiles:=}');
    Expect(1, 127023, '\p{ismahjongtiles}', "");
    Expect(0, 127023, '\p{^ismahjongtiles}', "");
    Expect(0, 127023, '\P{ismahjongtiles}', "");
    Expect(1, 127023, '\P{^ismahjongtiles}', "");
    Expect(0, 127024, '\p{ismahjongtiles}', "");
    Expect(1, 127024, '\p{^ismahjongtiles}', "");
    Expect(1, 127024, '\P{ismahjongtiles}', "");
    Expect(0, 127024, '\P{^ismahjongtiles}', "");
    Expect(1, 127023, '\p{-_Is_Mahjong_tiles}', "");
    Expect(0, 127023, '\p{^-_Is_Mahjong_tiles}', "");
    Expect(0, 127023, '\P{-_Is_Mahjong_tiles}', "");
    Expect(1, 127023, '\P{^-_Is_Mahjong_tiles}', "");
    Expect(0, 127024, '\p{-_Is_Mahjong_tiles}', "");
    Expect(1, 127024, '\p{^-_Is_Mahjong_tiles}', "");
    Expect(1, 127024, '\P{-_Is_Mahjong_tiles}', "");
    Expect(0, 127024, '\P{^-_Is_Mahjong_tiles}', "");
    Error('\p{_:=In_Mahjong_tiles}');
    Error('\P{_:=In_Mahjong_tiles}');
    Expect(1, 127023, '\p{inmahjongtiles}', "");
    Expect(0, 127023, '\p{^inmahjongtiles}', "");
    Expect(0, 127023, '\P{inmahjongtiles}', "");
    Expect(1, 127023, '\P{^inmahjongtiles}', "");
    Expect(0, 127024, '\p{inmahjongtiles}', "");
    Expect(1, 127024, '\p{^inmahjongtiles}', "");
    Expect(1, 127024, '\P{inmahjongtiles}', "");
    Expect(0, 127024, '\P{^inmahjongtiles}', "");
    Expect(1, 127023, '\p{-in_Mahjong_tiles}', "");
    Expect(0, 127023, '\p{^-in_Mahjong_tiles}', "");
    Expect(0, 127023, '\P{-in_Mahjong_tiles}', "");
    Expect(1, 127023, '\P{^-in_Mahjong_tiles}', "");
    Expect(0, 127024, '\p{-in_Mahjong_tiles}', "");
    Expect(1, 127024, '\p{^-in_Mahjong_tiles}', "");
    Expect(1, 127024, '\P{-in_Mahjong_tiles}', "");
    Expect(0, 127024, '\P{^-in_Mahjong_tiles}', "");
    Error('\p{:=  MAHJONG}');
    Error('\P{:=  MAHJONG}');
    Expect(1, 127023, '\p{mahjong}', "");
    Expect(0, 127023, '\p{^mahjong}', "");
    Expect(0, 127023, '\P{mahjong}', "");
    Expect(1, 127023, '\P{^mahjong}', "");
    Expect(0, 127024, '\p{mahjong}', "");
    Expect(1, 127024, '\p{^mahjong}', "");
    Expect(1, 127024, '\P{mahjong}', "");
    Expect(0, 127024, '\P{^mahjong}', "");
    Expect(1, 127023, '\p{ MAHJONG}', "");
    Expect(0, 127023, '\p{^ MAHJONG}', "");
    Expect(0, 127023, '\P{ MAHJONG}', "");
    Expect(1, 127023, '\P{^ MAHJONG}', "");
    Expect(0, 127024, '\p{ MAHJONG}', "");
    Expect(1, 127024, '\p{^ MAHJONG}', "");
    Expect(1, 127024, '\P{ MAHJONG}', "");
    Expect(0, 127024, '\P{^ MAHJONG}', "");
    Error('\p{ :=IS_Mahjong}');
    Error('\P{ :=IS_Mahjong}');
    Expect(1, 127023, '\p{ismahjong}', "");
    Expect(0, 127023, '\p{^ismahjong}', "");
    Expect(0, 127023, '\P{ismahjong}', "");
    Expect(1, 127023, '\P{^ismahjong}', "");
    Expect(0, 127024, '\p{ismahjong}', "");
    Expect(1, 127024, '\p{^ismahjong}', "");
    Expect(1, 127024, '\P{ismahjong}', "");
    Expect(0, 127024, '\P{^ismahjong}', "");
    Expect(1, 127023, '\p{__Is_mahjong}', "");
    Expect(0, 127023, '\p{^__Is_mahjong}', "");
    Expect(0, 127023, '\P{__Is_mahjong}', "");
    Expect(1, 127023, '\P{^__Is_mahjong}', "");
    Expect(0, 127024, '\p{__Is_mahjong}', "");
    Expect(1, 127024, '\p{^__Is_mahjong}', "");
    Expect(1, 127024, '\P{__Is_mahjong}', "");
    Expect(0, 127024, '\P{^__Is_mahjong}', "");
    Error('\p{	:=in_MAHJONG}');
    Error('\P{	:=in_MAHJONG}');
    Expect(1, 127023, '\p{inmahjong}', "");
    Expect(0, 127023, '\p{^inmahjong}', "");
    Expect(0, 127023, '\P{inmahjong}', "");
    Expect(1, 127023, '\P{^inmahjong}', "");
    Expect(0, 127024, '\p{inmahjong}', "");
    Expect(1, 127024, '\p{^inmahjong}', "");
    Expect(1, 127024, '\P{inmahjong}', "");
    Expect(0, 127024, '\P{^inmahjong}', "");
    Expect(1, 127023, '\p{ -IN_mahjong}', "");
    Expect(0, 127023, '\p{^ -IN_mahjong}', "");
    Expect(0, 127023, '\P{ -IN_mahjong}', "");
    Expect(1, 127023, '\P{^ -IN_mahjong}', "");
    Expect(0, 127024, '\p{ -IN_mahjong}', "");
    Expect(1, 127024, '\p{^ -IN_mahjong}', "");
    Expect(1, 127024, '\P{ -IN_mahjong}', "");
    Expect(0, 127024, '\P{^ -IN_mahjong}', "");
    Error('\p{-MAKASAR:=}');
    Error('\P{-MAKASAR:=}');
    Expect(1, 73464, '\p{makasar}', "");
    Expect(0, 73464, '\p{^makasar}', "");
    Expect(0, 73464, '\P{makasar}', "");
    Expect(1, 73464, '\P{^makasar}', "");
    Expect(0, 73465, '\p{makasar}', "");
    Expect(1, 73465, '\p{^makasar}', "");
    Expect(1, 73465, '\P{makasar}', "");
    Expect(0, 73465, '\P{^makasar}', "");
    Expect(1, 73464, '\p{	-makasar}', "");
    Expect(0, 73464, '\p{^	-makasar}', "");
    Expect(0, 73464, '\P{	-makasar}', "");
    Expect(1, 73464, '\P{^	-makasar}', "");
    Expect(0, 73465, '\p{	-makasar}', "");
    Expect(1, 73465, '\p{^	-makasar}', "");
    Expect(1, 73465, '\P{	-makasar}', "");
    Expect(0, 73465, '\P{^	-makasar}', "");
    Error('\p{ Is_makasar/a/}');
    Error('\P{ Is_makasar/a/}');
    Expect(1, 73464, '\p{ismakasar}', "");
    Expect(0, 73464, '\p{^ismakasar}', "");
    Expect(0, 73464, '\P{ismakasar}', "");
    Expect(1, 73464, '\P{^ismakasar}', "");
    Expect(0, 73465, '\p{ismakasar}', "");
    Expect(1, 73465, '\p{^ismakasar}', "");
    Expect(1, 73465, '\P{ismakasar}', "");
    Expect(0, 73465, '\P{^ismakasar}', "");
    Expect(1, 73464, '\p{_IS_Makasar}', "");
    Expect(0, 73464, '\p{^_IS_Makasar}', "");
    Expect(0, 73464, '\P{_IS_Makasar}', "");
    Expect(1, 73464, '\P{^_IS_Makasar}', "");
    Expect(0, 73465, '\p{_IS_Makasar}', "");
    Expect(1, 73465, '\p{^_IS_Makasar}', "");
    Expect(1, 73465, '\P{_IS_Makasar}', "");
    Expect(0, 73465, '\P{^_IS_Makasar}', "");
    Error('\p{:=MAKA}');
    Error('\P{:=MAKA}');
    Expect(1, 73464, '\p{maka}', "");
    Expect(0, 73464, '\p{^maka}', "");
    Expect(0, 73464, '\P{maka}', "");
    Expect(1, 73464, '\P{^maka}', "");
    Expect(0, 73465, '\p{maka}', "");
    Expect(1, 73465, '\p{^maka}', "");
    Expect(1, 73465, '\P{maka}', "");
    Expect(0, 73465, '\P{^maka}', "");
    Expect(1, 73464, '\p{ MAKA}', "");
    Expect(0, 73464, '\p{^ MAKA}', "");
    Expect(0, 73464, '\P{ MAKA}', "");
    Expect(1, 73464, '\P{^ MAKA}', "");
    Expect(0, 73465, '\p{ MAKA}', "");
    Expect(1, 73465, '\p{^ MAKA}', "");
    Expect(1, 73465, '\P{ MAKA}', "");
    Expect(0, 73465, '\P{^ MAKA}', "");
    Error('\p{ 	Is_Maka/a/}');
    Error('\P{ 	Is_Maka/a/}');
    Expect(1, 73464, '\p{ismaka}', "");
    Expect(0, 73464, '\p{^ismaka}', "");
    Expect(0, 73464, '\P{ismaka}', "");
    Expect(1, 73464, '\P{^ismaka}', "");
    Expect(0, 73465, '\p{ismaka}', "");
    Expect(1, 73465, '\p{^ismaka}', "");
    Expect(1, 73465, '\P{ismaka}', "");
    Expect(0, 73465, '\P{^ismaka}', "");
    Expect(1, 73464, '\p{	_is_Maka}', "");
    Expect(0, 73464, '\p{^	_is_Maka}', "");
    Expect(0, 73464, '\P{	_is_Maka}', "");
    Expect(1, 73464, '\P{^	_is_Maka}', "");
    Expect(0, 73465, '\p{	_is_Maka}', "");
    Expect(1, 73465, '\p{^	_is_Maka}', "");
    Expect(1, 73465, '\P{	_is_Maka}', "");
    Expect(0, 73465, '\P{^	_is_Maka}', "");
    Error('\p{ -MALAYALAM:=}');
    Error('\P{ -MALAYALAM:=}');
    Expect(1, 43058, '\p{malayalam}', "");
    Expect(0, 43058, '\p{^malayalam}', "");
    Expect(0, 43058, '\P{malayalam}', "");
    Expect(1, 43058, '\P{^malayalam}', "");
    Expect(0, 43059, '\p{malayalam}', "");
    Expect(1, 43059, '\p{^malayalam}', "");
    Expect(1, 43059, '\P{malayalam}', "");
    Expect(0, 43059, '\P{^malayalam}', "");
    Expect(1, 43058, '\p{		Malayalam}', "");
    Expect(0, 43058, '\p{^		Malayalam}', "");
    Expect(0, 43058, '\P{		Malayalam}', "");
    Expect(1, 43058, '\P{^		Malayalam}', "");
    Expect(0, 43059, '\p{		Malayalam}', "");
    Expect(1, 43059, '\p{^		Malayalam}', "");
    Expect(1, 43059, '\P{		Malayalam}', "");
    Expect(0, 43059, '\P{^		Malayalam}', "");
    Error('\p{_ Is_Malayalam/a/}');
    Error('\P{_ Is_Malayalam/a/}');
    Expect(1, 43058, '\p{ismalayalam}', "");
    Expect(0, 43058, '\p{^ismalayalam}', "");
    Expect(0, 43058, '\P{ismalayalam}', "");
    Expect(1, 43058, '\P{^ismalayalam}', "");
    Expect(0, 43059, '\p{ismalayalam}', "");
    Expect(1, 43059, '\p{^ismalayalam}', "");
    Expect(1, 43059, '\P{ismalayalam}', "");
    Expect(0, 43059, '\P{^ismalayalam}', "");
    Expect(1, 43058, '\p{-_Is_Malayalam}', "");
    Expect(0, 43058, '\p{^-_Is_Malayalam}', "");
    Expect(0, 43058, '\P{-_Is_Malayalam}', "");
    Expect(1, 43058, '\P{^-_Is_Malayalam}', "");
    Expect(0, 43059, '\p{-_Is_Malayalam}', "");
    Expect(1, 43059, '\p{^-_Is_Malayalam}', "");
    Expect(1, 43059, '\P{-_Is_Malayalam}', "");
    Expect(0, 43059, '\P{^-_Is_Malayalam}', "");
    Error('\p{:=	Mlym}');
    Error('\P{:=	Mlym}');
    Expect(1, 43058, '\p{mlym}', "");
    Expect(0, 43058, '\p{^mlym}', "");
    Expect(0, 43058, '\P{mlym}', "");
    Expect(1, 43058, '\P{^mlym}', "");
    Expect(0, 43059, '\p{mlym}', "");
    Expect(1, 43059, '\p{^mlym}', "");
    Expect(1, 43059, '\P{mlym}', "");
    Expect(0, 43059, '\P{^mlym}', "");
    Expect(1, 43058, '\p{ _MLYM}', "");
    Expect(0, 43058, '\p{^ _MLYM}', "");
    Expect(0, 43058, '\P{ _MLYM}', "");
    Expect(1, 43058, '\P{^ _MLYM}', "");
    Expect(0, 43059, '\p{ _MLYM}', "");
    Expect(1, 43059, '\p{^ _MLYM}', "");
    Expect(1, 43059, '\P{ _MLYM}', "");
    Expect(0, 43059, '\P{^ _MLYM}', "");
    Error('\p{-:=is_Mlym}');
    Error('\P{-:=is_Mlym}');
    Expect(1, 43058, '\p{ismlym}', "");
    Expect(0, 43058, '\p{^ismlym}', "");
    Expect(0, 43058, '\P{ismlym}', "");
    Expect(1, 43058, '\P{^ismlym}', "");
    Expect(0, 43059, '\p{ismlym}', "");
    Expect(1, 43059, '\p{^ismlym}', "");
    Expect(1, 43059, '\P{ismlym}', "");
    Expect(0, 43059, '\P{^ismlym}', "");
    Expect(1, 43058, '\p{-_IS_Mlym}', "");
    Expect(0, 43058, '\p{^-_IS_Mlym}', "");
    Expect(0, 43058, '\P{-_IS_Mlym}', "");
    Expect(1, 43058, '\P{^-_IS_Mlym}', "");
    Expect(0, 43059, '\p{-_IS_Mlym}', "");
    Expect(1, 43059, '\p{^-_IS_Mlym}', "");
    Expect(1, 43059, '\P{-_IS_Mlym}', "");
    Expect(0, 43059, '\P{^-_IS_Mlym}', "");
    Error('\p{:= Mandaic}');
    Error('\P{:= Mandaic}');
    Expect(1, 2142, '\p{mandaic}', "");
    Expect(0, 2142, '\p{^mandaic}', "");
    Expect(0, 2142, '\P{mandaic}', "");
    Expect(1, 2142, '\P{^mandaic}', "");
    Expect(0, 2143, '\p{mandaic}', "");
    Expect(1, 2143, '\p{^mandaic}', "");
    Expect(1, 2143, '\P{mandaic}', "");
    Expect(0, 2143, '\P{^mandaic}', "");
    Expect(1, 2142, '\p{_mandaic}', "");
    Expect(0, 2142, '\p{^_mandaic}', "");
    Expect(0, 2142, '\P{_mandaic}', "");
    Expect(1, 2142, '\P{^_mandaic}', "");
    Expect(0, 2143, '\p{_mandaic}', "");
    Expect(1, 2143, '\p{^_mandaic}', "");
    Expect(1, 2143, '\P{_mandaic}', "");
    Expect(0, 2143, '\P{^_mandaic}', "");
    Error('\p{-	IS_Mandaic:=}');
    Error('\P{-	IS_Mandaic:=}');
    Expect(1, 2142, '\p{ismandaic}', "");
    Expect(0, 2142, '\p{^ismandaic}', "");
    Expect(0, 2142, '\P{ismandaic}', "");
    Expect(1, 2142, '\P{^ismandaic}', "");
    Expect(0, 2143, '\p{ismandaic}', "");
    Expect(1, 2143, '\p{^ismandaic}', "");
    Expect(1, 2143, '\P{ismandaic}', "");
    Expect(0, 2143, '\P{^ismandaic}', "");
    Expect(1, 2142, '\p{Is_mandaic}', "");
    Expect(0, 2142, '\p{^Is_mandaic}', "");
    Expect(0, 2142, '\P{Is_mandaic}', "");
    Expect(1, 2142, '\P{^Is_mandaic}', "");
    Expect(0, 2143, '\p{Is_mandaic}', "");
    Expect(1, 2143, '\p{^Is_mandaic}', "");
    Expect(1, 2143, '\P{Is_mandaic}', "");
    Expect(0, 2143, '\P{^Is_mandaic}', "");
    Error('\p{	MAND/a/}');
    Error('\P{	MAND/a/}');
    Expect(1, 2142, '\p{mand}', "");
    Expect(0, 2142, '\p{^mand}', "");
    Expect(0, 2142, '\P{mand}', "");
    Expect(1, 2142, '\P{^mand}', "");
    Expect(0, 2143, '\p{mand}', "");
    Expect(1, 2143, '\p{^mand}', "");
    Expect(1, 2143, '\P{mand}', "");
    Expect(0, 2143, '\P{^mand}', "");
    Expect(1, 2142, '\p{__Mand}', "");
    Expect(0, 2142, '\p{^__Mand}', "");
    Expect(0, 2142, '\P{__Mand}', "");
    Expect(1, 2142, '\P{^__Mand}', "");
    Expect(0, 2143, '\p{__Mand}', "");
    Expect(1, 2143, '\p{^__Mand}', "");
    Expect(1, 2143, '\P{__Mand}', "");
    Expect(0, 2143, '\P{^__Mand}', "");
    Error('\p{_/a/IS_mand}');
    Error('\P{_/a/IS_mand}');
    Expect(1, 2142, '\p{ismand}', "");
    Expect(0, 2142, '\p{^ismand}', "");
    Expect(0, 2142, '\P{ismand}', "");
    Expect(1, 2142, '\P{^ismand}', "");
    Expect(0, 2143, '\p{ismand}', "");
    Expect(1, 2143, '\p{^ismand}', "");
    Expect(1, 2143, '\P{ismand}', "");
    Expect(0, 2143, '\P{^ismand}', "");
    Expect(1, 2142, '\p{	 Is_Mand}', "");
    Expect(0, 2142, '\p{^	 Is_Mand}', "");
    Expect(0, 2142, '\P{	 Is_Mand}', "");
    Expect(1, 2142, '\P{^	 Is_Mand}', "");
    Expect(0, 2143, '\p{	 Is_Mand}', "");
    Expect(1, 2143, '\p{^	 Is_Mand}', "");
    Expect(1, 2143, '\P{	 Is_Mand}', "");
    Expect(0, 2143, '\P{^	 Is_Mand}', "");
    Error('\p{ /a/manichaean}');
    Error('\P{ /a/manichaean}');
    Expect(1, 68342, '\p{manichaean}', "");
    Expect(0, 68342, '\p{^manichaean}', "");
    Expect(0, 68342, '\P{manichaean}', "");
    Expect(1, 68342, '\P{^manichaean}', "");
    Expect(0, 68343, '\p{manichaean}', "");
    Expect(1, 68343, '\p{^manichaean}', "");
    Expect(1, 68343, '\P{manichaean}', "");
    Expect(0, 68343, '\P{^manichaean}', "");
    Expect(1, 68342, '\p{ -MANICHAEAN}', "");
    Expect(0, 68342, '\p{^ -MANICHAEAN}', "");
    Expect(0, 68342, '\P{ -MANICHAEAN}', "");
    Expect(1, 68342, '\P{^ -MANICHAEAN}', "");
    Expect(0, 68343, '\p{ -MANICHAEAN}', "");
    Expect(1, 68343, '\p{^ -MANICHAEAN}', "");
    Expect(1, 68343, '\P{ -MANICHAEAN}', "");
    Expect(0, 68343, '\P{^ -MANICHAEAN}', "");
    Error('\p{/a/- Is_MANICHAEAN}');
    Error('\P{/a/- Is_MANICHAEAN}');
    Expect(1, 68342, '\p{ismanichaean}', "");
    Expect(0, 68342, '\p{^ismanichaean}', "");
    Expect(0, 68342, '\P{ismanichaean}', "");
    Expect(1, 68342, '\P{^ismanichaean}', "");
    Expect(0, 68343, '\p{ismanichaean}', "");
    Expect(1, 68343, '\p{^ismanichaean}', "");
    Expect(1, 68343, '\P{ismanichaean}', "");
    Expect(0, 68343, '\P{^ismanichaean}', "");
    Expect(1, 68342, '\p{-IS_Manichaean}', "");
    Expect(0, 68342, '\p{^-IS_Manichaean}', "");
    Expect(0, 68342, '\P{-IS_Manichaean}', "");
    Expect(1, 68342, '\P{^-IS_Manichaean}', "");
    Expect(0, 68343, '\p{-IS_Manichaean}', "");
    Expect(1, 68343, '\p{^-IS_Manichaean}', "");
    Expect(1, 68343, '\P{-IS_Manichaean}', "");
    Expect(0, 68343, '\P{^-IS_Manichaean}', "");
    Error('\p{/a/mani}');
    Error('\P{/a/mani}');
    Expect(1, 68342, '\p{mani}', "");
    Expect(0, 68342, '\p{^mani}', "");
    Expect(0, 68342, '\P{mani}', "");
    Expect(1, 68342, '\P{^mani}', "");
    Expect(0, 68343, '\p{mani}', "");
    Expect(1, 68343, '\p{^mani}', "");
    Expect(1, 68343, '\P{mani}', "");
    Expect(0, 68343, '\P{^mani}', "");
    Expect(1, 68342, '\p{ -mani}', "");
    Expect(0, 68342, '\p{^ -mani}', "");
    Expect(0, 68342, '\P{ -mani}', "");
    Expect(1, 68342, '\P{^ -mani}', "");
    Expect(0, 68343, '\p{ -mani}', "");
    Expect(1, 68343, '\p{^ -mani}', "");
    Expect(1, 68343, '\P{ -mani}', "");
    Expect(0, 68343, '\P{^ -mani}', "");
    Error('\p{ :=is_MANI}');
    Error('\P{ :=is_MANI}');
    Expect(1, 68342, '\p{ismani}', "");
    Expect(0, 68342, '\p{^ismani}', "");
    Expect(0, 68342, '\P{ismani}', "");
    Expect(1, 68342, '\P{^ismani}', "");
    Expect(0, 68343, '\p{ismani}', "");
    Expect(1, 68343, '\p{^ismani}', "");
    Expect(1, 68343, '\P{ismani}', "");
    Expect(0, 68343, '\P{^ismani}', "");
    Expect(1, 68342, '\p{--IS_Mani}', "");
    Expect(0, 68342, '\p{^--IS_Mani}', "");
    Expect(0, 68342, '\P{--IS_Mani}', "");
    Expect(1, 68342, '\P{^--IS_Mani}', "");
    Expect(0, 68343, '\p{--IS_Mani}', "");
    Expect(1, 68343, '\p{^--IS_Mani}', "");
    Expect(1, 68343, '\P{--IS_Mani}', "");
    Expect(0, 68343, '\P{^--IS_Mani}', "");
    Error('\p{-/a/Marchen}');
    Error('\P{-/a/Marchen}');
    Expect(1, 72886, '\p{marchen}', "");
    Expect(0, 72886, '\p{^marchen}', "");
    Expect(0, 72886, '\P{marchen}', "");
    Expect(1, 72886, '\P{^marchen}', "");
    Expect(0, 72887, '\p{marchen}', "");
    Expect(1, 72887, '\p{^marchen}', "");
    Expect(1, 72887, '\P{marchen}', "");
    Expect(0, 72887, '\P{^marchen}', "");
    Expect(1, 72886, '\p{	_Marchen}', "");
    Expect(0, 72886, '\p{^	_Marchen}', "");
    Expect(0, 72886, '\P{	_Marchen}', "");
    Expect(1, 72886, '\P{^	_Marchen}', "");
    Expect(0, 72887, '\p{	_Marchen}', "");
    Expect(1, 72887, '\p{^	_Marchen}', "");
    Expect(1, 72887, '\P{	_Marchen}', "");
    Expect(0, 72887, '\P{^	_Marchen}', "");
    Error('\p{/a/ Is_marchen}');
    Error('\P{/a/ Is_marchen}');
    Expect(1, 72886, '\p{ismarchen}', "");
    Expect(0, 72886, '\p{^ismarchen}', "");
    Expect(0, 72886, '\P{ismarchen}', "");
    Expect(1, 72886, '\P{^ismarchen}', "");
    Expect(0, 72887, '\p{ismarchen}', "");
    Expect(1, 72887, '\p{^ismarchen}', "");
    Expect(1, 72887, '\P{ismarchen}', "");
    Expect(0, 72887, '\P{^ismarchen}', "");
    Expect(1, 72886, '\p{		Is_Marchen}', "");
    Expect(0, 72886, '\p{^		Is_Marchen}', "");
    Expect(0, 72886, '\P{		Is_Marchen}', "");
    Expect(1, 72886, '\P{^		Is_Marchen}', "");
    Expect(0, 72887, '\p{		Is_Marchen}', "");
    Expect(1, 72887, '\p{^		Is_Marchen}', "");
    Expect(1, 72887, '\P{		Is_Marchen}', "");
    Expect(0, 72887, '\P{^		Is_Marchen}', "");
    Error('\p{/a/MARC}');
    Error('\P{/a/MARC}');
    Expect(1, 72886, '\p{marc}', "");
    Expect(0, 72886, '\p{^marc}', "");
    Expect(0, 72886, '\P{marc}', "");
    Expect(1, 72886, '\P{^marc}', "");
    Expect(0, 72887, '\p{marc}', "");
    Expect(1, 72887, '\p{^marc}', "");
    Expect(1, 72887, '\P{marc}', "");
    Expect(0, 72887, '\P{^marc}', "");
    Expect(1, 72886, '\p{ -Marc}', "");
    Expect(0, 72886, '\p{^ -Marc}', "");
    Expect(0, 72886, '\P{ -Marc}', "");
    Expect(1, 72886, '\P{^ -Marc}', "");
    Expect(0, 72887, '\p{ -Marc}', "");
    Expect(1, 72887, '\p{^ -Marc}', "");
    Expect(1, 72887, '\P{ -Marc}', "");
    Expect(0, 72887, '\P{^ -Marc}', "");
    Error('\p{:=-is_Marc}');
    Error('\P{:=-is_Marc}');
    Expect(1, 72886, '\p{ismarc}', "");
    Expect(0, 72886, '\p{^ismarc}', "");
    Expect(0, 72886, '\P{ismarc}', "");
    Expect(1, 72886, '\P{^ismarc}', "");
    Expect(0, 72887, '\p{ismarc}', "");
    Expect(1, 72887, '\p{^ismarc}', "");
    Expect(1, 72887, '\P{ismarc}', "");
    Expect(0, 72887, '\P{^ismarc}', "");
    Expect(1, 72886, '\p{_is_Marc}', "");
    Expect(0, 72886, '\p{^_is_Marc}', "");
    Expect(0, 72886, '\P{_is_Marc}', "");
    Expect(1, 72886, '\P{^_is_Marc}', "");
    Expect(0, 72887, '\p{_is_Marc}', "");
    Expect(1, 72887, '\p{^_is_Marc}', "");
    Expect(1, 72887, '\P{_is_Marc}', "");
    Expect(0, 72887, '\P{^_is_Marc}', "");
    Error('\p{/a/_	Mark}');
    Error('\P{/a/_	Mark}');
    Expect(1, 917999, '\p{mark}', "");
    Expect(0, 917999, '\p{^mark}', "");
    Expect(0, 917999, '\P{mark}', "");
    Expect(1, 917999, '\P{^mark}', "");
    Expect(0, 918000, '\p{mark}', "");
    Expect(1, 918000, '\p{^mark}', "");
    Expect(1, 918000, '\P{mark}', "");
    Expect(0, 918000, '\P{^mark}', "");
    Expect(1, 917999, '\p{	MARK}', "");
    Expect(0, 917999, '\p{^	MARK}', "");
    Expect(0, 917999, '\P{	MARK}', "");
    Expect(1, 917999, '\P{^	MARK}', "");
    Expect(0, 918000, '\p{	MARK}', "");
    Expect(1, 918000, '\p{^	MARK}', "");
    Expect(1, 918000, '\P{	MARK}', "");
    Expect(0, 918000, '\P{^	MARK}', "");
    Error('\p{ is_mark:=}');
    Error('\P{ is_mark:=}');
    Expect(1, 917999, '\p{ismark}', "");
    Expect(0, 917999, '\p{^ismark}', "");
    Expect(0, 917999, '\P{ismark}', "");
    Expect(1, 917999, '\P{^ismark}', "");
    Expect(0, 918000, '\p{ismark}', "");
    Expect(1, 918000, '\p{^ismark}', "");
    Expect(1, 918000, '\P{ismark}', "");
    Expect(0, 918000, '\P{^ismark}', "");
    Expect(1, 917999, '\p{_	is_MARK}', "");
    Expect(0, 917999, '\p{^_	is_MARK}', "");
    Expect(0, 917999, '\P{_	is_MARK}', "");
    Expect(1, 917999, '\P{^_	is_MARK}', "");
    Expect(0, 918000, '\p{_	is_MARK}', "");
    Expect(1, 918000, '\p{^_	is_MARK}', "");
    Expect(1, 918000, '\P{_	is_MARK}', "");
    Expect(0, 918000, '\P{^_	is_MARK}', "");
    Error('\p{/a/	M}');
    Error('\P{/a/	M}');
    Expect(1, 917999, '\p{m}', "");
    Expect(0, 917999, '\p{^m}', "");
    Expect(0, 917999, '\P{m}', "");
    Expect(1, 917999, '\P{^m}', "");
    Expect(0, 918000, '\p{m}', "");
    Expect(1, 918000, '\p{^m}', "");
    Expect(1, 918000, '\P{m}', "");
    Expect(0, 918000, '\P{^m}', "");
    Expect(1, 917999, '\p{ 	m}', "");
    Expect(0, 917999, '\p{^ 	m}', "");
    Expect(0, 917999, '\P{ 	m}', "");
    Expect(1, 917999, '\P{^ 	m}', "");
    Expect(0, 918000, '\p{ 	m}', "");
    Expect(1, 918000, '\p{^ 	m}', "");
    Expect(1, 918000, '\P{ 	m}', "");
    Expect(0, 918000, '\P{^ 	m}', "");
    Error('\p{ _is_M/a/}');
    Error('\P{ _is_M/a/}');
    Expect(1, 917999, '\p{ism}', "");
    Expect(0, 917999, '\p{^ism}', "");
    Expect(0, 917999, '\P{ism}', "");
    Expect(1, 917999, '\P{^ism}', "");
    Expect(0, 918000, '\p{ism}', "");
    Expect(1, 918000, '\p{^ism}', "");
    Expect(1, 918000, '\P{ism}', "");
    Expect(0, 918000, '\P{^ism}', "");
    Expect(1, 917999, '\p{-_Is_M}', "");
    Expect(0, 917999, '\p{^-_Is_M}', "");
    Expect(0, 917999, '\P{-_Is_M}', "");
    Expect(1, 917999, '\P{^-_Is_M}', "");
    Expect(0, 918000, '\p{-_Is_M}', "");
    Expect(1, 918000, '\p{^-_Is_M}', "");
    Expect(1, 918000, '\P{-_Is_M}', "");
    Expect(0, 918000, '\P{^-_Is_M}', "");
    Error('\p{:=-_combining_mark}');
    Error('\P{:=-_combining_mark}');
    Expect(1, 917999, '\p{combiningmark}', "");
    Expect(0, 917999, '\p{^combiningmark}', "");
    Expect(0, 917999, '\P{combiningmark}', "");
    Expect(1, 917999, '\P{^combiningmark}', "");
    Expect(0, 918000, '\p{combiningmark}', "");
    Expect(1, 918000, '\p{^combiningmark}', "");
    Expect(1, 918000, '\P{combiningmark}', "");
    Expect(0, 918000, '\P{^combiningmark}', "");
    Expect(1, 917999, '\p{-combining_Mark}', "");
    Expect(0, 917999, '\p{^-combining_Mark}', "");
    Expect(0, 917999, '\P{-combining_Mark}', "");
    Expect(1, 917999, '\P{^-combining_Mark}', "");
    Expect(0, 918000, '\p{-combining_Mark}', "");
    Expect(1, 918000, '\p{^-combining_Mark}', "");
    Expect(1, 918000, '\P{-combining_Mark}', "");
    Expect(0, 918000, '\P{^-combining_Mark}', "");
    Error('\p{ 	Is_Combining_MARK:=}');
    Error('\P{ 	Is_Combining_MARK:=}');
    Expect(1, 917999, '\p{iscombiningmark}', "");
    Expect(0, 917999, '\p{^iscombiningmark}', "");
    Expect(0, 917999, '\P{iscombiningmark}', "");
    Expect(1, 917999, '\P{^iscombiningmark}', "");
    Expect(0, 918000, '\p{iscombiningmark}', "");
    Expect(1, 918000, '\p{^iscombiningmark}', "");
    Expect(1, 918000, '\P{iscombiningmark}', "");
    Expect(0, 918000, '\P{^iscombiningmark}', "");
    Expect(1, 917999, '\p{		is_COMBINING_mark}', "");
    Expect(0, 917999, '\p{^		is_COMBINING_mark}', "");
    Expect(0, 917999, '\P{		is_COMBINING_mark}', "");
    Expect(1, 917999, '\P{^		is_COMBINING_mark}', "");
    Expect(0, 918000, '\p{		is_COMBINING_mark}', "");
    Expect(1, 918000, '\p{^		is_COMBINING_mark}', "");
    Expect(1, 918000, '\P{		is_COMBINING_mark}', "");
    Expect(0, 918000, '\P{^		is_COMBINING_mark}', "");
    Error('\p{  masaram_GONDI:=}');
    Error('\P{  masaram_GONDI:=}');
    Expect(1, 73049, '\p{masaramgondi}', "");
    Expect(0, 73049, '\p{^masaramgondi}', "");
    Expect(0, 73049, '\P{masaramgondi}', "");
    Expect(1, 73049, '\P{^masaramgondi}', "");
    Expect(0, 73050, '\p{masaramgondi}', "");
    Expect(1, 73050, '\p{^masaramgondi}', "");
    Expect(1, 73050, '\P{masaramgondi}', "");
    Expect(0, 73050, '\P{^masaramgondi}', "");
    Expect(1, 73049, '\p{_MASARAM_gondi}', "");
    Expect(0, 73049, '\p{^_MASARAM_gondi}', "");
    Expect(0, 73049, '\P{_MASARAM_gondi}', "");
    Expect(1, 73049, '\P{^_MASARAM_gondi}', "");
    Expect(0, 73050, '\p{_MASARAM_gondi}', "");
    Expect(1, 73050, '\p{^_MASARAM_gondi}', "");
    Expect(1, 73050, '\P{_MASARAM_gondi}', "");
    Expect(0, 73050, '\P{^_MASARAM_gondi}', "");
    Error('\p{ :=is_MASARAM_Gondi}');
    Error('\P{ :=is_MASARAM_Gondi}');
    Expect(1, 73049, '\p{ismasaramgondi}', "");
    Expect(0, 73049, '\p{^ismasaramgondi}', "");
    Expect(0, 73049, '\P{ismasaramgondi}', "");
    Expect(1, 73049, '\P{^ismasaramgondi}', "");
    Expect(0, 73050, '\p{ismasaramgondi}', "");
    Expect(1, 73050, '\p{^ismasaramgondi}', "");
    Expect(1, 73050, '\P{ismasaramgondi}', "");
    Expect(0, 73050, '\P{^ismasaramgondi}', "");
    Expect(1, 73049, '\p{		is_masaram_Gondi}', "");
    Expect(0, 73049, '\p{^		is_masaram_Gondi}', "");
    Expect(0, 73049, '\P{		is_masaram_Gondi}', "");
    Expect(1, 73049, '\P{^		is_masaram_Gondi}', "");
    Expect(0, 73050, '\p{		is_masaram_Gondi}', "");
    Expect(1, 73050, '\p{^		is_masaram_Gondi}', "");
    Expect(1, 73050, '\P{		is_masaram_Gondi}', "");
    Expect(0, 73050, '\P{^		is_masaram_Gondi}', "");
    Error('\p{	 Gonm:=}');
    Error('\P{	 Gonm:=}');
    Expect(1, 73049, '\p{gonm}', "");
    Expect(0, 73049, '\p{^gonm}', "");
    Expect(0, 73049, '\P{gonm}', "");
    Expect(1, 73049, '\P{^gonm}', "");
    Expect(0, 73050, '\p{gonm}', "");
    Expect(1, 73050, '\p{^gonm}', "");
    Expect(1, 73050, '\P{gonm}', "");
    Expect(0, 73050, '\P{^gonm}', "");
    Expect(1, 73049, '\p{		Gonm}', "");
    Expect(0, 73049, '\p{^		Gonm}', "");
    Expect(0, 73049, '\P{		Gonm}', "");
    Expect(1, 73049, '\P{^		Gonm}', "");
    Expect(0, 73050, '\p{		Gonm}', "");
    Expect(1, 73050, '\p{^		Gonm}', "");
    Expect(1, 73050, '\P{		Gonm}', "");
    Expect(0, 73050, '\P{^		Gonm}', "");
    Error('\p{- IS_Gonm/a/}');
    Error('\P{- IS_Gonm/a/}');
    Expect(1, 73049, '\p{isgonm}', "");
    Expect(0, 73049, '\p{^isgonm}', "");
    Expect(0, 73049, '\P{isgonm}', "");
    Expect(1, 73049, '\P{^isgonm}', "");
    Expect(0, 73050, '\p{isgonm}', "");
    Expect(1, 73050, '\p{^isgonm}', "");
    Expect(1, 73050, '\P{isgonm}', "");
    Expect(0, 73050, '\P{^isgonm}', "");
    Expect(1, 73049, '\p{-	Is_gonm}', "");
    Expect(0, 73049, '\p{^-	Is_gonm}', "");
    Expect(0, 73049, '\P{-	Is_gonm}', "");
    Expect(1, 73049, '\P{^-	Is_gonm}', "");
    Expect(0, 73050, '\p{-	Is_gonm}', "");
    Expect(1, 73050, '\p{^-	Is_gonm}', "");
    Expect(1, 73050, '\P{-	Is_gonm}', "");
    Expect(0, 73050, '\P{^-	Is_gonm}', "");
    Error('\p{:=Math}');
    Error('\P{:=Math}');
    Expect(1, 126705, '\p{math}', "");
    Expect(0, 126705, '\p{^math}', "");
    Expect(0, 126705, '\P{math}', "");
    Expect(1, 126705, '\P{^math}', "");
    Expect(0, 126706, '\p{math}', "");
    Expect(1, 126706, '\p{^math}', "");
    Expect(1, 126706, '\P{math}', "");
    Expect(0, 126706, '\P{^math}', "");
    Expect(1, 126705, '\p{-math}', "");
    Expect(0, 126705, '\p{^-math}', "");
    Expect(0, 126705, '\P{-math}', "");
    Expect(1, 126705, '\P{^-math}', "");
    Expect(0, 126706, '\p{-math}', "");
    Expect(1, 126706, '\p{^-math}', "");
    Expect(1, 126706, '\P{-math}', "");
    Expect(0, 126706, '\P{^-math}', "");
    Error('\p{- Is_Math:=}');
    Error('\P{- Is_Math:=}');
    Expect(1, 126705, '\p{ismath}', "");
    Expect(0, 126705, '\p{^ismath}', "");
    Expect(0, 126705, '\P{ismath}', "");
    Expect(1, 126705, '\P{^ismath}', "");
    Expect(0, 126706, '\p{ismath}', "");
    Expect(1, 126706, '\p{^ismath}', "");
    Expect(1, 126706, '\P{ismath}', "");
    Expect(0, 126706, '\P{^ismath}', "");
    Expect(1, 126705, '\p{  IS_Math}', "");
    Expect(0, 126705, '\p{^  IS_Math}', "");
    Expect(0, 126705, '\P{  IS_Math}', "");
    Expect(1, 126705, '\P{^  IS_Math}', "");
    Expect(0, 126706, '\p{  IS_Math}', "");
    Expect(1, 126706, '\p{^  IS_Math}', "");
    Expect(1, 126706, '\P{  IS_Math}', "");
    Expect(0, 126706, '\P{^  IS_Math}', "");
    Error('\p{:=_ math_Symbol}');
    Error('\P{:=_ math_Symbol}');
    Expect(1, 126705, '\p{mathsymbol}', "");
    Expect(0, 126705, '\p{^mathsymbol}', "");
    Expect(0, 126705, '\P{mathsymbol}', "");
    Expect(1, 126705, '\P{^mathsymbol}', "");
    Expect(0, 126706, '\p{mathsymbol}', "");
    Expect(1, 126706, '\p{^mathsymbol}', "");
    Expect(1, 126706, '\P{mathsymbol}', "");
    Expect(0, 126706, '\P{^mathsymbol}', "");
    Expect(1, 126705, '\p{_MATH_symbol}', "");
    Expect(0, 126705, '\p{^_MATH_symbol}', "");
    Expect(0, 126705, '\P{_MATH_symbol}', "");
    Expect(1, 126705, '\P{^_MATH_symbol}', "");
    Expect(0, 126706, '\p{_MATH_symbol}', "");
    Expect(1, 126706, '\p{^_MATH_symbol}', "");
    Expect(1, 126706, '\P{_MATH_symbol}', "");
    Expect(0, 126706, '\P{^_MATH_symbol}', "");
    Error('\p{:= is_math_SYMBOL}');
    Error('\P{:= is_math_SYMBOL}');
    Expect(1, 126705, '\p{ismathsymbol}', "");
    Expect(0, 126705, '\p{^ismathsymbol}', "");
    Expect(0, 126705, '\P{ismathsymbol}', "");
    Expect(1, 126705, '\P{^ismathsymbol}', "");
    Expect(0, 126706, '\p{ismathsymbol}', "");
    Expect(1, 126706, '\p{^ismathsymbol}', "");
    Expect(1, 126706, '\P{ismathsymbol}', "");
    Expect(0, 126706, '\P{^ismathsymbol}', "");
    Expect(1, 126705, '\p{		is_Math_symbol}', "");
    Expect(0, 126705, '\p{^		is_Math_symbol}', "");
    Expect(0, 126705, '\P{		is_Math_symbol}', "");
    Expect(1, 126705, '\P{^		is_Math_symbol}', "");
    Expect(0, 126706, '\p{		is_Math_symbol}', "");
    Expect(1, 126706, '\p{^		is_Math_symbol}', "");
    Expect(1, 126706, '\P{		is_Math_symbol}', "");
    Expect(0, 126706, '\P{^		is_Math_symbol}', "");
    Error('\p{/a/_SM}');
    Error('\P{/a/_SM}');
    Expect(1, 126705, '\p{sm}', "");
    Expect(0, 126705, '\p{^sm}', "");
    Expect(0, 126705, '\P{sm}', "");
    Expect(1, 126705, '\P{^sm}', "");
    Expect(0, 126706, '\p{sm}', "");
    Expect(1, 126706, '\p{^sm}', "");
    Expect(1, 126706, '\P{sm}', "");
    Expect(0, 126706, '\P{^sm}', "");
    Expect(1, 126705, '\p{-	Sm}', "");
    Expect(0, 126705, '\p{^-	Sm}', "");
    Expect(0, 126705, '\P{-	Sm}', "");
    Expect(1, 126705, '\P{^-	Sm}', "");
    Expect(0, 126706, '\p{-	Sm}', "");
    Expect(1, 126706, '\p{^-	Sm}', "");
    Expect(1, 126706, '\P{-	Sm}', "");
    Expect(0, 126706, '\P{^-	Sm}', "");
    Error('\p{--IS_sm/a/}');
    Error('\P{--IS_sm/a/}');
    Expect(1, 126705, '\p{issm}', "");
    Expect(0, 126705, '\p{^issm}', "");
    Expect(0, 126705, '\P{issm}', "");
    Expect(1, 126705, '\P{^issm}', "");
    Expect(0, 126706, '\p{issm}', "");
    Expect(1, 126706, '\p{^issm}', "");
    Expect(1, 126706, '\P{issm}', "");
    Expect(0, 126706, '\P{^issm}', "");
    Expect(1, 126705, '\p{ IS_SM}', "");
    Expect(0, 126705, '\p{^ IS_SM}', "");
    Expect(0, 126705, '\P{ IS_SM}', "");
    Expect(1, 126705, '\P{^ IS_SM}', "");
    Expect(0, 126706, '\p{ IS_SM}', "");
    Expect(1, 126706, '\p{^ IS_SM}', "");
    Expect(1, 126706, '\P{ IS_SM}', "");
    Expect(0, 126706, '\P{^ IS_SM}', "");
    Error('\p{:= _Mathematical_alphanumeric_SYMBOLS}');
    Error('\P{:= _Mathematical_alphanumeric_SYMBOLS}');
    Expect(1, 120831, '\p{mathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\p{^mathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\P{mathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\P{^mathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\p{mathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\p{^mathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\P{mathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\P{^mathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\p{		mathematical_Alphanumeric_SYMBOLS}', "");
    Expect(0, 120831, '\p{^		mathematical_Alphanumeric_SYMBOLS}', "");
    Expect(0, 120831, '\P{		mathematical_Alphanumeric_SYMBOLS}', "");
    Expect(1, 120831, '\P{^		mathematical_Alphanumeric_SYMBOLS}', "");
    Expect(0, 120832, '\p{		mathematical_Alphanumeric_SYMBOLS}', "");
    Expect(1, 120832, '\p{^		mathematical_Alphanumeric_SYMBOLS}', "");
    Expect(1, 120832, '\P{		mathematical_Alphanumeric_SYMBOLS}', "");
    Expect(0, 120832, '\P{^		mathematical_Alphanumeric_SYMBOLS}', "");
    Error('\p{:=_Is_Mathematical_ALPHANUMERIC_SYMBOLS}');
    Error('\P{:=_Is_Mathematical_ALPHANUMERIC_SYMBOLS}');
    Expect(1, 120831, '\p{ismathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\p{^ismathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\P{ismathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\P{^ismathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\p{ismathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\p{^ismathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\P{ismathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\P{^ismathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\p{-Is_Mathematical_Alphanumeric_Symbols}', "");
    Expect(0, 120831, '\p{^-Is_Mathematical_Alphanumeric_Symbols}', "");
    Expect(0, 120831, '\P{-Is_Mathematical_Alphanumeric_Symbols}', "");
    Expect(1, 120831, '\P{^-Is_Mathematical_Alphanumeric_Symbols}', "");
    Expect(0, 120832, '\p{-Is_Mathematical_Alphanumeric_Symbols}', "");
    Expect(1, 120832, '\p{^-Is_Mathematical_Alphanumeric_Symbols}', "");
    Expect(1, 120832, '\P{-Is_Mathematical_Alphanumeric_Symbols}', "");
    Expect(0, 120832, '\P{^-Is_Mathematical_Alphanumeric_Symbols}', "");
    Error('\p{:=	in_Mathematical_Alphanumeric_Symbols}');
    Error('\P{:=	in_Mathematical_Alphanumeric_Symbols}');
    Expect(1, 120831, '\p{inmathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\p{^inmathematicalalphanumericsymbols}', "");
    Expect(0, 120831, '\P{inmathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\P{^inmathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\p{inmathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\p{^inmathematicalalphanumericsymbols}', "");
    Expect(1, 120832, '\P{inmathematicalalphanumericsymbols}', "");
    Expect(0, 120832, '\P{^inmathematicalalphanumericsymbols}', "");
    Expect(1, 120831, '\p{_ In_Mathematical_Alphanumeric_symbols}', "");
    Expect(0, 120831, '\p{^_ In_Mathematical_Alphanumeric_symbols}', "");
    Expect(0, 120831, '\P{_ In_Mathematical_Alphanumeric_symbols}', "");
    Expect(1, 120831, '\P{^_ In_Mathematical_Alphanumeric_symbols}', "");
    Expect(0, 120832, '\p{_ In_Mathematical_Alphanumeric_symbols}', "");
    Expect(1, 120832, '\p{^_ In_Mathematical_Alphanumeric_symbols}', "");
    Expect(1, 120832, '\P{_ In_Mathematical_Alphanumeric_symbols}', "");
    Expect(0, 120832, '\P{^_ In_Mathematical_Alphanumeric_symbols}', "");
    Error('\p{/a/	-Math_ALPHANUM}');
    Error('\P{/a/	-Math_ALPHANUM}');
    Expect(1, 120831, '\p{mathalphanum}', "");
    Expect(0, 120831, '\p{^mathalphanum}', "");
    Expect(0, 120831, '\P{mathalphanum}', "");
    Expect(1, 120831, '\P{^mathalphanum}', "");
    Expect(0, 120832, '\p{mathalphanum}', "");
    Expect(1, 120832, '\p{^mathalphanum}', "");
    Expect(1, 120832, '\P{mathalphanum}', "");
    Expect(0, 120832, '\P{^mathalphanum}', "");
    Expect(1, 120831, '\p{	-Math_Alphanum}', "");
    Expect(0, 120831, '\p{^	-Math_Alphanum}', "");
    Expect(0, 120831, '\P{	-Math_Alphanum}', "");
    Expect(1, 120831, '\P{^	-Math_Alphanum}', "");
    Expect(0, 120832, '\p{	-Math_Alphanum}', "");
    Expect(1, 120832, '\p{^	-Math_Alphanum}', "");
    Expect(1, 120832, '\P{	-Math_Alphanum}', "");
    Expect(0, 120832, '\P{^	-Math_Alphanum}', "");
    Error('\p{:= Is_Math_alphanum}');
    Error('\P{:= Is_Math_alphanum}');
    Expect(1, 120831, '\p{ismathalphanum}', "");
    Expect(0, 120831, '\p{^ismathalphanum}', "");
    Expect(0, 120831, '\P{ismathalphanum}', "");
    Expect(1, 120831, '\P{^ismathalphanum}', "");
    Expect(0, 120832, '\p{ismathalphanum}', "");
    Expect(1, 120832, '\p{^ismathalphanum}', "");
    Expect(1, 120832, '\P{ismathalphanum}', "");
    Expect(0, 120832, '\P{^ismathalphanum}', "");
    Expect(1, 120831, '\p{_IS_Math_alphanum}', "");
    Expect(0, 120831, '\p{^_IS_Math_alphanum}', "");
    Expect(0, 120831, '\P{_IS_Math_alphanum}', "");
    Expect(1, 120831, '\P{^_IS_Math_alphanum}', "");
    Expect(0, 120832, '\p{_IS_Math_alphanum}', "");
    Expect(1, 120832, '\p{^_IS_Math_alphanum}', "");
    Expect(1, 120832, '\P{_IS_Math_alphanum}', "");
    Expect(0, 120832, '\P{^_IS_Math_alphanum}', "");
    Error('\p{-:=In_math_Alphanum}');
    Error('\P{-:=In_math_Alphanum}');
    Expect(1, 120831, '\p{inmathalphanum}', "");
    Expect(0, 120831, '\p{^inmathalphanum}', "");
    Expect(0, 120831, '\P{inmathalphanum}', "");
    Expect(1, 120831, '\P{^inmathalphanum}', "");
    Expect(0, 120832, '\p{inmathalphanum}', "");
    Expect(1, 120832, '\p{^inmathalphanum}', "");
    Expect(1, 120832, '\P{inmathalphanum}', "");
    Expect(0, 120832, '\P{^inmathalphanum}', "");
    Expect(1, 120831, '\p{	IN_Math_Alphanum}', "");
    Expect(0, 120831, '\p{^	IN_Math_Alphanum}', "");
    Expect(0, 120831, '\P{	IN_Math_Alphanum}', "");
    Expect(1, 120831, '\P{^	IN_Math_Alphanum}', "");
    Expect(0, 120832, '\p{	IN_Math_Alphanum}', "");
    Expect(1, 120832, '\p{^	IN_Math_Alphanum}', "");
    Expect(1, 120832, '\P{	IN_Math_Alphanum}', "");
    Expect(0, 120832, '\P{^	IN_Math_Alphanum}', "");
    Error('\p{/a/	-Mathematical_operators}');
    Error('\P{/a/	-Mathematical_operators}');
    Expect(1, 8959, '\p{mathematicaloperators}', "");
    Expect(0, 8959, '\p{^mathematicaloperators}', "");
    Expect(0, 8959, '\P{mathematicaloperators}', "");
    Expect(1, 8959, '\P{^mathematicaloperators}', "");
    Expect(0, 8960, '\p{mathematicaloperators}', "");
    Expect(1, 8960, '\p{^mathematicaloperators}', "");
    Expect(1, 8960, '\P{mathematicaloperators}', "");
    Expect(0, 8960, '\P{^mathematicaloperators}', "");
    Expect(1, 8959, '\p{	_MATHEMATICAL_Operators}', "");
    Expect(0, 8959, '\p{^	_MATHEMATICAL_Operators}', "");
    Expect(0, 8959, '\P{	_MATHEMATICAL_Operators}', "");
    Expect(1, 8959, '\P{^	_MATHEMATICAL_Operators}', "");
    Expect(0, 8960, '\p{	_MATHEMATICAL_Operators}', "");
    Expect(1, 8960, '\p{^	_MATHEMATICAL_Operators}', "");
    Expect(1, 8960, '\P{	_MATHEMATICAL_Operators}', "");
    Expect(0, 8960, '\P{^	_MATHEMATICAL_Operators}', "");
    Error('\p{:=__Is_MATHEMATICAL_operators}');
    Error('\P{:=__Is_MATHEMATICAL_operators}');
    Expect(1, 8959, '\p{ismathematicaloperators}', "");
    Expect(0, 8959, '\p{^ismathematicaloperators}', "");
    Expect(0, 8959, '\P{ismathematicaloperators}', "");
    Expect(1, 8959, '\P{^ismathematicaloperators}', "");
    Expect(0, 8960, '\p{ismathematicaloperators}', "");
    Expect(1, 8960, '\p{^ismathematicaloperators}', "");
    Expect(1, 8960, '\P{ismathematicaloperators}', "");
    Expect(0, 8960, '\P{^ismathematicaloperators}', "");
    Expect(1, 8959, '\p{Is_Mathematical_Operators}', "");
    Expect(0, 8959, '\p{^Is_Mathematical_Operators}', "");
    Expect(0, 8959, '\P{Is_Mathematical_Operators}', "");
    Expect(1, 8959, '\P{^Is_Mathematical_Operators}', "");
    Expect(0, 8960, '\p{Is_Mathematical_Operators}', "");
    Expect(1, 8960, '\p{^Is_Mathematical_Operators}', "");
    Expect(1, 8960, '\P{Is_Mathematical_Operators}', "");
    Expect(0, 8960, '\P{^Is_Mathematical_Operators}', "");
    Error('\p{-/a/In_Mathematical_OPERATORS}');
    Error('\P{-/a/In_Mathematical_OPERATORS}');
    Expect(1, 8959, '\p{inmathematicaloperators}', "");
    Expect(0, 8959, '\p{^inmathematicaloperators}', "");
    Expect(0, 8959, '\P{inmathematicaloperators}', "");
    Expect(1, 8959, '\P{^inmathematicaloperators}', "");
    Expect(0, 8960, '\p{inmathematicaloperators}', "");
    Expect(1, 8960, '\p{^inmathematicaloperators}', "");
    Expect(1, 8960, '\P{inmathematicaloperators}', "");
    Expect(0, 8960, '\P{^inmathematicaloperators}', "");
    Expect(1, 8959, '\p{ 	IN_Mathematical_OPERATORS}', "");
    Expect(0, 8959, '\p{^ 	IN_Mathematical_OPERATORS}', "");
    Expect(0, 8959, '\P{ 	IN_Mathematical_OPERATORS}', "");
    Expect(1, 8959, '\P{^ 	IN_Mathematical_OPERATORS}', "");
    Expect(0, 8960, '\p{ 	IN_Mathematical_OPERATORS}', "");
    Expect(1, 8960, '\p{^ 	IN_Mathematical_OPERATORS}', "");
    Expect(1, 8960, '\P{ 	IN_Mathematical_OPERATORS}', "");
    Expect(0, 8960, '\P{^ 	IN_Mathematical_OPERATORS}', "");
    Error('\p{:=  MATH_OPERATORS}');
    Error('\P{:=  MATH_OPERATORS}');
    Expect(1, 8959, '\p{mathoperators}', "");
    Expect(0, 8959, '\p{^mathoperators}', "");
    Expect(0, 8959, '\P{mathoperators}', "");
    Expect(1, 8959, '\P{^mathoperators}', "");
    Expect(0, 8960, '\p{mathoperators}', "");
    Expect(1, 8960, '\p{^mathoperators}', "");
    Expect(1, 8960, '\P{mathoperators}', "");
    Expect(0, 8960, '\P{^mathoperators}', "");
    Expect(1, 8959, '\p{-Math_operators}', "");
    Expect(0, 8959, '\p{^-Math_operators}', "");
    Expect(0, 8959, '\P{-Math_operators}', "");
    Expect(1, 8959, '\P{^-Math_operators}', "");
    Expect(0, 8960, '\p{-Math_operators}', "");
    Expect(1, 8960, '\p{^-Math_operators}', "");
    Expect(1, 8960, '\P{-Math_operators}', "");
    Expect(0, 8960, '\P{^-Math_operators}', "");
    Error('\p{/a/ _IS_math_Operators}');
    Error('\P{/a/ _IS_math_Operators}');
    Expect(1, 8959, '\p{ismathoperators}', "");
    Expect(0, 8959, '\p{^ismathoperators}', "");
    Expect(0, 8959, '\P{ismathoperators}', "");
    Expect(1, 8959, '\P{^ismathoperators}', "");
    Expect(0, 8960, '\p{ismathoperators}', "");
    Expect(1, 8960, '\p{^ismathoperators}', "");
    Expect(1, 8960, '\P{ismathoperators}', "");
    Expect(0, 8960, '\P{^ismathoperators}', "");
    Expect(1, 8959, '\p{Is_Math_operators}', "");
    Expect(0, 8959, '\p{^Is_Math_operators}', "");
    Expect(0, 8959, '\P{Is_Math_operators}', "");
    Expect(1, 8959, '\P{^Is_Math_operators}', "");
    Expect(0, 8960, '\p{Is_Math_operators}', "");
    Expect(1, 8960, '\p{^Is_Math_operators}', "");
    Expect(1, 8960, '\P{Is_Math_operators}', "");
    Expect(0, 8960, '\P{^Is_Math_operators}', "");
    Error('\p{:=	 in_MATH_operators}');
    Error('\P{:=	 in_MATH_operators}');
    Expect(1, 8959, '\p{inmathoperators}', "");
    Expect(0, 8959, '\p{^inmathoperators}', "");
    Expect(0, 8959, '\P{inmathoperators}', "");
    Expect(1, 8959, '\P{^inmathoperators}', "");
    Expect(0, 8960, '\p{inmathoperators}', "");
    Expect(1, 8960, '\p{^inmathoperators}', "");
    Expect(1, 8960, '\P{inmathoperators}', "");
    Expect(0, 8960, '\P{^inmathoperators}', "");
    Expect(1, 8959, '\p{  In_Math_Operators}', "");
    Expect(0, 8959, '\p{^  In_Math_Operators}', "");
    Expect(0, 8959, '\P{  In_Math_Operators}', "");
    Expect(1, 8959, '\P{^  In_Math_Operators}', "");
    Expect(0, 8960, '\p{  In_Math_Operators}', "");
    Expect(1, 8960, '\p{^  In_Math_Operators}', "");
    Expect(1, 8960, '\P{  In_Math_Operators}', "");
    Expect(0, 8960, '\P{^  In_Math_Operators}', "");
    Error('\p{/a/_ Mayan_NUMERALS}');
    Error('\P{/a/_ Mayan_NUMERALS}');
    Expect(1, 119551, '\p{mayannumerals}', "");
    Expect(0, 119551, '\p{^mayannumerals}', "");
    Expect(0, 119551, '\P{mayannumerals}', "");
    Expect(1, 119551, '\P{^mayannumerals}', "");
    Expect(0, 119552, '\p{mayannumerals}', "");
    Expect(1, 119552, '\p{^mayannumerals}', "");
    Expect(1, 119552, '\P{mayannumerals}', "");
    Expect(0, 119552, '\P{^mayannumerals}', "");
    Expect(1, 119551, '\p{_-mayan_numerals}', "");
    Expect(0, 119551, '\p{^_-mayan_numerals}', "");
    Expect(0, 119551, '\P{_-mayan_numerals}', "");
    Expect(1, 119551, '\P{^_-mayan_numerals}', "");
    Expect(0, 119552, '\p{_-mayan_numerals}', "");
    Expect(1, 119552, '\p{^_-mayan_numerals}', "");
    Expect(1, 119552, '\P{_-mayan_numerals}', "");
    Expect(0, 119552, '\P{^_-mayan_numerals}', "");
    Error('\p{	/a/Is_MAYAN_Numerals}');
    Error('\P{	/a/Is_MAYAN_Numerals}');
    Expect(1, 119551, '\p{ismayannumerals}', "");
    Expect(0, 119551, '\p{^ismayannumerals}', "");
    Expect(0, 119551, '\P{ismayannumerals}', "");
    Expect(1, 119551, '\P{^ismayannumerals}', "");
    Expect(0, 119552, '\p{ismayannumerals}', "");
    Expect(1, 119552, '\p{^ismayannumerals}', "");
    Expect(1, 119552, '\P{ismayannumerals}', "");
    Expect(0, 119552, '\P{^ismayannumerals}', "");
    Expect(1, 119551, '\p{	_Is_mayan_NUMERALS}', "");
    Expect(0, 119551, '\p{^	_Is_mayan_NUMERALS}', "");
    Expect(0, 119551, '\P{	_Is_mayan_NUMERALS}', "");
    Expect(1, 119551, '\P{^	_Is_mayan_NUMERALS}', "");
    Expect(0, 119552, '\p{	_Is_mayan_NUMERALS}', "");
    Expect(1, 119552, '\p{^	_Is_mayan_NUMERALS}', "");
    Expect(1, 119552, '\P{	_Is_mayan_NUMERALS}', "");
    Expect(0, 119552, '\P{^	_Is_mayan_NUMERALS}', "");
    Error('\p{		In_MAYAN_numerals:=}');
    Error('\P{		In_MAYAN_numerals:=}');
    Expect(1, 119551, '\p{inmayannumerals}', "");
    Expect(0, 119551, '\p{^inmayannumerals}', "");
    Expect(0, 119551, '\P{inmayannumerals}', "");
    Expect(1, 119551, '\P{^inmayannumerals}', "");
    Expect(0, 119552, '\p{inmayannumerals}', "");
    Expect(1, 119552, '\p{^inmayannumerals}', "");
    Expect(1, 119552, '\P{inmayannumerals}', "");
    Expect(0, 119552, '\P{^inmayannumerals}', "");
    Expect(1, 119551, '\p{_IN_MAYAN_numerals}', "");
    Expect(0, 119551, '\p{^_IN_MAYAN_numerals}', "");
    Expect(0, 119551, '\P{_IN_MAYAN_numerals}', "");
    Expect(1, 119551, '\P{^_IN_MAYAN_numerals}', "");
    Expect(0, 119552, '\p{_IN_MAYAN_numerals}', "");
    Expect(1, 119552, '\p{^_IN_MAYAN_numerals}', "");
    Expect(1, 119552, '\P{_IN_MAYAN_numerals}', "");
    Expect(0, 119552, '\P{^_IN_MAYAN_numerals}', "");
    Error('\p{:=medefaidrin}');
    Error('\P{:=medefaidrin}');
    Expect(1, 93850, '\p{medefaidrin}', "");
    Expect(0, 93850, '\p{^medefaidrin}', "");
    Expect(0, 93850, '\P{medefaidrin}', "");
    Expect(1, 93850, '\P{^medefaidrin}', "");
    Expect(0, 93851, '\p{medefaidrin}', "");
    Expect(1, 93851, '\p{^medefaidrin}', "");
    Expect(1, 93851, '\P{medefaidrin}', "");
    Expect(0, 93851, '\P{^medefaidrin}', "");
    Expect(1, 93850, '\p{ -medefaidrin}', "");
    Expect(0, 93850, '\p{^ -medefaidrin}', "");
    Expect(0, 93850, '\P{ -medefaidrin}', "");
    Expect(1, 93850, '\P{^ -medefaidrin}', "");
    Expect(0, 93851, '\p{ -medefaidrin}', "");
    Expect(1, 93851, '\p{^ -medefaidrin}', "");
    Expect(1, 93851, '\P{ -medefaidrin}', "");
    Expect(0, 93851, '\P{^ -medefaidrin}', "");
    Error('\p{_/a/IS_Medefaidrin}');
    Error('\P{_/a/IS_Medefaidrin}');
    Expect(1, 93850, '\p{ismedefaidrin}', "");
    Expect(0, 93850, '\p{^ismedefaidrin}', "");
    Expect(0, 93850, '\P{ismedefaidrin}', "");
    Expect(1, 93850, '\P{^ismedefaidrin}', "");
    Expect(0, 93851, '\p{ismedefaidrin}', "");
    Expect(1, 93851, '\p{^ismedefaidrin}', "");
    Expect(1, 93851, '\P{ismedefaidrin}', "");
    Expect(0, 93851, '\P{^ismedefaidrin}', "");
    Expect(1, 93850, '\p{_Is_Medefaidrin}', "");
    Expect(0, 93850, '\p{^_Is_Medefaidrin}', "");
    Expect(0, 93850, '\P{_Is_Medefaidrin}', "");
    Expect(1, 93850, '\P{^_Is_Medefaidrin}', "");
    Expect(0, 93851, '\p{_Is_Medefaidrin}', "");
    Expect(1, 93851, '\p{^_Is_Medefaidrin}', "");
    Expect(1, 93851, '\P{_Is_Medefaidrin}', "");
    Expect(0, 93851, '\P{^_Is_Medefaidrin}', "");
    Error('\p{ MEDF/a/}');
    Error('\P{ MEDF/a/}');
    Expect(1, 93850, '\p{medf}', "");
    Expect(0, 93850, '\p{^medf}', "");
    Expect(0, 93850, '\P{medf}', "");
    Expect(1, 93850, '\P{^medf}', "");
    Expect(0, 93851, '\p{medf}', "");
    Expect(1, 93851, '\p{^medf}', "");
    Expect(1, 93851, '\P{medf}', "");
    Expect(0, 93851, '\P{^medf}', "");
    Expect(1, 93850, '\p{-	medf}', "");
    Expect(0, 93850, '\p{^-	medf}', "");
    Expect(0, 93850, '\P{-	medf}', "");
    Expect(1, 93850, '\P{^-	medf}', "");
    Expect(0, 93851, '\p{-	medf}', "");
    Expect(1, 93851, '\p{^-	medf}', "");
    Expect(1, 93851, '\P{-	medf}', "");
    Expect(0, 93851, '\P{^-	medf}', "");
    Error('\p{-_IS_MEDF:=}');
    Error('\P{-_IS_MEDF:=}');
    Expect(1, 93850, '\p{ismedf}', "");
    Expect(0, 93850, '\p{^ismedf}', "");
    Expect(0, 93850, '\P{ismedf}', "");
    Expect(1, 93850, '\P{^ismedf}', "");
    Expect(0, 93851, '\p{ismedf}', "");
    Expect(1, 93851, '\p{^ismedf}', "");
    Expect(1, 93851, '\P{ismedf}', "");
    Expect(0, 93851, '\P{^ismedf}', "");
    Expect(1, 93850, '\p{-Is_MEDF}', "");
    Expect(0, 93850, '\p{^-Is_MEDF}', "");
    Expect(0, 93850, '\P{-Is_MEDF}', "");
    Expect(1, 93850, '\P{^-Is_MEDF}', "");
    Expect(0, 93851, '\p{-Is_MEDF}', "");
    Expect(1, 93851, '\p{^-Is_MEDF}', "");
    Expect(1, 93851, '\P{-Is_MEDF}', "");
    Expect(0, 93851, '\P{^-Is_MEDF}', "");
    Error('\p{ /a/Meetei_Mayek}');
    Error('\P{ /a/Meetei_Mayek}');
    Expect(1, 44025, '\p{meeteimayek}', "");
    Expect(0, 44025, '\p{^meeteimayek}', "");
    Expect(0, 44025, '\P{meeteimayek}', "");
    Expect(1, 44025, '\P{^meeteimayek}', "");
    Expect(0, 44026, '\p{meeteimayek}', "");
    Expect(1, 44026, '\p{^meeteimayek}', "");
    Expect(1, 44026, '\P{meeteimayek}', "");
    Expect(0, 44026, '\P{^meeteimayek}', "");
    Expect(1, 44025, '\p{ 	Meetei_MAYEK}', "");
    Expect(0, 44025, '\p{^ 	Meetei_MAYEK}', "");
    Expect(0, 44025, '\P{ 	Meetei_MAYEK}', "");
    Expect(1, 44025, '\P{^ 	Meetei_MAYEK}', "");
    Expect(0, 44026, '\p{ 	Meetei_MAYEK}', "");
    Expect(1, 44026, '\p{^ 	Meetei_MAYEK}', "");
    Expect(1, 44026, '\P{ 	Meetei_MAYEK}', "");
    Expect(0, 44026, '\P{^ 	Meetei_MAYEK}', "");
    Error('\p{_/a/Is_Meetei_Mayek}');
    Error('\P{_/a/Is_Meetei_Mayek}');
    Expect(1, 44025, '\p{ismeeteimayek}', "");
    Expect(0, 44025, '\p{^ismeeteimayek}', "");
    Expect(0, 44025, '\P{ismeeteimayek}', "");
    Expect(1, 44025, '\P{^ismeeteimayek}', "");
    Expect(0, 44026, '\p{ismeeteimayek}', "");
    Expect(1, 44026, '\p{^ismeeteimayek}', "");
    Expect(1, 44026, '\P{ismeeteimayek}', "");
    Expect(0, 44026, '\P{^ismeeteimayek}', "");
    Expect(1, 44025, '\p{- IS_Meetei_MAYEK}', "");
    Expect(0, 44025, '\p{^- IS_Meetei_MAYEK}', "");
    Expect(0, 44025, '\P{- IS_Meetei_MAYEK}', "");
    Expect(1, 44025, '\P{^- IS_Meetei_MAYEK}', "");
    Expect(0, 44026, '\p{- IS_Meetei_MAYEK}', "");
    Expect(1, 44026, '\p{^- IS_Meetei_MAYEK}', "");
    Expect(1, 44026, '\P{- IS_Meetei_MAYEK}', "");
    Expect(0, 44026, '\P{^- IS_Meetei_MAYEK}', "");
    Error('\p{:=_Mtei}');
    Error('\P{:=_Mtei}');
    Expect(1, 44025, '\p{mtei}', "");
    Expect(0, 44025, '\p{^mtei}', "");
    Expect(0, 44025, '\P{mtei}', "");
    Expect(1, 44025, '\P{^mtei}', "");
    Expect(0, 44026, '\p{mtei}', "");
    Expect(1, 44026, '\p{^mtei}', "");
    Expect(1, 44026, '\P{mtei}', "");
    Expect(0, 44026, '\P{^mtei}', "");
    Expect(1, 44025, '\p{ mtei}', "");
    Expect(0, 44025, '\p{^ mtei}', "");
    Expect(0, 44025, '\P{ mtei}', "");
    Expect(1, 44025, '\P{^ mtei}', "");
    Expect(0, 44026, '\p{ mtei}', "");
    Expect(1, 44026, '\p{^ mtei}', "");
    Expect(1, 44026, '\P{ mtei}', "");
    Expect(0, 44026, '\P{^ mtei}', "");
    Error('\p{/a/-is_Mtei}');
    Error('\P{/a/-is_Mtei}');
    Expect(1, 44025, '\p{ismtei}', "");
    Expect(0, 44025, '\p{^ismtei}', "");
    Expect(0, 44025, '\P{ismtei}', "");
    Expect(1, 44025, '\P{^ismtei}', "");
    Expect(0, 44026, '\p{ismtei}', "");
    Expect(1, 44026, '\p{^ismtei}', "");
    Expect(1, 44026, '\P{ismtei}', "");
    Expect(0, 44026, '\P{^ismtei}', "");
    Expect(1, 44025, '\p{__is_MTEI}', "");
    Expect(0, 44025, '\p{^__is_MTEI}', "");
    Expect(0, 44025, '\P{__is_MTEI}', "");
    Expect(1, 44025, '\P{^__is_MTEI}', "");
    Expect(0, 44026, '\p{__is_MTEI}', "");
    Expect(1, 44026, '\p{^__is_MTEI}', "");
    Expect(1, 44026, '\P{__is_MTEI}', "");
    Expect(0, 44026, '\P{^__is_MTEI}', "");
    Error('\p{__MEETEI_MAYEK_Extensions/a/}');
    Error('\P{__MEETEI_MAYEK_Extensions/a/}');
    Expect(1, 43775, '\p{meeteimayekextensions}', "");
    Expect(0, 43775, '\p{^meeteimayekextensions}', "");
    Expect(0, 43775, '\P{meeteimayekextensions}', "");
    Expect(1, 43775, '\P{^meeteimayekextensions}', "");
    Expect(0, 43776, '\p{meeteimayekextensions}', "");
    Expect(1, 43776, '\p{^meeteimayekextensions}', "");
    Expect(1, 43776, '\P{meeteimayekextensions}', "");
    Expect(0, 43776, '\P{^meeteimayekextensions}', "");
    Expect(1, 43775, '\p{_Meetei_Mayek_Extensions}', "");
    Expect(0, 43775, '\p{^_Meetei_Mayek_Extensions}', "");
    Expect(0, 43775, '\P{_Meetei_Mayek_Extensions}', "");
    Expect(1, 43775, '\P{^_Meetei_Mayek_Extensions}', "");
    Expect(0, 43776, '\p{_Meetei_Mayek_Extensions}', "");
    Expect(1, 43776, '\p{^_Meetei_Mayek_Extensions}', "");
    Expect(1, 43776, '\P{_Meetei_Mayek_Extensions}', "");
    Expect(0, 43776, '\P{^_Meetei_Mayek_Extensions}', "");
    Error('\p{	Is_meetei_mayek_Extensions/a/}');
    Error('\P{	Is_meetei_mayek_Extensions/a/}');
    Expect(1, 43775, '\p{ismeeteimayekextensions}', "");
    Expect(0, 43775, '\p{^ismeeteimayekextensions}', "");
    Expect(0, 43775, '\P{ismeeteimayekextensions}', "");
    Expect(1, 43775, '\P{^ismeeteimayekextensions}', "");
    Expect(0, 43776, '\p{ismeeteimayekextensions}', "");
    Expect(1, 43776, '\p{^ismeeteimayekextensions}', "");
    Expect(1, 43776, '\P{ismeeteimayekextensions}', "");
    Expect(0, 43776, '\P{^ismeeteimayekextensions}', "");
    Expect(1, 43775, '\p{-	is_MEETEI_Mayek_extensions}', "");
    Expect(0, 43775, '\p{^-	is_MEETEI_Mayek_extensions}', "");
    Expect(0, 43775, '\P{-	is_MEETEI_Mayek_extensions}', "");
    Expect(1, 43775, '\P{^-	is_MEETEI_Mayek_extensions}', "");
    Expect(0, 43776, '\p{-	is_MEETEI_Mayek_extensions}', "");
    Expect(1, 43776, '\p{^-	is_MEETEI_Mayek_extensions}', "");
    Expect(1, 43776, '\P{-	is_MEETEI_Mayek_extensions}', "");
    Expect(0, 43776, '\P{^-	is_MEETEI_Mayek_extensions}', "");
    Error('\p{_ In_Meetei_mayek_EXTENSIONS/a/}');
    Error('\P{_ In_Meetei_mayek_EXTENSIONS/a/}');
    Expect(1, 43775, '\p{inmeeteimayekextensions}', "");
    Expect(0, 43775, '\p{^inmeeteimayekextensions}', "");
    Expect(0, 43775, '\P{inmeeteimayekextensions}', "");
    Expect(1, 43775, '\P{^inmeeteimayekextensions}', "");
    Expect(0, 43776, '\p{inmeeteimayekextensions}', "");
    Expect(1, 43776, '\p{^inmeeteimayekextensions}', "");
    Expect(1, 43776, '\P{inmeeteimayekextensions}', "");
    Expect(0, 43776, '\P{^inmeeteimayekextensions}', "");
    Expect(1, 43775, '\p{_IN_Meetei_mayek_Extensions}', "");
    Expect(0, 43775, '\p{^_IN_Meetei_mayek_Extensions}', "");
    Expect(0, 43775, '\P{_IN_Meetei_mayek_Extensions}', "");
    Expect(1, 43775, '\P{^_IN_Meetei_mayek_Extensions}', "");
    Expect(0, 43776, '\p{_IN_Meetei_mayek_Extensions}', "");
    Expect(1, 43776, '\p{^_IN_Meetei_mayek_Extensions}', "");
    Expect(1, 43776, '\P{_IN_Meetei_mayek_Extensions}', "");
    Expect(0, 43776, '\P{^_IN_Meetei_mayek_Extensions}', "");
    Error('\p{_Meetei_MAYEK_Ext/a/}');
    Error('\P{_Meetei_MAYEK_Ext/a/}');
    Expect(1, 43775, '\p{meeteimayekext}', "");
    Expect(0, 43775, '\p{^meeteimayekext}', "");
    Expect(0, 43775, '\P{meeteimayekext}', "");
    Expect(1, 43775, '\P{^meeteimayekext}', "");
    Expect(0, 43776, '\p{meeteimayekext}', "");
    Expect(1, 43776, '\p{^meeteimayekext}', "");
    Expect(1, 43776, '\P{meeteimayekext}', "");
    Expect(0, 43776, '\P{^meeteimayekext}', "");
    Expect(1, 43775, '\p{-MEETEI_mayek_Ext}', "");
    Expect(0, 43775, '\p{^-MEETEI_mayek_Ext}', "");
    Expect(0, 43775, '\P{-MEETEI_mayek_Ext}', "");
    Expect(1, 43775, '\P{^-MEETEI_mayek_Ext}', "");
    Expect(0, 43776, '\p{-MEETEI_mayek_Ext}', "");
    Expect(1, 43776, '\p{^-MEETEI_mayek_Ext}', "");
    Expect(1, 43776, '\P{-MEETEI_mayek_Ext}', "");
    Expect(0, 43776, '\P{^-MEETEI_mayek_Ext}', "");
    Error('\p{ :=IS_MEETEI_Mayek_Ext}');
    Error('\P{ :=IS_MEETEI_Mayek_Ext}');
    Expect(1, 43775, '\p{ismeeteimayekext}', "");
    Expect(0, 43775, '\p{^ismeeteimayekext}', "");
    Expect(0, 43775, '\P{ismeeteimayekext}', "");
    Expect(1, 43775, '\P{^ismeeteimayekext}', "");
    Expect(0, 43776, '\p{ismeeteimayekext}', "");
    Expect(1, 43776, '\p{^ismeeteimayekext}', "");
    Expect(1, 43776, '\P{ismeeteimayekext}', "");
    Expect(0, 43776, '\P{^ismeeteimayekext}', "");
    Expect(1, 43775, '\p{ -Is_MEETEI_Mayek_EXT}', "");
    Expect(0, 43775, '\p{^ -Is_MEETEI_Mayek_EXT}', "");
    Expect(0, 43775, '\P{ -Is_MEETEI_Mayek_EXT}', "");
    Expect(1, 43775, '\P{^ -Is_MEETEI_Mayek_EXT}', "");
    Expect(0, 43776, '\p{ -Is_MEETEI_Mayek_EXT}', "");
    Expect(1, 43776, '\p{^ -Is_MEETEI_Mayek_EXT}', "");
    Expect(1, 43776, '\P{ -Is_MEETEI_Mayek_EXT}', "");
    Expect(0, 43776, '\P{^ -Is_MEETEI_Mayek_EXT}', "");
    Error('\p{ :=IN_MEETEI_Mayek_EXT}');
    Error('\P{ :=IN_MEETEI_Mayek_EXT}');
    Expect(1, 43775, '\p{inmeeteimayekext}', "");
    Expect(0, 43775, '\p{^inmeeteimayekext}', "");
    Expect(0, 43775, '\P{inmeeteimayekext}', "");
    Expect(1, 43775, '\P{^inmeeteimayekext}', "");
    Expect(0, 43776, '\p{inmeeteimayekext}', "");
    Expect(1, 43776, '\p{^inmeeteimayekext}', "");
    Expect(1, 43776, '\P{inmeeteimayekext}', "");
    Expect(0, 43776, '\P{^inmeeteimayekext}', "");
    Expect(1, 43775, '\p{_IN_Meetei_mayek_ext}', "");
    Expect(0, 43775, '\p{^_IN_Meetei_mayek_ext}', "");
    Expect(0, 43775, '\P{_IN_Meetei_mayek_ext}', "");
    Expect(1, 43775, '\P{^_IN_Meetei_mayek_ext}', "");
    Expect(0, 43776, '\p{_IN_Meetei_mayek_ext}', "");
    Expect(1, 43776, '\p{^_IN_Meetei_mayek_ext}', "");
    Expect(1, 43776, '\P{_IN_Meetei_mayek_ext}', "");
    Expect(0, 43776, '\P{^_IN_Meetei_mayek_ext}', "");
    Error('\p{:=	-Mende_KIKAKUI}');
    Error('\P{:=	-Mende_KIKAKUI}');
    Expect(1, 125142, '\p{mendekikakui}', "");
    Expect(0, 125142, '\p{^mendekikakui}', "");
    Expect(0, 125142, '\P{mendekikakui}', "");
    Expect(1, 125142, '\P{^mendekikakui}', "");
    Expect(0, 125143, '\p{mendekikakui}', "");
    Expect(1, 125143, '\p{^mendekikakui}', "");
    Expect(1, 125143, '\P{mendekikakui}', "");
    Expect(0, 125143, '\P{^mendekikakui}', "");
    Expect(1, 125142, '\p{ 	Mende_Kikakui}', "");
    Expect(0, 125142, '\p{^ 	Mende_Kikakui}', "");
    Expect(0, 125142, '\P{ 	Mende_Kikakui}', "");
    Expect(1, 125142, '\P{^ 	Mende_Kikakui}', "");
    Expect(0, 125143, '\p{ 	Mende_Kikakui}', "");
    Expect(1, 125143, '\p{^ 	Mende_Kikakui}', "");
    Expect(1, 125143, '\P{ 	Mende_Kikakui}', "");
    Expect(0, 125143, '\P{^ 	Mende_Kikakui}', "");
    Error('\p{:= 	Is_Mende_kikakui}');
    Error('\P{:= 	Is_Mende_kikakui}');
    Expect(1, 125142, '\p{ismendekikakui}', "");
    Expect(0, 125142, '\p{^ismendekikakui}', "");
    Expect(0, 125142, '\P{ismendekikakui}', "");
    Expect(1, 125142, '\P{^ismendekikakui}', "");
    Expect(0, 125143, '\p{ismendekikakui}', "");
    Expect(1, 125143, '\p{^ismendekikakui}', "");
    Expect(1, 125143, '\P{ismendekikakui}', "");
    Expect(0, 125143, '\P{^ismendekikakui}', "");
    Expect(1, 125142, '\p{_IS_Mende_KIKAKUI}', "");
    Expect(0, 125142, '\p{^_IS_Mende_KIKAKUI}', "");
    Expect(0, 125142, '\P{_IS_Mende_KIKAKUI}', "");
    Expect(1, 125142, '\P{^_IS_Mende_KIKAKUI}', "");
    Expect(0, 125143, '\p{_IS_Mende_KIKAKUI}', "");
    Expect(1, 125143, '\p{^_IS_Mende_KIKAKUI}', "");
    Expect(1, 125143, '\P{_IS_Mende_KIKAKUI}', "");
    Expect(0, 125143, '\P{^_IS_Mende_KIKAKUI}', "");
    Error('\p{:=  MEND}');
    Error('\P{:=  MEND}');
    Expect(1, 125142, '\p{mend}', "");
    Expect(0, 125142, '\p{^mend}', "");
    Expect(0, 125142, '\P{mend}', "");
    Expect(1, 125142, '\P{^mend}', "");
    Expect(0, 125143, '\p{mend}', "");
    Expect(1, 125143, '\p{^mend}', "");
    Expect(1, 125143, '\P{mend}', "");
    Expect(0, 125143, '\P{^mend}', "");
    Expect(1, 125142, '\p{_Mend}', "");
    Expect(0, 125142, '\p{^_Mend}', "");
    Expect(0, 125142, '\P{_Mend}', "");
    Expect(1, 125142, '\P{^_Mend}', "");
    Expect(0, 125143, '\p{_Mend}', "");
    Expect(1, 125143, '\p{^_Mend}', "");
    Expect(1, 125143, '\P{_Mend}', "");
    Expect(0, 125143, '\P{^_Mend}', "");
    Error('\p{	Is_Mend/a/}');
    Error('\P{	Is_Mend/a/}');
    Expect(1, 125142, '\p{ismend}', "");
    Expect(0, 125142, '\p{^ismend}', "");
    Expect(0, 125142, '\P{ismend}', "");
    Expect(1, 125142, '\P{^ismend}', "");
    Expect(0, 125143, '\p{ismend}', "");
    Expect(1, 125143, '\p{^ismend}', "");
    Expect(1, 125143, '\P{ismend}', "");
    Expect(0, 125143, '\P{^ismend}', "");
    Expect(1, 125142, '\p{is_Mend}', "");
    Expect(0, 125142, '\p{^is_Mend}', "");
    Expect(0, 125142, '\P{is_Mend}', "");
    Expect(1, 125142, '\P{^is_Mend}', "");
    Expect(0, 125143, '\p{is_Mend}', "");
    Expect(1, 125143, '\p{^is_Mend}', "");
    Expect(1, 125143, '\P{is_Mend}', "");
    Expect(0, 125143, '\P{^is_Mend}', "");
    Error('\p{_	Meroitic_Cursive/a/}');
    Error('\P{_	Meroitic_Cursive/a/}');
    Expect(1, 68095, '\p{meroiticcursive}', "");
    Expect(0, 68095, '\p{^meroiticcursive}', "");
    Expect(0, 68095, '\P{meroiticcursive}', "");
    Expect(1, 68095, '\P{^meroiticcursive}', "");
    Expect(0, 68096, '\p{meroiticcursive}', "");
    Expect(1, 68096, '\p{^meroiticcursive}', "");
    Expect(1, 68096, '\P{meroiticcursive}', "");
    Expect(0, 68096, '\P{^meroiticcursive}', "");
    Expect(1, 68095, '\p{	 Meroitic_cursive}', "");
    Expect(0, 68095, '\p{^	 Meroitic_cursive}', "");
    Expect(0, 68095, '\P{	 Meroitic_cursive}', "");
    Expect(1, 68095, '\P{^	 Meroitic_cursive}', "");
    Expect(0, 68096, '\p{	 Meroitic_cursive}', "");
    Expect(1, 68096, '\p{^	 Meroitic_cursive}', "");
    Expect(1, 68096, '\P{	 Meroitic_cursive}', "");
    Expect(0, 68096, '\P{^	 Meroitic_cursive}', "");
    Error('\p{		Is_meroitic_cursive/a/}');
    Error('\P{		Is_meroitic_cursive/a/}');
    Expect(1, 68095, '\p{ismeroiticcursive}', "");
    Expect(0, 68095, '\p{^ismeroiticcursive}', "");
    Expect(0, 68095, '\P{ismeroiticcursive}', "");
    Expect(1, 68095, '\P{^ismeroiticcursive}', "");
    Expect(0, 68096, '\p{ismeroiticcursive}', "");
    Expect(1, 68096, '\p{^ismeroiticcursive}', "");
    Expect(1, 68096, '\P{ismeroiticcursive}', "");
    Expect(0, 68096, '\P{^ismeroiticcursive}', "");
    Expect(1, 68095, '\p{	IS_Meroitic_cursive}', "");
    Expect(0, 68095, '\p{^	IS_Meroitic_cursive}', "");
    Expect(0, 68095, '\P{	IS_Meroitic_cursive}', "");
    Expect(1, 68095, '\P{^	IS_Meroitic_cursive}', "");
    Expect(0, 68096, '\p{	IS_Meroitic_cursive}', "");
    Expect(1, 68096, '\p{^	IS_Meroitic_cursive}', "");
    Expect(1, 68096, '\P{	IS_Meroitic_cursive}', "");
    Expect(0, 68096, '\P{^	IS_Meroitic_cursive}', "");
    Error('\p{-merc:=}');
    Error('\P{-merc:=}');
    Expect(1, 68095, '\p{merc}', "");
    Expect(0, 68095, '\p{^merc}', "");
    Expect(0, 68095, '\P{merc}', "");
    Expect(1, 68095, '\P{^merc}', "");
    Expect(0, 68096, '\p{merc}', "");
    Expect(1, 68096, '\p{^merc}', "");
    Expect(1, 68096, '\P{merc}', "");
    Expect(0, 68096, '\P{^merc}', "");
    Expect(1, 68095, '\p{ _Merc}', "");
    Expect(0, 68095, '\p{^ _Merc}', "");
    Expect(0, 68095, '\P{ _Merc}', "");
    Expect(1, 68095, '\P{^ _Merc}', "");
    Expect(0, 68096, '\p{ _Merc}', "");
    Expect(1, 68096, '\p{^ _Merc}', "");
    Expect(1, 68096, '\P{ _Merc}', "");
    Expect(0, 68096, '\P{^ _Merc}', "");
    Error('\p{	:=Is_merc}');
    Error('\P{	:=Is_merc}');
    Expect(1, 68095, '\p{ismerc}', "");
    Expect(0, 68095, '\p{^ismerc}', "");
    Expect(0, 68095, '\P{ismerc}', "");
    Expect(1, 68095, '\P{^ismerc}', "");
    Expect(0, 68096, '\p{ismerc}', "");
    Expect(1, 68096, '\p{^ismerc}', "");
    Expect(1, 68096, '\P{ismerc}', "");
    Expect(0, 68096, '\P{^ismerc}', "");
    Expect(1, 68095, '\p{__IS_merc}', "");
    Expect(0, 68095, '\p{^__IS_merc}', "");
    Expect(0, 68095, '\P{__IS_merc}', "");
    Expect(1, 68095, '\P{^__IS_merc}', "");
    Expect(0, 68096, '\p{__IS_merc}', "");
    Expect(1, 68096, '\p{^__IS_merc}', "");
    Expect(1, 68096, '\P{__IS_merc}', "");
    Expect(0, 68096, '\P{^__IS_merc}', "");
    Error('\p{:=_	MEROITIC_Hieroglyphs}');
    Error('\P{:=_	MEROITIC_Hieroglyphs}');
    Expect(1, 67999, '\p{meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{	MEROITIC_HIEROGLYPHS}', "");
    Expect(0, 67999, '\p{^	MEROITIC_HIEROGLYPHS}', "");
    Expect(0, 67999, '\P{	MEROITIC_HIEROGLYPHS}', "");
    Expect(1, 67999, '\P{^	MEROITIC_HIEROGLYPHS}', "");
    Expect(0, 68000, '\p{	MEROITIC_HIEROGLYPHS}', "");
    Expect(1, 68000, '\p{^	MEROITIC_HIEROGLYPHS}', "");
    Expect(1, 68000, '\P{	MEROITIC_HIEROGLYPHS}', "");
    Expect(0, 68000, '\P{^	MEROITIC_HIEROGLYPHS}', "");
    Error('\p{-_Is_meroitic_Hieroglyphs/a/}');
    Error('\P{-_Is_meroitic_Hieroglyphs/a/}');
    Expect(1, 67999, '\p{ismeroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^ismeroitichieroglyphs}', "");
    Expect(0, 67999, '\P{ismeroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^ismeroitichieroglyphs}', "");
    Expect(0, 68000, '\p{ismeroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^ismeroitichieroglyphs}', "");
    Expect(1, 68000, '\P{ismeroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^ismeroitichieroglyphs}', "");
    Expect(1, 67999, '\p{	_IS_Meroitic_hieroglyphs}', "");
    Expect(0, 67999, '\p{^	_IS_Meroitic_hieroglyphs}', "");
    Expect(0, 67999, '\P{	_IS_Meroitic_hieroglyphs}', "");
    Expect(1, 67999, '\P{^	_IS_Meroitic_hieroglyphs}', "");
    Expect(0, 68000, '\p{	_IS_Meroitic_hieroglyphs}', "");
    Expect(1, 68000, '\p{^	_IS_Meroitic_hieroglyphs}', "");
    Expect(1, 68000, '\P{	_IS_Meroitic_hieroglyphs}', "");
    Expect(0, 68000, '\P{^	_IS_Meroitic_hieroglyphs}', "");
    Error('\p{:= MERO}');
    Error('\P{:= MERO}');
    Expect(1, 67999, '\p{mero}', "");
    Expect(0, 67999, '\p{^mero}', "");
    Expect(0, 67999, '\P{mero}', "");
    Expect(1, 67999, '\P{^mero}', "");
    Expect(0, 68000, '\p{mero}', "");
    Expect(1, 68000, '\p{^mero}', "");
    Expect(1, 68000, '\P{mero}', "");
    Expect(0, 68000, '\P{^mero}', "");
    Expect(1, 67999, '\p{_-Mero}', "");
    Expect(0, 67999, '\p{^_-Mero}', "");
    Expect(0, 67999, '\P{_-Mero}', "");
    Expect(1, 67999, '\P{^_-Mero}', "");
    Expect(0, 68000, '\p{_-Mero}', "");
    Expect(1, 68000, '\p{^_-Mero}', "");
    Expect(1, 68000, '\P{_-Mero}', "");
    Expect(0, 68000, '\P{^_-Mero}', "");
    Error('\p{_Is_mero:=}');
    Error('\P{_Is_mero:=}');
    Expect(1, 67999, '\p{ismero}', "");
    Expect(0, 67999, '\p{^ismero}', "");
    Expect(0, 67999, '\P{ismero}', "");
    Expect(1, 67999, '\P{^ismero}', "");
    Expect(0, 68000, '\p{ismero}', "");
    Expect(1, 68000, '\p{^ismero}', "");
    Expect(1, 68000, '\P{ismero}', "");
    Expect(0, 68000, '\P{^ismero}', "");
    Expect(1, 67999, '\p{--is_Mero}', "");
    Expect(0, 67999, '\p{^--is_Mero}', "");
    Expect(0, 67999, '\P{--is_Mero}', "");
    Expect(1, 67999, '\P{^--is_Mero}', "");
    Expect(0, 68000, '\p{--is_Mero}', "");
    Expect(1, 68000, '\p{^--is_Mero}', "");
    Expect(1, 68000, '\P{--is_Mero}', "");
    Expect(0, 68000, '\P{^--is_Mero}', "");
    Error('\p{_ Miao/a/}');
    Error('\P{_ Miao/a/}');
    Expect(1, 94111, '\p{miao}', "");
    Expect(0, 94111, '\p{^miao}', "");
    Expect(0, 94111, '\P{miao}', "");
    Expect(1, 94111, '\P{^miao}', "");
    Expect(0, 94112, '\p{miao}', "");
    Expect(1, 94112, '\p{^miao}', "");
    Expect(1, 94112, '\P{miao}', "");
    Expect(0, 94112, '\P{^miao}', "");
    Expect(1, 94111, '\p{__MIAO}', "");
    Expect(0, 94111, '\p{^__MIAO}', "");
    Expect(0, 94111, '\P{__MIAO}', "");
    Expect(1, 94111, '\P{^__MIAO}', "");
    Expect(0, 94112, '\p{__MIAO}', "");
    Expect(1, 94112, '\p{^__MIAO}', "");
    Expect(1, 94112, '\P{__MIAO}', "");
    Expect(0, 94112, '\P{^__MIAO}', "");
    Error('\p{/a/ _is_Miao}');
    Error('\P{/a/ _is_Miao}');
    Expect(1, 94111, '\p{ismiao}', "");
    Expect(0, 94111, '\p{^ismiao}', "");
    Expect(0, 94111, '\P{ismiao}', "");
    Expect(1, 94111, '\P{^ismiao}', "");
    Expect(0, 94112, '\p{ismiao}', "");
    Expect(1, 94112, '\p{^ismiao}', "");
    Expect(1, 94112, '\P{ismiao}', "");
    Expect(0, 94112, '\P{^ismiao}', "");
    Expect(1, 94111, '\p{ -Is_Miao}', "");
    Expect(0, 94111, '\p{^ -Is_Miao}', "");
    Expect(0, 94111, '\P{ -Is_Miao}', "");
    Expect(1, 94111, '\P{^ -Is_Miao}', "");
    Expect(0, 94112, '\p{ -Is_Miao}', "");
    Expect(1, 94112, '\p{^ -Is_Miao}', "");
    Expect(1, 94112, '\P{ -Is_Miao}', "");
    Expect(0, 94112, '\P{^ -Is_Miao}', "");
    Error('\p{/a/-PLRD}');
    Error('\P{/a/-PLRD}');
    Expect(1, 94111, '\p{plrd}', "");
    Expect(0, 94111, '\p{^plrd}', "");
    Expect(0, 94111, '\P{plrd}', "");
    Expect(1, 94111, '\P{^plrd}', "");
    Expect(0, 94112, '\p{plrd}', "");
    Expect(1, 94112, '\p{^plrd}', "");
    Expect(1, 94112, '\P{plrd}', "");
    Expect(0, 94112, '\P{^plrd}', "");
    Expect(1, 94111, '\p{__Plrd}', "");
    Expect(0, 94111, '\p{^__Plrd}', "");
    Expect(0, 94111, '\P{__Plrd}', "");
    Expect(1, 94111, '\P{^__Plrd}', "");
    Expect(0, 94112, '\p{__Plrd}', "");
    Expect(1, 94112, '\p{^__Plrd}', "");
    Expect(1, 94112, '\P{__Plrd}', "");
    Expect(0, 94112, '\P{^__Plrd}', "");
    Error('\p{_is_plrd/a/}');
    Error('\P{_is_plrd/a/}');
    Expect(1, 94111, '\p{isplrd}', "");
    Expect(0, 94111, '\p{^isplrd}', "");
    Expect(0, 94111, '\P{isplrd}', "");
    Expect(1, 94111, '\P{^isplrd}', "");
    Expect(0, 94112, '\p{isplrd}', "");
    Expect(1, 94112, '\p{^isplrd}', "");
    Expect(1, 94112, '\P{isplrd}', "");
    Expect(0, 94112, '\P{^isplrd}', "");
    Expect(1, 94111, '\p{ Is_PLRD}', "");
    Expect(0, 94111, '\p{^ Is_PLRD}', "");
    Expect(0, 94111, '\P{ Is_PLRD}', "");
    Expect(1, 94111, '\P{^ Is_PLRD}', "");
    Expect(0, 94112, '\p{ Is_PLRD}', "");
    Expect(1, 94112, '\p{^ Is_PLRD}', "");
    Expect(1, 94112, '\P{ Is_PLRD}', "");
    Expect(0, 94112, '\P{^ Is_PLRD}', "");
    Error('\p{	Miscellaneous_MATHEMATICAL_SYMBOLS_A:=}');
    Error('\P{	Miscellaneous_MATHEMATICAL_SYMBOLS_A:=}');
    Expect(1, 10223, '\p{miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\p{^miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\P{miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\P{^miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\p{miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\p{^miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\P{miscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\P{^miscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\p{_	Miscellaneous_Mathematical_SYMBOLS_A}', "");
    Expect(0, 10223, '\p{^_	Miscellaneous_Mathematical_SYMBOLS_A}', "");
    Expect(0, 10223, '\P{_	Miscellaneous_Mathematical_SYMBOLS_A}', "");
    Expect(1, 10223, '\P{^_	Miscellaneous_Mathematical_SYMBOLS_A}', "");
    Expect(0, 10224, '\p{_	Miscellaneous_Mathematical_SYMBOLS_A}', "");
    Expect(1, 10224, '\p{^_	Miscellaneous_Mathematical_SYMBOLS_A}', "");
    Expect(1, 10224, '\P{_	Miscellaneous_Mathematical_SYMBOLS_A}', "");
    Expect(0, 10224, '\P{^_	Miscellaneous_Mathematical_SYMBOLS_A}', "");
    Error('\p{_IS_Miscellaneous_MATHEMATICAL_SYMBOLS_A:=}');
    Error('\P{_IS_Miscellaneous_MATHEMATICAL_SYMBOLS_A:=}');
    Expect(1, 10223, '\p{ismiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\p{^ismiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\P{ismiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\P{^ismiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\p{ismiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\p{^ismiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\P{ismiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\P{^ismiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\p{Is_Miscellaneous_MATHEMATICAL_Symbols_A}', "");
    Expect(0, 10223, '\p{^Is_Miscellaneous_MATHEMATICAL_Symbols_A}', "");
    Expect(0, 10223, '\P{Is_Miscellaneous_MATHEMATICAL_Symbols_A}', "");
    Expect(1, 10223, '\P{^Is_Miscellaneous_MATHEMATICAL_Symbols_A}', "");
    Expect(0, 10224, '\p{Is_Miscellaneous_MATHEMATICAL_Symbols_A}', "");
    Expect(1, 10224, '\p{^Is_Miscellaneous_MATHEMATICAL_Symbols_A}', "");
    Expect(1, 10224, '\P{Is_Miscellaneous_MATHEMATICAL_Symbols_A}', "");
    Expect(0, 10224, '\P{^Is_Miscellaneous_MATHEMATICAL_Symbols_A}', "");
    Error('\p{:=in_Miscellaneous_Mathematical_Symbols_A}');
    Error('\P{:=in_Miscellaneous_Mathematical_Symbols_A}');
    Expect(1, 10223, '\p{inmiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\p{^inmiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10223, '\P{inmiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\P{^inmiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\p{inmiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\p{^inmiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10224, '\P{inmiscellaneousmathematicalsymbolsa}', "");
    Expect(0, 10224, '\P{^inmiscellaneousmathematicalsymbolsa}', "");
    Expect(1, 10223, '\p{		In_MISCELLANEOUS_Mathematical_Symbols_A}', "");
    Expect(0, 10223, '\p{^		In_MISCELLANEOUS_Mathematical_Symbols_A}', "");
    Expect(0, 10223, '\P{		In_MISCELLANEOUS_Mathematical_Symbols_A}', "");
    Expect(1, 10223, '\P{^		In_MISCELLANEOUS_Mathematical_Symbols_A}', "");
    Expect(0, 10224, '\p{		In_MISCELLANEOUS_Mathematical_Symbols_A}', "");
    Expect(1, 10224, '\p{^		In_MISCELLANEOUS_Mathematical_Symbols_A}', "");
    Expect(1, 10224, '\P{		In_MISCELLANEOUS_Mathematical_Symbols_A}', "");
    Expect(0, 10224, '\P{^		In_MISCELLANEOUS_Mathematical_Symbols_A}', "");
    Error('\p{:=-Misc_Math_Symbols_A}');
    Error('\P{:=-Misc_Math_Symbols_A}');
    Expect(1, 10223, '\p{miscmathsymbolsa}', "");
    Expect(0, 10223, '\p{^miscmathsymbolsa}', "");
    Expect(0, 10223, '\P{miscmathsymbolsa}', "");
    Expect(1, 10223, '\P{^miscmathsymbolsa}', "");
    Expect(0, 10224, '\p{miscmathsymbolsa}', "");
    Expect(1, 10224, '\p{^miscmathsymbolsa}', "");
    Expect(1, 10224, '\P{miscmathsymbolsa}', "");
    Expect(0, 10224, '\P{^miscmathsymbolsa}', "");
    Expect(1, 10223, '\p{	Misc_Math_Symbols_A}', "");
    Expect(0, 10223, '\p{^	Misc_Math_Symbols_A}', "");
    Expect(0, 10223, '\P{	Misc_Math_Symbols_A}', "");
    Expect(1, 10223, '\P{^	Misc_Math_Symbols_A}', "");
    Expect(0, 10224, '\p{	Misc_Math_Symbols_A}', "");
    Expect(1, 10224, '\p{^	Misc_Math_Symbols_A}', "");
    Expect(1, 10224, '\P{	Misc_Math_Symbols_A}', "");
    Expect(0, 10224, '\P{^	Misc_Math_Symbols_A}', "");
    Error('\p{/a/IS_Misc_MATH_Symbols_A}');
    Error('\P{/a/IS_Misc_MATH_Symbols_A}');
    Expect(1, 10223, '\p{ismiscmathsymbolsa}', "");
    Expect(0, 10223, '\p{^ismiscmathsymbolsa}', "");
    Expect(0, 10223, '\P{ismiscmathsymbolsa}', "");
    Expect(1, 10223, '\P{^ismiscmathsymbolsa}', "");
    Expect(0, 10224, '\p{ismiscmathsymbolsa}', "");
    Expect(1, 10224, '\p{^ismiscmathsymbolsa}', "");
    Expect(1, 10224, '\P{ismiscmathsymbolsa}', "");
    Expect(0, 10224, '\P{^ismiscmathsymbolsa}', "");
    Expect(1, 10223, '\p{- Is_Misc_math_symbols_A}', "");
    Expect(0, 10223, '\p{^- Is_Misc_math_symbols_A}', "");
    Expect(0, 10223, '\P{- Is_Misc_math_symbols_A}', "");
    Expect(1, 10223, '\P{^- Is_Misc_math_symbols_A}', "");
    Expect(0, 10224, '\p{- Is_Misc_math_symbols_A}', "");
    Expect(1, 10224, '\p{^- Is_Misc_math_symbols_A}', "");
    Expect(1, 10224, '\P{- Is_Misc_math_symbols_A}', "");
    Expect(0, 10224, '\P{^- Is_Misc_math_symbols_A}', "");
    Error('\p{	_in_Misc_math_Symbols_a:=}');
    Error('\P{	_in_Misc_math_Symbols_a:=}');
    Expect(1, 10223, '\p{inmiscmathsymbolsa}', "");
    Expect(0, 10223, '\p{^inmiscmathsymbolsa}', "");
    Expect(0, 10223, '\P{inmiscmathsymbolsa}', "");
    Expect(1, 10223, '\P{^inmiscmathsymbolsa}', "");
    Expect(0, 10224, '\p{inmiscmathsymbolsa}', "");
    Expect(1, 10224, '\p{^inmiscmathsymbolsa}', "");
    Expect(1, 10224, '\P{inmiscmathsymbolsa}', "");
    Expect(0, 10224, '\P{^inmiscmathsymbolsa}', "");
    Expect(1, 10223, '\p{in_Misc_Math_Symbols_a}', "");
    Expect(0, 10223, '\p{^in_Misc_Math_Symbols_a}', "");
    Expect(0, 10223, '\P{in_Misc_Math_Symbols_a}', "");
    Expect(1, 10223, '\P{^in_Misc_Math_Symbols_a}', "");
    Expect(0, 10224, '\p{in_Misc_Math_Symbols_a}', "");
    Expect(1, 10224, '\p{^in_Misc_Math_Symbols_a}', "");
    Expect(1, 10224, '\P{in_Misc_Math_Symbols_a}', "");
    Expect(0, 10224, '\P{^in_Misc_Math_Symbols_a}', "");
    Error('\p{:= 	miscellaneous_MATHEMATICAL_Symbols_B}');
    Error('\P{:= 	miscellaneous_MATHEMATICAL_Symbols_B}');
    Expect(1, 10751, '\p{miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\p{^miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\P{miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\P{^miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\p{miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\p{^miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\P{miscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\P{^miscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\p{	Miscellaneous_Mathematical_Symbols_B}', "");
    Expect(0, 10751, '\p{^	Miscellaneous_Mathematical_Symbols_B}', "");
    Expect(0, 10751, '\P{	Miscellaneous_Mathematical_Symbols_B}', "");
    Expect(1, 10751, '\P{^	Miscellaneous_Mathematical_Symbols_B}', "");
    Expect(0, 10752, '\p{	Miscellaneous_Mathematical_Symbols_B}', "");
    Expect(1, 10752, '\p{^	Miscellaneous_Mathematical_Symbols_B}', "");
    Expect(1, 10752, '\P{	Miscellaneous_Mathematical_Symbols_B}', "");
    Expect(0, 10752, '\P{^	Miscellaneous_Mathematical_Symbols_B}', "");
    Error('\p{-/a/IS_Miscellaneous_mathematical_Symbols_b}');
    Error('\P{-/a/IS_Miscellaneous_mathematical_Symbols_b}');
    Expect(1, 10751, '\p{ismiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\p{^ismiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\P{ismiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\P{^ismiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\p{ismiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\p{^ismiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\P{ismiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\P{^ismiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\p{_Is_miscellaneous_MATHEMATICAL_Symbols_B}', "");
    Expect(0, 10751, '\p{^_Is_miscellaneous_MATHEMATICAL_Symbols_B}', "");
    Expect(0, 10751, '\P{_Is_miscellaneous_MATHEMATICAL_Symbols_B}', "");
    Expect(1, 10751, '\P{^_Is_miscellaneous_MATHEMATICAL_Symbols_B}', "");
    Expect(0, 10752, '\p{_Is_miscellaneous_MATHEMATICAL_Symbols_B}', "");
    Expect(1, 10752, '\p{^_Is_miscellaneous_MATHEMATICAL_Symbols_B}', "");
    Expect(1, 10752, '\P{_Is_miscellaneous_MATHEMATICAL_Symbols_B}', "");
    Expect(0, 10752, '\P{^_Is_miscellaneous_MATHEMATICAL_Symbols_B}', "");
    Error('\p{:=-in_Miscellaneous_Mathematical_Symbols_b}');
    Error('\P{:=-in_Miscellaneous_Mathematical_Symbols_b}');
    Expect(1, 10751, '\p{inmiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\p{^inmiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10751, '\P{inmiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\P{^inmiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\p{inmiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\p{^inmiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10752, '\P{inmiscellaneousmathematicalsymbolsb}', "");
    Expect(0, 10752, '\P{^inmiscellaneousmathematicalsymbolsb}', "");
    Expect(1, 10751, '\p{	-IN_miscellaneous_Mathematical_symbols_b}', "");
    Expect(0, 10751, '\p{^	-IN_miscellaneous_Mathematical_symbols_b}', "");
    Expect(0, 10751, '\P{	-IN_miscellaneous_Mathematical_symbols_b}', "");
    Expect(1, 10751, '\P{^	-IN_miscellaneous_Mathematical_symbols_b}', "");
    Expect(0, 10752, '\p{	-IN_miscellaneous_Mathematical_symbols_b}', "");
    Expect(1, 10752, '\p{^	-IN_miscellaneous_Mathematical_symbols_b}', "");
    Expect(1, 10752, '\P{	-IN_miscellaneous_Mathematical_symbols_b}', "");
    Expect(0, 10752, '\P{^	-IN_miscellaneous_Mathematical_symbols_b}', "");
    Error('\p{/a/misc_math_SYMBOLS_b}');
    Error('\P{/a/misc_math_SYMBOLS_b}');
    Expect(1, 10751, '\p{miscmathsymbolsb}', "");
    Expect(0, 10751, '\p{^miscmathsymbolsb}', "");
    Expect(0, 10751, '\P{miscmathsymbolsb}', "");
    Expect(1, 10751, '\P{^miscmathsymbolsb}', "");
    Expect(0, 10752, '\p{miscmathsymbolsb}', "");
    Expect(1, 10752, '\p{^miscmathsymbolsb}', "");
    Expect(1, 10752, '\P{miscmathsymbolsb}', "");
    Expect(0, 10752, '\P{^miscmathsymbolsb}', "");
    Expect(1, 10751, '\p{ 	Misc_math_symbols_b}', "");
    Expect(0, 10751, '\p{^ 	Misc_math_symbols_b}', "");
    Expect(0, 10751, '\P{ 	Misc_math_symbols_b}', "");
    Expect(1, 10751, '\P{^ 	Misc_math_symbols_b}', "");
    Expect(0, 10752, '\p{ 	Misc_math_symbols_b}', "");
    Expect(1, 10752, '\p{^ 	Misc_math_symbols_b}', "");
    Expect(1, 10752, '\P{ 	Misc_math_symbols_b}', "");
    Expect(0, 10752, '\P{^ 	Misc_math_symbols_b}', "");
    Error('\p{ -Is_Misc_math_Symbols_b:=}');
    Error('\P{ -Is_Misc_math_Symbols_b:=}');
    Expect(1, 10751, '\p{ismiscmathsymbolsb}', "");
    Expect(0, 10751, '\p{^ismiscmathsymbolsb}', "");
    Expect(0, 10751, '\P{ismiscmathsymbolsb}', "");
    Expect(1, 10751, '\P{^ismiscmathsymbolsb}', "");
    Expect(0, 10752, '\p{ismiscmathsymbolsb}', "");
    Expect(1, 10752, '\p{^ismiscmathsymbolsb}', "");
    Expect(1, 10752, '\P{ismiscmathsymbolsb}', "");
    Expect(0, 10752, '\P{^ismiscmathsymbolsb}', "");
    Expect(1, 10751, '\p{	Is_misc_Math_SYMBOLS_B}', "");
    Expect(0, 10751, '\p{^	Is_misc_Math_SYMBOLS_B}', "");
    Expect(0, 10751, '\P{	Is_misc_Math_SYMBOLS_B}', "");
    Expect(1, 10751, '\P{^	Is_misc_Math_SYMBOLS_B}', "");
    Expect(0, 10752, '\p{	Is_misc_Math_SYMBOLS_B}', "");
    Expect(1, 10752, '\p{^	Is_misc_Math_SYMBOLS_B}', "");
    Expect(1, 10752, '\P{	Is_misc_Math_SYMBOLS_B}', "");
    Expect(0, 10752, '\P{^	Is_misc_Math_SYMBOLS_B}', "");
    Error('\p{_In_Misc_Math_Symbols_B/a/}');
    Error('\P{_In_Misc_Math_Symbols_B/a/}');
    Expect(1, 10751, '\p{inmiscmathsymbolsb}', "");
    Expect(0, 10751, '\p{^inmiscmathsymbolsb}', "");
    Expect(0, 10751, '\P{inmiscmathsymbolsb}', "");
    Expect(1, 10751, '\P{^inmiscmathsymbolsb}', "");
    Expect(0, 10752, '\p{inmiscmathsymbolsb}', "");
    Expect(1, 10752, '\p{^inmiscmathsymbolsb}', "");
    Expect(1, 10752, '\P{inmiscmathsymbolsb}', "");
    Expect(0, 10752, '\P{^inmiscmathsymbolsb}', "");
    Expect(1, 10751, '\p{- In_Misc_Math_SYMBOLS_b}', "");
    Expect(0, 10751, '\p{^- In_Misc_Math_SYMBOLS_b}', "");
    Expect(0, 10751, '\P{- In_Misc_Math_SYMBOLS_b}', "");
    Expect(1, 10751, '\P{^- In_Misc_Math_SYMBOLS_b}', "");
    Expect(0, 10752, '\p{- In_Misc_Math_SYMBOLS_b}', "");
    Expect(1, 10752, '\p{^- In_Misc_Math_SYMBOLS_b}', "");
    Expect(1, 10752, '\P{- In_Misc_Math_SYMBOLS_b}', "");
    Expect(0, 10752, '\P{^- In_Misc_Math_SYMBOLS_b}', "");
    Error('\p{-:=miscellaneous_SYMBOLS}');
    Error('\P{-:=miscellaneous_SYMBOLS}');
    Expect(1, 9983, '\p{miscellaneoussymbols}', "");
    Expect(0, 9983, '\p{^miscellaneoussymbols}', "");
    Expect(0, 9983, '\P{miscellaneoussymbols}', "");
    Expect(1, 9983, '\P{^miscellaneoussymbols}', "");
    Expect(0, 9984, '\p{miscellaneoussymbols}', "");
    Expect(1, 9984, '\p{^miscellaneoussymbols}', "");
    Expect(1, 9984, '\P{miscellaneoussymbols}', "");
    Expect(0, 9984, '\P{^miscellaneoussymbols}', "");
    Expect(1, 9983, '\p{_ MISCELLANEOUS_Symbols}', "");
    Expect(0, 9983, '\p{^_ MISCELLANEOUS_Symbols}', "");
    Expect(0, 9983, '\P{_ MISCELLANEOUS_Symbols}', "");
    Expect(1, 9983, '\P{^_ MISCELLANEOUS_Symbols}', "");
    Expect(0, 9984, '\p{_ MISCELLANEOUS_Symbols}', "");
    Expect(1, 9984, '\p{^_ MISCELLANEOUS_Symbols}', "");
    Expect(1, 9984, '\P{_ MISCELLANEOUS_Symbols}', "");
    Expect(0, 9984, '\P{^_ MISCELLANEOUS_Symbols}', "");
    Error('\p{/a/_Is_Miscellaneous_SYMBOLS}');
    Error('\P{/a/_Is_Miscellaneous_SYMBOLS}');
    Expect(1, 9983, '\p{ismiscellaneoussymbols}', "");
    Expect(0, 9983, '\p{^ismiscellaneoussymbols}', "");
    Expect(0, 9983, '\P{ismiscellaneoussymbols}', "");
    Expect(1, 9983, '\P{^ismiscellaneoussymbols}', "");
    Expect(0, 9984, '\p{ismiscellaneoussymbols}', "");
    Expect(1, 9984, '\p{^ismiscellaneoussymbols}', "");
    Expect(1, 9984, '\P{ismiscellaneoussymbols}', "");
    Expect(0, 9984, '\P{^ismiscellaneoussymbols}', "");
    Expect(1, 9983, '\p{ -Is_MISCELLANEOUS_Symbols}', "");
    Expect(0, 9983, '\p{^ -Is_MISCELLANEOUS_Symbols}', "");
    Expect(0, 9983, '\P{ -Is_MISCELLANEOUS_Symbols}', "");
    Expect(1, 9983, '\P{^ -Is_MISCELLANEOUS_Symbols}', "");
    Expect(0, 9984, '\p{ -Is_MISCELLANEOUS_Symbols}', "");
    Expect(1, 9984, '\p{^ -Is_MISCELLANEOUS_Symbols}', "");
    Expect(1, 9984, '\P{ -Is_MISCELLANEOUS_Symbols}', "");
    Expect(0, 9984, '\P{^ -Is_MISCELLANEOUS_Symbols}', "");
    Error('\p{:=	In_Miscellaneous_SYMBOLS}');
    Error('\P{:=	In_Miscellaneous_SYMBOLS}');
    Expect(1, 9983, '\p{inmiscellaneoussymbols}', "");
    Expect(0, 9983, '\p{^inmiscellaneoussymbols}', "");
    Expect(0, 9983, '\P{inmiscellaneoussymbols}', "");
    Expect(1, 9983, '\P{^inmiscellaneoussymbols}', "");
    Expect(0, 9984, '\p{inmiscellaneoussymbols}', "");
    Expect(1, 9984, '\p{^inmiscellaneoussymbols}', "");
    Expect(1, 9984, '\P{inmiscellaneoussymbols}', "");
    Expect(0, 9984, '\P{^inmiscellaneoussymbols}', "");
    Expect(1, 9983, '\p{	 In_Miscellaneous_Symbols}', "");
    Expect(0, 9983, '\p{^	 In_Miscellaneous_Symbols}', "");
    Expect(0, 9983, '\P{	 In_Miscellaneous_Symbols}', "");
    Expect(1, 9983, '\P{^	 In_Miscellaneous_Symbols}', "");
    Expect(0, 9984, '\p{	 In_Miscellaneous_Symbols}', "");
    Expect(1, 9984, '\p{^	 In_Miscellaneous_Symbols}', "");
    Expect(1, 9984, '\P{	 In_Miscellaneous_Symbols}', "");
    Expect(0, 9984, '\P{^	 In_Miscellaneous_Symbols}', "");
    Error('\p{	:=Misc_Symbols}');
    Error('\P{	:=Misc_Symbols}');
    Expect(1, 9983, '\p{miscsymbols}', "");
    Expect(0, 9983, '\p{^miscsymbols}', "");
    Expect(0, 9983, '\P{miscsymbols}', "");
    Expect(1, 9983, '\P{^miscsymbols}', "");
    Expect(0, 9984, '\p{miscsymbols}', "");
    Expect(1, 9984, '\p{^miscsymbols}', "");
    Expect(1, 9984, '\P{miscsymbols}', "");
    Expect(0, 9984, '\P{^miscsymbols}', "");
    Expect(1, 9983, '\p{	-misc_Symbols}', "");
    Expect(0, 9983, '\p{^	-misc_Symbols}', "");
    Expect(0, 9983, '\P{	-misc_Symbols}', "");
    Expect(1, 9983, '\P{^	-misc_Symbols}', "");
    Expect(0, 9984, '\p{	-misc_Symbols}', "");
    Expect(1, 9984, '\p{^	-misc_Symbols}', "");
    Expect(1, 9984, '\P{	-misc_Symbols}', "");
    Expect(0, 9984, '\P{^	-misc_Symbols}', "");
    Error('\p{:=-Is_MISC_symbols}');
    Error('\P{:=-Is_MISC_symbols}');
    Expect(1, 9983, '\p{ismiscsymbols}', "");
    Expect(0, 9983, '\p{^ismiscsymbols}', "");
    Expect(0, 9983, '\P{ismiscsymbols}', "");
    Expect(1, 9983, '\P{^ismiscsymbols}', "");
    Expect(0, 9984, '\p{ismiscsymbols}', "");
    Expect(1, 9984, '\p{^ismiscsymbols}', "");
    Expect(1, 9984, '\P{ismiscsymbols}', "");
    Expect(0, 9984, '\P{^ismiscsymbols}', "");
    Expect(1, 9983, '\p{	Is_misc_SYMBOLS}', "");
    Expect(0, 9983, '\p{^	Is_misc_SYMBOLS}', "");
    Expect(0, 9983, '\P{	Is_misc_SYMBOLS}', "");
    Expect(1, 9983, '\P{^	Is_misc_SYMBOLS}', "");
    Expect(0, 9984, '\p{	Is_misc_SYMBOLS}', "");
    Expect(1, 9984, '\p{^	Is_misc_SYMBOLS}', "");
    Expect(1, 9984, '\P{	Is_misc_SYMBOLS}', "");
    Expect(0, 9984, '\P{^	Is_misc_SYMBOLS}', "");
    Error('\p{	_IN_Misc_Symbols:=}');
    Error('\P{	_IN_Misc_Symbols:=}');
    Expect(1, 9983, '\p{inmiscsymbols}', "");
    Expect(0, 9983, '\p{^inmiscsymbols}', "");
    Expect(0, 9983, '\P{inmiscsymbols}', "");
    Expect(1, 9983, '\P{^inmiscsymbols}', "");
    Expect(0, 9984, '\p{inmiscsymbols}', "");
    Expect(1, 9984, '\p{^inmiscsymbols}', "");
    Expect(1, 9984, '\P{inmiscsymbols}', "");
    Expect(0, 9984, '\P{^inmiscsymbols}', "");
    Expect(1, 9983, '\p{  IN_Misc_SYMBOLS}', "");
    Expect(0, 9983, '\p{^  IN_Misc_SYMBOLS}', "");
    Expect(0, 9983, '\P{  IN_Misc_SYMBOLS}', "");
    Expect(1, 9983, '\P{^  IN_Misc_SYMBOLS}', "");
    Expect(0, 9984, '\p{  IN_Misc_SYMBOLS}', "");
    Expect(1, 9984, '\p{^  IN_Misc_SYMBOLS}', "");
    Expect(1, 9984, '\P{  IN_Misc_SYMBOLS}', "");
    Expect(0, 9984, '\P{^  IN_Misc_SYMBOLS}', "");
    Error('\p{ :=Miscellaneous_Symbols_And_Arrows}');
    Error('\P{ :=Miscellaneous_Symbols_And_Arrows}');
    Expect(1, 11263, '\p{miscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\p{^miscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\P{miscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\P{^miscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\p{miscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\p{^miscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\P{miscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\P{^miscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\p{ MISCELLANEOUS_symbols_And_ARROWS}', "");
    Expect(0, 11263, '\p{^ MISCELLANEOUS_symbols_And_ARROWS}', "");
    Expect(0, 11263, '\P{ MISCELLANEOUS_symbols_And_ARROWS}', "");
    Expect(1, 11263, '\P{^ MISCELLANEOUS_symbols_And_ARROWS}', "");
    Expect(0, 11264, '\p{ MISCELLANEOUS_symbols_And_ARROWS}', "");
    Expect(1, 11264, '\p{^ MISCELLANEOUS_symbols_And_ARROWS}', "");
    Expect(1, 11264, '\P{ MISCELLANEOUS_symbols_And_ARROWS}', "");
    Expect(0, 11264, '\P{^ MISCELLANEOUS_symbols_And_ARROWS}', "");
    Error('\p{ /a/Is_MISCELLANEOUS_symbols_AND_ARROWS}');
    Error('\P{ /a/Is_MISCELLANEOUS_symbols_AND_ARROWS}');
    Expect(1, 11263, '\p{ismiscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\p{^ismiscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\P{ismiscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\P{^ismiscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\p{ismiscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\p{^ismiscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\P{ismiscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\P{^ismiscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\p{-_Is_Miscellaneous_symbols_And_ARROWS}', "");
    Expect(0, 11263, '\p{^-_Is_Miscellaneous_symbols_And_ARROWS}', "");
    Expect(0, 11263, '\P{-_Is_Miscellaneous_symbols_And_ARROWS}', "");
    Expect(1, 11263, '\P{^-_Is_Miscellaneous_symbols_And_ARROWS}', "");
    Expect(0, 11264, '\p{-_Is_Miscellaneous_symbols_And_ARROWS}', "");
    Expect(1, 11264, '\p{^-_Is_Miscellaneous_symbols_And_ARROWS}', "");
    Expect(1, 11264, '\P{-_Is_Miscellaneous_symbols_And_ARROWS}', "");
    Expect(0, 11264, '\P{^-_Is_Miscellaneous_symbols_And_ARROWS}', "");
    Error('\p{/a/In_MISCELLANEOUS_Symbols_and_Arrows}');
    Error('\P{/a/In_MISCELLANEOUS_Symbols_and_Arrows}');
    Expect(1, 11263, '\p{inmiscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\p{^inmiscellaneoussymbolsandarrows}', "");
    Expect(0, 11263, '\P{inmiscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\P{^inmiscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\p{inmiscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\p{^inmiscellaneoussymbolsandarrows}', "");
    Expect(1, 11264, '\P{inmiscellaneoussymbolsandarrows}', "");
    Expect(0, 11264, '\P{^inmiscellaneoussymbolsandarrows}', "");
    Expect(1, 11263, '\p{  In_miscellaneous_Symbols_And_Arrows}', "");
    Expect(0, 11263, '\p{^  In_miscellaneous_Symbols_And_Arrows}', "");
    Expect(0, 11263, '\P{  In_miscellaneous_Symbols_And_Arrows}', "");
    Expect(1, 11263, '\P{^  In_miscellaneous_Symbols_And_Arrows}', "");
    Expect(0, 11264, '\p{  In_miscellaneous_Symbols_And_Arrows}', "");
    Expect(1, 11264, '\p{^  In_miscellaneous_Symbols_And_Arrows}', "");
    Expect(1, 11264, '\P{  In_miscellaneous_Symbols_And_Arrows}', "");
    Expect(0, 11264, '\P{^  In_miscellaneous_Symbols_And_Arrows}', "");
    Error('\p{_	Misc_Arrows/a/}');
    Error('\P{_	Misc_Arrows/a/}');
    Expect(1, 11263, '\p{miscarrows}', "");
    Expect(0, 11263, '\p{^miscarrows}', "");
    Expect(0, 11263, '\P{miscarrows}', "");
    Expect(1, 11263, '\P{^miscarrows}', "");
    Expect(0, 11264, '\p{miscarrows}', "");
    Expect(1, 11264, '\p{^miscarrows}', "");
    Expect(1, 11264, '\P{miscarrows}', "");
    Expect(0, 11264, '\P{^miscarrows}', "");
    Expect(1, 11263, '\p{-_misc_arrows}', "");
    Expect(0, 11263, '\p{^-_misc_arrows}', "");
    Expect(0, 11263, '\P{-_misc_arrows}', "");
    Expect(1, 11263, '\P{^-_misc_arrows}', "");
    Expect(0, 11264, '\p{-_misc_arrows}', "");
    Expect(1, 11264, '\p{^-_misc_arrows}', "");
    Expect(1, 11264, '\P{-_misc_arrows}', "");
    Expect(0, 11264, '\P{^-_misc_arrows}', "");
    Error('\p{	_IS_Misc_Arrows/a/}');
    Error('\P{	_IS_Misc_Arrows/a/}');
    Expect(1, 11263, '\p{ismiscarrows}', "");
    Expect(0, 11263, '\p{^ismiscarrows}', "");
    Expect(0, 11263, '\P{ismiscarrows}', "");
    Expect(1, 11263, '\P{^ismiscarrows}', "");
    Expect(0, 11264, '\p{ismiscarrows}', "");
    Expect(1, 11264, '\p{^ismiscarrows}', "");
    Expect(1, 11264, '\P{ismiscarrows}', "");
    Expect(0, 11264, '\P{^ismiscarrows}', "");
    Expect(1, 11263, '\p{	IS_MISC_Arrows}', "");
    Expect(0, 11263, '\p{^	IS_MISC_Arrows}', "");
    Expect(0, 11263, '\P{	IS_MISC_Arrows}', "");
    Expect(1, 11263, '\P{^	IS_MISC_Arrows}', "");
    Expect(0, 11264, '\p{	IS_MISC_Arrows}', "");
    Expect(1, 11264, '\p{^	IS_MISC_Arrows}', "");
    Expect(1, 11264, '\P{	IS_MISC_Arrows}', "");
    Expect(0, 11264, '\P{^	IS_MISC_Arrows}', "");
    Error('\p{ /a/In_MISC_arrows}');
    Error('\P{ /a/In_MISC_arrows}');
    Expect(1, 11263, '\p{inmiscarrows}', "");
    Expect(0, 11263, '\p{^inmiscarrows}', "");
    Expect(0, 11263, '\P{inmiscarrows}', "");
    Expect(1, 11263, '\P{^inmiscarrows}', "");
    Expect(0, 11264, '\p{inmiscarrows}', "");
    Expect(1, 11264, '\p{^inmiscarrows}', "");
    Expect(1, 11264, '\P{inmiscarrows}', "");
    Expect(0, 11264, '\P{^inmiscarrows}', "");
    Expect(1, 11263, '\p{ _In_Misc_ARROWS}', "");
    Expect(0, 11263, '\p{^ _In_Misc_ARROWS}', "");
    Expect(0, 11263, '\P{ _In_Misc_ARROWS}', "");
    Expect(1, 11263, '\P{^ _In_Misc_ARROWS}', "");
    Expect(0, 11264, '\p{ _In_Misc_ARROWS}', "");
    Expect(1, 11264, '\p{^ _In_Misc_ARROWS}', "");
    Expect(1, 11264, '\P{ _In_Misc_ARROWS}', "");
    Expect(0, 11264, '\P{^ _In_Misc_ARROWS}', "");
    Error('\p{:=	 Miscellaneous_Symbols_and_pictographs}');
    Error('\P{:=	 Miscellaneous_Symbols_and_pictographs}');
    Expect(1, 128511, '\p{miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\p{^miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\P{miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\P{^miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\p{miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\p{^miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\P{miscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\P{^miscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\p{_	Miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 128511, '\p{^_	Miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 128511, '\P{_	Miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(1, 128511, '\P{^_	Miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 128512, '\p{_	Miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(1, 128512, '\p{^_	Miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(1, 128512, '\P{_	Miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 128512, '\P{^_	Miscellaneous_Symbols_And_PICTOGRAPHS}', "");
    Error('\p{:=_-Is_MISCELLANEOUS_Symbols_AND_Pictographs}');
    Error('\P{:=_-Is_MISCELLANEOUS_Symbols_AND_Pictographs}');
    Expect(1, 128511, '\p{ismiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\p{^ismiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\P{ismiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\P{^ismiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\p{ismiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\p{^ismiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\P{ismiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\P{^ismiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\p{- Is_Miscellaneous_symbols_AND_pictographs}', "");
    Expect(0, 128511, '\p{^- Is_Miscellaneous_symbols_AND_pictographs}', "");
    Expect(0, 128511, '\P{- Is_Miscellaneous_symbols_AND_pictographs}', "");
    Expect(1, 128511, '\P{^- Is_Miscellaneous_symbols_AND_pictographs}', "");
    Expect(0, 128512, '\p{- Is_Miscellaneous_symbols_AND_pictographs}', "");
    Expect(1, 128512, '\p{^- Is_Miscellaneous_symbols_AND_pictographs}', "");
    Expect(1, 128512, '\P{- Is_Miscellaneous_symbols_AND_pictographs}', "");
    Expect(0, 128512, '\P{^- Is_Miscellaneous_symbols_AND_pictographs}', "");
    Error('\p{ -In_Miscellaneous_SYMBOLS_And_Pictographs/a/}');
    Error('\P{ -In_Miscellaneous_SYMBOLS_And_Pictographs/a/}');
    Expect(1, 128511, '\p{inmiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\p{^inmiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128511, '\P{inmiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\P{^inmiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\p{inmiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\p{^inmiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128512, '\P{inmiscellaneoussymbolsandpictographs}', "");
    Expect(0, 128512, '\P{^inmiscellaneoussymbolsandpictographs}', "");
    Expect(1, 128511, '\p{__In_MISCELLANEOUS_SYMBOLS_and_Pictographs}', "");
    Expect(0, 128511, '\p{^__In_MISCELLANEOUS_SYMBOLS_and_Pictographs}', "");
    Expect(0, 128511, '\P{__In_MISCELLANEOUS_SYMBOLS_and_Pictographs}', "");
    Expect(1, 128511, '\P{^__In_MISCELLANEOUS_SYMBOLS_and_Pictographs}', "");
    Expect(0, 128512, '\p{__In_MISCELLANEOUS_SYMBOLS_and_Pictographs}', "");
    Expect(1, 128512, '\p{^__In_MISCELLANEOUS_SYMBOLS_and_Pictographs}', "");
    Expect(1, 128512, '\P{__In_MISCELLANEOUS_SYMBOLS_and_Pictographs}', "");
    Expect(0, 128512, '\P{^__In_MISCELLANEOUS_SYMBOLS_and_Pictographs}', "");
    Error('\p{ _Misc_Pictographs:=}');
    Error('\P{ _Misc_Pictographs:=}');
    Expect(1, 128511, '\p{miscpictographs}', "");
    Expect(0, 128511, '\p{^miscpictographs}', "");
    Expect(0, 128511, '\P{miscpictographs}', "");
    Expect(1, 128511, '\P{^miscpictographs}', "");
    Expect(0, 128512, '\p{miscpictographs}', "");
    Expect(1, 128512, '\p{^miscpictographs}', "");
    Expect(1, 128512, '\P{miscpictographs}', "");
    Expect(0, 128512, '\P{^miscpictographs}', "");
    Expect(1, 128511, '\p{_ Misc_Pictographs}', "");
    Expect(0, 128511, '\p{^_ Misc_Pictographs}', "");
    Expect(0, 128511, '\P{_ Misc_Pictographs}', "");
    Expect(1, 128511, '\P{^_ Misc_Pictographs}', "");
    Expect(0, 128512, '\p{_ Misc_Pictographs}', "");
    Expect(1, 128512, '\p{^_ Misc_Pictographs}', "");
    Expect(1, 128512, '\P{_ Misc_Pictographs}', "");
    Expect(0, 128512, '\P{^_ Misc_Pictographs}', "");
    Error('\p{/a/IS_Misc_Pictographs}');
    Error('\P{/a/IS_Misc_Pictographs}');
    Expect(1, 128511, '\p{ismiscpictographs}', "");
    Expect(0, 128511, '\p{^ismiscpictographs}', "");
    Expect(0, 128511, '\P{ismiscpictographs}', "");
    Expect(1, 128511, '\P{^ismiscpictographs}', "");
    Expect(0, 128512, '\p{ismiscpictographs}', "");
    Expect(1, 128512, '\p{^ismiscpictographs}', "");
    Expect(1, 128512, '\P{ismiscpictographs}', "");
    Expect(0, 128512, '\P{^ismiscpictographs}', "");
    Expect(1, 128511, '\p{ -IS_MISC_pictographs}', "");
    Expect(0, 128511, '\p{^ -IS_MISC_pictographs}', "");
    Expect(0, 128511, '\P{ -IS_MISC_pictographs}', "");
    Expect(1, 128511, '\P{^ -IS_MISC_pictographs}', "");
    Expect(0, 128512, '\p{ -IS_MISC_pictographs}', "");
    Expect(1, 128512, '\p{^ -IS_MISC_pictographs}', "");
    Expect(1, 128512, '\P{ -IS_MISC_pictographs}', "");
    Expect(0, 128512, '\P{^ -IS_MISC_pictographs}', "");
    Error('\p{_In_Misc_Pictographs/a/}');
    Error('\P{_In_Misc_Pictographs/a/}');
    Expect(1, 128511, '\p{inmiscpictographs}', "");
    Expect(0, 128511, '\p{^inmiscpictographs}', "");
    Expect(0, 128511, '\P{inmiscpictographs}', "");
    Expect(1, 128511, '\P{^inmiscpictographs}', "");
    Expect(0, 128512, '\p{inmiscpictographs}', "");
    Expect(1, 128512, '\p{^inmiscpictographs}', "");
    Expect(1, 128512, '\P{inmiscpictographs}', "");
    Expect(0, 128512, '\P{^inmiscpictographs}', "");
    Expect(1, 128511, '\p{_-In_MISC_Pictographs}', "");
    Expect(0, 128511, '\p{^_-In_MISC_Pictographs}', "");
    Expect(0, 128511, '\P{_-In_MISC_Pictographs}', "");
    Expect(1, 128511, '\P{^_-In_MISC_Pictographs}', "");
    Expect(0, 128512, '\p{_-In_MISC_Pictographs}', "");
    Expect(1, 128512, '\p{^_-In_MISC_Pictographs}', "");
    Expect(1, 128512, '\P{_-In_MISC_Pictographs}', "");
    Expect(0, 128512, '\P{^_-In_MISC_Pictographs}', "");
    Error('\p{:=_Miscellaneous_technical}');
    Error('\P{:=_Miscellaneous_technical}');
    Expect(1, 9215, '\p{miscellaneoustechnical}', "");
    Expect(0, 9215, '\p{^miscellaneoustechnical}', "");
    Expect(0, 9215, '\P{miscellaneoustechnical}', "");
    Expect(1, 9215, '\P{^miscellaneoustechnical}', "");
    Expect(0, 9216, '\p{miscellaneoustechnical}', "");
    Expect(1, 9216, '\p{^miscellaneoustechnical}', "");
    Expect(1, 9216, '\P{miscellaneoustechnical}', "");
    Expect(0, 9216, '\P{^miscellaneoustechnical}', "");
    Expect(1, 9215, '\p{  miscellaneous_TECHNICAL}', "");
    Expect(0, 9215, '\p{^  miscellaneous_TECHNICAL}', "");
    Expect(0, 9215, '\P{  miscellaneous_TECHNICAL}', "");
    Expect(1, 9215, '\P{^  miscellaneous_TECHNICAL}', "");
    Expect(0, 9216, '\p{  miscellaneous_TECHNICAL}', "");
    Expect(1, 9216, '\p{^  miscellaneous_TECHNICAL}', "");
    Expect(1, 9216, '\P{  miscellaneous_TECHNICAL}', "");
    Expect(0, 9216, '\P{^  miscellaneous_TECHNICAL}', "");
    Error('\p{-/a/is_MISCELLANEOUS_technical}');
    Error('\P{-/a/is_MISCELLANEOUS_technical}');
    Expect(1, 9215, '\p{ismiscellaneoustechnical}', "");
    Expect(0, 9215, '\p{^ismiscellaneoustechnical}', "");
    Expect(0, 9215, '\P{ismiscellaneoustechnical}', "");
    Expect(1, 9215, '\P{^ismiscellaneoustechnical}', "");
    Expect(0, 9216, '\p{ismiscellaneoustechnical}', "");
    Expect(1, 9216, '\p{^ismiscellaneoustechnical}', "");
    Expect(1, 9216, '\P{ismiscellaneoustechnical}', "");
    Expect(0, 9216, '\P{^ismiscellaneoustechnical}', "");
    Expect(1, 9215, '\p{	-IS_Miscellaneous_Technical}', "");
    Expect(0, 9215, '\p{^	-IS_Miscellaneous_Technical}', "");
    Expect(0, 9215, '\P{	-IS_Miscellaneous_Technical}', "");
    Expect(1, 9215, '\P{^	-IS_Miscellaneous_Technical}', "");
    Expect(0, 9216, '\p{	-IS_Miscellaneous_Technical}', "");
    Expect(1, 9216, '\p{^	-IS_Miscellaneous_Technical}', "");
    Expect(1, 9216, '\P{	-IS_Miscellaneous_Technical}', "");
    Expect(0, 9216, '\P{^	-IS_Miscellaneous_Technical}', "");
    Error('\p{:=-In_miscellaneous_technical}');
    Error('\P{:=-In_miscellaneous_technical}');
    Expect(1, 9215, '\p{inmiscellaneoustechnical}', "");
    Expect(0, 9215, '\p{^inmiscellaneoustechnical}', "");
    Expect(0, 9215, '\P{inmiscellaneoustechnical}', "");
    Expect(1, 9215, '\P{^inmiscellaneoustechnical}', "");
    Expect(0, 9216, '\p{inmiscellaneoustechnical}', "");
    Expect(1, 9216, '\p{^inmiscellaneoustechnical}', "");
    Expect(1, 9216, '\P{inmiscellaneoustechnical}', "");
    Expect(0, 9216, '\P{^inmiscellaneoustechnical}', "");
    Expect(1, 9215, '\p{_ In_Miscellaneous_TECHNICAL}', "");
    Expect(0, 9215, '\p{^_ In_Miscellaneous_TECHNICAL}', "");
    Expect(0, 9215, '\P{_ In_Miscellaneous_TECHNICAL}', "");
    Expect(1, 9215, '\P{^_ In_Miscellaneous_TECHNICAL}', "");
    Expect(0, 9216, '\p{_ In_Miscellaneous_TECHNICAL}', "");
    Expect(1, 9216, '\p{^_ In_Miscellaneous_TECHNICAL}', "");
    Expect(1, 9216, '\P{_ In_Miscellaneous_TECHNICAL}', "");
    Expect(0, 9216, '\P{^_ In_Miscellaneous_TECHNICAL}', "");
    Error('\p{/a/Misc_Technical}');
    Error('\P{/a/Misc_Technical}');
    Expect(1, 9215, '\p{misctechnical}', "");
    Expect(0, 9215, '\p{^misctechnical}', "");
    Expect(0, 9215, '\P{misctechnical}', "");
    Expect(1, 9215, '\P{^misctechnical}', "");
    Expect(0, 9216, '\p{misctechnical}', "");
    Expect(1, 9216, '\p{^misctechnical}', "");
    Expect(1, 9216, '\P{misctechnical}', "");
    Expect(0, 9216, '\P{^misctechnical}', "");
    Expect(1, 9215, '\p{ 	misc_Technical}', "");
    Expect(0, 9215, '\p{^ 	misc_Technical}', "");
    Expect(0, 9215, '\P{ 	misc_Technical}', "");
    Expect(1, 9215, '\P{^ 	misc_Technical}', "");
    Expect(0, 9216, '\p{ 	misc_Technical}', "");
    Expect(1, 9216, '\p{^ 	misc_Technical}', "");
    Expect(1, 9216, '\P{ 	misc_Technical}', "");
    Expect(0, 9216, '\P{^ 	misc_Technical}', "");
    Error('\p{	:=Is_Misc_TECHNICAL}');
    Error('\P{	:=Is_Misc_TECHNICAL}');
    Expect(1, 9215, '\p{ismisctechnical}', "");
    Expect(0, 9215, '\p{^ismisctechnical}', "");
    Expect(0, 9215, '\P{ismisctechnical}', "");
    Expect(1, 9215, '\P{^ismisctechnical}', "");
    Expect(0, 9216, '\p{ismisctechnical}', "");
    Expect(1, 9216, '\p{^ismisctechnical}', "");
    Expect(1, 9216, '\P{ismisctechnical}', "");
    Expect(0, 9216, '\P{^ismisctechnical}', "");
    Expect(1, 9215, '\p{_ Is_MISC_TECHNICAL}', "");
    Expect(0, 9215, '\p{^_ Is_MISC_TECHNICAL}', "");
    Expect(0, 9215, '\P{_ Is_MISC_TECHNICAL}', "");
    Expect(1, 9215, '\P{^_ Is_MISC_TECHNICAL}', "");
    Expect(0, 9216, '\p{_ Is_MISC_TECHNICAL}', "");
    Expect(1, 9216, '\p{^_ Is_MISC_TECHNICAL}', "");
    Expect(1, 9216, '\P{_ Is_MISC_TECHNICAL}', "");
    Expect(0, 9216, '\P{^_ Is_MISC_TECHNICAL}', "");
    Error('\p{-/a/in_Misc_technical}');
    Error('\P{-/a/in_Misc_technical}');
    Expect(1, 9215, '\p{inmisctechnical}', "");
    Expect(0, 9215, '\p{^inmisctechnical}', "");
    Expect(0, 9215, '\P{inmisctechnical}', "");
    Expect(1, 9215, '\P{^inmisctechnical}', "");
    Expect(0, 9216, '\p{inmisctechnical}', "");
    Expect(1, 9216, '\p{^inmisctechnical}', "");
    Expect(1, 9216, '\P{inmisctechnical}', "");
    Expect(0, 9216, '\P{^inmisctechnical}', "");
    Expect(1, 9215, '\p{-in_Misc_TECHNICAL}', "");
    Expect(0, 9215, '\p{^-in_Misc_TECHNICAL}', "");
    Expect(0, 9215, '\P{-in_Misc_TECHNICAL}', "");
    Expect(1, 9215, '\P{^-in_Misc_TECHNICAL}', "");
    Expect(0, 9216, '\p{-in_Misc_TECHNICAL}', "");
    Expect(1, 9216, '\p{^-in_Misc_TECHNICAL}', "");
    Expect(1, 9216, '\P{-in_Misc_TECHNICAL}', "");
    Expect(0, 9216, '\P{^-in_Misc_TECHNICAL}', "");
    Error('\p{:=-	Modi}');
    Error('\P{:=-	Modi}');
    Expect(1, 71257, '\p{modi}', "");
    Expect(0, 71257, '\p{^modi}', "");
    Expect(0, 71257, '\P{modi}', "");
    Expect(1, 71257, '\P{^modi}', "");
    Expect(0, 71258, '\p{modi}', "");
    Expect(1, 71258, '\p{^modi}', "");
    Expect(1, 71258, '\P{modi}', "");
    Expect(0, 71258, '\P{^modi}', "");
    Expect(1, 71257, '\p{	MODI}', "");
    Expect(0, 71257, '\p{^	MODI}', "");
    Expect(0, 71257, '\P{	MODI}', "");
    Expect(1, 71257, '\P{^	MODI}', "");
    Expect(0, 71258, '\p{	MODI}', "");
    Expect(1, 71258, '\p{^	MODI}', "");
    Expect(1, 71258, '\P{	MODI}', "");
    Expect(0, 71258, '\P{^	MODI}', "");
    Error('\p{:=		is_MODI}');
    Error('\P{:=		is_MODI}');
    Expect(1, 71257, '\p{ismodi}', "");
    Expect(0, 71257, '\p{^ismodi}', "");
    Expect(0, 71257, '\P{ismodi}', "");
    Expect(1, 71257, '\P{^ismodi}', "");
    Expect(0, 71258, '\p{ismodi}', "");
    Expect(1, 71258, '\p{^ismodi}', "");
    Expect(1, 71258, '\P{ismodi}', "");
    Expect(0, 71258, '\P{^ismodi}', "");
    Expect(1, 71257, '\p{ -is_Modi}', "");
    Expect(0, 71257, '\p{^ -is_Modi}', "");
    Expect(0, 71257, '\P{ -is_Modi}', "");
    Expect(1, 71257, '\P{^ -is_Modi}', "");
    Expect(0, 71258, '\p{ -is_Modi}', "");
    Expect(1, 71258, '\p{^ -is_Modi}', "");
    Expect(1, 71258, '\P{ -is_Modi}', "");
    Expect(0, 71258, '\P{^ -is_Modi}', "");
    Error('\p{-Modifier_letter/a/}');
    Error('\P{-Modifier_letter/a/}');
    Expect(1, 125259, '\p{modifierletter}', "");
    Expect(0, 125259, '\p{^modifierletter}', "");
    Expect(0, 125259, '\P{modifierletter}', "");
    Expect(1, 125259, '\P{^modifierletter}', "");
    Expect(0, 125260, '\p{modifierletter}', "");
    Expect(1, 125260, '\p{^modifierletter}', "");
    Expect(1, 125260, '\P{modifierletter}', "");
    Expect(0, 125260, '\P{^modifierletter}', "");
    Expect(1, 125259, '\p{-_modifier_letter}', "");
    Expect(0, 125259, '\p{^-_modifier_letter}', "");
    Expect(0, 125259, '\P{-_modifier_letter}', "");
    Expect(1, 125259, '\P{^-_modifier_letter}', "");
    Expect(0, 125260, '\p{-_modifier_letter}', "");
    Expect(1, 125260, '\p{^-_modifier_letter}', "");
    Expect(1, 125260, '\P{-_modifier_letter}', "");
    Expect(0, 125260, '\P{^-_modifier_letter}', "");
    Error('\p{	_Is_Modifier_LETTER:=}');
    Error('\P{	_Is_Modifier_LETTER:=}');
    Expect(1, 125259, '\p{ismodifierletter}', "");
    Expect(0, 125259, '\p{^ismodifierletter}', "");
    Expect(0, 125259, '\P{ismodifierletter}', "");
    Expect(1, 125259, '\P{^ismodifierletter}', "");
    Expect(0, 125260, '\p{ismodifierletter}', "");
    Expect(1, 125260, '\p{^ismodifierletter}', "");
    Expect(1, 125260, '\P{ismodifierletter}', "");
    Expect(0, 125260, '\P{^ismodifierletter}', "");
    Expect(1, 125259, '\p{ _IS_Modifier_Letter}', "");
    Expect(0, 125259, '\p{^ _IS_Modifier_Letter}', "");
    Expect(0, 125259, '\P{ _IS_Modifier_Letter}', "");
    Expect(1, 125259, '\P{^ _IS_Modifier_Letter}', "");
    Expect(0, 125260, '\p{ _IS_Modifier_Letter}', "");
    Expect(1, 125260, '\p{^ _IS_Modifier_Letter}', "");
    Expect(1, 125260, '\P{ _IS_Modifier_Letter}', "");
    Expect(0, 125260, '\P{^ _IS_Modifier_Letter}', "");
    Error('\p{_-lm/a/}');
    Error('\P{_-lm/a/}');
    Expect(1, 125259, '\p{lm}', "");
    Expect(0, 125259, '\p{^lm}', "");
    Expect(0, 125259, '\P{lm}', "");
    Expect(1, 125259, '\P{^lm}', "");
    Expect(0, 125260, '\p{lm}', "");
    Expect(1, 125260, '\p{^lm}', "");
    Expect(1, 125260, '\P{lm}', "");
    Expect(0, 125260, '\P{^lm}', "");
    Expect(1, 125259, '\p{-_Lm}', "");
    Expect(0, 125259, '\p{^-_Lm}', "");
    Expect(0, 125259, '\P{-_Lm}', "");
    Expect(1, 125259, '\P{^-_Lm}', "");
    Expect(0, 125260, '\p{-_Lm}', "");
    Expect(1, 125260, '\p{^-_Lm}', "");
    Expect(1, 125260, '\P{-_Lm}', "");
    Expect(0, 125260, '\P{^-_Lm}', "");
    Error('\p{	IS_Lm:=}');
    Error('\P{	IS_Lm:=}');
    Expect(1, 125259, '\p{islm}', "");
    Expect(0, 125259, '\p{^islm}', "");
    Expect(0, 125259, '\P{islm}', "");
    Expect(1, 125259, '\P{^islm}', "");
    Expect(0, 125260, '\p{islm}', "");
    Expect(1, 125260, '\p{^islm}', "");
    Expect(1, 125260, '\P{islm}', "");
    Expect(0, 125260, '\P{^islm}', "");
    Expect(1, 125259, '\p{ -is_Lm}', "");
    Expect(0, 125259, '\p{^ -is_Lm}', "");
    Expect(0, 125259, '\P{ -is_Lm}', "");
    Expect(1, 125259, '\P{^ -is_Lm}', "");
    Expect(0, 125260, '\p{ -is_Lm}', "");
    Expect(1, 125260, '\p{^ -is_Lm}', "");
    Expect(1, 125260, '\P{ -is_Lm}', "");
    Expect(0, 125260, '\P{^ -is_Lm}', "");
    Error('\p{/a/ _MODIFIER_symbol}');
    Error('\P{/a/ _MODIFIER_symbol}');
    Expect(1, 127999, '\p{modifiersymbol}', "");
    Expect(0, 127999, '\p{^modifiersymbol}', "");
    Expect(0, 127999, '\P{modifiersymbol}', "");
    Expect(1, 127999, '\P{^modifiersymbol}', "");
    Expect(0, 128000, '\p{modifiersymbol}', "");
    Expect(1, 128000, '\p{^modifiersymbol}', "");
    Expect(1, 128000, '\P{modifiersymbol}', "");
    Expect(0, 128000, '\P{^modifiersymbol}', "");
    Expect(1, 127999, '\p{- Modifier_Symbol}', "");
    Expect(0, 127999, '\p{^- Modifier_Symbol}', "");
    Expect(0, 127999, '\P{- Modifier_Symbol}', "");
    Expect(1, 127999, '\P{^- Modifier_Symbol}', "");
    Expect(0, 128000, '\p{- Modifier_Symbol}', "");
    Expect(1, 128000, '\p{^- Modifier_Symbol}', "");
    Expect(1, 128000, '\P{- Modifier_Symbol}', "");
    Expect(0, 128000, '\P{^- Modifier_Symbol}', "");
    Error('\p{__Is_Modifier_Symbol/a/}');
    Error('\P{__Is_Modifier_Symbol/a/}');
    Expect(1, 127999, '\p{ismodifiersymbol}', "");
    Expect(0, 127999, '\p{^ismodifiersymbol}', "");
    Expect(0, 127999, '\P{ismodifiersymbol}', "");
    Expect(1, 127999, '\P{^ismodifiersymbol}', "");
    Expect(0, 128000, '\p{ismodifiersymbol}', "");
    Expect(1, 128000, '\p{^ismodifiersymbol}', "");
    Expect(1, 128000, '\P{ismodifiersymbol}', "");
    Expect(0, 128000, '\P{^ismodifiersymbol}', "");
    Expect(1, 127999, '\p{	is_Modifier_Symbol}', "");
    Expect(0, 127999, '\p{^	is_Modifier_Symbol}', "");
    Expect(0, 127999, '\P{	is_Modifier_Symbol}', "");
    Expect(1, 127999, '\P{^	is_Modifier_Symbol}', "");
    Expect(0, 128000, '\p{	is_Modifier_Symbol}', "");
    Expect(1, 128000, '\p{^	is_Modifier_Symbol}', "");
    Expect(1, 128000, '\P{	is_Modifier_Symbol}', "");
    Expect(0, 128000, '\P{^	is_Modifier_Symbol}', "");
    Error('\p{/a/-_Sk}');
    Error('\P{/a/-_Sk}');
    Expect(1, 127999, '\p{sk}', "");
    Expect(0, 127999, '\p{^sk}', "");
    Expect(0, 127999, '\P{sk}', "");
    Expect(1, 127999, '\P{^sk}', "");
    Expect(0, 128000, '\p{sk}', "");
    Expect(1, 128000, '\p{^sk}', "");
    Expect(1, 128000, '\P{sk}', "");
    Expect(0, 128000, '\P{^sk}', "");
    Expect(1, 127999, '\p{	Sk}', "");
    Expect(0, 127999, '\p{^	Sk}', "");
    Expect(0, 127999, '\P{	Sk}', "");
    Expect(1, 127999, '\P{^	Sk}', "");
    Expect(0, 128000, '\p{	Sk}', "");
    Expect(1, 128000, '\p{^	Sk}', "");
    Expect(1, 128000, '\P{	Sk}', "");
    Expect(0, 128000, '\P{^	Sk}', "");
    Error('\p{/a/ Is_SK}');
    Error('\P{/a/ Is_SK}');
    Expect(1, 127999, '\p{issk}', "");
    Expect(0, 127999, '\p{^issk}', "");
    Expect(0, 127999, '\P{issk}', "");
    Expect(1, 127999, '\P{^issk}', "");
    Expect(0, 128000, '\p{issk}', "");
    Expect(1, 128000, '\p{^issk}', "");
    Expect(1, 128000, '\P{issk}', "");
    Expect(0, 128000, '\P{^issk}', "");
    Expect(1, 127999, '\p{	Is_Sk}', "");
    Expect(0, 127999, '\p{^	Is_Sk}', "");
    Expect(0, 127999, '\P{	Is_Sk}', "");
    Expect(1, 127999, '\P{^	Is_Sk}', "");
    Expect(0, 128000, '\p{	Is_Sk}', "");
    Expect(1, 128000, '\p{^	Is_Sk}', "");
    Expect(1, 128000, '\P{	Is_Sk}', "");
    Expect(0, 128000, '\P{^	Is_Sk}', "");
    Error('\p{/a/	_modifier_Tone_Letters}');
    Error('\P{/a/	_modifier_Tone_Letters}');
    Expect(1, 42783, '\p{modifiertoneletters}', "");
    Expect(0, 42783, '\p{^modifiertoneletters}', "");
    Expect(0, 42783, '\P{modifiertoneletters}', "");
    Expect(1, 42783, '\P{^modifiertoneletters}', "");
    Expect(0, 42784, '\p{modifiertoneletters}', "");
    Expect(1, 42784, '\p{^modifiertoneletters}', "");
    Expect(1, 42784, '\P{modifiertoneletters}', "");
    Expect(0, 42784, '\P{^modifiertoneletters}', "");
    Expect(1, 42783, '\p{__modifier_TONE_Letters}', "");
    Expect(0, 42783, '\p{^__modifier_TONE_Letters}', "");
    Expect(0, 42783, '\P{__modifier_TONE_Letters}', "");
    Expect(1, 42783, '\P{^__modifier_TONE_Letters}', "");
    Expect(0, 42784, '\p{__modifier_TONE_Letters}', "");
    Expect(1, 42784, '\p{^__modifier_TONE_Letters}', "");
    Expect(1, 42784, '\P{__modifier_TONE_Letters}', "");
    Expect(0, 42784, '\P{^__modifier_TONE_Letters}', "");
    Error('\p{:=_	is_Modifier_Tone_Letters}');
    Error('\P{:=_	is_Modifier_Tone_Letters}');
    Expect(1, 42783, '\p{ismodifiertoneletters}', "");
    Expect(0, 42783, '\p{^ismodifiertoneletters}', "");
    Expect(0, 42783, '\P{ismodifiertoneletters}', "");
    Expect(1, 42783, '\P{^ismodifiertoneletters}', "");
    Expect(0, 42784, '\p{ismodifiertoneletters}', "");
    Expect(1, 42784, '\p{^ismodifiertoneletters}', "");
    Expect(1, 42784, '\P{ismodifiertoneletters}', "");
    Expect(0, 42784, '\P{^ismodifiertoneletters}', "");
    Expect(1, 42783, '\p{_ IS_MODIFIER_TONE_Letters}', "");
    Expect(0, 42783, '\p{^_ IS_MODIFIER_TONE_Letters}', "");
    Expect(0, 42783, '\P{_ IS_MODIFIER_TONE_Letters}', "");
    Expect(1, 42783, '\P{^_ IS_MODIFIER_TONE_Letters}', "");
    Expect(0, 42784, '\p{_ IS_MODIFIER_TONE_Letters}', "");
    Expect(1, 42784, '\p{^_ IS_MODIFIER_TONE_Letters}', "");
    Expect(1, 42784, '\P{_ IS_MODIFIER_TONE_Letters}', "");
    Expect(0, 42784, '\P{^_ IS_MODIFIER_TONE_Letters}', "");
    Error('\p{ :=In_Modifier_TONE_letters}');
    Error('\P{ :=In_Modifier_TONE_letters}');
    Expect(1, 42783, '\p{inmodifiertoneletters}', "");
    Expect(0, 42783, '\p{^inmodifiertoneletters}', "");
    Expect(0, 42783, '\P{inmodifiertoneletters}', "");
    Expect(1, 42783, '\P{^inmodifiertoneletters}', "");
    Expect(0, 42784, '\p{inmodifiertoneletters}', "");
    Expect(1, 42784, '\p{^inmodifiertoneletters}', "");
    Expect(1, 42784, '\P{inmodifiertoneletters}', "");
    Expect(0, 42784, '\P{^inmodifiertoneletters}', "");
    Expect(1, 42783, '\p{_IN_modifier_TONE_Letters}', "");
    Expect(0, 42783, '\p{^_IN_modifier_TONE_Letters}', "");
    Expect(0, 42783, '\P{_IN_modifier_TONE_Letters}', "");
    Expect(1, 42783, '\P{^_IN_modifier_TONE_Letters}', "");
    Expect(0, 42784, '\p{_IN_modifier_TONE_Letters}', "");
    Expect(1, 42784, '\p{^_IN_modifier_TONE_Letters}', "");
    Expect(1, 42784, '\P{_IN_modifier_TONE_Letters}', "");
    Expect(0, 42784, '\P{^_IN_modifier_TONE_Letters}', "");
    Error('\p{	_Mongolian:=}');
    Error('\P{	_Mongolian:=}');
    Expect(1, 71276, '\p{mongolian}', "");
    Expect(0, 71276, '\p{^mongolian}', "");
    Expect(0, 71276, '\P{mongolian}', "");
    Expect(1, 71276, '\P{^mongolian}', "");
    Expect(0, 71277, '\p{mongolian}', "");
    Expect(1, 71277, '\p{^mongolian}', "");
    Expect(1, 71277, '\P{mongolian}', "");
    Expect(0, 71277, '\P{^mongolian}', "");
    Expect(1, 71276, '\p{_ Mongolian}', "");
    Expect(0, 71276, '\p{^_ Mongolian}', "");
    Expect(0, 71276, '\P{_ Mongolian}', "");
    Expect(1, 71276, '\P{^_ Mongolian}', "");
    Expect(0, 71277, '\p{_ Mongolian}', "");
    Expect(1, 71277, '\p{^_ Mongolian}', "");
    Expect(1, 71277, '\P{_ Mongolian}', "");
    Expect(0, 71277, '\P{^_ Mongolian}', "");
    Error('\p{ -is_Mongolian/a/}');
    Error('\P{ -is_Mongolian/a/}');
    Expect(1, 71276, '\p{ismongolian}', "");
    Expect(0, 71276, '\p{^ismongolian}', "");
    Expect(0, 71276, '\P{ismongolian}', "");
    Expect(1, 71276, '\P{^ismongolian}', "");
    Expect(0, 71277, '\p{ismongolian}', "");
    Expect(1, 71277, '\p{^ismongolian}', "");
    Expect(1, 71277, '\P{ismongolian}', "");
    Expect(0, 71277, '\P{^ismongolian}', "");
    Expect(1, 71276, '\p{ -Is_mongolian}', "");
    Expect(0, 71276, '\p{^ -Is_mongolian}', "");
    Expect(0, 71276, '\P{ -Is_mongolian}', "");
    Expect(1, 71276, '\P{^ -Is_mongolian}', "");
    Expect(0, 71277, '\p{ -Is_mongolian}', "");
    Expect(1, 71277, '\p{^ -Is_mongolian}', "");
    Expect(1, 71277, '\P{ -Is_mongolian}', "");
    Expect(0, 71277, '\P{^ -Is_mongolian}', "");
    Error('\p{/a/_	MONG}');
    Error('\P{/a/_	MONG}');
    Expect(1, 71276, '\p{mong}', "");
    Expect(0, 71276, '\p{^mong}', "");
    Expect(0, 71276, '\P{mong}', "");
    Expect(1, 71276, '\P{^mong}', "");
    Expect(0, 71277, '\p{mong}', "");
    Expect(1, 71277, '\p{^mong}', "");
    Expect(1, 71277, '\P{mong}', "");
    Expect(0, 71277, '\P{^mong}', "");
    Expect(1, 71276, '\p{-	Mong}', "");
    Expect(0, 71276, '\p{^-	Mong}', "");
    Expect(0, 71276, '\P{-	Mong}', "");
    Expect(1, 71276, '\P{^-	Mong}', "");
    Expect(0, 71277, '\p{-	Mong}', "");
    Expect(1, 71277, '\p{^-	Mong}', "");
    Expect(1, 71277, '\P{-	Mong}', "");
    Expect(0, 71277, '\P{^-	Mong}', "");
    Error('\p{/a/_IS_MONG}');
    Error('\P{/a/_IS_MONG}');
    Expect(1, 71276, '\p{ismong}', "");
    Expect(0, 71276, '\p{^ismong}', "");
    Expect(0, 71276, '\P{ismong}', "");
    Expect(1, 71276, '\P{^ismong}', "");
    Expect(0, 71277, '\p{ismong}', "");
    Expect(1, 71277, '\p{^ismong}', "");
    Expect(1, 71277, '\P{ismong}', "");
    Expect(0, 71277, '\P{^ismong}', "");
    Expect(1, 71276, '\p{ -IS_Mong}', "");
    Expect(0, 71276, '\p{^ -IS_Mong}', "");
    Expect(0, 71276, '\P{ -IS_Mong}', "");
    Expect(1, 71276, '\P{^ -IS_Mong}', "");
    Expect(0, 71277, '\p{ -IS_Mong}', "");
    Expect(1, 71277, '\p{^ -IS_Mong}', "");
    Expect(1, 71277, '\P{ -IS_Mong}', "");
    Expect(0, 71277, '\P{^ -IS_Mong}', "");
    Error('\p{ _MONGOLIAN_supplement:=}');
    Error('\P{ _MONGOLIAN_supplement:=}');
    Expect(1, 71295, '\p{mongoliansupplement}', "");
    Expect(0, 71295, '\p{^mongoliansupplement}', "");
    Expect(0, 71295, '\P{mongoliansupplement}', "");
    Expect(1, 71295, '\P{^mongoliansupplement}', "");
    Expect(0, 71296, '\p{mongoliansupplement}', "");
    Expect(1, 71296, '\p{^mongoliansupplement}', "");
    Expect(1, 71296, '\P{mongoliansupplement}', "");
    Expect(0, 71296, '\P{^mongoliansupplement}', "");
    Expect(1, 71295, '\p{	_Mongolian_SUPPLEMENT}', "");
    Expect(0, 71295, '\p{^	_Mongolian_SUPPLEMENT}', "");
    Expect(0, 71295, '\P{	_Mongolian_SUPPLEMENT}', "");
    Expect(1, 71295, '\P{^	_Mongolian_SUPPLEMENT}', "");
    Expect(0, 71296, '\p{	_Mongolian_SUPPLEMENT}', "");
    Expect(1, 71296, '\p{^	_Mongolian_SUPPLEMENT}', "");
    Expect(1, 71296, '\P{	_Mongolian_SUPPLEMENT}', "");
    Expect(0, 71296, '\P{^	_Mongolian_SUPPLEMENT}', "");
    Error('\p{:= -Is_mongolian_Supplement}');
    Error('\P{:= -Is_mongolian_Supplement}');
    Expect(1, 71295, '\p{ismongoliansupplement}', "");
    Expect(0, 71295, '\p{^ismongoliansupplement}', "");
    Expect(0, 71295, '\P{ismongoliansupplement}', "");
    Expect(1, 71295, '\P{^ismongoliansupplement}', "");
    Expect(0, 71296, '\p{ismongoliansupplement}', "");
    Expect(1, 71296, '\p{^ismongoliansupplement}', "");
    Expect(1, 71296, '\P{ismongoliansupplement}', "");
    Expect(0, 71296, '\P{^ismongoliansupplement}', "");
    Expect(1, 71295, '\p{Is_MONGOLIAN_Supplement}', "");
    Expect(0, 71295, '\p{^Is_MONGOLIAN_Supplement}', "");
    Expect(0, 71295, '\P{Is_MONGOLIAN_Supplement}', "");
    Expect(1, 71295, '\P{^Is_MONGOLIAN_Supplement}', "");
    Expect(0, 71296, '\p{Is_MONGOLIAN_Supplement}', "");
    Expect(1, 71296, '\p{^Is_MONGOLIAN_Supplement}', "");
    Expect(1, 71296, '\P{Is_MONGOLIAN_Supplement}', "");
    Expect(0, 71296, '\P{^Is_MONGOLIAN_Supplement}', "");
    Error('\p{/a/- IN_mongolian_Supplement}');
    Error('\P{/a/- IN_mongolian_Supplement}');
    Expect(1, 71295, '\p{inmongoliansupplement}', "");
    Expect(0, 71295, '\p{^inmongoliansupplement}', "");
    Expect(0, 71295, '\P{inmongoliansupplement}', "");
    Expect(1, 71295, '\P{^inmongoliansupplement}', "");
    Expect(0, 71296, '\p{inmongoliansupplement}', "");
    Expect(1, 71296, '\p{^inmongoliansupplement}', "");
    Expect(1, 71296, '\P{inmongoliansupplement}', "");
    Expect(0, 71296, '\P{^inmongoliansupplement}', "");
    Expect(1, 71295, '\p{-In_MONGOLIAN_supplement}', "");
    Expect(0, 71295, '\p{^-In_MONGOLIAN_supplement}', "");
    Expect(0, 71295, '\P{-In_MONGOLIAN_supplement}', "");
    Expect(1, 71295, '\P{^-In_MONGOLIAN_supplement}', "");
    Expect(0, 71296, '\p{-In_MONGOLIAN_supplement}', "");
    Expect(1, 71296, '\p{^-In_MONGOLIAN_supplement}', "");
    Expect(1, 71296, '\P{-In_MONGOLIAN_supplement}', "");
    Expect(0, 71296, '\P{^-In_MONGOLIAN_supplement}', "");
    Error('\p{-:=mongolian_Sup}');
    Error('\P{-:=mongolian_Sup}');
    Expect(1, 71295, '\p{mongoliansup}', "");
    Expect(0, 71295, '\p{^mongoliansup}', "");
    Expect(0, 71295, '\P{mongoliansup}', "");
    Expect(1, 71295, '\P{^mongoliansup}', "");
    Expect(0, 71296, '\p{mongoliansup}', "");
    Expect(1, 71296, '\p{^mongoliansup}', "");
    Expect(1, 71296, '\P{mongoliansup}', "");
    Expect(0, 71296, '\P{^mongoliansup}', "");
    Expect(1, 71295, '\p{_ mongolian_SUP}', "");
    Expect(0, 71295, '\p{^_ mongolian_SUP}', "");
    Expect(0, 71295, '\P{_ mongolian_SUP}', "");
    Expect(1, 71295, '\P{^_ mongolian_SUP}', "");
    Expect(0, 71296, '\p{_ mongolian_SUP}', "");
    Expect(1, 71296, '\p{^_ mongolian_SUP}', "");
    Expect(1, 71296, '\P{_ mongolian_SUP}', "");
    Expect(0, 71296, '\P{^_ mongolian_SUP}', "");
    Error('\p{/a/_is_Mongolian_SUP}');
    Error('\P{/a/_is_Mongolian_SUP}');
    Expect(1, 71295, '\p{ismongoliansup}', "");
    Expect(0, 71295, '\p{^ismongoliansup}', "");
    Expect(0, 71295, '\P{ismongoliansup}', "");
    Expect(1, 71295, '\P{^ismongoliansup}', "");
    Expect(0, 71296, '\p{ismongoliansup}', "");
    Expect(1, 71296, '\p{^ismongoliansup}', "");
    Expect(1, 71296, '\P{ismongoliansup}', "");
    Expect(0, 71296, '\P{^ismongoliansup}', "");
    Expect(1, 71295, '\p{_-Is_Mongolian_sup}', "");
    Expect(0, 71295, '\p{^_-Is_Mongolian_sup}', "");
    Expect(0, 71295, '\P{_-Is_Mongolian_sup}', "");
    Expect(1, 71295, '\P{^_-Is_Mongolian_sup}', "");
    Expect(0, 71296, '\p{_-Is_Mongolian_sup}', "");
    Expect(1, 71296, '\p{^_-Is_Mongolian_sup}', "");
    Expect(1, 71296, '\P{_-Is_Mongolian_sup}', "");
    Expect(0, 71296, '\P{^_-Is_Mongolian_sup}', "");
    Error('\p{:=  In_mongolian_SUP}');
    Error('\P{:=  In_mongolian_SUP}');
    Expect(1, 71295, '\p{inmongoliansup}', "");
    Expect(0, 71295, '\p{^inmongoliansup}', "");
    Expect(0, 71295, '\P{inmongoliansup}', "");
    Expect(1, 71295, '\P{^inmongoliansup}', "");
    Expect(0, 71296, '\p{inmongoliansup}', "");
    Expect(1, 71296, '\p{^inmongoliansup}', "");
    Expect(1, 71296, '\P{inmongoliansup}', "");
    Expect(0, 71296, '\P{^inmongoliansup}', "");
    Expect(1, 71295, '\p{-In_MONGOLIAN_sup}', "");
    Expect(0, 71295, '\p{^-In_MONGOLIAN_sup}', "");
    Expect(0, 71295, '\P{-In_MONGOLIAN_sup}', "");
    Expect(1, 71295, '\P{^-In_MONGOLIAN_sup}', "");
    Expect(0, 71296, '\p{-In_MONGOLIAN_sup}', "");
    Expect(1, 71296, '\p{^-In_MONGOLIAN_sup}', "");
    Expect(1, 71296, '\P{-In_MONGOLIAN_sup}', "");
    Expect(0, 71296, '\P{^-In_MONGOLIAN_sup}', "");
    Error('\p{/a/Mro}');
    Error('\P{/a/Mro}');
    Expect(1, 92783, '\p{mro}', "");
    Expect(0, 92783, '\p{^mro}', "");
    Expect(0, 92783, '\P{mro}', "");
    Expect(1, 92783, '\P{^mro}', "");
    Expect(0, 92784, '\p{mro}', "");
    Expect(1, 92784, '\p{^mro}', "");
    Expect(1, 92784, '\P{mro}', "");
    Expect(0, 92784, '\P{^mro}', "");
    Expect(1, 92783, '\p{	Mro}', "");
    Expect(0, 92783, '\p{^	Mro}', "");
    Expect(0, 92783, '\P{	Mro}', "");
    Expect(1, 92783, '\P{^	Mro}', "");
    Expect(0, 92784, '\p{	Mro}', "");
    Expect(1, 92784, '\p{^	Mro}', "");
    Expect(1, 92784, '\P{	Mro}', "");
    Expect(0, 92784, '\P{^	Mro}', "");
    Error('\p{/a/	-IS_Mro}');
    Error('\P{/a/	-IS_Mro}');
    Expect(1, 92783, '\p{ismro}', "");
    Expect(0, 92783, '\p{^ismro}', "");
    Expect(0, 92783, '\P{ismro}', "");
    Expect(1, 92783, '\P{^ismro}', "");
    Expect(0, 92784, '\p{ismro}', "");
    Expect(1, 92784, '\p{^ismro}', "");
    Expect(1, 92784, '\P{ismro}', "");
    Expect(0, 92784, '\P{^ismro}', "");
    Expect(1, 92783, '\p{_Is_Mro}', "");
    Expect(0, 92783, '\p{^_Is_Mro}', "");
    Expect(0, 92783, '\P{_Is_Mro}', "");
    Expect(1, 92783, '\P{^_Is_Mro}', "");
    Expect(0, 92784, '\p{_Is_Mro}', "");
    Expect(1, 92784, '\p{^_Is_Mro}', "");
    Expect(1, 92784, '\P{_Is_Mro}', "");
    Expect(0, 92784, '\P{^_Is_Mro}', "");
    Error('\p{/a/_-MROO}');
    Error('\P{/a/_-MROO}');
    Expect(1, 92783, '\p{mroo}', "");
    Expect(0, 92783, '\p{^mroo}', "");
    Expect(0, 92783, '\P{mroo}', "");
    Expect(1, 92783, '\P{^mroo}', "");
    Expect(0, 92784, '\p{mroo}', "");
    Expect(1, 92784, '\p{^mroo}', "");
    Expect(1, 92784, '\P{mroo}', "");
    Expect(0, 92784, '\P{^mroo}', "");
    Expect(1, 92783, '\p{-_Mroo}', "");
    Expect(0, 92783, '\p{^-_Mroo}', "");
    Expect(0, 92783, '\P{-_Mroo}', "");
    Expect(1, 92783, '\P{^-_Mroo}', "");
    Expect(0, 92784, '\p{-_Mroo}', "");
    Expect(1, 92784, '\p{^-_Mroo}', "");
    Expect(1, 92784, '\P{-_Mroo}', "");
    Expect(0, 92784, '\P{^-_Mroo}', "");
    Error('\p{	Is_MROO/a/}');
    Error('\P{	Is_MROO/a/}');
    Expect(1, 92783, '\p{ismroo}', "");
    Expect(0, 92783, '\p{^ismroo}', "");
    Expect(0, 92783, '\P{ismroo}', "");
    Expect(1, 92783, '\P{^ismroo}', "");
    Expect(0, 92784, '\p{ismroo}', "");
    Expect(1, 92784, '\p{^ismroo}', "");
    Expect(1, 92784, '\P{ismroo}', "");
    Expect(0, 92784, '\P{^ismroo}', "");
    Expect(1, 92783, '\p{_ IS_Mroo}', "");
    Expect(0, 92783, '\p{^_ IS_Mroo}', "");
    Expect(0, 92783, '\P{_ IS_Mroo}', "");
    Expect(1, 92783, '\P{^_ IS_Mroo}', "");
    Expect(0, 92784, '\p{_ IS_Mroo}', "");
    Expect(1, 92784, '\p{^_ IS_Mroo}', "");
    Expect(1, 92784, '\P{_ IS_Mroo}', "");
    Expect(0, 92784, '\P{^_ IS_Mroo}', "");
    Error('\p{_multani:=}');
    Error('\P{_multani:=}');
    Expect(1, 70313, '\p{multani}', "");
    Expect(0, 70313, '\p{^multani}', "");
    Expect(0, 70313, '\P{multani}', "");
    Expect(1, 70313, '\P{^multani}', "");
    Expect(0, 70314, '\p{multani}', "");
    Expect(1, 70314, '\p{^multani}', "");
    Expect(1, 70314, '\P{multani}', "");
    Expect(0, 70314, '\P{^multani}', "");
    Expect(1, 70313, '\p{--Multani}', "");
    Expect(0, 70313, '\p{^--Multani}', "");
    Expect(0, 70313, '\P{--Multani}', "");
    Expect(1, 70313, '\P{^--Multani}', "");
    Expect(0, 70314, '\p{--Multani}', "");
    Expect(1, 70314, '\p{^--Multani}', "");
    Expect(1, 70314, '\P{--Multani}', "");
    Expect(0, 70314, '\P{^--Multani}', "");
    Error('\p{ :=Is_multani}');
    Error('\P{ :=Is_multani}');
    Expect(1, 70313, '\p{ismultani}', "");
    Expect(0, 70313, '\p{^ismultani}', "");
    Expect(0, 70313, '\P{ismultani}', "");
    Expect(1, 70313, '\P{^ismultani}', "");
    Expect(0, 70314, '\p{ismultani}', "");
    Expect(1, 70314, '\p{^ismultani}', "");
    Expect(1, 70314, '\P{ismultani}', "");
    Expect(0, 70314, '\P{^ismultani}', "");
    Expect(1, 70313, '\p{_Is_multani}', "");
    Expect(0, 70313, '\p{^_Is_multani}', "");
    Expect(0, 70313, '\P{_Is_multani}', "");
    Expect(1, 70313, '\P{^_Is_multani}', "");
    Expect(0, 70314, '\p{_Is_multani}', "");
    Expect(1, 70314, '\p{^_Is_multani}', "");
    Expect(1, 70314, '\P{_Is_multani}', "");
    Expect(0, 70314, '\P{^_Is_multani}', "");
    Error('\p{:=_MULT}');
    Error('\P{:=_MULT}');
    Expect(1, 70313, '\p{mult}', "");
    Expect(0, 70313, '\p{^mult}', "");
    Expect(0, 70313, '\P{mult}', "");
    Expect(1, 70313, '\P{^mult}', "");
    Expect(0, 70314, '\p{mult}', "");
    Expect(1, 70314, '\p{^mult}', "");
    Expect(1, 70314, '\P{mult}', "");
    Expect(0, 70314, '\P{^mult}', "");
    Expect(1, 70313, '\p{-Mult}', "");
    Expect(0, 70313, '\p{^-Mult}', "");
    Expect(0, 70313, '\P{-Mult}', "");
    Expect(1, 70313, '\P{^-Mult}', "");
    Expect(0, 70314, '\p{-Mult}', "");
    Expect(1, 70314, '\p{^-Mult}', "");
    Expect(1, 70314, '\P{-Mult}', "");
    Expect(0, 70314, '\P{^-Mult}', "");
    Error('\p{	:=IS_Mult}');
    Error('\P{	:=IS_Mult}');
    Expect(1, 70313, '\p{ismult}', "");
    Expect(0, 70313, '\p{^ismult}', "");
    Expect(0, 70313, '\P{ismult}', "");
    Expect(1, 70313, '\P{^ismult}', "");
    Expect(0, 70314, '\p{ismult}', "");
    Expect(1, 70314, '\p{^ismult}', "");
    Expect(1, 70314, '\P{ismult}', "");
    Expect(0, 70314, '\P{^ismult}', "");
    Expect(1, 70313, '\p{-IS_Mult}', "");
    Expect(0, 70313, '\p{^-IS_Mult}', "");
    Expect(0, 70313, '\P{-IS_Mult}', "");
    Expect(1, 70313, '\P{^-IS_Mult}', "");
    Expect(0, 70314, '\p{-IS_Mult}', "");
    Expect(1, 70314, '\p{^-IS_Mult}', "");
    Expect(1, 70314, '\P{-IS_Mult}', "");
    Expect(0, 70314, '\P{^-IS_Mult}', "");
    Error('\p{_:=MUSICAL_symbols}');
    Error('\P{_:=MUSICAL_symbols}');
    Expect(1, 119295, '\p{musicalsymbols}', "");
    Expect(0, 119295, '\p{^musicalsymbols}', "");
    Expect(0, 119295, '\P{musicalsymbols}', "");
    Expect(1, 119295, '\P{^musicalsymbols}', "");
    Expect(0, 119296, '\p{musicalsymbols}', "");
    Expect(1, 119296, '\p{^musicalsymbols}', "");
    Expect(1, 119296, '\P{musicalsymbols}', "");
    Expect(0, 119296, '\P{^musicalsymbols}', "");
    Expect(1, 119295, '\p{_Musical_symbols}', "");
    Expect(0, 119295, '\p{^_Musical_symbols}', "");
    Expect(0, 119295, '\P{_Musical_symbols}', "");
    Expect(1, 119295, '\P{^_Musical_symbols}', "");
    Expect(0, 119296, '\p{_Musical_symbols}', "");
    Expect(1, 119296, '\p{^_Musical_symbols}', "");
    Expect(1, 119296, '\P{_Musical_symbols}', "");
    Expect(0, 119296, '\P{^_Musical_symbols}', "");
    Error('\p{ -IS_MUSICAL_Symbols:=}');
    Error('\P{ -IS_MUSICAL_Symbols:=}');
    Expect(1, 119295, '\p{ismusicalsymbols}', "");
    Expect(0, 119295, '\p{^ismusicalsymbols}', "");
    Expect(0, 119295, '\P{ismusicalsymbols}', "");
    Expect(1, 119295, '\P{^ismusicalsymbols}', "");
    Expect(0, 119296, '\p{ismusicalsymbols}', "");
    Expect(1, 119296, '\p{^ismusicalsymbols}', "");
    Expect(1, 119296, '\P{ismusicalsymbols}', "");
    Expect(0, 119296, '\P{^ismusicalsymbols}', "");
    Expect(1, 119295, '\p{-_IS_musical_symbols}', "");
    Expect(0, 119295, '\p{^-_IS_musical_symbols}', "");
    Expect(0, 119295, '\P{-_IS_musical_symbols}', "");
    Expect(1, 119295, '\P{^-_IS_musical_symbols}', "");
    Expect(0, 119296, '\p{-_IS_musical_symbols}', "");
    Expect(1, 119296, '\p{^-_IS_musical_symbols}', "");
    Expect(1, 119296, '\P{-_IS_musical_symbols}', "");
    Expect(0, 119296, '\P{^-_IS_musical_symbols}', "");
    Error('\p{ :=IN_musical_SYMBOLS}');
    Error('\P{ :=IN_musical_SYMBOLS}');
    Expect(1, 119295, '\p{inmusicalsymbols}', "");
    Expect(0, 119295, '\p{^inmusicalsymbols}', "");
    Expect(0, 119295, '\P{inmusicalsymbols}', "");
    Expect(1, 119295, '\P{^inmusicalsymbols}', "");
    Expect(0, 119296, '\p{inmusicalsymbols}', "");
    Expect(1, 119296, '\p{^inmusicalsymbols}', "");
    Expect(1, 119296, '\P{inmusicalsymbols}', "");
    Expect(0, 119296, '\P{^inmusicalsymbols}', "");
    Expect(1, 119295, '\p{	in_Musical_Symbols}', "");
    Expect(0, 119295, '\p{^	in_Musical_Symbols}', "");
    Expect(0, 119295, '\P{	in_Musical_Symbols}', "");
    Expect(1, 119295, '\P{^	in_Musical_Symbols}', "");
    Expect(0, 119296, '\p{	in_Musical_Symbols}', "");
    Expect(1, 119296, '\p{^	in_Musical_Symbols}', "");
    Expect(1, 119296, '\P{	in_Musical_Symbols}', "");
    Expect(0, 119296, '\P{^	in_Musical_Symbols}', "");
    Error('\p{_/a/Music}');
    Error('\P{_/a/Music}');
    Expect(1, 119295, '\p{music}', "");
    Expect(0, 119295, '\p{^music}', "");
    Expect(0, 119295, '\P{music}', "");
    Expect(1, 119295, '\P{^music}', "");
    Expect(0, 119296, '\p{music}', "");
    Expect(1, 119296, '\p{^music}', "");
    Expect(1, 119296, '\P{music}', "");
    Expect(0, 119296, '\P{^music}', "");
    Expect(1, 119295, '\p{_ music}', "");
    Expect(0, 119295, '\p{^_ music}', "");
    Expect(0, 119295, '\P{_ music}', "");
    Expect(1, 119295, '\P{^_ music}', "");
    Expect(0, 119296, '\p{_ music}', "");
    Expect(1, 119296, '\p{^_ music}', "");
    Expect(1, 119296, '\P{_ music}', "");
    Expect(0, 119296, '\P{^_ music}', "");
    Error('\p{	 Is_Music:=}');
    Error('\P{	 Is_Music:=}');
    Expect(1, 119295, '\p{ismusic}', "");
    Expect(0, 119295, '\p{^ismusic}', "");
    Expect(0, 119295, '\P{ismusic}', "");
    Expect(1, 119295, '\P{^ismusic}', "");
    Expect(0, 119296, '\p{ismusic}', "");
    Expect(1, 119296, '\p{^ismusic}', "");
    Expect(1, 119296, '\P{ismusic}', "");
    Expect(0, 119296, '\P{^ismusic}', "");
    Expect(1, 119295, '\p{	IS_MUSIC}', "");
    Expect(0, 119295, '\p{^	IS_MUSIC}', "");
    Expect(0, 119295, '\P{	IS_MUSIC}', "");
    Expect(1, 119295, '\P{^	IS_MUSIC}', "");
    Expect(0, 119296, '\p{	IS_MUSIC}', "");
    Expect(1, 119296, '\p{^	IS_MUSIC}', "");
    Expect(1, 119296, '\P{	IS_MUSIC}', "");
    Expect(0, 119296, '\P{^	IS_MUSIC}', "");
    Error('\p{	In_music/a/}');
    Error('\P{	In_music/a/}');
    Expect(1, 119295, '\p{inmusic}', "");
    Expect(0, 119295, '\p{^inmusic}', "");
    Expect(0, 119295, '\P{inmusic}', "");
    Expect(1, 119295, '\P{^inmusic}', "");
    Expect(0, 119296, '\p{inmusic}', "");
    Expect(1, 119296, '\p{^inmusic}', "");
    Expect(1, 119296, '\P{inmusic}', "");
    Expect(0, 119296, '\P{^inmusic}', "");
    Expect(1, 119295, '\p{-_in_Music}', "");
    Expect(0, 119295, '\p{^-_in_Music}', "");
    Expect(0, 119295, '\P{-_in_Music}', "");
    Expect(1, 119295, '\P{^-_in_Music}', "");
    Expect(0, 119296, '\p{-_in_Music}', "");
    Expect(1, 119296, '\p{^-_in_Music}', "");
    Expect(1, 119296, '\P{-_in_Music}', "");
    Expect(0, 119296, '\P{^-_in_Music}', "");
    Error('\p{--myanmar:=}');
    Error('\P{--myanmar:=}');
    Expect(1, 43647, '\p{myanmar}', "");
    Expect(0, 43647, '\p{^myanmar}', "");
    Expect(0, 43647, '\P{myanmar}', "");
    Expect(1, 43647, '\P{^myanmar}', "");
    Expect(0, 43648, '\p{myanmar}', "");
    Expect(1, 43648, '\p{^myanmar}', "");
    Expect(1, 43648, '\P{myanmar}', "");
    Expect(0, 43648, '\P{^myanmar}', "");
    Expect(1, 43647, '\p{-	Myanmar}', "");
    Expect(0, 43647, '\p{^-	Myanmar}', "");
    Expect(0, 43647, '\P{-	Myanmar}', "");
    Expect(1, 43647, '\P{^-	Myanmar}', "");
    Expect(0, 43648, '\p{-	Myanmar}', "");
    Expect(1, 43648, '\p{^-	Myanmar}', "");
    Expect(1, 43648, '\P{-	Myanmar}', "");
    Expect(0, 43648, '\P{^-	Myanmar}', "");
    Error('\p{:= Is_Myanmar}');
    Error('\P{:= Is_Myanmar}');
    Expect(1, 43647, '\p{ismyanmar}', "");
    Expect(0, 43647, '\p{^ismyanmar}', "");
    Expect(0, 43647, '\P{ismyanmar}', "");
    Expect(1, 43647, '\P{^ismyanmar}', "");
    Expect(0, 43648, '\p{ismyanmar}', "");
    Expect(1, 43648, '\p{^ismyanmar}', "");
    Expect(1, 43648, '\P{ismyanmar}', "");
    Expect(0, 43648, '\P{^ismyanmar}', "");
    Expect(1, 43647, '\p{_Is_myanmar}', "");
    Expect(0, 43647, '\p{^_Is_myanmar}', "");
    Expect(0, 43647, '\P{_Is_myanmar}', "");
    Expect(1, 43647, '\P{^_Is_myanmar}', "");
    Expect(0, 43648, '\p{_Is_myanmar}', "");
    Expect(1, 43648, '\p{^_Is_myanmar}', "");
    Expect(1, 43648, '\P{_Is_myanmar}', "");
    Expect(0, 43648, '\P{^_Is_myanmar}', "");
    Error('\p{-/a/MYMR}');
    Error('\P{-/a/MYMR}');
    Expect(1, 43647, '\p{mymr}', "");
    Expect(0, 43647, '\p{^mymr}', "");
    Expect(0, 43647, '\P{mymr}', "");
    Expect(1, 43647, '\P{^mymr}', "");
    Expect(0, 43648, '\p{mymr}', "");
    Expect(1, 43648, '\p{^mymr}', "");
    Expect(1, 43648, '\P{mymr}', "");
    Expect(0, 43648, '\P{^mymr}', "");
    Expect(1, 43647, '\p{-Mymr}', "");
    Expect(0, 43647, '\p{^-Mymr}', "");
    Expect(0, 43647, '\P{-Mymr}', "");
    Expect(1, 43647, '\P{^-Mymr}', "");
    Expect(0, 43648, '\p{-Mymr}', "");
    Expect(1, 43648, '\p{^-Mymr}', "");
    Expect(1, 43648, '\P{-Mymr}', "");
    Expect(0, 43648, '\P{^-Mymr}', "");
    Error('\p{-:=Is_MYMR}');
    Error('\P{-:=Is_MYMR}');
    Expect(1, 43647, '\p{ismymr}', "");
    Expect(0, 43647, '\p{^ismymr}', "");
    Expect(0, 43647, '\P{ismymr}', "");
    Expect(1, 43647, '\P{^ismymr}', "");
    Expect(0, 43648, '\p{ismymr}', "");
    Expect(1, 43648, '\p{^ismymr}', "");
    Expect(1, 43648, '\P{ismymr}', "");
    Expect(0, 43648, '\P{^ismymr}', "");
    Expect(1, 43647, '\p{_	Is_mymr}', "");
    Expect(0, 43647, '\p{^_	Is_mymr}', "");
    Expect(0, 43647, '\P{_	Is_mymr}', "");
    Expect(1, 43647, '\P{^_	Is_mymr}', "");
    Expect(0, 43648, '\p{_	Is_mymr}', "");
    Expect(1, 43648, '\p{^_	Is_mymr}', "");
    Expect(1, 43648, '\P{_	Is_mymr}', "");
    Expect(0, 43648, '\P{^_	Is_mymr}', "");
    Error('\p{ /a/MYANMAR_EXTENDED_A}');
    Error('\P{ /a/MYANMAR_EXTENDED_A}');
    Expect(1, 43647, '\p{myanmarextendeda}', "");
    Expect(0, 43647, '\p{^myanmarextendeda}', "");
    Expect(0, 43647, '\P{myanmarextendeda}', "");
    Expect(1, 43647, '\P{^myanmarextendeda}', "");
    Expect(0, 43648, '\p{myanmarextendeda}', "");
    Expect(1, 43648, '\p{^myanmarextendeda}', "");
    Expect(1, 43648, '\P{myanmarextendeda}', "");
    Expect(0, 43648, '\P{^myanmarextendeda}', "");
    Expect(1, 43647, '\p{		myanmar_Extended_A}', "");
    Expect(0, 43647, '\p{^		myanmar_Extended_A}', "");
    Expect(0, 43647, '\P{		myanmar_Extended_A}', "");
    Expect(1, 43647, '\P{^		myanmar_Extended_A}', "");
    Expect(0, 43648, '\p{		myanmar_Extended_A}', "");
    Expect(1, 43648, '\p{^		myanmar_Extended_A}', "");
    Expect(1, 43648, '\P{		myanmar_Extended_A}', "");
    Expect(0, 43648, '\P{^		myanmar_Extended_A}', "");
    Error('\p{	:=IS_Myanmar_EXTENDED_A}');
    Error('\P{	:=IS_Myanmar_EXTENDED_A}');
    Expect(1, 43647, '\p{ismyanmarextendeda}', "");
    Expect(0, 43647, '\p{^ismyanmarextendeda}', "");
    Expect(0, 43647, '\P{ismyanmarextendeda}', "");
    Expect(1, 43647, '\P{^ismyanmarextendeda}', "");
    Expect(0, 43648, '\p{ismyanmarextendeda}', "");
    Expect(1, 43648, '\p{^ismyanmarextendeda}', "");
    Expect(1, 43648, '\P{ismyanmarextendeda}', "");
    Expect(0, 43648, '\P{^ismyanmarextendeda}', "");
    Expect(1, 43647, '\p{_ Is_Myanmar_EXTENDED_A}', "");
    Expect(0, 43647, '\p{^_ Is_Myanmar_EXTENDED_A}', "");
    Expect(0, 43647, '\P{_ Is_Myanmar_EXTENDED_A}', "");
    Expect(1, 43647, '\P{^_ Is_Myanmar_EXTENDED_A}', "");
    Expect(0, 43648, '\p{_ Is_Myanmar_EXTENDED_A}', "");
    Expect(1, 43648, '\p{^_ Is_Myanmar_EXTENDED_A}', "");
    Expect(1, 43648, '\P{_ Is_Myanmar_EXTENDED_A}', "");
    Expect(0, 43648, '\P{^_ Is_Myanmar_EXTENDED_A}', "");
    Error('\p{/a/ _In_myanmar_Extended_A}');
    Error('\P{/a/ _In_myanmar_Extended_A}');
    Expect(1, 43647, '\p{inmyanmarextendeda}', "");
    Expect(0, 43647, '\p{^inmyanmarextendeda}', "");
    Expect(0, 43647, '\P{inmyanmarextendeda}', "");
    Expect(1, 43647, '\P{^inmyanmarextendeda}', "");
    Expect(0, 43648, '\p{inmyanmarextendeda}', "");
    Expect(1, 43648, '\p{^inmyanmarextendeda}', "");
    Expect(1, 43648, '\P{inmyanmarextendeda}', "");
    Expect(0, 43648, '\P{^inmyanmarextendeda}', "");
    Expect(1, 43647, '\p{		In_Myanmar_Extended_A}', "");
    Expect(0, 43647, '\p{^		In_Myanmar_Extended_A}', "");
    Expect(0, 43647, '\P{		In_Myanmar_Extended_A}', "");
    Expect(1, 43647, '\P{^		In_Myanmar_Extended_A}', "");
    Expect(0, 43648, '\p{		In_Myanmar_Extended_A}', "");
    Expect(1, 43648, '\p{^		In_Myanmar_Extended_A}', "");
    Expect(1, 43648, '\P{		In_Myanmar_Extended_A}', "");
    Expect(0, 43648, '\P{^		In_Myanmar_Extended_A}', "");
    Error('\p{_:=myanmar_ext_A}');
    Error('\P{_:=myanmar_ext_A}');
    Expect(1, 43647, '\p{myanmarexta}', "");
    Expect(0, 43647, '\p{^myanmarexta}', "");
    Expect(0, 43647, '\P{myanmarexta}', "");
    Expect(1, 43647, '\P{^myanmarexta}', "");
    Expect(0, 43648, '\p{myanmarexta}', "");
    Expect(1, 43648, '\p{^myanmarexta}', "");
    Expect(1, 43648, '\P{myanmarexta}', "");
    Expect(0, 43648, '\P{^myanmarexta}', "");
    Expect(1, 43647, '\p{	myanmar_ext_a}', "");
    Expect(0, 43647, '\p{^	myanmar_ext_a}', "");
    Expect(0, 43647, '\P{	myanmar_ext_a}', "");
    Expect(1, 43647, '\P{^	myanmar_ext_a}', "");
    Expect(0, 43648, '\p{	myanmar_ext_a}', "");
    Expect(1, 43648, '\p{^	myanmar_ext_a}', "");
    Expect(1, 43648, '\P{	myanmar_ext_a}', "");
    Expect(0, 43648, '\P{^	myanmar_ext_a}', "");
    Error('\p{:=_Is_myanmar_Ext_A}');
    Error('\P{:=_Is_myanmar_Ext_A}');
    Expect(1, 43647, '\p{ismyanmarexta}', "");
    Expect(0, 43647, '\p{^ismyanmarexta}', "");
    Expect(0, 43647, '\P{ismyanmarexta}', "");
    Expect(1, 43647, '\P{^ismyanmarexta}', "");
    Expect(0, 43648, '\p{ismyanmarexta}', "");
    Expect(1, 43648, '\p{^ismyanmarexta}', "");
    Expect(1, 43648, '\P{ismyanmarexta}', "");
    Expect(0, 43648, '\P{^ismyanmarexta}', "");
    Expect(1, 43647, '\p{	 Is_myanmar_ext_A}', "");
    Expect(0, 43647, '\p{^	 Is_myanmar_ext_A}', "");
    Expect(0, 43647, '\P{	 Is_myanmar_ext_A}', "");
    Expect(1, 43647, '\P{^	 Is_myanmar_ext_A}', "");
    Expect(0, 43648, '\p{	 Is_myanmar_ext_A}', "");
    Expect(1, 43648, '\p{^	 Is_myanmar_ext_A}', "");
    Expect(1, 43648, '\P{	 Is_myanmar_ext_A}', "");
    Expect(0, 43648, '\P{^	 Is_myanmar_ext_A}', "");
    Error('\p{ -IN_Myanmar_Ext_A/a/}');
    Error('\P{ -IN_Myanmar_Ext_A/a/}');
    Expect(1, 43647, '\p{inmyanmarexta}', "");
    Expect(0, 43647, '\p{^inmyanmarexta}', "");
    Expect(0, 43647, '\P{inmyanmarexta}', "");
    Expect(1, 43647, '\P{^inmyanmarexta}', "");
    Expect(0, 43648, '\p{inmyanmarexta}', "");
    Expect(1, 43648, '\p{^inmyanmarexta}', "");
    Expect(1, 43648, '\P{inmyanmarexta}', "");
    Expect(0, 43648, '\P{^inmyanmarexta}', "");
    Expect(1, 43647, '\p{	-In_MYANMAR_EXT_a}', "");
    Expect(0, 43647, '\p{^	-In_MYANMAR_EXT_a}', "");
    Expect(0, 43647, '\P{	-In_MYANMAR_EXT_a}', "");
    Expect(1, 43647, '\P{^	-In_MYANMAR_EXT_a}', "");
    Expect(0, 43648, '\p{	-In_MYANMAR_EXT_a}', "");
    Expect(1, 43648, '\p{^	-In_MYANMAR_EXT_a}', "");
    Expect(1, 43648, '\P{	-In_MYANMAR_EXT_a}', "");
    Expect(0, 43648, '\P{^	-In_MYANMAR_EXT_a}', "");
    Error('\p{/a/--MYANMAR_Extended_B}');
    Error('\P{/a/--MYANMAR_Extended_B}');
    Expect(1, 43519, '\p{myanmarextendedb}', "");
    Expect(0, 43519, '\p{^myanmarextendedb}', "");
    Expect(0, 43519, '\P{myanmarextendedb}', "");
    Expect(1, 43519, '\P{^myanmarextendedb}', "");
    Expect(0, 43520, '\p{myanmarextendedb}', "");
    Expect(1, 43520, '\p{^myanmarextendedb}', "");
    Expect(1, 43520, '\P{myanmarextendedb}', "");
    Expect(0, 43520, '\P{^myanmarextendedb}', "");
    Expect(1, 43519, '\p{		MYANMAR_Extended_B}', "");
    Expect(0, 43519, '\p{^		MYANMAR_Extended_B}', "");
    Expect(0, 43519, '\P{		MYANMAR_Extended_B}', "");
    Expect(1, 43519, '\P{^		MYANMAR_Extended_B}', "");
    Expect(0, 43520, '\p{		MYANMAR_Extended_B}', "");
    Expect(1, 43520, '\p{^		MYANMAR_Extended_B}', "");
    Expect(1, 43520, '\P{		MYANMAR_Extended_B}', "");
    Expect(0, 43520, '\P{^		MYANMAR_Extended_B}', "");
    Error('\p{/a/ is_myanmar_EXTENDED_b}');
    Error('\P{/a/ is_myanmar_EXTENDED_b}');
    Expect(1, 43519, '\p{ismyanmarextendedb}', "");
    Expect(0, 43519, '\p{^ismyanmarextendedb}', "");
    Expect(0, 43519, '\P{ismyanmarextendedb}', "");
    Expect(1, 43519, '\P{^ismyanmarextendedb}', "");
    Expect(0, 43520, '\p{ismyanmarextendedb}', "");
    Expect(1, 43520, '\p{^ismyanmarextendedb}', "");
    Expect(1, 43520, '\P{ismyanmarextendedb}', "");
    Expect(0, 43520, '\P{^ismyanmarextendedb}', "");
    Expect(1, 43519, '\p{- is_Myanmar_extended_B}', "");
    Expect(0, 43519, '\p{^- is_Myanmar_extended_B}', "");
    Expect(0, 43519, '\P{- is_Myanmar_extended_B}', "");
    Expect(1, 43519, '\P{^- is_Myanmar_extended_B}', "");
    Expect(0, 43520, '\p{- is_Myanmar_extended_B}', "");
    Expect(1, 43520, '\p{^- is_Myanmar_extended_B}', "");
    Expect(1, 43520, '\P{- is_Myanmar_extended_B}', "");
    Expect(0, 43520, '\P{^- is_Myanmar_extended_B}', "");
    Error('\p{-:=In_myanmar_EXTENDED_B}');
    Error('\P{-:=In_myanmar_EXTENDED_B}');
    Expect(1, 43519, '\p{inmyanmarextendedb}', "");
    Expect(0, 43519, '\p{^inmyanmarextendedb}', "");
    Expect(0, 43519, '\P{inmyanmarextendedb}', "");
    Expect(1, 43519, '\P{^inmyanmarextendedb}', "");
    Expect(0, 43520, '\p{inmyanmarextendedb}', "");
    Expect(1, 43520, '\p{^inmyanmarextendedb}', "");
    Expect(1, 43520, '\P{inmyanmarextendedb}', "");
    Expect(0, 43520, '\P{^inmyanmarextendedb}', "");
    Expect(1, 43519, '\p{_	In_myanmar_Extended_b}', "");
    Expect(0, 43519, '\p{^_	In_myanmar_Extended_b}', "");
    Expect(0, 43519, '\P{_	In_myanmar_Extended_b}', "");
    Expect(1, 43519, '\P{^_	In_myanmar_Extended_b}', "");
    Expect(0, 43520, '\p{_	In_myanmar_Extended_b}', "");
    Expect(1, 43520, '\p{^_	In_myanmar_Extended_b}', "");
    Expect(1, 43520, '\P{_	In_myanmar_Extended_b}', "");
    Expect(0, 43520, '\P{^_	In_myanmar_Extended_b}', "");
    Error('\p{ -Myanmar_ext_B:=}');
    Error('\P{ -Myanmar_ext_B:=}');
    Expect(1, 43519, '\p{myanmarextb}', "");
    Expect(0, 43519, '\p{^myanmarextb}', "");
    Expect(0, 43519, '\P{myanmarextb}', "");
    Expect(1, 43519, '\P{^myanmarextb}', "");
    Expect(0, 43520, '\p{myanmarextb}', "");
    Expect(1, 43520, '\p{^myanmarextb}', "");
    Expect(1, 43520, '\P{myanmarextb}', "");
    Expect(0, 43520, '\P{^myanmarextb}', "");
    Expect(1, 43519, '\p{ Myanmar_EXT_b}', "");
    Expect(0, 43519, '\p{^ Myanmar_EXT_b}', "");
    Expect(0, 43519, '\P{ Myanmar_EXT_b}', "");
    Expect(1, 43519, '\P{^ Myanmar_EXT_b}', "");
    Expect(0, 43520, '\p{ Myanmar_EXT_b}', "");
    Expect(1, 43520, '\p{^ Myanmar_EXT_b}', "");
    Expect(1, 43520, '\P{ Myanmar_EXT_b}', "");
    Expect(0, 43520, '\P{^ Myanmar_EXT_b}', "");
    Error('\p{:= Is_myanmar_ext_B}');
    Error('\P{:= Is_myanmar_ext_B}');
    Expect(1, 43519, '\p{ismyanmarextb}', "");
    Expect(0, 43519, '\p{^ismyanmarextb}', "");
    Expect(0, 43519, '\P{ismyanmarextb}', "");
    Expect(1, 43519, '\P{^ismyanmarextb}', "");
    Expect(0, 43520, '\p{ismyanmarextb}', "");
    Expect(1, 43520, '\p{^ismyanmarextb}', "");
    Expect(1, 43520, '\P{ismyanmarextb}', "");
    Expect(0, 43520, '\P{^ismyanmarextb}', "");
    Expect(1, 43519, '\p{_ Is_Myanmar_ext_B}', "");
    Expect(0, 43519, '\p{^_ Is_Myanmar_ext_B}', "");
    Expect(0, 43519, '\P{_ Is_Myanmar_ext_B}', "");
    Expect(1, 43519, '\P{^_ Is_Myanmar_ext_B}', "");
    Expect(0, 43520, '\p{_ Is_Myanmar_ext_B}', "");
    Expect(1, 43520, '\p{^_ Is_Myanmar_ext_B}', "");
    Expect(1, 43520, '\P{_ Is_Myanmar_ext_B}', "");
    Expect(0, 43520, '\P{^_ Is_Myanmar_ext_B}', "");
    Error('\p{/a/IN_myanmar_Ext_B}');
    Error('\P{/a/IN_myanmar_Ext_B}');
    Expect(1, 43519, '\p{inmyanmarextb}', "");
    Expect(0, 43519, '\p{^inmyanmarextb}', "");
    Expect(0, 43519, '\P{inmyanmarextb}', "");
    Expect(1, 43519, '\P{^inmyanmarextb}', "");
    Expect(0, 43520, '\p{inmyanmarextb}', "");
    Expect(1, 43520, '\p{^inmyanmarextb}', "");
    Expect(1, 43520, '\P{inmyanmarextb}', "");
    Expect(0, 43520, '\P{^inmyanmarextb}', "");
    Expect(1, 43519, '\p{ _in_myanmar_EXT_B}', "");
    Expect(0, 43519, '\p{^ _in_myanmar_EXT_B}', "");
    Expect(0, 43519, '\P{ _in_myanmar_EXT_B}', "");
    Expect(1, 43519, '\P{^ _in_myanmar_EXT_B}', "");
    Expect(0, 43520, '\p{ _in_myanmar_EXT_B}', "");
    Expect(1, 43520, '\p{^ _in_myanmar_EXT_B}', "");
    Expect(1, 43520, '\P{ _in_myanmar_EXT_B}', "");
    Expect(0, 43520, '\P{^ _in_myanmar_EXT_B}', "");
    Error('\p{:=-Nabataean}');
    Error('\P{:=-Nabataean}');
    Expect(1, 67759, '\p{nabataean}', "");
    Expect(0, 67759, '\p{^nabataean}', "");
    Expect(0, 67759, '\P{nabataean}', "");
    Expect(1, 67759, '\P{^nabataean}', "");
    Expect(0, 67760, '\p{nabataean}', "");
    Expect(1, 67760, '\p{^nabataean}', "");
    Expect(1, 67760, '\P{nabataean}', "");
    Expect(0, 67760, '\P{^nabataean}', "");
    Expect(1, 67759, '\p{_	nabataean}', "");
    Expect(0, 67759, '\p{^_	nabataean}', "");
    Expect(0, 67759, '\P{_	nabataean}', "");
    Expect(1, 67759, '\P{^_	nabataean}', "");
    Expect(0, 67760, '\p{_	nabataean}', "");
    Expect(1, 67760, '\p{^_	nabataean}', "");
    Expect(1, 67760, '\P{_	nabataean}', "");
    Expect(0, 67760, '\P{^_	nabataean}', "");
    Error('\p{/a/	IS_nabataean}');
    Error('\P{/a/	IS_nabataean}');
    Expect(1, 67759, '\p{isnabataean}', "");
    Expect(0, 67759, '\p{^isnabataean}', "");
    Expect(0, 67759, '\P{isnabataean}', "");
    Expect(1, 67759, '\P{^isnabataean}', "");
    Expect(0, 67760, '\p{isnabataean}', "");
    Expect(1, 67760, '\p{^isnabataean}', "");
    Expect(1, 67760, '\P{isnabataean}', "");
    Expect(0, 67760, '\P{^isnabataean}', "");
    Expect(1, 67759, '\p{	 is_nabataean}', "");
    Expect(0, 67759, '\p{^	 is_nabataean}', "");
    Expect(0, 67759, '\P{	 is_nabataean}', "");
    Expect(1, 67759, '\P{^	 is_nabataean}', "");
    Expect(0, 67760, '\p{	 is_nabataean}', "");
    Expect(1, 67760, '\p{^	 is_nabataean}', "");
    Expect(1, 67760, '\P{	 is_nabataean}', "");
    Expect(0, 67760, '\P{^	 is_nabataean}', "");
    Error('\p{_	Nbat:=}');
    Error('\P{_	Nbat:=}');
    Expect(1, 67759, '\p{nbat}', "");
    Expect(0, 67759, '\p{^nbat}', "");
    Expect(0, 67759, '\P{nbat}', "");
    Expect(1, 67759, '\P{^nbat}', "");
    Expect(0, 67760, '\p{nbat}', "");
    Expect(1, 67760, '\p{^nbat}', "");
    Expect(1, 67760, '\P{nbat}', "");
    Expect(0, 67760, '\P{^nbat}', "");
    Expect(1, 67759, '\p{-Nbat}', "");
    Expect(0, 67759, '\p{^-Nbat}', "");
    Expect(0, 67759, '\P{-Nbat}', "");
    Expect(1, 67759, '\P{^-Nbat}', "");
    Expect(0, 67760, '\p{-Nbat}', "");
    Expect(1, 67760, '\p{^-Nbat}', "");
    Expect(1, 67760, '\P{-Nbat}', "");
    Expect(0, 67760, '\P{^-Nbat}', "");
    Error('\p{- IS_NBAT:=}');
    Error('\P{- IS_NBAT:=}');
    Expect(1, 67759, '\p{isnbat}', "");
    Expect(0, 67759, '\p{^isnbat}', "");
    Expect(0, 67759, '\P{isnbat}', "");
    Expect(1, 67759, '\P{^isnbat}', "");
    Expect(0, 67760, '\p{isnbat}', "");
    Expect(1, 67760, '\p{^isnbat}', "");
    Expect(1, 67760, '\P{isnbat}', "");
    Expect(0, 67760, '\P{^isnbat}', "");
    Expect(1, 67759, '\p{-	is_nbat}', "");
    Expect(0, 67759, '\p{^-	is_nbat}', "");
    Expect(0, 67759, '\P{-	is_nbat}', "");
    Expect(1, 67759, '\P{^-	is_nbat}', "");
    Expect(0, 67760, '\p{-	is_nbat}', "");
    Expect(1, 67760, '\p{^-	is_nbat}', "");
    Expect(1, 67760, '\P{-	is_nbat}', "");
    Expect(0, 67760, '\P{^-	is_nbat}', "");
    Error('\p{  nandinagari/a/}');
    Error('\P{  nandinagari/a/}');
    Expect(1, 72164, '\p{nandinagari}', "");
    Expect(0, 72164, '\p{^nandinagari}', "");
    Expect(0, 72164, '\P{nandinagari}', "");
    Expect(1, 72164, '\P{^nandinagari}', "");
    Expect(0, 72165, '\p{nandinagari}', "");
    Expect(1, 72165, '\p{^nandinagari}', "");
    Expect(1, 72165, '\P{nandinagari}', "");
    Expect(0, 72165, '\P{^nandinagari}', "");
    Expect(1, 72164, '\p{  Nandinagari}', "");
    Expect(0, 72164, '\p{^  Nandinagari}', "");
    Expect(0, 72164, '\P{  Nandinagari}', "");
    Expect(1, 72164, '\P{^  Nandinagari}', "");
    Expect(0, 72165, '\p{  Nandinagari}', "");
    Expect(1, 72165, '\p{^  Nandinagari}', "");
    Expect(1, 72165, '\P{  Nandinagari}', "");
    Expect(0, 72165, '\P{^  Nandinagari}', "");
    Error('\p{-_Is_nandinagari:=}');
    Error('\P{-_Is_nandinagari:=}');
    Expect(1, 72164, '\p{isnandinagari}', "");
    Expect(0, 72164, '\p{^isnandinagari}', "");
    Expect(0, 72164, '\P{isnandinagari}', "");
    Expect(1, 72164, '\P{^isnandinagari}', "");
    Expect(0, 72165, '\p{isnandinagari}', "");
    Expect(1, 72165, '\p{^isnandinagari}', "");
    Expect(1, 72165, '\P{isnandinagari}', "");
    Expect(0, 72165, '\P{^isnandinagari}', "");
    Expect(1, 72164, '\p{_Is_Nandinagari}', "");
    Expect(0, 72164, '\p{^_Is_Nandinagari}', "");
    Expect(0, 72164, '\P{_Is_Nandinagari}', "");
    Expect(1, 72164, '\P{^_Is_Nandinagari}', "");
    Expect(0, 72165, '\p{_Is_Nandinagari}', "");
    Expect(1, 72165, '\p{^_Is_Nandinagari}', "");
    Expect(1, 72165, '\P{_Is_Nandinagari}', "");
    Expect(0, 72165, '\P{^_Is_Nandinagari}', "");
    Error('\p{/a/  nand}');
    Error('\P{/a/  nand}');
    Expect(1, 72164, '\p{nand}', "");
    Expect(0, 72164, '\p{^nand}', "");
    Expect(0, 72164, '\P{nand}', "");
    Expect(1, 72164, '\P{^nand}', "");
    Expect(0, 72165, '\p{nand}', "");
    Expect(1, 72165, '\p{^nand}', "");
    Expect(1, 72165, '\P{nand}', "");
    Expect(0, 72165, '\P{^nand}', "");
    Expect(1, 72164, '\p{-NAND}', "");
    Expect(0, 72164, '\p{^-NAND}', "");
    Expect(0, 72164, '\P{-NAND}', "");
    Expect(1, 72164, '\P{^-NAND}', "");
    Expect(0, 72165, '\p{-NAND}', "");
    Expect(1, 72165, '\p{^-NAND}', "");
    Expect(1, 72165, '\P{-NAND}', "");
    Expect(0, 72165, '\P{^-NAND}', "");
    Error('\p{/a/-Is_Nand}');
    Error('\P{/a/-Is_Nand}');
    Expect(1, 72164, '\p{isnand}', "");
    Expect(0, 72164, '\p{^isnand}', "");
    Expect(0, 72164, '\P{isnand}', "");
    Expect(1, 72164, '\P{^isnand}', "");
    Expect(0, 72165, '\p{isnand}', "");
    Expect(1, 72165, '\p{^isnand}', "");
    Expect(1, 72165, '\P{isnand}', "");
    Expect(0, 72165, '\P{^isnand}', "");
    Expect(1, 72164, '\p{ _is_NAND}', "");
    Expect(0, 72164, '\p{^ _is_NAND}', "");
    Expect(0, 72164, '\P{ _is_NAND}', "");
    Expect(1, 72164, '\P{^ _is_NAND}', "");
    Expect(0, 72165, '\p{ _is_NAND}', "");
    Expect(1, 72165, '\p{^ _is_NAND}', "");
    Expect(1, 72165, '\P{ _is_NAND}', "");
    Expect(0, 72165, '\P{^ _is_NAND}', "");
    Error('\p{:=_	New_tai_Lue}');
    Error('\P{:=_	New_tai_Lue}');
    Expect(1, 6623, '\p{newtailue}', "");
    Expect(0, 6623, '\p{^newtailue}', "");
    Expect(0, 6623, '\P{newtailue}', "");
    Expect(1, 6623, '\P{^newtailue}', "");
    Expect(0, 6624, '\p{newtailue}', "");
    Expect(1, 6624, '\p{^newtailue}', "");
    Expect(1, 6624, '\P{newtailue}', "");
    Expect(0, 6624, '\P{^newtailue}', "");
    Expect(1, 6623, '\p{-New_tai_Lue}', "");
    Expect(0, 6623, '\p{^-New_tai_Lue}', "");
    Expect(0, 6623, '\P{-New_tai_Lue}', "");
    Expect(1, 6623, '\P{^-New_tai_Lue}', "");
    Expect(0, 6624, '\p{-New_tai_Lue}', "");
    Expect(1, 6624, '\p{^-New_tai_Lue}', "");
    Expect(1, 6624, '\P{-New_tai_Lue}', "");
    Expect(0, 6624, '\P{^-New_tai_Lue}', "");
    Error('\p{/a/	 IS_NEW_tai_LUE}');
    Error('\P{/a/	 IS_NEW_tai_LUE}');
    Expect(1, 6623, '\p{isnewtailue}', "");
    Expect(0, 6623, '\p{^isnewtailue}', "");
    Expect(0, 6623, '\P{isnewtailue}', "");
    Expect(1, 6623, '\P{^isnewtailue}', "");
    Expect(0, 6624, '\p{isnewtailue}', "");
    Expect(1, 6624, '\p{^isnewtailue}', "");
    Expect(1, 6624, '\P{isnewtailue}', "");
    Expect(0, 6624, '\P{^isnewtailue}', "");
    Expect(1, 6623, '\p{__is_New_TAI_Lue}', "");
    Expect(0, 6623, '\p{^__is_New_TAI_Lue}', "");
    Expect(0, 6623, '\P{__is_New_TAI_Lue}', "");
    Expect(1, 6623, '\P{^__is_New_TAI_Lue}', "");
    Expect(0, 6624, '\p{__is_New_TAI_Lue}', "");
    Expect(1, 6624, '\p{^__is_New_TAI_Lue}', "");
    Expect(1, 6624, '\P{__is_New_TAI_Lue}', "");
    Expect(0, 6624, '\P{^__is_New_TAI_Lue}', "");
    Error('\p{  TALU/a/}');
    Error('\P{  TALU/a/}');
    Expect(1, 6623, '\p{talu}', "");
    Expect(0, 6623, '\p{^talu}', "");
    Expect(0, 6623, '\P{talu}', "");
    Expect(1, 6623, '\P{^talu}', "");
    Expect(0, 6624, '\p{talu}', "");
    Expect(1, 6624, '\p{^talu}', "");
    Expect(1, 6624, '\P{talu}', "");
    Expect(0, 6624, '\P{^talu}', "");
    Expect(1, 6623, '\p{	Talu}', "");
    Expect(0, 6623, '\p{^	Talu}', "");
    Expect(0, 6623, '\P{	Talu}', "");
    Expect(1, 6623, '\P{^	Talu}', "");
    Expect(0, 6624, '\p{	Talu}', "");
    Expect(1, 6624, '\p{^	Talu}', "");
    Expect(1, 6624, '\P{	Talu}', "");
    Expect(0, 6624, '\P{^	Talu}', "");
    Error('\p{- Is_Talu/a/}');
    Error('\P{- Is_Talu/a/}');
    Expect(1, 6623, '\p{istalu}', "");
    Expect(0, 6623, '\p{^istalu}', "");
    Expect(0, 6623, '\P{istalu}', "");
    Expect(1, 6623, '\P{^istalu}', "");
    Expect(0, 6624, '\p{istalu}', "");
    Expect(1, 6624, '\p{^istalu}', "");
    Expect(1, 6624, '\P{istalu}', "");
    Expect(0, 6624, '\P{^istalu}', "");
    Expect(1, 6623, '\p{-Is_Talu}', "");
    Expect(0, 6623, '\p{^-Is_Talu}', "");
    Expect(0, 6623, '\P{-Is_Talu}', "");
    Expect(1, 6623, '\P{^-Is_Talu}', "");
    Expect(0, 6624, '\p{-Is_Talu}', "");
    Expect(1, 6624, '\p{^-Is_Talu}', "");
    Expect(1, 6624, '\P{-Is_Talu}', "");
    Expect(0, 6624, '\P{^-Is_Talu}', "");
    Error('\p{:=	newa}');
    Error('\P{:=	newa}');
    Expect(1, 70751, '\p{newa}', "");
    Expect(0, 70751, '\p{^newa}', "");
    Expect(0, 70751, '\P{newa}', "");
    Expect(1, 70751, '\P{^newa}', "");
    Expect(0, 70752, '\p{newa}', "");
    Expect(1, 70752, '\p{^newa}', "");
    Expect(1, 70752, '\P{newa}', "");
    Expect(0, 70752, '\P{^newa}', "");
    Expect(1, 70751, '\p{_-Newa}', "");
    Expect(0, 70751, '\p{^_-Newa}', "");
    Expect(0, 70751, '\P{_-Newa}', "");
    Expect(1, 70751, '\P{^_-Newa}', "");
    Expect(0, 70752, '\p{_-Newa}', "");
    Expect(1, 70752, '\p{^_-Newa}', "");
    Expect(1, 70752, '\P{_-Newa}', "");
    Expect(0, 70752, '\P{^_-Newa}', "");
    Error('\p{:= _IS_newa}');
    Error('\P{:= _IS_newa}');
    Expect(1, 70751, '\p{isnewa}', "");
    Expect(0, 70751, '\p{^isnewa}', "");
    Expect(0, 70751, '\P{isnewa}', "");
    Expect(1, 70751, '\P{^isnewa}', "");
    Expect(0, 70752, '\p{isnewa}', "");
    Expect(1, 70752, '\p{^isnewa}', "");
    Expect(1, 70752, '\P{isnewa}', "");
    Expect(0, 70752, '\P{^isnewa}', "");
    Expect(1, 70751, '\p{__is_NEWA}', "");
    Expect(0, 70751, '\p{^__is_NEWA}', "");
    Expect(0, 70751, '\P{__is_NEWA}', "");
    Expect(1, 70751, '\P{^__is_NEWA}', "");
    Expect(0, 70752, '\p{__is_NEWA}', "");
    Expect(1, 70752, '\p{^__is_NEWA}', "");
    Expect(1, 70752, '\P{__is_NEWA}', "");
    Expect(0, 70752, '\P{^__is_NEWA}', "");
    Error('\p{ /a/nko}');
    Error('\P{ /a/nko}');
    Expect(1, 2047, '\p{nko}', "");
    Expect(0, 2047, '\p{^nko}', "");
    Expect(0, 2047, '\P{nko}', "");
    Expect(1, 2047, '\P{^nko}', "");
    Expect(0, 2048, '\p{nko}', "");
    Expect(1, 2048, '\p{^nko}', "");
    Expect(1, 2048, '\P{nko}', "");
    Expect(0, 2048, '\P{^nko}', "");
    Expect(1, 2047, '\p{-nko}', "");
    Expect(0, 2047, '\p{^-nko}', "");
    Expect(0, 2047, '\P{-nko}', "");
    Expect(1, 2047, '\P{^-nko}', "");
    Expect(0, 2048, '\p{-nko}', "");
    Expect(1, 2048, '\p{^-nko}', "");
    Expect(1, 2048, '\P{-nko}', "");
    Expect(0, 2048, '\P{^-nko}', "");
    Error('\p{ /a/is_nko}');
    Error('\P{ /a/is_nko}');
    Expect(1, 2047, '\p{isnko}', "");
    Expect(0, 2047, '\p{^isnko}', "");
    Expect(0, 2047, '\P{isnko}', "");
    Expect(1, 2047, '\P{^isnko}', "");
    Expect(0, 2048, '\p{isnko}', "");
    Expect(1, 2048, '\p{^isnko}', "");
    Expect(1, 2048, '\P{isnko}', "");
    Expect(0, 2048, '\P{^isnko}', "");
    Expect(1, 2047, '\p{	 Is_nko}', "");
    Expect(0, 2047, '\p{^	 Is_nko}', "");
    Expect(0, 2047, '\P{	 Is_nko}', "");
    Expect(1, 2047, '\P{^	 Is_nko}', "");
    Expect(0, 2048, '\p{	 Is_nko}', "");
    Expect(1, 2048, '\p{^	 Is_nko}', "");
    Expect(1, 2048, '\P{	 Is_nko}', "");
    Expect(0, 2048, '\P{^	 Is_nko}', "");
    Error('\p{_:=Nkoo}');
    Error('\P{_:=Nkoo}');
    Expect(1, 2047, '\p{nkoo}', "");
    Expect(0, 2047, '\p{^nkoo}', "");
    Expect(0, 2047, '\P{nkoo}', "");
    Expect(1, 2047, '\P{^nkoo}', "");
    Expect(0, 2048, '\p{nkoo}', "");
    Expect(1, 2048, '\p{^nkoo}', "");
    Expect(1, 2048, '\P{nkoo}', "");
    Expect(0, 2048, '\P{^nkoo}', "");
    Expect(1, 2047, '\p{_ NKOO}', "");
    Expect(0, 2047, '\p{^_ NKOO}', "");
    Expect(0, 2047, '\P{_ NKOO}', "");
    Expect(1, 2047, '\P{^_ NKOO}', "");
    Expect(0, 2048, '\p{_ NKOO}', "");
    Expect(1, 2048, '\p{^_ NKOO}', "");
    Expect(1, 2048, '\P{_ NKOO}', "");
    Expect(0, 2048, '\P{^_ NKOO}', "");
    Error('\p{  is_nkoo:=}');
    Error('\P{  is_nkoo:=}');
    Expect(1, 2047, '\p{isnkoo}', "");
    Expect(0, 2047, '\p{^isnkoo}', "");
    Expect(0, 2047, '\P{isnkoo}', "");
    Expect(1, 2047, '\P{^isnkoo}', "");
    Expect(0, 2048, '\p{isnkoo}', "");
    Expect(1, 2048, '\p{^isnkoo}', "");
    Expect(1, 2048, '\P{isnkoo}', "");
    Expect(0, 2048, '\P{^isnkoo}', "");
    Expect(1, 2047, '\p{_-IS_NKOO}', "");
    Expect(0, 2047, '\p{^_-IS_NKOO}', "");
    Expect(0, 2047, '\P{_-IS_NKOO}', "");
    Expect(1, 2047, '\P{^_-IS_NKOO}', "");
    Expect(0, 2048, '\p{_-IS_NKOO}', "");
    Expect(1, 2048, '\p{^_-IS_NKOO}', "");
    Expect(1, 2048, '\P{_-IS_NKOO}', "");
    Expect(0, 2048, '\P{^_-IS_NKOO}', "");
    Error('\p{	/a/no_Block}');
    Error('\P{	/a/no_Block}');
    Expect(1, 918000, '\p{noblock}', "");
    Expect(0, 918000, '\p{^noblock}', "");
    Expect(0, 918000, '\P{noblock}', "");
    Expect(1, 918000, '\P{^noblock}', "");
    Expect(0, 983040, '\p{noblock}', "");
    Expect(1, 983040, '\p{^noblock}', "");
    Expect(1, 983040, '\P{noblock}', "");
    Expect(0, 983040, '\P{^noblock}', "");
    Expect(1, 918000, '\p{-	no_Block}', "");
    Expect(0, 918000, '\p{^-	no_Block}', "");
    Expect(0, 918000, '\P{-	no_Block}', "");
    Expect(1, 918000, '\P{^-	no_Block}', "");
    Expect(0, 983040, '\p{-	no_Block}', "");
    Expect(1, 983040, '\p{^-	no_Block}', "");
    Expect(1, 983040, '\P{-	no_Block}', "");
    Expect(0, 983040, '\P{^-	no_Block}', "");
    Error('\p{-Is_No_Block:=}');
    Error('\P{-Is_No_Block:=}');
    Expect(1, 918000, '\p{isnoblock}', "");
    Expect(0, 918000, '\p{^isnoblock}', "");
    Expect(0, 918000, '\P{isnoblock}', "");
    Expect(1, 918000, '\P{^isnoblock}', "");
    Expect(0, 983040, '\p{isnoblock}', "");
    Expect(1, 983040, '\p{^isnoblock}', "");
    Expect(1, 983040, '\P{isnoblock}', "");
    Expect(0, 983040, '\P{^isnoblock}', "");
    Expect(1, 918000, '\p{_Is_NO_Block}', "");
    Expect(0, 918000, '\p{^_Is_NO_Block}', "");
    Expect(0, 918000, '\P{_Is_NO_Block}', "");
    Expect(1, 918000, '\P{^_Is_NO_Block}', "");
    Expect(0, 983040, '\p{_Is_NO_Block}', "");
    Expect(1, 983040, '\p{^_Is_NO_Block}', "");
    Expect(1, 983040, '\P{_Is_NO_Block}', "");
    Expect(0, 983040, '\P{^_Is_NO_Block}', "");
    Error('\p{_	in_No_Block:=}');
    Error('\P{_	in_No_Block:=}');
    Expect(1, 918000, '\p{innoblock}', "");
    Expect(0, 918000, '\p{^innoblock}', "");
    Expect(0, 918000, '\P{innoblock}', "");
    Expect(1, 918000, '\P{^innoblock}', "");
    Expect(0, 983040, '\p{innoblock}', "");
    Expect(1, 983040, '\p{^innoblock}', "");
    Expect(1, 983040, '\P{innoblock}', "");
    Expect(0, 983040, '\P{^innoblock}', "");
    Expect(1, 918000, '\p{__IN_NO_Block}', "");
    Expect(0, 918000, '\p{^__IN_NO_Block}', "");
    Expect(0, 918000, '\P{__IN_NO_Block}', "");
    Expect(1, 918000, '\P{^__IN_NO_Block}', "");
    Expect(0, 983040, '\p{__IN_NO_Block}', "");
    Expect(1, 983040, '\p{^__IN_NO_Block}', "");
    Expect(1, 983040, '\P{__IN_NO_Block}', "");
    Expect(0, 983040, '\P{^__IN_NO_Block}', "");
    Error('\p{:=_ NB}');
    Error('\P{:=_ NB}');
    Expect(1, 918000, '\p{nb}', "");
    Expect(0, 918000, '\p{^nb}', "");
    Expect(0, 918000, '\P{nb}', "");
    Expect(1, 918000, '\P{^nb}', "");
    Expect(0, 983040, '\p{nb}', "");
    Expect(1, 983040, '\p{^nb}', "");
    Expect(1, 983040, '\P{nb}', "");
    Expect(0, 983040, '\P{^nb}', "");
    Expect(1, 918000, '\p{_NB}', "");
    Expect(0, 918000, '\p{^_NB}', "");
    Expect(0, 918000, '\P{_NB}', "");
    Expect(1, 918000, '\P{^_NB}', "");
    Expect(0, 983040, '\p{_NB}', "");
    Expect(1, 983040, '\p{^_NB}', "");
    Expect(1, 983040, '\P{_NB}', "");
    Expect(0, 983040, '\P{^_NB}', "");
    Error('\p{-Is_NB/a/}');
    Error('\P{-Is_NB/a/}');
    Expect(1, 918000, '\p{isnb}', "");
    Expect(0, 918000, '\p{^isnb}', "");
    Expect(0, 918000, '\P{isnb}', "");
    Expect(1, 918000, '\P{^isnb}', "");
    Expect(0, 983040, '\p{isnb}', "");
    Expect(1, 983040, '\p{^isnb}', "");
    Expect(1, 983040, '\P{isnb}', "");
    Expect(0, 983040, '\P{^isnb}', "");
    Expect(1, 918000, '\p{	Is_nb}', "");
    Expect(0, 918000, '\p{^	Is_nb}', "");
    Expect(0, 918000, '\P{	Is_nb}', "");
    Expect(1, 918000, '\P{^	Is_nb}', "");
    Expect(0, 983040, '\p{	Is_nb}', "");
    Expect(1, 983040, '\p{^	Is_nb}', "");
    Expect(1, 983040, '\P{	Is_nb}', "");
    Expect(0, 983040, '\P{^	Is_nb}', "");
    Error('\p{_/a/in_NB}');
    Error('\P{_/a/in_NB}');
    Expect(1, 918000, '\p{innb}', "");
    Expect(0, 918000, '\p{^innb}', "");
    Expect(0, 918000, '\P{innb}', "");
    Expect(1, 918000, '\P{^innb}', "");
    Expect(0, 983040, '\p{innb}', "");
    Expect(1, 983040, '\p{^innb}', "");
    Expect(1, 983040, '\P{innb}', "");
    Expect(0, 983040, '\P{^innb}', "");
    Expect(1, 918000, '\p{__In_NB}', "");
    Expect(0, 918000, '\p{^__In_NB}', "");
    Expect(0, 918000, '\P{__In_NB}', "");
    Expect(1, 918000, '\P{^__In_NB}', "");
    Expect(0, 983040, '\p{__In_NB}', "");
    Expect(1, 983040, '\p{^__In_NB}', "");
    Expect(1, 983040, '\P{__In_NB}', "");
    Expect(0, 983040, '\P{^__In_NB}', "");
    Error('\p{-noncharacter_Code_point/a/}');
    Error('\P{-noncharacter_Code_point/a/}');
    Expect(1, 1114111, '\p{noncharactercodepoint}', "");
    Expect(0, 1114111, '\p{^noncharactercodepoint}', "");
    Expect(0, 1114111, '\P{noncharactercodepoint}', "");
    Expect(1, 1114111, '\P{^noncharactercodepoint}', "");
    Expect(0, 1114109, '\p{noncharactercodepoint}', "");
    Expect(1, 1114109, '\p{^noncharactercodepoint}', "");
    Expect(1, 1114109, '\P{noncharactercodepoint}', "");
    Expect(0, 1114109, '\P{^noncharactercodepoint}', "");
    Expect(1, 1114111, '\p{	noncharacter_Code_point}', "");
    Expect(0, 1114111, '\p{^	noncharacter_Code_point}', "");
    Expect(0, 1114111, '\P{	noncharacter_Code_point}', "");
    Expect(1, 1114111, '\P{^	noncharacter_Code_point}', "");
    Expect(0, 1114109, '\p{	noncharacter_Code_point}', "");
    Expect(1, 1114109, '\p{^	noncharacter_Code_point}', "");
    Expect(1, 1114109, '\P{	noncharacter_Code_point}', "");
    Expect(0, 1114109, '\P{^	noncharacter_Code_point}', "");
    Error('\p{_ is_Noncharacter_code_point:=}');
    Error('\P{_ is_Noncharacter_code_point:=}');
    Expect(1, 1114111, '\p{isnoncharactercodepoint}', "");
    Expect(0, 1114111, '\p{^isnoncharactercodepoint}', "");
    Expect(0, 1114111, '\P{isnoncharactercodepoint}', "");
    Expect(1, 1114111, '\P{^isnoncharactercodepoint}', "");
    Expect(0, 1114109, '\p{isnoncharactercodepoint}', "");
    Expect(1, 1114109, '\p{^isnoncharactercodepoint}', "");
    Expect(1, 1114109, '\P{isnoncharactercodepoint}', "");
    Expect(0, 1114109, '\P{^isnoncharactercodepoint}', "");
    Expect(1, 1114111, '\p{-is_Noncharacter_Code_point}', "");
    Expect(0, 1114111, '\p{^-is_Noncharacter_Code_point}', "");
    Expect(0, 1114111, '\P{-is_Noncharacter_Code_point}', "");
    Expect(1, 1114111, '\P{^-is_Noncharacter_Code_point}', "");
    Expect(0, 1114109, '\p{-is_Noncharacter_Code_point}', "");
    Expect(1, 1114109, '\p{^-is_Noncharacter_Code_point}', "");
    Expect(1, 1114109, '\P{-is_Noncharacter_Code_point}', "");
    Expect(0, 1114109, '\P{^-is_Noncharacter_Code_point}', "");
    Error('\p{-nchar/a/}');
    Error('\P{-nchar/a/}');
    Expect(1, 1114111, '\p{nchar}', "");
    Expect(0, 1114111, '\p{^nchar}', "");
    Expect(0, 1114111, '\P{nchar}', "");
    Expect(1, 1114111, '\P{^nchar}', "");
    Expect(0, 1114109, '\p{nchar}', "");
    Expect(1, 1114109, '\p{^nchar}', "");
    Expect(1, 1114109, '\P{nchar}', "");
    Expect(0, 1114109, '\P{^nchar}', "");
    Expect(1, 1114111, '\p{-_NChar}', "");
    Expect(0, 1114111, '\p{^-_NChar}', "");
    Expect(0, 1114111, '\P{-_NChar}', "");
    Expect(1, 1114111, '\P{^-_NChar}', "");
    Expect(0, 1114109, '\p{-_NChar}', "");
    Expect(1, 1114109, '\p{^-_NChar}', "");
    Expect(1, 1114109, '\P{-_NChar}', "");
    Expect(0, 1114109, '\P{^-_NChar}', "");
    Error('\p{	Is_NChar/a/}');
    Error('\P{	Is_NChar/a/}');
    Expect(1, 1114111, '\p{isnchar}', "");
    Expect(0, 1114111, '\p{^isnchar}', "");
    Expect(0, 1114111, '\P{isnchar}', "");
    Expect(1, 1114111, '\P{^isnchar}', "");
    Expect(0, 1114109, '\p{isnchar}', "");
    Expect(1, 1114109, '\p{^isnchar}', "");
    Expect(1, 1114109, '\P{isnchar}', "");
    Expect(0, 1114109, '\P{^isnchar}', "");
    Expect(1, 1114111, '\p{_is_nchar}', "");
    Expect(0, 1114111, '\p{^_is_nchar}', "");
    Expect(0, 1114111, '\P{_is_nchar}', "");
    Expect(1, 1114111, '\P{^_is_nchar}', "");
    Expect(0, 1114109, '\p{_is_nchar}', "");
    Expect(1, 1114109, '\p{^_is_nchar}', "");
    Expect(1, 1114109, '\P{_is_nchar}', "");
    Expect(0, 1114109, '\P{^_is_nchar}', "");
    Error('\p{	-Nonspacing_Mark/a/}');
    Error('\P{	-Nonspacing_Mark/a/}');
    Expect(1, 917999, '\p{nonspacingmark}', "");
    Expect(0, 917999, '\p{^nonspacingmark}', "");
    Expect(0, 917999, '\P{nonspacingmark}', "");
    Expect(1, 917999, '\P{^nonspacingmark}', "");
    Expect(0, 918000, '\p{nonspacingmark}', "");
    Expect(1, 918000, '\p{^nonspacingmark}', "");
    Expect(1, 918000, '\P{nonspacingmark}', "");
    Expect(0, 918000, '\P{^nonspacingmark}', "");
    Expect(1, 917999, '\p{-Nonspacing_mark}', "");
    Expect(0, 917999, '\p{^-Nonspacing_mark}', "");
    Expect(0, 917999, '\P{-Nonspacing_mark}', "");
    Expect(1, 917999, '\P{^-Nonspacing_mark}', "");
    Expect(0, 918000, '\p{-Nonspacing_mark}', "");
    Expect(1, 918000, '\p{^-Nonspacing_mark}', "");
    Expect(1, 918000, '\P{-Nonspacing_mark}', "");
    Expect(0, 918000, '\P{^-Nonspacing_mark}', "");
    Error('\p{/a/--Is_NONSPACING_mark}');
    Error('\P{/a/--Is_NONSPACING_mark}');
    Expect(1, 917999, '\p{isnonspacingmark}', "");
    Expect(0, 917999, '\p{^isnonspacingmark}', "");
    Expect(0, 917999, '\P{isnonspacingmark}', "");
    Expect(1, 917999, '\P{^isnonspacingmark}', "");
    Expect(0, 918000, '\p{isnonspacingmark}', "");
    Expect(1, 918000, '\p{^isnonspacingmark}', "");
    Expect(1, 918000, '\P{isnonspacingmark}', "");
    Expect(0, 918000, '\P{^isnonspacingmark}', "");
    Expect(1, 917999, '\p{-Is_Nonspacing_mark}', "");
    Expect(0, 917999, '\p{^-Is_Nonspacing_mark}', "");
    Expect(0, 917999, '\P{-Is_Nonspacing_mark}', "");
    Expect(1, 917999, '\P{^-Is_Nonspacing_mark}', "");
    Expect(0, 918000, '\p{-Is_Nonspacing_mark}', "");
    Expect(1, 918000, '\p{^-Is_Nonspacing_mark}', "");
    Expect(1, 918000, '\P{-Is_Nonspacing_mark}', "");
    Expect(0, 918000, '\P{^-Is_Nonspacing_mark}', "");
    Error('\p{  Mn/a/}');
    Error('\P{  Mn/a/}');
    Expect(1, 917999, '\p{mn}', "");
    Expect(0, 917999, '\p{^mn}', "");
    Expect(0, 917999, '\P{mn}', "");
    Expect(1, 917999, '\P{^mn}', "");
    Expect(0, 918000, '\p{mn}', "");
    Expect(1, 918000, '\p{^mn}', "");
    Expect(1, 918000, '\P{mn}', "");
    Expect(0, 918000, '\P{^mn}', "");
    Expect(1, 917999, '\p{	MN}', "");
    Expect(0, 917999, '\p{^	MN}', "");
    Expect(0, 917999, '\P{	MN}', "");
    Expect(1, 917999, '\P{^	MN}', "");
    Expect(0, 918000, '\p{	MN}', "");
    Expect(1, 918000, '\p{^	MN}', "");
    Expect(1, 918000, '\P{	MN}', "");
    Expect(0, 918000, '\P{^	MN}', "");
    Error('\p{_is_Mn/a/}');
    Error('\P{_is_Mn/a/}');
    Expect(1, 917999, '\p{ismn}', "");
    Expect(0, 917999, '\p{^ismn}', "");
    Expect(0, 917999, '\P{ismn}', "");
    Expect(1, 917999, '\P{^ismn}', "");
    Expect(0, 918000, '\p{ismn}', "");
    Expect(1, 918000, '\p{^ismn}', "");
    Expect(1, 918000, '\P{ismn}', "");
    Expect(0, 918000, '\P{^ismn}', "");
    Expect(1, 917999, '\p{	 Is_mn}', "");
    Expect(0, 917999, '\p{^	 Is_mn}', "");
    Expect(0, 917999, '\P{	 Is_mn}', "");
    Expect(1, 917999, '\P{^	 Is_mn}', "");
    Expect(0, 918000, '\p{	 Is_mn}', "");
    Expect(1, 918000, '\p{^	 Is_mn}', "");
    Expect(1, 918000, '\P{	 Is_mn}', "");
    Expect(0, 918000, '\P{^	 Is_mn}', "");
    Error('\p{	/a/Number}');
    Error('\P{	/a/Number}');
    Expect(1, 127244, '\p{number}', "");
    Expect(0, 127244, '\p{^number}', "");
    Expect(0, 127244, '\P{number}', "");
    Expect(1, 127244, '\P{^number}', "");
    Expect(0, 127245, '\p{number}', "");
    Expect(1, 127245, '\p{^number}', "");
    Expect(1, 127245, '\P{number}', "");
    Expect(0, 127245, '\P{^number}', "");
    Expect(1, 127244, '\p{- NUMBER}', "");
    Expect(0, 127244, '\p{^- NUMBER}', "");
    Expect(0, 127244, '\P{- NUMBER}', "");
    Expect(1, 127244, '\P{^- NUMBER}', "");
    Expect(0, 127245, '\p{- NUMBER}', "");
    Expect(1, 127245, '\p{^- NUMBER}', "");
    Expect(1, 127245, '\P{- NUMBER}', "");
    Expect(0, 127245, '\P{^- NUMBER}', "");
    Error('\p{/a/- Is_Number}');
    Error('\P{/a/- Is_Number}');
    Expect(1, 127244, '\p{isnumber}', "");
    Expect(0, 127244, '\p{^isnumber}', "");
    Expect(0, 127244, '\P{isnumber}', "");
    Expect(1, 127244, '\P{^isnumber}', "");
    Expect(0, 127245, '\p{isnumber}', "");
    Expect(1, 127245, '\p{^isnumber}', "");
    Expect(1, 127245, '\P{isnumber}', "");
    Expect(0, 127245, '\P{^isnumber}', "");
    Expect(1, 127244, '\p{_Is_number}', "");
    Expect(0, 127244, '\p{^_Is_number}', "");
    Expect(0, 127244, '\P{_Is_number}', "");
    Expect(1, 127244, '\P{^_Is_number}', "");
    Expect(0, 127245, '\p{_Is_number}', "");
    Expect(1, 127245, '\p{^_Is_number}', "");
    Expect(1, 127245, '\P{_Is_number}', "");
    Expect(0, 127245, '\P{^_Is_number}', "");
    Error('\p{/a/_-N}');
    Error('\P{/a/_-N}');
    Expect(1, 127244, '\p{n}', "");
    Expect(0, 127244, '\p{^n}', "");
    Expect(0, 127244, '\P{n}', "");
    Expect(1, 127244, '\P{^n}', "");
    Expect(0, 127245, '\p{n}', "");
    Expect(1, 127245, '\p{^n}', "");
    Expect(1, 127245, '\P{n}', "");
    Expect(0, 127245, '\P{^n}', "");
    Expect(1, 127244, '\p{ N}', "");
    Expect(0, 127244, '\p{^ N}', "");
    Expect(0, 127244, '\P{ N}', "");
    Expect(1, 127244, '\P{^ N}', "");
    Expect(0, 127245, '\p{ N}', "");
    Expect(1, 127245, '\p{^ N}', "");
    Expect(1, 127245, '\P{ N}', "");
    Expect(0, 127245, '\P{^ N}', "");
    Error('\p{ -Is_N:=}');
    Error('\P{ -Is_N:=}');
    Expect(1, 127244, '\p{isn}', "");
    Expect(0, 127244, '\p{^isn}', "");
    Expect(0, 127244, '\P{isn}', "");
    Expect(1, 127244, '\P{^isn}', "");
    Expect(0, 127245, '\p{isn}', "");
    Expect(1, 127245, '\p{^isn}', "");
    Expect(1, 127245, '\P{isn}', "");
    Expect(0, 127245, '\P{^isn}', "");
    Expect(1, 127244, '\p{ -is_N}', "");
    Expect(0, 127244, '\p{^ -is_N}', "");
    Expect(0, 127244, '\P{ -is_N}', "");
    Expect(1, 127244, '\P{^ -is_N}', "");
    Expect(0, 127245, '\p{ -is_N}', "");
    Expect(1, 127245, '\p{^ -is_N}', "");
    Expect(1, 127245, '\P{ -is_N}', "");
    Expect(0, 127245, '\P{^ -is_N}', "");
    Error('\p{:=_NUMBER_FORMS}');
    Error('\P{:=_NUMBER_FORMS}');
    Expect(1, 8591, '\p{numberforms}', "");
    Expect(0, 8591, '\p{^numberforms}', "");
    Expect(0, 8591, '\P{numberforms}', "");
    Expect(1, 8591, '\P{^numberforms}', "");
    Expect(0, 8592, '\p{numberforms}', "");
    Expect(1, 8592, '\p{^numberforms}', "");
    Expect(1, 8592, '\P{numberforms}', "");
    Expect(0, 8592, '\P{^numberforms}', "");
    Expect(1, 8591, '\p{	 Number_FORMS}', "");
    Expect(0, 8591, '\p{^	 Number_FORMS}', "");
    Expect(0, 8591, '\P{	 Number_FORMS}', "");
    Expect(1, 8591, '\P{^	 Number_FORMS}', "");
    Expect(0, 8592, '\p{	 Number_FORMS}', "");
    Expect(1, 8592, '\p{^	 Number_FORMS}', "");
    Expect(1, 8592, '\P{	 Number_FORMS}', "");
    Expect(0, 8592, '\P{^	 Number_FORMS}', "");
    Error('\p{/a/- is_NUMBER_FORMS}');
    Error('\P{/a/- is_NUMBER_FORMS}');
    Expect(1, 8591, '\p{isnumberforms}', "");
    Expect(0, 8591, '\p{^isnumberforms}', "");
    Expect(0, 8591, '\P{isnumberforms}', "");
    Expect(1, 8591, '\P{^isnumberforms}', "");
    Expect(0, 8592, '\p{isnumberforms}', "");
    Expect(1, 8592, '\p{^isnumberforms}', "");
    Expect(1, 8592, '\P{isnumberforms}', "");
    Expect(0, 8592, '\P{^isnumberforms}', "");
    Expect(1, 8591, '\p{	 Is_NUMBER_FORMS}', "");
    Expect(0, 8591, '\p{^	 Is_NUMBER_FORMS}', "");
    Expect(0, 8591, '\P{	 Is_NUMBER_FORMS}', "");
    Expect(1, 8591, '\P{^	 Is_NUMBER_FORMS}', "");
    Expect(0, 8592, '\p{	 Is_NUMBER_FORMS}', "");
    Expect(1, 8592, '\p{^	 Is_NUMBER_FORMS}', "");
    Expect(1, 8592, '\P{	 Is_NUMBER_FORMS}', "");
    Expect(0, 8592, '\P{^	 Is_NUMBER_FORMS}', "");
    Error('\p{-/a/in_Number_FORMS}');
    Error('\P{-/a/in_Number_FORMS}');
    Expect(1, 8591, '\p{innumberforms}', "");
    Expect(0, 8591, '\p{^innumberforms}', "");
    Expect(0, 8591, '\P{innumberforms}', "");
    Expect(1, 8591, '\P{^innumberforms}', "");
    Expect(0, 8592, '\p{innumberforms}', "");
    Expect(1, 8592, '\p{^innumberforms}', "");
    Expect(1, 8592, '\P{innumberforms}', "");
    Expect(0, 8592, '\P{^innumberforms}', "");
    Expect(1, 8591, '\p{-	In_NUMBER_Forms}', "");
    Expect(0, 8591, '\p{^-	In_NUMBER_Forms}', "");
    Expect(0, 8591, '\P{-	In_NUMBER_Forms}', "");
    Expect(1, 8591, '\P{^-	In_NUMBER_Forms}', "");
    Expect(0, 8592, '\p{-	In_NUMBER_Forms}', "");
    Expect(1, 8592, '\p{^-	In_NUMBER_Forms}', "");
    Expect(1, 8592, '\P{-	In_NUMBER_Forms}', "");
    Expect(0, 8592, '\P{^-	In_NUMBER_Forms}', "");
    Error('\p{ :=NUSHU}');
    Error('\P{ :=NUSHU}');
    Expect(1, 111355, '\p{nushu}', "");
    Expect(0, 111355, '\p{^nushu}', "");
    Expect(0, 111355, '\P{nushu}', "");
    Expect(1, 111355, '\P{^nushu}', "");
    Expect(0, 111356, '\p{nushu}', "");
    Expect(1, 111356, '\p{^nushu}', "");
    Expect(1, 111356, '\P{nushu}', "");
    Expect(0, 111356, '\P{^nushu}', "");
    Expect(1, 111355, '\p{_	Nushu}', "");
    Expect(0, 111355, '\p{^_	Nushu}', "");
    Expect(0, 111355, '\P{_	Nushu}', "");
    Expect(1, 111355, '\P{^_	Nushu}', "");
    Expect(0, 111356, '\p{_	Nushu}', "");
    Expect(1, 111356, '\p{^_	Nushu}', "");
    Expect(1, 111356, '\P{_	Nushu}', "");
    Expect(0, 111356, '\P{^_	Nushu}', "");
    Error('\p{:=	-is_nushu}');
    Error('\P{:=	-is_nushu}');
    Expect(1, 111355, '\p{isnushu}', "");
    Expect(0, 111355, '\p{^isnushu}', "");
    Expect(0, 111355, '\P{isnushu}', "");
    Expect(1, 111355, '\P{^isnushu}', "");
    Expect(0, 111356, '\p{isnushu}', "");
    Expect(1, 111356, '\p{^isnushu}', "");
    Expect(1, 111356, '\P{isnushu}', "");
    Expect(0, 111356, '\P{^isnushu}', "");
    Expect(1, 111355, '\p{_	is_NUSHU}', "");
    Expect(0, 111355, '\p{^_	is_NUSHU}', "");
    Expect(0, 111355, '\P{_	is_NUSHU}', "");
    Expect(1, 111355, '\P{^_	is_NUSHU}', "");
    Expect(0, 111356, '\p{_	is_NUSHU}', "");
    Expect(1, 111356, '\p{^_	is_NUSHU}', "");
    Expect(1, 111356, '\P{_	is_NUSHU}', "");
    Expect(0, 111356, '\P{^_	is_NUSHU}', "");
    Error('\p{:=Nshu}');
    Error('\P{:=Nshu}');
    Expect(1, 111355, '\p{nshu}', "");
    Expect(0, 111355, '\p{^nshu}', "");
    Expect(0, 111355, '\P{nshu}', "");
    Expect(1, 111355, '\P{^nshu}', "");
    Expect(0, 111356, '\p{nshu}', "");
    Expect(1, 111356, '\p{^nshu}', "");
    Expect(1, 111356, '\P{nshu}', "");
    Expect(0, 111356, '\P{^nshu}', "");
    Expect(1, 111355, '\p{ -nshu}', "");
    Expect(0, 111355, '\p{^ -nshu}', "");
    Expect(0, 111355, '\P{ -nshu}', "");
    Expect(1, 111355, '\P{^ -nshu}', "");
    Expect(0, 111356, '\p{ -nshu}', "");
    Expect(1, 111356, '\p{^ -nshu}', "");
    Expect(1, 111356, '\P{ -nshu}', "");
    Expect(0, 111356, '\P{^ -nshu}', "");
    Error('\p{:=	Is_nshu}');
    Error('\P{:=	Is_nshu}');
    Expect(1, 111355, '\p{isnshu}', "");
    Expect(0, 111355, '\p{^isnshu}', "");
    Expect(0, 111355, '\P{isnshu}', "");
    Expect(1, 111355, '\P{^isnshu}', "");
    Expect(0, 111356, '\p{isnshu}', "");
    Expect(1, 111356, '\p{^isnshu}', "");
    Expect(1, 111356, '\P{isnshu}', "");
    Expect(0, 111356, '\P{^isnshu}', "");
    Expect(1, 111355, '\p{  Is_nshu}', "");
    Expect(0, 111355, '\p{^  Is_nshu}', "");
    Expect(0, 111355, '\P{  Is_nshu}', "");
    Expect(1, 111355, '\P{^  Is_nshu}', "");
    Expect(0, 111356, '\p{  Is_nshu}', "");
    Expect(1, 111356, '\p{^  Is_nshu}', "");
    Expect(1, 111356, '\P{  Is_nshu}', "");
    Expect(0, 111356, '\P{^  Is_nshu}', "");
    Error('\p{_Nyiakeng_Puachue_hmong:=}');
    Error('\P{_Nyiakeng_Puachue_hmong:=}');
    Expect(1, 123215, '\p{nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{-NYIAKENG_puachue_HMONG}', "");
    Expect(0, 123215, '\p{^-NYIAKENG_puachue_HMONG}', "");
    Expect(0, 123215, '\P{-NYIAKENG_puachue_HMONG}', "");
    Expect(1, 123215, '\P{^-NYIAKENG_puachue_HMONG}', "");
    Expect(0, 123216, '\p{-NYIAKENG_puachue_HMONG}', "");
    Expect(1, 123216, '\p{^-NYIAKENG_puachue_HMONG}', "");
    Expect(1, 123216, '\P{-NYIAKENG_puachue_HMONG}', "");
    Expect(0, 123216, '\P{^-NYIAKENG_puachue_HMONG}', "");
    Error('\p{:= Is_NYIAKENG_Puachue_Hmong}');
    Error('\P{:= Is_NYIAKENG_Puachue_Hmong}');
    Expect(1, 123215, '\p{isnyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^isnyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{isnyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^isnyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{isnyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^isnyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{isnyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^isnyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{ _is_Nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123215, '\p{^ _is_Nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123215, '\P{ _is_Nyiakeng_Puachue_HMONG}', "");
    Expect(1, 123215, '\P{^ _is_Nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123216, '\p{ _is_Nyiakeng_Puachue_HMONG}', "");
    Expect(1, 123216, '\p{^ _is_Nyiakeng_Puachue_HMONG}', "");
    Expect(1, 123216, '\P{ _is_Nyiakeng_Puachue_HMONG}', "");
    Expect(0, 123216, '\P{^ _is_Nyiakeng_Puachue_HMONG}', "");
    Error('\p{:=_HMNP}');
    Error('\P{:=_HMNP}');
    Expect(1, 123215, '\p{hmnp}', "");
    Expect(0, 123215, '\p{^hmnp}', "");
    Expect(0, 123215, '\P{hmnp}', "");
    Expect(1, 123215, '\P{^hmnp}', "");
    Expect(0, 123216, '\p{hmnp}', "");
    Expect(1, 123216, '\p{^hmnp}', "");
    Expect(1, 123216, '\P{hmnp}', "");
    Expect(0, 123216, '\P{^hmnp}', "");
    Expect(1, 123215, '\p{ -HMNP}', "");
    Expect(0, 123215, '\p{^ -HMNP}', "");
    Expect(0, 123215, '\P{ -HMNP}', "");
    Expect(1, 123215, '\P{^ -HMNP}', "");
    Expect(0, 123216, '\p{ -HMNP}', "");
    Expect(1, 123216, '\p{^ -HMNP}', "");
    Expect(1, 123216, '\P{ -HMNP}', "");
    Expect(0, 123216, '\P{^ -HMNP}', "");
    Error('\p{-is_Hmnp/a/}');
    Error('\P{-is_Hmnp/a/}');
    Expect(1, 123215, '\p{ishmnp}', "");
    Expect(0, 123215, '\p{^ishmnp}', "");
    Expect(0, 123215, '\P{ishmnp}', "");
    Expect(1, 123215, '\P{^ishmnp}', "");
    Expect(0, 123216, '\p{ishmnp}', "");
    Expect(1, 123216, '\p{^ishmnp}', "");
    Expect(1, 123216, '\P{ishmnp}', "");
    Expect(0, 123216, '\P{^ishmnp}', "");
    Expect(1, 123215, '\p{_	Is_Hmnp}', "");
    Expect(0, 123215, '\p{^_	Is_Hmnp}', "");
    Expect(0, 123215, '\P{_	Is_Hmnp}', "");
    Expect(1, 123215, '\P{^_	Is_Hmnp}', "");
    Expect(0, 123216, '\p{_	Is_Hmnp}', "");
    Expect(1, 123216, '\p{^_	Is_Hmnp}', "");
    Expect(1, 123216, '\P{_	Is_Hmnp}', "");
    Expect(0, 123216, '\P{^_	Is_Hmnp}', "");
    Error('\p{/a/- ogham}');
    Error('\P{/a/- ogham}');
    Expect(1, 5788, '\p{ogham}', "");
    Expect(0, 5788, '\p{^ogham}', "");
    Expect(0, 5788, '\P{ogham}', "");
    Expect(1, 5788, '\P{^ogham}', "");
    Expect(0, 5789, '\p{ogham}', "");
    Expect(1, 5789, '\p{^ogham}', "");
    Expect(1, 5789, '\P{ogham}', "");
    Expect(0, 5789, '\P{^ogham}', "");
    Expect(1, 5788, '\p{-	Ogham}', "");
    Expect(0, 5788, '\p{^-	Ogham}', "");
    Expect(0, 5788, '\P{-	Ogham}', "");
    Expect(1, 5788, '\P{^-	Ogham}', "");
    Expect(0, 5789, '\p{-	Ogham}', "");
    Expect(1, 5789, '\p{^-	Ogham}', "");
    Expect(1, 5789, '\P{-	Ogham}', "");
    Expect(0, 5789, '\P{^-	Ogham}', "");
    Error('\p{-/a/Is_OGHAM}');
    Error('\P{-/a/Is_OGHAM}');
    Expect(1, 5788, '\p{isogham}', "");
    Expect(0, 5788, '\p{^isogham}', "");
    Expect(0, 5788, '\P{isogham}', "");
    Expect(1, 5788, '\P{^isogham}', "");
    Expect(0, 5789, '\p{isogham}', "");
    Expect(1, 5789, '\p{^isogham}', "");
    Expect(1, 5789, '\P{isogham}', "");
    Expect(0, 5789, '\P{^isogham}', "");
    Expect(1, 5788, '\p{- Is_Ogham}', "");
    Expect(0, 5788, '\p{^- Is_Ogham}', "");
    Expect(0, 5788, '\P{- Is_Ogham}', "");
    Expect(1, 5788, '\P{^- Is_Ogham}', "");
    Expect(0, 5789, '\p{- Is_Ogham}', "");
    Expect(1, 5789, '\p{^- Is_Ogham}', "");
    Expect(1, 5789, '\P{- Is_Ogham}', "");
    Expect(0, 5789, '\P{^- Is_Ogham}', "");
    Error('\p{_:=OGAM}');
    Error('\P{_:=OGAM}');
    Expect(1, 5788, '\p{ogam}', "");
    Expect(0, 5788, '\p{^ogam}', "");
    Expect(0, 5788, '\P{ogam}', "");
    Expect(1, 5788, '\P{^ogam}', "");
    Expect(0, 5789, '\p{ogam}', "");
    Expect(1, 5789, '\p{^ogam}', "");
    Expect(1, 5789, '\P{ogam}', "");
    Expect(0, 5789, '\P{^ogam}', "");
    Expect(1, 5788, '\p{	ogam}', "");
    Expect(0, 5788, '\p{^	ogam}', "");
    Expect(0, 5788, '\P{	ogam}', "");
    Expect(1, 5788, '\P{^	ogam}', "");
    Expect(0, 5789, '\p{	ogam}', "");
    Expect(1, 5789, '\p{^	ogam}', "");
    Expect(1, 5789, '\P{	ogam}', "");
    Expect(0, 5789, '\P{^	ogam}', "");
    Error('\p{/a/	IS_Ogam}');
    Error('\P{/a/	IS_Ogam}');
    Expect(1, 5788, '\p{isogam}', "");
    Expect(0, 5788, '\p{^isogam}', "");
    Expect(0, 5788, '\P{isogam}', "");
    Expect(1, 5788, '\P{^isogam}', "");
    Expect(0, 5789, '\p{isogam}', "");
    Expect(1, 5789, '\p{^isogam}', "");
    Expect(1, 5789, '\P{isogam}', "");
    Expect(0, 5789, '\P{^isogam}', "");
    Expect(1, 5788, '\p{__is_Ogam}', "");
    Expect(0, 5788, '\p{^__is_Ogam}', "");
    Expect(0, 5788, '\P{__is_Ogam}', "");
    Expect(1, 5788, '\P{^__is_Ogam}', "");
    Expect(0, 5789, '\p{__is_Ogam}', "");
    Expect(1, 5789, '\p{^__is_Ogam}', "");
    Expect(1, 5789, '\P{__is_Ogam}', "");
    Expect(0, 5789, '\P{^__is_Ogam}', "");
    Error('\p{  OL_Chiki:=}');
    Error('\P{  OL_Chiki:=}');
    Expect(1, 7295, '\p{olchiki}', "");
    Expect(0, 7295, '\p{^olchiki}', "");
    Expect(0, 7295, '\P{olchiki}', "");
    Expect(1, 7295, '\P{^olchiki}', "");
    Expect(0, 7296, '\p{olchiki}', "");
    Expect(1, 7296, '\p{^olchiki}', "");
    Expect(1, 7296, '\P{olchiki}', "");
    Expect(0, 7296, '\P{^olchiki}', "");
    Expect(1, 7295, '\p{__OL_CHIKI}', "");
    Expect(0, 7295, '\p{^__OL_CHIKI}', "");
    Expect(0, 7295, '\P{__OL_CHIKI}', "");
    Expect(1, 7295, '\P{^__OL_CHIKI}', "");
    Expect(0, 7296, '\p{__OL_CHIKI}', "");
    Expect(1, 7296, '\p{^__OL_CHIKI}', "");
    Expect(1, 7296, '\P{__OL_CHIKI}', "");
    Expect(0, 7296, '\P{^__OL_CHIKI}', "");
    Error('\p{--Is_OL_chiki/a/}');
    Error('\P{--Is_OL_chiki/a/}');
    Expect(1, 7295, '\p{isolchiki}', "");
    Expect(0, 7295, '\p{^isolchiki}', "");
    Expect(0, 7295, '\P{isolchiki}', "");
    Expect(1, 7295, '\P{^isolchiki}', "");
    Expect(0, 7296, '\p{isolchiki}', "");
    Expect(1, 7296, '\p{^isolchiki}', "");
    Expect(1, 7296, '\P{isolchiki}', "");
    Expect(0, 7296, '\P{^isolchiki}', "");
    Expect(1, 7295, '\p{ IS_ol_Chiki}', "");
    Expect(0, 7295, '\p{^ IS_ol_Chiki}', "");
    Expect(0, 7295, '\P{ IS_ol_Chiki}', "");
    Expect(1, 7295, '\P{^ IS_ol_Chiki}', "");
    Expect(0, 7296, '\p{ IS_ol_Chiki}', "");
    Expect(1, 7296, '\p{^ IS_ol_Chiki}', "");
    Expect(1, 7296, '\P{ IS_ol_Chiki}', "");
    Expect(0, 7296, '\P{^ IS_ol_Chiki}', "");
    Error('\p{ Olck/a/}');
    Error('\P{ Olck/a/}');
    Expect(1, 7295, '\p{olck}', "");
    Expect(0, 7295, '\p{^olck}', "");
    Expect(0, 7295, '\P{olck}', "");
    Expect(1, 7295, '\P{^olck}', "");
    Expect(0, 7296, '\p{olck}', "");
    Expect(1, 7296, '\p{^olck}', "");
    Expect(1, 7296, '\P{olck}', "");
    Expect(0, 7296, '\P{^olck}', "");
    Error('\p{/a/_	Is_olck}');
    Error('\P{/a/_	Is_olck}');
    Expect(1, 7295, '\p{isolck}', "");
    Expect(0, 7295, '\p{^isolck}', "");
    Expect(0, 7295, '\P{isolck}', "");
    Expect(1, 7295, '\P{^isolck}', "");
    Expect(0, 7296, '\p{isolck}', "");
    Expect(1, 7296, '\p{^isolck}', "");
    Expect(1, 7296, '\P{isolck}', "");
    Expect(0, 7296, '\P{^isolck}', "");
    Expect(1, 7295, '\p{-_Is_OLCK}', "");
    Expect(0, 7295, '\p{^-_Is_OLCK}', "");
    Expect(0, 7295, '\P{-_Is_OLCK}', "");
    Expect(1, 7295, '\P{^-_Is_OLCK}', "");
    Expect(0, 7296, '\p{-_Is_OLCK}', "");
    Expect(1, 7296, '\p{^-_Is_OLCK}', "");
    Expect(1, 7296, '\P{-_Is_OLCK}', "");
    Expect(0, 7296, '\P{^-_Is_OLCK}', "");
    Error('\p{-:=old_Hungarian}');
    Error('\P{-:=old_Hungarian}');
    Expect(1, 68863, '\p{oldhungarian}', "");
    Expect(0, 68863, '\p{^oldhungarian}', "");
    Expect(0, 68863, '\P{oldhungarian}', "");
    Expect(1, 68863, '\P{^oldhungarian}', "");
    Expect(0, 68864, '\p{oldhungarian}', "");
    Expect(1, 68864, '\p{^oldhungarian}', "");
    Expect(1, 68864, '\P{oldhungarian}', "");
    Expect(0, 68864, '\P{^oldhungarian}', "");
    Expect(1, 68863, '\p{-OLD_Hungarian}', "");
    Expect(0, 68863, '\p{^-OLD_Hungarian}', "");
    Expect(0, 68863, '\P{-OLD_Hungarian}', "");
    Expect(1, 68863, '\P{^-OLD_Hungarian}', "");
    Expect(0, 68864, '\p{-OLD_Hungarian}', "");
    Expect(1, 68864, '\p{^-OLD_Hungarian}', "");
    Expect(1, 68864, '\P{-OLD_Hungarian}', "");
    Expect(0, 68864, '\P{^-OLD_Hungarian}', "");
    Error('\p{:=_is_old_Hungarian}');
    Error('\P{:=_is_old_Hungarian}');
    Expect(1, 68863, '\p{isoldhungarian}', "");
    Expect(0, 68863, '\p{^isoldhungarian}', "");
    Expect(0, 68863, '\P{isoldhungarian}', "");
    Expect(1, 68863, '\P{^isoldhungarian}', "");
    Expect(0, 68864, '\p{isoldhungarian}', "");
    Expect(1, 68864, '\p{^isoldhungarian}', "");
    Expect(1, 68864, '\P{isoldhungarian}', "");
    Expect(0, 68864, '\P{^isoldhungarian}', "");
    Expect(1, 68863, '\p{-_Is_Old_Hungarian}', "");
    Expect(0, 68863, '\p{^-_Is_Old_Hungarian}', "");
    Expect(0, 68863, '\P{-_Is_Old_Hungarian}', "");
    Expect(1, 68863, '\P{^-_Is_Old_Hungarian}', "");
    Expect(0, 68864, '\p{-_Is_Old_Hungarian}', "");
    Expect(1, 68864, '\p{^-_Is_Old_Hungarian}', "");
    Expect(1, 68864, '\P{-_Is_Old_Hungarian}', "");
    Expect(0, 68864, '\P{^-_Is_Old_Hungarian}', "");
    Error('\p{/a/-	Hung}');
    Error('\P{/a/-	Hung}');
    Expect(1, 68863, '\p{hung}', "");
    Expect(0, 68863, '\p{^hung}', "");
    Expect(0, 68863, '\P{hung}', "");
    Expect(1, 68863, '\P{^hung}', "");
    Expect(0, 68864, '\p{hung}', "");
    Expect(1, 68864, '\p{^hung}', "");
    Expect(1, 68864, '\P{hung}', "");
    Expect(0, 68864, '\P{^hung}', "");
    Expect(1, 68863, '\p{_	HUNG}', "");
    Expect(0, 68863, '\p{^_	HUNG}', "");
    Expect(0, 68863, '\P{_	HUNG}', "");
    Expect(1, 68863, '\P{^_	HUNG}', "");
    Expect(0, 68864, '\p{_	HUNG}', "");
    Expect(1, 68864, '\p{^_	HUNG}', "");
    Expect(1, 68864, '\P{_	HUNG}', "");
    Expect(0, 68864, '\P{^_	HUNG}', "");
    Error('\p{-_is_Hung:=}');
    Error('\P{-_is_Hung:=}');
    Expect(1, 68863, '\p{ishung}', "");
    Expect(0, 68863, '\p{^ishung}', "");
    Expect(0, 68863, '\P{ishung}', "");
    Expect(1, 68863, '\P{^ishung}', "");
    Expect(0, 68864, '\p{ishung}', "");
    Expect(1, 68864, '\p{^ishung}', "");
    Expect(1, 68864, '\P{ishung}', "");
    Expect(0, 68864, '\P{^ishung}', "");
    Expect(1, 68863, '\p{	-is_hung}', "");
    Expect(0, 68863, '\p{^	-is_hung}', "");
    Expect(0, 68863, '\P{	-is_hung}', "");
    Expect(1, 68863, '\P{^	-is_hung}', "");
    Expect(0, 68864, '\p{	-is_hung}', "");
    Expect(1, 68864, '\p{^	-is_hung}', "");
    Expect(1, 68864, '\P{	-is_hung}', "");
    Expect(0, 68864, '\P{^	-is_hung}', "");
    Error('\p{/a/		OLD_ITALIC}');
    Error('\P{/a/		OLD_ITALIC}');
    Expect(1, 66351, '\p{olditalic}', "");
    Expect(0, 66351, '\p{^olditalic}', "");
    Expect(0, 66351, '\P{olditalic}', "");
    Expect(1, 66351, '\P{^olditalic}', "");
    Expect(0, 66352, '\p{olditalic}', "");
    Expect(1, 66352, '\p{^olditalic}', "");
    Expect(1, 66352, '\P{olditalic}', "");
    Expect(0, 66352, '\P{^olditalic}', "");
    Expect(1, 66351, '\p{_old_Italic}', "");
    Expect(0, 66351, '\p{^_old_Italic}', "");
    Expect(0, 66351, '\P{_old_Italic}', "");
    Expect(1, 66351, '\P{^_old_Italic}', "");
    Expect(0, 66352, '\p{_old_Italic}', "");
    Expect(1, 66352, '\p{^_old_Italic}', "");
    Expect(1, 66352, '\P{_old_Italic}', "");
    Expect(0, 66352, '\P{^_old_Italic}', "");
    Error('\p{_	is_old_italic:=}');
    Error('\P{_	is_old_italic:=}');
    Expect(1, 66351, '\p{isolditalic}', "");
    Expect(0, 66351, '\p{^isolditalic}', "");
    Expect(0, 66351, '\P{isolditalic}', "");
    Expect(1, 66351, '\P{^isolditalic}', "");
    Expect(0, 66352, '\p{isolditalic}', "");
    Expect(1, 66352, '\p{^isolditalic}', "");
    Expect(1, 66352, '\P{isolditalic}', "");
    Expect(0, 66352, '\P{^isolditalic}', "");
    Expect(1, 66351, '\p{-IS_old_Italic}', "");
    Expect(0, 66351, '\p{^-IS_old_Italic}', "");
    Expect(0, 66351, '\P{-IS_old_Italic}', "");
    Expect(1, 66351, '\P{^-IS_old_Italic}', "");
    Expect(0, 66352, '\p{-IS_old_Italic}', "");
    Expect(1, 66352, '\p{^-IS_old_Italic}', "");
    Expect(1, 66352, '\P{-IS_old_Italic}', "");
    Expect(0, 66352, '\P{^-IS_old_Italic}', "");
    Error('\p{/a/-	ITAL}');
    Error('\P{/a/-	ITAL}');
    Expect(1, 66351, '\p{ital}', "");
    Expect(0, 66351, '\p{^ital}', "");
    Expect(0, 66351, '\P{ital}', "");
    Expect(1, 66351, '\P{^ital}', "");
    Expect(0, 66352, '\p{ital}', "");
    Expect(1, 66352, '\p{^ital}', "");
    Expect(1, 66352, '\P{ital}', "");
    Expect(0, 66352, '\P{^ital}', "");
    Expect(1, 66351, '\p{--ital}', "");
    Expect(0, 66351, '\p{^--ital}', "");
    Expect(0, 66351, '\P{--ital}', "");
    Expect(1, 66351, '\P{^--ital}', "");
    Expect(0, 66352, '\p{--ital}', "");
    Expect(1, 66352, '\p{^--ital}', "");
    Expect(1, 66352, '\P{--ital}', "");
    Expect(0, 66352, '\P{^--ital}', "");
    Error('\p{-:=Is_Ital}');
    Error('\P{-:=Is_Ital}');
    Expect(1, 66351, '\p{isital}', "");
    Expect(0, 66351, '\p{^isital}', "");
    Expect(0, 66351, '\P{isital}', "");
    Expect(1, 66351, '\P{^isital}', "");
    Expect(0, 66352, '\p{isital}', "");
    Expect(1, 66352, '\p{^isital}', "");
    Expect(1, 66352, '\P{isital}', "");
    Expect(0, 66352, '\P{^isital}', "");
    Expect(1, 66351, '\p{-Is_ITAL}', "");
    Expect(0, 66351, '\p{^-Is_ITAL}', "");
    Expect(0, 66351, '\P{-Is_ITAL}', "");
    Expect(1, 66351, '\P{^-Is_ITAL}', "");
    Expect(0, 66352, '\p{-Is_ITAL}', "");
    Expect(1, 66352, '\p{^-Is_ITAL}', "");
    Expect(1, 66352, '\P{-Is_ITAL}', "");
    Expect(0, 66352, '\P{^-Is_ITAL}', "");
    Error('\p{/a/OLD_North_ARABIAN}');
    Error('\P{/a/OLD_North_ARABIAN}');
    Expect(1, 68255, '\p{oldnortharabian}', "");
    Expect(0, 68255, '\p{^oldnortharabian}', "");
    Expect(0, 68255, '\P{oldnortharabian}', "");
    Expect(1, 68255, '\P{^oldnortharabian}', "");
    Expect(0, 68256, '\p{oldnortharabian}', "");
    Expect(1, 68256, '\p{^oldnortharabian}', "");
    Expect(1, 68256, '\P{oldnortharabian}', "");
    Expect(0, 68256, '\P{^oldnortharabian}', "");
    Expect(1, 68255, '\p{_old_NORTH_arabian}', "");
    Expect(0, 68255, '\p{^_old_NORTH_arabian}', "");
    Expect(0, 68255, '\P{_old_NORTH_arabian}', "");
    Expect(1, 68255, '\P{^_old_NORTH_arabian}', "");
    Expect(0, 68256, '\p{_old_NORTH_arabian}', "");
    Expect(1, 68256, '\p{^_old_NORTH_arabian}', "");
    Expect(1, 68256, '\P{_old_NORTH_arabian}', "");
    Expect(0, 68256, '\P{^_old_NORTH_arabian}', "");
    Error('\p{_:=IS_OLD_NORTH_Arabian}');
    Error('\P{_:=IS_OLD_NORTH_Arabian}');
    Expect(1, 68255, '\p{isoldnortharabian}', "");
    Expect(0, 68255, '\p{^isoldnortharabian}', "");
    Expect(0, 68255, '\P{isoldnortharabian}', "");
    Expect(1, 68255, '\P{^isoldnortharabian}', "");
    Expect(0, 68256, '\p{isoldnortharabian}', "");
    Expect(1, 68256, '\p{^isoldnortharabian}', "");
    Expect(1, 68256, '\P{isoldnortharabian}', "");
    Expect(0, 68256, '\P{^isoldnortharabian}', "");
    Expect(1, 68255, '\p{- is_old_NORTH_arabian}', "");
    Expect(0, 68255, '\p{^- is_old_NORTH_arabian}', "");
    Expect(0, 68255, '\P{- is_old_NORTH_arabian}', "");
    Expect(1, 68255, '\P{^- is_old_NORTH_arabian}', "");
    Expect(0, 68256, '\p{- is_old_NORTH_arabian}', "");
    Expect(1, 68256, '\p{^- is_old_NORTH_arabian}', "");
    Expect(1, 68256, '\P{- is_old_NORTH_arabian}', "");
    Expect(0, 68256, '\P{^- is_old_NORTH_arabian}', "");
    Error('\p{:=-Narb}');
    Error('\P{:=-Narb}');
    Expect(1, 68255, '\p{narb}', "");
    Expect(0, 68255, '\p{^narb}', "");
    Expect(0, 68255, '\P{narb}', "");
    Expect(1, 68255, '\P{^narb}', "");
    Expect(0, 68256, '\p{narb}', "");
    Expect(1, 68256, '\p{^narb}', "");
    Expect(1, 68256, '\P{narb}', "");
    Expect(0, 68256, '\P{^narb}', "");
    Expect(1, 68255, '\p{  Narb}', "");
    Expect(0, 68255, '\p{^  Narb}', "");
    Expect(0, 68255, '\P{  Narb}', "");
    Expect(1, 68255, '\P{^  Narb}', "");
    Expect(0, 68256, '\p{  Narb}', "");
    Expect(1, 68256, '\p{^  Narb}', "");
    Expect(1, 68256, '\P{  Narb}', "");
    Expect(0, 68256, '\P{^  Narb}', "");
    Error('\p{:=	_Is_narb}');
    Error('\P{:=	_Is_narb}');
    Expect(1, 68255, '\p{isnarb}', "");
    Expect(0, 68255, '\p{^isnarb}', "");
    Expect(0, 68255, '\P{isnarb}', "");
    Expect(1, 68255, '\P{^isnarb}', "");
    Expect(0, 68256, '\p{isnarb}', "");
    Expect(1, 68256, '\p{^isnarb}', "");
    Expect(1, 68256, '\P{isnarb}', "");
    Expect(0, 68256, '\P{^isnarb}', "");
    Expect(1, 68255, '\p{	IS_Narb}', "");
    Expect(0, 68255, '\p{^	IS_Narb}', "");
    Expect(0, 68255, '\P{	IS_Narb}', "");
    Expect(1, 68255, '\P{^	IS_Narb}', "");
    Expect(0, 68256, '\p{	IS_Narb}', "");
    Expect(1, 68256, '\p{^	IS_Narb}', "");
    Expect(1, 68256, '\P{	IS_Narb}', "");
    Expect(0, 68256, '\P{^	IS_Narb}', "");
    Error('\p{	:=Old_permic}');
    Error('\P{	:=Old_permic}');
    Expect(1, 66426, '\p{oldpermic}', "");
    Expect(0, 66426, '\p{^oldpermic}', "");
    Expect(0, 66426, '\P{oldpermic}', "");
    Expect(1, 66426, '\P{^oldpermic}', "");
    Expect(0, 66427, '\p{oldpermic}', "");
    Expect(1, 66427, '\p{^oldpermic}', "");
    Expect(1, 66427, '\P{oldpermic}', "");
    Expect(0, 66427, '\P{^oldpermic}', "");
    Expect(1, 66426, '\p{_	Old_permic}', "");
    Expect(0, 66426, '\p{^_	Old_permic}', "");
    Expect(0, 66426, '\P{_	Old_permic}', "");
    Expect(1, 66426, '\P{^_	Old_permic}', "");
    Expect(0, 66427, '\p{_	Old_permic}', "");
    Expect(1, 66427, '\p{^_	Old_permic}', "");
    Expect(1, 66427, '\P{_	Old_permic}', "");
    Expect(0, 66427, '\P{^_	Old_permic}', "");
    Error('\p{ -Is_Old_permic:=}');
    Error('\P{ -Is_Old_permic:=}');
    Expect(1, 66426, '\p{isoldpermic}', "");
    Expect(0, 66426, '\p{^isoldpermic}', "");
    Expect(0, 66426, '\P{isoldpermic}', "");
    Expect(1, 66426, '\P{^isoldpermic}', "");
    Expect(0, 66427, '\p{isoldpermic}', "");
    Expect(1, 66427, '\p{^isoldpermic}', "");
    Expect(1, 66427, '\P{isoldpermic}', "");
    Expect(0, 66427, '\P{^isoldpermic}', "");
    Expect(1, 66426, '\p{	Is_old_PERMIC}', "");
    Expect(0, 66426, '\p{^	Is_old_PERMIC}', "");
    Expect(0, 66426, '\P{	Is_old_PERMIC}', "");
    Expect(1, 66426, '\P{^	Is_old_PERMIC}', "");
    Expect(0, 66427, '\p{	Is_old_PERMIC}', "");
    Expect(1, 66427, '\p{^	Is_old_PERMIC}', "");
    Expect(1, 66427, '\P{	Is_old_PERMIC}', "");
    Expect(0, 66427, '\P{^	Is_old_PERMIC}', "");
    Error('\p{:=	Perm}');
    Error('\P{:=	Perm}');
    Expect(1, 66426, '\p{perm}', "");
    Expect(0, 66426, '\p{^perm}', "");
    Expect(0, 66426, '\P{perm}', "");
    Expect(1, 66426, '\P{^perm}', "");
    Expect(0, 66427, '\p{perm}', "");
    Expect(1, 66427, '\p{^perm}', "");
    Expect(1, 66427, '\P{perm}', "");
    Expect(0, 66427, '\P{^perm}', "");
    Expect(1, 66426, '\p{	perm}', "");
    Expect(0, 66426, '\p{^	perm}', "");
    Expect(0, 66426, '\P{	perm}', "");
    Expect(1, 66426, '\P{^	perm}', "");
    Expect(0, 66427, '\p{	perm}', "");
    Expect(1, 66427, '\p{^	perm}', "");
    Expect(1, 66427, '\P{	perm}', "");
    Expect(0, 66427, '\P{^	perm}', "");
    Error('\p{_-IS_perm:=}');
    Error('\P{_-IS_perm:=}');
    Expect(1, 66426, '\p{isperm}', "");
    Expect(0, 66426, '\p{^isperm}', "");
    Expect(0, 66426, '\P{isperm}', "");
    Expect(1, 66426, '\P{^isperm}', "");
    Expect(0, 66427, '\p{isperm}', "");
    Expect(1, 66427, '\p{^isperm}', "");
    Expect(1, 66427, '\P{isperm}', "");
    Expect(0, 66427, '\P{^isperm}', "");
    Expect(1, 66426, '\p{-Is_Perm}', "");
    Expect(0, 66426, '\p{^-Is_Perm}', "");
    Expect(0, 66426, '\P{-Is_Perm}', "");
    Expect(1, 66426, '\P{^-Is_Perm}', "");
    Expect(0, 66427, '\p{-Is_Perm}', "");
    Expect(1, 66427, '\p{^-Is_Perm}', "");
    Expect(1, 66427, '\P{-Is_Perm}', "");
    Expect(0, 66427, '\P{^-Is_Perm}', "");
    Error('\p{	-OLD_persian/a/}');
    Error('\P{	-OLD_persian/a/}');
    Expect(1, 66517, '\p{oldpersian}', "");
    Expect(0, 66517, '\p{^oldpersian}', "");
    Expect(0, 66517, '\P{oldpersian}', "");
    Expect(1, 66517, '\P{^oldpersian}', "");
    Expect(0, 66518, '\p{oldpersian}', "");
    Expect(1, 66518, '\p{^oldpersian}', "");
    Expect(1, 66518, '\P{oldpersian}', "");
    Expect(0, 66518, '\P{^oldpersian}', "");
    Expect(1, 66517, '\p{--OLD_Persian}', "");
    Expect(0, 66517, '\p{^--OLD_Persian}', "");
    Expect(0, 66517, '\P{--OLD_Persian}', "");
    Expect(1, 66517, '\P{^--OLD_Persian}', "");
    Expect(0, 66518, '\p{--OLD_Persian}', "");
    Expect(1, 66518, '\p{^--OLD_Persian}', "");
    Expect(1, 66518, '\P{--OLD_Persian}', "");
    Expect(0, 66518, '\P{^--OLD_Persian}', "");
    Error('\p{/a/-_IS_Old_Persian}');
    Error('\P{/a/-_IS_Old_Persian}');
    Expect(1, 66517, '\p{isoldpersian}', "");
    Expect(0, 66517, '\p{^isoldpersian}', "");
    Expect(0, 66517, '\P{isoldpersian}', "");
    Expect(1, 66517, '\P{^isoldpersian}', "");
    Expect(0, 66518, '\p{isoldpersian}', "");
    Expect(1, 66518, '\p{^isoldpersian}', "");
    Expect(1, 66518, '\P{isoldpersian}', "");
    Expect(0, 66518, '\P{^isoldpersian}', "");
    Expect(1, 66517, '\p{--is_Old_persian}', "");
    Expect(0, 66517, '\p{^--is_Old_persian}', "");
    Expect(0, 66517, '\P{--is_Old_persian}', "");
    Expect(1, 66517, '\P{^--is_Old_persian}', "");
    Expect(0, 66518, '\p{--is_Old_persian}', "");
    Expect(1, 66518, '\p{^--is_Old_persian}', "");
    Expect(1, 66518, '\P{--is_Old_persian}', "");
    Expect(0, 66518, '\P{^--is_Old_persian}', "");
    Error('\p{ -XPEO:=}');
    Error('\P{ -XPEO:=}');
    Expect(1, 66517, '\p{xpeo}', "");
    Expect(0, 66517, '\p{^xpeo}', "");
    Expect(0, 66517, '\P{xpeo}', "");
    Expect(1, 66517, '\P{^xpeo}', "");
    Expect(0, 66518, '\p{xpeo}', "");
    Expect(1, 66518, '\p{^xpeo}', "");
    Expect(1, 66518, '\P{xpeo}', "");
    Expect(0, 66518, '\P{^xpeo}', "");
    Expect(1, 66517, '\p{_XPEO}', "");
    Expect(0, 66517, '\p{^_XPEO}', "");
    Expect(0, 66517, '\P{_XPEO}', "");
    Expect(1, 66517, '\P{^_XPEO}', "");
    Expect(0, 66518, '\p{_XPEO}', "");
    Expect(1, 66518, '\p{^_XPEO}', "");
    Expect(1, 66518, '\P{_XPEO}', "");
    Expect(0, 66518, '\P{^_XPEO}', "");
    Error('\p{:= 	Is_Xpeo}');
    Error('\P{:= 	Is_Xpeo}');
    Expect(1, 66517, '\p{isxpeo}', "");
    Expect(0, 66517, '\p{^isxpeo}', "");
    Expect(0, 66517, '\P{isxpeo}', "");
    Expect(1, 66517, '\P{^isxpeo}', "");
    Expect(0, 66518, '\p{isxpeo}', "");
    Expect(1, 66518, '\p{^isxpeo}', "");
    Expect(1, 66518, '\P{isxpeo}', "");
    Expect(0, 66518, '\P{^isxpeo}', "");
    Expect(1, 66517, '\p{ _is_Xpeo}', "");
    Expect(0, 66517, '\p{^ _is_Xpeo}', "");
    Expect(0, 66517, '\P{ _is_Xpeo}', "");
    Expect(1, 66517, '\P{^ _is_Xpeo}', "");
    Expect(0, 66518, '\p{ _is_Xpeo}', "");
    Expect(1, 66518, '\p{^ _is_Xpeo}', "");
    Expect(1, 66518, '\P{ _is_Xpeo}', "");
    Expect(0, 66518, '\P{^ _is_Xpeo}', "");
    Error('\p{-	OLD_Sogdian/a/}');
    Error('\P{-	OLD_Sogdian/a/}');
    Expect(1, 69415, '\p{oldsogdian}', "");
    Expect(0, 69415, '\p{^oldsogdian}', "");
    Expect(0, 69415, '\P{oldsogdian}', "");
    Expect(1, 69415, '\P{^oldsogdian}', "");
    Expect(0, 69416, '\p{oldsogdian}', "");
    Expect(1, 69416, '\p{^oldsogdian}', "");
    Expect(1, 69416, '\P{oldsogdian}', "");
    Expect(0, 69416, '\P{^oldsogdian}', "");
    Expect(1, 69415, '\p{-OLD_Sogdian}', "");
    Expect(0, 69415, '\p{^-OLD_Sogdian}', "");
    Expect(0, 69415, '\P{-OLD_Sogdian}', "");
    Expect(1, 69415, '\P{^-OLD_Sogdian}', "");
    Expect(0, 69416, '\p{-OLD_Sogdian}', "");
    Expect(1, 69416, '\p{^-OLD_Sogdian}', "");
    Expect(1, 69416, '\P{-OLD_Sogdian}', "");
    Expect(0, 69416, '\P{^-OLD_Sogdian}', "");
    Error('\p{ _Is_OLD_Sogdian:=}');
    Error('\P{ _Is_OLD_Sogdian:=}');
    Expect(1, 69415, '\p{isoldsogdian}', "");
    Expect(0, 69415, '\p{^isoldsogdian}', "");
    Expect(0, 69415, '\P{isoldsogdian}', "");
    Expect(1, 69415, '\P{^isoldsogdian}', "");
    Expect(0, 69416, '\p{isoldsogdian}', "");
    Expect(1, 69416, '\p{^isoldsogdian}', "");
    Expect(1, 69416, '\P{isoldsogdian}', "");
    Expect(0, 69416, '\P{^isoldsogdian}', "");
    Expect(1, 69415, '\p{ 	Is_Old_SOGDIAN}', "");
    Expect(0, 69415, '\p{^ 	Is_Old_SOGDIAN}', "");
    Expect(0, 69415, '\P{ 	Is_Old_SOGDIAN}', "");
    Expect(1, 69415, '\P{^ 	Is_Old_SOGDIAN}', "");
    Expect(0, 69416, '\p{ 	Is_Old_SOGDIAN}', "");
    Expect(1, 69416, '\p{^ 	Is_Old_SOGDIAN}', "");
    Expect(1, 69416, '\P{ 	Is_Old_SOGDIAN}', "");
    Expect(0, 69416, '\P{^ 	Is_Old_SOGDIAN}', "");
    Error('\p{ Sogo/a/}');
    Error('\P{ Sogo/a/}');
    Expect(1, 69415, '\p{sogo}', "");
    Expect(0, 69415, '\p{^sogo}', "");
    Expect(0, 69415, '\P{sogo}', "");
    Expect(1, 69415, '\P{^sogo}', "");
    Expect(0, 69416, '\p{sogo}', "");
    Expect(1, 69416, '\p{^sogo}', "");
    Expect(1, 69416, '\P{sogo}', "");
    Expect(0, 69416, '\P{^sogo}', "");
    Expect(1, 69415, '\p{		sogo}', "");
    Expect(0, 69415, '\p{^		sogo}', "");
    Expect(0, 69415, '\P{		sogo}', "");
    Expect(1, 69415, '\P{^		sogo}', "");
    Expect(0, 69416, '\p{		sogo}', "");
    Expect(1, 69416, '\p{^		sogo}', "");
    Expect(1, 69416, '\P{		sogo}', "");
    Expect(0, 69416, '\P{^		sogo}', "");
    Error('\p{ :=IS_Sogo}');
    Error('\P{ :=IS_Sogo}');
    Expect(1, 69415, '\p{issogo}', "");
    Expect(0, 69415, '\p{^issogo}', "");
    Expect(0, 69415, '\P{issogo}', "");
    Expect(1, 69415, '\P{^issogo}', "");
    Expect(0, 69416, '\p{issogo}', "");
    Expect(1, 69416, '\p{^issogo}', "");
    Expect(1, 69416, '\P{issogo}', "");
    Expect(0, 69416, '\P{^issogo}', "");
    Expect(1, 69415, '\p{--is_Sogo}', "");
    Expect(0, 69415, '\p{^--is_Sogo}', "");
    Expect(0, 69415, '\P{--is_Sogo}', "");
    Expect(1, 69415, '\P{^--is_Sogo}', "");
    Expect(0, 69416, '\p{--is_Sogo}', "");
    Expect(1, 69416, '\p{^--is_Sogo}', "");
    Expect(1, 69416, '\P{--is_Sogo}', "");
    Expect(0, 69416, '\P{^--is_Sogo}', "");
    Error('\p{ -old_SOUTH_ARABIAN:=}');
    Error('\P{ -old_SOUTH_ARABIAN:=}');
    Expect(1, 68223, '\p{oldsoutharabian}', "");
    Expect(0, 68223, '\p{^oldsoutharabian}', "");
    Expect(0, 68223, '\P{oldsoutharabian}', "");
    Expect(1, 68223, '\P{^oldsoutharabian}', "");
    Expect(0, 68224, '\p{oldsoutharabian}', "");
    Expect(1, 68224, '\p{^oldsoutharabian}', "");
    Expect(1, 68224, '\P{oldsoutharabian}', "");
    Expect(0, 68224, '\P{^oldsoutharabian}', "");
    Expect(1, 68223, '\p{ old_South_Arabian}', "");
    Expect(0, 68223, '\p{^ old_South_Arabian}', "");
    Expect(0, 68223, '\P{ old_South_Arabian}', "");
    Expect(1, 68223, '\P{^ old_South_Arabian}', "");
    Expect(0, 68224, '\p{ old_South_Arabian}', "");
    Expect(1, 68224, '\p{^ old_South_Arabian}', "");
    Expect(1, 68224, '\P{ old_South_Arabian}', "");
    Expect(0, 68224, '\P{^ old_South_Arabian}', "");
    Error('\p{:=__Is_Old_SOUTH_ARABIAN}');
    Error('\P{:=__Is_Old_SOUTH_ARABIAN}');
    Expect(1, 68223, '\p{isoldsoutharabian}', "");
    Expect(0, 68223, '\p{^isoldsoutharabian}', "");
    Expect(0, 68223, '\P{isoldsoutharabian}', "");
    Expect(1, 68223, '\P{^isoldsoutharabian}', "");
    Expect(0, 68224, '\p{isoldsoutharabian}', "");
    Expect(1, 68224, '\p{^isoldsoutharabian}', "");
    Expect(1, 68224, '\P{isoldsoutharabian}', "");
    Expect(0, 68224, '\P{^isoldsoutharabian}', "");
    Expect(1, 68223, '\p{_-Is_OLD_south_ARABIAN}', "");
    Expect(0, 68223, '\p{^_-Is_OLD_south_ARABIAN}', "");
    Expect(0, 68223, '\P{_-Is_OLD_south_ARABIAN}', "");
    Expect(1, 68223, '\P{^_-Is_OLD_south_ARABIAN}', "");
    Expect(0, 68224, '\p{_-Is_OLD_south_ARABIAN}', "");
    Expect(1, 68224, '\p{^_-Is_OLD_south_ARABIAN}', "");
    Expect(1, 68224, '\P{_-Is_OLD_south_ARABIAN}', "");
    Expect(0, 68224, '\P{^_-Is_OLD_south_ARABIAN}', "");
    Error('\p{/a/- sarb}');
    Error('\P{/a/- sarb}');
    Expect(1, 68223, '\p{sarb}', "");
    Expect(0, 68223, '\p{^sarb}', "");
    Expect(0, 68223, '\P{sarb}', "");
    Expect(1, 68223, '\P{^sarb}', "");
    Expect(0, 68224, '\p{sarb}', "");
    Expect(1, 68224, '\p{^sarb}', "");
    Expect(1, 68224, '\P{sarb}', "");
    Expect(0, 68224, '\P{^sarb}', "");
    Expect(1, 68223, '\p{-	Sarb}', "");
    Expect(0, 68223, '\p{^-	Sarb}', "");
    Expect(0, 68223, '\P{-	Sarb}', "");
    Expect(1, 68223, '\P{^-	Sarb}', "");
    Expect(0, 68224, '\p{-	Sarb}', "");
    Expect(1, 68224, '\p{^-	Sarb}', "");
    Expect(1, 68224, '\P{-	Sarb}', "");
    Expect(0, 68224, '\P{^-	Sarb}', "");
    Error('\p{ _is_SARB:=}');
    Error('\P{ _is_SARB:=}');
    Expect(1, 68223, '\p{issarb}', "");
    Expect(0, 68223, '\p{^issarb}', "");
    Expect(0, 68223, '\P{issarb}', "");
    Expect(1, 68223, '\P{^issarb}', "");
    Expect(0, 68224, '\p{issarb}', "");
    Expect(1, 68224, '\p{^issarb}', "");
    Expect(1, 68224, '\P{issarb}', "");
    Expect(0, 68224, '\P{^issarb}', "");
    Expect(1, 68223, '\p{Is_sarb}', "");
    Expect(0, 68223, '\p{^Is_sarb}', "");
    Expect(0, 68223, '\P{Is_sarb}', "");
    Expect(1, 68223, '\P{^Is_sarb}', "");
    Expect(0, 68224, '\p{Is_sarb}', "");
    Expect(1, 68224, '\p{^Is_sarb}', "");
    Expect(1, 68224, '\P{Is_sarb}', "");
    Expect(0, 68224, '\P{^Is_sarb}', "");
    Error('\p{__Old_Turkic:=}');
    Error('\P{__Old_Turkic:=}');
    Expect(1, 68680, '\p{oldturkic}', "");
    Expect(0, 68680, '\p{^oldturkic}', "");
    Expect(0, 68680, '\P{oldturkic}', "");
    Expect(1, 68680, '\P{^oldturkic}', "");
    Expect(0, 68681, '\p{oldturkic}', "");
    Expect(1, 68681, '\p{^oldturkic}', "");
    Expect(1, 68681, '\P{oldturkic}', "");
    Expect(0, 68681, '\P{^oldturkic}', "");
    Expect(1, 68680, '\p{-_OLD_TURKIC}', "");
    Expect(0, 68680, '\p{^-_OLD_TURKIC}', "");
    Expect(0, 68680, '\P{-_OLD_TURKIC}', "");
    Expect(1, 68680, '\P{^-_OLD_TURKIC}', "");
    Expect(0, 68681, '\p{-_OLD_TURKIC}', "");
    Expect(1, 68681, '\p{^-_OLD_TURKIC}', "");
    Expect(1, 68681, '\P{-_OLD_TURKIC}', "");
    Expect(0, 68681, '\P{^-_OLD_TURKIC}', "");
    Error('\p{:=_	is_Old_Turkic}');
    Error('\P{:=_	is_Old_Turkic}');
    Expect(1, 68680, '\p{isoldturkic}', "");
    Expect(0, 68680, '\p{^isoldturkic}', "");
    Expect(0, 68680, '\P{isoldturkic}', "");
    Expect(1, 68680, '\P{^isoldturkic}', "");
    Expect(0, 68681, '\p{isoldturkic}', "");
    Expect(1, 68681, '\p{^isoldturkic}', "");
    Expect(1, 68681, '\P{isoldturkic}', "");
    Expect(0, 68681, '\P{^isoldturkic}', "");
    Expect(1, 68680, '\p{	 Is_OLD_TURKIC}', "");
    Expect(0, 68680, '\p{^	 Is_OLD_TURKIC}', "");
    Expect(0, 68680, '\P{	 Is_OLD_TURKIC}', "");
    Expect(1, 68680, '\P{^	 Is_OLD_TURKIC}', "");
    Expect(0, 68681, '\p{	 Is_OLD_TURKIC}', "");
    Expect(1, 68681, '\p{^	 Is_OLD_TURKIC}', "");
    Expect(1, 68681, '\P{	 Is_OLD_TURKIC}', "");
    Expect(0, 68681, '\P{^	 Is_OLD_TURKIC}', "");
    Error('\p{:= _Orkh}');
    Error('\P{:= _Orkh}');
    Expect(1, 68680, '\p{orkh}', "");
    Expect(0, 68680, '\p{^orkh}', "");
    Expect(0, 68680, '\P{orkh}', "");
    Expect(1, 68680, '\P{^orkh}', "");
    Expect(0, 68681, '\p{orkh}', "");
    Expect(1, 68681, '\p{^orkh}', "");
    Expect(1, 68681, '\P{orkh}', "");
    Expect(0, 68681, '\P{^orkh}', "");
    Expect(1, 68680, '\p{-_Orkh}', "");
    Expect(0, 68680, '\p{^-_Orkh}', "");
    Expect(0, 68680, '\P{-_Orkh}', "");
    Expect(1, 68680, '\P{^-_Orkh}', "");
    Expect(0, 68681, '\p{-_Orkh}', "");
    Expect(1, 68681, '\p{^-_Orkh}', "");
    Expect(1, 68681, '\P{-_Orkh}', "");
    Expect(0, 68681, '\P{^-_Orkh}', "");
    Error('\p{:=		IS_ORKH}');
    Error('\P{:=		IS_ORKH}');
    Expect(1, 68680, '\p{isorkh}', "");
    Expect(0, 68680, '\p{^isorkh}', "");
    Expect(0, 68680, '\P{isorkh}', "");
    Expect(1, 68680, '\P{^isorkh}', "");
    Expect(0, 68681, '\p{isorkh}', "");
    Expect(1, 68681, '\p{^isorkh}', "");
    Expect(1, 68681, '\P{isorkh}', "");
    Expect(0, 68681, '\P{^isorkh}', "");
    Expect(1, 68680, '\p{	_is_orkh}', "");
    Expect(0, 68680, '\p{^	_is_orkh}', "");
    Expect(0, 68680, '\P{	_is_orkh}', "");
    Expect(1, 68680, '\P{^	_is_orkh}', "");
    Expect(0, 68681, '\p{	_is_orkh}', "");
    Expect(1, 68681, '\p{^	_is_orkh}', "");
    Expect(1, 68681, '\P{	_is_orkh}', "");
    Expect(0, 68681, '\P{^	_is_orkh}', "");
    Error('\p{- Open_Punctuation/a/}');
    Error('\P{- Open_Punctuation/a/}');
    Expect(1, 65378, '\p{openpunctuation}', "");
    Expect(0, 65378, '\p{^openpunctuation}', "");
    Expect(0, 65378, '\P{openpunctuation}', "");
    Expect(1, 65378, '\P{^openpunctuation}', "");
    Expect(0, 65379, '\p{openpunctuation}', "");
    Expect(1, 65379, '\p{^openpunctuation}', "");
    Expect(1, 65379, '\P{openpunctuation}', "");
    Expect(0, 65379, '\P{^openpunctuation}', "");
    Expect(1, 65378, '\p{-_Open_Punctuation}', "");
    Expect(0, 65378, '\p{^-_Open_Punctuation}', "");
    Expect(0, 65378, '\P{-_Open_Punctuation}', "");
    Expect(1, 65378, '\P{^-_Open_Punctuation}', "");
    Expect(0, 65379, '\p{-_Open_Punctuation}', "");
    Expect(1, 65379, '\p{^-_Open_Punctuation}', "");
    Expect(1, 65379, '\P{-_Open_Punctuation}', "");
    Expect(0, 65379, '\P{^-_Open_Punctuation}', "");
    Error('\p{_/a/IS_OPEN_PUNCTUATION}');
    Error('\P{_/a/IS_OPEN_PUNCTUATION}');
    Expect(1, 65378, '\p{isopenpunctuation}', "");
    Expect(0, 65378, '\p{^isopenpunctuation}', "");
    Expect(0, 65378, '\P{isopenpunctuation}', "");
    Expect(1, 65378, '\P{^isopenpunctuation}', "");
    Expect(0, 65379, '\p{isopenpunctuation}', "");
    Expect(1, 65379, '\p{^isopenpunctuation}', "");
    Expect(1, 65379, '\P{isopenpunctuation}', "");
    Expect(0, 65379, '\P{^isopenpunctuation}', "");
    Expect(1, 65378, '\p{ 	Is_open_Punctuation}', "");
    Expect(0, 65378, '\p{^ 	Is_open_Punctuation}', "");
    Expect(0, 65378, '\P{ 	Is_open_Punctuation}', "");
    Expect(1, 65378, '\P{^ 	Is_open_Punctuation}', "");
    Expect(0, 65379, '\p{ 	Is_open_Punctuation}', "");
    Expect(1, 65379, '\p{^ 	Is_open_Punctuation}', "");
    Expect(1, 65379, '\P{ 	Is_open_Punctuation}', "");
    Expect(0, 65379, '\P{^ 	Is_open_Punctuation}', "");
    Error('\p{	/a/PS}');
    Error('\P{	/a/PS}');
    Expect(1, 65378, '\p{ps}', "");
    Expect(0, 65378, '\p{^ps}', "");
    Expect(0, 65378, '\P{ps}', "");
    Expect(1, 65378, '\P{^ps}', "");
    Expect(0, 65379, '\p{ps}', "");
    Expect(1, 65379, '\p{^ps}', "");
    Expect(1, 65379, '\P{ps}', "");
    Expect(0, 65379, '\P{^ps}', "");
    Expect(1, 65378, '\p{-_Ps}', "");
    Expect(0, 65378, '\p{^-_Ps}', "");
    Expect(0, 65378, '\P{-_Ps}', "");
    Expect(1, 65378, '\P{^-_Ps}', "");
    Expect(0, 65379, '\p{-_Ps}', "");
    Expect(1, 65379, '\p{^-_Ps}', "");
    Expect(1, 65379, '\P{-_Ps}', "");
    Expect(0, 65379, '\P{^-_Ps}', "");
    Error('\p{ :=Is_PS}');
    Error('\P{ :=Is_PS}');
    Expect(1, 65378, '\p{isps}', "");
    Expect(0, 65378, '\p{^isps}', "");
    Expect(0, 65378, '\P{isps}', "");
    Expect(1, 65378, '\P{^isps}', "");
    Expect(0, 65379, '\p{isps}', "");
    Expect(1, 65379, '\p{^isps}', "");
    Expect(1, 65379, '\P{isps}', "");
    Expect(0, 65379, '\P{^isps}', "");
    Expect(1, 65378, '\p{ -IS_PS}', "");
    Expect(0, 65378, '\p{^ -IS_PS}', "");
    Expect(0, 65378, '\P{ -IS_PS}', "");
    Expect(1, 65378, '\P{^ -IS_PS}', "");
    Expect(0, 65379, '\p{ -IS_PS}', "");
    Expect(1, 65379, '\p{^ -IS_PS}', "");
    Expect(1, 65379, '\P{ -IS_PS}', "");
    Expect(0, 65379, '\P{^ -IS_PS}', "");
    Error('\p{	/a/optical_Character_recognition}');
    Error('\P{	/a/optical_Character_recognition}');
    Expect(1, 9311, '\p{opticalcharacterrecognition}', "");
    Expect(0, 9311, '\p{^opticalcharacterrecognition}', "");
    Expect(0, 9311, '\P{opticalcharacterrecognition}', "");
    Expect(1, 9311, '\P{^opticalcharacterrecognition}', "");
    Expect(0, 9312, '\p{opticalcharacterrecognition}', "");
    Expect(1, 9312, '\p{^opticalcharacterrecognition}', "");
    Expect(1, 9312, '\P{opticalcharacterrecognition}', "");
    Expect(0, 9312, '\P{^opticalcharacterrecognition}', "");
    Expect(1, 9311, '\p{ Optical_CHARACTER_recognition}', "");
    Expect(0, 9311, '\p{^ Optical_CHARACTER_recognition}', "");
    Expect(0, 9311, '\P{ Optical_CHARACTER_recognition}', "");
    Expect(1, 9311, '\P{^ Optical_CHARACTER_recognition}', "");
    Expect(0, 9312, '\p{ Optical_CHARACTER_recognition}', "");
    Expect(1, 9312, '\p{^ Optical_CHARACTER_recognition}', "");
    Expect(1, 9312, '\P{ Optical_CHARACTER_recognition}', "");
    Expect(0, 9312, '\P{^ Optical_CHARACTER_recognition}', "");
    Error('\p{/a/_	is_OPTICAL_character_Recognition}');
    Error('\P{/a/_	is_OPTICAL_character_Recognition}');
    Expect(1, 9311, '\p{isopticalcharacterrecognition}', "");
    Expect(0, 9311, '\p{^isopticalcharacterrecognition}', "");
    Expect(0, 9311, '\P{isopticalcharacterrecognition}', "");
    Expect(1, 9311, '\P{^isopticalcharacterrecognition}', "");
    Expect(0, 9312, '\p{isopticalcharacterrecognition}', "");
    Expect(1, 9312, '\p{^isopticalcharacterrecognition}', "");
    Expect(1, 9312, '\P{isopticalcharacterrecognition}', "");
    Expect(0, 9312, '\P{^isopticalcharacterrecognition}', "");
    Expect(1, 9311, '\p{ IS_OPTICAL_CHARACTER_Recognition}', "");
    Expect(0, 9311, '\p{^ IS_OPTICAL_CHARACTER_Recognition}', "");
    Expect(0, 9311, '\P{ IS_OPTICAL_CHARACTER_Recognition}', "");
    Expect(1, 9311, '\P{^ IS_OPTICAL_CHARACTER_Recognition}', "");
    Expect(0, 9312, '\p{ IS_OPTICAL_CHARACTER_Recognition}', "");
    Expect(1, 9312, '\p{^ IS_OPTICAL_CHARACTER_Recognition}', "");
    Expect(1, 9312, '\P{ IS_OPTICAL_CHARACTER_Recognition}', "");
    Expect(0, 9312, '\P{^ IS_OPTICAL_CHARACTER_Recognition}', "");
    Error('\p{:=__in_Optical_character_Recognition}');
    Error('\P{:=__in_Optical_character_Recognition}');
    Expect(1, 9311, '\p{inopticalcharacterrecognition}', "");
    Expect(0, 9311, '\p{^inopticalcharacterrecognition}', "");
    Expect(0, 9311, '\P{inopticalcharacterrecognition}', "");
    Expect(1, 9311, '\P{^inopticalcharacterrecognition}', "");
    Expect(0, 9312, '\p{inopticalcharacterrecognition}', "");
    Expect(1, 9312, '\p{^inopticalcharacterrecognition}', "");
    Expect(1, 9312, '\P{inopticalcharacterrecognition}', "");
    Expect(0, 9312, '\P{^inopticalcharacterrecognition}', "");
    Expect(1, 9311, '\p{_ In_Optical_CHARACTER_Recognition}', "");
    Expect(0, 9311, '\p{^_ In_Optical_CHARACTER_Recognition}', "");
    Expect(0, 9311, '\P{_ In_Optical_CHARACTER_Recognition}', "");
    Expect(1, 9311, '\P{^_ In_Optical_CHARACTER_Recognition}', "");
    Expect(0, 9312, '\p{_ In_Optical_CHARACTER_Recognition}', "");
    Expect(1, 9312, '\p{^_ In_Optical_CHARACTER_Recognition}', "");
    Expect(1, 9312, '\P{_ In_Optical_CHARACTER_Recognition}', "");
    Expect(0, 9312, '\P{^_ In_Optical_CHARACTER_Recognition}', "");
    Error('\p{-:=OCR}');
    Error('\P{-:=OCR}');
    Expect(1, 9311, '\p{ocr}', "");
    Expect(0, 9311, '\p{^ocr}', "");
    Expect(0, 9311, '\P{ocr}', "");
    Expect(1, 9311, '\P{^ocr}', "");
    Expect(0, 9312, '\p{ocr}', "");
    Expect(1, 9312, '\p{^ocr}', "");
    Expect(1, 9312, '\P{ocr}', "");
    Expect(0, 9312, '\P{^ocr}', "");
    Expect(1, 9311, '\p{		ocr}', "");
    Expect(0, 9311, '\p{^		ocr}', "");
    Expect(0, 9311, '\P{		ocr}', "");
    Expect(1, 9311, '\P{^		ocr}', "");
    Expect(0, 9312, '\p{		ocr}', "");
    Expect(1, 9312, '\p{^		ocr}', "");
    Expect(1, 9312, '\P{		ocr}', "");
    Expect(0, 9312, '\P{^		ocr}', "");
    Error('\p{_IS_ocr/a/}');
    Error('\P{_IS_ocr/a/}');
    Expect(1, 9311, '\p{isocr}', "");
    Expect(0, 9311, '\p{^isocr}', "");
    Expect(0, 9311, '\P{isocr}', "");
    Expect(1, 9311, '\P{^isocr}', "");
    Expect(0, 9312, '\p{isocr}', "");
    Expect(1, 9312, '\p{^isocr}', "");
    Expect(1, 9312, '\P{isocr}', "");
    Expect(0, 9312, '\P{^isocr}', "");
    Expect(1, 9311, '\p{ 	IS_ocr}', "");
    Expect(0, 9311, '\p{^ 	IS_ocr}', "");
    Expect(0, 9311, '\P{ 	IS_ocr}', "");
    Expect(1, 9311, '\P{^ 	IS_ocr}', "");
    Expect(0, 9312, '\p{ 	IS_ocr}', "");
    Expect(1, 9312, '\p{^ 	IS_ocr}', "");
    Expect(1, 9312, '\P{ 	IS_ocr}', "");
    Expect(0, 9312, '\P{^ 	IS_ocr}', "");
    Error('\p{	 In_ocr/a/}');
    Error('\P{	 In_ocr/a/}');
    Expect(1, 9311, '\p{inocr}', "");
    Expect(0, 9311, '\p{^inocr}', "");
    Expect(0, 9311, '\P{inocr}', "");
    Expect(1, 9311, '\P{^inocr}', "");
    Expect(0, 9312, '\p{inocr}', "");
    Expect(1, 9312, '\p{^inocr}', "");
    Expect(1, 9312, '\P{inocr}', "");
    Expect(0, 9312, '\P{^inocr}', "");
    Expect(1, 9311, '\p{-in_ocr}', "");
    Expect(0, 9311, '\p{^-in_ocr}', "");
    Expect(0, 9311, '\P{-in_ocr}', "");
    Expect(1, 9311, '\P{^-in_ocr}', "");
    Expect(0, 9312, '\p{-in_ocr}', "");
    Expect(1, 9312, '\p{^-in_ocr}', "");
    Expect(1, 9312, '\P{-in_ocr}', "");
    Expect(0, 9312, '\P{^-in_ocr}', "");
    Error('\p{:=__Oriya}');
    Error('\P{:=__Oriya}');
    Expect(1, 7410, '\p{oriya}', "");
    Expect(0, 7410, '\p{^oriya}', "");
    Expect(0, 7410, '\P{oriya}', "");
    Expect(1, 7410, '\P{^oriya}', "");
    Expect(0, 7411, '\p{oriya}', "");
    Expect(1, 7411, '\p{^oriya}', "");
    Expect(1, 7411, '\P{oriya}', "");
    Expect(0, 7411, '\P{^oriya}', "");
    Expect(1, 7410, '\p{ _ORIYA}', "");
    Expect(0, 7410, '\p{^ _ORIYA}', "");
    Expect(0, 7410, '\P{ _ORIYA}', "");
    Expect(1, 7410, '\P{^ _ORIYA}', "");
    Expect(0, 7411, '\p{ _ORIYA}', "");
    Expect(1, 7411, '\p{^ _ORIYA}', "");
    Expect(1, 7411, '\P{ _ORIYA}', "");
    Expect(0, 7411, '\P{^ _ORIYA}', "");
    Error('\p{/a/	Is_Oriya}');
    Error('\P{/a/	Is_Oriya}');
    Expect(1, 7410, '\p{isoriya}', "");
    Expect(0, 7410, '\p{^isoriya}', "");
    Expect(0, 7410, '\P{isoriya}', "");
    Expect(1, 7410, '\P{^isoriya}', "");
    Expect(0, 7411, '\p{isoriya}', "");
    Expect(1, 7411, '\p{^isoriya}', "");
    Expect(1, 7411, '\P{isoriya}', "");
    Expect(0, 7411, '\P{^isoriya}', "");
    Expect(1, 7410, '\p{ -Is_Oriya}', "");
    Expect(0, 7410, '\p{^ -Is_Oriya}', "");
    Expect(0, 7410, '\P{ -Is_Oriya}', "");
    Expect(1, 7410, '\P{^ -Is_Oriya}', "");
    Expect(0, 7411, '\p{ -Is_Oriya}', "");
    Expect(1, 7411, '\p{^ -Is_Oriya}', "");
    Expect(1, 7411, '\P{ -Is_Oriya}', "");
    Expect(0, 7411, '\P{^ -Is_Oriya}', "");
    Error('\p{ :=Orya}');
    Error('\P{ :=Orya}');
    Expect(1, 7410, '\p{orya}', "");
    Expect(0, 7410, '\p{^orya}', "");
    Expect(0, 7410, '\P{orya}', "");
    Expect(1, 7410, '\P{^orya}', "");
    Expect(0, 7411, '\p{orya}', "");
    Expect(1, 7411, '\p{^orya}', "");
    Expect(1, 7411, '\P{orya}', "");
    Expect(0, 7411, '\P{^orya}', "");
    Expect(1, 7410, '\p{-_Orya}', "");
    Expect(0, 7410, '\p{^-_Orya}', "");
    Expect(0, 7410, '\P{-_Orya}', "");
    Expect(1, 7410, '\P{^-_Orya}', "");
    Expect(0, 7411, '\p{-_Orya}', "");
    Expect(1, 7411, '\p{^-_Orya}', "");
    Expect(1, 7411, '\P{-_Orya}', "");
    Expect(0, 7411, '\P{^-_Orya}', "");
    Error('\p{ _Is_ORYA/a/}');
    Error('\P{ _Is_ORYA/a/}');
    Expect(1, 7410, '\p{isorya}', "");
    Expect(0, 7410, '\p{^isorya}', "");
    Expect(0, 7410, '\P{isorya}', "");
    Expect(1, 7410, '\P{^isorya}', "");
    Expect(0, 7411, '\p{isorya}', "");
    Expect(1, 7411, '\p{^isorya}', "");
    Expect(1, 7411, '\P{isorya}', "");
    Expect(0, 7411, '\P{^isorya}', "");
    Expect(1, 7410, '\p{ _IS_orya}', "");
    Expect(0, 7410, '\p{^ _IS_orya}', "");
    Expect(0, 7410, '\P{ _IS_orya}', "");
    Expect(1, 7410, '\P{^ _IS_orya}', "");
    Expect(0, 7411, '\p{ _IS_orya}', "");
    Expect(1, 7411, '\p{^ _IS_orya}', "");
    Expect(1, 7411, '\P{ _IS_orya}', "");
    Expect(0, 7411, '\P{^ _IS_orya}', "");
    Error('\p{	ornamental_dingbats/a/}');
    Error('\P{	ornamental_dingbats/a/}');
    Expect(1, 128639, '\p{ornamentaldingbats}', "");
    Expect(0, 128639, '\p{^ornamentaldingbats}', "");
    Expect(0, 128639, '\P{ornamentaldingbats}', "");
    Expect(1, 128639, '\P{^ornamentaldingbats}', "");
    Expect(0, 128640, '\p{ornamentaldingbats}', "");
    Expect(1, 128640, '\p{^ornamentaldingbats}', "");
    Expect(1, 128640, '\P{ornamentaldingbats}', "");
    Expect(0, 128640, '\P{^ornamentaldingbats}', "");
    Expect(1, 128639, '\p{_Ornamental_DINGBATS}', "");
    Expect(0, 128639, '\p{^_Ornamental_DINGBATS}', "");
    Expect(0, 128639, '\P{_Ornamental_DINGBATS}', "");
    Expect(1, 128639, '\P{^_Ornamental_DINGBATS}', "");
    Expect(0, 128640, '\p{_Ornamental_DINGBATS}', "");
    Expect(1, 128640, '\p{^_Ornamental_DINGBATS}', "");
    Expect(1, 128640, '\P{_Ornamental_DINGBATS}', "");
    Expect(0, 128640, '\P{^_Ornamental_DINGBATS}', "");
    Error('\p{/a/ Is_Ornamental_Dingbats}');
    Error('\P{/a/ Is_Ornamental_Dingbats}');
    Expect(1, 128639, '\p{isornamentaldingbats}', "");
    Expect(0, 128639, '\p{^isornamentaldingbats}', "");
    Expect(0, 128639, '\P{isornamentaldingbats}', "");
    Expect(1, 128639, '\P{^isornamentaldingbats}', "");
    Expect(0, 128640, '\p{isornamentaldingbats}', "");
    Expect(1, 128640, '\p{^isornamentaldingbats}', "");
    Expect(1, 128640, '\P{isornamentaldingbats}', "");
    Expect(0, 128640, '\P{^isornamentaldingbats}', "");
    Expect(1, 128639, '\p{_	IS_Ornamental_Dingbats}', "");
    Expect(0, 128639, '\p{^_	IS_Ornamental_Dingbats}', "");
    Expect(0, 128639, '\P{_	IS_Ornamental_Dingbats}', "");
    Expect(1, 128639, '\P{^_	IS_Ornamental_Dingbats}', "");
    Expect(0, 128640, '\p{_	IS_Ornamental_Dingbats}', "");
    Expect(1, 128640, '\p{^_	IS_Ornamental_Dingbats}', "");
    Expect(1, 128640, '\P{_	IS_Ornamental_Dingbats}', "");
    Expect(0, 128640, '\P{^_	IS_Ornamental_Dingbats}', "");
    Error('\p{:= In_ORNAMENTAL_Dingbats}');
    Error('\P{:= In_ORNAMENTAL_Dingbats}');
    Expect(1, 128639, '\p{inornamentaldingbats}', "");
    Expect(0, 128639, '\p{^inornamentaldingbats}', "");
    Expect(0, 128639, '\P{inornamentaldingbats}', "");
    Expect(1, 128639, '\P{^inornamentaldingbats}', "");
    Expect(0, 128640, '\p{inornamentaldingbats}', "");
    Expect(1, 128640, '\p{^inornamentaldingbats}', "");
    Expect(1, 128640, '\P{inornamentaldingbats}', "");
    Expect(0, 128640, '\P{^inornamentaldingbats}', "");
    Expect(1, 128639, '\p{-	In_ornamental_dingbats}', "");
    Expect(0, 128639, '\p{^-	In_ornamental_dingbats}', "");
    Expect(0, 128639, '\P{-	In_ornamental_dingbats}', "");
    Expect(1, 128639, '\P{^-	In_ornamental_dingbats}', "");
    Expect(0, 128640, '\p{-	In_ornamental_dingbats}', "");
    Expect(1, 128640, '\p{^-	In_ornamental_dingbats}', "");
    Expect(1, 128640, '\P{-	In_ornamental_dingbats}', "");
    Expect(0, 128640, '\P{^-	In_ornamental_dingbats}', "");
    Error('\p{ _osage/a/}');
    Error('\P{ _osage/a/}');
    Expect(1, 66811, '\p{osage}', "");
    Expect(0, 66811, '\p{^osage}', "");
    Expect(0, 66811, '\P{osage}', "");
    Expect(1, 66811, '\P{^osage}', "");
    Expect(0, 66812, '\p{osage}', "");
    Expect(1, 66812, '\p{^osage}', "");
    Expect(1, 66812, '\P{osage}', "");
    Expect(0, 66812, '\P{^osage}', "");
    Expect(1, 66811, '\p{-osage}', "");
    Expect(0, 66811, '\p{^-osage}', "");
    Expect(0, 66811, '\P{-osage}', "");
    Expect(1, 66811, '\P{^-osage}', "");
    Expect(0, 66812, '\p{-osage}', "");
    Expect(1, 66812, '\p{^-osage}', "");
    Expect(1, 66812, '\P{-osage}', "");
    Expect(0, 66812, '\P{^-osage}', "");
    Error('\p{ _is_Osage:=}');
    Error('\P{ _is_Osage:=}');
    Expect(1, 66811, '\p{isosage}', "");
    Expect(0, 66811, '\p{^isosage}', "");
    Expect(0, 66811, '\P{isosage}', "");
    Expect(1, 66811, '\P{^isosage}', "");
    Expect(0, 66812, '\p{isosage}', "");
    Expect(1, 66812, '\p{^isosage}', "");
    Expect(1, 66812, '\P{isosage}', "");
    Expect(0, 66812, '\P{^isosage}', "");
    Expect(1, 66811, '\p{_IS_OSAGE}', "");
    Expect(0, 66811, '\p{^_IS_OSAGE}', "");
    Expect(0, 66811, '\P{_IS_OSAGE}', "");
    Expect(1, 66811, '\P{^_IS_OSAGE}', "");
    Expect(0, 66812, '\p{_IS_OSAGE}', "");
    Expect(1, 66812, '\p{^_IS_OSAGE}', "");
    Expect(1, 66812, '\P{_IS_OSAGE}', "");
    Expect(0, 66812, '\P{^_IS_OSAGE}', "");
    Error('\p{/a/-_Osge}');
    Error('\P{/a/-_Osge}');
    Expect(1, 66811, '\p{osge}', "");
    Expect(0, 66811, '\p{^osge}', "");
    Expect(0, 66811, '\P{osge}', "");
    Expect(1, 66811, '\P{^osge}', "");
    Expect(0, 66812, '\p{osge}', "");
    Expect(1, 66812, '\p{^osge}', "");
    Expect(1, 66812, '\P{osge}', "");
    Expect(0, 66812, '\P{^osge}', "");
    Expect(1, 66811, '\p{ Osge}', "");
    Expect(0, 66811, '\p{^ Osge}', "");
    Expect(0, 66811, '\P{ Osge}', "");
    Expect(1, 66811, '\P{^ Osge}', "");
    Expect(0, 66812, '\p{ Osge}', "");
    Expect(1, 66812, '\p{^ Osge}', "");
    Expect(1, 66812, '\P{ Osge}', "");
    Expect(0, 66812, '\P{^ Osge}', "");
    Error('\p{/a/-Is_Osge}');
    Error('\P{/a/-Is_Osge}');
    Expect(1, 66811, '\p{isosge}', "");
    Expect(0, 66811, '\p{^isosge}', "");
    Expect(0, 66811, '\P{isosge}', "");
    Expect(1, 66811, '\P{^isosge}', "");
    Expect(0, 66812, '\p{isosge}', "");
    Expect(1, 66812, '\p{^isosge}', "");
    Expect(1, 66812, '\P{isosge}', "");
    Expect(0, 66812, '\P{^isosge}', "");
    Expect(1, 66811, '\p{ -Is_osge}', "");
    Expect(0, 66811, '\p{^ -Is_osge}', "");
    Expect(0, 66811, '\P{ -Is_osge}', "");
    Expect(1, 66811, '\P{^ -Is_osge}', "");
    Expect(0, 66812, '\p{ -Is_osge}', "");
    Expect(1, 66812, '\p{^ -Is_osge}', "");
    Expect(1, 66812, '\P{ -Is_osge}', "");
    Expect(0, 66812, '\P{^ -Is_osge}', "");
    Error('\p{_	OSMANYA:=}');
    Error('\P{_	OSMANYA:=}');
    Expect(1, 66729, '\p{osmanya}', "");
    Expect(0, 66729, '\p{^osmanya}', "");
    Expect(0, 66729, '\P{osmanya}', "");
    Expect(1, 66729, '\P{^osmanya}', "");
    Expect(0, 66730, '\p{osmanya}', "");
    Expect(1, 66730, '\p{^osmanya}', "");
    Expect(1, 66730, '\P{osmanya}', "");
    Expect(0, 66730, '\P{^osmanya}', "");
    Expect(1, 66729, '\p{-_Osmanya}', "");
    Expect(0, 66729, '\p{^-_Osmanya}', "");
    Expect(0, 66729, '\P{-_Osmanya}', "");
    Expect(1, 66729, '\P{^-_Osmanya}', "");
    Expect(0, 66730, '\p{-_Osmanya}', "");
    Expect(1, 66730, '\p{^-_Osmanya}', "");
    Expect(1, 66730, '\P{-_Osmanya}', "");
    Expect(0, 66730, '\P{^-_Osmanya}', "");
    Error('\p{:=	 Is_OSMANYA}');
    Error('\P{:=	 Is_OSMANYA}');
    Expect(1, 66729, '\p{isosmanya}', "");
    Expect(0, 66729, '\p{^isosmanya}', "");
    Expect(0, 66729, '\P{isosmanya}', "");
    Expect(1, 66729, '\P{^isosmanya}', "");
    Expect(0, 66730, '\p{isosmanya}', "");
    Expect(1, 66730, '\p{^isosmanya}', "");
    Expect(1, 66730, '\P{isosmanya}', "");
    Expect(0, 66730, '\P{^isosmanya}', "");
    Expect(1, 66729, '\p{	 is_Osmanya}', "");
    Expect(0, 66729, '\p{^	 is_Osmanya}', "");
    Expect(0, 66729, '\P{	 is_Osmanya}', "");
    Expect(1, 66729, '\P{^	 is_Osmanya}', "");
    Expect(0, 66730, '\p{	 is_Osmanya}', "");
    Expect(1, 66730, '\p{^	 is_Osmanya}', "");
    Expect(1, 66730, '\P{	 is_Osmanya}', "");
    Expect(0, 66730, '\P{^	 is_Osmanya}', "");
    Error('\p{/a/	_Osma}');
    Error('\P{/a/	_Osma}');
    Expect(1, 66729, '\p{osma}', "");
    Expect(0, 66729, '\p{^osma}', "");
    Expect(0, 66729, '\P{osma}', "");
    Expect(1, 66729, '\P{^osma}', "");
    Expect(0, 66730, '\p{osma}', "");
    Expect(1, 66730, '\p{^osma}', "");
    Expect(1, 66730, '\P{osma}', "");
    Expect(0, 66730, '\P{^osma}', "");
    Expect(1, 66729, '\p{	_OSMA}', "");
    Expect(0, 66729, '\p{^	_OSMA}', "");
    Expect(0, 66729, '\P{	_OSMA}', "");
    Expect(1, 66729, '\P{^	_OSMA}', "");
    Expect(0, 66730, '\p{	_OSMA}', "");
    Expect(1, 66730, '\p{^	_OSMA}', "");
    Expect(1, 66730, '\P{	_OSMA}', "");
    Expect(0, 66730, '\P{^	_OSMA}', "");
    Error('\p{	_IS_Osma/a/}');
    Error('\P{	_IS_Osma/a/}');
    Expect(1, 66729, '\p{isosma}', "");
    Expect(0, 66729, '\p{^isosma}', "");
    Expect(0, 66729, '\P{isosma}', "");
    Expect(1, 66729, '\P{^isosma}', "");
    Expect(0, 66730, '\p{isosma}', "");
    Expect(1, 66730, '\p{^isosma}', "");
    Expect(1, 66730, '\P{isosma}', "");
    Expect(0, 66730, '\P{^isosma}', "");
    Expect(1, 66729, '\p{--Is_Osma}', "");
    Expect(0, 66729, '\p{^--Is_Osma}', "");
    Expect(0, 66729, '\P{--Is_Osma}', "");
    Expect(1, 66729, '\P{^--Is_Osma}', "");
    Expect(0, 66730, '\p{--Is_Osma}', "");
    Expect(1, 66730, '\p{^--Is_Osma}', "");
    Expect(1, 66730, '\P{--Is_Osma}', "");
    Expect(0, 66730, '\P{^--Is_Osma}', "");
    Error('\p{:=OTHER}');
    Error('\P{:=OTHER}');
    Expect(1, 918000, '\p{other}', "");
    Expect(0, 918000, '\p{^other}', "");
    Expect(0, 918000, '\P{other}', "");
    Expect(1, 918000, '\P{^other}', "");
    Expect(0, 917999, '\p{other}', "");
    Expect(1, 917999, '\p{^other}', "");
    Expect(1, 917999, '\P{other}', "");
    Expect(0, 917999, '\P{^other}', "");
    Expect(1, 918000, '\p{_-Other}', "");
    Expect(0, 918000, '\p{^_-Other}', "");
    Expect(0, 918000, '\P{_-Other}', "");
    Expect(1, 918000, '\P{^_-Other}', "");
    Expect(0, 917999, '\p{_-Other}', "");
    Expect(1, 917999, '\p{^_-Other}', "");
    Expect(1, 917999, '\P{_-Other}', "");
    Expect(0, 917999, '\P{^_-Other}', "");
    Error('\p{/a/_Is_other}');
    Error('\P{/a/_Is_other}');
    Expect(1, 918000, '\p{isother}', "");
    Expect(0, 918000, '\p{^isother}', "");
    Expect(0, 918000, '\P{isother}', "");
    Expect(1, 918000, '\P{^isother}', "");
    Expect(0, 917999, '\p{isother}', "");
    Expect(1, 917999, '\p{^isother}', "");
    Expect(1, 917999, '\P{isother}', "");
    Expect(0, 917999, '\P{^isother}', "");
    Expect(1, 918000, '\p{_	Is_Other}', "");
    Expect(0, 918000, '\p{^_	Is_Other}', "");
    Expect(0, 918000, '\P{_	Is_Other}', "");
    Expect(1, 918000, '\P{^_	Is_Other}', "");
    Expect(0, 917999, '\p{_	Is_Other}', "");
    Expect(1, 917999, '\p{^_	Is_Other}', "");
    Expect(1, 917999, '\P{_	Is_Other}', "");
    Expect(0, 917999, '\P{^_	Is_Other}', "");
    Error('\p{-:=c}');
    Error('\P{-:=c}');
    Expect(1, 918000, '\p{c}', "");
    Expect(0, 918000, '\p{^c}', "");
    Expect(0, 918000, '\P{c}', "");
    Expect(1, 918000, '\P{^c}', "");
    Expect(0, 917999, '\p{c}', "");
    Expect(1, 917999, '\p{^c}', "");
    Expect(1, 917999, '\P{c}', "");
    Expect(0, 917999, '\P{^c}', "");
    Expect(1, 918000, '\p{-C}', "");
    Expect(0, 918000, '\p{^-C}', "");
    Expect(0, 918000, '\P{-C}', "");
    Expect(1, 918000, '\P{^-C}', "");
    Expect(0, 917999, '\p{-C}', "");
    Expect(1, 917999, '\p{^-C}', "");
    Expect(1, 917999, '\P{-C}', "");
    Expect(0, 917999, '\P{^-C}', "");
    Error('\p{ _Is_C:=}');
    Error('\P{ _Is_C:=}');
    Expect(1, 918000, '\p{isc}', "");
    Expect(0, 918000, '\p{^isc}', "");
    Expect(0, 918000, '\P{isc}', "");
    Expect(1, 918000, '\P{^isc}', "");
    Expect(0, 917999, '\p{isc}', "");
    Expect(1, 917999, '\p{^isc}', "");
    Expect(1, 917999, '\P{isc}', "");
    Expect(0, 917999, '\P{^isc}', "");
    Expect(1, 918000, '\p{	Is_C}', "");
    Expect(0, 918000, '\p{^	Is_C}', "");
    Expect(0, 918000, '\P{	Is_C}', "");
    Expect(1, 918000, '\P{^	Is_C}', "");
    Expect(0, 917999, '\p{	Is_C}', "");
    Expect(1, 917999, '\p{^	Is_C}', "");
    Expect(1, 917999, '\P{	Is_C}', "");
    Expect(0, 917999, '\P{^	Is_C}', "");
    Error('\p{Other_Alphabetic}');
    Error('\P{Other_Alphabetic}');
    Error('\p{OAlpha}');
    Error('\P{OAlpha}');
    Error('\p{Other_Default_Ignorable_Code_Point}');
    Error('\P{Other_Default_Ignorable_Code_Point}');
    Error('\p{ODI}');
    Error('\P{ODI}');
    Error('\p{Other_Grapheme_Extend}');
    Error('\P{Other_Grapheme_Extend}');
    Error('\p{OGr_Ext}');
    Error('\P{OGr_Ext}');
    Error('\p{Other_ID_Continue}');
    Error('\P{Other_ID_Continue}');
    Error('\p{OIDC}');
    Error('\P{OIDC}');
    Error('\p{Other_ID_Start}');
    Error('\P{Other_ID_Start}');
    Error('\p{OIDS}');
    Error('\P{OIDS}');
    Error('\p{_/a/Other_Letter}');
    Error('\P{_/a/Other_Letter}');
    Expect(1, 195101, '\p{otherletter}', "");
    Expect(0, 195101, '\p{^otherletter}', "");
    Expect(0, 195101, '\P{otherletter}', "");
    Expect(1, 195101, '\P{^otherletter}', "");
    Expect(0, 195102, '\p{otherletter}', "");
    Expect(1, 195102, '\p{^otherletter}', "");
    Expect(1, 195102, '\P{otherletter}', "");
    Expect(0, 195102, '\P{^otherletter}', "");
    Expect(1, 195101, '\p{_OTHER_Letter}', "");
    Expect(0, 195101, '\p{^_OTHER_Letter}', "");
    Expect(0, 195101, '\P{_OTHER_Letter}', "");
    Expect(1, 195101, '\P{^_OTHER_Letter}', "");
    Expect(0, 195102, '\p{_OTHER_Letter}', "");
    Expect(1, 195102, '\p{^_OTHER_Letter}', "");
    Expect(1, 195102, '\P{_OTHER_Letter}', "");
    Expect(0, 195102, '\P{^_OTHER_Letter}', "");
    Error('\p{-IS_Other_Letter:=}');
    Error('\P{-IS_Other_Letter:=}');
    Expect(1, 195101, '\p{isotherletter}', "");
    Expect(0, 195101, '\p{^isotherletter}', "");
    Expect(0, 195101, '\P{isotherletter}', "");
    Expect(1, 195101, '\P{^isotherletter}', "");
    Expect(0, 195102, '\p{isotherletter}', "");
    Expect(1, 195102, '\p{^isotherletter}', "");
    Expect(1, 195102, '\P{isotherletter}', "");
    Expect(0, 195102, '\P{^isotherletter}', "");
    Expect(1, 195101, '\p{-is_Other_letter}', "");
    Expect(0, 195101, '\p{^-is_Other_letter}', "");
    Expect(0, 195101, '\P{-is_Other_letter}', "");
    Expect(1, 195101, '\P{^-is_Other_letter}', "");
    Expect(0, 195102, '\p{-is_Other_letter}', "");
    Expect(1, 195102, '\p{^-is_Other_letter}', "");
    Expect(1, 195102, '\P{-is_Other_letter}', "");
    Expect(0, 195102, '\P{^-is_Other_letter}', "");
    Error('\p{ -LO:=}');
    Error('\P{ -LO:=}');
    Expect(1, 195101, '\p{lo}', "");
    Expect(0, 195101, '\p{^lo}', "");
    Expect(0, 195101, '\P{lo}', "");
    Expect(1, 195101, '\P{^lo}', "");
    Expect(0, 195102, '\p{lo}', "");
    Expect(1, 195102, '\p{^lo}', "");
    Expect(1, 195102, '\P{lo}', "");
    Expect(0, 195102, '\P{^lo}', "");
    Expect(1, 195101, '\p{	lo}', "");
    Expect(0, 195101, '\p{^	lo}', "");
    Expect(0, 195101, '\P{	lo}', "");
    Expect(1, 195101, '\P{^	lo}', "");
    Expect(0, 195102, '\p{	lo}', "");
    Expect(1, 195102, '\p{^	lo}', "");
    Expect(1, 195102, '\P{	lo}', "");
    Expect(0, 195102, '\P{^	lo}', "");
    Error('\p{:=__Is_lo}');
    Error('\P{:=__Is_lo}');
    Expect(1, 195101, '\p{islo}', "");
    Expect(0, 195101, '\p{^islo}', "");
    Expect(0, 195101, '\P{islo}', "");
    Expect(1, 195101, '\P{^islo}', "");
    Expect(0, 195102, '\p{islo}', "");
    Expect(1, 195102, '\p{^islo}', "");
    Expect(1, 195102, '\P{islo}', "");
    Expect(0, 195102, '\P{^islo}', "");
    Expect(1, 195101, '\p{_	Is_Lo}', "");
    Expect(0, 195101, '\p{^_	Is_Lo}', "");
    Expect(0, 195101, '\P{_	Is_Lo}', "");
    Expect(1, 195101, '\P{^_	Is_Lo}', "");
    Expect(0, 195102, '\p{_	Is_Lo}', "");
    Expect(1, 195102, '\p{^_	Is_Lo}', "");
    Expect(1, 195102, '\P{_	Is_Lo}', "");
    Expect(0, 195102, '\P{^_	Is_Lo}', "");
    Error('\p{Other_Lowercase}');
    Error('\P{Other_Lowercase}');
    Error('\p{OLower}');
    Error('\P{OLower}');
    Error('\p{Other_Math}');
    Error('\P{Other_Math}');
    Error('\p{OMath}');
    Error('\P{OMath}');
    Error('\p{  other_Number/a/}');
    Error('\P{  other_Number/a/}');
    Expect(1, 127244, '\p{othernumber}', "");
    Expect(0, 127244, '\p{^othernumber}', "");
    Expect(0, 127244, '\P{othernumber}', "");
    Expect(1, 127244, '\P{^othernumber}', "");
    Expect(0, 127245, '\p{othernumber}', "");
    Expect(1, 127245, '\p{^othernumber}', "");
    Expect(1, 127245, '\P{othernumber}', "");
    Expect(0, 127245, '\P{^othernumber}', "");
    Expect(1, 127244, '\p{_Other_Number}', "");
    Expect(0, 127244, '\p{^_Other_Number}', "");
    Expect(0, 127244, '\P{_Other_Number}', "");
    Expect(1, 127244, '\P{^_Other_Number}', "");
    Expect(0, 127245, '\p{_Other_Number}', "");
    Expect(1, 127245, '\p{^_Other_Number}', "");
    Expect(1, 127245, '\P{_Other_Number}', "");
    Expect(0, 127245, '\P{^_Other_Number}', "");
    Error('\p{-Is_other_NUMBER:=}');
    Error('\P{-Is_other_NUMBER:=}');
    Expect(1, 127244, '\p{isothernumber}', "");
    Expect(0, 127244, '\p{^isothernumber}', "");
    Expect(0, 127244, '\P{isothernumber}', "");
    Expect(1, 127244, '\P{^isothernumber}', "");
    Expect(0, 127245, '\p{isothernumber}', "");
    Expect(1, 127245, '\p{^isothernumber}', "");
    Expect(1, 127245, '\P{isothernumber}', "");
    Expect(0, 127245, '\P{^isothernumber}', "");
    Expect(1, 127244, '\p{-	is_Other_Number}', "");
    Expect(0, 127244, '\p{^-	is_Other_Number}', "");
    Expect(0, 127244, '\P{-	is_Other_Number}', "");
    Expect(1, 127244, '\P{^-	is_Other_Number}', "");
    Expect(0, 127245, '\p{-	is_Other_Number}', "");
    Expect(1, 127245, '\p{^-	is_Other_Number}', "");
    Expect(1, 127245, '\P{-	is_Other_Number}', "");
    Expect(0, 127245, '\P{^-	is_Other_Number}', "");
    Error('\p{_:=NO}');
    Error('\P{_:=NO}');
    Expect(1, 127244, '\p{no}', "");
    Expect(0, 127244, '\p{^no}', "");
    Expect(0, 127244, '\P{no}', "");
    Expect(1, 127244, '\P{^no}', "");
    Expect(0, 127245, '\p{no}', "");
    Expect(1, 127245, '\p{^no}', "");
    Expect(1, 127245, '\P{no}', "");
    Expect(0, 127245, '\P{^no}', "");
    Expect(1, 127244, '\p{- No}', "");
    Expect(0, 127244, '\p{^- No}', "");
    Expect(0, 127244, '\P{- No}', "");
    Expect(1, 127244, '\P{^- No}', "");
    Expect(0, 127245, '\p{- No}', "");
    Expect(1, 127245, '\p{^- No}', "");
    Expect(1, 127245, '\P{- No}', "");
    Expect(0, 127245, '\P{^- No}', "");
    Error('\p{/a/_-Is_NO}');
    Error('\P{/a/_-Is_NO}');
    Expect(1, 127244, '\p{isno}', "");
    Expect(0, 127244, '\p{^isno}', "");
    Expect(0, 127244, '\P{isno}', "");
    Expect(1, 127244, '\P{^isno}', "");
    Expect(0, 127245, '\p{isno}', "");
    Expect(1, 127245, '\p{^isno}', "");
    Expect(1, 127245, '\P{isno}', "");
    Expect(0, 127245, '\P{^isno}', "");
    Expect(1, 127244, '\p{_IS_NO}', "");
    Expect(0, 127244, '\p{^_IS_NO}', "");
    Expect(0, 127244, '\P{_IS_NO}', "");
    Expect(1, 127244, '\P{^_IS_NO}', "");
    Expect(0, 127245, '\p{_IS_NO}', "");
    Expect(1, 127245, '\p{^_IS_NO}', "");
    Expect(1, 127245, '\P{_IS_NO}', "");
    Expect(0, 127245, '\P{^_IS_NO}', "");
    Error('\p{	-Other_punctuation/a/}');
    Error('\P{	-Other_punctuation/a/}');
    Expect(1, 125279, '\p{otherpunctuation}', "");
    Expect(0, 125279, '\p{^otherpunctuation}', "");
    Expect(0, 125279, '\P{otherpunctuation}', "");
    Expect(1, 125279, '\P{^otherpunctuation}', "");
    Expect(0, 125280, '\p{otherpunctuation}', "");
    Expect(1, 125280, '\p{^otherpunctuation}', "");
    Expect(1, 125280, '\P{otherpunctuation}', "");
    Expect(0, 125280, '\P{^otherpunctuation}', "");
    Expect(1, 125279, '\p{-Other_PUNCTUATION}', "");
    Expect(0, 125279, '\p{^-Other_PUNCTUATION}', "");
    Expect(0, 125279, '\P{-Other_PUNCTUATION}', "");
    Expect(1, 125279, '\P{^-Other_PUNCTUATION}', "");
    Expect(0, 125280, '\p{-Other_PUNCTUATION}', "");
    Expect(1, 125280, '\p{^-Other_PUNCTUATION}', "");
    Expect(1, 125280, '\P{-Other_PUNCTUATION}', "");
    Expect(0, 125280, '\P{^-Other_PUNCTUATION}', "");
    Error('\p{Is_Other_Punctuation/a/}');
    Error('\P{Is_Other_Punctuation/a/}');
    Expect(1, 125279, '\p{isotherpunctuation}', "");
    Expect(0, 125279, '\p{^isotherpunctuation}', "");
    Expect(0, 125279, '\P{isotherpunctuation}', "");
    Expect(1, 125279, '\P{^isotherpunctuation}', "");
    Expect(0, 125280, '\p{isotherpunctuation}', "");
    Expect(1, 125280, '\p{^isotherpunctuation}', "");
    Expect(1, 125280, '\P{isotherpunctuation}', "");
    Expect(0, 125280, '\P{^isotherpunctuation}', "");
    Expect(1, 125279, '\p{ _IS_other_Punctuation}', "");
    Expect(0, 125279, '\p{^ _IS_other_Punctuation}', "");
    Expect(0, 125279, '\P{ _IS_other_Punctuation}', "");
    Expect(1, 125279, '\P{^ _IS_other_Punctuation}', "");
    Expect(0, 125280, '\p{ _IS_other_Punctuation}', "");
    Expect(1, 125280, '\p{^ _IS_other_Punctuation}', "");
    Expect(1, 125280, '\P{ _IS_other_Punctuation}', "");
    Expect(0, 125280, '\P{^ _IS_other_Punctuation}', "");
    Error('\p{ -Po/a/}');
    Error('\P{ -Po/a/}');
    Expect(1, 125279, '\p{po}', "");
    Expect(0, 125279, '\p{^po}', "");
    Expect(0, 125279, '\P{po}', "");
    Expect(1, 125279, '\P{^po}', "");
    Expect(0, 125280, '\p{po}', "");
    Expect(1, 125280, '\p{^po}', "");
    Expect(1, 125280, '\P{po}', "");
    Expect(0, 125280, '\P{^po}', "");
    Expect(1, 125279, '\p{ 	Po}', "");
    Expect(0, 125279, '\p{^ 	Po}', "");
    Expect(0, 125279, '\P{ 	Po}', "");
    Expect(1, 125279, '\P{^ 	Po}', "");
    Expect(0, 125280, '\p{ 	Po}', "");
    Expect(1, 125280, '\p{^ 	Po}', "");
    Expect(1, 125280, '\P{ 	Po}', "");
    Expect(0, 125280, '\P{^ 	Po}', "");
    Error('\p{	:=is_po}');
    Error('\P{	:=is_po}');
    Expect(1, 125279, '\p{ispo}', "");
    Expect(0, 125279, '\p{^ispo}', "");
    Expect(0, 125279, '\P{ispo}', "");
    Expect(1, 125279, '\P{^ispo}', "");
    Expect(0, 125280, '\p{ispo}', "");
    Expect(1, 125280, '\p{^ispo}', "");
    Expect(1, 125280, '\P{ispo}', "");
    Expect(0, 125280, '\P{^ispo}', "");
    Expect(1, 125279, '\p{		IS_po}', "");
    Expect(0, 125279, '\p{^		IS_po}', "");
    Expect(0, 125279, '\P{		IS_po}', "");
    Expect(1, 125279, '\P{^		IS_po}', "");
    Expect(0, 125280, '\p{		IS_po}', "");
    Expect(1, 125280, '\p{^		IS_po}', "");
    Expect(1, 125280, '\P{		IS_po}', "");
    Expect(0, 125280, '\P{^		IS_po}', "");
    Error('\p{		Other_Symbol/a/}');
    Error('\P{		Other_Symbol/a/}');
    Expect(1, 129685, '\p{othersymbol}', "");
    Expect(0, 129685, '\p{^othersymbol}', "");
    Expect(0, 129685, '\P{othersymbol}', "");
    Expect(1, 129685, '\P{^othersymbol}', "");
    Expect(0, 129686, '\p{othersymbol}', "");
    Expect(1, 129686, '\p{^othersymbol}', "");
    Expect(1, 129686, '\P{othersymbol}', "");
    Expect(0, 129686, '\P{^othersymbol}', "");
    Expect(1, 129685, '\p{ OTHER_symbol}', "");
    Expect(0, 129685, '\p{^ OTHER_symbol}', "");
    Expect(0, 129685, '\P{ OTHER_symbol}', "");
    Expect(1, 129685, '\P{^ OTHER_symbol}', "");
    Expect(0, 129686, '\p{ OTHER_symbol}', "");
    Expect(1, 129686, '\p{^ OTHER_symbol}', "");
    Expect(1, 129686, '\P{ OTHER_symbol}', "");
    Expect(0, 129686, '\P{^ OTHER_symbol}', "");
    Error('\p{/a/	is_OTHER_Symbol}');
    Error('\P{/a/	is_OTHER_Symbol}');
    Expect(1, 129685, '\p{isothersymbol}', "");
    Expect(0, 129685, '\p{^isothersymbol}', "");
    Expect(0, 129685, '\P{isothersymbol}', "");
    Expect(1, 129685, '\P{^isothersymbol}', "");
    Expect(0, 129686, '\p{isothersymbol}', "");
    Expect(1, 129686, '\p{^isothersymbol}', "");
    Expect(1, 129686, '\P{isothersymbol}', "");
    Expect(0, 129686, '\P{^isothersymbol}', "");
    Expect(1, 129685, '\p{_IS_OTHER_Symbol}', "");
    Expect(0, 129685, '\p{^_IS_OTHER_Symbol}', "");
    Expect(0, 129685, '\P{_IS_OTHER_Symbol}', "");
    Expect(1, 129685, '\P{^_IS_OTHER_Symbol}', "");
    Expect(0, 129686, '\p{_IS_OTHER_Symbol}', "");
    Expect(1, 129686, '\p{^_IS_OTHER_Symbol}', "");
    Expect(1, 129686, '\P{_IS_OTHER_Symbol}', "");
    Expect(0, 129686, '\P{^_IS_OTHER_Symbol}', "");
    Error('\p{-/a/SO}');
    Error('\P{-/a/SO}');
    Expect(1, 129685, '\p{so}', "");
    Expect(0, 129685, '\p{^so}', "");
    Expect(0, 129685, '\P{so}', "");
    Expect(1, 129685, '\P{^so}', "");
    Expect(0, 129686, '\p{so}', "");
    Expect(1, 129686, '\p{^so}', "");
    Expect(1, 129686, '\P{so}', "");
    Expect(0, 129686, '\P{^so}', "");
    Expect(1, 129685, '\p{_-So}', "");
    Expect(0, 129685, '\p{^_-So}', "");
    Expect(0, 129685, '\P{_-So}', "");
    Expect(1, 129685, '\P{^_-So}', "");
    Expect(0, 129686, '\p{_-So}', "");
    Expect(1, 129686, '\p{^_-So}', "");
    Expect(1, 129686, '\P{_-So}', "");
    Expect(0, 129686, '\P{^_-So}', "");
    Error('\p{:= 	Is_SO}');
    Error('\P{:= 	Is_SO}');
    Expect(1, 129685, '\p{isso}', "");
    Expect(0, 129685, '\p{^isso}', "");
    Expect(0, 129685, '\P{isso}', "");
    Expect(1, 129685, '\P{^isso}', "");
    Expect(0, 129686, '\p{isso}', "");
    Expect(1, 129686, '\p{^isso}', "");
    Expect(1, 129686, '\P{isso}', "");
    Expect(0, 129686, '\P{^isso}', "");
    Expect(1, 129685, '\p{- is_So}', "");
    Expect(0, 129685, '\p{^- is_So}', "");
    Expect(0, 129685, '\P{- is_So}', "");
    Expect(1, 129685, '\P{^- is_So}', "");
    Expect(0, 129686, '\p{- is_So}', "");
    Expect(1, 129686, '\p{^- is_So}', "");
    Expect(1, 129686, '\P{- is_So}', "");
    Expect(0, 129686, '\P{^- is_So}', "");
    Error('\p{Other_Uppercase}');
    Error('\P{Other_Uppercase}');
    Error('\p{OUpper}');
    Error('\P{OUpper}');
    Error('\p{/a/	 ottoman_Siyaq_Numbers}');
    Error('\P{/a/	 ottoman_Siyaq_Numbers}');
    Expect(1, 126287, '\p{ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\p{^ottomansiyaqnumbers}', "");
    Expect(0, 126287, '\P{ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\P{^ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\p{ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\p{^ottomansiyaqnumbers}', "");
    Expect(1, 126288, '\P{ottomansiyaqnumbers}', "");
    Expect(0, 126288, '\P{^ottomansiyaqnumbers}', "");
    Expect(1, 126287, '\p{_-Ottoman_SIYAQ_Numbers}', "");
    Expect(0, 126287, '\p{^_-Ottoman_SIYAQ_Numbers}', "");
    Expect(0, 126287, '\P{_-Ottoman_SIYAQ_Numbers}', "");
    Expect(1, 126287, '\P{^_-Ottoman_SIYAQ_Numbers}', "");
    Expect(0, 126288, '\p{_-Ottoman_SIYAQ_Numbers}', "");
    Expect(1, 126288, '\p{^_-Ottoman_SIYAQ_Numbers}', "");
    Expect(1, 126288, '\P{_-Ottoman_SIYAQ_Numbers}', "");
    Expect(0, 126288, '\P{^_-Ottoman_SIYAQ_Numbers}', "");
    Error('\p{	:=is_OTTOMAN_Siyaq_NUMBERS}');
    Error('\P{	:=is_OTTOMAN_Siyaq_NUMBERS}');
    Expect(1, 126287, '\p{isottomansiyaqnumbers}', "");
    Expect(0, 126287, '\p{^isottomansiyaqnumbers}', "");
    Expect(0, 126287, '\P{isottomansiyaqnumbers}', "");
    Expect(1, 126287, '\P{^isottomansiyaqnumbers}', "");
    Expect(0, 126288, '\p{isottomansiyaqnumbers}', "");
    Expect(1, 126288, '\p{^isottomansiyaqnumbers}', "");
    Expect(1, 126288, '\P{isottomansiyaqnumbers}', "");
    Expect(0, 126288, '\P{^isottomansiyaqnumbers}', "");
    Expect(1, 126287, '\p{	IS_OTTOMAN_Siyaq_numbers}', "");
    Expect(0, 126287, '\p{^	IS_OTTOMAN_Siyaq_numbers}', "");
    Expect(0, 126287, '\P{	IS_OTTOMAN_Siyaq_numbers}', "");
    Expect(1, 126287, '\P{^	IS_OTTOMAN_Siyaq_numbers}', "");
    Expect(0, 126288, '\p{	IS_OTTOMAN_Siyaq_numbers}', "");
    Expect(1, 126288, '\p{^	IS_OTTOMAN_Siyaq_numbers}', "");
    Expect(1, 126288, '\P{	IS_OTTOMAN_Siyaq_numbers}', "");
    Expect(0, 126288, '\P{^	IS_OTTOMAN_Siyaq_numbers}', "");
    Error('\p{/a/ -In_Ottoman_SIYAQ_Numbers}');
    Error('\P{/a/ -In_Ottoman_SIYAQ_Numbers}');
    Expect(1, 126287, '\p{inottomansiyaqnumbers}', "");
    Expect(0, 126287, '\p{^inottomansiyaqnumbers}', "");
    Expect(0, 126287, '\P{inottomansiyaqnumbers}', "");
    Expect(1, 126287, '\P{^inottomansiyaqnumbers}', "");
    Expect(0, 126288, '\p{inottomansiyaqnumbers}', "");
    Expect(1, 126288, '\p{^inottomansiyaqnumbers}', "");
    Expect(1, 126288, '\P{inottomansiyaqnumbers}', "");
    Expect(0, 126288, '\P{^inottomansiyaqnumbers}', "");
    Expect(1, 126287, '\p{--In_Ottoman_siyaq_Numbers}', "");
    Expect(0, 126287, '\p{^--In_Ottoman_siyaq_Numbers}', "");
    Expect(0, 126287, '\P{--In_Ottoman_siyaq_Numbers}', "");
    Expect(1, 126287, '\P{^--In_Ottoman_siyaq_Numbers}', "");
    Expect(0, 126288, '\p{--In_Ottoman_siyaq_Numbers}', "");
    Expect(1, 126288, '\p{^--In_Ottoman_siyaq_Numbers}', "");
    Expect(1, 126288, '\P{--In_Ottoman_siyaq_Numbers}', "");
    Expect(0, 126288, '\P{^--In_Ottoman_siyaq_Numbers}', "");
    Error('\p{/a/_ Pahawh_Hmong}');
    Error('\P{/a/_ Pahawh_Hmong}');
    Expect(1, 93071, '\p{pahawhhmong}', "");
    Expect(0, 93071, '\p{^pahawhhmong}', "");
    Expect(0, 93071, '\P{pahawhhmong}', "");
    Expect(1, 93071, '\P{^pahawhhmong}', "");
    Expect(0, 93072, '\p{pahawhhmong}', "");
    Expect(1, 93072, '\p{^pahawhhmong}', "");
    Expect(1, 93072, '\P{pahawhhmong}', "");
    Expect(0, 93072, '\P{^pahawhhmong}', "");
    Expect(1, 93071, '\p{_ pahawh_Hmong}', "");
    Expect(0, 93071, '\p{^_ pahawh_Hmong}', "");
    Expect(0, 93071, '\P{_ pahawh_Hmong}', "");
    Expect(1, 93071, '\P{^_ pahawh_Hmong}', "");
    Expect(0, 93072, '\p{_ pahawh_Hmong}', "");
    Expect(1, 93072, '\p{^_ pahawh_Hmong}', "");
    Expect(1, 93072, '\P{_ pahawh_Hmong}', "");
    Expect(0, 93072, '\P{^_ pahawh_Hmong}', "");
    Error('\p{-_Is_Pahawh_HMONG/a/}');
    Error('\P{-_Is_Pahawh_HMONG/a/}');
    Expect(1, 93071, '\p{ispahawhhmong}', "");
    Expect(0, 93071, '\p{^ispahawhhmong}', "");
    Expect(0, 93071, '\P{ispahawhhmong}', "");
    Expect(1, 93071, '\P{^ispahawhhmong}', "");
    Expect(0, 93072, '\p{ispahawhhmong}', "");
    Expect(1, 93072, '\p{^ispahawhhmong}', "");
    Expect(1, 93072, '\P{ispahawhhmong}', "");
    Expect(0, 93072, '\P{^ispahawhhmong}', "");
    Expect(1, 93071, '\p{  is_Pahawh_Hmong}', "");
    Expect(0, 93071, '\p{^  is_Pahawh_Hmong}', "");
    Expect(0, 93071, '\P{  is_Pahawh_Hmong}', "");
    Expect(1, 93071, '\P{^  is_Pahawh_Hmong}', "");
    Expect(0, 93072, '\p{  is_Pahawh_Hmong}', "");
    Expect(1, 93072, '\p{^  is_Pahawh_Hmong}', "");
    Expect(1, 93072, '\P{  is_Pahawh_Hmong}', "");
    Expect(0, 93072, '\P{^  is_Pahawh_Hmong}', "");
    Error('\p{Hmng/a/}');
    Error('\P{Hmng/a/}');
    Expect(1, 93071, '\p{hmng}', "");
    Expect(0, 93071, '\p{^hmng}', "");
    Expect(0, 93071, '\P{hmng}', "");
    Expect(1, 93071, '\P{^hmng}', "");
    Expect(0, 93072, '\p{hmng}', "");
    Expect(1, 93072, '\p{^hmng}', "");
    Expect(1, 93072, '\P{hmng}', "");
    Expect(0, 93072, '\P{^hmng}', "");
    Expect(1, 93071, '\p{		HMNG}', "");
    Expect(0, 93071, '\p{^		HMNG}', "");
    Expect(0, 93071, '\P{		HMNG}', "");
    Expect(1, 93071, '\P{^		HMNG}', "");
    Expect(0, 93072, '\p{		HMNG}', "");
    Expect(1, 93072, '\p{^		HMNG}', "");
    Expect(1, 93072, '\P{		HMNG}', "");
    Expect(0, 93072, '\P{^		HMNG}', "");
    Error('\p{_-is_hmng:=}');
    Error('\P{_-is_hmng:=}');
    Expect(1, 93071, '\p{ishmng}', "");
    Expect(0, 93071, '\p{^ishmng}', "");
    Expect(0, 93071, '\P{ishmng}', "");
    Expect(1, 93071, '\P{^ishmng}', "");
    Expect(0, 93072, '\p{ishmng}', "");
    Expect(1, 93072, '\p{^ishmng}', "");
    Expect(1, 93072, '\P{ishmng}', "");
    Expect(0, 93072, '\P{^ishmng}', "");
    Expect(1, 93071, '\p{_-Is_Hmng}', "");
    Expect(0, 93071, '\p{^_-Is_Hmng}', "");
    Expect(0, 93071, '\P{_-Is_Hmng}', "");
    Expect(1, 93071, '\P{^_-Is_Hmng}', "");
    Expect(0, 93072, '\p{_-Is_Hmng}', "");
    Expect(1, 93072, '\p{^_-Is_Hmng}', "");
    Expect(1, 93072, '\P{_-Is_Hmng}', "");
    Expect(0, 93072, '\P{^_-Is_Hmng}', "");
    Error('\p{-:=Palmyrene}');
    Error('\P{-:=Palmyrene}');
    Expect(1, 67711, '\p{palmyrene}', "");
    Expect(0, 67711, '\p{^palmyrene}', "");
    Expect(0, 67711, '\P{palmyrene}', "");
    Expect(1, 67711, '\P{^palmyrene}', "");
    Expect(0, 67712, '\p{palmyrene}', "");
    Expect(1, 67712, '\p{^palmyrene}', "");
    Expect(1, 67712, '\P{palmyrene}', "");
    Expect(0, 67712, '\P{^palmyrene}', "");
    Expect(1, 67711, '\p{_Palmyrene}', "");
    Expect(0, 67711, '\p{^_Palmyrene}', "");
    Expect(0, 67711, '\P{_Palmyrene}', "");
    Expect(1, 67711, '\P{^_Palmyrene}', "");
    Expect(0, 67712, '\p{_Palmyrene}', "");
    Expect(1, 67712, '\p{^_Palmyrene}', "");
    Expect(1, 67712, '\P{_Palmyrene}', "");
    Expect(0, 67712, '\P{^_Palmyrene}', "");
    Error('\p{--Is_Palmyrene/a/}');
    Error('\P{--Is_Palmyrene/a/}');
    Expect(1, 67711, '\p{ispalmyrene}', "");
    Expect(0, 67711, '\p{^ispalmyrene}', "");
    Expect(0, 67711, '\P{ispalmyrene}', "");
    Expect(1, 67711, '\P{^ispalmyrene}', "");
    Expect(0, 67712, '\p{ispalmyrene}', "");
    Expect(1, 67712, '\p{^ispalmyrene}', "");
    Expect(1, 67712, '\P{ispalmyrene}', "");
    Expect(0, 67712, '\P{^ispalmyrene}', "");
    Expect(1, 67711, '\p{IS_Palmyrene}', "");
    Expect(0, 67711, '\p{^IS_Palmyrene}', "");
    Expect(0, 67711, '\P{IS_Palmyrene}', "");
    Expect(1, 67711, '\P{^IS_Palmyrene}', "");
    Expect(0, 67712, '\p{IS_Palmyrene}', "");
    Expect(1, 67712, '\p{^IS_Palmyrene}', "");
    Expect(1, 67712, '\P{IS_Palmyrene}', "");
    Expect(0, 67712, '\P{^IS_Palmyrene}', "");
    Error('\p{/a/_PALM}');
    Error('\P{/a/_PALM}');
    Expect(1, 67711, '\p{palm}', "");
    Expect(0, 67711, '\p{^palm}', "");
    Expect(0, 67711, '\P{palm}', "");
    Expect(1, 67711, '\P{^palm}', "");
    Expect(0, 67712, '\p{palm}', "");
    Expect(1, 67712, '\p{^palm}', "");
    Expect(1, 67712, '\P{palm}', "");
    Expect(0, 67712, '\P{^palm}', "");
    Expect(1, 67711, '\p{ -palm}', "");
    Expect(0, 67711, '\p{^ -palm}', "");
    Expect(0, 67711, '\P{ -palm}', "");
    Expect(1, 67711, '\P{^ -palm}', "");
    Expect(0, 67712, '\p{ -palm}', "");
    Expect(1, 67712, '\p{^ -palm}', "");
    Expect(1, 67712, '\P{ -palm}', "");
    Expect(0, 67712, '\P{^ -palm}', "");
    Error('\p{	/a/Is_palm}');
    Error('\P{	/a/Is_palm}');
    Expect(1, 67711, '\p{ispalm}', "");
    Expect(0, 67711, '\p{^ispalm}', "");
    Expect(0, 67711, '\P{ispalm}', "");
    Expect(1, 67711, '\P{^ispalm}', "");
    Expect(0, 67712, '\p{ispalm}', "");
    Expect(1, 67712, '\p{^ispalm}', "");
    Expect(1, 67712, '\P{ispalm}', "");
    Expect(0, 67712, '\P{^ispalm}', "");
    Expect(1, 67711, '\p{_Is_Palm}', "");
    Expect(0, 67711, '\p{^_Is_Palm}', "");
    Expect(0, 67711, '\P{_Is_Palm}', "");
    Expect(1, 67711, '\P{^_Is_Palm}', "");
    Expect(0, 67712, '\p{_Is_Palm}', "");
    Expect(1, 67712, '\p{^_Is_Palm}', "");
    Expect(1, 67712, '\P{_Is_Palm}', "");
    Expect(0, 67712, '\P{^_Is_Palm}', "");
    Error('\p{-	Paragraph_separator/a/}');
    Error('\P{-	Paragraph_separator/a/}');
    Expect(1, 8233, '\p{paragraphseparator}', "");
    Expect(0, 8233, '\p{^paragraphseparator}', "");
    Expect(0, 8233, '\P{paragraphseparator}', "");
    Expect(1, 8233, '\P{^paragraphseparator}', "");
    Expect(0, 8234, '\p{paragraphseparator}', "");
    Expect(1, 8234, '\p{^paragraphseparator}', "");
    Expect(1, 8234, '\P{paragraphseparator}', "");
    Expect(0, 8234, '\P{^paragraphseparator}', "");
    Expect(1, 8233, '\p{	Paragraph_separator}', "");
    Expect(0, 8233, '\p{^	Paragraph_separator}', "");
    Expect(0, 8233, '\P{	Paragraph_separator}', "");
    Expect(1, 8233, '\P{^	Paragraph_separator}', "");
    Expect(0, 8234, '\p{	Paragraph_separator}', "");
    Expect(1, 8234, '\p{^	Paragraph_separator}', "");
    Expect(1, 8234, '\P{	Paragraph_separator}', "");
    Expect(0, 8234, '\P{^	Paragraph_separator}', "");
    Error('\p{/a/	 is_Paragraph_separator}');
    Error('\P{/a/	 is_Paragraph_separator}');
    Expect(1, 8233, '\p{isparagraphseparator}', "");
    Expect(0, 8233, '\p{^isparagraphseparator}', "");
    Expect(0, 8233, '\P{isparagraphseparator}', "");
    Expect(1, 8233, '\P{^isparagraphseparator}', "");
    Expect(0, 8234, '\p{isparagraphseparator}', "");
    Expect(1, 8234, '\p{^isparagraphseparator}', "");
    Expect(1, 8234, '\P{isparagraphseparator}', "");
    Expect(0, 8234, '\P{^isparagraphseparator}', "");
    Expect(1, 8233, '\p{_is_PARAGRAPH_SEPARATOR}', "");
    Expect(0, 8233, '\p{^_is_PARAGRAPH_SEPARATOR}', "");
    Expect(0, 8233, '\P{_is_PARAGRAPH_SEPARATOR}', "");
    Expect(1, 8233, '\P{^_is_PARAGRAPH_SEPARATOR}', "");
    Expect(0, 8234, '\p{_is_PARAGRAPH_SEPARATOR}', "");
    Expect(1, 8234, '\p{^_is_PARAGRAPH_SEPARATOR}', "");
    Expect(1, 8234, '\P{_is_PARAGRAPH_SEPARATOR}', "");
    Expect(0, 8234, '\P{^_is_PARAGRAPH_SEPARATOR}', "");
    Error('\p{ /a/zp}');
    Error('\P{ /a/zp}');
    Expect(1, 8233, '\p{zp}', "");
    Expect(0, 8233, '\p{^zp}', "");
    Expect(0, 8233, '\P{zp}', "");
    Expect(1, 8233, '\P{^zp}', "");
    Expect(0, 8234, '\p{zp}', "");
    Expect(1, 8234, '\p{^zp}', "");
    Expect(1, 8234, '\P{zp}', "");
    Expect(0, 8234, '\P{^zp}', "");
    Expect(1, 8233, '\p{Zp}', "");
    Expect(0, 8233, '\p{^Zp}', "");
    Expect(0, 8233, '\P{Zp}', "");
    Expect(1, 8233, '\P{^Zp}', "");
    Expect(0, 8234, '\p{Zp}', "");
    Expect(1, 8234, '\p{^Zp}', "");
    Expect(1, 8234, '\P{Zp}', "");
    Expect(0, 8234, '\P{^Zp}', "");
    Error('\p{/a/  Is_Zp}');
    Error('\P{/a/  Is_Zp}');
    Expect(1, 8233, '\p{iszp}', "");
    Expect(0, 8233, '\p{^iszp}', "");
    Expect(0, 8233, '\P{iszp}', "");
    Expect(1, 8233, '\P{^iszp}', "");
    Expect(0, 8234, '\p{iszp}', "");
    Expect(1, 8234, '\p{^iszp}', "");
    Expect(1, 8234, '\P{iszp}', "");
    Expect(0, 8234, '\P{^iszp}', "");
    Expect(1, 8233, '\p{ IS_ZP}', "");
    Expect(0, 8233, '\p{^ IS_ZP}', "");
    Expect(0, 8233, '\P{ IS_ZP}', "");
    Expect(1, 8233, '\P{^ IS_ZP}', "");
    Expect(0, 8234, '\p{ IS_ZP}', "");
    Expect(1, 8234, '\p{^ IS_ZP}', "");
    Expect(1, 8234, '\P{ IS_ZP}', "");
    Expect(0, 8234, '\P{^ IS_ZP}', "");
    Error('\p{/a/-pattern_Syntax}');
    Error('\P{/a/-pattern_Syntax}');
    Expect(1, 65094, '\p{patternsyntax}', "");
    Expect(0, 65094, '\p{^patternsyntax}', "");
    Expect(0, 65094, '\P{patternsyntax}', "");
    Expect(1, 65094, '\P{^patternsyntax}', "");
    Expect(0, 65095, '\p{patternsyntax}', "");
    Expect(1, 65095, '\p{^patternsyntax}', "");
    Expect(1, 65095, '\P{patternsyntax}', "");
    Expect(0, 65095, '\P{^patternsyntax}', "");
    Expect(1, 65094, '\p{-pattern_Syntax}', "");
    Expect(0, 65094, '\p{^-pattern_Syntax}', "");
    Expect(0, 65094, '\P{-pattern_Syntax}', "");
    Expect(1, 65094, '\P{^-pattern_Syntax}', "");
    Expect(0, 65095, '\p{-pattern_Syntax}', "");
    Expect(1, 65095, '\p{^-pattern_Syntax}', "");
    Expect(1, 65095, '\P{-pattern_Syntax}', "");
    Expect(0, 65095, '\P{^-pattern_Syntax}', "");
    Error('\p{:=_ IS_Pattern_SYNTAX}');
    Error('\P{:=_ IS_Pattern_SYNTAX}');
    Expect(1, 65094, '\p{ispatternsyntax}', "");
    Expect(0, 65094, '\p{^ispatternsyntax}', "");
    Expect(0, 65094, '\P{ispatternsyntax}', "");
    Expect(1, 65094, '\P{^ispatternsyntax}', "");
    Expect(0, 65095, '\p{ispatternsyntax}', "");
    Expect(1, 65095, '\p{^ispatternsyntax}', "");
    Expect(1, 65095, '\P{ispatternsyntax}', "");
    Expect(0, 65095, '\P{^ispatternsyntax}', "");
    Expect(1, 65094, '\p{-is_PATTERN_SYNTAX}', "");
    Expect(0, 65094, '\p{^-is_PATTERN_SYNTAX}', "");
    Expect(0, 65094, '\P{-is_PATTERN_SYNTAX}', "");
    Expect(1, 65094, '\P{^-is_PATTERN_SYNTAX}', "");
    Expect(0, 65095, '\p{-is_PATTERN_SYNTAX}', "");
    Expect(1, 65095, '\p{^-is_PATTERN_SYNTAX}', "");
    Expect(1, 65095, '\P{-is_PATTERN_SYNTAX}', "");
    Expect(0, 65095, '\P{^-is_PATTERN_SYNTAX}', "");
    Error('\p{		Pat_Syn:=}');
    Error('\P{		Pat_Syn:=}');
    Expect(1, 65094, '\p{patsyn}', "");
    Expect(0, 65094, '\p{^patsyn}', "");
    Expect(0, 65094, '\P{patsyn}', "");
    Expect(1, 65094, '\P{^patsyn}', "");
    Expect(0, 65095, '\p{patsyn}', "");
    Expect(1, 65095, '\p{^patsyn}', "");
    Expect(1, 65095, '\P{patsyn}', "");
    Expect(0, 65095, '\P{^patsyn}', "");
    Expect(1, 65094, '\p{-	Pat_syn}', "");
    Expect(0, 65094, '\p{^-	Pat_syn}', "");
    Expect(0, 65094, '\P{-	Pat_syn}', "");
    Expect(1, 65094, '\P{^-	Pat_syn}', "");
    Expect(0, 65095, '\p{-	Pat_syn}', "");
    Expect(1, 65095, '\p{^-	Pat_syn}', "");
    Expect(1, 65095, '\P{-	Pat_syn}', "");
    Expect(0, 65095, '\P{^-	Pat_syn}', "");
    Error('\p{_/a/Is_Pat_SYN}');
    Error('\P{_/a/Is_Pat_SYN}');
    Expect(1, 65094, '\p{ispatsyn}', "");
    Expect(0, 65094, '\p{^ispatsyn}', "");
    Expect(0, 65094, '\P{ispatsyn}', "");
    Expect(1, 65094, '\P{^ispatsyn}', "");
    Expect(0, 65095, '\p{ispatsyn}', "");
    Expect(1, 65095, '\p{^ispatsyn}', "");
    Expect(1, 65095, '\P{ispatsyn}', "");
    Expect(0, 65095, '\P{^ispatsyn}', "");
    Expect(1, 65094, '\p{ Is_Pat_SYN}', "");
    Expect(0, 65094, '\p{^ Is_Pat_SYN}', "");
    Expect(0, 65094, '\P{ Is_Pat_SYN}', "");
    Expect(1, 65094, '\P{^ Is_Pat_SYN}', "");
    Expect(0, 65095, '\p{ Is_Pat_SYN}', "");
    Expect(1, 65095, '\p{^ Is_Pat_SYN}', "");
    Expect(1, 65095, '\P{ Is_Pat_SYN}', "");
    Expect(0, 65095, '\P{^ Is_Pat_SYN}', "");
    Error('\p{/a/-	Pattern_White_Space}');
    Error('\P{/a/-	Pattern_White_Space}');
    Expect(1, 8233, '\p{patternwhitespace}', "");
    Expect(0, 8233, '\p{^patternwhitespace}', "");
    Expect(0, 8233, '\P{patternwhitespace}', "");
    Expect(1, 8233, '\P{^patternwhitespace}', "");
    Expect(0, 8234, '\p{patternwhitespace}', "");
    Expect(1, 8234, '\p{^patternwhitespace}', "");
    Expect(1, 8234, '\P{patternwhitespace}', "");
    Expect(0, 8234, '\P{^patternwhitespace}', "");
    Expect(1, 8233, '\p{_	Pattern_white_Space}', "");
    Expect(0, 8233, '\p{^_	Pattern_white_Space}', "");
    Expect(0, 8233, '\P{_	Pattern_white_Space}', "");
    Expect(1, 8233, '\P{^_	Pattern_white_Space}', "");
    Expect(0, 8234, '\p{_	Pattern_white_Space}', "");
    Expect(1, 8234, '\p{^_	Pattern_white_Space}', "");
    Expect(1, 8234, '\P{_	Pattern_white_Space}', "");
    Expect(0, 8234, '\P{^_	Pattern_white_Space}', "");
    Error('\p{-Is_PATTERN_WHITE_Space/a/}');
    Error('\P{-Is_PATTERN_WHITE_Space/a/}');
    Expect(1, 8233, '\p{ispatternwhitespace}', "");
    Expect(0, 8233, '\p{^ispatternwhitespace}', "");
    Expect(0, 8233, '\P{ispatternwhitespace}', "");
    Expect(1, 8233, '\P{^ispatternwhitespace}', "");
    Expect(0, 8234, '\p{ispatternwhitespace}', "");
    Expect(1, 8234, '\p{^ispatternwhitespace}', "");
    Expect(1, 8234, '\P{ispatternwhitespace}', "");
    Expect(0, 8234, '\P{^ispatternwhitespace}', "");
    Expect(1, 8233, '\p{-	IS_Pattern_WHITE_SPACE}', "");
    Expect(0, 8233, '\p{^-	IS_Pattern_WHITE_SPACE}', "");
    Expect(0, 8233, '\P{-	IS_Pattern_WHITE_SPACE}', "");
    Expect(1, 8233, '\P{^-	IS_Pattern_WHITE_SPACE}', "");
    Expect(0, 8234, '\p{-	IS_Pattern_WHITE_SPACE}', "");
    Expect(1, 8234, '\p{^-	IS_Pattern_WHITE_SPACE}', "");
    Expect(1, 8234, '\P{-	IS_Pattern_WHITE_SPACE}', "");
    Expect(0, 8234, '\P{^-	IS_Pattern_WHITE_SPACE}', "");
    Error('\p{-_Pat_WS:=}');
    Error('\P{-_Pat_WS:=}');
    Expect(1, 8233, '\p{patws}', "");
    Expect(0, 8233, '\p{^patws}', "");
    Expect(0, 8233, '\P{patws}', "");
    Expect(1, 8233, '\P{^patws}', "");
    Expect(0, 8234, '\p{patws}', "");
    Expect(1, 8234, '\p{^patws}', "");
    Expect(1, 8234, '\P{patws}', "");
    Expect(0, 8234, '\P{^patws}', "");
    Expect(1, 8233, '\p{		PAT_ws}', "");
    Expect(0, 8233, '\p{^		PAT_ws}', "");
    Expect(0, 8233, '\P{		PAT_ws}', "");
    Expect(1, 8233, '\P{^		PAT_ws}', "");
    Expect(0, 8234, '\p{		PAT_ws}', "");
    Expect(1, 8234, '\p{^		PAT_ws}', "");
    Expect(1, 8234, '\P{		PAT_ws}', "");
    Expect(0, 8234, '\P{^		PAT_ws}', "");
    Error('\p{ :=IS_PAT_WS}');
    Error('\P{ :=IS_PAT_WS}');
    Expect(1, 8233, '\p{ispatws}', "");
    Expect(0, 8233, '\p{^ispatws}', "");
    Expect(0, 8233, '\P{ispatws}', "");
    Expect(1, 8233, '\P{^ispatws}', "");
    Expect(0, 8234, '\p{ispatws}', "");
    Expect(1, 8234, '\p{^ispatws}', "");
    Expect(1, 8234, '\P{ispatws}', "");
    Expect(0, 8234, '\P{^ispatws}', "");
    Expect(1, 8233, '\p{-Is_Pat_WS}', "");
    Expect(0, 8233, '\p{^-Is_Pat_WS}', "");
    Expect(0, 8233, '\P{-Is_Pat_WS}', "");
    Expect(1, 8233, '\P{^-Is_Pat_WS}', "");
    Expect(0, 8234, '\p{-Is_Pat_WS}', "");
    Expect(1, 8234, '\p{^-Is_Pat_WS}', "");
    Expect(1, 8234, '\P{-Is_Pat_WS}', "");
    Expect(0, 8234, '\P{^-Is_Pat_WS}', "");
    Error('\p{ 	Pau_Cin_Hau/a/}');
    Error('\P{ 	Pau_Cin_Hau/a/}');
    Expect(1, 72440, '\p{paucinhau}', "");
    Expect(0, 72440, '\p{^paucinhau}', "");
    Expect(0, 72440, '\P{paucinhau}', "");
    Expect(1, 72440, '\P{^paucinhau}', "");
    Expect(0, 72441, '\p{paucinhau}', "");
    Expect(1, 72441, '\p{^paucinhau}', "");
    Expect(1, 72441, '\P{paucinhau}', "");
    Expect(0, 72441, '\P{^paucinhau}', "");
    Expect(1, 72440, '\p{_ PAU_CIN_hau}', "");
    Expect(0, 72440, '\p{^_ PAU_CIN_hau}', "");
    Expect(0, 72440, '\P{_ PAU_CIN_hau}', "");
    Expect(1, 72440, '\P{^_ PAU_CIN_hau}', "");
    Expect(0, 72441, '\p{_ PAU_CIN_hau}', "");
    Expect(1, 72441, '\p{^_ PAU_CIN_hau}', "");
    Expect(1, 72441, '\P{_ PAU_CIN_hau}', "");
    Expect(0, 72441, '\P{^_ PAU_CIN_hau}', "");
    Error('\p{ IS_pau_Cin_HAU/a/}');
    Error('\P{ IS_pau_Cin_HAU/a/}');
    Expect(1, 72440, '\p{ispaucinhau}', "");
    Expect(0, 72440, '\p{^ispaucinhau}', "");
    Expect(0, 72440, '\P{ispaucinhau}', "");
    Expect(1, 72440, '\P{^ispaucinhau}', "");
    Expect(0, 72441, '\p{ispaucinhau}', "");
    Expect(1, 72441, '\p{^ispaucinhau}', "");
    Expect(1, 72441, '\P{ispaucinhau}', "");
    Expect(0, 72441, '\P{^ispaucinhau}', "");
    Expect(1, 72440, '\p{		is_Pau_Cin_Hau}', "");
    Expect(0, 72440, '\p{^		is_Pau_Cin_Hau}', "");
    Expect(0, 72440, '\P{		is_Pau_Cin_Hau}', "");
    Expect(1, 72440, '\P{^		is_Pau_Cin_Hau}', "");
    Expect(0, 72441, '\p{		is_Pau_Cin_Hau}', "");
    Expect(1, 72441, '\p{^		is_Pau_Cin_Hau}', "");
    Expect(1, 72441, '\P{		is_Pau_Cin_Hau}', "");
    Expect(0, 72441, '\P{^		is_Pau_Cin_Hau}', "");
    Error('\p{ PAUC/a/}');
    Error('\P{ PAUC/a/}');
    Expect(1, 72440, '\p{pauc}', "");
    Expect(0, 72440, '\p{^pauc}', "");
    Expect(0, 72440, '\P{pauc}', "");
    Expect(1, 72440, '\P{^pauc}', "");
    Expect(0, 72441, '\p{pauc}', "");
    Expect(1, 72441, '\p{^pauc}', "");
    Expect(1, 72441, '\P{pauc}', "");
    Expect(0, 72441, '\P{^pauc}', "");
    Expect(1, 72440, '\p{	_pauc}', "");
    Expect(0, 72440, '\p{^	_pauc}', "");
    Expect(0, 72440, '\P{	_pauc}', "");
    Expect(1, 72440, '\P{^	_pauc}', "");
    Expect(0, 72441, '\p{	_pauc}', "");
    Expect(1, 72441, '\p{^	_pauc}', "");
    Expect(1, 72441, '\P{	_pauc}', "");
    Expect(0, 72441, '\P{^	_pauc}', "");
    Error('\p{-:=is_Pauc}');
    Error('\P{-:=is_Pauc}');
    Expect(1, 72440, '\p{ispauc}', "");
    Expect(0, 72440, '\p{^ispauc}', "");
    Expect(0, 72440, '\P{ispauc}', "");
    Expect(1, 72440, '\P{^ispauc}', "");
    Expect(0, 72441, '\p{ispauc}', "");
    Expect(1, 72441, '\p{^ispauc}', "");
    Expect(1, 72441, '\P{ispauc}', "");
    Expect(0, 72441, '\P{^ispauc}', "");
    Expect(1, 72440, '\p{- Is_PAUC}', "");
    Expect(0, 72440, '\p{^- Is_PAUC}', "");
    Expect(0, 72440, '\P{- Is_PAUC}', "");
    Expect(1, 72440, '\P{^- Is_PAUC}', "");
    Expect(0, 72441, '\p{- Is_PAUC}', "");
    Expect(1, 72441, '\p{^- Is_PAUC}', "");
    Expect(1, 72441, '\P{- Is_PAUC}', "");
    Expect(0, 72441, '\P{^- Is_PAUC}', "");
    Error('\p{_/a/Phags_Pa}');
    Error('\P{_/a/Phags_Pa}');
    Expect(1, 43127, '\p{phagspa}', "");
    Expect(0, 43127, '\p{^phagspa}', "");
    Expect(0, 43127, '\P{phagspa}', "");
    Expect(1, 43127, '\P{^phagspa}', "");
    Expect(0, 43128, '\p{phagspa}', "");
    Expect(1, 43128, '\p{^phagspa}', "");
    Expect(1, 43128, '\P{phagspa}', "");
    Expect(0, 43128, '\P{^phagspa}', "");
    Expect(1, 43127, '\p{__phags_Pa}', "");
    Expect(0, 43127, '\p{^__phags_Pa}', "");
    Expect(0, 43127, '\P{__phags_Pa}', "");
    Expect(1, 43127, '\P{^__phags_Pa}', "");
    Expect(0, 43128, '\p{__phags_Pa}', "");
    Expect(1, 43128, '\p{^__phags_Pa}', "");
    Expect(1, 43128, '\P{__phags_Pa}', "");
    Expect(0, 43128, '\P{^__phags_Pa}', "");
    Error('\p{/a/-Is_Phags_Pa}');
    Error('\P{/a/-Is_Phags_Pa}');
    Expect(1, 43127, '\p{isphagspa}', "");
    Expect(0, 43127, '\p{^isphagspa}', "");
    Expect(0, 43127, '\P{isphagspa}', "");
    Expect(1, 43127, '\P{^isphagspa}', "");
    Expect(0, 43128, '\p{isphagspa}', "");
    Expect(1, 43128, '\p{^isphagspa}', "");
    Expect(1, 43128, '\P{isphagspa}', "");
    Expect(0, 43128, '\P{^isphagspa}', "");
    Expect(1, 43127, '\p{ Is_Phags_Pa}', "");
    Expect(0, 43127, '\p{^ Is_Phags_Pa}', "");
    Expect(0, 43127, '\P{ Is_Phags_Pa}', "");
    Expect(1, 43127, '\P{^ Is_Phags_Pa}', "");
    Expect(0, 43128, '\p{ Is_Phags_Pa}', "");
    Expect(1, 43128, '\p{^ Is_Phags_Pa}', "");
    Expect(1, 43128, '\P{ Is_Phags_Pa}', "");
    Expect(0, 43128, '\P{^ Is_Phags_Pa}', "");
    Error('\p{:=	PHAG}');
    Error('\P{:=	PHAG}');
    Expect(1, 43127, '\p{phag}', "");
    Expect(0, 43127, '\p{^phag}', "");
    Expect(0, 43127, '\P{phag}', "");
    Expect(1, 43127, '\P{^phag}', "");
    Expect(0, 43128, '\p{phag}', "");
    Expect(1, 43128, '\p{^phag}', "");
    Expect(1, 43128, '\P{phag}', "");
    Expect(0, 43128, '\P{^phag}', "");
    Expect(1, 43127, '\p{- Phag}', "");
    Expect(0, 43127, '\p{^- Phag}', "");
    Expect(0, 43127, '\P{- Phag}', "");
    Expect(1, 43127, '\P{^- Phag}', "");
    Expect(0, 43128, '\p{- Phag}', "");
    Expect(1, 43128, '\p{^- Phag}', "");
    Expect(1, 43128, '\P{- Phag}', "");
    Expect(0, 43128, '\P{^- Phag}', "");
    Error('\p{/a/is_phag}');
    Error('\P{/a/is_phag}');
    Expect(1, 43127, '\p{isphag}', "");
    Expect(0, 43127, '\p{^isphag}', "");
    Expect(0, 43127, '\P{isphag}', "");
    Expect(1, 43127, '\P{^isphag}', "");
    Expect(0, 43128, '\p{isphag}', "");
    Expect(1, 43128, '\p{^isphag}', "");
    Expect(1, 43128, '\P{isphag}', "");
    Expect(0, 43128, '\P{^isphag}', "");
    Expect(1, 43127, '\p{ Is_Phag}', "");
    Expect(0, 43127, '\p{^ Is_Phag}', "");
    Expect(0, 43127, '\P{ Is_Phag}', "");
    Expect(1, 43127, '\P{^ Is_Phag}', "");
    Expect(0, 43128, '\p{ Is_Phag}', "");
    Expect(1, 43128, '\p{^ Is_Phag}', "");
    Expect(1, 43128, '\P{ Is_Phag}', "");
    Expect(0, 43128, '\P{^ Is_Phag}', "");
    Error('\p{_	Phaistos_Disc/a/}');
    Error('\P{_	Phaistos_Disc/a/}');
    Expect(1, 66047, '\p{phaistosdisc}', "");
    Expect(0, 66047, '\p{^phaistosdisc}', "");
    Expect(0, 66047, '\P{phaistosdisc}', "");
    Expect(1, 66047, '\P{^phaistosdisc}', "");
    Expect(0, 66048, '\p{phaistosdisc}', "");
    Expect(1, 66048, '\p{^phaistosdisc}', "");
    Expect(1, 66048, '\P{phaistosdisc}', "");
    Expect(0, 66048, '\P{^phaistosdisc}', "");
    Expect(1, 66047, '\p{ 	phaistos_DISC}', "");
    Expect(0, 66047, '\p{^ 	phaistos_DISC}', "");
    Expect(0, 66047, '\P{ 	phaistos_DISC}', "");
    Expect(1, 66047, '\P{^ 	phaistos_DISC}', "");
    Expect(0, 66048, '\p{ 	phaistos_DISC}', "");
    Expect(1, 66048, '\p{^ 	phaistos_DISC}', "");
    Expect(1, 66048, '\P{ 	phaistos_DISC}', "");
    Expect(0, 66048, '\P{^ 	phaistos_DISC}', "");
    Error('\p{ 	is_phaistos_Disc/a/}');
    Error('\P{ 	is_phaistos_Disc/a/}');
    Expect(1, 66047, '\p{isphaistosdisc}', "");
    Expect(0, 66047, '\p{^isphaistosdisc}', "");
    Expect(0, 66047, '\P{isphaistosdisc}', "");
    Expect(1, 66047, '\P{^isphaistosdisc}', "");
    Expect(0, 66048, '\p{isphaistosdisc}', "");
    Expect(1, 66048, '\p{^isphaistosdisc}', "");
    Expect(1, 66048, '\P{isphaistosdisc}', "");
    Expect(0, 66048, '\P{^isphaistosdisc}', "");
    Expect(1, 66047, '\p{_Is_phaistos_Disc}', "");
    Expect(0, 66047, '\p{^_Is_phaistos_Disc}', "");
    Expect(0, 66047, '\P{_Is_phaistos_Disc}', "");
    Expect(1, 66047, '\P{^_Is_phaistos_Disc}', "");
    Expect(0, 66048, '\p{_Is_phaistos_Disc}', "");
    Expect(1, 66048, '\p{^_Is_phaistos_Disc}', "");
    Expect(1, 66048, '\P{_Is_phaistos_Disc}', "");
    Expect(0, 66048, '\P{^_Is_phaistos_Disc}', "");
    Error('\p{-/a/In_Phaistos_Disc}');
    Error('\P{-/a/In_Phaistos_Disc}');
    Expect(1, 66047, '\p{inphaistosdisc}', "");
    Expect(0, 66047, '\p{^inphaistosdisc}', "");
    Expect(0, 66047, '\P{inphaistosdisc}', "");
    Expect(1, 66047, '\P{^inphaistosdisc}', "");
    Expect(0, 66048, '\p{inphaistosdisc}', "");
    Expect(1, 66048, '\p{^inphaistosdisc}', "");
    Expect(1, 66048, '\P{inphaistosdisc}', "");
    Expect(0, 66048, '\P{^inphaistosdisc}', "");
    Expect(1, 66047, '\p{__In_phaistos_Disc}', "");
    Expect(0, 66047, '\p{^__In_phaistos_Disc}', "");
    Expect(0, 66047, '\P{__In_phaistos_Disc}', "");
    Expect(1, 66047, '\P{^__In_phaistos_Disc}', "");
    Expect(0, 66048, '\p{__In_phaistos_Disc}', "");
    Expect(1, 66048, '\p{^__In_phaistos_Disc}', "");
    Expect(1, 66048, '\P{__In_phaistos_Disc}', "");
    Expect(0, 66048, '\P{^__In_phaistos_Disc}', "");
    Error('\p{:=PHAISTOS}');
    Error('\P{:=PHAISTOS}');
    Expect(1, 66047, '\p{phaistos}', "");
    Expect(0, 66047, '\p{^phaistos}', "");
    Expect(0, 66047, '\P{phaistos}', "");
    Expect(1, 66047, '\P{^phaistos}', "");
    Expect(0, 66048, '\p{phaistos}', "");
    Expect(1, 66048, '\p{^phaistos}', "");
    Expect(1, 66048, '\P{phaistos}', "");
    Expect(0, 66048, '\P{^phaistos}', "");
    Expect(1, 66047, '\p{	_Phaistos}', "");
    Expect(0, 66047, '\p{^	_Phaistos}', "");
    Expect(0, 66047, '\P{	_Phaistos}', "");
    Expect(1, 66047, '\P{^	_Phaistos}', "");
    Expect(0, 66048, '\p{	_Phaistos}', "");
    Expect(1, 66048, '\p{^	_Phaistos}', "");
    Expect(1, 66048, '\P{	_Phaistos}', "");
    Expect(0, 66048, '\P{^	_Phaistos}', "");
    Error('\p{:=_Is_PHAISTOS}');
    Error('\P{:=_Is_PHAISTOS}');
    Expect(1, 66047, '\p{isphaistos}', "");
    Expect(0, 66047, '\p{^isphaistos}', "");
    Expect(0, 66047, '\P{isphaistos}', "");
    Expect(1, 66047, '\P{^isphaistos}', "");
    Expect(0, 66048, '\p{isphaistos}', "");
    Expect(1, 66048, '\p{^isphaistos}', "");
    Expect(1, 66048, '\P{isphaistos}', "");
    Expect(0, 66048, '\P{^isphaistos}', "");
    Expect(1, 66047, '\p{-_Is_phaistos}', "");
    Expect(0, 66047, '\p{^-_Is_phaistos}', "");
    Expect(0, 66047, '\P{-_Is_phaistos}', "");
    Expect(1, 66047, '\P{^-_Is_phaistos}', "");
    Expect(0, 66048, '\p{-_Is_phaistos}', "");
    Expect(1, 66048, '\p{^-_Is_phaistos}', "");
    Expect(1, 66048, '\P{-_Is_phaistos}', "");
    Expect(0, 66048, '\P{^-_Is_phaistos}', "");
    Error('\p{/a/ In_PHAISTOS}');
    Error('\P{/a/ In_PHAISTOS}');
    Expect(1, 66047, '\p{inphaistos}', "");
    Expect(0, 66047, '\p{^inphaistos}', "");
    Expect(0, 66047, '\P{inphaistos}', "");
    Expect(1, 66047, '\P{^inphaistos}', "");
    Expect(0, 66048, '\p{inphaistos}', "");
    Expect(1, 66048, '\p{^inphaistos}', "");
    Expect(1, 66048, '\P{inphaistos}', "");
    Expect(0, 66048, '\P{^inphaistos}', "");
    Expect(1, 66047, '\p{ In_Phaistos}', "");
    Expect(0, 66047, '\p{^ In_Phaistos}', "");
    Expect(0, 66047, '\P{ In_Phaistos}', "");
    Expect(1, 66047, '\P{^ In_Phaistos}', "");
    Expect(0, 66048, '\p{ In_Phaistos}', "");
    Expect(1, 66048, '\p{^ In_Phaistos}', "");
    Expect(1, 66048, '\P{ In_Phaistos}', "");
    Expect(0, 66048, '\P{^ In_Phaistos}', "");
    Error('\p{/a/_Phoenician}');
    Error('\P{/a/_Phoenician}');
    Expect(1, 67871, '\p{phoenician}', "");
    Expect(0, 67871, '\p{^phoenician}', "");
    Expect(0, 67871, '\P{phoenician}', "");
    Expect(1, 67871, '\P{^phoenician}', "");
    Expect(0, 67872, '\p{phoenician}', "");
    Expect(1, 67872, '\p{^phoenician}', "");
    Expect(1, 67872, '\P{phoenician}', "");
    Expect(0, 67872, '\P{^phoenician}', "");
    Expect(1, 67871, '\p{ -phoenician}', "");
    Expect(0, 67871, '\p{^ -phoenician}', "");
    Expect(0, 67871, '\P{ -phoenician}', "");
    Expect(1, 67871, '\P{^ -phoenician}', "");
    Expect(0, 67872, '\p{ -phoenician}', "");
    Expect(1, 67872, '\p{^ -phoenician}', "");
    Expect(1, 67872, '\P{ -phoenician}', "");
    Expect(0, 67872, '\P{^ -phoenician}', "");
    Error('\p{-:=IS_Phoenician}');
    Error('\P{-:=IS_Phoenician}');
    Expect(1, 67871, '\p{isphoenician}', "");
    Expect(0, 67871, '\p{^isphoenician}', "");
    Expect(0, 67871, '\P{isphoenician}', "");
    Expect(1, 67871, '\P{^isphoenician}', "");
    Expect(0, 67872, '\p{isphoenician}', "");
    Expect(1, 67872, '\p{^isphoenician}', "");
    Expect(1, 67872, '\P{isphoenician}', "");
    Expect(0, 67872, '\P{^isphoenician}', "");
    Expect(1, 67871, '\p{ Is_phoenician}', "");
    Expect(0, 67871, '\p{^ Is_phoenician}', "");
    Expect(0, 67871, '\P{ Is_phoenician}', "");
    Expect(1, 67871, '\P{^ Is_phoenician}', "");
    Expect(0, 67872, '\p{ Is_phoenician}', "");
    Expect(1, 67872, '\p{^ Is_phoenician}', "");
    Expect(1, 67872, '\P{ Is_phoenician}', "");
    Expect(0, 67872, '\P{^ Is_phoenician}', "");
    Error('\p{:=_PHNX}');
    Error('\P{:=_PHNX}');
    Expect(1, 67871, '\p{phnx}', "");
    Expect(0, 67871, '\p{^phnx}', "");
    Expect(0, 67871, '\P{phnx}', "");
    Expect(1, 67871, '\P{^phnx}', "");
    Expect(0, 67872, '\p{phnx}', "");
    Expect(1, 67872, '\p{^phnx}', "");
    Expect(1, 67872, '\P{phnx}', "");
    Expect(0, 67872, '\P{^phnx}', "");
    Expect(1, 67871, '\p{_-PHNX}', "");
    Expect(0, 67871, '\p{^_-PHNX}', "");
    Expect(0, 67871, '\P{_-PHNX}', "");
    Expect(1, 67871, '\P{^_-PHNX}', "");
    Expect(0, 67872, '\p{_-PHNX}', "");
    Expect(1, 67872, '\p{^_-PHNX}', "");
    Expect(1, 67872, '\P{_-PHNX}', "");
    Expect(0, 67872, '\P{^_-PHNX}', "");
    Error('\p{-:=Is_Phnx}');
    Error('\P{-:=Is_Phnx}');
    Expect(1, 67871, '\p{isphnx}', "");
    Expect(0, 67871, '\p{^isphnx}', "");
    Expect(0, 67871, '\P{isphnx}', "");
    Expect(1, 67871, '\P{^isphnx}', "");
    Expect(0, 67872, '\p{isphnx}', "");
    Expect(1, 67872, '\p{^isphnx}', "");
    Expect(1, 67872, '\P{isphnx}', "");
    Expect(0, 67872, '\P{^isphnx}', "");
    Expect(1, 67871, '\p{--Is_Phnx}', "");
    Expect(0, 67871, '\p{^--Is_Phnx}', "");
    Expect(0, 67871, '\P{--Is_Phnx}', "");
    Expect(1, 67871, '\P{^--Is_Phnx}', "");
    Expect(0, 67872, '\p{--Is_Phnx}', "");
    Expect(1, 67872, '\p{^--Is_Phnx}', "");
    Expect(1, 67872, '\P{--Is_Phnx}', "");
    Expect(0, 67872, '\P{^--Is_Phnx}', "");
    Error('\p{:=_	PHONETIC_Extensions}');
    Error('\P{:=_	PHONETIC_Extensions}');
    Expect(1, 7551, '\p{phoneticextensions}', "");
    Expect(0, 7551, '\p{^phoneticextensions}', "");
    Expect(0, 7551, '\P{phoneticextensions}', "");
    Expect(1, 7551, '\P{^phoneticextensions}', "");
    Expect(0, 7552, '\p{phoneticextensions}', "");
    Expect(1, 7552, '\p{^phoneticextensions}', "");
    Expect(1, 7552, '\P{phoneticextensions}', "");
    Expect(0, 7552, '\P{^phoneticextensions}', "");
    Expect(1, 7551, '\p{	Phonetic_extensions}', "");
    Expect(0, 7551, '\p{^	Phonetic_extensions}', "");
    Expect(0, 7551, '\P{	Phonetic_extensions}', "");
    Expect(1, 7551, '\P{^	Phonetic_extensions}', "");
    Expect(0, 7552, '\p{	Phonetic_extensions}', "");
    Expect(1, 7552, '\p{^	Phonetic_extensions}', "");
    Expect(1, 7552, '\P{	Phonetic_extensions}', "");
    Expect(0, 7552, '\P{^	Phonetic_extensions}', "");
    Error('\p{/a/Is_PHONETIC_extensions}');
    Error('\P{/a/Is_PHONETIC_extensions}');
    Expect(1, 7551, '\p{isphoneticextensions}', "");
    Expect(0, 7551, '\p{^isphoneticextensions}', "");
    Expect(0, 7551, '\P{isphoneticextensions}', "");
    Expect(1, 7551, '\P{^isphoneticextensions}', "");
    Expect(0, 7552, '\p{isphoneticextensions}', "");
    Expect(1, 7552, '\p{^isphoneticextensions}', "");
    Expect(1, 7552, '\P{isphoneticextensions}', "");
    Expect(0, 7552, '\P{^isphoneticextensions}', "");
    Expect(1, 7551, '\p{-	is_Phonetic_EXTENSIONS}', "");
    Expect(0, 7551, '\p{^-	is_Phonetic_EXTENSIONS}', "");
    Expect(0, 7551, '\P{-	is_Phonetic_EXTENSIONS}', "");
    Expect(1, 7551, '\P{^-	is_Phonetic_EXTENSIONS}', "");
    Expect(0, 7552, '\p{-	is_Phonetic_EXTENSIONS}', "");
    Expect(1, 7552, '\p{^-	is_Phonetic_EXTENSIONS}', "");
    Expect(1, 7552, '\P{-	is_Phonetic_EXTENSIONS}', "");
    Expect(0, 7552, '\P{^-	is_Phonetic_EXTENSIONS}', "");
    Error('\p{_/a/IN_Phonetic_EXTENSIONS}');
    Error('\P{_/a/IN_Phonetic_EXTENSIONS}');
    Expect(1, 7551, '\p{inphoneticextensions}', "");
    Expect(0, 7551, '\p{^inphoneticextensions}', "");
    Expect(0, 7551, '\P{inphoneticextensions}', "");
    Expect(1, 7551, '\P{^inphoneticextensions}', "");
    Expect(0, 7552, '\p{inphoneticextensions}', "");
    Expect(1, 7552, '\p{^inphoneticextensions}', "");
    Expect(1, 7552, '\P{inphoneticextensions}', "");
    Expect(0, 7552, '\P{^inphoneticextensions}', "");
    Expect(1, 7551, '\p{	In_Phonetic_EXTENSIONS}', "");
    Expect(0, 7551, '\p{^	In_Phonetic_EXTENSIONS}', "");
    Expect(0, 7551, '\P{	In_Phonetic_EXTENSIONS}', "");
    Expect(1, 7551, '\P{^	In_Phonetic_EXTENSIONS}', "");
    Expect(0, 7552, '\p{	In_Phonetic_EXTENSIONS}', "");
    Expect(1, 7552, '\p{^	In_Phonetic_EXTENSIONS}', "");
    Expect(1, 7552, '\P{	In_Phonetic_EXTENSIONS}', "");
    Expect(0, 7552, '\P{^	In_Phonetic_EXTENSIONS}', "");
    Error('\p{/a/ -Phonetic_ext}');
    Error('\P{/a/ -Phonetic_ext}');
    Expect(1, 7551, '\p{phoneticext}', "");
    Expect(0, 7551, '\p{^phoneticext}', "");
    Expect(0, 7551, '\P{phoneticext}', "");
    Expect(1, 7551, '\P{^phoneticext}', "");
    Expect(0, 7552, '\p{phoneticext}', "");
    Expect(1, 7552, '\p{^phoneticext}', "");
    Expect(1, 7552, '\P{phoneticext}', "");
    Expect(0, 7552, '\P{^phoneticext}', "");
    Expect(1, 7551, '\p{_-phonetic_Ext}', "");
    Expect(0, 7551, '\p{^_-phonetic_Ext}', "");
    Expect(0, 7551, '\P{_-phonetic_Ext}', "");
    Expect(1, 7551, '\P{^_-phonetic_Ext}', "");
    Expect(0, 7552, '\p{_-phonetic_Ext}', "");
    Expect(1, 7552, '\p{^_-phonetic_Ext}', "");
    Expect(1, 7552, '\P{_-phonetic_Ext}', "");
    Expect(0, 7552, '\P{^_-phonetic_Ext}', "");
    Error('\p{/a/		IS_Phonetic_Ext}');
    Error('\P{/a/		IS_Phonetic_Ext}');
    Expect(1, 7551, '\p{isphoneticext}', "");
    Expect(0, 7551, '\p{^isphoneticext}', "");
    Expect(0, 7551, '\P{isphoneticext}', "");
    Expect(1, 7551, '\P{^isphoneticext}', "");
    Expect(0, 7552, '\p{isphoneticext}', "");
    Expect(1, 7552, '\p{^isphoneticext}', "");
    Expect(1, 7552, '\P{isphoneticext}', "");
    Expect(0, 7552, '\P{^isphoneticext}', "");
    Expect(1, 7551, '\p{__IS_PHONETIC_ext}', "");
    Expect(0, 7551, '\p{^__IS_PHONETIC_ext}', "");
    Expect(0, 7551, '\P{__IS_PHONETIC_ext}', "");
    Expect(1, 7551, '\P{^__IS_PHONETIC_ext}', "");
    Expect(0, 7552, '\p{__IS_PHONETIC_ext}', "");
    Expect(1, 7552, '\p{^__IS_PHONETIC_ext}', "");
    Expect(1, 7552, '\P{__IS_PHONETIC_ext}', "");
    Expect(0, 7552, '\P{^__IS_PHONETIC_ext}', "");
    Error('\p{ :=in_Phonetic_EXT}');
    Error('\P{ :=in_Phonetic_EXT}');
    Expect(1, 7551, '\p{inphoneticext}', "");
    Expect(0, 7551, '\p{^inphoneticext}', "");
    Expect(0, 7551, '\P{inphoneticext}', "");
    Expect(1, 7551, '\P{^inphoneticext}', "");
    Expect(0, 7552, '\p{inphoneticext}', "");
    Expect(1, 7552, '\p{^inphoneticext}', "");
    Expect(1, 7552, '\P{inphoneticext}', "");
    Expect(0, 7552, '\P{^inphoneticext}', "");
    Expect(1, 7551, '\p{_IN_PHONETIC_ext}', "");
    Expect(0, 7551, '\p{^_IN_PHONETIC_ext}', "");
    Expect(0, 7551, '\P{_IN_PHONETIC_ext}', "");
    Expect(1, 7551, '\P{^_IN_PHONETIC_ext}', "");
    Expect(0, 7552, '\p{_IN_PHONETIC_ext}', "");
    Expect(1, 7552, '\p{^_IN_PHONETIC_ext}', "");
    Expect(1, 7552, '\P{_IN_PHONETIC_ext}', "");
    Expect(0, 7552, '\P{^_IN_PHONETIC_ext}', "");
    Error('\p{_	PHONETIC_EXTENSIONS_SUPPLEMENT:=}');
    Error('\P{_	PHONETIC_EXTENSIONS_SUPPLEMENT:=}');
    Expect(1, 7615, '\p{phoneticextensionssupplement}', "");
    Expect(0, 7615, '\p{^phoneticextensionssupplement}', "");
    Expect(0, 7615, '\P{phoneticextensionssupplement}', "");
    Expect(1, 7615, '\P{^phoneticextensionssupplement}', "");
    Expect(0, 7616, '\p{phoneticextensionssupplement}', "");
    Expect(1, 7616, '\p{^phoneticextensionssupplement}', "");
    Expect(1, 7616, '\P{phoneticextensionssupplement}', "");
    Expect(0, 7616, '\P{^phoneticextensionssupplement}', "");
    Expect(1, 7615, '\p{  Phonetic_EXTENSIONS_supplement}', "");
    Expect(0, 7615, '\p{^  Phonetic_EXTENSIONS_supplement}', "");
    Expect(0, 7615, '\P{  Phonetic_EXTENSIONS_supplement}', "");
    Expect(1, 7615, '\P{^  Phonetic_EXTENSIONS_supplement}', "");
    Expect(0, 7616, '\p{  Phonetic_EXTENSIONS_supplement}', "");
    Expect(1, 7616, '\p{^  Phonetic_EXTENSIONS_supplement}', "");
    Expect(1, 7616, '\P{  Phonetic_EXTENSIONS_supplement}', "");
    Expect(0, 7616, '\P{^  Phonetic_EXTENSIONS_supplement}', "");
    Error('\p{/a/-_is_Phonetic_EXTENSIONS_Supplement}');
    Error('\P{/a/-_is_Phonetic_EXTENSIONS_Supplement}');
    Expect(1, 7615, '\p{isphoneticextensionssupplement}', "");
    Expect(0, 7615, '\p{^isphoneticextensionssupplement}', "");
    Expect(0, 7615, '\P{isphoneticextensionssupplement}', "");
    Expect(1, 7615, '\P{^isphoneticextensionssupplement}', "");
    Expect(0, 7616, '\p{isphoneticextensionssupplement}', "");
    Expect(1, 7616, '\p{^isphoneticextensionssupplement}', "");
    Expect(1, 7616, '\P{isphoneticextensionssupplement}', "");
    Expect(0, 7616, '\P{^isphoneticextensionssupplement}', "");
    Expect(1, 7615, '\p{-IS_Phonetic_Extensions_Supplement}', "");
    Expect(0, 7615, '\p{^-IS_Phonetic_Extensions_Supplement}', "");
    Expect(0, 7615, '\P{-IS_Phonetic_Extensions_Supplement}', "");
    Expect(1, 7615, '\P{^-IS_Phonetic_Extensions_Supplement}', "");
    Expect(0, 7616, '\p{-IS_Phonetic_Extensions_Supplement}', "");
    Expect(1, 7616, '\p{^-IS_Phonetic_Extensions_Supplement}', "");
    Expect(1, 7616, '\P{-IS_Phonetic_Extensions_Supplement}', "");
    Expect(0, 7616, '\P{^-IS_Phonetic_Extensions_Supplement}', "");
    Error('\p{:= in_Phonetic_Extensions_supplement}');
    Error('\P{:= in_Phonetic_Extensions_supplement}');
    Expect(1, 7615, '\p{inphoneticextensionssupplement}', "");
    Expect(0, 7615, '\p{^inphoneticextensionssupplement}', "");
    Expect(0, 7615, '\P{inphoneticextensionssupplement}', "");
    Expect(1, 7615, '\P{^inphoneticextensionssupplement}', "");
    Expect(0, 7616, '\p{inphoneticextensionssupplement}', "");
    Expect(1, 7616, '\p{^inphoneticextensionssupplement}', "");
    Expect(1, 7616, '\P{inphoneticextensionssupplement}', "");
    Expect(0, 7616, '\P{^inphoneticextensionssupplement}', "");
    Expect(1, 7615, '\p{_-In_PHONETIC_Extensions_supplement}', "");
    Expect(0, 7615, '\p{^_-In_PHONETIC_Extensions_supplement}', "");
    Expect(0, 7615, '\P{_-In_PHONETIC_Extensions_supplement}', "");
    Expect(1, 7615, '\P{^_-In_PHONETIC_Extensions_supplement}', "");
    Expect(0, 7616, '\p{_-In_PHONETIC_Extensions_supplement}', "");
    Expect(1, 7616, '\p{^_-In_PHONETIC_Extensions_supplement}', "");
    Expect(1, 7616, '\P{_-In_PHONETIC_Extensions_supplement}', "");
    Expect(0, 7616, '\P{^_-In_PHONETIC_Extensions_supplement}', "");
    Error('\p{-/a/PHONETIC_Ext_Sup}');
    Error('\P{-/a/PHONETIC_Ext_Sup}');
    Expect(1, 7615, '\p{phoneticextsup}', "");
    Expect(0, 7615, '\p{^phoneticextsup}', "");
    Expect(0, 7615, '\P{phoneticextsup}', "");
    Expect(1, 7615, '\P{^phoneticextsup}', "");
    Expect(0, 7616, '\p{phoneticextsup}', "");
    Expect(1, 7616, '\p{^phoneticextsup}', "");
    Expect(1, 7616, '\P{phoneticextsup}', "");
    Expect(0, 7616, '\P{^phoneticextsup}', "");
    Expect(1, 7615, '\p{- phonetic_ext_Sup}', "");
    Expect(0, 7615, '\p{^- phonetic_ext_Sup}', "");
    Expect(0, 7615, '\P{- phonetic_ext_Sup}', "");
    Expect(1, 7615, '\P{^- phonetic_ext_Sup}', "");
    Expect(0, 7616, '\p{- phonetic_ext_Sup}', "");
    Expect(1, 7616, '\p{^- phonetic_ext_Sup}', "");
    Expect(1, 7616, '\P{- phonetic_ext_Sup}', "");
    Expect(0, 7616, '\P{^- phonetic_ext_Sup}', "");
    Error('\p{/a/_IS_phonetic_EXT_Sup}');
    Error('\P{/a/_IS_phonetic_EXT_Sup}');
    Expect(1, 7615, '\p{isphoneticextsup}', "");
    Expect(0, 7615, '\p{^isphoneticextsup}', "");
    Expect(0, 7615, '\P{isphoneticextsup}', "");
    Expect(1, 7615, '\P{^isphoneticextsup}', "");
    Expect(0, 7616, '\p{isphoneticextsup}', "");
    Expect(1, 7616, '\p{^isphoneticextsup}', "");
    Expect(1, 7616, '\P{isphoneticextsup}', "");
    Expect(0, 7616, '\P{^isphoneticextsup}', "");
    Expect(1, 7615, '\p{	_Is_PHONETIC_Ext_Sup}', "");
    Expect(0, 7615, '\p{^	_Is_PHONETIC_Ext_Sup}', "");
    Expect(0, 7615, '\P{	_Is_PHONETIC_Ext_Sup}', "");
    Expect(1, 7615, '\P{^	_Is_PHONETIC_Ext_Sup}', "");
    Expect(0, 7616, '\p{	_Is_PHONETIC_Ext_Sup}', "");
    Expect(1, 7616, '\p{^	_Is_PHONETIC_Ext_Sup}', "");
    Expect(1, 7616, '\P{	_Is_PHONETIC_Ext_Sup}', "");
    Expect(0, 7616, '\P{^	_Is_PHONETIC_Ext_Sup}', "");
    Error('\p{	in_PHONETIC_Ext_Sup/a/}');
    Error('\P{	in_PHONETIC_Ext_Sup/a/}');
    Expect(1, 7615, '\p{inphoneticextsup}', "");
    Expect(0, 7615, '\p{^inphoneticextsup}', "");
    Expect(0, 7615, '\P{inphoneticextsup}', "");
    Expect(1, 7615, '\P{^inphoneticextsup}', "");
    Expect(0, 7616, '\p{inphoneticextsup}', "");
    Expect(1, 7616, '\p{^inphoneticextsup}', "");
    Expect(1, 7616, '\P{inphoneticextsup}', "");
    Expect(0, 7616, '\P{^inphoneticextsup}', "");
    Expect(1, 7615, '\p{	In_PHONETIC_ext_Sup}', "");
    Expect(0, 7615, '\p{^	In_PHONETIC_ext_Sup}', "");
    Expect(0, 7615, '\P{	In_PHONETIC_ext_Sup}', "");
    Expect(1, 7615, '\P{^	In_PHONETIC_ext_Sup}', "");
    Expect(0, 7616, '\p{	In_PHONETIC_ext_Sup}', "");
    Expect(1, 7616, '\p{^	In_PHONETIC_ext_Sup}', "");
    Expect(1, 7616, '\P{	In_PHONETIC_ext_Sup}', "");
    Expect(0, 7616, '\P{^	In_PHONETIC_ext_Sup}', "");
    Error('\p{/a/	-PLAYING_CARDS}');
    Error('\P{/a/	-PLAYING_CARDS}');
    Expect(1, 127231, '\p{playingcards}', "");
    Expect(0, 127231, '\p{^playingcards}', "");
    Expect(0, 127231, '\P{playingcards}', "");
    Expect(1, 127231, '\P{^playingcards}', "");
    Expect(0, 127232, '\p{playingcards}', "");
    Expect(1, 127232, '\p{^playingcards}', "");
    Expect(1, 127232, '\P{playingcards}', "");
    Expect(0, 127232, '\P{^playingcards}', "");
    Expect(1, 127231, '\p{--playing_Cards}', "");
    Expect(0, 127231, '\p{^--playing_Cards}', "");
    Expect(0, 127231, '\P{--playing_Cards}', "");
    Expect(1, 127231, '\P{^--playing_Cards}', "");
    Expect(0, 127232, '\p{--playing_Cards}', "");
    Expect(1, 127232, '\p{^--playing_Cards}', "");
    Expect(1, 127232, '\P{--playing_Cards}', "");
    Expect(0, 127232, '\P{^--playing_Cards}', "");
    Error('\p{	/a/is_Playing_CARDS}');
    Error('\P{	/a/is_Playing_CARDS}');
    Expect(1, 127231, '\p{isplayingcards}', "");
    Expect(0, 127231, '\p{^isplayingcards}', "");
    Expect(0, 127231, '\P{isplayingcards}', "");
    Expect(1, 127231, '\P{^isplayingcards}', "");
    Expect(0, 127232, '\p{isplayingcards}', "");
    Expect(1, 127232, '\p{^isplayingcards}', "");
    Expect(1, 127232, '\P{isplayingcards}', "");
    Expect(0, 127232, '\P{^isplayingcards}', "");
    Expect(1, 127231, '\p{_	Is_Playing_cards}', "");
    Expect(0, 127231, '\p{^_	Is_Playing_cards}', "");
    Expect(0, 127231, '\P{_	Is_Playing_cards}', "");
    Expect(1, 127231, '\P{^_	Is_Playing_cards}', "");
    Expect(0, 127232, '\p{_	Is_Playing_cards}', "");
    Expect(1, 127232, '\p{^_	Is_Playing_cards}', "");
    Expect(1, 127232, '\P{_	Is_Playing_cards}', "");
    Expect(0, 127232, '\P{^_	Is_Playing_cards}', "");
    Error('\p{/a/In_playing_cards}');
    Error('\P{/a/In_playing_cards}');
    Expect(1, 127231, '\p{inplayingcards}', "");
    Expect(0, 127231, '\p{^inplayingcards}', "");
    Expect(0, 127231, '\P{inplayingcards}', "");
    Expect(1, 127231, '\P{^inplayingcards}', "");
    Expect(0, 127232, '\p{inplayingcards}', "");
    Expect(1, 127232, '\p{^inplayingcards}', "");
    Expect(1, 127232, '\P{inplayingcards}', "");
    Expect(0, 127232, '\P{^inplayingcards}', "");
    Expect(1, 127231, '\p{		IN_PLAYING_Cards}', "");
    Expect(0, 127231, '\p{^		IN_PLAYING_Cards}', "");
    Expect(0, 127231, '\P{		IN_PLAYING_Cards}', "");
    Expect(1, 127231, '\P{^		IN_PLAYING_Cards}', "");
    Expect(0, 127232, '\p{		IN_PLAYING_Cards}', "");
    Expect(1, 127232, '\p{^		IN_PLAYING_Cards}', "");
    Expect(1, 127232, '\P{		IN_PLAYING_Cards}', "");
    Expect(0, 127232, '\P{^		IN_PLAYING_Cards}', "");
    Error('\p{-_POSIXALNUM/a/}');
    Error('\P{-_POSIXALNUM/a/}');
    Expect(1, 122, '\p{posixalnum}', "");
    Expect(0, 122, '\p{^posixalnum}', "");
    Expect(0, 122, '\P{posixalnum}', "");
    Expect(1, 122, '\P{^posixalnum}', "");
    Expect(0, 123, '\p{posixalnum}', "");
    Expect(1, 123, '\p{^posixalnum}', "");
    Expect(1, 123, '\P{posixalnum}', "");
    Expect(0, 123, '\P{^posixalnum}', "");
    Expect(1, 122, '\p{	-PosixAlnum}', "");
    Expect(0, 122, '\p{^	-PosixAlnum}', "");
    Expect(0, 122, '\P{	-PosixAlnum}', "");
    Expect(1, 122, '\P{^	-PosixAlnum}', "");
    Expect(0, 123, '\p{	-PosixAlnum}', "");
    Expect(1, 123, '\p{^	-PosixAlnum}', "");
    Expect(1, 123, '\P{	-PosixAlnum}', "");
    Expect(0, 123, '\P{^	-PosixAlnum}', "");
    Error('\p{- IS_PosixAlnum:=}');
    Error('\P{- IS_PosixAlnum:=}');
    Expect(1, 122, '\p{isposixalnum}', "");
    Expect(0, 122, '\p{^isposixalnum}', "");
    Expect(0, 122, '\P{isposixalnum}', "");
    Expect(1, 122, '\P{^isposixalnum}', "");
    Expect(0, 123, '\p{isposixalnum}', "");
    Expect(1, 123, '\p{^isposixalnum}', "");
    Expect(1, 123, '\P{isposixalnum}', "");
    Expect(0, 123, '\P{^isposixalnum}', "");
    Expect(1, 122, '\p{	_IS_POSIXALNUM}', "");
    Expect(0, 122, '\p{^	_IS_POSIXALNUM}', "");
    Expect(0, 122, '\P{	_IS_POSIXALNUM}', "");
    Expect(1, 122, '\P{^	_IS_POSIXALNUM}', "");
    Expect(0, 123, '\p{	_IS_POSIXALNUM}', "");
    Expect(1, 123, '\p{^	_IS_POSIXALNUM}', "");
    Expect(1, 123, '\P{	_IS_POSIXALNUM}', "");
    Expect(0, 123, '\P{^	_IS_POSIXALNUM}', "");
    Error('\p{PosixAlpha/a/}');
    Error('\P{PosixAlpha/a/}');
    Expect(1, 122, '\p{posixalpha}', "");
    Expect(0, 122, '\p{^posixalpha}', "");
    Expect(0, 122, '\P{posixalpha}', "");
    Expect(1, 122, '\P{^posixalpha}', "");
    Expect(0, 123, '\p{posixalpha}', "");
    Expect(1, 123, '\p{^posixalpha}', "");
    Expect(1, 123, '\P{posixalpha}', "");
    Expect(0, 123, '\P{^posixalpha}', "");
    Expect(1, 122, '\p{-POSIXALPHA}', "");
    Expect(0, 122, '\p{^-POSIXALPHA}', "");
    Expect(0, 122, '\P{-POSIXALPHA}', "");
    Expect(1, 122, '\P{^-POSIXALPHA}', "");
    Expect(0, 123, '\p{-POSIXALPHA}', "");
    Expect(1, 123, '\p{^-POSIXALPHA}', "");
    Expect(1, 123, '\P{-POSIXALPHA}', "");
    Expect(0, 123, '\P{^-POSIXALPHA}', "");
    Error('\p{/a/Is_posixalpha}');
    Error('\P{/a/Is_posixalpha}');
    Expect(1, 122, '\p{isposixalpha}', "");
    Expect(0, 122, '\p{^isposixalpha}', "");
    Expect(0, 122, '\P{isposixalpha}', "");
    Expect(1, 122, '\P{^isposixalpha}', "");
    Expect(0, 123, '\p{isposixalpha}', "");
    Expect(1, 123, '\p{^isposixalpha}', "");
    Expect(1, 123, '\P{isposixalpha}', "");
    Expect(0, 123, '\P{^isposixalpha}', "");
    Expect(1, 122, '\p{- Is_POSIXALPHA}', "");
    Expect(0, 122, '\p{^- Is_POSIXALPHA}', "");
    Expect(0, 122, '\P{- Is_POSIXALPHA}', "");
    Expect(1, 122, '\P{^- Is_POSIXALPHA}', "");
    Expect(0, 123, '\p{- Is_POSIXALPHA}', "");
    Expect(1, 123, '\p{^- Is_POSIXALPHA}', "");
    Expect(1, 123, '\P{- Is_POSIXALPHA}', "");
    Expect(0, 123, '\P{^- Is_POSIXALPHA}', "");
    Error('\p{:= PosixBlank}');
    Error('\P{:= PosixBlank}');
    Expect(1, 32, '\p{posixblank}', "");
    Expect(0, 32, '\p{^posixblank}', "");
    Expect(0, 32, '\P{posixblank}', "");
    Expect(1, 32, '\P{^posixblank}', "");
    Expect(0, 33, '\p{posixblank}', "");
    Expect(1, 33, '\p{^posixblank}', "");
    Expect(1, 33, '\P{posixblank}', "");
    Expect(0, 33, '\P{^posixblank}', "");
    Expect(1, 32, '\p{_-posixblank}', "");
    Expect(0, 32, '\p{^_-posixblank}', "");
    Expect(0, 32, '\P{_-posixblank}', "");
    Expect(1, 32, '\P{^_-posixblank}', "");
    Expect(0, 33, '\p{_-posixblank}', "");
    Expect(1, 33, '\p{^_-posixblank}', "");
    Expect(1, 33, '\P{_-posixblank}', "");
    Expect(0, 33, '\P{^_-posixblank}', "");
    Error('\p{:=_Is_PosixBlank}');
    Error('\P{:=_Is_PosixBlank}');
    Expect(1, 32, '\p{isposixblank}', "");
    Expect(0, 32, '\p{^isposixblank}', "");
    Expect(0, 32, '\P{isposixblank}', "");
    Expect(1, 32, '\P{^isposixblank}', "");
    Expect(0, 33, '\p{isposixblank}', "");
    Expect(1, 33, '\p{^isposixblank}', "");
    Expect(1, 33, '\P{isposixblank}', "");
    Expect(0, 33, '\P{^isposixblank}', "");
    Expect(1, 32, '\p{  is_posixblank}', "");
    Expect(0, 32, '\p{^  is_posixblank}', "");
    Expect(0, 32, '\P{  is_posixblank}', "");
    Expect(1, 32, '\P{^  is_posixblank}', "");
    Expect(0, 33, '\p{  is_posixblank}', "");
    Expect(1, 33, '\p{^  is_posixblank}', "");
    Expect(1, 33, '\P{  is_posixblank}', "");
    Expect(0, 33, '\P{^  is_posixblank}', "");
    Error('\p{--PosixCntrl/a/}');
    Error('\P{--PosixCntrl/a/}');
    Expect(1, 127, '\p{posixcntrl}', "");
    Expect(0, 127, '\p{^posixcntrl}', "");
    Expect(0, 127, '\P{posixcntrl}', "");
    Expect(1, 127, '\P{^posixcntrl}', "");
    Expect(0, 128, '\p{posixcntrl}', "");
    Expect(1, 128, '\p{^posixcntrl}', "");
    Expect(1, 128, '\P{posixcntrl}', "");
    Expect(0, 128, '\P{^posixcntrl}', "");
    Expect(1, 127, '\p{	 POSIXCNTRL}', "");
    Expect(0, 127, '\p{^	 POSIXCNTRL}', "");
    Expect(0, 127, '\P{	 POSIXCNTRL}', "");
    Expect(1, 127, '\P{^	 POSIXCNTRL}', "");
    Expect(0, 128, '\p{	 POSIXCNTRL}', "");
    Expect(1, 128, '\p{^	 POSIXCNTRL}', "");
    Expect(1, 128, '\P{	 POSIXCNTRL}', "");
    Expect(0, 128, '\P{^	 POSIXCNTRL}', "");
    Error('\p{_ is_posixcntrl/a/}');
    Error('\P{_ is_posixcntrl/a/}');
    Expect(1, 127, '\p{isposixcntrl}', "");
    Expect(0, 127, '\p{^isposixcntrl}', "");
    Expect(0, 127, '\P{isposixcntrl}', "");
    Expect(1, 127, '\P{^isposixcntrl}', "");
    Expect(0, 128, '\p{isposixcntrl}', "");
    Expect(1, 128, '\p{^isposixcntrl}', "");
    Expect(1, 128, '\P{isposixcntrl}', "");
    Expect(0, 128, '\P{^isposixcntrl}', "");
    Expect(1, 127, '\p{-	is_POSIXCNTRL}', "");
    Expect(0, 127, '\p{^-	is_POSIXCNTRL}', "");
    Expect(0, 127, '\P{-	is_POSIXCNTRL}', "");
    Expect(1, 127, '\P{^-	is_POSIXCNTRL}', "");
    Expect(0, 128, '\p{-	is_POSIXCNTRL}', "");
    Expect(1, 128, '\p{^-	is_POSIXCNTRL}', "");
    Expect(1, 128, '\P{-	is_POSIXCNTRL}', "");
    Expect(0, 128, '\P{^-	is_POSIXCNTRL}', "");
    Error('\p{	_POSIXDIGIT/a/}');
    Error('\P{	_POSIXDIGIT/a/}');
    Expect(1, 57, '\p{posixdigit}', "");
    Expect(0, 57, '\p{^posixdigit}', "");
    Expect(0, 57, '\P{posixdigit}', "");
    Expect(1, 57, '\P{^posixdigit}', "");
    Expect(0, 58, '\p{posixdigit}', "");
    Expect(1, 58, '\p{^posixdigit}', "");
    Expect(1, 58, '\P{posixdigit}', "");
    Expect(0, 58, '\P{^posixdigit}', "");
    Expect(1, 57, '\p{_PosixDigit}', "");
    Expect(0, 57, '\p{^_PosixDigit}', "");
    Expect(0, 57, '\P{_PosixDigit}', "");
    Expect(1, 57, '\P{^_PosixDigit}', "");
    Expect(0, 58, '\p{_PosixDigit}', "");
    Expect(1, 58, '\p{^_PosixDigit}', "");
    Expect(1, 58, '\P{_PosixDigit}', "");
    Expect(0, 58, '\P{^_PosixDigit}', "");
    Error('\p{_:=IS_PosixDigit}');
    Error('\P{_:=IS_PosixDigit}');
    Expect(1, 57, '\p{isposixdigit}', "");
    Expect(0, 57, '\p{^isposixdigit}', "");
    Expect(0, 57, '\P{isposixdigit}', "");
    Expect(1, 57, '\P{^isposixdigit}', "");
    Expect(0, 58, '\p{isposixdigit}', "");
    Expect(1, 58, '\p{^isposixdigit}', "");
    Expect(1, 58, '\P{isposixdigit}', "");
    Expect(0, 58, '\P{^isposixdigit}', "");
    Expect(1, 57, '\p{- is_PosixDigit}', "");
    Expect(0, 57, '\p{^- is_PosixDigit}', "");
    Expect(0, 57, '\P{- is_PosixDigit}', "");
    Expect(1, 57, '\P{^- is_PosixDigit}', "");
    Expect(0, 58, '\p{- is_PosixDigit}', "");
    Expect(1, 58, '\p{^- is_PosixDigit}', "");
    Expect(1, 58, '\P{- is_PosixDigit}', "");
    Expect(0, 58, '\P{^- is_PosixDigit}', "");
    Error('\p{-POSIXGRAPH/a/}');
    Error('\P{-POSIXGRAPH/a/}');
    Expect(1, 126, '\p{posixgraph}', "");
    Expect(0, 126, '\p{^posixgraph}', "");
    Expect(0, 126, '\P{posixgraph}', "");
    Expect(1, 126, '\P{^posixgraph}', "");
    Expect(0, 127, '\p{posixgraph}', "");
    Expect(1, 127, '\p{^posixgraph}', "");
    Expect(1, 127, '\P{posixgraph}', "");
    Expect(0, 127, '\P{^posixgraph}', "");
    Expect(1, 126, '\p{-POSIXGRAPH}', "");
    Expect(0, 126, '\p{^-POSIXGRAPH}', "");
    Expect(0, 126, '\P{-POSIXGRAPH}', "");
    Expect(1, 126, '\P{^-POSIXGRAPH}', "");
    Expect(0, 127, '\p{-POSIXGRAPH}', "");
    Expect(1, 127, '\p{^-POSIXGRAPH}', "");
    Expect(1, 127, '\P{-POSIXGRAPH}', "");
    Expect(0, 127, '\P{^-POSIXGRAPH}', "");
    Error('\p{	Is_PosixGraph:=}');
    Error('\P{	Is_PosixGraph:=}');
    Expect(1, 126, '\p{isposixgraph}', "");
    Expect(0, 126, '\p{^isposixgraph}', "");
    Expect(0, 126, '\P{isposixgraph}', "");
    Expect(1, 126, '\P{^isposixgraph}', "");
    Expect(0, 127, '\p{isposixgraph}', "");
    Expect(1, 127, '\p{^isposixgraph}', "");
    Expect(1, 127, '\P{isposixgraph}', "");
    Expect(0, 127, '\P{^isposixgraph}', "");
    Expect(1, 126, '\p{--Is_posixgraph}', "");
    Expect(0, 126, '\p{^--Is_posixgraph}', "");
    Expect(0, 126, '\P{--Is_posixgraph}', "");
    Expect(1, 126, '\P{^--Is_posixgraph}', "");
    Expect(0, 127, '\p{--Is_posixgraph}', "");
    Expect(1, 127, '\p{^--Is_posixgraph}', "");
    Expect(1, 127, '\P{--Is_posixgraph}', "");
    Expect(0, 127, '\P{^--Is_posixgraph}', "");
    Error('\p{/a/		posixlower}');
    Error('\P{/a/		posixlower}');
    Expect(1, 122, '\p{posixlower}', "");
    Expect(0, 122, '\p{^posixlower}', "");
    Expect(0, 122, '\P{posixlower}', "");
    Expect(1, 122, '\P{^posixlower}', "");
    Expect(0, 123, '\p{posixlower}', "");
    Expect(1, 123, '\p{^posixlower}', "");
    Expect(1, 123, '\P{posixlower}', "");
    Expect(0, 123, '\P{^posixlower}', "");
    Expect(1, 122, '\p{-	PosixLower}', "");
    Expect(0, 122, '\p{^-	PosixLower}', "");
    Expect(0, 122, '\P{-	PosixLower}', "");
    Expect(1, 122, '\P{^-	PosixLower}', "");
    Expect(0, 123, '\p{-	PosixLower}', "");
    Expect(1, 123, '\p{^-	PosixLower}', "");
    Expect(1, 123, '\P{-	PosixLower}', "");
    Expect(0, 123, '\P{^-	PosixLower}', "");
    Error('\p{_	IS_PosixLower:=}');
    Error('\P{_	IS_PosixLower:=}');
    Expect(1, 122, '\p{isposixlower}', "");
    Expect(0, 122, '\p{^isposixlower}', "");
    Expect(0, 122, '\P{isposixlower}', "");
    Expect(1, 122, '\P{^isposixlower}', "");
    Expect(0, 123, '\p{isposixlower}', "");
    Expect(1, 123, '\p{^isposixlower}', "");
    Expect(1, 123, '\P{isposixlower}', "");
    Expect(0, 123, '\P{^isposixlower}', "");
    Expect(1, 122, '\p{-	is_PosixLower}', "");
    Expect(0, 122, '\p{^-	is_PosixLower}', "");
    Expect(0, 122, '\P{-	is_PosixLower}', "");
    Expect(1, 122, '\P{^-	is_PosixLower}', "");
    Expect(0, 123, '\p{-	is_PosixLower}', "");
    Expect(1, 123, '\p{^-	is_PosixLower}', "");
    Expect(1, 123, '\P{-	is_PosixLower}', "");
    Expect(0, 123, '\P{^-	is_PosixLower}', "");
    Error('\p{  PosixPrint/a/}');
    Error('\P{  PosixPrint/a/}');
    Expect(1, 126, '\p{posixprint}', "");
    Expect(0, 126, '\p{^posixprint}', "");
    Expect(0, 126, '\P{posixprint}', "");
    Expect(1, 126, '\P{^posixprint}', "");
    Expect(0, 127, '\p{posixprint}', "");
    Expect(1, 127, '\p{^posixprint}', "");
    Expect(1, 127, '\P{posixprint}', "");
    Expect(0, 127, '\P{^posixprint}', "");
    Expect(1, 126, '\p{-PosixPrint}', "");
    Expect(0, 126, '\p{^-PosixPrint}', "");
    Expect(0, 126, '\P{-PosixPrint}', "");
    Expect(1, 126, '\P{^-PosixPrint}', "");
    Expect(0, 127, '\p{-PosixPrint}', "");
    Expect(1, 127, '\p{^-PosixPrint}', "");
    Expect(1, 127, '\P{-PosixPrint}', "");
    Expect(0, 127, '\P{^-PosixPrint}', "");
    Error('\p{_Is_posixprint/a/}');
    Error('\P{_Is_posixprint/a/}');
    Expect(1, 126, '\p{isposixprint}', "");
    Expect(0, 126, '\p{^isposixprint}', "");
    Expect(0, 126, '\P{isposixprint}', "");
    Expect(1, 126, '\P{^isposixprint}', "");
    Expect(0, 127, '\p{isposixprint}', "");
    Expect(1, 127, '\p{^isposixprint}', "");
    Expect(1, 127, '\P{isposixprint}', "");
    Expect(0, 127, '\P{^isposixprint}', "");
    Expect(1, 126, '\p{  Is_PosixPrint}', "");
    Expect(0, 126, '\p{^  Is_PosixPrint}', "");
    Expect(0, 126, '\P{  Is_PosixPrint}', "");
    Expect(1, 126, '\P{^  Is_PosixPrint}', "");
    Expect(0, 127, '\p{  Is_PosixPrint}', "");
    Expect(1, 127, '\p{^  Is_PosixPrint}', "");
    Expect(1, 127, '\P{  Is_PosixPrint}', "");
    Expect(0, 127, '\P{^  Is_PosixPrint}', "");
    Error('\p{	/a/PosixPunct}');
    Error('\P{	/a/PosixPunct}');
    Expect(1, 126, '\p{posixpunct}', "");
    Expect(0, 126, '\p{^posixpunct}', "");
    Expect(0, 126, '\P{posixpunct}', "");
    Expect(1, 126, '\P{^posixpunct}', "");
    Expect(0, 127, '\p{posixpunct}', "");
    Expect(1, 127, '\p{^posixpunct}', "");
    Expect(1, 127, '\P{posixpunct}', "");
    Expect(0, 127, '\P{^posixpunct}', "");
    Expect(1, 126, '\p{_ PosixPunct}', "");
    Expect(0, 126, '\p{^_ PosixPunct}', "");
    Expect(0, 126, '\P{_ PosixPunct}', "");
    Expect(1, 126, '\P{^_ PosixPunct}', "");
    Expect(0, 127, '\p{_ PosixPunct}', "");
    Expect(1, 127, '\p{^_ PosixPunct}', "");
    Expect(1, 127, '\P{_ PosixPunct}', "");
    Expect(0, 127, '\P{^_ PosixPunct}', "");
    Error('\p{:= -Is_POSIXPUNCT}');
    Error('\P{:= -Is_POSIXPUNCT}');
    Expect(1, 126, '\p{isposixpunct}', "");
    Expect(0, 126, '\p{^isposixpunct}', "");
    Expect(0, 126, '\P{isposixpunct}', "");
    Expect(1, 126, '\P{^isposixpunct}', "");
    Expect(0, 127, '\p{isposixpunct}', "");
    Expect(1, 127, '\p{^isposixpunct}', "");
    Expect(1, 127, '\P{isposixpunct}', "");
    Expect(0, 127, '\P{^isposixpunct}', "");
    Expect(1, 126, '\p{ IS_POSIXPUNCT}', "");
    Expect(0, 126, '\p{^ IS_POSIXPUNCT}', "");
    Expect(0, 126, '\P{ IS_POSIXPUNCT}', "");
    Expect(1, 126, '\P{^ IS_POSIXPUNCT}', "");
    Expect(0, 127, '\p{ IS_POSIXPUNCT}', "");
    Expect(1, 127, '\p{^ IS_POSIXPUNCT}', "");
    Expect(1, 127, '\P{ IS_POSIXPUNCT}', "");
    Expect(0, 127, '\P{^ IS_POSIXPUNCT}', "");
    Error('\p{ :=posixspace}');
    Error('\P{ :=posixspace}');
    Expect(1, 32, '\p{posixspace}', "");
    Expect(0, 32, '\p{^posixspace}', "");
    Expect(0, 32, '\P{posixspace}', "");
    Expect(1, 32, '\P{^posixspace}', "");
    Expect(0, 33, '\p{posixspace}', "");
    Expect(1, 33, '\p{^posixspace}', "");
    Expect(1, 33, '\P{posixspace}', "");
    Expect(0, 33, '\P{^posixspace}', "");
    Expect(1, 32, '\p{	PosixSpace}', "");
    Expect(0, 32, '\p{^	PosixSpace}', "");
    Expect(0, 32, '\P{	PosixSpace}', "");
    Expect(1, 32, '\P{^	PosixSpace}', "");
    Expect(0, 33, '\p{	PosixSpace}', "");
    Expect(1, 33, '\p{^	PosixSpace}', "");
    Expect(1, 33, '\P{	PosixSpace}', "");
    Expect(0, 33, '\P{^	PosixSpace}', "");
    Error('\p{:=	 perlspace}');
    Error('\P{:=	 perlspace}');
    Expect(1, 32, '\p{perlspace}', "");
    Expect(0, 32, '\p{^perlspace}', "");
    Expect(0, 32, '\P{perlspace}', "");
    Expect(1, 32, '\P{^perlspace}', "");
    Expect(0, 33, '\p{perlspace}', "");
    Expect(1, 33, '\p{^perlspace}', "");
    Expect(1, 33, '\P{perlspace}', "");
    Expect(0, 33, '\P{^perlspace}', "");
    Expect(1, 32, '\p{-_PerlSpace}', "");
    Expect(0, 32, '\p{^-_PerlSpace}', "");
    Expect(0, 32, '\P{-_PerlSpace}', "");
    Expect(1, 32, '\P{^-_PerlSpace}', "");
    Expect(0, 33, '\p{-_PerlSpace}', "");
    Expect(1, 33, '\p{^-_PerlSpace}', "");
    Expect(1, 33, '\P{-_PerlSpace}', "");
    Expect(0, 33, '\P{^-_PerlSpace}', "");
    Error('\p{:=_ Is_POSIXSPACE}');
    Error('\P{:=_ Is_POSIXSPACE}');
    Expect(1, 32, '\p{isposixspace}', "");
    Expect(0, 32, '\p{^isposixspace}', "");
    Expect(0, 32, '\P{isposixspace}', "");
    Expect(1, 32, '\P{^isposixspace}', "");
    Expect(0, 33, '\p{isposixspace}', "");
    Expect(1, 33, '\p{^isposixspace}', "");
    Expect(1, 33, '\P{isposixspace}', "");
    Expect(0, 33, '\P{^isposixspace}', "");
    Expect(1, 32, '\p{	is_POSIXSPACE}', "");
    Expect(0, 32, '\p{^	is_POSIXSPACE}', "");
    Expect(0, 32, '\P{	is_POSIXSPACE}', "");
    Expect(1, 32, '\P{^	is_POSIXSPACE}', "");
    Expect(0, 33, '\p{	is_POSIXSPACE}', "");
    Expect(1, 33, '\p{^	is_POSIXSPACE}', "");
    Expect(1, 33, '\P{	is_POSIXSPACE}', "");
    Expect(0, 33, '\P{^	is_POSIXSPACE}', "");
    Error('\p{/a/		Is_perlspace}');
    Error('\P{/a/		Is_perlspace}');
    Expect(1, 32, '\p{isperlspace}', "");
    Expect(0, 32, '\p{^isperlspace}', "");
    Expect(0, 32, '\P{isperlspace}', "");
    Expect(1, 32, '\P{^isperlspace}', "");
    Expect(0, 33, '\p{isperlspace}', "");
    Expect(1, 33, '\p{^isperlspace}', "");
    Expect(1, 33, '\P{isperlspace}', "");
    Expect(0, 33, '\P{^isperlspace}', "");
    Expect(1, 32, '\p{ Is_PERLSPACE}', "");
    Expect(0, 32, '\p{^ Is_PERLSPACE}', "");
    Expect(0, 32, '\P{ Is_PERLSPACE}', "");
    Expect(1, 32, '\P{^ Is_PERLSPACE}', "");
    Expect(0, 33, '\p{ Is_PERLSPACE}', "");
    Expect(1, 33, '\p{^ Is_PERLSPACE}', "");
    Expect(1, 33, '\P{ Is_PERLSPACE}', "");
    Expect(0, 33, '\P{^ Is_PERLSPACE}', "");
    Error('\p{:= posixupper}');
    Error('\P{:= posixupper}');
    Expect(1, 90, '\p{posixupper}', "");
    Expect(0, 90, '\p{^posixupper}', "");
    Expect(0, 90, '\P{posixupper}', "");
    Expect(1, 90, '\P{^posixupper}', "");
    Expect(0, 91, '\p{posixupper}', "");
    Expect(1, 91, '\p{^posixupper}', "");
    Expect(1, 91, '\P{posixupper}', "");
    Expect(0, 91, '\P{^posixupper}', "");
    Expect(1, 90, '\p{	posixupper}', "");
    Expect(0, 90, '\p{^	posixupper}', "");
    Expect(0, 90, '\P{	posixupper}', "");
    Expect(1, 90, '\P{^	posixupper}', "");
    Expect(0, 91, '\p{	posixupper}', "");
    Expect(1, 91, '\p{^	posixupper}', "");
    Expect(1, 91, '\P{	posixupper}', "");
    Expect(0, 91, '\P{^	posixupper}', "");
    Error('\p{-Is_PosixUpper:=}');
    Error('\P{-Is_PosixUpper:=}');
    Expect(1, 90, '\p{isposixupper}', "");
    Expect(0, 90, '\p{^isposixupper}', "");
    Expect(0, 90, '\P{isposixupper}', "");
    Expect(1, 90, '\P{^isposixupper}', "");
    Expect(0, 91, '\p{isposixupper}', "");
    Expect(1, 91, '\p{^isposixupper}', "");
    Expect(1, 91, '\P{isposixupper}', "");
    Expect(0, 91, '\P{^isposixupper}', "");
    Expect(1, 90, '\p{	_IS_posixupper}', "");
    Expect(0, 90, '\p{^	_IS_posixupper}', "");
    Expect(0, 90, '\P{	_IS_posixupper}', "");
    Expect(1, 90, '\P{^	_IS_posixupper}', "");
    Expect(0, 91, '\p{	_IS_posixupper}', "");
    Expect(1, 91, '\p{^	_IS_posixupper}', "");
    Expect(1, 91, '\P{	_IS_posixupper}', "");
    Expect(0, 91, '\P{^	_IS_posixupper}', "");
    Error('\p{-PosixWord:=}');
    Error('\P{-PosixWord:=}');
    Expect(1, 122, '\p{posixword}', "");
    Expect(0, 122, '\p{^posixword}', "");
    Expect(0, 122, '\P{posixword}', "");
    Expect(1, 122, '\P{^posixword}', "");
    Expect(0, 123, '\p{posixword}', "");
    Expect(1, 123, '\p{^posixword}', "");
    Expect(1, 123, '\P{posixword}', "");
    Expect(0, 123, '\P{^posixword}', "");
    Expect(1, 122, '\p{ _POSIXWORD}', "");
    Expect(0, 122, '\p{^ _POSIXWORD}', "");
    Expect(0, 122, '\P{ _POSIXWORD}', "");
    Expect(1, 122, '\P{^ _POSIXWORD}', "");
    Expect(0, 123, '\p{ _POSIXWORD}', "");
    Expect(1, 123, '\p{^ _POSIXWORD}', "");
    Expect(1, 123, '\P{ _POSIXWORD}', "");
    Expect(0, 123, '\P{^ _POSIXWORD}', "");
    Error('\p{-/a/PERLWORD}');
    Error('\P{-/a/PERLWORD}');
    Expect(1, 122, '\p{perlword}', "");
    Expect(0, 122, '\p{^perlword}', "");
    Expect(0, 122, '\P{perlword}', "");
    Expect(1, 122, '\P{^perlword}', "");
    Expect(0, 123, '\p{perlword}', "");
    Expect(1, 123, '\p{^perlword}', "");
    Expect(1, 123, '\P{perlword}', "");
    Expect(0, 123, '\P{^perlword}', "");
    Expect(1, 122, '\p{ -PerlWord}', "");
    Expect(0, 122, '\p{^ -PerlWord}', "");
    Expect(0, 122, '\P{ -PerlWord}', "");
    Expect(1, 122, '\P{^ -PerlWord}', "");
    Expect(0, 123, '\p{ -PerlWord}', "");
    Expect(1, 123, '\p{^ -PerlWord}', "");
    Expect(1, 123, '\P{ -PerlWord}', "");
    Expect(0, 123, '\P{^ -PerlWord}', "");
    Error('\p{ /a/Is_PosixWord}');
    Error('\P{ /a/Is_PosixWord}');
    Expect(1, 122, '\p{isposixword}', "");
    Expect(0, 122, '\p{^isposixword}', "");
    Expect(0, 122, '\P{isposixword}', "");
    Expect(1, 122, '\P{^isposixword}', "");
    Expect(0, 123, '\p{isposixword}', "");
    Expect(1, 123, '\p{^isposixword}', "");
    Expect(1, 123, '\P{isposixword}', "");
    Expect(0, 123, '\P{^isposixword}', "");
    Expect(1, 122, '\p{ -is_POSIXWORD}', "");
    Expect(0, 122, '\p{^ -is_POSIXWORD}', "");
    Expect(0, 122, '\P{ -is_POSIXWORD}', "");
    Expect(1, 122, '\P{^ -is_POSIXWORD}', "");
    Expect(0, 123, '\p{ -is_POSIXWORD}', "");
    Expect(1, 123, '\p{^ -is_POSIXWORD}', "");
    Expect(1, 123, '\P{ -is_POSIXWORD}', "");
    Expect(0, 123, '\P{^ -is_POSIXWORD}', "");
    Error('\p{ :=is_perlword}');
    Error('\P{ :=is_perlword}');
    Expect(1, 122, '\p{isperlword}', "");
    Expect(0, 122, '\p{^isperlword}', "");
    Expect(0, 122, '\P{isperlword}', "");
    Expect(1, 122, '\P{^isperlword}', "");
    Expect(0, 123, '\p{isperlword}', "");
    Expect(1, 123, '\p{^isperlword}', "");
    Expect(1, 123, '\P{isperlword}', "");
    Expect(0, 123, '\P{^isperlword}', "");
    Expect(1, 122, '\p{_is_PerlWord}', "");
    Expect(0, 122, '\p{^_is_PerlWord}', "");
    Expect(0, 122, '\P{_is_PerlWord}', "");
    Expect(1, 122, '\P{^_is_PerlWord}', "");
    Expect(0, 123, '\p{_is_PerlWord}', "");
    Expect(1, 123, '\p{^_is_PerlWord}', "");
    Expect(1, 123, '\P{_is_PerlWord}', "");
    Expect(0, 123, '\P{^_is_PerlWord}', "");
    Error('\p{	posixxdigit/a/}');
    Error('\P{	posixxdigit/a/}');
    Expect(1, 102, '\p{posixxdigit}', "");
    Expect(0, 102, '\p{^posixxdigit}', "");
    Expect(0, 102, '\P{posixxdigit}', "");
    Expect(1, 102, '\P{^posixxdigit}', "");
    Expect(0, 103, '\p{posixxdigit}', "");
    Expect(1, 103, '\p{^posixxdigit}', "");
    Expect(1, 103, '\P{posixxdigit}', "");
    Expect(0, 103, '\P{^posixxdigit}', "");
    Expect(1, 102, '\p{  PosixXDigit}', "");
    Expect(0, 102, '\p{^  PosixXDigit}', "");
    Expect(0, 102, '\P{  PosixXDigit}', "");
    Expect(1, 102, '\P{^  PosixXDigit}', "");
    Expect(0, 103, '\p{  PosixXDigit}', "");
    Expect(1, 103, '\p{^  PosixXDigit}', "");
    Expect(1, 103, '\P{  PosixXDigit}', "");
    Expect(0, 103, '\P{^  PosixXDigit}', "");
    Error('\p{/a/-Is_posixxdigit}');
    Error('\P{/a/-Is_posixxdigit}');
    Expect(1, 102, '\p{isposixxdigit}', "");
    Expect(0, 102, '\p{^isposixxdigit}', "");
    Expect(0, 102, '\P{isposixxdigit}', "");
    Expect(1, 102, '\P{^isposixxdigit}', "");
    Expect(0, 103, '\p{isposixxdigit}', "");
    Expect(1, 103, '\p{^isposixxdigit}', "");
    Expect(1, 103, '\P{isposixxdigit}', "");
    Expect(0, 103, '\P{^isposixxdigit}', "");
    Expect(1, 102, '\p{_	is_POSIXXDIGIT}', "");
    Expect(0, 102, '\p{^_	is_POSIXXDIGIT}', "");
    Expect(0, 102, '\P{_	is_POSIXXDIGIT}', "");
    Expect(1, 102, '\P{^_	is_POSIXXDIGIT}', "");
    Expect(0, 103, '\p{_	is_POSIXXDIGIT}', "");
    Expect(1, 103, '\p{^_	is_POSIXXDIGIT}', "");
    Expect(1, 103, '\P{_	is_POSIXXDIGIT}', "");
    Expect(0, 103, '\P{^_	is_POSIXXDIGIT}', "");
    Error('\p{:=-	ascii_Hex_DIGIT}');
    Error('\P{:=-	ascii_Hex_DIGIT}');
    Expect(1, 102, '\p{asciihexdigit}', "");
    Expect(0, 102, '\p{^asciihexdigit}', "");
    Expect(0, 102, '\P{asciihexdigit}', "");
    Expect(1, 102, '\P{^asciihexdigit}', "");
    Expect(0, 103, '\p{asciihexdigit}', "");
    Expect(1, 103, '\p{^asciihexdigit}', "");
    Expect(1, 103, '\P{asciihexdigit}', "");
    Expect(0, 103, '\P{^asciihexdigit}', "");
    Expect(1, 102, '\p{	ASCII_HEX_digit}', "");
    Expect(0, 102, '\p{^	ASCII_HEX_digit}', "");
    Expect(0, 102, '\P{	ASCII_HEX_digit}', "");
    Expect(1, 102, '\P{^	ASCII_HEX_digit}', "");
    Expect(0, 103, '\p{	ASCII_HEX_digit}', "");
    Expect(1, 103, '\p{^	ASCII_HEX_digit}', "");
    Expect(1, 103, '\P{	ASCII_HEX_digit}', "");
    Expect(0, 103, '\P{^	ASCII_HEX_digit}', "");
    Error('\p{/a/Is_ASCII_HEX_DIGIT}');
    Error('\P{/a/Is_ASCII_HEX_DIGIT}');
    Expect(1, 102, '\p{isasciihexdigit}', "");
    Expect(0, 102, '\p{^isasciihexdigit}', "");
    Expect(0, 102, '\P{isasciihexdigit}', "");
    Expect(1, 102, '\P{^isasciihexdigit}', "");
    Expect(0, 103, '\p{isasciihexdigit}', "");
    Expect(1, 103, '\p{^isasciihexdigit}', "");
    Expect(1, 103, '\P{isasciihexdigit}', "");
    Expect(0, 103, '\P{^isasciihexdigit}', "");
    Expect(1, 102, '\p{_is_ASCII_Hex_DIGIT}', "");
    Expect(0, 102, '\p{^_is_ASCII_Hex_DIGIT}', "");
    Expect(0, 102, '\P{_is_ASCII_Hex_DIGIT}', "");
    Expect(1, 102, '\P{^_is_ASCII_Hex_DIGIT}', "");
    Expect(0, 103, '\p{_is_ASCII_Hex_DIGIT}', "");
    Expect(1, 103, '\p{^_is_ASCII_Hex_DIGIT}', "");
    Expect(1, 103, '\P{_is_ASCII_Hex_DIGIT}', "");
    Expect(0, 103, '\P{^_is_ASCII_Hex_DIGIT}', "");
    Error('\p{:=		ahex}');
    Error('\P{:=		ahex}');
    Expect(1, 102, '\p{ahex}', "");
    Expect(0, 102, '\p{^ahex}', "");
    Expect(0, 102, '\P{ahex}', "");
    Expect(1, 102, '\P{^ahex}', "");
    Expect(0, 103, '\p{ahex}', "");
    Expect(1, 103, '\p{^ahex}', "");
    Expect(1, 103, '\P{ahex}', "");
    Expect(0, 103, '\P{^ahex}', "");
    Expect(1, 102, '\p{--ahex}', "");
    Expect(0, 102, '\p{^--ahex}', "");
    Expect(0, 102, '\P{--ahex}', "");
    Expect(1, 102, '\P{^--ahex}', "");
    Expect(0, 103, '\p{--ahex}', "");
    Expect(1, 103, '\p{^--ahex}', "");
    Expect(1, 103, '\P{--ahex}', "");
    Expect(0, 103, '\P{^--ahex}', "");
    Error('\p{-:=is_AHex}');
    Error('\P{-:=is_AHex}');
    Expect(1, 102, '\p{isahex}', "");
    Expect(0, 102, '\p{^isahex}', "");
    Expect(0, 102, '\P{isahex}', "");
    Expect(1, 102, '\P{^isahex}', "");
    Expect(0, 103, '\p{isahex}', "");
    Expect(1, 103, '\p{^isahex}', "");
    Expect(1, 103, '\P{isahex}', "");
    Expect(0, 103, '\P{^isahex}', "");
    Expect(1, 102, '\p{- Is_AHex}', "");
    Expect(0, 102, '\p{^- Is_AHex}', "");
    Expect(0, 102, '\P{- Is_AHex}', "");
    Expect(1, 102, '\P{^- Is_AHex}', "");
    Expect(0, 103, '\p{- Is_AHex}', "");
    Expect(1, 103, '\p{^- Is_AHex}', "");
    Expect(1, 103, '\P{- Is_AHex}', "");
    Expect(0, 103, '\P{^- Is_AHex}', "");
    Error('\p{:=	 PREPENDED_Concatenation_MARK}');
    Error('\P{:=	 PREPENDED_Concatenation_MARK}');
    Expect(1, 69837, '\p{prependedconcatenationmark}', "");
    Expect(0, 69837, '\p{^prependedconcatenationmark}', "");
    Expect(0, 69837, '\P{prependedconcatenationmark}', "");
    Expect(1, 69837, '\P{^prependedconcatenationmark}', "");
    Expect(0, 69838, '\p{prependedconcatenationmark}', "");
    Expect(1, 69838, '\p{^prependedconcatenationmark}', "");
    Expect(1, 69838, '\P{prependedconcatenationmark}', "");
    Expect(0, 69838, '\P{^prependedconcatenationmark}', "");
    Expect(1, 69837, '\p{-_Prepended_CONCATENATION_mark}', "");
    Expect(0, 69837, '\p{^-_Prepended_CONCATENATION_mark}', "");
    Expect(0, 69837, '\P{-_Prepended_CONCATENATION_mark}', "");
    Expect(1, 69837, '\P{^-_Prepended_CONCATENATION_mark}', "");
    Expect(0, 69838, '\p{-_Prepended_CONCATENATION_mark}', "");
    Expect(1, 69838, '\p{^-_Prepended_CONCATENATION_mark}', "");
    Expect(1, 69838, '\P{-_Prepended_CONCATENATION_mark}', "");
    Expect(0, 69838, '\P{^-_Prepended_CONCATENATION_mark}', "");
    Error('\p{-Is_prepended_concatenation_Mark/a/}');
    Error('\P{-Is_prepended_concatenation_Mark/a/}');
    Expect(1, 69837, '\p{isprependedconcatenationmark}', "");
    Expect(0, 69837, '\p{^isprependedconcatenationmark}', "");
    Expect(0, 69837, '\P{isprependedconcatenationmark}', "");
    Expect(1, 69837, '\P{^isprependedconcatenationmark}', "");
    Expect(0, 69838, '\p{isprependedconcatenationmark}', "");
    Expect(1, 69838, '\p{^isprependedconcatenationmark}', "");
    Expect(1, 69838, '\P{isprependedconcatenationmark}', "");
    Expect(0, 69838, '\P{^isprependedconcatenationmark}', "");
    Expect(1, 69837, '\p{ -is_Prepended_CONCATENATION_MARK}', "");
    Expect(0, 69837, '\p{^ -is_Prepended_CONCATENATION_MARK}', "");
    Expect(0, 69837, '\P{ -is_Prepended_CONCATENATION_MARK}', "");
    Expect(1, 69837, '\P{^ -is_Prepended_CONCATENATION_MARK}', "");
    Expect(0, 69838, '\p{ -is_Prepended_CONCATENATION_MARK}', "");
    Expect(1, 69838, '\p{^ -is_Prepended_CONCATENATION_MARK}', "");
    Expect(1, 69838, '\P{ -is_Prepended_CONCATENATION_MARK}', "");
    Expect(0, 69838, '\P{^ -is_Prepended_CONCATENATION_MARK}', "");
    Error('\p{ -PCM/a/}');
    Error('\P{ -PCM/a/}');
    Expect(1, 69837, '\p{pcm}', "");
    Expect(0, 69837, '\p{^pcm}', "");
    Expect(0, 69837, '\P{pcm}', "");
    Expect(1, 69837, '\P{^pcm}', "");
    Expect(0, 69838, '\p{pcm}', "");
    Expect(1, 69838, '\p{^pcm}', "");
    Expect(1, 69838, '\P{pcm}', "");
    Expect(0, 69838, '\P{^pcm}', "");
    Expect(1, 69837, '\p{ -PCM}', "");
    Expect(0, 69837, '\p{^ -PCM}', "");
    Expect(0, 69837, '\P{ -PCM}', "");
    Expect(1, 69837, '\P{^ -PCM}', "");
    Expect(0, 69838, '\p{ -PCM}', "");
    Expect(1, 69838, '\p{^ -PCM}', "");
    Expect(1, 69838, '\P{ -PCM}', "");
    Expect(0, 69838, '\P{^ -PCM}', "");
    Error('\p{ :=is_PCM}');
    Error('\P{ :=is_PCM}');
    Expect(1, 69837, '\p{ispcm}', "");
    Expect(0, 69837, '\p{^ispcm}', "");
    Expect(0, 69837, '\P{ispcm}', "");
    Expect(1, 69837, '\P{^ispcm}', "");
    Expect(0, 69838, '\p{ispcm}', "");
    Expect(1, 69838, '\p{^ispcm}', "");
    Expect(1, 69838, '\P{ispcm}', "");
    Expect(0, 69838, '\P{^ispcm}', "");
    Expect(1, 69837, '\p{ is_pcm}', "");
    Expect(0, 69837, '\p{^ is_pcm}', "");
    Expect(0, 69837, '\P{ is_pcm}', "");
    Expect(1, 69837, '\P{^ is_pcm}', "");
    Expect(0, 69838, '\p{ is_pcm}', "");
    Expect(1, 69838, '\p{^ is_pcm}', "");
    Expect(1, 69838, '\P{ is_pcm}', "");
    Expect(0, 69838, '\P{^ is_pcm}', "");
    Error('\p{/a/ XPosixPrint}');
    Error('\P{/a/ XPosixPrint}');
    Expect(1, 1114109, '\p{xposixprint}', "");
    Expect(0, 1114109, '\p{^xposixprint}', "");
    Expect(0, 1114109, '\P{xposixprint}', "");
    Expect(1, 1114109, '\P{^xposixprint}', "");
    Expect(0, 918000, '\p{xposixprint}', "");
    Expect(1, 918000, '\p{^xposixprint}', "");
    Expect(1, 918000, '\P{xposixprint}', "");
    Expect(0, 918000, '\P{^xposixprint}', "");
    Expect(1, 1114109, '\p{-	xposixprint}', "");
    Expect(0, 1114109, '\p{^-	xposixprint}', "");
    Expect(0, 1114109, '\P{-	xposixprint}', "");
    Expect(1, 1114109, '\P{^-	xposixprint}', "");
    Expect(0, 918000, '\p{-	xposixprint}', "");
    Expect(1, 918000, '\p{^-	xposixprint}', "");
    Expect(1, 918000, '\P{-	xposixprint}', "");
    Expect(0, 918000, '\P{^-	xposixprint}', "");
    Error('\p{/a/	PRINT}');
    Error('\P{/a/	PRINT}');
    Expect(1, 1114109, '\p{print}', "");
    Expect(0, 1114109, '\p{^print}', "");
    Expect(0, 1114109, '\P{print}', "");
    Expect(1, 1114109, '\P{^print}', "");
    Expect(0, 918000, '\p{print}', "");
    Expect(1, 918000, '\p{^print}', "");
    Expect(1, 918000, '\P{print}', "");
    Expect(0, 918000, '\P{^print}', "");
    Expect(1, 1114109, '\p{ _Print}', "");
    Expect(0, 1114109, '\p{^ _Print}', "");
    Expect(0, 1114109, '\P{ _Print}', "");
    Expect(1, 1114109, '\P{^ _Print}', "");
    Expect(0, 918000, '\p{ _Print}', "");
    Expect(1, 918000, '\p{^ _Print}', "");
    Expect(1, 918000, '\P{ _Print}', "");
    Expect(0, 918000, '\P{^ _Print}', "");
    Error('\p{ Is_XPOSIXPRINT:=}');
    Error('\P{ Is_XPOSIXPRINT:=}');
    Expect(1, 1114109, '\p{isxposixprint}', "");
    Expect(0, 1114109, '\p{^isxposixprint}', "");
    Expect(0, 1114109, '\P{isxposixprint}', "");
    Expect(1, 1114109, '\P{^isxposixprint}', "");
    Expect(0, 918000, '\p{isxposixprint}', "");
    Expect(1, 918000, '\p{^isxposixprint}', "");
    Expect(1, 918000, '\P{isxposixprint}', "");
    Expect(0, 918000, '\P{^isxposixprint}', "");
    Expect(1, 1114109, '\p{_is_XPOSIXPRINT}', "");
    Expect(0, 1114109, '\p{^_is_XPOSIXPRINT}', "");
    Expect(0, 1114109, '\P{_is_XPOSIXPRINT}', "");
    Expect(1, 1114109, '\P{^_is_XPOSIXPRINT}', "");
    Expect(0, 918000, '\p{_is_XPOSIXPRINT}', "");
    Expect(1, 918000, '\p{^_is_XPOSIXPRINT}', "");
    Expect(1, 918000, '\P{_is_XPOSIXPRINT}', "");
    Expect(0, 918000, '\P{^_is_XPOSIXPRINT}', "");
    Error('\p{:= is_Print}');
    Error('\P{:= is_Print}');
    Expect(1, 1114109, '\p{isprint}', "");
    Expect(0, 1114109, '\p{^isprint}', "");
    Expect(0, 1114109, '\P{isprint}', "");
    Expect(1, 1114109, '\P{^isprint}', "");
    Expect(0, 918000, '\p{isprint}', "");
    Expect(1, 918000, '\p{^isprint}', "");
    Expect(1, 918000, '\P{isprint}', "");
    Expect(0, 918000, '\P{^isprint}', "");
    Expect(1, 1114109, '\p{		is_Print}', "");
    Expect(0, 1114109, '\p{^		is_Print}', "");
    Expect(0, 1114109, '\P{		is_Print}', "");
    Expect(1, 1114109, '\P{^		is_Print}', "");
    Expect(0, 918000, '\p{		is_Print}', "");
    Expect(1, 918000, '\p{^		is_Print}', "");
    Expect(1, 918000, '\P{		is_Print}', "");
    Expect(0, 918000, '\P{^		is_Print}', "");
    Error('\p{	:=private_use}');
    Error('\P{	:=private_use}');
    Expect(1, 1114109, '\p{privateuse}', "");
    Expect(0, 1114109, '\p{^privateuse}', "");
    Expect(0, 1114109, '\P{privateuse}', "");
    Expect(1, 1114109, '\P{^privateuse}', "");
    Expect(0, 63744, '\p{privateuse}', "");
    Expect(1, 63744, '\p{^privateuse}', "");
    Expect(1, 63744, '\P{privateuse}', "");
    Expect(0, 63744, '\P{^privateuse}', "");
    Expect(1, 1114109, '\p{ _Private_Use}', "");
    Expect(0, 1114109, '\p{^ _Private_Use}', "");
    Expect(0, 1114109, '\P{ _Private_Use}', "");
    Expect(1, 1114109, '\P{^ _Private_Use}', "");
    Expect(0, 63744, '\p{ _Private_Use}', "");
    Expect(1, 63744, '\p{^ _Private_Use}', "");
    Expect(1, 63744, '\P{ _Private_Use}', "");
    Expect(0, 63744, '\P{^ _Private_Use}', "");
    Error('\p{/a/	is_Private_Use}');
    Error('\P{/a/	is_Private_Use}');
    Expect(1, 1114109, '\p{isprivateuse}', "");
    Expect(0, 1114109, '\p{^isprivateuse}', "");
    Expect(0, 1114109, '\P{isprivateuse}', "");
    Expect(1, 1114109, '\P{^isprivateuse}', "");
    Expect(0, 63744, '\p{isprivateuse}', "");
    Expect(1, 63744, '\p{^isprivateuse}', "");
    Expect(1, 63744, '\P{isprivateuse}', "");
    Expect(0, 63744, '\P{^isprivateuse}', "");
    Expect(1, 1114109, '\p{_	Is_Private_Use}', "");
    Expect(0, 1114109, '\p{^_	Is_Private_Use}', "");
    Expect(0, 1114109, '\P{_	Is_Private_Use}', "");
    Expect(1, 1114109, '\P{^_	Is_Private_Use}', "");
    Expect(0, 63744, '\p{_	Is_Private_Use}', "");
    Expect(1, 63744, '\p{^_	Is_Private_Use}', "");
    Expect(1, 63744, '\P{_	Is_Private_Use}', "");
    Expect(0, 63744, '\P{^_	Is_Private_Use}', "");
    Error('\p{Co:=}');
    Error('\P{Co:=}');
    Expect(1, 1114109, '\p{co}', "");
    Expect(0, 1114109, '\p{^co}', "");
    Expect(0, 1114109, '\P{co}', "");
    Expect(1, 1114109, '\P{^co}', "");
    Expect(0, 63744, '\p{co}', "");
    Expect(1, 63744, '\p{^co}', "");
    Expect(1, 63744, '\P{co}', "");
    Expect(0, 63744, '\P{^co}', "");
    Expect(1, 1114109, '\p{-Co}', "");
    Expect(0, 1114109, '\p{^-Co}', "");
    Expect(0, 1114109, '\P{-Co}', "");
    Expect(1, 1114109, '\P{^-Co}', "");
    Expect(0, 63744, '\p{-Co}', "");
    Expect(1, 63744, '\p{^-Co}', "");
    Expect(1, 63744, '\P{-Co}', "");
    Expect(0, 63744, '\P{^-Co}', "");
    Error('\p{/a/IS_co}');
    Error('\P{/a/IS_co}');
    Expect(1, 1114109, '\p{isco}', "");
    Expect(0, 1114109, '\p{^isco}', "");
    Expect(0, 1114109, '\P{isco}', "");
    Expect(1, 1114109, '\P{^isco}', "");
    Expect(0, 63744, '\p{isco}', "");
    Expect(1, 63744, '\p{^isco}', "");
    Expect(1, 63744, '\P{isco}', "");
    Expect(0, 63744, '\P{^isco}', "");
    Expect(1, 1114109, '\p{	 is_CO}', "");
    Expect(0, 1114109, '\p{^	 is_CO}', "");
    Expect(0, 1114109, '\P{	 is_CO}', "");
    Expect(1, 1114109, '\P{^	 is_CO}', "");
    Expect(0, 63744, '\p{	 is_CO}', "");
    Expect(1, 63744, '\p{^	 is_CO}', "");
    Expect(1, 63744, '\P{	 is_CO}', "");
    Expect(0, 63744, '\P{^	 is_CO}', "");
    Error('\p{ _Private_use_AREA/a/}');
    Error('\P{ _Private_use_AREA/a/}');
    Expect(1, 63743, '\p{privateusearea}', "");
    Expect(0, 63743, '\p{^privateusearea}', "");
    Expect(0, 63743, '\P{privateusearea}', "");
    Expect(1, 63743, '\P{^privateusearea}', "");
    Expect(0, 63744, '\p{privateusearea}', "");
    Expect(1, 63744, '\p{^privateusearea}', "");
    Expect(1, 63744, '\P{privateusearea}', "");
    Expect(0, 63744, '\P{^privateusearea}', "");
    Expect(1, 63743, '\p{ private_use_Area}', "");
    Expect(0, 63743, '\p{^ private_use_Area}', "");
    Expect(0, 63743, '\P{ private_use_Area}', "");
    Expect(1, 63743, '\P{^ private_use_Area}', "");
    Expect(0, 63744, '\p{ private_use_Area}', "");
    Expect(1, 63744, '\p{^ private_use_Area}', "");
    Expect(1, 63744, '\P{ private_use_Area}', "");
    Expect(0, 63744, '\P{^ private_use_Area}', "");
    Error('\p{	_IS_Private_Use_Area:=}');
    Error('\P{	_IS_Private_Use_Area:=}');
    Expect(1, 63743, '\p{isprivateusearea}', "");
    Expect(0, 63743, '\p{^isprivateusearea}', "");
    Expect(0, 63743, '\P{isprivateusearea}', "");
    Expect(1, 63743, '\P{^isprivateusearea}', "");
    Expect(0, 63744, '\p{isprivateusearea}', "");
    Expect(1, 63744, '\p{^isprivateusearea}', "");
    Expect(1, 63744, '\P{isprivateusearea}', "");
    Expect(0, 63744, '\P{^isprivateusearea}', "");
    Expect(1, 63743, '\p{- Is_private_USE_Area}', "");
    Expect(0, 63743, '\p{^- Is_private_USE_Area}', "");
    Expect(0, 63743, '\P{- Is_private_USE_Area}', "");
    Expect(1, 63743, '\P{^- Is_private_USE_Area}', "");
    Expect(0, 63744, '\p{- Is_private_USE_Area}', "");
    Expect(1, 63744, '\p{^- Is_private_USE_Area}', "");
    Expect(1, 63744, '\P{- Is_private_USE_Area}', "");
    Expect(0, 63744, '\P{^- Is_private_USE_Area}', "");
    Error('\p{:=--In_private_Use_Area}');
    Error('\P{:=--In_private_Use_Area}');
    Expect(1, 63743, '\p{inprivateusearea}', "");
    Expect(0, 63743, '\p{^inprivateusearea}', "");
    Expect(0, 63743, '\P{inprivateusearea}', "");
    Expect(1, 63743, '\P{^inprivateusearea}', "");
    Expect(0, 63744, '\p{inprivateusearea}', "");
    Expect(1, 63744, '\p{^inprivateusearea}', "");
    Expect(1, 63744, '\P{inprivateusearea}', "");
    Expect(0, 63744, '\P{^inprivateusearea}', "");
    Expect(1, 63743, '\p{-_IN_private_use_Area}', "");
    Expect(0, 63743, '\p{^-_IN_private_use_Area}', "");
    Expect(0, 63743, '\P{-_IN_private_use_Area}', "");
    Expect(1, 63743, '\P{^-_IN_private_use_Area}', "");
    Expect(0, 63744, '\p{-_IN_private_use_Area}', "");
    Expect(1, 63744, '\p{^-_IN_private_use_Area}', "");
    Expect(1, 63744, '\P{-_IN_private_use_Area}', "");
    Expect(0, 63744, '\P{^-_IN_private_use_Area}', "");
    Error('\p{	:=pua}');
    Error('\P{	:=pua}');
    Expect(1, 63743, '\p{pua}', "");
    Expect(0, 63743, '\p{^pua}', "");
    Expect(0, 63743, '\P{pua}', "");
    Expect(1, 63743, '\P{^pua}', "");
    Expect(0, 63744, '\p{pua}', "");
    Expect(1, 63744, '\p{^pua}', "");
    Expect(1, 63744, '\P{pua}', "");
    Expect(0, 63744, '\P{^pua}', "");
    Expect(1, 63743, '\p{	 pua}', "");
    Expect(0, 63743, '\p{^	 pua}', "");
    Expect(0, 63743, '\P{	 pua}', "");
    Expect(1, 63743, '\P{^	 pua}', "");
    Expect(0, 63744, '\p{	 pua}', "");
    Expect(1, 63744, '\p{^	 pua}', "");
    Expect(1, 63744, '\P{	 pua}', "");
    Expect(0, 63744, '\P{^	 pua}', "");
    Error('\p{ :=is_PUA}');
    Error('\P{ :=is_PUA}');
    Expect(1, 63743, '\p{ispua}', "");
    Expect(0, 63743, '\p{^ispua}', "");
    Expect(0, 63743, '\P{ispua}', "");
    Expect(1, 63743, '\P{^ispua}', "");
    Expect(0, 63744, '\p{ispua}', "");
    Expect(1, 63744, '\p{^ispua}', "");
    Expect(1, 63744, '\P{ispua}', "");
    Expect(0, 63744, '\P{^ispua}', "");
    Expect(1, 63743, '\p{	_Is_PUA}', "");
    Expect(0, 63743, '\p{^	_Is_PUA}', "");
    Expect(0, 63743, '\P{	_Is_PUA}', "");
    Expect(1, 63743, '\P{^	_Is_PUA}', "");
    Expect(0, 63744, '\p{	_Is_PUA}', "");
    Expect(1, 63744, '\p{^	_Is_PUA}', "");
    Expect(1, 63744, '\P{	_Is_PUA}', "");
    Expect(0, 63744, '\P{^	_Is_PUA}', "");
    Error('\p{--In_PUA:=}');
    Error('\P{--In_PUA:=}');
    Expect(1, 63743, '\p{inpua}', "");
    Expect(0, 63743, '\p{^inpua}', "");
    Expect(0, 63743, '\P{inpua}', "");
    Expect(1, 63743, '\P{^inpua}', "");
    Expect(0, 63744, '\p{inpua}', "");
    Expect(1, 63744, '\p{^inpua}', "");
    Expect(1, 63744, '\P{inpua}', "");
    Expect(0, 63744, '\P{^inpua}', "");
    Expect(1, 63743, '\p{_	in_PUA}', "");
    Expect(0, 63743, '\p{^_	in_PUA}', "");
    Expect(0, 63743, '\P{_	in_PUA}', "");
    Expect(1, 63743, '\P{^_	in_PUA}', "");
    Expect(0, 63744, '\p{_	in_PUA}', "");
    Expect(1, 63744, '\p{^_	in_PUA}', "");
    Expect(1, 63744, '\P{_	in_PUA}', "");
    Expect(0, 63744, '\P{^_	in_PUA}', "");
    Error('\p{:=  In_Private_USE}');
    Error('\P{:=  In_Private_USE}');
    Expect(1, 63743, '\p{inprivateuse}', "");
    Expect(0, 63743, '\p{^inprivateuse}', "");
    Expect(0, 63743, '\P{inprivateuse}', "");
    Expect(1, 63743, '\P{^inprivateuse}', "");
    Expect(0, 63744, '\p{inprivateuse}', "");
    Expect(1, 63744, '\p{^inprivateuse}', "");
    Expect(1, 63744, '\P{inprivateuse}', "");
    Expect(0, 63744, '\P{^inprivateuse}', "");
    Expect(1, 63743, '\p{-IN_PRIVATE_USE}', "");
    Expect(0, 63743, '\p{^-IN_PRIVATE_USE}', "");
    Expect(0, 63743, '\P{-IN_PRIVATE_USE}', "");
    Expect(1, 63743, '\P{^-IN_PRIVATE_USE}', "");
    Expect(0, 63744, '\p{-IN_PRIVATE_USE}', "");
    Expect(1, 63744, '\p{^-IN_PRIVATE_USE}', "");
    Expect(1, 63744, '\P{-IN_PRIVATE_USE}', "");
    Expect(0, 63744, '\P{^-IN_PRIVATE_USE}', "");
    Error('\p{:=__psalter_PAHLAVI}');
    Error('\P{:=__psalter_PAHLAVI}');
    Expect(1, 68527, '\p{psalterpahlavi}', "");
    Expect(0, 68527, '\p{^psalterpahlavi}', "");
    Expect(0, 68527, '\P{psalterpahlavi}', "");
    Expect(1, 68527, '\P{^psalterpahlavi}', "");
    Expect(0, 68528, '\p{psalterpahlavi}', "");
    Expect(1, 68528, '\p{^psalterpahlavi}', "");
    Expect(1, 68528, '\P{psalterpahlavi}', "");
    Expect(0, 68528, '\P{^psalterpahlavi}', "");
    Expect(1, 68527, '\p{	 Psalter_Pahlavi}', "");
    Expect(0, 68527, '\p{^	 Psalter_Pahlavi}', "");
    Expect(0, 68527, '\P{	 Psalter_Pahlavi}', "");
    Expect(1, 68527, '\P{^	 Psalter_Pahlavi}', "");
    Expect(0, 68528, '\p{	 Psalter_Pahlavi}', "");
    Expect(1, 68528, '\p{^	 Psalter_Pahlavi}', "");
    Expect(1, 68528, '\P{	 Psalter_Pahlavi}', "");
    Expect(0, 68528, '\P{^	 Psalter_Pahlavi}', "");
    Error('\p{-	IS_psalter_Pahlavi:=}');
    Error('\P{-	IS_psalter_Pahlavi:=}');
    Expect(1, 68527, '\p{ispsalterpahlavi}', "");
    Expect(0, 68527, '\p{^ispsalterpahlavi}', "");
    Expect(0, 68527, '\P{ispsalterpahlavi}', "");
    Expect(1, 68527, '\P{^ispsalterpahlavi}', "");
    Expect(0, 68528, '\p{ispsalterpahlavi}', "");
    Expect(1, 68528, '\p{^ispsalterpahlavi}', "");
    Expect(1, 68528, '\P{ispsalterpahlavi}', "");
    Expect(0, 68528, '\P{^ispsalterpahlavi}', "");
    Expect(1, 68527, '\p{	-IS_Psalter_pahlavi}', "");
    Expect(0, 68527, '\p{^	-IS_Psalter_pahlavi}', "");
    Expect(0, 68527, '\P{	-IS_Psalter_pahlavi}', "");
    Expect(1, 68527, '\P{^	-IS_Psalter_pahlavi}', "");
    Expect(0, 68528, '\p{	-IS_Psalter_pahlavi}', "");
    Expect(1, 68528, '\p{^	-IS_Psalter_pahlavi}', "");
    Expect(1, 68528, '\P{	-IS_Psalter_pahlavi}', "");
    Expect(0, 68528, '\P{^	-IS_Psalter_pahlavi}', "");
    Error('\p{-/a/PHLP}');
    Error('\P{-/a/PHLP}');
    Expect(1, 68527, '\p{phlp}', "");
    Expect(0, 68527, '\p{^phlp}', "");
    Expect(0, 68527, '\P{phlp}', "");
    Expect(1, 68527, '\P{^phlp}', "");
    Expect(0, 68528, '\p{phlp}', "");
    Expect(1, 68528, '\p{^phlp}', "");
    Expect(1, 68528, '\P{phlp}', "");
    Expect(0, 68528, '\P{^phlp}', "");
    Expect(1, 68527, '\p{ _Phlp}', "");
    Expect(0, 68527, '\p{^ _Phlp}', "");
    Expect(0, 68527, '\P{ _Phlp}', "");
    Expect(1, 68527, '\P{^ _Phlp}', "");
    Expect(0, 68528, '\p{ _Phlp}', "");
    Expect(1, 68528, '\p{^ _Phlp}', "");
    Expect(1, 68528, '\P{ _Phlp}', "");
    Expect(0, 68528, '\P{^ _Phlp}', "");
    Error('\p{_/a/Is_Phlp}');
    Error('\P{_/a/Is_Phlp}');
    Expect(1, 68527, '\p{isphlp}', "");
    Expect(0, 68527, '\p{^isphlp}', "");
    Expect(0, 68527, '\P{isphlp}', "");
    Expect(1, 68527, '\P{^isphlp}', "");
    Expect(0, 68528, '\p{isphlp}', "");
    Expect(1, 68528, '\p{^isphlp}', "");
    Expect(1, 68528, '\P{isphlp}', "");
    Expect(0, 68528, '\P{^isphlp}', "");
    Expect(1, 68527, '\p{		Is_Phlp}', "");
    Expect(0, 68527, '\p{^		Is_Phlp}', "");
    Expect(0, 68527, '\P{		Is_Phlp}', "");
    Expect(1, 68527, '\P{^		Is_Phlp}', "");
    Expect(0, 68528, '\p{		Is_Phlp}', "");
    Expect(1, 68528, '\p{^		Is_Phlp}', "");
    Expect(1, 68528, '\P{		Is_Phlp}', "");
    Expect(0, 68528, '\P{^		Is_Phlp}', "");
    Error('\p{/a/punct}');
    Error('\P{/a/punct}');
    Expect(1, 125279, '\p{punct}', "");
    Expect(0, 125279, '\p{^punct}', "");
    Expect(0, 125279, '\P{punct}', "");
    Expect(1, 125279, '\P{^punct}', "");
    Expect(0, 125280, '\p{punct}', "");
    Expect(1, 125280, '\p{^punct}', "");
    Expect(1, 125280, '\P{punct}', "");
    Expect(0, 125280, '\P{^punct}', "");
    Expect(1, 125279, '\p{		punct}', "");
    Expect(0, 125279, '\p{^		punct}', "");
    Expect(0, 125279, '\P{		punct}', "");
    Expect(1, 125279, '\P{^		punct}', "");
    Expect(0, 125280, '\p{		punct}', "");
    Expect(1, 125280, '\p{^		punct}', "");
    Expect(1, 125280, '\P{		punct}', "");
    Expect(0, 125280, '\P{^		punct}', "");
    Error('\p{ is_Punct/a/}');
    Error('\P{ is_Punct/a/}');
    Expect(1, 125279, '\p{ispunct}', "");
    Expect(0, 125279, '\p{^ispunct}', "");
    Expect(0, 125279, '\P{ispunct}', "");
    Expect(1, 125279, '\P{^ispunct}', "");
    Expect(0, 125280, '\p{ispunct}', "");
    Expect(1, 125280, '\p{^ispunct}', "");
    Expect(1, 125280, '\P{ispunct}', "");
    Expect(0, 125280, '\P{^ispunct}', "");
    Expect(1, 125279, '\p{_	Is_punct}', "");
    Expect(0, 125279, '\p{^_	Is_punct}', "");
    Expect(0, 125279, '\P{_	Is_punct}', "");
    Expect(1, 125279, '\P{^_	Is_punct}', "");
    Expect(0, 125280, '\p{_	Is_punct}', "");
    Expect(1, 125280, '\p{^_	Is_punct}', "");
    Expect(1, 125280, '\P{_	Is_punct}', "");
    Expect(0, 125280, '\P{^_	Is_punct}', "");
    Error('\p{ 	PUNCTUATION/a/}');
    Error('\P{ 	PUNCTUATION/a/}');
    Expect(1, 125279, '\p{punctuation}', "");
    Expect(0, 125279, '\p{^punctuation}', "");
    Expect(0, 125279, '\P{punctuation}', "");
    Expect(1, 125279, '\P{^punctuation}', "");
    Expect(0, 125280, '\p{punctuation}', "");
    Expect(1, 125280, '\p{^punctuation}', "");
    Expect(1, 125280, '\P{punctuation}', "");
    Expect(0, 125280, '\P{^punctuation}', "");
    Expect(1, 125279, '\p{ PUNCTUATION}', "");
    Expect(0, 125279, '\p{^ PUNCTUATION}', "");
    Expect(0, 125279, '\P{ PUNCTUATION}', "");
    Expect(1, 125279, '\P{^ PUNCTUATION}', "");
    Expect(0, 125280, '\p{ PUNCTUATION}', "");
    Expect(1, 125280, '\p{^ PUNCTUATION}', "");
    Expect(1, 125280, '\P{ PUNCTUATION}', "");
    Expect(0, 125280, '\P{^ PUNCTUATION}', "");
    Error('\p{ :=IS_punctuation}');
    Error('\P{ :=IS_punctuation}');
    Expect(1, 125279, '\p{ispunctuation}', "");
    Expect(0, 125279, '\p{^ispunctuation}', "");
    Expect(0, 125279, '\P{ispunctuation}', "");
    Expect(1, 125279, '\P{^ispunctuation}', "");
    Expect(0, 125280, '\p{ispunctuation}', "");
    Expect(1, 125280, '\p{^ispunctuation}', "");
    Expect(1, 125280, '\P{ispunctuation}', "");
    Expect(0, 125280, '\P{^ispunctuation}', "");
    Expect(1, 125279, '\p{ 	Is_punctuation}', "");
    Expect(0, 125279, '\p{^ 	Is_punctuation}', "");
    Expect(0, 125279, '\P{ 	Is_punctuation}', "");
    Expect(1, 125279, '\P{^ 	Is_punctuation}', "");
    Expect(0, 125280, '\p{ 	Is_punctuation}', "");
    Expect(1, 125280, '\p{^ 	Is_punctuation}', "");
    Expect(1, 125280, '\P{ 	Is_punctuation}', "");
    Expect(0, 125280, '\P{^ 	Is_punctuation}', "");
    Error('\p{/a/	P}');
    Error('\P{/a/	P}');
    Expect(1, 125279, '\p{p}', "");
    Expect(0, 125279, '\p{^p}', "");
    Expect(0, 125279, '\P{p}', "");
    Expect(1, 125279, '\P{^p}', "");
    Expect(0, 125280, '\p{p}', "");
    Expect(1, 125280, '\p{^p}', "");
    Expect(1, 125280, '\P{p}', "");
    Expect(0, 125280, '\P{^p}', "");
    Expect(1, 125279, '\p{	_P}', "");
    Expect(0, 125279, '\p{^	_P}', "");
    Expect(0, 125279, '\P{	_P}', "");
    Expect(1, 125279, '\P{^	_P}', "");
    Expect(0, 125280, '\p{	_P}', "");
    Expect(1, 125280, '\p{^	_P}', "");
    Expect(1, 125280, '\P{	_P}', "");
    Expect(0, 125280, '\P{^	_P}', "");
    Error('\p{-Is_P:=}');
    Error('\P{-Is_P:=}');
    Expect(1, 125279, '\p{isp}', "");
    Expect(0, 125279, '\p{^isp}', "");
    Expect(0, 125279, '\P{isp}', "");
    Expect(1, 125279, '\P{^isp}', "");
    Expect(0, 125280, '\p{isp}', "");
    Expect(1, 125280, '\p{^isp}', "");
    Expect(1, 125280, '\P{isp}', "");
    Expect(0, 125280, '\P{^isp}', "");
    Expect(1, 125279, '\p{__IS_p}', "");
    Expect(0, 125279, '\p{^__IS_p}', "");
    Expect(0, 125279, '\P{__IS_p}', "");
    Expect(1, 125279, '\P{^__IS_p}', "");
    Expect(0, 125280, '\p{__IS_p}', "");
    Expect(1, 125280, '\p{^__IS_p}', "");
    Expect(1, 125280, '\P{__IS_p}', "");
    Expect(0, 125280, '\P{^__IS_p}', "");
    Error('\p{-	Quotation_Mark/a/}');
    Error('\P{-	Quotation_Mark/a/}');
    Expect(1, 65379, '\p{quotationmark}', "");
    Expect(0, 65379, '\p{^quotationmark}', "");
    Expect(0, 65379, '\P{quotationmark}', "");
    Expect(1, 65379, '\P{^quotationmark}', "");
    Expect(0, 65380, '\p{quotationmark}', "");
    Expect(1, 65380, '\p{^quotationmark}', "");
    Expect(1, 65380, '\P{quotationmark}', "");
    Expect(0, 65380, '\P{^quotationmark}', "");
    Expect(1, 65379, '\p{--Quotation_mark}', "");
    Expect(0, 65379, '\p{^--Quotation_mark}', "");
    Expect(0, 65379, '\P{--Quotation_mark}', "");
    Expect(1, 65379, '\P{^--Quotation_mark}', "");
    Expect(0, 65380, '\p{--Quotation_mark}', "");
    Expect(1, 65380, '\p{^--Quotation_mark}', "");
    Expect(1, 65380, '\P{--Quotation_mark}', "");
    Expect(0, 65380, '\P{^--Quotation_mark}', "");
    Error('\p{		is_Quotation_MARK:=}');
    Error('\P{		is_Quotation_MARK:=}');
    Expect(1, 65379, '\p{isquotationmark}', "");
    Expect(0, 65379, '\p{^isquotationmark}', "");
    Expect(0, 65379, '\P{isquotationmark}', "");
    Expect(1, 65379, '\P{^isquotationmark}', "");
    Expect(0, 65380, '\p{isquotationmark}', "");
    Expect(1, 65380, '\p{^isquotationmark}', "");
    Expect(1, 65380, '\P{isquotationmark}', "");
    Expect(0, 65380, '\P{^isquotationmark}', "");
    Expect(1, 65379, '\p{-	IS_Quotation_Mark}', "");
    Expect(0, 65379, '\p{^-	IS_Quotation_Mark}', "");
    Expect(0, 65379, '\P{-	IS_Quotation_Mark}', "");
    Expect(1, 65379, '\P{^-	IS_Quotation_Mark}', "");
    Expect(0, 65380, '\p{-	IS_Quotation_Mark}', "");
    Expect(1, 65380, '\p{^-	IS_Quotation_Mark}', "");
    Expect(1, 65380, '\P{-	IS_Quotation_Mark}', "");
    Expect(0, 65380, '\P{^-	IS_Quotation_Mark}', "");
    Error('\p{ :=QMark}');
    Error('\P{ :=QMark}');
    Expect(1, 65379, '\p{qmark}', "");
    Expect(0, 65379, '\p{^qmark}', "");
    Expect(0, 65379, '\P{qmark}', "");
    Expect(1, 65379, '\P{^qmark}', "");
    Expect(0, 65380, '\p{qmark}', "");
    Expect(1, 65380, '\p{^qmark}', "");
    Expect(1, 65380, '\P{qmark}', "");
    Expect(0, 65380, '\P{^qmark}', "");
    Expect(1, 65379, '\p{- QMark}', "");
    Expect(0, 65379, '\p{^- QMark}', "");
    Expect(0, 65379, '\P{- QMark}', "");
    Expect(1, 65379, '\P{^- QMark}', "");
    Expect(0, 65380, '\p{- QMark}', "");
    Expect(1, 65380, '\p{^- QMark}', "");
    Expect(1, 65380, '\P{- QMark}', "");
    Expect(0, 65380, '\P{^- QMark}', "");
    Error('\p{  is_QMark:=}');
    Error('\P{  is_QMark:=}');
    Expect(1, 65379, '\p{isqmark}', "");
    Expect(0, 65379, '\p{^isqmark}', "");
    Expect(0, 65379, '\P{isqmark}', "");
    Expect(1, 65379, '\P{^isqmark}', "");
    Expect(0, 65380, '\p{isqmark}', "");
    Expect(1, 65380, '\p{^isqmark}', "");
    Expect(1, 65380, '\P{isqmark}', "");
    Expect(0, 65380, '\P{^isqmark}', "");
    Expect(1, 65379, '\p{	-IS_QMARK}', "");
    Expect(0, 65379, '\p{^	-IS_QMARK}', "");
    Expect(0, 65379, '\P{	-IS_QMARK}', "");
    Expect(1, 65379, '\P{^	-IS_QMARK}', "");
    Expect(0, 65380, '\p{	-IS_QMARK}', "");
    Expect(1, 65380, '\p{^	-IS_QMARK}', "");
    Expect(1, 65380, '\P{	-IS_QMARK}', "");
    Expect(0, 65380, '\P{^	-IS_QMARK}', "");
    Error('\p{-_Radical/a/}');
    Error('\P{-_Radical/a/}');
    Expect(1, 12245, '\p{radical}', "");
    Expect(0, 12245, '\p{^radical}', "");
    Expect(0, 12245, '\P{radical}', "");
    Expect(1, 12245, '\P{^radical}', "");
    Expect(0, 12246, '\p{radical}', "");
    Expect(1, 12246, '\p{^radical}', "");
    Expect(1, 12246, '\P{radical}', "");
    Expect(0, 12246, '\P{^radical}', "");
    Expect(1, 12245, '\p{	-radical}', "");
    Expect(0, 12245, '\p{^	-radical}', "");
    Expect(0, 12245, '\P{	-radical}', "");
    Expect(1, 12245, '\P{^	-radical}', "");
    Expect(0, 12246, '\p{	-radical}', "");
    Expect(1, 12246, '\p{^	-radical}', "");
    Expect(1, 12246, '\P{	-radical}', "");
    Expect(0, 12246, '\P{^	-radical}', "");
    Error('\p{ -is_Radical/a/}');
    Error('\P{ -is_Radical/a/}');
    Expect(1, 12245, '\p{isradical}', "");
    Expect(0, 12245, '\p{^isradical}', "");
    Expect(0, 12245, '\P{isradical}', "");
    Expect(1, 12245, '\P{^isradical}', "");
    Expect(0, 12246, '\p{isradical}', "");
    Expect(1, 12246, '\p{^isradical}', "");
    Expect(1, 12246, '\P{isradical}', "");
    Expect(0, 12246, '\P{^isradical}', "");
    Expect(1, 12245, '\p{-is_radical}', "");
    Expect(0, 12245, '\p{^-is_radical}', "");
    Expect(0, 12245, '\P{-is_radical}', "");
    Expect(1, 12245, '\P{^-is_radical}', "");
    Expect(0, 12246, '\p{-is_radical}', "");
    Expect(1, 12246, '\p{^-is_radical}', "");
    Expect(1, 12246, '\P{-is_radical}', "");
    Expect(0, 12246, '\P{^-is_radical}', "");
    Error('\p{-regional_Indicator:=}');
    Error('\P{-regional_Indicator:=}');
    Expect(1, 127487, '\p{regionalindicator}', "");
    Expect(0, 127487, '\p{^regionalindicator}', "");
    Expect(0, 127487, '\P{regionalindicator}', "");
    Expect(1, 127487, '\P{^regionalindicator}', "");
    Expect(0, 127488, '\p{regionalindicator}', "");
    Expect(1, 127488, '\p{^regionalindicator}', "");
    Expect(1, 127488, '\P{regionalindicator}', "");
    Expect(0, 127488, '\P{^regionalindicator}', "");
    Expect(1, 127487, '\p{	-Regional_indicator}', "");
    Expect(0, 127487, '\p{^	-Regional_indicator}', "");
    Expect(0, 127487, '\P{	-Regional_indicator}', "");
    Expect(1, 127487, '\P{^	-Regional_indicator}', "");
    Expect(0, 127488, '\p{	-Regional_indicator}', "");
    Expect(1, 127488, '\p{^	-Regional_indicator}', "");
    Expect(1, 127488, '\P{	-Regional_indicator}', "");
    Expect(0, 127488, '\P{^	-Regional_indicator}', "");
    Error('\p{ /a/Is_regional_indicator}');
    Error('\P{ /a/Is_regional_indicator}');
    Expect(1, 127487, '\p{isregionalindicator}', "");
    Expect(0, 127487, '\p{^isregionalindicator}', "");
    Expect(0, 127487, '\P{isregionalindicator}', "");
    Expect(1, 127487, '\P{^isregionalindicator}', "");
    Expect(0, 127488, '\p{isregionalindicator}', "");
    Expect(1, 127488, '\p{^isregionalindicator}', "");
    Expect(1, 127488, '\P{isregionalindicator}', "");
    Expect(0, 127488, '\P{^isregionalindicator}', "");
    Expect(1, 127487, '\p{_-Is_REGIONAL_indicator}', "");
    Expect(0, 127487, '\p{^_-Is_REGIONAL_indicator}', "");
    Expect(0, 127487, '\P{_-Is_REGIONAL_indicator}', "");
    Expect(1, 127487, '\P{^_-Is_REGIONAL_indicator}', "");
    Expect(0, 127488, '\p{_-Is_REGIONAL_indicator}', "");
    Expect(1, 127488, '\p{^_-Is_REGIONAL_indicator}', "");
    Expect(1, 127488, '\P{_-Is_REGIONAL_indicator}', "");
    Expect(0, 127488, '\P{^_-Is_REGIONAL_indicator}', "");
    Error('\p{:=RI}');
    Error('\P{:=RI}');
    Expect(1, 127487, '\p{ri}', "");
    Expect(0, 127487, '\p{^ri}', "");
    Expect(0, 127487, '\P{ri}', "");
    Expect(1, 127487, '\P{^ri}', "");
    Expect(0, 127488, '\p{ri}', "");
    Expect(1, 127488, '\p{^ri}', "");
    Expect(1, 127488, '\P{ri}', "");
    Expect(0, 127488, '\P{^ri}', "");
    Expect(1, 127487, '\p{_ri}', "");
    Expect(0, 127487, '\p{^_ri}', "");
    Expect(0, 127487, '\P{_ri}', "");
    Expect(1, 127487, '\P{^_ri}', "");
    Expect(0, 127488, '\p{_ri}', "");
    Expect(1, 127488, '\p{^_ri}', "");
    Expect(1, 127488, '\P{_ri}', "");
    Expect(0, 127488, '\P{^_ri}', "");
    Error('\p{	/a/is_RI}');
    Error('\P{	/a/is_RI}');
    Expect(1, 127487, '\p{isri}', "");
    Expect(0, 127487, '\p{^isri}', "");
    Expect(0, 127487, '\P{isri}', "");
    Expect(1, 127487, '\P{^isri}', "");
    Expect(0, 127488, '\p{isri}', "");
    Expect(1, 127488, '\p{^isri}', "");
    Expect(1, 127488, '\P{isri}', "");
    Expect(0, 127488, '\P{^isri}', "");
    Expect(1, 127487, '\p{_Is_RI}', "");
    Expect(0, 127487, '\p{^_Is_RI}', "");
    Expect(0, 127487, '\P{_Is_RI}', "");
    Expect(1, 127487, '\P{^_Is_RI}', "");
    Expect(0, 127488, '\p{_Is_RI}', "");
    Expect(1, 127488, '\p{^_Is_RI}', "");
    Expect(1, 127488, '\P{_Is_RI}', "");
    Expect(0, 127488, '\P{^_Is_RI}', "");
    Error('\p{/a/REJANG}');
    Error('\P{/a/REJANG}');
    Expect(1, 43359, '\p{rejang}', "");
    Expect(0, 43359, '\p{^rejang}', "");
    Expect(0, 43359, '\P{rejang}', "");
    Expect(1, 43359, '\P{^rejang}', "");
    Expect(0, 43360, '\p{rejang}', "");
    Expect(1, 43360, '\p{^rejang}', "");
    Expect(1, 43360, '\P{rejang}', "");
    Expect(0, 43360, '\P{^rejang}', "");
    Expect(1, 43359, '\p{	-REJANG}', "");
    Expect(0, 43359, '\p{^	-REJANG}', "");
    Expect(0, 43359, '\P{	-REJANG}', "");
    Expect(1, 43359, '\P{^	-REJANG}', "");
    Expect(0, 43360, '\p{	-REJANG}', "");
    Expect(1, 43360, '\p{^	-REJANG}', "");
    Expect(1, 43360, '\P{	-REJANG}', "");
    Expect(0, 43360, '\P{^	-REJANG}', "");
    Error('\p{/a/  Is_Rejang}');
    Error('\P{/a/  Is_Rejang}');
    Expect(1, 43359, '\p{isrejang}', "");
    Expect(0, 43359, '\p{^isrejang}', "");
    Expect(0, 43359, '\P{isrejang}', "");
    Expect(1, 43359, '\P{^isrejang}', "");
    Expect(0, 43360, '\p{isrejang}', "");
    Expect(1, 43360, '\p{^isrejang}', "");
    Expect(1, 43360, '\P{isrejang}', "");
    Expect(0, 43360, '\P{^isrejang}', "");
    Expect(1, 43359, '\p{	IS_Rejang}', "");
    Expect(0, 43359, '\p{^	IS_Rejang}', "");
    Expect(0, 43359, '\P{	IS_Rejang}', "");
    Expect(1, 43359, '\P{^	IS_Rejang}', "");
    Expect(0, 43360, '\p{	IS_Rejang}', "");
    Expect(1, 43360, '\p{^	IS_Rejang}', "");
    Expect(1, 43360, '\P{	IS_Rejang}', "");
    Expect(0, 43360, '\P{^	IS_Rejang}', "");
}
if (!$::TESTCHUNK or $::TESTCHUNK == 4) {
    Error('\p{/a/rjng}');
    Error('\P{/a/rjng}');
    Expect(1, 43359, '\p{rjng}', "");
    Expect(0, 43359, '\p{^rjng}', "");
    Expect(0, 43359, '\P{rjng}', "");
    Expect(1, 43359, '\P{^rjng}', "");
    Expect(0, 43360, '\p{rjng}', "");
    Expect(1, 43360, '\p{^rjng}', "");
    Expect(1, 43360, '\P{rjng}', "");
    Expect(0, 43360, '\P{^rjng}', "");
    Expect(1, 43359, '\p{_ RJNG}', "");
    Expect(0, 43359, '\p{^_ RJNG}', "");
    Expect(0, 43359, '\P{_ RJNG}', "");
    Expect(1, 43359, '\P{^_ RJNG}', "");
    Expect(0, 43360, '\p{_ RJNG}', "");
    Expect(1, 43360, '\p{^_ RJNG}', "");
    Expect(1, 43360, '\P{_ RJNG}', "");
    Expect(0, 43360, '\P{^_ RJNG}', "");
    Error('\p{	_is_rjng/a/}');
    Error('\P{	_is_rjng/a/}');
    Expect(1, 43359, '\p{isrjng}', "");
    Expect(0, 43359, '\p{^isrjng}', "");
    Expect(0, 43359, '\P{isrjng}', "");
    Expect(1, 43359, '\P{^isrjng}', "");
    Expect(0, 43360, '\p{isrjng}', "");
    Expect(1, 43360, '\p{^isrjng}', "");
    Expect(1, 43360, '\P{isrjng}', "");
    Expect(0, 43360, '\P{^isrjng}', "");
    Expect(1, 43359, '\p{--IS_rjng}', "");
    Expect(0, 43359, '\p{^--IS_rjng}', "");
    Expect(0, 43359, '\P{--IS_rjng}', "");
    Expect(1, 43359, '\P{^--IS_rjng}', "");
    Expect(0, 43360, '\p{--IS_rjng}', "");
    Expect(1, 43360, '\p{^--IS_rjng}', "");
    Expect(1, 43360, '\P{--IS_rjng}', "");
    Expect(0, 43360, '\P{^--IS_rjng}', "");
    Error('\p{	rumi_numeral_Symbols/a/}');
    Error('\P{	rumi_numeral_Symbols/a/}');
    Expect(1, 69247, '\p{ruminumeralsymbols}', "");
    Expect(0, 69247, '\p{^ruminumeralsymbols}', "");
    Expect(0, 69247, '\P{ruminumeralsymbols}', "");
    Expect(1, 69247, '\P{^ruminumeralsymbols}', "");
    Expect(0, 69248, '\p{ruminumeralsymbols}', "");
    Expect(1, 69248, '\p{^ruminumeralsymbols}', "");
    Expect(1, 69248, '\P{ruminumeralsymbols}', "");
    Expect(0, 69248, '\P{^ruminumeralsymbols}', "");
    Expect(1, 69247, '\p{- RUMI_numeral_symbols}', "");
    Expect(0, 69247, '\p{^- RUMI_numeral_symbols}', "");
    Expect(0, 69247, '\P{- RUMI_numeral_symbols}', "");
    Expect(1, 69247, '\P{^- RUMI_numeral_symbols}', "");
    Expect(0, 69248, '\p{- RUMI_numeral_symbols}', "");
    Expect(1, 69248, '\p{^- RUMI_numeral_symbols}', "");
    Expect(1, 69248, '\P{- RUMI_numeral_symbols}', "");
    Expect(0, 69248, '\P{^- RUMI_numeral_symbols}', "");
    Error('\p{/a/_	IS_rumi_Numeral_symbols}');
    Error('\P{/a/_	IS_rumi_Numeral_symbols}');
    Expect(1, 69247, '\p{isruminumeralsymbols}', "");
    Expect(0, 69247, '\p{^isruminumeralsymbols}', "");
    Expect(0, 69247, '\P{isruminumeralsymbols}', "");
    Expect(1, 69247, '\P{^isruminumeralsymbols}', "");
    Expect(0, 69248, '\p{isruminumeralsymbols}', "");
    Expect(1, 69248, '\p{^isruminumeralsymbols}', "");
    Expect(1, 69248, '\P{isruminumeralsymbols}', "");
    Expect(0, 69248, '\P{^isruminumeralsymbols}', "");
    Expect(1, 69247, '\p{-IS_Rumi_Numeral_Symbols}', "");
    Expect(0, 69247, '\p{^-IS_Rumi_Numeral_Symbols}', "");
    Expect(0, 69247, '\P{-IS_Rumi_Numeral_Symbols}', "");
    Expect(1, 69247, '\P{^-IS_Rumi_Numeral_Symbols}', "");
    Expect(0, 69248, '\p{-IS_Rumi_Numeral_Symbols}', "");
    Expect(1, 69248, '\p{^-IS_Rumi_Numeral_Symbols}', "");
    Expect(1, 69248, '\P{-IS_Rumi_Numeral_Symbols}', "");
    Expect(0, 69248, '\P{^-IS_Rumi_Numeral_Symbols}', "");
    Error('\p{:=	IN_RUMI_numeral_Symbols}');
    Error('\P{:=	IN_RUMI_numeral_Symbols}');
    Expect(1, 69247, '\p{inruminumeralsymbols}', "");
    Expect(0, 69247, '\p{^inruminumeralsymbols}', "");
    Expect(0, 69247, '\P{inruminumeralsymbols}', "");
    Expect(1, 69247, '\P{^inruminumeralsymbols}', "");
    Expect(0, 69248, '\p{inruminumeralsymbols}', "");
    Expect(1, 69248, '\p{^inruminumeralsymbols}', "");
    Expect(1, 69248, '\P{inruminumeralsymbols}', "");
    Expect(0, 69248, '\P{^inruminumeralsymbols}', "");
    Expect(1, 69247, '\p{--In_Rumi_numeral_Symbols}', "");
    Expect(0, 69247, '\p{^--In_Rumi_numeral_Symbols}', "");
    Expect(0, 69247, '\P{--In_Rumi_numeral_Symbols}', "");
    Expect(1, 69247, '\P{^--In_Rumi_numeral_Symbols}', "");
    Expect(0, 69248, '\p{--In_Rumi_numeral_Symbols}', "");
    Expect(1, 69248, '\p{^--In_Rumi_numeral_Symbols}', "");
    Expect(1, 69248, '\P{--In_Rumi_numeral_Symbols}', "");
    Expect(0, 69248, '\P{^--In_Rumi_numeral_Symbols}', "");
    Error('\p{/a/	rumi}');
    Error('\P{/a/	rumi}');
    Expect(1, 69247, '\p{rumi}', "");
    Expect(0, 69247, '\p{^rumi}', "");
    Expect(0, 69247, '\P{rumi}', "");
    Expect(1, 69247, '\P{^rumi}', "");
    Expect(0, 69248, '\p{rumi}', "");
    Expect(1, 69248, '\p{^rumi}', "");
    Expect(1, 69248, '\P{rumi}', "");
    Expect(0, 69248, '\P{^rumi}', "");
    Expect(1, 69247, '\p{  RUMI}', "");
    Expect(0, 69247, '\p{^  RUMI}', "");
    Expect(0, 69247, '\P{  RUMI}', "");
    Expect(1, 69247, '\P{^  RUMI}', "");
    Expect(0, 69248, '\p{  RUMI}', "");
    Expect(1, 69248, '\p{^  RUMI}', "");
    Expect(1, 69248, '\P{  RUMI}', "");
    Expect(0, 69248, '\P{^  RUMI}', "");
    Error('\p{-:=Is_RUMI}');
    Error('\P{-:=Is_RUMI}');
    Expect(1, 69247, '\p{isrumi}', "");
    Expect(0, 69247, '\p{^isrumi}', "");
    Expect(0, 69247, '\P{isrumi}', "");
    Expect(1, 69247, '\P{^isrumi}', "");
    Expect(0, 69248, '\p{isrumi}', "");
    Expect(1, 69248, '\p{^isrumi}', "");
    Expect(1, 69248, '\P{isrumi}', "");
    Expect(0, 69248, '\P{^isrumi}', "");
    Expect(1, 69247, '\p{ -Is_rumi}', "");
    Expect(0, 69247, '\p{^ -Is_rumi}', "");
    Expect(0, 69247, '\P{ -Is_rumi}', "");
    Expect(1, 69247, '\P{^ -Is_rumi}', "");
    Expect(0, 69248, '\p{ -Is_rumi}', "");
    Expect(1, 69248, '\p{^ -Is_rumi}', "");
    Expect(1, 69248, '\P{ -Is_rumi}', "");
    Expect(0, 69248, '\P{^ -Is_rumi}', "");
    Error('\p{_:=In_Rumi}');
    Error('\P{_:=In_Rumi}');
    Expect(1, 69247, '\p{inrumi}', "");
    Expect(0, 69247, '\p{^inrumi}', "");
    Expect(0, 69247, '\P{inrumi}', "");
    Expect(1, 69247, '\P{^inrumi}', "");
    Expect(0, 69248, '\p{inrumi}', "");
    Expect(1, 69248, '\p{^inrumi}', "");
    Expect(1, 69248, '\P{inrumi}', "");
    Expect(0, 69248, '\P{^inrumi}', "");
    Expect(1, 69247, '\p{_-in_rumi}', "");
    Expect(0, 69247, '\p{^_-in_rumi}', "");
    Expect(0, 69247, '\P{_-in_rumi}', "");
    Expect(1, 69247, '\P{^_-in_rumi}', "");
    Expect(0, 69248, '\p{_-in_rumi}', "");
    Expect(1, 69248, '\p{^_-in_rumi}', "");
    Expect(1, 69248, '\P{_-in_rumi}', "");
    Expect(0, 69248, '\P{^_-in_rumi}', "");
    Error('\p{/a/	runic}');
    Error('\P{/a/	runic}');
    Expect(1, 5880, '\p{runic}', "");
    Expect(0, 5880, '\p{^runic}', "");
    Expect(0, 5880, '\P{runic}', "");
    Expect(1, 5880, '\P{^runic}', "");
    Expect(0, 5881, '\p{runic}', "");
    Expect(1, 5881, '\p{^runic}', "");
    Expect(1, 5881, '\P{runic}', "");
    Expect(0, 5881, '\P{^runic}', "");
    Expect(1, 5880, '\p{_	Runic}', "");
    Expect(0, 5880, '\p{^_	Runic}', "");
    Expect(0, 5880, '\P{_	Runic}', "");
    Expect(1, 5880, '\P{^_	Runic}', "");
    Expect(0, 5881, '\p{_	Runic}', "");
    Expect(1, 5881, '\p{^_	Runic}', "");
    Expect(1, 5881, '\P{_	Runic}', "");
    Expect(0, 5881, '\P{^_	Runic}', "");
    Error('\p{ /a/Is_Runic}');
    Error('\P{ /a/Is_Runic}');
    Expect(1, 5880, '\p{isrunic}', "");
    Expect(0, 5880, '\p{^isrunic}', "");
    Expect(0, 5880, '\P{isrunic}', "");
    Expect(1, 5880, '\P{^isrunic}', "");
    Expect(0, 5881, '\p{isrunic}', "");
    Expect(1, 5881, '\p{^isrunic}', "");
    Expect(1, 5881, '\P{isrunic}', "");
    Expect(0, 5881, '\P{^isrunic}', "");
    Expect(1, 5880, '\p{	IS_runic}', "");
    Expect(0, 5880, '\p{^	IS_runic}', "");
    Expect(0, 5880, '\P{	IS_runic}', "");
    Expect(1, 5880, '\P{^	IS_runic}', "");
    Expect(0, 5881, '\p{	IS_runic}', "");
    Expect(1, 5881, '\p{^	IS_runic}', "");
    Expect(1, 5881, '\P{	IS_runic}', "");
    Expect(0, 5881, '\P{^	IS_runic}', "");
    Error('\p{	Runr/a/}');
    Error('\P{	Runr/a/}');
    Expect(1, 5880, '\p{runr}', "");
    Expect(0, 5880, '\p{^runr}', "");
    Expect(0, 5880, '\P{runr}', "");
    Expect(1, 5880, '\P{^runr}', "");
    Expect(0, 5881, '\p{runr}', "");
    Expect(1, 5881, '\p{^runr}', "");
    Expect(1, 5881, '\P{runr}', "");
    Expect(0, 5881, '\P{^runr}', "");
    Expect(1, 5880, '\p{ _Runr}', "");
    Expect(0, 5880, '\p{^ _Runr}', "");
    Expect(0, 5880, '\P{ _Runr}', "");
    Expect(1, 5880, '\P{^ _Runr}', "");
    Expect(0, 5881, '\p{ _Runr}', "");
    Expect(1, 5881, '\p{^ _Runr}', "");
    Expect(1, 5881, '\P{ _Runr}', "");
    Expect(0, 5881, '\P{^ _Runr}', "");
    Error('\p{	Is_Runr/a/}');
    Error('\P{	Is_Runr/a/}');
    Expect(1, 5880, '\p{isrunr}', "");
    Expect(0, 5880, '\p{^isrunr}', "");
    Expect(0, 5880, '\P{isrunr}', "");
    Expect(1, 5880, '\P{^isrunr}', "");
    Expect(0, 5881, '\p{isrunr}', "");
    Expect(1, 5881, '\p{^isrunr}', "");
    Expect(1, 5881, '\P{isrunr}', "");
    Expect(0, 5881, '\P{^isrunr}', "");
    Expect(1, 5880, '\p{	 Is_runr}', "");
    Expect(0, 5880, '\p{^	 Is_runr}', "");
    Expect(0, 5880, '\P{	 Is_runr}', "");
    Expect(1, 5880, '\P{^	 Is_runr}', "");
    Expect(0, 5881, '\p{	 Is_runr}', "");
    Expect(1, 5881, '\p{^	 Is_runr}', "");
    Expect(1, 5881, '\P{	 Is_runr}', "");
    Expect(0, 5881, '\P{^	 Is_runr}', "");
    Error('\p{ _Samaritan/a/}');
    Error('\P{ _Samaritan/a/}');
    Expect(1, 2110, '\p{samaritan}', "");
    Expect(0, 2110, '\p{^samaritan}', "");
    Expect(0, 2110, '\P{samaritan}', "");
    Expect(1, 2110, '\P{^samaritan}', "");
    Expect(0, 2111, '\p{samaritan}', "");
    Expect(1, 2111, '\p{^samaritan}', "");
    Expect(1, 2111, '\P{samaritan}', "");
    Expect(0, 2111, '\P{^samaritan}', "");
    Expect(1, 2110, '\p{-	Samaritan}', "");
    Expect(0, 2110, '\p{^-	Samaritan}', "");
    Expect(0, 2110, '\P{-	Samaritan}', "");
    Expect(1, 2110, '\P{^-	Samaritan}', "");
    Expect(0, 2111, '\p{-	Samaritan}', "");
    Expect(1, 2111, '\p{^-	Samaritan}', "");
    Expect(1, 2111, '\P{-	Samaritan}', "");
    Expect(0, 2111, '\P{^-	Samaritan}', "");
    Error('\p{:=  is_Samaritan}');
    Error('\P{:=  is_Samaritan}');
    Expect(1, 2110, '\p{issamaritan}', "");
    Expect(0, 2110, '\p{^issamaritan}', "");
    Expect(0, 2110, '\P{issamaritan}', "");
    Expect(1, 2110, '\P{^issamaritan}', "");
    Expect(0, 2111, '\p{issamaritan}', "");
    Expect(1, 2111, '\p{^issamaritan}', "");
    Expect(1, 2111, '\P{issamaritan}', "");
    Expect(0, 2111, '\P{^issamaritan}', "");
    Expect(1, 2110, '\p{	is_samaritan}', "");
    Expect(0, 2110, '\p{^	is_samaritan}', "");
    Expect(0, 2110, '\P{	is_samaritan}', "");
    Expect(1, 2110, '\P{^	is_samaritan}', "");
    Expect(0, 2111, '\p{	is_samaritan}', "");
    Expect(1, 2111, '\p{^	is_samaritan}', "");
    Expect(1, 2111, '\P{	is_samaritan}', "");
    Expect(0, 2111, '\P{^	is_samaritan}', "");
    Error('\p{_Samr/a/}');
    Error('\P{_Samr/a/}');
    Expect(1, 2110, '\p{samr}', "");
    Expect(0, 2110, '\p{^samr}', "");
    Expect(0, 2110, '\P{samr}', "");
    Expect(1, 2110, '\P{^samr}', "");
    Expect(0, 2111, '\p{samr}', "");
    Expect(1, 2111, '\p{^samr}', "");
    Expect(1, 2111, '\P{samr}', "");
    Expect(0, 2111, '\P{^samr}', "");
    Expect(1, 2110, '\p{	 Samr}', "");
    Expect(0, 2110, '\p{^	 Samr}', "");
    Expect(0, 2110, '\P{	 Samr}', "");
    Expect(1, 2110, '\P{^	 Samr}', "");
    Expect(0, 2111, '\p{	 Samr}', "");
    Expect(1, 2111, '\p{^	 Samr}', "");
    Expect(1, 2111, '\P{	 Samr}', "");
    Expect(0, 2111, '\P{^	 Samr}', "");
    Error('\p{_	Is_SAMR/a/}');
    Error('\P{_	Is_SAMR/a/}');
    Expect(1, 2110, '\p{issamr}', "");
    Expect(0, 2110, '\p{^issamr}', "");
    Expect(0, 2110, '\P{issamr}', "");
    Expect(1, 2110, '\P{^issamr}', "");
    Expect(0, 2111, '\p{issamr}', "");
    Expect(1, 2111, '\p{^issamr}', "");
    Expect(1, 2111, '\P{issamr}', "");
    Expect(0, 2111, '\P{^issamr}', "");
    Expect(1, 2110, '\p{__is_samr}', "");
    Expect(0, 2110, '\p{^__is_samr}', "");
    Expect(0, 2110, '\P{__is_samr}', "");
    Expect(1, 2110, '\P{^__is_samr}', "");
    Expect(0, 2111, '\p{__is_samr}', "");
    Expect(1, 2111, '\p{^__is_samr}', "");
    Expect(1, 2111, '\P{__is_samr}', "");
    Expect(0, 2111, '\P{^__is_samr}', "");
    Error('\p{--SAURASHTRA:=}');
    Error('\P{--SAURASHTRA:=}');
    Expect(1, 43225, '\p{saurashtra}', "");
    Expect(0, 43225, '\p{^saurashtra}', "");
    Expect(0, 43225, '\P{saurashtra}', "");
    Expect(1, 43225, '\P{^saurashtra}', "");
    Expect(0, 43226, '\p{saurashtra}', "");
    Expect(1, 43226, '\p{^saurashtra}', "");
    Expect(1, 43226, '\P{saurashtra}', "");
    Expect(0, 43226, '\P{^saurashtra}', "");
    Expect(1, 43225, '\p{	-saurashtra}', "");
    Expect(0, 43225, '\p{^	-saurashtra}', "");
    Expect(0, 43225, '\P{	-saurashtra}', "");
    Expect(1, 43225, '\P{^	-saurashtra}', "");
    Expect(0, 43226, '\p{	-saurashtra}', "");
    Expect(1, 43226, '\p{^	-saurashtra}', "");
    Expect(1, 43226, '\P{	-saurashtra}', "");
    Expect(0, 43226, '\P{^	-saurashtra}', "");
    Error('\p{-/a/Is_Saurashtra}');
    Error('\P{-/a/Is_Saurashtra}');
    Expect(1, 43225, '\p{issaurashtra}', "");
    Expect(0, 43225, '\p{^issaurashtra}', "");
    Expect(0, 43225, '\P{issaurashtra}', "");
    Expect(1, 43225, '\P{^issaurashtra}', "");
    Expect(0, 43226, '\p{issaurashtra}', "");
    Expect(1, 43226, '\p{^issaurashtra}', "");
    Expect(1, 43226, '\P{issaurashtra}', "");
    Expect(0, 43226, '\P{^issaurashtra}', "");
    Expect(1, 43225, '\p{_ Is_SAURASHTRA}', "");
    Expect(0, 43225, '\p{^_ Is_SAURASHTRA}', "");
    Expect(0, 43225, '\P{_ Is_SAURASHTRA}', "");
    Expect(1, 43225, '\P{^_ Is_SAURASHTRA}', "");
    Expect(0, 43226, '\p{_ Is_SAURASHTRA}', "");
    Expect(1, 43226, '\p{^_ Is_SAURASHTRA}', "");
    Expect(1, 43226, '\P{_ Is_SAURASHTRA}', "");
    Expect(0, 43226, '\P{^_ Is_SAURASHTRA}', "");
    Error('\p{/a/ -Saur}');
    Error('\P{/a/ -Saur}');
    Expect(1, 43225, '\p{saur}', "");
    Expect(0, 43225, '\p{^saur}', "");
    Expect(0, 43225, '\P{saur}', "");
    Expect(1, 43225, '\P{^saur}', "");
    Expect(0, 43226, '\p{saur}', "");
    Expect(1, 43226, '\p{^saur}', "");
    Expect(1, 43226, '\P{saur}', "");
    Expect(0, 43226, '\P{^saur}', "");
    Expect(1, 43225, '\p{_Saur}', "");
    Expect(0, 43225, '\p{^_Saur}', "");
    Expect(0, 43225, '\P{_Saur}', "");
    Expect(1, 43225, '\P{^_Saur}', "");
    Expect(0, 43226, '\p{_Saur}', "");
    Expect(1, 43226, '\p{^_Saur}', "");
    Expect(1, 43226, '\P{_Saur}', "");
    Expect(0, 43226, '\P{^_Saur}', "");
    Error('\p{-is_Saur/a/}');
    Error('\P{-is_Saur/a/}');
    Expect(1, 43225, '\p{issaur}', "");
    Expect(0, 43225, '\p{^issaur}', "");
    Expect(0, 43225, '\P{issaur}', "");
    Expect(1, 43225, '\P{^issaur}', "");
    Expect(0, 43226, '\p{issaur}', "");
    Expect(1, 43226, '\p{^issaur}', "");
    Expect(1, 43226, '\P{issaur}', "");
    Expect(0, 43226, '\P{^issaur}', "");
    Expect(1, 43225, '\p{  IS_SAUR}', "");
    Expect(0, 43225, '\p{^  IS_SAUR}', "");
    Expect(0, 43225, '\P{  IS_SAUR}', "");
    Expect(1, 43225, '\P{^  IS_SAUR}', "");
    Expect(0, 43226, '\p{  IS_SAUR}', "");
    Expect(1, 43226, '\p{^  IS_SAUR}', "");
    Expect(1, 43226, '\P{  IS_SAUR}', "");
    Expect(0, 43226, '\P{^  IS_SAUR}', "");
    Error('\p{		Sentence_terminal/a/}');
    Error('\P{		Sentence_terminal/a/}');
    Expect(1, 121480, '\p{sentenceterminal}', "");
    Expect(0, 121480, '\p{^sentenceterminal}', "");
    Expect(0, 121480, '\P{sentenceterminal}', "");
    Expect(1, 121480, '\P{^sentenceterminal}', "");
    Expect(0, 121481, '\p{sentenceterminal}', "");
    Expect(1, 121481, '\p{^sentenceterminal}', "");
    Expect(1, 121481, '\P{sentenceterminal}', "");
    Expect(0, 121481, '\P{^sentenceterminal}', "");
    Expect(1, 121480, '\p{	sentence_Terminal}', "");
    Expect(0, 121480, '\p{^	sentence_Terminal}', "");
    Expect(0, 121480, '\P{	sentence_Terminal}', "");
    Expect(1, 121480, '\P{^	sentence_Terminal}', "");
    Expect(0, 121481, '\p{	sentence_Terminal}', "");
    Expect(1, 121481, '\p{^	sentence_Terminal}', "");
    Expect(1, 121481, '\P{	sentence_Terminal}', "");
    Expect(0, 121481, '\P{^	sentence_Terminal}', "");
    Error('\p{is_Sentence_Terminal/a/}');
    Error('\P{is_Sentence_Terminal/a/}');
    Expect(1, 121480, '\p{issentenceterminal}', "");
    Expect(0, 121480, '\p{^issentenceterminal}', "");
    Expect(0, 121480, '\P{issentenceterminal}', "");
    Expect(1, 121480, '\P{^issentenceterminal}', "");
    Expect(0, 121481, '\p{issentenceterminal}', "");
    Expect(1, 121481, '\p{^issentenceterminal}', "");
    Expect(1, 121481, '\P{issentenceterminal}', "");
    Expect(0, 121481, '\P{^issentenceterminal}', "");
    Expect(1, 121480, '\p{		Is_SENTENCE_terminal}', "");
    Expect(0, 121480, '\p{^		Is_SENTENCE_terminal}', "");
    Expect(0, 121480, '\P{		Is_SENTENCE_terminal}', "");
    Expect(1, 121480, '\P{^		Is_SENTENCE_terminal}', "");
    Expect(0, 121481, '\p{		Is_SENTENCE_terminal}', "");
    Expect(1, 121481, '\p{^		Is_SENTENCE_terminal}', "");
    Expect(1, 121481, '\P{		Is_SENTENCE_terminal}', "");
    Expect(0, 121481, '\P{^		Is_SENTENCE_terminal}', "");
    Error('\p{--STerm:=}');
    Error('\P{--STerm:=}');
    Expect(1, 121480, '\p{sterm}', "");
    Expect(0, 121480, '\p{^sterm}', "");
    Expect(0, 121480, '\P{sterm}', "");
    Expect(1, 121480, '\P{^sterm}', "");
    Expect(0, 121481, '\p{sterm}', "");
    Expect(1, 121481, '\p{^sterm}', "");
    Expect(1, 121481, '\P{sterm}', "");
    Expect(0, 121481, '\P{^sterm}', "");
    Expect(1, 121480, '\p{	 STERM}', "");
    Expect(0, 121480, '\p{^	 STERM}', "");
    Expect(0, 121480, '\P{	 STERM}', "");
    Expect(1, 121480, '\P{^	 STERM}', "");
    Expect(0, 121481, '\p{	 STERM}', "");
    Expect(1, 121481, '\p{^	 STERM}', "");
    Expect(1, 121481, '\P{	 STERM}', "");
    Expect(0, 121481, '\P{^	 STERM}', "");
    Error('\p{_Is_sterm/a/}');
    Error('\P{_Is_sterm/a/}');
    Expect(1, 121480, '\p{issterm}', "");
    Expect(0, 121480, '\p{^issterm}', "");
    Expect(0, 121480, '\P{issterm}', "");
    Expect(1, 121480, '\P{^issterm}', "");
    Expect(0, 121481, '\p{issterm}', "");
    Expect(1, 121481, '\p{^issterm}', "");
    Expect(1, 121481, '\P{issterm}', "");
    Expect(0, 121481, '\P{^issterm}', "");
    Expect(1, 121480, '\p{ 	IS_STerm}', "");
    Expect(0, 121480, '\p{^ 	IS_STerm}', "");
    Expect(0, 121480, '\P{ 	IS_STerm}', "");
    Expect(1, 121480, '\P{^ 	IS_STerm}', "");
    Expect(0, 121481, '\p{ 	IS_STerm}', "");
    Expect(1, 121481, '\p{^ 	IS_STerm}', "");
    Expect(1, 121481, '\P{ 	IS_STerm}', "");
    Expect(0, 121481, '\P{^ 	IS_STerm}', "");
    Error('\p{ -Separator:=}');
    Error('\P{ -Separator:=}');
    Expect(1, 12288, '\p{separator}', "");
    Expect(0, 12288, '\p{^separator}', "");
    Expect(0, 12288, '\P{separator}', "");
    Expect(1, 12288, '\P{^separator}', "");
    Expect(0, 12289, '\p{separator}', "");
    Expect(1, 12289, '\p{^separator}', "");
    Expect(1, 12289, '\P{separator}', "");
    Expect(0, 12289, '\P{^separator}', "");
    Error('\p{/a/-is_separator}');
    Error('\P{/a/-is_separator}');
    Expect(1, 12288, '\p{isseparator}', "");
    Expect(0, 12288, '\p{^isseparator}', "");
    Expect(0, 12288, '\P{isseparator}', "");
    Expect(1, 12288, '\P{^isseparator}', "");
    Expect(0, 12289, '\p{isseparator}', "");
    Expect(1, 12289, '\p{^isseparator}', "");
    Expect(1, 12289, '\P{isseparator}', "");
    Expect(0, 12289, '\P{^isseparator}', "");
    Expect(1, 12288, '\p{	_Is_SEPARATOR}', "");
    Expect(0, 12288, '\p{^	_Is_SEPARATOR}', "");
    Expect(0, 12288, '\P{	_Is_SEPARATOR}', "");
    Expect(1, 12288, '\P{^	_Is_SEPARATOR}', "");
    Expect(0, 12289, '\p{	_Is_SEPARATOR}', "");
    Expect(1, 12289, '\p{^	_Is_SEPARATOR}', "");
    Expect(1, 12289, '\P{	_Is_SEPARATOR}', "");
    Expect(0, 12289, '\P{^	_Is_SEPARATOR}', "");
    Error('\p{:=z}');
    Error('\P{:=z}');
    Expect(1, 12288, '\p{z}', "");
    Expect(0, 12288, '\p{^z}', "");
    Expect(0, 12288, '\P{z}', "");
    Expect(1, 12288, '\P{^z}', "");
    Expect(0, 12289, '\p{z}', "");
    Expect(1, 12289, '\p{^z}', "");
    Expect(1, 12289, '\P{z}', "");
    Expect(0, 12289, '\P{^z}', "");
    Expect(1, 12288, '\p{_-Z}', "");
    Expect(0, 12288, '\p{^_-Z}', "");
    Expect(0, 12288, '\P{_-Z}', "");
    Expect(1, 12288, '\P{^_-Z}', "");
    Expect(0, 12289, '\p{_-Z}', "");
    Expect(1, 12289, '\p{^_-Z}', "");
    Expect(1, 12289, '\P{_-Z}', "");
    Expect(0, 12289, '\P{^_-Z}', "");
    Error('\p{:=	 is_Z}');
    Error('\P{:=	 is_Z}');
    Expect(1, 12288, '\p{isz}', "");
    Expect(0, 12288, '\p{^isz}', "");
    Expect(0, 12288, '\P{isz}', "");
    Expect(1, 12288, '\P{^isz}', "");
    Expect(0, 12289, '\p{isz}', "");
    Expect(1, 12289, '\p{^isz}', "");
    Expect(1, 12289, '\P{isz}', "");
    Expect(0, 12289, '\P{^isz}', "");
    Expect(1, 12288, '\p{-_Is_z}', "");
    Expect(0, 12288, '\p{^-_Is_z}', "");
    Expect(0, 12288, '\P{-_Is_z}', "");
    Expect(1, 12288, '\P{^-_Is_z}', "");
    Expect(0, 12289, '\p{-_Is_z}', "");
    Expect(1, 12289, '\p{^-_Is_z}', "");
    Expect(1, 12289, '\P{-_Is_z}', "");
    Expect(0, 12289, '\P{^-_Is_z}', "");
    Error('\p{ Sharada:=}');
    Error('\P{ Sharada:=}');
    Expect(1, 70111, '\p{sharada}', "");
    Expect(0, 70111, '\p{^sharada}', "");
    Expect(0, 70111, '\P{sharada}', "");
    Expect(1, 70111, '\P{^sharada}', "");
    Expect(0, 70112, '\p{sharada}', "");
    Expect(1, 70112, '\p{^sharada}', "");
    Expect(1, 70112, '\P{sharada}', "");
    Expect(0, 70112, '\P{^sharada}', "");
    Expect(1, 70111, '\p{	 Sharada}', "");
    Expect(0, 70111, '\p{^	 Sharada}', "");
    Expect(0, 70111, '\P{	 Sharada}', "");
    Expect(1, 70111, '\P{^	 Sharada}', "");
    Expect(0, 70112, '\p{	 Sharada}', "");
    Expect(1, 70112, '\p{^	 Sharada}', "");
    Expect(1, 70112, '\P{	 Sharada}', "");
    Expect(0, 70112, '\P{^	 Sharada}', "");
    Error('\p{ IS_sharada:=}');
    Error('\P{ IS_sharada:=}');
    Expect(1, 70111, '\p{issharada}', "");
    Expect(0, 70111, '\p{^issharada}', "");
    Expect(0, 70111, '\P{issharada}', "");
    Expect(1, 70111, '\P{^issharada}', "");
    Expect(0, 70112, '\p{issharada}', "");
    Expect(1, 70112, '\p{^issharada}', "");
    Expect(1, 70112, '\P{issharada}', "");
    Expect(0, 70112, '\P{^issharada}', "");
    Expect(1, 70111, '\p{	_Is_sharada}', "");
    Expect(0, 70111, '\p{^	_Is_sharada}', "");
    Expect(0, 70111, '\P{	_Is_sharada}', "");
    Expect(1, 70111, '\P{^	_Is_sharada}', "");
    Expect(0, 70112, '\p{	_Is_sharada}', "");
    Expect(1, 70112, '\p{^	_Is_sharada}', "");
    Expect(1, 70112, '\P{	_Is_sharada}', "");
    Expect(0, 70112, '\P{^	_Is_sharada}', "");
    Error('\p{:=	_shrd}');
    Error('\P{:=	_shrd}');
    Expect(1, 70111, '\p{shrd}', "");
    Expect(0, 70111, '\p{^shrd}', "");
    Expect(0, 70111, '\P{shrd}', "");
    Expect(1, 70111, '\P{^shrd}', "");
    Expect(0, 70112, '\p{shrd}', "");
    Expect(1, 70112, '\p{^shrd}', "");
    Expect(1, 70112, '\P{shrd}', "");
    Expect(0, 70112, '\P{^shrd}', "");
    Expect(1, 70111, '\p{__Shrd}', "");
    Expect(0, 70111, '\p{^__Shrd}', "");
    Expect(0, 70111, '\P{__Shrd}', "");
    Expect(1, 70111, '\P{^__Shrd}', "");
    Expect(0, 70112, '\p{__Shrd}', "");
    Expect(1, 70112, '\p{^__Shrd}', "");
    Expect(1, 70112, '\P{__Shrd}', "");
    Expect(0, 70112, '\P{^__Shrd}', "");
    Error('\p{/a/-_Is_Shrd}');
    Error('\P{/a/-_Is_Shrd}');
    Expect(1, 70111, '\p{isshrd}', "");
    Expect(0, 70111, '\p{^isshrd}', "");
    Expect(0, 70111, '\P{isshrd}', "");
    Expect(1, 70111, '\P{^isshrd}', "");
    Expect(0, 70112, '\p{isshrd}', "");
    Expect(1, 70112, '\p{^isshrd}', "");
    Expect(1, 70112, '\P{isshrd}', "");
    Expect(0, 70112, '\P{^isshrd}', "");
    Expect(1, 70111, '\p{Is_SHRD}', "");
    Expect(0, 70111, '\p{^Is_SHRD}', "");
    Expect(0, 70111, '\P{Is_SHRD}', "");
    Expect(1, 70111, '\P{^Is_SHRD}', "");
    Expect(0, 70112, '\p{Is_SHRD}', "");
    Expect(1, 70112, '\p{^Is_SHRD}', "");
    Expect(1, 70112, '\P{Is_SHRD}', "");
    Expect(0, 70112, '\P{^Is_SHRD}', "");
    Error('\p{_	Shavian:=}');
    Error('\P{_	Shavian:=}');
    Expect(1, 66687, '\p{shavian}', "");
    Expect(0, 66687, '\p{^shavian}', "");
    Expect(0, 66687, '\P{shavian}', "");
    Expect(1, 66687, '\P{^shavian}', "");
    Expect(0, 66688, '\p{shavian}', "");
    Expect(1, 66688, '\p{^shavian}', "");
    Expect(1, 66688, '\P{shavian}', "");
    Expect(0, 66688, '\P{^shavian}', "");
    Expect(1, 66687, '\p{ _Shavian}', "");
    Expect(0, 66687, '\p{^ _Shavian}', "");
    Expect(0, 66687, '\P{ _Shavian}', "");
    Expect(1, 66687, '\P{^ _Shavian}', "");
    Expect(0, 66688, '\p{ _Shavian}', "");
    Expect(1, 66688, '\p{^ _Shavian}', "");
    Expect(1, 66688, '\P{ _Shavian}', "");
    Expect(0, 66688, '\P{^ _Shavian}', "");
    Error('\p{_:=is_Shavian}');
    Error('\P{_:=is_Shavian}');
    Expect(1, 66687, '\p{isshavian}', "");
    Expect(0, 66687, '\p{^isshavian}', "");
    Expect(0, 66687, '\P{isshavian}', "");
    Expect(1, 66687, '\P{^isshavian}', "");
    Expect(0, 66688, '\p{isshavian}', "");
    Expect(1, 66688, '\p{^isshavian}', "");
    Expect(1, 66688, '\P{isshavian}', "");
    Expect(0, 66688, '\P{^isshavian}', "");
    Expect(1, 66687, '\p{-Is_Shavian}', "");
    Expect(0, 66687, '\p{^-Is_Shavian}', "");
    Expect(0, 66687, '\P{-Is_Shavian}', "");
    Expect(1, 66687, '\P{^-Is_Shavian}', "");
    Expect(0, 66688, '\p{-Is_Shavian}', "");
    Expect(1, 66688, '\p{^-Is_Shavian}', "");
    Expect(1, 66688, '\P{-Is_Shavian}', "");
    Expect(0, 66688, '\P{^-Is_Shavian}', "");
    Error('\p{/a/SHAW}');
    Error('\P{/a/SHAW}');
    Expect(1, 66687, '\p{shaw}', "");
    Expect(0, 66687, '\p{^shaw}', "");
    Expect(0, 66687, '\P{shaw}', "");
    Expect(1, 66687, '\P{^shaw}', "");
    Expect(0, 66688, '\p{shaw}', "");
    Expect(1, 66688, '\p{^shaw}', "");
    Expect(1, 66688, '\P{shaw}', "");
    Expect(0, 66688, '\P{^shaw}', "");
    Expect(1, 66687, '\p{	shaw}', "");
    Expect(0, 66687, '\p{^	shaw}', "");
    Expect(0, 66687, '\P{	shaw}', "");
    Expect(1, 66687, '\P{^	shaw}', "");
    Expect(0, 66688, '\p{	shaw}', "");
    Expect(1, 66688, '\p{^	shaw}', "");
    Expect(1, 66688, '\P{	shaw}', "");
    Expect(0, 66688, '\P{^	shaw}', "");
    Error('\p{_:=Is_SHAW}');
    Error('\P{_:=Is_SHAW}');
    Expect(1, 66687, '\p{isshaw}', "");
    Expect(0, 66687, '\p{^isshaw}', "");
    Expect(0, 66687, '\P{isshaw}', "");
    Expect(1, 66687, '\P{^isshaw}', "");
    Expect(0, 66688, '\p{isshaw}', "");
    Expect(1, 66688, '\p{^isshaw}', "");
    Expect(1, 66688, '\P{isshaw}', "");
    Expect(0, 66688, '\P{^isshaw}', "");
    Expect(1, 66687, '\p{ Is_SHAW}', "");
    Expect(0, 66687, '\p{^ Is_SHAW}', "");
    Expect(0, 66687, '\P{ Is_SHAW}', "");
    Expect(1, 66687, '\P{^ Is_SHAW}', "");
    Expect(0, 66688, '\p{ Is_SHAW}', "");
    Expect(1, 66688, '\p{^ Is_SHAW}', "");
    Expect(1, 66688, '\P{ Is_SHAW}', "");
    Expect(0, 66688, '\P{^ Is_SHAW}', "");
    Error('\p{ /a/shorthand_Format_controls}');
    Error('\P{ /a/shorthand_Format_controls}');
    Expect(1, 113839, '\p{shorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^shorthandformatcontrols}', "");
    Expect(0, 113839, '\P{shorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^shorthandformatcontrols}', "");
    Expect(0, 113840, '\p{shorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^shorthandformatcontrols}', "");
    Expect(1, 113840, '\P{shorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^shorthandformatcontrols}', "");
    Expect(1, 113839, '\p{	 SHORTHAND_Format_controls}', "");
    Expect(0, 113839, '\p{^	 SHORTHAND_Format_controls}', "");
    Expect(0, 113839, '\P{	 SHORTHAND_Format_controls}', "");
    Expect(1, 113839, '\P{^	 SHORTHAND_Format_controls}', "");
    Expect(0, 113840, '\p{	 SHORTHAND_Format_controls}', "");
    Expect(1, 113840, '\p{^	 SHORTHAND_Format_controls}', "");
    Expect(1, 113840, '\P{	 SHORTHAND_Format_controls}', "");
    Expect(0, 113840, '\P{^	 SHORTHAND_Format_controls}', "");
    Error('\p{	is_shorthand_FORMAT_Controls/a/}');
    Error('\P{	is_shorthand_FORMAT_Controls/a/}');
    Expect(1, 113839, '\p{isshorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^isshorthandformatcontrols}', "");
    Expect(0, 113839, '\P{isshorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^isshorthandformatcontrols}', "");
    Expect(0, 113840, '\p{isshorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^isshorthandformatcontrols}', "");
    Expect(1, 113840, '\P{isshorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^isshorthandformatcontrols}', "");
    Expect(1, 113839, '\p{--Is_Shorthand_Format_Controls}', "");
    Expect(0, 113839, '\p{^--Is_Shorthand_Format_Controls}', "");
    Expect(0, 113839, '\P{--Is_Shorthand_Format_Controls}', "");
    Expect(1, 113839, '\P{^--Is_Shorthand_Format_Controls}', "");
    Expect(0, 113840, '\p{--Is_Shorthand_Format_Controls}', "");
    Expect(1, 113840, '\p{^--Is_Shorthand_Format_Controls}', "");
    Expect(1, 113840, '\P{--Is_Shorthand_Format_Controls}', "");
    Expect(0, 113840, '\P{^--Is_Shorthand_Format_Controls}', "");
    Error('\p{_:=IN_Shorthand_format_Controls}');
    Error('\P{_:=IN_Shorthand_format_Controls}');
    Expect(1, 113839, '\p{inshorthandformatcontrols}', "");
    Expect(0, 113839, '\p{^inshorthandformatcontrols}', "");
    Expect(0, 113839, '\P{inshorthandformatcontrols}', "");
    Expect(1, 113839, '\P{^inshorthandformatcontrols}', "");
    Expect(0, 113840, '\p{inshorthandformatcontrols}', "");
    Expect(1, 113840, '\p{^inshorthandformatcontrols}', "");
    Expect(1, 113840, '\P{inshorthandformatcontrols}', "");
    Expect(0, 113840, '\P{^inshorthandformatcontrols}', "");
    Expect(1, 113839, '\p{_in_shorthand_FORMAT_CONTROLS}', "");
    Expect(0, 113839, '\p{^_in_shorthand_FORMAT_CONTROLS}', "");
    Expect(0, 113839, '\P{_in_shorthand_FORMAT_CONTROLS}', "");
    Expect(1, 113839, '\P{^_in_shorthand_FORMAT_CONTROLS}', "");
    Expect(0, 113840, '\p{_in_shorthand_FORMAT_CONTROLS}', "");
    Expect(1, 113840, '\p{^_in_shorthand_FORMAT_CONTROLS}', "");
    Expect(1, 113840, '\P{_in_shorthand_FORMAT_CONTROLS}', "");
    Expect(0, 113840, '\P{^_in_shorthand_FORMAT_CONTROLS}', "");
    Error('\p{ /a/SIDDHAM}');
    Error('\P{ /a/SIDDHAM}');
    Expect(1, 71133, '\p{siddham}', "");
    Expect(0, 71133, '\p{^siddham}', "");
    Expect(0, 71133, '\P{siddham}', "");
    Expect(1, 71133, '\P{^siddham}', "");
    Expect(0, 71134, '\p{siddham}', "");
    Expect(1, 71134, '\p{^siddham}', "");
    Expect(1, 71134, '\P{siddham}', "");
    Expect(0, 71134, '\P{^siddham}', "");
    Expect(1, 71133, '\p{-Siddham}', "");
    Expect(0, 71133, '\p{^-Siddham}', "");
    Expect(0, 71133, '\P{-Siddham}', "");
    Expect(1, 71133, '\P{^-Siddham}', "");
    Expect(0, 71134, '\p{-Siddham}', "");
    Expect(1, 71134, '\p{^-Siddham}', "");
    Expect(1, 71134, '\P{-Siddham}', "");
    Expect(0, 71134, '\P{^-Siddham}', "");
    Error('\p{_-Is_siddham:=}');
    Error('\P{_-Is_siddham:=}');
    Expect(1, 71133, '\p{issiddham}', "");
    Expect(0, 71133, '\p{^issiddham}', "");
    Expect(0, 71133, '\P{issiddham}', "");
    Expect(1, 71133, '\P{^issiddham}', "");
    Expect(0, 71134, '\p{issiddham}', "");
    Expect(1, 71134, '\p{^issiddham}', "");
    Expect(1, 71134, '\P{issiddham}', "");
    Expect(0, 71134, '\P{^issiddham}', "");
    Expect(1, 71133, '\p{-	is_siddham}', "");
    Expect(0, 71133, '\p{^-	is_siddham}', "");
    Expect(0, 71133, '\P{-	is_siddham}', "");
    Expect(1, 71133, '\P{^-	is_siddham}', "");
    Expect(0, 71134, '\p{-	is_siddham}', "");
    Expect(1, 71134, '\p{^-	is_siddham}', "");
    Expect(1, 71134, '\P{-	is_siddham}', "");
    Expect(0, 71134, '\P{^-	is_siddham}', "");
    Error('\p{	 Sidd:=}');
    Error('\P{	 Sidd:=}');
    Expect(1, 71133, '\p{sidd}', "");
    Expect(0, 71133, '\p{^sidd}', "");
    Expect(0, 71133, '\P{sidd}', "");
    Expect(1, 71133, '\P{^sidd}', "");
    Expect(0, 71134, '\p{sidd}', "");
    Expect(1, 71134, '\p{^sidd}', "");
    Expect(1, 71134, '\P{sidd}', "");
    Expect(0, 71134, '\P{^sidd}', "");
    Expect(1, 71133, '\p{	_sidd}', "");
    Expect(0, 71133, '\p{^	_sidd}', "");
    Expect(0, 71133, '\P{	_sidd}', "");
    Expect(1, 71133, '\P{^	_sidd}', "");
    Expect(0, 71134, '\p{	_sidd}', "");
    Expect(1, 71134, '\p{^	_sidd}', "");
    Expect(1, 71134, '\P{	_sidd}', "");
    Expect(0, 71134, '\P{^	_sidd}', "");
    Error('\p{_/a/Is_SIDD}');
    Error('\P{_/a/Is_SIDD}');
    Expect(1, 71133, '\p{issidd}', "");
    Expect(0, 71133, '\p{^issidd}', "");
    Expect(0, 71133, '\P{issidd}', "");
    Expect(1, 71133, '\P{^issidd}', "");
    Expect(0, 71134, '\p{issidd}', "");
    Expect(1, 71134, '\p{^issidd}', "");
    Expect(1, 71134, '\P{issidd}', "");
    Expect(0, 71134, '\P{^issidd}', "");
    Expect(1, 71133, '\p{	 is_sidd}', "");
    Expect(0, 71133, '\p{^	 is_sidd}', "");
    Expect(0, 71133, '\P{	 is_sidd}', "");
    Expect(1, 71133, '\P{^	 is_sidd}', "");
    Expect(0, 71134, '\p{	 is_sidd}', "");
    Expect(1, 71134, '\p{^	 is_sidd}', "");
    Expect(1, 71134, '\P{	 is_sidd}', "");
    Expect(0, 71134, '\P{^	 is_sidd}', "");
    Error('\p{:=	_SignWriting}');
    Error('\P{:=	_SignWriting}');
    Expect(1, 121519, '\p{signwriting}', "");
    Expect(0, 121519, '\p{^signwriting}', "");
    Expect(0, 121519, '\P{signwriting}', "");
    Expect(1, 121519, '\P{^signwriting}', "");
    Expect(0, 121520, '\p{signwriting}', "");
    Expect(1, 121520, '\p{^signwriting}', "");
    Expect(1, 121520, '\P{signwriting}', "");
    Expect(0, 121520, '\P{^signwriting}', "");
    Expect(1, 121519, '\p{	SignWriting}', "");
    Expect(0, 121519, '\p{^	SignWriting}', "");
    Expect(0, 121519, '\P{	SignWriting}', "");
    Expect(1, 121519, '\P{^	SignWriting}', "");
    Expect(0, 121520, '\p{	SignWriting}', "");
    Expect(1, 121520, '\p{^	SignWriting}', "");
    Expect(1, 121520, '\P{	SignWriting}', "");
    Expect(0, 121520, '\P{^	SignWriting}', "");
    Error('\p{/a/_Is_SignWriting}');
    Error('\P{/a/_Is_SignWriting}');
    Expect(1, 121519, '\p{issignwriting}', "");
    Expect(0, 121519, '\p{^issignwriting}', "");
    Expect(0, 121519, '\P{issignwriting}', "");
    Expect(1, 121519, '\P{^issignwriting}', "");
    Expect(0, 121520, '\p{issignwriting}', "");
    Expect(1, 121520, '\p{^issignwriting}', "");
    Expect(1, 121520, '\P{issignwriting}', "");
    Expect(0, 121520, '\P{^issignwriting}', "");
    Expect(1, 121519, '\p{_	Is_SignWriting}', "");
    Expect(0, 121519, '\p{^_	Is_SignWriting}', "");
    Expect(0, 121519, '\P{_	Is_SignWriting}', "");
    Expect(1, 121519, '\P{^_	Is_SignWriting}', "");
    Expect(0, 121520, '\p{_	Is_SignWriting}', "");
    Expect(1, 121520, '\p{^_	Is_SignWriting}', "");
    Expect(1, 121520, '\P{_	Is_SignWriting}', "");
    Expect(0, 121520, '\P{^_	Is_SignWriting}', "");
    Error('\p{/a/ sgnw}');
    Error('\P{/a/ sgnw}');
    Expect(1, 121519, '\p{sgnw}', "");
    Expect(0, 121519, '\p{^sgnw}', "");
    Expect(0, 121519, '\P{sgnw}', "");
    Expect(1, 121519, '\P{^sgnw}', "");
    Expect(0, 121520, '\p{sgnw}', "");
    Expect(1, 121520, '\p{^sgnw}', "");
    Expect(1, 121520, '\P{sgnw}', "");
    Expect(0, 121520, '\P{^sgnw}', "");
    Expect(1, 121519, '\p{  sgnw}', "");
    Expect(0, 121519, '\p{^  sgnw}', "");
    Expect(0, 121519, '\P{  sgnw}', "");
    Expect(1, 121519, '\P{^  sgnw}', "");
    Expect(0, 121520, '\p{  sgnw}', "");
    Expect(1, 121520, '\p{^  sgnw}', "");
    Expect(1, 121520, '\P{  sgnw}', "");
    Expect(0, 121520, '\P{^  sgnw}', "");
    Error('\p{-Is_sgnw:=}');
    Error('\P{-Is_sgnw:=}');
    Expect(1, 121519, '\p{issgnw}', "");
    Expect(0, 121519, '\p{^issgnw}', "");
    Expect(0, 121519, '\P{issgnw}', "");
    Expect(1, 121519, '\P{^issgnw}', "");
    Expect(0, 121520, '\p{issgnw}', "");
    Expect(1, 121520, '\p{^issgnw}', "");
    Expect(1, 121520, '\P{issgnw}', "");
    Expect(0, 121520, '\P{^issgnw}', "");
    Expect(1, 121519, '\p{Is_Sgnw}', "");
    Expect(0, 121519, '\p{^Is_Sgnw}', "");
    Expect(0, 121519, '\P{Is_Sgnw}', "");
    Expect(1, 121519, '\P{^Is_Sgnw}', "");
    Expect(0, 121520, '\p{Is_Sgnw}', "");
    Expect(1, 121520, '\p{^Is_Sgnw}', "");
    Expect(1, 121520, '\P{Is_Sgnw}', "");
    Expect(0, 121520, '\P{^Is_Sgnw}', "");
    Error('\p{:= -Sinhala}');
    Error('\P{:= -Sinhala}');
    Expect(1, 70132, '\p{sinhala}', "");
    Expect(0, 70132, '\p{^sinhala}', "");
    Expect(0, 70132, '\P{sinhala}', "");
    Expect(1, 70132, '\P{^sinhala}', "");
    Expect(0, 70133, '\p{sinhala}', "");
    Expect(1, 70133, '\p{^sinhala}', "");
    Expect(1, 70133, '\P{sinhala}', "");
    Expect(0, 70133, '\P{^sinhala}', "");
    Expect(1, 70132, '\p{--Sinhala}', "");
    Expect(0, 70132, '\p{^--Sinhala}', "");
    Expect(0, 70132, '\P{--Sinhala}', "");
    Expect(1, 70132, '\P{^--Sinhala}', "");
    Expect(0, 70133, '\p{--Sinhala}', "");
    Expect(1, 70133, '\p{^--Sinhala}', "");
    Expect(1, 70133, '\P{--Sinhala}', "");
    Expect(0, 70133, '\P{^--Sinhala}', "");
    Error('\p{ :=IS_Sinhala}');
    Error('\P{ :=IS_Sinhala}');
    Expect(1, 70132, '\p{issinhala}', "");
    Expect(0, 70132, '\p{^issinhala}', "");
    Expect(0, 70132, '\P{issinhala}', "");
    Expect(1, 70132, '\P{^issinhala}', "");
    Expect(0, 70133, '\p{issinhala}', "");
    Expect(1, 70133, '\p{^issinhala}', "");
    Expect(1, 70133, '\P{issinhala}', "");
    Expect(0, 70133, '\P{^issinhala}', "");
    Expect(1, 70132, '\p{_Is_Sinhala}', "");
    Expect(0, 70132, '\p{^_Is_Sinhala}', "");
    Expect(0, 70132, '\P{_Is_Sinhala}', "");
    Expect(1, 70132, '\P{^_Is_Sinhala}', "");
    Expect(0, 70133, '\p{_Is_Sinhala}', "");
    Expect(1, 70133, '\p{^_Is_Sinhala}', "");
    Expect(1, 70133, '\P{_Is_Sinhala}', "");
    Expect(0, 70133, '\P{^_Is_Sinhala}', "");
    Error('\p{	/a/Sinh}');
    Error('\P{	/a/Sinh}');
    Expect(1, 70132, '\p{sinh}', "");
    Expect(0, 70132, '\p{^sinh}', "");
    Expect(0, 70132, '\P{sinh}', "");
    Expect(1, 70132, '\P{^sinh}', "");
    Expect(0, 70133, '\p{sinh}', "");
    Expect(1, 70133, '\p{^sinh}', "");
    Expect(1, 70133, '\P{sinh}', "");
    Expect(0, 70133, '\P{^sinh}', "");
    Expect(1, 70132, '\p{ _SINH}', "");
    Expect(0, 70132, '\p{^ _SINH}', "");
    Expect(0, 70132, '\P{ _SINH}', "");
    Expect(1, 70132, '\P{^ _SINH}', "");
    Expect(0, 70133, '\p{ _SINH}', "");
    Expect(1, 70133, '\p{^ _SINH}', "");
    Expect(1, 70133, '\P{ _SINH}', "");
    Expect(0, 70133, '\P{^ _SINH}', "");
    Error('\p{/a/-IS_sinh}');
    Error('\P{/a/-IS_sinh}');
    Expect(1, 70132, '\p{issinh}', "");
    Expect(0, 70132, '\p{^issinh}', "");
    Expect(0, 70132, '\P{issinh}', "");
    Expect(1, 70132, '\P{^issinh}', "");
    Expect(0, 70133, '\p{issinh}', "");
    Expect(1, 70133, '\p{^issinh}', "");
    Expect(1, 70133, '\P{issinh}', "");
    Expect(0, 70133, '\P{^issinh}', "");
    Expect(1, 70132, '\p{--Is_Sinh}', "");
    Expect(0, 70132, '\p{^--Is_Sinh}', "");
    Expect(0, 70132, '\P{--Is_Sinh}', "");
    Expect(1, 70132, '\P{^--Is_Sinh}', "");
    Expect(0, 70133, '\p{--Is_Sinh}', "");
    Expect(1, 70133, '\p{^--Is_Sinh}', "");
    Expect(1, 70133, '\P{--Is_Sinh}', "");
    Expect(0, 70133, '\P{^--Is_Sinh}', "");
    Error('\p{-:=sinhala_ARCHAIC_NUMBERS}');
    Error('\P{-:=sinhala_ARCHAIC_NUMBERS}');
    Expect(1, 70143, '\p{sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^sinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^sinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{sinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^sinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{- sinhala_Archaic_NUMBERS}', "");
    Expect(0, 70143, '\p{^- sinhala_Archaic_NUMBERS}', "");
    Expect(0, 70143, '\P{- sinhala_Archaic_NUMBERS}', "");
    Expect(1, 70143, '\P{^- sinhala_Archaic_NUMBERS}', "");
    Expect(0, 70144, '\p{- sinhala_Archaic_NUMBERS}', "");
    Expect(1, 70144, '\p{^- sinhala_Archaic_NUMBERS}', "");
    Expect(1, 70144, '\P{- sinhala_Archaic_NUMBERS}', "");
    Expect(0, 70144, '\P{^- sinhala_Archaic_NUMBERS}', "");
    Error('\p{ :=Is_SINHALA_Archaic_NUMBERS}');
    Error('\P{ :=Is_SINHALA_Archaic_NUMBERS}');
    Expect(1, 70143, '\p{issinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^issinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{issinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^issinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{issinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^issinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{issinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^issinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{_	IS_sinhala_Archaic_numbers}', "");
    Expect(0, 70143, '\p{^_	IS_sinhala_Archaic_numbers}', "");
    Expect(0, 70143, '\P{_	IS_sinhala_Archaic_numbers}', "");
    Expect(1, 70143, '\P{^_	IS_sinhala_Archaic_numbers}', "");
    Expect(0, 70144, '\p{_	IS_sinhala_Archaic_numbers}', "");
    Expect(1, 70144, '\p{^_	IS_sinhala_Archaic_numbers}', "");
    Expect(1, 70144, '\P{_	IS_sinhala_Archaic_numbers}', "");
    Expect(0, 70144, '\P{^_	IS_sinhala_Archaic_numbers}', "");
    Error('\p{-:=In_Sinhala_Archaic_Numbers}');
    Error('\P{-:=In_Sinhala_Archaic_Numbers}');
    Expect(1, 70143, '\p{insinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\p{^insinhalaarchaicnumbers}', "");
    Expect(0, 70143, '\P{insinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\P{^insinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\p{insinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\p{^insinhalaarchaicnumbers}', "");
    Expect(1, 70144, '\P{insinhalaarchaicnumbers}', "");
    Expect(0, 70144, '\P{^insinhalaarchaicnumbers}', "");
    Expect(1, 70143, '\p{ _in_Sinhala_archaic_NUMBERS}', "");
    Expect(0, 70143, '\p{^ _in_Sinhala_archaic_NUMBERS}', "");
    Expect(0, 70143, '\P{ _in_Sinhala_archaic_NUMBERS}', "");
    Expect(1, 70143, '\P{^ _in_Sinhala_archaic_NUMBERS}', "");
    Expect(0, 70144, '\p{ _in_Sinhala_archaic_NUMBERS}', "");
    Expect(1, 70144, '\p{^ _in_Sinhala_archaic_NUMBERS}', "");
    Expect(1, 70144, '\P{ _in_Sinhala_archaic_NUMBERS}', "");
    Expect(0, 70144, '\P{^ _in_Sinhala_archaic_NUMBERS}', "");
    Error('\p{/a/__Small_Form_Variants}');
    Error('\P{/a/__Small_Form_Variants}');
    Expect(1, 65135, '\p{smallformvariants}', "");
    Expect(0, 65135, '\p{^smallformvariants}', "");
    Expect(0, 65135, '\P{smallformvariants}', "");
    Expect(1, 65135, '\P{^smallformvariants}', "");
    Expect(0, 65136, '\p{smallformvariants}', "");
    Expect(1, 65136, '\p{^smallformvariants}', "");
    Expect(1, 65136, '\P{smallformvariants}', "");
    Expect(0, 65136, '\P{^smallformvariants}', "");
    Expect(1, 65135, '\p{ Small_form_VARIANTS}', "");
    Expect(0, 65135, '\p{^ Small_form_VARIANTS}', "");
    Expect(0, 65135, '\P{ Small_form_VARIANTS}', "");
    Expect(1, 65135, '\P{^ Small_form_VARIANTS}', "");
    Expect(0, 65136, '\p{ Small_form_VARIANTS}', "");
    Expect(1, 65136, '\p{^ Small_form_VARIANTS}', "");
    Expect(1, 65136, '\P{ Small_form_VARIANTS}', "");
    Expect(0, 65136, '\P{^ Small_form_VARIANTS}', "");
    Error('\p{	:=is_small_FORM_Variants}');
    Error('\P{	:=is_small_FORM_Variants}');
    Expect(1, 65135, '\p{issmallformvariants}', "");
    Expect(0, 65135, '\p{^issmallformvariants}', "");
    Expect(0, 65135, '\P{issmallformvariants}', "");
    Expect(1, 65135, '\P{^issmallformvariants}', "");
    Expect(0, 65136, '\p{issmallformvariants}', "");
    Expect(1, 65136, '\p{^issmallformvariants}', "");
    Expect(1, 65136, '\P{issmallformvariants}', "");
    Expect(0, 65136, '\P{^issmallformvariants}', "");
    Expect(1, 65135, '\p{	is_small_Form_variants}', "");
    Expect(0, 65135, '\p{^	is_small_Form_variants}', "");
    Expect(0, 65135, '\P{	is_small_Form_variants}', "");
    Expect(1, 65135, '\P{^	is_small_Form_variants}', "");
    Expect(0, 65136, '\p{	is_small_Form_variants}', "");
    Expect(1, 65136, '\p{^	is_small_Form_variants}', "");
    Expect(1, 65136, '\P{	is_small_Form_variants}', "");
    Expect(0, 65136, '\P{^	is_small_Form_variants}', "");
    Error('\p{/a/ 	in_SMALL_FORM_Variants}');
    Error('\P{/a/ 	in_SMALL_FORM_Variants}');
    Expect(1, 65135, '\p{insmallformvariants}', "");
    Expect(0, 65135, '\p{^insmallformvariants}', "");
    Expect(0, 65135, '\P{insmallformvariants}', "");
    Expect(1, 65135, '\P{^insmallformvariants}', "");
    Expect(0, 65136, '\p{insmallformvariants}', "");
    Expect(1, 65136, '\p{^insmallformvariants}', "");
    Expect(1, 65136, '\P{insmallformvariants}', "");
    Expect(0, 65136, '\P{^insmallformvariants}', "");
    Expect(1, 65135, '\p{ _In_SMALL_FORM_VARIANTS}', "");
    Expect(0, 65135, '\p{^ _In_SMALL_FORM_VARIANTS}', "");
    Expect(0, 65135, '\P{ _In_SMALL_FORM_VARIANTS}', "");
    Expect(1, 65135, '\P{^ _In_SMALL_FORM_VARIANTS}', "");
    Expect(0, 65136, '\p{ _In_SMALL_FORM_VARIANTS}', "");
    Expect(1, 65136, '\p{^ _In_SMALL_FORM_VARIANTS}', "");
    Expect(1, 65136, '\P{ _In_SMALL_FORM_VARIANTS}', "");
    Expect(0, 65136, '\P{^ _In_SMALL_FORM_VARIANTS}', "");
    Error('\p{/a/_SMALL_Forms}');
    Error('\P{/a/_SMALL_Forms}');
    Expect(1, 65135, '\p{smallforms}', "");
    Expect(0, 65135, '\p{^smallforms}', "");
    Expect(0, 65135, '\P{smallforms}', "");
    Expect(1, 65135, '\P{^smallforms}', "");
    Expect(0, 65136, '\p{smallforms}', "");
    Expect(1, 65136, '\p{^smallforms}', "");
    Expect(1, 65136, '\P{smallforms}', "");
    Expect(0, 65136, '\P{^smallforms}', "");
    Expect(1, 65135, '\p{SMALL_Forms}', "");
    Expect(0, 65135, '\p{^SMALL_Forms}', "");
    Expect(0, 65135, '\P{SMALL_Forms}', "");
    Expect(1, 65135, '\P{^SMALL_Forms}', "");
    Expect(0, 65136, '\p{SMALL_Forms}', "");
    Expect(1, 65136, '\p{^SMALL_Forms}', "");
    Expect(1, 65136, '\P{SMALL_Forms}', "");
    Expect(0, 65136, '\P{^SMALL_Forms}', "");
    Error('\p{_IS_small_Forms/a/}');
    Error('\P{_IS_small_Forms/a/}');
    Expect(1, 65135, '\p{issmallforms}', "");
    Expect(0, 65135, '\p{^issmallforms}', "");
    Expect(0, 65135, '\P{issmallforms}', "");
    Expect(1, 65135, '\P{^issmallforms}', "");
    Expect(0, 65136, '\p{issmallforms}', "");
    Expect(1, 65136, '\p{^issmallforms}', "");
    Expect(1, 65136, '\P{issmallforms}', "");
    Expect(0, 65136, '\P{^issmallforms}', "");
    Expect(1, 65135, '\p{--Is_small_FORMS}', "");
    Expect(0, 65135, '\p{^--Is_small_FORMS}', "");
    Expect(0, 65135, '\P{--Is_small_FORMS}', "");
    Expect(1, 65135, '\P{^--Is_small_FORMS}', "");
    Expect(0, 65136, '\p{--Is_small_FORMS}', "");
    Expect(1, 65136, '\p{^--Is_small_FORMS}', "");
    Expect(1, 65136, '\P{--Is_small_FORMS}', "");
    Expect(0, 65136, '\P{^--Is_small_FORMS}', "");
    Error('\p{:=	 in_Small_Forms}');
    Error('\P{:=	 in_Small_Forms}');
    Expect(1, 65135, '\p{insmallforms}', "");
    Expect(0, 65135, '\p{^insmallforms}', "");
    Expect(0, 65135, '\P{insmallforms}', "");
    Expect(1, 65135, '\P{^insmallforms}', "");
    Expect(0, 65136, '\p{insmallforms}', "");
    Expect(1, 65136, '\p{^insmallforms}', "");
    Expect(1, 65136, '\P{insmallforms}', "");
    Expect(0, 65136, '\P{^insmallforms}', "");
    Expect(1, 65135, '\p{- In_Small_forms}', "");
    Expect(0, 65135, '\p{^- In_Small_forms}', "");
    Expect(0, 65135, '\P{- In_Small_forms}', "");
    Expect(1, 65135, '\P{^- In_Small_forms}', "");
    Expect(0, 65136, '\p{- In_Small_forms}', "");
    Expect(1, 65136, '\p{^- In_Small_forms}', "");
    Expect(1, 65136, '\P{- In_Small_forms}', "");
    Expect(0, 65136, '\P{^- In_Small_forms}', "");
    Error('\p{	SMALL_Kana_Extension/a/}');
    Error('\P{	SMALL_Kana_Extension/a/}');
    Expect(1, 110959, '\p{smallkanaextension}', "");
    Expect(0, 110959, '\p{^smallkanaextension}', "");
    Expect(0, 110959, '\P{smallkanaextension}', "");
    Expect(1, 110959, '\P{^smallkanaextension}', "");
    Expect(0, 110960, '\p{smallkanaextension}', "");
    Expect(1, 110960, '\p{^smallkanaextension}', "");
    Expect(1, 110960, '\P{smallkanaextension}', "");
    Expect(0, 110960, '\P{^smallkanaextension}', "");
    Expect(1, 110959, '\p{_	Small_kana_Extension}', "");
    Expect(0, 110959, '\p{^_	Small_kana_Extension}', "");
    Expect(0, 110959, '\P{_	Small_kana_Extension}', "");
    Expect(1, 110959, '\P{^_	Small_kana_Extension}', "");
    Expect(0, 110960, '\p{_	Small_kana_Extension}', "");
    Expect(1, 110960, '\p{^_	Small_kana_Extension}', "");
    Expect(1, 110960, '\P{_	Small_kana_Extension}', "");
    Expect(0, 110960, '\P{^_	Small_kana_Extension}', "");
    Error('\p{	_IS_Small_KANA_Extension:=}');
    Error('\P{	_IS_Small_KANA_Extension:=}');
    Expect(1, 110959, '\p{issmallkanaextension}', "");
    Expect(0, 110959, '\p{^issmallkanaextension}', "");
    Expect(0, 110959, '\P{issmallkanaextension}', "");
    Expect(1, 110959, '\P{^issmallkanaextension}', "");
    Expect(0, 110960, '\p{issmallkanaextension}', "");
    Expect(1, 110960, '\p{^issmallkanaextension}', "");
    Expect(1, 110960, '\P{issmallkanaextension}', "");
    Expect(0, 110960, '\P{^issmallkanaextension}', "");
    Expect(1, 110959, '\p{--is_Small_kana_EXTENSION}', "");
    Expect(0, 110959, '\p{^--is_Small_kana_EXTENSION}', "");
    Expect(0, 110959, '\P{--is_Small_kana_EXTENSION}', "");
    Expect(1, 110959, '\P{^--is_Small_kana_EXTENSION}', "");
    Expect(0, 110960, '\p{--is_Small_kana_EXTENSION}', "");
    Expect(1, 110960, '\p{^--is_Small_kana_EXTENSION}', "");
    Expect(1, 110960, '\P{--is_Small_kana_EXTENSION}', "");
    Expect(0, 110960, '\P{^--is_Small_kana_EXTENSION}', "");
    Error('\p{:= In_Small_Kana_EXTENSION}');
    Error('\P{:= In_Small_Kana_EXTENSION}');
    Expect(1, 110959, '\p{insmallkanaextension}', "");
    Expect(0, 110959, '\p{^insmallkanaextension}', "");
    Expect(0, 110959, '\P{insmallkanaextension}', "");
    Expect(1, 110959, '\P{^insmallkanaextension}', "");
    Expect(0, 110960, '\p{insmallkanaextension}', "");
    Expect(1, 110960, '\p{^insmallkanaextension}', "");
    Expect(1, 110960, '\P{insmallkanaextension}', "");
    Expect(0, 110960, '\P{^insmallkanaextension}', "");
    Expect(1, 110959, '\p{	In_small_Kana_Extension}', "");
    Expect(0, 110959, '\p{^	In_small_Kana_Extension}', "");
    Expect(0, 110959, '\P{	In_small_Kana_Extension}', "");
    Expect(1, 110959, '\P{^	In_small_Kana_Extension}', "");
    Expect(0, 110960, '\p{	In_small_Kana_Extension}', "");
    Expect(1, 110960, '\p{^	In_small_Kana_Extension}', "");
    Expect(1, 110960, '\P{	In_small_Kana_Extension}', "");
    Expect(0, 110960, '\P{^	In_small_Kana_Extension}', "");
    Error('\p{	_SMALL_Kana_Ext/a/}');
    Error('\P{	_SMALL_Kana_Ext/a/}');
    Expect(1, 110959, '\p{smallkanaext}', "");
    Expect(0, 110959, '\p{^smallkanaext}', "");
    Expect(0, 110959, '\P{smallkanaext}', "");
    Expect(1, 110959, '\P{^smallkanaext}', "");
    Expect(0, 110960, '\p{smallkanaext}', "");
    Expect(1, 110960, '\p{^smallkanaext}', "");
    Expect(1, 110960, '\P{smallkanaext}', "");
    Expect(0, 110960, '\P{^smallkanaext}', "");
    Expect(1, 110959, '\p{		SMALL_kana_EXT}', "");
    Expect(0, 110959, '\p{^		SMALL_kana_EXT}', "");
    Expect(0, 110959, '\P{		SMALL_kana_EXT}', "");
    Expect(1, 110959, '\P{^		SMALL_kana_EXT}', "");
    Expect(0, 110960, '\p{		SMALL_kana_EXT}', "");
    Expect(1, 110960, '\p{^		SMALL_kana_EXT}', "");
    Expect(1, 110960, '\P{		SMALL_kana_EXT}', "");
    Expect(0, 110960, '\P{^		SMALL_kana_EXT}', "");
    Error('\p{-:=is_Small_Kana_ext}');
    Error('\P{-:=is_Small_Kana_ext}');
    Expect(1, 110959, '\p{issmallkanaext}', "");
    Expect(0, 110959, '\p{^issmallkanaext}', "");
    Expect(0, 110959, '\P{issmallkanaext}', "");
    Expect(1, 110959, '\P{^issmallkanaext}', "");
    Expect(0, 110960, '\p{issmallkanaext}', "");
    Expect(1, 110960, '\p{^issmallkanaext}', "");
    Expect(1, 110960, '\P{issmallkanaext}', "");
    Expect(0, 110960, '\P{^issmallkanaext}', "");
    Expect(1, 110959, '\p{_-is_Small_kana_ext}', "");
    Expect(0, 110959, '\p{^_-is_Small_kana_ext}', "");
    Expect(0, 110959, '\P{_-is_Small_kana_ext}', "");
    Expect(1, 110959, '\P{^_-is_Small_kana_ext}', "");
    Expect(0, 110960, '\p{_-is_Small_kana_ext}', "");
    Expect(1, 110960, '\p{^_-is_Small_kana_ext}', "");
    Expect(1, 110960, '\P{_-is_Small_kana_ext}', "");
    Expect(0, 110960, '\P{^_-is_Small_kana_ext}', "");
    Error('\p{:=-in_Small_KANA_ext}');
    Error('\P{:=-in_Small_KANA_ext}');
    Expect(1, 110959, '\p{insmallkanaext}', "");
    Expect(0, 110959, '\p{^insmallkanaext}', "");
    Expect(0, 110959, '\P{insmallkanaext}', "");
    Expect(1, 110959, '\P{^insmallkanaext}', "");
    Expect(0, 110960, '\p{insmallkanaext}', "");
    Expect(1, 110960, '\p{^insmallkanaext}', "");
    Expect(1, 110960, '\P{insmallkanaext}', "");
    Expect(0, 110960, '\P{^insmallkanaext}', "");
    Expect(1, 110959, '\p{-In_small_kana_Ext}', "");
    Expect(0, 110959, '\p{^-In_small_kana_Ext}', "");
    Expect(0, 110959, '\P{-In_small_kana_Ext}', "");
    Expect(1, 110959, '\P{^-In_small_kana_Ext}', "");
    Expect(0, 110960, '\p{-In_small_kana_Ext}', "");
    Expect(1, 110960, '\p{^-In_small_kana_Ext}', "");
    Expect(1, 110960, '\P{-In_small_kana_Ext}', "");
    Expect(0, 110960, '\P{^-In_small_kana_Ext}', "");
    Error('\p{:=	_soft_DOTTED}');
    Error('\P{:=	_soft_DOTTED}');
    Expect(1, 120467, '\p{softdotted}', "");
    Expect(0, 120467, '\p{^softdotted}', "");
    Expect(0, 120467, '\P{softdotted}', "");
    Expect(1, 120467, '\P{^softdotted}', "");
    Expect(0, 120468, '\p{softdotted}', "");
    Expect(1, 120468, '\p{^softdotted}', "");
    Expect(1, 120468, '\P{softdotted}', "");
    Expect(0, 120468, '\P{^softdotted}', "");
    Expect(1, 120467, '\p{ _soft_Dotted}', "");
    Expect(0, 120467, '\p{^ _soft_Dotted}', "");
    Expect(0, 120467, '\P{ _soft_Dotted}', "");
    Expect(1, 120467, '\P{^ _soft_Dotted}', "");
    Expect(0, 120468, '\p{ _soft_Dotted}', "");
    Expect(1, 120468, '\p{^ _soft_Dotted}', "");
    Expect(1, 120468, '\P{ _soft_Dotted}', "");
    Expect(0, 120468, '\P{^ _soft_Dotted}', "");
    Error('\p{	 is_soft_Dotted/a/}');
    Error('\P{	 is_soft_Dotted/a/}');
    Expect(1, 120467, '\p{issoftdotted}', "");
    Expect(0, 120467, '\p{^issoftdotted}', "");
    Expect(0, 120467, '\P{issoftdotted}', "");
    Expect(1, 120467, '\P{^issoftdotted}', "");
    Expect(0, 120468, '\p{issoftdotted}', "");
    Expect(1, 120468, '\p{^issoftdotted}', "");
    Expect(1, 120468, '\P{issoftdotted}', "");
    Expect(0, 120468, '\P{^issoftdotted}', "");
    Expect(1, 120467, '\p{--is_Soft_DOTTED}', "");
    Expect(0, 120467, '\p{^--is_Soft_DOTTED}', "");
    Expect(0, 120467, '\P{--is_Soft_DOTTED}', "");
    Expect(1, 120467, '\P{^--is_Soft_DOTTED}', "");
    Expect(0, 120468, '\p{--is_Soft_DOTTED}', "");
    Expect(1, 120468, '\p{^--is_Soft_DOTTED}', "");
    Expect(1, 120468, '\P{--is_Soft_DOTTED}', "");
    Expect(0, 120468, '\P{^--is_Soft_DOTTED}', "");
    Error('\p{	/a/SD}');
    Error('\P{	/a/SD}');
    Expect(1, 120467, '\p{sd}', "");
    Expect(0, 120467, '\p{^sd}', "");
    Expect(0, 120467, '\P{sd}', "");
    Expect(1, 120467, '\P{^sd}', "");
    Expect(0, 120468, '\p{sd}', "");
    Expect(1, 120468, '\p{^sd}', "");
    Expect(1, 120468, '\P{sd}', "");
    Expect(0, 120468, '\P{^sd}', "");
    Expect(1, 120467, '\p{_ SD}', "");
    Expect(0, 120467, '\p{^_ SD}', "");
    Expect(0, 120467, '\P{_ SD}', "");
    Expect(1, 120467, '\P{^_ SD}', "");
    Expect(0, 120468, '\p{_ SD}', "");
    Expect(1, 120468, '\p{^_ SD}', "");
    Expect(1, 120468, '\P{_ SD}', "");
    Expect(0, 120468, '\P{^_ SD}', "");
    Error('\p{- is_SD:=}');
    Error('\P{- is_SD:=}');
    Expect(1, 120467, '\p{issd}', "");
    Expect(0, 120467, '\p{^issd}', "");
    Expect(0, 120467, '\P{issd}', "");
    Expect(1, 120467, '\P{^issd}', "");
    Expect(0, 120468, '\p{issd}', "");
    Expect(1, 120468, '\p{^issd}', "");
    Expect(1, 120468, '\P{issd}', "");
    Expect(0, 120468, '\P{^issd}', "");
    Expect(1, 120467, '\p{Is_sd}', "");
    Expect(0, 120467, '\p{^Is_sd}', "");
    Expect(0, 120467, '\P{Is_sd}', "");
    Expect(1, 120467, '\P{^Is_sd}', "");
    Expect(0, 120468, '\p{Is_sd}', "");
    Expect(1, 120468, '\p{^Is_sd}', "");
    Expect(1, 120468, '\P{Is_sd}', "");
    Expect(0, 120468, '\P{^Is_sd}', "");
    Error('\p{:=-_Sogdian}');
    Error('\P{:=-_Sogdian}');
    Expect(1, 69465, '\p{sogdian}', "");
    Expect(0, 69465, '\p{^sogdian}', "");
    Expect(0, 69465, '\P{sogdian}', "");
    Expect(1, 69465, '\P{^sogdian}', "");
    Expect(0, 69466, '\p{sogdian}', "");
    Expect(1, 69466, '\p{^sogdian}', "");
    Expect(1, 69466, '\P{sogdian}', "");
    Expect(0, 69466, '\P{^sogdian}', "");
    Expect(1, 69465, '\p{-	Sogdian}', "");
    Expect(0, 69465, '\p{^-	Sogdian}', "");
    Expect(0, 69465, '\P{-	Sogdian}', "");
    Expect(1, 69465, '\P{^-	Sogdian}', "");
    Expect(0, 69466, '\p{-	Sogdian}', "");
    Expect(1, 69466, '\p{^-	Sogdian}', "");
    Expect(1, 69466, '\P{-	Sogdian}', "");
    Expect(0, 69466, '\P{^-	Sogdian}', "");
    Error('\p{--Is_SOGDIAN/a/}');
    Error('\P{--Is_SOGDIAN/a/}');
    Expect(1, 69465, '\p{issogdian}', "");
    Expect(0, 69465, '\p{^issogdian}', "");
    Expect(0, 69465, '\P{issogdian}', "");
    Expect(1, 69465, '\P{^issogdian}', "");
    Expect(0, 69466, '\p{issogdian}', "");
    Expect(1, 69466, '\p{^issogdian}', "");
    Expect(1, 69466, '\P{issogdian}', "");
    Expect(0, 69466, '\P{^issogdian}', "");
    Expect(1, 69465, '\p{--Is_sogdian}', "");
    Expect(0, 69465, '\p{^--Is_sogdian}', "");
    Expect(0, 69465, '\P{--Is_sogdian}', "");
    Expect(1, 69465, '\P{^--Is_sogdian}', "");
    Expect(0, 69466, '\p{--Is_sogdian}', "");
    Expect(1, 69466, '\p{^--Is_sogdian}', "");
    Expect(1, 69466, '\P{--Is_sogdian}', "");
    Expect(0, 69466, '\P{^--Is_sogdian}', "");
    Error('\p{:=-Sogd}');
    Error('\P{:=-Sogd}');
    Expect(1, 69465, '\p{sogd}', "");
    Expect(0, 69465, '\p{^sogd}', "");
    Expect(0, 69465, '\P{sogd}', "");
    Expect(1, 69465, '\P{^sogd}', "");
    Expect(0, 69466, '\p{sogd}', "");
    Expect(1, 69466, '\p{^sogd}', "");
    Expect(1, 69466, '\P{sogd}', "");
    Expect(0, 69466, '\P{^sogd}', "");
    Expect(1, 69465, '\p{-SOGD}', "");
    Expect(0, 69465, '\p{^-SOGD}', "");
    Expect(0, 69465, '\P{-SOGD}', "");
    Expect(1, 69465, '\P{^-SOGD}', "");
    Expect(0, 69466, '\p{-SOGD}', "");
    Expect(1, 69466, '\p{^-SOGD}', "");
    Expect(1, 69466, '\P{-SOGD}', "");
    Expect(0, 69466, '\P{^-SOGD}', "");
    Error('\p{:=_Is_SOGD}');
    Error('\P{:=_Is_SOGD}');
    Expect(1, 69465, '\p{issogd}', "");
    Expect(0, 69465, '\p{^issogd}', "");
    Expect(0, 69465, '\P{issogd}', "");
    Expect(1, 69465, '\P{^issogd}', "");
    Expect(0, 69466, '\p{issogd}', "");
    Expect(1, 69466, '\p{^issogd}', "");
    Expect(1, 69466, '\P{issogd}', "");
    Expect(0, 69466, '\P{^issogd}', "");
    Expect(1, 69465, '\p{__is_sogd}', "");
    Expect(0, 69465, '\p{^__is_sogd}', "");
    Expect(0, 69465, '\P{__is_sogd}', "");
    Expect(1, 69465, '\P{^__is_sogd}', "");
    Expect(0, 69466, '\p{__is_sogd}', "");
    Expect(1, 69466, '\p{^__is_sogd}', "");
    Expect(1, 69466, '\P{__is_sogd}', "");
    Expect(0, 69466, '\P{^__is_sogd}', "");
    Error('\p{ sora_SOMPENG/a/}');
    Error('\P{ sora_SOMPENG/a/}');
    Expect(1, 69881, '\p{sorasompeng}', "");
    Expect(0, 69881, '\p{^sorasompeng}', "");
    Expect(0, 69881, '\P{sorasompeng}', "");
    Expect(1, 69881, '\P{^sorasompeng}', "");
    Expect(0, 69882, '\p{sorasompeng}', "");
    Expect(1, 69882, '\p{^sorasompeng}', "");
    Expect(1, 69882, '\P{sorasompeng}', "");
    Expect(0, 69882, '\P{^sorasompeng}', "");
    Expect(1, 69881, '\p{_SORA_sompeng}', "");
    Expect(0, 69881, '\p{^_SORA_sompeng}', "");
    Expect(0, 69881, '\P{_SORA_sompeng}', "");
    Expect(1, 69881, '\P{^_SORA_sompeng}', "");
    Expect(0, 69882, '\p{_SORA_sompeng}', "");
    Expect(1, 69882, '\p{^_SORA_sompeng}', "");
    Expect(1, 69882, '\P{_SORA_sompeng}', "");
    Expect(0, 69882, '\P{^_SORA_sompeng}', "");
    Error('\p{ Is_Sora_Sompeng:=}');
    Error('\P{ Is_Sora_Sompeng:=}');
    Expect(1, 69881, '\p{issorasompeng}', "");
    Expect(0, 69881, '\p{^issorasompeng}', "");
    Expect(0, 69881, '\P{issorasompeng}', "");
    Expect(1, 69881, '\P{^issorasompeng}', "");
    Expect(0, 69882, '\p{issorasompeng}', "");
    Expect(1, 69882, '\p{^issorasompeng}', "");
    Expect(1, 69882, '\P{issorasompeng}', "");
    Expect(0, 69882, '\P{^issorasompeng}', "");
    Expect(1, 69881, '\p{__Is_sora_Sompeng}', "");
    Expect(0, 69881, '\p{^__Is_sora_Sompeng}', "");
    Expect(0, 69881, '\P{__Is_sora_Sompeng}', "");
    Expect(1, 69881, '\P{^__Is_sora_Sompeng}', "");
    Expect(0, 69882, '\p{__Is_sora_Sompeng}', "");
    Expect(1, 69882, '\p{^__Is_sora_Sompeng}', "");
    Expect(1, 69882, '\P{__Is_sora_Sompeng}', "");
    Expect(0, 69882, '\P{^__Is_sora_Sompeng}', "");
    Error('\p{_	SORA:=}');
    Error('\P{_	SORA:=}');
    Expect(1, 69881, '\p{sora}', "");
    Expect(0, 69881, '\p{^sora}', "");
    Expect(0, 69881, '\P{sora}', "");
    Expect(1, 69881, '\P{^sora}', "");
    Expect(0, 69882, '\p{sora}', "");
    Expect(1, 69882, '\p{^sora}', "");
    Expect(1, 69882, '\P{sora}', "");
    Expect(0, 69882, '\P{^sora}', "");
    Expect(1, 69881, '\p{		Sora}', "");
    Expect(0, 69881, '\p{^		Sora}', "");
    Expect(0, 69881, '\P{		Sora}', "");
    Expect(1, 69881, '\P{^		Sora}', "");
    Expect(0, 69882, '\p{		Sora}', "");
    Expect(1, 69882, '\p{^		Sora}', "");
    Expect(1, 69882, '\P{		Sora}', "");
    Expect(0, 69882, '\P{^		Sora}', "");
    Error('\p{is_sora:=}');
    Error('\P{is_sora:=}');
    Expect(1, 69881, '\p{issora}', "");
    Expect(0, 69881, '\p{^issora}', "");
    Expect(0, 69881, '\P{issora}', "");
    Expect(1, 69881, '\P{^issora}', "");
    Expect(0, 69882, '\p{issora}', "");
    Expect(1, 69882, '\p{^issora}', "");
    Expect(1, 69882, '\P{issora}', "");
    Expect(0, 69882, '\P{^issora}', "");
    Expect(1, 69881, '\p{ is_Sora}', "");
    Expect(0, 69881, '\p{^ is_Sora}', "");
    Expect(0, 69881, '\P{ is_Sora}', "");
    Expect(1, 69881, '\P{^ is_Sora}', "");
    Expect(0, 69882, '\p{ is_Sora}', "");
    Expect(1, 69882, '\p{^ is_Sora}', "");
    Expect(1, 69882, '\P{ is_Sora}', "");
    Expect(0, 69882, '\P{^ is_Sora}', "");
    Error('\p{/a/_soyombo}');
    Error('\P{/a/_soyombo}');
    Expect(1, 72354, '\p{soyombo}', "");
    Expect(0, 72354, '\p{^soyombo}', "");
    Expect(0, 72354, '\P{soyombo}', "");
    Expect(1, 72354, '\P{^soyombo}', "");
    Expect(0, 72355, '\p{soyombo}', "");
    Expect(1, 72355, '\p{^soyombo}', "");
    Expect(1, 72355, '\P{soyombo}', "");
    Expect(0, 72355, '\P{^soyombo}', "");
    Expect(1, 72354, '\p{  SOYOMBO}', "");
    Expect(0, 72354, '\p{^  SOYOMBO}', "");
    Expect(0, 72354, '\P{  SOYOMBO}', "");
    Expect(1, 72354, '\P{^  SOYOMBO}', "");
    Expect(0, 72355, '\p{  SOYOMBO}', "");
    Expect(1, 72355, '\p{^  SOYOMBO}', "");
    Expect(1, 72355, '\P{  SOYOMBO}', "");
    Expect(0, 72355, '\P{^  SOYOMBO}', "");
    Error('\p{-:=is_soyombo}');
    Error('\P{-:=is_soyombo}');
    Expect(1, 72354, '\p{issoyombo}', "");
    Expect(0, 72354, '\p{^issoyombo}', "");
    Expect(0, 72354, '\P{issoyombo}', "");
    Expect(1, 72354, '\P{^issoyombo}', "");
    Expect(0, 72355, '\p{issoyombo}', "");
    Expect(1, 72355, '\p{^issoyombo}', "");
    Expect(1, 72355, '\P{issoyombo}', "");
    Expect(0, 72355, '\P{^issoyombo}', "");
    Expect(1, 72354, '\p{-_IS_soyombo}', "");
    Expect(0, 72354, '\p{^-_IS_soyombo}', "");
    Expect(0, 72354, '\P{-_IS_soyombo}', "");
    Expect(1, 72354, '\P{^-_IS_soyombo}', "");
    Expect(0, 72355, '\p{-_IS_soyombo}', "");
    Expect(1, 72355, '\p{^-_IS_soyombo}', "");
    Expect(1, 72355, '\P{-_IS_soyombo}', "");
    Expect(0, 72355, '\P{^-_IS_soyombo}', "");
    Error('\p{ /a/Soyo}');
    Error('\P{ /a/Soyo}');
    Expect(1, 72354, '\p{soyo}', "");
    Expect(0, 72354, '\p{^soyo}', "");
    Expect(0, 72354, '\P{soyo}', "");
    Expect(1, 72354, '\P{^soyo}', "");
    Expect(0, 72355, '\p{soyo}', "");
    Expect(1, 72355, '\p{^soyo}', "");
    Expect(1, 72355, '\P{soyo}', "");
    Expect(0, 72355, '\P{^soyo}', "");
    Expect(1, 72354, '\p{-	soyo}', "");
    Expect(0, 72354, '\p{^-	soyo}', "");
    Expect(0, 72354, '\P{-	soyo}', "");
    Expect(1, 72354, '\P{^-	soyo}', "");
    Expect(0, 72355, '\p{-	soyo}', "");
    Expect(1, 72355, '\p{^-	soyo}', "");
    Expect(1, 72355, '\P{-	soyo}', "");
    Expect(0, 72355, '\P{^-	soyo}', "");
    Error('\p{:= Is_Soyo}');
    Error('\P{:= Is_Soyo}');
    Expect(1, 72354, '\p{issoyo}', "");
    Expect(0, 72354, '\p{^issoyo}', "");
    Expect(0, 72354, '\P{issoyo}', "");
    Expect(1, 72354, '\P{^issoyo}', "");
    Expect(0, 72355, '\p{issoyo}', "");
    Expect(1, 72355, '\p{^issoyo}', "");
    Expect(1, 72355, '\P{issoyo}', "");
    Expect(0, 72355, '\P{^issoyo}', "");
    Expect(1, 72354, '\p{- Is_Soyo}', "");
    Expect(0, 72354, '\p{^- Is_Soyo}', "");
    Expect(0, 72354, '\P{- Is_Soyo}', "");
    Expect(1, 72354, '\P{^- Is_Soyo}', "");
    Expect(0, 72355, '\p{- Is_Soyo}', "");
    Expect(1, 72355, '\p{^- Is_Soyo}', "");
    Expect(1, 72355, '\P{- Is_Soyo}', "");
    Expect(0, 72355, '\P{^- Is_Soyo}', "");
    Error('\p{  space_Separator/a/}');
    Error('\P{  space_Separator/a/}');
    Expect(1, 12288, '\p{spaceseparator}', "");
    Expect(0, 12288, '\p{^spaceseparator}', "");
    Expect(0, 12288, '\P{spaceseparator}', "");
    Expect(1, 12288, '\P{^spaceseparator}', "");
    Expect(0, 12289, '\p{spaceseparator}', "");
    Expect(1, 12289, '\p{^spaceseparator}', "");
    Expect(1, 12289, '\P{spaceseparator}', "");
    Expect(0, 12289, '\P{^spaceseparator}', "");
    Expect(1, 12288, '\p{ 	SPACE_Separator}', "");
    Expect(0, 12288, '\p{^ 	SPACE_Separator}', "");
    Expect(0, 12288, '\P{ 	SPACE_Separator}', "");
    Expect(1, 12288, '\P{^ 	SPACE_Separator}', "");
    Expect(0, 12289, '\p{ 	SPACE_Separator}', "");
    Expect(1, 12289, '\p{^ 	SPACE_Separator}', "");
    Expect(1, 12289, '\P{ 	SPACE_Separator}', "");
    Expect(0, 12289, '\P{^ 	SPACE_Separator}', "");
    Error('\p{ :=IS_Space_Separator}');
    Error('\P{ :=IS_Space_Separator}');
    Expect(1, 12288, '\p{isspaceseparator}', "");
    Expect(0, 12288, '\p{^isspaceseparator}', "");
    Expect(0, 12288, '\P{isspaceseparator}', "");
    Expect(1, 12288, '\P{^isspaceseparator}', "");
    Expect(0, 12289, '\p{isspaceseparator}', "");
    Expect(1, 12289, '\p{^isspaceseparator}', "");
    Expect(1, 12289, '\P{isspaceseparator}', "");
    Expect(0, 12289, '\P{^isspaceseparator}', "");
    Expect(1, 12288, '\p{	Is_Space_SEPARATOR}', "");
    Expect(0, 12288, '\p{^	Is_Space_SEPARATOR}', "");
    Expect(0, 12288, '\P{	Is_Space_SEPARATOR}', "");
    Expect(1, 12288, '\P{^	Is_Space_SEPARATOR}', "");
    Expect(0, 12289, '\p{	Is_Space_SEPARATOR}', "");
    Expect(1, 12289, '\p{^	Is_Space_SEPARATOR}', "");
    Expect(1, 12289, '\P{	Is_Space_SEPARATOR}', "");
    Expect(0, 12289, '\P{^	Is_Space_SEPARATOR}', "");
    Error('\p{_ zs/a/}');
    Error('\P{_ zs/a/}');
    Expect(1, 12288, '\p{zs}', "");
    Expect(0, 12288, '\p{^zs}', "");
    Expect(0, 12288, '\P{zs}', "");
    Expect(1, 12288, '\P{^zs}', "");
    Expect(0, 12289, '\p{zs}', "");
    Expect(1, 12289, '\p{^zs}', "");
    Expect(1, 12289, '\P{zs}', "");
    Expect(0, 12289, '\P{^zs}', "");
    Expect(1, 12288, '\p{Zs}', "");
    Expect(0, 12288, '\p{^Zs}', "");
    Expect(0, 12288, '\P{Zs}', "");
    Expect(1, 12288, '\P{^Zs}', "");
    Expect(0, 12289, '\p{Zs}', "");
    Expect(1, 12289, '\p{^Zs}', "");
    Expect(1, 12289, '\P{Zs}', "");
    Expect(0, 12289, '\P{^Zs}', "");
    Error('\p{ _Is_ZS/a/}');
    Error('\P{ _Is_ZS/a/}');
    Expect(1, 12288, '\p{iszs}', "");
    Expect(0, 12288, '\p{^iszs}', "");
    Expect(0, 12288, '\P{iszs}', "");
    Expect(1, 12288, '\P{^iszs}', "");
    Expect(0, 12289, '\p{iszs}', "");
    Expect(1, 12289, '\p{^iszs}', "");
    Expect(1, 12289, '\P{iszs}', "");
    Expect(0, 12289, '\P{^iszs}', "");
    Expect(1, 12288, '\p{	 Is_ZS}', "");
    Expect(0, 12288, '\p{^	 Is_ZS}', "");
    Expect(0, 12288, '\P{	 Is_ZS}', "");
    Expect(1, 12288, '\P{^	 Is_ZS}', "");
    Expect(0, 12289, '\p{	 Is_ZS}', "");
    Expect(1, 12289, '\p{^	 Is_ZS}', "");
    Expect(1, 12289, '\P{	 Is_ZS}', "");
    Expect(0, 12289, '\P{^	 Is_ZS}', "");
    Error('\p{ :=spacing_mark}');
    Error('\P{ :=spacing_mark}');
    Expect(1, 119154, '\p{spacingmark}', "");
    Expect(0, 119154, '\p{^spacingmark}', "");
    Expect(0, 119154, '\P{spacingmark}', "");
    Expect(1, 119154, '\P{^spacingmark}', "");
    Expect(0, 119155, '\p{spacingmark}', "");
    Expect(1, 119155, '\p{^spacingmark}', "");
    Expect(1, 119155, '\P{spacingmark}', "");
    Expect(0, 119155, '\P{^spacingmark}', "");
    Expect(1, 119154, '\p{ SPACING_Mark}', "");
    Expect(0, 119154, '\p{^ SPACING_Mark}', "");
    Expect(0, 119154, '\P{ SPACING_Mark}', "");
    Expect(1, 119154, '\P{^ SPACING_Mark}', "");
    Expect(0, 119155, '\p{ SPACING_Mark}', "");
    Expect(1, 119155, '\p{^ SPACING_Mark}', "");
    Expect(1, 119155, '\P{ SPACING_Mark}', "");
    Expect(0, 119155, '\P{^ SPACING_Mark}', "");
    Error('\p{/a/_	IS_Spacing_Mark}');
    Error('\P{/a/_	IS_Spacing_Mark}');
    Expect(1, 119154, '\p{isspacingmark}', "");
    Expect(0, 119154, '\p{^isspacingmark}', "");
    Expect(0, 119154, '\P{isspacingmark}', "");
    Expect(1, 119154, '\P{^isspacingmark}', "");
    Expect(0, 119155, '\p{isspacingmark}', "");
    Expect(1, 119155, '\p{^isspacingmark}', "");
    Expect(1, 119155, '\P{isspacingmark}', "");
    Expect(0, 119155, '\P{^isspacingmark}', "");
    Expect(1, 119154, '\p{ Is_Spacing_Mark}', "");
    Expect(0, 119154, '\p{^ Is_Spacing_Mark}', "");
    Expect(0, 119154, '\P{ Is_Spacing_Mark}', "");
    Expect(1, 119154, '\P{^ Is_Spacing_Mark}', "");
    Expect(0, 119155, '\p{ Is_Spacing_Mark}', "");
    Expect(1, 119155, '\p{^ Is_Spacing_Mark}', "");
    Expect(1, 119155, '\P{ Is_Spacing_Mark}', "");
    Expect(0, 119155, '\P{^ Is_Spacing_Mark}', "");
    Error('\p{-:=Mc}');
    Error('\P{-:=Mc}');
    Expect(1, 119154, '\p{mc}', "");
    Expect(0, 119154, '\p{^mc}', "");
    Expect(0, 119154, '\P{mc}', "");
    Expect(1, 119154, '\P{^mc}', "");
    Expect(0, 119155, '\p{mc}', "");
    Expect(1, 119155, '\p{^mc}', "");
    Expect(1, 119155, '\P{mc}', "");
    Expect(0, 119155, '\P{^mc}', "");
    Expect(1, 119154, '\p{	_MC}', "");
    Expect(0, 119154, '\p{^	_MC}', "");
    Expect(0, 119154, '\P{	_MC}', "");
    Expect(1, 119154, '\P{^	_MC}', "");
    Expect(0, 119155, '\p{	_MC}', "");
    Expect(1, 119155, '\p{^	_MC}', "");
    Expect(1, 119155, '\P{	_MC}', "");
    Expect(0, 119155, '\P{^	_MC}', "");
    Error('\p{_is_MC:=}');
    Error('\P{_is_MC:=}');
    Expect(1, 119154, '\p{ismc}', "");
    Expect(0, 119154, '\p{^ismc}', "");
    Expect(0, 119154, '\P{ismc}', "");
    Expect(1, 119154, '\P{^ismc}', "");
    Expect(0, 119155, '\p{ismc}', "");
    Expect(1, 119155, '\p{^ismc}', "");
    Expect(1, 119155, '\P{ismc}', "");
    Expect(0, 119155, '\P{^ismc}', "");
    Expect(1, 119154, '\p{-_is_mc}', "");
    Expect(0, 119154, '\p{^-_is_mc}', "");
    Expect(0, 119154, '\P{-_is_mc}', "");
    Expect(1, 119154, '\P{^-_is_mc}', "");
    Expect(0, 119155, '\p{-_is_mc}', "");
    Expect(1, 119155, '\p{^-_is_mc}', "");
    Expect(1, 119155, '\P{-_is_mc}', "");
    Expect(0, 119155, '\P{^-_is_mc}', "");
    Error('\p{-Spacing_Modifier_LETTERS:=}');
    Error('\P{-Spacing_Modifier_LETTERS:=}');
    Expect(1, 767, '\p{spacingmodifierletters}', "");
    Expect(0, 767, '\p{^spacingmodifierletters}', "");
    Expect(0, 767, '\P{spacingmodifierletters}', "");
    Expect(1, 767, '\P{^spacingmodifierletters}', "");
    Expect(0, 768, '\p{spacingmodifierletters}', "");
    Expect(1, 768, '\p{^spacingmodifierletters}', "");
    Expect(1, 768, '\P{spacingmodifierletters}', "");
    Expect(0, 768, '\P{^spacingmodifierletters}', "");
    Expect(1, 767, '\p{		SPACING_modifier_Letters}', "");
    Expect(0, 767, '\p{^		SPACING_modifier_Letters}', "");
    Expect(0, 767, '\P{		SPACING_modifier_Letters}', "");
    Expect(1, 767, '\P{^		SPACING_modifier_Letters}', "");
    Expect(0, 768, '\p{		SPACING_modifier_Letters}', "");
    Expect(1, 768, '\p{^		SPACING_modifier_Letters}', "");
    Expect(1, 768, '\P{		SPACING_modifier_Letters}', "");
    Expect(0, 768, '\P{^		SPACING_modifier_Letters}', "");
    Error('\p{--is_SPACING_Modifier_Letters/a/}');
    Error('\P{--is_SPACING_Modifier_Letters/a/}');
    Expect(1, 767, '\p{isspacingmodifierletters}', "");
    Expect(0, 767, '\p{^isspacingmodifierletters}', "");
    Expect(0, 767, '\P{isspacingmodifierletters}', "");
    Expect(1, 767, '\P{^isspacingmodifierletters}', "");
    Expect(0, 768, '\p{isspacingmodifierletters}', "");
    Expect(1, 768, '\p{^isspacingmodifierletters}', "");
    Expect(1, 768, '\P{isspacingmodifierletters}', "");
    Expect(0, 768, '\P{^isspacingmodifierletters}', "");
    Expect(1, 767, '\p{	_is_SPACING_Modifier_LETTERS}', "");
    Expect(0, 767, '\p{^	_is_SPACING_Modifier_LETTERS}', "");
    Expect(0, 767, '\P{	_is_SPACING_Modifier_LETTERS}', "");
    Expect(1, 767, '\P{^	_is_SPACING_Modifier_LETTERS}', "");
    Expect(0, 768, '\p{	_is_SPACING_Modifier_LETTERS}', "");
    Expect(1, 768, '\p{^	_is_SPACING_Modifier_LETTERS}', "");
    Expect(1, 768, '\P{	_is_SPACING_Modifier_LETTERS}', "");
    Expect(0, 768, '\P{^	_is_SPACING_Modifier_LETTERS}', "");
    Error('\p{:=_IN_spacing_Modifier_letters}');
    Error('\P{:=_IN_spacing_Modifier_letters}');
    Expect(1, 767, '\p{inspacingmodifierletters}', "");
    Expect(0, 767, '\p{^inspacingmodifierletters}', "");
    Expect(0, 767, '\P{inspacingmodifierletters}', "");
    Expect(1, 767, '\P{^inspacingmodifierletters}', "");
    Expect(0, 768, '\p{inspacingmodifierletters}', "");
    Expect(1, 768, '\p{^inspacingmodifierletters}', "");
    Expect(1, 768, '\P{inspacingmodifierletters}', "");
    Expect(0, 768, '\P{^inspacingmodifierletters}', "");
    Expect(1, 767, '\p{ In_spacing_MODIFIER_Letters}', "");
    Expect(0, 767, '\p{^ In_spacing_MODIFIER_Letters}', "");
    Expect(0, 767, '\P{ In_spacing_MODIFIER_Letters}', "");
    Expect(1, 767, '\P{^ In_spacing_MODIFIER_Letters}', "");
    Expect(0, 768, '\p{ In_spacing_MODIFIER_Letters}', "");
    Expect(1, 768, '\p{^ In_spacing_MODIFIER_Letters}', "");
    Expect(1, 768, '\P{ In_spacing_MODIFIER_Letters}', "");
    Expect(0, 768, '\P{^ In_spacing_MODIFIER_Letters}', "");
    Error('\p{:=_modifier_letters}');
    Error('\P{:=_modifier_letters}');
    Expect(1, 767, '\p{modifierletters}', "");
    Expect(0, 767, '\p{^modifierletters}', "");
    Expect(0, 767, '\P{modifierletters}', "");
    Expect(1, 767, '\P{^modifierletters}', "");
    Expect(0, 768, '\p{modifierletters}', "");
    Expect(1, 768, '\p{^modifierletters}', "");
    Expect(1, 768, '\P{modifierletters}', "");
    Expect(0, 768, '\P{^modifierletters}', "");
    Expect(1, 767, '\p{	_Modifier_Letters}', "");
    Expect(0, 767, '\p{^	_Modifier_Letters}', "");
    Expect(0, 767, '\P{	_Modifier_Letters}', "");
    Expect(1, 767, '\P{^	_Modifier_Letters}', "");
    Expect(0, 768, '\p{	_Modifier_Letters}', "");
    Expect(1, 768, '\p{^	_Modifier_Letters}', "");
    Expect(1, 768, '\P{	_Modifier_Letters}', "");
    Expect(0, 768, '\P{^	_Modifier_Letters}', "");
    Error('\p{:=is_Modifier_letters}');
    Error('\P{:=is_Modifier_letters}');
    Expect(1, 767, '\p{ismodifierletters}', "");
    Expect(0, 767, '\p{^ismodifierletters}', "");
    Expect(0, 767, '\P{ismodifierletters}', "");
    Expect(1, 767, '\P{^ismodifierletters}', "");
    Expect(0, 768, '\p{ismodifierletters}', "");
    Expect(1, 768, '\p{^ismodifierletters}', "");
    Expect(1, 768, '\P{ismodifierletters}', "");
    Expect(0, 768, '\P{^ismodifierletters}', "");
    Expect(1, 767, '\p{  IS_MODIFIER_LETTERS}', "");
    Expect(0, 767, '\p{^  IS_MODIFIER_LETTERS}', "");
    Expect(0, 767, '\P{  IS_MODIFIER_LETTERS}', "");
    Expect(1, 767, '\P{^  IS_MODIFIER_LETTERS}', "");
    Expect(0, 768, '\p{  IS_MODIFIER_LETTERS}', "");
    Expect(1, 768, '\p{^  IS_MODIFIER_LETTERS}', "");
    Expect(1, 768, '\P{  IS_MODIFIER_LETTERS}', "");
    Expect(0, 768, '\P{^  IS_MODIFIER_LETTERS}', "");
    Error('\p{:=	_In_Modifier_Letters}');
    Error('\P{:=	_In_Modifier_Letters}');
    Expect(1, 767, '\p{inmodifierletters}', "");
    Expect(0, 767, '\p{^inmodifierletters}', "");
    Expect(0, 767, '\P{inmodifierletters}', "");
    Expect(1, 767, '\P{^inmodifierletters}', "");
    Expect(0, 768, '\p{inmodifierletters}', "");
    Expect(1, 768, '\p{^inmodifierletters}', "");
    Expect(1, 768, '\P{inmodifierletters}', "");
    Expect(0, 768, '\P{^inmodifierletters}', "");
    Expect(1, 767, '\p{	 in_Modifier_Letters}', "");
    Expect(0, 767, '\p{^	 in_Modifier_Letters}', "");
    Expect(0, 767, '\P{	 in_Modifier_Letters}', "");
    Expect(1, 767, '\P{^	 in_Modifier_Letters}', "");
    Expect(0, 768, '\p{	 in_Modifier_Letters}', "");
    Expect(1, 768, '\p{^	 in_Modifier_Letters}', "");
    Expect(1, 768, '\P{	 in_Modifier_Letters}', "");
    Expect(0, 768, '\P{^	 in_Modifier_Letters}', "");
    Error('\p{_specials:=}');
    Error('\P{_specials:=}');
    Expect(1, 65520, '\p{specials}', "");
    Expect(0, 65520, '\p{^specials}', "");
    Expect(0, 65520, '\P{specials}', "");
    Expect(1, 65520, '\P{^specials}', "");
    Expect(0, 65536, '\p{specials}', "");
    Expect(1, 65536, '\p{^specials}', "");
    Expect(1, 65536, '\P{specials}', "");
    Expect(0, 65536, '\P{^specials}', "");
    Expect(1, 65520, '\p{	specials}', "");
    Expect(0, 65520, '\p{^	specials}', "");
    Expect(0, 65520, '\P{	specials}', "");
    Expect(1, 65520, '\P{^	specials}', "");
    Expect(0, 65536, '\p{	specials}', "");
    Expect(1, 65536, '\p{^	specials}', "");
    Expect(1, 65536, '\P{	specials}', "");
    Expect(0, 65536, '\P{^	specials}', "");
    Error('\p{/a/is_Specials}');
    Error('\P{/a/is_Specials}');
    Expect(1, 65520, '\p{isspecials}', "");
    Expect(0, 65520, '\p{^isspecials}', "");
    Expect(0, 65520, '\P{isspecials}', "");
    Expect(1, 65520, '\P{^isspecials}', "");
    Expect(0, 65536, '\p{isspecials}', "");
    Expect(1, 65536, '\p{^isspecials}', "");
    Expect(1, 65536, '\P{isspecials}', "");
    Expect(0, 65536, '\P{^isspecials}', "");
    Expect(1, 65520, '\p{		IS_specials}', "");
    Expect(0, 65520, '\p{^		IS_specials}', "");
    Expect(0, 65520, '\P{		IS_specials}', "");
    Expect(1, 65520, '\P{^		IS_specials}', "");
    Expect(0, 65536, '\p{		IS_specials}', "");
    Expect(1, 65536, '\p{^		IS_specials}', "");
    Expect(1, 65536, '\P{		IS_specials}', "");
    Expect(0, 65536, '\P{^		IS_specials}', "");
    Error('\p{	_In_Specials/a/}');
    Error('\P{	_In_Specials/a/}');
    Expect(1, 65520, '\p{inspecials}', "");
    Expect(0, 65520, '\p{^inspecials}', "");
    Expect(0, 65520, '\P{inspecials}', "");
    Expect(1, 65520, '\P{^inspecials}', "");
    Expect(0, 65536, '\p{inspecials}', "");
    Expect(1, 65536, '\p{^inspecials}', "");
    Expect(1, 65536, '\P{inspecials}', "");
    Expect(0, 65536, '\P{^inspecials}', "");
    Expect(1, 65520, '\p{	-IN_Specials}', "");
    Expect(0, 65520, '\p{^	-IN_Specials}', "");
    Expect(0, 65520, '\P{	-IN_Specials}', "");
    Expect(1, 65520, '\P{^	-IN_Specials}', "");
    Expect(0, 65536, '\p{	-IN_Specials}', "");
    Expect(1, 65536, '\p{^	-IN_Specials}', "");
    Expect(1, 65536, '\P{	-IN_Specials}', "");
    Expect(0, 65536, '\P{^	-IN_Specials}', "");
    Error('\p{_:=Sundanese}');
    Error('\P{_:=Sundanese}');
    Expect(1, 7367, '\p{sundanese}', "");
    Expect(0, 7367, '\p{^sundanese}', "");
    Expect(0, 7367, '\P{sundanese}', "");
    Expect(1, 7367, '\P{^sundanese}', "");
    Expect(0, 7368, '\p{sundanese}', "");
    Expect(1, 7368, '\p{^sundanese}', "");
    Expect(1, 7368, '\P{sundanese}', "");
    Expect(0, 7368, '\P{^sundanese}', "");
    Expect(1, 7367, '\p{_ Sundanese}', "");
    Expect(0, 7367, '\p{^_ Sundanese}', "");
    Expect(0, 7367, '\P{_ Sundanese}', "");
    Expect(1, 7367, '\P{^_ Sundanese}', "");
    Expect(0, 7368, '\p{_ Sundanese}', "");
    Expect(1, 7368, '\p{^_ Sundanese}', "");
    Expect(1, 7368, '\P{_ Sundanese}', "");
    Expect(0, 7368, '\P{^_ Sundanese}', "");
    Error('\p{-_IS_sundanese/a/}');
    Error('\P{-_IS_sundanese/a/}');
    Expect(1, 7367, '\p{issundanese}', "");
    Expect(0, 7367, '\p{^issundanese}', "");
    Expect(0, 7367, '\P{issundanese}', "");
    Expect(1, 7367, '\P{^issundanese}', "");
    Expect(0, 7368, '\p{issundanese}', "");
    Expect(1, 7368, '\p{^issundanese}', "");
    Expect(1, 7368, '\P{issundanese}', "");
    Expect(0, 7368, '\P{^issundanese}', "");
    Expect(1, 7367, '\p{ 	Is_Sundanese}', "");
    Expect(0, 7367, '\p{^ 	Is_Sundanese}', "");
    Expect(0, 7367, '\P{ 	Is_Sundanese}', "");
    Expect(1, 7367, '\P{^ 	Is_Sundanese}', "");
    Expect(0, 7368, '\p{ 	Is_Sundanese}', "");
    Expect(1, 7368, '\p{^ 	Is_Sundanese}', "");
    Expect(1, 7368, '\P{ 	Is_Sundanese}', "");
    Expect(0, 7368, '\P{^ 	Is_Sundanese}', "");
    Error('\p{_-Sund/a/}');
    Error('\P{_-Sund/a/}');
    Expect(1, 7367, '\p{sund}', "");
    Expect(0, 7367, '\p{^sund}', "");
    Expect(0, 7367, '\P{sund}', "");
    Expect(1, 7367, '\P{^sund}', "");
    Expect(0, 7368, '\p{sund}', "");
    Expect(1, 7368, '\p{^sund}', "");
    Expect(1, 7368, '\P{sund}', "");
    Expect(0, 7368, '\P{^sund}', "");
    Expect(1, 7367, '\p{ -Sund}', "");
    Expect(0, 7367, '\p{^ -Sund}', "");
    Expect(0, 7367, '\P{ -Sund}', "");
    Expect(1, 7367, '\P{^ -Sund}', "");
    Expect(0, 7368, '\p{ -Sund}', "");
    Expect(1, 7368, '\p{^ -Sund}', "");
    Expect(1, 7368, '\P{ -Sund}', "");
    Expect(0, 7368, '\P{^ -Sund}', "");
    Error('\p{-_Is_Sund/a/}');
    Error('\P{-_Is_Sund/a/}');
    Expect(1, 7367, '\p{issund}', "");
    Expect(0, 7367, '\p{^issund}', "");
    Expect(0, 7367, '\P{issund}', "");
    Expect(1, 7367, '\P{^issund}', "");
    Expect(0, 7368, '\p{issund}', "");
    Expect(1, 7368, '\p{^issund}', "");
    Expect(1, 7368, '\P{issund}', "");
    Expect(0, 7368, '\P{^issund}', "");
    Expect(1, 7367, '\p{_is_Sund}', "");
    Expect(0, 7367, '\p{^_is_Sund}', "");
    Expect(0, 7367, '\P{_is_Sund}', "");
    Expect(1, 7367, '\P{^_is_Sund}', "");
    Expect(0, 7368, '\p{_is_Sund}', "");
    Expect(1, 7368, '\p{^_is_Sund}', "");
    Expect(1, 7368, '\P{_is_Sund}', "");
    Expect(0, 7368, '\P{^_is_Sund}', "");
    Error('\p{/a/__Sundanese_Supplement}');
    Error('\P{/a/__Sundanese_Supplement}');
    Expect(1, 7375, '\p{sundanesesupplement}', "");
    Expect(0, 7375, '\p{^sundanesesupplement}', "");
    Expect(0, 7375, '\P{sundanesesupplement}', "");
    Expect(1, 7375, '\P{^sundanesesupplement}', "");
    Expect(0, 7376, '\p{sundanesesupplement}', "");
    Expect(1, 7376, '\p{^sundanesesupplement}', "");
    Expect(1, 7376, '\P{sundanesesupplement}', "");
    Expect(0, 7376, '\P{^sundanesesupplement}', "");
    Expect(1, 7375, '\p{__Sundanese_supplement}', "");
    Expect(0, 7375, '\p{^__Sundanese_supplement}', "");
    Expect(0, 7375, '\P{__Sundanese_supplement}', "");
    Expect(1, 7375, '\P{^__Sundanese_supplement}', "");
    Expect(0, 7376, '\p{__Sundanese_supplement}', "");
    Expect(1, 7376, '\p{^__Sundanese_supplement}', "");
    Expect(1, 7376, '\P{__Sundanese_supplement}', "");
    Expect(0, 7376, '\P{^__Sundanese_supplement}', "");
    Error('\p{/a/	_is_sundanese_Supplement}');
    Error('\P{/a/	_is_sundanese_Supplement}');
    Expect(1, 7375, '\p{issundanesesupplement}', "");
    Expect(0, 7375, '\p{^issundanesesupplement}', "");
    Expect(0, 7375, '\P{issundanesesupplement}', "");
    Expect(1, 7375, '\P{^issundanesesupplement}', "");
    Expect(0, 7376, '\p{issundanesesupplement}', "");
    Expect(1, 7376, '\p{^issundanesesupplement}', "");
    Expect(1, 7376, '\P{issundanesesupplement}', "");
    Expect(0, 7376, '\P{^issundanesesupplement}', "");
    Expect(1, 7375, '\p{	-IS_Sundanese_Supplement}', "");
    Expect(0, 7375, '\p{^	-IS_Sundanese_Supplement}', "");
    Expect(0, 7375, '\P{	-IS_Sundanese_Supplement}', "");
    Expect(1, 7375, '\P{^	-IS_Sundanese_Supplement}', "");
    Expect(0, 7376, '\p{	-IS_Sundanese_Supplement}', "");
    Expect(1, 7376, '\p{^	-IS_Sundanese_Supplement}', "");
    Expect(1, 7376, '\P{	-IS_Sundanese_Supplement}', "");
    Expect(0, 7376, '\P{^	-IS_Sundanese_Supplement}', "");
    Error('\p{	/a/In_SUNDANESE_supplement}');
    Error('\P{	/a/In_SUNDANESE_supplement}');
    Expect(1, 7375, '\p{insundanesesupplement}', "");
    Expect(0, 7375, '\p{^insundanesesupplement}', "");
    Expect(0, 7375, '\P{insundanesesupplement}', "");
    Expect(1, 7375, '\P{^insundanesesupplement}', "");
    Expect(0, 7376, '\p{insundanesesupplement}', "");
    Expect(1, 7376, '\p{^insundanesesupplement}', "");
    Expect(1, 7376, '\P{insundanesesupplement}', "");
    Expect(0, 7376, '\P{^insundanesesupplement}', "");
    Expect(1, 7375, '\p{_	In_sundanese_Supplement}', "");
    Expect(0, 7375, '\p{^_	In_sundanese_Supplement}', "");
    Expect(0, 7375, '\P{_	In_sundanese_Supplement}', "");
    Expect(1, 7375, '\P{^_	In_sundanese_Supplement}', "");
    Expect(0, 7376, '\p{_	In_sundanese_Supplement}', "");
    Expect(1, 7376, '\p{^_	In_sundanese_Supplement}', "");
    Expect(1, 7376, '\P{_	In_sundanese_Supplement}', "");
    Expect(0, 7376, '\P{^_	In_sundanese_Supplement}', "");
    Error('\p{/a/Sundanese_SUP}');
    Error('\P{/a/Sundanese_SUP}');
    Expect(1, 7375, '\p{sundanesesup}', "");
    Expect(0, 7375, '\p{^sundanesesup}', "");
    Expect(0, 7375, '\P{sundanesesup}', "");
    Expect(1, 7375, '\P{^sundanesesup}', "");
    Expect(0, 7376, '\p{sundanesesup}', "");
    Expect(1, 7376, '\p{^sundanesesup}', "");
    Expect(1, 7376, '\P{sundanesesup}', "");
    Expect(0, 7376, '\P{^sundanesesup}', "");
    Expect(1, 7375, '\p{_Sundanese_Sup}', "");
    Expect(0, 7375, '\p{^_Sundanese_Sup}', "");
    Expect(0, 7375, '\P{_Sundanese_Sup}', "");
    Expect(1, 7375, '\P{^_Sundanese_Sup}', "");
    Expect(0, 7376, '\p{_Sundanese_Sup}', "");
    Expect(1, 7376, '\p{^_Sundanese_Sup}', "");
    Expect(1, 7376, '\P{_Sundanese_Sup}', "");
    Expect(0, 7376, '\P{^_Sundanese_Sup}', "");
    Error('\p{/a/ _Is_Sundanese_sup}');
    Error('\P{/a/ _Is_Sundanese_sup}');
    Expect(1, 7375, '\p{issundanesesup}', "");
    Expect(0, 7375, '\p{^issundanesesup}', "");
    Expect(0, 7375, '\P{issundanesesup}', "");
    Expect(1, 7375, '\P{^issundanesesup}', "");
    Expect(0, 7376, '\p{issundanesesup}', "");
    Expect(1, 7376, '\p{^issundanesesup}', "");
    Expect(1, 7376, '\P{issundanesesup}', "");
    Expect(0, 7376, '\P{^issundanesesup}', "");
    Expect(1, 7375, '\p{_Is_sundanese_Sup}', "");
    Expect(0, 7375, '\p{^_Is_sundanese_Sup}', "");
    Expect(0, 7375, '\P{_Is_sundanese_Sup}', "");
    Expect(1, 7375, '\P{^_Is_sundanese_Sup}', "");
    Expect(0, 7376, '\p{_Is_sundanese_Sup}', "");
    Expect(1, 7376, '\p{^_Is_sundanese_Sup}', "");
    Expect(1, 7376, '\P{_Is_sundanese_Sup}', "");
    Expect(0, 7376, '\P{^_Is_sundanese_Sup}', "");
    Error('\p{	/a/In_Sundanese_Sup}');
    Error('\P{	/a/In_Sundanese_Sup}');
    Expect(1, 7375, '\p{insundanesesup}', "");
    Expect(0, 7375, '\p{^insundanesesup}', "");
    Expect(0, 7375, '\P{insundanesesup}', "");
    Expect(1, 7375, '\P{^insundanesesup}', "");
    Expect(0, 7376, '\p{insundanesesup}', "");
    Expect(1, 7376, '\p{^insundanesesup}', "");
    Expect(1, 7376, '\P{insundanesesup}', "");
    Expect(0, 7376, '\P{^insundanesesup}', "");
    Expect(1, 7375, '\p{-	IN_Sundanese_Sup}', "");
    Expect(0, 7375, '\p{^-	IN_Sundanese_Sup}', "");
    Expect(0, 7375, '\P{-	IN_Sundanese_Sup}', "");
    Expect(1, 7375, '\P{^-	IN_Sundanese_Sup}', "");
    Expect(0, 7376, '\p{-	IN_Sundanese_Sup}', "");
    Expect(1, 7376, '\p{^-	IN_Sundanese_Sup}', "");
    Expect(1, 7376, '\P{-	IN_Sundanese_Sup}', "");
    Expect(0, 7376, '\P{^-	IN_Sundanese_Sup}', "");
    Error('\p{_:=Superscripts_AND_Subscripts}');
    Error('\P{_:=Superscripts_AND_Subscripts}');
    Expect(1, 8351, '\p{superscriptsandsubscripts}', "");
    Expect(0, 8351, '\p{^superscriptsandsubscripts}', "");
    Expect(0, 8351, '\P{superscriptsandsubscripts}', "");
    Expect(1, 8351, '\P{^superscriptsandsubscripts}', "");
    Expect(0, 8352, '\p{superscriptsandsubscripts}', "");
    Expect(1, 8352, '\p{^superscriptsandsubscripts}', "");
    Expect(1, 8352, '\P{superscriptsandsubscripts}', "");
    Expect(0, 8352, '\P{^superscriptsandsubscripts}', "");
    Expect(1, 8351, '\p{_	superscripts_and_SUBSCRIPTS}', "");
    Expect(0, 8351, '\p{^_	superscripts_and_SUBSCRIPTS}', "");
    Expect(0, 8351, '\P{_	superscripts_and_SUBSCRIPTS}', "");
    Expect(1, 8351, '\P{^_	superscripts_and_SUBSCRIPTS}', "");
    Expect(0, 8352, '\p{_	superscripts_and_SUBSCRIPTS}', "");
    Expect(1, 8352, '\p{^_	superscripts_and_SUBSCRIPTS}', "");
    Expect(1, 8352, '\P{_	superscripts_and_SUBSCRIPTS}', "");
    Expect(0, 8352, '\P{^_	superscripts_and_SUBSCRIPTS}', "");
    Error('\p{:=_IS_Superscripts_and_Subscripts}');
    Error('\P{:=_IS_Superscripts_and_Subscripts}');
    Expect(1, 8351, '\p{issuperscriptsandsubscripts}', "");
    Expect(0, 8351, '\p{^issuperscriptsandsubscripts}', "");
    Expect(0, 8351, '\P{issuperscriptsandsubscripts}', "");
    Expect(1, 8351, '\P{^issuperscriptsandsubscripts}', "");
    Expect(0, 8352, '\p{issuperscriptsandsubscripts}', "");
    Expect(1, 8352, '\p{^issuperscriptsandsubscripts}', "");
    Expect(1, 8352, '\P{issuperscriptsandsubscripts}', "");
    Expect(0, 8352, '\P{^issuperscriptsandsubscripts}', "");
    Expect(1, 8351, '\p{	-is_superscripts_And_Subscripts}', "");
    Expect(0, 8351, '\p{^	-is_superscripts_And_Subscripts}', "");
    Expect(0, 8351, '\P{	-is_superscripts_And_Subscripts}', "");
    Expect(1, 8351, '\P{^	-is_superscripts_And_Subscripts}', "");
    Expect(0, 8352, '\p{	-is_superscripts_And_Subscripts}', "");
    Expect(1, 8352, '\p{^	-is_superscripts_And_Subscripts}', "");
    Expect(1, 8352, '\P{	-is_superscripts_And_Subscripts}', "");
    Expect(0, 8352, '\P{^	-is_superscripts_And_Subscripts}', "");
    Error('\p{ :=IN_superscripts_and_Subscripts}');
    Error('\P{ :=IN_superscripts_and_Subscripts}');
    Expect(1, 8351, '\p{insuperscriptsandsubscripts}', "");
    Expect(0, 8351, '\p{^insuperscriptsandsubscripts}', "");
    Expect(0, 8351, '\P{insuperscriptsandsubscripts}', "");
    Expect(1, 8351, '\P{^insuperscriptsandsubscripts}', "");
    Expect(0, 8352, '\p{insuperscriptsandsubscripts}', "");
    Expect(1, 8352, '\p{^insuperscriptsandsubscripts}', "");
    Expect(1, 8352, '\P{insuperscriptsandsubscripts}', "");
    Expect(0, 8352, '\P{^insuperscriptsandsubscripts}', "");
    Expect(1, 8351, '\p{		In_superscripts_And_SUBSCRIPTS}', "");
    Expect(0, 8351, '\p{^		In_superscripts_And_SUBSCRIPTS}', "");
    Expect(0, 8351, '\P{		In_superscripts_And_SUBSCRIPTS}', "");
    Expect(1, 8351, '\P{^		In_superscripts_And_SUBSCRIPTS}', "");
    Expect(0, 8352, '\p{		In_superscripts_And_SUBSCRIPTS}', "");
    Expect(1, 8352, '\p{^		In_superscripts_And_SUBSCRIPTS}', "");
    Expect(1, 8352, '\P{		In_superscripts_And_SUBSCRIPTS}', "");
    Expect(0, 8352, '\P{^		In_superscripts_And_SUBSCRIPTS}', "");
    Error('\p{:=--Super_AND_sub}');
    Error('\P{:=--Super_AND_sub}');
    Expect(1, 8351, '\p{superandsub}', "");
    Expect(0, 8351, '\p{^superandsub}', "");
    Expect(0, 8351, '\P{superandsub}', "");
    Expect(1, 8351, '\P{^superandsub}', "");
    Expect(0, 8352, '\p{superandsub}', "");
    Expect(1, 8352, '\p{^superandsub}', "");
    Expect(1, 8352, '\P{superandsub}', "");
    Expect(0, 8352, '\P{^superandsub}', "");
    Expect(1, 8351, '\p{	 SUPER_AND_SUB}', "");
    Expect(0, 8351, '\p{^	 SUPER_AND_SUB}', "");
    Expect(0, 8351, '\P{	 SUPER_AND_SUB}', "");
    Expect(1, 8351, '\P{^	 SUPER_AND_SUB}', "");
    Expect(0, 8352, '\p{	 SUPER_AND_SUB}', "");
    Expect(1, 8352, '\p{^	 SUPER_AND_SUB}', "");
    Expect(1, 8352, '\P{	 SUPER_AND_SUB}', "");
    Expect(0, 8352, '\P{^	 SUPER_AND_SUB}', "");
    Error('\p{:=is_SUPER_And_SUB}');
    Error('\P{:=is_SUPER_And_SUB}');
    Expect(1, 8351, '\p{issuperandsub}', "");
    Expect(0, 8351, '\p{^issuperandsub}', "");
    Expect(0, 8351, '\P{issuperandsub}', "");
    Expect(1, 8351, '\P{^issuperandsub}', "");
    Expect(0, 8352, '\p{issuperandsub}', "");
    Expect(1, 8352, '\p{^issuperandsub}', "");
    Expect(1, 8352, '\P{issuperandsub}', "");
    Expect(0, 8352, '\P{^issuperandsub}', "");
    Expect(1, 8351, '\p{	-is_Super_AND_sub}', "");
    Expect(0, 8351, '\p{^	-is_Super_AND_sub}', "");
    Expect(0, 8351, '\P{	-is_Super_AND_sub}', "");
    Expect(1, 8351, '\P{^	-is_Super_AND_sub}', "");
    Expect(0, 8352, '\p{	-is_Super_AND_sub}', "");
    Expect(1, 8352, '\p{^	-is_Super_AND_sub}', "");
    Expect(1, 8352, '\P{	-is_Super_AND_sub}', "");
    Expect(0, 8352, '\P{^	-is_Super_AND_sub}', "");
    Error('\p{/a/ _IN_Super_and_Sub}');
    Error('\P{/a/ _IN_Super_and_Sub}');
    Expect(1, 8351, '\p{insuperandsub}', "");
    Expect(0, 8351, '\p{^insuperandsub}', "");
    Expect(0, 8351, '\P{insuperandsub}', "");
    Expect(1, 8351, '\P{^insuperandsub}', "");
    Expect(0, 8352, '\p{insuperandsub}', "");
    Expect(1, 8352, '\p{^insuperandsub}', "");
    Expect(1, 8352, '\P{insuperandsub}', "");
    Expect(0, 8352, '\P{^insuperandsub}', "");
    Expect(1, 8351, '\p{ _in_SUPER_and_SUB}', "");
    Expect(0, 8351, '\p{^ _in_SUPER_and_SUB}', "");
    Expect(0, 8351, '\P{ _in_SUPER_and_SUB}', "");
    Expect(1, 8351, '\P{^ _in_SUPER_and_SUB}', "");
    Expect(0, 8352, '\p{ _in_SUPER_and_SUB}', "");
    Expect(1, 8352, '\p{^ _in_SUPER_and_SUB}', "");
    Expect(1, 8352, '\P{ _in_SUPER_and_SUB}', "");
    Expect(0, 8352, '\P{^ _in_SUPER_and_SUB}', "");
    Error('\p{_/a/Supplemental_ARROWS_A}');
    Error('\P{_/a/Supplemental_ARROWS_A}');
    Expect(1, 10239, '\p{supplementalarrowsa}', "");
    Expect(0, 10239, '\p{^supplementalarrowsa}', "");
    Expect(0, 10239, '\P{supplementalarrowsa}', "");
    Expect(1, 10239, '\P{^supplementalarrowsa}', "");
    Expect(0, 10240, '\p{supplementalarrowsa}', "");
    Expect(1, 10240, '\p{^supplementalarrowsa}', "");
    Expect(1, 10240, '\P{supplementalarrowsa}', "");
    Expect(0, 10240, '\P{^supplementalarrowsa}', "");
    Expect(1, 10239, '\p{_-Supplemental_Arrows_A}', "");
    Expect(0, 10239, '\p{^_-Supplemental_Arrows_A}', "");
    Expect(0, 10239, '\P{_-Supplemental_Arrows_A}', "");
    Expect(1, 10239, '\P{^_-Supplemental_Arrows_A}', "");
    Expect(0, 10240, '\p{_-Supplemental_Arrows_A}', "");
    Expect(1, 10240, '\p{^_-Supplemental_Arrows_A}', "");
    Expect(1, 10240, '\P{_-Supplemental_Arrows_A}', "");
    Expect(0, 10240, '\P{^_-Supplemental_Arrows_A}', "");
    Error('\p{/a/ 	Is_supplemental_Arrows_A}');
    Error('\P{/a/ 	Is_supplemental_Arrows_A}');
    Expect(1, 10239, '\p{issupplementalarrowsa}', "");
    Expect(0, 10239, '\p{^issupplementalarrowsa}', "");
    Expect(0, 10239, '\P{issupplementalarrowsa}', "");
    Expect(1, 10239, '\P{^issupplementalarrowsa}', "");
    Expect(0, 10240, '\p{issupplementalarrowsa}', "");
    Expect(1, 10240, '\p{^issupplementalarrowsa}', "");
    Expect(1, 10240, '\P{issupplementalarrowsa}', "");
    Expect(0, 10240, '\P{^issupplementalarrowsa}', "");
    Expect(1, 10239, '\p{-Is_Supplemental_ARROWS_a}', "");
    Expect(0, 10239, '\p{^-Is_Supplemental_ARROWS_a}', "");
    Expect(0, 10239, '\P{-Is_Supplemental_ARROWS_a}', "");
    Expect(1, 10239, '\P{^-Is_Supplemental_ARROWS_a}', "");
    Expect(0, 10240, '\p{-Is_Supplemental_ARROWS_a}', "");
    Expect(1, 10240, '\p{^-Is_Supplemental_ARROWS_a}', "");
    Expect(1, 10240, '\P{-Is_Supplemental_ARROWS_a}', "");
    Expect(0, 10240, '\P{^-Is_Supplemental_ARROWS_a}', "");
    Error('\p{_-IN_supplemental_arrows_A/a/}');
    Error('\P{_-IN_supplemental_arrows_A/a/}');
    Expect(1, 10239, '\p{insupplementalarrowsa}', "");
    Expect(0, 10239, '\p{^insupplementalarrowsa}', "");
    Expect(0, 10239, '\P{insupplementalarrowsa}', "");
    Expect(1, 10239, '\P{^insupplementalarrowsa}', "");
    Expect(0, 10240, '\p{insupplementalarrowsa}', "");
    Expect(1, 10240, '\p{^insupplementalarrowsa}', "");
    Expect(1, 10240, '\P{insupplementalarrowsa}', "");
    Expect(0, 10240, '\P{^insupplementalarrowsa}', "");
    Expect(1, 10239, '\p{_-in_SUPPLEMENTAL_Arrows_A}', "");
    Expect(0, 10239, '\p{^_-in_SUPPLEMENTAL_Arrows_A}', "");
    Expect(0, 10239, '\P{_-in_SUPPLEMENTAL_Arrows_A}', "");
    Expect(1, 10239, '\P{^_-in_SUPPLEMENTAL_Arrows_A}', "");
    Expect(0, 10240, '\p{_-in_SUPPLEMENTAL_Arrows_A}', "");
    Expect(1, 10240, '\p{^_-in_SUPPLEMENTAL_Arrows_A}', "");
    Expect(1, 10240, '\P{_-in_SUPPLEMENTAL_Arrows_A}', "");
    Expect(0, 10240, '\P{^_-in_SUPPLEMENTAL_Arrows_A}', "");
    Error('\p{ 	SUP_Arrows_A/a/}');
    Error('\P{ 	SUP_Arrows_A/a/}');
    Expect(1, 10239, '\p{suparrowsa}', "");
    Expect(0, 10239, '\p{^suparrowsa}', "");
    Expect(0, 10239, '\P{suparrowsa}', "");
    Expect(1, 10239, '\P{^suparrowsa}', "");
    Expect(0, 10240, '\p{suparrowsa}', "");
    Expect(1, 10240, '\p{^suparrowsa}', "");
    Expect(1, 10240, '\P{suparrowsa}', "");
    Expect(0, 10240, '\P{^suparrowsa}', "");
    Expect(1, 10239, '\p{-Sup_ARROWS_a}', "");
    Expect(0, 10239, '\p{^-Sup_ARROWS_a}', "");
    Expect(0, 10239, '\P{-Sup_ARROWS_a}', "");
    Expect(1, 10239, '\P{^-Sup_ARROWS_a}', "");
    Expect(0, 10240, '\p{-Sup_ARROWS_a}', "");
    Expect(1, 10240, '\p{^-Sup_ARROWS_a}', "");
    Expect(1, 10240, '\P{-Sup_ARROWS_a}', "");
    Expect(0, 10240, '\P{^-Sup_ARROWS_a}', "");
    Error('\p{:=_ Is_SUP_ARROWS_A}');
    Error('\P{:=_ Is_SUP_ARROWS_A}');
    Expect(1, 10239, '\p{issuparrowsa}', "");
    Expect(0, 10239, '\p{^issuparrowsa}', "");
    Expect(0, 10239, '\P{issuparrowsa}', "");
    Expect(1, 10239, '\P{^issuparrowsa}', "");
    Expect(0, 10240, '\p{issuparrowsa}', "");
    Expect(1, 10240, '\p{^issuparrowsa}', "");
    Expect(1, 10240, '\P{issuparrowsa}', "");
    Expect(0, 10240, '\P{^issuparrowsa}', "");
    Expect(1, 10239, '\p{  is_Sup_arrows_A}', "");
    Expect(0, 10239, '\p{^  is_Sup_arrows_A}', "");
    Expect(0, 10239, '\P{  is_Sup_arrows_A}', "");
    Expect(1, 10239, '\P{^  is_Sup_arrows_A}', "");
    Expect(0, 10240, '\p{  is_Sup_arrows_A}', "");
    Expect(1, 10240, '\p{^  is_Sup_arrows_A}', "");
    Expect(1, 10240, '\P{  is_Sup_arrows_A}', "");
    Expect(0, 10240, '\P{^  is_Sup_arrows_A}', "");
    Error('\p{/a/	_In_sup_arrows_A}');
    Error('\P{/a/	_In_sup_arrows_A}');
    Expect(1, 10239, '\p{insuparrowsa}', "");
    Expect(0, 10239, '\p{^insuparrowsa}', "");
    Expect(0, 10239, '\P{insuparrowsa}', "");
    Expect(1, 10239, '\P{^insuparrowsa}', "");
    Expect(0, 10240, '\p{insuparrowsa}', "");
    Expect(1, 10240, '\p{^insuparrowsa}', "");
    Expect(1, 10240, '\P{insuparrowsa}', "");
    Expect(0, 10240, '\P{^insuparrowsa}', "");
    Expect(1, 10239, '\p{	-in_Sup_Arrows_A}', "");
    Expect(0, 10239, '\p{^	-in_Sup_Arrows_A}', "");
    Expect(0, 10239, '\P{	-in_Sup_Arrows_A}', "");
    Expect(1, 10239, '\P{^	-in_Sup_Arrows_A}', "");
    Expect(0, 10240, '\p{	-in_Sup_Arrows_A}', "");
    Expect(1, 10240, '\p{^	-in_Sup_Arrows_A}', "");
    Expect(1, 10240, '\P{	-in_Sup_Arrows_A}', "");
    Expect(0, 10240, '\P{^	-in_Sup_Arrows_A}', "");
    Error('\p{-	Supplemental_Arrows_B:=}');
    Error('\P{-	Supplemental_Arrows_B:=}');
    Expect(1, 10623, '\p{supplementalarrowsb}', "");
    Expect(0, 10623, '\p{^supplementalarrowsb}', "");
    Expect(0, 10623, '\P{supplementalarrowsb}', "");
    Expect(1, 10623, '\P{^supplementalarrowsb}', "");
    Expect(0, 10624, '\p{supplementalarrowsb}', "");
    Expect(1, 10624, '\p{^supplementalarrowsb}', "");
    Expect(1, 10624, '\P{supplementalarrowsb}', "");
    Expect(0, 10624, '\P{^supplementalarrowsb}', "");
    Expect(1, 10623, '\p{--Supplemental_arrows_B}', "");
    Expect(0, 10623, '\p{^--Supplemental_arrows_B}', "");
    Expect(0, 10623, '\P{--Supplemental_arrows_B}', "");
    Expect(1, 10623, '\P{^--Supplemental_arrows_B}', "");
    Expect(0, 10624, '\p{--Supplemental_arrows_B}', "");
    Expect(1, 10624, '\p{^--Supplemental_arrows_B}', "");
    Expect(1, 10624, '\P{--Supplemental_arrows_B}', "");
    Expect(0, 10624, '\P{^--Supplemental_arrows_B}', "");
    Error('\p{/a/IS_SUPPLEMENTAL_arrows_b}');
    Error('\P{/a/IS_SUPPLEMENTAL_arrows_b}');
    Expect(1, 10623, '\p{issupplementalarrowsb}', "");
    Expect(0, 10623, '\p{^issupplementalarrowsb}', "");
    Expect(0, 10623, '\P{issupplementalarrowsb}', "");
    Expect(1, 10623, '\P{^issupplementalarrowsb}', "");
    Expect(0, 10624, '\p{issupplementalarrowsb}', "");
    Expect(1, 10624, '\p{^issupplementalarrowsb}', "");
    Expect(1, 10624, '\P{issupplementalarrowsb}', "");
    Expect(0, 10624, '\P{^issupplementalarrowsb}', "");
    Expect(1, 10623, '\p{	-Is_supplemental_Arrows_b}', "");
    Expect(0, 10623, '\p{^	-Is_supplemental_Arrows_b}', "");
    Expect(0, 10623, '\P{	-Is_supplemental_Arrows_b}', "");
    Expect(1, 10623, '\P{^	-Is_supplemental_Arrows_b}', "");
    Expect(0, 10624, '\p{	-Is_supplemental_Arrows_b}', "");
    Expect(1, 10624, '\p{^	-Is_supplemental_Arrows_b}', "");
    Expect(1, 10624, '\P{	-Is_supplemental_Arrows_b}', "");
    Expect(0, 10624, '\P{^	-Is_supplemental_Arrows_b}', "");
    Error('\p{ :=In_supplemental_Arrows_B}');
    Error('\P{ :=In_supplemental_Arrows_B}');
    Expect(1, 10623, '\p{insupplementalarrowsb}', "");
    Expect(0, 10623, '\p{^insupplementalarrowsb}', "");
    Expect(0, 10623, '\P{insupplementalarrowsb}', "");
    Expect(1, 10623, '\P{^insupplementalarrowsb}', "");
    Expect(0, 10624, '\p{insupplementalarrowsb}', "");
    Expect(1, 10624, '\p{^insupplementalarrowsb}', "");
    Expect(1, 10624, '\P{insupplementalarrowsb}', "");
    Expect(0, 10624, '\P{^insupplementalarrowsb}', "");
    Expect(1, 10623, '\p{ -IN_Supplemental_arrows_b}', "");
    Expect(0, 10623, '\p{^ -IN_Supplemental_arrows_b}', "");
    Expect(0, 10623, '\P{ -IN_Supplemental_arrows_b}', "");
    Expect(1, 10623, '\P{^ -IN_Supplemental_arrows_b}', "");
    Expect(0, 10624, '\p{ -IN_Supplemental_arrows_b}', "");
    Expect(1, 10624, '\p{^ -IN_Supplemental_arrows_b}', "");
    Expect(1, 10624, '\P{ -IN_Supplemental_arrows_b}', "");
    Expect(0, 10624, '\P{^ -IN_Supplemental_arrows_b}', "");
    Error('\p{/a/SUP_arrows_B}');
    Error('\P{/a/SUP_arrows_B}');
    Expect(1, 10623, '\p{suparrowsb}', "");
    Expect(0, 10623, '\p{^suparrowsb}', "");
    Expect(0, 10623, '\P{suparrowsb}', "");
    Expect(1, 10623, '\P{^suparrowsb}', "");
    Expect(0, 10624, '\p{suparrowsb}', "");
    Expect(1, 10624, '\p{^suparrowsb}', "");
    Expect(1, 10624, '\P{suparrowsb}', "");
    Expect(0, 10624, '\P{^suparrowsb}', "");
    Expect(1, 10623, '\p{	-Sup_arrows_B}', "");
    Expect(0, 10623, '\p{^	-Sup_arrows_B}', "");
    Expect(0, 10623, '\P{	-Sup_arrows_B}', "");
    Expect(1, 10623, '\P{^	-Sup_arrows_B}', "");
    Expect(0, 10624, '\p{	-Sup_arrows_B}', "");
    Expect(1, 10624, '\p{^	-Sup_arrows_B}', "");
    Expect(1, 10624, '\P{	-Sup_arrows_B}', "");
    Expect(0, 10624, '\P{^	-Sup_arrows_B}', "");
    Error('\p{/a/	is_Sup_Arrows_B}');
    Error('\P{/a/	is_Sup_Arrows_B}');
    Expect(1, 10623, '\p{issuparrowsb}', "");
    Expect(0, 10623, '\p{^issuparrowsb}', "");
    Expect(0, 10623, '\P{issuparrowsb}', "");
    Expect(1, 10623, '\P{^issuparrowsb}', "");
    Expect(0, 10624, '\p{issuparrowsb}', "");
    Expect(1, 10624, '\p{^issuparrowsb}', "");
    Expect(1, 10624, '\P{issuparrowsb}', "");
    Expect(0, 10624, '\P{^issuparrowsb}', "");
    Expect(1, 10623, '\p{ Is_sup_Arrows_b}', "");
    Expect(0, 10623, '\p{^ Is_sup_Arrows_b}', "");
    Expect(0, 10623, '\P{ Is_sup_Arrows_b}', "");
    Expect(1, 10623, '\P{^ Is_sup_Arrows_b}', "");
    Expect(0, 10624, '\p{ Is_sup_Arrows_b}', "");
    Expect(1, 10624, '\p{^ Is_sup_Arrows_b}', "");
    Expect(1, 10624, '\P{ Is_sup_Arrows_b}', "");
    Expect(0, 10624, '\P{^ Is_sup_Arrows_b}', "");
    Error('\p{	/a/in_sup_Arrows_B}');
    Error('\P{	/a/in_sup_Arrows_B}');
    Expect(1, 10623, '\p{insuparrowsb}', "");
    Expect(0, 10623, '\p{^insuparrowsb}', "");
    Expect(0, 10623, '\P{insuparrowsb}', "");
    Expect(1, 10623, '\P{^insuparrowsb}', "");
    Expect(0, 10624, '\p{insuparrowsb}', "");
    Expect(1, 10624, '\p{^insuparrowsb}', "");
    Expect(1, 10624, '\P{insuparrowsb}', "");
    Expect(0, 10624, '\P{^insuparrowsb}', "");
    Expect(1, 10623, '\p{_-In_SUP_arrows_B}', "");
    Expect(0, 10623, '\p{^_-In_SUP_arrows_B}', "");
    Expect(0, 10623, '\P{_-In_SUP_arrows_B}', "");
    Expect(1, 10623, '\P{^_-In_SUP_arrows_B}', "");
    Expect(0, 10624, '\p{_-In_SUP_arrows_B}', "");
    Expect(1, 10624, '\p{^_-In_SUP_arrows_B}', "");
    Expect(1, 10624, '\P{_-In_SUP_arrows_B}', "");
    Expect(0, 10624, '\P{^_-In_SUP_arrows_B}', "");
    Error('\p{ Supplemental_Arrows_C/a/}');
    Error('\P{ Supplemental_Arrows_C/a/}');
    Expect(1, 129279, '\p{supplementalarrowsc}', "");
    Expect(0, 129279, '\p{^supplementalarrowsc}', "");
    Expect(0, 129279, '\P{supplementalarrowsc}', "");
    Expect(1, 129279, '\P{^supplementalarrowsc}', "");
    Expect(0, 129280, '\p{supplementalarrowsc}', "");
    Expect(1, 129280, '\p{^supplementalarrowsc}', "");
    Expect(1, 129280, '\P{supplementalarrowsc}', "");
    Expect(0, 129280, '\P{^supplementalarrowsc}', "");
    Expect(1, 129279, '\p{  SUPPLEMENTAL_Arrows_C}', "");
    Expect(0, 129279, '\p{^  SUPPLEMENTAL_Arrows_C}', "");
    Expect(0, 129279, '\P{  SUPPLEMENTAL_Arrows_C}', "");
    Expect(1, 129279, '\P{^  SUPPLEMENTAL_Arrows_C}', "");
    Expect(0, 129280, '\p{  SUPPLEMENTAL_Arrows_C}', "");
    Expect(1, 129280, '\p{^  SUPPLEMENTAL_Arrows_C}', "");
    Expect(1, 129280, '\P{  SUPPLEMENTAL_Arrows_C}', "");
    Expect(0, 129280, '\P{^  SUPPLEMENTAL_Arrows_C}', "");
    Error('\p{-is_supplemental_arrows_C:=}');
    Error('\P{-is_supplemental_arrows_C:=}');
    Expect(1, 129279, '\p{issupplementalarrowsc}', "");
    Expect(0, 129279, '\p{^issupplementalarrowsc}', "");
    Expect(0, 129279, '\P{issupplementalarrowsc}', "");
    Expect(1, 129279, '\P{^issupplementalarrowsc}', "");
    Expect(0, 129280, '\p{issupplementalarrowsc}', "");
    Expect(1, 129280, '\p{^issupplementalarrowsc}', "");
    Expect(1, 129280, '\P{issupplementalarrowsc}', "");
    Expect(0, 129280, '\P{^issupplementalarrowsc}', "");
    Expect(1, 129279, '\p{-Is_SUPPLEMENTAL_Arrows_c}', "");
    Expect(0, 129279, '\p{^-Is_SUPPLEMENTAL_Arrows_c}', "");
    Expect(0, 129279, '\P{-Is_SUPPLEMENTAL_Arrows_c}', "");
    Expect(1, 129279, '\P{^-Is_SUPPLEMENTAL_Arrows_c}', "");
    Expect(0, 129280, '\p{-Is_SUPPLEMENTAL_Arrows_c}', "");
    Expect(1, 129280, '\p{^-Is_SUPPLEMENTAL_Arrows_c}', "");
    Expect(1, 129280, '\P{-Is_SUPPLEMENTAL_Arrows_c}', "");
    Expect(0, 129280, '\P{^-Is_SUPPLEMENTAL_Arrows_c}', "");
    Error('\p{ :=In_Supplemental_arrows_C}');
    Error('\P{ :=In_Supplemental_arrows_C}');
    Expect(1, 129279, '\p{insupplementalarrowsc}', "");
    Expect(0, 129279, '\p{^insupplementalarrowsc}', "");
    Expect(0, 129279, '\P{insupplementalarrowsc}', "");
    Expect(1, 129279, '\P{^insupplementalarrowsc}', "");
    Expect(0, 129280, '\p{insupplementalarrowsc}', "");
    Expect(1, 129280, '\p{^insupplementalarrowsc}', "");
    Expect(1, 129280, '\P{insupplementalarrowsc}', "");
    Expect(0, 129280, '\P{^insupplementalarrowsc}', "");
    Expect(1, 129279, '\p{		In_Supplemental_ARROWS_C}', "");
    Expect(0, 129279, '\p{^		In_Supplemental_ARROWS_C}', "");
    Expect(0, 129279, '\P{		In_Supplemental_ARROWS_C}', "");
    Expect(1, 129279, '\P{^		In_Supplemental_ARROWS_C}', "");
    Expect(0, 129280, '\p{		In_Supplemental_ARROWS_C}', "");
    Expect(1, 129280, '\p{^		In_Supplemental_ARROWS_C}', "");
    Expect(1, 129280, '\P{		In_Supplemental_ARROWS_C}', "");
    Expect(0, 129280, '\P{^		In_Supplemental_ARROWS_C}', "");
    Error('\p{:=		Sup_arrows_C}');
    Error('\P{:=		Sup_arrows_C}');
    Expect(1, 129279, '\p{suparrowsc}', "");
    Expect(0, 129279, '\p{^suparrowsc}', "");
    Expect(0, 129279, '\P{suparrowsc}', "");
    Expect(1, 129279, '\P{^suparrowsc}', "");
    Expect(0, 129280, '\p{suparrowsc}', "");
    Expect(1, 129280, '\p{^suparrowsc}', "");
    Expect(1, 129280, '\P{suparrowsc}', "");
    Expect(0, 129280, '\P{^suparrowsc}', "");
    Expect(1, 129279, '\p{_-SUP_ARROWS_c}', "");
    Expect(0, 129279, '\p{^_-SUP_ARROWS_c}', "");
    Expect(0, 129279, '\P{_-SUP_ARROWS_c}', "");
    Expect(1, 129279, '\P{^_-SUP_ARROWS_c}', "");
    Expect(0, 129280, '\p{_-SUP_ARROWS_c}', "");
    Expect(1, 129280, '\p{^_-SUP_ARROWS_c}', "");
    Expect(1, 129280, '\P{_-SUP_ARROWS_c}', "");
    Expect(0, 129280, '\P{^_-SUP_ARROWS_c}', "");
    Error('\p{/a/	Is_sup_Arrows_C}');
    Error('\P{/a/	Is_sup_Arrows_C}');
    Expect(1, 129279, '\p{issuparrowsc}', "");
    Expect(0, 129279, '\p{^issuparrowsc}', "");
    Expect(0, 129279, '\P{issuparrowsc}', "");
    Expect(1, 129279, '\P{^issuparrowsc}', "");
    Expect(0, 129280, '\p{issuparrowsc}', "");
    Expect(1, 129280, '\p{^issuparrowsc}', "");
    Expect(1, 129280, '\P{issuparrowsc}', "");
    Expect(0, 129280, '\P{^issuparrowsc}', "");
    Expect(1, 129279, '\p{ _is_Sup_arrows_C}', "");
    Expect(0, 129279, '\p{^ _is_Sup_arrows_C}', "");
    Expect(0, 129279, '\P{ _is_Sup_arrows_C}', "");
    Expect(1, 129279, '\P{^ _is_Sup_arrows_C}', "");
    Expect(0, 129280, '\p{ _is_Sup_arrows_C}', "");
    Expect(1, 129280, '\p{^ _is_Sup_arrows_C}', "");
    Expect(1, 129280, '\P{ _is_Sup_arrows_C}', "");
    Expect(0, 129280, '\P{^ _is_Sup_arrows_C}', "");
    Error('\p{	 in_Sup_arrows_C/a/}');
    Error('\P{	 in_Sup_arrows_C/a/}');
    Expect(1, 129279, '\p{insuparrowsc}', "");
    Expect(0, 129279, '\p{^insuparrowsc}', "");
    Expect(0, 129279, '\P{insuparrowsc}', "");
    Expect(1, 129279, '\P{^insuparrowsc}', "");
    Expect(0, 129280, '\p{insuparrowsc}', "");
    Expect(1, 129280, '\p{^insuparrowsc}', "");
    Expect(1, 129280, '\P{insuparrowsc}', "");
    Expect(0, 129280, '\P{^insuparrowsc}', "");
    Expect(1, 129279, '\p{ IN_sup_Arrows_C}', "");
    Expect(0, 129279, '\p{^ IN_sup_Arrows_C}', "");
    Expect(0, 129279, '\P{ IN_sup_Arrows_C}', "");
    Expect(1, 129279, '\P{^ IN_sup_Arrows_C}', "");
    Expect(0, 129280, '\p{ IN_sup_Arrows_C}', "");
    Expect(1, 129280, '\p{^ IN_sup_Arrows_C}', "");
    Expect(1, 129280, '\P{ IN_sup_Arrows_C}', "");
    Expect(0, 129280, '\P{^ IN_sup_Arrows_C}', "");
    Error('\p{_ supplemental_Mathematical_Operators:=}');
    Error('\P{_ supplemental_Mathematical_Operators:=}');
    Expect(1, 11007, '\p{supplementalmathematicaloperators}', "");
    Expect(0, 11007, '\p{^supplementalmathematicaloperators}', "");
    Expect(0, 11007, '\P{supplementalmathematicaloperators}', "");
    Expect(1, 11007, '\P{^supplementalmathematicaloperators}', "");
    Expect(0, 11008, '\p{supplementalmathematicaloperators}', "");
    Expect(1, 11008, '\p{^supplementalmathematicaloperators}', "");
    Expect(1, 11008, '\P{supplementalmathematicaloperators}', "");
    Expect(0, 11008, '\P{^supplementalmathematicaloperators}', "");
    Expect(1, 11007, '\p{		supplemental_Mathematical_Operators}', "");
    Expect(0, 11007, '\p{^		supplemental_Mathematical_Operators}', "");
    Expect(0, 11007, '\P{		supplemental_Mathematical_Operators}', "");
    Expect(1, 11007, '\P{^		supplemental_Mathematical_Operators}', "");
    Expect(0, 11008, '\p{		supplemental_Mathematical_Operators}', "");
    Expect(1, 11008, '\p{^		supplemental_Mathematical_Operators}', "");
    Expect(1, 11008, '\P{		supplemental_Mathematical_Operators}', "");
    Expect(0, 11008, '\P{^		supplemental_Mathematical_Operators}', "");
    Error('\p{:= -IS_Supplemental_mathematical_Operators}');
    Error('\P{:= -IS_Supplemental_mathematical_Operators}');
    Expect(1, 11007, '\p{issupplementalmathematicaloperators}', "");
    Expect(0, 11007, '\p{^issupplementalmathematicaloperators}', "");
    Expect(0, 11007, '\P{issupplementalmathematicaloperators}', "");
    Expect(1, 11007, '\P{^issupplementalmathematicaloperators}', "");
    Expect(0, 11008, '\p{issupplementalmathematicaloperators}', "");
    Expect(1, 11008, '\p{^issupplementalmathematicaloperators}', "");
    Expect(1, 11008, '\P{issupplementalmathematicaloperators}', "");
    Expect(0, 11008, '\P{^issupplementalmathematicaloperators}', "");
    Expect(1, 11007, '\p{		Is_Supplemental_Mathematical_Operators}', "");
    Expect(0, 11007, '\p{^		Is_Supplemental_Mathematical_Operators}', "");
    Expect(0, 11007, '\P{		Is_Supplemental_Mathematical_Operators}', "");
    Expect(1, 11007, '\P{^		Is_Supplemental_Mathematical_Operators}', "");
    Expect(0, 11008, '\p{		Is_Supplemental_Mathematical_Operators}', "");
    Expect(1, 11008, '\p{^		Is_Supplemental_Mathematical_Operators}', "");
    Expect(1, 11008, '\P{		Is_Supplemental_Mathematical_Operators}', "");
    Expect(0, 11008, '\P{^		Is_Supplemental_Mathematical_Operators}', "");
    Error('\p{/a/In_Supplemental_mathematical_Operators}');
    Error('\P{/a/In_Supplemental_mathematical_Operators}');
    Expect(1, 11007, '\p{insupplementalmathematicaloperators}', "");
    Expect(0, 11007, '\p{^insupplementalmathematicaloperators}', "");
    Expect(0, 11007, '\P{insupplementalmathematicaloperators}', "");
    Expect(1, 11007, '\P{^insupplementalmathematicaloperators}', "");
    Expect(0, 11008, '\p{insupplementalmathematicaloperators}', "");
    Expect(1, 11008, '\p{^insupplementalmathematicaloperators}', "");
    Expect(1, 11008, '\P{insupplementalmathematicaloperators}', "");
    Expect(0, 11008, '\P{^insupplementalmathematicaloperators}', "");
    Expect(1, 11007, '\p{ _in_SUPPLEMENTAL_Mathematical_operators}', "");
    Expect(0, 11007, '\p{^ _in_SUPPLEMENTAL_Mathematical_operators}', "");
    Expect(0, 11007, '\P{ _in_SUPPLEMENTAL_Mathematical_operators}', "");
    Expect(1, 11007, '\P{^ _in_SUPPLEMENTAL_Mathematical_operators}', "");
    Expect(0, 11008, '\p{ _in_SUPPLEMENTAL_Mathematical_operators}', "");
    Expect(1, 11008, '\p{^ _in_SUPPLEMENTAL_Mathematical_operators}', "");
    Expect(1, 11008, '\P{ _in_SUPPLEMENTAL_Mathematical_operators}', "");
    Expect(0, 11008, '\P{^ _in_SUPPLEMENTAL_Mathematical_operators}', "");
    Error('\p{-/a/SUP_math_OPERATORS}');
    Error('\P{-/a/SUP_math_OPERATORS}');
    Expect(1, 11007, '\p{supmathoperators}', "");
    Expect(0, 11007, '\p{^supmathoperators}', "");
    Expect(0, 11007, '\P{supmathoperators}', "");
    Expect(1, 11007, '\P{^supmathoperators}', "");
    Expect(0, 11008, '\p{supmathoperators}', "");
    Expect(1, 11008, '\p{^supmathoperators}', "");
    Expect(1, 11008, '\P{supmathoperators}', "");
    Expect(0, 11008, '\P{^supmathoperators}', "");
    Expect(1, 11007, '\p{-_Sup_Math_Operators}', "");
    Expect(0, 11007, '\p{^-_Sup_Math_Operators}', "");
    Expect(0, 11007, '\P{-_Sup_Math_Operators}', "");
    Expect(1, 11007, '\P{^-_Sup_Math_Operators}', "");
    Expect(0, 11008, '\p{-_Sup_Math_Operators}', "");
    Expect(1, 11008, '\p{^-_Sup_Math_Operators}', "");
    Expect(1, 11008, '\P{-_Sup_Math_Operators}', "");
    Expect(0, 11008, '\P{^-_Sup_Math_Operators}', "");
    Error('\p{/a/-_IS_SUP_MATH_operators}');
    Error('\P{/a/-_IS_SUP_MATH_operators}');
    Expect(1, 11007, '\p{issupmathoperators}', "");
    Expect(0, 11007, '\p{^issupmathoperators}', "");
    Expect(0, 11007, '\P{issupmathoperators}', "");
    Expect(1, 11007, '\P{^issupmathoperators}', "");
    Expect(0, 11008, '\p{issupmathoperators}', "");
    Expect(1, 11008, '\p{^issupmathoperators}', "");
    Expect(1, 11008, '\P{issupmathoperators}', "");
    Expect(0, 11008, '\P{^issupmathoperators}', "");
    Expect(1, 11007, '\p{ Is_sup_math_operators}', "");
    Expect(0, 11007, '\p{^ Is_sup_math_operators}', "");
    Expect(0, 11007, '\P{ Is_sup_math_operators}', "");
    Expect(1, 11007, '\P{^ Is_sup_math_operators}', "");
    Expect(0, 11008, '\p{ Is_sup_math_operators}', "");
    Expect(1, 11008, '\p{^ Is_sup_math_operators}', "");
    Expect(1, 11008, '\P{ Is_sup_math_operators}', "");
    Expect(0, 11008, '\P{^ Is_sup_math_operators}', "");
    Error('\p{:=-in_Sup_Math_OPERATORS}');
    Error('\P{:=-in_Sup_Math_OPERATORS}');
    Expect(1, 11007, '\p{insupmathoperators}', "");
    Expect(0, 11007, '\p{^insupmathoperators}', "");
    Expect(0, 11007, '\P{insupmathoperators}', "");
    Expect(1, 11007, '\P{^insupmathoperators}', "");
    Expect(0, 11008, '\p{insupmathoperators}', "");
    Expect(1, 11008, '\p{^insupmathoperators}', "");
    Expect(1, 11008, '\P{insupmathoperators}', "");
    Expect(0, 11008, '\P{^insupmathoperators}', "");
    Expect(1, 11007, '\p{_	in_Sup_MATH_Operators}', "");
    Expect(0, 11007, '\p{^_	in_Sup_MATH_Operators}', "");
    Expect(0, 11007, '\P{_	in_Sup_MATH_Operators}', "");
    Expect(1, 11007, '\P{^_	in_Sup_MATH_Operators}', "");
    Expect(0, 11008, '\p{_	in_Sup_MATH_Operators}', "");
    Expect(1, 11008, '\p{^_	in_Sup_MATH_Operators}', "");
    Expect(1, 11008, '\P{_	in_Sup_MATH_Operators}', "");
    Expect(0, 11008, '\P{^_	in_Sup_MATH_Operators}', "");
    Error('\p{_/a/SUPPLEMENTAL_Punctuation}');
    Error('\P{_/a/SUPPLEMENTAL_Punctuation}');
    Expect(1, 11903, '\p{supplementalpunctuation}', "");
    Expect(0, 11903, '\p{^supplementalpunctuation}', "");
    Expect(0, 11903, '\P{supplementalpunctuation}', "");
    Expect(1, 11903, '\P{^supplementalpunctuation}', "");
    Expect(0, 11904, '\p{supplementalpunctuation}', "");
    Expect(1, 11904, '\p{^supplementalpunctuation}', "");
    Expect(1, 11904, '\P{supplementalpunctuation}', "");
    Expect(0, 11904, '\P{^supplementalpunctuation}', "");
    Expect(1, 11903, '\p{_	Supplemental_PUNCTUATION}', "");
    Expect(0, 11903, '\p{^_	Supplemental_PUNCTUATION}', "");
    Expect(0, 11903, '\P{_	Supplemental_PUNCTUATION}', "");
    Expect(1, 11903, '\P{^_	Supplemental_PUNCTUATION}', "");
    Expect(0, 11904, '\p{_	Supplemental_PUNCTUATION}', "");
    Expect(1, 11904, '\p{^_	Supplemental_PUNCTUATION}', "");
    Expect(1, 11904, '\P{_	Supplemental_PUNCTUATION}', "");
    Expect(0, 11904, '\P{^_	Supplemental_PUNCTUATION}', "");
    Error('\p{-/a/Is_Supplemental_Punctuation}');
    Error('\P{-/a/Is_Supplemental_Punctuation}');
    Expect(1, 11903, '\p{issupplementalpunctuation}', "");
    Expect(0, 11903, '\p{^issupplementalpunctuation}', "");
    Expect(0, 11903, '\P{issupplementalpunctuation}', "");
    Expect(1, 11903, '\P{^issupplementalpunctuation}', "");
    Expect(0, 11904, '\p{issupplementalpunctuation}', "");
    Expect(1, 11904, '\p{^issupplementalpunctuation}', "");
    Expect(1, 11904, '\P{issupplementalpunctuation}', "");
    Expect(0, 11904, '\P{^issupplementalpunctuation}', "");
    Expect(1, 11903, '\p{ 	IS_Supplemental_Punctuation}', "");
    Expect(0, 11903, '\p{^ 	IS_Supplemental_Punctuation}', "");
    Expect(0, 11903, '\P{ 	IS_Supplemental_Punctuation}', "");
    Expect(1, 11903, '\P{^ 	IS_Supplemental_Punctuation}', "");
    Expect(0, 11904, '\p{ 	IS_Supplemental_Punctuation}', "");
    Expect(1, 11904, '\p{^ 	IS_Supplemental_Punctuation}', "");
    Expect(1, 11904, '\P{ 	IS_Supplemental_Punctuation}', "");
    Expect(0, 11904, '\P{^ 	IS_Supplemental_Punctuation}', "");
    Error('\p{ :=In_Supplemental_Punctuation}');
    Error('\P{ :=In_Supplemental_Punctuation}');
    Expect(1, 11903, '\p{insupplementalpunctuation}', "");
    Expect(0, 11903, '\p{^insupplementalpunctuation}', "");
    Expect(0, 11903, '\P{insupplementalpunctuation}', "");
    Expect(1, 11903, '\P{^insupplementalpunctuation}', "");
    Expect(0, 11904, '\p{insupplementalpunctuation}', "");
    Expect(1, 11904, '\p{^insupplementalpunctuation}', "");
    Expect(1, 11904, '\P{insupplementalpunctuation}', "");
    Expect(0, 11904, '\P{^insupplementalpunctuation}', "");
    Expect(1, 11903, '\p{__in_SUPPLEMENTAL_punctuation}', "");
    Expect(0, 11903, '\p{^__in_SUPPLEMENTAL_punctuation}', "");
    Expect(0, 11903, '\P{__in_SUPPLEMENTAL_punctuation}', "");
    Expect(1, 11903, '\P{^__in_SUPPLEMENTAL_punctuation}', "");
    Expect(0, 11904, '\p{__in_SUPPLEMENTAL_punctuation}', "");
    Expect(1, 11904, '\p{^__in_SUPPLEMENTAL_punctuation}', "");
    Expect(1, 11904, '\P{__in_SUPPLEMENTAL_punctuation}', "");
    Expect(0, 11904, '\P{^__in_SUPPLEMENTAL_punctuation}', "");
    Error('\p{:=_Sup_punctuation}');
    Error('\P{:=_Sup_punctuation}');
    Expect(1, 11903, '\p{suppunctuation}', "");
    Expect(0, 11903, '\p{^suppunctuation}', "");
    Expect(0, 11903, '\P{suppunctuation}', "");
    Expect(1, 11903, '\P{^suppunctuation}', "");
    Expect(0, 11904, '\p{suppunctuation}', "");
    Expect(1, 11904, '\p{^suppunctuation}', "");
    Expect(1, 11904, '\P{suppunctuation}', "");
    Expect(0, 11904, '\P{^suppunctuation}', "");
    Expect(1, 11903, '\p{__Sup_Punctuation}', "");
    Expect(0, 11903, '\p{^__Sup_Punctuation}', "");
    Expect(0, 11903, '\P{__Sup_Punctuation}', "");
    Expect(1, 11903, '\P{^__Sup_Punctuation}', "");
    Expect(0, 11904, '\p{__Sup_Punctuation}', "");
    Expect(1, 11904, '\p{^__Sup_Punctuation}', "");
    Expect(1, 11904, '\P{__Sup_Punctuation}', "");
    Expect(0, 11904, '\P{^__Sup_Punctuation}', "");
    Error('\p{/a/Is_SUP_Punctuation}');
    Error('\P{/a/Is_SUP_Punctuation}');
    Expect(1, 11903, '\p{issuppunctuation}', "");
    Expect(0, 11903, '\p{^issuppunctuation}', "");
    Expect(0, 11903, '\P{issuppunctuation}', "");
    Expect(1, 11903, '\P{^issuppunctuation}', "");
    Expect(0, 11904, '\p{issuppunctuation}', "");
    Expect(1, 11904, '\p{^issuppunctuation}', "");
    Expect(1, 11904, '\P{issuppunctuation}', "");
    Expect(0, 11904, '\P{^issuppunctuation}', "");
    Expect(1, 11903, '\p{IS_SUP_PUNCTUATION}', "");
    Expect(0, 11903, '\p{^IS_SUP_PUNCTUATION}', "");
    Expect(0, 11903, '\P{IS_SUP_PUNCTUATION}', "");
    Expect(1, 11903, '\P{^IS_SUP_PUNCTUATION}', "");
    Expect(0, 11904, '\p{IS_SUP_PUNCTUATION}', "");
    Expect(1, 11904, '\p{^IS_SUP_PUNCTUATION}', "");
    Expect(1, 11904, '\P{IS_SUP_PUNCTUATION}', "");
    Expect(0, 11904, '\P{^IS_SUP_PUNCTUATION}', "");
    Error('\p{:=_IN_Sup_punctuation}');
    Error('\P{:=_IN_Sup_punctuation}');
    Expect(1, 11903, '\p{insuppunctuation}', "");
    Expect(0, 11903, '\p{^insuppunctuation}', "");
    Expect(0, 11903, '\P{insuppunctuation}', "");
    Expect(1, 11903, '\P{^insuppunctuation}', "");
    Expect(0, 11904, '\p{insuppunctuation}', "");
    Expect(1, 11904, '\p{^insuppunctuation}', "");
    Expect(1, 11904, '\P{insuppunctuation}', "");
    Expect(0, 11904, '\P{^insuppunctuation}', "");
    Expect(1, 11903, '\p{	In_SUP_Punctuation}', "");
    Expect(0, 11903, '\p{^	In_SUP_Punctuation}', "");
    Expect(0, 11903, '\P{	In_SUP_Punctuation}', "");
    Expect(1, 11903, '\P{^	In_SUP_Punctuation}', "");
    Expect(0, 11904, '\p{	In_SUP_Punctuation}', "");
    Expect(1, 11904, '\p{^	In_SUP_Punctuation}', "");
    Expect(1, 11904, '\P{	In_SUP_Punctuation}', "");
    Expect(0, 11904, '\P{^	In_SUP_Punctuation}', "");
    Error('\p{	:=SUPPLEMENTAL_SYMBOLS_AND_Pictographs}');
    Error('\P{	:=SUPPLEMENTAL_SYMBOLS_AND_Pictographs}');
    Expect(1, 129535, '\p{supplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^supplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{supplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^supplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{supplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^supplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{supplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^supplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{ -Supplemental_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 129535, '\p{^ -Supplemental_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 129535, '\P{ -Supplemental_Symbols_And_PICTOGRAPHS}', "");
    Expect(1, 129535, '\P{^ -Supplemental_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 129536, '\p{ -Supplemental_Symbols_And_PICTOGRAPHS}', "");
    Expect(1, 129536, '\p{^ -Supplemental_Symbols_And_PICTOGRAPHS}', "");
    Expect(1, 129536, '\P{ -Supplemental_Symbols_And_PICTOGRAPHS}', "");
    Expect(0, 129536, '\P{^ -Supplemental_Symbols_And_PICTOGRAPHS}', "");
    Error('\p{/a/-_Is_supplemental_Symbols_And_PICTOGRAPHS}');
    Error('\P{/a/-_Is_supplemental_Symbols_And_PICTOGRAPHS}');
    Expect(1, 129535, '\p{issupplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^issupplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{issupplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^issupplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{issupplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^issupplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{issupplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^issupplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{ 	Is_Supplemental_Symbols_And_Pictographs}', "");
    Expect(0, 129535, '\p{^ 	Is_Supplemental_Symbols_And_Pictographs}', "");
    Expect(0, 129535, '\P{ 	Is_Supplemental_Symbols_And_Pictographs}', "");
    Expect(1, 129535, '\P{^ 	Is_Supplemental_Symbols_And_Pictographs}', "");
    Expect(0, 129536, '\p{ 	Is_Supplemental_Symbols_And_Pictographs}', "");
    Expect(1, 129536, '\p{^ 	Is_Supplemental_Symbols_And_Pictographs}', "");
    Expect(1, 129536, '\P{ 	Is_Supplemental_Symbols_And_Pictographs}', "");
    Expect(0, 129536, '\P{^ 	Is_Supplemental_Symbols_And_Pictographs}', "");
    Error('\p{:=  In_Supplemental_SYMBOLS_And_Pictographs}');
    Error('\P{:=  In_Supplemental_SYMBOLS_And_Pictographs}');
    Expect(1, 129535, '\p{insupplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^insupplementalsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{insupplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^insupplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{insupplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^insupplementalsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{insupplementalsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^insupplementalsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{_-In_SUPPLEMENTAL_Symbols_and_Pictographs}', "");
    Expect(0, 129535, '\p{^_-In_SUPPLEMENTAL_Symbols_and_Pictographs}', "");
    Expect(0, 129535, '\P{_-In_SUPPLEMENTAL_Symbols_and_Pictographs}', "");
    Expect(1, 129535, '\P{^_-In_SUPPLEMENTAL_Symbols_and_Pictographs}', "");
    Expect(0, 129536, '\p{_-In_SUPPLEMENTAL_Symbols_and_Pictographs}', "");
    Expect(1, 129536, '\p{^_-In_SUPPLEMENTAL_Symbols_and_Pictographs}', "");
    Expect(1, 129536, '\P{_-In_SUPPLEMENTAL_Symbols_and_Pictographs}', "");
    Expect(0, 129536, '\P{^_-In_SUPPLEMENTAL_Symbols_and_Pictographs}', "");
    Error('\p{	:=SUP_SYMBOLS_AND_Pictographs}');
    Error('\P{	:=SUP_SYMBOLS_AND_Pictographs}');
    Expect(1, 129535, '\p{supsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^supsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{supsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^supsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{supsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^supsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{supsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^supsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{_-Sup_Symbols_and_Pictographs}', "");
    Expect(0, 129535, '\p{^_-Sup_Symbols_and_Pictographs}', "");
    Expect(0, 129535, '\P{_-Sup_Symbols_and_Pictographs}', "");
    Expect(1, 129535, '\P{^_-Sup_Symbols_and_Pictographs}', "");
    Expect(0, 129536, '\p{_-Sup_Symbols_and_Pictographs}', "");
    Expect(1, 129536, '\p{^_-Sup_Symbols_and_Pictographs}', "");
    Expect(1, 129536, '\P{_-Sup_Symbols_and_Pictographs}', "");
    Expect(0, 129536, '\P{^_-Sup_Symbols_and_Pictographs}', "");
    Error('\p{ Is_sup_symbols_And_PICTOGRAPHS/a/}');
    Error('\P{ Is_sup_symbols_And_PICTOGRAPHS/a/}');
    Expect(1, 129535, '\p{issupsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^issupsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{issupsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^issupsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{issupsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^issupsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{issupsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^issupsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{_Is_SUP_symbols_And_PICTOGRAPHS}', "");
    Expect(0, 129535, '\p{^_Is_SUP_symbols_And_PICTOGRAPHS}', "");
    Expect(0, 129535, '\P{_Is_SUP_symbols_And_PICTOGRAPHS}', "");
    Expect(1, 129535, '\P{^_Is_SUP_symbols_And_PICTOGRAPHS}', "");
    Expect(0, 129536, '\p{_Is_SUP_symbols_And_PICTOGRAPHS}', "");
    Expect(1, 129536, '\p{^_Is_SUP_symbols_And_PICTOGRAPHS}', "");
    Expect(1, 129536, '\P{_Is_SUP_symbols_And_PICTOGRAPHS}', "");
    Expect(0, 129536, '\P{^_Is_SUP_symbols_And_PICTOGRAPHS}', "");
    Error('\p{:=_in_Sup_Symbols_And_Pictographs}');
    Error('\P{:=_in_Sup_Symbols_And_Pictographs}');
    Expect(1, 129535, '\p{insupsymbolsandpictographs}', "");
    Expect(0, 129535, '\p{^insupsymbolsandpictographs}', "");
    Expect(0, 129535, '\P{insupsymbolsandpictographs}', "");
    Expect(1, 129535, '\P{^insupsymbolsandpictographs}', "");
    Expect(0, 129536, '\p{insupsymbolsandpictographs}', "");
    Expect(1, 129536, '\p{^insupsymbolsandpictographs}', "");
    Expect(1, 129536, '\P{insupsymbolsandpictographs}', "");
    Expect(0, 129536, '\P{^insupsymbolsandpictographs}', "");
    Expect(1, 129535, '\p{ in_Sup_Symbols_AND_PICTOGRAPHS}', "");
    Expect(0, 129535, '\p{^ in_Sup_Symbols_AND_PICTOGRAPHS}', "");
    Expect(0, 129535, '\P{ in_Sup_Symbols_AND_PICTOGRAPHS}', "");
    Expect(1, 129535, '\P{^ in_Sup_Symbols_AND_PICTOGRAPHS}', "");
    Expect(0, 129536, '\p{ in_Sup_Symbols_AND_PICTOGRAPHS}', "");
    Expect(1, 129536, '\p{^ in_Sup_Symbols_AND_PICTOGRAPHS}', "");
    Expect(1, 129536, '\P{ in_Sup_Symbols_AND_PICTOGRAPHS}', "");
    Expect(0, 129536, '\P{^ in_Sup_Symbols_AND_PICTOGRAPHS}', "");
    Error('\p{	/a/Supplementary_Private_USE_area_A}');
    Error('\P{	/a/Supplementary_Private_USE_area_A}');
    Expect(1, 983040, '\p{supplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\p{^supplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\P{supplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\P{^supplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\p{supplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\p{^supplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\P{supplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\P{^supplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\p{ _Supplementary_PRIVATE_Use_Area_A}', "");
    Expect(0, 983040, '\p{^ _Supplementary_PRIVATE_Use_Area_A}', "");
    Expect(0, 983040, '\P{ _Supplementary_PRIVATE_Use_Area_A}', "");
    Expect(1, 983040, '\P{^ _Supplementary_PRIVATE_Use_Area_A}', "");
    Expect(0, 1048576, '\p{ _Supplementary_PRIVATE_Use_Area_A}', "");
    Expect(1, 1048576, '\p{^ _Supplementary_PRIVATE_Use_Area_A}', "");
    Expect(1, 1048576, '\P{ _Supplementary_PRIVATE_Use_Area_A}', "");
    Expect(0, 1048576, '\P{^ _Supplementary_PRIVATE_Use_Area_A}', "");
    Error('\p{_Is_SUPPLEMENTARY_PRIVATE_Use_Area_A:=}');
    Error('\P{_Is_SUPPLEMENTARY_PRIVATE_Use_Area_A:=}');
    Expect(1, 983040, '\p{issupplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\p{^issupplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\P{issupplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\P{^issupplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\p{issupplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\p{^issupplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\P{issupplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\P{^issupplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\p{ is_supplementary_Private_USE_Area_A}', "");
    Expect(0, 983040, '\p{^ is_supplementary_Private_USE_Area_A}', "");
    Expect(0, 983040, '\P{ is_supplementary_Private_USE_Area_A}', "");
    Expect(1, 983040, '\P{^ is_supplementary_Private_USE_Area_A}', "");
    Expect(0, 1048576, '\p{ is_supplementary_Private_USE_Area_A}', "");
    Expect(1, 1048576, '\p{^ is_supplementary_Private_USE_Area_A}', "");
    Expect(1, 1048576, '\P{ is_supplementary_Private_USE_Area_A}', "");
    Expect(0, 1048576, '\P{^ is_supplementary_Private_USE_Area_A}', "");
    Error('\p{/a/In_Supplementary_Private_Use_AREA_A}');
    Error('\P{/a/In_Supplementary_Private_Use_AREA_A}');
    Expect(1, 983040, '\p{insupplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\p{^insupplementaryprivateuseareaa}', "");
    Expect(0, 983040, '\P{insupplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\P{^insupplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\p{insupplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\p{^insupplementaryprivateuseareaa}', "");
    Expect(1, 1048576, '\P{insupplementaryprivateuseareaa}', "");
    Expect(0, 1048576, '\P{^insupplementaryprivateuseareaa}', "");
    Expect(1, 983040, '\p{  In_SUPPLEMENTARY_PRIVATE_use_Area_A}', "");
    Expect(0, 983040, '\p{^  In_SUPPLEMENTARY_PRIVATE_use_Area_A}', "");
    Expect(0, 983040, '\P{  In_SUPPLEMENTARY_PRIVATE_use_Area_A}', "");
    Expect(1, 983040, '\P{^  In_SUPPLEMENTARY_PRIVATE_use_Area_A}', "");
    Expect(0, 1048576, '\p{  In_SUPPLEMENTARY_PRIVATE_use_Area_A}', "");
    Expect(1, 1048576, '\p{^  In_SUPPLEMENTARY_PRIVATE_use_Area_A}', "");
    Expect(1, 1048576, '\P{  In_SUPPLEMENTARY_PRIVATE_use_Area_A}', "");
    Expect(0, 1048576, '\P{^  In_SUPPLEMENTARY_PRIVATE_use_Area_A}', "");
    Error('\p{	:=SUP_pua_a}');
    Error('\P{	:=SUP_pua_a}');
    Expect(1, 983040, '\p{suppuaa}', "");
    Expect(0, 983040, '\p{^suppuaa}', "");
    Expect(0, 983040, '\P{suppuaa}', "");
    Expect(1, 983040, '\P{^suppuaa}', "");
    Expect(0, 1048576, '\p{suppuaa}', "");
    Expect(1, 1048576, '\p{^suppuaa}', "");
    Expect(1, 1048576, '\P{suppuaa}', "");
    Expect(0, 1048576, '\P{^suppuaa}', "");
    Expect(1, 983040, '\p{ _Sup_PUA_A}', "");
    Expect(0, 983040, '\p{^ _Sup_PUA_A}', "");
    Expect(0, 983040, '\P{ _Sup_PUA_A}', "");
    Expect(1, 983040, '\P{^ _Sup_PUA_A}', "");
    Expect(0, 1048576, '\p{ _Sup_PUA_A}', "");
    Expect(1, 1048576, '\p{^ _Sup_PUA_A}', "");
    Expect(1, 1048576, '\P{ _Sup_PUA_A}', "");
    Expect(0, 1048576, '\P{^ _Sup_PUA_A}', "");
    Error('\p{ :=Is_Sup_PUA_A}');
    Error('\P{ :=Is_Sup_PUA_A}');
    Expect(1, 983040, '\p{issuppuaa}', "");
    Expect(0, 983040, '\p{^issuppuaa}', "");
    Expect(0, 983040, '\P{issuppuaa}', "");
    Expect(1, 983040, '\P{^issuppuaa}', "");
    Expect(0, 1048576, '\p{issuppuaa}', "");
    Expect(1, 1048576, '\p{^issuppuaa}', "");
    Expect(1, 1048576, '\P{issuppuaa}', "");
    Expect(0, 1048576, '\P{^issuppuaa}', "");
    Expect(1, 983040, '\p{ -Is_Sup_PUA_A}', "");
    Expect(0, 983040, '\p{^ -Is_Sup_PUA_A}', "");
    Expect(0, 983040, '\P{ -Is_Sup_PUA_A}', "");
    Expect(1, 983040, '\P{^ -Is_Sup_PUA_A}', "");
    Expect(0, 1048576, '\p{ -Is_Sup_PUA_A}', "");
    Expect(1, 1048576, '\p{^ -Is_Sup_PUA_A}', "");
    Expect(1, 1048576, '\P{ -Is_Sup_PUA_A}', "");
    Expect(0, 1048576, '\P{^ -Is_Sup_PUA_A}', "");
    Error('\p{/a/ -In_sup_PUA_A}');
    Error('\P{/a/ -In_sup_PUA_A}');
    Expect(1, 983040, '\p{insuppuaa}', "");
    Expect(0, 983040, '\p{^insuppuaa}', "");
    Expect(0, 983040, '\P{insuppuaa}', "");
    Expect(1, 983040, '\P{^insuppuaa}', "");
    Expect(0, 1048576, '\p{insuppuaa}', "");
    Expect(1, 1048576, '\p{^insuppuaa}', "");
    Expect(1, 1048576, '\P{insuppuaa}', "");
    Expect(0, 1048576, '\P{^insuppuaa}', "");
    Expect(1, 983040, '\p{In_sup_PUA_a}', "");
    Expect(0, 983040, '\p{^In_sup_PUA_a}', "");
    Expect(0, 983040, '\P{In_sup_PUA_a}', "");
    Expect(1, 983040, '\P{^In_sup_PUA_a}', "");
    Expect(0, 1048576, '\p{In_sup_PUA_a}', "");
    Expect(1, 1048576, '\p{^In_sup_PUA_a}', "");
    Expect(1, 1048576, '\P{In_sup_PUA_a}', "");
    Expect(0, 1048576, '\P{^In_sup_PUA_a}', "");
    Error('\p{/a/	_Supplementary_Private_Use_Area_B}');
    Error('\P{/a/	_Supplementary_Private_Use_Area_B}');
    Expect(1, 1048576, '\p{supplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\p{^supplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\P{supplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\P{^supplementaryprivateuseareab}', "");
    Expect(0, 1, '\p{supplementaryprivateuseareab}', "");
    Expect(1, 1, '\p{^supplementaryprivateuseareab}', "");
    Expect(1, 1, '\P{supplementaryprivateuseareab}', "");
    Expect(0, 1, '\P{^supplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\p{	-Supplementary_PRIVATE_USE_AREA_B}', "");
    Expect(0, 1048576, '\p{^	-Supplementary_PRIVATE_USE_AREA_B}', "");
    Expect(0, 1048576, '\P{	-Supplementary_PRIVATE_USE_AREA_B}', "");
    Expect(1, 1048576, '\P{^	-Supplementary_PRIVATE_USE_AREA_B}', "");
    Expect(0, 1, '\p{	-Supplementary_PRIVATE_USE_AREA_B}', "");
    Expect(1, 1, '\p{^	-Supplementary_PRIVATE_USE_AREA_B}', "");
    Expect(1, 1, '\P{	-Supplementary_PRIVATE_USE_AREA_B}', "");
    Expect(0, 1, '\P{^	-Supplementary_PRIVATE_USE_AREA_B}', "");
    Error('\p{:=Is_Supplementary_Private_USE_Area_B}');
    Error('\P{:=Is_Supplementary_Private_USE_Area_B}');
    Expect(1, 1048576, '\p{issupplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\p{^issupplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\P{issupplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\P{^issupplementaryprivateuseareab}', "");
    Expect(0, 1, '\p{issupplementaryprivateuseareab}', "");
    Expect(1, 1, '\p{^issupplementaryprivateuseareab}', "");
    Expect(1, 1, '\P{issupplementaryprivateuseareab}', "");
    Expect(0, 1, '\P{^issupplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\p{_IS_SUPPLEMENTARY_private_Use_AREA_B}', "");
    Expect(0, 1048576, '\p{^_IS_SUPPLEMENTARY_private_Use_AREA_B}', "");
    Expect(0, 1048576, '\P{_IS_SUPPLEMENTARY_private_Use_AREA_B}', "");
    Expect(1, 1048576, '\P{^_IS_SUPPLEMENTARY_private_Use_AREA_B}', "");
    Expect(0, 1, '\p{_IS_SUPPLEMENTARY_private_Use_AREA_B}', "");
    Expect(1, 1, '\p{^_IS_SUPPLEMENTARY_private_Use_AREA_B}', "");
    Expect(1, 1, '\P{_IS_SUPPLEMENTARY_private_Use_AREA_B}', "");
    Expect(0, 1, '\P{^_IS_SUPPLEMENTARY_private_Use_AREA_B}', "");
    Error('\p{/a/_In_SUPPLEMENTARY_private_USE_area_B}');
    Error('\P{/a/_In_SUPPLEMENTARY_private_USE_area_B}');
    Expect(1, 1048576, '\p{insupplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\p{^insupplementaryprivateuseareab}', "");
    Expect(0, 1048576, '\P{insupplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\P{^insupplementaryprivateuseareab}', "");
    Expect(0, 1, '\p{insupplementaryprivateuseareab}', "");
    Expect(1, 1, '\p{^insupplementaryprivateuseareab}', "");
    Expect(1, 1, '\P{insupplementaryprivateuseareab}', "");
    Expect(0, 1, '\P{^insupplementaryprivateuseareab}', "");
    Expect(1, 1048576, '\p{	 In_Supplementary_PRIVATE_USE_Area_B}', "");
    Expect(0, 1048576, '\p{^	 In_Supplementary_PRIVATE_USE_Area_B}', "");
    Expect(0, 1048576, '\P{	 In_Supplementary_PRIVATE_USE_Area_B}', "");
    Expect(1, 1048576, '\P{^	 In_Supplementary_PRIVATE_USE_Area_B}', "");
    Expect(0, 1, '\p{	 In_Supplementary_PRIVATE_USE_Area_B}', "");
    Expect(1, 1, '\p{^	 In_Supplementary_PRIVATE_USE_Area_B}', "");
    Expect(1, 1, '\P{	 In_Supplementary_PRIVATE_USE_Area_B}', "");
    Expect(0, 1, '\P{^	 In_Supplementary_PRIVATE_USE_Area_B}', "");
    Error('\p{ 	Sup_PUA_b/a/}');
    Error('\P{ 	Sup_PUA_b/a/}');
    Expect(1, 1048576, '\p{suppuab}', "");
    Expect(0, 1048576, '\p{^suppuab}', "");
    Expect(0, 1048576, '\P{suppuab}', "");
    Expect(1, 1048576, '\P{^suppuab}', "");
    Expect(0, 1, '\p{suppuab}', "");
    Expect(1, 1, '\p{^suppuab}', "");
    Expect(1, 1, '\P{suppuab}', "");
    Expect(0, 1, '\P{^suppuab}', "");
    Expect(1, 1048576, '\p{_ Sup_PUA_B}', "");
    Expect(0, 1048576, '\p{^_ Sup_PUA_B}', "");
    Expect(0, 1048576, '\P{_ Sup_PUA_B}', "");
    Expect(1, 1048576, '\P{^_ Sup_PUA_B}', "");
    Expect(0, 1, '\p{_ Sup_PUA_B}', "");
    Expect(1, 1, '\p{^_ Sup_PUA_B}', "");
    Expect(1, 1, '\P{_ Sup_PUA_B}', "");
    Expect(0, 1, '\P{^_ Sup_PUA_B}', "");
    Error('\p{-/a/is_SUP_PUA_b}');
    Error('\P{-/a/is_SUP_PUA_b}');
    Expect(1, 1048576, '\p{issuppuab}', "");
    Expect(0, 1048576, '\p{^issuppuab}', "");
    Expect(0, 1048576, '\P{issuppuab}', "");
    Expect(1, 1048576, '\P{^issuppuab}', "");
    Expect(0, 1, '\p{issuppuab}', "");
    Expect(1, 1, '\p{^issuppuab}', "");
    Expect(1, 1, '\P{issuppuab}', "");
    Expect(0, 1, '\P{^issuppuab}', "");
    Expect(1, 1048576, '\p{ is_sup_PUA_B}', "");
    Expect(0, 1048576, '\p{^ is_sup_PUA_B}', "");
    Expect(0, 1048576, '\P{ is_sup_PUA_B}', "");
    Expect(1, 1048576, '\P{^ is_sup_PUA_B}', "");
    Expect(0, 1, '\p{ is_sup_PUA_B}', "");
    Expect(1, 1, '\p{^ is_sup_PUA_B}', "");
    Expect(1, 1, '\P{ is_sup_PUA_B}', "");
    Expect(0, 1, '\P{^ is_sup_PUA_B}', "");
    Error('\p{ _In_SUP_PUA_B/a/}');
    Error('\P{ _In_SUP_PUA_B/a/}');
    Expect(1, 1048576, '\p{insuppuab}', "");
    Expect(0, 1048576, '\p{^insuppuab}', "");
    Expect(0, 1048576, '\P{insuppuab}', "");
    Expect(1, 1048576, '\P{^insuppuab}', "");
    Expect(0, 1, '\p{insuppuab}', "");
    Expect(1, 1, '\p{^insuppuab}', "");
    Expect(1, 1, '\P{insuppuab}', "");
    Expect(0, 1, '\P{^insuppuab}', "");
    Expect(1, 1048576, '\p{_ In_sup_PUA_B}', "");
    Expect(0, 1048576, '\p{^_ In_sup_PUA_B}', "");
    Expect(0, 1048576, '\P{_ In_sup_PUA_B}', "");
    Expect(1, 1048576, '\P{^_ In_sup_PUA_B}', "");
    Expect(0, 1, '\p{_ In_sup_PUA_B}', "");
    Expect(1, 1, '\p{^_ In_sup_PUA_B}', "");
    Expect(1, 1, '\P{_ In_sup_PUA_B}', "");
    Expect(0, 1, '\P{^_ In_sup_PUA_B}', "");
    Error('\p{:= _Surrogate}');
    Error('\P{:= _Surrogate}');
    Expect(1, 57343, '\p{surrogate}', "");
    Expect(0, 57343, '\p{^surrogate}', "");
    Expect(0, 57343, '\P{surrogate}', "");
    Expect(1, 57343, '\P{^surrogate}', "");
    Expect(0, 57344, '\p{surrogate}', "");
    Expect(1, 57344, '\p{^surrogate}', "");
    Expect(1, 57344, '\P{surrogate}', "");
    Expect(0, 57344, '\P{^surrogate}', "");
    Expect(1, 57343, '\p{- Surrogate}', "");
    Expect(0, 57343, '\p{^- Surrogate}', "");
    Expect(0, 57343, '\P{- Surrogate}', "");
    Expect(1, 57343, '\P{^- Surrogate}', "");
    Expect(0, 57344, '\p{- Surrogate}', "");
    Expect(1, 57344, '\p{^- Surrogate}', "");
    Expect(1, 57344, '\P{- Surrogate}', "");
    Expect(0, 57344, '\P{^- Surrogate}', "");
    Error('\p{/a/is_Surrogate}');
    Error('\P{/a/is_Surrogate}');
    Expect(1, 57343, '\p{issurrogate}', "");
    Expect(0, 57343, '\p{^issurrogate}', "");
    Expect(0, 57343, '\P{issurrogate}', "");
    Expect(1, 57343, '\P{^issurrogate}', "");
    Expect(0, 57344, '\p{issurrogate}', "");
    Expect(1, 57344, '\p{^issurrogate}', "");
    Expect(1, 57344, '\P{issurrogate}', "");
    Expect(0, 57344, '\P{^issurrogate}', "");
    Expect(1, 57343, '\p{-_is_SURROGATE}', "");
    Expect(0, 57343, '\p{^-_is_SURROGATE}', "");
    Expect(0, 57343, '\P{-_is_SURROGATE}', "");
    Expect(1, 57343, '\P{^-_is_SURROGATE}', "");
    Expect(0, 57344, '\p{-_is_SURROGATE}', "");
    Expect(1, 57344, '\p{^-_is_SURROGATE}', "");
    Expect(1, 57344, '\P{-_is_SURROGATE}', "");
    Expect(0, 57344, '\P{^-_is_SURROGATE}', "");
    Error('\p{-/a/cs}');
    Error('\P{-/a/cs}');
    Expect(1, 57343, '\p{cs}', "");
    Expect(0, 57343, '\p{^cs}', "");
    Expect(0, 57343, '\P{cs}', "");
    Expect(1, 57343, '\P{^cs}', "");
    Expect(0, 57344, '\p{cs}', "");
    Expect(1, 57344, '\p{^cs}', "");
    Expect(1, 57344, '\P{cs}', "");
    Expect(0, 57344, '\P{^cs}', "");
    Expect(1, 57343, '\p{_Cs}', "");
    Expect(0, 57343, '\p{^_Cs}', "");
    Expect(0, 57343, '\P{_Cs}', "");
    Expect(1, 57343, '\P{^_Cs}', "");
    Expect(0, 57344, '\p{_Cs}', "");
    Expect(1, 57344, '\p{^_Cs}', "");
    Expect(1, 57344, '\P{_Cs}', "");
    Expect(0, 57344, '\P{^_Cs}', "");
    Error('\p{:=	-IS_cs}');
    Error('\P{:=	-IS_cs}');
    Expect(1, 57343, '\p{iscs}', "");
    Expect(0, 57343, '\p{^iscs}', "");
    Expect(0, 57343, '\P{iscs}', "");
    Expect(1, 57343, '\P{^iscs}', "");
    Expect(0, 57344, '\p{iscs}', "");
    Expect(1, 57344, '\p{^iscs}', "");
    Expect(1, 57344, '\P{iscs}', "");
    Expect(0, 57344, '\P{^iscs}', "");
    Expect(1, 57343, '\p{ _Is_cs}', "");
    Expect(0, 57343, '\p{^ _Is_cs}', "");
    Expect(0, 57343, '\P{ _Is_cs}', "");
    Expect(1, 57343, '\P{^ _Is_cs}', "");
    Expect(0, 57344, '\p{ _Is_cs}', "");
    Expect(1, 57344, '\p{^ _Is_cs}', "");
    Expect(1, 57344, '\P{ _Is_cs}', "");
    Expect(0, 57344, '\P{^ _Is_cs}', "");
    Error('\p{:= -Sutton_SIGNWRITING}');
    Error('\P{:= -Sutton_SIGNWRITING}');
    Expect(1, 121519, '\p{suttonsignwriting}', "");
    Expect(0, 121519, '\p{^suttonsignwriting}', "");
    Expect(0, 121519, '\P{suttonsignwriting}', "");
    Expect(1, 121519, '\P{^suttonsignwriting}', "");
    Expect(0, 121520, '\p{suttonsignwriting}', "");
    Expect(1, 121520, '\p{^suttonsignwriting}', "");
    Expect(1, 121520, '\P{suttonsignwriting}', "");
    Expect(0, 121520, '\P{^suttonsignwriting}', "");
    Expect(1, 121519, '\p{_ Sutton_SignWriting}', "");
    Expect(0, 121519, '\p{^_ Sutton_SignWriting}', "");
    Expect(0, 121519, '\P{_ Sutton_SignWriting}', "");
    Expect(1, 121519, '\P{^_ Sutton_SignWriting}', "");
    Expect(0, 121520, '\p{_ Sutton_SignWriting}', "");
    Expect(1, 121520, '\p{^_ Sutton_SignWriting}', "");
    Expect(1, 121520, '\P{_ Sutton_SignWriting}', "");
    Expect(0, 121520, '\P{^_ Sutton_SignWriting}', "");
    Error('\p{	 is_Sutton_SignWriting:=}');
    Error('\P{	 is_Sutton_SignWriting:=}');
    Expect(1, 121519, '\p{issuttonsignwriting}', "");
    Expect(0, 121519, '\p{^issuttonsignwriting}', "");
    Expect(0, 121519, '\P{issuttonsignwriting}', "");
    Expect(1, 121519, '\P{^issuttonsignwriting}', "");
    Expect(0, 121520, '\p{issuttonsignwriting}', "");
    Expect(1, 121520, '\p{^issuttonsignwriting}', "");
    Expect(1, 121520, '\P{issuttonsignwriting}', "");
    Expect(0, 121520, '\P{^issuttonsignwriting}', "");
    Expect(1, 121519, '\p{	_is_Sutton_SignWriting}', "");
    Expect(0, 121519, '\p{^	_is_Sutton_SignWriting}', "");
    Expect(0, 121519, '\P{	_is_Sutton_SignWriting}', "");
    Expect(1, 121519, '\P{^	_is_Sutton_SignWriting}', "");
    Expect(0, 121520, '\p{	_is_Sutton_SignWriting}', "");
    Expect(1, 121520, '\p{^	_is_Sutton_SignWriting}', "");
    Expect(1, 121520, '\P{	_is_Sutton_SignWriting}', "");
    Expect(0, 121520, '\P{^	_is_Sutton_SignWriting}', "");
    Error('\p{/a/_	in_Sutton_SignWriting}');
    Error('\P{/a/_	in_Sutton_SignWriting}');
    Expect(1, 121519, '\p{insuttonsignwriting}', "");
    Expect(0, 121519, '\p{^insuttonsignwriting}', "");
    Expect(0, 121519, '\P{insuttonsignwriting}', "");
    Expect(1, 121519, '\P{^insuttonsignwriting}', "");
    Expect(0, 121520, '\p{insuttonsignwriting}', "");
    Expect(1, 121520, '\p{^insuttonsignwriting}', "");
    Expect(1, 121520, '\P{insuttonsignwriting}', "");
    Expect(0, 121520, '\P{^insuttonsignwriting}', "");
    Expect(1, 121519, '\p{	 IN_Sutton_SignWriting}', "");
    Expect(0, 121519, '\p{^	 IN_Sutton_SignWriting}', "");
    Expect(0, 121519, '\P{	 IN_Sutton_SignWriting}', "");
    Expect(1, 121519, '\P{^	 IN_Sutton_SignWriting}', "");
    Expect(0, 121520, '\p{	 IN_Sutton_SignWriting}', "");
    Expect(1, 121520, '\p{^	 IN_Sutton_SignWriting}', "");
    Expect(1, 121520, '\P{	 IN_Sutton_SignWriting}', "");
    Expect(0, 121520, '\P{^	 IN_Sutton_SignWriting}', "");
    Error('\p{:=	_Syloti_Nagri}');
    Error('\P{:=	_Syloti_Nagri}');
    Expect(1, 43051, '\p{sylotinagri}', "");
    Expect(0, 43051, '\p{^sylotinagri}', "");
    Expect(0, 43051, '\P{sylotinagri}', "");
    Expect(1, 43051, '\P{^sylotinagri}', "");
    Expect(0, 43052, '\p{sylotinagri}', "");
    Expect(1, 43052, '\p{^sylotinagri}', "");
    Expect(1, 43052, '\P{sylotinagri}', "");
    Expect(0, 43052, '\P{^sylotinagri}', "");
    Expect(1, 43051, '\p{-Syloti_nagri}', "");
    Expect(0, 43051, '\p{^-Syloti_nagri}', "");
    Expect(0, 43051, '\P{-Syloti_nagri}', "");
    Expect(1, 43051, '\P{^-Syloti_nagri}', "");
    Expect(0, 43052, '\p{-Syloti_nagri}', "");
    Expect(1, 43052, '\p{^-Syloti_nagri}', "");
    Expect(1, 43052, '\P{-Syloti_nagri}', "");
    Expect(0, 43052, '\P{^-Syloti_nagri}', "");
    Error('\p{	/a/IS_Syloti_Nagri}');
    Error('\P{	/a/IS_Syloti_Nagri}');
    Expect(1, 43051, '\p{issylotinagri}', "");
    Expect(0, 43051, '\p{^issylotinagri}', "");
    Expect(0, 43051, '\P{issylotinagri}', "");
    Expect(1, 43051, '\P{^issylotinagri}', "");
    Expect(0, 43052, '\p{issylotinagri}', "");
    Expect(1, 43052, '\p{^issylotinagri}', "");
    Expect(1, 43052, '\P{issylotinagri}', "");
    Expect(0, 43052, '\P{^issylotinagri}', "");
    Expect(1, 43051, '\p{_Is_Syloti_Nagri}', "");
    Expect(0, 43051, '\p{^_Is_Syloti_Nagri}', "");
    Expect(0, 43051, '\P{_Is_Syloti_Nagri}', "");
    Expect(1, 43051, '\P{^_Is_Syloti_Nagri}', "");
    Expect(0, 43052, '\p{_Is_Syloti_Nagri}', "");
    Expect(1, 43052, '\p{^_Is_Syloti_Nagri}', "");
    Expect(1, 43052, '\P{_Is_Syloti_Nagri}', "");
    Expect(0, 43052, '\P{^_Is_Syloti_Nagri}', "");
    Error('\p{	-sylo/a/}');
    Error('\P{	-sylo/a/}');
    Expect(1, 43051, '\p{sylo}', "");
    Expect(0, 43051, '\p{^sylo}', "");
    Expect(0, 43051, '\P{sylo}', "");
    Expect(1, 43051, '\P{^sylo}', "");
    Expect(0, 43052, '\p{sylo}', "");
    Expect(1, 43052, '\p{^sylo}', "");
    Expect(1, 43052, '\P{sylo}', "");
    Expect(0, 43052, '\P{^sylo}', "");
    Expect(1, 43051, '\p{__sylo}', "");
    Expect(0, 43051, '\p{^__sylo}', "");
    Expect(0, 43051, '\P{__sylo}', "");
    Expect(1, 43051, '\P{^__sylo}', "");
    Expect(0, 43052, '\p{__sylo}', "");
    Expect(1, 43052, '\p{^__sylo}', "");
    Expect(1, 43052, '\P{__sylo}', "");
    Expect(0, 43052, '\P{^__sylo}', "");
    Error('\p{:=IS_SYLO}');
    Error('\P{:=IS_SYLO}');
    Expect(1, 43051, '\p{issylo}', "");
    Expect(0, 43051, '\p{^issylo}', "");
    Expect(0, 43051, '\P{issylo}', "");
    Expect(1, 43051, '\P{^issylo}', "");
    Expect(0, 43052, '\p{issylo}', "");
    Expect(1, 43052, '\p{^issylo}', "");
    Expect(1, 43052, '\P{issylo}', "");
    Expect(0, 43052, '\P{^issylo}', "");
    Expect(1, 43051, '\p{- IS_Sylo}', "");
    Expect(0, 43051, '\p{^- IS_Sylo}', "");
    Expect(0, 43051, '\P{- IS_Sylo}', "");
    Expect(1, 43051, '\P{^- IS_Sylo}', "");
    Expect(0, 43052, '\p{- IS_Sylo}', "");
    Expect(1, 43052, '\p{^- IS_Sylo}', "");
    Expect(1, 43052, '\P{- IS_Sylo}', "");
    Expect(0, 43052, '\P{^- IS_Sylo}', "");
    Error('\p{-:=Symbol}');
    Error('\P{-:=Symbol}');
    Expect(1, 129685, '\p{symbol}', "");
    Expect(0, 129685, '\p{^symbol}', "");
    Expect(0, 129685, '\P{symbol}', "");
    Expect(1, 129685, '\P{^symbol}', "");
    Expect(0, 129686, '\p{symbol}', "");
    Expect(1, 129686, '\p{^symbol}', "");
    Expect(1, 129686, '\P{symbol}', "");
    Expect(0, 129686, '\P{^symbol}', "");
    Expect(1, 129685, '\p{-	Symbol}', "");
    Expect(0, 129685, '\p{^-	Symbol}', "");
    Expect(0, 129685, '\P{-	Symbol}', "");
    Expect(1, 129685, '\P{^-	Symbol}', "");
    Expect(0, 129686, '\p{-	Symbol}', "");
    Expect(1, 129686, '\p{^-	Symbol}', "");
    Expect(1, 129686, '\P{-	Symbol}', "");
    Expect(0, 129686, '\P{^-	Symbol}', "");
    Error('\p{_is_Symbol/a/}');
    Error('\P{_is_Symbol/a/}');
    Expect(1, 129685, '\p{issymbol}', "");
    Expect(0, 129685, '\p{^issymbol}', "");
    Expect(0, 129685, '\P{issymbol}', "");
    Expect(1, 129685, '\P{^issymbol}', "");
    Expect(0, 129686, '\p{issymbol}', "");
    Expect(1, 129686, '\p{^issymbol}', "");
    Expect(1, 129686, '\P{issymbol}', "");
    Expect(0, 129686, '\P{^issymbol}', "");
    Expect(1, 129685, '\p{  Is_SYMBOL}', "");
    Expect(0, 129685, '\p{^  Is_SYMBOL}', "");
    Expect(0, 129685, '\P{  Is_SYMBOL}', "");
    Expect(1, 129685, '\P{^  Is_SYMBOL}', "");
    Expect(0, 129686, '\p{  Is_SYMBOL}', "");
    Expect(1, 129686, '\p{^  Is_SYMBOL}', "");
    Expect(1, 129686, '\P{  Is_SYMBOL}', "");
    Expect(0, 129686, '\P{^  Is_SYMBOL}', "");
    Error('\p{  S/a/}');
    Error('\P{  S/a/}');
    Expect(1, 129685, '\p{s}', "");
    Expect(0, 129685, '\p{^s}', "");
    Expect(0, 129685, '\P{s}', "");
    Expect(1, 129685, '\P{^s}', "");
    Expect(0, 129686, '\p{s}', "");
    Expect(1, 129686, '\p{^s}', "");
    Expect(1, 129686, '\P{s}', "");
    Expect(0, 129686, '\P{^s}', "");
    Expect(1, 129685, '\p{  s}', "");
    Expect(0, 129685, '\p{^  s}', "");
    Expect(0, 129685, '\P{  s}', "");
    Expect(1, 129685, '\P{^  s}', "");
    Expect(0, 129686, '\p{  s}', "");
    Expect(1, 129686, '\p{^  s}', "");
    Expect(1, 129686, '\P{  s}', "");
    Expect(0, 129686, '\P{^  s}', "");
    Error('\p{--Is_s/a/}');
    Error('\P{--Is_s/a/}');
    Expect(1, 129685, '\p{iss}', "");
    Expect(0, 129685, '\p{^iss}', "");
    Expect(0, 129685, '\P{iss}', "");
    Expect(1, 129685, '\P{^iss}', "");
    Expect(0, 129686, '\p{iss}', "");
    Expect(1, 129686, '\p{^iss}', "");
    Expect(1, 129686, '\P{iss}', "");
    Expect(0, 129686, '\P{^iss}', "");
    Expect(1, 129685, '\p{	 Is_s}', "");
    Expect(0, 129685, '\p{^	 Is_s}', "");
    Expect(0, 129685, '\P{	 Is_s}', "");
    Expect(1, 129685, '\P{^	 Is_s}', "");
    Expect(0, 129686, '\p{	 Is_s}', "");
    Expect(1, 129686, '\p{^	 Is_s}', "");
    Expect(1, 129686, '\P{	 Is_s}', "");
    Expect(0, 129686, '\P{^	 Is_s}', "");
    Error('\p{	/a/Symbols_AND_Pictographs_Extended_a}');
    Error('\P{	/a/Symbols_AND_Pictographs_Extended_a}');
    Expect(1, 129791, '\p{symbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\p{^symbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\P{symbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\P{^symbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\p{symbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\p{^symbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\P{symbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\P{^symbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\p{	-symbols_And_Pictographs_Extended_A}', "");
    Expect(0, 129791, '\p{^	-symbols_And_Pictographs_Extended_A}', "");
    Expect(0, 129791, '\P{	-symbols_And_Pictographs_Extended_A}', "");
    Expect(1, 129791, '\P{^	-symbols_And_Pictographs_Extended_A}', "");
    Expect(0, 129792, '\p{	-symbols_And_Pictographs_Extended_A}', "");
    Expect(1, 129792, '\p{^	-symbols_And_Pictographs_Extended_A}', "");
    Expect(1, 129792, '\P{	-symbols_And_Pictographs_Extended_A}', "");
    Expect(0, 129792, '\P{^	-symbols_And_Pictographs_Extended_A}', "");
    Error('\p{/a/	IS_Symbols_and_pictographs_EXTENDED_a}');
    Error('\P{/a/	IS_Symbols_and_pictographs_EXTENDED_a}');
    Expect(1, 129791, '\p{issymbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\p{^issymbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\P{issymbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\P{^issymbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\p{issymbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\p{^issymbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\P{issymbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\P{^issymbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\p{-_Is_SYMBOLS_and_Pictographs_EXTENDED_A}', "");
    Expect(0, 129791, '\p{^-_Is_SYMBOLS_and_Pictographs_EXTENDED_A}', "");
    Expect(0, 129791, '\P{-_Is_SYMBOLS_and_Pictographs_EXTENDED_A}', "");
    Expect(1, 129791, '\P{^-_Is_SYMBOLS_and_Pictographs_EXTENDED_A}', "");
    Expect(0, 129792, '\p{-_Is_SYMBOLS_and_Pictographs_EXTENDED_A}', "");
    Expect(1, 129792, '\p{^-_Is_SYMBOLS_and_Pictographs_EXTENDED_A}', "");
    Expect(1, 129792, '\P{-_Is_SYMBOLS_and_Pictographs_EXTENDED_A}', "");
    Expect(0, 129792, '\P{^-_Is_SYMBOLS_and_Pictographs_EXTENDED_A}', "");
    Error('\p{:=	_In_Symbols_AND_Pictographs_EXTENDED_A}');
    Error('\P{:=	_In_Symbols_AND_Pictographs_EXTENDED_A}');
    Expect(1, 129791, '\p{insymbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\p{^insymbolsandpictographsextendeda}', "");
    Expect(0, 129791, '\P{insymbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\P{^insymbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\p{insymbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\p{^insymbolsandpictographsextendeda}', "");
    Expect(1, 129792, '\P{insymbolsandpictographsextendeda}', "");
    Expect(0, 129792, '\P{^insymbolsandpictographsextendeda}', "");
    Expect(1, 129791, '\p{	IN_Symbols_and_PICTOGRAPHS_Extended_A}', "");
    Expect(0, 129791, '\p{^	IN_Symbols_and_PICTOGRAPHS_Extended_A}', "");
    Expect(0, 129791, '\P{	IN_Symbols_and_PICTOGRAPHS_Extended_A}', "");
    Expect(1, 129791, '\P{^	IN_Symbols_and_PICTOGRAPHS_Extended_A}', "");
    Expect(0, 129792, '\p{	IN_Symbols_and_PICTOGRAPHS_Extended_A}', "");
    Expect(1, 129792, '\p{^	IN_Symbols_and_PICTOGRAPHS_Extended_A}', "");
    Expect(1, 129792, '\P{	IN_Symbols_and_PICTOGRAPHS_Extended_A}', "");
    Expect(0, 129792, '\P{^	IN_Symbols_and_PICTOGRAPHS_Extended_A}', "");
    Error('\p{	:=SYMBOLS_And_Pictographs_Ext_A}');
    Error('\P{	:=SYMBOLS_And_Pictographs_Ext_A}');
    Expect(1, 129791, '\p{symbolsandpictographsexta}', "");
    Expect(0, 129791, '\p{^symbolsandpictographsexta}', "");
    Expect(0, 129791, '\P{symbolsandpictographsexta}', "");
    Expect(1, 129791, '\P{^symbolsandpictographsexta}', "");
    Expect(0, 129792, '\p{symbolsandpictographsexta}', "");
    Expect(1, 129792, '\p{^symbolsandpictographsexta}', "");
    Expect(1, 129792, '\P{symbolsandpictographsexta}', "");
    Expect(0, 129792, '\P{^symbolsandpictographsexta}', "");
    Expect(1, 129791, '\p{ symbols_And_Pictographs_Ext_a}', "");
    Expect(0, 129791, '\p{^ symbols_And_Pictographs_Ext_a}', "");
    Expect(0, 129791, '\P{ symbols_And_Pictographs_Ext_a}', "");
    Expect(1, 129791, '\P{^ symbols_And_Pictographs_Ext_a}', "");
    Expect(0, 129792, '\p{ symbols_And_Pictographs_Ext_a}', "");
    Expect(1, 129792, '\p{^ symbols_And_Pictographs_Ext_a}', "");
    Expect(1, 129792, '\P{ symbols_And_Pictographs_Ext_a}', "");
    Expect(0, 129792, '\P{^ symbols_And_Pictographs_Ext_a}', "");
    Error('\p{	 Is_Symbols_AND_Pictographs_Ext_A/a/}');
    Error('\P{	 Is_Symbols_AND_Pictographs_Ext_A/a/}');
    Expect(1, 129791, '\p{issymbolsandpictographsexta}', "");
    Expect(0, 129791, '\p{^issymbolsandpictographsexta}', "");
    Expect(0, 129791, '\P{issymbolsandpictographsexta}', "");
    Expect(1, 129791, '\P{^issymbolsandpictographsexta}', "");
    Expect(0, 129792, '\p{issymbolsandpictographsexta}', "");
    Expect(1, 129792, '\p{^issymbolsandpictographsexta}', "");
    Expect(1, 129792, '\P{issymbolsandpictographsexta}', "");
    Expect(0, 129792, '\P{^issymbolsandpictographsexta}', "");
    Expect(1, 129791, '\p{_	is_SYMBOLS_and_PICTOGRAPHS_Ext_A}', "");
    Expect(0, 129791, '\p{^_	is_SYMBOLS_and_PICTOGRAPHS_Ext_A}', "");
    Expect(0, 129791, '\P{_	is_SYMBOLS_and_PICTOGRAPHS_Ext_A}', "");
    Expect(1, 129791, '\P{^_	is_SYMBOLS_and_PICTOGRAPHS_Ext_A}', "");
    Expect(0, 129792, '\p{_	is_SYMBOLS_and_PICTOGRAPHS_Ext_A}', "");
    Expect(1, 129792, '\p{^_	is_SYMBOLS_and_PICTOGRAPHS_Ext_A}', "");
    Expect(1, 129792, '\P{_	is_SYMBOLS_and_PICTOGRAPHS_Ext_A}', "");
    Expect(0, 129792, '\P{^_	is_SYMBOLS_and_PICTOGRAPHS_Ext_A}', "");
    Error('\p{:=-in_symbols_AND_Pictographs_EXT_a}');
    Error('\P{:=-in_symbols_AND_Pictographs_EXT_a}');
    Expect(1, 129791, '\p{insymbolsandpictographsexta}', "");
    Expect(0, 129791, '\p{^insymbolsandpictographsexta}', "");
    Expect(0, 129791, '\P{insymbolsandpictographsexta}', "");
    Expect(1, 129791, '\P{^insymbolsandpictographsexta}', "");
    Expect(0, 129792, '\p{insymbolsandpictographsexta}', "");
    Expect(1, 129792, '\p{^insymbolsandpictographsexta}', "");
    Expect(1, 129792, '\P{insymbolsandpictographsexta}', "");
    Expect(0, 129792, '\P{^insymbolsandpictographsexta}', "");
    Expect(1, 129791, '\p{-_In_SYMBOLS_And_pictographs_Ext_A}', "");
    Expect(0, 129791, '\p{^-_In_SYMBOLS_And_pictographs_Ext_A}', "");
    Expect(0, 129791, '\P{-_In_SYMBOLS_And_pictographs_Ext_A}', "");
    Expect(1, 129791, '\P{^-_In_SYMBOLS_And_pictographs_Ext_A}', "");
    Expect(0, 129792, '\p{-_In_SYMBOLS_And_pictographs_Ext_A}', "");
    Expect(1, 129792, '\p{^-_In_SYMBOLS_And_pictographs_Ext_A}', "");
    Expect(1, 129792, '\P{-_In_SYMBOLS_And_pictographs_Ext_A}', "");
    Expect(0, 129792, '\P{^-_In_SYMBOLS_And_pictographs_Ext_A}', "");
    Error('\p{:=_SYRIAC}');
    Error('\P{:=_SYRIAC}');
    Expect(1, 2154, '\p{syriac}', "");
    Expect(0, 2154, '\p{^syriac}', "");
    Expect(0, 2154, '\P{syriac}', "");
    Expect(1, 2154, '\P{^syriac}', "");
    Expect(0, 2155, '\p{syriac}', "");
    Expect(1, 2155, '\p{^syriac}', "");
    Expect(1, 2155, '\P{syriac}', "");
    Expect(0, 2155, '\P{^syriac}', "");
    Expect(1, 2154, '\p{ 	syriac}', "");
    Expect(0, 2154, '\p{^ 	syriac}', "");
    Expect(0, 2154, '\P{ 	syriac}', "");
    Expect(1, 2154, '\P{^ 	syriac}', "");
    Expect(0, 2155, '\p{ 	syriac}', "");
    Expect(1, 2155, '\p{^ 	syriac}', "");
    Expect(1, 2155, '\P{ 	syriac}', "");
    Expect(0, 2155, '\P{^ 	syriac}', "");
    Error('\p{	/a/IS_SYRIAC}');
    Error('\P{	/a/IS_SYRIAC}');
    Expect(1, 2154, '\p{issyriac}', "");
    Expect(0, 2154, '\p{^issyriac}', "");
    Expect(0, 2154, '\P{issyriac}', "");
    Expect(1, 2154, '\P{^issyriac}', "");
    Expect(0, 2155, '\p{issyriac}', "");
    Expect(1, 2155, '\p{^issyriac}', "");
    Expect(1, 2155, '\P{issyriac}', "");
    Expect(0, 2155, '\P{^issyriac}', "");
    Expect(1, 2154, '\p{-_Is_Syriac}', "");
    Expect(0, 2154, '\p{^-_Is_Syriac}', "");
    Expect(0, 2154, '\P{-_Is_Syriac}', "");
    Expect(1, 2154, '\P{^-_Is_Syriac}', "");
    Expect(0, 2155, '\p{-_Is_Syriac}', "");
    Expect(1, 2155, '\p{^-_Is_Syriac}', "");
    Expect(1, 2155, '\P{-_Is_Syriac}', "");
    Expect(0, 2155, '\P{^-_Is_Syriac}', "");
    Error('\p{ -Syrc:=}');
    Error('\P{ -Syrc:=}');
    Expect(1, 2154, '\p{syrc}', "");
    Expect(0, 2154, '\p{^syrc}', "");
    Expect(0, 2154, '\P{syrc}', "");
    Expect(1, 2154, '\P{^syrc}', "");
    Expect(0, 2155, '\p{syrc}', "");
    Expect(1, 2155, '\p{^syrc}', "");
    Expect(1, 2155, '\P{syrc}', "");
    Expect(0, 2155, '\P{^syrc}', "");
    Expect(1, 2154, '\p{	 SYRC}', "");
    Expect(0, 2154, '\p{^	 SYRC}', "");
    Expect(0, 2154, '\P{	 SYRC}', "");
    Expect(1, 2154, '\P{^	 SYRC}', "");
    Expect(0, 2155, '\p{	 SYRC}', "");
    Expect(1, 2155, '\p{^	 SYRC}', "");
    Expect(1, 2155, '\P{	 SYRC}', "");
    Expect(0, 2155, '\P{^	 SYRC}', "");
    Error('\p{:=--is_SYRC}');
    Error('\P{:=--is_SYRC}');
    Expect(1, 2154, '\p{issyrc}', "");
    Expect(0, 2154, '\p{^issyrc}', "");
    Expect(0, 2154, '\P{issyrc}', "");
    Expect(1, 2154, '\P{^issyrc}', "");
    Expect(0, 2155, '\p{issyrc}', "");
    Expect(1, 2155, '\p{^issyrc}', "");
    Expect(1, 2155, '\P{issyrc}', "");
    Expect(0, 2155, '\P{^issyrc}', "");
    Expect(1, 2154, '\p{ is_Syrc}', "");
    Expect(0, 2154, '\p{^ is_Syrc}', "");
    Expect(0, 2154, '\P{ is_Syrc}', "");
    Expect(1, 2154, '\P{^ is_Syrc}', "");
    Expect(0, 2155, '\p{ is_Syrc}', "");
    Expect(1, 2155, '\p{^ is_Syrc}', "");
    Expect(1, 2155, '\P{ is_Syrc}', "");
    Expect(0, 2155, '\P{^ is_Syrc}', "");
    Error('\p{:=_Syriac_supplement}');
    Error('\P{:=_Syriac_supplement}');
    Expect(1, 2159, '\p{syriacsupplement}', "");
    Expect(0, 2159, '\p{^syriacsupplement}', "");
    Expect(0, 2159, '\P{syriacsupplement}', "");
    Expect(1, 2159, '\P{^syriacsupplement}', "");
    Expect(0, 2160, '\p{syriacsupplement}', "");
    Expect(1, 2160, '\p{^syriacsupplement}', "");
    Expect(1, 2160, '\P{syriacsupplement}', "");
    Expect(0, 2160, '\P{^syriacsupplement}', "");
    Expect(1, 2159, '\p{		SYRIAC_Supplement}', "");
    Expect(0, 2159, '\p{^		SYRIAC_Supplement}', "");
    Expect(0, 2159, '\P{		SYRIAC_Supplement}', "");
    Expect(1, 2159, '\P{^		SYRIAC_Supplement}', "");
    Expect(0, 2160, '\p{		SYRIAC_Supplement}', "");
    Expect(1, 2160, '\p{^		SYRIAC_Supplement}', "");
    Expect(1, 2160, '\P{		SYRIAC_Supplement}', "");
    Expect(0, 2160, '\P{^		SYRIAC_Supplement}', "");
    Error('\p{/a/_	IS_Syriac_SUPPLEMENT}');
    Error('\P{/a/_	IS_Syriac_SUPPLEMENT}');
    Expect(1, 2159, '\p{issyriacsupplement}', "");
    Expect(0, 2159, '\p{^issyriacsupplement}', "");
    Expect(0, 2159, '\P{issyriacsupplement}', "");
    Expect(1, 2159, '\P{^issyriacsupplement}', "");
    Expect(0, 2160, '\p{issyriacsupplement}', "");
    Expect(1, 2160, '\p{^issyriacsupplement}', "");
    Expect(1, 2160, '\P{issyriacsupplement}', "");
    Expect(0, 2160, '\P{^issyriacsupplement}', "");
    Expect(1, 2159, '\p{- Is_Syriac_SUPPLEMENT}', "");
    Expect(0, 2159, '\p{^- Is_Syriac_SUPPLEMENT}', "");
    Expect(0, 2159, '\P{- Is_Syriac_SUPPLEMENT}', "");
    Expect(1, 2159, '\P{^- Is_Syriac_SUPPLEMENT}', "");
    Expect(0, 2160, '\p{- Is_Syriac_SUPPLEMENT}', "");
    Expect(1, 2160, '\p{^- Is_Syriac_SUPPLEMENT}', "");
    Expect(1, 2160, '\P{- Is_Syriac_SUPPLEMENT}', "");
    Expect(0, 2160, '\P{^- Is_Syriac_SUPPLEMENT}', "");
    Error('\p{/a/-in_Syriac_supplement}');
    Error('\P{/a/-in_Syriac_supplement}');
    Expect(1, 2159, '\p{insyriacsupplement}', "");
    Expect(0, 2159, '\p{^insyriacsupplement}', "");
    Expect(0, 2159, '\P{insyriacsupplement}', "");
    Expect(1, 2159, '\P{^insyriacsupplement}', "");
    Expect(0, 2160, '\p{insyriacsupplement}', "");
    Expect(1, 2160, '\p{^insyriacsupplement}', "");
    Expect(1, 2160, '\P{insyriacsupplement}', "");
    Expect(0, 2160, '\P{^insyriacsupplement}', "");
    Expect(1, 2159, '\p{	-In_SYRIAC_SUPPLEMENT}', "");
    Expect(0, 2159, '\p{^	-In_SYRIAC_SUPPLEMENT}', "");
    Expect(0, 2159, '\P{	-In_SYRIAC_SUPPLEMENT}', "");
    Expect(1, 2159, '\P{^	-In_SYRIAC_SUPPLEMENT}', "");
    Expect(0, 2160, '\p{	-In_SYRIAC_SUPPLEMENT}', "");
    Expect(1, 2160, '\p{^	-In_SYRIAC_SUPPLEMENT}', "");
    Expect(1, 2160, '\P{	-In_SYRIAC_SUPPLEMENT}', "");
    Expect(0, 2160, '\P{^	-In_SYRIAC_SUPPLEMENT}', "");
    Error('\p{/a/ -Syriac_Sup}');
    Error('\P{/a/ -Syriac_Sup}');
    Expect(1, 2159, '\p{syriacsup}', "");
    Expect(0, 2159, '\p{^syriacsup}', "");
    Expect(0, 2159, '\P{syriacsup}', "");
    Expect(1, 2159, '\P{^syriacsup}', "");
    Expect(0, 2160, '\p{syriacsup}', "");
    Expect(1, 2160, '\p{^syriacsup}', "");
    Expect(1, 2160, '\P{syriacsup}', "");
    Expect(0, 2160, '\P{^syriacsup}', "");
    Expect(1, 2159, '\p{ _Syriac_sup}', "");
    Expect(0, 2159, '\p{^ _Syriac_sup}', "");
    Expect(0, 2159, '\P{ _Syriac_sup}', "");
    Expect(1, 2159, '\P{^ _Syriac_sup}', "");
    Expect(0, 2160, '\p{ _Syriac_sup}', "");
    Expect(1, 2160, '\p{^ _Syriac_sup}', "");
    Expect(1, 2160, '\P{ _Syriac_sup}', "");
    Expect(0, 2160, '\P{^ _Syriac_sup}', "");
    Error('\p{/a/-_Is_Syriac_Sup}');
    Error('\P{/a/-_Is_Syriac_Sup}');
    Expect(1, 2159, '\p{issyriacsup}', "");
    Expect(0, 2159, '\p{^issyriacsup}', "");
    Expect(0, 2159, '\P{issyriacsup}', "");
    Expect(1, 2159, '\P{^issyriacsup}', "");
    Expect(0, 2160, '\p{issyriacsup}', "");
    Expect(1, 2160, '\p{^issyriacsup}', "");
    Expect(1, 2160, '\P{issyriacsup}', "");
    Expect(0, 2160, '\P{^issyriacsup}', "");
    Expect(1, 2159, '\p{ Is_Syriac_Sup}', "");
    Expect(0, 2159, '\p{^ Is_Syriac_Sup}', "");
    Expect(0, 2159, '\P{ Is_Syriac_Sup}', "");
    Expect(1, 2159, '\P{^ Is_Syriac_Sup}', "");
    Expect(0, 2160, '\p{ Is_Syriac_Sup}', "");
    Expect(1, 2160, '\p{^ Is_Syriac_Sup}', "");
    Expect(1, 2160, '\P{ Is_Syriac_Sup}', "");
    Expect(0, 2160, '\P{^ Is_Syriac_Sup}', "");
    Error('\p{-:=in_syriac_SUP}');
    Error('\P{-:=in_syriac_SUP}');
    Expect(1, 2159, '\p{insyriacsup}', "");
    Expect(0, 2159, '\p{^insyriacsup}', "");
    Expect(0, 2159, '\P{insyriacsup}', "");
    Expect(1, 2159, '\P{^insyriacsup}', "");
    Expect(0, 2160, '\p{insyriacsup}', "");
    Expect(1, 2160, '\p{^insyriacsup}', "");
    Expect(1, 2160, '\P{insyriacsup}', "");
    Expect(0, 2160, '\P{^insyriacsup}', "");
    Expect(1, 2159, '\p{ 	in_syriac_sup}', "");
    Expect(0, 2159, '\p{^ 	in_syriac_sup}', "");
    Expect(0, 2159, '\P{ 	in_syriac_sup}', "");
    Expect(1, 2159, '\P{^ 	in_syriac_sup}', "");
    Expect(0, 2160, '\p{ 	in_syriac_sup}', "");
    Expect(1, 2160, '\p{^ 	in_syriac_sup}', "");
    Expect(1, 2160, '\P{ 	in_syriac_sup}', "");
    Expect(0, 2160, '\P{^ 	in_syriac_sup}', "");
    Error('\p{:= TAGALOG}');
    Error('\P{:= TAGALOG}');
    Expect(1, 5942, '\p{tagalog}', "");
    Expect(0, 5942, '\p{^tagalog}', "");
    Expect(0, 5942, '\P{tagalog}', "");
    Expect(1, 5942, '\P{^tagalog}', "");
    Expect(0, 5943, '\p{tagalog}', "");
    Expect(1, 5943, '\p{^tagalog}', "");
    Expect(1, 5943, '\P{tagalog}', "");
    Expect(0, 5943, '\P{^tagalog}', "");
    Expect(1, 5942, '\p{  Tagalog}', "");
    Expect(0, 5942, '\p{^  Tagalog}', "");
    Expect(0, 5942, '\P{  Tagalog}', "");
    Expect(1, 5942, '\P{^  Tagalog}', "");
    Expect(0, 5943, '\p{  Tagalog}', "");
    Expect(1, 5943, '\p{^  Tagalog}', "");
    Expect(1, 5943, '\P{  Tagalog}', "");
    Expect(0, 5943, '\P{^  Tagalog}', "");
    Error('\p{-Is_tagalog:=}');
    Error('\P{-Is_tagalog:=}');
    Expect(1, 5942, '\p{istagalog}', "");
    Expect(0, 5942, '\p{^istagalog}', "");
    Expect(0, 5942, '\P{istagalog}', "");
    Expect(1, 5942, '\P{^istagalog}', "");
    Expect(0, 5943, '\p{istagalog}', "");
    Expect(1, 5943, '\p{^istagalog}', "");
    Expect(1, 5943, '\P{istagalog}', "");
    Expect(0, 5943, '\P{^istagalog}', "");
    Expect(1, 5942, '\p{ IS_Tagalog}', "");
    Expect(0, 5942, '\p{^ IS_Tagalog}', "");
    Expect(0, 5942, '\P{ IS_Tagalog}', "");
    Expect(1, 5942, '\P{^ IS_Tagalog}', "");
    Expect(0, 5943, '\p{ IS_Tagalog}', "");
    Expect(1, 5943, '\p{^ IS_Tagalog}', "");
    Expect(1, 5943, '\P{ IS_Tagalog}', "");
    Expect(0, 5943, '\P{^ IS_Tagalog}', "");
    Error('\p{	-Tglg/a/}');
    Error('\P{	-Tglg/a/}');
    Expect(1, 5942, '\p{tglg}', "");
    Expect(0, 5942, '\p{^tglg}', "");
    Expect(0, 5942, '\P{tglg}', "");
    Expect(1, 5942, '\P{^tglg}', "");
    Expect(0, 5943, '\p{tglg}', "");
    Expect(1, 5943, '\p{^tglg}', "");
    Expect(1, 5943, '\P{tglg}', "");
    Expect(0, 5943, '\P{^tglg}', "");
    Expect(1, 5942, '\p{ 	Tglg}', "");
    Expect(0, 5942, '\p{^ 	Tglg}', "");
    Expect(0, 5942, '\P{ 	Tglg}', "");
    Expect(1, 5942, '\P{^ 	Tglg}', "");
    Expect(0, 5943, '\p{ 	Tglg}', "");
    Expect(1, 5943, '\p{^ 	Tglg}', "");
    Expect(1, 5943, '\P{ 	Tglg}', "");
    Expect(0, 5943, '\P{^ 	Tglg}', "");
    Error('\p{:=is_TGLG}');
    Error('\P{:=is_TGLG}');
    Expect(1, 5942, '\p{istglg}', "");
    Expect(0, 5942, '\p{^istglg}', "");
    Expect(0, 5942, '\P{istglg}', "");
    Expect(1, 5942, '\P{^istglg}', "");
    Expect(0, 5943, '\p{istglg}', "");
    Expect(1, 5943, '\p{^istglg}', "");
    Expect(1, 5943, '\P{istglg}', "");
    Expect(0, 5943, '\P{^istglg}', "");
    Expect(1, 5942, '\p{	-Is_tglg}', "");
    Expect(0, 5942, '\p{^	-Is_tglg}', "");
    Expect(0, 5942, '\P{	-Is_tglg}', "");
    Expect(1, 5942, '\P{^	-Is_tglg}', "");
    Expect(0, 5943, '\p{	-Is_tglg}', "");
    Expect(1, 5943, '\p{^	-Is_tglg}', "");
    Expect(1, 5943, '\P{	-Is_tglg}', "");
    Expect(0, 5943, '\P{^	-Is_tglg}', "");
    Error('\p{- Tagbanwa:=}');
    Error('\P{- Tagbanwa:=}');
    Expect(1, 6003, '\p{tagbanwa}', "");
    Expect(0, 6003, '\p{^tagbanwa}', "");
    Expect(0, 6003, '\P{tagbanwa}', "");
    Expect(1, 6003, '\P{^tagbanwa}', "");
    Expect(0, 6004, '\p{tagbanwa}', "");
    Expect(1, 6004, '\p{^tagbanwa}', "");
    Expect(1, 6004, '\P{tagbanwa}', "");
    Expect(0, 6004, '\P{^tagbanwa}', "");
    Expect(1, 6003, '\p{	tagbanwa}', "");
    Expect(0, 6003, '\p{^	tagbanwa}', "");
    Expect(0, 6003, '\P{	tagbanwa}', "");
    Expect(1, 6003, '\P{^	tagbanwa}', "");
    Expect(0, 6004, '\p{	tagbanwa}', "");
    Expect(1, 6004, '\p{^	tagbanwa}', "");
    Expect(1, 6004, '\P{	tagbanwa}', "");
    Expect(0, 6004, '\P{^	tagbanwa}', "");
    Error('\p{_	IS_Tagbanwa:=}');
    Error('\P{_	IS_Tagbanwa:=}');
    Expect(1, 6003, '\p{istagbanwa}', "");
    Expect(0, 6003, '\p{^istagbanwa}', "");
    Expect(0, 6003, '\P{istagbanwa}', "");
    Expect(1, 6003, '\P{^istagbanwa}', "");
    Expect(0, 6004, '\p{istagbanwa}', "");
    Expect(1, 6004, '\p{^istagbanwa}', "");
    Expect(1, 6004, '\P{istagbanwa}', "");
    Expect(0, 6004, '\P{^istagbanwa}', "");
    Expect(1, 6003, '\p{_Is_Tagbanwa}', "");
    Expect(0, 6003, '\p{^_Is_Tagbanwa}', "");
    Expect(0, 6003, '\P{_Is_Tagbanwa}', "");
    Expect(1, 6003, '\P{^_Is_Tagbanwa}', "");
    Expect(0, 6004, '\p{_Is_Tagbanwa}', "");
    Expect(1, 6004, '\p{^_Is_Tagbanwa}', "");
    Expect(1, 6004, '\P{_Is_Tagbanwa}', "");
    Expect(0, 6004, '\P{^_Is_Tagbanwa}', "");
    Error('\p{/a/ tagb}');
    Error('\P{/a/ tagb}');
    Expect(1, 6003, '\p{tagb}', "");
    Expect(0, 6003, '\p{^tagb}', "");
    Expect(0, 6003, '\P{tagb}', "");
    Expect(1, 6003, '\P{^tagb}', "");
    Expect(0, 6004, '\p{tagb}', "");
    Expect(1, 6004, '\p{^tagb}', "");
    Expect(1, 6004, '\P{tagb}', "");
    Expect(0, 6004, '\P{^tagb}', "");
    Expect(1, 6003, '\p{--tagb}', "");
    Expect(0, 6003, '\p{^--tagb}', "");
    Expect(0, 6003, '\P{--tagb}', "");
    Expect(1, 6003, '\P{^--tagb}', "");
    Expect(0, 6004, '\p{--tagb}', "");
    Expect(1, 6004, '\p{^--tagb}', "");
    Expect(1, 6004, '\P{--tagb}', "");
    Expect(0, 6004, '\P{^--tagb}', "");
    Error('\p{_:=is_Tagb}');
    Error('\P{_:=is_Tagb}');
    Expect(1, 6003, '\p{istagb}', "");
    Expect(0, 6003, '\p{^istagb}', "");
    Expect(0, 6003, '\P{istagb}', "");
    Expect(1, 6003, '\P{^istagb}', "");
    Expect(0, 6004, '\p{istagb}', "");
    Expect(1, 6004, '\p{^istagb}', "");
    Expect(1, 6004, '\P{istagb}', "");
    Expect(0, 6004, '\P{^istagb}', "");
    Expect(1, 6003, '\p{_Is_tagb}', "");
    Expect(0, 6003, '\p{^_Is_tagb}', "");
    Expect(0, 6003, '\P{_Is_tagb}', "");
    Expect(1, 6003, '\P{^_Is_tagb}', "");
    Expect(0, 6004, '\p{_Is_tagb}', "");
    Expect(1, 6004, '\p{^_Is_tagb}', "");
    Expect(1, 6004, '\P{_Is_tagb}', "");
    Expect(0, 6004, '\P{^_Is_tagb}', "");
    Error('\p{_/a/Tags}');
    Error('\P{_/a/Tags}');
    Expect(1, 917631, '\p{tags}', "");
    Expect(0, 917631, '\p{^tags}', "");
    Expect(0, 917631, '\P{tags}', "");
    Expect(1, 917631, '\P{^tags}', "");
    Expect(0, 917632, '\p{tags}', "");
    Expect(1, 917632, '\p{^tags}', "");
    Expect(1, 917632, '\P{tags}', "");
    Expect(0, 917632, '\P{^tags}', "");
    Expect(1, 917631, '\p{_Tags}', "");
    Expect(0, 917631, '\p{^_Tags}', "");
    Expect(0, 917631, '\P{_Tags}', "");
    Expect(1, 917631, '\P{^_Tags}', "");
    Expect(0, 917632, '\p{_Tags}', "");
    Expect(1, 917632, '\p{^_Tags}', "");
    Expect(1, 917632, '\P{_Tags}', "");
    Expect(0, 917632, '\P{^_Tags}', "");
    Error('\p{/a/		Is_Tags}');
    Error('\P{/a/		Is_Tags}');
    Expect(1, 917631, '\p{istags}', "");
    Expect(0, 917631, '\p{^istags}', "");
    Expect(0, 917631, '\P{istags}', "");
    Expect(1, 917631, '\P{^istags}', "");
    Expect(0, 917632, '\p{istags}', "");
    Expect(1, 917632, '\p{^istags}', "");
    Expect(1, 917632, '\P{istags}', "");
    Expect(0, 917632, '\P{^istags}', "");
    Expect(1, 917631, '\p{		is_Tags}', "");
    Expect(0, 917631, '\p{^		is_Tags}', "");
    Expect(0, 917631, '\P{		is_Tags}', "");
    Expect(1, 917631, '\P{^		is_Tags}', "");
    Expect(0, 917632, '\p{		is_Tags}', "");
    Expect(1, 917632, '\p{^		is_Tags}', "");
    Expect(1, 917632, '\P{		is_Tags}', "");
    Expect(0, 917632, '\P{^		is_Tags}', "");
    Error('\p{/a/ -In_Tags}');
    Error('\P{/a/ -In_Tags}');
    Expect(1, 917631, '\p{intags}', "");
    Expect(0, 917631, '\p{^intags}', "");
    Expect(0, 917631, '\P{intags}', "");
    Expect(1, 917631, '\P{^intags}', "");
    Expect(0, 917632, '\p{intags}', "");
    Expect(1, 917632, '\p{^intags}', "");
    Expect(1, 917632, '\P{intags}', "");
    Expect(0, 917632, '\P{^intags}', "");
    Expect(1, 917631, '\p{__In_Tags}', "");
    Expect(0, 917631, '\p{^__In_Tags}', "");
    Expect(0, 917631, '\P{__In_Tags}', "");
    Expect(1, 917631, '\P{^__In_Tags}', "");
    Expect(0, 917632, '\p{__In_Tags}', "");
    Expect(1, 917632, '\p{^__In_Tags}', "");
    Expect(1, 917632, '\P{__In_Tags}', "");
    Expect(0, 917632, '\P{^__In_Tags}', "");
    Error('\p{:= -tai_LE}');
    Error('\P{:= -tai_LE}');
    Expect(1, 6516, '\p{taile}', "");
    Expect(0, 6516, '\p{^taile}', "");
    Expect(0, 6516, '\P{taile}', "");
    Expect(1, 6516, '\P{^taile}', "");
    Expect(0, 6517, '\p{taile}', "");
    Expect(1, 6517, '\p{^taile}', "");
    Expect(1, 6517, '\P{taile}', "");
    Expect(0, 6517, '\P{^taile}', "");
    Expect(1, 6516, '\p{_Tai_le}', "");
    Expect(0, 6516, '\p{^_Tai_le}', "");
    Expect(0, 6516, '\P{_Tai_le}', "");
    Expect(1, 6516, '\P{^_Tai_le}', "");
    Expect(0, 6517, '\p{_Tai_le}', "");
    Expect(1, 6517, '\p{^_Tai_le}', "");
    Expect(1, 6517, '\P{_Tai_le}', "");
    Expect(0, 6517, '\P{^_Tai_le}', "");
    Error('\p{-IS_TAI_LE/a/}');
    Error('\P{-IS_TAI_LE/a/}');
    Expect(1, 6516, '\p{istaile}', "");
    Expect(0, 6516, '\p{^istaile}', "");
    Expect(0, 6516, '\P{istaile}', "");
    Expect(1, 6516, '\P{^istaile}', "");
    Expect(0, 6517, '\p{istaile}', "");
    Expect(1, 6517, '\p{^istaile}', "");
    Expect(1, 6517, '\P{istaile}', "");
    Expect(0, 6517, '\P{^istaile}', "");
    Expect(1, 6516, '\p{ 	is_tai_Le}', "");
    Expect(0, 6516, '\p{^ 	is_tai_Le}', "");
    Expect(0, 6516, '\P{ 	is_tai_Le}', "");
    Expect(1, 6516, '\P{^ 	is_tai_Le}', "");
    Expect(0, 6517, '\p{ 	is_tai_Le}', "");
    Expect(1, 6517, '\p{^ 	is_tai_Le}', "");
    Expect(1, 6517, '\P{ 	is_tai_Le}', "");
    Expect(0, 6517, '\P{^ 	is_tai_Le}', "");
    Error('\p{_Tale/a/}');
    Error('\P{_Tale/a/}');
    Expect(1, 6516, '\p{tale}', "");
    Expect(0, 6516, '\p{^tale}', "");
    Expect(0, 6516, '\P{tale}', "");
    Expect(1, 6516, '\P{^tale}', "");
    Expect(0, 6517, '\p{tale}', "");
    Expect(1, 6517, '\p{^tale}', "");
    Expect(1, 6517, '\P{tale}', "");
    Expect(0, 6517, '\P{^tale}', "");
    Expect(1, 6516, '\p{_	Tale}', "");
    Expect(0, 6516, '\p{^_	Tale}', "");
    Expect(0, 6516, '\P{_	Tale}', "");
    Expect(1, 6516, '\P{^_	Tale}', "");
    Expect(0, 6517, '\p{_	Tale}', "");
    Expect(1, 6517, '\p{^_	Tale}', "");
    Expect(1, 6517, '\P{_	Tale}', "");
    Expect(0, 6517, '\P{^_	Tale}', "");
    Error('\p{-is_tale/a/}');
    Error('\P{-is_tale/a/}');
    Expect(1, 6516, '\p{istale}', "");
    Expect(0, 6516, '\p{^istale}', "");
    Expect(0, 6516, '\P{istale}', "");
    Expect(1, 6516, '\P{^istale}', "");
    Expect(0, 6517, '\p{istale}', "");
    Expect(1, 6517, '\p{^istale}', "");
    Expect(1, 6517, '\P{istale}', "");
    Expect(0, 6517, '\P{^istale}', "");
    Expect(1, 6516, '\p{_-is_TALE}', "");
    Expect(0, 6516, '\p{^_-is_TALE}', "");
    Expect(0, 6516, '\P{_-is_TALE}', "");
    Expect(1, 6516, '\P{^_-is_TALE}', "");
    Expect(0, 6517, '\p{_-is_TALE}', "");
    Expect(1, 6517, '\p{^_-is_TALE}', "");
    Expect(1, 6517, '\P{_-is_TALE}', "");
    Expect(0, 6517, '\P{^_-is_TALE}', "");
    Error('\p{-Tai_Tham:=}');
    Error('\P{-Tai_Tham:=}');
    Expect(1, 6829, '\p{taitham}', "");
    Expect(0, 6829, '\p{^taitham}', "");
    Expect(0, 6829, '\P{taitham}', "");
    Expect(1, 6829, '\P{^taitham}', "");
    Expect(0, 6830, '\p{taitham}', "");
    Expect(1, 6830, '\p{^taitham}', "");
    Expect(1, 6830, '\P{taitham}', "");
    Expect(0, 6830, '\P{^taitham}', "");
    Expect(1, 6829, '\p{__TAI_THAM}', "");
    Expect(0, 6829, '\p{^__TAI_THAM}', "");
    Expect(0, 6829, '\P{__TAI_THAM}', "");
    Expect(1, 6829, '\P{^__TAI_THAM}', "");
    Expect(0, 6830, '\p{__TAI_THAM}', "");
    Expect(1, 6830, '\p{^__TAI_THAM}', "");
    Expect(1, 6830, '\P{__TAI_THAM}', "");
    Expect(0, 6830, '\P{^__TAI_THAM}', "");
    Error('\p{_/a/IS_Tai_THAM}');
    Error('\P{_/a/IS_Tai_THAM}');
    Expect(1, 6829, '\p{istaitham}', "");
    Expect(0, 6829, '\p{^istaitham}', "");
    Expect(0, 6829, '\P{istaitham}', "");
    Expect(1, 6829, '\P{^istaitham}', "");
    Expect(0, 6830, '\p{istaitham}', "");
    Expect(1, 6830, '\p{^istaitham}', "");
    Expect(1, 6830, '\P{istaitham}', "");
    Expect(0, 6830, '\P{^istaitham}', "");
    Expect(1, 6829, '\p{--Is_Tai_tham}', "");
    Expect(0, 6829, '\p{^--Is_Tai_tham}', "");
    Expect(0, 6829, '\P{--Is_Tai_tham}', "");
    Expect(1, 6829, '\P{^--Is_Tai_tham}', "");
    Expect(0, 6830, '\p{--Is_Tai_tham}', "");
    Expect(1, 6830, '\p{^--Is_Tai_tham}', "");
    Expect(1, 6830, '\P{--Is_Tai_tham}', "");
    Expect(0, 6830, '\P{^--Is_Tai_tham}', "");
    Error('\p{	:=lana}');
    Error('\P{	:=lana}');
    Expect(1, 6829, '\p{lana}', "");
    Expect(0, 6829, '\p{^lana}', "");
    Expect(0, 6829, '\P{lana}', "");
    Expect(1, 6829, '\P{^lana}', "");
    Expect(0, 6830, '\p{lana}', "");
    Expect(1, 6830, '\p{^lana}', "");
    Expect(1, 6830, '\P{lana}', "");
    Expect(0, 6830, '\P{^lana}', "");
    Expect(1, 6829, '\p{Lana}', "");
    Expect(0, 6829, '\p{^Lana}', "");
    Expect(0, 6829, '\P{Lana}', "");
    Expect(1, 6829, '\P{^Lana}', "");
    Expect(0, 6830, '\p{Lana}', "");
    Expect(1, 6830, '\p{^Lana}', "");
    Expect(1, 6830, '\P{Lana}', "");
    Expect(0, 6830, '\P{^Lana}', "");
    Error('\p{/a/  is_Lana}');
    Error('\P{/a/  is_Lana}');
    Expect(1, 6829, '\p{islana}', "");
    Expect(0, 6829, '\p{^islana}', "");
    Expect(0, 6829, '\P{islana}', "");
    Expect(1, 6829, '\P{^islana}', "");
    Expect(0, 6830, '\p{islana}', "");
    Expect(1, 6830, '\p{^islana}', "");
    Expect(1, 6830, '\P{islana}', "");
    Expect(0, 6830, '\P{^islana}', "");
    Expect(1, 6829, '\p{	Is_Lana}', "");
    Expect(0, 6829, '\p{^	Is_Lana}', "");
    Expect(0, 6829, '\P{	Is_Lana}', "");
    Expect(1, 6829, '\P{^	Is_Lana}', "");
    Expect(0, 6830, '\p{	Is_Lana}', "");
    Expect(1, 6830, '\p{^	Is_Lana}', "");
    Expect(1, 6830, '\P{	Is_Lana}', "");
    Expect(0, 6830, '\P{^	Is_Lana}', "");
    Error('\p{	-TAI_VIET/a/}');
    Error('\P{	-TAI_VIET/a/}');
    Expect(1, 43743, '\p{taiviet}', "");
    Expect(0, 43743, '\p{^taiviet}', "");
    Expect(0, 43743, '\P{taiviet}', "");
    Expect(1, 43743, '\P{^taiviet}', "");
    Expect(0, 43744, '\p{taiviet}', "");
    Expect(1, 43744, '\p{^taiviet}', "");
    Expect(1, 43744, '\P{taiviet}', "");
    Expect(0, 43744, '\P{^taiviet}', "");
    Expect(1, 43743, '\p{	TAI_viet}', "");
    Expect(0, 43743, '\p{^	TAI_viet}', "");
    Expect(0, 43743, '\P{	TAI_viet}', "");
    Expect(1, 43743, '\P{^	TAI_viet}', "");
    Expect(0, 43744, '\p{	TAI_viet}', "");
    Expect(1, 43744, '\p{^	TAI_viet}', "");
    Expect(1, 43744, '\P{	TAI_viet}', "");
    Expect(0, 43744, '\P{^	TAI_viet}', "");
    Error('\p{/a/	is_tai_Viet}');
    Error('\P{/a/	is_tai_Viet}');
    Expect(1, 43743, '\p{istaiviet}', "");
    Expect(0, 43743, '\p{^istaiviet}', "");
    Expect(0, 43743, '\P{istaiviet}', "");
    Expect(1, 43743, '\P{^istaiviet}', "");
    Expect(0, 43744, '\p{istaiviet}', "");
    Expect(1, 43744, '\p{^istaiviet}', "");
    Expect(1, 43744, '\P{istaiviet}', "");
    Expect(0, 43744, '\P{^istaiviet}', "");
    Expect(1, 43743, '\p{		Is_tai_VIET}', "");
    Expect(0, 43743, '\p{^		Is_tai_VIET}', "");
    Expect(0, 43743, '\P{		Is_tai_VIET}', "");
    Expect(1, 43743, '\P{^		Is_tai_VIET}', "");
    Expect(0, 43744, '\p{		Is_tai_VIET}', "");
    Expect(1, 43744, '\p{^		Is_tai_VIET}', "");
    Expect(1, 43744, '\P{		Is_tai_VIET}', "");
    Expect(0, 43744, '\P{^		Is_tai_VIET}', "");
    Error('\p{-:=Tavt}');
    Error('\P{-:=Tavt}');
    Expect(1, 43743, '\p{tavt}', "");
    Expect(0, 43743, '\p{^tavt}', "");
    Expect(0, 43743, '\P{tavt}', "");
    Expect(1, 43743, '\P{^tavt}', "");
    Expect(0, 43744, '\p{tavt}', "");
    Expect(1, 43744, '\p{^tavt}', "");
    Expect(1, 43744, '\P{tavt}', "");
    Expect(0, 43744, '\P{^tavt}', "");
    Expect(1, 43743, '\p{ Tavt}', "");
    Expect(0, 43743, '\p{^ Tavt}', "");
    Expect(0, 43743, '\P{ Tavt}', "");
    Expect(1, 43743, '\P{^ Tavt}', "");
    Expect(0, 43744, '\p{ Tavt}', "");
    Expect(1, 43744, '\p{^ Tavt}', "");
    Expect(1, 43744, '\P{ Tavt}', "");
    Expect(0, 43744, '\P{^ Tavt}', "");
    Error('\p{_:=Is_tavt}');
    Error('\P{_:=Is_tavt}');
    Expect(1, 43743, '\p{istavt}', "");
    Expect(0, 43743, '\p{^istavt}', "");
    Expect(0, 43743, '\P{istavt}', "");
    Expect(1, 43743, '\P{^istavt}', "");
    Expect(0, 43744, '\p{istavt}', "");
    Expect(1, 43744, '\p{^istavt}', "");
    Expect(1, 43744, '\P{istavt}', "");
    Expect(0, 43744, '\P{^istavt}', "");
    Expect(1, 43743, '\p{--IS_TAVT}', "");
    Expect(0, 43743, '\p{^--IS_TAVT}', "");
    Expect(0, 43743, '\P{--IS_TAVT}', "");
    Expect(1, 43743, '\P{^--IS_TAVT}', "");
    Expect(0, 43744, '\p{--IS_TAVT}', "");
    Expect(1, 43744, '\p{^--IS_TAVT}', "");
    Expect(1, 43744, '\P{--IS_TAVT}', "");
    Expect(0, 43744, '\P{^--IS_TAVT}', "");
    Error('\p{	/a/tai_XUAN_JING_symbols}');
    Error('\P{	/a/tai_XUAN_JING_symbols}');
    Expect(1, 119647, '\p{taixuanjingsymbols}', "");
    Expect(0, 119647, '\p{^taixuanjingsymbols}', "");
    Expect(0, 119647, '\P{taixuanjingsymbols}', "");
    Expect(1, 119647, '\P{^taixuanjingsymbols}', "");
    Expect(0, 119648, '\p{taixuanjingsymbols}', "");
    Expect(1, 119648, '\p{^taixuanjingsymbols}', "");
    Expect(1, 119648, '\P{taixuanjingsymbols}', "");
    Expect(0, 119648, '\P{^taixuanjingsymbols}', "");
    Expect(1, 119647, '\p{ 	Tai_Xuan_Jing_Symbols}', "");
    Expect(0, 119647, '\p{^ 	Tai_Xuan_Jing_Symbols}', "");
    Expect(0, 119647, '\P{ 	Tai_Xuan_Jing_Symbols}', "");
    Expect(1, 119647, '\P{^ 	Tai_Xuan_Jing_Symbols}', "");
    Expect(0, 119648, '\p{ 	Tai_Xuan_Jing_Symbols}', "");
    Expect(1, 119648, '\p{^ 	Tai_Xuan_Jing_Symbols}', "");
    Expect(1, 119648, '\P{ 	Tai_Xuan_Jing_Symbols}', "");
    Expect(0, 119648, '\P{^ 	Tai_Xuan_Jing_Symbols}', "");
    Error('\p{_is_Tai_xuan_JING_Symbols/a/}');
    Error('\P{_is_Tai_xuan_JING_Symbols/a/}');
    Expect(1, 119647, '\p{istaixuanjingsymbols}', "");
    Expect(0, 119647, '\p{^istaixuanjingsymbols}', "");
    Expect(0, 119647, '\P{istaixuanjingsymbols}', "");
    Expect(1, 119647, '\P{^istaixuanjingsymbols}', "");
    Expect(0, 119648, '\p{istaixuanjingsymbols}', "");
    Expect(1, 119648, '\p{^istaixuanjingsymbols}', "");
    Expect(1, 119648, '\P{istaixuanjingsymbols}', "");
    Expect(0, 119648, '\P{^istaixuanjingsymbols}', "");
    Expect(1, 119647, '\p{	_IS_Tai_Xuan_jing_Symbols}', "");
    Expect(0, 119647, '\p{^	_IS_Tai_Xuan_jing_Symbols}', "");
    Expect(0, 119647, '\P{	_IS_Tai_Xuan_jing_Symbols}', "");
    Expect(1, 119647, '\P{^	_IS_Tai_Xuan_jing_Symbols}', "");
    Expect(0, 119648, '\p{	_IS_Tai_Xuan_jing_Symbols}', "");
    Expect(1, 119648, '\p{^	_IS_Tai_Xuan_jing_Symbols}', "");
    Expect(1, 119648, '\P{	_IS_Tai_Xuan_jing_Symbols}', "");
    Expect(0, 119648, '\P{^	_IS_Tai_Xuan_jing_Symbols}', "");
    Error('\p{-In_Tai_XUAN_JING_Symbols/a/}');
    Error('\P{-In_Tai_XUAN_JING_Symbols/a/}');
    Expect(1, 119647, '\p{intaixuanjingsymbols}', "");
    Expect(0, 119647, '\p{^intaixuanjingsymbols}', "");
    Expect(0, 119647, '\P{intaixuanjingsymbols}', "");
    Expect(1, 119647, '\P{^intaixuanjingsymbols}', "");
    Expect(0, 119648, '\p{intaixuanjingsymbols}', "");
    Expect(1, 119648, '\p{^intaixuanjingsymbols}', "");
    Expect(1, 119648, '\P{intaixuanjingsymbols}', "");
    Expect(0, 119648, '\P{^intaixuanjingsymbols}', "");
    Expect(1, 119647, '\p{	_In_TAI_xuan_Jing_Symbols}', "");
    Expect(0, 119647, '\p{^	_In_TAI_xuan_Jing_Symbols}', "");
    Expect(0, 119647, '\P{	_In_TAI_xuan_Jing_Symbols}', "");
    Expect(1, 119647, '\P{^	_In_TAI_xuan_Jing_Symbols}', "");
    Expect(0, 119648, '\p{	_In_TAI_xuan_Jing_Symbols}', "");
    Expect(1, 119648, '\p{^	_In_TAI_xuan_Jing_Symbols}', "");
    Expect(1, 119648, '\P{	_In_TAI_xuan_Jing_Symbols}', "");
    Expect(0, 119648, '\P{^	_In_TAI_xuan_Jing_Symbols}', "");
    Error('\p{	:=TAI_Xuan_Jing}');
    Error('\P{	:=TAI_Xuan_Jing}');
    Expect(1, 119647, '\p{taixuanjing}', "");
    Expect(0, 119647, '\p{^taixuanjing}', "");
    Expect(0, 119647, '\P{taixuanjing}', "");
    Expect(1, 119647, '\P{^taixuanjing}', "");
    Expect(0, 119648, '\p{taixuanjing}', "");
    Expect(1, 119648, '\p{^taixuanjing}', "");
    Expect(1, 119648, '\P{taixuanjing}', "");
    Expect(0, 119648, '\P{^taixuanjing}', "");
    Expect(1, 119647, '\p{ _Tai_XUAN_JING}', "");
    Expect(0, 119647, '\p{^ _Tai_XUAN_JING}', "");
    Expect(0, 119647, '\P{ _Tai_XUAN_JING}', "");
    Expect(1, 119647, '\P{^ _Tai_XUAN_JING}', "");
    Expect(0, 119648, '\p{ _Tai_XUAN_JING}', "");
    Expect(1, 119648, '\p{^ _Tai_XUAN_JING}', "");
    Expect(1, 119648, '\P{ _Tai_XUAN_JING}', "");
    Expect(0, 119648, '\P{^ _Tai_XUAN_JING}', "");
    Error('\p{-:=is_tai_Xuan_JING}');
    Error('\P{-:=is_tai_Xuan_JING}');
    Expect(1, 119647, '\p{istaixuanjing}', "");
    Expect(0, 119647, '\p{^istaixuanjing}', "");
    Expect(0, 119647, '\P{istaixuanjing}', "");
    Expect(1, 119647, '\P{^istaixuanjing}', "");
    Expect(0, 119648, '\p{istaixuanjing}', "");
    Expect(1, 119648, '\p{^istaixuanjing}', "");
    Expect(1, 119648, '\P{istaixuanjing}', "");
    Expect(0, 119648, '\P{^istaixuanjing}', "");
    Expect(1, 119647, '\p{-Is_Tai_xuan_jing}', "");
    Expect(0, 119647, '\p{^-Is_Tai_xuan_jing}', "");
    Expect(0, 119647, '\P{-Is_Tai_xuan_jing}', "");
    Expect(1, 119647, '\P{^-Is_Tai_xuan_jing}', "");
    Expect(0, 119648, '\p{-Is_Tai_xuan_jing}', "");
    Expect(1, 119648, '\p{^-Is_Tai_xuan_jing}', "");
    Expect(1, 119648, '\P{-Is_Tai_xuan_jing}', "");
    Expect(0, 119648, '\P{^-Is_Tai_xuan_jing}', "");
    Error('\p{_-In_tai_xuan_JING/a/}');
    Error('\P{_-In_tai_xuan_JING/a/}');
    Expect(1, 119647, '\p{intaixuanjing}', "");
    Expect(0, 119647, '\p{^intaixuanjing}', "");
    Expect(0, 119647, '\P{intaixuanjing}', "");
    Expect(1, 119647, '\P{^intaixuanjing}', "");
    Expect(0, 119648, '\p{intaixuanjing}', "");
    Expect(1, 119648, '\p{^intaixuanjing}', "");
    Expect(1, 119648, '\P{intaixuanjing}', "");
    Expect(0, 119648, '\P{^intaixuanjing}', "");
    Expect(1, 119647, '\p{	IN_Tai_xuan_Jing}', "");
    Expect(0, 119647, '\p{^	IN_Tai_xuan_Jing}', "");
    Expect(0, 119647, '\P{	IN_Tai_xuan_Jing}', "");
    Expect(1, 119647, '\P{^	IN_Tai_xuan_Jing}', "");
    Expect(0, 119648, '\p{	IN_Tai_xuan_Jing}', "");
    Expect(1, 119648, '\p{^	IN_Tai_xuan_Jing}', "");
    Expect(1, 119648, '\P{	IN_Tai_xuan_Jing}', "");
    Expect(0, 119648, '\P{^	IN_Tai_xuan_Jing}', "");
    Error('\p{	Takri:=}');
    Error('\P{	Takri:=}');
    Expect(1, 71369, '\p{takri}', "");
    Expect(0, 71369, '\p{^takri}', "");
    Expect(0, 71369, '\P{takri}', "");
    Expect(1, 71369, '\P{^takri}', "");
    Expect(0, 71370, '\p{takri}', "");
    Expect(1, 71370, '\p{^takri}', "");
    Expect(1, 71370, '\P{takri}', "");
    Expect(0, 71370, '\P{^takri}', "");
    Expect(1, 71369, '\p{	 TAKRI}', "");
    Expect(0, 71369, '\p{^	 TAKRI}', "");
    Expect(0, 71369, '\P{	 TAKRI}', "");
    Expect(1, 71369, '\P{^	 TAKRI}', "");
    Expect(0, 71370, '\p{	 TAKRI}', "");
    Expect(1, 71370, '\p{^	 TAKRI}', "");
    Expect(1, 71370, '\P{	 TAKRI}', "");
    Expect(0, 71370, '\P{^	 TAKRI}', "");
    Error('\p{-_IS_Takri:=}');
    Error('\P{-_IS_Takri:=}');
    Expect(1, 71369, '\p{istakri}', "");
    Expect(0, 71369, '\p{^istakri}', "");
    Expect(0, 71369, '\P{istakri}', "");
    Expect(1, 71369, '\P{^istakri}', "");
    Expect(0, 71370, '\p{istakri}', "");
    Expect(1, 71370, '\p{^istakri}', "");
    Expect(1, 71370, '\P{istakri}', "");
    Expect(0, 71370, '\P{^istakri}', "");
    Expect(1, 71369, '\p{-_Is_Takri}', "");
    Expect(0, 71369, '\p{^-_Is_Takri}', "");
    Expect(0, 71369, '\P{-_Is_Takri}', "");
    Expect(1, 71369, '\P{^-_Is_Takri}', "");
    Expect(0, 71370, '\p{-_Is_Takri}', "");
    Expect(1, 71370, '\p{^-_Is_Takri}', "");
    Expect(1, 71370, '\P{-_Is_Takri}', "");
    Expect(0, 71370, '\P{^-_Is_Takri}', "");
    Error('\p{_/a/takr}');
    Error('\P{_/a/takr}');
    Expect(1, 71369, '\p{takr}', "");
    Expect(0, 71369, '\p{^takr}', "");
    Expect(0, 71369, '\P{takr}', "");
    Expect(1, 71369, '\P{^takr}', "");
    Expect(0, 71370, '\p{takr}', "");
    Expect(1, 71370, '\p{^takr}', "");
    Expect(1, 71370, '\P{takr}', "");
    Expect(0, 71370, '\P{^takr}', "");
    Expect(1, 71369, '\p{-	TAKR}', "");
    Expect(0, 71369, '\p{^-	TAKR}', "");
    Expect(0, 71369, '\P{-	TAKR}', "");
    Expect(1, 71369, '\P{^-	TAKR}', "");
    Expect(0, 71370, '\p{-	TAKR}', "");
    Expect(1, 71370, '\p{^-	TAKR}', "");
    Expect(1, 71370, '\P{-	TAKR}', "");
    Expect(0, 71370, '\P{^-	TAKR}', "");
    Error('\p{		is_takr/a/}');
    Error('\P{		is_takr/a/}');
    Expect(1, 71369, '\p{istakr}', "");
    Expect(0, 71369, '\p{^istakr}', "");
    Expect(0, 71369, '\P{istakr}', "");
    Expect(1, 71369, '\P{^istakr}', "");
    Expect(0, 71370, '\p{istakr}', "");
    Expect(1, 71370, '\p{^istakr}', "");
    Expect(1, 71370, '\P{istakr}', "");
    Expect(0, 71370, '\P{^istakr}', "");
    Expect(1, 71369, '\p{-Is_Takr}', "");
    Expect(0, 71369, '\p{^-Is_Takr}', "");
    Expect(0, 71369, '\P{-Is_Takr}', "");
    Expect(1, 71369, '\P{^-Is_Takr}', "");
    Expect(0, 71370, '\p{-Is_Takr}', "");
    Expect(1, 71370, '\p{^-Is_Takr}', "");
    Expect(1, 71370, '\P{-Is_Takr}', "");
    Expect(0, 71370, '\P{^-Is_Takr}', "");
    Error('\p{-:=Tamil}');
    Error('\P{-:=Tamil}');
    Expect(1, 73727, '\p{tamil}', "");
    Expect(0, 73727, '\p{^tamil}', "");
    Expect(0, 73727, '\P{tamil}', "");
    Expect(1, 73727, '\P{^tamil}', "");
    Expect(0, 73728, '\p{tamil}', "");
    Expect(1, 73728, '\p{^tamil}', "");
    Expect(1, 73728, '\P{tamil}', "");
    Expect(0, 73728, '\P{^tamil}', "");
    Expect(1, 73727, '\p{		Tamil}', "");
    Expect(0, 73727, '\p{^		Tamil}', "");
    Expect(0, 73727, '\P{		Tamil}', "");
    Expect(1, 73727, '\P{^		Tamil}', "");
    Expect(0, 73728, '\p{		Tamil}', "");
    Expect(1, 73728, '\p{^		Tamil}', "");
    Expect(1, 73728, '\P{		Tamil}', "");
    Expect(0, 73728, '\P{^		Tamil}', "");
    Error('\p{/a/ _Is_Tamil}');
    Error('\P{/a/ _Is_Tamil}');
    Expect(1, 73727, '\p{istamil}', "");
    Expect(0, 73727, '\p{^istamil}', "");
    Expect(0, 73727, '\P{istamil}', "");
    Expect(1, 73727, '\P{^istamil}', "");
    Expect(0, 73728, '\p{istamil}', "");
    Expect(1, 73728, '\p{^istamil}', "");
    Expect(1, 73728, '\P{istamil}', "");
    Expect(0, 73728, '\P{^istamil}', "");
    Expect(1, 73727, '\p{	 IS_Tamil}', "");
    Expect(0, 73727, '\p{^	 IS_Tamil}', "");
    Expect(0, 73727, '\P{	 IS_Tamil}', "");
    Expect(1, 73727, '\P{^	 IS_Tamil}', "");
    Expect(0, 73728, '\p{	 IS_Tamil}', "");
    Expect(1, 73728, '\p{^	 IS_Tamil}', "");
    Expect(1, 73728, '\P{	 IS_Tamil}', "");
    Expect(0, 73728, '\P{^	 IS_Tamil}', "");
    Error('\p{/a/	 TAML}');
    Error('\P{/a/	 TAML}');
    Expect(1, 73727, '\p{taml}', "");
    Expect(0, 73727, '\p{^taml}', "");
    Expect(0, 73727, '\P{taml}', "");
    Expect(1, 73727, '\P{^taml}', "");
    Expect(0, 73728, '\p{taml}', "");
    Expect(1, 73728, '\p{^taml}', "");
    Expect(1, 73728, '\P{taml}', "");
    Expect(0, 73728, '\P{^taml}', "");
    Expect(1, 73727, '\p{ Taml}', "");
    Expect(0, 73727, '\p{^ Taml}', "");
    Expect(0, 73727, '\P{ Taml}', "");
    Expect(1, 73727, '\P{^ Taml}', "");
    Expect(0, 73728, '\p{ Taml}', "");
    Expect(1, 73728, '\p{^ Taml}', "");
    Expect(1, 73728, '\P{ Taml}', "");
    Expect(0, 73728, '\P{^ Taml}', "");
    Error('\p{	:=Is_Taml}');
    Error('\P{	:=Is_Taml}');
    Expect(1, 73727, '\p{istaml}', "");
    Expect(0, 73727, '\p{^istaml}', "");
    Expect(0, 73727, '\P{istaml}', "");
    Expect(1, 73727, '\P{^istaml}', "");
    Expect(0, 73728, '\p{istaml}', "");
    Expect(1, 73728, '\p{^istaml}', "");
    Expect(1, 73728, '\P{istaml}', "");
    Expect(0, 73728, '\P{^istaml}', "");
    Expect(1, 73727, '\p{IS_taml}', "");
    Expect(0, 73727, '\p{^IS_taml}', "");
    Expect(0, 73727, '\P{IS_taml}', "");
    Expect(1, 73727, '\P{^IS_taml}', "");
    Expect(0, 73728, '\p{IS_taml}', "");
    Expect(1, 73728, '\p{^IS_taml}', "");
    Expect(1, 73728, '\P{IS_taml}', "");
    Expect(0, 73728, '\P{^IS_taml}', "");
    Error('\p{ /a/Tamil_Supplement}');
    Error('\P{ /a/Tamil_Supplement}');
    Expect(1, 73727, '\p{tamilsupplement}', "");
    Expect(0, 73727, '\p{^tamilsupplement}', "");
    Expect(0, 73727, '\P{tamilsupplement}', "");
    Expect(1, 73727, '\P{^tamilsupplement}', "");
    Expect(0, 73728, '\p{tamilsupplement}', "");
    Expect(1, 73728, '\p{^tamilsupplement}', "");
    Expect(1, 73728, '\P{tamilsupplement}', "");
    Expect(0, 73728, '\P{^tamilsupplement}', "");
    Expect(1, 73727, '\p{	 Tamil_Supplement}', "");
    Expect(0, 73727, '\p{^	 Tamil_Supplement}', "");
    Expect(0, 73727, '\P{	 Tamil_Supplement}', "");
    Expect(1, 73727, '\P{^	 Tamil_Supplement}', "");
    Expect(0, 73728, '\p{	 Tamil_Supplement}', "");
    Expect(1, 73728, '\p{^	 Tamil_Supplement}', "");
    Expect(1, 73728, '\P{	 Tamil_Supplement}', "");
    Expect(0, 73728, '\P{^	 Tamil_Supplement}', "");
    Error('\p{/a/_IS_tamil_Supplement}');
    Error('\P{/a/_IS_tamil_Supplement}');
    Expect(1, 73727, '\p{istamilsupplement}', "");
    Expect(0, 73727, '\p{^istamilsupplement}', "");
    Expect(0, 73727, '\P{istamilsupplement}', "");
    Expect(1, 73727, '\P{^istamilsupplement}', "");
    Expect(0, 73728, '\p{istamilsupplement}', "");
    Expect(1, 73728, '\p{^istamilsupplement}', "");
    Expect(1, 73728, '\P{istamilsupplement}', "");
    Expect(0, 73728, '\P{^istamilsupplement}', "");
    Expect(1, 73727, '\p{	IS_Tamil_Supplement}', "");
    Expect(0, 73727, '\p{^	IS_Tamil_Supplement}', "");
    Expect(0, 73727, '\P{	IS_Tamil_Supplement}', "");
    Expect(1, 73727, '\P{^	IS_Tamil_Supplement}', "");
    Expect(0, 73728, '\p{	IS_Tamil_Supplement}', "");
    Expect(1, 73728, '\p{^	IS_Tamil_Supplement}', "");
    Expect(1, 73728, '\P{	IS_Tamil_Supplement}', "");
    Expect(0, 73728, '\P{^	IS_Tamil_Supplement}', "");
    Error('\p{:=--In_Tamil_Supplement}');
    Error('\P{:=--In_Tamil_Supplement}');
    Expect(1, 73727, '\p{intamilsupplement}', "");
    Expect(0, 73727, '\p{^intamilsupplement}', "");
    Expect(0, 73727, '\P{intamilsupplement}', "");
    Expect(1, 73727, '\P{^intamilsupplement}', "");
    Expect(0, 73728, '\p{intamilsupplement}', "");
    Expect(1, 73728, '\p{^intamilsupplement}', "");
    Expect(1, 73728, '\P{intamilsupplement}', "");
    Expect(0, 73728, '\P{^intamilsupplement}', "");
    Expect(1, 73727, '\p{- In_Tamil_Supplement}', "");
    Expect(0, 73727, '\p{^- In_Tamil_Supplement}', "");
    Expect(0, 73727, '\P{- In_Tamil_Supplement}', "");
    Expect(1, 73727, '\P{^- In_Tamil_Supplement}', "");
    Expect(0, 73728, '\p{- In_Tamil_Supplement}', "");
    Expect(1, 73728, '\p{^- In_Tamil_Supplement}', "");
    Expect(1, 73728, '\P{- In_Tamil_Supplement}', "");
    Expect(0, 73728, '\P{^- In_Tamil_Supplement}', "");
    Error('\p{/a/ _tamil_Sup}');
    Error('\P{/a/ _tamil_Sup}');
    Expect(1, 73727, '\p{tamilsup}', "");
    Expect(0, 73727, '\p{^tamilsup}', "");
    Expect(0, 73727, '\P{tamilsup}', "");
    Expect(1, 73727, '\P{^tamilsup}', "");
    Expect(0, 73728, '\p{tamilsup}', "");
    Expect(1, 73728, '\p{^tamilsup}', "");
    Expect(1, 73728, '\P{tamilsup}', "");
    Expect(0, 73728, '\P{^tamilsup}', "");
    Expect(1, 73727, '\p{_Tamil_Sup}', "");
    Expect(0, 73727, '\p{^_Tamil_Sup}', "");
    Expect(0, 73727, '\P{_Tamil_Sup}', "");
    Expect(1, 73727, '\P{^_Tamil_Sup}', "");
    Expect(0, 73728, '\p{_Tamil_Sup}', "");
    Expect(1, 73728, '\p{^_Tamil_Sup}', "");
    Expect(1, 73728, '\P{_Tamil_Sup}', "");
    Expect(0, 73728, '\P{^_Tamil_Sup}', "");
    Error('\p{ 	Is_TAMIL_Sup/a/}');
    Error('\P{ 	Is_TAMIL_Sup/a/}');
    Expect(1, 73727, '\p{istamilsup}', "");
    Expect(0, 73727, '\p{^istamilsup}', "");
    Expect(0, 73727, '\P{istamilsup}', "");
    Expect(1, 73727, '\P{^istamilsup}', "");
    Expect(0, 73728, '\p{istamilsup}', "");
    Expect(1, 73728, '\p{^istamilsup}', "");
    Expect(1, 73728, '\P{istamilsup}', "");
    Expect(0, 73728, '\P{^istamilsup}', "");
    Expect(1, 73727, '\p{__Is_Tamil_sup}', "");
    Expect(0, 73727, '\p{^__Is_Tamil_sup}', "");
    Expect(0, 73727, '\P{__Is_Tamil_sup}', "");
    Expect(1, 73727, '\P{^__Is_Tamil_sup}', "");
    Expect(0, 73728, '\p{__Is_Tamil_sup}', "");
    Expect(1, 73728, '\p{^__Is_Tamil_sup}', "");
    Expect(1, 73728, '\P{__Is_Tamil_sup}', "");
    Expect(0, 73728, '\P{^__Is_Tamil_sup}', "");
    Error('\p{-:=In_tamil_Sup}');
    Error('\P{-:=In_tamil_Sup}');
    Expect(1, 73727, '\p{intamilsup}', "");
    Expect(0, 73727, '\p{^intamilsup}', "");
    Expect(0, 73727, '\P{intamilsup}', "");
    Expect(1, 73727, '\P{^intamilsup}', "");
    Expect(0, 73728, '\p{intamilsup}', "");
    Expect(1, 73728, '\p{^intamilsup}', "");
    Expect(1, 73728, '\P{intamilsup}', "");
    Expect(0, 73728, '\P{^intamilsup}', "");
    Expect(1, 73727, '\p{-_IN_Tamil_Sup}', "");
    Expect(0, 73727, '\p{^-_IN_Tamil_Sup}', "");
    Expect(0, 73727, '\P{-_IN_Tamil_Sup}', "");
    Expect(1, 73727, '\P{^-_IN_Tamil_Sup}', "");
    Expect(0, 73728, '\p{-_IN_Tamil_Sup}', "");
    Expect(1, 73728, '\p{^-_IN_Tamil_Sup}', "");
    Expect(1, 73728, '\P{-_IN_Tamil_Sup}', "");
    Expect(0, 73728, '\P{^-_IN_Tamil_Sup}', "");
    Error('\p{	/a/tangut}');
    Error('\P{	/a/tangut}');
    Expect(1, 101106, '\p{tangut}', "");
    Expect(0, 101106, '\p{^tangut}', "");
    Expect(0, 101106, '\P{tangut}', "");
    Expect(1, 101106, '\P{^tangut}', "");
    Expect(0, 101107, '\p{tangut}', "");
    Expect(1, 101107, '\p{^tangut}', "");
    Expect(1, 101107, '\P{tangut}', "");
    Expect(0, 101107, '\P{^tangut}', "");
    Expect(1, 101106, '\p{ 	TANGUT}', "");
    Expect(0, 101106, '\p{^ 	TANGUT}', "");
    Expect(0, 101106, '\P{ 	TANGUT}', "");
    Expect(1, 101106, '\P{^ 	TANGUT}', "");
    Expect(0, 101107, '\p{ 	TANGUT}', "");
    Expect(1, 101107, '\p{^ 	TANGUT}', "");
    Expect(1, 101107, '\P{ 	TANGUT}', "");
    Expect(0, 101107, '\P{^ 	TANGUT}', "");
    Error('\p{:=-Is_Tangut}');
    Error('\P{:=-Is_Tangut}');
    Expect(1, 101106, '\p{istangut}', "");
    Expect(0, 101106, '\p{^istangut}', "");
    Expect(0, 101106, '\P{istangut}', "");
    Expect(1, 101106, '\P{^istangut}', "");
    Expect(0, 101107, '\p{istangut}', "");
    Expect(1, 101107, '\p{^istangut}', "");
    Expect(1, 101107, '\P{istangut}', "");
    Expect(0, 101107, '\P{^istangut}', "");
    Expect(1, 101106, '\p{	is_TANGUT}', "");
    Expect(0, 101106, '\p{^	is_TANGUT}', "");
    Expect(0, 101106, '\P{	is_TANGUT}', "");
    Expect(1, 101106, '\P{^	is_TANGUT}', "");
    Expect(0, 101107, '\p{	is_TANGUT}', "");
    Expect(1, 101107, '\p{^	is_TANGUT}', "");
    Expect(1, 101107, '\P{	is_TANGUT}', "");
    Expect(0, 101107, '\P{^	is_TANGUT}', "");
    Error('\p{/a/	Tang}');
    Error('\P{/a/	Tang}');
    Expect(1, 101106, '\p{tang}', "");
    Expect(0, 101106, '\p{^tang}', "");
    Expect(0, 101106, '\P{tang}', "");
    Expect(1, 101106, '\P{^tang}', "");
    Expect(0, 101107, '\p{tang}', "");
    Expect(1, 101107, '\p{^tang}', "");
    Expect(1, 101107, '\P{tang}', "");
    Expect(0, 101107, '\P{^tang}', "");
    Expect(1, 101106, '\p{_-TANG}', "");
    Expect(0, 101106, '\p{^_-TANG}', "");
    Expect(0, 101106, '\P{_-TANG}', "");
    Expect(1, 101106, '\P{^_-TANG}', "");
    Expect(0, 101107, '\p{_-TANG}', "");
    Expect(1, 101107, '\p{^_-TANG}', "");
    Expect(1, 101107, '\P{_-TANG}', "");
    Expect(0, 101107, '\P{^_-TANG}', "");
    Error('\p{ /a/Is_TANG}');
    Error('\P{ /a/Is_TANG}');
    Expect(1, 101106, '\p{istang}', "");
    Expect(0, 101106, '\p{^istang}', "");
    Expect(0, 101106, '\P{istang}', "");
    Expect(1, 101106, '\P{^istang}', "");
    Expect(0, 101107, '\p{istang}', "");
    Expect(1, 101107, '\p{^istang}', "");
    Expect(1, 101107, '\P{istang}', "");
    Expect(0, 101107, '\P{^istang}', "");
    Expect(1, 101106, '\p{	_IS_tang}', "");
    Expect(0, 101106, '\p{^	_IS_tang}', "");
    Expect(0, 101106, '\P{	_IS_tang}', "");
    Expect(1, 101106, '\P{^	_IS_tang}', "");
    Expect(0, 101107, '\p{	_IS_tang}', "");
    Expect(1, 101107, '\p{^	_IS_tang}', "");
    Expect(1, 101107, '\P{	_IS_tang}', "");
    Expect(0, 101107, '\P{^	_IS_tang}', "");
    Error('\p{-:=Tangut_Components}');
    Error('\P{-:=Tangut_Components}');
    Expect(1, 101119, '\p{tangutcomponents}', "");
    Expect(0, 101119, '\p{^tangutcomponents}', "");
    Expect(0, 101119, '\P{tangutcomponents}', "");
    Expect(1, 101119, '\P{^tangutcomponents}', "");
    Expect(0, 101120, '\p{tangutcomponents}', "");
    Expect(1, 101120, '\p{^tangutcomponents}', "");
    Expect(1, 101120, '\P{tangutcomponents}', "");
    Expect(0, 101120, '\P{^tangutcomponents}', "");
    Expect(1, 101119, '\p{  Tangut_Components}', "");
    Expect(0, 101119, '\p{^  Tangut_Components}', "");
    Expect(0, 101119, '\P{  Tangut_Components}', "");
    Expect(1, 101119, '\P{^  Tangut_Components}', "");
    Expect(0, 101120, '\p{  Tangut_Components}', "");
    Expect(1, 101120, '\p{^  Tangut_Components}', "");
    Expect(1, 101120, '\P{  Tangut_Components}', "");
    Expect(0, 101120, '\P{^  Tangut_Components}', "");
    Error('\p{/a/Is_Tangut_Components}');
    Error('\P{/a/Is_Tangut_Components}');
    Expect(1, 101119, '\p{istangutcomponents}', "");
    Expect(0, 101119, '\p{^istangutcomponents}', "");
    Expect(0, 101119, '\P{istangutcomponents}', "");
    Expect(1, 101119, '\P{^istangutcomponents}', "");
    Expect(0, 101120, '\p{istangutcomponents}', "");
    Expect(1, 101120, '\p{^istangutcomponents}', "");
    Expect(1, 101120, '\P{istangutcomponents}', "");
    Expect(0, 101120, '\P{^istangutcomponents}', "");
    Expect(1, 101119, '\p{ 	is_Tangut_Components}', "");
    Expect(0, 101119, '\p{^ 	is_Tangut_Components}', "");
    Expect(0, 101119, '\P{ 	is_Tangut_Components}', "");
    Expect(1, 101119, '\P{^ 	is_Tangut_Components}', "");
    Expect(0, 101120, '\p{ 	is_Tangut_Components}', "");
    Expect(1, 101120, '\p{^ 	is_Tangut_Components}', "");
    Expect(1, 101120, '\P{ 	is_Tangut_Components}', "");
    Expect(0, 101120, '\P{^ 	is_Tangut_Components}', "");
    Error('\p{-:=In_tangut_Components}');
    Error('\P{-:=In_tangut_Components}');
    Expect(1, 101119, '\p{intangutcomponents}', "");
    Expect(0, 101119, '\p{^intangutcomponents}', "");
    Expect(0, 101119, '\P{intangutcomponents}', "");
    Expect(1, 101119, '\P{^intangutcomponents}', "");
    Expect(0, 101120, '\p{intangutcomponents}', "");
    Expect(1, 101120, '\p{^intangutcomponents}', "");
    Expect(1, 101120, '\P{intangutcomponents}', "");
    Expect(0, 101120, '\P{^intangutcomponents}', "");
    Expect(1, 101119, '\p{ _In_Tangut_COMPONENTS}', "");
    Expect(0, 101119, '\p{^ _In_Tangut_COMPONENTS}', "");
    Expect(0, 101119, '\P{ _In_Tangut_COMPONENTS}', "");
    Expect(1, 101119, '\P{^ _In_Tangut_COMPONENTS}', "");
    Expect(0, 101120, '\p{ _In_Tangut_COMPONENTS}', "");
    Expect(1, 101120, '\p{^ _In_Tangut_COMPONENTS}', "");
    Expect(1, 101120, '\P{ _In_Tangut_COMPONENTS}', "");
    Expect(0, 101120, '\P{^ _In_Tangut_COMPONENTS}', "");
    Error('\p{ /a/Telugu}');
    Error('\P{ /a/Telugu}');
    Expect(1, 7410, '\p{telugu}', "");
    Expect(0, 7410, '\p{^telugu}', "");
    Expect(0, 7410, '\P{telugu}', "");
    Expect(1, 7410, '\P{^telugu}', "");
    Expect(0, 7411, '\p{telugu}', "");
    Expect(1, 7411, '\p{^telugu}', "");
    Expect(1, 7411, '\P{telugu}', "");
    Expect(0, 7411, '\P{^telugu}', "");
    Expect(1, 7410, '\p{-TELUGU}', "");
    Expect(0, 7410, '\p{^-TELUGU}', "");
    Expect(0, 7410, '\P{-TELUGU}', "");
    Expect(1, 7410, '\P{^-TELUGU}', "");
    Expect(0, 7411, '\p{-TELUGU}', "");
    Expect(1, 7411, '\p{^-TELUGU}', "");
    Expect(1, 7411, '\P{-TELUGU}', "");
    Expect(0, 7411, '\P{^-TELUGU}', "");
    Error('\p{	-is_Telugu/a/}');
    Error('\P{	-is_Telugu/a/}');
    Expect(1, 7410, '\p{istelugu}', "");
    Expect(0, 7410, '\p{^istelugu}', "");
    Expect(0, 7410, '\P{istelugu}', "");
    Expect(1, 7410, '\P{^istelugu}', "");
    Expect(0, 7411, '\p{istelugu}', "");
    Expect(1, 7411, '\p{^istelugu}', "");
    Expect(1, 7411, '\P{istelugu}', "");
    Expect(0, 7411, '\P{^istelugu}', "");
    Expect(1, 7410, '\p{		is_telugu}', "");
    Expect(0, 7410, '\p{^		is_telugu}', "");
    Expect(0, 7410, '\P{		is_telugu}', "");
    Expect(1, 7410, '\P{^		is_telugu}', "");
    Expect(0, 7411, '\p{		is_telugu}', "");
    Expect(1, 7411, '\p{^		is_telugu}', "");
    Expect(1, 7411, '\P{		is_telugu}', "");
    Expect(0, 7411, '\P{^		is_telugu}', "");
    Error('\p{-_TELU:=}');
    Error('\P{-_TELU:=}');
    Expect(1, 7410, '\p{telu}', "");
    Expect(0, 7410, '\p{^telu}', "");
    Expect(0, 7410, '\P{telu}', "");
    Expect(1, 7410, '\P{^telu}', "");
    Expect(0, 7411, '\p{telu}', "");
    Expect(1, 7411, '\p{^telu}', "");
    Expect(1, 7411, '\P{telu}', "");
    Expect(0, 7411, '\P{^telu}', "");
    Expect(1, 7410, '\p{-	telu}', "");
    Expect(0, 7410, '\p{^-	telu}', "");
    Expect(0, 7410, '\P{-	telu}', "");
    Expect(1, 7410, '\P{^-	telu}', "");
    Expect(0, 7411, '\p{-	telu}', "");
    Expect(1, 7411, '\p{^-	telu}', "");
    Expect(1, 7411, '\P{-	telu}', "");
    Expect(0, 7411, '\P{^-	telu}', "");
    Error('\p{:= _is_telu}');
    Error('\P{:= _is_telu}');
    Expect(1, 7410, '\p{istelu}', "");
    Expect(0, 7410, '\p{^istelu}', "");
    Expect(0, 7410, '\P{istelu}', "");
    Expect(1, 7410, '\P{^istelu}', "");
    Expect(0, 7411, '\p{istelu}', "");
    Expect(1, 7411, '\p{^istelu}', "");
    Expect(1, 7411, '\P{istelu}', "");
    Expect(0, 7411, '\P{^istelu}', "");
    Expect(1, 7410, '\p{_	Is_Telu}', "");
    Expect(0, 7410, '\p{^_	Is_Telu}', "");
    Expect(0, 7410, '\P{_	Is_Telu}', "");
    Expect(1, 7410, '\P{^_	Is_Telu}', "");
    Expect(0, 7411, '\p{_	Is_Telu}', "");
    Expect(1, 7411, '\p{^_	Is_Telu}', "");
    Expect(1, 7411, '\P{_	Is_Telu}', "");
    Expect(0, 7411, '\P{^_	Is_Telu}', "");
    Error('\p{:=-Terminal_Punctuation}');
    Error('\P{:=-Terminal_Punctuation}');
    Expect(1, 121482, '\p{terminalpunctuation}', "");
    Expect(0, 121482, '\p{^terminalpunctuation}', "");
    Expect(0, 121482, '\P{terminalpunctuation}', "");
    Expect(1, 121482, '\P{^terminalpunctuation}', "");
    Expect(0, 121483, '\p{terminalpunctuation}', "");
    Expect(1, 121483, '\p{^terminalpunctuation}', "");
    Expect(1, 121483, '\P{terminalpunctuation}', "");
    Expect(0, 121483, '\P{^terminalpunctuation}', "");
    Expect(1, 121482, '\p{ 	TERMINAL_Punctuation}', "");
    Expect(0, 121482, '\p{^ 	TERMINAL_Punctuation}', "");
    Expect(0, 121482, '\P{ 	TERMINAL_Punctuation}', "");
    Expect(1, 121482, '\P{^ 	TERMINAL_Punctuation}', "");
    Expect(0, 121483, '\p{ 	TERMINAL_Punctuation}', "");
    Expect(1, 121483, '\p{^ 	TERMINAL_Punctuation}', "");
    Expect(1, 121483, '\P{ 	TERMINAL_Punctuation}', "");
    Expect(0, 121483, '\P{^ 	TERMINAL_Punctuation}', "");
    Error('\p{-:=Is_Terminal_Punctuation}');
    Error('\P{-:=Is_Terminal_Punctuation}');
    Expect(1, 121482, '\p{isterminalpunctuation}', "");
    Expect(0, 121482, '\p{^isterminalpunctuation}', "");
    Expect(0, 121482, '\P{isterminalpunctuation}', "");
    Expect(1, 121482, '\P{^isterminalpunctuation}', "");
    Expect(0, 121483, '\p{isterminalpunctuation}', "");
    Expect(1, 121483, '\p{^isterminalpunctuation}', "");
    Expect(1, 121483, '\P{isterminalpunctuation}', "");
    Expect(0, 121483, '\P{^isterminalpunctuation}', "");
    Expect(1, 121482, '\p{	IS_Terminal_PUNCTUATION}', "");
    Expect(0, 121482, '\p{^	IS_Terminal_PUNCTUATION}', "");
    Expect(0, 121482, '\P{	IS_Terminal_PUNCTUATION}', "");
    Expect(1, 121482, '\P{^	IS_Terminal_PUNCTUATION}', "");
    Expect(0, 121483, '\p{	IS_Terminal_PUNCTUATION}', "");
    Expect(1, 121483, '\p{^	IS_Terminal_PUNCTUATION}', "");
    Expect(1, 121483, '\P{	IS_Terminal_PUNCTUATION}', "");
    Expect(0, 121483, '\P{^	IS_Terminal_PUNCTUATION}', "");
    Error('\p{	-Term:=}');
    Error('\P{	-Term:=}');
    Expect(1, 121482, '\p{term}', "");
    Expect(0, 121482, '\p{^term}', "");
    Expect(0, 121482, '\P{term}', "");
    Expect(1, 121482, '\P{^term}', "");
    Expect(0, 121483, '\p{term}', "");
    Expect(1, 121483, '\p{^term}', "");
    Expect(1, 121483, '\P{term}', "");
    Expect(0, 121483, '\P{^term}', "");
    Expect(1, 121482, '\p{	 term}', "");
    Expect(0, 121482, '\p{^	 term}', "");
    Expect(0, 121482, '\P{	 term}', "");
    Expect(1, 121482, '\P{^	 term}', "");
    Expect(0, 121483, '\p{	 term}', "");
    Expect(1, 121483, '\p{^	 term}', "");
    Expect(1, 121483, '\P{	 term}', "");
    Expect(0, 121483, '\P{^	 term}', "");
    Error('\p{:=Is_Term}');
    Error('\P{:=Is_Term}');
    Expect(1, 121482, '\p{isterm}', "");
    Expect(0, 121482, '\p{^isterm}', "");
    Expect(0, 121482, '\P{isterm}', "");
    Expect(1, 121482, '\P{^isterm}', "");
    Expect(0, 121483, '\p{isterm}', "");
    Expect(1, 121483, '\p{^isterm}', "");
    Expect(1, 121483, '\P{isterm}', "");
    Expect(0, 121483, '\P{^isterm}', "");
    Expect(1, 121482, '\p{	is_Term}', "");
    Expect(0, 121482, '\p{^	is_Term}', "");
    Expect(0, 121482, '\P{	is_Term}', "");
    Expect(1, 121482, '\P{^	is_Term}', "");
    Expect(0, 121483, '\p{	is_Term}', "");
    Expect(1, 121483, '\p{^	is_Term}', "");
    Expect(1, 121483, '\P{	is_Term}', "");
    Expect(0, 121483, '\P{^	is_Term}', "");
    Error('\p{ /a/thaana}');
    Error('\P{ /a/thaana}');
    Expect(1, 65021, '\p{thaana}', "");
    Expect(0, 65021, '\p{^thaana}', "");
    Expect(0, 65021, '\P{thaana}', "");
    Expect(1, 65021, '\P{^thaana}', "");
    Expect(0, 65022, '\p{thaana}', "");
    Expect(1, 65022, '\p{^thaana}', "");
    Expect(1, 65022, '\P{thaana}', "");
    Expect(0, 65022, '\P{^thaana}', "");
    Expect(1, 65021, '\p{ Thaana}', "");
    Expect(0, 65021, '\p{^ Thaana}', "");
    Expect(0, 65021, '\P{ Thaana}', "");
    Expect(1, 65021, '\P{^ Thaana}', "");
    Expect(0, 65022, '\p{ Thaana}', "");
    Expect(1, 65022, '\p{^ Thaana}', "");
    Expect(1, 65022, '\P{ Thaana}', "");
    Expect(0, 65022, '\P{^ Thaana}', "");
    Error('\p{:=- Is_THAANA}');
    Error('\P{:=- Is_THAANA}');
    Expect(1, 65021, '\p{isthaana}', "");
    Expect(0, 65021, '\p{^isthaana}', "");
    Expect(0, 65021, '\P{isthaana}', "");
    Expect(1, 65021, '\P{^isthaana}', "");
    Expect(0, 65022, '\p{isthaana}', "");
    Expect(1, 65022, '\p{^isthaana}', "");
    Expect(1, 65022, '\P{isthaana}', "");
    Expect(0, 65022, '\P{^isthaana}', "");
    Expect(1, 65021, '\p{is_Thaana}', "");
    Expect(0, 65021, '\p{^is_Thaana}', "");
    Expect(0, 65021, '\P{is_Thaana}', "");
    Expect(1, 65021, '\P{^is_Thaana}', "");
    Expect(0, 65022, '\p{is_Thaana}', "");
    Expect(1, 65022, '\p{^is_Thaana}', "");
    Expect(1, 65022, '\P{is_Thaana}', "");
    Expect(0, 65022, '\P{^is_Thaana}', "");
    Error('\p{-_thaa:=}');
    Error('\P{-_thaa:=}');
    Expect(1, 65021, '\p{thaa}', "");
    Expect(0, 65021, '\p{^thaa}', "");
    Expect(0, 65021, '\P{thaa}', "");
    Expect(1, 65021, '\P{^thaa}', "");
    Expect(0, 65022, '\p{thaa}', "");
    Expect(1, 65022, '\p{^thaa}', "");
    Expect(1, 65022, '\P{thaa}', "");
    Expect(0, 65022, '\P{^thaa}', "");
    Expect(1, 65021, '\p{ -Thaa}', "");
    Expect(0, 65021, '\p{^ -Thaa}', "");
    Expect(0, 65021, '\P{ -Thaa}', "");
    Expect(1, 65021, '\P{^ -Thaa}', "");
    Expect(0, 65022, '\p{ -Thaa}', "");
    Expect(1, 65022, '\p{^ -Thaa}', "");
    Expect(1, 65022, '\P{ -Thaa}', "");
    Expect(0, 65022, '\P{^ -Thaa}', "");
    Error('\p{_/a/IS_Thaa}');
    Error('\P{_/a/IS_Thaa}');
    Expect(1, 65021, '\p{isthaa}', "");
    Expect(0, 65021, '\p{^isthaa}', "");
    Expect(0, 65021, '\P{isthaa}', "");
    Expect(1, 65021, '\P{^isthaa}', "");
    Expect(0, 65022, '\p{isthaa}', "");
    Expect(1, 65022, '\p{^isthaa}', "");
    Expect(1, 65022, '\P{isthaa}', "");
    Expect(0, 65022, '\P{^isthaa}', "");
    Expect(1, 65021, '\p{ _Is_Thaa}', "");
    Expect(0, 65021, '\p{^ _Is_Thaa}', "");
    Expect(0, 65021, '\P{ _Is_Thaa}', "");
    Expect(1, 65021, '\P{^ _Is_Thaa}', "");
    Expect(0, 65022, '\p{ _Is_Thaa}', "");
    Expect(1, 65022, '\p{^ _Is_Thaa}', "");
    Expect(1, 65022, '\P{ _Is_Thaa}', "");
    Expect(0, 65022, '\P{^ _Is_Thaa}', "");
    Error('\p{_thai:=}');
    Error('\P{_thai:=}');
    Expect(1, 3675, '\p{thai}', "");
    Expect(0, 3675, '\p{^thai}', "");
    Expect(0, 3675, '\P{thai}', "");
    Expect(1, 3675, '\P{^thai}', "");
    Expect(0, 3676, '\p{thai}', "");
    Expect(1, 3676, '\p{^thai}', "");
    Expect(1, 3676, '\P{thai}', "");
    Expect(0, 3676, '\P{^thai}', "");
    Expect(1, 3675, '\p{	_thai}', "");
    Expect(0, 3675, '\p{^	_thai}', "");
    Expect(0, 3675, '\P{	_thai}', "");
    Expect(1, 3675, '\P{^	_thai}', "");
    Expect(0, 3676, '\p{	_thai}', "");
    Expect(1, 3676, '\p{^	_thai}', "");
    Expect(1, 3676, '\P{	_thai}', "");
    Expect(0, 3676, '\P{^	_thai}', "");
    Error('\p{:=_Is_Thai}');
    Error('\P{:=_Is_Thai}');
    Expect(1, 3675, '\p{isthai}', "");
    Expect(0, 3675, '\p{^isthai}', "");
    Expect(0, 3675, '\P{isthai}', "");
    Expect(1, 3675, '\P{^isthai}', "");
    Expect(0, 3676, '\p{isthai}', "");
    Expect(1, 3676, '\p{^isthai}', "");
    Expect(1, 3676, '\P{isthai}', "");
    Expect(0, 3676, '\P{^isthai}', "");
    Expect(1, 3675, '\p{ Is_THAI}', "");
    Expect(0, 3675, '\p{^ Is_THAI}', "");
    Expect(0, 3675, '\P{ Is_THAI}', "");
    Expect(1, 3675, '\P{^ Is_THAI}', "");
    Expect(0, 3676, '\p{ Is_THAI}', "");
    Expect(1, 3676, '\p{^ Is_THAI}', "");
    Expect(1, 3676, '\P{ Is_THAI}', "");
    Expect(0, 3676, '\P{^ Is_THAI}', "");
    Error('\p{:=_	Tibetan}');
    Error('\P{:=_	Tibetan}');
    Expect(1, 4058, '\p{tibetan}', "");
    Expect(0, 4058, '\p{^tibetan}', "");
    Expect(0, 4058, '\P{tibetan}', "");
    Expect(1, 4058, '\P{^tibetan}', "");
    Expect(0, 4059, '\p{tibetan}', "");
    Expect(1, 4059, '\p{^tibetan}', "");
    Expect(1, 4059, '\P{tibetan}', "");
    Expect(0, 4059, '\P{^tibetan}', "");
    Expect(1, 4058, '\p{		TIBETAN}', "");
    Expect(0, 4058, '\p{^		TIBETAN}', "");
    Expect(0, 4058, '\P{		TIBETAN}', "");
    Expect(1, 4058, '\P{^		TIBETAN}', "");
    Expect(0, 4059, '\p{		TIBETAN}', "");
    Expect(1, 4059, '\p{^		TIBETAN}', "");
    Expect(1, 4059, '\P{		TIBETAN}', "");
    Expect(0, 4059, '\P{^		TIBETAN}', "");
    Error('\p{:= -Is_TIBETAN}');
    Error('\P{:= -Is_TIBETAN}');
    Expect(1, 4058, '\p{istibetan}', "");
    Expect(0, 4058, '\p{^istibetan}', "");
    Expect(0, 4058, '\P{istibetan}', "");
    Expect(1, 4058, '\P{^istibetan}', "");
    Expect(0, 4059, '\p{istibetan}', "");
    Expect(1, 4059, '\p{^istibetan}', "");
    Expect(1, 4059, '\P{istibetan}', "");
    Expect(0, 4059, '\P{^istibetan}', "");
    Expect(1, 4058, '\p{_is_tibetan}', "");
    Expect(0, 4058, '\p{^_is_tibetan}', "");
    Expect(0, 4058, '\P{_is_tibetan}', "");
    Expect(1, 4058, '\P{^_is_tibetan}', "");
    Expect(0, 4059, '\p{_is_tibetan}', "");
    Expect(1, 4059, '\p{^_is_tibetan}', "");
    Expect(1, 4059, '\P{_is_tibetan}', "");
    Expect(0, 4059, '\P{^_is_tibetan}', "");
    Error('\p{_:=tibt}');
    Error('\P{_:=tibt}');
    Expect(1, 4058, '\p{tibt}', "");
    Expect(0, 4058, '\p{^tibt}', "");
    Expect(0, 4058, '\P{tibt}', "");
    Expect(1, 4058, '\P{^tibt}', "");
    Expect(0, 4059, '\p{tibt}', "");
    Expect(1, 4059, '\p{^tibt}', "");
    Expect(1, 4059, '\P{tibt}', "");
    Expect(0, 4059, '\P{^tibt}', "");
    Expect(1, 4058, '\p{  Tibt}', "");
    Expect(0, 4058, '\p{^  Tibt}', "");
    Expect(0, 4058, '\P{  Tibt}', "");
    Expect(1, 4058, '\P{^  Tibt}', "");
    Expect(0, 4059, '\p{  Tibt}', "");
    Expect(1, 4059, '\p{^  Tibt}', "");
    Expect(1, 4059, '\P{  Tibt}', "");
    Expect(0, 4059, '\P{^  Tibt}', "");
    Error('\p{/a/	_IS_TIBT}');
    Error('\P{/a/	_IS_TIBT}');
    Expect(1, 4058, '\p{istibt}', "");
    Expect(0, 4058, '\p{^istibt}', "");
    Expect(0, 4058, '\P{istibt}', "");
    Expect(1, 4058, '\P{^istibt}', "");
    Expect(0, 4059, '\p{istibt}', "");
    Expect(1, 4059, '\p{^istibt}', "");
    Expect(1, 4059, '\P{istibt}', "");
    Expect(0, 4059, '\P{^istibt}', "");
    Expect(1, 4058, '\p{-	Is_tibt}', "");
    Expect(0, 4058, '\p{^-	Is_tibt}', "");
    Expect(0, 4058, '\P{-	Is_tibt}', "");
    Expect(1, 4058, '\P{^-	Is_tibt}', "");
    Expect(0, 4059, '\p{-	Is_tibt}', "");
    Expect(1, 4059, '\p{^-	Is_tibt}', "");
    Expect(1, 4059, '\P{-	Is_tibt}', "");
    Expect(0, 4059, '\P{^-	Is_tibt}', "");
    Error('\p{:=_-Tifinagh}');
    Error('\P{:=_-Tifinagh}');
    Expect(1, 11647, '\p{tifinagh}', "");
    Expect(0, 11647, '\p{^tifinagh}', "");
    Expect(0, 11647, '\P{tifinagh}', "");
    Expect(1, 11647, '\P{^tifinagh}', "");
    Expect(0, 11648, '\p{tifinagh}', "");
    Expect(1, 11648, '\p{^tifinagh}', "");
    Expect(1, 11648, '\P{tifinagh}', "");
    Expect(0, 11648, '\P{^tifinagh}', "");
    Expect(1, 11647, '\p{	TIFINAGH}', "");
    Expect(0, 11647, '\p{^	TIFINAGH}', "");
    Expect(0, 11647, '\P{	TIFINAGH}', "");
    Expect(1, 11647, '\P{^	TIFINAGH}', "");
    Expect(0, 11648, '\p{	TIFINAGH}', "");
    Expect(1, 11648, '\p{^	TIFINAGH}', "");
    Expect(1, 11648, '\P{	TIFINAGH}', "");
    Expect(0, 11648, '\P{^	TIFINAGH}', "");
    Error('\p{__IS_Tifinagh/a/}');
    Error('\P{__IS_Tifinagh/a/}');
    Expect(1, 11647, '\p{istifinagh}', "");
    Expect(0, 11647, '\p{^istifinagh}', "");
    Expect(0, 11647, '\P{istifinagh}', "");
    Expect(1, 11647, '\P{^istifinagh}', "");
    Expect(0, 11648, '\p{istifinagh}', "");
    Expect(1, 11648, '\p{^istifinagh}', "");
    Expect(1, 11648, '\P{istifinagh}', "");
    Expect(0, 11648, '\P{^istifinagh}', "");
    Expect(1, 11647, '\p{- Is_Tifinagh}', "");
    Expect(0, 11647, '\p{^- Is_Tifinagh}', "");
    Expect(0, 11647, '\P{- Is_Tifinagh}', "");
    Expect(1, 11647, '\P{^- Is_Tifinagh}', "");
    Expect(0, 11648, '\p{- Is_Tifinagh}', "");
    Expect(1, 11648, '\p{^- Is_Tifinagh}', "");
    Expect(1, 11648, '\P{- Is_Tifinagh}', "");
    Expect(0, 11648, '\P{^- Is_Tifinagh}', "");
    Error('\p{	:=Tfng}');
    Error('\P{	:=Tfng}');
    Expect(1, 11647, '\p{tfng}', "");
    Expect(0, 11647, '\p{^tfng}', "");
    Expect(0, 11647, '\P{tfng}', "");
    Expect(1, 11647, '\P{^tfng}', "");
    Expect(0, 11648, '\p{tfng}', "");
    Expect(1, 11648, '\p{^tfng}', "");
    Expect(1, 11648, '\P{tfng}', "");
    Expect(0, 11648, '\P{^tfng}', "");
    Expect(1, 11647, '\p{-_tfng}', "");
    Expect(0, 11647, '\p{^-_tfng}', "");
    Expect(0, 11647, '\P{-_tfng}', "");
    Expect(1, 11647, '\P{^-_tfng}', "");
    Expect(0, 11648, '\p{-_tfng}', "");
    Expect(1, 11648, '\p{^-_tfng}', "");
    Expect(1, 11648, '\P{-_tfng}', "");
    Expect(0, 11648, '\P{^-_tfng}', "");
    Error('\p{:=_	is_Tfng}');
    Error('\P{:=_	is_Tfng}');
    Expect(1, 11647, '\p{istfng}', "");
    Expect(0, 11647, '\p{^istfng}', "");
    Expect(0, 11647, '\P{istfng}', "");
    Expect(1, 11647, '\P{^istfng}', "");
    Expect(0, 11648, '\p{istfng}', "");
    Expect(1, 11648, '\p{^istfng}', "");
    Expect(1, 11648, '\P{istfng}', "");
    Expect(0, 11648, '\P{^istfng}', "");
    Expect(1, 11647, '\p{-IS_tfng}', "");
    Expect(0, 11647, '\p{^-IS_tfng}', "");
    Expect(0, 11647, '\P{-IS_tfng}', "");
    Expect(1, 11647, '\P{^-IS_tfng}', "");
    Expect(0, 11648, '\p{-IS_tfng}', "");
    Expect(1, 11648, '\p{^-IS_tfng}', "");
    Expect(1, 11648, '\P{-IS_tfng}', "");
    Expect(0, 11648, '\P{^-IS_tfng}', "");
    Error('\p{:=_TIRHUTA}');
    Error('\P{:=_TIRHUTA}');
    Expect(1, 70873, '\p{tirhuta}', "");
    Expect(0, 70873, '\p{^tirhuta}', "");
    Expect(0, 70873, '\P{tirhuta}', "");
    Expect(1, 70873, '\P{^tirhuta}', "");
    Expect(0, 70874, '\p{tirhuta}', "");
    Expect(1, 70874, '\p{^tirhuta}', "");
    Expect(1, 70874, '\P{tirhuta}', "");
    Expect(0, 70874, '\P{^tirhuta}', "");
    Expect(1, 70873, '\p{	 TIRHUTA}', "");
    Expect(0, 70873, '\p{^	 TIRHUTA}', "");
    Expect(0, 70873, '\P{	 TIRHUTA}', "");
    Expect(1, 70873, '\P{^	 TIRHUTA}', "");
    Expect(0, 70874, '\p{	 TIRHUTA}', "");
    Expect(1, 70874, '\p{^	 TIRHUTA}', "");
    Expect(1, 70874, '\P{	 TIRHUTA}', "");
    Expect(0, 70874, '\P{^	 TIRHUTA}', "");
    Error('\p{_:=Is_TIRHUTA}');
    Error('\P{_:=Is_TIRHUTA}');
    Expect(1, 70873, '\p{istirhuta}', "");
    Expect(0, 70873, '\p{^istirhuta}', "");
    Expect(0, 70873, '\P{istirhuta}', "");
    Expect(1, 70873, '\P{^istirhuta}', "");
    Expect(0, 70874, '\p{istirhuta}', "");
    Expect(1, 70874, '\p{^istirhuta}', "");
    Expect(1, 70874, '\P{istirhuta}', "");
    Expect(0, 70874, '\P{^istirhuta}', "");
    Expect(1, 70873, '\p{ _is_Tirhuta}', "");
    Expect(0, 70873, '\p{^ _is_Tirhuta}', "");
    Expect(0, 70873, '\P{ _is_Tirhuta}', "");
    Expect(1, 70873, '\P{^ _is_Tirhuta}', "");
    Expect(0, 70874, '\p{ _is_Tirhuta}', "");
    Expect(1, 70874, '\p{^ _is_Tirhuta}', "");
    Expect(1, 70874, '\P{ _is_Tirhuta}', "");
    Expect(0, 70874, '\P{^ _is_Tirhuta}', "");
    Error('\p{-:=tirh}');
    Error('\P{-:=tirh}');
    Expect(1, 70873, '\p{tirh}', "");
    Expect(0, 70873, '\p{^tirh}', "");
    Expect(0, 70873, '\P{tirh}', "");
    Expect(1, 70873, '\P{^tirh}', "");
    Expect(0, 70874, '\p{tirh}', "");
    Expect(1, 70874, '\p{^tirh}', "");
    Expect(1, 70874, '\P{tirh}', "");
    Expect(0, 70874, '\P{^tirh}', "");
    Expect(1, 70873, '\p{_ Tirh}', "");
    Expect(0, 70873, '\p{^_ Tirh}', "");
    Expect(0, 70873, '\P{_ Tirh}', "");
    Expect(1, 70873, '\P{^_ Tirh}', "");
    Expect(0, 70874, '\p{_ Tirh}', "");
    Expect(1, 70874, '\p{^_ Tirh}', "");
    Expect(1, 70874, '\P{_ Tirh}', "");
    Expect(0, 70874, '\P{^_ Tirh}', "");
    Error('\p{:=_-Is_tirh}');
    Error('\P{:=_-Is_tirh}');
    Expect(1, 70873, '\p{istirh}', "");
    Expect(0, 70873, '\p{^istirh}', "");
    Expect(0, 70873, '\P{istirh}', "");
    Expect(1, 70873, '\P{^istirh}', "");
    Expect(0, 70874, '\p{istirh}', "");
    Expect(1, 70874, '\p{^istirh}', "");
    Expect(1, 70874, '\P{istirh}', "");
    Expect(0, 70874, '\P{^istirh}', "");
    Expect(1, 70873, '\p{	_Is_Tirh}', "");
    Expect(0, 70873, '\p{^	_Is_Tirh}', "");
    Expect(0, 70873, '\P{	_Is_Tirh}', "");
    Expect(1, 70873, '\P{^	_Is_Tirh}', "");
    Expect(0, 70874, '\p{	_Is_Tirh}', "");
    Expect(1, 70874, '\p{^	_Is_Tirh}', "");
    Expect(1, 70874, '\P{	_Is_Tirh}', "");
    Expect(0, 70874, '\P{^	_Is_Tirh}', "");
    Error('\p{	/a/Titlecase}');
    Error('\P{	/a/Titlecase}');
    Expect(1, 8188, '\p{titlecase}', "");
    Expect(0, 8188, '\p{^titlecase}', "");
    Expect(0, 8188, '\P{titlecase}', "");
    Expect(1, 8188, '\P{^titlecase}', "");
    Expect(0, 8189, '\p{titlecase}', "");
    Expect(1, 8189, '\p{^titlecase}', "");
    Expect(1, 8189, '\P{titlecase}', "");
    Expect(0, 8189, '\P{^titlecase}', "");
    Expect(1, 8188, '\p{-TITLECASE}', "");
    Expect(0, 8188, '\p{^-TITLECASE}', "");
    Expect(0, 8188, '\P{-TITLECASE}', "");
    Expect(1, 8188, '\P{^-TITLECASE}', "");
    Expect(0, 8189, '\p{-TITLECASE}', "");
    Expect(1, 8189, '\p{^-TITLECASE}', "");
    Expect(1, 8189, '\P{-TITLECASE}', "");
    Expect(0, 8189, '\P{^-TITLECASE}', "");
    Error('\p{-/a/Title}');
    Error('\P{-/a/Title}');
    Expect(1, 8188, '\p{title}', "");
    Expect(0, 8188, '\p{^title}', "");
    Expect(0, 8188, '\P{title}', "");
    Expect(1, 8188, '\P{^title}', "");
    Expect(0, 8189, '\p{title}', "");
    Expect(1, 8189, '\p{^title}', "");
    Expect(1, 8189, '\P{title}', "");
    Expect(0, 8189, '\P{^title}', "");
    Expect(1, 8188, '\p{-	Title}', "");
    Expect(0, 8188, '\p{^-	Title}', "");
    Expect(0, 8188, '\P{-	Title}', "");
    Expect(1, 8188, '\P{^-	Title}', "");
    Expect(0, 8189, '\p{-	Title}', "");
    Expect(1, 8189, '\p{^-	Title}', "");
    Expect(1, 8189, '\P{-	Title}', "");
    Expect(0, 8189, '\P{^-	Title}', "");
    Error('\p{:=-_Is_titlecase}');
    Error('\P{:=-_Is_titlecase}');
    Expect(1, 8188, '\p{istitlecase}', "");
    Expect(0, 8188, '\p{^istitlecase}', "");
    Expect(0, 8188, '\P{istitlecase}', "");
    Expect(1, 8188, '\P{^istitlecase}', "");
    Expect(0, 8189, '\p{istitlecase}', "");
    Expect(1, 8189, '\p{^istitlecase}', "");
    Expect(1, 8189, '\P{istitlecase}', "");
    Expect(0, 8189, '\P{^istitlecase}', "");
    Expect(1, 8188, '\p{  is_Titlecase}', "");
    Expect(0, 8188, '\p{^  is_Titlecase}', "");
    Expect(0, 8188, '\P{  is_Titlecase}', "");
    Expect(1, 8188, '\P{^  is_Titlecase}', "");
    Expect(0, 8189, '\p{  is_Titlecase}', "");
    Expect(1, 8189, '\p{^  is_Titlecase}', "");
    Expect(1, 8189, '\P{  is_Titlecase}', "");
    Expect(0, 8189, '\P{^  is_Titlecase}', "");
    Error('\p{_:=is_title}');
    Error('\P{_:=is_title}');
    Expect(1, 8188, '\p{istitle}', "");
    Expect(0, 8188, '\p{^istitle}', "");
    Expect(0, 8188, '\P{istitle}', "");
    Expect(1, 8188, '\P{^istitle}', "");
    Expect(0, 8189, '\p{istitle}', "");
    Expect(1, 8189, '\p{^istitle}', "");
    Expect(1, 8189, '\P{istitle}', "");
    Expect(0, 8189, '\P{^istitle}', "");
    Expect(1, 8188, '\p{	is_TITLE}', "");
    Expect(0, 8188, '\p{^	is_TITLE}', "");
    Expect(0, 8188, '\P{	is_TITLE}', "");
    Expect(1, 8188, '\P{^	is_TITLE}', "");
    Expect(0, 8189, '\p{	is_TITLE}', "");
    Expect(1, 8189, '\p{^	is_TITLE}', "");
    Expect(1, 8189, '\P{	is_TITLE}', "");
    Expect(0, 8189, '\P{^	is_TITLE}', "");
    Error('\p{:= 	titlecase_LETTER}');
    Error('\P{:= 	titlecase_LETTER}');
    Expect(1, 8188, '\p{titlecaseletter}', "");
    Expect(0, 8188, '\p{^titlecaseletter}', "");
    Expect(0, 8188, '\P{titlecaseletter}', "");
    Expect(1, 8188, '\P{^titlecaseletter}', "");
    Expect(0, 8189, '\p{titlecaseletter}', "");
    Expect(1, 8189, '\p{^titlecaseletter}', "");
    Expect(1, 8189, '\P{titlecaseletter}', "");
    Expect(0, 8189, '\P{^titlecaseletter}', "");
    Expect(1, 8188, '\p{-Titlecase_Letter}', "");
    Expect(0, 8188, '\p{^-Titlecase_Letter}', "");
    Expect(0, 8188, '\P{-Titlecase_Letter}', "");
    Expect(1, 8188, '\P{^-Titlecase_Letter}', "");
    Expect(0, 8189, '\p{-Titlecase_Letter}', "");
    Expect(1, 8189, '\p{^-Titlecase_Letter}', "");
    Expect(1, 8189, '\P{-Titlecase_Letter}', "");
    Expect(0, 8189, '\P{^-Titlecase_Letter}', "");
    Error('\p{/a/_-Is_Titlecase_LETTER}');
    Error('\P{/a/_-Is_Titlecase_LETTER}');
    Expect(1, 8188, '\p{istitlecaseletter}', "");
    Expect(0, 8188, '\p{^istitlecaseletter}', "");
    Expect(0, 8188, '\P{istitlecaseletter}', "");
    Expect(1, 8188, '\P{^istitlecaseletter}', "");
    Expect(0, 8189, '\p{istitlecaseletter}', "");
    Expect(1, 8189, '\p{^istitlecaseletter}', "");
    Expect(1, 8189, '\P{istitlecaseletter}', "");
    Expect(0, 8189, '\P{^istitlecaseletter}', "");
    Expect(1, 8188, '\p{	 Is_Titlecase_letter}', "");
    Expect(0, 8188, '\p{^	 Is_Titlecase_letter}', "");
    Expect(0, 8188, '\P{	 Is_Titlecase_letter}', "");
    Expect(1, 8188, '\P{^	 Is_Titlecase_letter}', "");
    Expect(0, 8189, '\p{	 Is_Titlecase_letter}', "");
    Expect(1, 8189, '\p{^	 Is_Titlecase_letter}', "");
    Expect(1, 8189, '\P{	 Is_Titlecase_letter}', "");
    Expect(0, 8189, '\P{^	 Is_Titlecase_letter}', "");
    Error('\p{/a/Lt}');
    Error('\P{/a/Lt}');
    Expect(1, 8188, '\p{lt}', "");
    Expect(0, 8188, '\p{^lt}', "");
    Expect(0, 8188, '\P{lt}', "");
    Expect(1, 8188, '\P{^lt}', "");
    Expect(0, 8189, '\p{lt}', "");
    Expect(1, 8189, '\p{^lt}', "");
    Expect(1, 8189, '\P{lt}', "");
    Expect(0, 8189, '\P{^lt}', "");
    Expect(1, 8188, '\p{	Lt}', "");
    Expect(0, 8188, '\p{^	Lt}', "");
    Expect(0, 8188, '\P{	Lt}', "");
    Expect(1, 8188, '\P{^	Lt}', "");
    Expect(0, 8189, '\p{	Lt}', "");
    Expect(1, 8189, '\p{^	Lt}', "");
    Expect(1, 8189, '\P{	Lt}', "");
    Expect(0, 8189, '\P{^	Lt}', "");
    Error('\p{:= -Is_Lt}');
    Error('\P{:= -Is_Lt}');
    Expect(1, 8188, '\p{islt}', "");
    Expect(0, 8188, '\p{^islt}', "");
    Expect(0, 8188, '\P{islt}', "");
    Expect(1, 8188, '\P{^islt}', "");
    Expect(0, 8189, '\p{islt}', "");
    Expect(1, 8189, '\p{^islt}', "");
    Expect(1, 8189, '\P{islt}', "");
    Expect(0, 8189, '\P{^islt}', "");
    Expect(1, 8188, '\p{	 IS_lt}', "");
    Expect(0, 8188, '\p{^	 IS_lt}', "");
    Expect(0, 8188, '\P{	 IS_lt}', "");
    Expect(1, 8188, '\P{^	 IS_lt}', "");
    Expect(0, 8189, '\p{	 IS_lt}', "");
    Expect(1, 8189, '\p{^	 IS_lt}', "");
    Expect(1, 8189, '\P{	 IS_lt}', "");
    Expect(0, 8189, '\P{^	 IS_lt}', "");
    Error('\p{_/a/Transport_And_Map_Symbols}');
    Error('\P{_/a/Transport_And_Map_Symbols}');
    Expect(1, 128767, '\p{transportandmapsymbols}', "");
    Expect(0, 128767, '\p{^transportandmapsymbols}', "");
    Expect(0, 128767, '\P{transportandmapsymbols}', "");
    Expect(1, 128767, '\P{^transportandmapsymbols}', "");
    Expect(0, 128768, '\p{transportandmapsymbols}', "");
    Expect(1, 128768, '\p{^transportandmapsymbols}', "");
    Expect(1, 128768, '\P{transportandmapsymbols}', "");
    Expect(0, 128768, '\P{^transportandmapsymbols}', "");
    Expect(1, 128767, '\p{_Transport_And_Map_Symbols}', "");
    Expect(0, 128767, '\p{^_Transport_And_Map_Symbols}', "");
    Expect(0, 128767, '\P{_Transport_And_Map_Symbols}', "");
    Expect(1, 128767, '\P{^_Transport_And_Map_Symbols}', "");
    Expect(0, 128768, '\p{_Transport_And_Map_Symbols}', "");
    Expect(1, 128768, '\p{^_Transport_And_Map_Symbols}', "");
    Expect(1, 128768, '\P{_Transport_And_Map_Symbols}', "");
    Expect(0, 128768, '\P{^_Transport_And_Map_Symbols}', "");
    Error('\p{ IS_Transport_And_map_SYMBOLS/a/}');
    Error('\P{ IS_Transport_And_map_SYMBOLS/a/}');
    Expect(1, 128767, '\p{istransportandmapsymbols}', "");
    Expect(0, 128767, '\p{^istransportandmapsymbols}', "");
    Expect(0, 128767, '\P{istransportandmapsymbols}', "");
    Expect(1, 128767, '\P{^istransportandmapsymbols}', "");
    Expect(0, 128768, '\p{istransportandmapsymbols}', "");
    Expect(1, 128768, '\p{^istransportandmapsymbols}', "");
    Expect(1, 128768, '\P{istransportandmapsymbols}', "");
    Expect(0, 128768, '\P{^istransportandmapsymbols}', "");
    Expect(1, 128767, '\p{IS_Transport_and_map_SYMBOLS}', "");
    Expect(0, 128767, '\p{^IS_Transport_and_map_SYMBOLS}', "");
    Expect(0, 128767, '\P{IS_Transport_and_map_SYMBOLS}', "");
    Expect(1, 128767, '\P{^IS_Transport_and_map_SYMBOLS}', "");
    Expect(0, 128768, '\p{IS_Transport_and_map_SYMBOLS}', "");
    Expect(1, 128768, '\p{^IS_Transport_and_map_SYMBOLS}', "");
    Expect(1, 128768, '\P{IS_Transport_and_map_SYMBOLS}', "");
    Expect(0, 128768, '\P{^IS_Transport_and_map_SYMBOLS}', "");
    Error('\p{/a/	-in_transport_AND_Map_SYMBOLS}');
    Error('\P{/a/	-in_transport_AND_Map_SYMBOLS}');
    Expect(1, 128767, '\p{intransportandmapsymbols}', "");
    Expect(0, 128767, '\p{^intransportandmapsymbols}', "");
    Expect(0, 128767, '\P{intransportandmapsymbols}', "");
    Expect(1, 128767, '\P{^intransportandmapsymbols}', "");
    Expect(0, 128768, '\p{intransportandmapsymbols}', "");
    Expect(1, 128768, '\p{^intransportandmapsymbols}', "");
    Expect(1, 128768, '\P{intransportandmapsymbols}', "");
    Expect(0, 128768, '\P{^intransportandmapsymbols}', "");
    Expect(1, 128767, '\p{_In_Transport_AND_Map_Symbols}', "");
    Expect(0, 128767, '\p{^_In_Transport_AND_Map_Symbols}', "");
    Expect(0, 128767, '\P{_In_Transport_AND_Map_Symbols}', "");
    Expect(1, 128767, '\P{^_In_Transport_AND_Map_Symbols}', "");
    Expect(0, 128768, '\p{_In_Transport_AND_Map_Symbols}', "");
    Expect(1, 128768, '\p{^_In_Transport_AND_Map_Symbols}', "");
    Expect(1, 128768, '\P{_In_Transport_AND_Map_Symbols}', "");
    Expect(0, 128768, '\P{^_In_Transport_AND_Map_Symbols}', "");
    Error('\p{ :=TRANSPORT_And_MAP}');
    Error('\P{ :=TRANSPORT_And_MAP}');
    Expect(1, 128767, '\p{transportandmap}', "");
    Expect(0, 128767, '\p{^transportandmap}', "");
    Expect(0, 128767, '\P{transportandmap}', "");
    Expect(1, 128767, '\P{^transportandmap}', "");
    Expect(0, 128768, '\p{transportandmap}', "");
    Expect(1, 128768, '\p{^transportandmap}', "");
    Expect(1, 128768, '\P{transportandmap}', "");
    Expect(0, 128768, '\P{^transportandmap}', "");
    Expect(1, 128767, '\p{	Transport_and_Map}', "");
    Expect(0, 128767, '\p{^	Transport_and_Map}', "");
    Expect(0, 128767, '\P{	Transport_and_Map}', "");
    Expect(1, 128767, '\P{^	Transport_and_Map}', "");
    Expect(0, 128768, '\p{	Transport_and_Map}', "");
    Expect(1, 128768, '\p{^	Transport_and_Map}', "");
    Expect(1, 128768, '\P{	Transport_and_Map}', "");
    Expect(0, 128768, '\P{^	Transport_and_Map}', "");
    Error('\p{ IS_TRANSPORT_And_Map:=}');
    Error('\P{ IS_TRANSPORT_And_Map:=}');
    Expect(1, 128767, '\p{istransportandmap}', "");
    Expect(0, 128767, '\p{^istransportandmap}', "");
    Expect(0, 128767, '\P{istransportandmap}', "");
    Expect(1, 128767, '\P{^istransportandmap}', "");
    Expect(0, 128768, '\p{istransportandmap}', "");
    Expect(1, 128768, '\p{^istransportandmap}', "");
    Expect(1, 128768, '\P{istransportandmap}', "");
    Expect(0, 128768, '\P{^istransportandmap}', "");
    Expect(1, 128767, '\p{ IS_Transport_AND_MAP}', "");
    Expect(0, 128767, '\p{^ IS_Transport_AND_MAP}', "");
    Expect(0, 128767, '\P{ IS_Transport_AND_MAP}', "");
    Expect(1, 128767, '\P{^ IS_Transport_AND_MAP}', "");
    Expect(0, 128768, '\p{ IS_Transport_AND_MAP}', "");
    Expect(1, 128768, '\p{^ IS_Transport_AND_MAP}', "");
    Expect(1, 128768, '\P{ IS_Transport_AND_MAP}', "");
    Expect(0, 128768, '\P{^ IS_Transport_AND_MAP}', "");
    Error('\p{	:=in_Transport_And_Map}');
    Error('\P{	:=in_Transport_And_Map}');
    Expect(1, 128767, '\p{intransportandmap}', "");
    Expect(0, 128767, '\p{^intransportandmap}', "");
    Expect(0, 128767, '\P{intransportandmap}', "");
    Expect(1, 128767, '\P{^intransportandmap}', "");
    Expect(0, 128768, '\p{intransportandmap}', "");
    Expect(1, 128768, '\p{^intransportandmap}', "");
    Expect(1, 128768, '\P{intransportandmap}', "");
    Expect(0, 128768, '\P{^intransportandmap}', "");
    Expect(1, 128767, '\p{	-In_TRANSPORT_And_Map}', "");
    Expect(0, 128767, '\p{^	-In_TRANSPORT_And_Map}', "");
    Expect(0, 128767, '\P{	-In_TRANSPORT_And_Map}', "");
    Expect(1, 128767, '\P{^	-In_TRANSPORT_And_Map}', "");
    Expect(0, 128768, '\p{	-In_TRANSPORT_And_Map}', "");
    Expect(1, 128768, '\p{^	-In_TRANSPORT_And_Map}', "");
    Expect(1, 128768, '\P{	-In_TRANSPORT_And_Map}', "");
    Expect(0, 128768, '\P{^	-In_TRANSPORT_And_Map}', "");
    Error('\p{:=	_ugaritic}');
    Error('\P{:=	_ugaritic}');
    Expect(1, 66463, '\p{ugaritic}', "");
    Expect(0, 66463, '\p{^ugaritic}', "");
    Expect(0, 66463, '\P{ugaritic}', "");
    Expect(1, 66463, '\P{^ugaritic}', "");
    Expect(0, 66464, '\p{ugaritic}', "");
    Expect(1, 66464, '\p{^ugaritic}', "");
    Expect(1, 66464, '\P{ugaritic}', "");
    Expect(0, 66464, '\P{^ugaritic}', "");
    Expect(1, 66463, '\p{ -UGARITIC}', "");
    Expect(0, 66463, '\p{^ -UGARITIC}', "");
    Expect(0, 66463, '\P{ -UGARITIC}', "");
    Expect(1, 66463, '\P{^ -UGARITIC}', "");
    Expect(0, 66464, '\p{ -UGARITIC}', "");
    Expect(1, 66464, '\p{^ -UGARITIC}', "");
    Expect(1, 66464, '\P{ -UGARITIC}', "");
    Expect(0, 66464, '\P{^ -UGARITIC}', "");
    Error('\p{:=		Is_Ugaritic}');
    Error('\P{:=		Is_Ugaritic}');
    Expect(1, 66463, '\p{isugaritic}', "");
    Expect(0, 66463, '\p{^isugaritic}', "");
    Expect(0, 66463, '\P{isugaritic}', "");
    Expect(1, 66463, '\P{^isugaritic}', "");
    Expect(0, 66464, '\p{isugaritic}', "");
    Expect(1, 66464, '\p{^isugaritic}', "");
    Expect(1, 66464, '\P{isugaritic}', "");
    Expect(0, 66464, '\P{^isugaritic}', "");
    Expect(1, 66463, '\p{-_is_Ugaritic}', "");
    Expect(0, 66463, '\p{^-_is_Ugaritic}', "");
    Expect(0, 66463, '\P{-_is_Ugaritic}', "");
    Expect(1, 66463, '\P{^-_is_Ugaritic}', "");
    Expect(0, 66464, '\p{-_is_Ugaritic}', "");
    Expect(1, 66464, '\p{^-_is_Ugaritic}', "");
    Expect(1, 66464, '\P{-_is_Ugaritic}', "");
    Expect(0, 66464, '\P{^-_is_Ugaritic}', "");
    Error('\p{-/a/Ugar}');
    Error('\P{-/a/Ugar}');
    Expect(1, 66463, '\p{ugar}', "");
    Expect(0, 66463, '\p{^ugar}', "");
    Expect(0, 66463, '\P{ugar}', "");
    Expect(1, 66463, '\P{^ugar}', "");
    Expect(0, 66464, '\p{ugar}', "");
    Expect(1, 66464, '\p{^ugar}', "");
    Expect(1, 66464, '\P{ugar}', "");
    Expect(0, 66464, '\P{^ugar}', "");
    Expect(1, 66463, '\p{_Ugar}', "");
    Expect(0, 66463, '\p{^_Ugar}', "");
    Expect(0, 66463, '\P{_Ugar}', "");
    Expect(1, 66463, '\P{^_Ugar}', "");
    Expect(0, 66464, '\p{_Ugar}', "");
    Expect(1, 66464, '\p{^_Ugar}', "");
    Expect(1, 66464, '\P{_Ugar}', "");
    Expect(0, 66464, '\P{^_Ugar}', "");
    Error('\p{_	IS_ugar:=}');
    Error('\P{_	IS_ugar:=}');
    Expect(1, 66463, '\p{isugar}', "");
    Expect(0, 66463, '\p{^isugar}', "");
    Expect(0, 66463, '\P{isugar}', "");
    Expect(1, 66463, '\P{^isugar}', "");
    Expect(0, 66464, '\p{isugar}', "");
    Expect(1, 66464, '\p{^isugar}', "");
    Expect(1, 66464, '\P{isugar}', "");
    Expect(0, 66464, '\P{^isugar}', "");
    Expect(1, 66463, '\p{_ IS_Ugar}', "");
    Expect(0, 66463, '\p{^_ IS_Ugar}', "");
    Expect(0, 66463, '\P{_ IS_Ugar}', "");
    Expect(1, 66463, '\P{^_ IS_Ugar}', "");
    Expect(0, 66464, '\p{_ IS_Ugar}', "");
    Expect(1, 66464, '\p{^_ IS_Ugar}', "");
    Expect(1, 66464, '\P{_ IS_Ugar}', "");
    Expect(0, 66464, '\P{^_ IS_Ugar}', "");
    Error('\p{ 	unassigned/a/}');
    Error('\P{ 	unassigned/a/}');
    Expect(1, 918000, '\p{unassigned}', "");
    Expect(0, 918000, '\p{^unassigned}', "");
    Expect(0, 918000, '\P{unassigned}', "");
    Expect(1, 918000, '\P{^unassigned}', "");
    Expect(0, 1114109, '\p{unassigned}', "");
    Expect(1, 1114109, '\p{^unassigned}', "");
    Expect(1, 1114109, '\P{unassigned}', "");
    Expect(0, 1114109, '\P{^unassigned}', "");
    Expect(1, 918000, '\p{_	unassigned}', "");
    Expect(0, 918000, '\p{^_	unassigned}', "");
    Expect(0, 918000, '\P{_	unassigned}', "");
    Expect(1, 918000, '\P{^_	unassigned}', "");
    Expect(0, 1114109, '\p{_	unassigned}', "");
    Expect(1, 1114109, '\p{^_	unassigned}', "");
    Expect(1, 1114109, '\P{_	unassigned}', "");
    Expect(0, 1114109, '\P{^_	unassigned}', "");
    Error('\p{_-Is_UNASSIGNED:=}');
    Error('\P{_-Is_UNASSIGNED:=}');
    Expect(1, 918000, '\p{isunassigned}', "");
    Expect(0, 918000, '\p{^isunassigned}', "");
    Expect(0, 918000, '\P{isunassigned}', "");
    Expect(1, 918000, '\P{^isunassigned}', "");
    Expect(0, 1114109, '\p{isunassigned}', "");
    Expect(1, 1114109, '\p{^isunassigned}', "");
    Expect(1, 1114109, '\P{isunassigned}', "");
    Expect(0, 1114109, '\P{^isunassigned}', "");
    Expect(1, 918000, '\p{	_Is_unassigned}', "");
    Expect(0, 918000, '\p{^	_Is_unassigned}', "");
    Expect(0, 918000, '\P{	_Is_unassigned}', "");
    Expect(1, 918000, '\P{^	_Is_unassigned}', "");
    Expect(0, 1114109, '\p{	_Is_unassigned}', "");
    Expect(1, 1114109, '\p{^	_Is_unassigned}', "");
    Expect(1, 1114109, '\P{	_Is_unassigned}', "");
    Expect(0, 1114109, '\P{^	_Is_unassigned}', "");
    Error('\p{-_CN/a/}');
    Error('\P{-_CN/a/}');
    Expect(1, 918000, '\p{cn}', "");
    Expect(0, 918000, '\p{^cn}', "");
    Expect(0, 918000, '\P{cn}', "");
    Expect(1, 918000, '\P{^cn}', "");
    Expect(0, 1114109, '\p{cn}', "");
    Expect(1, 1114109, '\p{^cn}', "");
    Expect(1, 1114109, '\P{cn}', "");
    Expect(0, 1114109, '\P{^cn}', "");
    Expect(1, 918000, '\p{- cn}', "");
    Expect(0, 918000, '\p{^- cn}', "");
    Expect(0, 918000, '\P{- cn}', "");
    Expect(1, 918000, '\P{^- cn}', "");
    Expect(0, 1114109, '\p{- cn}', "");
    Expect(1, 1114109, '\p{^- cn}', "");
    Expect(1, 1114109, '\P{- cn}', "");
    Expect(0, 1114109, '\P{^- cn}', "");
    Error('\p{ -Is_CN:=}');
    Error('\P{ -Is_CN:=}');
    Expect(1, 918000, '\p{iscn}', "");
    Expect(0, 918000, '\p{^iscn}', "");
    Expect(0, 918000, '\P{iscn}', "");
    Expect(1, 918000, '\P{^iscn}', "");
    Expect(0, 1114109, '\p{iscn}', "");
    Expect(1, 1114109, '\p{^iscn}', "");
    Expect(1, 1114109, '\P{iscn}', "");
    Expect(0, 1114109, '\P{^iscn}', "");
    Expect(1, 918000, '\p{  is_Cn}', "");
    Expect(0, 918000, '\p{^  is_Cn}', "");
    Expect(0, 918000, '\P{  is_Cn}', "");
    Expect(1, 918000, '\P{^  is_Cn}', "");
    Expect(0, 1114109, '\p{  is_Cn}', "");
    Expect(1, 1114109, '\p{^  is_Cn}', "");
    Expect(1, 1114109, '\P{  is_Cn}', "");
    Expect(0, 1114109, '\P{^  is_Cn}', "");
    Error('\p{:=	Unified_Canadian_Aboriginal_SYLLABICS}');
    Error('\P{:=	Unified_Canadian_Aboriginal_SYLLABICS}');
    Expect(1, 5759, '\p{unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\p{^unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\P{unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\P{^unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\p{unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\p{^unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\P{unifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\P{^unifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\p{-UNIFIED_Canadian_aboriginal_SYLLABICS}', "");
    Expect(0, 5759, '\p{^-UNIFIED_Canadian_aboriginal_SYLLABICS}', "");
    Expect(0, 5759, '\P{-UNIFIED_Canadian_aboriginal_SYLLABICS}', "");
    Expect(1, 5759, '\P{^-UNIFIED_Canadian_aboriginal_SYLLABICS}', "");
    Expect(0, 5760, '\p{-UNIFIED_Canadian_aboriginal_SYLLABICS}', "");
    Expect(1, 5760, '\p{^-UNIFIED_Canadian_aboriginal_SYLLABICS}', "");
    Expect(1, 5760, '\P{-UNIFIED_Canadian_aboriginal_SYLLABICS}', "");
    Expect(0, 5760, '\P{^-UNIFIED_Canadian_aboriginal_SYLLABICS}', "");
    Error('\p{/a/_-IS_unified_CANADIAN_Aboriginal_Syllabics}');
    Error('\P{/a/_-IS_unified_CANADIAN_Aboriginal_Syllabics}');
    Expect(1, 5759, '\p{isunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\p{^isunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\P{isunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\P{^isunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\p{isunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\p{^isunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\P{isunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\P{^isunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\p{ -Is_Unified_Canadian_Aboriginal_Syllabics}', "");
    Expect(0, 5759, '\p{^ -Is_Unified_Canadian_Aboriginal_Syllabics}', "");
    Expect(0, 5759, '\P{ -Is_Unified_Canadian_Aboriginal_Syllabics}', "");
    Expect(1, 5759, '\P{^ -Is_Unified_Canadian_Aboriginal_Syllabics}', "");
    Expect(0, 5760, '\p{ -Is_Unified_Canadian_Aboriginal_Syllabics}', "");
    Expect(1, 5760, '\p{^ -Is_Unified_Canadian_Aboriginal_Syllabics}', "");
    Expect(1, 5760, '\P{ -Is_Unified_Canadian_Aboriginal_Syllabics}', "");
    Expect(0, 5760, '\P{^ -Is_Unified_Canadian_Aboriginal_Syllabics}', "");
    Error('\p{__IN_Unified_Canadian_aboriginal_syllabics/a/}');
    Error('\P{__IN_Unified_Canadian_aboriginal_syllabics/a/}');
    Expect(1, 5759, '\p{inunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\p{^inunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5759, '\P{inunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\P{^inunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\p{inunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\p{^inunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5760, '\P{inunifiedcanadianaboriginalsyllabics}', "");
    Expect(0, 5760, '\P{^inunifiedcanadianaboriginalsyllabics}', "");
    Expect(1, 5759, '\p{-In_Unified_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(0, 5759, '\p{^-In_Unified_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(0, 5759, '\P{-In_Unified_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(1, 5759, '\P{^-In_Unified_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(0, 5760, '\p{-In_Unified_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(1, 5760, '\p{^-In_Unified_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(1, 5760, '\P{-In_Unified_Canadian_Aboriginal_SYLLABICS}', "");
    Expect(0, 5760, '\P{^-In_Unified_Canadian_Aboriginal_SYLLABICS}', "");
    Error('\p{	/a/UCAS}');
    Error('\P{	/a/UCAS}');
    Expect(1, 5759, '\p{ucas}', "");
    Expect(0, 5759, '\p{^ucas}', "");
    Expect(0, 5759, '\P{ucas}', "");
    Expect(1, 5759, '\P{^ucas}', "");
    Expect(0, 5760, '\p{ucas}', "");
    Expect(1, 5760, '\p{^ucas}', "");
    Expect(1, 5760, '\P{ucas}', "");
    Expect(0, 5760, '\P{^ucas}', "");
    Expect(1, 5759, '\p{	 UCAS}', "");
    Expect(0, 5759, '\p{^	 UCAS}', "");
    Expect(0, 5759, '\P{	 UCAS}', "");
    Expect(1, 5759, '\P{^	 UCAS}', "");
    Expect(0, 5760, '\p{	 UCAS}', "");
    Expect(1, 5760, '\p{^	 UCAS}', "");
    Expect(1, 5760, '\P{	 UCAS}', "");
    Expect(0, 5760, '\P{^	 UCAS}', "");
    Error('\p{:=	IS_ucas}');
    Error('\P{:=	IS_ucas}');
    Expect(1, 5759, '\p{isucas}', "");
    Expect(0, 5759, '\p{^isucas}', "");
    Expect(0, 5759, '\P{isucas}', "");
    Expect(1, 5759, '\P{^isucas}', "");
    Expect(0, 5760, '\p{isucas}', "");
    Expect(1, 5760, '\p{^isucas}', "");
    Expect(1, 5760, '\P{isucas}', "");
    Expect(0, 5760, '\P{^isucas}', "");
    Expect(1, 5759, '\p{	_Is_ucas}', "");
    Expect(0, 5759, '\p{^	_Is_ucas}', "");
    Expect(0, 5759, '\P{	_Is_ucas}', "");
    Expect(1, 5759, '\P{^	_Is_ucas}', "");
    Expect(0, 5760, '\p{	_Is_ucas}', "");
    Expect(1, 5760, '\p{^	_Is_ucas}', "");
    Expect(1, 5760, '\P{	_Is_ucas}', "");
    Expect(0, 5760, '\P{^	_Is_ucas}', "");
    Error('\p{:=_In_UCAS}');
    Error('\P{:=_In_UCAS}');
    Expect(1, 5759, '\p{inucas}', "");
    Expect(0, 5759, '\p{^inucas}', "");
    Expect(0, 5759, '\P{inucas}', "");
    Expect(1, 5759, '\P{^inucas}', "");
    Expect(0, 5760, '\p{inucas}', "");
    Expect(1, 5760, '\p{^inucas}', "");
    Expect(1, 5760, '\P{inucas}', "");
    Expect(0, 5760, '\P{^inucas}', "");
    Expect(1, 5759, '\p{- In_UCAS}', "");
    Expect(0, 5759, '\p{^- In_UCAS}', "");
    Expect(0, 5759, '\P{- In_UCAS}', "");
    Expect(1, 5759, '\P{^- In_UCAS}', "");
    Expect(0, 5760, '\p{- In_UCAS}', "");
    Expect(1, 5760, '\p{^- In_UCAS}', "");
    Expect(1, 5760, '\P{- In_UCAS}', "");
    Expect(0, 5760, '\P{^- In_UCAS}', "");
    Error('\p{/a/-	CANADIAN_Syllabics}');
    Error('\P{/a/-	CANADIAN_Syllabics}');
    Expect(1, 5759, '\p{canadiansyllabics}', "");
    Expect(0, 5759, '\p{^canadiansyllabics}', "");
    Expect(0, 5759, '\P{canadiansyllabics}', "");
    Expect(1, 5759, '\P{^canadiansyllabics}', "");
    Expect(0, 5760, '\p{canadiansyllabics}', "");
    Expect(1, 5760, '\p{^canadiansyllabics}', "");
    Expect(1, 5760, '\P{canadiansyllabics}', "");
    Expect(0, 5760, '\P{^canadiansyllabics}', "");
    Expect(1, 5759, '\p{-canadian_Syllabics}', "");
    Expect(0, 5759, '\p{^-canadian_Syllabics}', "");
    Expect(0, 5759, '\P{-canadian_Syllabics}', "");
    Expect(1, 5759, '\P{^-canadian_Syllabics}', "");
    Expect(0, 5760, '\p{-canadian_Syllabics}', "");
    Expect(1, 5760, '\p{^-canadian_Syllabics}', "");
    Expect(1, 5760, '\P{-canadian_Syllabics}', "");
    Expect(0, 5760, '\P{^-canadian_Syllabics}', "");
    Error('\p{  Is_Canadian_Syllabics/a/}');
    Error('\P{  Is_Canadian_Syllabics/a/}');
    Expect(1, 5759, '\p{iscanadiansyllabics}', "");
    Expect(0, 5759, '\p{^iscanadiansyllabics}', "");
    Expect(0, 5759, '\P{iscanadiansyllabics}', "");
    Expect(1, 5759, '\P{^iscanadiansyllabics}', "");
    Expect(0, 5760, '\p{iscanadiansyllabics}', "");
    Expect(1, 5760, '\p{^iscanadiansyllabics}', "");
    Expect(1, 5760, '\P{iscanadiansyllabics}', "");
    Expect(0, 5760, '\P{^iscanadiansyllabics}', "");
    Expect(1, 5759, '\p{-Is_Canadian_Syllabics}', "");
    Expect(0, 5759, '\p{^-Is_Canadian_Syllabics}', "");
    Expect(0, 5759, '\P{-Is_Canadian_Syllabics}', "");
    Expect(1, 5759, '\P{^-Is_Canadian_Syllabics}', "");
    Expect(0, 5760, '\p{-Is_Canadian_Syllabics}', "");
    Expect(1, 5760, '\p{^-Is_Canadian_Syllabics}', "");
    Expect(1, 5760, '\P{-Is_Canadian_Syllabics}', "");
    Expect(0, 5760, '\P{^-Is_Canadian_Syllabics}', "");
    Error('\p{-in_Canadian_SYLLABICS/a/}');
    Error('\P{-in_Canadian_SYLLABICS/a/}');
    Expect(1, 5759, '\p{incanadiansyllabics}', "");
    Expect(0, 5759, '\p{^incanadiansyllabics}', "");
    Expect(0, 5759, '\P{incanadiansyllabics}', "");
    Expect(1, 5759, '\P{^incanadiansyllabics}', "");
    Expect(0, 5760, '\p{incanadiansyllabics}', "");
    Expect(1, 5760, '\p{^incanadiansyllabics}', "");
    Expect(1, 5760, '\P{incanadiansyllabics}', "");
    Expect(0, 5760, '\P{^incanadiansyllabics}', "");
    Expect(1, 5759, '\p{_ In_Canadian_Syllabics}', "");
    Expect(0, 5759, '\p{^_ In_Canadian_Syllabics}', "");
    Expect(0, 5759, '\P{_ In_Canadian_Syllabics}', "");
    Expect(1, 5759, '\P{^_ In_Canadian_Syllabics}', "");
    Expect(0, 5760, '\p{_ In_Canadian_Syllabics}', "");
    Expect(1, 5760, '\p{^_ In_Canadian_Syllabics}', "");
    Expect(1, 5760, '\P{_ In_Canadian_Syllabics}', "");
    Expect(0, 5760, '\P{^_ In_Canadian_Syllabics}', "");
    Error('\p{--UNIFIED_canadian_Aboriginal_SYLLABICS_Extended/a/}');
    Error('\P{--UNIFIED_canadian_Aboriginal_SYLLABICS_Extended/a/}');
    Expect(1, 6399, '\p{unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\p{^unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\P{unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\P{^unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\p{unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\p{^unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\P{unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\P{^unifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\p{	Unified_Canadian_Aboriginal_Syllabics_Extended}', "");
    Expect(0, 6399, '\p{^	Unified_Canadian_Aboriginal_Syllabics_Extended}', "");
    Expect(0, 6399, '\P{	Unified_Canadian_Aboriginal_Syllabics_Extended}', "");
    Expect(1, 6399, '\P{^	Unified_Canadian_Aboriginal_Syllabics_Extended}', "");
    Expect(0, 6400, '\p{	Unified_Canadian_Aboriginal_Syllabics_Extended}', "");
    Expect(1, 6400, '\p{^	Unified_Canadian_Aboriginal_Syllabics_Extended}', "");
    Expect(1, 6400, '\P{	Unified_Canadian_Aboriginal_Syllabics_Extended}', "");
    Expect(0, 6400, '\P{^	Unified_Canadian_Aboriginal_Syllabics_Extended}', "");
    Error('\p{:=- Is_unified_canadian_ABORIGINAL_Syllabics_extended}');
    Error('\P{:=- Is_unified_canadian_ABORIGINAL_Syllabics_extended}');
    Expect(1, 6399, '\p{isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\p{^isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\P{isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\P{^isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\p{isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\p{^isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\P{isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\P{^isunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\p{	-IS_Unified_CANADIAN_aboriginal_SYLLABICS_extended}', "");
    Expect(0, 6399, '\p{^	-IS_Unified_CANADIAN_aboriginal_SYLLABICS_extended}', "");
    Expect(0, 6399, '\P{	-IS_Unified_CANADIAN_aboriginal_SYLLABICS_extended}', "");
    Expect(1, 6399, '\P{^	-IS_Unified_CANADIAN_aboriginal_SYLLABICS_extended}', "");
    Expect(0, 6400, '\p{	-IS_Unified_CANADIAN_aboriginal_SYLLABICS_extended}', "");
    Expect(1, 6400, '\p{^	-IS_Unified_CANADIAN_aboriginal_SYLLABICS_extended}', "");
    Expect(1, 6400, '\P{	-IS_Unified_CANADIAN_aboriginal_SYLLABICS_extended}', "");
    Expect(0, 6400, '\P{^	-IS_Unified_CANADIAN_aboriginal_SYLLABICS_extended}', "");
    Error('\p{/a/		In_Unified_CANADIAN_aboriginal_SYLLABICS_extended}');
    Error('\P{/a/		In_Unified_CANADIAN_aboriginal_SYLLABICS_extended}');
    Expect(1, 6399, '\p{inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\p{^inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6399, '\P{inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\P{^inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\p{inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\p{^inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6400, '\P{inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(0, 6400, '\P{^inunifiedcanadianaboriginalsyllabicsextended}', "");
    Expect(1, 6399, '\p{ In_UNIFIED_Canadian_ABORIGINAL_syllabics_extended}', "");
    Expect(0, 6399, '\p{^ In_UNIFIED_Canadian_ABORIGINAL_syllabics_extended}', "");
    Expect(0, 6399, '\P{ In_UNIFIED_Canadian_ABORIGINAL_syllabics_extended}', "");
    Expect(1, 6399, '\P{^ In_UNIFIED_Canadian_ABORIGINAL_syllabics_extended}', "");
    Expect(0, 6400, '\p{ In_UNIFIED_Canadian_ABORIGINAL_syllabics_extended}', "");
    Expect(1, 6400, '\p{^ In_UNIFIED_Canadian_ABORIGINAL_syllabics_extended}', "");
    Expect(1, 6400, '\P{ In_UNIFIED_Canadian_ABORIGINAL_syllabics_extended}', "");
    Expect(0, 6400, '\P{^ In_UNIFIED_Canadian_ABORIGINAL_syllabics_extended}', "");
    Error('\p{-ucas_EXT/a/}');
    Error('\P{-ucas_EXT/a/}');
    Expect(1, 6399, '\p{ucasext}', "");
    Expect(0, 6399, '\p{^ucasext}', "");
    Expect(0, 6399, '\P{ucasext}', "");
    Expect(1, 6399, '\P{^ucasext}', "");
    Expect(0, 6400, '\p{ucasext}', "");
    Expect(1, 6400, '\p{^ucasext}', "");
    Expect(1, 6400, '\P{ucasext}', "");
    Expect(0, 6400, '\P{^ucasext}', "");
    Expect(1, 6399, '\p{-UCAS_Ext}', "");
    Expect(0, 6399, '\p{^-UCAS_Ext}', "");
    Expect(0, 6399, '\P{-UCAS_Ext}', "");
    Expect(1, 6399, '\P{^-UCAS_Ext}', "");
    Expect(0, 6400, '\p{-UCAS_Ext}', "");
    Expect(1, 6400, '\p{^-UCAS_Ext}', "");
    Expect(1, 6400, '\P{-UCAS_Ext}', "");
    Expect(0, 6400, '\P{^-UCAS_Ext}', "");
    Error('\p{_ IS_UCAS_EXT:=}');
    Error('\P{_ IS_UCAS_EXT:=}');
    Expect(1, 6399, '\p{isucasext}', "");
    Expect(0, 6399, '\p{^isucasext}', "");
    Expect(0, 6399, '\P{isucasext}', "");
    Expect(1, 6399, '\P{^isucasext}', "");
    Expect(0, 6400, '\p{isucasext}', "");
    Expect(1, 6400, '\p{^isucasext}', "");
    Expect(1, 6400, '\P{isucasext}', "");
    Expect(0, 6400, '\P{^isucasext}', "");
    Expect(1, 6399, '\p{	 is_UCAS_EXT}', "");
    Expect(0, 6399, '\p{^	 is_UCAS_EXT}', "");
    Expect(0, 6399, '\P{	 is_UCAS_EXT}', "");
    Expect(1, 6399, '\P{^	 is_UCAS_EXT}', "");
    Expect(0, 6400, '\p{	 is_UCAS_EXT}', "");
    Expect(1, 6400, '\p{^	 is_UCAS_EXT}', "");
    Expect(1, 6400, '\P{	 is_UCAS_EXT}', "");
    Expect(0, 6400, '\P{^	 is_UCAS_EXT}', "");
    Error('\p{ :=in_UCAS_Ext}');
    Error('\P{ :=in_UCAS_Ext}');
    Expect(1, 6399, '\p{inucasext}', "");
    Expect(0, 6399, '\p{^inucasext}', "");
    Expect(0, 6399, '\P{inucasext}', "");
    Expect(1, 6399, '\P{^inucasext}', "");
    Expect(0, 6400, '\p{inucasext}', "");
    Expect(1, 6400, '\p{^inucasext}', "");
    Expect(1, 6400, '\P{inucasext}', "");
    Expect(0, 6400, '\P{^inucasext}', "");
    Expect(1, 6399, '\p{ 	IN_UCAS_EXT}', "");
    Expect(0, 6399, '\p{^ 	IN_UCAS_EXT}', "");
    Expect(0, 6399, '\P{ 	IN_UCAS_EXT}', "");
    Expect(1, 6399, '\P{^ 	IN_UCAS_EXT}', "");
    Expect(0, 6400, '\p{ 	IN_UCAS_EXT}', "");
    Expect(1, 6400, '\p{^ 	IN_UCAS_EXT}', "");
    Expect(1, 6400, '\P{ 	IN_UCAS_EXT}', "");
    Expect(0, 6400, '\P{^ 	IN_UCAS_EXT}', "");
    Error('\p{/a/Unified_IDEOGRAPH}');
    Error('\P{/a/Unified_IDEOGRAPH}');
    Expect(1, 191456, '\p{unifiedideograph}', "");
    Expect(0, 191456, '\p{^unifiedideograph}', "");
    Expect(0, 191456, '\P{unifiedideograph}', "");
    Expect(1, 191456, '\P{^unifiedideograph}', "");
    Expect(0, 191457, '\p{unifiedideograph}', "");
    Expect(1, 191457, '\p{^unifiedideograph}', "");
    Expect(1, 191457, '\P{unifiedideograph}', "");
    Expect(0, 191457, '\P{^unifiedideograph}', "");
    Expect(1, 191456, '\p{	_unified_ideograph}', "");
    Expect(0, 191456, '\p{^	_unified_ideograph}', "");
    Expect(0, 191456, '\P{	_unified_ideograph}', "");
    Expect(1, 191456, '\P{^	_unified_ideograph}', "");
    Expect(0, 191457, '\p{	_unified_ideograph}', "");
    Expect(1, 191457, '\p{^	_unified_ideograph}', "");
    Expect(1, 191457, '\P{	_unified_ideograph}', "");
    Expect(0, 191457, '\P{^	_unified_ideograph}', "");
    Error('\p{:=	is_unified_ideograph}');
    Error('\P{:=	is_unified_ideograph}');
    Expect(1, 191456, '\p{isunifiedideograph}', "");
    Expect(0, 191456, '\p{^isunifiedideograph}', "");
    Expect(0, 191456, '\P{isunifiedideograph}', "");
    Expect(1, 191456, '\P{^isunifiedideograph}', "");
    Expect(0, 191457, '\p{isunifiedideograph}', "");
    Expect(1, 191457, '\p{^isunifiedideograph}', "");
    Expect(1, 191457, '\P{isunifiedideograph}', "");
    Expect(0, 191457, '\P{^isunifiedideograph}', "");
    Expect(1, 191456, '\p{_ Is_Unified_ideograph}', "");
    Expect(0, 191456, '\p{^_ Is_Unified_ideograph}', "");
    Expect(0, 191456, '\P{_ Is_Unified_ideograph}', "");
    Expect(1, 191456, '\P{^_ Is_Unified_ideograph}', "");
    Expect(0, 191457, '\p{_ Is_Unified_ideograph}', "");
    Expect(1, 191457, '\p{^_ Is_Unified_ideograph}', "");
    Expect(1, 191457, '\P{_ Is_Unified_ideograph}', "");
    Expect(0, 191457, '\P{^_ Is_Unified_ideograph}', "");
    Error('\p{-	uideo/a/}');
    Error('\P{-	uideo/a/}');
    Expect(1, 191456, '\p{uideo}', "");
    Expect(0, 191456, '\p{^uideo}', "");
    Expect(0, 191456, '\P{uideo}', "");
    Expect(1, 191456, '\P{^uideo}', "");
    Expect(0, 191457, '\p{uideo}', "");
    Expect(1, 191457, '\p{^uideo}', "");
    Expect(1, 191457, '\P{uideo}', "");
    Expect(0, 191457, '\P{^uideo}', "");
    Error('\p{:= Is_UIdeo}');
    Error('\P{:= Is_UIdeo}');
    Expect(1, 191456, '\p{isuideo}', "");
    Expect(0, 191456, '\p{^isuideo}', "");
    Expect(0, 191456, '\P{isuideo}', "");
    Expect(1, 191456, '\P{^isuideo}', "");
    Expect(0, 191457, '\p{isuideo}', "");
    Expect(1, 191457, '\p{^isuideo}', "");
    Expect(1, 191457, '\P{isuideo}', "");
    Expect(0, 191457, '\P{^isuideo}', "");
    Expect(1, 191456, '\p{_is_UIDEO}', "");
    Expect(0, 191456, '\p{^_is_UIDEO}', "");
    Expect(0, 191456, '\P{_is_UIDEO}', "");
    Expect(1, 191456, '\P{^_is_UIDEO}', "");
    Expect(0, 191457, '\p{_is_UIDEO}', "");
    Expect(1, 191457, '\p{^_is_UIDEO}', "");
    Expect(1, 191457, '\P{_is_UIDEO}', "");
    Expect(0, 191457, '\P{^_is_UIDEO}', "");
    Error('\p{		unknown:=}');
    Error('\P{		unknown:=}');
    Expect(1, 918000, '\p{unknown}', "");
    Expect(0, 918000, '\p{^unknown}', "");
    Expect(0, 918000, '\P{unknown}', "");
    Expect(1, 918000, '\P{^unknown}', "");
    Expect(0, 917999, '\p{unknown}', "");
    Expect(1, 917999, '\p{^unknown}', "");
    Expect(1, 917999, '\P{unknown}', "");
    Expect(0, 917999, '\P{^unknown}', "");
    Expect(1, 918000, '\p{	Unknown}', "");
    Expect(0, 918000, '\p{^	Unknown}', "");
    Expect(0, 918000, '\P{	Unknown}', "");
    Expect(1, 918000, '\P{^	Unknown}', "");
    Expect(0, 917999, '\p{	Unknown}', "");
    Expect(1, 917999, '\p{^	Unknown}', "");
    Expect(1, 917999, '\P{	Unknown}', "");
    Expect(0, 917999, '\P{^	Unknown}', "");
    Error('\p{	:=is_Unknown}');
    Error('\P{	:=is_Unknown}');
    Expect(1, 918000, '\p{isunknown}', "");
    Expect(0, 918000, '\p{^isunknown}', "");
    Expect(0, 918000, '\P{isunknown}', "");
    Expect(1, 918000, '\P{^isunknown}', "");
    Expect(0, 917999, '\p{isunknown}', "");
    Expect(1, 917999, '\p{^isunknown}', "");
    Expect(1, 917999, '\P{isunknown}', "");
    Expect(0, 917999, '\P{^isunknown}', "");
    Expect(1, 918000, '\p{	Is_Unknown}', "");
    Expect(0, 918000, '\p{^	Is_Unknown}', "");
    Expect(0, 918000, '\P{	Is_Unknown}', "");
    Expect(1, 918000, '\P{^	Is_Unknown}', "");
    Expect(0, 917999, '\p{	Is_Unknown}', "");
    Expect(1, 917999, '\p{^	Is_Unknown}', "");
    Expect(1, 917999, '\P{	Is_Unknown}', "");
    Expect(0, 917999, '\P{^	Is_Unknown}', "");
    Error('\p{ :=Zzzz}');
    Error('\P{ :=Zzzz}');
    Expect(1, 918000, '\p{zzzz}', "");
    Expect(0, 918000, '\p{^zzzz}', "");
    Expect(0, 918000, '\P{zzzz}', "");
    Expect(1, 918000, '\P{^zzzz}', "");
    Expect(0, 917999, '\p{zzzz}', "");
    Expect(1, 917999, '\p{^zzzz}', "");
    Expect(1, 917999, '\P{zzzz}', "");
    Expect(0, 917999, '\P{^zzzz}', "");
    Expect(1, 918000, '\p{-Zzzz}', "");
    Expect(0, 918000, '\p{^-Zzzz}', "");
    Expect(0, 918000, '\P{-Zzzz}', "");
    Expect(1, 918000, '\P{^-Zzzz}', "");
    Expect(0, 917999, '\p{-Zzzz}', "");
    Expect(1, 917999, '\p{^-Zzzz}', "");
    Expect(1, 917999, '\P{-Zzzz}', "");
    Expect(0, 917999, '\P{^-Zzzz}', "");
    Error('\p{/a/ -IS_zzzz}');
    Error('\P{/a/ -IS_zzzz}');
    Expect(1, 918000, '\p{iszzzz}', "");
    Expect(0, 918000, '\p{^iszzzz}', "");
    Expect(0, 918000, '\P{iszzzz}', "");
    Expect(1, 918000, '\P{^iszzzz}', "");
    Expect(0, 917999, '\p{iszzzz}', "");
    Expect(1, 917999, '\p{^iszzzz}', "");
    Expect(1, 917999, '\P{iszzzz}', "");
    Expect(0, 917999, '\P{^iszzzz}', "");
    Expect(1, 918000, '\p{-_Is_zzzz}', "");
    Expect(0, 918000, '\p{^-_Is_zzzz}', "");
    Expect(0, 918000, '\P{-_Is_zzzz}', "");
    Expect(1, 918000, '\P{^-_Is_zzzz}', "");
    Expect(0, 917999, '\p{-_Is_zzzz}', "");
    Expect(1, 917999, '\p{^-_Is_zzzz}', "");
    Expect(1, 917999, '\P{-_Is_zzzz}', "");
    Expect(0, 917999, '\P{^-_Is_zzzz}', "");
    Error('\p{_/a/uppercase_Letter}');
    Error('\P{_/a/uppercase_Letter}');
    Expect(1, 125217, '\p{uppercaseletter}', "");
    Expect(0, 125217, '\p{^uppercaseletter}', "");
    Expect(0, 125217, '\P{uppercaseletter}', "");
    Expect(1, 125217, '\P{^uppercaseletter}', "");
    Expect(0, 125218, '\p{uppercaseletter}', "");
    Expect(1, 125218, '\p{^uppercaseletter}', "");
    Expect(1, 125218, '\P{uppercaseletter}', "");
    Expect(0, 125218, '\P{^uppercaseletter}', "");
    Expect(1, 125217, '\p{- UPPERCASE_letter}', "");
    Expect(0, 125217, '\p{^- UPPERCASE_letter}', "");
    Expect(0, 125217, '\P{- UPPERCASE_letter}', "");
    Expect(1, 125217, '\P{^- UPPERCASE_letter}', "");
    Expect(0, 125218, '\p{- UPPERCASE_letter}', "");
    Expect(1, 125218, '\p{^- UPPERCASE_letter}', "");
    Expect(1, 125218, '\P{- UPPERCASE_letter}', "");
    Expect(0, 125218, '\P{^- UPPERCASE_letter}', "");
    Error('\p{_:=is_uppercase_Letter}');
    Error('\P{_:=is_uppercase_Letter}');
    Expect(1, 125217, '\p{isuppercaseletter}', "");
    Expect(0, 125217, '\p{^isuppercaseletter}', "");
    Expect(0, 125217, '\P{isuppercaseletter}', "");
    Expect(1, 125217, '\P{^isuppercaseletter}', "");
    Expect(0, 125218, '\p{isuppercaseletter}', "");
    Expect(1, 125218, '\p{^isuppercaseletter}', "");
    Expect(1, 125218, '\P{isuppercaseletter}', "");
    Expect(0, 125218, '\P{^isuppercaseletter}', "");
    Expect(1, 125217, '\p{	-is_UPPERCASE_Letter}', "");
    Expect(0, 125217, '\p{^	-is_UPPERCASE_Letter}', "");
    Expect(0, 125217, '\P{	-is_UPPERCASE_Letter}', "");
    Expect(1, 125217, '\P{^	-is_UPPERCASE_Letter}', "");
    Expect(0, 125218, '\p{	-is_UPPERCASE_Letter}', "");
    Expect(1, 125218, '\p{^	-is_UPPERCASE_Letter}', "");
    Expect(1, 125218, '\P{	-is_UPPERCASE_Letter}', "");
    Expect(0, 125218, '\P{^	-is_UPPERCASE_Letter}', "");
    Error('\p{/a/  Lu}');
    Error('\P{/a/  Lu}');
    Expect(1, 125217, '\p{lu}', "");
    Expect(0, 125217, '\p{^lu}', "");
    Expect(0, 125217, '\P{lu}', "");
    Expect(1, 125217, '\P{^lu}', "");
    Expect(0, 125218, '\p{lu}', "");
    Expect(1, 125218, '\p{^lu}', "");
    Expect(1, 125218, '\P{lu}', "");
    Expect(0, 125218, '\P{^lu}', "");
    Expect(1, 125217, '\p{		Lu}', "");
    Expect(0, 125217, '\p{^		Lu}', "");
    Expect(0, 125217, '\P{		Lu}', "");
    Expect(1, 125217, '\P{^		Lu}', "");
    Expect(0, 125218, '\p{		Lu}', "");
    Expect(1, 125218, '\p{^		Lu}', "");
    Expect(1, 125218, '\P{		Lu}', "");
    Expect(0, 125218, '\P{^		Lu}', "");
    Error('\p{ /a/IS_Lu}');
    Error('\P{ /a/IS_Lu}');
    Expect(1, 125217, '\p{islu}', "");
    Expect(0, 125217, '\p{^islu}', "");
    Expect(0, 125217, '\P{islu}', "");
    Expect(1, 125217, '\P{^islu}', "");
    Expect(0, 125218, '\p{islu}', "");
    Expect(1, 125218, '\p{^islu}', "");
    Expect(1, 125218, '\P{islu}', "");
    Expect(0, 125218, '\P{^islu}', "");
    Expect(1, 125217, '\p{ _Is_Lu}', "");
    Expect(0, 125217, '\p{^ _Is_Lu}', "");
    Expect(0, 125217, '\P{ _Is_Lu}', "");
    Expect(1, 125217, '\P{^ _Is_Lu}', "");
    Expect(0, 125218, '\p{ _Is_Lu}', "");
    Expect(1, 125218, '\p{^ _Is_Lu}', "");
    Expect(1, 125218, '\P{ _Is_Lu}', "");
    Expect(0, 125218, '\P{^ _Is_Lu}', "");
    Error('\p{ /a/Vai}');
    Error('\P{ /a/Vai}');
    Expect(1, 42539, '\p{vai}', "");
    Expect(0, 42539, '\p{^vai}', "");
    Expect(0, 42539, '\P{vai}', "");
    Expect(1, 42539, '\P{^vai}', "");
    Expect(0, 42540, '\p{vai}', "");
    Expect(1, 42540, '\p{^vai}', "");
    Expect(1, 42540, '\P{vai}', "");
    Expect(0, 42540, '\P{^vai}', "");
    Expect(1, 42539, '\p{  vai}', "");
    Expect(0, 42539, '\p{^  vai}', "");
    Expect(0, 42539, '\P{  vai}', "");
    Expect(1, 42539, '\P{^  vai}', "");
    Expect(0, 42540, '\p{  vai}', "");
    Expect(1, 42540, '\p{^  vai}', "");
    Expect(1, 42540, '\P{  vai}', "");
    Expect(0, 42540, '\P{^  vai}', "");
    Error('\p{Is_VAI:=}');
    Error('\P{Is_VAI:=}');
    Expect(1, 42539, '\p{isvai}', "");
    Expect(0, 42539, '\p{^isvai}', "");
    Expect(0, 42539, '\P{isvai}', "");
    Expect(1, 42539, '\P{^isvai}', "");
    Expect(0, 42540, '\p{isvai}', "");
    Expect(1, 42540, '\p{^isvai}', "");
    Expect(1, 42540, '\P{isvai}', "");
    Expect(0, 42540, '\P{^isvai}', "");
    Expect(1, 42539, '\p{	-IS_vai}', "");
    Expect(0, 42539, '\p{^	-IS_vai}', "");
    Expect(0, 42539, '\P{	-IS_vai}', "");
    Expect(1, 42539, '\P{^	-IS_vai}', "");
    Expect(0, 42540, '\p{	-IS_vai}', "");
    Expect(1, 42540, '\p{^	-IS_vai}', "");
    Expect(1, 42540, '\P{	-IS_vai}', "");
    Expect(0, 42540, '\P{^	-IS_vai}', "");
    Error('\p{/a/	 VAII}');
    Error('\P{/a/	 VAII}');
    Expect(1, 42539, '\p{vaii}', "");
    Expect(0, 42539, '\p{^vaii}', "");
    Expect(0, 42539, '\P{vaii}', "");
    Expect(1, 42539, '\P{^vaii}', "");
    Expect(0, 42540, '\p{vaii}', "");
    Expect(1, 42540, '\p{^vaii}', "");
    Expect(1, 42540, '\P{vaii}', "");
    Expect(0, 42540, '\P{^vaii}', "");
    Expect(1, 42539, '\p{_vaii}', "");
    Expect(0, 42539, '\p{^_vaii}', "");
    Expect(0, 42539, '\P{_vaii}', "");
    Expect(1, 42539, '\P{^_vaii}', "");
    Expect(0, 42540, '\p{_vaii}', "");
    Expect(1, 42540, '\p{^_vaii}', "");
    Expect(1, 42540, '\P{_vaii}', "");
    Expect(0, 42540, '\P{^_vaii}', "");
    Error('\p{ Is_Vaii:=}');
    Error('\P{ Is_Vaii:=}');
    Expect(1, 42539, '\p{isvaii}', "");
    Expect(0, 42539, '\p{^isvaii}', "");
    Expect(0, 42539, '\P{isvaii}', "");
    Expect(1, 42539, '\P{^isvaii}', "");
    Expect(0, 42540, '\p{isvaii}', "");
    Expect(1, 42540, '\p{^isvaii}', "");
    Expect(1, 42540, '\P{isvaii}', "");
    Expect(0, 42540, '\P{^isvaii}', "");
    Expect(1, 42539, '\p{Is_Vaii}', "");
    Expect(0, 42539, '\p{^Is_Vaii}', "");
    Expect(0, 42539, '\P{Is_Vaii}', "");
    Expect(1, 42539, '\P{^Is_Vaii}', "");
    Expect(0, 42540, '\p{Is_Vaii}', "");
    Expect(1, 42540, '\p{^Is_Vaii}', "");
    Expect(1, 42540, '\P{Is_Vaii}', "");
    Expect(0, 42540, '\P{^Is_Vaii}', "");
    Error('\p{/a/	 Variation_Selector}');
    Error('\P{/a/	 Variation_Selector}');
    Expect(1, 917999, '\p{variationselector}', "");
    Expect(0, 917999, '\p{^variationselector}', "");
    Expect(0, 917999, '\P{variationselector}', "");
    Expect(1, 917999, '\P{^variationselector}', "");
    Expect(0, 918000, '\p{variationselector}', "");
    Expect(1, 918000, '\p{^variationselector}', "");
    Expect(1, 918000, '\P{variationselector}', "");
    Expect(0, 918000, '\P{^variationselector}', "");
    Expect(1, 917999, '\p{		VARIATION_selector}', "");
    Expect(0, 917999, '\p{^		VARIATION_selector}', "");
    Expect(0, 917999, '\P{		VARIATION_selector}', "");
    Expect(1, 917999, '\P{^		VARIATION_selector}', "");
    Expect(0, 918000, '\p{		VARIATION_selector}', "");
    Expect(1, 918000, '\p{^		VARIATION_selector}', "");
    Expect(1, 918000, '\P{		VARIATION_selector}', "");
    Expect(0, 918000, '\P{^		VARIATION_selector}', "");
    Error('\p{/a/ _Is_Variation_SELECTOR}');
    Error('\P{/a/ _Is_Variation_SELECTOR}');
    Expect(1, 917999, '\p{isvariationselector}', "");
    Expect(0, 917999, '\p{^isvariationselector}', "");
    Expect(0, 917999, '\P{isvariationselector}', "");
    Expect(1, 917999, '\P{^isvariationselector}', "");
    Expect(0, 918000, '\p{isvariationselector}', "");
    Expect(1, 918000, '\p{^isvariationselector}', "");
    Expect(1, 918000, '\P{isvariationselector}', "");
    Expect(0, 918000, '\P{^isvariationselector}', "");
    Expect(1, 917999, '\p{ IS_variation_Selector}', "");
    Expect(0, 917999, '\p{^ IS_variation_Selector}', "");
    Expect(0, 917999, '\P{ IS_variation_Selector}', "");
    Expect(1, 917999, '\P{^ IS_variation_Selector}', "");
    Expect(0, 918000, '\p{ IS_variation_Selector}', "");
    Expect(1, 918000, '\p{^ IS_variation_Selector}', "");
    Expect(1, 918000, '\P{ IS_variation_Selector}', "");
    Expect(0, 918000, '\P{^ IS_variation_Selector}', "");
    Error('\p{_ VS:=}');
    Error('\P{_ VS:=}');
    Expect(1, 917999, '\p{vs}', "");
    Expect(0, 917999, '\p{^vs}', "");
    Expect(0, 917999, '\P{vs}', "");
    Expect(1, 917999, '\P{^vs}', "");
    Expect(0, 918000, '\p{vs}', "");
    Expect(1, 918000, '\p{^vs}', "");
    Expect(1, 918000, '\P{vs}', "");
    Expect(0, 918000, '\P{^vs}', "");
    Expect(1, 917999, '\p{	_VS}', "");
    Expect(0, 917999, '\p{^	_VS}', "");
    Expect(0, 917999, '\P{	_VS}', "");
    Expect(1, 917999, '\P{^	_VS}', "");
    Expect(0, 918000, '\p{	_VS}', "");
    Expect(1, 918000, '\p{^	_VS}', "");
    Expect(1, 918000, '\P{	_VS}', "");
    Expect(0, 918000, '\P{^	_VS}', "");
    Error('\p{/a/	Is_VS}');
    Error('\P{/a/	Is_VS}');
    Expect(1, 917999, '\p{isvs}', "");
    Expect(0, 917999, '\p{^isvs}', "");
    Expect(0, 917999, '\P{isvs}', "");
    Expect(1, 917999, '\P{^isvs}', "");
    Expect(0, 918000, '\p{isvs}', "");
    Expect(1, 918000, '\p{^isvs}', "");
    Expect(1, 918000, '\P{isvs}', "");
    Expect(0, 918000, '\P{^isvs}', "");
    Expect(1, 917999, '\p{	_Is_VS}', "");
    Expect(0, 917999, '\p{^	_Is_VS}', "");
    Expect(0, 917999, '\P{	_Is_VS}', "");
    Expect(1, 917999, '\P{^	_Is_VS}', "");
    Expect(0, 918000, '\p{	_Is_VS}', "");
    Expect(1, 918000, '\p{^	_Is_VS}', "");
    Expect(1, 918000, '\P{	_Is_VS}', "");
    Expect(0, 918000, '\P{^	_Is_VS}', "");
    Error('\p{_/a/variation_Selectors}');
    Error('\P{_/a/variation_Selectors}');
    Expect(1, 65039, '\p{variationselectors}', "");
    Expect(0, 65039, '\p{^variationselectors}', "");
    Expect(0, 65039, '\P{variationselectors}', "");
    Expect(1, 65039, '\P{^variationselectors}', "");
    Expect(0, 65040, '\p{variationselectors}', "");
    Expect(1, 65040, '\p{^variationselectors}', "");
    Expect(1, 65040, '\P{variationselectors}', "");
    Expect(0, 65040, '\P{^variationselectors}', "");
    Expect(1, 65039, '\p{-variation_SELECTORS}', "");
    Expect(0, 65039, '\p{^-variation_SELECTORS}', "");
    Expect(0, 65039, '\P{-variation_SELECTORS}', "");
    Expect(1, 65039, '\P{^-variation_SELECTORS}', "");
    Expect(0, 65040, '\p{-variation_SELECTORS}', "");
    Expect(1, 65040, '\p{^-variation_SELECTORS}', "");
    Expect(1, 65040, '\P{-variation_SELECTORS}', "");
    Expect(0, 65040, '\P{^-variation_SELECTORS}', "");
    Error('\p{/a/_ is_VARIATION_Selectors}');
    Error('\P{/a/_ is_VARIATION_Selectors}');
    Expect(1, 65039, '\p{isvariationselectors}', "");
    Expect(0, 65039, '\p{^isvariationselectors}', "");
    Expect(0, 65039, '\P{isvariationselectors}', "");
    Expect(1, 65039, '\P{^isvariationselectors}', "");
    Expect(0, 65040, '\p{isvariationselectors}', "");
    Expect(1, 65040, '\p{^isvariationselectors}', "");
    Expect(1, 65040, '\P{isvariationselectors}', "");
    Expect(0, 65040, '\P{^isvariationselectors}', "");
    Expect(1, 65039, '\p{_is_VARIATION_Selectors}', "");
    Expect(0, 65039, '\p{^_is_VARIATION_Selectors}', "");
    Expect(0, 65039, '\P{_is_VARIATION_Selectors}', "");
    Expect(1, 65039, '\P{^_is_VARIATION_Selectors}', "");
    Expect(0, 65040, '\p{_is_VARIATION_Selectors}', "");
    Expect(1, 65040, '\p{^_is_VARIATION_Selectors}', "");
    Expect(1, 65040, '\P{_is_VARIATION_Selectors}', "");
    Expect(0, 65040, '\P{^_is_VARIATION_Selectors}', "");
    Error('\p{	:=In_Variation_Selectors}');
    Error('\P{	:=In_Variation_Selectors}');
    Expect(1, 65039, '\p{invariationselectors}', "");
    Expect(0, 65039, '\p{^invariationselectors}', "");
    Expect(0, 65039, '\P{invariationselectors}', "");
    Expect(1, 65039, '\P{^invariationselectors}', "");
    Expect(0, 65040, '\p{invariationselectors}', "");
    Expect(1, 65040, '\p{^invariationselectors}', "");
    Expect(1, 65040, '\P{invariationselectors}', "");
    Expect(0, 65040, '\P{^invariationselectors}', "");
    Expect(1, 65039, '\p{-In_Variation_SELECTORS}', "");
    Expect(0, 65039, '\p{^-In_Variation_SELECTORS}', "");
    Expect(0, 65039, '\P{-In_Variation_SELECTORS}', "");
    Expect(1, 65039, '\P{^-In_Variation_SELECTORS}', "");
    Expect(0, 65040, '\p{-In_Variation_SELECTORS}', "");
    Expect(1, 65040, '\p{^-In_Variation_SELECTORS}', "");
    Expect(1, 65040, '\P{-In_Variation_SELECTORS}', "");
    Expect(0, 65040, '\P{^-In_Variation_SELECTORS}', "");
    Error('\p{/a/__in_VS}');
    Error('\P{/a/__in_VS}');
    Expect(1, 65039, '\p{invs}', "");
    Expect(0, 65039, '\p{^invs}', "");
    Expect(0, 65039, '\P{invs}', "");
    Expect(1, 65039, '\P{^invs}', "");
    Expect(0, 65040, '\p{invs}', "");
    Expect(1, 65040, '\p{^invs}', "");
    Expect(1, 65040, '\P{invs}', "");
    Expect(0, 65040, '\P{^invs}', "");
    Expect(1, 65039, '\p{		In_VS}', "");
    Expect(0, 65039, '\p{^		In_VS}', "");
    Expect(0, 65039, '\P{		In_VS}', "");
    Expect(1, 65039, '\P{^		In_VS}', "");
    Expect(0, 65040, '\p{		In_VS}', "");
    Expect(1, 65040, '\p{^		In_VS}', "");
    Expect(1, 65040, '\P{		In_VS}', "");
    Expect(0, 65040, '\P{^		In_VS}', "");
    Error('\p{	VARIATION_SELECTORS_SUPPLEMENT/a/}');
    Error('\P{	VARIATION_SELECTORS_SUPPLEMENT/a/}');
    Expect(1, 917999, '\p{variationselectorssupplement}', "");
    Expect(0, 917999, '\p{^variationselectorssupplement}', "");
    Expect(0, 917999, '\P{variationselectorssupplement}', "");
    Expect(1, 917999, '\P{^variationselectorssupplement}', "");
    Expect(0, 918000, '\p{variationselectorssupplement}', "");
    Expect(1, 918000, '\p{^variationselectorssupplement}', "");
    Expect(1, 918000, '\P{variationselectorssupplement}', "");
    Expect(0, 918000, '\P{^variationselectorssupplement}', "");
    Expect(1, 917999, '\p{-_variation_SELECTORS_Supplement}', "");
    Expect(0, 917999, '\p{^-_variation_SELECTORS_Supplement}', "");
    Expect(0, 917999, '\P{-_variation_SELECTORS_Supplement}', "");
    Expect(1, 917999, '\P{^-_variation_SELECTORS_Supplement}', "");
    Expect(0, 918000, '\p{-_variation_SELECTORS_Supplement}', "");
    Expect(1, 918000, '\p{^-_variation_SELECTORS_Supplement}', "");
    Expect(1, 918000, '\P{-_variation_SELECTORS_Supplement}', "");
    Expect(0, 918000, '\P{^-_variation_SELECTORS_Supplement}', "");
    Error('\p{--Is_Variation_selectors_Supplement:=}');
    Error('\P{--Is_Variation_selectors_Supplement:=}');
    Expect(1, 917999, '\p{isvariationselectorssupplement}', "");
    Expect(0, 917999, '\p{^isvariationselectorssupplement}', "");
    Expect(0, 917999, '\P{isvariationselectorssupplement}', "");
    Expect(1, 917999, '\P{^isvariationselectorssupplement}', "");
    Expect(0, 918000, '\p{isvariationselectorssupplement}', "");
    Expect(1, 918000, '\p{^isvariationselectorssupplement}', "");
    Expect(1, 918000, '\P{isvariationselectorssupplement}', "");
    Expect(0, 918000, '\P{^isvariationselectorssupplement}', "");
    Expect(1, 917999, '\p{	Is_Variation_SELECTORS_Supplement}', "");
    Expect(0, 917999, '\p{^	Is_Variation_SELECTORS_Supplement}', "");
    Expect(0, 917999, '\P{	Is_Variation_SELECTORS_Supplement}', "");
    Expect(1, 917999, '\P{^	Is_Variation_SELECTORS_Supplement}', "");
    Expect(0, 918000, '\p{	Is_Variation_SELECTORS_Supplement}', "");
    Expect(1, 918000, '\p{^	Is_Variation_SELECTORS_Supplement}', "");
    Expect(1, 918000, '\P{	Is_Variation_SELECTORS_Supplement}', "");
    Expect(0, 918000, '\P{^	Is_Variation_SELECTORS_Supplement}', "");
    Error('\p{:=in_VARIATION_Selectors_SUPPLEMENT}');
    Error('\P{:=in_VARIATION_Selectors_SUPPLEMENT}');
    Expect(1, 917999, '\p{invariationselectorssupplement}', "");
    Expect(0, 917999, '\p{^invariationselectorssupplement}', "");
    Expect(0, 917999, '\P{invariationselectorssupplement}', "");
    Expect(1, 917999, '\P{^invariationselectorssupplement}', "");
    Expect(0, 918000, '\p{invariationselectorssupplement}', "");
    Expect(1, 918000, '\p{^invariationselectorssupplement}', "");
    Expect(1, 918000, '\P{invariationselectorssupplement}', "");
    Expect(0, 918000, '\P{^invariationselectorssupplement}', "");
    Expect(1, 917999, '\p{--In_Variation_Selectors_SUPPLEMENT}', "");
    Expect(0, 917999, '\p{^--In_Variation_Selectors_SUPPLEMENT}', "");
    Expect(0, 917999, '\P{--In_Variation_Selectors_SUPPLEMENT}', "");
    Expect(1, 917999, '\P{^--In_Variation_Selectors_SUPPLEMENT}', "");
    Expect(0, 918000, '\p{--In_Variation_Selectors_SUPPLEMENT}', "");
    Expect(1, 918000, '\p{^--In_Variation_Selectors_SUPPLEMENT}', "");
    Expect(1, 918000, '\P{--In_Variation_Selectors_SUPPLEMENT}', "");
    Expect(0, 918000, '\P{^--In_Variation_Selectors_SUPPLEMENT}', "");
    Error('\p{__VS_sup/a/}');
    Error('\P{__VS_sup/a/}');
    Expect(1, 917999, '\p{vssup}', "");
    Expect(0, 917999, '\p{^vssup}', "");
    Expect(0, 917999, '\P{vssup}', "");
    Expect(1, 917999, '\P{^vssup}', "");
    Expect(0, 918000, '\p{vssup}', "");
    Expect(1, 918000, '\p{^vssup}', "");
    Expect(1, 918000, '\P{vssup}', "");
    Expect(0, 918000, '\P{^vssup}', "");
    Expect(1, 917999, '\p{_-VS_sup}', "");
    Expect(0, 917999, '\p{^_-VS_sup}', "");
    Expect(0, 917999, '\P{_-VS_sup}', "");
    Expect(1, 917999, '\P{^_-VS_sup}', "");
    Expect(0, 918000, '\p{_-VS_sup}', "");
    Expect(1, 918000, '\p{^_-VS_sup}', "");
    Expect(1, 918000, '\P{_-VS_sup}', "");
    Expect(0, 918000, '\P{^_-VS_sup}', "");
    Error('\p{-	Is_VS_SUP/a/}');
    Error('\P{-	Is_VS_SUP/a/}');
    Expect(1, 917999, '\p{isvssup}', "");
    Expect(0, 917999, '\p{^isvssup}', "");
    Expect(0, 917999, '\P{isvssup}', "");
    Expect(1, 917999, '\P{^isvssup}', "");
    Expect(0, 918000, '\p{isvssup}', "");
    Expect(1, 918000, '\p{^isvssup}', "");
    Expect(1, 918000, '\P{isvssup}', "");
    Expect(0, 918000, '\P{^isvssup}', "");
    Expect(1, 917999, '\p{__Is_VS_sup}', "");
    Expect(0, 917999, '\p{^__Is_VS_sup}', "");
    Expect(0, 917999, '\P{__Is_VS_sup}', "");
    Expect(1, 917999, '\P{^__Is_VS_sup}', "");
    Expect(0, 918000, '\p{__Is_VS_sup}', "");
    Expect(1, 918000, '\p{^__Is_VS_sup}', "");
    Expect(1, 918000, '\P{__Is_VS_sup}', "");
    Expect(0, 918000, '\P{^__Is_VS_sup}', "");
    Error('\p{:=		In_vs_Sup}');
    Error('\P{:=		In_vs_Sup}');
    Expect(1, 917999, '\p{invssup}', "");
    Expect(0, 917999, '\p{^invssup}', "");
    Expect(0, 917999, '\P{invssup}', "");
    Expect(1, 917999, '\P{^invssup}', "");
    Expect(0, 918000, '\p{invssup}', "");
    Expect(1, 918000, '\p{^invssup}', "");
    Expect(1, 918000, '\P{invssup}', "");
    Expect(0, 918000, '\P{^invssup}', "");
    Expect(1, 917999, '\p{	_In_VS_Sup}', "");
    Expect(0, 917999, '\p{^	_In_VS_Sup}', "");
    Expect(0, 917999, '\P{	_In_VS_Sup}', "");
    Expect(1, 917999, '\P{^	_In_VS_Sup}', "");
    Expect(0, 918000, '\p{	_In_VS_Sup}', "");
    Expect(1, 918000, '\p{^	_In_VS_Sup}', "");
    Expect(1, 918000, '\P{	_In_VS_Sup}', "");
    Expect(0, 918000, '\P{^	_In_VS_Sup}', "");
    Error('\p{	:=Vedic_extensions}');
    Error('\P{	:=Vedic_extensions}');
    Expect(1, 7423, '\p{vedicextensions}', "");
    Expect(0, 7423, '\p{^vedicextensions}', "");
    Expect(0, 7423, '\P{vedicextensions}', "");
    Expect(1, 7423, '\P{^vedicextensions}', "");
    Expect(0, 7424, '\p{vedicextensions}', "");
    Expect(1, 7424, '\p{^vedicextensions}', "");
    Expect(1, 7424, '\P{vedicextensions}', "");
    Expect(0, 7424, '\P{^vedicextensions}', "");
    Expect(1, 7423, '\p{_vedic_Extensions}', "");
    Expect(0, 7423, '\p{^_vedic_Extensions}', "");
    Expect(0, 7423, '\P{_vedic_Extensions}', "");
    Expect(1, 7423, '\P{^_vedic_Extensions}', "");
    Expect(0, 7424, '\p{_vedic_Extensions}', "");
    Expect(1, 7424, '\p{^_vedic_Extensions}', "");
    Expect(1, 7424, '\P{_vedic_Extensions}', "");
    Expect(0, 7424, '\P{^_vedic_Extensions}', "");
    Error('\p{-/a/Is_Vedic_EXTENSIONS}');
    Error('\P{-/a/Is_Vedic_EXTENSIONS}');
    Expect(1, 7423, '\p{isvedicextensions}', "");
    Expect(0, 7423, '\p{^isvedicextensions}', "");
    Expect(0, 7423, '\P{isvedicextensions}', "");
    Expect(1, 7423, '\P{^isvedicextensions}', "");
    Expect(0, 7424, '\p{isvedicextensions}', "");
    Expect(1, 7424, '\p{^isvedicextensions}', "");
    Expect(1, 7424, '\P{isvedicextensions}', "");
    Expect(0, 7424, '\P{^isvedicextensions}', "");
    Expect(1, 7423, '\p{_	Is_Vedic_Extensions}', "");
    Expect(0, 7423, '\p{^_	Is_Vedic_Extensions}', "");
    Expect(0, 7423, '\P{_	Is_Vedic_Extensions}', "");
    Expect(1, 7423, '\P{^_	Is_Vedic_Extensions}', "");
    Expect(0, 7424, '\p{_	Is_Vedic_Extensions}', "");
    Expect(1, 7424, '\p{^_	Is_Vedic_Extensions}', "");
    Expect(1, 7424, '\P{_	Is_Vedic_Extensions}', "");
    Expect(0, 7424, '\P{^_	Is_Vedic_Extensions}', "");
    Error('\p{ /a/in_vedic_extensions}');
    Error('\P{ /a/in_vedic_extensions}');
    Expect(1, 7423, '\p{invedicextensions}', "");
    Expect(0, 7423, '\p{^invedicextensions}', "");
    Expect(0, 7423, '\P{invedicextensions}', "");
    Expect(1, 7423, '\P{^invedicextensions}', "");
    Expect(0, 7424, '\p{invedicextensions}', "");
    Expect(1, 7424, '\p{^invedicextensions}', "");
    Expect(1, 7424, '\P{invedicextensions}', "");
    Expect(0, 7424, '\P{^invedicextensions}', "");
    Expect(1, 7423, '\p{_In_VEDIC_Extensions}', "");
    Expect(0, 7423, '\p{^_In_VEDIC_Extensions}', "");
    Expect(0, 7423, '\P{_In_VEDIC_Extensions}', "");
    Expect(1, 7423, '\P{^_In_VEDIC_Extensions}', "");
    Expect(0, 7424, '\p{_In_VEDIC_Extensions}', "");
    Expect(1, 7424, '\p{^_In_VEDIC_Extensions}', "");
    Expect(1, 7424, '\P{_In_VEDIC_Extensions}', "");
    Expect(0, 7424, '\P{^_In_VEDIC_Extensions}', "");
    Error('\p{	:=Vedic_Ext}');
    Error('\P{	:=Vedic_Ext}');
    Expect(1, 7423, '\p{vedicext}', "");
    Expect(0, 7423, '\p{^vedicext}', "");
    Expect(0, 7423, '\P{vedicext}', "");
    Expect(1, 7423, '\P{^vedicext}', "");
    Expect(0, 7424, '\p{vedicext}', "");
    Expect(1, 7424, '\p{^vedicext}', "");
    Expect(1, 7424, '\P{vedicext}', "");
    Expect(0, 7424, '\P{^vedicext}', "");
    Expect(1, 7423, '\p{vedic_EXT}', "");
    Expect(0, 7423, '\p{^vedic_EXT}', "");
    Expect(0, 7423, '\P{vedic_EXT}', "");
    Expect(1, 7423, '\P{^vedic_EXT}', "");
    Expect(0, 7424, '\p{vedic_EXT}', "");
    Expect(1, 7424, '\p{^vedic_EXT}', "");
    Expect(1, 7424, '\P{vedic_EXT}', "");
    Expect(0, 7424, '\P{^vedic_EXT}', "");
    Error('\p{-:=IS_Vedic_ext}');
    Error('\P{-:=IS_Vedic_ext}');
    Expect(1, 7423, '\p{isvedicext}', "");
    Expect(0, 7423, '\p{^isvedicext}', "");
    Expect(0, 7423, '\P{isvedicext}', "");
    Expect(1, 7423, '\P{^isvedicext}', "");
    Expect(0, 7424, '\p{isvedicext}', "");
    Expect(1, 7424, '\p{^isvedicext}', "");
    Expect(1, 7424, '\P{isvedicext}', "");
    Expect(0, 7424, '\P{^isvedicext}', "");
    Expect(1, 7423, '\p{- Is_Vedic_Ext}', "");
    Expect(0, 7423, '\p{^- Is_Vedic_Ext}', "");
    Expect(0, 7423, '\P{- Is_Vedic_Ext}', "");
    Expect(1, 7423, '\P{^- Is_Vedic_Ext}', "");
    Expect(0, 7424, '\p{- Is_Vedic_Ext}', "");
    Expect(1, 7424, '\p{^- Is_Vedic_Ext}', "");
    Expect(1, 7424, '\P{- Is_Vedic_Ext}', "");
    Expect(0, 7424, '\P{^- Is_Vedic_Ext}', "");
    Error('\p{/a/		In_vedic_ext}');
    Error('\P{/a/		In_vedic_ext}');
    Expect(1, 7423, '\p{invedicext}', "");
    Expect(0, 7423, '\p{^invedicext}', "");
    Expect(0, 7423, '\P{invedicext}', "");
    Expect(1, 7423, '\P{^invedicext}', "");
    Expect(0, 7424, '\p{invedicext}', "");
    Expect(1, 7424, '\p{^invedicext}', "");
    Expect(1, 7424, '\P{invedicext}', "");
    Expect(0, 7424, '\P{^invedicext}', "");
    Expect(1, 7423, '\p{	IN_VEDIC_ext}', "");
    Expect(0, 7423, '\p{^	IN_VEDIC_ext}', "");
    Expect(0, 7423, '\P{	IN_VEDIC_ext}', "");
    Expect(1, 7423, '\P{^	IN_VEDIC_ext}', "");
    Expect(0, 7424, '\p{	IN_VEDIC_ext}', "");
    Expect(1, 7424, '\p{^	IN_VEDIC_ext}', "");
    Expect(1, 7424, '\P{	IN_VEDIC_ext}', "");
    Expect(0, 7424, '\P{^	IN_VEDIC_ext}', "");
    Error('\p{/a/_ Vertical_Forms}');
    Error('\P{/a/_ Vertical_Forms}');
    Expect(1, 65055, '\p{verticalforms}', "");
    Expect(0, 65055, '\p{^verticalforms}', "");
    Expect(0, 65055, '\P{verticalforms}', "");
    Expect(1, 65055, '\P{^verticalforms}', "");
    Expect(0, 65056, '\p{verticalforms}', "");
    Expect(1, 65056, '\p{^verticalforms}', "");
    Expect(1, 65056, '\P{verticalforms}', "");
    Expect(0, 65056, '\P{^verticalforms}', "");
    Expect(1, 65055, '\p{	Vertical_FORMS}', "");
    Expect(0, 65055, '\p{^	Vertical_FORMS}', "");
    Expect(0, 65055, '\P{	Vertical_FORMS}', "");
    Expect(1, 65055, '\P{^	Vertical_FORMS}', "");
    Expect(0, 65056, '\p{	Vertical_FORMS}', "");
    Expect(1, 65056, '\p{^	Vertical_FORMS}', "");
    Expect(1, 65056, '\P{	Vertical_FORMS}', "");
    Expect(0, 65056, '\P{^	Vertical_FORMS}', "");
    Error('\p{/a/-is_VERTICAL_Forms}');
    Error('\P{/a/-is_VERTICAL_Forms}');
    Expect(1, 65055, '\p{isverticalforms}', "");
    Expect(0, 65055, '\p{^isverticalforms}', "");
    Expect(0, 65055, '\P{isverticalforms}', "");
    Expect(1, 65055, '\P{^isverticalforms}', "");
    Expect(0, 65056, '\p{isverticalforms}', "");
    Expect(1, 65056, '\p{^isverticalforms}', "");
    Expect(1, 65056, '\P{isverticalforms}', "");
    Expect(0, 65056, '\P{^isverticalforms}', "");
    Expect(1, 65055, '\p{-is_Vertical_Forms}', "");
    Expect(0, 65055, '\p{^-is_Vertical_Forms}', "");
    Expect(0, 65055, '\P{-is_Vertical_Forms}', "");
    Expect(1, 65055, '\P{^-is_Vertical_Forms}', "");
    Expect(0, 65056, '\p{-is_Vertical_Forms}', "");
    Expect(1, 65056, '\p{^-is_Vertical_Forms}', "");
    Expect(1, 65056, '\P{-is_Vertical_Forms}', "");
    Expect(0, 65056, '\P{^-is_Vertical_Forms}', "");
    Error('\p{/a/	 In_Vertical_Forms}');
    Error('\P{/a/	 In_Vertical_Forms}');
    Expect(1, 65055, '\p{inverticalforms}', "");
    Expect(0, 65055, '\p{^inverticalforms}', "");
    Expect(0, 65055, '\P{inverticalforms}', "");
    Expect(1, 65055, '\P{^inverticalforms}', "");
    Expect(0, 65056, '\p{inverticalforms}', "");
    Expect(1, 65056, '\p{^inverticalforms}', "");
    Expect(1, 65056, '\P{inverticalforms}', "");
    Expect(0, 65056, '\P{^inverticalforms}', "");
    Expect(1, 65055, '\p{-	IN_VERTICAL_FORMS}', "");
    Expect(0, 65055, '\p{^-	IN_VERTICAL_FORMS}', "");
    Expect(0, 65055, '\P{-	IN_VERTICAL_FORMS}', "");
    Expect(1, 65055, '\P{^-	IN_VERTICAL_FORMS}', "");
    Expect(0, 65056, '\p{-	IN_VERTICAL_FORMS}', "");
    Expect(1, 65056, '\p{^-	IN_VERTICAL_FORMS}', "");
    Expect(1, 65056, '\P{-	IN_VERTICAL_FORMS}', "");
    Expect(0, 65056, '\P{^-	IN_VERTICAL_FORMS}', "");
    Error('\p{:= -VertSpace}');
    Error('\P{:= -VertSpace}');
    Expect(1, 8233, '\p{vertspace}', "");
    Expect(0, 8233, '\p{^vertspace}', "");
    Expect(0, 8233, '\P{vertspace}', "");
    Expect(1, 8233, '\P{^vertspace}', "");
    Expect(0, 8234, '\p{vertspace}', "");
    Expect(1, 8234, '\p{^vertspace}', "");
    Expect(1, 8234, '\P{vertspace}', "");
    Expect(0, 8234, '\P{^vertspace}', "");
    Expect(1, 8233, '\p{	vertspace}', "");
    Expect(0, 8233, '\p{^	vertspace}', "");
    Expect(0, 8233, '\P{	vertspace}', "");
    Expect(1, 8233, '\P{^	vertspace}', "");
    Expect(0, 8234, '\p{	vertspace}', "");
    Expect(1, 8234, '\p{^	vertspace}', "");
    Expect(1, 8234, '\P{	vertspace}', "");
    Expect(0, 8234, '\P{^	vertspace}', "");
    Error('\p{ :=Is_vertspace}');
    Error('\P{ :=Is_vertspace}');
    Expect(1, 8233, '\p{isvertspace}', "");
    Expect(0, 8233, '\p{^isvertspace}', "");
    Expect(0, 8233, '\P{isvertspace}', "");
    Expect(1, 8233, '\P{^isvertspace}', "");
    Expect(0, 8234, '\p{isvertspace}', "");
    Expect(1, 8234, '\p{^isvertspace}', "");
    Expect(1, 8234, '\P{isvertspace}', "");
    Expect(0, 8234, '\P{^isvertspace}', "");
    Expect(1, 8233, '\p{-_is_VertSpace}', "");
    Expect(0, 8233, '\p{^-_is_VertSpace}', "");
    Expect(0, 8233, '\P{-_is_VertSpace}', "");
    Expect(1, 8233, '\P{^-_is_VertSpace}', "");
    Expect(0, 8234, '\p{-_is_VertSpace}', "");
    Expect(1, 8234, '\p{^-_is_VertSpace}', "");
    Expect(1, 8234, '\P{-_is_VertSpace}', "");
    Expect(0, 8234, '\P{^-_is_VertSpace}', "");
    Error('\p{:=WANCHO}');
    Error('\P{:=WANCHO}');
    Expect(1, 123647, '\p{wancho}', "");
    Expect(0, 123647, '\p{^wancho}', "");
    Expect(0, 123647, '\P{wancho}', "");
    Expect(1, 123647, '\P{^wancho}', "");
    Expect(0, 123648, '\p{wancho}', "");
    Expect(1, 123648, '\p{^wancho}', "");
    Expect(1, 123648, '\P{wancho}', "");
    Expect(0, 123648, '\P{^wancho}', "");
    Expect(1, 123647, '\p{	Wancho}', "");
    Expect(0, 123647, '\p{^	Wancho}', "");
    Expect(0, 123647, '\P{	Wancho}', "");
    Expect(1, 123647, '\P{^	Wancho}', "");
    Expect(0, 123648, '\p{	Wancho}', "");
    Expect(1, 123648, '\p{^	Wancho}', "");
    Expect(1, 123648, '\P{	Wancho}', "");
    Expect(0, 123648, '\P{^	Wancho}', "");
    Error('\p{-_IS_WANCHO/a/}');
    Error('\P{-_IS_WANCHO/a/}');
    Expect(1, 123647, '\p{iswancho}', "");
    Expect(0, 123647, '\p{^iswancho}', "");
    Expect(0, 123647, '\P{iswancho}', "");
    Expect(1, 123647, '\P{^iswancho}', "");
    Expect(0, 123648, '\p{iswancho}', "");
    Expect(1, 123648, '\p{^iswancho}', "");
    Expect(1, 123648, '\P{iswancho}', "");
    Expect(0, 123648, '\P{^iswancho}', "");
    Expect(1, 123647, '\p{ is_Wancho}', "");
    Expect(0, 123647, '\p{^ is_Wancho}', "");
    Expect(0, 123647, '\P{ is_Wancho}', "");
    Expect(1, 123647, '\P{^ is_Wancho}', "");
    Expect(0, 123648, '\p{ is_Wancho}', "");
    Expect(1, 123648, '\p{^ is_Wancho}', "");
    Expect(1, 123648, '\P{ is_Wancho}', "");
    Expect(0, 123648, '\P{^ is_Wancho}', "");
    Error('\p{:=Wcho}');
    Error('\P{:=Wcho}');
    Expect(1, 123647, '\p{wcho}', "");
    Expect(0, 123647, '\p{^wcho}', "");
    Expect(0, 123647, '\P{wcho}', "");
    Expect(1, 123647, '\P{^wcho}', "");
    Expect(0, 123648, '\p{wcho}', "");
    Expect(1, 123648, '\p{^wcho}', "");
    Expect(1, 123648, '\P{wcho}', "");
    Expect(0, 123648, '\P{^wcho}', "");
    Expect(1, 123647, '\p{	Wcho}', "");
    Expect(0, 123647, '\p{^	Wcho}', "");
    Expect(0, 123647, '\P{	Wcho}', "");
    Expect(1, 123647, '\P{^	Wcho}', "");
    Expect(0, 123648, '\p{	Wcho}', "");
    Expect(1, 123648, '\p{^	Wcho}', "");
    Expect(1, 123648, '\P{	Wcho}', "");
    Expect(0, 123648, '\P{^	Wcho}', "");
    Error('\p{/a/-is_Wcho}');
    Error('\P{/a/-is_Wcho}');
    Expect(1, 123647, '\p{iswcho}', "");
    Expect(0, 123647, '\p{^iswcho}', "");
    Expect(0, 123647, '\P{iswcho}', "");
    Expect(1, 123647, '\P{^iswcho}', "");
    Expect(0, 123648, '\p{iswcho}', "");
    Expect(1, 123648, '\p{^iswcho}', "");
    Expect(1, 123648, '\P{iswcho}', "");
    Expect(0, 123648, '\P{^iswcho}', "");
    Expect(1, 123647, '\p{-_Is_Wcho}', "");
    Expect(0, 123647, '\p{^-_Is_Wcho}', "");
    Expect(0, 123647, '\P{-_Is_Wcho}', "");
    Expect(1, 123647, '\P{^-_Is_Wcho}', "");
    Expect(0, 123648, '\p{-_Is_Wcho}', "");
    Expect(1, 123648, '\p{^-_Is_Wcho}', "");
    Expect(1, 123648, '\P{-_Is_Wcho}', "");
    Expect(0, 123648, '\P{^-_Is_Wcho}', "");
    Error('\p{	/a/Warang_Citi}');
    Error('\P{	/a/Warang_Citi}');
    Expect(1, 71935, '\p{warangciti}', "");
    Expect(0, 71935, '\p{^warangciti}', "");
    Expect(0, 71935, '\P{warangciti}', "");
    Expect(1, 71935, '\P{^warangciti}', "");
    Expect(0, 71936, '\p{warangciti}', "");
    Expect(1, 71936, '\p{^warangciti}', "");
    Expect(1, 71936, '\P{warangciti}', "");
    Expect(0, 71936, '\P{^warangciti}', "");
    Expect(1, 71935, '\p{		warang_Citi}', "");
    Expect(0, 71935, '\p{^		warang_Citi}', "");
    Expect(0, 71935, '\P{		warang_Citi}', "");
    Expect(1, 71935, '\P{^		warang_Citi}', "");
    Expect(0, 71936, '\p{		warang_Citi}', "");
    Expect(1, 71936, '\p{^		warang_Citi}', "");
    Expect(1, 71936, '\P{		warang_Citi}', "");
    Expect(0, 71936, '\P{^		warang_Citi}', "");
    Error('\p{ Is_WARANG_Citi:=}');
    Error('\P{ Is_WARANG_Citi:=}');
    Expect(1, 71935, '\p{iswarangciti}', "");
    Expect(0, 71935, '\p{^iswarangciti}', "");
    Expect(0, 71935, '\P{iswarangciti}', "");
    Expect(1, 71935, '\P{^iswarangciti}', "");
    Expect(0, 71936, '\p{iswarangciti}', "");
    Expect(1, 71936, '\p{^iswarangciti}', "");
    Expect(1, 71936, '\P{iswarangciti}', "");
    Expect(0, 71936, '\P{^iswarangciti}', "");
    Expect(1, 71935, '\p{  Is_Warang_citi}', "");
    Expect(0, 71935, '\p{^  Is_Warang_citi}', "");
    Expect(0, 71935, '\P{  Is_Warang_citi}', "");
    Expect(1, 71935, '\P{^  Is_Warang_citi}', "");
    Expect(0, 71936, '\p{  Is_Warang_citi}', "");
    Expect(1, 71936, '\p{^  Is_Warang_citi}', "");
    Expect(1, 71936, '\P{  Is_Warang_citi}', "");
    Expect(0, 71936, '\P{^  Is_Warang_citi}', "");
    Error('\p{/a/_ Wara}');
    Error('\P{/a/_ Wara}');
    Expect(1, 71935, '\p{wara}', "");
    Expect(0, 71935, '\p{^wara}', "");
    Expect(0, 71935, '\P{wara}', "");
    Expect(1, 71935, '\P{^wara}', "");
    Expect(0, 71936, '\p{wara}', "");
    Expect(1, 71936, '\p{^wara}', "");
    Expect(1, 71936, '\P{wara}', "");
    Expect(0, 71936, '\P{^wara}', "");
    Expect(1, 71935, '\p{ _wara}', "");
    Expect(0, 71935, '\p{^ _wara}', "");
    Expect(0, 71935, '\P{ _wara}', "");
    Expect(1, 71935, '\P{^ _wara}', "");
    Expect(0, 71936, '\p{ _wara}', "");
    Expect(1, 71936, '\p{^ _wara}', "");
    Expect(1, 71936, '\P{ _wara}', "");
    Expect(0, 71936, '\P{^ _wara}', "");
    Error('\p{  is_Wara:=}');
    Error('\P{  is_Wara:=}');
    Expect(1, 71935, '\p{iswara}', "");
    Expect(0, 71935, '\p{^iswara}', "");
    Expect(0, 71935, '\P{iswara}', "");
    Expect(1, 71935, '\P{^iswara}', "");
    Expect(0, 71936, '\p{iswara}', "");
    Expect(1, 71936, '\p{^iswara}', "");
    Expect(1, 71936, '\P{iswara}', "");
    Expect(0, 71936, '\P{^iswara}', "");
    Expect(1, 71935, '\p{-_Is_wara}', "");
    Expect(0, 71935, '\p{^-_Is_wara}', "");
    Expect(0, 71935, '\P{-_Is_wara}', "");
    Expect(1, 71935, '\P{^-_Is_wara}', "");
    Expect(0, 71936, '\p{-_Is_wara}', "");
    Expect(1, 71936, '\p{^-_Is_wara}', "");
    Expect(1, 71936, '\P{-_Is_wara}', "");
    Expect(0, 71936, '\P{^-_Is_wara}', "");
    Error('\p{/a/__white_Space}');
    Error('\P{/a/__white_Space}');
    Expect(1, 12288, '\p{whitespace}', "");
    Expect(0, 12288, '\p{^whitespace}', "");
    Expect(0, 12288, '\P{whitespace}', "");
    Expect(1, 12288, '\P{^whitespace}', "");
    Expect(0, 12289, '\p{whitespace}', "");
    Expect(1, 12289, '\p{^whitespace}', "");
    Expect(1, 12289, '\P{whitespace}', "");
    Expect(0, 12289, '\P{^whitespace}', "");
    Expect(1, 12288, '\p{ -WHITE_Space}', "");
    Expect(0, 12288, '\p{^ -WHITE_Space}', "");
    Expect(0, 12288, '\P{ -WHITE_Space}', "");
    Expect(1, 12288, '\P{^ -WHITE_Space}', "");
    Expect(0, 12289, '\p{ -WHITE_Space}', "");
    Expect(1, 12289, '\p{^ -WHITE_Space}', "");
    Expect(1, 12289, '\P{ -WHITE_Space}', "");
    Expect(0, 12289, '\P{^ -WHITE_Space}', "");
    Error('\p{/a/ Is_White_Space}');
    Error('\P{/a/ Is_White_Space}');
    Expect(1, 12288, '\p{iswhitespace}', "");
    Expect(0, 12288, '\p{^iswhitespace}', "");
    Expect(0, 12288, '\P{iswhitespace}', "");
    Expect(1, 12288, '\P{^iswhitespace}', "");
    Expect(0, 12289, '\p{iswhitespace}', "");
    Expect(1, 12289, '\p{^iswhitespace}', "");
    Expect(1, 12289, '\P{iswhitespace}', "");
    Expect(0, 12289, '\P{^iswhitespace}', "");
    Expect(1, 12288, '\p{	_IS_White_Space}', "");
    Expect(0, 12288, '\p{^	_IS_White_Space}', "");
    Expect(0, 12288, '\P{	_IS_White_Space}', "");
    Expect(1, 12288, '\P{^	_IS_White_Space}', "");
    Expect(0, 12289, '\p{	_IS_White_Space}', "");
    Expect(1, 12289, '\p{^	_IS_White_Space}', "");
    Expect(1, 12289, '\P{	_IS_White_Space}', "");
    Expect(0, 12289, '\P{^	_IS_White_Space}', "");
    Error('\p{:=_	WSPACE}');
    Error('\P{:=_	WSPACE}');
    Expect(1, 12288, '\p{wspace}', "");
    Expect(0, 12288, '\p{^wspace}', "");
    Expect(0, 12288, '\P{wspace}', "");
    Expect(1, 12288, '\P{^wspace}', "");
    Expect(0, 12289, '\p{wspace}', "");
    Expect(1, 12289, '\p{^wspace}', "");
    Expect(1, 12289, '\P{wspace}', "");
    Expect(0, 12289, '\P{^wspace}', "");
    Expect(1, 12288, '\p{_WSpace}', "");
    Expect(0, 12288, '\p{^_WSpace}', "");
    Expect(0, 12288, '\P{_WSpace}', "");
    Expect(1, 12288, '\P{^_WSpace}', "");
    Expect(0, 12289, '\p{_WSpace}', "");
    Expect(1, 12289, '\p{^_WSpace}', "");
    Expect(1, 12289, '\P{_WSpace}', "");
    Expect(0, 12289, '\P{^_WSpace}', "");
    Error('\p{_:=Is_wspace}');
    Error('\P{_:=Is_wspace}');
    Expect(1, 12288, '\p{iswspace}', "");
    Expect(0, 12288, '\p{^iswspace}', "");
    Expect(0, 12288, '\P{iswspace}', "");
    Expect(1, 12288, '\P{^iswspace}', "");
    Expect(0, 12289, '\p{iswspace}', "");
    Expect(1, 12289, '\p{^iswspace}', "");
    Expect(1, 12289, '\P{iswspace}', "");
    Expect(0, 12289, '\P{^iswspace}', "");
    Expect(1, 12288, '\p{	-Is_WSpace}', "");
    Expect(0, 12288, '\p{^	-Is_WSpace}', "");
    Expect(0, 12288, '\P{	-Is_WSpace}', "");
    Expect(1, 12288, '\P{^	-Is_WSpace}', "");
    Expect(0, 12289, '\p{	-Is_WSpace}', "");
    Expect(1, 12289, '\p{^	-Is_WSpace}', "");
    Expect(1, 12289, '\P{	-Is_WSpace}', "");
    Expect(0, 12289, '\P{^	-Is_WSpace}', "");
    Error('\p{/a/_-Space}');
    Error('\P{/a/_-Space}');
    Expect(1, 12288, '\p{space}', "");
    Expect(0, 12288, '\p{^space}', "");
    Expect(0, 12288, '\P{space}', "");
    Expect(1, 12288, '\P{^space}', "");
    Expect(0, 12289, '\p{space}', "");
    Expect(1, 12289, '\p{^space}', "");
    Expect(1, 12289, '\P{space}', "");
    Expect(0, 12289, '\P{^space}', "");
    Expect(1, 12288, '\p{	Space}', "");
    Expect(0, 12288, '\p{^	Space}', "");
    Expect(0, 12288, '\P{	Space}', "");
    Expect(1, 12288, '\P{^	Space}', "");
    Expect(0, 12289, '\p{	Space}', "");
    Expect(1, 12289, '\p{^	Space}', "");
    Expect(1, 12289, '\P{	Space}', "");
    Expect(0, 12289, '\P{^	Space}', "");
    Error('\p{- IS_Space/a/}');
    Error('\P{- IS_Space/a/}');
    Expect(1, 12288, '\p{isspace}', "");
    Expect(0, 12288, '\p{^isspace}', "");
    Expect(0, 12288, '\P{isspace}', "");
    Expect(1, 12288, '\P{^isspace}', "");
    Expect(0, 12289, '\p{isspace}', "");
    Expect(1, 12289, '\p{^isspace}', "");
    Expect(1, 12289, '\P{isspace}', "");
    Expect(0, 12289, '\P{^isspace}', "");
    Expect(1, 12288, '\p{-	Is_SPACE}', "");
    Expect(0, 12288, '\p{^-	Is_SPACE}', "");
    Expect(0, 12288, '\P{-	Is_SPACE}', "");
    Expect(1, 12288, '\P{^-	Is_SPACE}', "");
    Expect(0, 12289, '\p{-	Is_SPACE}', "");
    Expect(1, 12289, '\p{^-	Is_SPACE}', "");
    Expect(1, 12289, '\P{-	Is_SPACE}', "");
    Expect(0, 12289, '\P{^-	Is_SPACE}', "");
    Error('\p{/a/XPOSIXWORD}');
    Error('\P{/a/XPOSIXWORD}');
    Expect(1, 917999, '\p{xposixword}', "");
    Expect(0, 917999, '\p{^xposixword}', "");
    Expect(0, 917999, '\P{xposixword}', "");
    Expect(1, 917999, '\P{^xposixword}', "");
    Expect(0, 918000, '\p{xposixword}', "");
    Expect(1, 918000, '\p{^xposixword}', "");
    Expect(1, 918000, '\P{xposixword}', "");
    Expect(0, 918000, '\P{^xposixword}', "");
    Expect(1, 917999, '\p{-XPosixWord}', "");
    Expect(0, 917999, '\p{^-XPosixWord}', "");
    Expect(0, 917999, '\P{-XPosixWord}', "");
    Expect(1, 917999, '\P{^-XPosixWord}', "");
    Expect(0, 918000, '\p{-XPosixWord}', "");
    Expect(1, 918000, '\p{^-XPosixWord}', "");
    Expect(1, 918000, '\P{-XPosixWord}', "");
    Expect(0, 918000, '\P{^-XPosixWord}', "");
    Error('\p{ -Word/a/}');
    Error('\P{ -Word/a/}');
    Expect(1, 917999, '\p{word}', "");
    Expect(0, 917999, '\p{^word}', "");
    Expect(0, 917999, '\P{word}', "");
    Expect(1, 917999, '\P{^word}', "");
    Expect(0, 918000, '\p{word}', "");
    Expect(1, 918000, '\p{^word}', "");
    Expect(1, 918000, '\P{word}', "");
    Expect(0, 918000, '\P{^word}', "");
    Expect(1, 917999, '\p{-	WORD}', "");
    Expect(0, 917999, '\p{^-	WORD}', "");
    Expect(0, 917999, '\P{-	WORD}', "");
    Expect(1, 917999, '\P{^-	WORD}', "");
    Expect(0, 918000, '\p{-	WORD}', "");
    Expect(1, 918000, '\p{^-	WORD}', "");
    Expect(1, 918000, '\P{-	WORD}', "");
    Expect(0, 918000, '\P{^-	WORD}', "");
    Error('\p{:=_-is_XPOSIXWORD}');
    Error('\P{:=_-is_XPOSIXWORD}');
    Expect(1, 917999, '\p{isxposixword}', "");
    Expect(0, 917999, '\p{^isxposixword}', "");
    Expect(0, 917999, '\P{isxposixword}', "");
    Expect(1, 917999, '\P{^isxposixword}', "");
    Expect(0, 918000, '\p{isxposixword}', "");
    Expect(1, 918000, '\p{^isxposixword}', "");
    Expect(1, 918000, '\P{isxposixword}', "");
    Expect(0, 918000, '\P{^isxposixword}', "");
    Expect(1, 917999, '\p{ _Is_XPosixWord}', "");
    Expect(0, 917999, '\p{^ _Is_XPosixWord}', "");
    Expect(0, 917999, '\P{ _Is_XPosixWord}', "");
    Expect(1, 917999, '\P{^ _Is_XPosixWord}', "");
    Expect(0, 918000, '\p{ _Is_XPosixWord}', "");
    Expect(1, 918000, '\p{^ _Is_XPosixWord}', "");
    Expect(1, 918000, '\P{ _Is_XPosixWord}', "");
    Expect(0, 918000, '\P{^ _Is_XPosixWord}', "");
    Error('\p{/a/	_is_Word}');
    Error('\P{/a/	_is_Word}');
    Expect(1, 917999, '\p{isword}', "");
    Expect(0, 917999, '\p{^isword}', "");
    Expect(0, 917999, '\P{isword}', "");
    Expect(1, 917999, '\P{^isword}', "");
    Expect(0, 918000, '\p{isword}', "");
    Expect(1, 918000, '\p{^isword}', "");
    Expect(1, 918000, '\P{isword}', "");
    Expect(0, 918000, '\P{^isword}', "");
    Expect(1, 917999, '\p{-IS_word}', "");
    Expect(0, 917999, '\p{^-IS_word}', "");
    Expect(0, 917999, '\P{-IS_word}', "");
    Expect(1, 917999, '\P{^-IS_word}', "");
    Expect(0, 918000, '\p{-IS_word}', "");
    Expect(1, 918000, '\p{^-IS_word}', "");
    Expect(1, 918000, '\P{-IS_word}', "");
    Expect(0, 918000, '\P{^-IS_word}', "");
    Error('\p{_/a/XPOSIXXDIGIT}');
    Error('\P{_/a/XPOSIXXDIGIT}');
    Expect(1, 65350, '\p{xposixxdigit}', "");
    Expect(0, 65350, '\p{^xposixxdigit}', "");
    Expect(0, 65350, '\P{xposixxdigit}', "");
    Expect(1, 65350, '\P{^xposixxdigit}', "");
    Expect(0, 65351, '\p{xposixxdigit}', "");
    Expect(1, 65351, '\p{^xposixxdigit}', "");
    Expect(1, 65351, '\P{xposixxdigit}', "");
    Expect(0, 65351, '\P{^xposixxdigit}', "");
    Expect(1, 65350, '\p{__xposixxdigit}', "");
    Expect(0, 65350, '\p{^__xposixxdigit}', "");
    Expect(0, 65350, '\P{__xposixxdigit}', "");
    Expect(1, 65350, '\P{^__xposixxdigit}', "");
    Expect(0, 65351, '\p{__xposixxdigit}', "");
    Expect(1, 65351, '\p{^__xposixxdigit}', "");
    Expect(1, 65351, '\P{__xposixxdigit}', "");
    Expect(0, 65351, '\P{^__xposixxdigit}', "");
    Error('\p{- XDIGIT/a/}');
    Error('\P{- XDIGIT/a/}');
    Expect(1, 65350, '\p{xdigit}', "");
    Expect(0, 65350, '\p{^xdigit}', "");
    Expect(0, 65350, '\P{xdigit}', "");
    Expect(1, 65350, '\P{^xdigit}', "");
    Expect(0, 65351, '\p{xdigit}', "");
    Expect(1, 65351, '\p{^xdigit}', "");
    Expect(1, 65351, '\P{xdigit}', "");
    Expect(0, 65351, '\P{^xdigit}', "");
    Expect(1, 65350, '\p{- XDIGIT}', "");
    Expect(0, 65350, '\p{^- XDIGIT}', "");
    Expect(0, 65350, '\P{- XDIGIT}', "");
    Expect(1, 65350, '\P{^- XDIGIT}', "");
    Expect(0, 65351, '\p{- XDIGIT}', "");
    Expect(1, 65351, '\p{^- XDIGIT}', "");
    Expect(1, 65351, '\P{- XDIGIT}', "");
    Expect(0, 65351, '\P{^- XDIGIT}', "");
    Error('\p{:=-_is_xposixxdigit}');
    Error('\P{:=-_is_xposixxdigit}');
    Expect(1, 65350, '\p{isxposixxdigit}', "");
    Expect(0, 65350, '\p{^isxposixxdigit}', "");
    Expect(0, 65350, '\P{isxposixxdigit}', "");
    Expect(1, 65350, '\P{^isxposixxdigit}', "");
    Expect(0, 65351, '\p{isxposixxdigit}', "");
    Expect(1, 65351, '\p{^isxposixxdigit}', "");
    Expect(1, 65351, '\P{isxposixxdigit}', "");
    Expect(0, 65351, '\P{^isxposixxdigit}', "");
    Expect(1, 65350, '\p{ Is_xposixxdigit}', "");
    Expect(0, 65350, '\p{^ Is_xposixxdigit}', "");
    Expect(0, 65350, '\P{ Is_xposixxdigit}', "");
    Expect(1, 65350, '\P{^ Is_xposixxdigit}', "");
    Expect(0, 65351, '\p{ Is_xposixxdigit}', "");
    Expect(1, 65351, '\p{^ Is_xposixxdigit}', "");
    Expect(1, 65351, '\P{ Is_xposixxdigit}', "");
    Expect(0, 65351, '\P{^ Is_xposixxdigit}', "");
    Error('\p{_/a/Is_XDigit}');
    Error('\P{_/a/Is_XDigit}');
    Expect(1, 65350, '\p{isxdigit}', "");
    Expect(0, 65350, '\p{^isxdigit}', "");
    Expect(0, 65350, '\P{isxdigit}', "");
    Expect(1, 65350, '\P{^isxdigit}', "");
    Expect(0, 65351, '\p{isxdigit}', "");
    Expect(1, 65351, '\p{^isxdigit}', "");
    Expect(1, 65351, '\P{isxdigit}', "");
    Expect(0, 65351, '\P{^isxdigit}', "");
    Expect(1, 65350, '\p{_	IS_xdigit}', "");
    Expect(0, 65350, '\p{^_	IS_xdigit}', "");
    Expect(0, 65350, '\P{_	IS_xdigit}', "");
    Expect(1, 65350, '\P{^_	IS_xdigit}', "");
    Expect(0, 65351, '\p{_	IS_xdigit}', "");
    Expect(1, 65351, '\p{^_	IS_xdigit}', "");
    Expect(1, 65351, '\P{_	IS_xdigit}', "");
    Expect(0, 65351, '\P{^_	IS_xdigit}', "");
    Error('\p{--hex_digit:=}');
    Error('\P{--hex_digit:=}');
    Expect(1, 65350, '\p{hexdigit}', "");
    Expect(0, 65350, '\p{^hexdigit}', "");
    Expect(0, 65350, '\P{hexdigit}', "");
    Expect(1, 65350, '\P{^hexdigit}', "");
    Expect(0, 65351, '\p{hexdigit}', "");
    Expect(1, 65351, '\p{^hexdigit}', "");
    Expect(1, 65351, '\P{hexdigit}', "");
    Expect(0, 65351, '\P{^hexdigit}', "");
    Expect(1, 65350, '\p{_	HEX_digit}', "");
    Expect(0, 65350, '\p{^_	HEX_digit}', "");
    Expect(0, 65350, '\P{_	HEX_digit}', "");
    Expect(1, 65350, '\P{^_	HEX_digit}', "");
    Expect(0, 65351, '\p{_	HEX_digit}', "");
    Expect(1, 65351, '\p{^_	HEX_digit}', "");
    Expect(1, 65351, '\P{_	HEX_digit}', "");
    Expect(0, 65351, '\P{^_	HEX_digit}', "");
    Error('\p{ /a/is_hex_Digit}');
    Error('\P{ /a/is_hex_Digit}');
    Expect(1, 65350, '\p{ishexdigit}', "");
    Expect(0, 65350, '\p{^ishexdigit}', "");
    Expect(0, 65350, '\P{ishexdigit}', "");
    Expect(1, 65350, '\P{^ishexdigit}', "");
    Expect(0, 65351, '\p{ishexdigit}', "");
    Expect(1, 65351, '\p{^ishexdigit}', "");
    Expect(1, 65351, '\P{ishexdigit}', "");
    Expect(0, 65351, '\P{^ishexdigit}', "");
    Expect(1, 65350, '\p{	Is_hex_DIGIT}', "");
    Expect(0, 65350, '\p{^	Is_hex_DIGIT}', "");
    Expect(0, 65350, '\P{	Is_hex_DIGIT}', "");
    Expect(1, 65350, '\P{^	Is_hex_DIGIT}', "");
    Expect(0, 65351, '\p{	Is_hex_DIGIT}', "");
    Expect(1, 65351, '\p{^	Is_hex_DIGIT}', "");
    Expect(1, 65351, '\P{	Is_hex_DIGIT}', "");
    Expect(0, 65351, '\P{^	Is_hex_DIGIT}', "");
    Error('\p{:=-Hex}');
    Error('\P{:=-Hex}');
    Expect(1, 65350, '\p{hex}', "");
    Expect(0, 65350, '\p{^hex}', "");
    Expect(0, 65350, '\P{hex}', "");
    Expect(1, 65350, '\P{^hex}', "");
    Expect(0, 65351, '\p{hex}', "");
    Expect(1, 65351, '\p{^hex}', "");
    Expect(1, 65351, '\P{hex}', "");
    Expect(0, 65351, '\P{^hex}', "");
    Expect(1, 65350, '\p{_	hex}', "");
    Expect(0, 65350, '\p{^_	hex}', "");
    Expect(0, 65350, '\P{_	hex}', "");
    Expect(1, 65350, '\P{^_	hex}', "");
    Expect(0, 65351, '\p{_	hex}', "");
    Expect(1, 65351, '\p{^_	hex}', "");
    Expect(1, 65351, '\P{_	hex}', "");
    Expect(0, 65351, '\P{^_	hex}', "");
    Error('\p{-/a/is_HEX}');
    Error('\P{-/a/is_HEX}');
    Expect(1, 65350, '\p{ishex}', "");
    Expect(0, 65350, '\p{^ishex}', "");
    Expect(0, 65350, '\P{ishex}', "");
    Expect(1, 65350, '\P{^ishex}', "");
    Expect(0, 65351, '\p{ishex}', "");
    Expect(1, 65351, '\p{^ishex}', "");
    Expect(1, 65351, '\P{ishex}', "");
    Expect(0, 65351, '\P{^ishex}', "");
    Expect(1, 65350, '\p{-	Is_HEX}', "");
    Expect(0, 65350, '\p{^-	Is_HEX}', "");
    Expect(0, 65350, '\P{-	Is_HEX}', "");
    Expect(1, 65350, '\P{^-	Is_HEX}', "");
    Expect(0, 65351, '\p{-	Is_HEX}', "");
    Expect(1, 65351, '\p{^-	Is_HEX}', "");
    Expect(1, 65351, '\P{-	Is_HEX}', "");
    Expect(0, 65351, '\P{^-	Is_HEX}', "");
    Error('\p{-	XID_CONTINUE:=}');
    Error('\P{-	XID_CONTINUE:=}');
    Expect(1, 917999, '\p{xidcontinue}', "");
    Expect(0, 917999, '\p{^xidcontinue}', "");
    Expect(0, 917999, '\P{xidcontinue}', "");
    Expect(1, 917999, '\P{^xidcontinue}', "");
    Expect(0, 918000, '\p{xidcontinue}', "");
    Expect(1, 918000, '\p{^xidcontinue}', "");
    Expect(1, 918000, '\P{xidcontinue}', "");
    Expect(0, 918000, '\P{^xidcontinue}', "");
    Expect(1, 917999, '\p{		XID_CONTINUE}', "");
    Expect(0, 917999, '\p{^		XID_CONTINUE}', "");
    Expect(0, 917999, '\P{		XID_CONTINUE}', "");
    Expect(1, 917999, '\P{^		XID_CONTINUE}', "");
    Expect(0, 918000, '\p{		XID_CONTINUE}', "");
    Expect(1, 918000, '\p{^		XID_CONTINUE}', "");
    Expect(1, 918000, '\P{		XID_CONTINUE}', "");
    Expect(0, 918000, '\P{^		XID_CONTINUE}', "");
    Error('\p{:=_is_XID_Continue}');
    Error('\P{:=_is_XID_Continue}');
    Expect(1, 917999, '\p{isxidcontinue}', "");
    Expect(0, 917999, '\p{^isxidcontinue}', "");
    Expect(0, 917999, '\P{isxidcontinue}', "");
    Expect(1, 917999, '\P{^isxidcontinue}', "");
    Expect(0, 918000, '\p{isxidcontinue}', "");
    Expect(1, 918000, '\p{^isxidcontinue}', "");
    Expect(1, 918000, '\P{isxidcontinue}', "");
    Expect(0, 918000, '\P{^isxidcontinue}', "");
    Expect(1, 917999, '\p{_ is_xid_Continue}', "");
    Expect(0, 917999, '\p{^_ is_xid_Continue}', "");
    Expect(0, 917999, '\P{_ is_xid_Continue}', "");
    Expect(1, 917999, '\P{^_ is_xid_Continue}', "");
    Expect(0, 918000, '\p{_ is_xid_Continue}', "");
    Expect(1, 918000, '\p{^_ is_xid_Continue}', "");
    Expect(1, 918000, '\P{_ is_xid_Continue}', "");
    Expect(0, 918000, '\P{^_ is_xid_Continue}', "");
    Error('\p{:=	xidc}');
    Error('\P{:=	xidc}');
    Expect(1, 917999, '\p{xidc}', "");
    Expect(0, 917999, '\p{^xidc}', "");
    Expect(0, 917999, '\P{xidc}', "");
    Expect(1, 917999, '\P{^xidc}', "");
    Expect(0, 918000, '\p{xidc}', "");
    Expect(1, 918000, '\p{^xidc}', "");
    Expect(1, 918000, '\P{xidc}', "");
    Expect(0, 918000, '\P{^xidc}', "");
    Expect(1, 917999, '\p{ XIDC}', "");
    Expect(0, 917999, '\p{^ XIDC}', "");
    Expect(0, 917999, '\P{ XIDC}', "");
    Expect(1, 917999, '\P{^ XIDC}', "");
    Expect(0, 918000, '\p{ XIDC}', "");
    Expect(1, 918000, '\p{^ XIDC}', "");
    Expect(1, 918000, '\P{ XIDC}', "");
    Expect(0, 918000, '\P{^ XIDC}', "");
    Error('\p{/a/- IS_xidc}');
    Error('\P{/a/- IS_xidc}');
    Expect(1, 917999, '\p{isxidc}', "");
    Expect(0, 917999, '\p{^isxidc}', "");
    Expect(0, 917999, '\P{isxidc}', "");
    Expect(1, 917999, '\P{^isxidc}', "");
    Expect(0, 918000, '\p{isxidc}', "");
    Expect(1, 918000, '\p{^isxidc}', "");
    Expect(1, 918000, '\P{isxidc}', "");
    Expect(0, 918000, '\P{^isxidc}', "");
    Expect(1, 917999, '\p{-	Is_XIDC}', "");
    Expect(0, 917999, '\p{^-	Is_XIDC}', "");
    Expect(0, 917999, '\P{-	Is_XIDC}', "");
    Expect(1, 917999, '\P{^-	Is_XIDC}', "");
    Expect(0, 918000, '\p{-	Is_XIDC}', "");
    Expect(1, 918000, '\p{^-	Is_XIDC}', "");
    Expect(1, 918000, '\P{-	Is_XIDC}', "");
    Expect(0, 918000, '\P{^-	Is_XIDC}', "");
    Error('\p{/a/-XID_Start}');
    Error('\P{/a/-XID_Start}');
    Expect(1, 195101, '\p{xidstart}', "");
    Expect(0, 195101, '\p{^xidstart}', "");
    Expect(0, 195101, '\P{xidstart}', "");
    Expect(1, 195101, '\P{^xidstart}', "");
    Expect(0, 195102, '\p{xidstart}', "");
    Expect(1, 195102, '\p{^xidstart}', "");
    Expect(1, 195102, '\P{xidstart}', "");
    Expect(0, 195102, '\P{^xidstart}', "");
    Expect(1, 195101, '\p{_	XID_Start}', "");
    Expect(0, 195101, '\p{^_	XID_Start}', "");
    Expect(0, 195101, '\P{_	XID_Start}', "");
    Expect(1, 195101, '\P{^_	XID_Start}', "");
    Expect(0, 195102, '\p{_	XID_Start}', "");
    Expect(1, 195102, '\p{^_	XID_Start}', "");
    Expect(1, 195102, '\P{_	XID_Start}', "");
    Expect(0, 195102, '\P{^_	XID_Start}', "");
    Error('\p{ _Is_XID_Start:=}');
    Error('\P{ _Is_XID_Start:=}');
    Expect(1, 195101, '\p{isxidstart}', "");
    Expect(0, 195101, '\p{^isxidstart}', "");
    Expect(0, 195101, '\P{isxidstart}', "");
    Expect(1, 195101, '\P{^isxidstart}', "");
    Expect(0, 195102, '\p{isxidstart}', "");
    Expect(1, 195102, '\p{^isxidstart}', "");
    Expect(1, 195102, '\P{isxidstart}', "");
    Expect(0, 195102, '\P{^isxidstart}', "");
    Expect(1, 195101, '\p{IS_XID_Start}', "");
    Expect(0, 195101, '\p{^IS_XID_Start}', "");
    Expect(0, 195101, '\P{IS_XID_Start}', "");
    Expect(1, 195101, '\P{^IS_XID_Start}', "");
    Expect(0, 195102, '\p{IS_XID_Start}', "");
    Expect(1, 195102, '\p{^IS_XID_Start}', "");
    Expect(1, 195102, '\P{IS_XID_Start}', "");
    Expect(0, 195102, '\P{^IS_XID_Start}', "");
    Error('\p{	 XIDS/a/}');
    Error('\P{	 XIDS/a/}');
    Expect(1, 195101, '\p{xids}', "");
    Expect(0, 195101, '\p{^xids}', "");
    Expect(0, 195101, '\P{xids}', "");
    Expect(1, 195101, '\P{^xids}', "");
    Expect(0, 195102, '\p{xids}', "");
    Expect(1, 195102, '\p{^xids}', "");
    Expect(1, 195102, '\P{xids}', "");
    Expect(0, 195102, '\P{^xids}', "");
    Expect(1, 195101, '\p{ XIDS}', "");
    Expect(0, 195101, '\p{^ XIDS}', "");
    Expect(0, 195101, '\P{ XIDS}', "");
    Expect(1, 195101, '\P{^ XIDS}', "");
    Expect(0, 195102, '\p{ XIDS}', "");
    Expect(1, 195102, '\p{^ XIDS}', "");
    Expect(1, 195102, '\P{ XIDS}', "");
    Expect(0, 195102, '\P{^ XIDS}', "");
    Error('\p{-/a/IS_xids}');
    Error('\P{-/a/IS_xids}');
    Expect(1, 195101, '\p{isxids}', "");
    Expect(0, 195101, '\p{^isxids}', "");
    Expect(0, 195101, '\P{isxids}', "");
    Expect(1, 195101, '\P{^isxids}', "");
    Expect(0, 195102, '\p{isxids}', "");
    Expect(1, 195102, '\p{^isxids}', "");
    Expect(1, 195102, '\P{isxids}', "");
    Expect(0, 195102, '\P{^isxids}', "");
    Expect(1, 195101, '\p{_Is_XIDS}', "");
    Expect(0, 195101, '\p{^_Is_XIDS}', "");
    Expect(0, 195101, '\P{_Is_XIDS}', "");
    Expect(1, 195101, '\P{^_Is_XIDS}', "");
    Expect(0, 195102, '\p{_Is_XIDS}', "");
    Expect(1, 195102, '\p{^_Is_XIDS}', "");
    Expect(1, 195102, '\P{_Is_XIDS}', "");
    Expect(0, 195102, '\P{^_Is_XIDS}', "");
    Error('\p{ _XPosixAlpha/a/}');
    Error('\P{ _XPosixAlpha/a/}');
    Expect(1, 195101, '\p{xposixalpha}', "");
    Expect(0, 195101, '\p{^xposixalpha}', "");
    Expect(0, 195101, '\P{xposixalpha}', "");
    Expect(1, 195101, '\P{^xposixalpha}', "");
    Expect(0, 195102, '\p{xposixalpha}', "");
    Expect(1, 195102, '\p{^xposixalpha}', "");
    Expect(1, 195102, '\P{xposixalpha}', "");
    Expect(0, 195102, '\P{^xposixalpha}', "");
    Expect(1, 195101, '\p{__XPosixAlpha}', "");
    Expect(0, 195101, '\p{^__XPosixAlpha}', "");
    Expect(0, 195101, '\P{__XPosixAlpha}', "");
    Expect(1, 195101, '\P{^__XPosixAlpha}', "");
    Expect(0, 195102, '\p{__XPosixAlpha}', "");
    Expect(1, 195102, '\p{^__XPosixAlpha}', "");
    Expect(1, 195102, '\P{__XPosixAlpha}', "");
    Expect(0, 195102, '\P{^__XPosixAlpha}', "");
    Error('\p{	-Is_XPosixAlpha/a/}');
    Error('\P{	-Is_XPosixAlpha/a/}');
    Expect(1, 195101, '\p{isxposixalpha}', "");
    Expect(0, 195101, '\p{^isxposixalpha}', "");
    Expect(0, 195101, '\P{isxposixalpha}', "");
    Expect(1, 195101, '\P{^isxposixalpha}', "");
    Expect(0, 195102, '\p{isxposixalpha}', "");
    Expect(1, 195102, '\p{^isxposixalpha}', "");
    Expect(1, 195102, '\P{isxposixalpha}', "");
    Expect(0, 195102, '\P{^isxposixalpha}', "");
    Expect(1, 195101, '\p{	_is_xposixalpha}', "");
    Expect(0, 195101, '\p{^	_is_xposixalpha}', "");
    Expect(0, 195101, '\P{	_is_xposixalpha}', "");
    Expect(1, 195101, '\P{^	_is_xposixalpha}', "");
    Expect(0, 195102, '\p{	_is_xposixalpha}', "");
    Expect(1, 195102, '\p{^	_is_xposixalpha}', "");
    Expect(1, 195102, '\P{	_is_xposixalpha}', "");
    Expect(0, 195102, '\P{^	_is_xposixalpha}', "");
    Error('\p{-Alphabetic/a/}');
    Error('\P{-Alphabetic/a/}');
    Expect(1, 195101, '\p{alphabetic}', "");
    Expect(0, 195101, '\p{^alphabetic}', "");
    Expect(0, 195101, '\P{alphabetic}', "");
    Expect(1, 195101, '\P{^alphabetic}', "");
    Expect(0, 195102, '\p{alphabetic}', "");
    Expect(1, 195102, '\p{^alphabetic}', "");
    Expect(1, 195102, '\P{alphabetic}', "");
    Expect(0, 195102, '\P{^alphabetic}', "");
    Expect(1, 195101, '\p{		ALPHABETIC}', "");
    Expect(0, 195101, '\p{^		ALPHABETIC}', "");
    Expect(0, 195101, '\P{		ALPHABETIC}', "");
    Expect(1, 195101, '\P{^		ALPHABETIC}', "");
    Expect(0, 195102, '\p{		ALPHABETIC}', "");
    Expect(1, 195102, '\p{^		ALPHABETIC}', "");
    Expect(1, 195102, '\P{		ALPHABETIC}', "");
    Expect(0, 195102, '\P{^		ALPHABETIC}', "");
    Error('\p{-/a/Is_Alphabetic}');
    Error('\P{-/a/Is_Alphabetic}');
    Expect(1, 195101, '\p{isalphabetic}', "");
    Expect(0, 195101, '\p{^isalphabetic}', "");
    Expect(0, 195101, '\P{isalphabetic}', "");
    Expect(1, 195101, '\P{^isalphabetic}', "");
    Expect(0, 195102, '\p{isalphabetic}', "");
    Expect(1, 195102, '\p{^isalphabetic}', "");
    Expect(1, 195102, '\P{isalphabetic}', "");
    Expect(0, 195102, '\P{^isalphabetic}', "");
    Expect(1, 195101, '\p{_-IS_ALPHABETIC}', "");
    Expect(0, 195101, '\p{^_-IS_ALPHABETIC}', "");
    Expect(0, 195101, '\P{_-IS_ALPHABETIC}', "");
    Expect(1, 195101, '\P{^_-IS_ALPHABETIC}', "");
    Expect(0, 195102, '\p{_-IS_ALPHABETIC}', "");
    Expect(1, 195102, '\p{^_-IS_ALPHABETIC}', "");
    Expect(1, 195102, '\P{_-IS_ALPHABETIC}', "");
    Expect(0, 195102, '\P{^_-IS_ALPHABETIC}', "");
    Error('\p{/a/alpha}');
    Error('\P{/a/alpha}');
    Expect(1, 195101, '\p{alpha}', "");
    Expect(0, 195101, '\p{^alpha}', "");
    Expect(0, 195101, '\P{alpha}', "");
    Expect(1, 195101, '\P{^alpha}', "");
    Expect(0, 195102, '\p{alpha}', "");
    Expect(1, 195102, '\p{^alpha}', "");
    Expect(1, 195102, '\P{alpha}', "");
    Expect(0, 195102, '\P{^alpha}', "");
    Expect(1, 195101, '\p{_Alpha}', "");
    Expect(0, 195101, '\p{^_Alpha}', "");
    Expect(0, 195101, '\P{_Alpha}', "");
    Expect(1, 195101, '\P{^_Alpha}', "");
    Expect(0, 195102, '\p{_Alpha}', "");
    Expect(1, 195102, '\p{^_Alpha}', "");
    Expect(1, 195102, '\P{_Alpha}', "");
    Expect(0, 195102, '\P{^_Alpha}', "");
    Error('\p{:=is_Alpha}');
    Error('\P{:=is_Alpha}');
    Expect(1, 195101, '\p{isalpha}', "");
    Expect(0, 195101, '\p{^isalpha}', "");
    Expect(0, 195101, '\P{isalpha}', "");
    Expect(1, 195101, '\P{^isalpha}', "");
    Expect(0, 195102, '\p{isalpha}', "");
    Expect(1, 195102, '\p{^isalpha}', "");
    Expect(1, 195102, '\P{isalpha}', "");
    Expect(0, 195102, '\P{^isalpha}', "");
    Expect(1, 195101, '\p{	-Is_alpha}', "");
    Expect(0, 195101, '\p{^	-Is_alpha}', "");
    Expect(0, 195101, '\P{	-Is_alpha}', "");
    Expect(1, 195101, '\P{^	-Is_alpha}', "");
    Expect(0, 195102, '\p{	-Is_alpha}', "");
    Expect(1, 195102, '\p{^	-Is_alpha}', "");
    Expect(1, 195102, '\P{	-Is_alpha}', "");
    Expect(0, 195102, '\P{^	-Is_alpha}', "");
    Error('\p{ xposixlower/a/}');
    Error('\P{ xposixlower/a/}');
    Expect(1, 125251, '\p{xposixlower}', "");
    Expect(0, 125251, '\p{^xposixlower}', "");
    Expect(0, 125251, '\P{xposixlower}', "");
    Expect(1, 125251, '\P{^xposixlower}', "");
    Expect(0, 125252, '\p{xposixlower}', "");
    Expect(1, 125252, '\p{^xposixlower}', "");
    Expect(1, 125252, '\P{xposixlower}', "");
    Expect(0, 125252, '\P{^xposixlower}', "");
    Expect(1, 125251, '\p{	XPosixLower}', "");
    Expect(0, 125251, '\p{^	XPosixLower}', "");
    Expect(0, 125251, '\P{	XPosixLower}', "");
    Expect(1, 125251, '\P{^	XPosixLower}', "");
    Expect(0, 125252, '\p{	XPosixLower}', "");
    Expect(1, 125252, '\p{^	XPosixLower}', "");
    Expect(1, 125252, '\P{	XPosixLower}', "");
    Expect(0, 125252, '\P{^	XPosixLower}', "");
    Error('\p{:=	 Is_xposixlower}');
    Error('\P{:=	 Is_xposixlower}');
    Expect(1, 125251, '\p{isxposixlower}', "");
    Expect(0, 125251, '\p{^isxposixlower}', "");
    Expect(0, 125251, '\P{isxposixlower}', "");
    Expect(1, 125251, '\P{^isxposixlower}', "");
    Expect(0, 125252, '\p{isxposixlower}', "");
    Expect(1, 125252, '\p{^isxposixlower}', "");
    Expect(1, 125252, '\P{isxposixlower}', "");
    Expect(0, 125252, '\P{^isxposixlower}', "");
    Expect(1, 125251, '\p{	-Is_XPosixLower}', "");
    Expect(0, 125251, '\p{^	-Is_XPosixLower}', "");
    Expect(0, 125251, '\P{	-Is_XPosixLower}', "");
    Expect(1, 125251, '\P{^	-Is_XPosixLower}', "");
    Expect(0, 125252, '\p{	-Is_XPosixLower}', "");
    Expect(1, 125252, '\p{^	-Is_XPosixLower}', "");
    Expect(1, 125252, '\P{	-Is_XPosixLower}', "");
    Expect(0, 125252, '\P{^	-Is_XPosixLower}', "");
    Error('\p{ Lowercase:=}');
    Error('\P{ Lowercase:=}');
    Expect(1, 125251, '\p{lowercase}', "");
    Expect(0, 125251, '\p{^lowercase}', "");
    Expect(0, 125251, '\P{lowercase}', "");
    Expect(1, 125251, '\P{^lowercase}', "");
    Expect(0, 125252, '\p{lowercase}', "");
    Expect(1, 125252, '\p{^lowercase}', "");
    Expect(1, 125252, '\P{lowercase}', "");
    Expect(0, 125252, '\P{^lowercase}', "");
    Expect(1, 125251, '\p{	 LOWERCASE}', "");
    Expect(0, 125251, '\p{^	 LOWERCASE}', "");
    Expect(0, 125251, '\P{	 LOWERCASE}', "");
    Expect(1, 125251, '\P{^	 LOWERCASE}', "");
    Expect(0, 125252, '\p{	 LOWERCASE}', "");
    Expect(1, 125252, '\p{^	 LOWERCASE}', "");
    Expect(1, 125252, '\P{	 LOWERCASE}', "");
    Expect(0, 125252, '\P{^	 LOWERCASE}', "");
    Error('\p{--is_LOWERCASE:=}');
    Error('\P{--is_LOWERCASE:=}');
    Expect(1, 125251, '\p{islowercase}', "");
    Expect(0, 125251, '\p{^islowercase}', "");
    Expect(0, 125251, '\P{islowercase}', "");
    Expect(1, 125251, '\P{^islowercase}', "");
    Expect(0, 125252, '\p{islowercase}', "");
    Expect(1, 125252, '\p{^islowercase}', "");
    Expect(1, 125252, '\P{islowercase}', "");
    Expect(0, 125252, '\P{^islowercase}', "");
    Expect(1, 125251, '\p{-_is_LOWERCASE}', "");
    Expect(0, 125251, '\p{^-_is_LOWERCASE}', "");
    Expect(0, 125251, '\P{-_is_LOWERCASE}', "");
    Expect(1, 125251, '\P{^-_is_LOWERCASE}', "");
    Expect(0, 125252, '\p{-_is_LOWERCASE}', "");
    Expect(1, 125252, '\p{^-_is_LOWERCASE}', "");
    Expect(1, 125252, '\P{-_is_LOWERCASE}', "");
    Expect(0, 125252, '\P{^-_is_LOWERCASE}', "");
    Error('\p{:=_lower}');
    Error('\P{:=_lower}');
    Expect(1, 125251, '\p{lower}', "");
    Expect(0, 125251, '\p{^lower}', "");
    Expect(0, 125251, '\P{lower}', "");
    Expect(1, 125251, '\P{^lower}', "");
    Expect(0, 125252, '\p{lower}', "");
    Expect(1, 125252, '\p{^lower}', "");
    Expect(1, 125252, '\P{lower}', "");
    Expect(0, 125252, '\P{^lower}', "");
    Expect(1, 125251, '\p{  lower}', "");
    Expect(0, 125251, '\p{^  lower}', "");
    Expect(0, 125251, '\P{  lower}', "");
    Expect(1, 125251, '\P{^  lower}', "");
    Expect(0, 125252, '\p{  lower}', "");
    Expect(1, 125252, '\p{^  lower}', "");
    Expect(1, 125252, '\P{  lower}', "");
    Expect(0, 125252, '\P{^  lower}', "");
    Error('\p{ /a/Is_Lower}');
    Error('\P{ /a/Is_Lower}');
    Expect(1, 125251, '\p{islower}', "");
    Expect(0, 125251, '\p{^islower}', "");
    Expect(0, 125251, '\P{islower}', "");
    Expect(1, 125251, '\P{^islower}', "");
    Expect(0, 125252, '\p{islower}', "");
    Expect(1, 125252, '\p{^islower}', "");
    Expect(1, 125252, '\P{islower}', "");
    Expect(0, 125252, '\P{^islower}', "");
    Expect(1, 125251, '\p{--is_LOWER}', "");
    Expect(0, 125251, '\p{^--is_LOWER}', "");
    Expect(0, 125251, '\P{--is_LOWER}', "");
    Expect(1, 125251, '\P{^--is_LOWER}', "");
    Expect(0, 125252, '\p{--is_LOWER}', "");
    Expect(1, 125252, '\p{^--is_LOWER}', "");
    Expect(1, 125252, '\P{--is_LOWER}', "");
    Expect(0, 125252, '\P{^--is_LOWER}', "");
    Error('\p{ XPOSIXPUNCT:=}');
    Error('\P{ XPOSIXPUNCT:=}');
    Expect(1, 125279, '\p{xposixpunct}', "");
    Expect(0, 125279, '\p{^xposixpunct}', "");
    Expect(0, 125279, '\P{xposixpunct}', "");
    Expect(1, 125279, '\P{^xposixpunct}', "");
    Expect(0, 125280, '\p{xposixpunct}', "");
    Expect(1, 125280, '\p{^xposixpunct}', "");
    Expect(1, 125280, '\P{xposixpunct}', "");
    Expect(0, 125280, '\P{^xposixpunct}', "");
    Expect(1, 125279, '\p{	 XPosixPunct}', "");
    Expect(0, 125279, '\p{^	 XPosixPunct}', "");
    Expect(0, 125279, '\P{	 XPosixPunct}', "");
    Expect(1, 125279, '\P{^	 XPosixPunct}', "");
    Expect(0, 125280, '\p{	 XPosixPunct}', "");
    Expect(1, 125280, '\p{^	 XPosixPunct}', "");
    Expect(1, 125280, '\P{	 XPosixPunct}', "");
    Expect(0, 125280, '\P{^	 XPosixPunct}', "");
    Error('\p{	 Is_XPosixPunct/a/}');
    Error('\P{	 Is_XPosixPunct/a/}');
    Expect(1, 125279, '\p{isxposixpunct}', "");
    Expect(0, 125279, '\p{^isxposixpunct}', "");
    Expect(0, 125279, '\P{isxposixpunct}', "");
    Expect(1, 125279, '\P{^isxposixpunct}', "");
    Expect(0, 125280, '\p{isxposixpunct}', "");
    Expect(1, 125280, '\p{^isxposixpunct}', "");
    Expect(1, 125280, '\P{isxposixpunct}', "");
    Expect(0, 125280, '\P{^isxposixpunct}', "");
    Expect(1, 125279, '\p{		Is_xposixpunct}', "");
    Expect(0, 125279, '\p{^		Is_xposixpunct}', "");
    Expect(0, 125279, '\P{		Is_xposixpunct}', "");
    Expect(1, 125279, '\P{^		Is_xposixpunct}', "");
    Expect(0, 125280, '\p{		Is_xposixpunct}', "");
    Expect(1, 125280, '\p{^		Is_xposixpunct}', "");
    Expect(1, 125280, '\P{		Is_xposixpunct}', "");
    Expect(0, 125280, '\P{^		Is_xposixpunct}', "");
    Error('\p{/a/  xposixspace}');
    Error('\P{/a/  xposixspace}');
    Expect(1, 12288, '\p{xposixspace}', "");
    Expect(0, 12288, '\p{^xposixspace}', "");
    Expect(0, 12288, '\P{xposixspace}', "");
    Expect(1, 12288, '\P{^xposixspace}', "");
    Expect(0, 12289, '\p{xposixspace}', "");
    Expect(1, 12289, '\p{^xposixspace}', "");
    Expect(1, 12289, '\P{xposixspace}', "");
    Expect(0, 12289, '\P{^xposixspace}', "");
    Expect(1, 12288, '\p{__XPOSIXSPACE}', "");
    Expect(0, 12288, '\p{^__XPOSIXSPACE}', "");
    Expect(0, 12288, '\P{__XPOSIXSPACE}', "");
    Expect(1, 12288, '\P{^__XPOSIXSPACE}', "");
    Expect(0, 12289, '\p{__XPOSIXSPACE}', "");
    Expect(1, 12289, '\p{^__XPOSIXSPACE}', "");
    Expect(1, 12289, '\P{__XPOSIXSPACE}', "");
    Expect(0, 12289, '\P{^__XPOSIXSPACE}', "");
    Error('\p{/a/XPerlSpace}');
    Error('\P{/a/XPerlSpace}');
    Expect(1, 12288, '\p{xperlspace}', "");
    Expect(0, 12288, '\p{^xperlspace}', "");
    Expect(0, 12288, '\P{xperlspace}', "");
    Expect(1, 12288, '\P{^xperlspace}', "");
    Expect(0, 12289, '\p{xperlspace}', "");
    Expect(1, 12289, '\p{^xperlspace}', "");
    Expect(1, 12289, '\P{xperlspace}', "");
    Expect(0, 12289, '\P{^xperlspace}', "");
    Expect(1, 12288, '\p{	-xperlspace}', "");
    Expect(0, 12288, '\p{^	-xperlspace}', "");
    Expect(0, 12288, '\P{	-xperlspace}', "");
    Expect(1, 12288, '\P{^	-xperlspace}', "");
    Expect(0, 12289, '\p{	-xperlspace}', "");
    Expect(1, 12289, '\p{^	-xperlspace}', "");
    Expect(1, 12289, '\P{	-xperlspace}', "");
    Expect(0, 12289, '\P{^	-xperlspace}', "");
    Error('\p{-:=SpacePerl}');
    Error('\P{-:=SpacePerl}');
    Expect(1, 12288, '\p{spaceperl}', "");
    Expect(0, 12288, '\p{^spaceperl}', "");
    Expect(0, 12288, '\P{spaceperl}', "");
    Expect(1, 12288, '\P{^spaceperl}', "");
    Expect(0, 12289, '\p{spaceperl}', "");
    Expect(1, 12289, '\p{^spaceperl}', "");
    Expect(1, 12289, '\P{spaceperl}', "");
    Expect(0, 12289, '\P{^spaceperl}', "");
    Expect(1, 12288, '\p{SpacePerl}', "");
    Expect(0, 12288, '\p{^SpacePerl}', "");
    Expect(0, 12288, '\P{SpacePerl}', "");
    Expect(1, 12288, '\P{^SpacePerl}', "");
    Expect(0, 12289, '\p{SpacePerl}', "");
    Expect(1, 12289, '\p{^SpacePerl}', "");
    Expect(1, 12289, '\P{SpacePerl}', "");
    Expect(0, 12289, '\P{^SpacePerl}', "");
    Error('\p{_-Is_XPosixSpace:=}');
    Error('\P{_-Is_XPosixSpace:=}');
    Expect(1, 12288, '\p{isxposixspace}', "");
    Expect(0, 12288, '\p{^isxposixspace}', "");
    Expect(0, 12288, '\P{isxposixspace}', "");
    Expect(1, 12288, '\P{^isxposixspace}', "");
    Expect(0, 12289, '\p{isxposixspace}', "");
    Expect(1, 12289, '\p{^isxposixspace}', "");
    Expect(1, 12289, '\P{isxposixspace}', "");
    Expect(0, 12289, '\P{^isxposixspace}', "");
    Expect(1, 12288, '\p{_is_XPosixSpace}', "");
    Expect(0, 12288, '\p{^_is_XPosixSpace}', "");
    Expect(0, 12288, '\P{_is_XPosixSpace}', "");
    Expect(1, 12288, '\P{^_is_XPosixSpace}', "");
    Expect(0, 12289, '\p{_is_XPosixSpace}', "");
    Expect(1, 12289, '\p{^_is_XPosixSpace}', "");
    Expect(1, 12289, '\P{_is_XPosixSpace}', "");
    Expect(0, 12289, '\P{^_is_XPosixSpace}', "");
    Error('\p{/a/-Is_XPerlSpace}');
    Error('\P{/a/-Is_XPerlSpace}');
    Expect(1, 12288, '\p{isxperlspace}', "");
    Expect(0, 12288, '\p{^isxperlspace}', "");
    Expect(0, 12288, '\P{isxperlspace}', "");
    Expect(1, 12288, '\P{^isxperlspace}', "");
    Expect(0, 12289, '\p{isxperlspace}', "");
    Expect(1, 12289, '\p{^isxperlspace}', "");
    Expect(1, 12289, '\P{isxperlspace}', "");
    Expect(0, 12289, '\P{^isxperlspace}', "");
    Expect(1, 12288, '\p{ _is_XPERLSPACE}', "");
    Expect(0, 12288, '\p{^ _is_XPERLSPACE}', "");
    Expect(0, 12288, '\P{ _is_XPERLSPACE}', "");
    Expect(1, 12288, '\P{^ _is_XPERLSPACE}', "");
    Expect(0, 12289, '\p{ _is_XPERLSPACE}', "");
    Expect(1, 12289, '\p{^ _is_XPERLSPACE}', "");
    Expect(1, 12289, '\P{ _is_XPERLSPACE}', "");
    Expect(0, 12289, '\P{^ _is_XPERLSPACE}', "");
    Error('\p{:=Is_SPACEPERL}');
    Error('\P{:=Is_SPACEPERL}');
    Expect(1, 12288, '\p{isspaceperl}', "");
    Expect(0, 12288, '\p{^isspaceperl}', "");
    Expect(0, 12288, '\P{isspaceperl}', "");
    Expect(1, 12288, '\P{^isspaceperl}', "");
    Expect(0, 12289, '\p{isspaceperl}', "");
    Expect(1, 12289, '\p{^isspaceperl}', "");
    Expect(1, 12289, '\P{isspaceperl}', "");
    Expect(0, 12289, '\P{^isspaceperl}', "");
    Expect(1, 12288, '\p{ _IS_SpacePerl}', "");
    Expect(0, 12288, '\p{^ _IS_SpacePerl}', "");
    Expect(0, 12288, '\P{ _IS_SpacePerl}', "");
    Expect(1, 12288, '\P{^ _IS_SpacePerl}', "");
    Expect(0, 12289, '\p{ _IS_SpacePerl}', "");
    Expect(1, 12289, '\p{^ _IS_SpacePerl}', "");
    Expect(1, 12289, '\P{ _IS_SpacePerl}', "");
    Expect(0, 12289, '\P{^ _IS_SpacePerl}', "");
    Error('\p{ 	XPosixUpper/a/}');
    Error('\P{ 	XPosixUpper/a/}');
    Expect(1, 127369, '\p{xposixupper}', "");
    Expect(0, 127369, '\p{^xposixupper}', "");
    Expect(0, 127369, '\P{xposixupper}', "");
    Expect(1, 127369, '\P{^xposixupper}', "");
    Expect(0, 127370, '\p{xposixupper}', "");
    Expect(1, 127370, '\p{^xposixupper}', "");
    Expect(1, 127370, '\P{xposixupper}', "");
    Expect(0, 127370, '\P{^xposixupper}', "");
    Expect(1, 127369, '\p{ 	XPOSIXUPPER}', "");
    Expect(0, 127369, '\p{^ 	XPOSIXUPPER}', "");
    Expect(0, 127369, '\P{ 	XPOSIXUPPER}', "");
    Expect(1, 127369, '\P{^ 	XPOSIXUPPER}', "");
    Expect(0, 127370, '\p{ 	XPOSIXUPPER}', "");
    Expect(1, 127370, '\p{^ 	XPOSIXUPPER}', "");
    Expect(1, 127370, '\P{ 	XPOSIXUPPER}', "");
    Expect(0, 127370, '\P{^ 	XPOSIXUPPER}', "");
    Error('\p{/a/  is_XPosixUpper}');
    Error('\P{/a/  is_XPosixUpper}');
    Expect(1, 127369, '\p{isxposixupper}', "");
    Expect(0, 127369, '\p{^isxposixupper}', "");
    Expect(0, 127369, '\P{isxposixupper}', "");
    Expect(1, 127369, '\P{^isxposixupper}', "");
    Expect(0, 127370, '\p{isxposixupper}', "");
    Expect(1, 127370, '\p{^isxposixupper}', "");
    Expect(1, 127370, '\P{isxposixupper}', "");
    Expect(0, 127370, '\P{^isxposixupper}', "");
    Expect(1, 127369, '\p{	 IS_xposixupper}', "");
    Expect(0, 127369, '\p{^	 IS_xposixupper}', "");
    Expect(0, 127369, '\P{	 IS_xposixupper}', "");
    Expect(1, 127369, '\P{^	 IS_xposixupper}', "");
    Expect(0, 127370, '\p{	 IS_xposixupper}', "");
    Expect(1, 127370, '\p{^	 IS_xposixupper}', "");
    Expect(1, 127370, '\P{	 IS_xposixupper}', "");
    Expect(0, 127370, '\P{^	 IS_xposixupper}', "");
    Error('\p{ _Uppercase/a/}');
    Error('\P{ _Uppercase/a/}');
    Expect(1, 127369, '\p{uppercase}', "");
    Expect(0, 127369, '\p{^uppercase}', "");
    Expect(0, 127369, '\P{uppercase}', "");
    Expect(1, 127369, '\P{^uppercase}', "");
    Expect(0, 127370, '\p{uppercase}', "");
    Expect(1, 127370, '\p{^uppercase}', "");
    Expect(1, 127370, '\P{uppercase}', "");
    Expect(0, 127370, '\P{^uppercase}', "");
    Expect(1, 127369, '\p{_-uppercase}', "");
    Expect(0, 127369, '\p{^_-uppercase}', "");
    Expect(0, 127369, '\P{_-uppercase}', "");
    Expect(1, 127369, '\P{^_-uppercase}', "");
    Expect(0, 127370, '\p{_-uppercase}', "");
    Expect(1, 127370, '\p{^_-uppercase}', "");
    Expect(1, 127370, '\P{_-uppercase}', "");
    Expect(0, 127370, '\P{^_-uppercase}', "");
    Error('\p{ -Is_uppercase:=}');
    Error('\P{ -Is_uppercase:=}');
    Expect(1, 127369, '\p{isuppercase}', "");
    Expect(0, 127369, '\p{^isuppercase}', "");
    Expect(0, 127369, '\P{isuppercase}', "");
    Expect(1, 127369, '\P{^isuppercase}', "");
    Expect(0, 127370, '\p{isuppercase}', "");
    Expect(1, 127370, '\p{^isuppercase}', "");
    Expect(1, 127370, '\P{isuppercase}', "");
    Expect(0, 127370, '\P{^isuppercase}', "");
    Expect(1, 127369, '\p{-_is_uppercase}', "");
    Expect(0, 127369, '\p{^-_is_uppercase}', "");
    Expect(0, 127369, '\P{-_is_uppercase}', "");
    Expect(1, 127369, '\P{^-_is_uppercase}', "");
    Expect(0, 127370, '\p{-_is_uppercase}', "");
    Expect(1, 127370, '\p{^-_is_uppercase}', "");
    Expect(1, 127370, '\P{-_is_uppercase}', "");
    Expect(0, 127370, '\P{^-_is_uppercase}', "");
    Error('\p{/a/ -upper}');
    Error('\P{/a/ -upper}');
    Expect(1, 127369, '\p{upper}', "");
    Expect(0, 127369, '\p{^upper}', "");
    Expect(0, 127369, '\P{upper}', "");
    Expect(1, 127369, '\P{^upper}', "");
    Expect(0, 127370, '\p{upper}', "");
    Expect(1, 127370, '\p{^upper}', "");
    Expect(1, 127370, '\P{upper}', "");
    Expect(0, 127370, '\P{^upper}', "");
    Expect(1, 127369, '\p{_UPPER}', "");
    Expect(0, 127369, '\p{^_UPPER}', "");
    Expect(0, 127369, '\P{_UPPER}', "");
    Expect(1, 127369, '\P{^_UPPER}', "");
    Expect(0, 127370, '\p{_UPPER}', "");
    Expect(1, 127370, '\p{^_UPPER}', "");
    Expect(1, 127370, '\P{_UPPER}', "");
    Expect(0, 127370, '\P{^_UPPER}', "");
    Error('\p{/a/	 Is_UPPER}');
    Error('\P{/a/	 Is_UPPER}');
    Expect(1, 127369, '\p{isupper}', "");
    Expect(0, 127369, '\p{^isupper}', "");
    Expect(0, 127369, '\P{isupper}', "");
    Expect(1, 127369, '\P{^isupper}', "");
    Expect(0, 127370, '\p{isupper}', "");
    Expect(1, 127370, '\p{^isupper}', "");
    Expect(1, 127370, '\P{isupper}', "");
    Expect(0, 127370, '\P{^isupper}', "");
    Expect(1, 127369, '\p{-_Is_upper}', "");
    Expect(0, 127369, '\p{^-_Is_upper}', "");
    Expect(0, 127369, '\P{-_Is_upper}', "");
    Expect(1, 127369, '\P{^-_Is_upper}', "");
    Expect(0, 127370, '\p{-_Is_upper}', "");
    Expect(1, 127370, '\p{^-_Is_upper}', "");
    Expect(1, 127370, '\P{-_Is_upper}', "");
    Expect(0, 127370, '\P{^-_Is_upper}', "");
    Error('\p{ _YI/a/}');
    Error('\P{ _YI/a/}');
    Expect(1, 65381, '\p{yi}', "");
    Expect(0, 65381, '\p{^yi}', "");
    Expect(0, 65381, '\P{yi}', "");
    Expect(1, 65381, '\P{^yi}', "");
    Expect(0, 65382, '\p{yi}', "");
    Expect(1, 65382, '\p{^yi}', "");
    Expect(1, 65382, '\P{yi}', "");
    Expect(0, 65382, '\P{^yi}', "");
    Expect(1, 65381, '\p{ yi}', "");
    Expect(0, 65381, '\p{^ yi}', "");
    Expect(0, 65381, '\P{ yi}', "");
    Expect(1, 65381, '\P{^ yi}', "");
    Expect(0, 65382, '\p{ yi}', "");
    Expect(1, 65382, '\p{^ yi}', "");
    Expect(1, 65382, '\P{ yi}', "");
    Expect(0, 65382, '\P{^ yi}', "");
    Error('\p{/a/__Is_Yi}');
    Error('\P{/a/__Is_Yi}');
    Expect(1, 65381, '\p{isyi}', "");
    Expect(0, 65381, '\p{^isyi}', "");
    Expect(0, 65381, '\P{isyi}', "");
    Expect(1, 65381, '\P{^isyi}', "");
    Expect(0, 65382, '\p{isyi}', "");
    Expect(1, 65382, '\p{^isyi}', "");
    Expect(1, 65382, '\P{isyi}', "");
    Expect(0, 65382, '\P{^isyi}', "");
    Expect(1, 65381, '\p{_is_YI}', "");
    Expect(0, 65381, '\p{^_is_YI}', "");
    Expect(0, 65381, '\P{_is_YI}', "");
    Expect(1, 65381, '\P{^_is_YI}', "");
    Expect(0, 65382, '\p{_is_YI}', "");
    Expect(1, 65382, '\p{^_is_YI}', "");
    Expect(1, 65382, '\P{_is_YI}', "");
    Expect(0, 65382, '\P{^_is_YI}', "");
    Error('\p{	 YIII:=}');
    Error('\P{	 YIII:=}');
    Expect(1, 65381, '\p{yiii}', "");
    Expect(0, 65381, '\p{^yiii}', "");
    Expect(0, 65381, '\P{yiii}', "");
    Expect(1, 65381, '\P{^yiii}', "");
    Expect(0, 65382, '\p{yiii}', "");
    Expect(1, 65382, '\p{^yiii}', "");
    Expect(1, 65382, '\P{yiii}', "");
    Expect(0, 65382, '\P{^yiii}', "");
    Expect(1, 65381, '\p{-Yiii}', "");
    Expect(0, 65381, '\p{^-Yiii}', "");
    Expect(0, 65381, '\P{-Yiii}', "");
    Expect(1, 65381, '\P{^-Yiii}', "");
    Expect(0, 65382, '\p{-Yiii}', "");
    Expect(1, 65382, '\p{^-Yiii}', "");
    Expect(1, 65382, '\P{-Yiii}', "");
    Expect(0, 65382, '\P{^-Yiii}', "");
    Error('\p{	:=Is_Yiii}');
    Error('\P{	:=Is_Yiii}');
    Expect(1, 65381, '\p{isyiii}', "");
    Expect(0, 65381, '\p{^isyiii}', "");
    Expect(0, 65381, '\P{isyiii}', "");
    Expect(1, 65381, '\P{^isyiii}', "");
    Expect(0, 65382, '\p{isyiii}', "");
    Expect(1, 65382, '\p{^isyiii}', "");
    Expect(1, 65382, '\P{isyiii}', "");
    Expect(0, 65382, '\P{^isyiii}', "");
    Expect(1, 65381, '\p{ -Is_Yiii}', "");
    Expect(0, 65381, '\p{^ -Is_Yiii}', "");
    Expect(0, 65381, '\P{ -Is_Yiii}', "");
    Expect(1, 65381, '\P{^ -Is_Yiii}', "");
    Expect(0, 65382, '\p{ -Is_Yiii}', "");
    Expect(1, 65382, '\p{^ -Is_Yiii}', "");
    Expect(1, 65382, '\P{ -Is_Yiii}', "");
    Expect(0, 65382, '\P{^ -Is_Yiii}', "");
    Error('\p{--Yi_Radicals/a/}');
    Error('\P{--Yi_Radicals/a/}');
    Expect(1, 42191, '\p{yiradicals}', "");
    Expect(0, 42191, '\p{^yiradicals}', "");
    Expect(0, 42191, '\P{yiradicals}', "");
    Expect(1, 42191, '\P{^yiradicals}', "");
    Expect(0, 42192, '\p{yiradicals}', "");
    Expect(1, 42192, '\p{^yiradicals}', "");
    Expect(1, 42192, '\P{yiradicals}', "");
    Expect(0, 42192, '\P{^yiradicals}', "");
    Expect(1, 42191, '\p{	YI_radicals}', "");
    Expect(0, 42191, '\p{^	YI_radicals}', "");
    Expect(0, 42191, '\P{	YI_radicals}', "");
    Expect(1, 42191, '\P{^	YI_radicals}', "");
    Expect(0, 42192, '\p{	YI_radicals}', "");
    Expect(1, 42192, '\p{^	YI_radicals}', "");
    Expect(1, 42192, '\P{	YI_radicals}', "");
    Expect(0, 42192, '\P{^	YI_radicals}', "");
    Error('\p{:=-IS_Yi_radicals}');
    Error('\P{:=-IS_Yi_radicals}');
    Expect(1, 42191, '\p{isyiradicals}', "");
    Expect(0, 42191, '\p{^isyiradicals}', "");
    Expect(0, 42191, '\P{isyiradicals}', "");
    Expect(1, 42191, '\P{^isyiradicals}', "");
    Expect(0, 42192, '\p{isyiradicals}', "");
    Expect(1, 42192, '\p{^isyiradicals}', "");
    Expect(1, 42192, '\P{isyiradicals}', "");
    Expect(0, 42192, '\P{^isyiradicals}', "");
    Expect(1, 42191, '\p{ 	Is_yi_radicals}', "");
    Expect(0, 42191, '\p{^ 	Is_yi_radicals}', "");
    Expect(0, 42191, '\P{ 	Is_yi_radicals}', "");
    Expect(1, 42191, '\P{^ 	Is_yi_radicals}', "");
    Expect(0, 42192, '\p{ 	Is_yi_radicals}', "");
    Expect(1, 42192, '\p{^ 	Is_yi_radicals}', "");
    Expect(1, 42192, '\P{ 	Is_yi_radicals}', "");
    Expect(0, 42192, '\P{^ 	Is_yi_radicals}', "");
    Error('\p{	In_Yi_Radicals:=}');
    Error('\P{	In_Yi_Radicals:=}');
    Expect(1, 42191, '\p{inyiradicals}', "");
    Expect(0, 42191, '\p{^inyiradicals}', "");
    Expect(0, 42191, '\P{inyiradicals}', "");
    Expect(1, 42191, '\P{^inyiradicals}', "");
    Expect(0, 42192, '\p{inyiradicals}', "");
    Expect(1, 42192, '\p{^inyiradicals}', "");
    Expect(1, 42192, '\P{inyiradicals}', "");
    Expect(0, 42192, '\P{^inyiradicals}', "");
    Expect(1, 42191, '\p{ -IN_yi_RADICALS}', "");
    Expect(0, 42191, '\p{^ -IN_yi_RADICALS}', "");
    Expect(0, 42191, '\P{ -IN_yi_RADICALS}', "");
    Expect(1, 42191, '\P{^ -IN_yi_RADICALS}', "");
    Expect(0, 42192, '\p{ -IN_yi_RADICALS}', "");
    Expect(1, 42192, '\p{^ -IN_yi_RADICALS}', "");
    Expect(1, 42192, '\P{ -IN_yi_RADICALS}', "");
    Expect(0, 42192, '\P{^ -IN_yi_RADICALS}', "");
    Error('\p{yi_syllables:=}');
    Error('\P{yi_syllables:=}');
    Expect(1, 42127, '\p{yisyllables}', "");
    Expect(0, 42127, '\p{^yisyllables}', "");
    Expect(0, 42127, '\P{yisyllables}', "");
    Expect(1, 42127, '\P{^yisyllables}', "");
    Expect(0, 42128, '\p{yisyllables}', "");
    Expect(1, 42128, '\p{^yisyllables}', "");
    Expect(1, 42128, '\P{yisyllables}', "");
    Expect(0, 42128, '\P{^yisyllables}', "");
    Expect(1, 42127, '\p{-	yi_Syllables}', "");
    Expect(0, 42127, '\p{^-	yi_Syllables}', "");
    Expect(0, 42127, '\P{-	yi_Syllables}', "");
    Expect(1, 42127, '\P{^-	yi_Syllables}', "");
    Expect(0, 42128, '\p{-	yi_Syllables}', "");
    Expect(1, 42128, '\p{^-	yi_Syllables}', "");
    Expect(1, 42128, '\P{-	yi_Syllables}', "");
    Expect(0, 42128, '\P{^-	yi_Syllables}', "");
    Error('\p{:=_-IS_yi_Syllables}');
    Error('\P{:=_-IS_yi_Syllables}');
    Expect(1, 42127, '\p{isyisyllables}', "");
    Expect(0, 42127, '\p{^isyisyllables}', "");
    Expect(0, 42127, '\P{isyisyllables}', "");
    Expect(1, 42127, '\P{^isyisyllables}', "");
    Expect(0, 42128, '\p{isyisyllables}', "");
    Expect(1, 42128, '\p{^isyisyllables}', "");
    Expect(1, 42128, '\P{isyisyllables}', "");
    Expect(0, 42128, '\P{^isyisyllables}', "");
    Expect(1, 42127, '\p{ Is_yi_Syllables}', "");
    Expect(0, 42127, '\p{^ Is_yi_Syllables}', "");
    Expect(0, 42127, '\P{ Is_yi_Syllables}', "");
    Expect(1, 42127, '\P{^ Is_yi_Syllables}', "");
    Expect(0, 42128, '\p{ Is_yi_Syllables}', "");
    Expect(1, 42128, '\p{^ Is_yi_Syllables}', "");
    Expect(1, 42128, '\P{ Is_yi_Syllables}', "");
    Expect(0, 42128, '\P{^ Is_yi_Syllables}', "");
    Error('\p{:=_-in_yi_syllables}');
    Error('\P{:=_-in_yi_syllables}');
    Expect(1, 42127, '\p{inyisyllables}', "");
    Expect(0, 42127, '\p{^inyisyllables}', "");
    Expect(0, 42127, '\P{inyisyllables}', "");
    Expect(1, 42127, '\P{^inyisyllables}', "");
    Expect(0, 42128, '\p{inyisyllables}', "");
    Expect(1, 42128, '\p{^inyisyllables}', "");
    Expect(1, 42128, '\P{inyisyllables}', "");
    Expect(0, 42128, '\P{^inyisyllables}', "");
    Expect(1, 42127, '\p{ in_YI_syllables}', "");
    Expect(0, 42127, '\p{^ in_YI_syllables}', "");
    Expect(0, 42127, '\P{ in_YI_syllables}', "");
    Expect(1, 42127, '\P{^ in_YI_syllables}', "");
    Expect(0, 42128, '\p{ in_YI_syllables}', "");
    Expect(1, 42128, '\p{^ in_YI_syllables}', "");
    Expect(1, 42128, '\P{ in_YI_syllables}', "");
    Expect(0, 42128, '\P{^ in_YI_syllables}', "");
    Error('\p{:=  YIJING_Hexagram_Symbols}');
    Error('\P{:=  YIJING_Hexagram_Symbols}');
    Expect(1, 19967, '\p{yijinghexagramsymbols}', "");
    Expect(0, 19967, '\p{^yijinghexagramsymbols}', "");
    Expect(0, 19967, '\P{yijinghexagramsymbols}', "");
    Expect(1, 19967, '\P{^yijinghexagramsymbols}', "");
    Expect(0, 19968, '\p{yijinghexagramsymbols}', "");
    Expect(1, 19968, '\p{^yijinghexagramsymbols}', "");
    Expect(1, 19968, '\P{yijinghexagramsymbols}', "");
    Expect(0, 19968, '\P{^yijinghexagramsymbols}', "");
    Expect(1, 19967, '\p{ _yijing_hexagram_symbols}', "");
    Expect(0, 19967, '\p{^ _yijing_hexagram_symbols}', "");
    Expect(0, 19967, '\P{ _yijing_hexagram_symbols}', "");
    Expect(1, 19967, '\P{^ _yijing_hexagram_symbols}', "");
    Expect(0, 19968, '\p{ _yijing_hexagram_symbols}', "");
    Expect(1, 19968, '\p{^ _yijing_hexagram_symbols}', "");
    Expect(1, 19968, '\P{ _yijing_hexagram_symbols}', "");
    Expect(0, 19968, '\P{^ _yijing_hexagram_symbols}', "");
    Error('\p{/a/_is_yijing_HEXAGRAM_symbols}');
    Error('\P{/a/_is_yijing_HEXAGRAM_symbols}');
    Expect(1, 19967, '\p{isyijinghexagramsymbols}', "");
    Expect(0, 19967, '\p{^isyijinghexagramsymbols}', "");
    Expect(0, 19967, '\P{isyijinghexagramsymbols}', "");
    Expect(1, 19967, '\P{^isyijinghexagramsymbols}', "");
    Expect(0, 19968, '\p{isyijinghexagramsymbols}', "");
    Expect(1, 19968, '\p{^isyijinghexagramsymbols}', "");
    Expect(1, 19968, '\P{isyijinghexagramsymbols}', "");
    Expect(0, 19968, '\P{^isyijinghexagramsymbols}', "");
    Expect(1, 19967, '\p{_	Is_Yijing_Hexagram_Symbols}', "");
    Expect(0, 19967, '\p{^_	Is_Yijing_Hexagram_Symbols}', "");
    Expect(0, 19967, '\P{_	Is_Yijing_Hexagram_Symbols}', "");
    Expect(1, 19967, '\P{^_	Is_Yijing_Hexagram_Symbols}', "");
    Expect(0, 19968, '\p{_	Is_Yijing_Hexagram_Symbols}', "");
    Expect(1, 19968, '\p{^_	Is_Yijing_Hexagram_Symbols}', "");
    Expect(1, 19968, '\P{_	Is_Yijing_Hexagram_Symbols}', "");
    Expect(0, 19968, '\P{^_	Is_Yijing_Hexagram_Symbols}', "");
    Error('\p{_/a/IN_Yijing_Hexagram_Symbols}');
    Error('\P{_/a/IN_Yijing_Hexagram_Symbols}');
    Expect(1, 19967, '\p{inyijinghexagramsymbols}', "");
    Expect(0, 19967, '\p{^inyijinghexagramsymbols}', "");
    Expect(0, 19967, '\P{inyijinghexagramsymbols}', "");
    Expect(1, 19967, '\P{^inyijinghexagramsymbols}', "");
    Expect(0, 19968, '\p{inyijinghexagramsymbols}', "");
    Expect(1, 19968, '\p{^inyijinghexagramsymbols}', "");
    Expect(1, 19968, '\P{inyijinghexagramsymbols}', "");
    Expect(0, 19968, '\P{^inyijinghexagramsymbols}', "");
    Expect(1, 19967, '\p{_-In_Yijing_hexagram_Symbols}', "");
    Expect(0, 19967, '\p{^_-In_Yijing_hexagram_Symbols}', "");
    Expect(0, 19967, '\P{_-In_Yijing_hexagram_Symbols}', "");
    Expect(1, 19967, '\P{^_-In_Yijing_hexagram_Symbols}', "");
    Expect(0, 19968, '\p{_-In_Yijing_hexagram_Symbols}', "");
    Expect(1, 19968, '\p{^_-In_Yijing_hexagram_Symbols}', "");
    Expect(1, 19968, '\P{_-In_Yijing_hexagram_Symbols}', "");
    Expect(0, 19968, '\P{^_-In_Yijing_hexagram_Symbols}', "");
    Error('\p{:=- Yijing}');
    Error('\P{:=- Yijing}');
    Expect(1, 19967, '\p{yijing}', "");
    Expect(0, 19967, '\p{^yijing}', "");
    Expect(0, 19967, '\P{yijing}', "");
    Expect(1, 19967, '\P{^yijing}', "");
    Expect(0, 19968, '\p{yijing}', "");
    Expect(1, 19968, '\p{^yijing}', "");
    Expect(1, 19968, '\P{yijing}', "");
    Expect(0, 19968, '\P{^yijing}', "");
    Expect(1, 19967, '\p{--YIJING}', "");
    Expect(0, 19967, '\p{^--YIJING}', "");
    Expect(0, 19967, '\P{--YIJING}', "");
    Expect(1, 19967, '\P{^--YIJING}', "");
    Expect(0, 19968, '\p{--YIJING}', "");
    Expect(1, 19968, '\p{^--YIJING}', "");
    Expect(1, 19968, '\P{--YIJING}', "");
    Expect(0, 19968, '\P{^--YIJING}', "");
    Error('\p{_:=IS_Yijing}');
    Error('\P{_:=IS_Yijing}');
    Expect(1, 19967, '\p{isyijing}', "");
    Expect(0, 19967, '\p{^isyijing}', "");
    Expect(0, 19967, '\P{isyijing}', "");
    Expect(1, 19967, '\P{^isyijing}', "");
    Expect(0, 19968, '\p{isyijing}', "");
    Expect(1, 19968, '\p{^isyijing}', "");
    Expect(1, 19968, '\P{isyijing}', "");
    Expect(0, 19968, '\P{^isyijing}', "");
    Expect(1, 19967, '\p{		Is_yijing}', "");
    Expect(0, 19967, '\p{^		Is_yijing}', "");
    Expect(0, 19967, '\P{		Is_yijing}', "");
    Expect(1, 19967, '\P{^		Is_yijing}', "");
    Expect(0, 19968, '\p{		Is_yijing}', "");
    Expect(1, 19968, '\p{^		Is_yijing}', "");
    Expect(1, 19968, '\P{		Is_yijing}', "");
    Expect(0, 19968, '\P{^		Is_yijing}', "");
    Error('\p{:=in_Yijing}');
    Error('\P{:=in_Yijing}');
    Expect(1, 19967, '\p{inyijing}', "");
    Expect(0, 19967, '\p{^inyijing}', "");
    Expect(0, 19967, '\P{inyijing}', "");
    Expect(1, 19967, '\P{^inyijing}', "");
    Expect(0, 19968, '\p{inyijing}', "");
    Expect(1, 19968, '\p{^inyijing}', "");
    Expect(1, 19968, '\P{inyijing}', "");
    Expect(0, 19968, '\P{^inyijing}', "");
    Expect(1, 19967, '\p{ In_YIJING}', "");
    Expect(0, 19967, '\p{^ In_YIJING}', "");
    Expect(0, 19967, '\P{ In_YIJING}', "");
    Expect(1, 19967, '\P{^ In_YIJING}', "");
    Expect(0, 19968, '\p{ In_YIJING}', "");
    Expect(1, 19968, '\p{^ In_YIJING}', "");
    Expect(1, 19968, '\P{ In_YIJING}', "");
    Expect(0, 19968, '\P{^ In_YIJING}', "");
    Error('\p{ zanabazar_square:=}');
    Error('\P{ zanabazar_square:=}');
    Expect(1, 72263, '\p{zanabazarsquare}', "");
    Expect(0, 72263, '\p{^zanabazarsquare}', "");
    Expect(0, 72263, '\P{zanabazarsquare}', "");
    Expect(1, 72263, '\P{^zanabazarsquare}', "");
    Expect(0, 72264, '\p{zanabazarsquare}', "");
    Expect(1, 72264, '\p{^zanabazarsquare}', "");
    Expect(1, 72264, '\P{zanabazarsquare}', "");
    Expect(0, 72264, '\P{^zanabazarsquare}', "");
    Expect(1, 72263, '\p{ Zanabazar_Square}', "");
    Expect(0, 72263, '\p{^ Zanabazar_Square}', "");
    Expect(0, 72263, '\P{ Zanabazar_Square}', "");
    Expect(1, 72263, '\P{^ Zanabazar_Square}', "");
    Expect(0, 72264, '\p{ Zanabazar_Square}', "");
    Expect(1, 72264, '\p{^ Zanabazar_Square}', "");
    Expect(1, 72264, '\P{ Zanabazar_Square}', "");
    Expect(0, 72264, '\P{^ Zanabazar_Square}', "");
    Error('\p{- Is_zanabazar_Square:=}');
    Error('\P{- Is_zanabazar_Square:=}');
    Expect(1, 72263, '\p{iszanabazarsquare}', "");
    Expect(0, 72263, '\p{^iszanabazarsquare}', "");
    Expect(0, 72263, '\P{iszanabazarsquare}', "");
    Expect(1, 72263, '\P{^iszanabazarsquare}', "");
    Expect(0, 72264, '\p{iszanabazarsquare}', "");
    Expect(1, 72264, '\p{^iszanabazarsquare}', "");
    Expect(1, 72264, '\P{iszanabazarsquare}', "");
    Expect(0, 72264, '\P{^iszanabazarsquare}', "");
    Expect(1, 72263, '\p{-	is_zanabazar_square}', "");
    Expect(0, 72263, '\p{^-	is_zanabazar_square}', "");
    Expect(0, 72263, '\P{-	is_zanabazar_square}', "");
    Expect(1, 72263, '\P{^-	is_zanabazar_square}', "");
    Expect(0, 72264, '\p{-	is_zanabazar_square}', "");
    Expect(1, 72264, '\p{^-	is_zanabazar_square}', "");
    Expect(1, 72264, '\P{-	is_zanabazar_square}', "");
    Expect(0, 72264, '\P{^-	is_zanabazar_square}', "");
    Error('\p{_/a/Zanb}');
    Error('\P{_/a/Zanb}');
    Expect(1, 72263, '\p{zanb}', "");
    Expect(0, 72263, '\p{^zanb}', "");
    Expect(0, 72263, '\P{zanb}', "");
    Expect(1, 72263, '\P{^zanb}', "");
    Expect(0, 72264, '\p{zanb}', "");
    Expect(1, 72264, '\p{^zanb}', "");
    Expect(1, 72264, '\P{zanb}', "");
    Expect(0, 72264, '\P{^zanb}', "");
    Expect(1, 72263, '\p{- ZANB}', "");
    Expect(0, 72263, '\p{^- ZANB}', "");
    Expect(0, 72263, '\P{- ZANB}', "");
    Expect(1, 72263, '\P{^- ZANB}', "");
    Expect(0, 72264, '\p{- ZANB}', "");
    Expect(1, 72264, '\p{^- ZANB}', "");
    Expect(1, 72264, '\P{- ZANB}', "");
    Expect(0, 72264, '\P{^- ZANB}', "");
    Error('\p{	/a/Is_Zanb}');
    Error('\P{	/a/Is_Zanb}');
    Expect(1, 72263, '\p{iszanb}', "");
    Expect(0, 72263, '\p{^iszanb}', "");
    Expect(0, 72263, '\P{iszanb}', "");
    Expect(1, 72263, '\P{^iszanb}', "");
    Expect(0, 72264, '\p{iszanb}', "");
    Expect(1, 72264, '\p{^iszanb}', "");
    Expect(1, 72264, '\P{iszanb}', "");
    Expect(0, 72264, '\P{^iszanb}', "");
    Expect(1, 72263, '\p{-is_zanb}', "");
    Expect(0, 72263, '\p{^-is_zanb}', "");
    Expect(0, 72263, '\P{-is_zanb}', "");
    Expect(1, 72263, '\P{^-is_zanb}', "");
    Expect(0, 72264, '\p{-is_zanb}', "");
    Expect(1, 72264, '\p{^-is_zanb}', "");
    Expect(1, 72264, '\P{-is_zanb}', "");
    Expect(0, 72264, '\P{^-is_zanb}', "");
    Error('\p{perlcharnames}');
    Error('\P{perlcharnames}');
    Error('\p{perldecimaldigit}');
    Error('\P{perldecimaldigit}');
    Error('\p{perldecompositionmapping}');
    Error('\P{perldecompositionmapping}');
    Error('\p{Quotation_Mark=-/a/no}');
    Error('\P{Quotation_Mark=-/a/no}');
    Expect(1, 65380, '\p{Quotation_Mark=:\ANo\z:}', "");;
    Expect(0, 65379, '\p{Quotation_Mark=:\ANo\z:}', "");;
    Expect(1, 65380, '\p{Quotation_Mark=no}', "");
    Expect(0, 65380, '\p{^Quotation_Mark=no}', "");
    Expect(0, 65380, '\P{Quotation_Mark=no}', "");
    Expect(1, 65380, '\P{^Quotation_Mark=no}', "");
    Expect(0, 65379, '\p{Quotation_Mark=no}', "");
    Expect(1, 65379, '\p{^Quotation_Mark=no}', "");
    Expect(1, 65379, '\P{Quotation_Mark=no}', "");
    Expect(0, 65379, '\P{^Quotation_Mark=no}', "");
    Expect(1, 65380, '\p{Quotation_Mark=:\Ano\z:}', "");;
    Expect(0, 65379, '\p{Quotation_Mark=:\Ano\z:}', "");;
    Expect(1, 65380, '\p{Quotation_Mark=- No}', "");
    Expect(0, 65380, '\p{^Quotation_Mark=- No}', "");
    Expect(0, 65380, '\P{Quotation_Mark=- No}', "");
    Expect(1, 65380, '\P{^Quotation_Mark=- No}', "");
    Expect(0, 65379, '\p{Quotation_Mark=- No}', "");
    Expect(1, 65379, '\p{^Quotation_Mark=- No}', "");
    Expect(1, 65379, '\P{Quotation_Mark=- No}', "");
    Expect(0, 65379, '\P{^Quotation_Mark=- No}', "");
    Error('\p{QMark:	:=n}');
    Error('\P{QMark:	:=n}');
    Expect(1, 65380, '\p{QMark=:\AN\z:}', "");;
    Expect(0, 65379, '\p{QMark=:\AN\z:}', "");;
    Expect(1, 65380, '\p{QMark=n}', "");
    Expect(0, 65380, '\p{^QMark=n}', "");
    Expect(0, 65380, '\P{QMark=n}', "");
    Expect(1, 65380, '\P{^QMark=n}', "");
    Expect(0, 65379, '\p{QMark=n}', "");
    Expect(1, 65379, '\p{^QMark=n}', "");
    Expect(1, 65379, '\P{QMark=n}', "");
    Expect(0, 65379, '\P{^QMark=n}', "");
    Expect(1, 65380, '\p{QMark=:\An\z:}', "");;
    Expect(0, 65379, '\p{QMark=:\An\z:}', "");;
    Expect(1, 65380, '\p{QMark= -N}', "");
    Expect(0, 65380, '\p{^QMark= -N}', "");
    Expect(0, 65380, '\P{QMark= -N}', "");
    Expect(1, 65380, '\P{^QMark= -N}', "");
    Expect(0, 65379, '\p{QMark= -N}', "");
    Expect(1, 65379, '\p{^QMark= -N}', "");
    Expect(1, 65379, '\P{QMark= -N}', "");
    Expect(0, 65379, '\P{^QMark= -N}', "");
    Error('\p{Is_Quotation_Mark=_:=F}');
    Error('\P{Is_Quotation_Mark=_:=F}');
    Expect(1, 65380, '\p{Is_Quotation_Mark=f}', "");
    Expect(0, 65380, '\p{^Is_Quotation_Mark=f}', "");
    Expect(0, 65380, '\P{Is_Quotation_Mark=f}', "");
    Expect(1, 65380, '\P{^Is_Quotation_Mark=f}', "");
    Expect(0, 65379, '\p{Is_Quotation_Mark=f}', "");
    Expect(1, 65379, '\p{^Is_Quotation_Mark=f}', "");
    Expect(1, 65379, '\P{Is_Quotation_Mark=f}', "");
    Expect(0, 65379, '\P{^Is_Quotation_Mark=f}', "");
    Expect(1, 65380, '\p{Is_Quotation_Mark=_F}', "");
    Expect(0, 65380, '\p{^Is_Quotation_Mark=_F}', "");
    Expect(0, 65380, '\P{Is_Quotation_Mark=_F}', "");
    Expect(1, 65380, '\P{^Is_Quotation_Mark=_F}', "");
    Expect(0, 65379, '\p{Is_Quotation_Mark=_F}', "");
    Expect(1, 65379, '\p{^Is_Quotation_Mark=_F}', "");
    Expect(1, 65379, '\P{Is_Quotation_Mark=_F}', "");
    Expect(0, 65379, '\P{^Is_Quotation_Mark=_F}', "");
    Error('\p{Is_QMark=-False:=}');
    Error('\P{Is_QMark=-False:=}');
    Expect(1, 65380, '\p{Is_QMark=false}', "");
    Expect(0, 65380, '\p{^Is_QMark=false}', "");
    Expect(0, 65380, '\P{Is_QMark=false}', "");
    Expect(1, 65380, '\P{^Is_QMark=false}', "");
    Expect(0, 65379, '\p{Is_QMark=false}', "");
    Expect(1, 65379, '\p{^Is_QMark=false}', "");
    Expect(1, 65379, '\P{Is_QMark=false}', "");
    Expect(0, 65379, '\P{^Is_QMark=false}', "");
    Expect(1, 65380, '\p{Is_QMark= _FALSE}', "");
    Expect(0, 65380, '\p{^Is_QMark= _FALSE}', "");
    Expect(0, 65380, '\P{Is_QMark= _FALSE}', "");
    Expect(1, 65380, '\P{^Is_QMark= _FALSE}', "");
    Expect(0, 65379, '\p{Is_QMark= _FALSE}', "");
    Expect(1, 65379, '\p{^Is_QMark= _FALSE}', "");
    Expect(1, 65379, '\P{Is_QMark= _FALSE}', "");
    Expect(0, 65379, '\P{^Is_QMark= _FALSE}', "");
    Error('\p{Quotation_Mark=-yes:=}');
    Error('\P{Quotation_Mark=-yes:=}');
    Expect(1, 65379, '\p{Quotation_Mark=:\AYes\z:}', "");;
    Expect(0, 65380, '\p{Quotation_Mark=:\AYes\z:}', "");;
    Expect(1, 65379, '\p{Quotation_Mark=yes}', "");
    Expect(0, 65379, '\p{^Quotation_Mark=yes}', "");
    Expect(0, 65379, '\P{Quotation_Mark=yes}', "");
    Expect(1, 65379, '\P{^Quotation_Mark=yes}', "");
    Expect(0, 65380, '\p{Quotation_Mark=yes}', "");
    Expect(1, 65380, '\p{^Quotation_Mark=yes}', "");
    Expect(1, 65380, '\P{Quotation_Mark=yes}', "");
    Expect(0, 65380, '\P{^Quotation_Mark=yes}', "");
    Expect(1, 65379, '\p{Quotation_Mark=:\Ayes\z:}', "");;
    Expect(0, 65380, '\p{Quotation_Mark=:\Ayes\z:}', "");;
    Expect(1, 65379, '\p{Quotation_Mark=- yes}', "");
    Expect(0, 65379, '\p{^Quotation_Mark=- yes}', "");
    Expect(0, 65379, '\P{Quotation_Mark=- yes}', "");
    Expect(1, 65379, '\P{^Quotation_Mark=- yes}', "");
    Expect(0, 65380, '\p{Quotation_Mark=- yes}', "");
    Expect(1, 65380, '\p{^Quotation_Mark=- yes}', "");
    Expect(1, 65380, '\P{Quotation_Mark=- yes}', "");
    Expect(0, 65380, '\P{^Quotation_Mark=- yes}', "");
    Error('\p{QMark=_Y:=}');
    Error('\P{QMark=_Y:=}');
    Expect(1, 65379, '\p{QMark=:\AY\z:}', "");;
    Expect(0, 65380, '\p{QMark=:\AY\z:}', "");;
    Expect(1, 65379, '\p{QMark: y}', "");
    Expect(0, 65379, '\p{^QMark: y}', "");
    Expect(0, 65379, '\P{QMark: y}', "");
    Expect(1, 65379, '\P{^QMark: y}', "");
    Expect(0, 65380, '\p{QMark: y}', "");
    Expect(1, 65380, '\p{^QMark: y}', "");
    Expect(1, 65380, '\P{QMark: y}', "");
    Expect(0, 65380, '\P{^QMark: y}', "");
    Expect(1, 65379, '\p{QMark=:\Ay\z:}', "");;
    Expect(0, 65380, '\p{QMark=:\Ay\z:}', "");;
    Expect(1, 65379, '\p{QMark=--Y}', "");
    Expect(0, 65379, '\p{^QMark=--Y}', "");
    Expect(0, 65379, '\P{QMark=--Y}', "");
    Expect(1, 65379, '\P{^QMark=--Y}', "");
    Expect(0, 65380, '\p{QMark=--Y}', "");
    Expect(1, 65380, '\p{^QMark=--Y}', "");
    Expect(1, 65380, '\P{QMark=--Y}', "");
    Expect(0, 65380, '\P{^QMark=--Y}', "");
    Error('\p{Is_Quotation_Mark=:=- T}');
    Error('\P{Is_Quotation_Mark=:=- T}');
    Expect(1, 65379, '\p{Is_Quotation_Mark=t}', "");
    Expect(0, 65379, '\p{^Is_Quotation_Mark=t}', "");
    Expect(0, 65379, '\P{Is_Quotation_Mark=t}', "");
    Expect(1, 65379, '\P{^Is_Quotation_Mark=t}', "");
    Expect(0, 65380, '\p{Is_Quotation_Mark=t}', "");
    Expect(1, 65380, '\p{^Is_Quotation_Mark=t}', "");
    Expect(1, 65380, '\P{Is_Quotation_Mark=t}', "");
    Expect(0, 65380, '\P{^Is_Quotation_Mark=t}', "");
    Expect(1, 65379, '\p{Is_Quotation_Mark= _t}', "");
    Expect(0, 65379, '\p{^Is_Quotation_Mark= _t}', "");
    Expect(0, 65379, '\P{Is_Quotation_Mark= _t}', "");
    Expect(1, 65379, '\P{^Is_Quotation_Mark= _t}', "");
    Expect(0, 65380, '\p{Is_Quotation_Mark= _t}', "");
    Expect(1, 65380, '\p{^Is_Quotation_Mark= _t}', "");
    Expect(1, 65380, '\P{Is_Quotation_Mark= _t}', "");
    Expect(0, 65380, '\P{^Is_Quotation_Mark= _t}', "");
    Error('\p{Is_QMark=	-true:=}');
    Error('\P{Is_QMark=	-true:=}');
    Expect(1, 65379, '\p{Is_QMark=true}', "");
    Expect(0, 65379, '\p{^Is_QMark=true}', "");
    Expect(0, 65379, '\P{Is_QMark=true}', "");
    Expect(1, 65379, '\P{^Is_QMark=true}', "");
    Expect(0, 65380, '\p{Is_QMark=true}', "");
    Expect(1, 65380, '\p{^Is_QMark=true}', "");
    Expect(1, 65380, '\P{Is_QMark=true}', "");
    Expect(0, 65380, '\P{^Is_QMark=true}', "");
    Expect(1, 65379, '\p{Is_QMark=		TRUE}', "");
    Expect(0, 65379, '\p{^Is_QMark=		TRUE}', "");
    Expect(0, 65379, '\P{Is_QMark=		TRUE}', "");
    Expect(1, 65379, '\P{^Is_QMark=		TRUE}', "");
    Expect(0, 65380, '\p{Is_QMark=		TRUE}', "");
    Expect(1, 65380, '\p{^Is_QMark=		TRUE}', "");
    Expect(1, 65380, '\P{Is_QMark=		TRUE}', "");
    Expect(0, 65380, '\P{^Is_QMark=		TRUE}', "");
    Error('\p{Radical=  No/a/}');
    Error('\P{Radical=  No/a/}');
    Expect(1, 12246, '\p{Radical=:\ANo\z:}', "");;
    Expect(0, 12245, '\p{Radical=:\ANo\z:}', "");;
    Expect(1, 12246, '\p{Radical=no}', "");
    Expect(0, 12246, '\p{^Radical=no}', "");
    Expect(0, 12246, '\P{Radical=no}', "");
    Expect(1, 12246, '\P{^Radical=no}', "");
    Expect(0, 12245, '\p{Radical=no}', "");
    Expect(1, 12245, '\p{^Radical=no}', "");
    Expect(1, 12245, '\P{Radical=no}', "");
    Expect(0, 12245, '\P{^Radical=no}', "");
    Expect(1, 12246, '\p{Radical=:\Ano\z:}', "");;
    Expect(0, 12245, '\p{Radical=:\Ano\z:}', "");;
    Expect(1, 12246, '\p{Radical=-_No}', "");
    Expect(0, 12246, '\p{^Radical=-_No}', "");
    Expect(0, 12246, '\P{Radical=-_No}', "");
    Expect(1, 12246, '\P{^Radical=-_No}', "");
    Expect(0, 12245, '\p{Radical=-_No}', "");
    Expect(1, 12245, '\p{^Radical=-_No}', "");
    Expect(1, 12245, '\P{Radical=-_No}', "");
    Expect(0, 12245, '\P{^Radical=-_No}', "");
    Error('\p{Is_Radical=:=N}');
    Error('\P{Is_Radical=:=N}');
    Expect(1, 12246, '\p{Is_Radical: n}', "");
    Expect(0, 12246, '\p{^Is_Radical: n}', "");
    Expect(0, 12246, '\P{Is_Radical: n}', "");
    Expect(1, 12246, '\P{^Is_Radical: n}', "");
    Expect(0, 12245, '\p{Is_Radical: n}', "");
    Expect(1, 12245, '\p{^Is_Radical: n}', "");
    Expect(1, 12245, '\P{Is_Radical: n}', "");
    Expect(0, 12245, '\P{^Is_Radical: n}', "");
    Expect(1, 12246, '\p{Is_Radical=_N}', "");
    Expect(0, 12246, '\p{^Is_Radical=_N}', "");
    Expect(0, 12246, '\P{Is_Radical=_N}', "");
    Expect(1, 12246, '\P{^Is_Radical=_N}', "");
    Expect(0, 12245, '\p{Is_Radical=_N}', "");
    Expect(1, 12245, '\p{^Is_Radical=_N}', "");
    Expect(1, 12245, '\P{Is_Radical=_N}', "");
    Expect(0, 12245, '\P{^Is_Radical=_N}', "");
    Error('\p{Radical=/a/  f}');
    Error('\P{Radical=/a/  f}');
    Expect(1, 12246, '\p{Radical=:\AF\z:}', "");;
    Expect(0, 12245, '\p{Radical=:\AF\z:}', "");;
    Expect(1, 12246, '\p{Radical=f}', "");
    Expect(0, 12246, '\p{^Radical=f}', "");
    Expect(0, 12246, '\P{Radical=f}', "");
    Expect(1, 12246, '\P{^Radical=f}', "");
    Expect(0, 12245, '\p{Radical=f}', "");
    Expect(1, 12245, '\p{^Radical=f}', "");
    Expect(1, 12245, '\P{Radical=f}', "");
    Expect(0, 12245, '\P{^Radical=f}', "");
    Expect(1, 12246, '\p{Radical=:\Af\z:}', "");;
    Expect(0, 12245, '\p{Radical=:\Af\z:}', "");;
    Expect(1, 12246, '\p{Radical= _F}', "");
    Expect(0, 12246, '\p{^Radical= _F}', "");
    Expect(0, 12246, '\P{Radical= _F}', "");
    Expect(1, 12246, '\P{^Radical= _F}', "");
    Expect(0, 12245, '\p{Radical= _F}', "");
    Expect(1, 12245, '\p{^Radical= _F}', "");
    Expect(1, 12245, '\P{Radical= _F}', "");
    Expect(0, 12245, '\P{^Radical= _F}', "");
    Error('\p{Is_Radical=-false/a/}');
    Error('\P{Is_Radical=-false/a/}');
    Expect(1, 12246, '\p{Is_Radical=false}', "");
    Expect(0, 12246, '\p{^Is_Radical=false}', "");
    Expect(0, 12246, '\P{Is_Radical=false}', "");
    Expect(1, 12246, '\P{^Is_Radical=false}', "");
    Expect(0, 12245, '\p{Is_Radical=false}', "");
    Expect(1, 12245, '\p{^Is_Radical=false}', "");
    Expect(1, 12245, '\P{Is_Radical=false}', "");
    Expect(0, 12245, '\P{^Is_Radical=false}', "");
    Expect(1, 12246, '\p{Is_Radical=- FALSE}', "");
    Expect(0, 12246, '\p{^Is_Radical=- FALSE}', "");
    Expect(0, 12246, '\P{Is_Radical=- FALSE}', "");
    Expect(1, 12246, '\P{^Is_Radical=- FALSE}', "");
    Expect(0, 12245, '\p{Is_Radical=- FALSE}', "");
    Expect(1, 12245, '\p{^Is_Radical=- FALSE}', "");
    Expect(1, 12245, '\P{Is_Radical=- FALSE}', "");
    Expect(0, 12245, '\P{^Is_Radical=- FALSE}', "");
    Error('\p{Radical=--Yes/a/}');
    Error('\P{Radical=--Yes/a/}');
    Expect(1, 12245, '\p{Radical=:\AYes\z:}', "");;
    Expect(0, 12246, '\p{Radical=:\AYes\z:}', "");;
    Expect(1, 12245, '\p{Radical=yes}', "");
    Expect(0, 12245, '\p{^Radical=yes}', "");
    Expect(0, 12245, '\P{Radical=yes}', "");
    Expect(1, 12245, '\P{^Radical=yes}', "");
    Expect(0, 12246, '\p{Radical=yes}', "");
    Expect(1, 12246, '\p{^Radical=yes}', "");
    Expect(1, 12246, '\P{Radical=yes}', "");
    Expect(0, 12246, '\P{^Radical=yes}', "");
    Expect(1, 12245, '\p{Radical=:\Ayes\z:}', "");;
    Expect(0, 12246, '\p{Radical=:\Ayes\z:}', "");;
    Expect(1, 12245, '\p{Radical= -YES}', "");
    Expect(0, 12245, '\p{^Radical= -YES}', "");
    Expect(0, 12245, '\P{Radical= -YES}', "");
    Expect(1, 12245, '\P{^Radical= -YES}', "");
    Expect(0, 12246, '\p{Radical= -YES}', "");
    Expect(1, 12246, '\p{^Radical= -YES}', "");
    Expect(1, 12246, '\P{Radical= -YES}', "");
    Expect(0, 12246, '\P{^Radical= -YES}', "");
    Error('\p{Is_Radical=--Y/a/}');
    Error('\P{Is_Radical=--Y/a/}');
    Expect(1, 12245, '\p{Is_Radical=y}', "");
    Expect(0, 12245, '\p{^Is_Radical=y}', "");
    Expect(0, 12245, '\P{Is_Radical=y}', "");
    Expect(1, 12245, '\P{^Is_Radical=y}', "");
    Expect(0, 12246, '\p{Is_Radical=y}', "");
    Expect(1, 12246, '\p{^Is_Radical=y}', "");
    Expect(1, 12246, '\P{Is_Radical=y}', "");
    Expect(0, 12246, '\P{^Is_Radical=y}', "");
    Expect(1, 12245, '\p{Is_Radical=-Y}', "");
    Expect(0, 12245, '\p{^Is_Radical=-Y}', "");
    Expect(0, 12245, '\P{Is_Radical=-Y}', "");
    Expect(1, 12245, '\P{^Is_Radical=-Y}', "");
    Expect(0, 12246, '\p{Is_Radical=-Y}', "");
    Expect(1, 12246, '\p{^Is_Radical=-Y}', "");
    Expect(1, 12246, '\P{Is_Radical=-Y}', "");
    Expect(0, 12246, '\P{^Is_Radical=-Y}', "");
    Error('\p{Radical:	/a/	_T}');
    Error('\P{Radical:	/a/	_T}');
    Expect(1, 12245, '\p{Radical=:\AT\z:}', "");;
    Expect(0, 12246, '\p{Radical=:\AT\z:}', "");;
    Expect(1, 12245, '\p{Radical=t}', "");
    Expect(0, 12245, '\p{^Radical=t}', "");
    Expect(0, 12245, '\P{Radical=t}', "");
    Expect(1, 12245, '\P{^Radical=t}', "");
    Expect(0, 12246, '\p{Radical=t}', "");
    Expect(1, 12246, '\p{^Radical=t}', "");
    Expect(1, 12246, '\P{Radical=t}', "");
    Expect(0, 12246, '\P{^Radical=t}', "");
    Expect(1, 12245, '\p{Radical=:\At\z:}', "");;
    Expect(0, 12246, '\p{Radical=:\At\z:}', "");;
    Expect(1, 12245, '\p{Radical=  T}', "");
    Expect(0, 12245, '\p{^Radical=  T}', "");
    Expect(0, 12245, '\P{Radical=  T}', "");
    Expect(1, 12245, '\P{^Radical=  T}', "");
    Expect(0, 12246, '\p{Radical=  T}', "");
    Expect(1, 12246, '\p{^Radical=  T}', "");
    Expect(1, 12246, '\P{Radical=  T}', "");
    Expect(0, 12246, '\P{^Radical=  T}', "");
    Error('\p{Is_Radical= TRUE/a/}');
    Error('\P{Is_Radical= TRUE/a/}');
    Expect(1, 12245, '\p{Is_Radical=true}', "");
    Expect(0, 12245, '\p{^Is_Radical=true}', "");
    Expect(0, 12245, '\P{Is_Radical=true}', "");
    Expect(1, 12245, '\P{^Is_Radical=true}', "");
    Expect(0, 12246, '\p{Is_Radical=true}', "");
    Expect(1, 12246, '\p{^Is_Radical=true}', "");
    Expect(1, 12246, '\P{Is_Radical=true}', "");
    Expect(0, 12246, '\P{^Is_Radical=true}', "");
    Expect(1, 12245, '\p{Is_Radical=_ True}', "");
    Expect(0, 12245, '\p{^Is_Radical=_ True}', "");
    Expect(0, 12245, '\P{Is_Radical=_ True}', "");
    Expect(1, 12245, '\P{^Is_Radical=_ True}', "");
    Expect(0, 12246, '\p{Is_Radical=_ True}', "");
    Expect(1, 12246, '\p{^Is_Radical=_ True}', "");
    Expect(1, 12246, '\P{Is_Radical=_ True}', "");
    Expect(0, 12246, '\P{^Is_Radical=_ True}', "");
    Error('\p{Regional_Indicator=	No/a/}');
    Error('\P{Regional_Indicator=	No/a/}');
    Expect(1, 127488, '\p{Regional_Indicator=:\ANo\z:}', "");;
    Expect(0, 127487, '\p{Regional_Indicator=:\ANo\z:}', "");;
    Expect(1, 127488, '\p{Regional_Indicator=no}', "");
    Expect(0, 127488, '\p{^Regional_Indicator=no}', "");
    Expect(0, 127488, '\P{Regional_Indicator=no}', "");
    Expect(1, 127488, '\P{^Regional_Indicator=no}', "");
    Expect(0, 127487, '\p{Regional_Indicator=no}', "");
    Expect(1, 127487, '\p{^Regional_Indicator=no}', "");
    Expect(1, 127487, '\P{Regional_Indicator=no}', "");
    Expect(0, 127487, '\P{^Regional_Indicator=no}', "");
    Expect(1, 127488, '\p{Regional_Indicator=:\Ano\z:}', "");;
    Expect(0, 127487, '\p{Regional_Indicator=:\Ano\z:}', "");;
    Expect(1, 127488, '\p{Regional_Indicator= No}', "");
    Expect(0, 127488, '\p{^Regional_Indicator= No}', "");
    Expect(0, 127488, '\P{Regional_Indicator= No}', "");
    Expect(1, 127488, '\P{^Regional_Indicator= No}', "");
    Expect(0, 127487, '\p{Regional_Indicator= No}', "");
    Expect(1, 127487, '\p{^Regional_Indicator= No}', "");
    Expect(1, 127487, '\P{Regional_Indicator= No}', "");
    Expect(0, 127487, '\P{^Regional_Indicator= No}', "");
    Error('\p{RI= _n:=}');
    Error('\P{RI= _n:=}');
    Expect(1, 127488, '\p{RI=:\AN\z:}', "");;
    Expect(0, 127487, '\p{RI=:\AN\z:}', "");;
    Expect(1, 127488, '\p{RI=n}', "");
    Expect(0, 127488, '\p{^RI=n}', "");
    Expect(0, 127488, '\P{RI=n}', "");
    Expect(1, 127488, '\P{^RI=n}', "");
    Expect(0, 127487, '\p{RI=n}', "");
    Expect(1, 127487, '\p{^RI=n}', "");
    Expect(1, 127487, '\P{RI=n}', "");
    Expect(0, 127487, '\P{^RI=n}', "");
    Expect(1, 127488, '\p{RI=:\An\z:}', "");;
    Expect(0, 127487, '\p{RI=:\An\z:}', "");;
    Expect(1, 127488, '\p{RI= -n}', "");
    Expect(0, 127488, '\p{^RI= -n}', "");
    Expect(0, 127488, '\P{RI= -n}', "");
    Expect(1, 127488, '\P{^RI= -n}', "");
    Expect(0, 127487, '\p{RI= -n}', "");
    Expect(1, 127487, '\p{^RI= -n}', "");
    Expect(1, 127487, '\P{RI= -n}', "");
    Expect(0, 127487, '\P{^RI= -n}', "");
    Error('\p{Is_Regional_Indicator=/a/_F}');
    Error('\P{Is_Regional_Indicator=/a/_F}');
    Expect(1, 127488, '\p{Is_Regional_Indicator=f}', "");
    Expect(0, 127488, '\p{^Is_Regional_Indicator=f}', "");
    Expect(0, 127488, '\P{Is_Regional_Indicator=f}', "");
    Expect(1, 127488, '\P{^Is_Regional_Indicator=f}', "");
    Expect(0, 127487, '\p{Is_Regional_Indicator=f}', "");
    Expect(1, 127487, '\p{^Is_Regional_Indicator=f}', "");
    Expect(1, 127487, '\P{Is_Regional_Indicator=f}', "");
    Expect(0, 127487, '\P{^Is_Regional_Indicator=f}', "");
    Expect(1, 127488, '\p{Is_Regional_Indicator=-	F}', "");
    Expect(0, 127488, '\p{^Is_Regional_Indicator=-	F}', "");
    Expect(0, 127488, '\P{Is_Regional_Indicator=-	F}', "");
    Expect(1, 127488, '\P{^Is_Regional_Indicator=-	F}', "");
    Expect(0, 127487, '\p{Is_Regional_Indicator=-	F}', "");
    Expect(1, 127487, '\p{^Is_Regional_Indicator=-	F}', "");
    Expect(1, 127487, '\P{Is_Regional_Indicator=-	F}', "");
    Expect(0, 127487, '\P{^Is_Regional_Indicator=-	F}', "");
    Error('\p{Is_RI=:=FALSE}');
    Error('\P{Is_RI=:=FALSE}');
    Expect(1, 127488, '\p{Is_RI:   false}', "");
    Expect(0, 127488, '\p{^Is_RI:   false}', "");
    Expect(0, 127488, '\P{Is_RI:   false}', "");
    Expect(1, 127488, '\P{^Is_RI:   false}', "");
    Expect(0, 127487, '\p{Is_RI:   false}', "");
    Expect(1, 127487, '\p{^Is_RI:   false}', "");
    Expect(1, 127487, '\P{Is_RI:   false}', "");
    Expect(0, 127487, '\P{^Is_RI:   false}', "");
    Expect(1, 127488, '\p{Is_RI=-_False}', "");
    Expect(0, 127488, '\p{^Is_RI=-_False}', "");
    Expect(0, 127488, '\P{Is_RI=-_False}', "");
    Expect(1, 127488, '\P{^Is_RI=-_False}', "");
    Expect(0, 127487, '\p{Is_RI=-_False}', "");
    Expect(1, 127487, '\p{^Is_RI=-_False}', "");
    Expect(1, 127487, '\P{Is_RI=-_False}', "");
    Expect(0, 127487, '\P{^Is_RI=-_False}', "");
    Error('\p{Regional_Indicator=:=	 yes}');
    Error('\P{Regional_Indicator=:=	 yes}');
    Expect(1, 127487, '\p{Regional_Indicator=:\AYes\z:}', "");;
    Expect(0, 127488, '\p{Regional_Indicator=:\AYes\z:}', "");;
    Expect(1, 127487, '\p{Regional_Indicator:	yes}', "");
    Expect(0, 127487, '\p{^Regional_Indicator:	yes}', "");
    Expect(0, 127487, '\P{Regional_Indicator:	yes}', "");
    Expect(1, 127487, '\P{^Regional_Indicator:	yes}', "");
    Expect(0, 127488, '\p{Regional_Indicator:	yes}', "");
    Expect(1, 127488, '\p{^Regional_Indicator:	yes}', "");
    Expect(1, 127488, '\P{Regional_Indicator:	yes}', "");
    Expect(0, 127488, '\P{^Regional_Indicator:	yes}', "");
    Expect(1, 127487, '\p{Regional_Indicator=:\Ayes\z:}', "");;
    Expect(0, 127488, '\p{Regional_Indicator=:\Ayes\z:}', "");;
    Expect(1, 127487, '\p{Regional_Indicator=-Yes}', "");
    Expect(0, 127487, '\p{^Regional_Indicator=-Yes}', "");
    Expect(0, 127487, '\P{Regional_Indicator=-Yes}', "");
    Expect(1, 127487, '\P{^Regional_Indicator=-Yes}', "");
    Expect(0, 127488, '\p{Regional_Indicator=-Yes}', "");
    Expect(1, 127488, '\p{^Regional_Indicator=-Yes}', "");
    Expect(1, 127488, '\P{Regional_Indicator=-Yes}', "");
    Expect(0, 127488, '\P{^Regional_Indicator=-Yes}', "");
    Error('\p{RI=:= 	Y}');
    Error('\P{RI=:= 	Y}');
    Expect(1, 127487, '\p{RI=:\AY\z:}', "");;
    Expect(0, 127488, '\p{RI=:\AY\z:}', "");;
    Expect(1, 127487, '\p{RI=y}', "");
    Expect(0, 127487, '\p{^RI=y}', "");
    Expect(0, 127487, '\P{RI=y}', "");
    Expect(1, 127487, '\P{^RI=y}', "");
    Expect(0, 127488, '\p{RI=y}', "");
    Expect(1, 127488, '\p{^RI=y}', "");
    Expect(1, 127488, '\P{RI=y}', "");
    Expect(0, 127488, '\P{^RI=y}', "");
    Expect(1, 127487, '\p{RI=:\Ay\z:}', "");;
    Expect(0, 127488, '\p{RI=:\Ay\z:}', "");;
    Expect(1, 127487, '\p{RI=-	y}', "");
    Expect(0, 127487, '\p{^RI=-	y}', "");
    Expect(0, 127487, '\P{RI=-	y}', "");
    Expect(1, 127487, '\P{^RI=-	y}', "");
    Expect(0, 127488, '\p{RI=-	y}', "");
    Expect(1, 127488, '\p{^RI=-	y}', "");
    Expect(1, 127488, '\P{RI=-	y}', "");
    Expect(0, 127488, '\P{^RI=-	y}', "");
    Error('\p{Is_Regional_Indicator= /a/t}');
    Error('\P{Is_Regional_Indicator= /a/t}');
    Expect(1, 127487, '\p{Is_Regional_Indicator=t}', "");
    Expect(0, 127487, '\p{^Is_Regional_Indicator=t}', "");
    Expect(0, 127487, '\P{Is_Regional_Indicator=t}', "");
    Expect(1, 127487, '\P{^Is_Regional_Indicator=t}', "");
    Expect(0, 127488, '\p{Is_Regional_Indicator=t}', "");
    Expect(1, 127488, '\p{^Is_Regional_Indicator=t}', "");
    Expect(1, 127488, '\P{Is_Regional_Indicator=t}', "");
    Expect(0, 127488, '\P{^Is_Regional_Indicator=t}', "");
    Expect(1, 127487, '\p{Is_Regional_Indicator= T}', "");
    Expect(0, 127487, '\p{^Is_Regional_Indicator= T}', "");
    Expect(0, 127487, '\P{Is_Regional_Indicator= T}', "");
    Expect(1, 127487, '\P{^Is_Regional_Indicator= T}', "");
    Expect(0, 127488, '\p{Is_Regional_Indicator= T}', "");
    Expect(1, 127488, '\p{^Is_Regional_Indicator= T}', "");
    Expect(1, 127488, '\P{Is_Regional_Indicator= T}', "");
    Expect(0, 127488, '\P{^Is_Regional_Indicator= T}', "");
    Error('\p{Is_RI=-:=True}');
    Error('\P{Is_RI=-:=True}');
    Expect(1, 127487, '\p{Is_RI=true}', "");
    Expect(0, 127487, '\p{^Is_RI=true}', "");
    Expect(0, 127487, '\P{Is_RI=true}', "");
    Expect(1, 127487, '\P{^Is_RI=true}', "");
    Expect(0, 127488, '\p{Is_RI=true}', "");
    Expect(1, 127488, '\p{^Is_RI=true}', "");
    Expect(1, 127488, '\P{Is_RI=true}', "");
    Expect(0, 127488, '\P{^Is_RI=true}', "");
    Expect(1, 127487, '\p{Is_RI=- true}', "");
    Expect(0, 127487, '\p{^Is_RI=- true}', "");
    Expect(0, 127487, '\P{Is_RI=- true}', "");
    Expect(1, 127487, '\P{^Is_RI=- true}', "");
    Expect(0, 127488, '\p{Is_RI=- true}', "");
    Expect(1, 127488, '\p{^Is_RI=- true}', "");
    Expect(1, 127488, '\P{Is_RI=- true}', "");
    Expect(0, 127488, '\P{^Is_RI=- true}', "");
    Error('\p{sentencebreak}');
    Error('\P{sentencebreak}');
    Error('\p{sb}');
    Error('\P{sb}');
    Error('\p{_perlsb}');
    Error('\P{_perlsb}');
    Error('\p{Sentence_Break: 	ATerm:=}');
    Error('\P{Sentence_Break: 	ATerm:=}');
    Expect(1, 65294, '\p{Sentence_Break=:\AATerm\z:}', "");;
    Expect(0, 65295, '\p{Sentence_Break=:\AATerm\z:}', "");;
    Expect(1, 65294, '\p{Sentence_Break=aterm}', "");
    Expect(0, 65294, '\p{^Sentence_Break=aterm}', "");
    Expect(0, 65294, '\P{Sentence_Break=aterm}', "");
    Expect(1, 65294, '\P{^Sentence_Break=aterm}', "");
    Expect(0, 65295, '\p{Sentence_Break=aterm}', "");
    Expect(1, 65295, '\p{^Sentence_Break=aterm}', "");
    Expect(1, 65295, '\P{Sentence_Break=aterm}', "");
    Expect(0, 65295, '\P{^Sentence_Break=aterm}', "");
    Expect(1, 65294, '\p{Sentence_Break=:\Aaterm\z:}', "");;
    Expect(0, 65295, '\p{Sentence_Break=:\Aaterm\z:}', "");;
    Expect(1, 65294, '\p{Sentence_Break=-_ATerm}', "");
    Expect(0, 65294, '\p{^Sentence_Break=-_ATerm}', "");
    Expect(0, 65294, '\P{Sentence_Break=-_ATerm}', "");
    Expect(1, 65294, '\P{^Sentence_Break=-_ATerm}', "");
    Expect(0, 65295, '\p{Sentence_Break=-_ATerm}', "");
    Expect(1, 65295, '\p{^Sentence_Break=-_ATerm}', "");
    Expect(1, 65295, '\P{Sentence_Break=-_ATerm}', "");
    Expect(0, 65295, '\P{^Sentence_Break=-_ATerm}', "");
    Error('\p{SB=	-AT:=}');
    Error('\P{SB=	-AT:=}');
    Expect(1, 65294, '\p{SB=:\AAT\z:}', "");;
    Expect(0, 65295, '\p{SB=:\AAT\z:}', "");;
    Expect(1, 65294, '\p{SB=at}', "");
    Expect(0, 65294, '\p{^SB=at}', "");
    Expect(0, 65294, '\P{SB=at}', "");
    Expect(1, 65294, '\P{^SB=at}', "");
    Expect(0, 65295, '\p{SB=at}', "");
    Expect(1, 65295, '\p{^SB=at}', "");
    Expect(1, 65295, '\P{SB=at}', "");
    Expect(0, 65295, '\P{^SB=at}', "");
    Expect(1, 65294, '\p{SB=:\Aat\z:}', "");;
    Expect(0, 65295, '\p{SB=:\Aat\z:}', "");;
    Expect(1, 65294, '\p{SB=__at}', "");
    Expect(0, 65294, '\p{^SB=__at}', "");
    Expect(0, 65294, '\P{SB=__at}', "");
    Expect(1, 65294, '\P{^SB=__at}', "");
    Expect(0, 65295, '\p{SB=__at}', "");
    Expect(1, 65295, '\p{^SB=__at}', "");
    Expect(1, 65295, '\P{SB=__at}', "");
    Expect(0, 65295, '\P{^SB=__at}', "");
    Error('\p{Is_Sentence_Break=/a/aterm}');
    Error('\P{Is_Sentence_Break=/a/aterm}');
    Expect(1, 65294, '\p{Is_Sentence_Break=aterm}', "");
    Expect(0, 65294, '\p{^Is_Sentence_Break=aterm}', "");
    Expect(0, 65294, '\P{Is_Sentence_Break=aterm}', "");
    Expect(1, 65294, '\P{^Is_Sentence_Break=aterm}', "");
    Expect(0, 65295, '\p{Is_Sentence_Break=aterm}', "");
    Expect(1, 65295, '\p{^Is_Sentence_Break=aterm}', "");
    Expect(1, 65295, '\P{Is_Sentence_Break=aterm}', "");
    Expect(0, 65295, '\P{^Is_Sentence_Break=aterm}', "");
    Expect(1, 65294, '\p{Is_Sentence_Break= ATERM}', "");
    Expect(0, 65294, '\p{^Is_Sentence_Break= ATERM}', "");
    Expect(0, 65294, '\P{Is_Sentence_Break= ATERM}', "");
    Expect(1, 65294, '\P{^Is_Sentence_Break= ATERM}', "");
    Expect(0, 65295, '\p{Is_Sentence_Break= ATERM}', "");
    Expect(1, 65295, '\p{^Is_Sentence_Break= ATERM}', "");
    Expect(1, 65295, '\P{Is_Sentence_Break= ATERM}', "");
    Expect(0, 65295, '\P{^Is_Sentence_Break= ATERM}', "");
    Error('\p{Is_SB=  AT/a/}');
    Error('\P{Is_SB=  AT/a/}');
    Expect(1, 65294, '\p{Is_SB=at}', "");
    Expect(0, 65294, '\p{^Is_SB=at}', "");
    Expect(0, 65294, '\P{Is_SB=at}', "");
    Expect(1, 65294, '\P{^Is_SB=at}', "");
    Expect(0, 65295, '\p{Is_SB=at}', "");
    Expect(1, 65295, '\p{^Is_SB=at}', "");
    Expect(1, 65295, '\P{Is_SB=at}', "");
    Expect(0, 65295, '\P{^Is_SB=at}', "");
    Expect(1, 65294, '\p{Is_SB=-at}', "");
    Expect(0, 65294, '\p{^Is_SB=-at}', "");
    Expect(0, 65294, '\P{Is_SB=-at}', "");
    Expect(1, 65294, '\P{^Is_SB=-at}', "");
    Expect(0, 65295, '\p{Is_SB=-at}', "");
    Expect(1, 65295, '\p{^Is_SB=-at}', "");
    Expect(1, 65295, '\P{Is_SB=-at}', "");
    Expect(0, 65295, '\P{^Is_SB=-at}', "");
    Error('\p{Sentence_Break=/a/_ close}');
    Error('\P{Sentence_Break=/a/_ close}');
    Expect(1, 128632, '\p{Sentence_Break=:\AClose\z:}', "");;
    Expect(0, 128633, '\p{Sentence_Break=:\AClose\z:}', "");;
    Expect(1, 128632, '\p{Sentence_Break=close}', "");
    Expect(0, 128632, '\p{^Sentence_Break=close}', "");
    Expect(0, 128632, '\P{Sentence_Break=close}', "");
    Expect(1, 128632, '\P{^Sentence_Break=close}', "");
    Expect(0, 128633, '\p{Sentence_Break=close}', "");
    Expect(1, 128633, '\p{^Sentence_Break=close}', "");
    Expect(1, 128633, '\P{Sentence_Break=close}', "");
    Expect(0, 128633, '\P{^Sentence_Break=close}', "");
    Expect(1, 128632, '\p{Sentence_Break=:\Aclose\z:}', "");;
    Expect(0, 128633, '\p{Sentence_Break=:\Aclose\z:}', "");;
    Expect(1, 128632, '\p{Sentence_Break:		Close}', "");
    Expect(0, 128632, '\p{^Sentence_Break:		Close}', "");
    Expect(0, 128632, '\P{Sentence_Break:		Close}', "");
    Expect(1, 128632, '\P{^Sentence_Break:		Close}', "");
    Expect(0, 128633, '\p{Sentence_Break:		Close}', "");
    Expect(1, 128633, '\p{^Sentence_Break:		Close}', "");
    Expect(1, 128633, '\P{Sentence_Break:		Close}', "");
    Expect(0, 128633, '\P{^Sentence_Break:		Close}', "");
    Error('\p{SB=-:=CL}');
    Error('\P{SB=-:=CL}');
    Expect(1, 128632, '\p{SB=:\ACL\z:}', "");;
    Expect(0, 128633, '\p{SB=:\ACL\z:}', "");;
    Expect(1, 128632, '\p{SB=cl}', "");
    Expect(0, 128632, '\p{^SB=cl}', "");
    Expect(0, 128632, '\P{SB=cl}', "");
    Expect(1, 128632, '\P{^SB=cl}', "");
    Expect(0, 128633, '\p{SB=cl}', "");
    Expect(1, 128633, '\p{^SB=cl}', "");
    Expect(1, 128633, '\P{SB=cl}', "");
    Expect(0, 128633, '\P{^SB=cl}', "");
    Expect(1, 128632, '\p{SB=:\Acl\z:}', "");;
    Expect(0, 128633, '\p{SB=:\Acl\z:}', "");;
    Expect(1, 128632, '\p{SB=-_CL}', "");
    Expect(0, 128632, '\p{^SB=-_CL}', "");
    Expect(0, 128632, '\P{SB=-_CL}', "");
    Expect(1, 128632, '\P{^SB=-_CL}', "");
    Expect(0, 128633, '\p{SB=-_CL}', "");
    Expect(1, 128633, '\p{^SB=-_CL}', "");
    Expect(1, 128633, '\P{SB=-_CL}', "");
    Expect(0, 128633, '\P{^SB=-_CL}', "");
    Error('\p{Is_Sentence_Break=-Close/a/}');
    Error('\P{Is_Sentence_Break=-Close/a/}');
    Expect(1, 128632, '\p{Is_Sentence_Break=close}', "");
    Expect(0, 128632, '\p{^Is_Sentence_Break=close}', "");
    Expect(0, 128632, '\P{Is_Sentence_Break=close}', "");
    Expect(1, 128632, '\P{^Is_Sentence_Break=close}', "");
    Expect(0, 128633, '\p{Is_Sentence_Break=close}', "");
    Expect(1, 128633, '\p{^Is_Sentence_Break=close}', "");
    Expect(1, 128633, '\P{Is_Sentence_Break=close}', "");
    Expect(0, 128633, '\P{^Is_Sentence_Break=close}', "");
    Expect(1, 128632, '\p{Is_Sentence_Break=_-close}', "");
    Expect(0, 128632, '\p{^Is_Sentence_Break=_-close}', "");
    Expect(0, 128632, '\P{Is_Sentence_Break=_-close}', "");
    Expect(1, 128632, '\P{^Is_Sentence_Break=_-close}', "");
    Expect(0, 128633, '\p{Is_Sentence_Break=_-close}', "");
    Expect(1, 128633, '\p{^Is_Sentence_Break=_-close}', "");
    Expect(1, 128633, '\P{Is_Sentence_Break=_-close}', "");
    Expect(0, 128633, '\P{^Is_Sentence_Break=_-close}', "");
    Error('\p{Is_SB=_/a/CL}');
    Error('\P{Is_SB=_/a/CL}');
    Expect(1, 128632, '\p{Is_SB=cl}', "");
    Expect(0, 128632, '\p{^Is_SB=cl}', "");
    Expect(0, 128632, '\P{Is_SB=cl}', "");
    Expect(1, 128632, '\P{^Is_SB=cl}', "");
    Expect(0, 128633, '\p{Is_SB=cl}', "");
    Expect(1, 128633, '\p{^Is_SB=cl}', "");
    Expect(1, 128633, '\P{Is_SB=cl}', "");
    Expect(0, 128633, '\P{^Is_SB=cl}', "");
    Expect(1, 128632, '\p{Is_SB= cl}', "");
    Expect(0, 128632, '\p{^Is_SB= cl}', "");
    Expect(0, 128632, '\P{Is_SB= cl}', "");
    Expect(1, 128632, '\P{^Is_SB= cl}', "");
    Expect(0, 128633, '\p{Is_SB= cl}', "");
    Expect(1, 128633, '\p{^Is_SB= cl}', "");
    Expect(1, 128633, '\P{Is_SB= cl}', "");
    Expect(0, 128633, '\P{^Is_SB= cl}', "");
    Error('\p{Sentence_Break=-	CR/a/}');
    Error('\P{Sentence_Break=-	CR/a/}');
    Expect(1, 13, '\p{Sentence_Break=:\ACR\z:}', "");;
    Expect(0, 14, '\p{Sentence_Break=:\ACR\z:}', "");;
    Expect(1, 13, '\p{Sentence_Break=cr}', "");
    Expect(0, 13, '\p{^Sentence_Break=cr}', "");
    Expect(0, 13, '\P{Sentence_Break=cr}', "");
    Expect(1, 13, '\P{^Sentence_Break=cr}', "");
    Expect(0, 14, '\p{Sentence_Break=cr}', "");
    Expect(1, 14, '\p{^Sentence_Break=cr}', "");
    Expect(1, 14, '\P{Sentence_Break=cr}', "");
    Expect(0, 14, '\P{^Sentence_Break=cr}', "");
    Expect(1, 13, '\p{Sentence_Break=:\Acr\z:}', "");;
    Expect(0, 14, '\p{Sentence_Break=:\Acr\z:}', "");;
    Expect(1, 13, '\p{Sentence_Break=-_CR}', "");
    Expect(0, 13, '\p{^Sentence_Break=-_CR}', "");
    Expect(0, 13, '\P{Sentence_Break=-_CR}', "");
    Expect(1, 13, '\P{^Sentence_Break=-_CR}', "");
    Expect(0, 14, '\p{Sentence_Break=-_CR}', "");
    Expect(1, 14, '\p{^Sentence_Break=-_CR}', "");
    Expect(1, 14, '\P{Sentence_Break=-_CR}', "");
    Expect(0, 14, '\P{^Sentence_Break=-_CR}', "");
    Error('\p{SB=CR/a/}');
    Error('\P{SB=CR/a/}');
    Expect(1, 13, '\p{SB=:\ACR\z:}', "");;
    Expect(0, 14, '\p{SB=:\ACR\z:}', "");;
    Expect(1, 13, '\p{SB: cr}', "");
    Expect(0, 13, '\p{^SB: cr}', "");
    Expect(0, 13, '\P{SB: cr}', "");
    Expect(1, 13, '\P{^SB: cr}', "");
    Expect(0, 14, '\p{SB: cr}', "");
    Expect(1, 14, '\p{^SB: cr}', "");
    Expect(1, 14, '\P{SB: cr}', "");
    Expect(0, 14, '\P{^SB: cr}', "");
    Expect(1, 13, '\p{SB=:\Acr\z:}', "");;
    Expect(0, 14, '\p{SB=:\Acr\z:}', "");;
    Expect(1, 13, '\p{SB=_cr}', "");
    Expect(0, 13, '\p{^SB=_cr}', "");
    Expect(0, 13, '\P{SB=_cr}', "");
    Expect(1, 13, '\P{^SB=_cr}', "");
    Expect(0, 14, '\p{SB=_cr}', "");
    Expect(1, 14, '\p{^SB=_cr}', "");
    Expect(1, 14, '\P{SB=_cr}', "");
    Expect(0, 14, '\P{^SB=_cr}', "");
    Error('\p{Is_Sentence_Break=/a/ 	CR}');
    Error('\P{Is_Sentence_Break=/a/ 	CR}');
    Expect(1, 13, '\p{Is_Sentence_Break=cr}', "");
    Expect(0, 13, '\p{^Is_Sentence_Break=cr}', "");
    Expect(0, 13, '\P{Is_Sentence_Break=cr}', "");
    Expect(1, 13, '\P{^Is_Sentence_Break=cr}', "");
    Expect(0, 14, '\p{Is_Sentence_Break=cr}', "");
    Expect(1, 14, '\p{^Is_Sentence_Break=cr}', "");
    Expect(1, 14, '\P{Is_Sentence_Break=cr}', "");
    Expect(0, 14, '\P{^Is_Sentence_Break=cr}', "");
    Expect(1, 13, '\p{Is_Sentence_Break=		cr}', "");
    Expect(0, 13, '\p{^Is_Sentence_Break=		cr}', "");
    Expect(0, 13, '\P{Is_Sentence_Break=		cr}', "");
    Expect(1, 13, '\P{^Is_Sentence_Break=		cr}', "");
    Expect(0, 14, '\p{Is_Sentence_Break=		cr}', "");
    Expect(1, 14, '\p{^Is_Sentence_Break=		cr}', "");
    Expect(1, 14, '\P{Is_Sentence_Break=		cr}', "");
    Expect(0, 14, '\P{^Is_Sentence_Break=		cr}', "");
    Error('\p{Is_SB=_-CR:=}');
    Error('\P{Is_SB=_-CR:=}');
    Expect(1, 13, '\p{Is_SB=cr}', "");
    Expect(0, 13, '\p{^Is_SB=cr}', "");
    Expect(0, 13, '\P{Is_SB=cr}', "");
    Expect(1, 13, '\P{^Is_SB=cr}', "");
    Expect(0, 14, '\p{Is_SB=cr}', "");
    Expect(1, 14, '\p{^Is_SB=cr}', "");
    Expect(1, 14, '\P{Is_SB=cr}', "");
    Expect(0, 14, '\P{^Is_SB=cr}', "");
    Expect(1, 13, '\p{Is_SB= 	CR}', "");
    Expect(0, 13, '\p{^Is_SB= 	CR}', "");
    Expect(0, 13, '\P{Is_SB= 	CR}', "");
    Expect(1, 13, '\P{^Is_SB= 	CR}', "");
    Expect(0, 14, '\p{Is_SB= 	CR}', "");
    Expect(1, 14, '\p{^Is_SB= 	CR}', "");
    Expect(1, 14, '\P{Is_SB= 	CR}', "");
    Expect(0, 14, '\P{^Is_SB= 	CR}', "");
    Error('\p{Sentence_Break=:= 	Extend}');
    Error('\P{Sentence_Break=:= 	Extend}');
    Expect(1, 917999, '\p{Sentence_Break=:\AExtend\z:}', "");;
    Expect(0, 918000, '\p{Sentence_Break=:\AExtend\z:}', "");;
    Expect(1, 917999, '\p{Sentence_Break:extend}', "");
    Expect(0, 917999, '\p{^Sentence_Break:extend}', "");
    Expect(0, 917999, '\P{Sentence_Break:extend}', "");
    Expect(1, 917999, '\P{^Sentence_Break:extend}', "");
    Expect(0, 918000, '\p{Sentence_Break:extend}', "");
    Expect(1, 918000, '\p{^Sentence_Break:extend}', "");
    Expect(1, 918000, '\P{Sentence_Break:extend}', "");
    Expect(0, 918000, '\P{^Sentence_Break:extend}', "");
    Expect(1, 917999, '\p{Sentence_Break=:\Aextend\z:}', "");;
    Expect(0, 918000, '\p{Sentence_Break=:\Aextend\z:}', "");;
    Expect(1, 917999, '\p{Sentence_Break=_extend}', "");
    Expect(0, 917999, '\p{^Sentence_Break=_extend}', "");
    Expect(0, 917999, '\P{Sentence_Break=_extend}', "");
    Expect(1, 917999, '\P{^Sentence_Break=_extend}', "");
    Expect(0, 918000, '\p{Sentence_Break=_extend}', "");
    Expect(1, 918000, '\p{^Sentence_Break=_extend}', "");
    Expect(1, 918000, '\P{Sentence_Break=_extend}', "");
    Expect(0, 918000, '\P{^Sentence_Break=_extend}', "");
    Error('\p{SB=/a/__ex}');
    Error('\P{SB=/a/__ex}');
    Expect(1, 917999, '\p{SB=:\AEX\z:}', "");;
    Expect(0, 918000, '\p{SB=:\AEX\z:}', "");;
    Expect(1, 917999, '\p{SB=ex}', "");
    Expect(0, 917999, '\p{^SB=ex}', "");
    Expect(0, 917999, '\P{SB=ex}', "");
    Expect(1, 917999, '\P{^SB=ex}', "");
    Expect(0, 918000, '\p{SB=ex}', "");
    Expect(1, 918000, '\p{^SB=ex}', "");
    Expect(1, 918000, '\P{SB=ex}', "");
    Expect(0, 918000, '\P{^SB=ex}', "");
    Expect(1, 917999, '\p{SB=:\Aex\z:}', "");;
    Expect(0, 918000, '\p{SB=:\Aex\z:}', "");;
    Expect(1, 917999, '\p{SB=-	EX}', "");
    Expect(0, 917999, '\p{^SB=-	EX}', "");
    Expect(0, 917999, '\P{SB=-	EX}', "");
    Expect(1, 917999, '\P{^SB=-	EX}', "");
    Expect(0, 918000, '\p{SB=-	EX}', "");
    Expect(1, 918000, '\p{^SB=-	EX}', "");
    Expect(1, 918000, '\P{SB=-	EX}', "");
    Expect(0, 918000, '\P{^SB=-	EX}', "");
    Error('\p{Is_Sentence_Break=/a/-Extend}');
    Error('\P{Is_Sentence_Break=/a/-Extend}');
    Expect(1, 917999, '\p{Is_Sentence_Break=extend}', "");
    Expect(0, 917999, '\p{^Is_Sentence_Break=extend}', "");
    Expect(0, 917999, '\P{Is_Sentence_Break=extend}', "");
    Expect(1, 917999, '\P{^Is_Sentence_Break=extend}', "");
    Expect(0, 918000, '\p{Is_Sentence_Break=extend}', "");
    Expect(1, 918000, '\p{^Is_Sentence_Break=extend}', "");
    Expect(1, 918000, '\P{Is_Sentence_Break=extend}', "");
    Expect(0, 918000, '\P{^Is_Sentence_Break=extend}', "");
    Expect(1, 917999, '\p{Is_Sentence_Break=	 EXTEND}', "");
    Expect(0, 917999, '\p{^Is_Sentence_Break=	 EXTEND}', "");
    Expect(0, 917999, '\P{Is_Sentence_Break=	 EXTEND}', "");
    Expect(1, 917999, '\P{^Is_Sentence_Break=	 EXTEND}', "");
    Expect(0, 918000, '\p{Is_Sentence_Break=	 EXTEND}', "");
    Expect(1, 918000, '\p{^Is_Sentence_Break=	 EXTEND}', "");
    Expect(1, 918000, '\P{Is_Sentence_Break=	 EXTEND}', "");
    Expect(0, 918000, '\P{^Is_Sentence_Break=	 EXTEND}', "");
    Error('\p{Is_SB=:=_EX}');
    Error('\P{Is_SB=:=_EX}');
    Expect(1, 917999, '\p{Is_SB=ex}', "");
    Expect(0, 917999, '\p{^Is_SB=ex}', "");
    Expect(0, 917999, '\P{Is_SB=ex}', "");
    Expect(1, 917999, '\P{^Is_SB=ex}', "");
    Expect(0, 918000, '\p{Is_SB=ex}', "");
    Expect(1, 918000, '\p{^Is_SB=ex}', "");
    Expect(1, 918000, '\P{Is_SB=ex}', "");
    Expect(0, 918000, '\P{^Is_SB=ex}', "");
    Expect(1, 917999, '\p{Is_SB=_	ex}', "");
    Expect(0, 917999, '\p{^Is_SB=_	ex}', "");
    Expect(0, 917999, '\P{Is_SB=_	ex}', "");
    Expect(1, 917999, '\P{^Is_SB=_	ex}', "");
    Expect(0, 918000, '\p{Is_SB=_	ex}', "");
    Expect(1, 918000, '\p{^Is_SB=_	ex}', "");
    Expect(1, 918000, '\P{Is_SB=_	ex}', "");
    Expect(0, 918000, '\P{^Is_SB=_	ex}', "");
    Error('\p{Sentence_Break=_:=FORMAT}');
    Error('\P{Sentence_Break=_:=FORMAT}');
    Expect(1, 917505, '\p{Sentence_Break=:\AFormat\z:}', "");;
    Expect(0, 917506, '\p{Sentence_Break=:\AFormat\z:}', "");;
    Expect(1, 917505, '\p{Sentence_Break:	format}', "");
    Expect(0, 917505, '\p{^Sentence_Break:	format}', "");
    Expect(0, 917505, '\P{Sentence_Break:	format}', "");
    Expect(1, 917505, '\P{^Sentence_Break:	format}', "");
    Expect(0, 917506, '\p{Sentence_Break:	format}', "");
    Expect(1, 917506, '\p{^Sentence_Break:	format}', "");
    Expect(1, 917506, '\P{Sentence_Break:	format}', "");
    Expect(0, 917506, '\P{^Sentence_Break:	format}', "");
    Expect(1, 917505, '\p{Sentence_Break=:\Aformat\z:}', "");;
    Expect(0, 917506, '\p{Sentence_Break=:\Aformat\z:}', "");;
    Expect(1, 917505, '\p{Sentence_Break=-FORMAT}', "");
    Expect(0, 917505, '\p{^Sentence_Break=-FORMAT}', "");
    Expect(0, 917505, '\P{Sentence_Break=-FORMAT}', "");
    Expect(1, 917505, '\P{^Sentence_Break=-FORMAT}', "");
    Expect(0, 917506, '\p{Sentence_Break=-FORMAT}', "");
    Expect(1, 917506, '\p{^Sentence_Break=-FORMAT}', "");
    Expect(1, 917506, '\P{Sentence_Break=-FORMAT}', "");
    Expect(0, 917506, '\P{^Sentence_Break=-FORMAT}', "");
    Error('\p{SB=_	fo:=}');
    Error('\P{SB=_	fo:=}');
    Expect(1, 917505, '\p{SB=:\AFO\z:}', "");;
    Expect(0, 917506, '\p{SB=:\AFO\z:}', "");;
    Expect(1, 917505, '\p{SB=fo}', "");
    Expect(0, 917505, '\p{^SB=fo}', "");
    Expect(0, 917505, '\P{SB=fo}', "");
    Expect(1, 917505, '\P{^SB=fo}', "");
    Expect(0, 917506, '\p{SB=fo}', "");
    Expect(1, 917506, '\p{^SB=fo}', "");
    Expect(1, 917506, '\P{SB=fo}', "");
    Expect(0, 917506, '\P{^SB=fo}', "");
    Expect(1, 917505, '\p{SB=:\Afo\z:}', "");;
    Expect(0, 917506, '\p{SB=:\Afo\z:}', "");;
    Expect(1, 917505, '\p{SB=	FO}', "");
    Expect(0, 917505, '\p{^SB=	FO}', "");
    Expect(0, 917505, '\P{SB=	FO}', "");
    Expect(1, 917505, '\P{^SB=	FO}', "");
    Expect(0, 917506, '\p{SB=	FO}', "");
    Expect(1, 917506, '\p{^SB=	FO}', "");
    Expect(1, 917506, '\P{SB=	FO}', "");
    Expect(0, 917506, '\P{^SB=	FO}', "");
    Error('\p{Is_Sentence_Break=:=_	Format}');
    Error('\P{Is_Sentence_Break=:=_	Format}');
    Expect(1, 917505, '\p{Is_Sentence_Break=format}', "");
    Expect(0, 917505, '\p{^Is_Sentence_Break=format}', "");
    Expect(0, 917505, '\P{Is_Sentence_Break=format}', "");
    Expect(1, 917505, '\P{^Is_Sentence_Break=format}', "");
    Expect(0, 917506, '\p{Is_Sentence_Break=format}', "");
    Expect(1, 917506, '\p{^Is_Sentence_Break=format}', "");
    Expect(1, 917506, '\P{Is_Sentence_Break=format}', "");
    Expect(0, 917506, '\P{^Is_Sentence_Break=format}', "");
    Expect(1, 917505, '\p{Is_Sentence_Break= 	Format}', "");
    Expect(0, 917505, '\p{^Is_Sentence_Break= 	Format}', "");
    Expect(0, 917505, '\P{Is_Sentence_Break= 	Format}', "");
    Expect(1, 917505, '\P{^Is_Sentence_Break= 	Format}', "");
    Expect(0, 917506, '\p{Is_Sentence_Break= 	Format}', "");
    Expect(1, 917506, '\p{^Is_Sentence_Break= 	Format}', "");
    Expect(1, 917506, '\P{Is_Sentence_Break= 	Format}', "");
    Expect(0, 917506, '\P{^Is_Sentence_Break= 	Format}', "");
    Error('\p{Is_SB=:=-FO}');
    Error('\P{Is_SB=:=-FO}');
    Expect(1, 917505, '\p{Is_SB=fo}', "");
    Expect(0, 917505, '\p{^Is_SB=fo}', "");
    Expect(0, 917505, '\P{Is_SB=fo}', "");
    Expect(1, 917505, '\P{^Is_SB=fo}', "");
    Expect(0, 917506, '\p{Is_SB=fo}', "");
    Expect(1, 917506, '\p{^Is_SB=fo}', "");
    Expect(1, 917506, '\P{Is_SB=fo}', "");
    Expect(0, 917506, '\P{^Is_SB=fo}', "");
    Expect(1, 917505, '\p{Is_SB:	-_FO}', "");
    Expect(0, 917505, '\p{^Is_SB:	-_FO}', "");
    Expect(0, 917505, '\P{Is_SB:	-_FO}', "");
    Expect(1, 917505, '\P{^Is_SB:	-_FO}', "");
    Expect(0, 917506, '\p{Is_SB:	-_FO}', "");
    Expect(1, 917506, '\p{^Is_SB:	-_FO}', "");
    Expect(1, 917506, '\P{Is_SB:	-_FO}', "");
    Expect(0, 917506, '\P{^Is_SB:	-_FO}', "");
    Error('\p{Sentence_Break=:=OLetter}');
    Error('\P{Sentence_Break=:=OLetter}');
    Expect(1, 195101, '\p{Sentence_Break=:\AOLetter\z:}', "");;
    Expect(0, 195102, '\p{Sentence_Break=:\AOLetter\z:}', "");;
    Expect(1, 195101, '\p{Sentence_Break: oletter}', "");
    Expect(0, 195101, '\p{^Sentence_Break: oletter}', "");
    Expect(0, 195101, '\P{Sentence_Break: oletter}', "");
    Expect(1, 195101, '\P{^Sentence_Break: oletter}', "");
    Expect(0, 195102, '\p{Sentence_Break: oletter}', "");
    Expect(1, 195102, '\p{^Sentence_Break: oletter}', "");
    Expect(1, 195102, '\P{Sentence_Break: oletter}', "");
    Expect(0, 195102, '\P{^Sentence_Break: oletter}', "");
    Expect(1, 195101, '\p{Sentence_Break=:\Aoletter\z:}', "");;
    Expect(0, 195102, '\p{Sentence_Break=:\Aoletter\z:}', "");;
    Expect(1, 195101, '\p{Sentence_Break=	OLetter}', "");
    Expect(0, 195101, '\p{^Sentence_Break=	OLetter}', "");
    Expect(0, 195101, '\P{Sentence_Break=	OLetter}', "");
    Expect(1, 195101, '\P{^Sentence_Break=	OLetter}', "");
    Expect(0, 195102, '\p{Sentence_Break=	OLetter}', "");
    Expect(1, 195102, '\p{^Sentence_Break=	OLetter}', "");
    Expect(1, 195102, '\P{Sentence_Break=	OLetter}', "");
    Expect(0, 195102, '\P{^Sentence_Break=	OLetter}', "");
    Error('\p{SB=- LE/a/}');
    Error('\P{SB=- LE/a/}');
    Expect(1, 195101, '\p{SB=:\ALE\z:}', "");;
    Expect(0, 195102, '\p{SB=:\ALE\z:}', "");;
    Expect(1, 195101, '\p{SB=le}', "");
    Expect(0, 195101, '\p{^SB=le}', "");
    Expect(0, 195101, '\P{SB=le}', "");
    Expect(1, 195101, '\P{^SB=le}', "");
    Expect(0, 195102, '\p{SB=le}', "");
    Expect(1, 195102, '\p{^SB=le}', "");
    Expect(1, 195102, '\P{SB=le}', "");
    Expect(0, 195102, '\P{^SB=le}', "");
    Expect(1, 195101, '\p{SB=:\Ale\z:}', "");;
    Expect(0, 195102, '\p{SB=:\Ale\z:}', "");;
    Expect(1, 195101, '\p{SB= LE}', "");
    Expect(0, 195101, '\p{^SB= LE}', "");
    Expect(0, 195101, '\P{SB= LE}', "");
    Expect(1, 195101, '\P{^SB= LE}', "");
    Expect(0, 195102, '\p{SB= LE}', "");
    Expect(1, 195102, '\p{^SB= LE}', "");
    Expect(1, 195102, '\P{SB= LE}', "");
    Expect(0, 195102, '\P{^SB= LE}', "");
    Error('\p{Is_Sentence_Break=_ OLETTER:=}');
    Error('\P{Is_Sentence_Break=_ OLETTER:=}');
    Expect(1, 195101, '\p{Is_Sentence_Break=oletter}', "");
    Expect(0, 195101, '\p{^Is_Sentence_Break=oletter}', "");
    Expect(0, 195101, '\P{Is_Sentence_Break=oletter}', "");
    Expect(1, 195101, '\P{^Is_Sentence_Break=oletter}', "");
    Expect(0, 195102, '\p{Is_Sentence_Break=oletter}', "");
    Expect(1, 195102, '\p{^Is_Sentence_Break=oletter}', "");
    Expect(1, 195102, '\P{Is_Sentence_Break=oletter}', "");
    Expect(0, 195102, '\P{^Is_Sentence_Break=oletter}', "");
    Error('\p{Is_SB=_-LE:=}');
    Error('\P{Is_SB=_-LE:=}');
    Expect(1, 195101, '\p{Is_SB=le}', "");
    Expect(0, 195101, '\p{^Is_SB=le}', "");
    Expect(0, 195101, '\P{Is_SB=le}', "");
    Expect(1, 195101, '\P{^Is_SB=le}', "");
    Expect(0, 195102, '\p{Is_SB=le}', "");
    Expect(1, 195102, '\p{^Is_SB=le}', "");
    Expect(1, 195102, '\P{Is_SB=le}', "");
    Expect(0, 195102, '\P{^Is_SB=le}', "");
    Expect(1, 195101, '\p{Is_SB: -LE}', "");
    Expect(0, 195101, '\p{^Is_SB: -LE}', "");
    Expect(0, 195101, '\P{Is_SB: -LE}', "");
    Expect(1, 195101, '\P{^Is_SB: -LE}', "");
    Expect(0, 195102, '\p{Is_SB: -LE}', "");
    Expect(1, 195102, '\p{^Is_SB: -LE}', "");
    Expect(1, 195102, '\P{Is_SB: -LE}', "");
    Expect(0, 195102, '\P{^Is_SB: -LE}', "");
    Error('\p{Sentence_Break=:= 	LF}');
    Error('\P{Sentence_Break=:= 	LF}');
    Expect(1, 10, '\p{Sentence_Break=:\ALF\z:}', "");;
    Expect(0, 11, '\p{Sentence_Break=:\ALF\z:}', "");;
    Expect(1, 10, '\p{Sentence_Break=lf}', "");
    Expect(0, 10, '\p{^Sentence_Break=lf}', "");
    Expect(0, 10, '\P{Sentence_Break=lf}', "");
    Expect(1, 10, '\P{^Sentence_Break=lf}', "");
    Expect(0, 11, '\p{Sentence_Break=lf}', "");
    Expect(1, 11, '\p{^Sentence_Break=lf}', "");
    Expect(1, 11, '\P{Sentence_Break=lf}', "");
    Expect(0, 11, '\P{^Sentence_Break=lf}', "");
    Expect(1, 10, '\p{Sentence_Break=:\Alf\z:}', "");;
    Expect(0, 11, '\p{Sentence_Break=:\Alf\z:}', "");;
    Expect(1, 10, '\p{Sentence_Break=	LF}', "");
    Expect(0, 10, '\p{^Sentence_Break=	LF}', "");
    Expect(0, 10, '\P{Sentence_Break=	LF}', "");
    Expect(1, 10, '\P{^Sentence_Break=	LF}', "");
    Expect(0, 11, '\p{Sentence_Break=	LF}', "");
    Expect(1, 11, '\p{^Sentence_Break=	LF}', "");
    Expect(1, 11, '\P{Sentence_Break=	LF}', "");
    Expect(0, 11, '\P{^Sentence_Break=	LF}', "");
    Error('\p{SB=:=LF}');
    Error('\P{SB=:=LF}');
    Expect(1, 10, '\p{SB=:\ALF\z:}', "");;
    Expect(0, 11, '\p{SB=:\ALF\z:}', "");;
    Expect(1, 10, '\p{SB=lf}', "");
    Expect(0, 10, '\p{^SB=lf}', "");
    Expect(0, 10, '\P{SB=lf}', "");
    Expect(1, 10, '\P{^SB=lf}', "");
    Expect(0, 11, '\p{SB=lf}', "");
    Expect(1, 11, '\p{^SB=lf}', "");
    Expect(1, 11, '\P{SB=lf}', "");
    Expect(0, 11, '\P{^SB=lf}', "");
    Expect(1, 10, '\p{SB=:\Alf\z:}', "");;
    Expect(0, 11, '\p{SB=:\Alf\z:}', "");;
    Expect(1, 10, '\p{SB= 	LF}', "");
    Expect(0, 10, '\p{^SB= 	LF}', "");
    Expect(0, 10, '\P{SB= 	LF}', "");
    Expect(1, 10, '\P{^SB= 	LF}', "");
    Expect(0, 11, '\p{SB= 	LF}', "");
    Expect(1, 11, '\p{^SB= 	LF}', "");
    Expect(1, 11, '\P{SB= 	LF}', "");
    Expect(0, 11, '\P{^SB= 	LF}', "");
    Error('\p{Is_Sentence_Break=:= LF}');
    Error('\P{Is_Sentence_Break=:= LF}');
    Expect(1, 10, '\p{Is_Sentence_Break=lf}', "");
    Expect(0, 10, '\p{^Is_Sentence_Break=lf}', "");
    Expect(0, 10, '\P{Is_Sentence_Break=lf}', "");
    Expect(1, 10, '\P{^Is_Sentence_Break=lf}', "");
    Expect(0, 11, '\p{Is_Sentence_Break=lf}', "");
    Expect(1, 11, '\p{^Is_Sentence_Break=lf}', "");
    Expect(1, 11, '\P{Is_Sentence_Break=lf}', "");
    Expect(0, 11, '\P{^Is_Sentence_Break=lf}', "");
    Expect(1, 10, '\p{Is_Sentence_Break=	_LF}', "");
    Expect(0, 10, '\p{^Is_Sentence_Break=	_LF}', "");
    Expect(0, 10, '\P{Is_Sentence_Break=	_LF}', "");
    Expect(1, 10, '\P{^Is_Sentence_Break=	_LF}', "");
    Expect(0, 11, '\p{Is_Sentence_Break=	_LF}', "");
    Expect(1, 11, '\p{^Is_Sentence_Break=	_LF}', "");
    Expect(1, 11, '\P{Is_Sentence_Break=	_LF}', "");
    Expect(0, 11, '\P{^Is_Sentence_Break=	_LF}', "");
    Error('\p{Is_SB=_/a/LF}');
    Error('\P{Is_SB=_/a/LF}');
    Expect(1, 10, '\p{Is_SB=lf}', "");
    Expect(0, 10, '\p{^Is_SB=lf}', "");
    Expect(0, 10, '\P{Is_SB=lf}', "");
    Expect(1, 10, '\P{^Is_SB=lf}', "");
    Expect(0, 11, '\p{Is_SB=lf}', "");
    Expect(1, 11, '\p{^Is_SB=lf}', "");
    Expect(1, 11, '\P{Is_SB=lf}', "");
    Expect(0, 11, '\P{^Is_SB=lf}', "");
    Expect(1, 10, '\p{Is_SB=__lf}', "");
    Expect(0, 10, '\p{^Is_SB=__lf}', "");
    Expect(0, 10, '\P{Is_SB=__lf}', "");
    Expect(1, 10, '\P{^Is_SB=__lf}', "");
    Expect(0, 11, '\p{Is_SB=__lf}', "");
    Expect(1, 11, '\p{^Is_SB=__lf}', "");
    Expect(1, 11, '\P{Is_SB=__lf}', "");
    Expect(0, 11, '\P{^Is_SB=__lf}', "");
    Error('\p{Sentence_Break=	:=lower}');
    Error('\P{Sentence_Break=	:=lower}');
    Expect(1, 125251, '\p{Sentence_Break=:\ALower\z:}', "");;
    Expect(0, 125252, '\p{Sentence_Break=:\ALower\z:}', "");;
    Expect(1, 125251, '\p{Sentence_Break:	lower}', "");
    Expect(0, 125251, '\p{^Sentence_Break:	lower}', "");
    Expect(0, 125251, '\P{Sentence_Break:	lower}', "");
    Expect(1, 125251, '\P{^Sentence_Break:	lower}', "");
    Expect(0, 125252, '\p{Sentence_Break:	lower}', "");
    Expect(1, 125252, '\p{^Sentence_Break:	lower}', "");
    Expect(1, 125252, '\P{Sentence_Break:	lower}', "");
    Expect(0, 125252, '\P{^Sentence_Break:	lower}', "");
    Expect(1, 125251, '\p{Sentence_Break=:\Alower\z:}', "");;
    Expect(0, 125252, '\p{Sentence_Break=:\Alower\z:}', "");;
    Expect(1, 125251, '\p{Sentence_Break=- Lower}', "");
    Expect(0, 125251, '\p{^Sentence_Break=- Lower}', "");
    Expect(0, 125251, '\P{Sentence_Break=- Lower}', "");
    Expect(1, 125251, '\P{^Sentence_Break=- Lower}', "");
    Expect(0, 125252, '\p{Sentence_Break=- Lower}', "");
    Expect(1, 125252, '\p{^Sentence_Break=- Lower}', "");
    Expect(1, 125252, '\P{Sentence_Break=- Lower}', "");
    Expect(0, 125252, '\P{^Sentence_Break=- Lower}', "");
    Error('\p{SB=:=_	LO}');
    Error('\P{SB=:=_	LO}');
    Expect(1, 125251, '\p{SB=:\ALO\z:}', "");;
    Expect(0, 125252, '\p{SB=:\ALO\z:}', "");;
    Expect(1, 125251, '\p{SB=lo}', "");
    Expect(0, 125251, '\p{^SB=lo}', "");
    Expect(0, 125251, '\P{SB=lo}', "");
    Expect(1, 125251, '\P{^SB=lo}', "");
    Expect(0, 125252, '\p{SB=lo}', "");
    Expect(1, 125252, '\p{^SB=lo}', "");
    Expect(1, 125252, '\P{SB=lo}', "");
    Expect(0, 125252, '\P{^SB=lo}', "");
    Expect(1, 125251, '\p{SB=:\Alo\z:}', "");;
    Expect(0, 125252, '\p{SB=:\Alo\z:}', "");;
    Expect(1, 125251, '\p{SB=__LO}', "");
    Expect(0, 125251, '\p{^SB=__LO}', "");
    Expect(0, 125251, '\P{SB=__LO}', "");
    Expect(1, 125251, '\P{^SB=__LO}', "");
    Expect(0, 125252, '\p{SB=__LO}', "");
    Expect(1, 125252, '\p{^SB=__LO}', "");
    Expect(1, 125252, '\P{SB=__LO}', "");
    Expect(0, 125252, '\P{^SB=__LO}', "");
    Error('\p{Is_Sentence_Break=	:=Lower}');
    Error('\P{Is_Sentence_Break=	:=Lower}');
    Expect(1, 125251, '\p{Is_Sentence_Break=lower}', "");
    Expect(0, 125251, '\p{^Is_Sentence_Break=lower}', "");
    Expect(0, 125251, '\P{Is_Sentence_Break=lower}', "");
    Expect(1, 125251, '\P{^Is_Sentence_Break=lower}', "");
    Expect(0, 125252, '\p{Is_Sentence_Break=lower}', "");
    Expect(1, 125252, '\p{^Is_Sentence_Break=lower}', "");
    Expect(1, 125252, '\P{Is_Sentence_Break=lower}', "");
    Expect(0, 125252, '\P{^Is_Sentence_Break=lower}', "");
    Expect(1, 125251, '\p{Is_Sentence_Break=-Lower}', "");
    Expect(0, 125251, '\p{^Is_Sentence_Break=-Lower}', "");
    Expect(0, 125251, '\P{Is_Sentence_Break=-Lower}', "");
    Expect(1, 125251, '\P{^Is_Sentence_Break=-Lower}', "");
    Expect(0, 125252, '\p{Is_Sentence_Break=-Lower}', "");
    Expect(1, 125252, '\p{^Is_Sentence_Break=-Lower}', "");
    Expect(1, 125252, '\P{Is_Sentence_Break=-Lower}', "");
    Expect(0, 125252, '\P{^Is_Sentence_Break=-Lower}', "");
    Error('\p{Is_SB=:=LO}');
    Error('\P{Is_SB=:=LO}');
    Expect(1, 125251, '\p{Is_SB=lo}', "");
    Expect(0, 125251, '\p{^Is_SB=lo}', "");
    Expect(0, 125251, '\P{Is_SB=lo}', "");
    Expect(1, 125251, '\P{^Is_SB=lo}', "");
    Expect(0, 125252, '\p{Is_SB=lo}', "");
    Expect(1, 125252, '\p{^Is_SB=lo}', "");
    Expect(1, 125252, '\P{Is_SB=lo}', "");
    Expect(0, 125252, '\P{^Is_SB=lo}', "");
    Expect(1, 125251, '\p{Is_SB: -LO}', "");
    Expect(0, 125251, '\p{^Is_SB: -LO}', "");
    Expect(0, 125251, '\P{Is_SB: -LO}', "");
    Expect(1, 125251, '\P{^Is_SB: -LO}', "");
    Expect(0, 125252, '\p{Is_SB: -LO}', "");
    Expect(1, 125252, '\p{^Is_SB: -LO}', "");
    Expect(1, 125252, '\P{Is_SB: -LO}', "");
    Expect(0, 125252, '\P{^Is_SB: -LO}', "");
    Error('\p{Sentence_Break=	:=numeric}');
    Error('\P{Sentence_Break=	:=numeric}');
    Expect(1, 125273, '\p{Sentence_Break=:\ANumeric\z:}', "");;
    Expect(0, 125274, '\p{Sentence_Break=:\ANumeric\z:}', "");;
    Expect(1, 125273, '\p{Sentence_Break=numeric}', "");
    Expect(0, 125273, '\p{^Sentence_Break=numeric}', "");
    Expect(0, 125273, '\P{Sentence_Break=numeric}', "");
    Expect(1, 125273, '\P{^Sentence_Break=numeric}', "");
    Expect(0, 125274, '\p{Sentence_Break=numeric}', "");
    Expect(1, 125274, '\p{^Sentence_Break=numeric}', "");
    Expect(1, 125274, '\P{Sentence_Break=numeric}', "");
    Expect(0, 125274, '\P{^Sentence_Break=numeric}', "");
    Expect(1, 125273, '\p{Sentence_Break=:\Anumeric\z:}', "");;
    Expect(0, 125274, '\p{Sentence_Break=:\Anumeric\z:}', "");;
    Expect(1, 125273, '\p{Sentence_Break=--Numeric}', "");
    Expect(0, 125273, '\p{^Sentence_Break=--Numeric}', "");
    Expect(0, 125273, '\P{Sentence_Break=--Numeric}', "");
    Expect(1, 125273, '\P{^Sentence_Break=--Numeric}', "");
    Expect(0, 125274, '\p{Sentence_Break=--Numeric}', "");
    Expect(1, 125274, '\p{^Sentence_Break=--Numeric}', "");
    Expect(1, 125274, '\P{Sentence_Break=--Numeric}', "");
    Expect(0, 125274, '\P{^Sentence_Break=--Numeric}', "");
    Error('\p{SB= /a/NU}');
    Error('\P{SB= /a/NU}');
    Expect(1, 125273, '\p{SB=:\ANU\z:}', "");;
    Expect(0, 125274, '\p{SB=:\ANU\z:}', "");;
    Expect(1, 125273, '\p{SB:	nu}', "");
    Expect(0, 125273, '\p{^SB:	nu}', "");
    Expect(0, 125273, '\P{SB:	nu}', "");
    Expect(1, 125273, '\P{^SB:	nu}', "");
    Expect(0, 125274, '\p{SB:	nu}', "");
    Expect(1, 125274, '\p{^SB:	nu}', "");
    Expect(1, 125274, '\P{SB:	nu}', "");
    Expect(0, 125274, '\P{^SB:	nu}', "");
    Expect(1, 125273, '\p{SB=:\Anu\z:}', "");;
    Expect(0, 125274, '\p{SB=:\Anu\z:}', "");;
    Expect(1, 125273, '\p{SB=--NU}', "");
    Expect(0, 125273, '\p{^SB=--NU}', "");
    Expect(0, 125273, '\P{SB=--NU}', "");
    Expect(1, 125273, '\P{^SB=--NU}', "");
    Expect(0, 125274, '\p{SB=--NU}', "");
    Expect(1, 125274, '\p{^SB=--NU}', "");
    Expect(1, 125274, '\P{SB=--NU}', "");
    Expect(0, 125274, '\P{^SB=--NU}', "");
    Error('\p{Is_Sentence_Break=/a/_	Numeric}');
    Error('\P{Is_Sentence_Break=/a/_	Numeric}');
    Expect(1, 125273, '\p{Is_Sentence_Break=numeric}', "");
    Expect(0, 125273, '\p{^Is_Sentence_Break=numeric}', "");
    Expect(0, 125273, '\P{Is_Sentence_Break=numeric}', "");
    Expect(1, 125273, '\P{^Is_Sentence_Break=numeric}', "");
    Expect(0, 125274, '\p{Is_Sentence_Break=numeric}', "");
    Expect(1, 125274, '\p{^Is_Sentence_Break=numeric}', "");
    Expect(1, 125274, '\P{Is_Sentence_Break=numeric}', "");
    Expect(0, 125274, '\P{^Is_Sentence_Break=numeric}', "");
    Expect(1, 125273, '\p{Is_Sentence_Break:-Numeric}', "");
    Expect(0, 125273, '\p{^Is_Sentence_Break:-Numeric}', "");
    Expect(0, 125273, '\P{Is_Sentence_Break:-Numeric}', "");
    Expect(1, 125273, '\P{^Is_Sentence_Break:-Numeric}', "");
    Expect(0, 125274, '\p{Is_Sentence_Break:-Numeric}', "");
    Expect(1, 125274, '\p{^Is_Sentence_Break:-Numeric}', "");
    Expect(1, 125274, '\P{Is_Sentence_Break:-Numeric}', "");
    Expect(0, 125274, '\P{^Is_Sentence_Break:-Numeric}', "");
    Error('\p{Is_SB=:=	NU}');
    Error('\P{Is_SB=:=	NU}');
    Expect(1, 125273, '\p{Is_SB=nu}', "");
    Expect(0, 125273, '\p{^Is_SB=nu}', "");
    Expect(0, 125273, '\P{Is_SB=nu}', "");
    Expect(1, 125273, '\P{^Is_SB=nu}', "");
    Expect(0, 125274, '\p{Is_SB=nu}', "");
    Expect(1, 125274, '\p{^Is_SB=nu}', "");
    Expect(1, 125274, '\P{Is_SB=nu}', "");
    Expect(0, 125274, '\P{^Is_SB=nu}', "");
    Expect(1, 125273, '\p{Is_SB=	_nu}', "");
    Expect(0, 125273, '\p{^Is_SB=	_nu}', "");
    Expect(0, 125273, '\P{Is_SB=	_nu}', "");
    Expect(1, 125273, '\P{^Is_SB=	_nu}', "");
    Expect(0, 125274, '\p{Is_SB=	_nu}', "");
    Expect(1, 125274, '\p{^Is_SB=	_nu}', "");
    Expect(1, 125274, '\P{Is_SB=	_nu}', "");
    Expect(0, 125274, '\P{^Is_SB=	_nu}', "");
    Error('\p{Sentence_Break=:=--SContinue}');
    Error('\P{Sentence_Break=:=--SContinue}');
    Expect(1, 65380, '\p{Sentence_Break=:\ASContinue\z:}', "");;
    Expect(0, 65381, '\p{Sentence_Break=:\ASContinue\z:}', "");;
    Expect(1, 65380, '\p{Sentence_Break=scontinue}', "");
    Expect(0, 65380, '\p{^Sentence_Break=scontinue}', "");
    Expect(0, 65380, '\P{Sentence_Break=scontinue}', "");
    Expect(1, 65380, '\P{^Sentence_Break=scontinue}', "");
    Expect(0, 65381, '\p{Sentence_Break=scontinue}', "");
    Expect(1, 65381, '\p{^Sentence_Break=scontinue}', "");
    Expect(1, 65381, '\P{Sentence_Break=scontinue}', "");
    Expect(0, 65381, '\P{^Sentence_Break=scontinue}', "");
    Expect(1, 65380, '\p{Sentence_Break=:\Ascontinue\z:}', "");;
    Expect(0, 65381, '\p{Sentence_Break=:\Ascontinue\z:}', "");;
    Expect(1, 65380, '\p{Sentence_Break=	_scontinue}', "");
    Expect(0, 65380, '\p{^Sentence_Break=	_scontinue}', "");
    Expect(0, 65380, '\P{Sentence_Break=	_scontinue}', "");
    Expect(1, 65380, '\P{^Sentence_Break=	_scontinue}', "");
    Expect(0, 65381, '\p{Sentence_Break=	_scontinue}', "");
    Expect(1, 65381, '\p{^Sentence_Break=	_scontinue}', "");
    Expect(1, 65381, '\P{Sentence_Break=	_scontinue}', "");
    Expect(0, 65381, '\P{^Sentence_Break=	_scontinue}', "");
    Error('\p{SB=-/a/SC}');
    Error('\P{SB=-/a/SC}');
    Expect(1, 65380, '\p{SB=:\ASC\z:}', "");;
    Expect(0, 65381, '\p{SB=:\ASC\z:}', "");;
    Expect(1, 65380, '\p{SB=sc}', "");
    Expect(0, 65380, '\p{^SB=sc}', "");
    Expect(0, 65380, '\P{SB=sc}', "");
    Expect(1, 65380, '\P{^SB=sc}', "");
    Expect(0, 65381, '\p{SB=sc}', "");
    Expect(1, 65381, '\p{^SB=sc}', "");
    Expect(1, 65381, '\P{SB=sc}', "");
    Expect(0, 65381, '\P{^SB=sc}', "");
    Expect(1, 65380, '\p{SB=:\Asc\z:}', "");;
    Expect(0, 65381, '\p{SB=:\Asc\z:}', "");;
    Expect(1, 65380, '\p{SB=		SC}', "");
    Expect(0, 65380, '\p{^SB=		SC}', "");
    Expect(0, 65380, '\P{SB=		SC}', "");
    Expect(1, 65380, '\P{^SB=		SC}', "");
    Expect(0, 65381, '\p{SB=		SC}', "");
    Expect(1, 65381, '\p{^SB=		SC}', "");
    Expect(1, 65381, '\P{SB=		SC}', "");
    Expect(0, 65381, '\P{^SB=		SC}', "");
    Error('\p{Is_Sentence_Break=/a/SContinue}');
    Error('\P{Is_Sentence_Break=/a/SContinue}');
    Expect(1, 65380, '\p{Is_Sentence_Break=scontinue}', "");
    Expect(0, 65380, '\p{^Is_Sentence_Break=scontinue}', "");
    Expect(0, 65380, '\P{Is_Sentence_Break=scontinue}', "");
    Expect(1, 65380, '\P{^Is_Sentence_Break=scontinue}', "");
    Expect(0, 65381, '\p{Is_Sentence_Break=scontinue}', "");
    Expect(1, 65381, '\p{^Is_Sentence_Break=scontinue}', "");
    Expect(1, 65381, '\P{Is_Sentence_Break=scontinue}', "");
    Expect(0, 65381, '\P{^Is_Sentence_Break=scontinue}', "");
    Expect(1, 65380, '\p{Is_Sentence_Break=  scontinue}', "");
    Expect(0, 65380, '\p{^Is_Sentence_Break=  scontinue}', "");
    Expect(0, 65380, '\P{Is_Sentence_Break=  scontinue}', "");
    Expect(1, 65380, '\P{^Is_Sentence_Break=  scontinue}', "");
    Expect(0, 65381, '\p{Is_Sentence_Break=  scontinue}', "");
    Expect(1, 65381, '\p{^Is_Sentence_Break=  scontinue}', "");
    Expect(1, 65381, '\P{Is_Sentence_Break=  scontinue}', "");
    Expect(0, 65381, '\P{^Is_Sentence_Break=  scontinue}', "");
    Error('\p{Is_SB=/a/	SC}');
    Error('\P{Is_SB=/a/	SC}');
    Expect(1, 65380, '\p{Is_SB:sc}', "");
    Expect(0, 65380, '\p{^Is_SB:sc}', "");
    Expect(0, 65380, '\P{Is_SB:sc}', "");
    Expect(1, 65380, '\P{^Is_SB:sc}', "");
    Expect(0, 65381, '\p{Is_SB:sc}', "");
    Expect(1, 65381, '\p{^Is_SB:sc}', "");
    Expect(1, 65381, '\P{Is_SB:sc}', "");
    Expect(0, 65381, '\P{^Is_SB:sc}', "");
    Expect(1, 65380, '\p{Is_SB=-sc}', "");
    Expect(0, 65380, '\p{^Is_SB=-sc}', "");
    Expect(0, 65380, '\P{Is_SB=-sc}', "");
    Expect(1, 65380, '\P{^Is_SB=-sc}', "");
    Expect(0, 65381, '\p{Is_SB=-sc}', "");
    Expect(1, 65381, '\p{^Is_SB=-sc}', "");
    Expect(1, 65381, '\P{Is_SB=-sc}', "");
    Expect(0, 65381, '\P{^Is_SB=-sc}', "");
    Error('\p{Sentence_Break=/a/ -Sep}');
    Error('\P{Sentence_Break=/a/ -Sep}');
    Expect(1, 8233, '\p{Sentence_Break=:\ASep\z:}', "");;
    Expect(0, 8234, '\p{Sentence_Break=:\ASep\z:}', "");;
    Expect(1, 8233, '\p{Sentence_Break=sep}', "");
    Expect(0, 8233, '\p{^Sentence_Break=sep}', "");
    Expect(0, 8233, '\P{Sentence_Break=sep}', "");
    Expect(1, 8233, '\P{^Sentence_Break=sep}', "");
    Expect(0, 8234, '\p{Sentence_Break=sep}', "");
    Expect(1, 8234, '\p{^Sentence_Break=sep}', "");
    Expect(1, 8234, '\P{Sentence_Break=sep}', "");
    Expect(0, 8234, '\P{^Sentence_Break=sep}', "");
    Expect(1, 8233, '\p{Sentence_Break=:\Asep\z:}', "");;
    Expect(0, 8234, '\p{Sentence_Break=:\Asep\z:}', "");;
    Expect(1, 8233, '\p{Sentence_Break= Sep}', "");
    Expect(0, 8233, '\p{^Sentence_Break= Sep}', "");
    Expect(0, 8233, '\P{Sentence_Break= Sep}', "");
    Expect(1, 8233, '\P{^Sentence_Break= Sep}', "");
    Expect(0, 8234, '\p{Sentence_Break= Sep}', "");
    Expect(1, 8234, '\p{^Sentence_Break= Sep}', "");
    Expect(1, 8234, '\P{Sentence_Break= Sep}', "");
    Expect(0, 8234, '\P{^Sentence_Break= Sep}', "");
    Error('\p{SB=:=SE}');
    Error('\P{SB=:=SE}');
    Expect(1, 8233, '\p{SB=:\ASE\z:}', "");;
    Expect(0, 8234, '\p{SB=:\ASE\z:}', "");;
    Expect(1, 8233, '\p{SB=se}', "");
    Expect(0, 8233, '\p{^SB=se}', "");
    Expect(0, 8233, '\P{SB=se}', "");
    Expect(1, 8233, '\P{^SB=se}', "");
    Expect(0, 8234, '\p{SB=se}', "");
    Expect(1, 8234, '\p{^SB=se}', "");
    Expect(1, 8234, '\P{SB=se}', "");
    Expect(0, 8234, '\P{^SB=se}', "");
    Expect(1, 8233, '\p{SB=:\Ase\z:}', "");;
    Expect(0, 8234, '\p{SB=:\Ase\z:}', "");;
    Expect(1, 8233, '\p{SB=-_SE}', "");
    Expect(0, 8233, '\p{^SB=-_SE}', "");
    Expect(0, 8233, '\P{SB=-_SE}', "");
    Expect(1, 8233, '\P{^SB=-_SE}', "");
    Expect(0, 8234, '\p{SB=-_SE}', "");
    Expect(1, 8234, '\p{^SB=-_SE}', "");
    Expect(1, 8234, '\P{SB=-_SE}', "");
    Expect(0, 8234, '\P{^SB=-_SE}', "");
    Error('\p{Is_Sentence_Break=	_sep/a/}');
    Error('\P{Is_Sentence_Break=	_sep/a/}');
    Expect(1, 8233, '\p{Is_Sentence_Break=sep}', "");
    Expect(0, 8233, '\p{^Is_Sentence_Break=sep}', "");
    Expect(0, 8233, '\P{Is_Sentence_Break=sep}', "");
    Expect(1, 8233, '\P{^Is_Sentence_Break=sep}', "");
    Expect(0, 8234, '\p{Is_Sentence_Break=sep}', "");
    Expect(1, 8234, '\p{^Is_Sentence_Break=sep}', "");
    Expect(1, 8234, '\P{Is_Sentence_Break=sep}', "");
    Expect(0, 8234, '\P{^Is_Sentence_Break=sep}', "");
    Expect(1, 8233, '\p{Is_Sentence_Break=_-SEP}', "");
    Expect(0, 8233, '\p{^Is_Sentence_Break=_-SEP}', "");
    Expect(0, 8233, '\P{Is_Sentence_Break=_-SEP}', "");
    Expect(1, 8233, '\P{^Is_Sentence_Break=_-SEP}', "");
    Expect(0, 8234, '\p{Is_Sentence_Break=_-SEP}', "");
    Expect(1, 8234, '\p{^Is_Sentence_Break=_-SEP}', "");
    Expect(1, 8234, '\P{Is_Sentence_Break=_-SEP}', "");
    Expect(0, 8234, '\P{^Is_Sentence_Break=_-SEP}', "");
    Error('\p{Is_SB=-/a/SE}');
    Error('\P{Is_SB=-/a/SE}');
    Expect(1, 8233, '\p{Is_SB=se}', "");
    Expect(0, 8233, '\p{^Is_SB=se}', "");
    Expect(0, 8233, '\P{Is_SB=se}', "");
    Expect(1, 8233, '\P{^Is_SB=se}', "");
    Expect(0, 8234, '\p{Is_SB=se}', "");
    Expect(1, 8234, '\p{^Is_SB=se}', "");
    Expect(1, 8234, '\P{Is_SB=se}', "");
    Expect(0, 8234, '\P{^Is_SB=se}', "");
    Expect(1, 8233, '\p{Is_SB=_-SE}', "");
    Expect(0, 8233, '\p{^Is_SB=_-SE}', "");
    Expect(0, 8233, '\P{Is_SB=_-SE}', "");
    Expect(1, 8233, '\P{^Is_SB=_-SE}', "");
    Expect(0, 8234, '\p{Is_SB=_-SE}', "");
    Expect(1, 8234, '\p{^Is_SB=_-SE}', "");
    Expect(1, 8234, '\P{Is_SB=_-SE}', "");
    Expect(0, 8234, '\P{^Is_SB=_-SE}', "");
    Error('\p{Sentence_Break=:=-sp}');
    Error('\P{Sentence_Break=:=-sp}');
    Expect(1, 12288, '\p{Sentence_Break=:\ASp\z:}', "");;
    Expect(0, 12289, '\p{Sentence_Break=:\ASp\z:}', "");;
    Expect(1, 12288, '\p{Sentence_Break=sp}', "");
    Expect(0, 12288, '\p{^Sentence_Break=sp}', "");
    Expect(0, 12288, '\P{Sentence_Break=sp}', "");
    Expect(1, 12288, '\P{^Sentence_Break=sp}', "");
    Expect(0, 12289, '\p{Sentence_Break=sp}', "");
    Expect(1, 12289, '\p{^Sentence_Break=sp}', "");
    Expect(1, 12289, '\P{Sentence_Break=sp}', "");
    Expect(0, 12289, '\P{^Sentence_Break=sp}', "");
    Expect(1, 12288, '\p{Sentence_Break=:\Asp\z:}', "");;
    Expect(0, 12289, '\p{Sentence_Break=:\Asp\z:}', "");;
    Expect(1, 12288, '\p{Sentence_Break=__sp}', "");
    Expect(0, 12288, '\p{^Sentence_Break=__sp}', "");
    Expect(0, 12288, '\P{Sentence_Break=__sp}', "");
    Expect(1, 12288, '\P{^Sentence_Break=__sp}', "");
    Expect(0, 12289, '\p{Sentence_Break=__sp}', "");
    Expect(1, 12289, '\p{^Sentence_Break=__sp}', "");
    Expect(1, 12289, '\P{Sentence_Break=__sp}', "");
    Expect(0, 12289, '\P{^Sentence_Break=__sp}', "");
    Error('\p{SB=:= _sp}');
    Error('\P{SB=:= _sp}');
    Expect(1, 12288, '\p{SB=:\ASp\z:}', "");;
    Expect(0, 12289, '\p{SB=:\ASp\z:}', "");;
    Expect(1, 12288, '\p{SB=sp}', "");
    Expect(0, 12288, '\p{^SB=sp}', "");
    Expect(0, 12288, '\P{SB=sp}', "");
    Expect(1, 12288, '\P{^SB=sp}', "");
    Expect(0, 12289, '\p{SB=sp}', "");
    Expect(1, 12289, '\p{^SB=sp}', "");
    Expect(1, 12289, '\P{SB=sp}', "");
    Expect(0, 12289, '\P{^SB=sp}', "");
    Expect(1, 12288, '\p{SB=:\Asp\z:}', "");;
    Expect(0, 12289, '\p{SB=:\Asp\z:}', "");;
    Expect(1, 12288, '\p{SB=_-Sp}', "");
    Expect(0, 12288, '\p{^SB=_-Sp}', "");
    Expect(0, 12288, '\P{SB=_-Sp}', "");
    Expect(1, 12288, '\P{^SB=_-Sp}', "");
    Expect(0, 12289, '\p{SB=_-Sp}', "");
    Expect(1, 12289, '\p{^SB=_-Sp}', "");
    Expect(1, 12289, '\P{SB=_-Sp}', "");
    Expect(0, 12289, '\P{^SB=_-Sp}', "");
    Error('\p{Is_Sentence_Break=/a/		SP}');
    Error('\P{Is_Sentence_Break=/a/		SP}');
    Expect(1, 12288, '\p{Is_Sentence_Break=sp}', "");
    Expect(0, 12288, '\p{^Is_Sentence_Break=sp}', "");
    Expect(0, 12288, '\P{Is_Sentence_Break=sp}', "");
    Expect(1, 12288, '\P{^Is_Sentence_Break=sp}', "");
    Expect(0, 12289, '\p{Is_Sentence_Break=sp}', "");
    Expect(1, 12289, '\p{^Is_Sentence_Break=sp}', "");
    Expect(1, 12289, '\P{Is_Sentence_Break=sp}', "");
    Expect(0, 12289, '\P{^Is_Sentence_Break=sp}', "");
    Expect(1, 12288, '\p{Is_Sentence_Break=	 Sp}', "");
    Expect(0, 12288, '\p{^Is_Sentence_Break=	 Sp}', "");
    Expect(0, 12288, '\P{Is_Sentence_Break=	 Sp}', "");
    Expect(1, 12288, '\P{^Is_Sentence_Break=	 Sp}', "");
    Expect(0, 12289, '\p{Is_Sentence_Break=	 Sp}', "");
    Expect(1, 12289, '\p{^Is_Sentence_Break=	 Sp}', "");
    Expect(1, 12289, '\P{Is_Sentence_Break=	 Sp}', "");
    Expect(0, 12289, '\P{^Is_Sentence_Break=	 Sp}', "");
    Error('\p{Is_SB=/a/Sp}');
    Error('\P{Is_SB=/a/Sp}');
    Expect(1, 12288, '\p{Is_SB=sp}', "");
    Expect(0, 12288, '\p{^Is_SB=sp}', "");
    Expect(0, 12288, '\P{Is_SB=sp}', "");
    Expect(1, 12288, '\P{^Is_SB=sp}', "");
    Expect(0, 12289, '\p{Is_SB=sp}', "");
    Expect(1, 12289, '\p{^Is_SB=sp}', "");
    Expect(1, 12289, '\P{Is_SB=sp}', "");
    Expect(0, 12289, '\P{^Is_SB=sp}', "");
    Expect(1, 12288, '\p{Is_SB=-Sp}', "");
    Expect(0, 12288, '\p{^Is_SB=-Sp}', "");
    Expect(0, 12288, '\P{Is_SB=-Sp}', "");
    Expect(1, 12288, '\P{^Is_SB=-Sp}', "");
    Expect(0, 12289, '\p{Is_SB=-Sp}', "");
    Expect(1, 12289, '\p{^Is_SB=-Sp}', "");
    Expect(1, 12289, '\P{Is_SB=-Sp}', "");
    Expect(0, 12289, '\P{^Is_SB=-Sp}', "");
    Error('\p{Sentence_Break=_ sterm:=}');
    Error('\P{Sentence_Break=_ sterm:=}');
    Expect(1, 121480, '\p{Sentence_Break=:\ASTerm\z:}', "");;
    Expect(0, 121481, '\p{Sentence_Break=:\ASTerm\z:}', "");;
    Expect(1, 121480, '\p{Sentence_Break=sterm}', "");
    Expect(0, 121480, '\p{^Sentence_Break=sterm}', "");
    Expect(0, 121480, '\P{Sentence_Break=sterm}', "");
    Expect(1, 121480, '\P{^Sentence_Break=sterm}', "");
    Expect(0, 121481, '\p{Sentence_Break=sterm}', "");
    Expect(1, 121481, '\p{^Sentence_Break=sterm}', "");
    Expect(1, 121481, '\P{Sentence_Break=sterm}', "");
    Expect(0, 121481, '\P{^Sentence_Break=sterm}', "");
    Expect(1, 121480, '\p{Sentence_Break=:\Asterm\z:}', "");;
    Expect(0, 121481, '\p{Sentence_Break=:\Asterm\z:}', "");;
    Expect(1, 121480, '\p{Sentence_Break=_STerm}', "");
    Expect(0, 121480, '\p{^Sentence_Break=_STerm}', "");
    Expect(0, 121480, '\P{Sentence_Break=_STerm}', "");
    Expect(1, 121480, '\P{^Sentence_Break=_STerm}', "");
    Expect(0, 121481, '\p{Sentence_Break=_STerm}', "");
    Expect(1, 121481, '\p{^Sentence_Break=_STerm}', "");
    Expect(1, 121481, '\P{Sentence_Break=_STerm}', "");
    Expect(0, 121481, '\P{^Sentence_Break=_STerm}', "");
    Error('\p{SB=/a/	ST}');
    Error('\P{SB=/a/	ST}');
    Expect(1, 121480, '\p{SB=:\AST\z:}', "");;
    Expect(0, 121481, '\p{SB=:\AST\z:}', "");;
    Expect(1, 121480, '\p{SB=st}', "");
    Expect(0, 121480, '\p{^SB=st}', "");
    Expect(0, 121480, '\P{SB=st}', "");
    Expect(1, 121480, '\P{^SB=st}', "");
    Expect(0, 121481, '\p{SB=st}', "");
    Expect(1, 121481, '\p{^SB=st}', "");
    Expect(1, 121481, '\P{SB=st}', "");
    Expect(0, 121481, '\P{^SB=st}', "");
    Expect(1, 121480, '\p{SB=:\Ast\z:}', "");;
    Expect(0, 121481, '\p{SB=:\Ast\z:}', "");;
    Expect(1, 121480, '\p{SB=-st}', "");
    Expect(0, 121480, '\p{^SB=-st}', "");
    Expect(0, 121480, '\P{SB=-st}', "");
    Expect(1, 121480, '\P{^SB=-st}', "");
    Expect(0, 121481, '\p{SB=-st}', "");
    Expect(1, 121481, '\p{^SB=-st}', "");
    Expect(1, 121481, '\P{SB=-st}', "");
    Expect(0, 121481, '\P{^SB=-st}', "");
    Error('\p{Is_Sentence_Break=	/a/STERM}');
    Error('\P{Is_Sentence_Break=	/a/STERM}');
    Expect(1, 121480, '\p{Is_Sentence_Break=sterm}', "");
    Expect(0, 121480, '\p{^Is_Sentence_Break=sterm}', "");
    Expect(0, 121480, '\P{Is_Sentence_Break=sterm}', "");
    Expect(1, 121480, '\P{^Is_Sentence_Break=sterm}', "");
    Expect(0, 121481, '\p{Is_Sentence_Break=sterm}', "");
    Expect(1, 121481, '\p{^Is_Sentence_Break=sterm}', "");
    Expect(1, 121481, '\P{Is_Sentence_Break=sterm}', "");
    Expect(0, 121481, '\P{^Is_Sentence_Break=sterm}', "");
    Expect(1, 121480, '\p{Is_Sentence_Break=- STERM}', "");
    Expect(0, 121480, '\p{^Is_Sentence_Break=- STERM}', "");
    Expect(0, 121480, '\P{Is_Sentence_Break=- STERM}', "");
    Expect(1, 121480, '\P{^Is_Sentence_Break=- STERM}', "");
    Expect(0, 121481, '\p{Is_Sentence_Break=- STERM}', "");
    Expect(1, 121481, '\p{^Is_Sentence_Break=- STERM}', "");
    Expect(1, 121481, '\P{Is_Sentence_Break=- STERM}', "");
    Expect(0, 121481, '\P{^Is_Sentence_Break=- STERM}', "");
    Error('\p{Is_SB=:=ST}');
    Error('\P{Is_SB=:=ST}');
    Expect(1, 121480, '\p{Is_SB=st}', "");
    Expect(0, 121480, '\p{^Is_SB=st}', "");
    Expect(0, 121480, '\P{Is_SB=st}', "");
    Expect(1, 121480, '\P{^Is_SB=st}', "");
    Expect(0, 121481, '\p{Is_SB=st}', "");
    Expect(1, 121481, '\p{^Is_SB=st}', "");
    Expect(1, 121481, '\P{Is_SB=st}', "");
    Expect(0, 121481, '\P{^Is_SB=st}', "");
    Expect(1, 121480, '\p{Is_SB=	-ST}', "");
    Expect(0, 121480, '\p{^Is_SB=	-ST}', "");
    Expect(0, 121480, '\P{Is_SB=	-ST}', "");
    Expect(1, 121480, '\P{^Is_SB=	-ST}', "");
    Expect(0, 121481, '\p{Is_SB=	-ST}', "");
    Expect(1, 121481, '\p{^Is_SB=	-ST}', "");
    Expect(1, 121481, '\P{Is_SB=	-ST}', "");
    Expect(0, 121481, '\P{^Is_SB=	-ST}', "");
    Error('\p{Sentence_Break= _UPPER/a/}');
    Error('\P{Sentence_Break= _UPPER/a/}');
    Expect(1, 127369, '\p{Sentence_Break=:\AUpper\z:}', "");;
    Expect(0, 127370, '\p{Sentence_Break=:\AUpper\z:}', "");;
    Expect(1, 127369, '\p{Sentence_Break=upper}', "");
    Expect(0, 127369, '\p{^Sentence_Break=upper}', "");
    Expect(0, 127369, '\P{Sentence_Break=upper}', "");
    Expect(1, 127369, '\P{^Sentence_Break=upper}', "");
    Expect(0, 127370, '\p{Sentence_Break=upper}', "");
    Expect(1, 127370, '\p{^Sentence_Break=upper}', "");
    Expect(1, 127370, '\P{Sentence_Break=upper}', "");
    Expect(0, 127370, '\P{^Sentence_Break=upper}', "");
    Expect(1, 127369, '\p{Sentence_Break=:\Aupper\z:}', "");;
    Expect(0, 127370, '\p{Sentence_Break=:\Aupper\z:}', "");;
    Expect(1, 127369, '\p{Sentence_Break=	Upper}', "");
    Expect(0, 127369, '\p{^Sentence_Break=	Upper}', "");
    Expect(0, 127369, '\P{Sentence_Break=	Upper}', "");
    Expect(1, 127369, '\P{^Sentence_Break=	Upper}', "");
    Expect(0, 127370, '\p{Sentence_Break=	Upper}', "");
    Expect(1, 127370, '\p{^Sentence_Break=	Upper}', "");
    Expect(1, 127370, '\P{Sentence_Break=	Upper}', "");
    Expect(0, 127370, '\P{^Sentence_Break=	Upper}', "");
    Error('\p{SB=	/a/up}');
    Error('\P{SB=	/a/up}');
    Expect(1, 127369, '\p{SB=:\AUP\z:}', "");;
    Expect(0, 127370, '\p{SB=:\AUP\z:}', "");;
    Expect(1, 127369, '\p{SB=up}', "");
    Expect(0, 127369, '\p{^SB=up}', "");
    Expect(0, 127369, '\P{SB=up}', "");
    Expect(1, 127369, '\P{^SB=up}', "");
    Expect(0, 127370, '\p{SB=up}', "");
    Expect(1, 127370, '\p{^SB=up}', "");
    Expect(1, 127370, '\P{SB=up}', "");
    Expect(0, 127370, '\P{^SB=up}', "");
    Expect(1, 127369, '\p{SB=:\Aup\z:}', "");;
    Expect(0, 127370, '\p{SB=:\Aup\z:}', "");;
    Expect(1, 127369, '\p{SB: -_up}', "");
    Expect(0, 127369, '\p{^SB: -_up}', "");
    Expect(0, 127369, '\P{SB: -_up}', "");
    Expect(1, 127369, '\P{^SB: -_up}', "");
    Expect(0, 127370, '\p{SB: -_up}', "");
    Expect(1, 127370, '\p{^SB: -_up}', "");
    Expect(1, 127370, '\P{SB: -_up}', "");
    Expect(0, 127370, '\P{^SB: -_up}', "");
    Error('\p{Is_Sentence_Break=_-UPPER:=}');
    Error('\P{Is_Sentence_Break=_-UPPER:=}');
    Expect(1, 127369, '\p{Is_Sentence_Break=upper}', "");
    Expect(0, 127369, '\p{^Is_Sentence_Break=upper}', "");
    Expect(0, 127369, '\P{Is_Sentence_Break=upper}', "");
    Expect(1, 127369, '\P{^Is_Sentence_Break=upper}', "");
    Expect(0, 127370, '\p{Is_Sentence_Break=upper}', "");
    Expect(1, 127370, '\p{^Is_Sentence_Break=upper}', "");
    Expect(1, 127370, '\P{Is_Sentence_Break=upper}', "");
    Expect(0, 127370, '\P{^Is_Sentence_Break=upper}', "");
    Expect(1, 127369, '\p{Is_Sentence_Break= upper}', "");
    Expect(0, 127369, '\p{^Is_Sentence_Break= upper}', "");
    Expect(0, 127369, '\P{Is_Sentence_Break= upper}', "");
    Expect(1, 127369, '\P{^Is_Sentence_Break= upper}', "");
    Expect(0, 127370, '\p{Is_Sentence_Break= upper}', "");
    Expect(1, 127370, '\p{^Is_Sentence_Break= upper}', "");
    Expect(1, 127370, '\P{Is_Sentence_Break= upper}', "");
    Expect(0, 127370, '\P{^Is_Sentence_Break= upper}', "");
    Error('\p{Is_SB= /a/UP}');
    Error('\P{Is_SB= /a/UP}');
    Expect(1, 127369, '\p{Is_SB=up}', "");
    Expect(0, 127369, '\p{^Is_SB=up}', "");
    Expect(0, 127369, '\P{Is_SB=up}', "");
    Expect(1, 127369, '\P{^Is_SB=up}', "");
    Expect(0, 127370, '\p{Is_SB=up}', "");
    Expect(1, 127370, '\p{^Is_SB=up}', "");
    Expect(1, 127370, '\P{Is_SB=up}', "");
    Expect(0, 127370, '\P{^Is_SB=up}', "");
    Expect(1, 127369, '\p{Is_SB=_-UP}', "");
    Expect(0, 127369, '\p{^Is_SB=_-UP}', "");
    Expect(0, 127369, '\P{Is_SB=_-UP}', "");
    Expect(1, 127369, '\P{^Is_SB=_-UP}', "");
    Expect(0, 127370, '\p{Is_SB=_-UP}', "");
    Expect(1, 127370, '\p{^Is_SB=_-UP}', "");
    Expect(1, 127370, '\P{Is_SB=_-UP}', "");
    Expect(0, 127370, '\P{^Is_SB=_-UP}', "");
    Error('\p{Sentence_Break=/a/ other}');
    Error('\P{Sentence_Break=/a/ other}');
    Expect(1, 918000, '\p{Sentence_Break=:\AOther\z:}', "");;
    Expect(0, 917999, '\p{Sentence_Break=:\AOther\z:}', "");;
    Expect(1, 918000, '\p{Sentence_Break:	other}', "");
    Expect(0, 918000, '\p{^Sentence_Break:	other}', "");
    Expect(0, 918000, '\P{Sentence_Break:	other}', "");
    Expect(1, 918000, '\P{^Sentence_Break:	other}', "");
    Expect(0, 917999, '\p{Sentence_Break:	other}', "");
    Expect(1, 917999, '\p{^Sentence_Break:	other}', "");
    Expect(1, 917999, '\P{Sentence_Break:	other}', "");
    Expect(0, 917999, '\P{^Sentence_Break:	other}', "");
    Expect(1, 918000, '\p{Sentence_Break=:\Aother\z:}', "");;
    Expect(0, 917999, '\p{Sentence_Break=:\Aother\z:}', "");;
    Expect(1, 918000, '\p{Sentence_Break=--OTHER}', "");
    Expect(0, 918000, '\p{^Sentence_Break=--OTHER}', "");
    Expect(0, 918000, '\P{Sentence_Break=--OTHER}', "");
    Expect(1, 918000, '\P{^Sentence_Break=--OTHER}', "");
    Expect(0, 917999, '\p{Sentence_Break=--OTHER}', "");
    Expect(1, 917999, '\p{^Sentence_Break=--OTHER}', "");
    Expect(1, 917999, '\P{Sentence_Break=--OTHER}', "");
    Expect(0, 917999, '\P{^Sentence_Break=--OTHER}', "");
    Error('\p{SB=/a/-_xx}');
    Error('\P{SB=/a/-_xx}');
    Expect(1, 918000, '\p{SB=:\AXX\z:}', "");;
    Expect(0, 917999, '\p{SB=:\AXX\z:}', "");;
    Expect(1, 918000, '\p{SB=xx}', "");
    Expect(0, 918000, '\p{^SB=xx}', "");
    Expect(0, 918000, '\P{SB=xx}', "");
    Expect(1, 918000, '\P{^SB=xx}', "");
    Expect(0, 917999, '\p{SB=xx}', "");
    Expect(1, 917999, '\p{^SB=xx}', "");
    Expect(1, 917999, '\P{SB=xx}', "");
    Expect(0, 917999, '\P{^SB=xx}', "");
    Expect(1, 918000, '\p{SB=:\Axx\z:}', "");;
    Expect(0, 917999, '\p{SB=:\Axx\z:}', "");;
    Expect(1, 918000, '\p{SB=_	XX}', "");
    Expect(0, 918000, '\p{^SB=_	XX}', "");
    Expect(0, 918000, '\P{SB=_	XX}', "");
    Expect(1, 918000, '\P{^SB=_	XX}', "");
    Expect(0, 917999, '\p{SB=_	XX}', "");
    Expect(1, 917999, '\p{^SB=_	XX}', "");
    Expect(1, 917999, '\P{SB=_	XX}', "");
    Expect(0, 917999, '\P{^SB=_	XX}', "");
    Error('\p{Is_Sentence_Break=_ Other:=}');
    Error('\P{Is_Sentence_Break=_ Other:=}');
    Expect(1, 918000, '\p{Is_Sentence_Break=other}', "");
    Expect(0, 918000, '\p{^Is_Sentence_Break=other}', "");
    Expect(0, 918000, '\P{Is_Sentence_Break=other}', "");
    Expect(1, 918000, '\P{^Is_Sentence_Break=other}', "");
    Expect(0, 917999, '\p{Is_Sentence_Break=other}', "");
    Expect(1, 917999, '\p{^Is_Sentence_Break=other}', "");
    Expect(1, 917999, '\P{Is_Sentence_Break=other}', "");
    Expect(0, 917999, '\P{^Is_Sentence_Break=other}', "");
    Expect(1, 918000, '\p{Is_Sentence_Break:		other}', "");
    Expect(0, 918000, '\p{^Is_Sentence_Break:		other}', "");
    Expect(0, 918000, '\P{Is_Sentence_Break:		other}', "");
    Expect(1, 918000, '\P{^Is_Sentence_Break:		other}', "");
    Expect(0, 917999, '\p{Is_Sentence_Break:		other}', "");
    Expect(1, 917999, '\p{^Is_Sentence_Break:		other}', "");
    Expect(1, 917999, '\P{Is_Sentence_Break:		other}', "");
    Expect(0, 917999, '\P{^Is_Sentence_Break:		other}', "");
    Error('\p{Is_SB=	/a/XX}');
    Error('\P{Is_SB=	/a/XX}');
    Expect(1, 918000, '\p{Is_SB:	xx}', "");
    Expect(0, 918000, '\p{^Is_SB:	xx}', "");
    Expect(0, 918000, '\P{Is_SB:	xx}', "");
    Expect(1, 918000, '\P{^Is_SB:	xx}', "");
    Expect(0, 917999, '\p{Is_SB:	xx}', "");
    Expect(1, 917999, '\p{^Is_SB:	xx}', "");
    Expect(1, 917999, '\P{Is_SB:	xx}', "");
    Expect(0, 917999, '\P{^Is_SB:	xx}', "");
    Expect(1, 918000, '\p{Is_SB=	XX}', "");
    Expect(0, 918000, '\p{^Is_SB=	XX}', "");
    Expect(0, 918000, '\P{Is_SB=	XX}', "");
    Expect(1, 918000, '\P{^Is_SB=	XX}', "");
    Expect(0, 917999, '\p{Is_SB=	XX}', "");
    Expect(1, 917999, '\p{^Is_SB=	XX}', "");
    Expect(1, 917999, '\P{Is_SB=	XX}', "");
    Expect(0, 917999, '\P{^Is_SB=	XX}', "");
    Error('\p{script}');
    Error('\P{script}');
    Error('\p{Script= :=adlam}');
    Error('\P{Script= :=adlam}');
    Expect(1, 125279, '\p{Script=:\AAdlam\z:}', "");;
    Expect(0, 125280, '\p{Script=:\AAdlam\z:}', "");;
    Expect(1, 125279, '\p{Script=adlam}', "");
    Expect(0, 125279, '\p{^Script=adlam}', "");
    Expect(0, 125279, '\P{Script=adlam}', "");
    Expect(1, 125279, '\P{^Script=adlam}', "");
    Expect(0, 125280, '\p{Script=adlam}', "");
    Expect(1, 125280, '\p{^Script=adlam}', "");
    Expect(1, 125280, '\P{Script=adlam}', "");
    Expect(0, 125280, '\P{^Script=adlam}', "");
    Expect(1, 125279, '\p{Script=:\Aadlam\z:}', "");;
    Expect(0, 125280, '\p{Script=:\Aadlam\z:}', "");;
    Expect(1, 125279, '\p{Script= 	adlam}', "");
    Expect(0, 125279, '\p{^Script= 	adlam}', "");
    Expect(0, 125279, '\P{Script= 	adlam}', "");
    Expect(1, 125279, '\P{^Script= 	adlam}', "");
    Expect(0, 125280, '\p{Script= 	adlam}', "");
    Expect(1, 125280, '\p{^Script= 	adlam}', "");
    Expect(1, 125280, '\P{Script= 	adlam}', "");
    Expect(0, 125280, '\P{^Script= 	adlam}', "");
    Error('\p{Sc=_:=Adlm}');
    Error('\P{Sc=_:=Adlm}');
    Expect(1, 125279, '\p{Sc=:\AAdlm\z:}', "");;
    Expect(0, 125280, '\p{Sc=:\AAdlm\z:}', "");;
    Expect(1, 125279, '\p{Sc=adlm}', "");
    Expect(0, 125279, '\p{^Sc=adlm}', "");
    Expect(0, 125279, '\P{Sc=adlm}', "");
    Expect(1, 125279, '\P{^Sc=adlm}', "");
    Expect(0, 125280, '\p{Sc=adlm}', "");
    Expect(1, 125280, '\p{^Sc=adlm}', "");
    Expect(1, 125280, '\P{Sc=adlm}', "");
    Expect(0, 125280, '\P{^Sc=adlm}', "");
    Expect(1, 125279, '\p{Sc=:\Aadlm\z:}', "");;
    Expect(0, 125280, '\p{Sc=:\Aadlm\z:}', "");;
    Expect(1, 125279, '\p{Sc=_Adlm}', "");
    Expect(0, 125279, '\p{^Sc=_Adlm}', "");
    Expect(0, 125279, '\P{Sc=_Adlm}', "");
    Expect(1, 125279, '\P{^Sc=_Adlm}', "");
    Expect(0, 125280, '\p{Sc=_Adlm}', "");
    Expect(1, 125280, '\p{^Sc=_Adlm}', "");
    Expect(1, 125280, '\P{Sc=_Adlm}', "");
    Expect(0, 125280, '\P{^Sc=_Adlm}', "");
    Error('\p{Is_Script=:=Adlam}');
    Error('\P{Is_Script=:=Adlam}');
    Expect(1, 125279, '\p{Is_Script=adlam}', "");
    Expect(0, 125279, '\p{^Is_Script=adlam}', "");
    Expect(0, 125279, '\P{Is_Script=adlam}', "");
    Expect(1, 125279, '\P{^Is_Script=adlam}', "");
    Expect(0, 125280, '\p{Is_Script=adlam}', "");
    Expect(1, 125280, '\p{^Is_Script=adlam}', "");
    Expect(1, 125280, '\P{Is_Script=adlam}', "");
    Expect(0, 125280, '\P{^Is_Script=adlam}', "");
    Expect(1, 125279, '\p{Is_Script= _Adlam}', "");
    Expect(0, 125279, '\p{^Is_Script= _Adlam}', "");
    Expect(0, 125279, '\P{Is_Script= _Adlam}', "");
    Expect(1, 125279, '\P{^Is_Script= _Adlam}', "");
    Expect(0, 125280, '\p{Is_Script= _Adlam}', "");
    Expect(1, 125280, '\p{^Is_Script= _Adlam}', "");
    Expect(1, 125280, '\P{Is_Script= _Adlam}', "");
    Expect(0, 125280, '\P{^Is_Script= _Adlam}', "");
    Error('\p{Is_Sc=/a/_-Adlm}');
    Error('\P{Is_Sc=/a/_-Adlm}');
    Expect(1, 125279, '\p{Is_Sc=adlm}', "");
    Expect(0, 125279, '\p{^Is_Sc=adlm}', "");
    Expect(0, 125279, '\P{Is_Sc=adlm}', "");
    Expect(1, 125279, '\P{^Is_Sc=adlm}', "");
    Expect(0, 125280, '\p{Is_Sc=adlm}', "");
    Expect(1, 125280, '\p{^Is_Sc=adlm}', "");
    Expect(1, 125280, '\P{Is_Sc=adlm}', "");
    Expect(0, 125280, '\P{^Is_Sc=adlm}', "");
    Expect(1, 125279, '\p{Is_Sc=-Adlm}', "");
    Expect(0, 125279, '\p{^Is_Sc=-Adlm}', "");
    Expect(0, 125279, '\P{Is_Sc=-Adlm}', "");
    Expect(1, 125279, '\P{^Is_Sc=-Adlm}', "");
    Expect(0, 125280, '\p{Is_Sc=-Adlm}', "");
    Expect(1, 125280, '\p{^Is_Sc=-Adlm}', "");
    Expect(1, 125280, '\P{Is_Sc=-Adlm}', "");
    Expect(0, 125280, '\P{^Is_Sc=-Adlm}', "");
    Error('\p{Script=:=-	Caucasian_albanian}');
    Error('\P{Script=:=-	Caucasian_albanian}');
    Expect(1, 66927, '\p{Script=:\ACaucasian_Albanian\z:}', "");;
    Expect(0, 66928, '\p{Script=:\ACaucasian_Albanian\z:}', "");;
    Expect(1, 66927, '\p{Script: caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Script: caucasianalbanian}', "");
    Expect(0, 66927, '\P{Script: caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Script: caucasianalbanian}', "");
    Expect(0, 66928, '\p{Script: caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Script: caucasianalbanian}', "");
    Expect(1, 66928, '\P{Script: caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Script: caucasianalbanian}', "");
    Expect(1, 66927, '\p{Script=:\Acaucasianalbanian\z:}', "");;
    Expect(0, 66928, '\p{Script=:\Acaucasianalbanian\z:}', "");;
    Expect(1, 66927, '\p{Script=	-Caucasian_albanian}', "");
    Expect(0, 66927, '\p{^Script=	-Caucasian_albanian}', "");
    Expect(0, 66927, '\P{Script=	-Caucasian_albanian}', "");
    Expect(1, 66927, '\P{^Script=	-Caucasian_albanian}', "");
    Expect(0, 66928, '\p{Script=	-Caucasian_albanian}', "");
    Expect(1, 66928, '\p{^Script=	-Caucasian_albanian}', "");
    Expect(1, 66928, '\P{Script=	-Caucasian_albanian}', "");
    Expect(0, 66928, '\P{^Script=	-Caucasian_albanian}', "");
    Error('\p{Sc=_-aghb:=}');
    Error('\P{Sc=_-aghb:=}');
    Expect(1, 66927, '\p{Sc=:\AAghb\z:}', "");;
    Expect(0, 66928, '\p{Sc=:\AAghb\z:}', "");;
    Expect(1, 66927, '\p{Sc=aghb}', "");
    Expect(0, 66927, '\p{^Sc=aghb}', "");
    Expect(0, 66927, '\P{Sc=aghb}', "");
    Expect(1, 66927, '\P{^Sc=aghb}', "");
    Expect(0, 66928, '\p{Sc=aghb}', "");
    Expect(1, 66928, '\p{^Sc=aghb}', "");
    Expect(1, 66928, '\P{Sc=aghb}', "");
    Expect(0, 66928, '\P{^Sc=aghb}', "");
    Expect(1, 66927, '\p{Sc=:\Aaghb\z:}', "");;
    Expect(0, 66928, '\p{Sc=:\Aaghb\z:}', "");;
    Expect(1, 66927, '\p{Sc= -Aghb}', "");
    Expect(0, 66927, '\p{^Sc= -Aghb}', "");
    Expect(0, 66927, '\P{Sc= -Aghb}', "");
    Expect(1, 66927, '\P{^Sc= -Aghb}', "");
    Expect(0, 66928, '\p{Sc= -Aghb}', "");
    Expect(1, 66928, '\p{^Sc= -Aghb}', "");
    Expect(1, 66928, '\P{Sc= -Aghb}', "");
    Expect(0, 66928, '\P{^Sc= -Aghb}', "");
    Error('\p{Is_Script= _Caucasian_albanian:=}');
    Error('\P{Is_Script= _Caucasian_albanian:=}');
    Expect(1, 66927, '\p{Is_Script=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Is_Script=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Is_Script=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Is_Script=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Is_Script=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Is_Script=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Is_Script=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Is_Script=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Is_Script=_ CAUCASIAN_albanian}', "");
    Expect(0, 66927, '\p{^Is_Script=_ CAUCASIAN_albanian}', "");
    Expect(0, 66927, '\P{Is_Script=_ CAUCASIAN_albanian}', "");
    Expect(1, 66927, '\P{^Is_Script=_ CAUCASIAN_albanian}', "");
    Expect(0, 66928, '\p{Is_Script=_ CAUCASIAN_albanian}', "");
    Expect(1, 66928, '\p{^Is_Script=_ CAUCASIAN_albanian}', "");
    Expect(1, 66928, '\P{Is_Script=_ CAUCASIAN_albanian}', "");
    Expect(0, 66928, '\P{^Is_Script=_ CAUCASIAN_albanian}', "");
    Error('\p{Is_Sc=-/a/Aghb}');
    Error('\P{Is_Sc=-/a/Aghb}');
    Expect(1, 66927, '\p{Is_Sc=aghb}', "");
    Expect(0, 66927, '\p{^Is_Sc=aghb}', "");
    Expect(0, 66927, '\P{Is_Sc=aghb}', "");
    Expect(1, 66927, '\P{^Is_Sc=aghb}', "");
    Expect(0, 66928, '\p{Is_Sc=aghb}', "");
    Expect(1, 66928, '\p{^Is_Sc=aghb}', "");
    Expect(1, 66928, '\P{Is_Sc=aghb}', "");
    Expect(0, 66928, '\P{^Is_Sc=aghb}', "");
    Expect(1, 66927, '\p{Is_Sc= _Aghb}', "");
    Expect(0, 66927, '\p{^Is_Sc= _Aghb}', "");
    Expect(0, 66927, '\P{Is_Sc= _Aghb}', "");
    Expect(1, 66927, '\P{^Is_Sc= _Aghb}', "");
    Expect(0, 66928, '\p{Is_Sc= _Aghb}', "");
    Expect(1, 66928, '\p{^Is_Sc= _Aghb}', "");
    Expect(1, 66928, '\P{Is_Sc= _Aghb}', "");
    Expect(0, 66928, '\P{^Is_Sc= _Aghb}', "");
    Error('\p{Script=/a/-AHOM}');
    Error('\P{Script=/a/-AHOM}');
    Expect(1, 71487, '\p{Script=:\AAhom\z:}', "");;
    Expect(0, 71488, '\p{Script=:\AAhom\z:}', "");;
    Expect(1, 71487, '\p{Script:ahom}', "");
    Expect(0, 71487, '\p{^Script:ahom}', "");
    Expect(0, 71487, '\P{Script:ahom}', "");
    Expect(1, 71487, '\P{^Script:ahom}', "");
    Expect(0, 71488, '\p{Script:ahom}', "");
    Expect(1, 71488, '\p{^Script:ahom}', "");
    Expect(1, 71488, '\P{Script:ahom}', "");
    Expect(0, 71488, '\P{^Script:ahom}', "");
    Expect(1, 71487, '\p{Script=:\Aahom\z:}', "");;
    Expect(0, 71488, '\p{Script=:\Aahom\z:}', "");;
    Expect(1, 71487, '\p{Script=-Ahom}', "");
    Expect(0, 71487, '\p{^Script=-Ahom}', "");
    Expect(0, 71487, '\P{Script=-Ahom}', "");
    Expect(1, 71487, '\P{^Script=-Ahom}', "");
    Expect(0, 71488, '\p{Script=-Ahom}', "");
    Expect(1, 71488, '\p{^Script=-Ahom}', "");
    Expect(1, 71488, '\P{Script=-Ahom}', "");
    Expect(0, 71488, '\P{^Script=-Ahom}', "");
    Error('\p{Sc=_/a/Ahom}');
    Error('\P{Sc=_/a/Ahom}');
    Expect(1, 71487, '\p{Sc=:\AAhom\z:}', "");;
    Expect(0, 71488, '\p{Sc=:\AAhom\z:}', "");;
    Expect(1, 71487, '\p{Sc=ahom}', "");
    Expect(0, 71487, '\p{^Sc=ahom}', "");
    Expect(0, 71487, '\P{Sc=ahom}', "");
    Expect(1, 71487, '\P{^Sc=ahom}', "");
    Expect(0, 71488, '\p{Sc=ahom}', "");
    Expect(1, 71488, '\p{^Sc=ahom}', "");
    Expect(1, 71488, '\P{Sc=ahom}', "");
    Expect(0, 71488, '\P{^Sc=ahom}', "");
    Expect(1, 71487, '\p{Sc=:\Aahom\z:}', "");;
    Expect(0, 71488, '\p{Sc=:\Aahom\z:}', "");;
    Expect(1, 71487, '\p{Sc= _Ahom}', "");
    Expect(0, 71487, '\p{^Sc= _Ahom}', "");
    Expect(0, 71487, '\P{Sc= _Ahom}', "");
    Expect(1, 71487, '\P{^Sc= _Ahom}', "");
    Expect(0, 71488, '\p{Sc= _Ahom}', "");
    Expect(1, 71488, '\p{^Sc= _Ahom}', "");
    Expect(1, 71488, '\P{Sc= _Ahom}', "");
    Expect(0, 71488, '\P{^Sc= _Ahom}', "");
    Error('\p{Is_Script= _Ahom/a/}');
    Error('\P{Is_Script= _Ahom/a/}');
    Expect(1, 71487, '\p{Is_Script=ahom}', "");
    Expect(0, 71487, '\p{^Is_Script=ahom}', "");
    Expect(0, 71487, '\P{Is_Script=ahom}', "");
    Expect(1, 71487, '\P{^Is_Script=ahom}', "");
    Expect(0, 71488, '\p{Is_Script=ahom}', "");
    Expect(1, 71488, '\p{^Is_Script=ahom}', "");
    Expect(1, 71488, '\P{Is_Script=ahom}', "");
    Expect(0, 71488, '\P{^Is_Script=ahom}', "");
    Expect(1, 71487, '\p{Is_Script=- AHOM}', "");
    Expect(0, 71487, '\p{^Is_Script=- AHOM}', "");
    Expect(0, 71487, '\P{Is_Script=- AHOM}', "");
    Expect(1, 71487, '\P{^Is_Script=- AHOM}', "");
    Expect(0, 71488, '\p{Is_Script=- AHOM}', "");
    Expect(1, 71488, '\p{^Is_Script=- AHOM}', "");
    Expect(1, 71488, '\P{Is_Script=- AHOM}', "");
    Expect(0, 71488, '\P{^Is_Script=- AHOM}', "");
    Error('\p{Is_Sc:Ahom:=}');
    Error('\P{Is_Sc:Ahom:=}');
    Expect(1, 71487, '\p{Is_Sc=ahom}', "");
    Expect(0, 71487, '\p{^Is_Sc=ahom}', "");
    Expect(0, 71487, '\P{Is_Sc=ahom}', "");
    Expect(1, 71487, '\P{^Is_Sc=ahom}', "");
    Expect(0, 71488, '\p{Is_Sc=ahom}', "");
    Expect(1, 71488, '\p{^Is_Sc=ahom}', "");
    Expect(1, 71488, '\P{Is_Sc=ahom}', "");
    Expect(0, 71488, '\P{^Is_Sc=ahom}', "");
    Expect(1, 71487, '\p{Is_Sc=_AHOM}', "");
    Expect(0, 71487, '\p{^Is_Sc=_AHOM}', "");
    Expect(0, 71487, '\P{Is_Sc=_AHOM}', "");
    Expect(1, 71487, '\P{^Is_Sc=_AHOM}', "");
    Expect(0, 71488, '\p{Is_Sc=_AHOM}', "");
    Expect(1, 71488, '\p{^Is_Sc=_AHOM}', "");
    Expect(1, 71488, '\P{Is_Sc=_AHOM}', "");
    Expect(0, 71488, '\P{^Is_Sc=_AHOM}', "");
    Error('\p{Script=_-Arabic/a/}');
    Error('\P{Script=_-Arabic/a/}');
    Expect(1, 126705, '\p{Script=:\AArabic\z:}', "");;
    Expect(0, 126706, '\p{Script=:\AArabic\z:}', "");;
    Expect(1, 126705, '\p{Script=arabic}', "");
    Expect(0, 126705, '\p{^Script=arabic}', "");
    Expect(0, 126705, '\P{Script=arabic}', "");
    Expect(1, 126705, '\P{^Script=arabic}', "");
    Expect(0, 126706, '\p{Script=arabic}', "");
    Expect(1, 126706, '\p{^Script=arabic}', "");
    Expect(1, 126706, '\P{Script=arabic}', "");
    Expect(0, 126706, '\P{^Script=arabic}', "");
    Expect(1, 126705, '\p{Script=:\Aarabic\z:}', "");;
    Expect(0, 126706, '\p{Script=:\Aarabic\z:}', "");;
    Expect(1, 126705, '\p{Script=--arabic}', "");
    Expect(0, 126705, '\p{^Script=--arabic}', "");
    Expect(0, 126705, '\P{Script=--arabic}', "");
    Expect(1, 126705, '\P{^Script=--arabic}', "");
    Expect(0, 126706, '\p{Script=--arabic}', "");
    Expect(1, 126706, '\p{^Script=--arabic}', "");
    Expect(1, 126706, '\P{Script=--arabic}', "");
    Expect(0, 126706, '\P{^Script=--arabic}', "");
    Error('\p{Sc=:=_ARAB}');
    Error('\P{Sc=:=_ARAB}');
    Expect(1, 126705, '\p{Sc=:\AArab\z:}', "");;
    Expect(0, 126706, '\p{Sc=:\AArab\z:}', "");;
    Expect(1, 126705, '\p{Sc=arab}', "");
    Expect(0, 126705, '\p{^Sc=arab}', "");
    Expect(0, 126705, '\P{Sc=arab}', "");
    Expect(1, 126705, '\P{^Sc=arab}', "");
    Expect(0, 126706, '\p{Sc=arab}', "");
    Expect(1, 126706, '\p{^Sc=arab}', "");
    Expect(1, 126706, '\P{Sc=arab}', "");
    Expect(0, 126706, '\P{^Sc=arab}', "");
    Expect(1, 126705, '\p{Sc=:\Aarab\z:}', "");;
    Expect(0, 126706, '\p{Sc=:\Aarab\z:}', "");;
    Expect(1, 126705, '\p{Sc=_	ARAB}', "");
    Expect(0, 126705, '\p{^Sc=_	ARAB}', "");
    Expect(0, 126705, '\P{Sc=_	ARAB}', "");
    Expect(1, 126705, '\P{^Sc=_	ARAB}', "");
    Expect(0, 126706, '\p{Sc=_	ARAB}', "");
    Expect(1, 126706, '\p{^Sc=_	ARAB}', "");
    Expect(1, 126706, '\P{Sc=_	ARAB}', "");
    Expect(0, 126706, '\P{^Sc=_	ARAB}', "");
    Error('\p{Is_Script=_/a/Arabic}');
    Error('\P{Is_Script=_/a/Arabic}');
    Expect(1, 126705, '\p{Is_Script=arabic}', "");
    Expect(0, 126705, '\p{^Is_Script=arabic}', "");
    Expect(0, 126705, '\P{Is_Script=arabic}', "");
    Expect(1, 126705, '\P{^Is_Script=arabic}', "");
    Expect(0, 126706, '\p{Is_Script=arabic}', "");
    Expect(1, 126706, '\p{^Is_Script=arabic}', "");
    Expect(1, 126706, '\P{Is_Script=arabic}', "");
    Expect(0, 126706, '\P{^Is_Script=arabic}', "");
    Expect(1, 126705, '\p{Is_Script=_ Arabic}', "");
    Expect(0, 126705, '\p{^Is_Script=_ Arabic}', "");
    Expect(0, 126705, '\P{Is_Script=_ Arabic}', "");
    Expect(1, 126705, '\P{^Is_Script=_ Arabic}', "");
    Expect(0, 126706, '\p{Is_Script=_ Arabic}', "");
    Expect(1, 126706, '\p{^Is_Script=_ Arabic}', "");
    Expect(1, 126706, '\P{Is_Script=_ Arabic}', "");
    Expect(0, 126706, '\P{^Is_Script=_ Arabic}', "");
    Error('\p{Is_Sc=:=_arab}');
    Error('\P{Is_Sc=:=_arab}');
    Expect(1, 126705, '\p{Is_Sc=arab}', "");
    Expect(0, 126705, '\p{^Is_Sc=arab}', "");
    Expect(0, 126705, '\P{Is_Sc=arab}', "");
    Expect(1, 126705, '\P{^Is_Sc=arab}', "");
    Expect(0, 126706, '\p{Is_Sc=arab}', "");
    Expect(1, 126706, '\p{^Is_Sc=arab}', "");
    Expect(1, 126706, '\P{Is_Sc=arab}', "");
    Expect(0, 126706, '\P{^Is_Sc=arab}', "");
    Expect(1, 126705, '\p{Is_Sc=- ARAB}', "");
    Expect(0, 126705, '\p{^Is_Sc=- ARAB}', "");
    Expect(0, 126705, '\P{Is_Sc=- ARAB}', "");
    Expect(1, 126705, '\P{^Is_Sc=- ARAB}', "");
    Expect(0, 126706, '\p{Is_Sc=- ARAB}', "");
    Expect(1, 126706, '\p{^Is_Sc=- ARAB}', "");
    Expect(1, 126706, '\P{Is_Sc=- ARAB}', "");
    Expect(0, 126706, '\P{^Is_Sc=- ARAB}', "");
    Error('\p{Script= 	IMPERIAL_Aramaic/a/}');
    Error('\P{Script= 	IMPERIAL_Aramaic/a/}');
    Expect(1, 67679, '\p{Script=:\AImperial_Aramaic\z:}', "");;
    Expect(0, 67680, '\p{Script=:\AImperial_Aramaic\z:}', "");;
    Expect(1, 67679, '\p{Script=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Script=imperialaramaic}', "");
    Expect(0, 67679, '\P{Script=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Script=imperialaramaic}', "");
    Expect(0, 67680, '\p{Script=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Script=imperialaramaic}', "");
    Expect(1, 67680, '\P{Script=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Script=imperialaramaic}', "");
    Expect(1, 67679, '\p{Script=:\Aimperialaramaic\z:}', "");;
    Expect(0, 67680, '\p{Script=:\Aimperialaramaic\z:}', "");;
    Expect(1, 67679, '\p{Script= 	imperial_Aramaic}', "");
    Expect(0, 67679, '\p{^Script= 	imperial_Aramaic}', "");
    Expect(0, 67679, '\P{Script= 	imperial_Aramaic}', "");
    Expect(1, 67679, '\P{^Script= 	imperial_Aramaic}', "");
    Expect(0, 67680, '\p{Script= 	imperial_Aramaic}', "");
    Expect(1, 67680, '\p{^Script= 	imperial_Aramaic}', "");
    Expect(1, 67680, '\P{Script= 	imperial_Aramaic}', "");
    Expect(0, 67680, '\P{^Script= 	imperial_Aramaic}', "");
    Error('\p{Sc=--ARMI:=}');
    Error('\P{Sc=--ARMI:=}');
    Expect(1, 67679, '\p{Sc=:\AArmi\z:}', "");;
    Expect(0, 67680, '\p{Sc=:\AArmi\z:}', "");;
    Expect(1, 67679, '\p{Sc=armi}', "");
    Expect(0, 67679, '\p{^Sc=armi}', "");
    Expect(0, 67679, '\P{Sc=armi}', "");
    Expect(1, 67679, '\P{^Sc=armi}', "");
    Expect(0, 67680, '\p{Sc=armi}', "");
    Expect(1, 67680, '\p{^Sc=armi}', "");
    Expect(1, 67680, '\P{Sc=armi}', "");
    Expect(0, 67680, '\P{^Sc=armi}', "");
    Expect(1, 67679, '\p{Sc=:\Aarmi\z:}', "");;
    Expect(0, 67680, '\p{Sc=:\Aarmi\z:}', "");;
    Expect(1, 67679, '\p{Sc=_ armi}', "");
    Expect(0, 67679, '\p{^Sc=_ armi}', "");
    Expect(0, 67679, '\P{Sc=_ armi}', "");
    Expect(1, 67679, '\P{^Sc=_ armi}', "");
    Expect(0, 67680, '\p{Sc=_ armi}', "");
    Expect(1, 67680, '\p{^Sc=_ armi}', "");
    Expect(1, 67680, '\P{Sc=_ armi}', "");
    Expect(0, 67680, '\P{^Sc=_ armi}', "");
    Error('\p{Is_Script=:=-imperial_ARAMAIC}');
    Error('\P{Is_Script=:=-imperial_ARAMAIC}');
    Expect(1, 67679, '\p{Is_Script=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Is_Script=imperialaramaic}', "");
    Expect(0, 67679, '\P{Is_Script=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Is_Script=imperialaramaic}', "");
    Expect(0, 67680, '\p{Is_Script=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Is_Script=imperialaramaic}', "");
    Expect(1, 67680, '\P{Is_Script=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Is_Script=imperialaramaic}', "");
    Expect(1, 67679, '\p{Is_Script=	Imperial_Aramaic}', "");
    Expect(0, 67679, '\p{^Is_Script=	Imperial_Aramaic}', "");
    Expect(0, 67679, '\P{Is_Script=	Imperial_Aramaic}', "");
    Expect(1, 67679, '\P{^Is_Script=	Imperial_Aramaic}', "");
    Expect(0, 67680, '\p{Is_Script=	Imperial_Aramaic}', "");
    Expect(1, 67680, '\p{^Is_Script=	Imperial_Aramaic}', "");
    Expect(1, 67680, '\P{Is_Script=	Imperial_Aramaic}', "");
    Expect(0, 67680, '\P{^Is_Script=	Imperial_Aramaic}', "");
    Error('\p{Is_Sc=	/a/ARMI}');
    Error('\P{Is_Sc=	/a/ARMI}');
    Expect(1, 67679, '\p{Is_Sc=armi}', "");
    Expect(0, 67679, '\p{^Is_Sc=armi}', "");
    Expect(0, 67679, '\P{Is_Sc=armi}', "");
    Expect(1, 67679, '\P{^Is_Sc=armi}', "");
    Expect(0, 67680, '\p{Is_Sc=armi}', "");
    Expect(1, 67680, '\p{^Is_Sc=armi}', "");
    Expect(1, 67680, '\P{Is_Sc=armi}', "");
    Expect(0, 67680, '\P{^Is_Sc=armi}', "");
    Expect(1, 67679, '\p{Is_Sc=	ARMI}', "");
    Expect(0, 67679, '\p{^Is_Sc=	ARMI}', "");
    Expect(0, 67679, '\P{Is_Sc=	ARMI}', "");
    Expect(1, 67679, '\P{^Is_Sc=	ARMI}', "");
    Expect(0, 67680, '\p{Is_Sc=	ARMI}', "");
    Expect(1, 67680, '\p{^Is_Sc=	ARMI}', "");
    Expect(1, 67680, '\P{Is_Sc=	ARMI}', "");
    Expect(0, 67680, '\P{^Is_Sc=	ARMI}', "");
    Error('\p{Script=	:=Armenian}');
    Error('\P{Script=	:=Armenian}');
    Expect(1, 64279, '\p{Script=:\AArmenian\z:}', "");;
    Expect(0, 64280, '\p{Script=:\AArmenian\z:}', "");;
    Expect(1, 64279, '\p{Script=armenian}', "");
    Expect(0, 64279, '\p{^Script=armenian}', "");
    Expect(0, 64279, '\P{Script=armenian}', "");
    Expect(1, 64279, '\P{^Script=armenian}', "");
    Expect(0, 64280, '\p{Script=armenian}', "");
    Expect(1, 64280, '\p{^Script=armenian}', "");
    Expect(1, 64280, '\P{Script=armenian}', "");
    Expect(0, 64280, '\P{^Script=armenian}', "");
    Expect(1, 64279, '\p{Script=:\Aarmenian\z:}', "");;
    Expect(0, 64280, '\p{Script=:\Aarmenian\z:}', "");;
    Expect(1, 64279, '\p{Script=-_Armenian}', "");
    Expect(0, 64279, '\p{^Script=-_Armenian}', "");
    Expect(0, 64279, '\P{Script=-_Armenian}', "");
    Expect(1, 64279, '\P{^Script=-_Armenian}', "");
    Expect(0, 64280, '\p{Script=-_Armenian}', "");
    Expect(1, 64280, '\p{^Script=-_Armenian}', "");
    Expect(1, 64280, '\P{Script=-_Armenian}', "");
    Expect(0, 64280, '\P{^Script=-_Armenian}', "");
    Error('\p{Sc=:=	Armn}');
    Error('\P{Sc=:=	Armn}');
    Expect(1, 64279, '\p{Sc=:\AArmn\z:}', "");;
    Expect(0, 64280, '\p{Sc=:\AArmn\z:}', "");;
    Expect(1, 64279, '\p{Sc=armn}', "");
    Expect(0, 64279, '\p{^Sc=armn}', "");
    Expect(0, 64279, '\P{Sc=armn}', "");
    Expect(1, 64279, '\P{^Sc=armn}', "");
    Expect(0, 64280, '\p{Sc=armn}', "");
    Expect(1, 64280, '\p{^Sc=armn}', "");
    Expect(1, 64280, '\P{Sc=armn}', "");
    Expect(0, 64280, '\P{^Sc=armn}', "");
    Expect(1, 64279, '\p{Sc=:\Aarmn\z:}', "");;
    Expect(0, 64280, '\p{Sc=:\Aarmn\z:}', "");;
    Expect(1, 64279, '\p{Sc=	ARMN}', "");
    Expect(0, 64279, '\p{^Sc=	ARMN}', "");
    Expect(0, 64279, '\P{Sc=	ARMN}', "");
    Expect(1, 64279, '\P{^Sc=	ARMN}', "");
    Expect(0, 64280, '\p{Sc=	ARMN}', "");
    Expect(1, 64280, '\p{^Sc=	ARMN}', "");
    Expect(1, 64280, '\P{Sc=	ARMN}', "");
    Expect(0, 64280, '\P{^Sc=	ARMN}', "");
    Error('\p{Is_Script= :=Armenian}');
    Error('\P{Is_Script= :=Armenian}');
    Expect(1, 64279, '\p{Is_Script=armenian}', "");
    Expect(0, 64279, '\p{^Is_Script=armenian}', "");
    Expect(0, 64279, '\P{Is_Script=armenian}', "");
    Expect(1, 64279, '\P{^Is_Script=armenian}', "");
    Expect(0, 64280, '\p{Is_Script=armenian}', "");
    Expect(1, 64280, '\p{^Is_Script=armenian}', "");
    Expect(1, 64280, '\P{Is_Script=armenian}', "");
    Expect(0, 64280, '\P{^Is_Script=armenian}', "");
    Expect(1, 64279, '\p{Is_Script=  armenian}', "");
    Expect(0, 64279, '\p{^Is_Script=  armenian}', "");
    Expect(0, 64279, '\P{Is_Script=  armenian}', "");
    Expect(1, 64279, '\P{^Is_Script=  armenian}', "");
    Expect(0, 64280, '\p{Is_Script=  armenian}', "");
    Expect(1, 64280, '\p{^Is_Script=  armenian}', "");
    Expect(1, 64280, '\P{Is_Script=  armenian}', "");
    Expect(0, 64280, '\P{^Is_Script=  armenian}', "");
    Error('\p{Is_Sc=-	Armn:=}');
    Error('\P{Is_Sc=-	Armn:=}');
    Expect(1, 64279, '\p{Is_Sc=armn}', "");
    Expect(0, 64279, '\p{^Is_Sc=armn}', "");
    Expect(0, 64279, '\P{Is_Sc=armn}', "");
    Expect(1, 64279, '\P{^Is_Sc=armn}', "");
    Expect(0, 64280, '\p{Is_Sc=armn}', "");
    Expect(1, 64280, '\p{^Is_Sc=armn}', "");
    Expect(1, 64280, '\P{Is_Sc=armn}', "");
    Expect(0, 64280, '\P{^Is_Sc=armn}', "");
    Expect(1, 64279, '\p{Is_Sc=-Armn}', "");
    Expect(0, 64279, '\p{^Is_Sc=-Armn}', "");
    Expect(0, 64279, '\P{Is_Sc=-Armn}', "");
    Expect(1, 64279, '\P{^Is_Sc=-Armn}', "");
    Expect(0, 64280, '\p{Is_Sc=-Armn}', "");
    Expect(1, 64280, '\p{^Is_Sc=-Armn}', "");
    Expect(1, 64280, '\P{Is_Sc=-Armn}', "");
    Expect(0, 64280, '\P{^Is_Sc=-Armn}', "");
    Error('\p{Script=_:=Avestan}');
    Error('\P{Script=_:=Avestan}');
    Expect(1, 68415, '\p{Script=:\AAvestan\z:}', "");;
    Expect(0, 68416, '\p{Script=:\AAvestan\z:}', "");;
    Expect(1, 68415, '\p{Script=avestan}', "");
    Expect(0, 68415, '\p{^Script=avestan}', "");
    Expect(0, 68415, '\P{Script=avestan}', "");
    Expect(1, 68415, '\P{^Script=avestan}', "");
    Expect(0, 68416, '\p{Script=avestan}', "");
    Expect(1, 68416, '\p{^Script=avestan}', "");
    Expect(1, 68416, '\P{Script=avestan}', "");
    Expect(0, 68416, '\P{^Script=avestan}', "");
    Expect(1, 68415, '\p{Script=:\Aavestan\z:}', "");;
    Expect(0, 68416, '\p{Script=:\Aavestan\z:}', "");;
    Expect(1, 68415, '\p{Script:	-AVESTAN}', "");
    Expect(0, 68415, '\p{^Script:	-AVESTAN}', "");
    Expect(0, 68415, '\P{Script:	-AVESTAN}', "");
    Expect(1, 68415, '\P{^Script:	-AVESTAN}', "");
    Expect(0, 68416, '\p{Script:	-AVESTAN}', "");
    Expect(1, 68416, '\p{^Script:	-AVESTAN}', "");
    Expect(1, 68416, '\P{Script:	-AVESTAN}', "");
    Expect(0, 68416, '\P{^Script:	-AVESTAN}', "");
    Error('\p{Sc=:=_AVST}');
    Error('\P{Sc=:=_AVST}');
    Expect(1, 68415, '\p{Sc=:\AAvst\z:}', "");;
    Expect(0, 68416, '\p{Sc=:\AAvst\z:}', "");;
    Expect(1, 68415, '\p{Sc=avst}', "");
    Expect(0, 68415, '\p{^Sc=avst}', "");
    Expect(0, 68415, '\P{Sc=avst}', "");
    Expect(1, 68415, '\P{^Sc=avst}', "");
    Expect(0, 68416, '\p{Sc=avst}', "");
    Expect(1, 68416, '\p{^Sc=avst}', "");
    Expect(1, 68416, '\P{Sc=avst}', "");
    Expect(0, 68416, '\P{^Sc=avst}', "");
    Expect(1, 68415, '\p{Sc=:\Aavst\z:}', "");;
    Expect(0, 68416, '\p{Sc=:\Aavst\z:}', "");;
    Expect(1, 68415, '\p{Sc=	_avst}', "");
    Expect(0, 68415, '\p{^Sc=	_avst}', "");
    Expect(0, 68415, '\P{Sc=	_avst}', "");
    Expect(1, 68415, '\P{^Sc=	_avst}', "");
    Expect(0, 68416, '\p{Sc=	_avst}', "");
    Expect(1, 68416, '\p{^Sc=	_avst}', "");
    Expect(1, 68416, '\P{Sc=	_avst}', "");
    Expect(0, 68416, '\P{^Sc=	_avst}', "");
    Error('\p{Is_Script=/a/ avestan}');
    Error('\P{Is_Script=/a/ avestan}');
    Expect(1, 68415, '\p{Is_Script=avestan}', "");
    Expect(0, 68415, '\p{^Is_Script=avestan}', "");
    Expect(0, 68415, '\P{Is_Script=avestan}', "");
    Expect(1, 68415, '\P{^Is_Script=avestan}', "");
    Expect(0, 68416, '\p{Is_Script=avestan}', "");
    Expect(1, 68416, '\p{^Is_Script=avestan}', "");
    Expect(1, 68416, '\P{Is_Script=avestan}', "");
    Expect(0, 68416, '\P{^Is_Script=avestan}', "");
    Expect(1, 68415, '\p{Is_Script=-avestan}', "");
    Expect(0, 68415, '\p{^Is_Script=-avestan}', "");
    Expect(0, 68415, '\P{Is_Script=-avestan}', "");
    Expect(1, 68415, '\P{^Is_Script=-avestan}', "");
    Expect(0, 68416, '\p{Is_Script=-avestan}', "");
    Expect(1, 68416, '\p{^Is_Script=-avestan}', "");
    Expect(1, 68416, '\P{Is_Script=-avestan}', "");
    Expect(0, 68416, '\P{^Is_Script=-avestan}', "");
    Error('\p{Is_Sc=:=Avst}');
    Error('\P{Is_Sc=:=Avst}');
    Expect(1, 68415, '\p{Is_Sc=avst}', "");
    Expect(0, 68415, '\p{^Is_Sc=avst}', "");
    Expect(0, 68415, '\P{Is_Sc=avst}', "");
    Expect(1, 68415, '\P{^Is_Sc=avst}', "");
    Expect(0, 68416, '\p{Is_Sc=avst}', "");
    Expect(1, 68416, '\p{^Is_Sc=avst}', "");
    Expect(1, 68416, '\P{Is_Sc=avst}', "");
    Expect(0, 68416, '\P{^Is_Sc=avst}', "");
    Expect(1, 68415, '\p{Is_Sc=_	avst}', "");
    Expect(0, 68415, '\p{^Is_Sc=_	avst}', "");
    Expect(0, 68415, '\P{Is_Sc=_	avst}', "");
    Expect(1, 68415, '\P{^Is_Sc=_	avst}', "");
    Expect(0, 68416, '\p{Is_Sc=_	avst}', "");
    Expect(1, 68416, '\p{^Is_Sc=_	avst}', "");
    Expect(1, 68416, '\P{Is_Sc=_	avst}', "");
    Expect(0, 68416, '\P{^Is_Sc=_	avst}', "");
    Error('\p{Script=/a/ BALINESE}');
    Error('\P{Script=/a/ BALINESE}');
    Expect(1, 7036, '\p{Script=:\ABalinese\z:}', "");;
    Expect(0, 7037, '\p{Script=:\ABalinese\z:}', "");;
    Expect(1, 7036, '\p{Script=balinese}', "");
    Expect(0, 7036, '\p{^Script=balinese}', "");
    Expect(0, 7036, '\P{Script=balinese}', "");
    Expect(1, 7036, '\P{^Script=balinese}', "");
    Expect(0, 7037, '\p{Script=balinese}', "");
    Expect(1, 7037, '\p{^Script=balinese}', "");
    Expect(1, 7037, '\P{Script=balinese}', "");
    Expect(0, 7037, '\P{^Script=balinese}', "");
    Expect(1, 7036, '\p{Script=:\Abalinese\z:}', "");;
    Expect(0, 7037, '\p{Script=:\Abalinese\z:}', "");;
    Expect(1, 7036, '\p{Script=-Balinese}', "");
    Expect(0, 7036, '\p{^Script=-Balinese}', "");
    Expect(0, 7036, '\P{Script=-Balinese}', "");
    Expect(1, 7036, '\P{^Script=-Balinese}', "");
    Expect(0, 7037, '\p{Script=-Balinese}', "");
    Expect(1, 7037, '\p{^Script=-Balinese}', "");
    Expect(1, 7037, '\P{Script=-Balinese}', "");
    Expect(0, 7037, '\P{^Script=-Balinese}', "");
    Error('\p{Sc=:=-bali}');
    Error('\P{Sc=:=-bali}');
    Expect(1, 7036, '\p{Sc=:\ABali\z:}', "");;
    Expect(0, 7037, '\p{Sc=:\ABali\z:}', "");;
    Expect(1, 7036, '\p{Sc=bali}', "");
    Expect(0, 7036, '\p{^Sc=bali}', "");
    Expect(0, 7036, '\P{Sc=bali}', "");
    Expect(1, 7036, '\P{^Sc=bali}', "");
    Expect(0, 7037, '\p{Sc=bali}', "");
    Expect(1, 7037, '\p{^Sc=bali}', "");
    Expect(1, 7037, '\P{Sc=bali}', "");
    Expect(0, 7037, '\P{^Sc=bali}', "");
    Expect(1, 7036, '\p{Sc=:\Abali\z:}', "");;
    Expect(0, 7037, '\p{Sc=:\Abali\z:}', "");;
    Expect(1, 7036, '\p{Sc:  _BALI}', "");
    Expect(0, 7036, '\p{^Sc:  _BALI}', "");
    Expect(0, 7036, '\P{Sc:  _BALI}', "");
    Expect(1, 7036, '\P{^Sc:  _BALI}', "");
    Expect(0, 7037, '\p{Sc:  _BALI}', "");
    Expect(1, 7037, '\p{^Sc:  _BALI}', "");
    Expect(1, 7037, '\P{Sc:  _BALI}', "");
    Expect(0, 7037, '\P{^Sc:  _BALI}', "");
    Error('\p{Is_Script=  balinese:=}');
    Error('\P{Is_Script=  balinese:=}');
    Expect(1, 7036, '\p{Is_Script=balinese}', "");
    Expect(0, 7036, '\p{^Is_Script=balinese}', "");
    Expect(0, 7036, '\P{Is_Script=balinese}', "");
    Expect(1, 7036, '\P{^Is_Script=balinese}', "");
    Expect(0, 7037, '\p{Is_Script=balinese}', "");
    Expect(1, 7037, '\p{^Is_Script=balinese}', "");
    Expect(1, 7037, '\P{Is_Script=balinese}', "");
    Expect(0, 7037, '\P{^Is_Script=balinese}', "");
    Expect(1, 7036, '\p{Is_Script=_	balinese}', "");
    Expect(0, 7036, '\p{^Is_Script=_	balinese}', "");
    Expect(0, 7036, '\P{Is_Script=_	balinese}', "");
    Expect(1, 7036, '\P{^Is_Script=_	balinese}', "");
    Expect(0, 7037, '\p{Is_Script=_	balinese}', "");
    Expect(1, 7037, '\p{^Is_Script=_	balinese}', "");
    Expect(1, 7037, '\P{Is_Script=_	balinese}', "");
    Expect(0, 7037, '\P{^Is_Script=_	balinese}', "");
    Error('\p{Is_Sc= :=BALI}');
    Error('\P{Is_Sc= :=BALI}');
    Expect(1, 7036, '\p{Is_Sc=bali}', "");
    Expect(0, 7036, '\p{^Is_Sc=bali}', "");
    Expect(0, 7036, '\P{Is_Sc=bali}', "");
    Expect(1, 7036, '\P{^Is_Sc=bali}', "");
    Expect(0, 7037, '\p{Is_Sc=bali}', "");
    Expect(1, 7037, '\p{^Is_Sc=bali}', "");
    Expect(1, 7037, '\P{Is_Sc=bali}', "");
    Expect(0, 7037, '\P{^Is_Sc=bali}', "");
    Expect(1, 7036, '\p{Is_Sc=	Bali}', "");
    Expect(0, 7036, '\p{^Is_Sc=	Bali}', "");
    Expect(0, 7036, '\P{Is_Sc=	Bali}', "");
    Expect(1, 7036, '\P{^Is_Sc=	Bali}', "");
    Expect(0, 7037, '\p{Is_Sc=	Bali}', "");
    Expect(1, 7037, '\p{^Is_Sc=	Bali}', "");
    Expect(1, 7037, '\P{Is_Sc=	Bali}', "");
    Expect(0, 7037, '\P{^Is_Sc=	Bali}', "");
    Error('\p{Script=/a/ _Bamum}');
    Error('\P{Script=/a/ _Bamum}');
    Expect(1, 92728, '\p{Script=:\ABamum\z:}', "");;
    Expect(0, 92729, '\p{Script=:\ABamum\z:}', "");;
    Expect(1, 92728, '\p{Script=bamum}', "");
    Expect(0, 92728, '\p{^Script=bamum}', "");
    Expect(0, 92728, '\P{Script=bamum}', "");
    Expect(1, 92728, '\P{^Script=bamum}', "");
    Expect(0, 92729, '\p{Script=bamum}', "");
    Expect(1, 92729, '\p{^Script=bamum}', "");
    Expect(1, 92729, '\P{Script=bamum}', "");
    Expect(0, 92729, '\P{^Script=bamum}', "");
    Expect(1, 92728, '\p{Script=:\Abamum\z:}', "");;
    Expect(0, 92729, '\p{Script=:\Abamum\z:}', "");;
    Expect(1, 92728, '\p{Script= 	Bamum}', "");
    Expect(0, 92728, '\p{^Script= 	Bamum}', "");
    Expect(0, 92728, '\P{Script= 	Bamum}', "");
    Expect(1, 92728, '\P{^Script= 	Bamum}', "");
    Expect(0, 92729, '\p{Script= 	Bamum}', "");
    Expect(1, 92729, '\p{^Script= 	Bamum}', "");
    Expect(1, 92729, '\P{Script= 	Bamum}', "");
    Expect(0, 92729, '\P{^Script= 	Bamum}', "");
    Error('\p{Sc=  Bamu/a/}');
    Error('\P{Sc=  Bamu/a/}');
    Expect(1, 92728, '\p{Sc=:\ABamu\z:}', "");;
    Expect(0, 92729, '\p{Sc=:\ABamu\z:}', "");;
    Expect(1, 92728, '\p{Sc:	bamu}', "");
    Expect(0, 92728, '\p{^Sc:	bamu}', "");
    Expect(0, 92728, '\P{Sc:	bamu}', "");
    Expect(1, 92728, '\P{^Sc:	bamu}', "");
    Expect(0, 92729, '\p{Sc:	bamu}', "");
    Expect(1, 92729, '\p{^Sc:	bamu}', "");
    Expect(1, 92729, '\P{Sc:	bamu}', "");
    Expect(0, 92729, '\P{^Sc:	bamu}', "");
    Expect(1, 92728, '\p{Sc=:\Abamu\z:}', "");;
    Expect(0, 92729, '\p{Sc=:\Abamu\z:}', "");;
    Expect(1, 92728, '\p{Sc=-Bamu}', "");
    Expect(0, 92728, '\p{^Sc=-Bamu}', "");
    Expect(0, 92728, '\P{Sc=-Bamu}', "");
    Expect(1, 92728, '\P{^Sc=-Bamu}', "");
    Expect(0, 92729, '\p{Sc=-Bamu}', "");
    Expect(1, 92729, '\p{^Sc=-Bamu}', "");
    Expect(1, 92729, '\P{Sc=-Bamu}', "");
    Expect(0, 92729, '\P{^Sc=-Bamu}', "");
    Error('\p{Is_Script=:=_Bamum}');
    Error('\P{Is_Script=:=_Bamum}');
    Expect(1, 92728, '\p{Is_Script=bamum}', "");
    Expect(0, 92728, '\p{^Is_Script=bamum}', "");
    Expect(0, 92728, '\P{Is_Script=bamum}', "");
    Expect(1, 92728, '\P{^Is_Script=bamum}', "");
    Expect(0, 92729, '\p{Is_Script=bamum}', "");
    Expect(1, 92729, '\p{^Is_Script=bamum}', "");
    Expect(1, 92729, '\P{Is_Script=bamum}', "");
    Expect(0, 92729, '\P{^Is_Script=bamum}', "");
    Expect(1, 92728, '\p{Is_Script=-_BAMUM}', "");
    Expect(0, 92728, '\p{^Is_Script=-_BAMUM}', "");
    Expect(0, 92728, '\P{Is_Script=-_BAMUM}', "");
    Expect(1, 92728, '\P{^Is_Script=-_BAMUM}', "");
    Expect(0, 92729, '\p{Is_Script=-_BAMUM}', "");
    Expect(1, 92729, '\p{^Is_Script=-_BAMUM}', "");
    Expect(1, 92729, '\P{Is_Script=-_BAMUM}', "");
    Expect(0, 92729, '\P{^Is_Script=-_BAMUM}', "");
    Error('\p{Is_Sc=/a/	_Bamu}');
    Error('\P{Is_Sc=/a/	_Bamu}');
    Expect(1, 92728, '\p{Is_Sc=bamu}', "");
    Expect(0, 92728, '\p{^Is_Sc=bamu}', "");
    Expect(0, 92728, '\P{Is_Sc=bamu}', "");
    Expect(1, 92728, '\P{^Is_Sc=bamu}', "");
    Expect(0, 92729, '\p{Is_Sc=bamu}', "");
    Expect(1, 92729, '\p{^Is_Sc=bamu}', "");
    Expect(1, 92729, '\P{Is_Sc=bamu}', "");
    Expect(0, 92729, '\P{^Is_Sc=bamu}', "");
    Expect(1, 92728, '\p{Is_Sc=--Bamu}', "");
    Expect(0, 92728, '\p{^Is_Sc=--Bamu}', "");
    Expect(0, 92728, '\P{Is_Sc=--Bamu}', "");
    Expect(1, 92728, '\P{^Is_Sc=--Bamu}', "");
    Expect(0, 92729, '\p{Is_Sc=--Bamu}', "");
    Expect(1, 92729, '\p{^Is_Sc=--Bamu}', "");
    Expect(1, 92729, '\P{Is_Sc=--Bamu}', "");
    Expect(0, 92729, '\P{^Is_Sc=--Bamu}', "");
    Error('\p{Script=__Bassa_Vah:=}');
    Error('\P{Script=__Bassa_Vah:=}');
    Expect(1, 92917, '\p{Script=:\ABassa_Vah\z:}', "");;
    Expect(0, 92918, '\p{Script=:\ABassa_Vah\z:}', "");;
    Expect(1, 92917, '\p{Script=bassavah}', "");
    Expect(0, 92917, '\p{^Script=bassavah}', "");
    Expect(0, 92917, '\P{Script=bassavah}', "");
    Expect(1, 92917, '\P{^Script=bassavah}', "");
    Expect(0, 92918, '\p{Script=bassavah}', "");
    Expect(1, 92918, '\p{^Script=bassavah}', "");
    Expect(1, 92918, '\P{Script=bassavah}', "");
    Expect(0, 92918, '\P{^Script=bassavah}', "");
    Expect(1, 92917, '\p{Script=:\Abassavah\z:}', "");;
    Expect(0, 92918, '\p{Script=:\Abassavah\z:}', "");;
    Expect(1, 92917, '\p{Script=	_BASSA_Vah}', "");
    Expect(0, 92917, '\p{^Script=	_BASSA_Vah}', "");
    Expect(0, 92917, '\P{Script=	_BASSA_Vah}', "");
    Expect(1, 92917, '\P{^Script=	_BASSA_Vah}', "");
    Expect(0, 92918, '\p{Script=	_BASSA_Vah}', "");
    Expect(1, 92918, '\p{^Script=	_BASSA_Vah}', "");
    Expect(1, 92918, '\P{Script=	_BASSA_Vah}', "");
    Expect(0, 92918, '\P{^Script=	_BASSA_Vah}', "");
    Error('\p{Sc=/a/_-BASS}');
    Error('\P{Sc=/a/_-BASS}');
    Expect(1, 92917, '\p{Sc=:\ABass\z:}', "");;
    Expect(0, 92918, '\p{Sc=:\ABass\z:}', "");;
    Expect(1, 92917, '\p{Sc=bass}', "");
    Expect(0, 92917, '\p{^Sc=bass}', "");
    Expect(0, 92917, '\P{Sc=bass}', "");
    Expect(1, 92917, '\P{^Sc=bass}', "");
    Expect(0, 92918, '\p{Sc=bass}', "");
    Expect(1, 92918, '\p{^Sc=bass}', "");
    Expect(1, 92918, '\P{Sc=bass}', "");
    Expect(0, 92918, '\P{^Sc=bass}', "");
    Expect(1, 92917, '\p{Sc=:\Abass\z:}', "");;
    Expect(0, 92918, '\p{Sc=:\Abass\z:}', "");;
    Expect(1, 92917, '\p{Sc=-_Bass}', "");
    Expect(0, 92917, '\p{^Sc=-_Bass}', "");
    Expect(0, 92917, '\P{Sc=-_Bass}', "");
    Expect(1, 92917, '\P{^Sc=-_Bass}', "");
    Expect(0, 92918, '\p{Sc=-_Bass}', "");
    Expect(1, 92918, '\p{^Sc=-_Bass}', "");
    Expect(1, 92918, '\P{Sc=-_Bass}', "");
    Expect(0, 92918, '\P{^Sc=-_Bass}', "");
    Error('\p{Is_Script: /a/_bassa_VAH}');
    Error('\P{Is_Script: /a/_bassa_VAH}');
    Expect(1, 92917, '\p{Is_Script=bassavah}', "");
    Expect(0, 92917, '\p{^Is_Script=bassavah}', "");
    Expect(0, 92917, '\P{Is_Script=bassavah}', "");
    Expect(1, 92917, '\P{^Is_Script=bassavah}', "");
    Expect(0, 92918, '\p{Is_Script=bassavah}', "");
    Expect(1, 92918, '\p{^Is_Script=bassavah}', "");
    Expect(1, 92918, '\P{Is_Script=bassavah}', "");
    Expect(0, 92918, '\P{^Is_Script=bassavah}', "");
    Expect(1, 92917, '\p{Is_Script=_-Bassa_VAH}', "");
    Expect(0, 92917, '\p{^Is_Script=_-Bassa_VAH}', "");
    Expect(0, 92917, '\P{Is_Script=_-Bassa_VAH}', "");
    Expect(1, 92917, '\P{^Is_Script=_-Bassa_VAH}', "");
    Expect(0, 92918, '\p{Is_Script=_-Bassa_VAH}', "");
    Expect(1, 92918, '\p{^Is_Script=_-Bassa_VAH}', "");
    Expect(1, 92918, '\P{Is_Script=_-Bassa_VAH}', "");
    Expect(0, 92918, '\P{^Is_Script=_-Bassa_VAH}', "");
    Error('\p{Is_Sc=:=_-BASS}');
    Error('\P{Is_Sc=:=_-BASS}');
    Expect(1, 92917, '\p{Is_Sc=bass}', "");
    Expect(0, 92917, '\p{^Is_Sc=bass}', "");
    Expect(0, 92917, '\P{Is_Sc=bass}', "");
    Expect(1, 92917, '\P{^Is_Sc=bass}', "");
    Expect(0, 92918, '\p{Is_Sc=bass}', "");
    Expect(1, 92918, '\p{^Is_Sc=bass}', "");
    Expect(1, 92918, '\P{Is_Sc=bass}', "");
    Expect(0, 92918, '\P{^Is_Sc=bass}', "");
    Expect(1, 92917, '\p{Is_Sc=_ bass}', "");
    Expect(0, 92917, '\p{^Is_Sc=_ bass}', "");
    Expect(0, 92917, '\P{Is_Sc=_ bass}', "");
    Expect(1, 92917, '\P{^Is_Sc=_ bass}', "");
    Expect(0, 92918, '\p{Is_Sc=_ bass}', "");
    Expect(1, 92918, '\p{^Is_Sc=_ bass}', "");
    Expect(1, 92918, '\P{Is_Sc=_ bass}', "");
    Expect(0, 92918, '\P{^Is_Sc=_ bass}', "");
    Error('\p{Script= :=Batak}');
    Error('\P{Script= :=Batak}');
    Expect(1, 7167, '\p{Script=:\ABatak\z:}', "");;
    Expect(0, 7168, '\p{Script=:\ABatak\z:}', "");;
    Expect(1, 7167, '\p{Script=batak}', "");
    Expect(0, 7167, '\p{^Script=batak}', "");
    Expect(0, 7167, '\P{Script=batak}', "");
    Expect(1, 7167, '\P{^Script=batak}', "");
    Expect(0, 7168, '\p{Script=batak}', "");
    Expect(1, 7168, '\p{^Script=batak}', "");
    Expect(1, 7168, '\P{Script=batak}', "");
    Expect(0, 7168, '\P{^Script=batak}', "");
    Expect(1, 7167, '\p{Script=:\Abatak\z:}', "");;
    Expect(0, 7168, '\p{Script=:\Abatak\z:}', "");;
    Expect(1, 7167, '\p{Script=- Batak}', "");
    Expect(0, 7167, '\p{^Script=- Batak}', "");
    Expect(0, 7167, '\P{Script=- Batak}', "");
    Expect(1, 7167, '\P{^Script=- Batak}', "");
    Expect(0, 7168, '\p{Script=- Batak}', "");
    Expect(1, 7168, '\p{^Script=- Batak}', "");
    Expect(1, 7168, '\P{Script=- Batak}', "");
    Expect(0, 7168, '\P{^Script=- Batak}', "");
    Error('\p{Sc:    :=Batk}');
    Error('\P{Sc:    :=Batk}');
    Expect(1, 7167, '\p{Sc=:\ABatk\z:}', "");;
    Expect(0, 7168, '\p{Sc=:\ABatk\z:}', "");;
    Expect(1, 7167, '\p{Sc=batk}', "");
    Expect(0, 7167, '\p{^Sc=batk}', "");
    Expect(0, 7167, '\P{Sc=batk}', "");
    Expect(1, 7167, '\P{^Sc=batk}', "");
    Expect(0, 7168, '\p{Sc=batk}', "");
    Expect(1, 7168, '\p{^Sc=batk}', "");
    Expect(1, 7168, '\P{Sc=batk}', "");
    Expect(0, 7168, '\P{^Sc=batk}', "");
    Expect(1, 7167, '\p{Sc=:\Abatk\z:}', "");;
    Expect(0, 7168, '\p{Sc=:\Abatk\z:}', "");;
    Expect(1, 7167, '\p{Sc=	-Batk}', "");
    Expect(0, 7167, '\p{^Sc=	-Batk}', "");
    Expect(0, 7167, '\P{Sc=	-Batk}', "");
    Expect(1, 7167, '\P{^Sc=	-Batk}', "");
    Expect(0, 7168, '\p{Sc=	-Batk}', "");
    Expect(1, 7168, '\p{^Sc=	-Batk}', "");
    Expect(1, 7168, '\P{Sc=	-Batk}', "");
    Expect(0, 7168, '\P{^Sc=	-Batk}', "");
    Error('\p{Is_Script=/a/	BATAK}');
    Error('\P{Is_Script=/a/	BATAK}');
    Expect(1, 7167, '\p{Is_Script=batak}', "");
    Expect(0, 7167, '\p{^Is_Script=batak}', "");
    Expect(0, 7167, '\P{Is_Script=batak}', "");
    Expect(1, 7167, '\P{^Is_Script=batak}', "");
    Expect(0, 7168, '\p{Is_Script=batak}', "");
    Expect(1, 7168, '\p{^Is_Script=batak}', "");
    Expect(1, 7168, '\P{Is_Script=batak}', "");
    Expect(0, 7168, '\P{^Is_Script=batak}', "");
    Expect(1, 7167, '\p{Is_Script:	-batak}', "");
    Expect(0, 7167, '\p{^Is_Script:	-batak}', "");
    Expect(0, 7167, '\P{Is_Script:	-batak}', "");
    Expect(1, 7167, '\P{^Is_Script:	-batak}', "");
    Expect(0, 7168, '\p{Is_Script:	-batak}', "");
    Expect(1, 7168, '\p{^Is_Script:	-batak}', "");
    Expect(1, 7168, '\P{Is_Script:	-batak}', "");
    Expect(0, 7168, '\P{^Is_Script:	-batak}', "");
    Error('\p{Is_Sc=:= Batk}');
    Error('\P{Is_Sc=:= Batk}');
    Expect(1, 7167, '\p{Is_Sc=batk}', "");
    Expect(0, 7167, '\p{^Is_Sc=batk}', "");
    Expect(0, 7167, '\P{Is_Sc=batk}', "");
    Expect(1, 7167, '\P{^Is_Sc=batk}', "");
    Expect(0, 7168, '\p{Is_Sc=batk}', "");
    Expect(1, 7168, '\p{^Is_Sc=batk}', "");
    Expect(1, 7168, '\P{Is_Sc=batk}', "");
    Expect(0, 7168, '\P{^Is_Sc=batk}', "");
    Expect(1, 7167, '\p{Is_Sc=--BATK}', "");
    Expect(0, 7167, '\p{^Is_Sc=--BATK}', "");
    Expect(0, 7167, '\P{Is_Sc=--BATK}', "");
    Expect(1, 7167, '\P{^Is_Sc=--BATK}', "");
    Expect(0, 7168, '\p{Is_Sc=--BATK}', "");
    Expect(1, 7168, '\p{^Is_Sc=--BATK}', "");
    Expect(1, 7168, '\P{Is_Sc=--BATK}', "");
    Expect(0, 7168, '\P{^Is_Sc=--BATK}', "");
    Error('\p{Script=-:=BENGALI}');
    Error('\P{Script=-:=BENGALI}');
    Expect(1, 2558, '\p{Script=:\ABengali\z:}', "");;
    Expect(0, 2559, '\p{Script=:\ABengali\z:}', "");;
    Expect(1, 2558, '\p{Script=bengali}', "");
    Expect(0, 2558, '\p{^Script=bengali}', "");
    Expect(0, 2558, '\P{Script=bengali}', "");
    Expect(1, 2558, '\P{^Script=bengali}', "");
    Expect(0, 2559, '\p{Script=bengali}', "");
    Expect(1, 2559, '\p{^Script=bengali}', "");
    Expect(1, 2559, '\P{Script=bengali}', "");
    Expect(0, 2559, '\P{^Script=bengali}', "");
    Expect(1, 2558, '\p{Script=:\Abengali\z:}', "");;
    Expect(0, 2559, '\p{Script=:\Abengali\z:}', "");;
    Expect(1, 2558, '\p{Script=		Bengali}', "");
    Expect(0, 2558, '\p{^Script=		Bengali}', "");
    Expect(0, 2558, '\P{Script=		Bengali}', "");
    Expect(1, 2558, '\P{^Script=		Bengali}', "");
    Expect(0, 2559, '\p{Script=		Bengali}', "");
    Expect(1, 2559, '\p{^Script=		Bengali}', "");
    Expect(1, 2559, '\P{Script=		Bengali}', "");
    Expect(0, 2559, '\P{^Script=		Bengali}', "");
    Error('\p{Sc:	 /a/Beng}');
    Error('\P{Sc:	 /a/Beng}');
    Expect(1, 2558, '\p{Sc=:\ABeng\z:}', "");;
    Expect(0, 2559, '\p{Sc=:\ABeng\z:}', "");;
    Expect(1, 2558, '\p{Sc=beng}', "");
    Expect(0, 2558, '\p{^Sc=beng}', "");
    Expect(0, 2558, '\P{Sc=beng}', "");
    Expect(1, 2558, '\P{^Sc=beng}', "");
    Expect(0, 2559, '\p{Sc=beng}', "");
    Expect(1, 2559, '\p{^Sc=beng}', "");
    Expect(1, 2559, '\P{Sc=beng}', "");
    Expect(0, 2559, '\P{^Sc=beng}', "");
    Expect(1, 2558, '\p{Sc=:\Abeng\z:}', "");;
    Expect(0, 2559, '\p{Sc=:\Abeng\z:}', "");;
    Expect(1, 2558, '\p{Sc=-Beng}', "");
    Expect(0, 2558, '\p{^Sc=-Beng}', "");
    Expect(0, 2558, '\P{Sc=-Beng}', "");
    Expect(1, 2558, '\P{^Sc=-Beng}', "");
    Expect(0, 2559, '\p{Sc=-Beng}', "");
    Expect(1, 2559, '\p{^Sc=-Beng}', "");
    Expect(1, 2559, '\P{Sc=-Beng}', "");
    Expect(0, 2559, '\P{^Sc=-Beng}', "");
    Error('\p{Is_Script: -/a/bengali}');
    Error('\P{Is_Script: -/a/bengali}');
    Expect(1, 2558, '\p{Is_Script: bengali}', "");
    Expect(0, 2558, '\p{^Is_Script: bengali}', "");
    Expect(0, 2558, '\P{Is_Script: bengali}', "");
    Expect(1, 2558, '\P{^Is_Script: bengali}', "");
    Expect(0, 2559, '\p{Is_Script: bengali}', "");
    Expect(1, 2559, '\p{^Is_Script: bengali}', "");
    Expect(1, 2559, '\P{Is_Script: bengali}', "");
    Expect(0, 2559, '\P{^Is_Script: bengali}', "");
    Expect(1, 2558, '\p{Is_Script: 	Bengali}', "");
    Expect(0, 2558, '\p{^Is_Script: 	Bengali}', "");
    Expect(0, 2558, '\P{Is_Script: 	Bengali}', "");
    Expect(1, 2558, '\P{^Is_Script: 	Bengali}', "");
    Expect(0, 2559, '\p{Is_Script: 	Bengali}', "");
    Expect(1, 2559, '\p{^Is_Script: 	Bengali}', "");
    Expect(1, 2559, '\P{Is_Script: 	Bengali}', "");
    Expect(0, 2559, '\P{^Is_Script: 	Bengali}', "");
    Error('\p{Is_Sc=/a/--BENG}');
    Error('\P{Is_Sc=/a/--BENG}');
    Expect(1, 2558, '\p{Is_Sc=beng}', "");
    Expect(0, 2558, '\p{^Is_Sc=beng}', "");
    Expect(0, 2558, '\P{Is_Sc=beng}', "");
    Expect(1, 2558, '\P{^Is_Sc=beng}', "");
    Expect(0, 2559, '\p{Is_Sc=beng}', "");
    Expect(1, 2559, '\p{^Is_Sc=beng}', "");
    Expect(1, 2559, '\P{Is_Sc=beng}', "");
    Expect(0, 2559, '\P{^Is_Sc=beng}', "");
    Expect(1, 2558, '\p{Is_Sc=	_beng}', "");
    Expect(0, 2558, '\p{^Is_Sc=	_beng}', "");
    Expect(0, 2558, '\P{Is_Sc=	_beng}', "");
    Expect(1, 2558, '\P{^Is_Sc=	_beng}', "");
    Expect(0, 2559, '\p{Is_Sc=	_beng}', "");
    Expect(1, 2559, '\p{^Is_Sc=	_beng}', "");
    Expect(1, 2559, '\P{Is_Sc=	_beng}', "");
    Expect(0, 2559, '\P{^Is_Sc=	_beng}', "");
    Error('\p{Script: :=		Bhaiksuki}');
    Error('\P{Script: :=		Bhaiksuki}');
    Expect(1, 72812, '\p{Script=:\ABhaiksuki\z:}', "");;
    Expect(0, 72813, '\p{Script=:\ABhaiksuki\z:}', "");;
    Expect(1, 72812, '\p{Script=bhaiksuki}', "");
    Expect(0, 72812, '\p{^Script=bhaiksuki}', "");
    Expect(0, 72812, '\P{Script=bhaiksuki}', "");
    Expect(1, 72812, '\P{^Script=bhaiksuki}', "");
    Expect(0, 72813, '\p{Script=bhaiksuki}', "");
    Expect(1, 72813, '\p{^Script=bhaiksuki}', "");
    Expect(1, 72813, '\P{Script=bhaiksuki}', "");
    Expect(0, 72813, '\P{^Script=bhaiksuki}', "");
    Expect(1, 72812, '\p{Script=:\Abhaiksuki\z:}', "");;
    Expect(0, 72813, '\p{Script=:\Abhaiksuki\z:}', "");;
    Expect(1, 72812, '\p{Script=_	bhaiksuki}', "");
    Expect(0, 72812, '\p{^Script=_	bhaiksuki}', "");
    Expect(0, 72812, '\P{Script=_	bhaiksuki}', "");
    Expect(1, 72812, '\P{^Script=_	bhaiksuki}', "");
    Expect(0, 72813, '\p{Script=_	bhaiksuki}', "");
    Expect(1, 72813, '\p{^Script=_	bhaiksuki}', "");
    Expect(1, 72813, '\P{Script=_	bhaiksuki}', "");
    Expect(0, 72813, '\P{^Script=_	bhaiksuki}', "");
    Error('\p{Sc=/a/-BHKS}');
    Error('\P{Sc=/a/-BHKS}');
    Expect(1, 72812, '\p{Sc=:\ABhks\z:}', "");;
    Expect(0, 72813, '\p{Sc=:\ABhks\z:}', "");;
    Expect(1, 72812, '\p{Sc=bhks}', "");
    Expect(0, 72812, '\p{^Sc=bhks}', "");
    Expect(0, 72812, '\P{Sc=bhks}', "");
    Expect(1, 72812, '\P{^Sc=bhks}', "");
    Expect(0, 72813, '\p{Sc=bhks}', "");
    Expect(1, 72813, '\p{^Sc=bhks}', "");
    Expect(1, 72813, '\P{Sc=bhks}', "");
    Expect(0, 72813, '\P{^Sc=bhks}', "");
    Expect(1, 72812, '\p{Sc=:\Abhks\z:}', "");;
    Expect(0, 72813, '\p{Sc=:\Abhks\z:}', "");;
    Expect(1, 72812, '\p{Sc= _Bhks}', "");
    Expect(0, 72812, '\p{^Sc= _Bhks}', "");
    Expect(0, 72812, '\P{Sc= _Bhks}', "");
    Expect(1, 72812, '\P{^Sc= _Bhks}', "");
    Expect(0, 72813, '\p{Sc= _Bhks}', "");
    Expect(1, 72813, '\p{^Sc= _Bhks}', "");
    Expect(1, 72813, '\P{Sc= _Bhks}', "");
    Expect(0, 72813, '\P{^Sc= _Bhks}', "");
    Error('\p{Is_Script=-/a/BHAIKSUKI}');
    Error('\P{Is_Script=-/a/BHAIKSUKI}');
    Expect(1, 72812, '\p{Is_Script=bhaiksuki}', "");
    Expect(0, 72812, '\p{^Is_Script=bhaiksuki}', "");
    Expect(0, 72812, '\P{Is_Script=bhaiksuki}', "");
    Expect(1, 72812, '\P{^Is_Script=bhaiksuki}', "");
    Expect(0, 72813, '\p{Is_Script=bhaiksuki}', "");
    Expect(1, 72813, '\p{^Is_Script=bhaiksuki}', "");
    Expect(1, 72813, '\P{Is_Script=bhaiksuki}', "");
    Expect(0, 72813, '\P{^Is_Script=bhaiksuki}', "");
    Expect(1, 72812, '\p{Is_Script=-_Bhaiksuki}', "");
    Expect(0, 72812, '\p{^Is_Script=-_Bhaiksuki}', "");
    Expect(0, 72812, '\P{Is_Script=-_Bhaiksuki}', "");
    Expect(1, 72812, '\P{^Is_Script=-_Bhaiksuki}', "");
    Expect(0, 72813, '\p{Is_Script=-_Bhaiksuki}', "");
    Expect(1, 72813, '\p{^Is_Script=-_Bhaiksuki}', "");
    Expect(1, 72813, '\P{Is_Script=-_Bhaiksuki}', "");
    Expect(0, 72813, '\P{^Is_Script=-_Bhaiksuki}', "");
    Error('\p{Is_Sc= :=Bhks}');
    Error('\P{Is_Sc= :=Bhks}');
    Expect(1, 72812, '\p{Is_Sc: bhks}', "");
    Expect(0, 72812, '\p{^Is_Sc: bhks}', "");
    Expect(0, 72812, '\P{Is_Sc: bhks}', "");
    Expect(1, 72812, '\P{^Is_Sc: bhks}', "");
    Expect(0, 72813, '\p{Is_Sc: bhks}', "");
    Expect(1, 72813, '\p{^Is_Sc: bhks}', "");
    Expect(1, 72813, '\P{Is_Sc: bhks}', "");
    Expect(0, 72813, '\P{^Is_Sc: bhks}', "");
    Expect(1, 72812, '\p{Is_Sc=_Bhks}', "");
    Expect(0, 72812, '\p{^Is_Sc=_Bhks}', "");
    Expect(0, 72812, '\P{Is_Sc=_Bhks}', "");
    Expect(1, 72812, '\P{^Is_Sc=_Bhks}', "");
    Expect(0, 72813, '\p{Is_Sc=_Bhks}', "");
    Expect(1, 72813, '\p{^Is_Sc=_Bhks}', "");
    Expect(1, 72813, '\P{Is_Sc=_Bhks}', "");
    Expect(0, 72813, '\P{^Is_Sc=_Bhks}', "");
    Error('\p{Script:/a/-	Bopomofo}');
    Error('\P{Script:/a/-	Bopomofo}');
    Expect(1, 12730, '\p{Script=:\ABopomofo\z:}', "");;
    Expect(0, 12731, '\p{Script=:\ABopomofo\z:}', "");;
    Expect(1, 12730, '\p{Script=bopomofo}', "");
    Expect(0, 12730, '\p{^Script=bopomofo}', "");
    Expect(0, 12730, '\P{Script=bopomofo}', "");
    Expect(1, 12730, '\P{^Script=bopomofo}', "");
    Expect(0, 12731, '\p{Script=bopomofo}', "");
    Expect(1, 12731, '\p{^Script=bopomofo}', "");
    Expect(1, 12731, '\P{Script=bopomofo}', "");
    Expect(0, 12731, '\P{^Script=bopomofo}', "");
    Expect(1, 12730, '\p{Script=:\Abopomofo\z:}', "");;
    Expect(0, 12731, '\p{Script=:\Abopomofo\z:}', "");;
    Expect(1, 12730, '\p{Script=	-BOPOMOFO}', "");
    Expect(0, 12730, '\p{^Script=	-BOPOMOFO}', "");
    Expect(0, 12730, '\P{Script=	-BOPOMOFO}', "");
    Expect(1, 12730, '\P{^Script=	-BOPOMOFO}', "");
    Expect(0, 12731, '\p{Script=	-BOPOMOFO}', "");
    Expect(1, 12731, '\p{^Script=	-BOPOMOFO}', "");
    Expect(1, 12731, '\P{Script=	-BOPOMOFO}', "");
    Expect(0, 12731, '\P{^Script=	-BOPOMOFO}', "");
    Error('\p{Sc=:=  BOPO}');
    Error('\P{Sc=:=  BOPO}');
    Expect(1, 12730, '\p{Sc=:\ABopo\z:}', "");;
    Expect(0, 12731, '\p{Sc=:\ABopo\z:}', "");;
    Expect(1, 12730, '\p{Sc=bopo}', "");
    Expect(0, 12730, '\p{^Sc=bopo}', "");
    Expect(0, 12730, '\P{Sc=bopo}', "");
    Expect(1, 12730, '\P{^Sc=bopo}', "");
    Expect(0, 12731, '\p{Sc=bopo}', "");
    Expect(1, 12731, '\p{^Sc=bopo}', "");
    Expect(1, 12731, '\P{Sc=bopo}', "");
    Expect(0, 12731, '\P{^Sc=bopo}', "");
    Expect(1, 12730, '\p{Sc=:\Abopo\z:}', "");;
    Expect(0, 12731, '\p{Sc=:\Abopo\z:}', "");;
    Expect(1, 12730, '\p{Sc=_Bopo}', "");
    Expect(0, 12730, '\p{^Sc=_Bopo}', "");
    Expect(0, 12730, '\P{Sc=_Bopo}', "");
    Expect(1, 12730, '\P{^Sc=_Bopo}', "");
    Expect(0, 12731, '\p{Sc=_Bopo}', "");
    Expect(1, 12731, '\p{^Sc=_Bopo}', "");
    Expect(1, 12731, '\P{Sc=_Bopo}', "");
    Expect(0, 12731, '\P{^Sc=_Bopo}', "");
    Error('\p{Is_Script= /a/Bopomofo}');
    Error('\P{Is_Script= /a/Bopomofo}');
    Expect(1, 12730, '\p{Is_Script=bopomofo}', "");
    Expect(0, 12730, '\p{^Is_Script=bopomofo}', "");
    Expect(0, 12730, '\P{Is_Script=bopomofo}', "");
    Expect(1, 12730, '\P{^Is_Script=bopomofo}', "");
    Expect(0, 12731, '\p{Is_Script=bopomofo}', "");
    Expect(1, 12731, '\p{^Is_Script=bopomofo}', "");
    Expect(1, 12731, '\P{Is_Script=bopomofo}', "");
    Expect(0, 12731, '\P{^Is_Script=bopomofo}', "");
    Expect(1, 12730, '\p{Is_Script:     Bopomofo}', "");
    Expect(0, 12730, '\p{^Is_Script:     Bopomofo}', "");
    Expect(0, 12730, '\P{Is_Script:     Bopomofo}', "");
    Expect(1, 12730, '\P{^Is_Script:     Bopomofo}', "");
    Expect(0, 12731, '\p{Is_Script:     Bopomofo}', "");
    Expect(1, 12731, '\p{^Is_Script:     Bopomofo}', "");
    Expect(1, 12731, '\P{Is_Script:     Bopomofo}', "");
    Expect(0, 12731, '\P{^Is_Script:     Bopomofo}', "");
    Error('\p{Is_Sc=/a/		bopo}');
    Error('\P{Is_Sc=/a/		bopo}');
    Expect(1, 12730, '\p{Is_Sc=bopo}', "");
    Expect(0, 12730, '\p{^Is_Sc=bopo}', "");
    Expect(0, 12730, '\P{Is_Sc=bopo}', "");
    Expect(1, 12730, '\P{^Is_Sc=bopo}', "");
    Expect(0, 12731, '\p{Is_Sc=bopo}', "");
    Expect(1, 12731, '\p{^Is_Sc=bopo}', "");
    Expect(1, 12731, '\P{Is_Sc=bopo}', "");
    Expect(0, 12731, '\P{^Is_Sc=bopo}', "");
    Expect(1, 12730, '\p{Is_Sc=-_Bopo}', "");
    Expect(0, 12730, '\p{^Is_Sc=-_Bopo}', "");
    Expect(0, 12730, '\P{Is_Sc=-_Bopo}', "");
    Expect(1, 12730, '\P{^Is_Sc=-_Bopo}', "");
    Expect(0, 12731, '\p{Is_Sc=-_Bopo}', "");
    Expect(1, 12731, '\p{^Is_Sc=-_Bopo}', "");
    Expect(1, 12731, '\P{Is_Sc=-_Bopo}', "");
    Expect(0, 12731, '\P{^Is_Sc=-_Bopo}', "");
    Error('\p{Script=- brahmi:=}');
    Error('\P{Script=- brahmi:=}');
    Expect(1, 69759, '\p{Script=:\ABrahmi\z:}', "");;
    Expect(0, 69760, '\p{Script=:\ABrahmi\z:}', "");;
    Expect(1, 69759, '\p{Script=brahmi}', "");
    Expect(0, 69759, '\p{^Script=brahmi}', "");
    Expect(0, 69759, '\P{Script=brahmi}', "");
    Expect(1, 69759, '\P{^Script=brahmi}', "");
    Expect(0, 69760, '\p{Script=brahmi}', "");
    Expect(1, 69760, '\p{^Script=brahmi}', "");
    Expect(1, 69760, '\P{Script=brahmi}', "");
    Expect(0, 69760, '\P{^Script=brahmi}', "");
    Expect(1, 69759, '\p{Script=:\Abrahmi\z:}', "");;
    Expect(0, 69760, '\p{Script=:\Abrahmi\z:}', "");;
    Expect(1, 69759, '\p{Script:-_brahmi}', "");
    Expect(0, 69759, '\p{^Script:-_brahmi}', "");
    Expect(0, 69759, '\P{Script:-_brahmi}', "");
    Expect(1, 69759, '\P{^Script:-_brahmi}', "");
    Expect(0, 69760, '\p{Script:-_brahmi}', "");
    Expect(1, 69760, '\p{^Script:-_brahmi}', "");
    Expect(1, 69760, '\P{Script:-_brahmi}', "");
    Expect(0, 69760, '\P{^Script:-_brahmi}', "");
    Error('\p{Sc= Brah:=}');
    Error('\P{Sc= Brah:=}');
    Expect(1, 69759, '\p{Sc=:\ABrah\z:}', "");;
    Expect(0, 69760, '\p{Sc=:\ABrah\z:}', "");;
    Expect(1, 69759, '\p{Sc=brah}', "");
    Expect(0, 69759, '\p{^Sc=brah}', "");
    Expect(0, 69759, '\P{Sc=brah}', "");
    Expect(1, 69759, '\P{^Sc=brah}', "");
    Expect(0, 69760, '\p{Sc=brah}', "");
    Expect(1, 69760, '\p{^Sc=brah}', "");
    Expect(1, 69760, '\P{Sc=brah}', "");
    Expect(0, 69760, '\P{^Sc=brah}', "");
    Expect(1, 69759, '\p{Sc=:\Abrah\z:}', "");;
    Expect(0, 69760, '\p{Sc=:\Abrah\z:}', "");;
    Expect(1, 69759, '\p{Sc=_Brah}', "");
    Expect(0, 69759, '\p{^Sc=_Brah}', "");
    Expect(0, 69759, '\P{Sc=_Brah}', "");
    Expect(1, 69759, '\P{^Sc=_Brah}', "");
    Expect(0, 69760, '\p{Sc=_Brah}', "");
    Expect(1, 69760, '\p{^Sc=_Brah}', "");
    Expect(1, 69760, '\P{Sc=_Brah}', "");
    Expect(0, 69760, '\P{^Sc=_Brah}', "");
    Error('\p{Is_Script: _brahmi/a/}');
    Error('\P{Is_Script: _brahmi/a/}');
    Expect(1, 69759, '\p{Is_Script=brahmi}', "");
    Expect(0, 69759, '\p{^Is_Script=brahmi}', "");
    Expect(0, 69759, '\P{Is_Script=brahmi}', "");
    Expect(1, 69759, '\P{^Is_Script=brahmi}', "");
    Expect(0, 69760, '\p{Is_Script=brahmi}', "");
    Expect(1, 69760, '\p{^Is_Script=brahmi}', "");
    Expect(1, 69760, '\P{Is_Script=brahmi}', "");
    Expect(0, 69760, '\P{^Is_Script=brahmi}', "");
    Expect(1, 69759, '\p{Is_Script=	-BRAHMI}', "");
    Expect(0, 69759, '\p{^Is_Script=	-BRAHMI}', "");
    Expect(0, 69759, '\P{Is_Script=	-BRAHMI}', "");
    Expect(1, 69759, '\P{^Is_Script=	-BRAHMI}', "");
    Expect(0, 69760, '\p{Is_Script=	-BRAHMI}', "");
    Expect(1, 69760, '\p{^Is_Script=	-BRAHMI}', "");
    Expect(1, 69760, '\P{Is_Script=	-BRAHMI}', "");
    Expect(0, 69760, '\P{^Is_Script=	-BRAHMI}', "");
    Error('\p{Is_Sc=:= Brah}');
    Error('\P{Is_Sc=:= Brah}');
    Expect(1, 69759, '\p{Is_Sc=brah}', "");
    Expect(0, 69759, '\p{^Is_Sc=brah}', "");
    Expect(0, 69759, '\P{Is_Sc=brah}', "");
    Expect(1, 69759, '\P{^Is_Sc=brah}', "");
    Expect(0, 69760, '\p{Is_Sc=brah}', "");
    Expect(1, 69760, '\p{^Is_Sc=brah}', "");
    Expect(1, 69760, '\P{Is_Sc=brah}', "");
    Expect(0, 69760, '\P{^Is_Sc=brah}', "");
    Expect(1, 69759, '\p{Is_Sc=	brah}', "");
    Expect(0, 69759, '\p{^Is_Sc=	brah}', "");
    Expect(0, 69759, '\P{Is_Sc=	brah}', "");
    Expect(1, 69759, '\P{^Is_Sc=	brah}', "");
    Expect(0, 69760, '\p{Is_Sc=	brah}', "");
    Expect(1, 69760, '\p{^Is_Sc=	brah}', "");
    Expect(1, 69760, '\P{Is_Sc=	brah}', "");
    Expect(0, 69760, '\P{^Is_Sc=	brah}', "");
    Error('\p{Script=	_Braille/a/}');
    Error('\P{Script=	_Braille/a/}');
    Expect(1, 10495, '\p{Script=:\ABraille\z:}', "");;
    Expect(0, 10496, '\p{Script=:\ABraille\z:}', "");;
    Expect(1, 10495, '\p{Script=braille}', "");
    Expect(0, 10495, '\p{^Script=braille}', "");
    Expect(0, 10495, '\P{Script=braille}', "");
    Expect(1, 10495, '\P{^Script=braille}', "");
    Expect(0, 10496, '\p{Script=braille}', "");
    Expect(1, 10496, '\p{^Script=braille}', "");
    Expect(1, 10496, '\P{Script=braille}', "");
    Expect(0, 10496, '\P{^Script=braille}', "");
    Expect(1, 10495, '\p{Script=:\Abraille\z:}', "");;
    Expect(0, 10496, '\p{Script=:\Abraille\z:}', "");;
    Expect(1, 10495, '\p{Script=_-Braille}', "");
    Expect(0, 10495, '\p{^Script=_-Braille}', "");
    Expect(0, 10495, '\P{Script=_-Braille}', "");
    Expect(1, 10495, '\P{^Script=_-Braille}', "");
    Expect(0, 10496, '\p{Script=_-Braille}', "");
    Expect(1, 10496, '\p{^Script=_-Braille}', "");
    Expect(1, 10496, '\P{Script=_-Braille}', "");
    Expect(0, 10496, '\P{^Script=_-Braille}', "");
    Error('\p{Sc=/a/BRAI}');
    Error('\P{Sc=/a/BRAI}');
    Expect(1, 10495, '\p{Sc=:\ABrai\z:}', "");;
    Expect(0, 10496, '\p{Sc=:\ABrai\z:}', "");;
    Expect(1, 10495, '\p{Sc=brai}', "");
    Expect(0, 10495, '\p{^Sc=brai}', "");
    Expect(0, 10495, '\P{Sc=brai}', "");
    Expect(1, 10495, '\P{^Sc=brai}', "");
    Expect(0, 10496, '\p{Sc=brai}', "");
    Expect(1, 10496, '\p{^Sc=brai}', "");
    Expect(1, 10496, '\P{Sc=brai}', "");
    Expect(0, 10496, '\P{^Sc=brai}', "");
    Expect(1, 10495, '\p{Sc=:\Abrai\z:}', "");;
    Expect(0, 10496, '\p{Sc=:\Abrai\z:}', "");;
    Expect(1, 10495, '\p{Sc=		BRAI}', "");
    Expect(0, 10495, '\p{^Sc=		BRAI}', "");
    Expect(0, 10495, '\P{Sc=		BRAI}', "");
    Expect(1, 10495, '\P{^Sc=		BRAI}', "");
    Expect(0, 10496, '\p{Sc=		BRAI}', "");
    Expect(1, 10496, '\p{^Sc=		BRAI}', "");
    Expect(1, 10496, '\P{Sc=		BRAI}', "");
    Expect(0, 10496, '\P{^Sc=		BRAI}', "");
    Error('\p{Is_Script= /a/Braille}');
    Error('\P{Is_Script= /a/Braille}');
    Expect(1, 10495, '\p{Is_Script=braille}', "");
    Expect(0, 10495, '\p{^Is_Script=braille}', "");
    Expect(0, 10495, '\P{Is_Script=braille}', "");
    Expect(1, 10495, '\P{^Is_Script=braille}', "");
    Expect(0, 10496, '\p{Is_Script=braille}', "");
    Expect(1, 10496, '\p{^Is_Script=braille}', "");
    Expect(1, 10496, '\P{Is_Script=braille}', "");
    Expect(0, 10496, '\P{^Is_Script=braille}', "");
    Expect(1, 10495, '\p{Is_Script=_-Braille}', "");
    Expect(0, 10495, '\p{^Is_Script=_-Braille}', "");
    Expect(0, 10495, '\P{Is_Script=_-Braille}', "");
    Expect(1, 10495, '\P{^Is_Script=_-Braille}', "");
    Expect(0, 10496, '\p{Is_Script=_-Braille}', "");
    Expect(1, 10496, '\p{^Is_Script=_-Braille}', "");
    Expect(1, 10496, '\P{Is_Script=_-Braille}', "");
    Expect(0, 10496, '\P{^Is_Script=_-Braille}', "");
    Error('\p{Is_Sc: 	-brai/a/}');
    Error('\P{Is_Sc: 	-brai/a/}');
    Expect(1, 10495, '\p{Is_Sc=brai}', "");
    Expect(0, 10495, '\p{^Is_Sc=brai}', "");
    Expect(0, 10495, '\P{Is_Sc=brai}', "");
    Expect(1, 10495, '\P{^Is_Sc=brai}', "");
    Expect(0, 10496, '\p{Is_Sc=brai}', "");
    Expect(1, 10496, '\p{^Is_Sc=brai}', "");
    Expect(1, 10496, '\P{Is_Sc=brai}', "");
    Expect(0, 10496, '\P{^Is_Sc=brai}', "");
    Expect(1, 10495, '\p{Is_Sc=	brai}', "");
    Expect(0, 10495, '\p{^Is_Sc=	brai}', "");
    Expect(0, 10495, '\P{Is_Sc=	brai}', "");
    Expect(1, 10495, '\P{^Is_Sc=	brai}', "");
    Expect(0, 10496, '\p{Is_Sc=	brai}', "");
    Expect(1, 10496, '\p{^Is_Sc=	brai}', "");
    Expect(1, 10496, '\P{Is_Sc=	brai}', "");
    Expect(0, 10496, '\P{^Is_Sc=	brai}', "");
    Error('\p{Script=_-Buginese/a/}');
    Error('\P{Script=_-Buginese/a/}');
    Expect(1, 6687, '\p{Script=:\ABuginese\z:}', "");;
    Expect(0, 6688, '\p{Script=:\ABuginese\z:}', "");;
    Expect(1, 6687, '\p{Script=buginese}', "");
    Expect(0, 6687, '\p{^Script=buginese}', "");
    Expect(0, 6687, '\P{Script=buginese}', "");
    Expect(1, 6687, '\P{^Script=buginese}', "");
    Expect(0, 6688, '\p{Script=buginese}', "");
    Expect(1, 6688, '\p{^Script=buginese}', "");
    Expect(1, 6688, '\P{Script=buginese}', "");
    Expect(0, 6688, '\P{^Script=buginese}', "");
    Expect(1, 6687, '\p{Script=:\Abuginese\z:}', "");;
    Expect(0, 6688, '\p{Script=:\Abuginese\z:}', "");;
    Expect(1, 6687, '\p{Script=	BUGINESE}', "");
    Expect(0, 6687, '\p{^Script=	BUGINESE}', "");
    Expect(0, 6687, '\P{Script=	BUGINESE}', "");
    Expect(1, 6687, '\P{^Script=	BUGINESE}', "");
    Expect(0, 6688, '\p{Script=	BUGINESE}', "");
    Expect(1, 6688, '\p{^Script=	BUGINESE}', "");
    Expect(1, 6688, '\P{Script=	BUGINESE}', "");
    Expect(0, 6688, '\P{^Script=	BUGINESE}', "");
    Error('\p{Sc=/a/ 	Bugi}');
    Error('\P{Sc=/a/ 	Bugi}');
    Expect(1, 6687, '\p{Sc=:\ABugi\z:}', "");;
    Expect(0, 6688, '\p{Sc=:\ABugi\z:}', "");;
    Expect(1, 6687, '\p{Sc:	bugi}', "");
    Expect(0, 6687, '\p{^Sc:	bugi}', "");
    Expect(0, 6687, '\P{Sc:	bugi}', "");
    Expect(1, 6687, '\P{^Sc:	bugi}', "");
    Expect(0, 6688, '\p{Sc:	bugi}', "");
    Expect(1, 6688, '\p{^Sc:	bugi}', "");
    Expect(1, 6688, '\P{Sc:	bugi}', "");
    Expect(0, 6688, '\P{^Sc:	bugi}', "");
    Expect(1, 6687, '\p{Sc=:\Abugi\z:}', "");;
    Expect(0, 6688, '\p{Sc=:\Abugi\z:}', "");;
    Expect(1, 6687, '\p{Sc:	-bugi}', "");
    Expect(0, 6687, '\p{^Sc:	-bugi}', "");
    Expect(0, 6687, '\P{Sc:	-bugi}', "");
    Expect(1, 6687, '\P{^Sc:	-bugi}', "");
    Expect(0, 6688, '\p{Sc:	-bugi}', "");
    Expect(1, 6688, '\p{^Sc:	-bugi}', "");
    Expect(1, 6688, '\P{Sc:	-bugi}', "");
    Expect(0, 6688, '\P{^Sc:	-bugi}', "");
    Error('\p{Is_Script=:=_	buginese}');
    Error('\P{Is_Script=:=_	buginese}');
    Expect(1, 6687, '\p{Is_Script=buginese}', "");
    Expect(0, 6687, '\p{^Is_Script=buginese}', "");
    Expect(0, 6687, '\P{Is_Script=buginese}', "");
    Expect(1, 6687, '\P{^Is_Script=buginese}', "");
    Expect(0, 6688, '\p{Is_Script=buginese}', "");
    Expect(1, 6688, '\p{^Is_Script=buginese}', "");
    Expect(1, 6688, '\P{Is_Script=buginese}', "");
    Expect(0, 6688, '\P{^Is_Script=buginese}', "");
    Expect(1, 6687, '\p{Is_Script=	BUGINESE}', "");
    Expect(0, 6687, '\p{^Is_Script=	BUGINESE}', "");
    Expect(0, 6687, '\P{Is_Script=	BUGINESE}', "");
    Expect(1, 6687, '\P{^Is_Script=	BUGINESE}', "");
    Expect(0, 6688, '\p{Is_Script=	BUGINESE}', "");
    Expect(1, 6688, '\p{^Is_Script=	BUGINESE}', "");
    Expect(1, 6688, '\P{Is_Script=	BUGINESE}', "");
    Expect(0, 6688, '\P{^Is_Script=	BUGINESE}', "");
    Error('\p{Is_Sc=/a/-BUGI}');
    Error('\P{Is_Sc=/a/-BUGI}');
    Expect(1, 6687, '\p{Is_Sc=bugi}', "");
    Expect(0, 6687, '\p{^Is_Sc=bugi}', "");
    Expect(0, 6687, '\P{Is_Sc=bugi}', "");
    Expect(1, 6687, '\P{^Is_Sc=bugi}', "");
    Expect(0, 6688, '\p{Is_Sc=bugi}', "");
    Expect(1, 6688, '\p{^Is_Sc=bugi}', "");
    Expect(1, 6688, '\P{Is_Sc=bugi}', "");
    Expect(0, 6688, '\P{^Is_Sc=bugi}', "");
    Expect(1, 6687, '\p{Is_Sc= -BUGI}', "");
    Expect(0, 6687, '\p{^Is_Sc= -BUGI}', "");
    Expect(0, 6687, '\P{Is_Sc= -BUGI}', "");
    Expect(1, 6687, '\P{^Is_Sc= -BUGI}', "");
    Expect(0, 6688, '\p{Is_Sc= -BUGI}', "");
    Expect(1, 6688, '\p{^Is_Sc= -BUGI}', "");
    Expect(1, 6688, '\P{Is_Sc= -BUGI}', "");
    Expect(0, 6688, '\P{^Is_Sc= -BUGI}', "");
    Error('\p{Script=:=_ Buhid}');
    Error('\P{Script=:=_ Buhid}');
    Expect(1, 5971, '\p{Script=:\ABuhid\z:}', "");;
    Expect(0, 5972, '\p{Script=:\ABuhid\z:}', "");;
    Expect(1, 5971, '\p{Script=buhid}', "");
    Expect(0, 5971, '\p{^Script=buhid}', "");
    Expect(0, 5971, '\P{Script=buhid}', "");
    Expect(1, 5971, '\P{^Script=buhid}', "");
    Expect(0, 5972, '\p{Script=buhid}', "");
    Expect(1, 5972, '\p{^Script=buhid}', "");
    Expect(1, 5972, '\P{Script=buhid}', "");
    Expect(0, 5972, '\P{^Script=buhid}', "");
    Expect(1, 5971, '\p{Script=:\Abuhid\z:}', "");;
    Expect(0, 5972, '\p{Script=:\Abuhid\z:}', "");;
    Expect(1, 5971, '\p{Script=	Buhid}', "");
    Expect(0, 5971, '\p{^Script=	Buhid}', "");
    Expect(0, 5971, '\P{Script=	Buhid}', "");
    Expect(1, 5971, '\P{^Script=	Buhid}', "");
    Expect(0, 5972, '\p{Script=	Buhid}', "");
    Expect(1, 5972, '\p{^Script=	Buhid}', "");
    Expect(1, 5972, '\P{Script=	Buhid}', "");
    Expect(0, 5972, '\P{^Script=	Buhid}', "");
    Error('\p{Sc=/a/-	buhd}');
    Error('\P{Sc=/a/-	buhd}');
    Expect(1, 5971, '\p{Sc=:\ABuhd\z:}', "");;
    Expect(0, 5972, '\p{Sc=:\ABuhd\z:}', "");;
    Expect(1, 5971, '\p{Sc:buhd}', "");
    Expect(0, 5971, '\p{^Sc:buhd}', "");
    Expect(0, 5971, '\P{Sc:buhd}', "");
    Expect(1, 5971, '\P{^Sc:buhd}', "");
    Expect(0, 5972, '\p{Sc:buhd}', "");
    Expect(1, 5972, '\p{^Sc:buhd}', "");
    Expect(1, 5972, '\P{Sc:buhd}', "");
    Expect(0, 5972, '\P{^Sc:buhd}', "");
    Expect(1, 5971, '\p{Sc=:\Abuhd\z:}', "");;
    Expect(0, 5972, '\p{Sc=:\Abuhd\z:}', "");;
    Expect(1, 5971, '\p{Sc= _Buhd}', "");
    Expect(0, 5971, '\p{^Sc= _Buhd}', "");
    Expect(0, 5971, '\P{Sc= _Buhd}', "");
    Expect(1, 5971, '\P{^Sc= _Buhd}', "");
    Expect(0, 5972, '\p{Sc= _Buhd}', "");
    Expect(1, 5972, '\p{^Sc= _Buhd}', "");
    Expect(1, 5972, '\P{Sc= _Buhd}', "");
    Expect(0, 5972, '\P{^Sc= _Buhd}', "");
    Error('\p{Is_Script=_:=buhid}');
    Error('\P{Is_Script=_:=buhid}');
    Expect(1, 5971, '\p{Is_Script=buhid}', "");
    Expect(0, 5971, '\p{^Is_Script=buhid}', "");
    Expect(0, 5971, '\P{Is_Script=buhid}', "");
    Expect(1, 5971, '\P{^Is_Script=buhid}', "");
    Expect(0, 5972, '\p{Is_Script=buhid}', "");
    Expect(1, 5972, '\p{^Is_Script=buhid}', "");
    Expect(1, 5972, '\P{Is_Script=buhid}', "");
    Expect(0, 5972, '\P{^Is_Script=buhid}', "");
    Expect(1, 5971, '\p{Is_Script=	 buhid}', "");
    Expect(0, 5971, '\p{^Is_Script=	 buhid}', "");
    Expect(0, 5971, '\P{Is_Script=	 buhid}', "");
    Expect(1, 5971, '\P{^Is_Script=	 buhid}', "");
    Expect(0, 5972, '\p{Is_Script=	 buhid}', "");
    Expect(1, 5972, '\p{^Is_Script=	 buhid}', "");
    Expect(1, 5972, '\P{Is_Script=	 buhid}', "");
    Expect(0, 5972, '\P{^Is_Script=	 buhid}', "");
    Error('\p{Is_Sc=:=_BUHD}');
    Error('\P{Is_Sc=:=_BUHD}');
    Expect(1, 5971, '\p{Is_Sc=buhd}', "");
    Expect(0, 5971, '\p{^Is_Sc=buhd}', "");
    Expect(0, 5971, '\P{Is_Sc=buhd}', "");
    Expect(1, 5971, '\P{^Is_Sc=buhd}', "");
    Expect(0, 5972, '\p{Is_Sc=buhd}', "");
    Expect(1, 5972, '\p{^Is_Sc=buhd}', "");
    Expect(1, 5972, '\P{Is_Sc=buhd}', "");
    Expect(0, 5972, '\P{^Is_Sc=buhd}', "");
    Expect(1, 5971, '\p{Is_Sc=__buhd}', "");
    Expect(0, 5971, '\p{^Is_Sc=__buhd}', "");
    Expect(0, 5971, '\P{Is_Sc=__buhd}', "");
    Expect(1, 5971, '\P{^Is_Sc=__buhd}', "");
    Expect(0, 5972, '\p{Is_Sc=__buhd}', "");
    Expect(1, 5972, '\p{^Is_Sc=__buhd}', "");
    Expect(1, 5972, '\P{Is_Sc=__buhd}', "");
    Expect(0, 5972, '\P{^Is_Sc=__buhd}', "");
    Error('\p{Script=  Chakma:=}');
    Error('\P{Script=  Chakma:=}');
    Expect(1, 69958, '\p{Script=:\AChakma\z:}', "");;
    Expect(0, 69959, '\p{Script=:\AChakma\z:}', "");;
    Expect(1, 69958, '\p{Script=chakma}', "");
    Expect(0, 69958, '\p{^Script=chakma}', "");
    Expect(0, 69958, '\P{Script=chakma}', "");
    Expect(1, 69958, '\P{^Script=chakma}', "");
    Expect(0, 69959, '\p{Script=chakma}', "");
    Expect(1, 69959, '\p{^Script=chakma}', "");
    Expect(1, 69959, '\P{Script=chakma}', "");
    Expect(0, 69959, '\P{^Script=chakma}', "");
    Expect(1, 69958, '\p{Script=:\Achakma\z:}', "");;
    Expect(0, 69959, '\p{Script=:\Achakma\z:}', "");;
    Expect(1, 69958, '\p{Script=_Chakma}', "");
    Expect(0, 69958, '\p{^Script=_Chakma}', "");
    Expect(0, 69958, '\P{Script=_Chakma}', "");
    Expect(1, 69958, '\P{^Script=_Chakma}', "");
    Expect(0, 69959, '\p{Script=_Chakma}', "");
    Expect(1, 69959, '\p{^Script=_Chakma}', "");
    Expect(1, 69959, '\P{Script=_Chakma}', "");
    Expect(0, 69959, '\P{^Script=_Chakma}', "");
    Error('\p{Sc=:= _Cakm}');
    Error('\P{Sc=:= _Cakm}');
    Expect(1, 69958, '\p{Sc=:\ACakm\z:}', "");;
    Expect(0, 69959, '\p{Sc=:\ACakm\z:}', "");;
    Expect(1, 69958, '\p{Sc=cakm}', "");
    Expect(0, 69958, '\p{^Sc=cakm}', "");
    Expect(0, 69958, '\P{Sc=cakm}', "");
    Expect(1, 69958, '\P{^Sc=cakm}', "");
    Expect(0, 69959, '\p{Sc=cakm}', "");
    Expect(1, 69959, '\p{^Sc=cakm}', "");
    Expect(1, 69959, '\P{Sc=cakm}', "");
    Expect(0, 69959, '\P{^Sc=cakm}', "");
    Expect(1, 69958, '\p{Sc=:\Acakm\z:}', "");;
    Expect(0, 69959, '\p{Sc=:\Acakm\z:}', "");;
    Expect(1, 69958, '\p{Sc=_CAKM}', "");
    Expect(0, 69958, '\p{^Sc=_CAKM}', "");
    Expect(0, 69958, '\P{Sc=_CAKM}', "");
    Expect(1, 69958, '\P{^Sc=_CAKM}', "");
    Expect(0, 69959, '\p{Sc=_CAKM}', "");
    Expect(1, 69959, '\p{^Sc=_CAKM}', "");
    Expect(1, 69959, '\P{Sc=_CAKM}', "");
    Expect(0, 69959, '\P{^Sc=_CAKM}', "");
    Error('\p{Is_Script=/a/-Chakma}');
    Error('\P{Is_Script=/a/-Chakma}');
    Expect(1, 69958, '\p{Is_Script=chakma}', "");
    Expect(0, 69958, '\p{^Is_Script=chakma}', "");
    Expect(0, 69958, '\P{Is_Script=chakma}', "");
    Expect(1, 69958, '\P{^Is_Script=chakma}', "");
    Expect(0, 69959, '\p{Is_Script=chakma}', "");
    Expect(1, 69959, '\p{^Is_Script=chakma}', "");
    Expect(1, 69959, '\P{Is_Script=chakma}', "");
    Expect(0, 69959, '\P{^Is_Script=chakma}', "");
    Expect(1, 69958, '\p{Is_Script= CHAKMA}', "");
    Expect(0, 69958, '\p{^Is_Script= CHAKMA}', "");
    Expect(0, 69958, '\P{Is_Script= CHAKMA}', "");
    Expect(1, 69958, '\P{^Is_Script= CHAKMA}', "");
    Expect(0, 69959, '\p{Is_Script= CHAKMA}', "");
    Expect(1, 69959, '\p{^Is_Script= CHAKMA}', "");
    Expect(1, 69959, '\P{Is_Script= CHAKMA}', "");
    Expect(0, 69959, '\P{^Is_Script= CHAKMA}', "");
    Error('\p{Is_Sc=:=  Cakm}');
    Error('\P{Is_Sc=:=  Cakm}');
    Expect(1, 69958, '\p{Is_Sc=cakm}', "");
    Expect(0, 69958, '\p{^Is_Sc=cakm}', "");
    Expect(0, 69958, '\P{Is_Sc=cakm}', "");
    Expect(1, 69958, '\P{^Is_Sc=cakm}', "");
    Expect(0, 69959, '\p{Is_Sc=cakm}', "");
    Expect(1, 69959, '\p{^Is_Sc=cakm}', "");
    Expect(1, 69959, '\P{Is_Sc=cakm}', "");
    Expect(0, 69959, '\P{^Is_Sc=cakm}', "");
    Expect(1, 69958, '\p{Is_Sc=--Cakm}', "");
    Expect(0, 69958, '\p{^Is_Sc=--Cakm}', "");
    Expect(0, 69958, '\P{Is_Sc=--Cakm}', "");
    Expect(1, 69958, '\P{^Is_Sc=--Cakm}', "");
    Expect(0, 69959, '\p{Is_Sc=--Cakm}', "");
    Expect(1, 69959, '\p{^Is_Sc=--Cakm}', "");
    Expect(1, 69959, '\P{Is_Sc=--Cakm}', "");
    Expect(0, 69959, '\P{^Is_Sc=--Cakm}', "");
    Error('\p{Script= -canadian_ABORIGINAL/a/}');
    Error('\P{Script= -canadian_ABORIGINAL/a/}');
    Expect(1, 6389, '\p{Script=:\ACanadian_Aboriginal\z:}', "");;
    Expect(0, 6390, '\p{Script=:\ACanadian_Aboriginal\z:}', "");;
    Expect(1, 6389, '\p{Script=canadianaboriginal}', "");
    Expect(0, 6389, '\p{^Script=canadianaboriginal}', "");
    Expect(0, 6389, '\P{Script=canadianaboriginal}', "");
    Expect(1, 6389, '\P{^Script=canadianaboriginal}', "");
    Expect(0, 6390, '\p{Script=canadianaboriginal}', "");
    Expect(1, 6390, '\p{^Script=canadianaboriginal}', "");
    Expect(1, 6390, '\P{Script=canadianaboriginal}', "");
    Expect(0, 6390, '\P{^Script=canadianaboriginal}', "");
    Expect(1, 6389, '\p{Script=:\Acanadianaboriginal\z:}', "");;
    Expect(0, 6390, '\p{Script=:\Acanadianaboriginal\z:}', "");;
    Expect(1, 6389, '\p{Script=	_Canadian_ABORIGINAL}', "");
    Expect(0, 6389, '\p{^Script=	_Canadian_ABORIGINAL}', "");
    Expect(0, 6389, '\P{Script=	_Canadian_ABORIGINAL}', "");
    Expect(1, 6389, '\P{^Script=	_Canadian_ABORIGINAL}', "");
    Expect(0, 6390, '\p{Script=	_Canadian_ABORIGINAL}', "");
    Expect(1, 6390, '\p{^Script=	_Canadian_ABORIGINAL}', "");
    Expect(1, 6390, '\P{Script=	_Canadian_ABORIGINAL}', "");
    Expect(0, 6390, '\P{^Script=	_Canadian_ABORIGINAL}', "");
    Error('\p{Sc:	 :=Cans}');
    Error('\P{Sc:	 :=Cans}');
    Expect(1, 6389, '\p{Sc=:\ACans\z:}', "");;
    Expect(0, 6390, '\p{Sc=:\ACans\z:}', "");;
    Expect(1, 6389, '\p{Sc:cans}', "");
    Expect(0, 6389, '\p{^Sc:cans}', "");
    Expect(0, 6389, '\P{Sc:cans}', "");
    Expect(1, 6389, '\P{^Sc:cans}', "");
    Expect(0, 6390, '\p{Sc:cans}', "");
    Expect(1, 6390, '\p{^Sc:cans}', "");
    Expect(1, 6390, '\P{Sc:cans}', "");
    Expect(0, 6390, '\P{^Sc:cans}', "");
    Expect(1, 6389, '\p{Sc=:\Acans\z:}', "");;
    Expect(0, 6390, '\p{Sc=:\Acans\z:}', "");;
    Expect(1, 6389, '\p{Sc=  Cans}', "");
    Expect(0, 6389, '\p{^Sc=  Cans}', "");
    Expect(0, 6389, '\P{Sc=  Cans}', "");
    Expect(1, 6389, '\P{^Sc=  Cans}', "");
    Expect(0, 6390, '\p{Sc=  Cans}', "");
    Expect(1, 6390, '\p{^Sc=  Cans}', "");
    Expect(1, 6390, '\P{Sc=  Cans}', "");
    Expect(0, 6390, '\P{^Sc=  Cans}', "");
    Error('\p{Is_Script=	/a/Canadian_Aboriginal}');
    Error('\P{Is_Script=	/a/Canadian_Aboriginal}');
    Expect(1, 6389, '\p{Is_Script=canadianaboriginal}', "");
    Expect(0, 6389, '\p{^Is_Script=canadianaboriginal}', "");
    Expect(0, 6389, '\P{Is_Script=canadianaboriginal}', "");
    Expect(1, 6389, '\P{^Is_Script=canadianaboriginal}', "");
    Expect(0, 6390, '\p{Is_Script=canadianaboriginal}', "");
    Expect(1, 6390, '\p{^Is_Script=canadianaboriginal}', "");
    Expect(1, 6390, '\P{Is_Script=canadianaboriginal}', "");
    Expect(0, 6390, '\P{^Is_Script=canadianaboriginal}', "");
    Expect(1, 6389, '\p{Is_Script=  CANADIAN_Aboriginal}', "");
    Expect(0, 6389, '\p{^Is_Script=  CANADIAN_Aboriginal}', "");
    Expect(0, 6389, '\P{Is_Script=  CANADIAN_Aboriginal}', "");
    Expect(1, 6389, '\P{^Is_Script=  CANADIAN_Aboriginal}', "");
    Expect(0, 6390, '\p{Is_Script=  CANADIAN_Aboriginal}', "");
    Expect(1, 6390, '\p{^Is_Script=  CANADIAN_Aboriginal}', "");
    Expect(1, 6390, '\P{Is_Script=  CANADIAN_Aboriginal}', "");
    Expect(0, 6390, '\P{^Is_Script=  CANADIAN_Aboriginal}', "");
    Error('\p{Is_Sc=-/a/Cans}');
    Error('\P{Is_Sc=-/a/Cans}');
    Expect(1, 6389, '\p{Is_Sc=cans}', "");
    Expect(0, 6389, '\p{^Is_Sc=cans}', "");
    Expect(0, 6389, '\P{Is_Sc=cans}', "");
    Expect(1, 6389, '\P{^Is_Sc=cans}', "");
    Expect(0, 6390, '\p{Is_Sc=cans}', "");
    Expect(1, 6390, '\p{^Is_Sc=cans}', "");
    Expect(1, 6390, '\P{Is_Sc=cans}', "");
    Expect(0, 6390, '\P{^Is_Sc=cans}', "");
    Expect(1, 6389, '\p{Is_Sc= Cans}', "");
    Expect(0, 6389, '\p{^Is_Sc= Cans}', "");
    Expect(0, 6389, '\P{Is_Sc= Cans}', "");
    Expect(1, 6389, '\P{^Is_Sc= Cans}', "");
    Expect(0, 6390, '\p{Is_Sc= Cans}', "");
    Expect(1, 6390, '\p{^Is_Sc= Cans}', "");
    Expect(1, 6390, '\P{Is_Sc= Cans}', "");
    Expect(0, 6390, '\P{^Is_Sc= Cans}', "");
    Error('\p{Script:	_:=CARIAN}');
    Error('\P{Script:	_:=CARIAN}');
    Expect(1, 66256, '\p{Script=:\ACarian\z:}', "");;
    Expect(0, 66257, '\p{Script=:\ACarian\z:}', "");;
    Expect(1, 66256, '\p{Script=carian}', "");
    Expect(0, 66256, '\p{^Script=carian}', "");
    Expect(0, 66256, '\P{Script=carian}', "");
    Expect(1, 66256, '\P{^Script=carian}', "");
    Expect(0, 66257, '\p{Script=carian}', "");
    Expect(1, 66257, '\p{^Script=carian}', "");
    Expect(1, 66257, '\P{Script=carian}', "");
    Expect(0, 66257, '\P{^Script=carian}', "");
    Expect(1, 66256, '\p{Script=:\Acarian\z:}', "");;
    Expect(0, 66257, '\p{Script=:\Acarian\z:}', "");;
    Expect(1, 66256, '\p{Script=__carian}', "");
    Expect(0, 66256, '\p{^Script=__carian}', "");
    Expect(0, 66256, '\P{Script=__carian}', "");
    Expect(1, 66256, '\P{^Script=__carian}', "");
    Expect(0, 66257, '\p{Script=__carian}', "");
    Expect(1, 66257, '\p{^Script=__carian}', "");
    Expect(1, 66257, '\P{Script=__carian}', "");
    Expect(0, 66257, '\P{^Script=__carian}', "");
    Error('\p{Sc=-/a/Cari}');
    Error('\P{Sc=-/a/Cari}');
    Expect(1, 66256, '\p{Sc=:\ACari\z:}', "");;
    Expect(0, 66257, '\p{Sc=:\ACari\z:}', "");;
    Expect(1, 66256, '\p{Sc=cari}', "");
    Expect(0, 66256, '\p{^Sc=cari}', "");
    Expect(0, 66256, '\P{Sc=cari}', "");
    Expect(1, 66256, '\P{^Sc=cari}', "");
    Expect(0, 66257, '\p{Sc=cari}', "");
    Expect(1, 66257, '\p{^Sc=cari}', "");
    Expect(1, 66257, '\P{Sc=cari}', "");
    Expect(0, 66257, '\P{^Sc=cari}', "");
    Expect(1, 66256, '\p{Sc=:\Acari\z:}', "");;
    Expect(0, 66257, '\p{Sc=:\Acari\z:}', "");;
    Expect(1, 66256, '\p{Sc=__cari}', "");
    Expect(0, 66256, '\p{^Sc=__cari}', "");
    Expect(0, 66256, '\P{Sc=__cari}', "");
    Expect(1, 66256, '\P{^Sc=__cari}', "");
    Expect(0, 66257, '\p{Sc=__cari}', "");
    Expect(1, 66257, '\p{^Sc=__cari}', "");
    Expect(1, 66257, '\P{Sc=__cari}', "");
    Expect(0, 66257, '\P{^Sc=__cari}', "");
    Error('\p{Is_Script= carian/a/}');
    Error('\P{Is_Script= carian/a/}');
    Expect(1, 66256, '\p{Is_Script=carian}', "");
    Expect(0, 66256, '\p{^Is_Script=carian}', "");
    Expect(0, 66256, '\P{Is_Script=carian}', "");
    Expect(1, 66256, '\P{^Is_Script=carian}', "");
    Expect(0, 66257, '\p{Is_Script=carian}', "");
    Expect(1, 66257, '\p{^Is_Script=carian}', "");
    Expect(1, 66257, '\P{Is_Script=carian}', "");
    Expect(0, 66257, '\P{^Is_Script=carian}', "");
    Expect(1, 66256, '\p{Is_Script= CARIAN}', "");
    Expect(0, 66256, '\p{^Is_Script= CARIAN}', "");
    Expect(0, 66256, '\P{Is_Script= CARIAN}', "");
    Expect(1, 66256, '\P{^Is_Script= CARIAN}', "");
    Expect(0, 66257, '\p{Is_Script= CARIAN}', "");
    Expect(1, 66257, '\p{^Is_Script= CARIAN}', "");
    Expect(1, 66257, '\P{Is_Script= CARIAN}', "");
    Expect(0, 66257, '\P{^Is_Script= CARIAN}', "");
    Error('\p{Is_Sc=/a/cari}');
    Error('\P{Is_Sc=/a/cari}');
    Expect(1, 66256, '\p{Is_Sc=cari}', "");
    Expect(0, 66256, '\p{^Is_Sc=cari}', "");
    Expect(0, 66256, '\P{Is_Sc=cari}', "");
    Expect(1, 66256, '\P{^Is_Sc=cari}', "");
    Expect(0, 66257, '\p{Is_Sc=cari}', "");
    Expect(1, 66257, '\p{^Is_Sc=cari}', "");
    Expect(1, 66257, '\P{Is_Sc=cari}', "");
    Expect(0, 66257, '\P{^Is_Sc=cari}', "");
    Expect(1, 66256, '\p{Is_Sc: --Cari}', "");
    Expect(0, 66256, '\p{^Is_Sc: --Cari}', "");
    Expect(0, 66256, '\P{Is_Sc: --Cari}', "");
    Expect(1, 66256, '\P{^Is_Sc: --Cari}', "");
    Expect(0, 66257, '\p{Is_Sc: --Cari}', "");
    Expect(1, 66257, '\p{^Is_Sc: --Cari}', "");
    Expect(1, 66257, '\P{Is_Sc: --Cari}', "");
    Expect(0, 66257, '\P{^Is_Sc: --Cari}', "");
    Error('\p{Script: -Cham:=}');
    Error('\P{Script: -Cham:=}');
    Expect(1, 43615, '\p{Script=:\ACham\z:}', "");;
    Expect(0, 43616, '\p{Script=:\ACham\z:}', "");;
    Expect(1, 43615, '\p{Script=cham}', "");
    Expect(0, 43615, '\p{^Script=cham}', "");
    Expect(0, 43615, '\P{Script=cham}', "");
    Expect(1, 43615, '\P{^Script=cham}', "");
    Expect(0, 43616, '\p{Script=cham}', "");
    Expect(1, 43616, '\p{^Script=cham}', "");
    Expect(1, 43616, '\P{Script=cham}', "");
    Expect(0, 43616, '\P{^Script=cham}', "");
    Expect(1, 43615, '\p{Script=:\Acham\z:}', "");;
    Expect(0, 43616, '\p{Script=:\Acham\z:}', "");;
    Expect(1, 43615, '\p{Script=-Cham}', "");
    Expect(0, 43615, '\p{^Script=-Cham}', "");
    Expect(0, 43615, '\P{Script=-Cham}', "");
    Expect(1, 43615, '\P{^Script=-Cham}', "");
    Expect(0, 43616, '\p{Script=-Cham}', "");
    Expect(1, 43616, '\p{^Script=-Cham}', "");
    Expect(1, 43616, '\P{Script=-Cham}', "");
    Expect(0, 43616, '\P{^Script=-Cham}', "");
    Error('\p{Sc=-/a/CHAM}');
    Error('\P{Sc=-/a/CHAM}');
    Expect(1, 43615, '\p{Sc=:\ACham\z:}', "");;
    Expect(0, 43616, '\p{Sc=:\ACham\z:}', "");;
    Expect(1, 43615, '\p{Sc=cham}', "");
    Expect(0, 43615, '\p{^Sc=cham}', "");
    Expect(0, 43615, '\P{Sc=cham}', "");
    Expect(1, 43615, '\P{^Sc=cham}', "");
    Expect(0, 43616, '\p{Sc=cham}', "");
    Expect(1, 43616, '\p{^Sc=cham}', "");
    Expect(1, 43616, '\P{Sc=cham}', "");
    Expect(0, 43616, '\P{^Sc=cham}', "");
    Expect(1, 43615, '\p{Sc=:\Acham\z:}', "");;
    Expect(0, 43616, '\p{Sc=:\Acham\z:}', "");;
    Expect(1, 43615, '\p{Sc=	Cham}', "");
    Expect(0, 43615, '\p{^Sc=	Cham}', "");
    Expect(0, 43615, '\P{Sc=	Cham}', "");
    Expect(1, 43615, '\P{^Sc=	Cham}', "");
    Expect(0, 43616, '\p{Sc=	Cham}', "");
    Expect(1, 43616, '\p{^Sc=	Cham}', "");
    Expect(1, 43616, '\P{Sc=	Cham}', "");
    Expect(0, 43616, '\P{^Sc=	Cham}', "");
    Error('\p{Is_Script=/a/- Cham}');
    Error('\P{Is_Script=/a/- Cham}');
    Expect(1, 43615, '\p{Is_Script=cham}', "");
    Expect(0, 43615, '\p{^Is_Script=cham}', "");
    Expect(0, 43615, '\P{Is_Script=cham}', "");
    Expect(1, 43615, '\P{^Is_Script=cham}', "");
    Expect(0, 43616, '\p{Is_Script=cham}', "");
    Expect(1, 43616, '\p{^Is_Script=cham}', "");
    Expect(1, 43616, '\P{Is_Script=cham}', "");
    Expect(0, 43616, '\P{^Is_Script=cham}', "");
    Expect(1, 43615, '\p{Is_Script=_-cham}', "");
    Expect(0, 43615, '\p{^Is_Script=_-cham}', "");
    Expect(0, 43615, '\P{Is_Script=_-cham}', "");
    Expect(1, 43615, '\P{^Is_Script=_-cham}', "");
    Expect(0, 43616, '\p{Is_Script=_-cham}', "");
    Expect(1, 43616, '\p{^Is_Script=_-cham}', "");
    Expect(1, 43616, '\P{Is_Script=_-cham}', "");
    Expect(0, 43616, '\P{^Is_Script=_-cham}', "");
    Error('\p{Is_Sc=-/a/Cham}');
    Error('\P{Is_Sc=-/a/Cham}');
    Expect(1, 43615, '\p{Is_Sc=cham}', "");
    Expect(0, 43615, '\p{^Is_Sc=cham}', "");
    Expect(0, 43615, '\P{Is_Sc=cham}', "");
    Expect(1, 43615, '\P{^Is_Sc=cham}', "");
    Expect(0, 43616, '\p{Is_Sc=cham}', "");
    Expect(1, 43616, '\p{^Is_Sc=cham}', "");
    Expect(1, 43616, '\P{Is_Sc=cham}', "");
    Expect(0, 43616, '\P{^Is_Sc=cham}', "");
    Expect(1, 43615, '\p{Is_Sc= 	Cham}', "");
    Expect(0, 43615, '\p{^Is_Sc= 	Cham}', "");
    Expect(0, 43615, '\P{Is_Sc= 	Cham}', "");
    Expect(1, 43615, '\P{^Is_Sc= 	Cham}', "");
    Expect(0, 43616, '\p{Is_Sc= 	Cham}', "");
    Expect(1, 43616, '\p{^Is_Sc= 	Cham}', "");
    Expect(1, 43616, '\P{Is_Sc= 	Cham}', "");
    Expect(0, 43616, '\P{^Is_Sc= 	Cham}', "");
    Error('\p{Script=	/a/Cherokee}');
    Error('\P{Script=	/a/Cherokee}');
    Expect(1, 43967, '\p{Script=:\ACherokee\z:}', "");;
    Expect(0, 43968, '\p{Script=:\ACherokee\z:}', "");;
    Expect(1, 43967, '\p{Script=cherokee}', "");
    Expect(0, 43967, '\p{^Script=cherokee}', "");
    Expect(0, 43967, '\P{Script=cherokee}', "");
    Expect(1, 43967, '\P{^Script=cherokee}', "");
    Expect(0, 43968, '\p{Script=cherokee}', "");
    Expect(1, 43968, '\p{^Script=cherokee}', "");
    Expect(1, 43968, '\P{Script=cherokee}', "");
    Expect(0, 43968, '\P{^Script=cherokee}', "");
    Expect(1, 43967, '\p{Script=:\Acherokee\z:}', "");;
    Expect(0, 43968, '\p{Script=:\Acherokee\z:}', "");;
    Expect(1, 43967, '\p{Script=CHEROKEE}', "");
    Expect(0, 43967, '\p{^Script=CHEROKEE}', "");
    Expect(0, 43967, '\P{Script=CHEROKEE}', "");
    Expect(1, 43967, '\P{^Script=CHEROKEE}', "");
    Expect(0, 43968, '\p{Script=CHEROKEE}', "");
    Expect(1, 43968, '\p{^Script=CHEROKEE}', "");
    Expect(1, 43968, '\P{Script=CHEROKEE}', "");
    Expect(0, 43968, '\P{^Script=CHEROKEE}', "");
    Error('\p{Sc: :=_	CHER}');
    Error('\P{Sc: :=_	CHER}');
    Expect(1, 43967, '\p{Sc=:\ACher\z:}', "");;
    Expect(0, 43968, '\p{Sc=:\ACher\z:}', "");;
    Expect(1, 43967, '\p{Sc=cher}', "");
    Expect(0, 43967, '\p{^Sc=cher}', "");
    Expect(0, 43967, '\P{Sc=cher}', "");
    Expect(1, 43967, '\P{^Sc=cher}', "");
    Expect(0, 43968, '\p{Sc=cher}', "");
    Expect(1, 43968, '\p{^Sc=cher}', "");
    Expect(1, 43968, '\P{Sc=cher}', "");
    Expect(0, 43968, '\P{^Sc=cher}', "");
    Expect(1, 43967, '\p{Sc=:\Acher\z:}', "");;
    Expect(0, 43968, '\p{Sc=:\Acher\z:}', "");;
    Expect(1, 43967, '\p{Sc=_-CHER}', "");
    Expect(0, 43967, '\p{^Sc=_-CHER}', "");
    Expect(0, 43967, '\P{Sc=_-CHER}', "");
    Expect(1, 43967, '\P{^Sc=_-CHER}', "");
    Expect(0, 43968, '\p{Sc=_-CHER}', "");
    Expect(1, 43968, '\p{^Sc=_-CHER}', "");
    Expect(1, 43968, '\P{Sc=_-CHER}', "");
    Expect(0, 43968, '\P{^Sc=_-CHER}', "");
    Error('\p{Is_Script=_/a/Cherokee}');
    Error('\P{Is_Script=_/a/Cherokee}');
    Expect(1, 43967, '\p{Is_Script=cherokee}', "");
    Expect(0, 43967, '\p{^Is_Script=cherokee}', "");
    Expect(0, 43967, '\P{Is_Script=cherokee}', "");
    Expect(1, 43967, '\P{^Is_Script=cherokee}', "");
    Expect(0, 43968, '\p{Is_Script=cherokee}', "");
    Expect(1, 43968, '\p{^Is_Script=cherokee}', "");
    Expect(1, 43968, '\P{Is_Script=cherokee}', "");
    Expect(0, 43968, '\P{^Is_Script=cherokee}', "");
    Expect(1, 43967, '\p{Is_Script=-Cherokee}', "");
    Expect(0, 43967, '\p{^Is_Script=-Cherokee}', "");
    Expect(0, 43967, '\P{Is_Script=-Cherokee}', "");
    Expect(1, 43967, '\P{^Is_Script=-Cherokee}', "");
    Expect(0, 43968, '\p{Is_Script=-Cherokee}', "");
    Expect(1, 43968, '\p{^Is_Script=-Cherokee}', "");
    Expect(1, 43968, '\P{Is_Script=-Cherokee}', "");
    Expect(0, 43968, '\P{^Is_Script=-Cherokee}', "");
    Error('\p{Is_Sc=_	CHER/a/}');
    Error('\P{Is_Sc=_	CHER/a/}');
    Expect(1, 43967, '\p{Is_Sc=cher}', "");
    Expect(0, 43967, '\p{^Is_Sc=cher}', "");
    Expect(0, 43967, '\P{Is_Sc=cher}', "");
    Expect(1, 43967, '\P{^Is_Sc=cher}', "");
    Expect(0, 43968, '\p{Is_Sc=cher}', "");
    Expect(1, 43968, '\p{^Is_Sc=cher}', "");
    Expect(1, 43968, '\P{Is_Sc=cher}', "");
    Expect(0, 43968, '\P{^Is_Sc=cher}', "");
    Expect(1, 43967, '\p{Is_Sc=  CHER}', "");
    Expect(0, 43967, '\p{^Is_Sc=  CHER}', "");
    Expect(0, 43967, '\P{Is_Sc=  CHER}', "");
    Expect(1, 43967, '\P{^Is_Sc=  CHER}', "");
    Expect(0, 43968, '\p{Is_Sc=  CHER}', "");
    Expect(1, 43968, '\p{^Is_Sc=  CHER}', "");
    Expect(1, 43968, '\P{Is_Sc=  CHER}', "");
    Expect(0, 43968, '\P{^Is_Sc=  CHER}', "");
    Error('\p{Script=_/a/coptic}');
    Error('\P{Script=_/a/coptic}');
    Expect(1, 11519, '\p{Script=:\ACoptic\z:}', "");;
    Expect(0, 11520, '\p{Script=:\ACoptic\z:}', "");;
    Expect(1, 11519, '\p{Script: coptic}', "");
    Expect(0, 11519, '\p{^Script: coptic}', "");
    Expect(0, 11519, '\P{Script: coptic}', "");
    Expect(1, 11519, '\P{^Script: coptic}', "");
    Expect(0, 11520, '\p{Script: coptic}', "");
    Expect(1, 11520, '\p{^Script: coptic}', "");
    Expect(1, 11520, '\P{Script: coptic}', "");
    Expect(0, 11520, '\P{^Script: coptic}', "");
    Expect(1, 11519, '\p{Script=:\Acoptic\z:}', "");;
    Expect(0, 11520, '\p{Script=:\Acoptic\z:}', "");;
    Expect(1, 11519, '\p{Script:	--COPTIC}', "");
    Expect(0, 11519, '\p{^Script:	--COPTIC}', "");
    Expect(0, 11519, '\P{Script:	--COPTIC}', "");
    Expect(1, 11519, '\P{^Script:	--COPTIC}', "");
    Expect(0, 11520, '\p{Script:	--COPTIC}', "");
    Expect(1, 11520, '\p{^Script:	--COPTIC}', "");
    Expect(1, 11520, '\P{Script:	--COPTIC}', "");
    Expect(0, 11520, '\P{^Script:	--COPTIC}', "");
    Error('\p{Sc=/a/_-Copt}');
    Error('\P{Sc=/a/_-Copt}');
    Expect(1, 11519, '\p{Sc=:\ACopt\z:}', "");;
    Expect(0, 11520, '\p{Sc=:\ACopt\z:}', "");;
    Expect(1, 11519, '\p{Sc=copt}', "");
    Expect(0, 11519, '\p{^Sc=copt}', "");
    Expect(0, 11519, '\P{Sc=copt}', "");
    Expect(1, 11519, '\P{^Sc=copt}', "");
    Expect(0, 11520, '\p{Sc=copt}', "");
    Expect(1, 11520, '\p{^Sc=copt}', "");
    Expect(1, 11520, '\P{Sc=copt}', "");
    Expect(0, 11520, '\P{^Sc=copt}', "");
    Expect(1, 11519, '\p{Sc=:\Acopt\z:}', "");;
    Expect(0, 11520, '\p{Sc=:\Acopt\z:}', "");;
    Expect(1, 11519, '\p{Sc=	 copt}', "");
    Expect(0, 11519, '\p{^Sc=	 copt}', "");
    Expect(0, 11519, '\P{Sc=	 copt}', "");
    Expect(1, 11519, '\P{^Sc=	 copt}', "");
    Expect(0, 11520, '\p{Sc=	 copt}', "");
    Expect(1, 11520, '\p{^Sc=	 copt}', "");
    Expect(1, 11520, '\P{Sc=	 copt}', "");
    Expect(0, 11520, '\P{^Sc=	 copt}', "");
    Error('\p{Is_Script=-Qaac/a/}');
    Error('\P{Is_Script=-Qaac/a/}');
    Expect(1, 11519, '\p{Is_Script: qaac}', "");
    Expect(0, 11519, '\p{^Is_Script: qaac}', "");
    Expect(0, 11519, '\P{Is_Script: qaac}', "");
    Expect(1, 11519, '\P{^Is_Script: qaac}', "");
    Expect(0, 11520, '\p{Is_Script: qaac}', "");
    Expect(1, 11520, '\p{^Is_Script: qaac}', "");
    Expect(1, 11520, '\P{Is_Script: qaac}', "");
    Expect(0, 11520, '\P{^Is_Script: qaac}', "");
    Expect(1, 11519, '\p{Is_Script: -Qaac}', "");
    Expect(0, 11519, '\p{^Is_Script: -Qaac}', "");
    Expect(0, 11519, '\P{Is_Script: -Qaac}', "");
    Expect(1, 11519, '\P{^Is_Script: -Qaac}', "");
    Expect(0, 11520, '\p{Is_Script: -Qaac}', "");
    Expect(1, 11520, '\p{^Is_Script: -Qaac}', "");
    Expect(1, 11520, '\P{Is_Script: -Qaac}', "");
    Expect(0, 11520, '\P{^Is_Script: -Qaac}', "");
    Error('\p{Is_Sc=/a/  COPTIC}');
    Error('\P{Is_Sc=/a/  COPTIC}');
    Expect(1, 11519, '\p{Is_Sc=coptic}', "");
    Expect(0, 11519, '\p{^Is_Sc=coptic}', "");
    Expect(0, 11519, '\P{Is_Sc=coptic}', "");
    Expect(1, 11519, '\P{^Is_Sc=coptic}', "");
    Expect(0, 11520, '\p{Is_Sc=coptic}', "");
    Expect(1, 11520, '\p{^Is_Sc=coptic}', "");
    Expect(1, 11520, '\P{Is_Sc=coptic}', "");
    Expect(0, 11520, '\P{^Is_Sc=coptic}', "");
    Expect(1, 11519, '\p{Is_Sc=_	coptic}', "");
    Expect(0, 11519, '\p{^Is_Sc=_	coptic}', "");
    Expect(0, 11519, '\P{Is_Sc=_	coptic}', "");
    Expect(1, 11519, '\P{^Is_Sc=_	coptic}', "");
    Expect(0, 11520, '\p{Is_Sc=_	coptic}', "");
    Expect(1, 11520, '\p{^Is_Sc=_	coptic}', "");
    Expect(1, 11520, '\P{Is_Sc=_	coptic}', "");
    Expect(0, 11520, '\P{^Is_Sc=_	coptic}', "");
    Error('\p{Script=	:=Cypriot}');
    Error('\P{Script=	:=Cypriot}');
    Expect(1, 67647, '\p{Script=:\ACypriot\z:}', "");;
    Expect(0, 67648, '\p{Script=:\ACypriot\z:}', "");;
    Expect(1, 67647, '\p{Script=cypriot}', "");
    Expect(0, 67647, '\p{^Script=cypriot}', "");
    Expect(0, 67647, '\P{Script=cypriot}', "");
    Expect(1, 67647, '\P{^Script=cypriot}', "");
    Expect(0, 67648, '\p{Script=cypriot}', "");
    Expect(1, 67648, '\p{^Script=cypriot}', "");
    Expect(1, 67648, '\P{Script=cypriot}', "");
    Expect(0, 67648, '\P{^Script=cypriot}', "");
    Expect(1, 67647, '\p{Script=:\Acypriot\z:}', "");;
    Expect(0, 67648, '\p{Script=:\Acypriot\z:}', "");;
    Expect(1, 67647, '\p{Script=	_Cypriot}', "");
    Expect(0, 67647, '\p{^Script=	_Cypriot}', "");
    Expect(0, 67647, '\P{Script=	_Cypriot}', "");
    Expect(1, 67647, '\P{^Script=	_Cypriot}', "");
    Expect(0, 67648, '\p{Script=	_Cypriot}', "");
    Expect(1, 67648, '\p{^Script=	_Cypriot}', "");
    Expect(1, 67648, '\P{Script=	_Cypriot}', "");
    Expect(0, 67648, '\P{^Script=	_Cypriot}', "");
    Error('\p{Sc= :=Cprt}');
    Error('\P{Sc= :=Cprt}');
    Expect(1, 67647, '\p{Sc=:\ACprt\z:}', "");;
    Expect(0, 67648, '\p{Sc=:\ACprt\z:}', "");;
    Expect(1, 67647, '\p{Sc=cprt}', "");
    Expect(0, 67647, '\p{^Sc=cprt}', "");
    Expect(0, 67647, '\P{Sc=cprt}', "");
    Expect(1, 67647, '\P{^Sc=cprt}', "");
    Expect(0, 67648, '\p{Sc=cprt}', "");
    Expect(1, 67648, '\p{^Sc=cprt}', "");
    Expect(1, 67648, '\P{Sc=cprt}', "");
    Expect(0, 67648, '\P{^Sc=cprt}', "");
    Expect(1, 67647, '\p{Sc=:\Acprt\z:}', "");;
    Expect(0, 67648, '\p{Sc=:\Acprt\z:}', "");;
    Expect(1, 67647, '\p{Sc=_CPRT}', "");
    Expect(0, 67647, '\p{^Sc=_CPRT}', "");
    Expect(0, 67647, '\P{Sc=_CPRT}', "");
    Expect(1, 67647, '\P{^Sc=_CPRT}', "");
    Expect(0, 67648, '\p{Sc=_CPRT}', "");
    Expect(1, 67648, '\p{^Sc=_CPRT}', "");
    Expect(1, 67648, '\P{Sc=_CPRT}', "");
    Expect(0, 67648, '\P{^Sc=_CPRT}', "");
    Error('\p{Is_Script= /a/cypriot}');
    Error('\P{Is_Script= /a/cypriot}');
    Expect(1, 67647, '\p{Is_Script=cypriot}', "");
    Expect(0, 67647, '\p{^Is_Script=cypriot}', "");
    Expect(0, 67647, '\P{Is_Script=cypriot}', "");
    Expect(1, 67647, '\P{^Is_Script=cypriot}', "");
    Expect(0, 67648, '\p{Is_Script=cypriot}', "");
    Expect(1, 67648, '\p{^Is_Script=cypriot}', "");
    Expect(1, 67648, '\P{Is_Script=cypriot}', "");
    Expect(0, 67648, '\P{^Is_Script=cypriot}', "");
    Expect(1, 67647, '\p{Is_Script=_	cypriot}', "");
    Expect(0, 67647, '\p{^Is_Script=_	cypriot}', "");
    Expect(0, 67647, '\P{Is_Script=_	cypriot}', "");
    Expect(1, 67647, '\P{^Is_Script=_	cypriot}', "");
    Expect(0, 67648, '\p{Is_Script=_	cypriot}', "");
    Expect(1, 67648, '\p{^Is_Script=_	cypriot}', "");
    Expect(1, 67648, '\P{Is_Script=_	cypriot}', "");
    Expect(0, 67648, '\P{^Is_Script=_	cypriot}', "");
    Error('\p{Is_Sc=-Cprt:=}');
    Error('\P{Is_Sc=-Cprt:=}');
    Expect(1, 67647, '\p{Is_Sc=cprt}', "");
    Expect(0, 67647, '\p{^Is_Sc=cprt}', "");
    Expect(0, 67647, '\P{Is_Sc=cprt}', "");
    Expect(1, 67647, '\P{^Is_Sc=cprt}', "");
    Expect(0, 67648, '\p{Is_Sc=cprt}', "");
    Expect(1, 67648, '\p{^Is_Sc=cprt}', "");
    Expect(1, 67648, '\P{Is_Sc=cprt}', "");
    Expect(0, 67648, '\P{^Is_Sc=cprt}', "");
    Expect(1, 67647, '\p{Is_Sc=_-Cprt}', "");
    Expect(0, 67647, '\p{^Is_Sc=_-Cprt}', "");
    Expect(0, 67647, '\P{Is_Sc=_-Cprt}', "");
    Expect(1, 67647, '\P{^Is_Sc=_-Cprt}', "");
    Expect(0, 67648, '\p{Is_Sc=_-Cprt}', "");
    Expect(1, 67648, '\p{^Is_Sc=_-Cprt}', "");
    Expect(1, 67648, '\P{Is_Sc=_-Cprt}', "");
    Expect(0, 67648, '\P{^Is_Sc=_-Cprt}', "");
    Error('\p{Script:	:= Cyrillic}');
    Error('\P{Script:	:= Cyrillic}');
    Expect(1, 65071, '\p{Script=:\ACyrillic\z:}', "");;
    Expect(0, 65072, '\p{Script=:\ACyrillic\z:}', "");;
    Expect(1, 65071, '\p{Script=cyrillic}', "");
    Expect(0, 65071, '\p{^Script=cyrillic}', "");
    Expect(0, 65071, '\P{Script=cyrillic}', "");
    Expect(1, 65071, '\P{^Script=cyrillic}', "");
    Expect(0, 65072, '\p{Script=cyrillic}', "");
    Expect(1, 65072, '\p{^Script=cyrillic}', "");
    Expect(1, 65072, '\P{Script=cyrillic}', "");
    Expect(0, 65072, '\P{^Script=cyrillic}', "");
    Expect(1, 65071, '\p{Script=:\Acyrillic\z:}', "");;
    Expect(0, 65072, '\p{Script=:\Acyrillic\z:}', "");;
    Expect(1, 65071, '\p{Script=__Cyrillic}', "");
    Expect(0, 65071, '\p{^Script=__Cyrillic}', "");
    Expect(0, 65071, '\P{Script=__Cyrillic}', "");
    Expect(1, 65071, '\P{^Script=__Cyrillic}', "");
    Expect(0, 65072, '\p{Script=__Cyrillic}', "");
    Expect(1, 65072, '\p{^Script=__Cyrillic}', "");
    Expect(1, 65072, '\P{Script=__Cyrillic}', "");
    Expect(0, 65072, '\P{^Script=__Cyrillic}', "");
    Error('\p{Sc=:=  CYRL}');
    Error('\P{Sc=:=  CYRL}');
    Expect(1, 65071, '\p{Sc=:\ACyrl\z:}', "");;
    Expect(0, 65072, '\p{Sc=:\ACyrl\z:}', "");;
    Expect(1, 65071, '\p{Sc:   cyrl}', "");
    Expect(0, 65071, '\p{^Sc:   cyrl}', "");
    Expect(0, 65071, '\P{Sc:   cyrl}', "");
    Expect(1, 65071, '\P{^Sc:   cyrl}', "");
    Expect(0, 65072, '\p{Sc:   cyrl}', "");
    Expect(1, 65072, '\p{^Sc:   cyrl}', "");
    Expect(1, 65072, '\P{Sc:   cyrl}', "");
    Expect(0, 65072, '\P{^Sc:   cyrl}', "");
    Expect(1, 65071, '\p{Sc=:\Acyrl\z:}', "");;
    Expect(0, 65072, '\p{Sc=:\Acyrl\z:}', "");;
    Expect(1, 65071, '\p{Sc:    Cyrl}', "");
    Expect(0, 65071, '\p{^Sc:    Cyrl}', "");
    Expect(0, 65071, '\P{Sc:    Cyrl}', "");
    Expect(1, 65071, '\P{^Sc:    Cyrl}', "");
    Expect(0, 65072, '\p{Sc:    Cyrl}', "");
    Expect(1, 65072, '\p{^Sc:    Cyrl}', "");
    Expect(1, 65072, '\P{Sc:    Cyrl}', "");
    Expect(0, 65072, '\P{^Sc:    Cyrl}', "");
    Error('\p{Is_Script=_	cyrillic:=}');
    Error('\P{Is_Script=_	cyrillic:=}');
    Expect(1, 65071, '\p{Is_Script: cyrillic}', "");
    Expect(0, 65071, '\p{^Is_Script: cyrillic}', "");
    Expect(0, 65071, '\P{Is_Script: cyrillic}', "");
    Expect(1, 65071, '\P{^Is_Script: cyrillic}', "");
    Expect(0, 65072, '\p{Is_Script: cyrillic}', "");
    Expect(1, 65072, '\p{^Is_Script: cyrillic}', "");
    Expect(1, 65072, '\P{Is_Script: cyrillic}', "");
    Expect(0, 65072, '\P{^Is_Script: cyrillic}', "");
    Expect(1, 65071, '\p{Is_Script=_Cyrillic}', "");
    Expect(0, 65071, '\p{^Is_Script=_Cyrillic}', "");
    Expect(0, 65071, '\P{Is_Script=_Cyrillic}', "");
    Expect(1, 65071, '\P{^Is_Script=_Cyrillic}', "");
    Expect(0, 65072, '\p{Is_Script=_Cyrillic}', "");
    Expect(1, 65072, '\p{^Is_Script=_Cyrillic}', "");
    Expect(1, 65072, '\P{Is_Script=_Cyrillic}', "");
    Expect(0, 65072, '\P{^Is_Script=_Cyrillic}', "");
    Error('\p{Is_Sc=	:=cyrl}');
    Error('\P{Is_Sc=	:=cyrl}');
    Expect(1, 65071, '\p{Is_Sc:cyrl}', "");
    Expect(0, 65071, '\p{^Is_Sc:cyrl}', "");
    Expect(0, 65071, '\P{Is_Sc:cyrl}', "");
    Expect(1, 65071, '\P{^Is_Sc:cyrl}', "");
    Expect(0, 65072, '\p{Is_Sc:cyrl}', "");
    Expect(1, 65072, '\p{^Is_Sc:cyrl}', "");
    Expect(1, 65072, '\P{Is_Sc:cyrl}', "");
    Expect(0, 65072, '\P{^Is_Sc:cyrl}', "");
    Expect(1, 65071, '\p{Is_Sc=_-cyrl}', "");
    Expect(0, 65071, '\p{^Is_Sc=_-cyrl}', "");
    Expect(0, 65071, '\P{Is_Sc=_-cyrl}', "");
    Expect(1, 65071, '\P{^Is_Sc=_-cyrl}', "");
    Expect(0, 65072, '\p{Is_Sc=_-cyrl}', "");
    Expect(1, 65072, '\p{^Is_Sc=_-cyrl}', "");
    Expect(1, 65072, '\P{Is_Sc=_-cyrl}', "");
    Expect(0, 65072, '\P{^Is_Sc=_-cyrl}', "");
    Error('\p{Script=_devanagari/a/}');
    Error('\P{Script=_devanagari/a/}');
    Expect(1, 43263, '\p{Script=:\ADevanagari\z:}', "");;
    Expect(0, 43264, '\p{Script=:\ADevanagari\z:}', "");;
    Expect(1, 43263, '\p{Script=devanagari}', "");
    Expect(0, 43263, '\p{^Script=devanagari}', "");
    Expect(0, 43263, '\P{Script=devanagari}', "");
    Expect(1, 43263, '\P{^Script=devanagari}', "");
    Expect(0, 43264, '\p{Script=devanagari}', "");
    Expect(1, 43264, '\p{^Script=devanagari}', "");
    Expect(1, 43264, '\P{Script=devanagari}', "");
    Expect(0, 43264, '\P{^Script=devanagari}', "");
    Expect(1, 43263, '\p{Script=:\Adevanagari\z:}', "");;
    Expect(0, 43264, '\p{Script=:\Adevanagari\z:}', "");;
    Expect(1, 43263, '\p{Script=_ devanagari}', "");
    Expect(0, 43263, '\p{^Script=_ devanagari}', "");
    Expect(0, 43263, '\P{Script=_ devanagari}', "");
    Expect(1, 43263, '\P{^Script=_ devanagari}', "");
    Expect(0, 43264, '\p{Script=_ devanagari}', "");
    Expect(1, 43264, '\p{^Script=_ devanagari}', "");
    Expect(1, 43264, '\P{Script=_ devanagari}', "");
    Expect(0, 43264, '\P{^Script=_ devanagari}', "");
    Error('\p{Sc:Deva/a/}');
    Error('\P{Sc:Deva/a/}');
    Expect(1, 43263, '\p{Sc=:\ADeva\z:}', "");;
    Expect(0, 43264, '\p{Sc=:\ADeva\z:}', "");;
    Expect(1, 43263, '\p{Sc=deva}', "");
    Expect(0, 43263, '\p{^Sc=deva}', "");
    Expect(0, 43263, '\P{Sc=deva}', "");
    Expect(1, 43263, '\P{^Sc=deva}', "");
    Expect(0, 43264, '\p{Sc=deva}', "");
    Expect(1, 43264, '\p{^Sc=deva}', "");
    Expect(1, 43264, '\P{Sc=deva}', "");
    Expect(0, 43264, '\P{^Sc=deva}', "");
    Expect(1, 43263, '\p{Sc=:\Adeva\z:}', "");;
    Expect(0, 43264, '\p{Sc=:\Adeva\z:}', "");;
    Expect(1, 43263, '\p{Sc=	-Deva}', "");
    Expect(0, 43263, '\p{^Sc=	-Deva}', "");
    Expect(0, 43263, '\P{Sc=	-Deva}', "");
    Expect(1, 43263, '\P{^Sc=	-Deva}', "");
    Expect(0, 43264, '\p{Sc=	-Deva}', "");
    Expect(1, 43264, '\p{^Sc=	-Deva}', "");
    Expect(1, 43264, '\P{Sc=	-Deva}', "");
    Expect(0, 43264, '\P{^Sc=	-Deva}', "");
    Error('\p{Is_Script:	 /a/Devanagari}');
    Error('\P{Is_Script:	 /a/Devanagari}');
    Expect(1, 43263, '\p{Is_Script=devanagari}', "");
    Expect(0, 43263, '\p{^Is_Script=devanagari}', "");
    Expect(0, 43263, '\P{Is_Script=devanagari}', "");
    Expect(1, 43263, '\P{^Is_Script=devanagari}', "");
    Expect(0, 43264, '\p{Is_Script=devanagari}', "");
    Expect(1, 43264, '\p{^Is_Script=devanagari}', "");
    Expect(1, 43264, '\P{Is_Script=devanagari}', "");
    Expect(0, 43264, '\P{^Is_Script=devanagari}', "");
    Expect(1, 43263, '\p{Is_Script=_ Devanagari}', "");
    Expect(0, 43263, '\p{^Is_Script=_ Devanagari}', "");
    Expect(0, 43263, '\P{Is_Script=_ Devanagari}', "");
    Expect(1, 43263, '\P{^Is_Script=_ Devanagari}', "");
    Expect(0, 43264, '\p{Is_Script=_ Devanagari}', "");
    Expect(1, 43264, '\p{^Is_Script=_ Devanagari}', "");
    Expect(1, 43264, '\P{Is_Script=_ Devanagari}', "");
    Expect(0, 43264, '\P{^Is_Script=_ Devanagari}', "");
    Error('\p{Is_Sc=:=_	Deva}');
    Error('\P{Is_Sc=:=_	Deva}');
    Expect(1, 43263, '\p{Is_Sc=deva}', "");
    Expect(0, 43263, '\p{^Is_Sc=deva}', "");
    Expect(0, 43263, '\P{Is_Sc=deva}', "");
    Expect(1, 43263, '\P{^Is_Sc=deva}', "");
    Expect(0, 43264, '\p{Is_Sc=deva}', "");
    Expect(1, 43264, '\p{^Is_Sc=deva}', "");
    Expect(1, 43264, '\P{Is_Sc=deva}', "");
    Expect(0, 43264, '\P{^Is_Sc=deva}', "");
    Expect(1, 43263, '\p{Is_Sc= -Deva}', "");
    Expect(0, 43263, '\p{^Is_Sc= -Deva}', "");
    Expect(0, 43263, '\P{Is_Sc= -Deva}', "");
    Expect(1, 43263, '\P{^Is_Sc= -Deva}', "");
    Expect(0, 43264, '\p{Is_Sc= -Deva}', "");
    Expect(1, 43264, '\p{^Is_Sc= -Deva}', "");
    Expect(1, 43264, '\P{Is_Sc= -Deva}', "");
    Expect(0, 43264, '\P{^Is_Sc= -Deva}', "");
    Error('\p{Script=_ DOGRA/a/}');
    Error('\P{Script=_ DOGRA/a/}');
    Expect(1, 71739, '\p{Script=:\ADogra\z:}', "");;
    Expect(0, 71740, '\p{Script=:\ADogra\z:}', "");;
    Expect(1, 71739, '\p{Script=dogra}', "");
    Expect(0, 71739, '\p{^Script=dogra}', "");
    Expect(0, 71739, '\P{Script=dogra}', "");
    Expect(1, 71739, '\P{^Script=dogra}', "");
    Expect(0, 71740, '\p{Script=dogra}', "");
    Expect(1, 71740, '\p{^Script=dogra}', "");
    Expect(1, 71740, '\P{Script=dogra}', "");
    Expect(0, 71740, '\P{^Script=dogra}', "");
    Expect(1, 71739, '\p{Script=:\Adogra\z:}', "");;
    Expect(0, 71740, '\p{Script=:\Adogra\z:}', "");;
    Expect(1, 71739, '\p{Script:_ Dogra}', "");
    Expect(0, 71739, '\p{^Script:_ Dogra}', "");
    Expect(0, 71739, '\P{Script:_ Dogra}', "");
    Expect(1, 71739, '\P{^Script:_ Dogra}', "");
    Expect(0, 71740, '\p{Script:_ Dogra}', "");
    Expect(1, 71740, '\p{^Script:_ Dogra}', "");
    Expect(1, 71740, '\P{Script:_ Dogra}', "");
    Expect(0, 71740, '\P{^Script:_ Dogra}', "");
    Error('\p{Sc=/a/ Dogr}');
    Error('\P{Sc=/a/ Dogr}');
    Expect(1, 71739, '\p{Sc=:\ADogr\z:}', "");;
    Expect(0, 71740, '\p{Sc=:\ADogr\z:}', "");;
    Expect(1, 71739, '\p{Sc=dogr}', "");
    Expect(0, 71739, '\p{^Sc=dogr}', "");
    Expect(0, 71739, '\P{Sc=dogr}', "");
    Expect(1, 71739, '\P{^Sc=dogr}', "");
    Expect(0, 71740, '\p{Sc=dogr}', "");
    Expect(1, 71740, '\p{^Sc=dogr}', "");
    Expect(1, 71740, '\P{Sc=dogr}', "");
    Expect(0, 71740, '\P{^Sc=dogr}', "");
    Expect(1, 71739, '\p{Sc=:\Adogr\z:}', "");;
    Expect(0, 71740, '\p{Sc=:\Adogr\z:}', "");;
    Expect(1, 71739, '\p{Sc=	 dogr}', "");
    Expect(0, 71739, '\p{^Sc=	 dogr}', "");
    Expect(0, 71739, '\P{Sc=	 dogr}', "");
    Expect(1, 71739, '\P{^Sc=	 dogr}', "");
    Expect(0, 71740, '\p{Sc=	 dogr}', "");
    Expect(1, 71740, '\p{^Sc=	 dogr}', "");
    Expect(1, 71740, '\P{Sc=	 dogr}', "");
    Expect(0, 71740, '\P{^Sc=	 dogr}', "");
    Error('\p{Is_Script=-/a/DOGRA}');
    Error('\P{Is_Script=-/a/DOGRA}');
    Expect(1, 71739, '\p{Is_Script=dogra}', "");
    Expect(0, 71739, '\p{^Is_Script=dogra}', "");
    Expect(0, 71739, '\P{Is_Script=dogra}', "");
    Expect(1, 71739, '\P{^Is_Script=dogra}', "");
    Expect(0, 71740, '\p{Is_Script=dogra}', "");
    Expect(1, 71740, '\p{^Is_Script=dogra}', "");
    Expect(1, 71740, '\P{Is_Script=dogra}', "");
    Expect(0, 71740, '\P{^Is_Script=dogra}', "");
    Expect(1, 71739, '\p{Is_Script=		DOGRA}', "");
    Expect(0, 71739, '\p{^Is_Script=		DOGRA}', "");
    Expect(0, 71739, '\P{Is_Script=		DOGRA}', "");
    Expect(1, 71739, '\P{^Is_Script=		DOGRA}', "");
    Expect(0, 71740, '\p{Is_Script=		DOGRA}', "");
    Expect(1, 71740, '\p{^Is_Script=		DOGRA}', "");
    Expect(1, 71740, '\P{Is_Script=		DOGRA}', "");
    Expect(0, 71740, '\P{^Is_Script=		DOGRA}', "");
    Error('\p{Is_Sc=:= -Dogr}');
    Error('\P{Is_Sc=:= -Dogr}');
    Expect(1, 71739, '\p{Is_Sc=dogr}', "");
    Expect(0, 71739, '\p{^Is_Sc=dogr}', "");
    Expect(0, 71739, '\P{Is_Sc=dogr}', "");
    Expect(1, 71739, '\P{^Is_Sc=dogr}', "");
    Expect(0, 71740, '\p{Is_Sc=dogr}', "");
    Expect(1, 71740, '\p{^Is_Sc=dogr}', "");
    Expect(1, 71740, '\P{Is_Sc=dogr}', "");
    Expect(0, 71740, '\P{^Is_Sc=dogr}', "");
    Expect(1, 71739, '\p{Is_Sc= _dogr}', "");
    Expect(0, 71739, '\p{^Is_Sc= _dogr}', "");
    Expect(0, 71739, '\P{Is_Sc= _dogr}', "");
    Expect(1, 71739, '\P{^Is_Sc= _dogr}', "");
    Expect(0, 71740, '\p{Is_Sc= _dogr}', "");
    Expect(1, 71740, '\p{^Is_Sc= _dogr}', "");
    Expect(1, 71740, '\P{Is_Sc= _dogr}', "");
    Expect(0, 71740, '\P{^Is_Sc= _dogr}', "");
    Error('\p{Script=-/a/Deseret}');
    Error('\P{Script=-/a/Deseret}');
    Expect(1, 66639, '\p{Script=:\ADeseret\z:}', "");;
    Expect(0, 66640, '\p{Script=:\ADeseret\z:}', "");;
    Expect(1, 66639, '\p{Script=deseret}', "");
    Expect(0, 66639, '\p{^Script=deseret}', "");
    Expect(0, 66639, '\P{Script=deseret}', "");
    Expect(1, 66639, '\P{^Script=deseret}', "");
    Expect(0, 66640, '\p{Script=deseret}', "");
    Expect(1, 66640, '\p{^Script=deseret}', "");
    Expect(1, 66640, '\P{Script=deseret}', "");
    Expect(0, 66640, '\P{^Script=deseret}', "");
    Expect(1, 66639, '\p{Script=:\Adeseret\z:}', "");;
    Expect(0, 66640, '\p{Script=:\Adeseret\z:}', "");;
    Expect(1, 66639, '\p{Script= 	deseret}', "");
    Expect(0, 66639, '\p{^Script= 	deseret}', "");
    Expect(0, 66639, '\P{Script= 	deseret}', "");
    Expect(1, 66639, '\P{^Script= 	deseret}', "");
    Expect(0, 66640, '\p{Script= 	deseret}', "");
    Expect(1, 66640, '\p{^Script= 	deseret}', "");
    Expect(1, 66640, '\P{Script= 	deseret}', "");
    Expect(0, 66640, '\P{^Script= 	deseret}', "");
    Error('\p{Sc=	/a/Dsrt}');
    Error('\P{Sc=	/a/Dsrt}');
    Expect(1, 66639, '\p{Sc=:\ADsrt\z:}', "");;
    Expect(0, 66640, '\p{Sc=:\ADsrt\z:}', "");;
    Expect(1, 66639, '\p{Sc=dsrt}', "");
    Expect(0, 66639, '\p{^Sc=dsrt}', "");
    Expect(0, 66639, '\P{Sc=dsrt}', "");
    Expect(1, 66639, '\P{^Sc=dsrt}', "");
    Expect(0, 66640, '\p{Sc=dsrt}', "");
    Expect(1, 66640, '\p{^Sc=dsrt}', "");
    Expect(1, 66640, '\P{Sc=dsrt}', "");
    Expect(0, 66640, '\P{^Sc=dsrt}', "");
    Expect(1, 66639, '\p{Sc=:\Adsrt\z:}', "");;
    Expect(0, 66640, '\p{Sc=:\Adsrt\z:}', "");;
    Expect(1, 66639, '\p{Sc= DSRT}', "");
    Expect(0, 66639, '\p{^Sc= DSRT}', "");
    Expect(0, 66639, '\P{Sc= DSRT}', "");
    Expect(1, 66639, '\P{^Sc= DSRT}', "");
    Expect(0, 66640, '\p{Sc= DSRT}', "");
    Expect(1, 66640, '\p{^Sc= DSRT}', "");
    Expect(1, 66640, '\P{Sc= DSRT}', "");
    Expect(0, 66640, '\P{^Sc= DSRT}', "");
    Error('\p{Is_Script=:=	Deseret}');
    Error('\P{Is_Script=:=	Deseret}');
    Expect(1, 66639, '\p{Is_Script=deseret}', "");
    Expect(0, 66639, '\p{^Is_Script=deseret}', "");
    Expect(0, 66639, '\P{Is_Script=deseret}', "");
    Expect(1, 66639, '\P{^Is_Script=deseret}', "");
    Expect(0, 66640, '\p{Is_Script=deseret}', "");
    Expect(1, 66640, '\p{^Is_Script=deseret}', "");
    Expect(1, 66640, '\P{Is_Script=deseret}', "");
    Expect(0, 66640, '\P{^Is_Script=deseret}', "");
    Expect(1, 66639, '\p{Is_Script=-Deseret}', "");
    Expect(0, 66639, '\p{^Is_Script=-Deseret}', "");
    Expect(0, 66639, '\P{Is_Script=-Deseret}', "");
    Expect(1, 66639, '\P{^Is_Script=-Deseret}', "");
    Expect(0, 66640, '\p{Is_Script=-Deseret}', "");
    Expect(1, 66640, '\p{^Is_Script=-Deseret}', "");
    Expect(1, 66640, '\P{Is_Script=-Deseret}', "");
    Expect(0, 66640, '\P{^Is_Script=-Deseret}', "");
    Error('\p{Is_Sc=:=Dsrt}');
    Error('\P{Is_Sc=:=Dsrt}');
    Expect(1, 66639, '\p{Is_Sc=dsrt}', "");
    Expect(0, 66639, '\p{^Is_Sc=dsrt}', "");
    Expect(0, 66639, '\P{Is_Sc=dsrt}', "");
    Expect(1, 66639, '\P{^Is_Sc=dsrt}', "");
    Expect(0, 66640, '\p{Is_Sc=dsrt}', "");
    Expect(1, 66640, '\p{^Is_Sc=dsrt}', "");
    Expect(1, 66640, '\P{Is_Sc=dsrt}', "");
    Expect(0, 66640, '\P{^Is_Sc=dsrt}', "");
    Expect(1, 66639, '\p{Is_Sc=	_Dsrt}', "");
    Expect(0, 66639, '\p{^Is_Sc=	_Dsrt}', "");
    Expect(0, 66639, '\P{Is_Sc=	_Dsrt}', "");
    Expect(1, 66639, '\P{^Is_Sc=	_Dsrt}', "");
    Expect(0, 66640, '\p{Is_Sc=	_Dsrt}', "");
    Expect(1, 66640, '\p{^Is_Sc=	_Dsrt}', "");
    Expect(1, 66640, '\P{Is_Sc=	_Dsrt}', "");
    Expect(0, 66640, '\P{^Is_Sc=	_Dsrt}', "");
    Error('\p{Script=:=DUPLOYAN}');
    Error('\P{Script=:=DUPLOYAN}');
    Expect(1, 113823, '\p{Script=:\ADuployan\z:}', "");;
    Expect(0, 113824, '\p{Script=:\ADuployan\z:}', "");;
    Expect(1, 113823, '\p{Script=duployan}', "");
    Expect(0, 113823, '\p{^Script=duployan}', "");
    Expect(0, 113823, '\P{Script=duployan}', "");
    Expect(1, 113823, '\P{^Script=duployan}', "");
    Expect(0, 113824, '\p{Script=duployan}', "");
    Expect(1, 113824, '\p{^Script=duployan}', "");
    Expect(1, 113824, '\P{Script=duployan}', "");
    Expect(0, 113824, '\P{^Script=duployan}', "");
    Expect(1, 113823, '\p{Script=:\Aduployan\z:}', "");;
    Expect(0, 113824, '\p{Script=:\Aduployan\z:}', "");;
    Expect(1, 113823, '\p{Script= _duployan}', "");
    Expect(0, 113823, '\p{^Script= _duployan}', "");
    Expect(0, 113823, '\P{Script= _duployan}', "");
    Expect(1, 113823, '\P{^Script= _duployan}', "");
    Expect(0, 113824, '\p{Script= _duployan}', "");
    Expect(1, 113824, '\p{^Script= _duployan}', "");
    Expect(1, 113824, '\P{Script= _duployan}', "");
    Expect(0, 113824, '\P{^Script= _duployan}', "");
    Error('\p{Sc=_dupl/a/}');
    Error('\P{Sc=_dupl/a/}');
    Expect(1, 113823, '\p{Sc=:\ADupl\z:}', "");;
    Expect(0, 113824, '\p{Sc=:\ADupl\z:}', "");;
    Expect(1, 113823, '\p{Sc=dupl}', "");
    Expect(0, 113823, '\p{^Sc=dupl}', "");
    Expect(0, 113823, '\P{Sc=dupl}', "");
    Expect(1, 113823, '\P{^Sc=dupl}', "");
    Expect(0, 113824, '\p{Sc=dupl}', "");
    Expect(1, 113824, '\p{^Sc=dupl}', "");
    Expect(1, 113824, '\P{Sc=dupl}', "");
    Expect(0, 113824, '\P{^Sc=dupl}', "");
    Expect(1, 113823, '\p{Sc=:\Adupl\z:}', "");;
    Expect(0, 113824, '\p{Sc=:\Adupl\z:}', "");;
    Expect(1, 113823, '\p{Sc=_Dupl}', "");
    Expect(0, 113823, '\p{^Sc=_Dupl}', "");
    Expect(0, 113823, '\P{Sc=_Dupl}', "");
    Expect(1, 113823, '\P{^Sc=_Dupl}', "");
    Expect(0, 113824, '\p{Sc=_Dupl}', "");
    Expect(1, 113824, '\p{^Sc=_Dupl}', "");
    Expect(1, 113824, '\P{Sc=_Dupl}', "");
    Expect(0, 113824, '\P{^Sc=_Dupl}', "");
    Error('\p{Is_Script=_:=DUPLOYAN}');
    Error('\P{Is_Script=_:=DUPLOYAN}');
    Expect(1, 113823, '\p{Is_Script=duployan}', "");
    Expect(0, 113823, '\p{^Is_Script=duployan}', "");
    Expect(0, 113823, '\P{Is_Script=duployan}', "");
    Expect(1, 113823, '\P{^Is_Script=duployan}', "");
    Expect(0, 113824, '\p{Is_Script=duployan}', "");
    Expect(1, 113824, '\p{^Is_Script=duployan}', "");
    Expect(1, 113824, '\P{Is_Script=duployan}', "");
    Expect(0, 113824, '\P{^Is_Script=duployan}', "");
    Expect(1, 113823, '\p{Is_Script=DUPLOYAN}', "");
    Expect(0, 113823, '\p{^Is_Script=DUPLOYAN}', "");
    Expect(0, 113823, '\P{Is_Script=DUPLOYAN}', "");
    Expect(1, 113823, '\P{^Is_Script=DUPLOYAN}', "");
    Expect(0, 113824, '\p{Is_Script=DUPLOYAN}', "");
    Expect(1, 113824, '\p{^Is_Script=DUPLOYAN}', "");
    Expect(1, 113824, '\P{Is_Script=DUPLOYAN}', "");
    Expect(0, 113824, '\P{^Is_Script=DUPLOYAN}', "");
    Error('\p{Is_Sc=	Dupl/a/}');
    Error('\P{Is_Sc=	Dupl/a/}');
    Expect(1, 113823, '\p{Is_Sc=dupl}', "");
    Expect(0, 113823, '\p{^Is_Sc=dupl}', "");
    Expect(0, 113823, '\P{Is_Sc=dupl}', "");
    Expect(1, 113823, '\P{^Is_Sc=dupl}', "");
    Expect(0, 113824, '\p{Is_Sc=dupl}', "");
    Expect(1, 113824, '\p{^Is_Sc=dupl}', "");
    Expect(1, 113824, '\P{Is_Sc=dupl}', "");
    Expect(0, 113824, '\P{^Is_Sc=dupl}', "");
    Expect(1, 113823, '\p{Is_Sc=-dupl}', "");
    Expect(0, 113823, '\p{^Is_Sc=-dupl}', "");
    Expect(0, 113823, '\P{Is_Sc=-dupl}', "");
    Expect(1, 113823, '\P{^Is_Sc=-dupl}', "");
    Expect(0, 113824, '\p{Is_Sc=-dupl}', "");
    Expect(1, 113824, '\p{^Is_Sc=-dupl}', "");
    Expect(1, 113824, '\P{Is_Sc=-dupl}', "");
    Expect(0, 113824, '\P{^Is_Sc=-dupl}', "");
    Error('\p{Script= _Egyptian_Hieroglyphs/a/}');
    Error('\P{Script= _Egyptian_Hieroglyphs/a/}');
    Expect(1, 78904, '\p{Script=:\AEgyptian_Hieroglyphs\z:}', "");;
    Expect(0, 78905, '\p{Script=:\AEgyptian_Hieroglyphs\z:}', "");;
    Expect(1, 78904, '\p{Script=egyptianhieroglyphs}', "");
    Expect(0, 78904, '\p{^Script=egyptianhieroglyphs}', "");
    Expect(0, 78904, '\P{Script=egyptianhieroglyphs}', "");
    Expect(1, 78904, '\P{^Script=egyptianhieroglyphs}', "");
    Expect(0, 78905, '\p{Script=egyptianhieroglyphs}', "");
    Expect(1, 78905, '\p{^Script=egyptianhieroglyphs}', "");
    Expect(1, 78905, '\P{Script=egyptianhieroglyphs}', "");
    Expect(0, 78905, '\P{^Script=egyptianhieroglyphs}', "");
    Expect(1, 78904, '\p{Script=:\Aegyptianhieroglyphs\z:}', "");;
    Expect(0, 78905, '\p{Script=:\Aegyptianhieroglyphs\z:}', "");;
    Expect(1, 78904, '\p{Script= -egyptian_hieroglyphs}', "");
    Expect(0, 78904, '\p{^Script= -egyptian_hieroglyphs}', "");
    Expect(0, 78904, '\P{Script= -egyptian_hieroglyphs}', "");
    Expect(1, 78904, '\P{^Script= -egyptian_hieroglyphs}', "");
    Expect(0, 78905, '\p{Script= -egyptian_hieroglyphs}', "");
    Expect(1, 78905, '\p{^Script= -egyptian_hieroglyphs}', "");
    Expect(1, 78905, '\P{Script= -egyptian_hieroglyphs}', "");
    Expect(0, 78905, '\P{^Script= -egyptian_hieroglyphs}', "");
    Error('\p{Sc=_egyp/a/}');
    Error('\P{Sc=_egyp/a/}');
    Expect(1, 78904, '\p{Sc=:\AEgyp\z:}', "");;
    Expect(0, 78905, '\p{Sc=:\AEgyp\z:}', "");;
    Expect(1, 78904, '\p{Sc=egyp}', "");
    Expect(0, 78904, '\p{^Sc=egyp}', "");
    Expect(0, 78904, '\P{Sc=egyp}', "");
    Expect(1, 78904, '\P{^Sc=egyp}', "");
    Expect(0, 78905, '\p{Sc=egyp}', "");
    Expect(1, 78905, '\p{^Sc=egyp}', "");
    Expect(1, 78905, '\P{Sc=egyp}', "");
    Expect(0, 78905, '\P{^Sc=egyp}', "");
    Expect(1, 78904, '\p{Sc=:\Aegyp\z:}', "");;
    Expect(0, 78905, '\p{Sc=:\Aegyp\z:}', "");;
    Expect(1, 78904, '\p{Sc=Egyp}', "");
    Expect(0, 78904, '\p{^Sc=Egyp}', "");
    Expect(0, 78904, '\P{Sc=Egyp}', "");
    Expect(1, 78904, '\P{^Sc=Egyp}', "");
    Expect(0, 78905, '\p{Sc=Egyp}', "");
    Expect(1, 78905, '\p{^Sc=Egyp}', "");
    Expect(1, 78905, '\P{Sc=Egyp}', "");
    Expect(0, 78905, '\P{^Sc=Egyp}', "");
    Error('\p{Is_Script=/a/_	Egyptian_HIEROGLYPHS}');
    Error('\P{Is_Script=/a/_	Egyptian_HIEROGLYPHS}');
    Expect(1, 78904, '\p{Is_Script=egyptianhieroglyphs}', "");
    Expect(0, 78904, '\p{^Is_Script=egyptianhieroglyphs}', "");
    Expect(0, 78904, '\P{Is_Script=egyptianhieroglyphs}', "");
    Expect(1, 78904, '\P{^Is_Script=egyptianhieroglyphs}', "");
    Expect(0, 78905, '\p{Is_Script=egyptianhieroglyphs}', "");
    Expect(1, 78905, '\p{^Is_Script=egyptianhieroglyphs}', "");
    Expect(1, 78905, '\P{Is_Script=egyptianhieroglyphs}', "");
    Expect(0, 78905, '\P{^Is_Script=egyptianhieroglyphs}', "");
    Expect(1, 78904, '\p{Is_Script=  EGYPTIAN_Hieroglyphs}', "");
    Expect(0, 78904, '\p{^Is_Script=  EGYPTIAN_Hieroglyphs}', "");
    Expect(0, 78904, '\P{Is_Script=  EGYPTIAN_Hieroglyphs}', "");
    Expect(1, 78904, '\P{^Is_Script=  EGYPTIAN_Hieroglyphs}', "");
    Expect(0, 78905, '\p{Is_Script=  EGYPTIAN_Hieroglyphs}', "");
    Expect(1, 78905, '\p{^Is_Script=  EGYPTIAN_Hieroglyphs}', "");
    Expect(1, 78905, '\P{Is_Script=  EGYPTIAN_Hieroglyphs}', "");
    Expect(0, 78905, '\P{^Is_Script=  EGYPTIAN_Hieroglyphs}', "");
    Error('\p{Is_Sc= :=egyp}');
    Error('\P{Is_Sc= :=egyp}');
    Expect(1, 78904, '\p{Is_Sc=egyp}', "");
    Expect(0, 78904, '\p{^Is_Sc=egyp}', "");
    Expect(0, 78904, '\P{Is_Sc=egyp}', "");
    Expect(1, 78904, '\P{^Is_Sc=egyp}', "");
    Expect(0, 78905, '\p{Is_Sc=egyp}', "");
    Expect(1, 78905, '\p{^Is_Sc=egyp}', "");
    Expect(1, 78905, '\P{Is_Sc=egyp}', "");
    Expect(0, 78905, '\P{^Is_Sc=egyp}', "");
    Expect(1, 78904, '\p{Is_Sc=_-Egyp}', "");
    Expect(0, 78904, '\p{^Is_Sc=_-Egyp}', "");
    Expect(0, 78904, '\P{Is_Sc=_-Egyp}', "");
    Expect(1, 78904, '\P{^Is_Sc=_-Egyp}', "");
    Expect(0, 78905, '\p{Is_Sc=_-Egyp}', "");
    Expect(1, 78905, '\p{^Is_Sc=_-Egyp}', "");
    Expect(1, 78905, '\P{Is_Sc=_-Egyp}', "");
    Expect(0, 78905, '\P{^Is_Sc=_-Egyp}', "");
    Error('\p{Script=-:=elbasan}');
    Error('\P{Script=-:=elbasan}');
    Expect(1, 66855, '\p{Script=:\AElbasan\z:}', "");;
    Expect(0, 66856, '\p{Script=:\AElbasan\z:}', "");;
    Expect(1, 66855, '\p{Script=elbasan}', "");
    Expect(0, 66855, '\p{^Script=elbasan}', "");
    Expect(0, 66855, '\P{Script=elbasan}', "");
    Expect(1, 66855, '\P{^Script=elbasan}', "");
    Expect(0, 66856, '\p{Script=elbasan}', "");
    Expect(1, 66856, '\p{^Script=elbasan}', "");
    Expect(1, 66856, '\P{Script=elbasan}', "");
    Expect(0, 66856, '\P{^Script=elbasan}', "");
    Expect(1, 66855, '\p{Script=:\Aelbasan\z:}', "");;
    Expect(0, 66856, '\p{Script=:\Aelbasan\z:}', "");;
    Expect(1, 66855, '\p{Script: 	ELBASAN}', "");
    Expect(0, 66855, '\p{^Script: 	ELBASAN}', "");
    Expect(0, 66855, '\P{Script: 	ELBASAN}', "");
    Expect(1, 66855, '\P{^Script: 	ELBASAN}', "");
    Expect(0, 66856, '\p{Script: 	ELBASAN}', "");
    Expect(1, 66856, '\p{^Script: 	ELBASAN}', "");
    Expect(1, 66856, '\P{Script: 	ELBASAN}', "");
    Expect(0, 66856, '\P{^Script: 	ELBASAN}', "");
    Error('\p{Sc=/a/_ Elba}');
    Error('\P{Sc=/a/_ Elba}');
    Expect(1, 66855, '\p{Sc=:\AElba\z:}', "");;
    Expect(0, 66856, '\p{Sc=:\AElba\z:}', "");;
    Expect(1, 66855, '\p{Sc=elba}', "");
    Expect(0, 66855, '\p{^Sc=elba}', "");
    Expect(0, 66855, '\P{Sc=elba}', "");
    Expect(1, 66855, '\P{^Sc=elba}', "");
    Expect(0, 66856, '\p{Sc=elba}', "");
    Expect(1, 66856, '\p{^Sc=elba}', "");
    Expect(1, 66856, '\P{Sc=elba}', "");
    Expect(0, 66856, '\P{^Sc=elba}', "");
    Expect(1, 66855, '\p{Sc=:\Aelba\z:}', "");;
    Expect(0, 66856, '\p{Sc=:\Aelba\z:}', "");;
    Expect(1, 66855, '\p{Sc=_Elba}', "");
    Expect(0, 66855, '\p{^Sc=_Elba}', "");
    Expect(0, 66855, '\P{Sc=_Elba}', "");
    Expect(1, 66855, '\P{^Sc=_Elba}', "");
    Expect(0, 66856, '\p{Sc=_Elba}', "");
    Expect(1, 66856, '\p{^Sc=_Elba}', "");
    Expect(1, 66856, '\P{Sc=_Elba}', "");
    Expect(0, 66856, '\P{^Sc=_Elba}', "");
    Error('\p{Is_Script=-:=Elbasan}');
    Error('\P{Is_Script=-:=Elbasan}');
    Expect(1, 66855, '\p{Is_Script=elbasan}', "");
    Expect(0, 66855, '\p{^Is_Script=elbasan}', "");
    Expect(0, 66855, '\P{Is_Script=elbasan}', "");
    Expect(1, 66855, '\P{^Is_Script=elbasan}', "");
    Expect(0, 66856, '\p{Is_Script=elbasan}', "");
    Expect(1, 66856, '\p{^Is_Script=elbasan}', "");
    Expect(1, 66856, '\P{Is_Script=elbasan}', "");
    Expect(0, 66856, '\P{^Is_Script=elbasan}', "");
    Expect(1, 66855, '\p{Is_Script:_ ELBASAN}', "");
    Expect(0, 66855, '\p{^Is_Script:_ ELBASAN}', "");
    Expect(0, 66855, '\P{Is_Script:_ ELBASAN}', "");
    Expect(1, 66855, '\P{^Is_Script:_ ELBASAN}', "");
    Expect(0, 66856, '\p{Is_Script:_ ELBASAN}', "");
    Expect(1, 66856, '\p{^Is_Script:_ ELBASAN}', "");
    Expect(1, 66856, '\P{Is_Script:_ ELBASAN}', "");
    Expect(0, 66856, '\P{^Is_Script:_ ELBASAN}', "");
    Error('\p{Is_Sc=-_Elba/a/}');
    Error('\P{Is_Sc=-_Elba/a/}');
    Expect(1, 66855, '\p{Is_Sc:elba}', "");
    Expect(0, 66855, '\p{^Is_Sc:elba}', "");
    Expect(0, 66855, '\P{Is_Sc:elba}', "");
    Expect(1, 66855, '\P{^Is_Sc:elba}', "");
    Expect(0, 66856, '\p{Is_Sc:elba}', "");
    Expect(1, 66856, '\p{^Is_Sc:elba}', "");
    Expect(1, 66856, '\P{Is_Sc:elba}', "");
    Expect(0, 66856, '\P{^Is_Sc:elba}', "");
    Expect(1, 66855, '\p{Is_Sc= Elba}', "");
    Expect(0, 66855, '\p{^Is_Sc= Elba}', "");
    Expect(0, 66855, '\P{Is_Sc= Elba}', "");
    Expect(1, 66855, '\P{^Is_Sc= Elba}', "");
    Expect(0, 66856, '\p{Is_Sc= Elba}', "");
    Expect(1, 66856, '\p{^Is_Sc= Elba}', "");
    Expect(1, 66856, '\P{Is_Sc= Elba}', "");
    Expect(0, 66856, '\P{^Is_Sc= Elba}', "");
    Error('\p{Script=	_ELYMAIC/a/}');
    Error('\P{Script=	_ELYMAIC/a/}');
    Expect(1, 69622, '\p{Script=:\AElymaic\z:}', "");;
    Expect(0, 69623, '\p{Script=:\AElymaic\z:}', "");;
    Expect(1, 69622, '\p{Script=elymaic}', "");
    Expect(0, 69622, '\p{^Script=elymaic}', "");
    Expect(0, 69622, '\P{Script=elymaic}', "");
    Expect(1, 69622, '\P{^Script=elymaic}', "");
    Expect(0, 69623, '\p{Script=elymaic}', "");
    Expect(1, 69623, '\p{^Script=elymaic}', "");
    Expect(1, 69623, '\P{Script=elymaic}', "");
    Expect(0, 69623, '\P{^Script=elymaic}', "");
    Expect(1, 69622, '\p{Script=:\Aelymaic\z:}', "");;
    Expect(0, 69623, '\p{Script=:\Aelymaic\z:}', "");;
    Expect(1, 69622, '\p{Script=	_Elymaic}', "");
    Expect(0, 69622, '\p{^Script=	_Elymaic}', "");
    Expect(0, 69622, '\P{Script=	_Elymaic}', "");
    Expect(1, 69622, '\P{^Script=	_Elymaic}', "");
    Expect(0, 69623, '\p{Script=	_Elymaic}', "");
    Expect(1, 69623, '\p{^Script=	_Elymaic}', "");
    Expect(1, 69623, '\P{Script=	_Elymaic}', "");
    Expect(0, 69623, '\P{^Script=	_Elymaic}', "");
    Error('\p{Sc::=_elym}');
    Error('\P{Sc::=_elym}');
    Expect(1, 69622, '\p{Sc=:\AElym\z:}', "");;
    Expect(0, 69623, '\p{Sc=:\AElym\z:}', "");;
    Expect(1, 69622, '\p{Sc=elym}', "");
    Expect(0, 69622, '\p{^Sc=elym}', "");
    Expect(0, 69622, '\P{Sc=elym}', "");
    Expect(1, 69622, '\P{^Sc=elym}', "");
    Expect(0, 69623, '\p{Sc=elym}', "");
    Expect(1, 69623, '\p{^Sc=elym}', "");
    Expect(1, 69623, '\P{Sc=elym}', "");
    Expect(0, 69623, '\P{^Sc=elym}', "");
    Expect(1, 69622, '\p{Sc=:\Aelym\z:}', "");;
    Expect(0, 69623, '\p{Sc=:\Aelym\z:}', "");;
    Expect(1, 69622, '\p{Sc: 	 elym}', "");
    Expect(0, 69622, '\p{^Sc: 	 elym}', "");
    Expect(0, 69622, '\P{Sc: 	 elym}', "");
    Expect(1, 69622, '\P{^Sc: 	 elym}', "");
    Expect(0, 69623, '\p{Sc: 	 elym}', "");
    Expect(1, 69623, '\p{^Sc: 	 elym}', "");
    Expect(1, 69623, '\P{Sc: 	 elym}', "");
    Expect(0, 69623, '\P{^Sc: 	 elym}', "");
    Error('\p{Is_Script=__ELYMAIC/a/}');
    Error('\P{Is_Script=__ELYMAIC/a/}');
    Expect(1, 69622, '\p{Is_Script=elymaic}', "");
    Expect(0, 69622, '\p{^Is_Script=elymaic}', "");
    Expect(0, 69622, '\P{Is_Script=elymaic}', "");
    Expect(1, 69622, '\P{^Is_Script=elymaic}', "");
    Expect(0, 69623, '\p{Is_Script=elymaic}', "");
    Expect(1, 69623, '\p{^Is_Script=elymaic}', "");
    Expect(1, 69623, '\P{Is_Script=elymaic}', "");
    Expect(0, 69623, '\P{^Is_Script=elymaic}', "");
    Expect(1, 69622, '\p{Is_Script= ELYMAIC}', "");
    Expect(0, 69622, '\p{^Is_Script= ELYMAIC}', "");
    Expect(0, 69622, '\P{Is_Script= ELYMAIC}', "");
    Expect(1, 69622, '\P{^Is_Script= ELYMAIC}', "");
    Expect(0, 69623, '\p{Is_Script= ELYMAIC}', "");
    Expect(1, 69623, '\p{^Is_Script= ELYMAIC}', "");
    Expect(1, 69623, '\P{Is_Script= ELYMAIC}', "");
    Expect(0, 69623, '\P{^Is_Script= ELYMAIC}', "");
    Error('\p{Is_Sc=-:=Elym}');
    Error('\P{Is_Sc=-:=Elym}');
    Expect(1, 69622, '\p{Is_Sc=elym}', "");
    Expect(0, 69622, '\p{^Is_Sc=elym}', "");
    Expect(0, 69622, '\P{Is_Sc=elym}', "");
    Expect(1, 69622, '\P{^Is_Sc=elym}', "");
    Expect(0, 69623, '\p{Is_Sc=elym}', "");
    Expect(1, 69623, '\p{^Is_Sc=elym}', "");
    Expect(1, 69623, '\P{Is_Sc=elym}', "");
    Expect(0, 69623, '\P{^Is_Sc=elym}', "");
    Expect(1, 69622, '\p{Is_Sc=-elym}', "");
    Expect(0, 69622, '\p{^Is_Sc=-elym}', "");
    Expect(0, 69622, '\P{Is_Sc=-elym}', "");
    Expect(1, 69622, '\P{^Is_Sc=-elym}', "");
    Expect(0, 69623, '\p{Is_Sc=-elym}', "");
    Expect(1, 69623, '\p{^Is_Sc=-elym}', "");
    Expect(1, 69623, '\P{Is_Sc=-elym}', "");
    Expect(0, 69623, '\P{^Is_Sc=-elym}', "");
    Error('\p{Script=_:=Ethiopic}');
    Error('\P{Script=_:=Ethiopic}');
    Expect(1, 43822, '\p{Script=:\AEthiopic\z:}', "");;
    Expect(0, 43823, '\p{Script=:\AEthiopic\z:}', "");;
    Expect(1, 43822, '\p{Script=ethiopic}', "");
    Expect(0, 43822, '\p{^Script=ethiopic}', "");
    Expect(0, 43822, '\P{Script=ethiopic}', "");
    Expect(1, 43822, '\P{^Script=ethiopic}', "");
    Expect(0, 43823, '\p{Script=ethiopic}', "");
    Expect(1, 43823, '\p{^Script=ethiopic}', "");
    Expect(1, 43823, '\P{Script=ethiopic}', "");
    Expect(0, 43823, '\P{^Script=ethiopic}', "");
    Expect(1, 43822, '\p{Script=:\Aethiopic\z:}', "");;
    Expect(0, 43823, '\p{Script=:\Aethiopic\z:}', "");;
    Expect(1, 43822, '\p{Script=	-ethiopic}', "");
    Expect(0, 43822, '\p{^Script=	-ethiopic}', "");
    Expect(0, 43822, '\P{Script=	-ethiopic}', "");
    Expect(1, 43822, '\P{^Script=	-ethiopic}', "");
    Expect(0, 43823, '\p{Script=	-ethiopic}', "");
    Expect(1, 43823, '\p{^Script=	-ethiopic}', "");
    Expect(1, 43823, '\P{Script=	-ethiopic}', "");
    Expect(0, 43823, '\P{^Script=	-ethiopic}', "");
    Error('\p{Sc=-ETHI:=}');
    Error('\P{Sc=-ETHI:=}');
    Expect(1, 43822, '\p{Sc=:\AEthi\z:}', "");;
    Expect(0, 43823, '\p{Sc=:\AEthi\z:}', "");;
    Expect(1, 43822, '\p{Sc=ethi}', "");
    Expect(0, 43822, '\p{^Sc=ethi}', "");
    Expect(0, 43822, '\P{Sc=ethi}', "");
    Expect(1, 43822, '\P{^Sc=ethi}', "");
    Expect(0, 43823, '\p{Sc=ethi}', "");
    Expect(1, 43823, '\p{^Sc=ethi}', "");
    Expect(1, 43823, '\P{Sc=ethi}', "");
    Expect(0, 43823, '\P{^Sc=ethi}', "");
    Expect(1, 43822, '\p{Sc=:\Aethi\z:}', "");;
    Expect(0, 43823, '\p{Sc=:\Aethi\z:}', "");;
    Expect(1, 43822, '\p{Sc=		ETHI}', "");
    Expect(0, 43822, '\p{^Sc=		ETHI}', "");
    Expect(0, 43822, '\P{Sc=		ETHI}', "");
    Expect(1, 43822, '\P{^Sc=		ETHI}', "");
    Expect(0, 43823, '\p{Sc=		ETHI}', "");
    Expect(1, 43823, '\p{^Sc=		ETHI}', "");
    Expect(1, 43823, '\P{Sc=		ETHI}', "");
    Expect(0, 43823, '\P{^Sc=		ETHI}', "");
    Error('\p{Is_Script=/a/	ethiopic}');
    Error('\P{Is_Script=/a/	ethiopic}');
    Expect(1, 43822, '\p{Is_Script=ethiopic}', "");
    Expect(0, 43822, '\p{^Is_Script=ethiopic}', "");
    Expect(0, 43822, '\P{Is_Script=ethiopic}', "");
    Expect(1, 43822, '\P{^Is_Script=ethiopic}', "");
    Expect(0, 43823, '\p{Is_Script=ethiopic}', "");
    Expect(1, 43823, '\p{^Is_Script=ethiopic}', "");
    Expect(1, 43823, '\P{Is_Script=ethiopic}', "");
    Expect(0, 43823, '\P{^Is_Script=ethiopic}', "");
    Expect(1, 43822, '\p{Is_Script=	ethiopic}', "");
    Expect(0, 43822, '\p{^Is_Script=	ethiopic}', "");
    Expect(0, 43822, '\P{Is_Script=	ethiopic}', "");
    Expect(1, 43822, '\P{^Is_Script=	ethiopic}', "");
    Expect(0, 43823, '\p{Is_Script=	ethiopic}', "");
    Expect(1, 43823, '\p{^Is_Script=	ethiopic}', "");
    Expect(1, 43823, '\P{Is_Script=	ethiopic}', "");
    Expect(0, 43823, '\P{^Is_Script=	ethiopic}', "");
    Error('\p{Is_Sc=/a/  ethi}');
    Error('\P{Is_Sc=/a/  ethi}');
    Expect(1, 43822, '\p{Is_Sc=ethi}', "");
    Expect(0, 43822, '\p{^Is_Sc=ethi}', "");
    Expect(0, 43822, '\P{Is_Sc=ethi}', "");
    Expect(1, 43822, '\P{^Is_Sc=ethi}', "");
    Expect(0, 43823, '\p{Is_Sc=ethi}', "");
    Expect(1, 43823, '\p{^Is_Sc=ethi}', "");
    Expect(1, 43823, '\P{Is_Sc=ethi}', "");
    Expect(0, 43823, '\P{^Is_Sc=ethi}', "");
    Expect(1, 43822, '\p{Is_Sc=_Ethi}', "");
    Expect(0, 43822, '\p{^Is_Sc=_Ethi}', "");
    Expect(0, 43822, '\P{Is_Sc=_Ethi}', "");
    Expect(1, 43822, '\P{^Is_Sc=_Ethi}', "");
    Expect(0, 43823, '\p{Is_Sc=_Ethi}', "");
    Expect(1, 43823, '\p{^Is_Sc=_Ethi}', "");
    Expect(1, 43823, '\P{Is_Sc=_Ethi}', "");
    Expect(0, 43823, '\P{^Is_Sc=_Ethi}', "");
    Error('\p{Script=/a/_-GEORGIAN}');
    Error('\P{Script=/a/_-GEORGIAN}');
    Expect(1, 11565, '\p{Script=:\AGeorgian\z:}', "");;
    Expect(0, 11566, '\p{Script=:\AGeorgian\z:}', "");;
    Expect(1, 11565, '\p{Script=georgian}', "");
    Expect(0, 11565, '\p{^Script=georgian}', "");
    Expect(0, 11565, '\P{Script=georgian}', "");
    Expect(1, 11565, '\P{^Script=georgian}', "");
    Expect(0, 11566, '\p{Script=georgian}', "");
    Expect(1, 11566, '\p{^Script=georgian}', "");
    Expect(1, 11566, '\P{Script=georgian}', "");
    Expect(0, 11566, '\P{^Script=georgian}', "");
    Expect(1, 11565, '\p{Script=:\Ageorgian\z:}', "");;
    Expect(0, 11566, '\p{Script=:\Ageorgian\z:}', "");;
    Expect(1, 11565, '\p{Script=-GEORGIAN}', "");
    Expect(0, 11565, '\p{^Script=-GEORGIAN}', "");
    Expect(0, 11565, '\P{Script=-GEORGIAN}', "");
    Expect(1, 11565, '\P{^Script=-GEORGIAN}', "");
    Expect(0, 11566, '\p{Script=-GEORGIAN}', "");
    Expect(1, 11566, '\p{^Script=-GEORGIAN}', "");
    Expect(1, 11566, '\P{Script=-GEORGIAN}', "");
    Expect(0, 11566, '\P{^Script=-GEORGIAN}', "");
    Error('\p{Sc= -Geor:=}');
    Error('\P{Sc= -Geor:=}');
    Expect(1, 11565, '\p{Sc=:\AGeor\z:}', "");;
    Expect(0, 11566, '\p{Sc=:\AGeor\z:}', "");;
    Expect(1, 11565, '\p{Sc=geor}', "");
    Expect(0, 11565, '\p{^Sc=geor}', "");
    Expect(0, 11565, '\P{Sc=geor}', "");
    Expect(1, 11565, '\P{^Sc=geor}', "");
    Expect(0, 11566, '\p{Sc=geor}', "");
    Expect(1, 11566, '\p{^Sc=geor}', "");
    Expect(1, 11566, '\P{Sc=geor}', "");
    Expect(0, 11566, '\P{^Sc=geor}', "");
    Expect(1, 11565, '\p{Sc=:\Ageor\z:}', "");;
    Expect(0, 11566, '\p{Sc=:\Ageor\z:}', "");;
    Expect(1, 11565, '\p{Sc=-_Geor}', "");
    Expect(0, 11565, '\p{^Sc=-_Geor}', "");
    Expect(0, 11565, '\P{Sc=-_Geor}', "");
    Expect(1, 11565, '\P{^Sc=-_Geor}', "");
    Expect(0, 11566, '\p{Sc=-_Geor}', "");
    Expect(1, 11566, '\p{^Sc=-_Geor}', "");
    Expect(1, 11566, '\P{Sc=-_Geor}', "");
    Expect(0, 11566, '\P{^Sc=-_Geor}', "");
    Error('\p{Is_Script=:=  Georgian}');
    Error('\P{Is_Script=:=  Georgian}');
    Expect(1, 11565, '\p{Is_Script:	georgian}', "");
    Expect(0, 11565, '\p{^Is_Script:	georgian}', "");
    Expect(0, 11565, '\P{Is_Script:	georgian}', "");
    Expect(1, 11565, '\P{^Is_Script:	georgian}', "");
    Expect(0, 11566, '\p{Is_Script:	georgian}', "");
    Expect(1, 11566, '\p{^Is_Script:	georgian}', "");
    Expect(1, 11566, '\P{Is_Script:	georgian}', "");
    Expect(0, 11566, '\P{^Is_Script:	georgian}', "");
    Expect(1, 11565, '\p{Is_Script= georgian}', "");
    Expect(0, 11565, '\p{^Is_Script= georgian}', "");
    Expect(0, 11565, '\P{Is_Script= georgian}', "");
    Expect(1, 11565, '\P{^Is_Script= georgian}', "");
    Expect(0, 11566, '\p{Is_Script= georgian}', "");
    Expect(1, 11566, '\p{^Is_Script= georgian}', "");
    Expect(1, 11566, '\P{Is_Script= georgian}', "");
    Expect(0, 11566, '\P{^Is_Script= georgian}', "");
    Error('\p{Is_Sc=:= _Geor}');
    Error('\P{Is_Sc=:= _Geor}');
    Expect(1, 11565, '\p{Is_Sc=geor}', "");
    Expect(0, 11565, '\p{^Is_Sc=geor}', "");
    Expect(0, 11565, '\P{Is_Sc=geor}', "");
    Expect(1, 11565, '\P{^Is_Sc=geor}', "");
    Expect(0, 11566, '\p{Is_Sc=geor}', "");
    Expect(1, 11566, '\p{^Is_Sc=geor}', "");
    Expect(1, 11566, '\P{Is_Sc=geor}', "");
    Expect(0, 11566, '\P{^Is_Sc=geor}', "");
    Expect(1, 11565, '\p{Is_Sc=	_Geor}', "");
    Expect(0, 11565, '\p{^Is_Sc=	_Geor}', "");
    Expect(0, 11565, '\P{Is_Sc=	_Geor}', "");
    Expect(1, 11565, '\P{^Is_Sc=	_Geor}', "");
    Expect(0, 11566, '\p{Is_Sc=	_Geor}', "");
    Expect(1, 11566, '\p{^Is_Sc=	_Geor}', "");
    Expect(1, 11566, '\P{Is_Sc=	_Geor}', "");
    Expect(0, 11566, '\P{^Is_Sc=	_Geor}', "");
    Error('\p{Script=/a/_-GLAGOLITIC}');
    Error('\P{Script=/a/_-GLAGOLITIC}');
    Expect(1, 122922, '\p{Script=:\AGlagolitic\z:}', "");;
    Expect(0, 122923, '\p{Script=:\AGlagolitic\z:}', "");;
    Expect(1, 122922, '\p{Script=glagolitic}', "");
    Expect(0, 122922, '\p{^Script=glagolitic}', "");
    Expect(0, 122922, '\P{Script=glagolitic}', "");
    Expect(1, 122922, '\P{^Script=glagolitic}', "");
    Expect(0, 122923, '\p{Script=glagolitic}', "");
    Expect(1, 122923, '\p{^Script=glagolitic}', "");
    Expect(1, 122923, '\P{Script=glagolitic}', "");
    Expect(0, 122923, '\P{^Script=glagolitic}', "");
    Expect(1, 122922, '\p{Script=:\Aglagolitic\z:}', "");;
    Expect(0, 122923, '\p{Script=:\Aglagolitic\z:}', "");;
    Expect(1, 122922, '\p{Script=- Glagolitic}', "");
    Expect(0, 122922, '\p{^Script=- Glagolitic}', "");
    Expect(0, 122922, '\P{Script=- Glagolitic}', "");
    Expect(1, 122922, '\P{^Script=- Glagolitic}', "");
    Expect(0, 122923, '\p{Script=- Glagolitic}', "");
    Expect(1, 122923, '\p{^Script=- Glagolitic}', "");
    Expect(1, 122923, '\P{Script=- Glagolitic}', "");
    Expect(0, 122923, '\P{^Script=- Glagolitic}', "");
    Error('\p{Sc= /a/GLAG}');
    Error('\P{Sc= /a/GLAG}');
    Expect(1, 122922, '\p{Sc=:\AGlag\z:}', "");;
    Expect(0, 122923, '\p{Sc=:\AGlag\z:}', "");;
    Expect(1, 122922, '\p{Sc=glag}', "");
    Expect(0, 122922, '\p{^Sc=glag}', "");
    Expect(0, 122922, '\P{Sc=glag}', "");
    Expect(1, 122922, '\P{^Sc=glag}', "");
    Expect(0, 122923, '\p{Sc=glag}', "");
    Expect(1, 122923, '\p{^Sc=glag}', "");
    Expect(1, 122923, '\P{Sc=glag}', "");
    Expect(0, 122923, '\P{^Sc=glag}', "");
    Expect(1, 122922, '\p{Sc=:\Aglag\z:}', "");;
    Expect(0, 122923, '\p{Sc=:\Aglag\z:}', "");;
    Expect(1, 122922, '\p{Sc=	glag}', "");
    Expect(0, 122922, '\p{^Sc=	glag}', "");
    Expect(0, 122922, '\P{Sc=	glag}', "");
    Expect(1, 122922, '\P{^Sc=	glag}', "");
    Expect(0, 122923, '\p{Sc=	glag}', "");
    Expect(1, 122923, '\p{^Sc=	glag}', "");
    Expect(1, 122923, '\P{Sc=	glag}', "");
    Expect(0, 122923, '\P{^Sc=	glag}', "");
    Error('\p{Is_Script=/a/ -GLAGOLITIC}');
    Error('\P{Is_Script=/a/ -GLAGOLITIC}');
    Expect(1, 122922, '\p{Is_Script=glagolitic}', "");
    Expect(0, 122922, '\p{^Is_Script=glagolitic}', "");
    Expect(0, 122922, '\P{Is_Script=glagolitic}', "");
    Expect(1, 122922, '\P{^Is_Script=glagolitic}', "");
    Expect(0, 122923, '\p{Is_Script=glagolitic}', "");
    Expect(1, 122923, '\p{^Is_Script=glagolitic}', "");
    Expect(1, 122923, '\P{Is_Script=glagolitic}', "");
    Expect(0, 122923, '\P{^Is_Script=glagolitic}', "");
    Expect(1, 122922, '\p{Is_Script=_-Glagolitic}', "");
    Expect(0, 122922, '\p{^Is_Script=_-Glagolitic}', "");
    Expect(0, 122922, '\P{Is_Script=_-Glagolitic}', "");
    Expect(1, 122922, '\P{^Is_Script=_-Glagolitic}', "");
    Expect(0, 122923, '\p{Is_Script=_-Glagolitic}', "");
    Expect(1, 122923, '\p{^Is_Script=_-Glagolitic}', "");
    Expect(1, 122923, '\P{Is_Script=_-Glagolitic}', "");
    Expect(0, 122923, '\P{^Is_Script=_-Glagolitic}', "");
    Error('\p{Is_Sc:   /a/	Glag}');
    Error('\P{Is_Sc:   /a/	Glag}');
    Expect(1, 122922, '\p{Is_Sc=glag}', "");
    Expect(0, 122922, '\p{^Is_Sc=glag}', "");
    Expect(0, 122922, '\P{Is_Sc=glag}', "");
    Expect(1, 122922, '\P{^Is_Sc=glag}', "");
    Expect(0, 122923, '\p{Is_Sc=glag}', "");
    Expect(1, 122923, '\p{^Is_Sc=glag}', "");
    Expect(1, 122923, '\P{Is_Sc=glag}', "");
    Expect(0, 122923, '\P{^Is_Sc=glag}', "");
    Expect(1, 122922, '\p{Is_Sc=Glag}', "");
    Expect(0, 122922, '\p{^Is_Sc=Glag}', "");
    Expect(0, 122922, '\P{Is_Sc=Glag}', "");
    Expect(1, 122922, '\P{^Is_Sc=Glag}', "");
    Expect(0, 122923, '\p{Is_Sc=Glag}', "");
    Expect(1, 122923, '\p{^Is_Sc=Glag}', "");
    Expect(1, 122923, '\P{Is_Sc=Glag}', "");
    Expect(0, 122923, '\P{^Is_Sc=Glag}', "");
    Error('\p{Script:	-:=GUNJALA_Gondi}');
    Error('\P{Script:	-:=GUNJALA_Gondi}');
    Expect(1, 73129, '\p{Script=:\AGunjala_Gondi\z:}', "");;
    Expect(0, 73130, '\p{Script=:\AGunjala_Gondi\z:}', "");;
    Expect(1, 73129, '\p{Script=gunjalagondi}', "");
    Expect(0, 73129, '\p{^Script=gunjalagondi}', "");
    Expect(0, 73129, '\P{Script=gunjalagondi}', "");
    Expect(1, 73129, '\P{^Script=gunjalagondi}', "");
    Expect(0, 73130, '\p{Script=gunjalagondi}', "");
    Expect(1, 73130, '\p{^Script=gunjalagondi}', "");
    Expect(1, 73130, '\P{Script=gunjalagondi}', "");
    Expect(0, 73130, '\P{^Script=gunjalagondi}', "");
    Expect(1, 73129, '\p{Script=:\Agunjalagondi\z:}', "");;
    Expect(0, 73130, '\p{Script=:\Agunjalagondi\z:}', "");;
    Expect(1, 73129, '\p{Script:   --Gunjala_gondi}', "");
    Expect(0, 73129, '\p{^Script:   --Gunjala_gondi}', "");
    Expect(0, 73129, '\P{Script:   --Gunjala_gondi}', "");
    Expect(1, 73129, '\P{^Script:   --Gunjala_gondi}', "");
    Expect(0, 73130, '\p{Script:   --Gunjala_gondi}', "");
    Expect(1, 73130, '\p{^Script:   --Gunjala_gondi}', "");
    Expect(1, 73130, '\P{Script:   --Gunjala_gondi}', "");
    Expect(0, 73130, '\P{^Script:   --Gunjala_gondi}', "");
    Error('\p{Sc= :=GONG}');
    Error('\P{Sc= :=GONG}');
    Expect(1, 73129, '\p{Sc=:\AGong\z:}', "");;
    Expect(0, 73130, '\p{Sc=:\AGong\z:}', "");;
    Expect(1, 73129, '\p{Sc=gong}', "");
    Expect(0, 73129, '\p{^Sc=gong}', "");
    Expect(0, 73129, '\P{Sc=gong}', "");
    Expect(1, 73129, '\P{^Sc=gong}', "");
    Expect(0, 73130, '\p{Sc=gong}', "");
    Expect(1, 73130, '\p{^Sc=gong}', "");
    Expect(1, 73130, '\P{Sc=gong}', "");
    Expect(0, 73130, '\P{^Sc=gong}', "");
    Expect(1, 73129, '\p{Sc=:\Agong\z:}', "");;
    Expect(0, 73130, '\p{Sc=:\Agong\z:}', "");;
    Expect(1, 73129, '\p{Sc=_Gong}', "");
    Expect(0, 73129, '\p{^Sc=_Gong}', "");
    Expect(0, 73129, '\P{Sc=_Gong}', "");
    Expect(1, 73129, '\P{^Sc=_Gong}', "");
    Expect(0, 73130, '\p{Sc=_Gong}', "");
    Expect(1, 73130, '\p{^Sc=_Gong}', "");
    Expect(1, 73130, '\P{Sc=_Gong}', "");
    Expect(0, 73130, '\P{^Sc=_Gong}', "");
    Error('\p{Is_Script=:=-Gunjala_GONDI}');
    Error('\P{Is_Script=:=-Gunjala_GONDI}');
    Expect(1, 73129, '\p{Is_Script=gunjalagondi}', "");
    Expect(0, 73129, '\p{^Is_Script=gunjalagondi}', "");
    Expect(0, 73129, '\P{Is_Script=gunjalagondi}', "");
    Expect(1, 73129, '\P{^Is_Script=gunjalagondi}', "");
    Expect(0, 73130, '\p{Is_Script=gunjalagondi}', "");
    Expect(1, 73130, '\p{^Is_Script=gunjalagondi}', "");
    Expect(1, 73130, '\P{Is_Script=gunjalagondi}', "");
    Expect(0, 73130, '\P{^Is_Script=gunjalagondi}', "");
    Expect(1, 73129, '\p{Is_Script= -Gunjala_GONDI}', "");
    Expect(0, 73129, '\p{^Is_Script= -Gunjala_GONDI}', "");
    Expect(0, 73129, '\P{Is_Script= -Gunjala_GONDI}', "");
    Expect(1, 73129, '\P{^Is_Script= -Gunjala_GONDI}', "");
    Expect(0, 73130, '\p{Is_Script= -Gunjala_GONDI}', "");
    Expect(1, 73130, '\p{^Is_Script= -Gunjala_GONDI}', "");
    Expect(1, 73130, '\P{Is_Script= -Gunjala_GONDI}', "");
    Expect(0, 73130, '\P{^Is_Script= -Gunjala_GONDI}', "");
    Error('\p{Is_Sc=-_Gong/a/}');
    Error('\P{Is_Sc=-_Gong/a/}');
    Expect(1, 73129, '\p{Is_Sc=gong}', "");
    Expect(0, 73129, '\p{^Is_Sc=gong}', "");
    Expect(0, 73129, '\P{Is_Sc=gong}', "");
    Expect(1, 73129, '\P{^Is_Sc=gong}', "");
    Expect(0, 73130, '\p{Is_Sc=gong}', "");
    Expect(1, 73130, '\p{^Is_Sc=gong}', "");
    Expect(1, 73130, '\P{Is_Sc=gong}', "");
    Expect(0, 73130, '\P{^Is_Sc=gong}', "");
    Expect(1, 73129, '\p{Is_Sc=_ GONG}', "");
    Expect(0, 73129, '\p{^Is_Sc=_ GONG}', "");
    Expect(0, 73129, '\P{Is_Sc=_ GONG}', "");
    Expect(1, 73129, '\P{^Is_Sc=_ GONG}', "");
    Expect(0, 73130, '\p{Is_Sc=_ GONG}', "");
    Expect(1, 73130, '\p{^Is_Sc=_ GONG}', "");
    Expect(1, 73130, '\P{Is_Sc=_ GONG}', "");
    Expect(0, 73130, '\P{^Is_Sc=_ GONG}', "");
    Error('\p{Script=-:=Masaram_Gondi}');
    Error('\P{Script=-:=Masaram_Gondi}');
    Expect(1, 73049, '\p{Script=:\AMasaram_Gondi\z:}', "");;
    Expect(0, 73050, '\p{Script=:\AMasaram_Gondi\z:}', "");;
    Expect(1, 73049, '\p{Script=masaramgondi}', "");
    Expect(0, 73049, '\p{^Script=masaramgondi}', "");
    Expect(0, 73049, '\P{Script=masaramgondi}', "");
    Expect(1, 73049, '\P{^Script=masaramgondi}', "");
    Expect(0, 73050, '\p{Script=masaramgondi}', "");
    Expect(1, 73050, '\p{^Script=masaramgondi}', "");
    Expect(1, 73050, '\P{Script=masaramgondi}', "");
    Expect(0, 73050, '\P{^Script=masaramgondi}', "");
    Expect(1, 73049, '\p{Script=:\Amasaramgondi\z:}', "");;
    Expect(0, 73050, '\p{Script=:\Amasaramgondi\z:}', "");;
    Expect(1, 73049, '\p{Script= Masaram_Gondi}', "");
    Expect(0, 73049, '\p{^Script= Masaram_Gondi}', "");
    Expect(0, 73049, '\P{Script= Masaram_Gondi}', "");
    Expect(1, 73049, '\P{^Script= Masaram_Gondi}', "");
    Expect(0, 73050, '\p{Script= Masaram_Gondi}', "");
    Expect(1, 73050, '\p{^Script= Masaram_Gondi}', "");
    Expect(1, 73050, '\P{Script= Masaram_Gondi}', "");
    Expect(0, 73050, '\P{^Script= Masaram_Gondi}', "");
    Error('\p{Sc=-	GONM:=}');
    Error('\P{Sc=-	GONM:=}');
    Expect(1, 73049, '\p{Sc=:\AGonm\z:}', "");;
    Expect(0, 73050, '\p{Sc=:\AGonm\z:}', "");;
    Expect(1, 73049, '\p{Sc=gonm}', "");
    Expect(0, 73049, '\p{^Sc=gonm}', "");
    Expect(0, 73049, '\P{Sc=gonm}', "");
    Expect(1, 73049, '\P{^Sc=gonm}', "");
    Expect(0, 73050, '\p{Sc=gonm}', "");
    Expect(1, 73050, '\p{^Sc=gonm}', "");
    Expect(1, 73050, '\P{Sc=gonm}', "");
    Expect(0, 73050, '\P{^Sc=gonm}', "");
    Expect(1, 73049, '\p{Sc=:\Agonm\z:}', "");;
    Expect(0, 73050, '\p{Sc=:\Agonm\z:}', "");;
    Expect(1, 73049, '\p{Sc=_ gonm}', "");
    Expect(0, 73049, '\p{^Sc=_ gonm}', "");
    Expect(0, 73049, '\P{Sc=_ gonm}', "");
    Expect(1, 73049, '\P{^Sc=_ gonm}', "");
    Expect(0, 73050, '\p{Sc=_ gonm}', "");
    Expect(1, 73050, '\p{^Sc=_ gonm}', "");
    Expect(1, 73050, '\P{Sc=_ gonm}', "");
    Expect(0, 73050, '\P{^Sc=_ gonm}', "");
    Error('\p{Is_Script= /a/MASARAM_Gondi}');
    Error('\P{Is_Script= /a/MASARAM_Gondi}');
    Expect(1, 73049, '\p{Is_Script=masaramgondi}', "");
    Expect(0, 73049, '\p{^Is_Script=masaramgondi}', "");
    Expect(0, 73049, '\P{Is_Script=masaramgondi}', "");
    Expect(1, 73049, '\P{^Is_Script=masaramgondi}', "");
    Expect(0, 73050, '\p{Is_Script=masaramgondi}', "");
    Expect(1, 73050, '\p{^Is_Script=masaramgondi}', "");
    Expect(1, 73050, '\P{Is_Script=masaramgondi}', "");
    Expect(0, 73050, '\P{^Is_Script=masaramgondi}', "");
    Expect(1, 73049, '\p{Is_Script=_-masaram_gondi}', "");
    Expect(0, 73049, '\p{^Is_Script=_-masaram_gondi}', "");
    Expect(0, 73049, '\P{Is_Script=_-masaram_gondi}', "");
    Expect(1, 73049, '\P{^Is_Script=_-masaram_gondi}', "");
    Expect(0, 73050, '\p{Is_Script=_-masaram_gondi}', "");
    Expect(1, 73050, '\p{^Is_Script=_-masaram_gondi}', "");
    Expect(1, 73050, '\P{Is_Script=_-masaram_gondi}', "");
    Expect(0, 73050, '\P{^Is_Script=_-masaram_gondi}', "");
    Error('\p{Is_Sc=:=	gonm}');
    Error('\P{Is_Sc=:=	gonm}');
    Expect(1, 73049, '\p{Is_Sc=gonm}', "");
    Expect(0, 73049, '\p{^Is_Sc=gonm}', "");
    Expect(0, 73049, '\P{Is_Sc=gonm}', "");
    Expect(1, 73049, '\P{^Is_Sc=gonm}', "");
    Expect(0, 73050, '\p{Is_Sc=gonm}', "");
    Expect(1, 73050, '\p{^Is_Sc=gonm}', "");
    Expect(1, 73050, '\P{Is_Sc=gonm}', "");
    Expect(0, 73050, '\P{^Is_Sc=gonm}', "");
    Expect(1, 73049, '\p{Is_Sc=  Gonm}', "");
    Expect(0, 73049, '\p{^Is_Sc=  Gonm}', "");
    Expect(0, 73049, '\P{Is_Sc=  Gonm}', "");
    Expect(1, 73049, '\P{^Is_Sc=  Gonm}', "");
    Expect(0, 73050, '\p{Is_Sc=  Gonm}', "");
    Expect(1, 73050, '\p{^Is_Sc=  Gonm}', "");
    Expect(1, 73050, '\P{Is_Sc=  Gonm}', "");
    Expect(0, 73050, '\P{^Is_Sc=  Gonm}', "");
    Error('\p{Script=-	Gothic:=}');
    Error('\P{Script=-	Gothic:=}');
    Expect(1, 66378, '\p{Script=:\AGothic\z:}', "");;
    Expect(0, 66379, '\p{Script=:\AGothic\z:}', "");;
    Expect(1, 66378, '\p{Script=gothic}', "");
    Expect(0, 66378, '\p{^Script=gothic}', "");
    Expect(0, 66378, '\P{Script=gothic}', "");
    Expect(1, 66378, '\P{^Script=gothic}', "");
    Expect(0, 66379, '\p{Script=gothic}', "");
    Expect(1, 66379, '\p{^Script=gothic}', "");
    Expect(1, 66379, '\P{Script=gothic}', "");
    Expect(0, 66379, '\P{^Script=gothic}', "");
    Expect(1, 66378, '\p{Script=:\Agothic\z:}', "");;
    Expect(0, 66379, '\p{Script=:\Agothic\z:}', "");;
    Expect(1, 66378, '\p{Script=_ gothic}', "");
    Expect(0, 66378, '\p{^Script=_ gothic}', "");
    Expect(0, 66378, '\P{Script=_ gothic}', "");
    Expect(1, 66378, '\P{^Script=_ gothic}', "");
    Expect(0, 66379, '\p{Script=_ gothic}', "");
    Expect(1, 66379, '\p{^Script=_ gothic}', "");
    Expect(1, 66379, '\P{Script=_ gothic}', "");
    Expect(0, 66379, '\P{^Script=_ gothic}', "");
    Error('\p{Sc=/a/ 	Goth}');
    Error('\P{Sc=/a/ 	Goth}');
    Expect(1, 66378, '\p{Sc=:\AGoth\z:}', "");;
    Expect(0, 66379, '\p{Sc=:\AGoth\z:}', "");;
    Expect(1, 66378, '\p{Sc=goth}', "");
    Expect(0, 66378, '\p{^Sc=goth}', "");
    Expect(0, 66378, '\P{Sc=goth}', "");
    Expect(1, 66378, '\P{^Sc=goth}', "");
    Expect(0, 66379, '\p{Sc=goth}', "");
    Expect(1, 66379, '\p{^Sc=goth}', "");
    Expect(1, 66379, '\P{Sc=goth}', "");
    Expect(0, 66379, '\P{^Sc=goth}', "");
    Expect(1, 66378, '\p{Sc=:\Agoth\z:}', "");;
    Expect(0, 66379, '\p{Sc=:\Agoth\z:}', "");;
    Expect(1, 66378, '\p{Sc=		goth}', "");
    Expect(0, 66378, '\p{^Sc=		goth}', "");
    Expect(0, 66378, '\P{Sc=		goth}', "");
    Expect(1, 66378, '\P{^Sc=		goth}', "");
    Expect(0, 66379, '\p{Sc=		goth}', "");
    Expect(1, 66379, '\p{^Sc=		goth}', "");
    Expect(1, 66379, '\P{Sc=		goth}', "");
    Expect(0, 66379, '\P{^Sc=		goth}', "");
    Error('\p{Is_Script= :=Gothic}');
    Error('\P{Is_Script= :=Gothic}');
    Expect(1, 66378, '\p{Is_Script=gothic}', "");
    Expect(0, 66378, '\p{^Is_Script=gothic}', "");
    Expect(0, 66378, '\P{Is_Script=gothic}', "");
    Expect(1, 66378, '\P{^Is_Script=gothic}', "");
    Expect(0, 66379, '\p{Is_Script=gothic}', "");
    Expect(1, 66379, '\p{^Is_Script=gothic}', "");
    Expect(1, 66379, '\P{Is_Script=gothic}', "");
    Expect(0, 66379, '\P{^Is_Script=gothic}', "");
    Expect(1, 66378, '\p{Is_Script=GOTHIC}', "");
    Expect(0, 66378, '\p{^Is_Script=GOTHIC}', "");
    Expect(0, 66378, '\P{Is_Script=GOTHIC}', "");
    Expect(1, 66378, '\P{^Is_Script=GOTHIC}', "");
    Expect(0, 66379, '\p{Is_Script=GOTHIC}', "");
    Expect(1, 66379, '\p{^Is_Script=GOTHIC}', "");
    Expect(1, 66379, '\P{Is_Script=GOTHIC}', "");
    Expect(0, 66379, '\P{^Is_Script=GOTHIC}', "");
    Error('\p{Is_Sc=-:=GOTH}');
    Error('\P{Is_Sc=-:=GOTH}');
    Expect(1, 66378, '\p{Is_Sc=goth}', "");
    Expect(0, 66378, '\p{^Is_Sc=goth}', "");
    Expect(0, 66378, '\P{Is_Sc=goth}', "");
    Expect(1, 66378, '\P{^Is_Sc=goth}', "");
    Expect(0, 66379, '\p{Is_Sc=goth}', "");
    Expect(1, 66379, '\p{^Is_Sc=goth}', "");
    Expect(1, 66379, '\P{Is_Sc=goth}', "");
    Expect(0, 66379, '\P{^Is_Sc=goth}', "");
    Expect(1, 66378, '\p{Is_Sc=_	goth}', "");
    Expect(0, 66378, '\p{^Is_Sc=_	goth}', "");
    Expect(0, 66378, '\P{Is_Sc=_	goth}', "");
    Expect(1, 66378, '\P{^Is_Sc=_	goth}', "");
    Expect(0, 66379, '\p{Is_Sc=_	goth}', "");
    Expect(1, 66379, '\p{^Is_Sc=_	goth}', "");
    Expect(1, 66379, '\P{Is_Sc=_	goth}', "");
    Expect(0, 66379, '\P{^Is_Sc=_	goth}', "");
    Error('\p{Script=	Grantha/a/}');
    Error('\P{Script=	Grantha/a/}');
    Expect(1, 70516, '\p{Script=:\AGrantha\z:}', "");;
    Expect(0, 70517, '\p{Script=:\AGrantha\z:}', "");;
    Expect(1, 70516, '\p{Script=grantha}', "");
    Expect(0, 70516, '\p{^Script=grantha}', "");
    Expect(0, 70516, '\P{Script=grantha}', "");
    Expect(1, 70516, '\P{^Script=grantha}', "");
    Expect(0, 70517, '\p{Script=grantha}', "");
    Expect(1, 70517, '\p{^Script=grantha}', "");
    Expect(1, 70517, '\P{Script=grantha}', "");
    Expect(0, 70517, '\P{^Script=grantha}', "");
    Expect(1, 70516, '\p{Script=:\Agrantha\z:}', "");;
    Expect(0, 70517, '\p{Script=:\Agrantha\z:}', "");;
    Expect(1, 70516, '\p{Script=-	Grantha}', "");
    Expect(0, 70516, '\p{^Script=-	Grantha}', "");
    Expect(0, 70516, '\P{Script=-	Grantha}', "");
    Expect(1, 70516, '\P{^Script=-	Grantha}', "");
    Expect(0, 70517, '\p{Script=-	Grantha}', "");
    Expect(1, 70517, '\p{^Script=-	Grantha}', "");
    Expect(1, 70517, '\P{Script=-	Grantha}', "");
    Expect(0, 70517, '\P{^Script=-	Grantha}', "");
    Error('\p{Sc=:=  GRAN}');
    Error('\P{Sc=:=  GRAN}');
    Expect(1, 70516, '\p{Sc=:\AGran\z:}', "");;
    Expect(0, 70517, '\p{Sc=:\AGran\z:}', "");;
    Expect(1, 70516, '\p{Sc=gran}', "");
    Expect(0, 70516, '\p{^Sc=gran}', "");
    Expect(0, 70516, '\P{Sc=gran}', "");
    Expect(1, 70516, '\P{^Sc=gran}', "");
    Expect(0, 70517, '\p{Sc=gran}', "");
    Expect(1, 70517, '\p{^Sc=gran}', "");
    Expect(1, 70517, '\P{Sc=gran}', "");
    Expect(0, 70517, '\P{^Sc=gran}', "");
    Expect(1, 70516, '\p{Sc=:\Agran\z:}', "");;
    Expect(0, 70517, '\p{Sc=:\Agran\z:}', "");;
    Expect(1, 70516, '\p{Sc=		gran}', "");
    Expect(0, 70516, '\p{^Sc=		gran}', "");
    Expect(0, 70516, '\P{Sc=		gran}', "");
    Expect(1, 70516, '\P{^Sc=		gran}', "");
    Expect(0, 70517, '\p{Sc=		gran}', "");
    Expect(1, 70517, '\p{^Sc=		gran}', "");
    Expect(1, 70517, '\P{Sc=		gran}', "");
    Expect(0, 70517, '\P{^Sc=		gran}', "");
    Error('\p{Is_Script= 	Grantha:=}');
    Error('\P{Is_Script= 	Grantha:=}');
    Expect(1, 70516, '\p{Is_Script=grantha}', "");
    Expect(0, 70516, '\p{^Is_Script=grantha}', "");
    Expect(0, 70516, '\P{Is_Script=grantha}', "");
    Expect(1, 70516, '\P{^Is_Script=grantha}', "");
    Expect(0, 70517, '\p{Is_Script=grantha}', "");
    Expect(1, 70517, '\p{^Is_Script=grantha}', "");
    Expect(1, 70517, '\P{Is_Script=grantha}', "");
    Expect(0, 70517, '\P{^Is_Script=grantha}', "");
    Expect(1, 70516, '\p{Is_Script=-GRANTHA}', "");
    Expect(0, 70516, '\p{^Is_Script=-GRANTHA}', "");
    Expect(0, 70516, '\P{Is_Script=-GRANTHA}', "");
    Expect(1, 70516, '\P{^Is_Script=-GRANTHA}', "");
    Expect(0, 70517, '\p{Is_Script=-GRANTHA}', "");
    Expect(1, 70517, '\p{^Is_Script=-GRANTHA}', "");
    Expect(1, 70517, '\P{Is_Script=-GRANTHA}', "");
    Expect(0, 70517, '\P{^Is_Script=-GRANTHA}', "");
    Error('\p{Is_Sc= /a/Gran}');
    Error('\P{Is_Sc= /a/Gran}');
    Expect(1, 70516, '\p{Is_Sc=gran}', "");
    Expect(0, 70516, '\p{^Is_Sc=gran}', "");
    Expect(0, 70516, '\P{Is_Sc=gran}', "");
    Expect(1, 70516, '\P{^Is_Sc=gran}', "");
    Expect(0, 70517, '\p{Is_Sc=gran}', "");
    Expect(1, 70517, '\p{^Is_Sc=gran}', "");
    Expect(1, 70517, '\P{Is_Sc=gran}', "");
    Expect(0, 70517, '\P{^Is_Sc=gran}', "");
    Expect(1, 70516, '\p{Is_Sc: __Gran}', "");
    Expect(0, 70516, '\p{^Is_Sc: __Gran}', "");
    Expect(0, 70516, '\P{Is_Sc: __Gran}', "");
    Expect(1, 70516, '\P{^Is_Sc: __Gran}', "");
    Expect(0, 70517, '\p{Is_Sc: __Gran}', "");
    Expect(1, 70517, '\p{^Is_Sc: __Gran}', "");
    Expect(1, 70517, '\P{Is_Sc: __Gran}', "");
    Expect(0, 70517, '\P{^Is_Sc: __Gran}', "");
    Error('\p{Script= /a/Greek}');
    Error('\P{Script= /a/Greek}');
    Expect(1, 119365, '\p{Script=:\AGreek\z:}', "");;
    Expect(0, 119366, '\p{Script=:\AGreek\z:}', "");;
    Expect(1, 119365, '\p{Script=greek}', "");
    Expect(0, 119365, '\p{^Script=greek}', "");
    Expect(0, 119365, '\P{Script=greek}', "");
    Expect(1, 119365, '\P{^Script=greek}', "");
    Expect(0, 119366, '\p{Script=greek}', "");
    Expect(1, 119366, '\p{^Script=greek}', "");
    Expect(1, 119366, '\P{Script=greek}', "");
    Expect(0, 119366, '\P{^Script=greek}', "");
    Expect(1, 119365, '\p{Script=:\Agreek\z:}', "");;
    Expect(0, 119366, '\p{Script=:\Agreek\z:}', "");;
    Expect(1, 119365, '\p{Script= -Greek}', "");
    Expect(0, 119365, '\p{^Script= -Greek}', "");
    Expect(0, 119365, '\P{Script= -Greek}', "");
    Expect(1, 119365, '\P{^Script= -Greek}', "");
    Expect(0, 119366, '\p{Script= -Greek}', "");
    Expect(1, 119366, '\p{^Script= -Greek}', "");
    Expect(1, 119366, '\P{Script= -Greek}', "");
    Expect(0, 119366, '\P{^Script= -Greek}', "");
    Error('\p{Sc:	:= 	GREK}');
    Error('\P{Sc:	:= 	GREK}');
    Expect(1, 119365, '\p{Sc=:\AGrek\z:}', "");;
    Expect(0, 119366, '\p{Sc=:\AGrek\z:}', "");;
    Expect(1, 119365, '\p{Sc:	grek}', "");
    Expect(0, 119365, '\p{^Sc:	grek}', "");
    Expect(0, 119365, '\P{Sc:	grek}', "");
    Expect(1, 119365, '\P{^Sc:	grek}', "");
    Expect(0, 119366, '\p{Sc:	grek}', "");
    Expect(1, 119366, '\p{^Sc:	grek}', "");
    Expect(1, 119366, '\P{Sc:	grek}', "");
    Expect(0, 119366, '\P{^Sc:	grek}', "");
    Expect(1, 119365, '\p{Sc=:\Agrek\z:}', "");;
    Expect(0, 119366, '\p{Sc=:\Agrek\z:}', "");;
    Expect(1, 119365, '\p{Sc=- GREK}', "");
    Expect(0, 119365, '\p{^Sc=- GREK}', "");
    Expect(0, 119365, '\P{Sc=- GREK}', "");
    Expect(1, 119365, '\P{^Sc=- GREK}', "");
    Expect(0, 119366, '\p{Sc=- GREK}', "");
    Expect(1, 119366, '\p{^Sc=- GREK}', "");
    Expect(1, 119366, '\P{Sc=- GREK}', "");
    Expect(0, 119366, '\P{^Sc=- GREK}', "");
    Error('\p{Is_Script=/a/-	greek}');
    Error('\P{Is_Script=/a/-	greek}');
    Expect(1, 119365, '\p{Is_Script=greek}', "");
    Expect(0, 119365, '\p{^Is_Script=greek}', "");
    Expect(0, 119365, '\P{Is_Script=greek}', "");
    Expect(1, 119365, '\P{^Is_Script=greek}', "");
    Expect(0, 119366, '\p{Is_Script=greek}', "");
    Expect(1, 119366, '\p{^Is_Script=greek}', "");
    Expect(1, 119366, '\P{Is_Script=greek}', "");
    Expect(0, 119366, '\P{^Is_Script=greek}', "");
    Expect(1, 119365, '\p{Is_Script= _Greek}', "");
    Expect(0, 119365, '\p{^Is_Script= _Greek}', "");
    Expect(0, 119365, '\P{Is_Script= _Greek}', "");
    Expect(1, 119365, '\P{^Is_Script= _Greek}', "");
    Expect(0, 119366, '\p{Is_Script= _Greek}', "");
    Expect(1, 119366, '\p{^Is_Script= _Greek}', "");
    Expect(1, 119366, '\P{Is_Script= _Greek}', "");
    Expect(0, 119366, '\P{^Is_Script= _Greek}', "");
    Error('\p{Is_Sc= /a/grek}');
    Error('\P{Is_Sc= /a/grek}');
    Expect(1, 119365, '\p{Is_Sc=grek}', "");
    Expect(0, 119365, '\p{^Is_Sc=grek}', "");
    Expect(0, 119365, '\P{Is_Sc=grek}', "");
    Expect(1, 119365, '\P{^Is_Sc=grek}', "");
    Expect(0, 119366, '\p{Is_Sc=grek}', "");
    Expect(1, 119366, '\p{^Is_Sc=grek}', "");
    Expect(1, 119366, '\P{Is_Sc=grek}', "");
    Expect(0, 119366, '\P{^Is_Sc=grek}', "");
    Expect(1, 119365, '\p{Is_Sc=	-GREK}', "");
    Expect(0, 119365, '\p{^Is_Sc=	-GREK}', "");
    Expect(0, 119365, '\P{Is_Sc=	-GREK}', "");
    Expect(1, 119365, '\P{^Is_Sc=	-GREK}', "");
    Expect(0, 119366, '\p{Is_Sc=	-GREK}', "");
    Expect(1, 119366, '\p{^Is_Sc=	-GREK}', "");
    Expect(1, 119366, '\P{Is_Sc=	-GREK}', "");
    Expect(0, 119366, '\P{^Is_Sc=	-GREK}', "");
    Error('\p{Script=__Gujarati:=}');
    Error('\P{Script=__Gujarati:=}');
    Expect(1, 2815, '\p{Script=:\AGujarati\z:}', "");;
    Expect(0, 2816, '\p{Script=:\AGujarati\z:}', "");;
    Expect(1, 2815, '\p{Script=gujarati}', "");
    Expect(0, 2815, '\p{^Script=gujarati}', "");
    Expect(0, 2815, '\P{Script=gujarati}', "");
    Expect(1, 2815, '\P{^Script=gujarati}', "");
    Expect(0, 2816, '\p{Script=gujarati}', "");
    Expect(1, 2816, '\p{^Script=gujarati}', "");
    Expect(1, 2816, '\P{Script=gujarati}', "");
    Expect(0, 2816, '\P{^Script=gujarati}', "");
    Expect(1, 2815, '\p{Script=:\Agujarati\z:}', "");;
    Expect(0, 2816, '\p{Script=:\Agujarati\z:}', "");;
    Expect(1, 2815, '\p{Script=--gujarati}', "");
    Expect(0, 2815, '\p{^Script=--gujarati}', "");
    Expect(0, 2815, '\P{Script=--gujarati}', "");
    Expect(1, 2815, '\P{^Script=--gujarati}', "");
    Expect(0, 2816, '\p{Script=--gujarati}', "");
    Expect(1, 2816, '\p{^Script=--gujarati}', "");
    Expect(1, 2816, '\P{Script=--gujarati}', "");
    Expect(0, 2816, '\P{^Script=--gujarati}', "");
    Error('\p{Sc: 	Gujr:=}');
    Error('\P{Sc: 	Gujr:=}');
    Expect(1, 2815, '\p{Sc=:\AGujr\z:}', "");;
    Expect(0, 2816, '\p{Sc=:\AGujr\z:}', "");;
    Expect(1, 2815, '\p{Sc=gujr}', "");
    Expect(0, 2815, '\p{^Sc=gujr}', "");
    Expect(0, 2815, '\P{Sc=gujr}', "");
    Expect(1, 2815, '\P{^Sc=gujr}', "");
    Expect(0, 2816, '\p{Sc=gujr}', "");
    Expect(1, 2816, '\p{^Sc=gujr}', "");
    Expect(1, 2816, '\P{Sc=gujr}', "");
    Expect(0, 2816, '\P{^Sc=gujr}', "");
    Expect(1, 2815, '\p{Sc=:\Agujr\z:}', "");;
    Expect(0, 2816, '\p{Sc=:\Agujr\z:}', "");;
    Expect(1, 2815, '\p{Sc=  GUJR}', "");
    Expect(0, 2815, '\p{^Sc=  GUJR}', "");
    Expect(0, 2815, '\P{Sc=  GUJR}', "");
    Expect(1, 2815, '\P{^Sc=  GUJR}', "");
    Expect(0, 2816, '\p{Sc=  GUJR}', "");
    Expect(1, 2816, '\p{^Sc=  GUJR}', "");
    Expect(1, 2816, '\P{Sc=  GUJR}', "");
    Expect(0, 2816, '\P{^Sc=  GUJR}', "");
    Error('\p{Is_Script=:=-Gujarati}');
    Error('\P{Is_Script=:=-Gujarati}');
    Expect(1, 2815, '\p{Is_Script: gujarati}', "");
    Expect(0, 2815, '\p{^Is_Script: gujarati}', "");
    Expect(0, 2815, '\P{Is_Script: gujarati}', "");
    Expect(1, 2815, '\P{^Is_Script: gujarati}', "");
    Expect(0, 2816, '\p{Is_Script: gujarati}', "");
    Expect(1, 2816, '\p{^Is_Script: gujarati}', "");
    Expect(1, 2816, '\P{Is_Script: gujarati}', "");
    Expect(0, 2816, '\P{^Is_Script: gujarati}', "");
    Expect(1, 2815, '\p{Is_Script=_-gujarati}', "");
    Expect(0, 2815, '\p{^Is_Script=_-gujarati}', "");
    Expect(0, 2815, '\P{Is_Script=_-gujarati}', "");
    Expect(1, 2815, '\P{^Is_Script=_-gujarati}', "");
    Expect(0, 2816, '\p{Is_Script=_-gujarati}', "");
    Expect(1, 2816, '\p{^Is_Script=_-gujarati}', "");
    Expect(1, 2816, '\P{Is_Script=_-gujarati}', "");
    Expect(0, 2816, '\P{^Is_Script=_-gujarati}', "");
    Error('\p{Is_Sc=_/a/Gujr}');
    Error('\P{Is_Sc=_/a/Gujr}');
    Expect(1, 2815, '\p{Is_Sc=gujr}', "");
    Expect(0, 2815, '\p{^Is_Sc=gujr}', "");
    Expect(0, 2815, '\P{Is_Sc=gujr}', "");
    Expect(1, 2815, '\P{^Is_Sc=gujr}', "");
    Expect(0, 2816, '\p{Is_Sc=gujr}', "");
    Expect(1, 2816, '\p{^Is_Sc=gujr}', "");
    Expect(1, 2816, '\P{Is_Sc=gujr}', "");
    Expect(0, 2816, '\P{^Is_Sc=gujr}', "");
    Expect(1, 2815, '\p{Is_Sc=_	gujr}', "");
    Expect(0, 2815, '\p{^Is_Sc=_	gujr}', "");
    Expect(0, 2815, '\P{Is_Sc=_	gujr}', "");
    Expect(1, 2815, '\P{^Is_Sc=_	gujr}', "");
    Expect(0, 2816, '\p{Is_Sc=_	gujr}', "");
    Expect(1, 2816, '\p{^Is_Sc=_	gujr}', "");
    Expect(1, 2816, '\P{Is_Sc=_	gujr}', "");
    Expect(0, 2816, '\P{^Is_Sc=_	gujr}', "");
    Error('\p{Script= 	GURMUKHI/a/}');
    Error('\P{Script= 	GURMUKHI/a/}');
    Expect(1, 2678, '\p{Script=:\AGurmukhi\z:}', "");;
    Expect(0, 2679, '\p{Script=:\AGurmukhi\z:}', "");;
    Expect(1, 2678, '\p{Script:gurmukhi}', "");
    Expect(0, 2678, '\p{^Script:gurmukhi}', "");
    Expect(0, 2678, '\P{Script:gurmukhi}', "");
    Expect(1, 2678, '\P{^Script:gurmukhi}', "");
    Expect(0, 2679, '\p{Script:gurmukhi}', "");
    Expect(1, 2679, '\p{^Script:gurmukhi}', "");
    Expect(1, 2679, '\P{Script:gurmukhi}', "");
    Expect(0, 2679, '\P{^Script:gurmukhi}', "");
    Expect(1, 2678, '\p{Script=:\Agurmukhi\z:}', "");;
    Expect(0, 2679, '\p{Script=:\Agurmukhi\z:}', "");;
    Expect(1, 2678, '\p{Script= -Gurmukhi}', "");
    Expect(0, 2678, '\p{^Script= -Gurmukhi}', "");
    Expect(0, 2678, '\P{Script= -Gurmukhi}', "");
    Expect(1, 2678, '\P{^Script= -Gurmukhi}', "");
    Expect(0, 2679, '\p{Script= -Gurmukhi}', "");
    Expect(1, 2679, '\p{^Script= -Gurmukhi}', "");
    Expect(1, 2679, '\P{Script= -Gurmukhi}', "");
    Expect(0, 2679, '\P{^Script= -Gurmukhi}', "");
    Error('\p{Sc=/a/_	GURU}');
    Error('\P{Sc=/a/_	GURU}');
    Expect(1, 2678, '\p{Sc=:\AGuru\z:}', "");;
    Expect(0, 2679, '\p{Sc=:\AGuru\z:}', "");;
    Expect(1, 2678, '\p{Sc=guru}', "");
    Expect(0, 2678, '\p{^Sc=guru}', "");
    Expect(0, 2678, '\P{Sc=guru}', "");
    Expect(1, 2678, '\P{^Sc=guru}', "");
    Expect(0, 2679, '\p{Sc=guru}', "");
    Expect(1, 2679, '\p{^Sc=guru}', "");
    Expect(1, 2679, '\P{Sc=guru}', "");
    Expect(0, 2679, '\P{^Sc=guru}', "");
    Expect(1, 2678, '\p{Sc=:\Aguru\z:}', "");;
    Expect(0, 2679, '\p{Sc=:\Aguru\z:}', "");;
    Expect(1, 2678, '\p{Sc: -Guru}', "");
    Expect(0, 2678, '\p{^Sc: -Guru}', "");
    Expect(0, 2678, '\P{Sc: -Guru}', "");
    Expect(1, 2678, '\P{^Sc: -Guru}', "");
    Expect(0, 2679, '\p{Sc: -Guru}', "");
    Expect(1, 2679, '\p{^Sc: -Guru}', "");
    Expect(1, 2679, '\P{Sc: -Guru}', "");
    Expect(0, 2679, '\P{^Sc: -Guru}', "");
    Error('\p{Is_Script=	/a/GURMUKHI}');
    Error('\P{Is_Script=	/a/GURMUKHI}');
    Expect(1, 2678, '\p{Is_Script=gurmukhi}', "");
    Expect(0, 2678, '\p{^Is_Script=gurmukhi}', "");
    Expect(0, 2678, '\P{Is_Script=gurmukhi}', "");
    Expect(1, 2678, '\P{^Is_Script=gurmukhi}', "");
    Expect(0, 2679, '\p{Is_Script=gurmukhi}', "");
    Expect(1, 2679, '\p{^Is_Script=gurmukhi}', "");
    Expect(1, 2679, '\P{Is_Script=gurmukhi}', "");
    Expect(0, 2679, '\P{^Is_Script=gurmukhi}', "");
    Expect(1, 2678, '\p{Is_Script= 	gurmukhi}', "");
    Expect(0, 2678, '\p{^Is_Script= 	gurmukhi}', "");
    Expect(0, 2678, '\P{Is_Script= 	gurmukhi}', "");
    Expect(1, 2678, '\P{^Is_Script= 	gurmukhi}', "");
    Expect(0, 2679, '\p{Is_Script= 	gurmukhi}', "");
    Expect(1, 2679, '\p{^Is_Script= 	gurmukhi}', "");
    Expect(1, 2679, '\P{Is_Script= 	gurmukhi}', "");
    Expect(0, 2679, '\P{^Is_Script= 	gurmukhi}', "");
    Error('\p{Is_Sc=/a/-_guru}');
    Error('\P{Is_Sc=/a/-_guru}');
    Expect(1, 2678, '\p{Is_Sc=guru}', "");
    Expect(0, 2678, '\p{^Is_Sc=guru}', "");
    Expect(0, 2678, '\P{Is_Sc=guru}', "");
    Expect(1, 2678, '\P{^Is_Sc=guru}', "");
    Expect(0, 2679, '\p{Is_Sc=guru}', "");
    Expect(1, 2679, '\p{^Is_Sc=guru}', "");
    Expect(1, 2679, '\P{Is_Sc=guru}', "");
    Expect(0, 2679, '\P{^Is_Sc=guru}', "");
    Expect(1, 2678, '\p{Is_Sc=__GURU}', "");
    Expect(0, 2678, '\p{^Is_Sc=__GURU}', "");
    Expect(0, 2678, '\P{Is_Sc=__GURU}', "");
    Expect(1, 2678, '\P{^Is_Sc=__GURU}', "");
    Expect(0, 2679, '\p{Is_Sc=__GURU}', "");
    Expect(1, 2679, '\p{^Is_Sc=__GURU}', "");
    Expect(1, 2679, '\P{Is_Sc=__GURU}', "");
    Expect(0, 2679, '\P{^Is_Sc=__GURU}', "");
    Error('\p{Script=:=	HANGUL}');
    Error('\P{Script=:=	HANGUL}');
    Expect(1, 65500, '\p{Script=:\AHangul\z:}', "");;
    Expect(0, 65501, '\p{Script=:\AHangul\z:}', "");;
    Expect(1, 65500, '\p{Script=hangul}', "");
    Expect(0, 65500, '\p{^Script=hangul}', "");
    Expect(0, 65500, '\P{Script=hangul}', "");
    Expect(1, 65500, '\P{^Script=hangul}', "");
    Expect(0, 65501, '\p{Script=hangul}', "");
    Expect(1, 65501, '\p{^Script=hangul}', "");
    Expect(1, 65501, '\P{Script=hangul}', "");
    Expect(0, 65501, '\P{^Script=hangul}', "");
    Expect(1, 65500, '\p{Script=:\Ahangul\z:}', "");;
    Expect(0, 65501, '\p{Script=:\Ahangul\z:}', "");;
    Expect(1, 65500, '\p{Script=_hangul}', "");
    Expect(0, 65500, '\p{^Script=_hangul}', "");
    Expect(0, 65500, '\P{Script=_hangul}', "");
    Expect(1, 65500, '\P{^Script=_hangul}', "");
    Expect(0, 65501, '\p{Script=_hangul}', "");
    Expect(1, 65501, '\p{^Script=_hangul}', "");
    Expect(1, 65501, '\P{Script=_hangul}', "");
    Expect(0, 65501, '\P{^Script=_hangul}', "");
    Error('\p{Sc=/a/  Hang}');
    Error('\P{Sc=/a/  Hang}');
    Expect(1, 65500, '\p{Sc=:\AHang\z:}', "");;
    Expect(0, 65501, '\p{Sc=:\AHang\z:}', "");;
    Expect(1, 65500, '\p{Sc=hang}', "");
    Expect(0, 65500, '\p{^Sc=hang}', "");
    Expect(0, 65500, '\P{Sc=hang}', "");
    Expect(1, 65500, '\P{^Sc=hang}', "");
    Expect(0, 65501, '\p{Sc=hang}', "");
    Expect(1, 65501, '\p{^Sc=hang}', "");
    Expect(1, 65501, '\P{Sc=hang}', "");
    Expect(0, 65501, '\P{^Sc=hang}', "");
    Expect(1, 65500, '\p{Sc=:\Ahang\z:}', "");;
    Expect(0, 65501, '\p{Sc=:\Ahang\z:}', "");;
    Expect(1, 65500, '\p{Sc=_Hang}', "");
    Expect(0, 65500, '\p{^Sc=_Hang}', "");
    Expect(0, 65500, '\P{Sc=_Hang}', "");
    Expect(1, 65500, '\P{^Sc=_Hang}', "");
    Expect(0, 65501, '\p{Sc=_Hang}', "");
    Expect(1, 65501, '\p{^Sc=_Hang}', "");
    Expect(1, 65501, '\P{Sc=_Hang}', "");
    Expect(0, 65501, '\P{^Sc=_Hang}', "");
    Error('\p{Is_Script=_	Hangul:=}');
    Error('\P{Is_Script=_	Hangul:=}');
    Expect(1, 65500, '\p{Is_Script=hangul}', "");
    Expect(0, 65500, '\p{^Is_Script=hangul}', "");
    Expect(0, 65500, '\P{Is_Script=hangul}', "");
    Expect(1, 65500, '\P{^Is_Script=hangul}', "");
    Expect(0, 65501, '\p{Is_Script=hangul}', "");
    Expect(1, 65501, '\p{^Is_Script=hangul}', "");
    Expect(1, 65501, '\P{Is_Script=hangul}', "");
    Expect(0, 65501, '\P{^Is_Script=hangul}', "");
    Expect(1, 65500, '\p{Is_Script=--hangul}', "");
    Expect(0, 65500, '\p{^Is_Script=--hangul}', "");
    Expect(0, 65500, '\P{Is_Script=--hangul}', "");
    Expect(1, 65500, '\P{^Is_Script=--hangul}', "");
    Expect(0, 65501, '\p{Is_Script=--hangul}', "");
    Expect(1, 65501, '\p{^Is_Script=--hangul}', "");
    Expect(1, 65501, '\P{Is_Script=--hangul}', "");
    Expect(0, 65501, '\P{^Is_Script=--hangul}', "");
    Error('\p{Is_Sc= :=hang}');
    Error('\P{Is_Sc= :=hang}');
    Expect(1, 65500, '\p{Is_Sc=hang}', "");
    Expect(0, 65500, '\p{^Is_Sc=hang}', "");
    Expect(0, 65500, '\P{Is_Sc=hang}', "");
    Expect(1, 65500, '\P{^Is_Sc=hang}', "");
    Expect(0, 65501, '\p{Is_Sc=hang}', "");
    Expect(1, 65501, '\p{^Is_Sc=hang}', "");
    Expect(1, 65501, '\P{Is_Sc=hang}', "");
    Expect(0, 65501, '\P{^Is_Sc=hang}', "");
    Expect(1, 65500, '\p{Is_Sc=  hang}', "");
    Expect(0, 65500, '\p{^Is_Sc=  hang}', "");
    Expect(0, 65500, '\P{Is_Sc=  hang}', "");
    Expect(1, 65500, '\P{^Is_Sc=  hang}', "");
    Expect(0, 65501, '\p{Is_Sc=  hang}', "");
    Expect(1, 65501, '\p{^Is_Sc=  hang}', "");
    Expect(1, 65501, '\P{Is_Sc=  hang}', "");
    Expect(0, 65501, '\P{^Is_Sc=  hang}', "");
    Error('\p{Script=- Han:=}');
    Error('\P{Script=- Han:=}');
    Expect(1, 195101, '\p{Script=:\AHan\z:}', "");;
    Expect(0, 195102, '\p{Script=:\AHan\z:}', "");;
    Expect(1, 195101, '\p{Script=han}', "");
    Expect(0, 195101, '\p{^Script=han}', "");
    Expect(0, 195101, '\P{Script=han}', "");
    Expect(1, 195101, '\P{^Script=han}', "");
    Expect(0, 195102, '\p{Script=han}', "");
    Expect(1, 195102, '\p{^Script=han}', "");
    Expect(1, 195102, '\P{Script=han}', "");
    Expect(0, 195102, '\P{^Script=han}', "");
    Expect(1, 195101, '\p{Script=:\Ahan\z:}', "");;
    Expect(0, 195102, '\p{Script=:\Ahan\z:}', "");;
    Expect(1, 195101, '\p{Script=-	Han}', "");
    Expect(0, 195101, '\p{^Script=-	Han}', "");
    Expect(0, 195101, '\P{Script=-	Han}', "");
    Expect(1, 195101, '\P{^Script=-	Han}', "");
    Expect(0, 195102, '\p{Script=-	Han}', "");
    Expect(1, 195102, '\p{^Script=-	Han}', "");
    Expect(1, 195102, '\P{Script=-	Han}', "");
    Expect(0, 195102, '\P{^Script=-	Han}', "");
    Error('\p{Sc=/a/Hani}');
    Error('\P{Sc=/a/Hani}');
    Expect(1, 195101, '\p{Sc=:\AHani\z:}', "");;
    Expect(0, 195102, '\p{Sc=:\AHani\z:}', "");;
    Expect(1, 195101, '\p{Sc: hani}', "");
    Expect(0, 195101, '\p{^Sc: hani}', "");
    Expect(0, 195101, '\P{Sc: hani}', "");
    Expect(1, 195101, '\P{^Sc: hani}', "");
    Expect(0, 195102, '\p{Sc: hani}', "");
    Expect(1, 195102, '\p{^Sc: hani}', "");
    Expect(1, 195102, '\P{Sc: hani}', "");
    Expect(0, 195102, '\P{^Sc: hani}', "");
    Expect(1, 195101, '\p{Sc=:\Ahani\z:}', "");;
    Expect(0, 195102, '\p{Sc=:\Ahani\z:}', "");;
    Expect(1, 195101, '\p{Sc=-HANI}', "");
    Expect(0, 195101, '\p{^Sc=-HANI}', "");
    Expect(0, 195101, '\P{Sc=-HANI}', "");
    Expect(1, 195101, '\P{^Sc=-HANI}', "");
    Expect(0, 195102, '\p{Sc=-HANI}', "");
    Expect(1, 195102, '\p{^Sc=-HANI}', "");
    Expect(1, 195102, '\P{Sc=-HANI}', "");
    Expect(0, 195102, '\P{^Sc=-HANI}', "");
    Error('\p{Is_Script: :=Han}');
    Error('\P{Is_Script: :=Han}');
    Expect(1, 195101, '\p{Is_Script=han}', "");
    Expect(0, 195101, '\p{^Is_Script=han}', "");
    Expect(0, 195101, '\P{Is_Script=han}', "");
    Expect(1, 195101, '\P{^Is_Script=han}', "");
    Expect(0, 195102, '\p{Is_Script=han}', "");
    Expect(1, 195102, '\p{^Is_Script=han}', "");
    Expect(1, 195102, '\P{Is_Script=han}', "");
    Expect(0, 195102, '\P{^Is_Script=han}', "");
    Expect(1, 195101, '\p{Is_Script=- han}', "");
    Expect(0, 195101, '\p{^Is_Script=- han}', "");
    Expect(0, 195101, '\P{Is_Script=- han}', "");
    Expect(1, 195101, '\P{^Is_Script=- han}', "");
    Expect(0, 195102, '\p{Is_Script=- han}', "");
    Expect(1, 195102, '\p{^Is_Script=- han}', "");
    Expect(1, 195102, '\P{Is_Script=- han}', "");
    Expect(0, 195102, '\P{^Is_Script=- han}', "");
    Error('\p{Is_Sc=:=Hani}');
    Error('\P{Is_Sc=:=Hani}');
    Expect(1, 195101, '\p{Is_Sc=hani}', "");
    Expect(0, 195101, '\p{^Is_Sc=hani}', "");
    Expect(0, 195101, '\P{Is_Sc=hani}', "");
    Expect(1, 195101, '\P{^Is_Sc=hani}', "");
    Expect(0, 195102, '\p{Is_Sc=hani}', "");
    Expect(1, 195102, '\p{^Is_Sc=hani}', "");
    Expect(1, 195102, '\P{Is_Sc=hani}', "");
    Expect(0, 195102, '\P{^Is_Sc=hani}', "");
    Expect(1, 195101, '\p{Is_Sc=-HANI}', "");
    Expect(0, 195101, '\p{^Is_Sc=-HANI}', "");
    Expect(0, 195101, '\P{Is_Sc=-HANI}', "");
    Expect(1, 195101, '\P{^Is_Sc=-HANI}', "");
    Expect(0, 195102, '\p{Is_Sc=-HANI}', "");
    Expect(1, 195102, '\p{^Is_Sc=-HANI}', "");
    Expect(1, 195102, '\P{Is_Sc=-HANI}', "");
    Expect(0, 195102, '\P{^Is_Sc=-HANI}', "");
    Error('\p{Script=/a/- HANUNOO}');
    Error('\P{Script=/a/- HANUNOO}');
    Expect(1, 5940, '\p{Script=:\AHanunoo\z:}', "");;
    Expect(0, 5941, '\p{Script=:\AHanunoo\z:}', "");;
    Expect(1, 5940, '\p{Script=hanunoo}', "");
    Expect(0, 5940, '\p{^Script=hanunoo}', "");
    Expect(0, 5940, '\P{Script=hanunoo}', "");
    Expect(1, 5940, '\P{^Script=hanunoo}', "");
    Expect(0, 5941, '\p{Script=hanunoo}', "");
    Expect(1, 5941, '\p{^Script=hanunoo}', "");
    Expect(1, 5941, '\P{Script=hanunoo}', "");
    Expect(0, 5941, '\P{^Script=hanunoo}', "");
    Expect(1, 5940, '\p{Script=:\Ahanunoo\z:}', "");;
    Expect(0, 5941, '\p{Script=:\Ahanunoo\z:}', "");;
    Expect(1, 5940, '\p{Script= _Hanunoo}', "");
    Expect(0, 5940, '\p{^Script= _Hanunoo}', "");
    Expect(0, 5940, '\P{Script= _Hanunoo}', "");
    Expect(1, 5940, '\P{^Script= _Hanunoo}', "");
    Expect(0, 5941, '\p{Script= _Hanunoo}', "");
    Expect(1, 5941, '\p{^Script= _Hanunoo}', "");
    Expect(1, 5941, '\P{Script= _Hanunoo}', "");
    Expect(0, 5941, '\P{^Script= _Hanunoo}', "");
    Error('\p{Sc= hano/a/}');
    Error('\P{Sc= hano/a/}');
    Expect(1, 5940, '\p{Sc=:\AHano\z:}', "");;
    Expect(0, 5941, '\p{Sc=:\AHano\z:}', "");;
    Expect(1, 5940, '\p{Sc=hano}', "");
    Expect(0, 5940, '\p{^Sc=hano}', "");
    Expect(0, 5940, '\P{Sc=hano}', "");
    Expect(1, 5940, '\P{^Sc=hano}', "");
    Expect(0, 5941, '\p{Sc=hano}', "");
    Expect(1, 5941, '\p{^Sc=hano}', "");
    Expect(1, 5941, '\P{Sc=hano}', "");
    Expect(0, 5941, '\P{^Sc=hano}', "");
    Expect(1, 5940, '\p{Sc=:\Ahano\z:}', "");;
    Expect(0, 5941, '\p{Sc=:\Ahano\z:}', "");;
    Expect(1, 5940, '\p{Sc=_Hano}', "");
    Expect(0, 5940, '\p{^Sc=_Hano}', "");
    Expect(0, 5940, '\P{Sc=_Hano}', "");
    Expect(1, 5940, '\P{^Sc=_Hano}', "");
    Expect(0, 5941, '\p{Sc=_Hano}', "");
    Expect(1, 5941, '\p{^Sc=_Hano}', "");
    Expect(1, 5941, '\P{Sc=_Hano}', "");
    Expect(0, 5941, '\P{^Sc=_Hano}', "");
    Error('\p{Is_Script=_:=HANUNOO}');
    Error('\P{Is_Script=_:=HANUNOO}');
    Expect(1, 5940, '\p{Is_Script=hanunoo}', "");
    Expect(0, 5940, '\p{^Is_Script=hanunoo}', "");
    Expect(0, 5940, '\P{Is_Script=hanunoo}', "");
    Expect(1, 5940, '\P{^Is_Script=hanunoo}', "");
    Expect(0, 5941, '\p{Is_Script=hanunoo}', "");
    Expect(1, 5941, '\p{^Is_Script=hanunoo}', "");
    Expect(1, 5941, '\P{Is_Script=hanunoo}', "");
    Expect(0, 5941, '\P{^Is_Script=hanunoo}', "");
    Expect(1, 5940, '\p{Is_Script=__hanunoo}', "");
    Expect(0, 5940, '\p{^Is_Script=__hanunoo}', "");
    Expect(0, 5940, '\P{Is_Script=__hanunoo}', "");
    Expect(1, 5940, '\P{^Is_Script=__hanunoo}', "");
    Expect(0, 5941, '\p{Is_Script=__hanunoo}', "");
    Expect(1, 5941, '\p{^Is_Script=__hanunoo}', "");
    Expect(1, 5941, '\P{Is_Script=__hanunoo}', "");
    Expect(0, 5941, '\P{^Is_Script=__hanunoo}', "");
    Error('\p{Is_Sc=/a/ _Hano}');
    Error('\P{Is_Sc=/a/ _Hano}');
    Expect(1, 5940, '\p{Is_Sc=hano}', "");
    Expect(0, 5940, '\p{^Is_Sc=hano}', "");
    Expect(0, 5940, '\P{Is_Sc=hano}', "");
    Expect(1, 5940, '\P{^Is_Sc=hano}', "");
    Expect(0, 5941, '\p{Is_Sc=hano}', "");
    Expect(1, 5941, '\p{^Is_Sc=hano}', "");
    Expect(1, 5941, '\P{Is_Sc=hano}', "");
    Expect(0, 5941, '\P{^Is_Sc=hano}', "");
    Expect(1, 5940, '\p{Is_Sc=	HANO}', "");
    Expect(0, 5940, '\p{^Is_Sc=	HANO}', "");
    Expect(0, 5940, '\P{Is_Sc=	HANO}', "");
    Expect(1, 5940, '\P{^Is_Sc=	HANO}', "");
    Expect(0, 5941, '\p{Is_Sc=	HANO}', "");
    Expect(1, 5941, '\p{^Is_Sc=	HANO}', "");
    Expect(1, 5941, '\P{Is_Sc=	HANO}', "");
    Expect(0, 5941, '\P{^Is_Sc=	HANO}', "");
    Error('\p{Script=-_Hatran:=}');
    Error('\P{Script=-_Hatran:=}');
    Expect(1, 67839, '\p{Script=:\AHatran\z:}', "");;
    Expect(0, 67840, '\p{Script=:\AHatran\z:}', "");;
    Expect(1, 67839, '\p{Script=hatran}', "");
    Expect(0, 67839, '\p{^Script=hatran}', "");
    Expect(0, 67839, '\P{Script=hatran}', "");
    Expect(1, 67839, '\P{^Script=hatran}', "");
    Expect(0, 67840, '\p{Script=hatran}', "");
    Expect(1, 67840, '\p{^Script=hatran}', "");
    Expect(1, 67840, '\P{Script=hatran}', "");
    Expect(0, 67840, '\P{^Script=hatran}', "");
    Expect(1, 67839, '\p{Script=:\Ahatran\z:}', "");;
    Expect(0, 67840, '\p{Script=:\Ahatran\z:}', "");;
    Expect(1, 67839, '\p{Script= -Hatran}', "");
    Expect(0, 67839, '\p{^Script= -Hatran}', "");
    Expect(0, 67839, '\P{Script= -Hatran}', "");
    Expect(1, 67839, '\P{^Script= -Hatran}', "");
    Expect(0, 67840, '\p{Script= -Hatran}', "");
    Expect(1, 67840, '\p{^Script= -Hatran}', "");
    Expect(1, 67840, '\P{Script= -Hatran}', "");
    Expect(0, 67840, '\P{^Script= -Hatran}', "");
    Error('\p{Sc=--HATR:=}');
    Error('\P{Sc=--HATR:=}');
    Expect(1, 67839, '\p{Sc=:\AHatr\z:}', "");;
    Expect(0, 67840, '\p{Sc=:\AHatr\z:}', "");;
    Expect(1, 67839, '\p{Sc=hatr}', "");
    Expect(0, 67839, '\p{^Sc=hatr}', "");
    Expect(0, 67839, '\P{Sc=hatr}', "");
    Expect(1, 67839, '\P{^Sc=hatr}', "");
    Expect(0, 67840, '\p{Sc=hatr}', "");
    Expect(1, 67840, '\p{^Sc=hatr}', "");
    Expect(1, 67840, '\P{Sc=hatr}', "");
    Expect(0, 67840, '\P{^Sc=hatr}', "");
    Expect(1, 67839, '\p{Sc=:\Ahatr\z:}', "");;
    Expect(0, 67840, '\p{Sc=:\Ahatr\z:}', "");;
    Expect(1, 67839, '\p{Sc=	-hatr}', "");
    Expect(0, 67839, '\p{^Sc=	-hatr}', "");
    Expect(0, 67839, '\P{Sc=	-hatr}', "");
    Expect(1, 67839, '\P{^Sc=	-hatr}', "");
    Expect(0, 67840, '\p{Sc=	-hatr}', "");
    Expect(1, 67840, '\p{^Sc=	-hatr}', "");
    Expect(1, 67840, '\P{Sc=	-hatr}', "");
    Expect(0, 67840, '\P{^Sc=	-hatr}', "");
    Error('\p{Is_Script= :=HATRAN}');
    Error('\P{Is_Script= :=HATRAN}');
    Expect(1, 67839, '\p{Is_Script=hatran}', "");
    Expect(0, 67839, '\p{^Is_Script=hatran}', "");
    Expect(0, 67839, '\P{Is_Script=hatran}', "");
    Expect(1, 67839, '\P{^Is_Script=hatran}', "");
    Expect(0, 67840, '\p{Is_Script=hatran}', "");
    Expect(1, 67840, '\p{^Is_Script=hatran}', "");
    Expect(1, 67840, '\P{Is_Script=hatran}', "");
    Expect(0, 67840, '\P{^Is_Script=hatran}', "");
    Expect(1, 67839, '\p{Is_Script=_-Hatran}', "");
    Expect(0, 67839, '\p{^Is_Script=_-Hatran}', "");
    Expect(0, 67839, '\P{Is_Script=_-Hatran}', "");
    Expect(1, 67839, '\P{^Is_Script=_-Hatran}', "");
    Expect(0, 67840, '\p{Is_Script=_-Hatran}', "");
    Expect(1, 67840, '\p{^Is_Script=_-Hatran}', "");
    Expect(1, 67840, '\P{Is_Script=_-Hatran}', "");
    Expect(0, 67840, '\P{^Is_Script=_-Hatran}', "");
    Error('\p{Is_Sc=	Hatr:=}');
    Error('\P{Is_Sc=	Hatr:=}');
    Expect(1, 67839, '\p{Is_Sc=hatr}', "");
    Expect(0, 67839, '\p{^Is_Sc=hatr}', "");
    Expect(0, 67839, '\P{Is_Sc=hatr}', "");
    Expect(1, 67839, '\P{^Is_Sc=hatr}', "");
    Expect(0, 67840, '\p{Is_Sc=hatr}', "");
    Expect(1, 67840, '\p{^Is_Sc=hatr}', "");
    Expect(1, 67840, '\P{Is_Sc=hatr}', "");
    Expect(0, 67840, '\P{^Is_Sc=hatr}', "");
    Expect(1, 67839, '\p{Is_Sc= _hatr}', "");
    Expect(0, 67839, '\p{^Is_Sc= _hatr}', "");
    Expect(0, 67839, '\P{Is_Sc= _hatr}', "");
    Expect(1, 67839, '\P{^Is_Sc= _hatr}', "");
    Expect(0, 67840, '\p{Is_Sc= _hatr}', "");
    Expect(1, 67840, '\p{^Is_Sc= _hatr}', "");
    Expect(1, 67840, '\P{Is_Sc= _hatr}', "");
    Expect(0, 67840, '\P{^Is_Sc= _hatr}', "");
    Error('\p{Script=/a/-hebrew}');
    Error('\P{Script=/a/-hebrew}');
    Expect(1, 64335, '\p{Script=:\AHebrew\z:}', "");;
    Expect(0, 64336, '\p{Script=:\AHebrew\z:}', "");;
    Expect(1, 64335, '\p{Script=hebrew}', "");
    Expect(0, 64335, '\p{^Script=hebrew}', "");
    Expect(0, 64335, '\P{Script=hebrew}', "");
    Expect(1, 64335, '\P{^Script=hebrew}', "");
    Expect(0, 64336, '\p{Script=hebrew}', "");
    Expect(1, 64336, '\p{^Script=hebrew}', "");
    Expect(1, 64336, '\P{Script=hebrew}', "");
    Expect(0, 64336, '\P{^Script=hebrew}', "");
    Expect(1, 64335, '\p{Script=:\Ahebrew\z:}', "");;
    Expect(0, 64336, '\p{Script=:\Ahebrew\z:}', "");;
    Expect(1, 64335, '\p{Script=_Hebrew}', "");
    Expect(0, 64335, '\p{^Script=_Hebrew}', "");
    Expect(0, 64335, '\P{Script=_Hebrew}', "");
    Expect(1, 64335, '\P{^Script=_Hebrew}', "");
    Expect(0, 64336, '\p{Script=_Hebrew}', "");
    Expect(1, 64336, '\p{^Script=_Hebrew}', "");
    Expect(1, 64336, '\P{Script=_Hebrew}', "");
    Expect(0, 64336, '\P{^Script=_Hebrew}', "");
    Error('\p{Sc=:=_HEBR}');
    Error('\P{Sc=:=_HEBR}');
    Expect(1, 64335, '\p{Sc=:\AHebr\z:}', "");;
    Expect(0, 64336, '\p{Sc=:\AHebr\z:}', "");;
    Expect(1, 64335, '\p{Sc=hebr}', "");
    Expect(0, 64335, '\p{^Sc=hebr}', "");
    Expect(0, 64335, '\P{Sc=hebr}', "");
    Expect(1, 64335, '\P{^Sc=hebr}', "");
    Expect(0, 64336, '\p{Sc=hebr}', "");
    Expect(1, 64336, '\p{^Sc=hebr}', "");
    Expect(1, 64336, '\P{Sc=hebr}', "");
    Expect(0, 64336, '\P{^Sc=hebr}', "");
    Expect(1, 64335, '\p{Sc=:\Ahebr\z:}', "");;
    Expect(0, 64336, '\p{Sc=:\Ahebr\z:}', "");;
    Expect(1, 64335, '\p{Sc=-Hebr}', "");
    Expect(0, 64335, '\p{^Sc=-Hebr}', "");
    Expect(0, 64335, '\P{Sc=-Hebr}', "");
    Expect(1, 64335, '\P{^Sc=-Hebr}', "");
    Expect(0, 64336, '\p{Sc=-Hebr}', "");
    Expect(1, 64336, '\p{^Sc=-Hebr}', "");
    Expect(1, 64336, '\P{Sc=-Hebr}', "");
    Expect(0, 64336, '\P{^Sc=-Hebr}', "");
    Error('\p{Is_Script=	 Hebrew:=}');
    Error('\P{Is_Script=	 Hebrew:=}');
    Expect(1, 64335, '\p{Is_Script=hebrew}', "");
    Expect(0, 64335, '\p{^Is_Script=hebrew}', "");
    Expect(0, 64335, '\P{Is_Script=hebrew}', "");
    Expect(1, 64335, '\P{^Is_Script=hebrew}', "");
    Expect(0, 64336, '\p{Is_Script=hebrew}', "");
    Expect(1, 64336, '\p{^Is_Script=hebrew}', "");
    Expect(1, 64336, '\P{Is_Script=hebrew}', "");
    Expect(0, 64336, '\P{^Is_Script=hebrew}', "");
    Expect(1, 64335, '\p{Is_Script=	-Hebrew}', "");
    Expect(0, 64335, '\p{^Is_Script=	-Hebrew}', "");
    Expect(0, 64335, '\P{Is_Script=	-Hebrew}', "");
    Expect(1, 64335, '\P{^Is_Script=	-Hebrew}', "");
    Expect(0, 64336, '\p{Is_Script=	-Hebrew}', "");
    Expect(1, 64336, '\p{^Is_Script=	-Hebrew}', "");
    Expect(1, 64336, '\P{Is_Script=	-Hebrew}', "");
    Expect(0, 64336, '\P{^Is_Script=	-Hebrew}', "");
    Error('\p{Is_Sc=	/a/hebr}');
    Error('\P{Is_Sc=	/a/hebr}');
    Expect(1, 64335, '\p{Is_Sc=hebr}', "");
    Expect(0, 64335, '\p{^Is_Sc=hebr}', "");
    Expect(0, 64335, '\P{Is_Sc=hebr}', "");
    Expect(1, 64335, '\P{^Is_Sc=hebr}', "");
    Expect(0, 64336, '\p{Is_Sc=hebr}', "");
    Expect(1, 64336, '\p{^Is_Sc=hebr}', "");
    Expect(1, 64336, '\P{Is_Sc=hebr}', "");
    Expect(0, 64336, '\P{^Is_Sc=hebr}', "");
    Expect(1, 64335, '\p{Is_Sc: -Hebr}', "");
    Expect(0, 64335, '\p{^Is_Sc: -Hebr}', "");
    Expect(0, 64335, '\P{Is_Sc: -Hebr}', "");
    Expect(1, 64335, '\P{^Is_Sc: -Hebr}', "");
    Expect(0, 64336, '\p{Is_Sc: -Hebr}', "");
    Expect(1, 64336, '\p{^Is_Sc: -Hebr}', "");
    Expect(1, 64336, '\P{Is_Sc: -Hebr}', "");
    Expect(0, 64336, '\P{^Is_Sc: -Hebr}', "");
    Error('\p{Script=:=HIRAGANA}');
    Error('\P{Script=:=HIRAGANA}');
    Expect(1, 127488, '\p{Script=:\AHiragana\z:}', "");;
    Expect(0, 127489, '\p{Script=:\AHiragana\z:}', "");;
    Expect(1, 127488, '\p{Script=hiragana}', "");
    Expect(0, 127488, '\p{^Script=hiragana}', "");
    Expect(0, 127488, '\P{Script=hiragana}', "");
    Expect(1, 127488, '\P{^Script=hiragana}', "");
    Expect(0, 127489, '\p{Script=hiragana}', "");
    Expect(1, 127489, '\p{^Script=hiragana}', "");
    Expect(1, 127489, '\P{Script=hiragana}', "");
    Expect(0, 127489, '\P{^Script=hiragana}', "");
    Expect(1, 127488, '\p{Script=:\Ahiragana\z:}', "");;
    Expect(0, 127489, '\p{Script=:\Ahiragana\z:}', "");;
    Expect(1, 127488, '\p{Script: 	Hiragana}', "");
    Expect(0, 127488, '\p{^Script: 	Hiragana}', "");
    Expect(0, 127488, '\P{Script: 	Hiragana}', "");
    Expect(1, 127488, '\P{^Script: 	Hiragana}', "");
    Expect(0, 127489, '\p{Script: 	Hiragana}', "");
    Expect(1, 127489, '\p{^Script: 	Hiragana}', "");
    Expect(1, 127489, '\P{Script: 	Hiragana}', "");
    Expect(0, 127489, '\P{^Script: 	Hiragana}', "");
    Error('\p{Sc=:=-hira}');
    Error('\P{Sc=:=-hira}');
    Expect(1, 127488, '\p{Sc=:\AHira\z:}', "");;
    Expect(0, 127489, '\p{Sc=:\AHira\z:}', "");;
    Expect(1, 127488, '\p{Sc=hira}', "");
    Expect(0, 127488, '\p{^Sc=hira}', "");
    Expect(0, 127488, '\P{Sc=hira}', "");
    Expect(1, 127488, '\P{^Sc=hira}', "");
    Expect(0, 127489, '\p{Sc=hira}', "");
    Expect(1, 127489, '\p{^Sc=hira}', "");
    Expect(1, 127489, '\P{Sc=hira}', "");
    Expect(0, 127489, '\P{^Sc=hira}', "");
    Expect(1, 127488, '\p{Sc=:\Ahira\z:}', "");;
    Expect(0, 127489, '\p{Sc=:\Ahira\z:}', "");;
    Expect(1, 127488, '\p{Sc=	HIRA}', "");
    Expect(0, 127488, '\p{^Sc=	HIRA}', "");
    Expect(0, 127488, '\P{Sc=	HIRA}', "");
    Expect(1, 127488, '\P{^Sc=	HIRA}', "");
    Expect(0, 127489, '\p{Sc=	HIRA}', "");
    Expect(1, 127489, '\p{^Sc=	HIRA}', "");
    Expect(1, 127489, '\P{Sc=	HIRA}', "");
    Expect(0, 127489, '\P{^Sc=	HIRA}', "");
    Error('\p{Is_Script= /a/Hiragana}');
    Error('\P{Is_Script= /a/Hiragana}');
    Expect(1, 127488, '\p{Is_Script=hiragana}', "");
    Expect(0, 127488, '\p{^Is_Script=hiragana}', "");
    Expect(0, 127488, '\P{Is_Script=hiragana}', "");
    Expect(1, 127488, '\P{^Is_Script=hiragana}', "");
    Expect(0, 127489, '\p{Is_Script=hiragana}', "");
    Expect(1, 127489, '\p{^Is_Script=hiragana}', "");
    Expect(1, 127489, '\P{Is_Script=hiragana}', "");
    Expect(0, 127489, '\P{^Is_Script=hiragana}', "");
    Expect(1, 127488, '\p{Is_Script=_ Hiragana}', "");
    Expect(0, 127488, '\p{^Is_Script=_ Hiragana}', "");
    Expect(0, 127488, '\P{Is_Script=_ Hiragana}', "");
    Expect(1, 127488, '\P{^Is_Script=_ Hiragana}', "");
    Expect(0, 127489, '\p{Is_Script=_ Hiragana}', "");
    Expect(1, 127489, '\p{^Is_Script=_ Hiragana}', "");
    Expect(1, 127489, '\P{Is_Script=_ Hiragana}', "");
    Expect(0, 127489, '\P{^Is_Script=_ Hiragana}', "");
    Error('\p{Is_Sc=/a/--Hira}');
    Error('\P{Is_Sc=/a/--Hira}');
    Expect(1, 127488, '\p{Is_Sc=hira}', "");
    Expect(0, 127488, '\p{^Is_Sc=hira}', "");
    Expect(0, 127488, '\P{Is_Sc=hira}', "");
    Expect(1, 127488, '\P{^Is_Sc=hira}', "");
    Expect(0, 127489, '\p{Is_Sc=hira}', "");
    Expect(1, 127489, '\p{^Is_Sc=hira}', "");
    Expect(1, 127489, '\P{Is_Sc=hira}', "");
    Expect(0, 127489, '\P{^Is_Sc=hira}', "");
    Expect(1, 127488, '\p{Is_Sc=-	Hira}', "");
    Expect(0, 127488, '\p{^Is_Sc=-	Hira}', "");
    Expect(0, 127488, '\P{Is_Sc=-	Hira}', "");
    Expect(1, 127488, '\P{^Is_Sc=-	Hira}', "");
    Expect(0, 127489, '\p{Is_Sc=-	Hira}', "");
    Expect(1, 127489, '\p{^Is_Sc=-	Hira}', "");
    Expect(1, 127489, '\P{Is_Sc=-	Hira}', "");
    Expect(0, 127489, '\P{^Is_Sc=-	Hira}', "");
    Error('\p{Script=	:=Anatolian_Hieroglyphs}');
    Error('\P{Script=	:=Anatolian_Hieroglyphs}');
    Expect(1, 83526, '\p{Script=:\AAnatolian_Hieroglyphs\z:}', "");;
    Expect(0, 83527, '\p{Script=:\AAnatolian_Hieroglyphs\z:}', "");;
    Expect(1, 83526, '\p{Script=anatolianhieroglyphs}', "");
    Expect(0, 83526, '\p{^Script=anatolianhieroglyphs}', "");
    Expect(0, 83526, '\P{Script=anatolianhieroglyphs}', "");
    Expect(1, 83526, '\P{^Script=anatolianhieroglyphs}', "");
    Expect(0, 83527, '\p{Script=anatolianhieroglyphs}', "");
    Expect(1, 83527, '\p{^Script=anatolianhieroglyphs}', "");
    Expect(1, 83527, '\P{Script=anatolianhieroglyphs}', "");
    Expect(0, 83527, '\P{^Script=anatolianhieroglyphs}', "");
    Expect(1, 83526, '\p{Script=:\Aanatolianhieroglyphs\z:}', "");;
    Expect(0, 83527, '\p{Script=:\Aanatolianhieroglyphs\z:}', "");;
    Expect(1, 83526, '\p{Script=_anatolian_Hieroglyphs}', "");
    Expect(0, 83526, '\p{^Script=_anatolian_Hieroglyphs}', "");
    Expect(0, 83526, '\P{Script=_anatolian_Hieroglyphs}', "");
    Expect(1, 83526, '\P{^Script=_anatolian_Hieroglyphs}', "");
    Expect(0, 83527, '\p{Script=_anatolian_Hieroglyphs}', "");
    Expect(1, 83527, '\p{^Script=_anatolian_Hieroglyphs}', "");
    Expect(1, 83527, '\P{Script=_anatolian_Hieroglyphs}', "");
    Expect(0, 83527, '\P{^Script=_anatolian_Hieroglyphs}', "");
    Error('\p{Sc= HLUW:=}');
    Error('\P{Sc= HLUW:=}');
    Expect(1, 83526, '\p{Sc=:\AHluw\z:}', "");;
    Expect(0, 83527, '\p{Sc=:\AHluw\z:}', "");;
    Expect(1, 83526, '\p{Sc=hluw}', "");
    Expect(0, 83526, '\p{^Sc=hluw}', "");
    Expect(0, 83526, '\P{Sc=hluw}', "");
    Expect(1, 83526, '\P{^Sc=hluw}', "");
    Expect(0, 83527, '\p{Sc=hluw}', "");
    Expect(1, 83527, '\p{^Sc=hluw}', "");
    Expect(1, 83527, '\P{Sc=hluw}', "");
    Expect(0, 83527, '\P{^Sc=hluw}', "");
    Expect(1, 83526, '\p{Sc=:\Ahluw\z:}', "");;
    Expect(0, 83527, '\p{Sc=:\Ahluw\z:}', "");;
    Expect(1, 83526, '\p{Sc:    HLUW}', "");
    Expect(0, 83526, '\p{^Sc:    HLUW}', "");
    Expect(0, 83526, '\P{Sc:    HLUW}', "");
    Expect(1, 83526, '\P{^Sc:    HLUW}', "");
    Expect(0, 83527, '\p{Sc:    HLUW}', "");
    Expect(1, 83527, '\p{^Sc:    HLUW}', "");
    Expect(1, 83527, '\P{Sc:    HLUW}', "");
    Expect(0, 83527, '\P{^Sc:    HLUW}', "");
    Error('\p{Is_Script=	/a/ANATOLIAN_Hieroglyphs}');
    Error('\P{Is_Script=	/a/ANATOLIAN_Hieroglyphs}');
    Expect(1, 83526, '\p{Is_Script: anatolianhieroglyphs}', "");
    Expect(0, 83526, '\p{^Is_Script: anatolianhieroglyphs}', "");
    Expect(0, 83526, '\P{Is_Script: anatolianhieroglyphs}', "");
    Expect(1, 83526, '\P{^Is_Script: anatolianhieroglyphs}', "");
    Expect(0, 83527, '\p{Is_Script: anatolianhieroglyphs}', "");
    Expect(1, 83527, '\p{^Is_Script: anatolianhieroglyphs}', "");
    Expect(1, 83527, '\P{Is_Script: anatolianhieroglyphs}', "");
    Expect(0, 83527, '\P{^Is_Script: anatolianhieroglyphs}', "");
    Expect(1, 83526, '\p{Is_Script=_-ANATOLIAN_Hieroglyphs}', "");
    Expect(0, 83526, '\p{^Is_Script=_-ANATOLIAN_Hieroglyphs}', "");
    Expect(0, 83526, '\P{Is_Script=_-ANATOLIAN_Hieroglyphs}', "");
    Expect(1, 83526, '\P{^Is_Script=_-ANATOLIAN_Hieroglyphs}', "");
    Expect(0, 83527, '\p{Is_Script=_-ANATOLIAN_Hieroglyphs}', "");
    Expect(1, 83527, '\p{^Is_Script=_-ANATOLIAN_Hieroglyphs}', "");
    Expect(1, 83527, '\P{Is_Script=_-ANATOLIAN_Hieroglyphs}', "");
    Expect(0, 83527, '\P{^Is_Script=_-ANATOLIAN_Hieroglyphs}', "");
    Error('\p{Is_Sc=:= _Hluw}');
    Error('\P{Is_Sc=:= _Hluw}');
    Expect(1, 83526, '\p{Is_Sc=hluw}', "");
    Expect(0, 83526, '\p{^Is_Sc=hluw}', "");
    Expect(0, 83526, '\P{Is_Sc=hluw}', "");
    Expect(1, 83526, '\P{^Is_Sc=hluw}', "");
    Expect(0, 83527, '\p{Is_Sc=hluw}', "");
    Expect(1, 83527, '\p{^Is_Sc=hluw}', "");
    Expect(1, 83527, '\P{Is_Sc=hluw}', "");
    Expect(0, 83527, '\P{^Is_Sc=hluw}', "");
    Expect(1, 83526, '\p{Is_Sc= 	hluw}', "");
    Expect(0, 83526, '\p{^Is_Sc= 	hluw}', "");
    Expect(0, 83526, '\P{Is_Sc= 	hluw}', "");
    Expect(1, 83526, '\P{^Is_Sc= 	hluw}', "");
    Expect(0, 83527, '\p{Is_Sc= 	hluw}', "");
    Expect(1, 83527, '\p{^Is_Sc= 	hluw}', "");
    Expect(1, 83527, '\P{Is_Sc= 	hluw}', "");
    Expect(0, 83527, '\P{^Is_Sc= 	hluw}', "");
    Error('\p{Script=_Pahawh_HMONG/a/}');
    Error('\P{Script=_Pahawh_HMONG/a/}');
    Expect(1, 93071, '\p{Script=:\APahawh_Hmong\z:}', "");;
    Expect(0, 93072, '\p{Script=:\APahawh_Hmong\z:}', "");;
    Expect(1, 93071, '\p{Script=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Script=pahawhhmong}', "");
    Expect(0, 93071, '\P{Script=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Script=pahawhhmong}', "");
    Expect(0, 93072, '\p{Script=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Script=pahawhhmong}', "");
    Expect(1, 93072, '\P{Script=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Script=pahawhhmong}', "");
    Expect(1, 93071, '\p{Script=:\Apahawhhmong\z:}', "");;
    Expect(0, 93072, '\p{Script=:\Apahawhhmong\z:}', "");;
    Expect(1, 93071, '\p{Script=__PAHAWH_hmong}', "");
    Expect(0, 93071, '\p{^Script=__PAHAWH_hmong}', "");
    Expect(0, 93071, '\P{Script=__PAHAWH_hmong}', "");
    Expect(1, 93071, '\P{^Script=__PAHAWH_hmong}', "");
    Expect(0, 93072, '\p{Script=__PAHAWH_hmong}', "");
    Expect(1, 93072, '\p{^Script=__PAHAWH_hmong}', "");
    Expect(1, 93072, '\P{Script=__PAHAWH_hmong}', "");
    Expect(0, 93072, '\P{^Script=__PAHAWH_hmong}', "");
    Error('\p{Sc= hmng:=}');
    Error('\P{Sc= hmng:=}');
    Expect(1, 93071, '\p{Sc=:\AHmng\z:}', "");;
    Expect(0, 93072, '\p{Sc=:\AHmng\z:}', "");;
    Expect(1, 93071, '\p{Sc=hmng}', "");
    Expect(0, 93071, '\p{^Sc=hmng}', "");
    Expect(0, 93071, '\P{Sc=hmng}', "");
    Expect(1, 93071, '\P{^Sc=hmng}', "");
    Expect(0, 93072, '\p{Sc=hmng}', "");
    Expect(1, 93072, '\p{^Sc=hmng}', "");
    Expect(1, 93072, '\P{Sc=hmng}', "");
    Expect(0, 93072, '\P{^Sc=hmng}', "");
    Expect(1, 93071, '\p{Sc=:\Ahmng\z:}', "");;
    Expect(0, 93072, '\p{Sc=:\Ahmng\z:}', "");;
    Expect(1, 93071, '\p{Sc= 	Hmng}', "");
    Expect(0, 93071, '\p{^Sc= 	Hmng}', "");
    Expect(0, 93071, '\P{Sc= 	Hmng}', "");
    Expect(1, 93071, '\P{^Sc= 	Hmng}', "");
    Expect(0, 93072, '\p{Sc= 	Hmng}', "");
    Expect(1, 93072, '\p{^Sc= 	Hmng}', "");
    Expect(1, 93072, '\P{Sc= 	Hmng}', "");
    Expect(0, 93072, '\P{^Sc= 	Hmng}', "");
    Error('\p{Is_Script=-/a/Pahawh_Hmong}');
    Error('\P{Is_Script=-/a/Pahawh_Hmong}');
    Expect(1, 93071, '\p{Is_Script=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Is_Script=pahawhhmong}', "");
    Expect(0, 93071, '\P{Is_Script=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Is_Script=pahawhhmong}', "");
    Expect(0, 93072, '\p{Is_Script=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Is_Script=pahawhhmong}', "");
    Expect(1, 93072, '\P{Is_Script=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Is_Script=pahawhhmong}', "");
    Expect(1, 93071, '\p{Is_Script=-_pahawh_Hmong}', "");
    Expect(0, 93071, '\p{^Is_Script=-_pahawh_Hmong}', "");
    Expect(0, 93071, '\P{Is_Script=-_pahawh_Hmong}', "");
    Expect(1, 93071, '\P{^Is_Script=-_pahawh_Hmong}', "");
    Expect(0, 93072, '\p{Is_Script=-_pahawh_Hmong}', "");
    Expect(1, 93072, '\p{^Is_Script=-_pahawh_Hmong}', "");
    Expect(1, 93072, '\P{Is_Script=-_pahawh_Hmong}', "");
    Expect(0, 93072, '\P{^Is_Script=-_pahawh_Hmong}', "");
    Error('\p{Is_Sc=/a/--Hmng}');
    Error('\P{Is_Sc=/a/--Hmng}');
    Expect(1, 93071, '\p{Is_Sc=hmng}', "");
    Expect(0, 93071, '\p{^Is_Sc=hmng}', "");
    Expect(0, 93071, '\P{Is_Sc=hmng}', "");
    Expect(1, 93071, '\P{^Is_Sc=hmng}', "");
    Expect(0, 93072, '\p{Is_Sc=hmng}', "");
    Expect(1, 93072, '\p{^Is_Sc=hmng}', "");
    Expect(1, 93072, '\P{Is_Sc=hmng}', "");
    Expect(0, 93072, '\P{^Is_Sc=hmng}', "");
    Expect(1, 93071, '\p{Is_Sc=--HMNG}', "");
    Expect(0, 93071, '\p{^Is_Sc=--HMNG}', "");
    Expect(0, 93071, '\P{Is_Sc=--HMNG}', "");
    Expect(1, 93071, '\P{^Is_Sc=--HMNG}', "");
    Expect(0, 93072, '\p{Is_Sc=--HMNG}', "");
    Expect(1, 93072, '\p{^Is_Sc=--HMNG}', "");
    Expect(1, 93072, '\P{Is_Sc=--HMNG}', "");
    Expect(0, 93072, '\P{^Is_Sc=--HMNG}', "");
    Error('\p{Script:-NYIAKENG_Puachue_HMONG/a/}');
    Error('\P{Script:-NYIAKENG_Puachue_HMONG/a/}');
    Expect(1, 123215, '\p{Script=:\ANyiakeng_Puachue_Hmong\z:}', "");;
    Expect(0, 123216, '\p{Script=:\ANyiakeng_Puachue_Hmong\z:}', "");;
    Expect(1, 123215, '\p{Script=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^Script=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{Script=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^Script=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{Script=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^Script=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{Script=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^Script=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{Script=:\Anyiakengpuachuehmong\z:}', "");;
    Expect(0, 123216, '\p{Script=:\Anyiakengpuachuehmong\z:}', "");;
    Expect(1, 123215, '\p{Script=_nyiakeng_puachue_Hmong}', "");
    Expect(0, 123215, '\p{^Script=_nyiakeng_puachue_Hmong}', "");
    Expect(0, 123215, '\P{Script=_nyiakeng_puachue_Hmong}', "");
    Expect(1, 123215, '\P{^Script=_nyiakeng_puachue_Hmong}', "");
    Expect(0, 123216, '\p{Script=_nyiakeng_puachue_Hmong}', "");
    Expect(1, 123216, '\p{^Script=_nyiakeng_puachue_Hmong}', "");
    Expect(1, 123216, '\P{Script=_nyiakeng_puachue_Hmong}', "");
    Expect(0, 123216, '\P{^Script=_nyiakeng_puachue_Hmong}', "");
    Error('\p{Sc=_HMNP:=}');
    Error('\P{Sc=_HMNP:=}');
    Expect(1, 123215, '\p{Sc=:\AHmnp\z:}', "");;
    Expect(0, 123216, '\p{Sc=:\AHmnp\z:}', "");;
    Expect(1, 123215, '\p{Sc:	hmnp}', "");
    Expect(0, 123215, '\p{^Sc:	hmnp}', "");
    Expect(0, 123215, '\P{Sc:	hmnp}', "");
    Expect(1, 123215, '\P{^Sc:	hmnp}', "");
    Expect(0, 123216, '\p{Sc:	hmnp}', "");
    Expect(1, 123216, '\p{^Sc:	hmnp}', "");
    Expect(1, 123216, '\P{Sc:	hmnp}', "");
    Expect(0, 123216, '\P{^Sc:	hmnp}', "");
    Expect(1, 123215, '\p{Sc=:\Ahmnp\z:}', "");;
    Expect(0, 123216, '\p{Sc=:\Ahmnp\z:}', "");;
    Expect(1, 123215, '\p{Sc=-	Hmnp}', "");
    Expect(0, 123215, '\p{^Sc=-	Hmnp}', "");
    Expect(0, 123215, '\P{Sc=-	Hmnp}', "");
    Expect(1, 123215, '\P{^Sc=-	Hmnp}', "");
    Expect(0, 123216, '\p{Sc=-	Hmnp}', "");
    Expect(1, 123216, '\p{^Sc=-	Hmnp}', "");
    Expect(1, 123216, '\P{Sc=-	Hmnp}', "");
    Expect(0, 123216, '\P{^Sc=-	Hmnp}', "");
    Error('\p{Is_Script=	:=Nyiakeng_Puachue_hmong}');
    Error('\P{Is_Script=	:=Nyiakeng_Puachue_hmong}');
    Expect(1, 123215, '\p{Is_Script:nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^Is_Script:nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{Is_Script:nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^Is_Script:nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{Is_Script:nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^Is_Script:nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{Is_Script:nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^Is_Script:nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{Is_Script=-	Nyiakeng_PUACHUE_Hmong}', "");
    Expect(0, 123215, '\p{^Is_Script=-	Nyiakeng_PUACHUE_Hmong}', "");
    Expect(0, 123215, '\P{Is_Script=-	Nyiakeng_PUACHUE_Hmong}', "");
    Expect(1, 123215, '\P{^Is_Script=-	Nyiakeng_PUACHUE_Hmong}', "");
    Expect(0, 123216, '\p{Is_Script=-	Nyiakeng_PUACHUE_Hmong}', "");
    Expect(1, 123216, '\p{^Is_Script=-	Nyiakeng_PUACHUE_Hmong}', "");
    Expect(1, 123216, '\P{Is_Script=-	Nyiakeng_PUACHUE_Hmong}', "");
    Expect(0, 123216, '\P{^Is_Script=-	Nyiakeng_PUACHUE_Hmong}', "");
    Error('\p{Is_Sc=-:=hmnp}');
    Error('\P{Is_Sc=-:=hmnp}');
    Expect(1, 123215, '\p{Is_Sc=hmnp}', "");
    Expect(0, 123215, '\p{^Is_Sc=hmnp}', "");
    Expect(0, 123215, '\P{Is_Sc=hmnp}', "");
    Expect(1, 123215, '\P{^Is_Sc=hmnp}', "");
    Expect(0, 123216, '\p{Is_Sc=hmnp}', "");
    Expect(1, 123216, '\p{^Is_Sc=hmnp}', "");
    Expect(1, 123216, '\P{Is_Sc=hmnp}', "");
    Expect(0, 123216, '\P{^Is_Sc=hmnp}', "");
    Expect(1, 123215, '\p{Is_Sc=_-Hmnp}', "");
    Expect(0, 123215, '\p{^Is_Sc=_-Hmnp}', "");
    Expect(0, 123215, '\P{Is_Sc=_-Hmnp}', "");
    Expect(1, 123215, '\P{^Is_Sc=_-Hmnp}', "");
    Expect(0, 123216, '\p{Is_Sc=_-Hmnp}', "");
    Expect(1, 123216, '\p{^Is_Sc=_-Hmnp}', "");
    Expect(1, 123216, '\P{Is_Sc=_-Hmnp}', "");
    Expect(0, 123216, '\P{^Is_Sc=_-Hmnp}', "");
    Error('\p{Script:   Katakana_Or_Hiragana}');
    Error('\P{Script:   Katakana_Or_Hiragana}');
    Error('\p{Sc: Hrkt}');
    Error('\P{Sc: Hrkt}');
    Error('\p{Is_Script=Katakana_Or_Hiragana}');
    Error('\P{Is_Script=Katakana_Or_Hiragana}');
    Error('\p{Is_Sc=Hrkt}');
    Error('\P{Is_Sc=Hrkt}');
    Error('\p{Script=:= Old_Hungarian}');
    Error('\P{Script=:= Old_Hungarian}');
    Expect(1, 68863, '\p{Script=:\AOld_Hungarian\z:}', "");;
    Expect(0, 68864, '\p{Script=:\AOld_Hungarian\z:}', "");;
    Expect(1, 68863, '\p{Script=oldhungarian}', "");
    Expect(0, 68863, '\p{^Script=oldhungarian}', "");
    Expect(0, 68863, '\P{Script=oldhungarian}', "");
    Expect(1, 68863, '\P{^Script=oldhungarian}', "");
    Expect(0, 68864, '\p{Script=oldhungarian}', "");
    Expect(1, 68864, '\p{^Script=oldhungarian}', "");
    Expect(1, 68864, '\P{Script=oldhungarian}', "");
    Expect(0, 68864, '\P{^Script=oldhungarian}', "");
    Expect(1, 68863, '\p{Script=:\Aoldhungarian\z:}', "");;
    Expect(0, 68864, '\p{Script=:\Aoldhungarian\z:}', "");;
    Expect(1, 68863, '\p{Script=--old_Hungarian}', "");
    Expect(0, 68863, '\p{^Script=--old_Hungarian}', "");
    Expect(0, 68863, '\P{Script=--old_Hungarian}', "");
    Expect(1, 68863, '\P{^Script=--old_Hungarian}', "");
    Expect(0, 68864, '\p{Script=--old_Hungarian}', "");
    Expect(1, 68864, '\p{^Script=--old_Hungarian}', "");
    Expect(1, 68864, '\P{Script=--old_Hungarian}', "");
    Expect(0, 68864, '\P{^Script=--old_Hungarian}', "");
    Error('\p{Sc=-/a/Hung}');
    Error('\P{Sc=-/a/Hung}');
    Expect(1, 68863, '\p{Sc=:\AHung\z:}', "");;
    Expect(0, 68864, '\p{Sc=:\AHung\z:}', "");;
    Expect(1, 68863, '\p{Sc=hung}', "");
    Expect(0, 68863, '\p{^Sc=hung}', "");
    Expect(0, 68863, '\P{Sc=hung}', "");
    Expect(1, 68863, '\P{^Sc=hung}', "");
    Expect(0, 68864, '\p{Sc=hung}', "");
    Expect(1, 68864, '\p{^Sc=hung}', "");
    Expect(1, 68864, '\P{Sc=hung}', "");
    Expect(0, 68864, '\P{^Sc=hung}', "");
    Expect(1, 68863, '\p{Sc=:\Ahung\z:}', "");;
    Expect(0, 68864, '\p{Sc=:\Ahung\z:}', "");;
    Expect(1, 68863, '\p{Sc=  hung}', "");
    Expect(0, 68863, '\p{^Sc=  hung}', "");
    Expect(0, 68863, '\P{Sc=  hung}', "");
    Expect(1, 68863, '\P{^Sc=  hung}', "");
    Expect(0, 68864, '\p{Sc=  hung}', "");
    Expect(1, 68864, '\p{^Sc=  hung}', "");
    Expect(1, 68864, '\P{Sc=  hung}', "");
    Expect(0, 68864, '\P{^Sc=  hung}', "");
    Error('\p{Is_Script:  OLD_HUNGARIAN:=}');
    Error('\P{Is_Script:  OLD_HUNGARIAN:=}');
    Expect(1, 68863, '\p{Is_Script=oldhungarian}', "");
    Expect(0, 68863, '\p{^Is_Script=oldhungarian}', "");
    Expect(0, 68863, '\P{Is_Script=oldhungarian}', "");
    Expect(1, 68863, '\P{^Is_Script=oldhungarian}', "");
    Expect(0, 68864, '\p{Is_Script=oldhungarian}', "");
    Expect(1, 68864, '\p{^Is_Script=oldhungarian}', "");
    Expect(1, 68864, '\P{Is_Script=oldhungarian}', "");
    Expect(0, 68864, '\P{^Is_Script=oldhungarian}', "");
    Expect(1, 68863, '\p{Is_Script= -Old_hungarian}', "");
    Expect(0, 68863, '\p{^Is_Script= -Old_hungarian}', "");
    Expect(0, 68863, '\P{Is_Script= -Old_hungarian}', "");
    Expect(1, 68863, '\P{^Is_Script= -Old_hungarian}', "");
    Expect(0, 68864, '\p{Is_Script= -Old_hungarian}', "");
    Expect(1, 68864, '\p{^Is_Script= -Old_hungarian}', "");
    Expect(1, 68864, '\P{Is_Script= -Old_hungarian}', "");
    Expect(0, 68864, '\P{^Is_Script= -Old_hungarian}', "");
    Error('\p{Is_Sc=	-hung:=}');
    Error('\P{Is_Sc=	-hung:=}');
    Expect(1, 68863, '\p{Is_Sc: hung}', "");
    Expect(0, 68863, '\p{^Is_Sc: hung}', "");
    Expect(0, 68863, '\P{Is_Sc: hung}', "");
    Expect(1, 68863, '\P{^Is_Sc: hung}', "");
    Expect(0, 68864, '\p{Is_Sc: hung}', "");
    Expect(1, 68864, '\p{^Is_Sc: hung}', "");
    Expect(1, 68864, '\P{Is_Sc: hung}', "");
    Expect(0, 68864, '\P{^Is_Sc: hung}', "");
    Expect(1, 68863, '\p{Is_Sc=- HUNG}', "");
    Expect(0, 68863, '\p{^Is_Sc=- HUNG}', "");
    Expect(0, 68863, '\P{Is_Sc=- HUNG}', "");
    Expect(1, 68863, '\P{^Is_Sc=- HUNG}', "");
    Expect(0, 68864, '\p{Is_Sc=- HUNG}', "");
    Expect(1, 68864, '\p{^Is_Sc=- HUNG}', "");
    Expect(1, 68864, '\P{Is_Sc=- HUNG}', "");
    Expect(0, 68864, '\P{^Is_Sc=- HUNG}', "");
    Error('\p{Script=:=_	Old_Italic}');
    Error('\P{Script=:=_	Old_Italic}');
    Expect(1, 66351, '\p{Script=:\AOld_Italic\z:}', "");;
    Expect(0, 66352, '\p{Script=:\AOld_Italic\z:}', "");;
    Expect(1, 66351, '\p{Script=olditalic}', "");
    Expect(0, 66351, '\p{^Script=olditalic}', "");
    Expect(0, 66351, '\P{Script=olditalic}', "");
    Expect(1, 66351, '\P{^Script=olditalic}', "");
    Expect(0, 66352, '\p{Script=olditalic}', "");
    Expect(1, 66352, '\p{^Script=olditalic}', "");
    Expect(1, 66352, '\P{Script=olditalic}', "");
    Expect(0, 66352, '\P{^Script=olditalic}', "");
    Expect(1, 66351, '\p{Script=:\Aolditalic\z:}', "");;
    Expect(0, 66352, '\p{Script=:\Aolditalic\z:}', "");;
    Expect(1, 66351, '\p{Script=-_Old_italic}', "");
    Expect(0, 66351, '\p{^Script=-_Old_italic}', "");
    Expect(0, 66351, '\P{Script=-_Old_italic}', "");
    Expect(1, 66351, '\P{^Script=-_Old_italic}', "");
    Expect(0, 66352, '\p{Script=-_Old_italic}', "");
    Expect(1, 66352, '\p{^Script=-_Old_italic}', "");
    Expect(1, 66352, '\P{Script=-_Old_italic}', "");
    Expect(0, 66352, '\P{^Script=-_Old_italic}', "");
    Error('\p{Sc:--ITAL/a/}');
    Error('\P{Sc:--ITAL/a/}');
    Expect(1, 66351, '\p{Sc=:\AItal\z:}', "");;
    Expect(0, 66352, '\p{Sc=:\AItal\z:}', "");;
    Expect(1, 66351, '\p{Sc=ital}', "");
    Expect(0, 66351, '\p{^Sc=ital}', "");
    Expect(0, 66351, '\P{Sc=ital}', "");
    Expect(1, 66351, '\P{^Sc=ital}', "");
    Expect(0, 66352, '\p{Sc=ital}', "");
    Expect(1, 66352, '\p{^Sc=ital}', "");
    Expect(1, 66352, '\P{Sc=ital}', "");
    Expect(0, 66352, '\P{^Sc=ital}', "");
    Expect(1, 66351, '\p{Sc=:\Aital\z:}', "");;
    Expect(0, 66352, '\p{Sc=:\Aital\z:}', "");;
    Expect(1, 66351, '\p{Sc=-Ital}', "");
    Expect(0, 66351, '\p{^Sc=-Ital}', "");
    Expect(0, 66351, '\P{Sc=-Ital}', "");
    Expect(1, 66351, '\P{^Sc=-Ital}', "");
    Expect(0, 66352, '\p{Sc=-Ital}', "");
    Expect(1, 66352, '\p{^Sc=-Ital}', "");
    Expect(1, 66352, '\P{Sc=-Ital}', "");
    Expect(0, 66352, '\P{^Sc=-Ital}', "");
    Error('\p{Is_Script=-_old_Italic/a/}');
    Error('\P{Is_Script=-_old_Italic/a/}');
    Expect(1, 66351, '\p{Is_Script=olditalic}', "");
    Expect(0, 66351, '\p{^Is_Script=olditalic}', "");
    Expect(0, 66351, '\P{Is_Script=olditalic}', "");
    Expect(1, 66351, '\P{^Is_Script=olditalic}', "");
    Expect(0, 66352, '\p{Is_Script=olditalic}', "");
    Expect(1, 66352, '\p{^Is_Script=olditalic}', "");
    Expect(1, 66352, '\P{Is_Script=olditalic}', "");
    Expect(0, 66352, '\P{^Is_Script=olditalic}', "");
    Expect(1, 66351, '\p{Is_Script=OLD_Italic}', "");
    Expect(0, 66351, '\p{^Is_Script=OLD_Italic}', "");
    Expect(0, 66351, '\P{Is_Script=OLD_Italic}', "");
    Expect(1, 66351, '\P{^Is_Script=OLD_Italic}', "");
    Expect(0, 66352, '\p{Is_Script=OLD_Italic}', "");
    Expect(1, 66352, '\p{^Is_Script=OLD_Italic}', "");
    Expect(1, 66352, '\P{Is_Script=OLD_Italic}', "");
    Expect(0, 66352, '\P{^Is_Script=OLD_Italic}', "");
    Error('\p{Is_Sc=:=--ITAL}');
    Error('\P{Is_Sc=:=--ITAL}');
    Expect(1, 66351, '\p{Is_Sc=ital}', "");
    Expect(0, 66351, '\p{^Is_Sc=ital}', "");
    Expect(0, 66351, '\P{Is_Sc=ital}', "");
    Expect(1, 66351, '\P{^Is_Sc=ital}', "");
    Expect(0, 66352, '\p{Is_Sc=ital}', "");
    Expect(1, 66352, '\p{^Is_Sc=ital}', "");
    Expect(1, 66352, '\P{Is_Sc=ital}', "");
    Expect(0, 66352, '\P{^Is_Sc=ital}', "");
    Expect(1, 66351, '\p{Is_Sc=	ital}', "");
    Expect(0, 66351, '\p{^Is_Sc=	ital}', "");
    Expect(0, 66351, '\P{Is_Sc=	ital}', "");
    Expect(1, 66351, '\P{^Is_Sc=	ital}', "");
    Expect(0, 66352, '\p{Is_Sc=	ital}', "");
    Expect(1, 66352, '\p{^Is_Sc=	ital}', "");
    Expect(1, 66352, '\P{Is_Sc=	ital}', "");
    Expect(0, 66352, '\P{^Is_Sc=	ital}', "");
    Error('\p{Script= 	Javanese:=}');
    Error('\P{Script= 	Javanese:=}');
    Expect(1, 43487, '\p{Script=:\AJavanese\z:}', "");;
    Expect(0, 43488, '\p{Script=:\AJavanese\z:}', "");;
    Expect(1, 43487, '\p{Script=javanese}', "");
    Expect(0, 43487, '\p{^Script=javanese}', "");
    Expect(0, 43487, '\P{Script=javanese}', "");
    Expect(1, 43487, '\P{^Script=javanese}', "");
    Expect(0, 43488, '\p{Script=javanese}', "");
    Expect(1, 43488, '\p{^Script=javanese}', "");
    Expect(1, 43488, '\P{Script=javanese}', "");
    Expect(0, 43488, '\P{^Script=javanese}', "");
    Expect(1, 43487, '\p{Script=:\Ajavanese\z:}', "");;
    Expect(0, 43488, '\p{Script=:\Ajavanese\z:}', "");;
    Expect(1, 43487, '\p{Script=		Javanese}', "");
    Expect(0, 43487, '\p{^Script=		Javanese}', "");
    Expect(0, 43487, '\P{Script=		Javanese}', "");
    Expect(1, 43487, '\P{^Script=		Javanese}', "");
    Expect(0, 43488, '\p{Script=		Javanese}', "");
    Expect(1, 43488, '\p{^Script=		Javanese}', "");
    Expect(1, 43488, '\P{Script=		Javanese}', "");
    Expect(0, 43488, '\P{^Script=		Javanese}', "");
    Error('\p{Sc=:=		Java}');
    Error('\P{Sc=:=		Java}');
    Expect(1, 43487, '\p{Sc=:\AJava\z:}', "");;
    Expect(0, 43488, '\p{Sc=:\AJava\z:}', "");;
    Expect(1, 43487, '\p{Sc=java}', "");
    Expect(0, 43487, '\p{^Sc=java}', "");
    Expect(0, 43487, '\P{Sc=java}', "");
    Expect(1, 43487, '\P{^Sc=java}', "");
    Expect(0, 43488, '\p{Sc=java}', "");
    Expect(1, 43488, '\p{^Sc=java}', "");
    Expect(1, 43488, '\P{Sc=java}', "");
    Expect(0, 43488, '\P{^Sc=java}', "");
    Expect(1, 43487, '\p{Sc=:\Ajava\z:}', "");;
    Expect(0, 43488, '\p{Sc=:\Ajava\z:}', "");;
    Expect(1, 43487, '\p{Sc=-_Java}', "");
    Expect(0, 43487, '\p{^Sc=-_Java}', "");
    Expect(0, 43487, '\P{Sc=-_Java}', "");
    Expect(1, 43487, '\P{^Sc=-_Java}', "");
    Expect(0, 43488, '\p{Sc=-_Java}', "");
    Expect(1, 43488, '\p{^Sc=-_Java}', "");
    Expect(1, 43488, '\P{Sc=-_Java}', "");
    Expect(0, 43488, '\P{^Sc=-_Java}', "");
    Error('\p{Is_Script=/a/ javanese}');
    Error('\P{Is_Script=/a/ javanese}');
    Expect(1, 43487, '\p{Is_Script:	javanese}', "");
    Expect(0, 43487, '\p{^Is_Script:	javanese}', "");
    Expect(0, 43487, '\P{Is_Script:	javanese}', "");
    Expect(1, 43487, '\P{^Is_Script:	javanese}', "");
    Expect(0, 43488, '\p{Is_Script:	javanese}', "");
    Expect(1, 43488, '\p{^Is_Script:	javanese}', "");
    Expect(1, 43488, '\P{Is_Script:	javanese}', "");
    Expect(0, 43488, '\P{^Is_Script:	javanese}', "");
    Expect(1, 43487, '\p{Is_Script=	javanese}', "");
    Expect(0, 43487, '\p{^Is_Script=	javanese}', "");
    Expect(0, 43487, '\P{Is_Script=	javanese}', "");
    Expect(1, 43487, '\P{^Is_Script=	javanese}', "");
    Expect(0, 43488, '\p{Is_Script=	javanese}', "");
    Expect(1, 43488, '\p{^Is_Script=	javanese}', "");
    Expect(1, 43488, '\P{Is_Script=	javanese}', "");
    Expect(0, 43488, '\P{^Is_Script=	javanese}', "");
    Error('\p{Is_Sc= /a/Java}');
    Error('\P{Is_Sc= /a/Java}');
    Expect(1, 43487, '\p{Is_Sc=java}', "");
    Expect(0, 43487, '\p{^Is_Sc=java}', "");
    Expect(0, 43487, '\P{Is_Sc=java}', "");
    Expect(1, 43487, '\P{^Is_Sc=java}', "");
    Expect(0, 43488, '\p{Is_Sc=java}', "");
    Expect(1, 43488, '\p{^Is_Sc=java}', "");
    Expect(1, 43488, '\P{Is_Sc=java}', "");
    Expect(0, 43488, '\P{^Is_Sc=java}', "");
    Expect(1, 43487, '\p{Is_Sc=	Java}', "");
    Expect(0, 43487, '\p{^Is_Sc=	Java}', "");
    Expect(0, 43487, '\P{Is_Sc=	Java}', "");
    Expect(1, 43487, '\P{^Is_Sc=	Java}', "");
    Expect(0, 43488, '\p{Is_Sc=	Java}', "");
    Expect(1, 43488, '\p{^Is_Sc=	Java}', "");
    Expect(1, 43488, '\P{Is_Sc=	Java}', "");
    Expect(0, 43488, '\P{^Is_Sc=	Java}', "");
    Error('\p{Script=/a/	 KAYAH_LI}');
    Error('\P{Script=/a/	 KAYAH_LI}');
    Expect(1, 43311, '\p{Script=:\AKayah_Li\z:}', "");;
    Expect(0, 43312, '\p{Script=:\AKayah_Li\z:}', "");;
    Expect(1, 43311, '\p{Script=kayahli}', "");
    Expect(0, 43311, '\p{^Script=kayahli}', "");
    Expect(0, 43311, '\P{Script=kayahli}', "");
    Expect(1, 43311, '\P{^Script=kayahli}', "");
    Expect(0, 43312, '\p{Script=kayahli}', "");
    Expect(1, 43312, '\p{^Script=kayahli}', "");
    Expect(1, 43312, '\P{Script=kayahli}', "");
    Expect(0, 43312, '\P{^Script=kayahli}', "");
    Expect(1, 43311, '\p{Script=:\Akayahli\z:}', "");;
    Expect(0, 43312, '\p{Script=:\Akayahli\z:}', "");;
    Expect(1, 43311, '\p{Script=Kayah_Li}', "");
    Expect(0, 43311, '\p{^Script=Kayah_Li}', "");
    Expect(0, 43311, '\P{Script=Kayah_Li}', "");
    Expect(1, 43311, '\P{^Script=Kayah_Li}', "");
    Expect(0, 43312, '\p{Script=Kayah_Li}', "");
    Expect(1, 43312, '\p{^Script=Kayah_Li}', "");
    Expect(1, 43312, '\P{Script=Kayah_Li}', "");
    Expect(0, 43312, '\P{^Script=Kayah_Li}', "");
    Error('\p{Sc: -	Kali/a/}');
    Error('\P{Sc: -	Kali/a/}');
    Expect(1, 43311, '\p{Sc=:\AKali\z:}', "");;
    Expect(0, 43312, '\p{Sc=:\AKali\z:}', "");;
    Expect(1, 43311, '\p{Sc=kali}', "");
    Expect(0, 43311, '\p{^Sc=kali}', "");
    Expect(0, 43311, '\P{Sc=kali}', "");
    Expect(1, 43311, '\P{^Sc=kali}', "");
    Expect(0, 43312, '\p{Sc=kali}', "");
    Expect(1, 43312, '\p{^Sc=kali}', "");
    Expect(1, 43312, '\P{Sc=kali}', "");
    Expect(0, 43312, '\P{^Sc=kali}', "");
    Expect(1, 43311, '\p{Sc=:\Akali\z:}', "");;
    Expect(0, 43312, '\p{Sc=:\Akali\z:}', "");;
    Expect(1, 43311, '\p{Sc=_Kali}', "");
    Expect(0, 43311, '\p{^Sc=_Kali}', "");
    Expect(0, 43311, '\P{Sc=_Kali}', "");
    Expect(1, 43311, '\P{^Sc=_Kali}', "");
    Expect(0, 43312, '\p{Sc=_Kali}', "");
    Expect(1, 43312, '\p{^Sc=_Kali}', "");
    Expect(1, 43312, '\P{Sc=_Kali}', "");
    Expect(0, 43312, '\P{^Sc=_Kali}', "");
    Error('\p{Is_Script:   /a/ kayah_Li}');
    Error('\P{Is_Script:   /a/ kayah_Li}');
    Expect(1, 43311, '\p{Is_Script=kayahli}', "");
    Expect(0, 43311, '\p{^Is_Script=kayahli}', "");
    Expect(0, 43311, '\P{Is_Script=kayahli}', "");
    Expect(1, 43311, '\P{^Is_Script=kayahli}', "");
    Expect(0, 43312, '\p{Is_Script=kayahli}', "");
    Expect(1, 43312, '\p{^Is_Script=kayahli}', "");
    Expect(1, 43312, '\P{Is_Script=kayahli}', "");
    Expect(0, 43312, '\P{^Is_Script=kayahli}', "");
    Expect(1, 43311, '\p{Is_Script=_-kayah_Li}', "");
    Expect(0, 43311, '\p{^Is_Script=_-kayah_Li}', "");
    Expect(0, 43311, '\P{Is_Script=_-kayah_Li}', "");
    Expect(1, 43311, '\P{^Is_Script=_-kayah_Li}', "");
    Expect(0, 43312, '\p{Is_Script=_-kayah_Li}', "");
    Expect(1, 43312, '\p{^Is_Script=_-kayah_Li}', "");
    Expect(1, 43312, '\P{Is_Script=_-kayah_Li}', "");
    Expect(0, 43312, '\P{^Is_Script=_-kayah_Li}', "");
    Error('\p{Is_Sc=/a/kali}');
    Error('\P{Is_Sc=/a/kali}');
    Expect(1, 43311, '\p{Is_Sc=kali}', "");
    Expect(0, 43311, '\p{^Is_Sc=kali}', "");
    Expect(0, 43311, '\P{Is_Sc=kali}', "");
    Expect(1, 43311, '\P{^Is_Sc=kali}', "");
    Expect(0, 43312, '\p{Is_Sc=kali}', "");
    Expect(1, 43312, '\p{^Is_Sc=kali}', "");
    Expect(1, 43312, '\P{Is_Sc=kali}', "");
    Expect(0, 43312, '\P{^Is_Sc=kali}', "");
    Expect(1, 43311, '\p{Is_Sc=-Kali}', "");
    Expect(0, 43311, '\p{^Is_Sc=-Kali}', "");
    Expect(0, 43311, '\P{Is_Sc=-Kali}', "");
    Expect(1, 43311, '\P{^Is_Sc=-Kali}', "");
    Expect(0, 43312, '\p{Is_Sc=-Kali}', "");
    Expect(1, 43312, '\p{^Is_Sc=-Kali}', "");
    Expect(1, 43312, '\P{Is_Sc=-Kali}', "");
    Expect(0, 43312, '\P{^Is_Sc=-Kali}', "");
    Error('\p{Script=/a/	_Katakana}');
    Error('\P{Script=/a/	_Katakana}');
    Expect(1, 110951, '\p{Script=:\AKatakana\z:}', "");;
    Expect(0, 110952, '\p{Script=:\AKatakana\z:}', "");;
    Expect(1, 110951, '\p{Script=katakana}', "");
    Expect(0, 110951, '\p{^Script=katakana}', "");
    Expect(0, 110951, '\P{Script=katakana}', "");
    Expect(1, 110951, '\P{^Script=katakana}', "");
    Expect(0, 110952, '\p{Script=katakana}', "");
    Expect(1, 110952, '\p{^Script=katakana}', "");
    Expect(1, 110952, '\P{Script=katakana}', "");
    Expect(0, 110952, '\P{^Script=katakana}', "");
    Expect(1, 110951, '\p{Script=:\Akatakana\z:}', "");;
    Expect(0, 110952, '\p{Script=:\Akatakana\z:}', "");;
    Expect(1, 110951, '\p{Script=_ KATAKANA}', "");
    Expect(0, 110951, '\p{^Script=_ KATAKANA}', "");
    Expect(0, 110951, '\P{Script=_ KATAKANA}', "");
    Expect(1, 110951, '\P{^Script=_ KATAKANA}', "");
    Expect(0, 110952, '\p{Script=_ KATAKANA}', "");
    Expect(1, 110952, '\p{^Script=_ KATAKANA}', "");
    Expect(1, 110952, '\P{Script=_ KATAKANA}', "");
    Expect(0, 110952, '\P{^Script=_ KATAKANA}', "");
    Error('\p{Sc=:=-	Kana}');
    Error('\P{Sc=:=-	Kana}');
    Expect(1, 110951, '\p{Sc=:\AKana\z:}', "");;
    Expect(0, 110952, '\p{Sc=:\AKana\z:}', "");;
    Expect(1, 110951, '\p{Sc=kana}', "");
    Expect(0, 110951, '\p{^Sc=kana}', "");
    Expect(0, 110951, '\P{Sc=kana}', "");
    Expect(1, 110951, '\P{^Sc=kana}', "");
    Expect(0, 110952, '\p{Sc=kana}', "");
    Expect(1, 110952, '\p{^Sc=kana}', "");
    Expect(1, 110952, '\P{Sc=kana}', "");
    Expect(0, 110952, '\P{^Sc=kana}', "");
    Expect(1, 110951, '\p{Sc=:\Akana\z:}', "");;
    Expect(0, 110952, '\p{Sc=:\Akana\z:}', "");;
    Expect(1, 110951, '\p{Sc:	 kana}', "");
    Expect(0, 110951, '\p{^Sc:	 kana}', "");
    Expect(0, 110951, '\P{Sc:	 kana}', "");
    Expect(1, 110951, '\P{^Sc:	 kana}', "");
    Expect(0, 110952, '\p{Sc:	 kana}', "");
    Expect(1, 110952, '\p{^Sc:	 kana}', "");
    Expect(1, 110952, '\P{Sc:	 kana}', "");
    Expect(0, 110952, '\P{^Sc:	 kana}', "");
    Error('\p{Is_Script= -Katakana/a/}');
    Error('\P{Is_Script= -Katakana/a/}');
    Expect(1, 110951, '\p{Is_Script=katakana}', "");
    Expect(0, 110951, '\p{^Is_Script=katakana}', "");
    Expect(0, 110951, '\P{Is_Script=katakana}', "");
    Expect(1, 110951, '\P{^Is_Script=katakana}', "");
    Expect(0, 110952, '\p{Is_Script=katakana}', "");
    Expect(1, 110952, '\p{^Is_Script=katakana}', "");
    Expect(1, 110952, '\P{Is_Script=katakana}', "");
    Expect(0, 110952, '\P{^Is_Script=katakana}', "");
    Expect(1, 110951, '\p{Is_Script=- katakana}', "");
    Expect(0, 110951, '\p{^Is_Script=- katakana}', "");
    Expect(0, 110951, '\P{Is_Script=- katakana}', "");
    Expect(1, 110951, '\P{^Is_Script=- katakana}', "");
    Expect(0, 110952, '\p{Is_Script=- katakana}', "");
    Expect(1, 110952, '\p{^Is_Script=- katakana}', "");
    Expect(1, 110952, '\P{Is_Script=- katakana}', "");
    Expect(0, 110952, '\P{^Is_Script=- katakana}', "");
    Error('\p{Is_Sc:		Kana/a/}');
    Error('\P{Is_Sc:		Kana/a/}');
    Expect(1, 110951, '\p{Is_Sc=kana}', "");
    Expect(0, 110951, '\p{^Is_Sc=kana}', "");
    Expect(0, 110951, '\P{Is_Sc=kana}', "");
    Expect(1, 110951, '\P{^Is_Sc=kana}', "");
    Expect(0, 110952, '\p{Is_Sc=kana}', "");
    Expect(1, 110952, '\p{^Is_Sc=kana}', "");
    Expect(1, 110952, '\P{Is_Sc=kana}', "");
    Expect(0, 110952, '\P{^Is_Sc=kana}', "");
    Expect(1, 110951, '\p{Is_Sc=_ Kana}', "");
    Expect(0, 110951, '\p{^Is_Sc=_ Kana}', "");
    Expect(0, 110951, '\P{Is_Sc=_ Kana}', "");
    Expect(1, 110951, '\P{^Is_Sc=_ Kana}', "");
    Expect(0, 110952, '\p{Is_Sc=_ Kana}', "");
    Expect(1, 110952, '\p{^Is_Sc=_ Kana}', "");
    Expect(1, 110952, '\P{Is_Sc=_ Kana}', "");
    Expect(0, 110952, '\P{^Is_Sc=_ Kana}', "");
    Error('\p{Script=_/a/kharoshthi}');
    Error('\P{Script=_/a/kharoshthi}');
    Expect(1, 68184, '\p{Script=:\AKharoshthi\z:}', "");;
    Expect(0, 68185, '\p{Script=:\AKharoshthi\z:}', "");;
    Expect(1, 68184, '\p{Script=kharoshthi}', "");
    Expect(0, 68184, '\p{^Script=kharoshthi}', "");
    Expect(0, 68184, '\P{Script=kharoshthi}', "");
    Expect(1, 68184, '\P{^Script=kharoshthi}', "");
    Expect(0, 68185, '\p{Script=kharoshthi}', "");
    Expect(1, 68185, '\p{^Script=kharoshthi}', "");
    Expect(1, 68185, '\P{Script=kharoshthi}', "");
    Expect(0, 68185, '\P{^Script=kharoshthi}', "");
    Expect(1, 68184, '\p{Script=:\Akharoshthi\z:}', "");;
    Expect(0, 68185, '\p{Script=:\Akharoshthi\z:}', "");;
    Expect(1, 68184, '\p{Script=KHAROSHTHI}', "");
    Expect(0, 68184, '\p{^Script=KHAROSHTHI}', "");
    Expect(0, 68184, '\P{Script=KHAROSHTHI}', "");
    Expect(1, 68184, '\P{^Script=KHAROSHTHI}', "");
    Expect(0, 68185, '\p{Script=KHAROSHTHI}', "");
    Expect(1, 68185, '\p{^Script=KHAROSHTHI}', "");
    Expect(1, 68185, '\P{Script=KHAROSHTHI}', "");
    Expect(0, 68185, '\P{^Script=KHAROSHTHI}', "");
    Error('\p{Sc=_/a/KHAR}');
    Error('\P{Sc=_/a/KHAR}');
    Expect(1, 68184, '\p{Sc=:\AKhar\z:}', "");;
    Expect(0, 68185, '\p{Sc=:\AKhar\z:}', "");;
    Expect(1, 68184, '\p{Sc=khar}', "");
    Expect(0, 68184, '\p{^Sc=khar}', "");
    Expect(0, 68184, '\P{Sc=khar}', "");
    Expect(1, 68184, '\P{^Sc=khar}', "");
    Expect(0, 68185, '\p{Sc=khar}', "");
    Expect(1, 68185, '\p{^Sc=khar}', "");
    Expect(1, 68185, '\P{Sc=khar}', "");
    Expect(0, 68185, '\P{^Sc=khar}', "");
    Expect(1, 68184, '\p{Sc=:\Akhar\z:}', "");;
    Expect(0, 68185, '\p{Sc=:\Akhar\z:}', "");;
    Expect(1, 68184, '\p{Sc=_khar}', "");
    Expect(0, 68184, '\p{^Sc=_khar}', "");
    Expect(0, 68184, '\P{Sc=_khar}', "");
    Expect(1, 68184, '\P{^Sc=_khar}', "");
    Expect(0, 68185, '\p{Sc=_khar}', "");
    Expect(1, 68185, '\p{^Sc=_khar}', "");
    Expect(1, 68185, '\P{Sc=_khar}', "");
    Expect(0, 68185, '\P{^Sc=_khar}', "");
    Error('\p{Is_Script=	-kharoshthi:=}');
    Error('\P{Is_Script=	-kharoshthi:=}');
    Expect(1, 68184, '\p{Is_Script=kharoshthi}', "");
    Expect(0, 68184, '\p{^Is_Script=kharoshthi}', "");
    Expect(0, 68184, '\P{Is_Script=kharoshthi}', "");
    Expect(1, 68184, '\P{^Is_Script=kharoshthi}', "");
    Expect(0, 68185, '\p{Is_Script=kharoshthi}', "");
    Expect(1, 68185, '\p{^Is_Script=kharoshthi}', "");
    Expect(1, 68185, '\P{Is_Script=kharoshthi}', "");
    Expect(0, 68185, '\P{^Is_Script=kharoshthi}', "");
    Expect(1, 68184, '\p{Is_Script=-kharoshthi}', "");
    Expect(0, 68184, '\p{^Is_Script=-kharoshthi}', "");
    Expect(0, 68184, '\P{Is_Script=-kharoshthi}', "");
    Expect(1, 68184, '\P{^Is_Script=-kharoshthi}', "");
    Expect(0, 68185, '\p{Is_Script=-kharoshthi}', "");
    Expect(1, 68185, '\p{^Is_Script=-kharoshthi}', "");
    Expect(1, 68185, '\P{Is_Script=-kharoshthi}', "");
    Expect(0, 68185, '\P{^Is_Script=-kharoshthi}', "");
    Error('\p{Is_Sc=/a/Khar}');
    Error('\P{Is_Sc=/a/Khar}');
    Expect(1, 68184, '\p{Is_Sc=khar}', "");
    Expect(0, 68184, '\p{^Is_Sc=khar}', "");
    Expect(0, 68184, '\P{Is_Sc=khar}', "");
    Expect(1, 68184, '\P{^Is_Sc=khar}', "");
    Expect(0, 68185, '\p{Is_Sc=khar}', "");
    Expect(1, 68185, '\p{^Is_Sc=khar}', "");
    Expect(1, 68185, '\P{Is_Sc=khar}', "");
    Expect(0, 68185, '\P{^Is_Sc=khar}', "");
    Expect(1, 68184, '\p{Is_Sc:   -	KHAR}', "");
    Expect(0, 68184, '\p{^Is_Sc:   -	KHAR}', "");
    Expect(0, 68184, '\P{Is_Sc:   -	KHAR}', "");
    Expect(1, 68184, '\P{^Is_Sc:   -	KHAR}', "");
    Expect(0, 68185, '\p{Is_Sc:   -	KHAR}', "");
    Expect(1, 68185, '\p{^Is_Sc:   -	KHAR}', "");
    Expect(1, 68185, '\P{Is_Sc:   -	KHAR}', "");
    Expect(0, 68185, '\P{^Is_Sc:   -	KHAR}', "");
    Error('\p{Script:-:=KHMER}');
    Error('\P{Script:-:=KHMER}');
    Expect(1, 6655, '\p{Script=:\AKhmer\z:}', "");;
    Expect(0, 6656, '\p{Script=:\AKhmer\z:}', "");;
    Expect(1, 6655, '\p{Script=khmer}', "");
    Expect(0, 6655, '\p{^Script=khmer}', "");
    Expect(0, 6655, '\P{Script=khmer}', "");
    Expect(1, 6655, '\P{^Script=khmer}', "");
    Expect(0, 6656, '\p{Script=khmer}', "");
    Expect(1, 6656, '\p{^Script=khmer}', "");
    Expect(1, 6656, '\P{Script=khmer}', "");
    Expect(0, 6656, '\P{^Script=khmer}', "");
    Expect(1, 6655, '\p{Script=:\Akhmer\z:}', "");;
    Expect(0, 6656, '\p{Script=:\Akhmer\z:}', "");;
    Expect(1, 6655, '\p{Script=__KHMER}', "");
    Expect(0, 6655, '\p{^Script=__KHMER}', "");
    Expect(0, 6655, '\P{Script=__KHMER}', "");
    Expect(1, 6655, '\P{^Script=__KHMER}', "");
    Expect(0, 6656, '\p{Script=__KHMER}', "");
    Expect(1, 6656, '\p{^Script=__KHMER}', "");
    Expect(1, 6656, '\P{Script=__KHMER}', "");
    Expect(0, 6656, '\P{^Script=__KHMER}', "");
    Error('\p{Sc=/a/Khmr}');
    Error('\P{Sc=/a/Khmr}');
    Expect(1, 6655, '\p{Sc=:\AKhmr\z:}', "");;
    Expect(0, 6656, '\p{Sc=:\AKhmr\z:}', "");;
    Expect(1, 6655, '\p{Sc=khmr}', "");
    Expect(0, 6655, '\p{^Sc=khmr}', "");
    Expect(0, 6655, '\P{Sc=khmr}', "");
    Expect(1, 6655, '\P{^Sc=khmr}', "");
    Expect(0, 6656, '\p{Sc=khmr}', "");
    Expect(1, 6656, '\p{^Sc=khmr}', "");
    Expect(1, 6656, '\P{Sc=khmr}', "");
    Expect(0, 6656, '\P{^Sc=khmr}', "");
    Expect(1, 6655, '\p{Sc=:\Akhmr\z:}', "");;
    Expect(0, 6656, '\p{Sc=:\Akhmr\z:}', "");;
    Expect(1, 6655, '\p{Sc:- KHMR}', "");
    Expect(0, 6655, '\p{^Sc:- KHMR}', "");
    Expect(0, 6655, '\P{Sc:- KHMR}', "");
    Expect(1, 6655, '\P{^Sc:- KHMR}', "");
    Expect(0, 6656, '\p{Sc:- KHMR}', "");
    Expect(1, 6656, '\p{^Sc:- KHMR}', "");
    Expect(1, 6656, '\P{Sc:- KHMR}', "");
    Expect(0, 6656, '\P{^Sc:- KHMR}', "");
    Error('\p{Is_Script:	/a/- Khmer}');
    Error('\P{Is_Script:	/a/- Khmer}');
    Expect(1, 6655, '\p{Is_Script=khmer}', "");
    Expect(0, 6655, '\p{^Is_Script=khmer}', "");
    Expect(0, 6655, '\P{Is_Script=khmer}', "");
    Expect(1, 6655, '\P{^Is_Script=khmer}', "");
    Expect(0, 6656, '\p{Is_Script=khmer}', "");
    Expect(1, 6656, '\p{^Is_Script=khmer}', "");
    Expect(1, 6656, '\P{Is_Script=khmer}', "");
    Expect(0, 6656, '\P{^Is_Script=khmer}', "");
    Expect(1, 6655, '\p{Is_Script=-khmer}', "");
    Expect(0, 6655, '\p{^Is_Script=-khmer}', "");
    Expect(0, 6655, '\P{Is_Script=-khmer}', "");
    Expect(1, 6655, '\P{^Is_Script=-khmer}', "");
    Expect(0, 6656, '\p{Is_Script=-khmer}', "");
    Expect(1, 6656, '\p{^Is_Script=-khmer}', "");
    Expect(1, 6656, '\P{Is_Script=-khmer}', "");
    Expect(0, 6656, '\P{^Is_Script=-khmer}', "");
    Error('\p{Is_Sc=-/a/Khmr}');
    Error('\P{Is_Sc=-/a/Khmr}');
    Expect(1, 6655, '\p{Is_Sc=khmr}', "");
    Expect(0, 6655, '\p{^Is_Sc=khmr}', "");
    Expect(0, 6655, '\P{Is_Sc=khmr}', "");
    Expect(1, 6655, '\P{^Is_Sc=khmr}', "");
    Expect(0, 6656, '\p{Is_Sc=khmr}', "");
    Expect(1, 6656, '\p{^Is_Sc=khmr}', "");
    Expect(1, 6656, '\P{Is_Sc=khmr}', "");
    Expect(0, 6656, '\P{^Is_Sc=khmr}', "");
    Expect(1, 6655, '\p{Is_Sc=_-khmr}', "");
    Expect(0, 6655, '\p{^Is_Sc=_-khmr}', "");
    Expect(0, 6655, '\P{Is_Sc=_-khmr}', "");
    Expect(1, 6655, '\P{^Is_Sc=_-khmr}', "");
    Expect(0, 6656, '\p{Is_Sc=_-khmr}', "");
    Expect(1, 6656, '\p{^Is_Sc=_-khmr}', "");
    Expect(1, 6656, '\P{Is_Sc=_-khmr}', "");
    Expect(0, 6656, '\P{^Is_Sc=_-khmr}', "");
    Error('\p{Script=KHOJKI:=}');
    Error('\P{Script=KHOJKI:=}');
    Expect(1, 70206, '\p{Script=:\AKhojki\z:}', "");;
    Expect(0, 70207, '\p{Script=:\AKhojki\z:}', "");;
    Expect(1, 70206, '\p{Script=khojki}', "");
    Expect(0, 70206, '\p{^Script=khojki}', "");
    Expect(0, 70206, '\P{Script=khojki}', "");
    Expect(1, 70206, '\P{^Script=khojki}', "");
    Expect(0, 70207, '\p{Script=khojki}', "");
    Expect(1, 70207, '\p{^Script=khojki}', "");
    Expect(1, 70207, '\P{Script=khojki}', "");
    Expect(0, 70207, '\P{^Script=khojki}', "");
    Expect(1, 70206, '\p{Script=:\Akhojki\z:}', "");;
    Expect(0, 70207, '\p{Script=:\Akhojki\z:}', "");;
    Expect(1, 70206, '\p{Script=	Khojki}', "");
    Expect(0, 70206, '\p{^Script=	Khojki}', "");
    Expect(0, 70206, '\P{Script=	Khojki}', "");
    Expect(1, 70206, '\P{^Script=	Khojki}', "");
    Expect(0, 70207, '\p{Script=	Khojki}', "");
    Expect(1, 70207, '\p{^Script=	Khojki}', "");
    Expect(1, 70207, '\P{Script=	Khojki}', "");
    Expect(0, 70207, '\P{^Script=	Khojki}', "");
    Error('\p{Sc= :=Khoj}');
    Error('\P{Sc= :=Khoj}');
    Expect(1, 70206, '\p{Sc=:\AKhoj\z:}', "");;
    Expect(0, 70207, '\p{Sc=:\AKhoj\z:}', "");;
    Expect(1, 70206, '\p{Sc=khoj}', "");
    Expect(0, 70206, '\p{^Sc=khoj}', "");
    Expect(0, 70206, '\P{Sc=khoj}', "");
    Expect(1, 70206, '\P{^Sc=khoj}', "");
    Expect(0, 70207, '\p{Sc=khoj}', "");
    Expect(1, 70207, '\p{^Sc=khoj}', "");
    Expect(1, 70207, '\P{Sc=khoj}', "");
    Expect(0, 70207, '\P{^Sc=khoj}', "");
    Expect(1, 70206, '\p{Sc=:\Akhoj\z:}', "");;
    Expect(0, 70207, '\p{Sc=:\Akhoj\z:}', "");;
    Expect(1, 70206, '\p{Sc:	 KHOJ}', "");
    Expect(0, 70206, '\p{^Sc:	 KHOJ}', "");
    Expect(0, 70206, '\P{Sc:	 KHOJ}', "");
    Expect(1, 70206, '\P{^Sc:	 KHOJ}', "");
    Expect(0, 70207, '\p{Sc:	 KHOJ}', "");
    Expect(1, 70207, '\p{^Sc:	 KHOJ}', "");
    Expect(1, 70207, '\P{Sc:	 KHOJ}', "");
    Expect(0, 70207, '\P{^Sc:	 KHOJ}', "");
    Error('\p{Is_Script= :=KHOJKI}');
    Error('\P{Is_Script= :=KHOJKI}');
    Expect(1, 70206, '\p{Is_Script=khojki}', "");
    Expect(0, 70206, '\p{^Is_Script=khojki}', "");
    Expect(0, 70206, '\P{Is_Script=khojki}', "");
    Expect(1, 70206, '\P{^Is_Script=khojki}', "");
    Expect(0, 70207, '\p{Is_Script=khojki}', "");
    Expect(1, 70207, '\p{^Is_Script=khojki}', "");
    Expect(1, 70207, '\P{Is_Script=khojki}', "");
    Expect(0, 70207, '\P{^Is_Script=khojki}', "");
    Expect(1, 70206, '\p{Is_Script=	 khojki}', "");
    Expect(0, 70206, '\p{^Is_Script=	 khojki}', "");
    Expect(0, 70206, '\P{Is_Script=	 khojki}', "");
    Expect(1, 70206, '\P{^Is_Script=	 khojki}', "");
    Expect(0, 70207, '\p{Is_Script=	 khojki}', "");
    Expect(1, 70207, '\p{^Is_Script=	 khojki}', "");
    Expect(1, 70207, '\P{Is_Script=	 khojki}', "");
    Expect(0, 70207, '\P{^Is_Script=	 khojki}', "");
    Error('\p{Is_Sc= :=Khoj}');
    Error('\P{Is_Sc= :=Khoj}');
    Expect(1, 70206, '\p{Is_Sc=khoj}', "");
    Expect(0, 70206, '\p{^Is_Sc=khoj}', "");
    Expect(0, 70206, '\P{Is_Sc=khoj}', "");
    Expect(1, 70206, '\P{^Is_Sc=khoj}', "");
    Expect(0, 70207, '\p{Is_Sc=khoj}', "");
    Expect(1, 70207, '\p{^Is_Sc=khoj}', "");
    Expect(1, 70207, '\P{Is_Sc=khoj}', "");
    Expect(0, 70207, '\P{^Is_Sc=khoj}', "");
    Expect(1, 70206, '\p{Is_Sc=	 KHOJ}', "");
    Expect(0, 70206, '\p{^Is_Sc=	 KHOJ}', "");
    Expect(0, 70206, '\P{Is_Sc=	 KHOJ}', "");
    Expect(1, 70206, '\P{^Is_Sc=	 KHOJ}', "");
    Expect(0, 70207, '\p{Is_Sc=	 KHOJ}', "");
    Expect(1, 70207, '\p{^Is_Sc=	 KHOJ}', "");
    Expect(1, 70207, '\P{Is_Sc=	 KHOJ}', "");
    Expect(0, 70207, '\P{^Is_Sc=	 KHOJ}', "");
    Error('\p{Script=/a/Kannada}');
    Error('\P{Script=/a/Kannada}');
    Expect(1, 3314, '\p{Script=:\AKannada\z:}', "");;
    Expect(0, 3315, '\p{Script=:\AKannada\z:}', "");;
    Expect(1, 3314, '\p{Script=kannada}', "");
    Expect(0, 3314, '\p{^Script=kannada}', "");
    Expect(0, 3314, '\P{Script=kannada}', "");
    Expect(1, 3314, '\P{^Script=kannada}', "");
    Expect(0, 3315, '\p{Script=kannada}', "");
    Expect(1, 3315, '\p{^Script=kannada}', "");
    Expect(1, 3315, '\P{Script=kannada}', "");
    Expect(0, 3315, '\P{^Script=kannada}', "");
    Expect(1, 3314, '\p{Script=:\Akannada\z:}', "");;
    Expect(0, 3315, '\p{Script=:\Akannada\z:}', "");;
    Expect(1, 3314, '\p{Script=--kannada}', "");
    Expect(0, 3314, '\p{^Script=--kannada}', "");
    Expect(0, 3314, '\P{Script=--kannada}', "");
    Expect(1, 3314, '\P{^Script=--kannada}', "");
    Expect(0, 3315, '\p{Script=--kannada}', "");
    Expect(1, 3315, '\p{^Script=--kannada}', "");
    Expect(1, 3315, '\P{Script=--kannada}', "");
    Expect(0, 3315, '\P{^Script=--kannada}', "");
    Error('\p{Sc=-Knda:=}');
    Error('\P{Sc=-Knda:=}');
    Expect(1, 3314, '\p{Sc=:\AKnda\z:}', "");;
    Expect(0, 3315, '\p{Sc=:\AKnda\z:}', "");;
    Expect(1, 3314, '\p{Sc:	knda}', "");
    Expect(0, 3314, '\p{^Sc:	knda}', "");
    Expect(0, 3314, '\P{Sc:	knda}', "");
    Expect(1, 3314, '\P{^Sc:	knda}', "");
    Expect(0, 3315, '\p{Sc:	knda}', "");
    Expect(1, 3315, '\p{^Sc:	knda}', "");
    Expect(1, 3315, '\P{Sc:	knda}', "");
    Expect(0, 3315, '\P{^Sc:	knda}', "");
    Expect(1, 3314, '\p{Sc=:\Aknda\z:}', "");;
    Expect(0, 3315, '\p{Sc=:\Aknda\z:}', "");;
    Expect(1, 3314, '\p{Sc= Knda}', "");
    Expect(0, 3314, '\p{^Sc= Knda}', "");
    Expect(0, 3314, '\P{Sc= Knda}', "");
    Expect(1, 3314, '\P{^Sc= Knda}', "");
    Expect(0, 3315, '\p{Sc= Knda}', "");
    Expect(1, 3315, '\p{^Sc= Knda}', "");
    Expect(1, 3315, '\P{Sc= Knda}', "");
    Expect(0, 3315, '\P{^Sc= Knda}', "");
    Error('\p{Is_Script=		KANNADA/a/}');
    Error('\P{Is_Script=		KANNADA/a/}');
    Expect(1, 3314, '\p{Is_Script=kannada}', "");
    Expect(0, 3314, '\p{^Is_Script=kannada}', "");
    Expect(0, 3314, '\P{Is_Script=kannada}', "");
    Expect(1, 3314, '\P{^Is_Script=kannada}', "");
    Expect(0, 3315, '\p{Is_Script=kannada}', "");
    Expect(1, 3315, '\p{^Is_Script=kannada}', "");
    Expect(1, 3315, '\P{Is_Script=kannada}', "");
    Expect(0, 3315, '\P{^Is_Script=kannada}', "");
    Expect(1, 3314, '\p{Is_Script=_Kannada}', "");
    Expect(0, 3314, '\p{^Is_Script=_Kannada}', "");
    Expect(0, 3314, '\P{Is_Script=_Kannada}', "");
    Expect(1, 3314, '\P{^Is_Script=_Kannada}', "");
    Expect(0, 3315, '\p{Is_Script=_Kannada}', "");
    Expect(1, 3315, '\p{^Is_Script=_Kannada}', "");
    Expect(1, 3315, '\P{Is_Script=_Kannada}', "");
    Expect(0, 3315, '\P{^Is_Script=_Kannada}', "");
    Error('\p{Is_Sc=/a/-Knda}');
    Error('\P{Is_Sc=/a/-Knda}');
    Expect(1, 3314, '\p{Is_Sc=knda}', "");
    Expect(0, 3314, '\p{^Is_Sc=knda}', "");
    Expect(0, 3314, '\P{Is_Sc=knda}', "");
    Expect(1, 3314, '\P{^Is_Sc=knda}', "");
    Expect(0, 3315, '\p{Is_Sc=knda}', "");
    Expect(1, 3315, '\p{^Is_Sc=knda}', "");
    Expect(1, 3315, '\P{Is_Sc=knda}', "");
    Expect(0, 3315, '\P{^Is_Sc=knda}', "");
    Expect(1, 3314, '\p{Is_Sc=_Knda}', "");
    Expect(0, 3314, '\p{^Is_Sc=_Knda}', "");
    Expect(0, 3314, '\P{Is_Sc=_Knda}', "");
    Expect(1, 3314, '\P{^Is_Sc=_Knda}', "");
    Expect(0, 3315, '\p{Is_Sc=_Knda}', "");
    Expect(1, 3315, '\p{^Is_Sc=_Knda}', "");
    Expect(1, 3315, '\P{Is_Sc=_Knda}', "");
    Expect(0, 3315, '\P{^Is_Sc=_Knda}', "");
    Error('\p{Script=:=  kaithi}');
    Error('\P{Script=:=  kaithi}');
    Expect(1, 69837, '\p{Script=:\AKaithi\z:}', "");;
    Expect(0, 69838, '\p{Script=:\AKaithi\z:}', "");;
    Expect(1, 69837, '\p{Script=kaithi}', "");
    Expect(0, 69837, '\p{^Script=kaithi}', "");
    Expect(0, 69837, '\P{Script=kaithi}', "");
    Expect(1, 69837, '\P{^Script=kaithi}', "");
    Expect(0, 69838, '\p{Script=kaithi}', "");
    Expect(1, 69838, '\p{^Script=kaithi}', "");
    Expect(1, 69838, '\P{Script=kaithi}', "");
    Expect(0, 69838, '\P{^Script=kaithi}', "");
    Expect(1, 69837, '\p{Script=:\Akaithi\z:}', "");;
    Expect(0, 69838, '\p{Script=:\Akaithi\z:}', "");;
    Expect(1, 69837, '\p{Script= _KAITHI}', "");
    Expect(0, 69837, '\p{^Script= _KAITHI}', "");
    Expect(0, 69837, '\P{Script= _KAITHI}', "");
    Expect(1, 69837, '\P{^Script= _KAITHI}', "");
    Expect(0, 69838, '\p{Script= _KAITHI}', "");
    Expect(1, 69838, '\p{^Script= _KAITHI}', "");
    Expect(1, 69838, '\P{Script= _KAITHI}', "");
    Expect(0, 69838, '\P{^Script= _KAITHI}', "");
    Error('\p{Sc= Kthi/a/}');
    Error('\P{Sc= Kthi/a/}');
    Expect(1, 69837, '\p{Sc=:\AKthi\z:}', "");;
    Expect(0, 69838, '\p{Sc=:\AKthi\z:}', "");;
    Expect(1, 69837, '\p{Sc=kthi}', "");
    Expect(0, 69837, '\p{^Sc=kthi}', "");
    Expect(0, 69837, '\P{Sc=kthi}', "");
    Expect(1, 69837, '\P{^Sc=kthi}', "");
    Expect(0, 69838, '\p{Sc=kthi}', "");
    Expect(1, 69838, '\p{^Sc=kthi}', "");
    Expect(1, 69838, '\P{Sc=kthi}', "");
    Expect(0, 69838, '\P{^Sc=kthi}', "");
    Expect(1, 69837, '\p{Sc=:\Akthi\z:}', "");;
    Expect(0, 69838, '\p{Sc=:\Akthi\z:}', "");;
    Expect(1, 69837, '\p{Sc=	kthi}', "");
    Expect(0, 69837, '\p{^Sc=	kthi}', "");
    Expect(0, 69837, '\P{Sc=	kthi}', "");
    Expect(1, 69837, '\P{^Sc=	kthi}', "");
    Expect(0, 69838, '\p{Sc=	kthi}', "");
    Expect(1, 69838, '\p{^Sc=	kthi}', "");
    Expect(1, 69838, '\P{Sc=	kthi}', "");
    Expect(0, 69838, '\P{^Sc=	kthi}', "");
    Error('\p{Is_Script=	:=Kaithi}');
    Error('\P{Is_Script=	:=Kaithi}');
    Expect(1, 69837, '\p{Is_Script=kaithi}', "");
    Expect(0, 69837, '\p{^Is_Script=kaithi}', "");
    Expect(0, 69837, '\P{Is_Script=kaithi}', "");
    Expect(1, 69837, '\P{^Is_Script=kaithi}', "");
    Expect(0, 69838, '\p{Is_Script=kaithi}', "");
    Expect(1, 69838, '\p{^Is_Script=kaithi}', "");
    Expect(1, 69838, '\P{Is_Script=kaithi}', "");
    Expect(0, 69838, '\P{^Is_Script=kaithi}', "");
    Expect(1, 69837, '\p{Is_Script= KAITHI}', "");
    Expect(0, 69837, '\p{^Is_Script= KAITHI}', "");
    Expect(0, 69837, '\P{Is_Script= KAITHI}', "");
    Expect(1, 69837, '\P{^Is_Script= KAITHI}', "");
    Expect(0, 69838, '\p{Is_Script= KAITHI}', "");
    Expect(1, 69838, '\p{^Is_Script= KAITHI}', "");
    Expect(1, 69838, '\P{Is_Script= KAITHI}', "");
    Expect(0, 69838, '\P{^Is_Script= KAITHI}', "");
    Error('\p{Is_Sc:   := -kthi}');
    Error('\P{Is_Sc:   := -kthi}');
    Expect(1, 69837, '\p{Is_Sc=kthi}', "");
    Expect(0, 69837, '\p{^Is_Sc=kthi}', "");
    Expect(0, 69837, '\P{Is_Sc=kthi}', "");
    Expect(1, 69837, '\P{^Is_Sc=kthi}', "");
    Expect(0, 69838, '\p{Is_Sc=kthi}', "");
    Expect(1, 69838, '\p{^Is_Sc=kthi}', "");
    Expect(1, 69838, '\P{Is_Sc=kthi}', "");
    Expect(0, 69838, '\P{^Is_Sc=kthi}', "");
    Expect(1, 69837, '\p{Is_Sc= kthi}', "");
    Expect(0, 69837, '\p{^Is_Sc= kthi}', "");
    Expect(0, 69837, '\P{Is_Sc= kthi}', "");
    Expect(1, 69837, '\P{^Is_Sc= kthi}', "");
    Expect(0, 69838, '\p{Is_Sc= kthi}', "");
    Expect(1, 69838, '\p{^Is_Sc= kthi}', "");
    Expect(1, 69838, '\P{Is_Sc= kthi}', "");
    Expect(0, 69838, '\P{^Is_Sc= kthi}', "");
    Error('\p{Script=	 Tai_THAM:=}');
    Error('\P{Script=	 Tai_THAM:=}');
    Expect(1, 6829, '\p{Script=:\ATai_Tham\z:}', "");;
    Expect(0, 6830, '\p{Script=:\ATai_Tham\z:}', "");;
    Expect(1, 6829, '\p{Script=taitham}', "");
    Expect(0, 6829, '\p{^Script=taitham}', "");
    Expect(0, 6829, '\P{Script=taitham}', "");
    Expect(1, 6829, '\P{^Script=taitham}', "");
    Expect(0, 6830, '\p{Script=taitham}', "");
    Expect(1, 6830, '\p{^Script=taitham}', "");
    Expect(1, 6830, '\P{Script=taitham}', "");
    Expect(0, 6830, '\P{^Script=taitham}', "");
    Expect(1, 6829, '\p{Script=:\Ataitham\z:}', "");;
    Expect(0, 6830, '\p{Script=:\Ataitham\z:}', "");;
    Expect(1, 6829, '\p{Script=-TAI_tham}', "");
    Expect(0, 6829, '\p{^Script=-TAI_tham}', "");
    Expect(0, 6829, '\P{Script=-TAI_tham}', "");
    Expect(1, 6829, '\P{^Script=-TAI_tham}', "");
    Expect(0, 6830, '\p{Script=-TAI_tham}', "");
    Expect(1, 6830, '\p{^Script=-TAI_tham}', "");
    Expect(1, 6830, '\P{Script=-TAI_tham}', "");
    Expect(0, 6830, '\P{^Script=-TAI_tham}', "");
    Error('\p{Sc=:= lana}');
    Error('\P{Sc=:= lana}');
    Expect(1, 6829, '\p{Sc=:\ALana\z:}', "");;
    Expect(0, 6830, '\p{Sc=:\ALana\z:}', "");;
    Expect(1, 6829, '\p{Sc=lana}', "");
    Expect(0, 6829, '\p{^Sc=lana}', "");
    Expect(0, 6829, '\P{Sc=lana}', "");
    Expect(1, 6829, '\P{^Sc=lana}', "");
    Expect(0, 6830, '\p{Sc=lana}', "");
    Expect(1, 6830, '\p{^Sc=lana}', "");
    Expect(1, 6830, '\P{Sc=lana}', "");
    Expect(0, 6830, '\P{^Sc=lana}', "");
    Expect(1, 6829, '\p{Sc=:\Alana\z:}', "");;
    Expect(0, 6830, '\p{Sc=:\Alana\z:}', "");;
    Expect(1, 6829, '\p{Sc:	 	lana}', "");
    Expect(0, 6829, '\p{^Sc:	 	lana}', "");
    Expect(0, 6829, '\P{Sc:	 	lana}', "");
    Expect(1, 6829, '\P{^Sc:	 	lana}', "");
    Expect(0, 6830, '\p{Sc:	 	lana}', "");
    Expect(1, 6830, '\p{^Sc:	 	lana}', "");
    Expect(1, 6830, '\P{Sc:	 	lana}', "");
    Expect(0, 6830, '\P{^Sc:	 	lana}', "");
    Error('\p{Is_Script=/a/TAI_Tham}');
    Error('\P{Is_Script=/a/TAI_Tham}');
    Expect(1, 6829, '\p{Is_Script=taitham}', "");
    Expect(0, 6829, '\p{^Is_Script=taitham}', "");
    Expect(0, 6829, '\P{Is_Script=taitham}', "");
    Expect(1, 6829, '\P{^Is_Script=taitham}', "");
    Expect(0, 6830, '\p{Is_Script=taitham}', "");
    Expect(1, 6830, '\p{^Is_Script=taitham}', "");
    Expect(1, 6830, '\P{Is_Script=taitham}', "");
    Expect(0, 6830, '\P{^Is_Script=taitham}', "");
    Expect(1, 6829, '\p{Is_Script=_Tai_Tham}', "");
    Expect(0, 6829, '\p{^Is_Script=_Tai_Tham}', "");
    Expect(0, 6829, '\P{Is_Script=_Tai_Tham}', "");
    Expect(1, 6829, '\P{^Is_Script=_Tai_Tham}', "");
    Expect(0, 6830, '\p{Is_Script=_Tai_Tham}', "");
    Expect(1, 6830, '\p{^Is_Script=_Tai_Tham}', "");
    Expect(1, 6830, '\P{Is_Script=_Tai_Tham}', "");
    Expect(0, 6830, '\P{^Is_Script=_Tai_Tham}', "");
    Error('\p{Is_Sc=_/a/Lana}');
    Error('\P{Is_Sc=_/a/Lana}');
    Expect(1, 6829, '\p{Is_Sc=lana}', "");
    Expect(0, 6829, '\p{^Is_Sc=lana}', "");
    Expect(0, 6829, '\P{Is_Sc=lana}', "");
    Expect(1, 6829, '\P{^Is_Sc=lana}', "");
    Expect(0, 6830, '\p{Is_Sc=lana}', "");
    Expect(1, 6830, '\p{^Is_Sc=lana}', "");
    Expect(1, 6830, '\P{Is_Sc=lana}', "");
    Expect(0, 6830, '\P{^Is_Sc=lana}', "");
    Expect(1, 6829, '\p{Is_Sc= LANA}', "");
    Expect(0, 6829, '\p{^Is_Sc= LANA}', "");
    Expect(0, 6829, '\P{Is_Sc= LANA}', "");
    Expect(1, 6829, '\P{^Is_Sc= LANA}', "");
    Expect(0, 6830, '\p{Is_Sc= LANA}', "");
    Expect(1, 6830, '\p{^Is_Sc= LANA}', "");
    Expect(1, 6830, '\P{Is_Sc= LANA}', "");
    Expect(0, 6830, '\P{^Is_Sc= LANA}', "");
    Error('\p{Script:	_Lao:=}');
    Error('\P{Script:	_Lao:=}');
    Expect(1, 3807, '\p{Script=:\ALao\z:}', "");;
    Expect(0, 3808, '\p{Script=:\ALao\z:}', "");;
    Expect(1, 3807, '\p{Script=lao}', "");
    Expect(0, 3807, '\p{^Script=lao}', "");
    Expect(0, 3807, '\P{Script=lao}', "");
    Expect(1, 3807, '\P{^Script=lao}', "");
    Expect(0, 3808, '\p{Script=lao}', "");
    Expect(1, 3808, '\p{^Script=lao}', "");
    Expect(1, 3808, '\P{Script=lao}', "");
    Expect(0, 3808, '\P{^Script=lao}', "");
    Expect(1, 3807, '\p{Script=:\Alao\z:}', "");;
    Expect(0, 3808, '\p{Script=:\Alao\z:}', "");;
    Expect(1, 3807, '\p{Script:    LAO}', "");
    Expect(0, 3807, '\p{^Script:    LAO}', "");
    Expect(0, 3807, '\P{Script:    LAO}', "");
    Expect(1, 3807, '\P{^Script:    LAO}', "");
    Expect(0, 3808, '\p{Script:    LAO}', "");
    Expect(1, 3808, '\p{^Script:    LAO}', "");
    Expect(1, 3808, '\P{Script:    LAO}', "");
    Expect(0, 3808, '\P{^Script:    LAO}', "");
    Error('\p{Sc=	:=laoo}');
    Error('\P{Sc=	:=laoo}');
    Expect(1, 3807, '\p{Sc=:\ALaoo\z:}', "");;
    Expect(0, 3808, '\p{Sc=:\ALaoo\z:}', "");;
    Expect(1, 3807, '\p{Sc:	laoo}', "");
    Expect(0, 3807, '\p{^Sc:	laoo}', "");
    Expect(0, 3807, '\P{Sc:	laoo}', "");
    Expect(1, 3807, '\P{^Sc:	laoo}', "");
    Expect(0, 3808, '\p{Sc:	laoo}', "");
    Expect(1, 3808, '\p{^Sc:	laoo}', "");
    Expect(1, 3808, '\P{Sc:	laoo}', "");
    Expect(0, 3808, '\P{^Sc:	laoo}', "");
    Expect(1, 3807, '\p{Sc=:\Alaoo\z:}', "");;
    Expect(0, 3808, '\p{Sc=:\Alaoo\z:}', "");;
    Expect(1, 3807, '\p{Sc=	Laoo}', "");
    Expect(0, 3807, '\p{^Sc=	Laoo}', "");
    Expect(0, 3807, '\P{Sc=	Laoo}', "");
    Expect(1, 3807, '\P{^Sc=	Laoo}', "");
    Expect(0, 3808, '\p{Sc=	Laoo}', "");
    Expect(1, 3808, '\p{^Sc=	Laoo}', "");
    Expect(1, 3808, '\P{Sc=	Laoo}', "");
    Expect(0, 3808, '\P{^Sc=	Laoo}', "");
    Error('\p{Is_Script=/a/ 	lao}');
    Error('\P{Is_Script=/a/ 	lao}');
    Expect(1, 3807, '\p{Is_Script=lao}', "");
    Expect(0, 3807, '\p{^Is_Script=lao}', "");
    Expect(0, 3807, '\P{Is_Script=lao}', "");
    Expect(1, 3807, '\P{^Is_Script=lao}', "");
    Expect(0, 3808, '\p{Is_Script=lao}', "");
    Expect(1, 3808, '\p{^Is_Script=lao}', "");
    Expect(1, 3808, '\P{Is_Script=lao}', "");
    Expect(0, 3808, '\P{^Is_Script=lao}', "");
    Expect(1, 3807, '\p{Is_Script=- Lao}', "");
    Expect(0, 3807, '\p{^Is_Script=- Lao}', "");
    Expect(0, 3807, '\P{Is_Script=- Lao}', "");
    Expect(1, 3807, '\P{^Is_Script=- Lao}', "");
    Expect(0, 3808, '\p{Is_Script=- Lao}', "");
    Expect(1, 3808, '\p{^Is_Script=- Lao}', "");
    Expect(1, 3808, '\P{Is_Script=- Lao}', "");
    Expect(0, 3808, '\P{^Is_Script=- Lao}', "");
    Error('\p{Is_Sc=/a/	Laoo}');
    Error('\P{Is_Sc=/a/	Laoo}');
    Expect(1, 3807, '\p{Is_Sc: laoo}', "");
    Expect(0, 3807, '\p{^Is_Sc: laoo}', "");
    Expect(0, 3807, '\P{Is_Sc: laoo}', "");
    Expect(1, 3807, '\P{^Is_Sc: laoo}', "");
    Expect(0, 3808, '\p{Is_Sc: laoo}', "");
    Expect(1, 3808, '\p{^Is_Sc: laoo}', "");
    Expect(1, 3808, '\P{Is_Sc: laoo}', "");
    Expect(0, 3808, '\P{^Is_Sc: laoo}', "");
    Expect(1, 3807, '\p{Is_Sc=-	Laoo}', "");
    Expect(0, 3807, '\p{^Is_Sc=-	Laoo}', "");
    Expect(0, 3807, '\P{Is_Sc=-	Laoo}', "");
    Expect(1, 3807, '\P{^Is_Sc=-	Laoo}', "");
    Expect(0, 3808, '\p{Is_Sc=-	Laoo}', "");
    Expect(1, 3808, '\p{^Is_Sc=-	Laoo}', "");
    Expect(1, 3808, '\P{Is_Sc=-	Laoo}', "");
    Expect(0, 3808, '\P{^Is_Sc=-	Laoo}', "");
    Error('\p{Script=/a/	 Latin}');
    Error('\P{Script=/a/	 Latin}');
    Expect(1, 65370, '\p{Script=:\ALatin\z:}', "");;
    Expect(0, 65371, '\p{Script=:\ALatin\z:}', "");;
    Expect(1, 65370, '\p{Script=latin}', "");
    Expect(0, 65370, '\p{^Script=latin}', "");
    Expect(0, 65370, '\P{Script=latin}', "");
    Expect(1, 65370, '\P{^Script=latin}', "");
    Expect(0, 65371, '\p{Script=latin}', "");
    Expect(1, 65371, '\p{^Script=latin}', "");
    Expect(1, 65371, '\P{Script=latin}', "");
    Expect(0, 65371, '\P{^Script=latin}', "");
    Expect(1, 65370, '\p{Script=:\Alatin\z:}', "");;
    Expect(0, 65371, '\p{Script=:\Alatin\z:}', "");;
    Expect(1, 65370, '\p{Script=_latin}', "");
    Expect(0, 65370, '\p{^Script=_latin}', "");
    Expect(0, 65370, '\P{Script=_latin}', "");
    Expect(1, 65370, '\P{^Script=_latin}', "");
    Expect(0, 65371, '\p{Script=_latin}', "");
    Expect(1, 65371, '\p{^Script=_latin}', "");
    Expect(1, 65371, '\P{Script=_latin}', "");
    Expect(0, 65371, '\P{^Script=_latin}', "");
    Error('\p{Sc=:=_-Latn}');
    Error('\P{Sc=:=_-Latn}');
    Expect(1, 65370, '\p{Sc=:\ALatn\z:}', "");;
    Expect(0, 65371, '\p{Sc=:\ALatn\z:}', "");;
    Expect(1, 65370, '\p{Sc=latn}', "");
    Expect(0, 65370, '\p{^Sc=latn}', "");
    Expect(0, 65370, '\P{Sc=latn}', "");
    Expect(1, 65370, '\P{^Sc=latn}', "");
    Expect(0, 65371, '\p{Sc=latn}', "");
    Expect(1, 65371, '\p{^Sc=latn}', "");
    Expect(1, 65371, '\P{Sc=latn}', "");
    Expect(0, 65371, '\P{^Sc=latn}', "");
    Expect(1, 65370, '\p{Sc=:\Alatn\z:}', "");;
    Expect(0, 65371, '\p{Sc=:\Alatn\z:}', "");;
    Expect(1, 65370, '\p{Sc=	-Latn}', "");
    Expect(0, 65370, '\p{^Sc=	-Latn}', "");
    Expect(0, 65370, '\P{Sc=	-Latn}', "");
    Expect(1, 65370, '\P{^Sc=	-Latn}', "");
    Expect(0, 65371, '\p{Sc=	-Latn}', "");
    Expect(1, 65371, '\p{^Sc=	-Latn}', "");
    Expect(1, 65371, '\P{Sc=	-Latn}', "");
    Expect(0, 65371, '\P{^Sc=	-Latn}', "");
    Error('\p{Is_Script=/a/ _LATIN}');
    Error('\P{Is_Script=/a/ _LATIN}');
    Expect(1, 65370, '\p{Is_Script=latin}', "");
    Expect(0, 65370, '\p{^Is_Script=latin}', "");
    Expect(0, 65370, '\P{Is_Script=latin}', "");
    Expect(1, 65370, '\P{^Is_Script=latin}', "");
    Expect(0, 65371, '\p{Is_Script=latin}', "");
    Expect(1, 65371, '\p{^Is_Script=latin}', "");
    Expect(1, 65371, '\P{Is_Script=latin}', "");
    Expect(0, 65371, '\P{^Is_Script=latin}', "");
    Expect(1, 65370, '\p{Is_Script=LATIN}', "");
    Expect(0, 65370, '\p{^Is_Script=LATIN}', "");
    Expect(0, 65370, '\P{Is_Script=LATIN}', "");
    Expect(1, 65370, '\P{^Is_Script=LATIN}', "");
    Expect(0, 65371, '\p{Is_Script=LATIN}', "");
    Expect(1, 65371, '\p{^Is_Script=LATIN}', "");
    Expect(1, 65371, '\P{Is_Script=LATIN}', "");
    Expect(0, 65371, '\P{^Is_Script=LATIN}', "");
    Error('\p{Is_Sc=:=  LATN}');
    Error('\P{Is_Sc=:=  LATN}');
    Expect(1, 65370, '\p{Is_Sc=latn}', "");
    Expect(0, 65370, '\p{^Is_Sc=latn}', "");
    Expect(0, 65370, '\P{Is_Sc=latn}', "");
    Expect(1, 65370, '\P{^Is_Sc=latn}', "");
    Expect(0, 65371, '\p{Is_Sc=latn}', "");
    Expect(1, 65371, '\p{^Is_Sc=latn}', "");
    Expect(1, 65371, '\P{Is_Sc=latn}', "");
    Expect(0, 65371, '\P{^Is_Sc=latn}', "");
    Expect(1, 65370, '\p{Is_Sc=_Latn}', "");
    Expect(0, 65370, '\p{^Is_Sc=_Latn}', "");
    Expect(0, 65370, '\P{Is_Sc=_Latn}', "");
    Expect(1, 65370, '\P{^Is_Sc=_Latn}', "");
    Expect(0, 65371, '\p{Is_Sc=_Latn}', "");
    Expect(1, 65371, '\p{^Is_Sc=_Latn}', "");
    Expect(1, 65371, '\P{Is_Sc=_Latn}', "");
    Expect(0, 65371, '\P{^Is_Sc=_Latn}', "");
    Error('\p{Script=:=-	Lepcha}');
    Error('\P{Script=:=-	Lepcha}');
    Expect(1, 7247, '\p{Script=:\ALepcha\z:}', "");;
    Expect(0, 7248, '\p{Script=:\ALepcha\z:}', "");;
    Expect(1, 7247, '\p{Script=lepcha}', "");
    Expect(0, 7247, '\p{^Script=lepcha}', "");
    Expect(0, 7247, '\P{Script=lepcha}', "");
    Expect(1, 7247, '\P{^Script=lepcha}', "");
    Expect(0, 7248, '\p{Script=lepcha}', "");
    Expect(1, 7248, '\p{^Script=lepcha}', "");
    Expect(1, 7248, '\P{Script=lepcha}', "");
    Expect(0, 7248, '\P{^Script=lepcha}', "");
    Expect(1, 7247, '\p{Script=:\Alepcha\z:}', "");;
    Expect(0, 7248, '\p{Script=:\Alepcha\z:}', "");;
    Expect(1, 7247, '\p{Script=	lepcha}', "");
    Expect(0, 7247, '\p{^Script=	lepcha}', "");
    Expect(0, 7247, '\P{Script=	lepcha}', "");
    Expect(1, 7247, '\P{^Script=	lepcha}', "");
    Expect(0, 7248, '\p{Script=	lepcha}', "");
    Expect(1, 7248, '\p{^Script=	lepcha}', "");
    Expect(1, 7248, '\P{Script=	lepcha}', "");
    Expect(0, 7248, '\P{^Script=	lepcha}', "");
    Error('\p{Sc:-Lepc:=}');
    Error('\P{Sc:-Lepc:=}');
    Expect(1, 7247, '\p{Sc=:\ALepc\z:}', "");;
    Expect(0, 7248, '\p{Sc=:\ALepc\z:}', "");;
    Expect(1, 7247, '\p{Sc=lepc}', "");
    Expect(0, 7247, '\p{^Sc=lepc}', "");
    Expect(0, 7247, '\P{Sc=lepc}', "");
    Expect(1, 7247, '\P{^Sc=lepc}', "");
    Expect(0, 7248, '\p{Sc=lepc}', "");
    Expect(1, 7248, '\p{^Sc=lepc}', "");
    Expect(1, 7248, '\P{Sc=lepc}', "");
    Expect(0, 7248, '\P{^Sc=lepc}', "");
    Expect(1, 7247, '\p{Sc=:\Alepc\z:}', "");;
    Expect(0, 7248, '\p{Sc=:\Alepc\z:}', "");;
    Expect(1, 7247, '\p{Sc=_LEPC}', "");
    Expect(0, 7247, '\p{^Sc=_LEPC}', "");
    Expect(0, 7247, '\P{Sc=_LEPC}', "");
    Expect(1, 7247, '\P{^Sc=_LEPC}', "");
    Expect(0, 7248, '\p{Sc=_LEPC}', "");
    Expect(1, 7248, '\p{^Sc=_LEPC}', "");
    Expect(1, 7248, '\P{Sc=_LEPC}', "");
    Expect(0, 7248, '\P{^Sc=_LEPC}', "");
    Error('\p{Is_Script= /a/Lepcha}');
    Error('\P{Is_Script= /a/Lepcha}');
    Expect(1, 7247, '\p{Is_Script=lepcha}', "");
    Expect(0, 7247, '\p{^Is_Script=lepcha}', "");
    Expect(0, 7247, '\P{Is_Script=lepcha}', "");
    Expect(1, 7247, '\P{^Is_Script=lepcha}', "");
    Expect(0, 7248, '\p{Is_Script=lepcha}', "");
    Expect(1, 7248, '\p{^Is_Script=lepcha}', "");
    Expect(1, 7248, '\P{Is_Script=lepcha}', "");
    Expect(0, 7248, '\P{^Is_Script=lepcha}', "");
    Expect(1, 7247, '\p{Is_Script=_-Lepcha}', "");
    Expect(0, 7247, '\p{^Is_Script=_-Lepcha}', "");
    Expect(0, 7247, '\P{Is_Script=_-Lepcha}', "");
    Expect(1, 7247, '\P{^Is_Script=_-Lepcha}', "");
    Expect(0, 7248, '\p{Is_Script=_-Lepcha}', "");
    Expect(1, 7248, '\p{^Is_Script=_-Lepcha}', "");
    Expect(1, 7248, '\P{Is_Script=_-Lepcha}', "");
    Expect(0, 7248, '\P{^Is_Script=_-Lepcha}', "");
    Error('\p{Is_Sc=/a/Lepc}');
    Error('\P{Is_Sc=/a/Lepc}');
    Expect(1, 7247, '\p{Is_Sc=lepc}', "");
    Expect(0, 7247, '\p{^Is_Sc=lepc}', "");
    Expect(0, 7247, '\P{Is_Sc=lepc}', "");
    Expect(1, 7247, '\P{^Is_Sc=lepc}', "");
    Expect(0, 7248, '\p{Is_Sc=lepc}', "");
    Expect(1, 7248, '\p{^Is_Sc=lepc}', "");
    Expect(1, 7248, '\P{Is_Sc=lepc}', "");
    Expect(0, 7248, '\P{^Is_Sc=lepc}', "");
    Expect(1, 7247, '\p{Is_Sc=	-Lepc}', "");
    Expect(0, 7247, '\p{^Is_Sc=	-Lepc}', "");
    Expect(0, 7247, '\P{Is_Sc=	-Lepc}', "");
    Expect(1, 7247, '\P{^Is_Sc=	-Lepc}', "");
    Expect(0, 7248, '\p{Is_Sc=	-Lepc}', "");
    Expect(1, 7248, '\p{^Is_Sc=	-Lepc}', "");
    Expect(1, 7248, '\P{Is_Sc=	-Lepc}', "");
    Expect(0, 7248, '\P{^Is_Sc=	-Lepc}', "");
    Error('\p{Script=_ Limbu:=}');
    Error('\P{Script=_ Limbu:=}');
    Expect(1, 6479, '\p{Script=:\ALimbu\z:}', "");;
    Expect(0, 6480, '\p{Script=:\ALimbu\z:}', "");;
    Expect(1, 6479, '\p{Script=limbu}', "");
    Expect(0, 6479, '\p{^Script=limbu}', "");
    Expect(0, 6479, '\P{Script=limbu}', "");
    Expect(1, 6479, '\P{^Script=limbu}', "");
    Expect(0, 6480, '\p{Script=limbu}', "");
    Expect(1, 6480, '\p{^Script=limbu}', "");
    Expect(1, 6480, '\P{Script=limbu}', "");
    Expect(0, 6480, '\P{^Script=limbu}', "");
    Expect(1, 6479, '\p{Script=:\Alimbu\z:}', "");;
    Expect(0, 6480, '\p{Script=:\Alimbu\z:}', "");;
    Expect(1, 6479, '\p{Script=__limbu}', "");
    Expect(0, 6479, '\p{^Script=__limbu}', "");
    Expect(0, 6479, '\P{Script=__limbu}', "");
    Expect(1, 6479, '\P{^Script=__limbu}', "");
    Expect(0, 6480, '\p{Script=__limbu}', "");
    Expect(1, 6480, '\p{^Script=__limbu}', "");
    Expect(1, 6480, '\P{Script=__limbu}', "");
    Expect(0, 6480, '\P{^Script=__limbu}', "");
    Error('\p{Sc: -	limb:=}');
    Error('\P{Sc: -	limb:=}');
    Expect(1, 6479, '\p{Sc=:\ALimb\z:}', "");;
    Expect(0, 6480, '\p{Sc=:\ALimb\z:}', "");;
    Expect(1, 6479, '\p{Sc=limb}', "");
    Expect(0, 6479, '\p{^Sc=limb}', "");
    Expect(0, 6479, '\P{Sc=limb}', "");
    Expect(1, 6479, '\P{^Sc=limb}', "");
    Expect(0, 6480, '\p{Sc=limb}', "");
    Expect(1, 6480, '\p{^Sc=limb}', "");
    Expect(1, 6480, '\P{Sc=limb}', "");
    Expect(0, 6480, '\P{^Sc=limb}', "");
    Expect(1, 6479, '\p{Sc=:\Alimb\z:}', "");;
    Expect(0, 6480, '\p{Sc=:\Alimb\z:}', "");;
    Expect(1, 6479, '\p{Sc= LIMB}', "");
    Expect(0, 6479, '\p{^Sc= LIMB}', "");
    Expect(0, 6479, '\P{Sc= LIMB}', "");
    Expect(1, 6479, '\P{^Sc= LIMB}', "");
    Expect(0, 6480, '\p{Sc= LIMB}', "");
    Expect(1, 6480, '\p{^Sc= LIMB}', "");
    Expect(1, 6480, '\P{Sc= LIMB}', "");
    Expect(0, 6480, '\P{^Sc= LIMB}', "");
    Error('\p{Is_Script=--limbu/a/}');
    Error('\P{Is_Script=--limbu/a/}');
    Expect(1, 6479, '\p{Is_Script=limbu}', "");
    Expect(0, 6479, '\p{^Is_Script=limbu}', "");
    Expect(0, 6479, '\P{Is_Script=limbu}', "");
    Expect(1, 6479, '\P{^Is_Script=limbu}', "");
    Expect(0, 6480, '\p{Is_Script=limbu}', "");
    Expect(1, 6480, '\p{^Is_Script=limbu}', "");
    Expect(1, 6480, '\P{Is_Script=limbu}', "");
    Expect(0, 6480, '\P{^Is_Script=limbu}', "");
    Expect(1, 6479, '\p{Is_Script=- Limbu}', "");
    Expect(0, 6479, '\p{^Is_Script=- Limbu}', "");
    Expect(0, 6479, '\P{Is_Script=- Limbu}', "");
    Expect(1, 6479, '\P{^Is_Script=- Limbu}', "");
    Expect(0, 6480, '\p{Is_Script=- Limbu}', "");
    Expect(1, 6480, '\p{^Is_Script=- Limbu}', "");
    Expect(1, 6480, '\P{Is_Script=- Limbu}', "");
    Expect(0, 6480, '\P{^Is_Script=- Limbu}', "");
    Error('\p{Is_Sc=	-limb/a/}');
    Error('\P{Is_Sc=	-limb/a/}');
    Expect(1, 6479, '\p{Is_Sc=limb}', "");
    Expect(0, 6479, '\p{^Is_Sc=limb}', "");
    Expect(0, 6479, '\P{Is_Sc=limb}', "");
    Expect(1, 6479, '\P{^Is_Sc=limb}', "");
    Expect(0, 6480, '\p{Is_Sc=limb}', "");
    Expect(1, 6480, '\p{^Is_Sc=limb}', "");
    Expect(1, 6480, '\P{Is_Sc=limb}', "");
    Expect(0, 6480, '\P{^Is_Sc=limb}', "");
    Expect(1, 6479, '\p{Is_Sc: -Limb}', "");
    Expect(0, 6479, '\p{^Is_Sc: -Limb}', "");
    Expect(0, 6479, '\P{Is_Sc: -Limb}', "");
    Expect(1, 6479, '\P{^Is_Sc: -Limb}', "");
    Expect(0, 6480, '\p{Is_Sc: -Limb}', "");
    Expect(1, 6480, '\p{^Is_Sc: -Limb}', "");
    Expect(1, 6480, '\P{Is_Sc: -Limb}', "");
    Expect(0, 6480, '\P{^Is_Sc: -Limb}', "");
    Error('\p{Script=/a/-	LINEAR_A}');
    Error('\P{Script=/a/-	LINEAR_A}');
    Expect(1, 67431, '\p{Script=:\ALinear_A\z:}', "");;
    Expect(0, 67432, '\p{Script=:\ALinear_A\z:}', "");;
    Expect(1, 67431, '\p{Script=lineara}', "");
    Expect(0, 67431, '\p{^Script=lineara}', "");
    Expect(0, 67431, '\P{Script=lineara}', "");
    Expect(1, 67431, '\P{^Script=lineara}', "");
    Expect(0, 67432, '\p{Script=lineara}', "");
    Expect(1, 67432, '\p{^Script=lineara}', "");
    Expect(1, 67432, '\P{Script=lineara}', "");
    Expect(0, 67432, '\P{^Script=lineara}', "");
    Expect(1, 67431, '\p{Script=:\Alineara\z:}', "");;
    Expect(0, 67432, '\p{Script=:\Alineara\z:}', "");;
    Expect(1, 67431, '\p{Script=_LINEAR_a}', "");
    Expect(0, 67431, '\p{^Script=_LINEAR_a}', "");
    Expect(0, 67431, '\P{Script=_LINEAR_a}', "");
    Expect(1, 67431, '\P{^Script=_LINEAR_a}', "");
    Expect(0, 67432, '\p{Script=_LINEAR_a}', "");
    Expect(1, 67432, '\p{^Script=_LINEAR_a}', "");
    Expect(1, 67432, '\P{Script=_LINEAR_a}', "");
    Expect(0, 67432, '\P{^Script=_LINEAR_a}', "");
    Error('\p{Sc=__lina:=}');
    Error('\P{Sc=__lina:=}');
    Expect(1, 67431, '\p{Sc=:\ALina\z:}', "");;
    Expect(0, 67432, '\p{Sc=:\ALina\z:}', "");;
    Expect(1, 67431, '\p{Sc=lina}', "");
    Expect(0, 67431, '\p{^Sc=lina}', "");
    Expect(0, 67431, '\P{Sc=lina}', "");
    Expect(1, 67431, '\P{^Sc=lina}', "");
    Expect(0, 67432, '\p{Sc=lina}', "");
    Expect(1, 67432, '\p{^Sc=lina}', "");
    Expect(1, 67432, '\P{Sc=lina}', "");
    Expect(0, 67432, '\P{^Sc=lina}', "");
    Expect(1, 67431, '\p{Sc=:\Alina\z:}', "");;
    Expect(0, 67432, '\p{Sc=:\Alina\z:}', "");;
    Expect(1, 67431, '\p{Sc=_-Lina}', "");
    Expect(0, 67431, '\p{^Sc=_-Lina}', "");
    Expect(0, 67431, '\P{Sc=_-Lina}', "");
    Expect(1, 67431, '\P{^Sc=_-Lina}', "");
    Expect(0, 67432, '\p{Sc=_-Lina}', "");
    Expect(1, 67432, '\p{^Sc=_-Lina}', "");
    Expect(1, 67432, '\P{Sc=_-Lina}', "");
    Expect(0, 67432, '\P{^Sc=_-Lina}', "");
    Error('\p{Is_Script: :=_-Linear_a}');
    Error('\P{Is_Script: :=_-Linear_a}');
    Expect(1, 67431, '\p{Is_Script:lineara}', "");
    Expect(0, 67431, '\p{^Is_Script:lineara}', "");
    Expect(0, 67431, '\P{Is_Script:lineara}', "");
    Expect(1, 67431, '\P{^Is_Script:lineara}', "");
    Expect(0, 67432, '\p{Is_Script:lineara}', "");
    Expect(1, 67432, '\p{^Is_Script:lineara}', "");
    Expect(1, 67432, '\P{Is_Script:lineara}', "");
    Expect(0, 67432, '\P{^Is_Script:lineara}', "");
    Expect(1, 67431, '\p{Is_Script=--Linear_a}', "");
    Expect(0, 67431, '\p{^Is_Script=--Linear_a}', "");
    Expect(0, 67431, '\P{Is_Script=--Linear_a}', "");
    Expect(1, 67431, '\P{^Is_Script=--Linear_a}', "");
    Expect(0, 67432, '\p{Is_Script=--Linear_a}', "");
    Expect(1, 67432, '\p{^Is_Script=--Linear_a}', "");
    Expect(1, 67432, '\P{Is_Script=--Linear_a}', "");
    Expect(0, 67432, '\P{^Is_Script=--Linear_a}', "");
    Error('\p{Is_Sc=	:=Lina}');
    Error('\P{Is_Sc=	:=Lina}');
    Expect(1, 67431, '\p{Is_Sc=lina}', "");
    Expect(0, 67431, '\p{^Is_Sc=lina}', "");
    Expect(0, 67431, '\P{Is_Sc=lina}', "");
    Expect(1, 67431, '\P{^Is_Sc=lina}', "");
    Expect(0, 67432, '\p{Is_Sc=lina}', "");
    Expect(1, 67432, '\p{^Is_Sc=lina}', "");
    Expect(1, 67432, '\P{Is_Sc=lina}', "");
    Expect(0, 67432, '\P{^Is_Sc=lina}', "");
    Expect(1, 67431, '\p{Is_Sc=	_lina}', "");
    Expect(0, 67431, '\p{^Is_Sc=	_lina}', "");
    Expect(0, 67431, '\P{Is_Sc=	_lina}', "");
    Expect(1, 67431, '\P{^Is_Sc=	_lina}', "");
    Expect(0, 67432, '\p{Is_Sc=	_lina}', "");
    Expect(1, 67432, '\p{^Is_Sc=	_lina}', "");
    Expect(1, 67432, '\P{Is_Sc=	_lina}', "");
    Expect(0, 67432, '\P{^Is_Sc=	_lina}', "");
    Error('\p{Script=:=linear_b}');
    Error('\P{Script=:=linear_b}');
    Expect(1, 65786, '\p{Script=:\ALinear_B\z:}', "");;
    Expect(0, 65787, '\p{Script=:\ALinear_B\z:}', "");;
    Expect(1, 65786, '\p{Script=linearb}', "");
    Expect(0, 65786, '\p{^Script=linearb}', "");
    Expect(0, 65786, '\P{Script=linearb}', "");
    Expect(1, 65786, '\P{^Script=linearb}', "");
    Expect(0, 65787, '\p{Script=linearb}', "");
    Expect(1, 65787, '\p{^Script=linearb}', "");
    Expect(1, 65787, '\P{Script=linearb}', "");
    Expect(0, 65787, '\P{^Script=linearb}', "");
    Expect(1, 65786, '\p{Script=:\Alinearb\z:}', "");;
    Expect(0, 65787, '\p{Script=:\Alinearb\z:}', "");;
    Expect(1, 65786, '\p{Script=	-Linear_B}', "");
    Expect(0, 65786, '\p{^Script=	-Linear_B}', "");
    Expect(0, 65786, '\P{Script=	-Linear_B}', "");
    Expect(1, 65786, '\P{^Script=	-Linear_B}', "");
    Expect(0, 65787, '\p{Script=	-Linear_B}', "");
    Expect(1, 65787, '\p{^Script=	-Linear_B}', "");
    Expect(1, 65787, '\P{Script=	-Linear_B}', "");
    Expect(0, 65787, '\P{^Script=	-Linear_B}', "");
    Error('\p{Sc:_	Linb:=}');
    Error('\P{Sc:_	Linb:=}');
    Expect(1, 65786, '\p{Sc=:\ALinb\z:}', "");;
    Expect(0, 65787, '\p{Sc=:\ALinb\z:}', "");;
    Expect(1, 65786, '\p{Sc=linb}', "");
    Expect(0, 65786, '\p{^Sc=linb}', "");
    Expect(0, 65786, '\P{Sc=linb}', "");
    Expect(1, 65786, '\P{^Sc=linb}', "");
    Expect(0, 65787, '\p{Sc=linb}', "");
    Expect(1, 65787, '\p{^Sc=linb}', "");
    Expect(1, 65787, '\P{Sc=linb}', "");
    Expect(0, 65787, '\P{^Sc=linb}', "");
    Expect(1, 65786, '\p{Sc=:\Alinb\z:}', "");;
    Expect(0, 65787, '\p{Sc=:\Alinb\z:}', "");;
    Expect(1, 65786, '\p{Sc:-linb}', "");
    Expect(0, 65786, '\p{^Sc:-linb}', "");
    Expect(0, 65786, '\P{Sc:-linb}', "");
    Expect(1, 65786, '\P{^Sc:-linb}', "");
    Expect(0, 65787, '\p{Sc:-linb}', "");
    Expect(1, 65787, '\p{^Sc:-linb}', "");
    Expect(1, 65787, '\P{Sc:-linb}', "");
    Expect(0, 65787, '\P{^Sc:-linb}', "");
    Error('\p{Is_Script:/a/Linear_B}');
    Error('\P{Is_Script:/a/Linear_B}');
    Expect(1, 65786, '\p{Is_Script=linearb}', "");
    Expect(0, 65786, '\p{^Is_Script=linearb}', "");
    Expect(0, 65786, '\P{Is_Script=linearb}', "");
    Expect(1, 65786, '\P{^Is_Script=linearb}', "");
    Expect(0, 65787, '\p{Is_Script=linearb}', "");
    Expect(1, 65787, '\p{^Is_Script=linearb}', "");
    Expect(1, 65787, '\P{Is_Script=linearb}', "");
    Expect(0, 65787, '\P{^Is_Script=linearb}', "");
    Expect(1, 65786, '\p{Is_Script= Linear_B}', "");
    Expect(0, 65786, '\p{^Is_Script= Linear_B}', "");
    Expect(0, 65786, '\P{Is_Script= Linear_B}', "");
    Expect(1, 65786, '\P{^Is_Script= Linear_B}', "");
    Expect(0, 65787, '\p{Is_Script= Linear_B}', "");
    Expect(1, 65787, '\p{^Is_Script= Linear_B}', "");
    Expect(1, 65787, '\P{Is_Script= Linear_B}', "");
    Expect(0, 65787, '\P{^Is_Script= Linear_B}', "");
    Error('\p{Is_Sc=:= 	LINB}');
    Error('\P{Is_Sc=:= 	LINB}');
    Expect(1, 65786, '\p{Is_Sc=linb}', "");
    Expect(0, 65786, '\p{^Is_Sc=linb}', "");
    Expect(0, 65786, '\P{Is_Sc=linb}', "");
    Expect(1, 65786, '\P{^Is_Sc=linb}', "");
    Expect(0, 65787, '\p{Is_Sc=linb}', "");
    Expect(1, 65787, '\p{^Is_Sc=linb}', "");
    Expect(1, 65787, '\P{Is_Sc=linb}', "");
    Expect(0, 65787, '\P{^Is_Sc=linb}', "");
    Expect(1, 65786, '\p{Is_Sc=-_Linb}', "");
    Expect(0, 65786, '\p{^Is_Sc=-_Linb}', "");
    Expect(0, 65786, '\P{Is_Sc=-_Linb}', "");
    Expect(1, 65786, '\P{^Is_Sc=-_Linb}', "");
    Expect(0, 65787, '\p{Is_Sc=-_Linb}', "");
    Expect(1, 65787, '\p{^Is_Sc=-_Linb}', "");
    Expect(1, 65787, '\P{Is_Sc=-_Linb}', "");
    Expect(0, 65787, '\P{^Is_Sc=-_Linb}', "");
    Error('\p{Script=-/a/LISU}');
    Error('\P{Script=-/a/LISU}');
    Expect(1, 42239, '\p{Script=:\ALisu\z:}', "");;
    Expect(0, 42240, '\p{Script=:\ALisu\z:}', "");;
    Expect(1, 42239, '\p{Script=lisu}', "");
    Expect(0, 42239, '\p{^Script=lisu}', "");
    Expect(0, 42239, '\P{Script=lisu}', "");
    Expect(1, 42239, '\P{^Script=lisu}', "");
    Expect(0, 42240, '\p{Script=lisu}', "");
    Expect(1, 42240, '\p{^Script=lisu}', "");
    Expect(1, 42240, '\P{Script=lisu}', "");
    Expect(0, 42240, '\P{^Script=lisu}', "");
    Expect(1, 42239, '\p{Script=:\Alisu\z:}', "");;
    Expect(0, 42240, '\p{Script=:\Alisu\z:}', "");;
    Expect(1, 42239, '\p{Script=--lisu}', "");
    Expect(0, 42239, '\p{^Script=--lisu}', "");
    Expect(0, 42239, '\P{Script=--lisu}', "");
    Expect(1, 42239, '\P{^Script=--lisu}', "");
    Expect(0, 42240, '\p{Script=--lisu}', "");
    Expect(1, 42240, '\p{^Script=--lisu}', "");
    Expect(1, 42240, '\P{Script=--lisu}', "");
    Expect(0, 42240, '\P{^Script=--lisu}', "");
    Error('\p{Sc=-LISU:=}');
    Error('\P{Sc=-LISU:=}');
    Expect(1, 42239, '\p{Sc=:\ALisu\z:}', "");;
    Expect(0, 42240, '\p{Sc=:\ALisu\z:}', "");;
    Expect(1, 42239, '\p{Sc=lisu}', "");
    Expect(0, 42239, '\p{^Sc=lisu}', "");
    Expect(0, 42239, '\P{Sc=lisu}', "");
    Expect(1, 42239, '\P{^Sc=lisu}', "");
    Expect(0, 42240, '\p{Sc=lisu}', "");
    Expect(1, 42240, '\p{^Sc=lisu}', "");
    Expect(1, 42240, '\P{Sc=lisu}', "");
    Expect(0, 42240, '\P{^Sc=lisu}', "");
    Expect(1, 42239, '\p{Sc=:\Alisu\z:}', "");;
    Expect(0, 42240, '\p{Sc=:\Alisu\z:}', "");;
    Expect(1, 42239, '\p{Sc=	-Lisu}', "");
    Expect(0, 42239, '\p{^Sc=	-Lisu}', "");
    Expect(0, 42239, '\P{Sc=	-Lisu}', "");
    Expect(1, 42239, '\P{^Sc=	-Lisu}', "");
    Expect(0, 42240, '\p{Sc=	-Lisu}', "");
    Expect(1, 42240, '\p{^Sc=	-Lisu}', "");
    Expect(1, 42240, '\P{Sc=	-Lisu}', "");
    Expect(0, 42240, '\P{^Sc=	-Lisu}', "");
    Error('\p{Is_Script=/a/-Lisu}');
    Error('\P{Is_Script=/a/-Lisu}');
    Expect(1, 42239, '\p{Is_Script=lisu}', "");
    Expect(0, 42239, '\p{^Is_Script=lisu}', "");
    Expect(0, 42239, '\P{Is_Script=lisu}', "");
    Expect(1, 42239, '\P{^Is_Script=lisu}', "");
    Expect(0, 42240, '\p{Is_Script=lisu}', "");
    Expect(1, 42240, '\p{^Is_Script=lisu}', "");
    Expect(1, 42240, '\P{Is_Script=lisu}', "");
    Expect(0, 42240, '\P{^Is_Script=lisu}', "");
    Expect(1, 42239, '\p{Is_Script=_Lisu}', "");
    Expect(0, 42239, '\p{^Is_Script=_Lisu}', "");
    Expect(0, 42239, '\P{Is_Script=_Lisu}', "");
    Expect(1, 42239, '\P{^Is_Script=_Lisu}', "");
    Expect(0, 42240, '\p{Is_Script=_Lisu}', "");
    Expect(1, 42240, '\p{^Is_Script=_Lisu}', "");
    Expect(1, 42240, '\P{Is_Script=_Lisu}', "");
    Expect(0, 42240, '\P{^Is_Script=_Lisu}', "");
    Error('\p{Is_Sc=/a/-_Lisu}');
    Error('\P{Is_Sc=/a/-_Lisu}');
    Expect(1, 42239, '\p{Is_Sc=lisu}', "");
    Expect(0, 42239, '\p{^Is_Sc=lisu}', "");
    Expect(0, 42239, '\P{Is_Sc=lisu}', "");
    Expect(1, 42239, '\P{^Is_Sc=lisu}', "");
    Expect(0, 42240, '\p{Is_Sc=lisu}', "");
    Expect(1, 42240, '\p{^Is_Sc=lisu}', "");
    Expect(1, 42240, '\P{Is_Sc=lisu}', "");
    Expect(0, 42240, '\P{^Is_Sc=lisu}', "");
    Expect(1, 42239, '\p{Is_Sc= LISU}', "");
    Expect(0, 42239, '\p{^Is_Sc= LISU}', "");
    Expect(0, 42239, '\P{Is_Sc= LISU}', "");
    Expect(1, 42239, '\P{^Is_Sc= LISU}', "");
    Expect(0, 42240, '\p{Is_Sc= LISU}', "");
    Expect(1, 42240, '\p{^Is_Sc= LISU}', "");
    Expect(1, 42240, '\P{Is_Sc= LISU}', "");
    Expect(0, 42240, '\P{^Is_Sc= LISU}', "");
    Error('\p{Script=  lycian:=}');
    Error('\P{Script=  lycian:=}');
    Expect(1, 66204, '\p{Script=:\ALycian\z:}', "");;
    Expect(0, 66205, '\p{Script=:\ALycian\z:}', "");;
    Expect(1, 66204, '\p{Script=lycian}', "");
    Expect(0, 66204, '\p{^Script=lycian}', "");
    Expect(0, 66204, '\P{Script=lycian}', "");
    Expect(1, 66204, '\P{^Script=lycian}', "");
    Expect(0, 66205, '\p{Script=lycian}', "");
    Expect(1, 66205, '\p{^Script=lycian}', "");
    Expect(1, 66205, '\P{Script=lycian}', "");
    Expect(0, 66205, '\P{^Script=lycian}', "");
    Expect(1, 66204, '\p{Script=:\Alycian\z:}', "");;
    Expect(0, 66205, '\p{Script=:\Alycian\z:}', "");;
    Expect(1, 66204, '\p{Script=-Lycian}', "");
    Expect(0, 66204, '\p{^Script=-Lycian}', "");
    Expect(0, 66204, '\P{Script=-Lycian}', "");
    Expect(1, 66204, '\P{^Script=-Lycian}', "");
    Expect(0, 66205, '\p{Script=-Lycian}', "");
    Expect(1, 66205, '\p{^Script=-Lycian}', "");
    Expect(1, 66205, '\P{Script=-Lycian}', "");
    Expect(0, 66205, '\P{^Script=-Lycian}', "");
    Error('\p{Sc=:= Lyci}');
    Error('\P{Sc=:= Lyci}');
    Expect(1, 66204, '\p{Sc=:\ALyci\z:}', "");;
    Expect(0, 66205, '\p{Sc=:\ALyci\z:}', "");;
    Expect(1, 66204, '\p{Sc=lyci}', "");
    Expect(0, 66204, '\p{^Sc=lyci}', "");
    Expect(0, 66204, '\P{Sc=lyci}', "");
    Expect(1, 66204, '\P{^Sc=lyci}', "");
    Expect(0, 66205, '\p{Sc=lyci}', "");
    Expect(1, 66205, '\p{^Sc=lyci}', "");
    Expect(1, 66205, '\P{Sc=lyci}', "");
    Expect(0, 66205, '\P{^Sc=lyci}', "");
    Expect(1, 66204, '\p{Sc=:\Alyci\z:}', "");;
    Expect(0, 66205, '\p{Sc=:\Alyci\z:}', "");;
    Expect(1, 66204, '\p{Sc=- LYCI}', "");
    Expect(0, 66204, '\p{^Sc=- LYCI}', "");
    Expect(0, 66204, '\P{Sc=- LYCI}', "");
    Expect(1, 66204, '\P{^Sc=- LYCI}', "");
    Expect(0, 66205, '\p{Sc=- LYCI}', "");
    Expect(1, 66205, '\p{^Sc=- LYCI}', "");
    Expect(1, 66205, '\P{Sc=- LYCI}', "");
    Expect(0, 66205, '\P{^Sc=- LYCI}', "");
    Error('\p{Is_Script=		LYCIAN/a/}');
    Error('\P{Is_Script=		LYCIAN/a/}');
    Expect(1, 66204, '\p{Is_Script:   lycian}', "");
    Expect(0, 66204, '\p{^Is_Script:   lycian}', "");
    Expect(0, 66204, '\P{Is_Script:   lycian}', "");
    Expect(1, 66204, '\P{^Is_Script:   lycian}', "");
    Expect(0, 66205, '\p{Is_Script:   lycian}', "");
    Expect(1, 66205, '\p{^Is_Script:   lycian}', "");
    Expect(1, 66205, '\P{Is_Script:   lycian}', "");
    Expect(0, 66205, '\P{^Is_Script:   lycian}', "");
    Expect(1, 66204, '\p{Is_Script=-Lycian}', "");
    Expect(0, 66204, '\p{^Is_Script=-Lycian}', "");
    Expect(0, 66204, '\P{Is_Script=-Lycian}', "");
    Expect(1, 66204, '\P{^Is_Script=-Lycian}', "");
    Expect(0, 66205, '\p{Is_Script=-Lycian}', "");
    Expect(1, 66205, '\p{^Is_Script=-Lycian}', "");
    Expect(1, 66205, '\P{Is_Script=-Lycian}', "");
    Expect(0, 66205, '\P{^Is_Script=-Lycian}', "");
    Error('\p{Is_Sc= _LYCI:=}');
    Error('\P{Is_Sc= _LYCI:=}');
    Expect(1, 66204, '\p{Is_Sc=lyci}', "");
    Expect(0, 66204, '\p{^Is_Sc=lyci}', "");
    Expect(0, 66204, '\P{Is_Sc=lyci}', "");
    Expect(1, 66204, '\P{^Is_Sc=lyci}', "");
    Expect(0, 66205, '\p{Is_Sc=lyci}', "");
    Expect(1, 66205, '\p{^Is_Sc=lyci}', "");
    Expect(1, 66205, '\P{Is_Sc=lyci}', "");
    Expect(0, 66205, '\P{^Is_Sc=lyci}', "");
    Expect(1, 66204, '\p{Is_Sc: _Lyci}', "");
    Expect(0, 66204, '\p{^Is_Sc: _Lyci}', "");
    Expect(0, 66204, '\P{Is_Sc: _Lyci}', "");
    Expect(1, 66204, '\P{^Is_Sc: _Lyci}', "");
    Expect(0, 66205, '\p{Is_Sc: _Lyci}', "");
    Expect(1, 66205, '\p{^Is_Sc: _Lyci}', "");
    Expect(1, 66205, '\P{Is_Sc: _Lyci}', "");
    Expect(0, 66205, '\P{^Is_Sc: _Lyci}', "");
    Error('\p{Script=-LYDIAN/a/}');
    Error('\P{Script=-LYDIAN/a/}');
    Expect(1, 67903, '\p{Script=:\ALydian\z:}', "");;
    Expect(0, 67904, '\p{Script=:\ALydian\z:}', "");;
    Expect(1, 67903, '\p{Script=lydian}', "");
    Expect(0, 67903, '\p{^Script=lydian}', "");
    Expect(0, 67903, '\P{Script=lydian}', "");
    Expect(1, 67903, '\P{^Script=lydian}', "");
    Expect(0, 67904, '\p{Script=lydian}', "");
    Expect(1, 67904, '\p{^Script=lydian}', "");
    Expect(1, 67904, '\P{Script=lydian}', "");
    Expect(0, 67904, '\P{^Script=lydian}', "");
    Expect(1, 67903, '\p{Script=:\Alydian\z:}', "");;
    Expect(0, 67904, '\p{Script=:\Alydian\z:}', "");;
    Expect(1, 67903, '\p{Script=	_lydian}', "");
    Expect(0, 67903, '\p{^Script=	_lydian}', "");
    Expect(0, 67903, '\P{Script=	_lydian}', "");
    Expect(1, 67903, '\P{^Script=	_lydian}', "");
    Expect(0, 67904, '\p{Script=	_lydian}', "");
    Expect(1, 67904, '\p{^Script=	_lydian}', "");
    Expect(1, 67904, '\P{Script=	_lydian}', "");
    Expect(0, 67904, '\P{^Script=	_lydian}', "");
    Error('\p{Sc:   _:=Lydi}');
    Error('\P{Sc:   _:=Lydi}');
    Expect(1, 67903, '\p{Sc=:\ALydi\z:}', "");;
    Expect(0, 67904, '\p{Sc=:\ALydi\z:}', "");;
    Expect(1, 67903, '\p{Sc=lydi}', "");
    Expect(0, 67903, '\p{^Sc=lydi}', "");
    Expect(0, 67903, '\P{Sc=lydi}', "");
    Expect(1, 67903, '\P{^Sc=lydi}', "");
    Expect(0, 67904, '\p{Sc=lydi}', "");
    Expect(1, 67904, '\p{^Sc=lydi}', "");
    Expect(1, 67904, '\P{Sc=lydi}', "");
    Expect(0, 67904, '\P{^Sc=lydi}', "");
    Expect(1, 67903, '\p{Sc=:\Alydi\z:}', "");;
    Expect(0, 67904, '\p{Sc=:\Alydi\z:}', "");;
    Expect(1, 67903, '\p{Sc=-_Lydi}', "");
    Expect(0, 67903, '\p{^Sc=-_Lydi}', "");
    Expect(0, 67903, '\P{Sc=-_Lydi}', "");
    Expect(1, 67903, '\P{^Sc=-_Lydi}', "");
    Expect(0, 67904, '\p{Sc=-_Lydi}', "");
    Expect(1, 67904, '\p{^Sc=-_Lydi}', "");
    Expect(1, 67904, '\P{Sc=-_Lydi}', "");
    Expect(0, 67904, '\P{^Sc=-_Lydi}', "");
    Error('\p{Is_Script= :=LYDIAN}');
    Error('\P{Is_Script= :=LYDIAN}');
    Expect(1, 67903, '\p{Is_Script:lydian}', "");
    Expect(0, 67903, '\p{^Is_Script:lydian}', "");
    Expect(0, 67903, '\P{Is_Script:lydian}', "");
    Expect(1, 67903, '\P{^Is_Script:lydian}', "");
    Expect(0, 67904, '\p{Is_Script:lydian}', "");
    Expect(1, 67904, '\p{^Is_Script:lydian}', "");
    Expect(1, 67904, '\P{Is_Script:lydian}', "");
    Expect(0, 67904, '\P{^Is_Script:lydian}', "");
    Expect(1, 67903, '\p{Is_Script=	 LYDIAN}', "");
    Expect(0, 67903, '\p{^Is_Script=	 LYDIAN}', "");
    Expect(0, 67903, '\P{Is_Script=	 LYDIAN}', "");
    Expect(1, 67903, '\P{^Is_Script=	 LYDIAN}', "");
    Expect(0, 67904, '\p{Is_Script=	 LYDIAN}', "");
    Expect(1, 67904, '\p{^Is_Script=	 LYDIAN}', "");
    Expect(1, 67904, '\P{Is_Script=	 LYDIAN}', "");
    Expect(0, 67904, '\P{^Is_Script=	 LYDIAN}', "");
    Error('\p{Is_Sc=Lydi/a/}');
    Error('\P{Is_Sc=Lydi/a/}');
    Expect(1, 67903, '\p{Is_Sc=lydi}', "");
    Expect(0, 67903, '\p{^Is_Sc=lydi}', "");
    Expect(0, 67903, '\P{Is_Sc=lydi}', "");
    Expect(1, 67903, '\P{^Is_Sc=lydi}', "");
    Expect(0, 67904, '\p{Is_Sc=lydi}', "");
    Expect(1, 67904, '\p{^Is_Sc=lydi}', "");
    Expect(1, 67904, '\P{Is_Sc=lydi}', "");
    Expect(0, 67904, '\P{^Is_Sc=lydi}', "");
    Expect(1, 67903, '\p{Is_Sc=		Lydi}', "");
    Expect(0, 67903, '\p{^Is_Sc=		Lydi}', "");
    Expect(0, 67903, '\P{Is_Sc=		Lydi}', "");
    Expect(1, 67903, '\P{^Is_Sc=		Lydi}', "");
    Expect(0, 67904, '\p{Is_Sc=		Lydi}', "");
    Expect(1, 67904, '\p{^Is_Sc=		Lydi}', "");
    Expect(1, 67904, '\P{Is_Sc=		Lydi}', "");
    Expect(0, 67904, '\P{^Is_Sc=		Lydi}', "");
    Error('\p{Script=/a/ -Mahajani}');
    Error('\P{Script=/a/ -Mahajani}');
    Expect(1, 70006, '\p{Script=:\AMahajani\z:}', "");;
    Expect(0, 70007, '\p{Script=:\AMahajani\z:}', "");;
    Expect(1, 70006, '\p{Script=mahajani}', "");
    Expect(0, 70006, '\p{^Script=mahajani}', "");
    Expect(0, 70006, '\P{Script=mahajani}', "");
    Expect(1, 70006, '\P{^Script=mahajani}', "");
    Expect(0, 70007, '\p{Script=mahajani}', "");
    Expect(1, 70007, '\p{^Script=mahajani}', "");
    Expect(1, 70007, '\P{Script=mahajani}', "");
    Expect(0, 70007, '\P{^Script=mahajani}', "");
    Expect(1, 70006, '\p{Script=:\Amahajani\z:}', "");;
    Expect(0, 70007, '\p{Script=:\Amahajani\z:}', "");;
    Expect(1, 70006, '\p{Script:    _Mahajani}', "");
    Expect(0, 70006, '\p{^Script:    _Mahajani}', "");
    Expect(0, 70006, '\P{Script:    _Mahajani}', "");
    Expect(1, 70006, '\P{^Script:    _Mahajani}', "");
    Expect(0, 70007, '\p{Script:    _Mahajani}', "");
    Expect(1, 70007, '\p{^Script:    _Mahajani}', "");
    Expect(1, 70007, '\P{Script:    _Mahajani}', "");
    Expect(0, 70007, '\P{^Script:    _Mahajani}', "");
    Error('\p{Sc=:=Mahj}');
    Error('\P{Sc=:=Mahj}');
    Expect(1, 70006, '\p{Sc=:\AMahj\z:}', "");;
    Expect(0, 70007, '\p{Sc=:\AMahj\z:}', "");;
    Expect(1, 70006, '\p{Sc=mahj}', "");
    Expect(0, 70006, '\p{^Sc=mahj}', "");
    Expect(0, 70006, '\P{Sc=mahj}', "");
    Expect(1, 70006, '\P{^Sc=mahj}', "");
    Expect(0, 70007, '\p{Sc=mahj}', "");
    Expect(1, 70007, '\p{^Sc=mahj}', "");
    Expect(1, 70007, '\P{Sc=mahj}', "");
    Expect(0, 70007, '\P{^Sc=mahj}', "");
    Expect(1, 70006, '\p{Sc=:\Amahj\z:}', "");;
    Expect(0, 70007, '\p{Sc=:\Amahj\z:}', "");;
    Expect(1, 70006, '\p{Sc: -	Mahj}', "");
    Expect(0, 70006, '\p{^Sc: -	Mahj}', "");
    Expect(0, 70006, '\P{Sc: -	Mahj}', "");
    Expect(1, 70006, '\P{^Sc: -	Mahj}', "");
    Expect(0, 70007, '\p{Sc: -	Mahj}', "");
    Expect(1, 70007, '\p{^Sc: -	Mahj}', "");
    Expect(1, 70007, '\P{Sc: -	Mahj}', "");
    Expect(0, 70007, '\P{^Sc: -	Mahj}', "");
    Error('\p{Is_Script=:= Mahajani}');
    Error('\P{Is_Script=:= Mahajani}');
    Expect(1, 70006, '\p{Is_Script=mahajani}', "");
    Expect(0, 70006, '\p{^Is_Script=mahajani}', "");
    Expect(0, 70006, '\P{Is_Script=mahajani}', "");
    Expect(1, 70006, '\P{^Is_Script=mahajani}', "");
    Expect(0, 70007, '\p{Is_Script=mahajani}', "");
    Expect(1, 70007, '\p{^Is_Script=mahajani}', "");
    Expect(1, 70007, '\P{Is_Script=mahajani}', "");
    Expect(0, 70007, '\P{^Is_Script=mahajani}', "");
    Expect(1, 70006, '\p{Is_Script=-	Mahajani}', "");
    Expect(0, 70006, '\p{^Is_Script=-	Mahajani}', "");
    Expect(0, 70006, '\P{Is_Script=-	Mahajani}', "");
    Expect(1, 70006, '\P{^Is_Script=-	Mahajani}', "");
    Expect(0, 70007, '\p{Is_Script=-	Mahajani}', "");
    Expect(1, 70007, '\p{^Is_Script=-	Mahajani}', "");
    Expect(1, 70007, '\P{Is_Script=-	Mahajani}', "");
    Expect(0, 70007, '\P{^Is_Script=-	Mahajani}', "");
    Error('\p{Is_Sc=/a/ MAHJ}');
    Error('\P{Is_Sc=/a/ MAHJ}');
    Expect(1, 70006, '\p{Is_Sc=mahj}', "");
    Expect(0, 70006, '\p{^Is_Sc=mahj}', "");
    Expect(0, 70006, '\P{Is_Sc=mahj}', "");
    Expect(1, 70006, '\P{^Is_Sc=mahj}', "");
    Expect(0, 70007, '\p{Is_Sc=mahj}', "");
    Expect(1, 70007, '\p{^Is_Sc=mahj}', "");
    Expect(1, 70007, '\P{Is_Sc=mahj}', "");
    Expect(0, 70007, '\P{^Is_Sc=mahj}', "");
    Expect(1, 70006, '\p{Is_Sc=_mahj}', "");
    Expect(0, 70006, '\p{^Is_Sc=_mahj}', "");
    Expect(0, 70006, '\P{Is_Sc=_mahj}', "");
    Expect(1, 70006, '\P{^Is_Sc=_mahj}', "");
    Expect(0, 70007, '\p{Is_Sc=_mahj}', "");
    Expect(1, 70007, '\p{^Is_Sc=_mahj}', "");
    Expect(1, 70007, '\P{Is_Sc=_mahj}', "");
    Expect(0, 70007, '\P{^Is_Sc=_mahj}', "");
    Error('\p{Script=	makasar/a/}');
    Error('\P{Script=	makasar/a/}');
    Expect(1, 73464, '\p{Script=:\AMakasar\z:}', "");;
    Expect(0, 73465, '\p{Script=:\AMakasar\z:}', "");;
    Expect(1, 73464, '\p{Script=makasar}', "");
    Expect(0, 73464, '\p{^Script=makasar}', "");
    Expect(0, 73464, '\P{Script=makasar}', "");
    Expect(1, 73464, '\P{^Script=makasar}', "");
    Expect(0, 73465, '\p{Script=makasar}', "");
    Expect(1, 73465, '\p{^Script=makasar}', "");
    Expect(1, 73465, '\P{Script=makasar}', "");
    Expect(0, 73465, '\P{^Script=makasar}', "");
    Expect(1, 73464, '\p{Script=:\Amakasar\z:}', "");;
    Expect(0, 73465, '\p{Script=:\Amakasar\z:}', "");;
    Expect(1, 73464, '\p{Script=	makasar}', "");
    Expect(0, 73464, '\p{^Script=	makasar}', "");
    Expect(0, 73464, '\P{Script=	makasar}', "");
    Expect(1, 73464, '\P{^Script=	makasar}', "");
    Expect(0, 73465, '\p{Script=	makasar}', "");
    Expect(1, 73465, '\p{^Script=	makasar}', "");
    Expect(1, 73465, '\P{Script=	makasar}', "");
    Expect(0, 73465, '\P{^Script=	makasar}', "");
    Error('\p{Sc= 	Maka/a/}');
    Error('\P{Sc= 	Maka/a/}');
    Expect(1, 73464, '\p{Sc=:\AMaka\z:}', "");;
    Expect(0, 73465, '\p{Sc=:\AMaka\z:}', "");;
    Expect(1, 73464, '\p{Sc=maka}', "");
    Expect(0, 73464, '\p{^Sc=maka}', "");
    Expect(0, 73464, '\P{Sc=maka}', "");
    Expect(1, 73464, '\P{^Sc=maka}', "");
    Expect(0, 73465, '\p{Sc=maka}', "");
    Expect(1, 73465, '\p{^Sc=maka}', "");
    Expect(1, 73465, '\P{Sc=maka}', "");
    Expect(0, 73465, '\P{^Sc=maka}', "");
    Expect(1, 73464, '\p{Sc=:\Amaka\z:}', "");;
    Expect(0, 73465, '\p{Sc=:\Amaka\z:}', "");;
    Expect(1, 73464, '\p{Sc=_maka}', "");
    Expect(0, 73464, '\p{^Sc=_maka}', "");
    Expect(0, 73464, '\P{Sc=_maka}', "");
    Expect(1, 73464, '\P{^Sc=_maka}', "");
    Expect(0, 73465, '\p{Sc=_maka}', "");
    Expect(1, 73465, '\p{^Sc=_maka}', "");
    Expect(1, 73465, '\P{Sc=_maka}', "");
    Expect(0, 73465, '\P{^Sc=_maka}', "");
    Error('\p{Is_Script=	_makasar:=}');
    Error('\P{Is_Script=	_makasar:=}');
    Expect(1, 73464, '\p{Is_Script=makasar}', "");
    Expect(0, 73464, '\p{^Is_Script=makasar}', "");
    Expect(0, 73464, '\P{Is_Script=makasar}', "");
    Expect(1, 73464, '\P{^Is_Script=makasar}', "");
    Expect(0, 73465, '\p{Is_Script=makasar}', "");
    Expect(1, 73465, '\p{^Is_Script=makasar}', "");
    Expect(1, 73465, '\P{Is_Script=makasar}', "");
    Expect(0, 73465, '\P{^Is_Script=makasar}', "");
    Expect(1, 73464, '\p{Is_Script= -MAKASAR}', "");
    Expect(0, 73464, '\p{^Is_Script= -MAKASAR}', "");
    Expect(0, 73464, '\P{Is_Script= -MAKASAR}', "");
    Expect(1, 73464, '\P{^Is_Script= -MAKASAR}', "");
    Expect(0, 73465, '\p{Is_Script= -MAKASAR}', "");
    Expect(1, 73465, '\p{^Is_Script= -MAKASAR}', "");
    Expect(1, 73465, '\P{Is_Script= -MAKASAR}', "");
    Expect(0, 73465, '\P{^Is_Script= -MAKASAR}', "");
    Error('\p{Is_Sc=/a/Maka}');
    Error('\P{Is_Sc=/a/Maka}');
    Expect(1, 73464, '\p{Is_Sc:   maka}', "");
    Expect(0, 73464, '\p{^Is_Sc:   maka}', "");
    Expect(0, 73464, '\P{Is_Sc:   maka}', "");
    Expect(1, 73464, '\P{^Is_Sc:   maka}', "");
    Expect(0, 73465, '\p{Is_Sc:   maka}', "");
    Expect(1, 73465, '\p{^Is_Sc:   maka}', "");
    Expect(1, 73465, '\P{Is_Sc:   maka}', "");
    Expect(0, 73465, '\P{^Is_Sc:   maka}', "");
    Expect(1, 73464, '\p{Is_Sc=__Maka}', "");
    Expect(0, 73464, '\p{^Is_Sc=__Maka}', "");
    Expect(0, 73464, '\P{Is_Sc=__Maka}', "");
    Expect(1, 73464, '\P{^Is_Sc=__Maka}', "");
    Expect(0, 73465, '\p{Is_Sc=__Maka}', "");
    Expect(1, 73465, '\p{^Is_Sc=__Maka}', "");
    Expect(1, 73465, '\P{Is_Sc=__Maka}', "");
    Expect(0, 73465, '\P{^Is_Sc=__Maka}', "");
    Error('\p{Script=_:=mandaic}');
    Error('\P{Script=_:=mandaic}');
    Expect(1, 2142, '\p{Script=:\AMandaic\z:}', "");;
    Expect(0, 2143, '\p{Script=:\AMandaic\z:}', "");;
    Expect(1, 2142, '\p{Script=mandaic}', "");
    Expect(0, 2142, '\p{^Script=mandaic}', "");
    Expect(0, 2142, '\P{Script=mandaic}', "");
    Expect(1, 2142, '\P{^Script=mandaic}', "");
    Expect(0, 2143, '\p{Script=mandaic}', "");
    Expect(1, 2143, '\p{^Script=mandaic}', "");
    Expect(1, 2143, '\P{Script=mandaic}', "");
    Expect(0, 2143, '\P{^Script=mandaic}', "");
    Expect(1, 2142, '\p{Script=:\Amandaic\z:}', "");;
    Expect(0, 2143, '\p{Script=:\Amandaic\z:}', "");;
    Expect(1, 2142, '\p{Script=- Mandaic}', "");
    Expect(0, 2142, '\p{^Script=- Mandaic}', "");
    Expect(0, 2142, '\P{Script=- Mandaic}', "");
    Expect(1, 2142, '\P{^Script=- Mandaic}', "");
    Expect(0, 2143, '\p{Script=- Mandaic}', "");
    Expect(1, 2143, '\p{^Script=- Mandaic}', "");
    Expect(1, 2143, '\P{Script=- Mandaic}', "");
    Expect(0, 2143, '\P{^Script=- Mandaic}', "");
    Error('\p{Sc: :=Mand}');
    Error('\P{Sc: :=Mand}');
    Expect(1, 2142, '\p{Sc=:\AMand\z:}', "");;
    Expect(0, 2143, '\p{Sc=:\AMand\z:}', "");;
    Expect(1, 2142, '\p{Sc=mand}', "");
    Expect(0, 2142, '\p{^Sc=mand}', "");
    Expect(0, 2142, '\P{Sc=mand}', "");
    Expect(1, 2142, '\P{^Sc=mand}', "");
    Expect(0, 2143, '\p{Sc=mand}', "");
    Expect(1, 2143, '\p{^Sc=mand}', "");
    Expect(1, 2143, '\P{Sc=mand}', "");
    Expect(0, 2143, '\P{^Sc=mand}', "");
    Expect(1, 2142, '\p{Sc=:\Amand\z:}', "");;
    Expect(0, 2143, '\p{Sc=:\Amand\z:}', "");;
    Expect(1, 2142, '\p{Sc=-_Mand}', "");
    Expect(0, 2142, '\p{^Sc=-_Mand}', "");
    Expect(0, 2142, '\P{Sc=-_Mand}', "");
    Expect(1, 2142, '\P{^Sc=-_Mand}', "");
    Expect(0, 2143, '\p{Sc=-_Mand}', "");
    Expect(1, 2143, '\p{^Sc=-_Mand}', "");
    Expect(1, 2143, '\P{Sc=-_Mand}', "");
    Expect(0, 2143, '\P{^Sc=-_Mand}', "");
    Error('\p{Is_Script= _Mandaic:=}');
    Error('\P{Is_Script= _Mandaic:=}');
    Expect(1, 2142, '\p{Is_Script=mandaic}', "");
    Expect(0, 2142, '\p{^Is_Script=mandaic}', "");
    Expect(0, 2142, '\P{Is_Script=mandaic}', "");
    Expect(1, 2142, '\P{^Is_Script=mandaic}', "");
    Expect(0, 2143, '\p{Is_Script=mandaic}', "");
    Expect(1, 2143, '\p{^Is_Script=mandaic}', "");
    Expect(1, 2143, '\P{Is_Script=mandaic}', "");
    Expect(0, 2143, '\P{^Is_Script=mandaic}', "");
    Expect(1, 2142, '\p{Is_Script=		MANDAIC}', "");
    Expect(0, 2142, '\p{^Is_Script=		MANDAIC}', "");
    Expect(0, 2142, '\P{Is_Script=		MANDAIC}', "");
    Expect(1, 2142, '\P{^Is_Script=		MANDAIC}', "");
    Expect(0, 2143, '\p{Is_Script=		MANDAIC}', "");
    Expect(1, 2143, '\p{^Is_Script=		MANDAIC}', "");
    Expect(1, 2143, '\P{Is_Script=		MANDAIC}', "");
    Expect(0, 2143, '\P{^Is_Script=		MANDAIC}', "");
    Error('\p{Is_Sc= _MAND:=}');
    Error('\P{Is_Sc= _MAND:=}');
    Expect(1, 2142, '\p{Is_Sc:   mand}', "");
    Expect(0, 2142, '\p{^Is_Sc:   mand}', "");
    Expect(0, 2142, '\P{Is_Sc:   mand}', "");
    Expect(1, 2142, '\P{^Is_Sc:   mand}', "");
    Expect(0, 2143, '\p{Is_Sc:   mand}', "");
    Expect(1, 2143, '\p{^Is_Sc:   mand}', "");
    Expect(1, 2143, '\P{Is_Sc:   mand}', "");
    Expect(0, 2143, '\P{^Is_Sc:   mand}', "");
    Expect(1, 2142, '\p{Is_Sc= -Mand}', "");
    Expect(0, 2142, '\p{^Is_Sc= -Mand}', "");
    Expect(0, 2142, '\P{Is_Sc= -Mand}', "");
    Expect(1, 2142, '\P{^Is_Sc= -Mand}', "");
    Expect(0, 2143, '\p{Is_Sc= -Mand}', "");
    Expect(1, 2143, '\p{^Is_Sc= -Mand}', "");
    Expect(1, 2143, '\P{Is_Sc= -Mand}', "");
    Expect(0, 2143, '\P{^Is_Sc= -Mand}', "");
    Error('\p{Script=	-Manichaean:=}');
    Error('\P{Script=	-Manichaean:=}');
    Expect(1, 68342, '\p{Script=:\AManichaean\z:}', "");;
    Expect(0, 68343, '\p{Script=:\AManichaean\z:}', "");;
    Expect(1, 68342, '\p{Script: manichaean}', "");
    Expect(0, 68342, '\p{^Script: manichaean}', "");
    Expect(0, 68342, '\P{Script: manichaean}', "");
    Expect(1, 68342, '\P{^Script: manichaean}', "");
    Expect(0, 68343, '\p{Script: manichaean}', "");
    Expect(1, 68343, '\p{^Script: manichaean}', "");
    Expect(1, 68343, '\P{Script: manichaean}', "");
    Expect(0, 68343, '\P{^Script: manichaean}', "");
    Expect(1, 68342, '\p{Script=:\Amanichaean\z:}', "");;
    Expect(0, 68343, '\p{Script=:\Amanichaean\z:}', "");;
    Expect(1, 68342, '\p{Script=_Manichaean}', "");
    Expect(0, 68342, '\p{^Script=_Manichaean}', "");
    Expect(0, 68342, '\P{Script=_Manichaean}', "");
    Expect(1, 68342, '\P{^Script=_Manichaean}', "");
    Expect(0, 68343, '\p{Script=_Manichaean}', "");
    Expect(1, 68343, '\p{^Script=_Manichaean}', "");
    Expect(1, 68343, '\P{Script=_Manichaean}', "");
    Expect(0, 68343, '\P{^Script=_Manichaean}', "");
    Error('\p{Sc=/a/_	Mani}');
    Error('\P{Sc=/a/_	Mani}');
    Expect(1, 68342, '\p{Sc=:\AMani\z:}', "");;
    Expect(0, 68343, '\p{Sc=:\AMani\z:}', "");;
    Expect(1, 68342, '\p{Sc=mani}', "");
    Expect(0, 68342, '\p{^Sc=mani}', "");
    Expect(0, 68342, '\P{Sc=mani}', "");
    Expect(1, 68342, '\P{^Sc=mani}', "");
    Expect(0, 68343, '\p{Sc=mani}', "");
    Expect(1, 68343, '\p{^Sc=mani}', "");
    Expect(1, 68343, '\P{Sc=mani}', "");
    Expect(0, 68343, '\P{^Sc=mani}', "");
    Expect(1, 68342, '\p{Sc=:\Amani\z:}', "");;
    Expect(0, 68343, '\p{Sc=:\Amani\z:}', "");;
    Expect(1, 68342, '\p{Sc=	 Mani}', "");
    Expect(0, 68342, '\p{^Sc=	 Mani}', "");
    Expect(0, 68342, '\P{Sc=	 Mani}', "");
    Expect(1, 68342, '\P{^Sc=	 Mani}', "");
    Expect(0, 68343, '\p{Sc=	 Mani}', "");
    Expect(1, 68343, '\p{^Sc=	 Mani}', "");
    Expect(1, 68343, '\P{Sc=	 Mani}', "");
    Expect(0, 68343, '\P{^Sc=	 Mani}', "");
    Error('\p{Is_Script=-Manichaean:=}');
    Error('\P{Is_Script=-Manichaean:=}');
    Expect(1, 68342, '\p{Is_Script=manichaean}', "");
    Expect(0, 68342, '\p{^Is_Script=manichaean}', "");
    Expect(0, 68342, '\P{Is_Script=manichaean}', "");
    Expect(1, 68342, '\P{^Is_Script=manichaean}', "");
    Expect(0, 68343, '\p{Is_Script=manichaean}', "");
    Expect(1, 68343, '\p{^Is_Script=manichaean}', "");
    Expect(1, 68343, '\P{Is_Script=manichaean}', "");
    Expect(0, 68343, '\P{^Is_Script=manichaean}', "");
    Expect(1, 68342, '\p{Is_Script=--MANICHAEAN}', "");
    Expect(0, 68342, '\p{^Is_Script=--MANICHAEAN}', "");
    Expect(0, 68342, '\P{Is_Script=--MANICHAEAN}', "");
    Expect(1, 68342, '\P{^Is_Script=--MANICHAEAN}', "");
    Expect(0, 68343, '\p{Is_Script=--MANICHAEAN}', "");
    Expect(1, 68343, '\p{^Is_Script=--MANICHAEAN}', "");
    Expect(1, 68343, '\P{Is_Script=--MANICHAEAN}', "");
    Expect(0, 68343, '\P{^Is_Script=--MANICHAEAN}', "");
    Error('\p{Is_Sc=	-mani:=}');
    Error('\P{Is_Sc=	-mani:=}');
    Expect(1, 68342, '\p{Is_Sc=mani}', "");
    Expect(0, 68342, '\p{^Is_Sc=mani}', "");
    Expect(0, 68342, '\P{Is_Sc=mani}', "");
    Expect(1, 68342, '\P{^Is_Sc=mani}', "");
    Expect(0, 68343, '\p{Is_Sc=mani}', "");
    Expect(1, 68343, '\p{^Is_Sc=mani}', "");
    Expect(1, 68343, '\P{Is_Sc=mani}', "");
    Expect(0, 68343, '\P{^Is_Sc=mani}', "");
    Expect(1, 68342, '\p{Is_Sc: 	-Mani}', "");
    Expect(0, 68342, '\p{^Is_Sc: 	-Mani}', "");
    Expect(0, 68342, '\P{Is_Sc: 	-Mani}', "");
    Expect(1, 68342, '\P{^Is_Sc: 	-Mani}', "");
    Expect(0, 68343, '\p{Is_Sc: 	-Mani}', "");
    Expect(1, 68343, '\p{^Is_Sc: 	-Mani}', "");
    Expect(1, 68343, '\P{Is_Sc: 	-Mani}', "");
    Expect(0, 68343, '\P{^Is_Sc: 	-Mani}', "");
    Error('\p{Script=_ MARCHEN/a/}');
    Error('\P{Script=_ MARCHEN/a/}');
    Expect(1, 72886, '\p{Script=:\AMarchen\z:}', "");;
    Expect(0, 72887, '\p{Script=:\AMarchen\z:}', "");;
    Expect(1, 72886, '\p{Script=marchen}', "");
    Expect(0, 72886, '\p{^Script=marchen}', "");
    Expect(0, 72886, '\P{Script=marchen}', "");
    Expect(1, 72886, '\P{^Script=marchen}', "");
    Expect(0, 72887, '\p{Script=marchen}', "");
    Expect(1, 72887, '\p{^Script=marchen}', "");
    Expect(1, 72887, '\P{Script=marchen}', "");
    Expect(0, 72887, '\P{^Script=marchen}', "");
    Expect(1, 72886, '\p{Script=:\Amarchen\z:}', "");;
    Expect(0, 72887, '\p{Script=:\Amarchen\z:}', "");;
    Expect(1, 72886, '\p{Script=-marchen}', "");
    Expect(0, 72886, '\p{^Script=-marchen}', "");
    Expect(0, 72886, '\P{Script=-marchen}', "");
    Expect(1, 72886, '\P{^Script=-marchen}', "");
    Expect(0, 72887, '\p{Script=-marchen}', "");
    Expect(1, 72887, '\p{^Script=-marchen}', "");
    Expect(1, 72887, '\P{Script=-marchen}', "");
    Expect(0, 72887, '\P{^Script=-marchen}', "");
    Error('\p{Sc=:=	-marc}');
    Error('\P{Sc=:=	-marc}');
    Expect(1, 72886, '\p{Sc=:\AMarc\z:}', "");;
    Expect(0, 72887, '\p{Sc=:\AMarc\z:}', "");;
    Expect(1, 72886, '\p{Sc=marc}', "");
    Expect(0, 72886, '\p{^Sc=marc}', "");
    Expect(0, 72886, '\P{Sc=marc}', "");
    Expect(1, 72886, '\P{^Sc=marc}', "");
    Expect(0, 72887, '\p{Sc=marc}', "");
    Expect(1, 72887, '\p{^Sc=marc}', "");
    Expect(1, 72887, '\P{Sc=marc}', "");
    Expect(0, 72887, '\P{^Sc=marc}', "");
    Expect(1, 72886, '\p{Sc=:\Amarc\z:}', "");;
    Expect(0, 72887, '\p{Sc=:\Amarc\z:}', "");;
    Expect(1, 72886, '\p{Sc: - MARC}', "");
    Expect(0, 72886, '\p{^Sc: - MARC}', "");
    Expect(0, 72886, '\P{Sc: - MARC}', "");
    Expect(1, 72886, '\P{^Sc: - MARC}', "");
    Expect(0, 72887, '\p{Sc: - MARC}', "");
    Expect(1, 72887, '\p{^Sc: - MARC}', "");
    Expect(1, 72887, '\P{Sc: - MARC}', "");
    Expect(0, 72887, '\P{^Sc: - MARC}', "");
    Error('\p{Is_Script=--Marchen/a/}');
    Error('\P{Is_Script=--Marchen/a/}');
    Expect(1, 72886, '\p{Is_Script: marchen}', "");
    Expect(0, 72886, '\p{^Is_Script: marchen}', "");
    Expect(0, 72886, '\P{Is_Script: marchen}', "");
    Expect(1, 72886, '\P{^Is_Script: marchen}', "");
    Expect(0, 72887, '\p{Is_Script: marchen}', "");
    Expect(1, 72887, '\p{^Is_Script: marchen}', "");
    Expect(1, 72887, '\P{Is_Script: marchen}', "");
    Expect(0, 72887, '\P{^Is_Script: marchen}', "");
    Expect(1, 72886, '\p{Is_Script=	marchen}', "");
    Expect(0, 72886, '\p{^Is_Script=	marchen}', "");
    Expect(0, 72886, '\P{Is_Script=	marchen}', "");
    Expect(1, 72886, '\P{^Is_Script=	marchen}', "");
    Expect(0, 72887, '\p{Is_Script=	marchen}', "");
    Expect(1, 72887, '\p{^Is_Script=	marchen}', "");
    Expect(1, 72887, '\P{Is_Script=	marchen}', "");
    Expect(0, 72887, '\P{^Is_Script=	marchen}', "");
    Error('\p{Is_Sc=	:=Marc}');
    Error('\P{Is_Sc=	:=Marc}');
    Expect(1, 72886, '\p{Is_Sc=marc}', "");
    Expect(0, 72886, '\p{^Is_Sc=marc}', "");
    Expect(0, 72886, '\P{Is_Sc=marc}', "");
    Expect(1, 72886, '\P{^Is_Sc=marc}', "");
    Expect(0, 72887, '\p{Is_Sc=marc}', "");
    Expect(1, 72887, '\p{^Is_Sc=marc}', "");
    Expect(1, 72887, '\P{Is_Sc=marc}', "");
    Expect(0, 72887, '\P{^Is_Sc=marc}', "");
    Expect(1, 72886, '\p{Is_Sc=_-MARC}', "");
    Expect(0, 72886, '\p{^Is_Sc=_-MARC}', "");
    Expect(0, 72886, '\P{Is_Sc=_-MARC}', "");
    Expect(1, 72886, '\P{^Is_Sc=_-MARC}', "");
    Expect(0, 72887, '\p{Is_Sc=_-MARC}', "");
    Expect(1, 72887, '\p{^Is_Sc=_-MARC}', "");
    Expect(1, 72887, '\P{Is_Sc=_-MARC}', "");
    Expect(0, 72887, '\P{^Is_Sc=_-MARC}', "");
    Error('\p{Script=	-Medefaidrin/a/}');
    Error('\P{Script=	-Medefaidrin/a/}');
    Expect(1, 93850, '\p{Script=:\AMedefaidrin\z:}', "");;
    Expect(0, 93851, '\p{Script=:\AMedefaidrin\z:}', "");;
    Expect(1, 93850, '\p{Script=medefaidrin}', "");
    Expect(0, 93850, '\p{^Script=medefaidrin}', "");
    Expect(0, 93850, '\P{Script=medefaidrin}', "");
    Expect(1, 93850, '\P{^Script=medefaidrin}', "");
    Expect(0, 93851, '\p{Script=medefaidrin}', "");
    Expect(1, 93851, '\p{^Script=medefaidrin}', "");
    Expect(1, 93851, '\P{Script=medefaidrin}', "");
    Expect(0, 93851, '\P{^Script=medefaidrin}', "");
    Expect(1, 93850, '\p{Script=:\Amedefaidrin\z:}', "");;
    Expect(0, 93851, '\p{Script=:\Amedefaidrin\z:}', "");;
    Expect(1, 93850, '\p{Script=_medefaidrin}', "");
    Expect(0, 93850, '\p{^Script=_medefaidrin}', "");
    Expect(0, 93850, '\P{Script=_medefaidrin}', "");
    Expect(1, 93850, '\P{^Script=_medefaidrin}', "");
    Expect(0, 93851, '\p{Script=_medefaidrin}', "");
    Expect(1, 93851, '\p{^Script=_medefaidrin}', "");
    Expect(1, 93851, '\P{Script=_medefaidrin}', "");
    Expect(0, 93851, '\P{^Script=_medefaidrin}', "");
    Error('\p{Sc:	- Medf:=}');
    Error('\P{Sc:	- Medf:=}');
    Expect(1, 93850, '\p{Sc=:\AMedf\z:}', "");;
    Expect(0, 93851, '\p{Sc=:\AMedf\z:}', "");;
    Expect(1, 93850, '\p{Sc=medf}', "");
    Expect(0, 93850, '\p{^Sc=medf}', "");
    Expect(0, 93850, '\P{Sc=medf}', "");
    Expect(1, 93850, '\P{^Sc=medf}', "");
    Expect(0, 93851, '\p{Sc=medf}', "");
    Expect(1, 93851, '\p{^Sc=medf}', "");
    Expect(1, 93851, '\P{Sc=medf}', "");
    Expect(0, 93851, '\P{^Sc=medf}', "");
    Expect(1, 93850, '\p{Sc=:\Amedf\z:}', "");;
    Expect(0, 93851, '\p{Sc=:\Amedf\z:}', "");;
    Expect(1, 93850, '\p{Sc= _medf}', "");
    Expect(0, 93850, '\p{^Sc= _medf}', "");
    Expect(0, 93850, '\P{Sc= _medf}', "");
    Expect(1, 93850, '\P{^Sc= _medf}', "");
    Expect(0, 93851, '\p{Sc= _medf}', "");
    Expect(1, 93851, '\p{^Sc= _medf}', "");
    Expect(1, 93851, '\P{Sc= _medf}', "");
    Expect(0, 93851, '\P{^Sc= _medf}', "");
    Error('\p{Is_Script= :=MEDEFAIDRIN}');
    Error('\P{Is_Script= :=MEDEFAIDRIN}');
    Expect(1, 93850, '\p{Is_Script=medefaidrin}', "");
    Expect(0, 93850, '\p{^Is_Script=medefaidrin}', "");
    Expect(0, 93850, '\P{Is_Script=medefaidrin}', "");
    Expect(1, 93850, '\P{^Is_Script=medefaidrin}', "");
    Expect(0, 93851, '\p{Is_Script=medefaidrin}', "");
    Expect(1, 93851, '\p{^Is_Script=medefaidrin}', "");
    Expect(1, 93851, '\P{Is_Script=medefaidrin}', "");
    Expect(0, 93851, '\P{^Is_Script=medefaidrin}', "");
    Expect(1, 93850, '\p{Is_Script=--Medefaidrin}', "");
    Expect(0, 93850, '\p{^Is_Script=--Medefaidrin}', "");
    Expect(0, 93850, '\P{Is_Script=--Medefaidrin}', "");
    Expect(1, 93850, '\P{^Is_Script=--Medefaidrin}', "");
    Expect(0, 93851, '\p{Is_Script=--Medefaidrin}', "");
    Expect(1, 93851, '\p{^Is_Script=--Medefaidrin}', "");
    Expect(1, 93851, '\P{Is_Script=--Medefaidrin}', "");
    Expect(0, 93851, '\P{^Is_Script=--Medefaidrin}', "");
    Error('\p{Is_Sc=-:=MEDF}');
    Error('\P{Is_Sc=-:=MEDF}');
    Expect(1, 93850, '\p{Is_Sc=medf}', "");
    Expect(0, 93850, '\p{^Is_Sc=medf}', "");
    Expect(0, 93850, '\P{Is_Sc=medf}', "");
    Expect(1, 93850, '\P{^Is_Sc=medf}', "");
    Expect(0, 93851, '\p{Is_Sc=medf}', "");
    Expect(1, 93851, '\p{^Is_Sc=medf}', "");
    Expect(1, 93851, '\P{Is_Sc=medf}', "");
    Expect(0, 93851, '\P{^Is_Sc=medf}', "");
    Expect(1, 93850, '\p{Is_Sc= Medf}', "");
    Expect(0, 93850, '\p{^Is_Sc= Medf}', "");
    Expect(0, 93850, '\P{Is_Sc= Medf}', "");
    Expect(1, 93850, '\P{^Is_Sc= Medf}', "");
    Expect(0, 93851, '\p{Is_Sc= Medf}', "");
    Expect(1, 93851, '\p{^Is_Sc= Medf}', "");
    Expect(1, 93851, '\P{Is_Sc= Medf}', "");
    Expect(0, 93851, '\P{^Is_Sc= Medf}', "");
    Error('\p{Script=-:=mende_Kikakui}');
    Error('\P{Script=-:=mende_Kikakui}');
    Expect(1, 125142, '\p{Script=:\AMende_Kikakui\z:}', "");;
    Expect(0, 125143, '\p{Script=:\AMende_Kikakui\z:}', "");;
    Expect(1, 125142, '\p{Script: mendekikakui}', "");
    Expect(0, 125142, '\p{^Script: mendekikakui}', "");
    Expect(0, 125142, '\P{Script: mendekikakui}', "");
    Expect(1, 125142, '\P{^Script: mendekikakui}', "");
    Expect(0, 125143, '\p{Script: mendekikakui}', "");
    Expect(1, 125143, '\p{^Script: mendekikakui}', "");
    Expect(1, 125143, '\P{Script: mendekikakui}', "");
    Expect(0, 125143, '\P{^Script: mendekikakui}', "");
    Expect(1, 125142, '\p{Script=:\Amendekikakui\z:}', "");;
    Expect(0, 125143, '\p{Script=:\Amendekikakui\z:}', "");;
    Expect(1, 125142, '\p{Script:	_ MENDE_Kikakui}', "");
    Expect(0, 125142, '\p{^Script:	_ MENDE_Kikakui}', "");
    Expect(0, 125142, '\P{Script:	_ MENDE_Kikakui}', "");
    Expect(1, 125142, '\P{^Script:	_ MENDE_Kikakui}', "");
    Expect(0, 125143, '\p{Script:	_ MENDE_Kikakui}', "");
    Expect(1, 125143, '\p{^Script:	_ MENDE_Kikakui}', "");
    Expect(1, 125143, '\P{Script:	_ MENDE_Kikakui}', "");
    Expect(0, 125143, '\P{^Script:	_ MENDE_Kikakui}', "");
    Error('\p{Sc=_-MEND:=}');
    Error('\P{Sc=_-MEND:=}');
    Expect(1, 125142, '\p{Sc=:\AMend\z:}', "");;
    Expect(0, 125143, '\p{Sc=:\AMend\z:}', "");;
    Expect(1, 125142, '\p{Sc=mend}', "");
    Expect(0, 125142, '\p{^Sc=mend}', "");
    Expect(0, 125142, '\P{Sc=mend}', "");
    Expect(1, 125142, '\P{^Sc=mend}', "");
    Expect(0, 125143, '\p{Sc=mend}', "");
    Expect(1, 125143, '\p{^Sc=mend}', "");
    Expect(1, 125143, '\P{Sc=mend}', "");
    Expect(0, 125143, '\P{^Sc=mend}', "");
    Expect(1, 125142, '\p{Sc=:\Amend\z:}', "");;
    Expect(0, 125143, '\p{Sc=:\Amend\z:}', "");;
    Expect(1, 125142, '\p{Sc=	 Mend}', "");
    Expect(0, 125142, '\p{^Sc=	 Mend}', "");
    Expect(0, 125142, '\P{Sc=	 Mend}', "");
    Expect(1, 125142, '\P{^Sc=	 Mend}', "");
    Expect(0, 125143, '\p{Sc=	 Mend}', "");
    Expect(1, 125143, '\p{^Sc=	 Mend}', "");
    Expect(1, 125143, '\P{Sc=	 Mend}', "");
    Expect(0, 125143, '\P{^Sc=	 Mend}', "");
    Error('\p{Is_Script=:=  Mende_Kikakui}');
    Error('\P{Is_Script=:=  Mende_Kikakui}');
    Expect(1, 125142, '\p{Is_Script=mendekikakui}', "");
    Expect(0, 125142, '\p{^Is_Script=mendekikakui}', "");
    Expect(0, 125142, '\P{Is_Script=mendekikakui}', "");
    Expect(1, 125142, '\P{^Is_Script=mendekikakui}', "");
    Expect(0, 125143, '\p{Is_Script=mendekikakui}', "");
    Expect(1, 125143, '\p{^Is_Script=mendekikakui}', "");
    Expect(1, 125143, '\P{Is_Script=mendekikakui}', "");
    Expect(0, 125143, '\P{^Is_Script=mendekikakui}', "");
    Expect(1, 125142, '\p{Is_Script=  Mende_kikakui}', "");
    Expect(0, 125142, '\p{^Is_Script=  Mende_kikakui}', "");
    Expect(0, 125142, '\P{Is_Script=  Mende_kikakui}', "");
    Expect(1, 125142, '\P{^Is_Script=  Mende_kikakui}', "");
    Expect(0, 125143, '\p{Is_Script=  Mende_kikakui}', "");
    Expect(1, 125143, '\p{^Is_Script=  Mende_kikakui}', "");
    Expect(1, 125143, '\P{Is_Script=  Mende_kikakui}', "");
    Expect(0, 125143, '\P{^Is_Script=  Mende_kikakui}', "");
    Error('\p{Is_Sc:    _MEND:=}');
    Error('\P{Is_Sc:    _MEND:=}');
    Expect(1, 125142, '\p{Is_Sc=mend}', "");
    Expect(0, 125142, '\p{^Is_Sc=mend}', "");
    Expect(0, 125142, '\P{Is_Sc=mend}', "");
    Expect(1, 125142, '\P{^Is_Sc=mend}', "");
    Expect(0, 125143, '\p{Is_Sc=mend}', "");
    Expect(1, 125143, '\p{^Is_Sc=mend}', "");
    Expect(1, 125143, '\P{Is_Sc=mend}', "");
    Expect(0, 125143, '\P{^Is_Sc=mend}', "");
    Expect(1, 125142, '\p{Is_Sc=--mend}', "");
    Expect(0, 125142, '\p{^Is_Sc=--mend}', "");
    Expect(0, 125142, '\P{Is_Sc=--mend}', "");
    Expect(1, 125142, '\P{^Is_Sc=--mend}', "");
    Expect(0, 125143, '\p{Is_Sc=--mend}', "");
    Expect(1, 125143, '\p{^Is_Sc=--mend}', "");
    Expect(1, 125143, '\P{Is_Sc=--mend}', "");
    Expect(0, 125143, '\P{^Is_Sc=--mend}', "");
    Error('\p{Script=/a/ 	Meroitic_CURSIVE}');
    Error('\P{Script=/a/ 	Meroitic_CURSIVE}');
    Expect(1, 68095, '\p{Script=:\AMeroitic_Cursive\z:}', "");;
    Expect(0, 68096, '\p{Script=:\AMeroitic_Cursive\z:}', "");;
    Expect(1, 68095, '\p{Script=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Script=meroiticcursive}', "");
    Expect(0, 68095, '\P{Script=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Script=meroiticcursive}', "");
    Expect(0, 68096, '\p{Script=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Script=meroiticcursive}', "");
    Expect(1, 68096, '\P{Script=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Script=meroiticcursive}', "");
    Expect(1, 68095, '\p{Script=:\Ameroiticcursive\z:}', "");;
    Expect(0, 68096, '\p{Script=:\Ameroiticcursive\z:}', "");;
    Expect(1, 68095, '\p{Script=- Meroitic_CURSIVE}', "");
    Expect(0, 68095, '\p{^Script=- Meroitic_CURSIVE}', "");
    Expect(0, 68095, '\P{Script=- Meroitic_CURSIVE}', "");
    Expect(1, 68095, '\P{^Script=- Meroitic_CURSIVE}', "");
    Expect(0, 68096, '\p{Script=- Meroitic_CURSIVE}', "");
    Expect(1, 68096, '\p{^Script=- Meroitic_CURSIVE}', "");
    Expect(1, 68096, '\P{Script=- Meroitic_CURSIVE}', "");
    Expect(0, 68096, '\P{^Script=- Meroitic_CURSIVE}', "");
    Error('\p{Sc=-:=Merc}');
    Error('\P{Sc=-:=Merc}');
    Expect(1, 68095, '\p{Sc=:\AMerc\z:}', "");;
    Expect(0, 68096, '\p{Sc=:\AMerc\z:}', "");;
    Expect(1, 68095, '\p{Sc=merc}', "");
    Expect(0, 68095, '\p{^Sc=merc}', "");
    Expect(0, 68095, '\P{Sc=merc}', "");
    Expect(1, 68095, '\P{^Sc=merc}', "");
    Expect(0, 68096, '\p{Sc=merc}', "");
    Expect(1, 68096, '\p{^Sc=merc}', "");
    Expect(1, 68096, '\P{Sc=merc}', "");
    Expect(0, 68096, '\P{^Sc=merc}', "");
    Expect(1, 68095, '\p{Sc=:\Amerc\z:}', "");;
    Expect(0, 68096, '\p{Sc=:\Amerc\z:}', "");;
    Expect(1, 68095, '\p{Sc= Merc}', "");
    Expect(0, 68095, '\p{^Sc= Merc}', "");
    Expect(0, 68095, '\P{Sc= Merc}', "");
    Expect(1, 68095, '\P{^Sc= Merc}', "");
    Expect(0, 68096, '\p{Sc= Merc}', "");
    Expect(1, 68096, '\p{^Sc= Merc}', "");
    Expect(1, 68096, '\P{Sc= Merc}', "");
    Expect(0, 68096, '\P{^Sc= Merc}', "");
    Error('\p{Is_Script=/a/ _Meroitic_Cursive}');
    Error('\P{Is_Script=/a/ _Meroitic_Cursive}');
    Expect(1, 68095, '\p{Is_Script=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Is_Script=meroiticcursive}', "");
    Expect(0, 68095, '\P{Is_Script=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Is_Script=meroiticcursive}', "");
    Expect(0, 68096, '\p{Is_Script=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Is_Script=meroiticcursive}', "");
    Expect(1, 68096, '\P{Is_Script=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Is_Script=meroiticcursive}', "");
    Expect(1, 68095, '\p{Is_Script=-meroitic_cursive}', "");
    Expect(0, 68095, '\p{^Is_Script=-meroitic_cursive}', "");
    Expect(0, 68095, '\P{Is_Script=-meroitic_cursive}', "");
    Expect(1, 68095, '\P{^Is_Script=-meroitic_cursive}', "");
    Expect(0, 68096, '\p{Is_Script=-meroitic_cursive}', "");
    Expect(1, 68096, '\p{^Is_Script=-meroitic_cursive}', "");
    Expect(1, 68096, '\P{Is_Script=-meroitic_cursive}', "");
    Expect(0, 68096, '\P{^Is_Script=-meroitic_cursive}', "");
    Error('\p{Is_Sc=	Merc/a/}');
    Error('\P{Is_Sc=	Merc/a/}');
    Expect(1, 68095, '\p{Is_Sc=merc}', "");
    Expect(0, 68095, '\p{^Is_Sc=merc}', "");
    Expect(0, 68095, '\P{Is_Sc=merc}', "");
    Expect(1, 68095, '\P{^Is_Sc=merc}', "");
    Expect(0, 68096, '\p{Is_Sc=merc}', "");
    Expect(1, 68096, '\p{^Is_Sc=merc}', "");
    Expect(1, 68096, '\P{Is_Sc=merc}', "");
    Expect(0, 68096, '\P{^Is_Sc=merc}', "");
    Expect(1, 68095, '\p{Is_Sc=-Merc}', "");
    Expect(0, 68095, '\p{^Is_Sc=-Merc}', "");
    Expect(0, 68095, '\P{Is_Sc=-Merc}', "");
    Expect(1, 68095, '\P{^Is_Sc=-Merc}', "");
    Expect(0, 68096, '\p{Is_Sc=-Merc}', "");
    Expect(1, 68096, '\p{^Is_Sc=-Merc}', "");
    Expect(1, 68096, '\P{Is_Sc=-Merc}', "");
    Expect(0, 68096, '\P{^Is_Sc=-Merc}', "");
    Error('\p{Script=-_MEROITIC_Hieroglyphs/a/}');
    Error('\P{Script=-_MEROITIC_Hieroglyphs/a/}');
    Expect(1, 67999, '\p{Script=:\AMeroitic_Hieroglyphs\z:}', "");;
    Expect(0, 68000, '\p{Script=:\AMeroitic_Hieroglyphs\z:}', "");;
    Expect(1, 67999, '\p{Script=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Script=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Script=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Script=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Script=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Script=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Script=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Script=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Script=:\Ameroitichieroglyphs\z:}', "");;
    Expect(0, 68000, '\p{Script=:\Ameroitichieroglyphs\z:}', "");;
    Expect(1, 67999, '\p{Script=- meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^Script=- meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\P{Script=- meroitic_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^Script=- meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\p{Script=- meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^Script=- meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\P{Script=- meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^Script=- meroitic_Hieroglyphs}', "");
    Error('\p{Sc=:=-_Mero}');
    Error('\P{Sc=:=-_Mero}');
    Expect(1, 67999, '\p{Sc=:\AMero\z:}', "");;
    Expect(0, 68000, '\p{Sc=:\AMero\z:}', "");;
    Expect(1, 67999, '\p{Sc=mero}', "");
    Expect(0, 67999, '\p{^Sc=mero}', "");
    Expect(0, 67999, '\P{Sc=mero}', "");
    Expect(1, 67999, '\P{^Sc=mero}', "");
    Expect(0, 68000, '\p{Sc=mero}', "");
    Expect(1, 68000, '\p{^Sc=mero}', "");
    Expect(1, 68000, '\P{Sc=mero}', "");
    Expect(0, 68000, '\P{^Sc=mero}', "");
    Expect(1, 67999, '\p{Sc=:\Amero\z:}', "");;
    Expect(0, 68000, '\p{Sc=:\Amero\z:}', "");;
    Expect(1, 67999, '\p{Sc=	-Mero}', "");
    Expect(0, 67999, '\p{^Sc=	-Mero}', "");
    Expect(0, 67999, '\P{Sc=	-Mero}', "");
    Expect(1, 67999, '\P{^Sc=	-Mero}', "");
    Expect(0, 68000, '\p{Sc=	-Mero}', "");
    Expect(1, 68000, '\p{^Sc=	-Mero}', "");
    Expect(1, 68000, '\P{Sc=	-Mero}', "");
    Expect(0, 68000, '\P{^Sc=	-Mero}', "");
    Error('\p{Is_Script= MEROITIC_Hieroglyphs:=}');
    Error('\P{Is_Script= MEROITIC_Hieroglyphs:=}');
    Expect(1, 67999, '\p{Is_Script=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Script=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Script=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Script=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Script=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Script=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Script=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Script=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Is_Script=  MEROITIC_hieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Script=  MEROITIC_hieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Script=  MEROITIC_hieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Script=  MEROITIC_hieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Script=  MEROITIC_hieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Script=  MEROITIC_hieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Script=  MEROITIC_hieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Script=  MEROITIC_hieroglyphs}', "");
    Error('\p{Is_Sc=:=-_mero}');
    Error('\P{Is_Sc=:=-_mero}');
    Expect(1, 67999, '\p{Is_Sc=mero}', "");
    Expect(0, 67999, '\p{^Is_Sc=mero}', "");
    Expect(0, 67999, '\P{Is_Sc=mero}', "");
    Expect(1, 67999, '\P{^Is_Sc=mero}', "");
    Expect(0, 68000, '\p{Is_Sc=mero}', "");
    Expect(1, 68000, '\p{^Is_Sc=mero}', "");
    Expect(1, 68000, '\P{Is_Sc=mero}', "");
    Expect(0, 68000, '\P{^Is_Sc=mero}', "");
    Expect(1, 67999, '\p{Is_Sc=-MERO}', "");
    Expect(0, 67999, '\p{^Is_Sc=-MERO}', "");
    Expect(0, 67999, '\P{Is_Sc=-MERO}', "");
    Expect(1, 67999, '\P{^Is_Sc=-MERO}', "");
    Expect(0, 68000, '\p{Is_Sc=-MERO}', "");
    Expect(1, 68000, '\p{^Is_Sc=-MERO}', "");
    Expect(1, 68000, '\P{Is_Sc=-MERO}', "");
    Expect(0, 68000, '\P{^Is_Sc=-MERO}', "");
    Error('\p{Script:	:=MALAYALAM}');
    Error('\P{Script:	:=MALAYALAM}');
    Expect(1, 3455, '\p{Script=:\AMalayalam\z:}', "");;
    Expect(0, 3456, '\p{Script=:\AMalayalam\z:}', "");;
    Expect(1, 3455, '\p{Script=malayalam}', "");
    Expect(0, 3455, '\p{^Script=malayalam}', "");
    Expect(0, 3455, '\P{Script=malayalam}', "");
    Expect(1, 3455, '\P{^Script=malayalam}', "");
    Expect(0, 3456, '\p{Script=malayalam}', "");
    Expect(1, 3456, '\p{^Script=malayalam}', "");
    Expect(1, 3456, '\P{Script=malayalam}', "");
    Expect(0, 3456, '\P{^Script=malayalam}', "");
    Expect(1, 3455, '\p{Script=:\Amalayalam\z:}', "");;
    Expect(0, 3456, '\p{Script=:\Amalayalam\z:}', "");;
    Expect(1, 3455, '\p{Script: _Malayalam}', "");
    Expect(0, 3455, '\p{^Script: _Malayalam}', "");
    Expect(0, 3455, '\P{Script: _Malayalam}', "");
    Expect(1, 3455, '\P{^Script: _Malayalam}', "");
    Expect(0, 3456, '\p{Script: _Malayalam}', "");
    Expect(1, 3456, '\p{^Script: _Malayalam}', "");
    Expect(1, 3456, '\P{Script: _Malayalam}', "");
    Expect(0, 3456, '\P{^Script: _Malayalam}', "");
    Error('\p{Sc= /a/MLYM}');
    Error('\P{Sc= /a/MLYM}');
    Expect(1, 3455, '\p{Sc=:\AMlym\z:}', "");;
    Expect(0, 3456, '\p{Sc=:\AMlym\z:}', "");;
    Expect(1, 3455, '\p{Sc=mlym}', "");
    Expect(0, 3455, '\p{^Sc=mlym}', "");
    Expect(0, 3455, '\P{Sc=mlym}', "");
    Expect(1, 3455, '\P{^Sc=mlym}', "");
    Expect(0, 3456, '\p{Sc=mlym}', "");
    Expect(1, 3456, '\p{^Sc=mlym}', "");
    Expect(1, 3456, '\P{Sc=mlym}', "");
    Expect(0, 3456, '\P{^Sc=mlym}', "");
    Expect(1, 3455, '\p{Sc=:\Amlym\z:}', "");;
    Expect(0, 3456, '\p{Sc=:\Amlym\z:}', "");;
    Expect(1, 3455, '\p{Sc=-MLYM}', "");
    Expect(0, 3455, '\p{^Sc=-MLYM}', "");
    Expect(0, 3455, '\P{Sc=-MLYM}', "");
    Expect(1, 3455, '\P{^Sc=-MLYM}', "");
    Expect(0, 3456, '\p{Sc=-MLYM}', "");
    Expect(1, 3456, '\p{^Sc=-MLYM}', "");
    Expect(1, 3456, '\P{Sc=-MLYM}', "");
    Expect(0, 3456, '\P{^Sc=-MLYM}', "");
    Error('\p{Is_Script=		Malayalam:=}');
    Error('\P{Is_Script=		Malayalam:=}');
    Expect(1, 3455, '\p{Is_Script=malayalam}', "");
    Expect(0, 3455, '\p{^Is_Script=malayalam}', "");
    Expect(0, 3455, '\P{Is_Script=malayalam}', "");
    Expect(1, 3455, '\P{^Is_Script=malayalam}', "");
    Expect(0, 3456, '\p{Is_Script=malayalam}', "");
    Expect(1, 3456, '\p{^Is_Script=malayalam}', "");
    Expect(1, 3456, '\P{Is_Script=malayalam}', "");
    Expect(0, 3456, '\P{^Is_Script=malayalam}', "");
    Expect(1, 3455, '\p{Is_Script=  malayalam}', "");
    Expect(0, 3455, '\p{^Is_Script=  malayalam}', "");
    Expect(0, 3455, '\P{Is_Script=  malayalam}', "");
    Expect(1, 3455, '\P{^Is_Script=  malayalam}', "");
    Expect(0, 3456, '\p{Is_Script=  malayalam}', "");
    Expect(1, 3456, '\p{^Is_Script=  malayalam}', "");
    Expect(1, 3456, '\P{Is_Script=  malayalam}', "");
    Expect(0, 3456, '\P{^Is_Script=  malayalam}', "");
    Error('\p{Is_Sc=-	mlym:=}');
    Error('\P{Is_Sc=-	mlym:=}');
    Expect(1, 3455, '\p{Is_Sc=mlym}', "");
    Expect(0, 3455, '\p{^Is_Sc=mlym}', "");
    Expect(0, 3455, '\P{Is_Sc=mlym}', "");
    Expect(1, 3455, '\P{^Is_Sc=mlym}', "");
    Expect(0, 3456, '\p{Is_Sc=mlym}', "");
    Expect(1, 3456, '\p{^Is_Sc=mlym}', "");
    Expect(1, 3456, '\P{Is_Sc=mlym}', "");
    Expect(0, 3456, '\P{^Is_Sc=mlym}', "");
    Expect(1, 3455, '\p{Is_Sc=	Mlym}', "");
    Expect(0, 3455, '\p{^Is_Sc=	Mlym}', "");
    Expect(0, 3455, '\P{Is_Sc=	Mlym}', "");
    Expect(1, 3455, '\P{^Is_Sc=	Mlym}', "");
    Expect(0, 3456, '\p{Is_Sc=	Mlym}', "");
    Expect(1, 3456, '\p{^Is_Sc=	Mlym}', "");
    Expect(1, 3456, '\P{Is_Sc=	Mlym}', "");
    Expect(0, 3456, '\P{^Is_Sc=	Mlym}', "");
    Error('\p{Script: 	:=MODI}');
    Error('\P{Script: 	:=MODI}');
    Expect(1, 71257, '\p{Script=:\AModi\z:}', "");;
    Expect(0, 71258, '\p{Script=:\AModi\z:}', "");;
    Expect(1, 71257, '\p{Script=modi}', "");
    Expect(0, 71257, '\p{^Script=modi}', "");
    Expect(0, 71257, '\P{Script=modi}', "");
    Expect(1, 71257, '\P{^Script=modi}', "");
    Expect(0, 71258, '\p{Script=modi}', "");
    Expect(1, 71258, '\p{^Script=modi}', "");
    Expect(1, 71258, '\P{Script=modi}', "");
    Expect(0, 71258, '\P{^Script=modi}', "");
    Expect(1, 71257, '\p{Script=:\Amodi\z:}', "");;
    Expect(0, 71258, '\p{Script=:\Amodi\z:}', "");;
    Expect(1, 71257, '\p{Script:	_MODI}', "");
    Expect(0, 71257, '\p{^Script:	_MODI}', "");
    Expect(0, 71257, '\P{Script:	_MODI}', "");
    Expect(1, 71257, '\P{^Script:	_MODI}', "");
    Expect(0, 71258, '\p{Script:	_MODI}', "");
    Expect(1, 71258, '\p{^Script:	_MODI}', "");
    Expect(1, 71258, '\P{Script:	_MODI}', "");
    Expect(0, 71258, '\P{^Script:	_MODI}', "");
    Error('\p{Sc=_	Modi:=}');
    Error('\P{Sc=_	Modi:=}');
    Expect(1, 71257, '\p{Sc=:\AModi\z:}', "");;
    Expect(0, 71258, '\p{Sc=:\AModi\z:}', "");;
    Expect(1, 71257, '\p{Sc=modi}', "");
    Expect(0, 71257, '\p{^Sc=modi}', "");
    Expect(0, 71257, '\P{Sc=modi}', "");
    Expect(1, 71257, '\P{^Sc=modi}', "");
    Expect(0, 71258, '\p{Sc=modi}', "");
    Expect(1, 71258, '\p{^Sc=modi}', "");
    Expect(1, 71258, '\P{Sc=modi}', "");
    Expect(0, 71258, '\P{^Sc=modi}', "");
    Expect(1, 71257, '\p{Sc=:\Amodi\z:}', "");;
    Expect(0, 71258, '\p{Sc=:\Amodi\z:}', "");;
    Expect(1, 71257, '\p{Sc=	Modi}', "");
    Expect(0, 71257, '\p{^Sc=	Modi}', "");
    Expect(0, 71257, '\P{Sc=	Modi}', "");
    Expect(1, 71257, '\P{^Sc=	Modi}', "");
    Expect(0, 71258, '\p{Sc=	Modi}', "");
    Expect(1, 71258, '\p{^Sc=	Modi}', "");
    Expect(1, 71258, '\P{Sc=	Modi}', "");
    Expect(0, 71258, '\P{^Sc=	Modi}', "");
    Error('\p{Is_Script= /a/modi}');
    Error('\P{Is_Script= /a/modi}');
    Expect(1, 71257, '\p{Is_Script=modi}', "");
    Expect(0, 71257, '\p{^Is_Script=modi}', "");
    Expect(0, 71257, '\P{Is_Script=modi}', "");
    Expect(1, 71257, '\P{^Is_Script=modi}', "");
    Expect(0, 71258, '\p{Is_Script=modi}', "");
    Expect(1, 71258, '\p{^Is_Script=modi}', "");
    Expect(1, 71258, '\P{Is_Script=modi}', "");
    Expect(0, 71258, '\P{^Is_Script=modi}', "");
    Expect(1, 71257, '\p{Is_Script:	-_modi}', "");
    Expect(0, 71257, '\p{^Is_Script:	-_modi}', "");
    Expect(0, 71257, '\P{Is_Script:	-_modi}', "");
    Expect(1, 71257, '\P{^Is_Script:	-_modi}', "");
    Expect(0, 71258, '\p{Is_Script:	-_modi}', "");
    Expect(1, 71258, '\p{^Is_Script:	-_modi}', "");
    Expect(1, 71258, '\P{Is_Script:	-_modi}', "");
    Expect(0, 71258, '\P{^Is_Script:	-_modi}', "");
    Error('\p{Is_Sc= MODI:=}');
    Error('\P{Is_Sc= MODI:=}');
    Expect(1, 71257, '\p{Is_Sc:   modi}', "");
    Expect(0, 71257, '\p{^Is_Sc:   modi}', "");
    Expect(0, 71257, '\P{Is_Sc:   modi}', "");
    Expect(1, 71257, '\P{^Is_Sc:   modi}', "");
    Expect(0, 71258, '\p{Is_Sc:   modi}', "");
    Expect(1, 71258, '\p{^Is_Sc:   modi}', "");
    Expect(1, 71258, '\P{Is_Sc:   modi}', "");
    Expect(0, 71258, '\P{^Is_Sc:   modi}', "");
    Expect(1, 71257, '\p{Is_Sc=	_Modi}', "");
    Expect(0, 71257, '\p{^Is_Sc=	_Modi}', "");
    Expect(0, 71257, '\P{Is_Sc=	_Modi}', "");
    Expect(1, 71257, '\P{^Is_Sc=	_Modi}', "");
    Expect(0, 71258, '\p{Is_Sc=	_Modi}', "");
    Expect(1, 71258, '\p{^Is_Sc=	_Modi}', "");
    Expect(1, 71258, '\P{Is_Sc=	_Modi}', "");
    Expect(0, 71258, '\P{^Is_Sc=	_Modi}', "");
    Error('\p{Script=:=-Mongolian}');
    Error('\P{Script=:=-Mongolian}');
    Expect(1, 71276, '\p{Script=:\AMongolian\z:}', "");;
    Expect(0, 71277, '\p{Script=:\AMongolian\z:}', "");;
    Expect(1, 71276, '\p{Script=mongolian}', "");
    Expect(0, 71276, '\p{^Script=mongolian}', "");
    Expect(0, 71276, '\P{Script=mongolian}', "");
    Expect(1, 71276, '\P{^Script=mongolian}', "");
    Expect(0, 71277, '\p{Script=mongolian}', "");
    Expect(1, 71277, '\p{^Script=mongolian}', "");
    Expect(1, 71277, '\P{Script=mongolian}', "");
    Expect(0, 71277, '\P{^Script=mongolian}', "");
    Expect(1, 71276, '\p{Script=:\Amongolian\z:}', "");;
    Expect(0, 71277, '\p{Script=:\Amongolian\z:}', "");;
    Expect(1, 71276, '\p{Script=	Mongolian}', "");
    Expect(0, 71276, '\p{^Script=	Mongolian}', "");
    Expect(0, 71276, '\P{Script=	Mongolian}', "");
    Expect(1, 71276, '\P{^Script=	Mongolian}', "");
    Expect(0, 71277, '\p{Script=	Mongolian}', "");
    Expect(1, 71277, '\p{^Script=	Mongolian}', "");
    Expect(1, 71277, '\P{Script=	Mongolian}', "");
    Expect(0, 71277, '\P{^Script=	Mongolian}', "");
    Error('\p{Sc=	:=MONG}');
    Error('\P{Sc=	:=MONG}');
    Expect(1, 71276, '\p{Sc=:\AMong\z:}', "");;
    Expect(0, 71277, '\p{Sc=:\AMong\z:}', "");;
    Expect(1, 71276, '\p{Sc=mong}', "");
    Expect(0, 71276, '\p{^Sc=mong}', "");
    Expect(0, 71276, '\P{Sc=mong}', "");
    Expect(1, 71276, '\P{^Sc=mong}', "");
    Expect(0, 71277, '\p{Sc=mong}', "");
    Expect(1, 71277, '\p{^Sc=mong}', "");
    Expect(1, 71277, '\P{Sc=mong}', "");
    Expect(0, 71277, '\P{^Sc=mong}', "");
    Expect(1, 71276, '\p{Sc=:\Among\z:}', "");;
    Expect(0, 71277, '\p{Sc=:\Among\z:}', "");;
    Expect(1, 71276, '\p{Sc:-_Mong}', "");
    Expect(0, 71276, '\p{^Sc:-_Mong}', "");
    Expect(0, 71276, '\P{Sc:-_Mong}', "");
    Expect(1, 71276, '\P{^Sc:-_Mong}', "");
    Expect(0, 71277, '\p{Sc:-_Mong}', "");
    Expect(1, 71277, '\p{^Sc:-_Mong}', "");
    Expect(1, 71277, '\P{Sc:-_Mong}', "");
    Expect(0, 71277, '\P{^Sc:-_Mong}', "");
    Error('\p{Is_Script=-MONGOLIAN/a/}');
    Error('\P{Is_Script=-MONGOLIAN/a/}');
    Expect(1, 71276, '\p{Is_Script=mongolian}', "");
    Expect(0, 71276, '\p{^Is_Script=mongolian}', "");
    Expect(0, 71276, '\P{Is_Script=mongolian}', "");
    Expect(1, 71276, '\P{^Is_Script=mongolian}', "");
    Expect(0, 71277, '\p{Is_Script=mongolian}', "");
    Expect(1, 71277, '\p{^Is_Script=mongolian}', "");
    Expect(1, 71277, '\P{Is_Script=mongolian}', "");
    Expect(0, 71277, '\P{^Is_Script=mongolian}', "");
    Expect(1, 71276, '\p{Is_Script= -mongolian}', "");
    Expect(0, 71276, '\p{^Is_Script= -mongolian}', "");
    Expect(0, 71276, '\P{Is_Script= -mongolian}', "");
    Expect(1, 71276, '\P{^Is_Script= -mongolian}', "");
    Expect(0, 71277, '\p{Is_Script= -mongolian}', "");
    Expect(1, 71277, '\p{^Is_Script= -mongolian}', "");
    Expect(1, 71277, '\P{Is_Script= -mongolian}', "");
    Expect(0, 71277, '\P{^Is_Script= -mongolian}', "");
    Error('\p{Is_Sc=/a/_MONG}');
    Error('\P{Is_Sc=/a/_MONG}');
    Expect(1, 71276, '\p{Is_Sc=mong}', "");
    Expect(0, 71276, '\p{^Is_Sc=mong}', "");
    Expect(0, 71276, '\P{Is_Sc=mong}', "");
    Expect(1, 71276, '\P{^Is_Sc=mong}', "");
    Expect(0, 71277, '\p{Is_Sc=mong}', "");
    Expect(1, 71277, '\p{^Is_Sc=mong}', "");
    Expect(1, 71277, '\P{Is_Sc=mong}', "");
    Expect(0, 71277, '\P{^Is_Sc=mong}', "");
    Expect(1, 71276, '\p{Is_Sc=--MONG}', "");
    Expect(0, 71276, '\p{^Is_Sc=--MONG}', "");
    Expect(0, 71276, '\P{Is_Sc=--MONG}', "");
    Expect(1, 71276, '\P{^Is_Sc=--MONG}', "");
    Expect(0, 71277, '\p{Is_Sc=--MONG}', "");
    Expect(1, 71277, '\p{^Is_Sc=--MONG}', "");
    Expect(1, 71277, '\P{Is_Sc=--MONG}', "");
    Expect(0, 71277, '\P{^Is_Sc=--MONG}', "");
    Error('\p{Script=_:=Mro}');
    Error('\P{Script=_:=Mro}');
    Expect(1, 92783, '\p{Script=:\AMro\z:}', "");;
    Expect(0, 92784, '\p{Script=:\AMro\z:}', "");;
    Expect(1, 92783, '\p{Script=mro}', "");
    Expect(0, 92783, '\p{^Script=mro}', "");
    Expect(0, 92783, '\P{Script=mro}', "");
    Expect(1, 92783, '\P{^Script=mro}', "");
    Expect(0, 92784, '\p{Script=mro}', "");
    Expect(1, 92784, '\p{^Script=mro}', "");
    Expect(1, 92784, '\P{Script=mro}', "");
    Expect(0, 92784, '\P{^Script=mro}', "");
    Expect(1, 92783, '\p{Script=:\Amro\z:}', "");;
    Expect(0, 92784, '\p{Script=:\Amro\z:}', "");;
    Expect(1, 92783, '\p{Script=-Mro}', "");
    Expect(0, 92783, '\p{^Script=-Mro}', "");
    Expect(0, 92783, '\P{Script=-Mro}', "");
    Expect(1, 92783, '\P{^Script=-Mro}', "");
    Expect(0, 92784, '\p{Script=-Mro}', "");
    Expect(1, 92784, '\p{^Script=-Mro}', "");
    Expect(1, 92784, '\P{Script=-Mro}', "");
    Expect(0, 92784, '\P{^Script=-Mro}', "");
    Error('\p{Sc=	_MROO/a/}');
    Error('\P{Sc=	_MROO/a/}');
    Expect(1, 92783, '\p{Sc=:\AMroo\z:}', "");;
    Expect(0, 92784, '\p{Sc=:\AMroo\z:}', "");;
    Expect(1, 92783, '\p{Sc=mroo}', "");
    Expect(0, 92783, '\p{^Sc=mroo}', "");
    Expect(0, 92783, '\P{Sc=mroo}', "");
    Expect(1, 92783, '\P{^Sc=mroo}', "");
    Expect(0, 92784, '\p{Sc=mroo}', "");
    Expect(1, 92784, '\p{^Sc=mroo}', "");
    Expect(1, 92784, '\P{Sc=mroo}', "");
    Expect(0, 92784, '\P{^Sc=mroo}', "");
    Expect(1, 92783, '\p{Sc=:\Amroo\z:}', "");;
    Expect(0, 92784, '\p{Sc=:\Amroo\z:}', "");;
    Expect(1, 92783, '\p{Sc=--Mroo}', "");
    Expect(0, 92783, '\p{^Sc=--Mroo}', "");
    Expect(0, 92783, '\P{Sc=--Mroo}', "");
    Expect(1, 92783, '\P{^Sc=--Mroo}', "");
    Expect(0, 92784, '\p{Sc=--Mroo}', "");
    Expect(1, 92784, '\p{^Sc=--Mroo}', "");
    Expect(1, 92784, '\P{Sc=--Mroo}', "");
    Expect(0, 92784, '\P{^Sc=--Mroo}', "");
    Error('\p{Is_Script=/a/	mro}');
    Error('\P{Is_Script=/a/	mro}');
    Expect(1, 92783, '\p{Is_Script=mro}', "");
    Expect(0, 92783, '\p{^Is_Script=mro}', "");
    Expect(0, 92783, '\P{Is_Script=mro}', "");
    Expect(1, 92783, '\P{^Is_Script=mro}', "");
    Expect(0, 92784, '\p{Is_Script=mro}', "");
    Expect(1, 92784, '\p{^Is_Script=mro}', "");
    Expect(1, 92784, '\P{Is_Script=mro}', "");
    Expect(0, 92784, '\P{^Is_Script=mro}', "");
    Expect(1, 92783, '\p{Is_Script=	mro}', "");
    Expect(0, 92783, '\p{^Is_Script=	mro}', "");
    Expect(0, 92783, '\P{Is_Script=	mro}', "");
    Expect(1, 92783, '\P{^Is_Script=	mro}', "");
    Expect(0, 92784, '\p{Is_Script=	mro}', "");
    Expect(1, 92784, '\p{^Is_Script=	mro}', "");
    Expect(1, 92784, '\P{Is_Script=	mro}', "");
    Expect(0, 92784, '\P{^Is_Script=	mro}', "");
    Error('\p{Is_Sc=--mroo/a/}');
    Error('\P{Is_Sc=--mroo/a/}');
    Expect(1, 92783, '\p{Is_Sc=mroo}', "");
    Expect(0, 92783, '\p{^Is_Sc=mroo}', "");
    Expect(0, 92783, '\P{Is_Sc=mroo}', "");
    Expect(1, 92783, '\P{^Is_Sc=mroo}', "");
    Expect(0, 92784, '\p{Is_Sc=mroo}', "");
    Expect(1, 92784, '\p{^Is_Sc=mroo}', "");
    Expect(1, 92784, '\P{Is_Sc=mroo}', "");
    Expect(0, 92784, '\P{^Is_Sc=mroo}', "");
    Expect(1, 92783, '\p{Is_Sc=--Mroo}', "");
    Expect(0, 92783, '\p{^Is_Sc=--Mroo}', "");
    Expect(0, 92783, '\P{Is_Sc=--Mroo}', "");
    Expect(1, 92783, '\P{^Is_Sc=--Mroo}', "");
    Expect(0, 92784, '\p{Is_Sc=--Mroo}', "");
    Expect(1, 92784, '\p{^Is_Sc=--Mroo}', "");
    Expect(1, 92784, '\P{Is_Sc=--Mroo}', "");
    Expect(0, 92784, '\P{^Is_Sc=--Mroo}', "");
    Error('\p{Script=		meetei_MAYEK:=}');
    Error('\P{Script=		meetei_MAYEK:=}');
    Expect(1, 44025, '\p{Script=:\AMeetei_Mayek\z:}', "");;
    Expect(0, 44026, '\p{Script=:\AMeetei_Mayek\z:}', "");;
    Expect(1, 44025, '\p{Script=meeteimayek}', "");
    Expect(0, 44025, '\p{^Script=meeteimayek}', "");
    Expect(0, 44025, '\P{Script=meeteimayek}', "");
    Expect(1, 44025, '\P{^Script=meeteimayek}', "");
    Expect(0, 44026, '\p{Script=meeteimayek}', "");
    Expect(1, 44026, '\p{^Script=meeteimayek}', "");
    Expect(1, 44026, '\P{Script=meeteimayek}', "");
    Expect(0, 44026, '\P{^Script=meeteimayek}', "");
    Expect(1, 44025, '\p{Script=:\Ameeteimayek\z:}', "");;
    Expect(0, 44026, '\p{Script=:\Ameeteimayek\z:}', "");;
    Expect(1, 44025, '\p{Script=-_MEETEI_Mayek}', "");
    Expect(0, 44025, '\p{^Script=-_MEETEI_Mayek}', "");
    Expect(0, 44025, '\P{Script=-_MEETEI_Mayek}', "");
    Expect(1, 44025, '\P{^Script=-_MEETEI_Mayek}', "");
    Expect(0, 44026, '\p{Script=-_MEETEI_Mayek}', "");
    Expect(1, 44026, '\p{^Script=-_MEETEI_Mayek}', "");
    Expect(1, 44026, '\P{Script=-_MEETEI_Mayek}', "");
    Expect(0, 44026, '\P{^Script=-_MEETEI_Mayek}', "");
    Error('\p{Sc=/a/		MTEI}');
    Error('\P{Sc=/a/		MTEI}');
    Expect(1, 44025, '\p{Sc=:\AMtei\z:}', "");;
    Expect(0, 44026, '\p{Sc=:\AMtei\z:}', "");;
    Expect(1, 44025, '\p{Sc=mtei}', "");
    Expect(0, 44025, '\p{^Sc=mtei}', "");
    Expect(0, 44025, '\P{Sc=mtei}', "");
    Expect(1, 44025, '\P{^Sc=mtei}', "");
    Expect(0, 44026, '\p{Sc=mtei}', "");
    Expect(1, 44026, '\p{^Sc=mtei}', "");
    Expect(1, 44026, '\P{Sc=mtei}', "");
    Expect(0, 44026, '\P{^Sc=mtei}', "");
    Expect(1, 44025, '\p{Sc=:\Amtei\z:}', "");;
    Expect(0, 44026, '\p{Sc=:\Amtei\z:}', "");;
    Expect(1, 44025, '\p{Sc=_	MTEI}', "");
    Expect(0, 44025, '\p{^Sc=_	MTEI}', "");
    Expect(0, 44025, '\P{Sc=_	MTEI}', "");
    Expect(1, 44025, '\P{^Sc=_	MTEI}', "");
    Expect(0, 44026, '\p{Sc=_	MTEI}', "");
    Expect(1, 44026, '\p{^Sc=_	MTEI}', "");
    Expect(1, 44026, '\P{Sc=_	MTEI}', "");
    Expect(0, 44026, '\P{^Sc=_	MTEI}', "");
    Error('\p{Is_Script:_-MEETEI_MAYEK/a/}');
    Error('\P{Is_Script:_-MEETEI_MAYEK/a/}');
    Expect(1, 44025, '\p{Is_Script=meeteimayek}', "");
    Expect(0, 44025, '\p{^Is_Script=meeteimayek}', "");
    Expect(0, 44025, '\P{Is_Script=meeteimayek}', "");
    Expect(1, 44025, '\P{^Is_Script=meeteimayek}', "");
    Expect(0, 44026, '\p{Is_Script=meeteimayek}', "");
    Expect(1, 44026, '\p{^Is_Script=meeteimayek}', "");
    Expect(1, 44026, '\P{Is_Script=meeteimayek}', "");
    Expect(0, 44026, '\P{^Is_Script=meeteimayek}', "");
    Expect(1, 44025, '\p{Is_Script= Meetei_MAYEK}', "");
    Expect(0, 44025, '\p{^Is_Script= Meetei_MAYEK}', "");
    Expect(0, 44025, '\P{Is_Script= Meetei_MAYEK}', "");
    Expect(1, 44025, '\P{^Is_Script= Meetei_MAYEK}', "");
    Expect(0, 44026, '\p{Is_Script= Meetei_MAYEK}', "");
    Expect(1, 44026, '\p{^Is_Script= Meetei_MAYEK}', "");
    Expect(1, 44026, '\P{Is_Script= Meetei_MAYEK}', "");
    Expect(0, 44026, '\P{^Is_Script= Meetei_MAYEK}', "");
    Error('\p{Is_Sc= :=Mtei}');
    Error('\P{Is_Sc= :=Mtei}');
    Expect(1, 44025, '\p{Is_Sc=mtei}', "");
    Expect(0, 44025, '\p{^Is_Sc=mtei}', "");
    Expect(0, 44025, '\P{Is_Sc=mtei}', "");
    Expect(1, 44025, '\P{^Is_Sc=mtei}', "");
    Expect(0, 44026, '\p{Is_Sc=mtei}', "");
    Expect(1, 44026, '\p{^Is_Sc=mtei}', "");
    Expect(1, 44026, '\P{Is_Sc=mtei}', "");
    Expect(0, 44026, '\P{^Is_Sc=mtei}', "");
    Expect(1, 44025, '\p{Is_Sc=	mtei}', "");
    Expect(0, 44025, '\p{^Is_Sc=	mtei}', "");
    Expect(0, 44025, '\P{Is_Sc=	mtei}', "");
    Expect(1, 44025, '\P{^Is_Sc=	mtei}', "");
    Expect(0, 44026, '\p{Is_Sc=	mtei}', "");
    Expect(1, 44026, '\p{^Is_Sc=	mtei}', "");
    Expect(1, 44026, '\P{Is_Sc=	mtei}', "");
    Expect(0, 44026, '\P{^Is_Sc=	mtei}', "");
    Error('\p{Script=_multani/a/}');
    Error('\P{Script=_multani/a/}');
    Expect(1, 70313, '\p{Script=:\AMultani\z:}', "");;
    Expect(0, 70314, '\p{Script=:\AMultani\z:}', "");;
    Expect(1, 70313, '\p{Script=multani}', "");
    Expect(0, 70313, '\p{^Script=multani}', "");
    Expect(0, 70313, '\P{Script=multani}', "");
    Expect(1, 70313, '\P{^Script=multani}', "");
    Expect(0, 70314, '\p{Script=multani}', "");
    Expect(1, 70314, '\p{^Script=multani}', "");
    Expect(1, 70314, '\P{Script=multani}', "");
    Expect(0, 70314, '\P{^Script=multani}', "");
    Expect(1, 70313, '\p{Script=:\Amultani\z:}', "");;
    Expect(0, 70314, '\p{Script=:\Amultani\z:}', "");;
    Expect(1, 70313, '\p{Script= Multani}', "");
    Expect(0, 70313, '\p{^Script= Multani}', "");
    Expect(0, 70313, '\P{Script= Multani}', "");
    Expect(1, 70313, '\P{^Script= Multani}', "");
    Expect(0, 70314, '\p{Script= Multani}', "");
    Expect(1, 70314, '\p{^Script= Multani}', "");
    Expect(1, 70314, '\P{Script= Multani}', "");
    Expect(0, 70314, '\P{^Script= Multani}', "");
    Error('\p{Sc=/a/_	Mult}');
    Error('\P{Sc=/a/_	Mult}');
    Expect(1, 70313, '\p{Sc=:\AMult\z:}', "");;
    Expect(0, 70314, '\p{Sc=:\AMult\z:}', "");;
    Expect(1, 70313, '\p{Sc=mult}', "");
    Expect(0, 70313, '\p{^Sc=mult}', "");
    Expect(0, 70313, '\P{Sc=mult}', "");
    Expect(1, 70313, '\P{^Sc=mult}', "");
    Expect(0, 70314, '\p{Sc=mult}', "");
    Expect(1, 70314, '\p{^Sc=mult}', "");
    Expect(1, 70314, '\P{Sc=mult}', "");
    Expect(0, 70314, '\P{^Sc=mult}', "");
    Expect(1, 70313, '\p{Sc=:\Amult\z:}', "");;
    Expect(0, 70314, '\p{Sc=:\Amult\z:}', "");;
    Expect(1, 70313, '\p{Sc=_ MULT}', "");
    Expect(0, 70313, '\p{^Sc=_ MULT}', "");
    Expect(0, 70313, '\P{Sc=_ MULT}', "");
    Expect(1, 70313, '\P{^Sc=_ MULT}', "");
    Expect(0, 70314, '\p{Sc=_ MULT}', "");
    Expect(1, 70314, '\p{^Sc=_ MULT}', "");
    Expect(1, 70314, '\P{Sc=_ MULT}', "");
    Expect(0, 70314, '\P{^Sc=_ MULT}', "");
    Error('\p{Is_Script::= 	Multani}');
    Error('\P{Is_Script::= 	Multani}');
    Expect(1, 70313, '\p{Is_Script=multani}', "");
    Expect(0, 70313, '\p{^Is_Script=multani}', "");
    Expect(0, 70313, '\P{Is_Script=multani}', "");
    Expect(1, 70313, '\P{^Is_Script=multani}', "");
    Expect(0, 70314, '\p{Is_Script=multani}', "");
    Expect(1, 70314, '\p{^Is_Script=multani}', "");
    Expect(1, 70314, '\P{Is_Script=multani}', "");
    Expect(0, 70314, '\P{^Is_Script=multani}', "");
    Expect(1, 70313, '\p{Is_Script=-multani}', "");
    Expect(0, 70313, '\p{^Is_Script=-multani}', "");
    Expect(0, 70313, '\P{Is_Script=-multani}', "");
    Expect(1, 70313, '\P{^Is_Script=-multani}', "");
    Expect(0, 70314, '\p{Is_Script=-multani}', "");
    Expect(1, 70314, '\p{^Is_Script=-multani}', "");
    Expect(1, 70314, '\P{Is_Script=-multani}', "");
    Expect(0, 70314, '\P{^Is_Script=-multani}', "");
    Error('\p{Is_Sc=	_Mult/a/}');
    Error('\P{Is_Sc=	_Mult/a/}');
    Expect(1, 70313, '\p{Is_Sc=mult}', "");
    Expect(0, 70313, '\p{^Is_Sc=mult}', "");
    Expect(0, 70313, '\P{Is_Sc=mult}', "");
    Expect(1, 70313, '\P{^Is_Sc=mult}', "");
    Expect(0, 70314, '\p{Is_Sc=mult}', "");
    Expect(1, 70314, '\p{^Is_Sc=mult}', "");
    Expect(1, 70314, '\P{Is_Sc=mult}', "");
    Expect(0, 70314, '\P{^Is_Sc=mult}', "");
    Expect(1, 70313, '\p{Is_Sc= MULT}', "");
    Expect(0, 70313, '\p{^Is_Sc= MULT}', "");
    Expect(0, 70313, '\P{Is_Sc= MULT}', "");
    Expect(1, 70313, '\P{^Is_Sc= MULT}', "");
    Expect(0, 70314, '\p{Is_Sc= MULT}', "");
    Expect(1, 70314, '\p{^Is_Sc= MULT}', "");
    Expect(1, 70314, '\P{Is_Sc= MULT}', "");
    Expect(0, 70314, '\P{^Is_Sc= MULT}', "");
    Error('\p{Script=:=	_Myanmar}');
    Error('\P{Script=:=	_Myanmar}');
    Expect(1, 43647, '\p{Script=:\AMyanmar\z:}', "");;
    Expect(0, 43648, '\p{Script=:\AMyanmar\z:}', "");;
    Expect(1, 43647, '\p{Script=myanmar}', "");
    Expect(0, 43647, '\p{^Script=myanmar}', "");
    Expect(0, 43647, '\P{Script=myanmar}', "");
    Expect(1, 43647, '\P{^Script=myanmar}', "");
    Expect(0, 43648, '\p{Script=myanmar}', "");
    Expect(1, 43648, '\p{^Script=myanmar}', "");
    Expect(1, 43648, '\P{Script=myanmar}', "");
    Expect(0, 43648, '\P{^Script=myanmar}', "");
    Expect(1, 43647, '\p{Script=:\Amyanmar\z:}', "");;
    Expect(0, 43648, '\p{Script=:\Amyanmar\z:}', "");;
    Expect(1, 43647, '\p{Script=_ MYANMAR}', "");
    Expect(0, 43647, '\p{^Script=_ MYANMAR}', "");
    Expect(0, 43647, '\P{Script=_ MYANMAR}', "");
    Expect(1, 43647, '\P{^Script=_ MYANMAR}', "");
    Expect(0, 43648, '\p{Script=_ MYANMAR}', "");
    Expect(1, 43648, '\p{^Script=_ MYANMAR}', "");
    Expect(1, 43648, '\P{Script=_ MYANMAR}', "");
    Expect(0, 43648, '\P{^Script=_ MYANMAR}', "");
    Error('\p{Sc=_ mymr/a/}');
    Error('\P{Sc=_ mymr/a/}');
    Expect(1, 43647, '\p{Sc=:\AMymr\z:}', "");;
    Expect(0, 43648, '\p{Sc=:\AMymr\z:}', "");;
    Expect(1, 43647, '\p{Sc=mymr}', "");
    Expect(0, 43647, '\p{^Sc=mymr}', "");
    Expect(0, 43647, '\P{Sc=mymr}', "");
    Expect(1, 43647, '\P{^Sc=mymr}', "");
    Expect(0, 43648, '\p{Sc=mymr}', "");
    Expect(1, 43648, '\p{^Sc=mymr}', "");
    Expect(1, 43648, '\P{Sc=mymr}', "");
    Expect(0, 43648, '\P{^Sc=mymr}', "");
    Expect(1, 43647, '\p{Sc=:\Amymr\z:}', "");;
    Expect(0, 43648, '\p{Sc=:\Amymr\z:}', "");;
    Expect(1, 43647, '\p{Sc=_	Mymr}', "");
    Expect(0, 43647, '\p{^Sc=_	Mymr}', "");
    Expect(0, 43647, '\P{Sc=_	Mymr}', "");
    Expect(1, 43647, '\P{^Sc=_	Mymr}', "");
    Expect(0, 43648, '\p{Sc=_	Mymr}', "");
    Expect(1, 43648, '\p{^Sc=_	Mymr}', "");
    Expect(1, 43648, '\P{Sc=_	Mymr}', "");
    Expect(0, 43648, '\P{^Sc=_	Mymr}', "");
    Error('\p{Is_Script=_	Myanmar/a/}');
    Error('\P{Is_Script=_	Myanmar/a/}');
    Expect(1, 43647, '\p{Is_Script=myanmar}', "");
    Expect(0, 43647, '\p{^Is_Script=myanmar}', "");
    Expect(0, 43647, '\P{Is_Script=myanmar}', "");
    Expect(1, 43647, '\P{^Is_Script=myanmar}', "");
    Expect(0, 43648, '\p{Is_Script=myanmar}', "");
    Expect(1, 43648, '\p{^Is_Script=myanmar}', "");
    Expect(1, 43648, '\P{Is_Script=myanmar}', "");
    Expect(0, 43648, '\P{^Is_Script=myanmar}', "");
    Expect(1, 43647, '\p{Is_Script:  	Myanmar}', "");
    Expect(0, 43647, '\p{^Is_Script:  	Myanmar}', "");
    Expect(0, 43647, '\P{Is_Script:  	Myanmar}', "");
    Expect(1, 43647, '\P{^Is_Script:  	Myanmar}', "");
    Expect(0, 43648, '\p{Is_Script:  	Myanmar}', "");
    Expect(1, 43648, '\p{^Is_Script:  	Myanmar}', "");
    Expect(1, 43648, '\P{Is_Script:  	Myanmar}', "");
    Expect(0, 43648, '\P{^Is_Script:  	Myanmar}', "");
    Error('\p{Is_Sc=_-Mymr:=}');
    Error('\P{Is_Sc=_-Mymr:=}');
    Expect(1, 43647, '\p{Is_Sc: mymr}', "");
    Expect(0, 43647, '\p{^Is_Sc: mymr}', "");
    Expect(0, 43647, '\P{Is_Sc: mymr}', "");
    Expect(1, 43647, '\P{^Is_Sc: mymr}', "");
    Expect(0, 43648, '\p{Is_Sc: mymr}', "");
    Expect(1, 43648, '\p{^Is_Sc: mymr}', "");
    Expect(1, 43648, '\P{Is_Sc: mymr}', "");
    Expect(0, 43648, '\P{^Is_Sc: mymr}', "");
    Expect(1, 43647, '\p{Is_Sc=_MYMR}', "");
    Expect(0, 43647, '\p{^Is_Sc=_MYMR}', "");
    Expect(0, 43647, '\P{Is_Sc=_MYMR}', "");
    Expect(1, 43647, '\P{^Is_Sc=_MYMR}', "");
    Expect(0, 43648, '\p{Is_Sc=_MYMR}', "");
    Expect(1, 43648, '\p{^Is_Sc=_MYMR}', "");
    Expect(1, 43648, '\P{Is_Sc=_MYMR}', "");
    Expect(0, 43648, '\P{^Is_Sc=_MYMR}', "");
    Error('\p{Script=:=	 Nandinagari}');
    Error('\P{Script=:=	 Nandinagari}');
    Expect(1, 72164, '\p{Script=:\ANandinagari\z:}', "");;
    Expect(0, 72165, '\p{Script=:\ANandinagari\z:}', "");;
    Expect(1, 72164, '\p{Script=nandinagari}', "");
    Expect(0, 72164, '\p{^Script=nandinagari}', "");
    Expect(0, 72164, '\P{Script=nandinagari}', "");
    Expect(1, 72164, '\P{^Script=nandinagari}', "");
    Expect(0, 72165, '\p{Script=nandinagari}', "");
    Expect(1, 72165, '\p{^Script=nandinagari}', "");
    Expect(1, 72165, '\P{Script=nandinagari}', "");
    Expect(0, 72165, '\P{^Script=nandinagari}', "");
    Expect(1, 72164, '\p{Script=:\Anandinagari\z:}', "");;
    Expect(0, 72165, '\p{Script=:\Anandinagari\z:}', "");;
    Expect(1, 72164, '\p{Script= NANDINAGARI}', "");
    Expect(0, 72164, '\p{^Script= NANDINAGARI}', "");
    Expect(0, 72164, '\P{Script= NANDINAGARI}', "");
    Expect(1, 72164, '\P{^Script= NANDINAGARI}', "");
    Expect(0, 72165, '\p{Script= NANDINAGARI}', "");
    Expect(1, 72165, '\p{^Script= NANDINAGARI}', "");
    Expect(1, 72165, '\P{Script= NANDINAGARI}', "");
    Expect(0, 72165, '\P{^Script= NANDINAGARI}', "");
    Error('\p{Sc=	/a/Nand}');
    Error('\P{Sc=	/a/Nand}');
    Expect(1, 72164, '\p{Sc=:\ANand\z:}', "");;
    Expect(0, 72165, '\p{Sc=:\ANand\z:}', "");;
    Expect(1, 72164, '\p{Sc=nand}', "");
    Expect(0, 72164, '\p{^Sc=nand}', "");
    Expect(0, 72164, '\P{Sc=nand}', "");
    Expect(1, 72164, '\P{^Sc=nand}', "");
    Expect(0, 72165, '\p{Sc=nand}', "");
    Expect(1, 72165, '\p{^Sc=nand}', "");
    Expect(1, 72165, '\P{Sc=nand}', "");
    Expect(0, 72165, '\P{^Sc=nand}', "");
    Expect(1, 72164, '\p{Sc=:\Anand\z:}', "");;
    Expect(0, 72165, '\p{Sc=:\Anand\z:}', "");;
    Expect(1, 72164, '\p{Sc:   NAND}', "");
    Expect(0, 72164, '\p{^Sc:   NAND}', "");
    Expect(0, 72164, '\P{Sc:   NAND}', "");
    Expect(1, 72164, '\P{^Sc:   NAND}', "");
    Expect(0, 72165, '\p{Sc:   NAND}', "");
    Expect(1, 72165, '\p{^Sc:   NAND}', "");
    Expect(1, 72165, '\P{Sc:   NAND}', "");
    Expect(0, 72165, '\P{^Sc:   NAND}', "");
    Error('\p{Is_Script: _Nandinagari/a/}');
    Error('\P{Is_Script: _Nandinagari/a/}');
    Expect(1, 72164, '\p{Is_Script=nandinagari}', "");
    Expect(0, 72164, '\p{^Is_Script=nandinagari}', "");
    Expect(0, 72164, '\P{Is_Script=nandinagari}', "");
    Expect(1, 72164, '\P{^Is_Script=nandinagari}', "");
    Expect(0, 72165, '\p{Is_Script=nandinagari}', "");
    Expect(1, 72165, '\p{^Is_Script=nandinagari}', "");
    Expect(1, 72165, '\P{Is_Script=nandinagari}', "");
    Expect(0, 72165, '\P{^Is_Script=nandinagari}', "");
    Expect(1, 72164, '\p{Is_Script=	 nandinagari}', "");
    Expect(0, 72164, '\p{^Is_Script=	 nandinagari}', "");
    Expect(0, 72164, '\P{Is_Script=	 nandinagari}', "");
    Expect(1, 72164, '\P{^Is_Script=	 nandinagari}', "");
    Expect(0, 72165, '\p{Is_Script=	 nandinagari}', "");
    Expect(1, 72165, '\p{^Is_Script=	 nandinagari}', "");
    Expect(1, 72165, '\P{Is_Script=	 nandinagari}', "");
    Expect(0, 72165, '\P{^Is_Script=	 nandinagari}', "");
    Error('\p{Is_Sc=	NAND/a/}');
    Error('\P{Is_Sc=	NAND/a/}');
    Expect(1, 72164, '\p{Is_Sc=nand}', "");
    Expect(0, 72164, '\p{^Is_Sc=nand}', "");
    Expect(0, 72164, '\P{Is_Sc=nand}', "");
    Expect(1, 72164, '\P{^Is_Sc=nand}', "");
    Expect(0, 72165, '\p{Is_Sc=nand}', "");
    Expect(1, 72165, '\p{^Is_Sc=nand}', "");
    Expect(1, 72165, '\P{Is_Sc=nand}', "");
    Expect(0, 72165, '\P{^Is_Sc=nand}', "");
    Expect(1, 72164, '\p{Is_Sc=-Nand}', "");
    Expect(0, 72164, '\p{^Is_Sc=-Nand}', "");
    Expect(0, 72164, '\P{Is_Sc=-Nand}', "");
    Expect(1, 72164, '\P{^Is_Sc=-Nand}', "");
    Expect(0, 72165, '\p{Is_Sc=-Nand}', "");
    Expect(1, 72165, '\p{^Is_Sc=-Nand}', "");
    Expect(1, 72165, '\P{Is_Sc=-Nand}', "");
    Expect(0, 72165, '\P{^Is_Sc=-Nand}', "");
    Error('\p{Script:- old_North_Arabian:=}');
    Error('\P{Script:- old_North_Arabian:=}');
    Expect(1, 68255, '\p{Script=:\AOld_North_Arabian\z:}', "");;
    Expect(0, 68256, '\p{Script=:\AOld_North_Arabian\z:}', "");;
    Expect(1, 68255, '\p{Script=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Script=oldnortharabian}', "");
    Expect(0, 68255, '\P{Script=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Script=oldnortharabian}', "");
    Expect(0, 68256, '\p{Script=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Script=oldnortharabian}', "");
    Expect(1, 68256, '\P{Script=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Script=oldnortharabian}', "");
    Expect(1, 68255, '\p{Script=:\Aoldnortharabian\z:}', "");;
    Expect(0, 68256, '\p{Script=:\Aoldnortharabian\z:}', "");;
    Expect(1, 68255, '\p{Script=--OLD_North_Arabian}', "");
    Expect(0, 68255, '\p{^Script=--OLD_North_Arabian}', "");
    Expect(0, 68255, '\P{Script=--OLD_North_Arabian}', "");
    Expect(1, 68255, '\P{^Script=--OLD_North_Arabian}', "");
    Expect(0, 68256, '\p{Script=--OLD_North_Arabian}', "");
    Expect(1, 68256, '\p{^Script=--OLD_North_Arabian}', "");
    Expect(1, 68256, '\P{Script=--OLD_North_Arabian}', "");
    Expect(0, 68256, '\P{^Script=--OLD_North_Arabian}', "");
    Error('\p{Sc=_ narb/a/}');
    Error('\P{Sc=_ narb/a/}');
    Expect(1, 68255, '\p{Sc=:\ANarb\z:}', "");;
    Expect(0, 68256, '\p{Sc=:\ANarb\z:}', "");;
    Expect(1, 68255, '\p{Sc:	narb}', "");
    Expect(0, 68255, '\p{^Sc:	narb}', "");
    Expect(0, 68255, '\P{Sc:	narb}', "");
    Expect(1, 68255, '\P{^Sc:	narb}', "");
    Expect(0, 68256, '\p{Sc:	narb}', "");
    Expect(1, 68256, '\p{^Sc:	narb}', "");
    Expect(1, 68256, '\P{Sc:	narb}', "");
    Expect(0, 68256, '\P{^Sc:	narb}', "");
    Expect(1, 68255, '\p{Sc=:\Anarb\z:}', "");;
    Expect(0, 68256, '\p{Sc=:\Anarb\z:}', "");;
    Expect(1, 68255, '\p{Sc=_Narb}', "");
    Expect(0, 68255, '\p{^Sc=_Narb}', "");
    Expect(0, 68255, '\P{Sc=_Narb}', "");
    Expect(1, 68255, '\P{^Sc=_Narb}', "");
    Expect(0, 68256, '\p{Sc=_Narb}', "");
    Expect(1, 68256, '\p{^Sc=_Narb}', "");
    Expect(1, 68256, '\P{Sc=_Narb}', "");
    Expect(0, 68256, '\P{^Sc=_Narb}', "");
    Error('\p{Is_Script=- Old_NORTH_Arabian:=}');
    Error('\P{Is_Script=- Old_NORTH_Arabian:=}');
    Expect(1, 68255, '\p{Is_Script=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Is_Script=oldnortharabian}', "");
    Expect(0, 68255, '\P{Is_Script=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Is_Script=oldnortharabian}', "");
    Expect(0, 68256, '\p{Is_Script=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Is_Script=oldnortharabian}', "");
    Expect(1, 68256, '\P{Is_Script=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Is_Script=oldnortharabian}', "");
    Expect(1, 68255, '\p{Is_Script=  Old_North_ARABIAN}', "");
    Expect(0, 68255, '\p{^Is_Script=  Old_North_ARABIAN}', "");
    Expect(0, 68255, '\P{Is_Script=  Old_North_ARABIAN}', "");
    Expect(1, 68255, '\P{^Is_Script=  Old_North_ARABIAN}', "");
    Expect(0, 68256, '\p{Is_Script=  Old_North_ARABIAN}', "");
    Expect(1, 68256, '\p{^Is_Script=  Old_North_ARABIAN}', "");
    Expect(1, 68256, '\P{Is_Script=  Old_North_ARABIAN}', "");
    Expect(0, 68256, '\P{^Is_Script=  Old_North_ARABIAN}', "");
    Error('\p{Is_Sc: /a/narb}');
    Error('\P{Is_Sc: /a/narb}');
    Expect(1, 68255, '\p{Is_Sc=narb}', "");
    Expect(0, 68255, '\p{^Is_Sc=narb}', "");
    Expect(0, 68255, '\P{Is_Sc=narb}', "");
    Expect(1, 68255, '\P{^Is_Sc=narb}', "");
    Expect(0, 68256, '\p{Is_Sc=narb}', "");
    Expect(1, 68256, '\p{^Is_Sc=narb}', "");
    Expect(1, 68256, '\P{Is_Sc=narb}', "");
    Expect(0, 68256, '\P{^Is_Sc=narb}', "");
    Expect(1, 68255, '\p{Is_Sc=	NARB}', "");
    Expect(0, 68255, '\p{^Is_Sc=	NARB}', "");
    Expect(0, 68255, '\P{Is_Sc=	NARB}', "");
    Expect(1, 68255, '\P{^Is_Sc=	NARB}', "");
    Expect(0, 68256, '\p{Is_Sc=	NARB}', "");
    Expect(1, 68256, '\p{^Is_Sc=	NARB}', "");
    Expect(1, 68256, '\P{Is_Sc=	NARB}', "");
    Expect(0, 68256, '\P{^Is_Sc=	NARB}', "");
    Error('\p{Script=	:=Nabataean}');
    Error('\P{Script=	:=Nabataean}');
    Expect(1, 67759, '\p{Script=:\ANabataean\z:}', "");;
    Expect(0, 67760, '\p{Script=:\ANabataean\z:}', "");;
    Expect(1, 67759, '\p{Script=nabataean}', "");
    Expect(0, 67759, '\p{^Script=nabataean}', "");
    Expect(0, 67759, '\P{Script=nabataean}', "");
    Expect(1, 67759, '\P{^Script=nabataean}', "");
    Expect(0, 67760, '\p{Script=nabataean}', "");
    Expect(1, 67760, '\p{^Script=nabataean}', "");
    Expect(1, 67760, '\P{Script=nabataean}', "");
    Expect(0, 67760, '\P{^Script=nabataean}', "");
    Expect(1, 67759, '\p{Script=:\Anabataean\z:}', "");;
    Expect(0, 67760, '\p{Script=:\Anabataean\z:}', "");;
    Expect(1, 67759, '\p{Script=	-Nabataean}', "");
    Expect(0, 67759, '\p{^Script=	-Nabataean}', "");
    Expect(0, 67759, '\P{Script=	-Nabataean}', "");
    Expect(1, 67759, '\P{^Script=	-Nabataean}', "");
    Expect(0, 67760, '\p{Script=	-Nabataean}', "");
    Expect(1, 67760, '\p{^Script=	-Nabataean}', "");
    Expect(1, 67760, '\P{Script=	-Nabataean}', "");
    Expect(0, 67760, '\P{^Script=	-Nabataean}', "");
    Error('\p{Sc=/a/ 	Nbat}');
    Error('\P{Sc=/a/ 	Nbat}');
    Expect(1, 67759, '\p{Sc=:\ANbat\z:}', "");;
    Expect(0, 67760, '\p{Sc=:\ANbat\z:}', "");;
    Expect(1, 67759, '\p{Sc=nbat}', "");
    Expect(0, 67759, '\p{^Sc=nbat}', "");
    Expect(0, 67759, '\P{Sc=nbat}', "");
    Expect(1, 67759, '\P{^Sc=nbat}', "");
    Expect(0, 67760, '\p{Sc=nbat}', "");
    Expect(1, 67760, '\p{^Sc=nbat}', "");
    Expect(1, 67760, '\P{Sc=nbat}', "");
    Expect(0, 67760, '\P{^Sc=nbat}', "");
    Expect(1, 67759, '\p{Sc=:\Anbat\z:}', "");;
    Expect(0, 67760, '\p{Sc=:\Anbat\z:}', "");;
    Expect(1, 67759, '\p{Sc=__Nbat}', "");
    Expect(0, 67759, '\p{^Sc=__Nbat}', "");
    Expect(0, 67759, '\P{Sc=__Nbat}', "");
    Expect(1, 67759, '\P{^Sc=__Nbat}', "");
    Expect(0, 67760, '\p{Sc=__Nbat}', "");
    Expect(1, 67760, '\p{^Sc=__Nbat}', "");
    Expect(1, 67760, '\P{Sc=__Nbat}', "");
    Expect(0, 67760, '\P{^Sc=__Nbat}', "");
    Error('\p{Is_Script=	:=Nabataean}');
    Error('\P{Is_Script=	:=Nabataean}');
    Expect(1, 67759, '\p{Is_Script=nabataean}', "");
    Expect(0, 67759, '\p{^Is_Script=nabataean}', "");
    Expect(0, 67759, '\P{Is_Script=nabataean}', "");
    Expect(1, 67759, '\P{^Is_Script=nabataean}', "");
    Expect(0, 67760, '\p{Is_Script=nabataean}', "");
    Expect(1, 67760, '\p{^Is_Script=nabataean}', "");
    Expect(1, 67760, '\P{Is_Script=nabataean}', "");
    Expect(0, 67760, '\P{^Is_Script=nabataean}', "");
    Expect(1, 67759, '\p{Is_Script=	-Nabataean}', "");
    Expect(0, 67759, '\p{^Is_Script=	-Nabataean}', "");
    Expect(0, 67759, '\P{Is_Script=	-Nabataean}', "");
    Expect(1, 67759, '\P{^Is_Script=	-Nabataean}', "");
    Expect(0, 67760, '\p{Is_Script=	-Nabataean}', "");
    Expect(1, 67760, '\p{^Is_Script=	-Nabataean}', "");
    Expect(1, 67760, '\P{Is_Script=	-Nabataean}', "");
    Expect(0, 67760, '\P{^Is_Script=	-Nabataean}', "");
    Error('\p{Is_Sc=:=-Nbat}');
    Error('\P{Is_Sc=:=-Nbat}');
    Expect(1, 67759, '\p{Is_Sc=nbat}', "");
    Expect(0, 67759, '\p{^Is_Sc=nbat}', "");
    Expect(0, 67759, '\P{Is_Sc=nbat}', "");
    Expect(1, 67759, '\P{^Is_Sc=nbat}', "");
    Expect(0, 67760, '\p{Is_Sc=nbat}', "");
    Expect(1, 67760, '\p{^Is_Sc=nbat}', "");
    Expect(1, 67760, '\P{Is_Sc=nbat}', "");
    Expect(0, 67760, '\P{^Is_Sc=nbat}', "");
    Expect(1, 67759, '\p{Is_Sc:   -Nbat}', "");
    Expect(0, 67759, '\p{^Is_Sc:   -Nbat}', "");
    Expect(0, 67759, '\P{Is_Sc:   -Nbat}', "");
    Expect(1, 67759, '\P{^Is_Sc:   -Nbat}', "");
    Expect(0, 67760, '\p{Is_Sc:   -Nbat}', "");
    Expect(1, 67760, '\p{^Is_Sc:   -Nbat}', "");
    Expect(1, 67760, '\P{Is_Sc:   -Nbat}', "");
    Expect(0, 67760, '\P{^Is_Sc:   -Nbat}', "");
    Error('\p{Script=	NEWA/a/}');
    Error('\P{Script=	NEWA/a/}');
    Expect(1, 70751, '\p{Script=:\ANewa\z:}', "");;
    Expect(0, 70752, '\p{Script=:\ANewa\z:}', "");;
    Expect(1, 70751, '\p{Script=newa}', "");
    Expect(0, 70751, '\p{^Script=newa}', "");
    Expect(0, 70751, '\P{Script=newa}', "");
    Expect(1, 70751, '\P{^Script=newa}', "");
    Expect(0, 70752, '\p{Script=newa}', "");
    Expect(1, 70752, '\p{^Script=newa}', "");
    Expect(1, 70752, '\P{Script=newa}', "");
    Expect(0, 70752, '\P{^Script=newa}', "");
    Expect(1, 70751, '\p{Script=:\Anewa\z:}', "");;
    Expect(0, 70752, '\p{Script=:\Anewa\z:}', "");;
    Expect(1, 70751, '\p{Script=_-NEWA}', "");
    Expect(0, 70751, '\p{^Script=_-NEWA}', "");
    Expect(0, 70751, '\P{Script=_-NEWA}', "");
    Expect(1, 70751, '\P{^Script=_-NEWA}', "");
    Expect(0, 70752, '\p{Script=_-NEWA}', "");
    Expect(1, 70752, '\p{^Script=_-NEWA}', "");
    Expect(1, 70752, '\P{Script=_-NEWA}', "");
    Expect(0, 70752, '\P{^Script=_-NEWA}', "");
    Error('\p{Sc=_newa/a/}');
    Error('\P{Sc=_newa/a/}');
    Expect(1, 70751, '\p{Sc=:\ANewa\z:}', "");;
    Expect(0, 70752, '\p{Sc=:\ANewa\z:}', "");;
    Expect(1, 70751, '\p{Sc=newa}', "");
    Expect(0, 70751, '\p{^Sc=newa}', "");
    Expect(0, 70751, '\P{Sc=newa}', "");
    Expect(1, 70751, '\P{^Sc=newa}', "");
    Expect(0, 70752, '\p{Sc=newa}', "");
    Expect(1, 70752, '\p{^Sc=newa}', "");
    Expect(1, 70752, '\P{Sc=newa}', "");
    Expect(0, 70752, '\P{^Sc=newa}', "");
    Expect(1, 70751, '\p{Sc=:\Anewa\z:}', "");;
    Expect(0, 70752, '\p{Sc=:\Anewa\z:}', "");;
    Expect(1, 70751, '\p{Sc: __Newa}', "");
    Expect(0, 70751, '\p{^Sc: __Newa}', "");
    Expect(0, 70751, '\P{Sc: __Newa}', "");
    Expect(1, 70751, '\P{^Sc: __Newa}', "");
    Expect(0, 70752, '\p{Sc: __Newa}', "");
    Expect(1, 70752, '\p{^Sc: __Newa}', "");
    Expect(1, 70752, '\P{Sc: __Newa}', "");
    Expect(0, 70752, '\P{^Sc: __Newa}', "");
    Error('\p{Is_Script=	Newa:=}');
    Error('\P{Is_Script=	Newa:=}');
    Expect(1, 70751, '\p{Is_Script=newa}', "");
    Expect(0, 70751, '\p{^Is_Script=newa}', "");
    Expect(0, 70751, '\P{Is_Script=newa}', "");
    Expect(1, 70751, '\P{^Is_Script=newa}', "");
    Expect(0, 70752, '\p{Is_Script=newa}', "");
    Expect(1, 70752, '\p{^Is_Script=newa}', "");
    Expect(1, 70752, '\P{Is_Script=newa}', "");
    Expect(0, 70752, '\P{^Is_Script=newa}', "");
    Expect(1, 70751, '\p{Is_Script:	 	NEWA}', "");
    Expect(0, 70751, '\p{^Is_Script:	 	NEWA}', "");
    Expect(0, 70751, '\P{Is_Script:	 	NEWA}', "");
    Expect(1, 70751, '\P{^Is_Script:	 	NEWA}', "");
    Expect(0, 70752, '\p{Is_Script:	 	NEWA}', "");
    Expect(1, 70752, '\p{^Is_Script:	 	NEWA}', "");
    Expect(1, 70752, '\P{Is_Script:	 	NEWA}', "");
    Expect(0, 70752, '\P{^Is_Script:	 	NEWA}', "");
    Error('\p{Is_Sc=_Newa/a/}');
    Error('\P{Is_Sc=_Newa/a/}');
    Expect(1, 70751, '\p{Is_Sc=newa}', "");
    Expect(0, 70751, '\p{^Is_Sc=newa}', "");
    Expect(0, 70751, '\P{Is_Sc=newa}', "");
    Expect(1, 70751, '\P{^Is_Sc=newa}', "");
    Expect(0, 70752, '\p{Is_Sc=newa}', "");
    Expect(1, 70752, '\p{^Is_Sc=newa}', "");
    Expect(1, 70752, '\P{Is_Sc=newa}', "");
    Expect(0, 70752, '\P{^Is_Sc=newa}', "");
    Expect(1, 70751, '\p{Is_Sc=_NEWA}', "");
    Expect(0, 70751, '\p{^Is_Sc=_NEWA}', "");
    Expect(0, 70751, '\P{Is_Sc=_NEWA}', "");
    Expect(1, 70751, '\P{^Is_Sc=_NEWA}', "");
    Expect(0, 70752, '\p{Is_Sc=_NEWA}', "");
    Expect(1, 70752, '\p{^Is_Sc=_NEWA}', "");
    Expect(1, 70752, '\P{Is_Sc=_NEWA}', "");
    Expect(0, 70752, '\P{^Is_Sc=_NEWA}', "");
    Error('\p{Script=/a/_	Nko}');
    Error('\P{Script=/a/_	Nko}');
    Expect(1, 2047, '\p{Script=:\ANko\z:}', "");;
    Expect(0, 2048, '\p{Script=:\ANko\z:}', "");;
    Expect(1, 2047, '\p{Script=nko}', "");
    Expect(0, 2047, '\p{^Script=nko}', "");
    Expect(0, 2047, '\P{Script=nko}', "");
    Expect(1, 2047, '\P{^Script=nko}', "");
    Expect(0, 2048, '\p{Script=nko}', "");
    Expect(1, 2048, '\p{^Script=nko}', "");
    Expect(1, 2048, '\P{Script=nko}', "");
    Expect(0, 2048, '\P{^Script=nko}', "");
    Expect(1, 2047, '\p{Script=:\Anko\z:}', "");;
    Expect(0, 2048, '\p{Script=:\Anko\z:}', "");;
    Expect(1, 2047, '\p{Script=	-Nko}', "");
    Expect(0, 2047, '\p{^Script=	-Nko}', "");
    Expect(0, 2047, '\P{Script=	-Nko}', "");
    Expect(1, 2047, '\P{^Script=	-Nko}', "");
    Expect(0, 2048, '\p{Script=	-Nko}', "");
    Expect(1, 2048, '\p{^Script=	-Nko}', "");
    Expect(1, 2048, '\P{Script=	-Nko}', "");
    Expect(0, 2048, '\P{^Script=	-Nko}', "");
    Error('\p{Sc=_	Nkoo/a/}');
    Error('\P{Sc=_	Nkoo/a/}');
    Expect(1, 2047, '\p{Sc=:\ANkoo\z:}', "");;
    Expect(0, 2048, '\p{Sc=:\ANkoo\z:}', "");;
    Expect(1, 2047, '\p{Sc=nkoo}', "");
    Expect(0, 2047, '\p{^Sc=nkoo}', "");
    Expect(0, 2047, '\P{Sc=nkoo}', "");
    Expect(1, 2047, '\P{^Sc=nkoo}', "");
    Expect(0, 2048, '\p{Sc=nkoo}', "");
    Expect(1, 2048, '\p{^Sc=nkoo}', "");
    Expect(1, 2048, '\P{Sc=nkoo}', "");
    Expect(0, 2048, '\P{^Sc=nkoo}', "");
    Expect(1, 2047, '\p{Sc=:\Ankoo\z:}', "");;
    Expect(0, 2048, '\p{Sc=:\Ankoo\z:}', "");;
    Expect(1, 2047, '\p{Sc=_ Nkoo}', "");
    Expect(0, 2047, '\p{^Sc=_ Nkoo}', "");
    Expect(0, 2047, '\P{Sc=_ Nkoo}', "");
    Expect(1, 2047, '\P{^Sc=_ Nkoo}', "");
    Expect(0, 2048, '\p{Sc=_ Nkoo}', "");
    Expect(1, 2048, '\p{^Sc=_ Nkoo}', "");
    Expect(1, 2048, '\P{Sc=_ Nkoo}', "");
    Expect(0, 2048, '\P{^Sc=_ Nkoo}', "");
    Error('\p{Is_Script=_:=Nko}');
    Error('\P{Is_Script=_:=Nko}');
    Expect(1, 2047, '\p{Is_Script=nko}', "");
    Expect(0, 2047, '\p{^Is_Script=nko}', "");
    Expect(0, 2047, '\P{Is_Script=nko}', "");
    Expect(1, 2047, '\P{^Is_Script=nko}', "");
    Expect(0, 2048, '\p{Is_Script=nko}', "");
    Expect(1, 2048, '\p{^Is_Script=nko}', "");
    Expect(1, 2048, '\P{Is_Script=nko}', "");
    Expect(0, 2048, '\P{^Is_Script=nko}', "");
    Expect(1, 2047, '\p{Is_Script=-	nko}', "");
    Expect(0, 2047, '\p{^Is_Script=-	nko}', "");
    Expect(0, 2047, '\P{Is_Script=-	nko}', "");
    Expect(1, 2047, '\P{^Is_Script=-	nko}', "");
    Expect(0, 2048, '\p{Is_Script=-	nko}', "");
    Expect(1, 2048, '\p{^Is_Script=-	nko}', "");
    Expect(1, 2048, '\P{Is_Script=-	nko}', "");
    Expect(0, 2048, '\P{^Is_Script=-	nko}', "");
    Error('\p{Is_Sc=	Nkoo:=}');
    Error('\P{Is_Sc=	Nkoo:=}');
    Expect(1, 2047, '\p{Is_Sc=nkoo}', "");
    Expect(0, 2047, '\p{^Is_Sc=nkoo}', "");
    Expect(0, 2047, '\P{Is_Sc=nkoo}', "");
    Expect(1, 2047, '\P{^Is_Sc=nkoo}', "");
    Expect(0, 2048, '\p{Is_Sc=nkoo}', "");
    Expect(1, 2048, '\p{^Is_Sc=nkoo}', "");
    Expect(1, 2048, '\P{Is_Sc=nkoo}', "");
    Expect(0, 2048, '\P{^Is_Sc=nkoo}', "");
    Expect(1, 2047, '\p{Is_Sc=	nkoo}', "");
    Expect(0, 2047, '\p{^Is_Sc=	nkoo}', "");
    Expect(0, 2047, '\P{Is_Sc=	nkoo}', "");
    Expect(1, 2047, '\P{^Is_Sc=	nkoo}', "");
    Expect(0, 2048, '\p{Is_Sc=	nkoo}', "");
    Expect(1, 2048, '\p{^Is_Sc=	nkoo}', "");
    Expect(1, 2048, '\P{Is_Sc=	nkoo}', "");
    Expect(0, 2048, '\P{^Is_Sc=	nkoo}', "");
    Error('\p{Script=	_Nushu:=}');
    Error('\P{Script=	_Nushu:=}');
    Expect(1, 111355, '\p{Script=:\ANushu\z:}', "");;
    Expect(0, 111356, '\p{Script=:\ANushu\z:}', "");;
    Expect(1, 111355, '\p{Script=nushu}', "");
    Expect(0, 111355, '\p{^Script=nushu}', "");
    Expect(0, 111355, '\P{Script=nushu}', "");
    Expect(1, 111355, '\P{^Script=nushu}', "");
    Expect(0, 111356, '\p{Script=nushu}', "");
    Expect(1, 111356, '\p{^Script=nushu}', "");
    Expect(1, 111356, '\P{Script=nushu}', "");
    Expect(0, 111356, '\P{^Script=nushu}', "");
    Expect(1, 111355, '\p{Script=:\Anushu\z:}', "");;
    Expect(0, 111356, '\p{Script=:\Anushu\z:}', "");;
    Expect(1, 111355, '\p{Script:-_Nushu}', "");
    Expect(0, 111355, '\p{^Script:-_Nushu}', "");
    Expect(0, 111355, '\P{Script:-_Nushu}', "");
    Expect(1, 111355, '\P{^Script:-_Nushu}', "");
    Expect(0, 111356, '\p{Script:-_Nushu}', "");
    Expect(1, 111356, '\p{^Script:-_Nushu}', "");
    Expect(1, 111356, '\P{Script:-_Nushu}', "");
    Expect(0, 111356, '\P{^Script:-_Nushu}', "");
    Error('\p{Sc=:=nshu}');
    Error('\P{Sc=:=nshu}');
    Expect(1, 111355, '\p{Sc=:\ANshu\z:}', "");;
    Expect(0, 111356, '\p{Sc=:\ANshu\z:}', "");;
    Expect(1, 111355, '\p{Sc=nshu}', "");
    Expect(0, 111355, '\p{^Sc=nshu}', "");
    Expect(0, 111355, '\P{Sc=nshu}', "");
    Expect(1, 111355, '\P{^Sc=nshu}', "");
    Expect(0, 111356, '\p{Sc=nshu}', "");
    Expect(1, 111356, '\p{^Sc=nshu}', "");
    Expect(1, 111356, '\P{Sc=nshu}', "");
    Expect(0, 111356, '\P{^Sc=nshu}', "");
    Expect(1, 111355, '\p{Sc=:\Anshu\z:}', "");;
    Expect(0, 111356, '\p{Sc=:\Anshu\z:}', "");;
    Expect(1, 111355, '\p{Sc=_ Nshu}', "");
    Expect(0, 111355, '\p{^Sc=_ Nshu}', "");
    Expect(0, 111355, '\P{Sc=_ Nshu}', "");
    Expect(1, 111355, '\P{^Sc=_ Nshu}', "");
    Expect(0, 111356, '\p{Sc=_ Nshu}', "");
    Expect(1, 111356, '\p{^Sc=_ Nshu}', "");
    Expect(1, 111356, '\P{Sc=_ Nshu}', "");
    Expect(0, 111356, '\P{^Sc=_ Nshu}', "");
    Error('\p{Is_Script= 	Nushu:=}');
    Error('\P{Is_Script= 	Nushu:=}');
    Expect(1, 111355, '\p{Is_Script: nushu}', "");
    Expect(0, 111355, '\p{^Is_Script: nushu}', "");
    Expect(0, 111355, '\P{Is_Script: nushu}', "");
    Expect(1, 111355, '\P{^Is_Script: nushu}', "");
    Expect(0, 111356, '\p{Is_Script: nushu}', "");
    Expect(1, 111356, '\p{^Is_Script: nushu}', "");
    Expect(1, 111356, '\P{Is_Script: nushu}', "");
    Expect(0, 111356, '\P{^Is_Script: nushu}', "");
    Expect(1, 111355, '\p{Is_Script=	-Nushu}', "");
    Expect(0, 111355, '\p{^Is_Script=	-Nushu}', "");
    Expect(0, 111355, '\P{Is_Script=	-Nushu}', "");
    Expect(1, 111355, '\P{^Is_Script=	-Nushu}', "");
    Expect(0, 111356, '\p{Is_Script=	-Nushu}', "");
    Expect(1, 111356, '\p{^Is_Script=	-Nushu}', "");
    Expect(1, 111356, '\P{Is_Script=	-Nushu}', "");
    Expect(0, 111356, '\P{^Is_Script=	-Nushu}', "");
    Error('\p{Is_Sc=:=Nshu}');
    Error('\P{Is_Sc=:=Nshu}');
    Expect(1, 111355, '\p{Is_Sc=nshu}', "");
    Expect(0, 111355, '\p{^Is_Sc=nshu}', "");
    Expect(0, 111355, '\P{Is_Sc=nshu}', "");
    Expect(1, 111355, '\P{^Is_Sc=nshu}', "");
    Expect(0, 111356, '\p{Is_Sc=nshu}', "");
    Expect(1, 111356, '\p{^Is_Sc=nshu}', "");
    Expect(1, 111356, '\P{Is_Sc=nshu}', "");
    Expect(0, 111356, '\P{^Is_Sc=nshu}', "");
    Expect(1, 111355, '\p{Is_Sc=_	nshu}', "");
    Expect(0, 111355, '\p{^Is_Sc=_	nshu}', "");
    Expect(0, 111355, '\P{Is_Sc=_	nshu}', "");
    Expect(1, 111355, '\P{^Is_Sc=_	nshu}', "");
    Expect(0, 111356, '\p{Is_Sc=_	nshu}', "");
    Expect(1, 111356, '\p{^Is_Sc=_	nshu}', "");
    Expect(1, 111356, '\P{Is_Sc=_	nshu}', "");
    Expect(0, 111356, '\P{^Is_Sc=_	nshu}', "");
    Error('\p{Script=_ ogham:=}');
    Error('\P{Script=_ ogham:=}');
    Expect(1, 5788, '\p{Script=:\AOgham\z:}', "");;
    Expect(0, 5789, '\p{Script=:\AOgham\z:}', "");;
    Expect(1, 5788, '\p{Script=ogham}', "");
    Expect(0, 5788, '\p{^Script=ogham}', "");
    Expect(0, 5788, '\P{Script=ogham}', "");
    Expect(1, 5788, '\P{^Script=ogham}', "");
    Expect(0, 5789, '\p{Script=ogham}', "");
    Expect(1, 5789, '\p{^Script=ogham}', "");
    Expect(1, 5789, '\P{Script=ogham}', "");
    Expect(0, 5789, '\P{^Script=ogham}', "");
    Expect(1, 5788, '\p{Script=:\Aogham\z:}', "");;
    Expect(0, 5789, '\p{Script=:\Aogham\z:}', "");;
    Expect(1, 5788, '\p{Script=__Ogham}', "");
    Expect(0, 5788, '\p{^Script=__Ogham}', "");
    Expect(0, 5788, '\P{Script=__Ogham}', "");
    Expect(1, 5788, '\P{^Script=__Ogham}', "");
    Expect(0, 5789, '\p{Script=__Ogham}', "");
    Expect(1, 5789, '\p{^Script=__Ogham}', "");
    Expect(1, 5789, '\P{Script=__Ogham}', "");
    Expect(0, 5789, '\P{^Script=__Ogham}', "");
    Error('\p{Sc:_/a/ogam}');
    Error('\P{Sc:_/a/ogam}');
    Expect(1, 5788, '\p{Sc=:\AOgam\z:}', "");;
    Expect(0, 5789, '\p{Sc=:\AOgam\z:}', "");;
    Expect(1, 5788, '\p{Sc=ogam}', "");
    Expect(0, 5788, '\p{^Sc=ogam}', "");
    Expect(0, 5788, '\P{Sc=ogam}', "");
    Expect(1, 5788, '\P{^Sc=ogam}', "");
    Expect(0, 5789, '\p{Sc=ogam}', "");
    Expect(1, 5789, '\p{^Sc=ogam}', "");
    Expect(1, 5789, '\P{Sc=ogam}', "");
    Expect(0, 5789, '\P{^Sc=ogam}', "");
    Expect(1, 5788, '\p{Sc=:\Aogam\z:}', "");;
    Expect(0, 5789, '\p{Sc=:\Aogam\z:}', "");;
    Expect(1, 5788, '\p{Sc=	-Ogam}', "");
    Expect(0, 5788, '\p{^Sc=	-Ogam}', "");
    Expect(0, 5788, '\P{Sc=	-Ogam}', "");
    Expect(1, 5788, '\P{^Sc=	-Ogam}', "");
    Expect(0, 5789, '\p{Sc=	-Ogam}', "");
    Expect(1, 5789, '\p{^Sc=	-Ogam}', "");
    Expect(1, 5789, '\P{Sc=	-Ogam}', "");
    Expect(0, 5789, '\P{^Sc=	-Ogam}', "");
    Error('\p{Is_Script=-	OGHAM/a/}');
    Error('\P{Is_Script=-	OGHAM/a/}');
    Expect(1, 5788, '\p{Is_Script=ogham}', "");
    Expect(0, 5788, '\p{^Is_Script=ogham}', "");
    Expect(0, 5788, '\P{Is_Script=ogham}', "");
    Expect(1, 5788, '\P{^Is_Script=ogham}', "");
    Expect(0, 5789, '\p{Is_Script=ogham}', "");
    Expect(1, 5789, '\p{^Is_Script=ogham}', "");
    Expect(1, 5789, '\P{Is_Script=ogham}', "");
    Expect(0, 5789, '\P{^Is_Script=ogham}', "");
    Expect(1, 5788, '\p{Is_Script= ogham}', "");
    Expect(0, 5788, '\p{^Is_Script= ogham}', "");
    Expect(0, 5788, '\P{Is_Script= ogham}', "");
    Expect(1, 5788, '\P{^Is_Script= ogham}', "");
    Expect(0, 5789, '\p{Is_Script= ogham}', "");
    Expect(1, 5789, '\p{^Is_Script= ogham}', "");
    Expect(1, 5789, '\P{Is_Script= ogham}', "");
    Expect(0, 5789, '\P{^Is_Script= ogham}', "");
    Error('\p{Is_Sc=-_ogam/a/}');
    Error('\P{Is_Sc=-_ogam/a/}');
    Expect(1, 5788, '\p{Is_Sc=ogam}', "");
    Expect(0, 5788, '\p{^Is_Sc=ogam}', "");
    Expect(0, 5788, '\P{Is_Sc=ogam}', "");
    Expect(1, 5788, '\P{^Is_Sc=ogam}', "");
    Expect(0, 5789, '\p{Is_Sc=ogam}', "");
    Expect(1, 5789, '\p{^Is_Sc=ogam}', "");
    Expect(1, 5789, '\P{Is_Sc=ogam}', "");
    Expect(0, 5789, '\P{^Is_Sc=ogam}', "");
    Expect(1, 5788, '\p{Is_Sc=	 OGAM}', "");
    Expect(0, 5788, '\p{^Is_Sc=	 OGAM}', "");
    Expect(0, 5788, '\P{Is_Sc=	 OGAM}', "");
    Expect(1, 5788, '\P{^Is_Sc=	 OGAM}', "");
    Expect(0, 5789, '\p{Is_Sc=	 OGAM}', "");
    Expect(1, 5789, '\p{^Is_Sc=	 OGAM}', "");
    Expect(1, 5789, '\P{Is_Sc=	 OGAM}', "");
    Expect(0, 5789, '\P{^Is_Sc=	 OGAM}', "");
    Error('\p{Script=:=-_Ol_Chiki}');
    Error('\P{Script=:=-_Ol_Chiki}');
    Expect(1, 7295, '\p{Script=:\AOl_Chiki\z:}', "");;
    Expect(0, 7296, '\p{Script=:\AOl_Chiki\z:}', "");;
    Expect(1, 7295, '\p{Script=olchiki}', "");
    Expect(0, 7295, '\p{^Script=olchiki}', "");
    Expect(0, 7295, '\P{Script=olchiki}', "");
    Expect(1, 7295, '\P{^Script=olchiki}', "");
    Expect(0, 7296, '\p{Script=olchiki}', "");
    Expect(1, 7296, '\p{^Script=olchiki}', "");
    Expect(1, 7296, '\P{Script=olchiki}', "");
    Expect(0, 7296, '\P{^Script=olchiki}', "");
    Expect(1, 7295, '\p{Script=:\Aolchiki\z:}', "");;
    Expect(0, 7296, '\p{Script=:\Aolchiki\z:}', "");;
    Expect(1, 7295, '\p{Script=_-OL_chiki}', "");
    Expect(0, 7295, '\p{^Script=_-OL_chiki}', "");
    Expect(0, 7295, '\P{Script=_-OL_chiki}', "");
    Expect(1, 7295, '\P{^Script=_-OL_chiki}', "");
    Expect(0, 7296, '\p{Script=_-OL_chiki}', "");
    Expect(1, 7296, '\p{^Script=_-OL_chiki}', "");
    Expect(1, 7296, '\P{Script=_-OL_chiki}', "");
    Expect(0, 7296, '\P{^Script=_-OL_chiki}', "");
    Error('\p{Sc:   	-olck:=}');
    Error('\P{Sc:   	-olck:=}');
    Expect(1, 7295, '\p{Sc=:\AOlck\z:}', "");;
    Expect(0, 7296, '\p{Sc=:\AOlck\z:}', "");;
    Expect(1, 7295, '\p{Sc=olck}', "");
    Expect(0, 7295, '\p{^Sc=olck}', "");
    Expect(0, 7295, '\P{Sc=olck}', "");
    Expect(1, 7295, '\P{^Sc=olck}', "");
    Expect(0, 7296, '\p{Sc=olck}', "");
    Expect(1, 7296, '\p{^Sc=olck}', "");
    Expect(1, 7296, '\P{Sc=olck}', "");
    Expect(0, 7296, '\P{^Sc=olck}', "");
    Expect(1, 7295, '\p{Sc=:\Aolck\z:}', "");;
    Expect(0, 7296, '\p{Sc=:\Aolck\z:}', "");;
    Expect(1, 7295, '\p{Sc=	_OLCK}', "");
    Expect(0, 7295, '\p{^Sc=	_OLCK}', "");
    Expect(0, 7295, '\P{Sc=	_OLCK}', "");
    Expect(1, 7295, '\P{^Sc=	_OLCK}', "");
    Expect(0, 7296, '\p{Sc=	_OLCK}', "");
    Expect(1, 7296, '\p{^Sc=	_OLCK}', "");
    Expect(1, 7296, '\P{Sc=	_OLCK}', "");
    Expect(0, 7296, '\P{^Sc=	_OLCK}', "");
    Error('\p{Is_Script= ol_Chiki:=}');
    Error('\P{Is_Script= ol_Chiki:=}');
    Expect(1, 7295, '\p{Is_Script=olchiki}', "");
    Expect(0, 7295, '\p{^Is_Script=olchiki}', "");
    Expect(0, 7295, '\P{Is_Script=olchiki}', "");
    Expect(1, 7295, '\P{^Is_Script=olchiki}', "");
    Expect(0, 7296, '\p{Is_Script=olchiki}', "");
    Expect(1, 7296, '\p{^Is_Script=olchiki}', "");
    Expect(1, 7296, '\P{Is_Script=olchiki}', "");
    Expect(0, 7296, '\P{^Is_Script=olchiki}', "");
    Expect(1, 7295, '\p{Is_Script=-	OL_chiki}', "");
    Expect(0, 7295, '\p{^Is_Script=-	OL_chiki}', "");
    Expect(0, 7295, '\P{Is_Script=-	OL_chiki}', "");
    Expect(1, 7295, '\P{^Is_Script=-	OL_chiki}', "");
    Expect(0, 7296, '\p{Is_Script=-	OL_chiki}', "");
    Expect(1, 7296, '\p{^Is_Script=-	OL_chiki}', "");
    Expect(1, 7296, '\P{Is_Script=-	OL_chiki}', "");
    Expect(0, 7296, '\P{^Is_Script=-	OL_chiki}', "");
    Error('\p{Is_Sc= :=Olck}');
    Error('\P{Is_Sc= :=Olck}');
    Expect(1, 7295, '\p{Is_Sc=olck}', "");
    Expect(0, 7295, '\p{^Is_Sc=olck}', "");
    Expect(0, 7295, '\P{Is_Sc=olck}', "");
    Expect(1, 7295, '\P{^Is_Sc=olck}', "");
    Expect(0, 7296, '\p{Is_Sc=olck}', "");
    Expect(1, 7296, '\p{^Is_Sc=olck}', "");
    Expect(1, 7296, '\P{Is_Sc=olck}', "");
    Expect(0, 7296, '\P{^Is_Sc=olck}', "");
    Expect(1, 7295, '\p{Is_Sc=_	Olck}', "");
    Expect(0, 7295, '\p{^Is_Sc=_	Olck}', "");
    Expect(0, 7295, '\P{Is_Sc=_	Olck}', "");
    Expect(1, 7295, '\P{^Is_Sc=_	Olck}', "");
    Expect(0, 7296, '\p{Is_Sc=_	Olck}', "");
    Expect(1, 7296, '\p{^Is_Sc=_	Olck}', "");
    Expect(1, 7296, '\P{Is_Sc=_	Olck}', "");
    Expect(0, 7296, '\P{^Is_Sc=_	Olck}', "");
    Error('\p{Script=:=OLD_TURKIC}');
    Error('\P{Script=:=OLD_TURKIC}');
    Expect(1, 68680, '\p{Script=:\AOld_Turkic\z:}', "");;
    Expect(0, 68681, '\p{Script=:\AOld_Turkic\z:}', "");;
    Expect(1, 68680, '\p{Script=oldturkic}', "");
    Expect(0, 68680, '\p{^Script=oldturkic}', "");
    Expect(0, 68680, '\P{Script=oldturkic}', "");
    Expect(1, 68680, '\P{^Script=oldturkic}', "");
    Expect(0, 68681, '\p{Script=oldturkic}', "");
    Expect(1, 68681, '\p{^Script=oldturkic}', "");
    Expect(1, 68681, '\P{Script=oldturkic}', "");
    Expect(0, 68681, '\P{^Script=oldturkic}', "");
    Expect(1, 68680, '\p{Script=:\Aoldturkic\z:}', "");;
    Expect(0, 68681, '\p{Script=:\Aoldturkic\z:}', "");;
    Expect(1, 68680, '\p{Script=_	Old_Turkic}', "");
    Expect(0, 68680, '\p{^Script=_	Old_Turkic}', "");
    Expect(0, 68680, '\P{Script=_	Old_Turkic}', "");
    Expect(1, 68680, '\P{^Script=_	Old_Turkic}', "");
    Expect(0, 68681, '\p{Script=_	Old_Turkic}', "");
    Expect(1, 68681, '\p{^Script=_	Old_Turkic}', "");
    Expect(1, 68681, '\P{Script=_	Old_Turkic}', "");
    Expect(0, 68681, '\P{^Script=_	Old_Turkic}', "");
    Error('\p{Sc=:=__ORKH}');
    Error('\P{Sc=:=__ORKH}');
    Expect(1, 68680, '\p{Sc=:\AOrkh\z:}', "");;
    Expect(0, 68681, '\p{Sc=:\AOrkh\z:}', "");;
    Expect(1, 68680, '\p{Sc=orkh}', "");
    Expect(0, 68680, '\p{^Sc=orkh}', "");
    Expect(0, 68680, '\P{Sc=orkh}', "");
    Expect(1, 68680, '\P{^Sc=orkh}', "");
    Expect(0, 68681, '\p{Sc=orkh}', "");
    Expect(1, 68681, '\p{^Sc=orkh}', "");
    Expect(1, 68681, '\P{Sc=orkh}', "");
    Expect(0, 68681, '\P{^Sc=orkh}', "");
    Expect(1, 68680, '\p{Sc=:\Aorkh\z:}', "");;
    Expect(0, 68681, '\p{Sc=:\Aorkh\z:}', "");;
    Expect(1, 68680, '\p{Sc=-	orkh}', "");
    Expect(0, 68680, '\p{^Sc=-	orkh}', "");
    Expect(0, 68680, '\P{Sc=-	orkh}', "");
    Expect(1, 68680, '\P{^Sc=-	orkh}', "");
    Expect(0, 68681, '\p{Sc=-	orkh}', "");
    Expect(1, 68681, '\p{^Sc=-	orkh}', "");
    Expect(1, 68681, '\P{Sc=-	orkh}', "");
    Expect(0, 68681, '\P{^Sc=-	orkh}', "");
    Error('\p{Is_Script:	_:=Old_TURKIC}');
    Error('\P{Is_Script:	_:=Old_TURKIC}');
    Expect(1, 68680, '\p{Is_Script=oldturkic}', "");
    Expect(0, 68680, '\p{^Is_Script=oldturkic}', "");
    Expect(0, 68680, '\P{Is_Script=oldturkic}', "");
    Expect(1, 68680, '\P{^Is_Script=oldturkic}', "");
    Expect(0, 68681, '\p{Is_Script=oldturkic}', "");
    Expect(1, 68681, '\p{^Is_Script=oldturkic}', "");
    Expect(1, 68681, '\P{Is_Script=oldturkic}', "");
    Expect(0, 68681, '\P{^Is_Script=oldturkic}', "");
    Expect(1, 68680, '\p{Is_Script=_ Old_TURKIC}', "");
    Expect(0, 68680, '\p{^Is_Script=_ Old_TURKIC}', "");
    Expect(0, 68680, '\P{Is_Script=_ Old_TURKIC}', "");
    Expect(1, 68680, '\P{^Is_Script=_ Old_TURKIC}', "");
    Expect(0, 68681, '\p{Is_Script=_ Old_TURKIC}', "");
    Expect(1, 68681, '\p{^Is_Script=_ Old_TURKIC}', "");
    Expect(1, 68681, '\P{Is_Script=_ Old_TURKIC}', "");
    Expect(0, 68681, '\P{^Is_Script=_ Old_TURKIC}', "");
    Error('\p{Is_Sc= :=Orkh}');
    Error('\P{Is_Sc= :=Orkh}');
    Expect(1, 68680, '\p{Is_Sc=orkh}', "");
    Expect(0, 68680, '\p{^Is_Sc=orkh}', "");
    Expect(0, 68680, '\P{Is_Sc=orkh}', "");
    Expect(1, 68680, '\P{^Is_Sc=orkh}', "");
    Expect(0, 68681, '\p{Is_Sc=orkh}', "");
    Expect(1, 68681, '\p{^Is_Sc=orkh}', "");
    Expect(1, 68681, '\P{Is_Sc=orkh}', "");
    Expect(0, 68681, '\P{^Is_Sc=orkh}', "");
    Expect(1, 68680, '\p{Is_Sc=_orkh}', "");
    Expect(0, 68680, '\p{^Is_Sc=_orkh}', "");
    Expect(0, 68680, '\P{Is_Sc=_orkh}', "");
    Expect(1, 68680, '\P{^Is_Sc=_orkh}', "");
    Expect(0, 68681, '\p{Is_Sc=_orkh}', "");
    Expect(1, 68681, '\p{^Is_Sc=_orkh}', "");
    Expect(1, 68681, '\P{Is_Sc=_orkh}', "");
    Expect(0, 68681, '\P{^Is_Sc=_orkh}', "");
    Error('\p{Script=_-ORIYA:=}');
    Error('\P{Script=_-ORIYA:=}');
    Expect(1, 2935, '\p{Script=:\AOriya\z:}', "");;
    Expect(0, 2936, '\p{Script=:\AOriya\z:}', "");;
    Expect(1, 2935, '\p{Script:	oriya}', "");
    Expect(0, 2935, '\p{^Script:	oriya}', "");
    Expect(0, 2935, '\P{Script:	oriya}', "");
    Expect(1, 2935, '\P{^Script:	oriya}', "");
    Expect(0, 2936, '\p{Script:	oriya}', "");
    Expect(1, 2936, '\p{^Script:	oriya}', "");
    Expect(1, 2936, '\P{Script:	oriya}', "");
    Expect(0, 2936, '\P{^Script:	oriya}', "");
    Expect(1, 2935, '\p{Script=:\Aoriya\z:}', "");;
    Expect(0, 2936, '\p{Script=:\Aoriya\z:}', "");;
    Expect(1, 2935, '\p{Script:		Oriya}', "");
    Expect(0, 2935, '\p{^Script:		Oriya}', "");
    Expect(0, 2935, '\P{Script:		Oriya}', "");
    Expect(1, 2935, '\P{^Script:		Oriya}', "");
    Expect(0, 2936, '\p{Script:		Oriya}', "");
    Expect(1, 2936, '\p{^Script:		Oriya}', "");
    Expect(1, 2936, '\P{Script:		Oriya}', "");
    Expect(0, 2936, '\P{^Script:		Oriya}', "");
    Error('\p{Sc= /a/orya}');
    Error('\P{Sc= /a/orya}');
    Expect(1, 2935, '\p{Sc=:\AOrya\z:}', "");;
    Expect(0, 2936, '\p{Sc=:\AOrya\z:}', "");;
    Expect(1, 2935, '\p{Sc=orya}', "");
    Expect(0, 2935, '\p{^Sc=orya}', "");
    Expect(0, 2935, '\P{Sc=orya}', "");
    Expect(1, 2935, '\P{^Sc=orya}', "");
    Expect(0, 2936, '\p{Sc=orya}', "");
    Expect(1, 2936, '\p{^Sc=orya}', "");
    Expect(1, 2936, '\P{Sc=orya}', "");
    Expect(0, 2936, '\P{^Sc=orya}', "");
    Expect(1, 2935, '\p{Sc=:\Aorya\z:}', "");;
    Expect(0, 2936, '\p{Sc=:\Aorya\z:}', "");;
    Expect(1, 2935, '\p{Sc=	 ORYA}', "");
    Expect(0, 2935, '\p{^Sc=	 ORYA}', "");
    Expect(0, 2935, '\P{Sc=	 ORYA}', "");
    Expect(1, 2935, '\P{^Sc=	 ORYA}', "");
    Expect(0, 2936, '\p{Sc=	 ORYA}', "");
    Expect(1, 2936, '\p{^Sc=	 ORYA}', "");
    Expect(1, 2936, '\P{Sc=	 ORYA}', "");
    Expect(0, 2936, '\P{^Sc=	 ORYA}', "");
    Error('\p{Is_Script=_/a/Oriya}');
    Error('\P{Is_Script=_/a/Oriya}');
    Expect(1, 2935, '\p{Is_Script=oriya}', "");
    Expect(0, 2935, '\p{^Is_Script=oriya}', "");
    Expect(0, 2935, '\P{Is_Script=oriya}', "");
    Expect(1, 2935, '\P{^Is_Script=oriya}', "");
    Expect(0, 2936, '\p{Is_Script=oriya}', "");
    Expect(1, 2936, '\p{^Is_Script=oriya}', "");
    Expect(1, 2936, '\P{Is_Script=oriya}', "");
    Expect(0, 2936, '\P{^Is_Script=oriya}', "");
    Expect(1, 2935, '\p{Is_Script=_ORIYA}', "");
    Expect(0, 2935, '\p{^Is_Script=_ORIYA}', "");
    Expect(0, 2935, '\P{Is_Script=_ORIYA}', "");
    Expect(1, 2935, '\P{^Is_Script=_ORIYA}', "");
    Expect(0, 2936, '\p{Is_Script=_ORIYA}', "");
    Expect(1, 2936, '\p{^Is_Script=_ORIYA}', "");
    Expect(1, 2936, '\P{Is_Script=_ORIYA}', "");
    Expect(0, 2936, '\P{^Is_Script=_ORIYA}', "");
    Error('\p{Is_Sc: _:=ORYA}');
    Error('\P{Is_Sc: _:=ORYA}');
    Expect(1, 2935, '\p{Is_Sc=orya}', "");
    Expect(0, 2935, '\p{^Is_Sc=orya}', "");
    Expect(0, 2935, '\P{Is_Sc=orya}', "");
    Expect(1, 2935, '\P{^Is_Sc=orya}', "");
    Expect(0, 2936, '\p{Is_Sc=orya}', "");
    Expect(1, 2936, '\p{^Is_Sc=orya}', "");
    Expect(1, 2936, '\P{Is_Sc=orya}', "");
    Expect(0, 2936, '\P{^Is_Sc=orya}', "");
    Expect(1, 2935, '\p{Is_Sc=-_orya}', "");
    Expect(0, 2935, '\p{^Is_Sc=-_orya}', "");
    Expect(0, 2935, '\P{Is_Sc=-_orya}', "");
    Expect(1, 2935, '\P{^Is_Sc=-_orya}', "");
    Expect(0, 2936, '\p{Is_Sc=-_orya}', "");
    Expect(1, 2936, '\p{^Is_Sc=-_orya}', "");
    Expect(1, 2936, '\P{Is_Sc=-_orya}', "");
    Expect(0, 2936, '\P{^Is_Sc=-_orya}', "");
    Error('\p{Script=/a/--Osage}');
    Error('\P{Script=/a/--Osage}');
    Expect(1, 66811, '\p{Script=:\AOsage\z:}', "");;
    Expect(0, 66812, '\p{Script=:\AOsage\z:}', "");;
    Expect(1, 66811, '\p{Script=osage}', "");
    Expect(0, 66811, '\p{^Script=osage}', "");
    Expect(0, 66811, '\P{Script=osage}', "");
    Expect(1, 66811, '\P{^Script=osage}', "");
    Expect(0, 66812, '\p{Script=osage}', "");
    Expect(1, 66812, '\p{^Script=osage}', "");
    Expect(1, 66812, '\P{Script=osage}', "");
    Expect(0, 66812, '\P{^Script=osage}', "");
    Expect(1, 66811, '\p{Script=:\Aosage\z:}', "");;
    Expect(0, 66812, '\p{Script=:\Aosage\z:}', "");;
    Expect(1, 66811, '\p{Script=_Osage}', "");
    Expect(0, 66811, '\p{^Script=_Osage}', "");
    Expect(0, 66811, '\P{Script=_Osage}', "");
    Expect(1, 66811, '\P{^Script=_Osage}', "");
    Expect(0, 66812, '\p{Script=_Osage}', "");
    Expect(1, 66812, '\p{^Script=_Osage}', "");
    Expect(1, 66812, '\P{Script=_Osage}', "");
    Expect(0, 66812, '\P{^Script=_Osage}', "");
    Error('\p{Sc: :=	Osge}');
    Error('\P{Sc: :=	Osge}');
    Expect(1, 66811, '\p{Sc=:\AOsge\z:}', "");;
    Expect(0, 66812, '\p{Sc=:\AOsge\z:}', "");;
    Expect(1, 66811, '\p{Sc=osge}', "");
    Expect(0, 66811, '\p{^Sc=osge}', "");
    Expect(0, 66811, '\P{Sc=osge}', "");
    Expect(1, 66811, '\P{^Sc=osge}', "");
    Expect(0, 66812, '\p{Sc=osge}', "");
    Expect(1, 66812, '\p{^Sc=osge}', "");
    Expect(1, 66812, '\P{Sc=osge}', "");
    Expect(0, 66812, '\P{^Sc=osge}', "");
    Expect(1, 66811, '\p{Sc=:\Aosge\z:}', "");;
    Expect(0, 66812, '\p{Sc=:\Aosge\z:}', "");;
    Expect(1, 66811, '\p{Sc=	-osge}', "");
    Expect(0, 66811, '\p{^Sc=	-osge}', "");
    Expect(0, 66811, '\P{Sc=	-osge}', "");
    Expect(1, 66811, '\P{^Sc=	-osge}', "");
    Expect(0, 66812, '\p{Sc=	-osge}', "");
    Expect(1, 66812, '\p{^Sc=	-osge}', "");
    Expect(1, 66812, '\P{Sc=	-osge}', "");
    Expect(0, 66812, '\P{^Sc=	-osge}', "");
    Error('\p{Is_Script=/a/--OSAGE}');
    Error('\P{Is_Script=/a/--OSAGE}');
    Expect(1, 66811, '\p{Is_Script=osage}', "");
    Expect(0, 66811, '\p{^Is_Script=osage}', "");
    Expect(0, 66811, '\P{Is_Script=osage}', "");
    Expect(1, 66811, '\P{^Is_Script=osage}', "");
    Expect(0, 66812, '\p{Is_Script=osage}', "");
    Expect(1, 66812, '\p{^Is_Script=osage}', "");
    Expect(1, 66812, '\P{Is_Script=osage}', "");
    Expect(0, 66812, '\P{^Is_Script=osage}', "");
    Expect(1, 66811, '\p{Is_Script=		Osage}', "");
    Expect(0, 66811, '\p{^Is_Script=		Osage}', "");
    Expect(0, 66811, '\P{Is_Script=		Osage}', "");
    Expect(1, 66811, '\P{^Is_Script=		Osage}', "");
    Expect(0, 66812, '\p{Is_Script=		Osage}', "");
    Expect(1, 66812, '\p{^Is_Script=		Osage}', "");
    Expect(1, 66812, '\P{Is_Script=		Osage}', "");
    Expect(0, 66812, '\P{^Is_Script=		Osage}', "");
    Error('\p{Is_Sc=:=	osge}');
    Error('\P{Is_Sc=:=	osge}');
    Expect(1, 66811, '\p{Is_Sc:osge}', "");
    Expect(0, 66811, '\p{^Is_Sc:osge}', "");
    Expect(0, 66811, '\P{Is_Sc:osge}', "");
    Expect(1, 66811, '\P{^Is_Sc:osge}', "");
    Expect(0, 66812, '\p{Is_Sc:osge}', "");
    Expect(1, 66812, '\p{^Is_Sc:osge}', "");
    Expect(1, 66812, '\P{Is_Sc:osge}', "");
    Expect(0, 66812, '\P{^Is_Sc:osge}', "");
    Error('\p{Script= :=Osmanya}');
    Error('\P{Script= :=Osmanya}');
    Expect(1, 66729, '\p{Script=:\AOsmanya\z:}', "");;
    Expect(0, 66730, '\p{Script=:\AOsmanya\z:}', "");;
    Expect(1, 66729, '\p{Script=osmanya}', "");
    Expect(0, 66729, '\p{^Script=osmanya}', "");
    Expect(0, 66729, '\P{Script=osmanya}', "");
    Expect(1, 66729, '\P{^Script=osmanya}', "");
    Expect(0, 66730, '\p{Script=osmanya}', "");
    Expect(1, 66730, '\p{^Script=osmanya}', "");
    Expect(1, 66730, '\P{Script=osmanya}', "");
    Expect(0, 66730, '\P{^Script=osmanya}', "");
    Expect(1, 66729, '\p{Script=:\Aosmanya\z:}', "");;
    Expect(0, 66730, '\p{Script=:\Aosmanya\z:}', "");;
    Expect(1, 66729, '\p{Script=--Osmanya}', "");
    Expect(0, 66729, '\p{^Script=--Osmanya}', "");
    Expect(0, 66729, '\P{Script=--Osmanya}', "");
    Expect(1, 66729, '\P{^Script=--Osmanya}', "");
    Expect(0, 66730, '\p{Script=--Osmanya}', "");
    Expect(1, 66730, '\p{^Script=--Osmanya}', "");
    Expect(1, 66730, '\P{Script=--Osmanya}', "");
    Expect(0, 66730, '\P{^Script=--Osmanya}', "");
    Error('\p{Sc=	/a/osma}');
    Error('\P{Sc=	/a/osma}');
    Expect(1, 66729, '\p{Sc=:\AOsma\z:}', "");;
    Expect(0, 66730, '\p{Sc=:\AOsma\z:}', "");;
    Expect(1, 66729, '\p{Sc=osma}', "");
    Expect(0, 66729, '\p{^Sc=osma}', "");
    Expect(0, 66729, '\P{Sc=osma}', "");
    Expect(1, 66729, '\P{^Sc=osma}', "");
    Expect(0, 66730, '\p{Sc=osma}', "");
    Expect(1, 66730, '\p{^Sc=osma}', "");
    Expect(1, 66730, '\P{Sc=osma}', "");
    Expect(0, 66730, '\P{^Sc=osma}', "");
    Expect(1, 66729, '\p{Sc=:\Aosma\z:}', "");;
    Expect(0, 66730, '\p{Sc=:\Aosma\z:}', "");;
    Expect(1, 66729, '\p{Sc=-_OSMA}', "");
    Expect(0, 66729, '\p{^Sc=-_OSMA}', "");
    Expect(0, 66729, '\P{Sc=-_OSMA}', "");
    Expect(1, 66729, '\P{^Sc=-_OSMA}', "");
    Expect(0, 66730, '\p{Sc=-_OSMA}', "");
    Expect(1, 66730, '\p{^Sc=-_OSMA}', "");
    Expect(1, 66730, '\P{Sc=-_OSMA}', "");
    Expect(0, 66730, '\P{^Sc=-_OSMA}', "");
    Error('\p{Is_Script=:=_	OSMANYA}');
    Error('\P{Is_Script=:=_	OSMANYA}');
    Expect(1, 66729, '\p{Is_Script=osmanya}', "");
    Expect(0, 66729, '\p{^Is_Script=osmanya}', "");
    Expect(0, 66729, '\P{Is_Script=osmanya}', "");
    Expect(1, 66729, '\P{^Is_Script=osmanya}', "");
    Expect(0, 66730, '\p{Is_Script=osmanya}', "");
    Expect(1, 66730, '\p{^Is_Script=osmanya}', "");
    Expect(1, 66730, '\P{Is_Script=osmanya}', "");
    Expect(0, 66730, '\P{^Is_Script=osmanya}', "");
    Expect(1, 66729, '\p{Is_Script= 	osmanya}', "");
    Expect(0, 66729, '\p{^Is_Script= 	osmanya}', "");
    Expect(0, 66729, '\P{Is_Script= 	osmanya}', "");
    Expect(1, 66729, '\P{^Is_Script= 	osmanya}', "");
    Expect(0, 66730, '\p{Is_Script= 	osmanya}', "");
    Expect(1, 66730, '\p{^Is_Script= 	osmanya}', "");
    Expect(1, 66730, '\P{Is_Script= 	osmanya}', "");
    Expect(0, 66730, '\P{^Is_Script= 	osmanya}', "");
    Error('\p{Is_Sc= 	osma:=}');
    Error('\P{Is_Sc= 	osma:=}');
    Expect(1, 66729, '\p{Is_Sc=osma}', "");
    Expect(0, 66729, '\p{^Is_Sc=osma}', "");
    Expect(0, 66729, '\P{Is_Sc=osma}', "");
    Expect(1, 66729, '\P{^Is_Sc=osma}', "");
    Expect(0, 66730, '\p{Is_Sc=osma}', "");
    Expect(1, 66730, '\p{^Is_Sc=osma}', "");
    Expect(1, 66730, '\P{Is_Sc=osma}', "");
    Expect(0, 66730, '\P{^Is_Sc=osma}', "");
    Expect(1, 66729, '\p{Is_Sc=-Osma}', "");
    Expect(0, 66729, '\p{^Is_Sc=-Osma}', "");
    Expect(0, 66729, '\P{Is_Sc=-Osma}', "");
    Expect(1, 66729, '\P{^Is_Sc=-Osma}', "");
    Expect(0, 66730, '\p{Is_Sc=-Osma}', "");
    Expect(1, 66730, '\p{^Is_Sc=-Osma}', "");
    Expect(1, 66730, '\P{Is_Sc=-Osma}', "");
    Expect(0, 66730, '\P{^Is_Sc=-Osma}', "");
    Error('\p{Script=:=	-palmyrene}');
    Error('\P{Script=:=	-palmyrene}');
    Expect(1, 67711, '\p{Script=:\APalmyrene\z:}', "");;
    Expect(0, 67712, '\p{Script=:\APalmyrene\z:}', "");;
    Expect(1, 67711, '\p{Script=palmyrene}', "");
    Expect(0, 67711, '\p{^Script=palmyrene}', "");
    Expect(0, 67711, '\P{Script=palmyrene}', "");
    Expect(1, 67711, '\P{^Script=palmyrene}', "");
    Expect(0, 67712, '\p{Script=palmyrene}', "");
    Expect(1, 67712, '\p{^Script=palmyrene}', "");
    Expect(1, 67712, '\P{Script=palmyrene}', "");
    Expect(0, 67712, '\P{^Script=palmyrene}', "");
    Expect(1, 67711, '\p{Script=:\Apalmyrene\z:}', "");;
    Expect(0, 67712, '\p{Script=:\Apalmyrene\z:}', "");;
    Expect(1, 67711, '\p{Script= _PALMYRENE}', "");
    Expect(0, 67711, '\p{^Script= _PALMYRENE}', "");
    Expect(0, 67711, '\P{Script= _PALMYRENE}', "");
    Expect(1, 67711, '\P{^Script= _PALMYRENE}', "");
    Expect(0, 67712, '\p{Script= _PALMYRENE}', "");
    Expect(1, 67712, '\p{^Script= _PALMYRENE}', "");
    Expect(1, 67712, '\P{Script= _PALMYRENE}', "");
    Expect(0, 67712, '\P{^Script= _PALMYRENE}', "");
    Error('\p{Sc=:=Palm}');
    Error('\P{Sc=:=Palm}');
    Expect(1, 67711, '\p{Sc=:\APalm\z:}', "");;
    Expect(0, 67712, '\p{Sc=:\APalm\z:}', "");;
    Expect(1, 67711, '\p{Sc:   palm}', "");
    Expect(0, 67711, '\p{^Sc:   palm}', "");
    Expect(0, 67711, '\P{Sc:   palm}', "");
    Expect(1, 67711, '\P{^Sc:   palm}', "");
    Expect(0, 67712, '\p{Sc:   palm}', "");
    Expect(1, 67712, '\p{^Sc:   palm}', "");
    Expect(1, 67712, '\P{Sc:   palm}', "");
    Expect(0, 67712, '\P{^Sc:   palm}', "");
    Expect(1, 67711, '\p{Sc=:\Apalm\z:}', "");;
    Expect(0, 67712, '\p{Sc=:\Apalm\z:}', "");;
    Expect(1, 67711, '\p{Sc=	 palm}', "");
    Expect(0, 67711, '\p{^Sc=	 palm}', "");
    Expect(0, 67711, '\P{Sc=	 palm}', "");
    Expect(1, 67711, '\P{^Sc=	 palm}', "");
    Expect(0, 67712, '\p{Sc=	 palm}', "");
    Expect(1, 67712, '\p{^Sc=	 palm}', "");
    Expect(1, 67712, '\P{Sc=	 palm}', "");
    Expect(0, 67712, '\P{^Sc=	 palm}', "");
    Error('\p{Is_Script= :=Palmyrene}');
    Error('\P{Is_Script= :=Palmyrene}');
    Expect(1, 67711, '\p{Is_Script:   palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Script:   palmyrene}', "");
    Expect(0, 67711, '\P{Is_Script:   palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Script:   palmyrene}', "");
    Expect(0, 67712, '\p{Is_Script:   palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Script:   palmyrene}', "");
    Expect(1, 67712, '\P{Is_Script:   palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Script:   palmyrene}', "");
    Expect(1, 67711, '\p{Is_Script=-	Palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Script=-	Palmyrene}', "");
    Expect(0, 67711, '\P{Is_Script=-	Palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Script=-	Palmyrene}', "");
    Expect(0, 67712, '\p{Is_Script=-	Palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Script=-	Palmyrene}', "");
    Expect(1, 67712, '\P{Is_Script=-	Palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Script=-	Palmyrene}', "");
    Error('\p{Is_Sc=_ Palm:=}');
    Error('\P{Is_Sc=_ Palm:=}');
    Expect(1, 67711, '\p{Is_Sc=palm}', "");
    Expect(0, 67711, '\p{^Is_Sc=palm}', "");
    Expect(0, 67711, '\P{Is_Sc=palm}', "");
    Expect(1, 67711, '\P{^Is_Sc=palm}', "");
    Expect(0, 67712, '\p{Is_Sc=palm}', "");
    Expect(1, 67712, '\p{^Is_Sc=palm}', "");
    Expect(1, 67712, '\P{Is_Sc=palm}', "");
    Expect(0, 67712, '\P{^Is_Sc=palm}', "");
    Expect(1, 67711, '\p{Is_Sc= -palm}', "");
    Expect(0, 67711, '\p{^Is_Sc= -palm}', "");
    Expect(0, 67711, '\P{Is_Sc= -palm}', "");
    Expect(1, 67711, '\P{^Is_Sc= -palm}', "");
    Expect(0, 67712, '\p{Is_Sc= -palm}', "");
    Expect(1, 67712, '\p{^Is_Sc= -palm}', "");
    Expect(1, 67712, '\P{Is_Sc= -palm}', "");
    Expect(0, 67712, '\P{^Is_Sc= -palm}', "");
    Error('\p{Script=/a/-	Pau_CIN_hau}');
    Error('\P{Script=/a/-	Pau_CIN_hau}');
    Expect(1, 72440, '\p{Script=:\APau_Cin_Hau\z:}', "");;
    Expect(0, 72441, '\p{Script=:\APau_Cin_Hau\z:}', "");;
    Expect(1, 72440, '\p{Script:   paucinhau}', "");
    Expect(0, 72440, '\p{^Script:   paucinhau}', "");
    Expect(0, 72440, '\P{Script:   paucinhau}', "");
    Expect(1, 72440, '\P{^Script:   paucinhau}', "");
    Expect(0, 72441, '\p{Script:   paucinhau}', "");
    Expect(1, 72441, '\p{^Script:   paucinhau}', "");
    Expect(1, 72441, '\P{Script:   paucinhau}', "");
    Expect(0, 72441, '\P{^Script:   paucinhau}', "");
    Expect(1, 72440, '\p{Script=:\Apaucinhau\z:}', "");;
    Expect(0, 72441, '\p{Script=:\Apaucinhau\z:}', "");;
    Expect(1, 72440, '\p{Script=_	Pau_cin_Hau}', "");
    Expect(0, 72440, '\p{^Script=_	Pau_cin_Hau}', "");
    Expect(0, 72440, '\P{Script=_	Pau_cin_Hau}', "");
    Expect(1, 72440, '\P{^Script=_	Pau_cin_Hau}', "");
    Expect(0, 72441, '\p{Script=_	Pau_cin_Hau}', "");
    Expect(1, 72441, '\p{^Script=_	Pau_cin_Hau}', "");
    Expect(1, 72441, '\P{Script=_	Pau_cin_Hau}', "");
    Expect(0, 72441, '\P{^Script=_	Pau_cin_Hau}', "");
    Error('\p{Sc=/a/ 	Pauc}');
    Error('\P{Sc=/a/ 	Pauc}');
    Expect(1, 72440, '\p{Sc=:\APauc\z:}', "");;
    Expect(0, 72441, '\p{Sc=:\APauc\z:}', "");;
    Expect(1, 72440, '\p{Sc=pauc}', "");
    Expect(0, 72440, '\p{^Sc=pauc}', "");
    Expect(0, 72440, '\P{Sc=pauc}', "");
    Expect(1, 72440, '\P{^Sc=pauc}', "");
    Expect(0, 72441, '\p{Sc=pauc}', "");
    Expect(1, 72441, '\p{^Sc=pauc}', "");
    Expect(1, 72441, '\P{Sc=pauc}', "");
    Expect(0, 72441, '\P{^Sc=pauc}', "");
    Expect(1, 72440, '\p{Sc=:\Apauc\z:}', "");;
    Expect(0, 72441, '\p{Sc=:\Apauc\z:}', "");;
    Expect(1, 72440, '\p{Sc=_PAUC}', "");
    Expect(0, 72440, '\p{^Sc=_PAUC}', "");
    Expect(0, 72440, '\P{Sc=_PAUC}', "");
    Expect(1, 72440, '\P{^Sc=_PAUC}', "");
    Expect(0, 72441, '\p{Sc=_PAUC}', "");
    Expect(1, 72441, '\p{^Sc=_PAUC}', "");
    Expect(1, 72441, '\P{Sc=_PAUC}', "");
    Expect(0, 72441, '\P{^Sc=_PAUC}', "");
    Error('\p{Is_Script=:=-pau_Cin_hau}');
    Error('\P{Is_Script=:=-pau_Cin_hau}');
    Expect(1, 72440, '\p{Is_Script:   paucinhau}', "");
    Expect(0, 72440, '\p{^Is_Script:   paucinhau}', "");
    Expect(0, 72440, '\P{Is_Script:   paucinhau}', "");
    Expect(1, 72440, '\P{^Is_Script:   paucinhau}', "");
    Expect(0, 72441, '\p{Is_Script:   paucinhau}', "");
    Expect(1, 72441, '\p{^Is_Script:   paucinhau}', "");
    Expect(1, 72441, '\P{Is_Script:   paucinhau}', "");
    Expect(0, 72441, '\P{^Is_Script:   paucinhau}', "");
    Expect(1, 72440, '\p{Is_Script:_Pau_Cin_hau}', "");
    Expect(0, 72440, '\p{^Is_Script:_Pau_Cin_hau}', "");
    Expect(0, 72440, '\P{Is_Script:_Pau_Cin_hau}', "");
    Expect(1, 72440, '\P{^Is_Script:_Pau_Cin_hau}', "");
    Expect(0, 72441, '\p{Is_Script:_Pau_Cin_hau}', "");
    Expect(1, 72441, '\p{^Is_Script:_Pau_Cin_hau}', "");
    Expect(1, 72441, '\P{Is_Script:_Pau_Cin_hau}', "");
    Expect(0, 72441, '\P{^Is_Script:_Pau_Cin_hau}', "");
    Error('\p{Is_Sc=	-Pauc/a/}');
    Error('\P{Is_Sc=	-Pauc/a/}');
    Expect(1, 72440, '\p{Is_Sc=pauc}', "");
    Expect(0, 72440, '\p{^Is_Sc=pauc}', "");
    Expect(0, 72440, '\P{Is_Sc=pauc}', "");
    Expect(1, 72440, '\P{^Is_Sc=pauc}', "");
    Expect(0, 72441, '\p{Is_Sc=pauc}', "");
    Expect(1, 72441, '\p{^Is_Sc=pauc}', "");
    Expect(1, 72441, '\P{Is_Sc=pauc}', "");
    Expect(0, 72441, '\P{^Is_Sc=pauc}', "");
    Expect(1, 72440, '\p{Is_Sc=-Pauc}', "");
    Expect(0, 72440, '\p{^Is_Sc=-Pauc}', "");
    Expect(0, 72440, '\P{Is_Sc=-Pauc}', "");
    Expect(1, 72440, '\P{^Is_Sc=-Pauc}', "");
    Expect(0, 72441, '\p{Is_Sc=-Pauc}', "");
    Expect(1, 72441, '\p{^Is_Sc=-Pauc}', "");
    Expect(1, 72441, '\P{Is_Sc=-Pauc}', "");
    Expect(0, 72441, '\P{^Is_Sc=-Pauc}', "");
    Error('\p{Script=:=_Old_permic}');
    Error('\P{Script=:=_Old_permic}');
    Expect(1, 66426, '\p{Script=:\AOld_Permic\z:}', "");;
    Expect(0, 66427, '\p{Script=:\AOld_Permic\z:}', "");;
    Expect(1, 66426, '\p{Script=oldpermic}', "");
    Expect(0, 66426, '\p{^Script=oldpermic}', "");
    Expect(0, 66426, '\P{Script=oldpermic}', "");
    Expect(1, 66426, '\P{^Script=oldpermic}', "");
    Expect(0, 66427, '\p{Script=oldpermic}', "");
    Expect(1, 66427, '\p{^Script=oldpermic}', "");
    Expect(1, 66427, '\P{Script=oldpermic}', "");
    Expect(0, 66427, '\P{^Script=oldpermic}', "");
    Expect(1, 66426, '\p{Script=:\Aoldpermic\z:}', "");;
    Expect(0, 66427, '\p{Script=:\Aoldpermic\z:}', "");;
    Expect(1, 66426, '\p{Script=-Old_permic}', "");
    Expect(0, 66426, '\p{^Script=-Old_permic}', "");
    Expect(0, 66426, '\P{Script=-Old_permic}', "");
    Expect(1, 66426, '\P{^Script=-Old_permic}', "");
    Expect(0, 66427, '\p{Script=-Old_permic}', "");
    Expect(1, 66427, '\p{^Script=-Old_permic}', "");
    Expect(1, 66427, '\P{Script=-Old_permic}', "");
    Expect(0, 66427, '\P{^Script=-Old_permic}', "");
    Error('\p{Sc=	/a/Perm}');
    Error('\P{Sc=	/a/Perm}');
    Expect(1, 66426, '\p{Sc=:\APerm\z:}', "");;
    Expect(0, 66427, '\p{Sc=:\APerm\z:}', "");;
    Expect(1, 66426, '\p{Sc:	perm}', "");
    Expect(0, 66426, '\p{^Sc:	perm}', "");
    Expect(0, 66426, '\P{Sc:	perm}', "");
    Expect(1, 66426, '\P{^Sc:	perm}', "");
    Expect(0, 66427, '\p{Sc:	perm}', "");
    Expect(1, 66427, '\p{^Sc:	perm}', "");
    Expect(1, 66427, '\P{Sc:	perm}', "");
    Expect(0, 66427, '\P{^Sc:	perm}', "");
    Expect(1, 66426, '\p{Sc=:\Aperm\z:}', "");;
    Expect(0, 66427, '\p{Sc=:\Aperm\z:}', "");;
    Expect(1, 66426, '\p{Sc=  PERM}', "");
    Expect(0, 66426, '\p{^Sc=  PERM}', "");
    Expect(0, 66426, '\P{Sc=  PERM}', "");
    Expect(1, 66426, '\P{^Sc=  PERM}', "");
    Expect(0, 66427, '\p{Sc=  PERM}', "");
    Expect(1, 66427, '\p{^Sc=  PERM}', "");
    Expect(1, 66427, '\P{Sc=  PERM}', "");
    Expect(0, 66427, '\P{^Sc=  PERM}', "");
    Error('\p{Is_Script=/a/- OLD_permic}');
    Error('\P{Is_Script=/a/- OLD_permic}');
    Expect(1, 66426, '\p{Is_Script=oldpermic}', "");
    Expect(0, 66426, '\p{^Is_Script=oldpermic}', "");
    Expect(0, 66426, '\P{Is_Script=oldpermic}', "");
    Expect(1, 66426, '\P{^Is_Script=oldpermic}', "");
    Expect(0, 66427, '\p{Is_Script=oldpermic}', "");
    Expect(1, 66427, '\p{^Is_Script=oldpermic}', "");
    Expect(1, 66427, '\P{Is_Script=oldpermic}', "");
    Expect(0, 66427, '\P{^Is_Script=oldpermic}', "");
    Expect(1, 66426, '\p{Is_Script=--old_Permic}', "");
    Expect(0, 66426, '\p{^Is_Script=--old_Permic}', "");
    Expect(0, 66426, '\P{Is_Script=--old_Permic}', "");
    Expect(1, 66426, '\P{^Is_Script=--old_Permic}', "");
    Expect(0, 66427, '\p{Is_Script=--old_Permic}', "");
    Expect(1, 66427, '\p{^Is_Script=--old_Permic}', "");
    Expect(1, 66427, '\P{Is_Script=--old_Permic}', "");
    Expect(0, 66427, '\P{^Is_Script=--old_Permic}', "");
    Error('\p{Is_Sc: 	:=Perm}');
    Error('\P{Is_Sc: 	:=Perm}');
    Expect(1, 66426, '\p{Is_Sc=perm}', "");
    Expect(0, 66426, '\p{^Is_Sc=perm}', "");
    Expect(0, 66426, '\P{Is_Sc=perm}', "");
    Expect(1, 66426, '\P{^Is_Sc=perm}', "");
    Expect(0, 66427, '\p{Is_Sc=perm}', "");
    Expect(1, 66427, '\p{^Is_Sc=perm}', "");
    Expect(1, 66427, '\P{Is_Sc=perm}', "");
    Expect(0, 66427, '\P{^Is_Sc=perm}', "");
    Expect(1, 66426, '\p{Is_Sc=_-Perm}', "");
    Expect(0, 66426, '\p{^Is_Sc=_-Perm}', "");
    Expect(0, 66426, '\P{Is_Sc=_-Perm}', "");
    Expect(1, 66426, '\P{^Is_Sc=_-Perm}', "");
    Expect(0, 66427, '\p{Is_Sc=_-Perm}', "");
    Expect(1, 66427, '\p{^Is_Sc=_-Perm}', "");
    Expect(1, 66427, '\P{Is_Sc=_-Perm}', "");
    Expect(0, 66427, '\P{^Is_Sc=_-Perm}', "");
    Error('\p{Script= 	PHAGS_pa/a/}');
    Error('\P{Script= 	PHAGS_pa/a/}');
    Expect(1, 43127, '\p{Script=:\APhags_Pa\z:}', "");;
    Expect(0, 43128, '\p{Script=:\APhags_Pa\z:}', "");;
    Expect(1, 43127, '\p{Script=phagspa}', "");
    Expect(0, 43127, '\p{^Script=phagspa}', "");
    Expect(0, 43127, '\P{Script=phagspa}', "");
    Expect(1, 43127, '\P{^Script=phagspa}', "");
    Expect(0, 43128, '\p{Script=phagspa}', "");
    Expect(1, 43128, '\p{^Script=phagspa}', "");
    Expect(1, 43128, '\P{Script=phagspa}', "");
    Expect(0, 43128, '\P{^Script=phagspa}', "");
    Expect(1, 43127, '\p{Script=:\Aphagspa\z:}', "");;
    Expect(0, 43128, '\p{Script=:\Aphagspa\z:}', "");;
    Expect(1, 43127, '\p{Script=-_Phags_Pa}', "");
    Expect(0, 43127, '\p{^Script=-_Phags_Pa}', "");
    Expect(0, 43127, '\P{Script=-_Phags_Pa}', "");
    Expect(1, 43127, '\P{^Script=-_Phags_Pa}', "");
    Expect(0, 43128, '\p{Script=-_Phags_Pa}', "");
    Expect(1, 43128, '\p{^Script=-_Phags_Pa}', "");
    Expect(1, 43128, '\P{Script=-_Phags_Pa}', "");
    Expect(0, 43128, '\P{^Script=-_Phags_Pa}', "");
    Error('\p{Sc=/a/_Phag}');
    Error('\P{Sc=/a/_Phag}');
    Expect(1, 43127, '\p{Sc=:\APhag\z:}', "");;
    Expect(0, 43128, '\p{Sc=:\APhag\z:}', "");;
    Expect(1, 43127, '\p{Sc=phag}', "");
    Expect(0, 43127, '\p{^Sc=phag}', "");
    Expect(0, 43127, '\P{Sc=phag}', "");
    Expect(1, 43127, '\P{^Sc=phag}', "");
    Expect(0, 43128, '\p{Sc=phag}', "");
    Expect(1, 43128, '\p{^Sc=phag}', "");
    Expect(1, 43128, '\P{Sc=phag}', "");
    Expect(0, 43128, '\P{^Sc=phag}', "");
    Expect(1, 43127, '\p{Sc=:\Aphag\z:}', "");;
    Expect(0, 43128, '\p{Sc=:\Aphag\z:}', "");;
    Expect(1, 43127, '\p{Sc: -_PHAG}', "");
    Expect(0, 43127, '\p{^Sc: -_PHAG}', "");
    Expect(0, 43127, '\P{Sc: -_PHAG}', "");
    Expect(1, 43127, '\P{^Sc: -_PHAG}', "");
    Expect(0, 43128, '\p{Sc: -_PHAG}', "");
    Expect(1, 43128, '\p{^Sc: -_PHAG}', "");
    Expect(1, 43128, '\P{Sc: -_PHAG}', "");
    Expect(0, 43128, '\P{^Sc: -_PHAG}', "");
    Error('\p{Is_Script=- PHAGS_Pa:=}');
    Error('\P{Is_Script=- PHAGS_Pa:=}');
    Expect(1, 43127, '\p{Is_Script=phagspa}', "");
    Expect(0, 43127, '\p{^Is_Script=phagspa}', "");
    Expect(0, 43127, '\P{Is_Script=phagspa}', "");
    Expect(1, 43127, '\P{^Is_Script=phagspa}', "");
    Expect(0, 43128, '\p{Is_Script=phagspa}', "");
    Expect(1, 43128, '\p{^Is_Script=phagspa}', "");
    Expect(1, 43128, '\P{Is_Script=phagspa}', "");
    Expect(0, 43128, '\P{^Is_Script=phagspa}', "");
    Expect(1, 43127, '\p{Is_Script=	-phags_Pa}', "");
    Expect(0, 43127, '\p{^Is_Script=	-phags_Pa}', "");
    Expect(0, 43127, '\P{Is_Script=	-phags_Pa}', "");
    Expect(1, 43127, '\P{^Is_Script=	-phags_Pa}', "");
    Expect(0, 43128, '\p{Is_Script=	-phags_Pa}', "");
    Expect(1, 43128, '\p{^Is_Script=	-phags_Pa}', "");
    Expect(1, 43128, '\P{Is_Script=	-phags_Pa}', "");
    Expect(0, 43128, '\P{^Is_Script=	-phags_Pa}', "");
    Error('\p{Is_Sc=__phag/a/}');
    Error('\P{Is_Sc=__phag/a/}');
    Expect(1, 43127, '\p{Is_Sc:   phag}', "");
    Expect(0, 43127, '\p{^Is_Sc:   phag}', "");
    Expect(0, 43127, '\P{Is_Sc:   phag}', "");
    Expect(1, 43127, '\P{^Is_Sc:   phag}', "");
    Expect(0, 43128, '\p{Is_Sc:   phag}', "");
    Expect(1, 43128, '\p{^Is_Sc:   phag}', "");
    Expect(1, 43128, '\P{Is_Sc:   phag}', "");
    Expect(0, 43128, '\P{^Is_Sc:   phag}', "");
    Expect(1, 43127, '\p{Is_Sc=__phag}', "");
    Expect(0, 43127, '\p{^Is_Sc=__phag}', "");
    Expect(0, 43127, '\P{Is_Sc=__phag}', "");
    Expect(1, 43127, '\P{^Is_Sc=__phag}', "");
    Expect(0, 43128, '\p{Is_Sc=__phag}', "");
    Expect(1, 43128, '\p{^Is_Sc=__phag}', "");
    Expect(1, 43128, '\P{Is_Sc=__phag}', "");
    Expect(0, 43128, '\P{^Is_Sc=__phag}', "");
    Error('\p{Script=:=-	Inscriptional_Pahlavi}');
    Error('\P{Script=:=-	Inscriptional_Pahlavi}');
    Expect(1, 68479, '\p{Script=:\AInscriptional_Pahlavi\z:}', "");;
    Expect(0, 68480, '\p{Script=:\AInscriptional_Pahlavi\z:}', "");;
    Expect(1, 68479, '\p{Script=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Script=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Script=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Script=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Script=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Script=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Script=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Script=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Script=:\Ainscriptionalpahlavi\z:}', "");;
    Expect(0, 68480, '\p{Script=:\Ainscriptionalpahlavi\z:}', "");;
    Expect(1, 68479, '\p{Script=-inscriptional_PAHLAVI}', "");
    Expect(0, 68479, '\p{^Script=-inscriptional_PAHLAVI}', "");
    Expect(0, 68479, '\P{Script=-inscriptional_PAHLAVI}', "");
    Expect(1, 68479, '\P{^Script=-inscriptional_PAHLAVI}', "");
    Expect(0, 68480, '\p{Script=-inscriptional_PAHLAVI}', "");
    Expect(1, 68480, '\p{^Script=-inscriptional_PAHLAVI}', "");
    Expect(1, 68480, '\P{Script=-inscriptional_PAHLAVI}', "");
    Expect(0, 68480, '\P{^Script=-inscriptional_PAHLAVI}', "");
    Error('\p{Sc= :=PHLI}');
    Error('\P{Sc= :=PHLI}');
    Expect(1, 68479, '\p{Sc=:\APhli\z:}', "");;
    Expect(0, 68480, '\p{Sc=:\APhli\z:}', "");;
    Expect(1, 68479, '\p{Sc:phli}', "");
    Expect(0, 68479, '\p{^Sc:phli}', "");
    Expect(0, 68479, '\P{Sc:phli}', "");
    Expect(1, 68479, '\P{^Sc:phli}', "");
    Expect(0, 68480, '\p{Sc:phli}', "");
    Expect(1, 68480, '\p{^Sc:phli}', "");
    Expect(1, 68480, '\P{Sc:phli}', "");
    Expect(0, 68480, '\P{^Sc:phli}', "");
    Expect(1, 68479, '\p{Sc=:\Aphli\z:}', "");;
    Expect(0, 68480, '\p{Sc=:\Aphli\z:}', "");;
    Expect(1, 68479, '\p{Sc:	 	Phli}', "");
    Expect(0, 68479, '\p{^Sc:	 	Phli}', "");
    Expect(0, 68479, '\P{Sc:	 	Phli}', "");
    Expect(1, 68479, '\P{^Sc:	 	Phli}', "");
    Expect(0, 68480, '\p{Sc:	 	Phli}', "");
    Expect(1, 68480, '\p{^Sc:	 	Phli}', "");
    Expect(1, 68480, '\P{Sc:	 	Phli}', "");
    Expect(0, 68480, '\P{^Sc:	 	Phli}', "");
    Error('\p{Is_Script=-	Inscriptional_PAHLAVI:=}');
    Error('\P{Is_Script=-	Inscriptional_PAHLAVI:=}');
    Expect(1, 68479, '\p{Is_Script=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Is_Script=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Is_Script=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Is_Script=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Is_Script=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Is_Script=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Is_Script=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Is_Script=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Is_Script=_	INSCRIPTIONAL_Pahlavi}', "");
    Expect(0, 68479, '\p{^Is_Script=_	INSCRIPTIONAL_Pahlavi}', "");
    Expect(0, 68479, '\P{Is_Script=_	INSCRIPTIONAL_Pahlavi}', "");
    Expect(1, 68479, '\P{^Is_Script=_	INSCRIPTIONAL_Pahlavi}', "");
    Expect(0, 68480, '\p{Is_Script=_	INSCRIPTIONAL_Pahlavi}', "");
    Expect(1, 68480, '\p{^Is_Script=_	INSCRIPTIONAL_Pahlavi}', "");
    Expect(1, 68480, '\P{Is_Script=_	INSCRIPTIONAL_Pahlavi}', "");
    Expect(0, 68480, '\P{^Is_Script=_	INSCRIPTIONAL_Pahlavi}', "");
    Error('\p{Is_Sc=_	Phli:=}');
    Error('\P{Is_Sc=_	Phli:=}');
    Expect(1, 68479, '\p{Is_Sc: phli}', "");
    Expect(0, 68479, '\p{^Is_Sc: phli}', "");
    Expect(0, 68479, '\P{Is_Sc: phli}', "");
    Expect(1, 68479, '\P{^Is_Sc: phli}', "");
    Expect(0, 68480, '\p{Is_Sc: phli}', "");
    Expect(1, 68480, '\p{^Is_Sc: phli}', "");
    Expect(1, 68480, '\P{Is_Sc: phli}', "");
    Expect(0, 68480, '\P{^Is_Sc: phli}', "");
    Expect(1, 68479, '\p{Is_Sc=-	phli}', "");
    Expect(0, 68479, '\p{^Is_Sc=-	phli}', "");
    Expect(0, 68479, '\P{Is_Sc=-	phli}', "");
    Expect(1, 68479, '\P{^Is_Sc=-	phli}', "");
    Expect(0, 68480, '\p{Is_Sc=-	phli}', "");
    Expect(1, 68480, '\p{^Is_Sc=-	phli}', "");
    Expect(1, 68480, '\P{Is_Sc=-	phli}', "");
    Expect(0, 68480, '\P{^Is_Sc=-	phli}', "");
    Error('\p{Script: /a/-	PSALTER_pahlavi}');
    Error('\P{Script: /a/-	PSALTER_pahlavi}');
    Expect(1, 68527, '\p{Script=:\APsalter_Pahlavi\z:}', "");;
    Expect(0, 68528, '\p{Script=:\APsalter_Pahlavi\z:}', "");;
    Expect(1, 68527, '\p{Script=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Script=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Script=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Script=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Script=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Script=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Script=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Script=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Script=:\Apsalterpahlavi\z:}', "");;
    Expect(0, 68528, '\p{Script=:\Apsalterpahlavi\z:}', "");;
    Expect(1, 68527, '\p{Script=_ psalter_PAHLAVI}', "");
    Expect(0, 68527, '\p{^Script=_ psalter_PAHLAVI}', "");
    Expect(0, 68527, '\P{Script=_ psalter_PAHLAVI}', "");
    Expect(1, 68527, '\P{^Script=_ psalter_PAHLAVI}', "");
    Expect(0, 68528, '\p{Script=_ psalter_PAHLAVI}', "");
    Expect(1, 68528, '\p{^Script=_ psalter_PAHLAVI}', "");
    Expect(1, 68528, '\P{Script=_ psalter_PAHLAVI}', "");
    Expect(0, 68528, '\P{^Script=_ psalter_PAHLAVI}', "");
    Error('\p{Sc=	PHLP/a/}');
    Error('\P{Sc=	PHLP/a/}');
    Expect(1, 68527, '\p{Sc=:\APhlp\z:}', "");;
    Expect(0, 68528, '\p{Sc=:\APhlp\z:}', "");;
    Expect(1, 68527, '\p{Sc=phlp}', "");
    Expect(0, 68527, '\p{^Sc=phlp}', "");
    Expect(0, 68527, '\P{Sc=phlp}', "");
    Expect(1, 68527, '\P{^Sc=phlp}', "");
    Expect(0, 68528, '\p{Sc=phlp}', "");
    Expect(1, 68528, '\p{^Sc=phlp}', "");
    Expect(1, 68528, '\P{Sc=phlp}', "");
    Expect(0, 68528, '\P{^Sc=phlp}', "");
    Expect(1, 68527, '\p{Sc=:\Aphlp\z:}', "");;
    Expect(0, 68528, '\p{Sc=:\Aphlp\z:}', "");;
    Expect(1, 68527, '\p{Sc=  PHLP}', "");
    Expect(0, 68527, '\p{^Sc=  PHLP}', "");
    Expect(0, 68527, '\P{Sc=  PHLP}', "");
    Expect(1, 68527, '\P{^Sc=  PHLP}', "");
    Expect(0, 68528, '\p{Sc=  PHLP}', "");
    Expect(1, 68528, '\p{^Sc=  PHLP}', "");
    Expect(1, 68528, '\P{Sc=  PHLP}', "");
    Expect(0, 68528, '\P{^Sc=  PHLP}', "");
    Error('\p{Is_Script=:=	Psalter_Pahlavi}');
    Error('\P{Is_Script=:=	Psalter_Pahlavi}');
    Expect(1, 68527, '\p{Is_Script=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Is_Script=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Is_Script=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Is_Script=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Is_Script=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Is_Script=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Is_Script=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Is_Script=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Is_Script=psalter_Pahlavi}', "");
    Expect(0, 68527, '\p{^Is_Script=psalter_Pahlavi}', "");
    Expect(0, 68527, '\P{Is_Script=psalter_Pahlavi}', "");
    Expect(1, 68527, '\P{^Is_Script=psalter_Pahlavi}', "");
    Expect(0, 68528, '\p{Is_Script=psalter_Pahlavi}', "");
    Expect(1, 68528, '\p{^Is_Script=psalter_Pahlavi}', "");
    Expect(1, 68528, '\P{Is_Script=psalter_Pahlavi}', "");
    Expect(0, 68528, '\P{^Is_Script=psalter_Pahlavi}', "");
    Error('\p{Is_Sc= /a/Phlp}');
    Error('\P{Is_Sc= /a/Phlp}');
    Expect(1, 68527, '\p{Is_Sc=phlp}', "");
    Expect(0, 68527, '\p{^Is_Sc=phlp}', "");
    Expect(0, 68527, '\P{Is_Sc=phlp}', "");
    Expect(1, 68527, '\P{^Is_Sc=phlp}', "");
    Expect(0, 68528, '\p{Is_Sc=phlp}', "");
    Expect(1, 68528, '\p{^Is_Sc=phlp}', "");
    Expect(1, 68528, '\P{Is_Sc=phlp}', "");
    Expect(0, 68528, '\P{^Is_Sc=phlp}', "");
    Expect(1, 68527, '\p{Is_Sc=_ Phlp}', "");
    Expect(0, 68527, '\p{^Is_Sc=_ Phlp}', "");
    Expect(0, 68527, '\P{Is_Sc=_ Phlp}', "");
    Expect(1, 68527, '\P{^Is_Sc=_ Phlp}', "");
    Expect(0, 68528, '\p{Is_Sc=_ Phlp}', "");
    Expect(1, 68528, '\p{^Is_Sc=_ Phlp}', "");
    Expect(1, 68528, '\P{Is_Sc=_ Phlp}', "");
    Expect(0, 68528, '\P{^Is_Sc=_ Phlp}', "");
    Error('\p{Script=/a/ 	Phoenician}');
    Error('\P{Script=/a/ 	Phoenician}');
    Expect(1, 67871, '\p{Script=:\APhoenician\z:}', "");;
    Expect(0, 67872, '\p{Script=:\APhoenician\z:}', "");;
    Expect(1, 67871, '\p{Script=phoenician}', "");
    Expect(0, 67871, '\p{^Script=phoenician}', "");
    Expect(0, 67871, '\P{Script=phoenician}', "");
    Expect(1, 67871, '\P{^Script=phoenician}', "");
    Expect(0, 67872, '\p{Script=phoenician}', "");
    Expect(1, 67872, '\p{^Script=phoenician}', "");
    Expect(1, 67872, '\P{Script=phoenician}', "");
    Expect(0, 67872, '\P{^Script=phoenician}', "");
    Expect(1, 67871, '\p{Script=:\Aphoenician\z:}', "");;
    Expect(0, 67872, '\p{Script=:\Aphoenician\z:}', "");;
    Expect(1, 67871, '\p{Script= 	PHOENICIAN}', "");
    Expect(0, 67871, '\p{^Script= 	PHOENICIAN}', "");
    Expect(0, 67871, '\P{Script= 	PHOENICIAN}', "");
    Expect(1, 67871, '\P{^Script= 	PHOENICIAN}', "");
    Expect(0, 67872, '\p{Script= 	PHOENICIAN}', "");
    Expect(1, 67872, '\p{^Script= 	PHOENICIAN}', "");
    Expect(1, 67872, '\P{Script= 	PHOENICIAN}', "");
    Expect(0, 67872, '\P{^Script= 	PHOENICIAN}', "");
    Error('\p{Sc=/a/	-PHNX}');
    Error('\P{Sc=/a/	-PHNX}');
    Expect(1, 67871, '\p{Sc=:\APhnx\z:}', "");;
    Expect(0, 67872, '\p{Sc=:\APhnx\z:}', "");;
    Expect(1, 67871, '\p{Sc:   phnx}', "");
    Expect(0, 67871, '\p{^Sc:   phnx}', "");
    Expect(0, 67871, '\P{Sc:   phnx}', "");
    Expect(1, 67871, '\P{^Sc:   phnx}', "");
    Expect(0, 67872, '\p{Sc:   phnx}', "");
    Expect(1, 67872, '\p{^Sc:   phnx}', "");
    Expect(1, 67872, '\P{Sc:   phnx}', "");
    Expect(0, 67872, '\P{^Sc:   phnx}', "");
    Expect(1, 67871, '\p{Sc=:\Aphnx\z:}', "");;
    Expect(0, 67872, '\p{Sc=:\Aphnx\z:}', "");;
    Expect(1, 67871, '\p{Sc=_-Phnx}', "");
    Expect(0, 67871, '\p{^Sc=_-Phnx}', "");
    Expect(0, 67871, '\P{Sc=_-Phnx}', "");
    Expect(1, 67871, '\P{^Sc=_-Phnx}', "");
    Expect(0, 67872, '\p{Sc=_-Phnx}', "");
    Expect(1, 67872, '\p{^Sc=_-Phnx}', "");
    Expect(1, 67872, '\P{Sc=_-Phnx}', "");
    Expect(0, 67872, '\P{^Sc=_-Phnx}', "");
    Error('\p{Is_Script= Phoenician:=}');
    Error('\P{Is_Script= Phoenician:=}');
    Expect(1, 67871, '\p{Is_Script=phoenician}', "");
    Expect(0, 67871, '\p{^Is_Script=phoenician}', "");
    Expect(0, 67871, '\P{Is_Script=phoenician}', "");
    Expect(1, 67871, '\P{^Is_Script=phoenician}', "");
    Expect(0, 67872, '\p{Is_Script=phoenician}', "");
    Expect(1, 67872, '\p{^Is_Script=phoenician}', "");
    Expect(1, 67872, '\P{Is_Script=phoenician}', "");
    Expect(0, 67872, '\P{^Is_Script=phoenician}', "");
    Expect(1, 67871, '\p{Is_Script= -Phoenician}', "");
    Expect(0, 67871, '\p{^Is_Script= -Phoenician}', "");
    Expect(0, 67871, '\P{Is_Script= -Phoenician}', "");
    Expect(1, 67871, '\P{^Is_Script= -Phoenician}', "");
    Expect(0, 67872, '\p{Is_Script= -Phoenician}', "");
    Expect(1, 67872, '\p{^Is_Script= -Phoenician}', "");
    Expect(1, 67872, '\P{Is_Script= -Phoenician}', "");
    Expect(0, 67872, '\P{^Is_Script= -Phoenician}', "");
    Error('\p{Is_Sc=	/a/Phnx}');
    Error('\P{Is_Sc=	/a/Phnx}');
    Expect(1, 67871, '\p{Is_Sc=phnx}', "");
    Expect(0, 67871, '\p{^Is_Sc=phnx}', "");
    Expect(0, 67871, '\P{Is_Sc=phnx}', "");
    Expect(1, 67871, '\P{^Is_Sc=phnx}', "");
    Expect(0, 67872, '\p{Is_Sc=phnx}', "");
    Expect(1, 67872, '\p{^Is_Sc=phnx}', "");
    Expect(1, 67872, '\P{Is_Sc=phnx}', "");
    Expect(0, 67872, '\P{^Is_Sc=phnx}', "");
    Expect(1, 67871, '\p{Is_Sc=__phnx}', "");
    Expect(0, 67871, '\p{^Is_Sc=__phnx}', "");
    Expect(0, 67871, '\P{Is_Sc=__phnx}', "");
    Expect(1, 67871, '\P{^Is_Sc=__phnx}', "");
    Expect(0, 67872, '\p{Is_Sc=__phnx}', "");
    Expect(1, 67872, '\p{^Is_Sc=__phnx}', "");
    Expect(1, 67872, '\P{Is_Sc=__phnx}', "");
    Expect(0, 67872, '\P{^Is_Sc=__phnx}', "");
    Error('\p{Script=	Miao/a/}');
    Error('\P{Script=	Miao/a/}');
    Expect(1, 94111, '\p{Script=:\AMiao\z:}', "");;
    Expect(0, 94112, '\p{Script=:\AMiao\z:}', "");;
    Expect(1, 94111, '\p{Script=miao}', "");
    Expect(0, 94111, '\p{^Script=miao}', "");
    Expect(0, 94111, '\P{Script=miao}', "");
    Expect(1, 94111, '\P{^Script=miao}', "");
    Expect(0, 94112, '\p{Script=miao}', "");
    Expect(1, 94112, '\p{^Script=miao}', "");
    Expect(1, 94112, '\P{Script=miao}', "");
    Expect(0, 94112, '\P{^Script=miao}', "");
    Expect(1, 94111, '\p{Script=:\Amiao\z:}', "");;
    Expect(0, 94112, '\p{Script=:\Amiao\z:}', "");;
    Expect(1, 94111, '\p{Script= 	MIAO}', "");
    Expect(0, 94111, '\p{^Script= 	MIAO}', "");
    Expect(0, 94111, '\P{Script= 	MIAO}', "");
    Expect(1, 94111, '\P{^Script= 	MIAO}', "");
    Expect(0, 94112, '\p{Script= 	MIAO}', "");
    Expect(1, 94112, '\p{^Script= 	MIAO}', "");
    Expect(1, 94112, '\P{Script= 	MIAO}', "");
    Expect(0, 94112, '\P{^Script= 	MIAO}', "");
    Error('\p{Sc=/a/  plrd}');
    Error('\P{Sc=/a/  plrd}');
    Expect(1, 94111, '\p{Sc=:\APlrd\z:}', "");;
    Expect(0, 94112, '\p{Sc=:\APlrd\z:}', "");;
    Expect(1, 94111, '\p{Sc:   plrd}', "");
    Expect(0, 94111, '\p{^Sc:   plrd}', "");
    Expect(0, 94111, '\P{Sc:   plrd}', "");
    Expect(1, 94111, '\P{^Sc:   plrd}', "");
    Expect(0, 94112, '\p{Sc:   plrd}', "");
    Expect(1, 94112, '\p{^Sc:   plrd}', "");
    Expect(1, 94112, '\P{Sc:   plrd}', "");
    Expect(0, 94112, '\P{^Sc:   plrd}', "");
    Expect(1, 94111, '\p{Sc=:\Aplrd\z:}', "");;
    Expect(0, 94112, '\p{Sc=:\Aplrd\z:}', "");;
    Expect(1, 94111, '\p{Sc=--PLRD}', "");
    Expect(0, 94111, '\p{^Sc=--PLRD}', "");
    Expect(0, 94111, '\P{Sc=--PLRD}', "");
    Expect(1, 94111, '\P{^Sc=--PLRD}', "");
    Expect(0, 94112, '\p{Sc=--PLRD}', "");
    Expect(1, 94112, '\p{^Sc=--PLRD}', "");
    Expect(1, 94112, '\P{Sc=--PLRD}', "");
    Expect(0, 94112, '\P{^Sc=--PLRD}', "");
    Error('\p{Is_Script= 	miao/a/}');
    Error('\P{Is_Script= 	miao/a/}');
    Expect(1, 94111, '\p{Is_Script=miao}', "");
    Expect(0, 94111, '\p{^Is_Script=miao}', "");
    Expect(0, 94111, '\P{Is_Script=miao}', "");
    Expect(1, 94111, '\P{^Is_Script=miao}', "");
    Expect(0, 94112, '\p{Is_Script=miao}', "");
    Expect(1, 94112, '\p{^Is_Script=miao}', "");
    Expect(1, 94112, '\P{Is_Script=miao}', "");
    Expect(0, 94112, '\P{^Is_Script=miao}', "");
    Expect(1, 94111, '\p{Is_Script= Miao}', "");
    Expect(0, 94111, '\p{^Is_Script= Miao}', "");
    Expect(0, 94111, '\P{Is_Script= Miao}', "");
    Expect(1, 94111, '\P{^Is_Script= Miao}', "");
    Expect(0, 94112, '\p{Is_Script= Miao}', "");
    Expect(1, 94112, '\p{^Is_Script= Miao}', "");
    Expect(1, 94112, '\P{Is_Script= Miao}', "");
    Expect(0, 94112, '\P{^Is_Script= Miao}', "");
    Error('\p{Is_Sc=-_plrd:=}');
    Error('\P{Is_Sc=-_plrd:=}');
    Expect(1, 94111, '\p{Is_Sc=plrd}', "");
    Expect(0, 94111, '\p{^Is_Sc=plrd}', "");
    Expect(0, 94111, '\P{Is_Sc=plrd}', "");
    Expect(1, 94111, '\P{^Is_Sc=plrd}', "");
    Expect(0, 94112, '\p{Is_Sc=plrd}', "");
    Expect(1, 94112, '\p{^Is_Sc=plrd}', "");
    Expect(1, 94112, '\P{Is_Sc=plrd}', "");
    Expect(0, 94112, '\P{^Is_Sc=plrd}', "");
    Expect(1, 94111, '\p{Is_Sc=		Plrd}', "");
    Expect(0, 94111, '\p{^Is_Sc=		Plrd}', "");
    Expect(0, 94111, '\P{Is_Sc=		Plrd}', "");
    Expect(1, 94111, '\P{^Is_Sc=		Plrd}', "");
    Expect(0, 94112, '\p{Is_Sc=		Plrd}', "");
    Expect(1, 94112, '\p{^Is_Sc=		Plrd}', "");
    Expect(1, 94112, '\P{Is_Sc=		Plrd}', "");
    Expect(0, 94112, '\P{^Is_Sc=		Plrd}', "");
    Error('\p{Script: --inscriptional_parthian/a/}');
    Error('\P{Script: --inscriptional_parthian/a/}');
    Expect(1, 68447, '\p{Script=:\AInscriptional_Parthian\z:}', "");;
    Expect(0, 68448, '\p{Script=:\AInscriptional_Parthian\z:}', "");;
    Expect(1, 68447, '\p{Script=inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Script=inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Script=inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Script=inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Script=inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Script=inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Script=inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Script=inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Script=:\Ainscriptionalparthian\z:}', "");;
    Expect(0, 68448, '\p{Script=:\Ainscriptionalparthian\z:}', "");;
    Expect(1, 68447, '\p{Script=_inscriptional_Parthian}', "");
    Expect(0, 68447, '\p{^Script=_inscriptional_Parthian}', "");
    Expect(0, 68447, '\P{Script=_inscriptional_Parthian}', "");
    Expect(1, 68447, '\P{^Script=_inscriptional_Parthian}', "");
    Expect(0, 68448, '\p{Script=_inscriptional_Parthian}', "");
    Expect(1, 68448, '\p{^Script=_inscriptional_Parthian}', "");
    Expect(1, 68448, '\P{Script=_inscriptional_Parthian}', "");
    Expect(0, 68448, '\P{^Script=_inscriptional_Parthian}', "");
    Error('\p{Sc=-/a/PRTI}');
    Error('\P{Sc=-/a/PRTI}');
    Expect(1, 68447, '\p{Sc=:\APrti\z:}', "");;
    Expect(0, 68448, '\p{Sc=:\APrti\z:}', "");;
    Expect(1, 68447, '\p{Sc=prti}', "");
    Expect(0, 68447, '\p{^Sc=prti}', "");
    Expect(0, 68447, '\P{Sc=prti}', "");
    Expect(1, 68447, '\P{^Sc=prti}', "");
    Expect(0, 68448, '\p{Sc=prti}', "");
    Expect(1, 68448, '\p{^Sc=prti}', "");
    Expect(1, 68448, '\P{Sc=prti}', "");
    Expect(0, 68448, '\P{^Sc=prti}', "");
    Expect(1, 68447, '\p{Sc=:\Aprti\z:}', "");;
    Expect(0, 68448, '\p{Sc=:\Aprti\z:}', "");;
    Expect(1, 68447, '\p{Sc=	Prti}', "");
    Expect(0, 68447, '\p{^Sc=	Prti}', "");
    Expect(0, 68447, '\P{Sc=	Prti}', "");
    Expect(1, 68447, '\P{^Sc=	Prti}', "");
    Expect(0, 68448, '\p{Sc=	Prti}', "");
    Expect(1, 68448, '\p{^Sc=	Prti}', "");
    Expect(1, 68448, '\P{Sc=	Prti}', "");
    Expect(0, 68448, '\P{^Sc=	Prti}', "");
    Error('\p{Is_Script=/a/_INSCRIPTIONAL_PARTHIAN}');
    Error('\P{Is_Script=/a/_INSCRIPTIONAL_PARTHIAN}');
    Expect(1, 68447, '\p{Is_Script=inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Is_Script=inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Is_Script=inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Is_Script=inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Is_Script=inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Is_Script=inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Is_Script=inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Is_Script=inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Is_Script= 	INSCRIPTIONAL_Parthian}', "");
    Expect(0, 68447, '\p{^Is_Script= 	INSCRIPTIONAL_Parthian}', "");
    Expect(0, 68447, '\P{Is_Script= 	INSCRIPTIONAL_Parthian}', "");
    Expect(1, 68447, '\P{^Is_Script= 	INSCRIPTIONAL_Parthian}', "");
    Expect(0, 68448, '\p{Is_Script= 	INSCRIPTIONAL_Parthian}', "");
    Expect(1, 68448, '\p{^Is_Script= 	INSCRIPTIONAL_Parthian}', "");
    Expect(1, 68448, '\P{Is_Script= 	INSCRIPTIONAL_Parthian}', "");
    Expect(0, 68448, '\P{^Is_Script= 	INSCRIPTIONAL_Parthian}', "");
    Error('\p{Is_Sc= :=prti}');
    Error('\P{Is_Sc= :=prti}');
    Expect(1, 68447, '\p{Is_Sc=prti}', "");
    Expect(0, 68447, '\p{^Is_Sc=prti}', "");
    Expect(0, 68447, '\P{Is_Sc=prti}', "");
    Expect(1, 68447, '\P{^Is_Sc=prti}', "");
    Expect(0, 68448, '\p{Is_Sc=prti}', "");
    Expect(1, 68448, '\p{^Is_Sc=prti}', "");
    Expect(1, 68448, '\P{Is_Sc=prti}', "");
    Expect(0, 68448, '\P{^Is_Sc=prti}', "");
    Expect(1, 68447, '\p{Is_Sc=_Prti}', "");
    Expect(0, 68447, '\p{^Is_Sc=_Prti}', "");
    Expect(0, 68447, '\P{Is_Sc=_Prti}', "");
    Expect(1, 68447, '\P{^Is_Sc=_Prti}', "");
    Expect(0, 68448, '\p{Is_Sc=_Prti}', "");
    Expect(1, 68448, '\p{^Is_Sc=_Prti}', "");
    Expect(1, 68448, '\P{Is_Sc=_Prti}', "");
    Expect(0, 68448, '\P{^Is_Sc=_Prti}', "");
    Error('\p{Script=/a/_ Rejang}');
    Error('\P{Script=/a/_ Rejang}');
    Expect(1, 43359, '\p{Script=:\ARejang\z:}', "");;
    Expect(0, 43360, '\p{Script=:\ARejang\z:}', "");;
    Expect(1, 43359, '\p{Script=rejang}', "");
    Expect(0, 43359, '\p{^Script=rejang}', "");
    Expect(0, 43359, '\P{Script=rejang}', "");
    Expect(1, 43359, '\P{^Script=rejang}', "");
    Expect(0, 43360, '\p{Script=rejang}', "");
    Expect(1, 43360, '\p{^Script=rejang}', "");
    Expect(1, 43360, '\P{Script=rejang}', "");
    Expect(0, 43360, '\P{^Script=rejang}', "");
    Expect(1, 43359, '\p{Script=:\Arejang\z:}', "");;
    Expect(0, 43360, '\p{Script=:\Arejang\z:}', "");;
    Expect(1, 43359, '\p{Script=- rejang}', "");
    Expect(0, 43359, '\p{^Script=- rejang}', "");
    Expect(0, 43359, '\P{Script=- rejang}', "");
    Expect(1, 43359, '\P{^Script=- rejang}', "");
    Expect(0, 43360, '\p{Script=- rejang}', "");
    Expect(1, 43360, '\p{^Script=- rejang}', "");
    Expect(1, 43360, '\P{Script=- rejang}', "");
    Expect(0, 43360, '\P{^Script=- rejang}', "");
    Error('\p{Sc=-rjng/a/}');
    Error('\P{Sc=-rjng/a/}');
    Expect(1, 43359, '\p{Sc=:\ARjng\z:}', "");;
    Expect(0, 43360, '\p{Sc=:\ARjng\z:}', "");;
    Expect(1, 43359, '\p{Sc=rjng}', "");
    Expect(0, 43359, '\p{^Sc=rjng}', "");
    Expect(0, 43359, '\P{Sc=rjng}', "");
    Expect(1, 43359, '\P{^Sc=rjng}', "");
    Expect(0, 43360, '\p{Sc=rjng}', "");
    Expect(1, 43360, '\p{^Sc=rjng}', "");
    Expect(1, 43360, '\P{Sc=rjng}', "");
    Expect(0, 43360, '\P{^Sc=rjng}', "");
    Expect(1, 43359, '\p{Sc=:\Arjng\z:}', "");;
    Expect(0, 43360, '\p{Sc=:\Arjng\z:}', "");;
    Expect(1, 43359, '\p{Sc:   		rjng}', "");
    Expect(0, 43359, '\p{^Sc:   		rjng}', "");
    Expect(0, 43359, '\P{Sc:   		rjng}', "");
    Expect(1, 43359, '\P{^Sc:   		rjng}', "");
    Expect(0, 43360, '\p{Sc:   		rjng}', "");
    Expect(1, 43360, '\p{^Sc:   		rjng}', "");
    Expect(1, 43360, '\P{Sc:   		rjng}', "");
    Expect(0, 43360, '\P{^Sc:   		rjng}', "");
    Error('\p{Is_Script=/a/_Rejang}');
    Error('\P{Is_Script=/a/_Rejang}');
    Expect(1, 43359, '\p{Is_Script=rejang}', "");
    Expect(0, 43359, '\p{^Is_Script=rejang}', "");
    Expect(0, 43359, '\P{Is_Script=rejang}', "");
    Expect(1, 43359, '\P{^Is_Script=rejang}', "");
    Expect(0, 43360, '\p{Is_Script=rejang}', "");
    Expect(1, 43360, '\p{^Is_Script=rejang}', "");
    Expect(1, 43360, '\P{Is_Script=rejang}', "");
    Expect(0, 43360, '\P{^Is_Script=rejang}', "");
    Expect(1, 43359, '\p{Is_Script=-rejang}', "");
    Expect(0, 43359, '\p{^Is_Script=-rejang}', "");
    Expect(0, 43359, '\P{Is_Script=-rejang}', "");
    Expect(1, 43359, '\P{^Is_Script=-rejang}', "");
    Expect(0, 43360, '\p{Is_Script=-rejang}', "");
    Expect(1, 43360, '\p{^Is_Script=-rejang}', "");
    Expect(1, 43360, '\P{Is_Script=-rejang}', "");
    Expect(0, 43360, '\P{^Is_Script=-rejang}', "");
    Error('\p{Is_Sc=/a/ 	RJNG}');
    Error('\P{Is_Sc=/a/ 	RJNG}');
    Expect(1, 43359, '\p{Is_Sc=rjng}', "");
    Expect(0, 43359, '\p{^Is_Sc=rjng}', "");
    Expect(0, 43359, '\P{Is_Sc=rjng}', "");
    Expect(1, 43359, '\P{^Is_Sc=rjng}', "");
    Expect(0, 43360, '\p{Is_Sc=rjng}', "");
    Expect(1, 43360, '\p{^Is_Sc=rjng}', "");
    Expect(1, 43360, '\P{Is_Sc=rjng}', "");
    Expect(0, 43360, '\P{^Is_Sc=rjng}', "");
    Expect(1, 43359, '\p{Is_Sc=  Rjng}', "");
    Expect(0, 43359, '\p{^Is_Sc=  Rjng}', "");
    Expect(0, 43359, '\P{Is_Sc=  Rjng}', "");
    Expect(1, 43359, '\P{^Is_Sc=  Rjng}', "");
    Expect(0, 43360, '\p{Is_Sc=  Rjng}', "");
    Expect(1, 43360, '\p{^Is_Sc=  Rjng}', "");
    Expect(1, 43360, '\P{Is_Sc=  Rjng}', "");
    Expect(0, 43360, '\P{^Is_Sc=  Rjng}', "");
    Error('\p{Script=	-hanifi_Rohingya/a/}');
    Error('\P{Script=	-hanifi_Rohingya/a/}');
    Expect(1, 68921, '\p{Script=:\AHanifi_Rohingya\z:}', "");;
    Expect(0, 68922, '\p{Script=:\AHanifi_Rohingya\z:}', "");;
    Expect(1, 68921, '\p{Script: hanifirohingya}', "");
    Expect(0, 68921, '\p{^Script: hanifirohingya}', "");
    Expect(0, 68921, '\P{Script: hanifirohingya}', "");
    Expect(1, 68921, '\P{^Script: hanifirohingya}', "");
    Expect(0, 68922, '\p{Script: hanifirohingya}', "");
    Expect(1, 68922, '\p{^Script: hanifirohingya}', "");
    Expect(1, 68922, '\P{Script: hanifirohingya}', "");
    Expect(0, 68922, '\P{^Script: hanifirohingya}', "");
    Expect(1, 68921, '\p{Script=:\Ahanifirohingya\z:}', "");;
    Expect(0, 68922, '\p{Script=:\Ahanifirohingya\z:}', "");;
    Expect(1, 68921, '\p{Script=		hanifi_rohingya}', "");
    Expect(0, 68921, '\p{^Script=		hanifi_rohingya}', "");
    Expect(0, 68921, '\P{Script=		hanifi_rohingya}', "");
    Expect(1, 68921, '\P{^Script=		hanifi_rohingya}', "");
    Expect(0, 68922, '\p{Script=		hanifi_rohingya}', "");
    Expect(1, 68922, '\p{^Script=		hanifi_rohingya}', "");
    Expect(1, 68922, '\P{Script=		hanifi_rohingya}', "");
    Expect(0, 68922, '\P{^Script=		hanifi_rohingya}', "");
    Error('\p{Sc=/a/-ROHG}');
    Error('\P{Sc=/a/-ROHG}');
    Expect(1, 68921, '\p{Sc=:\ARohg\z:}', "");;
    Expect(0, 68922, '\p{Sc=:\ARohg\z:}', "");;
    Expect(1, 68921, '\p{Sc=rohg}', "");
    Expect(0, 68921, '\p{^Sc=rohg}', "");
    Expect(0, 68921, '\P{Sc=rohg}', "");
    Expect(1, 68921, '\P{^Sc=rohg}', "");
    Expect(0, 68922, '\p{Sc=rohg}', "");
    Expect(1, 68922, '\p{^Sc=rohg}', "");
    Expect(1, 68922, '\P{Sc=rohg}', "");
    Expect(0, 68922, '\P{^Sc=rohg}', "");
    Expect(1, 68921, '\p{Sc=:\Arohg\z:}', "");;
    Expect(0, 68922, '\p{Sc=:\Arohg\z:}', "");;
    Expect(1, 68921, '\p{Sc= 	Rohg}', "");
    Expect(0, 68921, '\p{^Sc= 	Rohg}', "");
    Expect(0, 68921, '\P{Sc= 	Rohg}', "");
    Expect(1, 68921, '\P{^Sc= 	Rohg}', "");
    Expect(0, 68922, '\p{Sc= 	Rohg}', "");
    Expect(1, 68922, '\p{^Sc= 	Rohg}', "");
    Expect(1, 68922, '\P{Sc= 	Rohg}', "");
    Expect(0, 68922, '\P{^Sc= 	Rohg}', "");
    Error('\p{Is_Script=HANIFI_ROHINGYA:=}');
    Error('\P{Is_Script=HANIFI_ROHINGYA:=}');
    Expect(1, 68921, '\p{Is_Script:	hanifirohingya}', "");
    Expect(0, 68921, '\p{^Is_Script:	hanifirohingya}', "");
    Expect(0, 68921, '\P{Is_Script:	hanifirohingya}', "");
    Expect(1, 68921, '\P{^Is_Script:	hanifirohingya}', "");
    Expect(0, 68922, '\p{Is_Script:	hanifirohingya}', "");
    Expect(1, 68922, '\p{^Is_Script:	hanifirohingya}', "");
    Expect(1, 68922, '\P{Is_Script:	hanifirohingya}', "");
    Expect(0, 68922, '\P{^Is_Script:	hanifirohingya}', "");
    Expect(1, 68921, '\p{Is_Script=-HANIFI_rohingya}', "");
    Expect(0, 68921, '\p{^Is_Script=-HANIFI_rohingya}', "");
    Expect(0, 68921, '\P{Is_Script=-HANIFI_rohingya}', "");
    Expect(1, 68921, '\P{^Is_Script=-HANIFI_rohingya}', "");
    Expect(0, 68922, '\p{Is_Script=-HANIFI_rohingya}', "");
    Expect(1, 68922, '\p{^Is_Script=-HANIFI_rohingya}', "");
    Expect(1, 68922, '\P{Is_Script=-HANIFI_rohingya}', "");
    Expect(0, 68922, '\P{^Is_Script=-HANIFI_rohingya}', "");
    Error('\p{Is_Sc=:=_Rohg}');
    Error('\P{Is_Sc=:=_Rohg}');
    Expect(1, 68921, '\p{Is_Sc=rohg}', "");
    Expect(0, 68921, '\p{^Is_Sc=rohg}', "");
    Expect(0, 68921, '\P{Is_Sc=rohg}', "");
    Expect(1, 68921, '\P{^Is_Sc=rohg}', "");
    Expect(0, 68922, '\p{Is_Sc=rohg}', "");
    Expect(1, 68922, '\p{^Is_Sc=rohg}', "");
    Expect(1, 68922, '\P{Is_Sc=rohg}', "");
    Expect(0, 68922, '\P{^Is_Sc=rohg}', "");
    Expect(1, 68921, '\p{Is_Sc= rohg}', "");
    Expect(0, 68921, '\p{^Is_Sc= rohg}', "");
    Expect(0, 68921, '\P{Is_Sc= rohg}', "");
    Expect(1, 68921, '\P{^Is_Sc= rohg}', "");
    Expect(0, 68922, '\p{Is_Sc= rohg}', "");
    Expect(1, 68922, '\p{^Is_Sc= rohg}', "");
    Expect(1, 68922, '\P{Is_Sc= rohg}', "");
    Expect(0, 68922, '\P{^Is_Sc= rohg}', "");
    Error('\p{Script=_:=Runic}');
    Error('\P{Script=_:=Runic}');
    Expect(1, 5880, '\p{Script=:\ARunic\z:}', "");;
    Expect(0, 5881, '\p{Script=:\ARunic\z:}', "");;
    Expect(1, 5880, '\p{Script=runic}', "");
    Expect(0, 5880, '\p{^Script=runic}', "");
    Expect(0, 5880, '\P{Script=runic}', "");
    Expect(1, 5880, '\P{^Script=runic}', "");
    Expect(0, 5881, '\p{Script=runic}', "");
    Expect(1, 5881, '\p{^Script=runic}', "");
    Expect(1, 5881, '\P{Script=runic}', "");
    Expect(0, 5881, '\P{^Script=runic}', "");
    Expect(1, 5880, '\p{Script=:\Arunic\z:}', "");;
    Expect(0, 5881, '\p{Script=:\Arunic\z:}', "");;
    Error('\p{Sc= Runr/a/}');
    Error('\P{Sc= Runr/a/}');
    Expect(1, 5880, '\p{Sc=:\ARunr\z:}', "");;
    Expect(0, 5881, '\p{Sc=:\ARunr\z:}', "");;
    Expect(1, 5880, '\p{Sc=runr}', "");
    Expect(0, 5880, '\p{^Sc=runr}', "");
    Expect(0, 5880, '\P{Sc=runr}', "");
    Expect(1, 5880, '\P{^Sc=runr}', "");
    Expect(0, 5881, '\p{Sc=runr}', "");
    Expect(1, 5881, '\p{^Sc=runr}', "");
    Expect(1, 5881, '\P{Sc=runr}', "");
    Expect(0, 5881, '\P{^Sc=runr}', "");
    Expect(1, 5880, '\p{Sc=:\Arunr\z:}', "");;
    Expect(0, 5881, '\p{Sc=:\Arunr\z:}', "");;
    Expect(1, 5880, '\p{Sc: 	 Runr}', "");
    Expect(0, 5880, '\p{^Sc: 	 Runr}', "");
    Expect(0, 5880, '\P{Sc: 	 Runr}', "");
    Expect(1, 5880, '\P{^Sc: 	 Runr}', "");
    Expect(0, 5881, '\p{Sc: 	 Runr}', "");
    Expect(1, 5881, '\p{^Sc: 	 Runr}', "");
    Expect(1, 5881, '\P{Sc: 	 Runr}', "");
    Expect(0, 5881, '\P{^Sc: 	 Runr}', "");
    Error('\p{Is_Script=-:=runic}');
    Error('\P{Is_Script=-:=runic}');
    Expect(1, 5880, '\p{Is_Script=runic}', "");
    Expect(0, 5880, '\p{^Is_Script=runic}', "");
    Expect(0, 5880, '\P{Is_Script=runic}', "");
    Expect(1, 5880, '\P{^Is_Script=runic}', "");
    Expect(0, 5881, '\p{Is_Script=runic}', "");
    Expect(1, 5881, '\p{^Is_Script=runic}', "");
    Expect(1, 5881, '\P{Is_Script=runic}', "");
    Expect(0, 5881, '\P{^Is_Script=runic}', "");
    Expect(1, 5880, '\p{Is_Script= _Runic}', "");
    Expect(0, 5880, '\p{^Is_Script= _Runic}', "");
    Expect(0, 5880, '\P{Is_Script= _Runic}', "");
    Expect(1, 5880, '\P{^Is_Script= _Runic}', "");
    Expect(0, 5881, '\p{Is_Script= _Runic}', "");
    Expect(1, 5881, '\p{^Is_Script= _Runic}', "");
    Expect(1, 5881, '\P{Is_Script= _Runic}', "");
    Expect(0, 5881, '\P{^Is_Script= _Runic}', "");
    Error('\p{Is_Sc=:=Runr}');
    Error('\P{Is_Sc=:=Runr}');
    Expect(1, 5880, '\p{Is_Sc=runr}', "");
    Expect(0, 5880, '\p{^Is_Sc=runr}', "");
    Expect(0, 5880, '\P{Is_Sc=runr}', "");
    Expect(1, 5880, '\P{^Is_Sc=runr}', "");
    Expect(0, 5881, '\p{Is_Sc=runr}', "");
    Expect(1, 5881, '\p{^Is_Sc=runr}', "");
    Expect(1, 5881, '\P{Is_Sc=runr}', "");
    Expect(0, 5881, '\P{^Is_Sc=runr}', "");
    Expect(1, 5880, '\p{Is_Sc=-Runr}', "");
    Expect(0, 5880, '\p{^Is_Sc=-Runr}', "");
    Expect(0, 5880, '\P{Is_Sc=-Runr}', "");
    Expect(1, 5880, '\P{^Is_Sc=-Runr}', "");
    Expect(0, 5881, '\p{Is_Sc=-Runr}', "");
    Expect(1, 5881, '\p{^Is_Sc=-Runr}', "");
    Expect(1, 5881, '\P{Is_Sc=-Runr}', "");
    Expect(0, 5881, '\P{^Is_Sc=-Runr}', "");
    Error('\p{Script=_-Samaritan:=}');
    Error('\P{Script=_-Samaritan:=}');
    Expect(1, 2110, '\p{Script=:\ASamaritan\z:}', "");;
    Expect(0, 2111, '\p{Script=:\ASamaritan\z:}', "");;
    Expect(1, 2110, '\p{Script=samaritan}', "");
    Expect(0, 2110, '\p{^Script=samaritan}', "");
    Expect(0, 2110, '\P{Script=samaritan}', "");
    Expect(1, 2110, '\P{^Script=samaritan}', "");
    Expect(0, 2111, '\p{Script=samaritan}', "");
    Expect(1, 2111, '\p{^Script=samaritan}', "");
    Expect(1, 2111, '\P{Script=samaritan}', "");
    Expect(0, 2111, '\P{^Script=samaritan}', "");
    Expect(1, 2110, '\p{Script=:\Asamaritan\z:}', "");;
    Expect(0, 2111, '\p{Script=:\Asamaritan\z:}', "");;
    Expect(1, 2110, '\p{Script=Samaritan}', "");
    Expect(0, 2110, '\p{^Script=Samaritan}', "");
    Expect(0, 2110, '\P{Script=Samaritan}', "");
    Expect(1, 2110, '\P{^Script=Samaritan}', "");
    Expect(0, 2111, '\p{Script=Samaritan}', "");
    Expect(1, 2111, '\p{^Script=Samaritan}', "");
    Expect(1, 2111, '\P{Script=Samaritan}', "");
    Expect(0, 2111, '\P{^Script=Samaritan}', "");
    Error('\p{Sc=/a/	 samr}');
    Error('\P{Sc=/a/	 samr}');
    Expect(1, 2110, '\p{Sc=:\ASamr\z:}', "");;
    Expect(0, 2111, '\p{Sc=:\ASamr\z:}', "");;
    Expect(1, 2110, '\p{Sc:	samr}', "");
    Expect(0, 2110, '\p{^Sc:	samr}', "");
    Expect(0, 2110, '\P{Sc:	samr}', "");
    Expect(1, 2110, '\P{^Sc:	samr}', "");
    Expect(0, 2111, '\p{Sc:	samr}', "");
    Expect(1, 2111, '\p{^Sc:	samr}', "");
    Expect(1, 2111, '\P{Sc:	samr}', "");
    Expect(0, 2111, '\P{^Sc:	samr}', "");
    Expect(1, 2110, '\p{Sc=:\Asamr\z:}', "");;
    Expect(0, 2111, '\p{Sc=:\Asamr\z:}', "");;
    Expect(1, 2110, '\p{Sc=-	SAMR}', "");
    Expect(0, 2110, '\p{^Sc=-	SAMR}', "");
    Expect(0, 2110, '\P{Sc=-	SAMR}', "");
    Expect(1, 2110, '\P{^Sc=-	SAMR}', "");
    Expect(0, 2111, '\p{Sc=-	SAMR}', "");
    Expect(1, 2111, '\p{^Sc=-	SAMR}', "");
    Expect(1, 2111, '\P{Sc=-	SAMR}', "");
    Expect(0, 2111, '\P{^Sc=-	SAMR}', "");
    Error('\p{Is_Script=/a/ 	Samaritan}');
    Error('\P{Is_Script=/a/ 	Samaritan}');
    Expect(1, 2110, '\p{Is_Script=samaritan}', "");
    Expect(0, 2110, '\p{^Is_Script=samaritan}', "");
    Expect(0, 2110, '\P{Is_Script=samaritan}', "");
    Expect(1, 2110, '\P{^Is_Script=samaritan}', "");
    Expect(0, 2111, '\p{Is_Script=samaritan}', "");
    Expect(1, 2111, '\p{^Is_Script=samaritan}', "");
    Expect(1, 2111, '\P{Is_Script=samaritan}', "");
    Expect(0, 2111, '\P{^Is_Script=samaritan}', "");
    Expect(1, 2110, '\p{Is_Script=_-samaritan}', "");
    Expect(0, 2110, '\p{^Is_Script=_-samaritan}', "");
    Expect(0, 2110, '\P{Is_Script=_-samaritan}', "");
    Expect(1, 2110, '\P{^Is_Script=_-samaritan}', "");
    Expect(0, 2111, '\p{Is_Script=_-samaritan}', "");
    Expect(1, 2111, '\p{^Is_Script=_-samaritan}', "");
    Expect(1, 2111, '\P{Is_Script=_-samaritan}', "");
    Expect(0, 2111, '\P{^Is_Script=_-samaritan}', "");
    Error('\p{Is_Sc= :=samr}');
    Error('\P{Is_Sc= :=samr}');
    Expect(1, 2110, '\p{Is_Sc=samr}', "");
    Expect(0, 2110, '\p{^Is_Sc=samr}', "");
    Expect(0, 2110, '\P{Is_Sc=samr}', "");
    Expect(1, 2110, '\P{^Is_Sc=samr}', "");
    Expect(0, 2111, '\p{Is_Sc=samr}', "");
    Expect(1, 2111, '\p{^Is_Sc=samr}', "");
    Expect(1, 2111, '\P{Is_Sc=samr}', "");
    Expect(0, 2111, '\P{^Is_Sc=samr}', "");
    Expect(1, 2110, '\p{Is_Sc=- samr}', "");
    Expect(0, 2110, '\p{^Is_Sc=- samr}', "");
    Expect(0, 2110, '\P{Is_Sc=- samr}', "");
    Expect(1, 2110, '\P{^Is_Sc=- samr}', "");
    Expect(0, 2111, '\p{Is_Sc=- samr}', "");
    Expect(1, 2111, '\p{^Is_Sc=- samr}', "");
    Expect(1, 2111, '\P{Is_Sc=- samr}', "");
    Expect(0, 2111, '\P{^Is_Sc=- samr}', "");
    Error('\p{Script=-:=old_SOUTH_arabian}');
    Error('\P{Script=-:=old_SOUTH_arabian}');
    Expect(1, 68223, '\p{Script=:\AOld_South_Arabian\z:}', "");;
    Expect(0, 68224, '\p{Script=:\AOld_South_Arabian\z:}', "");;
    Expect(1, 68223, '\p{Script: oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Script: oldsoutharabian}', "");
    Expect(0, 68223, '\P{Script: oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Script: oldsoutharabian}', "");
    Expect(0, 68224, '\p{Script: oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Script: oldsoutharabian}', "");
    Expect(1, 68224, '\P{Script: oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Script: oldsoutharabian}', "");
    Expect(1, 68223, '\p{Script=:\Aoldsoutharabian\z:}', "");;
    Expect(0, 68224, '\p{Script=:\Aoldsoutharabian\z:}', "");;
    Expect(1, 68223, '\p{Script= _OLD_South_Arabian}', "");
    Expect(0, 68223, '\p{^Script= _OLD_South_Arabian}', "");
    Expect(0, 68223, '\P{Script= _OLD_South_Arabian}', "");
    Expect(1, 68223, '\P{^Script= _OLD_South_Arabian}', "");
    Expect(0, 68224, '\p{Script= _OLD_South_Arabian}', "");
    Expect(1, 68224, '\p{^Script= _OLD_South_Arabian}', "");
    Expect(1, 68224, '\P{Script= _OLD_South_Arabian}', "");
    Expect(0, 68224, '\P{^Script= _OLD_South_Arabian}', "");
    Error('\p{Sc=/a/	SARB}');
    Error('\P{Sc=/a/	SARB}');
    Expect(1, 68223, '\p{Sc=:\ASarb\z:}', "");;
    Expect(0, 68224, '\p{Sc=:\ASarb\z:}', "");;
    Expect(1, 68223, '\p{Sc=sarb}', "");
    Expect(0, 68223, '\p{^Sc=sarb}', "");
    Expect(0, 68223, '\P{Sc=sarb}', "");
    Expect(1, 68223, '\P{^Sc=sarb}', "");
    Expect(0, 68224, '\p{Sc=sarb}', "");
    Expect(1, 68224, '\p{^Sc=sarb}', "");
    Expect(1, 68224, '\P{Sc=sarb}', "");
    Expect(0, 68224, '\P{^Sc=sarb}', "");
    Expect(1, 68223, '\p{Sc=:\Asarb\z:}', "");;
    Expect(0, 68224, '\p{Sc=:\Asarb\z:}', "");;
    Expect(1, 68223, '\p{Sc:    SARB}', "");
    Expect(0, 68223, '\p{^Sc:    SARB}', "");
    Expect(0, 68223, '\P{Sc:    SARB}', "");
    Expect(1, 68223, '\P{^Sc:    SARB}', "");
    Expect(0, 68224, '\p{Sc:    SARB}', "");
    Expect(1, 68224, '\p{^Sc:    SARB}', "");
    Expect(1, 68224, '\P{Sc:    SARB}', "");
    Expect(0, 68224, '\P{^Sc:    SARB}', "");
    Error('\p{Is_Script=/a/_Old_SOUTH_Arabian}');
    Error('\P{Is_Script=/a/_Old_SOUTH_Arabian}');
    Expect(1, 68223, '\p{Is_Script=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Is_Script=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Is_Script=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Is_Script=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Is_Script=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Is_Script=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Is_Script=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Is_Script=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Is_Script:	__OLD_South_ARABIAN}', "");
    Expect(0, 68223, '\p{^Is_Script:	__OLD_South_ARABIAN}', "");
    Expect(0, 68223, '\P{Is_Script:	__OLD_South_ARABIAN}', "");
    Expect(1, 68223, '\P{^Is_Script:	__OLD_South_ARABIAN}', "");
    Expect(0, 68224, '\p{Is_Script:	__OLD_South_ARABIAN}', "");
    Expect(1, 68224, '\p{^Is_Script:	__OLD_South_ARABIAN}', "");
    Expect(1, 68224, '\P{Is_Script:	__OLD_South_ARABIAN}', "");
    Expect(0, 68224, '\P{^Is_Script:	__OLD_South_ARABIAN}', "");
    Error('\p{Is_Sc=:=-SARB}');
    Error('\P{Is_Sc=:=-SARB}');
    Expect(1, 68223, '\p{Is_Sc=sarb}', "");
    Expect(0, 68223, '\p{^Is_Sc=sarb}', "");
    Expect(0, 68223, '\P{Is_Sc=sarb}', "");
    Expect(1, 68223, '\P{^Is_Sc=sarb}', "");
    Expect(0, 68224, '\p{Is_Sc=sarb}', "");
    Expect(1, 68224, '\p{^Is_Sc=sarb}', "");
    Expect(1, 68224, '\P{Is_Sc=sarb}', "");
    Expect(0, 68224, '\P{^Is_Sc=sarb}', "");
    Expect(1, 68223, '\p{Is_Sc=  sarb}', "");
    Expect(0, 68223, '\p{^Is_Sc=  sarb}', "");
    Expect(0, 68223, '\P{Is_Sc=  sarb}', "");
    Expect(1, 68223, '\P{^Is_Sc=  sarb}', "");
    Expect(0, 68224, '\p{Is_Sc=  sarb}', "");
    Expect(1, 68224, '\p{^Is_Sc=  sarb}', "");
    Expect(1, 68224, '\P{Is_Sc=  sarb}', "");
    Expect(0, 68224, '\P{^Is_Sc=  sarb}', "");
    Error('\p{Script=_:=Saurashtra}');
    Error('\P{Script=_:=Saurashtra}');
    Expect(1, 43225, '\p{Script=:\ASaurashtra\z:}', "");;
    Expect(0, 43226, '\p{Script=:\ASaurashtra\z:}', "");;
    Expect(1, 43225, '\p{Script:   saurashtra}', "");
    Expect(0, 43225, '\p{^Script:   saurashtra}', "");
    Expect(0, 43225, '\P{Script:   saurashtra}', "");
    Expect(1, 43225, '\P{^Script:   saurashtra}', "");
    Expect(0, 43226, '\p{Script:   saurashtra}', "");
    Expect(1, 43226, '\p{^Script:   saurashtra}', "");
    Expect(1, 43226, '\P{Script:   saurashtra}', "");
    Expect(0, 43226, '\P{^Script:   saurashtra}', "");
    Expect(1, 43225, '\p{Script=:\Asaurashtra\z:}', "");;
    Expect(0, 43226, '\p{Script=:\Asaurashtra\z:}', "");;
    Expect(1, 43225, '\p{Script=	 Saurashtra}', "");
    Expect(0, 43225, '\p{^Script=	 Saurashtra}', "");
    Expect(0, 43225, '\P{Script=	 Saurashtra}', "");
    Expect(1, 43225, '\P{^Script=	 Saurashtra}', "");
    Expect(0, 43226, '\p{Script=	 Saurashtra}', "");
    Expect(1, 43226, '\p{^Script=	 Saurashtra}', "");
    Expect(1, 43226, '\P{Script=	 Saurashtra}', "");
    Expect(0, 43226, '\P{^Script=	 Saurashtra}', "");
    Error('\p{Sc=:=	saur}');
    Error('\P{Sc=:=	saur}');
    Expect(1, 43225, '\p{Sc=:\ASaur\z:}', "");;
    Expect(0, 43226, '\p{Sc=:\ASaur\z:}', "");;
    Expect(1, 43225, '\p{Sc=saur}', "");
    Expect(0, 43225, '\p{^Sc=saur}', "");
    Expect(0, 43225, '\P{Sc=saur}', "");
    Expect(1, 43225, '\P{^Sc=saur}', "");
    Expect(0, 43226, '\p{Sc=saur}', "");
    Expect(1, 43226, '\p{^Sc=saur}', "");
    Expect(1, 43226, '\P{Sc=saur}', "");
    Expect(0, 43226, '\P{^Sc=saur}', "");
    Expect(1, 43225, '\p{Sc=:\Asaur\z:}', "");;
    Expect(0, 43226, '\p{Sc=:\Asaur\z:}', "");;
    Expect(1, 43225, '\p{Sc=		Saur}', "");
    Expect(0, 43225, '\p{^Sc=		Saur}', "");
    Expect(0, 43225, '\P{Sc=		Saur}', "");
    Expect(1, 43225, '\P{^Sc=		Saur}', "");
    Expect(0, 43226, '\p{Sc=		Saur}', "");
    Expect(1, 43226, '\p{^Sc=		Saur}', "");
    Expect(1, 43226, '\P{Sc=		Saur}', "");
    Expect(0, 43226, '\P{^Sc=		Saur}', "");
    Error('\p{Is_Script=_/a/Saurashtra}');
    Error('\P{Is_Script=_/a/Saurashtra}');
    Expect(1, 43225, '\p{Is_Script=saurashtra}', "");
    Expect(0, 43225, '\p{^Is_Script=saurashtra}', "");
    Expect(0, 43225, '\P{Is_Script=saurashtra}', "");
    Expect(1, 43225, '\P{^Is_Script=saurashtra}', "");
    Expect(0, 43226, '\p{Is_Script=saurashtra}', "");
    Expect(1, 43226, '\p{^Is_Script=saurashtra}', "");
    Expect(1, 43226, '\P{Is_Script=saurashtra}', "");
    Expect(0, 43226, '\P{^Is_Script=saurashtra}', "");
    Expect(1, 43225, '\p{Is_Script:  _saurashtra}', "");
    Expect(0, 43225, '\p{^Is_Script:  _saurashtra}', "");
    Expect(0, 43225, '\P{Is_Script:  _saurashtra}', "");
    Expect(1, 43225, '\P{^Is_Script:  _saurashtra}', "");
    Expect(0, 43226, '\p{Is_Script:  _saurashtra}', "");
    Expect(1, 43226, '\p{^Is_Script:  _saurashtra}', "");
    Expect(1, 43226, '\P{Is_Script:  _saurashtra}', "");
    Expect(0, 43226, '\P{^Is_Script:  _saurashtra}', "");
    Error('\p{Is_Sc= /a/Saur}');
    Error('\P{Is_Sc= /a/Saur}');
    Expect(1, 43225, '\p{Is_Sc=saur}', "");
    Expect(0, 43225, '\p{^Is_Sc=saur}', "");
    Expect(0, 43225, '\P{Is_Sc=saur}', "");
    Expect(1, 43225, '\P{^Is_Sc=saur}', "");
    Expect(0, 43226, '\p{Is_Sc=saur}', "");
    Expect(1, 43226, '\p{^Is_Sc=saur}', "");
    Expect(1, 43226, '\P{Is_Sc=saur}', "");
    Expect(0, 43226, '\P{^Is_Sc=saur}', "");
    Expect(1, 43225, '\p{Is_Sc=	Saur}', "");
    Expect(0, 43225, '\p{^Is_Sc=	Saur}', "");
    Expect(0, 43225, '\P{Is_Sc=	Saur}', "");
    Expect(1, 43225, '\P{^Is_Sc=	Saur}', "");
    Expect(0, 43226, '\p{Is_Sc=	Saur}', "");
    Expect(1, 43226, '\p{^Is_Sc=	Saur}', "");
    Expect(1, 43226, '\P{Is_Sc=	Saur}', "");
    Expect(0, 43226, '\P{^Is_Sc=	Saur}', "");
    Error('\p{Script=/a/ SignWriting}');
    Error('\P{Script=/a/ SignWriting}');
    Expect(1, 121519, '\p{Script=:\ASignWriting\z:}', "");;
    Expect(0, 121520, '\p{Script=:\ASignWriting\z:}', "");;
    Expect(1, 121519, '\p{Script=signwriting}', "");
    Expect(0, 121519, '\p{^Script=signwriting}', "");
    Expect(0, 121519, '\P{Script=signwriting}', "");
    Expect(1, 121519, '\P{^Script=signwriting}', "");
    Expect(0, 121520, '\p{Script=signwriting}', "");
    Expect(1, 121520, '\p{^Script=signwriting}', "");
    Expect(1, 121520, '\P{Script=signwriting}', "");
    Expect(0, 121520, '\P{^Script=signwriting}', "");
    Expect(1, 121519, '\p{Script=:\Asignwriting\z:}', "");;
    Expect(0, 121520, '\p{Script=:\Asignwriting\z:}', "");;
    Expect(1, 121519, '\p{Script=__SignWriting}', "");
    Expect(0, 121519, '\p{^Script=__SignWriting}', "");
    Expect(0, 121519, '\P{Script=__SignWriting}', "");
    Expect(1, 121519, '\P{^Script=__SignWriting}', "");
    Expect(0, 121520, '\p{Script=__SignWriting}', "");
    Expect(1, 121520, '\p{^Script=__SignWriting}', "");
    Expect(1, 121520, '\P{Script=__SignWriting}', "");
    Expect(0, 121520, '\P{^Script=__SignWriting}', "");
    Error('\p{Sc=/a/__Sgnw}');
    Error('\P{Sc=/a/__Sgnw}');
    Expect(1, 121519, '\p{Sc=:\ASgnw\z:}', "");;
    Expect(0, 121520, '\p{Sc=:\ASgnw\z:}', "");;
    Expect(1, 121519, '\p{Sc=sgnw}', "");
    Expect(0, 121519, '\p{^Sc=sgnw}', "");
    Expect(0, 121519, '\P{Sc=sgnw}', "");
    Expect(1, 121519, '\P{^Sc=sgnw}', "");
    Expect(0, 121520, '\p{Sc=sgnw}', "");
    Expect(1, 121520, '\p{^Sc=sgnw}', "");
    Expect(1, 121520, '\P{Sc=sgnw}', "");
    Expect(0, 121520, '\P{^Sc=sgnw}', "");
    Expect(1, 121519, '\p{Sc=:\Asgnw\z:}', "");;
    Expect(0, 121520, '\p{Sc=:\Asgnw\z:}', "");;
    Expect(1, 121519, '\p{Sc=_-Sgnw}', "");
    Expect(0, 121519, '\p{^Sc=_-Sgnw}', "");
    Expect(0, 121519, '\P{Sc=_-Sgnw}', "");
    Expect(1, 121519, '\P{^Sc=_-Sgnw}', "");
    Expect(0, 121520, '\p{Sc=_-Sgnw}', "");
    Expect(1, 121520, '\p{^Sc=_-Sgnw}', "");
    Expect(1, 121520, '\P{Sc=_-Sgnw}', "");
    Expect(0, 121520, '\P{^Sc=_-Sgnw}', "");
    Error('\p{Is_Script= SignWriting/a/}');
    Error('\P{Is_Script= SignWriting/a/}');
    Expect(1, 121519, '\p{Is_Script=signwriting}', "");
    Expect(0, 121519, '\p{^Is_Script=signwriting}', "");
    Expect(0, 121519, '\P{Is_Script=signwriting}', "");
    Expect(1, 121519, '\P{^Is_Script=signwriting}', "");
    Expect(0, 121520, '\p{Is_Script=signwriting}', "");
    Expect(1, 121520, '\p{^Is_Script=signwriting}', "");
    Expect(1, 121520, '\P{Is_Script=signwriting}', "");
    Expect(0, 121520, '\P{^Is_Script=signwriting}', "");
    Expect(1, 121519, '\p{Is_Script=_signwriting}', "");
    Expect(0, 121519, '\p{^Is_Script=_signwriting}', "");
    Expect(0, 121519, '\P{Is_Script=_signwriting}', "");
    Expect(1, 121519, '\P{^Is_Script=_signwriting}', "");
    Expect(0, 121520, '\p{Is_Script=_signwriting}', "");
    Expect(1, 121520, '\p{^Is_Script=_signwriting}', "");
    Expect(1, 121520, '\P{Is_Script=_signwriting}', "");
    Expect(0, 121520, '\P{^Is_Script=_signwriting}', "");
    Error('\p{Is_Sc=/a/Sgnw}');
    Error('\P{Is_Sc=/a/Sgnw}');
    Expect(1, 121519, '\p{Is_Sc=sgnw}', "");
    Expect(0, 121519, '\p{^Is_Sc=sgnw}', "");
    Expect(0, 121519, '\P{Is_Sc=sgnw}', "");
    Expect(1, 121519, '\P{^Is_Sc=sgnw}', "");
    Expect(0, 121520, '\p{Is_Sc=sgnw}', "");
    Expect(1, 121520, '\p{^Is_Sc=sgnw}', "");
    Expect(1, 121520, '\P{Is_Sc=sgnw}', "");
    Expect(0, 121520, '\P{^Is_Sc=sgnw}', "");
    Expect(1, 121519, '\p{Is_Sc=--SGNW}', "");
    Expect(0, 121519, '\p{^Is_Sc=--SGNW}', "");
    Expect(0, 121519, '\P{Is_Sc=--SGNW}', "");
    Expect(1, 121519, '\P{^Is_Sc=--SGNW}', "");
    Expect(0, 121520, '\p{Is_Sc=--SGNW}', "");
    Expect(1, 121520, '\p{^Is_Sc=--SGNW}', "");
    Expect(1, 121520, '\P{Is_Sc=--SGNW}', "");
    Expect(0, 121520, '\P{^Is_Sc=--SGNW}', "");
    Error('\p{Script:   	_Shavian/a/}');
    Error('\P{Script:   	_Shavian/a/}');
    Expect(1, 66687, '\p{Script=:\AShavian\z:}', "");;
    Expect(0, 66688, '\p{Script=:\AShavian\z:}', "");;
    Expect(1, 66687, '\p{Script=shavian}', "");
    Expect(0, 66687, '\p{^Script=shavian}', "");
    Expect(0, 66687, '\P{Script=shavian}', "");
    Expect(1, 66687, '\P{^Script=shavian}', "");
    Expect(0, 66688, '\p{Script=shavian}', "");
    Expect(1, 66688, '\p{^Script=shavian}', "");
    Expect(1, 66688, '\P{Script=shavian}', "");
    Expect(0, 66688, '\P{^Script=shavian}', "");
    Expect(1, 66687, '\p{Script=:\Ashavian\z:}', "");;
    Expect(0, 66688, '\p{Script=:\Ashavian\z:}', "");;
    Expect(1, 66687, '\p{Script=Shavian}', "");
    Expect(0, 66687, '\p{^Script=Shavian}', "");
    Expect(0, 66687, '\P{Script=Shavian}', "");
    Expect(1, 66687, '\P{^Script=Shavian}', "");
    Expect(0, 66688, '\p{Script=Shavian}', "");
    Expect(1, 66688, '\p{^Script=Shavian}', "");
    Expect(1, 66688, '\P{Script=Shavian}', "");
    Expect(0, 66688, '\P{^Script=Shavian}', "");
    Error('\p{Sc:	 :=Shaw}');
    Error('\P{Sc:	 :=Shaw}');
    Expect(1, 66687, '\p{Sc=:\AShaw\z:}', "");;
    Expect(0, 66688, '\p{Sc=:\AShaw\z:}', "");;
    Expect(1, 66687, '\p{Sc=shaw}', "");
    Expect(0, 66687, '\p{^Sc=shaw}', "");
    Expect(0, 66687, '\P{Sc=shaw}', "");
    Expect(1, 66687, '\P{^Sc=shaw}', "");
    Expect(0, 66688, '\p{Sc=shaw}', "");
    Expect(1, 66688, '\p{^Sc=shaw}', "");
    Expect(1, 66688, '\P{Sc=shaw}', "");
    Expect(0, 66688, '\P{^Sc=shaw}', "");
    Expect(1, 66687, '\p{Sc=:\Ashaw\z:}', "");;
    Expect(0, 66688, '\p{Sc=:\Ashaw\z:}', "");;
    Expect(1, 66687, '\p{Sc:	 Shaw}', "");
    Expect(0, 66687, '\p{^Sc:	 Shaw}', "");
    Expect(0, 66687, '\P{Sc:	 Shaw}', "");
    Expect(1, 66687, '\P{^Sc:	 Shaw}', "");
    Expect(0, 66688, '\p{Sc:	 Shaw}', "");
    Expect(1, 66688, '\p{^Sc:	 Shaw}', "");
    Expect(1, 66688, '\P{Sc:	 Shaw}', "");
    Expect(0, 66688, '\P{^Sc:	 Shaw}', "");
    Error('\p{Is_Script=_	shavian:=}');
    Error('\P{Is_Script=_	shavian:=}');
    Expect(1, 66687, '\p{Is_Script=shavian}', "");
    Expect(0, 66687, '\p{^Is_Script=shavian}', "");
    Expect(0, 66687, '\P{Is_Script=shavian}', "");
    Expect(1, 66687, '\P{^Is_Script=shavian}', "");
    Expect(0, 66688, '\p{Is_Script=shavian}', "");
    Expect(1, 66688, '\p{^Is_Script=shavian}', "");
    Expect(1, 66688, '\P{Is_Script=shavian}', "");
    Expect(0, 66688, '\P{^Is_Script=shavian}', "");
    Expect(1, 66687, '\p{Is_Script=_Shavian}', "");
    Expect(0, 66687, '\p{^Is_Script=_Shavian}', "");
    Expect(0, 66687, '\P{Is_Script=_Shavian}', "");
    Expect(1, 66687, '\P{^Is_Script=_Shavian}', "");
    Expect(0, 66688, '\p{Is_Script=_Shavian}', "");
    Expect(1, 66688, '\p{^Is_Script=_Shavian}', "");
    Expect(1, 66688, '\P{Is_Script=_Shavian}', "");
    Expect(0, 66688, '\P{^Is_Script=_Shavian}', "");
    Error('\p{Is_Sc=_:=Shaw}');
    Error('\P{Is_Sc=_:=Shaw}');
    Expect(1, 66687, '\p{Is_Sc=shaw}', "");
    Expect(0, 66687, '\p{^Is_Sc=shaw}', "");
    Expect(0, 66687, '\P{Is_Sc=shaw}', "");
    Expect(1, 66687, '\P{^Is_Sc=shaw}', "");
    Expect(0, 66688, '\p{Is_Sc=shaw}', "");
    Expect(1, 66688, '\p{^Is_Sc=shaw}', "");
    Expect(1, 66688, '\P{Is_Sc=shaw}', "");
    Expect(0, 66688, '\P{^Is_Sc=shaw}', "");
    Expect(1, 66687, '\p{Is_Sc=_ SHAW}', "");
    Expect(0, 66687, '\p{^Is_Sc=_ SHAW}', "");
    Expect(0, 66687, '\P{Is_Sc=_ SHAW}', "");
    Expect(1, 66687, '\P{^Is_Sc=_ SHAW}', "");
    Expect(0, 66688, '\p{Is_Sc=_ SHAW}', "");
    Expect(1, 66688, '\p{^Is_Sc=_ SHAW}', "");
    Expect(1, 66688, '\P{Is_Sc=_ SHAW}', "");
    Expect(0, 66688, '\P{^Is_Sc=_ SHAW}', "");
    Error('\p{Script=/a/sharada}');
    Error('\P{Script=/a/sharada}');
    Expect(1, 70111, '\p{Script=:\ASharada\z:}', "");;
    Expect(0, 70112, '\p{Script=:\ASharada\z:}', "");;
    Expect(1, 70111, '\p{Script=sharada}', "");
    Expect(0, 70111, '\p{^Script=sharada}', "");
    Expect(0, 70111, '\P{Script=sharada}', "");
    Expect(1, 70111, '\P{^Script=sharada}', "");
    Expect(0, 70112, '\p{Script=sharada}', "");
    Expect(1, 70112, '\p{^Script=sharada}', "");
    Expect(1, 70112, '\P{Script=sharada}', "");
    Expect(0, 70112, '\P{^Script=sharada}', "");
    Expect(1, 70111, '\p{Script=:\Asharada\z:}', "");;
    Expect(0, 70112, '\p{Script=:\Asharada\z:}', "");;
    Expect(1, 70111, '\p{Script=_Sharada}', "");
    Expect(0, 70111, '\p{^Script=_Sharada}', "");
    Expect(0, 70111, '\P{Script=_Sharada}', "");
    Expect(1, 70111, '\P{^Script=_Sharada}', "");
    Expect(0, 70112, '\p{Script=_Sharada}', "");
    Expect(1, 70112, '\p{^Script=_Sharada}', "");
    Expect(1, 70112, '\P{Script=_Sharada}', "");
    Expect(0, 70112, '\P{^Script=_Sharada}', "");
    Error('\p{Sc=:=shrd}');
    Error('\P{Sc=:=shrd}');
    Expect(1, 70111, '\p{Sc=:\AShrd\z:}', "");;
    Expect(0, 70112, '\p{Sc=:\AShrd\z:}', "");;
    Expect(1, 70111, '\p{Sc=shrd}', "");
    Expect(0, 70111, '\p{^Sc=shrd}', "");
    Expect(0, 70111, '\P{Sc=shrd}', "");
    Expect(1, 70111, '\P{^Sc=shrd}', "");
    Expect(0, 70112, '\p{Sc=shrd}', "");
    Expect(1, 70112, '\p{^Sc=shrd}', "");
    Expect(1, 70112, '\P{Sc=shrd}', "");
    Expect(0, 70112, '\P{^Sc=shrd}', "");
    Expect(1, 70111, '\p{Sc=:\Ashrd\z:}', "");;
    Expect(0, 70112, '\p{Sc=:\Ashrd\z:}', "");;
    Expect(1, 70111, '\p{Sc= SHRD}', "");
    Expect(0, 70111, '\p{^Sc= SHRD}', "");
    Expect(0, 70111, '\P{Sc= SHRD}', "");
    Expect(1, 70111, '\P{^Sc= SHRD}', "");
    Expect(0, 70112, '\p{Sc= SHRD}', "");
    Expect(1, 70112, '\p{^Sc= SHRD}', "");
    Expect(1, 70112, '\P{Sc= SHRD}', "");
    Expect(0, 70112, '\P{^Sc= SHRD}', "");
    Error('\p{Is_Script=-/a/Sharada}');
    Error('\P{Is_Script=-/a/Sharada}');
    Expect(1, 70111, '\p{Is_Script=sharada}', "");
    Expect(0, 70111, '\p{^Is_Script=sharada}', "");
    Expect(0, 70111, '\P{Is_Script=sharada}', "");
    Expect(1, 70111, '\P{^Is_Script=sharada}', "");
    Expect(0, 70112, '\p{Is_Script=sharada}', "");
    Expect(1, 70112, '\p{^Is_Script=sharada}', "");
    Expect(1, 70112, '\P{Is_Script=sharada}', "");
    Expect(0, 70112, '\P{^Is_Script=sharada}', "");
    Expect(1, 70111, '\p{Is_Script=	_SHARADA}', "");
    Expect(0, 70111, '\p{^Is_Script=	_SHARADA}', "");
    Expect(0, 70111, '\P{Is_Script=	_SHARADA}', "");
    Expect(1, 70111, '\P{^Is_Script=	_SHARADA}', "");
    Expect(0, 70112, '\p{Is_Script=	_SHARADA}', "");
    Expect(1, 70112, '\p{^Is_Script=	_SHARADA}', "");
    Expect(1, 70112, '\P{Is_Script=	_SHARADA}', "");
    Expect(0, 70112, '\P{^Is_Script=	_SHARADA}', "");
    Error('\p{Is_Sc=:=-_SHRD}');
    Error('\P{Is_Sc=:=-_SHRD}');
    Expect(1, 70111, '\p{Is_Sc=shrd}', "");
    Expect(0, 70111, '\p{^Is_Sc=shrd}', "");
    Expect(0, 70111, '\P{Is_Sc=shrd}', "");
    Expect(1, 70111, '\P{^Is_Sc=shrd}', "");
    Expect(0, 70112, '\p{Is_Sc=shrd}', "");
    Expect(1, 70112, '\p{^Is_Sc=shrd}', "");
    Expect(1, 70112, '\P{Is_Sc=shrd}', "");
    Expect(0, 70112, '\P{^Is_Sc=shrd}', "");
    Expect(1, 70111, '\p{Is_Sc=		Shrd}', "");
    Expect(0, 70111, '\p{^Is_Sc=		Shrd}', "");
    Expect(0, 70111, '\P{Is_Sc=		Shrd}', "");
    Expect(1, 70111, '\P{^Is_Sc=		Shrd}', "");
    Expect(0, 70112, '\p{Is_Sc=		Shrd}', "");
    Expect(1, 70112, '\p{^Is_Sc=		Shrd}', "");
    Expect(1, 70112, '\P{Is_Sc=		Shrd}', "");
    Expect(0, 70112, '\P{^Is_Sc=		Shrd}', "");
    Error('\p{Script::= Siddham}');
    Error('\P{Script::= Siddham}');
    Expect(1, 71133, '\p{Script=:\ASiddham\z:}', "");;
    Expect(0, 71134, '\p{Script=:\ASiddham\z:}', "");;
    Expect(1, 71133, '\p{Script=siddham}', "");
    Expect(0, 71133, '\p{^Script=siddham}', "");
    Expect(0, 71133, '\P{Script=siddham}', "");
    Expect(1, 71133, '\P{^Script=siddham}', "");
    Expect(0, 71134, '\p{Script=siddham}', "");
    Expect(1, 71134, '\p{^Script=siddham}', "");
    Expect(1, 71134, '\P{Script=siddham}', "");
    Expect(0, 71134, '\P{^Script=siddham}', "");
    Expect(1, 71133, '\p{Script=:\Asiddham\z:}', "");;
    Expect(0, 71134, '\p{Script=:\Asiddham\z:}', "");;
    Expect(1, 71133, '\p{Script=	 SIDDHAM}', "");
    Expect(0, 71133, '\p{^Script=	 SIDDHAM}', "");
    Expect(0, 71133, '\P{Script=	 SIDDHAM}', "");
    Expect(1, 71133, '\P{^Script=	 SIDDHAM}', "");
    Expect(0, 71134, '\p{Script=	 SIDDHAM}', "");
    Expect(1, 71134, '\p{^Script=	 SIDDHAM}', "");
    Expect(1, 71134, '\P{Script=	 SIDDHAM}', "");
    Expect(0, 71134, '\P{^Script=	 SIDDHAM}', "");
    Error('\p{Sc=_/a/sidd}');
    Error('\P{Sc=_/a/sidd}');
    Expect(1, 71133, '\p{Sc=:\ASidd\z:}', "");;
    Expect(0, 71134, '\p{Sc=:\ASidd\z:}', "");;
    Expect(1, 71133, '\p{Sc=sidd}', "");
    Expect(0, 71133, '\p{^Sc=sidd}', "");
    Expect(0, 71133, '\P{Sc=sidd}', "");
    Expect(1, 71133, '\P{^Sc=sidd}', "");
    Expect(0, 71134, '\p{Sc=sidd}', "");
    Expect(1, 71134, '\p{^Sc=sidd}', "");
    Expect(1, 71134, '\P{Sc=sidd}', "");
    Expect(0, 71134, '\P{^Sc=sidd}', "");
    Expect(1, 71133, '\p{Sc=:\Asidd\z:}', "");;
    Expect(0, 71134, '\p{Sc=:\Asidd\z:}', "");;
    Expect(1, 71133, '\p{Sc=	sidd}', "");
    Expect(0, 71133, '\p{^Sc=	sidd}', "");
    Expect(0, 71133, '\P{Sc=	sidd}', "");
    Expect(1, 71133, '\P{^Sc=	sidd}', "");
    Expect(0, 71134, '\p{Sc=	sidd}', "");
    Expect(1, 71134, '\p{^Sc=	sidd}', "");
    Expect(1, 71134, '\P{Sc=	sidd}', "");
    Expect(0, 71134, '\P{^Sc=	sidd}', "");
    Error('\p{Is_Script=_/a/siddham}');
    Error('\P{Is_Script=_/a/siddham}');
    Expect(1, 71133, '\p{Is_Script=siddham}', "");
    Expect(0, 71133, '\p{^Is_Script=siddham}', "");
    Expect(0, 71133, '\P{Is_Script=siddham}', "");
    Expect(1, 71133, '\P{^Is_Script=siddham}', "");
    Expect(0, 71134, '\p{Is_Script=siddham}', "");
    Expect(1, 71134, '\p{^Is_Script=siddham}', "");
    Expect(1, 71134, '\P{Is_Script=siddham}', "");
    Expect(0, 71134, '\P{^Is_Script=siddham}', "");
    Expect(1, 71133, '\p{Is_Script=-_siddham}', "");
    Expect(0, 71133, '\p{^Is_Script=-_siddham}', "");
    Expect(0, 71133, '\P{Is_Script=-_siddham}', "");
    Expect(1, 71133, '\P{^Is_Script=-_siddham}', "");
    Expect(0, 71134, '\p{Is_Script=-_siddham}', "");
    Expect(1, 71134, '\p{^Is_Script=-_siddham}', "");
    Expect(1, 71134, '\P{Is_Script=-_siddham}', "");
    Expect(0, 71134, '\P{^Is_Script=-_siddham}', "");
    Error('\p{Is_Sc=/a/	 sidd}');
    Error('\P{Is_Sc=/a/	 sidd}');
    Expect(1, 71133, '\p{Is_Sc=sidd}', "");
    Expect(0, 71133, '\p{^Is_Sc=sidd}', "");
    Expect(0, 71133, '\P{Is_Sc=sidd}', "");
    Expect(1, 71133, '\P{^Is_Sc=sidd}', "");
    Expect(0, 71134, '\p{Is_Sc=sidd}', "");
    Expect(1, 71134, '\p{^Is_Sc=sidd}', "");
    Expect(1, 71134, '\P{Is_Sc=sidd}', "");
    Expect(0, 71134, '\P{^Is_Sc=sidd}', "");
    Expect(1, 71133, '\p{Is_Sc=Sidd}', "");
    Expect(0, 71133, '\p{^Is_Sc=Sidd}', "");
    Expect(0, 71133, '\P{Is_Sc=Sidd}', "");
    Expect(1, 71133, '\P{^Is_Sc=Sidd}', "");
    Expect(0, 71134, '\p{Is_Sc=Sidd}', "");
    Expect(1, 71134, '\p{^Is_Sc=Sidd}', "");
    Expect(1, 71134, '\P{Is_Sc=Sidd}', "");
    Expect(0, 71134, '\P{^Is_Sc=Sidd}', "");
    Error('\p{Script= -Khudawadi/a/}');
    Error('\P{Script= -Khudawadi/a/}');
    Expect(1, 70393, '\p{Script=:\AKhudawadi\z:}', "");;
    Expect(0, 70394, '\p{Script=:\AKhudawadi\z:}', "");;
    Expect(1, 70393, '\p{Script:   khudawadi}', "");
    Expect(0, 70393, '\p{^Script:   khudawadi}', "");
    Expect(0, 70393, '\P{Script:   khudawadi}', "");
    Expect(1, 70393, '\P{^Script:   khudawadi}', "");
    Expect(0, 70394, '\p{Script:   khudawadi}', "");
    Expect(1, 70394, '\p{^Script:   khudawadi}', "");
    Expect(1, 70394, '\P{Script:   khudawadi}', "");
    Expect(0, 70394, '\P{^Script:   khudawadi}', "");
    Expect(1, 70393, '\p{Script=:\Akhudawadi\z:}', "");;
    Expect(0, 70394, '\p{Script=:\Akhudawadi\z:}', "");;
    Expect(1, 70393, '\p{Script=	Khudawadi}', "");
    Expect(0, 70393, '\p{^Script=	Khudawadi}', "");
    Expect(0, 70393, '\P{Script=	Khudawadi}', "");
    Expect(1, 70393, '\P{^Script=	Khudawadi}', "");
    Expect(0, 70394, '\p{Script=	Khudawadi}', "");
    Expect(1, 70394, '\p{^Script=	Khudawadi}', "");
    Expect(1, 70394, '\P{Script=	Khudawadi}', "");
    Expect(0, 70394, '\P{^Script=	Khudawadi}', "");
    Error('\p{Sc:	_-sind:=}');
    Error('\P{Sc:	_-sind:=}');
    Expect(1, 70393, '\p{Sc=:\ASind\z:}', "");;
    Expect(0, 70394, '\p{Sc=:\ASind\z:}', "");;
    Expect(1, 70393, '\p{Sc=sind}', "");
    Expect(0, 70393, '\p{^Sc=sind}', "");
    Expect(0, 70393, '\P{Sc=sind}', "");
    Expect(1, 70393, '\P{^Sc=sind}', "");
    Expect(0, 70394, '\p{Sc=sind}', "");
    Expect(1, 70394, '\p{^Sc=sind}', "");
    Expect(1, 70394, '\P{Sc=sind}', "");
    Expect(0, 70394, '\P{^Sc=sind}', "");
    Expect(1, 70393, '\p{Sc=:\Asind\z:}', "");;
    Expect(0, 70394, '\p{Sc=:\Asind\z:}', "");;
    Expect(1, 70393, '\p{Sc=_sind}', "");
    Expect(0, 70393, '\p{^Sc=_sind}', "");
    Expect(0, 70393, '\P{Sc=_sind}', "");
    Expect(1, 70393, '\P{^Sc=_sind}', "");
    Expect(0, 70394, '\p{Sc=_sind}', "");
    Expect(1, 70394, '\p{^Sc=_sind}', "");
    Expect(1, 70394, '\P{Sc=_sind}', "");
    Expect(0, 70394, '\P{^Sc=_sind}', "");
    Error('\p{Is_Script=	KHUDAWADI:=}');
    Error('\P{Is_Script=	KHUDAWADI:=}');
    Expect(1, 70393, '\p{Is_Script=khudawadi}', "");
    Expect(0, 70393, '\p{^Is_Script=khudawadi}', "");
    Expect(0, 70393, '\P{Is_Script=khudawadi}', "");
    Expect(1, 70393, '\P{^Is_Script=khudawadi}', "");
    Expect(0, 70394, '\p{Is_Script=khudawadi}', "");
    Expect(1, 70394, '\p{^Is_Script=khudawadi}', "");
    Expect(1, 70394, '\P{Is_Script=khudawadi}', "");
    Expect(0, 70394, '\P{^Is_Script=khudawadi}', "");
    Expect(1, 70393, '\p{Is_Script=-	Khudawadi}', "");
    Expect(0, 70393, '\p{^Is_Script=-	Khudawadi}', "");
    Expect(0, 70393, '\P{Is_Script=-	Khudawadi}', "");
    Expect(1, 70393, '\P{^Is_Script=-	Khudawadi}', "");
    Expect(0, 70394, '\p{Is_Script=-	Khudawadi}', "");
    Expect(1, 70394, '\p{^Is_Script=-	Khudawadi}', "");
    Expect(1, 70394, '\P{Is_Script=-	Khudawadi}', "");
    Expect(0, 70394, '\P{^Is_Script=-	Khudawadi}', "");
    Error('\p{Is_Sc=-sind/a/}');
    Error('\P{Is_Sc=-sind/a/}');
    Expect(1, 70393, '\p{Is_Sc=sind}', "");
    Expect(0, 70393, '\p{^Is_Sc=sind}', "");
    Expect(0, 70393, '\P{Is_Sc=sind}', "");
    Expect(1, 70393, '\P{^Is_Sc=sind}', "");
    Expect(0, 70394, '\p{Is_Sc=sind}', "");
    Expect(1, 70394, '\p{^Is_Sc=sind}', "");
    Expect(1, 70394, '\P{Is_Sc=sind}', "");
    Expect(0, 70394, '\P{^Is_Sc=sind}', "");
    Expect(1, 70393, '\p{Is_Sc=_-Sind}', "");
    Expect(0, 70393, '\p{^Is_Sc=_-Sind}', "");
    Expect(0, 70393, '\P{Is_Sc=_-Sind}', "");
    Expect(1, 70393, '\P{^Is_Sc=_-Sind}', "");
    Expect(0, 70394, '\p{Is_Sc=_-Sind}', "");
    Expect(1, 70394, '\p{^Is_Sc=_-Sind}', "");
    Expect(1, 70394, '\P{Is_Sc=_-Sind}', "");
    Expect(0, 70394, '\P{^Is_Sc=_-Sind}', "");
    Error('\p{Script=	/a/Sinhala}');
    Error('\P{Script=	/a/Sinhala}');
    Expect(1, 70132, '\p{Script=:\ASinhala\z:}', "");;
    Expect(0, 70133, '\p{Script=:\ASinhala\z:}', "");;
    Expect(1, 70132, '\p{Script=sinhala}', "");
    Expect(0, 70132, '\p{^Script=sinhala}', "");
    Expect(0, 70132, '\P{Script=sinhala}', "");
    Expect(1, 70132, '\P{^Script=sinhala}', "");
    Expect(0, 70133, '\p{Script=sinhala}', "");
    Expect(1, 70133, '\p{^Script=sinhala}', "");
    Expect(1, 70133, '\P{Script=sinhala}', "");
    Expect(0, 70133, '\P{^Script=sinhala}', "");
    Expect(1, 70132, '\p{Script=:\Asinhala\z:}', "");;
    Expect(0, 70133, '\p{Script=:\Asinhala\z:}', "");;
    Expect(1, 70132, '\p{Script: sinhala}', "");
    Expect(0, 70132, '\p{^Script: sinhala}', "");
    Expect(0, 70132, '\P{Script: sinhala}', "");
    Expect(1, 70132, '\P{^Script: sinhala}', "");
    Expect(0, 70133, '\p{Script: sinhala}', "");
    Expect(1, 70133, '\p{^Script: sinhala}', "");
    Expect(1, 70133, '\P{Script: sinhala}', "");
    Expect(0, 70133, '\P{^Script: sinhala}', "");
    Error('\p{Sc=_	Sinh:=}');
    Error('\P{Sc=_	Sinh:=}');
    Expect(1, 70132, '\p{Sc=:\ASinh\z:}', "");;
    Expect(0, 70133, '\p{Sc=:\ASinh\z:}', "");;
    Expect(1, 70132, '\p{Sc=sinh}', "");
    Expect(0, 70132, '\p{^Sc=sinh}', "");
    Expect(0, 70132, '\P{Sc=sinh}', "");
    Expect(1, 70132, '\P{^Sc=sinh}', "");
    Expect(0, 70133, '\p{Sc=sinh}', "");
    Expect(1, 70133, '\p{^Sc=sinh}', "");
    Expect(1, 70133, '\P{Sc=sinh}', "");
    Expect(0, 70133, '\P{^Sc=sinh}', "");
    Expect(1, 70132, '\p{Sc=:\Asinh\z:}', "");;
    Expect(0, 70133, '\p{Sc=:\Asinh\z:}', "");;
    Expect(1, 70132, '\p{Sc=--Sinh}', "");
    Expect(0, 70132, '\p{^Sc=--Sinh}', "");
    Expect(0, 70132, '\P{Sc=--Sinh}', "");
    Expect(1, 70132, '\P{^Sc=--Sinh}', "");
    Expect(0, 70133, '\p{Sc=--Sinh}', "");
    Expect(1, 70133, '\p{^Sc=--Sinh}', "");
    Expect(1, 70133, '\P{Sc=--Sinh}', "");
    Expect(0, 70133, '\P{^Sc=--Sinh}', "");
    Error('\p{Is_Script=	SINHALA:=}');
    Error('\P{Is_Script=	SINHALA:=}');
    Expect(1, 70132, '\p{Is_Script=sinhala}', "");
    Expect(0, 70132, '\p{^Is_Script=sinhala}', "");
    Expect(0, 70132, '\P{Is_Script=sinhala}', "");
    Expect(1, 70132, '\P{^Is_Script=sinhala}', "");
    Expect(0, 70133, '\p{Is_Script=sinhala}', "");
    Expect(1, 70133, '\p{^Is_Script=sinhala}', "");
    Expect(1, 70133, '\P{Is_Script=sinhala}', "");
    Expect(0, 70133, '\P{^Is_Script=sinhala}', "");
    Expect(1, 70132, '\p{Is_Script= Sinhala}', "");
    Expect(0, 70132, '\p{^Is_Script= Sinhala}', "");
    Expect(0, 70132, '\P{Is_Script= Sinhala}', "");
    Expect(1, 70132, '\P{^Is_Script= Sinhala}', "");
    Expect(0, 70133, '\p{Is_Script= Sinhala}', "");
    Expect(1, 70133, '\p{^Is_Script= Sinhala}', "");
    Expect(1, 70133, '\P{Is_Script= Sinhala}', "");
    Expect(0, 70133, '\P{^Is_Script= Sinhala}', "");
    Error('\p{Is_Sc:   /a/--SINH}');
    Error('\P{Is_Sc:   /a/--SINH}');
    Expect(1, 70132, '\p{Is_Sc=sinh}', "");
    Expect(0, 70132, '\p{^Is_Sc=sinh}', "");
    Expect(0, 70132, '\P{Is_Sc=sinh}', "");
    Expect(1, 70132, '\P{^Is_Sc=sinh}', "");
    Expect(0, 70133, '\p{Is_Sc=sinh}', "");
    Expect(1, 70133, '\p{^Is_Sc=sinh}', "");
    Expect(1, 70133, '\P{Is_Sc=sinh}', "");
    Expect(0, 70133, '\P{^Is_Sc=sinh}', "");
    Expect(1, 70132, '\p{Is_Sc=_	Sinh}', "");
    Expect(0, 70132, '\p{^Is_Sc=_	Sinh}', "");
    Expect(0, 70132, '\P{Is_Sc=_	Sinh}', "");
    Expect(1, 70132, '\P{^Is_Sc=_	Sinh}', "");
    Expect(0, 70133, '\p{Is_Sc=_	Sinh}', "");
    Expect(1, 70133, '\p{^Is_Sc=_	Sinh}', "");
    Expect(1, 70133, '\P{Is_Sc=_	Sinh}', "");
    Expect(0, 70133, '\P{^Is_Sc=_	Sinh}', "");
    Error('\p{Script= 	sogdian/a/}');
    Error('\P{Script= 	sogdian/a/}');
    Expect(1, 69465, '\p{Script=:\ASogdian\z:}', "");;
    Expect(0, 69466, '\p{Script=:\ASogdian\z:}', "");;
    Expect(1, 69465, '\p{Script=sogdian}', "");
    Expect(0, 69465, '\p{^Script=sogdian}', "");
    Expect(0, 69465, '\P{Script=sogdian}', "");
    Expect(1, 69465, '\P{^Script=sogdian}', "");
    Expect(0, 69466, '\p{Script=sogdian}', "");
    Expect(1, 69466, '\p{^Script=sogdian}', "");
    Expect(1, 69466, '\P{Script=sogdian}', "");
    Expect(0, 69466, '\P{^Script=sogdian}', "");
    Expect(1, 69465, '\p{Script=:\Asogdian\z:}', "");;
    Expect(0, 69466, '\p{Script=:\Asogdian\z:}', "");;
    Expect(1, 69465, '\p{Script=- Sogdian}', "");
    Expect(0, 69465, '\p{^Script=- Sogdian}', "");
    Expect(0, 69465, '\P{Script=- Sogdian}', "");
    Expect(1, 69465, '\P{^Script=- Sogdian}', "");
    Expect(0, 69466, '\p{Script=- Sogdian}', "");
    Expect(1, 69466, '\p{^Script=- Sogdian}', "");
    Expect(1, 69466, '\P{Script=- Sogdian}', "");
    Expect(0, 69466, '\P{^Script=- Sogdian}', "");
    Error('\p{Sc=/a/_-SOGD}');
    Error('\P{Sc=/a/_-SOGD}');
    Expect(1, 69465, '\p{Sc=:\ASogd\z:}', "");;
    Expect(0, 69466, '\p{Sc=:\ASogd\z:}', "");;
    Expect(1, 69465, '\p{Sc=sogd}', "");
    Expect(0, 69465, '\p{^Sc=sogd}', "");
    Expect(0, 69465, '\P{Sc=sogd}', "");
    Expect(1, 69465, '\P{^Sc=sogd}', "");
    Expect(0, 69466, '\p{Sc=sogd}', "");
    Expect(1, 69466, '\p{^Sc=sogd}', "");
    Expect(1, 69466, '\P{Sc=sogd}', "");
    Expect(0, 69466, '\P{^Sc=sogd}', "");
    Expect(1, 69465, '\p{Sc=:\Asogd\z:}', "");;
    Expect(0, 69466, '\p{Sc=:\Asogd\z:}', "");;
    Expect(1, 69465, '\p{Sc=- Sogd}', "");
    Expect(0, 69465, '\p{^Sc=- Sogd}', "");
    Expect(0, 69465, '\P{Sc=- Sogd}', "");
    Expect(1, 69465, '\P{^Sc=- Sogd}', "");
    Expect(0, 69466, '\p{Sc=- Sogd}', "");
    Expect(1, 69466, '\p{^Sc=- Sogd}', "");
    Expect(1, 69466, '\P{Sc=- Sogd}', "");
    Expect(0, 69466, '\P{^Sc=- Sogd}', "");
    Error('\p{Is_Script: /a/	_Sogdian}');
    Error('\P{Is_Script: /a/	_Sogdian}');
    Expect(1, 69465, '\p{Is_Script=sogdian}', "");
    Expect(0, 69465, '\p{^Is_Script=sogdian}', "");
    Expect(0, 69465, '\P{Is_Script=sogdian}', "");
    Expect(1, 69465, '\P{^Is_Script=sogdian}', "");
    Expect(0, 69466, '\p{Is_Script=sogdian}', "");
    Expect(1, 69466, '\p{^Is_Script=sogdian}', "");
    Expect(1, 69466, '\P{Is_Script=sogdian}', "");
    Expect(0, 69466, '\P{^Is_Script=sogdian}', "");
    Expect(1, 69465, '\p{Is_Script=-Sogdian}', "");
    Expect(0, 69465, '\p{^Is_Script=-Sogdian}', "");
    Expect(0, 69465, '\P{Is_Script=-Sogdian}', "");
    Expect(1, 69465, '\P{^Is_Script=-Sogdian}', "");
    Expect(0, 69466, '\p{Is_Script=-Sogdian}', "");
    Expect(1, 69466, '\p{^Is_Script=-Sogdian}', "");
    Expect(1, 69466, '\P{Is_Script=-Sogdian}', "");
    Expect(0, 69466, '\P{^Is_Script=-Sogdian}', "");
    Error('\p{Is_Sc=-_Sogd:=}');
    Error('\P{Is_Sc=-_Sogd:=}');
    Expect(1, 69465, '\p{Is_Sc=sogd}', "");
    Expect(0, 69465, '\p{^Is_Sc=sogd}', "");
    Expect(0, 69465, '\P{Is_Sc=sogd}', "");
    Expect(1, 69465, '\P{^Is_Sc=sogd}', "");
    Expect(0, 69466, '\p{Is_Sc=sogd}', "");
    Expect(1, 69466, '\p{^Is_Sc=sogd}', "");
    Expect(1, 69466, '\P{Is_Sc=sogd}', "");
    Expect(0, 69466, '\P{^Is_Sc=sogd}', "");
    Expect(1, 69465, '\p{Is_Sc=	sogd}', "");
    Expect(0, 69465, '\p{^Is_Sc=	sogd}', "");
    Expect(0, 69465, '\P{Is_Sc=	sogd}', "");
    Expect(1, 69465, '\P{^Is_Sc=	sogd}', "");
    Expect(0, 69466, '\p{Is_Sc=	sogd}', "");
    Expect(1, 69466, '\p{^Is_Sc=	sogd}', "");
    Expect(1, 69466, '\P{Is_Sc=	sogd}', "");
    Expect(0, 69466, '\P{^Is_Sc=	sogd}', "");
    Error('\p{Script=	OLD_sogdian:=}');
    Error('\P{Script=	OLD_sogdian:=}');
    Expect(1, 69415, '\p{Script=:\AOld_Sogdian\z:}', "");;
    Expect(0, 69416, '\p{Script=:\AOld_Sogdian\z:}', "");;
    Expect(1, 69415, '\p{Script=oldsogdian}', "");
    Expect(0, 69415, '\p{^Script=oldsogdian}', "");
    Expect(0, 69415, '\P{Script=oldsogdian}', "");
    Expect(1, 69415, '\P{^Script=oldsogdian}', "");
    Expect(0, 69416, '\p{Script=oldsogdian}', "");
    Expect(1, 69416, '\p{^Script=oldsogdian}', "");
    Expect(1, 69416, '\P{Script=oldsogdian}', "");
    Expect(0, 69416, '\P{^Script=oldsogdian}', "");
    Expect(1, 69415, '\p{Script=:\Aoldsogdian\z:}', "");;
    Expect(0, 69416, '\p{Script=:\Aoldsogdian\z:}', "");;
    Expect(1, 69415, '\p{Script=__Old_sogdian}', "");
    Expect(0, 69415, '\p{^Script=__Old_sogdian}', "");
    Expect(0, 69415, '\P{Script=__Old_sogdian}', "");
    Expect(1, 69415, '\P{^Script=__Old_sogdian}', "");
    Expect(0, 69416, '\p{Script=__Old_sogdian}', "");
    Expect(1, 69416, '\p{^Script=__Old_sogdian}', "");
    Expect(1, 69416, '\P{Script=__Old_sogdian}', "");
    Expect(0, 69416, '\P{^Script=__Old_sogdian}', "");
    Error('\p{Sc= /a/Sogo}');
    Error('\P{Sc= /a/Sogo}');
    Expect(1, 69415, '\p{Sc=:\ASogo\z:}', "");;
    Expect(0, 69416, '\p{Sc=:\ASogo\z:}', "");;
    Expect(1, 69415, '\p{Sc=sogo}', "");
    Expect(0, 69415, '\p{^Sc=sogo}', "");
    Expect(0, 69415, '\P{Sc=sogo}', "");
    Expect(1, 69415, '\P{^Sc=sogo}', "");
    Expect(0, 69416, '\p{Sc=sogo}', "");
    Expect(1, 69416, '\p{^Sc=sogo}', "");
    Expect(1, 69416, '\P{Sc=sogo}', "");
    Expect(0, 69416, '\P{^Sc=sogo}', "");
    Expect(1, 69415, '\p{Sc=:\Asogo\z:}', "");;
    Expect(0, 69416, '\p{Sc=:\Asogo\z:}', "");;
    Expect(1, 69415, '\p{Sc=	-sogo}', "");
    Expect(0, 69415, '\p{^Sc=	-sogo}', "");
    Expect(0, 69415, '\P{Sc=	-sogo}', "");
    Expect(1, 69415, '\P{^Sc=	-sogo}', "");
    Expect(0, 69416, '\p{Sc=	-sogo}', "");
    Expect(1, 69416, '\p{^Sc=	-sogo}', "");
    Expect(1, 69416, '\P{Sc=	-sogo}', "");
    Expect(0, 69416, '\P{^Sc=	-sogo}', "");
    Error('\p{Is_Script=_Old_sogdian/a/}');
    Error('\P{Is_Script=_Old_sogdian/a/}');
    Expect(1, 69415, '\p{Is_Script=oldsogdian}', "");
    Expect(0, 69415, '\p{^Is_Script=oldsogdian}', "");
    Expect(0, 69415, '\P{Is_Script=oldsogdian}', "");
    Expect(1, 69415, '\P{^Is_Script=oldsogdian}', "");
    Expect(0, 69416, '\p{Is_Script=oldsogdian}', "");
    Expect(1, 69416, '\p{^Is_Script=oldsogdian}', "");
    Expect(1, 69416, '\P{Is_Script=oldsogdian}', "");
    Expect(0, 69416, '\P{^Is_Script=oldsogdian}', "");
    Expect(1, 69415, '\p{Is_Script=-Old_Sogdian}', "");
    Expect(0, 69415, '\p{^Is_Script=-Old_Sogdian}', "");
    Expect(0, 69415, '\P{Is_Script=-Old_Sogdian}', "");
    Expect(1, 69415, '\P{^Is_Script=-Old_Sogdian}', "");
    Expect(0, 69416, '\p{Is_Script=-Old_Sogdian}', "");
    Expect(1, 69416, '\p{^Is_Script=-Old_Sogdian}', "");
    Expect(1, 69416, '\P{Is_Script=-Old_Sogdian}', "");
    Expect(0, 69416, '\P{^Is_Script=-Old_Sogdian}', "");
    Error('\p{Is_Sc=/a/ sogo}');
    Error('\P{Is_Sc=/a/ sogo}');
    Expect(1, 69415, '\p{Is_Sc=sogo}', "");
    Expect(0, 69415, '\p{^Is_Sc=sogo}', "");
    Expect(0, 69415, '\P{Is_Sc=sogo}', "");
    Expect(1, 69415, '\P{^Is_Sc=sogo}', "");
    Expect(0, 69416, '\p{Is_Sc=sogo}', "");
    Expect(1, 69416, '\p{^Is_Sc=sogo}', "");
    Expect(1, 69416, '\P{Is_Sc=sogo}', "");
    Expect(0, 69416, '\P{^Is_Sc=sogo}', "");
    Expect(1, 69415, '\p{Is_Sc:  Sogo}', "");
    Expect(0, 69415, '\p{^Is_Sc:  Sogo}', "");
    Expect(0, 69415, '\P{Is_Sc:  Sogo}', "");
    Expect(1, 69415, '\P{^Is_Sc:  Sogo}', "");
    Expect(0, 69416, '\p{Is_Sc:  Sogo}', "");
    Expect(1, 69416, '\p{^Is_Sc:  Sogo}', "");
    Expect(1, 69416, '\P{Is_Sc:  Sogo}', "");
    Expect(0, 69416, '\P{^Is_Sc:  Sogo}', "");
    Error('\p{Script=--SORA_Sompeng/a/}');
    Error('\P{Script=--SORA_Sompeng/a/}');
    Expect(1, 69881, '\p{Script=:\ASora_Sompeng\z:}', "");;
    Expect(0, 69882, '\p{Script=:\ASora_Sompeng\z:}', "");;
    Expect(1, 69881, '\p{Script=sorasompeng}', "");
    Expect(0, 69881, '\p{^Script=sorasompeng}', "");
    Expect(0, 69881, '\P{Script=sorasompeng}', "");
    Expect(1, 69881, '\P{^Script=sorasompeng}', "");
    Expect(0, 69882, '\p{Script=sorasompeng}', "");
    Expect(1, 69882, '\p{^Script=sorasompeng}', "");
    Expect(1, 69882, '\P{Script=sorasompeng}', "");
    Expect(0, 69882, '\P{^Script=sorasompeng}', "");
    Expect(1, 69881, '\p{Script=:\Asorasompeng\z:}', "");;
    Expect(0, 69882, '\p{Script=:\Asorasompeng\z:}', "");;
    Expect(1, 69881, '\p{Script= sora_sompeng}', "");
    Expect(0, 69881, '\p{^Script= sora_sompeng}', "");
    Expect(0, 69881, '\P{Script= sora_sompeng}', "");
    Expect(1, 69881, '\P{^Script= sora_sompeng}', "");
    Expect(0, 69882, '\p{Script= sora_sompeng}', "");
    Expect(1, 69882, '\p{^Script= sora_sompeng}', "");
    Expect(1, 69882, '\P{Script= sora_sompeng}', "");
    Expect(0, 69882, '\P{^Script= sora_sompeng}', "");
    Error('\p{Sc=	:=sora}');
    Error('\P{Sc=	:=sora}');
    Expect(1, 69881, '\p{Sc=:\ASora\z:}', "");;
    Expect(0, 69882, '\p{Sc=:\ASora\z:}', "");;
    Expect(1, 69881, '\p{Sc=sora}', "");
    Expect(0, 69881, '\p{^Sc=sora}', "");
    Expect(0, 69881, '\P{Sc=sora}', "");
    Expect(1, 69881, '\P{^Sc=sora}', "");
    Expect(0, 69882, '\p{Sc=sora}', "");
    Expect(1, 69882, '\p{^Sc=sora}', "");
    Expect(1, 69882, '\P{Sc=sora}', "");
    Expect(0, 69882, '\P{^Sc=sora}', "");
    Expect(1, 69881, '\p{Sc=:\Asora\z:}', "");;
    Expect(0, 69882, '\p{Sc=:\Asora\z:}', "");;
    Expect(1, 69881, '\p{Sc=  Sora}', "");
    Expect(0, 69881, '\p{^Sc=  Sora}', "");
    Expect(0, 69881, '\P{Sc=  Sora}', "");
    Expect(1, 69881, '\P{^Sc=  Sora}', "");
    Expect(0, 69882, '\p{Sc=  Sora}', "");
    Expect(1, 69882, '\p{^Sc=  Sora}', "");
    Expect(1, 69882, '\P{Sc=  Sora}', "");
    Expect(0, 69882, '\P{^Sc=  Sora}', "");
    Error('\p{Is_Script=:= -SORA_SOMPENG}');
    Error('\P{Is_Script=:= -SORA_SOMPENG}');
    Expect(1, 69881, '\p{Is_Script=sorasompeng}', "");
    Expect(0, 69881, '\p{^Is_Script=sorasompeng}', "");
    Expect(0, 69881, '\P{Is_Script=sorasompeng}', "");
    Expect(1, 69881, '\P{^Is_Script=sorasompeng}', "");
    Expect(0, 69882, '\p{Is_Script=sorasompeng}', "");
    Expect(1, 69882, '\p{^Is_Script=sorasompeng}', "");
    Expect(1, 69882, '\P{Is_Script=sorasompeng}', "");
    Expect(0, 69882, '\P{^Is_Script=sorasompeng}', "");
    Expect(1, 69881, '\p{Is_Script=_	SORA_Sompeng}', "");
    Expect(0, 69881, '\p{^Is_Script=_	SORA_Sompeng}', "");
    Expect(0, 69881, '\P{Is_Script=_	SORA_Sompeng}', "");
    Expect(1, 69881, '\P{^Is_Script=_	SORA_Sompeng}', "");
    Expect(0, 69882, '\p{Is_Script=_	SORA_Sompeng}', "");
    Expect(1, 69882, '\p{^Is_Script=_	SORA_Sompeng}', "");
    Expect(1, 69882, '\P{Is_Script=_	SORA_Sompeng}', "");
    Expect(0, 69882, '\P{^Is_Script=_	SORA_Sompeng}', "");
    Error('\p{Is_Sc:   		sora/a/}');
    Error('\P{Is_Sc:   		sora/a/}');
    Expect(1, 69881, '\p{Is_Sc=sora}', "");
    Expect(0, 69881, '\p{^Is_Sc=sora}', "");
    Expect(0, 69881, '\P{Is_Sc=sora}', "");
    Expect(1, 69881, '\P{^Is_Sc=sora}', "");
    Expect(0, 69882, '\p{Is_Sc=sora}', "");
    Expect(1, 69882, '\p{^Is_Sc=sora}', "");
    Expect(1, 69882, '\P{Is_Sc=sora}', "");
    Expect(0, 69882, '\P{^Is_Sc=sora}', "");
    Expect(1, 69881, '\p{Is_Sc=  sora}', "");
    Expect(0, 69881, '\p{^Is_Sc=  sora}', "");
    Expect(0, 69881, '\P{Is_Sc=  sora}', "");
    Expect(1, 69881, '\P{^Is_Sc=  sora}', "");
    Expect(0, 69882, '\p{Is_Sc=  sora}', "");
    Expect(1, 69882, '\p{^Is_Sc=  sora}', "");
    Expect(1, 69882, '\P{Is_Sc=  sora}', "");
    Expect(0, 69882, '\P{^Is_Sc=  sora}', "");
    Error('\p{Script=- Soyombo/a/}');
    Error('\P{Script=- Soyombo/a/}');
    Expect(1, 72354, '\p{Script=:\ASoyombo\z:}', "");;
    Expect(0, 72355, '\p{Script=:\ASoyombo\z:}', "");;
    Expect(1, 72354, '\p{Script=soyombo}', "");
    Expect(0, 72354, '\p{^Script=soyombo}', "");
    Expect(0, 72354, '\P{Script=soyombo}', "");
    Expect(1, 72354, '\P{^Script=soyombo}', "");
    Expect(0, 72355, '\p{Script=soyombo}', "");
    Expect(1, 72355, '\p{^Script=soyombo}', "");
    Expect(1, 72355, '\P{Script=soyombo}', "");
    Expect(0, 72355, '\P{^Script=soyombo}', "");
    Expect(1, 72354, '\p{Script=:\Asoyombo\z:}', "");;
    Expect(0, 72355, '\p{Script=:\Asoyombo\z:}', "");;
    Expect(1, 72354, '\p{Script=  Soyombo}', "");
    Expect(0, 72354, '\p{^Script=  Soyombo}', "");
    Expect(0, 72354, '\P{Script=  Soyombo}', "");
    Expect(1, 72354, '\P{^Script=  Soyombo}', "");
    Expect(0, 72355, '\p{Script=  Soyombo}', "");
    Expect(1, 72355, '\p{^Script=  Soyombo}', "");
    Expect(1, 72355, '\P{Script=  Soyombo}', "");
    Expect(0, 72355, '\P{^Script=  Soyombo}', "");
    Error('\p{Sc=/a/_	Soyo}');
    Error('\P{Sc=/a/_	Soyo}');
    Expect(1, 72354, '\p{Sc=:\ASoyo\z:}', "");;
    Expect(0, 72355, '\p{Sc=:\ASoyo\z:}', "");;
    Expect(1, 72354, '\p{Sc=soyo}', "");
    Expect(0, 72354, '\p{^Sc=soyo}', "");
    Expect(0, 72354, '\P{Sc=soyo}', "");
    Expect(1, 72354, '\P{^Sc=soyo}', "");
    Expect(0, 72355, '\p{Sc=soyo}', "");
    Expect(1, 72355, '\p{^Sc=soyo}', "");
    Expect(1, 72355, '\P{Sc=soyo}', "");
    Expect(0, 72355, '\P{^Sc=soyo}', "");
    Expect(1, 72354, '\p{Sc=:\Asoyo\z:}', "");;
    Expect(0, 72355, '\p{Sc=:\Asoyo\z:}', "");;
    Expect(1, 72354, '\p{Sc=-_SOYO}', "");
    Expect(0, 72354, '\p{^Sc=-_SOYO}', "");
    Expect(0, 72354, '\P{Sc=-_SOYO}', "");
    Expect(1, 72354, '\P{^Sc=-_SOYO}', "");
    Expect(0, 72355, '\p{Sc=-_SOYO}', "");
    Expect(1, 72355, '\p{^Sc=-_SOYO}', "");
    Expect(1, 72355, '\P{Sc=-_SOYO}', "");
    Expect(0, 72355, '\P{^Sc=-_SOYO}', "");
    Error('\p{Is_Script=	/a/SOYOMBO}');
    Error('\P{Is_Script=	/a/SOYOMBO}');
    Expect(1, 72354, '\p{Is_Script=soyombo}', "");
    Expect(0, 72354, '\p{^Is_Script=soyombo}', "");
    Expect(0, 72354, '\P{Is_Script=soyombo}', "");
    Expect(1, 72354, '\P{^Is_Script=soyombo}', "");
    Expect(0, 72355, '\p{Is_Script=soyombo}', "");
    Expect(1, 72355, '\p{^Is_Script=soyombo}', "");
    Expect(1, 72355, '\P{Is_Script=soyombo}', "");
    Expect(0, 72355, '\P{^Is_Script=soyombo}', "");
    Expect(1, 72354, '\p{Is_Script=- soyombo}', "");
    Expect(0, 72354, '\p{^Is_Script=- soyombo}', "");
    Expect(0, 72354, '\P{Is_Script=- soyombo}', "");
    Expect(1, 72354, '\P{^Is_Script=- soyombo}', "");
    Expect(0, 72355, '\p{Is_Script=- soyombo}', "");
    Expect(1, 72355, '\p{^Is_Script=- soyombo}', "");
    Expect(1, 72355, '\P{Is_Script=- soyombo}', "");
    Expect(0, 72355, '\P{^Is_Script=- soyombo}', "");
    Error('\p{Is_Sc: 	SOYO/a/}');
    Error('\P{Is_Sc: 	SOYO/a/}');
    Expect(1, 72354, '\p{Is_Sc=soyo}', "");
    Expect(0, 72354, '\p{^Is_Sc=soyo}', "");
    Expect(0, 72354, '\P{Is_Sc=soyo}', "");
    Expect(1, 72354, '\P{^Is_Sc=soyo}', "");
    Expect(0, 72355, '\p{Is_Sc=soyo}', "");
    Expect(1, 72355, '\p{^Is_Sc=soyo}', "");
    Expect(1, 72355, '\P{Is_Sc=soyo}', "");
    Expect(0, 72355, '\P{^Is_Sc=soyo}', "");
    Expect(1, 72354, '\p{Is_Sc= 	SOYO}', "");
    Expect(0, 72354, '\p{^Is_Sc= 	SOYO}', "");
    Expect(0, 72354, '\P{Is_Sc= 	SOYO}', "");
    Expect(1, 72354, '\P{^Is_Sc= 	SOYO}', "");
    Expect(0, 72355, '\p{Is_Sc= 	SOYO}', "");
    Expect(1, 72355, '\p{^Is_Sc= 	SOYO}', "");
    Expect(1, 72355, '\P{Is_Sc= 	SOYO}', "");
    Expect(0, 72355, '\P{^Is_Sc= 	SOYO}', "");
    Error('\p{Script=_Sundanese/a/}');
    Error('\P{Script=_Sundanese/a/}');
    Expect(1, 7367, '\p{Script=:\ASundanese\z:}', "");;
    Expect(0, 7368, '\p{Script=:\ASundanese\z:}', "");;
    Expect(1, 7367, '\p{Script=sundanese}', "");
    Expect(0, 7367, '\p{^Script=sundanese}', "");
    Expect(0, 7367, '\P{Script=sundanese}', "");
    Expect(1, 7367, '\P{^Script=sundanese}', "");
    Expect(0, 7368, '\p{Script=sundanese}', "");
    Expect(1, 7368, '\p{^Script=sundanese}', "");
    Expect(1, 7368, '\P{Script=sundanese}', "");
    Expect(0, 7368, '\P{^Script=sundanese}', "");
    Expect(1, 7367, '\p{Script=:\Asundanese\z:}', "");;
    Expect(0, 7368, '\p{Script=:\Asundanese\z:}', "");;
    Expect(1, 7367, '\p{Script=-Sundanese}', "");
    Expect(0, 7367, '\p{^Script=-Sundanese}', "");
    Expect(0, 7367, '\P{Script=-Sundanese}', "");
    Expect(1, 7367, '\P{^Script=-Sundanese}', "");
    Expect(0, 7368, '\p{Script=-Sundanese}', "");
    Expect(1, 7368, '\p{^Script=-Sundanese}', "");
    Expect(1, 7368, '\P{Script=-Sundanese}', "");
    Expect(0, 7368, '\P{^Script=-Sundanese}', "");
    Error('\p{Sc=	/a/SUND}');
    Error('\P{Sc=	/a/SUND}');
    Expect(1, 7367, '\p{Sc=:\ASund\z:}', "");;
    Expect(0, 7368, '\p{Sc=:\ASund\z:}', "");;
    Expect(1, 7367, '\p{Sc=sund}', "");
    Expect(0, 7367, '\p{^Sc=sund}', "");
    Expect(0, 7367, '\P{Sc=sund}', "");
    Expect(1, 7367, '\P{^Sc=sund}', "");
    Expect(0, 7368, '\p{Sc=sund}', "");
    Expect(1, 7368, '\p{^Sc=sund}', "");
    Expect(1, 7368, '\P{Sc=sund}', "");
    Expect(0, 7368, '\P{^Sc=sund}', "");
    Expect(1, 7367, '\p{Sc=:\Asund\z:}', "");;
    Expect(0, 7368, '\p{Sc=:\Asund\z:}', "");;
    Expect(1, 7367, '\p{Sc=	-SUND}', "");
    Expect(0, 7367, '\p{^Sc=	-SUND}', "");
    Expect(0, 7367, '\P{Sc=	-SUND}', "");
    Expect(1, 7367, '\P{^Sc=	-SUND}', "");
    Expect(0, 7368, '\p{Sc=	-SUND}', "");
    Expect(1, 7368, '\p{^Sc=	-SUND}', "");
    Expect(1, 7368, '\P{Sc=	-SUND}', "");
    Expect(0, 7368, '\P{^Sc=	-SUND}', "");
    Error('\p{Is_Script=	 SUNDANESE:=}');
    Error('\P{Is_Script=	 SUNDANESE:=}');
    Expect(1, 7367, '\p{Is_Script=sundanese}', "");
    Expect(0, 7367, '\p{^Is_Script=sundanese}', "");
    Expect(0, 7367, '\P{Is_Script=sundanese}', "");
    Expect(1, 7367, '\P{^Is_Script=sundanese}', "");
    Expect(0, 7368, '\p{Is_Script=sundanese}', "");
    Expect(1, 7368, '\p{^Is_Script=sundanese}', "");
    Expect(1, 7368, '\P{Is_Script=sundanese}', "");
    Expect(0, 7368, '\P{^Is_Script=sundanese}', "");
    Expect(1, 7367, '\p{Is_Script=		Sundanese}', "");
    Expect(0, 7367, '\p{^Is_Script=		Sundanese}', "");
    Expect(0, 7367, '\P{Is_Script=		Sundanese}', "");
    Expect(1, 7367, '\P{^Is_Script=		Sundanese}', "");
    Expect(0, 7368, '\p{Is_Script=		Sundanese}', "");
    Expect(1, 7368, '\p{^Is_Script=		Sundanese}', "");
    Expect(1, 7368, '\P{Is_Script=		Sundanese}', "");
    Expect(0, 7368, '\P{^Is_Script=		Sundanese}', "");
    Error('\p{Is_Sc=:=SUND}');
    Error('\P{Is_Sc=:=SUND}');
    Expect(1, 7367, '\p{Is_Sc=sund}', "");
    Expect(0, 7367, '\p{^Is_Sc=sund}', "");
    Expect(0, 7367, '\P{Is_Sc=sund}', "");
    Expect(1, 7367, '\P{^Is_Sc=sund}', "");
    Expect(0, 7368, '\p{Is_Sc=sund}', "");
    Expect(1, 7368, '\p{^Is_Sc=sund}', "");
    Expect(1, 7368, '\P{Is_Sc=sund}', "");
    Expect(0, 7368, '\P{^Is_Sc=sund}', "");
    Expect(1, 7367, '\p{Is_Sc=	 SUND}', "");
    Expect(0, 7367, '\p{^Is_Sc=	 SUND}', "");
    Expect(0, 7367, '\P{Is_Sc=	 SUND}', "");
    Expect(1, 7367, '\P{^Is_Sc=	 SUND}', "");
    Expect(0, 7368, '\p{Is_Sc=	 SUND}', "");
    Expect(1, 7368, '\p{^Is_Sc=	 SUND}', "");
    Expect(1, 7368, '\P{Is_Sc=	 SUND}', "");
    Expect(0, 7368, '\P{^Is_Sc=	 SUND}', "");
    Error('\p{Script=-	Syloti_nagri:=}');
    Error('\P{Script=-	Syloti_nagri:=}');
    Expect(1, 43051, '\p{Script=:\ASyloti_Nagri\z:}', "");;
    Expect(0, 43052, '\p{Script=:\ASyloti_Nagri\z:}', "");;
    Expect(1, 43051, '\p{Script=sylotinagri}', "");
    Expect(0, 43051, '\p{^Script=sylotinagri}', "");
    Expect(0, 43051, '\P{Script=sylotinagri}', "");
    Expect(1, 43051, '\P{^Script=sylotinagri}', "");
    Expect(0, 43052, '\p{Script=sylotinagri}', "");
    Expect(1, 43052, '\p{^Script=sylotinagri}', "");
    Expect(1, 43052, '\P{Script=sylotinagri}', "");
    Expect(0, 43052, '\P{^Script=sylotinagri}', "");
    Expect(1, 43051, '\p{Script=:\Asylotinagri\z:}', "");;
    Expect(0, 43052, '\p{Script=:\Asylotinagri\z:}', "");;
    Expect(1, 43051, '\p{Script= 	syloti_NAGRI}', "");
    Expect(0, 43051, '\p{^Script= 	syloti_NAGRI}', "");
    Expect(0, 43051, '\P{Script= 	syloti_NAGRI}', "");
    Expect(1, 43051, '\P{^Script= 	syloti_NAGRI}', "");
    Expect(0, 43052, '\p{Script= 	syloti_NAGRI}', "");
    Expect(1, 43052, '\p{^Script= 	syloti_NAGRI}', "");
    Expect(1, 43052, '\P{Script= 	syloti_NAGRI}', "");
    Expect(0, 43052, '\P{^Script= 	syloti_NAGRI}', "");
    Error('\p{Sc=:=SYLO}');
    Error('\P{Sc=:=SYLO}');
    Expect(1, 43051, '\p{Sc=:\ASylo\z:}', "");;
    Expect(0, 43052, '\p{Sc=:\ASylo\z:}', "");;
    Expect(1, 43051, '\p{Sc:   sylo}', "");
    Expect(0, 43051, '\p{^Sc:   sylo}', "");
    Expect(0, 43051, '\P{Sc:   sylo}', "");
    Expect(1, 43051, '\P{^Sc:   sylo}', "");
    Expect(0, 43052, '\p{Sc:   sylo}', "");
    Expect(1, 43052, '\p{^Sc:   sylo}', "");
    Expect(1, 43052, '\P{Sc:   sylo}', "");
    Expect(0, 43052, '\P{^Sc:   sylo}', "");
    Expect(1, 43051, '\p{Sc=:\Asylo\z:}', "");;
    Expect(0, 43052, '\p{Sc=:\Asylo\z:}', "");;
    Expect(1, 43051, '\p{Sc=-_sylo}', "");
    Expect(0, 43051, '\p{^Sc=-_sylo}', "");
    Expect(0, 43051, '\P{Sc=-_sylo}', "");
    Expect(1, 43051, '\P{^Sc=-_sylo}', "");
    Expect(0, 43052, '\p{Sc=-_sylo}', "");
    Expect(1, 43052, '\p{^Sc=-_sylo}', "");
    Expect(1, 43052, '\P{Sc=-_sylo}', "");
    Expect(0, 43052, '\P{^Sc=-_sylo}', "");
    Error('\p{Is_Script=/a/--Syloti_Nagri}');
    Error('\P{Is_Script=/a/--Syloti_Nagri}');
    Expect(1, 43051, '\p{Is_Script:   sylotinagri}', "");
    Expect(0, 43051, '\p{^Is_Script:   sylotinagri}', "");
    Expect(0, 43051, '\P{Is_Script:   sylotinagri}', "");
    Expect(1, 43051, '\P{^Is_Script:   sylotinagri}', "");
    Expect(0, 43052, '\p{Is_Script:   sylotinagri}', "");
    Expect(1, 43052, '\p{^Is_Script:   sylotinagri}', "");
    Expect(1, 43052, '\P{Is_Script:   sylotinagri}', "");
    Expect(0, 43052, '\P{^Is_Script:   sylotinagri}', "");
    Expect(1, 43051, '\p{Is_Script=	 Syloti_Nagri}', "");
    Expect(0, 43051, '\p{^Is_Script=	 Syloti_Nagri}', "");
    Expect(0, 43051, '\P{Is_Script=	 Syloti_Nagri}', "");
    Expect(1, 43051, '\P{^Is_Script=	 Syloti_Nagri}', "");
    Expect(0, 43052, '\p{Is_Script=	 Syloti_Nagri}', "");
    Expect(1, 43052, '\p{^Is_Script=	 Syloti_Nagri}', "");
    Expect(1, 43052, '\P{Is_Script=	 Syloti_Nagri}', "");
    Expect(0, 43052, '\P{^Is_Script=	 Syloti_Nagri}', "");
    Error('\p{Is_Sc=/a/-Sylo}');
    Error('\P{Is_Sc=/a/-Sylo}');
    Expect(1, 43051, '\p{Is_Sc=sylo}', "");
    Expect(0, 43051, '\p{^Is_Sc=sylo}', "");
    Expect(0, 43051, '\P{Is_Sc=sylo}', "");
    Expect(1, 43051, '\P{^Is_Sc=sylo}', "");
    Expect(0, 43052, '\p{Is_Sc=sylo}', "");
    Expect(1, 43052, '\p{^Is_Sc=sylo}', "");
    Expect(1, 43052, '\P{Is_Sc=sylo}', "");
    Expect(0, 43052, '\P{^Is_Sc=sylo}', "");
    Expect(1, 43051, '\p{Is_Sc= SYLO}', "");
    Expect(0, 43051, '\p{^Is_Sc= SYLO}', "");
    Expect(0, 43051, '\P{Is_Sc= SYLO}', "");
    Expect(1, 43051, '\P{^Is_Sc= SYLO}', "");
    Expect(0, 43052, '\p{Is_Sc= SYLO}', "");
    Expect(1, 43052, '\p{^Is_Sc= SYLO}', "");
    Expect(1, 43052, '\P{Is_Sc= SYLO}', "");
    Expect(0, 43052, '\P{^Is_Sc= SYLO}', "");
    Error('\p{Script=_ syriac/a/}');
    Error('\P{Script=_ syriac/a/}');
    Expect(1, 2154, '\p{Script=:\ASyriac\z:}', "");;
    Expect(0, 2155, '\p{Script=:\ASyriac\z:}', "");;
    Expect(1, 2154, '\p{Script=syriac}', "");
    Expect(0, 2154, '\p{^Script=syriac}', "");
    Expect(0, 2154, '\P{Script=syriac}', "");
    Expect(1, 2154, '\P{^Script=syriac}', "");
    Expect(0, 2155, '\p{Script=syriac}', "");
    Expect(1, 2155, '\p{^Script=syriac}', "");
    Expect(1, 2155, '\P{Script=syriac}', "");
    Expect(0, 2155, '\P{^Script=syriac}', "");
    Expect(1, 2154, '\p{Script=:\Asyriac\z:}', "");;
    Expect(0, 2155, '\p{Script=:\Asyriac\z:}', "");;
    Expect(1, 2154, '\p{Script=_-SYRIAC}', "");
    Expect(0, 2154, '\p{^Script=_-SYRIAC}', "");
    Expect(0, 2154, '\P{Script=_-SYRIAC}', "");
    Expect(1, 2154, '\P{^Script=_-SYRIAC}', "");
    Expect(0, 2155, '\p{Script=_-SYRIAC}', "");
    Expect(1, 2155, '\p{^Script=_-SYRIAC}', "");
    Expect(1, 2155, '\P{Script=_-SYRIAC}', "");
    Expect(0, 2155, '\P{^Script=_-SYRIAC}', "");
    Error('\p{Sc=:=	SYRC}');
    Error('\P{Sc=:=	SYRC}');
    Expect(1, 2154, '\p{Sc=:\ASyrc\z:}', "");;
    Expect(0, 2155, '\p{Sc=:\ASyrc\z:}', "");;
    Expect(1, 2154, '\p{Sc=syrc}', "");
    Expect(0, 2154, '\p{^Sc=syrc}', "");
    Expect(0, 2154, '\P{Sc=syrc}', "");
    Expect(1, 2154, '\P{^Sc=syrc}', "");
    Expect(0, 2155, '\p{Sc=syrc}', "");
    Expect(1, 2155, '\p{^Sc=syrc}', "");
    Expect(1, 2155, '\P{Sc=syrc}', "");
    Expect(0, 2155, '\P{^Sc=syrc}', "");
    Expect(1, 2154, '\p{Sc=:\Asyrc\z:}', "");;
    Expect(0, 2155, '\p{Sc=:\Asyrc\z:}', "");;
    Expect(1, 2154, '\p{Sc=- SYRC}', "");
    Expect(0, 2154, '\p{^Sc=- SYRC}', "");
    Expect(0, 2154, '\P{Sc=- SYRC}', "");
    Expect(1, 2154, '\P{^Sc=- SYRC}', "");
    Expect(0, 2155, '\p{Sc=- SYRC}', "");
    Expect(1, 2155, '\p{^Sc=- SYRC}', "");
    Expect(1, 2155, '\P{Sc=- SYRC}', "");
    Expect(0, 2155, '\P{^Sc=- SYRC}', "");
    Error('\p{Is_Script=	Syriac:=}');
    Error('\P{Is_Script=	Syriac:=}');
    Expect(1, 2154, '\p{Is_Script:syriac}', "");
    Expect(0, 2154, '\p{^Is_Script:syriac}', "");
    Expect(0, 2154, '\P{Is_Script:syriac}', "");
    Expect(1, 2154, '\P{^Is_Script:syriac}', "");
    Expect(0, 2155, '\p{Is_Script:syriac}', "");
    Expect(1, 2155, '\p{^Is_Script:syriac}', "");
    Expect(1, 2155, '\P{Is_Script:syriac}', "");
    Expect(0, 2155, '\P{^Is_Script:syriac}', "");
    Expect(1, 2154, '\p{Is_Script=	_syriac}', "");
    Expect(0, 2154, '\p{^Is_Script=	_syriac}', "");
    Expect(0, 2154, '\P{Is_Script=	_syriac}', "");
    Expect(1, 2154, '\P{^Is_Script=	_syriac}', "");
    Expect(0, 2155, '\p{Is_Script=	_syriac}', "");
    Expect(1, 2155, '\p{^Is_Script=	_syriac}', "");
    Expect(1, 2155, '\P{Is_Script=	_syriac}', "");
    Expect(0, 2155, '\P{^Is_Script=	_syriac}', "");
    Error('\p{Is_Sc=/a/Syrc}');
    Error('\P{Is_Sc=/a/Syrc}');
    Expect(1, 2154, '\p{Is_Sc=syrc}', "");
    Expect(0, 2154, '\p{^Is_Sc=syrc}', "");
    Expect(0, 2154, '\P{Is_Sc=syrc}', "");
    Expect(1, 2154, '\P{^Is_Sc=syrc}', "");
    Expect(0, 2155, '\p{Is_Sc=syrc}', "");
    Expect(1, 2155, '\p{^Is_Sc=syrc}', "");
    Expect(1, 2155, '\P{Is_Sc=syrc}', "");
    Expect(0, 2155, '\P{^Is_Sc=syrc}', "");
    Expect(1, 2154, '\p{Is_Sc= -syrc}', "");
    Expect(0, 2154, '\p{^Is_Sc= -syrc}', "");
    Expect(0, 2154, '\P{Is_Sc= -syrc}', "");
    Expect(1, 2154, '\P{^Is_Sc= -syrc}', "");
    Expect(0, 2155, '\p{Is_Sc= -syrc}', "");
    Expect(1, 2155, '\p{^Is_Sc= -syrc}', "");
    Expect(1, 2155, '\P{Is_Sc= -syrc}', "");
    Expect(0, 2155, '\P{^Is_Sc= -syrc}', "");
    Error('\p{Script=/a/- TAGBANWA}');
    Error('\P{Script=/a/- TAGBANWA}');
    Expect(1, 6003, '\p{Script=:\ATagbanwa\z:}', "");;
    Expect(0, 6004, '\p{Script=:\ATagbanwa\z:}', "");;
    Expect(1, 6003, '\p{Script=tagbanwa}', "");
    Expect(0, 6003, '\p{^Script=tagbanwa}', "");
    Expect(0, 6003, '\P{Script=tagbanwa}', "");
    Expect(1, 6003, '\P{^Script=tagbanwa}', "");
    Expect(0, 6004, '\p{Script=tagbanwa}', "");
    Expect(1, 6004, '\p{^Script=tagbanwa}', "");
    Expect(1, 6004, '\P{Script=tagbanwa}', "");
    Expect(0, 6004, '\P{^Script=tagbanwa}', "");
    Expect(1, 6003, '\p{Script=:\Atagbanwa\z:}', "");;
    Expect(0, 6004, '\p{Script=:\Atagbanwa\z:}', "");;
    Expect(1, 6003, '\p{Script= -tagbanwa}', "");
    Expect(0, 6003, '\p{^Script= -tagbanwa}', "");
    Expect(0, 6003, '\P{Script= -tagbanwa}', "");
    Expect(1, 6003, '\P{^Script= -tagbanwa}', "");
    Expect(0, 6004, '\p{Script= -tagbanwa}', "");
    Expect(1, 6004, '\p{^Script= -tagbanwa}', "");
    Expect(1, 6004, '\P{Script= -tagbanwa}', "");
    Expect(0, 6004, '\P{^Script= -tagbanwa}', "");
    Error('\p{Sc=--tagb:=}');
    Error('\P{Sc=--tagb:=}');
    Expect(1, 6003, '\p{Sc=:\ATagb\z:}', "");;
    Expect(0, 6004, '\p{Sc=:\ATagb\z:}', "");;
    Expect(1, 6003, '\p{Sc=tagb}', "");
    Expect(0, 6003, '\p{^Sc=tagb}', "");
    Expect(0, 6003, '\P{Sc=tagb}', "");
    Expect(1, 6003, '\P{^Sc=tagb}', "");
    Expect(0, 6004, '\p{Sc=tagb}', "");
    Expect(1, 6004, '\p{^Sc=tagb}', "");
    Expect(1, 6004, '\P{Sc=tagb}', "");
    Expect(0, 6004, '\P{^Sc=tagb}', "");
    Expect(1, 6003, '\p{Sc=:\Atagb\z:}', "");;
    Expect(0, 6004, '\p{Sc=:\Atagb\z:}', "");;
    Expect(1, 6003, '\p{Sc=	TAGB}', "");
    Expect(0, 6003, '\p{^Sc=	TAGB}', "");
    Expect(0, 6003, '\P{Sc=	TAGB}', "");
    Expect(1, 6003, '\P{^Sc=	TAGB}', "");
    Expect(0, 6004, '\p{Sc=	TAGB}', "");
    Expect(1, 6004, '\p{^Sc=	TAGB}', "");
    Expect(1, 6004, '\P{Sc=	TAGB}', "");
    Expect(0, 6004, '\P{^Sc=	TAGB}', "");
    Error('\p{Is_Script=:= 	Tagbanwa}');
    Error('\P{Is_Script=:= 	Tagbanwa}');
    Expect(1, 6003, '\p{Is_Script=tagbanwa}', "");
    Expect(0, 6003, '\p{^Is_Script=tagbanwa}', "");
    Expect(0, 6003, '\P{Is_Script=tagbanwa}', "");
    Expect(1, 6003, '\P{^Is_Script=tagbanwa}', "");
    Expect(0, 6004, '\p{Is_Script=tagbanwa}', "");
    Expect(1, 6004, '\p{^Is_Script=tagbanwa}', "");
    Expect(1, 6004, '\P{Is_Script=tagbanwa}', "");
    Expect(0, 6004, '\P{^Is_Script=tagbanwa}', "");
    Expect(1, 6003, '\p{Is_Script=	-Tagbanwa}', "");
    Expect(0, 6003, '\p{^Is_Script=	-Tagbanwa}', "");
    Expect(0, 6003, '\P{Is_Script=	-Tagbanwa}', "");
    Expect(1, 6003, '\P{^Is_Script=	-Tagbanwa}', "");
    Expect(0, 6004, '\p{Is_Script=	-Tagbanwa}', "");
    Expect(1, 6004, '\p{^Is_Script=	-Tagbanwa}', "");
    Expect(1, 6004, '\P{Is_Script=	-Tagbanwa}', "");
    Expect(0, 6004, '\P{^Is_Script=	-Tagbanwa}', "");
    Error('\p{Is_Sc= Tagb:=}');
    Error('\P{Is_Sc= Tagb:=}');
    Expect(1, 6003, '\p{Is_Sc=tagb}', "");
    Expect(0, 6003, '\p{^Is_Sc=tagb}', "");
    Expect(0, 6003, '\P{Is_Sc=tagb}', "");
    Expect(1, 6003, '\P{^Is_Sc=tagb}', "");
    Expect(0, 6004, '\p{Is_Sc=tagb}', "");
    Expect(1, 6004, '\p{^Is_Sc=tagb}', "");
    Expect(1, 6004, '\P{Is_Sc=tagb}', "");
    Expect(0, 6004, '\P{^Is_Sc=tagb}', "");
    Expect(1, 6003, '\p{Is_Sc=_	Tagb}', "");
    Expect(0, 6003, '\p{^Is_Sc=_	Tagb}', "");
    Expect(0, 6003, '\P{Is_Sc=_	Tagb}', "");
    Expect(1, 6003, '\P{^Is_Sc=_	Tagb}', "");
    Expect(0, 6004, '\p{Is_Sc=_	Tagb}', "");
    Expect(1, 6004, '\p{^Is_Sc=_	Tagb}', "");
    Expect(1, 6004, '\P{Is_Sc=_	Tagb}', "");
    Expect(0, 6004, '\P{^Is_Sc=_	Tagb}', "");
    Error('\p{Script=	:=takri}');
    Error('\P{Script=	:=takri}');
    Expect(1, 71369, '\p{Script=:\ATakri\z:}', "");;
    Expect(0, 71370, '\p{Script=:\ATakri\z:}', "");;
    Expect(1, 71369, '\p{Script:takri}', "");
    Expect(0, 71369, '\p{^Script:takri}', "");
    Expect(0, 71369, '\P{Script:takri}', "");
    Expect(1, 71369, '\P{^Script:takri}', "");
    Expect(0, 71370, '\p{Script:takri}', "");
    Expect(1, 71370, '\p{^Script:takri}', "");
    Expect(1, 71370, '\P{Script:takri}', "");
    Expect(0, 71370, '\P{^Script:takri}', "");
    Expect(1, 71369, '\p{Script=:\Atakri\z:}', "");;
    Expect(0, 71370, '\p{Script=:\Atakri\z:}', "");;
    Expect(1, 71369, '\p{Script=	_Takri}', "");
    Expect(0, 71369, '\p{^Script=	_Takri}', "");
    Expect(0, 71369, '\P{Script=	_Takri}', "");
    Expect(1, 71369, '\P{^Script=	_Takri}', "");
    Expect(0, 71370, '\p{Script=	_Takri}', "");
    Expect(1, 71370, '\p{^Script=	_Takri}', "");
    Expect(1, 71370, '\P{Script=	_Takri}', "");
    Expect(0, 71370, '\P{^Script=	_Takri}', "");
    Error('\p{Sc=_:=Takr}');
    Error('\P{Sc=_:=Takr}');
    Expect(1, 71369, '\p{Sc=:\ATakr\z:}', "");;
    Expect(0, 71370, '\p{Sc=:\ATakr\z:}', "");;
    Expect(1, 71369, '\p{Sc:   takr}', "");
    Expect(0, 71369, '\p{^Sc:   takr}', "");
    Expect(0, 71369, '\P{Sc:   takr}', "");
    Expect(1, 71369, '\P{^Sc:   takr}', "");
    Expect(0, 71370, '\p{Sc:   takr}', "");
    Expect(1, 71370, '\p{^Sc:   takr}', "");
    Expect(1, 71370, '\P{Sc:   takr}', "");
    Expect(0, 71370, '\P{^Sc:   takr}', "");
    Expect(1, 71369, '\p{Sc=:\Atakr\z:}', "");;
    Expect(0, 71370, '\p{Sc=:\Atakr\z:}', "");;
    Expect(1, 71369, '\p{Sc: _	takr}', "");
    Expect(0, 71369, '\p{^Sc: _	takr}', "");
    Expect(0, 71369, '\P{Sc: _	takr}', "");
    Expect(1, 71369, '\P{^Sc: _	takr}', "");
    Expect(0, 71370, '\p{Sc: _	takr}', "");
    Expect(1, 71370, '\p{^Sc: _	takr}', "");
    Expect(1, 71370, '\P{Sc: _	takr}', "");
    Expect(0, 71370, '\P{^Sc: _	takr}', "");
    Error('\p{Is_Script=	:=TAKRI}');
    Error('\P{Is_Script=	:=TAKRI}');
    Expect(1, 71369, '\p{Is_Script=takri}', "");
    Expect(0, 71369, '\p{^Is_Script=takri}', "");
    Expect(0, 71369, '\P{Is_Script=takri}', "");
    Expect(1, 71369, '\P{^Is_Script=takri}', "");
    Expect(0, 71370, '\p{Is_Script=takri}', "");
    Expect(1, 71370, '\p{^Is_Script=takri}', "");
    Expect(1, 71370, '\P{Is_Script=takri}', "");
    Expect(0, 71370, '\P{^Is_Script=takri}', "");
    Expect(1, 71369, '\p{Is_Script=	TAKRI}', "");
    Expect(0, 71369, '\p{^Is_Script=	TAKRI}', "");
    Expect(0, 71369, '\P{Is_Script=	TAKRI}', "");
    Expect(1, 71369, '\P{^Is_Script=	TAKRI}', "");
    Expect(0, 71370, '\p{Is_Script=	TAKRI}', "");
    Expect(1, 71370, '\p{^Is_Script=	TAKRI}', "");
    Expect(1, 71370, '\P{Is_Script=	TAKRI}', "");
    Expect(0, 71370, '\P{^Is_Script=	TAKRI}', "");
    Error('\p{Is_Sc:		TAKR/a/}');
    Error('\P{Is_Sc:		TAKR/a/}');
    Expect(1, 71369, '\p{Is_Sc:	takr}', "");
    Expect(0, 71369, '\p{^Is_Sc:	takr}', "");
    Expect(0, 71369, '\P{Is_Sc:	takr}', "");
    Expect(1, 71369, '\P{^Is_Sc:	takr}', "");
    Expect(0, 71370, '\p{Is_Sc:	takr}', "");
    Expect(1, 71370, '\p{^Is_Sc:	takr}', "");
    Expect(1, 71370, '\P{Is_Sc:	takr}', "");
    Expect(0, 71370, '\P{^Is_Sc:	takr}', "");
    Expect(1, 71369, '\p{Is_Sc:	  TAKR}', "");
    Expect(0, 71369, '\p{^Is_Sc:	  TAKR}', "");
    Expect(0, 71369, '\P{Is_Sc:	  TAKR}', "");
    Expect(1, 71369, '\P{^Is_Sc:	  TAKR}', "");
    Expect(0, 71370, '\p{Is_Sc:	  TAKR}', "");
    Expect(1, 71370, '\p{^Is_Sc:	  TAKR}', "");
    Expect(1, 71370, '\P{Is_Sc:	  TAKR}', "");
    Expect(0, 71370, '\P{^Is_Sc:	  TAKR}', "");
    Error('\p{Script=- Tai_Le:=}');
    Error('\P{Script=- Tai_Le:=}');
    Expect(1, 6516, '\p{Script=:\ATai_Le\z:}', "");;
    Expect(0, 6517, '\p{Script=:\ATai_Le\z:}', "");;
    Expect(1, 6516, '\p{Script=taile}', "");
    Expect(0, 6516, '\p{^Script=taile}', "");
    Expect(0, 6516, '\P{Script=taile}', "");
    Expect(1, 6516, '\P{^Script=taile}', "");
    Expect(0, 6517, '\p{Script=taile}', "");
    Expect(1, 6517, '\p{^Script=taile}', "");
    Expect(1, 6517, '\P{Script=taile}', "");
    Expect(0, 6517, '\P{^Script=taile}', "");
    Expect(1, 6516, '\p{Script=:\Ataile\z:}', "");;
    Expect(0, 6517, '\p{Script=:\Ataile\z:}', "");;
    Expect(1, 6516, '\p{Script=	_Tai_LE}', "");
    Expect(0, 6516, '\p{^Script=	_Tai_LE}', "");
    Expect(0, 6516, '\P{Script=	_Tai_LE}', "");
    Expect(1, 6516, '\P{^Script=	_Tai_LE}', "");
    Expect(0, 6517, '\p{Script=	_Tai_LE}', "");
    Expect(1, 6517, '\p{^Script=	_Tai_LE}', "");
    Expect(1, 6517, '\P{Script=	_Tai_LE}', "");
    Expect(0, 6517, '\P{^Script=	_Tai_LE}', "");
    Error('\p{Sc=/a/	_Tale}');
    Error('\P{Sc=/a/	_Tale}');
    Expect(1, 6516, '\p{Sc=:\ATale\z:}', "");;
    Expect(0, 6517, '\p{Sc=:\ATale\z:}', "");;
    Expect(1, 6516, '\p{Sc=tale}', "");
    Expect(0, 6516, '\p{^Sc=tale}', "");
    Expect(0, 6516, '\P{Sc=tale}', "");
    Expect(1, 6516, '\P{^Sc=tale}', "");
    Expect(0, 6517, '\p{Sc=tale}', "");
    Expect(1, 6517, '\p{^Sc=tale}', "");
    Expect(1, 6517, '\P{Sc=tale}', "");
    Expect(0, 6517, '\P{^Sc=tale}', "");
    Expect(1, 6516, '\p{Sc=:\Atale\z:}', "");;
    Expect(0, 6517, '\p{Sc=:\Atale\z:}', "");;
    Expect(1, 6516, '\p{Sc=-_Tale}', "");
    Expect(0, 6516, '\p{^Sc=-_Tale}', "");
    Expect(0, 6516, '\P{Sc=-_Tale}', "");
    Expect(1, 6516, '\P{^Sc=-_Tale}', "");
    Expect(0, 6517, '\p{Sc=-_Tale}', "");
    Expect(1, 6517, '\p{^Sc=-_Tale}', "");
    Expect(1, 6517, '\P{Sc=-_Tale}', "");
    Expect(0, 6517, '\P{^Sc=-_Tale}', "");
    Error('\p{Is_Script:    :=tai_LE}');
    Error('\P{Is_Script:    :=tai_LE}');
    Expect(1, 6516, '\p{Is_Script=taile}', "");
    Expect(0, 6516, '\p{^Is_Script=taile}', "");
    Expect(0, 6516, '\P{Is_Script=taile}', "");
    Expect(1, 6516, '\P{^Is_Script=taile}', "");
    Expect(0, 6517, '\p{Is_Script=taile}', "");
    Expect(1, 6517, '\p{^Is_Script=taile}', "");
    Expect(1, 6517, '\P{Is_Script=taile}', "");
    Expect(0, 6517, '\P{^Is_Script=taile}', "");
    Expect(1, 6516, '\p{Is_Script=_TAI_Le}', "");
    Expect(0, 6516, '\p{^Is_Script=_TAI_Le}', "");
    Expect(0, 6516, '\P{Is_Script=_TAI_Le}', "");
    Expect(1, 6516, '\P{^Is_Script=_TAI_Le}', "");
    Expect(0, 6517, '\p{Is_Script=_TAI_Le}', "");
    Expect(1, 6517, '\p{^Is_Script=_TAI_Le}', "");
    Expect(1, 6517, '\P{Is_Script=_TAI_Le}', "");
    Expect(0, 6517, '\P{^Is_Script=_TAI_Le}', "");
    Error('\p{Is_Sc=_:=Tale}');
    Error('\P{Is_Sc=_:=Tale}');
    Expect(1, 6516, '\p{Is_Sc=tale}', "");
    Expect(0, 6516, '\p{^Is_Sc=tale}', "");
    Expect(0, 6516, '\P{Is_Sc=tale}', "");
    Expect(1, 6516, '\P{^Is_Sc=tale}', "");
    Expect(0, 6517, '\p{Is_Sc=tale}', "");
    Expect(1, 6517, '\p{^Is_Sc=tale}', "");
    Expect(1, 6517, '\P{Is_Sc=tale}', "");
    Expect(0, 6517, '\P{^Is_Sc=tale}', "");
    Expect(1, 6516, '\p{Is_Sc= _Tale}', "");
    Expect(0, 6516, '\p{^Is_Sc= _Tale}', "");
    Expect(0, 6516, '\P{Is_Sc= _Tale}', "");
    Expect(1, 6516, '\P{^Is_Sc= _Tale}', "");
    Expect(0, 6517, '\p{Is_Sc= _Tale}', "");
    Expect(1, 6517, '\p{^Is_Sc= _Tale}', "");
    Expect(1, 6517, '\P{Is_Sc= _Tale}', "");
    Expect(0, 6517, '\P{^Is_Sc= _Tale}', "");
    Error('\p{Script=/a/	NEW_tai_Lue}');
    Error('\P{Script=/a/	NEW_tai_Lue}');
    Expect(1, 6623, '\p{Script=:\ANew_Tai_Lue\z:}', "");;
    Expect(0, 6624, '\p{Script=:\ANew_Tai_Lue\z:}', "");;
    Expect(1, 6623, '\p{Script=newtailue}', "");
    Expect(0, 6623, '\p{^Script=newtailue}', "");
    Expect(0, 6623, '\P{Script=newtailue}', "");
    Expect(1, 6623, '\P{^Script=newtailue}', "");
    Expect(0, 6624, '\p{Script=newtailue}', "");
    Expect(1, 6624, '\p{^Script=newtailue}', "");
    Expect(1, 6624, '\P{Script=newtailue}', "");
    Expect(0, 6624, '\P{^Script=newtailue}', "");
    Expect(1, 6623, '\p{Script=:\Anewtailue\z:}', "");;
    Expect(0, 6624, '\p{Script=:\Anewtailue\z:}', "");;
    Expect(1, 6623, '\p{Script=--New_Tai_Lue}', "");
    Expect(0, 6623, '\p{^Script=--New_Tai_Lue}', "");
    Expect(0, 6623, '\P{Script=--New_Tai_Lue}', "");
    Expect(1, 6623, '\P{^Script=--New_Tai_Lue}', "");
    Expect(0, 6624, '\p{Script=--New_Tai_Lue}', "");
    Expect(1, 6624, '\p{^Script=--New_Tai_Lue}', "");
    Expect(1, 6624, '\P{Script=--New_Tai_Lue}', "");
    Expect(0, 6624, '\P{^Script=--New_Tai_Lue}', "");
    Error('\p{Sc= :=Talu}');
    Error('\P{Sc= :=Talu}');
    Expect(1, 6623, '\p{Sc=:\ATalu\z:}', "");;
    Expect(0, 6624, '\p{Sc=:\ATalu\z:}', "");;
    Expect(1, 6623, '\p{Sc=talu}', "");
    Expect(0, 6623, '\p{^Sc=talu}', "");
    Expect(0, 6623, '\P{Sc=talu}', "");
    Expect(1, 6623, '\P{^Sc=talu}', "");
    Expect(0, 6624, '\p{Sc=talu}', "");
    Expect(1, 6624, '\p{^Sc=talu}', "");
    Expect(1, 6624, '\P{Sc=talu}', "");
    Expect(0, 6624, '\P{^Sc=talu}', "");
    Expect(1, 6623, '\p{Sc=:\Atalu\z:}', "");;
    Expect(0, 6624, '\p{Sc=:\Atalu\z:}', "");;
    Error('\p{Is_Script=-/a/NEW_TAI_Lue}');
    Error('\P{Is_Script=-/a/NEW_TAI_Lue}');
    Expect(1, 6623, '\p{Is_Script=newtailue}', "");
    Expect(0, 6623, '\p{^Is_Script=newtailue}', "");
    Expect(0, 6623, '\P{Is_Script=newtailue}', "");
    Expect(1, 6623, '\P{^Is_Script=newtailue}', "");
    Expect(0, 6624, '\p{Is_Script=newtailue}', "");
    Expect(1, 6624, '\p{^Is_Script=newtailue}', "");
    Expect(1, 6624, '\P{Is_Script=newtailue}', "");
    Expect(0, 6624, '\P{^Is_Script=newtailue}', "");
    Expect(1, 6623, '\p{Is_Script= 	NEW_TAI_Lue}', "");
    Expect(0, 6623, '\p{^Is_Script= 	NEW_TAI_Lue}', "");
    Expect(0, 6623, '\P{Is_Script= 	NEW_TAI_Lue}', "");
    Expect(1, 6623, '\P{^Is_Script= 	NEW_TAI_Lue}', "");
    Expect(0, 6624, '\p{Is_Script= 	NEW_TAI_Lue}', "");
    Expect(1, 6624, '\p{^Is_Script= 	NEW_TAI_Lue}', "");
    Expect(1, 6624, '\P{Is_Script= 	NEW_TAI_Lue}', "");
    Expect(0, 6624, '\P{^Is_Script= 	NEW_TAI_Lue}', "");
    Error('\p{Is_Sc=:=	-Talu}');
    Error('\P{Is_Sc=:=	-Talu}');
    Expect(1, 6623, '\p{Is_Sc=talu}', "");
    Expect(0, 6623, '\p{^Is_Sc=talu}', "");
    Expect(0, 6623, '\P{Is_Sc=talu}', "");
    Expect(1, 6623, '\P{^Is_Sc=talu}', "");
    Expect(0, 6624, '\p{Is_Sc=talu}', "");
    Expect(1, 6624, '\p{^Is_Sc=talu}', "");
    Expect(1, 6624, '\P{Is_Sc=talu}', "");
    Expect(0, 6624, '\P{^Is_Sc=talu}', "");
    Expect(1, 6623, '\p{Is_Sc=		Talu}', "");
    Expect(0, 6623, '\p{^Is_Sc=		Talu}', "");
    Expect(0, 6623, '\P{Is_Sc=		Talu}', "");
    Expect(1, 6623, '\P{^Is_Sc=		Talu}', "");
    Expect(0, 6624, '\p{Is_Sc=		Talu}', "");
    Expect(1, 6624, '\p{^Is_Sc=		Talu}', "");
    Expect(1, 6624, '\P{Is_Sc=		Talu}', "");
    Expect(0, 6624, '\P{^Is_Sc=		Talu}', "");
    Error('\p{Script:   :=__Tamil}');
    Error('\P{Script:   :=__Tamil}');
    Expect(1, 73727, '\p{Script=:\ATamil\z:}', "");;
    Expect(0, 73728, '\p{Script=:\ATamil\z:}', "");;
    Expect(1, 73727, '\p{Script=tamil}', "");
    Expect(0, 73727, '\p{^Script=tamil}', "");
    Expect(0, 73727, '\P{Script=tamil}', "");
    Expect(1, 73727, '\P{^Script=tamil}', "");
    Expect(0, 73728, '\p{Script=tamil}', "");
    Expect(1, 73728, '\p{^Script=tamil}', "");
    Expect(1, 73728, '\P{Script=tamil}', "");
    Expect(0, 73728, '\P{^Script=tamil}', "");
    Expect(1, 73727, '\p{Script=:\Atamil\z:}', "");;
    Expect(0, 73728, '\p{Script=:\Atamil\z:}', "");;
    Expect(1, 73727, '\p{Script=_tamil}', "");
    Expect(0, 73727, '\p{^Script=_tamil}', "");
    Expect(0, 73727, '\P{Script=_tamil}', "");
    Expect(1, 73727, '\P{^Script=_tamil}', "");
    Expect(0, 73728, '\p{Script=_tamil}', "");
    Expect(1, 73728, '\p{^Script=_tamil}', "");
    Expect(1, 73728, '\P{Script=_tamil}', "");
    Expect(0, 73728, '\P{^Script=_tamil}', "");
    Error('\p{Sc:	 _Taml/a/}');
    Error('\P{Sc:	 _Taml/a/}');
    Expect(1, 73727, '\p{Sc=:\ATaml\z:}', "");;
    Expect(0, 73728, '\p{Sc=:\ATaml\z:}', "");;
    Expect(1, 73727, '\p{Sc=taml}', "");
    Expect(0, 73727, '\p{^Sc=taml}', "");
    Expect(0, 73727, '\P{Sc=taml}', "");
    Expect(1, 73727, '\P{^Sc=taml}', "");
    Expect(0, 73728, '\p{Sc=taml}', "");
    Expect(1, 73728, '\p{^Sc=taml}', "");
    Expect(1, 73728, '\P{Sc=taml}', "");
    Expect(0, 73728, '\P{^Sc=taml}', "");
    Expect(1, 73727, '\p{Sc=:\Ataml\z:}', "");;
    Expect(0, 73728, '\p{Sc=:\Ataml\z:}', "");;
    Expect(1, 73727, '\p{Sc=	taml}', "");
    Expect(0, 73727, '\p{^Sc=	taml}', "");
    Expect(0, 73727, '\P{Sc=	taml}', "");
    Expect(1, 73727, '\P{^Sc=	taml}', "");
    Expect(0, 73728, '\p{Sc=	taml}', "");
    Expect(1, 73728, '\p{^Sc=	taml}', "");
    Expect(1, 73728, '\P{Sc=	taml}', "");
    Expect(0, 73728, '\P{^Sc=	taml}', "");
    Error('\p{Is_Script=_/a/TAMIL}');
    Error('\P{Is_Script=_/a/TAMIL}');
    Expect(1, 73727, '\p{Is_Script=tamil}', "");
    Expect(0, 73727, '\p{^Is_Script=tamil}', "");
    Expect(0, 73727, '\P{Is_Script=tamil}', "");
    Expect(1, 73727, '\P{^Is_Script=tamil}', "");
    Expect(0, 73728, '\p{Is_Script=tamil}', "");
    Expect(1, 73728, '\p{^Is_Script=tamil}', "");
    Expect(1, 73728, '\P{Is_Script=tamil}', "");
    Expect(0, 73728, '\P{^Is_Script=tamil}', "");
    Expect(1, 73727, '\p{Is_Script=--TAMIL}', "");
    Expect(0, 73727, '\p{^Is_Script=--TAMIL}', "");
    Expect(0, 73727, '\P{Is_Script=--TAMIL}', "");
    Expect(1, 73727, '\P{^Is_Script=--TAMIL}', "");
    Expect(0, 73728, '\p{Is_Script=--TAMIL}', "");
    Expect(1, 73728, '\p{^Is_Script=--TAMIL}', "");
    Expect(1, 73728, '\P{Is_Script=--TAMIL}', "");
    Expect(0, 73728, '\P{^Is_Script=--TAMIL}', "");
    Error('\p{Is_Sc=	TAML:=}');
    Error('\P{Is_Sc=	TAML:=}');
    Expect(1, 73727, '\p{Is_Sc=taml}', "");
    Expect(0, 73727, '\p{^Is_Sc=taml}', "");
    Expect(0, 73727, '\P{Is_Sc=taml}', "");
    Expect(1, 73727, '\P{^Is_Sc=taml}', "");
    Expect(0, 73728, '\p{Is_Sc=taml}', "");
    Expect(1, 73728, '\p{^Is_Sc=taml}', "");
    Expect(1, 73728, '\P{Is_Sc=taml}', "");
    Expect(0, 73728, '\P{^Is_Sc=taml}', "");
    Expect(1, 73727, '\p{Is_Sc=-_Taml}', "");
    Expect(0, 73727, '\p{^Is_Sc=-_Taml}', "");
    Expect(0, 73727, '\P{Is_Sc=-_Taml}', "");
    Expect(1, 73727, '\P{^Is_Sc=-_Taml}', "");
    Expect(0, 73728, '\p{Is_Sc=-_Taml}', "");
    Expect(1, 73728, '\p{^Is_Sc=-_Taml}', "");
    Expect(1, 73728, '\P{Is_Sc=-_Taml}', "");
    Expect(0, 73728, '\P{^Is_Sc=-_Taml}', "");
    Error('\p{Script=/a/	-Tangut}');
    Error('\P{Script=/a/	-Tangut}');
    Expect(1, 101106, '\p{Script=:\ATangut\z:}', "");;
    Expect(0, 101107, '\p{Script=:\ATangut\z:}', "");;
    Expect(1, 101106, '\p{Script=tangut}', "");
    Expect(0, 101106, '\p{^Script=tangut}', "");
    Expect(0, 101106, '\P{Script=tangut}', "");
    Expect(1, 101106, '\P{^Script=tangut}', "");
    Expect(0, 101107, '\p{Script=tangut}', "");
    Expect(1, 101107, '\p{^Script=tangut}', "");
    Expect(1, 101107, '\P{Script=tangut}', "");
    Expect(0, 101107, '\P{^Script=tangut}', "");
    Expect(1, 101106, '\p{Script=:\Atangut\z:}', "");;
    Expect(0, 101107, '\p{Script=:\Atangut\z:}', "");;
    Expect(1, 101106, '\p{Script=	_Tangut}', "");
    Expect(0, 101106, '\p{^Script=	_Tangut}', "");
    Expect(0, 101106, '\P{Script=	_Tangut}', "");
    Expect(1, 101106, '\P{^Script=	_Tangut}', "");
    Expect(0, 101107, '\p{Script=	_Tangut}', "");
    Expect(1, 101107, '\p{^Script=	_Tangut}', "");
    Expect(1, 101107, '\P{Script=	_Tangut}', "");
    Expect(0, 101107, '\P{^Script=	_Tangut}', "");
    Error('\p{Sc=-:=TANG}');
    Error('\P{Sc=-:=TANG}');
    Expect(1, 101106, '\p{Sc=:\ATang\z:}', "");;
    Expect(0, 101107, '\p{Sc=:\ATang\z:}', "");;
    Expect(1, 101106, '\p{Sc=tang}', "");
    Expect(0, 101106, '\p{^Sc=tang}', "");
    Expect(0, 101106, '\P{Sc=tang}', "");
    Expect(1, 101106, '\P{^Sc=tang}', "");
    Expect(0, 101107, '\p{Sc=tang}', "");
    Expect(1, 101107, '\p{^Sc=tang}', "");
    Expect(1, 101107, '\P{Sc=tang}', "");
    Expect(0, 101107, '\P{^Sc=tang}', "");
    Expect(1, 101106, '\p{Sc=:\Atang\z:}', "");;
    Expect(0, 101107, '\p{Sc=:\Atang\z:}', "");;
    Expect(1, 101106, '\p{Sc=	tang}', "");
    Expect(0, 101106, '\p{^Sc=	tang}', "");
    Expect(0, 101106, '\P{Sc=	tang}', "");
    Expect(1, 101106, '\P{^Sc=	tang}', "");
    Expect(0, 101107, '\p{Sc=	tang}', "");
    Expect(1, 101107, '\p{^Sc=	tang}', "");
    Expect(1, 101107, '\P{Sc=	tang}', "");
    Expect(0, 101107, '\P{^Sc=	tang}', "");
    Error('\p{Is_Script= 	Tangut/a/}');
    Error('\P{Is_Script= 	Tangut/a/}');
    Expect(1, 101106, '\p{Is_Script=tangut}', "");
    Expect(0, 101106, '\p{^Is_Script=tangut}', "");
    Expect(0, 101106, '\P{Is_Script=tangut}', "");
    Expect(1, 101106, '\P{^Is_Script=tangut}', "");
    Expect(0, 101107, '\p{Is_Script=tangut}', "");
    Expect(1, 101107, '\p{^Is_Script=tangut}', "");
    Expect(1, 101107, '\P{Is_Script=tangut}', "");
    Expect(0, 101107, '\P{^Is_Script=tangut}', "");
    Expect(1, 101106, '\p{Is_Script= 	Tangut}', "");
    Expect(0, 101106, '\p{^Is_Script= 	Tangut}', "");
    Expect(0, 101106, '\P{Is_Script= 	Tangut}', "");
    Expect(1, 101106, '\P{^Is_Script= 	Tangut}', "");
    Expect(0, 101107, '\p{Is_Script= 	Tangut}', "");
    Expect(1, 101107, '\p{^Is_Script= 	Tangut}', "");
    Expect(1, 101107, '\P{Is_Script= 	Tangut}', "");
    Expect(0, 101107, '\P{^Is_Script= 	Tangut}', "");
    Error('\p{Is_Sc=	-Tang:=}');
    Error('\P{Is_Sc=	-Tang:=}');
    Expect(1, 101106, '\p{Is_Sc:tang}', "");
    Expect(0, 101106, '\p{^Is_Sc:tang}', "");
    Expect(0, 101106, '\P{Is_Sc:tang}', "");
    Expect(1, 101106, '\P{^Is_Sc:tang}', "");
    Expect(0, 101107, '\p{Is_Sc:tang}', "");
    Expect(1, 101107, '\p{^Is_Sc:tang}', "");
    Expect(1, 101107, '\P{Is_Sc:tang}', "");
    Expect(0, 101107, '\P{^Is_Sc:tang}', "");
    Expect(1, 101106, '\p{Is_Sc:	_ tang}', "");
    Expect(0, 101106, '\p{^Is_Sc:	_ tang}', "");
    Expect(0, 101106, '\P{Is_Sc:	_ tang}', "");
    Expect(1, 101106, '\P{^Is_Sc:	_ tang}', "");
    Expect(0, 101107, '\p{Is_Sc:	_ tang}', "");
    Expect(1, 101107, '\p{^Is_Sc:	_ tang}', "");
    Expect(1, 101107, '\P{Is_Sc:	_ tang}', "");
    Expect(0, 101107, '\P{^Is_Sc:	_ tang}', "");
    Error('\p{Script= 	TAI_Viet:=}');
    Error('\P{Script= 	TAI_Viet:=}');
    Expect(1, 43743, '\p{Script=:\ATai_Viet\z:}', "");;
    Expect(0, 43744, '\p{Script=:\ATai_Viet\z:}', "");;
    Expect(1, 43743, '\p{Script=taiviet}', "");
    Expect(0, 43743, '\p{^Script=taiviet}', "");
    Expect(0, 43743, '\P{Script=taiviet}', "");
    Expect(1, 43743, '\P{^Script=taiviet}', "");
    Expect(0, 43744, '\p{Script=taiviet}', "");
    Expect(1, 43744, '\p{^Script=taiviet}', "");
    Expect(1, 43744, '\P{Script=taiviet}', "");
    Expect(0, 43744, '\P{^Script=taiviet}', "");
    Expect(1, 43743, '\p{Script=:\Ataiviet\z:}', "");;
    Expect(0, 43744, '\p{Script=:\Ataiviet\z:}', "");;
    Expect(1, 43743, '\p{Script= _Tai_Viet}', "");
    Expect(0, 43743, '\p{^Script= _Tai_Viet}', "");
    Expect(0, 43743, '\P{Script= _Tai_Viet}', "");
    Expect(1, 43743, '\P{^Script= _Tai_Viet}', "");
    Expect(0, 43744, '\p{Script= _Tai_Viet}', "");
    Expect(1, 43744, '\p{^Script= _Tai_Viet}', "");
    Expect(1, 43744, '\P{Script= _Tai_Viet}', "");
    Expect(0, 43744, '\P{^Script= _Tai_Viet}', "");
    Error('\p{Sc=/a/_	TAVT}');
    Error('\P{Sc=/a/_	TAVT}');
    Expect(1, 43743, '\p{Sc=:\ATavt\z:}', "");;
    Expect(0, 43744, '\p{Sc=:\ATavt\z:}', "");;
    Expect(1, 43743, '\p{Sc=tavt}', "");
    Expect(0, 43743, '\p{^Sc=tavt}', "");
    Expect(0, 43743, '\P{Sc=tavt}', "");
    Expect(1, 43743, '\P{^Sc=tavt}', "");
    Expect(0, 43744, '\p{Sc=tavt}', "");
    Expect(1, 43744, '\p{^Sc=tavt}', "");
    Expect(1, 43744, '\P{Sc=tavt}', "");
    Expect(0, 43744, '\P{^Sc=tavt}', "");
    Expect(1, 43743, '\p{Sc=:\Atavt\z:}', "");;
    Expect(0, 43744, '\p{Sc=:\Atavt\z:}', "");;
    Expect(1, 43743, '\p{Sc= 	Tavt}', "");
    Expect(0, 43743, '\p{^Sc= 	Tavt}', "");
    Expect(0, 43743, '\P{Sc= 	Tavt}', "");
    Expect(1, 43743, '\P{^Sc= 	Tavt}', "");
    Expect(0, 43744, '\p{Sc= 	Tavt}', "");
    Expect(1, 43744, '\p{^Sc= 	Tavt}', "");
    Expect(1, 43744, '\P{Sc= 	Tavt}', "");
    Expect(0, 43744, '\P{^Sc= 	Tavt}', "");
    Error('\p{Is_Script=:=_tai_viet}');
    Error('\P{Is_Script=:=_tai_viet}');
    Expect(1, 43743, '\p{Is_Script:taiviet}', "");
    Expect(0, 43743, '\p{^Is_Script:taiviet}', "");
    Expect(0, 43743, '\P{Is_Script:taiviet}', "");
    Expect(1, 43743, '\P{^Is_Script:taiviet}', "");
    Expect(0, 43744, '\p{Is_Script:taiviet}', "");
    Expect(1, 43744, '\p{^Is_Script:taiviet}', "");
    Expect(1, 43744, '\P{Is_Script:taiviet}', "");
    Expect(0, 43744, '\P{^Is_Script:taiviet}', "");
    Expect(1, 43743, '\p{Is_Script:-	Tai_VIET}', "");
    Expect(0, 43743, '\p{^Is_Script:-	Tai_VIET}', "");
    Expect(0, 43743, '\P{Is_Script:-	Tai_VIET}', "");
    Expect(1, 43743, '\P{^Is_Script:-	Tai_VIET}', "");
    Expect(0, 43744, '\p{Is_Script:-	Tai_VIET}', "");
    Expect(1, 43744, '\p{^Is_Script:-	Tai_VIET}', "");
    Expect(1, 43744, '\P{Is_Script:-	Tai_VIET}', "");
    Expect(0, 43744, '\P{^Is_Script:-	Tai_VIET}', "");
    Error('\p{Is_Sc:   :=	 tavt}');
    Error('\P{Is_Sc:   :=	 tavt}');
    Expect(1, 43743, '\p{Is_Sc=tavt}', "");
    Expect(0, 43743, '\p{^Is_Sc=tavt}', "");
    Expect(0, 43743, '\P{Is_Sc=tavt}', "");
    Expect(1, 43743, '\P{^Is_Sc=tavt}', "");
    Expect(0, 43744, '\p{Is_Sc=tavt}', "");
    Expect(1, 43744, '\p{^Is_Sc=tavt}', "");
    Expect(1, 43744, '\P{Is_Sc=tavt}', "");
    Expect(0, 43744, '\P{^Is_Sc=tavt}', "");
    Expect(1, 43743, '\p{Is_Sc=--Tavt}', "");
    Expect(0, 43743, '\p{^Is_Sc=--Tavt}', "");
    Expect(0, 43743, '\P{Is_Sc=--Tavt}', "");
    Expect(1, 43743, '\P{^Is_Sc=--Tavt}', "");
    Expect(0, 43744, '\p{Is_Sc=--Tavt}', "");
    Expect(1, 43744, '\p{^Is_Sc=--Tavt}', "");
    Expect(1, 43744, '\P{Is_Sc=--Tavt}', "");
    Expect(0, 43744, '\P{^Is_Sc=--Tavt}', "");
    Error('\p{Script=	/a/telugu}');
    Error('\P{Script=	/a/telugu}');
    Expect(1, 3199, '\p{Script=:\ATelugu\z:}', "");;
    Expect(0, 3200, '\p{Script=:\ATelugu\z:}', "");;
    Expect(1, 3199, '\p{Script=telugu}', "");
    Expect(0, 3199, '\p{^Script=telugu}', "");
    Expect(0, 3199, '\P{Script=telugu}', "");
    Expect(1, 3199, '\P{^Script=telugu}', "");
    Expect(0, 3200, '\p{Script=telugu}', "");
    Expect(1, 3200, '\p{^Script=telugu}', "");
    Expect(1, 3200, '\P{Script=telugu}', "");
    Expect(0, 3200, '\P{^Script=telugu}', "");
    Expect(1, 3199, '\p{Script=:\Atelugu\z:}', "");;
    Expect(0, 3200, '\p{Script=:\Atelugu\z:}', "");;
    Expect(1, 3199, '\p{Script= 	TELUGU}', "");
    Expect(0, 3199, '\p{^Script= 	TELUGU}', "");
    Expect(0, 3199, '\P{Script= 	TELUGU}', "");
    Expect(1, 3199, '\P{^Script= 	TELUGU}', "");
    Expect(0, 3200, '\p{Script= 	TELUGU}', "");
    Expect(1, 3200, '\p{^Script= 	TELUGU}', "");
    Expect(1, 3200, '\P{Script= 	TELUGU}', "");
    Expect(0, 3200, '\P{^Script= 	TELUGU}', "");
    Error('\p{Sc=-_Telu:=}');
    Error('\P{Sc=-_Telu:=}');
    Expect(1, 3199, '\p{Sc=:\ATelu\z:}', "");;
    Expect(0, 3200, '\p{Sc=:\ATelu\z:}', "");;
    Expect(1, 3199, '\p{Sc=telu}', "");
    Expect(0, 3199, '\p{^Sc=telu}', "");
    Expect(0, 3199, '\P{Sc=telu}', "");
    Expect(1, 3199, '\P{^Sc=telu}', "");
    Expect(0, 3200, '\p{Sc=telu}', "");
    Expect(1, 3200, '\p{^Sc=telu}', "");
    Expect(1, 3200, '\P{Sc=telu}', "");
    Expect(0, 3200, '\P{^Sc=telu}', "");
    Expect(1, 3199, '\p{Sc=:\Atelu\z:}', "");;
    Expect(0, 3200, '\p{Sc=:\Atelu\z:}', "");;
    Expect(1, 3199, '\p{Sc=_	TELU}', "");
    Expect(0, 3199, '\p{^Sc=_	TELU}', "");
    Expect(0, 3199, '\P{Sc=_	TELU}', "");
    Expect(1, 3199, '\P{^Sc=_	TELU}', "");
    Expect(0, 3200, '\p{Sc=_	TELU}', "");
    Expect(1, 3200, '\p{^Sc=_	TELU}', "");
    Expect(1, 3200, '\P{Sc=_	TELU}', "");
    Expect(0, 3200, '\P{^Sc=_	TELU}', "");
    Error('\p{Is_Script=:=	Telugu}');
    Error('\P{Is_Script=:=	Telugu}');
    Expect(1, 3199, '\p{Is_Script=telugu}', "");
    Expect(0, 3199, '\p{^Is_Script=telugu}', "");
    Expect(0, 3199, '\P{Is_Script=telugu}', "");
    Expect(1, 3199, '\P{^Is_Script=telugu}', "");
    Expect(0, 3200, '\p{Is_Script=telugu}', "");
    Expect(1, 3200, '\p{^Is_Script=telugu}', "");
    Expect(1, 3200, '\P{Is_Script=telugu}', "");
    Expect(0, 3200, '\P{^Is_Script=telugu}', "");
    Expect(1, 3199, '\p{Is_Script=	Telugu}', "");
    Expect(0, 3199, '\p{^Is_Script=	Telugu}', "");
    Expect(0, 3199, '\P{Is_Script=	Telugu}', "");
    Expect(1, 3199, '\P{^Is_Script=	Telugu}', "");
    Expect(0, 3200, '\p{Is_Script=	Telugu}', "");
    Expect(1, 3200, '\p{^Is_Script=	Telugu}', "");
    Expect(1, 3200, '\P{Is_Script=	Telugu}', "");
    Expect(0, 3200, '\P{^Is_Script=	Telugu}', "");
    Error('\p{Is_Sc::=_telu}');
    Error('\P{Is_Sc::=_telu}');
    Expect(1, 3199, '\p{Is_Sc=telu}', "");
    Expect(0, 3199, '\p{^Is_Sc=telu}', "");
    Expect(0, 3199, '\P{Is_Sc=telu}', "");
    Expect(1, 3199, '\P{^Is_Sc=telu}', "");
    Expect(0, 3200, '\p{Is_Sc=telu}', "");
    Expect(1, 3200, '\p{^Is_Sc=telu}', "");
    Expect(1, 3200, '\P{Is_Sc=telu}', "");
    Expect(0, 3200, '\P{^Is_Sc=telu}', "");
    Expect(1, 3199, '\p{Is_Sc=-Telu}', "");
    Expect(0, 3199, '\p{^Is_Sc=-Telu}', "");
    Expect(0, 3199, '\P{Is_Sc=-Telu}', "");
    Expect(1, 3199, '\P{^Is_Sc=-Telu}', "");
    Expect(0, 3200, '\p{Is_Sc=-Telu}', "");
    Expect(1, 3200, '\p{^Is_Sc=-Telu}', "");
    Expect(1, 3200, '\P{Is_Sc=-Telu}', "");
    Expect(0, 3200, '\P{^Is_Sc=-Telu}', "");
    Error('\p{Script=:=	Tifinagh}');
    Error('\P{Script=:=	Tifinagh}');
    Expect(1, 11647, '\p{Script=:\ATifinagh\z:}', "");;
    Expect(0, 11648, '\p{Script=:\ATifinagh\z:}', "");;
    Expect(1, 11647, '\p{Script=tifinagh}', "");
    Expect(0, 11647, '\p{^Script=tifinagh}', "");
    Expect(0, 11647, '\P{Script=tifinagh}', "");
    Expect(1, 11647, '\P{^Script=tifinagh}', "");
    Expect(0, 11648, '\p{Script=tifinagh}', "");
    Expect(1, 11648, '\p{^Script=tifinagh}', "");
    Expect(1, 11648, '\P{Script=tifinagh}', "");
    Expect(0, 11648, '\P{^Script=tifinagh}', "");
    Expect(1, 11647, '\p{Script=:\Atifinagh\z:}', "");;
    Expect(0, 11648, '\p{Script=:\Atifinagh\z:}', "");;
    Expect(1, 11647, '\p{Script= 	TIFINAGH}', "");
    Expect(0, 11647, '\p{^Script= 	TIFINAGH}', "");
    Expect(0, 11647, '\P{Script= 	TIFINAGH}', "");
    Expect(1, 11647, '\P{^Script= 	TIFINAGH}', "");
    Expect(0, 11648, '\p{Script= 	TIFINAGH}', "");
    Expect(1, 11648, '\p{^Script= 	TIFINAGH}', "");
    Expect(1, 11648, '\P{Script= 	TIFINAGH}', "");
    Expect(0, 11648, '\P{^Script= 	TIFINAGH}', "");
    Error('\p{Sc=	 Tfng:=}');
    Error('\P{Sc=	 Tfng:=}');
    Expect(1, 11647, '\p{Sc=:\ATfng\z:}', "");;
    Expect(0, 11648, '\p{Sc=:\ATfng\z:}', "");;
    Expect(1, 11647, '\p{Sc=tfng}', "");
    Expect(0, 11647, '\p{^Sc=tfng}', "");
    Expect(0, 11647, '\P{Sc=tfng}', "");
    Expect(1, 11647, '\P{^Sc=tfng}', "");
    Expect(0, 11648, '\p{Sc=tfng}', "");
    Expect(1, 11648, '\p{^Sc=tfng}', "");
    Expect(1, 11648, '\P{Sc=tfng}', "");
    Expect(0, 11648, '\P{^Sc=tfng}', "");
    Expect(1, 11647, '\p{Sc=:\Atfng\z:}', "");;
    Expect(0, 11648, '\p{Sc=:\Atfng\z:}', "");;
    Expect(1, 11647, '\p{Sc:			tfng}', "");
    Expect(0, 11647, '\p{^Sc:			tfng}', "");
    Expect(0, 11647, '\P{Sc:			tfng}', "");
    Expect(1, 11647, '\P{^Sc:			tfng}', "");
    Expect(0, 11648, '\p{Sc:			tfng}', "");
    Expect(1, 11648, '\p{^Sc:			tfng}', "");
    Expect(1, 11648, '\P{Sc:			tfng}', "");
    Expect(0, 11648, '\P{^Sc:			tfng}', "");
    Error('\p{Is_Script=	:=Tifinagh}');
    Error('\P{Is_Script=	:=Tifinagh}');
    Expect(1, 11647, '\p{Is_Script=tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Script=tifinagh}', "");
    Expect(0, 11647, '\P{Is_Script=tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Script=tifinagh}', "");
    Expect(0, 11648, '\p{Is_Script=tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Script=tifinagh}', "");
    Expect(1, 11648, '\P{Is_Script=tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Script=tifinagh}', "");
    Expect(1, 11647, '\p{Is_Script=  tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Script=  tifinagh}', "");
    Expect(0, 11647, '\P{Is_Script=  tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Script=  tifinagh}', "");
    Expect(0, 11648, '\p{Is_Script=  tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Script=  tifinagh}', "");
    Expect(1, 11648, '\P{Is_Script=  tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Script=  tifinagh}', "");
    Error('\p{Is_Sc: -:=TFNG}');
    Error('\P{Is_Sc: -:=TFNG}');
    Expect(1, 11647, '\p{Is_Sc=tfng}', "");
    Expect(0, 11647, '\p{^Is_Sc=tfng}', "");
    Expect(0, 11647, '\P{Is_Sc=tfng}', "");
    Expect(1, 11647, '\P{^Is_Sc=tfng}', "");
    Expect(0, 11648, '\p{Is_Sc=tfng}', "");
    Expect(1, 11648, '\p{^Is_Sc=tfng}', "");
    Expect(1, 11648, '\P{Is_Sc=tfng}', "");
    Expect(0, 11648, '\P{^Is_Sc=tfng}', "");
    Expect(1, 11647, '\p{Is_Sc=- Tfng}', "");
    Expect(0, 11647, '\p{^Is_Sc=- Tfng}', "");
    Expect(0, 11647, '\P{Is_Sc=- Tfng}', "");
    Expect(1, 11647, '\P{^Is_Sc=- Tfng}', "");
    Expect(0, 11648, '\p{Is_Sc=- Tfng}', "");
    Expect(1, 11648, '\p{^Is_Sc=- Tfng}', "");
    Expect(1, 11648, '\P{Is_Sc=- Tfng}', "");
    Expect(0, 11648, '\P{^Is_Sc=- Tfng}', "");
    Error('\p{Script=:=_Tagalog}');
    Error('\P{Script=:=_Tagalog}');
    Expect(1, 5908, '\p{Script=:\ATagalog\z:}', "");;
    Expect(0, 5909, '\p{Script=:\ATagalog\z:}', "");;
    Expect(1, 5908, '\p{Script:   tagalog}', "");
    Expect(0, 5908, '\p{^Script:   tagalog}', "");
    Expect(0, 5908, '\P{Script:   tagalog}', "");
    Expect(1, 5908, '\P{^Script:   tagalog}', "");
    Expect(0, 5909, '\p{Script:   tagalog}', "");
    Expect(1, 5909, '\p{^Script:   tagalog}', "");
    Expect(1, 5909, '\P{Script:   tagalog}', "");
    Expect(0, 5909, '\P{^Script:   tagalog}', "");
    Expect(1, 5908, '\p{Script=:\Atagalog\z:}', "");;
    Expect(0, 5909, '\p{Script=:\Atagalog\z:}', "");;
    Expect(1, 5908, '\p{Script=_Tagalog}', "");
    Expect(0, 5908, '\p{^Script=_Tagalog}', "");
    Expect(0, 5908, '\P{Script=_Tagalog}', "");
    Expect(1, 5908, '\P{^Script=_Tagalog}', "");
    Expect(0, 5909, '\p{Script=_Tagalog}', "");
    Expect(1, 5909, '\p{^Script=_Tagalog}', "");
    Expect(1, 5909, '\P{Script=_Tagalog}', "");
    Expect(0, 5909, '\P{^Script=_Tagalog}', "");
    Error('\p{Sc=/a/-Tglg}');
    Error('\P{Sc=/a/-Tglg}');
    Expect(1, 5908, '\p{Sc=:\ATglg\z:}', "");;
    Expect(0, 5909, '\p{Sc=:\ATglg\z:}', "");;
    Expect(1, 5908, '\p{Sc=tglg}', "");
    Expect(0, 5908, '\p{^Sc=tglg}', "");
    Expect(0, 5908, '\P{Sc=tglg}', "");
    Expect(1, 5908, '\P{^Sc=tglg}', "");
    Expect(0, 5909, '\p{Sc=tglg}', "");
    Expect(1, 5909, '\p{^Sc=tglg}', "");
    Expect(1, 5909, '\P{Sc=tglg}', "");
    Expect(0, 5909, '\P{^Sc=tglg}', "");
    Expect(1, 5908, '\p{Sc=:\Atglg\z:}', "");;
    Expect(0, 5909, '\p{Sc=:\Atglg\z:}', "");;
    Expect(1, 5908, '\p{Sc=_tglg}', "");
    Expect(0, 5908, '\p{^Sc=_tglg}', "");
    Expect(0, 5908, '\P{Sc=_tglg}', "");
    Expect(1, 5908, '\P{^Sc=_tglg}', "");
    Expect(0, 5909, '\p{Sc=_tglg}', "");
    Expect(1, 5909, '\p{^Sc=_tglg}', "");
    Expect(1, 5909, '\P{Sc=_tglg}', "");
    Expect(0, 5909, '\P{^Sc=_tglg}', "");
    Error('\p{Is_Script=__tagalog:=}');
    Error('\P{Is_Script=__tagalog:=}');
    Expect(1, 5908, '\p{Is_Script=tagalog}', "");
    Expect(0, 5908, '\p{^Is_Script=tagalog}', "");
    Expect(0, 5908, '\P{Is_Script=tagalog}', "");
    Expect(1, 5908, '\P{^Is_Script=tagalog}', "");
    Expect(0, 5909, '\p{Is_Script=tagalog}', "");
    Expect(1, 5909, '\p{^Is_Script=tagalog}', "");
    Expect(1, 5909, '\P{Is_Script=tagalog}', "");
    Expect(0, 5909, '\P{^Is_Script=tagalog}', "");
    Expect(1, 5908, '\p{Is_Script=TAGALOG}', "");
    Expect(0, 5908, '\p{^Is_Script=TAGALOG}', "");
    Expect(0, 5908, '\P{Is_Script=TAGALOG}', "");
    Expect(1, 5908, '\P{^Is_Script=TAGALOG}', "");
    Expect(0, 5909, '\p{Is_Script=TAGALOG}', "");
    Expect(1, 5909, '\p{^Is_Script=TAGALOG}', "");
    Expect(1, 5909, '\P{Is_Script=TAGALOG}', "");
    Expect(0, 5909, '\P{^Is_Script=TAGALOG}', "");
    Error('\p{Is_Sc= -tglg:=}');
    Error('\P{Is_Sc= -tglg:=}');
    Expect(1, 5908, '\p{Is_Sc=tglg}', "");
    Expect(0, 5908, '\p{^Is_Sc=tglg}', "");
    Expect(0, 5908, '\P{Is_Sc=tglg}', "");
    Expect(1, 5908, '\P{^Is_Sc=tglg}', "");
    Expect(0, 5909, '\p{Is_Sc=tglg}', "");
    Expect(1, 5909, '\p{^Is_Sc=tglg}', "");
    Expect(1, 5909, '\P{Is_Sc=tglg}', "");
    Expect(0, 5909, '\P{^Is_Sc=tglg}', "");
    Expect(1, 5908, '\p{Is_Sc=-_Tglg}', "");
    Expect(0, 5908, '\p{^Is_Sc=-_Tglg}', "");
    Expect(0, 5908, '\P{Is_Sc=-_Tglg}', "");
    Expect(1, 5908, '\P{^Is_Sc=-_Tglg}', "");
    Expect(0, 5909, '\p{Is_Sc=-_Tglg}', "");
    Expect(1, 5909, '\p{^Is_Sc=-_Tglg}', "");
    Expect(1, 5909, '\P{Is_Sc=-_Tglg}', "");
    Expect(0, 5909, '\P{^Is_Sc=-_Tglg}', "");
    Error('\p{Script=:=_	Thaana}');
    Error('\P{Script=:=_	Thaana}');
    Expect(1, 1969, '\p{Script=:\AThaana\z:}', "");;
    Expect(0, 1970, '\p{Script=:\AThaana\z:}', "");;
    Expect(1, 1969, '\p{Script=thaana}', "");
    Expect(0, 1969, '\p{^Script=thaana}', "");
    Expect(0, 1969, '\P{Script=thaana}', "");
    Expect(1, 1969, '\P{^Script=thaana}', "");
    Expect(0, 1970, '\p{Script=thaana}', "");
    Expect(1, 1970, '\p{^Script=thaana}', "");
    Expect(1, 1970, '\P{Script=thaana}', "");
    Expect(0, 1970, '\P{^Script=thaana}', "");
    Expect(1, 1969, '\p{Script=:\Athaana\z:}', "");;
    Expect(0, 1970, '\p{Script=:\Athaana\z:}', "");;
    Expect(1, 1969, '\p{Script= THAANA}', "");
    Expect(0, 1969, '\p{^Script= THAANA}', "");
    Expect(0, 1969, '\P{Script= THAANA}', "");
    Expect(1, 1969, '\P{^Script= THAANA}', "");
    Expect(0, 1970, '\p{Script= THAANA}', "");
    Expect(1, 1970, '\p{^Script= THAANA}', "");
    Expect(1, 1970, '\P{Script= THAANA}', "");
    Expect(0, 1970, '\P{^Script= THAANA}', "");
    Error('\p{Sc:	  Thaa:=}');
    Error('\P{Sc:	  Thaa:=}');
    Expect(1, 1969, '\p{Sc=:\AThaa\z:}', "");;
    Expect(0, 1970, '\p{Sc=:\AThaa\z:}', "");;
    Expect(1, 1969, '\p{Sc: thaa}', "");
    Expect(0, 1969, '\p{^Sc: thaa}', "");
    Expect(0, 1969, '\P{Sc: thaa}', "");
    Expect(1, 1969, '\P{^Sc: thaa}', "");
    Expect(0, 1970, '\p{Sc: thaa}', "");
    Expect(1, 1970, '\p{^Sc: thaa}', "");
    Expect(1, 1970, '\P{Sc: thaa}', "");
    Expect(0, 1970, '\P{^Sc: thaa}', "");
    Expect(1, 1969, '\p{Sc=:\Athaa\z:}', "");;
    Expect(0, 1970, '\p{Sc=:\Athaa\z:}', "");;
    Expect(1, 1969, '\p{Sc=_	thaa}', "");
    Expect(0, 1969, '\p{^Sc=_	thaa}', "");
    Expect(0, 1969, '\P{Sc=_	thaa}', "");
    Expect(1, 1969, '\P{^Sc=_	thaa}', "");
    Expect(0, 1970, '\p{Sc=_	thaa}', "");
    Expect(1, 1970, '\p{^Sc=_	thaa}', "");
    Expect(1, 1970, '\P{Sc=_	thaa}', "");
    Expect(0, 1970, '\P{^Sc=_	thaa}', "");
    Error('\p{Is_Script=_THAANA/a/}');
    Error('\P{Is_Script=_THAANA/a/}');
    Expect(1, 1969, '\p{Is_Script=thaana}', "");
    Expect(0, 1969, '\p{^Is_Script=thaana}', "");
    Expect(0, 1969, '\P{Is_Script=thaana}', "");
    Expect(1, 1969, '\P{^Is_Script=thaana}', "");
    Expect(0, 1970, '\p{Is_Script=thaana}', "");
    Expect(1, 1970, '\p{^Is_Script=thaana}', "");
    Expect(1, 1970, '\P{Is_Script=thaana}', "");
    Expect(0, 1970, '\P{^Is_Script=thaana}', "");
    Expect(1, 1969, '\p{Is_Script=__Thaana}', "");
    Expect(0, 1969, '\p{^Is_Script=__Thaana}', "");
    Expect(0, 1969, '\P{Is_Script=__Thaana}', "");
    Expect(1, 1969, '\P{^Is_Script=__Thaana}', "");
    Expect(0, 1970, '\p{Is_Script=__Thaana}', "");
    Expect(1, 1970, '\p{^Is_Script=__Thaana}', "");
    Expect(1, 1970, '\P{Is_Script=__Thaana}', "");
    Expect(0, 1970, '\P{^Is_Script=__Thaana}', "");
    Error('\p{Is_Sc=_/a/THAA}');
    Error('\P{Is_Sc=_/a/THAA}');
    Expect(1, 1969, '\p{Is_Sc=thaa}', "");
    Expect(0, 1969, '\p{^Is_Sc=thaa}', "");
    Expect(0, 1969, '\P{Is_Sc=thaa}', "");
    Expect(1, 1969, '\P{^Is_Sc=thaa}', "");
    Expect(0, 1970, '\p{Is_Sc=thaa}', "");
    Expect(1, 1970, '\p{^Is_Sc=thaa}', "");
    Expect(1, 1970, '\P{Is_Sc=thaa}', "");
    Expect(0, 1970, '\P{^Is_Sc=thaa}', "");
    Expect(1, 1969, '\p{Is_Sc= _THAA}', "");
    Expect(0, 1969, '\p{^Is_Sc= _THAA}', "");
    Expect(0, 1969, '\P{Is_Sc= _THAA}', "");
    Expect(1, 1969, '\P{^Is_Sc= _THAA}', "");
    Expect(0, 1970, '\p{Is_Sc= _THAA}', "");
    Expect(1, 1970, '\p{^Is_Sc= _THAA}', "");
    Expect(1, 1970, '\P{Is_Sc= _THAA}', "");
    Expect(0, 1970, '\P{^Is_Sc= _THAA}', "");
    Error('\p{Script:	-/a/THAI}');
    Error('\P{Script:	-/a/THAI}');
    Expect(1, 3675, '\p{Script=:\AThai\z:}', "");;
    Expect(0, 3676, '\p{Script=:\AThai\z:}', "");;
    Expect(1, 3675, '\p{Script=thai}', "");
    Expect(0, 3675, '\p{^Script=thai}', "");
    Expect(0, 3675, '\P{Script=thai}', "");
    Expect(1, 3675, '\P{^Script=thai}', "");
    Expect(0, 3676, '\p{Script=thai}', "");
    Expect(1, 3676, '\p{^Script=thai}', "");
    Expect(1, 3676, '\P{Script=thai}', "");
    Expect(0, 3676, '\P{^Script=thai}', "");
    Expect(1, 3675, '\p{Script=:\Athai\z:}', "");;
    Expect(0, 3676, '\p{Script=:\Athai\z:}', "");;
    Expect(1, 3675, '\p{Script=--THAI}', "");
    Expect(0, 3675, '\p{^Script=--THAI}', "");
    Expect(0, 3675, '\P{Script=--THAI}', "");
    Expect(1, 3675, '\P{^Script=--THAI}', "");
    Expect(0, 3676, '\p{Script=--THAI}', "");
    Expect(1, 3676, '\p{^Script=--THAI}', "");
    Expect(1, 3676, '\P{Script=--THAI}', "");
    Expect(0, 3676, '\P{^Script=--THAI}', "");
    Error('\p{Sc=	 THAI:=}');
    Error('\P{Sc=	 THAI:=}');
    Expect(1, 3675, '\p{Sc=:\AThai\z:}', "");;
    Expect(0, 3676, '\p{Sc=:\AThai\z:}', "");;
    Expect(1, 3675, '\p{Sc=thai}', "");
    Expect(0, 3675, '\p{^Sc=thai}', "");
    Expect(0, 3675, '\P{Sc=thai}', "");
    Expect(1, 3675, '\P{^Sc=thai}', "");
    Expect(0, 3676, '\p{Sc=thai}', "");
    Expect(1, 3676, '\p{^Sc=thai}', "");
    Expect(1, 3676, '\P{Sc=thai}', "");
    Expect(0, 3676, '\P{^Sc=thai}', "");
    Expect(1, 3675, '\p{Sc=:\Athai\z:}', "");;
    Expect(0, 3676, '\p{Sc=:\Athai\z:}', "");;
    Expect(1, 3675, '\p{Sc=-_Thai}', "");
    Expect(0, 3675, '\p{^Sc=-_Thai}', "");
    Expect(0, 3675, '\P{Sc=-_Thai}', "");
    Expect(1, 3675, '\P{^Sc=-_Thai}', "");
    Expect(0, 3676, '\p{Sc=-_Thai}', "");
    Expect(1, 3676, '\p{^Sc=-_Thai}', "");
    Expect(1, 3676, '\P{Sc=-_Thai}', "");
    Expect(0, 3676, '\P{^Sc=-_Thai}', "");
    Error('\p{Is_Script=/a/  thai}');
    Error('\P{Is_Script=/a/  thai}');
    Expect(1, 3675, '\p{Is_Script=thai}', "");
    Expect(0, 3675, '\p{^Is_Script=thai}', "");
    Expect(0, 3675, '\P{Is_Script=thai}', "");
    Expect(1, 3675, '\P{^Is_Script=thai}', "");
    Expect(0, 3676, '\p{Is_Script=thai}', "");
    Expect(1, 3676, '\p{^Is_Script=thai}', "");
    Expect(1, 3676, '\P{Is_Script=thai}', "");
    Expect(0, 3676, '\P{^Is_Script=thai}', "");
    Expect(1, 3675, '\p{Is_Script=_THAI}', "");
    Expect(0, 3675, '\p{^Is_Script=_THAI}', "");
    Expect(0, 3675, '\P{Is_Script=_THAI}', "");
    Expect(1, 3675, '\P{^Is_Script=_THAI}', "");
    Expect(0, 3676, '\p{Is_Script=_THAI}', "");
    Expect(1, 3676, '\p{^Is_Script=_THAI}', "");
    Expect(1, 3676, '\P{Is_Script=_THAI}', "");
    Expect(0, 3676, '\P{^Is_Script=_THAI}', "");
    Error('\p{Is_Sc=:=THAI}');
    Error('\P{Is_Sc=:=THAI}');
    Expect(1, 3675, '\p{Is_Sc=thai}', "");
    Expect(0, 3675, '\p{^Is_Sc=thai}', "");
    Expect(0, 3675, '\P{Is_Sc=thai}', "");
    Expect(1, 3675, '\P{^Is_Sc=thai}', "");
    Expect(0, 3676, '\p{Is_Sc=thai}', "");
    Expect(1, 3676, '\p{^Is_Sc=thai}', "");
    Expect(1, 3676, '\P{Is_Sc=thai}', "");
    Expect(0, 3676, '\P{^Is_Sc=thai}', "");
    Expect(1, 3675, '\p{Is_Sc=-Thai}', "");
    Expect(0, 3675, '\p{^Is_Sc=-Thai}', "");
    Expect(0, 3675, '\P{Is_Sc=-Thai}', "");
    Expect(1, 3675, '\P{^Is_Sc=-Thai}', "");
    Expect(0, 3676, '\p{Is_Sc=-Thai}', "");
    Expect(1, 3676, '\p{^Is_Sc=-Thai}', "");
    Expect(1, 3676, '\P{Is_Sc=-Thai}', "");
    Expect(0, 3676, '\P{^Is_Sc=-Thai}', "");
    Error('\p{Script=_TIBETAN/a/}');
    Error('\P{Script=_TIBETAN/a/}');
    Expect(1, 4058, '\p{Script=:\ATibetan\z:}', "");;
    Expect(0, 4059, '\p{Script=:\ATibetan\z:}', "");;
    Expect(1, 4058, '\p{Script=tibetan}', "");
    Expect(0, 4058, '\p{^Script=tibetan}', "");
    Expect(0, 4058, '\P{Script=tibetan}', "");
    Expect(1, 4058, '\P{^Script=tibetan}', "");
    Expect(0, 4059, '\p{Script=tibetan}', "");
    Expect(1, 4059, '\p{^Script=tibetan}', "");
    Expect(1, 4059, '\P{Script=tibetan}', "");
    Expect(0, 4059, '\P{^Script=tibetan}', "");
    Expect(1, 4058, '\p{Script=:\Atibetan\z:}', "");;
    Expect(0, 4059, '\p{Script=:\Atibetan\z:}', "");;
    Expect(1, 4058, '\p{Script=	-TIBETAN}', "");
    Expect(0, 4058, '\p{^Script=	-TIBETAN}', "");
    Expect(0, 4058, '\P{Script=	-TIBETAN}', "");
    Expect(1, 4058, '\P{^Script=	-TIBETAN}', "");
    Expect(0, 4059, '\p{Script=	-TIBETAN}', "");
    Expect(1, 4059, '\p{^Script=	-TIBETAN}', "");
    Expect(1, 4059, '\P{Script=	-TIBETAN}', "");
    Expect(0, 4059, '\P{^Script=	-TIBETAN}', "");
    Error('\p{Sc= Tibt/a/}');
    Error('\P{Sc= Tibt/a/}');
    Expect(1, 4058, '\p{Sc=:\ATibt\z:}', "");;
    Expect(0, 4059, '\p{Sc=:\ATibt\z:}', "");;
    Expect(1, 4058, '\p{Sc=tibt}', "");
    Expect(0, 4058, '\p{^Sc=tibt}', "");
    Expect(0, 4058, '\P{Sc=tibt}', "");
    Expect(1, 4058, '\P{^Sc=tibt}', "");
    Expect(0, 4059, '\p{Sc=tibt}', "");
    Expect(1, 4059, '\p{^Sc=tibt}', "");
    Expect(1, 4059, '\P{Sc=tibt}', "");
    Expect(0, 4059, '\P{^Sc=tibt}', "");
    Expect(1, 4058, '\p{Sc=:\Atibt\z:}', "");;
    Expect(0, 4059, '\p{Sc=:\Atibt\z:}', "");;
    Expect(1, 4058, '\p{Sc=_-tibt}', "");
    Expect(0, 4058, '\p{^Sc=_-tibt}', "");
    Expect(0, 4058, '\P{Sc=_-tibt}', "");
    Expect(1, 4058, '\P{^Sc=_-tibt}', "");
    Expect(0, 4059, '\p{Sc=_-tibt}', "");
    Expect(1, 4059, '\p{^Sc=_-tibt}', "");
    Expect(1, 4059, '\P{Sc=_-tibt}', "");
    Expect(0, 4059, '\P{^Sc=_-tibt}', "");
    Error('\p{Is_Script:   -Tibetan/a/}');
    Error('\P{Is_Script:   -Tibetan/a/}');
    Expect(1, 4058, '\p{Is_Script=tibetan}', "");
    Expect(0, 4058, '\p{^Is_Script=tibetan}', "");
    Expect(0, 4058, '\P{Is_Script=tibetan}', "");
    Expect(1, 4058, '\P{^Is_Script=tibetan}', "");
    Expect(0, 4059, '\p{Is_Script=tibetan}', "");
    Expect(1, 4059, '\p{^Is_Script=tibetan}', "");
    Expect(1, 4059, '\P{Is_Script=tibetan}', "");
    Expect(0, 4059, '\P{^Is_Script=tibetan}', "");
    Expect(1, 4058, '\p{Is_Script=		tibetan}', "");
    Expect(0, 4058, '\p{^Is_Script=		tibetan}', "");
    Expect(0, 4058, '\P{Is_Script=		tibetan}', "");
    Expect(1, 4058, '\P{^Is_Script=		tibetan}', "");
    Expect(0, 4059, '\p{Is_Script=		tibetan}', "");
    Expect(1, 4059, '\p{^Is_Script=		tibetan}', "");
    Expect(1, 4059, '\P{Is_Script=		tibetan}', "");
    Expect(0, 4059, '\P{^Is_Script=		tibetan}', "");
    Error('\p{Is_Sc=	Tibt:=}');
    Error('\P{Is_Sc=	Tibt:=}');
    Expect(1, 4058, '\p{Is_Sc=tibt}', "");
    Expect(0, 4058, '\p{^Is_Sc=tibt}', "");
    Expect(0, 4058, '\P{Is_Sc=tibt}', "");
    Expect(1, 4058, '\P{^Is_Sc=tibt}', "");
    Expect(0, 4059, '\p{Is_Sc=tibt}', "");
    Expect(1, 4059, '\p{^Is_Sc=tibt}', "");
    Expect(1, 4059, '\P{Is_Sc=tibt}', "");
    Expect(0, 4059, '\P{^Is_Sc=tibt}', "");
    Expect(1, 4058, '\p{Is_Sc=-Tibt}', "");
    Expect(0, 4058, '\p{^Is_Sc=-Tibt}', "");
    Expect(0, 4058, '\P{Is_Sc=-Tibt}', "");
    Expect(1, 4058, '\P{^Is_Sc=-Tibt}', "");
    Expect(0, 4059, '\p{Is_Sc=-Tibt}', "");
    Expect(1, 4059, '\p{^Is_Sc=-Tibt}', "");
    Expect(1, 4059, '\P{Is_Sc=-Tibt}', "");
    Expect(0, 4059, '\P{^Is_Sc=-Tibt}', "");
    Error('\p{Script=-/a/Tirhuta}');
    Error('\P{Script=-/a/Tirhuta}');
    Expect(1, 70873, '\p{Script=:\ATirhuta\z:}', "");;
    Expect(0, 70874, '\p{Script=:\ATirhuta\z:}', "");;
    Expect(1, 70873, '\p{Script=tirhuta}', "");
    Expect(0, 70873, '\p{^Script=tirhuta}', "");
    Expect(0, 70873, '\P{Script=tirhuta}', "");
    Expect(1, 70873, '\P{^Script=tirhuta}', "");
    Expect(0, 70874, '\p{Script=tirhuta}', "");
    Expect(1, 70874, '\p{^Script=tirhuta}', "");
    Expect(1, 70874, '\P{Script=tirhuta}', "");
    Expect(0, 70874, '\P{^Script=tirhuta}', "");
    Expect(1, 70873, '\p{Script=:\Atirhuta\z:}', "");;
    Expect(0, 70874, '\p{Script=:\Atirhuta\z:}', "");;
    Expect(1, 70873, '\p{Script=_	tirhuta}', "");
    Expect(0, 70873, '\p{^Script=_	tirhuta}', "");
    Expect(0, 70873, '\P{Script=_	tirhuta}', "");
    Expect(1, 70873, '\P{^Script=_	tirhuta}', "");
    Expect(0, 70874, '\p{Script=_	tirhuta}', "");
    Expect(1, 70874, '\p{^Script=_	tirhuta}', "");
    Expect(1, 70874, '\P{Script=_	tirhuta}', "");
    Expect(0, 70874, '\P{^Script=_	tirhuta}', "");
    Error('\p{Sc=_	Tirh/a/}');
    Error('\P{Sc=_	Tirh/a/}');
    Expect(1, 70873, '\p{Sc=:\ATirh\z:}', "");;
    Expect(0, 70874, '\p{Sc=:\ATirh\z:}', "");;
    Expect(1, 70873, '\p{Sc=tirh}', "");
    Expect(0, 70873, '\p{^Sc=tirh}', "");
    Expect(0, 70873, '\P{Sc=tirh}', "");
    Expect(1, 70873, '\P{^Sc=tirh}', "");
    Expect(0, 70874, '\p{Sc=tirh}', "");
    Expect(1, 70874, '\p{^Sc=tirh}', "");
    Expect(1, 70874, '\P{Sc=tirh}', "");
    Expect(0, 70874, '\P{^Sc=tirh}', "");
    Expect(1, 70873, '\p{Sc=:\Atirh\z:}', "");;
    Expect(0, 70874, '\p{Sc=:\Atirh\z:}', "");;
    Expect(1, 70873, '\p{Sc= Tirh}', "");
    Expect(0, 70873, '\p{^Sc= Tirh}', "");
    Expect(0, 70873, '\P{Sc= Tirh}', "");
    Expect(1, 70873, '\P{^Sc= Tirh}', "");
    Expect(0, 70874, '\p{Sc= Tirh}', "");
    Expect(1, 70874, '\p{^Sc= Tirh}', "");
    Expect(1, 70874, '\P{Sc= Tirh}', "");
    Expect(0, 70874, '\P{^Sc= Tirh}', "");
    Error('\p{Is_Script=/a/-	TIRHUTA}');
    Error('\P{Is_Script=/a/-	TIRHUTA}');
    Expect(1, 70873, '\p{Is_Script=tirhuta}', "");
    Expect(0, 70873, '\p{^Is_Script=tirhuta}', "");
    Expect(0, 70873, '\P{Is_Script=tirhuta}', "");
    Expect(1, 70873, '\P{^Is_Script=tirhuta}', "");
    Expect(0, 70874, '\p{Is_Script=tirhuta}', "");
    Expect(1, 70874, '\p{^Is_Script=tirhuta}', "");
    Expect(1, 70874, '\P{Is_Script=tirhuta}', "");
    Expect(0, 70874, '\P{^Is_Script=tirhuta}', "");
    Expect(1, 70873, '\p{Is_Script=	 tirhuta}', "");
    Expect(0, 70873, '\p{^Is_Script=	 tirhuta}', "");
    Expect(0, 70873, '\P{Is_Script=	 tirhuta}', "");
    Expect(1, 70873, '\P{^Is_Script=	 tirhuta}', "");
    Expect(0, 70874, '\p{Is_Script=	 tirhuta}', "");
    Expect(1, 70874, '\p{^Is_Script=	 tirhuta}', "");
    Expect(1, 70874, '\P{Is_Script=	 tirhuta}', "");
    Expect(0, 70874, '\P{^Is_Script=	 tirhuta}', "");
    Error('\p{Is_Sc=	/a/tirh}');
    Error('\P{Is_Sc=	/a/tirh}');
    Expect(1, 70873, '\p{Is_Sc=tirh}', "");
    Expect(0, 70873, '\p{^Is_Sc=tirh}', "");
    Expect(0, 70873, '\P{Is_Sc=tirh}', "");
    Expect(1, 70873, '\P{^Is_Sc=tirh}', "");
    Expect(0, 70874, '\p{Is_Sc=tirh}', "");
    Expect(1, 70874, '\p{^Is_Sc=tirh}', "");
    Expect(1, 70874, '\P{Is_Sc=tirh}', "");
    Expect(0, 70874, '\P{^Is_Sc=tirh}', "");
    Expect(1, 70873, '\p{Is_Sc=	 TIRH}', "");
    Expect(0, 70873, '\p{^Is_Sc=	 TIRH}', "");
    Expect(0, 70873, '\P{Is_Sc=	 TIRH}', "");
    Expect(1, 70873, '\P{^Is_Sc=	 TIRH}', "");
    Expect(0, 70874, '\p{Is_Sc=	 TIRH}', "");
    Expect(1, 70874, '\p{^Is_Sc=	 TIRH}', "");
    Expect(1, 70874, '\P{Is_Sc=	 TIRH}', "");
    Expect(0, 70874, '\P{^Is_Sc=	 TIRH}', "");
    Error('\p{Script=:= _Ugaritic}');
    Error('\P{Script=:= _Ugaritic}');
    Expect(1, 66463, '\p{Script=:\AUgaritic\z:}', "");;
    Expect(0, 66464, '\p{Script=:\AUgaritic\z:}', "");;
    Expect(1, 66463, '\p{Script=ugaritic}', "");
    Expect(0, 66463, '\p{^Script=ugaritic}', "");
    Expect(0, 66463, '\P{Script=ugaritic}', "");
    Expect(1, 66463, '\P{^Script=ugaritic}', "");
    Expect(0, 66464, '\p{Script=ugaritic}', "");
    Expect(1, 66464, '\p{^Script=ugaritic}', "");
    Expect(1, 66464, '\P{Script=ugaritic}', "");
    Expect(0, 66464, '\P{^Script=ugaritic}', "");
    Expect(1, 66463, '\p{Script=:\Augaritic\z:}', "");;
    Expect(0, 66464, '\p{Script=:\Augaritic\z:}', "");;
    Expect(1, 66463, '\p{Script=		Ugaritic}', "");
    Expect(0, 66463, '\p{^Script=		Ugaritic}', "");
    Expect(0, 66463, '\P{Script=		Ugaritic}', "");
    Expect(1, 66463, '\P{^Script=		Ugaritic}', "");
    Expect(0, 66464, '\p{Script=		Ugaritic}', "");
    Expect(1, 66464, '\p{^Script=		Ugaritic}', "");
    Expect(1, 66464, '\P{Script=		Ugaritic}', "");
    Expect(0, 66464, '\P{^Script=		Ugaritic}', "");
    Error('\p{Sc=_Ugar/a/}');
    Error('\P{Sc=_Ugar/a/}');
    Expect(1, 66463, '\p{Sc=:\AUgar\z:}', "");;
    Expect(0, 66464, '\p{Sc=:\AUgar\z:}', "");;
    Expect(1, 66463, '\p{Sc=ugar}', "");
    Expect(0, 66463, '\p{^Sc=ugar}', "");
    Expect(0, 66463, '\P{Sc=ugar}', "");
    Expect(1, 66463, '\P{^Sc=ugar}', "");
    Expect(0, 66464, '\p{Sc=ugar}', "");
    Expect(1, 66464, '\p{^Sc=ugar}', "");
    Expect(1, 66464, '\P{Sc=ugar}', "");
    Expect(0, 66464, '\P{^Sc=ugar}', "");
    Expect(1, 66463, '\p{Sc=:\Augar\z:}', "");;
    Expect(0, 66464, '\p{Sc=:\Augar\z:}', "");;
    Expect(1, 66463, '\p{Sc= _ugar}', "");
    Expect(0, 66463, '\p{^Sc= _ugar}', "");
    Expect(0, 66463, '\P{Sc= _ugar}', "");
    Expect(1, 66463, '\P{^Sc= _ugar}', "");
    Expect(0, 66464, '\p{Sc= _ugar}', "");
    Expect(1, 66464, '\p{^Sc= _ugar}', "");
    Expect(1, 66464, '\P{Sc= _ugar}', "");
    Expect(0, 66464, '\P{^Sc= _ugar}', "");
    Error('\p{Is_Script= /a/ugaritic}');
    Error('\P{Is_Script= /a/ugaritic}');
    Expect(1, 66463, '\p{Is_Script: ugaritic}', "");
    Expect(0, 66463, '\p{^Is_Script: ugaritic}', "");
    Expect(0, 66463, '\P{Is_Script: ugaritic}', "");
    Expect(1, 66463, '\P{^Is_Script: ugaritic}', "");
    Expect(0, 66464, '\p{Is_Script: ugaritic}', "");
    Expect(1, 66464, '\p{^Is_Script: ugaritic}', "");
    Expect(1, 66464, '\P{Is_Script: ugaritic}', "");
    Expect(0, 66464, '\P{^Is_Script: ugaritic}', "");
    Expect(1, 66463, '\p{Is_Script= Ugaritic}', "");
    Expect(0, 66463, '\p{^Is_Script= Ugaritic}', "");
    Expect(0, 66463, '\P{Is_Script= Ugaritic}', "");
    Expect(1, 66463, '\P{^Is_Script= Ugaritic}', "");
    Expect(0, 66464, '\p{Is_Script= Ugaritic}', "");
    Expect(1, 66464, '\p{^Is_Script= Ugaritic}', "");
    Expect(1, 66464, '\P{Is_Script= Ugaritic}', "");
    Expect(0, 66464, '\P{^Is_Script= Ugaritic}', "");
    Error('\p{Is_Sc:    /a/ugar}');
    Error('\P{Is_Sc:    /a/ugar}');
    Expect(1, 66463, '\p{Is_Sc=ugar}', "");
    Expect(0, 66463, '\p{^Is_Sc=ugar}', "");
    Expect(0, 66463, '\P{Is_Sc=ugar}', "");
    Expect(1, 66463, '\P{^Is_Sc=ugar}', "");
    Expect(0, 66464, '\p{Is_Sc=ugar}', "");
    Expect(1, 66464, '\p{^Is_Sc=ugar}', "");
    Expect(1, 66464, '\P{Is_Sc=ugar}', "");
    Expect(0, 66464, '\P{^Is_Sc=ugar}', "");
    Expect(1, 66463, '\p{Is_Sc= 	ugar}', "");
    Expect(0, 66463, '\p{^Is_Sc= 	ugar}', "");
    Expect(0, 66463, '\P{Is_Sc= 	ugar}', "");
    Expect(1, 66463, '\P{^Is_Sc= 	ugar}', "");
    Expect(0, 66464, '\p{Is_Sc= 	ugar}', "");
    Expect(1, 66464, '\p{^Is_Sc= 	ugar}', "");
    Expect(1, 66464, '\P{Is_Sc= 	ugar}', "");
    Expect(0, 66464, '\P{^Is_Sc= 	ugar}', "");
    Error('\p{Script:    Vai:=}');
    Error('\P{Script:    Vai:=}');
    Expect(1, 42539, '\p{Script=:\AVai\z:}', "");;
    Expect(0, 42540, '\p{Script=:\AVai\z:}', "");;
    Expect(1, 42539, '\p{Script:   vai}', "");
    Expect(0, 42539, '\p{^Script:   vai}', "");
    Expect(0, 42539, '\P{Script:   vai}', "");
    Expect(1, 42539, '\P{^Script:   vai}', "");
    Expect(0, 42540, '\p{Script:   vai}', "");
    Expect(1, 42540, '\p{^Script:   vai}', "");
    Expect(1, 42540, '\P{Script:   vai}', "");
    Expect(0, 42540, '\P{^Script:   vai}', "");
    Expect(1, 42539, '\p{Script=:\Avai\z:}', "");;
    Expect(0, 42540, '\p{Script=:\Avai\z:}', "");;
    Expect(1, 42539, '\p{Script=_	Vai}', "");
    Expect(0, 42539, '\p{^Script=_	Vai}', "");
    Expect(0, 42539, '\P{Script=_	Vai}', "");
    Expect(1, 42539, '\P{^Script=_	Vai}', "");
    Expect(0, 42540, '\p{Script=_	Vai}', "");
    Expect(1, 42540, '\p{^Script=_	Vai}', "");
    Expect(1, 42540, '\P{Script=_	Vai}', "");
    Expect(0, 42540, '\P{^Script=_	Vai}', "");
    Error('\p{Sc=- Vaii:=}');
    Error('\P{Sc=- Vaii:=}');
    Expect(1, 42539, '\p{Sc=:\AVaii\z:}', "");;
    Expect(0, 42540, '\p{Sc=:\AVaii\z:}', "");;
    Expect(1, 42539, '\p{Sc=vaii}', "");
    Expect(0, 42539, '\p{^Sc=vaii}', "");
    Expect(0, 42539, '\P{Sc=vaii}', "");
    Expect(1, 42539, '\P{^Sc=vaii}', "");
    Expect(0, 42540, '\p{Sc=vaii}', "");
    Expect(1, 42540, '\p{^Sc=vaii}', "");
    Expect(1, 42540, '\P{Sc=vaii}', "");
    Expect(0, 42540, '\P{^Sc=vaii}', "");
    Expect(1, 42539, '\p{Sc=:\Avaii\z:}', "");;
    Expect(0, 42540, '\p{Sc=:\Avaii\z:}', "");;
    Expect(1, 42539, '\p{Sc=--VAII}', "");
    Expect(0, 42539, '\p{^Sc=--VAII}', "");
    Expect(0, 42539, '\P{Sc=--VAII}', "");
    Expect(1, 42539, '\P{^Sc=--VAII}', "");
    Expect(0, 42540, '\p{Sc=--VAII}', "");
    Expect(1, 42540, '\p{^Sc=--VAII}', "");
    Expect(1, 42540, '\P{Sc=--VAII}', "");
    Expect(0, 42540, '\P{^Sc=--VAII}', "");
    Error('\p{Is_Script=-Vai:=}');
    Error('\P{Is_Script=-Vai:=}');
    Expect(1, 42539, '\p{Is_Script=vai}', "");
    Expect(0, 42539, '\p{^Is_Script=vai}', "");
    Expect(0, 42539, '\P{Is_Script=vai}', "");
    Expect(1, 42539, '\P{^Is_Script=vai}', "");
    Expect(0, 42540, '\p{Is_Script=vai}', "");
    Expect(1, 42540, '\p{^Is_Script=vai}', "");
    Expect(1, 42540, '\P{Is_Script=vai}', "");
    Expect(0, 42540, '\P{^Is_Script=vai}', "");
    Expect(1, 42539, '\p{Is_Script= 	VAI}', "");
    Expect(0, 42539, '\p{^Is_Script= 	VAI}', "");
    Expect(0, 42539, '\P{Is_Script= 	VAI}', "");
    Expect(1, 42539, '\P{^Is_Script= 	VAI}', "");
    Expect(0, 42540, '\p{Is_Script= 	VAI}', "");
    Expect(1, 42540, '\p{^Is_Script= 	VAI}', "");
    Expect(1, 42540, '\P{Is_Script= 	VAI}', "");
    Expect(0, 42540, '\P{^Is_Script= 	VAI}', "");
    Error('\p{Is_Sc= :=Vaii}');
    Error('\P{Is_Sc= :=Vaii}');
    Expect(1, 42539, '\p{Is_Sc=vaii}', "");
    Expect(0, 42539, '\p{^Is_Sc=vaii}', "");
    Expect(0, 42539, '\P{Is_Sc=vaii}', "");
    Expect(1, 42539, '\P{^Is_Sc=vaii}', "");
    Expect(0, 42540, '\p{Is_Sc=vaii}', "");
    Expect(1, 42540, '\p{^Is_Sc=vaii}', "");
    Expect(1, 42540, '\P{Is_Sc=vaii}', "");
    Expect(0, 42540, '\P{^Is_Sc=vaii}', "");
    Expect(1, 42539, '\p{Is_Sc=	vaii}', "");
    Expect(0, 42539, '\p{^Is_Sc=	vaii}', "");
    Expect(0, 42539, '\P{Is_Sc=	vaii}', "");
    Expect(1, 42539, '\P{^Is_Sc=	vaii}', "");
    Expect(0, 42540, '\p{Is_Sc=	vaii}', "");
    Expect(1, 42540, '\p{^Is_Sc=	vaii}', "");
    Expect(1, 42540, '\P{Is_Sc=	vaii}', "");
    Expect(0, 42540, '\P{^Is_Sc=	vaii}', "");
    Error('\p{Script: -:=Warang_citi}');
    Error('\P{Script: -:=Warang_citi}');
    Expect(1, 71935, '\p{Script=:\AWarang_Citi\z:}', "");;
    Expect(0, 71936, '\p{Script=:\AWarang_Citi\z:}', "");;
    Expect(1, 71935, '\p{Script=warangciti}', "");
    Expect(0, 71935, '\p{^Script=warangciti}', "");
    Expect(0, 71935, '\P{Script=warangciti}', "");
    Expect(1, 71935, '\P{^Script=warangciti}', "");
    Expect(0, 71936, '\p{Script=warangciti}', "");
    Expect(1, 71936, '\p{^Script=warangciti}', "");
    Expect(1, 71936, '\P{Script=warangciti}', "");
    Expect(0, 71936, '\P{^Script=warangciti}', "");
    Expect(1, 71935, '\p{Script=:\Awarangciti\z:}', "");;
    Expect(0, 71936, '\p{Script=:\Awarangciti\z:}', "");;
    Expect(1, 71935, '\p{Script=- Warang_CITI}', "");
    Expect(0, 71935, '\p{^Script=- Warang_CITI}', "");
    Expect(0, 71935, '\P{Script=- Warang_CITI}', "");
    Expect(1, 71935, '\P{^Script=- Warang_CITI}', "");
    Expect(0, 71936, '\p{Script=- Warang_CITI}', "");
    Expect(1, 71936, '\p{^Script=- Warang_CITI}', "");
    Expect(1, 71936, '\P{Script=- Warang_CITI}', "");
    Expect(0, 71936, '\P{^Script=- Warang_CITI}', "");
    Error('\p{Sc=-:=WARA}');
    Error('\P{Sc=-:=WARA}');
    Expect(1, 71935, '\p{Sc=:\AWara\z:}', "");;
    Expect(0, 71936, '\p{Sc=:\AWara\z:}', "");;
    Expect(1, 71935, '\p{Sc:wara}', "");
    Expect(0, 71935, '\p{^Sc:wara}', "");
    Expect(0, 71935, '\P{Sc:wara}', "");
    Expect(1, 71935, '\P{^Sc:wara}', "");
    Expect(0, 71936, '\p{Sc:wara}', "");
    Expect(1, 71936, '\p{^Sc:wara}', "");
    Expect(1, 71936, '\P{Sc:wara}', "");
    Expect(0, 71936, '\P{^Sc:wara}', "");
    Expect(1, 71935, '\p{Sc=:\Awara\z:}', "");;
    Expect(0, 71936, '\p{Sc=:\Awara\z:}', "");;
    Expect(1, 71935, '\p{Sc:	  Wara}', "");
    Expect(0, 71935, '\p{^Sc:	  Wara}', "");
    Expect(0, 71935, '\P{Sc:	  Wara}', "");
    Expect(1, 71935, '\P{^Sc:	  Wara}', "");
    Expect(0, 71936, '\p{Sc:	  Wara}', "");
    Expect(1, 71936, '\p{^Sc:	  Wara}', "");
    Expect(1, 71936, '\P{Sc:	  Wara}', "");
    Expect(0, 71936, '\P{^Sc:	  Wara}', "");
    Error('\p{Is_Script=:=_-warang_citi}');
    Error('\P{Is_Script=:=_-warang_citi}');
    Expect(1, 71935, '\p{Is_Script=warangciti}', "");
    Expect(0, 71935, '\p{^Is_Script=warangciti}', "");
    Expect(0, 71935, '\P{Is_Script=warangciti}', "");
    Expect(1, 71935, '\P{^Is_Script=warangciti}', "");
    Expect(0, 71936, '\p{Is_Script=warangciti}', "");
    Expect(1, 71936, '\p{^Is_Script=warangciti}', "");
    Expect(1, 71936, '\P{Is_Script=warangciti}', "");
    Expect(0, 71936, '\P{^Is_Script=warangciti}', "");
    Expect(1, 71935, '\p{Is_Script=- warang_CITI}', "");
    Expect(0, 71935, '\p{^Is_Script=- warang_CITI}', "");
    Expect(0, 71935, '\P{Is_Script=- warang_CITI}', "");
    Expect(1, 71935, '\P{^Is_Script=- warang_CITI}', "");
    Expect(0, 71936, '\p{Is_Script=- warang_CITI}', "");
    Expect(1, 71936, '\p{^Is_Script=- warang_CITI}', "");
    Expect(1, 71936, '\P{Is_Script=- warang_CITI}', "");
    Expect(0, 71936, '\P{^Is_Script=- warang_CITI}', "");
    Error('\p{Is_Sc=Wara:=}');
    Error('\P{Is_Sc=Wara:=}');
    Expect(1, 71935, '\p{Is_Sc=wara}', "");
    Expect(0, 71935, '\p{^Is_Sc=wara}', "");
    Expect(0, 71935, '\P{Is_Sc=wara}', "");
    Expect(1, 71935, '\P{^Is_Sc=wara}', "");
    Expect(0, 71936, '\p{Is_Sc=wara}', "");
    Expect(1, 71936, '\p{^Is_Sc=wara}', "");
    Expect(1, 71936, '\P{Is_Sc=wara}', "");
    Expect(0, 71936, '\P{^Is_Sc=wara}', "");
    Expect(1, 71935, '\p{Is_Sc=-WARA}', "");
    Expect(0, 71935, '\p{^Is_Sc=-WARA}', "");
    Expect(0, 71935, '\P{Is_Sc=-WARA}', "");
    Expect(1, 71935, '\P{^Is_Sc=-WARA}', "");
    Expect(0, 71936, '\p{Is_Sc=-WARA}', "");
    Expect(1, 71936, '\p{^Is_Sc=-WARA}', "");
    Expect(1, 71936, '\P{Is_Sc=-WARA}', "");
    Expect(0, 71936, '\P{^Is_Sc=-WARA}', "");
    Error('\p{Script= :=Wancho}');
    Error('\P{Script= :=Wancho}');
    Expect(1, 123647, '\p{Script=:\AWancho\z:}', "");;
    Expect(0, 123648, '\p{Script=:\AWancho\z:}', "");;
    Expect(1, 123647, '\p{Script:	wancho}', "");
    Expect(0, 123647, '\p{^Script:	wancho}', "");
    Expect(0, 123647, '\P{Script:	wancho}', "");
    Expect(1, 123647, '\P{^Script:	wancho}', "");
    Expect(0, 123648, '\p{Script:	wancho}', "");
    Expect(1, 123648, '\p{^Script:	wancho}', "");
    Expect(1, 123648, '\P{Script:	wancho}', "");
    Expect(0, 123648, '\P{^Script:	wancho}', "");
    Expect(1, 123647, '\p{Script=:\Awancho\z:}', "");;
    Expect(0, 123648, '\p{Script=:\Awancho\z:}', "");;
    Expect(1, 123647, '\p{Script=	-Wancho}', "");
    Expect(0, 123647, '\p{^Script=	-Wancho}', "");
    Expect(0, 123647, '\P{Script=	-Wancho}', "");
    Expect(1, 123647, '\P{^Script=	-Wancho}', "");
    Expect(0, 123648, '\p{Script=	-Wancho}', "");
    Expect(1, 123648, '\p{^Script=	-Wancho}', "");
    Expect(1, 123648, '\P{Script=	-Wancho}', "");
    Expect(0, 123648, '\P{^Script=	-Wancho}', "");
    Error('\p{Sc=_-WCHO:=}');
    Error('\P{Sc=_-WCHO:=}');
    Expect(1, 123647, '\p{Sc=:\AWcho\z:}', "");;
    Expect(0, 123648, '\p{Sc=:\AWcho\z:}', "");;
    Expect(1, 123647, '\p{Sc=wcho}', "");
    Expect(0, 123647, '\p{^Sc=wcho}', "");
    Expect(0, 123647, '\P{Sc=wcho}', "");
    Expect(1, 123647, '\P{^Sc=wcho}', "");
    Expect(0, 123648, '\p{Sc=wcho}', "");
    Expect(1, 123648, '\p{^Sc=wcho}', "");
    Expect(1, 123648, '\P{Sc=wcho}', "");
    Expect(0, 123648, '\P{^Sc=wcho}', "");
    Expect(1, 123647, '\p{Sc=:\Awcho\z:}', "");;
    Expect(0, 123648, '\p{Sc=:\Awcho\z:}', "");;
    Expect(1, 123647, '\p{Sc=-WCHO}', "");
    Expect(0, 123647, '\p{^Sc=-WCHO}', "");
    Expect(0, 123647, '\P{Sc=-WCHO}', "");
    Expect(1, 123647, '\P{^Sc=-WCHO}', "");
    Expect(0, 123648, '\p{Sc=-WCHO}', "");
    Expect(1, 123648, '\p{^Sc=-WCHO}', "");
    Expect(1, 123648, '\P{Sc=-WCHO}', "");
    Expect(0, 123648, '\P{^Sc=-WCHO}', "");
    Error('\p{Is_Script=/a/	_Wancho}');
    Error('\P{Is_Script=/a/	_Wancho}');
    Expect(1, 123647, '\p{Is_Script=wancho}', "");
    Expect(0, 123647, '\p{^Is_Script=wancho}', "");
    Expect(0, 123647, '\P{Is_Script=wancho}', "");
    Expect(1, 123647, '\P{^Is_Script=wancho}', "");
    Expect(0, 123648, '\p{Is_Script=wancho}', "");
    Expect(1, 123648, '\p{^Is_Script=wancho}', "");
    Expect(1, 123648, '\P{Is_Script=wancho}', "");
    Expect(0, 123648, '\P{^Is_Script=wancho}', "");
    Expect(1, 123647, '\p{Is_Script=	 Wancho}', "");
    Expect(0, 123647, '\p{^Is_Script=	 Wancho}', "");
    Expect(0, 123647, '\P{Is_Script=	 Wancho}', "");
    Expect(1, 123647, '\P{^Is_Script=	 Wancho}', "");
    Expect(0, 123648, '\p{Is_Script=	 Wancho}', "");
    Expect(1, 123648, '\p{^Is_Script=	 Wancho}', "");
    Expect(1, 123648, '\P{Is_Script=	 Wancho}', "");
    Expect(0, 123648, '\P{^Is_Script=	 Wancho}', "");
    Error('\p{Is_Sc= WCHO:=}');
    Error('\P{Is_Sc= WCHO:=}');
    Expect(1, 123647, '\p{Is_Sc=wcho}', "");
    Expect(0, 123647, '\p{^Is_Sc=wcho}', "");
    Expect(0, 123647, '\P{Is_Sc=wcho}', "");
    Expect(1, 123647, '\P{^Is_Sc=wcho}', "");
    Expect(0, 123648, '\p{Is_Sc=wcho}', "");
    Expect(1, 123648, '\p{^Is_Sc=wcho}', "");
    Expect(1, 123648, '\P{Is_Sc=wcho}', "");
    Expect(0, 123648, '\P{^Is_Sc=wcho}', "");
    Expect(1, 123647, '\p{Is_Sc=	 Wcho}', "");
    Expect(0, 123647, '\p{^Is_Sc=	 Wcho}', "");
    Expect(0, 123647, '\P{Is_Sc=	 Wcho}', "");
    Expect(1, 123647, '\P{^Is_Sc=	 Wcho}', "");
    Expect(0, 123648, '\p{Is_Sc=	 Wcho}', "");
    Expect(1, 123648, '\p{^Is_Sc=	 Wcho}', "");
    Expect(1, 123648, '\P{Is_Sc=	 Wcho}', "");
    Expect(0, 123648, '\P{^Is_Sc=	 Wcho}', "");
    Error('\p{Script=_OLD_Persian/a/}');
    Error('\P{Script=_OLD_Persian/a/}');
    Expect(1, 66517, '\p{Script=:\AOld_Persian\z:}', "");;
    Expect(0, 66518, '\p{Script=:\AOld_Persian\z:}', "");;
    Expect(1, 66517, '\p{Script=oldpersian}', "");
    Expect(0, 66517, '\p{^Script=oldpersian}', "");
    Expect(0, 66517, '\P{Script=oldpersian}', "");
    Expect(1, 66517, '\P{^Script=oldpersian}', "");
    Expect(0, 66518, '\p{Script=oldpersian}', "");
    Expect(1, 66518, '\p{^Script=oldpersian}', "");
    Expect(1, 66518, '\P{Script=oldpersian}', "");
    Expect(0, 66518, '\P{^Script=oldpersian}', "");
    Expect(1, 66517, '\p{Script=:\Aoldpersian\z:}', "");;
    Expect(0, 66518, '\p{Script=:\Aoldpersian\z:}', "");;
    Expect(1, 66517, '\p{Script=_ Old_Persian}', "");
    Expect(0, 66517, '\p{^Script=_ Old_Persian}', "");
    Expect(0, 66517, '\P{Script=_ Old_Persian}', "");
    Expect(1, 66517, '\P{^Script=_ Old_Persian}', "");
    Expect(0, 66518, '\p{Script=_ Old_Persian}', "");
    Expect(1, 66518, '\p{^Script=_ Old_Persian}', "");
    Expect(1, 66518, '\P{Script=_ Old_Persian}', "");
    Expect(0, 66518, '\P{^Script=_ Old_Persian}', "");
    Error('\p{Sc=	 Xpeo:=}');
    Error('\P{Sc=	 Xpeo:=}');
    Expect(1, 66517, '\p{Sc=:\AXpeo\z:}', "");;
    Expect(0, 66518, '\p{Sc=:\AXpeo\z:}', "");;
    Expect(1, 66517, '\p{Sc=xpeo}', "");
    Expect(0, 66517, '\p{^Sc=xpeo}', "");
    Expect(0, 66517, '\P{Sc=xpeo}', "");
    Expect(1, 66517, '\P{^Sc=xpeo}', "");
    Expect(0, 66518, '\p{Sc=xpeo}', "");
    Expect(1, 66518, '\p{^Sc=xpeo}', "");
    Expect(1, 66518, '\P{Sc=xpeo}', "");
    Expect(0, 66518, '\P{^Sc=xpeo}', "");
    Expect(1, 66517, '\p{Sc=:\Axpeo\z:}', "");;
    Expect(0, 66518, '\p{Sc=:\Axpeo\z:}', "");;
    Expect(1, 66517, '\p{Sc:-	Xpeo}', "");
    Expect(0, 66517, '\p{^Sc:-	Xpeo}', "");
    Expect(0, 66517, '\P{Sc:-	Xpeo}', "");
    Expect(1, 66517, '\P{^Sc:-	Xpeo}', "");
    Expect(0, 66518, '\p{Sc:-	Xpeo}', "");
    Expect(1, 66518, '\p{^Sc:-	Xpeo}', "");
    Expect(1, 66518, '\P{Sc:-	Xpeo}', "");
    Expect(0, 66518, '\P{^Sc:-	Xpeo}', "");
    Error('\p{Is_Script=-/a/old_Persian}');
    Error('\P{Is_Script=-/a/old_Persian}');
    Expect(1, 66517, '\p{Is_Script=oldpersian}', "");
    Expect(0, 66517, '\p{^Is_Script=oldpersian}', "");
    Expect(0, 66517, '\P{Is_Script=oldpersian}', "");
    Expect(1, 66517, '\P{^Is_Script=oldpersian}', "");
    Expect(0, 66518, '\p{Is_Script=oldpersian}', "");
    Expect(1, 66518, '\p{^Is_Script=oldpersian}', "");
    Expect(1, 66518, '\P{Is_Script=oldpersian}', "");
    Expect(0, 66518, '\P{^Is_Script=oldpersian}', "");
    Expect(1, 66517, '\p{Is_Script=__OLD_PERSIAN}', "");
    Expect(0, 66517, '\p{^Is_Script=__OLD_PERSIAN}', "");
    Expect(0, 66517, '\P{Is_Script=__OLD_PERSIAN}', "");
    Expect(1, 66517, '\P{^Is_Script=__OLD_PERSIAN}', "");
    Expect(0, 66518, '\p{Is_Script=__OLD_PERSIAN}', "");
    Expect(1, 66518, '\p{^Is_Script=__OLD_PERSIAN}', "");
    Expect(1, 66518, '\P{Is_Script=__OLD_PERSIAN}', "");
    Expect(0, 66518, '\P{^Is_Script=__OLD_PERSIAN}', "");
    Error('\p{Is_Sc:	 :=xpeo}');
    Error('\P{Is_Sc:	 :=xpeo}');
    Expect(1, 66517, '\p{Is_Sc:	xpeo}', "");
    Expect(0, 66517, '\p{^Is_Sc:	xpeo}', "");
    Expect(0, 66517, '\P{Is_Sc:	xpeo}', "");
    Expect(1, 66517, '\P{^Is_Sc:	xpeo}', "");
    Expect(0, 66518, '\p{Is_Sc:	xpeo}', "");
    Expect(1, 66518, '\p{^Is_Sc:	xpeo}', "");
    Expect(1, 66518, '\P{Is_Sc:	xpeo}', "");
    Expect(0, 66518, '\P{^Is_Sc:	xpeo}', "");
    Expect(1, 66517, '\p{Is_Sc=-XPEO}', "");
    Expect(0, 66517, '\p{^Is_Sc=-XPEO}', "");
    Expect(0, 66517, '\P{Is_Sc=-XPEO}', "");
    Expect(1, 66517, '\P{^Is_Sc=-XPEO}', "");
    Expect(0, 66518, '\p{Is_Sc=-XPEO}', "");
    Expect(1, 66518, '\p{^Is_Sc=-XPEO}', "");
    Expect(1, 66518, '\P{Is_Sc=-XPEO}', "");
    Expect(0, 66518, '\P{^Is_Sc=-XPEO}', "");
    Error('\p{Script: /a/		cuneiform}');
    Error('\P{Script: /a/		cuneiform}');
    Expect(1, 75075, '\p{Script=:\ACuneiform\z:}', "");;
    Expect(0, 75076, '\p{Script=:\ACuneiform\z:}', "");;
    Expect(1, 75075, '\p{Script: cuneiform}', "");
    Expect(0, 75075, '\p{^Script: cuneiform}', "");
    Expect(0, 75075, '\P{Script: cuneiform}', "");
    Expect(1, 75075, '\P{^Script: cuneiform}', "");
    Expect(0, 75076, '\p{Script: cuneiform}', "");
    Expect(1, 75076, '\p{^Script: cuneiform}', "");
    Expect(1, 75076, '\P{Script: cuneiform}', "");
    Expect(0, 75076, '\P{^Script: cuneiform}', "");
    Expect(1, 75075, '\p{Script=:\Acuneiform\z:}', "");;
    Expect(0, 75076, '\p{Script=:\Acuneiform\z:}', "");;
    Expect(1, 75075, '\p{Script:   --Cuneiform}', "");
    Expect(0, 75075, '\p{^Script:   --Cuneiform}', "");
    Expect(0, 75075, '\P{Script:   --Cuneiform}', "");
    Expect(1, 75075, '\P{^Script:   --Cuneiform}', "");
    Expect(0, 75076, '\p{Script:   --Cuneiform}', "");
    Expect(1, 75076, '\p{^Script:   --Cuneiform}', "");
    Expect(1, 75076, '\P{Script:   --Cuneiform}', "");
    Expect(0, 75076, '\P{^Script:   --Cuneiform}', "");
    Error('\p{Sc=	 Xsux/a/}');
    Error('\P{Sc=	 Xsux/a/}');
    Expect(1, 75075, '\p{Sc=:\AXsux\z:}', "");;
    Expect(0, 75076, '\p{Sc=:\AXsux\z:}', "");;
    Expect(1, 75075, '\p{Sc=xsux}', "");
    Expect(0, 75075, '\p{^Sc=xsux}', "");
    Expect(0, 75075, '\P{Sc=xsux}', "");
    Expect(1, 75075, '\P{^Sc=xsux}', "");
    Expect(0, 75076, '\p{Sc=xsux}', "");
    Expect(1, 75076, '\p{^Sc=xsux}', "");
    Expect(1, 75076, '\P{Sc=xsux}', "");
    Expect(0, 75076, '\P{^Sc=xsux}', "");
    Expect(1, 75075, '\p{Sc=:\Axsux\z:}', "");;
    Expect(0, 75076, '\p{Sc=:\Axsux\z:}', "");;
    Expect(1, 75075, '\p{Sc=Xsux}', "");
    Expect(0, 75075, '\p{^Sc=Xsux}', "");
    Expect(0, 75075, '\P{Sc=Xsux}', "");
    Expect(1, 75075, '\P{^Sc=Xsux}', "");
    Expect(0, 75076, '\p{Sc=Xsux}', "");
    Expect(1, 75076, '\p{^Sc=Xsux}', "");
    Expect(1, 75076, '\P{Sc=Xsux}', "");
    Expect(0, 75076, '\P{^Sc=Xsux}', "");
    Error('\p{Is_Script= /a/CUNEIFORM}');
    Error('\P{Is_Script= /a/CUNEIFORM}');
    Expect(1, 75075, '\p{Is_Script=cuneiform}', "");
    Expect(0, 75075, '\p{^Is_Script=cuneiform}', "");
    Expect(0, 75075, '\P{Is_Script=cuneiform}', "");
    Expect(1, 75075, '\P{^Is_Script=cuneiform}', "");
    Expect(0, 75076, '\p{Is_Script=cuneiform}', "");
    Expect(1, 75076, '\p{^Is_Script=cuneiform}', "");
    Expect(1, 75076, '\P{Is_Script=cuneiform}', "");
    Expect(0, 75076, '\P{^Is_Script=cuneiform}', "");
    Expect(1, 75075, '\p{Is_Script=_-cuneiform}', "");
    Expect(0, 75075, '\p{^Is_Script=_-cuneiform}', "");
    Expect(0, 75075, '\P{Is_Script=_-cuneiform}', "");
    Expect(1, 75075, '\P{^Is_Script=_-cuneiform}', "");
    Expect(0, 75076, '\p{Is_Script=_-cuneiform}', "");
    Expect(1, 75076, '\p{^Is_Script=_-cuneiform}', "");
    Expect(1, 75076, '\P{Is_Script=_-cuneiform}', "");
    Expect(0, 75076, '\P{^Is_Script=_-cuneiform}', "");
    Error('\p{Is_Sc:	/a/ xsux}');
    Error('\P{Is_Sc:	/a/ xsux}');
    Expect(1, 75075, '\p{Is_Sc:xsux}', "");
    Expect(0, 75075, '\p{^Is_Sc:xsux}', "");
    Expect(0, 75075, '\P{Is_Sc:xsux}', "");
    Expect(1, 75075, '\P{^Is_Sc:xsux}', "");
    Expect(0, 75076, '\p{Is_Sc:xsux}', "");
    Expect(1, 75076, '\p{^Is_Sc:xsux}', "");
    Expect(1, 75076, '\P{Is_Sc:xsux}', "");
    Expect(0, 75076, '\P{^Is_Sc:xsux}', "");
    Expect(1, 75075, '\p{Is_Sc=_Xsux}', "");
    Expect(0, 75075, '\p{^Is_Sc=_Xsux}', "");
    Expect(0, 75075, '\P{Is_Sc=_Xsux}', "");
    Expect(1, 75075, '\P{^Is_Sc=_Xsux}', "");
    Expect(0, 75076, '\p{Is_Sc=_Xsux}', "");
    Expect(1, 75076, '\p{^Is_Sc=_Xsux}', "");
    Expect(1, 75076, '\P{Is_Sc=_Xsux}', "");
    Expect(0, 75076, '\P{^Is_Sc=_Xsux}', "");
    Error('\p{Script=:=_	YI}');
    Error('\P{Script=:=_	YI}');
    Expect(1, 42182, '\p{Script=:\AYi\z:}', "");;
    Expect(0, 42183, '\p{Script=:\AYi\z:}', "");;
    Expect(1, 42182, '\p{Script=yi}', "");
    Expect(0, 42182, '\p{^Script=yi}', "");
    Expect(0, 42182, '\P{Script=yi}', "");
    Expect(1, 42182, '\P{^Script=yi}', "");
    Expect(0, 42183, '\p{Script=yi}', "");
    Expect(1, 42183, '\p{^Script=yi}', "");
    Expect(1, 42183, '\P{Script=yi}', "");
    Expect(0, 42183, '\P{^Script=yi}', "");
    Expect(1, 42182, '\p{Script=:\Ayi\z:}', "");;
    Expect(0, 42183, '\p{Script=:\Ayi\z:}', "");;
    Expect(1, 42182, '\p{Script=-	Yi}', "");
    Expect(0, 42182, '\p{^Script=-	Yi}', "");
    Expect(0, 42182, '\P{Script=-	Yi}', "");
    Expect(1, 42182, '\P{^Script=-	Yi}', "");
    Expect(0, 42183, '\p{Script=-	Yi}', "");
    Expect(1, 42183, '\p{^Script=-	Yi}', "");
    Expect(1, 42183, '\P{Script=-	Yi}', "");
    Expect(0, 42183, '\P{^Script=-	Yi}', "");
    Error('\p{Sc=:=	 Yiii}');
    Error('\P{Sc=:=	 Yiii}');
    Expect(1, 42182, '\p{Sc=:\AYiii\z:}', "");;
    Expect(0, 42183, '\p{Sc=:\AYiii\z:}', "");;
    Expect(1, 42182, '\p{Sc=yiii}', "");
    Expect(0, 42182, '\p{^Sc=yiii}', "");
    Expect(0, 42182, '\P{Sc=yiii}', "");
    Expect(1, 42182, '\P{^Sc=yiii}', "");
    Expect(0, 42183, '\p{Sc=yiii}', "");
    Expect(1, 42183, '\p{^Sc=yiii}', "");
    Expect(1, 42183, '\P{Sc=yiii}', "");
    Expect(0, 42183, '\P{^Sc=yiii}', "");
    Expect(1, 42182, '\p{Sc=:\Ayiii\z:}', "");;
    Expect(0, 42183, '\p{Sc=:\Ayiii\z:}', "");;
    Expect(1, 42182, '\p{Sc=_	Yiii}', "");
    Expect(0, 42182, '\p{^Sc=_	Yiii}', "");
    Expect(0, 42182, '\P{Sc=_	Yiii}', "");
    Expect(1, 42182, '\P{^Sc=_	Yiii}', "");
    Expect(0, 42183, '\p{Sc=_	Yiii}', "");
    Expect(1, 42183, '\p{^Sc=_	Yiii}', "");
    Expect(1, 42183, '\P{Sc=_	Yiii}', "");
    Expect(0, 42183, '\P{^Sc=_	Yiii}', "");
    Error('\p{Is_Script=/a/- yi}');
    Error('\P{Is_Script=/a/- yi}');
    Expect(1, 42182, '\p{Is_Script=yi}', "");
    Expect(0, 42182, '\p{^Is_Script=yi}', "");
    Expect(0, 42182, '\P{Is_Script=yi}', "");
    Expect(1, 42182, '\P{^Is_Script=yi}', "");
    Expect(0, 42183, '\p{Is_Script=yi}', "");
    Expect(1, 42183, '\p{^Is_Script=yi}', "");
    Expect(1, 42183, '\P{Is_Script=yi}', "");
    Expect(0, 42183, '\P{^Is_Script=yi}', "");
    Expect(1, 42182, '\p{Is_Script=_ YI}', "");
    Expect(0, 42182, '\p{^Is_Script=_ YI}', "");
    Expect(0, 42182, '\P{Is_Script=_ YI}', "");
    Expect(1, 42182, '\P{^Is_Script=_ YI}', "");
    Expect(0, 42183, '\p{Is_Script=_ YI}', "");
    Expect(1, 42183, '\p{^Is_Script=_ YI}', "");
    Expect(1, 42183, '\P{Is_Script=_ YI}', "");
    Expect(0, 42183, '\P{^Is_Script=_ YI}', "");
    Error('\p{Is_Sc=  Yiii:=}');
    Error('\P{Is_Sc=  Yiii:=}');
    Expect(1, 42182, '\p{Is_Sc=yiii}', "");
    Expect(0, 42182, '\p{^Is_Sc=yiii}', "");
    Expect(0, 42182, '\P{Is_Sc=yiii}', "");
    Expect(1, 42182, '\P{^Is_Sc=yiii}', "");
    Expect(0, 42183, '\p{Is_Sc=yiii}', "");
    Expect(1, 42183, '\p{^Is_Sc=yiii}', "");
    Expect(1, 42183, '\P{Is_Sc=yiii}', "");
    Expect(0, 42183, '\P{^Is_Sc=yiii}', "");
    Expect(1, 42182, '\p{Is_Sc= _YIII}', "");
    Expect(0, 42182, '\p{^Is_Sc= _YIII}', "");
    Expect(0, 42182, '\P{Is_Sc= _YIII}', "");
    Expect(1, 42182, '\P{^Is_Sc= _YIII}', "");
    Expect(0, 42183, '\p{Is_Sc= _YIII}', "");
    Expect(1, 42183, '\p{^Is_Sc= _YIII}', "");
    Expect(1, 42183, '\P{Is_Sc= _YIII}', "");
    Expect(0, 42183, '\P{^Is_Sc= _YIII}', "");
    Error('\p{Script=	Zanabazar_SQUARE:=}');
    Error('\P{Script=	Zanabazar_SQUARE:=}');
    Expect(1, 72263, '\p{Script=:\AZanabazar_Square\z:}', "");;
    Expect(0, 72264, '\p{Script=:\AZanabazar_Square\z:}', "");;
    Expect(1, 72263, '\p{Script=zanabazarsquare}', "");
    Expect(0, 72263, '\p{^Script=zanabazarsquare}', "");
    Expect(0, 72263, '\P{Script=zanabazarsquare}', "");
    Expect(1, 72263, '\P{^Script=zanabazarsquare}', "");
    Expect(0, 72264, '\p{Script=zanabazarsquare}', "");
    Expect(1, 72264, '\p{^Script=zanabazarsquare}', "");
    Expect(1, 72264, '\P{Script=zanabazarsquare}', "");
    Expect(0, 72264, '\P{^Script=zanabazarsquare}', "");
    Expect(1, 72263, '\p{Script=:\Azanabazarsquare\z:}', "");;
    Expect(0, 72264, '\p{Script=:\Azanabazarsquare\z:}', "");;
    Expect(1, 72263, '\p{Script=	zanabazar_Square}', "");
    Expect(0, 72263, '\p{^Script=	zanabazar_Square}', "");
    Expect(0, 72263, '\P{Script=	zanabazar_Square}', "");
    Expect(1, 72263, '\P{^Script=	zanabazar_Square}', "");
    Expect(0, 72264, '\p{Script=	zanabazar_Square}', "");
    Expect(1, 72264, '\p{^Script=	zanabazar_Square}', "");
    Expect(1, 72264, '\P{Script=	zanabazar_Square}', "");
    Expect(0, 72264, '\P{^Script=	zanabazar_Square}', "");
    Error('\p{Sc=/a/-Zanb}');
    Error('\P{Sc=/a/-Zanb}');
    Expect(1, 72263, '\p{Sc=:\AZanb\z:}', "");;
    Expect(0, 72264, '\p{Sc=:\AZanb\z:}', "");;
    Expect(1, 72263, '\p{Sc=zanb}', "");
    Expect(0, 72263, '\p{^Sc=zanb}', "");
    Expect(0, 72263, '\P{Sc=zanb}', "");
    Expect(1, 72263, '\P{^Sc=zanb}', "");
    Expect(0, 72264, '\p{Sc=zanb}', "");
    Expect(1, 72264, '\p{^Sc=zanb}', "");
    Expect(1, 72264, '\P{Sc=zanb}', "");
    Expect(0, 72264, '\P{^Sc=zanb}', "");
    Expect(1, 72263, '\p{Sc=:\Azanb\z:}', "");;
    Expect(0, 72264, '\p{Sc=:\Azanb\z:}', "");;
    Expect(1, 72263, '\p{Sc=__Zanb}', "");
    Expect(0, 72263, '\p{^Sc=__Zanb}', "");
    Expect(0, 72263, '\P{Sc=__Zanb}', "");
    Expect(1, 72263, '\P{^Sc=__Zanb}', "");
    Expect(0, 72264, '\p{Sc=__Zanb}', "");
    Expect(1, 72264, '\p{^Sc=__Zanb}', "");
    Expect(1, 72264, '\P{Sc=__Zanb}', "");
    Expect(0, 72264, '\P{^Sc=__Zanb}', "");
    Error('\p{Is_Script=_:=zanabazar_Square}');
    Error('\P{Is_Script=_:=zanabazar_Square}');
    Expect(1, 72263, '\p{Is_Script=zanabazarsquare}', "");
    Expect(0, 72263, '\p{^Is_Script=zanabazarsquare}', "");
    Expect(0, 72263, '\P{Is_Script=zanabazarsquare}', "");
    Expect(1, 72263, '\P{^Is_Script=zanabazarsquare}', "");
    Expect(0, 72264, '\p{Is_Script=zanabazarsquare}', "");
    Expect(1, 72264, '\p{^Is_Script=zanabazarsquare}', "");
    Expect(1, 72264, '\P{Is_Script=zanabazarsquare}', "");
    Expect(0, 72264, '\P{^Is_Script=zanabazarsquare}', "");
    Expect(1, 72263, '\p{Is_Script:   	ZANABAZAR_square}', "");
    Expect(0, 72263, '\p{^Is_Script:   	ZANABAZAR_square}', "");
    Expect(0, 72263, '\P{Is_Script:   	ZANABAZAR_square}', "");
    Expect(1, 72263, '\P{^Is_Script:   	ZANABAZAR_square}', "");
    Expect(0, 72264, '\p{Is_Script:   	ZANABAZAR_square}', "");
    Expect(1, 72264, '\p{^Is_Script:   	ZANABAZAR_square}', "");
    Expect(1, 72264, '\P{Is_Script:   	ZANABAZAR_square}', "");
    Expect(0, 72264, '\P{^Is_Script:   	ZANABAZAR_square}', "");
    Error('\p{Is_Sc=/a/_ZANB}');
    Error('\P{Is_Sc=/a/_ZANB}');
    Expect(1, 72263, '\p{Is_Sc=zanb}', "");
    Expect(0, 72263, '\p{^Is_Sc=zanb}', "");
    Expect(0, 72263, '\P{Is_Sc=zanb}', "");
    Expect(1, 72263, '\P{^Is_Sc=zanb}', "");
    Expect(0, 72264, '\p{Is_Sc=zanb}', "");
    Expect(1, 72264, '\p{^Is_Sc=zanb}', "");
    Expect(1, 72264, '\P{Is_Sc=zanb}', "");
    Expect(0, 72264, '\P{^Is_Sc=zanb}', "");
    Expect(1, 72263, '\p{Is_Sc=Zanb}', "");
    Expect(0, 72263, '\p{^Is_Sc=Zanb}', "");
    Expect(0, 72263, '\P{Is_Sc=Zanb}', "");
    Expect(1, 72263, '\P{^Is_Sc=Zanb}', "");
    Expect(0, 72264, '\p{Is_Sc=Zanb}', "");
    Expect(1, 72264, '\p{^Is_Sc=Zanb}', "");
    Expect(1, 72264, '\P{Is_Sc=Zanb}', "");
    Expect(0, 72264, '\P{^Is_Sc=Zanb}', "");
    Error('\p{Script=-inherited:=}');
    Error('\P{Script=-inherited:=}');
    Expect(1, 917999, '\p{Script=:\AInherited\z:}', "");;
    Expect(0, 918000, '\p{Script=:\AInherited\z:}', "");;
    Expect(1, 917999, '\p{Script=inherited}', "");
    Expect(0, 917999, '\p{^Script=inherited}', "");
    Expect(0, 917999, '\P{Script=inherited}', "");
    Expect(1, 917999, '\P{^Script=inherited}', "");
    Expect(0, 918000, '\p{Script=inherited}', "");
    Expect(1, 918000, '\p{^Script=inherited}', "");
    Expect(1, 918000, '\P{Script=inherited}', "");
    Expect(0, 918000, '\P{^Script=inherited}', "");
    Expect(1, 917999, '\p{Script=:\Ainherited\z:}', "");;
    Expect(0, 918000, '\p{Script=:\Ainherited\z:}', "");;
    Expect(1, 917999, '\p{Script=	_Inherited}', "");
    Expect(0, 917999, '\p{^Script=	_Inherited}', "");
    Expect(0, 917999, '\P{Script=	_Inherited}', "");
    Expect(1, 917999, '\P{^Script=	_Inherited}', "");
    Expect(0, 918000, '\p{Script=	_Inherited}', "");
    Expect(1, 918000, '\p{^Script=	_Inherited}', "");
    Expect(1, 918000, '\P{Script=	_Inherited}', "");
    Expect(0, 918000, '\P{^Script=	_Inherited}', "");
    Error('\p{Sc=:=__ZINH}');
    Error('\P{Sc=:=__ZINH}');
    Expect(1, 917999, '\p{Sc=:\AZinh\z:}', "");;
    Expect(0, 918000, '\p{Sc=:\AZinh\z:}', "");;
    Expect(1, 917999, '\p{Sc=zinh}', "");
    Expect(0, 917999, '\p{^Sc=zinh}', "");
    Expect(0, 917999, '\P{Sc=zinh}', "");
    Expect(1, 917999, '\P{^Sc=zinh}', "");
    Expect(0, 918000, '\p{Sc=zinh}', "");
    Expect(1, 918000, '\p{^Sc=zinh}', "");
    Expect(1, 918000, '\P{Sc=zinh}', "");
    Expect(0, 918000, '\P{^Sc=zinh}', "");
    Expect(1, 917999, '\p{Sc=:\Azinh\z:}', "");;
    Expect(0, 918000, '\p{Sc=:\Azinh\z:}', "");;
    Expect(1, 917999, '\p{Sc=_ zinh}', "");
    Expect(0, 917999, '\p{^Sc=_ zinh}', "");
    Expect(0, 917999, '\P{Sc=_ zinh}', "");
    Expect(1, 917999, '\P{^Sc=_ zinh}', "");
    Expect(0, 918000, '\p{Sc=_ zinh}', "");
    Expect(1, 918000, '\p{^Sc=_ zinh}', "");
    Expect(1, 918000, '\P{Sc=_ zinh}', "");
    Expect(0, 918000, '\P{^Sc=_ zinh}', "");
    Error('\p{Is_Script=QAAI/a/}');
    Error('\P{Is_Script=QAAI/a/}');
    Expect(1, 917999, '\p{Is_Script=qaai}', "");
    Expect(0, 917999, '\p{^Is_Script=qaai}', "");
    Expect(0, 917999, '\P{Is_Script=qaai}', "");
    Expect(1, 917999, '\P{^Is_Script=qaai}', "");
    Expect(0, 918000, '\p{Is_Script=qaai}', "");
    Expect(1, 918000, '\p{^Is_Script=qaai}', "");
    Expect(1, 918000, '\P{Is_Script=qaai}', "");
    Expect(0, 918000, '\P{^Is_Script=qaai}', "");
    Expect(1, 917999, '\p{Is_Script: -	QAAI}', "");
    Expect(0, 917999, '\p{^Is_Script: -	QAAI}', "");
    Expect(0, 917999, '\P{Is_Script: -	QAAI}', "");
    Expect(1, 917999, '\P{^Is_Script: -	QAAI}', "");
    Expect(0, 918000, '\p{Is_Script: -	QAAI}', "");
    Expect(1, 918000, '\p{^Is_Script: -	QAAI}', "");
    Expect(1, 918000, '\P{Is_Script: -	QAAI}', "");
    Expect(0, 918000, '\P{^Is_Script: -	QAAI}', "");
    Error('\p{Is_Sc:	/a/	Inherited}');
    Error('\P{Is_Sc:	/a/	Inherited}');
    Expect(1, 917999, '\p{Is_Sc=inherited}', "");
    Expect(0, 917999, '\p{^Is_Sc=inherited}', "");
    Expect(0, 917999, '\P{Is_Sc=inherited}', "");
    Expect(1, 917999, '\P{^Is_Sc=inherited}', "");
    Expect(0, 918000, '\p{Is_Sc=inherited}', "");
    Expect(1, 918000, '\p{^Is_Sc=inherited}', "");
    Expect(1, 918000, '\P{Is_Sc=inherited}', "");
    Expect(0, 918000, '\P{^Is_Sc=inherited}', "");
    Expect(1, 917999, '\p{Is_Sc=__Inherited}', "");
    Expect(0, 917999, '\p{^Is_Sc=__Inherited}', "");
    Expect(0, 917999, '\P{Is_Sc=__Inherited}', "");
    Expect(1, 917999, '\P{^Is_Sc=__Inherited}', "");
    Expect(0, 918000, '\p{Is_Sc=__Inherited}', "");
    Expect(1, 918000, '\p{^Is_Sc=__Inherited}', "");
    Expect(1, 918000, '\P{Is_Sc=__Inherited}', "");
    Expect(0, 918000, '\P{^Is_Sc=__Inherited}', "");
    Error('\p{Script=	/a/common}');
    Error('\P{Script=	/a/common}');
    Expect(1, 917631, '\p{Script=:\ACommon\z:}', "");;
    Expect(0, 917632, '\p{Script=:\ACommon\z:}', "");;
    Expect(1, 917631, '\p{Script=common}', "");
    Expect(0, 917631, '\p{^Script=common}', "");
    Expect(0, 917631, '\P{Script=common}', "");
    Expect(1, 917631, '\P{^Script=common}', "");
    Expect(0, 917632, '\p{Script=common}', "");
    Expect(1, 917632, '\p{^Script=common}', "");
    Expect(1, 917632, '\P{Script=common}', "");
    Expect(0, 917632, '\P{^Script=common}', "");
    Expect(1, 917631, '\p{Script=:\Acommon\z:}', "");;
    Expect(0, 917632, '\p{Script=:\Acommon\z:}', "");;
    Expect(1, 917631, '\p{Script=  COMMON}', "");
    Expect(0, 917631, '\p{^Script=  COMMON}', "");
    Expect(0, 917631, '\P{Script=  COMMON}', "");
    Expect(1, 917631, '\P{^Script=  COMMON}', "");
    Expect(0, 917632, '\p{Script=  COMMON}', "");
    Expect(1, 917632, '\p{^Script=  COMMON}', "");
    Expect(1, 917632, '\P{Script=  COMMON}', "");
    Expect(0, 917632, '\P{^Script=  COMMON}', "");
    Error('\p{Sc=ZYYY:=}');
    Error('\P{Sc=ZYYY:=}');
    Expect(1, 917631, '\p{Sc=:\AZyyy\z:}', "");;
    Expect(0, 917632, '\p{Sc=:\AZyyy\z:}', "");;
    Expect(1, 917631, '\p{Sc=zyyy}', "");
    Expect(0, 917631, '\p{^Sc=zyyy}', "");
    Expect(0, 917631, '\P{Sc=zyyy}', "");
    Expect(1, 917631, '\P{^Sc=zyyy}', "");
    Expect(0, 917632, '\p{Sc=zyyy}', "");
    Expect(1, 917632, '\p{^Sc=zyyy}', "");
    Expect(1, 917632, '\P{Sc=zyyy}', "");
    Expect(0, 917632, '\P{^Sc=zyyy}', "");
    Expect(1, 917631, '\p{Sc=:\Azyyy\z:}', "");;
    Expect(0, 917632, '\p{Sc=:\Azyyy\z:}', "");;
    Expect(1, 917631, '\p{Sc:-Zyyy}', "");
    Expect(0, 917631, '\p{^Sc:-Zyyy}', "");
    Expect(0, 917631, '\P{Sc:-Zyyy}', "");
    Expect(1, 917631, '\P{^Sc:-Zyyy}', "");
    Expect(0, 917632, '\p{Sc:-Zyyy}', "");
    Expect(1, 917632, '\p{^Sc:-Zyyy}', "");
    Expect(1, 917632, '\P{Sc:-Zyyy}', "");
    Expect(0, 917632, '\P{^Sc:-Zyyy}', "");
    Error('\p{Is_Script=	:=Common}');
    Error('\P{Is_Script=	:=Common}');
    Expect(1, 917631, '\p{Is_Script=common}', "");
    Expect(0, 917631, '\p{^Is_Script=common}', "");
    Expect(0, 917631, '\P{Is_Script=common}', "");
    Expect(1, 917631, '\P{^Is_Script=common}', "");
    Expect(0, 917632, '\p{Is_Script=common}', "");
    Expect(1, 917632, '\p{^Is_Script=common}', "");
    Expect(1, 917632, '\P{Is_Script=common}', "");
    Expect(0, 917632, '\P{^Is_Script=common}', "");
    Expect(1, 917631, '\p{Is_Script=		Common}', "");
    Expect(0, 917631, '\p{^Is_Script=		Common}', "");
    Expect(0, 917631, '\P{Is_Script=		Common}', "");
    Expect(1, 917631, '\P{^Is_Script=		Common}', "");
    Expect(0, 917632, '\p{Is_Script=		Common}', "");
    Expect(1, 917632, '\p{^Is_Script=		Common}', "");
    Expect(1, 917632, '\P{Is_Script=		Common}', "");
    Expect(0, 917632, '\P{^Is_Script=		Common}', "");
    Error('\p{Is_Sc=/a/-ZYYY}');
    Error('\P{Is_Sc=/a/-ZYYY}');
    Expect(1, 917631, '\p{Is_Sc=zyyy}', "");
    Expect(0, 917631, '\p{^Is_Sc=zyyy}', "");
    Expect(0, 917631, '\P{Is_Sc=zyyy}', "");
    Expect(1, 917631, '\P{^Is_Sc=zyyy}', "");
    Expect(0, 917632, '\p{Is_Sc=zyyy}', "");
    Expect(1, 917632, '\p{^Is_Sc=zyyy}', "");
    Expect(1, 917632, '\P{Is_Sc=zyyy}', "");
    Expect(0, 917632, '\P{^Is_Sc=zyyy}', "");
    Expect(1, 917631, '\p{Is_Sc=_ZYYY}', "");
    Expect(0, 917631, '\p{^Is_Sc=_ZYYY}', "");
    Expect(0, 917631, '\P{Is_Sc=_ZYYY}', "");
    Expect(1, 917631, '\P{^Is_Sc=_ZYYY}', "");
    Expect(0, 917632, '\p{Is_Sc=_ZYYY}', "");
    Expect(1, 917632, '\p{^Is_Sc=_ZYYY}', "");
    Expect(1, 917632, '\P{Is_Sc=_ZYYY}', "");
    Expect(0, 917632, '\P{^Is_Sc=_ZYYY}', "");
    Error('\p{Script=	:=unknown}');
    Error('\P{Script=	:=unknown}');
    Expect(1, 918000, '\p{Script=:\AUnknown\z:}', "");;
    Expect(0, 917999, '\p{Script=:\AUnknown\z:}', "");;
    Expect(1, 918000, '\p{Script:	unknown}', "");
    Expect(0, 918000, '\p{^Script:	unknown}', "");
    Expect(0, 918000, '\P{Script:	unknown}', "");
    Expect(1, 918000, '\P{^Script:	unknown}', "");
    Expect(0, 917999, '\p{Script:	unknown}', "");
    Expect(1, 917999, '\p{^Script:	unknown}', "");
    Expect(1, 917999, '\P{Script:	unknown}', "");
    Expect(0, 917999, '\P{^Script:	unknown}', "");
    Expect(1, 918000, '\p{Script=:\Aunknown\z:}', "");;
    Expect(0, 917999, '\p{Script=:\Aunknown\z:}', "");;
    Expect(1, 918000, '\p{Script=-	Unknown}', "");
    Expect(0, 918000, '\p{^Script=-	Unknown}', "");
    Expect(0, 918000, '\P{Script=-	Unknown}', "");
    Expect(1, 918000, '\P{^Script=-	Unknown}', "");
    Expect(0, 917999, '\p{Script=-	Unknown}', "");
    Expect(1, 917999, '\p{^Script=-	Unknown}', "");
    Expect(1, 917999, '\P{Script=-	Unknown}', "");
    Expect(0, 917999, '\P{^Script=-	Unknown}', "");
    Error('\p{Sc=/a/	zzzz}');
    Error('\P{Sc=/a/	zzzz}');
    Expect(1, 918000, '\p{Sc=:\AZzzz\z:}', "");;
    Expect(0, 917999, '\p{Sc=:\AZzzz\z:}', "");;
    Expect(1, 918000, '\p{Sc=zzzz}', "");
    Expect(0, 918000, '\p{^Sc=zzzz}', "");
    Expect(0, 918000, '\P{Sc=zzzz}', "");
    Expect(1, 918000, '\P{^Sc=zzzz}', "");
    Expect(0, 917999, '\p{Sc=zzzz}', "");
    Expect(1, 917999, '\p{^Sc=zzzz}', "");
    Expect(1, 917999, '\P{Sc=zzzz}', "");
    Expect(0, 917999, '\P{^Sc=zzzz}', "");
    Expect(1, 918000, '\p{Sc=:\Azzzz\z:}', "");;
    Expect(0, 917999, '\p{Sc=:\Azzzz\z:}', "");;
    Expect(1, 918000, '\p{Sc=	zzzz}', "");
    Expect(0, 918000, '\p{^Sc=	zzzz}', "");
    Expect(0, 918000, '\P{Sc=	zzzz}', "");
    Expect(1, 918000, '\P{^Sc=	zzzz}', "");
    Expect(0, 917999, '\p{Sc=	zzzz}', "");
    Expect(1, 917999, '\p{^Sc=	zzzz}', "");
    Expect(1, 917999, '\P{Sc=	zzzz}', "");
    Expect(0, 917999, '\P{^Sc=	zzzz}', "");
    Error('\p{Is_Script: _:=UNKNOWN}');
    Error('\P{Is_Script: _:=UNKNOWN}');
    Expect(1, 918000, '\p{Is_Script=unknown}', "");
    Expect(0, 918000, '\p{^Is_Script=unknown}', "");
    Expect(0, 918000, '\P{Is_Script=unknown}', "");
    Expect(1, 918000, '\P{^Is_Script=unknown}', "");
    Expect(0, 917999, '\p{Is_Script=unknown}', "");
    Expect(1, 917999, '\p{^Is_Script=unknown}', "");
    Expect(1, 917999, '\P{Is_Script=unknown}', "");
    Expect(0, 917999, '\P{^Is_Script=unknown}', "");
    Expect(1, 918000, '\p{Is_Script=-	unknown}', "");
    Expect(0, 918000, '\p{^Is_Script=-	unknown}', "");
    Expect(0, 918000, '\P{Is_Script=-	unknown}', "");
    Expect(1, 918000, '\P{^Is_Script=-	unknown}', "");
    Expect(0, 917999, '\p{Is_Script=-	unknown}', "");
    Expect(1, 917999, '\p{^Is_Script=-	unknown}', "");
    Expect(1, 917999, '\P{Is_Script=-	unknown}', "");
    Expect(0, 917999, '\P{^Is_Script=-	unknown}', "");
    Error('\p{Is_Sc=/a/zzzz}');
    Error('\P{Is_Sc=/a/zzzz}');
    Expect(1, 918000, '\p{Is_Sc=zzzz}', "");
    Expect(0, 918000, '\p{^Is_Sc=zzzz}', "");
    Expect(0, 918000, '\P{Is_Sc=zzzz}', "");
    Expect(1, 918000, '\P{^Is_Sc=zzzz}', "");
    Expect(0, 917999, '\p{Is_Sc=zzzz}', "");
    Expect(1, 917999, '\p{^Is_Sc=zzzz}', "");
    Expect(1, 917999, '\P{Is_Sc=zzzz}', "");
    Expect(0, 917999, '\P{^Is_Sc=zzzz}', "");
    Expect(1, 918000, '\p{Is_Sc= _ZZZZ}', "");
    Expect(0, 918000, '\p{^Is_Sc= _ZZZZ}', "");
    Expect(0, 918000, '\P{Is_Sc= _ZZZZ}', "");
    Expect(1, 918000, '\P{^Is_Sc= _ZZZZ}', "");
    Expect(0, 917999, '\p{Is_Sc= _ZZZZ}', "");
    Expect(1, 917999, '\p{^Is_Sc= _ZZZZ}', "");
    Expect(1, 917999, '\P{Is_Sc= _ZZZZ}', "");
    Expect(0, 917999, '\P{^Is_Sc= _ZZZZ}', "");
    Error('\p{simplecasefolding}');
    Error('\P{simplecasefolding}');
    Error('\p{scf}');
    Error('\P{scf}');
    Error('\p{sfc}');
    Error('\P{sfc}');
    Error('\p{scriptextensions}');
    Error('\P{scriptextensions}');
    Error('\p{scx}');
    Error('\P{scx}');
    Error('\p{Script_Extensions=	/a/Adlam}');
    Error('\P{Script_Extensions=	/a/Adlam}');
    Expect(1, 125279, '\p{Script_Extensions=:\AAdlam\z:}', "");;
    Expect(0, 125280, '\p{Script_Extensions=:\AAdlam\z:}', "");;
    Expect(1, 125279, '\p{Script_Extensions=adlam}', "");
    Expect(0, 125279, '\p{^Script_Extensions=adlam}', "");
    Expect(0, 125279, '\P{Script_Extensions=adlam}', "");
    Expect(1, 125279, '\P{^Script_Extensions=adlam}', "");
    Expect(0, 125280, '\p{Script_Extensions=adlam}', "");
    Expect(1, 125280, '\p{^Script_Extensions=adlam}', "");
    Expect(1, 125280, '\P{Script_Extensions=adlam}', "");
    Expect(0, 125280, '\P{^Script_Extensions=adlam}', "");
    Expect(1, 125279, '\p{Script_Extensions=:\Aadlam\z:}', "");;
    Expect(0, 125280, '\p{Script_Extensions=:\Aadlam\z:}', "");;
    Expect(1, 125279, '\p{Script_Extensions=--Adlam}', "");
    Expect(0, 125279, '\p{^Script_Extensions=--Adlam}', "");
    Expect(0, 125279, '\P{Script_Extensions=--Adlam}', "");
    Expect(1, 125279, '\P{^Script_Extensions=--Adlam}', "");
    Expect(0, 125280, '\p{Script_Extensions=--Adlam}', "");
    Expect(1, 125280, '\p{^Script_Extensions=--Adlam}', "");
    Expect(1, 125280, '\P{Script_Extensions=--Adlam}', "");
    Expect(0, 125280, '\P{^Script_Extensions=--Adlam}', "");
    Error('\p{Scx=- Adlm/a/}');
    Error('\P{Scx=- Adlm/a/}');
    Expect(1, 125279, '\p{Scx=:\AAdlm\z:}', "");;
    Expect(0, 125280, '\p{Scx=:\AAdlm\z:}', "");;
    Expect(1, 125279, '\p{Scx=adlm}', "");
    Expect(0, 125279, '\p{^Scx=adlm}', "");
    Expect(0, 125279, '\P{Scx=adlm}', "");
    Expect(1, 125279, '\P{^Scx=adlm}', "");
    Expect(0, 125280, '\p{Scx=adlm}', "");
    Expect(1, 125280, '\p{^Scx=adlm}', "");
    Expect(1, 125280, '\P{Scx=adlm}', "");
    Expect(0, 125280, '\P{^Scx=adlm}', "");
    Expect(1, 125279, '\p{Scx=:\Aadlm\z:}', "");;
    Expect(0, 125280, '\p{Scx=:\Aadlm\z:}', "");;
    Expect(1, 125279, '\p{Scx=_-Adlm}', "");
    Expect(0, 125279, '\p{^Scx=_-Adlm}', "");
    Expect(0, 125279, '\P{Scx=_-Adlm}', "");
    Expect(1, 125279, '\P{^Scx=_-Adlm}', "");
    Expect(0, 125280, '\p{Scx=_-Adlm}', "");
    Expect(1, 125280, '\p{^Scx=_-Adlm}', "");
    Expect(1, 125280, '\P{Scx=_-Adlm}', "");
    Expect(0, 125280, '\P{^Scx=_-Adlm}', "");
    Error('\p{Is_Script_Extensions=_ Adlam/a/}');
    Error('\P{Is_Script_Extensions=_ Adlam/a/}');
    Expect(1, 125279, '\p{Is_Script_Extensions=adlam}', "");
    Expect(0, 125279, '\p{^Is_Script_Extensions=adlam}', "");
    Expect(0, 125279, '\P{Is_Script_Extensions=adlam}', "");
    Expect(1, 125279, '\P{^Is_Script_Extensions=adlam}', "");
    Expect(0, 125280, '\p{Is_Script_Extensions=adlam}', "");
    Expect(1, 125280, '\p{^Is_Script_Extensions=adlam}', "");
    Expect(1, 125280, '\P{Is_Script_Extensions=adlam}', "");
    Expect(0, 125280, '\P{^Is_Script_Extensions=adlam}', "");
    Expect(1, 125279, '\p{Is_Script_Extensions=	ADLAM}', "");
    Expect(0, 125279, '\p{^Is_Script_Extensions=	ADLAM}', "");
    Expect(0, 125279, '\P{Is_Script_Extensions=	ADLAM}', "");
    Expect(1, 125279, '\P{^Is_Script_Extensions=	ADLAM}', "");
    Expect(0, 125280, '\p{Is_Script_Extensions=	ADLAM}', "");
    Expect(1, 125280, '\p{^Is_Script_Extensions=	ADLAM}', "");
    Expect(1, 125280, '\P{Is_Script_Extensions=	ADLAM}', "");
    Expect(0, 125280, '\P{^Is_Script_Extensions=	ADLAM}', "");
    Error('\p{Is_Scx=:=Adlm}');
    Error('\P{Is_Scx=:=Adlm}');
    Expect(1, 125279, '\p{Is_Scx=adlm}', "");
    Expect(0, 125279, '\p{^Is_Scx=adlm}', "");
    Expect(0, 125279, '\P{Is_Scx=adlm}', "");
    Expect(1, 125279, '\P{^Is_Scx=adlm}', "");
    Expect(0, 125280, '\p{Is_Scx=adlm}', "");
    Expect(1, 125280, '\p{^Is_Scx=adlm}', "");
    Expect(1, 125280, '\P{Is_Scx=adlm}', "");
    Expect(0, 125280, '\P{^Is_Scx=adlm}', "");
    Expect(1, 125279, '\p{Is_Scx=_adlm}', "");
    Expect(0, 125279, '\p{^Is_Scx=_adlm}', "");
    Expect(0, 125279, '\P{Is_Scx=_adlm}', "");
    Expect(1, 125279, '\P{^Is_Scx=_adlm}', "");
    Expect(0, 125280, '\p{Is_Scx=_adlm}', "");
    Expect(1, 125280, '\p{^Is_Scx=_adlm}', "");
    Expect(1, 125280, '\P{Is_Scx=_adlm}', "");
    Expect(0, 125280, '\P{^Is_Scx=_adlm}', "");
    Error('\p{Script_Extensions= /a/Caucasian_Albanian}');
    Error('\P{Script_Extensions= /a/Caucasian_Albanian}');
    Expect(1, 66927, '\p{Script_Extensions=:\ACaucasian_Albanian\z:}', "");;
    Expect(0, 66928, '\p{Script_Extensions=:\ACaucasian_Albanian\z:}', "");;
    Expect(1, 66927, '\p{Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Script_Extensions=:\Acaucasianalbanian\z:}', "");;
    Expect(0, 66928, '\p{Script_Extensions=:\Acaucasianalbanian\z:}', "");;
    Expect(1, 66927, '\p{Script_Extensions=-	CAUCASIAN_albanian}', "");
    Expect(0, 66927, '\p{^Script_Extensions=-	CAUCASIAN_albanian}', "");
    Expect(0, 66927, '\P{Script_Extensions=-	CAUCASIAN_albanian}', "");
    Expect(1, 66927, '\P{^Script_Extensions=-	CAUCASIAN_albanian}', "");
    Expect(0, 66928, '\p{Script_Extensions=-	CAUCASIAN_albanian}', "");
    Expect(1, 66928, '\p{^Script_Extensions=-	CAUCASIAN_albanian}', "");
    Expect(1, 66928, '\P{Script_Extensions=-	CAUCASIAN_albanian}', "");
    Expect(0, 66928, '\P{^Script_Extensions=-	CAUCASIAN_albanian}', "");
    Error('\p{Scx=/a/_-aghb}');
    Error('\P{Scx=/a/_-aghb}');
    Expect(1, 66927, '\p{Scx=:\AAghb\z:}', "");;
    Expect(0, 66928, '\p{Scx=:\AAghb\z:}', "");;
    Expect(1, 66927, '\p{Scx=aghb}', "");
    Expect(0, 66927, '\p{^Scx=aghb}', "");
    Expect(0, 66927, '\P{Scx=aghb}', "");
    Expect(1, 66927, '\P{^Scx=aghb}', "");
    Expect(0, 66928, '\p{Scx=aghb}', "");
    Expect(1, 66928, '\p{^Scx=aghb}', "");
    Expect(1, 66928, '\P{Scx=aghb}', "");
    Expect(0, 66928, '\P{^Scx=aghb}', "");
    Expect(1, 66927, '\p{Scx=:\Aaghb\z:}', "");;
    Expect(0, 66928, '\p{Scx=:\Aaghb\z:}', "");;
    Expect(1, 66927, '\p{Scx=-	AGHB}', "");
    Expect(0, 66927, '\p{^Scx=-	AGHB}', "");
    Expect(0, 66927, '\P{Scx=-	AGHB}', "");
    Expect(1, 66927, '\P{^Scx=-	AGHB}', "");
    Expect(0, 66928, '\p{Scx=-	AGHB}', "");
    Expect(1, 66928, '\p{^Scx=-	AGHB}', "");
    Expect(1, 66928, '\P{Scx=-	AGHB}', "");
    Expect(0, 66928, '\P{^Scx=-	AGHB}', "");
    Error('\p{Is_Script_Extensions=:=- CAUCASIAN_Albanian}');
    Error('\P{Is_Script_Extensions=:=- CAUCASIAN_Albanian}');
    Expect(1, 66927, '\p{Is_Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66927, '\p{^Is_Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66927, '\P{Is_Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66927, '\P{^Is_Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66928, '\p{Is_Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66928, '\p{^Is_Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66928, '\P{Is_Script_Extensions=caucasianalbanian}', "");
    Expect(0, 66928, '\P{^Is_Script_Extensions=caucasianalbanian}', "");
    Expect(1, 66927, '\p{Is_Script_Extensions=	Caucasian_Albanian}', "");
    Expect(0, 66927, '\p{^Is_Script_Extensions=	Caucasian_Albanian}', "");
    Expect(0, 66927, '\P{Is_Script_Extensions=	Caucasian_Albanian}', "");
    Expect(1, 66927, '\P{^Is_Script_Extensions=	Caucasian_Albanian}', "");
    Expect(0, 66928, '\p{Is_Script_Extensions=	Caucasian_Albanian}', "");
    Expect(1, 66928, '\p{^Is_Script_Extensions=	Caucasian_Albanian}', "");
    Expect(1, 66928, '\P{Is_Script_Extensions=	Caucasian_Albanian}', "");
    Expect(0, 66928, '\P{^Is_Script_Extensions=	Caucasian_Albanian}', "");
    Error('\p{Is_Scx=	:=Aghb}');
    Error('\P{Is_Scx=	:=Aghb}');
    Expect(1, 66927, '\p{Is_Scx=aghb}', "");
    Expect(0, 66927, '\p{^Is_Scx=aghb}', "");
    Expect(0, 66927, '\P{Is_Scx=aghb}', "");
    Expect(1, 66927, '\P{^Is_Scx=aghb}', "");
    Expect(0, 66928, '\p{Is_Scx=aghb}', "");
    Expect(1, 66928, '\p{^Is_Scx=aghb}', "");
    Expect(1, 66928, '\P{Is_Scx=aghb}', "");
    Expect(0, 66928, '\P{^Is_Scx=aghb}', "");
    Expect(1, 66927, '\p{Is_Scx=	Aghb}', "");
    Expect(0, 66927, '\p{^Is_Scx=	Aghb}', "");
    Expect(0, 66927, '\P{Is_Scx=	Aghb}', "");
    Expect(1, 66927, '\P{^Is_Scx=	Aghb}', "");
    Expect(0, 66928, '\p{Is_Scx=	Aghb}', "");
    Expect(1, 66928, '\p{^Is_Scx=	Aghb}', "");
    Expect(1, 66928, '\P{Is_Scx=	Aghb}', "");
    Expect(0, 66928, '\P{^Is_Scx=	Aghb}', "");
    Error('\p{Script_Extensions=	-ahom/a/}');
    Error('\P{Script_Extensions=	-ahom/a/}');
    Expect(1, 71487, '\p{Script_Extensions=:\AAhom\z:}', "");;
    Expect(0, 71488, '\p{Script_Extensions=:\AAhom\z:}', "");;
    Expect(1, 71487, '\p{Script_Extensions=ahom}', "");
    Expect(0, 71487, '\p{^Script_Extensions=ahom}', "");
    Expect(0, 71487, '\P{Script_Extensions=ahom}', "");
    Expect(1, 71487, '\P{^Script_Extensions=ahom}', "");
    Expect(0, 71488, '\p{Script_Extensions=ahom}', "");
    Expect(1, 71488, '\p{^Script_Extensions=ahom}', "");
    Expect(1, 71488, '\P{Script_Extensions=ahom}', "");
    Expect(0, 71488, '\P{^Script_Extensions=ahom}', "");
    Expect(1, 71487, '\p{Script_Extensions=:\Aahom\z:}', "");;
    Expect(0, 71488, '\p{Script_Extensions=:\Aahom\z:}', "");;
    Expect(1, 71487, '\p{Script_Extensions:    	Ahom}', "");
    Expect(0, 71487, '\p{^Script_Extensions:    	Ahom}', "");
    Expect(0, 71487, '\P{Script_Extensions:    	Ahom}', "");
    Expect(1, 71487, '\P{^Script_Extensions:    	Ahom}', "");
    Expect(0, 71488, '\p{Script_Extensions:    	Ahom}', "");
    Expect(1, 71488, '\p{^Script_Extensions:    	Ahom}', "");
    Expect(1, 71488, '\P{Script_Extensions:    	Ahom}', "");
    Expect(0, 71488, '\P{^Script_Extensions:    	Ahom}', "");
    Error('\p{Scx=	:=Ahom}');
    Error('\P{Scx=	:=Ahom}');
    Expect(1, 71487, '\p{Scx=:\AAhom\z:}', "");;
    Expect(0, 71488, '\p{Scx=:\AAhom\z:}', "");;
    Expect(1, 71487, '\p{Scx=ahom}', "");
    Expect(0, 71487, '\p{^Scx=ahom}', "");
    Expect(0, 71487, '\P{Scx=ahom}', "");
    Expect(1, 71487, '\P{^Scx=ahom}', "");
    Expect(0, 71488, '\p{Scx=ahom}', "");
    Expect(1, 71488, '\p{^Scx=ahom}', "");
    Expect(1, 71488, '\P{Scx=ahom}', "");
    Expect(0, 71488, '\P{^Scx=ahom}', "");
    Expect(1, 71487, '\p{Scx=:\Aahom\z:}', "");;
    Expect(0, 71488, '\p{Scx=:\Aahom\z:}', "");;
    Expect(1, 71487, '\p{Scx=-Ahom}', "");
    Expect(0, 71487, '\p{^Scx=-Ahom}', "");
    Expect(0, 71487, '\P{Scx=-Ahom}', "");
    Expect(1, 71487, '\P{^Scx=-Ahom}', "");
    Expect(0, 71488, '\p{Scx=-Ahom}', "");
    Expect(1, 71488, '\p{^Scx=-Ahom}', "");
    Expect(1, 71488, '\P{Scx=-Ahom}', "");
    Expect(0, 71488, '\P{^Scx=-Ahom}', "");
    Error('\p{Is_Script_Extensions=:=	Ahom}');
    Error('\P{Is_Script_Extensions=:=	Ahom}');
    Expect(1, 71487, '\p{Is_Script_Extensions=ahom}', "");
    Expect(0, 71487, '\p{^Is_Script_Extensions=ahom}', "");
    Expect(0, 71487, '\P{Is_Script_Extensions=ahom}', "");
    Expect(1, 71487, '\P{^Is_Script_Extensions=ahom}', "");
    Expect(0, 71488, '\p{Is_Script_Extensions=ahom}', "");
    Expect(1, 71488, '\p{^Is_Script_Extensions=ahom}', "");
    Expect(1, 71488, '\P{Is_Script_Extensions=ahom}', "");
    Expect(0, 71488, '\P{^Is_Script_Extensions=ahom}', "");
    Expect(1, 71487, '\p{Is_Script_Extensions=	-AHOM}', "");
    Expect(0, 71487, '\p{^Is_Script_Extensions=	-AHOM}', "");
    Expect(0, 71487, '\P{Is_Script_Extensions=	-AHOM}', "");
    Expect(1, 71487, '\P{^Is_Script_Extensions=	-AHOM}', "");
    Expect(0, 71488, '\p{Is_Script_Extensions=	-AHOM}', "");
    Expect(1, 71488, '\p{^Is_Script_Extensions=	-AHOM}', "");
    Expect(1, 71488, '\P{Is_Script_Extensions=	-AHOM}', "");
    Expect(0, 71488, '\P{^Is_Script_Extensions=	-AHOM}', "");
    Error('\p{Is_Scx=	_AHOM/a/}');
    Error('\P{Is_Scx=	_AHOM/a/}');
    Expect(1, 71487, '\p{Is_Scx=ahom}', "");
    Expect(0, 71487, '\p{^Is_Scx=ahom}', "");
    Expect(0, 71487, '\P{Is_Scx=ahom}', "");
    Expect(1, 71487, '\P{^Is_Scx=ahom}', "");
    Expect(0, 71488, '\p{Is_Scx=ahom}', "");
    Expect(1, 71488, '\p{^Is_Scx=ahom}', "");
    Expect(1, 71488, '\P{Is_Scx=ahom}', "");
    Expect(0, 71488, '\P{^Is_Scx=ahom}', "");
    Expect(1, 71487, '\p{Is_Scx=_-Ahom}', "");
    Expect(0, 71487, '\p{^Is_Scx=_-Ahom}', "");
    Expect(0, 71487, '\P{Is_Scx=_-Ahom}', "");
    Expect(1, 71487, '\P{^Is_Scx=_-Ahom}', "");
    Expect(0, 71488, '\p{Is_Scx=_-Ahom}', "");
    Expect(1, 71488, '\p{^Is_Scx=_-Ahom}', "");
    Expect(1, 71488, '\P{Is_Scx=_-Ahom}', "");
    Expect(0, 71488, '\P{^Is_Scx=_-Ahom}', "");
    Error('\p{Script_Extensions=/a/ ARABIC}');
    Error('\P{Script_Extensions=/a/ ARABIC}');
    Expect(1, 126705, '\p{Script_Extensions=:\AArabic\z:}', "");;
    Expect(0, 126706, '\p{Script_Extensions=:\AArabic\z:}', "");;
    Expect(1, 126705, '\p{Script_Extensions=arabic}', "");
    Expect(0, 126705, '\p{^Script_Extensions=arabic}', "");
    Expect(0, 126705, '\P{Script_Extensions=arabic}', "");
    Expect(1, 126705, '\P{^Script_Extensions=arabic}', "");
    Expect(0, 126706, '\p{Script_Extensions=arabic}', "");
    Expect(1, 126706, '\p{^Script_Extensions=arabic}', "");
    Expect(1, 126706, '\P{Script_Extensions=arabic}', "");
    Expect(0, 126706, '\P{^Script_Extensions=arabic}', "");
    Expect(1, 126705, '\p{Script_Extensions=:\Aarabic\z:}', "");;
    Expect(0, 126706, '\p{Script_Extensions=:\Aarabic\z:}', "");;
    Expect(1, 126705, '\p{Script_Extensions: 	Arabic}', "");
    Expect(0, 126705, '\p{^Script_Extensions: 	Arabic}', "");
    Expect(0, 126705, '\P{Script_Extensions: 	Arabic}', "");
    Expect(1, 126705, '\P{^Script_Extensions: 	Arabic}', "");
    Expect(0, 126706, '\p{Script_Extensions: 	Arabic}', "");
    Expect(1, 126706, '\p{^Script_Extensions: 	Arabic}', "");
    Expect(1, 126706, '\P{Script_Extensions: 	Arabic}', "");
    Expect(0, 126706, '\P{^Script_Extensions: 	Arabic}', "");
    Error('\p{Scx= /a/Arab}');
    Error('\P{Scx= /a/Arab}');
    Expect(1, 126705, '\p{Scx=:\AArab\z:}', "");;
    Expect(0, 126706, '\p{Scx=:\AArab\z:}', "");;
    Expect(1, 126705, '\p{Scx=arab}', "");
    Expect(0, 126705, '\p{^Scx=arab}', "");
    Expect(0, 126705, '\P{Scx=arab}', "");
    Expect(1, 126705, '\P{^Scx=arab}', "");
    Expect(0, 126706, '\p{Scx=arab}', "");
    Expect(1, 126706, '\p{^Scx=arab}', "");
    Expect(1, 126706, '\P{Scx=arab}', "");
    Expect(0, 126706, '\P{^Scx=arab}', "");
    Expect(1, 126705, '\p{Scx=:\Aarab\z:}', "");;
    Expect(0, 126706, '\p{Scx=:\Aarab\z:}', "");;
    Expect(1, 126705, '\p{Scx= 	Arab}', "");
    Expect(0, 126705, '\p{^Scx= 	Arab}', "");
    Expect(0, 126705, '\P{Scx= 	Arab}', "");
    Expect(1, 126705, '\P{^Scx= 	Arab}', "");
    Expect(0, 126706, '\p{Scx= 	Arab}', "");
    Expect(1, 126706, '\p{^Scx= 	Arab}', "");
    Expect(1, 126706, '\P{Scx= 	Arab}', "");
    Expect(0, 126706, '\P{^Scx= 	Arab}', "");
    Error('\p{Is_Script_Extensions=:=ARABIC}');
    Error('\P{Is_Script_Extensions=:=ARABIC}');
    Expect(1, 126705, '\p{Is_Script_Extensions=arabic}', "");
    Expect(0, 126705, '\p{^Is_Script_Extensions=arabic}', "");
    Expect(0, 126705, '\P{Is_Script_Extensions=arabic}', "");
    Expect(1, 126705, '\P{^Is_Script_Extensions=arabic}', "");
    Expect(0, 126706, '\p{Is_Script_Extensions=arabic}', "");
    Expect(1, 126706, '\p{^Is_Script_Extensions=arabic}', "");
    Expect(1, 126706, '\P{Is_Script_Extensions=arabic}', "");
    Expect(0, 126706, '\P{^Is_Script_Extensions=arabic}', "");
    Expect(1, 126705, '\p{Is_Script_Extensions=__arabic}', "");
    Expect(0, 126705, '\p{^Is_Script_Extensions=__arabic}', "");
    Expect(0, 126705, '\P{Is_Script_Extensions=__arabic}', "");
    Expect(1, 126705, '\P{^Is_Script_Extensions=__arabic}', "");
    Expect(0, 126706, '\p{Is_Script_Extensions=__arabic}', "");
    Expect(1, 126706, '\p{^Is_Script_Extensions=__arabic}', "");
    Expect(1, 126706, '\P{Is_Script_Extensions=__arabic}', "");
    Expect(0, 126706, '\P{^Is_Script_Extensions=__arabic}', "");
    Error('\p{Is_Scx=-_Arab:=}');
    Error('\P{Is_Scx=-_Arab:=}');
    Expect(1, 126705, '\p{Is_Scx=arab}', "");
    Expect(0, 126705, '\p{^Is_Scx=arab}', "");
    Expect(0, 126705, '\P{Is_Scx=arab}', "");
    Expect(1, 126705, '\P{^Is_Scx=arab}', "");
    Expect(0, 126706, '\p{Is_Scx=arab}', "");
    Expect(1, 126706, '\p{^Is_Scx=arab}', "");
    Expect(1, 126706, '\P{Is_Scx=arab}', "");
    Expect(0, 126706, '\P{^Is_Scx=arab}', "");
    Expect(1, 126705, '\p{Is_Scx: arab}', "");
    Expect(0, 126705, '\p{^Is_Scx: arab}', "");
    Expect(0, 126705, '\P{Is_Scx: arab}', "");
    Expect(1, 126705, '\P{^Is_Scx: arab}', "");
    Expect(0, 126706, '\p{Is_Scx: arab}', "");
    Expect(1, 126706, '\p{^Is_Scx: arab}', "");
    Expect(1, 126706, '\P{Is_Scx: arab}', "");
    Expect(0, 126706, '\P{^Is_Scx: arab}', "");
    Error('\p{Script_Extensions=/a/ _IMPERIAL_ARAMAIC}');
    Error('\P{Script_Extensions=/a/ _IMPERIAL_ARAMAIC}');
    Expect(1, 67679, '\p{Script_Extensions=:\AImperial_Aramaic\z:}', "");;
    Expect(0, 67680, '\p{Script_Extensions=:\AImperial_Aramaic\z:}', "");;
    Expect(1, 67679, '\p{Script_Extensions=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Script_Extensions=imperialaramaic}', "");
    Expect(0, 67679, '\P{Script_Extensions=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Script_Extensions=imperialaramaic}', "");
    Expect(0, 67680, '\p{Script_Extensions=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Script_Extensions=imperialaramaic}', "");
    Expect(1, 67680, '\P{Script_Extensions=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Script_Extensions=imperialaramaic}', "");
    Expect(1, 67679, '\p{Script_Extensions=:\Aimperialaramaic\z:}', "");;
    Expect(0, 67680, '\p{Script_Extensions=:\Aimperialaramaic\z:}', "");;
    Expect(1, 67679, '\p{Script_Extensions=_ imperial_aramaic}', "");
    Expect(0, 67679, '\p{^Script_Extensions=_ imperial_aramaic}', "");
    Expect(0, 67679, '\P{Script_Extensions=_ imperial_aramaic}', "");
    Expect(1, 67679, '\P{^Script_Extensions=_ imperial_aramaic}', "");
    Expect(0, 67680, '\p{Script_Extensions=_ imperial_aramaic}', "");
    Expect(1, 67680, '\p{^Script_Extensions=_ imperial_aramaic}', "");
    Expect(1, 67680, '\P{Script_Extensions=_ imperial_aramaic}', "");
    Expect(0, 67680, '\P{^Script_Extensions=_ imperial_aramaic}', "");
    Error('\p{Scx=- Armi:=}');
    Error('\P{Scx=- Armi:=}');
    Expect(1, 67679, '\p{Scx=:\AArmi\z:}', "");;
    Expect(0, 67680, '\p{Scx=:\AArmi\z:}', "");;
    Expect(1, 67679, '\p{Scx=armi}', "");
    Expect(0, 67679, '\p{^Scx=armi}', "");
    Expect(0, 67679, '\P{Scx=armi}', "");
    Expect(1, 67679, '\P{^Scx=armi}', "");
    Expect(0, 67680, '\p{Scx=armi}', "");
    Expect(1, 67680, '\p{^Scx=armi}', "");
    Expect(1, 67680, '\P{Scx=armi}', "");
    Expect(0, 67680, '\P{^Scx=armi}', "");
    Expect(1, 67679, '\p{Scx=:\Aarmi\z:}', "");;
    Expect(0, 67680, '\p{Scx=:\Aarmi\z:}', "");;
    Expect(1, 67679, '\p{Scx=	 armi}', "");
    Expect(0, 67679, '\p{^Scx=	 armi}', "");
    Expect(0, 67679, '\P{Scx=	 armi}', "");
    Expect(1, 67679, '\P{^Scx=	 armi}', "");
    Expect(0, 67680, '\p{Scx=	 armi}', "");
    Expect(1, 67680, '\p{^Scx=	 armi}', "");
    Expect(1, 67680, '\P{Scx=	 armi}', "");
    Expect(0, 67680, '\P{^Scx=	 armi}', "");
    Error('\p{Is_Script_Extensions=__Imperial_aramaic/a/}');
    Error('\P{Is_Script_Extensions=__Imperial_aramaic/a/}');
    Expect(1, 67679, '\p{Is_Script_Extensions=imperialaramaic}', "");
    Expect(0, 67679, '\p{^Is_Script_Extensions=imperialaramaic}', "");
    Expect(0, 67679, '\P{Is_Script_Extensions=imperialaramaic}', "");
    Expect(1, 67679, '\P{^Is_Script_Extensions=imperialaramaic}', "");
    Expect(0, 67680, '\p{Is_Script_Extensions=imperialaramaic}', "");
    Expect(1, 67680, '\p{^Is_Script_Extensions=imperialaramaic}', "");
    Expect(1, 67680, '\P{Is_Script_Extensions=imperialaramaic}', "");
    Expect(0, 67680, '\P{^Is_Script_Extensions=imperialaramaic}', "");
    Expect(1, 67679, '\p{Is_Script_Extensions: Imperial_Aramaic}', "");
    Expect(0, 67679, '\p{^Is_Script_Extensions: Imperial_Aramaic}', "");
    Expect(0, 67679, '\P{Is_Script_Extensions: Imperial_Aramaic}', "");
    Expect(1, 67679, '\P{^Is_Script_Extensions: Imperial_Aramaic}', "");
    Expect(0, 67680, '\p{Is_Script_Extensions: Imperial_Aramaic}', "");
    Expect(1, 67680, '\p{^Is_Script_Extensions: Imperial_Aramaic}', "");
    Expect(1, 67680, '\P{Is_Script_Extensions: Imperial_Aramaic}', "");
    Expect(0, 67680, '\P{^Is_Script_Extensions: Imperial_Aramaic}', "");
    Error('\p{Is_Scx=_-armi/a/}');
    Error('\P{Is_Scx=_-armi/a/}');
    Expect(1, 67679, '\p{Is_Scx=armi}', "");
    Expect(0, 67679, '\p{^Is_Scx=armi}', "");
    Expect(0, 67679, '\P{Is_Scx=armi}', "");
    Expect(1, 67679, '\P{^Is_Scx=armi}', "");
    Expect(0, 67680, '\p{Is_Scx=armi}', "");
    Expect(1, 67680, '\p{^Is_Scx=armi}', "");
    Expect(1, 67680, '\P{Is_Scx=armi}', "");
    Expect(0, 67680, '\P{^Is_Scx=armi}', "");
    Expect(1, 67679, '\p{Is_Scx=-_armi}', "");
    Expect(0, 67679, '\p{^Is_Scx=-_armi}', "");
    Expect(0, 67679, '\P{Is_Scx=-_armi}', "");
    Expect(1, 67679, '\P{^Is_Scx=-_armi}', "");
    Expect(0, 67680, '\p{Is_Scx=-_armi}', "");
    Expect(1, 67680, '\p{^Is_Scx=-_armi}', "");
    Expect(1, 67680, '\P{Is_Scx=-_armi}', "");
    Expect(0, 67680, '\P{^Is_Scx=-_armi}', "");
    Error('\p{Script_Extensions: _/a/armenian}');
    Error('\P{Script_Extensions: _/a/armenian}');
    Expect(1, 64279, '\p{Script_Extensions=:\AArmenian\z:}', "");;
    Expect(0, 64280, '\p{Script_Extensions=:\AArmenian\z:}', "");;
    Expect(1, 64279, '\p{Script_Extensions=armenian}', "");
    Expect(0, 64279, '\p{^Script_Extensions=armenian}', "");
    Expect(0, 64279, '\P{Script_Extensions=armenian}', "");
    Expect(1, 64279, '\P{^Script_Extensions=armenian}', "");
    Expect(0, 64280, '\p{Script_Extensions=armenian}', "");
    Expect(1, 64280, '\p{^Script_Extensions=armenian}', "");
    Expect(1, 64280, '\P{Script_Extensions=armenian}', "");
    Expect(0, 64280, '\P{^Script_Extensions=armenian}', "");
    Expect(1, 64279, '\p{Script_Extensions=:\Aarmenian\z:}', "");;
    Expect(0, 64280, '\p{Script_Extensions=:\Aarmenian\z:}', "");;
    Expect(1, 64279, '\p{Script_Extensions=  Armenian}', "");
    Expect(0, 64279, '\p{^Script_Extensions=  Armenian}', "");
    Expect(0, 64279, '\P{Script_Extensions=  Armenian}', "");
    Expect(1, 64279, '\P{^Script_Extensions=  Armenian}', "");
    Expect(0, 64280, '\p{Script_Extensions=  Armenian}', "");
    Expect(1, 64280, '\p{^Script_Extensions=  Armenian}', "");
    Expect(1, 64280, '\P{Script_Extensions=  Armenian}', "");
    Expect(0, 64280, '\P{^Script_Extensions=  Armenian}', "");
    Error('\p{Scx=/a/ ARMN}');
    Error('\P{Scx=/a/ ARMN}');
    Expect(1, 64279, '\p{Scx=:\AArmn\z:}', "");;
    Expect(0, 64280, '\p{Scx=:\AArmn\z:}', "");;
    Expect(1, 64279, '\p{Scx:armn}', "");
    Expect(0, 64279, '\p{^Scx:armn}', "");
    Expect(0, 64279, '\P{Scx:armn}', "");
    Expect(1, 64279, '\P{^Scx:armn}', "");
    Expect(0, 64280, '\p{Scx:armn}', "");
    Expect(1, 64280, '\p{^Scx:armn}', "");
    Expect(1, 64280, '\P{Scx:armn}', "");
    Expect(0, 64280, '\P{^Scx:armn}', "");
    Expect(1, 64279, '\p{Scx=:\Aarmn\z:}', "");;
    Expect(0, 64280, '\p{Scx=:\Aarmn\z:}', "");;
    Expect(1, 64279, '\p{Scx=	-Armn}', "");
    Expect(0, 64279, '\p{^Scx=	-Armn}', "");
    Expect(0, 64279, '\P{Scx=	-Armn}', "");
    Expect(1, 64279, '\P{^Scx=	-Armn}', "");
    Expect(0, 64280, '\p{Scx=	-Armn}', "");
    Expect(1, 64280, '\p{^Scx=	-Armn}', "");
    Expect(1, 64280, '\P{Scx=	-Armn}', "");
    Expect(0, 64280, '\P{^Scx=	-Armn}', "");
    Error('\p{Is_Script_Extensions=_:=ARMENIAN}');
    Error('\P{Is_Script_Extensions=_:=ARMENIAN}');
    Expect(1, 64279, '\p{Is_Script_Extensions=armenian}', "");
    Expect(0, 64279, '\p{^Is_Script_Extensions=armenian}', "");
    Expect(0, 64279, '\P{Is_Script_Extensions=armenian}', "");
    Expect(1, 64279, '\P{^Is_Script_Extensions=armenian}', "");
    Expect(0, 64280, '\p{Is_Script_Extensions=armenian}', "");
    Expect(1, 64280, '\p{^Is_Script_Extensions=armenian}', "");
    Expect(1, 64280, '\P{Is_Script_Extensions=armenian}', "");
    Expect(0, 64280, '\P{^Is_Script_Extensions=armenian}', "");
    Expect(1, 64279, '\p{Is_Script_Extensions=__Armenian}', "");
    Expect(0, 64279, '\p{^Is_Script_Extensions=__Armenian}', "");
    Expect(0, 64279, '\P{Is_Script_Extensions=__Armenian}', "");
    Expect(1, 64279, '\P{^Is_Script_Extensions=__Armenian}', "");
    Expect(0, 64280, '\p{Is_Script_Extensions=__Armenian}', "");
    Expect(1, 64280, '\p{^Is_Script_Extensions=__Armenian}', "");
    Expect(1, 64280, '\P{Is_Script_Extensions=__Armenian}', "");
    Expect(0, 64280, '\P{^Is_Script_Extensions=__Armenian}', "");
    Error('\p{Is_Scx= /a/ARMN}');
    Error('\P{Is_Scx= /a/ARMN}');
    Expect(1, 64279, '\p{Is_Scx=armn}', "");
    Expect(0, 64279, '\p{^Is_Scx=armn}', "");
    Expect(0, 64279, '\P{Is_Scx=armn}', "");
    Expect(1, 64279, '\P{^Is_Scx=armn}', "");
    Expect(0, 64280, '\p{Is_Scx=armn}', "");
    Expect(1, 64280, '\p{^Is_Scx=armn}', "");
    Expect(1, 64280, '\P{Is_Scx=armn}', "");
    Expect(0, 64280, '\P{^Is_Scx=armn}', "");
    Expect(1, 64279, '\p{Is_Scx=		armn}', "");
    Expect(0, 64279, '\p{^Is_Scx=		armn}', "");
    Expect(0, 64279, '\P{Is_Scx=		armn}', "");
    Expect(1, 64279, '\P{^Is_Scx=		armn}', "");
    Expect(0, 64280, '\p{Is_Scx=		armn}', "");
    Expect(1, 64280, '\p{^Is_Scx=		armn}', "");
    Expect(1, 64280, '\P{Is_Scx=		armn}', "");
    Expect(0, 64280, '\P{^Is_Scx=		armn}', "");
    Error('\p{Script_Extensions=:=AVESTAN}');
    Error('\P{Script_Extensions=:=AVESTAN}');
    Expect(1, 68415, '\p{Script_Extensions=:\AAvestan\z:}', "");;
    Expect(0, 68416, '\p{Script_Extensions=:\AAvestan\z:}', "");;
    Expect(1, 68415, '\p{Script_Extensions:   avestan}', "");
    Expect(0, 68415, '\p{^Script_Extensions:   avestan}', "");
    Expect(0, 68415, '\P{Script_Extensions:   avestan}', "");
    Expect(1, 68415, '\P{^Script_Extensions:   avestan}', "");
    Expect(0, 68416, '\p{Script_Extensions:   avestan}', "");
    Expect(1, 68416, '\p{^Script_Extensions:   avestan}', "");
    Expect(1, 68416, '\P{Script_Extensions:   avestan}', "");
    Expect(0, 68416, '\P{^Script_Extensions:   avestan}', "");
    Expect(1, 68415, '\p{Script_Extensions=:\Aavestan\z:}', "");;
    Expect(0, 68416, '\p{Script_Extensions=:\Aavestan\z:}', "");;
    Expect(1, 68415, '\p{Script_Extensions= _Avestan}', "");
    Expect(0, 68415, '\p{^Script_Extensions= _Avestan}', "");
    Expect(0, 68415, '\P{Script_Extensions= _Avestan}', "");
    Expect(1, 68415, '\P{^Script_Extensions= _Avestan}', "");
    Expect(0, 68416, '\p{Script_Extensions= _Avestan}', "");
    Expect(1, 68416, '\p{^Script_Extensions= _Avestan}', "");
    Expect(1, 68416, '\P{Script_Extensions= _Avestan}', "");
    Expect(0, 68416, '\P{^Script_Extensions= _Avestan}', "");
    Error('\p{Scx: -	Avst:=}');
    Error('\P{Scx: -	Avst:=}');
    Expect(1, 68415, '\p{Scx=:\AAvst\z:}', "");;
    Expect(0, 68416, '\p{Scx=:\AAvst\z:}', "");;
    Expect(1, 68415, '\p{Scx=avst}', "");
    Expect(0, 68415, '\p{^Scx=avst}', "");
    Expect(0, 68415, '\P{Scx=avst}', "");
    Expect(1, 68415, '\P{^Scx=avst}', "");
    Expect(0, 68416, '\p{Scx=avst}', "");
    Expect(1, 68416, '\p{^Scx=avst}', "");
    Expect(1, 68416, '\P{Scx=avst}', "");
    Expect(0, 68416, '\P{^Scx=avst}', "");
    Expect(1, 68415, '\p{Scx=:\Aavst\z:}', "");;
    Expect(0, 68416, '\p{Scx=:\Aavst\z:}', "");;
    Expect(1, 68415, '\p{Scx= avst}', "");
    Expect(0, 68415, '\p{^Scx= avst}', "");
    Expect(0, 68415, '\P{Scx= avst}', "");
    Expect(1, 68415, '\P{^Scx= avst}', "");
    Expect(0, 68416, '\p{Scx= avst}', "");
    Expect(1, 68416, '\p{^Scx= avst}', "");
    Expect(1, 68416, '\P{Scx= avst}', "");
    Expect(0, 68416, '\P{^Scx= avst}', "");
    Error('\p{Is_Script_Extensions=_Avestan/a/}');
    Error('\P{Is_Script_Extensions=_Avestan/a/}');
    Expect(1, 68415, '\p{Is_Script_Extensions=avestan}', "");
    Expect(0, 68415, '\p{^Is_Script_Extensions=avestan}', "");
    Expect(0, 68415, '\P{Is_Script_Extensions=avestan}', "");
    Expect(1, 68415, '\P{^Is_Script_Extensions=avestan}', "");
    Expect(0, 68416, '\p{Is_Script_Extensions=avestan}', "");
    Expect(1, 68416, '\p{^Is_Script_Extensions=avestan}', "");
    Expect(1, 68416, '\P{Is_Script_Extensions=avestan}', "");
    Expect(0, 68416, '\P{^Is_Script_Extensions=avestan}', "");
    Expect(1, 68415, '\p{Is_Script_Extensions:   _-Avestan}', "");
    Expect(0, 68415, '\p{^Is_Script_Extensions:   _-Avestan}', "");
    Expect(0, 68415, '\P{Is_Script_Extensions:   _-Avestan}', "");
    Expect(1, 68415, '\P{^Is_Script_Extensions:   _-Avestan}', "");
    Expect(0, 68416, '\p{Is_Script_Extensions:   _-Avestan}', "");
    Expect(1, 68416, '\p{^Is_Script_Extensions:   _-Avestan}', "");
    Expect(1, 68416, '\P{Is_Script_Extensions:   _-Avestan}', "");
    Expect(0, 68416, '\P{^Is_Script_Extensions:   _-Avestan}', "");
    Error('\p{Is_Scx:   	/a/Avst}');
    Error('\P{Is_Scx:   	/a/Avst}');
    Expect(1, 68415, '\p{Is_Scx=avst}', "");
    Expect(0, 68415, '\p{^Is_Scx=avst}', "");
    Expect(0, 68415, '\P{Is_Scx=avst}', "");
    Expect(1, 68415, '\P{^Is_Scx=avst}', "");
    Expect(0, 68416, '\p{Is_Scx=avst}', "");
    Expect(1, 68416, '\p{^Is_Scx=avst}', "");
    Expect(1, 68416, '\P{Is_Scx=avst}', "");
    Expect(0, 68416, '\P{^Is_Scx=avst}', "");
    Expect(1, 68415, '\p{Is_Scx=-	Avst}', "");
    Expect(0, 68415, '\p{^Is_Scx=-	Avst}', "");
    Expect(0, 68415, '\P{Is_Scx=-	Avst}', "");
    Expect(1, 68415, '\P{^Is_Scx=-	Avst}', "");
    Expect(0, 68416, '\p{Is_Scx=-	Avst}', "");
    Expect(1, 68416, '\p{^Is_Scx=-	Avst}', "");
    Expect(1, 68416, '\P{Is_Scx=-	Avst}', "");
    Expect(0, 68416, '\P{^Is_Scx=-	Avst}', "");
    Error('\p{Script_Extensions=:=balinese}');
    Error('\P{Script_Extensions=:=balinese}');
    Expect(1, 7036, '\p{Script_Extensions=:\ABalinese\z:}', "");;
    Expect(0, 7037, '\p{Script_Extensions=:\ABalinese\z:}', "");;
    Expect(1, 7036, '\p{Script_Extensions: balinese}', "");
    Expect(0, 7036, '\p{^Script_Extensions: balinese}', "");
    Expect(0, 7036, '\P{Script_Extensions: balinese}', "");
    Expect(1, 7036, '\P{^Script_Extensions: balinese}', "");
    Expect(0, 7037, '\p{Script_Extensions: balinese}', "");
    Expect(1, 7037, '\p{^Script_Extensions: balinese}', "");
    Expect(1, 7037, '\P{Script_Extensions: balinese}', "");
    Expect(0, 7037, '\P{^Script_Extensions: balinese}', "");
    Expect(1, 7036, '\p{Script_Extensions=:\Abalinese\z:}', "");;
    Expect(0, 7037, '\p{Script_Extensions=:\Abalinese\z:}', "");;
    Expect(1, 7036, '\p{Script_Extensions=_-BALINESE}', "");
    Expect(0, 7036, '\p{^Script_Extensions=_-BALINESE}', "");
    Expect(0, 7036, '\P{Script_Extensions=_-BALINESE}', "");
    Expect(1, 7036, '\P{^Script_Extensions=_-BALINESE}', "");
    Expect(0, 7037, '\p{Script_Extensions=_-BALINESE}', "");
    Expect(1, 7037, '\p{^Script_Extensions=_-BALINESE}', "");
    Expect(1, 7037, '\P{Script_Extensions=_-BALINESE}', "");
    Expect(0, 7037, '\P{^Script_Extensions=_-BALINESE}', "");
    Error('\p{Scx=:=_ bali}');
    Error('\P{Scx=:=_ bali}');
    Expect(1, 7036, '\p{Scx=:\ABali\z:}', "");;
    Expect(0, 7037, '\p{Scx=:\ABali\z:}', "");;
    Expect(1, 7036, '\p{Scx=bali}', "");
    Expect(0, 7036, '\p{^Scx=bali}', "");
    Expect(0, 7036, '\P{Scx=bali}', "");
    Expect(1, 7036, '\P{^Scx=bali}', "");
    Expect(0, 7037, '\p{Scx=bali}', "");
    Expect(1, 7037, '\p{^Scx=bali}', "");
    Expect(1, 7037, '\P{Scx=bali}', "");
    Expect(0, 7037, '\P{^Scx=bali}', "");
    Expect(1, 7036, '\p{Scx=:\Abali\z:}', "");;
    Expect(0, 7037, '\p{Scx=:\Abali\z:}', "");;
    Expect(1, 7036, '\p{Scx:	BALI}', "");
    Expect(0, 7036, '\p{^Scx:	BALI}', "");
    Expect(0, 7036, '\P{Scx:	BALI}', "");
    Expect(1, 7036, '\P{^Scx:	BALI}', "");
    Expect(0, 7037, '\p{Scx:	BALI}', "");
    Expect(1, 7037, '\p{^Scx:	BALI}', "");
    Expect(1, 7037, '\P{Scx:	BALI}', "");
    Expect(0, 7037, '\P{^Scx:	BALI}', "");
    Error('\p{Is_Script_Extensions:	_:=BALINESE}');
    Error('\P{Is_Script_Extensions:	_:=BALINESE}');
    Expect(1, 7036, '\p{Is_Script_Extensions=balinese}', "");
    Expect(0, 7036, '\p{^Is_Script_Extensions=balinese}', "");
    Expect(0, 7036, '\P{Is_Script_Extensions=balinese}', "");
    Expect(1, 7036, '\P{^Is_Script_Extensions=balinese}', "");
    Expect(0, 7037, '\p{Is_Script_Extensions=balinese}', "");
    Expect(1, 7037, '\p{^Is_Script_Extensions=balinese}', "");
    Expect(1, 7037, '\P{Is_Script_Extensions=balinese}', "");
    Expect(0, 7037, '\P{^Is_Script_Extensions=balinese}', "");
    Expect(1, 7036, '\p{Is_Script_Extensions=-_BALINESE}', "");
    Expect(0, 7036, '\p{^Is_Script_Extensions=-_BALINESE}', "");
    Expect(0, 7036, '\P{Is_Script_Extensions=-_BALINESE}', "");
    Expect(1, 7036, '\P{^Is_Script_Extensions=-_BALINESE}', "");
    Expect(0, 7037, '\p{Is_Script_Extensions=-_BALINESE}', "");
    Expect(1, 7037, '\p{^Is_Script_Extensions=-_BALINESE}', "");
    Expect(1, 7037, '\P{Is_Script_Extensions=-_BALINESE}', "");
    Expect(0, 7037, '\P{^Is_Script_Extensions=-_BALINESE}', "");
    Error('\p{Is_Scx=:=bali}');
    Error('\P{Is_Scx=:=bali}');
    Expect(1, 7036, '\p{Is_Scx=bali}', "");
    Expect(0, 7036, '\p{^Is_Scx=bali}', "");
    Expect(0, 7036, '\P{Is_Scx=bali}', "");
    Expect(1, 7036, '\P{^Is_Scx=bali}', "");
    Expect(0, 7037, '\p{Is_Scx=bali}', "");
    Expect(1, 7037, '\p{^Is_Scx=bali}', "");
    Expect(1, 7037, '\P{Is_Scx=bali}', "");
    Expect(0, 7037, '\P{^Is_Scx=bali}', "");
    Expect(1, 7036, '\p{Is_Scx= _Bali}', "");
    Expect(0, 7036, '\p{^Is_Scx= _Bali}', "");
    Expect(0, 7036, '\P{Is_Scx= _Bali}', "");
    Expect(1, 7036, '\P{^Is_Scx= _Bali}', "");
    Expect(0, 7037, '\p{Is_Scx= _Bali}', "");
    Expect(1, 7037, '\p{^Is_Scx= _Bali}', "");
    Expect(1, 7037, '\P{Is_Scx= _Bali}', "");
    Expect(0, 7037, '\P{^Is_Scx= _Bali}', "");
    Error('\p{Script_Extensions=:=--Bamum}');
    Error('\P{Script_Extensions=:=--Bamum}');
    Expect(1, 92728, '\p{Script_Extensions=:\ABamum\z:}', "");;
    Expect(0, 92729, '\p{Script_Extensions=:\ABamum\z:}', "");;
    Expect(1, 92728, '\p{Script_Extensions=bamum}', "");
    Expect(0, 92728, '\p{^Script_Extensions=bamum}', "");
    Expect(0, 92728, '\P{Script_Extensions=bamum}', "");
    Expect(1, 92728, '\P{^Script_Extensions=bamum}', "");
    Expect(0, 92729, '\p{Script_Extensions=bamum}', "");
    Expect(1, 92729, '\p{^Script_Extensions=bamum}', "");
    Expect(1, 92729, '\P{Script_Extensions=bamum}', "");
    Expect(0, 92729, '\P{^Script_Extensions=bamum}', "");
    Expect(1, 92728, '\p{Script_Extensions=:\Abamum\z:}', "");;
    Expect(0, 92729, '\p{Script_Extensions=:\Abamum\z:}', "");;
    Expect(1, 92728, '\p{Script_Extensions:_BAMUM}', "");
    Expect(0, 92728, '\p{^Script_Extensions:_BAMUM}', "");
    Expect(0, 92728, '\P{Script_Extensions:_BAMUM}', "");
    Expect(1, 92728, '\P{^Script_Extensions:_BAMUM}', "");
    Expect(0, 92729, '\p{Script_Extensions:_BAMUM}', "");
    Expect(1, 92729, '\p{^Script_Extensions:_BAMUM}', "");
    Expect(1, 92729, '\P{Script_Extensions:_BAMUM}', "");
    Expect(0, 92729, '\P{^Script_Extensions:_BAMUM}', "");
    Error('\p{Scx=-/a/Bamu}');
    Error('\P{Scx=-/a/Bamu}');
    Expect(1, 92728, '\p{Scx=:\ABamu\z:}', "");;
    Expect(0, 92729, '\p{Scx=:\ABamu\z:}', "");;
    Expect(1, 92728, '\p{Scx: bamu}', "");
    Expect(0, 92728, '\p{^Scx: bamu}', "");
    Expect(0, 92728, '\P{Scx: bamu}', "");
    Expect(1, 92728, '\P{^Scx: bamu}', "");
    Expect(0, 92729, '\p{Scx: bamu}', "");
    Expect(1, 92729, '\p{^Scx: bamu}', "");
    Expect(1, 92729, '\P{Scx: bamu}', "");
    Expect(0, 92729, '\P{^Scx: bamu}', "");
    Expect(1, 92728, '\p{Scx=:\Abamu\z:}', "");;
    Expect(0, 92729, '\p{Scx=:\Abamu\z:}', "");;
    Expect(1, 92728, '\p{Scx=	_Bamu}', "");
    Expect(0, 92728, '\p{^Scx=	_Bamu}', "");
    Expect(0, 92728, '\P{Scx=	_Bamu}', "");
    Expect(1, 92728, '\P{^Scx=	_Bamu}', "");
    Expect(0, 92729, '\p{Scx=	_Bamu}', "");
    Expect(1, 92729, '\p{^Scx=	_Bamu}', "");
    Expect(1, 92729, '\P{Scx=	_Bamu}', "");
    Expect(0, 92729, '\P{^Scx=	_Bamu}', "");
    Error('\p{Is_Script_Extensions=:= 	Bamum}');
    Error('\P{Is_Script_Extensions=:= 	Bamum}');
    Expect(1, 92728, '\p{Is_Script_Extensions=bamum}', "");
    Expect(0, 92728, '\p{^Is_Script_Extensions=bamum}', "");
    Expect(0, 92728, '\P{Is_Script_Extensions=bamum}', "");
    Expect(1, 92728, '\P{^Is_Script_Extensions=bamum}', "");
    Expect(0, 92729, '\p{Is_Script_Extensions=bamum}', "");
    Expect(1, 92729, '\p{^Is_Script_Extensions=bamum}', "");
    Expect(1, 92729, '\P{Is_Script_Extensions=bamum}', "");
    Expect(0, 92729, '\P{^Is_Script_Extensions=bamum}', "");
    Expect(1, 92728, '\p{Is_Script_Extensions=  BAMUM}', "");
    Expect(0, 92728, '\p{^Is_Script_Extensions=  BAMUM}', "");
    Expect(0, 92728, '\P{Is_Script_Extensions=  BAMUM}', "");
    Expect(1, 92728, '\P{^Is_Script_Extensions=  BAMUM}', "");
    Expect(0, 92729, '\p{Is_Script_Extensions=  BAMUM}', "");
    Expect(1, 92729, '\p{^Is_Script_Extensions=  BAMUM}', "");
    Expect(1, 92729, '\P{Is_Script_Extensions=  BAMUM}', "");
    Expect(0, 92729, '\P{^Is_Script_Extensions=  BAMUM}', "");
    Error('\p{Is_Scx=_-Bamu/a/}');
    Error('\P{Is_Scx=_-Bamu/a/}');
    Expect(1, 92728, '\p{Is_Scx=bamu}', "");
    Expect(0, 92728, '\p{^Is_Scx=bamu}', "");
    Expect(0, 92728, '\P{Is_Scx=bamu}', "");
    Expect(1, 92728, '\P{^Is_Scx=bamu}', "");
    Expect(0, 92729, '\p{Is_Scx=bamu}', "");
    Expect(1, 92729, '\p{^Is_Scx=bamu}', "");
    Expect(1, 92729, '\P{Is_Scx=bamu}', "");
    Expect(0, 92729, '\P{^Is_Scx=bamu}', "");
    Expect(1, 92728, '\p{Is_Scx= _Bamu}', "");
    Expect(0, 92728, '\p{^Is_Scx= _Bamu}', "");
    Expect(0, 92728, '\P{Is_Scx= _Bamu}', "");
    Expect(1, 92728, '\P{^Is_Scx= _Bamu}', "");
    Expect(0, 92729, '\p{Is_Scx= _Bamu}', "");
    Expect(1, 92729, '\p{^Is_Scx= _Bamu}', "");
    Expect(1, 92729, '\P{Is_Scx= _Bamu}', "");
    Expect(0, 92729, '\P{^Is_Scx= _Bamu}', "");
    Error('\p{Script_Extensions=/a/		Bassa_VAH}');
    Error('\P{Script_Extensions=/a/		Bassa_VAH}');
    Expect(1, 92917, '\p{Script_Extensions=:\ABassa_Vah\z:}', "");;
    Expect(0, 92918, '\p{Script_Extensions=:\ABassa_Vah\z:}', "");;
    Expect(1, 92917, '\p{Script_Extensions=bassavah}', "");
    Expect(0, 92917, '\p{^Script_Extensions=bassavah}', "");
    Expect(0, 92917, '\P{Script_Extensions=bassavah}', "");
    Expect(1, 92917, '\P{^Script_Extensions=bassavah}', "");
    Expect(0, 92918, '\p{Script_Extensions=bassavah}', "");
    Expect(1, 92918, '\p{^Script_Extensions=bassavah}', "");
    Expect(1, 92918, '\P{Script_Extensions=bassavah}', "");
    Expect(0, 92918, '\P{^Script_Extensions=bassavah}', "");
    Expect(1, 92917, '\p{Script_Extensions=:\Abassavah\z:}', "");;
    Expect(0, 92918, '\p{Script_Extensions=:\Abassavah\z:}', "");;
    Expect(1, 92917, '\p{Script_Extensions=_BASSA_vah}', "");
    Expect(0, 92917, '\p{^Script_Extensions=_BASSA_vah}', "");
    Expect(0, 92917, '\P{Script_Extensions=_BASSA_vah}', "");
    Expect(1, 92917, '\P{^Script_Extensions=_BASSA_vah}', "");
    Expect(0, 92918, '\p{Script_Extensions=_BASSA_vah}', "");
    Expect(1, 92918, '\p{^Script_Extensions=_BASSA_vah}', "");
    Expect(1, 92918, '\P{Script_Extensions=_BASSA_vah}', "");
    Expect(0, 92918, '\P{^Script_Extensions=_BASSA_vah}', "");
    Error('\p{Scx: _	Bass/a/}');
    Error('\P{Scx: _	Bass/a/}');
    Expect(1, 92917, '\p{Scx=:\ABass\z:}', "");;
    Expect(0, 92918, '\p{Scx=:\ABass\z:}', "");;
    Expect(1, 92917, '\p{Scx=bass}', "");
    Expect(0, 92917, '\p{^Scx=bass}', "");
    Expect(0, 92917, '\P{Scx=bass}', "");
    Expect(1, 92917, '\P{^Scx=bass}', "");
    Expect(0, 92918, '\p{Scx=bass}', "");
    Expect(1, 92918, '\p{^Scx=bass}', "");
    Expect(1, 92918, '\P{Scx=bass}', "");
    Expect(0, 92918, '\P{^Scx=bass}', "");
    Expect(1, 92917, '\p{Scx=:\Abass\z:}', "");;
    Expect(0, 92918, '\p{Scx=:\Abass\z:}', "");;
    Expect(1, 92917, '\p{Scx=-	Bass}', "");
    Expect(0, 92917, '\p{^Scx=-	Bass}', "");
    Expect(0, 92917, '\P{Scx=-	Bass}', "");
    Expect(1, 92917, '\P{^Scx=-	Bass}', "");
    Expect(0, 92918, '\p{Scx=-	Bass}', "");
    Expect(1, 92918, '\p{^Scx=-	Bass}', "");
    Expect(1, 92918, '\P{Scx=-	Bass}', "");
    Expect(0, 92918, '\P{^Scx=-	Bass}', "");
    Error('\p{Is_Script_Extensions=/a/-bassa_VAH}');
    Error('\P{Is_Script_Extensions=/a/-bassa_VAH}');
    Expect(1, 92917, '\p{Is_Script_Extensions=bassavah}', "");
    Expect(0, 92917, '\p{^Is_Script_Extensions=bassavah}', "");
    Expect(0, 92917, '\P{Is_Script_Extensions=bassavah}', "");
    Expect(1, 92917, '\P{^Is_Script_Extensions=bassavah}', "");
    Expect(0, 92918, '\p{Is_Script_Extensions=bassavah}', "");
    Expect(1, 92918, '\p{^Is_Script_Extensions=bassavah}', "");
    Expect(1, 92918, '\P{Is_Script_Extensions=bassavah}', "");
    Expect(0, 92918, '\P{^Is_Script_Extensions=bassavah}', "");
    Expect(1, 92917, '\p{Is_Script_Extensions=_Bassa_VAH}', "");
    Expect(0, 92917, '\p{^Is_Script_Extensions=_Bassa_VAH}', "");
    Expect(0, 92917, '\P{Is_Script_Extensions=_Bassa_VAH}', "");
    Expect(1, 92917, '\P{^Is_Script_Extensions=_Bassa_VAH}', "");
    Expect(0, 92918, '\p{Is_Script_Extensions=_Bassa_VAH}', "");
    Expect(1, 92918, '\p{^Is_Script_Extensions=_Bassa_VAH}', "");
    Expect(1, 92918, '\P{Is_Script_Extensions=_Bassa_VAH}', "");
    Expect(0, 92918, '\P{^Is_Script_Extensions=_Bassa_VAH}', "");
    Error('\p{Is_Scx=	 Bass/a/}');
    Error('\P{Is_Scx=	 Bass/a/}');
    Expect(1, 92917, '\p{Is_Scx=bass}', "");
    Expect(0, 92917, '\p{^Is_Scx=bass}', "");
    Expect(0, 92917, '\P{Is_Scx=bass}', "");
    Expect(1, 92917, '\P{^Is_Scx=bass}', "");
    Expect(0, 92918, '\p{Is_Scx=bass}', "");
    Expect(1, 92918, '\p{^Is_Scx=bass}', "");
    Expect(1, 92918, '\P{Is_Scx=bass}', "");
    Expect(0, 92918, '\P{^Is_Scx=bass}', "");
    Expect(1, 92917, '\p{Is_Scx=	Bass}', "");
    Expect(0, 92917, '\p{^Is_Scx=	Bass}', "");
    Expect(0, 92917, '\P{Is_Scx=	Bass}', "");
    Expect(1, 92917, '\P{^Is_Scx=	Bass}', "");
    Expect(0, 92918, '\p{Is_Scx=	Bass}', "");
    Expect(1, 92918, '\p{^Is_Scx=	Bass}', "");
    Expect(1, 92918, '\P{Is_Scx=	Bass}', "");
    Expect(0, 92918, '\P{^Is_Scx=	Bass}', "");
    Error('\p{Script_Extensions=:=_-Batak}');
    Error('\P{Script_Extensions=:=_-Batak}');
    Expect(1, 7167, '\p{Script_Extensions=:\ABatak\z:}', "");;
    Expect(0, 7168, '\p{Script_Extensions=:\ABatak\z:}', "");;
    Expect(1, 7167, '\p{Script_Extensions=batak}', "");
    Expect(0, 7167, '\p{^Script_Extensions=batak}', "");
    Expect(0, 7167, '\P{Script_Extensions=batak}', "");
    Expect(1, 7167, '\P{^Script_Extensions=batak}', "");
    Expect(0, 7168, '\p{Script_Extensions=batak}', "");
    Expect(1, 7168, '\p{^Script_Extensions=batak}', "");
    Expect(1, 7168, '\P{Script_Extensions=batak}', "");
    Expect(0, 7168, '\P{^Script_Extensions=batak}', "");
    Expect(1, 7167, '\p{Script_Extensions=:\Abatak\z:}', "");;
    Expect(0, 7168, '\p{Script_Extensions=:\Abatak\z:}', "");;
    Expect(1, 7167, '\p{Script_Extensions=Batak}', "");
    Expect(0, 7167, '\p{^Script_Extensions=Batak}', "");
    Expect(0, 7167, '\P{Script_Extensions=Batak}', "");
    Expect(1, 7167, '\P{^Script_Extensions=Batak}', "");
    Expect(0, 7168, '\p{Script_Extensions=Batak}', "");
    Expect(1, 7168, '\p{^Script_Extensions=Batak}', "");
    Expect(1, 7168, '\P{Script_Extensions=Batak}', "");
    Expect(0, 7168, '\P{^Script_Extensions=Batak}', "");
    Error('\p{Scx:	/a/-Batk}');
    Error('\P{Scx:	/a/-Batk}');
    Expect(1, 7167, '\p{Scx=:\ABatk\z:}', "");;
    Expect(0, 7168, '\p{Scx=:\ABatk\z:}', "");;
    Expect(1, 7167, '\p{Scx=batk}', "");
    Expect(0, 7167, '\p{^Scx=batk}', "");
    Expect(0, 7167, '\P{Scx=batk}', "");
    Expect(1, 7167, '\P{^Scx=batk}', "");
    Expect(0, 7168, '\p{Scx=batk}', "");
    Expect(1, 7168, '\p{^Scx=batk}', "");
    Expect(1, 7168, '\P{Scx=batk}', "");
    Expect(0, 7168, '\P{^Scx=batk}', "");
    Expect(1, 7167, '\p{Scx=:\Abatk\z:}', "");;
    Expect(0, 7168, '\p{Scx=:\Abatk\z:}', "");;
    Expect(1, 7167, '\p{Scx=	-batk}', "");
    Expect(0, 7167, '\p{^Scx=	-batk}', "");
    Expect(0, 7167, '\P{Scx=	-batk}', "");
    Expect(1, 7167, '\P{^Scx=	-batk}', "");
    Expect(0, 7168, '\p{Scx=	-batk}', "");
    Expect(1, 7168, '\p{^Scx=	-batk}', "");
    Expect(1, 7168, '\P{Scx=	-batk}', "");
    Expect(0, 7168, '\P{^Scx=	-batk}', "");
    Error('\p{Is_Script_Extensions: :=__Batak}');
    Error('\P{Is_Script_Extensions: :=__Batak}');
    Expect(1, 7167, '\p{Is_Script_Extensions=batak}', "");
    Expect(0, 7167, '\p{^Is_Script_Extensions=batak}', "");
    Expect(0, 7167, '\P{Is_Script_Extensions=batak}', "");
    Expect(1, 7167, '\P{^Is_Script_Extensions=batak}', "");
    Expect(0, 7168, '\p{Is_Script_Extensions=batak}', "");
    Expect(1, 7168, '\p{^Is_Script_Extensions=batak}', "");
    Expect(1, 7168, '\P{Is_Script_Extensions=batak}', "");
    Expect(0, 7168, '\P{^Is_Script_Extensions=batak}', "");
    Expect(1, 7167, '\p{Is_Script_Extensions: Batak}', "");
    Expect(0, 7167, '\p{^Is_Script_Extensions: Batak}', "");
    Expect(0, 7167, '\P{Is_Script_Extensions: Batak}', "");
    Expect(1, 7167, '\P{^Is_Script_Extensions: Batak}', "");
    Expect(0, 7168, '\p{Is_Script_Extensions: Batak}', "");
    Expect(1, 7168, '\p{^Is_Script_Extensions: Batak}', "");
    Expect(1, 7168, '\P{Is_Script_Extensions: Batak}', "");
    Expect(0, 7168, '\P{^Is_Script_Extensions: Batak}', "");
    Error('\p{Is_Scx=/a/_-Batk}');
    Error('\P{Is_Scx=/a/_-Batk}');
    Expect(1, 7167, '\p{Is_Scx=batk}', "");
    Expect(0, 7167, '\p{^Is_Scx=batk}', "");
    Expect(0, 7167, '\P{Is_Scx=batk}', "");
    Expect(1, 7167, '\P{^Is_Scx=batk}', "");
    Expect(0, 7168, '\p{Is_Scx=batk}', "");
    Expect(1, 7168, '\p{^Is_Scx=batk}', "");
    Expect(1, 7168, '\P{Is_Scx=batk}', "");
    Expect(0, 7168, '\P{^Is_Scx=batk}', "");
    Expect(1, 7167, '\p{Is_Scx=	Batk}', "");
    Expect(0, 7167, '\p{^Is_Scx=	Batk}', "");
    Expect(0, 7167, '\P{Is_Scx=	Batk}', "");
    Expect(1, 7167, '\P{^Is_Scx=	Batk}', "");
    Expect(0, 7168, '\p{Is_Scx=	Batk}', "");
    Expect(1, 7168, '\p{^Is_Scx=	Batk}', "");
    Expect(1, 7168, '\P{Is_Scx=	Batk}', "");
    Expect(0, 7168, '\P{^Is_Scx=	Batk}', "");
    Error('\p{Script_Extensions= -bengali:=}');
    Error('\P{Script_Extensions= -bengali:=}');
    Expect(1, 43249, '\p{Script_Extensions=:\ABengali\z:}', "");;
    Expect(0, 43250, '\p{Script_Extensions=:\ABengali\z:}', "");;
    Expect(1, 43249, '\p{Script_Extensions=bengali}', "");
    Expect(0, 43249, '\p{^Script_Extensions=bengali}', "");
    Expect(0, 43249, '\P{Script_Extensions=bengali}', "");
    Expect(1, 43249, '\P{^Script_Extensions=bengali}', "");
    Expect(0, 43250, '\p{Script_Extensions=bengali}', "");
    Expect(1, 43250, '\p{^Script_Extensions=bengali}', "");
    Expect(1, 43250, '\P{Script_Extensions=bengali}', "");
    Expect(0, 43250, '\P{^Script_Extensions=bengali}', "");
    Expect(1, 43249, '\p{Script_Extensions=:\Abengali\z:}', "");;
    Expect(0, 43250, '\p{Script_Extensions=:\Abengali\z:}', "");;
    Expect(1, 43249, '\p{Script_Extensions=-	Bengali}', "");
    Expect(0, 43249, '\p{^Script_Extensions=-	Bengali}', "");
    Expect(0, 43249, '\P{Script_Extensions=-	Bengali}', "");
    Expect(1, 43249, '\P{^Script_Extensions=-	Bengali}', "");
    Expect(0, 43250, '\p{Script_Extensions=-	Bengali}', "");
    Expect(1, 43250, '\p{^Script_Extensions=-	Bengali}', "");
    Expect(1, 43250, '\P{Script_Extensions=-	Bengali}', "");
    Expect(0, 43250, '\P{^Script_Extensions=-	Bengali}', "");
    Error('\p{Scx=-_BENG:=}');
    Error('\P{Scx=-_BENG:=}');
    Expect(1, 43249, '\p{Scx=:\ABeng\z:}', "");;
    Expect(0, 43250, '\p{Scx=:\ABeng\z:}', "");;
    Expect(1, 43249, '\p{Scx=beng}', "");
    Expect(0, 43249, '\p{^Scx=beng}', "");
    Expect(0, 43249, '\P{Scx=beng}', "");
    Expect(1, 43249, '\P{^Scx=beng}', "");
    Expect(0, 43250, '\p{Scx=beng}', "");
    Expect(1, 43250, '\p{^Scx=beng}', "");
    Expect(1, 43250, '\P{Scx=beng}', "");
    Expect(0, 43250, '\P{^Scx=beng}', "");
    Expect(1, 43249, '\p{Scx=:\Abeng\z:}', "");;
    Expect(0, 43250, '\p{Scx=:\Abeng\z:}', "");;
    Expect(1, 43249, '\p{Scx=_ beng}', "");
    Expect(0, 43249, '\p{^Scx=_ beng}', "");
    Expect(0, 43249, '\P{Scx=_ beng}', "");
    Expect(1, 43249, '\P{^Scx=_ beng}', "");
    Expect(0, 43250, '\p{Scx=_ beng}', "");
    Expect(1, 43250, '\p{^Scx=_ beng}', "");
    Expect(1, 43250, '\P{Scx=_ beng}', "");
    Expect(0, 43250, '\P{^Scx=_ beng}', "");
    Error('\p{Is_Script_Extensions=_/a/Bengali}');
    Error('\P{Is_Script_Extensions=_/a/Bengali}');
    Expect(1, 43249, '\p{Is_Script_Extensions=bengali}', "");
    Expect(0, 43249, '\p{^Is_Script_Extensions=bengali}', "");
    Expect(0, 43249, '\P{Is_Script_Extensions=bengali}', "");
    Expect(1, 43249, '\P{^Is_Script_Extensions=bengali}', "");
    Expect(0, 43250, '\p{Is_Script_Extensions=bengali}', "");
    Expect(1, 43250, '\p{^Is_Script_Extensions=bengali}', "");
    Expect(1, 43250, '\P{Is_Script_Extensions=bengali}', "");
    Expect(0, 43250, '\P{^Is_Script_Extensions=bengali}', "");
    Expect(1, 43249, '\p{Is_Script_Extensions= Bengali}', "");
    Expect(0, 43249, '\p{^Is_Script_Extensions= Bengali}', "");
    Expect(0, 43249, '\P{Is_Script_Extensions= Bengali}', "");
    Expect(1, 43249, '\P{^Is_Script_Extensions= Bengali}', "");
    Expect(0, 43250, '\p{Is_Script_Extensions= Bengali}', "");
    Expect(1, 43250, '\p{^Is_Script_Extensions= Bengali}', "");
    Expect(1, 43250, '\P{Is_Script_Extensions= Bengali}', "");
    Expect(0, 43250, '\P{^Is_Script_Extensions= Bengali}', "");
    Error('\p{Is_Scx:   	/a/BENG}');
    Error('\P{Is_Scx:   	/a/BENG}');
    Expect(1, 43249, '\p{Is_Scx=beng}', "");
    Expect(0, 43249, '\p{^Is_Scx=beng}', "");
    Expect(0, 43249, '\P{Is_Scx=beng}', "");
    Expect(1, 43249, '\P{^Is_Scx=beng}', "");
    Expect(0, 43250, '\p{Is_Scx=beng}', "");
    Expect(1, 43250, '\p{^Is_Scx=beng}', "");
    Expect(1, 43250, '\P{Is_Scx=beng}', "");
    Expect(0, 43250, '\P{^Is_Scx=beng}', "");
    Expect(1, 43249, '\p{Is_Scx:		 Beng}', "");
    Expect(0, 43249, '\p{^Is_Scx:		 Beng}', "");
    Expect(0, 43249, '\P{Is_Scx:		 Beng}', "");
    Expect(1, 43249, '\P{^Is_Scx:		 Beng}', "");
    Expect(0, 43250, '\p{Is_Scx:		 Beng}', "");
    Expect(1, 43250, '\p{^Is_Scx:		 Beng}', "");
    Expect(1, 43250, '\P{Is_Scx:		 Beng}', "");
    Expect(0, 43250, '\P{^Is_Scx:		 Beng}', "");
    Error('\p{Script_Extensions=	/a/Bhaiksuki}');
    Error('\P{Script_Extensions=	/a/Bhaiksuki}');
    Expect(1, 72812, '\p{Script_Extensions=:\ABhaiksuki\z:}', "");;
    Expect(0, 72813, '\p{Script_Extensions=:\ABhaiksuki\z:}', "");;
    Expect(1, 72812, '\p{Script_Extensions=bhaiksuki}', "");
    Expect(0, 72812, '\p{^Script_Extensions=bhaiksuki}', "");
    Expect(0, 72812, '\P{Script_Extensions=bhaiksuki}', "");
    Expect(1, 72812, '\P{^Script_Extensions=bhaiksuki}', "");
    Expect(0, 72813, '\p{Script_Extensions=bhaiksuki}', "");
    Expect(1, 72813, '\p{^Script_Extensions=bhaiksuki}', "");
    Expect(1, 72813, '\P{Script_Extensions=bhaiksuki}', "");
    Expect(0, 72813, '\P{^Script_Extensions=bhaiksuki}', "");
    Expect(1, 72812, '\p{Script_Extensions=:\Abhaiksuki\z:}', "");;
    Expect(0, 72813, '\p{Script_Extensions=:\Abhaiksuki\z:}', "");;
    Expect(1, 72812, '\p{Script_Extensions= -Bhaiksuki}', "");
    Expect(0, 72812, '\p{^Script_Extensions= -Bhaiksuki}', "");
    Expect(0, 72812, '\P{Script_Extensions= -Bhaiksuki}', "");
    Expect(1, 72812, '\P{^Script_Extensions= -Bhaiksuki}', "");
    Expect(0, 72813, '\p{Script_Extensions= -Bhaiksuki}', "");
    Expect(1, 72813, '\p{^Script_Extensions= -Bhaiksuki}', "");
    Expect(1, 72813, '\P{Script_Extensions= -Bhaiksuki}', "");
    Expect(0, 72813, '\P{^Script_Extensions= -Bhaiksuki}', "");
    Error('\p{Scx: - BHKS/a/}');
    Error('\P{Scx: - BHKS/a/}');
    Expect(1, 72812, '\p{Scx=:\ABhks\z:}', "");;
    Expect(0, 72813, '\p{Scx=:\ABhks\z:}', "");;
    Expect(1, 72812, '\p{Scx=bhks}', "");
    Expect(0, 72812, '\p{^Scx=bhks}', "");
    Expect(0, 72812, '\P{Scx=bhks}', "");
    Expect(1, 72812, '\P{^Scx=bhks}', "");
    Expect(0, 72813, '\p{Scx=bhks}', "");
    Expect(1, 72813, '\p{^Scx=bhks}', "");
    Expect(1, 72813, '\P{Scx=bhks}', "");
    Expect(0, 72813, '\P{^Scx=bhks}', "");
    Expect(1, 72812, '\p{Scx=:\Abhks\z:}', "");;
    Expect(0, 72813, '\p{Scx=:\Abhks\z:}', "");;
    Expect(1, 72812, '\p{Scx:_Bhks}', "");
    Expect(0, 72812, '\p{^Scx:_Bhks}', "");
    Expect(0, 72812, '\P{Scx:_Bhks}', "");
    Expect(1, 72812, '\P{^Scx:_Bhks}', "");
    Expect(0, 72813, '\p{Scx:_Bhks}', "");
    Expect(1, 72813, '\p{^Scx:_Bhks}', "");
    Expect(1, 72813, '\P{Scx:_Bhks}', "");
    Expect(0, 72813, '\P{^Scx:_Bhks}', "");
    Error('\p{Is_Script_Extensions=/a/--BHAIKSUKI}');
    Error('\P{Is_Script_Extensions=/a/--BHAIKSUKI}');
    Expect(1, 72812, '\p{Is_Script_Extensions=bhaiksuki}', "");
    Expect(0, 72812, '\p{^Is_Script_Extensions=bhaiksuki}', "");
    Expect(0, 72812, '\P{Is_Script_Extensions=bhaiksuki}', "");
    Expect(1, 72812, '\P{^Is_Script_Extensions=bhaiksuki}', "");
    Expect(0, 72813, '\p{Is_Script_Extensions=bhaiksuki}', "");
    Expect(1, 72813, '\p{^Is_Script_Extensions=bhaiksuki}', "");
    Expect(1, 72813, '\P{Is_Script_Extensions=bhaiksuki}', "");
    Expect(0, 72813, '\P{^Is_Script_Extensions=bhaiksuki}', "");
    Expect(1, 72812, '\p{Is_Script_Extensions= Bhaiksuki}', "");
    Expect(0, 72812, '\p{^Is_Script_Extensions= Bhaiksuki}', "");
    Expect(0, 72812, '\P{Is_Script_Extensions= Bhaiksuki}', "");
    Expect(1, 72812, '\P{^Is_Script_Extensions= Bhaiksuki}', "");
    Expect(0, 72813, '\p{Is_Script_Extensions= Bhaiksuki}', "");
    Expect(1, 72813, '\p{^Is_Script_Extensions= Bhaiksuki}', "");
    Expect(1, 72813, '\P{Is_Script_Extensions= Bhaiksuki}', "");
    Expect(0, 72813, '\P{^Is_Script_Extensions= Bhaiksuki}', "");
    Error('\p{Is_Scx=:=	_bhks}');
    Error('\P{Is_Scx=:=	_bhks}');
    Expect(1, 72812, '\p{Is_Scx=bhks}', "");
    Expect(0, 72812, '\p{^Is_Scx=bhks}', "");
    Expect(0, 72812, '\P{Is_Scx=bhks}', "");
    Expect(1, 72812, '\P{^Is_Scx=bhks}', "");
    Expect(0, 72813, '\p{Is_Scx=bhks}', "");
    Expect(1, 72813, '\p{^Is_Scx=bhks}', "");
    Expect(1, 72813, '\P{Is_Scx=bhks}', "");
    Expect(0, 72813, '\P{^Is_Scx=bhks}', "");
    Expect(1, 72812, '\p{Is_Scx:   	_Bhks}', "");
    Expect(0, 72812, '\p{^Is_Scx:   	_Bhks}', "");
    Expect(0, 72812, '\P{Is_Scx:   	_Bhks}', "");
    Expect(1, 72812, '\P{^Is_Scx:   	_Bhks}', "");
    Expect(0, 72813, '\p{Is_Scx:   	_Bhks}', "");
    Expect(1, 72813, '\p{^Is_Scx:   	_Bhks}', "");
    Expect(1, 72813, '\P{Is_Scx:   	_Bhks}', "");
    Expect(0, 72813, '\P{^Is_Scx:   	_Bhks}', "");
    Error('\p{Script_Extensions=:=	bopomofo}');
    Error('\P{Script_Extensions=:=	bopomofo}');
    Expect(1, 65381, '\p{Script_Extensions=:\ABopomofo\z:}', "");;
    Expect(0, 65382, '\p{Script_Extensions=:\ABopomofo\z:}', "");;
    Expect(1, 65381, '\p{Script_Extensions=bopomofo}', "");
    Expect(0, 65381, '\p{^Script_Extensions=bopomofo}', "");
    Expect(0, 65381, '\P{Script_Extensions=bopomofo}', "");
    Expect(1, 65381, '\P{^Script_Extensions=bopomofo}', "");
    Expect(0, 65382, '\p{Script_Extensions=bopomofo}', "");
    Expect(1, 65382, '\p{^Script_Extensions=bopomofo}', "");
    Expect(1, 65382, '\P{Script_Extensions=bopomofo}', "");
    Expect(0, 65382, '\P{^Script_Extensions=bopomofo}', "");
    Expect(1, 65381, '\p{Script_Extensions=:\Abopomofo\z:}', "");;
    Expect(0, 65382, '\p{Script_Extensions=:\Abopomofo\z:}', "");;
    Expect(1, 65381, '\p{Script_Extensions=__bopomofo}', "");
    Expect(0, 65381, '\p{^Script_Extensions=__bopomofo}', "");
    Expect(0, 65381, '\P{Script_Extensions=__bopomofo}', "");
    Expect(1, 65381, '\P{^Script_Extensions=__bopomofo}', "");
    Expect(0, 65382, '\p{Script_Extensions=__bopomofo}', "");
    Expect(1, 65382, '\p{^Script_Extensions=__bopomofo}', "");
    Expect(1, 65382, '\P{Script_Extensions=__bopomofo}', "");
    Expect(0, 65382, '\P{^Script_Extensions=__bopomofo}', "");
    Error('\p{Scx=:=_bopo}');
    Error('\P{Scx=:=_bopo}');
    Expect(1, 65381, '\p{Scx=:\ABopo\z:}', "");;
    Expect(0, 65382, '\p{Scx=:\ABopo\z:}', "");;
    Expect(1, 65381, '\p{Scx=bopo}', "");
    Expect(0, 65381, '\p{^Scx=bopo}', "");
    Expect(0, 65381, '\P{Scx=bopo}', "");
    Expect(1, 65381, '\P{^Scx=bopo}', "");
    Expect(0, 65382, '\p{Scx=bopo}', "");
    Expect(1, 65382, '\p{^Scx=bopo}', "");
    Expect(1, 65382, '\P{Scx=bopo}', "");
    Expect(0, 65382, '\P{^Scx=bopo}', "");
    Expect(1, 65381, '\p{Scx=:\Abopo\z:}', "");;
    Expect(0, 65382, '\p{Scx=:\Abopo\z:}', "");;
    Expect(1, 65381, '\p{Scx=--Bopo}', "");
    Expect(0, 65381, '\p{^Scx=--Bopo}', "");
    Expect(0, 65381, '\P{Scx=--Bopo}', "");
    Expect(1, 65381, '\P{^Scx=--Bopo}', "");
    Expect(0, 65382, '\p{Scx=--Bopo}', "");
    Expect(1, 65382, '\p{^Scx=--Bopo}', "");
    Expect(1, 65382, '\P{Scx=--Bopo}', "");
    Expect(0, 65382, '\P{^Scx=--Bopo}', "");
    Error('\p{Is_Script_Extensions=:=_Bopomofo}');
    Error('\P{Is_Script_Extensions=:=_Bopomofo}');
    Expect(1, 65381, '\p{Is_Script_Extensions=bopomofo}', "");
    Expect(0, 65381, '\p{^Is_Script_Extensions=bopomofo}', "");
    Expect(0, 65381, '\P{Is_Script_Extensions=bopomofo}', "");
    Expect(1, 65381, '\P{^Is_Script_Extensions=bopomofo}', "");
    Expect(0, 65382, '\p{Is_Script_Extensions=bopomofo}', "");
    Expect(1, 65382, '\p{^Is_Script_Extensions=bopomofo}', "");
    Expect(1, 65382, '\P{Is_Script_Extensions=bopomofo}', "");
    Expect(0, 65382, '\P{^Is_Script_Extensions=bopomofo}', "");
    Expect(1, 65381, '\p{Is_Script_Extensions=	BOPOMOFO}', "");
    Expect(0, 65381, '\p{^Is_Script_Extensions=	BOPOMOFO}', "");
    Expect(0, 65381, '\P{Is_Script_Extensions=	BOPOMOFO}', "");
    Expect(1, 65381, '\P{^Is_Script_Extensions=	BOPOMOFO}', "");
    Expect(0, 65382, '\p{Is_Script_Extensions=	BOPOMOFO}', "");
    Expect(1, 65382, '\p{^Is_Script_Extensions=	BOPOMOFO}', "");
    Expect(1, 65382, '\P{Is_Script_Extensions=	BOPOMOFO}', "");
    Expect(0, 65382, '\P{^Is_Script_Extensions=	BOPOMOFO}', "");
    Error('\p{Is_Scx=-/a/BOPO}');
    Error('\P{Is_Scx=-/a/BOPO}');
    Expect(1, 65381, '\p{Is_Scx=bopo}', "");
    Expect(0, 65381, '\p{^Is_Scx=bopo}', "");
    Expect(0, 65381, '\P{Is_Scx=bopo}', "");
    Expect(1, 65381, '\P{^Is_Scx=bopo}', "");
    Expect(0, 65382, '\p{Is_Scx=bopo}', "");
    Expect(1, 65382, '\p{^Is_Scx=bopo}', "");
    Expect(1, 65382, '\P{Is_Scx=bopo}', "");
    Expect(0, 65382, '\P{^Is_Scx=bopo}', "");
    Expect(1, 65381, '\p{Is_Scx=	BOPO}', "");
    Expect(0, 65381, '\p{^Is_Scx=	BOPO}', "");
    Expect(0, 65381, '\P{Is_Scx=	BOPO}', "");
    Expect(1, 65381, '\P{^Is_Scx=	BOPO}', "");
    Expect(0, 65382, '\p{Is_Scx=	BOPO}', "");
    Expect(1, 65382, '\p{^Is_Scx=	BOPO}', "");
    Expect(1, 65382, '\P{Is_Scx=	BOPO}', "");
    Expect(0, 65382, '\P{^Is_Scx=	BOPO}', "");
    Error('\p{Script_Extensions=/a/Brahmi}');
    Error('\P{Script_Extensions=/a/Brahmi}');
    Expect(1, 69759, '\p{Script_Extensions=:\ABrahmi\z:}', "");;
    Expect(0, 69760, '\p{Script_Extensions=:\ABrahmi\z:}', "");;
    Expect(1, 69759, '\p{Script_Extensions=brahmi}', "");
    Expect(0, 69759, '\p{^Script_Extensions=brahmi}', "");
    Expect(0, 69759, '\P{Script_Extensions=brahmi}', "");
    Expect(1, 69759, '\P{^Script_Extensions=brahmi}', "");
    Expect(0, 69760, '\p{Script_Extensions=brahmi}', "");
    Expect(1, 69760, '\p{^Script_Extensions=brahmi}', "");
    Expect(1, 69760, '\P{Script_Extensions=brahmi}', "");
    Expect(0, 69760, '\P{^Script_Extensions=brahmi}', "");
    Expect(1, 69759, '\p{Script_Extensions=:\Abrahmi\z:}', "");;
    Expect(0, 69760, '\p{Script_Extensions=:\Abrahmi\z:}', "");;
    Expect(1, 69759, '\p{Script_Extensions=	_brahmi}', "");
    Expect(0, 69759, '\p{^Script_Extensions=	_brahmi}', "");
    Expect(0, 69759, '\P{Script_Extensions=	_brahmi}', "");
    Expect(1, 69759, '\P{^Script_Extensions=	_brahmi}', "");
    Expect(0, 69760, '\p{Script_Extensions=	_brahmi}', "");
    Expect(1, 69760, '\p{^Script_Extensions=	_brahmi}', "");
    Expect(1, 69760, '\P{Script_Extensions=	_brahmi}', "");
    Expect(0, 69760, '\P{^Script_Extensions=	_brahmi}', "");
    Error('\p{Scx=:=	-Brah}');
    Error('\P{Scx=:=	-Brah}');
    Expect(1, 69759, '\p{Scx=:\ABrah\z:}', "");;
    Expect(0, 69760, '\p{Scx=:\ABrah\z:}', "");;
    Expect(1, 69759, '\p{Scx=brah}', "");
    Expect(0, 69759, '\p{^Scx=brah}', "");
    Expect(0, 69759, '\P{Scx=brah}', "");
    Expect(1, 69759, '\P{^Scx=brah}', "");
    Expect(0, 69760, '\p{Scx=brah}', "");
    Expect(1, 69760, '\p{^Scx=brah}', "");
    Expect(1, 69760, '\P{Scx=brah}', "");
    Expect(0, 69760, '\P{^Scx=brah}', "");
    Expect(1, 69759, '\p{Scx=:\Abrah\z:}', "");;
    Expect(0, 69760, '\p{Scx=:\Abrah\z:}', "");;
    Expect(1, 69759, '\p{Scx=		Brah}', "");
    Expect(0, 69759, '\p{^Scx=		Brah}', "");
    Expect(0, 69759, '\P{Scx=		Brah}', "");
    Expect(1, 69759, '\P{^Scx=		Brah}', "");
    Expect(0, 69760, '\p{Scx=		Brah}', "");
    Expect(1, 69760, '\p{^Scx=		Brah}', "");
    Expect(1, 69760, '\P{Scx=		Brah}', "");
    Expect(0, 69760, '\P{^Scx=		Brah}', "");
    Error('\p{Is_Script_Extensions=:=-	BRAHMI}');
    Error('\P{Is_Script_Extensions=:=-	BRAHMI}');
    Expect(1, 69759, '\p{Is_Script_Extensions=brahmi}', "");
    Expect(0, 69759, '\p{^Is_Script_Extensions=brahmi}', "");
    Expect(0, 69759, '\P{Is_Script_Extensions=brahmi}', "");
    Expect(1, 69759, '\P{^Is_Script_Extensions=brahmi}', "");
    Expect(0, 69760, '\p{Is_Script_Extensions=brahmi}', "");
    Expect(1, 69760, '\p{^Is_Script_Extensions=brahmi}', "");
    Expect(1, 69760, '\P{Is_Script_Extensions=brahmi}', "");
    Expect(0, 69760, '\P{^Is_Script_Extensions=brahmi}', "");
    Expect(1, 69759, '\p{Is_Script_Extensions= Brahmi}', "");
    Expect(0, 69759, '\p{^Is_Script_Extensions= Brahmi}', "");
    Expect(0, 69759, '\P{Is_Script_Extensions= Brahmi}', "");
    Expect(1, 69759, '\P{^Is_Script_Extensions= Brahmi}', "");
    Expect(0, 69760, '\p{Is_Script_Extensions= Brahmi}', "");
    Expect(1, 69760, '\p{^Is_Script_Extensions= Brahmi}', "");
    Expect(1, 69760, '\P{Is_Script_Extensions= Brahmi}', "");
    Expect(0, 69760, '\P{^Is_Script_Extensions= Brahmi}', "");
    Error('\p{Is_Scx=:=Brah}');
    Error('\P{Is_Scx=:=Brah}');
    Expect(1, 69759, '\p{Is_Scx=brah}', "");
    Expect(0, 69759, '\p{^Is_Scx=brah}', "");
    Expect(0, 69759, '\P{Is_Scx=brah}', "");
    Expect(1, 69759, '\P{^Is_Scx=brah}', "");
    Expect(0, 69760, '\p{Is_Scx=brah}', "");
    Expect(1, 69760, '\p{^Is_Scx=brah}', "");
    Expect(1, 69760, '\P{Is_Scx=brah}', "");
    Expect(0, 69760, '\P{^Is_Scx=brah}', "");
    Expect(1, 69759, '\p{Is_Scx:    _Brah}', "");
    Expect(0, 69759, '\p{^Is_Scx:    _Brah}', "");
    Expect(0, 69759, '\P{Is_Scx:    _Brah}', "");
    Expect(1, 69759, '\P{^Is_Scx:    _Brah}', "");
    Expect(0, 69760, '\p{Is_Scx:    _Brah}', "");
    Expect(1, 69760, '\p{^Is_Scx:    _Brah}', "");
    Expect(1, 69760, '\P{Is_Scx:    _Brah}', "");
    Expect(0, 69760, '\P{^Is_Scx:    _Brah}', "");
    Error('\p{Script_Extensions=--Braille:=}');
    Error('\P{Script_Extensions=--Braille:=}');
    Expect(1, 10495, '\p{Script_Extensions=:\ABraille\z:}', "");;
    Expect(0, 10496, '\p{Script_Extensions=:\ABraille\z:}', "");;
    Expect(1, 10495, '\p{Script_Extensions=braille}', "");
    Expect(0, 10495, '\p{^Script_Extensions=braille}', "");
    Expect(0, 10495, '\P{Script_Extensions=braille}', "");
    Expect(1, 10495, '\P{^Script_Extensions=braille}', "");
    Expect(0, 10496, '\p{Script_Extensions=braille}', "");
    Expect(1, 10496, '\p{^Script_Extensions=braille}', "");
    Expect(1, 10496, '\P{Script_Extensions=braille}', "");
    Expect(0, 10496, '\P{^Script_Extensions=braille}', "");
    Expect(1, 10495, '\p{Script_Extensions=:\Abraille\z:}', "");;
    Expect(0, 10496, '\p{Script_Extensions=:\Abraille\z:}', "");;
    Expect(1, 10495, '\p{Script_Extensions= Braille}', "");
    Expect(0, 10495, '\p{^Script_Extensions= Braille}', "");
    Expect(0, 10495, '\P{Script_Extensions= Braille}', "");
    Expect(1, 10495, '\P{^Script_Extensions= Braille}', "");
    Expect(0, 10496, '\p{Script_Extensions= Braille}', "");
    Expect(1, 10496, '\p{^Script_Extensions= Braille}', "");
    Expect(1, 10496, '\P{Script_Extensions= Braille}', "");
    Expect(0, 10496, '\P{^Script_Extensions= Braille}', "");
    Error('\p{Scx= /a/brai}');
    Error('\P{Scx= /a/brai}');
    Expect(1, 10495, '\p{Scx=:\ABrai\z:}', "");;
    Expect(0, 10496, '\p{Scx=:\ABrai\z:}', "");;
    Expect(1, 10495, '\p{Scx=brai}', "");
    Expect(0, 10495, '\p{^Scx=brai}', "");
    Expect(0, 10495, '\P{Scx=brai}', "");
    Expect(1, 10495, '\P{^Scx=brai}', "");
    Expect(0, 10496, '\p{Scx=brai}', "");
    Expect(1, 10496, '\p{^Scx=brai}', "");
    Expect(1, 10496, '\P{Scx=brai}', "");
    Expect(0, 10496, '\P{^Scx=brai}', "");
    Expect(1, 10495, '\p{Scx=:\Abrai\z:}', "");;
    Expect(0, 10496, '\p{Scx=:\Abrai\z:}', "");;
    Expect(1, 10495, '\p{Scx:   -_Brai}', "");
    Expect(0, 10495, '\p{^Scx:   -_Brai}', "");
    Expect(0, 10495, '\P{Scx:   -_Brai}', "");
    Expect(1, 10495, '\P{^Scx:   -_Brai}', "");
    Expect(0, 10496, '\p{Scx:   -_Brai}', "");
    Expect(1, 10496, '\p{^Scx:   -_Brai}', "");
    Expect(1, 10496, '\P{Scx:   -_Brai}', "");
    Expect(0, 10496, '\P{^Scx:   -_Brai}', "");
    Error('\p{Is_Script_Extensions=-:=BRAILLE}');
    Error('\P{Is_Script_Extensions=-:=BRAILLE}');
    Expect(1, 10495, '\p{Is_Script_Extensions=braille}', "");
    Expect(0, 10495, '\p{^Is_Script_Extensions=braille}', "");
    Expect(0, 10495, '\P{Is_Script_Extensions=braille}', "");
    Expect(1, 10495, '\P{^Is_Script_Extensions=braille}', "");
    Expect(0, 10496, '\p{Is_Script_Extensions=braille}', "");
    Expect(1, 10496, '\p{^Is_Script_Extensions=braille}', "");
    Expect(1, 10496, '\P{Is_Script_Extensions=braille}', "");
    Expect(0, 10496, '\P{^Is_Script_Extensions=braille}', "");
    Expect(1, 10495, '\p{Is_Script_Extensions=__BRAILLE}', "");
    Expect(0, 10495, '\p{^Is_Script_Extensions=__BRAILLE}', "");
    Expect(0, 10495, '\P{Is_Script_Extensions=__BRAILLE}', "");
    Expect(1, 10495, '\P{^Is_Script_Extensions=__BRAILLE}', "");
    Expect(0, 10496, '\p{Is_Script_Extensions=__BRAILLE}', "");
    Expect(1, 10496, '\p{^Is_Script_Extensions=__BRAILLE}', "");
    Expect(1, 10496, '\P{Is_Script_Extensions=__BRAILLE}', "");
    Expect(0, 10496, '\P{^Is_Script_Extensions=__BRAILLE}', "");
    Error('\p{Is_Scx= _BRAI/a/}');
    Error('\P{Is_Scx= _BRAI/a/}');
    Expect(1, 10495, '\p{Is_Scx=brai}', "");
    Expect(0, 10495, '\p{^Is_Scx=brai}', "");
    Expect(0, 10495, '\P{Is_Scx=brai}', "");
    Expect(1, 10495, '\P{^Is_Scx=brai}', "");
    Expect(0, 10496, '\p{Is_Scx=brai}', "");
    Expect(1, 10496, '\p{^Is_Scx=brai}', "");
    Expect(1, 10496, '\P{Is_Scx=brai}', "");
    Expect(0, 10496, '\P{^Is_Scx=brai}', "");
    Expect(1, 10495, '\p{Is_Scx=_Brai}', "");
    Expect(0, 10495, '\p{^Is_Scx=_Brai}', "");
    Expect(0, 10495, '\P{Is_Scx=_Brai}', "");
    Expect(1, 10495, '\P{^Is_Scx=_Brai}', "");
    Expect(0, 10496, '\p{Is_Scx=_Brai}', "");
    Expect(1, 10496, '\p{^Is_Scx=_Brai}', "");
    Expect(1, 10496, '\P{Is_Scx=_Brai}', "");
    Expect(0, 10496, '\P{^Is_Scx=_Brai}', "");
    Error('\p{Script_Extensions=/a/-_Buginese}');
    Error('\P{Script_Extensions=/a/-_Buginese}');
    Expect(1, 43471, '\p{Script_Extensions=:\ABuginese\z:}', "");;
    Expect(0, 43472, '\p{Script_Extensions=:\ABuginese\z:}', "");;
    Expect(1, 43471, '\p{Script_Extensions=buginese}', "");
    Expect(0, 43471, '\p{^Script_Extensions=buginese}', "");
    Expect(0, 43471, '\P{Script_Extensions=buginese}', "");
    Expect(1, 43471, '\P{^Script_Extensions=buginese}', "");
    Expect(0, 43472, '\p{Script_Extensions=buginese}', "");
    Expect(1, 43472, '\p{^Script_Extensions=buginese}', "");
    Expect(1, 43472, '\P{Script_Extensions=buginese}', "");
    Expect(0, 43472, '\P{^Script_Extensions=buginese}', "");
    Expect(1, 43471, '\p{Script_Extensions=:\Abuginese\z:}', "");;
    Expect(0, 43472, '\p{Script_Extensions=:\Abuginese\z:}', "");;
    Expect(1, 43471, '\p{Script_Extensions=	buginese}', "");
    Expect(0, 43471, '\p{^Script_Extensions=	buginese}', "");
    Expect(0, 43471, '\P{Script_Extensions=	buginese}', "");
    Expect(1, 43471, '\P{^Script_Extensions=	buginese}', "");
    Expect(0, 43472, '\p{Script_Extensions=	buginese}', "");
    Expect(1, 43472, '\p{^Script_Extensions=	buginese}', "");
    Expect(1, 43472, '\P{Script_Extensions=	buginese}', "");
    Expect(0, 43472, '\P{^Script_Extensions=	buginese}', "");
    Error('\p{Scx=:= bugi}');
    Error('\P{Scx=:= bugi}');
    Expect(1, 43471, '\p{Scx=:\ABugi\z:}', "");;
    Expect(0, 43472, '\p{Scx=:\ABugi\z:}', "");;
    Expect(1, 43471, '\p{Scx=bugi}', "");
    Expect(0, 43471, '\p{^Scx=bugi}', "");
    Expect(0, 43471, '\P{Scx=bugi}', "");
    Expect(1, 43471, '\P{^Scx=bugi}', "");
    Expect(0, 43472, '\p{Scx=bugi}', "");
    Expect(1, 43472, '\p{^Scx=bugi}', "");
    Expect(1, 43472, '\P{Scx=bugi}', "");
    Expect(0, 43472, '\P{^Scx=bugi}', "");
    Expect(1, 43471, '\p{Scx=:\Abugi\z:}', "");;
    Expect(0, 43472, '\p{Scx=:\Abugi\z:}', "");;
    Expect(1, 43471, '\p{Scx=	 BUGI}', "");
    Expect(0, 43471, '\p{^Scx=	 BUGI}', "");
    Expect(0, 43471, '\P{Scx=	 BUGI}', "");
    Expect(1, 43471, '\P{^Scx=	 BUGI}', "");
    Expect(0, 43472, '\p{Scx=	 BUGI}', "");
    Expect(1, 43472, '\p{^Scx=	 BUGI}', "");
    Expect(1, 43472, '\P{Scx=	 BUGI}', "");
    Expect(0, 43472, '\P{^Scx=	 BUGI}', "");
    Error('\p{Is_Script_Extensions=_/a/buginese}');
    Error('\P{Is_Script_Extensions=_/a/buginese}');
    Expect(1, 43471, '\p{Is_Script_Extensions=buginese}', "");
    Expect(0, 43471, '\p{^Is_Script_Extensions=buginese}', "");
    Expect(0, 43471, '\P{Is_Script_Extensions=buginese}', "");
    Expect(1, 43471, '\P{^Is_Script_Extensions=buginese}', "");
    Expect(0, 43472, '\p{Is_Script_Extensions=buginese}', "");
    Expect(1, 43472, '\p{^Is_Script_Extensions=buginese}', "");
    Expect(1, 43472, '\P{Is_Script_Extensions=buginese}', "");
    Expect(0, 43472, '\P{^Is_Script_Extensions=buginese}', "");
    Expect(1, 43471, '\p{Is_Script_Extensions= Buginese}', "");
    Expect(0, 43471, '\p{^Is_Script_Extensions= Buginese}', "");
    Expect(0, 43471, '\P{Is_Script_Extensions= Buginese}', "");
    Expect(1, 43471, '\P{^Is_Script_Extensions= Buginese}', "");
    Expect(0, 43472, '\p{Is_Script_Extensions= Buginese}', "");
    Expect(1, 43472, '\p{^Is_Script_Extensions= Buginese}', "");
    Expect(1, 43472, '\P{Is_Script_Extensions= Buginese}', "");
    Expect(0, 43472, '\P{^Is_Script_Extensions= Buginese}', "");
    Error('\p{Is_Scx=:=-Bugi}');
    Error('\P{Is_Scx=:=-Bugi}');
    Expect(1, 43471, '\p{Is_Scx=bugi}', "");
    Expect(0, 43471, '\p{^Is_Scx=bugi}', "");
    Expect(0, 43471, '\P{Is_Scx=bugi}', "");
    Expect(1, 43471, '\P{^Is_Scx=bugi}', "");
    Expect(0, 43472, '\p{Is_Scx=bugi}', "");
    Expect(1, 43472, '\p{^Is_Scx=bugi}', "");
    Expect(1, 43472, '\P{Is_Scx=bugi}', "");
    Expect(0, 43472, '\P{^Is_Scx=bugi}', "");
    Expect(1, 43471, '\p{Is_Scx=__BUGI}', "");
    Expect(0, 43471, '\p{^Is_Scx=__BUGI}', "");
    Expect(0, 43471, '\P{Is_Scx=__BUGI}', "");
    Expect(1, 43471, '\P{^Is_Scx=__BUGI}', "");
    Expect(0, 43472, '\p{Is_Scx=__BUGI}', "");
    Expect(1, 43472, '\p{^Is_Scx=__BUGI}', "");
    Expect(1, 43472, '\P{Is_Scx=__BUGI}', "");
    Expect(0, 43472, '\P{^Is_Scx=__BUGI}', "");
    Error('\p{Script_Extensions: /a/buhid}');
    Error('\P{Script_Extensions: /a/buhid}');
    Expect(1, 5971, '\p{Script_Extensions=:\ABuhid\z:}', "");;
    Expect(0, 5972, '\p{Script_Extensions=:\ABuhid\z:}', "");;
    Expect(1, 5971, '\p{Script_Extensions:buhid}', "");
    Expect(0, 5971, '\p{^Script_Extensions:buhid}', "");
    Expect(0, 5971, '\P{Script_Extensions:buhid}', "");
    Expect(1, 5971, '\P{^Script_Extensions:buhid}', "");
    Expect(0, 5972, '\p{Script_Extensions:buhid}', "");
    Expect(1, 5972, '\p{^Script_Extensions:buhid}', "");
    Expect(1, 5972, '\P{Script_Extensions:buhid}', "");
    Expect(0, 5972, '\P{^Script_Extensions:buhid}', "");
    Expect(1, 5971, '\p{Script_Extensions=:\Abuhid\z:}', "");;
    Expect(0, 5972, '\p{Script_Extensions=:\Abuhid\z:}', "");;
    Expect(1, 5971, '\p{Script_Extensions: 	-Buhid}', "");
    Expect(0, 5971, '\p{^Script_Extensions: 	-Buhid}', "");
    Expect(0, 5971, '\P{Script_Extensions: 	-Buhid}', "");
    Expect(1, 5971, '\P{^Script_Extensions: 	-Buhid}', "");
    Expect(0, 5972, '\p{Script_Extensions: 	-Buhid}', "");
    Expect(1, 5972, '\p{^Script_Extensions: 	-Buhid}', "");
    Expect(1, 5972, '\P{Script_Extensions: 	-Buhid}', "");
    Expect(0, 5972, '\P{^Script_Extensions: 	-Buhid}', "");
    Error('\p{Scx: /a/BUHD}');
    Error('\P{Scx: /a/BUHD}');
    Expect(1, 5971, '\p{Scx=:\ABuhd\z:}', "");;
    Expect(0, 5972, '\p{Scx=:\ABuhd\z:}', "");;
    Expect(1, 5971, '\p{Scx:buhd}', "");
    Expect(0, 5971, '\p{^Scx:buhd}', "");
    Expect(0, 5971, '\P{Scx:buhd}', "");
    Expect(1, 5971, '\P{^Scx:buhd}', "");
    Expect(0, 5972, '\p{Scx:buhd}', "");
    Expect(1, 5972, '\p{^Scx:buhd}', "");
    Expect(1, 5972, '\P{Scx:buhd}', "");
    Expect(0, 5972, '\P{^Scx:buhd}', "");
    Expect(1, 5971, '\p{Scx=:\Abuhd\z:}', "");;
    Expect(0, 5972, '\p{Scx=:\Abuhd\z:}', "");;
    Expect(1, 5971, '\p{Scx: _ Buhd}', "");
    Expect(0, 5971, '\p{^Scx: _ Buhd}', "");
    Expect(0, 5971, '\P{Scx: _ Buhd}', "");
    Expect(1, 5971, '\P{^Scx: _ Buhd}', "");
    Expect(0, 5972, '\p{Scx: _ Buhd}', "");
    Expect(1, 5972, '\p{^Scx: _ Buhd}', "");
    Expect(1, 5972, '\P{Scx: _ Buhd}', "");
    Expect(0, 5972, '\P{^Scx: _ Buhd}', "");
    Error('\p{Is_Script_Extensions:    	BUHID:=}');
    Error('\P{Is_Script_Extensions:    	BUHID:=}');
    Expect(1, 5971, '\p{Is_Script_Extensions=buhid}', "");
    Expect(0, 5971, '\p{^Is_Script_Extensions=buhid}', "");
    Expect(0, 5971, '\P{Is_Script_Extensions=buhid}', "");
    Expect(1, 5971, '\P{^Is_Script_Extensions=buhid}', "");
    Expect(0, 5972, '\p{Is_Script_Extensions=buhid}', "");
    Expect(1, 5972, '\p{^Is_Script_Extensions=buhid}', "");
    Expect(1, 5972, '\P{Is_Script_Extensions=buhid}', "");
    Expect(0, 5972, '\P{^Is_Script_Extensions=buhid}', "");
    Expect(1, 5971, '\p{Is_Script_Extensions=	Buhid}', "");
    Expect(0, 5971, '\p{^Is_Script_Extensions=	Buhid}', "");
    Expect(0, 5971, '\P{Is_Script_Extensions=	Buhid}', "");
    Expect(1, 5971, '\P{^Is_Script_Extensions=	Buhid}', "");
    Expect(0, 5972, '\p{Is_Script_Extensions=	Buhid}', "");
    Expect(1, 5972, '\p{^Is_Script_Extensions=	Buhid}', "");
    Expect(1, 5972, '\P{Is_Script_Extensions=	Buhid}', "");
    Expect(0, 5972, '\P{^Is_Script_Extensions=	Buhid}', "");
    Error('\p{Is_Scx=_Buhd/a/}');
    Error('\P{Is_Scx=_Buhd/a/}');
    Expect(1, 5971, '\p{Is_Scx=buhd}', "");
    Expect(0, 5971, '\p{^Is_Scx=buhd}', "");
    Expect(0, 5971, '\P{Is_Scx=buhd}', "");
    Expect(1, 5971, '\P{^Is_Scx=buhd}', "");
    Expect(0, 5972, '\p{Is_Scx=buhd}', "");
    Expect(1, 5972, '\p{^Is_Scx=buhd}', "");
    Expect(1, 5972, '\P{Is_Scx=buhd}', "");
    Expect(0, 5972, '\P{^Is_Scx=buhd}', "");
    Expect(1, 5971, '\p{Is_Scx:	- BUHD}', "");
    Expect(0, 5971, '\p{^Is_Scx:	- BUHD}', "");
    Expect(0, 5971, '\P{Is_Scx:	- BUHD}', "");
    Expect(1, 5971, '\P{^Is_Scx:	- BUHD}', "");
    Expect(0, 5972, '\p{Is_Scx:	- BUHD}', "");
    Expect(1, 5972, '\p{^Is_Scx:	- BUHD}', "");
    Expect(1, 5972, '\P{Is_Scx:	- BUHD}', "");
    Expect(0, 5972, '\P{^Is_Scx:	- BUHD}', "");
    Error('\p{Script_Extensions:   -/a/CHAKMA}');
    Error('\P{Script_Extensions:   -/a/CHAKMA}');
    Expect(1, 69958, '\p{Script_Extensions=:\AChakma\z:}', "");;
    Expect(0, 69959, '\p{Script_Extensions=:\AChakma\z:}', "");;
    Expect(1, 69958, '\p{Script_Extensions=chakma}', "");
    Expect(0, 69958, '\p{^Script_Extensions=chakma}', "");
    Expect(0, 69958, '\P{Script_Extensions=chakma}', "");
    Expect(1, 69958, '\P{^Script_Extensions=chakma}', "");
    Expect(0, 69959, '\p{Script_Extensions=chakma}', "");
    Expect(1, 69959, '\p{^Script_Extensions=chakma}', "");
    Expect(1, 69959, '\P{Script_Extensions=chakma}', "");
    Expect(0, 69959, '\P{^Script_Extensions=chakma}', "");
    Expect(1, 69958, '\p{Script_Extensions=:\Achakma\z:}', "");;
    Expect(0, 69959, '\p{Script_Extensions=:\Achakma\z:}', "");;
    Expect(1, 69958, '\p{Script_Extensions:   -Chakma}', "");
    Expect(0, 69958, '\p{^Script_Extensions:   -Chakma}', "");
    Expect(0, 69958, '\P{Script_Extensions:   -Chakma}', "");
    Expect(1, 69958, '\P{^Script_Extensions:   -Chakma}', "");
    Expect(0, 69959, '\p{Script_Extensions:   -Chakma}', "");
    Expect(1, 69959, '\p{^Script_Extensions:   -Chakma}', "");
    Expect(1, 69959, '\P{Script_Extensions:   -Chakma}', "");
    Expect(0, 69959, '\P{^Script_Extensions:   -Chakma}', "");
    Error('\p{Scx=-CAKM:=}');
    Error('\P{Scx=-CAKM:=}');
    Expect(1, 69958, '\p{Scx=:\ACakm\z:}', "");;
    Expect(0, 69959, '\p{Scx=:\ACakm\z:}', "");;
    Expect(1, 69958, '\p{Scx=cakm}', "");
    Expect(0, 69958, '\p{^Scx=cakm}', "");
    Expect(0, 69958, '\P{Scx=cakm}', "");
    Expect(1, 69958, '\P{^Scx=cakm}', "");
    Expect(0, 69959, '\p{Scx=cakm}', "");
    Expect(1, 69959, '\p{^Scx=cakm}', "");
    Expect(1, 69959, '\P{Scx=cakm}', "");
    Expect(0, 69959, '\P{^Scx=cakm}', "");
    Expect(1, 69958, '\p{Scx=:\Acakm\z:}', "");;
    Expect(0, 69959, '\p{Scx=:\Acakm\z:}', "");;
    Error('\p{Is_Script_Extensions=CHAKMA:=}');
    Error('\P{Is_Script_Extensions=CHAKMA:=}');
    Expect(1, 69958, '\p{Is_Script_Extensions=chakma}', "");
    Expect(0, 69958, '\p{^Is_Script_Extensions=chakma}', "");
    Expect(0, 69958, '\P{Is_Script_Extensions=chakma}', "");
    Expect(1, 69958, '\P{^Is_Script_Extensions=chakma}', "");
    Expect(0, 69959, '\p{Is_Script_Extensions=chakma}', "");
    Expect(1, 69959, '\p{^Is_Script_Extensions=chakma}', "");
    Expect(1, 69959, '\P{Is_Script_Extensions=chakma}', "");
    Expect(0, 69959, '\P{^Is_Script_Extensions=chakma}', "");
    Expect(1, 69958, '\p{Is_Script_Extensions=	_CHAKMA}', "");
    Expect(0, 69958, '\p{^Is_Script_Extensions=	_CHAKMA}', "");
    Expect(0, 69958, '\P{Is_Script_Extensions=	_CHAKMA}', "");
    Expect(1, 69958, '\P{^Is_Script_Extensions=	_CHAKMA}', "");
    Expect(0, 69959, '\p{Is_Script_Extensions=	_CHAKMA}', "");
    Expect(1, 69959, '\p{^Is_Script_Extensions=	_CHAKMA}', "");
    Expect(1, 69959, '\P{Is_Script_Extensions=	_CHAKMA}', "");
    Expect(0, 69959, '\P{^Is_Script_Extensions=	_CHAKMA}', "");
    Error('\p{Is_Scx=_cakm:=}');
    Error('\P{Is_Scx=_cakm:=}');
    Expect(1, 69958, '\p{Is_Scx=cakm}', "");
    Expect(0, 69958, '\p{^Is_Scx=cakm}', "");
    Expect(0, 69958, '\P{Is_Scx=cakm}', "");
    Expect(1, 69958, '\P{^Is_Scx=cakm}', "");
    Expect(0, 69959, '\p{Is_Scx=cakm}', "");
    Expect(1, 69959, '\p{^Is_Scx=cakm}', "");
    Expect(1, 69959, '\P{Is_Scx=cakm}', "");
    Expect(0, 69959, '\P{^Is_Scx=cakm}', "");
    Expect(1, 69958, '\p{Is_Scx= _Cakm}', "");
    Expect(0, 69958, '\p{^Is_Scx= _Cakm}', "");
    Expect(0, 69958, '\P{Is_Scx= _Cakm}', "");
    Expect(1, 69958, '\P{^Is_Scx= _Cakm}', "");
    Expect(0, 69959, '\p{Is_Scx= _Cakm}', "");
    Expect(1, 69959, '\p{^Is_Scx= _Cakm}', "");
    Expect(1, 69959, '\P{Is_Scx= _Cakm}', "");
    Expect(0, 69959, '\P{^Is_Scx= _Cakm}', "");
    Error('\p{Script_Extensions=-:=Canadian_Aboriginal}');
    Error('\P{Script_Extensions=-:=Canadian_Aboriginal}');
    Expect(1, 6389, '\p{Script_Extensions=:\ACanadian_Aboriginal\z:}', "");;
    Expect(0, 6390, '\p{Script_Extensions=:\ACanadian_Aboriginal\z:}', "");;
    Expect(1, 6389, '\p{Script_Extensions=canadianaboriginal}', "");
    Expect(0, 6389, '\p{^Script_Extensions=canadianaboriginal}', "");
    Expect(0, 6389, '\P{Script_Extensions=canadianaboriginal}', "");
    Expect(1, 6389, '\P{^Script_Extensions=canadianaboriginal}', "");
    Expect(0, 6390, '\p{Script_Extensions=canadianaboriginal}', "");
    Expect(1, 6390, '\p{^Script_Extensions=canadianaboriginal}', "");
    Expect(1, 6390, '\P{Script_Extensions=canadianaboriginal}', "");
    Expect(0, 6390, '\P{^Script_Extensions=canadianaboriginal}', "");
    Expect(1, 6389, '\p{Script_Extensions=:\Acanadianaboriginal\z:}', "");;
    Expect(0, 6390, '\p{Script_Extensions=:\Acanadianaboriginal\z:}', "");;
    Expect(1, 6389, '\p{Script_Extensions=_	CANADIAN_Aboriginal}', "");
    Expect(0, 6389, '\p{^Script_Extensions=_	CANADIAN_Aboriginal}', "");
    Expect(0, 6389, '\P{Script_Extensions=_	CANADIAN_Aboriginal}', "");
    Expect(1, 6389, '\P{^Script_Extensions=_	CANADIAN_Aboriginal}', "");
    Expect(0, 6390, '\p{Script_Extensions=_	CANADIAN_Aboriginal}', "");
    Expect(1, 6390, '\p{^Script_Extensions=_	CANADIAN_Aboriginal}', "");
    Expect(1, 6390, '\P{Script_Extensions=_	CANADIAN_Aboriginal}', "");
    Expect(0, 6390, '\P{^Script_Extensions=_	CANADIAN_Aboriginal}', "");
    Error('\p{Scx=/a/_ cans}');
    Error('\P{Scx=/a/_ cans}');
    Expect(1, 6389, '\p{Scx=:\ACans\z:}', "");;
    Expect(0, 6390, '\p{Scx=:\ACans\z:}', "");;
    Expect(1, 6389, '\p{Scx=cans}', "");
    Expect(0, 6389, '\p{^Scx=cans}', "");
    Expect(0, 6389, '\P{Scx=cans}', "");
    Expect(1, 6389, '\P{^Scx=cans}', "");
    Expect(0, 6390, '\p{Scx=cans}', "");
    Expect(1, 6390, '\p{^Scx=cans}', "");
    Expect(1, 6390, '\P{Scx=cans}', "");
    Expect(0, 6390, '\P{^Scx=cans}', "");
    Expect(1, 6389, '\p{Scx=:\Acans\z:}', "");;
    Expect(0, 6390, '\p{Scx=:\Acans\z:}', "");;
    Expect(1, 6389, '\p{Scx:	_-Cans}', "");
    Expect(0, 6389, '\p{^Scx:	_-Cans}', "");
    Expect(0, 6389, '\P{Scx:	_-Cans}', "");
    Expect(1, 6389, '\P{^Scx:	_-Cans}', "");
    Expect(0, 6390, '\p{Scx:	_-Cans}', "");
    Expect(1, 6390, '\p{^Scx:	_-Cans}', "");
    Expect(1, 6390, '\P{Scx:	_-Cans}', "");
    Expect(0, 6390, '\P{^Scx:	_-Cans}', "");
    Error('\p{Is_Script_Extensions= 	Canadian_aboriginal/a/}');
    Error('\P{Is_Script_Extensions= 	Canadian_aboriginal/a/}');
    Expect(1, 6389, '\p{Is_Script_Extensions=canadianaboriginal}', "");
    Expect(0, 6389, '\p{^Is_Script_Extensions=canadianaboriginal}', "");
    Expect(0, 6389, '\P{Is_Script_Extensions=canadianaboriginal}', "");
    Expect(1, 6389, '\P{^Is_Script_Extensions=canadianaboriginal}', "");
    Expect(0, 6390, '\p{Is_Script_Extensions=canadianaboriginal}', "");
    Expect(1, 6390, '\p{^Is_Script_Extensions=canadianaboriginal}', "");
    Expect(1, 6390, '\P{Is_Script_Extensions=canadianaboriginal}', "");
    Expect(0, 6390, '\P{^Is_Script_Extensions=canadianaboriginal}', "");
    Expect(1, 6389, '\p{Is_Script_Extensions= Canadian_aboriginal}', "");
    Expect(0, 6389, '\p{^Is_Script_Extensions= Canadian_aboriginal}', "");
    Expect(0, 6389, '\P{Is_Script_Extensions= Canadian_aboriginal}', "");
    Expect(1, 6389, '\P{^Is_Script_Extensions= Canadian_aboriginal}', "");
    Expect(0, 6390, '\p{Is_Script_Extensions= Canadian_aboriginal}', "");
    Expect(1, 6390, '\p{^Is_Script_Extensions= Canadian_aboriginal}', "");
    Expect(1, 6390, '\P{Is_Script_Extensions= Canadian_aboriginal}', "");
    Expect(0, 6390, '\P{^Is_Script_Extensions= Canadian_aboriginal}', "");
    Error('\p{Is_Scx=:=	-Cans}');
    Error('\P{Is_Scx=:=	-Cans}');
    Expect(1, 6389, '\p{Is_Scx=cans}', "");
    Expect(0, 6389, '\p{^Is_Scx=cans}', "");
    Expect(0, 6389, '\P{Is_Scx=cans}', "");
    Expect(1, 6389, '\P{^Is_Scx=cans}', "");
    Expect(0, 6390, '\p{Is_Scx=cans}', "");
    Expect(1, 6390, '\p{^Is_Scx=cans}', "");
    Expect(1, 6390, '\P{Is_Scx=cans}', "");
    Expect(0, 6390, '\P{^Is_Scx=cans}', "");
    Expect(1, 6389, '\p{Is_Scx=	 Cans}', "");
    Expect(0, 6389, '\p{^Is_Scx=	 Cans}', "");
    Expect(0, 6389, '\P{Is_Scx=	 Cans}', "");
    Expect(1, 6389, '\P{^Is_Scx=	 Cans}', "");
    Expect(0, 6390, '\p{Is_Scx=	 Cans}', "");
    Expect(1, 6390, '\p{^Is_Scx=	 Cans}', "");
    Expect(1, 6390, '\P{Is_Scx=	 Cans}', "");
    Expect(0, 6390, '\P{^Is_Scx=	 Cans}', "");
    Error('\p{Script_Extensions=	_Carian:=}');
    Error('\P{Script_Extensions=	_Carian:=}');
    Expect(1, 66256, '\p{Script_Extensions=:\ACarian\z:}', "");;
    Expect(0, 66257, '\p{Script_Extensions=:\ACarian\z:}', "");;
    Expect(1, 66256, '\p{Script_Extensions:   carian}', "");
    Expect(0, 66256, '\p{^Script_Extensions:   carian}', "");
    Expect(0, 66256, '\P{Script_Extensions:   carian}', "");
    Expect(1, 66256, '\P{^Script_Extensions:   carian}', "");
    Expect(0, 66257, '\p{Script_Extensions:   carian}', "");
    Expect(1, 66257, '\p{^Script_Extensions:   carian}', "");
    Expect(1, 66257, '\P{Script_Extensions:   carian}', "");
    Expect(0, 66257, '\P{^Script_Extensions:   carian}', "");
    Expect(1, 66256, '\p{Script_Extensions=:\Acarian\z:}', "");;
    Expect(0, 66257, '\p{Script_Extensions=:\Acarian\z:}', "");;
    Expect(1, 66256, '\p{Script_Extensions=_Carian}', "");
    Expect(0, 66256, '\p{^Script_Extensions=_Carian}', "");
    Expect(0, 66256, '\P{Script_Extensions=_Carian}', "");
    Expect(1, 66256, '\P{^Script_Extensions=_Carian}', "");
    Expect(0, 66257, '\p{Script_Extensions=_Carian}', "");
    Expect(1, 66257, '\p{^Script_Extensions=_Carian}', "");
    Expect(1, 66257, '\P{Script_Extensions=_Carian}', "");
    Expect(0, 66257, '\P{^Script_Extensions=_Carian}', "");
    Error('\p{Scx= Cari:=}');
    Error('\P{Scx= Cari:=}');
    Expect(1, 66256, '\p{Scx=:\ACari\z:}', "");;
    Expect(0, 66257, '\p{Scx=:\ACari\z:}', "");;
    Expect(1, 66256, '\p{Scx=cari}', "");
    Expect(0, 66256, '\p{^Scx=cari}', "");
    Expect(0, 66256, '\P{Scx=cari}', "");
    Expect(1, 66256, '\P{^Scx=cari}', "");
    Expect(0, 66257, '\p{Scx=cari}', "");
    Expect(1, 66257, '\p{^Scx=cari}', "");
    Expect(1, 66257, '\P{Scx=cari}', "");
    Expect(0, 66257, '\P{^Scx=cari}', "");
    Expect(1, 66256, '\p{Scx=:\Acari\z:}', "");;
    Expect(0, 66257, '\p{Scx=:\Acari\z:}', "");;
    Expect(1, 66256, '\p{Scx=-Cari}', "");
    Expect(0, 66256, '\p{^Scx=-Cari}', "");
    Expect(0, 66256, '\P{Scx=-Cari}', "");
    Expect(1, 66256, '\P{^Scx=-Cari}', "");
    Expect(0, 66257, '\p{Scx=-Cari}', "");
    Expect(1, 66257, '\p{^Scx=-Cari}', "");
    Expect(1, 66257, '\P{Scx=-Cari}', "");
    Expect(0, 66257, '\P{^Scx=-Cari}', "");
    Error('\p{Is_Script_Extensions=	CARIAN/a/}');
    Error('\P{Is_Script_Extensions=	CARIAN/a/}');
    Expect(1, 66256, '\p{Is_Script_Extensions: carian}', "");
    Expect(0, 66256, '\p{^Is_Script_Extensions: carian}', "");
    Expect(0, 66256, '\P{Is_Script_Extensions: carian}', "");
    Expect(1, 66256, '\P{^Is_Script_Extensions: carian}', "");
    Expect(0, 66257, '\p{Is_Script_Extensions: carian}', "");
    Expect(1, 66257, '\p{^Is_Script_Extensions: carian}', "");
    Expect(1, 66257, '\P{Is_Script_Extensions: carian}', "");
    Expect(0, 66257, '\P{^Is_Script_Extensions: carian}', "");
    Expect(1, 66256, '\p{Is_Script_Extensions=  Carian}', "");
    Expect(0, 66256, '\p{^Is_Script_Extensions=  Carian}', "");
    Expect(0, 66256, '\P{Is_Script_Extensions=  Carian}', "");
    Expect(1, 66256, '\P{^Is_Script_Extensions=  Carian}', "");
    Expect(0, 66257, '\p{Is_Script_Extensions=  Carian}', "");
    Expect(1, 66257, '\p{^Is_Script_Extensions=  Carian}', "");
    Expect(1, 66257, '\P{Is_Script_Extensions=  Carian}', "");
    Expect(0, 66257, '\P{^Is_Script_Extensions=  Carian}', "");
    Error('\p{Is_Scx=:= Cari}');
    Error('\P{Is_Scx=:= Cari}');
    Expect(1, 66256, '\p{Is_Scx: cari}', "");
    Expect(0, 66256, '\p{^Is_Scx: cari}', "");
    Expect(0, 66256, '\P{Is_Scx: cari}', "");
    Expect(1, 66256, '\P{^Is_Scx: cari}', "");
    Expect(0, 66257, '\p{Is_Scx: cari}', "");
    Expect(1, 66257, '\p{^Is_Scx: cari}', "");
    Expect(1, 66257, '\P{Is_Scx: cari}', "");
    Expect(0, 66257, '\P{^Is_Scx: cari}', "");
    Expect(1, 66256, '\p{Is_Scx=	-Cari}', "");
    Expect(0, 66256, '\p{^Is_Scx=	-Cari}', "");
    Expect(0, 66256, '\P{Is_Scx=	-Cari}', "");
    Expect(1, 66256, '\P{^Is_Scx=	-Cari}', "");
    Expect(0, 66257, '\p{Is_Scx=	-Cari}', "");
    Expect(1, 66257, '\p{^Is_Scx=	-Cari}', "");
    Expect(1, 66257, '\P{Is_Scx=	-Cari}', "");
    Expect(0, 66257, '\P{^Is_Scx=	-Cari}', "");
    Error('\p{Script_Extensions=:=-	Cham}');
    Error('\P{Script_Extensions=:=-	Cham}');
    Expect(1, 43615, '\p{Script_Extensions=:\ACham\z:}', "");;
    Expect(0, 43616, '\p{Script_Extensions=:\ACham\z:}', "");;
    Expect(1, 43615, '\p{Script_Extensions=cham}', "");
    Expect(0, 43615, '\p{^Script_Extensions=cham}', "");
    Expect(0, 43615, '\P{Script_Extensions=cham}', "");
    Expect(1, 43615, '\P{^Script_Extensions=cham}', "");
    Expect(0, 43616, '\p{Script_Extensions=cham}', "");
    Expect(1, 43616, '\p{^Script_Extensions=cham}', "");
    Expect(1, 43616, '\P{Script_Extensions=cham}', "");
    Expect(0, 43616, '\P{^Script_Extensions=cham}', "");
    Expect(1, 43615, '\p{Script_Extensions=:\Acham\z:}', "");;
    Expect(0, 43616, '\p{Script_Extensions=:\Acham\z:}', "");;
    Expect(1, 43615, '\p{Script_Extensions=- Cham}', "");
    Expect(0, 43615, '\p{^Script_Extensions=- Cham}', "");
    Expect(0, 43615, '\P{Script_Extensions=- Cham}', "");
    Expect(1, 43615, '\P{^Script_Extensions=- Cham}', "");
    Expect(0, 43616, '\p{Script_Extensions=- Cham}', "");
    Expect(1, 43616, '\p{^Script_Extensions=- Cham}', "");
    Expect(1, 43616, '\P{Script_Extensions=- Cham}', "");
    Expect(0, 43616, '\P{^Script_Extensions=- Cham}', "");
    Error('\p{Scx=:=- Cham}');
    Error('\P{Scx=:=- Cham}');
    Expect(1, 43615, '\p{Scx=:\ACham\z:}', "");;
    Expect(0, 43616, '\p{Scx=:\ACham\z:}', "");;
    Expect(1, 43615, '\p{Scx=cham}', "");
    Expect(0, 43615, '\p{^Scx=cham}', "");
    Expect(0, 43615, '\P{Scx=cham}', "");
    Expect(1, 43615, '\P{^Scx=cham}', "");
    Expect(0, 43616, '\p{Scx=cham}', "");
    Expect(1, 43616, '\p{^Scx=cham}', "");
    Expect(1, 43616, '\P{Scx=cham}', "");
    Expect(0, 43616, '\P{^Scx=cham}', "");
    Expect(1, 43615, '\p{Scx=:\Acham\z:}', "");;
    Expect(0, 43616, '\p{Scx=:\Acham\z:}', "");;
    Expect(1, 43615, '\p{Scx=	cham}', "");
    Expect(0, 43615, '\p{^Scx=	cham}', "");
    Expect(0, 43615, '\P{Scx=	cham}', "");
    Expect(1, 43615, '\P{^Scx=	cham}', "");
    Expect(0, 43616, '\p{Scx=	cham}', "");
    Expect(1, 43616, '\p{^Scx=	cham}', "");
    Expect(1, 43616, '\P{Scx=	cham}', "");
    Expect(0, 43616, '\P{^Scx=	cham}', "");
    Error('\p{Is_Script_Extensions=-:=cham}');
    Error('\P{Is_Script_Extensions=-:=cham}');
    Expect(1, 43615, '\p{Is_Script_Extensions=cham}', "");
    Expect(0, 43615, '\p{^Is_Script_Extensions=cham}', "");
    Expect(0, 43615, '\P{Is_Script_Extensions=cham}', "");
    Expect(1, 43615, '\P{^Is_Script_Extensions=cham}', "");
    Expect(0, 43616, '\p{Is_Script_Extensions=cham}', "");
    Expect(1, 43616, '\p{^Is_Script_Extensions=cham}', "");
    Expect(1, 43616, '\P{Is_Script_Extensions=cham}', "");
    Expect(0, 43616, '\P{^Is_Script_Extensions=cham}', "");
    Expect(1, 43615, '\p{Is_Script_Extensions=	 Cham}', "");
    Expect(0, 43615, '\p{^Is_Script_Extensions=	 Cham}', "");
    Expect(0, 43615, '\P{Is_Script_Extensions=	 Cham}', "");
    Expect(1, 43615, '\P{^Is_Script_Extensions=	 Cham}', "");
    Expect(0, 43616, '\p{Is_Script_Extensions=	 Cham}', "");
    Expect(1, 43616, '\p{^Is_Script_Extensions=	 Cham}', "");
    Expect(1, 43616, '\P{Is_Script_Extensions=	 Cham}', "");
    Expect(0, 43616, '\P{^Is_Script_Extensions=	 Cham}', "");
    Error('\p{Is_Scx= _Cham/a/}');
    Error('\P{Is_Scx= _Cham/a/}');
    Expect(1, 43615, '\p{Is_Scx=cham}', "");
    Expect(0, 43615, '\p{^Is_Scx=cham}', "");
    Expect(0, 43615, '\P{Is_Scx=cham}', "");
    Expect(1, 43615, '\P{^Is_Scx=cham}', "");
    Expect(0, 43616, '\p{Is_Scx=cham}', "");
    Expect(1, 43616, '\p{^Is_Scx=cham}', "");
    Expect(1, 43616, '\P{Is_Scx=cham}', "");
    Expect(0, 43616, '\P{^Is_Scx=cham}', "");
    Expect(1, 43615, '\p{Is_Scx=	 Cham}', "");
    Expect(0, 43615, '\p{^Is_Scx=	 Cham}', "");
    Expect(0, 43615, '\P{Is_Scx=	 Cham}', "");
    Expect(1, 43615, '\P{^Is_Scx=	 Cham}', "");
    Expect(0, 43616, '\p{Is_Scx=	 Cham}', "");
    Expect(1, 43616, '\p{^Is_Scx=	 Cham}', "");
    Expect(1, 43616, '\P{Is_Scx=	 Cham}', "");
    Expect(0, 43616, '\P{^Is_Scx=	 Cham}', "");
    Error('\p{Script_Extensions=:=		CHEROKEE}');
    Error('\P{Script_Extensions=:=		CHEROKEE}');
    Expect(1, 43967, '\p{Script_Extensions=:\ACherokee\z:}', "");;
    Expect(0, 43968, '\p{Script_Extensions=:\ACherokee\z:}', "");;
    Expect(1, 43967, '\p{Script_Extensions=cherokee}', "");
    Expect(0, 43967, '\p{^Script_Extensions=cherokee}', "");
    Expect(0, 43967, '\P{Script_Extensions=cherokee}', "");
    Expect(1, 43967, '\P{^Script_Extensions=cherokee}', "");
    Expect(0, 43968, '\p{Script_Extensions=cherokee}', "");
    Expect(1, 43968, '\p{^Script_Extensions=cherokee}', "");
    Expect(1, 43968, '\P{Script_Extensions=cherokee}', "");
    Expect(0, 43968, '\P{^Script_Extensions=cherokee}', "");
    Expect(1, 43967, '\p{Script_Extensions=:\Acherokee\z:}', "");;
    Expect(0, 43968, '\p{Script_Extensions=:\Acherokee\z:}', "");;
    Expect(1, 43967, '\p{Script_Extensions=  Cherokee}', "");
    Expect(0, 43967, '\p{^Script_Extensions=  Cherokee}', "");
    Expect(0, 43967, '\P{Script_Extensions=  Cherokee}', "");
    Expect(1, 43967, '\P{^Script_Extensions=  Cherokee}', "");
    Expect(0, 43968, '\p{Script_Extensions=  Cherokee}', "");
    Expect(1, 43968, '\p{^Script_Extensions=  Cherokee}', "");
    Expect(1, 43968, '\P{Script_Extensions=  Cherokee}', "");
    Expect(0, 43968, '\P{^Script_Extensions=  Cherokee}', "");
    Error('\p{Scx=:=--cher}');
    Error('\P{Scx=:=--cher}');
    Expect(1, 43967, '\p{Scx=:\ACher\z:}', "");;
    Expect(0, 43968, '\p{Scx=:\ACher\z:}', "");;
    Expect(1, 43967, '\p{Scx=cher}', "");
    Expect(0, 43967, '\p{^Scx=cher}', "");
    Expect(0, 43967, '\P{Scx=cher}', "");
    Expect(1, 43967, '\P{^Scx=cher}', "");
    Expect(0, 43968, '\p{Scx=cher}', "");
    Expect(1, 43968, '\p{^Scx=cher}', "");
    Expect(1, 43968, '\P{Scx=cher}', "");
    Expect(0, 43968, '\P{^Scx=cher}', "");
    Expect(1, 43967, '\p{Scx=:\Acher\z:}', "");;
    Expect(0, 43968, '\p{Scx=:\Acher\z:}', "");;
    Expect(1, 43967, '\p{Scx=_ cher}', "");
    Expect(0, 43967, '\p{^Scx=_ cher}', "");
    Expect(0, 43967, '\P{Scx=_ cher}', "");
    Expect(1, 43967, '\P{^Scx=_ cher}', "");
    Expect(0, 43968, '\p{Scx=_ cher}', "");
    Expect(1, 43968, '\p{^Scx=_ cher}', "");
    Expect(1, 43968, '\P{Scx=_ cher}', "");
    Expect(0, 43968, '\P{^Scx=_ cher}', "");
    Error('\p{Is_Script_Extensions=/a/_Cherokee}');
    Error('\P{Is_Script_Extensions=/a/_Cherokee}');
    Expect(1, 43967, '\p{Is_Script_Extensions=cherokee}', "");
    Expect(0, 43967, '\p{^Is_Script_Extensions=cherokee}', "");
    Expect(0, 43967, '\P{Is_Script_Extensions=cherokee}', "");
    Expect(1, 43967, '\P{^Is_Script_Extensions=cherokee}', "");
    Expect(0, 43968, '\p{Is_Script_Extensions=cherokee}', "");
    Expect(1, 43968, '\p{^Is_Script_Extensions=cherokee}', "");
    Expect(1, 43968, '\P{Is_Script_Extensions=cherokee}', "");
    Expect(0, 43968, '\P{^Is_Script_Extensions=cherokee}', "");
    Expect(1, 43967, '\p{Is_Script_Extensions=_	Cherokee}', "");
    Expect(0, 43967, '\p{^Is_Script_Extensions=_	Cherokee}', "");
    Expect(0, 43967, '\P{Is_Script_Extensions=_	Cherokee}', "");
    Expect(1, 43967, '\P{^Is_Script_Extensions=_	Cherokee}', "");
    Expect(0, 43968, '\p{Is_Script_Extensions=_	Cherokee}', "");
    Expect(1, 43968, '\p{^Is_Script_Extensions=_	Cherokee}', "");
    Expect(1, 43968, '\P{Is_Script_Extensions=_	Cherokee}', "");
    Expect(0, 43968, '\P{^Is_Script_Extensions=_	Cherokee}', "");
    Error('\p{Is_Scx=	/a/Cher}');
    Error('\P{Is_Scx=	/a/Cher}');
    Expect(1, 43967, '\p{Is_Scx=cher}', "");
    Expect(0, 43967, '\p{^Is_Scx=cher}', "");
    Expect(0, 43967, '\P{Is_Scx=cher}', "");
    Expect(1, 43967, '\P{^Is_Scx=cher}', "");
    Expect(0, 43968, '\p{Is_Scx=cher}', "");
    Expect(1, 43968, '\p{^Is_Scx=cher}', "");
    Expect(1, 43968, '\P{Is_Scx=cher}', "");
    Expect(0, 43968, '\P{^Is_Scx=cher}', "");
    Expect(1, 43967, '\p{Is_Scx=  Cher}', "");
    Expect(0, 43967, '\p{^Is_Scx=  Cher}', "");
    Expect(0, 43967, '\P{Is_Scx=  Cher}', "");
    Expect(1, 43967, '\P{^Is_Scx=  Cher}', "");
    Expect(0, 43968, '\p{Is_Scx=  Cher}', "");
    Expect(1, 43968, '\p{^Is_Scx=  Cher}', "");
    Expect(1, 43968, '\P{Is_Scx=  Cher}', "");
    Expect(0, 43968, '\P{^Is_Scx=  Cher}', "");
    Error('\p{Script_Extensions=	-coptic:=}');
    Error('\P{Script_Extensions=	-coptic:=}');
    Expect(1, 66299, '\p{Script_Extensions=:\ACoptic\z:}', "");;
    Expect(0, 66300, '\p{Script_Extensions=:\ACoptic\z:}', "");;
    Expect(1, 66299, '\p{Script_Extensions:coptic}', "");
    Expect(0, 66299, '\p{^Script_Extensions:coptic}', "");
    Expect(0, 66299, '\P{Script_Extensions:coptic}', "");
    Expect(1, 66299, '\P{^Script_Extensions:coptic}', "");
    Expect(0, 66300, '\p{Script_Extensions:coptic}', "");
    Expect(1, 66300, '\p{^Script_Extensions:coptic}', "");
    Expect(1, 66300, '\P{Script_Extensions:coptic}', "");
    Expect(0, 66300, '\P{^Script_Extensions:coptic}', "");
    Expect(1, 66299, '\p{Script_Extensions=:\Acoptic\z:}', "");;
    Expect(0, 66300, '\p{Script_Extensions=:\Acoptic\z:}', "");;
    Expect(1, 66299, '\p{Script_Extensions:  COPTIC}', "");
    Expect(0, 66299, '\p{^Script_Extensions:  COPTIC}', "");
    Expect(0, 66299, '\P{Script_Extensions:  COPTIC}', "");
    Expect(1, 66299, '\P{^Script_Extensions:  COPTIC}', "");
    Expect(0, 66300, '\p{Script_Extensions:  COPTIC}', "");
    Expect(1, 66300, '\p{^Script_Extensions:  COPTIC}', "");
    Expect(1, 66300, '\P{Script_Extensions:  COPTIC}', "");
    Expect(0, 66300, '\P{^Script_Extensions:  COPTIC}', "");
    Error('\p{Scx=_	Copt:=}');
    Error('\P{Scx=_	Copt:=}');
    Expect(1, 66299, '\p{Scx=:\ACopt\z:}', "");;
    Expect(0, 66300, '\p{Scx=:\ACopt\z:}', "");;
    Expect(1, 66299, '\p{Scx:copt}', "");
    Expect(0, 66299, '\p{^Scx:copt}', "");
    Expect(0, 66299, '\P{Scx:copt}', "");
    Expect(1, 66299, '\P{^Scx:copt}', "");
    Expect(0, 66300, '\p{Scx:copt}', "");
    Expect(1, 66300, '\p{^Scx:copt}', "");
    Expect(1, 66300, '\P{Scx:copt}', "");
    Expect(0, 66300, '\P{^Scx:copt}', "");
    Expect(1, 66299, '\p{Scx=:\Acopt\z:}', "");;
    Expect(0, 66300, '\p{Scx=:\Acopt\z:}', "");;
    Expect(1, 66299, '\p{Scx=-	COPT}', "");
    Expect(0, 66299, '\p{^Scx=-	COPT}', "");
    Expect(0, 66299, '\P{Scx=-	COPT}', "");
    Expect(1, 66299, '\P{^Scx=-	COPT}', "");
    Expect(0, 66300, '\p{Scx=-	COPT}', "");
    Expect(1, 66300, '\p{^Scx=-	COPT}', "");
    Expect(1, 66300, '\P{Scx=-	COPT}', "");
    Expect(0, 66300, '\P{^Scx=-	COPT}', "");
    Error('\p{Is_Script_Extensions=/a/		qaac}');
    Error('\P{Is_Script_Extensions=/a/		qaac}');
    Expect(1, 66299, '\p{Is_Script_Extensions=qaac}', "");
    Expect(0, 66299, '\p{^Is_Script_Extensions=qaac}', "");
    Expect(0, 66299, '\P{Is_Script_Extensions=qaac}', "");
    Expect(1, 66299, '\P{^Is_Script_Extensions=qaac}', "");
    Expect(0, 66300, '\p{Is_Script_Extensions=qaac}', "");
    Expect(1, 66300, '\p{^Is_Script_Extensions=qaac}', "");
    Expect(1, 66300, '\P{Is_Script_Extensions=qaac}', "");
    Expect(0, 66300, '\P{^Is_Script_Extensions=qaac}', "");
    Expect(1, 66299, '\p{Is_Script_Extensions=- Qaac}', "");
    Expect(0, 66299, '\p{^Is_Script_Extensions=- Qaac}', "");
    Expect(0, 66299, '\P{Is_Script_Extensions=- Qaac}', "");
    Expect(1, 66299, '\P{^Is_Script_Extensions=- Qaac}', "");
    Expect(0, 66300, '\p{Is_Script_Extensions=- Qaac}', "");
    Expect(1, 66300, '\p{^Is_Script_Extensions=- Qaac}', "");
    Expect(1, 66300, '\P{Is_Script_Extensions=- Qaac}', "");
    Expect(0, 66300, '\P{^Is_Script_Extensions=- Qaac}', "");
    Error('\p{Is_Scx=	/a/Coptic}');
    Error('\P{Is_Scx=	/a/Coptic}');
    Expect(1, 66299, '\p{Is_Scx=coptic}', "");
    Expect(0, 66299, '\p{^Is_Scx=coptic}', "");
    Expect(0, 66299, '\P{Is_Scx=coptic}', "");
    Expect(1, 66299, '\P{^Is_Scx=coptic}', "");
    Expect(0, 66300, '\p{Is_Scx=coptic}', "");
    Expect(1, 66300, '\p{^Is_Scx=coptic}', "");
    Expect(1, 66300, '\P{Is_Scx=coptic}', "");
    Expect(0, 66300, '\P{^Is_Scx=coptic}', "");
    Expect(1, 66299, '\p{Is_Scx=Coptic}', "");
    Expect(0, 66299, '\p{^Is_Scx=Coptic}', "");
    Expect(0, 66299, '\P{Is_Scx=Coptic}', "");
    Expect(1, 66299, '\P{^Is_Scx=Coptic}', "");
    Expect(0, 66300, '\p{Is_Scx=Coptic}', "");
    Expect(1, 66300, '\p{^Is_Scx=Coptic}', "");
    Expect(1, 66300, '\P{Is_Scx=Coptic}', "");
    Expect(0, 66300, '\P{^Is_Scx=Coptic}', "");
    Error('\p{Script_Extensions=-/a/Cypriot}');
    Error('\P{Script_Extensions=-/a/Cypriot}');
    Expect(1, 67647, '\p{Script_Extensions=:\ACypriot\z:}', "");;
    Expect(0, 67648, '\p{Script_Extensions=:\ACypriot\z:}', "");;
    Expect(1, 67647, '\p{Script_Extensions=cypriot}', "");
    Expect(0, 67647, '\p{^Script_Extensions=cypriot}', "");
    Expect(0, 67647, '\P{Script_Extensions=cypriot}', "");
    Expect(1, 67647, '\P{^Script_Extensions=cypriot}', "");
    Expect(0, 67648, '\p{Script_Extensions=cypriot}', "");
    Expect(1, 67648, '\p{^Script_Extensions=cypriot}', "");
    Expect(1, 67648, '\P{Script_Extensions=cypriot}', "");
    Expect(0, 67648, '\P{^Script_Extensions=cypriot}', "");
    Expect(1, 67647, '\p{Script_Extensions=:\Acypriot\z:}', "");;
    Expect(0, 67648, '\p{Script_Extensions=:\Acypriot\z:}', "");;
    Expect(1, 67647, '\p{Script_Extensions=_	Cypriot}', "");
    Expect(0, 67647, '\p{^Script_Extensions=_	Cypriot}', "");
    Expect(0, 67647, '\P{Script_Extensions=_	Cypriot}', "");
    Expect(1, 67647, '\P{^Script_Extensions=_	Cypriot}', "");
    Expect(0, 67648, '\p{Script_Extensions=_	Cypriot}', "");
    Expect(1, 67648, '\p{^Script_Extensions=_	Cypriot}', "");
    Expect(1, 67648, '\P{Script_Extensions=_	Cypriot}', "");
    Expect(0, 67648, '\P{^Script_Extensions=_	Cypriot}', "");
    Error('\p{Scx=/a/ CPRT}');
    Error('\P{Scx=/a/ CPRT}');
    Expect(1, 67647, '\p{Scx=:\ACprt\z:}', "");;
    Expect(0, 67648, '\p{Scx=:\ACprt\z:}', "");;
    Expect(1, 67647, '\p{Scx=cprt}', "");
    Expect(0, 67647, '\p{^Scx=cprt}', "");
    Expect(0, 67647, '\P{Scx=cprt}', "");
    Expect(1, 67647, '\P{^Scx=cprt}', "");
    Expect(0, 67648, '\p{Scx=cprt}', "");
    Expect(1, 67648, '\p{^Scx=cprt}', "");
    Expect(1, 67648, '\P{Scx=cprt}', "");
    Expect(0, 67648, '\P{^Scx=cprt}', "");
    Expect(1, 67647, '\p{Scx=:\Acprt\z:}', "");;
    Expect(0, 67648, '\p{Scx=:\Acprt\z:}', "");;
    Expect(1, 67647, '\p{Scx=	-Cprt}', "");
    Expect(0, 67647, '\p{^Scx=	-Cprt}', "");
    Expect(0, 67647, '\P{Scx=	-Cprt}', "");
    Expect(1, 67647, '\P{^Scx=	-Cprt}', "");
    Expect(0, 67648, '\p{Scx=	-Cprt}', "");
    Expect(1, 67648, '\p{^Scx=	-Cprt}', "");
    Expect(1, 67648, '\P{Scx=	-Cprt}', "");
    Expect(0, 67648, '\P{^Scx=	-Cprt}', "");
    Error('\p{Is_Script_Extensions=:=_-Cypriot}');
    Error('\P{Is_Script_Extensions=:=_-Cypriot}');
    Expect(1, 67647, '\p{Is_Script_Extensions=cypriot}', "");
    Expect(0, 67647, '\p{^Is_Script_Extensions=cypriot}', "");
    Expect(0, 67647, '\P{Is_Script_Extensions=cypriot}', "");
    Expect(1, 67647, '\P{^Is_Script_Extensions=cypriot}', "");
    Expect(0, 67648, '\p{Is_Script_Extensions=cypriot}', "");
    Expect(1, 67648, '\p{^Is_Script_Extensions=cypriot}', "");
    Expect(1, 67648, '\P{Is_Script_Extensions=cypriot}', "");
    Expect(0, 67648, '\P{^Is_Script_Extensions=cypriot}', "");
    Expect(1, 67647, '\p{Is_Script_Extensions=-_Cypriot}', "");
    Expect(0, 67647, '\p{^Is_Script_Extensions=-_Cypriot}', "");
    Expect(0, 67647, '\P{Is_Script_Extensions=-_Cypriot}', "");
    Expect(1, 67647, '\P{^Is_Script_Extensions=-_Cypriot}', "");
    Expect(0, 67648, '\p{Is_Script_Extensions=-_Cypriot}', "");
    Expect(1, 67648, '\p{^Is_Script_Extensions=-_Cypriot}', "");
    Expect(1, 67648, '\P{Is_Script_Extensions=-_Cypriot}', "");
    Expect(0, 67648, '\P{^Is_Script_Extensions=-_Cypriot}', "");
    Error('\p{Is_Scx=/a/_CPRT}');
    Error('\P{Is_Scx=/a/_CPRT}');
    Expect(1, 67647, '\p{Is_Scx=cprt}', "");
    Expect(0, 67647, '\p{^Is_Scx=cprt}', "");
    Expect(0, 67647, '\P{Is_Scx=cprt}', "");
    Expect(1, 67647, '\P{^Is_Scx=cprt}', "");
    Expect(0, 67648, '\p{Is_Scx=cprt}', "");
    Expect(1, 67648, '\p{^Is_Scx=cprt}', "");
    Expect(1, 67648, '\P{Is_Scx=cprt}', "");
    Expect(0, 67648, '\P{^Is_Scx=cprt}', "");
    Expect(1, 67647, '\p{Is_Scx=-_CPRT}', "");
    Expect(0, 67647, '\p{^Is_Scx=-_CPRT}', "");
    Expect(0, 67647, '\P{Is_Scx=-_CPRT}', "");
    Expect(1, 67647, '\P{^Is_Scx=-_CPRT}', "");
    Expect(0, 67648, '\p{Is_Scx=-_CPRT}', "");
    Expect(1, 67648, '\p{^Is_Scx=-_CPRT}', "");
    Expect(1, 67648, '\P{Is_Scx=-_CPRT}', "");
    Expect(0, 67648, '\P{^Is_Scx=-_CPRT}', "");
    Error('\p{Script_Extensions=--cyrillic:=}');
    Error('\P{Script_Extensions=--cyrillic:=}');
    Expect(1, 65071, '\p{Script_Extensions=:\ACyrillic\z:}', "");;
    Expect(0, 65072, '\p{Script_Extensions=:\ACyrillic\z:}', "");;
    Expect(1, 65071, '\p{Script_Extensions=cyrillic}', "");
    Expect(0, 65071, '\p{^Script_Extensions=cyrillic}', "");
    Expect(0, 65071, '\P{Script_Extensions=cyrillic}', "");
    Expect(1, 65071, '\P{^Script_Extensions=cyrillic}', "");
    Expect(0, 65072, '\p{Script_Extensions=cyrillic}', "");
    Expect(1, 65072, '\p{^Script_Extensions=cyrillic}', "");
    Expect(1, 65072, '\P{Script_Extensions=cyrillic}', "");
    Expect(0, 65072, '\P{^Script_Extensions=cyrillic}', "");
    Expect(1, 65071, '\p{Script_Extensions=:\Acyrillic\z:}', "");;
    Expect(0, 65072, '\p{Script_Extensions=:\Acyrillic\z:}', "");;
    Expect(1, 65071, '\p{Script_Extensions=-_Cyrillic}', "");
    Expect(0, 65071, '\p{^Script_Extensions=-_Cyrillic}', "");
    Expect(0, 65071, '\P{Script_Extensions=-_Cyrillic}', "");
    Expect(1, 65071, '\P{^Script_Extensions=-_Cyrillic}', "");
    Expect(0, 65072, '\p{Script_Extensions=-_Cyrillic}', "");
    Expect(1, 65072, '\p{^Script_Extensions=-_Cyrillic}', "");
    Expect(1, 65072, '\P{Script_Extensions=-_Cyrillic}', "");
    Expect(0, 65072, '\P{^Script_Extensions=-_Cyrillic}', "");
    Error('\p{Scx:	 _cyrl/a/}');
    Error('\P{Scx:	 _cyrl/a/}');
    Expect(1, 65071, '\p{Scx=:\ACyrl\z:}', "");;
    Expect(0, 65072, '\p{Scx=:\ACyrl\z:}', "");;
    Expect(1, 65071, '\p{Scx=cyrl}', "");
    Expect(0, 65071, '\p{^Scx=cyrl}', "");
    Expect(0, 65071, '\P{Scx=cyrl}', "");
    Expect(1, 65071, '\P{^Scx=cyrl}', "");
    Expect(0, 65072, '\p{Scx=cyrl}', "");
    Expect(1, 65072, '\p{^Scx=cyrl}', "");
    Expect(1, 65072, '\P{Scx=cyrl}', "");
    Expect(0, 65072, '\P{^Scx=cyrl}', "");
    Expect(1, 65071, '\p{Scx=:\Acyrl\z:}', "");;
    Expect(0, 65072, '\p{Scx=:\Acyrl\z:}', "");;
    Expect(1, 65071, '\p{Scx= CYRL}', "");
    Expect(0, 65071, '\p{^Scx= CYRL}', "");
    Expect(0, 65071, '\P{Scx= CYRL}', "");
    Expect(1, 65071, '\P{^Scx= CYRL}', "");
    Expect(0, 65072, '\p{Scx= CYRL}', "");
    Expect(1, 65072, '\p{^Scx= CYRL}', "");
    Expect(1, 65072, '\P{Scx= CYRL}', "");
    Expect(0, 65072, '\P{^Scx= CYRL}', "");
    Error('\p{Is_Script_Extensions= _Cyrillic:=}');
    Error('\P{Is_Script_Extensions= _Cyrillic:=}');
    Expect(1, 65071, '\p{Is_Script_Extensions=cyrillic}', "");
    Expect(0, 65071, '\p{^Is_Script_Extensions=cyrillic}', "");
    Expect(0, 65071, '\P{Is_Script_Extensions=cyrillic}', "");
    Expect(1, 65071, '\P{^Is_Script_Extensions=cyrillic}', "");
    Expect(0, 65072, '\p{Is_Script_Extensions=cyrillic}', "");
    Expect(1, 65072, '\p{^Is_Script_Extensions=cyrillic}', "");
    Expect(1, 65072, '\P{Is_Script_Extensions=cyrillic}', "");
    Expect(0, 65072, '\P{^Is_Script_Extensions=cyrillic}', "");
    Expect(1, 65071, '\p{Is_Script_Extensions=_cyrillic}', "");
    Expect(0, 65071, '\p{^Is_Script_Extensions=_cyrillic}', "");
    Expect(0, 65071, '\P{Is_Script_Extensions=_cyrillic}', "");
    Expect(1, 65071, '\P{^Is_Script_Extensions=_cyrillic}', "");
    Expect(0, 65072, '\p{Is_Script_Extensions=_cyrillic}', "");
    Expect(1, 65072, '\p{^Is_Script_Extensions=_cyrillic}', "");
    Expect(1, 65072, '\P{Is_Script_Extensions=_cyrillic}', "");
    Expect(0, 65072, '\P{^Is_Script_Extensions=_cyrillic}', "");
    Error('\p{Is_Scx=-CYRL/a/}');
    Error('\P{Is_Scx=-CYRL/a/}');
    Expect(1, 65071, '\p{Is_Scx=cyrl}', "");
    Expect(0, 65071, '\p{^Is_Scx=cyrl}', "");
    Expect(0, 65071, '\P{Is_Scx=cyrl}', "");
    Expect(1, 65071, '\P{^Is_Scx=cyrl}', "");
    Expect(0, 65072, '\p{Is_Scx=cyrl}', "");
    Expect(1, 65072, '\p{^Is_Scx=cyrl}', "");
    Expect(1, 65072, '\P{Is_Scx=cyrl}', "");
    Expect(0, 65072, '\P{^Is_Scx=cyrl}', "");
    Expect(1, 65071, '\p{Is_Scx:    cyrl}', "");
    Expect(0, 65071, '\p{^Is_Scx:    cyrl}', "");
    Expect(0, 65071, '\P{Is_Scx:    cyrl}', "");
    Expect(1, 65071, '\P{^Is_Scx:    cyrl}', "");
    Expect(0, 65072, '\p{Is_Scx:    cyrl}', "");
    Expect(1, 65072, '\p{^Is_Scx:    cyrl}', "");
    Expect(1, 65072, '\P{Is_Scx:    cyrl}', "");
    Expect(0, 65072, '\P{^Is_Scx:    cyrl}', "");
    Error('\p{Script_Extensions: /a/DEVANAGARI}');
    Error('\P{Script_Extensions: /a/DEVANAGARI}');
    Expect(1, 43263, '\p{Script_Extensions=:\ADevanagari\z:}', "");;
    Expect(0, 43264, '\p{Script_Extensions=:\ADevanagari\z:}', "");;
    Expect(1, 43263, '\p{Script_Extensions:   devanagari}', "");
    Expect(0, 43263, '\p{^Script_Extensions:   devanagari}', "");
    Expect(0, 43263, '\P{Script_Extensions:   devanagari}', "");
    Expect(1, 43263, '\P{^Script_Extensions:   devanagari}', "");
    Expect(0, 43264, '\p{Script_Extensions:   devanagari}', "");
    Expect(1, 43264, '\p{^Script_Extensions:   devanagari}', "");
    Expect(1, 43264, '\P{Script_Extensions:   devanagari}', "");
    Expect(0, 43264, '\P{^Script_Extensions:   devanagari}', "");
    Expect(1, 43263, '\p{Script_Extensions=:\Adevanagari\z:}', "");;
    Expect(0, 43264, '\p{Script_Extensions=:\Adevanagari\z:}', "");;
    Expect(1, 43263, '\p{Script_Extensions= _DEVANAGARI}', "");
    Expect(0, 43263, '\p{^Script_Extensions= _DEVANAGARI}', "");
    Expect(0, 43263, '\P{Script_Extensions= _DEVANAGARI}', "");
    Expect(1, 43263, '\P{^Script_Extensions= _DEVANAGARI}', "");
    Expect(0, 43264, '\p{Script_Extensions= _DEVANAGARI}', "");
    Expect(1, 43264, '\p{^Script_Extensions= _DEVANAGARI}', "");
    Expect(1, 43264, '\P{Script_Extensions= _DEVANAGARI}', "");
    Expect(0, 43264, '\P{^Script_Extensions= _DEVANAGARI}', "");
    Error('\p{Scx=-Deva:=}');
    Error('\P{Scx=-Deva:=}');
    Expect(1, 43263, '\p{Scx=:\ADeva\z:}', "");;
    Expect(0, 43264, '\p{Scx=:\ADeva\z:}', "");;
    Expect(1, 43263, '\p{Scx=deva}', "");
    Expect(0, 43263, '\p{^Scx=deva}', "");
    Expect(0, 43263, '\P{Scx=deva}', "");
    Expect(1, 43263, '\P{^Scx=deva}', "");
    Expect(0, 43264, '\p{Scx=deva}', "");
    Expect(1, 43264, '\p{^Scx=deva}', "");
    Expect(1, 43264, '\P{Scx=deva}', "");
    Expect(0, 43264, '\P{^Scx=deva}', "");
    Expect(1, 43263, '\p{Scx=:\Adeva\z:}', "");;
    Expect(0, 43264, '\p{Scx=:\Adeva\z:}', "");;
    Expect(1, 43263, '\p{Scx=_deva}', "");
    Expect(0, 43263, '\p{^Scx=_deva}', "");
    Expect(0, 43263, '\P{Scx=_deva}', "");
    Expect(1, 43263, '\P{^Scx=_deva}', "");
    Expect(0, 43264, '\p{Scx=_deva}', "");
    Expect(1, 43264, '\p{^Scx=_deva}', "");
    Expect(1, 43264, '\P{Scx=_deva}', "");
    Expect(0, 43264, '\P{^Scx=_deva}', "");
    Error('\p{Is_Script_Extensions=_:=Devanagari}');
    Error('\P{Is_Script_Extensions=_:=Devanagari}');
    Expect(1, 43263, '\p{Is_Script_Extensions=devanagari}', "");
    Expect(0, 43263, '\p{^Is_Script_Extensions=devanagari}', "");
    Expect(0, 43263, '\P{Is_Script_Extensions=devanagari}', "");
    Expect(1, 43263, '\P{^Is_Script_Extensions=devanagari}', "");
    Expect(0, 43264, '\p{Is_Script_Extensions=devanagari}', "");
    Expect(1, 43264, '\p{^Is_Script_Extensions=devanagari}', "");
    Expect(1, 43264, '\P{Is_Script_Extensions=devanagari}', "");
    Expect(0, 43264, '\P{^Is_Script_Extensions=devanagari}', "");
    Expect(1, 43263, '\p{Is_Script_Extensions=-_Devanagari}', "");
    Expect(0, 43263, '\p{^Is_Script_Extensions=-_Devanagari}', "");
    Expect(0, 43263, '\P{Is_Script_Extensions=-_Devanagari}', "");
    Expect(1, 43263, '\P{^Is_Script_Extensions=-_Devanagari}', "");
    Expect(0, 43264, '\p{Is_Script_Extensions=-_Devanagari}', "");
    Expect(1, 43264, '\p{^Is_Script_Extensions=-_Devanagari}', "");
    Expect(1, 43264, '\P{Is_Script_Extensions=-_Devanagari}', "");
    Expect(0, 43264, '\P{^Is_Script_Extensions=-_Devanagari}', "");
    Error('\p{Is_Scx= Deva:=}');
    Error('\P{Is_Scx= Deva:=}');
    Expect(1, 43263, '\p{Is_Scx=deva}', "");
    Expect(0, 43263, '\p{^Is_Scx=deva}', "");
    Expect(0, 43263, '\P{Is_Scx=deva}', "");
    Expect(1, 43263, '\P{^Is_Scx=deva}', "");
    Expect(0, 43264, '\p{Is_Scx=deva}', "");
    Expect(1, 43264, '\p{^Is_Scx=deva}', "");
    Expect(1, 43264, '\P{Is_Scx=deva}', "");
    Expect(0, 43264, '\P{^Is_Scx=deva}', "");
    Expect(1, 43263, '\p{Is_Scx:   -Deva}', "");
    Expect(0, 43263, '\p{^Is_Scx:   -Deva}', "");
    Expect(0, 43263, '\P{Is_Scx:   -Deva}', "");
    Expect(1, 43263, '\P{^Is_Scx:   -Deva}', "");
    Expect(0, 43264, '\p{Is_Scx:   -Deva}', "");
    Expect(1, 43264, '\p{^Is_Scx:   -Deva}', "");
    Expect(1, 43264, '\P{Is_Scx:   -Deva}', "");
    Expect(0, 43264, '\P{^Is_Scx:   -Deva}', "");
    Error('\p{Script_Extensions=:=_DOGRA}');
    Error('\P{Script_Extensions=:=_DOGRA}');
    Expect(1, 71739, '\p{Script_Extensions=:\ADogra\z:}', "");;
    Expect(0, 71740, '\p{Script_Extensions=:\ADogra\z:}', "");;
    Expect(1, 71739, '\p{Script_Extensions=dogra}', "");
    Expect(0, 71739, '\p{^Script_Extensions=dogra}', "");
    Expect(0, 71739, '\P{Script_Extensions=dogra}', "");
    Expect(1, 71739, '\P{^Script_Extensions=dogra}', "");
    Expect(0, 71740, '\p{Script_Extensions=dogra}', "");
    Expect(1, 71740, '\p{^Script_Extensions=dogra}', "");
    Expect(1, 71740, '\P{Script_Extensions=dogra}', "");
    Expect(0, 71740, '\P{^Script_Extensions=dogra}', "");
    Expect(1, 71739, '\p{Script_Extensions=:\Adogra\z:}', "");;
    Expect(0, 71740, '\p{Script_Extensions=:\Adogra\z:}', "");;
    Expect(1, 71739, '\p{Script_Extensions=	dogra}', "");
    Expect(0, 71739, '\p{^Script_Extensions=	dogra}', "");
    Expect(0, 71739, '\P{Script_Extensions=	dogra}', "");
    Expect(1, 71739, '\P{^Script_Extensions=	dogra}', "");
    Expect(0, 71740, '\p{Script_Extensions=	dogra}', "");
    Expect(1, 71740, '\p{^Script_Extensions=	dogra}', "");
    Expect(1, 71740, '\P{Script_Extensions=	dogra}', "");
    Expect(0, 71740, '\P{^Script_Extensions=	dogra}', "");
    Error('\p{Scx=_ DOGR:=}');
    Error('\P{Scx=_ DOGR:=}');
    Expect(1, 71739, '\p{Scx=:\ADogr\z:}', "");;
    Expect(0, 71740, '\p{Scx=:\ADogr\z:}', "");;
    Expect(1, 71739, '\p{Scx:	dogr}', "");
    Expect(0, 71739, '\p{^Scx:	dogr}', "");
    Expect(0, 71739, '\P{Scx:	dogr}', "");
    Expect(1, 71739, '\P{^Scx:	dogr}', "");
    Expect(0, 71740, '\p{Scx:	dogr}', "");
    Expect(1, 71740, '\p{^Scx:	dogr}', "");
    Expect(1, 71740, '\P{Scx:	dogr}', "");
    Expect(0, 71740, '\P{^Scx:	dogr}', "");
    Expect(1, 71739, '\p{Scx=:\Adogr\z:}', "");;
    Expect(0, 71740, '\p{Scx=:\Adogr\z:}', "");;
    Expect(1, 71739, '\p{Scx=	DOGR}', "");
    Expect(0, 71739, '\p{^Scx=	DOGR}', "");
    Expect(0, 71739, '\P{Scx=	DOGR}', "");
    Expect(1, 71739, '\P{^Scx=	DOGR}', "");
    Expect(0, 71740, '\p{Scx=	DOGR}', "");
    Expect(1, 71740, '\p{^Scx=	DOGR}', "");
    Expect(1, 71740, '\P{Scx=	DOGR}', "");
    Expect(0, 71740, '\P{^Scx=	DOGR}', "");
    Error('\p{Is_Script_Extensions=	_DOGRA:=}');
    Error('\P{Is_Script_Extensions=	_DOGRA:=}');
    Expect(1, 71739, '\p{Is_Script_Extensions: dogra}', "");
    Expect(0, 71739, '\p{^Is_Script_Extensions: dogra}', "");
    Expect(0, 71739, '\P{Is_Script_Extensions: dogra}', "");
    Expect(1, 71739, '\P{^Is_Script_Extensions: dogra}', "");
    Expect(0, 71740, '\p{Is_Script_Extensions: dogra}', "");
    Expect(1, 71740, '\p{^Is_Script_Extensions: dogra}', "");
    Expect(1, 71740, '\P{Is_Script_Extensions: dogra}', "");
    Expect(0, 71740, '\P{^Is_Script_Extensions: dogra}', "");
    Expect(1, 71739, '\p{Is_Script_Extensions=- dogra}', "");
    Expect(0, 71739, '\p{^Is_Script_Extensions=- dogra}', "");
    Expect(0, 71739, '\P{Is_Script_Extensions=- dogra}', "");
    Expect(1, 71739, '\P{^Is_Script_Extensions=- dogra}', "");
    Expect(0, 71740, '\p{Is_Script_Extensions=- dogra}', "");
    Expect(1, 71740, '\p{^Is_Script_Extensions=- dogra}', "");
    Expect(1, 71740, '\P{Is_Script_Extensions=- dogra}', "");
    Expect(0, 71740, '\P{^Is_Script_Extensions=- dogra}', "");
    Error('\p{Is_Scx=	Dogr:=}');
    Error('\P{Is_Scx=	Dogr:=}');
    Expect(1, 71739, '\p{Is_Scx=dogr}', "");
    Expect(0, 71739, '\p{^Is_Scx=dogr}', "");
    Expect(0, 71739, '\P{Is_Scx=dogr}', "");
    Expect(1, 71739, '\P{^Is_Scx=dogr}', "");
    Expect(0, 71740, '\p{Is_Scx=dogr}', "");
    Expect(1, 71740, '\p{^Is_Scx=dogr}', "");
    Expect(1, 71740, '\P{Is_Scx=dogr}', "");
    Expect(0, 71740, '\P{^Is_Scx=dogr}', "");
    Expect(1, 71739, '\p{Is_Scx=	Dogr}', "");
    Expect(0, 71739, '\p{^Is_Scx=	Dogr}', "");
    Expect(0, 71739, '\P{Is_Scx=	Dogr}', "");
    Expect(1, 71739, '\P{^Is_Scx=	Dogr}', "");
    Expect(0, 71740, '\p{Is_Scx=	Dogr}', "");
    Expect(1, 71740, '\p{^Is_Scx=	Dogr}', "");
    Expect(1, 71740, '\P{Is_Scx=	Dogr}', "");
    Expect(0, 71740, '\P{^Is_Scx=	Dogr}', "");
    Error('\p{Script_Extensions=/a/	deseret}');
    Error('\P{Script_Extensions=/a/	deseret}');
    Expect(1, 66639, '\p{Script_Extensions=:\ADeseret\z:}', "");;
    Expect(0, 66640, '\p{Script_Extensions=:\ADeseret\z:}', "");;
    Expect(1, 66639, '\p{Script_Extensions:   deseret}', "");
    Expect(0, 66639, '\p{^Script_Extensions:   deseret}', "");
    Expect(0, 66639, '\P{Script_Extensions:   deseret}', "");
    Expect(1, 66639, '\P{^Script_Extensions:   deseret}', "");
    Expect(0, 66640, '\p{Script_Extensions:   deseret}', "");
    Expect(1, 66640, '\p{^Script_Extensions:   deseret}', "");
    Expect(1, 66640, '\P{Script_Extensions:   deseret}', "");
    Expect(0, 66640, '\P{^Script_Extensions:   deseret}', "");
    Expect(1, 66639, '\p{Script_Extensions=:\Adeseret\z:}', "");;
    Expect(0, 66640, '\p{Script_Extensions=:\Adeseret\z:}', "");;
    Expect(1, 66639, '\p{Script_Extensions= deseret}', "");
    Expect(0, 66639, '\p{^Script_Extensions= deseret}', "");
    Expect(0, 66639, '\P{Script_Extensions= deseret}', "");
    Expect(1, 66639, '\P{^Script_Extensions= deseret}', "");
    Expect(0, 66640, '\p{Script_Extensions= deseret}', "");
    Expect(1, 66640, '\p{^Script_Extensions= deseret}', "");
    Expect(1, 66640, '\P{Script_Extensions= deseret}', "");
    Expect(0, 66640, '\P{^Script_Extensions= deseret}', "");
    Error('\p{Scx=:=DSRT}');
    Error('\P{Scx=:=DSRT}');
    Expect(1, 66639, '\p{Scx=:\ADsrt\z:}', "");;
    Expect(0, 66640, '\p{Scx=:\ADsrt\z:}', "");;
    Expect(1, 66639, '\p{Scx=dsrt}', "");
    Expect(0, 66639, '\p{^Scx=dsrt}', "");
    Expect(0, 66639, '\P{Scx=dsrt}', "");
    Expect(1, 66639, '\P{^Scx=dsrt}', "");
    Expect(0, 66640, '\p{Scx=dsrt}', "");
    Expect(1, 66640, '\p{^Scx=dsrt}', "");
    Expect(1, 66640, '\P{Scx=dsrt}', "");
    Expect(0, 66640, '\P{^Scx=dsrt}', "");
    Expect(1, 66639, '\p{Scx=:\Adsrt\z:}', "");;
    Expect(0, 66640, '\p{Scx=:\Adsrt\z:}', "");;
    Expect(1, 66639, '\p{Scx=	 Dsrt}', "");
    Expect(0, 66639, '\p{^Scx=	 Dsrt}', "");
    Expect(0, 66639, '\P{Scx=	 Dsrt}', "");
    Expect(1, 66639, '\P{^Scx=	 Dsrt}', "");
    Expect(0, 66640, '\p{Scx=	 Dsrt}', "");
    Expect(1, 66640, '\p{^Scx=	 Dsrt}', "");
    Expect(1, 66640, '\P{Scx=	 Dsrt}', "");
    Expect(0, 66640, '\P{^Scx=	 Dsrt}', "");
    Error('\p{Is_Script_Extensions=_-Deseret/a/}');
    Error('\P{Is_Script_Extensions=_-Deseret/a/}');
    Expect(1, 66639, '\p{Is_Script_Extensions=deseret}', "");
    Expect(0, 66639, '\p{^Is_Script_Extensions=deseret}', "");
    Expect(0, 66639, '\P{Is_Script_Extensions=deseret}', "");
    Expect(1, 66639, '\P{^Is_Script_Extensions=deseret}', "");
    Expect(0, 66640, '\p{Is_Script_Extensions=deseret}', "");
    Expect(1, 66640, '\p{^Is_Script_Extensions=deseret}', "");
    Expect(1, 66640, '\P{Is_Script_Extensions=deseret}', "");
    Expect(0, 66640, '\P{^Is_Script_Extensions=deseret}', "");
    Expect(1, 66639, '\p{Is_Script_Extensions=	Deseret}', "");
    Expect(0, 66639, '\p{^Is_Script_Extensions=	Deseret}', "");
    Expect(0, 66639, '\P{Is_Script_Extensions=	Deseret}', "");
    Expect(1, 66639, '\P{^Is_Script_Extensions=	Deseret}', "");
    Expect(0, 66640, '\p{Is_Script_Extensions=	Deseret}', "");
    Expect(1, 66640, '\p{^Is_Script_Extensions=	Deseret}', "");
    Expect(1, 66640, '\P{Is_Script_Extensions=	Deseret}', "");
    Expect(0, 66640, '\P{^Is_Script_Extensions=	Deseret}', "");
    Error('\p{Is_Scx=:=	 Dsrt}');
    Error('\P{Is_Scx=:=	 Dsrt}');
    Expect(1, 66639, '\p{Is_Scx=dsrt}', "");
    Expect(0, 66639, '\p{^Is_Scx=dsrt}', "");
    Expect(0, 66639, '\P{Is_Scx=dsrt}', "");
    Expect(1, 66639, '\P{^Is_Scx=dsrt}', "");
    Expect(0, 66640, '\p{Is_Scx=dsrt}', "");
    Expect(1, 66640, '\p{^Is_Scx=dsrt}', "");
    Expect(1, 66640, '\P{Is_Scx=dsrt}', "");
    Expect(0, 66640, '\P{^Is_Scx=dsrt}', "");
    Expect(1, 66639, '\p{Is_Scx=-_DSRT}', "");
    Expect(0, 66639, '\p{^Is_Scx=-_DSRT}', "");
    Expect(0, 66639, '\P{Is_Scx=-_DSRT}', "");
    Expect(1, 66639, '\P{^Is_Scx=-_DSRT}', "");
    Expect(0, 66640, '\p{Is_Scx=-_DSRT}', "");
    Expect(1, 66640, '\p{^Is_Scx=-_DSRT}', "");
    Expect(1, 66640, '\P{Is_Scx=-_DSRT}', "");
    Expect(0, 66640, '\P{^Is_Scx=-_DSRT}', "");
    Error('\p{Script_Extensions=__DUPLOYAN/a/}');
    Error('\P{Script_Extensions=__DUPLOYAN/a/}');
    Expect(1, 113827, '\p{Script_Extensions=:\ADuployan\z:}', "");;
    Expect(0, 113828, '\p{Script_Extensions=:\ADuployan\z:}', "");;
    Expect(1, 113827, '\p{Script_Extensions=duployan}', "");
    Expect(0, 113827, '\p{^Script_Extensions=duployan}', "");
    Expect(0, 113827, '\P{Script_Extensions=duployan}', "");
    Expect(1, 113827, '\P{^Script_Extensions=duployan}', "");
    Expect(0, 113828, '\p{Script_Extensions=duployan}', "");
    Expect(1, 113828, '\p{^Script_Extensions=duployan}', "");
    Expect(1, 113828, '\P{Script_Extensions=duployan}', "");
    Expect(0, 113828, '\P{^Script_Extensions=duployan}', "");
    Expect(1, 113827, '\p{Script_Extensions=:\Aduployan\z:}', "");;
    Expect(0, 113828, '\p{Script_Extensions=:\Aduployan\z:}', "");;
    Expect(1, 113827, '\p{Script_Extensions=_Duployan}', "");
    Expect(0, 113827, '\p{^Script_Extensions=_Duployan}', "");
    Expect(0, 113827, '\P{Script_Extensions=_Duployan}', "");
    Expect(1, 113827, '\P{^Script_Extensions=_Duployan}', "");
    Expect(0, 113828, '\p{Script_Extensions=_Duployan}', "");
    Expect(1, 113828, '\p{^Script_Extensions=_Duployan}', "");
    Expect(1, 113828, '\P{Script_Extensions=_Duployan}', "");
    Expect(0, 113828, '\P{^Script_Extensions=_Duployan}', "");
    Error('\p{Scx=Dupl/a/}');
    Error('\P{Scx=Dupl/a/}');
    Expect(1, 113827, '\p{Scx=:\ADupl\z:}', "");;
    Expect(0, 113828, '\p{Scx=:\ADupl\z:}', "");;
    Expect(1, 113827, '\p{Scx=dupl}', "");
    Expect(0, 113827, '\p{^Scx=dupl}', "");
    Expect(0, 113827, '\P{Scx=dupl}', "");
    Expect(1, 113827, '\P{^Scx=dupl}', "");
    Expect(0, 113828, '\p{Scx=dupl}', "");
    Expect(1, 113828, '\p{^Scx=dupl}', "");
    Expect(1, 113828, '\P{Scx=dupl}', "");
    Expect(0, 113828, '\P{^Scx=dupl}', "");
    Expect(1, 113827, '\p{Scx=:\Adupl\z:}', "");;
    Expect(0, 113828, '\p{Scx=:\Adupl\z:}', "");;
    Expect(1, 113827, '\p{Scx=_	dupl}', "");
    Expect(0, 113827, '\p{^Scx=_	dupl}', "");
    Expect(0, 113827, '\P{Scx=_	dupl}', "");
    Expect(1, 113827, '\P{^Scx=_	dupl}', "");
    Expect(0, 113828, '\p{Scx=_	dupl}', "");
    Expect(1, 113828, '\p{^Scx=_	dupl}', "");
    Expect(1, 113828, '\P{Scx=_	dupl}', "");
    Expect(0, 113828, '\P{^Scx=_	dupl}', "");
    Error('\p{Is_Script_Extensions=-/a/Duployan}');
    Error('\P{Is_Script_Extensions=-/a/Duployan}');
    Expect(1, 113827, '\p{Is_Script_Extensions:   duployan}', "");
    Expect(0, 113827, '\p{^Is_Script_Extensions:   duployan}', "");
    Expect(0, 113827, '\P{Is_Script_Extensions:   duployan}', "");
    Expect(1, 113827, '\P{^Is_Script_Extensions:   duployan}', "");
    Expect(0, 113828, '\p{Is_Script_Extensions:   duployan}', "");
    Expect(1, 113828, '\p{^Is_Script_Extensions:   duployan}', "");
    Expect(1, 113828, '\P{Is_Script_Extensions:   duployan}', "");
    Expect(0, 113828, '\P{^Is_Script_Extensions:   duployan}', "");
    Expect(1, 113827, '\p{Is_Script_Extensions=-Duployan}', "");
    Expect(0, 113827, '\p{^Is_Script_Extensions=-Duployan}', "");
    Expect(0, 113827, '\P{Is_Script_Extensions=-Duployan}', "");
    Expect(1, 113827, '\P{^Is_Script_Extensions=-Duployan}', "");
    Expect(0, 113828, '\p{Is_Script_Extensions=-Duployan}', "");
    Expect(1, 113828, '\p{^Is_Script_Extensions=-Duployan}', "");
    Expect(1, 113828, '\P{Is_Script_Extensions=-Duployan}', "");
    Expect(0, 113828, '\P{^Is_Script_Extensions=-Duployan}', "");
    Error('\p{Is_Scx=_:=dupl}');
    Error('\P{Is_Scx=_:=dupl}');
    Expect(1, 113827, '\p{Is_Scx=dupl}', "");
    Expect(0, 113827, '\p{^Is_Scx=dupl}', "");
    Expect(0, 113827, '\P{Is_Scx=dupl}', "");
    Expect(1, 113827, '\P{^Is_Scx=dupl}', "");
    Expect(0, 113828, '\p{Is_Scx=dupl}', "");
    Expect(1, 113828, '\p{^Is_Scx=dupl}', "");
    Expect(1, 113828, '\P{Is_Scx=dupl}', "");
    Expect(0, 113828, '\P{^Is_Scx=dupl}', "");
    Expect(1, 113827, '\p{Is_Scx=--dupl}', "");
    Expect(0, 113827, '\p{^Is_Scx=--dupl}', "");
    Expect(0, 113827, '\P{Is_Scx=--dupl}', "");
    Expect(1, 113827, '\P{^Is_Scx=--dupl}', "");
    Expect(0, 113828, '\p{Is_Scx=--dupl}', "");
    Expect(1, 113828, '\p{^Is_Scx=--dupl}', "");
    Expect(1, 113828, '\P{Is_Scx=--dupl}', "");
    Expect(0, 113828, '\P{^Is_Scx=--dupl}', "");
    Error('\p{Script_Extensions=/a/egyptian_Hieroglyphs}');
    Error('\P{Script_Extensions=/a/egyptian_Hieroglyphs}');
    Expect(1, 78904, '\p{Script_Extensions=:\AEgyptian_Hieroglyphs\z:}', "");;
    Expect(0, 78905, '\p{Script_Extensions=:\AEgyptian_Hieroglyphs\z:}', "");;
    Expect(1, 78904, '\p{Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78904, '\p{^Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78904, '\P{Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78904, '\P{^Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78905, '\p{Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78905, '\p{^Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78905, '\P{Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78905, '\P{^Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78904, '\p{Script_Extensions=:\Aegyptianhieroglyphs\z:}', "");;
    Expect(0, 78905, '\p{Script_Extensions=:\Aegyptianhieroglyphs\z:}', "");;
    Expect(1, 78904, '\p{Script_Extensions=	-egyptian_HIEROGLYPHS}', "");
    Expect(0, 78904, '\p{^Script_Extensions=	-egyptian_HIEROGLYPHS}', "");
    Expect(0, 78904, '\P{Script_Extensions=	-egyptian_HIEROGLYPHS}', "");
    Expect(1, 78904, '\P{^Script_Extensions=	-egyptian_HIEROGLYPHS}', "");
    Expect(0, 78905, '\p{Script_Extensions=	-egyptian_HIEROGLYPHS}', "");
    Expect(1, 78905, '\p{^Script_Extensions=	-egyptian_HIEROGLYPHS}', "");
    Expect(1, 78905, '\P{Script_Extensions=	-egyptian_HIEROGLYPHS}', "");
    Expect(0, 78905, '\P{^Script_Extensions=	-egyptian_HIEROGLYPHS}', "");
    Error('\p{Scx=/a/_	Egyp}');
    Error('\P{Scx=/a/_	Egyp}');
    Expect(1, 78904, '\p{Scx=:\AEgyp\z:}', "");;
    Expect(0, 78905, '\p{Scx=:\AEgyp\z:}', "");;
    Expect(1, 78904, '\p{Scx=egyp}', "");
    Expect(0, 78904, '\p{^Scx=egyp}', "");
    Expect(0, 78904, '\P{Scx=egyp}', "");
    Expect(1, 78904, '\P{^Scx=egyp}', "");
    Expect(0, 78905, '\p{Scx=egyp}', "");
    Expect(1, 78905, '\p{^Scx=egyp}', "");
    Expect(1, 78905, '\P{Scx=egyp}', "");
    Expect(0, 78905, '\P{^Scx=egyp}', "");
    Expect(1, 78904, '\p{Scx=:\Aegyp\z:}', "");;
    Expect(0, 78905, '\p{Scx=:\Aegyp\z:}', "");;
    Expect(1, 78904, '\p{Scx:   -egyp}', "");
    Expect(0, 78904, '\p{^Scx:   -egyp}', "");
    Expect(0, 78904, '\P{Scx:   -egyp}', "");
    Expect(1, 78904, '\P{^Scx:   -egyp}', "");
    Expect(0, 78905, '\p{Scx:   -egyp}', "");
    Expect(1, 78905, '\p{^Scx:   -egyp}', "");
    Expect(1, 78905, '\P{Scx:   -egyp}', "");
    Expect(0, 78905, '\P{^Scx:   -egyp}', "");
    Error('\p{Is_Script_Extensions=/a/--Egyptian_hieroglyphs}');
    Error('\P{Is_Script_Extensions=/a/--Egyptian_hieroglyphs}');
    Expect(1, 78904, '\p{Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78904, '\p{^Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78904, '\P{Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78904, '\P{^Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78905, '\p{Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78905, '\p{^Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78905, '\P{Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(0, 78905, '\P{^Is_Script_Extensions=egyptianhieroglyphs}', "");
    Expect(1, 78904, '\p{Is_Script_Extensions=egyptian_hieroglyphs}', "");
    Expect(0, 78904, '\p{^Is_Script_Extensions=egyptian_hieroglyphs}', "");
    Expect(0, 78904, '\P{Is_Script_Extensions=egyptian_hieroglyphs}', "");
    Expect(1, 78904, '\P{^Is_Script_Extensions=egyptian_hieroglyphs}', "");
    Expect(0, 78905, '\p{Is_Script_Extensions=egyptian_hieroglyphs}', "");
    Expect(1, 78905, '\p{^Is_Script_Extensions=egyptian_hieroglyphs}', "");
    Expect(1, 78905, '\P{Is_Script_Extensions=egyptian_hieroglyphs}', "");
    Expect(0, 78905, '\P{^Is_Script_Extensions=egyptian_hieroglyphs}', "");
    Error('\p{Is_Scx=/a/ EGYP}');
    Error('\P{Is_Scx=/a/ EGYP}');
    Expect(1, 78904, '\p{Is_Scx=egyp}', "");
    Expect(0, 78904, '\p{^Is_Scx=egyp}', "");
    Expect(0, 78904, '\P{Is_Scx=egyp}', "");
    Expect(1, 78904, '\P{^Is_Scx=egyp}', "");
    Expect(0, 78905, '\p{Is_Scx=egyp}', "");
    Expect(1, 78905, '\p{^Is_Scx=egyp}', "");
    Expect(1, 78905, '\P{Is_Scx=egyp}', "");
    Expect(0, 78905, '\P{^Is_Scx=egyp}', "");
    Expect(1, 78904, '\p{Is_Scx= 	Egyp}', "");
    Expect(0, 78904, '\p{^Is_Scx= 	Egyp}', "");
    Expect(0, 78904, '\P{Is_Scx= 	Egyp}', "");
    Expect(1, 78904, '\P{^Is_Scx= 	Egyp}', "");
    Expect(0, 78905, '\p{Is_Scx= 	Egyp}', "");
    Expect(1, 78905, '\p{^Is_Scx= 	Egyp}', "");
    Expect(1, 78905, '\P{Is_Scx= 	Egyp}', "");
    Expect(0, 78905, '\P{^Is_Scx= 	Egyp}', "");
    Error('\p{Script_Extensions=--elbasan/a/}');
    Error('\P{Script_Extensions=--elbasan/a/}');
    Expect(1, 66855, '\p{Script_Extensions=:\AElbasan\z:}', "");;
    Expect(0, 66856, '\p{Script_Extensions=:\AElbasan\z:}', "");;
    Expect(1, 66855, '\p{Script_Extensions=elbasan}', "");
    Expect(0, 66855, '\p{^Script_Extensions=elbasan}', "");
    Expect(0, 66855, '\P{Script_Extensions=elbasan}', "");
    Expect(1, 66855, '\P{^Script_Extensions=elbasan}', "");
    Expect(0, 66856, '\p{Script_Extensions=elbasan}', "");
    Expect(1, 66856, '\p{^Script_Extensions=elbasan}', "");
    Expect(1, 66856, '\P{Script_Extensions=elbasan}', "");
    Expect(0, 66856, '\P{^Script_Extensions=elbasan}', "");
    Expect(1, 66855, '\p{Script_Extensions=:\Aelbasan\z:}', "");;
    Expect(0, 66856, '\p{Script_Extensions=:\Aelbasan\z:}', "");;
    Expect(1, 66855, '\p{Script_Extensions= -Elbasan}', "");
    Expect(0, 66855, '\p{^Script_Extensions= -Elbasan}', "");
    Expect(0, 66855, '\P{Script_Extensions= -Elbasan}', "");
    Expect(1, 66855, '\P{^Script_Extensions= -Elbasan}', "");
    Expect(0, 66856, '\p{Script_Extensions= -Elbasan}', "");
    Expect(1, 66856, '\p{^Script_Extensions= -Elbasan}', "");
    Expect(1, 66856, '\P{Script_Extensions= -Elbasan}', "");
    Expect(0, 66856, '\P{^Script_Extensions= -Elbasan}', "");
    Error('\p{Scx:	:=_ Elba}');
    Error('\P{Scx:	:=_ Elba}');
    Expect(1, 66855, '\p{Scx=:\AElba\z:}', "");;
    Expect(0, 66856, '\p{Scx=:\AElba\z:}', "");;
    Expect(1, 66855, '\p{Scx=elba}', "");
    Expect(0, 66855, '\p{^Scx=elba}', "");
    Expect(0, 66855, '\P{Scx=elba}', "");
    Expect(1, 66855, '\P{^Scx=elba}', "");
    Expect(0, 66856, '\p{Scx=elba}', "");
    Expect(1, 66856, '\p{^Scx=elba}', "");
    Expect(1, 66856, '\P{Scx=elba}', "");
    Expect(0, 66856, '\P{^Scx=elba}', "");
    Expect(1, 66855, '\p{Scx=:\Aelba\z:}', "");;
    Expect(0, 66856, '\p{Scx=:\Aelba\z:}', "");;
    Expect(1, 66855, '\p{Scx=_-ELBA}', "");
    Expect(0, 66855, '\p{^Scx=_-ELBA}', "");
    Expect(0, 66855, '\P{Scx=_-ELBA}', "");
    Expect(1, 66855, '\P{^Scx=_-ELBA}', "");
    Expect(0, 66856, '\p{Scx=_-ELBA}', "");
    Expect(1, 66856, '\p{^Scx=_-ELBA}', "");
    Expect(1, 66856, '\P{Scx=_-ELBA}', "");
    Expect(0, 66856, '\P{^Scx=_-ELBA}', "");
    Error('\p{Is_Script_Extensions= 	Elbasan/a/}');
    Error('\P{Is_Script_Extensions= 	Elbasan/a/}');
    Expect(1, 66855, '\p{Is_Script_Extensions=elbasan}', "");
    Expect(0, 66855, '\p{^Is_Script_Extensions=elbasan}', "");
    Expect(0, 66855, '\P{Is_Script_Extensions=elbasan}', "");
    Expect(1, 66855, '\P{^Is_Script_Extensions=elbasan}', "");
    Expect(0, 66856, '\p{Is_Script_Extensions=elbasan}', "");
    Expect(1, 66856, '\p{^Is_Script_Extensions=elbasan}', "");
    Expect(1, 66856, '\P{Is_Script_Extensions=elbasan}', "");
    Expect(0, 66856, '\P{^Is_Script_Extensions=elbasan}', "");
    Expect(1, 66855, '\p{Is_Script_Extensions=-ELBASAN}', "");
    Expect(0, 66855, '\p{^Is_Script_Extensions=-ELBASAN}', "");
    Expect(0, 66855, '\P{Is_Script_Extensions=-ELBASAN}', "");
    Expect(1, 66855, '\P{^Is_Script_Extensions=-ELBASAN}', "");
    Expect(0, 66856, '\p{Is_Script_Extensions=-ELBASAN}', "");
    Expect(1, 66856, '\p{^Is_Script_Extensions=-ELBASAN}', "");
    Expect(1, 66856, '\P{Is_Script_Extensions=-ELBASAN}', "");
    Expect(0, 66856, '\P{^Is_Script_Extensions=-ELBASAN}', "");
    Error('\p{Is_Scx=  ELBA:=}');
    Error('\P{Is_Scx=  ELBA:=}');
    Expect(1, 66855, '\p{Is_Scx=elba}', "");
    Expect(0, 66855, '\p{^Is_Scx=elba}', "");
    Expect(0, 66855, '\P{Is_Scx=elba}', "");
    Expect(1, 66855, '\P{^Is_Scx=elba}', "");
    Expect(0, 66856, '\p{Is_Scx=elba}', "");
    Expect(1, 66856, '\p{^Is_Scx=elba}', "");
    Expect(1, 66856, '\P{Is_Scx=elba}', "");
    Expect(0, 66856, '\P{^Is_Scx=elba}', "");
    Expect(1, 66855, '\p{Is_Scx=__Elba}', "");
    Expect(0, 66855, '\p{^Is_Scx=__Elba}', "");
    Expect(0, 66855, '\P{Is_Scx=__Elba}', "");
    Expect(1, 66855, '\P{^Is_Scx=__Elba}', "");
    Expect(0, 66856, '\p{Is_Scx=__Elba}', "");
    Expect(1, 66856, '\p{^Is_Scx=__Elba}', "");
    Expect(1, 66856, '\P{Is_Scx=__Elba}', "");
    Expect(0, 66856, '\P{^Is_Scx=__Elba}', "");
    Error('\p{Script_Extensions=	-ELYMAIC/a/}');
    Error('\P{Script_Extensions=	-ELYMAIC/a/}');
    Expect(1, 69622, '\p{Script_Extensions=:\AElymaic\z:}', "");;
    Expect(0, 69623, '\p{Script_Extensions=:\AElymaic\z:}', "");;
    Expect(1, 69622, '\p{Script_Extensions=elymaic}', "");
    Expect(0, 69622, '\p{^Script_Extensions=elymaic}', "");
    Expect(0, 69622, '\P{Script_Extensions=elymaic}', "");
    Expect(1, 69622, '\P{^Script_Extensions=elymaic}', "");
    Expect(0, 69623, '\p{Script_Extensions=elymaic}', "");
    Expect(1, 69623, '\p{^Script_Extensions=elymaic}', "");
    Expect(1, 69623, '\P{Script_Extensions=elymaic}', "");
    Expect(0, 69623, '\P{^Script_Extensions=elymaic}', "");
    Expect(1, 69622, '\p{Script_Extensions=:\Aelymaic\z:}', "");;
    Expect(0, 69623, '\p{Script_Extensions=:\Aelymaic\z:}', "");;
    Expect(1, 69622, '\p{Script_Extensions= -ELYMAIC}', "");
    Expect(0, 69622, '\p{^Script_Extensions= -ELYMAIC}', "");
    Expect(0, 69622, '\P{Script_Extensions= -ELYMAIC}', "");
    Expect(1, 69622, '\P{^Script_Extensions= -ELYMAIC}', "");
    Expect(0, 69623, '\p{Script_Extensions= -ELYMAIC}', "");
    Expect(1, 69623, '\p{^Script_Extensions= -ELYMAIC}', "");
    Expect(1, 69623, '\P{Script_Extensions= -ELYMAIC}', "");
    Expect(0, 69623, '\P{^Script_Extensions= -ELYMAIC}', "");
    Error('\p{Scx=_-Elym:=}');
    Error('\P{Scx=_-Elym:=}');
    Expect(1, 69622, '\p{Scx=:\AElym\z:}', "");;
    Expect(0, 69623, '\p{Scx=:\AElym\z:}', "");;
    Expect(1, 69622, '\p{Scx=elym}', "");
    Expect(0, 69622, '\p{^Scx=elym}', "");
    Expect(0, 69622, '\P{Scx=elym}', "");
    Expect(1, 69622, '\P{^Scx=elym}', "");
    Expect(0, 69623, '\p{Scx=elym}', "");
    Expect(1, 69623, '\p{^Scx=elym}', "");
    Expect(1, 69623, '\P{Scx=elym}', "");
    Expect(0, 69623, '\P{^Scx=elym}', "");
    Expect(1, 69622, '\p{Scx=:\Aelym\z:}', "");;
    Expect(0, 69623, '\p{Scx=:\Aelym\z:}', "");;
    Expect(1, 69622, '\p{Scx=		elym}', "");
    Expect(0, 69622, '\p{^Scx=		elym}', "");
    Expect(0, 69622, '\P{Scx=		elym}', "");
    Expect(1, 69622, '\P{^Scx=		elym}', "");
    Expect(0, 69623, '\p{Scx=		elym}', "");
    Expect(1, 69623, '\p{^Scx=		elym}', "");
    Expect(1, 69623, '\P{Scx=		elym}', "");
    Expect(0, 69623, '\P{^Scx=		elym}', "");
    Error('\p{Is_Script_Extensions=/a/_ELYMAIC}');
    Error('\P{Is_Script_Extensions=/a/_ELYMAIC}');
    Expect(1, 69622, '\p{Is_Script_Extensions=elymaic}', "");
    Expect(0, 69622, '\p{^Is_Script_Extensions=elymaic}', "");
    Expect(0, 69622, '\P{Is_Script_Extensions=elymaic}', "");
    Expect(1, 69622, '\P{^Is_Script_Extensions=elymaic}', "");
    Expect(0, 69623, '\p{Is_Script_Extensions=elymaic}', "");
    Expect(1, 69623, '\p{^Is_Script_Extensions=elymaic}', "");
    Expect(1, 69623, '\P{Is_Script_Extensions=elymaic}', "");
    Expect(0, 69623, '\P{^Is_Script_Extensions=elymaic}', "");
    Expect(1, 69622, '\p{Is_Script_Extensions=	 Elymaic}', "");
    Expect(0, 69622, '\p{^Is_Script_Extensions=	 Elymaic}', "");
    Expect(0, 69622, '\P{Is_Script_Extensions=	 Elymaic}', "");
    Expect(1, 69622, '\P{^Is_Script_Extensions=	 Elymaic}', "");
    Expect(0, 69623, '\p{Is_Script_Extensions=	 Elymaic}', "");
    Expect(1, 69623, '\p{^Is_Script_Extensions=	 Elymaic}', "");
    Expect(1, 69623, '\P{Is_Script_Extensions=	 Elymaic}', "");
    Expect(0, 69623, '\P{^Is_Script_Extensions=	 Elymaic}', "");
    Error('\p{Is_Scx= 	Elym:=}');
    Error('\P{Is_Scx= 	Elym:=}');
    Expect(1, 69622, '\p{Is_Scx=elym}', "");
    Expect(0, 69622, '\p{^Is_Scx=elym}', "");
    Expect(0, 69622, '\P{Is_Scx=elym}', "");
    Expect(1, 69622, '\P{^Is_Scx=elym}', "");
    Expect(0, 69623, '\p{Is_Scx=elym}', "");
    Expect(1, 69623, '\p{^Is_Scx=elym}', "");
    Expect(1, 69623, '\P{Is_Scx=elym}', "");
    Expect(0, 69623, '\P{^Is_Scx=elym}', "");
    Expect(1, 69622, '\p{Is_Scx=--ELYM}', "");
    Expect(0, 69622, '\p{^Is_Scx=--ELYM}', "");
    Expect(0, 69622, '\P{Is_Scx=--ELYM}', "");
    Expect(1, 69622, '\P{^Is_Scx=--ELYM}', "");
    Expect(0, 69623, '\p{Is_Scx=--ELYM}', "");
    Expect(1, 69623, '\p{^Is_Scx=--ELYM}', "");
    Expect(1, 69623, '\P{Is_Scx=--ELYM}', "");
    Expect(0, 69623, '\P{^Is_Scx=--ELYM}', "");
    Error('\p{Script_Extensions=:=--Ethiopic}');
    Error('\P{Script_Extensions=:=--Ethiopic}');
    Expect(1, 43822, '\p{Script_Extensions=:\AEthiopic\z:}', "");;
    Expect(0, 43823, '\p{Script_Extensions=:\AEthiopic\z:}', "");;
    Expect(1, 43822, '\p{Script_Extensions=ethiopic}', "");
    Expect(0, 43822, '\p{^Script_Extensions=ethiopic}', "");
    Expect(0, 43822, '\P{Script_Extensions=ethiopic}', "");
    Expect(1, 43822, '\P{^Script_Extensions=ethiopic}', "");
    Expect(0, 43823, '\p{Script_Extensions=ethiopic}', "");
    Expect(1, 43823, '\p{^Script_Extensions=ethiopic}', "");
    Expect(1, 43823, '\P{Script_Extensions=ethiopic}', "");
    Expect(0, 43823, '\P{^Script_Extensions=ethiopic}', "");
    Expect(1, 43822, '\p{Script_Extensions=:\Aethiopic\z:}', "");;
    Expect(0, 43823, '\p{Script_Extensions=:\Aethiopic\z:}', "");;
    Expect(1, 43822, '\p{Script_Extensions= _ETHIOPIC}', "");
    Expect(0, 43822, '\p{^Script_Extensions= _ETHIOPIC}', "");
    Expect(0, 43822, '\P{Script_Extensions= _ETHIOPIC}', "");
    Expect(1, 43822, '\P{^Script_Extensions= _ETHIOPIC}', "");
    Expect(0, 43823, '\p{Script_Extensions= _ETHIOPIC}', "");
    Expect(1, 43823, '\p{^Script_Extensions= _ETHIOPIC}', "");
    Expect(1, 43823, '\P{Script_Extensions= _ETHIOPIC}', "");
    Expect(0, 43823, '\P{^Script_Extensions= _ETHIOPIC}', "");
    Error('\p{Scx=/a/ 	ethi}');
    Error('\P{Scx=/a/ 	ethi}');
    Expect(1, 43822, '\p{Scx=:\AEthi\z:}', "");;
    Expect(0, 43823, '\p{Scx=:\AEthi\z:}', "");;
    Expect(1, 43822, '\p{Scx=ethi}', "");
    Expect(0, 43822, '\p{^Scx=ethi}', "");
    Expect(0, 43822, '\P{Scx=ethi}', "");
    Expect(1, 43822, '\P{^Scx=ethi}', "");
    Expect(0, 43823, '\p{Scx=ethi}', "");
    Expect(1, 43823, '\p{^Scx=ethi}', "");
    Expect(1, 43823, '\P{Scx=ethi}', "");
    Expect(0, 43823, '\P{^Scx=ethi}', "");
    Expect(1, 43822, '\p{Scx=:\Aethi\z:}', "");;
    Expect(0, 43823, '\p{Scx=:\Aethi\z:}', "");;
    Expect(1, 43822, '\p{Scx=Ethi}', "");
    Expect(0, 43822, '\p{^Scx=Ethi}', "");
    Expect(0, 43822, '\P{Scx=Ethi}', "");
    Expect(1, 43822, '\P{^Scx=Ethi}', "");
    Expect(0, 43823, '\p{Scx=Ethi}', "");
    Expect(1, 43823, '\p{^Scx=Ethi}', "");
    Expect(1, 43823, '\P{Scx=Ethi}', "");
    Expect(0, 43823, '\P{^Scx=Ethi}', "");
    Error('\p{Is_Script_Extensions=/a/	Ethiopic}');
    Error('\P{Is_Script_Extensions=/a/	Ethiopic}');
    Expect(1, 43822, '\p{Is_Script_Extensions=ethiopic}', "");
    Expect(0, 43822, '\p{^Is_Script_Extensions=ethiopic}', "");
    Expect(0, 43822, '\P{Is_Script_Extensions=ethiopic}', "");
    Expect(1, 43822, '\P{^Is_Script_Extensions=ethiopic}', "");
    Expect(0, 43823, '\p{Is_Script_Extensions=ethiopic}', "");
    Expect(1, 43823, '\p{^Is_Script_Extensions=ethiopic}', "");
    Expect(1, 43823, '\P{Is_Script_Extensions=ethiopic}', "");
    Expect(0, 43823, '\P{^Is_Script_Extensions=ethiopic}', "");
    Expect(1, 43822, '\p{Is_Script_Extensions=_Ethiopic}', "");
    Expect(0, 43822, '\p{^Is_Script_Extensions=_Ethiopic}', "");
    Expect(0, 43822, '\P{Is_Script_Extensions=_Ethiopic}', "");
    Expect(1, 43822, '\P{^Is_Script_Extensions=_Ethiopic}', "");
    Expect(0, 43823, '\p{Is_Script_Extensions=_Ethiopic}', "");
    Expect(1, 43823, '\p{^Is_Script_Extensions=_Ethiopic}', "");
    Expect(1, 43823, '\P{Is_Script_Extensions=_Ethiopic}', "");
    Expect(0, 43823, '\P{^Is_Script_Extensions=_Ethiopic}', "");
    Error('\p{Is_Scx:	-/a/ETHI}');
    Error('\P{Is_Scx:	-/a/ETHI}');
    Expect(1, 43822, '\p{Is_Scx=ethi}', "");
    Expect(0, 43822, '\p{^Is_Scx=ethi}', "");
    Expect(0, 43822, '\P{Is_Scx=ethi}', "");
    Expect(1, 43822, '\P{^Is_Scx=ethi}', "");
    Expect(0, 43823, '\p{Is_Scx=ethi}', "");
    Expect(1, 43823, '\p{^Is_Scx=ethi}', "");
    Expect(1, 43823, '\P{Is_Scx=ethi}', "");
    Expect(0, 43823, '\P{^Is_Scx=ethi}', "");
    Expect(1, 43822, '\p{Is_Scx=	 ethi}', "");
    Expect(0, 43822, '\p{^Is_Scx=	 ethi}', "");
    Expect(0, 43822, '\P{Is_Scx=	 ethi}', "");
    Expect(1, 43822, '\P{^Is_Scx=	 ethi}', "");
    Expect(0, 43823, '\p{Is_Scx=	 ethi}', "");
    Expect(1, 43823, '\p{^Is_Scx=	 ethi}', "");
    Expect(1, 43823, '\P{Is_Scx=	 ethi}', "");
    Expect(0, 43823, '\P{^Is_Scx=	 ethi}', "");
    Error('\p{Script_Extensions=-:=Georgian}');
    Error('\P{Script_Extensions=-:=Georgian}');
    Expect(1, 11565, '\p{Script_Extensions=:\AGeorgian\z:}', "");;
    Expect(0, 11566, '\p{Script_Extensions=:\AGeorgian\z:}', "");;
    Expect(1, 11565, '\p{Script_Extensions=georgian}', "");
    Expect(0, 11565, '\p{^Script_Extensions=georgian}', "");
    Expect(0, 11565, '\P{Script_Extensions=georgian}', "");
    Expect(1, 11565, '\P{^Script_Extensions=georgian}', "");
    Expect(0, 11566, '\p{Script_Extensions=georgian}', "");
    Expect(1, 11566, '\p{^Script_Extensions=georgian}', "");
    Expect(1, 11566, '\P{Script_Extensions=georgian}', "");
    Expect(0, 11566, '\P{^Script_Extensions=georgian}', "");
    Expect(1, 11565, '\p{Script_Extensions=:\Ageorgian\z:}', "");;
    Expect(0, 11566, '\p{Script_Extensions=:\Ageorgian\z:}', "");;
    Expect(1, 11565, '\p{Script_Extensions=-GEORGIAN}', "");
    Expect(0, 11565, '\p{^Script_Extensions=-GEORGIAN}', "");
    Expect(0, 11565, '\P{Script_Extensions=-GEORGIAN}', "");
    Expect(1, 11565, '\P{^Script_Extensions=-GEORGIAN}', "");
    Expect(0, 11566, '\p{Script_Extensions=-GEORGIAN}', "");
    Expect(1, 11566, '\p{^Script_Extensions=-GEORGIAN}', "");
    Expect(1, 11566, '\P{Script_Extensions=-GEORGIAN}', "");
    Expect(0, 11566, '\P{^Script_Extensions=-GEORGIAN}', "");
    Error('\p{Scx=	_GEOR:=}');
    Error('\P{Scx=	_GEOR:=}');
    Expect(1, 11565, '\p{Scx=:\AGeor\z:}', "");;
    Expect(0, 11566, '\p{Scx=:\AGeor\z:}', "");;
    Expect(1, 11565, '\p{Scx=geor}', "");
    Expect(0, 11565, '\p{^Scx=geor}', "");
    Expect(0, 11565, '\P{Scx=geor}', "");
    Expect(1, 11565, '\P{^Scx=geor}', "");
    Expect(0, 11566, '\p{Scx=geor}', "");
    Expect(1, 11566, '\p{^Scx=geor}', "");
    Expect(1, 11566, '\P{Scx=geor}', "");
    Expect(0, 11566, '\P{^Scx=geor}', "");
    Expect(1, 11565, '\p{Scx=:\Ageor\z:}', "");;
    Expect(0, 11566, '\p{Scx=:\Ageor\z:}', "");;
    Expect(1, 11565, '\p{Scx=_Geor}', "");
    Expect(0, 11565, '\p{^Scx=_Geor}', "");
    Expect(0, 11565, '\P{Scx=_Geor}', "");
    Expect(1, 11565, '\P{^Scx=_Geor}', "");
    Expect(0, 11566, '\p{Scx=_Geor}', "");
    Expect(1, 11566, '\p{^Scx=_Geor}', "");
    Expect(1, 11566, '\P{Scx=_Geor}', "");
    Expect(0, 11566, '\P{^Scx=_Geor}', "");
    Error('\p{Is_Script_Extensions=/a/--georgian}');
    Error('\P{Is_Script_Extensions=/a/--georgian}');
    Expect(1, 11565, '\p{Is_Script_Extensions=georgian}', "");
    Expect(0, 11565, '\p{^Is_Script_Extensions=georgian}', "");
    Expect(0, 11565, '\P{Is_Script_Extensions=georgian}', "");
    Expect(1, 11565, '\P{^Is_Script_Extensions=georgian}', "");
    Expect(0, 11566, '\p{Is_Script_Extensions=georgian}', "");
    Expect(1, 11566, '\p{^Is_Script_Extensions=georgian}', "");
    Expect(1, 11566, '\P{Is_Script_Extensions=georgian}', "");
    Expect(0, 11566, '\P{^Is_Script_Extensions=georgian}', "");
    Expect(1, 11565, '\p{Is_Script_Extensions=  Georgian}', "");
    Expect(0, 11565, '\p{^Is_Script_Extensions=  Georgian}', "");
    Expect(0, 11565, '\P{Is_Script_Extensions=  Georgian}', "");
    Expect(1, 11565, '\P{^Is_Script_Extensions=  Georgian}', "");
    Expect(0, 11566, '\p{Is_Script_Extensions=  Georgian}', "");
    Expect(1, 11566, '\p{^Is_Script_Extensions=  Georgian}', "");
    Expect(1, 11566, '\P{Is_Script_Extensions=  Georgian}', "");
    Expect(0, 11566, '\P{^Is_Script_Extensions=  Georgian}', "");
    Error('\p{Is_Scx=_geor:=}');
    Error('\P{Is_Scx=_geor:=}');
    Expect(1, 11565, '\p{Is_Scx=geor}', "");
    Expect(0, 11565, '\p{^Is_Scx=geor}', "");
    Expect(0, 11565, '\P{Is_Scx=geor}', "");
    Expect(1, 11565, '\P{^Is_Scx=geor}', "");
    Expect(0, 11566, '\p{Is_Scx=geor}', "");
    Expect(1, 11566, '\p{^Is_Scx=geor}', "");
    Expect(1, 11566, '\P{Is_Scx=geor}', "");
    Expect(0, 11566, '\P{^Is_Scx=geor}', "");
    Expect(1, 11565, '\p{Is_Scx:	_	Geor}', "");
    Expect(0, 11565, '\p{^Is_Scx:	_	Geor}', "");
    Expect(0, 11565, '\P{Is_Scx:	_	Geor}', "");
    Expect(1, 11565, '\P{^Is_Scx:	_	Geor}', "");
    Expect(0, 11566, '\p{Is_Scx:	_	Geor}', "");
    Expect(1, 11566, '\p{^Is_Scx:	_	Geor}', "");
    Expect(1, 11566, '\P{Is_Scx:	_	Geor}', "");
    Expect(0, 11566, '\P{^Is_Scx:	_	Geor}', "");
    Error('\p{Script_Extensions: --glagolitic/a/}');
    Error('\P{Script_Extensions: --glagolitic/a/}');
    Expect(1, 122922, '\p{Script_Extensions=:\AGlagolitic\z:}', "");;
    Expect(0, 122923, '\p{Script_Extensions=:\AGlagolitic\z:}', "");;
    Expect(1, 122922, '\p{Script_Extensions=glagolitic}', "");
    Expect(0, 122922, '\p{^Script_Extensions=glagolitic}', "");
    Expect(0, 122922, '\P{Script_Extensions=glagolitic}', "");
    Expect(1, 122922, '\P{^Script_Extensions=glagolitic}', "");
    Expect(0, 122923, '\p{Script_Extensions=glagolitic}', "");
    Expect(1, 122923, '\p{^Script_Extensions=glagolitic}', "");
    Expect(1, 122923, '\P{Script_Extensions=glagolitic}', "");
    Expect(0, 122923, '\P{^Script_Extensions=glagolitic}', "");
    Expect(1, 122922, '\p{Script_Extensions=:\Aglagolitic\z:}', "");;
    Expect(0, 122923, '\p{Script_Extensions=:\Aglagolitic\z:}', "");;
    Expect(1, 122922, '\p{Script_Extensions= GLAGOLITIC}', "");
    Expect(0, 122922, '\p{^Script_Extensions= GLAGOLITIC}', "");
    Expect(0, 122922, '\P{Script_Extensions= GLAGOLITIC}', "");
    Expect(1, 122922, '\P{^Script_Extensions= GLAGOLITIC}', "");
    Expect(0, 122923, '\p{Script_Extensions= GLAGOLITIC}', "");
    Expect(1, 122923, '\p{^Script_Extensions= GLAGOLITIC}', "");
    Expect(1, 122923, '\P{Script_Extensions= GLAGOLITIC}', "");
    Expect(0, 122923, '\P{^Script_Extensions= GLAGOLITIC}', "");
    Error('\p{Scx=_-glag:=}');
    Error('\P{Scx=_-glag:=}');
    Expect(1, 122922, '\p{Scx=:\AGlag\z:}', "");;
    Expect(0, 122923, '\p{Scx=:\AGlag\z:}', "");;
    Expect(1, 122922, '\p{Scx=glag}', "");
    Expect(0, 122922, '\p{^Scx=glag}', "");
    Expect(0, 122922, '\P{Scx=glag}', "");
    Expect(1, 122922, '\P{^Scx=glag}', "");
    Expect(0, 122923, '\p{Scx=glag}', "");
    Expect(1, 122923, '\p{^Scx=glag}', "");
    Expect(1, 122923, '\P{Scx=glag}', "");
    Expect(0, 122923, '\P{^Scx=glag}', "");
    Expect(1, 122922, '\p{Scx=:\Aglag\z:}', "");;
    Expect(0, 122923, '\p{Scx=:\Aglag\z:}', "");;
    Expect(1, 122922, '\p{Scx=_	GLAG}', "");
    Expect(0, 122922, '\p{^Scx=_	GLAG}', "");
    Expect(0, 122922, '\P{Scx=_	GLAG}', "");
    Expect(1, 122922, '\P{^Scx=_	GLAG}', "");
    Expect(0, 122923, '\p{Scx=_	GLAG}', "");
    Expect(1, 122923, '\p{^Scx=_	GLAG}', "");
    Expect(1, 122923, '\P{Scx=_	GLAG}', "");
    Expect(0, 122923, '\P{^Scx=_	GLAG}', "");
    Error('\p{Is_Script_Extensions:--Glagolitic/a/}');
    Error('\P{Is_Script_Extensions:--Glagolitic/a/}');
    Expect(1, 122922, '\p{Is_Script_Extensions=glagolitic}', "");
    Expect(0, 122922, '\p{^Is_Script_Extensions=glagolitic}', "");
    Expect(0, 122922, '\P{Is_Script_Extensions=glagolitic}', "");
    Expect(1, 122922, '\P{^Is_Script_Extensions=glagolitic}', "");
    Expect(0, 122923, '\p{Is_Script_Extensions=glagolitic}', "");
    Expect(1, 122923, '\p{^Is_Script_Extensions=glagolitic}', "");
    Expect(1, 122923, '\P{Is_Script_Extensions=glagolitic}', "");
    Expect(0, 122923, '\P{^Is_Script_Extensions=glagolitic}', "");
    Expect(1, 122922, '\p{Is_Script_Extensions=__glagolitic}', "");
    Expect(0, 122922, '\p{^Is_Script_Extensions=__glagolitic}', "");
    Expect(0, 122922, '\P{Is_Script_Extensions=__glagolitic}', "");
    Expect(1, 122922, '\P{^Is_Script_Extensions=__glagolitic}', "");
    Expect(0, 122923, '\p{Is_Script_Extensions=__glagolitic}', "");
    Expect(1, 122923, '\p{^Is_Script_Extensions=__glagolitic}', "");
    Expect(1, 122923, '\P{Is_Script_Extensions=__glagolitic}', "");
    Expect(0, 122923, '\P{^Is_Script_Extensions=__glagolitic}', "");
    Error('\p{Is_Scx=_:=glag}');
    Error('\P{Is_Scx=_:=glag}');
    Expect(1, 122922, '\p{Is_Scx=glag}', "");
    Expect(0, 122922, '\p{^Is_Scx=glag}', "");
    Expect(0, 122922, '\P{Is_Scx=glag}', "");
    Expect(1, 122922, '\P{^Is_Scx=glag}', "");
    Expect(0, 122923, '\p{Is_Scx=glag}', "");
    Expect(1, 122923, '\p{^Is_Scx=glag}', "");
    Expect(1, 122923, '\P{Is_Scx=glag}', "");
    Expect(0, 122923, '\P{^Is_Scx=glag}', "");
    Expect(1, 122922, '\p{Is_Scx= Glag}', "");
    Expect(0, 122922, '\p{^Is_Scx= Glag}', "");
    Expect(0, 122922, '\P{Is_Scx= Glag}', "");
    Expect(1, 122922, '\P{^Is_Scx= Glag}', "");
    Expect(0, 122923, '\p{Is_Scx= Glag}', "");
    Expect(1, 122923, '\p{^Is_Scx= Glag}', "");
    Expect(1, 122923, '\P{Is_Scx= Glag}', "");
    Expect(0, 122923, '\P{^Is_Scx= Glag}', "");
    Error('\p{Script_Extensions=/a/ _Gunjala_Gondi}');
    Error('\P{Script_Extensions=/a/ _Gunjala_Gondi}');
    Expect(1, 73129, '\p{Script_Extensions=:\AGunjala_Gondi\z:}', "");;
    Expect(0, 73130, '\p{Script_Extensions=:\AGunjala_Gondi\z:}', "");;
    Expect(1, 73129, '\p{Script_Extensions=gunjalagondi}', "");
    Expect(0, 73129, '\p{^Script_Extensions=gunjalagondi}', "");
    Expect(0, 73129, '\P{Script_Extensions=gunjalagondi}', "");
    Expect(1, 73129, '\P{^Script_Extensions=gunjalagondi}', "");
    Expect(0, 73130, '\p{Script_Extensions=gunjalagondi}', "");
    Expect(1, 73130, '\p{^Script_Extensions=gunjalagondi}', "");
    Expect(1, 73130, '\P{Script_Extensions=gunjalagondi}', "");
    Expect(0, 73130, '\P{^Script_Extensions=gunjalagondi}', "");
    Expect(1, 73129, '\p{Script_Extensions=:\Agunjalagondi\z:}', "");;
    Expect(0, 73130, '\p{Script_Extensions=:\Agunjalagondi\z:}', "");;
    Expect(1, 73129, '\p{Script_Extensions= GUNJALA_gondi}', "");
    Expect(0, 73129, '\p{^Script_Extensions= GUNJALA_gondi}', "");
    Expect(0, 73129, '\P{Script_Extensions= GUNJALA_gondi}', "");
    Expect(1, 73129, '\P{^Script_Extensions= GUNJALA_gondi}', "");
    Expect(0, 73130, '\p{Script_Extensions= GUNJALA_gondi}', "");
    Expect(1, 73130, '\p{^Script_Extensions= GUNJALA_gondi}', "");
    Expect(1, 73130, '\P{Script_Extensions= GUNJALA_gondi}', "");
    Expect(0, 73130, '\P{^Script_Extensions= GUNJALA_gondi}', "");
    Error('\p{Scx=	/a/GONG}');
    Error('\P{Scx=	/a/GONG}');
    Expect(1, 73129, '\p{Scx=:\AGong\z:}', "");;
    Expect(0, 73130, '\p{Scx=:\AGong\z:}', "");;
    Expect(1, 73129, '\p{Scx:	gong}', "");
    Expect(0, 73129, '\p{^Scx:	gong}', "");
    Expect(0, 73129, '\P{Scx:	gong}', "");
    Expect(1, 73129, '\P{^Scx:	gong}', "");
    Expect(0, 73130, '\p{Scx:	gong}', "");
    Expect(1, 73130, '\p{^Scx:	gong}', "");
    Expect(1, 73130, '\P{Scx:	gong}', "");
    Expect(0, 73130, '\P{^Scx:	gong}', "");
    Expect(1, 73129, '\p{Scx=:\Agong\z:}', "");;
    Expect(0, 73130, '\p{Scx=:\Agong\z:}', "");;
    Expect(1, 73129, '\p{Scx= 	GONG}', "");
    Expect(0, 73129, '\p{^Scx= 	GONG}', "");
    Expect(0, 73129, '\P{Scx= 	GONG}', "");
    Expect(1, 73129, '\P{^Scx= 	GONG}', "");
    Expect(0, 73130, '\p{Scx= 	GONG}', "");
    Expect(1, 73130, '\p{^Scx= 	GONG}', "");
    Expect(1, 73130, '\P{Scx= 	GONG}', "");
    Expect(0, 73130, '\P{^Scx= 	GONG}', "");
    Error('\p{Is_Script_Extensions=_ Gunjala_Gondi:=}');
    Error('\P{Is_Script_Extensions=_ Gunjala_Gondi:=}');
    Expect(1, 73129, '\p{Is_Script_Extensions=gunjalagondi}', "");
    Expect(0, 73129, '\p{^Is_Script_Extensions=gunjalagondi}', "");
    Expect(0, 73129, '\P{Is_Script_Extensions=gunjalagondi}', "");
    Expect(1, 73129, '\P{^Is_Script_Extensions=gunjalagondi}', "");
    Expect(0, 73130, '\p{Is_Script_Extensions=gunjalagondi}', "");
    Expect(1, 73130, '\p{^Is_Script_Extensions=gunjalagondi}', "");
    Expect(1, 73130, '\P{Is_Script_Extensions=gunjalagondi}', "");
    Expect(0, 73130, '\P{^Is_Script_Extensions=gunjalagondi}', "");
    Expect(1, 73129, '\p{Is_Script_Extensions=-_Gunjala_Gondi}', "");
    Expect(0, 73129, '\p{^Is_Script_Extensions=-_Gunjala_Gondi}', "");
    Expect(0, 73129, '\P{Is_Script_Extensions=-_Gunjala_Gondi}', "");
    Expect(1, 73129, '\P{^Is_Script_Extensions=-_Gunjala_Gondi}', "");
    Expect(0, 73130, '\p{Is_Script_Extensions=-_Gunjala_Gondi}', "");
    Expect(1, 73130, '\p{^Is_Script_Extensions=-_Gunjala_Gondi}', "");
    Expect(1, 73130, '\P{Is_Script_Extensions=-_Gunjala_Gondi}', "");
    Expect(0, 73130, '\P{^Is_Script_Extensions=-_Gunjala_Gondi}', "");
    Error('\p{Is_Scx=/a/ 	gong}');
    Error('\P{Is_Scx=/a/ 	gong}');
    Expect(1, 73129, '\p{Is_Scx: gong}', "");
    Expect(0, 73129, '\p{^Is_Scx: gong}', "");
    Expect(0, 73129, '\P{Is_Scx: gong}', "");
    Expect(1, 73129, '\P{^Is_Scx: gong}', "");
    Expect(0, 73130, '\p{Is_Scx: gong}', "");
    Expect(1, 73130, '\p{^Is_Scx: gong}', "");
    Expect(1, 73130, '\P{Is_Scx: gong}', "");
    Expect(0, 73130, '\P{^Is_Scx: gong}', "");
    Expect(1, 73129, '\p{Is_Scx=-	gong}', "");
    Expect(0, 73129, '\p{^Is_Scx=-	gong}', "");
    Expect(0, 73129, '\P{Is_Scx=-	gong}', "");
    Expect(1, 73129, '\P{^Is_Scx=-	gong}', "");
    Expect(0, 73130, '\p{Is_Scx=-	gong}', "");
    Expect(1, 73130, '\p{^Is_Scx=-	gong}', "");
    Expect(1, 73130, '\P{Is_Scx=-	gong}', "");
    Expect(0, 73130, '\P{^Is_Scx=-	gong}', "");
    Error('\p{Script_Extensions=_/a/masaram_gondi}');
    Error('\P{Script_Extensions=_/a/masaram_gondi}');
    Expect(1, 73049, '\p{Script_Extensions=:\AMasaram_Gondi\z:}', "");;
    Expect(0, 73050, '\p{Script_Extensions=:\AMasaram_Gondi\z:}', "");;
    Expect(1, 73049, '\p{Script_Extensions=masaramgondi}', "");
    Expect(0, 73049, '\p{^Script_Extensions=masaramgondi}', "");
    Expect(0, 73049, '\P{Script_Extensions=masaramgondi}', "");
    Expect(1, 73049, '\P{^Script_Extensions=masaramgondi}', "");
    Expect(0, 73050, '\p{Script_Extensions=masaramgondi}', "");
    Expect(1, 73050, '\p{^Script_Extensions=masaramgondi}', "");
    Expect(1, 73050, '\P{Script_Extensions=masaramgondi}', "");
    Expect(0, 73050, '\P{^Script_Extensions=masaramgondi}', "");
    Expect(1, 73049, '\p{Script_Extensions=:\Amasaramgondi\z:}', "");;
    Expect(0, 73050, '\p{Script_Extensions=:\Amasaramgondi\z:}', "");;
    Expect(1, 73049, '\p{Script_Extensions=-_Masaram_GONDI}', "");
    Expect(0, 73049, '\p{^Script_Extensions=-_Masaram_GONDI}', "");
    Expect(0, 73049, '\P{Script_Extensions=-_Masaram_GONDI}', "");
    Expect(1, 73049, '\P{^Script_Extensions=-_Masaram_GONDI}', "");
    Expect(0, 73050, '\p{Script_Extensions=-_Masaram_GONDI}', "");
    Expect(1, 73050, '\p{^Script_Extensions=-_Masaram_GONDI}', "");
    Expect(1, 73050, '\P{Script_Extensions=-_Masaram_GONDI}', "");
    Expect(0, 73050, '\P{^Script_Extensions=-_Masaram_GONDI}', "");
    Error('\p{Scx=/a/	 GONM}');
    Error('\P{Scx=/a/	 GONM}');
    Expect(1, 73049, '\p{Scx=:\AGonm\z:}', "");;
    Expect(0, 73050, '\p{Scx=:\AGonm\z:}', "");;
    Expect(1, 73049, '\p{Scx=gonm}', "");
    Expect(0, 73049, '\p{^Scx=gonm}', "");
    Expect(0, 73049, '\P{Scx=gonm}', "");
    Expect(1, 73049, '\P{^Scx=gonm}', "");
    Expect(0, 73050, '\p{Scx=gonm}', "");
    Expect(1, 73050, '\p{^Scx=gonm}', "");
    Expect(1, 73050, '\P{Scx=gonm}', "");
    Expect(0, 73050, '\P{^Scx=gonm}', "");
    Expect(1, 73049, '\p{Scx=:\Agonm\z:}', "");;
    Expect(0, 73050, '\p{Scx=:\Agonm\z:}', "");;
    Expect(1, 73049, '\p{Scx=-Gonm}', "");
    Expect(0, 73049, '\p{^Scx=-Gonm}', "");
    Expect(0, 73049, '\P{Scx=-Gonm}', "");
    Expect(1, 73049, '\P{^Scx=-Gonm}', "");
    Expect(0, 73050, '\p{Scx=-Gonm}', "");
    Expect(1, 73050, '\p{^Scx=-Gonm}', "");
    Expect(1, 73050, '\P{Scx=-Gonm}', "");
    Expect(0, 73050, '\P{^Scx=-Gonm}', "");
    Error('\p{Is_Script_Extensions=/a/-Masaram_gondi}');
    Error('\P{Is_Script_Extensions=/a/-Masaram_gondi}');
    Expect(1, 73049, '\p{Is_Script_Extensions=masaramgondi}', "");
    Expect(0, 73049, '\p{^Is_Script_Extensions=masaramgondi}', "");
    Expect(0, 73049, '\P{Is_Script_Extensions=masaramgondi}', "");
    Expect(1, 73049, '\P{^Is_Script_Extensions=masaramgondi}', "");
    Expect(0, 73050, '\p{Is_Script_Extensions=masaramgondi}', "");
    Expect(1, 73050, '\p{^Is_Script_Extensions=masaramgondi}', "");
    Expect(1, 73050, '\P{Is_Script_Extensions=masaramgondi}', "");
    Expect(0, 73050, '\P{^Is_Script_Extensions=masaramgondi}', "");
    Expect(1, 73049, '\p{Is_Script_Extensions=-Masaram_Gondi}', "");
    Expect(0, 73049, '\p{^Is_Script_Extensions=-Masaram_Gondi}', "");
    Expect(0, 73049, '\P{Is_Script_Extensions=-Masaram_Gondi}', "");
    Expect(1, 73049, '\P{^Is_Script_Extensions=-Masaram_Gondi}', "");
    Expect(0, 73050, '\p{Is_Script_Extensions=-Masaram_Gondi}', "");
    Expect(1, 73050, '\p{^Is_Script_Extensions=-Masaram_Gondi}', "");
    Expect(1, 73050, '\P{Is_Script_Extensions=-Masaram_Gondi}', "");
    Expect(0, 73050, '\P{^Is_Script_Extensions=-Masaram_Gondi}', "");
    Error('\p{Is_Scx=/a/_-gonm}');
    Error('\P{Is_Scx=/a/_-gonm}');
    Expect(1, 73049, '\p{Is_Scx=gonm}', "");
    Expect(0, 73049, '\p{^Is_Scx=gonm}', "");
    Expect(0, 73049, '\P{Is_Scx=gonm}', "");
    Expect(1, 73049, '\P{^Is_Scx=gonm}', "");
    Expect(0, 73050, '\p{Is_Scx=gonm}', "");
    Expect(1, 73050, '\p{^Is_Scx=gonm}', "");
    Expect(1, 73050, '\P{Is_Scx=gonm}', "");
    Expect(0, 73050, '\P{^Is_Scx=gonm}', "");
    Expect(1, 73049, '\p{Is_Scx=_Gonm}', "");
    Expect(0, 73049, '\p{^Is_Scx=_Gonm}', "");
    Expect(0, 73049, '\P{Is_Scx=_Gonm}', "");
    Expect(1, 73049, '\P{^Is_Scx=_Gonm}', "");
    Expect(0, 73050, '\p{Is_Scx=_Gonm}', "");
    Expect(1, 73050, '\p{^Is_Scx=_Gonm}', "");
    Expect(1, 73050, '\P{Is_Scx=_Gonm}', "");
    Expect(0, 73050, '\P{^Is_Scx=_Gonm}', "");
    Error('\p{Script_Extensions:/a/Gothic}');
    Error('\P{Script_Extensions:/a/Gothic}');
    Expect(1, 66378, '\p{Script_Extensions=:\AGothic\z:}', "");;
    Expect(0, 66379, '\p{Script_Extensions=:\AGothic\z:}', "");;
    Expect(1, 66378, '\p{Script_Extensions=gothic}', "");
    Expect(0, 66378, '\p{^Script_Extensions=gothic}', "");
    Expect(0, 66378, '\P{Script_Extensions=gothic}', "");
    Expect(1, 66378, '\P{^Script_Extensions=gothic}', "");
    Expect(0, 66379, '\p{Script_Extensions=gothic}', "");
    Expect(1, 66379, '\p{^Script_Extensions=gothic}', "");
    Expect(1, 66379, '\P{Script_Extensions=gothic}', "");
    Expect(0, 66379, '\P{^Script_Extensions=gothic}', "");
    Expect(1, 66378, '\p{Script_Extensions=:\Agothic\z:}', "");;
    Expect(0, 66379, '\p{Script_Extensions=:\Agothic\z:}', "");;
    Expect(1, 66378, '\p{Script_Extensions= -Gothic}', "");
    Expect(0, 66378, '\p{^Script_Extensions= -Gothic}', "");
    Expect(0, 66378, '\P{Script_Extensions= -Gothic}', "");
    Expect(1, 66378, '\P{^Script_Extensions= -Gothic}', "");
    Expect(0, 66379, '\p{Script_Extensions= -Gothic}', "");
    Expect(1, 66379, '\p{^Script_Extensions= -Gothic}', "");
    Expect(1, 66379, '\P{Script_Extensions= -Gothic}', "");
    Expect(0, 66379, '\P{^Script_Extensions= -Gothic}', "");
    Error('\p{Scx=:=-Goth}');
    Error('\P{Scx=:=-Goth}');
    Expect(1, 66378, '\p{Scx=:\AGoth\z:}', "");;
    Expect(0, 66379, '\p{Scx=:\AGoth\z:}', "");;
    Expect(1, 66378, '\p{Scx=goth}', "");
    Expect(0, 66378, '\p{^Scx=goth}', "");
    Expect(0, 66378, '\P{Scx=goth}', "");
    Expect(1, 66378, '\P{^Scx=goth}', "");
    Expect(0, 66379, '\p{Scx=goth}', "");
    Expect(1, 66379, '\p{^Scx=goth}', "");
    Expect(1, 66379, '\P{Scx=goth}', "");
    Expect(0, 66379, '\P{^Scx=goth}', "");
    Expect(1, 66378, '\p{Scx=:\Agoth\z:}', "");;
    Expect(0, 66379, '\p{Scx=:\Agoth\z:}', "");;
    Expect(1, 66378, '\p{Scx=-	Goth}', "");
    Expect(0, 66378, '\p{^Scx=-	Goth}', "");
    Expect(0, 66378, '\P{Scx=-	Goth}', "");
    Expect(1, 66378, '\P{^Scx=-	Goth}', "");
    Expect(0, 66379, '\p{Scx=-	Goth}', "");
    Expect(1, 66379, '\p{^Scx=-	Goth}', "");
    Expect(1, 66379, '\P{Scx=-	Goth}', "");
    Expect(0, 66379, '\P{^Scx=-	Goth}', "");
    Error('\p{Is_Script_Extensions=_ GOTHIC/a/}');
    Error('\P{Is_Script_Extensions=_ GOTHIC/a/}');
    Expect(1, 66378, '\p{Is_Script_Extensions=gothic}', "");
    Expect(0, 66378, '\p{^Is_Script_Extensions=gothic}', "");
    Expect(0, 66378, '\P{Is_Script_Extensions=gothic}', "");
    Expect(1, 66378, '\P{^Is_Script_Extensions=gothic}', "");
    Expect(0, 66379, '\p{Is_Script_Extensions=gothic}', "");
    Expect(1, 66379, '\p{^Is_Script_Extensions=gothic}', "");
    Expect(1, 66379, '\P{Is_Script_Extensions=gothic}', "");
    Expect(0, 66379, '\P{^Is_Script_Extensions=gothic}', "");
    Expect(1, 66378, '\p{Is_Script_Extensions:_ GOTHIC}', "");
    Expect(0, 66378, '\p{^Is_Script_Extensions:_ GOTHIC}', "");
    Expect(0, 66378, '\P{Is_Script_Extensions:_ GOTHIC}', "");
    Expect(1, 66378, '\P{^Is_Script_Extensions:_ GOTHIC}', "");
    Expect(0, 66379, '\p{Is_Script_Extensions:_ GOTHIC}', "");
    Expect(1, 66379, '\p{^Is_Script_Extensions:_ GOTHIC}', "");
    Expect(1, 66379, '\P{Is_Script_Extensions:_ GOTHIC}', "");
    Expect(0, 66379, '\P{^Is_Script_Extensions:_ GOTHIC}', "");
    Error('\p{Is_Scx=-GOTH:=}');
    Error('\P{Is_Scx=-GOTH:=}');
    Expect(1, 66378, '\p{Is_Scx=goth}', "");
    Expect(0, 66378, '\p{^Is_Scx=goth}', "");
    Expect(0, 66378, '\P{Is_Scx=goth}', "");
    Expect(1, 66378, '\P{^Is_Scx=goth}', "");
    Expect(0, 66379, '\p{Is_Scx=goth}', "");
    Expect(1, 66379, '\p{^Is_Scx=goth}', "");
    Expect(1, 66379, '\P{Is_Scx=goth}', "");
    Expect(0, 66379, '\P{^Is_Scx=goth}', "");
    Expect(1, 66378, '\p{Is_Scx=_-Goth}', "");
    Expect(0, 66378, '\p{^Is_Scx=_-Goth}', "");
    Expect(0, 66378, '\P{Is_Scx=_-Goth}', "");
    Expect(1, 66378, '\P{^Is_Scx=_-Goth}', "");
    Expect(0, 66379, '\p{Is_Scx=_-Goth}', "");
    Expect(1, 66379, '\p{^Is_Scx=_-Goth}', "");
    Expect(1, 66379, '\P{Is_Scx=_-Goth}', "");
    Expect(0, 66379, '\P{^Is_Scx=_-Goth}', "");
    Error('\p{Script_Extensions=:=	grantha}');
    Error('\P{Script_Extensions=:=	grantha}');
    Expect(1, 73683, '\p{Script_Extensions=:\AGrantha\z:}', "");;
    Expect(0, 73684, '\p{Script_Extensions=:\AGrantha\z:}', "");;
    Expect(1, 73683, '\p{Script_Extensions=grantha}', "");
    Expect(0, 73683, '\p{^Script_Extensions=grantha}', "");
    Expect(0, 73683, '\P{Script_Extensions=grantha}', "");
    Expect(1, 73683, '\P{^Script_Extensions=grantha}', "");
    Expect(0, 73684, '\p{Script_Extensions=grantha}', "");
    Expect(1, 73684, '\p{^Script_Extensions=grantha}', "");
    Expect(1, 73684, '\P{Script_Extensions=grantha}', "");
    Expect(0, 73684, '\P{^Script_Extensions=grantha}', "");
    Expect(1, 73683, '\p{Script_Extensions=:\Agrantha\z:}', "");;
    Expect(0, 73684, '\p{Script_Extensions=:\Agrantha\z:}', "");;
    Expect(1, 73683, '\p{Script_Extensions=	GRANTHA}', "");
    Expect(0, 73683, '\p{^Script_Extensions=	GRANTHA}', "");
    Expect(0, 73683, '\P{Script_Extensions=	GRANTHA}', "");
    Expect(1, 73683, '\P{^Script_Extensions=	GRANTHA}', "");
    Expect(0, 73684, '\p{Script_Extensions=	GRANTHA}', "");
    Expect(1, 73684, '\p{^Script_Extensions=	GRANTHA}', "");
    Expect(1, 73684, '\P{Script_Extensions=	GRANTHA}', "");
    Expect(0, 73684, '\P{^Script_Extensions=	GRANTHA}', "");
    Error('\p{Scx=:=GRAN}');
    Error('\P{Scx=:=GRAN}');
    Expect(1, 73683, '\p{Scx=:\AGran\z:}', "");;
    Expect(0, 73684, '\p{Scx=:\AGran\z:}', "");;
    Expect(1, 73683, '\p{Scx=gran}', "");
    Expect(0, 73683, '\p{^Scx=gran}', "");
    Expect(0, 73683, '\P{Scx=gran}', "");
    Expect(1, 73683, '\P{^Scx=gran}', "");
    Expect(0, 73684, '\p{Scx=gran}', "");
    Expect(1, 73684, '\p{^Scx=gran}', "");
    Expect(1, 73684, '\P{Scx=gran}', "");
    Expect(0, 73684, '\P{^Scx=gran}', "");
    Expect(1, 73683, '\p{Scx=:\Agran\z:}', "");;
    Expect(0, 73684, '\p{Scx=:\Agran\z:}', "");;
    Expect(1, 73683, '\p{Scx=-Gran}', "");
    Expect(0, 73683, '\p{^Scx=-Gran}', "");
    Expect(0, 73683, '\P{Scx=-Gran}', "");
    Expect(1, 73683, '\P{^Scx=-Gran}', "");
    Expect(0, 73684, '\p{Scx=-Gran}', "");
    Expect(1, 73684, '\p{^Scx=-Gran}', "");
    Expect(1, 73684, '\P{Scx=-Gran}', "");
    Expect(0, 73684, '\P{^Scx=-Gran}', "");
    Error('\p{Is_Script_Extensions=	 grantha:=}');
    Error('\P{Is_Script_Extensions=	 grantha:=}');
    Expect(1, 73683, '\p{Is_Script_Extensions=grantha}', "");
    Expect(0, 73683, '\p{^Is_Script_Extensions=grantha}', "");
    Expect(0, 73683, '\P{Is_Script_Extensions=grantha}', "");
    Expect(1, 73683, '\P{^Is_Script_Extensions=grantha}', "");
    Expect(0, 73684, '\p{Is_Script_Extensions=grantha}', "");
    Expect(1, 73684, '\p{^Is_Script_Extensions=grantha}', "");
    Expect(1, 73684, '\P{Is_Script_Extensions=grantha}', "");
    Expect(0, 73684, '\P{^Is_Script_Extensions=grantha}', "");
    Expect(1, 73683, '\p{Is_Script_Extensions=  Grantha}', "");
    Expect(0, 73683, '\p{^Is_Script_Extensions=  Grantha}', "");
    Expect(0, 73683, '\P{Is_Script_Extensions=  Grantha}', "");
    Expect(1, 73683, '\P{^Is_Script_Extensions=  Grantha}', "");
    Expect(0, 73684, '\p{Is_Script_Extensions=  Grantha}', "");
    Expect(1, 73684, '\p{^Is_Script_Extensions=  Grantha}', "");
    Expect(1, 73684, '\P{Is_Script_Extensions=  Grantha}', "");
    Expect(0, 73684, '\P{^Is_Script_Extensions=  Grantha}', "");
    Error('\p{Is_Scx=/a/_Gran}');
    Error('\P{Is_Scx=/a/_Gran}');
    Expect(1, 73683, '\p{Is_Scx=gran}', "");
    Expect(0, 73683, '\p{^Is_Scx=gran}', "");
    Expect(0, 73683, '\P{Is_Scx=gran}', "");
    Expect(1, 73683, '\P{^Is_Scx=gran}', "");
    Expect(0, 73684, '\p{Is_Scx=gran}', "");
    Expect(1, 73684, '\p{^Is_Scx=gran}', "");
    Expect(1, 73684, '\P{Is_Scx=gran}', "");
    Expect(0, 73684, '\P{^Is_Scx=gran}', "");
    Expect(1, 73683, '\p{Is_Scx: 	 GRAN}', "");
    Expect(0, 73683, '\p{^Is_Scx: 	 GRAN}', "");
    Expect(0, 73683, '\P{Is_Scx: 	 GRAN}', "");
    Expect(1, 73683, '\P{^Is_Scx: 	 GRAN}', "");
    Expect(0, 73684, '\p{Is_Scx: 	 GRAN}', "");
    Expect(1, 73684, '\p{^Is_Scx: 	 GRAN}', "");
    Expect(1, 73684, '\P{Is_Scx: 	 GRAN}', "");
    Expect(0, 73684, '\P{^Is_Scx: 	 GRAN}', "");
    Error('\p{Script_Extensions=:=_Greek}');
    Error('\P{Script_Extensions=:=_Greek}');
    Expect(1, 119365, '\p{Script_Extensions=:\AGreek\z:}', "");;
    Expect(0, 119366, '\p{Script_Extensions=:\AGreek\z:}', "");;
    Expect(1, 119365, '\p{Script_Extensions=greek}', "");
    Expect(0, 119365, '\p{^Script_Extensions=greek}', "");
    Expect(0, 119365, '\P{Script_Extensions=greek}', "");
    Expect(1, 119365, '\P{^Script_Extensions=greek}', "");
    Expect(0, 119366, '\p{Script_Extensions=greek}', "");
    Expect(1, 119366, '\p{^Script_Extensions=greek}', "");
    Expect(1, 119366, '\P{Script_Extensions=greek}', "");
    Expect(0, 119366, '\P{^Script_Extensions=greek}', "");
    Expect(1, 119365, '\p{Script_Extensions=:\Agreek\z:}', "");;
    Expect(0, 119366, '\p{Script_Extensions=:\Agreek\z:}', "");;
    Expect(1, 119365, '\p{Script_Extensions=	Greek}', "");
    Expect(0, 119365, '\p{^Script_Extensions=	Greek}', "");
    Expect(0, 119365, '\P{Script_Extensions=	Greek}', "");
    Expect(1, 119365, '\P{^Script_Extensions=	Greek}', "");
    Expect(0, 119366, '\p{Script_Extensions=	Greek}', "");
    Expect(1, 119366, '\p{^Script_Extensions=	Greek}', "");
    Expect(1, 119366, '\P{Script_Extensions=	Greek}', "");
    Expect(0, 119366, '\P{^Script_Extensions=	Greek}', "");
    Error('\p{Scx=/a/Grek}');
    Error('\P{Scx=/a/Grek}');
    Expect(1, 119365, '\p{Scx=:\AGrek\z:}', "");;
    Expect(0, 119366, '\p{Scx=:\AGrek\z:}', "");;
    Expect(1, 119365, '\p{Scx=grek}', "");
    Expect(0, 119365, '\p{^Scx=grek}', "");
    Expect(0, 119365, '\P{Scx=grek}', "");
    Expect(1, 119365, '\P{^Scx=grek}', "");
    Expect(0, 119366, '\p{Scx=grek}', "");
    Expect(1, 119366, '\p{^Scx=grek}', "");
    Expect(1, 119366, '\P{Scx=grek}', "");
    Expect(0, 119366, '\P{^Scx=grek}', "");
    Expect(1, 119365, '\p{Scx=:\Agrek\z:}', "");;
    Expect(0, 119366, '\p{Scx=:\Agrek\z:}', "");;
    Expect(1, 119365, '\p{Scx=GREK}', "");
    Expect(0, 119365, '\p{^Scx=GREK}', "");
    Expect(0, 119365, '\P{Scx=GREK}', "");
    Expect(1, 119365, '\P{^Scx=GREK}', "");
    Expect(0, 119366, '\p{Scx=GREK}', "");
    Expect(1, 119366, '\p{^Scx=GREK}', "");
    Expect(1, 119366, '\P{Scx=GREK}', "");
    Expect(0, 119366, '\P{^Scx=GREK}', "");
    Error('\p{Is_Script_Extensions=/a/__Greek}');
    Error('\P{Is_Script_Extensions=/a/__Greek}');
    Expect(1, 119365, '\p{Is_Script_Extensions=greek}', "");
    Expect(0, 119365, '\p{^Is_Script_Extensions=greek}', "");
    Expect(0, 119365, '\P{Is_Script_Extensions=greek}', "");
    Expect(1, 119365, '\P{^Is_Script_Extensions=greek}', "");
    Expect(0, 119366, '\p{Is_Script_Extensions=greek}', "");
    Expect(1, 119366, '\p{^Is_Script_Extensions=greek}', "");
    Expect(1, 119366, '\P{Is_Script_Extensions=greek}', "");
    Expect(0, 119366, '\P{^Is_Script_Extensions=greek}', "");
    Expect(1, 119365, '\p{Is_Script_Extensions=	-Greek}', "");
    Expect(0, 119365, '\p{^Is_Script_Extensions=	-Greek}', "");
    Expect(0, 119365, '\P{Is_Script_Extensions=	-Greek}', "");
    Expect(1, 119365, '\P{^Is_Script_Extensions=	-Greek}', "");
    Expect(0, 119366, '\p{Is_Script_Extensions=	-Greek}', "");
    Expect(1, 119366, '\p{^Is_Script_Extensions=	-Greek}', "");
    Expect(1, 119366, '\P{Is_Script_Extensions=	-Greek}', "");
    Expect(0, 119366, '\P{^Is_Script_Extensions=	-Greek}', "");
    Error('\p{Is_Scx=-	Grek/a/}');
    Error('\P{Is_Scx=-	Grek/a/}');
    Expect(1, 119365, '\p{Is_Scx=grek}', "");
    Expect(0, 119365, '\p{^Is_Scx=grek}', "");
    Expect(0, 119365, '\P{Is_Scx=grek}', "");
    Expect(1, 119365, '\P{^Is_Scx=grek}', "");
    Expect(0, 119366, '\p{Is_Scx=grek}', "");
    Expect(1, 119366, '\p{^Is_Scx=grek}', "");
    Expect(1, 119366, '\P{Is_Scx=grek}', "");
    Expect(0, 119366, '\P{^Is_Scx=grek}', "");
    Error('\p{Script_Extensions=:=Gujarati}');
    Error('\P{Script_Extensions=:=Gujarati}');
    Expect(1, 43065, '\p{Script_Extensions=:\AGujarati\z:}', "");;
    Expect(0, 43066, '\p{Script_Extensions=:\AGujarati\z:}', "");;
    Expect(1, 43065, '\p{Script_Extensions=gujarati}', "");
    Expect(0, 43065, '\p{^Script_Extensions=gujarati}', "");
    Expect(0, 43065, '\P{Script_Extensions=gujarati}', "");
    Expect(1, 43065, '\P{^Script_Extensions=gujarati}', "");
    Expect(0, 43066, '\p{Script_Extensions=gujarati}', "");
    Expect(1, 43066, '\p{^Script_Extensions=gujarati}', "");
    Expect(1, 43066, '\P{Script_Extensions=gujarati}', "");
    Expect(0, 43066, '\P{^Script_Extensions=gujarati}', "");
    Expect(1, 43065, '\p{Script_Extensions=:\Agujarati\z:}', "");;
    Expect(0, 43066, '\p{Script_Extensions=:\Agujarati\z:}', "");;
    Expect(1, 43065, '\p{Script_Extensions=_	gujarati}', "");
    Expect(0, 43065, '\p{^Script_Extensions=_	gujarati}', "");
    Expect(0, 43065, '\P{Script_Extensions=_	gujarati}', "");
    Expect(1, 43065, '\P{^Script_Extensions=_	gujarati}', "");
    Expect(0, 43066, '\p{Script_Extensions=_	gujarati}', "");
    Expect(1, 43066, '\p{^Script_Extensions=_	gujarati}', "");
    Expect(1, 43066, '\P{Script_Extensions=_	gujarati}', "");
    Expect(0, 43066, '\P{^Script_Extensions=_	gujarati}', "");
    Error('\p{Scx=:=	Gujr}');
    Error('\P{Scx=:=	Gujr}');
    Expect(1, 43065, '\p{Scx=:\AGujr\z:}', "");;
    Expect(0, 43066, '\p{Scx=:\AGujr\z:}', "");;
    Expect(1, 43065, '\p{Scx=gujr}', "");
    Expect(0, 43065, '\p{^Scx=gujr}', "");
    Expect(0, 43065, '\P{Scx=gujr}', "");
    Expect(1, 43065, '\P{^Scx=gujr}', "");
    Expect(0, 43066, '\p{Scx=gujr}', "");
    Expect(1, 43066, '\p{^Scx=gujr}', "");
    Expect(1, 43066, '\P{Scx=gujr}', "");
    Expect(0, 43066, '\P{^Scx=gujr}', "");
    Expect(1, 43065, '\p{Scx=:\Agujr\z:}', "");;
    Expect(0, 43066, '\p{Scx=:\Agujr\z:}', "");;
    Expect(1, 43065, '\p{Scx= -gujr}', "");
    Expect(0, 43065, '\p{^Scx= -gujr}', "");
    Expect(0, 43065, '\P{Scx= -gujr}', "");
    Expect(1, 43065, '\P{^Scx= -gujr}', "");
    Expect(0, 43066, '\p{Scx= -gujr}', "");
    Expect(1, 43066, '\p{^Scx= -gujr}', "");
    Expect(1, 43066, '\P{Scx= -gujr}', "");
    Expect(0, 43066, '\P{^Scx= -gujr}', "");
    Error('\p{Is_Script_Extensions=/a/		Gujarati}');
    Error('\P{Is_Script_Extensions=/a/		Gujarati}');
    Expect(1, 43065, '\p{Is_Script_Extensions=gujarati}', "");
    Expect(0, 43065, '\p{^Is_Script_Extensions=gujarati}', "");
    Expect(0, 43065, '\P{Is_Script_Extensions=gujarati}', "");
    Expect(1, 43065, '\P{^Is_Script_Extensions=gujarati}', "");
    Expect(0, 43066, '\p{Is_Script_Extensions=gujarati}', "");
    Expect(1, 43066, '\p{^Is_Script_Extensions=gujarati}', "");
    Expect(1, 43066, '\P{Is_Script_Extensions=gujarati}', "");
    Expect(0, 43066, '\P{^Is_Script_Extensions=gujarati}', "");
    Expect(1, 43065, '\p{Is_Script_Extensions=	 gujarati}', "");
    Expect(0, 43065, '\p{^Is_Script_Extensions=	 gujarati}', "");
    Expect(0, 43065, '\P{Is_Script_Extensions=	 gujarati}', "");
    Expect(1, 43065, '\P{^Is_Script_Extensions=	 gujarati}', "");
    Expect(0, 43066, '\p{Is_Script_Extensions=	 gujarati}', "");
    Expect(1, 43066, '\p{^Is_Script_Extensions=	 gujarati}', "");
    Expect(1, 43066, '\P{Is_Script_Extensions=	 gujarati}', "");
    Expect(0, 43066, '\P{^Is_Script_Extensions=	 gujarati}', "");
    Error('\p{Is_Scx=/a/gujr}');
    Error('\P{Is_Scx=/a/gujr}');
    Expect(1, 43065, '\p{Is_Scx: gujr}', "");
    Expect(0, 43065, '\p{^Is_Scx: gujr}', "");
    Expect(0, 43065, '\P{Is_Scx: gujr}', "");
    Expect(1, 43065, '\P{^Is_Scx: gujr}', "");
    Expect(0, 43066, '\p{Is_Scx: gujr}', "");
    Expect(1, 43066, '\p{^Is_Scx: gujr}', "");
    Expect(1, 43066, '\P{Is_Scx: gujr}', "");
    Expect(0, 43066, '\P{^Is_Scx: gujr}', "");
    Expect(1, 43065, '\p{Is_Scx= Gujr}', "");
    Expect(0, 43065, '\p{^Is_Scx= Gujr}', "");
    Expect(0, 43065, '\P{Is_Scx= Gujr}', "");
    Expect(1, 43065, '\P{^Is_Scx= Gujr}', "");
    Expect(0, 43066, '\p{Is_Scx= Gujr}', "");
    Expect(1, 43066, '\p{^Is_Scx= Gujr}', "");
    Expect(1, 43066, '\P{Is_Scx= Gujr}', "");
    Expect(0, 43066, '\P{^Is_Scx= Gujr}', "");
    Error('\p{Script_Extensions: /a/gurmukhi}');
    Error('\P{Script_Extensions: /a/gurmukhi}');
    Expect(1, 43065, '\p{Script_Extensions=:\AGurmukhi\z:}', "");;
    Expect(0, 43066, '\p{Script_Extensions=:\AGurmukhi\z:}', "");;
    Expect(1, 43065, '\p{Script_Extensions=gurmukhi}', "");
    Expect(0, 43065, '\p{^Script_Extensions=gurmukhi}', "");
    Expect(0, 43065, '\P{Script_Extensions=gurmukhi}', "");
    Expect(1, 43065, '\P{^Script_Extensions=gurmukhi}', "");
    Expect(0, 43066, '\p{Script_Extensions=gurmukhi}', "");
    Expect(1, 43066, '\p{^Script_Extensions=gurmukhi}', "");
    Expect(1, 43066, '\P{Script_Extensions=gurmukhi}', "");
    Expect(0, 43066, '\P{^Script_Extensions=gurmukhi}', "");
    Expect(1, 43065, '\p{Script_Extensions=:\Agurmukhi\z:}', "");;
    Expect(0, 43066, '\p{Script_Extensions=:\Agurmukhi\z:}', "");;
    Expect(1, 43065, '\p{Script_Extensions=__Gurmukhi}', "");
    Expect(0, 43065, '\p{^Script_Extensions=__Gurmukhi}', "");
    Expect(0, 43065, '\P{Script_Extensions=__Gurmukhi}', "");
    Expect(1, 43065, '\P{^Script_Extensions=__Gurmukhi}', "");
    Expect(0, 43066, '\p{Script_Extensions=__Gurmukhi}', "");
    Expect(1, 43066, '\p{^Script_Extensions=__Gurmukhi}', "");
    Expect(1, 43066, '\P{Script_Extensions=__Gurmukhi}', "");
    Expect(0, 43066, '\P{^Script_Extensions=__Gurmukhi}', "");
    Error('\p{Scx=:=--Guru}');
    Error('\P{Scx=:=--Guru}');
    Expect(1, 43065, '\p{Scx=:\AGuru\z:}', "");;
    Expect(0, 43066, '\p{Scx=:\AGuru\z:}', "");;
    Expect(1, 43065, '\p{Scx:	guru}', "");
    Expect(0, 43065, '\p{^Scx:	guru}', "");
    Expect(0, 43065, '\P{Scx:	guru}', "");
    Expect(1, 43065, '\P{^Scx:	guru}', "");
    Expect(0, 43066, '\p{Scx:	guru}', "");
    Expect(1, 43066, '\p{^Scx:	guru}', "");
    Expect(1, 43066, '\P{Scx:	guru}', "");
    Expect(0, 43066, '\P{^Scx:	guru}', "");
    Expect(1, 43065, '\p{Scx=:\Aguru\z:}', "");;
    Expect(0, 43066, '\p{Scx=:\Aguru\z:}', "");;
    Expect(1, 43065, '\p{Scx=_	guru}', "");
    Expect(0, 43065, '\p{^Scx=_	guru}', "");
    Expect(0, 43065, '\P{Scx=_	guru}', "");
    Expect(1, 43065, '\P{^Scx=_	guru}', "");
    Expect(0, 43066, '\p{Scx=_	guru}', "");
    Expect(1, 43066, '\p{^Scx=_	guru}', "");
    Expect(1, 43066, '\P{Scx=_	guru}', "");
    Expect(0, 43066, '\P{^Scx=_	guru}', "");
    Error('\p{Is_Script_Extensions= gurmukhi/a/}');
    Error('\P{Is_Script_Extensions= gurmukhi/a/}');
    Expect(1, 43065, '\p{Is_Script_Extensions=gurmukhi}', "");
    Expect(0, 43065, '\p{^Is_Script_Extensions=gurmukhi}', "");
    Expect(0, 43065, '\P{Is_Script_Extensions=gurmukhi}', "");
    Expect(1, 43065, '\P{^Is_Script_Extensions=gurmukhi}', "");
    Expect(0, 43066, '\p{Is_Script_Extensions=gurmukhi}', "");
    Expect(1, 43066, '\p{^Is_Script_Extensions=gurmukhi}', "");
    Expect(1, 43066, '\P{Is_Script_Extensions=gurmukhi}', "");
    Expect(0, 43066, '\P{^Is_Script_Extensions=gurmukhi}', "");
    Expect(1, 43065, '\p{Is_Script_Extensions= _gurmukhi}', "");
    Expect(0, 43065, '\p{^Is_Script_Extensions= _gurmukhi}', "");
    Expect(0, 43065, '\P{Is_Script_Extensions= _gurmukhi}', "");
    Expect(1, 43065, '\P{^Is_Script_Extensions= _gurmukhi}', "");
    Expect(0, 43066, '\p{Is_Script_Extensions= _gurmukhi}', "");
    Expect(1, 43066, '\p{^Is_Script_Extensions= _gurmukhi}', "");
    Expect(1, 43066, '\P{Is_Script_Extensions= _gurmukhi}', "");
    Expect(0, 43066, '\P{^Is_Script_Extensions= _gurmukhi}', "");
    Error('\p{Is_Scx=	/a/Guru}');
    Error('\P{Is_Scx=	/a/Guru}');
    Expect(1, 43065, '\p{Is_Scx:guru}', "");
    Expect(0, 43065, '\p{^Is_Scx:guru}', "");
    Expect(0, 43065, '\P{Is_Scx:guru}', "");
    Expect(1, 43065, '\P{^Is_Scx:guru}', "");
    Expect(0, 43066, '\p{Is_Scx:guru}', "");
    Expect(1, 43066, '\p{^Is_Scx:guru}', "");
    Expect(1, 43066, '\P{Is_Scx:guru}', "");
    Expect(0, 43066, '\P{^Is_Scx:guru}', "");
    Expect(1, 43065, '\p{Is_Scx=--GURU}', "");
    Expect(0, 43065, '\p{^Is_Scx=--GURU}', "");
    Expect(0, 43065, '\P{Is_Scx=--GURU}', "");
    Expect(1, 43065, '\P{^Is_Scx=--GURU}', "");
    Expect(0, 43066, '\p{Is_Scx=--GURU}', "");
    Expect(1, 43066, '\p{^Is_Scx=--GURU}', "");
    Expect(1, 43066, '\P{Is_Scx=--GURU}', "");
    Expect(0, 43066, '\P{^Is_Scx=--GURU}', "");
    Error('\p{Script_Extensions=_	Hangul/a/}');
    Error('\P{Script_Extensions=_	Hangul/a/}');
    Expect(1, 65500, '\p{Script_Extensions=:\AHangul\z:}', "");;
    Expect(0, 65501, '\p{Script_Extensions=:\AHangul\z:}', "");;
    Expect(1, 65500, '\p{Script_Extensions:	hangul}', "");
    Expect(0, 65500, '\p{^Script_Extensions:	hangul}', "");
    Expect(0, 65500, '\P{Script_Extensions:	hangul}', "");
    Expect(1, 65500, '\P{^Script_Extensions:	hangul}', "");
    Expect(0, 65501, '\p{Script_Extensions:	hangul}', "");
    Expect(1, 65501, '\p{^Script_Extensions:	hangul}', "");
    Expect(1, 65501, '\P{Script_Extensions:	hangul}', "");
    Expect(0, 65501, '\P{^Script_Extensions:	hangul}', "");
    Expect(1, 65500, '\p{Script_Extensions=:\Ahangul\z:}', "");;
    Expect(0, 65501, '\p{Script_Extensions=:\Ahangul\z:}', "");;
    Expect(1, 65500, '\p{Script_Extensions=-_Hangul}', "");
    Expect(0, 65500, '\p{^Script_Extensions=-_Hangul}', "");
    Expect(0, 65500, '\P{Script_Extensions=-_Hangul}', "");
    Expect(1, 65500, '\P{^Script_Extensions=-_Hangul}', "");
    Expect(0, 65501, '\p{Script_Extensions=-_Hangul}', "");
    Expect(1, 65501, '\p{^Script_Extensions=-_Hangul}', "");
    Expect(1, 65501, '\P{Script_Extensions=-_Hangul}', "");
    Expect(0, 65501, '\P{^Script_Extensions=-_Hangul}', "");
    Error('\p{Scx=  HANG:=}');
    Error('\P{Scx=  HANG:=}');
    Expect(1, 65500, '\p{Scx=:\AHang\z:}', "");;
    Expect(0, 65501, '\p{Scx=:\AHang\z:}', "");;
    Expect(1, 65500, '\p{Scx=hang}', "");
    Expect(0, 65500, '\p{^Scx=hang}', "");
    Expect(0, 65500, '\P{Scx=hang}', "");
    Expect(1, 65500, '\P{^Scx=hang}', "");
    Expect(0, 65501, '\p{Scx=hang}', "");
    Expect(1, 65501, '\p{^Scx=hang}', "");
    Expect(1, 65501, '\P{Scx=hang}', "");
    Expect(0, 65501, '\P{^Scx=hang}', "");
    Expect(1, 65500, '\p{Scx=:\Ahang\z:}', "");;
    Expect(0, 65501, '\p{Scx=:\Ahang\z:}', "");;
    Expect(1, 65500, '\p{Scx= 	hang}', "");
    Expect(0, 65500, '\p{^Scx= 	hang}', "");
    Expect(0, 65500, '\P{Scx= 	hang}', "");
    Expect(1, 65500, '\P{^Scx= 	hang}', "");
    Expect(0, 65501, '\p{Scx= 	hang}', "");
    Expect(1, 65501, '\p{^Scx= 	hang}', "");
    Expect(1, 65501, '\P{Scx= 	hang}', "");
    Expect(0, 65501, '\P{^Scx= 	hang}', "");
    Error('\p{Is_Script_Extensions=/a/_	HANGUL}');
    Error('\P{Is_Script_Extensions=/a/_	HANGUL}');
    Expect(1, 65500, '\p{Is_Script_Extensions=hangul}', "");
    Expect(0, 65500, '\p{^Is_Script_Extensions=hangul}', "");
    Expect(0, 65500, '\P{Is_Script_Extensions=hangul}', "");
    Expect(1, 65500, '\P{^Is_Script_Extensions=hangul}', "");
    Expect(0, 65501, '\p{Is_Script_Extensions=hangul}', "");
    Expect(1, 65501, '\p{^Is_Script_Extensions=hangul}', "");
    Expect(1, 65501, '\P{Is_Script_Extensions=hangul}', "");
    Expect(0, 65501, '\P{^Is_Script_Extensions=hangul}', "");
    Expect(1, 65500, '\p{Is_Script_Extensions:  	hangul}', "");
    Expect(0, 65500, '\p{^Is_Script_Extensions:  	hangul}', "");
    Expect(0, 65500, '\P{Is_Script_Extensions:  	hangul}', "");
    Expect(1, 65500, '\P{^Is_Script_Extensions:  	hangul}', "");
    Expect(0, 65501, '\p{Is_Script_Extensions:  	hangul}', "");
    Expect(1, 65501, '\p{^Is_Script_Extensions:  	hangul}', "");
    Expect(1, 65501, '\P{Is_Script_Extensions:  	hangul}', "");
    Expect(0, 65501, '\P{^Is_Script_Extensions:  	hangul}', "");
    Error('\p{Is_Scx=/a/hang}');
    Error('\P{Is_Scx=/a/hang}');
    Expect(1, 65500, '\p{Is_Scx=hang}', "");
    Expect(0, 65500, '\p{^Is_Scx=hang}', "");
    Expect(0, 65500, '\P{Is_Scx=hang}', "");
    Expect(1, 65500, '\P{^Is_Scx=hang}', "");
    Expect(0, 65501, '\p{Is_Scx=hang}', "");
    Expect(1, 65501, '\p{^Is_Scx=hang}', "");
    Expect(1, 65501, '\P{Is_Scx=hang}', "");
    Expect(0, 65501, '\P{^Is_Scx=hang}', "");
    Expect(1, 65500, '\p{Is_Scx=_-Hang}', "");
    Expect(0, 65500, '\p{^Is_Scx=_-Hang}', "");
    Expect(0, 65500, '\P{Is_Scx=_-Hang}', "");
    Expect(1, 65500, '\P{^Is_Scx=_-Hang}', "");
    Expect(0, 65501, '\p{Is_Scx=_-Hang}', "");
    Expect(1, 65501, '\p{^Is_Scx=_-Hang}', "");
    Expect(1, 65501, '\P{Is_Scx=_-Hang}', "");
    Expect(0, 65501, '\P{^Is_Scx=_-Hang}', "");
    Error('\p{Script_Extensions=	/a/HAN}');
    Error('\P{Script_Extensions=	/a/HAN}');
    Expect(1, 195101, '\p{Script_Extensions=:\AHan\z:}', "");;
    Expect(0, 195102, '\p{Script_Extensions=:\AHan\z:}', "");;
    Expect(1, 195101, '\p{Script_Extensions=han}', "");
    Expect(0, 195101, '\p{^Script_Extensions=han}', "");
    Expect(0, 195101, '\P{Script_Extensions=han}', "");
    Expect(1, 195101, '\P{^Script_Extensions=han}', "");
    Expect(0, 195102, '\p{Script_Extensions=han}', "");
    Expect(1, 195102, '\p{^Script_Extensions=han}', "");
    Expect(1, 195102, '\P{Script_Extensions=han}', "");
    Expect(0, 195102, '\P{^Script_Extensions=han}', "");
    Expect(1, 195101, '\p{Script_Extensions=:\Ahan\z:}', "");;
    Expect(0, 195102, '\p{Script_Extensions=:\Ahan\z:}', "");;
    Expect(1, 195101, '\p{Script_Extensions= 	han}', "");
    Expect(0, 195101, '\p{^Script_Extensions= 	han}', "");
    Expect(0, 195101, '\P{Script_Extensions= 	han}', "");
    Expect(1, 195101, '\P{^Script_Extensions= 	han}', "");
    Expect(0, 195102, '\p{Script_Extensions= 	han}', "");
    Expect(1, 195102, '\p{^Script_Extensions= 	han}', "");
    Expect(1, 195102, '\P{Script_Extensions= 	han}', "");
    Expect(0, 195102, '\P{^Script_Extensions= 	han}', "");
    Error('\p{Scx=/a/-HANI}');
    Error('\P{Scx=/a/-HANI}');
    Expect(1, 195101, '\p{Scx=:\AHani\z:}', "");;
    Expect(0, 195102, '\p{Scx=:\AHani\z:}', "");;
    Expect(1, 195101, '\p{Scx=hani}', "");
    Expect(0, 195101, '\p{^Scx=hani}', "");
    Expect(0, 195101, '\P{Scx=hani}', "");
    Expect(1, 195101, '\P{^Scx=hani}', "");
    Expect(0, 195102, '\p{Scx=hani}', "");
    Expect(1, 195102, '\p{^Scx=hani}', "");
    Expect(1, 195102, '\P{Scx=hani}', "");
    Expect(0, 195102, '\P{^Scx=hani}', "");
    Expect(1, 195101, '\p{Scx=:\Ahani\z:}', "");;
    Expect(0, 195102, '\p{Scx=:\Ahani\z:}', "");;
    Expect(1, 195101, '\p{Scx=-	Hani}', "");
    Expect(0, 195101, '\p{^Scx=-	Hani}', "");
    Expect(0, 195101, '\P{Scx=-	Hani}', "");
    Expect(1, 195101, '\P{^Scx=-	Hani}', "");
    Expect(0, 195102, '\p{Scx=-	Hani}', "");
    Expect(1, 195102, '\p{^Scx=-	Hani}', "");
    Expect(1, 195102, '\P{Scx=-	Hani}', "");
    Expect(0, 195102, '\P{^Scx=-	Hani}', "");
    Error('\p{Is_Script_Extensions=_/a/han}');
    Error('\P{Is_Script_Extensions=_/a/han}');
    Expect(1, 195101, '\p{Is_Script_Extensions=han}', "");
    Expect(0, 195101, '\p{^Is_Script_Extensions=han}', "");
    Expect(0, 195101, '\P{Is_Script_Extensions=han}', "");
    Expect(1, 195101, '\P{^Is_Script_Extensions=han}', "");
    Expect(0, 195102, '\p{Is_Script_Extensions=han}', "");
    Expect(1, 195102, '\p{^Is_Script_Extensions=han}', "");
    Expect(1, 195102, '\P{Is_Script_Extensions=han}', "");
    Expect(0, 195102, '\P{^Is_Script_Extensions=han}', "");
    Expect(1, 195101, '\p{Is_Script_Extensions=-	han}', "");
    Expect(0, 195101, '\p{^Is_Script_Extensions=-	han}', "");
    Expect(0, 195101, '\P{Is_Script_Extensions=-	han}', "");
    Expect(1, 195101, '\P{^Is_Script_Extensions=-	han}', "");
    Expect(0, 195102, '\p{Is_Script_Extensions=-	han}', "");
    Expect(1, 195102, '\p{^Is_Script_Extensions=-	han}', "");
    Expect(1, 195102, '\P{Is_Script_Extensions=-	han}', "");
    Expect(0, 195102, '\P{^Is_Script_Extensions=-	han}', "");
    Error('\p{Is_Scx=-	Hani/a/}');
    Error('\P{Is_Scx=-	Hani/a/}');
    Expect(1, 195101, '\p{Is_Scx=hani}', "");
    Expect(0, 195101, '\p{^Is_Scx=hani}', "");
    Expect(0, 195101, '\P{Is_Scx=hani}', "");
    Expect(1, 195101, '\P{^Is_Scx=hani}', "");
    Expect(0, 195102, '\p{Is_Scx=hani}', "");
    Expect(1, 195102, '\p{^Is_Scx=hani}', "");
    Expect(1, 195102, '\P{Is_Scx=hani}', "");
    Expect(0, 195102, '\P{^Is_Scx=hani}', "");
    Expect(1, 195101, '\p{Is_Scx=-	hani}', "");
    Expect(0, 195101, '\p{^Is_Scx=-	hani}', "");
    Expect(0, 195101, '\P{Is_Scx=-	hani}', "");
    Expect(1, 195101, '\P{^Is_Scx=-	hani}', "");
    Expect(0, 195102, '\p{Is_Scx=-	hani}', "");
    Expect(1, 195102, '\p{^Is_Scx=-	hani}', "");
    Expect(1, 195102, '\P{Is_Scx=-	hani}', "");
    Expect(0, 195102, '\P{^Is_Scx=-	hani}', "");
    Error('\p{Script_Extensions=	Hanunoo/a/}');
    Error('\P{Script_Extensions=	Hanunoo/a/}');
    Expect(1, 5942, '\p{Script_Extensions=:\AHanunoo\z:}', "");;
    Expect(0, 5943, '\p{Script_Extensions=:\AHanunoo\z:}', "");;
    Expect(1, 5942, '\p{Script_Extensions=hanunoo}', "");
    Expect(0, 5942, '\p{^Script_Extensions=hanunoo}', "");
    Expect(0, 5942, '\P{Script_Extensions=hanunoo}', "");
    Expect(1, 5942, '\P{^Script_Extensions=hanunoo}', "");
    Expect(0, 5943, '\p{Script_Extensions=hanunoo}', "");
    Expect(1, 5943, '\p{^Script_Extensions=hanunoo}', "");
    Expect(1, 5943, '\P{Script_Extensions=hanunoo}', "");
    Expect(0, 5943, '\P{^Script_Extensions=hanunoo}', "");
    Expect(1, 5942, '\p{Script_Extensions=:\Ahanunoo\z:}', "");;
    Expect(0, 5943, '\p{Script_Extensions=:\Ahanunoo\z:}', "");;
    Expect(1, 5942, '\p{Script_Extensions=	 hanunoo}', "");
    Expect(0, 5942, '\p{^Script_Extensions=	 hanunoo}', "");
    Expect(0, 5942, '\P{Script_Extensions=	 hanunoo}', "");
    Expect(1, 5942, '\P{^Script_Extensions=	 hanunoo}', "");
    Expect(0, 5943, '\p{Script_Extensions=	 hanunoo}', "");
    Expect(1, 5943, '\p{^Script_Extensions=	 hanunoo}', "");
    Expect(1, 5943, '\P{Script_Extensions=	 hanunoo}', "");
    Expect(0, 5943, '\P{^Script_Extensions=	 hanunoo}', "");
    Error('\p{Scx=-	Hano:=}');
    Error('\P{Scx=-	Hano:=}');
    Expect(1, 5942, '\p{Scx=:\AHano\z:}', "");;
    Expect(0, 5943, '\p{Scx=:\AHano\z:}', "");;
    Expect(1, 5942, '\p{Scx=hano}', "");
    Expect(0, 5942, '\p{^Scx=hano}', "");
    Expect(0, 5942, '\P{Scx=hano}', "");
    Expect(1, 5942, '\P{^Scx=hano}', "");
    Expect(0, 5943, '\p{Scx=hano}', "");
    Expect(1, 5943, '\p{^Scx=hano}', "");
    Expect(1, 5943, '\P{Scx=hano}', "");
    Expect(0, 5943, '\P{^Scx=hano}', "");
    Expect(1, 5942, '\p{Scx=:\Ahano\z:}', "");;
    Expect(0, 5943, '\p{Scx=:\Ahano\z:}', "");;
    Expect(1, 5942, '\p{Scx= 	Hano}', "");
    Expect(0, 5942, '\p{^Scx= 	Hano}', "");
    Expect(0, 5942, '\P{Scx= 	Hano}', "");
    Expect(1, 5942, '\P{^Scx= 	Hano}', "");
    Expect(0, 5943, '\p{Scx= 	Hano}', "");
    Expect(1, 5943, '\p{^Scx= 	Hano}', "");
    Expect(1, 5943, '\P{Scx= 	Hano}', "");
    Expect(0, 5943, '\P{^Scx= 	Hano}', "");
    Error('\p{Is_Script_Extensions:-:=Hanunoo}');
    Error('\P{Is_Script_Extensions:-:=Hanunoo}');
    Expect(1, 5942, '\p{Is_Script_Extensions=hanunoo}', "");
    Expect(0, 5942, '\p{^Is_Script_Extensions=hanunoo}', "");
    Expect(0, 5942, '\P{Is_Script_Extensions=hanunoo}', "");
    Expect(1, 5942, '\P{^Is_Script_Extensions=hanunoo}', "");
    Expect(0, 5943, '\p{Is_Script_Extensions=hanunoo}', "");
    Expect(1, 5943, '\p{^Is_Script_Extensions=hanunoo}', "");
    Expect(1, 5943, '\P{Is_Script_Extensions=hanunoo}', "");
    Expect(0, 5943, '\P{^Is_Script_Extensions=hanunoo}', "");
    Expect(1, 5942, '\p{Is_Script_Extensions: -Hanunoo}', "");
    Expect(0, 5942, '\p{^Is_Script_Extensions: -Hanunoo}', "");
    Expect(0, 5942, '\P{Is_Script_Extensions: -Hanunoo}', "");
    Expect(1, 5942, '\P{^Is_Script_Extensions: -Hanunoo}', "");
    Expect(0, 5943, '\p{Is_Script_Extensions: -Hanunoo}', "");
    Expect(1, 5943, '\p{^Is_Script_Extensions: -Hanunoo}', "");
    Expect(1, 5943, '\P{Is_Script_Extensions: -Hanunoo}', "");
    Expect(0, 5943, '\P{^Is_Script_Extensions: -Hanunoo}', "");
    Error('\p{Is_Scx=_/a/Hano}');
    Error('\P{Is_Scx=_/a/Hano}');
    Expect(1, 5942, '\p{Is_Scx=hano}', "");
    Expect(0, 5942, '\p{^Is_Scx=hano}', "");
    Expect(0, 5942, '\P{Is_Scx=hano}', "");
    Expect(1, 5942, '\P{^Is_Scx=hano}', "");
    Expect(0, 5943, '\p{Is_Scx=hano}', "");
    Expect(1, 5943, '\p{^Is_Scx=hano}', "");
    Expect(1, 5943, '\P{Is_Scx=hano}', "");
    Expect(0, 5943, '\P{^Is_Scx=hano}', "");
    Expect(1, 5942, '\p{Is_Scx=-hano}', "");
    Expect(0, 5942, '\p{^Is_Scx=-hano}', "");
    Expect(0, 5942, '\P{Is_Scx=-hano}', "");
    Expect(1, 5942, '\P{^Is_Scx=-hano}', "");
    Expect(0, 5943, '\p{Is_Scx=-hano}', "");
    Expect(1, 5943, '\p{^Is_Scx=-hano}', "");
    Expect(1, 5943, '\P{Is_Scx=-hano}', "");
    Expect(0, 5943, '\P{^Is_Scx=-hano}', "");
    Error('\p{Script_Extensions=-	HATRAN:=}');
    Error('\P{Script_Extensions=-	HATRAN:=}');
    Expect(1, 67839, '\p{Script_Extensions=:\AHatran\z:}', "");;
    Expect(0, 67840, '\p{Script_Extensions=:\AHatran\z:}', "");;
    Expect(1, 67839, '\p{Script_Extensions=hatran}', "");
    Expect(0, 67839, '\p{^Script_Extensions=hatran}', "");
    Expect(0, 67839, '\P{Script_Extensions=hatran}', "");
    Expect(1, 67839, '\P{^Script_Extensions=hatran}', "");
    Expect(0, 67840, '\p{Script_Extensions=hatran}', "");
    Expect(1, 67840, '\p{^Script_Extensions=hatran}', "");
    Expect(1, 67840, '\P{Script_Extensions=hatran}', "");
    Expect(0, 67840, '\P{^Script_Extensions=hatran}', "");
    Expect(1, 67839, '\p{Script_Extensions=:\Ahatran\z:}', "");;
    Expect(0, 67840, '\p{Script_Extensions=:\Ahatran\z:}', "");;
    Expect(1, 67839, '\p{Script_Extensions=_hatran}', "");
    Expect(0, 67839, '\p{^Script_Extensions=_hatran}', "");
    Expect(0, 67839, '\P{Script_Extensions=_hatran}', "");
    Expect(1, 67839, '\P{^Script_Extensions=_hatran}', "");
    Expect(0, 67840, '\p{Script_Extensions=_hatran}', "");
    Expect(1, 67840, '\p{^Script_Extensions=_hatran}', "");
    Expect(1, 67840, '\P{Script_Extensions=_hatran}', "");
    Expect(0, 67840, '\P{^Script_Extensions=_hatran}', "");
    Error('\p{Scx=  Hatr/a/}');
    Error('\P{Scx=  Hatr/a/}');
    Expect(1, 67839, '\p{Scx=:\AHatr\z:}', "");;
    Expect(0, 67840, '\p{Scx=:\AHatr\z:}', "");;
    Expect(1, 67839, '\p{Scx=hatr}', "");
    Expect(0, 67839, '\p{^Scx=hatr}', "");
    Expect(0, 67839, '\P{Scx=hatr}', "");
    Expect(1, 67839, '\P{^Scx=hatr}', "");
    Expect(0, 67840, '\p{Scx=hatr}', "");
    Expect(1, 67840, '\p{^Scx=hatr}', "");
    Expect(1, 67840, '\P{Scx=hatr}', "");
    Expect(0, 67840, '\P{^Scx=hatr}', "");
    Expect(1, 67839, '\p{Scx=:\Ahatr\z:}', "");;
    Expect(0, 67840, '\p{Scx=:\Ahatr\z:}', "");;
    Expect(1, 67839, '\p{Scx= 	HATR}', "");
    Expect(0, 67839, '\p{^Scx= 	HATR}', "");
    Expect(0, 67839, '\P{Scx= 	HATR}', "");
    Expect(1, 67839, '\P{^Scx= 	HATR}', "");
    Expect(0, 67840, '\p{Scx= 	HATR}', "");
    Expect(1, 67840, '\p{^Scx= 	HATR}', "");
    Expect(1, 67840, '\P{Scx= 	HATR}', "");
    Expect(0, 67840, '\P{^Scx= 	HATR}', "");
    Error('\p{Is_Script_Extensions=:=-hatran}');
    Error('\P{Is_Script_Extensions=:=-hatran}');
    Expect(1, 67839, '\p{Is_Script_Extensions:hatran}', "");
    Expect(0, 67839, '\p{^Is_Script_Extensions:hatran}', "");
    Expect(0, 67839, '\P{Is_Script_Extensions:hatran}', "");
    Expect(1, 67839, '\P{^Is_Script_Extensions:hatran}', "");
    Expect(0, 67840, '\p{Is_Script_Extensions:hatran}', "");
    Expect(1, 67840, '\p{^Is_Script_Extensions:hatran}', "");
    Expect(1, 67840, '\P{Is_Script_Extensions:hatran}', "");
    Expect(0, 67840, '\P{^Is_Script_Extensions:hatran}', "");
    Expect(1, 67839, '\p{Is_Script_Extensions=_	Hatran}', "");
    Expect(0, 67839, '\p{^Is_Script_Extensions=_	Hatran}', "");
    Expect(0, 67839, '\P{Is_Script_Extensions=_	Hatran}', "");
    Expect(1, 67839, '\P{^Is_Script_Extensions=_	Hatran}', "");
    Expect(0, 67840, '\p{Is_Script_Extensions=_	Hatran}', "");
    Expect(1, 67840, '\p{^Is_Script_Extensions=_	Hatran}', "");
    Expect(1, 67840, '\P{Is_Script_Extensions=_	Hatran}', "");
    Expect(0, 67840, '\P{^Is_Script_Extensions=_	Hatran}', "");
    Error('\p{Is_Scx=	 HATR:=}');
    Error('\P{Is_Scx=	 HATR:=}');
    Expect(1, 67839, '\p{Is_Scx=hatr}', "");
    Expect(0, 67839, '\p{^Is_Scx=hatr}', "");
    Expect(0, 67839, '\P{Is_Scx=hatr}', "");
    Expect(1, 67839, '\P{^Is_Scx=hatr}', "");
    Expect(0, 67840, '\p{Is_Scx=hatr}', "");
    Expect(1, 67840, '\p{^Is_Scx=hatr}', "");
    Expect(1, 67840, '\P{Is_Scx=hatr}', "");
    Expect(0, 67840, '\P{^Is_Scx=hatr}', "");
    Expect(1, 67839, '\p{Is_Scx=	hatr}', "");
    Expect(0, 67839, '\p{^Is_Scx=	hatr}', "");
    Expect(0, 67839, '\P{Is_Scx=	hatr}', "");
    Expect(1, 67839, '\P{^Is_Scx=	hatr}', "");
    Expect(0, 67840, '\p{Is_Scx=	hatr}', "");
    Expect(1, 67840, '\p{^Is_Scx=	hatr}', "");
    Expect(1, 67840, '\P{Is_Scx=	hatr}', "");
    Expect(0, 67840, '\P{^Is_Scx=	hatr}', "");
    Error('\p{Script_Extensions=:=Hebrew}');
    Error('\P{Script_Extensions=:=Hebrew}');
    Expect(1, 64335, '\p{Script_Extensions=:\AHebrew\z:}', "");;
    Expect(0, 64336, '\p{Script_Extensions=:\AHebrew\z:}', "");;
    Expect(1, 64335, '\p{Script_Extensions=hebrew}', "");
    Expect(0, 64335, '\p{^Script_Extensions=hebrew}', "");
    Expect(0, 64335, '\P{Script_Extensions=hebrew}', "");
    Expect(1, 64335, '\P{^Script_Extensions=hebrew}', "");
    Expect(0, 64336, '\p{Script_Extensions=hebrew}', "");
    Expect(1, 64336, '\p{^Script_Extensions=hebrew}', "");
    Expect(1, 64336, '\P{Script_Extensions=hebrew}', "");
    Expect(0, 64336, '\P{^Script_Extensions=hebrew}', "");
    Expect(1, 64335, '\p{Script_Extensions=:\Ahebrew\z:}', "");;
    Expect(0, 64336, '\p{Script_Extensions=:\Ahebrew\z:}', "");;
    Expect(1, 64335, '\p{Script_Extensions=_	Hebrew}', "");
    Expect(0, 64335, '\p{^Script_Extensions=_	Hebrew}', "");
    Expect(0, 64335, '\P{Script_Extensions=_	Hebrew}', "");
    Expect(1, 64335, '\P{^Script_Extensions=_	Hebrew}', "");
    Expect(0, 64336, '\p{Script_Extensions=_	Hebrew}', "");
    Expect(1, 64336, '\p{^Script_Extensions=_	Hebrew}', "");
    Expect(1, 64336, '\P{Script_Extensions=_	Hebrew}', "");
    Expect(0, 64336, '\P{^Script_Extensions=_	Hebrew}', "");
    Error('\p{Scx=:=-hebr}');
    Error('\P{Scx=:=-hebr}');
    Expect(1, 64335, '\p{Scx=:\AHebr\z:}', "");;
    Expect(0, 64336, '\p{Scx=:\AHebr\z:}', "");;
    Expect(1, 64335, '\p{Scx=hebr}', "");
    Expect(0, 64335, '\p{^Scx=hebr}', "");
    Expect(0, 64335, '\P{Scx=hebr}', "");
    Expect(1, 64335, '\P{^Scx=hebr}', "");
    Expect(0, 64336, '\p{Scx=hebr}', "");
    Expect(1, 64336, '\p{^Scx=hebr}', "");
    Expect(1, 64336, '\P{Scx=hebr}', "");
    Expect(0, 64336, '\P{^Scx=hebr}', "");
    Expect(1, 64335, '\p{Scx=:\Ahebr\z:}', "");;
    Expect(0, 64336, '\p{Scx=:\Ahebr\z:}', "");;
    Expect(1, 64335, '\p{Scx=__Hebr}', "");
    Expect(0, 64335, '\p{^Scx=__Hebr}', "");
    Expect(0, 64335, '\P{Scx=__Hebr}', "");
    Expect(1, 64335, '\P{^Scx=__Hebr}', "");
    Expect(0, 64336, '\p{Scx=__Hebr}', "");
    Expect(1, 64336, '\p{^Scx=__Hebr}', "");
    Expect(1, 64336, '\P{Scx=__Hebr}', "");
    Expect(0, 64336, '\P{^Scx=__Hebr}', "");
    Error('\p{Is_Script_Extensions=:=_-Hebrew}');
    Error('\P{Is_Script_Extensions=:=_-Hebrew}');
    Expect(1, 64335, '\p{Is_Script_Extensions=hebrew}', "");
    Expect(0, 64335, '\p{^Is_Script_Extensions=hebrew}', "");
    Expect(0, 64335, '\P{Is_Script_Extensions=hebrew}', "");
    Expect(1, 64335, '\P{^Is_Script_Extensions=hebrew}', "");
    Expect(0, 64336, '\p{Is_Script_Extensions=hebrew}', "");
    Expect(1, 64336, '\p{^Is_Script_Extensions=hebrew}', "");
    Expect(1, 64336, '\P{Is_Script_Extensions=hebrew}', "");
    Expect(0, 64336, '\P{^Is_Script_Extensions=hebrew}', "");
    Expect(1, 64335, '\p{Is_Script_Extensions=__hebrew}', "");
    Expect(0, 64335, '\p{^Is_Script_Extensions=__hebrew}', "");
    Expect(0, 64335, '\P{Is_Script_Extensions=__hebrew}', "");
    Expect(1, 64335, '\P{^Is_Script_Extensions=__hebrew}', "");
    Expect(0, 64336, '\p{Is_Script_Extensions=__hebrew}', "");
    Expect(1, 64336, '\p{^Is_Script_Extensions=__hebrew}', "");
    Expect(1, 64336, '\P{Is_Script_Extensions=__hebrew}', "");
    Expect(0, 64336, '\P{^Is_Script_Extensions=__hebrew}', "");
    Error('\p{Is_Scx=-:=hebr}');
    Error('\P{Is_Scx=-:=hebr}');
    Expect(1, 64335, '\p{Is_Scx=hebr}', "");
    Expect(0, 64335, '\p{^Is_Scx=hebr}', "");
    Expect(0, 64335, '\P{Is_Scx=hebr}', "");
    Expect(1, 64335, '\P{^Is_Scx=hebr}', "");
    Expect(0, 64336, '\p{Is_Scx=hebr}', "");
    Expect(1, 64336, '\p{^Is_Scx=hebr}', "");
    Expect(1, 64336, '\P{Is_Scx=hebr}', "");
    Expect(0, 64336, '\P{^Is_Scx=hebr}', "");
    Expect(1, 64335, '\p{Is_Scx:   		Hebr}', "");
    Expect(0, 64335, '\p{^Is_Scx:   		Hebr}', "");
    Expect(0, 64335, '\P{Is_Scx:   		Hebr}', "");
    Expect(1, 64335, '\P{^Is_Scx:   		Hebr}', "");
    Expect(0, 64336, '\p{Is_Scx:   		Hebr}', "");
    Expect(1, 64336, '\p{^Is_Scx:   		Hebr}', "");
    Expect(1, 64336, '\P{Is_Scx:   		Hebr}', "");
    Expect(0, 64336, '\P{^Is_Scx:   		Hebr}', "");
    Error('\p{Script_Extensions=:=  HIRAGANA}');
    Error('\P{Script_Extensions=:=  HIRAGANA}');
    Expect(1, 127488, '\p{Script_Extensions=:\AHiragana\z:}', "");;
    Expect(0, 127489, '\p{Script_Extensions=:\AHiragana\z:}', "");;
    Expect(1, 127488, '\p{Script_Extensions=hiragana}', "");
    Expect(0, 127488, '\p{^Script_Extensions=hiragana}', "");
    Expect(0, 127488, '\P{Script_Extensions=hiragana}', "");
    Expect(1, 127488, '\P{^Script_Extensions=hiragana}', "");
    Expect(0, 127489, '\p{Script_Extensions=hiragana}', "");
    Expect(1, 127489, '\p{^Script_Extensions=hiragana}', "");
    Expect(1, 127489, '\P{Script_Extensions=hiragana}', "");
    Expect(0, 127489, '\P{^Script_Extensions=hiragana}', "");
    Expect(1, 127488, '\p{Script_Extensions=:\Ahiragana\z:}', "");;
    Expect(0, 127489, '\p{Script_Extensions=:\Ahiragana\z:}', "");;
    Expect(1, 127488, '\p{Script_Extensions=_ Hiragana}', "");
    Expect(0, 127488, '\p{^Script_Extensions=_ Hiragana}', "");
    Expect(0, 127488, '\P{Script_Extensions=_ Hiragana}', "");
    Expect(1, 127488, '\P{^Script_Extensions=_ Hiragana}', "");
    Expect(0, 127489, '\p{Script_Extensions=_ Hiragana}', "");
    Expect(1, 127489, '\p{^Script_Extensions=_ Hiragana}', "");
    Expect(1, 127489, '\P{Script_Extensions=_ Hiragana}', "");
    Expect(0, 127489, '\P{^Script_Extensions=_ Hiragana}', "");
    Error('\p{Scx=:=	Hira}');
    Error('\P{Scx=:=	Hira}');
    Expect(1, 127488, '\p{Scx=:\AHira\z:}', "");;
    Expect(0, 127489, '\p{Scx=:\AHira\z:}', "");;
    Expect(1, 127488, '\p{Scx=hira}', "");
    Expect(0, 127488, '\p{^Scx=hira}', "");
    Expect(0, 127488, '\P{Scx=hira}', "");
    Expect(1, 127488, '\P{^Scx=hira}', "");
    Expect(0, 127489, '\p{Scx=hira}', "");
    Expect(1, 127489, '\p{^Scx=hira}', "");
    Expect(1, 127489, '\P{Scx=hira}', "");
    Expect(0, 127489, '\P{^Scx=hira}', "");
    Expect(1, 127488, '\p{Scx=:\Ahira\z:}', "");;
    Expect(0, 127489, '\p{Scx=:\Ahira\z:}', "");;
    Expect(1, 127488, '\p{Scx=-Hira}', "");
    Expect(0, 127488, '\p{^Scx=-Hira}', "");
    Expect(0, 127488, '\P{Scx=-Hira}', "");
    Expect(1, 127488, '\P{^Scx=-Hira}', "");
    Expect(0, 127489, '\p{Scx=-Hira}', "");
    Expect(1, 127489, '\p{^Scx=-Hira}', "");
    Expect(1, 127489, '\P{Scx=-Hira}', "");
    Expect(0, 127489, '\P{^Scx=-Hira}', "");
    Error('\p{Is_Script_Extensions=/a/ 	Hiragana}');
    Error('\P{Is_Script_Extensions=/a/ 	Hiragana}');
    Expect(1, 127488, '\p{Is_Script_Extensions=hiragana}', "");
    Expect(0, 127488, '\p{^Is_Script_Extensions=hiragana}', "");
    Expect(0, 127488, '\P{Is_Script_Extensions=hiragana}', "");
    Expect(1, 127488, '\P{^Is_Script_Extensions=hiragana}', "");
    Expect(0, 127489, '\p{Is_Script_Extensions=hiragana}', "");
    Expect(1, 127489, '\p{^Is_Script_Extensions=hiragana}', "");
    Expect(1, 127489, '\P{Is_Script_Extensions=hiragana}', "");
    Expect(0, 127489, '\P{^Is_Script_Extensions=hiragana}', "");
    Expect(1, 127488, '\p{Is_Script_Extensions=-HIRAGANA}', "");
    Expect(0, 127488, '\p{^Is_Script_Extensions=-HIRAGANA}', "");
    Expect(0, 127488, '\P{Is_Script_Extensions=-HIRAGANA}', "");
    Expect(1, 127488, '\P{^Is_Script_Extensions=-HIRAGANA}', "");
    Expect(0, 127489, '\p{Is_Script_Extensions=-HIRAGANA}', "");
    Expect(1, 127489, '\p{^Is_Script_Extensions=-HIRAGANA}', "");
    Expect(1, 127489, '\P{Is_Script_Extensions=-HIRAGANA}', "");
    Expect(0, 127489, '\P{^Is_Script_Extensions=-HIRAGANA}', "");
    Error('\p{Is_Scx=/a/_Hira}');
    Error('\P{Is_Scx=/a/_Hira}');
    Expect(1, 127488, '\p{Is_Scx=hira}', "");
    Expect(0, 127488, '\p{^Is_Scx=hira}', "");
    Expect(0, 127488, '\P{Is_Scx=hira}', "");
    Expect(1, 127488, '\P{^Is_Scx=hira}', "");
    Expect(0, 127489, '\p{Is_Scx=hira}', "");
    Expect(1, 127489, '\p{^Is_Scx=hira}', "");
    Expect(1, 127489, '\P{Is_Scx=hira}', "");
    Expect(0, 127489, '\P{^Is_Scx=hira}', "");
    Expect(1, 127488, '\p{Is_Scx:    _Hira}', "");
    Expect(0, 127488, '\p{^Is_Scx:    _Hira}', "");
    Expect(0, 127488, '\P{Is_Scx:    _Hira}', "");
    Expect(1, 127488, '\P{^Is_Scx:    _Hira}', "");
    Expect(0, 127489, '\p{Is_Scx:    _Hira}', "");
    Expect(1, 127489, '\p{^Is_Scx:    _Hira}', "");
    Expect(1, 127489, '\P{Is_Scx:    _Hira}', "");
    Expect(0, 127489, '\P{^Is_Scx:    _Hira}', "");
    Error('\p{Script_Extensions=:=-Anatolian_HIEROGLYPHS}');
    Error('\P{Script_Extensions=:=-Anatolian_HIEROGLYPHS}');
    Expect(1, 83526, '\p{Script_Extensions=:\AAnatolian_Hieroglyphs\z:}', "");;
    Expect(0, 83527, '\p{Script_Extensions=:\AAnatolian_Hieroglyphs\z:}', "");;
    Expect(1, 83526, '\p{Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83526, '\p{^Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83526, '\P{Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83526, '\P{^Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83527, '\p{Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83527, '\p{^Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83527, '\P{Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83527, '\P{^Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83526, '\p{Script_Extensions=:\Aanatolianhieroglyphs\z:}', "");;
    Expect(0, 83527, '\p{Script_Extensions=:\Aanatolianhieroglyphs\z:}', "");;
    Expect(1, 83526, '\p{Script_Extensions=_-anatolian_HIEROGLYPHS}', "");
    Expect(0, 83526, '\p{^Script_Extensions=_-anatolian_HIEROGLYPHS}', "");
    Expect(0, 83526, '\P{Script_Extensions=_-anatolian_HIEROGLYPHS}', "");
    Expect(1, 83526, '\P{^Script_Extensions=_-anatolian_HIEROGLYPHS}', "");
    Expect(0, 83527, '\p{Script_Extensions=_-anatolian_HIEROGLYPHS}', "");
    Expect(1, 83527, '\p{^Script_Extensions=_-anatolian_HIEROGLYPHS}', "");
    Expect(1, 83527, '\P{Script_Extensions=_-anatolian_HIEROGLYPHS}', "");
    Expect(0, 83527, '\P{^Script_Extensions=_-anatolian_HIEROGLYPHS}', "");
    Error('\p{Scx=/a/_Hluw}');
    Error('\P{Scx=/a/_Hluw}');
    Expect(1, 83526, '\p{Scx=:\AHluw\z:}', "");;
    Expect(0, 83527, '\p{Scx=:\AHluw\z:}', "");;
    Expect(1, 83526, '\p{Scx=hluw}', "");
    Expect(0, 83526, '\p{^Scx=hluw}', "");
    Expect(0, 83526, '\P{Scx=hluw}', "");
    Expect(1, 83526, '\P{^Scx=hluw}', "");
    Expect(0, 83527, '\p{Scx=hluw}', "");
    Expect(1, 83527, '\p{^Scx=hluw}', "");
    Expect(1, 83527, '\P{Scx=hluw}', "");
    Expect(0, 83527, '\P{^Scx=hluw}', "");
    Expect(1, 83526, '\p{Scx=:\Ahluw\z:}', "");;
    Expect(0, 83527, '\p{Scx=:\Ahluw\z:}', "");;
    Expect(1, 83526, '\p{Scx=- Hluw}', "");
    Expect(0, 83526, '\p{^Scx=- Hluw}', "");
    Expect(0, 83526, '\P{Scx=- Hluw}', "");
    Expect(1, 83526, '\P{^Scx=- Hluw}', "");
    Expect(0, 83527, '\p{Scx=- Hluw}', "");
    Expect(1, 83527, '\p{^Scx=- Hluw}', "");
    Expect(1, 83527, '\P{Scx=- Hluw}', "");
    Expect(0, 83527, '\P{^Scx=- Hluw}', "");
    Error('\p{Is_Script_Extensions= Anatolian_HIEROGLYPHS:=}');
    Error('\P{Is_Script_Extensions= Anatolian_HIEROGLYPHS:=}');
    Expect(1, 83526, '\p{Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83526, '\p{^Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83526, '\P{Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83526, '\P{^Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83527, '\p{Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83527, '\p{^Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83527, '\P{Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(0, 83527, '\P{^Is_Script_Extensions=anatolianhieroglyphs}', "");
    Expect(1, 83526, '\p{Is_Script_Extensions=	Anatolian_Hieroglyphs}', "");
    Expect(0, 83526, '\p{^Is_Script_Extensions=	Anatolian_Hieroglyphs}', "");
    Expect(0, 83526, '\P{Is_Script_Extensions=	Anatolian_Hieroglyphs}', "");
    Expect(1, 83526, '\P{^Is_Script_Extensions=	Anatolian_Hieroglyphs}', "");
    Expect(0, 83527, '\p{Is_Script_Extensions=	Anatolian_Hieroglyphs}', "");
    Expect(1, 83527, '\p{^Is_Script_Extensions=	Anatolian_Hieroglyphs}', "");
    Expect(1, 83527, '\P{Is_Script_Extensions=	Anatolian_Hieroglyphs}', "");
    Expect(0, 83527, '\P{^Is_Script_Extensions=	Anatolian_Hieroglyphs}', "");
    Error('\p{Is_Scx= _Hluw:=}');
    Error('\P{Is_Scx= _Hluw:=}');
    Expect(1, 83526, '\p{Is_Scx=hluw}', "");
    Expect(0, 83526, '\p{^Is_Scx=hluw}', "");
    Expect(0, 83526, '\P{Is_Scx=hluw}', "");
    Expect(1, 83526, '\P{^Is_Scx=hluw}', "");
    Expect(0, 83527, '\p{Is_Scx=hluw}', "");
    Expect(1, 83527, '\p{^Is_Scx=hluw}', "");
    Expect(1, 83527, '\P{Is_Scx=hluw}', "");
    Expect(0, 83527, '\P{^Is_Scx=hluw}', "");
    Expect(1, 83526, '\p{Is_Scx:   -hluw}', "");
    Expect(0, 83526, '\p{^Is_Scx:   -hluw}', "");
    Expect(0, 83526, '\P{Is_Scx:   -hluw}', "");
    Expect(1, 83526, '\P{^Is_Scx:   -hluw}', "");
    Expect(0, 83527, '\p{Is_Scx:   -hluw}', "");
    Expect(1, 83527, '\p{^Is_Scx:   -hluw}', "");
    Expect(1, 83527, '\P{Is_Scx:   -hluw}', "");
    Expect(0, 83527, '\P{^Is_Scx:   -hluw}', "");
    Error('\p{Script_Extensions=_PAHAWH_Hmong:=}');
    Error('\P{Script_Extensions=_PAHAWH_Hmong:=}');
    Expect(1, 93071, '\p{Script_Extensions=:\APahawh_Hmong\z:}', "");;
    Expect(0, 93072, '\p{Script_Extensions=:\APahawh_Hmong\z:}', "");;
    Expect(1, 93071, '\p{Script_Extensions=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Script_Extensions=pahawhhmong}', "");
    Expect(0, 93071, '\P{Script_Extensions=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Script_Extensions=pahawhhmong}', "");
    Expect(0, 93072, '\p{Script_Extensions=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Script_Extensions=pahawhhmong}', "");
    Expect(1, 93072, '\P{Script_Extensions=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Script_Extensions=pahawhhmong}', "");
    Expect(1, 93071, '\p{Script_Extensions=:\Apahawhhmong\z:}', "");;
    Expect(0, 93072, '\p{Script_Extensions=:\Apahawhhmong\z:}', "");;
    Expect(1, 93071, '\p{Script_Extensions=	-pahawh_HMONG}', "");
    Expect(0, 93071, '\p{^Script_Extensions=	-pahawh_HMONG}', "");
    Expect(0, 93071, '\P{Script_Extensions=	-pahawh_HMONG}', "");
    Expect(1, 93071, '\P{^Script_Extensions=	-pahawh_HMONG}', "");
    Expect(0, 93072, '\p{Script_Extensions=	-pahawh_HMONG}', "");
    Expect(1, 93072, '\p{^Script_Extensions=	-pahawh_HMONG}', "");
    Expect(1, 93072, '\P{Script_Extensions=	-pahawh_HMONG}', "");
    Expect(0, 93072, '\P{^Script_Extensions=	-pahawh_HMONG}', "");
    Error('\p{Scx:_:=HMNG}');
    Error('\P{Scx:_:=HMNG}');
    Expect(1, 93071, '\p{Scx=:\AHmng\z:}', "");;
    Expect(0, 93072, '\p{Scx=:\AHmng\z:}', "");;
    Expect(1, 93071, '\p{Scx:hmng}', "");
    Expect(0, 93071, '\p{^Scx:hmng}', "");
    Expect(0, 93071, '\P{Scx:hmng}', "");
    Expect(1, 93071, '\P{^Scx:hmng}', "");
    Expect(0, 93072, '\p{Scx:hmng}', "");
    Expect(1, 93072, '\p{^Scx:hmng}', "");
    Expect(1, 93072, '\P{Scx:hmng}', "");
    Expect(0, 93072, '\P{^Scx:hmng}', "");
    Expect(1, 93071, '\p{Scx=:\Ahmng\z:}', "");;
    Expect(0, 93072, '\p{Scx=:\Ahmng\z:}', "");;
    Expect(1, 93071, '\p{Scx=--HMNG}', "");
    Expect(0, 93071, '\p{^Scx=--HMNG}', "");
    Expect(0, 93071, '\P{Scx=--HMNG}', "");
    Expect(1, 93071, '\P{^Scx=--HMNG}', "");
    Expect(0, 93072, '\p{Scx=--HMNG}', "");
    Expect(1, 93072, '\p{^Scx=--HMNG}', "");
    Expect(1, 93072, '\P{Scx=--HMNG}', "");
    Expect(0, 93072, '\P{^Scx=--HMNG}', "");
    Error('\p{Is_Script_Extensions=_PAHAWH_Hmong/a/}');
    Error('\P{Is_Script_Extensions=_PAHAWH_Hmong/a/}');
    Expect(1, 93071, '\p{Is_Script_Extensions=pahawhhmong}', "");
    Expect(0, 93071, '\p{^Is_Script_Extensions=pahawhhmong}', "");
    Expect(0, 93071, '\P{Is_Script_Extensions=pahawhhmong}', "");
    Expect(1, 93071, '\P{^Is_Script_Extensions=pahawhhmong}', "");
    Expect(0, 93072, '\p{Is_Script_Extensions=pahawhhmong}', "");
    Expect(1, 93072, '\p{^Is_Script_Extensions=pahawhhmong}', "");
    Expect(1, 93072, '\P{Is_Script_Extensions=pahawhhmong}', "");
    Expect(0, 93072, '\P{^Is_Script_Extensions=pahawhhmong}', "");
    Expect(1, 93071, '\p{Is_Script_Extensions: 	pahawh_hmong}', "");
    Expect(0, 93071, '\p{^Is_Script_Extensions: 	pahawh_hmong}', "");
    Expect(0, 93071, '\P{Is_Script_Extensions: 	pahawh_hmong}', "");
    Expect(1, 93071, '\P{^Is_Script_Extensions: 	pahawh_hmong}', "");
    Expect(0, 93072, '\p{Is_Script_Extensions: 	pahawh_hmong}', "");
    Expect(1, 93072, '\p{^Is_Script_Extensions: 	pahawh_hmong}', "");
    Expect(1, 93072, '\P{Is_Script_Extensions: 	pahawh_hmong}', "");
    Expect(0, 93072, '\P{^Is_Script_Extensions: 	pahawh_hmong}', "");
    Error('\p{Is_Scx=:=		HMNG}');
    Error('\P{Is_Scx=:=		HMNG}');
    Expect(1, 93071, '\p{Is_Scx=hmng}', "");
    Expect(0, 93071, '\p{^Is_Scx=hmng}', "");
    Expect(0, 93071, '\P{Is_Scx=hmng}', "");
    Expect(1, 93071, '\P{^Is_Scx=hmng}', "");
    Expect(0, 93072, '\p{Is_Scx=hmng}', "");
    Expect(1, 93072, '\p{^Is_Scx=hmng}', "");
    Expect(1, 93072, '\P{Is_Scx=hmng}', "");
    Expect(0, 93072, '\P{^Is_Scx=hmng}', "");
    Expect(1, 93071, '\p{Is_Scx=--Hmng}', "");
    Expect(0, 93071, '\p{^Is_Scx=--Hmng}', "");
    Expect(0, 93071, '\P{Is_Scx=--Hmng}', "");
    Expect(1, 93071, '\P{^Is_Scx=--Hmng}', "");
    Expect(0, 93072, '\p{Is_Scx=--Hmng}', "");
    Expect(1, 93072, '\p{^Is_Scx=--Hmng}', "");
    Expect(1, 93072, '\P{Is_Scx=--Hmng}', "");
    Expect(0, 93072, '\P{^Is_Scx=--Hmng}', "");
    Error('\p{Script_Extensions=	 nyiakeng_puachue_Hmong/a/}');
    Error('\P{Script_Extensions=	 nyiakeng_puachue_Hmong/a/}');
    Expect(1, 123215, '\p{Script_Extensions=:\ANyiakeng_Puachue_Hmong\z:}', "");;
    Expect(0, 123216, '\p{Script_Extensions=:\ANyiakeng_Puachue_Hmong\z:}', "");;
    Expect(1, 123215, '\p{Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{Script_Extensions=:\Anyiakengpuachuehmong\z:}', "");;
    Expect(0, 123216, '\p{Script_Extensions=:\Anyiakengpuachuehmong\z:}', "");;
    Expect(1, 123215, '\p{Script_Extensions=  Nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123215, '\p{^Script_Extensions=  Nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123215, '\P{Script_Extensions=  Nyiakeng_Puachue_Hmong}', "");
    Expect(1, 123215, '\P{^Script_Extensions=  Nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123216, '\p{Script_Extensions=  Nyiakeng_Puachue_Hmong}', "");
    Expect(1, 123216, '\p{^Script_Extensions=  Nyiakeng_Puachue_Hmong}', "");
    Expect(1, 123216, '\P{Script_Extensions=  Nyiakeng_Puachue_Hmong}', "");
    Expect(0, 123216, '\P{^Script_Extensions=  Nyiakeng_Puachue_Hmong}', "");
    Error('\p{Scx=/a/- hmnp}');
    Error('\P{Scx=/a/- hmnp}');
    Expect(1, 123215, '\p{Scx=:\AHmnp\z:}', "");;
    Expect(0, 123216, '\p{Scx=:\AHmnp\z:}', "");;
    Expect(1, 123215, '\p{Scx=hmnp}', "");
    Expect(0, 123215, '\p{^Scx=hmnp}', "");
    Expect(0, 123215, '\P{Scx=hmnp}', "");
    Expect(1, 123215, '\P{^Scx=hmnp}', "");
    Expect(0, 123216, '\p{Scx=hmnp}', "");
    Expect(1, 123216, '\p{^Scx=hmnp}', "");
    Expect(1, 123216, '\P{Scx=hmnp}', "");
    Expect(0, 123216, '\P{^Scx=hmnp}', "");
    Expect(1, 123215, '\p{Scx=:\Ahmnp\z:}', "");;
    Expect(0, 123216, '\p{Scx=:\Ahmnp\z:}', "");;
    Expect(1, 123215, '\p{Scx=_ Hmnp}', "");
    Expect(0, 123215, '\p{^Scx=_ Hmnp}', "");
    Expect(0, 123215, '\P{Scx=_ Hmnp}', "");
    Expect(1, 123215, '\P{^Scx=_ Hmnp}', "");
    Expect(0, 123216, '\p{Scx=_ Hmnp}', "");
    Expect(1, 123216, '\p{^Scx=_ Hmnp}', "");
    Expect(1, 123216, '\P{Scx=_ Hmnp}', "");
    Expect(0, 123216, '\P{^Scx=_ Hmnp}', "");
    Error('\p{Is_Script_Extensions=_NYIAKENG_puachue_HMONG:=}');
    Error('\P{Is_Script_Extensions=_NYIAKENG_puachue_HMONG:=}');
    Expect(1, 123215, '\p{Is_Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\p{^Is_Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(0, 123215, '\P{Is_Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\P{^Is_Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\p{Is_Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\p{^Is_Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(1, 123216, '\P{Is_Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(0, 123216, '\P{^Is_Script_Extensions=nyiakengpuachuehmong}', "");
    Expect(1, 123215, '\p{Is_Script_Extensions=-Nyiakeng_PUACHUE_Hmong}', "");
    Expect(0, 123215, '\p{^Is_Script_Extensions=-Nyiakeng_PUACHUE_Hmong}', "");
    Expect(0, 123215, '\P{Is_Script_Extensions=-Nyiakeng_PUACHUE_Hmong}', "");
    Expect(1, 123215, '\P{^Is_Script_Extensions=-Nyiakeng_PUACHUE_Hmong}', "");
    Expect(0, 123216, '\p{Is_Script_Extensions=-Nyiakeng_PUACHUE_Hmong}', "");
    Expect(1, 123216, '\p{^Is_Script_Extensions=-Nyiakeng_PUACHUE_Hmong}', "");
    Expect(1, 123216, '\P{Is_Script_Extensions=-Nyiakeng_PUACHUE_Hmong}', "");
    Expect(0, 123216, '\P{^Is_Script_Extensions=-Nyiakeng_PUACHUE_Hmong}', "");
    Error('\p{Is_Scx= /a/Hmnp}');
    Error('\P{Is_Scx= /a/Hmnp}');
    Expect(1, 123215, '\p{Is_Scx=hmnp}', "");
    Expect(0, 123215, '\p{^Is_Scx=hmnp}', "");
    Expect(0, 123215, '\P{Is_Scx=hmnp}', "");
    Expect(1, 123215, '\P{^Is_Scx=hmnp}', "");
    Expect(0, 123216, '\p{Is_Scx=hmnp}', "");
    Expect(1, 123216, '\p{^Is_Scx=hmnp}', "");
    Expect(1, 123216, '\P{Is_Scx=hmnp}', "");
    Expect(0, 123216, '\P{^Is_Scx=hmnp}', "");
    Expect(1, 123215, '\p{Is_Scx=_	HMNP}', "");
    Expect(0, 123215, '\p{^Is_Scx=_	HMNP}', "");
    Expect(0, 123215, '\P{Is_Scx=_	HMNP}', "");
    Expect(1, 123215, '\P{^Is_Scx=_	HMNP}', "");
    Expect(0, 123216, '\p{Is_Scx=_	HMNP}', "");
    Expect(1, 123216, '\p{^Is_Scx=_	HMNP}', "");
    Expect(1, 123216, '\P{Is_Scx=_	HMNP}', "");
    Expect(0, 123216, '\P{^Is_Scx=_	HMNP}', "");
    Error('\p{Script_Extensions:   Katakana_Or_Hiragana}');
    Error('\P{Script_Extensions:   Katakana_Or_Hiragana}');
    Error('\p{Scx=Hrkt}');
    Error('\P{Scx=Hrkt}');
    Error('\p{Is_Script_Extensions=Katakana_Or_Hiragana}');
    Error('\P{Is_Script_Extensions=Katakana_Or_Hiragana}');
    Error('\p{Is_Scx=Hrkt}');
    Error('\P{Is_Scx=Hrkt}');
    Error('\p{Script_Extensions:	-Old_Hungarian/a/}');
    Error('\P{Script_Extensions:	-Old_Hungarian/a/}');
    Expect(1, 68863, '\p{Script_Extensions=:\AOld_Hungarian\z:}', "");;
    Expect(0, 68864, '\p{Script_Extensions=:\AOld_Hungarian\z:}', "");;
    Expect(1, 68863, '\p{Script_Extensions=oldhungarian}', "");
    Expect(0, 68863, '\p{^Script_Extensions=oldhungarian}', "");
    Expect(0, 68863, '\P{Script_Extensions=oldhungarian}', "");
    Expect(1, 68863, '\P{^Script_Extensions=oldhungarian}', "");
    Expect(0, 68864, '\p{Script_Extensions=oldhungarian}', "");
    Expect(1, 68864, '\p{^Script_Extensions=oldhungarian}', "");
    Expect(1, 68864, '\P{Script_Extensions=oldhungarian}', "");
    Expect(0, 68864, '\P{^Script_Extensions=oldhungarian}', "");
    Expect(1, 68863, '\p{Script_Extensions=:\Aoldhungarian\z:}', "");;
    Expect(0, 68864, '\p{Script_Extensions=:\Aoldhungarian\z:}', "");;
    Expect(1, 68863, '\p{Script_Extensions=- old_Hungarian}', "");
    Expect(0, 68863, '\p{^Script_Extensions=- old_Hungarian}', "");
    Expect(0, 68863, '\P{Script_Extensions=- old_Hungarian}', "");
    Expect(1, 68863, '\P{^Script_Extensions=- old_Hungarian}', "");
    Expect(0, 68864, '\p{Script_Extensions=- old_Hungarian}', "");
    Expect(1, 68864, '\p{^Script_Extensions=- old_Hungarian}', "");
    Expect(1, 68864, '\P{Script_Extensions=- old_Hungarian}', "");
    Expect(0, 68864, '\P{^Script_Extensions=- old_Hungarian}', "");
    Error('\p{Scx=-/a/Hung}');
    Error('\P{Scx=-/a/Hung}');
    Expect(1, 68863, '\p{Scx=:\AHung\z:}', "");;
    Expect(0, 68864, '\p{Scx=:\AHung\z:}', "");;
    Expect(1, 68863, '\p{Scx=hung}', "");
    Expect(0, 68863, '\p{^Scx=hung}', "");
    Expect(0, 68863, '\P{Scx=hung}', "");
    Expect(1, 68863, '\P{^Scx=hung}', "");
    Expect(0, 68864, '\p{Scx=hung}', "");
    Expect(1, 68864, '\p{^Scx=hung}', "");
    Expect(1, 68864, '\P{Scx=hung}', "");
    Expect(0, 68864, '\P{^Scx=hung}', "");
    Expect(1, 68863, '\p{Scx=:\Ahung\z:}', "");;
    Expect(0, 68864, '\p{Scx=:\Ahung\z:}', "");;
    Expect(1, 68863, '\p{Scx:    -hung}', "");
    Expect(0, 68863, '\p{^Scx:    -hung}', "");
    Expect(0, 68863, '\P{Scx:    -hung}', "");
    Expect(1, 68863, '\P{^Scx:    -hung}', "");
    Expect(0, 68864, '\p{Scx:    -hung}', "");
    Expect(1, 68864, '\p{^Scx:    -hung}', "");
    Expect(1, 68864, '\P{Scx:    -hung}', "");
    Expect(0, 68864, '\P{^Scx:    -hung}', "");
    Error('\p{Is_Script_Extensions=:= _OLD_Hungarian}');
    Error('\P{Is_Script_Extensions=:= _OLD_Hungarian}');
    Expect(1, 68863, '\p{Is_Script_Extensions=oldhungarian}', "");
    Expect(0, 68863, '\p{^Is_Script_Extensions=oldhungarian}', "");
    Expect(0, 68863, '\P{Is_Script_Extensions=oldhungarian}', "");
    Expect(1, 68863, '\P{^Is_Script_Extensions=oldhungarian}', "");
    Expect(0, 68864, '\p{Is_Script_Extensions=oldhungarian}', "");
    Expect(1, 68864, '\p{^Is_Script_Extensions=oldhungarian}', "");
    Expect(1, 68864, '\P{Is_Script_Extensions=oldhungarian}', "");
    Expect(0, 68864, '\P{^Is_Script_Extensions=oldhungarian}', "");
    Expect(1, 68863, '\p{Is_Script_Extensions=_ Old_Hungarian}', "");
    Expect(0, 68863, '\p{^Is_Script_Extensions=_ Old_Hungarian}', "");
    Expect(0, 68863, '\P{Is_Script_Extensions=_ Old_Hungarian}', "");
    Expect(1, 68863, '\P{^Is_Script_Extensions=_ Old_Hungarian}', "");
    Expect(0, 68864, '\p{Is_Script_Extensions=_ Old_Hungarian}', "");
    Expect(1, 68864, '\p{^Is_Script_Extensions=_ Old_Hungarian}', "");
    Expect(1, 68864, '\P{Is_Script_Extensions=_ Old_Hungarian}', "");
    Expect(0, 68864, '\P{^Is_Script_Extensions=_ Old_Hungarian}', "");
    Error('\p{Is_Scx=:=	-Hung}');
    Error('\P{Is_Scx=:=	-Hung}');
    Expect(1, 68863, '\p{Is_Scx=hung}', "");
    Expect(0, 68863, '\p{^Is_Scx=hung}', "");
    Expect(0, 68863, '\P{Is_Scx=hung}', "");
    Expect(1, 68863, '\P{^Is_Scx=hung}', "");
    Expect(0, 68864, '\p{Is_Scx=hung}', "");
    Expect(1, 68864, '\p{^Is_Scx=hung}', "");
    Expect(1, 68864, '\P{Is_Scx=hung}', "");
    Expect(0, 68864, '\P{^Is_Scx=hung}', "");
    Expect(1, 68863, '\p{Is_Scx=	 Hung}', "");
    Expect(0, 68863, '\p{^Is_Scx=	 Hung}', "");
    Expect(0, 68863, '\P{Is_Scx=	 Hung}', "");
    Expect(1, 68863, '\P{^Is_Scx=	 Hung}', "");
    Expect(0, 68864, '\p{Is_Scx=	 Hung}', "");
    Expect(1, 68864, '\p{^Is_Scx=	 Hung}', "");
    Expect(1, 68864, '\P{Is_Scx=	 Hung}', "");
    Expect(0, 68864, '\P{^Is_Scx=	 Hung}', "");
    Error('\p{Script_Extensions=:= 	OLD_Italic}');
    Error('\P{Script_Extensions=:= 	OLD_Italic}');
    Expect(1, 66351, '\p{Script_Extensions=:\AOld_Italic\z:}', "");;
    Expect(0, 66352, '\p{Script_Extensions=:\AOld_Italic\z:}', "");;
    Expect(1, 66351, '\p{Script_Extensions=olditalic}', "");
    Expect(0, 66351, '\p{^Script_Extensions=olditalic}', "");
    Expect(0, 66351, '\P{Script_Extensions=olditalic}', "");
    Expect(1, 66351, '\P{^Script_Extensions=olditalic}', "");
    Expect(0, 66352, '\p{Script_Extensions=olditalic}', "");
    Expect(1, 66352, '\p{^Script_Extensions=olditalic}', "");
    Expect(1, 66352, '\P{Script_Extensions=olditalic}', "");
    Expect(0, 66352, '\P{^Script_Extensions=olditalic}', "");
    Expect(1, 66351, '\p{Script_Extensions=:\Aolditalic\z:}', "");;
    Expect(0, 66352, '\p{Script_Extensions=:\Aolditalic\z:}', "");;
    Expect(1, 66351, '\p{Script_Extensions=Old_italic}', "");
    Expect(0, 66351, '\p{^Script_Extensions=Old_italic}', "");
    Expect(0, 66351, '\P{Script_Extensions=Old_italic}', "");
    Expect(1, 66351, '\P{^Script_Extensions=Old_italic}', "");
    Expect(0, 66352, '\p{Script_Extensions=Old_italic}', "");
    Expect(1, 66352, '\p{^Script_Extensions=Old_italic}', "");
    Expect(1, 66352, '\P{Script_Extensions=Old_italic}', "");
    Expect(0, 66352, '\P{^Script_Extensions=Old_italic}', "");
    Error('\p{Scx=	Ital/a/}');
    Error('\P{Scx=	Ital/a/}');
    Expect(1, 66351, '\p{Scx=:\AItal\z:}', "");;
    Expect(0, 66352, '\p{Scx=:\AItal\z:}', "");;
    Expect(1, 66351, '\p{Scx=ital}', "");
    Expect(0, 66351, '\p{^Scx=ital}', "");
    Expect(0, 66351, '\P{Scx=ital}', "");
    Expect(1, 66351, '\P{^Scx=ital}', "");
    Expect(0, 66352, '\p{Scx=ital}', "");
    Expect(1, 66352, '\p{^Scx=ital}', "");
    Expect(1, 66352, '\P{Scx=ital}', "");
    Expect(0, 66352, '\P{^Scx=ital}', "");
    Expect(1, 66351, '\p{Scx=:\Aital\z:}', "");;
    Expect(0, 66352, '\p{Scx=:\Aital\z:}', "");;
    Expect(1, 66351, '\p{Scx:     Ital}', "");
    Expect(0, 66351, '\p{^Scx:     Ital}', "");
    Expect(0, 66351, '\P{Scx:     Ital}', "");
    Expect(1, 66351, '\P{^Scx:     Ital}', "");
    Expect(0, 66352, '\p{Scx:     Ital}', "");
    Expect(1, 66352, '\p{^Scx:     Ital}', "");
    Expect(1, 66352, '\P{Scx:     Ital}', "");
    Expect(0, 66352, '\P{^Scx:     Ital}', "");
    Error('\p{Is_Script_Extensions=-	Old_italic/a/}');
    Error('\P{Is_Script_Extensions=-	Old_italic/a/}');
    Expect(1, 66351, '\p{Is_Script_Extensions=olditalic}', "");
    Expect(0, 66351, '\p{^Is_Script_Extensions=olditalic}', "");
    Expect(0, 66351, '\P{Is_Script_Extensions=olditalic}', "");
    Expect(1, 66351, '\P{^Is_Script_Extensions=olditalic}', "");
    Expect(0, 66352, '\p{Is_Script_Extensions=olditalic}', "");
    Expect(1, 66352, '\p{^Is_Script_Extensions=olditalic}', "");
    Expect(1, 66352, '\P{Is_Script_Extensions=olditalic}', "");
    Expect(0, 66352, '\P{^Is_Script_Extensions=olditalic}', "");
    Expect(1, 66351, '\p{Is_Script_Extensions=-Old_ITALIC}', "");
    Expect(0, 66351, '\p{^Is_Script_Extensions=-Old_ITALIC}', "");
    Expect(0, 66351, '\P{Is_Script_Extensions=-Old_ITALIC}', "");
    Expect(1, 66351, '\P{^Is_Script_Extensions=-Old_ITALIC}', "");
    Expect(0, 66352, '\p{Is_Script_Extensions=-Old_ITALIC}', "");
    Expect(1, 66352, '\p{^Is_Script_Extensions=-Old_ITALIC}', "");
    Expect(1, 66352, '\P{Is_Script_Extensions=-Old_ITALIC}', "");
    Expect(0, 66352, '\P{^Is_Script_Extensions=-Old_ITALIC}', "");
    Error('\p{Is_Scx:   _:=Ital}');
    Error('\P{Is_Scx:   _:=Ital}');
    Expect(1, 66351, '\p{Is_Scx=ital}', "");
    Expect(0, 66351, '\p{^Is_Scx=ital}', "");
    Expect(0, 66351, '\P{Is_Scx=ital}', "");
    Expect(1, 66351, '\P{^Is_Scx=ital}', "");
    Expect(0, 66352, '\p{Is_Scx=ital}', "");
    Expect(1, 66352, '\p{^Is_Scx=ital}', "");
    Expect(1, 66352, '\P{Is_Scx=ital}', "");
    Expect(0, 66352, '\P{^Is_Scx=ital}', "");
    Expect(1, 66351, '\p{Is_Scx=	_Ital}', "");
    Expect(0, 66351, '\p{^Is_Scx=	_Ital}', "");
    Expect(0, 66351, '\P{Is_Scx=	_Ital}', "");
    Expect(1, 66351, '\P{^Is_Scx=	_Ital}', "");
    Expect(0, 66352, '\p{Is_Scx=	_Ital}', "");
    Expect(1, 66352, '\p{^Is_Scx=	_Ital}', "");
    Expect(1, 66352, '\P{Is_Scx=	_Ital}', "");
    Expect(0, 66352, '\P{^Is_Scx=	_Ital}', "");
    Error('\p{Script_Extensions:	/a/--Javanese}');
    Error('\P{Script_Extensions:	/a/--Javanese}');
    Expect(1, 43487, '\p{Script_Extensions=:\AJavanese\z:}', "");;
    Expect(0, 43488, '\p{Script_Extensions=:\AJavanese\z:}', "");;
    Expect(1, 43487, '\p{Script_Extensions=javanese}', "");
    Expect(0, 43487, '\p{^Script_Extensions=javanese}', "");
    Expect(0, 43487, '\P{Script_Extensions=javanese}', "");
    Expect(1, 43487, '\P{^Script_Extensions=javanese}', "");
    Expect(0, 43488, '\p{Script_Extensions=javanese}', "");
    Expect(1, 43488, '\p{^Script_Extensions=javanese}', "");
    Expect(1, 43488, '\P{Script_Extensions=javanese}', "");
    Expect(0, 43488, '\P{^Script_Extensions=javanese}', "");
    Expect(1, 43487, '\p{Script_Extensions=:\Ajavanese\z:}', "");;
    Expect(0, 43488, '\p{Script_Extensions=:\Ajavanese\z:}', "");;
    Expect(1, 43487, '\p{Script_Extensions= -Javanese}', "");
    Expect(0, 43487, '\p{^Script_Extensions= -Javanese}', "");
    Expect(0, 43487, '\P{Script_Extensions= -Javanese}', "");
    Expect(1, 43487, '\P{^Script_Extensions= -Javanese}', "");
    Expect(0, 43488, '\p{Script_Extensions= -Javanese}', "");
    Expect(1, 43488, '\p{^Script_Extensions= -Javanese}', "");
    Expect(1, 43488, '\P{Script_Extensions= -Javanese}', "");
    Expect(0, 43488, '\P{^Script_Extensions= -Javanese}', "");
    Error('\p{Scx=	_Java:=}');
    Error('\P{Scx=	_Java:=}');
    Expect(1, 43487, '\p{Scx=:\AJava\z:}', "");;
    Expect(0, 43488, '\p{Scx=:\AJava\z:}', "");;
    Expect(1, 43487, '\p{Scx=java}', "");
    Expect(0, 43487, '\p{^Scx=java}', "");
    Expect(0, 43487, '\P{Scx=java}', "");
    Expect(1, 43487, '\P{^Scx=java}', "");
    Expect(0, 43488, '\p{Scx=java}', "");
    Expect(1, 43488, '\p{^Scx=java}', "");
    Expect(1, 43488, '\P{Scx=java}', "");
    Expect(0, 43488, '\P{^Scx=java}', "");
    Expect(1, 43487, '\p{Scx=:\Ajava\z:}', "");;
    Expect(0, 43488, '\p{Scx=:\Ajava\z:}', "");;
    Expect(1, 43487, '\p{Scx=  Java}', "");
    Expect(0, 43487, '\p{^Scx=  Java}', "");
    Expect(0, 43487, '\P{Scx=  Java}', "");
    Expect(1, 43487, '\P{^Scx=  Java}', "");
    Expect(0, 43488, '\p{Scx=  Java}', "");
    Expect(1, 43488, '\p{^Scx=  Java}', "");
    Expect(1, 43488, '\P{Scx=  Java}', "");
    Expect(0, 43488, '\P{^Scx=  Java}', "");
    Error('\p{Is_Script_Extensions=-/a/Javanese}');
    Error('\P{Is_Script_Extensions=-/a/Javanese}');
    Expect(1, 43487, '\p{Is_Script_Extensions=javanese}', "");
    Expect(0, 43487, '\p{^Is_Script_Extensions=javanese}', "");
    Expect(0, 43487, '\P{Is_Script_Extensions=javanese}', "");
    Expect(1, 43487, '\P{^Is_Script_Extensions=javanese}', "");
    Expect(0, 43488, '\p{Is_Script_Extensions=javanese}', "");
    Expect(1, 43488, '\p{^Is_Script_Extensions=javanese}', "");
    Expect(1, 43488, '\P{Is_Script_Extensions=javanese}', "");
    Expect(0, 43488, '\P{^Is_Script_Extensions=javanese}', "");
    Expect(1, 43487, '\p{Is_Script_Extensions=	Javanese}', "");
    Expect(0, 43487, '\p{^Is_Script_Extensions=	Javanese}', "");
    Expect(0, 43487, '\P{Is_Script_Extensions=	Javanese}', "");
    Expect(1, 43487, '\P{^Is_Script_Extensions=	Javanese}', "");
    Expect(0, 43488, '\p{Is_Script_Extensions=	Javanese}', "");
    Expect(1, 43488, '\p{^Is_Script_Extensions=	Javanese}', "");
    Expect(1, 43488, '\P{Is_Script_Extensions=	Javanese}', "");
    Expect(0, 43488, '\P{^Is_Script_Extensions=	Javanese}', "");
    Error('\p{Is_Scx=:=	_Java}');
    Error('\P{Is_Scx=:=	_Java}');
    Expect(1, 43487, '\p{Is_Scx=java}', "");
    Expect(0, 43487, '\p{^Is_Scx=java}', "");
    Expect(0, 43487, '\P{Is_Scx=java}', "");
    Expect(1, 43487, '\P{^Is_Scx=java}', "");
    Expect(0, 43488, '\p{Is_Scx=java}', "");
    Expect(1, 43488, '\p{^Is_Scx=java}', "");
    Expect(1, 43488, '\P{Is_Scx=java}', "");
    Expect(0, 43488, '\P{^Is_Scx=java}', "");
    Expect(1, 43487, '\p{Is_Scx= _JAVA}', "");
    Expect(0, 43487, '\p{^Is_Scx= _JAVA}', "");
    Expect(0, 43487, '\P{Is_Scx= _JAVA}', "");
    Expect(1, 43487, '\P{^Is_Scx= _JAVA}', "");
    Expect(0, 43488, '\p{Is_Scx= _JAVA}', "");
    Expect(1, 43488, '\p{^Is_Scx= _JAVA}', "");
    Expect(1, 43488, '\P{Is_Scx= _JAVA}', "");
    Expect(0, 43488, '\P{^Is_Scx= _JAVA}', "");
    Error('\p{Script_Extensions=/a/KAYAH_li}');
    Error('\P{Script_Extensions=/a/KAYAH_li}');
    Expect(1, 43311, '\p{Script_Extensions=:\AKayah_Li\z:}', "");;
    Expect(0, 43312, '\p{Script_Extensions=:\AKayah_Li\z:}', "");;
    Expect(1, 43311, '\p{Script_Extensions=kayahli}', "");
    Expect(0, 43311, '\p{^Script_Extensions=kayahli}', "");
    Expect(0, 43311, '\P{Script_Extensions=kayahli}', "");
    Expect(1, 43311, '\P{^Script_Extensions=kayahli}', "");
    Expect(0, 43312, '\p{Script_Extensions=kayahli}', "");
    Expect(1, 43312, '\p{^Script_Extensions=kayahli}', "");
    Expect(1, 43312, '\P{Script_Extensions=kayahli}', "");
    Expect(0, 43312, '\P{^Script_Extensions=kayahli}', "");
    Expect(1, 43311, '\p{Script_Extensions=:\Akayahli\z:}', "");;
    Expect(0, 43312, '\p{Script_Extensions=:\Akayahli\z:}', "");;
    Expect(1, 43311, '\p{Script_Extensions=	-KAYAH_li}', "");
    Expect(0, 43311, '\p{^Script_Extensions=	-KAYAH_li}', "");
    Expect(0, 43311, '\P{Script_Extensions=	-KAYAH_li}', "");
    Expect(1, 43311, '\P{^Script_Extensions=	-KAYAH_li}', "");
    Expect(0, 43312, '\p{Script_Extensions=	-KAYAH_li}', "");
    Expect(1, 43312, '\p{^Script_Extensions=	-KAYAH_li}', "");
    Expect(1, 43312, '\P{Script_Extensions=	-KAYAH_li}', "");
    Expect(0, 43312, '\P{^Script_Extensions=	-KAYAH_li}', "");
    Error('\p{Scx=:=	Kali}');
    Error('\P{Scx=:=	Kali}');
    Expect(1, 43311, '\p{Scx=:\AKali\z:}', "");;
    Expect(0, 43312, '\p{Scx=:\AKali\z:}', "");;
    Expect(1, 43311, '\p{Scx:   kali}', "");
    Expect(0, 43311, '\p{^Scx:   kali}', "");
    Expect(0, 43311, '\P{Scx:   kali}', "");
    Expect(1, 43311, '\P{^Scx:   kali}', "");
    Expect(0, 43312, '\p{Scx:   kali}', "");
    Expect(1, 43312, '\p{^Scx:   kali}', "");
    Expect(1, 43312, '\P{Scx:   kali}', "");
    Expect(0, 43312, '\P{^Scx:   kali}', "");
    Expect(1, 43311, '\p{Scx=:\Akali\z:}', "");;
    Expect(0, 43312, '\p{Scx=:\Akali\z:}', "");;
    Expect(1, 43311, '\p{Scx=-_Kali}', "");
    Expect(0, 43311, '\p{^Scx=-_Kali}', "");
    Expect(0, 43311, '\P{Scx=-_Kali}', "");
    Expect(1, 43311, '\P{^Scx=-_Kali}', "");
    Expect(0, 43312, '\p{Scx=-_Kali}', "");
    Expect(1, 43312, '\p{^Scx=-_Kali}', "");
    Expect(1, 43312, '\P{Scx=-_Kali}', "");
    Expect(0, 43312, '\P{^Scx=-_Kali}', "");
    Error('\p{Is_Script_Extensions=/a/ _Kayah_Li}');
    Error('\P{Is_Script_Extensions=/a/ _Kayah_Li}');
    Expect(1, 43311, '\p{Is_Script_Extensions=kayahli}', "");
    Expect(0, 43311, '\p{^Is_Script_Extensions=kayahli}', "");
    Expect(0, 43311, '\P{Is_Script_Extensions=kayahli}', "");
    Expect(1, 43311, '\P{^Is_Script_Extensions=kayahli}', "");
    Expect(0, 43312, '\p{Is_Script_Extensions=kayahli}', "");
    Expect(1, 43312, '\p{^Is_Script_Extensions=kayahli}', "");
    Expect(1, 43312, '\P{Is_Script_Extensions=kayahli}', "");
    Expect(0, 43312, '\P{^Is_Script_Extensions=kayahli}', "");
    Expect(1, 43311, '\p{Is_Script_Extensions=	 kayah_Li}', "");
    Expect(0, 43311, '\p{^Is_Script_Extensions=	 kayah_Li}', "");
    Expect(0, 43311, '\P{Is_Script_Extensions=	 kayah_Li}', "");
    Expect(1, 43311, '\P{^Is_Script_Extensions=	 kayah_Li}', "");
    Expect(0, 43312, '\p{Is_Script_Extensions=	 kayah_Li}', "");
    Expect(1, 43312, '\p{^Is_Script_Extensions=	 kayah_Li}', "");
    Expect(1, 43312, '\P{Is_Script_Extensions=	 kayah_Li}', "");
    Expect(0, 43312, '\P{^Is_Script_Extensions=	 kayah_Li}', "");
    Error('\p{Is_Scx: :=-Kali}');
    Error('\P{Is_Scx: :=-Kali}');
    Expect(1, 43311, '\p{Is_Scx=kali}', "");
    Expect(0, 43311, '\p{^Is_Scx=kali}', "");
    Expect(0, 43311, '\P{Is_Scx=kali}', "");
    Expect(1, 43311, '\P{^Is_Scx=kali}', "");
    Expect(0, 43312, '\p{Is_Scx=kali}', "");
    Expect(1, 43312, '\p{^Is_Scx=kali}', "");
    Expect(1, 43312, '\P{Is_Scx=kali}', "");
    Expect(0, 43312, '\P{^Is_Scx=kali}', "");
    Expect(1, 43311, '\p{Is_Scx: 	_Kali}', "");
    Expect(0, 43311, '\p{^Is_Scx: 	_Kali}', "");
    Expect(0, 43311, '\P{Is_Scx: 	_Kali}', "");
    Expect(1, 43311, '\P{^Is_Scx: 	_Kali}', "");
    Expect(0, 43312, '\p{Is_Scx: 	_Kali}', "");
    Expect(1, 43312, '\p{^Is_Scx: 	_Kali}', "");
    Expect(1, 43312, '\P{Is_Scx: 	_Kali}', "");
    Expect(0, 43312, '\P{^Is_Scx: 	_Kali}', "");
    Error('\p{Script_Extensions=_:=Katakana}');
    Error('\P{Script_Extensions=_:=Katakana}');
    Expect(1, 110951, '\p{Script_Extensions=:\AKatakana\z:}', "");;
    Expect(0, 110952, '\p{Script_Extensions=:\AKatakana\z:}', "");;
    Expect(1, 110951, '\p{Script_Extensions=katakana}', "");
    Expect(0, 110951, '\p{^Script_Extensions=katakana}', "");
    Expect(0, 110951, '\P{Script_Extensions=katakana}', "");
    Expect(1, 110951, '\P{^Script_Extensions=katakana}', "");
    Expect(0, 110952, '\p{Script_Extensions=katakana}', "");
    Expect(1, 110952, '\p{^Script_Extensions=katakana}', "");
    Expect(1, 110952, '\P{Script_Extensions=katakana}', "");
    Expect(0, 110952, '\P{^Script_Extensions=katakana}', "");
    Expect(1, 110951, '\p{Script_Extensions=:\Akatakana\z:}', "");;
    Expect(0, 110952, '\p{Script_Extensions=:\Akatakana\z:}', "");;
    Expect(1, 110951, '\p{Script_Extensions: katakana}', "");
    Expect(0, 110951, '\p{^Script_Extensions: katakana}', "");
    Expect(0, 110951, '\P{Script_Extensions: katakana}', "");
    Expect(1, 110951, '\P{^Script_Extensions: katakana}', "");
    Expect(0, 110952, '\p{Script_Extensions: katakana}', "");
    Expect(1, 110952, '\p{^Script_Extensions: katakana}', "");
    Expect(1, 110952, '\P{Script_Extensions: katakana}', "");
    Expect(0, 110952, '\P{^Script_Extensions: katakana}', "");
    Error('\p{Scx= /a/kana}');
    Error('\P{Scx= /a/kana}');
    Expect(1, 110951, '\p{Scx=:\AKana\z:}', "");;
    Expect(0, 110952, '\p{Scx=:\AKana\z:}', "");;
    Expect(1, 110951, '\p{Scx=kana}', "");
    Expect(0, 110951, '\p{^Scx=kana}', "");
    Expect(0, 110951, '\P{Scx=kana}', "");
    Expect(1, 110951, '\P{^Scx=kana}', "");
    Expect(0, 110952, '\p{Scx=kana}', "");
    Expect(1, 110952, '\p{^Scx=kana}', "");
    Expect(1, 110952, '\P{Scx=kana}', "");
    Expect(0, 110952, '\P{^Scx=kana}', "");
    Expect(1, 110951, '\p{Scx=:\Akana\z:}', "");;
    Expect(0, 110952, '\p{Scx=:\Akana\z:}', "");;
    Expect(1, 110951, '\p{Scx=-_Kana}', "");
    Expect(0, 110951, '\p{^Scx=-_Kana}', "");
    Expect(0, 110951, '\P{Scx=-_Kana}', "");
    Expect(1, 110951, '\P{^Scx=-_Kana}', "");
    Expect(0, 110952, '\p{Scx=-_Kana}', "");
    Expect(1, 110952, '\p{^Scx=-_Kana}', "");
    Expect(1, 110952, '\P{Scx=-_Kana}', "");
    Expect(0, 110952, '\P{^Scx=-_Kana}', "");
    Error('\p{Is_Script_Extensions=	:=katakana}');
    Error('\P{Is_Script_Extensions=	:=katakana}');
    Expect(1, 110951, '\p{Is_Script_Extensions=katakana}', "");
    Expect(0, 110951, '\p{^Is_Script_Extensions=katakana}', "");
    Expect(0, 110951, '\P{Is_Script_Extensions=katakana}', "");
    Expect(1, 110951, '\P{^Is_Script_Extensions=katakana}', "");
    Expect(0, 110952, '\p{Is_Script_Extensions=katakana}', "");
    Expect(1, 110952, '\p{^Is_Script_Extensions=katakana}', "");
    Expect(1, 110952, '\P{Is_Script_Extensions=katakana}', "");
    Expect(0, 110952, '\P{^Is_Script_Extensions=katakana}', "");
    Expect(1, 110951, '\p{Is_Script_Extensions=	_Katakana}', "");
    Expect(0, 110951, '\p{^Is_Script_Extensions=	_Katakana}', "");
    Expect(0, 110951, '\P{Is_Script_Extensions=	_Katakana}', "");
    Expect(1, 110951, '\P{^Is_Script_Extensions=	_Katakana}', "");
    Expect(0, 110952, '\p{Is_Script_Extensions=	_Katakana}', "");
    Expect(1, 110952, '\p{^Is_Script_Extensions=	_Katakana}', "");
    Expect(1, 110952, '\P{Is_Script_Extensions=	_Katakana}', "");
    Expect(0, 110952, '\P{^Is_Script_Extensions=	_Katakana}', "");
    Error('\p{Is_Scx=	-KANA/a/}');
    Error('\P{Is_Scx=	-KANA/a/}');
    Expect(1, 110951, '\p{Is_Scx=kana}', "");
    Expect(0, 110951, '\p{^Is_Scx=kana}', "");
    Expect(0, 110951, '\P{Is_Scx=kana}', "");
    Expect(1, 110951, '\P{^Is_Scx=kana}', "");
    Expect(0, 110952, '\p{Is_Scx=kana}', "");
    Expect(1, 110952, '\p{^Is_Scx=kana}', "");
    Expect(1, 110952, '\P{Is_Scx=kana}', "");
    Expect(0, 110952, '\P{^Is_Scx=kana}', "");
    Expect(1, 110951, '\p{Is_Scx=_Kana}', "");
    Expect(0, 110951, '\p{^Is_Scx=_Kana}', "");
    Expect(0, 110951, '\P{Is_Scx=_Kana}', "");
    Expect(1, 110951, '\P{^Is_Scx=_Kana}', "");
    Expect(0, 110952, '\p{Is_Scx=_Kana}', "");
    Expect(1, 110952, '\p{^Is_Scx=_Kana}', "");
    Expect(1, 110952, '\P{Is_Scx=_Kana}', "");
    Expect(0, 110952, '\P{^Is_Scx=_Kana}', "");
    Error('\p{Script_Extensions= :=kharoshthi}');
    Error('\P{Script_Extensions= :=kharoshthi}');
    Expect(1, 68184, '\p{Script_Extensions=:\AKharoshthi\z:}', "");;
    Expect(0, 68185, '\p{Script_Extensions=:\AKharoshthi\z:}', "");;
    Expect(1, 68184, '\p{Script_Extensions=kharoshthi}', "");
    Expect(0, 68184, '\p{^Script_Extensions=kharoshthi}', "");
    Expect(0, 68184, '\P{Script_Extensions=kharoshthi}', "");
    Expect(1, 68184, '\P{^Script_Extensions=kharoshthi}', "");
    Expect(0, 68185, '\p{Script_Extensions=kharoshthi}', "");
    Expect(1, 68185, '\p{^Script_Extensions=kharoshthi}', "");
    Expect(1, 68185, '\P{Script_Extensions=kharoshthi}', "");
    Expect(0, 68185, '\P{^Script_Extensions=kharoshthi}', "");
    Expect(1, 68184, '\p{Script_Extensions=:\Akharoshthi\z:}', "");;
    Expect(0, 68185, '\p{Script_Extensions=:\Akharoshthi\z:}', "");;
    Expect(1, 68184, '\p{Script_Extensions= 	Kharoshthi}', "");
    Expect(0, 68184, '\p{^Script_Extensions= 	Kharoshthi}', "");
    Expect(0, 68184, '\P{Script_Extensions= 	Kharoshthi}', "");
    Expect(1, 68184, '\P{^Script_Extensions= 	Kharoshthi}', "");
    Expect(0, 68185, '\p{Script_Extensions= 	Kharoshthi}', "");
    Expect(1, 68185, '\p{^Script_Extensions= 	Kharoshthi}', "");
    Expect(1, 68185, '\P{Script_Extensions= 	Kharoshthi}', "");
    Expect(0, 68185, '\P{^Script_Extensions= 	Kharoshthi}', "");
    Error('\p{Scx:   -/a/KHAR}');
    Error('\P{Scx:   -/a/KHAR}');
    Expect(1, 68184, '\p{Scx=:\AKhar\z:}', "");;
    Expect(0, 68185, '\p{Scx=:\AKhar\z:}', "");;
    Expect(1, 68184, '\p{Scx=khar}', "");
    Expect(0, 68184, '\p{^Scx=khar}', "");
    Expect(0, 68184, '\P{Scx=khar}', "");
    Expect(1, 68184, '\P{^Scx=khar}', "");
    Expect(0, 68185, '\p{Scx=khar}', "");
    Expect(1, 68185, '\p{^Scx=khar}', "");
    Expect(1, 68185, '\P{Scx=khar}', "");
    Expect(0, 68185, '\P{^Scx=khar}', "");
    Expect(1, 68184, '\p{Scx=:\Akhar\z:}', "");;
    Expect(0, 68185, '\p{Scx=:\Akhar\z:}', "");;
    Expect(1, 68184, '\p{Scx= 	Khar}', "");
    Expect(0, 68184, '\p{^Scx= 	Khar}', "");
    Expect(0, 68184, '\P{Scx= 	Khar}', "");
    Expect(1, 68184, '\P{^Scx= 	Khar}', "");
    Expect(0, 68185, '\p{Scx= 	Khar}', "");
    Expect(1, 68185, '\p{^Scx= 	Khar}', "");
    Expect(1, 68185, '\P{Scx= 	Khar}', "");
    Expect(0, 68185, '\P{^Scx= 	Khar}', "");
    Error('\p{Is_Script_Extensions=:=-Kharoshthi}');
    Error('\P{Is_Script_Extensions=:=-Kharoshthi}');
    Expect(1, 68184, '\p{Is_Script_Extensions=kharoshthi}', "");
    Expect(0, 68184, '\p{^Is_Script_Extensions=kharoshthi}', "");
    Expect(0, 68184, '\P{Is_Script_Extensions=kharoshthi}', "");
    Expect(1, 68184, '\P{^Is_Script_Extensions=kharoshthi}', "");
    Expect(0, 68185, '\p{Is_Script_Extensions=kharoshthi}', "");
    Expect(1, 68185, '\p{^Is_Script_Extensions=kharoshthi}', "");
    Expect(1, 68185, '\P{Is_Script_Extensions=kharoshthi}', "");
    Expect(0, 68185, '\P{^Is_Script_Extensions=kharoshthi}', "");
    Expect(1, 68184, '\p{Is_Script_Extensions=_	Kharoshthi}', "");
    Expect(0, 68184, '\p{^Is_Script_Extensions=_	Kharoshthi}', "");
    Expect(0, 68184, '\P{Is_Script_Extensions=_	Kharoshthi}', "");
    Expect(1, 68184, '\P{^Is_Script_Extensions=_	Kharoshthi}', "");
    Expect(0, 68185, '\p{Is_Script_Extensions=_	Kharoshthi}', "");
    Expect(1, 68185, '\p{^Is_Script_Extensions=_	Kharoshthi}', "");
    Expect(1, 68185, '\P{Is_Script_Extensions=_	Kharoshthi}', "");
    Expect(0, 68185, '\P{^Is_Script_Extensions=_	Kharoshthi}', "");
    Error('\p{Is_Scx=:=_	Khar}');
    Error('\P{Is_Scx=:=_	Khar}');
    Expect(1, 68184, '\p{Is_Scx=khar}', "");
    Expect(0, 68184, '\p{^Is_Scx=khar}', "");
    Expect(0, 68184, '\P{Is_Scx=khar}', "");
    Expect(1, 68184, '\P{^Is_Scx=khar}', "");
    Expect(0, 68185, '\p{Is_Scx=khar}', "");
    Expect(1, 68185, '\p{^Is_Scx=khar}', "");
    Expect(1, 68185, '\P{Is_Scx=khar}', "");
    Expect(0, 68185, '\P{^Is_Scx=khar}', "");
    Expect(1, 68184, '\p{Is_Scx=_KHAR}', "");
    Expect(0, 68184, '\p{^Is_Scx=_KHAR}', "");
    Expect(0, 68184, '\P{Is_Scx=_KHAR}', "");
    Expect(1, 68184, '\P{^Is_Scx=_KHAR}', "");
    Expect(0, 68185, '\p{Is_Scx=_KHAR}', "");
    Expect(1, 68185, '\p{^Is_Scx=_KHAR}', "");
    Expect(1, 68185, '\P{Is_Scx=_KHAR}', "");
    Expect(0, 68185, '\P{^Is_Scx=_KHAR}', "");
    Error('\p{Script_Extensions=_	KHMER/a/}');
    Error('\P{Script_Extensions=_	KHMER/a/}');
    Expect(1, 6655, '\p{Script_Extensions=:\AKhmer\z:}', "");;
    Expect(0, 6656, '\p{Script_Extensions=:\AKhmer\z:}', "");;
    Expect(1, 6655, '\p{Script_Extensions=khmer}', "");
    Expect(0, 6655, '\p{^Script_Extensions=khmer}', "");
    Expect(0, 6655, '\P{Script_Extensions=khmer}', "");
    Expect(1, 6655, '\P{^Script_Extensions=khmer}', "");
    Expect(0, 6656, '\p{Script_Extensions=khmer}', "");
    Expect(1, 6656, '\p{^Script_Extensions=khmer}', "");
    Expect(1, 6656, '\P{Script_Extensions=khmer}', "");
    Expect(0, 6656, '\P{^Script_Extensions=khmer}', "");
    Expect(1, 6655, '\p{Script_Extensions=:\Akhmer\z:}', "");;
    Expect(0, 6656, '\p{Script_Extensions=:\Akhmer\z:}', "");;
    Expect(1, 6655, '\p{Script_Extensions=-KHMER}', "");
    Expect(0, 6655, '\p{^Script_Extensions=-KHMER}', "");
    Expect(0, 6655, '\P{Script_Extensions=-KHMER}', "");
    Expect(1, 6655, '\P{^Script_Extensions=-KHMER}', "");
    Expect(0, 6656, '\p{Script_Extensions=-KHMER}', "");
    Expect(1, 6656, '\p{^Script_Extensions=-KHMER}', "");
    Expect(1, 6656, '\P{Script_Extensions=-KHMER}', "");
    Expect(0, 6656, '\P{^Script_Extensions=-KHMER}', "");
    Error('\p{Scx=-/a/khmr}');
    Error('\P{Scx=-/a/khmr}');
    Expect(1, 6655, '\p{Scx=:\AKhmr\z:}', "");;
    Expect(0, 6656, '\p{Scx=:\AKhmr\z:}', "");;
    Expect(1, 6655, '\p{Scx=khmr}', "");
    Expect(0, 6655, '\p{^Scx=khmr}', "");
    Expect(0, 6655, '\P{Scx=khmr}', "");
    Expect(1, 6655, '\P{^Scx=khmr}', "");
    Expect(0, 6656, '\p{Scx=khmr}', "");
    Expect(1, 6656, '\p{^Scx=khmr}', "");
    Expect(1, 6656, '\P{Scx=khmr}', "");
    Expect(0, 6656, '\P{^Scx=khmr}', "");
    Expect(1, 6655, '\p{Scx=:\Akhmr\z:}', "");;
    Expect(0, 6656, '\p{Scx=:\Akhmr\z:}', "");;
    Expect(1, 6655, '\p{Scx=	khmr}', "");
    Expect(0, 6655, '\p{^Scx=	khmr}', "");
    Expect(0, 6655, '\P{Scx=	khmr}', "");
    Expect(1, 6655, '\P{^Scx=	khmr}', "");
    Expect(0, 6656, '\p{Scx=	khmr}', "");
    Expect(1, 6656, '\p{^Scx=	khmr}', "");
    Expect(1, 6656, '\P{Scx=	khmr}', "");
    Expect(0, 6656, '\P{^Scx=	khmr}', "");
    Error('\p{Is_Script_Extensions=-/a/khmer}');
    Error('\P{Is_Script_Extensions=-/a/khmer}');
    Expect(1, 6655, '\p{Is_Script_Extensions=khmer}', "");
    Expect(0, 6655, '\p{^Is_Script_Extensions=khmer}', "");
    Expect(0, 6655, '\P{Is_Script_Extensions=khmer}', "");
    Expect(1, 6655, '\P{^Is_Script_Extensions=khmer}', "");
    Expect(0, 6656, '\p{Is_Script_Extensions=khmer}', "");
    Expect(1, 6656, '\p{^Is_Script_Extensions=khmer}', "");
    Expect(1, 6656, '\P{Is_Script_Extensions=khmer}', "");
    Expect(0, 6656, '\P{^Is_Script_Extensions=khmer}', "");
    Expect(1, 6655, '\p{Is_Script_Extensions=_-khmer}', "");
    Expect(0, 6655, '\p{^Is_Script_Extensions=_-khmer}', "");
    Expect(0, 6655, '\P{Is_Script_Extensions=_-khmer}', "");
    Expect(1, 6655, '\P{^Is_Script_Extensions=_-khmer}', "");
    Expect(0, 6656, '\p{Is_Script_Extensions=_-khmer}', "");
    Expect(1, 6656, '\p{^Is_Script_Extensions=_-khmer}', "");
    Expect(1, 6656, '\P{Is_Script_Extensions=_-khmer}', "");
    Expect(0, 6656, '\P{^Is_Script_Extensions=_-khmer}', "");
    Error('\p{Is_Scx=/a/khmr}');
    Error('\P{Is_Scx=/a/khmr}');
    Expect(1, 6655, '\p{Is_Scx=khmr}', "");
    Expect(0, 6655, '\p{^Is_Scx=khmr}', "");
    Expect(0, 6655, '\P{Is_Scx=khmr}', "");
    Expect(1, 6655, '\P{^Is_Scx=khmr}', "");
    Expect(0, 6656, '\p{Is_Scx=khmr}', "");
    Expect(1, 6656, '\p{^Is_Scx=khmr}', "");
    Expect(1, 6656, '\P{Is_Scx=khmr}', "");
    Expect(0, 6656, '\P{^Is_Scx=khmr}', "");
    Expect(1, 6655, '\p{Is_Scx=	khmr}', "");
    Expect(0, 6655, '\p{^Is_Scx=	khmr}', "");
    Expect(0, 6655, '\P{Is_Scx=	khmr}', "");
    Expect(1, 6655, '\P{^Is_Scx=	khmr}', "");
    Expect(0, 6656, '\p{Is_Scx=	khmr}', "");
    Expect(1, 6656, '\p{^Is_Scx=	khmr}', "");
    Expect(1, 6656, '\P{Is_Scx=	khmr}', "");
    Expect(0, 6656, '\P{^Is_Scx=	khmr}', "");
    Error('\p{Script_Extensions=:=khojki}');
    Error('\P{Script_Extensions=:=khojki}');
    Expect(1, 70206, '\p{Script_Extensions=:\AKhojki\z:}', "");;
    Expect(0, 70207, '\p{Script_Extensions=:\AKhojki\z:}', "");;
    Expect(1, 70206, '\p{Script_Extensions=khojki}', "");
    Expect(0, 70206, '\p{^Script_Extensions=khojki}', "");
    Expect(0, 70206, '\P{Script_Extensions=khojki}', "");
    Expect(1, 70206, '\P{^Script_Extensions=khojki}', "");
    Expect(0, 70207, '\p{Script_Extensions=khojki}', "");
    Expect(1, 70207, '\p{^Script_Extensions=khojki}', "");
    Expect(1, 70207, '\P{Script_Extensions=khojki}', "");
    Expect(0, 70207, '\P{^Script_Extensions=khojki}', "");
    Expect(1, 70206, '\p{Script_Extensions=:\Akhojki\z:}', "");;
    Expect(0, 70207, '\p{Script_Extensions=:\Akhojki\z:}', "");;
    Expect(1, 70206, '\p{Script_Extensions=-_KHOJKI}', "");
    Expect(0, 70206, '\p{^Script_Extensions=-_KHOJKI}', "");
    Expect(0, 70206, '\P{Script_Extensions=-_KHOJKI}', "");
    Expect(1, 70206, '\P{^Script_Extensions=-_KHOJKI}', "");
    Expect(0, 70207, '\p{Script_Extensions=-_KHOJKI}', "");
    Expect(1, 70207, '\p{^Script_Extensions=-_KHOJKI}', "");
    Expect(1, 70207, '\P{Script_Extensions=-_KHOJKI}', "");
    Expect(0, 70207, '\P{^Script_Extensions=-_KHOJKI}', "");
    Error('\p{Scx=/a/_-KHOJ}');
    Error('\P{Scx=/a/_-KHOJ}');
    Expect(1, 70206, '\p{Scx=:\AKhoj\z:}', "");;
    Expect(0, 70207, '\p{Scx=:\AKhoj\z:}', "");;
    Expect(1, 70206, '\p{Scx=khoj}', "");
    Expect(0, 70206, '\p{^Scx=khoj}', "");
    Expect(0, 70206, '\P{Scx=khoj}', "");
    Expect(1, 70206, '\P{^Scx=khoj}', "");
    Expect(0, 70207, '\p{Scx=khoj}', "");
    Expect(1, 70207, '\p{^Scx=khoj}', "");
    Expect(1, 70207, '\P{Scx=khoj}', "");
    Expect(0, 70207, '\P{^Scx=khoj}', "");
    Expect(1, 70206, '\p{Scx=:\Akhoj\z:}', "");;
    Expect(0, 70207, '\p{Scx=:\Akhoj\z:}', "");;
    Expect(1, 70206, '\p{Scx=_ KHOJ}', "");
    Expect(0, 70206, '\p{^Scx=_ KHOJ}', "");
    Expect(0, 70206, '\P{Scx=_ KHOJ}', "");
    Expect(1, 70206, '\P{^Scx=_ KHOJ}', "");
    Expect(0, 70207, '\p{Scx=_ KHOJ}', "");
    Expect(1, 70207, '\p{^Scx=_ KHOJ}', "");
    Expect(1, 70207, '\P{Scx=_ KHOJ}', "");
    Expect(0, 70207, '\P{^Scx=_ KHOJ}', "");
    Error('\p{Is_Script_Extensions=/a/_Khojki}');
    Error('\P{Is_Script_Extensions=/a/_Khojki}');
    Expect(1, 70206, '\p{Is_Script_Extensions:khojki}', "");
    Expect(0, 70206, '\p{^Is_Script_Extensions:khojki}', "");
    Expect(0, 70206, '\P{Is_Script_Extensions:khojki}', "");
    Expect(1, 70206, '\P{^Is_Script_Extensions:khojki}', "");
    Expect(0, 70207, '\p{Is_Script_Extensions:khojki}', "");
    Expect(1, 70207, '\p{^Is_Script_Extensions:khojki}', "");
    Expect(1, 70207, '\P{Is_Script_Extensions:khojki}', "");
    Expect(0, 70207, '\P{^Is_Script_Extensions:khojki}', "");
    Expect(1, 70206, '\p{Is_Script_Extensions=--Khojki}', "");
    Expect(0, 70206, '\p{^Is_Script_Extensions=--Khojki}', "");
    Expect(0, 70206, '\P{Is_Script_Extensions=--Khojki}', "");
    Expect(1, 70206, '\P{^Is_Script_Extensions=--Khojki}', "");
    Expect(0, 70207, '\p{Is_Script_Extensions=--Khojki}', "");
    Expect(1, 70207, '\p{^Is_Script_Extensions=--Khojki}', "");
    Expect(1, 70207, '\P{Is_Script_Extensions=--Khojki}', "");
    Expect(0, 70207, '\P{^Is_Script_Extensions=--Khojki}', "");
    Error('\p{Is_Scx=_khoj/a/}');
    Error('\P{Is_Scx=_khoj/a/}');
    Expect(1, 70206, '\p{Is_Scx=khoj}', "");
    Expect(0, 70206, '\p{^Is_Scx=khoj}', "");
    Expect(0, 70206, '\P{Is_Scx=khoj}', "");
    Expect(1, 70206, '\P{^Is_Scx=khoj}', "");
    Expect(0, 70207, '\p{Is_Scx=khoj}', "");
    Expect(1, 70207, '\p{^Is_Scx=khoj}', "");
    Expect(1, 70207, '\P{Is_Scx=khoj}', "");
    Expect(0, 70207, '\P{^Is_Scx=khoj}', "");
    Expect(1, 70206, '\p{Is_Scx=  KHOJ}', "");
    Expect(0, 70206, '\p{^Is_Scx=  KHOJ}', "");
    Expect(0, 70206, '\P{Is_Scx=  KHOJ}', "");
    Expect(1, 70206, '\P{^Is_Scx=  KHOJ}', "");
    Expect(0, 70207, '\p{Is_Scx=  KHOJ}', "");
    Expect(1, 70207, '\p{^Is_Scx=  KHOJ}', "");
    Expect(1, 70207, '\P{Is_Scx=  KHOJ}', "");
    Expect(0, 70207, '\P{^Is_Scx=  KHOJ}', "");
    Error('\p{Script_Extensions=:=--Kannada}');
    Error('\P{Script_Extensions=:=--Kannada}');
    Expect(1, 43061, '\p{Script_Extensions=:\AKannada\z:}', "");;
    Expect(0, 43062, '\p{Script_Extensions=:\AKannada\z:}', "");;
    Expect(1, 43061, '\p{Script_Extensions=kannada}', "");
    Expect(0, 43061, '\p{^Script_Extensions=kannada}', "");
    Expect(0, 43061, '\P{Script_Extensions=kannada}', "");
    Expect(1, 43061, '\P{^Script_Extensions=kannada}', "");
    Expect(0, 43062, '\p{Script_Extensions=kannada}', "");
    Expect(1, 43062, '\p{^Script_Extensions=kannada}', "");
    Expect(1, 43062, '\P{Script_Extensions=kannada}', "");
    Expect(0, 43062, '\P{^Script_Extensions=kannada}', "");
    Expect(1, 43061, '\p{Script_Extensions=:\Akannada\z:}', "");;
    Expect(0, 43062, '\p{Script_Extensions=:\Akannada\z:}', "");;
    Expect(1, 43061, '\p{Script_Extensions= Kannada}', "");
    Expect(0, 43061, '\p{^Script_Extensions= Kannada}', "");
    Expect(0, 43061, '\P{Script_Extensions= Kannada}', "");
    Expect(1, 43061, '\P{^Script_Extensions= Kannada}', "");
    Expect(0, 43062, '\p{Script_Extensions= Kannada}', "");
    Expect(1, 43062, '\p{^Script_Extensions= Kannada}', "");
    Expect(1, 43062, '\P{Script_Extensions= Kannada}', "");
    Expect(0, 43062, '\P{^Script_Extensions= Kannada}', "");
    Error('\p{Scx=	-Knda/a/}');
    Error('\P{Scx=	-Knda/a/}');
    Expect(1, 43061, '\p{Scx=:\AKnda\z:}', "");;
    Expect(0, 43062, '\p{Scx=:\AKnda\z:}', "");;
    Expect(1, 43061, '\p{Scx=knda}', "");
    Expect(0, 43061, '\p{^Scx=knda}', "");
    Expect(0, 43061, '\P{Scx=knda}', "");
    Expect(1, 43061, '\P{^Scx=knda}', "");
    Expect(0, 43062, '\p{Scx=knda}', "");
    Expect(1, 43062, '\p{^Scx=knda}', "");
    Expect(1, 43062, '\P{Scx=knda}', "");
    Expect(0, 43062, '\P{^Scx=knda}', "");
    Expect(1, 43061, '\p{Scx=:\Aknda\z:}', "");;
    Expect(0, 43062, '\p{Scx=:\Aknda\z:}', "");;
    Expect(1, 43061, '\p{Scx=_	Knda}', "");
    Expect(0, 43061, '\p{^Scx=_	Knda}', "");
    Expect(0, 43061, '\P{Scx=_	Knda}', "");
    Expect(1, 43061, '\P{^Scx=_	Knda}', "");
    Expect(0, 43062, '\p{Scx=_	Knda}', "");
    Expect(1, 43062, '\p{^Scx=_	Knda}', "");
    Expect(1, 43062, '\P{Scx=_	Knda}', "");
    Expect(0, 43062, '\P{^Scx=_	Knda}', "");
    Error('\p{Is_Script_Extensions=:= 	Kannada}');
    Error('\P{Is_Script_Extensions=:= 	Kannada}');
    Expect(1, 43061, '\p{Is_Script_Extensions=kannada}', "");
    Expect(0, 43061, '\p{^Is_Script_Extensions=kannada}', "");
    Expect(0, 43061, '\P{Is_Script_Extensions=kannada}', "");
    Expect(1, 43061, '\P{^Is_Script_Extensions=kannada}', "");
    Expect(0, 43062, '\p{Is_Script_Extensions=kannada}', "");
    Expect(1, 43062, '\p{^Is_Script_Extensions=kannada}', "");
    Expect(1, 43062, '\P{Is_Script_Extensions=kannada}', "");
    Expect(0, 43062, '\P{^Is_Script_Extensions=kannada}', "");
    Expect(1, 43061, '\p{Is_Script_Extensions= kannada}', "");
    Expect(0, 43061, '\p{^Is_Script_Extensions= kannada}', "");
    Expect(0, 43061, '\P{Is_Script_Extensions= kannada}', "");
    Expect(1, 43061, '\P{^Is_Script_Extensions= kannada}', "");
    Expect(0, 43062, '\p{Is_Script_Extensions= kannada}', "");
    Expect(1, 43062, '\p{^Is_Script_Extensions= kannada}', "");
    Expect(1, 43062, '\P{Is_Script_Extensions= kannada}', "");
    Expect(0, 43062, '\P{^Is_Script_Extensions= kannada}', "");
    Error('\p{Is_Scx=_ Knda/a/}');
    Error('\P{Is_Scx=_ Knda/a/}');
    Expect(1, 43061, '\p{Is_Scx=knda}', "");
    Expect(0, 43061, '\p{^Is_Scx=knda}', "");
    Expect(0, 43061, '\P{Is_Scx=knda}', "");
    Expect(1, 43061, '\P{^Is_Scx=knda}', "");
    Expect(0, 43062, '\p{Is_Scx=knda}', "");
    Expect(1, 43062, '\p{^Is_Scx=knda}', "");
    Expect(1, 43062, '\P{Is_Scx=knda}', "");
    Expect(0, 43062, '\P{^Is_Scx=knda}', "");
    Expect(1, 43061, '\p{Is_Scx=-Knda}', "");
    Expect(0, 43061, '\p{^Is_Scx=-Knda}', "");
    Expect(0, 43061, '\P{Is_Scx=-Knda}', "");
    Expect(1, 43061, '\P{^Is_Scx=-Knda}', "");
    Expect(0, 43062, '\p{Is_Scx=-Knda}', "");
    Expect(1, 43062, '\p{^Is_Scx=-Knda}', "");
    Expect(1, 43062, '\P{Is_Scx=-Knda}', "");
    Expect(0, 43062, '\P{^Is_Scx=-Knda}', "");
    Error('\p{Script_Extensions=-:=Kaithi}');
    Error('\P{Script_Extensions=-:=Kaithi}');
    Expect(1, 69837, '\p{Script_Extensions=:\AKaithi\z:}', "");;
    Expect(0, 69838, '\p{Script_Extensions=:\AKaithi\z:}', "");;
    Expect(1, 69837, '\p{Script_Extensions=kaithi}', "");
    Expect(0, 69837, '\p{^Script_Extensions=kaithi}', "");
    Expect(0, 69837, '\P{Script_Extensions=kaithi}', "");
    Expect(1, 69837, '\P{^Script_Extensions=kaithi}', "");
    Expect(0, 69838, '\p{Script_Extensions=kaithi}', "");
    Expect(1, 69838, '\p{^Script_Extensions=kaithi}', "");
    Expect(1, 69838, '\P{Script_Extensions=kaithi}', "");
    Expect(0, 69838, '\P{^Script_Extensions=kaithi}', "");
    Expect(1, 69837, '\p{Script_Extensions=:\Akaithi\z:}', "");;
    Expect(0, 69838, '\p{Script_Extensions=:\Akaithi\z:}', "");;
    Expect(1, 69837, '\p{Script_Extensions=		kaithi}', "");
    Expect(0, 69837, '\p{^Script_Extensions=		kaithi}', "");
    Expect(0, 69837, '\P{Script_Extensions=		kaithi}', "");
    Expect(1, 69837, '\P{^Script_Extensions=		kaithi}', "");
    Expect(0, 69838, '\p{Script_Extensions=		kaithi}', "");
    Expect(1, 69838, '\p{^Script_Extensions=		kaithi}', "");
    Expect(1, 69838, '\P{Script_Extensions=		kaithi}', "");
    Expect(0, 69838, '\P{^Script_Extensions=		kaithi}', "");
    Error('\p{Scx=_ KTHI:=}');
    Error('\P{Scx=_ KTHI:=}');
    Expect(1, 69837, '\p{Scx=:\AKthi\z:}', "");;
    Expect(0, 69838, '\p{Scx=:\AKthi\z:}', "");;
    Expect(1, 69837, '\p{Scx:kthi}', "");
    Expect(0, 69837, '\p{^Scx:kthi}', "");
    Expect(0, 69837, '\P{Scx:kthi}', "");
    Expect(1, 69837, '\P{^Scx:kthi}', "");
    Expect(0, 69838, '\p{Scx:kthi}', "");
    Expect(1, 69838, '\p{^Scx:kthi}', "");
    Expect(1, 69838, '\P{Scx:kthi}', "");
    Expect(0, 69838, '\P{^Scx:kthi}', "");
    Expect(1, 69837, '\p{Scx=:\Akthi\z:}', "");;
    Expect(0, 69838, '\p{Scx=:\Akthi\z:}', "");;
    Expect(1, 69837, '\p{Scx=--Kthi}', "");
    Expect(0, 69837, '\p{^Scx=--Kthi}', "");
    Expect(0, 69837, '\P{Scx=--Kthi}', "");
    Expect(1, 69837, '\P{^Scx=--Kthi}', "");
    Expect(0, 69838, '\p{Scx=--Kthi}', "");
    Expect(1, 69838, '\p{^Scx=--Kthi}', "");
    Expect(1, 69838, '\P{Scx=--Kthi}', "");
    Expect(0, 69838, '\P{^Scx=--Kthi}', "");
    Error('\p{Is_Script_Extensions=		Kaithi:=}');
    Error('\P{Is_Script_Extensions=		Kaithi:=}');
    Expect(1, 69837, '\p{Is_Script_Extensions=kaithi}', "");
    Expect(0, 69837, '\p{^Is_Script_Extensions=kaithi}', "");
    Expect(0, 69837, '\P{Is_Script_Extensions=kaithi}', "");
    Expect(1, 69837, '\P{^Is_Script_Extensions=kaithi}', "");
    Expect(0, 69838, '\p{Is_Script_Extensions=kaithi}', "");
    Expect(1, 69838, '\p{^Is_Script_Extensions=kaithi}', "");
    Expect(1, 69838, '\P{Is_Script_Extensions=kaithi}', "");
    Expect(0, 69838, '\P{^Is_Script_Extensions=kaithi}', "");
    Expect(1, 69837, '\p{Is_Script_Extensions=	-Kaithi}', "");
    Expect(0, 69837, '\p{^Is_Script_Extensions=	-Kaithi}', "");
    Expect(0, 69837, '\P{Is_Script_Extensions=	-Kaithi}', "");
    Expect(1, 69837, '\P{^Is_Script_Extensions=	-Kaithi}', "");
    Expect(0, 69838, '\p{Is_Script_Extensions=	-Kaithi}', "");
    Expect(1, 69838, '\p{^Is_Script_Extensions=	-Kaithi}', "");
    Expect(1, 69838, '\P{Is_Script_Extensions=	-Kaithi}', "");
    Expect(0, 69838, '\P{^Is_Script_Extensions=	-Kaithi}', "");
    Error('\p{Is_Scx= /a/kthi}');
    Error('\P{Is_Scx= /a/kthi}');
    Expect(1, 69837, '\p{Is_Scx=kthi}', "");
    Expect(0, 69837, '\p{^Is_Scx=kthi}', "");
    Expect(0, 69837, '\P{Is_Scx=kthi}', "");
    Expect(1, 69837, '\P{^Is_Scx=kthi}', "");
    Expect(0, 69838, '\p{Is_Scx=kthi}', "");
    Expect(1, 69838, '\p{^Is_Scx=kthi}', "");
    Expect(1, 69838, '\P{Is_Scx=kthi}', "");
    Expect(0, 69838, '\P{^Is_Scx=kthi}', "");
    Expect(1, 69837, '\p{Is_Scx=- Kthi}', "");
    Expect(0, 69837, '\p{^Is_Scx=- Kthi}', "");
    Expect(0, 69837, '\P{Is_Scx=- Kthi}', "");
    Expect(1, 69837, '\P{^Is_Scx=- Kthi}', "");
    Expect(0, 69838, '\p{Is_Scx=- Kthi}', "");
    Expect(1, 69838, '\p{^Is_Scx=- Kthi}', "");
    Expect(1, 69838, '\P{Is_Scx=- Kthi}', "");
    Expect(0, 69838, '\P{^Is_Scx=- Kthi}', "");
    Error('\p{Script_Extensions: _Tai_THAM:=}');
    Error('\P{Script_Extensions: _Tai_THAM:=}');
    Expect(1, 6829, '\p{Script_Extensions=:\ATai_Tham\z:}', "");;
    Expect(0, 6830, '\p{Script_Extensions=:\ATai_Tham\z:}', "");;
    Expect(1, 6829, '\p{Script_Extensions=taitham}', "");
    Expect(0, 6829, '\p{^Script_Extensions=taitham}', "");
    Expect(0, 6829, '\P{Script_Extensions=taitham}', "");
    Expect(1, 6829, '\P{^Script_Extensions=taitham}', "");
    Expect(0, 6830, '\p{Script_Extensions=taitham}', "");
    Expect(1, 6830, '\p{^Script_Extensions=taitham}', "");
    Expect(1, 6830, '\P{Script_Extensions=taitham}', "");
    Expect(0, 6830, '\P{^Script_Extensions=taitham}', "");
    Expect(1, 6829, '\p{Script_Extensions=:\Ataitham\z:}', "");;
    Expect(0, 6830, '\p{Script_Extensions=:\Ataitham\z:}', "");;
    Expect(1, 6829, '\p{Script_Extensions=_TAI_Tham}', "");
    Expect(0, 6829, '\p{^Script_Extensions=_TAI_Tham}', "");
    Expect(0, 6829, '\P{Script_Extensions=_TAI_Tham}', "");
    Expect(1, 6829, '\P{^Script_Extensions=_TAI_Tham}', "");
    Expect(0, 6830, '\p{Script_Extensions=_TAI_Tham}', "");
    Expect(1, 6830, '\p{^Script_Extensions=_TAI_Tham}', "");
    Expect(1, 6830, '\P{Script_Extensions=_TAI_Tham}', "");
    Expect(0, 6830, '\P{^Script_Extensions=_TAI_Tham}', "");
    Error('\p{Scx=_Lana:=}');
    Error('\P{Scx=_Lana:=}');
    Expect(1, 6829, '\p{Scx=:\ALana\z:}', "");;
    Expect(0, 6830, '\p{Scx=:\ALana\z:}', "");;
    Expect(1, 6829, '\p{Scx=lana}', "");
    Expect(0, 6829, '\p{^Scx=lana}', "");
    Expect(0, 6829, '\P{Scx=lana}', "");
    Expect(1, 6829, '\P{^Scx=lana}', "");
    Expect(0, 6830, '\p{Scx=lana}', "");
    Expect(1, 6830, '\p{^Scx=lana}', "");
    Expect(1, 6830, '\P{Scx=lana}', "");
    Expect(0, 6830, '\P{^Scx=lana}', "");
    Expect(1, 6829, '\p{Scx=:\Alana\z:}', "");;
    Expect(0, 6830, '\p{Scx=:\Alana\z:}', "");;
    Expect(1, 6829, '\p{Scx=-	Lana}', "");
    Expect(0, 6829, '\p{^Scx=-	Lana}', "");
    Expect(0, 6829, '\P{Scx=-	Lana}', "");
    Expect(1, 6829, '\P{^Scx=-	Lana}', "");
    Expect(0, 6830, '\p{Scx=-	Lana}', "");
    Expect(1, 6830, '\p{^Scx=-	Lana}', "");
    Expect(1, 6830, '\P{Scx=-	Lana}', "");
    Expect(0, 6830, '\P{^Scx=-	Lana}', "");
    Error('\p{Is_Script_Extensions=-/a/TAI_Tham}');
    Error('\P{Is_Script_Extensions=-/a/TAI_Tham}');
    Expect(1, 6829, '\p{Is_Script_Extensions=taitham}', "");
    Expect(0, 6829, '\p{^Is_Script_Extensions=taitham}', "");
    Expect(0, 6829, '\P{Is_Script_Extensions=taitham}', "");
    Expect(1, 6829, '\P{^Is_Script_Extensions=taitham}', "");
    Expect(0, 6830, '\p{Is_Script_Extensions=taitham}', "");
    Expect(1, 6830, '\p{^Is_Script_Extensions=taitham}', "");
    Expect(1, 6830, '\P{Is_Script_Extensions=taitham}', "");
    Expect(0, 6830, '\P{^Is_Script_Extensions=taitham}', "");
    Expect(1, 6829, '\p{Is_Script_Extensions:	 -tai_THAM}', "");
    Expect(0, 6829, '\p{^Is_Script_Extensions:	 -tai_THAM}', "");
    Expect(0, 6829, '\P{Is_Script_Extensions:	 -tai_THAM}', "");
    Expect(1, 6829, '\P{^Is_Script_Extensions:	 -tai_THAM}', "");
    Expect(0, 6830, '\p{Is_Script_Extensions:	 -tai_THAM}', "");
    Expect(1, 6830, '\p{^Is_Script_Extensions:	 -tai_THAM}', "");
    Expect(1, 6830, '\P{Is_Script_Extensions:	 -tai_THAM}', "");
    Expect(0, 6830, '\P{^Is_Script_Extensions:	 -tai_THAM}', "");
    Error('\p{Is_Scx=:=	-Lana}');
    Error('\P{Is_Scx=:=	-Lana}');
    Expect(1, 6829, '\p{Is_Scx=lana}', "");
    Expect(0, 6829, '\p{^Is_Scx=lana}', "");
    Expect(0, 6829, '\P{Is_Scx=lana}', "");
    Expect(1, 6829, '\P{^Is_Scx=lana}', "");
    Expect(0, 6830, '\p{Is_Scx=lana}', "");
    Expect(1, 6830, '\p{^Is_Scx=lana}', "");
    Expect(1, 6830, '\P{Is_Scx=lana}', "");
    Expect(0, 6830, '\P{^Is_Scx=lana}', "");
    Expect(1, 6829, '\p{Is_Scx=	lana}', "");
    Expect(0, 6829, '\p{^Is_Scx=	lana}', "");
    Expect(0, 6829, '\P{Is_Scx=	lana}', "");
    Expect(1, 6829, '\P{^Is_Scx=	lana}', "");
    Expect(0, 6830, '\p{Is_Scx=	lana}', "");
    Expect(1, 6830, '\p{^Is_Scx=	lana}', "");
    Expect(1, 6830, '\P{Is_Scx=	lana}', "");
    Expect(0, 6830, '\P{^Is_Scx=	lana}', "");
    Error('\p{Script_Extensions=- LAO/a/}');
    Error('\P{Script_Extensions=- LAO/a/}');
    Expect(1, 3807, '\p{Script_Extensions=:\ALao\z:}', "");;
    Expect(0, 3808, '\p{Script_Extensions=:\ALao\z:}', "");;
    Expect(1, 3807, '\p{Script_Extensions=lao}', "");
    Expect(0, 3807, '\p{^Script_Extensions=lao}', "");
    Expect(0, 3807, '\P{Script_Extensions=lao}', "");
    Expect(1, 3807, '\P{^Script_Extensions=lao}', "");
    Expect(0, 3808, '\p{Script_Extensions=lao}', "");
    Expect(1, 3808, '\p{^Script_Extensions=lao}', "");
    Expect(1, 3808, '\P{Script_Extensions=lao}', "");
    Expect(0, 3808, '\P{^Script_Extensions=lao}', "");
    Expect(1, 3807, '\p{Script_Extensions=:\Alao\z:}', "");;
    Expect(0, 3808, '\p{Script_Extensions=:\Alao\z:}', "");;
    Expect(1, 3807, '\p{Script_Extensions=Lao}', "");
    Expect(0, 3807, '\p{^Script_Extensions=Lao}', "");
    Expect(0, 3807, '\P{Script_Extensions=Lao}', "");
    Expect(1, 3807, '\P{^Script_Extensions=Lao}', "");
    Expect(0, 3808, '\p{Script_Extensions=Lao}', "");
    Expect(1, 3808, '\p{^Script_Extensions=Lao}', "");
    Expect(1, 3808, '\P{Script_Extensions=Lao}', "");
    Expect(0, 3808, '\P{^Script_Extensions=Lao}', "");
    Error('\p{Scx: :=Laoo}');
    Error('\P{Scx: :=Laoo}');
    Expect(1, 3807, '\p{Scx=:\ALaoo\z:}', "");;
    Expect(0, 3808, '\p{Scx=:\ALaoo\z:}', "");;
    Expect(1, 3807, '\p{Scx=laoo}', "");
    Expect(0, 3807, '\p{^Scx=laoo}', "");
    Expect(0, 3807, '\P{Scx=laoo}', "");
    Expect(1, 3807, '\P{^Scx=laoo}', "");
    Expect(0, 3808, '\p{Scx=laoo}', "");
    Expect(1, 3808, '\p{^Scx=laoo}', "");
    Expect(1, 3808, '\P{Scx=laoo}', "");
    Expect(0, 3808, '\P{^Scx=laoo}', "");
    Expect(1, 3807, '\p{Scx=:\Alaoo\z:}', "");;
    Expect(0, 3808, '\p{Scx=:\Alaoo\z:}', "");;
    Expect(1, 3807, '\p{Scx=Laoo}', "");
    Expect(0, 3807, '\p{^Scx=Laoo}', "");
    Expect(0, 3807, '\P{Scx=Laoo}', "");
    Expect(1, 3807, '\P{^Scx=Laoo}', "");
    Expect(0, 3808, '\p{Scx=Laoo}', "");
    Expect(1, 3808, '\p{^Scx=Laoo}', "");
    Expect(1, 3808, '\P{Scx=Laoo}', "");
    Expect(0, 3808, '\P{^Scx=Laoo}', "");
    Error('\p{Is_Script_Extensions=-/a/lao}');
    Error('\P{Is_Script_Extensions=-/a/lao}');
    Expect(1, 3807, '\p{Is_Script_Extensions=lao}', "");
    Expect(0, 3807, '\p{^Is_Script_Extensions=lao}', "");
    Expect(0, 3807, '\P{Is_Script_Extensions=lao}', "");
    Expect(1, 3807, '\P{^Is_Script_Extensions=lao}', "");
    Expect(0, 3808, '\p{Is_Script_Extensions=lao}', "");
    Expect(1, 3808, '\p{^Is_Script_Extensions=lao}', "");
    Expect(1, 3808, '\P{Is_Script_Extensions=lao}', "");
    Expect(0, 3808, '\P{^Is_Script_Extensions=lao}', "");
    Expect(1, 3807, '\p{Is_Script_Extensions=	 Lao}', "");
    Expect(0, 3807, '\p{^Is_Script_Extensions=	 Lao}', "");
    Expect(0, 3807, '\P{Is_Script_Extensions=	 Lao}', "");
    Expect(1, 3807, '\P{^Is_Script_Extensions=	 Lao}', "");
    Expect(0, 3808, '\p{Is_Script_Extensions=	 Lao}', "");
    Expect(1, 3808, '\p{^Is_Script_Extensions=	 Lao}', "");
    Expect(1, 3808, '\P{Is_Script_Extensions=	 Lao}', "");
    Expect(0, 3808, '\P{^Is_Script_Extensions=	 Lao}', "");
    Error('\p{Is_Scx=:=_ Laoo}');
    Error('\P{Is_Scx=:=_ Laoo}');
    Expect(1, 3807, '\p{Is_Scx=laoo}', "");
    Expect(0, 3807, '\p{^Is_Scx=laoo}', "");
    Expect(0, 3807, '\P{Is_Scx=laoo}', "");
    Expect(1, 3807, '\P{^Is_Scx=laoo}', "");
    Expect(0, 3808, '\p{Is_Scx=laoo}', "");
    Expect(1, 3808, '\p{^Is_Scx=laoo}', "");
    Expect(1, 3808, '\P{Is_Scx=laoo}', "");
    Expect(0, 3808, '\P{^Is_Scx=laoo}', "");
    Expect(1, 3807, '\p{Is_Scx:  Laoo}', "");
    Expect(0, 3807, '\p{^Is_Scx:  Laoo}', "");
    Expect(0, 3807, '\P{Is_Scx:  Laoo}', "");
    Expect(1, 3807, '\P{^Is_Scx:  Laoo}', "");
    Expect(0, 3808, '\p{Is_Scx:  Laoo}', "");
    Expect(1, 3808, '\p{^Is_Scx:  Laoo}', "");
    Expect(1, 3808, '\P{Is_Scx:  Laoo}', "");
    Expect(0, 3808, '\P{^Is_Scx:  Laoo}', "");
    Error('\p{Script_Extensions:	_/a/Latin}');
    Error('\P{Script_Extensions:	_/a/Latin}');
    Expect(1, 65370, '\p{Script_Extensions=:\ALatin\z:}', "");;
    Expect(0, 65371, '\p{Script_Extensions=:\ALatin\z:}', "");;
    Expect(1, 65370, '\p{Script_Extensions: latin}', "");
    Expect(0, 65370, '\p{^Script_Extensions: latin}', "");
    Expect(0, 65370, '\P{Script_Extensions: latin}', "");
    Expect(1, 65370, '\P{^Script_Extensions: latin}', "");
    Expect(0, 65371, '\p{Script_Extensions: latin}', "");
    Expect(1, 65371, '\p{^Script_Extensions: latin}', "");
    Expect(1, 65371, '\P{Script_Extensions: latin}', "");
    Expect(0, 65371, '\P{^Script_Extensions: latin}', "");
    Expect(1, 65370, '\p{Script_Extensions=:\Alatin\z:}', "");;
    Expect(0, 65371, '\p{Script_Extensions=:\Alatin\z:}', "");;
    Expect(1, 65370, '\p{Script_Extensions= Latin}', "");
    Expect(0, 65370, '\p{^Script_Extensions= Latin}', "");
    Expect(0, 65370, '\P{Script_Extensions= Latin}', "");
    Expect(1, 65370, '\P{^Script_Extensions= Latin}', "");
    Expect(0, 65371, '\p{Script_Extensions= Latin}', "");
    Expect(1, 65371, '\p{^Script_Extensions= Latin}', "");
    Expect(1, 65371, '\P{Script_Extensions= Latin}', "");
    Expect(0, 65371, '\P{^Script_Extensions= Latin}', "");
    Error('\p{Scx=--Latn:=}');
    Error('\P{Scx=--Latn:=}');
    Expect(1, 65370, '\p{Scx=:\ALatn\z:}', "");;
    Expect(0, 65371, '\p{Scx=:\ALatn\z:}', "");;
    Expect(1, 65370, '\p{Scx=latn}', "");
    Expect(0, 65370, '\p{^Scx=latn}', "");
    Expect(0, 65370, '\P{Scx=latn}', "");
    Expect(1, 65370, '\P{^Scx=latn}', "");
    Expect(0, 65371, '\p{Scx=latn}', "");
    Expect(1, 65371, '\p{^Scx=latn}', "");
    Expect(1, 65371, '\P{Scx=latn}', "");
    Expect(0, 65371, '\P{^Scx=latn}', "");
    Expect(1, 65370, '\p{Scx=:\Alatn\z:}', "");;
    Expect(0, 65371, '\p{Scx=:\Alatn\z:}', "");;
    Expect(1, 65370, '\p{Scx=-Latn}', "");
    Expect(0, 65370, '\p{^Scx=-Latn}', "");
    Expect(0, 65370, '\P{Scx=-Latn}', "");
    Expect(1, 65370, '\P{^Scx=-Latn}', "");
    Expect(0, 65371, '\p{Scx=-Latn}', "");
    Expect(1, 65371, '\p{^Scx=-Latn}', "");
    Expect(1, 65371, '\P{Scx=-Latn}', "");
    Expect(0, 65371, '\P{^Scx=-Latn}', "");
    Error('\p{Is_Script_Extensions=- Latin:=}');
    Error('\P{Is_Script_Extensions=- Latin:=}');
    Expect(1, 65370, '\p{Is_Script_Extensions=latin}', "");
    Expect(0, 65370, '\p{^Is_Script_Extensions=latin}', "");
    Expect(0, 65370, '\P{Is_Script_Extensions=latin}', "");
    Expect(1, 65370, '\P{^Is_Script_Extensions=latin}', "");
    Expect(0, 65371, '\p{Is_Script_Extensions=latin}', "");
    Expect(1, 65371, '\p{^Is_Script_Extensions=latin}', "");
    Expect(1, 65371, '\P{Is_Script_Extensions=latin}', "");
    Expect(0, 65371, '\P{^Is_Script_Extensions=latin}', "");
    Error('\p{Is_Scx= :=LATN}');
    Error('\P{Is_Scx= :=LATN}');
    Expect(1, 65370, '\p{Is_Scx:   latn}', "");
    Expect(0, 65370, '\p{^Is_Scx:   latn}', "");
    Expect(0, 65370, '\P{Is_Scx:   latn}', "");
    Expect(1, 65370, '\P{^Is_Scx:   latn}', "");
    Expect(0, 65371, '\p{Is_Scx:   latn}', "");
    Expect(1, 65371, '\p{^Is_Scx:   latn}', "");
    Expect(1, 65371, '\P{Is_Scx:   latn}', "");
    Expect(0, 65371, '\P{^Is_Scx:   latn}', "");
    Expect(1, 65370, '\p{Is_Scx=_Latn}', "");
    Expect(0, 65370, '\p{^Is_Scx=_Latn}', "");
    Expect(0, 65370, '\P{Is_Scx=_Latn}', "");
    Expect(1, 65370, '\P{^Is_Scx=_Latn}', "");
    Expect(0, 65371, '\p{Is_Scx=_Latn}', "");
    Expect(1, 65371, '\p{^Is_Scx=_Latn}', "");
    Expect(1, 65371, '\P{Is_Scx=_Latn}', "");
    Expect(0, 65371, '\P{^Is_Scx=_Latn}', "");
    Error('\p{Script_Extensions=	 LEPCHA:=}');
    Error('\P{Script_Extensions=	 LEPCHA:=}');
    Expect(1, 7247, '\p{Script_Extensions=:\ALepcha\z:}', "");;
    Expect(0, 7248, '\p{Script_Extensions=:\ALepcha\z:}', "");;
    Expect(1, 7247, '\p{Script_Extensions=lepcha}', "");
    Expect(0, 7247, '\p{^Script_Extensions=lepcha}', "");
    Expect(0, 7247, '\P{Script_Extensions=lepcha}', "");
    Expect(1, 7247, '\P{^Script_Extensions=lepcha}', "");
    Expect(0, 7248, '\p{Script_Extensions=lepcha}', "");
    Expect(1, 7248, '\p{^Script_Extensions=lepcha}', "");
    Expect(1, 7248, '\P{Script_Extensions=lepcha}', "");
    Expect(0, 7248, '\P{^Script_Extensions=lepcha}', "");
    Expect(1, 7247, '\p{Script_Extensions=:\Alepcha\z:}', "");;
    Expect(0, 7248, '\p{Script_Extensions=:\Alepcha\z:}', "");;
    Expect(1, 7247, '\p{Script_Extensions=	Lepcha}', "");
    Expect(0, 7247, '\p{^Script_Extensions=	Lepcha}', "");
    Expect(0, 7247, '\P{Script_Extensions=	Lepcha}', "");
    Expect(1, 7247, '\P{^Script_Extensions=	Lepcha}', "");
    Expect(0, 7248, '\p{Script_Extensions=	Lepcha}', "");
    Expect(1, 7248, '\p{^Script_Extensions=	Lepcha}', "");
    Expect(1, 7248, '\P{Script_Extensions=	Lepcha}', "");
    Expect(0, 7248, '\P{^Script_Extensions=	Lepcha}', "");
    Error('\p{Scx: _:=LEPC}');
    Error('\P{Scx: _:=LEPC}');
    Expect(1, 7247, '\p{Scx=:\ALepc\z:}', "");;
    Expect(0, 7248, '\p{Scx=:\ALepc\z:}', "");;
    Expect(1, 7247, '\p{Scx=lepc}', "");
    Expect(0, 7247, '\p{^Scx=lepc}', "");
    Expect(0, 7247, '\P{Scx=lepc}', "");
    Expect(1, 7247, '\P{^Scx=lepc}', "");
    Expect(0, 7248, '\p{Scx=lepc}', "");
    Expect(1, 7248, '\p{^Scx=lepc}', "");
    Expect(1, 7248, '\P{Scx=lepc}', "");
    Expect(0, 7248, '\P{^Scx=lepc}', "");
    Expect(1, 7247, '\p{Scx=:\Alepc\z:}', "");;
    Expect(0, 7248, '\p{Scx=:\Alepc\z:}', "");;
    Expect(1, 7247, '\p{Scx=_	LEPC}', "");
    Expect(0, 7247, '\p{^Scx=_	LEPC}', "");
    Expect(0, 7247, '\P{Scx=_	LEPC}', "");
    Expect(1, 7247, '\P{^Scx=_	LEPC}', "");
    Expect(0, 7248, '\p{Scx=_	LEPC}', "");
    Expect(1, 7248, '\p{^Scx=_	LEPC}', "");
    Expect(1, 7248, '\P{Scx=_	LEPC}', "");
    Expect(0, 7248, '\P{^Scx=_	LEPC}', "");
    Error('\p{Is_Script_Extensions= LEPCHA:=}');
    Error('\P{Is_Script_Extensions= LEPCHA:=}');
    Expect(1, 7247, '\p{Is_Script_Extensions=lepcha}', "");
    Expect(0, 7247, '\p{^Is_Script_Extensions=lepcha}', "");
    Expect(0, 7247, '\P{Is_Script_Extensions=lepcha}', "");
    Expect(1, 7247, '\P{^Is_Script_Extensions=lepcha}', "");
    Expect(0, 7248, '\p{Is_Script_Extensions=lepcha}', "");
    Expect(1, 7248, '\p{^Is_Script_Extensions=lepcha}', "");
    Expect(1, 7248, '\P{Is_Script_Extensions=lepcha}', "");
    Expect(0, 7248, '\P{^Is_Script_Extensions=lepcha}', "");
    Expect(1, 7247, '\p{Is_Script_Extensions=		LEPCHA}', "");
    Expect(0, 7247, '\p{^Is_Script_Extensions=		LEPCHA}', "");
    Expect(0, 7247, '\P{Is_Script_Extensions=		LEPCHA}', "");
    Expect(1, 7247, '\P{^Is_Script_Extensions=		LEPCHA}', "");
    Expect(0, 7248, '\p{Is_Script_Extensions=		LEPCHA}', "");
    Expect(1, 7248, '\p{^Is_Script_Extensions=		LEPCHA}', "");
    Expect(1, 7248, '\P{Is_Script_Extensions=		LEPCHA}', "");
    Expect(0, 7248, '\P{^Is_Script_Extensions=		LEPCHA}', "");
    Error('\p{Is_Scx=/a/ -Lepc}');
    Error('\P{Is_Scx=/a/ -Lepc}');
    Expect(1, 7247, '\p{Is_Scx=lepc}', "");
    Expect(0, 7247, '\p{^Is_Scx=lepc}', "");
    Expect(0, 7247, '\P{Is_Scx=lepc}', "");
    Expect(1, 7247, '\P{^Is_Scx=lepc}', "");
    Expect(0, 7248, '\p{Is_Scx=lepc}', "");
    Expect(1, 7248, '\p{^Is_Scx=lepc}', "");
    Expect(1, 7248, '\P{Is_Scx=lepc}', "");
    Expect(0, 7248, '\P{^Is_Scx=lepc}', "");
    Expect(1, 7247, '\p{Is_Scx= -lepc}', "");
    Expect(0, 7247, '\p{^Is_Scx= -lepc}', "");
    Expect(0, 7247, '\P{Is_Scx= -lepc}', "");
    Expect(1, 7247, '\P{^Is_Scx= -lepc}', "");
    Expect(0, 7248, '\p{Is_Scx= -lepc}', "");
    Expect(1, 7248, '\p{^Is_Scx= -lepc}', "");
    Expect(1, 7248, '\P{Is_Scx= -lepc}', "");
    Expect(0, 7248, '\P{^Is_Scx= -lepc}', "");
    Error('\p{Script_Extensions=_:=limbu}');
    Error('\P{Script_Extensions=_:=limbu}');
    Expect(1, 6479, '\p{Script_Extensions=:\ALimbu\z:}', "");;
    Expect(0, 6480, '\p{Script_Extensions=:\ALimbu\z:}', "");;
    Expect(1, 6479, '\p{Script_Extensions: limbu}', "");
    Expect(0, 6479, '\p{^Script_Extensions: limbu}', "");
    Expect(0, 6479, '\P{Script_Extensions: limbu}', "");
    Expect(1, 6479, '\P{^Script_Extensions: limbu}', "");
    Expect(0, 6480, '\p{Script_Extensions: limbu}', "");
    Expect(1, 6480, '\p{^Script_Extensions: limbu}', "");
    Expect(1, 6480, '\P{Script_Extensions: limbu}', "");
    Expect(0, 6480, '\P{^Script_Extensions: limbu}', "");
    Expect(1, 6479, '\p{Script_Extensions=:\Alimbu\z:}', "");;
    Expect(0, 6480, '\p{Script_Extensions=:\Alimbu\z:}', "");;
    Expect(1, 6479, '\p{Script_Extensions=	 Limbu}', "");
    Expect(0, 6479, '\p{^Script_Extensions=	 Limbu}', "");
    Expect(0, 6479, '\P{Script_Extensions=	 Limbu}', "");
    Expect(1, 6479, '\P{^Script_Extensions=	 Limbu}', "");
    Expect(0, 6480, '\p{Script_Extensions=	 Limbu}', "");
    Expect(1, 6480, '\p{^Script_Extensions=	 Limbu}', "");
    Expect(1, 6480, '\P{Script_Extensions=	 Limbu}', "");
    Expect(0, 6480, '\P{^Script_Extensions=	 Limbu}', "");
    Error('\p{Scx=:=-LIMB}');
    Error('\P{Scx=:=-LIMB}');
    Expect(1, 6479, '\p{Scx=:\ALimb\z:}', "");;
    Expect(0, 6480, '\p{Scx=:\ALimb\z:}', "");;
    Expect(1, 6479, '\p{Scx=limb}', "");
    Expect(0, 6479, '\p{^Scx=limb}', "");
    Expect(0, 6479, '\P{Scx=limb}', "");
    Expect(1, 6479, '\P{^Scx=limb}', "");
    Expect(0, 6480, '\p{Scx=limb}', "");
    Expect(1, 6480, '\p{^Scx=limb}', "");
    Expect(1, 6480, '\P{Scx=limb}', "");
    Expect(0, 6480, '\P{^Scx=limb}', "");
    Expect(1, 6479, '\p{Scx=:\Alimb\z:}', "");;
    Expect(0, 6480, '\p{Scx=:\Alimb\z:}', "");;
    Expect(1, 6479, '\p{Scx:		_Limb}', "");
    Expect(0, 6479, '\p{^Scx:		_Limb}', "");
    Expect(0, 6479, '\P{Scx:		_Limb}', "");
    Expect(1, 6479, '\P{^Scx:		_Limb}', "");
    Expect(0, 6480, '\p{Scx:		_Limb}', "");
    Expect(1, 6480, '\p{^Scx:		_Limb}', "");
    Expect(1, 6480, '\P{Scx:		_Limb}', "");
    Expect(0, 6480, '\P{^Scx:		_Limb}', "");
    Error('\p{Is_Script_Extensions=		LIMBU/a/}');
    Error('\P{Is_Script_Extensions=		LIMBU/a/}');
    Expect(1, 6479, '\p{Is_Script_Extensions=limbu}', "");
    Expect(0, 6479, '\p{^Is_Script_Extensions=limbu}', "");
    Expect(0, 6479, '\P{Is_Script_Extensions=limbu}', "");
    Expect(1, 6479, '\P{^Is_Script_Extensions=limbu}', "");
    Expect(0, 6480, '\p{Is_Script_Extensions=limbu}', "");
    Expect(1, 6480, '\p{^Is_Script_Extensions=limbu}', "");
    Expect(1, 6480, '\P{Is_Script_Extensions=limbu}', "");
    Expect(0, 6480, '\P{^Is_Script_Extensions=limbu}', "");
    Expect(1, 6479, '\p{Is_Script_Extensions=-	LIMBU}', "");
    Expect(0, 6479, '\p{^Is_Script_Extensions=-	LIMBU}', "");
    Expect(0, 6479, '\P{Is_Script_Extensions=-	LIMBU}', "");
    Expect(1, 6479, '\P{^Is_Script_Extensions=-	LIMBU}', "");
    Expect(0, 6480, '\p{Is_Script_Extensions=-	LIMBU}', "");
    Expect(1, 6480, '\p{^Is_Script_Extensions=-	LIMBU}', "");
    Expect(1, 6480, '\P{Is_Script_Extensions=-	LIMBU}', "");
    Expect(0, 6480, '\P{^Is_Script_Extensions=-	LIMBU}', "");
    Error('\p{Is_Scx=:=-_Limb}');
    Error('\P{Is_Scx=:=-_Limb}');
    Expect(1, 6479, '\p{Is_Scx=limb}', "");
    Expect(0, 6479, '\p{^Is_Scx=limb}', "");
    Expect(0, 6479, '\P{Is_Scx=limb}', "");
    Expect(1, 6479, '\P{^Is_Scx=limb}', "");
    Expect(0, 6480, '\p{Is_Scx=limb}', "");
    Expect(1, 6480, '\p{^Is_Scx=limb}', "");
    Expect(1, 6480, '\P{Is_Scx=limb}', "");
    Expect(0, 6480, '\P{^Is_Scx=limb}', "");
    Expect(1, 6479, '\p{Is_Scx=__LIMB}', "");
    Expect(0, 6479, '\p{^Is_Scx=__LIMB}', "");
    Expect(0, 6479, '\P{Is_Scx=__LIMB}', "");
    Expect(1, 6479, '\P{^Is_Scx=__LIMB}', "");
    Expect(0, 6480, '\p{Is_Scx=__LIMB}', "");
    Expect(1, 6480, '\p{^Is_Scx=__LIMB}', "");
    Expect(1, 6480, '\P{Is_Scx=__LIMB}', "");
    Expect(0, 6480, '\P{^Is_Scx=__LIMB}', "");
    Error('\p{Script_Extensions::=-Linear_A}');
    Error('\P{Script_Extensions::=-Linear_A}');
    Expect(1, 67431, '\p{Script_Extensions=:\ALinear_A\z:}', "");;
    Expect(0, 67432, '\p{Script_Extensions=:\ALinear_A\z:}', "");;
    Expect(1, 67431, '\p{Script_Extensions:	lineara}', "");
    Expect(0, 67431, '\p{^Script_Extensions:	lineara}', "");
    Expect(0, 67431, '\P{Script_Extensions:	lineara}', "");
    Expect(1, 67431, '\P{^Script_Extensions:	lineara}', "");
    Expect(0, 67432, '\p{Script_Extensions:	lineara}', "");
    Expect(1, 67432, '\p{^Script_Extensions:	lineara}', "");
    Expect(1, 67432, '\P{Script_Extensions:	lineara}', "");
    Expect(0, 67432, '\P{^Script_Extensions:	lineara}', "");
    Expect(1, 67431, '\p{Script_Extensions=:\Alineara\z:}', "");;
    Expect(0, 67432, '\p{Script_Extensions=:\Alineara\z:}', "");;
    Expect(1, 67431, '\p{Script_Extensions=  Linear_A}', "");
    Expect(0, 67431, '\p{^Script_Extensions=  Linear_A}', "");
    Expect(0, 67431, '\P{Script_Extensions=  Linear_A}', "");
    Expect(1, 67431, '\P{^Script_Extensions=  Linear_A}', "");
    Expect(0, 67432, '\p{Script_Extensions=  Linear_A}', "");
    Expect(1, 67432, '\p{^Script_Extensions=  Linear_A}', "");
    Expect(1, 67432, '\P{Script_Extensions=  Linear_A}', "");
    Expect(0, 67432, '\P{^Script_Extensions=  Linear_A}', "");
    Error('\p{Scx=		LINA/a/}');
    Error('\P{Scx=		LINA/a/}');
    Expect(1, 67431, '\p{Scx=:\ALina\z:}', "");;
    Expect(0, 67432, '\p{Scx=:\ALina\z:}', "");;
    Expect(1, 67431, '\p{Scx=lina}', "");
    Expect(0, 67431, '\p{^Scx=lina}', "");
    Expect(0, 67431, '\P{Scx=lina}', "");
    Expect(1, 67431, '\P{^Scx=lina}', "");
    Expect(0, 67432, '\p{Scx=lina}', "");
    Expect(1, 67432, '\p{^Scx=lina}', "");
    Expect(1, 67432, '\P{Scx=lina}', "");
    Expect(0, 67432, '\P{^Scx=lina}', "");
    Expect(1, 67431, '\p{Scx=:\Alina\z:}', "");;
    Expect(0, 67432, '\p{Scx=:\Alina\z:}', "");;
    Expect(1, 67431, '\p{Scx= _Lina}', "");
    Expect(0, 67431, '\p{^Scx= _Lina}', "");
    Expect(0, 67431, '\P{Scx= _Lina}', "");
    Expect(1, 67431, '\P{^Scx= _Lina}', "");
    Expect(0, 67432, '\p{Scx= _Lina}', "");
    Expect(1, 67432, '\p{^Scx= _Lina}', "");
    Expect(1, 67432, '\P{Scx= _Lina}', "");
    Expect(0, 67432, '\P{^Scx= _Lina}', "");
    Error('\p{Is_Script_Extensions=-/a/linear_A}');
    Error('\P{Is_Script_Extensions=-/a/linear_A}');
    Expect(1, 67431, '\p{Is_Script_Extensions=lineara}', "");
    Expect(0, 67431, '\p{^Is_Script_Extensions=lineara}', "");
    Expect(0, 67431, '\P{Is_Script_Extensions=lineara}', "");
    Expect(1, 67431, '\P{^Is_Script_Extensions=lineara}', "");
    Expect(0, 67432, '\p{Is_Script_Extensions=lineara}', "");
    Expect(1, 67432, '\p{^Is_Script_Extensions=lineara}', "");
    Expect(1, 67432, '\P{Is_Script_Extensions=lineara}', "");
    Expect(0, 67432, '\P{^Is_Script_Extensions=lineara}', "");
    Expect(1, 67431, '\p{Is_Script_Extensions=-_linear_a}', "");
    Expect(0, 67431, '\p{^Is_Script_Extensions=-_linear_a}', "");
    Expect(0, 67431, '\P{Is_Script_Extensions=-_linear_a}', "");
    Expect(1, 67431, '\P{^Is_Script_Extensions=-_linear_a}', "");
    Expect(0, 67432, '\p{Is_Script_Extensions=-_linear_a}', "");
    Expect(1, 67432, '\p{^Is_Script_Extensions=-_linear_a}', "");
    Expect(1, 67432, '\P{Is_Script_Extensions=-_linear_a}', "");
    Expect(0, 67432, '\P{^Is_Script_Extensions=-_linear_a}', "");
    Error('\p{Is_Scx:   	Lina:=}');
    Error('\P{Is_Scx:   	Lina:=}');
    Expect(1, 67431, '\p{Is_Scx=lina}', "");
    Expect(0, 67431, '\p{^Is_Scx=lina}', "");
    Expect(0, 67431, '\P{Is_Scx=lina}', "");
    Expect(1, 67431, '\P{^Is_Scx=lina}', "");
    Expect(0, 67432, '\p{Is_Scx=lina}', "");
    Expect(1, 67432, '\p{^Is_Scx=lina}', "");
    Expect(1, 67432, '\P{Is_Scx=lina}', "");
    Expect(0, 67432, '\P{^Is_Scx=lina}', "");
    Expect(1, 67431, '\p{Is_Scx= -Lina}', "");
    Expect(0, 67431, '\p{^Is_Scx= -Lina}', "");
    Expect(0, 67431, '\P{Is_Scx= -Lina}', "");
    Expect(1, 67431, '\P{^Is_Scx= -Lina}', "");
    Expect(0, 67432, '\p{Is_Scx= -Lina}', "");
    Expect(1, 67432, '\p{^Is_Scx= -Lina}', "");
    Expect(1, 67432, '\P{Is_Scx= -Lina}', "");
    Expect(0, 67432, '\P{^Is_Scx= -Lina}', "");
    Error('\p{Script_Extensions=		linear_B/a/}');
    Error('\P{Script_Extensions=		linear_B/a/}');
    Expect(1, 65855, '\p{Script_Extensions=:\ALinear_B\z:}', "");;
    Expect(0, 65856, '\p{Script_Extensions=:\ALinear_B\z:}', "");;
    Expect(1, 65855, '\p{Script_Extensions=linearb}', "");
    Expect(0, 65855, '\p{^Script_Extensions=linearb}', "");
    Expect(0, 65855, '\P{Script_Extensions=linearb}', "");
    Expect(1, 65855, '\P{^Script_Extensions=linearb}', "");
    Expect(0, 65856, '\p{Script_Extensions=linearb}', "");
    Expect(1, 65856, '\p{^Script_Extensions=linearb}', "");
    Expect(1, 65856, '\P{Script_Extensions=linearb}', "");
    Expect(0, 65856, '\P{^Script_Extensions=linearb}', "");
    Expect(1, 65855, '\p{Script_Extensions=:\Alinearb\z:}', "");;
    Expect(0, 65856, '\p{Script_Extensions=:\Alinearb\z:}', "");;
    Expect(1, 65855, '\p{Script_Extensions= _linear_B}', "");
    Expect(0, 65855, '\p{^Script_Extensions= _linear_B}', "");
    Expect(0, 65855, '\P{Script_Extensions= _linear_B}', "");
    Expect(1, 65855, '\P{^Script_Extensions= _linear_B}', "");
    Expect(0, 65856, '\p{Script_Extensions= _linear_B}', "");
    Expect(1, 65856, '\p{^Script_Extensions= _linear_B}', "");
    Expect(1, 65856, '\P{Script_Extensions= _linear_B}', "");
    Expect(0, 65856, '\P{^Script_Extensions= _linear_B}', "");
    Error('\p{Scx= :=linb}');
    Error('\P{Scx= :=linb}');
    Expect(1, 65855, '\p{Scx=:\ALinb\z:}', "");;
    Expect(0, 65856, '\p{Scx=:\ALinb\z:}', "");;
    Expect(1, 65855, '\p{Scx=linb}', "");
    Expect(0, 65855, '\p{^Scx=linb}', "");
    Expect(0, 65855, '\P{Scx=linb}', "");
    Expect(1, 65855, '\P{^Scx=linb}', "");
    Expect(0, 65856, '\p{Scx=linb}', "");
    Expect(1, 65856, '\p{^Scx=linb}', "");
    Expect(1, 65856, '\P{Scx=linb}', "");
    Expect(0, 65856, '\P{^Scx=linb}', "");
    Expect(1, 65855, '\p{Scx=:\Alinb\z:}', "");;
    Expect(0, 65856, '\p{Scx=:\Alinb\z:}', "");;
    Expect(1, 65855, '\p{Scx=		Linb}', "");
    Expect(0, 65855, '\p{^Scx=		Linb}', "");
    Expect(0, 65855, '\P{Scx=		Linb}', "");
    Expect(1, 65855, '\P{^Scx=		Linb}', "");
    Expect(0, 65856, '\p{Scx=		Linb}', "");
    Expect(1, 65856, '\p{^Scx=		Linb}', "");
    Expect(1, 65856, '\P{Scx=		Linb}', "");
    Expect(0, 65856, '\P{^Scx=		Linb}', "");
    Error('\p{Is_Script_Extensions=:=- Linear_B}');
    Error('\P{Is_Script_Extensions=:=- Linear_B}');
    Expect(1, 65855, '\p{Is_Script_Extensions=linearb}', "");
    Expect(0, 65855, '\p{^Is_Script_Extensions=linearb}', "");
    Expect(0, 65855, '\P{Is_Script_Extensions=linearb}', "");
    Expect(1, 65855, '\P{^Is_Script_Extensions=linearb}', "");
    Expect(0, 65856, '\p{Is_Script_Extensions=linearb}', "");
    Expect(1, 65856, '\p{^Is_Script_Extensions=linearb}', "");
    Expect(1, 65856, '\P{Is_Script_Extensions=linearb}', "");
    Expect(0, 65856, '\P{^Is_Script_Extensions=linearb}', "");
    Expect(1, 65855, '\p{Is_Script_Extensions=	 Linear_b}', "");
    Expect(0, 65855, '\p{^Is_Script_Extensions=	 Linear_b}', "");
    Expect(0, 65855, '\P{Is_Script_Extensions=	 Linear_b}', "");
    Expect(1, 65855, '\P{^Is_Script_Extensions=	 Linear_b}', "");
    Expect(0, 65856, '\p{Is_Script_Extensions=	 Linear_b}', "");
    Expect(1, 65856, '\p{^Is_Script_Extensions=	 Linear_b}', "");
    Expect(1, 65856, '\P{Is_Script_Extensions=	 Linear_b}', "");
    Expect(0, 65856, '\P{^Is_Script_Extensions=	 Linear_b}', "");
    Error('\p{Is_Scx: _/a/Linb}');
    Error('\P{Is_Scx: _/a/Linb}');
    Expect(1, 65855, '\p{Is_Scx:linb}', "");
    Expect(0, 65855, '\p{^Is_Scx:linb}', "");
    Expect(0, 65855, '\P{Is_Scx:linb}', "");
    Expect(1, 65855, '\P{^Is_Scx:linb}', "");
    Expect(0, 65856, '\p{Is_Scx:linb}', "");
    Expect(1, 65856, '\p{^Is_Scx:linb}', "");
    Expect(1, 65856, '\P{Is_Scx:linb}', "");
    Expect(0, 65856, '\P{^Is_Scx:linb}', "");
    Expect(1, 65855, '\p{Is_Scx=_ Linb}', "");
    Expect(0, 65855, '\p{^Is_Scx=_ Linb}', "");
    Expect(0, 65855, '\P{Is_Scx=_ Linb}', "");
    Expect(1, 65855, '\P{^Is_Scx=_ Linb}', "");
    Expect(0, 65856, '\p{Is_Scx=_ Linb}', "");
    Expect(1, 65856, '\p{^Is_Scx=_ Linb}', "");
    Expect(1, 65856, '\P{Is_Scx=_ Linb}', "");
    Expect(0, 65856, '\P{^Is_Scx=_ Linb}', "");
    Error('\p{Script_Extensions=:=-LISU}');
    Error('\P{Script_Extensions=:=-LISU}');
    Expect(1, 42239, '\p{Script_Extensions=:\ALisu\z:}', "");;
    Expect(0, 42240, '\p{Script_Extensions=:\ALisu\z:}', "");;
    Expect(1, 42239, '\p{Script_Extensions=lisu}', "");
    Expect(0, 42239, '\p{^Script_Extensions=lisu}', "");
    Expect(0, 42239, '\P{Script_Extensions=lisu}', "");
    Expect(1, 42239, '\P{^Script_Extensions=lisu}', "");
    Expect(0, 42240, '\p{Script_Extensions=lisu}', "");
    Expect(1, 42240, '\p{^Script_Extensions=lisu}', "");
    Expect(1, 42240, '\P{Script_Extensions=lisu}', "");
    Expect(0, 42240, '\P{^Script_Extensions=lisu}', "");
    Expect(1, 42239, '\p{Script_Extensions=:\Alisu\z:}', "");;
    Expect(0, 42240, '\p{Script_Extensions=:\Alisu\z:}', "");;
    Expect(1, 42239, '\p{Script_Extensions=- Lisu}', "");
    Expect(0, 42239, '\p{^Script_Extensions=- Lisu}', "");
    Expect(0, 42239, '\P{Script_Extensions=- Lisu}', "");
    Expect(1, 42239, '\P{^Script_Extensions=- Lisu}', "");
    Expect(0, 42240, '\p{Script_Extensions=- Lisu}', "");
    Expect(1, 42240, '\p{^Script_Extensions=- Lisu}', "");
    Expect(1, 42240, '\P{Script_Extensions=- Lisu}', "");
    Expect(0, 42240, '\P{^Script_Extensions=- Lisu}', "");
    Error('\p{Scx=/a/--LISU}');
    Error('\P{Scx=/a/--LISU}');
    Expect(1, 42239, '\p{Scx=:\ALisu\z:}', "");;
    Expect(0, 42240, '\p{Scx=:\ALisu\z:}', "");;
    Expect(1, 42239, '\p{Scx=lisu}', "");
    Expect(0, 42239, '\p{^Scx=lisu}', "");
    Expect(0, 42239, '\P{Scx=lisu}', "");
    Expect(1, 42239, '\P{^Scx=lisu}', "");
    Expect(0, 42240, '\p{Scx=lisu}', "");
    Expect(1, 42240, '\p{^Scx=lisu}', "");
    Expect(1, 42240, '\P{Scx=lisu}', "");
    Expect(0, 42240, '\P{^Scx=lisu}', "");
    Expect(1, 42239, '\p{Scx=:\Alisu\z:}', "");;
    Expect(0, 42240, '\p{Scx=:\Alisu\z:}', "");;
    Expect(1, 42239, '\p{Scx=	-Lisu}', "");
    Expect(0, 42239, '\p{^Scx=	-Lisu}', "");
    Expect(0, 42239, '\P{Scx=	-Lisu}', "");
    Expect(1, 42239, '\P{^Scx=	-Lisu}', "");
    Expect(0, 42240, '\p{Scx=	-Lisu}', "");
    Expect(1, 42240, '\p{^Scx=	-Lisu}', "");
    Expect(1, 42240, '\P{Scx=	-Lisu}', "");
    Expect(0, 42240, '\P{^Scx=	-Lisu}', "");
    Error('\p{Is_Script_Extensions: _/a/Lisu}');
    Error('\P{Is_Script_Extensions: _/a/Lisu}');
    Expect(1, 42239, '\p{Is_Script_Extensions=lisu}', "");
    Expect(0, 42239, '\p{^Is_Script_Extensions=lisu}', "");
    Expect(0, 42239, '\P{Is_Script_Extensions=lisu}', "");
    Expect(1, 42239, '\P{^Is_Script_Extensions=lisu}', "");
    Expect(0, 42240, '\p{Is_Script_Extensions=lisu}', "");
    Expect(1, 42240, '\p{^Is_Script_Extensions=lisu}', "");
    Expect(1, 42240, '\P{Is_Script_Extensions=lisu}', "");
    Expect(0, 42240, '\P{^Is_Script_Extensions=lisu}', "");
    Expect(1, 42239, '\p{Is_Script_Extensions=__LISU}', "");
    Expect(0, 42239, '\p{^Is_Script_Extensions=__LISU}', "");
    Expect(0, 42239, '\P{Is_Script_Extensions=__LISU}', "");
    Expect(1, 42239, '\P{^Is_Script_Extensions=__LISU}', "");
    Expect(0, 42240, '\p{Is_Script_Extensions=__LISU}', "");
    Expect(1, 42240, '\p{^Is_Script_Extensions=__LISU}', "");
    Expect(1, 42240, '\P{Is_Script_Extensions=__LISU}', "");
    Expect(0, 42240, '\P{^Is_Script_Extensions=__LISU}', "");
    Error('\p{Is_Scx=/a/_	Lisu}');
    Error('\P{Is_Scx=/a/_	Lisu}');
    Expect(1, 42239, '\p{Is_Scx=lisu}', "");
    Expect(0, 42239, '\p{^Is_Scx=lisu}', "");
    Expect(0, 42239, '\P{Is_Scx=lisu}', "");
    Expect(1, 42239, '\P{^Is_Scx=lisu}', "");
    Expect(0, 42240, '\p{Is_Scx=lisu}', "");
    Expect(1, 42240, '\p{^Is_Scx=lisu}', "");
    Expect(1, 42240, '\P{Is_Scx=lisu}', "");
    Expect(0, 42240, '\P{^Is_Scx=lisu}', "");
    Expect(1, 42239, '\p{Is_Scx=-_Lisu}', "");
    Expect(0, 42239, '\p{^Is_Scx=-_Lisu}', "");
    Expect(0, 42239, '\P{Is_Scx=-_Lisu}', "");
    Expect(1, 42239, '\P{^Is_Scx=-_Lisu}', "");
    Expect(0, 42240, '\p{Is_Scx=-_Lisu}', "");
    Expect(1, 42240, '\p{^Is_Scx=-_Lisu}', "");
    Expect(1, 42240, '\P{Is_Scx=-_Lisu}', "");
    Expect(0, 42240, '\P{^Is_Scx=-_Lisu}', "");
    Error('\p{Script_Extensions= :=Lycian}');
    Error('\P{Script_Extensions= :=Lycian}');
    Expect(1, 66204, '\p{Script_Extensions=:\ALycian\z:}', "");;
    Expect(0, 66205, '\p{Script_Extensions=:\ALycian\z:}', "");;
    Expect(1, 66204, '\p{Script_Extensions=lycian}', "");
    Expect(0, 66204, '\p{^Script_Extensions=lycian}', "");
    Expect(0, 66204, '\P{Script_Extensions=lycian}', "");
    Expect(1, 66204, '\P{^Script_Extensions=lycian}', "");
    Expect(0, 66205, '\p{Script_Extensions=lycian}', "");
    Expect(1, 66205, '\p{^Script_Extensions=lycian}', "");
    Expect(1, 66205, '\P{Script_Extensions=lycian}', "");
    Expect(0, 66205, '\P{^Script_Extensions=lycian}', "");
    Expect(1, 66204, '\p{Script_Extensions=:\Alycian\z:}', "");;
    Expect(0, 66205, '\p{Script_Extensions=:\Alycian\z:}', "");;
    Expect(1, 66204, '\p{Script_Extensions=	Lycian}', "");
    Expect(0, 66204, '\p{^Script_Extensions=	Lycian}', "");
    Expect(0, 66204, '\P{Script_Extensions=	Lycian}', "");
    Expect(1, 66204, '\P{^Script_Extensions=	Lycian}', "");
    Expect(0, 66205, '\p{Script_Extensions=	Lycian}', "");
    Expect(1, 66205, '\p{^Script_Extensions=	Lycian}', "");
    Expect(1, 66205, '\P{Script_Extensions=	Lycian}', "");
    Expect(0, 66205, '\P{^Script_Extensions=	Lycian}', "");
    Error('\p{Scx=/a/-Lyci}');
    Error('\P{Scx=/a/-Lyci}');
    Expect(1, 66204, '\p{Scx=:\ALyci\z:}', "");;
    Expect(0, 66205, '\p{Scx=:\ALyci\z:}', "");;
    Expect(1, 66204, '\p{Scx=lyci}', "");
    Expect(0, 66204, '\p{^Scx=lyci}', "");
    Expect(0, 66204, '\P{Scx=lyci}', "");
    Expect(1, 66204, '\P{^Scx=lyci}', "");
    Expect(0, 66205, '\p{Scx=lyci}', "");
    Expect(1, 66205, '\p{^Scx=lyci}', "");
    Expect(1, 66205, '\P{Scx=lyci}', "");
    Expect(0, 66205, '\P{^Scx=lyci}', "");
    Expect(1, 66204, '\p{Scx=:\Alyci\z:}', "");;
    Expect(0, 66205, '\p{Scx=:\Alyci\z:}', "");;
    Expect(1, 66204, '\p{Scx=-_Lyci}', "");
    Expect(0, 66204, '\p{^Scx=-_Lyci}', "");
    Expect(0, 66204, '\P{Scx=-_Lyci}', "");
    Expect(1, 66204, '\P{^Scx=-_Lyci}', "");
    Expect(0, 66205, '\p{Scx=-_Lyci}', "");
    Expect(1, 66205, '\p{^Scx=-_Lyci}', "");
    Expect(1, 66205, '\P{Scx=-_Lyci}', "");
    Expect(0, 66205, '\P{^Scx=-_Lyci}', "");
    Error('\p{Is_Script_Extensions=:=__Lycian}');
    Error('\P{Is_Script_Extensions=:=__Lycian}');
    Expect(1, 66204, '\p{Is_Script_Extensions=lycian}', "");
    Expect(0, 66204, '\p{^Is_Script_Extensions=lycian}', "");
    Expect(0, 66204, '\P{Is_Script_Extensions=lycian}', "");
    Expect(1, 66204, '\P{^Is_Script_Extensions=lycian}', "");
    Expect(0, 66205, '\p{Is_Script_Extensions=lycian}', "");
    Expect(1, 66205, '\p{^Is_Script_Extensions=lycian}', "");
    Expect(1, 66205, '\P{Is_Script_Extensions=lycian}', "");
    Expect(0, 66205, '\P{^Is_Script_Extensions=lycian}', "");
    Expect(1, 66204, '\p{Is_Script_Extensions:	-lycian}', "");
    Expect(0, 66204, '\p{^Is_Script_Extensions:	-lycian}', "");
    Expect(0, 66204, '\P{Is_Script_Extensions:	-lycian}', "");
    Expect(1, 66204, '\P{^Is_Script_Extensions:	-lycian}', "");
    Expect(0, 66205, '\p{Is_Script_Extensions:	-lycian}', "");
    Expect(1, 66205, '\p{^Is_Script_Extensions:	-lycian}', "");
    Expect(1, 66205, '\P{Is_Script_Extensions:	-lycian}', "");
    Expect(0, 66205, '\P{^Is_Script_Extensions:	-lycian}', "");
    Error('\p{Is_Scx=/a/	LYCI}');
    Error('\P{Is_Scx=/a/	LYCI}');
    Expect(1, 66204, '\p{Is_Scx:	lyci}', "");
    Expect(0, 66204, '\p{^Is_Scx:	lyci}', "");
    Expect(0, 66204, '\P{Is_Scx:	lyci}', "");
    Expect(1, 66204, '\P{^Is_Scx:	lyci}', "");
    Expect(0, 66205, '\p{Is_Scx:	lyci}', "");
    Expect(1, 66205, '\p{^Is_Scx:	lyci}', "");
    Expect(1, 66205, '\P{Is_Scx:	lyci}', "");
    Expect(0, 66205, '\P{^Is_Scx:	lyci}', "");
    Expect(1, 66204, '\p{Is_Scx:	 Lyci}', "");
    Expect(0, 66204, '\p{^Is_Scx:	 Lyci}', "");
    Expect(0, 66204, '\P{Is_Scx:	 Lyci}', "");
    Expect(1, 66204, '\P{^Is_Scx:	 Lyci}', "");
    Expect(0, 66205, '\p{Is_Scx:	 Lyci}', "");
    Expect(1, 66205, '\p{^Is_Scx:	 Lyci}', "");
    Expect(1, 66205, '\P{Is_Scx:	 Lyci}', "");
    Expect(0, 66205, '\P{^Is_Scx:	 Lyci}', "");
    Error('\p{Script_Extensions:    -LYDIAN/a/}');
    Error('\P{Script_Extensions:    -LYDIAN/a/}');
    Expect(1, 67903, '\p{Script_Extensions=:\ALydian\z:}', "");;
    Expect(0, 67904, '\p{Script_Extensions=:\ALydian\z:}', "");;
    Expect(1, 67903, '\p{Script_Extensions=lydian}', "");
    Expect(0, 67903, '\p{^Script_Extensions=lydian}', "");
    Expect(0, 67903, '\P{Script_Extensions=lydian}', "");
    Expect(1, 67903, '\P{^Script_Extensions=lydian}', "");
    Expect(0, 67904, '\p{Script_Extensions=lydian}', "");
    Expect(1, 67904, '\p{^Script_Extensions=lydian}', "");
    Expect(1, 67904, '\P{Script_Extensions=lydian}', "");
    Expect(0, 67904, '\P{^Script_Extensions=lydian}', "");
    Expect(1, 67903, '\p{Script_Extensions=:\Alydian\z:}', "");;
    Expect(0, 67904, '\p{Script_Extensions=:\Alydian\z:}', "");;
    Expect(1, 67903, '\p{Script_Extensions=	-Lydian}', "");
    Expect(0, 67903, '\p{^Script_Extensions=	-Lydian}', "");
    Expect(0, 67903, '\P{Script_Extensions=	-Lydian}', "");
    Expect(1, 67903, '\P{^Script_Extensions=	-Lydian}', "");
    Expect(0, 67904, '\p{Script_Extensions=	-Lydian}', "");
    Expect(1, 67904, '\p{^Script_Extensions=	-Lydian}', "");
    Expect(1, 67904, '\P{Script_Extensions=	-Lydian}', "");
    Expect(0, 67904, '\P{^Script_Extensions=	-Lydian}', "");
    Error('\p{Scx=-lydi/a/}');
    Error('\P{Scx=-lydi/a/}');
    Expect(1, 67903, '\p{Scx=:\ALydi\z:}', "");;
    Expect(0, 67904, '\p{Scx=:\ALydi\z:}', "");;
    Expect(1, 67903, '\p{Scx=lydi}', "");
    Expect(0, 67903, '\p{^Scx=lydi}', "");
    Expect(0, 67903, '\P{Scx=lydi}', "");
    Expect(1, 67903, '\P{^Scx=lydi}', "");
    Expect(0, 67904, '\p{Scx=lydi}', "");
    Expect(1, 67904, '\p{^Scx=lydi}', "");
    Expect(1, 67904, '\P{Scx=lydi}', "");
    Expect(0, 67904, '\P{^Scx=lydi}', "");
    Expect(1, 67903, '\p{Scx=:\Alydi\z:}', "");;
    Expect(0, 67904, '\p{Scx=:\Alydi\z:}', "");;
    Expect(1, 67903, '\p{Scx=- Lydi}', "");
    Expect(0, 67903, '\p{^Scx=- Lydi}', "");
    Expect(0, 67903, '\P{Scx=- Lydi}', "");
    Expect(1, 67903, '\P{^Scx=- Lydi}', "");
    Expect(0, 67904, '\p{Scx=- Lydi}', "");
    Expect(1, 67904, '\p{^Scx=- Lydi}', "");
    Expect(1, 67904, '\P{Scx=- Lydi}', "");
    Expect(0, 67904, '\P{^Scx=- Lydi}', "");
    Error('\p{Is_Script_Extensions=- LYDIAN/a/}');
    Error('\P{Is_Script_Extensions=- LYDIAN/a/}');
    Expect(1, 67903, '\p{Is_Script_Extensions=lydian}', "");
    Expect(0, 67903, '\p{^Is_Script_Extensions=lydian}', "");
    Expect(0, 67903, '\P{Is_Script_Extensions=lydian}', "");
    Expect(1, 67903, '\P{^Is_Script_Extensions=lydian}', "");
    Expect(0, 67904, '\p{Is_Script_Extensions=lydian}', "");
    Expect(1, 67904, '\p{^Is_Script_Extensions=lydian}', "");
    Expect(1, 67904, '\P{Is_Script_Extensions=lydian}', "");
    Expect(0, 67904, '\P{^Is_Script_Extensions=lydian}', "");
    Expect(1, 67903, '\p{Is_Script_Extensions= _LYDIAN}', "");
    Expect(0, 67903, '\p{^Is_Script_Extensions= _LYDIAN}', "");
    Expect(0, 67903, '\P{Is_Script_Extensions= _LYDIAN}', "");
    Expect(1, 67903, '\P{^Is_Script_Extensions= _LYDIAN}', "");
    Expect(0, 67904, '\p{Is_Script_Extensions= _LYDIAN}', "");
    Expect(1, 67904, '\p{^Is_Script_Extensions= _LYDIAN}', "");
    Expect(1, 67904, '\P{Is_Script_Extensions= _LYDIAN}', "");
    Expect(0, 67904, '\P{^Is_Script_Extensions= _LYDIAN}', "");
    Error('\p{Is_Scx=:=  lydi}');
    Error('\P{Is_Scx=:=  lydi}');
    Expect(1, 67903, '\p{Is_Scx=lydi}', "");
    Expect(0, 67903, '\p{^Is_Scx=lydi}', "");
    Expect(0, 67903, '\P{Is_Scx=lydi}', "");
    Expect(1, 67903, '\P{^Is_Scx=lydi}', "");
    Expect(0, 67904, '\p{Is_Scx=lydi}', "");
    Expect(1, 67904, '\p{^Is_Scx=lydi}', "");
    Expect(1, 67904, '\P{Is_Scx=lydi}', "");
    Expect(0, 67904, '\P{^Is_Scx=lydi}', "");
    Expect(1, 67903, '\p{Is_Scx=	_lydi}', "");
    Expect(0, 67903, '\p{^Is_Scx=	_lydi}', "");
    Expect(0, 67903, '\P{Is_Scx=	_lydi}', "");
    Expect(1, 67903, '\P{^Is_Scx=	_lydi}', "");
    Expect(0, 67904, '\p{Is_Scx=	_lydi}', "");
    Expect(1, 67904, '\p{^Is_Scx=	_lydi}', "");
    Expect(1, 67904, '\P{Is_Scx=	_lydi}', "");
    Expect(0, 67904, '\P{^Is_Scx=	_lydi}', "");
    Error('\p{Script_Extensions=/a/	Mahajani}');
    Error('\P{Script_Extensions=/a/	Mahajani}');
    Expect(1, 70006, '\p{Script_Extensions=:\AMahajani\z:}', "");;
    Expect(0, 70007, '\p{Script_Extensions=:\AMahajani\z:}', "");;
    Expect(1, 70006, '\p{Script_Extensions=mahajani}', "");
    Expect(0, 70006, '\p{^Script_Extensions=mahajani}', "");
    Expect(0, 70006, '\P{Script_Extensions=mahajani}', "");
    Expect(1, 70006, '\P{^Script_Extensions=mahajani}', "");
    Expect(0, 70007, '\p{Script_Extensions=mahajani}', "");
    Expect(1, 70007, '\p{^Script_Extensions=mahajani}', "");
    Expect(1, 70007, '\P{Script_Extensions=mahajani}', "");
    Expect(0, 70007, '\P{^Script_Extensions=mahajani}', "");
    Expect(1, 70006, '\p{Script_Extensions=:\Amahajani\z:}', "");;
    Expect(0, 70007, '\p{Script_Extensions=:\Amahajani\z:}', "");;
    Expect(1, 70006, '\p{Script_Extensions=-MAHAJANI}', "");
    Expect(0, 70006, '\p{^Script_Extensions=-MAHAJANI}', "");
    Expect(0, 70006, '\P{Script_Extensions=-MAHAJANI}', "");
    Expect(1, 70006, '\P{^Script_Extensions=-MAHAJANI}', "");
    Expect(0, 70007, '\p{Script_Extensions=-MAHAJANI}', "");
    Expect(1, 70007, '\p{^Script_Extensions=-MAHAJANI}', "");
    Expect(1, 70007, '\P{Script_Extensions=-MAHAJANI}', "");
    Expect(0, 70007, '\P{^Script_Extensions=-MAHAJANI}', "");
    Error('\p{Scx:   -_Mahj:=}');
    Error('\P{Scx:   -_Mahj:=}');
    Expect(1, 70006, '\p{Scx=:\AMahj\z:}', "");;
    Expect(0, 70007, '\p{Scx=:\AMahj\z:}', "");;
    Expect(1, 70006, '\p{Scx=mahj}', "");
    Expect(0, 70006, '\p{^Scx=mahj}', "");
    Expect(0, 70006, '\P{Scx=mahj}', "");
    Expect(1, 70006, '\P{^Scx=mahj}', "");
    Expect(0, 70007, '\p{Scx=mahj}', "");
    Expect(1, 70007, '\p{^Scx=mahj}', "");
    Expect(1, 70007, '\P{Scx=mahj}', "");
    Expect(0, 70007, '\P{^Scx=mahj}', "");
    Expect(1, 70006, '\p{Scx=:\Amahj\z:}', "");;
    Expect(0, 70007, '\p{Scx=:\Amahj\z:}', "");;
    Expect(1, 70006, '\p{Scx=-	Mahj}', "");
    Expect(0, 70006, '\p{^Scx=-	Mahj}', "");
    Expect(0, 70006, '\P{Scx=-	Mahj}', "");
    Expect(1, 70006, '\P{^Scx=-	Mahj}', "");
    Expect(0, 70007, '\p{Scx=-	Mahj}', "");
    Expect(1, 70007, '\p{^Scx=-	Mahj}', "");
    Expect(1, 70007, '\P{Scx=-	Mahj}', "");
    Expect(0, 70007, '\P{^Scx=-	Mahj}', "");
    Error('\p{Is_Script_Extensions=	Mahajani/a/}');
    Error('\P{Is_Script_Extensions=	Mahajani/a/}');
    Expect(1, 70006, '\p{Is_Script_Extensions=mahajani}', "");
    Expect(0, 70006, '\p{^Is_Script_Extensions=mahajani}', "");
    Expect(0, 70006, '\P{Is_Script_Extensions=mahajani}', "");
    Expect(1, 70006, '\P{^Is_Script_Extensions=mahajani}', "");
    Expect(0, 70007, '\p{Is_Script_Extensions=mahajani}', "");
    Expect(1, 70007, '\p{^Is_Script_Extensions=mahajani}', "");
    Expect(1, 70007, '\P{Is_Script_Extensions=mahajani}', "");
    Expect(0, 70007, '\P{^Is_Script_Extensions=mahajani}', "");
    Expect(1, 70006, '\p{Is_Script_Extensions:   	MAHAJANI}', "");
    Expect(0, 70006, '\p{^Is_Script_Extensions:   	MAHAJANI}', "");
    Expect(0, 70006, '\P{Is_Script_Extensions:   	MAHAJANI}', "");
    Expect(1, 70006, '\P{^Is_Script_Extensions:   	MAHAJANI}', "");
    Expect(0, 70007, '\p{Is_Script_Extensions:   	MAHAJANI}', "");
    Expect(1, 70007, '\p{^Is_Script_Extensions:   	MAHAJANI}', "");
    Expect(1, 70007, '\P{Is_Script_Extensions:   	MAHAJANI}', "");
    Expect(0, 70007, '\P{^Is_Script_Extensions:   	MAHAJANI}', "");
    Error('\p{Is_Scx=/a/_	Mahj}');
    Error('\P{Is_Scx=/a/_	Mahj}');
    Expect(1, 70006, '\p{Is_Scx=mahj}', "");
    Expect(0, 70006, '\p{^Is_Scx=mahj}', "");
    Expect(0, 70006, '\P{Is_Scx=mahj}', "");
    Expect(1, 70006, '\P{^Is_Scx=mahj}', "");
    Expect(0, 70007, '\p{Is_Scx=mahj}', "");
    Expect(1, 70007, '\p{^Is_Scx=mahj}', "");
    Expect(1, 70007, '\P{Is_Scx=mahj}', "");
    Expect(0, 70007, '\P{^Is_Scx=mahj}', "");
    Expect(1, 70006, '\p{Is_Scx=-Mahj}', "");
    Expect(0, 70006, '\p{^Is_Scx=-Mahj}', "");
    Expect(0, 70006, '\P{Is_Scx=-Mahj}', "");
    Expect(1, 70006, '\P{^Is_Scx=-Mahj}', "");
    Expect(0, 70007, '\p{Is_Scx=-Mahj}', "");
    Expect(1, 70007, '\p{^Is_Scx=-Mahj}', "");
    Expect(1, 70007, '\P{Is_Scx=-Mahj}', "");
    Expect(0, 70007, '\P{^Is_Scx=-Mahj}', "");
    Error('\p{Script_Extensions=/a/	Makasar}');
    Error('\P{Script_Extensions=/a/	Makasar}');
    Expect(1, 73464, '\p{Script_Extensions=:\AMakasar\z:}', "");;
    Expect(0, 73465, '\p{Script_Extensions=:\AMakasar\z:}', "");;
    Expect(1, 73464, '\p{Script_Extensions=makasar}', "");
    Expect(0, 73464, '\p{^Script_Extensions=makasar}', "");
    Expect(0, 73464, '\P{Script_Extensions=makasar}', "");
    Expect(1, 73464, '\P{^Script_Extensions=makasar}', "");
    Expect(0, 73465, '\p{Script_Extensions=makasar}', "");
    Expect(1, 73465, '\p{^Script_Extensions=makasar}', "");
    Expect(1, 73465, '\P{Script_Extensions=makasar}', "");
    Expect(0, 73465, '\P{^Script_Extensions=makasar}', "");
    Expect(1, 73464, '\p{Script_Extensions=:\Amakasar\z:}', "");;
    Expect(0, 73465, '\p{Script_Extensions=:\Amakasar\z:}', "");;
    Expect(1, 73464, '\p{Script_Extensions=_	Makasar}', "");
    Expect(0, 73464, '\p{^Script_Extensions=_	Makasar}', "");
    Expect(0, 73464, '\P{Script_Extensions=_	Makasar}', "");
    Expect(1, 73464, '\P{^Script_Extensions=_	Makasar}', "");
    Expect(0, 73465, '\p{Script_Extensions=_	Makasar}', "");
    Expect(1, 73465, '\p{^Script_Extensions=_	Makasar}', "");
    Expect(1, 73465, '\P{Script_Extensions=_	Makasar}', "");
    Expect(0, 73465, '\P{^Script_Extensions=_	Makasar}', "");
    Error('\p{Scx=		maka:=}');
    Error('\P{Scx=		maka:=}');
    Expect(1, 73464, '\p{Scx=:\AMaka\z:}', "");;
    Expect(0, 73465, '\p{Scx=:\AMaka\z:}', "");;
    Expect(1, 73464, '\p{Scx:   maka}', "");
    Expect(0, 73464, '\p{^Scx:   maka}', "");
    Expect(0, 73464, '\P{Scx:   maka}', "");
    Expect(1, 73464, '\P{^Scx:   maka}', "");
    Expect(0, 73465, '\p{Scx:   maka}', "");
    Expect(1, 73465, '\p{^Scx:   maka}', "");
    Expect(1, 73465, '\P{Scx:   maka}', "");
    Expect(0, 73465, '\P{^Scx:   maka}', "");
    Expect(1, 73464, '\p{Scx=:\Amaka\z:}', "");;
    Expect(0, 73465, '\p{Scx=:\Amaka\z:}', "");;
    Expect(1, 73464, '\p{Scx=		MAKA}', "");
    Expect(0, 73464, '\p{^Scx=		MAKA}', "");
    Expect(0, 73464, '\P{Scx=		MAKA}', "");
    Expect(1, 73464, '\P{^Scx=		MAKA}', "");
    Expect(0, 73465, '\p{Scx=		MAKA}', "");
    Expect(1, 73465, '\p{^Scx=		MAKA}', "");
    Expect(1, 73465, '\P{Scx=		MAKA}', "");
    Expect(0, 73465, '\P{^Scx=		MAKA}', "");
    Error('\p{Is_Script_Extensions=:=-_MAKASAR}');
    Error('\P{Is_Script_Extensions=:=-_MAKASAR}');
    Expect(1, 73464, '\p{Is_Script_Extensions: makasar}', "");
    Expect(0, 73464, '\p{^Is_Script_Extensions: makasar}', "");
    Expect(0, 73464, '\P{Is_Script_Extensions: makasar}', "");
    Expect(1, 73464, '\P{^Is_Script_Extensions: makasar}', "");
    Expect(0, 73465, '\p{Is_Script_Extensions: makasar}', "");
    Expect(1, 73465, '\p{^Is_Script_Extensions: makasar}', "");
    Expect(1, 73465, '\P{Is_Script_Extensions: makasar}', "");
    Expect(0, 73465, '\P{^Is_Script_Extensions: makasar}', "");
    Expect(1, 73464, '\p{Is_Script_Extensions=_-MAKASAR}', "");
    Expect(0, 73464, '\p{^Is_Script_Extensions=_-MAKASAR}', "");
    Expect(0, 73464, '\P{Is_Script_Extensions=_-MAKASAR}', "");
    Expect(1, 73464, '\P{^Is_Script_Extensions=_-MAKASAR}', "");
    Expect(0, 73465, '\p{Is_Script_Extensions=_-MAKASAR}', "");
    Expect(1, 73465, '\p{^Is_Script_Extensions=_-MAKASAR}', "");
    Expect(1, 73465, '\P{Is_Script_Extensions=_-MAKASAR}', "");
    Expect(0, 73465, '\P{^Is_Script_Extensions=_-MAKASAR}', "");
    Error('\p{Is_Scx=/a/_-Maka}');
    Error('\P{Is_Scx=/a/_-Maka}');
    Expect(1, 73464, '\p{Is_Scx=maka}', "");
    Expect(0, 73464, '\p{^Is_Scx=maka}', "");
    Expect(0, 73464, '\P{Is_Scx=maka}', "");
    Expect(1, 73464, '\P{^Is_Scx=maka}', "");
    Expect(0, 73465, '\p{Is_Scx=maka}', "");
    Expect(1, 73465, '\p{^Is_Scx=maka}', "");
    Expect(1, 73465, '\P{Is_Scx=maka}', "");
    Expect(0, 73465, '\P{^Is_Scx=maka}', "");
    Expect(1, 73464, '\p{Is_Scx:		-MAKA}', "");
    Expect(0, 73464, '\p{^Is_Scx:		-MAKA}', "");
    Expect(0, 73464, '\P{Is_Scx:		-MAKA}', "");
    Expect(1, 73464, '\P{^Is_Scx:		-MAKA}', "");
    Expect(0, 73465, '\p{Is_Scx:		-MAKA}', "");
    Expect(1, 73465, '\p{^Is_Scx:		-MAKA}', "");
    Expect(1, 73465, '\P{Is_Scx:		-MAKA}', "");
    Expect(0, 73465, '\P{^Is_Scx:		-MAKA}', "");
    Error('\p{Script_Extensions=:=Mandaic}');
    Error('\P{Script_Extensions=:=Mandaic}');
    Expect(1, 2142, '\p{Script_Extensions=:\AMandaic\z:}', "");;
    Expect(0, 2143, '\p{Script_Extensions=:\AMandaic\z:}', "");;
    Expect(1, 2142, '\p{Script_Extensions=mandaic}', "");
    Expect(0, 2142, '\p{^Script_Extensions=mandaic}', "");
    Expect(0, 2142, '\P{Script_Extensions=mandaic}', "");
    Expect(1, 2142, '\P{^Script_Extensions=mandaic}', "");
    Expect(0, 2143, '\p{Script_Extensions=mandaic}', "");
    Expect(1, 2143, '\p{^Script_Extensions=mandaic}', "");
    Expect(1, 2143, '\P{Script_Extensions=mandaic}', "");
    Expect(0, 2143, '\P{^Script_Extensions=mandaic}', "");
    Expect(1, 2142, '\p{Script_Extensions=:\Amandaic\z:}', "");;
    Expect(0, 2143, '\p{Script_Extensions=:\Amandaic\z:}', "");;
    Expect(1, 2142, '\p{Script_Extensions=_Mandaic}', "");
    Expect(0, 2142, '\p{^Script_Extensions=_Mandaic}', "");
    Expect(0, 2142, '\P{Script_Extensions=_Mandaic}', "");
    Expect(1, 2142, '\P{^Script_Extensions=_Mandaic}', "");
    Expect(0, 2143, '\p{Script_Extensions=_Mandaic}', "");
    Expect(1, 2143, '\p{^Script_Extensions=_Mandaic}', "");
    Expect(1, 2143, '\P{Script_Extensions=_Mandaic}', "");
    Expect(0, 2143, '\P{^Script_Extensions=_Mandaic}', "");
    Error('\p{Scx=:=_Mand}');
    Error('\P{Scx=:=_Mand}');
    Expect(1, 2142, '\p{Scx=:\AMand\z:}', "");;
    Expect(0, 2143, '\p{Scx=:\AMand\z:}', "");;
    Expect(1, 2142, '\p{Scx=mand}', "");
    Expect(0, 2142, '\p{^Scx=mand}', "");
    Expect(0, 2142, '\P{Scx=mand}', "");
    Expect(1, 2142, '\P{^Scx=mand}', "");
    Expect(0, 2143, '\p{Scx=mand}', "");
    Expect(1, 2143, '\p{^Scx=mand}', "");
    Expect(1, 2143, '\P{Scx=mand}', "");
    Expect(0, 2143, '\P{^Scx=mand}', "");
    Expect(1, 2142, '\p{Scx=:\Amand\z:}', "");;
    Expect(0, 2143, '\p{Scx=:\Amand\z:}', "");;
    Expect(1, 2142, '\p{Scx=	MAND}', "");
    Expect(0, 2142, '\p{^Scx=	MAND}', "");
    Expect(0, 2142, '\P{Scx=	MAND}', "");
    Expect(1, 2142, '\P{^Scx=	MAND}', "");
    Expect(0, 2143, '\p{Scx=	MAND}', "");
    Expect(1, 2143, '\p{^Scx=	MAND}', "");
    Expect(1, 2143, '\P{Scx=	MAND}', "");
    Expect(0, 2143, '\P{^Scx=	MAND}', "");
    Error('\p{Is_Script_Extensions=	:=Mandaic}');
    Error('\P{Is_Script_Extensions=	:=Mandaic}');
    Expect(1, 2142, '\p{Is_Script_Extensions=mandaic}', "");
    Expect(0, 2142, '\p{^Is_Script_Extensions=mandaic}', "");
    Expect(0, 2142, '\P{Is_Script_Extensions=mandaic}', "");
    Expect(1, 2142, '\P{^Is_Script_Extensions=mandaic}', "");
    Expect(0, 2143, '\p{Is_Script_Extensions=mandaic}', "");
    Expect(1, 2143, '\p{^Is_Script_Extensions=mandaic}', "");
    Expect(1, 2143, '\P{Is_Script_Extensions=mandaic}', "");
    Expect(0, 2143, '\P{^Is_Script_Extensions=mandaic}', "");
    Expect(1, 2142, '\p{Is_Script_Extensions=--MANDAIC}', "");
    Expect(0, 2142, '\p{^Is_Script_Extensions=--MANDAIC}', "");
    Expect(0, 2142, '\P{Is_Script_Extensions=--MANDAIC}', "");
    Expect(1, 2142, '\P{^Is_Script_Extensions=--MANDAIC}', "");
    Expect(0, 2143, '\p{Is_Script_Extensions=--MANDAIC}', "");
    Expect(1, 2143, '\p{^Is_Script_Extensions=--MANDAIC}', "");
    Expect(1, 2143, '\P{Is_Script_Extensions=--MANDAIC}', "");
    Expect(0, 2143, '\P{^Is_Script_Extensions=--MANDAIC}', "");
    Error('\p{Is_Scx=_/a/Mand}');
    Error('\P{Is_Scx=_/a/Mand}');
    Expect(1, 2142, '\p{Is_Scx=mand}', "");
    Expect(0, 2142, '\p{^Is_Scx=mand}', "");
    Expect(0, 2142, '\P{Is_Scx=mand}', "");
    Expect(1, 2142, '\P{^Is_Scx=mand}', "");
    Expect(0, 2143, '\p{Is_Scx=mand}', "");
    Expect(1, 2143, '\p{^Is_Scx=mand}', "");
    Expect(1, 2143, '\P{Is_Scx=mand}', "");
    Expect(0, 2143, '\P{^Is_Scx=mand}', "");
    Expect(1, 2142, '\p{Is_Scx=  Mand}', "");
    Expect(0, 2142, '\p{^Is_Scx=  Mand}', "");
    Expect(0, 2142, '\P{Is_Scx=  Mand}', "");
    Expect(1, 2142, '\P{^Is_Scx=  Mand}', "");
    Expect(0, 2143, '\p{Is_Scx=  Mand}', "");
    Expect(1, 2143, '\p{^Is_Scx=  Mand}', "");
    Expect(1, 2143, '\P{Is_Scx=  Mand}', "");
    Expect(0, 2143, '\P{^Is_Scx=  Mand}', "");
    Error('\p{Script_Extensions=/a/_-MANICHAEAN}');
    Error('\P{Script_Extensions=/a/_-MANICHAEAN}');
    Expect(1, 68342, '\p{Script_Extensions=:\AManichaean\z:}', "");;
    Expect(0, 68343, '\p{Script_Extensions=:\AManichaean\z:}', "");;
    Expect(1, 68342, '\p{Script_Extensions=manichaean}', "");
    Expect(0, 68342, '\p{^Script_Extensions=manichaean}', "");
    Expect(0, 68342, '\P{Script_Extensions=manichaean}', "");
    Expect(1, 68342, '\P{^Script_Extensions=manichaean}', "");
    Expect(0, 68343, '\p{Script_Extensions=manichaean}', "");
    Expect(1, 68343, '\p{^Script_Extensions=manichaean}', "");
    Expect(1, 68343, '\P{Script_Extensions=manichaean}', "");
    Expect(0, 68343, '\P{^Script_Extensions=manichaean}', "");
    Expect(1, 68342, '\p{Script_Extensions=:\Amanichaean\z:}', "");;
    Expect(0, 68343, '\p{Script_Extensions=:\Amanichaean\z:}', "");;
    Expect(1, 68342, '\p{Script_Extensions=	manichaean}', "");
    Expect(0, 68342, '\p{^Script_Extensions=	manichaean}', "");
    Expect(0, 68342, '\P{Script_Extensions=	manichaean}', "");
    Expect(1, 68342, '\P{^Script_Extensions=	manichaean}', "");
    Expect(0, 68343, '\p{Script_Extensions=	manichaean}', "");
    Expect(1, 68343, '\p{^Script_Extensions=	manichaean}', "");
    Expect(1, 68343, '\P{Script_Extensions=	manichaean}', "");
    Expect(0, 68343, '\P{^Script_Extensions=	manichaean}', "");
    Error('\p{Scx=	-MANI:=}');
    Error('\P{Scx=	-MANI:=}');
    Expect(1, 68342, '\p{Scx=:\AMani\z:}', "");;
    Expect(0, 68343, '\p{Scx=:\AMani\z:}', "");;
    Expect(1, 68342, '\p{Scx=mani}', "");
    Expect(0, 68342, '\p{^Scx=mani}', "");
    Expect(0, 68342, '\P{Scx=mani}', "");
    Expect(1, 68342, '\P{^Scx=mani}', "");
    Expect(0, 68343, '\p{Scx=mani}', "");
    Expect(1, 68343, '\p{^Scx=mani}', "");
    Expect(1, 68343, '\P{Scx=mani}', "");
    Expect(0, 68343, '\P{^Scx=mani}', "");
    Expect(1, 68342, '\p{Scx=:\Amani\z:}', "");;
    Expect(0, 68343, '\p{Scx=:\Amani\z:}', "");;
    Expect(1, 68342, '\p{Scx=-_Mani}', "");
    Expect(0, 68342, '\p{^Scx=-_Mani}', "");
    Expect(0, 68342, '\P{Scx=-_Mani}', "");
    Expect(1, 68342, '\P{^Scx=-_Mani}', "");
    Expect(0, 68343, '\p{Scx=-_Mani}', "");
    Expect(1, 68343, '\p{^Scx=-_Mani}', "");
    Expect(1, 68343, '\P{Scx=-_Mani}', "");
    Expect(0, 68343, '\P{^Scx=-_Mani}', "");
    Error('\p{Is_Script_Extensions=/a/-_manichaean}');
    Error('\P{Is_Script_Extensions=/a/-_manichaean}');
    Expect(1, 68342, '\p{Is_Script_Extensions=manichaean}', "");
    Expect(0, 68342, '\p{^Is_Script_Extensions=manichaean}', "");
    Expect(0, 68342, '\P{Is_Script_Extensions=manichaean}', "");
    Expect(1, 68342, '\P{^Is_Script_Extensions=manichaean}', "");
    Expect(0, 68343, '\p{Is_Script_Extensions=manichaean}', "");
    Expect(1, 68343, '\p{^Is_Script_Extensions=manichaean}', "");
    Expect(1, 68343, '\P{Is_Script_Extensions=manichaean}', "");
    Expect(0, 68343, '\P{^Is_Script_Extensions=manichaean}', "");
    Expect(1, 68342, '\p{Is_Script_Extensions= 	MANICHAEAN}', "");
    Expect(0, 68342, '\p{^Is_Script_Extensions= 	MANICHAEAN}', "");
    Expect(0, 68342, '\P{Is_Script_Extensions= 	MANICHAEAN}', "");
    Expect(1, 68342, '\P{^Is_Script_Extensions= 	MANICHAEAN}', "");
    Expect(0, 68343, '\p{Is_Script_Extensions= 	MANICHAEAN}', "");
    Expect(1, 68343, '\p{^Is_Script_Extensions= 	MANICHAEAN}', "");
    Expect(1, 68343, '\P{Is_Script_Extensions= 	MANICHAEAN}', "");
    Expect(0, 68343, '\P{^Is_Script_Extensions= 	MANICHAEAN}', "");
    Error('\p{Is_Scx=/a/	_Mani}');
    Error('\P{Is_Scx=/a/	_Mani}');
    Expect(1, 68342, '\p{Is_Scx=mani}', "");
    Expect(0, 68342, '\p{^Is_Scx=mani}', "");
    Expect(0, 68342, '\P{Is_Scx=mani}', "");
    Expect(1, 68342, '\P{^Is_Scx=mani}', "");
    Expect(0, 68343, '\p{Is_Scx=mani}', "");
    Expect(1, 68343, '\p{^Is_Scx=mani}', "");
    Expect(1, 68343, '\P{Is_Scx=mani}', "");
    Expect(0, 68343, '\P{^Is_Scx=mani}', "");
    Expect(1, 68342, '\p{Is_Scx=	 mani}', "");
    Expect(0, 68342, '\p{^Is_Scx=	 mani}', "");
    Expect(0, 68342, '\P{Is_Scx=	 mani}', "");
    Expect(1, 68342, '\P{^Is_Scx=	 mani}', "");
    Expect(0, 68343, '\p{Is_Scx=	 mani}', "");
    Expect(1, 68343, '\p{^Is_Scx=	 mani}', "");
    Expect(1, 68343, '\P{Is_Scx=	 mani}', "");
    Expect(0, 68343, '\P{^Is_Scx=	 mani}', "");
    Error('\p{Script_Extensions=-:=Marchen}');
    Error('\P{Script_Extensions=-:=Marchen}');
    Expect(1, 72886, '\p{Script_Extensions=:\AMarchen\z:}', "");;
    Expect(0, 72887, '\p{Script_Extensions=:\AMarchen\z:}', "");;
    Expect(1, 72886, '\p{Script_Extensions:	marchen}', "");
    Expect(0, 72886, '\p{^Script_Extensions:	marchen}', "");
    Expect(0, 72886, '\P{Script_Extensions:	marchen}', "");
    Expect(1, 72886, '\P{^Script_Extensions:	marchen}', "");
    Expect(0, 72887, '\p{Script_Extensions:	marchen}', "");
    Expect(1, 72887, '\p{^Script_Extensions:	marchen}', "");
    Expect(1, 72887, '\P{Script_Extensions:	marchen}', "");
    Expect(0, 72887, '\P{^Script_Extensions:	marchen}', "");
    Expect(1, 72886, '\p{Script_Extensions=:\Amarchen\z:}', "");;
    Expect(0, 72887, '\p{Script_Extensions=:\Amarchen\z:}', "");;
    Expect(1, 72886, '\p{Script_Extensions:	-_marchen}', "");
    Expect(0, 72886, '\p{^Script_Extensions:	-_marchen}', "");
    Expect(0, 72886, '\P{Script_Extensions:	-_marchen}', "");
    Expect(1, 72886, '\P{^Script_Extensions:	-_marchen}', "");
    Expect(0, 72887, '\p{Script_Extensions:	-_marchen}', "");
    Expect(1, 72887, '\p{^Script_Extensions:	-_marchen}', "");
    Expect(1, 72887, '\P{Script_Extensions:	-_marchen}', "");
    Expect(0, 72887, '\P{^Script_Extensions:	-_marchen}', "");
    Error('\p{Scx= /a/Marc}');
    Error('\P{Scx= /a/Marc}');
    Expect(1, 72886, '\p{Scx=:\AMarc\z:}', "");;
    Expect(0, 72887, '\p{Scx=:\AMarc\z:}', "");;
    Expect(1, 72886, '\p{Scx:	marc}', "");
    Expect(0, 72886, '\p{^Scx:	marc}', "");
    Expect(0, 72886, '\P{Scx:	marc}', "");
    Expect(1, 72886, '\P{^Scx:	marc}', "");
    Expect(0, 72887, '\p{Scx:	marc}', "");
    Expect(1, 72887, '\p{^Scx:	marc}', "");
    Expect(1, 72887, '\P{Scx:	marc}', "");
    Expect(0, 72887, '\P{^Scx:	marc}', "");
    Expect(1, 72886, '\p{Scx=:\Amarc\z:}', "");;
    Expect(0, 72887, '\p{Scx=:\Amarc\z:}', "");;
    Expect(1, 72886, '\p{Scx=	marc}', "");
    Expect(0, 72886, '\p{^Scx=	marc}', "");
    Expect(0, 72886, '\P{Scx=	marc}', "");
    Expect(1, 72886, '\P{^Scx=	marc}', "");
    Expect(0, 72887, '\p{Scx=	marc}', "");
    Expect(1, 72887, '\p{^Scx=	marc}', "");
    Expect(1, 72887, '\P{Scx=	marc}', "");
    Expect(0, 72887, '\P{^Scx=	marc}', "");
    Error('\p{Is_Script_Extensions=_ MARCHEN/a/}');
    Error('\P{Is_Script_Extensions=_ MARCHEN/a/}');
    Expect(1, 72886, '\p{Is_Script_Extensions=marchen}', "");
    Expect(0, 72886, '\p{^Is_Script_Extensions=marchen}', "");
    Expect(0, 72886, '\P{Is_Script_Extensions=marchen}', "");
    Expect(1, 72886, '\P{^Is_Script_Extensions=marchen}', "");
    Expect(0, 72887, '\p{Is_Script_Extensions=marchen}', "");
    Expect(1, 72887, '\p{^Is_Script_Extensions=marchen}', "");
    Expect(1, 72887, '\P{Is_Script_Extensions=marchen}', "");
    Expect(0, 72887, '\P{^Is_Script_Extensions=marchen}', "");
    Expect(1, 72886, '\p{Is_Script_Extensions:  marchen}', "");
    Expect(0, 72886, '\p{^Is_Script_Extensions:  marchen}', "");
    Expect(0, 72886, '\P{Is_Script_Extensions:  marchen}', "");
    Expect(1, 72886, '\P{^Is_Script_Extensions:  marchen}', "");
    Expect(0, 72887, '\p{Is_Script_Extensions:  marchen}', "");
    Expect(1, 72887, '\p{^Is_Script_Extensions:  marchen}', "");
    Expect(1, 72887, '\P{Is_Script_Extensions:  marchen}', "");
    Expect(0, 72887, '\P{^Is_Script_Extensions:  marchen}', "");
    Error('\p{Is_Scx=/a/__marc}');
    Error('\P{Is_Scx=/a/__marc}');
    Expect(1, 72886, '\p{Is_Scx=marc}', "");
    Expect(0, 72886, '\p{^Is_Scx=marc}', "");
    Expect(0, 72886, '\P{Is_Scx=marc}', "");
    Expect(1, 72886, '\P{^Is_Scx=marc}', "");
    Expect(0, 72887, '\p{Is_Scx=marc}', "");
    Expect(1, 72887, '\p{^Is_Scx=marc}', "");
    Expect(1, 72887, '\P{Is_Scx=marc}', "");
    Expect(0, 72887, '\P{^Is_Scx=marc}', "");
    Expect(1, 72886, '\p{Is_Scx=  Marc}', "");
    Expect(0, 72886, '\p{^Is_Scx=  Marc}', "");
    Expect(0, 72886, '\P{Is_Scx=  Marc}', "");
    Expect(1, 72886, '\P{^Is_Scx=  Marc}', "");
    Expect(0, 72887, '\p{Is_Scx=  Marc}', "");
    Expect(1, 72887, '\p{^Is_Scx=  Marc}', "");
    Expect(1, 72887, '\P{Is_Scx=  Marc}', "");
    Expect(0, 72887, '\P{^Is_Scx=  Marc}', "");
    Error('\p{Script_Extensions=_:=Medefaidrin}');
    Error('\P{Script_Extensions=_:=Medefaidrin}');
    Expect(1, 93850, '\p{Script_Extensions=:\AMedefaidrin\z:}', "");;
    Expect(0, 93851, '\p{Script_Extensions=:\AMedefaidrin\z:}', "");;
    Expect(1, 93850, '\p{Script_Extensions=medefaidrin}', "");
    Expect(0, 93850, '\p{^Script_Extensions=medefaidrin}', "");
    Expect(0, 93850, '\P{Script_Extensions=medefaidrin}', "");
    Expect(1, 93850, '\P{^Script_Extensions=medefaidrin}', "");
    Expect(0, 93851, '\p{Script_Extensions=medefaidrin}', "");
    Expect(1, 93851, '\p{^Script_Extensions=medefaidrin}', "");
    Expect(1, 93851, '\P{Script_Extensions=medefaidrin}', "");
    Expect(0, 93851, '\P{^Script_Extensions=medefaidrin}', "");
    Expect(1, 93850, '\p{Script_Extensions=:\Amedefaidrin\z:}', "");;
    Expect(0, 93851, '\p{Script_Extensions=:\Amedefaidrin\z:}', "");;
    Expect(1, 93850, '\p{Script_Extensions=		medefaidrin}', "");
    Expect(0, 93850, '\p{^Script_Extensions=		medefaidrin}', "");
    Expect(0, 93850, '\P{Script_Extensions=		medefaidrin}', "");
    Expect(1, 93850, '\P{^Script_Extensions=		medefaidrin}', "");
    Expect(0, 93851, '\p{Script_Extensions=		medefaidrin}', "");
    Expect(1, 93851, '\p{^Script_Extensions=		medefaidrin}', "");
    Expect(1, 93851, '\P{Script_Extensions=		medefaidrin}', "");
    Expect(0, 93851, '\P{^Script_Extensions=		medefaidrin}', "");
    Error('\p{Scx:   /a/-_Medf}');
    Error('\P{Scx:   /a/-_Medf}');
    Expect(1, 93850, '\p{Scx=:\AMedf\z:}', "");;
    Expect(0, 93851, '\p{Scx=:\AMedf\z:}', "");;
    Expect(1, 93850, '\p{Scx=medf}', "");
    Expect(0, 93850, '\p{^Scx=medf}', "");
    Expect(0, 93850, '\P{Scx=medf}', "");
    Expect(1, 93850, '\P{^Scx=medf}', "");
    Expect(0, 93851, '\p{Scx=medf}', "");
    Expect(1, 93851, '\p{^Scx=medf}', "");
    Expect(1, 93851, '\P{Scx=medf}', "");
    Expect(0, 93851, '\P{^Scx=medf}', "");
    Expect(1, 93850, '\p{Scx=:\Amedf\z:}', "");;
    Expect(0, 93851, '\p{Scx=:\Amedf\z:}', "");;
    Expect(1, 93850, '\p{Scx=- Medf}', "");
    Expect(0, 93850, '\p{^Scx=- Medf}', "");
    Expect(0, 93850, '\P{Scx=- Medf}', "");
    Expect(1, 93850, '\P{^Scx=- Medf}', "");
    Expect(0, 93851, '\p{Scx=- Medf}', "");
    Expect(1, 93851, '\p{^Scx=- Medf}', "");
    Expect(1, 93851, '\P{Scx=- Medf}', "");
    Expect(0, 93851, '\P{^Scx=- Medf}', "");
    Error('\p{Is_Script_Extensions=/a/_	MEDEFAIDRIN}');
    Error('\P{Is_Script_Extensions=/a/_	MEDEFAIDRIN}');
    Expect(1, 93850, '\p{Is_Script_Extensions=medefaidrin}', "");
    Expect(0, 93850, '\p{^Is_Script_Extensions=medefaidrin}', "");
    Expect(0, 93850, '\P{Is_Script_Extensions=medefaidrin}', "");
    Expect(1, 93850, '\P{^Is_Script_Extensions=medefaidrin}', "");
    Expect(0, 93851, '\p{Is_Script_Extensions=medefaidrin}', "");
    Expect(1, 93851, '\p{^Is_Script_Extensions=medefaidrin}', "");
    Expect(1, 93851, '\P{Is_Script_Extensions=medefaidrin}', "");
    Expect(0, 93851, '\P{^Is_Script_Extensions=medefaidrin}', "");
    Expect(1, 93850, '\p{Is_Script_Extensions=-	Medefaidrin}', "");
    Expect(0, 93850, '\p{^Is_Script_Extensions=-	Medefaidrin}', "");
    Expect(0, 93850, '\P{Is_Script_Extensions=-	Medefaidrin}', "");
    Expect(1, 93850, '\P{^Is_Script_Extensions=-	Medefaidrin}', "");
    Expect(0, 93851, '\p{Is_Script_Extensions=-	Medefaidrin}', "");
    Expect(1, 93851, '\p{^Is_Script_Extensions=-	Medefaidrin}', "");
    Expect(1, 93851, '\P{Is_Script_Extensions=-	Medefaidrin}', "");
    Expect(0, 93851, '\P{^Is_Script_Extensions=-	Medefaidrin}', "");
    Error('\p{Is_Scx=	-MEDF:=}');
    Error('\P{Is_Scx=	-MEDF:=}');
    Expect(1, 93850, '\p{Is_Scx=medf}', "");
    Expect(0, 93850, '\p{^Is_Scx=medf}', "");
    Expect(0, 93850, '\P{Is_Scx=medf}', "");
    Expect(1, 93850, '\P{^Is_Scx=medf}', "");
    Expect(0, 93851, '\p{Is_Scx=medf}', "");
    Expect(1, 93851, '\p{^Is_Scx=medf}', "");
    Expect(1, 93851, '\P{Is_Scx=medf}', "");
    Expect(0, 93851, '\P{^Is_Scx=medf}', "");
    Expect(1, 93850, '\p{Is_Scx=	 MEDF}', "");
    Expect(0, 93850, '\p{^Is_Scx=	 MEDF}', "");
    Expect(0, 93850, '\P{Is_Scx=	 MEDF}', "");
    Expect(1, 93850, '\P{^Is_Scx=	 MEDF}', "");
    Expect(0, 93851, '\p{Is_Scx=	 MEDF}', "");
    Expect(1, 93851, '\p{^Is_Scx=	 MEDF}', "");
    Expect(1, 93851, '\P{Is_Scx=	 MEDF}', "");
    Expect(0, 93851, '\P{^Is_Scx=	 MEDF}', "");
    Error('\p{Script_Extensions=:=MENDE_Kikakui}');
    Error('\P{Script_Extensions=:=MENDE_Kikakui}');
    Expect(1, 125142, '\p{Script_Extensions=:\AMende_Kikakui\z:}', "");;
    Expect(0, 125143, '\p{Script_Extensions=:\AMende_Kikakui\z:}', "");;
    Expect(1, 125142, '\p{Script_Extensions=mendekikakui}', "");
    Expect(0, 125142, '\p{^Script_Extensions=mendekikakui}', "");
    Expect(0, 125142, '\P{Script_Extensions=mendekikakui}', "");
    Expect(1, 125142, '\P{^Script_Extensions=mendekikakui}', "");
    Expect(0, 125143, '\p{Script_Extensions=mendekikakui}', "");
    Expect(1, 125143, '\p{^Script_Extensions=mendekikakui}', "");
    Expect(1, 125143, '\P{Script_Extensions=mendekikakui}', "");
    Expect(0, 125143, '\P{^Script_Extensions=mendekikakui}', "");
    Expect(1, 125142, '\p{Script_Extensions=:\Amendekikakui\z:}', "");;
    Expect(0, 125143, '\p{Script_Extensions=:\Amendekikakui\z:}', "");;
    Expect(1, 125142, '\p{Script_Extensions=	_Mende_kikakui}', "");
    Expect(0, 125142, '\p{^Script_Extensions=	_Mende_kikakui}', "");
    Expect(0, 125142, '\P{Script_Extensions=	_Mende_kikakui}', "");
    Expect(1, 125142, '\P{^Script_Extensions=	_Mende_kikakui}', "");
    Expect(0, 125143, '\p{Script_Extensions=	_Mende_kikakui}', "");
    Expect(1, 125143, '\p{^Script_Extensions=	_Mende_kikakui}', "");
    Expect(1, 125143, '\P{Script_Extensions=	_Mende_kikakui}', "");
    Expect(0, 125143, '\P{^Script_Extensions=	_Mende_kikakui}', "");
    Error('\p{Scx=/a/-MEND}');
    Error('\P{Scx=/a/-MEND}');
    Expect(1, 125142, '\p{Scx=:\AMend\z:}', "");;
    Expect(0, 125143, '\p{Scx=:\AMend\z:}', "");;
    Expect(1, 125142, '\p{Scx=mend}', "");
    Expect(0, 125142, '\p{^Scx=mend}', "");
    Expect(0, 125142, '\P{Scx=mend}', "");
    Expect(1, 125142, '\P{^Scx=mend}', "");
    Expect(0, 125143, '\p{Scx=mend}', "");
    Expect(1, 125143, '\p{^Scx=mend}', "");
    Expect(1, 125143, '\P{Scx=mend}', "");
    Expect(0, 125143, '\P{^Scx=mend}', "");
    Expect(1, 125142, '\p{Scx=:\Amend\z:}', "");;
    Expect(0, 125143, '\p{Scx=:\Amend\z:}', "");;
    Expect(1, 125142, '\p{Scx=_ mend}', "");
    Expect(0, 125142, '\p{^Scx=_ mend}', "");
    Expect(0, 125142, '\P{Scx=_ mend}', "");
    Expect(1, 125142, '\P{^Scx=_ mend}', "");
    Expect(0, 125143, '\p{Scx=_ mend}', "");
    Expect(1, 125143, '\p{^Scx=_ mend}', "");
    Expect(1, 125143, '\P{Scx=_ mend}', "");
    Expect(0, 125143, '\P{^Scx=_ mend}', "");
    Error('\p{Is_Script_Extensions=	:=mende_Kikakui}');
    Error('\P{Is_Script_Extensions=	:=mende_Kikakui}');
    Expect(1, 125142, '\p{Is_Script_Extensions=mendekikakui}', "");
    Expect(0, 125142, '\p{^Is_Script_Extensions=mendekikakui}', "");
    Expect(0, 125142, '\P{Is_Script_Extensions=mendekikakui}', "");
    Expect(1, 125142, '\P{^Is_Script_Extensions=mendekikakui}', "");
    Expect(0, 125143, '\p{Is_Script_Extensions=mendekikakui}', "");
    Expect(1, 125143, '\p{^Is_Script_Extensions=mendekikakui}', "");
    Expect(1, 125143, '\P{Is_Script_Extensions=mendekikakui}', "");
    Expect(0, 125143, '\P{^Is_Script_Extensions=mendekikakui}', "");
    Expect(1, 125142, '\p{Is_Script_Extensions=	Mende_KIKAKUI}', "");
    Expect(0, 125142, '\p{^Is_Script_Extensions=	Mende_KIKAKUI}', "");
    Expect(0, 125142, '\P{Is_Script_Extensions=	Mende_KIKAKUI}', "");
    Expect(1, 125142, '\P{^Is_Script_Extensions=	Mende_KIKAKUI}', "");
    Expect(0, 125143, '\p{Is_Script_Extensions=	Mende_KIKAKUI}', "");
    Expect(1, 125143, '\p{^Is_Script_Extensions=	Mende_KIKAKUI}', "");
    Expect(1, 125143, '\P{Is_Script_Extensions=	Mende_KIKAKUI}', "");
    Expect(0, 125143, '\P{^Is_Script_Extensions=	Mende_KIKAKUI}', "");
    Error('\p{Is_Scx=:= -mend}');
    Error('\P{Is_Scx=:= -mend}');
    Expect(1, 125142, '\p{Is_Scx=mend}', "");
    Expect(0, 125142, '\p{^Is_Scx=mend}', "");
    Expect(0, 125142, '\P{Is_Scx=mend}', "");
    Expect(1, 125142, '\P{^Is_Scx=mend}', "");
    Expect(0, 125143, '\p{Is_Scx=mend}', "");
    Expect(1, 125143, '\p{^Is_Scx=mend}', "");
    Expect(1, 125143, '\P{Is_Scx=mend}', "");
    Expect(0, 125143, '\P{^Is_Scx=mend}', "");
    Expect(1, 125142, '\p{Is_Scx=_ Mend}', "");
    Expect(0, 125142, '\p{^Is_Scx=_ Mend}', "");
    Expect(0, 125142, '\P{Is_Scx=_ Mend}', "");
    Expect(1, 125142, '\P{^Is_Scx=_ Mend}', "");
    Expect(0, 125143, '\p{Is_Scx=_ Mend}', "");
    Expect(1, 125143, '\p{^Is_Scx=_ Mend}', "");
    Expect(1, 125143, '\P{Is_Scx=_ Mend}', "");
    Expect(0, 125143, '\P{^Is_Scx=_ Mend}', "");
    Error('\p{Script_Extensions:  :=Meroitic_Cursive}');
    Error('\P{Script_Extensions:  :=Meroitic_Cursive}');
    Expect(1, 68095, '\p{Script_Extensions=:\AMeroitic_Cursive\z:}', "");;
    Expect(0, 68096, '\p{Script_Extensions=:\AMeroitic_Cursive\z:}', "");;
    Expect(1, 68095, '\p{Script_Extensions=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Script_Extensions=meroiticcursive}', "");
    Expect(0, 68095, '\P{Script_Extensions=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Script_Extensions=meroiticcursive}', "");
    Expect(0, 68096, '\p{Script_Extensions=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Script_Extensions=meroiticcursive}', "");
    Expect(1, 68096, '\P{Script_Extensions=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Script_Extensions=meroiticcursive}', "");
    Expect(1, 68095, '\p{Script_Extensions=:\Ameroiticcursive\z:}', "");;
    Expect(0, 68096, '\p{Script_Extensions=:\Ameroiticcursive\z:}', "");;
    Expect(1, 68095, '\p{Script_Extensions=	-Meroitic_cursive}', "");
    Expect(0, 68095, '\p{^Script_Extensions=	-Meroitic_cursive}', "");
    Expect(0, 68095, '\P{Script_Extensions=	-Meroitic_cursive}', "");
    Expect(1, 68095, '\P{^Script_Extensions=	-Meroitic_cursive}', "");
    Expect(0, 68096, '\p{Script_Extensions=	-Meroitic_cursive}', "");
    Expect(1, 68096, '\p{^Script_Extensions=	-Meroitic_cursive}', "");
    Expect(1, 68096, '\P{Script_Extensions=	-Meroitic_cursive}', "");
    Expect(0, 68096, '\P{^Script_Extensions=	-Meroitic_cursive}', "");
    Error('\p{Scx= _MERC:=}');
    Error('\P{Scx= _MERC:=}');
    Expect(1, 68095, '\p{Scx=:\AMerc\z:}', "");;
    Expect(0, 68096, '\p{Scx=:\AMerc\z:}', "");;
    Expect(1, 68095, '\p{Scx=merc}', "");
    Expect(0, 68095, '\p{^Scx=merc}', "");
    Expect(0, 68095, '\P{Scx=merc}', "");
    Expect(1, 68095, '\P{^Scx=merc}', "");
    Expect(0, 68096, '\p{Scx=merc}', "");
    Expect(1, 68096, '\p{^Scx=merc}', "");
    Expect(1, 68096, '\P{Scx=merc}', "");
    Expect(0, 68096, '\P{^Scx=merc}', "");
    Expect(1, 68095, '\p{Scx=:\Amerc\z:}', "");;
    Expect(0, 68096, '\p{Scx=:\Amerc\z:}', "");;
    Expect(1, 68095, '\p{Scx=_Merc}', "");
    Expect(0, 68095, '\p{^Scx=_Merc}', "");
    Expect(0, 68095, '\P{Scx=_Merc}', "");
    Expect(1, 68095, '\P{^Scx=_Merc}', "");
    Expect(0, 68096, '\p{Scx=_Merc}', "");
    Expect(1, 68096, '\p{^Scx=_Merc}', "");
    Expect(1, 68096, '\P{Scx=_Merc}', "");
    Expect(0, 68096, '\P{^Scx=_Merc}', "");
    Error('\p{Is_Script_Extensions:	:=Meroitic_cursive}');
    Error('\P{Is_Script_Extensions:	:=Meroitic_cursive}');
    Expect(1, 68095, '\p{Is_Script_Extensions=meroiticcursive}', "");
    Expect(0, 68095, '\p{^Is_Script_Extensions=meroiticcursive}', "");
    Expect(0, 68095, '\P{Is_Script_Extensions=meroiticcursive}', "");
    Expect(1, 68095, '\P{^Is_Script_Extensions=meroiticcursive}', "");
    Expect(0, 68096, '\p{Is_Script_Extensions=meroiticcursive}', "");
    Expect(1, 68096, '\p{^Is_Script_Extensions=meroiticcursive}', "");
    Expect(1, 68096, '\P{Is_Script_Extensions=meroiticcursive}', "");
    Expect(0, 68096, '\P{^Is_Script_Extensions=meroiticcursive}', "");
    Expect(1, 68095, '\p{Is_Script_Extensions=__MEROITIC_cursive}', "");
    Expect(0, 68095, '\p{^Is_Script_Extensions=__MEROITIC_cursive}', "");
    Expect(0, 68095, '\P{Is_Script_Extensions=__MEROITIC_cursive}', "");
    Expect(1, 68095, '\P{^Is_Script_Extensions=__MEROITIC_cursive}', "");
    Expect(0, 68096, '\p{Is_Script_Extensions=__MEROITIC_cursive}', "");
    Expect(1, 68096, '\p{^Is_Script_Extensions=__MEROITIC_cursive}', "");
    Expect(1, 68096, '\P{Is_Script_Extensions=__MEROITIC_cursive}', "");
    Expect(0, 68096, '\P{^Is_Script_Extensions=__MEROITIC_cursive}', "");
    Error('\p{Is_Scx=:=merc}');
    Error('\P{Is_Scx=:=merc}');
    Expect(1, 68095, '\p{Is_Scx=merc}', "");
    Expect(0, 68095, '\p{^Is_Scx=merc}', "");
    Expect(0, 68095, '\P{Is_Scx=merc}', "");
    Expect(1, 68095, '\P{^Is_Scx=merc}', "");
    Expect(0, 68096, '\p{Is_Scx=merc}', "");
    Expect(1, 68096, '\p{^Is_Scx=merc}', "");
    Expect(1, 68096, '\P{Is_Scx=merc}', "");
    Expect(0, 68096, '\P{^Is_Scx=merc}', "");
    Expect(1, 68095, '\p{Is_Scx= 	MERC}', "");
    Expect(0, 68095, '\p{^Is_Scx= 	MERC}', "");
    Expect(0, 68095, '\P{Is_Scx= 	MERC}', "");
    Expect(1, 68095, '\P{^Is_Scx= 	MERC}', "");
    Expect(0, 68096, '\p{Is_Scx= 	MERC}', "");
    Expect(1, 68096, '\p{^Is_Scx= 	MERC}', "");
    Expect(1, 68096, '\P{Is_Scx= 	MERC}', "");
    Expect(0, 68096, '\P{^Is_Scx= 	MERC}', "");
    Error('\p{Script_Extensions=  Meroitic_Hieroglyphs/a/}');
    Error('\P{Script_Extensions=  Meroitic_Hieroglyphs/a/}');
    Expect(1, 67999, '\p{Script_Extensions=:\AMeroitic_Hieroglyphs\z:}', "");;
    Expect(0, 68000, '\p{Script_Extensions=:\AMeroitic_Hieroglyphs\z:}', "");;
    Expect(1, 67999, '\p{Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Script_Extensions=:\Ameroitichieroglyphs\z:}', "");;
    Expect(0, 68000, '\p{Script_Extensions=:\Ameroitichieroglyphs\z:}', "");;
    Expect(1, 67999, '\p{Script_Extensions=_ meroitic_hieroglyphs}', "");
    Expect(0, 67999, '\p{^Script_Extensions=_ meroitic_hieroglyphs}', "");
    Expect(0, 67999, '\P{Script_Extensions=_ meroitic_hieroglyphs}', "");
    Expect(1, 67999, '\P{^Script_Extensions=_ meroitic_hieroglyphs}', "");
    Expect(0, 68000, '\p{Script_Extensions=_ meroitic_hieroglyphs}', "");
    Expect(1, 68000, '\p{^Script_Extensions=_ meroitic_hieroglyphs}', "");
    Expect(1, 68000, '\P{Script_Extensions=_ meroitic_hieroglyphs}', "");
    Expect(0, 68000, '\P{^Script_Extensions=_ meroitic_hieroglyphs}', "");
    Error('\p{Scx=/a/-	mero}');
    Error('\P{Scx=/a/-	mero}');
    Expect(1, 67999, '\p{Scx=:\AMero\z:}', "");;
    Expect(0, 68000, '\p{Scx=:\AMero\z:}', "");;
    Expect(1, 67999, '\p{Scx=mero}', "");
    Expect(0, 67999, '\p{^Scx=mero}', "");
    Expect(0, 67999, '\P{Scx=mero}', "");
    Expect(1, 67999, '\P{^Scx=mero}', "");
    Expect(0, 68000, '\p{Scx=mero}', "");
    Expect(1, 68000, '\p{^Scx=mero}', "");
    Expect(1, 68000, '\P{Scx=mero}', "");
    Expect(0, 68000, '\P{^Scx=mero}', "");
    Expect(1, 67999, '\p{Scx=:\Amero\z:}', "");;
    Expect(0, 68000, '\p{Scx=:\Amero\z:}', "");;
    Expect(1, 67999, '\p{Scx=-	mero}', "");
    Expect(0, 67999, '\p{^Scx=-	mero}', "");
    Expect(0, 67999, '\P{Scx=-	mero}', "");
    Expect(1, 67999, '\P{^Scx=-	mero}', "");
    Expect(0, 68000, '\p{Scx=-	mero}', "");
    Expect(1, 68000, '\p{^Scx=-	mero}', "");
    Expect(1, 68000, '\P{Scx=-	mero}', "");
    Expect(0, 68000, '\P{^Scx=-	mero}', "");
    Error('\p{Is_Script_Extensions:   -/a/Meroitic_Hieroglyphs}');
    Error('\P{Is_Script_Extensions:   -/a/Meroitic_Hieroglyphs}');
    Expect(1, 67999, '\p{Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Script_Extensions=meroitichieroglyphs}', "");
    Expect(1, 67999, '\p{Is_Script_Extensions:_-Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\p{^Is_Script_Extensions:_-Meroitic_Hieroglyphs}', "");
    Expect(0, 67999, '\P{Is_Script_Extensions:_-Meroitic_Hieroglyphs}', "");
    Expect(1, 67999, '\P{^Is_Script_Extensions:_-Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\p{Is_Script_Extensions:_-Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\p{^Is_Script_Extensions:_-Meroitic_Hieroglyphs}', "");
    Expect(1, 68000, '\P{Is_Script_Extensions:_-Meroitic_Hieroglyphs}', "");
    Expect(0, 68000, '\P{^Is_Script_Extensions:_-Meroitic_Hieroglyphs}', "");
    Error('\p{Is_Scx=	:=mero}');
    Error('\P{Is_Scx=	:=mero}');
    Expect(1, 67999, '\p{Is_Scx:mero}', "");
    Expect(0, 67999, '\p{^Is_Scx:mero}', "");
    Expect(0, 67999, '\P{Is_Scx:mero}', "");
    Expect(1, 67999, '\P{^Is_Scx:mero}', "");
    Expect(0, 68000, '\p{Is_Scx:mero}', "");
    Expect(1, 68000, '\p{^Is_Scx:mero}', "");
    Expect(1, 68000, '\P{Is_Scx:mero}', "");
    Expect(0, 68000, '\P{^Is_Scx:mero}', "");
    Expect(1, 67999, '\p{Is_Scx=__Mero}', "");
    Expect(0, 67999, '\p{^Is_Scx=__Mero}', "");
    Expect(0, 67999, '\P{Is_Scx=__Mero}', "");
    Expect(1, 67999, '\P{^Is_Scx=__Mero}', "");
    Expect(0, 68000, '\p{Is_Scx=__Mero}', "");
    Expect(1, 68000, '\p{^Is_Scx=__Mero}', "");
    Expect(1, 68000, '\P{Is_Scx=__Mero}', "");
    Expect(0, 68000, '\P{^Is_Scx=__Mero}', "");
    Error('\p{Script_Extensions=_:=Malayalam}');
    Error('\P{Script_Extensions=_:=Malayalam}');
    Expect(1, 43058, '\p{Script_Extensions=:\AMalayalam\z:}', "");;
    Expect(0, 43059, '\p{Script_Extensions=:\AMalayalam\z:}', "");;
    Expect(1, 43058, '\p{Script_Extensions=malayalam}', "");
    Expect(0, 43058, '\p{^Script_Extensions=malayalam}', "");
    Expect(0, 43058, '\P{Script_Extensions=malayalam}', "");
    Expect(1, 43058, '\P{^Script_Extensions=malayalam}', "");
    Expect(0, 43059, '\p{Script_Extensions=malayalam}', "");
    Expect(1, 43059, '\p{^Script_Extensions=malayalam}', "");
    Expect(1, 43059, '\P{Script_Extensions=malayalam}', "");
    Expect(0, 43059, '\P{^Script_Extensions=malayalam}', "");
    Expect(1, 43058, '\p{Script_Extensions=:\Amalayalam\z:}', "");;
    Expect(0, 43059, '\p{Script_Extensions=:\Amalayalam\z:}', "");;
    Expect(1, 43058, '\p{Script_Extensions:	  Malayalam}', "");
    Expect(0, 43058, '\p{^Script_Extensions:	  Malayalam}', "");
    Expect(0, 43058, '\P{Script_Extensions:	  Malayalam}', "");
    Expect(1, 43058, '\P{^Script_Extensions:	  Malayalam}', "");
    Expect(0, 43059, '\p{Script_Extensions:	  Malayalam}', "");
    Expect(1, 43059, '\p{^Script_Extensions:	  Malayalam}', "");
    Expect(1, 43059, '\P{Script_Extensions:	  Malayalam}', "");
    Expect(0, 43059, '\P{^Script_Extensions:	  Malayalam}', "");
    Error('\p{Scx=-:=Mlym}');
    Error('\P{Scx=-:=Mlym}');
    Expect(1, 43058, '\p{Scx=:\AMlym\z:}', "");;
    Expect(0, 43059, '\p{Scx=:\AMlym\z:}', "");;
    Expect(1, 43058, '\p{Scx=mlym}', "");
    Expect(0, 43058, '\p{^Scx=mlym}', "");
    Expect(0, 43058, '\P{Scx=mlym}', "");
    Expect(1, 43058, '\P{^Scx=mlym}', "");
    Expect(0, 43059, '\p{Scx=mlym}', "");
    Expect(1, 43059, '\p{^Scx=mlym}', "");
    Expect(1, 43059, '\P{Scx=mlym}', "");
    Expect(0, 43059, '\P{^Scx=mlym}', "");
    Expect(1, 43058, '\p{Scx=:\Amlym\z:}', "");;
    Expect(0, 43059, '\p{Scx=:\Amlym\z:}', "");;
    Expect(1, 43058, '\p{Scx= mlym}', "");
    Expect(0, 43058, '\p{^Scx= mlym}', "");
    Expect(0, 43058, '\P{Scx= mlym}', "");
    Expect(1, 43058, '\P{^Scx= mlym}', "");
    Expect(0, 43059, '\p{Scx= mlym}', "");
    Expect(1, 43059, '\p{^Scx= mlym}', "");
    Expect(1, 43059, '\P{Scx= mlym}', "");
    Expect(0, 43059, '\P{^Scx= mlym}', "");
    Error('\p{Is_Script_Extensions: :=_malayalam}');
    Error('\P{Is_Script_Extensions: :=_malayalam}');
    Expect(1, 43058, '\p{Is_Script_Extensions=malayalam}', "");
    Expect(0, 43058, '\p{^Is_Script_Extensions=malayalam}', "");
    Expect(0, 43058, '\P{Is_Script_Extensions=malayalam}', "");
    Expect(1, 43058, '\P{^Is_Script_Extensions=malayalam}', "");
    Expect(0, 43059, '\p{Is_Script_Extensions=malayalam}', "");
    Expect(1, 43059, '\p{^Is_Script_Extensions=malayalam}', "");
    Expect(1, 43059, '\P{Is_Script_Extensions=malayalam}', "");
    Expect(0, 43059, '\P{^Is_Script_Extensions=malayalam}', "");
    Expect(1, 43058, '\p{Is_Script_Extensions=_	Malayalam}', "");
    Expect(0, 43058, '\p{^Is_Script_Extensions=_	Malayalam}', "");
    Expect(0, 43058, '\P{Is_Script_Extensions=_	Malayalam}', "");
    Expect(1, 43058, '\P{^Is_Script_Extensions=_	Malayalam}', "");
    Expect(0, 43059, '\p{Is_Script_Extensions=_	Malayalam}', "");
    Expect(1, 43059, '\p{^Is_Script_Extensions=_	Malayalam}', "");
    Expect(1, 43059, '\P{Is_Script_Extensions=_	Malayalam}', "");
    Expect(0, 43059, '\P{^Is_Script_Extensions=_	Malayalam}', "");
    Error('\p{Is_Scx=:= 	mlym}');
    Error('\P{Is_Scx=:= 	mlym}');
    Expect(1, 43058, '\p{Is_Scx=mlym}', "");
    Expect(0, 43058, '\p{^Is_Scx=mlym}', "");
    Expect(0, 43058, '\P{Is_Scx=mlym}', "");
    Expect(1, 43058, '\P{^Is_Scx=mlym}', "");
    Expect(0, 43059, '\p{Is_Scx=mlym}', "");
    Expect(1, 43059, '\p{^Is_Scx=mlym}', "");
    Expect(1, 43059, '\P{Is_Scx=mlym}', "");
    Expect(0, 43059, '\P{^Is_Scx=mlym}', "");
    Expect(1, 43058, '\p{Is_Scx=-_Mlym}', "");
    Expect(0, 43058, '\p{^Is_Scx=-_Mlym}', "");
    Expect(0, 43058, '\P{Is_Scx=-_Mlym}', "");
    Expect(1, 43058, '\P{^Is_Scx=-_Mlym}', "");
    Expect(0, 43059, '\p{Is_Scx=-_Mlym}', "");
    Expect(1, 43059, '\p{^Is_Scx=-_Mlym}', "");
    Expect(1, 43059, '\P{Is_Scx=-_Mlym}', "");
    Expect(0, 43059, '\P{^Is_Scx=-_Mlym}', "");
    Error('\p{Script_Extensions:	/a/MODI}');
    Error('\P{Script_Extensions:	/a/MODI}');
    Expect(1, 71257, '\p{Script_Extensions=:\AModi\z:}', "");;
    Expect(0, 71258, '\p{Script_Extensions=:\AModi\z:}', "");;
    Expect(1, 71257, '\p{Script_Extensions=modi}', "");
    Expect(0, 71257, '\p{^Script_Extensions=modi}', "");
    Expect(0, 71257, '\P{Script_Extensions=modi}', "");
    Expect(1, 71257, '\P{^Script_Extensions=modi}', "");
    Expect(0, 71258, '\p{Script_Extensions=modi}', "");
    Expect(1, 71258, '\p{^Script_Extensions=modi}', "");
    Expect(1, 71258, '\P{Script_Extensions=modi}', "");
    Expect(0, 71258, '\P{^Script_Extensions=modi}', "");
    Expect(1, 71257, '\p{Script_Extensions=:\Amodi\z:}', "");;
    Expect(0, 71258, '\p{Script_Extensions=:\Amodi\z:}', "");;
    Expect(1, 71257, '\p{Script_Extensions= MODI}', "");
    Expect(0, 71257, '\p{^Script_Extensions= MODI}', "");
    Expect(0, 71257, '\P{Script_Extensions= MODI}', "");
    Expect(1, 71257, '\P{^Script_Extensions= MODI}', "");
    Expect(0, 71258, '\p{Script_Extensions= MODI}', "");
    Expect(1, 71258, '\p{^Script_Extensions= MODI}', "");
    Expect(1, 71258, '\P{Script_Extensions= MODI}', "");
    Expect(0, 71258, '\P{^Script_Extensions= MODI}', "");
    Error('\p{Scx=/a/-_Modi}');
    Error('\P{Scx=/a/-_Modi}');
    Expect(1, 71257, '\p{Scx=:\AModi\z:}', "");;
    Expect(0, 71258, '\p{Scx=:\AModi\z:}', "");;
    Expect(1, 71257, '\p{Scx=modi}', "");
    Expect(0, 71257, '\p{^Scx=modi}', "");
    Expect(0, 71257, '\P{Scx=modi}', "");
    Expect(1, 71257, '\P{^Scx=modi}', "");
    Expect(0, 71258, '\p{Scx=modi}', "");
    Expect(1, 71258, '\p{^Scx=modi}', "");
    Expect(1, 71258, '\P{Scx=modi}', "");
    Expect(0, 71258, '\P{^Scx=modi}', "");
    Expect(1, 71257, '\p{Scx=:\Amodi\z:}', "");;
    Expect(0, 71258, '\p{Scx=:\Amodi\z:}', "");;
    Expect(1, 71257, '\p{Scx:		Modi}', "");
    Expect(0, 71257, '\p{^Scx:		Modi}', "");
    Expect(0, 71257, '\P{Scx:		Modi}', "");
    Expect(1, 71257, '\P{^Scx:		Modi}', "");
    Expect(0, 71258, '\p{Scx:		Modi}', "");
    Expect(1, 71258, '\p{^Scx:		Modi}', "");
    Expect(1, 71258, '\P{Scx:		Modi}', "");
    Expect(0, 71258, '\P{^Scx:		Modi}', "");
    Error('\p{Is_Script_Extensions=:=		Modi}');
    Error('\P{Is_Script_Extensions=:=		Modi}');
    Expect(1, 71257, '\p{Is_Script_Extensions=modi}', "");
    Expect(0, 71257, '\p{^Is_Script_Extensions=modi}', "");
    Expect(0, 71257, '\P{Is_Script_Extensions=modi}', "");
    Expect(1, 71257, '\P{^Is_Script_Extensions=modi}', "");
    Expect(0, 71258, '\p{Is_Script_Extensions=modi}', "");
    Expect(1, 71258, '\p{^Is_Script_Extensions=modi}', "");
    Expect(1, 71258, '\P{Is_Script_Extensions=modi}', "");
    Expect(0, 71258, '\P{^Is_Script_Extensions=modi}', "");
    Expect(1, 71257, '\p{Is_Script_Extensions= _MODI}', "");
    Expect(0, 71257, '\p{^Is_Script_Extensions= _MODI}', "");
    Expect(0, 71257, '\P{Is_Script_Extensions= _MODI}', "");
    Expect(1, 71257, '\P{^Is_Script_Extensions= _MODI}', "");
    Expect(0, 71258, '\p{Is_Script_Extensions= _MODI}', "");
    Expect(1, 71258, '\p{^Is_Script_Extensions= _MODI}', "");
    Expect(1, 71258, '\P{Is_Script_Extensions= _MODI}', "");
    Expect(0, 71258, '\P{^Is_Script_Extensions= _MODI}', "");
    Error('\p{Is_Scx=_/a/modi}');
    Error('\P{Is_Scx=_/a/modi}');
    Expect(1, 71257, '\p{Is_Scx=modi}', "");
    Expect(0, 71257, '\p{^Is_Scx=modi}', "");
    Expect(0, 71257, '\P{Is_Scx=modi}', "");
    Expect(1, 71257, '\P{^Is_Scx=modi}', "");
    Expect(0, 71258, '\p{Is_Scx=modi}', "");
    Expect(1, 71258, '\p{^Is_Scx=modi}', "");
    Expect(1, 71258, '\P{Is_Scx=modi}', "");
    Expect(0, 71258, '\P{^Is_Scx=modi}', "");
    Expect(1, 71257, '\p{Is_Scx=-MODI}', "");
    Expect(0, 71257, '\p{^Is_Scx=-MODI}', "");
    Expect(0, 71257, '\P{Is_Scx=-MODI}', "");
    Expect(1, 71257, '\P{^Is_Scx=-MODI}', "");
    Expect(0, 71258, '\p{Is_Scx=-MODI}', "");
    Expect(1, 71258, '\p{^Is_Scx=-MODI}', "");
    Expect(1, 71258, '\P{Is_Scx=-MODI}', "");
    Expect(0, 71258, '\P{^Is_Scx=-MODI}', "");
    Error('\p{Script_Extensions= /a/Mongolian}');
    Error('\P{Script_Extensions= /a/Mongolian}');
    Expect(1, 71276, '\p{Script_Extensions=:\AMongolian\z:}', "");;
    Expect(0, 71277, '\p{Script_Extensions=:\AMongolian\z:}', "");;
    Expect(1, 71276, '\p{Script_Extensions=mongolian}', "");
    Expect(0, 71276, '\p{^Script_Extensions=mongolian}', "");
    Expect(0, 71276, '\P{Script_Extensions=mongolian}', "");
    Expect(1, 71276, '\P{^Script_Extensions=mongolian}', "");
    Expect(0, 71277, '\p{Script_Extensions=mongolian}', "");
    Expect(1, 71277, '\p{^Script_Extensions=mongolian}', "");
    Expect(1, 71277, '\P{Script_Extensions=mongolian}', "");
    Expect(0, 71277, '\P{^Script_Extensions=mongolian}', "");
    Expect(1, 71276, '\p{Script_Extensions=:\Amongolian\z:}', "");;
    Expect(0, 71277, '\p{Script_Extensions=:\Amongolian\z:}', "");;
    Expect(1, 71276, '\p{Script_Extensions=	 Mongolian}', "");
    Expect(0, 71276, '\p{^Script_Extensions=	 Mongolian}', "");
    Expect(0, 71276, '\P{Script_Extensions=	 Mongolian}', "");
    Expect(1, 71276, '\P{^Script_Extensions=	 Mongolian}', "");
    Expect(0, 71277, '\p{Script_Extensions=	 Mongolian}', "");
    Expect(1, 71277, '\p{^Script_Extensions=	 Mongolian}', "");
    Expect(1, 71277, '\P{Script_Extensions=	 Mongolian}', "");
    Expect(0, 71277, '\P{^Script_Extensions=	 Mongolian}', "");
    Error('\p{Scx=	/a/Mong}');
    Error('\P{Scx=	/a/Mong}');
    Expect(1, 71276, '\p{Scx=:\AMong\z:}', "");;
    Expect(0, 71277, '\p{Scx=:\AMong\z:}', "");;
    Expect(1, 71276, '\p{Scx=mong}', "");
    Expect(0, 71276, '\p{^Scx=mong}', "");
    Expect(0, 71276, '\P{Scx=mong}', "");
    Expect(1, 71276, '\P{^Scx=mong}', "");
    Expect(0, 71277, '\p{Scx=mong}', "");
    Expect(1, 71277, '\p{^Scx=mong}', "");
    Expect(1, 71277, '\P{Scx=mong}', "");
    Expect(0, 71277, '\P{^Scx=mong}', "");
    Expect(1, 71276, '\p{Scx=:\Among\z:}', "");;
    Expect(0, 71277, '\p{Scx=:\Among\z:}', "");;
    Expect(1, 71276, '\p{Scx=_ Mong}', "");
    Expect(0, 71276, '\p{^Scx=_ Mong}', "");
    Expect(0, 71276, '\P{Scx=_ Mong}', "");
    Expect(1, 71276, '\P{^Scx=_ Mong}', "");
    Expect(0, 71277, '\p{Scx=_ Mong}', "");
    Expect(1, 71277, '\p{^Scx=_ Mong}', "");
    Expect(1, 71277, '\P{Scx=_ Mong}', "");
    Expect(0, 71277, '\P{^Scx=_ Mong}', "");
    Error('\p{Is_Script_Extensions=_:=MONGOLIAN}');
    Error('\P{Is_Script_Extensions=_:=MONGOLIAN}');
    Expect(1, 71276, '\p{Is_Script_Extensions=mongolian}', "");
    Expect(0, 71276, '\p{^Is_Script_Extensions=mongolian}', "");
    Expect(0, 71276, '\P{Is_Script_Extensions=mongolian}', "");
    Expect(1, 71276, '\P{^Is_Script_Extensions=mongolian}', "");
    Expect(0, 71277, '\p{Is_Script_Extensions=mongolian}', "");
    Expect(1, 71277, '\p{^Is_Script_Extensions=mongolian}', "");
    Expect(1, 71277, '\P{Is_Script_Extensions=mongolian}', "");
    Expect(0, 71277, '\P{^Is_Script_Extensions=mongolian}', "");
    Expect(1, 71276, '\p{Is_Script_Extensions=		MONGOLIAN}', "");
    Expect(0, 71276, '\p{^Is_Script_Extensions=		MONGOLIAN}', "");
    Expect(0, 71276, '\P{Is_Script_Extensions=		MONGOLIAN}', "");
    Expect(1, 71276, '\P{^Is_Script_Extensions=		MONGOLIAN}', "");
    Expect(0, 71277, '\p{Is_Script_Extensions=		MONGOLIAN}', "");
    Expect(1, 71277, '\p{^Is_Script_Extensions=		MONGOLIAN}', "");
    Expect(1, 71277, '\P{Is_Script_Extensions=		MONGOLIAN}', "");
    Expect(0, 71277, '\P{^Is_Script_Extensions=		MONGOLIAN}', "");
    Error('\p{Is_Scx=/a/-_mong}');
    Error('\P{Is_Scx=/a/-_mong}');
    Expect(1, 71276, '\p{Is_Scx=mong}', "");
    Expect(0, 71276, '\p{^Is_Scx=mong}', "");
    Expect(0, 71276, '\P{Is_Scx=mong}', "");
    Expect(1, 71276, '\P{^Is_Scx=mong}', "");
    Expect(0, 71277, '\p{Is_Scx=mong}', "");
    Expect(1, 71277, '\p{^Is_Scx=mong}', "");
    Expect(1, 71277, '\P{Is_Scx=mong}', "");
    Expect(0, 71277, '\P{^Is_Scx=mong}', "");
    Expect(1, 71276, '\p{Is_Scx=_mong}', "");
    Expect(0, 71276, '\p{^Is_Scx=_mong}', "");
    Expect(0, 71276, '\P{Is_Scx=_mong}', "");
    Expect(1, 71276, '\P{^Is_Scx=_mong}', "");
    Expect(0, 71277, '\p{Is_Scx=_mong}', "");
    Expect(1, 71277, '\p{^Is_Scx=_mong}', "");
    Expect(1, 71277, '\P{Is_Scx=_mong}', "");
    Expect(0, 71277, '\P{^Is_Scx=_mong}', "");
    Error('\p{Script_Extensions=-:=MRO}');
    Error('\P{Script_Extensions=-:=MRO}');
    Expect(1, 92783, '\p{Script_Extensions=:\AMro\z:}', "");;
    Expect(0, 92784, '\p{Script_Extensions=:\AMro\z:}', "");;
    Expect(1, 92783, '\p{Script_Extensions=mro}', "");
    Expect(0, 92783, '\p{^Script_Extensions=mro}', "");
    Expect(0, 92783, '\P{Script_Extensions=mro}', "");
    Expect(1, 92783, '\P{^Script_Extensions=mro}', "");
    Expect(0, 92784, '\p{Script_Extensions=mro}', "");
    Expect(1, 92784, '\p{^Script_Extensions=mro}', "");
    Expect(1, 92784, '\P{Script_Extensions=mro}', "");
    Expect(0, 92784, '\P{^Script_Extensions=mro}', "");
    Expect(1, 92783, '\p{Script_Extensions=:\Amro\z:}', "");;
    Expect(0, 92784, '\p{Script_Extensions=:\Amro\z:}', "");;
    Expect(1, 92783, '\p{Script_Extensions=	mro}', "");
    Expect(0, 92783, '\p{^Script_Extensions=	mro}', "");
    Expect(0, 92783, '\P{Script_Extensions=	mro}', "");
    Expect(1, 92783, '\P{^Script_Extensions=	mro}', "");
    Expect(0, 92784, '\p{Script_Extensions=	mro}', "");
    Expect(1, 92784, '\p{^Script_Extensions=	mro}', "");
    Expect(1, 92784, '\P{Script_Extensions=	mro}', "");
    Expect(0, 92784, '\P{^Script_Extensions=	mro}', "");
    Error('\p{Scx= 	Mroo/a/}');
    Error('\P{Scx= 	Mroo/a/}');
    Expect(1, 92783, '\p{Scx=:\AMroo\z:}', "");;
    Expect(0, 92784, '\p{Scx=:\AMroo\z:}', "");;
    Expect(1, 92783, '\p{Scx:mroo}', "");
    Expect(0, 92783, '\p{^Scx:mroo}', "");
    Expect(0, 92783, '\P{Scx:mroo}', "");
    Expect(1, 92783, '\P{^Scx:mroo}', "");
    Expect(0, 92784, '\p{Scx:mroo}', "");
    Expect(1, 92784, '\p{^Scx:mroo}', "");
    Expect(1, 92784, '\P{Scx:mroo}', "");
    Expect(0, 92784, '\P{^Scx:mroo}', "");
    Expect(1, 92783, '\p{Scx=:\Amroo\z:}', "");;
    Expect(0, 92784, '\p{Scx=:\Amroo\z:}', "");;
    Expect(1, 92783, '\p{Scx=-	Mroo}', "");
    Expect(0, 92783, '\p{^Scx=-	Mroo}', "");
    Expect(0, 92783, '\P{Scx=-	Mroo}', "");
    Expect(1, 92783, '\P{^Scx=-	Mroo}', "");
    Expect(0, 92784, '\p{Scx=-	Mroo}', "");
    Expect(1, 92784, '\p{^Scx=-	Mroo}', "");
    Expect(1, 92784, '\P{Scx=-	Mroo}', "");
    Expect(0, 92784, '\P{^Scx=-	Mroo}', "");
    Error('\p{Is_Script_Extensions=_	Mro:=}');
    Error('\P{Is_Script_Extensions=_	Mro:=}');
    Expect(1, 92783, '\p{Is_Script_Extensions: mro}', "");
    Expect(0, 92783, '\p{^Is_Script_Extensions: mro}', "");
    Expect(0, 92783, '\P{Is_Script_Extensions: mro}', "");
    Expect(1, 92783, '\P{^Is_Script_Extensions: mro}', "");
    Expect(0, 92784, '\p{Is_Script_Extensions: mro}', "");
    Expect(1, 92784, '\p{^Is_Script_Extensions: mro}', "");
    Expect(1, 92784, '\P{Is_Script_Extensions: mro}', "");
    Expect(0, 92784, '\P{^Is_Script_Extensions: mro}', "");
    Expect(1, 92783, '\p{Is_Script_Extensions= mro}', "");
    Expect(0, 92783, '\p{^Is_Script_Extensions= mro}', "");
    Expect(0, 92783, '\P{Is_Script_Extensions= mro}', "");
    Expect(1, 92783, '\P{^Is_Script_Extensions= mro}', "");
    Expect(0, 92784, '\p{Is_Script_Extensions= mro}', "");
    Expect(1, 92784, '\p{^Is_Script_Extensions= mro}', "");
    Expect(1, 92784, '\P{Is_Script_Extensions= mro}', "");
    Expect(0, 92784, '\P{^Is_Script_Extensions= mro}', "");
    Error('\p{Is_Scx=	 mroo:=}');
    Error('\P{Is_Scx=	 mroo:=}');
    Expect(1, 92783, '\p{Is_Scx=mroo}', "");
    Expect(0, 92783, '\p{^Is_Scx=mroo}', "");
    Expect(0, 92783, '\P{Is_Scx=mroo}', "");
    Expect(1, 92783, '\P{^Is_Scx=mroo}', "");
    Expect(0, 92784, '\p{Is_Scx=mroo}', "");
    Expect(1, 92784, '\p{^Is_Scx=mroo}', "");
    Expect(1, 92784, '\P{Is_Scx=mroo}', "");
    Expect(0, 92784, '\P{^Is_Scx=mroo}', "");
    Expect(1, 92783, '\p{Is_Scx=-Mroo}', "");
    Expect(0, 92783, '\p{^Is_Scx=-Mroo}', "");
    Expect(0, 92783, '\P{Is_Scx=-Mroo}', "");
    Expect(1, 92783, '\P{^Is_Scx=-Mroo}', "");
    Expect(0, 92784, '\p{Is_Scx=-Mroo}', "");
    Expect(1, 92784, '\p{^Is_Scx=-Mroo}', "");
    Expect(1, 92784, '\P{Is_Scx=-Mroo}', "");
    Expect(0, 92784, '\P{^Is_Scx=-Mroo}', "");
    Error('\p{Script_Extensions=:= Meetei_Mayek}');
    Error('\P{Script_Extensions=:= Meetei_Mayek}');
    Expect(1, 44025, '\p{Script_Extensions=:\AMeetei_Mayek\z:}', "");;
    Expect(0, 44026, '\p{Script_Extensions=:\AMeetei_Mayek\z:}', "");;
    Expect(1, 44025, '\p{Script_Extensions=meeteimayek}', "");
    Expect(0, 44025, '\p{^Script_Extensions=meeteimayek}', "");
    Expect(0, 44025, '\P{Script_Extensions=meeteimayek}', "");
    Expect(1, 44025, '\P{^Script_Extensions=meeteimayek}', "");
    Expect(0, 44026, '\p{Script_Extensions=meeteimayek}', "");
    Expect(1, 44026, '\p{^Script_Extensions=meeteimayek}', "");
    Expect(1, 44026, '\P{Script_Extensions=meeteimayek}', "");
    Expect(0, 44026, '\P{^Script_Extensions=meeteimayek}', "");
    Expect(1, 44025, '\p{Script_Extensions=:\Ameeteimayek\z:}', "");;
    Expect(0, 44026, '\p{Script_Extensions=:\Ameeteimayek\z:}', "");;
    Expect(1, 44025, '\p{Script_Extensions:    meetei_MAYEK}', "");
    Expect(0, 44025, '\p{^Script_Extensions:    meetei_MAYEK}', "");
    Expect(0, 44025, '\P{Script_Extensions:    meetei_MAYEK}', "");
    Expect(1, 44025, '\P{^Script_Extensions:    meetei_MAYEK}', "");
    Expect(0, 44026, '\p{Script_Extensions:    meetei_MAYEK}', "");
    Expect(1, 44026, '\p{^Script_Extensions:    meetei_MAYEK}', "");
    Expect(1, 44026, '\P{Script_Extensions:    meetei_MAYEK}', "");
    Expect(0, 44026, '\P{^Script_Extensions:    meetei_MAYEK}', "");
    Error('\p{Scx=_/a/Mtei}');
    Error('\P{Scx=_/a/Mtei}');
    Expect(1, 44025, '\p{Scx=:\AMtei\z:}', "");;
    Expect(0, 44026, '\p{Scx=:\AMtei\z:}', "");;
    Expect(1, 44025, '\p{Scx:mtei}', "");
    Expect(0, 44025, '\p{^Scx:mtei}', "");
    Expect(0, 44025, '\P{Scx:mtei}', "");
    Expect(1, 44025, '\P{^Scx:mtei}', "");
    Expect(0, 44026, '\p{Scx:mtei}', "");
    Expect(1, 44026, '\p{^Scx:mtei}', "");
    Expect(1, 44026, '\P{Scx:mtei}', "");
    Expect(0, 44026, '\P{^Scx:mtei}', "");
    Expect(1, 44025, '\p{Scx=:\Amtei\z:}', "");;
    Expect(0, 44026, '\p{Scx=:\Amtei\z:}', "");;
    Expect(1, 44025, '\p{Scx=_-Mtei}', "");
    Expect(0, 44025, '\p{^Scx=_-Mtei}', "");
    Expect(0, 44025, '\P{Scx=_-Mtei}', "");
    Expect(1, 44025, '\P{^Scx=_-Mtei}', "");
    Expect(0, 44026, '\p{Scx=_-Mtei}', "");
    Expect(1, 44026, '\p{^Scx=_-Mtei}', "");
    Expect(1, 44026, '\P{Scx=_-Mtei}', "");
    Expect(0, 44026, '\P{^Scx=_-Mtei}', "");
    Error('\p{Is_Script_Extensions= 	Meetei_Mayek:=}');
    Error('\P{Is_Script_Extensions= 	Meetei_Mayek:=}');
    Expect(1, 44025, '\p{Is_Script_Extensions=meeteimayek}', "");
    Expect(0, 44025, '\p{^Is_Script_Extensions=meeteimayek}', "");
    Expect(0, 44025, '\P{Is_Script_Extensions=meeteimayek}', "");
    Expect(1, 44025, '\P{^Is_Script_Extensions=meeteimayek}', "");
    Expect(0, 44026, '\p{Is_Script_Extensions=meeteimayek}', "");
    Expect(1, 44026, '\p{^Is_Script_Extensions=meeteimayek}', "");
    Expect(1, 44026, '\P{Is_Script_Extensions=meeteimayek}', "");
    Expect(0, 44026, '\P{^Is_Script_Extensions=meeteimayek}', "");
    Expect(1, 44025, '\p{Is_Script_Extensions=_ Meetei_MAYEK}', "");
    Expect(0, 44025, '\p{^Is_Script_Extensions=_ Meetei_MAYEK}', "");
    Expect(0, 44025, '\P{Is_Script_Extensions=_ Meetei_MAYEK}', "");
    Expect(1, 44025, '\P{^Is_Script_Extensions=_ Meetei_MAYEK}', "");
    Expect(0, 44026, '\p{Is_Script_Extensions=_ Meetei_MAYEK}', "");
    Expect(1, 44026, '\p{^Is_Script_Extensions=_ Meetei_MAYEK}', "");
    Expect(1, 44026, '\P{Is_Script_Extensions=_ Meetei_MAYEK}', "");
    Expect(0, 44026, '\P{^Is_Script_Extensions=_ Meetei_MAYEK}', "");
    Error('\p{Is_Scx=:=  mtei}');
    Error('\P{Is_Scx=:=  mtei}');
    Expect(1, 44025, '\p{Is_Scx=mtei}', "");
    Expect(0, 44025, '\p{^Is_Scx=mtei}', "");
    Expect(0, 44025, '\P{Is_Scx=mtei}', "");
    Expect(1, 44025, '\P{^Is_Scx=mtei}', "");
    Expect(0, 44026, '\p{Is_Scx=mtei}', "");
    Expect(1, 44026, '\p{^Is_Scx=mtei}', "");
    Expect(1, 44026, '\P{Is_Scx=mtei}', "");
    Expect(0, 44026, '\P{^Is_Scx=mtei}', "");
    Expect(1, 44025, '\p{Is_Scx=	 Mtei}', "");
    Expect(0, 44025, '\p{^Is_Scx=	 Mtei}', "");
    Expect(0, 44025, '\P{Is_Scx=	 Mtei}', "");
    Expect(1, 44025, '\P{^Is_Scx=	 Mtei}', "");
    Expect(0, 44026, '\p{Is_Scx=	 Mtei}', "");
    Expect(1, 44026, '\p{^Is_Scx=	 Mtei}', "");
    Expect(1, 44026, '\P{Is_Scx=	 Mtei}', "");
    Expect(0, 44026, '\P{^Is_Scx=	 Mtei}', "");
    Error('\p{Script_Extensions=-	MULTANI:=}');
    Error('\P{Script_Extensions=-	MULTANI:=}');
    Expect(1, 70313, '\p{Script_Extensions=:\AMultani\z:}', "");;
    Expect(0, 70314, '\p{Script_Extensions=:\AMultani\z:}', "");;
    Expect(1, 70313, '\p{Script_Extensions=multani}', "");
    Expect(0, 70313, '\p{^Script_Extensions=multani}', "");
    Expect(0, 70313, '\P{Script_Extensions=multani}', "");
    Expect(1, 70313, '\P{^Script_Extensions=multani}', "");
    Expect(0, 70314, '\p{Script_Extensions=multani}', "");
    Expect(1, 70314, '\p{^Script_Extensions=multani}', "");
    Expect(1, 70314, '\P{Script_Extensions=multani}', "");
    Expect(0, 70314, '\P{^Script_Extensions=multani}', "");
    Expect(1, 70313, '\p{Script_Extensions=:\Amultani\z:}', "");;
    Expect(0, 70314, '\p{Script_Extensions=:\Amultani\z:}', "");;
    Expect(1, 70313, '\p{Script_Extensions=- MULTANI}', "");
    Expect(0, 70313, '\p{^Script_Extensions=- MULTANI}', "");
    Expect(0, 70313, '\P{Script_Extensions=- MULTANI}', "");
    Expect(1, 70313, '\P{^Script_Extensions=- MULTANI}', "");
    Expect(0, 70314, '\p{Script_Extensions=- MULTANI}', "");
    Expect(1, 70314, '\p{^Script_Extensions=- MULTANI}', "");
    Expect(1, 70314, '\P{Script_Extensions=- MULTANI}', "");
    Expect(0, 70314, '\P{^Script_Extensions=- MULTANI}', "");
    Error('\p{Scx=/a/Mult}');
    Error('\P{Scx=/a/Mult}');
    Expect(1, 70313, '\p{Scx=:\AMult\z:}', "");;
    Expect(0, 70314, '\p{Scx=:\AMult\z:}', "");;
    Expect(1, 70313, '\p{Scx=mult}', "");
    Expect(0, 70313, '\p{^Scx=mult}', "");
    Expect(0, 70313, '\P{Scx=mult}', "");
    Expect(1, 70313, '\P{^Scx=mult}', "");
    Expect(0, 70314, '\p{Scx=mult}', "");
    Expect(1, 70314, '\p{^Scx=mult}', "");
    Expect(1, 70314, '\P{Scx=mult}', "");
    Expect(0, 70314, '\P{^Scx=mult}', "");
    Expect(1, 70313, '\p{Scx=:\Amult\z:}', "");;
    Expect(0, 70314, '\p{Scx=:\Amult\z:}', "");;
    Expect(1, 70313, '\p{Scx=-Mult}', "");
    Expect(0, 70313, '\p{^Scx=-Mult}', "");
    Expect(0, 70313, '\P{Scx=-Mult}', "");
    Expect(1, 70313, '\P{^Scx=-Mult}', "");
    Expect(0, 70314, '\p{Scx=-Mult}', "");
    Expect(1, 70314, '\p{^Scx=-Mult}', "");
    Expect(1, 70314, '\P{Scx=-Mult}', "");
    Expect(0, 70314, '\P{^Scx=-Mult}', "");
    Error('\p{Is_Script_Extensions= :=multani}');
    Error('\P{Is_Script_Extensions= :=multani}');
    Expect(1, 70313, '\p{Is_Script_Extensions=multani}', "");
    Expect(0, 70313, '\p{^Is_Script_Extensions=multani}', "");
    Expect(0, 70313, '\P{Is_Script_Extensions=multani}', "");
    Expect(1, 70313, '\P{^Is_Script_Extensions=multani}', "");
    Expect(0, 70314, '\p{Is_Script_Extensions=multani}', "");
    Expect(1, 70314, '\p{^Is_Script_Extensions=multani}', "");
    Expect(1, 70314, '\P{Is_Script_Extensions=multani}', "");
    Expect(0, 70314, '\P{^Is_Script_Extensions=multani}', "");
    Expect(1, 70313, '\p{Is_Script_Extensions=__multani}', "");
    Expect(0, 70313, '\p{^Is_Script_Extensions=__multani}', "");
    Expect(0, 70313, '\P{Is_Script_Extensions=__multani}', "");
    Expect(1, 70313, '\P{^Is_Script_Extensions=__multani}', "");
    Expect(0, 70314, '\p{Is_Script_Extensions=__multani}', "");
    Expect(1, 70314, '\p{^Is_Script_Extensions=__multani}', "");
    Expect(1, 70314, '\P{Is_Script_Extensions=__multani}', "");
    Expect(0, 70314, '\P{^Is_Script_Extensions=__multani}', "");
    Error('\p{Is_Scx=:=Mult}');
    Error('\P{Is_Scx=:=Mult}');
    Expect(1, 70313, '\p{Is_Scx=mult}', "");
    Expect(0, 70313, '\p{^Is_Scx=mult}', "");
    Expect(0, 70313, '\P{Is_Scx=mult}', "");
    Expect(1, 70313, '\P{^Is_Scx=mult}', "");
    Expect(0, 70314, '\p{Is_Scx=mult}', "");
    Expect(1, 70314, '\p{^Is_Scx=mult}', "");
    Expect(1, 70314, '\P{Is_Scx=mult}', "");
    Expect(0, 70314, '\P{^Is_Scx=mult}', "");
    Expect(1, 70313, '\p{Is_Scx=	_mult}', "");
    Expect(0, 70313, '\p{^Is_Scx=	_mult}', "");
    Expect(0, 70313, '\P{Is_Scx=	_mult}', "");
    Expect(1, 70313, '\P{^Is_Scx=	_mult}', "");
    Expect(0, 70314, '\p{Is_Scx=	_mult}', "");
    Expect(1, 70314, '\p{^Is_Scx=	_mult}', "");
    Expect(1, 70314, '\P{Is_Scx=	_mult}', "");
    Expect(0, 70314, '\P{^Is_Scx=	_mult}', "");
    Error('\p{Script_Extensions=:= 	myanmar}');
    Error('\P{Script_Extensions=:= 	myanmar}');
    Expect(1, 43647, '\p{Script_Extensions=:\AMyanmar\z:}', "");;
    Expect(0, 43648, '\p{Script_Extensions=:\AMyanmar\z:}', "");;
    Expect(1, 43647, '\p{Script_Extensions=myanmar}', "");
    Expect(0, 43647, '\p{^Script_Extensions=myanmar}', "");
    Expect(0, 43647, '\P{Script_Extensions=myanmar}', "");
    Expect(1, 43647, '\P{^Script_Extensions=myanmar}', "");
    Expect(0, 43648, '\p{Script_Extensions=myanmar}', "");
    Expect(1, 43648, '\p{^Script_Extensions=myanmar}', "");
    Expect(1, 43648, '\P{Script_Extensions=myanmar}', "");
    Expect(0, 43648, '\P{^Script_Extensions=myanmar}', "");
    Expect(1, 43647, '\p{Script_Extensions=:\Amyanmar\z:}', "");;
    Expect(0, 43648, '\p{Script_Extensions=:\Amyanmar\z:}', "");;
    Expect(1, 43647, '\p{Script_Extensions=	_Myanmar}', "");
    Expect(0, 43647, '\p{^Script_Extensions=	_Myanmar}', "");
    Expect(0, 43647, '\P{Script_Extensions=	_Myanmar}', "");
    Expect(1, 43647, '\P{^Script_Extensions=	_Myanmar}', "");
    Expect(0, 43648, '\p{Script_Extensions=	_Myanmar}', "");
    Expect(1, 43648, '\p{^Script_Extensions=	_Myanmar}', "");
    Expect(1, 43648, '\P{Script_Extensions=	_Myanmar}', "");
    Expect(0, 43648, '\P{^Script_Extensions=	_Myanmar}', "");
    Error('\p{Scx=/a/_	Mymr}');
    Error('\P{Scx=/a/_	Mymr}');
    Expect(1, 43647, '\p{Scx=:\AMymr\z:}', "");;
    Expect(0, 43648, '\p{Scx=:\AMymr\z:}', "");;
    Expect(1, 43647, '\p{Scx=mymr}', "");
    Expect(0, 43647, '\p{^Scx=mymr}', "");
    Expect(0, 43647, '\P{Scx=mymr}', "");
    Expect(1, 43647, '\P{^Scx=mymr}', "");
    Expect(0, 43648, '\p{Scx=mymr}', "");
    Expect(1, 43648, '\p{^Scx=mymr}', "");
    Expect(1, 43648, '\P{Scx=mymr}', "");
    Expect(0, 43648, '\P{^Scx=mymr}', "");
    Expect(1, 43647, '\p{Scx=:\Amymr\z:}', "");;
    Expect(0, 43648, '\p{Scx=:\Amymr\z:}', "");;
    Expect(1, 43647, '\p{Scx=__MYMR}', "");
    Expect(0, 43647, '\p{^Scx=__MYMR}', "");
    Expect(0, 43647, '\P{Scx=__MYMR}', "");
    Expect(1, 43647, '\P{^Scx=__MYMR}', "");
    Expect(0, 43648, '\p{Scx=__MYMR}', "");
    Expect(1, 43648, '\p{^Scx=__MYMR}', "");
    Expect(1, 43648, '\P{Scx=__MYMR}', "");
    Expect(0, 43648, '\P{^Scx=__MYMR}', "");
    Error('\p{Is_Script_Extensions=/a/ myanmar}');
    Error('\P{Is_Script_Extensions=/a/ myanmar}');
    Expect(1, 43647, '\p{Is_Script_Extensions=myanmar}', "");
    Expect(0, 43647, '\p{^Is_Script_Extensions=myanmar}', "");
    Expect(0, 43647, '\P{Is_Script_Extensions=myanmar}', "");
    Expect(1, 43647, '\P{^Is_Script_Extensions=myanmar}', "");
    Expect(0, 43648, '\p{Is_Script_Extensions=myanmar}', "");
    Expect(1, 43648, '\p{^Is_Script_Extensions=myanmar}', "");
    Expect(1, 43648, '\P{Is_Script_Extensions=myanmar}', "");
    Expect(0, 43648, '\P{^Is_Script_Extensions=myanmar}', "");
    Expect(1, 43647, '\p{Is_Script_Extensions= 	Myanmar}', "");
    Expect(0, 43647, '\p{^Is_Script_Extensions= 	Myanmar}', "");
    Expect(0, 43647, '\P{Is_Script_Extensions= 	Myanmar}', "");
    Expect(1, 43647, '\P{^Is_Script_Extensions= 	Myanmar}', "");
    Expect(0, 43648, '\p{Is_Script_Extensions= 	Myanmar}', "");
    Expect(1, 43648, '\p{^Is_Script_Extensions= 	Myanmar}', "");
    Expect(1, 43648, '\P{Is_Script_Extensions= 	Myanmar}', "");
    Expect(0, 43648, '\P{^Is_Script_Extensions= 	Myanmar}', "");
    Error('\p{Is_Scx=_	mymr/a/}');
    Error('\P{Is_Scx=_	mymr/a/}');
    Expect(1, 43647, '\p{Is_Scx=mymr}', "");
    Expect(0, 43647, '\p{^Is_Scx=mymr}', "");
    Expect(0, 43647, '\P{Is_Scx=mymr}', "");
    Expect(1, 43647, '\P{^Is_Scx=mymr}', "");
    Expect(0, 43648, '\p{Is_Scx=mymr}', "");
    Expect(1, 43648, '\p{^Is_Scx=mymr}', "");
    Expect(1, 43648, '\P{Is_Scx=mymr}', "");
    Expect(0, 43648, '\P{^Is_Scx=mymr}', "");
    Expect(1, 43647, '\p{Is_Scx= -mymr}', "");
    Expect(0, 43647, '\p{^Is_Scx= -mymr}', "");
    Expect(0, 43647, '\P{Is_Scx= -mymr}', "");
    Expect(1, 43647, '\P{^Is_Scx= -mymr}', "");
    Expect(0, 43648, '\p{Is_Scx= -mymr}', "");
    Expect(1, 43648, '\p{^Is_Scx= -mymr}', "");
    Expect(1, 43648, '\P{Is_Scx= -mymr}', "");
    Expect(0, 43648, '\P{^Is_Scx= -mymr}', "");
    Error('\p{Script_Extensions=/a/	 NANDINAGARI}');
    Error('\P{Script_Extensions=/a/	 NANDINAGARI}');
    Expect(1, 72164, '\p{Script_Extensions=:\ANandinagari\z:}', "");;
    Expect(0, 72165, '\p{Script_Extensions=:\ANandinagari\z:}', "");;
    Expect(1, 72164, '\p{Script_Extensions=nandinagari}', "");
    Expect(0, 72164, '\p{^Script_Extensions=nandinagari}', "");
    Expect(0, 72164, '\P{Script_Extensions=nandinagari}', "");
    Expect(1, 72164, '\P{^Script_Extensions=nandinagari}', "");
    Expect(0, 72165, '\p{Script_Extensions=nandinagari}', "");
    Expect(1, 72165, '\p{^Script_Extensions=nandinagari}', "");
    Expect(1, 72165, '\P{Script_Extensions=nandinagari}', "");
    Expect(0, 72165, '\P{^Script_Extensions=nandinagari}', "");
    Expect(1, 72164, '\p{Script_Extensions=:\Anandinagari\z:}', "");;
    Expect(0, 72165, '\p{Script_Extensions=:\Anandinagari\z:}', "");;
    Expect(1, 72164, '\p{Script_Extensions= nandinagari}', "");
    Expect(0, 72164, '\p{^Script_Extensions= nandinagari}', "");
    Expect(0, 72164, '\P{Script_Extensions= nandinagari}', "");
    Expect(1, 72164, '\P{^Script_Extensions= nandinagari}', "");
    Expect(0, 72165, '\p{Script_Extensions= nandinagari}', "");
    Expect(1, 72165, '\p{^Script_Extensions= nandinagari}', "");
    Expect(1, 72165, '\P{Script_Extensions= nandinagari}', "");
    Expect(0, 72165, '\P{^Script_Extensions= nandinagari}', "");
    Error('\p{Scx=:= NAND}');
    Error('\P{Scx=:= NAND}');
    Expect(1, 72164, '\p{Scx=:\ANand\z:}', "");;
    Expect(0, 72165, '\p{Scx=:\ANand\z:}', "");;
    Expect(1, 72164, '\p{Scx=nand}', "");
    Expect(0, 72164, '\p{^Scx=nand}', "");
    Expect(0, 72164, '\P{Scx=nand}', "");
    Expect(1, 72164, '\P{^Scx=nand}', "");
    Expect(0, 72165, '\p{Scx=nand}', "");
    Expect(1, 72165, '\p{^Scx=nand}', "");
    Expect(1, 72165, '\P{Scx=nand}', "");
    Expect(0, 72165, '\P{^Scx=nand}', "");
    Expect(1, 72164, '\p{Scx=:\Anand\z:}', "");;
    Expect(0, 72165, '\p{Scx=:\Anand\z:}', "");;
    Expect(1, 72164, '\p{Scx=	-Nand}', "");
    Expect(0, 72164, '\p{^Scx=	-Nand}', "");
    Expect(0, 72164, '\P{Scx=	-Nand}', "");
    Expect(1, 72164, '\P{^Scx=	-Nand}', "");
    Expect(0, 72165, '\p{Scx=	-Nand}', "");
    Expect(1, 72165, '\p{^Scx=	-Nand}', "");
    Expect(1, 72165, '\P{Scx=	-Nand}', "");
    Expect(0, 72165, '\P{^Scx=	-Nand}', "");
    Error('\p{Is_Script_Extensions=-/a/nandinagari}');
    Error('\P{Is_Script_Extensions=-/a/nandinagari}');
    Expect(1, 72164, '\p{Is_Script_Extensions=nandinagari}', "");
    Expect(0, 72164, '\p{^Is_Script_Extensions=nandinagari}', "");
    Expect(0, 72164, '\P{Is_Script_Extensions=nandinagari}', "");
    Expect(1, 72164, '\P{^Is_Script_Extensions=nandinagari}', "");
    Expect(0, 72165, '\p{Is_Script_Extensions=nandinagari}', "");
    Expect(1, 72165, '\p{^Is_Script_Extensions=nandinagari}', "");
    Expect(1, 72165, '\P{Is_Script_Extensions=nandinagari}', "");
    Expect(0, 72165, '\P{^Is_Script_Extensions=nandinagari}', "");
    Expect(1, 72164, '\p{Is_Script_Extensions:_-nandinagari}', "");
    Expect(0, 72164, '\p{^Is_Script_Extensions:_-nandinagari}', "");
    Expect(0, 72164, '\P{Is_Script_Extensions:_-nandinagari}', "");
    Expect(1, 72164, '\P{^Is_Script_Extensions:_-nandinagari}', "");
    Expect(0, 72165, '\p{Is_Script_Extensions:_-nandinagari}', "");
    Expect(1, 72165, '\p{^Is_Script_Extensions:_-nandinagari}', "");
    Expect(1, 72165, '\P{Is_Script_Extensions:_-nandinagari}', "");
    Expect(0, 72165, '\P{^Is_Script_Extensions:_-nandinagari}', "");
    Error('\p{Is_Scx=/a/NAND}');
    Error('\P{Is_Scx=/a/NAND}');
    Expect(1, 72164, '\p{Is_Scx=nand}', "");
    Expect(0, 72164, '\p{^Is_Scx=nand}', "");
    Expect(0, 72164, '\P{Is_Scx=nand}', "");
    Expect(1, 72164, '\P{^Is_Scx=nand}', "");
    Expect(0, 72165, '\p{Is_Scx=nand}', "");
    Expect(1, 72165, '\p{^Is_Scx=nand}', "");
    Expect(1, 72165, '\P{Is_Scx=nand}', "");
    Expect(0, 72165, '\P{^Is_Scx=nand}', "");
    Expect(1, 72164, '\p{Is_Scx= nand}', "");
    Expect(0, 72164, '\p{^Is_Scx= nand}', "");
    Expect(0, 72164, '\P{Is_Scx= nand}', "");
    Expect(1, 72164, '\P{^Is_Scx= nand}', "");
    Expect(0, 72165, '\p{Is_Scx= nand}', "");
    Expect(1, 72165, '\p{^Is_Scx= nand}', "");
    Expect(1, 72165, '\P{Is_Scx= nand}', "");
    Expect(0, 72165, '\P{^Is_Scx= nand}', "");
    Error('\p{Script_Extensions=Old_North_Arabian/a/}');
    Error('\P{Script_Extensions=Old_North_Arabian/a/}');
    Expect(1, 68255, '\p{Script_Extensions=:\AOld_North_Arabian\z:}', "");;
    Expect(0, 68256, '\p{Script_Extensions=:\AOld_North_Arabian\z:}', "");;
    Expect(1, 68255, '\p{Script_Extensions=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Script_Extensions=oldnortharabian}', "");
    Expect(0, 68255, '\P{Script_Extensions=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Script_Extensions=oldnortharabian}', "");
    Expect(0, 68256, '\p{Script_Extensions=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Script_Extensions=oldnortharabian}', "");
    Expect(1, 68256, '\P{Script_Extensions=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Script_Extensions=oldnortharabian}', "");
    Expect(1, 68255, '\p{Script_Extensions=:\Aoldnortharabian\z:}', "");;
    Expect(0, 68256, '\p{Script_Extensions=:\Aoldnortharabian\z:}', "");;
    Expect(1, 68255, '\p{Script_Extensions=--Old_north_Arabian}', "");
    Expect(0, 68255, '\p{^Script_Extensions=--Old_north_Arabian}', "");
    Expect(0, 68255, '\P{Script_Extensions=--Old_north_Arabian}', "");
    Expect(1, 68255, '\P{^Script_Extensions=--Old_north_Arabian}', "");
    Expect(0, 68256, '\p{Script_Extensions=--Old_north_Arabian}', "");
    Expect(1, 68256, '\p{^Script_Extensions=--Old_north_Arabian}', "");
    Expect(1, 68256, '\P{Script_Extensions=--Old_north_Arabian}', "");
    Expect(0, 68256, '\P{^Script_Extensions=--Old_north_Arabian}', "");
    Error('\p{Scx=-:=Narb}');
    Error('\P{Scx=-:=Narb}');
    Expect(1, 68255, '\p{Scx=:\ANarb\z:}', "");;
    Expect(0, 68256, '\p{Scx=:\ANarb\z:}', "");;
    Expect(1, 68255, '\p{Scx=narb}', "");
    Expect(0, 68255, '\p{^Scx=narb}', "");
    Expect(0, 68255, '\P{Scx=narb}', "");
    Expect(1, 68255, '\P{^Scx=narb}', "");
    Expect(0, 68256, '\p{Scx=narb}', "");
    Expect(1, 68256, '\p{^Scx=narb}', "");
    Expect(1, 68256, '\P{Scx=narb}', "");
    Expect(0, 68256, '\P{^Scx=narb}', "");
    Expect(1, 68255, '\p{Scx=:\Anarb\z:}', "");;
    Expect(0, 68256, '\p{Scx=:\Anarb\z:}', "");;
    Expect(1, 68255, '\p{Scx=-Narb}', "");
    Expect(0, 68255, '\p{^Scx=-Narb}', "");
    Expect(0, 68255, '\P{Scx=-Narb}', "");
    Expect(1, 68255, '\P{^Scx=-Narb}', "");
    Expect(0, 68256, '\p{Scx=-Narb}', "");
    Expect(1, 68256, '\p{^Scx=-Narb}', "");
    Expect(1, 68256, '\P{Scx=-Narb}', "");
    Expect(0, 68256, '\P{^Scx=-Narb}', "");
    Error('\p{Is_Script_Extensions=:= -Old_North_arabian}');
    Error('\P{Is_Script_Extensions=:= -Old_North_arabian}');
    Expect(1, 68255, '\p{Is_Script_Extensions=oldnortharabian}', "");
    Expect(0, 68255, '\p{^Is_Script_Extensions=oldnortharabian}', "");
    Expect(0, 68255, '\P{Is_Script_Extensions=oldnortharabian}', "");
    Expect(1, 68255, '\P{^Is_Script_Extensions=oldnortharabian}', "");
    Expect(0, 68256, '\p{Is_Script_Extensions=oldnortharabian}', "");
    Expect(1, 68256, '\p{^Is_Script_Extensions=oldnortharabian}', "");
    Expect(1, 68256, '\P{Is_Script_Extensions=oldnortharabian}', "");
    Expect(0, 68256, '\P{^Is_Script_Extensions=oldnortharabian}', "");
    Expect(1, 68255, '\p{Is_Script_Extensions:    Old_north_Arabian}', "");
    Expect(0, 68255, '\p{^Is_Script_Extensions:    Old_north_Arabian}', "");
    Expect(0, 68255, '\P{Is_Script_Extensions:    Old_north_Arabian}', "");
    Expect(1, 68255, '\P{^Is_Script_Extensions:    Old_north_Arabian}', "");
    Expect(0, 68256, '\p{Is_Script_Extensions:    Old_north_Arabian}', "");
    Expect(1, 68256, '\p{^Is_Script_Extensions:    Old_north_Arabian}', "");
    Expect(1, 68256, '\P{Is_Script_Extensions:    Old_north_Arabian}', "");
    Expect(0, 68256, '\P{^Is_Script_Extensions:    Old_north_Arabian}', "");
    Error('\p{Is_Scx=_	NARB/a/}');
    Error('\P{Is_Scx=_	NARB/a/}');
    Expect(1, 68255, '\p{Is_Scx=narb}', "");
    Expect(0, 68255, '\p{^Is_Scx=narb}', "");
    Expect(0, 68255, '\P{Is_Scx=narb}', "");
    Expect(1, 68255, '\P{^Is_Scx=narb}', "");
    Expect(0, 68256, '\p{Is_Scx=narb}', "");
    Expect(1, 68256, '\p{^Is_Scx=narb}', "");
    Expect(1, 68256, '\P{Is_Scx=narb}', "");
    Expect(0, 68256, '\P{^Is_Scx=narb}', "");
    Expect(1, 68255, '\p{Is_Scx: 	narb}', "");
    Expect(0, 68255, '\p{^Is_Scx: 	narb}', "");
    Expect(0, 68255, '\P{Is_Scx: 	narb}', "");
    Expect(1, 68255, '\P{^Is_Scx: 	narb}', "");
    Expect(0, 68256, '\p{Is_Scx: 	narb}', "");
    Expect(1, 68256, '\p{^Is_Scx: 	narb}', "");
    Expect(1, 68256, '\P{Is_Scx: 	narb}', "");
    Expect(0, 68256, '\P{^Is_Scx: 	narb}', "");
    Error('\p{Script_Extensions=/a/_nabataean}');
    Error('\P{Script_Extensions=/a/_nabataean}');
    Expect(1, 67759, '\p{Script_Extensions=:\ANabataean\z:}', "");;
    Expect(0, 67760, '\p{Script_Extensions=:\ANabataean\z:}', "");;
    Expect(1, 67759, '\p{Script_Extensions=nabataean}', "");
    Expect(0, 67759, '\p{^Script_Extensions=nabataean}', "");
    Expect(0, 67759, '\P{Script_Extensions=nabataean}', "");
    Expect(1, 67759, '\P{^Script_Extensions=nabataean}', "");
    Expect(0, 67760, '\p{Script_Extensions=nabataean}', "");
    Expect(1, 67760, '\p{^Script_Extensions=nabataean}', "");
    Expect(1, 67760, '\P{Script_Extensions=nabataean}', "");
    Expect(0, 67760, '\P{^Script_Extensions=nabataean}', "");
    Expect(1, 67759, '\p{Script_Extensions=:\Anabataean\z:}', "");;
    Expect(0, 67760, '\p{Script_Extensions=:\Anabataean\z:}', "");;
    Expect(1, 67759, '\p{Script_Extensions=_Nabataean}', "");
    Expect(0, 67759, '\p{^Script_Extensions=_Nabataean}', "");
    Expect(0, 67759, '\P{Script_Extensions=_Nabataean}', "");
    Expect(1, 67759, '\P{^Script_Extensions=_Nabataean}', "");
    Expect(0, 67760, '\p{Script_Extensions=_Nabataean}', "");
    Expect(1, 67760, '\p{^Script_Extensions=_Nabataean}', "");
    Expect(1, 67760, '\P{Script_Extensions=_Nabataean}', "");
    Expect(0, 67760, '\P{^Script_Extensions=_Nabataean}', "");
    Error('\p{Scx=_	Nbat/a/}');
    Error('\P{Scx=_	Nbat/a/}');
    Expect(1, 67759, '\p{Scx=:\ANbat\z:}', "");;
    Expect(0, 67760, '\p{Scx=:\ANbat\z:}', "");;
    Expect(1, 67759, '\p{Scx=nbat}', "");
    Expect(0, 67759, '\p{^Scx=nbat}', "");
    Expect(0, 67759, '\P{Scx=nbat}', "");
    Expect(1, 67759, '\P{^Scx=nbat}', "");
    Expect(0, 67760, '\p{Scx=nbat}', "");
    Expect(1, 67760, '\p{^Scx=nbat}', "");
    Expect(1, 67760, '\P{Scx=nbat}', "");
    Expect(0, 67760, '\P{^Scx=nbat}', "");
    Expect(1, 67759, '\p{Scx=:\Anbat\z:}', "");;
    Expect(0, 67760, '\p{Scx=:\Anbat\z:}', "");;
    Expect(1, 67759, '\p{Scx=_	Nbat}', "");
    Expect(0, 67759, '\p{^Scx=_	Nbat}', "");
    Expect(0, 67759, '\P{Scx=_	Nbat}', "");
    Expect(1, 67759, '\P{^Scx=_	Nbat}', "");
    Expect(0, 67760, '\p{Scx=_	Nbat}', "");
    Expect(1, 67760, '\p{^Scx=_	Nbat}', "");
    Expect(1, 67760, '\P{Scx=_	Nbat}', "");
    Expect(0, 67760, '\P{^Scx=_	Nbat}', "");
    Error('\p{Is_Script_Extensions= -nabataean/a/}');
    Error('\P{Is_Script_Extensions= -nabataean/a/}');
    Expect(1, 67759, '\p{Is_Script_Extensions=nabataean}', "");
    Expect(0, 67759, '\p{^Is_Script_Extensions=nabataean}', "");
    Expect(0, 67759, '\P{Is_Script_Extensions=nabataean}', "");
    Expect(1, 67759, '\P{^Is_Script_Extensions=nabataean}', "");
    Expect(0, 67760, '\p{Is_Script_Extensions=nabataean}', "");
    Expect(1, 67760, '\p{^Is_Script_Extensions=nabataean}', "");
    Expect(1, 67760, '\P{Is_Script_Extensions=nabataean}', "");
    Expect(0, 67760, '\P{^Is_Script_Extensions=nabataean}', "");
    Expect(1, 67759, '\p{Is_Script_Extensions=	-nabataean}', "");
    Expect(0, 67759, '\p{^Is_Script_Extensions=	-nabataean}', "");
    Expect(0, 67759, '\P{Is_Script_Extensions=	-nabataean}', "");
    Expect(1, 67759, '\P{^Is_Script_Extensions=	-nabataean}', "");
    Expect(0, 67760, '\p{Is_Script_Extensions=	-nabataean}', "");
    Expect(1, 67760, '\p{^Is_Script_Extensions=	-nabataean}', "");
    Expect(1, 67760, '\P{Is_Script_Extensions=	-nabataean}', "");
    Expect(0, 67760, '\P{^Is_Script_Extensions=	-nabataean}', "");
    Error('\p{Is_Scx=:=nbat}');
    Error('\P{Is_Scx=:=nbat}');
    Expect(1, 67759, '\p{Is_Scx=nbat}', "");
    Expect(0, 67759, '\p{^Is_Scx=nbat}', "");
    Expect(0, 67759, '\P{Is_Scx=nbat}', "");
    Expect(1, 67759, '\P{^Is_Scx=nbat}', "");
    Expect(0, 67760, '\p{Is_Scx=nbat}', "");
    Expect(1, 67760, '\p{^Is_Scx=nbat}', "");
    Expect(1, 67760, '\P{Is_Scx=nbat}', "");
    Expect(0, 67760, '\P{^Is_Scx=nbat}', "");
    Expect(1, 67759, '\p{Is_Scx= 	nbat}', "");
    Expect(0, 67759, '\p{^Is_Scx= 	nbat}', "");
    Expect(0, 67759, '\P{Is_Scx= 	nbat}', "");
    Expect(1, 67759, '\P{^Is_Scx= 	nbat}', "");
    Expect(0, 67760, '\p{Is_Scx= 	nbat}', "");
    Expect(1, 67760, '\p{^Is_Scx= 	nbat}', "");
    Expect(1, 67760, '\P{Is_Scx= 	nbat}', "");
    Expect(0, 67760, '\P{^Is_Scx= 	nbat}', "");
    Error('\p{Script_Extensions=_-NEWA:=}');
    Error('\P{Script_Extensions=_-NEWA:=}');
    Expect(1, 70751, '\p{Script_Extensions=:\ANewa\z:}', "");;
    Expect(0, 70752, '\p{Script_Extensions=:\ANewa\z:}', "");;
    Expect(1, 70751, '\p{Script_Extensions=newa}', "");
    Expect(0, 70751, '\p{^Script_Extensions=newa}', "");
    Expect(0, 70751, '\P{Script_Extensions=newa}', "");
    Expect(1, 70751, '\P{^Script_Extensions=newa}', "");
    Expect(0, 70752, '\p{Script_Extensions=newa}', "");
    Expect(1, 70752, '\p{^Script_Extensions=newa}', "");
    Expect(1, 70752, '\P{Script_Extensions=newa}', "");
    Expect(0, 70752, '\P{^Script_Extensions=newa}', "");
    Expect(1, 70751, '\p{Script_Extensions=:\Anewa\z:}', "");;
    Expect(0, 70752, '\p{Script_Extensions=:\Anewa\z:}', "");;
    Expect(1, 70751, '\p{Script_Extensions=	-Newa}', "");
    Expect(0, 70751, '\p{^Script_Extensions=	-Newa}', "");
    Expect(0, 70751, '\P{Script_Extensions=	-Newa}', "");
    Expect(1, 70751, '\P{^Script_Extensions=	-Newa}', "");
    Expect(0, 70752, '\p{Script_Extensions=	-Newa}', "");
    Expect(1, 70752, '\p{^Script_Extensions=	-Newa}', "");
    Expect(1, 70752, '\P{Script_Extensions=	-Newa}', "");
    Expect(0, 70752, '\P{^Script_Extensions=	-Newa}', "");
    Error('\p{Scx: /a/ _NEWA}');
    Error('\P{Scx: /a/ _NEWA}');
    Expect(1, 70751, '\p{Scx=:\ANewa\z:}', "");;
    Expect(0, 70752, '\p{Scx=:\ANewa\z:}', "");;
    Expect(1, 70751, '\p{Scx=newa}', "");
    Expect(0, 70751, '\p{^Scx=newa}', "");
    Expect(0, 70751, '\P{Scx=newa}', "");
    Expect(1, 70751, '\P{^Scx=newa}', "");
    Expect(0, 70752, '\p{Scx=newa}', "");
    Expect(1, 70752, '\p{^Scx=newa}', "");
    Expect(1, 70752, '\P{Scx=newa}', "");
    Expect(0, 70752, '\P{^Scx=newa}', "");
    Expect(1, 70751, '\p{Scx=:\Anewa\z:}', "");;
    Expect(0, 70752, '\p{Scx=:\Anewa\z:}', "");;
    Expect(1, 70751, '\p{Scx=	Newa}', "");
    Expect(0, 70751, '\p{^Scx=	Newa}', "");
    Expect(0, 70751, '\P{Scx=	Newa}', "");
    Expect(1, 70751, '\P{^Scx=	Newa}', "");
    Expect(0, 70752, '\p{Scx=	Newa}', "");
    Expect(1, 70752, '\p{^Scx=	Newa}', "");
    Expect(1, 70752, '\P{Scx=	Newa}', "");
    Expect(0, 70752, '\P{^Scx=	Newa}', "");
    Error('\p{Is_Script_Extensions= -Newa/a/}');
    Error('\P{Is_Script_Extensions= -Newa/a/}');
    Expect(1, 70751, '\p{Is_Script_Extensions=newa}', "");
    Expect(0, 70751, '\p{^Is_Script_Extensions=newa}', "");
    Expect(0, 70751, '\P{Is_Script_Extensions=newa}', "");
    Expect(1, 70751, '\P{^Is_Script_Extensions=newa}', "");
    Expect(0, 70752, '\p{Is_Script_Extensions=newa}', "");
    Expect(1, 70752, '\p{^Is_Script_Extensions=newa}', "");
    Expect(1, 70752, '\P{Is_Script_Extensions=newa}', "");
    Expect(0, 70752, '\P{^Is_Script_Extensions=newa}', "");
    Expect(1, 70751, '\p{Is_Script_Extensions=--NEWA}', "");
    Expect(0, 70751, '\p{^Is_Script_Extensions=--NEWA}', "");
    Expect(0, 70751, '\P{Is_Script_Extensions=--NEWA}', "");
    Expect(1, 70751, '\P{^Is_Script_Extensions=--NEWA}', "");
    Expect(0, 70752, '\p{Is_Script_Extensions=--NEWA}', "");
    Expect(1, 70752, '\p{^Is_Script_Extensions=--NEWA}', "");
    Expect(1, 70752, '\P{Is_Script_Extensions=--NEWA}', "");
    Expect(0, 70752, '\P{^Is_Script_Extensions=--NEWA}', "");
    Error('\p{Is_Scx=_:=Newa}');
    Error('\P{Is_Scx=_:=Newa}');
    Expect(1, 70751, '\p{Is_Scx=newa}', "");
    Expect(0, 70751, '\p{^Is_Scx=newa}', "");
    Expect(0, 70751, '\P{Is_Scx=newa}', "");
    Expect(1, 70751, '\P{^Is_Scx=newa}', "");
    Expect(0, 70752, '\p{Is_Scx=newa}', "");
    Expect(1, 70752, '\p{^Is_Scx=newa}', "");
    Expect(1, 70752, '\P{Is_Scx=newa}', "");
    Expect(0, 70752, '\P{^Is_Scx=newa}', "");
    Expect(1, 70751, '\p{Is_Scx:   		NEWA}', "");
    Expect(0, 70751, '\p{^Is_Scx:   		NEWA}', "");
    Expect(0, 70751, '\P{Is_Scx:   		NEWA}', "");
    Expect(1, 70751, '\P{^Is_Scx:   		NEWA}', "");
    Expect(0, 70752, '\p{Is_Scx:   		NEWA}', "");
    Expect(1, 70752, '\p{^Is_Scx:   		NEWA}', "");
    Expect(1, 70752, '\P{Is_Scx:   		NEWA}', "");
    Expect(0, 70752, '\P{^Is_Scx:   		NEWA}', "");
    Error('\p{Script_Extensions:	__Nko/a/}');
    Error('\P{Script_Extensions:	__Nko/a/}');
    Expect(1, 2047, '\p{Script_Extensions=:\ANko\z:}', "");;
    Expect(0, 2048, '\p{Script_Extensions=:\ANko\z:}', "");;
    Expect(1, 2047, '\p{Script_Extensions=nko}', "");
    Expect(0, 2047, '\p{^Script_Extensions=nko}', "");
    Expect(0, 2047, '\P{Script_Extensions=nko}', "");
    Expect(1, 2047, '\P{^Script_Extensions=nko}', "");
    Expect(0, 2048, '\p{Script_Extensions=nko}', "");
    Expect(1, 2048, '\p{^Script_Extensions=nko}', "");
    Expect(1, 2048, '\P{Script_Extensions=nko}', "");
    Expect(0, 2048, '\P{^Script_Extensions=nko}', "");
    Expect(1, 2047, '\p{Script_Extensions=:\Anko\z:}', "");;
    Expect(0, 2048, '\p{Script_Extensions=:\Anko\z:}', "");;
    Expect(1, 2047, '\p{Script_Extensions= -Nko}', "");
    Expect(0, 2047, '\p{^Script_Extensions= -Nko}', "");
    Expect(0, 2047, '\P{Script_Extensions= -Nko}', "");
    Expect(1, 2047, '\P{^Script_Extensions= -Nko}', "");
    Expect(0, 2048, '\p{Script_Extensions= -Nko}', "");
    Expect(1, 2048, '\p{^Script_Extensions= -Nko}', "");
    Expect(1, 2048, '\P{Script_Extensions= -Nko}', "");
    Expect(0, 2048, '\P{^Script_Extensions= -Nko}', "");
    Error('\p{Scx=/a/	_NKOO}');
    Error('\P{Scx=/a/	_NKOO}');
    Expect(1, 2047, '\p{Scx=:\ANkoo\z:}', "");;
    Expect(0, 2048, '\p{Scx=:\ANkoo\z:}', "");;
    Expect(1, 2047, '\p{Scx=nkoo}', "");
    Expect(0, 2047, '\p{^Scx=nkoo}', "");
    Expect(0, 2047, '\P{Scx=nkoo}', "");
    Expect(1, 2047, '\P{^Scx=nkoo}', "");
    Expect(0, 2048, '\p{Scx=nkoo}', "");
    Expect(1, 2048, '\p{^Scx=nkoo}', "");
    Expect(1, 2048, '\P{Scx=nkoo}', "");
    Expect(0, 2048, '\P{^Scx=nkoo}', "");
    Expect(1, 2047, '\p{Scx=:\Ankoo\z:}', "");;
    Expect(0, 2048, '\p{Scx=:\Ankoo\z:}', "");;
    Expect(1, 2047, '\p{Scx=- Nkoo}', "");
    Expect(0, 2047, '\p{^Scx=- Nkoo}', "");
    Expect(0, 2047, '\P{Scx=- Nkoo}', "");
    Expect(1, 2047, '\P{^Scx=- Nkoo}', "");
    Expect(0, 2048, '\p{Scx=- Nkoo}', "");
    Expect(1, 2048, '\p{^Scx=- Nkoo}', "");
    Expect(1, 2048, '\P{Scx=- Nkoo}', "");
    Expect(0, 2048, '\P{^Scx=- Nkoo}', "");
    Error('\p{Is_Script_Extensions=/a/	_Nko}');
    Error('\P{Is_Script_Extensions=/a/	_Nko}');
    Expect(1, 2047, '\p{Is_Script_Extensions=nko}', "");
    Expect(0, 2047, '\p{^Is_Script_Extensions=nko}', "");
    Expect(0, 2047, '\P{Is_Script_Extensions=nko}', "");
    Expect(1, 2047, '\P{^Is_Script_Extensions=nko}', "");
    Expect(0, 2048, '\p{Is_Script_Extensions=nko}', "");
    Expect(1, 2048, '\p{^Is_Script_Extensions=nko}', "");
    Expect(1, 2048, '\P{Is_Script_Extensions=nko}', "");
    Expect(0, 2048, '\P{^Is_Script_Extensions=nko}', "");
    Expect(1, 2047, '\p{Is_Script_Extensions=__Nko}', "");
    Expect(0, 2047, '\p{^Is_Script_Extensions=__Nko}', "");
    Expect(0, 2047, '\P{Is_Script_Extensions=__Nko}', "");
    Expect(1, 2047, '\P{^Is_Script_Extensions=__Nko}', "");
    Expect(0, 2048, '\p{Is_Script_Extensions=__Nko}', "");
    Expect(1, 2048, '\p{^Is_Script_Extensions=__Nko}', "");
    Expect(1, 2048, '\P{Is_Script_Extensions=__Nko}', "");
    Expect(0, 2048, '\P{^Is_Script_Extensions=__Nko}', "");
    Error('\p{Is_Scx=:=nkoo}');
    Error('\P{Is_Scx=:=nkoo}');
    Expect(1, 2047, '\p{Is_Scx=nkoo}', "");
    Expect(0, 2047, '\p{^Is_Scx=nkoo}', "");
    Expect(0, 2047, '\P{Is_Scx=nkoo}', "");
    Expect(1, 2047, '\P{^Is_Scx=nkoo}', "");
    Expect(0, 2048, '\p{Is_Scx=nkoo}', "");
    Expect(1, 2048, '\p{^Is_Scx=nkoo}', "");
    Expect(1, 2048, '\P{Is_Scx=nkoo}', "");
    Expect(0, 2048, '\P{^Is_Scx=nkoo}', "");
    Expect(1, 2047, '\p{Is_Scx:   -	NKOO}', "");
    Expect(0, 2047, '\p{^Is_Scx:   -	NKOO}', "");
    Expect(0, 2047, '\P{Is_Scx:   -	NKOO}', "");
    Expect(1, 2047, '\P{^Is_Scx:   -	NKOO}', "");
    Expect(0, 2048, '\p{Is_Scx:   -	NKOO}', "");
    Expect(1, 2048, '\p{^Is_Scx:   -	NKOO}', "");
    Expect(1, 2048, '\P{Is_Scx:   -	NKOO}', "");
    Expect(0, 2048, '\P{^Is_Scx:   -	NKOO}', "");
    Error('\p{Script_Extensions=:=_	Nushu}');
    Error('\P{Script_Extensions=:=_	Nushu}');
    Expect(1, 111355, '\p{Script_Extensions=:\ANushu\z:}', "");;
    Expect(0, 111356, '\p{Script_Extensions=:\ANushu\z:}', "");;
    Expect(1, 111355, '\p{Script_Extensions=nushu}', "");
    Expect(0, 111355, '\p{^Script_Extensions=nushu}', "");
    Expect(0, 111355, '\P{Script_Extensions=nushu}', "");
    Expect(1, 111355, '\P{^Script_Extensions=nushu}', "");
    Expect(0, 111356, '\p{Script_Extensions=nushu}', "");
    Expect(1, 111356, '\p{^Script_Extensions=nushu}', "");
    Expect(1, 111356, '\P{Script_Extensions=nushu}', "");
    Expect(0, 111356, '\P{^Script_Extensions=nushu}', "");
    Expect(1, 111355, '\p{Script_Extensions=:\Anushu\z:}', "");;
    Expect(0, 111356, '\p{Script_Extensions=:\Anushu\z:}', "");;
    Expect(1, 111355, '\p{Script_Extensions=  NUSHU}', "");
    Expect(0, 111355, '\p{^Script_Extensions=  NUSHU}', "");
    Expect(0, 111355, '\P{Script_Extensions=  NUSHU}', "");
    Expect(1, 111355, '\P{^Script_Extensions=  NUSHU}', "");
    Expect(0, 111356, '\p{Script_Extensions=  NUSHU}', "");
    Expect(1, 111356, '\p{^Script_Extensions=  NUSHU}', "");
    Expect(1, 111356, '\P{Script_Extensions=  NUSHU}', "");
    Expect(0, 111356, '\P{^Script_Extensions=  NUSHU}', "");
    Error('\p{Scx=/a/-	nshu}');
    Error('\P{Scx=/a/-	nshu}');
    Expect(1, 111355, '\p{Scx=:\ANshu\z:}', "");;
    Expect(0, 111356, '\p{Scx=:\ANshu\z:}', "");;
    Expect(1, 111355, '\p{Scx=nshu}', "");
    Expect(0, 111355, '\p{^Scx=nshu}', "");
    Expect(0, 111355, '\P{Scx=nshu}', "");
    Expect(1, 111355, '\P{^Scx=nshu}', "");
    Expect(0, 111356, '\p{Scx=nshu}', "");
    Expect(1, 111356, '\p{^Scx=nshu}', "");
    Expect(1, 111356, '\P{Scx=nshu}', "");
    Expect(0, 111356, '\P{^Scx=nshu}', "");
    Expect(1, 111355, '\p{Scx=:\Anshu\z:}', "");;
    Expect(0, 111356, '\p{Scx=:\Anshu\z:}', "");;
    Expect(1, 111355, '\p{Scx=_-Nshu}', "");
    Expect(0, 111355, '\p{^Scx=_-Nshu}', "");
    Expect(0, 111355, '\P{Scx=_-Nshu}', "");
    Expect(1, 111355, '\P{^Scx=_-Nshu}', "");
    Expect(0, 111356, '\p{Scx=_-Nshu}', "");
    Expect(1, 111356, '\p{^Scx=_-Nshu}', "");
    Expect(1, 111356, '\P{Scx=_-Nshu}', "");
    Expect(0, 111356, '\P{^Scx=_-Nshu}', "");
    Error('\p{Is_Script_Extensions=_/a/Nushu}');
    Error('\P{Is_Script_Extensions=_/a/Nushu}');
    Expect(1, 111355, '\p{Is_Script_Extensions=nushu}', "");
    Expect(0, 111355, '\p{^Is_Script_Extensions=nushu}', "");
    Expect(0, 111355, '\P{Is_Script_Extensions=nushu}', "");
    Expect(1, 111355, '\P{^Is_Script_Extensions=nushu}', "");
    Expect(0, 111356, '\p{Is_Script_Extensions=nushu}', "");
    Expect(1, 111356, '\p{^Is_Script_Extensions=nushu}', "");
    Expect(1, 111356, '\P{Is_Script_Extensions=nushu}', "");
    Expect(0, 111356, '\P{^Is_Script_Extensions=nushu}', "");
    Expect(1, 111355, '\p{Is_Script_Extensions= Nushu}', "");
    Expect(0, 111355, '\p{^Is_Script_Extensions= Nushu}', "");
    Expect(0, 111355, '\P{Is_Script_Extensions= Nushu}', "");
    Expect(1, 111355, '\P{^Is_Script_Extensions= Nushu}', "");
    Expect(0, 111356, '\p{Is_Script_Extensions= Nushu}', "");
    Expect(1, 111356, '\p{^Is_Script_Extensions= Nushu}', "");
    Expect(1, 111356, '\P{Is_Script_Extensions= Nushu}', "");
    Expect(0, 111356, '\P{^Is_Script_Extensions= Nushu}', "");
    Error('\p{Is_Scx=-/a/Nshu}');
    Error('\P{Is_Scx=-/a/Nshu}');
    Expect(1, 111355, '\p{Is_Scx:nshu}', "");
    Expect(0, 111355, '\p{^Is_Scx:nshu}', "");
    Expect(0, 111355, '\P{Is_Scx:nshu}', "");
    Expect(1, 111355, '\P{^Is_Scx:nshu}', "");
    Expect(0, 111356, '\p{Is_Scx:nshu}', "");
    Expect(1, 111356, '\p{^Is_Scx:nshu}', "");
    Expect(1, 111356, '\P{Is_Scx:nshu}', "");
    Expect(0, 111356, '\P{^Is_Scx:nshu}', "");
    Expect(1, 111355, '\p{Is_Scx= Nshu}', "");
    Expect(0, 111355, '\p{^Is_Scx= Nshu}', "");
    Expect(0, 111355, '\P{Is_Scx= Nshu}', "");
    Expect(1, 111355, '\P{^Is_Scx= Nshu}', "");
    Expect(0, 111356, '\p{Is_Scx= Nshu}', "");
    Expect(1, 111356, '\p{^Is_Scx= Nshu}', "");
    Expect(1, 111356, '\P{Is_Scx= Nshu}', "");
    Expect(0, 111356, '\P{^Is_Scx= Nshu}', "");
    Error('\p{Script_Extensions=-/a/OGHAM}');
    Error('\P{Script_Extensions=-/a/OGHAM}');
    Expect(1, 5788, '\p{Script_Extensions=:\AOgham\z:}', "");;
    Expect(0, 5789, '\p{Script_Extensions=:\AOgham\z:}', "");;
    Expect(1, 5788, '\p{Script_Extensions=ogham}', "");
    Expect(0, 5788, '\p{^Script_Extensions=ogham}', "");
    Expect(0, 5788, '\P{Script_Extensions=ogham}', "");
    Expect(1, 5788, '\P{^Script_Extensions=ogham}', "");
    Expect(0, 5789, '\p{Script_Extensions=ogham}', "");
    Expect(1, 5789, '\p{^Script_Extensions=ogham}', "");
    Expect(1, 5789, '\P{Script_Extensions=ogham}', "");
    Expect(0, 5789, '\P{^Script_Extensions=ogham}', "");
    Expect(1, 5788, '\p{Script_Extensions=:\Aogham\z:}', "");;
    Expect(0, 5789, '\p{Script_Extensions=:\Aogham\z:}', "");;
    Expect(1, 5788, '\p{Script_Extensions= Ogham}', "");
    Expect(0, 5788, '\p{^Script_Extensions= Ogham}', "");
    Expect(0, 5788, '\P{Script_Extensions= Ogham}', "");
    Expect(1, 5788, '\P{^Script_Extensions= Ogham}', "");
    Expect(0, 5789, '\p{Script_Extensions= Ogham}', "");
    Expect(1, 5789, '\p{^Script_Extensions= Ogham}', "");
    Expect(1, 5789, '\P{Script_Extensions= Ogham}', "");
    Expect(0, 5789, '\P{^Script_Extensions= Ogham}', "");
    Error('\p{Scx=:=	ogam}');
    Error('\P{Scx=:=	ogam}');
    Expect(1, 5788, '\p{Scx=:\AOgam\z:}', "");;
    Expect(0, 5789, '\p{Scx=:\AOgam\z:}', "");;
    Expect(1, 5788, '\p{Scx=ogam}', "");
    Expect(0, 5788, '\p{^Scx=ogam}', "");
    Expect(0, 5788, '\P{Scx=ogam}', "");
    Expect(1, 5788, '\P{^Scx=ogam}', "");
    Expect(0, 5789, '\p{Scx=ogam}', "");
    Expect(1, 5789, '\p{^Scx=ogam}', "");
    Expect(1, 5789, '\P{Scx=ogam}', "");
    Expect(0, 5789, '\P{^Scx=ogam}', "");
    Expect(1, 5788, '\p{Scx=:\Aogam\z:}', "");;
    Expect(0, 5789, '\p{Scx=:\Aogam\z:}', "");;
    Expect(1, 5788, '\p{Scx=_Ogam}', "");
    Expect(0, 5788, '\p{^Scx=_Ogam}', "");
    Expect(0, 5788, '\P{Scx=_Ogam}', "");
    Expect(1, 5788, '\P{^Scx=_Ogam}', "");
    Expect(0, 5789, '\p{Scx=_Ogam}', "");
    Expect(1, 5789, '\p{^Scx=_Ogam}', "");
    Expect(1, 5789, '\P{Scx=_Ogam}', "");
    Expect(0, 5789, '\P{^Scx=_Ogam}', "");
    Error('\p{Is_Script_Extensions=:=__Ogham}');
    Error('\P{Is_Script_Extensions=:=__Ogham}');
    Expect(1, 5788, '\p{Is_Script_Extensions=ogham}', "");
    Expect(0, 5788, '\p{^Is_Script_Extensions=ogham}', "");
    Expect(0, 5788, '\P{Is_Script_Extensions=ogham}', "");
    Expect(1, 5788, '\P{^Is_Script_Extensions=ogham}', "");
    Expect(0, 5789, '\p{Is_Script_Extensions=ogham}', "");
    Expect(1, 5789, '\p{^Is_Script_Extensions=ogham}', "");
    Expect(1, 5789, '\P{Is_Script_Extensions=ogham}', "");
    Expect(0, 5789, '\P{^Is_Script_Extensions=ogham}', "");
    Expect(1, 5788, '\p{Is_Script_Extensions=-_ogham}', "");
    Expect(0, 5788, '\p{^Is_Script_Extensions=-_ogham}', "");
    Expect(0, 5788, '\P{Is_Script_Extensions=-_ogham}', "");
    Expect(1, 5788, '\P{^Is_Script_Extensions=-_ogham}', "");
    Expect(0, 5789, '\p{Is_Script_Extensions=-_ogham}', "");
    Expect(1, 5789, '\p{^Is_Script_Extensions=-_ogham}', "");
    Expect(1, 5789, '\P{Is_Script_Extensions=-_ogham}', "");
    Expect(0, 5789, '\P{^Is_Script_Extensions=-_ogham}', "");
    Error('\p{Is_Scx=/a/	-ogam}');
    Error('\P{Is_Scx=/a/	-ogam}');
    Expect(1, 5788, '\p{Is_Scx=ogam}', "");
    Expect(0, 5788, '\p{^Is_Scx=ogam}', "");
    Expect(0, 5788, '\P{Is_Scx=ogam}', "");
    Expect(1, 5788, '\P{^Is_Scx=ogam}', "");
    Expect(0, 5789, '\p{Is_Scx=ogam}', "");
    Expect(1, 5789, '\p{^Is_Scx=ogam}', "");
    Expect(1, 5789, '\P{Is_Scx=ogam}', "");
    Expect(0, 5789, '\P{^Is_Scx=ogam}', "");
    Expect(1, 5788, '\p{Is_Scx: __Ogam}', "");
    Expect(0, 5788, '\p{^Is_Scx: __Ogam}', "");
    Expect(0, 5788, '\P{Is_Scx: __Ogam}', "");
    Expect(1, 5788, '\P{^Is_Scx: __Ogam}', "");
    Expect(0, 5789, '\p{Is_Scx: __Ogam}', "");
    Expect(1, 5789, '\p{^Is_Scx: __Ogam}', "");
    Expect(1, 5789, '\P{Is_Scx: __Ogam}', "");
    Expect(0, 5789, '\P{^Is_Scx: __Ogam}', "");
    Error('\p{Script_Extensions=_:=ol_chiki}');
    Error('\P{Script_Extensions=_:=ol_chiki}');
    Expect(1, 7295, '\p{Script_Extensions=:\AOl_Chiki\z:}', "");;
    Expect(0, 7296, '\p{Script_Extensions=:\AOl_Chiki\z:}', "");;
    Expect(1, 7295, '\p{Script_Extensions=olchiki}', "");
    Expect(0, 7295, '\p{^Script_Extensions=olchiki}', "");
    Expect(0, 7295, '\P{Script_Extensions=olchiki}', "");
    Expect(1, 7295, '\P{^Script_Extensions=olchiki}', "");
    Expect(0, 7296, '\p{Script_Extensions=olchiki}', "");
    Expect(1, 7296, '\p{^Script_Extensions=olchiki}', "");
    Expect(1, 7296, '\P{Script_Extensions=olchiki}', "");
    Expect(0, 7296, '\P{^Script_Extensions=olchiki}', "");
    Expect(1, 7295, '\p{Script_Extensions=:\Aolchiki\z:}', "");;
    Expect(0, 7296, '\p{Script_Extensions=:\Aolchiki\z:}', "");;
    Expect(1, 7295, '\p{Script_Extensions=-_OL_CHIKI}', "");
    Expect(0, 7295, '\p{^Script_Extensions=-_OL_CHIKI}', "");
    Expect(0, 7295, '\P{Script_Extensions=-_OL_CHIKI}', "");
    Expect(1, 7295, '\P{^Script_Extensions=-_OL_CHIKI}', "");
    Expect(0, 7296, '\p{Script_Extensions=-_OL_CHIKI}', "");
    Expect(1, 7296, '\p{^Script_Extensions=-_OL_CHIKI}', "");
    Expect(1, 7296, '\P{Script_Extensions=-_OL_CHIKI}', "");
    Expect(0, 7296, '\P{^Script_Extensions=-_OL_CHIKI}', "");
    Error('\p{Scx=_-Olck:=}');
    Error('\P{Scx=_-Olck:=}');
    Expect(1, 7295, '\p{Scx=:\AOlck\z:}', "");;
    Expect(0, 7296, '\p{Scx=:\AOlck\z:}', "");;
    Expect(1, 7295, '\p{Scx=olck}', "");
    Expect(0, 7295, '\p{^Scx=olck}', "");
    Expect(0, 7295, '\P{Scx=olck}', "");
    Expect(1, 7295, '\P{^Scx=olck}', "");
    Expect(0, 7296, '\p{Scx=olck}', "");
    Expect(1, 7296, '\p{^Scx=olck}', "");
    Expect(1, 7296, '\P{Scx=olck}', "");
    Expect(0, 7296, '\P{^Scx=olck}', "");
    Expect(1, 7295, '\p{Scx=:\Aolck\z:}', "");;
    Expect(0, 7296, '\p{Scx=:\Aolck\z:}', "");;
    Expect(1, 7295, '\p{Scx=_-Olck}', "");
    Expect(0, 7295, '\p{^Scx=_-Olck}', "");
    Expect(0, 7295, '\P{Scx=_-Olck}', "");
    Expect(1, 7295, '\P{^Scx=_-Olck}', "");
    Expect(0, 7296, '\p{Scx=_-Olck}', "");
    Expect(1, 7296, '\p{^Scx=_-Olck}', "");
    Expect(1, 7296, '\P{Scx=_-Olck}', "");
    Expect(0, 7296, '\P{^Scx=_-Olck}', "");
    Error('\p{Is_Script_Extensions=_:=Ol_CHIKI}');
    Error('\P{Is_Script_Extensions=_:=Ol_CHIKI}');
    Expect(1, 7295, '\p{Is_Script_Extensions=olchiki}', "");
    Expect(0, 7295, '\p{^Is_Script_Extensions=olchiki}', "");
    Expect(0, 7295, '\P{Is_Script_Extensions=olchiki}', "");
    Expect(1, 7295, '\P{^Is_Script_Extensions=olchiki}', "");
    Expect(0, 7296, '\p{Is_Script_Extensions=olchiki}', "");
    Expect(1, 7296, '\p{^Is_Script_Extensions=olchiki}', "");
    Expect(1, 7296, '\P{Is_Script_Extensions=olchiki}', "");
    Expect(0, 7296, '\P{^Is_Script_Extensions=olchiki}', "");
    Expect(1, 7295, '\p{Is_Script_Extensions=-_Ol_CHIKI}', "");
    Expect(0, 7295, '\p{^Is_Script_Extensions=-_Ol_CHIKI}', "");
    Expect(0, 7295, '\P{Is_Script_Extensions=-_Ol_CHIKI}', "");
    Expect(1, 7295, '\P{^Is_Script_Extensions=-_Ol_CHIKI}', "");
    Expect(0, 7296, '\p{Is_Script_Extensions=-_Ol_CHIKI}', "");
    Expect(1, 7296, '\p{^Is_Script_Extensions=-_Ol_CHIKI}', "");
    Expect(1, 7296, '\P{Is_Script_Extensions=-_Ol_CHIKI}', "");
    Expect(0, 7296, '\P{^Is_Script_Extensions=-_Ol_CHIKI}', "");
    Error('\p{Is_Scx:   -Olck/a/}');
    Error('\P{Is_Scx:   -Olck/a/}');
    Expect(1, 7295, '\p{Is_Scx=olck}', "");
    Expect(0, 7295, '\p{^Is_Scx=olck}', "");
    Expect(0, 7295, '\P{Is_Scx=olck}', "");
    Expect(1, 7295, '\P{^Is_Scx=olck}', "");
    Expect(0, 7296, '\p{Is_Scx=olck}', "");
    Expect(1, 7296, '\p{^Is_Scx=olck}', "");
    Expect(1, 7296, '\P{Is_Scx=olck}', "");
    Expect(0, 7296, '\P{^Is_Scx=olck}', "");
    Expect(1, 7295, '\p{Is_Scx=	_olck}', "");
    Expect(0, 7295, '\p{^Is_Scx=	_olck}', "");
    Expect(0, 7295, '\P{Is_Scx=	_olck}', "");
    Expect(1, 7295, '\P{^Is_Scx=	_olck}', "");
    Expect(0, 7296, '\p{Is_Scx=	_olck}', "");
    Expect(1, 7296, '\p{^Is_Scx=	_olck}', "");
    Expect(1, 7296, '\P{Is_Scx=	_olck}', "");
    Expect(0, 7296, '\P{^Is_Scx=	_olck}', "");
    Error('\p{Script_Extensions=/a/- Old_Turkic}');
    Error('\P{Script_Extensions=/a/- Old_Turkic}');
    Expect(1, 68680, '\p{Script_Extensions=:\AOld_Turkic\z:}', "");;
    Expect(0, 68681, '\p{Script_Extensions=:\AOld_Turkic\z:}', "");;
    Expect(1, 68680, '\p{Script_Extensions=oldturkic}', "");
    Expect(0, 68680, '\p{^Script_Extensions=oldturkic}', "");
    Expect(0, 68680, '\P{Script_Extensions=oldturkic}', "");
    Expect(1, 68680, '\P{^Script_Extensions=oldturkic}', "");
    Expect(0, 68681, '\p{Script_Extensions=oldturkic}', "");
    Expect(1, 68681, '\p{^Script_Extensions=oldturkic}', "");
    Expect(1, 68681, '\P{Script_Extensions=oldturkic}', "");
    Expect(0, 68681, '\P{^Script_Extensions=oldturkic}', "");
    Expect(1, 68680, '\p{Script_Extensions=:\Aoldturkic\z:}', "");;
    Expect(0, 68681, '\p{Script_Extensions=:\Aoldturkic\z:}', "");;
    Expect(1, 68680, '\p{Script_Extensions= old_turkic}', "");
    Expect(0, 68680, '\p{^Script_Extensions= old_turkic}', "");
    Expect(0, 68680, '\P{Script_Extensions= old_turkic}', "");
    Expect(1, 68680, '\P{^Script_Extensions= old_turkic}', "");
    Expect(0, 68681, '\p{Script_Extensions= old_turkic}', "");
    Expect(1, 68681, '\p{^Script_Extensions= old_turkic}', "");
    Expect(1, 68681, '\P{Script_Extensions= old_turkic}', "");
    Expect(0, 68681, '\P{^Script_Extensions= old_turkic}', "");
    Error('\p{Scx=	_Orkh/a/}');
    Error('\P{Scx=	_Orkh/a/}');
    Expect(1, 68680, '\p{Scx=:\AOrkh\z:}', "");;
    Expect(0, 68681, '\p{Scx=:\AOrkh\z:}', "");;
    Expect(1, 68680, '\p{Scx=orkh}', "");
    Expect(0, 68680, '\p{^Scx=orkh}', "");
    Expect(0, 68680, '\P{Scx=orkh}', "");
    Expect(1, 68680, '\P{^Scx=orkh}', "");
    Expect(0, 68681, '\p{Scx=orkh}', "");
    Expect(1, 68681, '\p{^Scx=orkh}', "");
    Expect(1, 68681, '\P{Scx=orkh}', "");
    Expect(0, 68681, '\P{^Scx=orkh}', "");
    Expect(1, 68680, '\p{Scx=:\Aorkh\z:}', "");;
    Expect(0, 68681, '\p{Scx=:\Aorkh\z:}', "");;
    Expect(1, 68680, '\p{Scx=		ORKH}', "");
    Expect(0, 68680, '\p{^Scx=		ORKH}', "");
    Expect(0, 68680, '\P{Scx=		ORKH}', "");
    Expect(1, 68680, '\P{^Scx=		ORKH}', "");
    Expect(0, 68681, '\p{Scx=		ORKH}', "");
    Expect(1, 68681, '\p{^Scx=		ORKH}', "");
    Expect(1, 68681, '\P{Scx=		ORKH}', "");
    Expect(0, 68681, '\P{^Scx=		ORKH}', "");
    Error('\p{Is_Script_Extensions=:=	old_Turkic}');
    Error('\P{Is_Script_Extensions=:=	old_Turkic}');
    Expect(1, 68680, '\p{Is_Script_Extensions=oldturkic}', "");
    Expect(0, 68680, '\p{^Is_Script_Extensions=oldturkic}', "");
    Expect(0, 68680, '\P{Is_Script_Extensions=oldturkic}', "");
    Expect(1, 68680, '\P{^Is_Script_Extensions=oldturkic}', "");
    Expect(0, 68681, '\p{Is_Script_Extensions=oldturkic}', "");
    Expect(1, 68681, '\p{^Is_Script_Extensions=oldturkic}', "");
    Expect(1, 68681, '\P{Is_Script_Extensions=oldturkic}', "");
    Expect(0, 68681, '\P{^Is_Script_Extensions=oldturkic}', "");
    Expect(1, 68680, '\p{Is_Script_Extensions=-OLD_turkic}', "");
    Expect(0, 68680, '\p{^Is_Script_Extensions=-OLD_turkic}', "");
    Expect(0, 68680, '\P{Is_Script_Extensions=-OLD_turkic}', "");
    Expect(1, 68680, '\P{^Is_Script_Extensions=-OLD_turkic}', "");
    Expect(0, 68681, '\p{Is_Script_Extensions=-OLD_turkic}', "");
    Expect(1, 68681, '\p{^Is_Script_Extensions=-OLD_turkic}', "");
    Expect(1, 68681, '\P{Is_Script_Extensions=-OLD_turkic}', "");
    Expect(0, 68681, '\P{^Is_Script_Extensions=-OLD_turkic}', "");
    Error('\p{Is_Scx=:=--orkh}');
    Error('\P{Is_Scx=:=--orkh}');
    Expect(1, 68680, '\p{Is_Scx=orkh}', "");
    Expect(0, 68680, '\p{^Is_Scx=orkh}', "");
    Expect(0, 68680, '\P{Is_Scx=orkh}', "");
    Expect(1, 68680, '\P{^Is_Scx=orkh}', "");
    Expect(0, 68681, '\p{Is_Scx=orkh}', "");
    Expect(1, 68681, '\p{^Is_Scx=orkh}', "");
    Expect(1, 68681, '\P{Is_Scx=orkh}', "");
    Expect(0, 68681, '\P{^Is_Scx=orkh}', "");
    Expect(1, 68680, '\p{Is_Scx=  Orkh}', "");
    Expect(0, 68680, '\p{^Is_Scx=  Orkh}', "");
    Expect(0, 68680, '\P{Is_Scx=  Orkh}', "");
    Expect(1, 68680, '\P{^Is_Scx=  Orkh}', "");
    Expect(0, 68681, '\p{Is_Scx=  Orkh}', "");
    Expect(1, 68681, '\p{^Is_Scx=  Orkh}', "");
    Expect(1, 68681, '\P{Is_Scx=  Orkh}', "");
    Expect(0, 68681, '\P{^Is_Scx=  Orkh}', "");
    Error('\p{Script_Extensions=		ORIYA:=}');
    Error('\P{Script_Extensions=		ORIYA:=}');
    Expect(1, 7410, '\p{Script_Extensions=:\AOriya\z:}', "");;
    Expect(0, 7411, '\p{Script_Extensions=:\AOriya\z:}', "");;
    Expect(1, 7410, '\p{Script_Extensions=oriya}', "");
    Expect(0, 7410, '\p{^Script_Extensions=oriya}', "");
    Expect(0, 7410, '\P{Script_Extensions=oriya}', "");
    Expect(1, 7410, '\P{^Script_Extensions=oriya}', "");
    Expect(0, 7411, '\p{Script_Extensions=oriya}', "");
    Expect(1, 7411, '\p{^Script_Extensions=oriya}', "");
    Expect(1, 7411, '\P{Script_Extensions=oriya}', "");
    Expect(0, 7411, '\P{^Script_Extensions=oriya}', "");
    Expect(1, 7410, '\p{Script_Extensions=:\Aoriya\z:}', "");;
    Expect(0, 7411, '\p{Script_Extensions=:\Aoriya\z:}', "");;
    Expect(1, 7410, '\p{Script_Extensions=		Oriya}', "");
    Expect(0, 7410, '\p{^Script_Extensions=		Oriya}', "");
    Expect(0, 7410, '\P{Script_Extensions=		Oriya}', "");
    Expect(1, 7410, '\P{^Script_Extensions=		Oriya}', "");
    Expect(0, 7411, '\p{Script_Extensions=		Oriya}', "");
    Expect(1, 7411, '\p{^Script_Extensions=		Oriya}', "");
    Expect(1, 7411, '\P{Script_Extensions=		Oriya}', "");
    Expect(0, 7411, '\P{^Script_Extensions=		Oriya}', "");
    Error('\p{Scx= 	orya/a/}');
    Error('\P{Scx= 	orya/a/}');
    Expect(1, 7410, '\p{Scx=:\AOrya\z:}', "");;
    Expect(0, 7411, '\p{Scx=:\AOrya\z:}', "");;
    Expect(1, 7410, '\p{Scx=orya}', "");
    Expect(0, 7410, '\p{^Scx=orya}', "");
    Expect(0, 7410, '\P{Scx=orya}', "");
    Expect(1, 7410, '\P{^Scx=orya}', "");
    Expect(0, 7411, '\p{Scx=orya}', "");
    Expect(1, 7411, '\p{^Scx=orya}', "");
    Expect(1, 7411, '\P{Scx=orya}', "");
    Expect(0, 7411, '\P{^Scx=orya}', "");
    Expect(1, 7410, '\p{Scx=:\Aorya\z:}', "");;
    Expect(0, 7411, '\p{Scx=:\Aorya\z:}', "");;
    Expect(1, 7410, '\p{Scx=	orya}', "");
    Expect(0, 7410, '\p{^Scx=	orya}', "");
    Expect(0, 7410, '\P{Scx=	orya}', "");
    Expect(1, 7410, '\P{^Scx=	orya}', "");
    Expect(0, 7411, '\p{Scx=	orya}', "");
    Expect(1, 7411, '\p{^Scx=	orya}', "");
    Expect(1, 7411, '\P{Scx=	orya}', "");
    Expect(0, 7411, '\P{^Scx=	orya}', "");
    Error('\p{Is_Script_Extensions=		Oriya/a/}');
    Error('\P{Is_Script_Extensions=		Oriya/a/}');
    Expect(1, 7410, '\p{Is_Script_Extensions=oriya}', "");
    Expect(0, 7410, '\p{^Is_Script_Extensions=oriya}', "");
    Expect(0, 7410, '\P{Is_Script_Extensions=oriya}', "");
    Expect(1, 7410, '\P{^Is_Script_Extensions=oriya}', "");
    Expect(0, 7411, '\p{Is_Script_Extensions=oriya}', "");
    Expect(1, 7411, '\p{^Is_Script_Extensions=oriya}', "");
    Expect(1, 7411, '\P{Is_Script_Extensions=oriya}', "");
    Expect(0, 7411, '\P{^Is_Script_Extensions=oriya}', "");
    Expect(1, 7410, '\p{Is_Script_Extensions=Oriya}', "");
    Expect(0, 7410, '\p{^Is_Script_Extensions=Oriya}', "");
    Expect(0, 7410, '\P{Is_Script_Extensions=Oriya}', "");
    Expect(1, 7410, '\P{^Is_Script_Extensions=Oriya}', "");
    Expect(0, 7411, '\p{Is_Script_Extensions=Oriya}', "");
    Expect(1, 7411, '\p{^Is_Script_Extensions=Oriya}', "");
    Expect(1, 7411, '\P{Is_Script_Extensions=Oriya}', "");
    Expect(0, 7411, '\P{^Is_Script_Extensions=Oriya}', "");
    Error('\p{Is_Scx= orya/a/}');
    Error('\P{Is_Scx= orya/a/}');
    Expect(1, 7410, '\p{Is_Scx=orya}', "");
    Expect(0, 7410, '\p{^Is_Scx=orya}', "");
    Expect(0, 7410, '\P{Is_Scx=orya}', "");
    Expect(1, 7410, '\P{^Is_Scx=orya}', "");
    Expect(0, 7411, '\p{Is_Scx=orya}', "");
    Expect(1, 7411, '\p{^Is_Scx=orya}', "");
    Expect(1, 7411, '\P{Is_Scx=orya}', "");
    Expect(0, 7411, '\P{^Is_Scx=orya}', "");
    Expect(1, 7410, '\p{Is_Scx=  orya}', "");
    Expect(0, 7410, '\p{^Is_Scx=  orya}', "");
    Expect(0, 7410, '\P{Is_Scx=  orya}', "");
    Expect(1, 7410, '\P{^Is_Scx=  orya}', "");
    Expect(0, 7411, '\p{Is_Scx=  orya}', "");
    Expect(1, 7411, '\p{^Is_Scx=  orya}', "");
    Expect(1, 7411, '\P{Is_Scx=  orya}', "");
    Expect(0, 7411, '\P{^Is_Scx=  orya}', "");
    Error('\p{Script_Extensions=_Osage/a/}');
    Error('\P{Script_Extensions=_Osage/a/}');
    Expect(1, 66811, '\p{Script_Extensions=:\AOsage\z:}', "");;
    Expect(0, 66812, '\p{Script_Extensions=:\AOsage\z:}', "");;
    Expect(1, 66811, '\p{Script_Extensions=osage}', "");
    Expect(0, 66811, '\p{^Script_Extensions=osage}', "");
    Expect(0, 66811, '\P{Script_Extensions=osage}', "");
    Expect(1, 66811, '\P{^Script_Extensions=osage}', "");
    Expect(0, 66812, '\p{Script_Extensions=osage}', "");
    Expect(1, 66812, '\p{^Script_Extensions=osage}', "");
    Expect(1, 66812, '\P{Script_Extensions=osage}', "");
    Expect(0, 66812, '\P{^Script_Extensions=osage}', "");
    Expect(1, 66811, '\p{Script_Extensions=:\Aosage\z:}', "");;
    Expect(0, 66812, '\p{Script_Extensions=:\Aosage\z:}', "");;
    Expect(1, 66811, '\p{Script_Extensions=-_Osage}', "");
    Expect(0, 66811, '\p{^Script_Extensions=-_Osage}', "");
    Expect(0, 66811, '\P{Script_Extensions=-_Osage}', "");
    Expect(1, 66811, '\P{^Script_Extensions=-_Osage}', "");
    Expect(0, 66812, '\p{Script_Extensions=-_Osage}', "");
    Expect(1, 66812, '\p{^Script_Extensions=-_Osage}', "");
    Expect(1, 66812, '\P{Script_Extensions=-_Osage}', "");
    Expect(0, 66812, '\P{^Script_Extensions=-_Osage}', "");
    Error('\p{Scx=/a/	-OSGE}');
    Error('\P{Scx=/a/	-OSGE}');
    Expect(1, 66811, '\p{Scx=:\AOsge\z:}', "");;
    Expect(0, 66812, '\p{Scx=:\AOsge\z:}', "");;
    Expect(1, 66811, '\p{Scx=osge}', "");
    Expect(0, 66811, '\p{^Scx=osge}', "");
    Expect(0, 66811, '\P{Scx=osge}', "");
    Expect(1, 66811, '\P{^Scx=osge}', "");
    Expect(0, 66812, '\p{Scx=osge}', "");
    Expect(1, 66812, '\p{^Scx=osge}', "");
    Expect(1, 66812, '\P{Scx=osge}', "");
    Expect(0, 66812, '\P{^Scx=osge}', "");
    Expect(1, 66811, '\p{Scx=:\Aosge\z:}', "");;
    Expect(0, 66812, '\p{Scx=:\Aosge\z:}', "");;
    Expect(1, 66811, '\p{Scx=	_OSGE}', "");
    Expect(0, 66811, '\p{^Scx=	_OSGE}', "");
    Expect(0, 66811, '\P{Scx=	_OSGE}', "");
    Expect(1, 66811, '\P{^Scx=	_OSGE}', "");
    Expect(0, 66812, '\p{Scx=	_OSGE}', "");
    Expect(1, 66812, '\p{^Scx=	_OSGE}', "");
    Expect(1, 66812, '\P{Scx=	_OSGE}', "");
    Expect(0, 66812, '\P{^Scx=	_OSGE}', "");
    Error('\p{Is_Script_Extensions=_:=OSAGE}');
    Error('\P{Is_Script_Extensions=_:=OSAGE}');
    Expect(1, 66811, '\p{Is_Script_Extensions=osage}', "");
    Expect(0, 66811, '\p{^Is_Script_Extensions=osage}', "");
    Expect(0, 66811, '\P{Is_Script_Extensions=osage}', "");
    Expect(1, 66811, '\P{^Is_Script_Extensions=osage}', "");
    Expect(0, 66812, '\p{Is_Script_Extensions=osage}', "");
    Expect(1, 66812, '\p{^Is_Script_Extensions=osage}', "");
    Expect(1, 66812, '\P{Is_Script_Extensions=osage}', "");
    Expect(0, 66812, '\P{^Is_Script_Extensions=osage}', "");
    Expect(1, 66811, '\p{Is_Script_Extensions=-Osage}', "");
    Expect(0, 66811, '\p{^Is_Script_Extensions=-Osage}', "");
    Expect(0, 66811, '\P{Is_Script_Extensions=-Osage}', "");
    Expect(1, 66811, '\P{^Is_Script_Extensions=-Osage}', "");
    Expect(0, 66812, '\p{Is_Script_Extensions=-Osage}', "");
    Expect(1, 66812, '\p{^Is_Script_Extensions=-Osage}', "");
    Expect(1, 66812, '\P{Is_Script_Extensions=-Osage}', "");
    Expect(0, 66812, '\P{^Is_Script_Extensions=-Osage}', "");
    Error('\p{Is_Scx=:= osge}');
    Error('\P{Is_Scx=:= osge}');
    Expect(1, 66811, '\p{Is_Scx=osge}', "");
    Expect(0, 66811, '\p{^Is_Scx=osge}', "");
    Expect(0, 66811, '\P{Is_Scx=osge}', "");
    Expect(1, 66811, '\P{^Is_Scx=osge}', "");
    Expect(0, 66812, '\p{Is_Scx=osge}', "");
    Expect(1, 66812, '\p{^Is_Scx=osge}', "");
    Expect(1, 66812, '\P{Is_Scx=osge}', "");
    Expect(0, 66812, '\P{^Is_Scx=osge}', "");
    Expect(1, 66811, '\p{Is_Scx=-_Osge}', "");
    Expect(0, 66811, '\p{^Is_Scx=-_Osge}', "");
    Expect(0, 66811, '\P{Is_Scx=-_Osge}', "");
    Expect(1, 66811, '\P{^Is_Scx=-_Osge}', "");
    Expect(0, 66812, '\p{Is_Scx=-_Osge}', "");
    Expect(1, 66812, '\p{^Is_Scx=-_Osge}', "");
    Expect(1, 66812, '\P{Is_Scx=-_Osge}', "");
    Expect(0, 66812, '\P{^Is_Scx=-_Osge}', "");
    Error('\p{Script_Extensions=--osmanya:=}');
    Error('\P{Script_Extensions=--osmanya:=}');
    Expect(1, 66729, '\p{Script_Extensions=:\AOsmanya\z:}', "");;
    Expect(0, 66730, '\p{Script_Extensions=:\AOsmanya\z:}', "");;
    Expect(1, 66729, '\p{Script_Extensions=osmanya}', "");
    Expect(0, 66729, '\p{^Script_Extensions=osmanya}', "");
    Expect(0, 66729, '\P{Script_Extensions=osmanya}', "");
    Expect(1, 66729, '\P{^Script_Extensions=osmanya}', "");
    Expect(0, 66730, '\p{Script_Extensions=osmanya}', "");
    Expect(1, 66730, '\p{^Script_Extensions=osmanya}', "");
    Expect(1, 66730, '\P{Script_Extensions=osmanya}', "");
    Expect(0, 66730, '\P{^Script_Extensions=osmanya}', "");
    Expect(1, 66729, '\p{Script_Extensions=:\Aosmanya\z:}', "");;
    Expect(0, 66730, '\p{Script_Extensions=:\Aosmanya\z:}', "");;
    Expect(1, 66729, '\p{Script_Extensions=_	OSMANYA}', "");
    Expect(0, 66729, '\p{^Script_Extensions=_	OSMANYA}', "");
    Expect(0, 66729, '\P{Script_Extensions=_	OSMANYA}', "");
    Expect(1, 66729, '\P{^Script_Extensions=_	OSMANYA}', "");
    Expect(0, 66730, '\p{Script_Extensions=_	OSMANYA}', "");
    Expect(1, 66730, '\p{^Script_Extensions=_	OSMANYA}', "");
    Expect(1, 66730, '\P{Script_Extensions=_	OSMANYA}', "");
    Expect(0, 66730, '\P{^Script_Extensions=_	OSMANYA}', "");
    Error('\p{Scx: :=	_Osma}');
    Error('\P{Scx: :=	_Osma}');
    Expect(1, 66729, '\p{Scx=:\AOsma\z:}', "");;
    Expect(0, 66730, '\p{Scx=:\AOsma\z:}', "");;
    Expect(1, 66729, '\p{Scx=osma}', "");
    Expect(0, 66729, '\p{^Scx=osma}', "");
    Expect(0, 66729, '\P{Scx=osma}', "");
    Expect(1, 66729, '\P{^Scx=osma}', "");
    Expect(0, 66730, '\p{Scx=osma}', "");
    Expect(1, 66730, '\p{^Scx=osma}', "");
    Expect(1, 66730, '\P{Scx=osma}', "");
    Expect(0, 66730, '\P{^Scx=osma}', "");
    Expect(1, 66729, '\p{Scx=:\Aosma\z:}', "");;
    Expect(0, 66730, '\p{Scx=:\Aosma\z:}', "");;
    Expect(1, 66729, '\p{Scx= _OSMA}', "");
    Expect(0, 66729, '\p{^Scx= _OSMA}', "");
    Expect(0, 66729, '\P{Scx= _OSMA}', "");
    Expect(1, 66729, '\P{^Scx= _OSMA}', "");
    Expect(0, 66730, '\p{Scx= _OSMA}', "");
    Expect(1, 66730, '\p{^Scx= _OSMA}', "");
    Expect(1, 66730, '\P{Scx= _OSMA}', "");
    Expect(0, 66730, '\P{^Scx= _OSMA}', "");
    Error('\p{Is_Script_Extensions=  osmanya:=}');
    Error('\P{Is_Script_Extensions=  osmanya:=}');
    Expect(1, 66729, '\p{Is_Script_Extensions: osmanya}', "");
    Expect(0, 66729, '\p{^Is_Script_Extensions: osmanya}', "");
    Expect(0, 66729, '\P{Is_Script_Extensions: osmanya}', "");
    Expect(1, 66729, '\P{^Is_Script_Extensions: osmanya}', "");
    Expect(0, 66730, '\p{Is_Script_Extensions: osmanya}', "");
    Expect(1, 66730, '\p{^Is_Script_Extensions: osmanya}', "");
    Expect(1, 66730, '\P{Is_Script_Extensions: osmanya}', "");
    Expect(0, 66730, '\P{^Is_Script_Extensions: osmanya}', "");
    Expect(1, 66729, '\p{Is_Script_Extensions= 	Osmanya}', "");
    Expect(0, 66729, '\p{^Is_Script_Extensions= 	Osmanya}', "");
    Expect(0, 66729, '\P{Is_Script_Extensions= 	Osmanya}', "");
    Expect(1, 66729, '\P{^Is_Script_Extensions= 	Osmanya}', "");
    Expect(0, 66730, '\p{Is_Script_Extensions= 	Osmanya}', "");
    Expect(1, 66730, '\p{^Is_Script_Extensions= 	Osmanya}', "");
    Expect(1, 66730, '\P{Is_Script_Extensions= 	Osmanya}', "");
    Expect(0, 66730, '\P{^Is_Script_Extensions= 	Osmanya}', "");
    Error('\p{Is_Scx= /a/Osma}');
    Error('\P{Is_Scx= /a/Osma}');
    Expect(1, 66729, '\p{Is_Scx=osma}', "");
    Expect(0, 66729, '\p{^Is_Scx=osma}', "");
    Expect(0, 66729, '\P{Is_Scx=osma}', "");
    Expect(1, 66729, '\P{^Is_Scx=osma}', "");
    Expect(0, 66730, '\p{Is_Scx=osma}', "");
    Expect(1, 66730, '\p{^Is_Scx=osma}', "");
    Expect(1, 66730, '\P{Is_Scx=osma}', "");
    Expect(0, 66730, '\P{^Is_Scx=osma}', "");
    Expect(1, 66729, '\p{Is_Scx= osma}', "");
    Expect(0, 66729, '\p{^Is_Scx= osma}', "");
    Expect(0, 66729, '\P{Is_Scx= osma}', "");
    Expect(1, 66729, '\P{^Is_Scx= osma}', "");
    Expect(0, 66730, '\p{Is_Scx= osma}', "");
    Expect(1, 66730, '\p{^Is_Scx= osma}', "");
    Expect(1, 66730, '\P{Is_Scx= osma}', "");
    Expect(0, 66730, '\P{^Is_Scx= osma}', "");
    Error('\p{Script_Extensions=/a/_-Palmyrene}');
    Error('\P{Script_Extensions=/a/_-Palmyrene}');
    Expect(1, 67711, '\p{Script_Extensions=:\APalmyrene\z:}', "");;
    Expect(0, 67712, '\p{Script_Extensions=:\APalmyrene\z:}', "");;
    Expect(1, 67711, '\p{Script_Extensions=palmyrene}', "");
    Expect(0, 67711, '\p{^Script_Extensions=palmyrene}', "");
    Expect(0, 67711, '\P{Script_Extensions=palmyrene}', "");
    Expect(1, 67711, '\P{^Script_Extensions=palmyrene}', "");
    Expect(0, 67712, '\p{Script_Extensions=palmyrene}', "");
    Expect(1, 67712, '\p{^Script_Extensions=palmyrene}', "");
    Expect(1, 67712, '\P{Script_Extensions=palmyrene}', "");
    Expect(0, 67712, '\P{^Script_Extensions=palmyrene}', "");
    Expect(1, 67711, '\p{Script_Extensions=:\Apalmyrene\z:}', "");;
    Expect(0, 67712, '\p{Script_Extensions=:\Apalmyrene\z:}', "");;
    Expect(1, 67711, '\p{Script_Extensions=  Palmyrene}', "");
    Expect(0, 67711, '\p{^Script_Extensions=  Palmyrene}', "");
    Expect(0, 67711, '\P{Script_Extensions=  Palmyrene}', "");
    Expect(1, 67711, '\P{^Script_Extensions=  Palmyrene}', "");
    Expect(0, 67712, '\p{Script_Extensions=  Palmyrene}', "");
    Expect(1, 67712, '\p{^Script_Extensions=  Palmyrene}', "");
    Expect(1, 67712, '\P{Script_Extensions=  Palmyrene}', "");
    Expect(0, 67712, '\P{^Script_Extensions=  Palmyrene}', "");
    Error('\p{Scx:_	PALM/a/}');
    Error('\P{Scx:_	PALM/a/}');
    Expect(1, 67711, '\p{Scx=:\APalm\z:}', "");;
    Expect(0, 67712, '\p{Scx=:\APalm\z:}', "");;
    Expect(1, 67711, '\p{Scx=palm}', "");
    Expect(0, 67711, '\p{^Scx=palm}', "");
    Expect(0, 67711, '\P{Scx=palm}', "");
    Expect(1, 67711, '\P{^Scx=palm}', "");
    Expect(0, 67712, '\p{Scx=palm}', "");
    Expect(1, 67712, '\p{^Scx=palm}', "");
    Expect(1, 67712, '\P{Scx=palm}', "");
    Expect(0, 67712, '\P{^Scx=palm}', "");
    Expect(1, 67711, '\p{Scx=:\Apalm\z:}', "");;
    Expect(0, 67712, '\p{Scx=:\Apalm\z:}', "");;
    Expect(1, 67711, '\p{Scx= Palm}', "");
    Expect(0, 67711, '\p{^Scx= Palm}', "");
    Expect(0, 67711, '\P{Scx= Palm}', "");
    Expect(1, 67711, '\P{^Scx= Palm}', "");
    Expect(0, 67712, '\p{Scx= Palm}', "");
    Expect(1, 67712, '\p{^Scx= Palm}', "");
    Expect(1, 67712, '\P{Scx= Palm}', "");
    Expect(0, 67712, '\P{^Scx= Palm}', "");
    Error('\p{Is_Script_Extensions=-	PALMYRENE:=}');
    Error('\P{Is_Script_Extensions=-	PALMYRENE:=}');
    Expect(1, 67711, '\p{Is_Script_Extensions=palmyrene}', "");
    Expect(0, 67711, '\p{^Is_Script_Extensions=palmyrene}', "");
    Expect(0, 67711, '\P{Is_Script_Extensions=palmyrene}', "");
    Expect(1, 67711, '\P{^Is_Script_Extensions=palmyrene}', "");
    Expect(0, 67712, '\p{Is_Script_Extensions=palmyrene}', "");
    Expect(1, 67712, '\p{^Is_Script_Extensions=palmyrene}', "");
    Expect(1, 67712, '\P{Is_Script_Extensions=palmyrene}', "");
    Expect(0, 67712, '\P{^Is_Script_Extensions=palmyrene}', "");
    Expect(1, 67711, '\p{Is_Script_Extensions=-_PALMYRENE}', "");
    Expect(0, 67711, '\p{^Is_Script_Extensions=-_PALMYRENE}', "");
    Expect(0, 67711, '\P{Is_Script_Extensions=-_PALMYRENE}', "");
    Expect(1, 67711, '\P{^Is_Script_Extensions=-_PALMYRENE}', "");
    Expect(0, 67712, '\p{Is_Script_Extensions=-_PALMYRENE}', "");
    Expect(1, 67712, '\p{^Is_Script_Extensions=-_PALMYRENE}', "");
    Expect(1, 67712, '\P{Is_Script_Extensions=-_PALMYRENE}', "");
    Expect(0, 67712, '\P{^Is_Script_Extensions=-_PALMYRENE}', "");
    Error('\p{Is_Scx=-/a/palm}');
    Error('\P{Is_Scx=-/a/palm}');
    Expect(1, 67711, '\p{Is_Scx=palm}', "");
    Expect(0, 67711, '\p{^Is_Scx=palm}', "");
    Expect(0, 67711, '\P{Is_Scx=palm}', "");
    Expect(1, 67711, '\P{^Is_Scx=palm}', "");
    Expect(0, 67712, '\p{Is_Scx=palm}', "");
    Expect(1, 67712, '\p{^Is_Scx=palm}', "");
    Expect(1, 67712, '\P{Is_Scx=palm}', "");
    Expect(0, 67712, '\P{^Is_Scx=palm}', "");
    Expect(1, 67711, '\p{Is_Scx=_	palm}', "");
    Expect(0, 67711, '\p{^Is_Scx=_	palm}', "");
    Expect(0, 67711, '\P{Is_Scx=_	palm}', "");
    Expect(1, 67711, '\P{^Is_Scx=_	palm}', "");
    Expect(0, 67712, '\p{Is_Scx=_	palm}', "");
    Expect(1, 67712, '\p{^Is_Scx=_	palm}', "");
    Expect(1, 67712, '\P{Is_Scx=_	palm}', "");
    Expect(0, 67712, '\P{^Is_Scx=_	palm}', "");
    Error('\p{Script_Extensions=	-Pau_Cin_hau/a/}');
    Error('\P{Script_Extensions=	-Pau_Cin_hau/a/}');
    Expect(1, 72440, '\p{Script_Extensions=:\APau_Cin_Hau\z:}', "");;
    Expect(0, 72441, '\p{Script_Extensions=:\APau_Cin_Hau\z:}', "");;
    Expect(1, 72440, '\p{Script_Extensions=paucinhau}', "");
    Expect(0, 72440, '\p{^Script_Extensions=paucinhau}', "");
    Expect(0, 72440, '\P{Script_Extensions=paucinhau}', "");
    Expect(1, 72440, '\P{^Script_Extensions=paucinhau}', "");
    Expect(0, 72441, '\p{Script_Extensions=paucinhau}', "");
    Expect(1, 72441, '\p{^Script_Extensions=paucinhau}', "");
    Expect(1, 72441, '\P{Script_Extensions=paucinhau}', "");
    Expect(0, 72441, '\P{^Script_Extensions=paucinhau}', "");
    Expect(1, 72440, '\p{Script_Extensions=:\Apaucinhau\z:}', "");;
    Expect(0, 72441, '\p{Script_Extensions=:\Apaucinhau\z:}', "");;
    Expect(1, 72440, '\p{Script_Extensions= -PAU_cin_hau}', "");
    Expect(0, 72440, '\p{^Script_Extensions= -PAU_cin_hau}', "");
    Expect(0, 72440, '\P{Script_Extensions= -PAU_cin_hau}', "");
    Expect(1, 72440, '\P{^Script_Extensions= -PAU_cin_hau}', "");
    Expect(0, 72441, '\p{Script_Extensions= -PAU_cin_hau}', "");
    Expect(1, 72441, '\p{^Script_Extensions= -PAU_cin_hau}', "");
    Expect(1, 72441, '\P{Script_Extensions= -PAU_cin_hau}', "");
    Expect(0, 72441, '\P{^Script_Extensions= -PAU_cin_hau}', "");
    Error('\p{Scx=_ PAUC:=}');
    Error('\P{Scx=_ PAUC:=}');
    Expect(1, 72440, '\p{Scx=:\APauc\z:}', "");;
    Expect(0, 72441, '\p{Scx=:\APauc\z:}', "");;
    Expect(1, 72440, '\p{Scx=pauc}', "");
    Expect(0, 72440, '\p{^Scx=pauc}', "");
    Expect(0, 72440, '\P{Scx=pauc}', "");
    Expect(1, 72440, '\P{^Scx=pauc}', "");
    Expect(0, 72441, '\p{Scx=pauc}', "");
    Expect(1, 72441, '\p{^Scx=pauc}', "");
    Expect(1, 72441, '\P{Scx=pauc}', "");
    Expect(0, 72441, '\P{^Scx=pauc}', "");
    Expect(1, 72440, '\p{Scx=:\Apauc\z:}', "");;
    Expect(0, 72441, '\p{Scx=:\Apauc\z:}', "");;
    Expect(1, 72440, '\p{Scx= -Pauc}', "");
    Expect(0, 72440, '\p{^Scx= -Pauc}', "");
    Expect(0, 72440, '\P{Scx= -Pauc}', "");
    Expect(1, 72440, '\P{^Scx= -Pauc}', "");
    Expect(0, 72441, '\p{Scx= -Pauc}', "");
    Expect(1, 72441, '\p{^Scx= -Pauc}', "");
    Expect(1, 72441, '\P{Scx= -Pauc}', "");
    Expect(0, 72441, '\P{^Scx= -Pauc}', "");
    Error('\p{Is_Script_Extensions= /a/Pau_Cin_Hau}');
    Error('\P{Is_Script_Extensions= /a/Pau_Cin_Hau}');
    Expect(1, 72440, '\p{Is_Script_Extensions=paucinhau}', "");
    Expect(0, 72440, '\p{^Is_Script_Extensions=paucinhau}', "");
    Expect(0, 72440, '\P{Is_Script_Extensions=paucinhau}', "");
    Expect(1, 72440, '\P{^Is_Script_Extensions=paucinhau}', "");
    Expect(0, 72441, '\p{Is_Script_Extensions=paucinhau}', "");
    Expect(1, 72441, '\p{^Is_Script_Extensions=paucinhau}', "");
    Expect(1, 72441, '\P{Is_Script_Extensions=paucinhau}', "");
    Expect(0, 72441, '\P{^Is_Script_Extensions=paucinhau}', "");
    Expect(1, 72440, '\p{Is_Script_Extensions:   -PAU_Cin_Hau}', "");
    Expect(0, 72440, '\p{^Is_Script_Extensions:   -PAU_Cin_Hau}', "");
    Expect(0, 72440, '\P{Is_Script_Extensions:   -PAU_Cin_Hau}', "");
    Expect(1, 72440, '\P{^Is_Script_Extensions:   -PAU_Cin_Hau}', "");
    Expect(0, 72441, '\p{Is_Script_Extensions:   -PAU_Cin_Hau}', "");
    Expect(1, 72441, '\p{^Is_Script_Extensions:   -PAU_Cin_Hau}', "");
    Expect(1, 72441, '\P{Is_Script_Extensions:   -PAU_Cin_Hau}', "");
    Expect(0, 72441, '\P{^Is_Script_Extensions:   -PAU_Cin_Hau}', "");
    Error('\p{Is_Scx=:=-pauc}');
    Error('\P{Is_Scx=:=-pauc}');
    Expect(1, 72440, '\p{Is_Scx=pauc}', "");
    Expect(0, 72440, '\p{^Is_Scx=pauc}', "");
    Expect(0, 72440, '\P{Is_Scx=pauc}', "");
    Expect(1, 72440, '\P{^Is_Scx=pauc}', "");
    Expect(0, 72441, '\p{Is_Scx=pauc}', "");
    Expect(1, 72441, '\p{^Is_Scx=pauc}', "");
    Expect(1, 72441, '\P{Is_Scx=pauc}', "");
    Expect(0, 72441, '\P{^Is_Scx=pauc}', "");
    Expect(1, 72440, '\p{Is_Scx= PAUC}', "");
    Expect(0, 72440, '\p{^Is_Scx= PAUC}', "");
    Expect(0, 72440, '\P{Is_Scx= PAUC}', "");
    Expect(1, 72440, '\P{^Is_Scx= PAUC}', "");
    Expect(0, 72441, '\p{Is_Scx= PAUC}', "");
    Expect(1, 72441, '\p{^Is_Scx= PAUC}', "");
    Expect(1, 72441, '\P{Is_Scx= PAUC}', "");
    Expect(0, 72441, '\P{^Is_Scx= PAUC}', "");
    Error('\p{Script_Extensions=/a/_old_Permic}');
    Error('\P{Script_Extensions=/a/_old_Permic}');
    Expect(1, 66426, '\p{Script_Extensions=:\AOld_Permic\z:}', "");;
    Expect(0, 66427, '\p{Script_Extensions=:\AOld_Permic\z:}', "");;
    Expect(1, 66426, '\p{Script_Extensions=oldpermic}', "");
    Expect(0, 66426, '\p{^Script_Extensions=oldpermic}', "");
    Expect(0, 66426, '\P{Script_Extensions=oldpermic}', "");
    Expect(1, 66426, '\P{^Script_Extensions=oldpermic}', "");
    Expect(0, 66427, '\p{Script_Extensions=oldpermic}', "");
    Expect(1, 66427, '\p{^Script_Extensions=oldpermic}', "");
    Expect(1, 66427, '\P{Script_Extensions=oldpermic}', "");
    Expect(0, 66427, '\P{^Script_Extensions=oldpermic}', "");
    Expect(1, 66426, '\p{Script_Extensions=:\Aoldpermic\z:}', "");;
    Expect(0, 66427, '\p{Script_Extensions=:\Aoldpermic\z:}', "");;
    Expect(1, 66426, '\p{Script_Extensions= Old_Permic}', "");
    Expect(0, 66426, '\p{^Script_Extensions= Old_Permic}', "");
    Expect(0, 66426, '\P{Script_Extensions= Old_Permic}', "");
    Expect(1, 66426, '\P{^Script_Extensions= Old_Permic}', "");
    Expect(0, 66427, '\p{Script_Extensions= Old_Permic}', "");
    Expect(1, 66427, '\p{^Script_Extensions= Old_Permic}', "");
    Expect(1, 66427, '\P{Script_Extensions= Old_Permic}', "");
    Expect(0, 66427, '\P{^Script_Extensions= Old_Permic}', "");
    Error('\p{Scx=-/a/PERM}');
    Error('\P{Scx=-/a/PERM}');
    Expect(1, 66426, '\p{Scx=:\APerm\z:}', "");;
    Expect(0, 66427, '\p{Scx=:\APerm\z:}', "");;
    Expect(1, 66426, '\p{Scx:perm}', "");
    Expect(0, 66426, '\p{^Scx:perm}', "");
    Expect(0, 66426, '\P{Scx:perm}', "");
    Expect(1, 66426, '\P{^Scx:perm}', "");
    Expect(0, 66427, '\p{Scx:perm}', "");
    Expect(1, 66427, '\p{^Scx:perm}', "");
    Expect(1, 66427, '\P{Scx:perm}', "");
    Expect(0, 66427, '\P{^Scx:perm}', "");
    Expect(1, 66426, '\p{Scx=:\Aperm\z:}', "");;
    Expect(0, 66427, '\p{Scx=:\Aperm\z:}', "");;
    Expect(1, 66426, '\p{Scx=-	Perm}', "");
    Expect(0, 66426, '\p{^Scx=-	Perm}', "");
    Expect(0, 66426, '\P{Scx=-	Perm}', "");
    Expect(1, 66426, '\P{^Scx=-	Perm}', "");
    Expect(0, 66427, '\p{Scx=-	Perm}', "");
    Expect(1, 66427, '\p{^Scx=-	Perm}', "");
    Expect(1, 66427, '\P{Scx=-	Perm}', "");
    Expect(0, 66427, '\P{^Scx=-	Perm}', "");
    Error('\p{Is_Script_Extensions=/a/Old_permic}');
    Error('\P{Is_Script_Extensions=/a/Old_permic}');
    Expect(1, 66426, '\p{Is_Script_Extensions=oldpermic}', "");
    Expect(0, 66426, '\p{^Is_Script_Extensions=oldpermic}', "");
    Expect(0, 66426, '\P{Is_Script_Extensions=oldpermic}', "");
    Expect(1, 66426, '\P{^Is_Script_Extensions=oldpermic}', "");
    Expect(0, 66427, '\p{Is_Script_Extensions=oldpermic}', "");
    Expect(1, 66427, '\p{^Is_Script_Extensions=oldpermic}', "");
    Expect(1, 66427, '\P{Is_Script_Extensions=oldpermic}', "");
    Expect(0, 66427, '\P{^Is_Script_Extensions=oldpermic}', "");
    Expect(1, 66426, '\p{Is_Script_Extensions=	-old_PERMIC}', "");
    Expect(0, 66426, '\p{^Is_Script_Extensions=	-old_PERMIC}', "");
    Expect(0, 66426, '\P{Is_Script_Extensions=	-old_PERMIC}', "");
    Expect(1, 66426, '\P{^Is_Script_Extensions=	-old_PERMIC}', "");
    Expect(0, 66427, '\p{Is_Script_Extensions=	-old_PERMIC}', "");
    Expect(1, 66427, '\p{^Is_Script_Extensions=	-old_PERMIC}', "");
    Expect(1, 66427, '\P{Is_Script_Extensions=	-old_PERMIC}', "");
    Expect(0, 66427, '\P{^Is_Script_Extensions=	-old_PERMIC}', "");
    Error('\p{Is_Scx=	 Perm:=}');
    Error('\P{Is_Scx=	 Perm:=}');
    Expect(1, 66426, '\p{Is_Scx=perm}', "");
    Expect(0, 66426, '\p{^Is_Scx=perm}', "");
    Expect(0, 66426, '\P{Is_Scx=perm}', "");
    Expect(1, 66426, '\P{^Is_Scx=perm}', "");
    Expect(0, 66427, '\p{Is_Scx=perm}', "");
    Expect(1, 66427, '\p{^Is_Scx=perm}', "");
    Expect(1, 66427, '\P{Is_Scx=perm}', "");
    Expect(0, 66427, '\P{^Is_Scx=perm}', "");
    Expect(1, 66426, '\p{Is_Scx=	_Perm}', "");
    Expect(0, 66426, '\p{^Is_Scx=	_Perm}', "");
    Expect(0, 66426, '\P{Is_Scx=	_Perm}', "");
    Expect(1, 66426, '\P{^Is_Scx=	_Perm}', "");
    Expect(0, 66427, '\p{Is_Scx=	_Perm}', "");
    Expect(1, 66427, '\p{^Is_Scx=	_Perm}', "");
    Expect(1, 66427, '\P{Is_Scx=	_Perm}', "");
    Expect(0, 66427, '\P{^Is_Scx=	_Perm}', "");
    Error('\p{Script_Extensions=/a/_-phags_pa}');
    Error('\P{Script_Extensions=/a/_-phags_pa}');
    Expect(1, 43127, '\p{Script_Extensions=:\APhags_Pa\z:}', "");;
    Expect(0, 43128, '\p{Script_Extensions=:\APhags_Pa\z:}', "");;
    Expect(1, 43127, '\p{Script_Extensions=phagspa}', "");
    Expect(0, 43127, '\p{^Script_Extensions=phagspa}', "");
    Expect(0, 43127, '\P{Script_Extensions=phagspa}', "");
    Expect(1, 43127, '\P{^Script_Extensions=phagspa}', "");
    Expect(0, 43128, '\p{Script_Extensions=phagspa}', "");
    Expect(1, 43128, '\p{^Script_Extensions=phagspa}', "");
    Expect(1, 43128, '\P{Script_Extensions=phagspa}', "");
    Expect(0, 43128, '\P{^Script_Extensions=phagspa}', "");
    Expect(1, 43127, '\p{Script_Extensions=:\Aphagspa\z:}', "");;
    Expect(0, 43128, '\p{Script_Extensions=:\Aphagspa\z:}', "");;
    Expect(1, 43127, '\p{Script_Extensions= phags_pa}', "");
    Expect(0, 43127, '\p{^Script_Extensions= phags_pa}', "");
    Expect(0, 43127, '\P{Script_Extensions= phags_pa}', "");
    Expect(1, 43127, '\P{^Script_Extensions= phags_pa}', "");
    Expect(0, 43128, '\p{Script_Extensions= phags_pa}', "");
    Expect(1, 43128, '\p{^Script_Extensions= phags_pa}', "");
    Expect(1, 43128, '\P{Script_Extensions= phags_pa}', "");
    Expect(0, 43128, '\P{^Script_Extensions= phags_pa}', "");
    Error('\p{Scx=/a/-_Phag}');
    Error('\P{Scx=/a/-_Phag}');
    Expect(1, 43127, '\p{Scx=:\APhag\z:}', "");;
    Expect(0, 43128, '\p{Scx=:\APhag\z:}', "");;
    Expect(1, 43127, '\p{Scx=phag}', "");
    Expect(0, 43127, '\p{^Scx=phag}', "");
    Expect(0, 43127, '\P{Scx=phag}', "");
    Expect(1, 43127, '\P{^Scx=phag}', "");
    Expect(0, 43128, '\p{Scx=phag}', "");
    Expect(1, 43128, '\p{^Scx=phag}', "");
    Expect(1, 43128, '\P{Scx=phag}', "");
    Expect(0, 43128, '\P{^Scx=phag}', "");
    Expect(1, 43127, '\p{Scx=:\Aphag\z:}', "");;
    Expect(0, 43128, '\p{Scx=:\Aphag\z:}', "");;
    Expect(1, 43127, '\p{Scx=- phag}', "");
    Expect(0, 43127, '\p{^Scx=- phag}', "");
    Expect(0, 43127, '\P{Scx=- phag}', "");
    Expect(1, 43127, '\P{^Scx=- phag}', "");
    Expect(0, 43128, '\p{Scx=- phag}', "");
    Expect(1, 43128, '\p{^Scx=- phag}', "");
    Expect(1, 43128, '\P{Scx=- phag}', "");
    Expect(0, 43128, '\P{^Scx=- phag}', "");
    Error('\p{Is_Script_Extensions=	 phags_pa:=}');
    Error('\P{Is_Script_Extensions=	 phags_pa:=}');
    Expect(1, 43127, '\p{Is_Script_Extensions:phagspa}', "");
    Expect(0, 43127, '\p{^Is_Script_Extensions:phagspa}', "");
    Expect(0, 43127, '\P{Is_Script_Extensions:phagspa}', "");
    Expect(1, 43127, '\P{^Is_Script_Extensions:phagspa}', "");
    Expect(0, 43128, '\p{Is_Script_Extensions:phagspa}', "");
    Expect(1, 43128, '\p{^Is_Script_Extensions:phagspa}', "");
    Expect(1, 43128, '\P{Is_Script_Extensions:phagspa}', "");
    Expect(0, 43128, '\P{^Is_Script_Extensions:phagspa}', "");
    Expect(1, 43127, '\p{Is_Script_Extensions=_PHAGS_pa}', "");
    Expect(0, 43127, '\p{^Is_Script_Extensions=_PHAGS_pa}', "");
    Expect(0, 43127, '\P{Is_Script_Extensions=_PHAGS_pa}', "");
    Expect(1, 43127, '\P{^Is_Script_Extensions=_PHAGS_pa}', "");
    Expect(0, 43128, '\p{Is_Script_Extensions=_PHAGS_pa}', "");
    Expect(1, 43128, '\p{^Is_Script_Extensions=_PHAGS_pa}', "");
    Expect(1, 43128, '\P{Is_Script_Extensions=_PHAGS_pa}', "");
    Expect(0, 43128, '\P{^Is_Script_Extensions=_PHAGS_pa}', "");
    Error('\p{Is_Scx=- phag:=}');
    Error('\P{Is_Scx=- phag:=}');
    Expect(1, 43127, '\p{Is_Scx=phag}', "");
    Expect(0, 43127, '\p{^Is_Scx=phag}', "");
    Expect(0, 43127, '\P{Is_Scx=phag}', "");
    Expect(1, 43127, '\P{^Is_Scx=phag}', "");
    Expect(0, 43128, '\p{Is_Scx=phag}', "");
    Expect(1, 43128, '\p{^Is_Scx=phag}', "");
    Expect(1, 43128, '\P{Is_Scx=phag}', "");
    Expect(0, 43128, '\P{^Is_Scx=phag}', "");
    Expect(1, 43127, '\p{Is_Scx=_-phag}', "");
    Expect(0, 43127, '\p{^Is_Scx=_-phag}', "");
    Expect(0, 43127, '\P{Is_Scx=_-phag}', "");
    Expect(1, 43127, '\P{^Is_Scx=_-phag}', "");
    Expect(0, 43128, '\p{Is_Scx=_-phag}', "");
    Expect(1, 43128, '\p{^Is_Scx=_-phag}', "");
    Expect(1, 43128, '\P{Is_Scx=_-phag}', "");
    Expect(0, 43128, '\P{^Is_Scx=_-phag}', "");
    Error('\p{Script_Extensions= _INSCRIPTIONAL_Pahlavi/a/}');
    Error('\P{Script_Extensions= _INSCRIPTIONAL_Pahlavi/a/}');
    Expect(1, 68479, '\p{Script_Extensions=:\AInscriptional_Pahlavi\z:}', "");;
    Expect(0, 68480, '\p{Script_Extensions=:\AInscriptional_Pahlavi\z:}', "");;
    Expect(1, 68479, '\p{Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Script_Extensions=:\Ainscriptionalpahlavi\z:}', "");;
    Expect(0, 68480, '\p{Script_Extensions=:\Ainscriptionalpahlavi\z:}', "");;
    Expect(1, 68479, '\p{Script_Extensions=__inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\p{^Script_Extensions=__inscriptional_Pahlavi}', "");
    Expect(0, 68479, '\P{Script_Extensions=__inscriptional_Pahlavi}', "");
    Expect(1, 68479, '\P{^Script_Extensions=__inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\p{Script_Extensions=__inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\p{^Script_Extensions=__inscriptional_Pahlavi}', "");
    Expect(1, 68480, '\P{Script_Extensions=__inscriptional_Pahlavi}', "");
    Expect(0, 68480, '\P{^Script_Extensions=__inscriptional_Pahlavi}', "");
    Error('\p{Scx=--Phli/a/}');
    Error('\P{Scx=--Phli/a/}');
    Expect(1, 68479, '\p{Scx=:\APhli\z:}', "");;
    Expect(0, 68480, '\p{Scx=:\APhli\z:}', "");;
    Expect(1, 68479, '\p{Scx:	phli}', "");
    Expect(0, 68479, '\p{^Scx:	phli}', "");
    Expect(0, 68479, '\P{Scx:	phli}', "");
    Expect(1, 68479, '\P{^Scx:	phli}', "");
    Expect(0, 68480, '\p{Scx:	phli}', "");
    Expect(1, 68480, '\p{^Scx:	phli}', "");
    Expect(1, 68480, '\P{Scx:	phli}', "");
    Expect(0, 68480, '\P{^Scx:	phli}', "");
    Expect(1, 68479, '\p{Scx=:\Aphli\z:}', "");;
    Expect(0, 68480, '\p{Scx=:\Aphli\z:}', "");;
    Expect(1, 68479, '\p{Scx= -phli}', "");
    Expect(0, 68479, '\p{^Scx= -phli}', "");
    Expect(0, 68479, '\P{Scx= -phli}', "");
    Expect(1, 68479, '\P{^Scx= -phli}', "");
    Expect(0, 68480, '\p{Scx= -phli}', "");
    Expect(1, 68480, '\p{^Scx= -phli}', "");
    Expect(1, 68480, '\P{Scx= -phli}', "");
    Expect(0, 68480, '\P{^Scx= -phli}', "");
    Error('\p{Is_Script_Extensions=	Inscriptional_Pahlavi/a/}');
    Error('\P{Is_Script_Extensions=	Inscriptional_Pahlavi/a/}');
    Expect(1, 68479, '\p{Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\p{^Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68479, '\P{Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\P{^Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\p{Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\p{^Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68480, '\P{Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(0, 68480, '\P{^Is_Script_Extensions=inscriptionalpahlavi}', "");
    Expect(1, 68479, '\p{Is_Script_Extensions=--Inscriptional_pahlavi}', "");
    Expect(0, 68479, '\p{^Is_Script_Extensions=--Inscriptional_pahlavi}', "");
    Expect(0, 68479, '\P{Is_Script_Extensions=--Inscriptional_pahlavi}', "");
    Expect(1, 68479, '\P{^Is_Script_Extensions=--Inscriptional_pahlavi}', "");
    Expect(0, 68480, '\p{Is_Script_Extensions=--Inscriptional_pahlavi}', "");
    Expect(1, 68480, '\p{^Is_Script_Extensions=--Inscriptional_pahlavi}', "");
    Expect(1, 68480, '\P{Is_Script_Extensions=--Inscriptional_pahlavi}', "");
    Expect(0, 68480, '\P{^Is_Script_Extensions=--Inscriptional_pahlavi}', "");
    Error('\p{Is_Scx=/a/	_phli}');
    Error('\P{Is_Scx=/a/	_phli}');
    Expect(1, 68479, '\p{Is_Scx:   phli}', "");
    Expect(0, 68479, '\p{^Is_Scx:   phli}', "");
    Expect(0, 68479, '\P{Is_Scx:   phli}', "");
    Expect(1, 68479, '\P{^Is_Scx:   phli}', "");
    Expect(0, 68480, '\p{Is_Scx:   phli}', "");
    Expect(1, 68480, '\p{^Is_Scx:   phli}', "");
    Expect(1, 68480, '\P{Is_Scx:   phli}', "");
    Expect(0, 68480, '\P{^Is_Scx:   phli}', "");
    Expect(1, 68479, '\p{Is_Scx=--Phli}', "");
    Expect(0, 68479, '\p{^Is_Scx=--Phli}', "");
    Expect(0, 68479, '\P{Is_Scx=--Phli}', "");
    Expect(1, 68479, '\P{^Is_Scx=--Phli}', "");
    Expect(0, 68480, '\p{Is_Scx=--Phli}', "");
    Expect(1, 68480, '\p{^Is_Scx=--Phli}', "");
    Expect(1, 68480, '\P{Is_Scx=--Phli}', "");
    Expect(0, 68480, '\P{^Is_Scx=--Phli}', "");
    Error('\p{Script_Extensions=/a/	 Psalter_Pahlavi}');
    Error('\P{Script_Extensions=/a/	 Psalter_Pahlavi}');
    Expect(1, 68527, '\p{Script_Extensions=:\APsalter_Pahlavi\z:}', "");;
    Expect(0, 68528, '\p{Script_Extensions=:\APsalter_Pahlavi\z:}', "");;
    Expect(1, 68527, '\p{Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Script_Extensions=:\Apsalterpahlavi\z:}', "");;
    Expect(0, 68528, '\p{Script_Extensions=:\Apsalterpahlavi\z:}', "");;
    Expect(1, 68527, '\p{Script_Extensions= _Psalter_Pahlavi}', "");
    Expect(0, 68527, '\p{^Script_Extensions= _Psalter_Pahlavi}', "");
    Expect(0, 68527, '\P{Script_Extensions= _Psalter_Pahlavi}', "");
    Expect(1, 68527, '\P{^Script_Extensions= _Psalter_Pahlavi}', "");
    Expect(0, 68528, '\p{Script_Extensions= _Psalter_Pahlavi}', "");
    Expect(1, 68528, '\p{^Script_Extensions= _Psalter_Pahlavi}', "");
    Expect(1, 68528, '\P{Script_Extensions= _Psalter_Pahlavi}', "");
    Expect(0, 68528, '\P{^Script_Extensions= _Psalter_Pahlavi}', "");
    Error('\p{Scx=/a/phlp}');
    Error('\P{Scx=/a/phlp}');
    Expect(1, 68527, '\p{Scx=:\APhlp\z:}', "");;
    Expect(0, 68528, '\p{Scx=:\APhlp\z:}', "");;
    Expect(1, 68527, '\p{Scx=phlp}', "");
    Expect(0, 68527, '\p{^Scx=phlp}', "");
    Expect(0, 68527, '\P{Scx=phlp}', "");
    Expect(1, 68527, '\P{^Scx=phlp}', "");
    Expect(0, 68528, '\p{Scx=phlp}', "");
    Expect(1, 68528, '\p{^Scx=phlp}', "");
    Expect(1, 68528, '\P{Scx=phlp}', "");
    Expect(0, 68528, '\P{^Scx=phlp}', "");
    Expect(1, 68527, '\p{Scx=:\Aphlp\z:}', "");;
    Expect(0, 68528, '\p{Scx=:\Aphlp\z:}', "");;
    Expect(1, 68527, '\p{Scx=	_PHLP}', "");
    Expect(0, 68527, '\p{^Scx=	_PHLP}', "");
    Expect(0, 68527, '\P{Scx=	_PHLP}', "");
    Expect(1, 68527, '\P{^Scx=	_PHLP}', "");
    Expect(0, 68528, '\p{Scx=	_PHLP}', "");
    Expect(1, 68528, '\p{^Scx=	_PHLP}', "");
    Expect(1, 68528, '\P{Scx=	_PHLP}', "");
    Expect(0, 68528, '\P{^Scx=	_PHLP}', "");
    Error('\p{Is_Script_Extensions=-:=PSALTER_Pahlavi}');
    Error('\P{Is_Script_Extensions=-:=PSALTER_Pahlavi}');
    Expect(1, 68527, '\p{Is_Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68527, '\p{^Is_Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68527, '\P{Is_Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68527, '\P{^Is_Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68528, '\p{Is_Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68528, '\p{^Is_Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68528, '\P{Is_Script_Extensions=psalterpahlavi}', "");
    Expect(0, 68528, '\P{^Is_Script_Extensions=psalterpahlavi}', "");
    Expect(1, 68527, '\p{Is_Script_Extensions= Psalter_Pahlavi}', "");
    Expect(0, 68527, '\p{^Is_Script_Extensions= Psalter_Pahlavi}', "");
    Expect(0, 68527, '\P{Is_Script_Extensions= Psalter_Pahlavi}', "");
    Expect(1, 68527, '\P{^Is_Script_Extensions= Psalter_Pahlavi}', "");
    Expect(0, 68528, '\p{Is_Script_Extensions= Psalter_Pahlavi}', "");
    Expect(1, 68528, '\p{^Is_Script_Extensions= Psalter_Pahlavi}', "");
    Expect(1, 68528, '\P{Is_Script_Extensions= Psalter_Pahlavi}', "");
    Expect(0, 68528, '\P{^Is_Script_Extensions= Psalter_Pahlavi}', "");
    Error('\p{Is_Scx=__phlp:=}');
    Error('\P{Is_Scx=__phlp:=}');
    Expect(1, 68527, '\p{Is_Scx=phlp}', "");
    Expect(0, 68527, '\p{^Is_Scx=phlp}', "");
    Expect(0, 68527, '\P{Is_Scx=phlp}', "");
    Expect(1, 68527, '\P{^Is_Scx=phlp}', "");
    Expect(0, 68528, '\p{Is_Scx=phlp}', "");
    Expect(1, 68528, '\p{^Is_Scx=phlp}', "");
    Expect(1, 68528, '\P{Is_Scx=phlp}', "");
    Expect(0, 68528, '\P{^Is_Scx=phlp}', "");
    Expect(1, 68527, '\p{Is_Scx=	Phlp}', "");
    Expect(0, 68527, '\p{^Is_Scx=	Phlp}', "");
    Expect(0, 68527, '\P{Is_Scx=	Phlp}', "");
    Expect(1, 68527, '\P{^Is_Scx=	Phlp}', "");
    Expect(0, 68528, '\p{Is_Scx=	Phlp}', "");
    Expect(1, 68528, '\p{^Is_Scx=	Phlp}', "");
    Expect(1, 68528, '\P{Is_Scx=	Phlp}', "");
    Expect(0, 68528, '\P{^Is_Scx=	Phlp}', "");
    Error('\p{Script_Extensions=/a/-_phoenician}');
    Error('\P{Script_Extensions=/a/-_phoenician}');
    Expect(1, 67871, '\p{Script_Extensions=:\APhoenician\z:}', "");;
    Expect(0, 67872, '\p{Script_Extensions=:\APhoenician\z:}', "");;
    Expect(1, 67871, '\p{Script_Extensions=phoenician}', "");
    Expect(0, 67871, '\p{^Script_Extensions=phoenician}', "");
    Expect(0, 67871, '\P{Script_Extensions=phoenician}', "");
    Expect(1, 67871, '\P{^Script_Extensions=phoenician}', "");
    Expect(0, 67872, '\p{Script_Extensions=phoenician}', "");
    Expect(1, 67872, '\p{^Script_Extensions=phoenician}', "");
    Expect(1, 67872, '\P{Script_Extensions=phoenician}', "");
    Expect(0, 67872, '\P{^Script_Extensions=phoenician}', "");
    Expect(1, 67871, '\p{Script_Extensions=:\Aphoenician\z:}', "");;
    Expect(0, 67872, '\p{Script_Extensions=:\Aphoenician\z:}', "");;
    Expect(1, 67871, '\p{Script_Extensions= 	Phoenician}', "");
    Expect(0, 67871, '\p{^Script_Extensions= 	Phoenician}', "");
    Expect(0, 67871, '\P{Script_Extensions= 	Phoenician}', "");
    Expect(1, 67871, '\P{^Script_Extensions= 	Phoenician}', "");
    Expect(0, 67872, '\p{Script_Extensions= 	Phoenician}', "");
    Expect(1, 67872, '\p{^Script_Extensions= 	Phoenician}', "");
    Expect(1, 67872, '\P{Script_Extensions= 	Phoenician}', "");
    Expect(0, 67872, '\P{^Script_Extensions= 	Phoenician}', "");
    Error('\p{Scx=/a/-Phnx}');
    Error('\P{Scx=/a/-Phnx}');
    Expect(1, 67871, '\p{Scx=:\APhnx\z:}', "");;
    Expect(0, 67872, '\p{Scx=:\APhnx\z:}', "");;
    Expect(1, 67871, '\p{Scx=phnx}', "");
    Expect(0, 67871, '\p{^Scx=phnx}', "");
    Expect(0, 67871, '\P{Scx=phnx}', "");
    Expect(1, 67871, '\P{^Scx=phnx}', "");
    Expect(0, 67872, '\p{Scx=phnx}', "");
    Expect(1, 67872, '\p{^Scx=phnx}', "");
    Expect(1, 67872, '\P{Scx=phnx}', "");
    Expect(0, 67872, '\P{^Scx=phnx}', "");
    Expect(1, 67871, '\p{Scx=:\Aphnx\z:}', "");;
    Expect(0, 67872, '\p{Scx=:\Aphnx\z:}', "");;
    Expect(1, 67871, '\p{Scx=_ Phnx}', "");
    Expect(0, 67871, '\p{^Scx=_ Phnx}', "");
    Expect(0, 67871, '\P{Scx=_ Phnx}', "");
    Expect(1, 67871, '\P{^Scx=_ Phnx}', "");
    Expect(0, 67872, '\p{Scx=_ Phnx}', "");
    Expect(1, 67872, '\p{^Scx=_ Phnx}', "");
    Expect(1, 67872, '\P{Scx=_ Phnx}', "");
    Expect(0, 67872, '\P{^Scx=_ Phnx}', "");
    Error('\p{Is_Script_Extensions=-Phoenician/a/}');
    Error('\P{Is_Script_Extensions=-Phoenician/a/}');
    Expect(1, 67871, '\p{Is_Script_Extensions=phoenician}', "");
    Expect(0, 67871, '\p{^Is_Script_Extensions=phoenician}', "");
    Expect(0, 67871, '\P{Is_Script_Extensions=phoenician}', "");
    Expect(1, 67871, '\P{^Is_Script_Extensions=phoenician}', "");
    Expect(0, 67872, '\p{Is_Script_Extensions=phoenician}', "");
    Expect(1, 67872, '\p{^Is_Script_Extensions=phoenician}', "");
    Expect(1, 67872, '\P{Is_Script_Extensions=phoenician}', "");
    Expect(0, 67872, '\P{^Is_Script_Extensions=phoenician}', "");
    Expect(1, 67871, '\p{Is_Script_Extensions=__Phoenician}', "");
    Expect(0, 67871, '\p{^Is_Script_Extensions=__Phoenician}', "");
    Expect(0, 67871, '\P{Is_Script_Extensions=__Phoenician}', "");
    Expect(1, 67871, '\P{^Is_Script_Extensions=__Phoenician}', "");
    Expect(0, 67872, '\p{Is_Script_Extensions=__Phoenician}', "");
    Expect(1, 67872, '\p{^Is_Script_Extensions=__Phoenician}', "");
    Expect(1, 67872, '\P{Is_Script_Extensions=__Phoenician}', "");
    Expect(0, 67872, '\P{^Is_Script_Extensions=__Phoenician}', "");
    Error('\p{Is_Scx=-:=phnx}');
    Error('\P{Is_Scx=-:=phnx}');
    Expect(1, 67871, '\p{Is_Scx=phnx}', "");
    Expect(0, 67871, '\p{^Is_Scx=phnx}', "");
    Expect(0, 67871, '\P{Is_Scx=phnx}', "");
    Expect(1, 67871, '\P{^Is_Scx=phnx}', "");
    Expect(0, 67872, '\p{Is_Scx=phnx}', "");
    Expect(1, 67872, '\p{^Is_Scx=phnx}', "");
    Expect(1, 67872, '\P{Is_Scx=phnx}', "");
    Expect(0, 67872, '\P{^Is_Scx=phnx}', "");
    Expect(1, 67871, '\p{Is_Scx=_PHNX}', "");
    Expect(0, 67871, '\p{^Is_Scx=_PHNX}', "");
    Expect(0, 67871, '\P{Is_Scx=_PHNX}', "");
    Expect(1, 67871, '\P{^Is_Scx=_PHNX}', "");
    Expect(0, 67872, '\p{Is_Scx=_PHNX}', "");
    Expect(1, 67872, '\p{^Is_Scx=_PHNX}', "");
    Expect(1, 67872, '\P{Is_Scx=_PHNX}', "");
    Expect(0, 67872, '\P{^Is_Scx=_PHNX}', "");
    Error('\p{Script_Extensions=	 Miao/a/}');
    Error('\P{Script_Extensions=	 Miao/a/}');
    Expect(1, 94111, '\p{Script_Extensions=:\AMiao\z:}', "");;
    Expect(0, 94112, '\p{Script_Extensions=:\AMiao\z:}', "");;
    Expect(1, 94111, '\p{Script_Extensions=miao}', "");
    Expect(0, 94111, '\p{^Script_Extensions=miao}', "");
    Expect(0, 94111, '\P{Script_Extensions=miao}', "");
    Expect(1, 94111, '\P{^Script_Extensions=miao}', "");
    Expect(0, 94112, '\p{Script_Extensions=miao}', "");
    Expect(1, 94112, '\p{^Script_Extensions=miao}', "");
    Expect(1, 94112, '\P{Script_Extensions=miao}', "");
    Expect(0, 94112, '\P{^Script_Extensions=miao}', "");
    Expect(1, 94111, '\p{Script_Extensions=:\Amiao\z:}', "");;
    Expect(0, 94112, '\p{Script_Extensions=:\Amiao\z:}', "");;
    Expect(1, 94111, '\p{Script_Extensions=		Miao}', "");
    Expect(0, 94111, '\p{^Script_Extensions=		Miao}', "");
    Expect(0, 94111, '\P{Script_Extensions=		Miao}', "");
    Expect(1, 94111, '\P{^Script_Extensions=		Miao}', "");
    Expect(0, 94112, '\p{Script_Extensions=		Miao}', "");
    Expect(1, 94112, '\p{^Script_Extensions=		Miao}', "");
    Expect(1, 94112, '\P{Script_Extensions=		Miao}', "");
    Expect(0, 94112, '\P{^Script_Extensions=		Miao}', "");
    Error('\p{Scx=_ Plrd/a/}');
    Error('\P{Scx=_ Plrd/a/}');
    Expect(1, 94111, '\p{Scx=:\APlrd\z:}', "");;
    Expect(0, 94112, '\p{Scx=:\APlrd\z:}', "");;
    Expect(1, 94111, '\p{Scx:	plrd}', "");
    Expect(0, 94111, '\p{^Scx:	plrd}', "");
    Expect(0, 94111, '\P{Scx:	plrd}', "");
    Expect(1, 94111, '\P{^Scx:	plrd}', "");
    Expect(0, 94112, '\p{Scx:	plrd}', "");
    Expect(1, 94112, '\p{^Scx:	plrd}', "");
    Expect(1, 94112, '\P{Scx:	plrd}', "");
    Expect(0, 94112, '\P{^Scx:	plrd}', "");
    Expect(1, 94111, '\p{Scx=:\Aplrd\z:}', "");;
    Expect(0, 94112, '\p{Scx=:\Aplrd\z:}', "");;
    Expect(1, 94111, '\p{Scx=	-plrd}', "");
    Expect(0, 94111, '\p{^Scx=	-plrd}', "");
    Expect(0, 94111, '\P{Scx=	-plrd}', "");
    Expect(1, 94111, '\P{^Scx=	-plrd}', "");
    Expect(0, 94112, '\p{Scx=	-plrd}', "");
    Expect(1, 94112, '\p{^Scx=	-plrd}', "");
    Expect(1, 94112, '\P{Scx=	-plrd}', "");
    Expect(0, 94112, '\P{^Scx=	-plrd}', "");
    Error('\p{Is_Script_Extensions=_:=miao}');
    Error('\P{Is_Script_Extensions=_:=miao}');
    Expect(1, 94111, '\p{Is_Script_Extensions=miao}', "");
    Expect(0, 94111, '\p{^Is_Script_Extensions=miao}', "");
    Expect(0, 94111, '\P{Is_Script_Extensions=miao}', "");
    Expect(1, 94111, '\P{^Is_Script_Extensions=miao}', "");
    Expect(0, 94112, '\p{Is_Script_Extensions=miao}', "");
    Expect(1, 94112, '\p{^Is_Script_Extensions=miao}', "");
    Expect(1, 94112, '\P{Is_Script_Extensions=miao}', "");
    Expect(0, 94112, '\P{^Is_Script_Extensions=miao}', "");
    Expect(1, 94111, '\p{Is_Script_Extensions=__miao}', "");
    Expect(0, 94111, '\p{^Is_Script_Extensions=__miao}', "");
    Expect(0, 94111, '\P{Is_Script_Extensions=__miao}', "");
    Expect(1, 94111, '\P{^Is_Script_Extensions=__miao}', "");
    Expect(0, 94112, '\p{Is_Script_Extensions=__miao}', "");
    Expect(1, 94112, '\p{^Is_Script_Extensions=__miao}', "");
    Expect(1, 94112, '\P{Is_Script_Extensions=__miao}', "");
    Expect(0, 94112, '\P{^Is_Script_Extensions=__miao}', "");
    Error('\p{Is_Scx=_/a/Plrd}');
    Error('\P{Is_Scx=_/a/Plrd}');
    Expect(1, 94111, '\p{Is_Scx=plrd}', "");
    Expect(0, 94111, '\p{^Is_Scx=plrd}', "");
    Expect(0, 94111, '\P{Is_Scx=plrd}', "");
    Expect(1, 94111, '\P{^Is_Scx=plrd}', "");
    Expect(0, 94112, '\p{Is_Scx=plrd}', "");
    Expect(1, 94112, '\p{^Is_Scx=plrd}', "");
    Expect(1, 94112, '\P{Is_Scx=plrd}', "");
    Expect(0, 94112, '\P{^Is_Scx=plrd}', "");
    Expect(1, 94111, '\p{Is_Scx=-plrd}', "");
    Expect(0, 94111, '\p{^Is_Scx=-plrd}', "");
    Expect(0, 94111, '\P{Is_Scx=-plrd}', "");
    Expect(1, 94111, '\P{^Is_Scx=-plrd}', "");
    Expect(0, 94112, '\p{Is_Scx=-plrd}', "");
    Expect(1, 94112, '\p{^Is_Scx=-plrd}', "");
    Expect(1, 94112, '\P{Is_Scx=-plrd}', "");
    Expect(0, 94112, '\P{^Is_Scx=-plrd}', "");
    Error('\p{Script_Extensions:_Inscriptional_Parthian:=}');
    Error('\P{Script_Extensions:_Inscriptional_Parthian:=}');
    Expect(1, 68447, '\p{Script_Extensions=:\AInscriptional_Parthian\z:}', "");;
    Expect(0, 68448, '\p{Script_Extensions=:\AInscriptional_Parthian\z:}', "");;
    Expect(1, 68447, '\p{Script_Extensions=inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Script_Extensions=inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Script_Extensions=inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Script_Extensions=inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Script_Extensions=inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Script_Extensions=inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Script_Extensions=inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Script_Extensions=inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Script_Extensions=:\Ainscriptionalparthian\z:}', "");;
    Expect(0, 68448, '\p{Script_Extensions=:\Ainscriptionalparthian\z:}', "");;
    Expect(1, 68447, '\p{Script_Extensions=	_Inscriptional_Parthian}', "");
    Expect(0, 68447, '\p{^Script_Extensions=	_Inscriptional_Parthian}', "");
    Expect(0, 68447, '\P{Script_Extensions=	_Inscriptional_Parthian}', "");
    Expect(1, 68447, '\P{^Script_Extensions=	_Inscriptional_Parthian}', "");
    Expect(0, 68448, '\p{Script_Extensions=	_Inscriptional_Parthian}', "");
    Expect(1, 68448, '\p{^Script_Extensions=	_Inscriptional_Parthian}', "");
    Expect(1, 68448, '\P{Script_Extensions=	_Inscriptional_Parthian}', "");
    Expect(0, 68448, '\P{^Script_Extensions=	_Inscriptional_Parthian}', "");
    Error('\p{Scx=_:=PRTI}');
    Error('\P{Scx=_:=PRTI}');
    Expect(1, 68447, '\p{Scx=:\APrti\z:}', "");;
    Expect(0, 68448, '\p{Scx=:\APrti\z:}', "");;
    Expect(1, 68447, '\p{Scx=prti}', "");
    Expect(0, 68447, '\p{^Scx=prti}', "");
    Expect(0, 68447, '\P{Scx=prti}', "");
    Expect(1, 68447, '\P{^Scx=prti}', "");
    Expect(0, 68448, '\p{Scx=prti}', "");
    Expect(1, 68448, '\p{^Scx=prti}', "");
    Expect(1, 68448, '\P{Scx=prti}', "");
    Expect(0, 68448, '\P{^Scx=prti}', "");
    Expect(1, 68447, '\p{Scx=:\Aprti\z:}', "");;
    Expect(0, 68448, '\p{Scx=:\Aprti\z:}', "");;
    Expect(1, 68447, '\p{Scx: _prti}', "");
    Expect(0, 68447, '\p{^Scx: _prti}', "");
    Expect(0, 68447, '\P{Scx: _prti}', "");
    Expect(1, 68447, '\P{^Scx: _prti}', "");
    Expect(0, 68448, '\p{Scx: _prti}', "");
    Expect(1, 68448, '\p{^Scx: _prti}', "");
    Expect(1, 68448, '\P{Scx: _prti}', "");
    Expect(0, 68448, '\P{^Scx: _prti}', "");
    Error('\p{Is_Script_Extensions= _Inscriptional_parthian/a/}');
    Error('\P{Is_Script_Extensions= _Inscriptional_parthian/a/}');
    Expect(1, 68447, '\p{Is_Script_Extensions=inscriptionalparthian}', "");
    Expect(0, 68447, '\p{^Is_Script_Extensions=inscriptionalparthian}', "");
    Expect(0, 68447, '\P{Is_Script_Extensions=inscriptionalparthian}', "");
    Expect(1, 68447, '\P{^Is_Script_Extensions=inscriptionalparthian}', "");
    Expect(0, 68448, '\p{Is_Script_Extensions=inscriptionalparthian}', "");
    Expect(1, 68448, '\p{^Is_Script_Extensions=inscriptionalparthian}', "");
    Expect(1, 68448, '\P{Is_Script_Extensions=inscriptionalparthian}', "");
    Expect(0, 68448, '\P{^Is_Script_Extensions=inscriptionalparthian}', "");
    Expect(1, 68447, '\p{Is_Script_Extensions=	 INSCRIPTIONAL_Parthian}', "");
    Expect(0, 68447, '\p{^Is_Script_Extensions=	 INSCRIPTIONAL_Parthian}', "");
    Expect(0, 68447, '\P{Is_Script_Extensions=	 INSCRIPTIONAL_Parthian}', "");
    Expect(1, 68447, '\P{^Is_Script_Extensions=	 INSCRIPTIONAL_Parthian}', "");
    Expect(0, 68448, '\p{Is_Script_Extensions=	 INSCRIPTIONAL_Parthian}', "");
    Expect(1, 68448, '\p{^Is_Script_Extensions=	 INSCRIPTIONAL_Parthian}', "");
    Expect(1, 68448, '\P{Is_Script_Extensions=	 INSCRIPTIONAL_Parthian}', "");
    Expect(0, 68448, '\P{^Is_Script_Extensions=	 INSCRIPTIONAL_Parthian}', "");
    Error('\p{Is_Scx=-Prti:=}');
    Error('\P{Is_Scx=-Prti:=}');
    Expect(1, 68447, '\p{Is_Scx=prti}', "");
    Expect(0, 68447, '\p{^Is_Scx=prti}', "");
    Expect(0, 68447, '\P{Is_Scx=prti}', "");
    Expect(1, 68447, '\P{^Is_Scx=prti}', "");
    Expect(0, 68448, '\p{Is_Scx=prti}', "");
    Expect(1, 68448, '\p{^Is_Scx=prti}', "");
    Expect(1, 68448, '\P{Is_Scx=prti}', "");
    Expect(0, 68448, '\P{^Is_Scx=prti}', "");
    Expect(1, 68447, '\p{Is_Scx=_ Prti}', "");
    Expect(0, 68447, '\p{^Is_Scx=_ Prti}', "");
    Expect(0, 68447, '\P{Is_Scx=_ Prti}', "");
    Expect(1, 68447, '\P{^Is_Scx=_ Prti}', "");
    Expect(0, 68448, '\p{Is_Scx=_ Prti}', "");
    Expect(1, 68448, '\p{^Is_Scx=_ Prti}', "");
    Expect(1, 68448, '\P{Is_Scx=_ Prti}', "");
    Expect(0, 68448, '\P{^Is_Scx=_ Prti}', "");
    Error('\p{Script_Extensions=-_Rejang/a/}');
    Error('\P{Script_Extensions=-_Rejang/a/}');
    Expect(1, 43359, '\p{Script_Extensions=:\ARejang\z:}', "");;
    Expect(0, 43360, '\p{Script_Extensions=:\ARejang\z:}', "");;
    Expect(1, 43359, '\p{Script_Extensions=rejang}', "");
    Expect(0, 43359, '\p{^Script_Extensions=rejang}', "");
    Expect(0, 43359, '\P{Script_Extensions=rejang}', "");
    Expect(1, 43359, '\P{^Script_Extensions=rejang}', "");
    Expect(0, 43360, '\p{Script_Extensions=rejang}', "");
    Expect(1, 43360, '\p{^Script_Extensions=rejang}', "");
    Expect(1, 43360, '\P{Script_Extensions=rejang}', "");
    Expect(0, 43360, '\P{^Script_Extensions=rejang}', "");
    Expect(1, 43359, '\p{Script_Extensions=:\Arejang\z:}', "");;
    Expect(0, 43360, '\p{Script_Extensions=:\Arejang\z:}', "");;
    Expect(1, 43359, '\p{Script_Extensions=-	rejang}', "");
    Expect(0, 43359, '\p{^Script_Extensions=-	rejang}', "");
    Expect(0, 43359, '\P{Script_Extensions=-	rejang}', "");
    Expect(1, 43359, '\P{^Script_Extensions=-	rejang}', "");
    Expect(0, 43360, '\p{Script_Extensions=-	rejang}', "");
    Expect(1, 43360, '\p{^Script_Extensions=-	rejang}', "");
    Expect(1, 43360, '\P{Script_Extensions=-	rejang}', "");
    Expect(0, 43360, '\P{^Script_Extensions=-	rejang}', "");
    Error('\p{Scx=-_Rjng/a/}');
    Error('\P{Scx=-_Rjng/a/}');
    Expect(1, 43359, '\p{Scx=:\ARjng\z:}', "");;
    Expect(0, 43360, '\p{Scx=:\ARjng\z:}', "");;
    Expect(1, 43359, '\p{Scx=rjng}', "");
    Expect(0, 43359, '\p{^Scx=rjng}', "");
    Expect(0, 43359, '\P{Scx=rjng}', "");
    Expect(1, 43359, '\P{^Scx=rjng}', "");
    Expect(0, 43360, '\p{Scx=rjng}', "");
    Expect(1, 43360, '\p{^Scx=rjng}', "");
    Expect(1, 43360, '\P{Scx=rjng}', "");
    Expect(0, 43360, '\P{^Scx=rjng}', "");
    Expect(1, 43359, '\p{Scx=:\Arjng\z:}', "");;
    Expect(0, 43360, '\p{Scx=:\Arjng\z:}', "");;
    Expect(1, 43359, '\p{Scx=	 RJNG}', "");
    Expect(0, 43359, '\p{^Scx=	 RJNG}', "");
    Expect(0, 43359, '\P{Scx=	 RJNG}', "");
    Expect(1, 43359, '\P{^Scx=	 RJNG}', "");
    Expect(0, 43360, '\p{Scx=	 RJNG}', "");
    Expect(1, 43360, '\p{^Scx=	 RJNG}', "");
    Expect(1, 43360, '\P{Scx=	 RJNG}', "");
    Expect(0, 43360, '\P{^Scx=	 RJNG}', "");
    Error('\p{Is_Script_Extensions=	:=Rejang}');
    Error('\P{Is_Script_Extensions=	:=Rejang}');
    Expect(1, 43359, '\p{Is_Script_Extensions=rejang}', "");
    Expect(0, 43359, '\p{^Is_Script_Extensions=rejang}', "");
    Expect(0, 43359, '\P{Is_Script_Extensions=rejang}', "");
    Expect(1, 43359, '\P{^Is_Script_Extensions=rejang}', "");
    Expect(0, 43360, '\p{Is_Script_Extensions=rejang}', "");
    Expect(1, 43360, '\p{^Is_Script_Extensions=rejang}', "");
    Expect(1, 43360, '\P{Is_Script_Extensions=rejang}', "");
    Expect(0, 43360, '\P{^Is_Script_Extensions=rejang}', "");
    Expect(1, 43359, '\p{Is_Script_Extensions=-Rejang}', "");
    Expect(0, 43359, '\p{^Is_Script_Extensions=-Rejang}', "");
    Expect(0, 43359, '\P{Is_Script_Extensions=-Rejang}', "");
    Expect(1, 43359, '\P{^Is_Script_Extensions=-Rejang}', "");
    Expect(0, 43360, '\p{Is_Script_Extensions=-Rejang}', "");
    Expect(1, 43360, '\p{^Is_Script_Extensions=-Rejang}', "");
    Expect(1, 43360, '\P{Is_Script_Extensions=-Rejang}', "");
    Expect(0, 43360, '\P{^Is_Script_Extensions=-Rejang}', "");
    Error('\p{Is_Scx=:=-Rjng}');
    Error('\P{Is_Scx=:=-Rjng}');
    Expect(1, 43359, '\p{Is_Scx=rjng}', "");
    Expect(0, 43359, '\p{^Is_Scx=rjng}', "");
    Expect(0, 43359, '\P{Is_Scx=rjng}', "");
    Expect(1, 43359, '\P{^Is_Scx=rjng}', "");
    Expect(0, 43360, '\p{Is_Scx=rjng}', "");
    Expect(1, 43360, '\p{^Is_Scx=rjng}', "");
    Expect(1, 43360, '\P{Is_Scx=rjng}', "");
    Expect(0, 43360, '\P{^Is_Scx=rjng}', "");
    Expect(1, 43359, '\p{Is_Scx=	rjng}', "");
    Expect(0, 43359, '\p{^Is_Scx=	rjng}', "");
    Expect(0, 43359, '\P{Is_Scx=	rjng}', "");
    Expect(1, 43359, '\P{^Is_Scx=	rjng}', "");
    Expect(0, 43360, '\p{Is_Scx=	rjng}', "");
    Expect(1, 43360, '\p{^Is_Scx=	rjng}', "");
    Expect(1, 43360, '\P{Is_Scx=	rjng}', "");
    Expect(0, 43360, '\P{^Is_Scx=	rjng}', "");
    Error('\p{Script_Extensions=_/a/HANIFI_rohingya}');
    Error('\P{Script_Extensions=_/a/HANIFI_rohingya}');
    Expect(1, 68921, '\p{Script_Extensions=:\AHanifi_Rohingya\z:}', "");;
    Expect(0, 68922, '\p{Script_Extensions=:\AHanifi_Rohingya\z:}', "");;
    Expect(1, 68921, '\p{Script_Extensions=hanifirohingya}', "");
    Expect(0, 68921, '\p{^Script_Extensions=hanifirohingya}', "");
    Expect(0, 68921, '\P{Script_Extensions=hanifirohingya}', "");
    Expect(1, 68921, '\P{^Script_Extensions=hanifirohingya}', "");
    Expect(0, 68922, '\p{Script_Extensions=hanifirohingya}', "");
    Expect(1, 68922, '\p{^Script_Extensions=hanifirohingya}', "");
    Expect(1, 68922, '\P{Script_Extensions=hanifirohingya}', "");
    Expect(0, 68922, '\P{^Script_Extensions=hanifirohingya}', "");
    Expect(1, 68921, '\p{Script_Extensions=:\Ahanifirohingya\z:}', "");;
    Expect(0, 68922, '\p{Script_Extensions=:\Ahanifirohingya\z:}', "");;
    Expect(1, 68921, '\p{Script_Extensions=__HANIFI_rohingya}', "");
    Expect(0, 68921, '\p{^Script_Extensions=__HANIFI_rohingya}', "");
    Expect(0, 68921, '\P{Script_Extensions=__HANIFI_rohingya}', "");
    Expect(1, 68921, '\P{^Script_Extensions=__HANIFI_rohingya}', "");
    Expect(0, 68922, '\p{Script_Extensions=__HANIFI_rohingya}', "");
    Expect(1, 68922, '\p{^Script_Extensions=__HANIFI_rohingya}', "");
    Expect(1, 68922, '\P{Script_Extensions=__HANIFI_rohingya}', "");
    Expect(0, 68922, '\P{^Script_Extensions=__HANIFI_rohingya}', "");
    Error('\p{Scx=__Rohg/a/}');
    Error('\P{Scx=__Rohg/a/}');
    Expect(1, 68921, '\p{Scx=:\ARohg\z:}', "");;
    Expect(0, 68922, '\p{Scx=:\ARohg\z:}', "");;
    Expect(1, 68921, '\p{Scx: rohg}', "");
    Expect(0, 68921, '\p{^Scx: rohg}', "");
    Expect(0, 68921, '\P{Scx: rohg}', "");
    Expect(1, 68921, '\P{^Scx: rohg}', "");
    Expect(0, 68922, '\p{Scx: rohg}', "");
    Expect(1, 68922, '\p{^Scx: rohg}', "");
    Expect(1, 68922, '\P{Scx: rohg}', "");
    Expect(0, 68922, '\P{^Scx: rohg}', "");
    Expect(1, 68921, '\p{Scx=:\Arohg\z:}', "");;
    Expect(0, 68922, '\p{Scx=:\Arohg\z:}', "");;
    Expect(1, 68921, '\p{Scx=  Rohg}', "");
    Expect(0, 68921, '\p{^Scx=  Rohg}', "");
    Expect(0, 68921, '\P{Scx=  Rohg}', "");
    Expect(1, 68921, '\P{^Scx=  Rohg}', "");
    Expect(0, 68922, '\p{Scx=  Rohg}', "");
    Expect(1, 68922, '\p{^Scx=  Rohg}', "");
    Expect(1, 68922, '\P{Scx=  Rohg}', "");
    Expect(0, 68922, '\P{^Scx=  Rohg}', "");
    Error('\p{Is_Script_Extensions=/a/	_HANIFI_Rohingya}');
    Error('\P{Is_Script_Extensions=/a/	_HANIFI_Rohingya}');
    Expect(1, 68921, '\p{Is_Script_Extensions=hanifirohingya}', "");
    Expect(0, 68921, '\p{^Is_Script_Extensions=hanifirohingya}', "");
    Expect(0, 68921, '\P{Is_Script_Extensions=hanifirohingya}', "");
    Expect(1, 68921, '\P{^Is_Script_Extensions=hanifirohingya}', "");
    Expect(0, 68922, '\p{Is_Script_Extensions=hanifirohingya}', "");
    Expect(1, 68922, '\p{^Is_Script_Extensions=hanifirohingya}', "");
    Expect(1, 68922, '\P{Is_Script_Extensions=hanifirohingya}', "");
    Expect(0, 68922, '\P{^Is_Script_Extensions=hanifirohingya}', "");
    Expect(1, 68921, '\p{Is_Script_Extensions=_ HANIFI_ROHINGYA}', "");
    Expect(0, 68921, '\p{^Is_Script_Extensions=_ HANIFI_ROHINGYA}', "");
    Expect(0, 68921, '\P{Is_Script_Extensions=_ HANIFI_ROHINGYA}', "");
    Expect(1, 68921, '\P{^Is_Script_Extensions=_ HANIFI_ROHINGYA}', "");
    Expect(0, 68922, '\p{Is_Script_Extensions=_ HANIFI_ROHINGYA}', "");
    Expect(1, 68922, '\p{^Is_Script_Extensions=_ HANIFI_ROHINGYA}', "");
    Expect(1, 68922, '\P{Is_Script_Extensions=_ HANIFI_ROHINGYA}', "");
    Expect(0, 68922, '\P{^Is_Script_Extensions=_ HANIFI_ROHINGYA}', "");
    Error('\p{Is_Scx=:=-rohg}');
    Error('\P{Is_Scx=:=-rohg}');
    Expect(1, 68921, '\p{Is_Scx=rohg}', "");
    Expect(0, 68921, '\p{^Is_Scx=rohg}', "");
    Expect(0, 68921, '\P{Is_Scx=rohg}', "");
    Expect(1, 68921, '\P{^Is_Scx=rohg}', "");
    Expect(0, 68922, '\p{Is_Scx=rohg}', "");
    Expect(1, 68922, '\p{^Is_Scx=rohg}', "");
    Expect(1, 68922, '\P{Is_Scx=rohg}', "");
    Expect(0, 68922, '\P{^Is_Scx=rohg}', "");
    Expect(1, 68921, '\p{Is_Scx=-ROHG}', "");
    Expect(0, 68921, '\p{^Is_Scx=-ROHG}', "");
    Expect(0, 68921, '\P{Is_Scx=-ROHG}', "");
    Expect(1, 68921, '\P{^Is_Scx=-ROHG}', "");
    Expect(0, 68922, '\p{Is_Scx=-ROHG}', "");
    Expect(1, 68922, '\p{^Is_Scx=-ROHG}', "");
    Expect(1, 68922, '\P{Is_Scx=-ROHG}', "");
    Expect(0, 68922, '\P{^Is_Scx=-ROHG}', "");
    Error('\p{Script_Extensions=-:=Runic}');
    Error('\P{Script_Extensions=-:=Runic}');
    Expect(1, 5880, '\p{Script_Extensions=:\ARunic\z:}', "");;
    Expect(0, 5881, '\p{Script_Extensions=:\ARunic\z:}', "");;
    Expect(1, 5880, '\p{Script_Extensions=runic}', "");
    Expect(0, 5880, '\p{^Script_Extensions=runic}', "");
    Expect(0, 5880, '\P{Script_Extensions=runic}', "");
    Expect(1, 5880, '\P{^Script_Extensions=runic}', "");
    Expect(0, 5881, '\p{Script_Extensions=runic}', "");
    Expect(1, 5881, '\p{^Script_Extensions=runic}', "");
    Expect(1, 5881, '\P{Script_Extensions=runic}', "");
    Expect(0, 5881, '\P{^Script_Extensions=runic}', "");
    Expect(1, 5880, '\p{Script_Extensions=:\Arunic\z:}', "");;
    Expect(0, 5881, '\p{Script_Extensions=:\Arunic\z:}', "");;
    Expect(1, 5880, '\p{Script_Extensions= -runic}', "");
    Expect(0, 5880, '\p{^Script_Extensions= -runic}', "");
    Expect(0, 5880, '\P{Script_Extensions= -runic}', "");
    Expect(1, 5880, '\P{^Script_Extensions= -runic}', "");
    Expect(0, 5881, '\p{Script_Extensions= -runic}', "");
    Expect(1, 5881, '\p{^Script_Extensions= -runic}', "");
    Expect(1, 5881, '\P{Script_Extensions= -runic}', "");
    Expect(0, 5881, '\P{^Script_Extensions= -runic}', "");
    Error('\p{Scx=__Runr/a/}');
    Error('\P{Scx=__Runr/a/}');
    Expect(1, 5880, '\p{Scx=:\ARunr\z:}', "");;
    Expect(0, 5881, '\p{Scx=:\ARunr\z:}', "");;
    Expect(1, 5880, '\p{Scx=runr}', "");
    Expect(0, 5880, '\p{^Scx=runr}', "");
    Expect(0, 5880, '\P{Scx=runr}', "");
    Expect(1, 5880, '\P{^Scx=runr}', "");
    Expect(0, 5881, '\p{Scx=runr}', "");
    Expect(1, 5881, '\p{^Scx=runr}', "");
    Expect(1, 5881, '\P{Scx=runr}', "");
    Expect(0, 5881, '\P{^Scx=runr}', "");
    Expect(1, 5880, '\p{Scx=:\Arunr\z:}', "");;
    Expect(0, 5881, '\p{Scx=:\Arunr\z:}', "");;
    Expect(1, 5880, '\p{Scx=	RUNR}', "");
    Expect(0, 5880, '\p{^Scx=	RUNR}', "");
    Expect(0, 5880, '\P{Scx=	RUNR}', "");
    Expect(1, 5880, '\P{^Scx=	RUNR}', "");
    Expect(0, 5881, '\p{Scx=	RUNR}', "");
    Expect(1, 5881, '\p{^Scx=	RUNR}', "");
    Expect(1, 5881, '\P{Scx=	RUNR}', "");
    Expect(0, 5881, '\P{^Scx=	RUNR}', "");
    Error('\p{Is_Script_Extensions=-_Runic/a/}');
    Error('\P{Is_Script_Extensions=-_Runic/a/}');
    Expect(1, 5880, '\p{Is_Script_Extensions=runic}', "");
    Expect(0, 5880, '\p{^Is_Script_Extensions=runic}', "");
    Expect(0, 5880, '\P{Is_Script_Extensions=runic}', "");
    Expect(1, 5880, '\P{^Is_Script_Extensions=runic}', "");
    Expect(0, 5881, '\p{Is_Script_Extensions=runic}', "");
    Expect(1, 5881, '\p{^Is_Script_Extensions=runic}', "");
    Expect(1, 5881, '\P{Is_Script_Extensions=runic}', "");
    Expect(0, 5881, '\P{^Is_Script_Extensions=runic}', "");
    Expect(1, 5880, '\p{Is_Script_Extensions=--runic}', "");
    Expect(0, 5880, '\p{^Is_Script_Extensions=--runic}', "");
    Expect(0, 5880, '\P{Is_Script_Extensions=--runic}', "");
    Expect(1, 5880, '\P{^Is_Script_Extensions=--runic}', "");
    Expect(0, 5881, '\p{Is_Script_Extensions=--runic}', "");
    Expect(1, 5881, '\p{^Is_Script_Extensions=--runic}', "");
    Expect(1, 5881, '\P{Is_Script_Extensions=--runic}', "");
    Expect(0, 5881, '\P{^Is_Script_Extensions=--runic}', "");
    Error('\p{Is_Scx=_:=RUNR}');
    Error('\P{Is_Scx=_:=RUNR}');
    Expect(1, 5880, '\p{Is_Scx=runr}', "");
    Expect(0, 5880, '\p{^Is_Scx=runr}', "");
    Expect(0, 5880, '\P{Is_Scx=runr}', "");
    Expect(1, 5880, '\P{^Is_Scx=runr}', "");
    Expect(0, 5881, '\p{Is_Scx=runr}', "");
    Expect(1, 5881, '\p{^Is_Scx=runr}', "");
    Expect(1, 5881, '\P{Is_Scx=runr}', "");
    Expect(0, 5881, '\P{^Is_Scx=runr}', "");
    Expect(1, 5880, '\p{Is_Scx=_ Runr}', "");
    Expect(0, 5880, '\p{^Is_Scx=_ Runr}', "");
    Expect(0, 5880, '\P{Is_Scx=_ Runr}', "");
    Expect(1, 5880, '\P{^Is_Scx=_ Runr}', "");
    Expect(0, 5881, '\p{Is_Scx=_ Runr}', "");
    Expect(1, 5881, '\p{^Is_Scx=_ Runr}', "");
    Expect(1, 5881, '\P{Is_Scx=_ Runr}', "");
    Expect(0, 5881, '\P{^Is_Scx=_ Runr}', "");
    Error('\p{Script_Extensions=/a/-Samaritan}');
    Error('\P{Script_Extensions=/a/-Samaritan}');
    Expect(1, 2110, '\p{Script_Extensions=:\ASamaritan\z:}', "");;
    Expect(0, 2111, '\p{Script_Extensions=:\ASamaritan\z:}', "");;
    Expect(1, 2110, '\p{Script_Extensions=samaritan}', "");
    Expect(0, 2110, '\p{^Script_Extensions=samaritan}', "");
    Expect(0, 2110, '\P{Script_Extensions=samaritan}', "");
    Expect(1, 2110, '\P{^Script_Extensions=samaritan}', "");
    Expect(0, 2111, '\p{Script_Extensions=samaritan}', "");
    Expect(1, 2111, '\p{^Script_Extensions=samaritan}', "");
    Expect(1, 2111, '\P{Script_Extensions=samaritan}', "");
    Expect(0, 2111, '\P{^Script_Extensions=samaritan}', "");
    Expect(1, 2110, '\p{Script_Extensions=:\Asamaritan\z:}', "");;
    Expect(0, 2111, '\p{Script_Extensions=:\Asamaritan\z:}', "");;
    Expect(1, 2110, '\p{Script_Extensions= Samaritan}', "");
    Expect(0, 2110, '\p{^Script_Extensions= Samaritan}', "");
    Expect(0, 2110, '\P{Script_Extensions= Samaritan}', "");
    Expect(1, 2110, '\P{^Script_Extensions= Samaritan}', "");
    Expect(0, 2111, '\p{Script_Extensions= Samaritan}', "");
    Expect(1, 2111, '\p{^Script_Extensions= Samaritan}', "");
    Expect(1, 2111, '\P{Script_Extensions= Samaritan}', "");
    Expect(0, 2111, '\P{^Script_Extensions= Samaritan}', "");
    Error('\p{Scx=:=--Samr}');
    Error('\P{Scx=:=--Samr}');
    Expect(1, 2110, '\p{Scx=:\ASamr\z:}', "");;
    Expect(0, 2111, '\p{Scx=:\ASamr\z:}', "");;
    Expect(1, 2110, '\p{Scx=samr}', "");
    Expect(0, 2110, '\p{^Scx=samr}', "");
    Expect(0, 2110, '\P{Scx=samr}', "");
    Expect(1, 2110, '\P{^Scx=samr}', "");
    Expect(0, 2111, '\p{Scx=samr}', "");
    Expect(1, 2111, '\p{^Scx=samr}', "");
    Expect(1, 2111, '\P{Scx=samr}', "");
    Expect(0, 2111, '\P{^Scx=samr}', "");
    Expect(1, 2110, '\p{Scx=:\Asamr\z:}', "");;
    Expect(0, 2111, '\p{Scx=:\Asamr\z:}', "");;
    Expect(1, 2110, '\p{Scx= 	samr}', "");
    Expect(0, 2110, '\p{^Scx= 	samr}', "");
    Expect(0, 2110, '\P{Scx= 	samr}', "");
    Expect(1, 2110, '\P{^Scx= 	samr}', "");
    Expect(0, 2111, '\p{Scx= 	samr}', "");
    Expect(1, 2111, '\p{^Scx= 	samr}', "");
    Expect(1, 2111, '\P{Scx= 	samr}', "");
    Expect(0, 2111, '\P{^Scx= 	samr}', "");
    Error('\p{Is_Script_Extensions=/a/-Samaritan}');
    Error('\P{Is_Script_Extensions=/a/-Samaritan}');
    Expect(1, 2110, '\p{Is_Script_Extensions=samaritan}', "");
    Expect(0, 2110, '\p{^Is_Script_Extensions=samaritan}', "");
    Expect(0, 2110, '\P{Is_Script_Extensions=samaritan}', "");
    Expect(1, 2110, '\P{^Is_Script_Extensions=samaritan}', "");
    Expect(0, 2111, '\p{Is_Script_Extensions=samaritan}', "");
    Expect(1, 2111, '\p{^Is_Script_Extensions=samaritan}', "");
    Expect(1, 2111, '\P{Is_Script_Extensions=samaritan}', "");
    Expect(0, 2111, '\P{^Is_Script_Extensions=samaritan}', "");
    Expect(1, 2110, '\p{Is_Script_Extensions=--samaritan}', "");
    Expect(0, 2110, '\p{^Is_Script_Extensions=--samaritan}', "");
    Expect(0, 2110, '\P{Is_Script_Extensions=--samaritan}', "");
    Expect(1, 2110, '\P{^Is_Script_Extensions=--samaritan}', "");
    Expect(0, 2111, '\p{Is_Script_Extensions=--samaritan}', "");
    Expect(1, 2111, '\p{^Is_Script_Extensions=--samaritan}', "");
    Expect(1, 2111, '\P{Is_Script_Extensions=--samaritan}', "");
    Expect(0, 2111, '\P{^Is_Script_Extensions=--samaritan}', "");
    Error('\p{Is_Scx=-/a/SAMR}');
    Error('\P{Is_Scx=-/a/SAMR}');
    Expect(1, 2110, '\p{Is_Scx=samr}', "");
    Expect(0, 2110, '\p{^Is_Scx=samr}', "");
    Expect(0, 2110, '\P{Is_Scx=samr}', "");
    Expect(1, 2110, '\P{^Is_Scx=samr}', "");
    Expect(0, 2111, '\p{Is_Scx=samr}', "");
    Expect(1, 2111, '\p{^Is_Scx=samr}', "");
    Expect(1, 2111, '\P{Is_Scx=samr}', "");
    Expect(0, 2111, '\P{^Is_Scx=samr}', "");
    Expect(1, 2110, '\p{Is_Scx=_Samr}', "");
    Expect(0, 2110, '\p{^Is_Scx=_Samr}', "");
    Expect(0, 2110, '\P{Is_Scx=_Samr}', "");
    Expect(1, 2110, '\P{^Is_Scx=_Samr}', "");
    Expect(0, 2111, '\p{Is_Scx=_Samr}', "");
    Expect(1, 2111, '\p{^Is_Scx=_Samr}', "");
    Expect(1, 2111, '\P{Is_Scx=_Samr}', "");
    Expect(0, 2111, '\P{^Is_Scx=_Samr}', "");
    Error('\p{Script_Extensions=:=-old_south_Arabian}');
    Error('\P{Script_Extensions=:=-old_south_Arabian}');
    Expect(1, 68223, '\p{Script_Extensions=:\AOld_South_Arabian\z:}', "");;
    Expect(0, 68224, '\p{Script_Extensions=:\AOld_South_Arabian\z:}', "");;
    Expect(1, 68223, '\p{Script_Extensions: oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Script_Extensions: oldsoutharabian}', "");
    Expect(0, 68223, '\P{Script_Extensions: oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Script_Extensions: oldsoutharabian}', "");
    Expect(0, 68224, '\p{Script_Extensions: oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Script_Extensions: oldsoutharabian}', "");
    Expect(1, 68224, '\P{Script_Extensions: oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Script_Extensions: oldsoutharabian}', "");
    Expect(1, 68223, '\p{Script_Extensions=:\Aoldsoutharabian\z:}', "");;
    Expect(0, 68224, '\p{Script_Extensions=:\Aoldsoutharabian\z:}', "");;
    Expect(1, 68223, '\p{Script_Extensions=_Old_SOUTH_arabian}', "");
    Expect(0, 68223, '\p{^Script_Extensions=_Old_SOUTH_arabian}', "");
    Expect(0, 68223, '\P{Script_Extensions=_Old_SOUTH_arabian}', "");
    Expect(1, 68223, '\P{^Script_Extensions=_Old_SOUTH_arabian}', "");
    Expect(0, 68224, '\p{Script_Extensions=_Old_SOUTH_arabian}', "");
    Expect(1, 68224, '\p{^Script_Extensions=_Old_SOUTH_arabian}', "");
    Expect(1, 68224, '\P{Script_Extensions=_Old_SOUTH_arabian}', "");
    Expect(0, 68224, '\P{^Script_Extensions=_Old_SOUTH_arabian}', "");
    Error('\p{Scx=	_sarb/a/}');
    Error('\P{Scx=	_sarb/a/}');
    Expect(1, 68223, '\p{Scx=:\ASarb\z:}', "");;
    Expect(0, 68224, '\p{Scx=:\ASarb\z:}', "");;
    Expect(1, 68223, '\p{Scx=sarb}', "");
    Expect(0, 68223, '\p{^Scx=sarb}', "");
    Expect(0, 68223, '\P{Scx=sarb}', "");
    Expect(1, 68223, '\P{^Scx=sarb}', "");
    Expect(0, 68224, '\p{Scx=sarb}', "");
    Expect(1, 68224, '\p{^Scx=sarb}', "");
    Expect(1, 68224, '\P{Scx=sarb}', "");
    Expect(0, 68224, '\P{^Scx=sarb}', "");
    Expect(1, 68223, '\p{Scx=:\Asarb\z:}', "");;
    Expect(0, 68224, '\p{Scx=:\Asarb\z:}', "");;
    Expect(1, 68223, '\p{Scx=_ Sarb}', "");
    Expect(0, 68223, '\p{^Scx=_ Sarb}', "");
    Expect(0, 68223, '\P{Scx=_ Sarb}', "");
    Expect(1, 68223, '\P{^Scx=_ Sarb}', "");
    Expect(0, 68224, '\p{Scx=_ Sarb}', "");
    Expect(1, 68224, '\p{^Scx=_ Sarb}', "");
    Expect(1, 68224, '\P{Scx=_ Sarb}', "");
    Expect(0, 68224, '\P{^Scx=_ Sarb}', "");
    Error('\p{Is_Script_Extensions= :=old_SOUTH_Arabian}');
    Error('\P{Is_Script_Extensions= :=old_SOUTH_Arabian}');
    Expect(1, 68223, '\p{Is_Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68223, '\p{^Is_Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68223, '\P{Is_Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68223, '\P{^Is_Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68224, '\p{Is_Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68224, '\p{^Is_Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68224, '\P{Is_Script_Extensions=oldsoutharabian}', "");
    Expect(0, 68224, '\P{^Is_Script_Extensions=oldsoutharabian}', "");
    Expect(1, 68223, '\p{Is_Script_Extensions=OLD_South_Arabian}', "");
    Expect(0, 68223, '\p{^Is_Script_Extensions=OLD_South_Arabian}', "");
    Expect(0, 68223, '\P{Is_Script_Extensions=OLD_South_Arabian}', "");
    Expect(1, 68223, '\P{^Is_Script_Extensions=OLD_South_Arabian}', "");
    Expect(0, 68224, '\p{Is_Script_Extensions=OLD_South_Arabian}', "");
    Expect(1, 68224, '\p{^Is_Script_Extensions=OLD_South_Arabian}', "");
    Expect(1, 68224, '\P{Is_Script_Extensions=OLD_South_Arabian}', "");
    Expect(0, 68224, '\P{^Is_Script_Extensions=OLD_South_Arabian}', "");
    Error('\p{Is_Scx=	 Sarb:=}');
    Error('\P{Is_Scx=	 Sarb:=}');
    Expect(1, 68223, '\p{Is_Scx:	sarb}', "");
    Expect(0, 68223, '\p{^Is_Scx:	sarb}', "");
    Expect(0, 68223, '\P{Is_Scx:	sarb}', "");
    Expect(1, 68223, '\P{^Is_Scx:	sarb}', "");
    Expect(0, 68224, '\p{Is_Scx:	sarb}', "");
    Expect(1, 68224, '\p{^Is_Scx:	sarb}', "");
    Expect(1, 68224, '\P{Is_Scx:	sarb}', "");
    Expect(0, 68224, '\P{^Is_Scx:	sarb}', "");
    Expect(1, 68223, '\p{Is_Scx=- SARB}', "");
    Expect(0, 68223, '\p{^Is_Scx=- SARB}', "");
    Expect(0, 68223, '\P{Is_Scx=- SARB}', "");
    Expect(1, 68223, '\P{^Is_Scx=- SARB}', "");
    Expect(0, 68224, '\p{Is_Scx=- SARB}', "");
    Expect(1, 68224, '\p{^Is_Scx=- SARB}', "");
    Expect(1, 68224, '\P{Is_Scx=- SARB}', "");
    Expect(0, 68224, '\P{^Is_Scx=- SARB}', "");
    Error('\p{Script_Extensions=/a/  SAURASHTRA}');
    Error('\P{Script_Extensions=/a/  SAURASHTRA}');
    Expect(1, 43225, '\p{Script_Extensions=:\ASaurashtra\z:}', "");;
    Expect(0, 43226, '\p{Script_Extensions=:\ASaurashtra\z:}', "");;
    Expect(1, 43225, '\p{Script_Extensions=saurashtra}', "");
    Expect(0, 43225, '\p{^Script_Extensions=saurashtra}', "");
    Expect(0, 43225, '\P{Script_Extensions=saurashtra}', "");
    Expect(1, 43225, '\P{^Script_Extensions=saurashtra}', "");
    Expect(0, 43226, '\p{Script_Extensions=saurashtra}', "");
    Expect(1, 43226, '\p{^Script_Extensions=saurashtra}', "");
    Expect(1, 43226, '\P{Script_Extensions=saurashtra}', "");
    Expect(0, 43226, '\P{^Script_Extensions=saurashtra}', "");
    Expect(1, 43225, '\p{Script_Extensions=:\Asaurashtra\z:}', "");;
    Expect(0, 43226, '\p{Script_Extensions=:\Asaurashtra\z:}', "");;
    Expect(1, 43225, '\p{Script_Extensions=	 saurashtra}', "");
    Expect(0, 43225, '\p{^Script_Extensions=	 saurashtra}', "");
    Expect(0, 43225, '\P{Script_Extensions=	 saurashtra}', "");
    Expect(1, 43225, '\P{^Script_Extensions=	 saurashtra}', "");
    Expect(0, 43226, '\p{Script_Extensions=	 saurashtra}', "");
    Expect(1, 43226, '\p{^Script_Extensions=	 saurashtra}', "");
    Expect(1, 43226, '\P{Script_Extensions=	 saurashtra}', "");
    Expect(0, 43226, '\P{^Script_Extensions=	 saurashtra}', "");
    Error('\p{Scx=_ Saur/a/}');
    Error('\P{Scx=_ Saur/a/}');
    Expect(1, 43225, '\p{Scx=:\ASaur\z:}', "");;
    Expect(0, 43226, '\p{Scx=:\ASaur\z:}', "");;
    Expect(1, 43225, '\p{Scx=saur}', "");
    Expect(0, 43225, '\p{^Scx=saur}', "");
    Expect(0, 43225, '\P{Scx=saur}', "");
    Expect(1, 43225, '\P{^Scx=saur}', "");
    Expect(0, 43226, '\p{Scx=saur}', "");
    Expect(1, 43226, '\p{^Scx=saur}', "");
    Expect(1, 43226, '\P{Scx=saur}', "");
    Expect(0, 43226, '\P{^Scx=saur}', "");
    Expect(1, 43225, '\p{Scx=:\Asaur\z:}', "");;
    Expect(0, 43226, '\p{Scx=:\Asaur\z:}', "");;
    Expect(1, 43225, '\p{Scx=__Saur}', "");
    Expect(0, 43225, '\p{^Scx=__Saur}', "");
    Expect(0, 43225, '\P{Scx=__Saur}', "");
    Expect(1, 43225, '\P{^Scx=__Saur}', "");
    Expect(0, 43226, '\p{Scx=__Saur}', "");
    Expect(1, 43226, '\p{^Scx=__Saur}', "");
    Expect(1, 43226, '\P{Scx=__Saur}', "");
    Expect(0, 43226, '\P{^Scx=__Saur}', "");
    Error('\p{Is_Script_Extensions= 	Saurashtra:=}');
    Error('\P{Is_Script_Extensions= 	Saurashtra:=}');
    Expect(1, 43225, '\p{Is_Script_Extensions=saurashtra}', "");
    Expect(0, 43225, '\p{^Is_Script_Extensions=saurashtra}', "");
    Expect(0, 43225, '\P{Is_Script_Extensions=saurashtra}', "");
    Expect(1, 43225, '\P{^Is_Script_Extensions=saurashtra}', "");
    Expect(0, 43226, '\p{Is_Script_Extensions=saurashtra}', "");
    Expect(1, 43226, '\p{^Is_Script_Extensions=saurashtra}', "");
    Expect(1, 43226, '\P{Is_Script_Extensions=saurashtra}', "");
    Expect(0, 43226, '\P{^Is_Script_Extensions=saurashtra}', "");
    Expect(1, 43225, '\p{Is_Script_Extensions=_Saurashtra}', "");
    Expect(0, 43225, '\p{^Is_Script_Extensions=_Saurashtra}', "");
    Expect(0, 43225, '\P{Is_Script_Extensions=_Saurashtra}', "");
    Expect(1, 43225, '\P{^Is_Script_Extensions=_Saurashtra}', "");
    Expect(0, 43226, '\p{Is_Script_Extensions=_Saurashtra}', "");
    Expect(1, 43226, '\p{^Is_Script_Extensions=_Saurashtra}', "");
    Expect(1, 43226, '\P{Is_Script_Extensions=_Saurashtra}', "");
    Expect(0, 43226, '\P{^Is_Script_Extensions=_Saurashtra}', "");
    Error('\p{Is_Scx=		saur:=}');
    Error('\P{Is_Scx=		saur:=}');
    Expect(1, 43225, '\p{Is_Scx:saur}', "");
    Expect(0, 43225, '\p{^Is_Scx:saur}', "");
    Expect(0, 43225, '\P{Is_Scx:saur}', "");
    Expect(1, 43225, '\P{^Is_Scx:saur}', "");
    Expect(0, 43226, '\p{Is_Scx:saur}', "");
    Expect(1, 43226, '\p{^Is_Scx:saur}', "");
    Expect(1, 43226, '\P{Is_Scx:saur}', "");
    Expect(0, 43226, '\P{^Is_Scx:saur}', "");
    Expect(1, 43225, '\p{Is_Scx= 	SAUR}', "");
    Expect(0, 43225, '\p{^Is_Scx= 	SAUR}', "");
    Expect(0, 43225, '\P{Is_Scx= 	SAUR}', "");
    Expect(1, 43225, '\P{^Is_Scx= 	SAUR}', "");
    Expect(0, 43226, '\p{Is_Scx= 	SAUR}', "");
    Expect(1, 43226, '\p{^Is_Scx= 	SAUR}', "");
    Expect(1, 43226, '\P{Is_Scx= 	SAUR}', "");
    Expect(0, 43226, '\P{^Is_Scx= 	SAUR}', "");
    Error('\p{Script_Extensions:		 SignWriting:=}');
    Error('\P{Script_Extensions:		 SignWriting:=}');
    Expect(1, 121519, '\p{Script_Extensions=:\ASignWriting\z:}', "");;
    Expect(0, 121520, '\p{Script_Extensions=:\ASignWriting\z:}', "");;
    Expect(1, 121519, '\p{Script_Extensions=signwriting}', "");
    Expect(0, 121519, '\p{^Script_Extensions=signwriting}', "");
    Expect(0, 121519, '\P{Script_Extensions=signwriting}', "");
    Expect(1, 121519, '\P{^Script_Extensions=signwriting}', "");
    Expect(0, 121520, '\p{Script_Extensions=signwriting}', "");
    Expect(1, 121520, '\p{^Script_Extensions=signwriting}', "");
    Expect(1, 121520, '\P{Script_Extensions=signwriting}', "");
    Expect(0, 121520, '\P{^Script_Extensions=signwriting}', "");
    Expect(1, 121519, '\p{Script_Extensions=:\Asignwriting\z:}', "");;
    Expect(0, 121520, '\p{Script_Extensions=:\Asignwriting\z:}', "");;
    Expect(1, 121519, '\p{Script_Extensions=	-SignWriting}', "");
    Expect(0, 121519, '\p{^Script_Extensions=	-SignWriting}', "");
    Expect(0, 121519, '\P{Script_Extensions=	-SignWriting}', "");
    Expect(1, 121519, '\P{^Script_Extensions=	-SignWriting}', "");
    Expect(0, 121520, '\p{Script_Extensions=	-SignWriting}', "");
    Expect(1, 121520, '\p{^Script_Extensions=	-SignWriting}', "");
    Expect(1, 121520, '\P{Script_Extensions=	-SignWriting}', "");
    Expect(0, 121520, '\P{^Script_Extensions=	-SignWriting}', "");
    Error('\p{Scx= /a/Sgnw}');
    Error('\P{Scx= /a/Sgnw}');
    Expect(1, 121519, '\p{Scx=:\ASgnw\z:}', "");;
    Expect(0, 121520, '\p{Scx=:\ASgnw\z:}', "");;
    Expect(1, 121519, '\p{Scx=sgnw}', "");
    Expect(0, 121519, '\p{^Scx=sgnw}', "");
    Expect(0, 121519, '\P{Scx=sgnw}', "");
    Expect(1, 121519, '\P{^Scx=sgnw}', "");
    Expect(0, 121520, '\p{Scx=sgnw}', "");
    Expect(1, 121520, '\p{^Scx=sgnw}', "");
    Expect(1, 121520, '\P{Scx=sgnw}', "");
    Expect(0, 121520, '\P{^Scx=sgnw}', "");
    Expect(1, 121519, '\p{Scx=:\Asgnw\z:}', "");;
    Expect(0, 121520, '\p{Scx=:\Asgnw\z:}', "");;
    Expect(1, 121519, '\p{Scx=	SGNW}', "");
    Expect(0, 121519, '\p{^Scx=	SGNW}', "");
    Expect(0, 121519, '\P{Scx=	SGNW}', "");
    Expect(1, 121519, '\P{^Scx=	SGNW}', "");
    Expect(0, 121520, '\p{Scx=	SGNW}', "");
    Expect(1, 121520, '\p{^Scx=	SGNW}', "");
    Expect(1, 121520, '\P{Scx=	SGNW}', "");
    Expect(0, 121520, '\P{^Scx=	SGNW}', "");
    Error('\p{Is_Script_Extensions=/a/--SignWriting}');
    Error('\P{Is_Script_Extensions=/a/--SignWriting}');
    Expect(1, 121519, '\p{Is_Script_Extensions:   signwriting}', "");
    Expect(0, 121519, '\p{^Is_Script_Extensions:   signwriting}', "");
    Expect(0, 121519, '\P{Is_Script_Extensions:   signwriting}', "");
    Expect(1, 121519, '\P{^Is_Script_Extensions:   signwriting}', "");
    Expect(0, 121520, '\p{Is_Script_Extensions:   signwriting}', "");
    Expect(1, 121520, '\p{^Is_Script_Extensions:   signwriting}', "");
    Expect(1, 121520, '\P{Is_Script_Extensions:   signwriting}', "");
    Expect(0, 121520, '\P{^Is_Script_Extensions:   signwriting}', "");
    Expect(1, 121519, '\p{Is_Script_Extensions=-SIGNWRITING}', "");
    Expect(0, 121519, '\p{^Is_Script_Extensions=-SIGNWRITING}', "");
    Expect(0, 121519, '\P{Is_Script_Extensions=-SIGNWRITING}', "");
    Expect(1, 121519, '\P{^Is_Script_Extensions=-SIGNWRITING}', "");
    Expect(0, 121520, '\p{Is_Script_Extensions=-SIGNWRITING}', "");
    Expect(1, 121520, '\p{^Is_Script_Extensions=-SIGNWRITING}', "");
    Expect(1, 121520, '\P{Is_Script_Extensions=-SIGNWRITING}', "");
    Expect(0, 121520, '\P{^Is_Script_Extensions=-SIGNWRITING}', "");
    Error('\p{Is_Scx=_/a/SGNW}');
    Error('\P{Is_Scx=_/a/SGNW}');
    Expect(1, 121519, '\p{Is_Scx=sgnw}', "");
    Expect(0, 121519, '\p{^Is_Scx=sgnw}', "");
    Expect(0, 121519, '\P{Is_Scx=sgnw}', "");
    Expect(1, 121519, '\P{^Is_Scx=sgnw}', "");
    Expect(0, 121520, '\p{Is_Scx=sgnw}', "");
    Expect(1, 121520, '\p{^Is_Scx=sgnw}', "");
    Expect(1, 121520, '\P{Is_Scx=sgnw}', "");
    Expect(0, 121520, '\P{^Is_Scx=sgnw}', "");
    Expect(1, 121519, '\p{Is_Scx=-_sgnw}', "");
    Expect(0, 121519, '\p{^Is_Scx=-_sgnw}', "");
    Expect(0, 121519, '\P{Is_Scx=-_sgnw}', "");
    Expect(1, 121519, '\P{^Is_Scx=-_sgnw}', "");
    Expect(0, 121520, '\p{Is_Scx=-_sgnw}', "");
    Expect(1, 121520, '\p{^Is_Scx=-_sgnw}', "");
    Expect(1, 121520, '\P{Is_Scx=-_sgnw}', "");
    Expect(0, 121520, '\P{^Is_Scx=-_sgnw}', "");
    Error('\p{Script_Extensions=--Shavian/a/}');
    Error('\P{Script_Extensions=--Shavian/a/}');
    Expect(1, 66687, '\p{Script_Extensions=:\AShavian\z:}', "");;
    Expect(0, 66688, '\p{Script_Extensions=:\AShavian\z:}', "");;
    Expect(1, 66687, '\p{Script_Extensions=shavian}', "");
    Expect(0, 66687, '\p{^Script_Extensions=shavian}', "");
    Expect(0, 66687, '\P{Script_Extensions=shavian}', "");
    Expect(1, 66687, '\P{^Script_Extensions=shavian}', "");
    Expect(0, 66688, '\p{Script_Extensions=shavian}', "");
    Expect(1, 66688, '\p{^Script_Extensions=shavian}', "");
    Expect(1, 66688, '\P{Script_Extensions=shavian}', "");
    Expect(0, 66688, '\P{^Script_Extensions=shavian}', "");
    Expect(1, 66687, '\p{Script_Extensions=:\Ashavian\z:}', "");;
    Expect(0, 66688, '\p{Script_Extensions=:\Ashavian\z:}', "");;
    Expect(1, 66687, '\p{Script_Extensions= SHAVIAN}', "");
    Expect(0, 66687, '\p{^Script_Extensions= SHAVIAN}', "");
    Expect(0, 66687, '\P{Script_Extensions= SHAVIAN}', "");
    Expect(1, 66687, '\P{^Script_Extensions= SHAVIAN}', "");
    Expect(0, 66688, '\p{Script_Extensions= SHAVIAN}', "");
    Expect(1, 66688, '\p{^Script_Extensions= SHAVIAN}', "");
    Expect(1, 66688, '\P{Script_Extensions= SHAVIAN}', "");
    Expect(0, 66688, '\P{^Script_Extensions= SHAVIAN}', "");
    Error('\p{Scx=/a/	Shaw}');
    Error('\P{Scx=/a/	Shaw}');
    Expect(1, 66687, '\p{Scx=:\AShaw\z:}', "");;
    Expect(0, 66688, '\p{Scx=:\AShaw\z:}', "");;
    Expect(1, 66687, '\p{Scx: shaw}', "");
    Expect(0, 66687, '\p{^Scx: shaw}', "");
    Expect(0, 66687, '\P{Scx: shaw}', "");
    Expect(1, 66687, '\P{^Scx: shaw}', "");
    Expect(0, 66688, '\p{Scx: shaw}', "");
    Expect(1, 66688, '\p{^Scx: shaw}', "");
    Expect(1, 66688, '\P{Scx: shaw}', "");
    Expect(0, 66688, '\P{^Scx: shaw}', "");
    Expect(1, 66687, '\p{Scx=:\Ashaw\z:}', "");;
    Expect(0, 66688, '\p{Scx=:\Ashaw\z:}', "");;
    Expect(1, 66687, '\p{Scx=	 SHAW}', "");
    Expect(0, 66687, '\p{^Scx=	 SHAW}', "");
    Expect(0, 66687, '\P{Scx=	 SHAW}', "");
    Expect(1, 66687, '\P{^Scx=	 SHAW}', "");
    Expect(0, 66688, '\p{Scx=	 SHAW}', "");
    Expect(1, 66688, '\p{^Scx=	 SHAW}', "");
    Expect(1, 66688, '\P{Scx=	 SHAW}', "");
    Expect(0, 66688, '\P{^Scx=	 SHAW}', "");
    Error('\p{Is_Script_Extensions:	--Shavian/a/}');
    Error('\P{Is_Script_Extensions:	--Shavian/a/}');
    Expect(1, 66687, '\p{Is_Script_Extensions=shavian}', "");
    Expect(0, 66687, '\p{^Is_Script_Extensions=shavian}', "");
    Expect(0, 66687, '\P{Is_Script_Extensions=shavian}', "");
    Expect(1, 66687, '\P{^Is_Script_Extensions=shavian}', "");
    Expect(0, 66688, '\p{Is_Script_Extensions=shavian}', "");
    Expect(1, 66688, '\p{^Is_Script_Extensions=shavian}', "");
    Expect(1, 66688, '\P{Is_Script_Extensions=shavian}', "");
    Expect(0, 66688, '\P{^Is_Script_Extensions=shavian}', "");
    Expect(1, 66687, '\p{Is_Script_Extensions=_-SHAVIAN}', "");
    Expect(0, 66687, '\p{^Is_Script_Extensions=_-SHAVIAN}', "");
    Expect(0, 66687, '\P{Is_Script_Extensions=_-SHAVIAN}', "");
    Expect(1, 66687, '\P{^Is_Script_Extensions=_-SHAVIAN}', "");
    Expect(0, 66688, '\p{Is_Script_Extensions=_-SHAVIAN}', "");
    Expect(1, 66688, '\p{^Is_Script_Extensions=_-SHAVIAN}', "");
    Expect(1, 66688, '\P{Is_Script_Extensions=_-SHAVIAN}', "");
    Expect(0, 66688, '\P{^Is_Script_Extensions=_-SHAVIAN}', "");
    Error('\p{Is_Scx=	:=Shaw}');
    Error('\P{Is_Scx=	:=Shaw}');
    Expect(1, 66687, '\p{Is_Scx:	shaw}', "");
    Expect(0, 66687, '\p{^Is_Scx:	shaw}', "");
    Expect(0, 66687, '\P{Is_Scx:	shaw}', "");
    Expect(1, 66687, '\P{^Is_Scx:	shaw}', "");
    Expect(0, 66688, '\p{Is_Scx:	shaw}', "");
    Expect(1, 66688, '\p{^Is_Scx:	shaw}', "");
    Expect(1, 66688, '\P{Is_Scx:	shaw}', "");
    Expect(0, 66688, '\P{^Is_Scx:	shaw}', "");
    Expect(1, 66687, '\p{Is_Scx=		Shaw}', "");
    Expect(0, 66687, '\p{^Is_Scx=		Shaw}', "");
    Expect(0, 66687, '\P{Is_Scx=		Shaw}', "");
    Expect(1, 66687, '\P{^Is_Scx=		Shaw}', "");
    Expect(0, 66688, '\p{Is_Scx=		Shaw}', "");
    Expect(1, 66688, '\p{^Is_Scx=		Shaw}', "");
    Expect(1, 66688, '\P{Is_Scx=		Shaw}', "");
    Expect(0, 66688, '\P{^Is_Scx=		Shaw}', "");
    Error('\p{Script_Extensions:	:=_sharada}');
    Error('\P{Script_Extensions:	:=_sharada}');
    Expect(1, 70111, '\p{Script_Extensions=:\ASharada\z:}', "");;
    Expect(0, 70112, '\p{Script_Extensions=:\ASharada\z:}', "");;
    Expect(1, 70111, '\p{Script_Extensions=sharada}', "");
    Expect(0, 70111, '\p{^Script_Extensions=sharada}', "");
    Expect(0, 70111, '\P{Script_Extensions=sharada}', "");
    Expect(1, 70111, '\P{^Script_Extensions=sharada}', "");
    Expect(0, 70112, '\p{Script_Extensions=sharada}', "");
    Expect(1, 70112, '\p{^Script_Extensions=sharada}', "");
    Expect(1, 70112, '\P{Script_Extensions=sharada}', "");
    Expect(0, 70112, '\P{^Script_Extensions=sharada}', "");
    Expect(1, 70111, '\p{Script_Extensions=:\Asharada\z:}', "");;
    Expect(0, 70112, '\p{Script_Extensions=:\Asharada\z:}', "");;
    Expect(1, 70111, '\p{Script_Extensions=__SHARADA}', "");
    Expect(0, 70111, '\p{^Script_Extensions=__SHARADA}', "");
    Expect(0, 70111, '\P{Script_Extensions=__SHARADA}', "");
    Expect(1, 70111, '\P{^Script_Extensions=__SHARADA}', "");
    Expect(0, 70112, '\p{Script_Extensions=__SHARADA}', "");
    Expect(1, 70112, '\p{^Script_Extensions=__SHARADA}', "");
    Expect(1, 70112, '\P{Script_Extensions=__SHARADA}', "");
    Expect(0, 70112, '\P{^Script_Extensions=__SHARADA}', "");
    Error('\p{Scx=/a/__Shrd}');
    Error('\P{Scx=/a/__Shrd}');
    Expect(1, 70111, '\p{Scx=:\AShrd\z:}', "");;
    Expect(0, 70112, '\p{Scx=:\AShrd\z:}', "");;
    Expect(1, 70111, '\p{Scx:	shrd}', "");
    Expect(0, 70111, '\p{^Scx:	shrd}', "");
    Expect(0, 70111, '\P{Scx:	shrd}', "");
    Expect(1, 70111, '\P{^Scx:	shrd}', "");
    Expect(0, 70112, '\p{Scx:	shrd}', "");
    Expect(1, 70112, '\p{^Scx:	shrd}', "");
    Expect(1, 70112, '\P{Scx:	shrd}', "");
    Expect(0, 70112, '\P{^Scx:	shrd}', "");
    Expect(1, 70111, '\p{Scx=:\Ashrd\z:}', "");;
    Expect(0, 70112, '\p{Scx=:\Ashrd\z:}', "");;
    Expect(1, 70111, '\p{Scx:   	Shrd}', "");
    Expect(0, 70111, '\p{^Scx:   	Shrd}', "");
    Expect(0, 70111, '\P{Scx:   	Shrd}', "");
    Expect(1, 70111, '\P{^Scx:   	Shrd}', "");
    Expect(0, 70112, '\p{Scx:   	Shrd}', "");
    Expect(1, 70112, '\p{^Scx:   	Shrd}', "");
    Expect(1, 70112, '\P{Scx:   	Shrd}', "");
    Expect(0, 70112, '\P{^Scx:   	Shrd}', "");
    Error('\p{Is_Script_Extensions=		Sharada:=}');
    Error('\P{Is_Script_Extensions=		Sharada:=}');
    Expect(1, 70111, '\p{Is_Script_Extensions=sharada}', "");
    Expect(0, 70111, '\p{^Is_Script_Extensions=sharada}', "");
    Expect(0, 70111, '\P{Is_Script_Extensions=sharada}', "");
    Expect(1, 70111, '\P{^Is_Script_Extensions=sharada}', "");
    Expect(0, 70112, '\p{Is_Script_Extensions=sharada}', "");
    Expect(1, 70112, '\p{^Is_Script_Extensions=sharada}', "");
    Expect(1, 70112, '\P{Is_Script_Extensions=sharada}', "");
    Expect(0, 70112, '\P{^Is_Script_Extensions=sharada}', "");
    Expect(1, 70111, '\p{Is_Script_Extensions=	Sharada}', "");
    Expect(0, 70111, '\p{^Is_Script_Extensions=	Sharada}', "");
    Expect(0, 70111, '\P{Is_Script_Extensions=	Sharada}', "");
    Expect(1, 70111, '\P{^Is_Script_Extensions=	Sharada}', "");
    Expect(0, 70112, '\p{Is_Script_Extensions=	Sharada}', "");
    Expect(1, 70112, '\p{^Is_Script_Extensions=	Sharada}', "");
    Expect(1, 70112, '\P{Is_Script_Extensions=	Sharada}', "");
    Expect(0, 70112, '\P{^Is_Script_Extensions=	Sharada}', "");
    Error('\p{Is_Scx= 	Shrd/a/}');
    Error('\P{Is_Scx= 	Shrd/a/}');
    Expect(1, 70111, '\p{Is_Scx=shrd}', "");
    Expect(0, 70111, '\p{^Is_Scx=shrd}', "");
    Expect(0, 70111, '\P{Is_Scx=shrd}', "");
    Expect(1, 70111, '\P{^Is_Scx=shrd}', "");
    Expect(0, 70112, '\p{Is_Scx=shrd}', "");
    Expect(1, 70112, '\p{^Is_Scx=shrd}', "");
    Expect(1, 70112, '\P{Is_Scx=shrd}', "");
    Expect(0, 70112, '\P{^Is_Scx=shrd}', "");
    Expect(1, 70111, '\p{Is_Scx= _Shrd}', "");
    Expect(0, 70111, '\p{^Is_Scx= _Shrd}', "");
    Expect(0, 70111, '\P{Is_Scx= _Shrd}', "");
    Expect(1, 70111, '\P{^Is_Scx= _Shrd}', "");
    Expect(0, 70112, '\p{Is_Scx= _Shrd}', "");
    Expect(1, 70112, '\p{^Is_Scx= _Shrd}', "");
    Expect(1, 70112, '\P{Is_Scx= _Shrd}', "");
    Expect(0, 70112, '\P{^Is_Scx= _Shrd}', "");
    Error('\p{Script_Extensions=_siddham/a/}');
    Error('\P{Script_Extensions=_siddham/a/}');
    Expect(1, 71133, '\p{Script_Extensions=:\ASiddham\z:}', "");;
    Expect(0, 71134, '\p{Script_Extensions=:\ASiddham\z:}', "");;
    Expect(1, 71133, '\p{Script_Extensions: siddham}', "");
    Expect(0, 71133, '\p{^Script_Extensions: siddham}', "");
    Expect(0, 71133, '\P{Script_Extensions: siddham}', "");
    Expect(1, 71133, '\P{^Script_Extensions: siddham}', "");
    Expect(0, 71134, '\p{Script_Extensions: siddham}', "");
    Expect(1, 71134, '\p{^Script_Extensions: siddham}', "");
    Expect(1, 71134, '\P{Script_Extensions: siddham}', "");
    Expect(0, 71134, '\P{^Script_Extensions: siddham}', "");
    Expect(1, 71133, '\p{Script_Extensions=:\Asiddham\z:}', "");;
    Expect(0, 71134, '\p{Script_Extensions=:\Asiddham\z:}', "");;
    Expect(1, 71133, '\p{Script_Extensions= siddham}', "");
    Expect(0, 71133, '\p{^Script_Extensions= siddham}', "");
    Expect(0, 71133, '\P{Script_Extensions= siddham}', "");
    Expect(1, 71133, '\P{^Script_Extensions= siddham}', "");
    Expect(0, 71134, '\p{Script_Extensions= siddham}', "");
    Expect(1, 71134, '\p{^Script_Extensions= siddham}', "");
    Expect(1, 71134, '\P{Script_Extensions= siddham}', "");
    Expect(0, 71134, '\P{^Script_Extensions= siddham}', "");
    Error('\p{Scx:	-sidd:=}');
    Error('\P{Scx:	-sidd:=}');
    Expect(1, 71133, '\p{Scx=:\ASidd\z:}', "");;
    Expect(0, 71134, '\p{Scx=:\ASidd\z:}', "");;
    Expect(1, 71133, '\p{Scx=sidd}', "");
    Expect(0, 71133, '\p{^Scx=sidd}', "");
    Expect(0, 71133, '\P{Scx=sidd}', "");
    Expect(1, 71133, '\P{^Scx=sidd}', "");
    Expect(0, 71134, '\p{Scx=sidd}', "");
    Expect(1, 71134, '\p{^Scx=sidd}', "");
    Expect(1, 71134, '\P{Scx=sidd}', "");
    Expect(0, 71134, '\P{^Scx=sidd}', "");
    Expect(1, 71133, '\p{Scx=:\Asidd\z:}', "");;
    Expect(0, 71134, '\p{Scx=:\Asidd\z:}', "");;
    Expect(1, 71133, '\p{Scx=Sidd}', "");
    Expect(0, 71133, '\p{^Scx=Sidd}', "");
    Expect(0, 71133, '\P{Scx=Sidd}', "");
    Expect(1, 71133, '\P{^Scx=Sidd}', "");
    Expect(0, 71134, '\p{Scx=Sidd}', "");
    Expect(1, 71134, '\p{^Scx=Sidd}', "");
    Expect(1, 71134, '\P{Scx=Sidd}', "");
    Expect(0, 71134, '\P{^Scx=Sidd}', "");
    Error('\p{Is_Script_Extensions=_/a/Siddham}');
    Error('\P{Is_Script_Extensions=_/a/Siddham}');
    Expect(1, 71133, '\p{Is_Script_Extensions=siddham}', "");
    Expect(0, 71133, '\p{^Is_Script_Extensions=siddham}', "");
    Expect(0, 71133, '\P{Is_Script_Extensions=siddham}', "");
    Expect(1, 71133, '\P{^Is_Script_Extensions=siddham}', "");
    Expect(0, 71134, '\p{Is_Script_Extensions=siddham}', "");
    Expect(1, 71134, '\p{^Is_Script_Extensions=siddham}', "");
    Expect(1, 71134, '\P{Is_Script_Extensions=siddham}', "");
    Expect(0, 71134, '\P{^Is_Script_Extensions=siddham}', "");
    Expect(1, 71133, '\p{Is_Script_Extensions=_ siddham}', "");
    Expect(0, 71133, '\p{^Is_Script_Extensions=_ siddham}', "");
    Expect(0, 71133, '\P{Is_Script_Extensions=_ siddham}', "");
    Expect(1, 71133, '\P{^Is_Script_Extensions=_ siddham}', "");
    Expect(0, 71134, '\p{Is_Script_Extensions=_ siddham}', "");
    Expect(1, 71134, '\p{^Is_Script_Extensions=_ siddham}', "");
    Expect(1, 71134, '\P{Is_Script_Extensions=_ siddham}', "");
    Expect(0, 71134, '\P{^Is_Script_Extensions=_ siddham}', "");
    Error('\p{Is_Scx=__Sidd/a/}');
    Error('\P{Is_Scx=__Sidd/a/}');
    Expect(1, 71133, '\p{Is_Scx=sidd}', "");
    Expect(0, 71133, '\p{^Is_Scx=sidd}', "");
    Expect(0, 71133, '\P{Is_Scx=sidd}', "");
    Expect(1, 71133, '\P{^Is_Scx=sidd}', "");
    Expect(0, 71134, '\p{Is_Scx=sidd}', "");
    Expect(1, 71134, '\p{^Is_Scx=sidd}', "");
    Expect(1, 71134, '\P{Is_Scx=sidd}', "");
    Expect(0, 71134, '\P{^Is_Scx=sidd}', "");
    Expect(1, 71133, '\p{Is_Scx=	sidd}', "");
    Expect(0, 71133, '\p{^Is_Scx=	sidd}', "");
    Expect(0, 71133, '\P{Is_Scx=	sidd}', "");
    Expect(1, 71133, '\P{^Is_Scx=	sidd}', "");
    Expect(0, 71134, '\p{Is_Scx=	sidd}', "");
    Expect(1, 71134, '\p{^Is_Scx=	sidd}', "");
    Expect(1, 71134, '\P{Is_Scx=	sidd}', "");
    Expect(0, 71134, '\P{^Is_Scx=	sidd}', "");
    Error('\p{Script_Extensions=:=KHUDAWADI}');
    Error('\P{Script_Extensions=:=KHUDAWADI}');
    Expect(1, 70393, '\p{Script_Extensions=:\AKhudawadi\z:}', "");;
    Expect(0, 70394, '\p{Script_Extensions=:\AKhudawadi\z:}', "");;
    Expect(1, 70393, '\p{Script_Extensions=khudawadi}', "");
    Expect(0, 70393, '\p{^Script_Extensions=khudawadi}', "");
    Expect(0, 70393, '\P{Script_Extensions=khudawadi}', "");
    Expect(1, 70393, '\P{^Script_Extensions=khudawadi}', "");
    Expect(0, 70394, '\p{Script_Extensions=khudawadi}', "");
    Expect(1, 70394, '\p{^Script_Extensions=khudawadi}', "");
    Expect(1, 70394, '\P{Script_Extensions=khudawadi}', "");
    Expect(0, 70394, '\P{^Script_Extensions=khudawadi}', "");
    Expect(1, 70393, '\p{Script_Extensions=:\Akhudawadi\z:}', "");;
    Expect(0, 70394, '\p{Script_Extensions=:\Akhudawadi\z:}', "");;
    Expect(1, 70393, '\p{Script_Extensions:		Khudawadi}', "");
    Expect(0, 70393, '\p{^Script_Extensions:		Khudawadi}', "");
    Expect(0, 70393, '\P{Script_Extensions:		Khudawadi}', "");
    Expect(1, 70393, '\P{^Script_Extensions:		Khudawadi}', "");
    Expect(0, 70394, '\p{Script_Extensions:		Khudawadi}', "");
    Expect(1, 70394, '\p{^Script_Extensions:		Khudawadi}', "");
    Expect(1, 70394, '\P{Script_Extensions:		Khudawadi}', "");
    Expect(0, 70394, '\P{^Script_Extensions:		Khudawadi}', "");
    Error('\p{Scx=:=_SIND}');
    Error('\P{Scx=:=_SIND}');
    Expect(1, 70393, '\p{Scx=:\ASind\z:}', "");;
    Expect(0, 70394, '\p{Scx=:\ASind\z:}', "");;
    Expect(1, 70393, '\p{Scx=sind}', "");
    Expect(0, 70393, '\p{^Scx=sind}', "");
    Expect(0, 70393, '\P{Scx=sind}', "");
    Expect(1, 70393, '\P{^Scx=sind}', "");
    Expect(0, 70394, '\p{Scx=sind}', "");
    Expect(1, 70394, '\p{^Scx=sind}', "");
    Expect(1, 70394, '\P{Scx=sind}', "");
    Expect(0, 70394, '\P{^Scx=sind}', "");
    Expect(1, 70393, '\p{Scx=:\Asind\z:}', "");;
    Expect(0, 70394, '\p{Scx=:\Asind\z:}', "");;
    Expect(1, 70393, '\p{Scx=	 Sind}', "");
    Expect(0, 70393, '\p{^Scx=	 Sind}', "");
    Expect(0, 70393, '\P{Scx=	 Sind}', "");
    Expect(1, 70393, '\P{^Scx=	 Sind}', "");
    Expect(0, 70394, '\p{Scx=	 Sind}', "");
    Expect(1, 70394, '\p{^Scx=	 Sind}', "");
    Expect(1, 70394, '\P{Scx=	 Sind}', "");
    Expect(0, 70394, '\P{^Scx=	 Sind}', "");
    Error('\p{Is_Script_Extensions=:=_Khudawadi}');
    Error('\P{Is_Script_Extensions=:=_Khudawadi}');
    Expect(1, 70393, '\p{Is_Script_Extensions=khudawadi}', "");
    Expect(0, 70393, '\p{^Is_Script_Extensions=khudawadi}', "");
    Expect(0, 70393, '\P{Is_Script_Extensions=khudawadi}', "");
    Expect(1, 70393, '\P{^Is_Script_Extensions=khudawadi}', "");
    Expect(0, 70394, '\p{Is_Script_Extensions=khudawadi}', "");
    Expect(1, 70394, '\p{^Is_Script_Extensions=khudawadi}', "");
    Expect(1, 70394, '\P{Is_Script_Extensions=khudawadi}', "");
    Expect(0, 70394, '\P{^Is_Script_Extensions=khudawadi}', "");
    Expect(1, 70393, '\p{Is_Script_Extensions=		Khudawadi}', "");
    Expect(0, 70393, '\p{^Is_Script_Extensions=		Khudawadi}', "");
    Expect(0, 70393, '\P{Is_Script_Extensions=		Khudawadi}', "");
    Expect(1, 70393, '\P{^Is_Script_Extensions=		Khudawadi}', "");
    Expect(0, 70394, '\p{Is_Script_Extensions=		Khudawadi}', "");
    Expect(1, 70394, '\p{^Is_Script_Extensions=		Khudawadi}', "");
    Expect(1, 70394, '\P{Is_Script_Extensions=		Khudawadi}', "");
    Expect(0, 70394, '\P{^Is_Script_Extensions=		Khudawadi}', "");
    Error('\p{Is_Scx=/a/		sind}');
    Error('\P{Is_Scx=/a/		sind}');
    Expect(1, 70393, '\p{Is_Scx=sind}', "");
    Expect(0, 70393, '\p{^Is_Scx=sind}', "");
    Expect(0, 70393, '\P{Is_Scx=sind}', "");
    Expect(1, 70393, '\P{^Is_Scx=sind}', "");
    Expect(0, 70394, '\p{Is_Scx=sind}', "");
    Expect(1, 70394, '\p{^Is_Scx=sind}', "");
    Expect(1, 70394, '\P{Is_Scx=sind}', "");
    Expect(0, 70394, '\P{^Is_Scx=sind}', "");
    Expect(1, 70393, '\p{Is_Scx=__sind}', "");
    Expect(0, 70393, '\p{^Is_Scx=__sind}', "");
    Expect(0, 70393, '\P{Is_Scx=__sind}', "");
    Expect(1, 70393, '\P{^Is_Scx=__sind}', "");
    Expect(0, 70394, '\p{Is_Scx=__sind}', "");
    Expect(1, 70394, '\p{^Is_Scx=__sind}', "");
    Expect(1, 70394, '\P{Is_Scx=__sind}', "");
    Expect(0, 70394, '\P{^Is_Scx=__sind}', "");
    Error('\p{Script_Extensions=- SINHALA:=}');
    Error('\P{Script_Extensions=- SINHALA:=}');
    Expect(1, 70132, '\p{Script_Extensions=:\ASinhala\z:}', "");;
    Expect(0, 70133, '\p{Script_Extensions=:\ASinhala\z:}', "");;
    Expect(1, 70132, '\p{Script_Extensions=sinhala}', "");
    Expect(0, 70132, '\p{^Script_Extensions=sinhala}', "");
    Expect(0, 70132, '\P{Script_Extensions=sinhala}', "");
    Expect(1, 70132, '\P{^Script_Extensions=sinhala}', "");
    Expect(0, 70133, '\p{Script_Extensions=sinhala}', "");
    Expect(1, 70133, '\p{^Script_Extensions=sinhala}', "");
    Expect(1, 70133, '\P{Script_Extensions=sinhala}', "");
    Expect(0, 70133, '\P{^Script_Extensions=sinhala}', "");
    Expect(1, 70132, '\p{Script_Extensions=:\Asinhala\z:}', "");;
    Expect(0, 70133, '\p{Script_Extensions=:\Asinhala\z:}', "");;
    Expect(1, 70132, '\p{Script_Extensions=Sinhala}', "");
    Expect(0, 70132, '\p{^Script_Extensions=Sinhala}', "");
    Expect(0, 70132, '\P{Script_Extensions=Sinhala}', "");
    Expect(1, 70132, '\P{^Script_Extensions=Sinhala}', "");
    Expect(0, 70133, '\p{Script_Extensions=Sinhala}', "");
    Expect(1, 70133, '\p{^Script_Extensions=Sinhala}', "");
    Expect(1, 70133, '\P{Script_Extensions=Sinhala}', "");
    Expect(0, 70133, '\P{^Script_Extensions=Sinhala}', "");
    Error('\p{Scx= :=sinh}');
    Error('\P{Scx= :=sinh}');
    Expect(1, 70132, '\p{Scx=:\ASinh\z:}', "");;
    Expect(0, 70133, '\p{Scx=:\ASinh\z:}', "");;
    Expect(1, 70132, '\p{Scx=sinh}', "");
    Expect(0, 70132, '\p{^Scx=sinh}', "");
    Expect(0, 70132, '\P{Scx=sinh}', "");
    Expect(1, 70132, '\P{^Scx=sinh}', "");
    Expect(0, 70133, '\p{Scx=sinh}', "");
    Expect(1, 70133, '\p{^Scx=sinh}', "");
    Expect(1, 70133, '\P{Scx=sinh}', "");
    Expect(0, 70133, '\P{^Scx=sinh}', "");
    Expect(1, 70132, '\p{Scx=:\Asinh\z:}', "");;
    Expect(0, 70133, '\p{Scx=:\Asinh\z:}', "");;
    Expect(1, 70132, '\p{Scx=	-SINH}', "");
    Expect(0, 70132, '\p{^Scx=	-SINH}', "");
    Expect(0, 70132, '\P{Scx=	-SINH}', "");
    Expect(1, 70132, '\P{^Scx=	-SINH}', "");
    Expect(0, 70133, '\p{Scx=	-SINH}', "");
    Expect(1, 70133, '\p{^Scx=	-SINH}', "");
    Expect(1, 70133, '\P{Scx=	-SINH}', "");
    Expect(0, 70133, '\P{^Scx=	-SINH}', "");
    Error('\p{Is_Script_Extensions=/a/ Sinhala}');
    Error('\P{Is_Script_Extensions=/a/ Sinhala}');
    Expect(1, 70132, '\p{Is_Script_Extensions=sinhala}', "");
    Expect(0, 70132, '\p{^Is_Script_Extensions=sinhala}', "");
    Expect(0, 70132, '\P{Is_Script_Extensions=sinhala}', "");
    Expect(1, 70132, '\P{^Is_Script_Extensions=sinhala}', "");
    Expect(0, 70133, '\p{Is_Script_Extensions=sinhala}', "");
    Expect(1, 70133, '\p{^Is_Script_Extensions=sinhala}', "");
    Expect(1, 70133, '\P{Is_Script_Extensions=sinhala}', "");
    Expect(0, 70133, '\P{^Is_Script_Extensions=sinhala}', "");
    Expect(1, 70132, '\p{Is_Script_Extensions=	Sinhala}', "");
    Expect(0, 70132, '\p{^Is_Script_Extensions=	Sinhala}', "");
    Expect(0, 70132, '\P{Is_Script_Extensions=	Sinhala}', "");
    Expect(1, 70132, '\P{^Is_Script_Extensions=	Sinhala}', "");
    Expect(0, 70133, '\p{Is_Script_Extensions=	Sinhala}', "");
    Expect(1, 70133, '\p{^Is_Script_Extensions=	Sinhala}', "");
    Expect(1, 70133, '\P{Is_Script_Extensions=	Sinhala}', "");
    Expect(0, 70133, '\P{^Is_Script_Extensions=	Sinhala}', "");
    Error('\p{Is_Scx=_Sinh:=}');
    Error('\P{Is_Scx=_Sinh:=}');
    Expect(1, 70132, '\p{Is_Scx:sinh}', "");
    Expect(0, 70132, '\p{^Is_Scx:sinh}', "");
    Expect(0, 70132, '\P{Is_Scx:sinh}', "");
    Expect(1, 70132, '\P{^Is_Scx:sinh}', "");
    Expect(0, 70133, '\p{Is_Scx:sinh}', "");
    Expect(1, 70133, '\p{^Is_Scx:sinh}', "");
    Expect(1, 70133, '\P{Is_Scx:sinh}', "");
    Expect(0, 70133, '\P{^Is_Scx:sinh}', "");
    Expect(1, 70132, '\p{Is_Scx:   -_sinh}', "");
    Expect(0, 70132, '\p{^Is_Scx:   -_sinh}', "");
    Expect(0, 70132, '\P{Is_Scx:   -_sinh}', "");
    Expect(1, 70132, '\P{^Is_Scx:   -_sinh}', "");
    Expect(0, 70133, '\p{Is_Scx:   -_sinh}', "");
    Expect(1, 70133, '\p{^Is_Scx:   -_sinh}', "");
    Expect(1, 70133, '\P{Is_Scx:   -_sinh}', "");
    Expect(0, 70133, '\P{^Is_Scx:   -_sinh}', "");
    Error('\p{Script_Extensions=	Sogdian:=}');
    Error('\P{Script_Extensions=	Sogdian:=}');
    Expect(1, 69465, '\p{Script_Extensions=:\ASogdian\z:}', "");;
    Expect(0, 69466, '\p{Script_Extensions=:\ASogdian\z:}', "");;
    Expect(1, 69465, '\p{Script_Extensions=sogdian}', "");
    Expect(0, 69465, '\p{^Script_Extensions=sogdian}', "");
    Expect(0, 69465, '\P{Script_Extensions=sogdian}', "");
    Expect(1, 69465, '\P{^Script_Extensions=sogdian}', "");
    Expect(0, 69466, '\p{Script_Extensions=sogdian}', "");
    Expect(1, 69466, '\p{^Script_Extensions=sogdian}', "");
    Expect(1, 69466, '\P{Script_Extensions=sogdian}', "");
    Expect(0, 69466, '\P{^Script_Extensions=sogdian}', "");
    Expect(1, 69465, '\p{Script_Extensions=:\Asogdian\z:}', "");;
    Expect(0, 69466, '\p{Script_Extensions=:\Asogdian\z:}', "");;
    Expect(1, 69465, '\p{Script_Extensions= SOGDIAN}', "");
    Expect(0, 69465, '\p{^Script_Extensions= SOGDIAN}', "");
    Expect(0, 69465, '\P{Script_Extensions= SOGDIAN}', "");
    Expect(1, 69465, '\P{^Script_Extensions= SOGDIAN}', "");
    Expect(0, 69466, '\p{Script_Extensions= SOGDIAN}', "");
    Expect(1, 69466, '\p{^Script_Extensions= SOGDIAN}', "");
    Expect(1, 69466, '\P{Script_Extensions= SOGDIAN}', "");
    Expect(0, 69466, '\P{^Script_Extensions= SOGDIAN}', "");
    Error('\p{Scx=	/a/sogd}');
    Error('\P{Scx=	/a/sogd}');
    Expect(1, 69465, '\p{Scx=:\ASogd\z:}', "");;
    Expect(0, 69466, '\p{Scx=:\ASogd\z:}', "");;
    Expect(1, 69465, '\p{Scx:sogd}', "");
    Expect(0, 69465, '\p{^Scx:sogd}', "");
    Expect(0, 69465, '\P{Scx:sogd}', "");
    Expect(1, 69465, '\P{^Scx:sogd}', "");
    Expect(0, 69466, '\p{Scx:sogd}', "");
    Expect(1, 69466, '\p{^Scx:sogd}', "");
    Expect(1, 69466, '\P{Scx:sogd}', "");
    Expect(0, 69466, '\P{^Scx:sogd}', "");
    Expect(1, 69465, '\p{Scx=:\Asogd\z:}', "");;
    Expect(0, 69466, '\p{Scx=:\Asogd\z:}', "");;
    Expect(1, 69465, '\p{Scx= -sogd}', "");
    Expect(0, 69465, '\p{^Scx= -sogd}', "");
    Expect(0, 69465, '\P{Scx= -sogd}', "");
    Expect(1, 69465, '\P{^Scx= -sogd}', "");
    Expect(0, 69466, '\p{Scx= -sogd}', "");
    Expect(1, 69466, '\p{^Scx= -sogd}', "");
    Expect(1, 69466, '\P{Scx= -sogd}', "");
    Expect(0, 69466, '\P{^Scx= -sogd}', "");
    Error('\p{Is_Script_Extensions=_ SOGDIAN:=}');
    Error('\P{Is_Script_Extensions=_ SOGDIAN:=}');
    Expect(1, 69465, '\p{Is_Script_Extensions=sogdian}', "");
    Expect(0, 69465, '\p{^Is_Script_Extensions=sogdian}', "");
    Expect(0, 69465, '\P{Is_Script_Extensions=sogdian}', "");
    Expect(1, 69465, '\P{^Is_Script_Extensions=sogdian}', "");
    Expect(0, 69466, '\p{Is_Script_Extensions=sogdian}', "");
    Expect(1, 69466, '\p{^Is_Script_Extensions=sogdian}', "");
    Expect(1, 69466, '\P{Is_Script_Extensions=sogdian}', "");
    Expect(0, 69466, '\P{^Is_Script_Extensions=sogdian}', "");
    Expect(1, 69465, '\p{Is_Script_Extensions=--Sogdian}', "");
    Expect(0, 69465, '\p{^Is_Script_Extensions=--Sogdian}', "");
    Expect(0, 69465, '\P{Is_Script_Extensions=--Sogdian}', "");
    Expect(1, 69465, '\P{^Is_Script_Extensions=--Sogdian}', "");
    Expect(0, 69466, '\p{Is_Script_Extensions=--Sogdian}', "");
    Expect(1, 69466, '\p{^Is_Script_Extensions=--Sogdian}', "");
    Expect(1, 69466, '\P{Is_Script_Extensions=--Sogdian}', "");
    Expect(0, 69466, '\P{^Is_Script_Extensions=--Sogdian}', "");
    Error('\p{Is_Scx=_ Sogd:=}');
    Error('\P{Is_Scx=_ Sogd:=}');
    Expect(1, 69465, '\p{Is_Scx:	sogd}', "");
    Expect(0, 69465, '\p{^Is_Scx:	sogd}', "");
    Expect(0, 69465, '\P{Is_Scx:	sogd}', "");
    Expect(1, 69465, '\P{^Is_Scx:	sogd}', "");
    Expect(0, 69466, '\p{Is_Scx:	sogd}', "");
    Expect(1, 69466, '\p{^Is_Scx:	sogd}', "");
    Expect(1, 69466, '\P{Is_Scx:	sogd}', "");
    Expect(0, 69466, '\P{^Is_Scx:	sogd}', "");
    Expect(1, 69465, '\p{Is_Scx=_Sogd}', "");
    Expect(0, 69465, '\p{^Is_Scx=_Sogd}', "");
    Expect(0, 69465, '\P{Is_Scx=_Sogd}', "");
    Expect(1, 69465, '\P{^Is_Scx=_Sogd}', "");
    Expect(0, 69466, '\p{Is_Scx=_Sogd}', "");
    Expect(1, 69466, '\p{^Is_Scx=_Sogd}', "");
    Expect(1, 69466, '\P{Is_Scx=_Sogd}', "");
    Expect(0, 69466, '\P{^Is_Scx=_Sogd}', "");
    Error('\p{Script_Extensions=- OLD_Sogdian:=}');
    Error('\P{Script_Extensions=- OLD_Sogdian:=}');
    Expect(1, 69415, '\p{Script_Extensions=:\AOld_Sogdian\z:}', "");;
    Expect(0, 69416, '\p{Script_Extensions=:\AOld_Sogdian\z:}', "");;
    Expect(1, 69415, '\p{Script_Extensions=oldsogdian}', "");
    Expect(0, 69415, '\p{^Script_Extensions=oldsogdian}', "");
    Expect(0, 69415, '\P{Script_Extensions=oldsogdian}', "");
    Expect(1, 69415, '\P{^Script_Extensions=oldsogdian}', "");
    Expect(0, 69416, '\p{Script_Extensions=oldsogdian}', "");
    Expect(1, 69416, '\p{^Script_Extensions=oldsogdian}', "");
    Expect(1, 69416, '\P{Script_Extensions=oldsogdian}', "");
    Expect(0, 69416, '\P{^Script_Extensions=oldsogdian}', "");
    Expect(1, 69415, '\p{Script_Extensions=:\Aoldsogdian\z:}', "");;
    Expect(0, 69416, '\p{Script_Extensions=:\Aoldsogdian\z:}', "");;
    Expect(1, 69415, '\p{Script_Extensions=-old_Sogdian}', "");
    Expect(0, 69415, '\p{^Script_Extensions=-old_Sogdian}', "");
    Expect(0, 69415, '\P{Script_Extensions=-old_Sogdian}', "");
    Expect(1, 69415, '\P{^Script_Extensions=-old_Sogdian}', "");
    Expect(0, 69416, '\p{Script_Extensions=-old_Sogdian}', "");
    Expect(1, 69416, '\p{^Script_Extensions=-old_Sogdian}', "");
    Expect(1, 69416, '\P{Script_Extensions=-old_Sogdian}', "");
    Expect(0, 69416, '\P{^Script_Extensions=-old_Sogdian}', "");
    Error('\p{Scx=/a/-	Sogo}');
    Error('\P{Scx=/a/-	Sogo}');
    Expect(1, 69415, '\p{Scx=:\ASogo\z:}', "");;
    Expect(0, 69416, '\p{Scx=:\ASogo\z:}', "");;
    Expect(1, 69415, '\p{Scx=sogo}', "");
    Expect(0, 69415, '\p{^Scx=sogo}', "");
    Expect(0, 69415, '\P{Scx=sogo}', "");
    Expect(1, 69415, '\P{^Scx=sogo}', "");
    Expect(0, 69416, '\p{Scx=sogo}', "");
    Expect(1, 69416, '\p{^Scx=sogo}', "");
    Expect(1, 69416, '\P{Scx=sogo}', "");
    Expect(0, 69416, '\P{^Scx=sogo}', "");
    Expect(1, 69415, '\p{Scx=:\Asogo\z:}', "");;
    Expect(0, 69416, '\p{Scx=:\Asogo\z:}', "");;
    Expect(1, 69415, '\p{Scx= Sogo}', "");
    Expect(0, 69415, '\p{^Scx= Sogo}', "");
    Expect(0, 69415, '\P{Scx= Sogo}', "");
    Expect(1, 69415, '\P{^Scx= Sogo}', "");
    Expect(0, 69416, '\p{Scx= Sogo}', "");
    Expect(1, 69416, '\p{^Scx= Sogo}', "");
    Expect(1, 69416, '\P{Scx= Sogo}', "");
    Expect(0, 69416, '\P{^Scx= Sogo}', "");
    Error('\p{Is_Script_Extensions=:=	 old_Sogdian}');
    Error('\P{Is_Script_Extensions=:=	 old_Sogdian}');
    Expect(1, 69415, '\p{Is_Script_Extensions:	oldsogdian}', "");
    Expect(0, 69415, '\p{^Is_Script_Extensions:	oldsogdian}', "");
    Expect(0, 69415, '\P{Is_Script_Extensions:	oldsogdian}', "");
    Expect(1, 69415, '\P{^Is_Script_Extensions:	oldsogdian}', "");
    Expect(0, 69416, '\p{Is_Script_Extensions:	oldsogdian}', "");
    Expect(1, 69416, '\p{^Is_Script_Extensions:	oldsogdian}', "");
    Expect(1, 69416, '\P{Is_Script_Extensions:	oldsogdian}', "");
    Expect(0, 69416, '\P{^Is_Script_Extensions:	oldsogdian}', "");
    Expect(1, 69415, '\p{Is_Script_Extensions=-	Old_SOGDIAN}', "");
    Expect(0, 69415, '\p{^Is_Script_Extensions=-	Old_SOGDIAN}', "");
    Expect(0, 69415, '\P{Is_Script_Extensions=-	Old_SOGDIAN}', "");
    Expect(1, 69415, '\P{^Is_Script_Extensions=-	Old_SOGDIAN}', "");
    Expect(0, 69416, '\p{Is_Script_Extensions=-	Old_SOGDIAN}', "");
    Expect(1, 69416, '\p{^Is_Script_Extensions=-	Old_SOGDIAN}', "");
    Expect(1, 69416, '\P{Is_Script_Extensions=-	Old_SOGDIAN}', "");
    Expect(0, 69416, '\P{^Is_Script_Extensions=-	Old_SOGDIAN}', "");
    Error('\p{Is_Scx= -sogo/a/}');
    Error('\P{Is_Scx= -sogo/a/}');
    Expect(1, 69415, '\p{Is_Scx=sogo}', "");
    Expect(0, 69415, '\p{^Is_Scx=sogo}', "");
    Expect(0, 69415, '\P{Is_Scx=sogo}', "");
    Expect(1, 69415, '\P{^Is_Scx=sogo}', "");
    Expect(0, 69416, '\p{Is_Scx=sogo}', "");
    Expect(1, 69416, '\p{^Is_Scx=sogo}', "");
    Expect(1, 69416, '\P{Is_Scx=sogo}', "");
    Expect(0, 69416, '\P{^Is_Scx=sogo}', "");
    Expect(1, 69415, '\p{Is_Scx=-SOGO}', "");
    Expect(0, 69415, '\p{^Is_Scx=-SOGO}', "");
    Expect(0, 69415, '\P{Is_Scx=-SOGO}', "");
    Expect(1, 69415, '\P{^Is_Scx=-SOGO}', "");
    Expect(0, 69416, '\p{Is_Scx=-SOGO}', "");
    Expect(1, 69416, '\p{^Is_Scx=-SOGO}', "");
    Expect(1, 69416, '\P{Is_Scx=-SOGO}', "");
    Expect(0, 69416, '\P{^Is_Scx=-SOGO}', "");
    Error('\p{Script_Extensions=		Sora_Sompeng/a/}');
    Error('\P{Script_Extensions=		Sora_Sompeng/a/}');
    Expect(1, 69881, '\p{Script_Extensions=:\ASora_Sompeng\z:}', "");;
    Expect(0, 69882, '\p{Script_Extensions=:\ASora_Sompeng\z:}', "");;
    Expect(1, 69881, '\p{Script_Extensions=sorasompeng}', "");
    Expect(0, 69881, '\p{^Script_Extensions=sorasompeng}', "");
    Expect(0, 69881, '\P{Script_Extensions=sorasompeng}', "");
    Expect(1, 69881, '\P{^Script_Extensions=sorasompeng}', "");
    Expect(0, 69882, '\p{Script_Extensions=sorasompeng}', "");
    Expect(1, 69882, '\p{^Script_Extensions=sorasompeng}', "");
    Expect(1, 69882, '\P{Script_Extensions=sorasompeng}', "");
    Expect(0, 69882, '\P{^Script_Extensions=sorasompeng}', "");
    Expect(1, 69881, '\p{Script_Extensions=:\Asorasompeng\z:}', "");;
    Expect(0, 69882, '\p{Script_Extensions=:\Asorasompeng\z:}', "");;
    Expect(1, 69881, '\p{Script_Extensions=_sora_Sompeng}', "");
    Expect(0, 69881, '\p{^Script_Extensions=_sora_Sompeng}', "");
    Expect(0, 69881, '\P{Script_Extensions=_sora_Sompeng}', "");
    Expect(1, 69881, '\P{^Script_Extensions=_sora_Sompeng}', "");
    Expect(0, 69882, '\p{Script_Extensions=_sora_Sompeng}', "");
    Expect(1, 69882, '\p{^Script_Extensions=_sora_Sompeng}', "");
    Expect(1, 69882, '\P{Script_Extensions=_sora_Sompeng}', "");
    Expect(0, 69882, '\P{^Script_Extensions=_sora_Sompeng}', "");
    Error('\p{Scx=/a/  Sora}');
    Error('\P{Scx=/a/  Sora}');
    Expect(1, 69881, '\p{Scx=:\ASora\z:}', "");;
    Expect(0, 69882, '\p{Scx=:\ASora\z:}', "");;
    Expect(1, 69881, '\p{Scx=sora}', "");
    Expect(0, 69881, '\p{^Scx=sora}', "");
    Expect(0, 69881, '\P{Scx=sora}', "");
    Expect(1, 69881, '\P{^Scx=sora}', "");
    Expect(0, 69882, '\p{Scx=sora}', "");
    Expect(1, 69882, '\p{^Scx=sora}', "");
    Expect(1, 69882, '\P{Scx=sora}', "");
    Expect(0, 69882, '\P{^Scx=sora}', "");
    Expect(1, 69881, '\p{Scx=:\Asora\z:}', "");;
    Expect(0, 69882, '\p{Scx=:\Asora\z:}', "");;
    Error('\p{Is_Script_Extensions: :=_-SORA_SOMPENG}');
    Error('\P{Is_Script_Extensions: :=_-SORA_SOMPENG}');
    Expect(1, 69881, '\p{Is_Script_Extensions=sorasompeng}', "");
    Expect(0, 69881, '\p{^Is_Script_Extensions=sorasompeng}', "");
    Expect(0, 69881, '\P{Is_Script_Extensions=sorasompeng}', "");
    Expect(1, 69881, '\P{^Is_Script_Extensions=sorasompeng}', "");
    Expect(0, 69882, '\p{Is_Script_Extensions=sorasompeng}', "");
    Expect(1, 69882, '\p{^Is_Script_Extensions=sorasompeng}', "");
    Expect(1, 69882, '\P{Is_Script_Extensions=sorasompeng}', "");
    Expect(0, 69882, '\P{^Is_Script_Extensions=sorasompeng}', "");
    Expect(1, 69881, '\p{Is_Script_Extensions=		Sora_SOMPENG}', "");
    Expect(0, 69881, '\p{^Is_Script_Extensions=		Sora_SOMPENG}', "");
    Expect(0, 69881, '\P{Is_Script_Extensions=		Sora_SOMPENG}', "");
    Expect(1, 69881, '\P{^Is_Script_Extensions=		Sora_SOMPENG}', "");
    Expect(0, 69882, '\p{Is_Script_Extensions=		Sora_SOMPENG}', "");
    Expect(1, 69882, '\p{^Is_Script_Extensions=		Sora_SOMPENG}', "");
    Expect(1, 69882, '\P{Is_Script_Extensions=		Sora_SOMPENG}', "");
    Expect(0, 69882, '\P{^Is_Script_Extensions=		Sora_SOMPENG}', "");
    Error('\p{Is_Scx= _SORA/a/}');
    Error('\P{Is_Scx= _SORA/a/}');
    Expect(1, 69881, '\p{Is_Scx:sora}', "");
    Expect(0, 69881, '\p{^Is_Scx:sora}', "");
    Expect(0, 69881, '\P{Is_Scx:sora}', "");
    Expect(1, 69881, '\P{^Is_Scx:sora}', "");
    Expect(0, 69882, '\p{Is_Scx:sora}', "");
    Expect(1, 69882, '\p{^Is_Scx:sora}', "");
    Expect(1, 69882, '\P{Is_Scx:sora}', "");
    Expect(0, 69882, '\P{^Is_Scx:sora}', "");
    Expect(1, 69881, '\p{Is_Scx=--Sora}', "");
    Expect(0, 69881, '\p{^Is_Scx=--Sora}', "");
    Expect(0, 69881, '\P{Is_Scx=--Sora}', "");
    Expect(1, 69881, '\P{^Is_Scx=--Sora}', "");
    Expect(0, 69882, '\p{Is_Scx=--Sora}', "");
    Expect(1, 69882, '\p{^Is_Scx=--Sora}', "");
    Expect(1, 69882, '\P{Is_Scx=--Sora}', "");
    Expect(0, 69882, '\P{^Is_Scx=--Sora}', "");
    Error('\p{Script_Extensions=-/a/SOYOMBO}');
    Error('\P{Script_Extensions=-/a/SOYOMBO}');
    Expect(1, 72354, '\p{Script_Extensions=:\ASoyombo\z:}', "");;
    Expect(0, 72355, '\p{Script_Extensions=:\ASoyombo\z:}', "");;
    Expect(1, 72354, '\p{Script_Extensions=soyombo}', "");
    Expect(0, 72354, '\p{^Script_Extensions=soyombo}', "");
    Expect(0, 72354, '\P{Script_Extensions=soyombo}', "");
    Expect(1, 72354, '\P{^Script_Extensions=soyombo}', "");
    Expect(0, 72355, '\p{Script_Extensions=soyombo}', "");
    Expect(1, 72355, '\p{^Script_Extensions=soyombo}', "");
    Expect(1, 72355, '\P{Script_Extensions=soyombo}', "");
    Expect(0, 72355, '\P{^Script_Extensions=soyombo}', "");
    Expect(1, 72354, '\p{Script_Extensions=:\Asoyombo\z:}', "");;
    Expect(0, 72355, '\p{Script_Extensions=:\Asoyombo\z:}', "");;
    Expect(1, 72354, '\p{Script_Extensions:__soyombo}', "");
    Expect(0, 72354, '\p{^Script_Extensions:__soyombo}', "");
    Expect(0, 72354, '\P{Script_Extensions:__soyombo}', "");
    Expect(1, 72354, '\P{^Script_Extensions:__soyombo}', "");
    Expect(0, 72355, '\p{Script_Extensions:__soyombo}', "");
    Expect(1, 72355, '\p{^Script_Extensions:__soyombo}', "");
    Expect(1, 72355, '\P{Script_Extensions:__soyombo}', "");
    Expect(0, 72355, '\P{^Script_Extensions:__soyombo}', "");
    Error('\p{Scx=_/a/SOYO}');
    Error('\P{Scx=_/a/SOYO}');
    Expect(1, 72354, '\p{Scx=:\ASoyo\z:}', "");;
    Expect(0, 72355, '\p{Scx=:\ASoyo\z:}', "");;
    Expect(1, 72354, '\p{Scx=soyo}', "");
    Expect(0, 72354, '\p{^Scx=soyo}', "");
    Expect(0, 72354, '\P{Scx=soyo}', "");
    Expect(1, 72354, '\P{^Scx=soyo}', "");
    Expect(0, 72355, '\p{Scx=soyo}', "");
    Expect(1, 72355, '\p{^Scx=soyo}', "");
    Expect(1, 72355, '\P{Scx=soyo}', "");
    Expect(0, 72355, '\P{^Scx=soyo}', "");
    Expect(1, 72354, '\p{Scx=:\Asoyo\z:}', "");;
    Expect(0, 72355, '\p{Scx=:\Asoyo\z:}', "");;
    Expect(1, 72354, '\p{Scx=-Soyo}', "");
    Expect(0, 72354, '\p{^Scx=-Soyo}', "");
    Expect(0, 72354, '\P{Scx=-Soyo}', "");
    Expect(1, 72354, '\P{^Scx=-Soyo}', "");
    Expect(0, 72355, '\p{Scx=-Soyo}', "");
    Expect(1, 72355, '\p{^Scx=-Soyo}', "");
    Expect(1, 72355, '\P{Scx=-Soyo}', "");
    Expect(0, 72355, '\P{^Scx=-Soyo}', "");
    Error('\p{Is_Script_Extensions=:=		Soyombo}');
    Error('\P{Is_Script_Extensions=:=		Soyombo}');
    Expect(1, 72354, '\p{Is_Script_Extensions=soyombo}', "");
    Expect(0, 72354, '\p{^Is_Script_Extensions=soyombo}', "");
    Expect(0, 72354, '\P{Is_Script_Extensions=soyombo}', "");
    Expect(1, 72354, '\P{^Is_Script_Extensions=soyombo}', "");
    Expect(0, 72355, '\p{Is_Script_Extensions=soyombo}', "");
    Expect(1, 72355, '\p{^Is_Script_Extensions=soyombo}', "");
    Expect(1, 72355, '\P{Is_Script_Extensions=soyombo}', "");
    Expect(0, 72355, '\P{^Is_Script_Extensions=soyombo}', "");
    Expect(1, 72354, '\p{Is_Script_Extensions=Soyombo}', "");
    Expect(0, 72354, '\p{^Is_Script_Extensions=Soyombo}', "");
    Expect(0, 72354, '\P{Is_Script_Extensions=Soyombo}', "");
    Expect(1, 72354, '\P{^Is_Script_Extensions=Soyombo}', "");
    Expect(0, 72355, '\p{Is_Script_Extensions=Soyombo}', "");
    Expect(1, 72355, '\p{^Is_Script_Extensions=Soyombo}', "");
    Expect(1, 72355, '\P{Is_Script_Extensions=Soyombo}', "");
    Expect(0, 72355, '\P{^Is_Script_Extensions=Soyombo}', "");
    Error('\p{Is_Scx=:=		Soyo}');
    Error('\P{Is_Scx=:=		Soyo}');
    Expect(1, 72354, '\p{Is_Scx=soyo}', "");
    Expect(0, 72354, '\p{^Is_Scx=soyo}', "");
    Expect(0, 72354, '\P{Is_Scx=soyo}', "");
    Expect(1, 72354, '\P{^Is_Scx=soyo}', "");
    Expect(0, 72355, '\p{Is_Scx=soyo}', "");
    Expect(1, 72355, '\p{^Is_Scx=soyo}', "");
    Expect(1, 72355, '\P{Is_Scx=soyo}', "");
    Expect(0, 72355, '\P{^Is_Scx=soyo}', "");
    Expect(1, 72354, '\p{Is_Scx=	_soyo}', "");
    Expect(0, 72354, '\p{^Is_Scx=	_soyo}', "");
    Expect(0, 72354, '\P{Is_Scx=	_soyo}', "");
    Expect(1, 72354, '\P{^Is_Scx=	_soyo}', "");
    Expect(0, 72355, '\p{Is_Scx=	_soyo}', "");
    Expect(1, 72355, '\p{^Is_Scx=	_soyo}', "");
    Expect(1, 72355, '\P{Is_Scx=	_soyo}', "");
    Expect(0, 72355, '\P{^Is_Scx=	_soyo}', "");
    Error('\p{Script_Extensions=_/a/Sundanese}');
    Error('\P{Script_Extensions=_/a/Sundanese}');
    Expect(1, 7367, '\p{Script_Extensions=:\ASundanese\z:}', "");;
    Expect(0, 7368, '\p{Script_Extensions=:\ASundanese\z:}', "");;
    Expect(1, 7367, '\p{Script_Extensions=sundanese}', "");
    Expect(0, 7367, '\p{^Script_Extensions=sundanese}', "");
    Expect(0, 7367, '\P{Script_Extensions=sundanese}', "");
    Expect(1, 7367, '\P{^Script_Extensions=sundanese}', "");
    Expect(0, 7368, '\p{Script_Extensions=sundanese}', "");
    Expect(1, 7368, '\p{^Script_Extensions=sundanese}', "");
    Expect(1, 7368, '\P{Script_Extensions=sundanese}', "");
    Expect(0, 7368, '\P{^Script_Extensions=sundanese}', "");
    Expect(1, 7367, '\p{Script_Extensions=:\Asundanese\z:}', "");;
    Expect(0, 7368, '\p{Script_Extensions=:\Asundanese\z:}', "");;
    Expect(1, 7367, '\p{Script_Extensions=	-Sundanese}', "");
    Expect(0, 7367, '\p{^Script_Extensions=	-Sundanese}', "");
    Expect(0, 7367, '\P{Script_Extensions=	-Sundanese}', "");
    Expect(1, 7367, '\P{^Script_Extensions=	-Sundanese}', "");
    Expect(0, 7368, '\p{Script_Extensions=	-Sundanese}', "");
    Expect(1, 7368, '\p{^Script_Extensions=	-Sundanese}', "");
    Expect(1, 7368, '\P{Script_Extensions=	-Sundanese}', "");
    Expect(0, 7368, '\P{^Script_Extensions=	-Sundanese}', "");
    Error('\p{Scx=		Sund/a/}');
    Error('\P{Scx=		Sund/a/}');
    Expect(1, 7367, '\p{Scx=:\ASund\z:}', "");;
    Expect(0, 7368, '\p{Scx=:\ASund\z:}', "");;
    Expect(1, 7367, '\p{Scx=sund}', "");
    Expect(0, 7367, '\p{^Scx=sund}', "");
    Expect(0, 7367, '\P{Scx=sund}', "");
    Expect(1, 7367, '\P{^Scx=sund}', "");
    Expect(0, 7368, '\p{Scx=sund}', "");
    Expect(1, 7368, '\p{^Scx=sund}', "");
    Expect(1, 7368, '\P{Scx=sund}', "");
    Expect(0, 7368, '\P{^Scx=sund}', "");
    Expect(1, 7367, '\p{Scx=:\Asund\z:}', "");;
    Expect(0, 7368, '\p{Scx=:\Asund\z:}', "");;
    Expect(1, 7367, '\p{Scx=_ sund}', "");
    Expect(0, 7367, '\p{^Scx=_ sund}', "");
    Expect(0, 7367, '\P{Scx=_ sund}', "");
    Expect(1, 7367, '\P{^Scx=_ sund}', "");
    Expect(0, 7368, '\p{Scx=_ sund}', "");
    Expect(1, 7368, '\p{^Scx=_ sund}', "");
    Expect(1, 7368, '\P{Scx=_ sund}', "");
    Expect(0, 7368, '\P{^Scx=_ sund}', "");
    Error('\p{Is_Script_Extensions=_:=Sundanese}');
    Error('\P{Is_Script_Extensions=_:=Sundanese}');
    Expect(1, 7367, '\p{Is_Script_Extensions: sundanese}', "");
    Expect(0, 7367, '\p{^Is_Script_Extensions: sundanese}', "");
    Expect(0, 7367, '\P{Is_Script_Extensions: sundanese}', "");
    Expect(1, 7367, '\P{^Is_Script_Extensions: sundanese}', "");
    Expect(0, 7368, '\p{Is_Script_Extensions: sundanese}', "");
    Expect(1, 7368, '\p{^Is_Script_Extensions: sundanese}', "");
    Expect(1, 7368, '\P{Is_Script_Extensions: sundanese}', "");
    Expect(0, 7368, '\P{^Is_Script_Extensions: sundanese}', "");
    Expect(1, 7367, '\p{Is_Script_Extensions=	sundanese}', "");
    Expect(0, 7367, '\p{^Is_Script_Extensions=	sundanese}', "");
    Expect(0, 7367, '\P{Is_Script_Extensions=	sundanese}', "");
    Expect(1, 7367, '\P{^Is_Script_Extensions=	sundanese}', "");
    Expect(0, 7368, '\p{Is_Script_Extensions=	sundanese}', "");
    Expect(1, 7368, '\p{^Is_Script_Extensions=	sundanese}', "");
    Expect(1, 7368, '\P{Is_Script_Extensions=	sundanese}', "");
    Expect(0, 7368, '\P{^Is_Script_Extensions=	sundanese}', "");
    Error('\p{Is_Scx= 	Sund:=}');
    Error('\P{Is_Scx= 	Sund:=}');
    Expect(1, 7367, '\p{Is_Scx=sund}', "");
    Expect(0, 7367, '\p{^Is_Scx=sund}', "");
    Expect(0, 7367, '\P{Is_Scx=sund}', "");
    Expect(1, 7367, '\P{^Is_Scx=sund}', "");
    Expect(0, 7368, '\p{Is_Scx=sund}', "");
    Expect(1, 7368, '\p{^Is_Scx=sund}', "");
    Expect(1, 7368, '\P{Is_Scx=sund}', "");
    Expect(0, 7368, '\P{^Is_Scx=sund}', "");
    Expect(1, 7367, '\p{Is_Scx=_SUND}', "");
    Expect(0, 7367, '\p{^Is_Scx=_SUND}', "");
    Expect(0, 7367, '\P{Is_Scx=_SUND}', "");
    Expect(1, 7367, '\P{^Is_Scx=_SUND}', "");
    Expect(0, 7368, '\p{Is_Scx=_SUND}', "");
    Expect(1, 7368, '\p{^Is_Scx=_SUND}', "");
    Expect(1, 7368, '\P{Is_Scx=_SUND}', "");
    Expect(0, 7368, '\P{^Is_Scx=_SUND}', "");
    Error('\p{Script_Extensions=/a/syloti_NAGRI}');
    Error('\P{Script_Extensions=/a/syloti_NAGRI}');
    Expect(1, 43051, '\p{Script_Extensions=:\ASyloti_Nagri\z:}', "");;
    Expect(0, 43052, '\p{Script_Extensions=:\ASyloti_Nagri\z:}', "");;
    Expect(1, 43051, '\p{Script_Extensions:   sylotinagri}', "");
    Expect(0, 43051, '\p{^Script_Extensions:   sylotinagri}', "");
    Expect(0, 43051, '\P{Script_Extensions:   sylotinagri}', "");
    Expect(1, 43051, '\P{^Script_Extensions:   sylotinagri}', "");
    Expect(0, 43052, '\p{Script_Extensions:   sylotinagri}', "");
    Expect(1, 43052, '\p{^Script_Extensions:   sylotinagri}', "");
    Expect(1, 43052, '\P{Script_Extensions:   sylotinagri}', "");
    Expect(0, 43052, '\P{^Script_Extensions:   sylotinagri}', "");
    Expect(1, 43051, '\p{Script_Extensions=:\Asylotinagri\z:}', "");;
    Expect(0, 43052, '\p{Script_Extensions=:\Asylotinagri\z:}', "");;
    Expect(1, 43051, '\p{Script_Extensions=  Syloti_NAGRI}', "");
    Expect(0, 43051, '\p{^Script_Extensions=  Syloti_NAGRI}', "");
    Expect(0, 43051, '\P{Script_Extensions=  Syloti_NAGRI}', "");
    Expect(1, 43051, '\P{^Script_Extensions=  Syloti_NAGRI}', "");
    Expect(0, 43052, '\p{Script_Extensions=  Syloti_NAGRI}', "");
    Expect(1, 43052, '\p{^Script_Extensions=  Syloti_NAGRI}', "");
    Expect(1, 43052, '\P{Script_Extensions=  Syloti_NAGRI}', "");
    Expect(0, 43052, '\P{^Script_Extensions=  Syloti_NAGRI}', "");
    Error('\p{Scx=:=Sylo}');
    Error('\P{Scx=:=Sylo}');
    Expect(1, 43051, '\p{Scx=:\ASylo\z:}', "");;
    Expect(0, 43052, '\p{Scx=:\ASylo\z:}', "");;
    Expect(1, 43051, '\p{Scx=sylo}', "");
    Expect(0, 43051, '\p{^Scx=sylo}', "");
    Expect(0, 43051, '\P{Scx=sylo}', "");
    Expect(1, 43051, '\P{^Scx=sylo}', "");
    Expect(0, 43052, '\p{Scx=sylo}', "");
    Expect(1, 43052, '\p{^Scx=sylo}', "");
    Expect(1, 43052, '\P{Scx=sylo}', "");
    Expect(0, 43052, '\P{^Scx=sylo}', "");
    Expect(1, 43051, '\p{Scx=:\Asylo\z:}', "");;
    Expect(0, 43052, '\p{Scx=:\Asylo\z:}', "");;
    Expect(1, 43051, '\p{Scx: __SYLO}', "");
    Expect(0, 43051, '\p{^Scx: __SYLO}', "");
    Expect(0, 43051, '\P{Scx: __SYLO}', "");
    Expect(1, 43051, '\P{^Scx: __SYLO}', "");
    Expect(0, 43052, '\p{Scx: __SYLO}', "");
    Expect(1, 43052, '\p{^Scx: __SYLO}', "");
    Expect(1, 43052, '\P{Scx: __SYLO}', "");
    Expect(0, 43052, '\P{^Scx: __SYLO}', "");
    Error('\p{Is_Script_Extensions:	:=__Syloti_Nagri}');
    Error('\P{Is_Script_Extensions:	:=__Syloti_Nagri}');
    Expect(1, 43051, '\p{Is_Script_Extensions=sylotinagri}', "");
    Expect(0, 43051, '\p{^Is_Script_Extensions=sylotinagri}', "");
    Expect(0, 43051, '\P{Is_Script_Extensions=sylotinagri}', "");
    Expect(1, 43051, '\P{^Is_Script_Extensions=sylotinagri}', "");
    Expect(0, 43052, '\p{Is_Script_Extensions=sylotinagri}', "");
    Expect(1, 43052, '\p{^Is_Script_Extensions=sylotinagri}', "");
    Expect(1, 43052, '\P{Is_Script_Extensions=sylotinagri}', "");
    Expect(0, 43052, '\P{^Is_Script_Extensions=sylotinagri}', "");
    Expect(1, 43051, '\p{Is_Script_Extensions= _Syloti_NAGRI}', "");
    Expect(0, 43051, '\p{^Is_Script_Extensions= _Syloti_NAGRI}', "");
    Expect(0, 43051, '\P{Is_Script_Extensions= _Syloti_NAGRI}', "");
    Expect(1, 43051, '\P{^Is_Script_Extensions= _Syloti_NAGRI}', "");
    Expect(0, 43052, '\p{Is_Script_Extensions= _Syloti_NAGRI}', "");
    Expect(1, 43052, '\p{^Is_Script_Extensions= _Syloti_NAGRI}', "");
    Expect(1, 43052, '\P{Is_Script_Extensions= _Syloti_NAGRI}', "");
    Expect(0, 43052, '\P{^Is_Script_Extensions= _Syloti_NAGRI}', "");
    Error('\p{Is_Scx=/a/ _SYLO}');
    Error('\P{Is_Scx=/a/ _SYLO}');
    Expect(1, 43051, '\p{Is_Scx=sylo}', "");
    Expect(0, 43051, '\p{^Is_Scx=sylo}', "");
    Expect(0, 43051, '\P{Is_Scx=sylo}', "");
    Expect(1, 43051, '\P{^Is_Scx=sylo}', "");
    Expect(0, 43052, '\p{Is_Scx=sylo}', "");
    Expect(1, 43052, '\p{^Is_Scx=sylo}', "");
    Expect(1, 43052, '\P{Is_Scx=sylo}', "");
    Expect(0, 43052, '\P{^Is_Scx=sylo}', "");
    Expect(1, 43051, '\p{Is_Scx=  Sylo}', "");
    Expect(0, 43051, '\p{^Is_Scx=  Sylo}', "");
    Expect(0, 43051, '\P{Is_Scx=  Sylo}', "");
    Expect(1, 43051, '\P{^Is_Scx=  Sylo}', "");
    Expect(0, 43052, '\p{Is_Scx=  Sylo}', "");
    Expect(1, 43052, '\p{^Is_Scx=  Sylo}', "");
    Expect(1, 43052, '\P{Is_Scx=  Sylo}', "");
    Expect(0, 43052, '\P{^Is_Scx=  Sylo}', "");
    Error('\p{Script_Extensions=_/a/Syriac}');
    Error('\P{Script_Extensions=_/a/Syriac}');
    Expect(1, 2154, '\p{Script_Extensions=:\ASyriac\z:}', "");;
    Expect(0, 2155, '\p{Script_Extensions=:\ASyriac\z:}', "");;
    Expect(1, 2154, '\p{Script_Extensions=syriac}', "");
    Expect(0, 2154, '\p{^Script_Extensions=syriac}', "");
    Expect(0, 2154, '\P{Script_Extensions=syriac}', "");
    Expect(1, 2154, '\P{^Script_Extensions=syriac}', "");
    Expect(0, 2155, '\p{Script_Extensions=syriac}', "");
    Expect(1, 2155, '\p{^Script_Extensions=syriac}', "");
    Expect(1, 2155, '\P{Script_Extensions=syriac}', "");
    Expect(0, 2155, '\P{^Script_Extensions=syriac}', "");
    Expect(1, 2154, '\p{Script_Extensions=:\Asyriac\z:}', "");;
    Expect(0, 2155, '\p{Script_Extensions=:\Asyriac\z:}', "");;
    Expect(1, 2154, '\p{Script_Extensions=Syriac}', "");
    Expect(0, 2154, '\p{^Script_Extensions=Syriac}', "");
    Expect(0, 2154, '\P{Script_Extensions=Syriac}', "");
    Expect(1, 2154, '\P{^Script_Extensions=Syriac}', "");
    Expect(0, 2155, '\p{Script_Extensions=Syriac}', "");
    Expect(1, 2155, '\p{^Script_Extensions=Syriac}', "");
    Expect(1, 2155, '\P{Script_Extensions=Syriac}', "");
    Expect(0, 2155, '\P{^Script_Extensions=Syriac}', "");
    Error('\p{Scx=_:=Syrc}');
    Error('\P{Scx=_:=Syrc}');
    Expect(1, 2154, '\p{Scx=:\ASyrc\z:}', "");;
    Expect(0, 2155, '\p{Scx=:\ASyrc\z:}', "");;
    Expect(1, 2154, '\p{Scx=syrc}', "");
    Expect(0, 2154, '\p{^Scx=syrc}', "");
    Expect(0, 2154, '\P{Scx=syrc}', "");
    Expect(1, 2154, '\P{^Scx=syrc}', "");
    Expect(0, 2155, '\p{Scx=syrc}', "");
    Expect(1, 2155, '\p{^Scx=syrc}', "");
    Expect(1, 2155, '\P{Scx=syrc}', "");
    Expect(0, 2155, '\P{^Scx=syrc}', "");
    Expect(1, 2154, '\p{Scx=:\Asyrc\z:}', "");;
    Expect(0, 2155, '\p{Scx=:\Asyrc\z:}', "");;
    Expect(1, 2154, '\p{Scx=--Syrc}', "");
    Expect(0, 2154, '\p{^Scx=--Syrc}', "");
    Expect(0, 2154, '\P{Scx=--Syrc}', "");
    Expect(1, 2154, '\P{^Scx=--Syrc}', "");
    Expect(0, 2155, '\p{Scx=--Syrc}', "");
    Expect(1, 2155, '\p{^Scx=--Syrc}', "");
    Expect(1, 2155, '\P{Scx=--Syrc}', "");
    Expect(0, 2155, '\P{^Scx=--Syrc}', "");
    Error('\p{Is_Script_Extensions=_-Syriac:=}');
    Error('\P{Is_Script_Extensions=_-Syriac:=}');
    Expect(1, 2154, '\p{Is_Script_Extensions=syriac}', "");
    Expect(0, 2154, '\p{^Is_Script_Extensions=syriac}', "");
    Expect(0, 2154, '\P{Is_Script_Extensions=syriac}', "");
    Expect(1, 2154, '\P{^Is_Script_Extensions=syriac}', "");
    Expect(0, 2155, '\p{Is_Script_Extensions=syriac}', "");
    Expect(1, 2155, '\p{^Is_Script_Extensions=syriac}', "");
    Expect(1, 2155, '\P{Is_Script_Extensions=syriac}', "");
    Expect(0, 2155, '\P{^Is_Script_Extensions=syriac}', "");
    Expect(1, 2154, '\p{Is_Script_Extensions=	Syriac}', "");
    Expect(0, 2154, '\p{^Is_Script_Extensions=	Syriac}', "");
    Expect(0, 2154, '\P{Is_Script_Extensions=	Syriac}', "");
    Expect(1, 2154, '\P{^Is_Script_Extensions=	Syriac}', "");
    Expect(0, 2155, '\p{Is_Script_Extensions=	Syriac}', "");
    Expect(1, 2155, '\p{^Is_Script_Extensions=	Syriac}', "");
    Expect(1, 2155, '\P{Is_Script_Extensions=	Syriac}', "");
    Expect(0, 2155, '\P{^Is_Script_Extensions=	Syriac}', "");
    Error('\p{Is_Scx: 	-Syrc/a/}');
    Error('\P{Is_Scx: 	-Syrc/a/}');
    Expect(1, 2154, '\p{Is_Scx: syrc}', "");
    Expect(0, 2154, '\p{^Is_Scx: syrc}', "");
    Expect(0, 2154, '\P{Is_Scx: syrc}', "");
    Expect(1, 2154, '\P{^Is_Scx: syrc}', "");
    Expect(0, 2155, '\p{Is_Scx: syrc}', "");
    Expect(1, 2155, '\p{^Is_Scx: syrc}', "");
    Expect(1, 2155, '\P{Is_Scx: syrc}', "");
    Expect(0, 2155, '\P{^Is_Scx: syrc}', "");
    Expect(1, 2154, '\p{Is_Scx=-	Syrc}', "");
    Expect(0, 2154, '\p{^Is_Scx=-	Syrc}', "");
    Expect(0, 2154, '\P{Is_Scx=-	Syrc}', "");
    Expect(1, 2154, '\P{^Is_Scx=-	Syrc}', "");
    Expect(0, 2155, '\p{Is_Scx=-	Syrc}', "");
    Expect(1, 2155, '\p{^Is_Scx=-	Syrc}', "");
    Expect(1, 2155, '\P{Is_Scx=-	Syrc}', "");
    Expect(0, 2155, '\P{^Is_Scx=-	Syrc}', "");
    Error('\p{Script_Extensions=/a/ 	Tagbanwa}');
    Error('\P{Script_Extensions=/a/ 	Tagbanwa}');
    Expect(1, 6003, '\p{Script_Extensions=:\ATagbanwa\z:}', "");;
    Expect(0, 6004, '\p{Script_Extensions=:\ATagbanwa\z:}', "");;
    Expect(1, 6003, '\p{Script_Extensions:tagbanwa}', "");
    Expect(0, 6003, '\p{^Script_Extensions:tagbanwa}', "");
    Expect(0, 6003, '\P{Script_Extensions:tagbanwa}', "");
    Expect(1, 6003, '\P{^Script_Extensions:tagbanwa}', "");
    Expect(0, 6004, '\p{Script_Extensions:tagbanwa}', "");
    Expect(1, 6004, '\p{^Script_Extensions:tagbanwa}', "");
    Expect(1, 6004, '\P{Script_Extensions:tagbanwa}', "");
    Expect(0, 6004, '\P{^Script_Extensions:tagbanwa}', "");
    Expect(1, 6003, '\p{Script_Extensions=:\Atagbanwa\z:}', "");;
    Expect(0, 6004, '\p{Script_Extensions=:\Atagbanwa\z:}', "");;
    Expect(1, 6003, '\p{Script_Extensions=-Tagbanwa}', "");
    Expect(0, 6003, '\p{^Script_Extensions=-Tagbanwa}', "");
    Expect(0, 6003, '\P{Script_Extensions=-Tagbanwa}', "");
    Expect(1, 6003, '\P{^Script_Extensions=-Tagbanwa}', "");
    Expect(0, 6004, '\p{Script_Extensions=-Tagbanwa}', "");
    Expect(1, 6004, '\p{^Script_Extensions=-Tagbanwa}', "");
    Expect(1, 6004, '\P{Script_Extensions=-Tagbanwa}', "");
    Expect(0, 6004, '\P{^Script_Extensions=-Tagbanwa}', "");
    Error('\p{Scx= _Tagb:=}');
    Error('\P{Scx= _Tagb:=}');
    Expect(1, 6003, '\p{Scx=:\ATagb\z:}', "");;
    Expect(0, 6004, '\p{Scx=:\ATagb\z:}', "");;
    Expect(1, 6003, '\p{Scx=tagb}', "");
    Expect(0, 6003, '\p{^Scx=tagb}', "");
    Expect(0, 6003, '\P{Scx=tagb}', "");
    Expect(1, 6003, '\P{^Scx=tagb}', "");
    Expect(0, 6004, '\p{Scx=tagb}', "");
    Expect(1, 6004, '\p{^Scx=tagb}', "");
    Expect(1, 6004, '\P{Scx=tagb}', "");
    Expect(0, 6004, '\P{^Scx=tagb}', "");
    Expect(1, 6003, '\p{Scx=:\Atagb\z:}', "");;
    Expect(0, 6004, '\p{Scx=:\Atagb\z:}', "");;
    Expect(1, 6003, '\p{Scx=- tagb}', "");
    Expect(0, 6003, '\p{^Scx=- tagb}', "");
    Expect(0, 6003, '\P{Scx=- tagb}', "");
    Expect(1, 6003, '\P{^Scx=- tagb}', "");
    Expect(0, 6004, '\p{Scx=- tagb}', "");
    Expect(1, 6004, '\p{^Scx=- tagb}', "");
    Expect(1, 6004, '\P{Scx=- tagb}', "");
    Expect(0, 6004, '\P{^Scx=- tagb}', "");
    Error('\p{Is_Script_Extensions=/a/	-Tagbanwa}');
    Error('\P{Is_Script_Extensions=/a/	-Tagbanwa}');
    Expect(1, 6003, '\p{Is_Script_Extensions=tagbanwa}', "");
    Expect(0, 6003, '\p{^Is_Script_Extensions=tagbanwa}', "");
    Expect(0, 6003, '\P{Is_Script_Extensions=tagbanwa}', "");
    Expect(1, 6003, '\P{^Is_Script_Extensions=tagbanwa}', "");
    Expect(0, 6004, '\p{Is_Script_Extensions=tagbanwa}', "");
    Expect(1, 6004, '\p{^Is_Script_Extensions=tagbanwa}', "");
    Expect(1, 6004, '\P{Is_Script_Extensions=tagbanwa}', "");
    Expect(0, 6004, '\P{^Is_Script_Extensions=tagbanwa}', "");
    Expect(1, 6003, '\p{Is_Script_Extensions=_TAGBANWA}', "");
    Expect(0, 6003, '\p{^Is_Script_Extensions=_TAGBANWA}', "");
    Expect(0, 6003, '\P{Is_Script_Extensions=_TAGBANWA}', "");
    Expect(1, 6003, '\P{^Is_Script_Extensions=_TAGBANWA}', "");
    Expect(0, 6004, '\p{Is_Script_Extensions=_TAGBANWA}', "");
    Expect(1, 6004, '\p{^Is_Script_Extensions=_TAGBANWA}', "");
    Expect(1, 6004, '\P{Is_Script_Extensions=_TAGBANWA}', "");
    Expect(0, 6004, '\P{^Is_Script_Extensions=_TAGBANWA}', "");
    Error('\p{Is_Scx=/a/ tagb}');
    Error('\P{Is_Scx=/a/ tagb}');
    Expect(1, 6003, '\p{Is_Scx=tagb}', "");
    Expect(0, 6003, '\p{^Is_Scx=tagb}', "");
    Expect(0, 6003, '\P{Is_Scx=tagb}', "");
    Expect(1, 6003, '\P{^Is_Scx=tagb}', "");
    Expect(0, 6004, '\p{Is_Scx=tagb}', "");
    Expect(1, 6004, '\p{^Is_Scx=tagb}', "");
    Expect(1, 6004, '\P{Is_Scx=tagb}', "");
    Expect(0, 6004, '\P{^Is_Scx=tagb}', "");
    Expect(1, 6003, '\p{Is_Scx=- Tagb}', "");
    Expect(0, 6003, '\p{^Is_Scx=- Tagb}', "");
    Expect(0, 6003, '\P{Is_Scx=- Tagb}', "");
    Expect(1, 6003, '\P{^Is_Scx=- Tagb}', "");
    Expect(0, 6004, '\p{Is_Scx=- Tagb}', "");
    Expect(1, 6004, '\p{^Is_Scx=- Tagb}', "");
    Expect(1, 6004, '\P{Is_Scx=- Tagb}', "");
    Expect(0, 6004, '\P{^Is_Scx=- Tagb}', "");
    Error('\p{Script_Extensions=-TAKRI/a/}');
    Error('\P{Script_Extensions=-TAKRI/a/}');
    Expect(1, 71369, '\p{Script_Extensions=:\ATakri\z:}', "");;
    Expect(0, 71370, '\p{Script_Extensions=:\ATakri\z:}', "");;
    Expect(1, 71369, '\p{Script_Extensions=takri}', "");
    Expect(0, 71369, '\p{^Script_Extensions=takri}', "");
    Expect(0, 71369, '\P{Script_Extensions=takri}', "");
    Expect(1, 71369, '\P{^Script_Extensions=takri}', "");
    Expect(0, 71370, '\p{Script_Extensions=takri}', "");
    Expect(1, 71370, '\p{^Script_Extensions=takri}', "");
    Expect(1, 71370, '\P{Script_Extensions=takri}', "");
    Expect(0, 71370, '\P{^Script_Extensions=takri}', "");
    Expect(1, 71369, '\p{Script_Extensions=:\Atakri\z:}', "");;
    Expect(0, 71370, '\p{Script_Extensions=:\Atakri\z:}', "");;
    Expect(1, 71369, '\p{Script_Extensions=		takri}', "");
    Expect(0, 71369, '\p{^Script_Extensions=		takri}', "");
    Expect(0, 71369, '\P{Script_Extensions=		takri}', "");
    Expect(1, 71369, '\P{^Script_Extensions=		takri}', "");
    Expect(0, 71370, '\p{Script_Extensions=		takri}', "");
    Expect(1, 71370, '\p{^Script_Extensions=		takri}', "");
    Expect(1, 71370, '\P{Script_Extensions=		takri}', "");
    Expect(0, 71370, '\P{^Script_Extensions=		takri}', "");
    Error('\p{Scx:_ takr/a/}');
    Error('\P{Scx:_ takr/a/}');
    Expect(1, 71369, '\p{Scx=:\ATakr\z:}', "");;
    Expect(0, 71370, '\p{Scx=:\ATakr\z:}', "");;
    Expect(1, 71369, '\p{Scx=takr}', "");
    Expect(0, 71369, '\p{^Scx=takr}', "");
    Expect(0, 71369, '\P{Scx=takr}', "");
    Expect(1, 71369, '\P{^Scx=takr}', "");
    Expect(0, 71370, '\p{Scx=takr}', "");
    Expect(1, 71370, '\p{^Scx=takr}', "");
    Expect(1, 71370, '\P{Scx=takr}', "");
    Expect(0, 71370, '\P{^Scx=takr}', "");
    Expect(1, 71369, '\p{Scx=:\Atakr\z:}', "");;
    Expect(0, 71370, '\p{Scx=:\Atakr\z:}', "");;
    Expect(1, 71369, '\p{Scx=--Takr}', "");
    Expect(0, 71369, '\p{^Scx=--Takr}', "");
    Expect(0, 71369, '\P{Scx=--Takr}', "");
    Expect(1, 71369, '\P{^Scx=--Takr}', "");
    Expect(0, 71370, '\p{Scx=--Takr}', "");
    Expect(1, 71370, '\p{^Scx=--Takr}', "");
    Expect(1, 71370, '\P{Scx=--Takr}', "");
    Expect(0, 71370, '\P{^Scx=--Takr}', "");
    Error('\p{Is_Script_Extensions= /a/takri}');
    Error('\P{Is_Script_Extensions= /a/takri}');
    Expect(1, 71369, '\p{Is_Script_Extensions=takri}', "");
    Expect(0, 71369, '\p{^Is_Script_Extensions=takri}', "");
    Expect(0, 71369, '\P{Is_Script_Extensions=takri}', "");
    Expect(1, 71369, '\P{^Is_Script_Extensions=takri}', "");
    Expect(0, 71370, '\p{Is_Script_Extensions=takri}', "");
    Expect(1, 71370, '\p{^Is_Script_Extensions=takri}', "");
    Expect(1, 71370, '\P{Is_Script_Extensions=takri}', "");
    Expect(0, 71370, '\P{^Is_Script_Extensions=takri}', "");
    Expect(1, 71369, '\p{Is_Script_Extensions= _Takri}', "");
    Expect(0, 71369, '\p{^Is_Script_Extensions= _Takri}', "");
    Expect(0, 71369, '\P{Is_Script_Extensions= _Takri}', "");
    Expect(1, 71369, '\P{^Is_Script_Extensions= _Takri}', "");
    Expect(0, 71370, '\p{Is_Script_Extensions= _Takri}', "");
    Expect(1, 71370, '\p{^Is_Script_Extensions= _Takri}', "");
    Expect(1, 71370, '\P{Is_Script_Extensions= _Takri}', "");
    Expect(0, 71370, '\P{^Is_Script_Extensions= _Takri}', "");
    Error('\p{Is_Scx=/a/	takr}');
    Error('\P{Is_Scx=/a/	takr}');
    Expect(1, 71369, '\p{Is_Scx=takr}', "");
    Expect(0, 71369, '\p{^Is_Scx=takr}', "");
    Expect(0, 71369, '\P{Is_Scx=takr}', "");
    Expect(1, 71369, '\P{^Is_Scx=takr}', "");
    Expect(0, 71370, '\p{Is_Scx=takr}', "");
    Expect(1, 71370, '\p{^Is_Scx=takr}', "");
    Expect(1, 71370, '\P{Is_Scx=takr}', "");
    Expect(0, 71370, '\P{^Is_Scx=takr}', "");
    Expect(1, 71369, '\p{Is_Scx=__Takr}', "");
    Expect(0, 71369, '\p{^Is_Scx=__Takr}', "");
    Expect(0, 71369, '\P{Is_Scx=__Takr}', "");
    Expect(1, 71369, '\P{^Is_Scx=__Takr}', "");
    Expect(0, 71370, '\p{Is_Scx=__Takr}', "");
    Expect(1, 71370, '\p{^Is_Scx=__Takr}', "");
    Expect(1, 71370, '\P{Is_Scx=__Takr}', "");
    Expect(0, 71370, '\P{^Is_Scx=__Takr}', "");
    Error('\p{Script_Extensions: -:=tai_Le}');
    Error('\P{Script_Extensions: -:=tai_Le}');
    Expect(1, 6516, '\p{Script_Extensions=:\ATai_Le\z:}', "");;
    Expect(0, 6517, '\p{Script_Extensions=:\ATai_Le\z:}', "");;
    Expect(1, 6516, '\p{Script_Extensions=taile}', "");
    Expect(0, 6516, '\p{^Script_Extensions=taile}', "");
    Expect(0, 6516, '\P{Script_Extensions=taile}', "");
    Expect(1, 6516, '\P{^Script_Extensions=taile}', "");
    Expect(0, 6517, '\p{Script_Extensions=taile}', "");
    Expect(1, 6517, '\p{^Script_Extensions=taile}', "");
    Expect(1, 6517, '\P{Script_Extensions=taile}', "");
    Expect(0, 6517, '\P{^Script_Extensions=taile}', "");
    Expect(1, 6516, '\p{Script_Extensions=:\Ataile\z:}', "");;
    Expect(0, 6517, '\p{Script_Extensions=:\Ataile\z:}', "");;
    Expect(1, 6516, '\p{Script_Extensions=-TAI_LE}', "");
    Expect(0, 6516, '\p{^Script_Extensions=-TAI_LE}', "");
    Expect(0, 6516, '\P{Script_Extensions=-TAI_LE}', "");
    Expect(1, 6516, '\P{^Script_Extensions=-TAI_LE}', "");
    Expect(0, 6517, '\p{Script_Extensions=-TAI_LE}', "");
    Expect(1, 6517, '\p{^Script_Extensions=-TAI_LE}', "");
    Expect(1, 6517, '\P{Script_Extensions=-TAI_LE}', "");
    Expect(0, 6517, '\P{^Script_Extensions=-TAI_LE}', "");
    Error('\p{Scx= :=TALE}');
    Error('\P{Scx= :=TALE}');
    Expect(1, 6516, '\p{Scx=:\ATale\z:}', "");;
    Expect(0, 6517, '\p{Scx=:\ATale\z:}', "");;
    Expect(1, 6516, '\p{Scx=tale}', "");
    Expect(0, 6516, '\p{^Scx=tale}', "");
    Expect(0, 6516, '\P{Scx=tale}', "");
    Expect(1, 6516, '\P{^Scx=tale}', "");
    Expect(0, 6517, '\p{Scx=tale}', "");
    Expect(1, 6517, '\p{^Scx=tale}', "");
    Expect(1, 6517, '\P{Scx=tale}', "");
    Expect(0, 6517, '\P{^Scx=tale}', "");
    Expect(1, 6516, '\p{Scx=:\Atale\z:}', "");;
    Expect(0, 6517, '\p{Scx=:\Atale\z:}', "");;
    Expect(1, 6516, '\p{Scx=		Tale}', "");
    Expect(0, 6516, '\p{^Scx=		Tale}', "");
    Expect(0, 6516, '\P{Scx=		Tale}', "");
    Expect(1, 6516, '\P{^Scx=		Tale}', "");
    Expect(0, 6517, '\p{Scx=		Tale}', "");
    Expect(1, 6517, '\p{^Scx=		Tale}', "");
    Expect(1, 6517, '\P{Scx=		Tale}', "");
    Expect(0, 6517, '\P{^Scx=		Tale}', "");
    Error('\p{Is_Script_Extensions=__Tai_Le:=}');
    Error('\P{Is_Script_Extensions=__Tai_Le:=}');
    Expect(1, 6516, '\p{Is_Script_Extensions=taile}', "");
    Expect(0, 6516, '\p{^Is_Script_Extensions=taile}', "");
    Expect(0, 6516, '\P{Is_Script_Extensions=taile}', "");
    Expect(1, 6516, '\P{^Is_Script_Extensions=taile}', "");
    Expect(0, 6517, '\p{Is_Script_Extensions=taile}', "");
    Expect(1, 6517, '\p{^Is_Script_Extensions=taile}', "");
    Expect(1, 6517, '\P{Is_Script_Extensions=taile}', "");
    Expect(0, 6517, '\P{^Is_Script_Extensions=taile}', "");
    Expect(1, 6516, '\p{Is_Script_Extensions= Tai_Le}', "");
    Expect(0, 6516, '\p{^Is_Script_Extensions= Tai_Le}', "");
    Expect(0, 6516, '\P{Is_Script_Extensions= Tai_Le}', "");
    Expect(1, 6516, '\P{^Is_Script_Extensions= Tai_Le}', "");
    Expect(0, 6517, '\p{Is_Script_Extensions= Tai_Le}', "");
    Expect(1, 6517, '\p{^Is_Script_Extensions= Tai_Le}', "");
    Expect(1, 6517, '\P{Is_Script_Extensions= Tai_Le}', "");
    Expect(0, 6517, '\P{^Is_Script_Extensions= Tai_Le}', "");
    Error('\p{Is_Scx=:=TALE}');
    Error('\P{Is_Scx=:=TALE}');
    Expect(1, 6516, '\p{Is_Scx=tale}', "");
    Expect(0, 6516, '\p{^Is_Scx=tale}', "");
    Expect(0, 6516, '\P{Is_Scx=tale}', "");
    Expect(1, 6516, '\P{^Is_Scx=tale}', "");
    Expect(0, 6517, '\p{Is_Scx=tale}', "");
    Expect(1, 6517, '\p{^Is_Scx=tale}', "");
    Expect(1, 6517, '\P{Is_Scx=tale}', "");
    Expect(0, 6517, '\P{^Is_Scx=tale}', "");
    Expect(1, 6516, '\p{Is_Scx=  Tale}', "");
    Expect(0, 6516, '\p{^Is_Scx=  Tale}', "");
    Expect(0, 6516, '\P{Is_Scx=  Tale}', "");
    Expect(1, 6516, '\P{^Is_Scx=  Tale}', "");
    Expect(0, 6517, '\p{Is_Scx=  Tale}', "");
    Expect(1, 6517, '\p{^Is_Scx=  Tale}', "");
    Expect(1, 6517, '\P{Is_Scx=  Tale}', "");
    Expect(0, 6517, '\P{^Is_Scx=  Tale}', "");
    Error('\p{Script_Extensions= /a/new_Tai_Lue}');
    Error('\P{Script_Extensions= /a/new_Tai_Lue}');
    Expect(1, 6623, '\p{Script_Extensions=:\ANew_Tai_Lue\z:}', "");;
    Expect(0, 6624, '\p{Script_Extensions=:\ANew_Tai_Lue\z:}', "");;
    Expect(1, 6623, '\p{Script_Extensions=newtailue}', "");
    Expect(0, 6623, '\p{^Script_Extensions=newtailue}', "");
    Expect(0, 6623, '\P{Script_Extensions=newtailue}', "");
    Expect(1, 6623, '\P{^Script_Extensions=newtailue}', "");
    Expect(0, 6624, '\p{Script_Extensions=newtailue}', "");
    Expect(1, 6624, '\p{^Script_Extensions=newtailue}', "");
    Expect(1, 6624, '\P{Script_Extensions=newtailue}', "");
    Expect(0, 6624, '\P{^Script_Extensions=newtailue}', "");
    Expect(1, 6623, '\p{Script_Extensions=:\Anewtailue\z:}', "");;
    Expect(0, 6624, '\p{Script_Extensions=:\Anewtailue\z:}', "");;
    Expect(1, 6623, '\p{Script_Extensions=new_tai_Lue}', "");
    Expect(0, 6623, '\p{^Script_Extensions=new_tai_Lue}', "");
    Expect(0, 6623, '\P{Script_Extensions=new_tai_Lue}', "");
    Expect(1, 6623, '\P{^Script_Extensions=new_tai_Lue}', "");
    Expect(0, 6624, '\p{Script_Extensions=new_tai_Lue}', "");
    Expect(1, 6624, '\p{^Script_Extensions=new_tai_Lue}', "");
    Expect(1, 6624, '\P{Script_Extensions=new_tai_Lue}', "");
    Expect(0, 6624, '\P{^Script_Extensions=new_tai_Lue}', "");
    Error('\p{Scx=:=Talu}');
    Error('\P{Scx=:=Talu}');
    Expect(1, 6623, '\p{Scx=:\ATalu\z:}', "");;
    Expect(0, 6624, '\p{Scx=:\ATalu\z:}', "");;
    Expect(1, 6623, '\p{Scx=talu}', "");
    Expect(0, 6623, '\p{^Scx=talu}', "");
    Expect(0, 6623, '\P{Scx=talu}', "");
    Expect(1, 6623, '\P{^Scx=talu}', "");
    Expect(0, 6624, '\p{Scx=talu}', "");
    Expect(1, 6624, '\p{^Scx=talu}', "");
    Expect(1, 6624, '\P{Scx=talu}', "");
    Expect(0, 6624, '\P{^Scx=talu}', "");
    Expect(1, 6623, '\p{Scx=:\Atalu\z:}', "");;
    Expect(0, 6624, '\p{Scx=:\Atalu\z:}', "");;
    Expect(1, 6623, '\p{Scx=_-talu}', "");
    Expect(0, 6623, '\p{^Scx=_-talu}', "");
    Expect(0, 6623, '\P{Scx=_-talu}', "");
    Expect(1, 6623, '\P{^Scx=_-talu}', "");
    Expect(0, 6624, '\p{Scx=_-talu}', "");
    Expect(1, 6624, '\p{^Scx=_-talu}', "");
    Expect(1, 6624, '\P{Scx=_-talu}', "");
    Expect(0, 6624, '\P{^Scx=_-talu}', "");
    Error('\p{Is_Script_Extensions=_/a/New_Tai_Lue}');
    Error('\P{Is_Script_Extensions=_/a/New_Tai_Lue}');
    Expect(1, 6623, '\p{Is_Script_Extensions=newtailue}', "");
    Expect(0, 6623, '\p{^Is_Script_Extensions=newtailue}', "");
    Expect(0, 6623, '\P{Is_Script_Extensions=newtailue}', "");
    Expect(1, 6623, '\P{^Is_Script_Extensions=newtailue}', "");
    Expect(0, 6624, '\p{Is_Script_Extensions=newtailue}', "");
    Expect(1, 6624, '\p{^Is_Script_Extensions=newtailue}', "");
    Expect(1, 6624, '\P{Is_Script_Extensions=newtailue}', "");
    Expect(0, 6624, '\P{^Is_Script_Extensions=newtailue}', "");
    Expect(1, 6623, '\p{Is_Script_Extensions=		new_TAI_Lue}', "");
    Expect(0, 6623, '\p{^Is_Script_Extensions=		new_TAI_Lue}', "");
    Expect(0, 6623, '\P{Is_Script_Extensions=		new_TAI_Lue}', "");
    Expect(1, 6623, '\P{^Is_Script_Extensions=		new_TAI_Lue}', "");
    Expect(0, 6624, '\p{Is_Script_Extensions=		new_TAI_Lue}', "");
    Expect(1, 6624, '\p{^Is_Script_Extensions=		new_TAI_Lue}', "");
    Expect(1, 6624, '\P{Is_Script_Extensions=		new_TAI_Lue}', "");
    Expect(0, 6624, '\P{^Is_Script_Extensions=		new_TAI_Lue}', "");
    Error('\p{Is_Scx=_-TALU/a/}');
    Error('\P{Is_Scx=_-TALU/a/}');
    Expect(1, 6623, '\p{Is_Scx=talu}', "");
    Expect(0, 6623, '\p{^Is_Scx=talu}', "");
    Expect(0, 6623, '\P{Is_Scx=talu}', "");
    Expect(1, 6623, '\P{^Is_Scx=talu}', "");
    Expect(0, 6624, '\p{Is_Scx=talu}', "");
    Expect(1, 6624, '\p{^Is_Scx=talu}', "");
    Expect(1, 6624, '\P{Is_Scx=talu}', "");
    Expect(0, 6624, '\P{^Is_Scx=talu}', "");
    Expect(1, 6623, '\p{Is_Scx:	_talu}', "");
    Expect(0, 6623, '\p{^Is_Scx:	_talu}', "");
    Expect(0, 6623, '\P{Is_Scx:	_talu}', "");
    Expect(1, 6623, '\P{^Is_Scx:	_talu}', "");
    Expect(0, 6624, '\p{Is_Scx:	_talu}', "");
    Expect(1, 6624, '\p{^Is_Scx:	_talu}', "");
    Expect(1, 6624, '\P{Is_Scx:	_talu}', "");
    Expect(0, 6624, '\P{^Is_Scx:	_talu}', "");
    Error('\p{Script_Extensions= :=TAMIL}');
    Error('\P{Script_Extensions= :=TAMIL}');
    Expect(1, 73727, '\p{Script_Extensions=:\ATamil\z:}', "");;
    Expect(0, 73728, '\p{Script_Extensions=:\ATamil\z:}', "");;
    Expect(1, 73727, '\p{Script_Extensions=tamil}', "");
    Expect(0, 73727, '\p{^Script_Extensions=tamil}', "");
    Expect(0, 73727, '\P{Script_Extensions=tamil}', "");
    Expect(1, 73727, '\P{^Script_Extensions=tamil}', "");
    Expect(0, 73728, '\p{Script_Extensions=tamil}', "");
    Expect(1, 73728, '\p{^Script_Extensions=tamil}', "");
    Expect(1, 73728, '\P{Script_Extensions=tamil}', "");
    Expect(0, 73728, '\P{^Script_Extensions=tamil}', "");
    Expect(1, 73727, '\p{Script_Extensions=:\Atamil\z:}', "");;
    Expect(0, 73728, '\p{Script_Extensions=:\Atamil\z:}', "");;
    Expect(1, 73727, '\p{Script_Extensions=- tamil}', "");
    Expect(0, 73727, '\p{^Script_Extensions=- tamil}', "");
    Expect(0, 73727, '\P{Script_Extensions=- tamil}', "");
    Expect(1, 73727, '\P{^Script_Extensions=- tamil}', "");
    Expect(0, 73728, '\p{Script_Extensions=- tamil}', "");
    Expect(1, 73728, '\p{^Script_Extensions=- tamil}', "");
    Expect(1, 73728, '\P{Script_Extensions=- tamil}', "");
    Expect(0, 73728, '\P{^Script_Extensions=- tamil}', "");
    Error('\p{Scx=_/a/Taml}');
    Error('\P{Scx=_/a/Taml}');
    Expect(1, 73727, '\p{Scx=:\ATaml\z:}', "");;
    Expect(0, 73728, '\p{Scx=:\ATaml\z:}', "");;
    Expect(1, 73727, '\p{Scx=taml}', "");
    Expect(0, 73727, '\p{^Scx=taml}', "");
    Expect(0, 73727, '\P{Scx=taml}', "");
    Expect(1, 73727, '\P{^Scx=taml}', "");
    Expect(0, 73728, '\p{Scx=taml}', "");
    Expect(1, 73728, '\p{^Scx=taml}', "");
    Expect(1, 73728, '\P{Scx=taml}', "");
    Expect(0, 73728, '\P{^Scx=taml}', "");
    Expect(1, 73727, '\p{Scx=:\Ataml\z:}', "");;
    Expect(0, 73728, '\p{Scx=:\Ataml\z:}', "");;
    Expect(1, 73727, '\p{Scx=	taml}', "");
    Expect(0, 73727, '\p{^Scx=	taml}', "");
    Expect(0, 73727, '\P{Scx=	taml}', "");
    Expect(1, 73727, '\P{^Scx=	taml}', "");
    Expect(0, 73728, '\p{Scx=	taml}', "");
    Expect(1, 73728, '\p{^Scx=	taml}', "");
    Expect(1, 73728, '\P{Scx=	taml}', "");
    Expect(0, 73728, '\P{^Scx=	taml}', "");
    Error('\p{Is_Script_Extensions=/a/_	Tamil}');
    Error('\P{Is_Script_Extensions=/a/_	Tamil}');
    Expect(1, 73727, '\p{Is_Script_Extensions=tamil}', "");
    Expect(0, 73727, '\p{^Is_Script_Extensions=tamil}', "");
    Expect(0, 73727, '\P{Is_Script_Extensions=tamil}', "");
    Expect(1, 73727, '\P{^Is_Script_Extensions=tamil}', "");
    Expect(0, 73728, '\p{Is_Script_Extensions=tamil}', "");
    Expect(1, 73728, '\p{^Is_Script_Extensions=tamil}', "");
    Expect(1, 73728, '\P{Is_Script_Extensions=tamil}', "");
    Expect(0, 73728, '\P{^Is_Script_Extensions=tamil}', "");
    Expect(1, 73727, '\p{Is_Script_Extensions= tamil}', "");
    Expect(0, 73727, '\p{^Is_Script_Extensions= tamil}', "");
    Expect(0, 73727, '\P{Is_Script_Extensions= tamil}', "");
    Expect(1, 73727, '\P{^Is_Script_Extensions= tamil}', "");
    Expect(0, 73728, '\p{Is_Script_Extensions= tamil}', "");
    Expect(1, 73728, '\p{^Is_Script_Extensions= tamil}', "");
    Expect(1, 73728, '\P{Is_Script_Extensions= tamil}', "");
    Expect(0, 73728, '\P{^Is_Script_Extensions= tamil}', "");
    Error('\p{Is_Scx=_-TAML:=}');
    Error('\P{Is_Scx=_-TAML:=}');
    Expect(1, 73727, '\p{Is_Scx=taml}', "");
    Expect(0, 73727, '\p{^Is_Scx=taml}', "");
    Expect(0, 73727, '\P{Is_Scx=taml}', "");
    Expect(1, 73727, '\P{^Is_Scx=taml}', "");
    Expect(0, 73728, '\p{Is_Scx=taml}', "");
    Expect(1, 73728, '\p{^Is_Scx=taml}', "");
    Expect(1, 73728, '\P{Is_Scx=taml}', "");
    Expect(0, 73728, '\P{^Is_Scx=taml}', "");
    Expect(1, 73727, '\p{Is_Scx=	-taml}', "");
    Expect(0, 73727, '\p{^Is_Scx=	-taml}', "");
    Expect(0, 73727, '\P{Is_Scx=	-taml}', "");
    Expect(1, 73727, '\P{^Is_Scx=	-taml}', "");
    Expect(0, 73728, '\p{Is_Scx=	-taml}', "");
    Expect(1, 73728, '\p{^Is_Scx=	-taml}', "");
    Expect(1, 73728, '\P{Is_Scx=	-taml}', "");
    Expect(0, 73728, '\P{^Is_Scx=	-taml}', "");
    Error('\p{Script_Extensions=__Tangut:=}');
    Error('\P{Script_Extensions=__Tangut:=}');
    Expect(1, 101106, '\p{Script_Extensions=:\ATangut\z:}', "");;
    Expect(0, 101107, '\p{Script_Extensions=:\ATangut\z:}', "");;
    Expect(1, 101106, '\p{Script_Extensions=tangut}', "");
    Expect(0, 101106, '\p{^Script_Extensions=tangut}', "");
    Expect(0, 101106, '\P{Script_Extensions=tangut}', "");
    Expect(1, 101106, '\P{^Script_Extensions=tangut}', "");
    Expect(0, 101107, '\p{Script_Extensions=tangut}', "");
    Expect(1, 101107, '\p{^Script_Extensions=tangut}', "");
    Expect(1, 101107, '\P{Script_Extensions=tangut}', "");
    Expect(0, 101107, '\P{^Script_Extensions=tangut}', "");
    Expect(1, 101106, '\p{Script_Extensions=:\Atangut\z:}', "");;
    Expect(0, 101107, '\p{Script_Extensions=:\Atangut\z:}', "");;
    Expect(1, 101106, '\p{Script_Extensions=	Tangut}', "");
    Expect(0, 101106, '\p{^Script_Extensions=	Tangut}', "");
    Expect(0, 101106, '\P{Script_Extensions=	Tangut}', "");
    Expect(1, 101106, '\P{^Script_Extensions=	Tangut}', "");
    Expect(0, 101107, '\p{Script_Extensions=	Tangut}', "");
    Expect(1, 101107, '\p{^Script_Extensions=	Tangut}', "");
    Expect(1, 101107, '\P{Script_Extensions=	Tangut}', "");
    Expect(0, 101107, '\P{^Script_Extensions=	Tangut}', "");
    Error('\p{Scx:   	Tang/a/}');
    Error('\P{Scx:   	Tang/a/}');
    Expect(1, 101106, '\p{Scx=:\ATang\z:}', "");;
    Expect(0, 101107, '\p{Scx=:\ATang\z:}', "");;
    Expect(1, 101106, '\p{Scx=tang}', "");
    Expect(0, 101106, '\p{^Scx=tang}', "");
    Expect(0, 101106, '\P{Scx=tang}', "");
    Expect(1, 101106, '\P{^Scx=tang}', "");
    Expect(0, 101107, '\p{Scx=tang}', "");
    Expect(1, 101107, '\p{^Scx=tang}', "");
    Expect(1, 101107, '\P{Scx=tang}', "");
    Expect(0, 101107, '\P{^Scx=tang}', "");
    Expect(1, 101106, '\p{Scx=:\Atang\z:}', "");;
    Expect(0, 101107, '\p{Scx=:\Atang\z:}', "");;
    Expect(1, 101106, '\p{Scx:   _ TANG}', "");
    Expect(0, 101106, '\p{^Scx:   _ TANG}', "");
    Expect(0, 101106, '\P{Scx:   _ TANG}', "");
    Expect(1, 101106, '\P{^Scx:   _ TANG}', "");
    Expect(0, 101107, '\p{Scx:   _ TANG}', "");
    Expect(1, 101107, '\p{^Scx:   _ TANG}', "");
    Expect(1, 101107, '\P{Scx:   _ TANG}', "");
    Expect(0, 101107, '\P{^Scx:   _ TANG}', "");
    Error('\p{Is_Script_Extensions=:=Tangut}');
    Error('\P{Is_Script_Extensions=:=Tangut}');
    Expect(1, 101106, '\p{Is_Script_Extensions=tangut}', "");
    Expect(0, 101106, '\p{^Is_Script_Extensions=tangut}', "");
    Expect(0, 101106, '\P{Is_Script_Extensions=tangut}', "");
    Expect(1, 101106, '\P{^Is_Script_Extensions=tangut}', "");
    Expect(0, 101107, '\p{Is_Script_Extensions=tangut}', "");
    Expect(1, 101107, '\p{^Is_Script_Extensions=tangut}', "");
    Expect(1, 101107, '\P{Is_Script_Extensions=tangut}', "");
    Expect(0, 101107, '\P{^Is_Script_Extensions=tangut}', "");
    Expect(1, 101106, '\p{Is_Script_Extensions:	 	Tangut}', "");
    Expect(0, 101106, '\p{^Is_Script_Extensions:	 	Tangut}', "");
    Expect(0, 101106, '\P{Is_Script_Extensions:	 	Tangut}', "");
    Expect(1, 101106, '\P{^Is_Script_Extensions:	 	Tangut}', "");
    Expect(0, 101107, '\p{Is_Script_Extensions:	 	Tangut}', "");
    Expect(1, 101107, '\p{^Is_Script_Extensions:	 	Tangut}', "");
    Expect(1, 101107, '\P{Is_Script_Extensions:	 	Tangut}', "");
    Expect(0, 101107, '\P{^Is_Script_Extensions:	 	Tangut}', "");
    Error('\p{Is_Scx=-	Tang:=}');
    Error('\P{Is_Scx=-	Tang:=}');
    Expect(1, 101106, '\p{Is_Scx=tang}', "");
    Expect(0, 101106, '\p{^Is_Scx=tang}', "");
    Expect(0, 101106, '\P{Is_Scx=tang}', "");
    Expect(1, 101106, '\P{^Is_Scx=tang}', "");
    Expect(0, 101107, '\p{Is_Scx=tang}', "");
    Expect(1, 101107, '\p{^Is_Scx=tang}', "");
    Expect(1, 101107, '\P{Is_Scx=tang}', "");
    Expect(0, 101107, '\P{^Is_Scx=tang}', "");
    Expect(1, 101106, '\p{Is_Scx=		TANG}', "");
    Expect(0, 101106, '\p{^Is_Scx=		TANG}', "");
    Expect(0, 101106, '\P{Is_Scx=		TANG}', "");
    Expect(1, 101106, '\P{^Is_Scx=		TANG}', "");
    Expect(0, 101107, '\p{Is_Scx=		TANG}', "");
    Expect(1, 101107, '\p{^Is_Scx=		TANG}', "");
    Expect(1, 101107, '\P{Is_Scx=		TANG}', "");
    Expect(0, 101107, '\P{^Is_Scx=		TANG}', "");
    Error('\p{Script_Extensions: 	:=tai_Viet}');
    Error('\P{Script_Extensions: 	:=tai_Viet}');
    Expect(1, 43743, '\p{Script_Extensions=:\ATai_Viet\z:}', "");;
    Expect(0, 43744, '\p{Script_Extensions=:\ATai_Viet\z:}', "");;
    Expect(1, 43743, '\p{Script_Extensions=taiviet}', "");
    Expect(0, 43743, '\p{^Script_Extensions=taiviet}', "");
    Expect(0, 43743, '\P{Script_Extensions=taiviet}', "");
    Expect(1, 43743, '\P{^Script_Extensions=taiviet}', "");
    Expect(0, 43744, '\p{Script_Extensions=taiviet}', "");
    Expect(1, 43744, '\p{^Script_Extensions=taiviet}', "");
    Expect(1, 43744, '\P{Script_Extensions=taiviet}', "");
    Expect(0, 43744, '\P{^Script_Extensions=taiviet}', "");
    Expect(1, 43743, '\p{Script_Extensions=:\Ataiviet\z:}', "");;
    Expect(0, 43744, '\p{Script_Extensions=:\Ataiviet\z:}', "");;
    Expect(1, 43743, '\p{Script_Extensions=-_Tai_VIET}', "");
    Expect(0, 43743, '\p{^Script_Extensions=-_Tai_VIET}', "");
    Expect(0, 43743, '\P{Script_Extensions=-_Tai_VIET}', "");
    Expect(1, 43743, '\P{^Script_Extensions=-_Tai_VIET}', "");
    Expect(0, 43744, '\p{Script_Extensions=-_Tai_VIET}', "");
    Expect(1, 43744, '\p{^Script_Extensions=-_Tai_VIET}', "");
    Expect(1, 43744, '\P{Script_Extensions=-_Tai_VIET}', "");
    Expect(0, 43744, '\P{^Script_Extensions=-_Tai_VIET}', "");
    Error('\p{Scx=_/a/Tavt}');
    Error('\P{Scx=_/a/Tavt}');
    Expect(1, 43743, '\p{Scx=:\ATavt\z:}', "");;
    Expect(0, 43744, '\p{Scx=:\ATavt\z:}', "");;
    Expect(1, 43743, '\p{Scx=tavt}', "");
    Expect(0, 43743, '\p{^Scx=tavt}', "");
    Expect(0, 43743, '\P{Scx=tavt}', "");
    Expect(1, 43743, '\P{^Scx=tavt}', "");
    Expect(0, 43744, '\p{Scx=tavt}', "");
    Expect(1, 43744, '\p{^Scx=tavt}', "");
    Expect(1, 43744, '\P{Scx=tavt}', "");
    Expect(0, 43744, '\P{^Scx=tavt}', "");
    Expect(1, 43743, '\p{Scx=:\Atavt\z:}', "");;
    Expect(0, 43744, '\p{Scx=:\Atavt\z:}', "");;
    Expect(1, 43743, '\p{Scx=  TAVT}', "");
    Expect(0, 43743, '\p{^Scx=  TAVT}', "");
    Expect(0, 43743, '\P{Scx=  TAVT}', "");
    Expect(1, 43743, '\P{^Scx=  TAVT}', "");
    Expect(0, 43744, '\p{Scx=  TAVT}', "");
    Expect(1, 43744, '\p{^Scx=  TAVT}', "");
    Expect(1, 43744, '\P{Scx=  TAVT}', "");
    Expect(0, 43744, '\P{^Scx=  TAVT}', "");
    Error('\p{Is_Script_Extensions= /a/Tai_Viet}');
    Error('\P{Is_Script_Extensions= /a/Tai_Viet}');
    Expect(1, 43743, '\p{Is_Script_Extensions=taiviet}', "");
    Expect(0, 43743, '\p{^Is_Script_Extensions=taiviet}', "");
    Expect(0, 43743, '\P{Is_Script_Extensions=taiviet}', "");
    Expect(1, 43743, '\P{^Is_Script_Extensions=taiviet}', "");
    Expect(0, 43744, '\p{Is_Script_Extensions=taiviet}', "");
    Expect(1, 43744, '\p{^Is_Script_Extensions=taiviet}', "");
    Expect(1, 43744, '\P{Is_Script_Extensions=taiviet}', "");
    Expect(0, 43744, '\P{^Is_Script_Extensions=taiviet}', "");
    Expect(1, 43743, '\p{Is_Script_Extensions=		Tai_viet}', "");
    Expect(0, 43743, '\p{^Is_Script_Extensions=		Tai_viet}', "");
    Expect(0, 43743, '\P{Is_Script_Extensions=		Tai_viet}', "");
    Expect(1, 43743, '\P{^Is_Script_Extensions=		Tai_viet}', "");
    Expect(0, 43744, '\p{Is_Script_Extensions=		Tai_viet}', "");
    Expect(1, 43744, '\p{^Is_Script_Extensions=		Tai_viet}', "");
    Expect(1, 43744, '\P{Is_Script_Extensions=		Tai_viet}', "");
    Expect(0, 43744, '\P{^Is_Script_Extensions=		Tai_viet}', "");
    Error('\p{Is_Scx= -Tavt:=}');
    Error('\P{Is_Scx= -Tavt:=}');
    Expect(1, 43743, '\p{Is_Scx=tavt}', "");
    Expect(0, 43743, '\p{^Is_Scx=tavt}', "");
    Expect(0, 43743, '\P{Is_Scx=tavt}', "");
    Expect(1, 43743, '\P{^Is_Scx=tavt}', "");
    Expect(0, 43744, '\p{Is_Scx=tavt}', "");
    Expect(1, 43744, '\p{^Is_Scx=tavt}', "");
    Expect(1, 43744, '\P{Is_Scx=tavt}', "");
    Expect(0, 43744, '\P{^Is_Scx=tavt}', "");
    Expect(1, 43743, '\p{Is_Scx= 	tavt}', "");
    Expect(0, 43743, '\p{^Is_Scx= 	tavt}', "");
    Expect(0, 43743, '\P{Is_Scx= 	tavt}', "");
    Expect(1, 43743, '\P{^Is_Scx= 	tavt}', "");
    Expect(0, 43744, '\p{Is_Scx= 	tavt}', "");
    Expect(1, 43744, '\p{^Is_Scx= 	tavt}', "");
    Expect(1, 43744, '\P{Is_Scx= 	tavt}', "");
    Expect(0, 43744, '\P{^Is_Scx= 	tavt}', "");
    Error('\p{Script_Extensions=	:=TELUGU}');
    Error('\P{Script_Extensions=	:=TELUGU}');
    Expect(1, 7410, '\p{Script_Extensions=:\ATelugu\z:}', "");;
    Expect(0, 7411, '\p{Script_Extensions=:\ATelugu\z:}', "");;
    Expect(1, 7410, '\p{Script_Extensions=telugu}', "");
    Expect(0, 7410, '\p{^Script_Extensions=telugu}', "");
    Expect(0, 7410, '\P{Script_Extensions=telugu}', "");
    Expect(1, 7410, '\P{^Script_Extensions=telugu}', "");
    Expect(0, 7411, '\p{Script_Extensions=telugu}', "");
    Expect(1, 7411, '\p{^Script_Extensions=telugu}', "");
    Expect(1, 7411, '\P{Script_Extensions=telugu}', "");
    Expect(0, 7411, '\P{^Script_Extensions=telugu}', "");
    Expect(1, 7410, '\p{Script_Extensions=:\Atelugu\z:}', "");;
    Expect(0, 7411, '\p{Script_Extensions=:\Atelugu\z:}', "");;
    Expect(1, 7410, '\p{Script_Extensions=_telugu}', "");
    Expect(0, 7410, '\p{^Script_Extensions=_telugu}', "");
    Expect(0, 7410, '\P{Script_Extensions=_telugu}', "");
    Expect(1, 7410, '\P{^Script_Extensions=_telugu}', "");
    Expect(0, 7411, '\p{Script_Extensions=_telugu}', "");
    Expect(1, 7411, '\p{^Script_Extensions=_telugu}', "");
    Expect(1, 7411, '\P{Script_Extensions=_telugu}', "");
    Expect(0, 7411, '\P{^Script_Extensions=_telugu}', "");
    Error('\p{Scx:	 Telu/a/}');
    Error('\P{Scx:	 Telu/a/}');
    Expect(1, 7410, '\p{Scx=:\ATelu\z:}', "");;
    Expect(0, 7411, '\p{Scx=:\ATelu\z:}', "");;
    Expect(1, 7410, '\p{Scx=telu}', "");
    Expect(0, 7410, '\p{^Scx=telu}', "");
    Expect(0, 7410, '\P{Scx=telu}', "");
    Expect(1, 7410, '\P{^Scx=telu}', "");
    Expect(0, 7411, '\p{Scx=telu}', "");
    Expect(1, 7411, '\p{^Scx=telu}', "");
    Expect(1, 7411, '\P{Scx=telu}', "");
    Expect(0, 7411, '\P{^Scx=telu}', "");
    Expect(1, 7410, '\p{Scx=:\Atelu\z:}', "");;
    Expect(0, 7411, '\p{Scx=:\Atelu\z:}', "");;
    Expect(1, 7410, '\p{Scx=-Telu}', "");
    Expect(0, 7410, '\p{^Scx=-Telu}', "");
    Expect(0, 7410, '\P{Scx=-Telu}', "");
    Expect(1, 7410, '\P{^Scx=-Telu}', "");
    Expect(0, 7411, '\p{Scx=-Telu}', "");
    Expect(1, 7411, '\p{^Scx=-Telu}', "");
    Expect(1, 7411, '\P{Scx=-Telu}', "");
    Expect(0, 7411, '\P{^Scx=-Telu}', "");
    Error('\p{Is_Script_Extensions= _Telugu/a/}');
    Error('\P{Is_Script_Extensions= _Telugu/a/}');
    Expect(1, 7410, '\p{Is_Script_Extensions=telugu}', "");
    Expect(0, 7410, '\p{^Is_Script_Extensions=telugu}', "");
    Expect(0, 7410, '\P{Is_Script_Extensions=telugu}', "");
    Expect(1, 7410, '\P{^Is_Script_Extensions=telugu}', "");
    Expect(0, 7411, '\p{Is_Script_Extensions=telugu}', "");
    Expect(1, 7411, '\p{^Is_Script_Extensions=telugu}', "");
    Expect(1, 7411, '\P{Is_Script_Extensions=telugu}', "");
    Expect(0, 7411, '\P{^Is_Script_Extensions=telugu}', "");
    Expect(1, 7410, '\p{Is_Script_Extensions=-	Telugu}', "");
    Expect(0, 7410, '\p{^Is_Script_Extensions=-	Telugu}', "");
    Expect(0, 7410, '\P{Is_Script_Extensions=-	Telugu}', "");
    Expect(1, 7410, '\P{^Is_Script_Extensions=-	Telugu}', "");
    Expect(0, 7411, '\p{Is_Script_Extensions=-	Telugu}', "");
    Expect(1, 7411, '\p{^Is_Script_Extensions=-	Telugu}', "");
    Expect(1, 7411, '\P{Is_Script_Extensions=-	Telugu}', "");
    Expect(0, 7411, '\P{^Is_Script_Extensions=-	Telugu}', "");
    Error('\p{Is_Scx=_Telu/a/}');
    Error('\P{Is_Scx=_Telu/a/}');
    Expect(1, 7410, '\p{Is_Scx=telu}', "");
    Expect(0, 7410, '\p{^Is_Scx=telu}', "");
    Expect(0, 7410, '\P{Is_Scx=telu}', "");
    Expect(1, 7410, '\P{^Is_Scx=telu}', "");
    Expect(0, 7411, '\p{Is_Scx=telu}', "");
    Expect(1, 7411, '\p{^Is_Scx=telu}', "");
    Expect(1, 7411, '\P{Is_Scx=telu}', "");
    Expect(0, 7411, '\P{^Is_Scx=telu}', "");
    Expect(1, 7410, '\p{Is_Scx=	-telu}', "");
    Expect(0, 7410, '\p{^Is_Scx=	-telu}', "");
    Expect(0, 7410, '\P{Is_Scx=	-telu}', "");
    Expect(1, 7410, '\P{^Is_Scx=	-telu}', "");
    Expect(0, 7411, '\p{Is_Scx=	-telu}', "");
    Expect(1, 7411, '\p{^Is_Scx=	-telu}', "");
    Expect(1, 7411, '\P{Is_Scx=	-telu}', "");
    Expect(0, 7411, '\P{^Is_Scx=	-telu}', "");
    Error('\p{Script_Extensions=-/a/Tifinagh}');
    Error('\P{Script_Extensions=-/a/Tifinagh}');
    Expect(1, 11647, '\p{Script_Extensions=:\ATifinagh\z:}', "");;
    Expect(0, 11648, '\p{Script_Extensions=:\ATifinagh\z:}', "");;
    Expect(1, 11647, '\p{Script_Extensions=tifinagh}', "");
    Expect(0, 11647, '\p{^Script_Extensions=tifinagh}', "");
    Expect(0, 11647, '\P{Script_Extensions=tifinagh}', "");
    Expect(1, 11647, '\P{^Script_Extensions=tifinagh}', "");
    Expect(0, 11648, '\p{Script_Extensions=tifinagh}', "");
    Expect(1, 11648, '\p{^Script_Extensions=tifinagh}', "");
    Expect(1, 11648, '\P{Script_Extensions=tifinagh}', "");
    Expect(0, 11648, '\P{^Script_Extensions=tifinagh}', "");
    Expect(1, 11647, '\p{Script_Extensions=:\Atifinagh\z:}', "");;
    Expect(0, 11648, '\p{Script_Extensions=:\Atifinagh\z:}', "");;
    Expect(1, 11647, '\p{Script_Extensions=_-TIFINAGH}', "");
    Expect(0, 11647, '\p{^Script_Extensions=_-TIFINAGH}', "");
    Expect(0, 11647, '\P{Script_Extensions=_-TIFINAGH}', "");
    Expect(1, 11647, '\P{^Script_Extensions=_-TIFINAGH}', "");
    Expect(0, 11648, '\p{Script_Extensions=_-TIFINAGH}', "");
    Expect(1, 11648, '\p{^Script_Extensions=_-TIFINAGH}', "");
    Expect(1, 11648, '\P{Script_Extensions=_-TIFINAGH}', "");
    Expect(0, 11648, '\P{^Script_Extensions=_-TIFINAGH}', "");
    Error('\p{Scx=	 Tfng/a/}');
    Error('\P{Scx=	 Tfng/a/}');
    Expect(1, 11647, '\p{Scx=:\ATfng\z:}', "");;
    Expect(0, 11648, '\p{Scx=:\ATfng\z:}', "");;
    Expect(1, 11647, '\p{Scx:tfng}', "");
    Expect(0, 11647, '\p{^Scx:tfng}', "");
    Expect(0, 11647, '\P{Scx:tfng}', "");
    Expect(1, 11647, '\P{^Scx:tfng}', "");
    Expect(0, 11648, '\p{Scx:tfng}', "");
    Expect(1, 11648, '\p{^Scx:tfng}', "");
    Expect(1, 11648, '\P{Scx:tfng}', "");
    Expect(0, 11648, '\P{^Scx:tfng}', "");
    Expect(1, 11647, '\p{Scx=:\Atfng\z:}', "");;
    Expect(0, 11648, '\p{Scx=:\Atfng\z:}', "");;
    Expect(1, 11647, '\p{Scx=	 tfng}', "");
    Expect(0, 11647, '\p{^Scx=	 tfng}', "");
    Expect(0, 11647, '\P{Scx=	 tfng}', "");
    Expect(1, 11647, '\P{^Scx=	 tfng}', "");
    Expect(0, 11648, '\p{Scx=	 tfng}', "");
    Expect(1, 11648, '\p{^Scx=	 tfng}', "");
    Expect(1, 11648, '\P{Scx=	 tfng}', "");
    Expect(0, 11648, '\P{^Scx=	 tfng}', "");
    Error('\p{Is_Script_Extensions=:=-	tifinagh}');
    Error('\P{Is_Script_Extensions=:=-	tifinagh}');
    Expect(1, 11647, '\p{Is_Script_Extensions=tifinagh}', "");
    Expect(0, 11647, '\p{^Is_Script_Extensions=tifinagh}', "");
    Expect(0, 11647, '\P{Is_Script_Extensions=tifinagh}', "");
    Expect(1, 11647, '\P{^Is_Script_Extensions=tifinagh}', "");
    Expect(0, 11648, '\p{Is_Script_Extensions=tifinagh}', "");
    Expect(1, 11648, '\p{^Is_Script_Extensions=tifinagh}', "");
    Expect(1, 11648, '\P{Is_Script_Extensions=tifinagh}', "");
    Expect(0, 11648, '\P{^Is_Script_Extensions=tifinagh}', "");
    Expect(1, 11647, '\p{Is_Script_Extensions=_TIFINAGH}', "");
    Expect(0, 11647, '\p{^Is_Script_Extensions=_TIFINAGH}', "");
    Expect(0, 11647, '\P{Is_Script_Extensions=_TIFINAGH}', "");
    Expect(1, 11647, '\P{^Is_Script_Extensions=_TIFINAGH}', "");
    Expect(0, 11648, '\p{Is_Script_Extensions=_TIFINAGH}', "");
    Expect(1, 11648, '\p{^Is_Script_Extensions=_TIFINAGH}', "");
    Expect(1, 11648, '\P{Is_Script_Extensions=_TIFINAGH}', "");
    Expect(0, 11648, '\P{^Is_Script_Extensions=_TIFINAGH}', "");
    Error('\p{Is_Scx=--Tfng:=}');
    Error('\P{Is_Scx=--Tfng:=}');
    Expect(1, 11647, '\p{Is_Scx=tfng}', "");
    Expect(0, 11647, '\p{^Is_Scx=tfng}', "");
    Expect(0, 11647, '\P{Is_Scx=tfng}', "");
    Expect(1, 11647, '\P{^Is_Scx=tfng}', "");
    Expect(0, 11648, '\p{Is_Scx=tfng}', "");
    Expect(1, 11648, '\p{^Is_Scx=tfng}', "");
    Expect(1, 11648, '\P{Is_Scx=tfng}', "");
    Expect(0, 11648, '\P{^Is_Scx=tfng}', "");
    Expect(1, 11647, '\p{Is_Scx: - Tfng}', "");
    Expect(0, 11647, '\p{^Is_Scx: - Tfng}', "");
    Expect(0, 11647, '\P{Is_Scx: - Tfng}', "");
    Expect(1, 11647, '\P{^Is_Scx: - Tfng}', "");
    Expect(0, 11648, '\p{Is_Scx: - Tfng}', "");
    Expect(1, 11648, '\p{^Is_Scx: - Tfng}', "");
    Expect(1, 11648, '\P{Is_Scx: - Tfng}', "");
    Expect(0, 11648, '\P{^Is_Scx: - Tfng}', "");
    Error('\p{Script_Extensions=:= Tagalog}');
    Error('\P{Script_Extensions=:= Tagalog}');
    Expect(1, 5942, '\p{Script_Extensions=:\ATagalog\z:}', "");;
    Expect(0, 5943, '\p{Script_Extensions=:\ATagalog\z:}', "");;
    Expect(1, 5942, '\p{Script_Extensions=tagalog}', "");
    Expect(0, 5942, '\p{^Script_Extensions=tagalog}', "");
    Expect(0, 5942, '\P{Script_Extensions=tagalog}', "");
    Expect(1, 5942, '\P{^Script_Extensions=tagalog}', "");
    Expect(0, 5943, '\p{Script_Extensions=tagalog}', "");
    Expect(1, 5943, '\p{^Script_Extensions=tagalog}', "");
    Expect(1, 5943, '\P{Script_Extensions=tagalog}', "");
    Expect(0, 5943, '\P{^Script_Extensions=tagalog}', "");
    Expect(1, 5942, '\p{Script_Extensions=:\Atagalog\z:}', "");;
    Expect(0, 5943, '\p{Script_Extensions=:\Atagalog\z:}', "");;
    Expect(1, 5942, '\p{Script_Extensions= tagalog}', "");
    Expect(0, 5942, '\p{^Script_Extensions= tagalog}', "");
    Expect(0, 5942, '\P{Script_Extensions= tagalog}', "");
    Expect(1, 5942, '\P{^Script_Extensions= tagalog}', "");
    Expect(0, 5943, '\p{Script_Extensions= tagalog}', "");
    Expect(1, 5943, '\p{^Script_Extensions= tagalog}', "");
    Expect(1, 5943, '\P{Script_Extensions= tagalog}', "");
    Expect(0, 5943, '\P{^Script_Extensions= tagalog}', "");
    Error('\p{Scx=:=	_tglg}');
    Error('\P{Scx=:=	_tglg}');
    Expect(1, 5942, '\p{Scx=:\ATglg\z:}', "");;
    Expect(0, 5943, '\p{Scx=:\ATglg\z:}', "");;
    Expect(1, 5942, '\p{Scx=tglg}', "");
    Expect(0, 5942, '\p{^Scx=tglg}', "");
    Expect(0, 5942, '\P{Scx=tglg}', "");
    Expect(1, 5942, '\P{^Scx=tglg}', "");
    Expect(0, 5943, '\p{Scx=tglg}', "");
    Expect(1, 5943, '\p{^Scx=tglg}', "");
    Expect(1, 5943, '\P{Scx=tglg}', "");
    Expect(0, 5943, '\P{^Scx=tglg}', "");
    Expect(1, 5942, '\p{Scx=:\Atglg\z:}', "");;
    Expect(0, 5943, '\p{Scx=:\Atglg\z:}', "");;
    Expect(1, 5942, '\p{Scx=	-Tglg}', "");
    Expect(0, 5942, '\p{^Scx=	-Tglg}', "");
    Expect(0, 5942, '\P{Scx=	-Tglg}', "");
    Expect(1, 5942, '\P{^Scx=	-Tglg}', "");
    Expect(0, 5943, '\p{Scx=	-Tglg}', "");
    Expect(1, 5943, '\p{^Scx=	-Tglg}', "");
    Expect(1, 5943, '\P{Scx=	-Tglg}', "");
    Expect(0, 5943, '\P{^Scx=	-Tglg}', "");
    Error('\p{Is_Script_Extensions=/a/ TAGALOG}');
    Error('\P{Is_Script_Extensions=/a/ TAGALOG}');
    Expect(1, 5942, '\p{Is_Script_Extensions:	tagalog}', "");
    Expect(0, 5942, '\p{^Is_Script_Extensions:	tagalog}', "");
    Expect(0, 5942, '\P{Is_Script_Extensions:	tagalog}', "");
    Expect(1, 5942, '\P{^Is_Script_Extensions:	tagalog}', "");
    Expect(0, 5943, '\p{Is_Script_Extensions:	tagalog}', "");
    Expect(1, 5943, '\p{^Is_Script_Extensions:	tagalog}', "");
    Expect(1, 5943, '\P{Is_Script_Extensions:	tagalog}', "");
    Expect(0, 5943, '\P{^Is_Script_Extensions:	tagalog}', "");
    Expect(1, 5942, '\p{Is_Script_Extensions= 	TAGALOG}', "");
    Expect(0, 5942, '\p{^Is_Script_Extensions= 	TAGALOG}', "");
    Expect(0, 5942, '\P{Is_Script_Extensions= 	TAGALOG}', "");
    Expect(1, 5942, '\P{^Is_Script_Extensions= 	TAGALOG}', "");
    Expect(0, 5943, '\p{Is_Script_Extensions= 	TAGALOG}', "");
    Expect(1, 5943, '\p{^Is_Script_Extensions= 	TAGALOG}', "");
    Expect(1, 5943, '\P{Is_Script_Extensions= 	TAGALOG}', "");
    Expect(0, 5943, '\P{^Is_Script_Extensions= 	TAGALOG}', "");
    Error('\p{Is_Scx=_/a/Tglg}');
    Error('\P{Is_Scx=_/a/Tglg}');
    Expect(1, 5942, '\p{Is_Scx=tglg}', "");
    Expect(0, 5942, '\p{^Is_Scx=tglg}', "");
    Expect(0, 5942, '\P{Is_Scx=tglg}', "");
    Expect(1, 5942, '\P{^Is_Scx=tglg}', "");
    Expect(0, 5943, '\p{Is_Scx=tglg}', "");
    Expect(1, 5943, '\p{^Is_Scx=tglg}', "");
    Expect(1, 5943, '\P{Is_Scx=tglg}', "");
    Expect(0, 5943, '\P{^Is_Scx=tglg}', "");
    Expect(1, 5942, '\p{Is_Scx= _Tglg}', "");
    Expect(0, 5942, '\p{^Is_Scx= _Tglg}', "");
    Expect(0, 5942, '\P{Is_Scx= _Tglg}', "");
    Expect(1, 5942, '\P{^Is_Scx= _Tglg}', "");
    Expect(0, 5943, '\p{Is_Scx= _Tglg}', "");
    Expect(1, 5943, '\p{^Is_Scx= _Tglg}', "");
    Expect(1, 5943, '\P{Is_Scx= _Tglg}', "");
    Expect(0, 5943, '\P{^Is_Scx= _Tglg}', "");
    Error('\p{Script_Extensions= /a/thaana}');
    Error('\P{Script_Extensions= /a/thaana}');
    Expect(1, 65021, '\p{Script_Extensions=:\AThaana\z:}', "");;
    Expect(0, 65022, '\p{Script_Extensions=:\AThaana\z:}', "");;
    Expect(1, 65021, '\p{Script_Extensions=thaana}', "");
    Expect(0, 65021, '\p{^Script_Extensions=thaana}', "");
    Expect(0, 65021, '\P{Script_Extensions=thaana}', "");
    Expect(1, 65021, '\P{^Script_Extensions=thaana}', "");
    Expect(0, 65022, '\p{Script_Extensions=thaana}', "");
    Expect(1, 65022, '\p{^Script_Extensions=thaana}', "");
    Expect(1, 65022, '\P{Script_Extensions=thaana}', "");
    Expect(0, 65022, '\P{^Script_Extensions=thaana}', "");
    Expect(1, 65021, '\p{Script_Extensions=:\Athaana\z:}', "");;
    Expect(0, 65022, '\p{Script_Extensions=:\Athaana\z:}', "");;
    Expect(1, 65021, '\p{Script_Extensions=_THAANA}', "");
    Expect(0, 65021, '\p{^Script_Extensions=_THAANA}', "");
    Expect(0, 65021, '\P{Script_Extensions=_THAANA}', "");
    Expect(1, 65021, '\P{^Script_Extensions=_THAANA}', "");
    Expect(0, 65022, '\p{Script_Extensions=_THAANA}', "");
    Expect(1, 65022, '\p{^Script_Extensions=_THAANA}', "");
    Expect(1, 65022, '\P{Script_Extensions=_THAANA}', "");
    Expect(0, 65022, '\P{^Script_Extensions=_THAANA}', "");
    Error('\p{Scx=:=  THAA}');
    Error('\P{Scx=:=  THAA}');
    Expect(1, 65021, '\p{Scx=:\AThaa\z:}', "");;
    Expect(0, 65022, '\p{Scx=:\AThaa\z:}', "");;
    Expect(1, 65021, '\p{Scx=thaa}', "");
    Expect(0, 65021, '\p{^Scx=thaa}', "");
    Expect(0, 65021, '\P{Scx=thaa}', "");
    Expect(1, 65021, '\P{^Scx=thaa}', "");
    Expect(0, 65022, '\p{Scx=thaa}', "");
    Expect(1, 65022, '\p{^Scx=thaa}', "");
    Expect(1, 65022, '\P{Scx=thaa}', "");
    Expect(0, 65022, '\P{^Scx=thaa}', "");
    Expect(1, 65021, '\p{Scx=:\Athaa\z:}', "");;
    Expect(0, 65022, '\p{Scx=:\Athaa\z:}', "");;
    Expect(1, 65021, '\p{Scx=	-Thaa}', "");
    Expect(0, 65021, '\p{^Scx=	-Thaa}', "");
    Expect(0, 65021, '\P{Scx=	-Thaa}', "");
    Expect(1, 65021, '\P{^Scx=	-Thaa}', "");
    Expect(0, 65022, '\p{Scx=	-Thaa}', "");
    Expect(1, 65022, '\p{^Scx=	-Thaa}', "");
    Expect(1, 65022, '\P{Scx=	-Thaa}', "");
    Expect(0, 65022, '\P{^Scx=	-Thaa}', "");
    Error('\p{Is_Script_Extensions=/a/_thaana}');
    Error('\P{Is_Script_Extensions=/a/_thaana}');
    Expect(1, 65021, '\p{Is_Script_Extensions=thaana}', "");
    Expect(0, 65021, '\p{^Is_Script_Extensions=thaana}', "");
    Expect(0, 65021, '\P{Is_Script_Extensions=thaana}', "");
    Expect(1, 65021, '\P{^Is_Script_Extensions=thaana}', "");
    Expect(0, 65022, '\p{Is_Script_Extensions=thaana}', "");
    Expect(1, 65022, '\p{^Is_Script_Extensions=thaana}', "");
    Expect(1, 65022, '\P{Is_Script_Extensions=thaana}', "");
    Expect(0, 65022, '\P{^Is_Script_Extensions=thaana}', "");
    Expect(1, 65021, '\p{Is_Script_Extensions=_-Thaana}', "");
    Expect(0, 65021, '\p{^Is_Script_Extensions=_-Thaana}', "");
    Expect(0, 65021, '\P{Is_Script_Extensions=_-Thaana}', "");
    Expect(1, 65021, '\P{^Is_Script_Extensions=_-Thaana}', "");
    Expect(0, 65022, '\p{Is_Script_Extensions=_-Thaana}', "");
    Expect(1, 65022, '\p{^Is_Script_Extensions=_-Thaana}', "");
    Expect(1, 65022, '\P{Is_Script_Extensions=_-Thaana}', "");
    Expect(0, 65022, '\P{^Is_Script_Extensions=_-Thaana}', "");
    Error('\p{Is_Scx=:=	THAA}');
    Error('\P{Is_Scx=:=	THAA}');
    Expect(1, 65021, '\p{Is_Scx=thaa}', "");
    Expect(0, 65021, '\p{^Is_Scx=thaa}', "");
    Expect(0, 65021, '\P{Is_Scx=thaa}', "");
    Expect(1, 65021, '\P{^Is_Scx=thaa}', "");
    Expect(0, 65022, '\p{Is_Scx=thaa}', "");
    Expect(1, 65022, '\p{^Is_Scx=thaa}', "");
    Expect(1, 65022, '\P{Is_Scx=thaa}', "");
    Expect(0, 65022, '\P{^Is_Scx=thaa}', "");
    Expect(1, 65021, '\p{Is_Scx= thaa}', "");
    Expect(0, 65021, '\p{^Is_Scx= thaa}', "");
    Expect(0, 65021, '\P{Is_Scx= thaa}', "");
    Expect(1, 65021, '\P{^Is_Scx= thaa}', "");
    Expect(0, 65022, '\p{Is_Scx= thaa}', "");
    Expect(1, 65022, '\p{^Is_Scx= thaa}', "");
    Expect(1, 65022, '\P{Is_Scx= thaa}', "");
    Expect(0, 65022, '\P{^Is_Scx= thaa}', "");
    Error('\p{Script_Extensions: /a/-Thai}');
    Error('\P{Script_Extensions: /a/-Thai}');
    Expect(1, 3675, '\p{Script_Extensions=:\AThai\z:}', "");;
    Expect(0, 3676, '\p{Script_Extensions=:\AThai\z:}', "");;
    Expect(1, 3675, '\p{Script_Extensions=thai}', "");
    Expect(0, 3675, '\p{^Script_Extensions=thai}', "");
    Expect(0, 3675, '\P{Script_Extensions=thai}', "");
    Expect(1, 3675, '\P{^Script_Extensions=thai}', "");
    Expect(0, 3676, '\p{Script_Extensions=thai}', "");
    Expect(1, 3676, '\p{^Script_Extensions=thai}', "");
    Expect(1, 3676, '\P{Script_Extensions=thai}', "");
    Expect(0, 3676, '\P{^Script_Extensions=thai}', "");
    Expect(1, 3675, '\p{Script_Extensions=:\Athai\z:}', "");;
    Expect(0, 3676, '\p{Script_Extensions=:\Athai\z:}', "");;
    Expect(1, 3675, '\p{Script_Extensions=Thai}', "");
    Expect(0, 3675, '\p{^Script_Extensions=Thai}', "");
    Expect(0, 3675, '\P{Script_Extensions=Thai}', "");
    Expect(1, 3675, '\P{^Script_Extensions=Thai}', "");
    Expect(0, 3676, '\p{Script_Extensions=Thai}', "");
    Expect(1, 3676, '\p{^Script_Extensions=Thai}', "");
    Expect(1, 3676, '\P{Script_Extensions=Thai}', "");
    Expect(0, 3676, '\P{^Script_Extensions=Thai}', "");
    Error('\p{Scx=:=  Thai}');
    Error('\P{Scx=:=  Thai}');
    Expect(1, 3675, '\p{Scx=:\AThai\z:}', "");;
    Expect(0, 3676, '\p{Scx=:\AThai\z:}', "");;
    Expect(1, 3675, '\p{Scx=thai}', "");
    Expect(0, 3675, '\p{^Scx=thai}', "");
    Expect(0, 3675, '\P{Scx=thai}', "");
    Expect(1, 3675, '\P{^Scx=thai}', "");
    Expect(0, 3676, '\p{Scx=thai}', "");
    Expect(1, 3676, '\p{^Scx=thai}', "");
    Expect(1, 3676, '\P{Scx=thai}', "");
    Expect(0, 3676, '\P{^Scx=thai}', "");
    Expect(1, 3675, '\p{Scx=:\Athai\z:}', "");;
    Expect(0, 3676, '\p{Scx=:\Athai\z:}', "");;
    Expect(1, 3675, '\p{Scx=		THAI}', "");
    Expect(0, 3675, '\p{^Scx=		THAI}', "");
    Expect(0, 3675, '\P{Scx=		THAI}', "");
    Expect(1, 3675, '\P{^Scx=		THAI}', "");
    Expect(0, 3676, '\p{Scx=		THAI}', "");
    Expect(1, 3676, '\p{^Scx=		THAI}', "");
    Expect(1, 3676, '\P{Scx=		THAI}', "");
    Expect(0, 3676, '\P{^Scx=		THAI}', "");
    Error('\p{Is_Script_Extensions=- Thai/a/}');
    Error('\P{Is_Script_Extensions=- Thai/a/}');
    Expect(1, 3675, '\p{Is_Script_Extensions=thai}', "");
    Expect(0, 3675, '\p{^Is_Script_Extensions=thai}', "");
    Expect(0, 3675, '\P{Is_Script_Extensions=thai}', "");
    Expect(1, 3675, '\P{^Is_Script_Extensions=thai}', "");
    Expect(0, 3676, '\p{Is_Script_Extensions=thai}', "");
    Expect(1, 3676, '\p{^Is_Script_Extensions=thai}', "");
    Expect(1, 3676, '\P{Is_Script_Extensions=thai}', "");
    Expect(0, 3676, '\P{^Is_Script_Extensions=thai}', "");
    Expect(1, 3675, '\p{Is_Script_Extensions=-thai}', "");
    Expect(0, 3675, '\p{^Is_Script_Extensions=-thai}', "");
    Expect(0, 3675, '\P{Is_Script_Extensions=-thai}', "");
    Expect(1, 3675, '\P{^Is_Script_Extensions=-thai}', "");
    Expect(0, 3676, '\p{Is_Script_Extensions=-thai}', "");
    Expect(1, 3676, '\p{^Is_Script_Extensions=-thai}', "");
    Expect(1, 3676, '\P{Is_Script_Extensions=-thai}', "");
    Expect(0, 3676, '\P{^Is_Script_Extensions=-thai}', "");
    Error('\p{Is_Scx= :=Thai}');
    Error('\P{Is_Scx= :=Thai}');
    Expect(1, 3675, '\p{Is_Scx=thai}', "");
    Expect(0, 3675, '\p{^Is_Scx=thai}', "");
    Expect(0, 3675, '\P{Is_Scx=thai}', "");
    Expect(1, 3675, '\P{^Is_Scx=thai}', "");
    Expect(0, 3676, '\p{Is_Scx=thai}', "");
    Expect(1, 3676, '\p{^Is_Scx=thai}', "");
    Expect(1, 3676, '\P{Is_Scx=thai}', "");
    Expect(0, 3676, '\P{^Is_Scx=thai}', "");
    Expect(1, 3675, '\p{Is_Scx=-thai}', "");
    Expect(0, 3675, '\p{^Is_Scx=-thai}', "");
    Expect(0, 3675, '\P{Is_Scx=-thai}', "");
    Expect(1, 3675, '\P{^Is_Scx=-thai}', "");
    Expect(0, 3676, '\p{Is_Scx=-thai}', "");
    Expect(1, 3676, '\p{^Is_Scx=-thai}', "");
    Expect(1, 3676, '\P{Is_Scx=-thai}', "");
    Expect(0, 3676, '\P{^Is_Scx=-thai}', "");
    Error('\p{Script_Extensions=_	Tibetan/a/}');
    Error('\P{Script_Extensions=_	Tibetan/a/}');
    Expect(1, 4058, '\p{Script_Extensions=:\ATibetan\z:}', "");;
    Expect(0, 4059, '\p{Script_Extensions=:\ATibetan\z:}', "");;
    Expect(1, 4058, '\p{Script_Extensions=tibetan}', "");
    Expect(0, 4058, '\p{^Script_Extensions=tibetan}', "");
    Expect(0, 4058, '\P{Script_Extensions=tibetan}', "");
    Expect(1, 4058, '\P{^Script_Extensions=tibetan}', "");
    Expect(0, 4059, '\p{Script_Extensions=tibetan}', "");
    Expect(1, 4059, '\p{^Script_Extensions=tibetan}', "");
    Expect(1, 4059, '\P{Script_Extensions=tibetan}', "");
    Expect(0, 4059, '\P{^Script_Extensions=tibetan}', "");
    Expect(1, 4058, '\p{Script_Extensions=:\Atibetan\z:}', "");;
    Expect(0, 4059, '\p{Script_Extensions=:\Atibetan\z:}', "");;
    Expect(1, 4058, '\p{Script_Extensions=		Tibetan}', "");
    Expect(0, 4058, '\p{^Script_Extensions=		Tibetan}', "");
    Expect(0, 4058, '\P{Script_Extensions=		Tibetan}', "");
    Expect(1, 4058, '\P{^Script_Extensions=		Tibetan}', "");
    Expect(0, 4059, '\p{Script_Extensions=		Tibetan}', "");
    Expect(1, 4059, '\p{^Script_Extensions=		Tibetan}', "");
    Expect(1, 4059, '\P{Script_Extensions=		Tibetan}', "");
    Expect(0, 4059, '\P{^Script_Extensions=		Tibetan}', "");
    Error('\p{Scx=-/a/Tibt}');
    Error('\P{Scx=-/a/Tibt}');
    Expect(1, 4058, '\p{Scx=:\ATibt\z:}', "");;
    Expect(0, 4059, '\p{Scx=:\ATibt\z:}', "");;
    Expect(1, 4058, '\p{Scx=tibt}', "");
    Expect(0, 4058, '\p{^Scx=tibt}', "");
    Expect(0, 4058, '\P{Scx=tibt}', "");
    Expect(1, 4058, '\P{^Scx=tibt}', "");
    Expect(0, 4059, '\p{Scx=tibt}', "");
    Expect(1, 4059, '\p{^Scx=tibt}', "");
    Expect(1, 4059, '\P{Scx=tibt}', "");
    Expect(0, 4059, '\P{^Scx=tibt}', "");
    Expect(1, 4058, '\p{Scx=:\Atibt\z:}', "");;
    Expect(0, 4059, '\p{Scx=:\Atibt\z:}', "");;
    Expect(1, 4058, '\p{Scx=__tibt}', "");
    Expect(0, 4058, '\p{^Scx=__tibt}', "");
    Expect(0, 4058, '\P{Scx=__tibt}', "");
    Expect(1, 4058, '\P{^Scx=__tibt}', "");
    Expect(0, 4059, '\p{Scx=__tibt}', "");
    Expect(1, 4059, '\p{^Scx=__tibt}', "");
    Expect(1, 4059, '\P{Scx=__tibt}', "");
    Expect(0, 4059, '\P{^Scx=__tibt}', "");
    Error('\p{Is_Script_Extensions:/a/  tibetan}');
    Error('\P{Is_Script_Extensions:/a/  tibetan}');
    Expect(1, 4058, '\p{Is_Script_Extensions=tibetan}', "");
    Expect(0, 4058, '\p{^Is_Script_Extensions=tibetan}', "");
    Expect(0, 4058, '\P{Is_Script_Extensions=tibetan}', "");
    Expect(1, 4058, '\P{^Is_Script_Extensions=tibetan}', "");
    Expect(0, 4059, '\p{Is_Script_Extensions=tibetan}', "");
    Expect(1, 4059, '\p{^Is_Script_Extensions=tibetan}', "");
    Expect(1, 4059, '\P{Is_Script_Extensions=tibetan}', "");
    Expect(0, 4059, '\P{^Is_Script_Extensions=tibetan}', "");
    Expect(1, 4058, '\p{Is_Script_Extensions=_Tibetan}', "");
    Expect(0, 4058, '\p{^Is_Script_Extensions=_Tibetan}', "");
    Expect(0, 4058, '\P{Is_Script_Extensions=_Tibetan}', "");
    Expect(1, 4058, '\P{^Is_Script_Extensions=_Tibetan}', "");
    Expect(0, 4059, '\p{Is_Script_Extensions=_Tibetan}', "");
    Expect(1, 4059, '\p{^Is_Script_Extensions=_Tibetan}', "");
    Expect(1, 4059, '\P{Is_Script_Extensions=_Tibetan}', "");
    Expect(0, 4059, '\P{^Is_Script_Extensions=_Tibetan}', "");
    Error('\p{Is_Scx=	:=Tibt}');
    Error('\P{Is_Scx=	:=Tibt}');
    Expect(1, 4058, '\p{Is_Scx=tibt}', "");
    Expect(0, 4058, '\p{^Is_Scx=tibt}', "");
    Expect(0, 4058, '\P{Is_Scx=tibt}', "");
    Expect(1, 4058, '\P{^Is_Scx=tibt}', "");
    Expect(0, 4059, '\p{Is_Scx=tibt}', "");
    Expect(1, 4059, '\p{^Is_Scx=tibt}', "");
    Expect(1, 4059, '\P{Is_Scx=tibt}', "");
    Expect(0, 4059, '\P{^Is_Scx=tibt}', "");
    Expect(1, 4058, '\p{Is_Scx= -TIBT}', "");
    Expect(0, 4058, '\p{^Is_Scx= -TIBT}', "");
    Expect(0, 4058, '\P{Is_Scx= -TIBT}', "");
    Expect(1, 4058, '\P{^Is_Scx= -TIBT}', "");
    Expect(0, 4059, '\p{Is_Scx= -TIBT}', "");
    Expect(1, 4059, '\p{^Is_Scx= -TIBT}', "");
    Expect(1, 4059, '\P{Is_Scx= -TIBT}', "");
    Expect(0, 4059, '\P{^Is_Scx= -TIBT}', "");
    Error('\p{Script_Extensions: 	/a/TIRHUTA}');
    Error('\P{Script_Extensions: 	/a/TIRHUTA}');
    Expect(1, 70873, '\p{Script_Extensions=:\ATirhuta\z:}', "");;
    Expect(0, 70874, '\p{Script_Extensions=:\ATirhuta\z:}', "");;
    Expect(1, 70873, '\p{Script_Extensions=tirhuta}', "");
    Expect(0, 70873, '\p{^Script_Extensions=tirhuta}', "");
    Expect(0, 70873, '\P{Script_Extensions=tirhuta}', "");
    Expect(1, 70873, '\P{^Script_Extensions=tirhuta}', "");
    Expect(0, 70874, '\p{Script_Extensions=tirhuta}', "");
    Expect(1, 70874, '\p{^Script_Extensions=tirhuta}', "");
    Expect(1, 70874, '\P{Script_Extensions=tirhuta}', "");
    Expect(0, 70874, '\P{^Script_Extensions=tirhuta}', "");
    Expect(1, 70873, '\p{Script_Extensions=:\Atirhuta\z:}', "");;
    Expect(0, 70874, '\p{Script_Extensions=:\Atirhuta\z:}', "");;
    Expect(1, 70873, '\p{Script_Extensions=Tirhuta}', "");
    Expect(0, 70873, '\p{^Script_Extensions=Tirhuta}', "");
    Expect(0, 70873, '\P{Script_Extensions=Tirhuta}', "");
    Expect(1, 70873, '\P{^Script_Extensions=Tirhuta}', "");
    Expect(0, 70874, '\p{Script_Extensions=Tirhuta}', "");
    Expect(1, 70874, '\p{^Script_Extensions=Tirhuta}', "");
    Expect(1, 70874, '\P{Script_Extensions=Tirhuta}', "");
    Expect(0, 70874, '\P{^Script_Extensions=Tirhuta}', "");
    Error('\p{Scx: 	/a/tirh}');
    Error('\P{Scx: 	/a/tirh}');
    Expect(1, 70873, '\p{Scx=:\ATirh\z:}', "");;
    Expect(0, 70874, '\p{Scx=:\ATirh\z:}', "");;
    Expect(1, 70873, '\p{Scx=tirh}', "");
    Expect(0, 70873, '\p{^Scx=tirh}', "");
    Expect(0, 70873, '\P{Scx=tirh}', "");
    Expect(1, 70873, '\P{^Scx=tirh}', "");
    Expect(0, 70874, '\p{Scx=tirh}', "");
    Expect(1, 70874, '\p{^Scx=tirh}', "");
    Expect(1, 70874, '\P{Scx=tirh}', "");
    Expect(0, 70874, '\P{^Scx=tirh}', "");
    Expect(1, 70873, '\p{Scx=:\Atirh\z:}', "");;
    Expect(0, 70874, '\p{Scx=:\Atirh\z:}', "");;
    Expect(1, 70873, '\p{Scx=  tirh}', "");
    Expect(0, 70873, '\p{^Scx=  tirh}', "");
    Expect(0, 70873, '\P{Scx=  tirh}', "");
    Expect(1, 70873, '\P{^Scx=  tirh}', "");
    Expect(0, 70874, '\p{Scx=  tirh}', "");
    Expect(1, 70874, '\p{^Scx=  tirh}', "");
    Expect(1, 70874, '\P{Scx=  tirh}', "");
    Expect(0, 70874, '\P{^Scx=  tirh}', "");
    Error('\p{Is_Script_Extensions=/a/TIRHUTA}');
    Error('\P{Is_Script_Extensions=/a/TIRHUTA}');
    Expect(1, 70873, '\p{Is_Script_Extensions=tirhuta}', "");
    Expect(0, 70873, '\p{^Is_Script_Extensions=tirhuta}', "");
    Expect(0, 70873, '\P{Is_Script_Extensions=tirhuta}', "");
    Expect(1, 70873, '\P{^Is_Script_Extensions=tirhuta}', "");
    Expect(0, 70874, '\p{Is_Script_Extensions=tirhuta}', "");
    Expect(1, 70874, '\p{^Is_Script_Extensions=tirhuta}', "");
    Expect(1, 70874, '\P{Is_Script_Extensions=tirhuta}', "");
    Expect(0, 70874, '\P{^Is_Script_Extensions=tirhuta}', "");
    Expect(1, 70873, '\p{Is_Script_Extensions= Tirhuta}', "");
    Expect(0, 70873, '\p{^Is_Script_Extensions= Tirhuta}', "");
    Expect(0, 70873, '\P{Is_Script_Extensions= Tirhuta}', "");
    Expect(1, 70873, '\P{^Is_Script_Extensions= Tirhuta}', "");
    Expect(0, 70874, '\p{Is_Script_Extensions= Tirhuta}', "");
    Expect(1, 70874, '\p{^Is_Script_Extensions= Tirhuta}', "");
    Expect(1, 70874, '\P{Is_Script_Extensions= Tirhuta}', "");
    Expect(0, 70874, '\P{^Is_Script_Extensions= Tirhuta}', "");
    Error('\p{Is_Scx=/a/__Tirh}');
    Error('\P{Is_Scx=/a/__Tirh}');
    Expect(1, 70873, '\p{Is_Scx:   tirh}', "");
    Expect(0, 70873, '\p{^Is_Scx:   tirh}', "");
    Expect(0, 70873, '\P{Is_Scx:   tirh}', "");
    Expect(1, 70873, '\P{^Is_Scx:   tirh}', "");
    Expect(0, 70874, '\p{Is_Scx:   tirh}', "");
    Expect(1, 70874, '\p{^Is_Scx:   tirh}', "");
    Expect(1, 70874, '\P{Is_Scx:   tirh}', "");
    Expect(0, 70874, '\P{^Is_Scx:   tirh}', "");
    Expect(1, 70873, '\p{Is_Scx=- TIRH}', "");
    Expect(0, 70873, '\p{^Is_Scx=- TIRH}', "");
    Expect(0, 70873, '\P{Is_Scx=- TIRH}', "");
    Expect(1, 70873, '\P{^Is_Scx=- TIRH}', "");
    Expect(0, 70874, '\p{Is_Scx=- TIRH}', "");
    Expect(1, 70874, '\p{^Is_Scx=- TIRH}', "");
    Expect(1, 70874, '\P{Is_Scx=- TIRH}', "");
    Expect(0, 70874, '\P{^Is_Scx=- TIRH}', "");
    Error('\p{Script_Extensions=/a/Ugaritic}');
    Error('\P{Script_Extensions=/a/Ugaritic}');
    Expect(1, 66463, '\p{Script_Extensions=:\AUgaritic\z:}', "");;
    Expect(0, 66464, '\p{Script_Extensions=:\AUgaritic\z:}', "");;
    Expect(1, 66463, '\p{Script_Extensions=ugaritic}', "");
    Expect(0, 66463, '\p{^Script_Extensions=ugaritic}', "");
    Expect(0, 66463, '\P{Script_Extensions=ugaritic}', "");
    Expect(1, 66463, '\P{^Script_Extensions=ugaritic}', "");
    Expect(0, 66464, '\p{Script_Extensions=ugaritic}', "");
    Expect(1, 66464, '\p{^Script_Extensions=ugaritic}', "");
    Expect(1, 66464, '\P{Script_Extensions=ugaritic}', "");
    Expect(0, 66464, '\P{^Script_Extensions=ugaritic}', "");
    Expect(1, 66463, '\p{Script_Extensions=:\Augaritic\z:}', "");;
    Expect(0, 66464, '\p{Script_Extensions=:\Augaritic\z:}', "");;
    Expect(1, 66463, '\p{Script_Extensions: __Ugaritic}', "");
    Expect(0, 66463, '\p{^Script_Extensions: __Ugaritic}', "");
    Expect(0, 66463, '\P{Script_Extensions: __Ugaritic}', "");
    Expect(1, 66463, '\P{^Script_Extensions: __Ugaritic}', "");
    Expect(0, 66464, '\p{Script_Extensions: __Ugaritic}', "");
    Expect(1, 66464, '\p{^Script_Extensions: __Ugaritic}', "");
    Expect(1, 66464, '\P{Script_Extensions: __Ugaritic}', "");
    Expect(0, 66464, '\P{^Script_Extensions: __Ugaritic}', "");
    Error('\p{Scx=/a/_Ugar}');
    Error('\P{Scx=/a/_Ugar}');
    Expect(1, 66463, '\p{Scx=:\AUgar\z:}', "");;
    Expect(0, 66464, '\p{Scx=:\AUgar\z:}', "");;
    Expect(1, 66463, '\p{Scx=ugar}', "");
    Expect(0, 66463, '\p{^Scx=ugar}', "");
    Expect(0, 66463, '\P{Scx=ugar}', "");
    Expect(1, 66463, '\P{^Scx=ugar}', "");
    Expect(0, 66464, '\p{Scx=ugar}', "");
    Expect(1, 66464, '\p{^Scx=ugar}', "");
    Expect(1, 66464, '\P{Scx=ugar}', "");
    Expect(0, 66464, '\P{^Scx=ugar}', "");
    Expect(1, 66463, '\p{Scx=:\Augar\z:}', "");;
    Expect(0, 66464, '\p{Scx=:\Augar\z:}', "");;
    Expect(1, 66463, '\p{Scx=-ugar}', "");
    Expect(0, 66463, '\p{^Scx=-ugar}', "");
    Expect(0, 66463, '\P{Scx=-ugar}', "");
    Expect(1, 66463, '\P{^Scx=-ugar}', "");
    Expect(0, 66464, '\p{Scx=-ugar}', "");
    Expect(1, 66464, '\p{^Scx=-ugar}', "");
    Expect(1, 66464, '\P{Scx=-ugar}', "");
    Expect(0, 66464, '\P{^Scx=-ugar}', "");
    Error('\p{Is_Script_Extensions=	:=UGARITIC}');
    Error('\P{Is_Script_Extensions=	:=UGARITIC}');
    Expect(1, 66463, '\p{Is_Script_Extensions=ugaritic}', "");
    Expect(0, 66463, '\p{^Is_Script_Extensions=ugaritic}', "");
    Expect(0, 66463, '\P{Is_Script_Extensions=ugaritic}', "");
    Expect(1, 66463, '\P{^Is_Script_Extensions=ugaritic}', "");
    Expect(0, 66464, '\p{Is_Script_Extensions=ugaritic}', "");
    Expect(1, 66464, '\p{^Is_Script_Extensions=ugaritic}', "");
    Expect(1, 66464, '\P{Is_Script_Extensions=ugaritic}', "");
    Expect(0, 66464, '\P{^Is_Script_Extensions=ugaritic}', "");
    Expect(1, 66463, '\p{Is_Script_Extensions=		Ugaritic}', "");
    Expect(0, 66463, '\p{^Is_Script_Extensions=		Ugaritic}', "");
    Expect(0, 66463, '\P{Is_Script_Extensions=		Ugaritic}', "");
    Expect(1, 66463, '\P{^Is_Script_Extensions=		Ugaritic}', "");
    Expect(0, 66464, '\p{Is_Script_Extensions=		Ugaritic}', "");
    Expect(1, 66464, '\p{^Is_Script_Extensions=		Ugaritic}', "");
    Expect(1, 66464, '\P{Is_Script_Extensions=		Ugaritic}', "");
    Expect(0, 66464, '\P{^Is_Script_Extensions=		Ugaritic}', "");
    Error('\p{Is_Scx=/a/-	Ugar}');
    Error('\P{Is_Scx=/a/-	Ugar}');
    Expect(1, 66463, '\p{Is_Scx: ugar}', "");
    Expect(0, 66463, '\p{^Is_Scx: ugar}', "");
    Expect(0, 66463, '\P{Is_Scx: ugar}', "");
    Expect(1, 66463, '\P{^Is_Scx: ugar}', "");
    Expect(0, 66464, '\p{Is_Scx: ugar}', "");
    Expect(1, 66464, '\p{^Is_Scx: ugar}', "");
    Expect(1, 66464, '\P{Is_Scx: ugar}', "");
    Expect(0, 66464, '\P{^Is_Scx: ugar}', "");
    Expect(1, 66463, '\p{Is_Scx= _Ugar}', "");
    Expect(0, 66463, '\p{^Is_Scx= _Ugar}', "");
    Expect(0, 66463, '\P{Is_Scx= _Ugar}', "");
    Expect(1, 66463, '\P{^Is_Scx= _Ugar}', "");
    Expect(0, 66464, '\p{Is_Scx= _Ugar}', "");
    Expect(1, 66464, '\p{^Is_Scx= _Ugar}', "");
    Expect(1, 66464, '\P{Is_Scx= _Ugar}', "");
    Expect(0, 66464, '\P{^Is_Scx= _Ugar}', "");
    Error('\p{Script_Extensions=-:=Vai}');
    Error('\P{Script_Extensions=-:=Vai}');
    Expect(1, 42539, '\p{Script_Extensions=:\AVai\z:}', "");;
    Expect(0, 42540, '\p{Script_Extensions=:\AVai\z:}', "");;
    Expect(1, 42539, '\p{Script_Extensions=vai}', "");
    Expect(0, 42539, '\p{^Script_Extensions=vai}', "");
    Expect(0, 42539, '\P{Script_Extensions=vai}', "");
    Expect(1, 42539, '\P{^Script_Extensions=vai}', "");
    Expect(0, 42540, '\p{Script_Extensions=vai}', "");
    Expect(1, 42540, '\p{^Script_Extensions=vai}', "");
    Expect(1, 42540, '\P{Script_Extensions=vai}', "");
    Expect(0, 42540, '\P{^Script_Extensions=vai}', "");
    Expect(1, 42539, '\p{Script_Extensions=:\Avai\z:}', "");;
    Expect(0, 42540, '\p{Script_Extensions=:\Avai\z:}', "");;
    Expect(1, 42539, '\p{Script_Extensions=- VAI}', "");
    Expect(0, 42539, '\p{^Script_Extensions=- VAI}', "");
    Expect(0, 42539, '\P{Script_Extensions=- VAI}', "");
    Expect(1, 42539, '\P{^Script_Extensions=- VAI}', "");
    Expect(0, 42540, '\p{Script_Extensions=- VAI}', "");
    Expect(1, 42540, '\p{^Script_Extensions=- VAI}', "");
    Expect(1, 42540, '\P{Script_Extensions=- VAI}', "");
    Expect(0, 42540, '\P{^Script_Extensions=- VAI}', "");
    Error('\p{Scx= Vaii/a/}');
    Error('\P{Scx= Vaii/a/}');
    Expect(1, 42539, '\p{Scx=:\AVaii\z:}', "");;
    Expect(0, 42540, '\p{Scx=:\AVaii\z:}', "");;
    Expect(1, 42539, '\p{Scx=vaii}', "");
    Expect(0, 42539, '\p{^Scx=vaii}', "");
    Expect(0, 42539, '\P{Scx=vaii}', "");
    Expect(1, 42539, '\P{^Scx=vaii}', "");
    Expect(0, 42540, '\p{Scx=vaii}', "");
    Expect(1, 42540, '\p{^Scx=vaii}', "");
    Expect(1, 42540, '\P{Scx=vaii}', "");
    Expect(0, 42540, '\P{^Scx=vaii}', "");
    Expect(1, 42539, '\p{Scx=:\Avaii\z:}', "");;
    Expect(0, 42540, '\p{Scx=:\Avaii\z:}', "");;
    Expect(1, 42539, '\p{Scx: 	_Vaii}', "");
    Expect(0, 42539, '\p{^Scx: 	_Vaii}', "");
    Expect(0, 42539, '\P{Scx: 	_Vaii}', "");
    Expect(1, 42539, '\P{^Scx: 	_Vaii}', "");
    Expect(0, 42540, '\p{Scx: 	_Vaii}', "");
    Expect(1, 42540, '\p{^Scx: 	_Vaii}', "");
    Expect(1, 42540, '\P{Scx: 	_Vaii}', "");
    Expect(0, 42540, '\P{^Scx: 	_Vaii}', "");
    Error('\p{Is_Script_Extensions=	:=Vai}');
    Error('\P{Is_Script_Extensions=	:=Vai}');
    Expect(1, 42539, '\p{Is_Script_Extensions=vai}', "");
    Expect(0, 42539, '\p{^Is_Script_Extensions=vai}', "");
    Expect(0, 42539, '\P{Is_Script_Extensions=vai}', "");
    Expect(1, 42539, '\P{^Is_Script_Extensions=vai}', "");
    Expect(0, 42540, '\p{Is_Script_Extensions=vai}', "");
    Expect(1, 42540, '\p{^Is_Script_Extensions=vai}', "");
    Expect(1, 42540, '\P{Is_Script_Extensions=vai}', "");
    Expect(0, 42540, '\P{^Is_Script_Extensions=vai}', "");
    Expect(1, 42539, '\p{Is_Script_Extensions=__Vai}', "");
    Expect(0, 42539, '\p{^Is_Script_Extensions=__Vai}', "");
    Expect(0, 42539, '\P{Is_Script_Extensions=__Vai}', "");
    Expect(1, 42539, '\P{^Is_Script_Extensions=__Vai}', "");
    Expect(0, 42540, '\p{Is_Script_Extensions=__Vai}', "");
    Expect(1, 42540, '\p{^Is_Script_Extensions=__Vai}', "");
    Expect(1, 42540, '\P{Is_Script_Extensions=__Vai}', "");
    Expect(0, 42540, '\P{^Is_Script_Extensions=__Vai}', "");
    Error('\p{Is_Scx=:=_Vaii}');
    Error('\P{Is_Scx=:=_Vaii}');
    Expect(1, 42539, '\p{Is_Scx=vaii}', "");
    Expect(0, 42539, '\p{^Is_Scx=vaii}', "");
    Expect(0, 42539, '\P{Is_Scx=vaii}', "");
    Expect(1, 42539, '\P{^Is_Scx=vaii}', "");
    Expect(0, 42540, '\p{Is_Scx=vaii}', "");
    Expect(1, 42540, '\p{^Is_Scx=vaii}', "");
    Expect(1, 42540, '\P{Is_Scx=vaii}', "");
    Expect(0, 42540, '\P{^Is_Scx=vaii}', "");
    Expect(1, 42539, '\p{Is_Scx=	-VAII}', "");
    Expect(0, 42539, '\p{^Is_Scx=	-VAII}', "");
    Expect(0, 42539, '\P{Is_Scx=	-VAII}', "");
    Expect(1, 42539, '\P{^Is_Scx=	-VAII}', "");
    Expect(0, 42540, '\p{Is_Scx=	-VAII}', "");
    Expect(1, 42540, '\p{^Is_Scx=	-VAII}', "");
    Expect(1, 42540, '\P{Is_Scx=	-VAII}', "");
    Expect(0, 42540, '\P{^Is_Scx=	-VAII}', "");
    Error('\p{Script_Extensions=:=- warang_Citi}');
    Error('\P{Script_Extensions=:=- warang_Citi}');
    Expect(1, 71935, '\p{Script_Extensions=:\AWarang_Citi\z:}', "");;
    Expect(0, 71936, '\p{Script_Extensions=:\AWarang_Citi\z:}', "");;
    Expect(1, 71935, '\p{Script_Extensions=warangciti}', "");
    Expect(0, 71935, '\p{^Script_Extensions=warangciti}', "");
    Expect(0, 71935, '\P{Script_Extensions=warangciti}', "");
    Expect(1, 71935, '\P{^Script_Extensions=warangciti}', "");
    Expect(0, 71936, '\p{Script_Extensions=warangciti}', "");
    Expect(1, 71936, '\p{^Script_Extensions=warangciti}', "");
    Expect(1, 71936, '\P{Script_Extensions=warangciti}', "");
    Expect(0, 71936, '\P{^Script_Extensions=warangciti}', "");
    Expect(1, 71935, '\p{Script_Extensions=:\Awarangciti\z:}', "");;
    Expect(0, 71936, '\p{Script_Extensions=:\Awarangciti\z:}', "");;
    Expect(1, 71935, '\p{Script_Extensions=	_Warang_citi}', "");
    Expect(0, 71935, '\p{^Script_Extensions=	_Warang_citi}', "");
    Expect(0, 71935, '\P{Script_Extensions=	_Warang_citi}', "");
    Expect(1, 71935, '\P{^Script_Extensions=	_Warang_citi}', "");
    Expect(0, 71936, '\p{Script_Extensions=	_Warang_citi}', "");
    Expect(1, 71936, '\p{^Script_Extensions=	_Warang_citi}', "");
    Expect(1, 71936, '\P{Script_Extensions=	_Warang_citi}', "");
    Expect(0, 71936, '\P{^Script_Extensions=	_Warang_citi}', "");
    Error('\p{Scx=_/a/Wara}');
    Error('\P{Scx=_/a/Wara}');
    Expect(1, 71935, '\p{Scx=:\AWara\z:}', "");;
    Expect(0, 71936, '\p{Scx=:\AWara\z:}', "");;
    Expect(1, 71935, '\p{Scx=wara}', "");
    Expect(0, 71935, '\p{^Scx=wara}', "");
    Expect(0, 71935, '\P{Scx=wara}', "");
    Expect(1, 71935, '\P{^Scx=wara}', "");
    Expect(0, 71936, '\p{Scx=wara}', "");
    Expect(1, 71936, '\p{^Scx=wara}', "");
    Expect(1, 71936, '\P{Scx=wara}', "");
    Expect(0, 71936, '\P{^Scx=wara}', "");
    Expect(1, 71935, '\p{Scx=:\Awara\z:}', "");;
    Expect(0, 71936, '\p{Scx=:\Awara\z:}', "");;
    Expect(1, 71935, '\p{Scx=-Wara}', "");
    Expect(0, 71935, '\p{^Scx=-Wara}', "");
    Expect(0, 71935, '\P{Scx=-Wara}', "");
    Expect(1, 71935, '\P{^Scx=-Wara}', "");
    Expect(0, 71936, '\p{Scx=-Wara}', "");
    Expect(1, 71936, '\p{^Scx=-Wara}', "");
    Expect(1, 71936, '\P{Scx=-Wara}', "");
    Expect(0, 71936, '\P{^Scx=-Wara}', "");
    Error('\p{Is_Script_Extensions:/a/- WARANG_CITI}');
    Error('\P{Is_Script_Extensions:/a/- WARANG_CITI}');
    Expect(1, 71935, '\p{Is_Script_Extensions=warangciti}', "");
    Expect(0, 71935, '\p{^Is_Script_Extensions=warangciti}', "");
    Expect(0, 71935, '\P{Is_Script_Extensions=warangciti}', "");
    Expect(1, 71935, '\P{^Is_Script_Extensions=warangciti}', "");
    Expect(0, 71936, '\p{Is_Script_Extensions=warangciti}', "");
    Expect(1, 71936, '\p{^Is_Script_Extensions=warangciti}', "");
    Expect(1, 71936, '\P{Is_Script_Extensions=warangciti}', "");
    Expect(0, 71936, '\P{^Is_Script_Extensions=warangciti}', "");
    Expect(1, 71935, '\p{Is_Script_Extensions=--Warang_CITI}', "");
    Expect(0, 71935, '\p{^Is_Script_Extensions=--Warang_CITI}', "");
    Expect(0, 71935, '\P{Is_Script_Extensions=--Warang_CITI}', "");
    Expect(1, 71935, '\P{^Is_Script_Extensions=--Warang_CITI}', "");
    Expect(0, 71936, '\p{Is_Script_Extensions=--Warang_CITI}', "");
    Expect(1, 71936, '\p{^Is_Script_Extensions=--Warang_CITI}', "");
    Expect(1, 71936, '\P{Is_Script_Extensions=--Warang_CITI}', "");
    Expect(0, 71936, '\P{^Is_Script_Extensions=--Warang_CITI}', "");
    Error('\p{Is_Scx:/a/_-Wara}');
    Error('\P{Is_Scx:/a/_-Wara}');
    Expect(1, 71935, '\p{Is_Scx=wara}', "");
    Expect(0, 71935, '\p{^Is_Scx=wara}', "");
    Expect(0, 71935, '\P{Is_Scx=wara}', "");
    Expect(1, 71935, '\P{^Is_Scx=wara}', "");
    Expect(0, 71936, '\p{Is_Scx=wara}', "");
    Expect(1, 71936, '\p{^Is_Scx=wara}', "");
    Expect(1, 71936, '\P{Is_Scx=wara}', "");
    Expect(0, 71936, '\P{^Is_Scx=wara}', "");
    Expect(1, 71935, '\p{Is_Scx=_ wara}', "");
    Expect(0, 71935, '\p{^Is_Scx=_ wara}', "");
    Expect(0, 71935, '\P{Is_Scx=_ wara}', "");
    Expect(1, 71935, '\P{^Is_Scx=_ wara}', "");
    Expect(0, 71936, '\p{Is_Scx=_ wara}', "");
    Expect(1, 71936, '\p{^Is_Scx=_ wara}', "");
    Expect(1, 71936, '\P{Is_Scx=_ wara}', "");
    Expect(0, 71936, '\P{^Is_Scx=_ wara}', "");
    Error('\p{Script_Extensions=wancho:=}');
    Error('\P{Script_Extensions=wancho:=}');
    Expect(1, 123647, '\p{Script_Extensions=:\AWancho\z:}', "");;
    Expect(0, 123648, '\p{Script_Extensions=:\AWancho\z:}', "");;
    Expect(1, 123647, '\p{Script_Extensions=wancho}', "");
    Expect(0, 123647, '\p{^Script_Extensions=wancho}', "");
    Expect(0, 123647, '\P{Script_Extensions=wancho}', "");
    Expect(1, 123647, '\P{^Script_Extensions=wancho}', "");
    Expect(0, 123648, '\p{Script_Extensions=wancho}', "");
    Expect(1, 123648, '\p{^Script_Extensions=wancho}', "");
    Expect(1, 123648, '\P{Script_Extensions=wancho}', "");
    Expect(0, 123648, '\P{^Script_Extensions=wancho}', "");
    Expect(1, 123647, '\p{Script_Extensions=:\Awancho\z:}', "");;
    Expect(0, 123648, '\p{Script_Extensions=:\Awancho\z:}', "");;
    Expect(1, 123647, '\p{Script_Extensions=- wancho}', "");
    Expect(0, 123647, '\p{^Script_Extensions=- wancho}', "");
    Expect(0, 123647, '\P{Script_Extensions=- wancho}', "");
    Expect(1, 123647, '\P{^Script_Extensions=- wancho}', "");
    Expect(0, 123648, '\p{Script_Extensions=- wancho}', "");
    Expect(1, 123648, '\p{^Script_Extensions=- wancho}', "");
    Expect(1, 123648, '\P{Script_Extensions=- wancho}', "");
    Expect(0, 123648, '\P{^Script_Extensions=- wancho}', "");
    Error('\p{Scx=_/a/Wcho}');
    Error('\P{Scx=_/a/Wcho}');
    Expect(1, 123647, '\p{Scx=:\AWcho\z:}', "");;
    Expect(0, 123648, '\p{Scx=:\AWcho\z:}', "");;
    Expect(1, 123647, '\p{Scx=wcho}', "");
    Expect(0, 123647, '\p{^Scx=wcho}', "");
    Expect(0, 123647, '\P{Scx=wcho}', "");
    Expect(1, 123647, '\P{^Scx=wcho}', "");
    Expect(0, 123648, '\p{Scx=wcho}', "");
    Expect(1, 123648, '\p{^Scx=wcho}', "");
    Expect(1, 123648, '\P{Scx=wcho}', "");
    Expect(0, 123648, '\P{^Scx=wcho}', "");
    Expect(1, 123647, '\p{Scx=:\Awcho\z:}', "");;
    Expect(0, 123648, '\p{Scx=:\Awcho\z:}', "");;
    Expect(1, 123647, '\p{Scx=_WCHO}', "");
    Expect(0, 123647, '\p{^Scx=_WCHO}', "");
    Expect(0, 123647, '\P{Scx=_WCHO}', "");
    Expect(1, 123647, '\P{^Scx=_WCHO}', "");
    Expect(0, 123648, '\p{Scx=_WCHO}', "");
    Expect(1, 123648, '\p{^Scx=_WCHO}', "");
    Expect(1, 123648, '\P{Scx=_WCHO}', "");
    Expect(0, 123648, '\P{^Scx=_WCHO}', "");
    Error('\p{Is_Script_Extensions=_:=Wancho}');
    Error('\P{Is_Script_Extensions=_:=Wancho}');
    Expect(1, 123647, '\p{Is_Script_Extensions=wancho}', "");
    Expect(0, 123647, '\p{^Is_Script_Extensions=wancho}', "");
    Expect(0, 123647, '\P{Is_Script_Extensions=wancho}', "");
    Expect(1, 123647, '\P{^Is_Script_Extensions=wancho}', "");
    Expect(0, 123648, '\p{Is_Script_Extensions=wancho}', "");
    Expect(1, 123648, '\p{^Is_Script_Extensions=wancho}', "");
    Expect(1, 123648, '\P{Is_Script_Extensions=wancho}', "");
    Expect(0, 123648, '\P{^Is_Script_Extensions=wancho}', "");
    Expect(1, 123647, '\p{Is_Script_Extensions=	Wancho}', "");
    Expect(0, 123647, '\p{^Is_Script_Extensions=	Wancho}', "");
    Expect(0, 123647, '\P{Is_Script_Extensions=	Wancho}', "");
    Expect(1, 123647, '\P{^Is_Script_Extensions=	Wancho}', "");
    Expect(0, 123648, '\p{Is_Script_Extensions=	Wancho}', "");
    Expect(1, 123648, '\p{^Is_Script_Extensions=	Wancho}', "");
    Expect(1, 123648, '\P{Is_Script_Extensions=	Wancho}', "");
    Expect(0, 123648, '\P{^Is_Script_Extensions=	Wancho}', "");
    Error('\p{Is_Scx=_ Wcho/a/}');
    Error('\P{Is_Scx=_ Wcho/a/}');
    Expect(1, 123647, '\p{Is_Scx=wcho}', "");
    Expect(0, 123647, '\p{^Is_Scx=wcho}', "");
    Expect(0, 123647, '\P{Is_Scx=wcho}', "");
    Expect(1, 123647, '\P{^Is_Scx=wcho}', "");
    Expect(0, 123648, '\p{Is_Scx=wcho}', "");
    Expect(1, 123648, '\p{^Is_Scx=wcho}', "");
    Expect(1, 123648, '\P{Is_Scx=wcho}', "");
    Expect(0, 123648, '\P{^Is_Scx=wcho}', "");
    Expect(1, 123647, '\p{Is_Scx=-wcho}', "");
    Expect(0, 123647, '\p{^Is_Scx=-wcho}', "");
    Expect(0, 123647, '\P{Is_Scx=-wcho}', "");
    Expect(1, 123647, '\P{^Is_Scx=-wcho}', "");
    Expect(0, 123648, '\p{Is_Scx=-wcho}', "");
    Expect(1, 123648, '\p{^Is_Scx=-wcho}', "");
    Expect(1, 123648, '\P{Is_Scx=-wcho}', "");
    Expect(0, 123648, '\P{^Is_Scx=-wcho}', "");
    Error('\p{Script_Extensions=-:=Old_Persian}');
    Error('\P{Script_Extensions=-:=Old_Persian}');
    Expect(1, 66517, '\p{Script_Extensions=:\AOld_Persian\z:}', "");;
    Expect(0, 66518, '\p{Script_Extensions=:\AOld_Persian\z:}', "");;
    Expect(1, 66517, '\p{Script_Extensions=oldpersian}', "");
    Expect(0, 66517, '\p{^Script_Extensions=oldpersian}', "");
    Expect(0, 66517, '\P{Script_Extensions=oldpersian}', "");
    Expect(1, 66517, '\P{^Script_Extensions=oldpersian}', "");
    Expect(0, 66518, '\p{Script_Extensions=oldpersian}', "");
    Expect(1, 66518, '\p{^Script_Extensions=oldpersian}', "");
    Expect(1, 66518, '\P{Script_Extensions=oldpersian}', "");
    Expect(0, 66518, '\P{^Script_Extensions=oldpersian}', "");
    Expect(1, 66517, '\p{Script_Extensions=:\Aoldpersian\z:}', "");;
    Expect(0, 66518, '\p{Script_Extensions=:\Aoldpersian\z:}', "");;
    Expect(1, 66517, '\p{Script_Extensions=_old_Persian}', "");
    Expect(0, 66517, '\p{^Script_Extensions=_old_Persian}', "");
    Expect(0, 66517, '\P{Script_Extensions=_old_Persian}', "");
    Expect(1, 66517, '\P{^Script_Extensions=_old_Persian}', "");
    Expect(0, 66518, '\p{Script_Extensions=_old_Persian}', "");
    Expect(1, 66518, '\p{^Script_Extensions=_old_Persian}', "");
    Expect(1, 66518, '\P{Script_Extensions=_old_Persian}', "");
    Expect(0, 66518, '\P{^Script_Extensions=_old_Persian}', "");
    Error('\p{Scx=	:=xpeo}');
    Error('\P{Scx=	:=xpeo}');
    Expect(1, 66517, '\p{Scx=:\AXpeo\z:}', "");;
    Expect(0, 66518, '\p{Scx=:\AXpeo\z:}', "");;
    Expect(1, 66517, '\p{Scx=xpeo}', "");
    Expect(0, 66517, '\p{^Scx=xpeo}', "");
    Expect(0, 66517, '\P{Scx=xpeo}', "");
    Expect(1, 66517, '\P{^Scx=xpeo}', "");
    Expect(0, 66518, '\p{Scx=xpeo}', "");
    Expect(1, 66518, '\p{^Scx=xpeo}', "");
    Expect(1, 66518, '\P{Scx=xpeo}', "");
    Expect(0, 66518, '\P{^Scx=xpeo}', "");
    Expect(1, 66517, '\p{Scx=:\Axpeo\z:}', "");;
    Expect(0, 66518, '\p{Scx=:\Axpeo\z:}', "");;
    Expect(1, 66517, '\p{Scx=__XPEO}', "");
    Expect(0, 66517, '\p{^Scx=__XPEO}', "");
    Expect(0, 66517, '\P{Scx=__XPEO}', "");
    Expect(1, 66517, '\P{^Scx=__XPEO}', "");
    Expect(0, 66518, '\p{Scx=__XPEO}', "");
    Expect(1, 66518, '\p{^Scx=__XPEO}', "");
    Expect(1, 66518, '\P{Scx=__XPEO}', "");
    Expect(0, 66518, '\P{^Scx=__XPEO}', "");
    Error('\p{Is_Script_Extensions=		OLD_PERSIAN:=}');
    Error('\P{Is_Script_Extensions=		OLD_PERSIAN:=}');
    Expect(1, 66517, '\p{Is_Script_Extensions=oldpersian}', "");
    Expect(0, 66517, '\p{^Is_Script_Extensions=oldpersian}', "");
    Expect(0, 66517, '\P{Is_Script_Extensions=oldpersian}', "");
    Expect(1, 66517, '\P{^Is_Script_Extensions=oldpersian}', "");
    Expect(0, 66518, '\p{Is_Script_Extensions=oldpersian}', "");
    Expect(1, 66518, '\p{^Is_Script_Extensions=oldpersian}', "");
    Expect(1, 66518, '\P{Is_Script_Extensions=oldpersian}', "");
    Expect(0, 66518, '\P{^Is_Script_Extensions=oldpersian}', "");
    Expect(1, 66517, '\p{Is_Script_Extensions:   --Old_PERSIAN}', "");
    Expect(0, 66517, '\p{^Is_Script_Extensions:   --Old_PERSIAN}', "");
    Expect(0, 66517, '\P{Is_Script_Extensions:   --Old_PERSIAN}', "");
    Expect(1, 66517, '\P{^Is_Script_Extensions:   --Old_PERSIAN}', "");
    Expect(0, 66518, '\p{Is_Script_Extensions:   --Old_PERSIAN}', "");
    Expect(1, 66518, '\p{^Is_Script_Extensions:   --Old_PERSIAN}', "");
    Expect(1, 66518, '\P{Is_Script_Extensions:   --Old_PERSIAN}', "");
    Expect(0, 66518, '\P{^Is_Script_Extensions:   --Old_PERSIAN}', "");
    Error('\p{Is_Scx=-Xpeo:=}');
    Error('\P{Is_Scx=-Xpeo:=}');
    Expect(1, 66517, '\p{Is_Scx=xpeo}', "");
    Expect(0, 66517, '\p{^Is_Scx=xpeo}', "");
    Expect(0, 66517, '\P{Is_Scx=xpeo}', "");
    Expect(1, 66517, '\P{^Is_Scx=xpeo}', "");
    Expect(0, 66518, '\p{Is_Scx=xpeo}', "");
    Expect(1, 66518, '\p{^Is_Scx=xpeo}', "");
    Expect(1, 66518, '\P{Is_Scx=xpeo}', "");
    Expect(0, 66518, '\P{^Is_Scx=xpeo}', "");
    Expect(1, 66517, '\p{Is_Scx=-_Xpeo}', "");
    Expect(0, 66517, '\p{^Is_Scx=-_Xpeo}', "");
    Expect(0, 66517, '\P{Is_Scx=-_Xpeo}', "");
    Expect(1, 66517, '\P{^Is_Scx=-_Xpeo}', "");
    Expect(0, 66518, '\p{Is_Scx=-_Xpeo}', "");
    Expect(1, 66518, '\p{^Is_Scx=-_Xpeo}', "");
    Expect(1, 66518, '\P{Is_Scx=-_Xpeo}', "");
    Expect(0, 66518, '\P{^Is_Scx=-_Xpeo}', "");
    Error('\p{Script_Extensions=/a/ CUNEIFORM}');
    Error('\P{Script_Extensions=/a/ CUNEIFORM}');
    Expect(1, 75075, '\p{Script_Extensions=:\ACuneiform\z:}', "");;
    Expect(0, 75076, '\p{Script_Extensions=:\ACuneiform\z:}', "");;
    Expect(1, 75075, '\p{Script_Extensions=cuneiform}', "");
    Expect(0, 75075, '\p{^Script_Extensions=cuneiform}', "");
    Expect(0, 75075, '\P{Script_Extensions=cuneiform}', "");
    Expect(1, 75075, '\P{^Script_Extensions=cuneiform}', "");
    Expect(0, 75076, '\p{Script_Extensions=cuneiform}', "");
    Expect(1, 75076, '\p{^Script_Extensions=cuneiform}', "");
    Expect(1, 75076, '\P{Script_Extensions=cuneiform}', "");
    Expect(0, 75076, '\P{^Script_Extensions=cuneiform}', "");
    Expect(1, 75075, '\p{Script_Extensions=:\Acuneiform\z:}', "");;
    Expect(0, 75076, '\p{Script_Extensions=:\Acuneiform\z:}', "");;
    Expect(1, 75075, '\p{Script_Extensions=  Cuneiform}', "");
    Expect(0, 75075, '\p{^Script_Extensions=  Cuneiform}', "");
    Expect(0, 75075, '\P{Script_Extensions=  Cuneiform}', "");
    Expect(1, 75075, '\P{^Script_Extensions=  Cuneiform}', "");
    Expect(0, 75076, '\p{Script_Extensions=  Cuneiform}', "");
    Expect(1, 75076, '\p{^Script_Extensions=  Cuneiform}', "");
    Expect(1, 75076, '\P{Script_Extensions=  Cuneiform}', "");
    Expect(0, 75076, '\P{^Script_Extensions=  Cuneiform}', "");
    Error('\p{Scx=/a/--XSUX}');
    Error('\P{Scx=/a/--XSUX}');
    Expect(1, 75075, '\p{Scx=:\AXsux\z:}', "");;
    Expect(0, 75076, '\p{Scx=:\AXsux\z:}', "");;
    Expect(1, 75075, '\p{Scx=xsux}', "");
    Expect(0, 75075, '\p{^Scx=xsux}', "");
    Expect(0, 75075, '\P{Scx=xsux}', "");
    Expect(1, 75075, '\P{^Scx=xsux}', "");
    Expect(0, 75076, '\p{Scx=xsux}', "");
    Expect(1, 75076, '\p{^Scx=xsux}', "");
    Expect(1, 75076, '\P{Scx=xsux}', "");
    Expect(0, 75076, '\P{^Scx=xsux}', "");
    Expect(1, 75075, '\p{Scx=:\Axsux\z:}', "");;
    Expect(0, 75076, '\p{Scx=:\Axsux\z:}', "");;
    Expect(1, 75075, '\p{Scx: 	_xsux}', "");
    Expect(0, 75075, '\p{^Scx: 	_xsux}', "");
    Expect(0, 75075, '\P{Scx: 	_xsux}', "");
    Expect(1, 75075, '\P{^Scx: 	_xsux}', "");
    Expect(0, 75076, '\p{Scx: 	_xsux}', "");
    Expect(1, 75076, '\p{^Scx: 	_xsux}', "");
    Expect(1, 75076, '\P{Scx: 	_xsux}', "");
    Expect(0, 75076, '\P{^Scx: 	_xsux}', "");
    Error('\p{Is_Script_Extensions=:= 	cuneiform}');
    Error('\P{Is_Script_Extensions=:= 	cuneiform}');
    Expect(1, 75075, '\p{Is_Script_Extensions=cuneiform}', "");
    Expect(0, 75075, '\p{^Is_Script_Extensions=cuneiform}', "");
    Expect(0, 75075, '\P{Is_Script_Extensions=cuneiform}', "");
    Expect(1, 75075, '\P{^Is_Script_Extensions=cuneiform}', "");
    Expect(0, 75076, '\p{Is_Script_Extensions=cuneiform}', "");
    Expect(1, 75076, '\p{^Is_Script_Extensions=cuneiform}', "");
    Expect(1, 75076, '\P{Is_Script_Extensions=cuneiform}', "");
    Expect(0, 75076, '\P{^Is_Script_Extensions=cuneiform}', "");
    Expect(1, 75075, '\p{Is_Script_Extensions=-	Cuneiform}', "");
    Expect(0, 75075, '\p{^Is_Script_Extensions=-	Cuneiform}', "");
    Expect(0, 75075, '\P{Is_Script_Extensions=-	Cuneiform}', "");
    Expect(1, 75075, '\P{^Is_Script_Extensions=-	Cuneiform}', "");
    Expect(0, 75076, '\p{Is_Script_Extensions=-	Cuneiform}', "");
    Expect(1, 75076, '\p{^Is_Script_Extensions=-	Cuneiform}', "");
    Expect(1, 75076, '\P{Is_Script_Extensions=-	Cuneiform}', "");
    Expect(0, 75076, '\P{^Is_Script_Extensions=-	Cuneiform}', "");
    Error('\p{Is_Scx=-_Xsux/a/}');
    Error('\P{Is_Scx=-_Xsux/a/}');
    Expect(1, 75075, '\p{Is_Scx=xsux}', "");
    Expect(0, 75075, '\p{^Is_Scx=xsux}', "");
    Expect(0, 75075, '\P{Is_Scx=xsux}', "");
    Expect(1, 75075, '\P{^Is_Scx=xsux}', "");
    Expect(0, 75076, '\p{Is_Scx=xsux}', "");
    Expect(1, 75076, '\p{^Is_Scx=xsux}', "");
    Expect(1, 75076, '\P{Is_Scx=xsux}', "");
    Expect(0, 75076, '\P{^Is_Scx=xsux}', "");
    Expect(1, 75075, '\p{Is_Scx:   	-Xsux}', "");
    Expect(0, 75075, '\p{^Is_Scx:   	-Xsux}', "");
    Expect(0, 75075, '\P{Is_Scx:   	-Xsux}', "");
    Expect(1, 75075, '\P{^Is_Scx:   	-Xsux}', "");
    Expect(0, 75076, '\p{Is_Scx:   	-Xsux}', "");
    Expect(1, 75076, '\p{^Is_Scx:   	-Xsux}', "");
    Expect(1, 75076, '\P{Is_Scx:   	-Xsux}', "");
    Expect(0, 75076, '\P{^Is_Scx:   	-Xsux}', "");
    Error('\p{Script_Extensions=__Yi:=}');
    Error('\P{Script_Extensions=__Yi:=}');
    Expect(1, 65381, '\p{Script_Extensions=:\AYi\z:}', "");;
    Expect(0, 65382, '\p{Script_Extensions=:\AYi\z:}', "");;
    Expect(1, 65381, '\p{Script_Extensions:   yi}', "");
    Expect(0, 65381, '\p{^Script_Extensions:   yi}', "");
    Expect(0, 65381, '\P{Script_Extensions:   yi}', "");
    Expect(1, 65381, '\P{^Script_Extensions:   yi}', "");
    Expect(0, 65382, '\p{Script_Extensions:   yi}', "");
    Expect(1, 65382, '\p{^Script_Extensions:   yi}', "");
    Expect(1, 65382, '\P{Script_Extensions:   yi}', "");
    Expect(0, 65382, '\P{^Script_Extensions:   yi}', "");
    Expect(1, 65381, '\p{Script_Extensions=:\Ayi\z:}', "");;
    Expect(0, 65382, '\p{Script_Extensions=:\Ayi\z:}', "");;
    Expect(1, 65381, '\p{Script_Extensions=_YI}', "");
    Expect(0, 65381, '\p{^Script_Extensions=_YI}', "");
    Expect(0, 65381, '\P{Script_Extensions=_YI}', "");
    Expect(1, 65381, '\P{^Script_Extensions=_YI}', "");
    Expect(0, 65382, '\p{Script_Extensions=_YI}', "");
    Expect(1, 65382, '\p{^Script_Extensions=_YI}', "");
    Expect(1, 65382, '\P{Script_Extensions=_YI}', "");
    Expect(0, 65382, '\P{^Script_Extensions=_YI}', "");
    Error('\p{Scx=/a/_YIII}');
    Error('\P{Scx=/a/_YIII}');
    Expect(1, 65381, '\p{Scx=:\AYiii\z:}', "");;
    Expect(0, 65382, '\p{Scx=:\AYiii\z:}', "");;
    Expect(1, 65381, '\p{Scx=yiii}', "");
    Expect(0, 65381, '\p{^Scx=yiii}', "");
    Expect(0, 65381, '\P{Scx=yiii}', "");
    Expect(1, 65381, '\P{^Scx=yiii}', "");
    Expect(0, 65382, '\p{Scx=yiii}', "");
    Expect(1, 65382, '\p{^Scx=yiii}', "");
    Expect(1, 65382, '\P{Scx=yiii}', "");
    Expect(0, 65382, '\P{^Scx=yiii}', "");
    Expect(1, 65381, '\p{Scx=:\Ayiii\z:}', "");;
    Expect(0, 65382, '\p{Scx=:\Ayiii\z:}', "");;
    Expect(1, 65381, '\p{Scx=		Yiii}', "");
    Expect(0, 65381, '\p{^Scx=		Yiii}', "");
    Expect(0, 65381, '\P{Scx=		Yiii}', "");
    Expect(1, 65381, '\P{^Scx=		Yiii}', "");
    Expect(0, 65382, '\p{Scx=		Yiii}', "");
    Expect(1, 65382, '\p{^Scx=		Yiii}', "");
    Expect(1, 65382, '\P{Scx=		Yiii}', "");
    Expect(0, 65382, '\P{^Scx=		Yiii}', "");
    Error('\p{Is_Script_Extensions= /a/yi}');
    Error('\P{Is_Script_Extensions= /a/yi}');
    Expect(1, 65381, '\p{Is_Script_Extensions=yi}', "");
    Expect(0, 65381, '\p{^Is_Script_Extensions=yi}', "");
    Expect(0, 65381, '\P{Is_Script_Extensions=yi}', "");
    Expect(1, 65381, '\P{^Is_Script_Extensions=yi}', "");
    Expect(0, 65382, '\p{Is_Script_Extensions=yi}', "");
    Expect(1, 65382, '\p{^Is_Script_Extensions=yi}', "");
    Expect(1, 65382, '\P{Is_Script_Extensions=yi}', "");
    Expect(0, 65382, '\P{^Is_Script_Extensions=yi}', "");
    Expect(1, 65381, '\p{Is_Script_Extensions=		yi}', "");
    Expect(0, 65381, '\p{^Is_Script_Extensions=		yi}', "");
    Expect(0, 65381, '\P{Is_Script_Extensions=		yi}', "");
    Expect(1, 65381, '\P{^Is_Script_Extensions=		yi}', "");
    Expect(0, 65382, '\p{Is_Script_Extensions=		yi}', "");
    Expect(1, 65382, '\p{^Is_Script_Extensions=		yi}', "");
    Expect(1, 65382, '\P{Is_Script_Extensions=		yi}', "");
    Expect(0, 65382, '\P{^Is_Script_Extensions=		yi}', "");
    Error('\p{Is_Scx=_Yiii/a/}');
    Error('\P{Is_Scx=_Yiii/a/}');
    Expect(1, 65381, '\p{Is_Scx=yiii}', "");
    Expect(0, 65381, '\p{^Is_Scx=yiii}', "");
    Expect(0, 65381, '\P{Is_Scx=yiii}', "");
    Expect(1, 65381, '\P{^Is_Scx=yiii}', "");
    Expect(0, 65382, '\p{Is_Scx=yiii}', "");
    Expect(1, 65382, '\p{^Is_Scx=yiii}', "");
    Expect(1, 65382, '\P{Is_Scx=yiii}', "");
    Expect(0, 65382, '\P{^Is_Scx=yiii}', "");
    Expect(1, 65381, '\p{Is_Scx=	-Yiii}', "");
    Expect(0, 65381, '\p{^Is_Scx=	-Yiii}', "");
    Expect(0, 65381, '\P{Is_Scx=	-Yiii}', "");
    Expect(1, 65381, '\P{^Is_Scx=	-Yiii}', "");
    Expect(0, 65382, '\p{Is_Scx=	-Yiii}', "");
    Expect(1, 65382, '\p{^Is_Scx=	-Yiii}', "");
    Expect(1, 65382, '\P{Is_Scx=	-Yiii}', "");
    Expect(0, 65382, '\P{^Is_Scx=	-Yiii}', "");
    Error('\p{Script_Extensions=-:=ZANABAZAR_SQUARE}');
    Error('\P{Script_Extensions=-:=ZANABAZAR_SQUARE}');
    Expect(1, 72263, '\p{Script_Extensions=:\AZanabazar_Square\z:}', "");;
    Expect(0, 72264, '\p{Script_Extensions=:\AZanabazar_Square\z:}', "");;
    Expect(1, 72263, '\p{Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72263, '\p{^Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72263, '\P{Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72263, '\P{^Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72264, '\p{Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72264, '\p{^Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72264, '\P{Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72264, '\P{^Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72263, '\p{Script_Extensions=:\Azanabazarsquare\z:}', "");;
    Expect(0, 72264, '\p{Script_Extensions=:\Azanabazarsquare\z:}', "");;
    Expect(1, 72263, '\p{Script_Extensions=		zanabazar_square}', "");
    Expect(0, 72263, '\p{^Script_Extensions=		zanabazar_square}', "");
    Expect(0, 72263, '\P{Script_Extensions=		zanabazar_square}', "");
    Expect(1, 72263, '\P{^Script_Extensions=		zanabazar_square}', "");
    Expect(0, 72264, '\p{Script_Extensions=		zanabazar_square}', "");
    Expect(1, 72264, '\p{^Script_Extensions=		zanabazar_square}', "");
    Expect(1, 72264, '\P{Script_Extensions=		zanabazar_square}', "");
    Expect(0, 72264, '\P{^Script_Extensions=		zanabazar_square}', "");
    Error('\p{Scx=_zanb:=}');
    Error('\P{Scx=_zanb:=}');
    Expect(1, 72263, '\p{Scx=:\AZanb\z:}', "");;
    Expect(0, 72264, '\p{Scx=:\AZanb\z:}', "");;
    Expect(1, 72263, '\p{Scx=zanb}', "");
    Expect(0, 72263, '\p{^Scx=zanb}', "");
    Expect(0, 72263, '\P{Scx=zanb}', "");
    Expect(1, 72263, '\P{^Scx=zanb}', "");
    Expect(0, 72264, '\p{Scx=zanb}', "");
    Expect(1, 72264, '\p{^Scx=zanb}', "");
    Expect(1, 72264, '\P{Scx=zanb}', "");
    Expect(0, 72264, '\P{^Scx=zanb}', "");
    Expect(1, 72263, '\p{Scx=:\Azanb\z:}', "");;
    Expect(0, 72264, '\p{Scx=:\Azanb\z:}', "");;
    Expect(1, 72263, '\p{Scx=-Zanb}', "");
    Expect(0, 72263, '\p{^Scx=-Zanb}', "");
    Expect(0, 72263, '\P{Scx=-Zanb}', "");
    Expect(1, 72263, '\P{^Scx=-Zanb}', "");
    Expect(0, 72264, '\p{Scx=-Zanb}', "");
    Expect(1, 72264, '\p{^Scx=-Zanb}', "");
    Expect(1, 72264, '\P{Scx=-Zanb}', "");
    Expect(0, 72264, '\P{^Scx=-Zanb}', "");
    Error('\p{Is_Script_Extensions=:=Zanabazar_square}');
    Error('\P{Is_Script_Extensions=:=Zanabazar_square}');
    Expect(1, 72263, '\p{Is_Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72263, '\p{^Is_Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72263, '\P{Is_Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72263, '\P{^Is_Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72264, '\p{Is_Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72264, '\p{^Is_Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72264, '\P{Is_Script_Extensions=zanabazarsquare}', "");
    Expect(0, 72264, '\P{^Is_Script_Extensions=zanabazarsquare}', "");
    Expect(1, 72263, '\p{Is_Script_Extensions=- Zanabazar_SQUARE}', "");
    Expect(0, 72263, '\p{^Is_Script_Extensions=- Zanabazar_SQUARE}', "");
    Expect(0, 72263, '\P{Is_Script_Extensions=- Zanabazar_SQUARE}', "");
    Expect(1, 72263, '\P{^Is_Script_Extensions=- Zanabazar_SQUARE}', "");
    Expect(0, 72264, '\p{Is_Script_Extensions=- Zanabazar_SQUARE}', "");
    Expect(1, 72264, '\p{^Is_Script_Extensions=- Zanabazar_SQUARE}', "");
    Expect(1, 72264, '\P{Is_Script_Extensions=- Zanabazar_SQUARE}', "");
    Expect(0, 72264, '\P{^Is_Script_Extensions=- Zanabazar_SQUARE}', "");
    Error('\p{Is_Scx=:= -Zanb}');
    Error('\P{Is_Scx=:= -Zanb}');
    Expect(1, 72263, '\p{Is_Scx=zanb}', "");
    Expect(0, 72263, '\p{^Is_Scx=zanb}', "");
    Expect(0, 72263, '\P{Is_Scx=zanb}', "");
    Expect(1, 72263, '\P{^Is_Scx=zanb}', "");
    Expect(0, 72264, '\p{Is_Scx=zanb}', "");
    Expect(1, 72264, '\p{^Is_Scx=zanb}', "");
    Expect(1, 72264, '\P{Is_Scx=zanb}', "");
    Expect(0, 72264, '\P{^Is_Scx=zanb}', "");
    Expect(1, 72263, '\p{Is_Scx=-ZANB}', "");
    Expect(0, 72263, '\p{^Is_Scx=-ZANB}', "");
    Expect(0, 72263, '\P{Is_Scx=-ZANB}', "");
    Expect(1, 72263, '\P{^Is_Scx=-ZANB}', "");
    Expect(0, 72264, '\p{Is_Scx=-ZANB}', "");
    Expect(1, 72264, '\p{^Is_Scx=-ZANB}', "");
    Expect(1, 72264, '\P{Is_Scx=-ZANB}', "");
    Expect(0, 72264, '\P{^Is_Scx=-ZANB}', "");
    Error('\p{Script_Extensions=-:=INHERITED}');
    Error('\P{Script_Extensions=-:=INHERITED}');
    Expect(1, 917999, '\p{Script_Extensions=:\AInherited\z:}', "");;
    Expect(0, 918000, '\p{Script_Extensions=:\AInherited\z:}', "");;
    Expect(1, 917999, '\p{Script_Extensions=inherited}', "");
    Expect(0, 917999, '\p{^Script_Extensions=inherited}', "");
    Expect(0, 917999, '\P{Script_Extensions=inherited}', "");
    Expect(1, 917999, '\P{^Script_Extensions=inherited}', "");
    Expect(0, 918000, '\p{Script_Extensions=inherited}', "");
    Expect(1, 918000, '\p{^Script_Extensions=inherited}', "");
    Expect(1, 918000, '\P{Script_Extensions=inherited}', "");
    Expect(0, 918000, '\P{^Script_Extensions=inherited}', "");
    Expect(1, 917999, '\p{Script_Extensions=:\Ainherited\z:}', "");;
    Expect(0, 918000, '\p{Script_Extensions=:\Ainherited\z:}', "");;
    Expect(1, 917999, '\p{Script_Extensions= inherited}', "");
    Expect(0, 917999, '\p{^Script_Extensions= inherited}', "");
    Expect(0, 917999, '\P{Script_Extensions= inherited}', "");
    Expect(1, 917999, '\P{^Script_Extensions= inherited}', "");
    Expect(0, 918000, '\p{Script_Extensions= inherited}', "");
    Expect(1, 918000, '\p{^Script_Extensions= inherited}', "");
    Expect(1, 918000, '\P{Script_Extensions= inherited}', "");
    Expect(0, 918000, '\P{^Script_Extensions= inherited}', "");
    Error('\p{Scx=:=Zinh}');
    Error('\P{Scx=:=Zinh}');
    Expect(1, 917999, '\p{Scx=:\AZinh\z:}', "");;
    Expect(0, 918000, '\p{Scx=:\AZinh\z:}', "");;
    Expect(1, 917999, '\p{Scx: zinh}', "");
    Expect(0, 917999, '\p{^Scx: zinh}', "");
    Expect(0, 917999, '\P{Scx: zinh}', "");
    Expect(1, 917999, '\P{^Scx: zinh}', "");
    Expect(0, 918000, '\p{Scx: zinh}', "");
    Expect(1, 918000, '\p{^Scx: zinh}', "");
    Expect(1, 918000, '\P{Scx: zinh}', "");
    Expect(0, 918000, '\P{^Scx: zinh}', "");
    Expect(1, 917999, '\p{Scx=:\Azinh\z:}', "");;
    Expect(0, 918000, '\p{Scx=:\Azinh\z:}', "");;
    Expect(1, 917999, '\p{Scx=  ZINH}', "");
    Expect(0, 917999, '\p{^Scx=  ZINH}', "");
    Expect(0, 917999, '\P{Scx=  ZINH}', "");
    Expect(1, 917999, '\P{^Scx=  ZINH}', "");
    Expect(0, 918000, '\p{Scx=  ZINH}', "");
    Expect(1, 918000, '\p{^Scx=  ZINH}', "");
    Expect(1, 918000, '\P{Scx=  ZINH}', "");
    Expect(0, 918000, '\P{^Scx=  ZINH}', "");
    Error('\p{Is_Script_Extensions: /a/	_qaai}');
    Error('\P{Is_Script_Extensions: /a/	_qaai}');
    Expect(1, 917999, '\p{Is_Script_Extensions=qaai}', "");
    Expect(0, 917999, '\p{^Is_Script_Extensions=qaai}', "");
    Expect(0, 917999, '\P{Is_Script_Extensions=qaai}', "");
    Expect(1, 917999, '\P{^Is_Script_Extensions=qaai}', "");
    Expect(0, 918000, '\p{Is_Script_Extensions=qaai}', "");
    Expect(1, 918000, '\p{^Is_Script_Extensions=qaai}', "");
    Expect(1, 918000, '\P{Is_Script_Extensions=qaai}', "");
    Expect(0, 918000, '\P{^Is_Script_Extensions=qaai}', "");
    Expect(1, 917999, '\p{Is_Script_Extensions= 	Qaai}', "");
    Expect(0, 917999, '\p{^Is_Script_Extensions= 	Qaai}', "");
    Expect(0, 917999, '\P{Is_Script_Extensions= 	Qaai}', "");
    Expect(1, 917999, '\P{^Is_Script_Extensions= 	Qaai}', "");
    Expect(0, 918000, '\p{Is_Script_Extensions= 	Qaai}', "");
    Expect(1, 918000, '\p{^Is_Script_Extensions= 	Qaai}', "");
    Expect(1, 918000, '\P{Is_Script_Extensions= 	Qaai}', "");
    Expect(0, 918000, '\P{^Is_Script_Extensions= 	Qaai}', "");
    Error('\p{Is_Scx= -INHERITED/a/}');
    Error('\P{Is_Scx= -INHERITED/a/}');
    Expect(1, 917999, '\p{Is_Scx=inherited}', "");
    Expect(0, 917999, '\p{^Is_Scx=inherited}', "");
    Expect(0, 917999, '\P{Is_Scx=inherited}', "");
    Expect(1, 917999, '\P{^Is_Scx=inherited}', "");
    Expect(0, 918000, '\p{Is_Scx=inherited}', "");
    Expect(1, 918000, '\p{^Is_Scx=inherited}', "");
    Expect(1, 918000, '\P{Is_Scx=inherited}', "");
    Expect(0, 918000, '\P{^Is_Scx=inherited}', "");
    Expect(1, 917999, '\p{Is_Scx=INHERITED}', "");
    Expect(0, 917999, '\p{^Is_Scx=INHERITED}', "");
    Expect(0, 917999, '\P{Is_Scx=INHERITED}', "");
    Expect(1, 917999, '\P{^Is_Scx=INHERITED}', "");
    Expect(0, 918000, '\p{Is_Scx=INHERITED}', "");
    Expect(1, 918000, '\p{^Is_Scx=INHERITED}', "");
    Expect(1, 918000, '\P{Is_Scx=INHERITED}', "");
    Expect(0, 918000, '\P{^Is_Scx=INHERITED}', "");
    Error('\p{Script_Extensions=/a/	Common}');
    Error('\P{Script_Extensions=/a/	Common}');
    Expect(1, 917631, '\p{Script_Extensions=:\ACommon\z:}', "");;
    Expect(0, 917632, '\p{Script_Extensions=:\ACommon\z:}', "");;
    Expect(1, 917631, '\p{Script_Extensions=common}', "");
    Expect(0, 917631, '\p{^Script_Extensions=common}', "");
    Expect(0, 917631, '\P{Script_Extensions=common}', "");
    Expect(1, 917631, '\P{^Script_Extensions=common}', "");
    Expect(0, 917632, '\p{Script_Extensions=common}', "");
    Expect(1, 917632, '\p{^Script_Extensions=common}', "");
    Expect(1, 917632, '\P{Script_Extensions=common}', "");
    Expect(0, 917632, '\P{^Script_Extensions=common}', "");
    Expect(1, 917631, '\p{Script_Extensions=:\Acommon\z:}', "");;
    Expect(0, 917632, '\p{Script_Extensions=:\Acommon\z:}', "");;
    Expect(1, 917631, '\p{Script_Extensions= 	Common}', "");
    Expect(0, 917631, '\p{^Script_Extensions= 	Common}', "");
    Expect(0, 917631, '\P{Script_Extensions= 	Common}', "");
    Expect(1, 917631, '\P{^Script_Extensions= 	Common}', "");
    Expect(0, 917632, '\p{Script_Extensions= 	Common}', "");
    Expect(1, 917632, '\p{^Script_Extensions= 	Common}', "");
    Expect(1, 917632, '\P{Script_Extensions= 	Common}', "");
    Expect(0, 917632, '\P{^Script_Extensions= 	Common}', "");
    Error('\p{Scx=_/a/Zyyy}');
    Error('\P{Scx=_/a/Zyyy}');
    Expect(1, 917631, '\p{Scx=:\AZyyy\z:}', "");;
    Expect(0, 917632, '\p{Scx=:\AZyyy\z:}', "");;
    Expect(1, 917631, '\p{Scx=zyyy}', "");
    Expect(0, 917631, '\p{^Scx=zyyy}', "");
    Expect(0, 917631, '\P{Scx=zyyy}', "");
    Expect(1, 917631, '\P{^Scx=zyyy}', "");
    Expect(0, 917632, '\p{Scx=zyyy}', "");
    Expect(1, 917632, '\p{^Scx=zyyy}', "");
    Expect(1, 917632, '\P{Scx=zyyy}', "");
    Expect(0, 917632, '\P{^Scx=zyyy}', "");
    Expect(1, 917631, '\p{Scx=:\Azyyy\z:}', "");;
    Expect(0, 917632, '\p{Scx=:\Azyyy\z:}', "");;
    Expect(1, 917631, '\p{Scx:	- ZYYY}', "");
    Expect(0, 917631, '\p{^Scx:	- ZYYY}', "");
    Expect(0, 917631, '\P{Scx:	- ZYYY}', "");
    Expect(1, 917631, '\P{^Scx:	- ZYYY}', "");
    Expect(0, 917632, '\p{Scx:	- ZYYY}', "");
    Expect(1, 917632, '\p{^Scx:	- ZYYY}', "");
    Expect(1, 917632, '\P{Scx:	- ZYYY}', "");
    Expect(0, 917632, '\P{^Scx:	- ZYYY}', "");
    Error('\p{Is_Script_Extensions=/a/__Common}');
    Error('\P{Is_Script_Extensions=/a/__Common}');
    Expect(1, 917631, '\p{Is_Script_Extensions:common}', "");
    Expect(0, 917631, '\p{^Is_Script_Extensions:common}', "");
    Expect(0, 917631, '\P{Is_Script_Extensions:common}', "");
    Expect(1, 917631, '\P{^Is_Script_Extensions:common}', "");
    Expect(0, 917632, '\p{Is_Script_Extensions:common}', "");
    Expect(1, 917632, '\p{^Is_Script_Extensions:common}', "");
    Expect(1, 917632, '\P{Is_Script_Extensions:common}', "");
    Expect(0, 917632, '\P{^Is_Script_Extensions:common}', "");
    Expect(1, 917631, '\p{Is_Script_Extensions= Common}', "");
    Expect(0, 917631, '\p{^Is_Script_Extensions= Common}', "");
    Expect(0, 917631, '\P{Is_Script_Extensions= Common}', "");
    Expect(1, 917631, '\P{^Is_Script_Extensions= Common}', "");
    Expect(0, 917632, '\p{Is_Script_Extensions= Common}', "");
    Expect(1, 917632, '\p{^Is_Script_Extensions= Common}', "");
    Expect(1, 917632, '\P{Is_Script_Extensions= Common}', "");
    Expect(0, 917632, '\P{^Is_Script_Extensions= Common}', "");
    Error('\p{Is_Scx=_/a/ZYYY}');
    Error('\P{Is_Scx=_/a/ZYYY}');
    Expect(1, 917631, '\p{Is_Scx=zyyy}', "");
    Expect(0, 917631, '\p{^Is_Scx=zyyy}', "");
    Expect(0, 917631, '\P{Is_Scx=zyyy}', "");
    Expect(1, 917631, '\P{^Is_Scx=zyyy}', "");
    Expect(0, 917632, '\p{Is_Scx=zyyy}', "");
    Expect(1, 917632, '\p{^Is_Scx=zyyy}', "");
    Expect(1, 917632, '\P{Is_Scx=zyyy}', "");
    Expect(0, 917632, '\P{^Is_Scx=zyyy}', "");
    Expect(1, 917631, '\p{Is_Scx=-zyyy}', "");
    Expect(0, 917631, '\p{^Is_Scx=-zyyy}', "");
    Expect(0, 917631, '\P{Is_Scx=-zyyy}', "");
    Expect(1, 917631, '\P{^Is_Scx=-zyyy}', "");
    Expect(0, 917632, '\p{Is_Scx=-zyyy}', "");
    Expect(1, 917632, '\p{^Is_Scx=-zyyy}', "");
    Expect(1, 917632, '\P{Is_Scx=-zyyy}', "");
    Expect(0, 917632, '\P{^Is_Scx=-zyyy}', "");
    Error('\p{Script_Extensions= /a/Unknown}');
    Error('\P{Script_Extensions= /a/Unknown}');
    Expect(1, 918000, '\p{Script_Extensions=:\AUnknown\z:}', "");;
    Expect(0, 917999, '\p{Script_Extensions=:\AUnknown\z:}', "");;
    Expect(1, 918000, '\p{Script_Extensions=unknown}', "");
    Expect(0, 918000, '\p{^Script_Extensions=unknown}', "");
    Expect(0, 918000, '\P{Script_Extensions=unknown}', "");
    Expect(1, 918000, '\P{^Script_Extensions=unknown}', "");
    Expect(0, 917999, '\p{Script_Extensions=unknown}', "");
    Expect(1, 917999, '\p{^Script_Extensions=unknown}', "");
    Expect(1, 917999, '\P{Script_Extensions=unknown}', "");
    Expect(0, 917999, '\P{^Script_Extensions=unknown}', "");
    Expect(1, 918000, '\p{Script_Extensions=:\Aunknown\z:}', "");;
    Expect(0, 917999, '\p{Script_Extensions=:\Aunknown\z:}', "");;
    Expect(1, 918000, '\p{Script_Extensions=--unknown}', "");
    Expect(0, 918000, '\p{^Script_Extensions=--unknown}', "");
    Expect(0, 918000, '\P{Script_Extensions=--unknown}', "");
    Expect(1, 918000, '\P{^Script_Extensions=--unknown}', "");
    Expect(0, 917999, '\p{Script_Extensions=--unknown}', "");
    Expect(1, 917999, '\p{^Script_Extensions=--unknown}', "");
    Expect(1, 917999, '\P{Script_Extensions=--unknown}', "");
    Expect(0, 917999, '\P{^Script_Extensions=--unknown}', "");
    Error('\p{Scx: --Zzzz:=}');
    Error('\P{Scx: --Zzzz:=}');
    Expect(1, 918000, '\p{Scx=:\AZzzz\z:}', "");;
    Expect(0, 917999, '\p{Scx=:\AZzzz\z:}', "");;
    Expect(1, 918000, '\p{Scx=zzzz}', "");
    Expect(0, 918000, '\p{^Scx=zzzz}', "");
    Expect(0, 918000, '\P{Scx=zzzz}', "");
    Expect(1, 918000, '\P{^Scx=zzzz}', "");
    Expect(0, 917999, '\p{Scx=zzzz}', "");
    Expect(1, 917999, '\p{^Scx=zzzz}', "");
    Expect(1, 917999, '\P{Scx=zzzz}', "");
    Expect(0, 917999, '\P{^Scx=zzzz}', "");
    Expect(1, 918000, '\p{Scx=:\Azzzz\z:}', "");;
    Expect(0, 917999, '\p{Scx=:\Azzzz\z:}', "");;
    Expect(1, 918000, '\p{Scx:		ZZZZ}', "");
    Expect(0, 918000, '\p{^Scx:		ZZZZ}', "");
    Expect(0, 918000, '\P{Scx:		ZZZZ}', "");
    Expect(1, 918000, '\P{^Scx:		ZZZZ}', "");
    Expect(0, 917999, '\p{Scx:		ZZZZ}', "");
    Expect(1, 917999, '\p{^Scx:		ZZZZ}', "");
    Expect(1, 917999, '\P{Scx:		ZZZZ}', "");
    Expect(0, 917999, '\P{^Scx:		ZZZZ}', "");
    Error('\p{Is_Script_Extensions=:=-unknown}');
    Error('\P{Is_Script_Extensions=:=-unknown}');
    Expect(1, 918000, '\p{Is_Script_Extensions:unknown}', "");
    Expect(0, 918000, '\p{^Is_Script_Extensions:unknown}', "");
    Expect(0, 918000, '\P{Is_Script_Extensions:unknown}', "");
    Expect(1, 918000, '\P{^Is_Script_Extensions:unknown}', "");
    Expect(0, 917999, '\p{Is_Script_Extensions:unknown}', "");
    Expect(1, 917999, '\p{^Is_Script_Extensions:unknown}', "");
    Expect(1, 917999, '\P{Is_Script_Extensions:unknown}', "");
    Expect(0, 917999, '\P{^Is_Script_Extensions:unknown}', "");
    Expect(1, 918000, '\p{Is_Script_Extensions=-_Unknown}', "");
    Expect(0, 918000, '\p{^Is_Script_Extensions=-_Unknown}', "");
    Expect(0, 918000, '\P{Is_Script_Extensions=-_Unknown}', "");
    Expect(1, 918000, '\P{^Is_Script_Extensions=-_Unknown}', "");
    Expect(0, 917999, '\p{Is_Script_Extensions=-_Unknown}', "");
    Expect(1, 917999, '\p{^Is_Script_Extensions=-_Unknown}', "");
    Expect(1, 917999, '\P{Is_Script_Extensions=-_Unknown}', "");
    Expect(0, 917999, '\P{^Is_Script_Extensions=-_Unknown}', "");
    Error('\p{Is_Scx=-/a/Zzzz}');
    Error('\P{Is_Scx=-/a/Zzzz}');
    Expect(1, 918000, '\p{Is_Scx=zzzz}', "");
    Expect(0, 918000, '\p{^Is_Scx=zzzz}', "");
    Expect(0, 918000, '\P{Is_Scx=zzzz}', "");
    Expect(1, 918000, '\P{^Is_Scx=zzzz}', "");
    Expect(0, 917999, '\p{Is_Scx=zzzz}', "");
    Expect(1, 917999, '\p{^Is_Scx=zzzz}', "");
    Expect(1, 917999, '\P{Is_Scx=zzzz}', "");
    Expect(0, 917999, '\P{^Is_Scx=zzzz}', "");
    Expect(1, 918000, '\p{Is_Scx=  Zzzz}', "");
    Expect(0, 918000, '\p{^Is_Scx=  Zzzz}', "");
    Expect(0, 918000, '\P{Is_Scx=  Zzzz}', "");
    Expect(1, 918000, '\P{^Is_Scx=  Zzzz}', "");
    Expect(0, 917999, '\p{Is_Scx=  Zzzz}', "");
    Expect(1, 917999, '\p{^Is_Scx=  Zzzz}', "");
    Expect(1, 917999, '\P{Is_Scx=  Zzzz}', "");
    Expect(0, 917999, '\P{^Is_Scx=  Zzzz}', "");
    Error('\p{Soft_Dotted=	_No/a/}');
    Error('\P{Soft_Dotted=	_No/a/}');
    Expect(1, 120468, '\p{Soft_Dotted=:\ANo\z:}', "");;
    Expect(0, 120467, '\p{Soft_Dotted=:\ANo\z:}', "");;
    Expect(1, 120468, '\p{Soft_Dotted=no}', "");
    Expect(0, 120468, '\p{^Soft_Dotted=no}', "");
    Expect(0, 120468, '\P{Soft_Dotted=no}', "");
    Expect(1, 120468, '\P{^Soft_Dotted=no}', "");
    Expect(0, 120467, '\p{Soft_Dotted=no}', "");
    Expect(1, 120467, '\p{^Soft_Dotted=no}', "");
    Expect(1, 120467, '\P{Soft_Dotted=no}', "");
    Expect(0, 120467, '\P{^Soft_Dotted=no}', "");
    Expect(1, 120468, '\p{Soft_Dotted=:\Ano\z:}', "");;
    Expect(0, 120467, '\p{Soft_Dotted=:\Ano\z:}', "");;
    Expect(1, 120468, '\p{Soft_Dotted=_	No}', "");
    Expect(0, 120468, '\p{^Soft_Dotted=_	No}', "");
    Expect(0, 120468, '\P{Soft_Dotted=_	No}', "");
    Expect(1, 120468, '\P{^Soft_Dotted=_	No}', "");
    Expect(0, 120467, '\p{Soft_Dotted=_	No}', "");
    Expect(1, 120467, '\p{^Soft_Dotted=_	No}', "");
    Expect(1, 120467, '\P{Soft_Dotted=_	No}', "");
    Expect(0, 120467, '\P{^Soft_Dotted=_	No}', "");
    Error('\p{SD=_n:=}');
    Error('\P{SD=_n:=}');
    Expect(1, 120468, '\p{SD=:\AN\z:}', "");;
    Expect(0, 120467, '\p{SD=:\AN\z:}', "");;
    Expect(1, 120468, '\p{SD=n}', "");
    Expect(0, 120468, '\p{^SD=n}', "");
    Expect(0, 120468, '\P{SD=n}', "");
    Expect(1, 120468, '\P{^SD=n}', "");
    Expect(0, 120467, '\p{SD=n}', "");
    Expect(1, 120467, '\p{^SD=n}', "");
    Expect(1, 120467, '\P{SD=n}', "");
    Expect(0, 120467, '\P{^SD=n}', "");
    Expect(1, 120468, '\p{SD=:\An\z:}', "");;
    Expect(0, 120467, '\p{SD=:\An\z:}', "");;
    Expect(1, 120468, '\p{SD= -N}', "");
    Expect(0, 120468, '\p{^SD= -N}', "");
    Expect(0, 120468, '\P{SD= -N}', "");
    Expect(1, 120468, '\P{^SD= -N}', "");
    Expect(0, 120467, '\p{SD= -N}', "");
    Expect(1, 120467, '\p{^SD= -N}', "");
    Expect(1, 120467, '\P{SD= -N}', "");
    Expect(0, 120467, '\P{^SD= -N}', "");
    Error('\p{Is_Soft_Dotted=:=_	F}');
    Error('\P{Is_Soft_Dotted=:=_	F}');
    Expect(1, 120468, '\p{Is_Soft_Dotted=f}', "");
    Expect(0, 120468, '\p{^Is_Soft_Dotted=f}', "");
    Expect(0, 120468, '\P{Is_Soft_Dotted=f}', "");
    Expect(1, 120468, '\P{^Is_Soft_Dotted=f}', "");
    Expect(0, 120467, '\p{Is_Soft_Dotted=f}', "");
    Expect(1, 120467, '\p{^Is_Soft_Dotted=f}', "");
    Expect(1, 120467, '\P{Is_Soft_Dotted=f}', "");
    Expect(0, 120467, '\P{^Is_Soft_Dotted=f}', "");
    Expect(1, 120468, '\p{Is_Soft_Dotted=_-F}', "");
    Expect(0, 120468, '\p{^Is_Soft_Dotted=_-F}', "");
    Expect(0, 120468, '\P{Is_Soft_Dotted=_-F}', "");
    Expect(1, 120468, '\P{^Is_Soft_Dotted=_-F}', "");
    Expect(0, 120467, '\p{Is_Soft_Dotted=_-F}', "");
    Expect(1, 120467, '\p{^Is_Soft_Dotted=_-F}', "");
    Expect(1, 120467, '\P{Is_Soft_Dotted=_-F}', "");
    Expect(0, 120467, '\P{^Is_Soft_Dotted=_-F}', "");
    Error('\p{Is_SD:	-	FALSE/a/}');
    Error('\P{Is_SD:	-	FALSE/a/}');
    Expect(1, 120468, '\p{Is_SD=false}', "");
    Expect(0, 120468, '\p{^Is_SD=false}', "");
    Expect(0, 120468, '\P{Is_SD=false}', "");
    Expect(1, 120468, '\P{^Is_SD=false}', "");
    Expect(0, 120467, '\p{Is_SD=false}', "");
    Expect(1, 120467, '\p{^Is_SD=false}', "");
    Expect(1, 120467, '\P{Is_SD=false}', "");
    Expect(0, 120467, '\P{^Is_SD=false}', "");
    Expect(1, 120468, '\p{Is_SD=-FALSE}', "");
    Expect(0, 120468, '\p{^Is_SD=-FALSE}', "");
    Expect(0, 120468, '\P{Is_SD=-FALSE}', "");
    Expect(1, 120468, '\P{^Is_SD=-FALSE}', "");
    Expect(0, 120467, '\p{Is_SD=-FALSE}', "");
    Expect(1, 120467, '\p{^Is_SD=-FALSE}', "");
    Expect(1, 120467, '\P{Is_SD=-FALSE}', "");
    Expect(0, 120467, '\P{^Is_SD=-FALSE}', "");
    Error('\p{Soft_Dotted=-:=yes}');
    Error('\P{Soft_Dotted=-:=yes}');
    Expect(1, 120467, '\p{Soft_Dotted=:\AYes\z:}', "");;
    Expect(0, 120468, '\p{Soft_Dotted=:\AYes\z:}', "");;
    Expect(1, 120467, '\p{Soft_Dotted=yes}', "");
    Expect(0, 120467, '\p{^Soft_Dotted=yes}', "");
    Expect(0, 120467, '\P{Soft_Dotted=yes}', "");
    Expect(1, 120467, '\P{^Soft_Dotted=yes}', "");
    Expect(0, 120468, '\p{Soft_Dotted=yes}', "");
    Expect(1, 120468, '\p{^Soft_Dotted=yes}', "");
    Expect(1, 120468, '\P{Soft_Dotted=yes}', "");
    Expect(0, 120468, '\P{^Soft_Dotted=yes}', "");
    Expect(1, 120467, '\p{Soft_Dotted=:\Ayes\z:}', "");;
    Expect(0, 120468, '\p{Soft_Dotted=:\Ayes\z:}', "");;
    Expect(1, 120467, '\p{Soft_Dotted= yes}', "");
    Expect(0, 120467, '\p{^Soft_Dotted= yes}', "");
    Expect(0, 120467, '\P{Soft_Dotted= yes}', "");
    Expect(1, 120467, '\P{^Soft_Dotted= yes}', "");
    Expect(0, 120468, '\p{Soft_Dotted= yes}', "");
    Expect(1, 120468, '\p{^Soft_Dotted= yes}', "");
    Expect(1, 120468, '\P{Soft_Dotted= yes}', "");
    Expect(0, 120468, '\P{^Soft_Dotted= yes}', "");
    Error('\p{SD=_-y:=}');
    Error('\P{SD=_-y:=}');
    Expect(1, 120467, '\p{SD=:\AY\z:}', "");;
    Expect(0, 120468, '\p{SD=:\AY\z:}', "");;
    Expect(1, 120467, '\p{SD=y}', "");
    Expect(0, 120467, '\p{^SD=y}', "");
    Expect(0, 120467, '\P{SD=y}', "");
    Expect(1, 120467, '\P{^SD=y}', "");
    Expect(0, 120468, '\p{SD=y}', "");
    Expect(1, 120468, '\p{^SD=y}', "");
    Expect(1, 120468, '\P{SD=y}', "");
    Expect(0, 120468, '\P{^SD=y}', "");
    Expect(1, 120467, '\p{SD=:\Ay\z:}', "");;
    Expect(0, 120468, '\p{SD=:\Ay\z:}', "");;
    Expect(1, 120467, '\p{SD= -Y}', "");
    Expect(0, 120467, '\p{^SD= -Y}', "");
    Expect(0, 120467, '\P{SD= -Y}', "");
    Expect(1, 120467, '\P{^SD= -Y}', "");
    Expect(0, 120468, '\p{SD= -Y}', "");
    Expect(1, 120468, '\p{^SD= -Y}', "");
    Expect(1, 120468, '\P{SD= -Y}', "");
    Expect(0, 120468, '\P{^SD= -Y}', "");
    Error('\p{Is_Soft_Dotted:   /a/T}');
    Error('\P{Is_Soft_Dotted:   /a/T}');
    Expect(1, 120467, '\p{Is_Soft_Dotted=t}', "");
    Expect(0, 120467, '\p{^Is_Soft_Dotted=t}', "");
    Expect(0, 120467, '\P{Is_Soft_Dotted=t}', "");
    Expect(1, 120467, '\P{^Is_Soft_Dotted=t}', "");
    Expect(0, 120468, '\p{Is_Soft_Dotted=t}', "");
    Expect(1, 120468, '\p{^Is_Soft_Dotted=t}', "");
    Expect(1, 120468, '\P{Is_Soft_Dotted=t}', "");
    Expect(0, 120468, '\P{^Is_Soft_Dotted=t}', "");
    Expect(1, 120467, '\p{Is_Soft_Dotted=-	T}', "");
    Expect(0, 120467, '\p{^Is_Soft_Dotted=-	T}', "");
    Expect(0, 120467, '\P{Is_Soft_Dotted=-	T}', "");
    Expect(1, 120467, '\P{^Is_Soft_Dotted=-	T}', "");
    Expect(0, 120468, '\p{Is_Soft_Dotted=-	T}', "");
    Expect(1, 120468, '\p{^Is_Soft_Dotted=-	T}', "");
    Expect(1, 120468, '\P{Is_Soft_Dotted=-	T}', "");
    Expect(0, 120468, '\P{^Is_Soft_Dotted=-	T}', "");
    Error('\p{Is_SD=:=__True}');
    Error('\P{Is_SD=:=__True}');
    Expect(1, 120467, '\p{Is_SD=true}', "");
    Expect(0, 120467, '\p{^Is_SD=true}', "");
    Expect(0, 120467, '\P{Is_SD=true}', "");
    Expect(1, 120467, '\P{^Is_SD=true}', "");
    Expect(0, 120468, '\p{Is_SD=true}', "");
    Expect(1, 120468, '\p{^Is_SD=true}', "");
    Expect(1, 120468, '\P{Is_SD=true}', "");
    Expect(0, 120468, '\P{^Is_SD=true}', "");
    Expect(1, 120467, '\p{Is_SD:   -true}', "");
    Expect(0, 120467, '\p{^Is_SD:   -true}', "");
    Expect(0, 120467, '\P{Is_SD:   -true}', "");
    Expect(1, 120467, '\P{^Is_SD:   -true}', "");
    Expect(0, 120468, '\p{Is_SD:   -true}', "");
    Expect(1, 120468, '\p{^Is_SD:   -true}', "");
    Expect(1, 120468, '\P{Is_SD:   -true}', "");
    Expect(0, 120468, '\P{^Is_SD:   -true}', "");
    Error('\p{simplelowercasemapping}');
    Error('\P{simplelowercasemapping}');
    Error('\p{slc}');
    Error('\P{slc}');
    Error('\p{simpletitlecasemapping}');
    Error('\P{simpletitlecasemapping}');
    Error('\p{stc}');
    Error('\P{stc}');
    Error('\p{Sentence_Terminal=:=	 NO}');
    Error('\P{Sentence_Terminal=:=	 NO}');
    Expect(1, 121481, '\p{Sentence_Terminal=:\ANo\z:}', "");;
    Expect(0, 121480, '\p{Sentence_Terminal=:\ANo\z:}', "");;
    Expect(1, 121481, '\p{Sentence_Terminal=no}', "");
    Expect(0, 121481, '\p{^Sentence_Terminal=no}', "");
    Expect(0, 121481, '\P{Sentence_Terminal=no}', "");
    Expect(1, 121481, '\P{^Sentence_Terminal=no}', "");
    Expect(0, 121480, '\p{Sentence_Terminal=no}', "");
    Expect(1, 121480, '\p{^Sentence_Terminal=no}', "");
    Expect(1, 121480, '\P{Sentence_Terminal=no}', "");
    Expect(0, 121480, '\P{^Sentence_Terminal=no}', "");
    Expect(1, 121481, '\p{Sentence_Terminal=:\Ano\z:}', "");;
    Expect(0, 121480, '\p{Sentence_Terminal=:\Ano\z:}', "");;
    Expect(1, 121481, '\p{Sentence_Terminal=--No}', "");
    Expect(0, 121481, '\p{^Sentence_Terminal=--No}', "");
    Expect(0, 121481, '\P{Sentence_Terminal=--No}', "");
    Expect(1, 121481, '\P{^Sentence_Terminal=--No}', "");
    Expect(0, 121480, '\p{Sentence_Terminal=--No}', "");
    Expect(1, 121480, '\p{^Sentence_Terminal=--No}', "");
    Expect(1, 121480, '\P{Sentence_Terminal=--No}', "");
    Expect(0, 121480, '\P{^Sentence_Terminal=--No}', "");
    Error('\p{STerm=:= 	n}');
    Error('\P{STerm=:= 	n}');
    Expect(1, 121481, '\p{STerm=:\AN\z:}', "");;
    Expect(0, 121480, '\p{STerm=:\AN\z:}', "");;
    Expect(1, 121481, '\p{STerm=n}', "");
    Expect(0, 121481, '\p{^STerm=n}', "");
    Expect(0, 121481, '\P{STerm=n}', "");
    Expect(1, 121481, '\P{^STerm=n}', "");
    Expect(0, 121480, '\p{STerm=n}', "");
    Expect(1, 121480, '\p{^STerm=n}', "");
    Expect(1, 121480, '\P{STerm=n}', "");
    Expect(0, 121480, '\P{^STerm=n}', "");
    Expect(1, 121481, '\p{STerm=:\An\z:}', "");;
    Expect(0, 121480, '\p{STerm=:\An\z:}', "");;
    Expect(1, 121481, '\p{STerm:	_N}', "");
    Expect(0, 121481, '\p{^STerm:	_N}', "");
    Expect(0, 121481, '\P{STerm:	_N}', "");
    Expect(1, 121481, '\P{^STerm:	_N}', "");
    Expect(0, 121480, '\p{STerm:	_N}', "");
    Expect(1, 121480, '\p{^STerm:	_N}', "");
    Expect(1, 121480, '\P{STerm:	_N}', "");
    Expect(0, 121480, '\P{^STerm:	_N}', "");
    Error('\p{Is_Sentence_Terminal= /a/f}');
    Error('\P{Is_Sentence_Terminal= /a/f}');
    Expect(1, 121481, '\p{Is_Sentence_Terminal=f}', "");
    Expect(0, 121481, '\p{^Is_Sentence_Terminal=f}', "");
    Expect(0, 121481, '\P{Is_Sentence_Terminal=f}', "");
    Expect(1, 121481, '\P{^Is_Sentence_Terminal=f}', "");
    Expect(0, 121480, '\p{Is_Sentence_Terminal=f}', "");
    Expect(1, 121480, '\p{^Is_Sentence_Terminal=f}', "");
    Expect(1, 121480, '\P{Is_Sentence_Terminal=f}', "");
    Expect(0, 121480, '\P{^Is_Sentence_Terminal=f}', "");
    Expect(1, 121481, '\p{Is_Sentence_Terminal=--f}', "");
    Expect(0, 121481, '\p{^Is_Sentence_Terminal=--f}', "");
    Expect(0, 121481, '\P{Is_Sentence_Terminal=--f}', "");
    Expect(1, 121481, '\P{^Is_Sentence_Terminal=--f}', "");
    Expect(0, 121480, '\p{Is_Sentence_Terminal=--f}', "");
    Expect(1, 121480, '\p{^Is_Sentence_Terminal=--f}', "");
    Expect(1, 121480, '\P{Is_Sentence_Terminal=--f}', "");
    Expect(0, 121480, '\P{^Is_Sentence_Terminal=--f}', "");
    Error('\p{Is_STerm=-False/a/}');
    Error('\P{Is_STerm=-False/a/}');
    Expect(1, 121481, '\p{Is_STerm=false}', "");
    Expect(0, 121481, '\p{^Is_STerm=false}', "");
    Expect(0, 121481, '\P{Is_STerm=false}', "");
    Expect(1, 121481, '\P{^Is_STerm=false}', "");
    Expect(0, 121480, '\p{Is_STerm=false}', "");
    Expect(1, 121480, '\p{^Is_STerm=false}', "");
    Expect(1, 121480, '\P{Is_STerm=false}', "");
    Expect(0, 121480, '\P{^Is_STerm=false}', "");
    Expect(1, 121481, '\p{Is_STerm=_FALSE}', "");
    Expect(0, 121481, '\p{^Is_STerm=_FALSE}', "");
    Expect(0, 121481, '\P{Is_STerm=_FALSE}', "");
    Expect(1, 121481, '\P{^Is_STerm=_FALSE}', "");
    Expect(0, 121480, '\p{Is_STerm=_FALSE}', "");
    Expect(1, 121480, '\p{^Is_STerm=_FALSE}', "");
    Expect(1, 121480, '\P{Is_STerm=_FALSE}', "");
    Expect(0, 121480, '\P{^Is_STerm=_FALSE}', "");
    Error('\p{Sentence_Terminal:_:=yes}');
    Error('\P{Sentence_Terminal:_:=yes}');
    Expect(1, 121480, '\p{Sentence_Terminal=:\AYes\z:}', "");;
    Expect(0, 121481, '\p{Sentence_Terminal=:\AYes\z:}', "");;
    Expect(1, 121480, '\p{Sentence_Terminal=yes}', "");
    Expect(0, 121480, '\p{^Sentence_Terminal=yes}', "");
    Expect(0, 121480, '\P{Sentence_Terminal=yes}', "");
    Expect(1, 121480, '\P{^Sentence_Terminal=yes}', "");
    Expect(0, 121481, '\p{Sentence_Terminal=yes}', "");
    Expect(1, 121481, '\p{^Sentence_Terminal=yes}', "");
    Expect(1, 121481, '\P{Sentence_Terminal=yes}', "");
    Expect(0, 121481, '\P{^Sentence_Terminal=yes}', "");
    Expect(1, 121480, '\p{Sentence_Terminal=:\Ayes\z:}', "");;
    Expect(0, 121481, '\p{Sentence_Terminal=:\Ayes\z:}', "");;
    Expect(1, 121480, '\p{Sentence_Terminal=		yes}', "");
    Expect(0, 121480, '\p{^Sentence_Terminal=		yes}', "");
    Expect(0, 121480, '\P{Sentence_Terminal=		yes}', "");
    Expect(1, 121480, '\P{^Sentence_Terminal=		yes}', "");
    Expect(0, 121481, '\p{Sentence_Terminal=		yes}', "");
    Expect(1, 121481, '\p{^Sentence_Terminal=		yes}', "");
    Expect(1, 121481, '\P{Sentence_Terminal=		yes}', "");
    Expect(0, 121481, '\P{^Sentence_Terminal=		yes}', "");
    Error('\p{STerm=	/a/y}');
    Error('\P{STerm=	/a/y}');
    Expect(1, 121480, '\p{STerm=:\AY\z:}', "");;
    Expect(0, 121481, '\p{STerm=:\AY\z:}', "");;
    Expect(1, 121480, '\p{STerm=y}', "");
    Expect(0, 121480, '\p{^STerm=y}', "");
    Expect(0, 121480, '\P{STerm=y}', "");
    Expect(1, 121480, '\P{^STerm=y}', "");
    Expect(0, 121481, '\p{STerm=y}', "");
    Expect(1, 121481, '\p{^STerm=y}', "");
    Expect(1, 121481, '\P{STerm=y}', "");
    Expect(0, 121481, '\P{^STerm=y}', "");
    Expect(1, 121480, '\p{STerm=:\Ay\z:}', "");;
    Expect(0, 121481, '\p{STerm=:\Ay\z:}', "");;
    Expect(1, 121480, '\p{STerm=_Y}', "");
    Expect(0, 121480, '\p{^STerm=_Y}', "");
    Expect(0, 121480, '\P{STerm=_Y}', "");
    Expect(1, 121480, '\P{^STerm=_Y}', "");
    Expect(0, 121481, '\p{STerm=_Y}', "");
    Expect(1, 121481, '\p{^STerm=_Y}', "");
    Expect(1, 121481, '\P{STerm=_Y}', "");
    Expect(0, 121481, '\P{^STerm=_Y}', "");
    Error('\p{Is_Sentence_Terminal::=_	T}');
    Error('\P{Is_Sentence_Terminal::=_	T}');
    Expect(1, 121480, '\p{Is_Sentence_Terminal=t}', "");
    Expect(0, 121480, '\p{^Is_Sentence_Terminal=t}', "");
    Expect(0, 121480, '\P{Is_Sentence_Terminal=t}', "");
    Expect(1, 121480, '\P{^Is_Sentence_Terminal=t}', "");
    Expect(0, 121481, '\p{Is_Sentence_Terminal=t}', "");
    Expect(1, 121481, '\p{^Is_Sentence_Terminal=t}', "");
    Expect(1, 121481, '\P{Is_Sentence_Terminal=t}', "");
    Expect(0, 121481, '\P{^Is_Sentence_Terminal=t}', "");
    Expect(1, 121480, '\p{Is_Sentence_Terminal=- T}', "");
    Expect(0, 121480, '\p{^Is_Sentence_Terminal=- T}', "");
    Expect(0, 121480, '\P{Is_Sentence_Terminal=- T}', "");
    Expect(1, 121480, '\P{^Is_Sentence_Terminal=- T}', "");
    Expect(0, 121481, '\p{Is_Sentence_Terminal=- T}', "");
    Expect(1, 121481, '\p{^Is_Sentence_Terminal=- T}', "");
    Expect(1, 121481, '\P{Is_Sentence_Terminal=- T}', "");
    Expect(0, 121481, '\P{^Is_Sentence_Terminal=- T}', "");
    Error('\p{Is_STerm=_/a/true}');
    Error('\P{Is_STerm=_/a/true}');
    Expect(1, 121480, '\p{Is_STerm=true}', "");
    Expect(0, 121480, '\p{^Is_STerm=true}', "");
    Expect(0, 121480, '\P{Is_STerm=true}', "");
    Expect(1, 121480, '\P{^Is_STerm=true}', "");
    Expect(0, 121481, '\p{Is_STerm=true}', "");
    Expect(1, 121481, '\p{^Is_STerm=true}', "");
    Expect(1, 121481, '\P{Is_STerm=true}', "");
    Expect(0, 121481, '\P{^Is_STerm=true}', "");
    Expect(1, 121480, '\p{Is_STerm=	-TRUE}', "");
    Expect(0, 121480, '\p{^Is_STerm=	-TRUE}', "");
    Expect(0, 121480, '\P{Is_STerm=	-TRUE}', "");
    Expect(1, 121480, '\P{^Is_STerm=	-TRUE}', "");
    Expect(0, 121481, '\p{Is_STerm=	-TRUE}', "");
    Expect(1, 121481, '\p{^Is_STerm=	-TRUE}', "");
    Expect(1, 121481, '\P{Is_STerm=	-TRUE}', "");
    Expect(0, 121481, '\P{^Is_STerm=	-TRUE}', "");
    Error('\p{simpleuppercasemapping}');
    Error('\P{simpleuppercasemapping}');
    Error('\p{suc}');
    Error('\P{suc}');
    Error('\p{titlecasemapping}');
    Error('\P{titlecasemapping}');
    Error('\p{tc}');
    Error('\P{tc}');
    Error('\p{Terminal_Punctuation=--No:=}');
    Error('\P{Terminal_Punctuation=--No:=}');
    Expect(1, 121483, '\p{Terminal_Punctuation=:\ANo\z:}', "");;
    Expect(0, 121482, '\p{Terminal_Punctuation=:\ANo\z:}', "");;
    Expect(1, 121483, '\p{Terminal_Punctuation=no}', "");
    Expect(0, 121483, '\p{^Terminal_Punctuation=no}', "");
    Expect(0, 121483, '\P{Terminal_Punctuation=no}', "");
    Expect(1, 121483, '\P{^Terminal_Punctuation=no}', "");
    Expect(0, 121482, '\p{Terminal_Punctuation=no}', "");
    Expect(1, 121482, '\p{^Terminal_Punctuation=no}', "");
    Expect(1, 121482, '\P{Terminal_Punctuation=no}', "");
    Expect(0, 121482, '\P{^Terminal_Punctuation=no}', "");
    Expect(1, 121483, '\p{Terminal_Punctuation=:\Ano\z:}', "");;
    Expect(0, 121482, '\p{Terminal_Punctuation=:\Ano\z:}', "");;
    Expect(1, 121483, '\p{Terminal_Punctuation=--No}', "");
    Expect(0, 121483, '\p{^Terminal_Punctuation=--No}', "");
    Expect(0, 121483, '\P{Terminal_Punctuation=--No}', "");
    Expect(1, 121483, '\P{^Terminal_Punctuation=--No}', "");
    Expect(0, 121482, '\p{Terminal_Punctuation=--No}', "");
    Expect(1, 121482, '\p{^Terminal_Punctuation=--No}', "");
    Expect(1, 121482, '\P{Terminal_Punctuation=--No}', "");
    Expect(0, 121482, '\P{^Terminal_Punctuation=--No}', "");
    Error('\p{Term=/a/	-N}');
    Error('\P{Term=/a/	-N}');
    Expect(1, 121483, '\p{Term=:\AN\z:}', "");;
    Expect(0, 121482, '\p{Term=:\AN\z:}', "");;
    Expect(1, 121483, '\p{Term=n}', "");
    Expect(0, 121483, '\p{^Term=n}', "");
    Expect(0, 121483, '\P{Term=n}', "");
    Expect(1, 121483, '\P{^Term=n}', "");
    Expect(0, 121482, '\p{Term=n}', "");
    Expect(1, 121482, '\p{^Term=n}', "");
    Expect(1, 121482, '\P{Term=n}', "");
    Expect(0, 121482, '\P{^Term=n}', "");
    Expect(1, 121483, '\p{Term=:\An\z:}', "");;
    Expect(0, 121482, '\p{Term=:\An\z:}', "");;
    Expect(1, 121483, '\p{Term=-N}', "");
    Expect(0, 121483, '\p{^Term=-N}', "");
    Expect(0, 121483, '\P{Term=-N}', "");
    Expect(1, 121483, '\P{^Term=-N}', "");
    Expect(0, 121482, '\p{Term=-N}', "");
    Expect(1, 121482, '\p{^Term=-N}', "");
    Expect(1, 121482, '\P{Term=-N}', "");
    Expect(0, 121482, '\P{^Term=-N}', "");
    Error('\p{Is_Terminal_Punctuation=:=__F}');
    Error('\P{Is_Terminal_Punctuation=:=__F}');
    Expect(1, 121483, '\p{Is_Terminal_Punctuation=f}', "");
    Expect(0, 121483, '\p{^Is_Terminal_Punctuation=f}', "");
    Expect(0, 121483, '\P{Is_Terminal_Punctuation=f}', "");
    Expect(1, 121483, '\P{^Is_Terminal_Punctuation=f}', "");
    Expect(0, 121482, '\p{Is_Terminal_Punctuation=f}', "");
    Expect(1, 121482, '\p{^Is_Terminal_Punctuation=f}', "");
    Expect(1, 121482, '\P{Is_Terminal_Punctuation=f}', "");
    Expect(0, 121482, '\P{^Is_Terminal_Punctuation=f}', "");
    Expect(1, 121483, '\p{Is_Terminal_Punctuation:   -_F}', "");
    Expect(0, 121483, '\p{^Is_Terminal_Punctuation:   -_F}', "");
    Expect(0, 121483, '\P{Is_Terminal_Punctuation:   -_F}', "");
    Expect(1, 121483, '\P{^Is_Terminal_Punctuation:   -_F}', "");
    Expect(0, 121482, '\p{Is_Terminal_Punctuation:   -_F}', "");
    Expect(1, 121482, '\p{^Is_Terminal_Punctuation:   -_F}', "");
    Expect(1, 121482, '\P{Is_Terminal_Punctuation:   -_F}', "");
    Expect(0, 121482, '\P{^Is_Terminal_Punctuation:   -_F}', "");
    Error('\p{Is_Term=-FALSE/a/}');
    Error('\P{Is_Term=-FALSE/a/}');
    Expect(1, 121483, '\p{Is_Term=false}', "");
    Expect(0, 121483, '\p{^Is_Term=false}', "");
    Expect(0, 121483, '\P{Is_Term=false}', "");
    Expect(1, 121483, '\P{^Is_Term=false}', "");
    Expect(0, 121482, '\p{Is_Term=false}', "");
    Expect(1, 121482, '\p{^Is_Term=false}', "");
    Expect(1, 121482, '\P{Is_Term=false}', "");
    Expect(0, 121482, '\P{^Is_Term=false}', "");
    Expect(1, 121483, '\p{Is_Term= _False}', "");
    Expect(0, 121483, '\p{^Is_Term= _False}', "");
    Expect(0, 121483, '\P{Is_Term= _False}', "");
    Expect(1, 121483, '\P{^Is_Term= _False}', "");
    Expect(0, 121482, '\p{Is_Term= _False}', "");
    Expect(1, 121482, '\p{^Is_Term= _False}', "");
    Expect(1, 121482, '\P{Is_Term= _False}', "");
    Expect(0, 121482, '\P{^Is_Term= _False}', "");
    Error('\p{Terminal_Punctuation: :=_Yes}');
    Error('\P{Terminal_Punctuation: :=_Yes}');
    Expect(1, 121482, '\p{Terminal_Punctuation=:\AYes\z:}', "");;
    Expect(0, 121483, '\p{Terminal_Punctuation=:\AYes\z:}', "");;
    Expect(1, 121482, '\p{Terminal_Punctuation=yes}', "");
    Expect(0, 121482, '\p{^Terminal_Punctuation=yes}', "");
    Expect(0, 121482, '\P{Terminal_Punctuation=yes}', "");
    Expect(1, 121482, '\P{^Terminal_Punctuation=yes}', "");
    Expect(0, 121483, '\p{Terminal_Punctuation=yes}', "");
    Expect(1, 121483, '\p{^Terminal_Punctuation=yes}', "");
    Expect(1, 121483, '\P{Terminal_Punctuation=yes}', "");
    Expect(0, 121483, '\P{^Terminal_Punctuation=yes}', "");
    Expect(1, 121482, '\p{Terminal_Punctuation=:\Ayes\z:}', "");;
    Expect(0, 121483, '\p{Terminal_Punctuation=:\Ayes\z:}', "");;
    Expect(1, 121482, '\p{Terminal_Punctuation=	-yes}', "");
    Expect(0, 121482, '\p{^Terminal_Punctuation=	-yes}', "");
    Expect(0, 121482, '\P{Terminal_Punctuation=	-yes}', "");
    Expect(1, 121482, '\P{^Terminal_Punctuation=	-yes}', "");
    Expect(0, 121483, '\p{Terminal_Punctuation=	-yes}', "");
    Expect(1, 121483, '\p{^Terminal_Punctuation=	-yes}', "");
    Expect(1, 121483, '\P{Terminal_Punctuation=	-yes}', "");
    Expect(0, 121483, '\P{^Terminal_Punctuation=	-yes}', "");
    Error('\p{Term=_:=Y}');
    Error('\P{Term=_:=Y}');
    Expect(1, 121482, '\p{Term=:\AY\z:}', "");;
    Expect(0, 121483, '\p{Term=:\AY\z:}', "");;
    Expect(1, 121482, '\p{Term=y}', "");
    Expect(0, 121482, '\p{^Term=y}', "");
    Expect(0, 121482, '\P{Term=y}', "");
    Expect(1, 121482, '\P{^Term=y}', "");
    Expect(0, 121483, '\p{Term=y}', "");
    Expect(1, 121483, '\p{^Term=y}', "");
    Expect(1, 121483, '\P{Term=y}', "");
    Expect(0, 121483, '\P{^Term=y}', "");
    Expect(1, 121482, '\p{Term=:\Ay\z:}', "");;
    Expect(0, 121483, '\p{Term=:\Ay\z:}', "");;
    Expect(1, 121482, '\p{Term=	Y}', "");
    Expect(0, 121482, '\p{^Term=	Y}', "");
    Expect(0, 121482, '\P{Term=	Y}', "");
    Expect(1, 121482, '\P{^Term=	Y}', "");
    Expect(0, 121483, '\p{Term=	Y}', "");
    Expect(1, 121483, '\p{^Term=	Y}', "");
    Expect(1, 121483, '\P{Term=	Y}', "");
    Expect(0, 121483, '\P{^Term=	Y}', "");
    Error('\p{Is_Terminal_Punctuation=-T:=}');
    Error('\P{Is_Terminal_Punctuation=-T:=}');
    Expect(1, 121482, '\p{Is_Terminal_Punctuation=t}', "");
    Expect(0, 121482, '\p{^Is_Terminal_Punctuation=t}', "");
    Expect(0, 121482, '\P{Is_Terminal_Punctuation=t}', "");
    Expect(1, 121482, '\P{^Is_Terminal_Punctuation=t}', "");
    Expect(0, 121483, '\p{Is_Terminal_Punctuation=t}', "");
    Expect(1, 121483, '\p{^Is_Terminal_Punctuation=t}', "");
    Expect(1, 121483, '\P{Is_Terminal_Punctuation=t}', "");
    Expect(0, 121483, '\P{^Is_Terminal_Punctuation=t}', "");
    Expect(1, 121482, '\p{Is_Terminal_Punctuation= -T}', "");
    Expect(0, 121482, '\p{^Is_Terminal_Punctuation= -T}', "");
    Expect(0, 121482, '\P{Is_Terminal_Punctuation= -T}', "");
    Expect(1, 121482, '\P{^Is_Terminal_Punctuation= -T}', "");
    Expect(0, 121483, '\p{Is_Terminal_Punctuation= -T}', "");
    Expect(1, 121483, '\p{^Is_Terminal_Punctuation= -T}', "");
    Expect(1, 121483, '\P{Is_Terminal_Punctuation= -T}', "");
    Expect(0, 121483, '\P{^Is_Terminal_Punctuation= -T}', "");
    Error('\p{Is_Term:/a/--true}');
    Error('\P{Is_Term:/a/--true}');
    Expect(1, 121482, '\p{Is_Term=true}', "");
    Expect(0, 121482, '\p{^Is_Term=true}', "");
    Expect(0, 121482, '\P{Is_Term=true}', "");
    Expect(1, 121482, '\P{^Is_Term=true}', "");
    Expect(0, 121483, '\p{Is_Term=true}', "");
    Expect(1, 121483, '\p{^Is_Term=true}', "");
    Expect(1, 121483, '\P{Is_Term=true}', "");
    Expect(0, 121483, '\P{^Is_Term=true}', "");
    Expect(1, 121482, '\p{Is_Term=_	True}', "");
    Expect(0, 121482, '\p{^Is_Term=_	True}', "");
    Expect(0, 121482, '\P{Is_Term=_	True}', "");
    Expect(1, 121482, '\P{^Is_Term=_	True}', "");
    Expect(0, 121483, '\p{Is_Term=_	True}', "");
    Expect(1, 121483, '\p{^Is_Term=_	True}', "");
    Expect(1, 121483, '\P{Is_Term=_	True}', "");
    Expect(0, 121483, '\P{^Is_Term=_	True}', "");
    Error('\p{uppercasemapping}');
    Error('\P{uppercasemapping}');
    Error('\p{uc}');
    Error('\P{uc}');
    Error('\p{Unified_Ideograph=:=-NO}');
    Error('\P{Unified_Ideograph=:=-NO}');
    Expect(1, 191457, '\p{Unified_Ideograph=:\ANo\z:}', "");;
    Expect(0, 191456, '\p{Unified_Ideograph=:\ANo\z:}', "");;
    Expect(1, 191457, '\p{Unified_Ideograph: no}', "");
    Expect(0, 191457, '\p{^Unified_Ideograph: no}', "");
    Expect(0, 191457, '\P{Unified_Ideograph: no}', "");
    Expect(1, 191457, '\P{^Unified_Ideograph: no}', "");
    Expect(0, 191456, '\p{Unified_Ideograph: no}', "");
    Expect(1, 191456, '\p{^Unified_Ideograph: no}', "");
    Expect(1, 191456, '\P{Unified_Ideograph: no}', "");
    Expect(0, 191456, '\P{^Unified_Ideograph: no}', "");
    Expect(1, 191457, '\p{Unified_Ideograph=:\Ano\z:}', "");;
    Expect(0, 191456, '\p{Unified_Ideograph=:\Ano\z:}', "");;
    Expect(1, 191457, '\p{Unified_Ideograph=	No}', "");
    Expect(0, 191457, '\p{^Unified_Ideograph=	No}', "");
    Expect(0, 191457, '\P{Unified_Ideograph=	No}', "");
    Expect(1, 191457, '\P{^Unified_Ideograph=	No}', "");
    Expect(0, 191456, '\p{Unified_Ideograph=	No}', "");
    Expect(1, 191456, '\p{^Unified_Ideograph=	No}', "");
    Expect(1, 191456, '\P{Unified_Ideograph=	No}', "");
    Expect(0, 191456, '\P{^Unified_Ideograph=	No}', "");
    Error('\p{UIdeo:   _/a/N}');
    Error('\P{UIdeo:   _/a/N}');
    Expect(1, 191457, '\p{UIdeo=:\AN\z:}', "");;
    Expect(0, 191456, '\p{UIdeo=:\AN\z:}', "");;
    Expect(1, 191457, '\p{UIdeo=n}', "");
    Expect(0, 191457, '\p{^UIdeo=n}', "");
    Expect(0, 191457, '\P{UIdeo=n}', "");
    Expect(1, 191457, '\P{^UIdeo=n}', "");
    Expect(0, 191456, '\p{UIdeo=n}', "");
    Expect(1, 191456, '\p{^UIdeo=n}', "");
    Expect(1, 191456, '\P{UIdeo=n}', "");
    Expect(0, 191456, '\P{^UIdeo=n}', "");
    Expect(1, 191457, '\p{UIdeo=:\An\z:}', "");;
    Expect(0, 191456, '\p{UIdeo=:\An\z:}', "");;
    Expect(1, 191457, '\p{UIdeo=N}', "");
    Expect(0, 191457, '\p{^UIdeo=N}', "");
    Expect(0, 191457, '\P{UIdeo=N}', "");
    Expect(1, 191457, '\P{^UIdeo=N}', "");
    Expect(0, 191456, '\p{UIdeo=N}', "");
    Expect(1, 191456, '\p{^UIdeo=N}', "");
    Expect(1, 191456, '\P{UIdeo=N}', "");
    Expect(0, 191456, '\P{^UIdeo=N}', "");
    Error('\p{Is_Unified_Ideograph=/a/ -F}');
    Error('\P{Is_Unified_Ideograph=/a/ -F}');
    Expect(1, 191457, '\p{Is_Unified_Ideograph=f}', "");
    Expect(0, 191457, '\p{^Is_Unified_Ideograph=f}', "");
    Expect(0, 191457, '\P{Is_Unified_Ideograph=f}', "");
    Expect(1, 191457, '\P{^Is_Unified_Ideograph=f}', "");
    Expect(0, 191456, '\p{Is_Unified_Ideograph=f}', "");
    Expect(1, 191456, '\p{^Is_Unified_Ideograph=f}', "");
    Expect(1, 191456, '\P{Is_Unified_Ideograph=f}', "");
    Expect(0, 191456, '\P{^Is_Unified_Ideograph=f}', "");
    Expect(1, 191457, '\p{Is_Unified_Ideograph=-_F}', "");
    Expect(0, 191457, '\p{^Is_Unified_Ideograph=-_F}', "");
    Expect(0, 191457, '\P{Is_Unified_Ideograph=-_F}', "");
    Expect(1, 191457, '\P{^Is_Unified_Ideograph=-_F}', "");
    Expect(0, 191456, '\p{Is_Unified_Ideograph=-_F}', "");
    Expect(1, 191456, '\p{^Is_Unified_Ideograph=-_F}', "");
    Expect(1, 191456, '\P{Is_Unified_Ideograph=-_F}', "");
    Expect(0, 191456, '\P{^Is_Unified_Ideograph=-_F}', "");
    Error('\p{Is_UIdeo=_	false/a/}');
    Error('\P{Is_UIdeo=_	false/a/}');
    Expect(1, 191457, '\p{Is_UIdeo=false}', "");
    Expect(0, 191457, '\p{^Is_UIdeo=false}', "");
    Expect(0, 191457, '\P{Is_UIdeo=false}', "");
    Expect(1, 191457, '\P{^Is_UIdeo=false}', "");
    Expect(0, 191456, '\p{Is_UIdeo=false}', "");
    Expect(1, 191456, '\p{^Is_UIdeo=false}', "");
    Expect(1, 191456, '\P{Is_UIdeo=false}', "");
    Expect(0, 191456, '\P{^Is_UIdeo=false}', "");
    Expect(1, 191457, '\p{Is_UIdeo=	_False}', "");
    Expect(0, 191457, '\p{^Is_UIdeo=	_False}', "");
    Expect(0, 191457, '\P{Is_UIdeo=	_False}', "");
    Expect(1, 191457, '\P{^Is_UIdeo=	_False}', "");
    Expect(0, 191456, '\p{Is_UIdeo=	_False}', "");
    Expect(1, 191456, '\p{^Is_UIdeo=	_False}', "");
    Expect(1, 191456, '\P{Is_UIdeo=	_False}', "");
    Expect(0, 191456, '\P{^Is_UIdeo=	_False}', "");
    Error('\p{Unified_Ideograph=/a/-Yes}');
    Error('\P{Unified_Ideograph=/a/-Yes}');
    Expect(1, 191456, '\p{Unified_Ideograph=:\AYes\z:}', "");;
    Expect(0, 191457, '\p{Unified_Ideograph=:\AYes\z:}', "");;
    Expect(1, 191456, '\p{Unified_Ideograph=yes}', "");
    Expect(0, 191456, '\p{^Unified_Ideograph=yes}', "");
    Expect(0, 191456, '\P{Unified_Ideograph=yes}', "");
    Expect(1, 191456, '\P{^Unified_Ideograph=yes}', "");
    Expect(0, 191457, '\p{Unified_Ideograph=yes}', "");
    Expect(1, 191457, '\p{^Unified_Ideograph=yes}', "");
    Expect(1, 191457, '\P{Unified_Ideograph=yes}', "");
    Expect(0, 191457, '\P{^Unified_Ideograph=yes}', "");
    Expect(1, 191456, '\p{Unified_Ideograph=:\Ayes\z:}', "");;
    Expect(0, 191457, '\p{Unified_Ideograph=:\Ayes\z:}', "");;
    Expect(1, 191456, '\p{Unified_Ideograph=	yes}', "");
    Expect(0, 191456, '\p{^Unified_Ideograph=	yes}', "");
    Expect(0, 191456, '\P{Unified_Ideograph=	yes}', "");
    Expect(1, 191456, '\P{^Unified_Ideograph=	yes}', "");
    Expect(0, 191457, '\p{Unified_Ideograph=	yes}', "");
    Expect(1, 191457, '\p{^Unified_Ideograph=	yes}', "");
    Expect(1, 191457, '\P{Unified_Ideograph=	yes}', "");
    Expect(0, 191457, '\P{^Unified_Ideograph=	yes}', "");
    Error('\p{UIdeo=:=-	y}');
    Error('\P{UIdeo=:=-	y}');
    Expect(1, 191456, '\p{UIdeo=:\AY\z:}', "");;
    Expect(0, 191457, '\p{UIdeo=:\AY\z:}', "");;
    Expect(1, 191456, '\p{UIdeo=y}', "");
    Expect(0, 191456, '\p{^UIdeo=y}', "");
    Expect(0, 191456, '\P{UIdeo=y}', "");
    Expect(1, 191456, '\P{^UIdeo=y}', "");
    Expect(0, 191457, '\p{UIdeo=y}', "");
    Expect(1, 191457, '\p{^UIdeo=y}', "");
    Expect(1, 191457, '\P{UIdeo=y}', "");
    Expect(0, 191457, '\P{^UIdeo=y}', "");
    Expect(1, 191456, '\p{UIdeo=:\Ay\z:}', "");;
    Expect(0, 191457, '\p{UIdeo=:\Ay\z:}', "");;
    Expect(1, 191456, '\p{UIdeo=	 Y}', "");
    Expect(0, 191456, '\p{^UIdeo=	 Y}', "");
    Expect(0, 191456, '\P{UIdeo=	 Y}', "");
    Expect(1, 191456, '\P{^UIdeo=	 Y}', "");
    Expect(0, 191457, '\p{UIdeo=	 Y}', "");
    Expect(1, 191457, '\p{^UIdeo=	 Y}', "");
    Expect(1, 191457, '\P{UIdeo=	 Y}', "");
    Expect(0, 191457, '\P{^UIdeo=	 Y}', "");
    Error('\p{Is_Unified_Ideograph:   	t:=}');
    Error('\P{Is_Unified_Ideograph:   	t:=}');
    Expect(1, 191456, '\p{Is_Unified_Ideograph=t}', "");
    Expect(0, 191456, '\p{^Is_Unified_Ideograph=t}', "");
    Expect(0, 191456, '\P{Is_Unified_Ideograph=t}', "");
    Expect(1, 191456, '\P{^Is_Unified_Ideograph=t}', "");
    Expect(0, 191457, '\p{Is_Unified_Ideograph=t}', "");
    Expect(1, 191457, '\p{^Is_Unified_Ideograph=t}', "");
    Expect(1, 191457, '\P{Is_Unified_Ideograph=t}', "");
    Expect(0, 191457, '\P{^Is_Unified_Ideograph=t}', "");
    Expect(1, 191456, '\p{Is_Unified_Ideograph=--T}', "");
    Expect(0, 191456, '\p{^Is_Unified_Ideograph=--T}', "");
    Expect(0, 191456, '\P{Is_Unified_Ideograph=--T}', "");
    Expect(1, 191456, '\P{^Is_Unified_Ideograph=--T}', "");
    Expect(0, 191457, '\p{Is_Unified_Ideograph=--T}', "");
    Expect(1, 191457, '\p{^Is_Unified_Ideograph=--T}', "");
    Expect(1, 191457, '\P{Is_Unified_Ideograph=--T}', "");
    Expect(0, 191457, '\P{^Is_Unified_Ideograph=--T}', "");
    Error('\p{Is_UIdeo=:=-True}');
    Error('\P{Is_UIdeo=:=-True}');
    Expect(1, 191456, '\p{Is_UIdeo=true}', "");
    Expect(0, 191456, '\p{^Is_UIdeo=true}', "");
    Expect(0, 191456, '\P{Is_UIdeo=true}', "");
    Expect(1, 191456, '\P{^Is_UIdeo=true}', "");
    Expect(0, 191457, '\p{Is_UIdeo=true}', "");
    Expect(1, 191457, '\p{^Is_UIdeo=true}', "");
    Expect(1, 191457, '\P{Is_UIdeo=true}', "");
    Expect(0, 191457, '\P{^Is_UIdeo=true}', "");
    Expect(1, 191456, '\p{Is_UIdeo:	_	True}', "");
    Expect(0, 191456, '\p{^Is_UIdeo:	_	True}', "");
    Expect(0, 191456, '\P{Is_UIdeo:	_	True}', "");
    Expect(1, 191456, '\P{^Is_UIdeo:	_	True}', "");
    Expect(0, 191457, '\p{Is_UIdeo:	_	True}', "");
    Expect(1, 191457, '\p{^Is_UIdeo:	_	True}', "");
    Expect(1, 191457, '\P{Is_UIdeo:	_	True}', "");
    Expect(0, 191457, '\P{^Is_UIdeo:	_	True}', "");
    Error('\p{Uppercase=/a/	No}');
    Error('\P{Uppercase=/a/	No}');
    Expect(1, 127370, '\p{Uppercase=:\ANo\z:}', "");;
    Expect(0, 127369, '\p{Uppercase=:\ANo\z:}', "");;
    Expect(1, 127370, '\p{Uppercase=no}', "");
    Expect(0, 127370, '\p{^Uppercase=no}', "");
    Expect(0, 127370, '\P{Uppercase=no}', "");
    Expect(1, 127370, '\P{^Uppercase=no}', "");
    Expect(0, 127369, '\p{Uppercase=no}', "");
    Expect(1, 127369, '\p{^Uppercase=no}', "");
    Expect(1, 127369, '\P{Uppercase=no}', "");
    Expect(0, 127369, '\P{^Uppercase=no}', "");
    Expect(1, 127370, '\p{Uppercase=:\Ano\z:}', "");;
    Expect(0, 127369, '\p{Uppercase=:\Ano\z:}', "");;
    Expect(1, 127370, '\p{Uppercase=	 NO}', "");
    Expect(0, 127370, '\p{^Uppercase=	 NO}', "");
    Expect(0, 127370, '\P{Uppercase=	 NO}', "");
    Expect(1, 127370, '\P{^Uppercase=	 NO}', "");
    Expect(0, 127369, '\p{Uppercase=	 NO}', "");
    Expect(1, 127369, '\p{^Uppercase=	 NO}', "");
    Expect(1, 127369, '\P{Uppercase=	 NO}', "");
    Expect(0, 127369, '\P{^Uppercase=	 NO}', "");
    Error('\p{Upper:   _N:=}');
    Error('\P{Upper:   _N:=}');
    Expect(1, 127370, '\p{Upper=:\AN\z:}', "");;
    Expect(0, 127369, '\p{Upper=:\AN\z:}', "");;
    Expect(1, 127370, '\p{Upper=n}', "");
    Expect(0, 127370, '\p{^Upper=n}', "");
    Expect(0, 127370, '\P{Upper=n}', "");
    Expect(1, 127370, '\P{^Upper=n}', "");
    Expect(0, 127369, '\p{Upper=n}', "");
    Expect(1, 127369, '\p{^Upper=n}', "");
    Expect(1, 127369, '\P{Upper=n}', "");
    Expect(0, 127369, '\P{^Upper=n}', "");
    Expect(1, 127370, '\p{Upper=:\An\z:}', "");;
    Expect(0, 127369, '\p{Upper=:\An\z:}', "");;
    Expect(1, 127370, '\p{Upper=	-n}', "");
    Expect(0, 127370, '\p{^Upper=	-n}', "");
    Expect(0, 127370, '\P{Upper=	-n}', "");
    Expect(1, 127370, '\P{^Upper=	-n}', "");
    Expect(0, 127369, '\p{Upper=	-n}', "");
    Expect(1, 127369, '\p{^Upper=	-n}', "");
    Expect(1, 127369, '\P{Upper=	-n}', "");
    Expect(0, 127369, '\P{^Upper=	-n}', "");
    Error('\p{Is_Uppercase=/a/-_f}');
    Error('\P{Is_Uppercase=/a/-_f}');
    Expect(1, 127370, '\p{Is_Uppercase:	f}', "");
    Expect(0, 127370, '\p{^Is_Uppercase:	f}', "");
    Expect(0, 127370, '\P{Is_Uppercase:	f}', "");
    Expect(1, 127370, '\P{^Is_Uppercase:	f}', "");
    Expect(0, 127369, '\p{Is_Uppercase:	f}', "");
    Expect(1, 127369, '\p{^Is_Uppercase:	f}', "");
    Expect(1, 127369, '\P{Is_Uppercase:	f}', "");
    Expect(0, 127369, '\P{^Is_Uppercase:	f}', "");
    Expect(1, 127370, '\p{Is_Uppercase= F}', "");
    Expect(0, 127370, '\p{^Is_Uppercase= F}', "");
    Expect(0, 127370, '\P{Is_Uppercase= F}', "");
    Expect(1, 127370, '\P{^Is_Uppercase= F}', "");
    Expect(0, 127369, '\p{Is_Uppercase= F}', "");
    Expect(1, 127369, '\p{^Is_Uppercase= F}', "");
    Expect(1, 127369, '\P{Is_Uppercase= F}', "");
    Expect(0, 127369, '\P{^Is_Uppercase= F}', "");
    Error('\p{Is_Upper=:= False}');
    Error('\P{Is_Upper=:= False}');
    Expect(1, 127370, '\p{Is_Upper=false}', "");
    Expect(0, 127370, '\p{^Is_Upper=false}', "");
    Expect(0, 127370, '\P{Is_Upper=false}', "");
    Expect(1, 127370, '\P{^Is_Upper=false}', "");
    Expect(0, 127369, '\p{Is_Upper=false}', "");
    Expect(1, 127369, '\p{^Is_Upper=false}', "");
    Expect(1, 127369, '\P{Is_Upper=false}', "");
    Expect(0, 127369, '\P{^Is_Upper=false}', "");
    Expect(1, 127370, '\p{Is_Upper= False}', "");
    Expect(0, 127370, '\p{^Is_Upper= False}', "");
    Expect(0, 127370, '\P{Is_Upper= False}', "");
    Expect(1, 127370, '\P{^Is_Upper= False}', "");
    Expect(0, 127369, '\p{Is_Upper= False}', "");
    Expect(1, 127369, '\p{^Is_Upper= False}', "");
    Expect(1, 127369, '\P{Is_Upper= False}', "");
    Expect(0, 127369, '\P{^Is_Upper= False}', "");
    Error('\p{Uppercase=:=-Yes}');
    Error('\P{Uppercase=:=-Yes}');
    Expect(1, 127369, '\p{Uppercase=:\AYes\z:}', "");;
    Expect(0, 127370, '\p{Uppercase=:\AYes\z:}', "");;
    Expect(1, 127369, '\p{Uppercase=yes}', "");
    Expect(0, 127369, '\p{^Uppercase=yes}', "");
    Expect(0, 127369, '\P{Uppercase=yes}', "");
    Expect(1, 127369, '\P{^Uppercase=yes}', "");
    Expect(0, 127370, '\p{Uppercase=yes}', "");
    Expect(1, 127370, '\p{^Uppercase=yes}', "");
    Expect(1, 127370, '\P{Uppercase=yes}', "");
    Expect(0, 127370, '\P{^Uppercase=yes}', "");
    Expect(1, 127369, '\p{Uppercase=:\Ayes\z:}', "");;
    Expect(0, 127370, '\p{Uppercase=:\Ayes\z:}', "");;
    Expect(1, 127369, '\p{Uppercase= 	yes}', "");
    Expect(0, 127369, '\p{^Uppercase= 	yes}', "");
    Expect(0, 127369, '\P{Uppercase= 	yes}', "");
    Expect(1, 127369, '\P{^Uppercase= 	yes}', "");
    Expect(0, 127370, '\p{Uppercase= 	yes}', "");
    Expect(1, 127370, '\p{^Uppercase= 	yes}', "");
    Expect(1, 127370, '\P{Uppercase= 	yes}', "");
    Expect(0, 127370, '\P{^Uppercase= 	yes}', "");
    Error('\p{Upper=-/a/Y}');
    Error('\P{Upper=-/a/Y}');
    Expect(1, 127369, '\p{Upper=:\AY\z:}', "");;
    Expect(0, 127370, '\p{Upper=:\AY\z:}', "");;
    Expect(1, 127369, '\p{Upper=y}', "");
    Expect(0, 127369, '\p{^Upper=y}', "");
    Expect(0, 127369, '\P{Upper=y}', "");
    Expect(1, 127369, '\P{^Upper=y}', "");
    Expect(0, 127370, '\p{Upper=y}', "");
    Expect(1, 127370, '\p{^Upper=y}', "");
    Expect(1, 127370, '\P{Upper=y}', "");
    Expect(0, 127370, '\P{^Upper=y}', "");
    Expect(1, 127369, '\p{Upper=:\Ay\z:}', "");;
    Expect(0, 127370, '\p{Upper=:\Ay\z:}', "");;
    Expect(1, 127369, '\p{Upper=_Y}', "");
    Expect(0, 127369, '\p{^Upper=_Y}', "");
    Expect(0, 127369, '\P{Upper=_Y}', "");
    Expect(1, 127369, '\P{^Upper=_Y}', "");
    Expect(0, 127370, '\p{Upper=_Y}', "");
    Expect(1, 127370, '\p{^Upper=_Y}', "");
    Expect(1, 127370, '\P{Upper=_Y}', "");
    Expect(0, 127370, '\P{^Upper=_Y}', "");
    Error('\p{Is_Uppercase: _/a/T}');
    Error('\P{Is_Uppercase: _/a/T}');
    Expect(1, 127369, '\p{Is_Uppercase=t}', "");
    Expect(0, 127369, '\p{^Is_Uppercase=t}', "");
    Expect(0, 127369, '\P{Is_Uppercase=t}', "");
    Expect(1, 127369, '\P{^Is_Uppercase=t}', "");
    Expect(0, 127370, '\p{Is_Uppercase=t}', "");
    Expect(1, 127370, '\p{^Is_Uppercase=t}', "");
    Expect(1, 127370, '\P{Is_Uppercase=t}', "");
    Expect(0, 127370, '\P{^Is_Uppercase=t}', "");
    Expect(1, 127369, '\p{Is_Uppercase=_	t}', "");
    Expect(0, 127369, '\p{^Is_Uppercase=_	t}', "");
    Expect(0, 127369, '\P{Is_Uppercase=_	t}', "");
    Expect(1, 127369, '\P{^Is_Uppercase=_	t}', "");
    Expect(0, 127370, '\p{Is_Uppercase=_	t}', "");
    Expect(1, 127370, '\p{^Is_Uppercase=_	t}', "");
    Expect(1, 127370, '\P{Is_Uppercase=_	t}', "");
    Expect(0, 127370, '\P{^Is_Uppercase=_	t}', "");
    Error('\p{Is_Upper=	:=true}');
    Error('\P{Is_Upper=	:=true}');
    Expect(1, 127369, '\p{Is_Upper:true}', "");
    Expect(0, 127369, '\p{^Is_Upper:true}', "");
    Expect(0, 127369, '\P{Is_Upper:true}', "");
    Expect(1, 127369, '\P{^Is_Upper:true}', "");
    Expect(0, 127370, '\p{Is_Upper:true}', "");
    Expect(1, 127370, '\p{^Is_Upper:true}', "");
    Expect(1, 127370, '\P{Is_Upper:true}', "");
    Expect(0, 127370, '\P{^Is_Upper:true}', "");
    Expect(1, 127369, '\p{Is_Upper=-	true}', "");
    Expect(0, 127369, '\p{^Is_Upper=-	true}', "");
    Expect(0, 127369, '\P{Is_Upper=-	true}', "");
    Expect(1, 127369, '\P{^Is_Upper=-	true}', "");
    Expect(0, 127370, '\p{Is_Upper=-	true}', "");
    Expect(1, 127370, '\p{^Is_Upper=-	true}', "");
    Expect(1, 127370, '\P{Is_Upper=-	true}', "");
    Expect(0, 127370, '\P{^Is_Upper=-	true}', "");
    Error('\p{verticalorientation}');
    Error('\P{verticalorientation}');
    Error('\p{vo}');
    Error('\P{vo}');
    Error('\p{Vertical_Orientation= 	rotated/a/}');
    Error('\P{Vertical_Orientation= 	rotated/a/}');
    Expect(1, 262144, '\p{Vertical_Orientation=:\ARotated\z:}', "");;
    Expect(0, 1114109, '\p{Vertical_Orientation=:\ARotated\z:}', "");;
    Expect(1, 262144, '\p{Vertical_Orientation=rotated}', "");
    Expect(0, 262144, '\p{^Vertical_Orientation=rotated}', "");
    Expect(0, 262144, '\P{Vertical_Orientation=rotated}', "");
    Expect(1, 262144, '\P{^Vertical_Orientation=rotated}', "");
    Expect(0, 1114109, '\p{Vertical_Orientation=rotated}', "");
    Expect(1, 1114109, '\p{^Vertical_Orientation=rotated}', "");
    Expect(1, 1114109, '\P{Vertical_Orientation=rotated}', "");
    Expect(0, 1114109, '\P{^Vertical_Orientation=rotated}', "");
    Expect(1, 262144, '\p{Vertical_Orientation=:\Arotated\z:}', "");;
    Expect(0, 1114109, '\p{Vertical_Orientation=:\Arotated\z:}', "");;
    Expect(1, 262144, '\p{Vertical_Orientation:   - ROTATED}', "");
    Expect(0, 262144, '\p{^Vertical_Orientation:   - ROTATED}', "");
    Expect(0, 262144, '\P{Vertical_Orientation:   - ROTATED}', "");
    Expect(1, 262144, '\P{^Vertical_Orientation:   - ROTATED}', "");
    Expect(0, 1114109, '\p{Vertical_Orientation:   - ROTATED}', "");
    Expect(1, 1114109, '\p{^Vertical_Orientation:   - ROTATED}', "");
    Expect(1, 1114109, '\P{Vertical_Orientation:   - ROTATED}', "");
    Expect(0, 1114109, '\P{^Vertical_Orientation:   - ROTATED}', "");
    Error('\p{Vo= /a/R}');
    Error('\P{Vo= /a/R}');
    Expect(1, 262144, '\p{Vo=:\AR\z:}', "");;
    Expect(0, 1114109, '\p{Vo=:\AR\z:}', "");;
    Expect(1, 262144, '\p{Vo=r}', "");
    Expect(0, 262144, '\p{^Vo=r}', "");
    Expect(0, 262144, '\P{Vo=r}', "");
    Expect(1, 262144, '\P{^Vo=r}', "");
    Expect(0, 1114109, '\p{Vo=r}', "");
    Expect(1, 1114109, '\p{^Vo=r}', "");
    Expect(1, 1114109, '\P{Vo=r}', "");
    Expect(0, 1114109, '\P{^Vo=r}', "");
    Expect(1, 262144, '\p{Vo=:\Ar\z:}', "");;
    Expect(0, 1114109, '\p{Vo=:\Ar\z:}', "");;
    Expect(1, 262144, '\p{Vo=	-R}', "");
    Expect(0, 262144, '\p{^Vo=	-R}', "");
    Expect(0, 262144, '\P{Vo=	-R}', "");
    Expect(1, 262144, '\P{^Vo=	-R}', "");
    Expect(0, 1114109, '\p{Vo=	-R}', "");
    Expect(1, 1114109, '\p{^Vo=	-R}', "");
    Expect(1, 1114109, '\P{Vo=	-R}', "");
    Expect(0, 1114109, '\P{^Vo=	-R}', "");
    Error('\p{Is_Vertical_Orientation=/a/--rotated}');
    Error('\P{Is_Vertical_Orientation=/a/--rotated}');
    Expect(1, 262144, '\p{Is_Vertical_Orientation=rotated}', "");
    Expect(0, 262144, '\p{^Is_Vertical_Orientation=rotated}', "");
    Expect(0, 262144, '\P{Is_Vertical_Orientation=rotated}', "");
    Expect(1, 262144, '\P{^Is_Vertical_Orientation=rotated}', "");
    Expect(0, 1114109, '\p{Is_Vertical_Orientation=rotated}', "");
    Expect(1, 1114109, '\p{^Is_Vertical_Orientation=rotated}', "");
    Expect(1, 1114109, '\P{Is_Vertical_Orientation=rotated}', "");
    Expect(0, 1114109, '\P{^Is_Vertical_Orientation=rotated}', "");
    Expect(1, 262144, '\p{Is_Vertical_Orientation=-	rotated}', "");
    Expect(0, 262144, '\p{^Is_Vertical_Orientation=-	rotated}', "");
    Expect(0, 262144, '\P{Is_Vertical_Orientation=-	rotated}', "");
    Expect(1, 262144, '\P{^Is_Vertical_Orientation=-	rotated}', "");
    Expect(0, 1114109, '\p{Is_Vertical_Orientation=-	rotated}', "");
    Expect(1, 1114109, '\p{^Is_Vertical_Orientation=-	rotated}', "");
    Expect(1, 1114109, '\P{Is_Vertical_Orientation=-	rotated}', "");
    Expect(0, 1114109, '\P{^Is_Vertical_Orientation=-	rotated}', "");
    Error('\p{Is_Vo=-:=R}');
    Error('\P{Is_Vo=-:=R}');
    Expect(1, 262144, '\p{Is_Vo=r}', "");
    Expect(0, 262144, '\p{^Is_Vo=r}', "");
    Expect(0, 262144, '\P{Is_Vo=r}', "");
    Expect(1, 262144, '\P{^Is_Vo=r}', "");
    Expect(0, 1114109, '\p{Is_Vo=r}', "");
    Expect(1, 1114109, '\p{^Is_Vo=r}', "");
    Expect(1, 1114109, '\P{Is_Vo=r}', "");
    Expect(0, 1114109, '\P{^Is_Vo=r}', "");
    Expect(1, 262144, '\p{Is_Vo=-R}', "");
    Expect(0, 262144, '\p{^Is_Vo=-R}', "");
    Expect(0, 262144, '\P{Is_Vo=-R}', "");
    Expect(1, 262144, '\P{^Is_Vo=-R}', "");
    Expect(0, 1114109, '\p{Is_Vo=-R}', "");
    Expect(1, 1114109, '\p{^Is_Vo=-R}', "");
    Expect(1, 1114109, '\P{Is_Vo=-R}', "");
    Expect(0, 1114109, '\P{^Is_Vo=-R}', "");
    Error('\p{Vertical_Orientation=/a/Transformed_rotated}');
    Error('\P{Vertical_Orientation=/a/Transformed_rotated}');
    Expect(1, 65507, '\p{Vertical_Orientation=:\ATransformed_Rotated\z:}', "");;
    Expect(0, 65508, '\p{Vertical_Orientation=:\ATransformed_Rotated\z:}', "");;
    Expect(1, 65507, '\p{Vertical_Orientation: transformedrotated}', "");
    Expect(0, 65507, '\p{^Vertical_Orientation: transformedrotated}', "");
    Expect(0, 65507, '\P{Vertical_Orientation: transformedrotated}', "");
    Expect(1, 65507, '\P{^Vertical_Orientation: transformedrotated}', "");
    Expect(0, 65508, '\p{Vertical_Orientation: transformedrotated}', "");
    Expect(1, 65508, '\p{^Vertical_Orientation: transformedrotated}', "");
    Expect(1, 65508, '\P{Vertical_Orientation: transformedrotated}', "");
    Expect(0, 65508, '\P{^Vertical_Orientation: transformedrotated}', "");
    Expect(1, 65507, '\p{Vertical_Orientation=:\Atransformedrotated\z:}', "");;
    Expect(0, 65508, '\p{Vertical_Orientation=:\Atransformedrotated\z:}', "");;
    Expect(1, 65507, '\p{Vertical_Orientation=_-TRANSFORMED_rotated}', "");
    Expect(0, 65507, '\p{^Vertical_Orientation=_-TRANSFORMED_rotated}', "");
    Expect(0, 65507, '\P{Vertical_Orientation=_-TRANSFORMED_rotated}', "");
    Expect(1, 65507, '\P{^Vertical_Orientation=_-TRANSFORMED_rotated}', "");
    Expect(0, 65508, '\p{Vertical_Orientation=_-TRANSFORMED_rotated}', "");
    Expect(1, 65508, '\p{^Vertical_Orientation=_-TRANSFORMED_rotated}', "");
    Expect(1, 65508, '\P{Vertical_Orientation=_-TRANSFORMED_rotated}', "");
    Expect(0, 65508, '\P{^Vertical_Orientation=_-TRANSFORMED_rotated}', "");
    Error('\p{Vo=		tr/a/}');
    Error('\P{Vo=		tr/a/}');
    Expect(1, 65507, '\p{Vo=:\ATr\z:}', "");;
    Expect(0, 65508, '\p{Vo=:\ATr\z:}', "");;
    Expect(1, 65507, '\p{Vo:tr}', "");
    Expect(0, 65507, '\p{^Vo:tr}', "");
    Expect(0, 65507, '\P{Vo:tr}', "");
    Expect(1, 65507, '\P{^Vo:tr}', "");
    Expect(0, 65508, '\p{Vo:tr}', "");
    Expect(1, 65508, '\p{^Vo:tr}', "");
    Expect(1, 65508, '\P{Vo:tr}', "");
    Expect(0, 65508, '\P{^Vo:tr}', "");
    Expect(1, 65507, '\p{Vo=:\Atr\z:}', "");;
    Expect(0, 65508, '\p{Vo=:\Atr\z:}', "");;
    Expect(1, 65507, '\p{Vo=--Tr}', "");
    Expect(0, 65507, '\p{^Vo=--Tr}', "");
    Expect(0, 65507, '\P{Vo=--Tr}', "");
    Expect(1, 65507, '\P{^Vo=--Tr}', "");
    Expect(0, 65508, '\p{Vo=--Tr}', "");
    Expect(1, 65508, '\p{^Vo=--Tr}', "");
    Expect(1, 65508, '\P{Vo=--Tr}', "");
    Expect(0, 65508, '\P{^Vo=--Tr}', "");
    Error('\p{Is_Vertical_Orientation= :=transformed_Rotated}');
    Error('\P{Is_Vertical_Orientation= :=transformed_Rotated}');
    Expect(1, 65507, '\p{Is_Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65507, '\p{^Is_Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65507, '\P{Is_Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65507, '\P{^Is_Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65508, '\p{Is_Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65508, '\p{^Is_Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65508, '\P{Is_Vertical_Orientation=transformedrotated}', "");
    Expect(0, 65508, '\P{^Is_Vertical_Orientation=transformedrotated}', "");
    Expect(1, 65507, '\p{Is_Vertical_Orientation= TRANSFORMED_ROTATED}', "");
    Expect(0, 65507, '\p{^Is_Vertical_Orientation= TRANSFORMED_ROTATED}', "");
    Expect(0, 65507, '\P{Is_Vertical_Orientation= TRANSFORMED_ROTATED}', "");
    Expect(1, 65507, '\P{^Is_Vertical_Orientation= TRANSFORMED_ROTATED}', "");
    Expect(0, 65508, '\p{Is_Vertical_Orientation= TRANSFORMED_ROTATED}', "");
    Expect(1, 65508, '\p{^Is_Vertical_Orientation= TRANSFORMED_ROTATED}', "");
    Expect(1, 65508, '\P{Is_Vertical_Orientation= TRANSFORMED_ROTATED}', "");
    Expect(0, 65508, '\P{^Is_Vertical_Orientation= TRANSFORMED_ROTATED}', "");
    Error('\p{Is_Vo=	:=TR}');
    Error('\P{Is_Vo=	:=TR}');
    Expect(1, 65507, '\p{Is_Vo=tr}', "");
    Expect(0, 65507, '\p{^Is_Vo=tr}', "");
    Expect(0, 65507, '\P{Is_Vo=tr}', "");
    Expect(1, 65507, '\P{^Is_Vo=tr}', "");
    Expect(0, 65508, '\p{Is_Vo=tr}', "");
    Expect(1, 65508, '\p{^Is_Vo=tr}', "");
    Expect(1, 65508, '\P{Is_Vo=tr}', "");
    Expect(0, 65508, '\P{^Is_Vo=tr}', "");
    Expect(1, 65507, '\p{Is_Vo=__Tr}', "");
    Expect(0, 65507, '\p{^Is_Vo=__Tr}', "");
    Expect(0, 65507, '\P{Is_Vo=__Tr}', "");
    Expect(1, 65507, '\P{^Is_Vo=__Tr}', "");
    Expect(0, 65508, '\p{Is_Vo=__Tr}', "");
    Expect(1, 65508, '\p{^Is_Vo=__Tr}', "");
    Expect(1, 65508, '\P{Is_Vo=__Tr}', "");
    Expect(0, 65508, '\P{^Is_Vo=__Tr}', "");
    Error('\p{Vertical_Orientation=:=Transformed_upright}');
    Error('\P{Vertical_Orientation=:=Transformed_upright}');
    Expect(1, 127489, '\p{Vertical_Orientation=:\ATransformed_Upright\z:}', "");;
    Expect(0, 127490, '\p{Vertical_Orientation=:\ATransformed_Upright\z:}', "");;
    Expect(1, 127489, '\p{Vertical_Orientation=transformedupright}', "");
    Expect(0, 127489, '\p{^Vertical_Orientation=transformedupright}', "");
    Expect(0, 127489, '\P{Vertical_Orientation=transformedupright}', "");
    Expect(1, 127489, '\P{^Vertical_Orientation=transformedupright}', "");
    Expect(0, 127490, '\p{Vertical_Orientation=transformedupright}', "");
    Expect(1, 127490, '\p{^Vertical_Orientation=transformedupright}', "");
    Expect(1, 127490, '\P{Vertical_Orientation=transformedupright}', "");
    Expect(0, 127490, '\P{^Vertical_Orientation=transformedupright}', "");
    Expect(1, 127489, '\p{Vertical_Orientation=:\Atransformedupright\z:}', "");;
    Expect(0, 127490, '\p{Vertical_Orientation=:\Atransformedupright\z:}', "");;
    Expect(1, 127489, '\p{Vertical_Orientation=		Transformed_Upright}', "");
    Expect(0, 127489, '\p{^Vertical_Orientation=		Transformed_Upright}', "");
    Expect(0, 127489, '\P{Vertical_Orientation=		Transformed_Upright}', "");
    Expect(1, 127489, '\P{^Vertical_Orientation=		Transformed_Upright}', "");
    Expect(0, 127490, '\p{Vertical_Orientation=		Transformed_Upright}', "");
    Expect(1, 127490, '\p{^Vertical_Orientation=		Transformed_Upright}', "");
    Expect(1, 127490, '\P{Vertical_Orientation=		Transformed_Upright}', "");
    Expect(0, 127490, '\P{^Vertical_Orientation=		Transformed_Upright}', "");
    Error('\p{Vo=:=_ Tu}');
    Error('\P{Vo=:=_ Tu}');
    Expect(1, 127489, '\p{Vo=:\ATu\z:}', "");;
    Expect(0, 127490, '\p{Vo=:\ATu\z:}', "");;
    Expect(1, 127489, '\p{Vo:   tu}', "");
    Expect(0, 127489, '\p{^Vo:   tu}', "");
    Expect(0, 127489, '\P{Vo:   tu}', "");
    Expect(1, 127489, '\P{^Vo:   tu}', "");
    Expect(0, 127490, '\p{Vo:   tu}', "");
    Expect(1, 127490, '\p{^Vo:   tu}', "");
    Expect(1, 127490, '\P{Vo:   tu}', "");
    Expect(0, 127490, '\P{^Vo:   tu}', "");
    Expect(1, 127489, '\p{Vo=:\Atu\z:}', "");;
    Expect(0, 127490, '\p{Vo=:\Atu\z:}', "");;
    Expect(1, 127489, '\p{Vo:    -Tu}', "");
    Expect(0, 127489, '\p{^Vo:    -Tu}', "");
    Expect(0, 127489, '\P{Vo:    -Tu}', "");
    Expect(1, 127489, '\P{^Vo:    -Tu}', "");
    Expect(0, 127490, '\p{Vo:    -Tu}', "");
    Expect(1, 127490, '\p{^Vo:    -Tu}', "");
    Expect(1, 127490, '\P{Vo:    -Tu}', "");
    Expect(0, 127490, '\P{^Vo:    -Tu}', "");
    Error('\p{Is_Vertical_Orientation=/a/TRANSFORMED_upright}');
    Error('\P{Is_Vertical_Orientation=/a/TRANSFORMED_upright}');
    Expect(1, 127489, '\p{Is_Vertical_Orientation:   transformedupright}', "");
    Expect(0, 127489, '\p{^Is_Vertical_Orientation:   transformedupright}', "");
    Expect(0, 127489, '\P{Is_Vertical_Orientation:   transformedupright}', "");
    Expect(1, 127489, '\P{^Is_Vertical_Orientation:   transformedupright}', "");
    Expect(0, 127490, '\p{Is_Vertical_Orientation:   transformedupright}', "");
    Expect(1, 127490, '\p{^Is_Vertical_Orientation:   transformedupright}', "");
    Expect(1, 127490, '\P{Is_Vertical_Orientation:   transformedupright}', "");
    Expect(0, 127490, '\P{^Is_Vertical_Orientation:   transformedupright}', "");
    Expect(1, 127489, '\p{Is_Vertical_Orientation=-TRANSFORMED_Upright}', "");
    Expect(0, 127489, '\p{^Is_Vertical_Orientation=-TRANSFORMED_Upright}', "");
    Expect(0, 127489, '\P{Is_Vertical_Orientation=-TRANSFORMED_Upright}', "");
    Expect(1, 127489, '\P{^Is_Vertical_Orientation=-TRANSFORMED_Upright}', "");
    Expect(0, 127490, '\p{Is_Vertical_Orientation=-TRANSFORMED_Upright}', "");
    Expect(1, 127490, '\p{^Is_Vertical_Orientation=-TRANSFORMED_Upright}', "");
    Expect(1, 127490, '\P{Is_Vertical_Orientation=-TRANSFORMED_Upright}', "");
    Expect(0, 127490, '\P{^Is_Vertical_Orientation=-TRANSFORMED_Upright}', "");
    Error('\p{Is_Vo:	:=TU}');
    Error('\P{Is_Vo:	:=TU}');
    Expect(1, 127489, '\p{Is_Vo=tu}', "");
    Expect(0, 127489, '\p{^Is_Vo=tu}', "");
    Expect(0, 127489, '\P{Is_Vo=tu}', "");
    Expect(1, 127489, '\P{^Is_Vo=tu}', "");
    Expect(0, 127490, '\p{Is_Vo=tu}', "");
    Expect(1, 127490, '\p{^Is_Vo=tu}', "");
    Expect(1, 127490, '\P{Is_Vo=tu}', "");
    Expect(0, 127490, '\P{^Is_Vo=tu}', "");
    Expect(1, 127489, '\p{Is_Vo=_	tu}', "");
    Expect(0, 127489, '\p{^Is_Vo=_	tu}', "");
    Expect(0, 127489, '\P{Is_Vo=_	tu}', "");
    Expect(1, 127489, '\P{^Is_Vo=_	tu}', "");
    Expect(0, 127490, '\p{Is_Vo=_	tu}', "");
    Expect(1, 127490, '\p{^Is_Vo=_	tu}', "");
    Expect(1, 127490, '\P{Is_Vo=_	tu}', "");
    Expect(0, 127490, '\P{^Is_Vo=_	tu}', "");
    Error('\p{Vertical_Orientation:   -Upright/a/}');
    Error('\P{Vertical_Orientation:   -Upright/a/}');
    Expect(1, 1114109, '\p{Vertical_Orientation=:\AUpright\z:}', "");;
    Expect(0, 262144, '\p{Vertical_Orientation=:\AUpright\z:}', "");;
    Expect(1, 1114109, '\p{Vertical_Orientation=upright}', "");
    Expect(0, 1114109, '\p{^Vertical_Orientation=upright}', "");
    Expect(0, 1114109, '\P{Vertical_Orientation=upright}', "");
    Expect(1, 1114109, '\P{^Vertical_Orientation=upright}', "");
    Expect(0, 262144, '\p{Vertical_Orientation=upright}', "");
    Expect(1, 262144, '\p{^Vertical_Orientation=upright}', "");
    Expect(1, 262144, '\P{Vertical_Orientation=upright}', "");
    Expect(0, 262144, '\P{^Vertical_Orientation=upright}', "");
    Expect(1, 1114109, '\p{Vertical_Orientation=:\Aupright\z:}', "");;
    Expect(0, 262144, '\p{Vertical_Orientation=:\Aupright\z:}', "");;
    Expect(1, 1114109, '\p{Vertical_Orientation=-	upright}', "");
    Expect(0, 1114109, '\p{^Vertical_Orientation=-	upright}', "");
    Expect(0, 1114109, '\P{Vertical_Orientation=-	upright}', "");
    Expect(1, 1114109, '\P{^Vertical_Orientation=-	upright}', "");
    Expect(0, 262144, '\p{Vertical_Orientation=-	upright}', "");
    Expect(1, 262144, '\p{^Vertical_Orientation=-	upright}', "");
    Expect(1, 262144, '\P{Vertical_Orientation=-	upright}', "");
    Expect(0, 262144, '\P{^Vertical_Orientation=-	upright}', "");
    Error('\p{Vo=-:=u}');
    Error('\P{Vo=-:=u}');
    Expect(1, 1114109, '\p{Vo=:\AU\z:}', "");;
    Expect(0, 262144, '\p{Vo=:\AU\z:}', "");;
    Expect(1, 1114109, '\p{Vo=u}', "");
    Expect(0, 1114109, '\p{^Vo=u}', "");
    Expect(0, 1114109, '\P{Vo=u}', "");
    Expect(1, 1114109, '\P{^Vo=u}', "");
    Expect(0, 262144, '\p{Vo=u}', "");
    Expect(1, 262144, '\p{^Vo=u}', "");
    Expect(1, 262144, '\P{Vo=u}', "");
    Expect(0, 262144, '\P{^Vo=u}', "");
    Expect(1, 1114109, '\p{Vo=:\Au\z:}', "");;
    Expect(0, 262144, '\p{Vo=:\Au\z:}', "");;
    Expect(1, 1114109, '\p{Vo=--U}', "");
    Expect(0, 1114109, '\p{^Vo=--U}', "");
    Expect(0, 1114109, '\P{Vo=--U}', "");
    Expect(1, 1114109, '\P{^Vo=--U}', "");
    Expect(0, 262144, '\p{Vo=--U}', "");
    Expect(1, 262144, '\p{^Vo=--U}', "");
    Expect(1, 262144, '\P{Vo=--U}', "");
    Expect(0, 262144, '\P{^Vo=--U}', "");
    Error('\p{Is_Vertical_Orientation=/a/UPRIGHT}');
    Error('\P{Is_Vertical_Orientation=/a/UPRIGHT}');
    Expect(1, 1114109, '\p{Is_Vertical_Orientation=upright}', "");
    Expect(0, 1114109, '\p{^Is_Vertical_Orientation=upright}', "");
    Expect(0, 1114109, '\P{Is_Vertical_Orientation=upright}', "");
    Expect(1, 1114109, '\P{^Is_Vertical_Orientation=upright}', "");
    Expect(0, 262144, '\p{Is_Vertical_Orientation=upright}', "");
    Expect(1, 262144, '\p{^Is_Vertical_Orientation=upright}', "");
    Expect(1, 262144, '\P{Is_Vertical_Orientation=upright}', "");
    Expect(0, 262144, '\P{^Is_Vertical_Orientation=upright}', "");
    Expect(1, 1114109, '\p{Is_Vertical_Orientation= _Upright}', "");
    Expect(0, 1114109, '\p{^Is_Vertical_Orientation= _Upright}', "");
    Expect(0, 1114109, '\P{Is_Vertical_Orientation= _Upright}', "");
    Expect(1, 1114109, '\P{^Is_Vertical_Orientation= _Upright}', "");
    Expect(0, 262144, '\p{Is_Vertical_Orientation= _Upright}', "");
    Expect(1, 262144, '\p{^Is_Vertical_Orientation= _Upright}', "");
    Expect(1, 262144, '\P{Is_Vertical_Orientation= _Upright}', "");
    Expect(0, 262144, '\P{^Is_Vertical_Orientation= _Upright}', "");
    Error('\p{Is_Vo=:=u}');
    Error('\P{Is_Vo=:=u}');
    Expect(1, 1114109, '\p{Is_Vo=u}', "");
    Expect(0, 1114109, '\p{^Is_Vo=u}', "");
    Expect(0, 1114109, '\P{Is_Vo=u}', "");
    Expect(1, 1114109, '\P{^Is_Vo=u}', "");
    Expect(0, 262144, '\p{Is_Vo=u}', "");
    Expect(1, 262144, '\p{^Is_Vo=u}', "");
    Expect(1, 262144, '\P{Is_Vo=u}', "");
    Expect(0, 262144, '\P{^Is_Vo=u}', "");
    Expect(1, 1114109, '\p{Is_Vo=_u}', "");
    Expect(0, 1114109, '\p{^Is_Vo=_u}', "");
    Expect(0, 1114109, '\P{Is_Vo=_u}', "");
    Expect(1, 1114109, '\P{^Is_Vo=_u}', "");
    Expect(0, 262144, '\p{Is_Vo=_u}', "");
    Expect(1, 262144, '\p{^Is_Vo=_u}', "");
    Expect(1, 262144, '\P{Is_Vo=_u}', "");
    Expect(0, 262144, '\P{^Is_Vo=_u}', "");
    Error('\p{Variation_Selector= /a/no}');
    Error('\P{Variation_Selector= /a/no}');
    Expect(1, 918000, '\p{Variation_Selector=:\ANo\z:}', "");;
    Expect(0, 917999, '\p{Variation_Selector=:\ANo\z:}', "");;
    Expect(1, 918000, '\p{Variation_Selector=no}', "");
    Expect(0, 918000, '\p{^Variation_Selector=no}', "");
    Expect(0, 918000, '\P{Variation_Selector=no}', "");
    Expect(1, 918000, '\P{^Variation_Selector=no}', "");
    Expect(0, 917999, '\p{Variation_Selector=no}', "");
    Expect(1, 917999, '\p{^Variation_Selector=no}', "");
    Expect(1, 917999, '\P{Variation_Selector=no}', "");
    Expect(0, 917999, '\P{^Variation_Selector=no}', "");
    Expect(1, 918000, '\p{Variation_Selector=:\Ano\z:}', "");;
    Expect(0, 917999, '\p{Variation_Selector=:\Ano\z:}', "");;
    Expect(1, 918000, '\p{Variation_Selector=_NO}', "");
    Expect(0, 918000, '\p{^Variation_Selector=_NO}', "");
    Expect(0, 918000, '\P{Variation_Selector=_NO}', "");
    Expect(1, 918000, '\P{^Variation_Selector=_NO}', "");
    Expect(0, 917999, '\p{Variation_Selector=_NO}', "");
    Expect(1, 917999, '\p{^Variation_Selector=_NO}', "");
    Expect(1, 917999, '\P{Variation_Selector=_NO}', "");
    Expect(0, 917999, '\P{^Variation_Selector=_NO}', "");
    Error('\p{VS=:= N}');
    Error('\P{VS=:= N}');
    Expect(1, 918000, '\p{VS=:\AN\z:}', "");;
    Expect(0, 917999, '\p{VS=:\AN\z:}', "");;
    Expect(1, 918000, '\p{VS=n}', "");
    Expect(0, 918000, '\p{^VS=n}', "");
    Expect(0, 918000, '\P{VS=n}', "");
    Expect(1, 918000, '\P{^VS=n}', "");
    Expect(0, 917999, '\p{VS=n}', "");
    Expect(1, 917999, '\p{^VS=n}', "");
    Expect(1, 917999, '\P{VS=n}', "");
    Expect(0, 917999, '\P{^VS=n}', "");
    Expect(1, 918000, '\p{VS=:\An\z:}', "");;
    Expect(0, 917999, '\p{VS=:\An\z:}', "");;
    Expect(1, 918000, '\p{VS=_-N}', "");
    Expect(0, 918000, '\p{^VS=_-N}', "");
    Expect(0, 918000, '\P{VS=_-N}', "");
    Expect(1, 918000, '\P{^VS=_-N}', "");
    Expect(0, 917999, '\p{VS=_-N}', "");
    Expect(1, 917999, '\p{^VS=_-N}', "");
    Expect(1, 917999, '\P{VS=_-N}', "");
    Expect(0, 917999, '\P{^VS=_-N}', "");
    Error('\p{Is_Variation_Selector=/a/ F}');
    Error('\P{Is_Variation_Selector=/a/ F}');
    Expect(1, 918000, '\p{Is_Variation_Selector=f}', "");
    Expect(0, 918000, '\p{^Is_Variation_Selector=f}', "");
    Expect(0, 918000, '\P{Is_Variation_Selector=f}', "");
    Expect(1, 918000, '\P{^Is_Variation_Selector=f}', "");
    Expect(0, 917999, '\p{Is_Variation_Selector=f}', "");
    Expect(1, 917999, '\p{^Is_Variation_Selector=f}', "");
    Expect(1, 917999, '\P{Is_Variation_Selector=f}', "");
    Expect(0, 917999, '\P{^Is_Variation_Selector=f}', "");
    Expect(1, 918000, '\p{Is_Variation_Selector= _F}', "");
    Expect(0, 918000, '\p{^Is_Variation_Selector= _F}', "");
    Expect(0, 918000, '\P{Is_Variation_Selector= _F}', "");
    Expect(1, 918000, '\P{^Is_Variation_Selector= _F}', "");
    Expect(0, 917999, '\p{Is_Variation_Selector= _F}', "");
    Expect(1, 917999, '\p{^Is_Variation_Selector= _F}', "");
    Expect(1, 917999, '\P{Is_Variation_Selector= _F}', "");
    Expect(0, 917999, '\P{^Is_Variation_Selector= _F}', "");
    Error('\p{Is_VS:False:=}');
    Error('\P{Is_VS:False:=}');
    Expect(1, 918000, '\p{Is_VS=false}', "");
    Expect(0, 918000, '\p{^Is_VS=false}', "");
    Expect(0, 918000, '\P{Is_VS=false}', "");
    Expect(1, 918000, '\P{^Is_VS=false}', "");
    Expect(0, 917999, '\p{Is_VS=false}', "");
    Expect(1, 917999, '\p{^Is_VS=false}', "");
    Expect(1, 917999, '\P{Is_VS=false}', "");
    Expect(0, 917999, '\P{^Is_VS=false}', "");
    Expect(1, 918000, '\p{Is_VS=	-False}', "");
    Expect(0, 918000, '\p{^Is_VS=	-False}', "");
    Expect(0, 918000, '\P{Is_VS=	-False}', "");
    Expect(1, 918000, '\P{^Is_VS=	-False}', "");
    Expect(0, 917999, '\p{Is_VS=	-False}', "");
    Expect(1, 917999, '\p{^Is_VS=	-False}', "");
    Expect(1, 917999, '\P{Is_VS=	-False}', "");
    Expect(0, 917999, '\P{^Is_VS=	-False}', "");
    Error('\p{Variation_Selector= _Yes:=}');
    Error('\P{Variation_Selector= _Yes:=}');
    Expect(1, 917999, '\p{Variation_Selector=:\AYes\z:}', "");;
    Expect(0, 918000, '\p{Variation_Selector=:\AYes\z:}', "");;
    Expect(1, 917999, '\p{Variation_Selector=yes}', "");
    Expect(0, 917999, '\p{^Variation_Selector=yes}', "");
    Expect(0, 917999, '\P{Variation_Selector=yes}', "");
    Expect(1, 917999, '\P{^Variation_Selector=yes}', "");
    Expect(0, 918000, '\p{Variation_Selector=yes}', "");
    Expect(1, 918000, '\p{^Variation_Selector=yes}', "");
    Expect(1, 918000, '\P{Variation_Selector=yes}', "");
    Expect(0, 918000, '\P{^Variation_Selector=yes}', "");
    Expect(1, 917999, '\p{Variation_Selector=:\Ayes\z:}', "");;
    Expect(0, 918000, '\p{Variation_Selector=:\Ayes\z:}', "");;
    Expect(1, 917999, '\p{Variation_Selector=__Yes}', "");
    Expect(0, 917999, '\p{^Variation_Selector=__Yes}', "");
    Expect(0, 917999, '\P{Variation_Selector=__Yes}', "");
    Expect(1, 917999, '\P{^Variation_Selector=__Yes}', "");
    Expect(0, 918000, '\p{Variation_Selector=__Yes}', "");
    Expect(1, 918000, '\p{^Variation_Selector=__Yes}', "");
    Expect(1, 918000, '\P{Variation_Selector=__Yes}', "");
    Expect(0, 918000, '\P{^Variation_Selector=__Yes}', "");
    Error('\p{VS=/a/Y}');
    Error('\P{VS=/a/Y}');
    Expect(1, 917999, '\p{VS=:\AY\z:}', "");;
    Expect(0, 918000, '\p{VS=:\AY\z:}', "");;
    Expect(1, 917999, '\p{VS=y}', "");
    Expect(0, 917999, '\p{^VS=y}', "");
    Expect(0, 917999, '\P{VS=y}', "");
    Expect(1, 917999, '\P{^VS=y}', "");
    Expect(0, 918000, '\p{VS=y}', "");
    Expect(1, 918000, '\p{^VS=y}', "");
    Expect(1, 918000, '\P{VS=y}', "");
    Expect(0, 918000, '\P{^VS=y}', "");
    Expect(1, 917999, '\p{VS=:\Ay\z:}', "");;
    Expect(0, 918000, '\p{VS=:\Ay\z:}', "");;
    Expect(1, 917999, '\p{VS=_ Y}', "");
    Expect(0, 917999, '\p{^VS=_ Y}', "");
    Expect(0, 917999, '\P{VS=_ Y}', "");
    Expect(1, 917999, '\P{^VS=_ Y}', "");
    Expect(0, 918000, '\p{VS=_ Y}', "");
    Expect(1, 918000, '\p{^VS=_ Y}', "");
    Expect(1, 918000, '\P{VS=_ Y}', "");
    Expect(0, 918000, '\P{^VS=_ Y}', "");
    Error('\p{Is_Variation_Selector=_/a/T}');
    Error('\P{Is_Variation_Selector=_/a/T}');
    Expect(1, 917999, '\p{Is_Variation_Selector:   t}', "");
    Expect(0, 917999, '\p{^Is_Variation_Selector:   t}', "");
    Expect(0, 917999, '\P{Is_Variation_Selector:   t}', "");
    Expect(1, 917999, '\P{^Is_Variation_Selector:   t}', "");
    Expect(0, 918000, '\p{Is_Variation_Selector:   t}', "");
    Expect(1, 918000, '\p{^Is_Variation_Selector:   t}', "");
    Expect(1, 918000, '\P{Is_Variation_Selector:   t}', "");
    Expect(0, 918000, '\P{^Is_Variation_Selector:   t}', "");
    Expect(1, 917999, '\p{Is_Variation_Selector=	 T}', "");
    Expect(0, 917999, '\p{^Is_Variation_Selector=	 T}', "");
    Expect(0, 917999, '\P{Is_Variation_Selector=	 T}', "");
    Expect(1, 917999, '\P{^Is_Variation_Selector=	 T}', "");
    Expect(0, 918000, '\p{Is_Variation_Selector=	 T}', "");
    Expect(1, 918000, '\p{^Is_Variation_Selector=	 T}', "");
    Expect(1, 918000, '\P{Is_Variation_Selector=	 T}', "");
    Expect(0, 918000, '\P{^Is_Variation_Selector=	 T}', "");
    Error('\p{Is_VS=/a/		TRUE}');
    Error('\P{Is_VS=/a/		TRUE}');
    Expect(1, 917999, '\p{Is_VS=true}', "");
    Expect(0, 917999, '\p{^Is_VS=true}', "");
    Expect(0, 917999, '\P{Is_VS=true}', "");
    Expect(1, 917999, '\P{^Is_VS=true}', "");
    Expect(0, 918000, '\p{Is_VS=true}', "");
    Expect(1, 918000, '\p{^Is_VS=true}', "");
    Expect(1, 918000, '\P{Is_VS=true}', "");
    Expect(0, 918000, '\P{^Is_VS=true}', "");
    Expect(1, 917999, '\p{Is_VS=_True}', "");
    Expect(0, 917999, '\p{^Is_VS=_True}', "");
    Expect(0, 917999, '\P{Is_VS=_True}', "");
    Expect(1, 917999, '\P{^Is_VS=_True}', "");
    Expect(0, 918000, '\p{Is_VS=_True}', "");
    Expect(1, 918000, '\p{^Is_VS=_True}', "");
    Expect(1, 918000, '\P{Is_VS=_True}', "");
    Expect(0, 918000, '\P{^Is_VS=_True}', "");
    Error('\p{wordbreak}');
    Error('\P{wordbreak}');
    Error('\p{wb}');
    Error('\P{wb}');
    Error('\p{_perlwb}');
    Error('\P{_perlwb}');
    Error('\p{Word_Break=-cr/a/}');
    Error('\P{Word_Break=-cr/a/}');
    Expect(1, 13, '\p{Word_Break=:\ACR\z:}', "");;
    Expect(0, 14, '\p{Word_Break=:\ACR\z:}', "");;
    Expect(1, 13, '\p{Word_Break=cr}', "");
    Expect(0, 13, '\p{^Word_Break=cr}', "");
    Expect(0, 13, '\P{Word_Break=cr}', "");
    Expect(1, 13, '\P{^Word_Break=cr}', "");
    Expect(0, 14, '\p{Word_Break=cr}', "");
    Expect(1, 14, '\p{^Word_Break=cr}', "");
    Expect(1, 14, '\P{Word_Break=cr}', "");
    Expect(0, 14, '\P{^Word_Break=cr}', "");
    Expect(1, 13, '\p{Word_Break=:\Acr\z:}', "");;
    Expect(0, 14, '\p{Word_Break=:\Acr\z:}', "");;
    Expect(1, 13, '\p{Word_Break=_-cr}', "");
    Expect(0, 13, '\p{^Word_Break=_-cr}', "");
    Expect(0, 13, '\P{Word_Break=_-cr}', "");
    Expect(1, 13, '\P{^Word_Break=_-cr}', "");
    Expect(0, 14, '\p{Word_Break=_-cr}', "");
    Expect(1, 14, '\p{^Word_Break=_-cr}', "");
    Expect(1, 14, '\P{Word_Break=_-cr}', "");
    Expect(0, 14, '\P{^Word_Break=_-cr}', "");
    Error('\p{WB=-_CR:=}');
    Error('\P{WB=-_CR:=}');
    Expect(1, 13, '\p{WB=:\ACR\z:}', "");;
    Expect(0, 14, '\p{WB=:\ACR\z:}', "");;
    Expect(1, 13, '\p{WB=cr}', "");
    Expect(0, 13, '\p{^WB=cr}', "");
    Expect(0, 13, '\P{WB=cr}', "");
    Expect(1, 13, '\P{^WB=cr}', "");
    Expect(0, 14, '\p{WB=cr}', "");
    Expect(1, 14, '\p{^WB=cr}', "");
    Expect(1, 14, '\P{WB=cr}', "");
    Expect(0, 14, '\P{^WB=cr}', "");
    Expect(1, 13, '\p{WB=:\Acr\z:}', "");;
    Expect(0, 14, '\p{WB=:\Acr\z:}', "");;
    Expect(1, 13, '\p{WB=	_CR}', "");
    Expect(0, 13, '\p{^WB=	_CR}', "");
    Expect(0, 13, '\P{WB=	_CR}', "");
    Expect(1, 13, '\P{^WB=	_CR}', "");
    Expect(0, 14, '\p{WB=	_CR}', "");
    Expect(1, 14, '\p{^WB=	_CR}', "");
    Expect(1, 14, '\P{WB=	_CR}', "");
    Expect(0, 14, '\P{^WB=	_CR}', "");
    Error('\p{Is_Word_Break=	-CR/a/}');
    Error('\P{Is_Word_Break=	-CR/a/}');
    Expect(1, 13, '\p{Is_Word_Break=cr}', "");
    Expect(0, 13, '\p{^Is_Word_Break=cr}', "");
    Expect(0, 13, '\P{Is_Word_Break=cr}', "");
    Expect(1, 13, '\P{^Is_Word_Break=cr}', "");
    Expect(0, 14, '\p{Is_Word_Break=cr}', "");
    Expect(1, 14, '\p{^Is_Word_Break=cr}', "");
    Expect(1, 14, '\P{Is_Word_Break=cr}', "");
    Expect(0, 14, '\P{^Is_Word_Break=cr}', "");
    Expect(1, 13, '\p{Is_Word_Break=_ cr}', "");
    Expect(0, 13, '\p{^Is_Word_Break=_ cr}', "");
    Expect(0, 13, '\P{Is_Word_Break=_ cr}', "");
    Expect(1, 13, '\P{^Is_Word_Break=_ cr}', "");
    Expect(0, 14, '\p{Is_Word_Break=_ cr}', "");
    Expect(1, 14, '\p{^Is_Word_Break=_ cr}', "");
    Expect(1, 14, '\P{Is_Word_Break=_ cr}', "");
    Expect(0, 14, '\P{^Is_Word_Break=_ cr}', "");
    Error('\p{Is_WB:/a/		CR}');
    Error('\P{Is_WB:/a/		CR}');
    Expect(1, 13, '\p{Is_WB=cr}', "");
    Expect(0, 13, '\p{^Is_WB=cr}', "");
    Expect(0, 13, '\P{Is_WB=cr}', "");
    Expect(1, 13, '\P{^Is_WB=cr}', "");
    Expect(0, 14, '\p{Is_WB=cr}', "");
    Expect(1, 14, '\p{^Is_WB=cr}', "");
    Expect(1, 14, '\P{Is_WB=cr}', "");
    Expect(0, 14, '\P{^Is_WB=cr}', "");
    Expect(1, 13, '\p{Is_WB=	-CR}', "");
    Expect(0, 13, '\p{^Is_WB=	-CR}', "");
    Expect(0, 13, '\P{Is_WB=	-CR}', "");
    Expect(1, 13, '\P{^Is_WB=	-CR}', "");
    Expect(0, 14, '\p{Is_WB=	-CR}', "");
    Expect(1, 14, '\p{^Is_WB=	-CR}', "");
    Expect(1, 14, '\P{Is_WB=	-CR}', "");
    Expect(0, 14, '\P{^Is_WB=	-CR}', "");
    Error('\p{Word_Break=_:=Double_QUOTE}');
    Error('\P{Word_Break=_:=Double_QUOTE}');
    Expect(1, 34, '\p{Word_Break=:\ADouble_Quote\z:}', "");;
    Expect(0, 35, '\p{Word_Break=:\ADouble_Quote\z:}', "");;
    Expect(1, 34, '\p{Word_Break=doublequote}', "");
    Expect(0, 34, '\p{^Word_Break=doublequote}', "");
    Expect(0, 34, '\P{Word_Break=doublequote}', "");
    Expect(1, 34, '\P{^Word_Break=doublequote}', "");
    Expect(0, 35, '\p{Word_Break=doublequote}', "");
    Expect(1, 35, '\p{^Word_Break=doublequote}', "");
    Expect(1, 35, '\P{Word_Break=doublequote}', "");
    Expect(0, 35, '\P{^Word_Break=doublequote}', "");
    Expect(1, 34, '\p{Word_Break=:\Adoublequote\z:}', "");;
    Expect(0, 35, '\p{Word_Break=:\Adoublequote\z:}', "");;
    Expect(1, 34, '\p{Word_Break=__Double_QUOTE}', "");
    Expect(0, 34, '\p{^Word_Break=__Double_QUOTE}', "");
    Expect(0, 34, '\P{Word_Break=__Double_QUOTE}', "");
    Expect(1, 34, '\P{^Word_Break=__Double_QUOTE}', "");
    Expect(0, 35, '\p{Word_Break=__Double_QUOTE}', "");
    Expect(1, 35, '\p{^Word_Break=__Double_QUOTE}', "");
    Expect(1, 35, '\P{Word_Break=__Double_QUOTE}', "");
    Expect(0, 35, '\P{^Word_Break=__Double_QUOTE}', "");
    Error('\p{WB:   _/a/DQ}');
    Error('\P{WB:   _/a/DQ}');
    Expect(1, 34, '\p{WB=:\ADQ\z:}', "");;
    Expect(0, 35, '\p{WB=:\ADQ\z:}', "");;
    Expect(1, 34, '\p{WB=dq}', "");
    Expect(0, 34, '\p{^WB=dq}', "");
    Expect(0, 34, '\P{WB=dq}', "");
    Expect(1, 34, '\P{^WB=dq}', "");
    Expect(0, 35, '\p{WB=dq}', "");
    Expect(1, 35, '\p{^WB=dq}', "");
    Expect(1, 35, '\P{WB=dq}', "");
    Expect(0, 35, '\P{^WB=dq}', "");
    Expect(1, 34, '\p{WB=:\Adq\z:}', "");;
    Expect(0, 35, '\p{WB=:\Adq\z:}', "");;
    Expect(1, 34, '\p{WB=	DQ}', "");
    Expect(0, 34, '\p{^WB=	DQ}', "");
    Expect(0, 34, '\P{WB=	DQ}', "");
    Expect(1, 34, '\P{^WB=	DQ}', "");
    Expect(0, 35, '\p{WB=	DQ}', "");
    Expect(1, 35, '\p{^WB=	DQ}', "");
    Expect(1, 35, '\P{WB=	DQ}', "");
    Expect(0, 35, '\P{^WB=	DQ}', "");
    Error('\p{Is_Word_Break=/a/_	double_Quote}');
    Error('\P{Is_Word_Break=/a/_	double_Quote}');
    Expect(1, 34, '\p{Is_Word_Break=doublequote}', "");
    Expect(0, 34, '\p{^Is_Word_Break=doublequote}', "");
    Expect(0, 34, '\P{Is_Word_Break=doublequote}', "");
    Expect(1, 34, '\P{^Is_Word_Break=doublequote}', "");
    Expect(0, 35, '\p{Is_Word_Break=doublequote}', "");
    Expect(1, 35, '\p{^Is_Word_Break=doublequote}', "");
    Expect(1, 35, '\P{Is_Word_Break=doublequote}', "");
    Expect(0, 35, '\P{^Is_Word_Break=doublequote}', "");
    Expect(1, 34, '\p{Is_Word_Break=_DOUBLE_quote}', "");
    Expect(0, 34, '\p{^Is_Word_Break=_DOUBLE_quote}', "");
    Expect(0, 34, '\P{Is_Word_Break=_DOUBLE_quote}', "");
    Expect(1, 34, '\P{^Is_Word_Break=_DOUBLE_quote}', "");
    Expect(0, 35, '\p{Is_Word_Break=_DOUBLE_quote}', "");
    Expect(1, 35, '\p{^Is_Word_Break=_DOUBLE_quote}', "");
    Expect(1, 35, '\P{Is_Word_Break=_DOUBLE_quote}', "");
    Expect(0, 35, '\P{^Is_Word_Break=_DOUBLE_quote}', "");
    Error('\p{Is_WB=_/a/dq}');
    Error('\P{Is_WB=_/a/dq}');
    Expect(1, 34, '\p{Is_WB=dq}', "");
    Expect(0, 34, '\p{^Is_WB=dq}', "");
    Expect(0, 34, '\P{Is_WB=dq}', "");
    Expect(1, 34, '\P{^Is_WB=dq}', "");
    Expect(0, 35, '\p{Is_WB=dq}', "");
    Expect(1, 35, '\p{^Is_WB=dq}', "");
    Expect(1, 35, '\P{Is_WB=dq}', "");
    Expect(0, 35, '\P{^Is_WB=dq}', "");
    Expect(1, 34, '\p{Is_WB= DQ}', "");
    Expect(0, 34, '\p{^Is_WB= DQ}', "");
    Expect(0, 34, '\P{Is_WB= DQ}', "");
    Expect(1, 34, '\P{^Is_WB= DQ}', "");
    Expect(0, 35, '\p{Is_WB= DQ}', "");
    Expect(1, 35, '\p{^Is_WB= DQ}', "");
    Expect(1, 35, '\P{Is_WB= DQ}', "");
    Expect(0, 35, '\P{^Is_WB= DQ}', "");
    Error('\p{Word_Break= 	E_Base/a/}');
    Error('\P{Word_Break= 	E_Base/a/}');
    Expect(0, 1, '\p{Word_Break=:\AE_Base\z:}', "");;
    Expect(0, 1, '\p{Word_Break=ebase}', "");
    Expect(1, 1, '\p{^Word_Break=ebase}', "");
    Expect(1, 1, '\P{Word_Break=ebase}', "");
    Expect(0, 1, '\P{^Word_Break=ebase}', "");
    Expect(0, 1, '\p{Word_Break=:\Aebase\z:}', "");;
    Expect(0, 1, '\p{Word_Break: -E_base}', "");
    Expect(1, 1, '\p{^Word_Break: -E_base}', "");
    Expect(1, 1, '\P{Word_Break: -E_base}', "");
    Expect(0, 1, '\P{^Word_Break: -E_base}', "");
    Error('\p{WB= -eb/a/}');
    Error('\P{WB= -eb/a/}');
    Expect(0, 1, '\p{WB=:\AEB\z:}', "");;
    Expect(0, 1, '\p{WB=eb}', "");
    Expect(1, 1, '\p{^WB=eb}', "");
    Expect(1, 1, '\P{WB=eb}', "");
    Expect(0, 1, '\P{^WB=eb}', "");
    Expect(0, 1, '\p{WB=:\Aeb\z:}', "");;
    Expect(0, 1, '\p{WB=--EB}', "");
    Expect(1, 1, '\p{^WB=--EB}', "");
    Expect(1, 1, '\P{WB=--EB}', "");
    Expect(0, 1, '\P{^WB=--EB}', "");
    Error('\p{Is_Word_Break= :=E_base}');
    Error('\P{Is_Word_Break= :=E_base}');
    Expect(0, 1, '\p{Is_Word_Break:	ebase}', "");
    Expect(1, 1, '\p{^Is_Word_Break:	ebase}', "");
    Expect(1, 1, '\P{Is_Word_Break:	ebase}', "");
    Expect(0, 1, '\P{^Is_Word_Break:	ebase}', "");
    Expect(0, 1, '\p{Is_Word_Break=_E_base}', "");
    Expect(1, 1, '\p{^Is_Word_Break=_E_base}', "");
    Expect(1, 1, '\P{Is_Word_Break=_E_base}', "");
    Expect(0, 1, '\P{^Is_Word_Break=_E_base}', "");
    Error('\p{Is_WB=:= 	EB}');
    Error('\P{Is_WB=:= 	EB}');
    Expect(0, 1, '\p{Is_WB:   eb}', "");
    Expect(1, 1, '\p{^Is_WB:   eb}', "");
    Expect(1, 1, '\P{Is_WB:   eb}', "");
    Expect(0, 1, '\P{^Is_WB:   eb}', "");
    Expect(0, 1, '\p{Is_WB=_-eb}', "");
    Expect(1, 1, '\p{^Is_WB=_-eb}', "");
    Expect(1, 1, '\P{Is_WB=_-eb}', "");
    Expect(0, 1, '\P{^Is_WB=_-eb}', "");
    Error('\p{Word_Break=/a/--E_Base_GAZ}');
    Error('\P{Word_Break=/a/--E_Base_GAZ}');
    Expect(0, 1, '\p{Word_Break=:\AE_Base_GAZ\z:}', "");;
    Expect(0, 1, '\p{Word_Break=ebasegaz}', "");
    Expect(1, 1, '\p{^Word_Break=ebasegaz}', "");
    Expect(1, 1, '\P{Word_Break=ebasegaz}', "");
    Expect(0, 1, '\P{^Word_Break=ebasegaz}', "");
    Expect(0, 1, '\p{Word_Break=:\Aebasegaz\z:}', "");;
    Expect(0, 1, '\p{Word_Break=-	E_Base_GAZ}', "");
    Expect(1, 1, '\p{^Word_Break=-	E_Base_GAZ}', "");
    Expect(1, 1, '\P{Word_Break=-	E_Base_GAZ}', "");
    Expect(0, 1, '\P{^Word_Break=-	E_Base_GAZ}', "");
    Error('\p{WB:  -ebg/a/}');
    Error('\P{WB:  -ebg/a/}');
    Expect(0, 1, '\p{WB=:\AEBG\z:}', "");;
    Expect(0, 1, '\p{WB=ebg}', "");
    Expect(1, 1, '\p{^WB=ebg}', "");
    Expect(1, 1, '\P{WB=ebg}', "");
    Expect(0, 1, '\P{^WB=ebg}', "");
    Expect(0, 1, '\p{WB=:\Aebg\z:}', "");;
    Expect(0, 1, '\p{WB:	-EBG}', "");
    Expect(1, 1, '\p{^WB:	-EBG}', "");
    Expect(1, 1, '\P{WB:	-EBG}', "");
    Expect(0, 1, '\P{^WB:	-EBG}', "");
    Error('\p{Is_Word_Break=_/a/e_Base_GAZ}');
    Error('\P{Is_Word_Break=_/a/e_Base_GAZ}');
    Expect(0, 1, '\p{Is_Word_Break=ebasegaz}', "");
    Expect(1, 1, '\p{^Is_Word_Break=ebasegaz}', "");
    Expect(1, 1, '\P{Is_Word_Break=ebasegaz}', "");
    Expect(0, 1, '\P{^Is_Word_Break=ebasegaz}', "");
    Expect(0, 1, '\p{Is_Word_Break:	-	E_Base_GAZ}', "");
    Expect(1, 1, '\p{^Is_Word_Break:	-	E_Base_GAZ}', "");
    Expect(1, 1, '\P{Is_Word_Break:	-	E_Base_GAZ}', "");
    Expect(0, 1, '\P{^Is_Word_Break:	-	E_Base_GAZ}', "");
    Error('\p{Is_WB=-:=EBG}');
    Error('\P{Is_WB=-:=EBG}');
    Expect(0, 1, '\p{Is_WB=ebg}', "");
    Expect(1, 1, '\p{^Is_WB=ebg}', "");
    Expect(1, 1, '\P{Is_WB=ebg}', "");
    Expect(0, 1, '\P{^Is_WB=ebg}', "");
    Expect(0, 1, '\p{Is_WB=	 EBG}', "");
    Expect(1, 1, '\p{^Is_WB=	 EBG}', "");
    Expect(1, 1, '\P{Is_WB=	 EBG}', "");
    Expect(0, 1, '\P{^Is_WB=	 EBG}', "");
    Error('\p{Word_Break:   :=_ e_modifier}');
    Error('\P{Word_Break:   :=_ e_modifier}');
    Expect(0, 1, '\p{Word_Break=:\AE_Modifier\z:}', "");;
    Expect(0, 1, '\p{Word_Break=emodifier}', "");
    Expect(1, 1, '\p{^Word_Break=emodifier}', "");
    Expect(1, 1, '\P{Word_Break=emodifier}', "");
    Expect(0, 1, '\P{^Word_Break=emodifier}', "");
    Expect(0, 1, '\p{Word_Break=:\Aemodifier\z:}', "");;
    Expect(0, 1, '\p{Word_Break:-_e_Modifier}', "");
    Expect(1, 1, '\p{^Word_Break:-_e_Modifier}', "");
    Expect(1, 1, '\P{Word_Break:-_e_Modifier}', "");
    Expect(0, 1, '\P{^Word_Break:-_e_Modifier}', "");
    Error('\p{WB=:= -EM}');
    Error('\P{WB=:= -EM}');
    Expect(0, 1, '\p{WB=:\AEM\z:}', "");;
    Expect(0, 1, '\p{WB=em}', "");
    Expect(1, 1, '\p{^WB=em}', "");
    Expect(1, 1, '\P{WB=em}', "");
    Expect(0, 1, '\P{^WB=em}', "");
    Expect(0, 1, '\p{WB=:\Aem\z:}', "");;
    Expect(0, 1, '\p{WB=--EM}', "");
    Expect(1, 1, '\p{^WB=--EM}', "");
    Expect(1, 1, '\P{WB=--EM}', "");
    Expect(0, 1, '\P{^WB=--EM}', "");
    Error('\p{Is_Word_Break=_E_Modifier:=}');
    Error('\P{Is_Word_Break=_E_Modifier:=}');
    Expect(0, 1, '\p{Is_Word_Break=emodifier}', "");
    Expect(1, 1, '\p{^Is_Word_Break=emodifier}', "");
    Expect(1, 1, '\P{Is_Word_Break=emodifier}', "");
    Expect(0, 1, '\P{^Is_Word_Break=emodifier}', "");
    Expect(0, 1, '\p{Is_Word_Break= E_Modifier}', "");
    Expect(1, 1, '\p{^Is_Word_Break= E_Modifier}', "");
    Expect(1, 1, '\P{Is_Word_Break= E_Modifier}', "");
    Expect(0, 1, '\P{^Is_Word_Break= E_Modifier}', "");
    Error('\p{Is_WB=/a/	_em}');
    Error('\P{Is_WB=/a/	_em}');
    Expect(0, 1, '\p{Is_WB=em}', "");
    Expect(1, 1, '\p{^Is_WB=em}', "");
    Expect(1, 1, '\P{Is_WB=em}', "");
    Expect(0, 1, '\P{^Is_WB=em}', "");
    Expect(0, 1, '\p{Is_WB=-em}', "");
    Expect(1, 1, '\p{^Is_WB=-em}', "");
    Expect(1, 1, '\P{Is_WB=-em}', "");
    Expect(0, 1, '\P{^Is_WB=-em}', "");
    Error('\p{Word_Break:ExtendNumLet:=}');
    Error('\P{Word_Break:ExtendNumLet:=}');
    Expect(1, 65343, '\p{Word_Break=:\AExtendNumLet\z:}', "");;
    Expect(0, 65344, '\p{Word_Break=:\AExtendNumLet\z:}', "");;
    Expect(1, 65343, '\p{Word_Break=extendnumlet}', "");
    Expect(0, 65343, '\p{^Word_Break=extendnumlet}', "");
    Expect(0, 65343, '\P{Word_Break=extendnumlet}', "");
    Expect(1, 65343, '\P{^Word_Break=extendnumlet}', "");
    Expect(0, 65344, '\p{Word_Break=extendnumlet}', "");
    Expect(1, 65344, '\p{^Word_Break=extendnumlet}', "");
    Expect(1, 65344, '\P{Word_Break=extendnumlet}', "");
    Expect(0, 65344, '\P{^Word_Break=extendnumlet}', "");
    Expect(1, 65343, '\p{Word_Break=:\Aextendnumlet\z:}', "");;
    Expect(0, 65344, '\p{Word_Break=:\Aextendnumlet\z:}', "");;
    Expect(1, 65343, '\p{Word_Break=-	ExtendNumLet}', "");
    Expect(0, 65343, '\p{^Word_Break=-	ExtendNumLet}', "");
    Expect(0, 65343, '\P{Word_Break=-	ExtendNumLet}', "");
    Expect(1, 65343, '\P{^Word_Break=-	ExtendNumLet}', "");
    Expect(0, 65344, '\p{Word_Break=-	ExtendNumLet}', "");
    Expect(1, 65344, '\p{^Word_Break=-	ExtendNumLet}', "");
    Expect(1, 65344, '\P{Word_Break=-	ExtendNumLet}', "");
    Expect(0, 65344, '\P{^Word_Break=-	ExtendNumLet}', "");
    Error('\p{WB=-:=EX}');
    Error('\P{WB=-:=EX}');
    Expect(1, 65343, '\p{WB=:\AEX\z:}', "");;
    Expect(0, 65344, '\p{WB=:\AEX\z:}', "");;
    Expect(1, 65343, '\p{WB=ex}', "");
    Expect(0, 65343, '\p{^WB=ex}', "");
    Expect(0, 65343, '\P{WB=ex}', "");
    Expect(1, 65343, '\P{^WB=ex}', "");
    Expect(0, 65344, '\p{WB=ex}', "");
    Expect(1, 65344, '\p{^WB=ex}', "");
    Expect(1, 65344, '\P{WB=ex}', "");
    Expect(0, 65344, '\P{^WB=ex}', "");
    Expect(1, 65343, '\p{WB=:\Aex\z:}', "");;
    Expect(0, 65344, '\p{WB=:\Aex\z:}', "");;
    Expect(1, 65343, '\p{WB:   _ex}', "");
    Expect(0, 65343, '\p{^WB:   _ex}', "");
    Expect(0, 65343, '\P{WB:   _ex}', "");
    Expect(1, 65343, '\P{^WB:   _ex}', "");
    Expect(0, 65344, '\p{WB:   _ex}', "");
    Expect(1, 65344, '\p{^WB:   _ex}', "");
    Expect(1, 65344, '\P{WB:   _ex}', "");
    Expect(0, 65344, '\P{^WB:   _ex}', "");
    Error('\p{Is_Word_Break::= _ExtendNumLet}');
    Error('\P{Is_Word_Break::= _ExtendNumLet}');
    Expect(1, 65343, '\p{Is_Word_Break=extendnumlet}', "");
    Expect(0, 65343, '\p{^Is_Word_Break=extendnumlet}', "");
    Expect(0, 65343, '\P{Is_Word_Break=extendnumlet}', "");
    Expect(1, 65343, '\P{^Is_Word_Break=extendnumlet}', "");
    Expect(0, 65344, '\p{Is_Word_Break=extendnumlet}', "");
    Expect(1, 65344, '\p{^Is_Word_Break=extendnumlet}', "");
    Expect(1, 65344, '\P{Is_Word_Break=extendnumlet}', "");
    Expect(0, 65344, '\P{^Is_Word_Break=extendnumlet}', "");
    Expect(1, 65343, '\p{Is_Word_Break=	 extendnumlet}', "");
    Expect(0, 65343, '\p{^Is_Word_Break=	 extendnumlet}', "");
    Expect(0, 65343, '\P{Is_Word_Break=	 extendnumlet}', "");
    Expect(1, 65343, '\P{^Is_Word_Break=	 extendnumlet}', "");
    Expect(0, 65344, '\p{Is_Word_Break=	 extendnumlet}', "");
    Expect(1, 65344, '\p{^Is_Word_Break=	 extendnumlet}', "");
    Expect(1, 65344, '\P{Is_Word_Break=	 extendnumlet}', "");
    Expect(0, 65344, '\P{^Is_Word_Break=	 extendnumlet}', "");
    Error('\p{Is_WB=/a/--EX}');
    Error('\P{Is_WB=/a/--EX}');
    Expect(1, 65343, '\p{Is_WB=ex}', "");
    Expect(0, 65343, '\p{^Is_WB=ex}', "");
    Expect(0, 65343, '\P{Is_WB=ex}', "");
    Expect(1, 65343, '\P{^Is_WB=ex}', "");
    Expect(0, 65344, '\p{Is_WB=ex}', "");
    Expect(1, 65344, '\p{^Is_WB=ex}', "");
    Expect(1, 65344, '\P{Is_WB=ex}', "");
    Expect(0, 65344, '\P{^Is_WB=ex}', "");
    Expect(1, 65343, '\p{Is_WB=  EX}', "");
    Expect(0, 65343, '\p{^Is_WB=  EX}', "");
    Expect(0, 65343, '\P{Is_WB=  EX}', "");
    Expect(1, 65343, '\P{^Is_WB=  EX}', "");
    Expect(0, 65344, '\p{Is_WB=  EX}', "");
    Expect(1, 65344, '\p{^Is_WB=  EX}', "");
    Expect(1, 65344, '\P{Is_WB=  EX}', "");
    Expect(0, 65344, '\P{^Is_WB=  EX}', "");
    Error('\p{Word_Break=_ EXTEND/a/}');
    Error('\P{Word_Break=_ EXTEND/a/}');
    Expect(1, 917999, '\p{Word_Break=:\AExtend\z:}', "");;
    Expect(0, 918000, '\p{Word_Break=:\AExtend\z:}', "");;
    Expect(1, 917999, '\p{Word_Break=extend}', "");
    Expect(0, 917999, '\p{^Word_Break=extend}', "");
    Expect(0, 917999, '\P{Word_Break=extend}', "");
    Expect(1, 917999, '\P{^Word_Break=extend}', "");
    Expect(0, 918000, '\p{Word_Break=extend}', "");
    Expect(1, 918000, '\p{^Word_Break=extend}', "");
    Expect(1, 918000, '\P{Word_Break=extend}', "");
    Expect(0, 918000, '\P{^Word_Break=extend}', "");
    Expect(1, 917999, '\p{Word_Break=:\Aextend\z:}', "");;
    Expect(0, 918000, '\p{Word_Break=:\Aextend\z:}', "");;
    Expect(1, 917999, '\p{Word_Break= _Extend}', "");
    Expect(0, 917999, '\p{^Word_Break= _Extend}', "");
    Expect(0, 917999, '\P{Word_Break= _Extend}', "");
    Expect(1, 917999, '\P{^Word_Break= _Extend}', "");
    Expect(0, 918000, '\p{Word_Break= _Extend}', "");
    Expect(1, 918000, '\p{^Word_Break= _Extend}', "");
    Expect(1, 918000, '\P{Word_Break= _Extend}', "");
    Expect(0, 918000, '\P{^Word_Break= _Extend}', "");
    Error('\p{WB=-:=Extend}');
    Error('\P{WB=-:=Extend}');
    Expect(1, 917999, '\p{WB=:\AExtend\z:}', "");;
    Expect(0, 918000, '\p{WB=:\AExtend\z:}', "");;
    Expect(1, 917999, '\p{WB=extend}', "");
    Expect(0, 917999, '\p{^WB=extend}', "");
    Expect(0, 917999, '\P{WB=extend}', "");
    Expect(1, 917999, '\P{^WB=extend}', "");
    Expect(0, 918000, '\p{WB=extend}', "");
    Expect(1, 918000, '\p{^WB=extend}', "");
    Expect(1, 918000, '\P{WB=extend}', "");
    Expect(0, 918000, '\P{^WB=extend}', "");
    Expect(1, 917999, '\p{WB=:\Aextend\z:}', "");;
    Expect(0, 918000, '\p{WB=:\Aextend\z:}', "");;
    Expect(1, 917999, '\p{WB=	Extend}', "");
    Expect(0, 917999, '\p{^WB=	Extend}', "");
    Expect(0, 917999, '\P{WB=	Extend}', "");
    Expect(1, 917999, '\P{^WB=	Extend}', "");
    Expect(0, 918000, '\p{WB=	Extend}', "");
    Expect(1, 918000, '\p{^WB=	Extend}', "");
    Expect(1, 918000, '\P{WB=	Extend}', "");
    Expect(0, 918000, '\P{^WB=	Extend}', "");
    Error('\p{Is_Word_Break=:=-_extend}');
    Error('\P{Is_Word_Break=:=-_extend}');
    Expect(1, 917999, '\p{Is_Word_Break=extend}', "");
    Expect(0, 917999, '\p{^Is_Word_Break=extend}', "");
    Expect(0, 917999, '\P{Is_Word_Break=extend}', "");
    Expect(1, 917999, '\P{^Is_Word_Break=extend}', "");
    Expect(0, 918000, '\p{Is_Word_Break=extend}', "");
    Expect(1, 918000, '\p{^Is_Word_Break=extend}', "");
    Expect(1, 918000, '\P{Is_Word_Break=extend}', "");
    Expect(0, 918000, '\P{^Is_Word_Break=extend}', "");
    Expect(1, 917999, '\p{Is_Word_Break=Extend}', "");
    Expect(0, 917999, '\p{^Is_Word_Break=Extend}', "");
    Expect(0, 917999, '\P{Is_Word_Break=Extend}', "");
    Expect(1, 917999, '\P{^Is_Word_Break=Extend}', "");
    Expect(0, 918000, '\p{Is_Word_Break=Extend}', "");
    Expect(1, 918000, '\p{^Is_Word_Break=Extend}', "");
    Expect(1, 918000, '\P{Is_Word_Break=Extend}', "");
    Expect(0, 918000, '\P{^Is_Word_Break=Extend}', "");
    Error('\p{Is_WB=:=_-EXTEND}');
    Error('\P{Is_WB=:=_-EXTEND}');
    Expect(1, 917999, '\p{Is_WB=extend}', "");
    Expect(0, 917999, '\p{^Is_WB=extend}', "");
    Expect(0, 917999, '\P{Is_WB=extend}', "");
    Expect(1, 917999, '\P{^Is_WB=extend}', "");
    Expect(0, 918000, '\p{Is_WB=extend}', "");
    Expect(1, 918000, '\p{^Is_WB=extend}', "");
    Expect(1, 918000, '\P{Is_WB=extend}', "");
    Expect(0, 918000, '\P{^Is_WB=extend}', "");
    Expect(1, 917999, '\p{Is_WB=--EXTEND}', "");
    Expect(0, 917999, '\p{^Is_WB=--EXTEND}', "");
    Expect(0, 917999, '\P{Is_WB=--EXTEND}', "");
    Expect(1, 917999, '\P{^Is_WB=--EXTEND}', "");
    Expect(0, 918000, '\p{Is_WB=--EXTEND}', "");
    Expect(1, 918000, '\p{^Is_WB=--EXTEND}', "");
    Expect(1, 918000, '\P{Is_WB=--EXTEND}', "");
    Expect(0, 918000, '\P{^Is_WB=--EXTEND}', "");
    Error('\p{Word_Break= :=Format}');
    Error('\P{Word_Break= :=Format}');
    Expect(1, 917505, '\p{Word_Break=:\AFormat\z:}', "");;
    Expect(0, 917506, '\p{Word_Break=:\AFormat\z:}', "");;
    Expect(1, 917505, '\p{Word_Break=format}', "");
    Expect(0, 917505, '\p{^Word_Break=format}', "");
    Expect(0, 917505, '\P{Word_Break=format}', "");
    Expect(1, 917505, '\P{^Word_Break=format}', "");
    Expect(0, 917506, '\p{Word_Break=format}', "");
    Expect(1, 917506, '\p{^Word_Break=format}', "");
    Expect(1, 917506, '\P{Word_Break=format}', "");
    Expect(0, 917506, '\P{^Word_Break=format}', "");
    Expect(1, 917505, '\p{Word_Break=:\Aformat\z:}', "");;
    Expect(0, 917506, '\p{Word_Break=:\Aformat\z:}', "");;
    Expect(1, 917505, '\p{Word_Break:   -format}', "");
    Expect(0, 917505, '\p{^Word_Break:   -format}', "");
    Expect(0, 917505, '\P{Word_Break:   -format}', "");
    Expect(1, 917505, '\P{^Word_Break:   -format}', "");
    Expect(0, 917506, '\p{Word_Break:   -format}', "");
    Expect(1, 917506, '\p{^Word_Break:   -format}', "");
    Expect(1, 917506, '\P{Word_Break:   -format}', "");
    Expect(0, 917506, '\P{^Word_Break:   -format}', "");
    Error('\p{WB=	-FO:=}');
    Error('\P{WB=	-FO:=}');
    Expect(1, 917505, '\p{WB=:\AFO\z:}', "");;
    Expect(0, 917506, '\p{WB=:\AFO\z:}', "");;
    Expect(1, 917505, '\p{WB: fo}', "");
    Expect(0, 917505, '\p{^WB: fo}', "");
    Expect(0, 917505, '\P{WB: fo}', "");
    Expect(1, 917505, '\P{^WB: fo}', "");
    Expect(0, 917506, '\p{WB: fo}', "");
    Expect(1, 917506, '\p{^WB: fo}', "");
    Expect(1, 917506, '\P{WB: fo}', "");
    Expect(0, 917506, '\P{^WB: fo}', "");
    Expect(1, 917505, '\p{WB=:\Afo\z:}', "");;
    Expect(0, 917506, '\p{WB=:\Afo\z:}', "");;
    Expect(1, 917505, '\p{WB=-_fo}', "");
    Expect(0, 917505, '\p{^WB=-_fo}', "");
    Expect(0, 917505, '\P{WB=-_fo}', "");
    Expect(1, 917505, '\P{^WB=-_fo}', "");
    Expect(0, 917506, '\p{WB=-_fo}', "");
    Expect(1, 917506, '\p{^WB=-_fo}', "");
    Expect(1, 917506, '\P{WB=-_fo}', "");
    Expect(0, 917506, '\P{^WB=-_fo}', "");
    Error('\p{Is_Word_Break=_/a/Format}');
    Error('\P{Is_Word_Break=_/a/Format}');
    Expect(1, 917505, '\p{Is_Word_Break=format}', "");
    Expect(0, 917505, '\p{^Is_Word_Break=format}', "");
    Expect(0, 917505, '\P{Is_Word_Break=format}', "");
    Expect(1, 917505, '\P{^Is_Word_Break=format}', "");
    Expect(0, 917506, '\p{Is_Word_Break=format}', "");
    Expect(1, 917506, '\p{^Is_Word_Break=format}', "");
    Expect(1, 917506, '\P{Is_Word_Break=format}', "");
    Expect(0, 917506, '\P{^Is_Word_Break=format}', "");
    Expect(1, 917505, '\p{Is_Word_Break: 		FORMAT}', "");
    Expect(0, 917505, '\p{^Is_Word_Break: 		FORMAT}', "");
    Expect(0, 917505, '\P{Is_Word_Break: 		FORMAT}', "");
    Expect(1, 917505, '\P{^Is_Word_Break: 		FORMAT}', "");
    Expect(0, 917506, '\p{Is_Word_Break: 		FORMAT}', "");
    Expect(1, 917506, '\p{^Is_Word_Break: 		FORMAT}', "");
    Expect(1, 917506, '\P{Is_Word_Break: 		FORMAT}', "");
    Expect(0, 917506, '\P{^Is_Word_Break: 		FORMAT}', "");
    Error('\p{Is_WB=/a/-FO}');
    Error('\P{Is_WB=/a/-FO}');
    Expect(1, 917505, '\p{Is_WB=fo}', "");
    Expect(0, 917505, '\p{^Is_WB=fo}', "");
    Expect(0, 917505, '\P{Is_WB=fo}', "");
    Expect(1, 917505, '\P{^Is_WB=fo}', "");
    Expect(0, 917506, '\p{Is_WB=fo}', "");
    Expect(1, 917506, '\p{^Is_WB=fo}', "");
    Expect(1, 917506, '\P{Is_WB=fo}', "");
    Expect(0, 917506, '\P{^Is_WB=fo}', "");
    Expect(1, 917505, '\p{Is_WB=	FO}', "");
    Expect(0, 917505, '\p{^Is_WB=	FO}', "");
    Expect(0, 917505, '\P{Is_WB=	FO}', "");
    Expect(1, 917505, '\P{^Is_WB=	FO}', "");
    Expect(0, 917506, '\p{Is_WB=	FO}', "");
    Expect(1, 917506, '\p{^Is_WB=	FO}', "");
    Expect(1, 917506, '\P{Is_WB=	FO}', "");
    Expect(0, 917506, '\P{^Is_WB=	FO}', "");
    Error('\p{Word_Break=-/a/Glue_AFTER_zwj}');
    Error('\P{Word_Break=-/a/Glue_AFTER_zwj}');
    Expect(0, 1, '\p{Word_Break=:\AGlue_After_Zwj\z:}', "");;
    Expect(0, 1, '\p{Word_Break:	glueafterzwj}', "");
    Expect(1, 1, '\p{^Word_Break:	glueafterzwj}', "");
    Expect(1, 1, '\P{Word_Break:	glueafterzwj}', "");
    Expect(0, 1, '\P{^Word_Break:	glueafterzwj}', "");
    Expect(0, 1, '\p{Word_Break=:\Aglueafterzwj\z:}', "");;
    Expect(0, 1, '\p{Word_Break=_	GLUE_After_Zwj}', "");
    Expect(1, 1, '\p{^Word_Break=_	GLUE_After_Zwj}', "");
    Expect(1, 1, '\P{Word_Break=_	GLUE_After_Zwj}', "");
    Expect(0, 1, '\P{^Word_Break=_	GLUE_After_Zwj}', "");
    Error('\p{WB=_:=GAZ}');
    Error('\P{WB=_:=GAZ}');
    Expect(0, 1, '\p{WB=:\AGAZ\z:}', "");;
    Expect(0, 1, '\p{WB=gaz}', "");
    Expect(1, 1, '\p{^WB=gaz}', "");
    Expect(1, 1, '\P{WB=gaz}', "");
    Expect(0, 1, '\P{^WB=gaz}', "");
    Expect(0, 1, '\p{WB=:\Agaz\z:}', "");;
    Expect(0, 1, '\p{WB=_gaz}', "");
    Expect(1, 1, '\p{^WB=_gaz}', "");
    Expect(1, 1, '\P{WB=_gaz}', "");
    Expect(0, 1, '\P{^WB=_gaz}', "");
    Error('\p{Is_Word_Break=/a/ -Glue_AFTER_Zwj}');
    Error('\P{Is_Word_Break=/a/ -Glue_AFTER_Zwj}');
    Expect(0, 1, '\p{Is_Word_Break=glueafterzwj}', "");
    Expect(1, 1, '\p{^Is_Word_Break=glueafterzwj}', "");
    Expect(1, 1, '\P{Is_Word_Break=glueafterzwj}', "");
    Expect(0, 1, '\P{^Is_Word_Break=glueafterzwj}', "");
    Expect(0, 1, '\p{Is_Word_Break=_	glue_AFTER_zwj}', "");
    Expect(1, 1, '\p{^Is_Word_Break=_	glue_AFTER_zwj}', "");
    Expect(1, 1, '\P{Is_Word_Break=_	glue_AFTER_zwj}', "");
    Expect(0, 1, '\P{^Is_Word_Break=_	glue_AFTER_zwj}', "");
    Error('\p{Is_WB=_ gaz:=}');
    Error('\P{Is_WB=_ gaz:=}');
    Expect(0, 1, '\p{Is_WB=gaz}', "");
    Expect(1, 1, '\p{^Is_WB=gaz}', "");
    Expect(1, 1, '\P{Is_WB=gaz}', "");
    Expect(0, 1, '\P{^Is_WB=gaz}', "");
    Expect(0, 1, '\p{Is_WB= GAZ}', "");
    Expect(1, 1, '\p{^Is_WB= GAZ}', "");
    Expect(1, 1, '\P{Is_WB= GAZ}', "");
    Expect(0, 1, '\P{^Is_WB= GAZ}', "");
    Error('\p{Word_Break=  Hebrew_LETTER:=}');
    Error('\P{Word_Break=  Hebrew_LETTER:=}');
    Expect(1, 64335, '\p{Word_Break=:\AHebrew_Letter\z:}', "");;
    Expect(0, 64336, '\p{Word_Break=:\AHebrew_Letter\z:}', "");;
    Expect(1, 64335, '\p{Word_Break=hebrewletter}', "");
    Expect(0, 64335, '\p{^Word_Break=hebrewletter}', "");
    Expect(0, 64335, '\P{Word_Break=hebrewletter}', "");
    Expect(1, 64335, '\P{^Word_Break=hebrewletter}', "");
    Expect(0, 64336, '\p{Word_Break=hebrewletter}', "");
    Expect(1, 64336, '\p{^Word_Break=hebrewletter}', "");
    Expect(1, 64336, '\P{Word_Break=hebrewletter}', "");
    Expect(0, 64336, '\P{^Word_Break=hebrewletter}', "");
    Expect(1, 64335, '\p{Word_Break=:\Ahebrewletter\z:}', "");;
    Expect(0, 64336, '\p{Word_Break=:\Ahebrewletter\z:}', "");;
    Expect(1, 64335, '\p{Word_Break=	_Hebrew_Letter}', "");
    Expect(0, 64335, '\p{^Word_Break=	_Hebrew_Letter}', "");
    Expect(0, 64335, '\P{Word_Break=	_Hebrew_Letter}', "");
    Expect(1, 64335, '\P{^Word_Break=	_Hebrew_Letter}', "");
    Expect(0, 64336, '\p{Word_Break=	_Hebrew_Letter}', "");
    Expect(1, 64336, '\p{^Word_Break=	_Hebrew_Letter}', "");
    Expect(1, 64336, '\P{Word_Break=	_Hebrew_Letter}', "");
    Expect(0, 64336, '\P{^Word_Break=	_Hebrew_Letter}', "");
    Error('\p{WB:		 HL/a/}');
    Error('\P{WB:		 HL/a/}');
    Expect(1, 64335, '\p{WB=:\AHL\z:}', "");;
    Expect(0, 64336, '\p{WB=:\AHL\z:}', "");;
    Expect(1, 64335, '\p{WB=hl}', "");
    Expect(0, 64335, '\p{^WB=hl}', "");
    Expect(0, 64335, '\P{WB=hl}', "");
    Expect(1, 64335, '\P{^WB=hl}', "");
    Expect(0, 64336, '\p{WB=hl}', "");
    Expect(1, 64336, '\p{^WB=hl}', "");
    Expect(1, 64336, '\P{WB=hl}', "");
    Expect(0, 64336, '\P{^WB=hl}', "");
    Expect(1, 64335, '\p{WB=:\Ahl\z:}', "");;
    Expect(0, 64336, '\p{WB=:\Ahl\z:}', "");;
    Expect(1, 64335, '\p{WB= -HL}', "");
    Expect(0, 64335, '\p{^WB= -HL}', "");
    Expect(0, 64335, '\P{WB= -HL}', "");
    Expect(1, 64335, '\P{^WB= -HL}', "");
    Expect(0, 64336, '\p{WB= -HL}', "");
    Expect(1, 64336, '\p{^WB= -HL}', "");
    Expect(1, 64336, '\P{WB= -HL}', "");
    Expect(0, 64336, '\P{^WB= -HL}', "");
    Error('\p{Is_Word_Break=		HEBREW_LETTER:=}');
    Error('\P{Is_Word_Break=		HEBREW_LETTER:=}');
    Expect(1, 64335, '\p{Is_Word_Break=hebrewletter}', "");
    Expect(0, 64335, '\p{^Is_Word_Break=hebrewletter}', "");
    Expect(0, 64335, '\P{Is_Word_Break=hebrewletter}', "");
    Expect(1, 64335, '\P{^Is_Word_Break=hebrewletter}', "");
    Expect(0, 64336, '\p{Is_Word_Break=hebrewletter}', "");
    Expect(1, 64336, '\p{^Is_Word_Break=hebrewletter}', "");
    Expect(1, 64336, '\P{Is_Word_Break=hebrewletter}', "");
    Expect(0, 64336, '\P{^Is_Word_Break=hebrewletter}', "");
    Expect(1, 64335, '\p{Is_Word_Break=_hebrew_letter}', "");
    Expect(0, 64335, '\p{^Is_Word_Break=_hebrew_letter}', "");
    Expect(0, 64335, '\P{Is_Word_Break=_hebrew_letter}', "");
    Expect(1, 64335, '\P{^Is_Word_Break=_hebrew_letter}', "");
    Expect(0, 64336, '\p{Is_Word_Break=_hebrew_letter}', "");
    Expect(1, 64336, '\p{^Is_Word_Break=_hebrew_letter}', "");
    Expect(1, 64336, '\P{Is_Word_Break=_hebrew_letter}', "");
    Expect(0, 64336, '\P{^Is_Word_Break=_hebrew_letter}', "");
    Error('\p{Is_WB: /a/	_hl}');
    Error('\P{Is_WB: /a/	_hl}');
    Expect(1, 64335, '\p{Is_WB=hl}', "");
    Expect(0, 64335, '\p{^Is_WB=hl}', "");
    Expect(0, 64335, '\P{Is_WB=hl}', "");
    Expect(1, 64335, '\P{^Is_WB=hl}', "");
    Expect(0, 64336, '\p{Is_WB=hl}', "");
    Expect(1, 64336, '\p{^Is_WB=hl}', "");
    Expect(1, 64336, '\P{Is_WB=hl}', "");
    Expect(0, 64336, '\P{^Is_WB=hl}', "");
    Expect(1, 64335, '\p{Is_WB=		HL}', "");
    Expect(0, 64335, '\p{^Is_WB=		HL}', "");
    Expect(0, 64335, '\P{Is_WB=		HL}', "");
    Expect(1, 64335, '\P{^Is_WB=		HL}', "");
    Expect(0, 64336, '\p{Is_WB=		HL}', "");
    Expect(1, 64336, '\p{^Is_WB=		HL}', "");
    Expect(1, 64336, '\P{Is_WB=		HL}', "");
    Expect(0, 64336, '\P{^Is_WB=		HL}', "");
    Error('\p{Word_Break=:=KATAKANA}');
    Error('\P{Word_Break=:=KATAKANA}');
    Expect(1, 110951, '\p{Word_Break=:\AKatakana\z:}', "");;
    Expect(0, 110952, '\p{Word_Break=:\AKatakana\z:}', "");;
    Expect(1, 110951, '\p{Word_Break=katakana}', "");
    Expect(0, 110951, '\p{^Word_Break=katakana}', "");
    Expect(0, 110951, '\P{Word_Break=katakana}', "");
    Expect(1, 110951, '\P{^Word_Break=katakana}', "");
    Expect(0, 110952, '\p{Word_Break=katakana}', "");
    Expect(1, 110952, '\p{^Word_Break=katakana}', "");
    Expect(1, 110952, '\P{Word_Break=katakana}', "");
    Expect(0, 110952, '\P{^Word_Break=katakana}', "");
    Expect(1, 110951, '\p{Word_Break=:\Akatakana\z:}', "");;
    Expect(0, 110952, '\p{Word_Break=:\Akatakana\z:}', "");;
    Expect(1, 110951, '\p{Word_Break=	_katakana}', "");
    Expect(0, 110951, '\p{^Word_Break=	_katakana}', "");
    Expect(0, 110951, '\P{Word_Break=	_katakana}', "");
    Expect(1, 110951, '\P{^Word_Break=	_katakana}', "");
    Expect(0, 110952, '\p{Word_Break=	_katakana}', "");
    Expect(1, 110952, '\p{^Word_Break=	_katakana}', "");
    Expect(1, 110952, '\P{Word_Break=	_katakana}', "");
    Expect(0, 110952, '\P{^Word_Break=	_katakana}', "");
    Error('\p{WB=__KA:=}');
    Error('\P{WB=__KA:=}');
    Expect(1, 110951, '\p{WB=:\AKA\z:}', "");;
    Expect(0, 110952, '\p{WB=:\AKA\z:}', "");;
    Expect(1, 110951, '\p{WB=ka}', "");
    Expect(0, 110951, '\p{^WB=ka}', "");
    Expect(0, 110951, '\P{WB=ka}', "");
    Expect(1, 110951, '\P{^WB=ka}', "");
    Expect(0, 110952, '\p{WB=ka}', "");
    Expect(1, 110952, '\p{^WB=ka}', "");
    Expect(1, 110952, '\P{WB=ka}', "");
    Expect(0, 110952, '\P{^WB=ka}', "");
    Expect(1, 110951, '\p{WB=:\Aka\z:}', "");;
    Expect(0, 110952, '\p{WB=:\Aka\z:}', "");;
    Expect(1, 110951, '\p{WB:    _KA}', "");
    Expect(0, 110951, '\p{^WB:    _KA}', "");
    Expect(0, 110951, '\P{WB:    _KA}', "");
    Expect(1, 110951, '\P{^WB:    _KA}', "");
    Expect(0, 110952, '\p{WB:    _KA}', "");
    Expect(1, 110952, '\p{^WB:    _KA}', "");
    Expect(1, 110952, '\P{WB:    _KA}', "");
    Expect(0, 110952, '\P{^WB:    _KA}', "");
    Error('\p{Is_Word_Break:   :=		Katakana}');
    Error('\P{Is_Word_Break:   :=		Katakana}');
    Expect(1, 110951, '\p{Is_Word_Break:katakana}', "");
    Expect(0, 110951, '\p{^Is_Word_Break:katakana}', "");
    Expect(0, 110951, '\P{Is_Word_Break:katakana}', "");
    Expect(1, 110951, '\P{^Is_Word_Break:katakana}', "");
    Expect(0, 110952, '\p{Is_Word_Break:katakana}', "");
    Expect(1, 110952, '\p{^Is_Word_Break:katakana}', "");
    Expect(1, 110952, '\P{Is_Word_Break:katakana}', "");
    Expect(0, 110952, '\P{^Is_Word_Break:katakana}', "");
    Expect(1, 110951, '\p{Is_Word_Break=- KATAKANA}', "");
    Expect(0, 110951, '\p{^Is_Word_Break=- KATAKANA}', "");
    Expect(0, 110951, '\P{Is_Word_Break=- KATAKANA}', "");
    Expect(1, 110951, '\P{^Is_Word_Break=- KATAKANA}', "");
    Expect(0, 110952, '\p{Is_Word_Break=- KATAKANA}', "");
    Expect(1, 110952, '\p{^Is_Word_Break=- KATAKANA}', "");
    Expect(1, 110952, '\P{Is_Word_Break=- KATAKANA}', "");
    Expect(0, 110952, '\P{^Is_Word_Break=- KATAKANA}', "");
    Error('\p{Is_WB= ka:=}');
    Error('\P{Is_WB= ka:=}');
    Expect(1, 110951, '\p{Is_WB=ka}', "");
    Expect(0, 110951, '\p{^Is_WB=ka}', "");
    Expect(0, 110951, '\P{Is_WB=ka}', "");
    Expect(1, 110951, '\P{^Is_WB=ka}', "");
    Expect(0, 110952, '\p{Is_WB=ka}', "");
    Expect(1, 110952, '\p{^Is_WB=ka}', "");
    Expect(1, 110952, '\P{Is_WB=ka}', "");
    Expect(0, 110952, '\P{^Is_WB=ka}', "");
    Expect(1, 110951, '\p{Is_WB=__KA}', "");
    Expect(0, 110951, '\p{^Is_WB=__KA}', "");
    Expect(0, 110951, '\P{Is_WB=__KA}', "");
    Expect(1, 110951, '\P{^Is_WB=__KA}', "");
    Expect(0, 110952, '\p{Is_WB=__KA}', "");
    Expect(1, 110952, '\p{^Is_WB=__KA}', "");
    Expect(1, 110952, '\P{Is_WB=__KA}', "");
    Expect(0, 110952, '\P{^Is_WB=__KA}', "");
    Error('\p{Word_Break=:=_	ALetter}');
    Error('\P{Word_Break=:=_	ALetter}');
    Expect(1, 127369, '\p{Word_Break=:\AALetter\z:}', "");;
    Expect(0, 127370, '\p{Word_Break=:\AALetter\z:}', "");;
    Expect(1, 127369, '\p{Word_Break:   aletter}', "");
    Expect(0, 127369, '\p{^Word_Break:   aletter}', "");
    Expect(0, 127369, '\P{Word_Break:   aletter}', "");
    Expect(1, 127369, '\P{^Word_Break:   aletter}', "");
    Expect(0, 127370, '\p{Word_Break:   aletter}', "");
    Expect(1, 127370, '\p{^Word_Break:   aletter}', "");
    Expect(1, 127370, '\P{Word_Break:   aletter}', "");
    Expect(0, 127370, '\P{^Word_Break:   aletter}', "");
    Expect(1, 127369, '\p{Word_Break=:\Aaletter\z:}', "");;
    Expect(0, 127370, '\p{Word_Break=:\Aaletter\z:}', "");;
    Expect(1, 127369, '\p{Word_Break=	_aletter}', "");
    Expect(0, 127369, '\p{^Word_Break=	_aletter}', "");
    Expect(0, 127369, '\P{Word_Break=	_aletter}', "");
    Expect(1, 127369, '\P{^Word_Break=	_aletter}', "");
    Expect(0, 127370, '\p{Word_Break=	_aletter}', "");
    Expect(1, 127370, '\p{^Word_Break=	_aletter}', "");
    Expect(1, 127370, '\P{Word_Break=	_aletter}', "");
    Expect(0, 127370, '\P{^Word_Break=	_aletter}', "");
    Error('\p{WB=/a/ 	LE}');
    Error('\P{WB=/a/ 	LE}');
    Expect(1, 127369, '\p{WB=:\ALE\z:}', "");;
    Expect(0, 127370, '\p{WB=:\ALE\z:}', "");;
    Expect(1, 127369, '\p{WB=le}', "");
    Expect(0, 127369, '\p{^WB=le}', "");
    Expect(0, 127369, '\P{WB=le}', "");
    Expect(1, 127369, '\P{^WB=le}', "");
    Expect(0, 127370, '\p{WB=le}', "");
    Expect(1, 127370, '\p{^WB=le}', "");
    Expect(1, 127370, '\P{WB=le}', "");
    Expect(0, 127370, '\P{^WB=le}', "");
    Expect(1, 127369, '\p{WB=:\Ale\z:}', "");;
    Expect(0, 127370, '\p{WB=:\Ale\z:}', "");;
    Error('\p{Is_Word_Break=/a/ 	ALETTER}');
    Error('\P{Is_Word_Break=/a/ 	ALETTER}');
    Expect(1, 127369, '\p{Is_Word_Break=aletter}', "");
    Expect(0, 127369, '\p{^Is_Word_Break=aletter}', "");
    Expect(0, 127369, '\P{Is_Word_Break=aletter}', "");
    Expect(1, 127369, '\P{^Is_Word_Break=aletter}', "");
    Expect(0, 127370, '\p{Is_Word_Break=aletter}', "");
    Expect(1, 127370, '\p{^Is_Word_Break=aletter}', "");
    Expect(1, 127370, '\P{Is_Word_Break=aletter}', "");
    Expect(0, 127370, '\P{^Is_Word_Break=aletter}', "");
    Expect(1, 127369, '\p{Is_Word_Break=	 ALetter}', "");
    Expect(0, 127369, '\p{^Is_Word_Break=	 ALetter}', "");
    Expect(0, 127369, '\P{Is_Word_Break=	 ALetter}', "");
    Expect(1, 127369, '\P{^Is_Word_Break=	 ALetter}', "");
    Expect(0, 127370, '\p{Is_Word_Break=	 ALetter}', "");
    Expect(1, 127370, '\p{^Is_Word_Break=	 ALetter}', "");
    Expect(1, 127370, '\P{Is_Word_Break=	 ALetter}', "");
    Expect(0, 127370, '\P{^Is_Word_Break=	 ALetter}', "");
    Error('\p{Is_WB=/a/LE}');
    Error('\P{Is_WB=/a/LE}');
    Expect(1, 127369, '\p{Is_WB:   le}', "");
    Expect(0, 127369, '\p{^Is_WB:   le}', "");
    Expect(0, 127369, '\P{Is_WB:   le}', "");
    Expect(1, 127369, '\P{^Is_WB:   le}', "");
    Expect(0, 127370, '\p{Is_WB:   le}', "");
    Expect(1, 127370, '\p{^Is_WB:   le}', "");
    Expect(1, 127370, '\P{Is_WB:   le}', "");
    Expect(0, 127370, '\P{^Is_WB:   le}', "");
    Expect(1, 127369, '\p{Is_WB=_LE}', "");
    Expect(0, 127369, '\p{^Is_WB=_LE}', "");
    Expect(0, 127369, '\P{Is_WB=_LE}', "");
    Expect(1, 127369, '\P{^Is_WB=_LE}', "");
    Expect(0, 127370, '\p{Is_WB=_LE}', "");
    Expect(1, 127370, '\p{^Is_WB=_LE}', "");
    Expect(1, 127370, '\P{Is_WB=_LE}', "");
    Expect(0, 127370, '\P{^Is_WB=_LE}', "");
    Error('\p{Word_Break=-:=LF}');
    Error('\P{Word_Break=-:=LF}');
    Expect(1, 10, '\p{Word_Break=:\ALF\z:}', "");;
    Expect(0, 11, '\p{Word_Break=:\ALF\z:}', "");;
    Expect(1, 10, '\p{Word_Break=lf}', "");
    Expect(0, 10, '\p{^Word_Break=lf}', "");
    Expect(0, 10, '\P{Word_Break=lf}', "");
    Expect(1, 10, '\P{^Word_Break=lf}', "");
    Expect(0, 11, '\p{Word_Break=lf}', "");
    Expect(1, 11, '\p{^Word_Break=lf}', "");
    Expect(1, 11, '\P{Word_Break=lf}', "");
    Expect(0, 11, '\P{^Word_Break=lf}', "");
    Expect(1, 10, '\p{Word_Break=:\Alf\z:}', "");;
    Expect(0, 11, '\p{Word_Break=:\Alf\z:}', "");;
    Expect(1, 10, '\p{Word_Break=-lf}', "");
    Expect(0, 10, '\p{^Word_Break=-lf}', "");
    Expect(0, 10, '\P{Word_Break=-lf}', "");
    Expect(1, 10, '\P{^Word_Break=-lf}', "");
    Expect(0, 11, '\p{Word_Break=-lf}', "");
    Expect(1, 11, '\p{^Word_Break=-lf}', "");
    Expect(1, 11, '\P{Word_Break=-lf}', "");
    Expect(0, 11, '\P{^Word_Break=-lf}', "");
    Error('\p{WB=__LF/a/}');
    Error('\P{WB=__LF/a/}');
    Expect(1, 10, '\p{WB=:\ALF\z:}', "");;
    Expect(0, 11, '\p{WB=:\ALF\z:}', "");;
    Expect(1, 10, '\p{WB=lf}', "");
    Expect(0, 10, '\p{^WB=lf}', "");
    Expect(0, 10, '\P{WB=lf}', "");
    Expect(1, 10, '\P{^WB=lf}', "");
    Expect(0, 11, '\p{WB=lf}', "");
    Expect(1, 11, '\p{^WB=lf}', "");
    Expect(1, 11, '\P{WB=lf}', "");
    Expect(0, 11, '\P{^WB=lf}', "");
    Expect(1, 10, '\p{WB=:\Alf\z:}', "");;
    Expect(0, 11, '\p{WB=:\Alf\z:}', "");;
    Expect(1, 10, '\p{WB=_LF}', "");
    Expect(0, 10, '\p{^WB=_LF}', "");
    Expect(0, 10, '\P{WB=_LF}', "");
    Expect(1, 10, '\P{^WB=_LF}', "");
    Expect(0, 11, '\p{WB=_LF}', "");
    Expect(1, 11, '\p{^WB=_LF}', "");
    Expect(1, 11, '\P{WB=_LF}', "");
    Expect(0, 11, '\P{^WB=_LF}', "");
    Error('\p{Is_Word_Break=--LF/a/}');
    Error('\P{Is_Word_Break=--LF/a/}');
    Expect(1, 10, '\p{Is_Word_Break=lf}', "");
    Expect(0, 10, '\p{^Is_Word_Break=lf}', "");
    Expect(0, 10, '\P{Is_Word_Break=lf}', "");
    Expect(1, 10, '\P{^Is_Word_Break=lf}', "");
    Expect(0, 11, '\p{Is_Word_Break=lf}', "");
    Expect(1, 11, '\p{^Is_Word_Break=lf}', "");
    Expect(1, 11, '\P{Is_Word_Break=lf}', "");
    Expect(0, 11, '\P{^Is_Word_Break=lf}', "");
    Expect(1, 10, '\p{Is_Word_Break:	_	LF}', "");
    Expect(0, 10, '\p{^Is_Word_Break:	_	LF}', "");
    Expect(0, 10, '\P{Is_Word_Break:	_	LF}', "");
    Expect(1, 10, '\P{^Is_Word_Break:	_	LF}', "");
    Expect(0, 11, '\p{Is_Word_Break:	_	LF}', "");
    Expect(1, 11, '\p{^Is_Word_Break:	_	LF}', "");
    Expect(1, 11, '\P{Is_Word_Break:	_	LF}', "");
    Expect(0, 11, '\P{^Is_Word_Break:	_	LF}', "");
    Error('\p{Is_WB=--LF:=}');
    Error('\P{Is_WB=--LF:=}');
    Expect(1, 10, '\p{Is_WB=lf}', "");
    Expect(0, 10, '\p{^Is_WB=lf}', "");
    Expect(0, 10, '\P{Is_WB=lf}', "");
    Expect(1, 10, '\P{^Is_WB=lf}', "");
    Expect(0, 11, '\p{Is_WB=lf}', "");
    Expect(1, 11, '\p{^Is_WB=lf}', "");
    Expect(1, 11, '\P{Is_WB=lf}', "");
    Expect(0, 11, '\P{^Is_WB=lf}', "");
    Expect(1, 10, '\p{Is_WB=_	lf}', "");
    Expect(0, 10, '\p{^Is_WB=_	lf}', "");
    Expect(0, 10, '\P{Is_WB=_	lf}', "");
    Expect(1, 10, '\P{^Is_WB=_	lf}', "");
    Expect(0, 11, '\p{Is_WB=_	lf}', "");
    Expect(1, 11, '\p{^Is_WB=_	lf}', "");
    Expect(1, 11, '\P{Is_WB=_	lf}', "");
    Expect(0, 11, '\P{^Is_WB=_	lf}', "");
    Error('\p{Word_Break:	/a/-MidNumLet}');
    Error('\P{Word_Break:	/a/-MidNumLet}');
    Expect(1, 65294, '\p{Word_Break=:\AMidNumLet\z:}', "");;
    Expect(0, 65295, '\p{Word_Break=:\AMidNumLet\z:}', "");;
    Expect(1, 65294, '\p{Word_Break=midnumlet}', "");
    Expect(0, 65294, '\p{^Word_Break=midnumlet}', "");
    Expect(0, 65294, '\P{Word_Break=midnumlet}', "");
    Expect(1, 65294, '\P{^Word_Break=midnumlet}', "");
    Expect(0, 65295, '\p{Word_Break=midnumlet}', "");
    Expect(1, 65295, '\p{^Word_Break=midnumlet}', "");
    Expect(1, 65295, '\P{Word_Break=midnumlet}', "");
    Expect(0, 65295, '\P{^Word_Break=midnumlet}', "");
    Expect(1, 65294, '\p{Word_Break=:\Amidnumlet\z:}', "");;
    Expect(0, 65295, '\p{Word_Break=:\Amidnumlet\z:}', "");;
    Expect(1, 65294, '\p{Word_Break=	_midnumlet}', "");
    Expect(0, 65294, '\p{^Word_Break=	_midnumlet}', "");
    Expect(0, 65294, '\P{Word_Break=	_midnumlet}', "");
    Expect(1, 65294, '\P{^Word_Break=	_midnumlet}', "");
    Expect(0, 65295, '\p{Word_Break=	_midnumlet}', "");
    Expect(1, 65295, '\p{^Word_Break=	_midnumlet}', "");
    Expect(1, 65295, '\P{Word_Break=	_midnumlet}', "");
    Expect(0, 65295, '\P{^Word_Break=	_midnumlet}', "");
    Error('\p{WB= -MB:=}');
    Error('\P{WB= -MB:=}');
    Expect(1, 65294, '\p{WB=:\AMB\z:}', "");;
    Expect(0, 65295, '\p{WB=:\AMB\z:}', "");;
    Expect(1, 65294, '\p{WB:   mb}', "");
    Expect(0, 65294, '\p{^WB:   mb}', "");
    Expect(0, 65294, '\P{WB:   mb}', "");
    Expect(1, 65294, '\P{^WB:   mb}', "");
    Expect(0, 65295, '\p{WB:   mb}', "");
    Expect(1, 65295, '\p{^WB:   mb}', "");
    Expect(1, 65295, '\P{WB:   mb}', "");
    Expect(0, 65295, '\P{^WB:   mb}', "");
    Expect(1, 65294, '\p{WB=:\Amb\z:}', "");;
    Expect(0, 65295, '\p{WB=:\Amb\z:}', "");;
    Expect(1, 65294, '\p{WB=-_mb}', "");
    Expect(0, 65294, '\p{^WB=-_mb}', "");
    Expect(0, 65294, '\P{WB=-_mb}', "");
    Expect(1, 65294, '\P{^WB=-_mb}', "");
    Expect(0, 65295, '\p{WB=-_mb}', "");
    Expect(1, 65295, '\p{^WB=-_mb}', "");
    Expect(1, 65295, '\P{WB=-_mb}', "");
    Expect(0, 65295, '\P{^WB=-_mb}', "");
    Error('\p{Is_Word_Break=:=_ MIDNUMLET}');
    Error('\P{Is_Word_Break=:=_ MIDNUMLET}');
    Expect(1, 65294, '\p{Is_Word_Break=midnumlet}', "");
    Expect(0, 65294, '\p{^Is_Word_Break=midnumlet}', "");
    Expect(0, 65294, '\P{Is_Word_Break=midnumlet}', "");
    Expect(1, 65294, '\P{^Is_Word_Break=midnumlet}', "");
    Expect(0, 65295, '\p{Is_Word_Break=midnumlet}', "");
    Expect(1, 65295, '\p{^Is_Word_Break=midnumlet}', "");
    Expect(1, 65295, '\P{Is_Word_Break=midnumlet}', "");
    Expect(0, 65295, '\P{^Is_Word_Break=midnumlet}', "");
    Expect(1, 65294, '\p{Is_Word_Break=_-MidNumLet}', "");
    Expect(0, 65294, '\p{^Is_Word_Break=_-MidNumLet}', "");
    Expect(0, 65294, '\P{Is_Word_Break=_-MidNumLet}', "");
    Expect(1, 65294, '\P{^Is_Word_Break=_-MidNumLet}', "");
    Expect(0, 65295, '\p{Is_Word_Break=_-MidNumLet}', "");
    Expect(1, 65295, '\p{^Is_Word_Break=_-MidNumLet}', "");
    Expect(1, 65295, '\P{Is_Word_Break=_-MidNumLet}', "");
    Expect(0, 65295, '\P{^Is_Word_Break=_-MidNumLet}', "");
    Error('\p{Is_WB=	 MB:=}');
    Error('\P{Is_WB=	 MB:=}');
    Expect(1, 65294, '\p{Is_WB=mb}', "");
    Expect(0, 65294, '\p{^Is_WB=mb}', "");
    Expect(0, 65294, '\P{Is_WB=mb}', "");
    Expect(1, 65294, '\P{^Is_WB=mb}', "");
    Expect(0, 65295, '\p{Is_WB=mb}', "");
    Expect(1, 65295, '\p{^Is_WB=mb}', "");
    Expect(1, 65295, '\P{Is_WB=mb}', "");
    Expect(0, 65295, '\P{^Is_WB=mb}', "");
    Expect(1, 65294, '\p{Is_WB=-	MB}', "");
    Expect(0, 65294, '\p{^Is_WB=-	MB}', "");
    Expect(0, 65294, '\P{Is_WB=-	MB}', "");
    Expect(1, 65294, '\P{^Is_WB=-	MB}', "");
    Expect(0, 65295, '\p{Is_WB=-	MB}', "");
    Expect(1, 65295, '\p{^Is_WB=-	MB}', "");
    Expect(1, 65295, '\P{Is_WB=-	MB}', "");
    Expect(0, 65295, '\P{^Is_WB=-	MB}', "");
    Error('\p{Word_Break: /a/midletter}');
    Error('\P{Word_Break: /a/midletter}');
    Expect(1, 65306, '\p{Word_Break=:\AMidLetter\z:}', "");;
    Expect(0, 65307, '\p{Word_Break=:\AMidLetter\z:}', "");;
    Expect(1, 65306, '\p{Word_Break=midletter}', "");
    Expect(0, 65306, '\p{^Word_Break=midletter}', "");
    Expect(0, 65306, '\P{Word_Break=midletter}', "");
    Expect(1, 65306, '\P{^Word_Break=midletter}', "");
    Expect(0, 65307, '\p{Word_Break=midletter}', "");
    Expect(1, 65307, '\p{^Word_Break=midletter}', "");
    Expect(1, 65307, '\P{Word_Break=midletter}', "");
    Expect(0, 65307, '\P{^Word_Break=midletter}', "");
    Expect(1, 65306, '\p{Word_Break=:\Amidletter\z:}', "");;
    Expect(0, 65307, '\p{Word_Break=:\Amidletter\z:}', "");;
    Expect(1, 65306, '\p{Word_Break=-_MidLetter}', "");
    Expect(0, 65306, '\p{^Word_Break=-_MidLetter}', "");
    Expect(0, 65306, '\P{Word_Break=-_MidLetter}', "");
    Expect(1, 65306, '\P{^Word_Break=-_MidLetter}', "");
    Expect(0, 65307, '\p{Word_Break=-_MidLetter}', "");
    Expect(1, 65307, '\p{^Word_Break=-_MidLetter}', "");
    Expect(1, 65307, '\P{Word_Break=-_MidLetter}', "");
    Expect(0, 65307, '\P{^Word_Break=-_MidLetter}', "");
    Error('\p{WB=/a/-ML}');
    Error('\P{WB=/a/-ML}');
    Expect(1, 65306, '\p{WB=:\AML\z:}', "");;
    Expect(0, 65307, '\p{WB=:\AML\z:}', "");;
    Expect(1, 65306, '\p{WB=ml}', "");
    Expect(0, 65306, '\p{^WB=ml}', "");
    Expect(0, 65306, '\P{WB=ml}', "");
    Expect(1, 65306, '\P{^WB=ml}', "");
    Expect(0, 65307, '\p{WB=ml}', "");
    Expect(1, 65307, '\p{^WB=ml}', "");
    Expect(1, 65307, '\P{WB=ml}', "");
    Expect(0, 65307, '\P{^WB=ml}', "");
    Expect(1, 65306, '\p{WB=:\Aml\z:}', "");;
    Expect(0, 65307, '\p{WB=:\Aml\z:}', "");;
    Expect(1, 65306, '\p{WB=	 ml}', "");
    Expect(0, 65306, '\p{^WB=	 ml}', "");
    Expect(0, 65306, '\P{WB=	 ml}', "");
    Expect(1, 65306, '\P{^WB=	 ml}', "");
    Expect(0, 65307, '\p{WB=	 ml}', "");
    Expect(1, 65307, '\p{^WB=	 ml}', "");
    Expect(1, 65307, '\P{WB=	 ml}', "");
    Expect(0, 65307, '\P{^WB=	 ml}', "");
    Error('\p{Is_Word_Break=:=MidLetter}');
    Error('\P{Is_Word_Break=:=MidLetter}');
    Expect(1, 65306, '\p{Is_Word_Break:	midletter}', "");
    Expect(0, 65306, '\p{^Is_Word_Break:	midletter}', "");
    Expect(0, 65306, '\P{Is_Word_Break:	midletter}', "");
    Expect(1, 65306, '\P{^Is_Word_Break:	midletter}', "");
    Expect(0, 65307, '\p{Is_Word_Break:	midletter}', "");
    Expect(1, 65307, '\p{^Is_Word_Break:	midletter}', "");
    Expect(1, 65307, '\P{Is_Word_Break:	midletter}', "");
    Expect(0, 65307, '\P{^Is_Word_Break:	midletter}', "");
    Expect(1, 65306, '\p{Is_Word_Break=	MIDLETTER}', "");
    Expect(0, 65306, '\p{^Is_Word_Break=	MIDLETTER}', "");
    Expect(0, 65306, '\P{Is_Word_Break=	MIDLETTER}', "");
    Expect(1, 65306, '\P{^Is_Word_Break=	MIDLETTER}', "");
    Expect(0, 65307, '\p{Is_Word_Break=	MIDLETTER}', "");
    Expect(1, 65307, '\p{^Is_Word_Break=	MIDLETTER}', "");
    Expect(1, 65307, '\P{Is_Word_Break=	MIDLETTER}', "");
    Expect(0, 65307, '\P{^Is_Word_Break=	MIDLETTER}', "");
    Error('\p{Is_WB:   -:=ML}');
    Error('\P{Is_WB:   -:=ML}');
    Expect(1, 65306, '\p{Is_WB:	ml}', "");
    Expect(0, 65306, '\p{^Is_WB:	ml}', "");
    Expect(0, 65306, '\P{Is_WB:	ml}', "");
    Expect(1, 65306, '\P{^Is_WB:	ml}', "");
    Expect(0, 65307, '\p{Is_WB:	ml}', "");
    Expect(1, 65307, '\p{^Is_WB:	ml}', "");
    Expect(1, 65307, '\P{Is_WB:	ml}', "");
    Expect(0, 65307, '\P{^Is_WB:	ml}', "");
    Expect(1, 65306, '\p{Is_WB=_ML}', "");
    Expect(0, 65306, '\p{^Is_WB=_ML}', "");
    Expect(0, 65306, '\P{Is_WB=_ML}', "");
    Expect(1, 65306, '\P{^Is_WB=_ML}', "");
    Expect(0, 65307, '\p{Is_WB=_ML}', "");
    Expect(1, 65307, '\p{^Is_WB=_ML}', "");
    Expect(1, 65307, '\P{Is_WB=_ML}', "");
    Expect(0, 65307, '\P{^Is_WB=_ML}', "");
    Error('\p{Word_Break:   :=MidNum}');
    Error('\P{Word_Break:   :=MidNum}');
    Expect(1, 65307, '\p{Word_Break=:\AMidNum\z:}', "");;
    Expect(0, 65308, '\p{Word_Break=:\AMidNum\z:}', "");;
    Expect(1, 65307, '\p{Word_Break=midnum}', "");
    Expect(0, 65307, '\p{^Word_Break=midnum}', "");
    Expect(0, 65307, '\P{Word_Break=midnum}', "");
    Expect(1, 65307, '\P{^Word_Break=midnum}', "");
    Expect(0, 65308, '\p{Word_Break=midnum}', "");
    Expect(1, 65308, '\p{^Word_Break=midnum}', "");
    Expect(1, 65308, '\P{Word_Break=midnum}', "");
    Expect(0, 65308, '\P{^Word_Break=midnum}', "");
    Expect(1, 65307, '\p{Word_Break=:\Amidnum\z:}', "");;
    Expect(0, 65308, '\p{Word_Break=:\Amidnum\z:}', "");;
    Expect(1, 65307, '\p{Word_Break=_MIDNUM}', "");
    Expect(0, 65307, '\p{^Word_Break=_MIDNUM}', "");
    Expect(0, 65307, '\P{Word_Break=_MIDNUM}', "");
    Expect(1, 65307, '\P{^Word_Break=_MIDNUM}', "");
    Expect(0, 65308, '\p{Word_Break=_MIDNUM}', "");
    Expect(1, 65308, '\p{^Word_Break=_MIDNUM}', "");
    Expect(1, 65308, '\P{Word_Break=_MIDNUM}', "");
    Expect(0, 65308, '\P{^Word_Break=_MIDNUM}', "");
    Error('\p{WB=/a/__mn}');
    Error('\P{WB=/a/__mn}');
    Expect(1, 65307, '\p{WB=:\AMN\z:}', "");;
    Expect(0, 65308, '\p{WB=:\AMN\z:}', "");;
    Expect(1, 65307, '\p{WB: mn}', "");
    Expect(0, 65307, '\p{^WB: mn}', "");
    Expect(0, 65307, '\P{WB: mn}', "");
    Expect(1, 65307, '\P{^WB: mn}', "");
    Expect(0, 65308, '\p{WB: mn}', "");
    Expect(1, 65308, '\p{^WB: mn}', "");
    Expect(1, 65308, '\P{WB: mn}', "");
    Expect(0, 65308, '\P{^WB: mn}', "");
    Expect(1, 65307, '\p{WB=:\Amn\z:}', "");;
    Expect(0, 65308, '\p{WB=:\Amn\z:}', "");;
    Expect(1, 65307, '\p{WB=_	MN}', "");
    Expect(0, 65307, '\p{^WB=_	MN}', "");
    Expect(0, 65307, '\P{WB=_	MN}', "");
    Expect(1, 65307, '\P{^WB=_	MN}', "");
    Expect(0, 65308, '\p{WB=_	MN}', "");
    Expect(1, 65308, '\p{^WB=_	MN}', "");
    Expect(1, 65308, '\P{WB=_	MN}', "");
    Expect(0, 65308, '\P{^WB=_	MN}', "");
    Error('\p{Is_Word_Break= midnum/a/}');
    Error('\P{Is_Word_Break= midnum/a/}');
    Expect(1, 65307, '\p{Is_Word_Break=midnum}', "");
    Expect(0, 65307, '\p{^Is_Word_Break=midnum}', "");
    Expect(0, 65307, '\P{Is_Word_Break=midnum}', "");
    Expect(1, 65307, '\P{^Is_Word_Break=midnum}', "");
    Expect(0, 65308, '\p{Is_Word_Break=midnum}', "");
    Expect(1, 65308, '\p{^Is_Word_Break=midnum}', "");
    Expect(1, 65308, '\P{Is_Word_Break=midnum}', "");
    Expect(0, 65308, '\P{^Is_Word_Break=midnum}', "");
    Expect(1, 65307, '\p{Is_Word_Break=-MidNum}', "");
    Expect(0, 65307, '\p{^Is_Word_Break=-MidNum}', "");
    Expect(0, 65307, '\P{Is_Word_Break=-MidNum}', "");
    Expect(1, 65307, '\P{^Is_Word_Break=-MidNum}', "");
    Expect(0, 65308, '\p{Is_Word_Break=-MidNum}', "");
    Expect(1, 65308, '\p{^Is_Word_Break=-MidNum}', "");
    Expect(1, 65308, '\P{Is_Word_Break=-MidNum}', "");
    Expect(0, 65308, '\P{^Is_Word_Break=-MidNum}', "");
    Error('\p{Is_WB=-/a/MN}');
    Error('\P{Is_WB=-/a/MN}');
    Expect(1, 65307, '\p{Is_WB=mn}', "");
    Expect(0, 65307, '\p{^Is_WB=mn}', "");
    Expect(0, 65307, '\P{Is_WB=mn}', "");
    Expect(1, 65307, '\P{^Is_WB=mn}', "");
    Expect(0, 65308, '\p{Is_WB=mn}', "");
    Expect(1, 65308, '\p{^Is_WB=mn}', "");
    Expect(1, 65308, '\P{Is_WB=mn}', "");
    Expect(0, 65308, '\P{^Is_WB=mn}', "");
    Expect(1, 65307, '\p{Is_WB=-	MN}', "");
    Expect(0, 65307, '\p{^Is_WB=-	MN}', "");
    Expect(0, 65307, '\P{Is_WB=-	MN}', "");
    Expect(1, 65307, '\P{^Is_WB=-	MN}', "");
    Expect(0, 65308, '\p{Is_WB=-	MN}', "");
    Expect(1, 65308, '\p{^Is_WB=-	MN}', "");
    Expect(1, 65308, '\P{Is_WB=-	MN}', "");
    Expect(0, 65308, '\P{^Is_WB=-	MN}', "");
    Error('\p{Word_Break=--Newline/a/}');
    Error('\P{Word_Break=--Newline/a/}');
    Expect(1, 8233, '\p{Word_Break=:\ANewline\z:}', "");;
    Expect(0, 8234, '\p{Word_Break=:\ANewline\z:}', "");;
    Expect(1, 8233, '\p{Word_Break=newline}', "");
    Expect(0, 8233, '\p{^Word_Break=newline}', "");
    Expect(0, 8233, '\P{Word_Break=newline}', "");
    Expect(1, 8233, '\P{^Word_Break=newline}', "");
    Expect(0, 8234, '\p{Word_Break=newline}', "");
    Expect(1, 8234, '\p{^Word_Break=newline}', "");
    Expect(1, 8234, '\P{Word_Break=newline}', "");
    Expect(0, 8234, '\P{^Word_Break=newline}', "");
    Expect(1, 8233, '\p{Word_Break=:\Anewline\z:}', "");;
    Expect(0, 8234, '\p{Word_Break=:\Anewline\z:}', "");;
    Expect(1, 8233, '\p{Word_Break=_newline}', "");
    Expect(0, 8233, '\p{^Word_Break=_newline}', "");
    Expect(0, 8233, '\P{Word_Break=_newline}', "");
    Expect(1, 8233, '\P{^Word_Break=_newline}', "");
    Expect(0, 8234, '\p{Word_Break=_newline}', "");
    Expect(1, 8234, '\p{^Word_Break=_newline}', "");
    Expect(1, 8234, '\P{Word_Break=_newline}', "");
    Expect(0, 8234, '\P{^Word_Break=_newline}', "");
    Error('\p{WB=/a/NL}');
    Error('\P{WB=/a/NL}');
    Expect(1, 8233, '\p{WB=:\ANL\z:}', "");;
    Expect(0, 8234, '\p{WB=:\ANL\z:}', "");;
    Expect(1, 8233, '\p{WB=nl}', "");
    Expect(0, 8233, '\p{^WB=nl}', "");
    Expect(0, 8233, '\P{WB=nl}', "");
    Expect(1, 8233, '\P{^WB=nl}', "");
    Expect(0, 8234, '\p{WB=nl}', "");
    Expect(1, 8234, '\p{^WB=nl}', "");
    Expect(1, 8234, '\P{WB=nl}', "");
    Expect(0, 8234, '\P{^WB=nl}', "");
    Expect(1, 8233, '\p{WB=:\Anl\z:}', "");;
    Expect(0, 8234, '\p{WB=:\Anl\z:}', "");;
    Expect(1, 8233, '\p{WB=-nl}', "");
    Expect(0, 8233, '\p{^WB=-nl}', "");
    Expect(0, 8233, '\P{WB=-nl}', "");
    Expect(1, 8233, '\P{^WB=-nl}', "");
    Expect(0, 8234, '\p{WB=-nl}', "");
    Expect(1, 8234, '\p{^WB=-nl}', "");
    Expect(1, 8234, '\P{WB=-nl}', "");
    Expect(0, 8234, '\P{^WB=-nl}', "");
    Error('\p{Is_Word_Break=	/a/Newline}');
    Error('\P{Is_Word_Break=	/a/Newline}');
    Expect(1, 8233, '\p{Is_Word_Break=newline}', "");
    Expect(0, 8233, '\p{^Is_Word_Break=newline}', "");
    Expect(0, 8233, '\P{Is_Word_Break=newline}', "");
    Expect(1, 8233, '\P{^Is_Word_Break=newline}', "");
    Expect(0, 8234, '\p{Is_Word_Break=newline}', "");
    Expect(1, 8234, '\p{^Is_Word_Break=newline}', "");
    Expect(1, 8234, '\P{Is_Word_Break=newline}', "");
    Expect(0, 8234, '\P{^Is_Word_Break=newline}', "");
    Expect(1, 8233, '\p{Is_Word_Break=-newline}', "");
    Expect(0, 8233, '\p{^Is_Word_Break=-newline}', "");
    Expect(0, 8233, '\P{Is_Word_Break=-newline}', "");
    Expect(1, 8233, '\P{^Is_Word_Break=-newline}', "");
    Expect(0, 8234, '\p{Is_Word_Break=-newline}', "");
    Expect(1, 8234, '\p{^Is_Word_Break=-newline}', "");
    Expect(1, 8234, '\P{Is_Word_Break=-newline}', "");
    Expect(0, 8234, '\P{^Is_Word_Break=-newline}', "");
    Error('\p{Is_WB=/a/- NL}');
    Error('\P{Is_WB=/a/- NL}');
    Expect(1, 8233, '\p{Is_WB=nl}', "");
    Expect(0, 8233, '\p{^Is_WB=nl}', "");
    Expect(0, 8233, '\P{Is_WB=nl}', "");
    Expect(1, 8233, '\P{^Is_WB=nl}', "");
    Expect(0, 8234, '\p{Is_WB=nl}', "");
    Expect(1, 8234, '\p{^Is_WB=nl}', "");
    Expect(1, 8234, '\P{Is_WB=nl}', "");
    Expect(0, 8234, '\P{^Is_WB=nl}', "");
    Expect(1, 8233, '\p{Is_WB=-_NL}', "");
    Expect(0, 8233, '\p{^Is_WB=-_NL}', "");
    Expect(0, 8233, '\P{Is_WB=-_NL}', "");
    Expect(1, 8233, '\P{^Is_WB=-_NL}', "");
    Expect(0, 8234, '\p{Is_WB=-_NL}', "");
    Expect(1, 8234, '\p{^Is_WB=-_NL}', "");
    Expect(1, 8234, '\P{Is_WB=-_NL}', "");
    Expect(0, 8234, '\P{^Is_WB=-_NL}', "");
    Error('\p{Word_Break=:=--Numeric}');
    Error('\P{Word_Break=:=--Numeric}');
    Expect(1, 125273, '\p{Word_Break=:\ANumeric\z:}', "");;
    Expect(0, 125274, '\p{Word_Break=:\ANumeric\z:}', "");;
    Expect(1, 125273, '\p{Word_Break=numeric}', "");
    Expect(0, 125273, '\p{^Word_Break=numeric}', "");
    Expect(0, 125273, '\P{Word_Break=numeric}', "");
    Expect(1, 125273, '\P{^Word_Break=numeric}', "");
    Expect(0, 125274, '\p{Word_Break=numeric}', "");
    Expect(1, 125274, '\p{^Word_Break=numeric}', "");
    Expect(1, 125274, '\P{Word_Break=numeric}', "");
    Expect(0, 125274, '\P{^Word_Break=numeric}', "");
    Expect(1, 125273, '\p{Word_Break=:\Anumeric\z:}', "");;
    Expect(0, 125274, '\p{Word_Break=:\Anumeric\z:}', "");;
    Expect(1, 125273, '\p{Word_Break=-Numeric}', "");
    Expect(0, 125273, '\p{^Word_Break=-Numeric}', "");
    Expect(0, 125273, '\P{Word_Break=-Numeric}', "");
    Expect(1, 125273, '\P{^Word_Break=-Numeric}', "");
    Expect(0, 125274, '\p{Word_Break=-Numeric}', "");
    Expect(1, 125274, '\p{^Word_Break=-Numeric}', "");
    Expect(1, 125274, '\P{Word_Break=-Numeric}', "");
    Expect(0, 125274, '\P{^Word_Break=-Numeric}', "");
    Error('\p{WB=-nu/a/}');
    Error('\P{WB=-nu/a/}');
    Expect(1, 125273, '\p{WB=:\ANU\z:}', "");;
    Expect(0, 125274, '\p{WB=:\ANU\z:}', "");;
    Expect(1, 125273, '\p{WB=nu}', "");
    Expect(0, 125273, '\p{^WB=nu}', "");
    Expect(0, 125273, '\P{WB=nu}', "");
    Expect(1, 125273, '\P{^WB=nu}', "");
    Expect(0, 125274, '\p{WB=nu}', "");
    Expect(1, 125274, '\p{^WB=nu}', "");
    Expect(1, 125274, '\P{WB=nu}', "");
    Expect(0, 125274, '\P{^WB=nu}', "");
    Expect(1, 125273, '\p{WB=:\Anu\z:}', "");;
    Expect(0, 125274, '\p{WB=:\Anu\z:}', "");;
    Expect(1, 125273, '\p{WB:		nu}', "");
    Expect(0, 125273, '\p{^WB:		nu}', "");
    Expect(0, 125273, '\P{WB:		nu}', "");
    Expect(1, 125273, '\P{^WB:		nu}', "");
    Expect(0, 125274, '\p{WB:		nu}', "");
    Expect(1, 125274, '\p{^WB:		nu}', "");
    Expect(1, 125274, '\P{WB:		nu}', "");
    Expect(0, 125274, '\P{^WB:		nu}', "");
    Error('\p{Is_Word_Break=_numeric:=}');
    Error('\P{Is_Word_Break=_numeric:=}');
    Expect(1, 125273, '\p{Is_Word_Break=numeric}', "");
    Expect(0, 125273, '\p{^Is_Word_Break=numeric}', "");
    Expect(0, 125273, '\P{Is_Word_Break=numeric}', "");
    Expect(1, 125273, '\P{^Is_Word_Break=numeric}', "");
    Expect(0, 125274, '\p{Is_Word_Break=numeric}', "");
    Expect(1, 125274, '\p{^Is_Word_Break=numeric}', "");
    Expect(1, 125274, '\P{Is_Word_Break=numeric}', "");
    Expect(0, 125274, '\P{^Is_Word_Break=numeric}', "");
    Expect(1, 125273, '\p{Is_Word_Break=-	NUMERIC}', "");
    Expect(0, 125273, '\p{^Is_Word_Break=-	NUMERIC}', "");
    Expect(0, 125273, '\P{Is_Word_Break=-	NUMERIC}', "");
    Expect(1, 125273, '\P{^Is_Word_Break=-	NUMERIC}', "");
    Expect(0, 125274, '\p{Is_Word_Break=-	NUMERIC}', "");
    Expect(1, 125274, '\p{^Is_Word_Break=-	NUMERIC}', "");
    Expect(1, 125274, '\P{Is_Word_Break=-	NUMERIC}', "");
    Expect(0, 125274, '\P{^Is_Word_Break=-	NUMERIC}', "");
    Error('\p{Is_WB=/a/__NU}');
    Error('\P{Is_WB=/a/__NU}');
    Expect(1, 125273, '\p{Is_WB=nu}', "");
    Expect(0, 125273, '\p{^Is_WB=nu}', "");
    Expect(0, 125273, '\P{Is_WB=nu}', "");
    Expect(1, 125273, '\P{^Is_WB=nu}', "");
    Expect(0, 125274, '\p{Is_WB=nu}', "");
    Expect(1, 125274, '\p{^Is_WB=nu}', "");
    Expect(1, 125274, '\P{Is_WB=nu}', "");
    Expect(0, 125274, '\P{^Is_WB=nu}', "");
    Expect(1, 125273, '\p{Is_WB=_	nu}', "");
    Expect(0, 125273, '\p{^Is_WB=_	nu}', "");
    Expect(0, 125273, '\P{Is_WB=_	nu}', "");
    Expect(1, 125273, '\P{^Is_WB=_	nu}', "");
    Expect(0, 125274, '\p{Is_WB=_	nu}', "");
    Expect(1, 125274, '\p{^Is_WB=_	nu}', "");
    Expect(1, 125274, '\P{Is_WB=_	nu}', "");
    Expect(0, 125274, '\P{^Is_WB=_	nu}', "");
    Error('\p{Word_Break=--Regional_Indicator:=}');
    Error('\P{Word_Break=--Regional_Indicator:=}');
    Expect(1, 127487, '\p{Word_Break=:\ARegional_Indicator\z:}', "");;
    Expect(0, 127488, '\p{Word_Break=:\ARegional_Indicator\z:}', "");;
    Expect(1, 127487, '\p{Word_Break=regionalindicator}', "");
    Expect(0, 127487, '\p{^Word_Break=regionalindicator}', "");
    Expect(0, 127487, '\P{Word_Break=regionalindicator}', "");
    Expect(1, 127487, '\P{^Word_Break=regionalindicator}', "");
    Expect(0, 127488, '\p{Word_Break=regionalindicator}', "");
    Expect(1, 127488, '\p{^Word_Break=regionalindicator}', "");
    Expect(1, 127488, '\P{Word_Break=regionalindicator}', "");
    Expect(0, 127488, '\P{^Word_Break=regionalindicator}', "");
    Expect(1, 127487, '\p{Word_Break=:\Aregionalindicator\z:}', "");;
    Expect(0, 127488, '\p{Word_Break=:\Aregionalindicator\z:}', "");;
    Expect(1, 127487, '\p{Word_Break= -REGIONAL_Indicator}', "");
    Expect(0, 127487, '\p{^Word_Break= -REGIONAL_Indicator}', "");
    Expect(0, 127487, '\P{Word_Break= -REGIONAL_Indicator}', "");
    Expect(1, 127487, '\P{^Word_Break= -REGIONAL_Indicator}', "");
    Expect(0, 127488, '\p{Word_Break= -REGIONAL_Indicator}', "");
    Expect(1, 127488, '\p{^Word_Break= -REGIONAL_Indicator}', "");
    Expect(1, 127488, '\P{Word_Break= -REGIONAL_Indicator}', "");
    Expect(0, 127488, '\P{^Word_Break= -REGIONAL_Indicator}', "");
    Error('\p{WB:	/a/	-ri}');
    Error('\P{WB:	/a/	-ri}');
    Expect(1, 127487, '\p{WB=:\ARI\z:}', "");;
    Expect(0, 127488, '\p{WB=:\ARI\z:}', "");;
    Expect(1, 127487, '\p{WB=ri}', "");
    Expect(0, 127487, '\p{^WB=ri}', "");
    Expect(0, 127487, '\P{WB=ri}', "");
    Expect(1, 127487, '\P{^WB=ri}', "");
    Expect(0, 127488, '\p{WB=ri}', "");
    Expect(1, 127488, '\p{^WB=ri}', "");
    Expect(1, 127488, '\P{WB=ri}', "");
    Expect(0, 127488, '\P{^WB=ri}', "");
    Expect(1, 127487, '\p{WB=:\Ari\z:}', "");;
    Expect(0, 127488, '\p{WB=:\Ari\z:}', "");;
    Expect(1, 127487, '\p{WB=  ri}', "");
    Expect(0, 127487, '\p{^WB=  ri}', "");
    Expect(0, 127487, '\P{WB=  ri}', "");
    Expect(1, 127487, '\P{^WB=  ri}', "");
    Expect(0, 127488, '\p{WB=  ri}', "");
    Expect(1, 127488, '\p{^WB=  ri}', "");
    Expect(1, 127488, '\P{WB=  ri}', "");
    Expect(0, 127488, '\P{^WB=  ri}', "");
    Error('\p{Is_Word_Break=:=	REGIONAL_indicator}');
    Error('\P{Is_Word_Break=:=	REGIONAL_indicator}');
    Expect(1, 127487, '\p{Is_Word_Break=regionalindicator}', "");
    Expect(0, 127487, '\p{^Is_Word_Break=regionalindicator}', "");
    Expect(0, 127487, '\P{Is_Word_Break=regionalindicator}', "");
    Expect(1, 127487, '\P{^Is_Word_Break=regionalindicator}', "");
    Expect(0, 127488, '\p{Is_Word_Break=regionalindicator}', "");
    Expect(1, 127488, '\p{^Is_Word_Break=regionalindicator}', "");
    Expect(1, 127488, '\P{Is_Word_Break=regionalindicator}', "");
    Expect(0, 127488, '\P{^Is_Word_Break=regionalindicator}', "");
    Expect(1, 127487, '\p{Is_Word_Break= _regional_Indicator}', "");
    Expect(0, 127487, '\p{^Is_Word_Break= _regional_Indicator}', "");
    Expect(0, 127487, '\P{Is_Word_Break= _regional_Indicator}', "");
    Expect(1, 127487, '\P{^Is_Word_Break= _regional_Indicator}', "");
    Expect(0, 127488, '\p{Is_Word_Break= _regional_Indicator}', "");
    Expect(1, 127488, '\p{^Is_Word_Break= _regional_Indicator}', "");
    Expect(1, 127488, '\P{Is_Word_Break= _regional_Indicator}', "");
    Expect(0, 127488, '\P{^Is_Word_Break= _regional_Indicator}', "");
    Error('\p{Is_WB:	:=-	ri}');
    Error('\P{Is_WB:	:=-	ri}');
    Expect(1, 127487, '\p{Is_WB=ri}', "");
    Expect(0, 127487, '\p{^Is_WB=ri}', "");
    Expect(0, 127487, '\P{Is_WB=ri}', "");
    Expect(1, 127487, '\P{^Is_WB=ri}', "");
    Expect(0, 127488, '\p{Is_WB=ri}', "");
    Expect(1, 127488, '\p{^Is_WB=ri}', "");
    Expect(1, 127488, '\P{Is_WB=ri}', "");
    Expect(0, 127488, '\P{^Is_WB=ri}', "");
    Expect(1, 127487, '\p{Is_WB=-RI}', "");
    Expect(0, 127487, '\p{^Is_WB=-RI}', "");
    Expect(0, 127487, '\P{Is_WB=-RI}', "");
    Expect(1, 127487, '\P{^Is_WB=-RI}', "");
    Expect(0, 127488, '\p{Is_WB=-RI}', "");
    Expect(1, 127488, '\p{^Is_WB=-RI}', "");
    Expect(1, 127488, '\P{Is_WB=-RI}', "");
    Expect(0, 127488, '\P{^Is_WB=-RI}', "");
    Error('\p{Word_Break= SINGLE_Quote:=}');
    Error('\P{Word_Break= SINGLE_Quote:=}');
    Expect(1, 39, '\p{Word_Break=:\ASingle_Quote\z:}', "");;
    Expect(0, 40, '\p{Word_Break=:\ASingle_Quote\z:}', "");;
    Expect(1, 39, '\p{Word_Break=singlequote}', "");
    Expect(0, 39, '\p{^Word_Break=singlequote}', "");
    Expect(0, 39, '\P{Word_Break=singlequote}', "");
    Expect(1, 39, '\P{^Word_Break=singlequote}', "");
    Expect(0, 40, '\p{Word_Break=singlequote}', "");
    Expect(1, 40, '\p{^Word_Break=singlequote}', "");
    Expect(1, 40, '\P{Word_Break=singlequote}', "");
    Expect(0, 40, '\P{^Word_Break=singlequote}', "");
    Expect(1, 39, '\p{Word_Break=:\Asinglequote\z:}', "");;
    Expect(0, 40, '\p{Word_Break=:\Asinglequote\z:}', "");;
    Expect(1, 39, '\p{Word_Break=	 Single_Quote}', "");
    Expect(0, 39, '\p{^Word_Break=	 Single_Quote}', "");
    Expect(0, 39, '\P{Word_Break=	 Single_Quote}', "");
    Expect(1, 39, '\P{^Word_Break=	 Single_Quote}', "");
    Expect(0, 40, '\p{Word_Break=	 Single_Quote}', "");
    Expect(1, 40, '\p{^Word_Break=	 Single_Quote}', "");
    Expect(1, 40, '\P{Word_Break=	 Single_Quote}', "");
    Expect(0, 40, '\P{^Word_Break=	 Single_Quote}', "");
    Error('\p{WB=/a/_SQ}');
    Error('\P{WB=/a/_SQ}');
    Expect(1, 39, '\p{WB=:\ASQ\z:}', "");;
    Expect(0, 40, '\p{WB=:\ASQ\z:}', "");;
    Expect(1, 39, '\p{WB=sq}', "");
    Expect(0, 39, '\p{^WB=sq}', "");
    Expect(0, 39, '\P{WB=sq}', "");
    Expect(1, 39, '\P{^WB=sq}', "");
    Expect(0, 40, '\p{WB=sq}', "");
    Expect(1, 40, '\p{^WB=sq}', "");
    Expect(1, 40, '\P{WB=sq}', "");
    Expect(0, 40, '\P{^WB=sq}', "");
    Expect(1, 39, '\p{WB=:\Asq\z:}', "");;
    Expect(0, 40, '\p{WB=:\Asq\z:}', "");;
    Expect(1, 39, '\p{WB=_SQ}', "");
    Expect(0, 39, '\p{^WB=_SQ}', "");
    Expect(0, 39, '\P{WB=_SQ}', "");
    Expect(1, 39, '\P{^WB=_SQ}', "");
    Expect(0, 40, '\p{WB=_SQ}', "");
    Expect(1, 40, '\p{^WB=_SQ}', "");
    Expect(1, 40, '\P{WB=_SQ}', "");
    Expect(0, 40, '\P{^WB=_SQ}', "");
    Error('\p{Is_Word_Break=:=_-single_Quote}');
    Error('\P{Is_Word_Break=:=_-single_Quote}');
    Expect(1, 39, '\p{Is_Word_Break=singlequote}', "");
    Expect(0, 39, '\p{^Is_Word_Break=singlequote}', "");
    Expect(0, 39, '\P{Is_Word_Break=singlequote}', "");
    Expect(1, 39, '\P{^Is_Word_Break=singlequote}', "");
    Expect(0, 40, '\p{Is_Word_Break=singlequote}', "");
    Expect(1, 40, '\p{^Is_Word_Break=singlequote}', "");
    Expect(1, 40, '\P{Is_Word_Break=singlequote}', "");
    Expect(0, 40, '\P{^Is_Word_Break=singlequote}', "");
    Expect(1, 39, '\p{Is_Word_Break=	-SINGLE_QUOTE}', "");
    Expect(0, 39, '\p{^Is_Word_Break=	-SINGLE_QUOTE}', "");
    Expect(0, 39, '\P{Is_Word_Break=	-SINGLE_QUOTE}', "");
    Expect(1, 39, '\P{^Is_Word_Break=	-SINGLE_QUOTE}', "");
    Expect(0, 40, '\p{Is_Word_Break=	-SINGLE_QUOTE}', "");
    Expect(1, 40, '\p{^Is_Word_Break=	-SINGLE_QUOTE}', "");
    Expect(1, 40, '\P{Is_Word_Break=	-SINGLE_QUOTE}', "");
    Expect(0, 40, '\P{^Is_Word_Break=	-SINGLE_QUOTE}', "");
    Error('\p{Is_WB= 	SQ/a/}');
    Error('\P{Is_WB= 	SQ/a/}');
    Expect(1, 39, '\p{Is_WB=sq}', "");
    Expect(0, 39, '\p{^Is_WB=sq}', "");
    Expect(0, 39, '\P{Is_WB=sq}', "");
    Expect(1, 39, '\P{^Is_WB=sq}', "");
    Expect(0, 40, '\p{Is_WB=sq}', "");
    Expect(1, 40, '\p{^Is_WB=sq}', "");
    Expect(1, 40, '\P{Is_WB=sq}', "");
    Expect(0, 40, '\P{^Is_WB=sq}', "");
    Expect(1, 39, '\p{Is_WB=-sq}', "");
    Expect(0, 39, '\p{^Is_WB=-sq}', "");
    Expect(0, 39, '\P{Is_WB=-sq}', "");
    Expect(1, 39, '\P{^Is_WB=-sq}', "");
    Expect(0, 40, '\p{Is_WB=-sq}', "");
    Expect(1, 40, '\p{^Is_WB=-sq}', "");
    Expect(1, 40, '\P{Is_WB=-sq}', "");
    Expect(0, 40, '\P{^Is_WB=-sq}', "");
    Error('\p{Word_Break=_ wsegspace/a/}');
    Error('\P{Word_Break=_ wsegspace/a/}');
    Expect(1, 12288, '\p{Word_Break=:\AWSegSpace\z:}', "");;
    Expect(0, 12289, '\p{Word_Break=:\AWSegSpace\z:}', "");;
    Expect(1, 12288, '\p{Word_Break=wsegspace}', "");
    Expect(0, 12288, '\p{^Word_Break=wsegspace}', "");
    Expect(0, 12288, '\P{Word_Break=wsegspace}', "");
    Expect(1, 12288, '\P{^Word_Break=wsegspace}', "");
    Expect(0, 12289, '\p{Word_Break=wsegspace}', "");
    Expect(1, 12289, '\p{^Word_Break=wsegspace}', "");
    Expect(1, 12289, '\P{Word_Break=wsegspace}', "");
    Expect(0, 12289, '\P{^Word_Break=wsegspace}', "");
    Expect(1, 12288, '\p{Word_Break=:\Awsegspace\z:}', "");;
    Expect(0, 12289, '\p{Word_Break=:\Awsegspace\z:}', "");;
    Expect(1, 12288, '\p{Word_Break=	_WSegSpace}', "");
    Expect(0, 12288, '\p{^Word_Break=	_WSegSpace}', "");
    Expect(0, 12288, '\P{Word_Break=	_WSegSpace}', "");
    Expect(1, 12288, '\P{^Word_Break=	_WSegSpace}', "");
    Expect(0, 12289, '\p{Word_Break=	_WSegSpace}', "");
    Expect(1, 12289, '\p{^Word_Break=	_WSegSpace}', "");
    Expect(1, 12289, '\P{Word_Break=	_WSegSpace}', "");
    Expect(0, 12289, '\P{^Word_Break=	_WSegSpace}', "");
    Error('\p{WB=/a/WSegSpace}');
    Error('\P{WB=/a/WSegSpace}');
    Expect(1, 12288, '\p{WB=:\AWSegSpace\z:}', "");;
    Expect(0, 12289, '\p{WB=:\AWSegSpace\z:}', "");;
    Expect(1, 12288, '\p{WB=wsegspace}', "");
    Expect(0, 12288, '\p{^WB=wsegspace}', "");
    Expect(0, 12288, '\P{WB=wsegspace}', "");
    Expect(1, 12288, '\P{^WB=wsegspace}', "");
    Expect(0, 12289, '\p{WB=wsegspace}', "");
    Expect(1, 12289, '\p{^WB=wsegspace}', "");
    Expect(1, 12289, '\P{WB=wsegspace}', "");
    Expect(0, 12289, '\P{^WB=wsegspace}', "");
    Expect(1, 12288, '\p{WB=:\Awsegspace\z:}', "");;
    Expect(0, 12289, '\p{WB=:\Awsegspace\z:}', "");;
    Expect(1, 12288, '\p{WB= WSegSpace}', "");
    Expect(0, 12288, '\p{^WB= WSegSpace}', "");
    Expect(0, 12288, '\P{WB= WSegSpace}', "");
    Expect(1, 12288, '\P{^WB= WSegSpace}', "");
    Expect(0, 12289, '\p{WB= WSegSpace}', "");
    Expect(1, 12289, '\p{^WB= WSegSpace}', "");
    Expect(1, 12289, '\P{WB= WSegSpace}', "");
    Expect(0, 12289, '\P{^WB= WSegSpace}', "");
    Error('\p{Is_Word_Break=- wsegspace:=}');
    Error('\P{Is_Word_Break=- wsegspace:=}');
    Expect(1, 12288, '\p{Is_Word_Break=wsegspace}', "");
    Expect(0, 12288, '\p{^Is_Word_Break=wsegspace}', "");
    Expect(0, 12288, '\P{Is_Word_Break=wsegspace}', "");
    Expect(1, 12288, '\P{^Is_Word_Break=wsegspace}', "");
    Expect(0, 12289, '\p{Is_Word_Break=wsegspace}', "");
    Expect(1, 12289, '\p{^Is_Word_Break=wsegspace}', "");
    Expect(1, 12289, '\P{Is_Word_Break=wsegspace}', "");
    Expect(0, 12289, '\P{^Is_Word_Break=wsegspace}', "");
    Expect(1, 12288, '\p{Is_Word_Break= 	WSegSpace}', "");
    Expect(0, 12288, '\p{^Is_Word_Break= 	WSegSpace}', "");
    Expect(0, 12288, '\P{Is_Word_Break= 	WSegSpace}', "");
    Expect(1, 12288, '\P{^Is_Word_Break= 	WSegSpace}', "");
    Expect(0, 12289, '\p{Is_Word_Break= 	WSegSpace}', "");
    Expect(1, 12289, '\p{^Is_Word_Break= 	WSegSpace}', "");
    Expect(1, 12289, '\P{Is_Word_Break= 	WSegSpace}', "");
    Expect(0, 12289, '\P{^Is_Word_Break= 	WSegSpace}', "");
    Error('\p{Is_WB=/a/ WSEGSPACE}');
    Error('\P{Is_WB=/a/ WSEGSPACE}');
    Expect(1, 12288, '\p{Is_WB=wsegspace}', "");
    Expect(0, 12288, '\p{^Is_WB=wsegspace}', "");
    Expect(0, 12288, '\P{Is_WB=wsegspace}', "");
    Expect(1, 12288, '\P{^Is_WB=wsegspace}', "");
    Expect(0, 12289, '\p{Is_WB=wsegspace}', "");
    Expect(1, 12289, '\p{^Is_WB=wsegspace}', "");
    Expect(1, 12289, '\P{Is_WB=wsegspace}', "");
    Expect(0, 12289, '\P{^Is_WB=wsegspace}', "");
    Expect(1, 12288, '\p{Is_WB=--WSegSpace}', "");
    Expect(0, 12288, '\p{^Is_WB=--WSegSpace}', "");
    Expect(0, 12288, '\P{Is_WB=--WSegSpace}', "");
    Expect(1, 12288, '\P{^Is_WB=--WSegSpace}', "");
    Expect(0, 12289, '\p{Is_WB=--WSegSpace}', "");
    Expect(1, 12289, '\p{^Is_WB=--WSegSpace}', "");
    Expect(1, 12289, '\P{Is_WB=--WSegSpace}', "");
    Expect(0, 12289, '\P{^Is_WB=--WSegSpace}', "");
    Error('\p{Word_Break=:=-Other}');
    Error('\P{Word_Break=:=-Other}');
    Expect(1, 918000, '\p{Word_Break=:\AOther\z:}', "");;
    Expect(0, 917999, '\p{Word_Break=:\AOther\z:}', "");;
    Expect(1, 918000, '\p{Word_Break=other}', "");
    Expect(0, 918000, '\p{^Word_Break=other}', "");
    Expect(0, 918000, '\P{Word_Break=other}', "");
    Expect(1, 918000, '\P{^Word_Break=other}', "");
    Expect(0, 917999, '\p{Word_Break=other}', "");
    Expect(1, 917999, '\p{^Word_Break=other}', "");
    Expect(1, 917999, '\P{Word_Break=other}', "");
    Expect(0, 917999, '\P{^Word_Break=other}', "");
    Expect(1, 918000, '\p{Word_Break=:\Aother\z:}', "");;
    Expect(0, 917999, '\p{Word_Break=:\Aother\z:}', "");;
    Expect(1, 918000, '\p{Word_Break=_ Other}', "");
    Expect(0, 918000, '\p{^Word_Break=_ Other}', "");
    Expect(0, 918000, '\P{Word_Break=_ Other}', "");
    Expect(1, 918000, '\P{^Word_Break=_ Other}', "");
    Expect(0, 917999, '\p{Word_Break=_ Other}', "");
    Expect(1, 917999, '\p{^Word_Break=_ Other}', "");
    Expect(1, 917999, '\P{Word_Break=_ Other}', "");
    Expect(0, 917999, '\P{^Word_Break=_ Other}', "");
    Error('\p{WB=/a/ XX}');
    Error('\P{WB=/a/ XX}');
    Expect(1, 918000, '\p{WB=:\AXX\z:}', "");;
    Expect(0, 917999, '\p{WB=:\AXX\z:}', "");;
    Expect(1, 918000, '\p{WB=xx}', "");
    Expect(0, 918000, '\p{^WB=xx}', "");
    Expect(0, 918000, '\P{WB=xx}', "");
    Expect(1, 918000, '\P{^WB=xx}', "");
    Expect(0, 917999, '\p{WB=xx}', "");
    Expect(1, 917999, '\p{^WB=xx}', "");
    Expect(1, 917999, '\P{WB=xx}', "");
    Expect(0, 917999, '\P{^WB=xx}', "");
    Expect(1, 918000, '\p{WB=:\Axx\z:}', "");;
    Expect(0, 917999, '\p{WB=:\Axx\z:}', "");;
    Expect(1, 918000, '\p{WB=_XX}', "");
    Expect(0, 918000, '\p{^WB=_XX}', "");
    Expect(0, 918000, '\P{WB=_XX}', "");
    Expect(1, 918000, '\P{^WB=_XX}', "");
    Expect(0, 917999, '\p{WB=_XX}', "");
    Expect(1, 917999, '\p{^WB=_XX}', "");
    Expect(1, 917999, '\P{WB=_XX}', "");
    Expect(0, 917999, '\P{^WB=_XX}', "");
    Error('\p{Is_Word_Break= -other/a/}');
    Error('\P{Is_Word_Break= -other/a/}');
    Expect(1, 918000, '\p{Is_Word_Break:   other}', "");
    Expect(0, 918000, '\p{^Is_Word_Break:   other}', "");
    Expect(0, 918000, '\P{Is_Word_Break:   other}', "");
    Expect(1, 918000, '\P{^Is_Word_Break:   other}', "");
    Expect(0, 917999, '\p{Is_Word_Break:   other}', "");
    Expect(1, 917999, '\p{^Is_Word_Break:   other}', "");
    Expect(1, 917999, '\P{Is_Word_Break:   other}', "");
    Expect(0, 917999, '\P{^Is_Word_Break:   other}', "");
    Expect(1, 918000, '\p{Is_Word_Break=_OTHER}', "");
    Expect(0, 918000, '\p{^Is_Word_Break=_OTHER}', "");
    Expect(0, 918000, '\P{Is_Word_Break=_OTHER}', "");
    Expect(1, 918000, '\P{^Is_Word_Break=_OTHER}', "");
    Expect(0, 917999, '\p{Is_Word_Break=_OTHER}', "");
    Expect(1, 917999, '\p{^Is_Word_Break=_OTHER}', "");
    Expect(1, 917999, '\P{Is_Word_Break=_OTHER}', "");
    Expect(0, 917999, '\P{^Is_Word_Break=_OTHER}', "");
    Error('\p{Is_WB:	_/a/XX}');
    Error('\P{Is_WB:	_/a/XX}');
    Expect(1, 918000, '\p{Is_WB=xx}', "");
    Expect(0, 918000, '\p{^Is_WB=xx}', "");
    Expect(0, 918000, '\P{Is_WB=xx}', "");
    Expect(1, 918000, '\P{^Is_WB=xx}', "");
    Expect(0, 917999, '\p{Is_WB=xx}', "");
    Expect(1, 917999, '\p{^Is_WB=xx}', "");
    Expect(1, 917999, '\P{Is_WB=xx}', "");
    Expect(0, 917999, '\P{^Is_WB=xx}', "");
    Expect(1, 918000, '\p{Is_WB:	- xx}', "");
    Expect(0, 918000, '\p{^Is_WB:	- xx}', "");
    Expect(0, 918000, '\P{Is_WB:	- xx}', "");
    Expect(1, 918000, '\P{^Is_WB:	- xx}', "");
    Expect(0, 917999, '\p{Is_WB:	- xx}', "");
    Expect(1, 917999, '\p{^Is_WB:	- xx}', "");
    Expect(1, 917999, '\P{Is_WB:	- xx}', "");
    Expect(0, 917999, '\P{^Is_WB:	- xx}', "");
    Error('\p{Word_Break= /a/ZWJ}');
    Error('\P{Word_Break= /a/ZWJ}');
    Expect(1, 8205, '\p{Word_Break=:\AZWJ\z:}', "");;
    Expect(0, 8206, '\p{Word_Break=:\AZWJ\z:}', "");;
    Expect(1, 8205, '\p{Word_Break=zwj}', "");
    Expect(0, 8205, '\p{^Word_Break=zwj}', "");
    Expect(0, 8205, '\P{Word_Break=zwj}', "");
    Expect(1, 8205, '\P{^Word_Break=zwj}', "");
    Expect(0, 8206, '\p{Word_Break=zwj}', "");
    Expect(1, 8206, '\p{^Word_Break=zwj}', "");
    Expect(1, 8206, '\P{Word_Break=zwj}', "");
    Expect(0, 8206, '\P{^Word_Break=zwj}', "");
    Expect(1, 8205, '\p{Word_Break=:\Azwj\z:}', "");;
    Expect(0, 8206, '\p{Word_Break=:\Azwj\z:}', "");;
    Expect(1, 8205, '\p{Word_Break= -ZWJ}', "");
    Expect(0, 8205, '\p{^Word_Break= -ZWJ}', "");
    Expect(0, 8205, '\P{Word_Break= -ZWJ}', "");
    Expect(1, 8205, '\P{^Word_Break= -ZWJ}', "");
    Expect(0, 8206, '\p{Word_Break= -ZWJ}', "");
    Expect(1, 8206, '\p{^Word_Break= -ZWJ}', "");
    Expect(1, 8206, '\P{Word_Break= -ZWJ}', "");
    Expect(0, 8206, '\P{^Word_Break= -ZWJ}', "");
    Error('\p{WB=/a/-ZWJ}');
    Error('\P{WB=/a/-ZWJ}');
    Expect(1, 8205, '\p{WB=:\AZWJ\z:}', "");;
    Expect(0, 8206, '\p{WB=:\AZWJ\z:}', "");;
    Expect(1, 8205, '\p{WB=zwj}', "");
    Expect(0, 8205, '\p{^WB=zwj}', "");
    Expect(0, 8205, '\P{WB=zwj}', "");
    Expect(1, 8205, '\P{^WB=zwj}', "");
    Expect(0, 8206, '\p{WB=zwj}', "");
    Expect(1, 8206, '\p{^WB=zwj}', "");
    Expect(1, 8206, '\P{WB=zwj}', "");
    Expect(0, 8206, '\P{^WB=zwj}', "");
    Expect(1, 8205, '\p{WB=:\Azwj\z:}', "");;
    Expect(0, 8206, '\p{WB=:\Azwj\z:}', "");;
    Expect(1, 8205, '\p{WB=ZWJ}', "");
    Expect(0, 8205, '\p{^WB=ZWJ}', "");
    Expect(0, 8205, '\P{WB=ZWJ}', "");
    Expect(1, 8205, '\P{^WB=ZWJ}', "");
    Expect(0, 8206, '\p{WB=ZWJ}', "");
    Expect(1, 8206, '\p{^WB=ZWJ}', "");
    Expect(1, 8206, '\P{WB=ZWJ}', "");
    Expect(0, 8206, '\P{^WB=ZWJ}', "");
    Error('\p{Is_Word_Break=_/a/ZWJ}');
    Error('\P{Is_Word_Break=_/a/ZWJ}');
    Expect(1, 8205, '\p{Is_Word_Break=zwj}', "");
    Expect(0, 8205, '\p{^Is_Word_Break=zwj}', "");
    Expect(0, 8205, '\P{Is_Word_Break=zwj}', "");
    Expect(1, 8205, '\P{^Is_Word_Break=zwj}', "");
    Expect(0, 8206, '\p{Is_Word_Break=zwj}', "");
    Expect(1, 8206, '\p{^Is_Word_Break=zwj}', "");
    Expect(1, 8206, '\P{Is_Word_Break=zwj}', "");
    Expect(0, 8206, '\P{^Is_Word_Break=zwj}', "");
    Expect(1, 8205, '\p{Is_Word_Break:   	_ZWJ}', "");
    Expect(0, 8205, '\p{^Is_Word_Break:   	_ZWJ}', "");
    Expect(0, 8205, '\P{Is_Word_Break:   	_ZWJ}', "");
    Expect(1, 8205, '\P{^Is_Word_Break:   	_ZWJ}', "");
    Expect(0, 8206, '\p{Is_Word_Break:   	_ZWJ}', "");
    Expect(1, 8206, '\p{^Is_Word_Break:   	_ZWJ}', "");
    Expect(1, 8206, '\P{Is_Word_Break:   	_ZWJ}', "");
    Expect(0, 8206, '\P{^Is_Word_Break:   	_ZWJ}', "");
    Error('\p{Is_WB=	:=ZWJ}');
    Error('\P{Is_WB=	:=ZWJ}');
    Expect(1, 8205, '\p{Is_WB=zwj}', "");
    Expect(0, 8205, '\p{^Is_WB=zwj}', "");
    Expect(0, 8205, '\P{Is_WB=zwj}', "");
    Expect(1, 8205, '\P{^Is_WB=zwj}', "");
    Expect(0, 8206, '\p{Is_WB=zwj}', "");
    Expect(1, 8206, '\p{^Is_WB=zwj}', "");
    Expect(1, 8206, '\P{Is_WB=zwj}', "");
    Expect(0, 8206, '\P{^Is_WB=zwj}', "");
    Expect(1, 8205, '\p{Is_WB=__ZWJ}', "");
    Expect(0, 8205, '\p{^Is_WB=__ZWJ}', "");
    Expect(0, 8205, '\P{Is_WB=__ZWJ}', "");
    Expect(1, 8205, '\P{^Is_WB=__ZWJ}', "");
    Expect(0, 8206, '\p{Is_WB=__ZWJ}', "");
    Expect(1, 8206, '\p{^Is_WB=__ZWJ}', "");
    Expect(1, 8206, '\P{Is_WB=__ZWJ}', "");
    Expect(0, 8206, '\P{^Is_WB=__ZWJ}', "");
    Error('\p{White_Space=/a/	-NO}');
    Error('\P{White_Space=/a/	-NO}');
    Expect(1, 12289, '\p{White_Space=:\ANo\z:}', "");;
    Expect(0, 12288, '\p{White_Space=:\ANo\z:}', "");;
    Expect(1, 12289, '\p{White_Space=no}', "");
    Expect(0, 12289, '\p{^White_Space=no}', "");
    Expect(0, 12289, '\P{White_Space=no}', "");
    Expect(1, 12289, '\P{^White_Space=no}', "");
    Expect(0, 12288, '\p{White_Space=no}', "");
    Expect(1, 12288, '\p{^White_Space=no}', "");
    Expect(1, 12288, '\P{White_Space=no}', "");
    Expect(0, 12288, '\P{^White_Space=no}', "");
    Expect(1, 12289, '\p{White_Space=:\Ano\z:}', "");;
    Expect(0, 12288, '\p{White_Space=:\Ano\z:}', "");;
    Expect(1, 12289, '\p{White_Space:	-No}', "");
    Expect(0, 12289, '\p{^White_Space:	-No}', "");
    Expect(0, 12289, '\P{White_Space:	-No}', "");
    Expect(1, 12289, '\P{^White_Space:	-No}', "");
    Expect(0, 12288, '\p{White_Space:	-No}', "");
    Expect(1, 12288, '\p{^White_Space:	-No}', "");
    Expect(1, 12288, '\P{White_Space:	-No}', "");
    Expect(0, 12288, '\P{^White_Space:	-No}', "");
    Error('\p{WSpace=/a/-_N}');
    Error('\P{WSpace=/a/-_N}');
    Expect(1, 12289, '\p{WSpace=:\AN\z:}', "");;
    Expect(0, 12288, '\p{WSpace=:\AN\z:}', "");;
    Expect(1, 12289, '\p{WSpace=n}', "");
    Expect(0, 12289, '\p{^WSpace=n}', "");
    Expect(0, 12289, '\P{WSpace=n}', "");
    Expect(1, 12289, '\P{^WSpace=n}', "");
    Expect(0, 12288, '\p{WSpace=n}', "");
    Expect(1, 12288, '\p{^WSpace=n}', "");
    Expect(1, 12288, '\P{WSpace=n}', "");
    Expect(0, 12288, '\P{^WSpace=n}', "");
    Expect(1, 12289, '\p{WSpace=:\An\z:}', "");;
    Expect(0, 12288, '\p{WSpace=:\An\z:}', "");;
    Expect(1, 12289, '\p{WSpace=_ N}', "");
    Expect(0, 12289, '\p{^WSpace=_ N}', "");
    Expect(0, 12289, '\P{WSpace=_ N}', "");
    Expect(1, 12289, '\P{^WSpace=_ N}', "");
    Expect(0, 12288, '\p{WSpace=_ N}', "");
    Expect(1, 12288, '\p{^WSpace=_ N}', "");
    Expect(1, 12288, '\P{WSpace=_ N}', "");
    Expect(0, 12288, '\P{^WSpace=_ N}', "");
    Error('\p{Space=:=	F}');
    Error('\P{Space=:=	F}');
    Expect(1, 12289, '\p{Space=:\AF\z:}', "");;
    Expect(0, 12288, '\p{Space=:\AF\z:}', "");;
    Expect(1, 12289, '\p{Space: f}', "");
    Expect(0, 12289, '\p{^Space: f}', "");
    Expect(0, 12289, '\P{Space: f}', "");
    Expect(1, 12289, '\P{^Space: f}', "");
    Expect(0, 12288, '\p{Space: f}', "");
    Expect(1, 12288, '\p{^Space: f}', "");
    Expect(1, 12288, '\P{Space: f}', "");
    Expect(0, 12288, '\P{^Space: f}', "");
    Expect(1, 12289, '\p{Space=:\Af\z:}', "");;
    Expect(0, 12288, '\p{Space=:\Af\z:}', "");;
    Expect(1, 12289, '\p{Space= F}', "");
    Expect(0, 12289, '\p{^Space= F}', "");
    Expect(0, 12289, '\P{Space= F}', "");
    Expect(1, 12289, '\P{^Space= F}', "");
    Expect(0, 12288, '\p{Space= F}', "");
    Expect(1, 12288, '\p{^Space= F}', "");
    Expect(1, 12288, '\P{Space= F}', "");
    Expect(0, 12288, '\P{^Space= F}', "");
    Error('\p{Is_White_Space=/a/-False}');
    Error('\P{Is_White_Space=/a/-False}');
    Expect(1, 12289, '\p{Is_White_Space=false}', "");
    Expect(0, 12289, '\p{^Is_White_Space=false}', "");
    Expect(0, 12289, '\P{Is_White_Space=false}', "");
    Expect(1, 12289, '\P{^Is_White_Space=false}', "");
    Expect(0, 12288, '\p{Is_White_Space=false}', "");
    Expect(1, 12288, '\p{^Is_White_Space=false}', "");
    Expect(1, 12288, '\P{Is_White_Space=false}', "");
    Expect(0, 12288, '\P{^Is_White_Space=false}', "");
    Expect(1, 12289, '\p{Is_White_Space=- False}', "");
    Expect(0, 12289, '\p{^Is_White_Space=- False}', "");
    Expect(0, 12289, '\P{Is_White_Space=- False}', "");
    Expect(1, 12289, '\P{^Is_White_Space=- False}', "");
    Expect(0, 12288, '\p{Is_White_Space=- False}', "");
    Expect(1, 12288, '\p{^Is_White_Space=- False}', "");
    Expect(1, 12288, '\P{Is_White_Space=- False}', "");
    Expect(0, 12288, '\P{^Is_White_Space=- False}', "");
    Error('\p{Is_WSpace=_:=No}');
    Error('\P{Is_WSpace=_:=No}');
    Expect(1, 12289, '\p{Is_WSpace=no}', "");
    Expect(0, 12289, '\p{^Is_WSpace=no}', "");
    Expect(0, 12289, '\P{Is_WSpace=no}', "");
    Expect(1, 12289, '\P{^Is_WSpace=no}', "");
    Expect(0, 12288, '\p{Is_WSpace=no}', "");
    Expect(1, 12288, '\p{^Is_WSpace=no}', "");
    Expect(1, 12288, '\P{Is_WSpace=no}', "");
    Expect(0, 12288, '\P{^Is_WSpace=no}', "");
    Expect(1, 12289, '\p{Is_WSpace=-NO}', "");
    Expect(0, 12289, '\p{^Is_WSpace=-NO}', "");
    Expect(0, 12289, '\P{Is_WSpace=-NO}', "");
    Expect(1, 12289, '\P{^Is_WSpace=-NO}', "");
    Expect(0, 12288, '\p{Is_WSpace=-NO}', "");
    Expect(1, 12288, '\p{^Is_WSpace=-NO}', "");
    Expect(1, 12288, '\P{Is_WSpace=-NO}', "");
    Expect(0, 12288, '\P{^Is_WSpace=-NO}', "");
    Error('\p{Is_Space=_/a/N}');
    Error('\P{Is_Space=_/a/N}');
    Expect(1, 12289, '\p{Is_Space=n}', "");
    Expect(0, 12289, '\p{^Is_Space=n}', "");
    Expect(0, 12289, '\P{Is_Space=n}', "");
    Expect(1, 12289, '\P{^Is_Space=n}', "");
    Expect(0, 12288, '\p{Is_Space=n}', "");
    Expect(1, 12288, '\p{^Is_Space=n}', "");
    Expect(1, 12288, '\P{Is_Space=n}', "");
    Expect(0, 12288, '\P{^Is_Space=n}', "");
    Expect(1, 12289, '\p{Is_Space=--N}', "");
    Expect(0, 12289, '\p{^Is_Space=--N}', "");
    Expect(0, 12289, '\P{Is_Space=--N}', "");
    Expect(1, 12289, '\P{^Is_Space=--N}', "");
    Expect(0, 12288, '\p{Is_Space=--N}', "");
    Expect(1, 12288, '\p{^Is_Space=--N}', "");
    Expect(1, 12288, '\P{Is_Space=--N}', "");
    Expect(0, 12288, '\P{^Is_Space=--N}', "");
    Error('\p{White_Space=-:=yes}');
    Error('\P{White_Space=-:=yes}');
    Expect(1, 12288, '\p{White_Space=:\AYes\z:}', "");;
    Expect(0, 12289, '\p{White_Space=:\AYes\z:}', "");;
    Expect(1, 12288, '\p{White_Space=yes}', "");
    Expect(0, 12288, '\p{^White_Space=yes}', "");
    Expect(0, 12288, '\P{White_Space=yes}', "");
    Expect(1, 12288, '\P{^White_Space=yes}', "");
    Expect(0, 12289, '\p{White_Space=yes}', "");
    Expect(1, 12289, '\p{^White_Space=yes}', "");
    Expect(1, 12289, '\P{White_Space=yes}', "");
    Expect(0, 12289, '\P{^White_Space=yes}', "");
    Expect(1, 12288, '\p{White_Space=:\Ayes\z:}', "");;
    Expect(0, 12289, '\p{White_Space=:\Ayes\z:}', "");;
    Expect(1, 12288, '\p{White_Space= -Yes}', "");
    Expect(0, 12288, '\p{^White_Space= -Yes}', "");
    Expect(0, 12288, '\P{White_Space= -Yes}', "");
    Expect(1, 12288, '\P{^White_Space= -Yes}', "");
    Expect(0, 12289, '\p{White_Space= -Yes}', "");
    Expect(1, 12289, '\p{^White_Space= -Yes}', "");
    Expect(1, 12289, '\P{White_Space= -Yes}', "");
    Expect(0, 12289, '\P{^White_Space= -Yes}', "");
    Error('\p{WSpace=--Y/a/}');
    Error('\P{WSpace=--Y/a/}');
    Expect(1, 12288, '\p{WSpace=:\AY\z:}', "");;
    Expect(0, 12289, '\p{WSpace=:\AY\z:}', "");;
    Expect(1, 12288, '\p{WSpace=y}', "");
    Expect(0, 12288, '\p{^WSpace=y}', "");
    Expect(0, 12288, '\P{WSpace=y}', "");
    Expect(1, 12288, '\P{^WSpace=y}', "");
    Expect(0, 12289, '\p{WSpace=y}', "");
    Expect(1, 12289, '\p{^WSpace=y}', "");
    Expect(1, 12289, '\P{WSpace=y}', "");
    Expect(0, 12289, '\P{^WSpace=y}', "");
    Expect(1, 12288, '\p{WSpace=:\Ay\z:}', "");;
    Expect(0, 12289, '\p{WSpace=:\Ay\z:}', "");;
    Expect(1, 12288, '\p{WSpace=		y}', "");
    Expect(0, 12288, '\p{^WSpace=		y}', "");
    Expect(0, 12288, '\P{WSpace=		y}', "");
    Expect(1, 12288, '\P{^WSpace=		y}', "");
    Expect(0, 12289, '\p{WSpace=		y}', "");
    Expect(1, 12289, '\p{^WSpace=		y}', "");
    Expect(1, 12289, '\P{WSpace=		y}', "");
    Expect(0, 12289, '\P{^WSpace=		y}', "");
    Error('\p{Space=_-T/a/}');
    Error('\P{Space=_-T/a/}');
    Expect(1, 12288, '\p{Space=:\AT\z:}', "");;
    Expect(0, 12289, '\p{Space=:\AT\z:}', "");;
    Expect(1, 12288, '\p{Space=t}', "");
    Expect(0, 12288, '\p{^Space=t}', "");
    Expect(0, 12288, '\P{Space=t}', "");
    Expect(1, 12288, '\P{^Space=t}', "");
    Expect(0, 12289, '\p{Space=t}', "");
    Expect(1, 12289, '\p{^Space=t}', "");
    Expect(1, 12289, '\P{Space=t}', "");
    Expect(0, 12289, '\P{^Space=t}', "");
    Expect(1, 12288, '\p{Space=:\At\z:}', "");;
    Expect(0, 12289, '\p{Space=:\At\z:}', "");;
    Expect(1, 12288, '\p{Space=_T}', "");
    Expect(0, 12288, '\p{^Space=_T}', "");
    Expect(0, 12288, '\P{Space=_T}', "");
    Expect(1, 12288, '\P{^Space=_T}', "");
    Expect(0, 12289, '\p{Space=_T}', "");
    Expect(1, 12289, '\p{^Space=_T}', "");
    Expect(1, 12289, '\P{Space=_T}', "");
    Expect(0, 12289, '\P{^Space=_T}', "");
    Error('\p{Is_White_Space=:=True}');
    Error('\P{Is_White_Space=:=True}');
    Expect(1, 12288, '\p{Is_White_Space=true}', "");
    Expect(0, 12288, '\p{^Is_White_Space=true}', "");
    Expect(0, 12288, '\P{Is_White_Space=true}', "");
    Expect(1, 12288, '\P{^Is_White_Space=true}', "");
    Expect(0, 12289, '\p{Is_White_Space=true}', "");
    Expect(1, 12289, '\p{^Is_White_Space=true}', "");
    Expect(1, 12289, '\P{Is_White_Space=true}', "");
    Expect(0, 12289, '\P{^Is_White_Space=true}', "");
    Expect(1, 12288, '\p{Is_White_Space:	 True}', "");
    Expect(0, 12288, '\p{^Is_White_Space:	 True}', "");
    Expect(0, 12288, '\P{Is_White_Space:	 True}', "");
    Expect(1, 12288, '\P{^Is_White_Space:	 True}', "");
    Expect(0, 12289, '\p{Is_White_Space:	 True}', "");
    Expect(1, 12289, '\p{^Is_White_Space:	 True}', "");
    Expect(1, 12289, '\P{Is_White_Space:	 True}', "");
    Expect(0, 12289, '\P{^Is_White_Space:	 True}', "");
    Error('\p{Is_WSpace=	-YES/a/}');
    Error('\P{Is_WSpace=	-YES/a/}');
    Expect(1, 12288, '\p{Is_WSpace=yes}', "");
    Expect(0, 12288, '\p{^Is_WSpace=yes}', "");
    Expect(0, 12288, '\P{Is_WSpace=yes}', "");
    Expect(1, 12288, '\P{^Is_WSpace=yes}', "");
    Expect(0, 12289, '\p{Is_WSpace=yes}', "");
    Expect(1, 12289, '\p{^Is_WSpace=yes}', "");
    Expect(1, 12289, '\P{Is_WSpace=yes}', "");
    Expect(0, 12289, '\P{^Is_WSpace=yes}', "");
    Expect(1, 12288, '\p{Is_WSpace=	_Yes}', "");
    Expect(0, 12288, '\p{^Is_WSpace=	_Yes}', "");
    Expect(0, 12288, '\P{Is_WSpace=	_Yes}', "");
    Expect(1, 12288, '\P{^Is_WSpace=	_Yes}', "");
    Expect(0, 12289, '\p{Is_WSpace=	_Yes}', "");
    Expect(1, 12289, '\p{^Is_WSpace=	_Yes}', "");
    Expect(1, 12289, '\P{Is_WSpace=	_Yes}', "");
    Expect(0, 12289, '\P{^Is_WSpace=	_Yes}', "");
    Error('\p{Is_Space=/a/-Y}');
    Error('\P{Is_Space=/a/-Y}');
    Expect(1, 12288, '\p{Is_Space=y}', "");
    Expect(0, 12288, '\p{^Is_Space=y}', "");
    Expect(0, 12288, '\P{Is_Space=y}', "");
    Expect(1, 12288, '\P{^Is_Space=y}', "");
    Expect(0, 12289, '\p{Is_Space=y}', "");
    Expect(1, 12289, '\p{^Is_Space=y}', "");
    Expect(1, 12289, '\P{Is_Space=y}', "");
    Expect(0, 12289, '\P{^Is_Space=y}', "");
    Expect(1, 12288, '\p{Is_Space=-y}', "");
    Expect(0, 12288, '\p{^Is_Space=-y}', "");
    Expect(0, 12288, '\P{Is_Space=-y}', "");
    Expect(1, 12288, '\P{^Is_Space=-y}', "");
    Expect(0, 12289, '\p{Is_Space=-y}', "");
    Expect(1, 12289, '\p{^Is_Space=-y}', "");
    Expect(1, 12289, '\P{Is_Space=-y}', "");
    Expect(0, 12289, '\P{^Is_Space=-y}', "");
    Error('\p{XID_Continue=		no/a/}');
    Error('\P{XID_Continue=		no/a/}');
    Expect(1, 918000, '\p{XID_Continue=:\ANo\z:}', "");;
    Expect(0, 917999, '\p{XID_Continue=:\ANo\z:}', "");;
    Expect(1, 918000, '\p{XID_Continue=no}', "");
    Expect(0, 918000, '\p{^XID_Continue=no}', "");
    Expect(0, 918000, '\P{XID_Continue=no}', "");
    Expect(1, 918000, '\P{^XID_Continue=no}', "");
    Expect(0, 917999, '\p{XID_Continue=no}', "");
    Expect(1, 917999, '\p{^XID_Continue=no}', "");
    Expect(1, 917999, '\P{XID_Continue=no}', "");
    Expect(0, 917999, '\P{^XID_Continue=no}', "");
    Expect(1, 918000, '\p{XID_Continue=:\Ano\z:}', "");;
    Expect(0, 917999, '\p{XID_Continue=:\Ano\z:}', "");;
    Expect(1, 918000, '\p{XID_Continue=	No}', "");
    Expect(0, 918000, '\p{^XID_Continue=	No}', "");
    Expect(0, 918000, '\P{XID_Continue=	No}', "");
    Expect(1, 918000, '\P{^XID_Continue=	No}', "");
    Expect(0, 917999, '\p{XID_Continue=	No}', "");
    Expect(1, 917999, '\p{^XID_Continue=	No}', "");
    Expect(1, 917999, '\P{XID_Continue=	No}', "");
    Expect(0, 917999, '\P{^XID_Continue=	No}', "");
    Error('\p{XIDC=  N:=}');
    Error('\P{XIDC=  N:=}');
    Expect(1, 918000, '\p{XIDC=:\AN\z:}', "");;
    Expect(0, 917999, '\p{XIDC=:\AN\z:}', "");;
    Expect(1, 918000, '\p{XIDC=n}', "");
    Expect(0, 918000, '\p{^XIDC=n}', "");
    Expect(0, 918000, '\P{XIDC=n}', "");
    Expect(1, 918000, '\P{^XIDC=n}', "");
    Expect(0, 917999, '\p{XIDC=n}', "");
    Expect(1, 917999, '\p{^XIDC=n}', "");
    Expect(1, 917999, '\P{XIDC=n}', "");
    Expect(0, 917999, '\P{^XIDC=n}', "");
    Expect(1, 918000, '\p{XIDC=:\An\z:}', "");;
    Expect(0, 917999, '\p{XIDC=:\An\z:}', "");;
    Expect(1, 918000, '\p{XIDC=-N}', "");
    Expect(0, 918000, '\p{^XIDC=-N}', "");
    Expect(0, 918000, '\P{XIDC=-N}', "");
    Expect(1, 918000, '\P{^XIDC=-N}', "");
    Expect(0, 917999, '\p{XIDC=-N}', "");
    Expect(1, 917999, '\p{^XIDC=-N}', "");
    Expect(1, 917999, '\P{XIDC=-N}', "");
    Expect(0, 917999, '\P{^XIDC=-N}', "");
    Error('\p{Is_XID_Continue=	/a/f}');
    Error('\P{Is_XID_Continue=	/a/f}');
    Expect(1, 918000, '\p{Is_XID_Continue=f}', "");
    Expect(0, 918000, '\p{^Is_XID_Continue=f}', "");
    Expect(0, 918000, '\P{Is_XID_Continue=f}', "");
    Expect(1, 918000, '\P{^Is_XID_Continue=f}', "");
    Expect(0, 917999, '\p{Is_XID_Continue=f}', "");
    Expect(1, 917999, '\p{^Is_XID_Continue=f}', "");
    Expect(1, 917999, '\P{Is_XID_Continue=f}', "");
    Expect(0, 917999, '\P{^Is_XID_Continue=f}', "");
    Expect(1, 918000, '\p{Is_XID_Continue=--F}', "");
    Expect(0, 918000, '\p{^Is_XID_Continue=--F}', "");
    Expect(0, 918000, '\P{Is_XID_Continue=--F}', "");
    Expect(1, 918000, '\P{^Is_XID_Continue=--F}', "");
    Expect(0, 917999, '\p{Is_XID_Continue=--F}', "");
    Expect(1, 917999, '\p{^Is_XID_Continue=--F}', "");
    Expect(1, 917999, '\P{Is_XID_Continue=--F}', "");
    Expect(0, 917999, '\P{^Is_XID_Continue=--F}', "");
    Error('\p{Is_XIDC=	false/a/}');
    Error('\P{Is_XIDC=	false/a/}');
    Expect(1, 918000, '\p{Is_XIDC=false}', "");
    Expect(0, 918000, '\p{^Is_XIDC=false}', "");
    Expect(0, 918000, '\P{Is_XIDC=false}', "");
    Expect(1, 918000, '\P{^Is_XIDC=false}', "");
    Expect(0, 917999, '\p{Is_XIDC=false}', "");
    Expect(1, 917999, '\p{^Is_XIDC=false}', "");
    Expect(1, 917999, '\P{Is_XIDC=false}', "");
    Expect(0, 917999, '\P{^Is_XIDC=false}', "");
    Expect(1, 918000, '\p{Is_XIDC= -false}', "");
    Expect(0, 918000, '\p{^Is_XIDC= -false}', "");
    Expect(0, 918000, '\P{Is_XIDC= -false}', "");
    Expect(1, 918000, '\P{^Is_XIDC= -false}', "");
    Expect(0, 917999, '\p{Is_XIDC= -false}', "");
    Expect(1, 917999, '\p{^Is_XIDC= -false}', "");
    Expect(1, 917999, '\P{Is_XIDC= -false}', "");
    Expect(0, 917999, '\P{^Is_XIDC= -false}', "");
    Error('\p{XID_Continue=__YES/a/}');
    Error('\P{XID_Continue=__YES/a/}');
    Expect(1, 917999, '\p{XID_Continue=:\AYes\z:}', "");;
    Expect(0, 918000, '\p{XID_Continue=:\AYes\z:}', "");;
    Expect(1, 917999, '\p{XID_Continue=yes}', "");
    Expect(0, 917999, '\p{^XID_Continue=yes}', "");
    Expect(0, 917999, '\P{XID_Continue=yes}', "");
    Expect(1, 917999, '\P{^XID_Continue=yes}', "");
    Expect(0, 918000, '\p{XID_Continue=yes}', "");
    Expect(1, 918000, '\p{^XID_Continue=yes}', "");
    Expect(1, 918000, '\P{XID_Continue=yes}', "");
    Expect(0, 918000, '\P{^XID_Continue=yes}', "");
    Expect(1, 917999, '\p{XID_Continue=:\Ayes\z:}', "");;
    Expect(0, 918000, '\p{XID_Continue=:\Ayes\z:}', "");;
    Expect(1, 917999, '\p{XID_Continue=_	YES}', "");
    Expect(0, 917999, '\p{^XID_Continue=_	YES}', "");
    Expect(0, 917999, '\P{XID_Continue=_	YES}', "");
    Expect(1, 917999, '\P{^XID_Continue=_	YES}', "");
    Expect(0, 918000, '\p{XID_Continue=_	YES}', "");
    Expect(1, 918000, '\p{^XID_Continue=_	YES}', "");
    Expect(1, 918000, '\P{XID_Continue=_	YES}', "");
    Expect(0, 918000, '\P{^XID_Continue=_	YES}', "");
    Error('\p{XIDC= :=Y}');
    Error('\P{XIDC= :=Y}');
    Expect(1, 917999, '\p{XIDC=:\AY\z:}', "");;
    Expect(0, 918000, '\p{XIDC=:\AY\z:}', "");;
    Expect(1, 917999, '\p{XIDC=y}', "");
    Expect(0, 917999, '\p{^XIDC=y}', "");
    Expect(0, 917999, '\P{XIDC=y}', "");
    Expect(1, 917999, '\P{^XIDC=y}', "");
    Expect(0, 918000, '\p{XIDC=y}', "");
    Expect(1, 918000, '\p{^XIDC=y}', "");
    Expect(1, 918000, '\P{XIDC=y}', "");
    Expect(0, 918000, '\P{^XIDC=y}', "");
    Expect(1, 917999, '\p{XIDC=:\Ay\z:}', "");;
    Expect(0, 918000, '\p{XIDC=:\Ay\z:}', "");;
    Expect(1, 917999, '\p{XIDC=_	Y}', "");
    Expect(0, 917999, '\p{^XIDC=_	Y}', "");
    Expect(0, 917999, '\P{XIDC=_	Y}', "");
    Expect(1, 917999, '\P{^XIDC=_	Y}', "");
    Expect(0, 918000, '\p{XIDC=_	Y}', "");
    Expect(1, 918000, '\p{^XIDC=_	Y}', "");
    Expect(1, 918000, '\P{XIDC=_	Y}', "");
    Expect(0, 918000, '\P{^XIDC=_	Y}', "");
    Error('\p{Is_XID_Continue=T/a/}');
    Error('\P{Is_XID_Continue=T/a/}');
    Expect(1, 917999, '\p{Is_XID_Continue=t}', "");
    Expect(0, 917999, '\p{^Is_XID_Continue=t}', "");
    Expect(0, 917999, '\P{Is_XID_Continue=t}', "");
    Expect(1, 917999, '\P{^Is_XID_Continue=t}', "");
    Expect(0, 918000, '\p{Is_XID_Continue=t}', "");
    Expect(1, 918000, '\p{^Is_XID_Continue=t}', "");
    Expect(1, 918000, '\P{Is_XID_Continue=t}', "");
    Expect(0, 918000, '\P{^Is_XID_Continue=t}', "");
    Expect(1, 917999, '\p{Is_XID_Continue=	T}', "");
    Expect(0, 917999, '\p{^Is_XID_Continue=	T}', "");
    Expect(0, 917999, '\P{Is_XID_Continue=	T}', "");
    Expect(1, 917999, '\P{^Is_XID_Continue=	T}', "");
    Expect(0, 918000, '\p{Is_XID_Continue=	T}', "");
    Expect(1, 918000, '\p{^Is_XID_Continue=	T}', "");
    Expect(1, 918000, '\P{Is_XID_Continue=	T}', "");
    Expect(0, 918000, '\P{^Is_XID_Continue=	T}', "");
    Error('\p{Is_XIDC=_:=true}');
    Error('\P{Is_XIDC=_:=true}');
    Expect(1, 917999, '\p{Is_XIDC=true}', "");
    Expect(0, 917999, '\p{^Is_XIDC=true}', "");
    Expect(0, 917999, '\P{Is_XIDC=true}', "");
    Expect(1, 917999, '\P{^Is_XIDC=true}', "");
    Expect(0, 918000, '\p{Is_XIDC=true}', "");
    Expect(1, 918000, '\p{^Is_XIDC=true}', "");
    Expect(1, 918000, '\P{Is_XIDC=true}', "");
    Expect(0, 918000, '\P{^Is_XIDC=true}', "");
    Expect(1, 917999, '\p{Is_XIDC= 	TRUE}', "");
    Expect(0, 917999, '\p{^Is_XIDC= 	TRUE}', "");
    Expect(0, 917999, '\P{Is_XIDC= 	TRUE}', "");
    Expect(1, 917999, '\P{^Is_XIDC= 	TRUE}', "");
    Expect(0, 918000, '\p{Is_XIDC= 	TRUE}', "");
    Expect(1, 918000, '\p{^Is_XIDC= 	TRUE}', "");
    Expect(1, 918000, '\P{Is_XIDC= 	TRUE}', "");
    Expect(0, 918000, '\P{^Is_XIDC= 	TRUE}', "");
    Error('\p{XID_Start= no:=}');
    Error('\P{XID_Start= no:=}');
    Expect(1, 195102, '\p{XID_Start=:\ANo\z:}', "");;
    Expect(0, 195101, '\p{XID_Start=:\ANo\z:}', "");;
    Expect(1, 195102, '\p{XID_Start=no}', "");
    Expect(0, 195102, '\p{^XID_Start=no}', "");
    Expect(0, 195102, '\P{XID_Start=no}', "");
    Expect(1, 195102, '\P{^XID_Start=no}', "");
    Expect(0, 195101, '\p{XID_Start=no}', "");
    Expect(1, 195101, '\p{^XID_Start=no}', "");
    Expect(1, 195101, '\P{XID_Start=no}', "");
    Expect(0, 195101, '\P{^XID_Start=no}', "");
    Expect(1, 195102, '\p{XID_Start=:\Ano\z:}', "");;
    Expect(0, 195101, '\p{XID_Start=:\Ano\z:}', "");;
    Expect(1, 195102, '\p{XID_Start=	_No}', "");
    Expect(0, 195102, '\p{^XID_Start=	_No}', "");
    Expect(0, 195102, '\P{XID_Start=	_No}', "");
    Expect(1, 195102, '\P{^XID_Start=	_No}', "");
    Expect(0, 195101, '\p{XID_Start=	_No}', "");
    Expect(1, 195101, '\p{^XID_Start=	_No}', "");
    Expect(1, 195101, '\P{XID_Start=	_No}', "");
    Expect(0, 195101, '\P{^XID_Start=	_No}', "");
    Error('\p{XIDS=/a/_	N}');
    Error('\P{XIDS=/a/_	N}');
    Expect(1, 195102, '\p{XIDS=:\AN\z:}', "");;
    Expect(0, 195101, '\p{XIDS=:\AN\z:}', "");;
    Expect(1, 195102, '\p{XIDS=n}', "");
    Expect(0, 195102, '\p{^XIDS=n}', "");
    Expect(0, 195102, '\P{XIDS=n}', "");
    Expect(1, 195102, '\P{^XIDS=n}', "");
    Expect(0, 195101, '\p{XIDS=n}', "");
    Expect(1, 195101, '\p{^XIDS=n}', "");
    Expect(1, 195101, '\P{XIDS=n}', "");
    Expect(0, 195101, '\P{^XIDS=n}', "");
    Expect(1, 195102, '\p{XIDS=:\An\z:}', "");;
    Expect(0, 195101, '\p{XIDS=:\An\z:}', "");;
    Expect(1, 195102, '\p{XIDS=-_n}', "");
    Expect(0, 195102, '\p{^XIDS=-_n}', "");
    Expect(0, 195102, '\P{XIDS=-_n}', "");
    Expect(1, 195102, '\P{^XIDS=-_n}', "");
    Expect(0, 195101, '\p{XIDS=-_n}', "");
    Expect(1, 195101, '\p{^XIDS=-_n}', "");
    Expect(1, 195101, '\P{XIDS=-_n}', "");
    Expect(0, 195101, '\P{^XIDS=-_n}', "");
    Error('\p{Is_XID_Start=__F:=}');
    Error('\P{Is_XID_Start=__F:=}');
    Expect(1, 195102, '\p{Is_XID_Start=f}', "");
    Expect(0, 195102, '\p{^Is_XID_Start=f}', "");
    Expect(0, 195102, '\P{Is_XID_Start=f}', "");
    Expect(1, 195102, '\P{^Is_XID_Start=f}', "");
    Expect(0, 195101, '\p{Is_XID_Start=f}', "");
    Expect(1, 195101, '\p{^Is_XID_Start=f}', "");
    Expect(1, 195101, '\P{Is_XID_Start=f}', "");
    Expect(0, 195101, '\P{^Is_XID_Start=f}', "");
    Expect(1, 195102, '\p{Is_XID_Start=	-F}', "");
    Expect(0, 195102, '\p{^Is_XID_Start=	-F}', "");
    Expect(0, 195102, '\P{Is_XID_Start=	-F}', "");
    Expect(1, 195102, '\P{^Is_XID_Start=	-F}', "");
    Expect(0, 195101, '\p{Is_XID_Start=	-F}', "");
    Expect(1, 195101, '\p{^Is_XID_Start=	-F}', "");
    Expect(1, 195101, '\P{Is_XID_Start=	-F}', "");
    Expect(0, 195101, '\P{^Is_XID_Start=	-F}', "");
    Error('\p{Is_XIDS=_	False/a/}');
    Error('\P{Is_XIDS=_	False/a/}');
    Expect(1, 195102, '\p{Is_XIDS=false}', "");
    Expect(0, 195102, '\p{^Is_XIDS=false}', "");
    Expect(0, 195102, '\P{Is_XIDS=false}', "");
    Expect(1, 195102, '\P{^Is_XIDS=false}', "");
    Expect(0, 195101, '\p{Is_XIDS=false}', "");
    Expect(1, 195101, '\p{^Is_XIDS=false}', "");
    Expect(1, 195101, '\P{Is_XIDS=false}', "");
    Expect(0, 195101, '\P{^Is_XIDS=false}', "");
    Expect(1, 195102, '\p{Is_XIDS= 	false}', "");
    Expect(0, 195102, '\p{^Is_XIDS= 	false}', "");
    Expect(0, 195102, '\P{Is_XIDS= 	false}', "");
    Expect(1, 195102, '\P{^Is_XIDS= 	false}', "");
    Expect(0, 195101, '\p{Is_XIDS= 	false}', "");
    Expect(1, 195101, '\p{^Is_XIDS= 	false}', "");
    Expect(1, 195101, '\P{Is_XIDS= 	false}', "");
    Expect(0, 195101, '\P{^Is_XIDS= 	false}', "");
    Error('\p{XID_Start=-:=yes}');
    Error('\P{XID_Start=-:=yes}');
    Expect(1, 195101, '\p{XID_Start=:\AYes\z:}', "");;
    Expect(0, 195102, '\p{XID_Start=:\AYes\z:}', "");;
    Expect(1, 195101, '\p{XID_Start=yes}', "");
    Expect(0, 195101, '\p{^XID_Start=yes}', "");
    Expect(0, 195101, '\P{XID_Start=yes}', "");
    Expect(1, 195101, '\P{^XID_Start=yes}', "");
    Expect(0, 195102, '\p{XID_Start=yes}', "");
    Expect(1, 195102, '\p{^XID_Start=yes}', "");
    Expect(1, 195102, '\P{XID_Start=yes}', "");
    Expect(0, 195102, '\P{^XID_Start=yes}', "");
    Expect(1, 195101, '\p{XID_Start=:\Ayes\z:}', "");;
    Expect(0, 195102, '\p{XID_Start=:\Ayes\z:}', "");;
    Expect(1, 195101, '\p{XID_Start= yes}', "");
    Expect(0, 195101, '\p{^XID_Start= yes}', "");
    Expect(0, 195101, '\P{XID_Start= yes}', "");
    Expect(1, 195101, '\P{^XID_Start= yes}', "");
    Expect(0, 195102, '\p{XID_Start= yes}', "");
    Expect(1, 195102, '\p{^XID_Start= yes}', "");
    Expect(1, 195102, '\P{XID_Start= yes}', "");
    Expect(0, 195102, '\P{^XID_Start= yes}', "");
    Error('\p{XIDS=-:=y}');
    Error('\P{XIDS=-:=y}');
    Expect(1, 195101, '\p{XIDS=:\AY\z:}', "");;
    Expect(0, 195102, '\p{XIDS=:\AY\z:}', "");;
    Expect(1, 195101, '\p{XIDS=y}', "");
    Expect(0, 195101, '\p{^XIDS=y}', "");
    Expect(0, 195101, '\P{XIDS=y}', "");
    Expect(1, 195101, '\P{^XIDS=y}', "");
    Expect(0, 195102, '\p{XIDS=y}', "");
    Expect(1, 195102, '\p{^XIDS=y}', "");
    Expect(1, 195102, '\P{XIDS=y}', "");
    Expect(0, 195102, '\P{^XIDS=y}', "");
    Expect(1, 195101, '\p{XIDS=:\Ay\z:}', "");;
    Expect(0, 195102, '\p{XIDS=:\Ay\z:}', "");;
    Expect(1, 195101, '\p{XIDS=	_Y}', "");
    Expect(0, 195101, '\p{^XIDS=	_Y}', "");
    Expect(0, 195101, '\P{XIDS=	_Y}', "");
    Expect(1, 195101, '\P{^XIDS=	_Y}', "");
    Expect(0, 195102, '\p{XIDS=	_Y}', "");
    Expect(1, 195102, '\p{^XIDS=	_Y}', "");
    Expect(1, 195102, '\P{XIDS=	_Y}', "");
    Expect(0, 195102, '\P{^XIDS=	_Y}', "");
    Error('\p{Is_XID_Start=	t/a/}');
    Error('\P{Is_XID_Start=	t/a/}');
    Expect(1, 195101, '\p{Is_XID_Start=t}', "");
    Expect(0, 195101, '\p{^Is_XID_Start=t}', "");
    Expect(0, 195101, '\P{Is_XID_Start=t}', "");
    Expect(1, 195101, '\P{^Is_XID_Start=t}', "");
    Expect(0, 195102, '\p{Is_XID_Start=t}', "");
    Expect(1, 195102, '\p{^Is_XID_Start=t}', "");
    Expect(1, 195102, '\P{Is_XID_Start=t}', "");
    Expect(0, 195102, '\P{^Is_XID_Start=t}', "");
    Expect(1, 195101, '\p{Is_XID_Start=_T}', "");
    Expect(0, 195101, '\p{^Is_XID_Start=_T}', "");
    Expect(0, 195101, '\P{Is_XID_Start=_T}', "");
    Expect(1, 195101, '\P{^Is_XID_Start=_T}', "");
    Expect(0, 195102, '\p{Is_XID_Start=_T}', "");
    Expect(1, 195102, '\p{^Is_XID_Start=_T}', "");
    Expect(1, 195102, '\P{Is_XID_Start=_T}', "");
    Expect(0, 195102, '\P{^Is_XID_Start=_T}', "");
    Error('\p{Is_XIDS=:= _True}');
    Error('\P{Is_XIDS=:= _True}');
    Expect(1, 195101, '\p{Is_XIDS=true}', "");
    Expect(0, 195101, '\p{^Is_XIDS=true}', "");
    Expect(0, 195101, '\P{Is_XIDS=true}', "");
    Expect(1, 195101, '\P{^Is_XIDS=true}', "");
    Expect(0, 195102, '\p{Is_XIDS=true}', "");
    Expect(1, 195102, '\p{^Is_XIDS=true}', "");
    Expect(1, 195102, '\P{Is_XIDS=true}', "");
    Expect(0, 195102, '\P{^Is_XIDS=true}', "");
    Expect(1, 195101, '\p{Is_XIDS=True}', "");
    Expect(0, 195101, '\p{^Is_XIDS=True}', "");
    Expect(0, 195101, '\P{Is_XIDS=True}', "");
    Expect(1, 195101, '\P{^Is_XIDS=True}', "");
    Expect(0, 195102, '\p{Is_XIDS=True}', "");
    Expect(1, 195102, '\p{^Is_XIDS=True}', "");
    Expect(1, 195102, '\P{Is_XIDS=True}', "");
    Expect(0, 195102, '\P{^Is_XIDS=True}', "");
    Error('\p{Expands_On_NFC=No}');
    Error('\P{Expands_On_NFC=No}');
    Error('\p{XO_NFC=N}');
    Error('\P{XO_NFC=N}');
    Error('\p{Is_Expands_On_NFC=F}');
    Error('\P{Is_Expands_On_NFC=F}');
    Error('\p{Is_XO_NFC=False}');
    Error('\P{Is_XO_NFC=False}');
    Error('\p{Expands_On_NFC=Yes}');
    Error('\P{Expands_On_NFC=Yes}');
    Error('\p{XO_NFC=Y}');
    Error('\P{XO_NFC=Y}');
    Error('\p{Is_Expands_On_NFC=T}');
    Error('\P{Is_Expands_On_NFC=T}');
    Error('\p{Is_XO_NFC:   True}');
    Error('\P{Is_XO_NFC:   True}');
    Error('\p{Expands_On_NFD=No}');
    Error('\P{Expands_On_NFD=No}');
    Error('\p{XO_NFD=N}');
    Error('\P{XO_NFD=N}');
    Error('\p{Is_Expands_On_NFD=F}');
    Error('\P{Is_Expands_On_NFD=F}');
    Error('\p{Is_XO_NFD=False}');
    Error('\P{Is_XO_NFD=False}');
    Error('\p{Expands_On_NFD:   Yes}');
    Error('\P{Expands_On_NFD:   Yes}');
    Error('\p{XO_NFD:	Y}');
    Error('\P{XO_NFD:	Y}');
    Error('\p{Is_Expands_On_NFD=T}');
    Error('\P{Is_Expands_On_NFD=T}');
    Error('\p{Is_XO_NFD=True}');
    Error('\P{Is_XO_NFD=True}');
    Error('\p{Expands_On_NFKC=No}');
    Error('\P{Expands_On_NFKC=No}');
    Error('\p{XO_NFKC=N}');
    Error('\P{XO_NFKC=N}');
    Error('\p{Is_Expands_On_NFKC=F}');
    Error('\P{Is_Expands_On_NFKC=F}');
    Error('\p{Is_XO_NFKC=False}');
    Error('\P{Is_XO_NFKC=False}');
    Error('\p{Expands_On_NFKC: Yes}');
    Error('\P{Expands_On_NFKC: Yes}');
    Error('\p{XO_NFKC=Y}');
    Error('\P{XO_NFKC=Y}');
    Error('\p{Is_Expands_On_NFKC=T}');
    Error('\P{Is_Expands_On_NFKC=T}');
    Error('\p{Is_XO_NFKC=True}');
    Error('\P{Is_XO_NFKC=True}');
    Error('\p{Expands_On_NFKD=No}');
    Error('\P{Expands_On_NFKD=No}');
    Error('\p{XO_NFKD=N}');
    Error('\P{XO_NFKD=N}');
    Error('\p{Is_Expands_On_NFKD=F}');
    Error('\P{Is_Expands_On_NFKD=F}');
    Error('\p{Is_XO_NFKD=False}');
    Error('\P{Is_XO_NFKD=False}');
    Error('\p{Expands_On_NFKD=Yes}');
    Error('\P{Expands_On_NFKD=Yes}');
    Error('\p{XO_NFKD:	Y}');
    Error('\P{XO_NFKD:	Y}');
    Error('\p{Is_Expands_On_NFKD=T}');
    Error('\P{Is_Expands_On_NFKD=T}');
    Error('\p{Is_XO_NFKD:   True}');
    Error('\P{Is_XO_NFKD:   True}');
    Error('\p{Extended_Pictographic=No}');
    Error('\P{Extended_Pictographic=No}');
    Error('\p{XPG: N}');
    Error('\P{XPG: N}');
    Error('\p{Is_Extended_Pictographic:   F}');
    Error('\P{Is_Extended_Pictographic:   F}');
    Error('\p{Is_XPG=False}');
    Error('\P{Is_XPG=False}');
    Error('\p{Extended_Pictographic=Yes}');
    Error('\P{Extended_Pictographic=Yes}');
    Error('\p{XPG=Y}');
    Error('\P{XPG=Y}');
    Error('\p{Is_Extended_Pictographic=T}');
    Error('\P{Is_Extended_Pictographic=T}');
    Error('\p{Is_XPG=True}');
    Error('\P{Is_XPG=True}');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 5) {
    Test_GCB('÷ 0020 ÷ 0020 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 0020 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 000D ÷	#  ÷ [0.2] SPACE (Other) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 000D ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 000A ÷	#  ÷ [0.2] SPACE (Other) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 000A ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 0001 ÷	#  ÷ [0.2] SPACE (Other) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 0001 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0020 × 034F ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 × 034F ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 1F1E6 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 0600 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 0600 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0903 ÷	#  ÷ [0.2] SPACE (Other) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 × 0903 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 1100 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 1100 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 1160 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 1160 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 11A8 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ AC00 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ AC00 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ AC01 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ AC01 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 231A ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 231A ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0300 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 × 0300 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0020 × 200D ÷	#  ÷ [0.2] SPACE (Other) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 × 200D ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0020 ÷ 0378 ÷	#  ÷ [0.2] SPACE (Other) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0020 × 0308 ÷ 0378 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0020 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 0020 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 000D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 000D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 000D × 000A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) × [3.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 000A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0001 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 0001 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 034F ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 × 034F ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 1F1E6 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0600 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 0600 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0903 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 × 0903 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 1100 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 1100 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 1160 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 1160 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 11A8 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 11A8 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ AC00 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ AC00 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ AC01 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ AC01 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 231A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 231A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0300 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 × 0300 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 200D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 × 200D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0378 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 000D ÷ 0308 ÷ 0378 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0020 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 0020 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 000D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 000D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 000A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 000A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0001 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 0001 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 034F ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 × 034F ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 1F1E6 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0600 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 0600 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0903 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 × 0903 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 1100 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 1100 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 1160 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 1160 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 11A8 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 11A8 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ AC00 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ AC00 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ AC01 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ AC01 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 231A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 231A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0300 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 × 0300 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 200D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 × 200D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0378 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 000A ÷ 0308 ÷ 0378 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0020 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 0020 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 000D ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 000D ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 000A ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 000A ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0001 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 0001 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 034F ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 × 034F ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 1F1E6 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0600 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 0600 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0903 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 × 0903 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 1100 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 1100 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 1160 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 1160 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 11A8 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 11A8 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ AC00 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ AC00 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ AC01 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ AC01 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 231A ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 231A ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0300 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 × 0300 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 200D ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 × 200D ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0378 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0001 ÷ 0308 ÷ 0378 ÷	#  ÷ [0.2] <START OF HEADING> (Control) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 0020 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 0020 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 000D ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 000D ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 000A ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 000A ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 0001 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 0001 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 034F × 034F ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 × 034F ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 1F1E6 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 0600 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 0600 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 034F × 0903 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 × 0903 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 1100 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 1100 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 1160 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 1160 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 11A8 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 11A8 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ AC00 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ AC00 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ AC01 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ AC01 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 231A ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 231A ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 034F × 0300 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 × 0300 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 034F × 200D ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 × 200D ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 034F ÷ 0378 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 034F × 0308 ÷ 0378 ÷	#  ÷ [0.2] COMBINING GRAPHEME JOINER (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 0020 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 0020 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 000D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 000D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 000A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 000A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 0001 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 0001 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 034F ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 × 034F ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 1F1E6 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [12.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 0600 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 0600 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0903 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 × 0903 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 1100 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 1100 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 1160 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 1160 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 11A8 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ AC00 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ AC00 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ AC01 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ AC01 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 231A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 231A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0300 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 × 0300 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 200D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 × 200D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 ÷ 0378 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 0308 ÷ 0378 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0020 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 0020 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0600 ÷ 000D ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 000D ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0600 ÷ 000A ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 000A ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0600 ÷ 0001 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 0001 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0600 × 034F ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 × 034F ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0600 × 1F1E6 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0600 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 0600 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0903 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 × 0903 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0600 × 1100 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 1100 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0600 × 1160 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 1160 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0600 × 11A8 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0600 × AC00 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ AC00 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0600 × AC01 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ AC01 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0600 × 231A ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 231A ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0300 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 × 0300 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0600 × 200D ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 × 200D ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0378 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.2] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0600 × 0308 ÷ 0378 ÷	#  ÷ [0.2] ARABIC NUMBER SIGN (Prepend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 0020 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 0020 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 000D ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 000D ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 000A ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 000A ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 0001 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 0001 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0903 × 034F ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 × 034F ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 1F1E6 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 0600 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 0600 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0903 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 × 0903 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 1100 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 1100 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 1160 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 1160 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 11A8 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ AC00 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ AC00 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ AC01 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ AC01 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 231A ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 231A ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0300 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 × 0300 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0903 × 200D ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 × 200D ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0903 ÷ 0378 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0903 × 0308 ÷ 0378 ÷	#  ÷ [0.2] DEVANAGARI SIGN VISARGA (SpacingMark) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 0020 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 0020 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 000D ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 000D ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 000A ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 000A ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 0001 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 0001 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1100 × 034F ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 × 034F ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 0600 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 0600 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0903 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 × 0903 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1100 × 1100 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [6.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 1100 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1100 × 1160 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [6.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 1160 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 11A8 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1100 × AC00 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [6.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ AC00 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1100 × AC01 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [6.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ AC01 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 231A ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 231A ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0300 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 × 0300 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1100 × 200D ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 × 200D ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1100 ÷ 0378 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1100 × 0308 ÷ 0378 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 0020 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 0020 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 000D ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 000D ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 000A ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 000A ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 0001 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 0001 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 1160 × 034F ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 × 034F ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 0600 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 0600 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0903 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 × 0903 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 1100 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 1100 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1160 × 1160 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [7.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 1160 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 1160 × 11A8 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [7.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ AC00 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ AC00 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ AC01 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ AC01 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 231A ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 231A ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0300 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 × 0300 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1160 × 200D ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 × 200D ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 1160 ÷ 0378 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 1160 × 0308 ÷ 0378 ÷	#  ÷ [0.2] HANGUL JUNGSEONG FILLER (V) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 0020 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 0020 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 000D ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 000D ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 000A ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 000A ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 0001 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 0001 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 034F ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 × 034F ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 0600 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 0600 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0903 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 × 0903 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 1100 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 1100 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 1160 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 1160 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 11A8 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [8.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ AC00 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ AC00 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ AC01 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ AC01 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 231A ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 231A ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0300 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 × 0300 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 200D ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 × 200D ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 11A8 ÷ 0378 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 11A8 × 0308 ÷ 0378 ÷	#  ÷ [0.2] HANGUL JONGSEONG KIYEOK (T) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 0020 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 0020 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 000D ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 000D ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 000A ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 000A ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 0001 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 0001 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ AC00 × 034F ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 × 034F ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 0600 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 0600 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0903 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 × 0903 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 1100 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 1100 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ AC00 × 1160 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [7.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 1160 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ AC00 × 11A8 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [7.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ AC00 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ AC00 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ AC01 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ AC01 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 231A ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 231A ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0300 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 × 0300 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ AC00 × 200D ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 × 200D ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ AC00 ÷ 0378 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ AC00 × 0308 ÷ 0378 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 0020 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 0020 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 000D ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 000D ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 000A ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 000A ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 0001 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 0001 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ AC01 × 034F ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 × 034F ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 0600 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 0600 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0903 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 × 0903 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 1100 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 1100 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 1160 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 1160 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ AC01 × 11A8 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [8.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ AC00 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ AC00 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ AC01 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ AC01 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 231A ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 231A ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0300 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 × 0300 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ AC01 × 200D ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 × 200D ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ AC01 ÷ 0378 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ AC01 × 0308 ÷ 0378 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 0020 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 0020 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 000D ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 000D ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 000A ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 000A ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 0001 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 0001 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 231A × 034F ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 × 034F ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 1F1E6 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 0600 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 0600 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 231A × 0903 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 × 0903 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 1100 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 1100 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 1160 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 1160 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 11A8 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 11A8 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ AC00 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ AC00 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ AC01 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ AC01 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 231A ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 231A ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 231A × 0300 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 × 0300 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 231A × 200D ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 × 200D ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 231A ÷ 0378 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 231A × 0308 ÷ 0378 ÷	#  ÷ [0.2] WATCH (ExtPict) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 0020 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 0020 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 000D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 000D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 000A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 000A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 0001 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 0001 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0300 × 034F ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 × 034F ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 1F1E6 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 0600 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 0600 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0903 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 × 0903 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 1100 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 1100 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 1160 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 1160 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 11A8 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ AC00 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ AC00 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ AC01 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ AC01 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 231A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 231A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0300 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 × 0300 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0300 × 200D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 × 200D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0300 ÷ 0378 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0300 × 0308 ÷ 0378 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 0020 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 0020 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 000D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 000D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 000A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 000A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 0001 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 0001 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 200D × 034F ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 × 034F ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 1F1E6 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 0600 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 0600 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 200D × 0903 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 × 0903 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 1100 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 1100 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 1160 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 1160 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 11A8 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 11A8 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ AC00 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ AC00 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ AC01 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ AC01 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 231A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 231A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 200D × 0300 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 × 0300 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 200D × 200D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 × 200D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 200D ÷ 0378 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 200D × 0308 ÷ 0378 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 0020 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 0020 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 000D ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 000D ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 000A ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 000A ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 0001 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 0001 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [5.0] <START OF HEADING> (Control) ÷ [0.3]');
    Test_GCB('÷ 0378 × 034F ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 × 034F ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAPHEME JOINER (Extend) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 1F1E6 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 0600 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 0600 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0903 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 × 0903 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 1100 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 1100 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 1160 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 1160 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JUNGSEONG FILLER (V) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 11A8 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 11A8 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL JONGSEONG KIYEOK (T) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ AC00 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ AC00 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GA (LV) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ AC01 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ AC01 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] HANGUL SYLLABLE GAG (LVT) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 231A ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 231A ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0300 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 × 0300 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] COMBINING GRAVE ACCENT (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0378 × 200D ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 × 200D ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0378 ÷ 0378 ÷	#  ÷ [0.2] <reserved-0378> (Other) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 0378 × 0308 ÷ 0378 ÷	#  ÷ [0.2] <reserved-0378> (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] <reserved-0378> (Other) ÷ [0.3]');
    Test_GCB('÷ 000D × 000A ÷ 0061 ÷ 000A ÷ 0308 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) × [3.0] <LINE FEED (LF)> (LF) ÷ [4.0] LATIN SMALL LETTER A (Other) ÷ [5.0] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0061 × 0308 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0020 × 200D ÷ 0646 ÷	#  ÷ [0.2] SPACE (Other) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] ARABIC LETTER NOON (Other) ÷ [0.3]');
    Test_GCB('÷ 0646 × 200D ÷ 0020 ÷	#  ÷ [0.2] ARABIC LETTER NOON (Other) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] SPACE (Other) ÷ [0.3]');
    Test_GCB('÷ 1100 × 1100 ÷	#  ÷ [0.2] HANGUL CHOSEONG KIYEOK (L) × [6.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ AC00 × 11A8 ÷ 1100 ÷	#  ÷ [0.2] HANGUL SYLLABLE GA (LV) × [7.0] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ AC01 × 11A8 ÷ 1100 ÷	#  ÷ [0.2] HANGUL SYLLABLE GAG (LVT) × [8.0] HANGUL JONGSEONG KIYEOK (T) ÷ [999.0] HANGUL CHOSEONG KIYEOK (L) ÷ [0.3]');
    Test_GCB('÷ 1F1E6 × 1F1E7 ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [12.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 ÷ 1F1E6 × 1F1E7 ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 ÷ 1F1E6 × 1F1E7 × 200D ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 ÷ 1F1E6 × 200D ÷ 1F1E7 × 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) × [13.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 ÷ 1F1E6 × 1F1E7 ÷ 1F1E8 × 1F1E9 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) × [13.0] REGIONAL INDICATOR SYMBOL LETTER D (RI) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [0.3]');
    Test_GCB('÷ 0061 × 0308 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 × 0903 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.1] DEVANAGARI SIGN VISARGA (SpacingMark) ÷ [999.0] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 ÷ 0600 × 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) ÷ [999.0] ARABIC NUMBER SIGN (Prepend) × [9.2] LATIN SMALL LETTER B (Other) ÷ [0.3]');
    Test_GCB('÷ 1F476 × 1F3FF ÷ 1F476 ÷	#  ÷ [0.2] BABY (ExtPict) × [9.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend) ÷ [999.0] BABY (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0061 × 1F3FF ÷ 1F476 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend) ÷ [999.0] BABY (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0061 × 1F3FF ÷ 1F476 × 200D × 1F6D1 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend) ÷ [999.0] BABY (ExtPict) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [11.0] OCTAGONAL SIGN (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 1F476 × 1F3FF × 0308 × 200D × 1F476 × 1F3FF ÷	#  ÷ [0.2] BABY (ExtPict) × [9.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend) × [9.0] COMBINING DIAERESIS (Extend_ExtCccZwj) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [11.0] BABY (ExtPict) × [9.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend) ÷ [0.3]');
    Test_GCB('÷ 1F6D1 × 200D × 1F6D1 ÷	#  ÷ [0.2] OCTAGONAL SIGN (ExtPict) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [11.0] OCTAGONAL SIGN (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 0061 × 200D ÷ 1F6D1 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] OCTAGONAL SIGN (ExtPict) ÷ [0.3]');
    Test_GCB('÷ 2701 × 200D × 2701 ÷	#  ÷ [0.2] UPPER BLADE SCISSORS (Other) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) × [11.0] UPPER BLADE SCISSORS (Other) ÷ [0.3]');
    Test_GCB('÷ 0061 × 200D ÷ 2701 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Other) × [9.0] ZERO WIDTH JOINER (ZWJ_ExtCccZwj) ÷ [999.0] UPPER BLADE SCISSORS (Other) ÷ [0.3]');
    Test_SB('÷ 0001 × 0001 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0001 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0001 × 000D ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 000D ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0001 × 000A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 000A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0001 × 0085 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0085 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0001 × 0009 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0009 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0001 × 0061 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0061 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0001 × 0041 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0041 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0001 × 01BB ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 01BB ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0001 × 0030 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0030 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0001 × 002E ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 002E ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0001 × 0021 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0021 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0001 × 0022 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0022 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0001 × 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0001 × 00AD ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 00AD ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0001 × 0300 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0001 × 0308 × 0300 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0001 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0001 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 000D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 000D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 000D × 000A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) × [3.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 000A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0085 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0085 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0009 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0009 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0061 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0061 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0041 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0041 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 01BB ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 01BB ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0030 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0030 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 002E ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 002E ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0021 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0021 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0022 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0022 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 00AD ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 00AD ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0300 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 000D ÷ 0308 × 0300 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0001 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0001 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 000D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 000D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 000A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 000A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0085 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0085 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0009 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0009 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0061 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0061 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0041 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0041 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 01BB ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 01BB ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0030 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0030 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 002E ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 002E ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0021 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0021 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0022 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0022 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 00AD ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 00AD ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0300 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 000A ÷ 0308 × 0300 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0001 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0001 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 000D ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 000D ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 000A ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 000A ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0085 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0085 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0009 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0009 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0061 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0061 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0041 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0041 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 01BB ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 01BB ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0030 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0030 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 002E ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 002E ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0021 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0021 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0022 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0022 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 002C ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 002C ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 00AD ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 00AD ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0300 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0085 ÷ 0308 × 0300 ÷	#  ÷ [0.2] <NEXT LINE (NEL)> (Sep) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0009 × 0001 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0001 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0009 × 000D ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 000D ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0009 × 000A ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 000A ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0009 × 0085 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0085 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0009 × 0009 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0009 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0009 × 0061 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0061 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0009 × 0041 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0041 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0009 × 01BB ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 01BB ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0009 × 0030 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0030 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0009 × 002E ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 002E ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0009 × 0021 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0021 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0009 × 0022 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0022 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0009 × 002C ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 002C ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0009 × 00AD ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 00AD ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0009 × 0300 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0009 × 0308 × 0300 ÷	#  ÷ [0.2] <CHARACTER TABULATION> (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0061 × 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0061 × 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0061 × 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0061 × 0085 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0085 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0061 × 0009 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0009 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0061 × 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0061 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0061 × 01BB ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 01BB ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0061 × 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0061 × 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0061 × 0021 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0021 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0061 × 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0061 × 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0061 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0061 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0041 × 0001 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0001 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0041 × 000D ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 000D ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0041 × 000A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 000A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0041 × 0085 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0085 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0041 × 0009 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0009 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0041 × 0061 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0061 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0041 × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0041 × 01BB ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 01BB ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0041 × 0030 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0030 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0041 × 002E ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 002E ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0041 × 0021 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0021 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0041 × 0022 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0022 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0041 × 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0041 × 00AD ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 00AD ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0041 × 0300 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0041 × 0308 × 0300 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 01BB × 0001 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0001 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 01BB × 000D ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 000D ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 01BB × 000A ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 000A ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 01BB × 0085 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0085 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 01BB × 0009 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0009 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 01BB × 0061 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0061 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 01BB × 0041 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0041 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 01BB × 01BB ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 01BB ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 01BB × 0030 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0030 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 01BB × 002E ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 002E ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 01BB × 0021 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0021 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 01BB × 0022 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0022 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 01BB × 002C ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 002C ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 01BB × 00AD ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 00AD ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 01BB × 0300 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 01BB × 0308 × 0300 ÷	#  ÷ [0.2] LATIN LETTER TWO WITH STROKE (OLetter) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0030 × 0001 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0001 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0030 × 000D ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 000D ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0030 × 000A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 000A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0030 × 0085 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0085 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0030 × 0009 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0009 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0030 × 0061 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0061 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0030 × 0041 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0041 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0030 × 01BB ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 01BB ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0030 × 0030 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0030 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0030 × 002E ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 002E ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0030 × 0021 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0021 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0030 × 0022 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0022 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0030 × 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0030 × 00AD ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 00AD ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0030 × 0300 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0030 × 0308 × 0300 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 002E ÷ 0001 ÷	#  ÷ [0.2] FULL STOP (ATerm) ÷ [11.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 ÷ 0001 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 002E × 000D ÷	#  ÷ [0.2] FULL STOP (ATerm) × [9.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 000D ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 002E × 000A ÷	#  ÷ [0.2] FULL STOP (ATerm) × [9.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 000A ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 002E × 0085 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [9.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0085 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 002E × 0009 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [9.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0009 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 002E × 0061 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [8.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0061 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 002E ÷ 0041 ÷	#  ÷ [0.2] FULL STOP (ATerm) ÷ [11.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 ÷ 0041 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 002E ÷ 01BB ÷	#  ÷ [0.2] FULL STOP (ATerm) ÷ [11.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 ÷ 01BB ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 002E × 0030 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [6.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0030 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [6.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 002E × 002E ÷	#  ÷ [0.2] FULL STOP (ATerm) × [8.1] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 002E ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.1] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 002E × 0021 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [8.1] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0021 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.1] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 002E × 0022 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [9.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0022 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 002E × 002C ÷	#  ÷ [0.2] FULL STOP (ATerm) × [8.1] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 002C ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.1] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 002E × 00AD ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 00AD ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 002E × 0300 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 002E × 0308 × 0300 ÷	#  ÷ [0.2] FULL STOP (ATerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0021 ÷ 0001 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) ÷ [11.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 ÷ 0001 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0021 × 000D ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [9.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 000D ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0021 × 000A ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [9.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 000A ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0021 × 0085 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [9.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 0085 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0021 × 0009 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [9.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 0009 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0021 ÷ 0061 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) ÷ [11.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 ÷ 0061 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0021 ÷ 0041 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) ÷ [11.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 ÷ 0041 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0021 ÷ 01BB ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) ÷ [11.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 ÷ 01BB ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0021 ÷ 0030 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) ÷ [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 ÷ 0030 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0021 × 002E ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [8.1] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 002E ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.1] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0021 × 0021 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [8.1] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 0021 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.1] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0021 × 0022 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [9.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 0022 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [9.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0021 × 002C ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [8.1] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 002C ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.1] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0021 × 00AD ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 00AD ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0021 × 0300 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0021 × 0308 × 0300 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0022 × 0001 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0001 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0022 × 000D ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 000D ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0022 × 000A ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 000A ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0022 × 0085 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0085 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0022 × 0009 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0009 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0022 × 0061 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0061 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0022 × 0041 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0041 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0022 × 01BB ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 01BB ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0022 × 0030 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0030 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0022 × 002E ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 002E ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0022 × 0021 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0021 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0022 × 0022 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0022 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0022 × 002C ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 002C ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0022 × 00AD ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 00AD ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0022 × 0300 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0022 × 0308 × 0300 ÷	#  ÷ [0.2] QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 002C × 0001 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0001 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 002C × 000D ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 000D ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 002C × 000A ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 000A ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 002C × 0085 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0085 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 002C × 0009 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0009 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 002C × 0061 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0061 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 002C × 0041 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0041 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 002C × 01BB ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 01BB ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 002C × 0030 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0030 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 002C × 002E ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 002E ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 002C × 0021 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0021 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 002C × 0022 ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0022 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 002C × 002C ÷	#  ÷ [0.2] COMMA (SContinue) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 002C ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 002C × 00AD ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 00AD ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 002C × 0300 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 002C × 0308 × 0300 ÷	#  ÷ [0.2] COMMA (SContinue) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 00AD × 0001 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0001 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 00AD × 000D ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 000D ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 00AD × 000A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 000A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 00AD × 0085 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0085 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 00AD × 0009 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0009 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 00AD × 0061 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0061 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 00AD × 0041 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0041 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 00AD × 01BB ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 01BB ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 00AD × 0030 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0030 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 00AD × 002E ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 002E ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 00AD × 0021 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0021 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 00AD × 0022 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0022 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 00AD × 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 00AD × 00AD ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 00AD ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 00AD × 0300 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 00AD × 0308 × 0300 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0300 × 0001 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0001 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_SB('÷ 0300 × 000D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 000D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_SB('÷ 0300 × 000A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 000A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_SB('÷ 0300 × 0085 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0085 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <NEXT LINE (NEL)> (Sep) ÷ [0.3]');
    Test_SB('÷ 0300 × 0009 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0009 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] <CHARACTER TABULATION> (Sp) ÷ [0.3]');
    Test_SB('÷ 0300 × 0061 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0061 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN SMALL LETTER A (Lower) ÷ [0.3]');
    Test_SB('÷ 0300 × 0041 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0041 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER A (Upper) ÷ [0.3]');
    Test_SB('÷ 0300 × 01BB ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 01BB ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN LETTER TWO WITH STROKE (OLetter) ÷ [0.3]');
    Test_SB('÷ 0300 × 0030 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0030 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_SB('÷ 0300 × 002E ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 002E ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0300 × 0021 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0021 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] EXCLAMATION MARK (STerm) ÷ [0.3]');
    Test_SB('÷ 0300 × 0022 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0022 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] QUOTATION MARK (Close) ÷ [0.3]');
    Test_SB('÷ 0300 × 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [998.0] COMMA (SContinue) ÷ [0.3]');
    Test_SB('÷ 0300 × 00AD ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 00AD ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_SB('÷ 0300 × 0300 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0300 × 0308 × 0300 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 000D × 000A ÷ 0061 × 000A ÷ 0308 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) × [3.0] <LINE FEED (LF)> (LF) ÷ [4.0] LATIN SMALL LETTER A (Lower) × [998.0] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0061 × 0308 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (Lower) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [0.3]');
    Test_SB('÷ 0020 × 200D × 0646 ÷	#  ÷ [0.2] SPACE (Sp) × [5.0] ZERO WIDTH JOINER (Extend_FE) × [998.0] ARABIC LETTER NOON (OLetter) ÷ [0.3]');
    Test_SB('÷ 0646 × 200D × 0020 ÷	#  ÷ [0.2] ARABIC LETTER NOON (OLetter) × [5.0] ZERO WIDTH JOINER (Extend_FE) × [998.0] SPACE (Sp) ÷ [0.3]');
    Test_SB('÷ 0028 × 0022 × 0047 × 006F × 002E × 0022 × 0029 × 0020 ÷ 0028 × 0048 × 0065 × 0020 × 0064 × 0069 × 0064 × 002E × 0029 ÷	#  ÷ [0.2] LEFT PARENTHESIS (Close) × [998.0] QUOTATION MARK (Close) × [998.0] LATIN CAPITAL LETTER G (Upper) × [998.0] LATIN SMALL LETTER O (Lower) × [998.0] FULL STOP (ATerm) × [9.0] QUOTATION MARK (Close) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] SPACE (Sp) ÷ [11.0] LEFT PARENTHESIS (Close) × [998.0] LATIN CAPITAL LETTER H (Upper) × [998.0] LATIN SMALL LETTER E (Lower) × [998.0] SPACE (Sp) × [998.0] LATIN SMALL LETTER D (Lower) × [998.0] LATIN SMALL LETTER I (Lower) × [998.0] LATIN SMALL LETTER D (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) ÷ [0.3]');
    Test_SB('÷ 0028 × 201C × 0047 × 006F × 003F × 201D × 0029 × 0020 ÷ 0028 × 0048 × 0065 × 0020 × 0064 × 0069 × 0064 × 002E × 0029 ÷	#  ÷ [0.2] LEFT PARENTHESIS (Close) × [998.0] LEFT DOUBLE QUOTATION MARK (Close) × [998.0] LATIN CAPITAL LETTER G (Upper) × [998.0] LATIN SMALL LETTER O (Lower) × [998.0] QUESTION MARK (STerm) × [9.0] RIGHT DOUBLE QUOTATION MARK (Close) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] SPACE (Sp) ÷ [11.0] LEFT PARENTHESIS (Close) × [998.0] LATIN CAPITAL LETTER H (Upper) × [998.0] LATIN SMALL LETTER E (Lower) × [998.0] SPACE (Sp) × [998.0] LATIN SMALL LETTER D (Lower) × [998.0] LATIN SMALL LETTER I (Lower) × [998.0] LATIN SMALL LETTER D (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) ÷ [0.3]');
    Test_SB('÷ 0055 × 002E × 0053 × 002E × 0041 × 0300 × 002E × 0020 × 0069 × 0073 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER U (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER S (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] FULL STOP (ATerm) × [8.0] SPACE (Sp) × [8.0] LATIN SMALL LETTER I (Lower) × [998.0] LATIN SMALL LETTER S (Lower) ÷ [0.3]');
    Test_SB('÷ 0055 × 002E × 0053 × 002E × 0041 × 0300 × 003F × 0020 ÷ 0048 × 0065 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER U (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER S (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] QUESTION MARK (STerm) × [9.0] SPACE (Sp) ÷ [11.0] LATIN CAPITAL LETTER H (Upper) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0055 × 002E × 0053 × 002E × 0041 × 0300 × 002E ÷	#  ÷ [0.2] LATIN CAPITAL LETTER U (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER S (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER A (Upper) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] FULL STOP (ATerm) ÷ [0.3]');
    Test_SB('÷ 0033 × 002E × 0034 ÷	#  ÷ [0.2] DIGIT THREE (Numeric) × [998.0] FULL STOP (ATerm) × [6.0] DIGIT FOUR (Numeric) ÷ [0.3]');
    Test_SB('÷ 0063 × 002E × 0064 ÷	#  ÷ [0.2] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [8.0] LATIN SMALL LETTER D (Lower) ÷ [0.3]');
    Test_SB('÷ 0043 × 002E × 0064 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER C (Upper) × [998.0] FULL STOP (ATerm) × [8.0] LATIN SMALL LETTER D (Lower) ÷ [0.3]');
    Test_SB('÷ 0063 × 002E × 0044 ÷	#  ÷ [0.2] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER D (Upper) ÷ [0.3]');
    Test_SB('÷ 0043 × 002E × 0044 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER C (Upper) × [998.0] FULL STOP (ATerm) × [7.0] LATIN CAPITAL LETTER D (Upper) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 00A0 × 0074 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [8.0] RIGHT PARENTHESIS (Close) × [8.0] RIGHT SINGLE QUOTATION MARK (Close) × [8.0] NO-BREAK SPACE (Sp) × [8.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 00A0 ÷ 0054 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [9.0] NO-BREAK SPACE (Sp) ÷ [11.0] LATIN CAPITAL LETTER T (Upper) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 00A0 × 2018 × 0028 × 0074 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [8.0] RIGHT PARENTHESIS (Close) × [8.0] RIGHT SINGLE QUOTATION MARK (Close) × [8.0] NO-BREAK SPACE (Sp) × [8.0] LEFT SINGLE QUOTATION MARK (Close) × [998.0] LEFT PARENTHESIS (Close) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 00A0 ÷ 2018 × 0028 × 0054 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [9.0] NO-BREAK SPACE (Sp) ÷ [11.0] LEFT SINGLE QUOTATION MARK (Close) × [998.0] LEFT PARENTHESIS (Close) × [998.0] LATIN CAPITAL LETTER T (Upper) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 00A0 × 0308 × 0074 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [8.0] RIGHT PARENTHESIS (Close) × [8.0] RIGHT SINGLE QUOTATION MARK (Close) × [8.0] NO-BREAK SPACE (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 00A0 × 0308 ÷ 0054 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [9.0] NO-BREAK SPACE (Sp) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN CAPITAL LETTER T (Upper) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 2019 × 0308 ÷ 0054 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN CAPITAL LETTER T (Upper) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 0029 × 000A ÷ 0308 × 0054 × 0068 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [9.0] RIGHT PARENTHESIS (Close) × [9.0] <LINE FEED (LF)> (LF) ÷ [4.0] COMBINING DIAERESIS (Extend_FE) × [998.0] LATIN CAPITAL LETTER T (Upper) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 0074 × 0068 × 0065 × 0020 × 0072 × 0065 × 0073 × 0070 × 002E × 0020 × 006C × 0065 × 0061 × 0064 × 0065 × 0072 × 0073 × 0020 × 0061 × 0072 × 0065 ÷	#  ÷ [0.2] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER H (Lower) × [998.0] LATIN SMALL LETTER E (Lower) × [998.0] SPACE (Sp) × [998.0] LATIN SMALL LETTER R (Lower) × [998.0] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER S (Lower) × [998.0] LATIN SMALL LETTER P (Lower) × [998.0] FULL STOP (ATerm) × [8.0] SPACE (Sp) × [8.0] LATIN SMALL LETTER L (Lower) × [998.0] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER A (Lower) × [998.0] LATIN SMALL LETTER D (Lower) × [998.0] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER R (Lower) × [998.0] LATIN SMALL LETTER S (Lower) × [998.0] SPACE (Sp) × [998.0] LATIN SMALL LETTER A (Lower) × [998.0] LATIN SMALL LETTER R (Lower) × [998.0] LATIN SMALL LETTER E (Lower) ÷ [0.3]');
    Test_SB('÷ 5B57 × 002E ÷ 5B57 ÷	#  ÷ [0.2] CJK UNIFIED IDEOGRAPH-5B57 (OLetter) × [998.0] FULL STOP (ATerm) ÷ [11.0] CJK UNIFIED IDEOGRAPH-5B57 (OLetter) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E ÷ 5B83 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) ÷ [11.0] CJK UNIFIED IDEOGRAPH-5B83 (OLetter) ÷ [0.3]');
    Test_SB('÷ 0065 × 0074 × 0063 × 002E × 3002 ÷	#  ÷ [0.2] LATIN SMALL LETTER E (Lower) × [998.0] LATIN SMALL LETTER T (Lower) × [998.0] LATIN SMALL LETTER C (Lower) × [998.0] FULL STOP (ATerm) × [8.1] IDEOGRAPHIC FULL STOP (STerm) ÷ [0.3]');
    Test_SB('÷ 5B57 × 3002 ÷ 5B83 ÷	#  ÷ [0.2] CJK UNIFIED IDEOGRAPH-5B57 (OLetter) × [998.0] IDEOGRAPHIC FULL STOP (STerm) ÷ [11.0] CJK UNIFIED IDEOGRAPH-5B83 (OLetter) ÷ [0.3]');
    Test_SB('÷ 0021 × 0020 × 0020 ÷	#  ÷ [0.2] EXCLAMATION MARK (STerm) × [9.0] SPACE (Sp) × [10.0] SPACE (Sp) ÷ [0.3]');
    Test_SB('÷ 2060 × 0028 × 2060 × 0022 × 2060 × 0047 × 2060 × 006F × 2060 × 002E × 2060 × 0022 × 2060 × 0029 × 2060 × 0020 × 2060 ÷ 0028 × 2060 × 0048 × 2060 × 0065 × 2060 × 0020 × 2060 × 0064 × 2060 × 0069 × 2060 × 0064 × 2060 × 002E × 2060 × 0029 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LEFT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER G (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER O (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] LEFT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER H (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER I (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0028 × 2060 × 201C × 2060 × 0047 × 2060 × 006F × 2060 × 003F × 2060 × 201D × 2060 × 0029 × 2060 × 0020 × 2060 ÷ 0028 × 2060 × 0048 × 2060 × 0065 × 2060 × 0020 × 2060 × 0064 × 2060 × 0069 × 2060 × 0064 × 2060 × 002E × 2060 × 0029 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LEFT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LEFT DOUBLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER G (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER O (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] QUESTION MARK (STerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT DOUBLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] LEFT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER H (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER I (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0055 × 2060 × 002E × 2060 × 0053 × 2060 × 002E × 2060 × 0041 × 2060 × 0300 × 002E × 2060 × 0020 × 2060 × 0069 × 2060 × 0073 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER U (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER S (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER A (Upper) × [5.0] WORD JOINER (Format_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [8.0] LATIN SMALL LETTER I (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER S (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0055 × 2060 × 002E × 2060 × 0053 × 2060 × 002E × 2060 × 0041 × 2060 × 0300 × 003F × 2060 × 0020 × 2060 ÷ 0048 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER U (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER S (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER A (Upper) × [5.0] WORD JOINER (Format_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] QUESTION MARK (STerm) × [5.0] WORD JOINER (Format_FE) × [9.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] LATIN CAPITAL LETTER H (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0055 × 2060 × 002E × 2060 × 0053 × 2060 × 002E × 2060 × 0041 × 2060 × 0300 × 002E × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER U (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER S (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER A (Upper) × [5.0] WORD JOINER (Format_FE) × [5.0] COMBINING GRAVE ACCENT (Extend_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0033 × 2060 × 002E × 2060 × 0034 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] DIGIT THREE (Numeric) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [6.0] DIGIT FOUR (Numeric) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0063 × 2060 × 002E × 2060 × 0064 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0043 × 2060 × 002E × 2060 × 0064 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER C (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0063 × 2060 × 002E × 2060 × 0044 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER D (Upper) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0043 × 2060 × 002E × 2060 × 0044 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER C (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER D (Upper) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 00A0 × 2060 × 0074 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [8.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [8.0] NO-BREAK SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [8.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 00A0 × 2060 ÷ 0054 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] NO-BREAK SPACE (Sp) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] LATIN CAPITAL LETTER T (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 00A0 × 2060 × 2018 × 2060 × 0028 × 2060 × 0074 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [8.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [8.0] NO-BREAK SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [8.0] LEFT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LEFT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 00A0 × 2060 ÷ 2018 × 2060 × 0028 × 2060 × 0054 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] NO-BREAK SPACE (Sp) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] LEFT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LEFT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER T (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 00A0 × 2060 × 0308 × 0074 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [8.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [8.0] NO-BREAK SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [8.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 00A0 × 2060 × 0308 ÷ 0054 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] NO-BREAK SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN CAPITAL LETTER T (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 2019 × 2060 × 0308 ÷ 0054 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT SINGLE QUOTATION MARK (Close) × [5.0] WORD JOINER (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) ÷ [11.0] LATIN CAPITAL LETTER T (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 0029 × 2060 × 000A ÷ 2060 × 0308 × 2060 × 0054 × 2060 × 0068 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [9.0] RIGHT PARENTHESIS (Close) × [5.0] WORD JOINER (Format_FE) × [9.0] <LINE FEED (LF)> (LF) ÷ [4.0] WORD JOINER (Format_FE) × [5.0] COMBINING DIAERESIS (Extend_FE) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN CAPITAL LETTER T (Upper) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0074 × 2060 × 0068 × 2060 × 0065 × 2060 × 0020 × 2060 × 0072 × 2060 × 0065 × 2060 × 0073 × 2060 × 0070 × 2060 × 002E × 2060 × 0020 × 2060 × 006C × 2060 × 0065 × 2060 × 0061 × 2060 × 0064 × 2060 × 0065 × 2060 × 0072 × 2060 × 0073 × 2060 × 0020 × 2060 × 0061 × 2060 × 0072 × 2060 × 0065 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER H (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER R (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER S (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER P (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [8.0] LATIN SMALL LETTER L (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER A (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER D (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER R (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER S (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER A (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER R (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 5B57 × 2060 × 002E × 2060 ÷ 5B57 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] CJK UNIFIED IDEOGRAPH-5B57 (OLetter) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] CJK UNIFIED IDEOGRAPH-5B57 (OLetter) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 ÷ 5B83 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] CJK UNIFIED IDEOGRAPH-5B83 (OLetter) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0065 × 2060 × 0074 × 2060 × 0063 × 2060 × 002E × 2060 × 3002 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER E (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER T (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] LATIN SMALL LETTER C (Lower) × [5.0] WORD JOINER (Format_FE) × [998.0] FULL STOP (ATerm) × [5.0] WORD JOINER (Format_FE) × [8.1] IDEOGRAPHIC FULL STOP (STerm) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 5B57 × 2060 × 3002 × 2060 ÷ 5B83 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] CJK UNIFIED IDEOGRAPH-5B57 (OLetter) × [5.0] WORD JOINER (Format_FE) × [998.0] IDEOGRAPHIC FULL STOP (STerm) × [5.0] WORD JOINER (Format_FE) ÷ [11.0] CJK UNIFIED IDEOGRAPH-5B83 (OLetter) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_SB('÷ 2060 × 0021 × 2060 × 0020 × 2060 × 0020 × 2060 × 2060 ÷	#  ÷ [0.2] WORD JOINER (Format_FE) × [998.0] EXCLAMATION MARK (STerm) × [5.0] WORD JOINER (Format_FE) × [9.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [10.0] SPACE (Sp) × [5.0] WORD JOINER (Format_FE) × [5.0] WORD JOINER (Format_FE) ÷ [0.3]');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 6) {
    Test_LB('× 0023 × 0023 ÷	#  × [0.3] NUMBER SIGN (AL) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0023 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0023 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0023 ÷ 2014 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 2014 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 2014 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0023 × 0009 ÷	#  × [0.3] NUMBER SIGN (AL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0009 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0009 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0023 ÷ 00B4 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 00B4 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 00B4 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0023 × 000B ÷	#  × [0.3] NUMBER SIGN (AL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 000B ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 000B ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 000B ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0023 ÷ FFFC ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ FFFC ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ FFFC ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0023 × 007D ÷	#  × [0.3] NUMBER SIGN (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 007D ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 007D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 007D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0023 × 0029 ÷	#  × [0.3] NUMBER SIGN (AL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 0029 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0029 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 0029 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0023 × 000D ÷	#  × [0.3] NUMBER SIGN (AL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 000D ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 000D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 000D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0023 × 0021 ÷	#  × [0.3] NUMBER SIGN (AL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 0021 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0021 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 0021 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0023 × 00A0 ÷	#  × [0.3] NUMBER SIGN (AL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 00A0 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 00A0 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0023 ÷ AC00 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ AC00 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ AC00 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0023 ÷ AC01 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ AC01 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ AC01 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0023 × 05D0 ÷	#  × [0.3] NUMBER SIGN (AL) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 05D0 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 05D0 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0023 × 002D ÷	#  × [0.3] NUMBER SIGN (AL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 002D ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 002D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0023 ÷ 231A ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 231A ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 231A ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0023 × 2024 ÷	#  × [0.3] NUMBER SIGN (AL) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 2024 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 2024 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0023 × 002C ÷	#  × [0.3] NUMBER SIGN (AL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 002C ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 002C ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 002C ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0023 ÷ 1100 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 1100 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 1100 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0023 ÷ 11A8 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 11A8 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 11A8 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0023 ÷ 1160 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 1160 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 1160 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0023 × 000A ÷	#  × [0.3] NUMBER SIGN (AL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 000A ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 000A ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 000A ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0023 × 0085 ÷	#  × [0.3] NUMBER SIGN (AL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 0085 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0085 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 0085 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0023 × 17D6 ÷	#  × [0.3] NUMBER SIGN (AL) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 17D6 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 17D6 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0023 × 0030 ÷	#  × [0.3] NUMBER SIGN (AL) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0030 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0030 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0023 × 0028 ÷	#  × [0.3] NUMBER SIGN (AL) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0028 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0028 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0023 × 0025 ÷	#  × [0.3] NUMBER SIGN (AL) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0025 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0025 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0023 × 0024 ÷	#  × [0.3] NUMBER SIGN (AL) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0024 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0024 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0023 × 0022 ÷	#  × [0.3] NUMBER SIGN (AL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0022 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0022 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 0020 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 0020 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0023 × 002F ÷	#  × [0.3] NUMBER SIGN (AL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 002F ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 002F ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 002F ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0023 × 2060 ÷	#  × [0.3] NUMBER SIGN (AL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 2060 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 2060 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 2060 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0023 × 200B ÷	#  × [0.3] NUMBER SIGN (AL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0023 × 0020 × 200B ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 200B ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 × 200B ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0023 ÷ 1F1E6 ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 1F1E6 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 1F1E6 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0023 ÷ 261D ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 261D ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 261D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0023 ÷ 1F3FB ÷	#  × [0.3] NUMBER SIGN (AL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 1F3FB ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0023 × 0308 ÷ 1F3FB ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0023 × 0001 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0001 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0001 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0023 × 200D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 200D ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 200D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0023 × 00A7 ÷	#  × [0.3] NUMBER SIGN (AL) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 00A7 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 00A7 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0023 × 50005 ÷	#  × [0.3] NUMBER SIGN (AL) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 50005 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 50005 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0E01 ÷	#  × [0.3] NUMBER SIGN (AL) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 0E01 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0E01 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0023 × 3041 ÷	#  × [0.3] NUMBER SIGN (AL) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0023 × 0020 ÷ 3041 ÷	#  × [0.3] NUMBER SIGN (AL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 3041 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0023 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] NUMBER SIGN (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2014 ÷ 0023 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0023 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 0023 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2014 × 2014 ÷	#  × [0.3] EM DASH (B2) × [17.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 2014 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [17.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 2014 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [17.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 2014 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [17.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2014 × 0009 ÷	#  × [0.3] EM DASH (B2) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0009 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0009 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2014 ÷ 00B4 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 00B4 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 00B4 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2014 × 000B ÷	#  × [0.3] EM DASH (B2) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 000B ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 000B ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 000B ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2014 ÷ FFFC ÷	#  × [0.3] EM DASH (B2) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ FFFC ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ FFFC ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2014 × 007D ÷	#  × [0.3] EM DASH (B2) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 007D ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 007D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 007D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2014 × 0029 ÷	#  × [0.3] EM DASH (B2) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 0029 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0029 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 0029 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 2014 × 000D ÷	#  × [0.3] EM DASH (B2) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 000D ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 000D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 000D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2014 × 0021 ÷	#  × [0.3] EM DASH (B2) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 0021 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0021 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 0021 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2014 × 00A0 ÷	#  × [0.3] EM DASH (B2) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 00A0 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 00A0 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2014 ÷ AC00 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ AC00 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ AC00 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2014 ÷ AC01 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ AC01 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ AC01 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2014 ÷ 05D0 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 05D0 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 05D0 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2014 × 002D ÷	#  × [0.3] EM DASH (B2) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 002D ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 002D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2014 ÷ 231A ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 231A ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 231A ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2014 ÷ 2024 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 2024 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 2024 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2014 × 002C ÷	#  × [0.3] EM DASH (B2) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 002C ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 002C ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 002C ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2014 ÷ 1100 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 1100 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 1100 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2014 ÷ 11A8 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 11A8 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 11A8 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2014 ÷ 1160 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 1160 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 1160 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2014 × 000A ÷	#  × [0.3] EM DASH (B2) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 000A ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 000A ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 000A ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2014 × 0085 ÷	#  × [0.3] EM DASH (B2) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 0085 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0085 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 0085 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2014 × 17D6 ÷	#  × [0.3] EM DASH (B2) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 17D6 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 17D6 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2014 ÷ 0030 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0030 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 0030 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2014 ÷ 0028 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0028 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 0028 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 2014 ÷ 0025 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0025 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 0025 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2014 ÷ 0024 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0024 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 0024 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2014 × 0022 ÷	#  × [0.3] EM DASH (B2) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0022 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0022 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 0020 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 0020 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2014 × 002F ÷	#  × [0.3] EM DASH (B2) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 002F ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 002F ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 002F ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2014 × 2060 ÷	#  × [0.3] EM DASH (B2) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 2060 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 2060 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 2060 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2014 × 200B ÷	#  × [0.3] EM DASH (B2) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2014 × 0020 × 200B ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 200B ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 × 200B ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2014 ÷ 1F1E6 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 1F1E6 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 1F1E6 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2014 ÷ 261D ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 261D ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 261D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2014 ÷ 1F3FB ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 1F3FB ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 1F3FB ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2014 × 0001 ÷	#  × [0.3] EM DASH (B2) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0001 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0001 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2014 × 200D ÷	#  × [0.3] EM DASH (B2) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 200D ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 200D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2014 ÷ 00A7 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 00A7 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 00A7 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2014 ÷ 50005 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 50005 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 50005 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2014 ÷ 0E01 ÷	#  × [0.3] EM DASH (B2) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 0E01 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 ÷ 0E01 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2014 × 3041 ÷	#  × [0.3] EM DASH (B2) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2014 × 0020 ÷ 3041 ÷	#  × [0.3] EM DASH (B2) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 3041 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2014 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] EM DASH (B2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0009 ÷ 0023 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0023 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 0023 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0009 ÷ 2014 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 2014 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 2014 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0009 × 0009 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0009 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0009 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0009 ÷ 00B4 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 00B4 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 00B4 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0009 × 000B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 000B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 000B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 000B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0009 ÷ FFFC ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ FFFC ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ FFFC ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0009 × 007D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 007D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 007D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 007D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0009 × 0029 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 0029 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0029 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 0029 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0009 × 000D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 000D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 000D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 000D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0009 × 0021 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 0021 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0021 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 0021 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0009 ÷ 00A0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 00A0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 00A0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0009 ÷ AC00 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ AC00 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ AC00 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0009 ÷ AC01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ AC01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ AC01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0009 ÷ 05D0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 05D0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 05D0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0009 × 002D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 002D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 002D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0009 ÷ 231A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 231A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 231A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0009 ÷ 2024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 2024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 2024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0009 × 002C ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 002C ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 002C ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 002C ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0009 ÷ 1100 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 1100 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 1100 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0009 ÷ 11A8 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 11A8 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 11A8 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0009 ÷ 1160 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 1160 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 1160 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0009 × 000A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 000A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 000A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 000A ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0009 × 0085 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 0085 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0085 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 0085 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0009 × 17D6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 17D6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 17D6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0009 ÷ 0030 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0030 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 0030 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0009 ÷ 0028 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0028 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 0028 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0009 ÷ 0025 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0025 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 0025 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0009 ÷ 0024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 0024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0009 × 0022 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0022 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0022 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 0020 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 0020 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0009 × 002F ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 002F ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 002F ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 002F ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0009 × 2060 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 2060 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 2060 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 2060 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0009 × 200B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0009 × 0020 × 200B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 200B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 × 200B ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0009 ÷ 1F1E6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 1F1E6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0009 ÷ 261D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 261D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 261D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0009 ÷ 1F3FB ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 1F3FB ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 1F3FB ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0009 × 0001 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0001 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0001 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0009 × 200D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 200D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 200D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0009 ÷ 00A7 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 00A7 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 00A7 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0009 ÷ 50005 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 50005 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 50005 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0009 ÷ 0E01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 0E01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 ÷ 0E01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0009 × 3041 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0009 × 0020 ÷ 3041 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 3041 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0009 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <CHARACTER TABULATION> (BA) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0023 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0023 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0023 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00B4 × 2014 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 2014 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 2014 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00B4 × 0009 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0009 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0009 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00B4 × 00B4 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 00B4 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 00B4 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00B4 × 000B ÷	#  × [0.3] ACUTE ACCENT (BB) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 000B ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 000B ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 000B ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00B4 ÷ FFFC ÷	#  × [0.3] ACUTE ACCENT (BB) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ FFFC ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 ÷ FFFC ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00B4 × 007D ÷	#  × [0.3] ACUTE ACCENT (BB) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 007D ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 007D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 007D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00B4 × 0029 ÷	#  × [0.3] ACUTE ACCENT (BB) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 0029 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0029 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 0029 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 00B4 × 000D ÷	#  × [0.3] ACUTE ACCENT (BB) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 000D ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 000D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 000D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00B4 × 0021 ÷	#  × [0.3] ACUTE ACCENT (BB) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 0021 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0021 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 0021 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00B4 × 00A0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 00A0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 00A0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00B4 × AC00 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ AC00 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × AC00 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00B4 × AC01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ AC01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × AC01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00B4 × 05D0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 05D0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 05D0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00B4 × 002D ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 002D ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 002D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00B4 × 231A ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 231A ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 231A ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00B4 × 2024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 2024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 2024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00B4 × 002C ÷	#  × [0.3] ACUTE ACCENT (BB) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 002C ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 002C ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 002C ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00B4 × 1100 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 1100 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 1100 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00B4 × 11A8 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 11A8 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 11A8 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00B4 × 1160 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 1160 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 1160 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00B4 × 000A ÷	#  × [0.3] ACUTE ACCENT (BB) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 000A ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 000A ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 000A ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00B4 × 0085 ÷	#  × [0.3] ACUTE ACCENT (BB) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 0085 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0085 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 0085 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00B4 × 17D6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 17D6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 17D6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0030 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0030 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0030 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00B4 × 0028 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0028 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0028 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 00B4 × 0025 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0025 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0025 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00B4 × 0024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00B4 × 0022 ÷	#  × [0.3] ACUTE ACCENT (BB) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0022 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0022 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 0020 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 0020 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00B4 × 002F ÷	#  × [0.3] ACUTE ACCENT (BB) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 002F ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 002F ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 002F ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00B4 × 2060 ÷	#  × [0.3] ACUTE ACCENT (BB) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 2060 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 2060 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 2060 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00B4 × 200B ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 × 200B ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 200B ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 × 200B ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00B4 × 1F1E6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 1F1E6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 1F1E6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00B4 × 261D ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 261D ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 261D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00B4 × 1F3FB ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 1F3FB ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 1F3FB ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00B4 × 0001 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0001 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0001 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 200D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 200D ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 200D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00B4 × 00A7 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 00A7 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 00A7 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 50005 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 50005 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 50005 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0E01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.04] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 0E01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0E01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.04] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00B4 × 3041 ÷	#  × [0.3] ACUTE ACCENT (BB) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0020 ÷ 3041 ÷	#  × [0.3] ACUTE ACCENT (BB) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 3041 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00B4 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] ACUTE ACCENT (BB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0023 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0023 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0023 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 2014 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 2014 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 2014 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0009 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0009 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0009 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000B ÷ 00B4 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 00B4 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 00B4 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000B ÷ 000B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 000B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 000B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 000B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000B ÷ FFFC ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ FFFC ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ FFFC ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000B ÷ 007D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 007D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 007D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 007D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0029 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 0029 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0029 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 0029 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 000B ÷ 000D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 000D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 000D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 000D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0021 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 0021 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0021 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 0021 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000B ÷ 00A0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 00A0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 00A0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000B ÷ AC00 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ AC00 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ AC00 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000B ÷ AC01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ AC01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ AC01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000B ÷ 05D0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 05D0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 05D0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000B ÷ 002D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 002D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 002D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 002D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000B ÷ 231A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 231A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 231A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 231A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000B ÷ 2024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 2024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 2024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000B ÷ 002C ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 002C ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 002C ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 002C ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000B ÷ 1100 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 1100 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 1100 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000B ÷ 11A8 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 11A8 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 11A8 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000B ÷ 1160 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 1160 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 1160 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000B ÷ 000A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 000A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 000A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 000A ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000B ÷ 0085 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 0085 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0085 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 0085 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000B ÷ 17D6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 17D6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 17D6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0030 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0030 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0030 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0028 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0028 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0028 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0025 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0025 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0025 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000B ÷ 0024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000B ÷ 0022 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0022 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0022 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 0020 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 0020 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000B ÷ 002F ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 002F ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 002F ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 002F ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000B ÷ 2060 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 2060 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 2060 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 2060 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000B ÷ 200B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 × 200B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 200B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 × 200B ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000B ÷ 1F1E6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 1F1E6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 1F1E6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000B ÷ 261D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 261D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 261D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 261D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000B ÷ 1F3FB ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 1F3FB ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 ÷ 1F3FB ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0001 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0001 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0001 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 200D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 200D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 200D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 200D ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000B ÷ 00A7 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 00A7 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 00A7 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 50005 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 50005 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 50005 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0E01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 0E01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0E01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000B ÷ 3041 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0020 ÷ 3041 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 3041 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000B ÷ 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0023 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0023 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0023 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 2014 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 2014 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 2014 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0009 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0009 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0009 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× FFFC ÷ 00B4 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 00B4 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 00B4 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× FFFC × 000B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 000B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 000B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 000B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× FFFC ÷ FFFC ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ FFFC ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ FFFC ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× FFFC × 007D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 007D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 007D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 007D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× FFFC × 0029 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 0029 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0029 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 0029 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× FFFC × 000D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 000D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 000D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 000D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× FFFC × 0021 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 0021 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0021 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 0021 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× FFFC × 00A0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 00A0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 00A0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× FFFC ÷ AC00 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ AC00 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ AC00 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× FFFC ÷ AC01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ AC01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ AC01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× FFFC ÷ 05D0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 05D0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 05D0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 002D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 002D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 002D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 002D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× FFFC ÷ 231A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 231A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 231A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 231A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× FFFC ÷ 2024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 2024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 2024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× FFFC × 002C ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 002C ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 002C ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 002C ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× FFFC ÷ 1100 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 1100 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 1100 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 11A8 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 11A8 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 11A8 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× FFFC ÷ 1160 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 1160 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 1160 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× FFFC × 000A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 000A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 000A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 000A ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× FFFC × 0085 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 0085 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0085 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 0085 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 17D6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 17D6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 17D6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0030 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0030 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0030 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0028 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0028 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0028 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0025 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0025 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0025 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× FFFC × 0022 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0022 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0022 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 0020 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 0020 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× FFFC × 002F ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 002F ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 002F ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 002F ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× FFFC × 2060 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 2060 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 2060 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 2060 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× FFFC × 200B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× FFFC × 0020 × 200B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 200B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 × 200B ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× FFFC ÷ 1F1E6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 1F1E6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 1F1E6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× FFFC ÷ 261D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 261D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 261D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 261D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× FFFC ÷ 1F3FB ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 1F3FB ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 1F3FB ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× FFFC × 0001 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0001 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0001 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× FFFC × 200D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 200D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 200D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 200D ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× FFFC ÷ 00A7 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 00A7 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 00A7 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 50005 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 50005 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 50005 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 0E01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 0E01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 0E01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× FFFC ÷ 3041 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× FFFC × 0020 ÷ 3041 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× FFFC × 0308 ÷ 3041 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× FFFC × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 007D ÷ 0023 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0023 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 0023 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 007D ÷ 2014 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 2014 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 2014 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 007D × 0009 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0009 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0009 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 007D ÷ 00B4 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 00B4 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 00B4 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 007D × 000B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 000B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 000B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 000B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 007D ÷ FFFC ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ FFFC ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ FFFC ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 007D × 007D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 007D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 007D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 007D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 007D × 0029 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 0029 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0029 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 0029 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 007D × 000D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 000D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 000D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 000D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 007D × 0021 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 0021 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0021 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 0021 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 007D × 00A0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 00A0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 00A0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 007D ÷ AC00 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ AC00 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ AC00 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 007D ÷ AC01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ AC01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ AC01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 007D ÷ 05D0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 05D0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 05D0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 007D × 002D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 002D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 002D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 002D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 007D ÷ 231A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 231A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 231A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 231A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 007D ÷ 2024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 2024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 2024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 007D × 002C ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 002C ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 002C ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 002C ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 007D ÷ 1100 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 1100 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 1100 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 007D ÷ 11A8 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 11A8 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 11A8 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 007D ÷ 1160 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 1160 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 1160 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 007D × 000A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 000A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 000A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 000A ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 007D × 0085 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 0085 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0085 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 0085 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 007D × 17D6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 17D6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 17D6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 17D6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 007D ÷ 0030 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0030 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 0030 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 007D ÷ 0028 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0028 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 0028 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 007D ÷ 0025 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0025 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 0025 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 007D ÷ 0024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 0024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 007D × 0022 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0022 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0022 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 0020 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 0020 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 007D × 002F ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 002F ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 002F ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 002F ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 007D × 2060 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 2060 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 2060 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 2060 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 007D × 200B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 200B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 200B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 200B ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 007D ÷ 1F1E6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 1F1E6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 1F1E6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 007D ÷ 261D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 261D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 261D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 261D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 007D ÷ 1F3FB ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 1F3FB ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 1F3FB ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 007D × 0001 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0001 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0001 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 007D × 200D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 200D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 200D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 200D ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 007D ÷ 00A7 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 00A7 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 00A7 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 007D ÷ 50005 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 50005 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 50005 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 007D ÷ 0E01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 007D × 0020 ÷ 0E01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 ÷ 0E01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 007D × 3041 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 007D × 0020 × 3041 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 3041 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 007D × 0308 × 0020 × 3041 ÷	#  × [0.3] RIGHT CURLY BRACKET (CL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0029 × 0023 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [30.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0023 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0023 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0029 ÷ 2014 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 2014 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 2014 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0029 × 0009 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0009 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0009 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0029 ÷ 00B4 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 00B4 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 00B4 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0029 × 000B ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 000B ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 000B ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 000B ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0029 ÷ FFFC ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ FFFC ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ FFFC ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0029 × 007D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 007D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 007D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 007D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0029 × 0029 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 0029 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0029 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 0029 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0029 × 000D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 000D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 000D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 000D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0029 × 0021 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 0021 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0021 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 0021 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0029 × 00A0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 00A0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 00A0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0029 ÷ AC00 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ AC00 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ AC00 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0029 ÷ AC01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ AC01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ AC01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0029 × 05D0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [30.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 05D0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 05D0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0029 × 002D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 002D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 002D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0029 ÷ 231A ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 231A ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 231A ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0029 ÷ 2024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 2024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 2024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0029 × 002C ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 002C ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 002C ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 002C ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0029 ÷ 1100 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 1100 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 1100 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0029 ÷ 11A8 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 11A8 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 11A8 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0029 ÷ 1160 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 1160 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 1160 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0029 × 000A ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 000A ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 000A ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 000A ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0029 × 0085 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 0085 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0085 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 0085 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0029 × 17D6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 17D6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 17D6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 17D6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [16.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0029 × 0030 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [30.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0030 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0030 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0029 ÷ 0028 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0028 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 0028 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0029 ÷ 0025 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0025 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 0025 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0029 ÷ 0024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 0024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0029 × 0022 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0022 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0022 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 0020 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 0020 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0029 × 002F ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 002F ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 002F ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 002F ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0029 × 2060 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 2060 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 2060 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 2060 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0029 × 200B ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 200B ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 200B ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 200B ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0029 ÷ 1F1E6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 1F1E6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 1F1E6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0029 ÷ 261D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 261D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 261D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0029 ÷ 1F3FB ÷	#  × [0.3] RIGHT PARENTHESIS (CP) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 1F3FB ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0029 × 0308 ÷ 1F3FB ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0029 × 0001 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0001 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0001 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0029 × 200D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 200D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 200D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0029 × 00A7 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [30.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 00A7 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 00A7 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0029 × 50005 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [30.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 50005 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 50005 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0E01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [30.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0020 ÷ 0E01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0E01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0029 × 3041 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0029 × 0020 × 3041 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 3041 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0029 × 0308 × 0020 × 3041 ÷	#  × [0.3] RIGHT PARENTHESIS (CP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [16.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0023 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0023 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0023 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 2014 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 2014 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 2014 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0009 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0009 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0009 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000D ÷ 00B4 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 00B4 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 00B4 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000D ÷ 000B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 000B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 000B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 000B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000D ÷ FFFC ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ FFFC ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ FFFC ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000D ÷ 007D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 007D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 007D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 007D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0029 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 0029 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0029 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 0029 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 000D ÷ 000D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 000D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 000D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 000D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0021 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 0021 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0021 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 0021 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000D ÷ 00A0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 00A0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 00A0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000D ÷ AC00 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ AC00 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ AC00 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000D ÷ AC01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ AC01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ AC01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000D ÷ 05D0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 05D0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 05D0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000D ÷ 002D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 002D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 002D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 002D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000D ÷ 231A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 231A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 231A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 231A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000D ÷ 2024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 2024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 2024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000D ÷ 002C ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 002C ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 002C ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 002C ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000D ÷ 1100 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 1100 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 1100 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000D ÷ 11A8 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 11A8 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 11A8 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000D ÷ 1160 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 1160 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 1160 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000D × 000A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) × [5.01] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 000A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 000A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 000A ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000D ÷ 0085 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 0085 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0085 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 0085 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000D ÷ 17D6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 17D6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 17D6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0030 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0030 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0030 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0028 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0028 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0028 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0025 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0025 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0025 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000D ÷ 0024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000D ÷ 0022 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0022 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0022 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 0020 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 0020 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000D ÷ 002F ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 002F ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 002F ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 002F ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000D ÷ 2060 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 2060 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 2060 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 2060 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000D ÷ 200B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 × 200B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 200B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 × 200B ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000D ÷ 1F1E6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 1F1E6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 1F1E6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000D ÷ 261D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 261D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 261D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 261D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000D ÷ 1F3FB ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 1F3FB ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 ÷ 1F3FB ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0001 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0001 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0001 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 200D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 200D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 200D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 200D ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000D ÷ 00A7 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 00A7 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 00A7 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 50005 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 50005 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 50005 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0E01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 0E01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0E01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000D ÷ 3041 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0020 ÷ 3041 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 3041 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0021 ÷ 0023 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0023 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 0023 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0021 ÷ 2014 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 2014 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 2014 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0021 × 0009 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0009 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0009 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0021 ÷ 00B4 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 00B4 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 00B4 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0021 × 000B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 000B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 000B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 000B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0021 ÷ FFFC ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ FFFC ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ FFFC ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0021 × 007D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 007D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 007D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 007D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0021 × 0029 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 0029 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0029 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 0029 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0021 × 000D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 000D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 000D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 000D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0021 × 0021 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 0021 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0021 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 0021 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0021 × 00A0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 00A0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 00A0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0021 ÷ AC00 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ AC00 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ AC00 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0021 ÷ AC01 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ AC01 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ AC01 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0021 ÷ 05D0 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 05D0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 05D0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0021 × 002D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 002D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 002D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0021 ÷ 231A ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 231A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 231A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0021 × 2024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [22.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 2024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 2024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0021 × 002C ÷	#  × [0.3] EXCLAMATION MARK (EX) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 002C ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 002C ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 002C ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0021 ÷ 1100 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 1100 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 1100 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0021 ÷ 11A8 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 11A8 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 11A8 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0021 ÷ 1160 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 1160 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 1160 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0021 × 000A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 000A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 000A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 000A ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0021 × 0085 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 0085 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0085 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 0085 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0021 × 17D6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 17D6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 17D6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0021 ÷ 0030 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0030 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 0030 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0021 ÷ 0028 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0028 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 0028 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0021 ÷ 0025 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0025 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 0025 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0021 ÷ 0024 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 0024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0021 × 0022 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0022 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0022 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 0020 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 0020 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0021 × 002F ÷	#  × [0.3] EXCLAMATION MARK (EX) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 002F ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 002F ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 002F ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0021 × 2060 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 2060 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 2060 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 2060 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0021 × 200B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0021 × 0020 × 200B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 200B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 × 200B ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0021 ÷ 1F1E6 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 1F1E6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 1F1E6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0021 ÷ 261D ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 261D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 261D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0021 ÷ 1F3FB ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 1F3FB ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 1F3FB ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0021 × 0001 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0001 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0001 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0021 × 200D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 200D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 200D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0021 ÷ 00A7 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 00A7 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 00A7 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0021 ÷ 50005 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 50005 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 50005 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0021 ÷ 0E01 ÷	#  × [0.3] EXCLAMATION MARK (EX) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 0E01 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 ÷ 0E01 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0021 × 3041 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0021 × 0020 ÷ 3041 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 3041 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0021 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0023 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0023 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0023 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A0 × 2014 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 2014 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 2014 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A0 × 0009 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0009 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0009 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A0 × 00B4 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 00B4 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 00B4 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A0 × 000B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 000B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 000B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 000B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A0 × FFFC ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ FFFC ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × FFFC ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A0 × 007D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 007D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 007D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 007D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A0 × 0029 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 0029 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0029 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 0029 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 00A0 × 000D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 000D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 000D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 000D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A0 × 0021 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 0021 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0021 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 0021 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A0 × 00A0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 00A0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 00A0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A0 × AC00 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ AC00 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × AC00 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A0 × AC01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ AC01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × AC01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A0 × 05D0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 05D0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 05D0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A0 × 002D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 002D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 002D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A0 × 231A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 231A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 231A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A0 × 2024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 2024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 2024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A0 × 002C ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 002C ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 002C ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 002C ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A0 × 1100 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 1100 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 1100 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A0 × 11A8 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 11A8 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 11A8 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A0 × 1160 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 1160 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 1160 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A0 × 000A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 000A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 000A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 000A ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A0 × 0085 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 0085 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0085 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 0085 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A0 × 17D6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 17D6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 17D6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0030 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0030 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0030 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A0 × 0028 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0028 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0028 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 00A0 × 0025 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0025 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0025 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A0 × 0024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A0 × 0022 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0022 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0022 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 0020 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 0020 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A0 × 002F ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 002F ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 002F ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 002F ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A0 × 2060 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 2060 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 2060 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 2060 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A0 × 200B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 × 200B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 200B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 × 200B ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A0 × 1F1E6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 1F1E6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 1F1E6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A0 × 261D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 261D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 261D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A0 × 1F3FB ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 1F3FB ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 1F3FB ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A0 × 0001 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0001 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0001 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 200D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 7) {
    Test_LB('× 00A0 × 0020 ÷ 200D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 200D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A0 × 00A7 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 00A7 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 00A7 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 50005 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 50005 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 50005 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0E01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 0E01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0E01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A0 × 3041 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [12.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0020 ÷ 3041 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 3041 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A0 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] NO-BREAK SPACE (GL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC00 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC00 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC00 × 0009 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0009 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC00 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC00 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC00 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC00 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC00 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× AC00 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC00 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC00 × 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC00 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC00 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC00 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC00 × 002D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 002D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC00 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC00 × 2024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [27.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 2024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC00 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC00 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC00 × 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [26.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC00 × 1160 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [26.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 1160 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC00 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC00 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC00 × 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC00 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC00 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× AC00 × 0025 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0025 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC00 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC00 × 0022 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0022 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC00 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC00 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC00 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC00 × 0020 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC00 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC00 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC00 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC00 × 0001 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0001 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC00 × 200D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 200D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC00 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC00 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC00 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC00 × 3041 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC00 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 3041 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC00 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL SYLLABLE GA (H2) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC01 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× AC01 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× AC01 × 0009 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0009 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× AC01 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× AC01 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 000B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× AC01 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× AC01 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 007D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× AC01 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 0029 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× AC01 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 000D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× AC01 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 0021 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× AC01 × 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× AC01 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× AC01 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× AC01 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× AC01 × 002D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 002D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× AC01 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× AC01 × 2024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [27.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 2024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× AC01 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 002C ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× AC01 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× AC01 × 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [26.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× AC01 ÷ 1160 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 1160 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× AC01 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 000A ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× AC01 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 0085 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× AC01 × 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× AC01 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× AC01 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× AC01 × 0025 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0025 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× AC01 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× AC01 × 0022 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0022 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 0020 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× AC01 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 002F ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× AC01 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 2060 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× AC01 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC01 × 0020 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 × 200B ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× AC01 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× AC01 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× AC01 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× AC01 × 0001 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0001 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× AC01 × 200D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 200D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× AC01 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× AC01 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× AC01 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× AC01 × 3041 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC01 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 3041 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× AC01 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL SYLLABLE GAG (H3) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0023 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0023 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0023 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 2014 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 2014 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 2014 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 05D0 × 0009 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0009 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0009 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 00B4 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 00B4 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 00B4 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 05D0 × 000B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 000B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 000B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 000B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 05D0 ÷ FFFC ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ FFFC ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ FFFC ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 05D0 × 007D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 007D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 007D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 007D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 05D0 × 0029 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 0029 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0029 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 0029 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 05D0 × 000D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 000D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 000D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 000D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 05D0 × 0021 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 0021 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0021 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 0021 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 05D0 × 00A0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 00A0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 00A0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 05D0 ÷ AC00 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ AC00 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ AC00 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 05D0 ÷ AC01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ AC01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ AC01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 05D0 × 05D0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 05D0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 05D0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 05D0 × 002D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 002D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 002D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 231A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 231A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 231A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 05D0 × 2024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 2024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 2024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 05D0 × 002C ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 002C ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 002C ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 002C ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 1100 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 1100 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 1100 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 11A8 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 11A8 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 11A8 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 1160 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 1160 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 1160 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 05D0 × 000A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 000A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 000A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 000A ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 05D0 × 0085 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 0085 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0085 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 0085 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 05D0 × 17D6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 17D6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 17D6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0030 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0030 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0030 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 05D0 × 0028 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0028 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0028 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 05D0 × 0025 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0025 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0025 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 05D0 × 0024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 05D0 × 0022 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0022 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0022 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 0020 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 0020 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 05D0 × 002F ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 002F ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 002F ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 002F ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 05D0 × 2060 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 2060 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 2060 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 2060 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 05D0 × 200B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 × 200B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 200B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 × 200B ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 1F1E6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 261D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 261D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 261D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 05D0 ÷ 1F3FB ÷	#  × [0.3] HEBREW LETTER ALEF (HL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 1F3FB ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 ÷ 1F3FB ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 05D0 × 0001 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0001 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0001 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 200D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 200D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 200D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 05D0 × 00A7 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 00A7 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 00A7 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 50005 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 50005 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 50005 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0E01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 0E01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0E01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 05D0 × 3041 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0020 ÷ 3041 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 3041 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 05D0 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002D ÷ 0023 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0023 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 0023 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002D ÷ 2014 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 2014 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 2014 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002D × 0009 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0009 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0009 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002D ÷ 00B4 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 00B4 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 00B4 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002D × 000B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 000B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 000B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 000B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002D ÷ FFFC ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ FFFC ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ FFFC ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002D × 007D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 007D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 007D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 007D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002D × 0029 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 0029 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0029 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 0029 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 002D × 000D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 000D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 000D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 000D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002D × 0021 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 0021 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0021 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 0021 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002D ÷ 00A0 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 00A0 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 00A0 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002D ÷ AC00 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ AC00 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ AC00 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002D ÷ AC01 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ AC01 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ AC01 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002D ÷ 05D0 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 05D0 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 05D0 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002D × 002D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 002D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 002D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002D ÷ 231A ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 231A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 231A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002D ÷ 2024 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 2024 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 2024 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002D × 002C ÷	#  × [0.3] HYPHEN-MINUS (HY) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 002C ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 002C ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 002C ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002D ÷ 1100 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 1100 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 1100 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002D ÷ 11A8 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 11A8 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 11A8 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002D ÷ 1160 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 1160 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 1160 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002D × 000A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 000A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 000A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 000A ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002D × 0085 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 0085 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0085 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 0085 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002D × 17D6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 17D6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 17D6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002D × 0030 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [25.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0030 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0030 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002D ÷ 0028 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0028 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 0028 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 002D ÷ 0025 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0025 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 0025 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002D ÷ 0024 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0024 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 0024 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002D × 0022 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0022 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0022 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 0020 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 0020 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002D × 002F ÷	#  × [0.3] HYPHEN-MINUS (HY) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 002F ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 002F ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 002F ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002D × 2060 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 2060 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 2060 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 2060 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002D × 200B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002D × 0020 × 200B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 200B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 × 200B ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002D ÷ 1F1E6 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 1F1E6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 1F1E6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002D ÷ 261D ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 261D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 261D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002D ÷ 1F3FB ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 1F3FB ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 1F3FB ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002D × 0001 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0001 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0001 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002D × 200D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 200D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 200D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002D ÷ 00A7 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 00A7 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 00A7 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002D ÷ 50005 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 50005 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 50005 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002D ÷ 0E01 ÷	#  × [0.3] HYPHEN-MINUS (HY) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 0E01 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 ÷ 0E01 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002D × 3041 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002D × 0020 ÷ 3041 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 3041 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002D × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 231A ÷ 0023 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0023 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 0023 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 231A ÷ 2014 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 2014 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 2014 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 231A × 0009 ÷	#  × [0.3] WATCH (ID) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0009 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0009 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 231A ÷ 00B4 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 00B4 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 00B4 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 231A × 000B ÷	#  × [0.3] WATCH (ID) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 000B ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 000B ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 000B ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 231A ÷ FFFC ÷	#  × [0.3] WATCH (ID) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ FFFC ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ FFFC ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 231A × 007D ÷	#  × [0.3] WATCH (ID) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 007D ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 007D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 007D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 231A × 0029 ÷	#  × [0.3] WATCH (ID) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 0029 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0029 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 0029 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 231A × 000D ÷	#  × [0.3] WATCH (ID) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 000D ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 000D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 000D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 231A × 0021 ÷	#  × [0.3] WATCH (ID) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 0021 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0021 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 0021 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 231A × 00A0 ÷	#  × [0.3] WATCH (ID) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 00A0 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 00A0 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 231A ÷ AC00 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ AC00 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ AC00 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 231A ÷ AC01 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ AC01 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ AC01 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 231A ÷ 05D0 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 05D0 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 05D0 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 231A × 002D ÷	#  × [0.3] WATCH (ID) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 002D ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 002D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 002D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 231A ÷ 231A ÷	#  × [0.3] WATCH (ID) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 231A ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 231A ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 231A ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 231A × 2024 ÷	#  × [0.3] WATCH (ID) × [22.03] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 2024 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 2024 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.03] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 231A × 002C ÷	#  × [0.3] WATCH (ID) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 002C ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 002C ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 002C ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 231A ÷ 1100 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 1100 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 1100 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 231A ÷ 11A8 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 11A8 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 11A8 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 231A ÷ 1160 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 1160 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 1160 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 231A × 000A ÷	#  × [0.3] WATCH (ID) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 000A ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 000A ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 000A ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 231A × 0085 ÷	#  × [0.3] WATCH (ID) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 0085 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0085 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 0085 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 231A × 17D6 ÷	#  × [0.3] WATCH (ID) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 17D6 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 17D6 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 231A ÷ 0030 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0030 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 0030 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 231A ÷ 0028 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0028 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 0028 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 231A × 0025 ÷	#  × [0.3] WATCH (ID) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0025 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0025 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 231A ÷ 0024 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0024 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 0024 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 231A × 0022 ÷	#  × [0.3] WATCH (ID) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0022 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0022 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 0020 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 0020 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 231A × 002F ÷	#  × [0.3] WATCH (ID) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 002F ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 002F ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 002F ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 231A × 2060 ÷	#  × [0.3] WATCH (ID) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 2060 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 2060 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 2060 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 231A × 200B ÷	#  × [0.3] WATCH (ID) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 231A × 0020 × 200B ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 200B ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 × 200B ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 231A ÷ 1F1E6 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 1F1E6 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 1F1E6 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 231A ÷ 261D ÷	#  × [0.3] WATCH (ID) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 261D ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 261D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 261D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 231A ÷ 1F3FB ÷	#  × [0.3] WATCH (ID) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 1F3FB ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 1F3FB ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 231A × 0001 ÷	#  × [0.3] WATCH (ID) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0001 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0001 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 231A × 200D ÷	#  × [0.3] WATCH (ID) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 200D ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 200D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 200D ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 231A ÷ 00A7 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 00A7 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 00A7 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 231A ÷ 50005 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 50005 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 50005 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 231A ÷ 0E01 ÷	#  × [0.3] WATCH (ID) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 0E01 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 ÷ 0E01 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 231A × 3041 ÷	#  × [0.3] WATCH (ID) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 231A × 0020 ÷ 3041 ÷	#  × [0.3] WATCH (ID) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 3041 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 231A × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] WATCH (ID) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2024 ÷ 0023 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0023 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 0023 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2024 ÷ 2014 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 2014 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 2014 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2024 × 0009 ÷	#  × [0.3] ONE DOT LEADER (IN) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0009 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0009 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2024 ÷ 00B4 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 00B4 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 00B4 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2024 × 000B ÷	#  × [0.3] ONE DOT LEADER (IN) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 000B ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 000B ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 000B ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2024 ÷ FFFC ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ FFFC ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ FFFC ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2024 × 007D ÷	#  × [0.3] ONE DOT LEADER (IN) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 007D ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 007D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 007D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2024 × 0029 ÷	#  × [0.3] ONE DOT LEADER (IN) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 0029 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0029 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 0029 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 2024 × 000D ÷	#  × [0.3] ONE DOT LEADER (IN) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 000D ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 000D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 000D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2024 × 0021 ÷	#  × [0.3] ONE DOT LEADER (IN) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 0021 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0021 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 0021 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2024 × 00A0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 00A0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 00A0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2024 ÷ AC00 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ AC00 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ AC00 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2024 ÷ AC01 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ AC01 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ AC01 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2024 ÷ 05D0 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 05D0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 05D0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2024 × 002D ÷	#  × [0.3] ONE DOT LEADER (IN) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 002D ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 002D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2024 ÷ 231A ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 231A ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 231A ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2024 × 2024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [22.04] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 2024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 2024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.04] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2024 × 002C ÷	#  × [0.3] ONE DOT LEADER (IN) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 002C ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 002C ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 002C ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2024 ÷ 1100 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 1100 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 1100 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2024 ÷ 11A8 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 11A8 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 11A8 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2024 ÷ 1160 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 1160 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 1160 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2024 × 000A ÷	#  × [0.3] ONE DOT LEADER (IN) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 000A ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 000A ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 000A ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2024 × 0085 ÷	#  × [0.3] ONE DOT LEADER (IN) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 0085 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0085 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 0085 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2024 × 17D6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 17D6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 17D6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2024 ÷ 0030 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0030 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 0030 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2024 ÷ 0028 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0028 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 0028 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 2024 ÷ 0025 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0025 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 0025 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2024 ÷ 0024 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 0024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2024 × 0022 ÷	#  × [0.3] ONE DOT LEADER (IN) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0022 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0022 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 0020 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 0020 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2024 × 002F ÷	#  × [0.3] ONE DOT LEADER (IN) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 002F ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 002F ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 002F ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2024 × 2060 ÷	#  × [0.3] ONE DOT LEADER (IN) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 2060 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 2060 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 2060 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2024 × 200B ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2024 × 0020 × 200B ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 200B ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 × 200B ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2024 ÷ 1F1E6 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 1F1E6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 1F1E6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2024 ÷ 261D ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 261D ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 261D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2024 ÷ 1F3FB ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 1F3FB ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 1F3FB ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2024 × 0001 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0001 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0001 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2024 × 200D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 200D ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 200D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2024 ÷ 00A7 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 00A7 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 00A7 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2024 ÷ 50005 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 50005 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 50005 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2024 ÷ 0E01 ÷	#  × [0.3] ONE DOT LEADER (IN) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 0E01 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 ÷ 0E01 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2024 × 3041 ÷	#  × [0.3] ONE DOT LEADER (IN) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2024 × 0020 ÷ 3041 ÷	#  × [0.3] ONE DOT LEADER (IN) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 3041 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2024 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] ONE DOT LEADER (IN) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002C × 0023 ÷	#  × [0.3] COMMA (IS) × [29.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0023 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0023 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [29.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002C ÷ 2014 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 2014 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 2014 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002C × 0009 ÷	#  × [0.3] COMMA (IS) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0009 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0009 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002C ÷ 00B4 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 00B4 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 00B4 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002C × 000B ÷	#  × [0.3] COMMA (IS) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 000B ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 000B ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 000B ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002C ÷ FFFC ÷	#  × [0.3] COMMA (IS) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ FFFC ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ FFFC ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002C × 007D ÷	#  × [0.3] COMMA (IS) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 007D ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 007D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 007D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002C × 0029 ÷	#  × [0.3] COMMA (IS) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 0029 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0029 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 0029 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 002C × 000D ÷	#  × [0.3] COMMA (IS) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 000D ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 000D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 000D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002C × 0021 ÷	#  × [0.3] COMMA (IS) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 0021 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0021 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 0021 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002C × 00A0 ÷	#  × [0.3] COMMA (IS) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 00A0 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 00A0 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002C ÷ AC00 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ AC00 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ AC00 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002C ÷ AC01 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ AC01 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ AC01 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002C × 05D0 ÷	#  × [0.3] COMMA (IS) × [29.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 05D0 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 05D0 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [29.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002C × 002D ÷	#  × [0.3] COMMA (IS) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 002D ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 002D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 002D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002C ÷ 231A ÷	#  × [0.3] COMMA (IS) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 231A ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 231A ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 231A ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002C ÷ 2024 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 2024 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 2024 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002C × 002C ÷	#  × [0.3] COMMA (IS) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 002C ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 002C ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 002C ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002C ÷ 1100 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 1100 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 1100 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002C ÷ 11A8 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 11A8 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 11A8 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002C ÷ 1160 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 1160 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 1160 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002C × 000A ÷	#  × [0.3] COMMA (IS) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 000A ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 000A ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 000A ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002C × 0085 ÷	#  × [0.3] COMMA (IS) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 0085 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0085 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 0085 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002C × 17D6 ÷	#  × [0.3] COMMA (IS) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 17D6 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 17D6 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002C ÷ 0030 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0030 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 0030 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002C ÷ 0028 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0028 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 0028 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 002C ÷ 0025 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0025 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 0025 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002C ÷ 0024 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0024 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 0024 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002C × 0022 ÷	#  × [0.3] COMMA (IS) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0022 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0022 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 0020 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 0020 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002C × 002F ÷	#  × [0.3] COMMA (IS) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 002F ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 002F ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 002F ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002C × 2060 ÷	#  × [0.3] COMMA (IS) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 2060 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 2060 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 2060 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002C × 200B ÷	#  × [0.3] COMMA (IS) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002C × 0020 × 200B ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 200B ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 × 200B ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002C ÷ 1F1E6 ÷	#  × [0.3] COMMA (IS) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 1F1E6 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 1F1E6 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002C ÷ 261D ÷	#  × [0.3] COMMA (IS) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 261D ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 261D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 261D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002C ÷ 1F3FB ÷	#  × [0.3] COMMA (IS) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 1F3FB ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002C × 0308 ÷ 1F3FB ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002C × 0001 ÷	#  × [0.3] COMMA (IS) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0001 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0001 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002C × 200D ÷	#  × [0.3] COMMA (IS) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 200D ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 200D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 200D ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002C × 00A7 ÷	#  × [0.3] COMMA (IS) × [29.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 00A7 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 00A7 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [29.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002C × 50005 ÷	#  × [0.3] COMMA (IS) × [29.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 50005 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 50005 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [29.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002C × 0E01 ÷	#  × [0.3] COMMA (IS) × [29.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 0E01 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0E01 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [29.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002C × 3041 ÷	#  × [0.3] COMMA (IS) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002C × 0020 ÷ 3041 ÷	#  × [0.3] COMMA (IS) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 3041 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002C × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] COMMA (IS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1100 ÷ 0023 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 0023 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1100 ÷ 2014 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 2014 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1100 × 0009 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0009 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1100 ÷ 00B4 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 00B4 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1100 × 000B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 000B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 000B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 000B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1100 ÷ FFFC ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ FFFC ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1100 × 007D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 007D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 007D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 007D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1100 × 0029 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 0029 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0029 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 0029 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1100 × 000D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 000D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 000D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 000D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1100 × 0021 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 0021 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0021 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 0021 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1100 × 00A0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 00A0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1100 × AC00 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [26.01] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × AC00 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.01] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1100 × AC01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [26.01] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × AC01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.01] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1100 ÷ 05D0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 05D0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1100 × 002D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 002D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1100 ÷ 231A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 231A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1100 × 2024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [27.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 2024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1100 × 002C ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 002C ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 002C ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 002C ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1100 × 1100 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [26.01] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 1100 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.01] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1100 ÷ 11A8 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 11A8 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1100 × 1160 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [26.01] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 1160 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.01] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1100 × 000A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 000A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 000A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 000A ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1100 × 0085 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 0085 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0085 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 0085 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1100 × 17D6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 17D6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1100 ÷ 0030 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 0030 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1100 ÷ 0028 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 0028 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1100 × 0025 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0025 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1100 ÷ 0024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 0024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1100 × 0022 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0022 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 0020 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 0020 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1100 × 002F ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 002F ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 002F ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 002F ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1100 × 2060 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 2060 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 2060 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 2060 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1100 × 200B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1100 × 0020 × 200B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 200B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 × 200B ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1100 ÷ 1F1E6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1100 ÷ 261D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 261D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1100 ÷ 1F3FB ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 1F3FB ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1100 × 0001 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0001 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1100 × 200D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 200D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1100 ÷ 00A7 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 00A7 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1100 ÷ 50005 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 50005 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1100 ÷ 0E01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 ÷ 0E01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1100 × 3041 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1100 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 3041 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1100 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 0023 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 0023 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 2014 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 2014 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 11A8 × 0009 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0009 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 00B4 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 00B4 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 11A8 × 000B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 000B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 000B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 000B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 11A8 ÷ FFFC ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ FFFC ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 11A8 × 007D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 007D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 007D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 007D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 11A8 × 0029 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 0029 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0029 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 0029 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 11A8 × 000D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 000D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 000D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 000D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 11A8 × 0021 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 0021 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0021 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 0021 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 11A8 × 00A0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 00A0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 11A8 ÷ AC00 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ AC00 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 11A8 ÷ AC01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ AC01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 05D0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 05D0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 11A8 × 002D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 002D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 231A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 231A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 11A8 × 2024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [27.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 2024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 11A8 × 002C ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 002C ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 002C ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 002C ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 1100 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 1100 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 11A8 × 11A8 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [26.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 11A8 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 1160 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 1160 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 11A8 × 000A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 000A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 000A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 000A ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 11A8 × 0085 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 0085 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0085 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 0085 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 11A8 × 17D6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 17D6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 0030 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 0030 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 0028 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 0028 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 11A8 × 0025 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0025 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 0024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 0024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 11A8 × 0022 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0022 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 0020 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 0020 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 11A8 × 002F ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 002F ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 002F ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 002F ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 11A8 × 2060 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 2060 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 2060 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 2060 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 11A8 × 200B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 × 200B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 200B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 × 200B ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 261D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 261D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 1F3FB ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 1F3FB ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 11A8 × 0001 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0001 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 200D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 200D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 00A7 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 00A7 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 50005 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 50005 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 11A8 ÷ 0E01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 ÷ 0E01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 11A8 × 3041 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 11A8 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 3041 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 11A8 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1160 ÷ 0023 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 0023 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1160 ÷ 2014 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 2014 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1160 × 0009 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0009 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1160 ÷ 00B4 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 00B4 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1160 × 000B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 000B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 000B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 000B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1160 ÷ FFFC ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ FFFC ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1160 × 007D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 007D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 007D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 007D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1160 × 0029 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 0029 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0029 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 0029 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1160 × 000D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 000D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 000D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 000D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1160 × 0021 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 0021 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0021 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 0021 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1160 × 00A0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 00A0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1160 ÷ AC00 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ AC00 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1160 ÷ AC01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ AC01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1160 ÷ 05D0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 05D0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1160 × 002D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 002D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1160 ÷ 231A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 231A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1160 × 2024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [27.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 2024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1160 × 002C ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 002C ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 002C ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 002C ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1160 ÷ 1100 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 1100 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1160 × 11A8 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [26.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 11A8 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1160 × 1160 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [26.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 1160 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [26.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1160 × 000A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 000A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 000A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 000A ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1160 × 0085 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 0085 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0085 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 0085 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1160 × 17D6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 17D6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1160 ÷ 0030 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 0030 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1160 ÷ 0028 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 0028 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1160 × 0025 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0025 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1160 ÷ 0024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 0024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1160 × 0022 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0022 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 0020 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 0020 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1160 × 002F ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 002F ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 002F ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 002F ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1160 × 2060 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 2060 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 2060 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 2060 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1160 × 200B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1160 × 0020 × 200B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 200B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 × 200B ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1160 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1160 ÷ 261D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 261D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1160 ÷ 1F3FB ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 1F3FB ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1160 × 0001 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0001 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1160 × 200D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 200D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1160 ÷ 00A7 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 00A7 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1160 ÷ 50005 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 50005 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1160 ÷ 0E01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 ÷ 0E01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1160 × 3041 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1160 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 3041 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1160 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0023 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0023 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0023 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 2014 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 2014 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 2014 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0009 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0009 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0009 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 000A ÷ 00B4 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 00B4 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 00B4 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 000A ÷ 000B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 000B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 000B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 000B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 000A ÷ FFFC ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ FFFC ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ FFFC ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 000A ÷ 007D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 007D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 007D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 007D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0029 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 0029 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0029 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 0029 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 000A ÷ 000D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 000D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 000D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 000D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0021 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 0021 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0021 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 0021 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 000A ÷ 00A0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 00A0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 00A0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 000A ÷ AC00 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ AC00 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ AC00 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 000A ÷ AC01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ AC01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ AC01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 000A ÷ 05D0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 05D0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 05D0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 000A ÷ 002D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 002D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 002D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 002D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 000A ÷ 231A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 231A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 231A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 231A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 000A ÷ 2024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 2024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 2024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 000A ÷ 002C ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 002C ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 002C ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 002C ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 000A ÷ 1100 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 1100 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 1100 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 000A ÷ 11A8 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 11A8 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 11A8 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 000A ÷ 1160 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 1160 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 1160 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 000A ÷ 000A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 000A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 000A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 000A ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 000A ÷ 0085 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 0085 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0085 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 0085 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 000A ÷ 17D6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 17D6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 17D6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0030 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0030 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0030 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0028 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0028 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0028 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0025 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0025 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0025 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 000A ÷ 0024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 000A ÷ 0022 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0022 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0022 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 0020 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 0020 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000A ÷ 002F ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 002F ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 002F ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 002F ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 000A ÷ 2060 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 2060 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 2060 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 2060 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 000A ÷ 200B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 × 200B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 8) {
    Test_LB('× 000A ÷ 0308 × 200B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 × 200B ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 000A ÷ 1F1E6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 1F1E6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 1F1E6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 000A ÷ 261D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 261D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 261D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 261D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 000A ÷ 1F3FB ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 1F3FB ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 ÷ 1F3FB ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0001 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0001 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0001 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 200D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 200D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 200D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 200D ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 000A ÷ 00A7 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 00A7 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 00A7 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 50005 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 50005 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 50005 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0E01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 0E01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0E01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 000A ÷ 3041 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0020 ÷ 3041 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 3041 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000A ÷ 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0023 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0023 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0023 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 2014 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 2014 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 2014 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0009 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0009 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0009 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0085 ÷ 00B4 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 00B4 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 00B4 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 000B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 000B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 000B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 000B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0085 ÷ FFFC ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ FFFC ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ FFFC ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 007D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 007D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 007D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 007D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0029 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 0029 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0029 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 0029 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 000D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 000D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 000D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 000D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0021 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 0021 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0021 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 0021 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0085 ÷ 00A0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 00A0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 00A0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0085 ÷ AC00 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ AC00 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ AC00 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0085 ÷ AC01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ AC01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ AC01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0085 ÷ 05D0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 05D0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 05D0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 002D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 002D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 002D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 002D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 231A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 231A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 231A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 231A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0085 ÷ 2024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 2024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 2024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0085 ÷ 002C ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 002C ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 002C ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 002C ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 1100 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 1100 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 1100 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 11A8 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 11A8 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 11A8 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0085 ÷ 1160 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 1160 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 1160 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0085 ÷ 000A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 000A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 000A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 000A ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0085 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 0085 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0085 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 0085 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 17D6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 17D6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 17D6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0030 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0030 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0030 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0028 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0028 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0028 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0025 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0025 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0025 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0022 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0022 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0022 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 0020 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 0020 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0085 ÷ 002F ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 002F ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 002F ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 002F ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0085 ÷ 2060 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 2060 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 2060 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 2060 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0085 ÷ 200B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 × 200B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 200B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 × 200B ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0085 ÷ 1F1E6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 1F1E6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 1F1E6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0085 ÷ 261D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 261D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 261D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 261D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0085 ÷ 1F3FB ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 1F3FB ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 ÷ 1F3FB ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0001 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0001 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0001 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 200D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 200D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 200D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 200D ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0085 ÷ 00A7 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 00A7 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 00A7 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 50005 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 50005 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 50005 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0E01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 0E01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0E01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0085 ÷ 3041 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0020 ÷ 3041 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 3041 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 0023 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0023 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 0023 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 2014 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 2014 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 2014 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 17D6 × 0009 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0009 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0009 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 00B4 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 00B4 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 00B4 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 17D6 × 000B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 000B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 000B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 000B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 17D6 ÷ FFFC ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ FFFC ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ FFFC ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 17D6 × 007D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 007D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 007D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 007D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 17D6 × 0029 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 0029 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0029 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 0029 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 17D6 × 000D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 000D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 000D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 000D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 17D6 × 0021 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 0021 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0021 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 0021 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 17D6 × 00A0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 00A0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 00A0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 17D6 ÷ AC00 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ AC00 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ AC00 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 17D6 ÷ AC01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ AC01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ AC01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 05D0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 05D0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 05D0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 17D6 × 002D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 002D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 002D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 231A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 231A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 231A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 2024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 2024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 2024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 17D6 × 002C ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 002C ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 002C ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 002C ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 1100 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 1100 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 1100 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 11A8 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 11A8 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 11A8 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 1160 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 1160 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 1160 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 17D6 × 000A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 000A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 000A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 000A ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 17D6 × 0085 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 0085 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0085 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 0085 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 17D6 × 17D6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 17D6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 17D6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 0030 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0030 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 0030 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 0028 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0028 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 0028 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 0025 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0025 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 0025 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 0024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 0024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 17D6 × 0022 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0022 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0022 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 0020 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 0020 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 17D6 × 002F ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 002F ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 002F ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 002F ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 17D6 × 2060 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 2060 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 2060 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 2060 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 17D6 × 200B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 × 200B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 200B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 × 200B ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 1F1E6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 1F1E6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 1F1E6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 261D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 261D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 261D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 1F3FB ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 1F3FB ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 1F3FB ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 17D6 × 0001 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0001 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0001 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 200D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 200D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 200D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 00A7 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 00A7 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 00A7 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 50005 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 50005 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 50005 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 17D6 ÷ 0E01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 0E01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 ÷ 0E01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 17D6 × 3041 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 17D6 × 0020 ÷ 3041 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 3041 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 17D6 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] KHMER SIGN CAMNUC PII KUUH (NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0030 × 0023 ÷	#  × [0.3] DIGIT ZERO (NU) × [23.03] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0023 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0023 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.03] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0030 ÷ 2014 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 2014 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 2014 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0030 × 0009 ÷	#  × [0.3] DIGIT ZERO (NU) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0009 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0009 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0030 ÷ 00B4 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 00B4 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 00B4 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0030 × 000B ÷	#  × [0.3] DIGIT ZERO (NU) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 000B ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 000B ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 000B ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0030 ÷ FFFC ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ FFFC ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ FFFC ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0030 × 007D ÷	#  × [0.3] DIGIT ZERO (NU) × [25.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 007D ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 007D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 007D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0030 × 0029 ÷	#  × [0.3] DIGIT ZERO (NU) × [25.04] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 0029 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0029 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.04] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 0029 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0030 × 000D ÷	#  × [0.3] DIGIT ZERO (NU) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 000D ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 000D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 000D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0030 × 0021 ÷	#  × [0.3] DIGIT ZERO (NU) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 0021 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0021 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 0021 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0030 × 00A0 ÷	#  × [0.3] DIGIT ZERO (NU) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 00A0 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 00A0 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0030 ÷ AC00 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ AC00 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ AC00 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0030 ÷ AC01 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ AC01 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ AC01 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0030 × 05D0 ÷	#  × [0.3] DIGIT ZERO (NU) × [23.03] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 05D0 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 05D0 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.03] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0030 × 002D ÷	#  × [0.3] DIGIT ZERO (NU) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 002D ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 002D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0030 ÷ 231A ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 231A ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 231A ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0030 × 2024 ÷	#  × [0.3] DIGIT ZERO (NU) × [22.05] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 2024 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 2024 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.05] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0030 × 002C ÷	#  × [0.3] DIGIT ZERO (NU) × [25.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 002C ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 002C ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 002C ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0030 ÷ 1100 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 1100 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 1100 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0030 ÷ 11A8 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 11A8 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 11A8 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0030 ÷ 1160 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 1160 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 1160 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0030 × 000A ÷	#  × [0.3] DIGIT ZERO (NU) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 000A ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 000A ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 000A ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0030 × 0085 ÷	#  × [0.3] DIGIT ZERO (NU) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 0085 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0085 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 0085 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0030 × 17D6 ÷	#  × [0.3] DIGIT ZERO (NU) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 17D6 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 17D6 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0030 × 0030 ÷	#  × [0.3] DIGIT ZERO (NU) × [25.03] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0030 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0030 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.03] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0030 × 0028 ÷	#  × [0.3] DIGIT ZERO (NU) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0028 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0028 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0030 × 0025 ÷	#  × [0.3] DIGIT ZERO (NU) × [25.05] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0025 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0025 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.05] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0030 × 0024 ÷	#  × [0.3] DIGIT ZERO (NU) × [25.05] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0024 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0024 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.05] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0030 × 0022 ÷	#  × [0.3] DIGIT ZERO (NU) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0022 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0022 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 0020 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 0020 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0030 × 002F ÷	#  × [0.3] DIGIT ZERO (NU) × [25.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 002F ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 002F ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 002F ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0030 × 2060 ÷	#  × [0.3] DIGIT ZERO (NU) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 2060 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 2060 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 2060 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0030 × 200B ÷	#  × [0.3] DIGIT ZERO (NU) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0030 × 0020 × 200B ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 200B ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 × 200B ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0030 ÷ 1F1E6 ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 1F1E6 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 1F1E6 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0030 ÷ 261D ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 261D ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 261D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0030 ÷ 1F3FB ÷	#  × [0.3] DIGIT ZERO (NU) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 1F3FB ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0030 × 0308 ÷ 1F3FB ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0030 × 0001 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0001 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0001 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0030 × 200D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 200D ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 200D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0030 × 00A7 ÷	#  × [0.3] DIGIT ZERO (NU) × [23.03] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 00A7 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 00A7 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.03] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0030 × 50005 ÷	#  × [0.3] DIGIT ZERO (NU) × [23.03] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 50005 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 50005 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.03] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0E01 ÷	#  × [0.3] DIGIT ZERO (NU) × [23.03] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 0E01 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0E01 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.03] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0030 × 3041 ÷	#  × [0.3] DIGIT ZERO (NU) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0030 × 0020 ÷ 3041 ÷	#  × [0.3] DIGIT ZERO (NU) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 3041 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0030 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] DIGIT ZERO (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0028 × 0023 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0023 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0023 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0023 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0028 × 2014 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 2014 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 2014 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 2014 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0028 × 0009 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0009 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0009 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0009 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0028 × 00B4 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 00B4 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 00B4 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 00B4 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0028 × 000B ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 000B ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 000B ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 000B ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0028 × FFFC ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × FFFC ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × FFFC ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × FFFC ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0028 × 007D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 007D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 007D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 007D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0028 × 0029 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0029 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0029 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0029 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0028 × 000D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 000D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 000D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 000D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0028 × 0021 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0021 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0021 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0021 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0028 × 00A0 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 00A0 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 00A0 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 00A0 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0028 × AC00 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × AC00 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × AC00 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × AC00 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0028 × AC01 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × AC01 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × AC01 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × AC01 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0028 × 05D0 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 05D0 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 05D0 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 05D0 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0028 × 002D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 002D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 002D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 002D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0028 × 231A ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 231A ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 231A ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 231A ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0028 × 2024 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 2024 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 2024 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 2024 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0028 × 002C ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 002C ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 002C ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 002C ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0028 × 1100 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 1100 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 1100 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 1100 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0028 × 11A8 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 11A8 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 11A8 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 11A8 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0028 × 1160 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 1160 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 1160 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 1160 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0028 × 000A ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 000A ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 000A ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 000A ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0028 × 0085 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0085 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0085 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0085 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0028 × 17D6 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 17D6 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 17D6 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 17D6 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0028 × 0030 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0030 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0030 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0030 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0028 × 0028 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0028 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0028 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0028 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0028 × 0025 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0025 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0025 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0025 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0028 × 0024 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0024 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0024 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0024 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0028 × 0022 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0022 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0022 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0022 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0028 × 0020 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0020 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0020 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0028 × 002F ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 002F ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 002F ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 002F ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0028 × 2060 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 2060 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 2060 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 2060 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0028 × 200B ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 200B ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 200B ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 200B ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0028 × 1F1E6 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 1F1E6 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 1F1E6 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 1F1E6 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0028 × 261D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 261D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 261D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 261D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0028 × 1F3FB ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 1F3FB ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 1F3FB ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 1F3FB ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0028 × 0001 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0001 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0001 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0001 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0028 × 200D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 200D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 200D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 200D ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0028 × 00A7 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 00A7 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 00A7 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 00A7 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0028 × 50005 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 50005 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 50005 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 50005 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0E01 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 0E01 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0E01 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 0E01 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0028 × 3041 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0028 × 0020 × 3041 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 3041 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [14.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0028 × 0308 × 0020 × 3041 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [14.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0025 × 0023 ÷	#  × [0.3] PERCENT SIGN (PO) × [24.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0023 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0023 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0025 ÷ 2014 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 2014 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 2014 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0025 × 0009 ÷	#  × [0.3] PERCENT SIGN (PO) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0009 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0009 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0025 ÷ 00B4 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 00B4 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 00B4 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0025 × 000B ÷	#  × [0.3] PERCENT SIGN (PO) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 000B ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 000B ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 000B ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0025 ÷ FFFC ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ FFFC ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ FFFC ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0025 × 007D ÷	#  × [0.3] PERCENT SIGN (PO) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 007D ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 007D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 007D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0025 × 0029 ÷	#  × [0.3] PERCENT SIGN (PO) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 0029 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0029 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 0029 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0025 × 000D ÷	#  × [0.3] PERCENT SIGN (PO) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 000D ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 000D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 000D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0025 × 0021 ÷	#  × [0.3] PERCENT SIGN (PO) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 0021 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0021 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 0021 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0025 × 00A0 ÷	#  × [0.3] PERCENT SIGN (PO) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 00A0 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 00A0 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0025 ÷ AC00 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ AC00 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ AC00 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0025 ÷ AC01 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ AC01 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ AC01 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0025 × 05D0 ÷	#  × [0.3] PERCENT SIGN (PO) × [24.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 05D0 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 05D0 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0025 × 002D ÷	#  × [0.3] PERCENT SIGN (PO) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 002D ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 002D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0025 ÷ 231A ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 231A ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 231A ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0025 ÷ 2024 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 2024 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 2024 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0025 × 002C ÷	#  × [0.3] PERCENT SIGN (PO) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 002C ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 002C ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 002C ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0025 ÷ 1100 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 1100 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 1100 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0025 ÷ 11A8 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 11A8 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 11A8 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0025 ÷ 1160 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 1160 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 1160 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0025 × 000A ÷	#  × [0.3] PERCENT SIGN (PO) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 000A ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 000A ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 000A ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0025 × 0085 ÷	#  × [0.3] PERCENT SIGN (PO) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 0085 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0085 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 0085 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0025 × 17D6 ÷	#  × [0.3] PERCENT SIGN (PO) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 17D6 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 17D6 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0025 × 0030 ÷	#  × [0.3] PERCENT SIGN (PO) × [25.01] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0030 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0030 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.01] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0025 ÷ 0028 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0028 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 0028 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0025 ÷ 0025 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0025 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 0025 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0025 ÷ 0024 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0024 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 0024 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0025 × 0022 ÷	#  × [0.3] PERCENT SIGN (PO) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0022 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0022 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 0020 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 0020 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0025 × 002F ÷	#  × [0.3] PERCENT SIGN (PO) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 002F ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 002F ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 002F ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0025 × 2060 ÷	#  × [0.3] PERCENT SIGN (PO) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 2060 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 2060 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 2060 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0025 × 200B ÷	#  × [0.3] PERCENT SIGN (PO) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0025 × 0020 × 200B ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 200B ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 × 200B ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0025 ÷ 1F1E6 ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 1F1E6 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 1F1E6 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0025 ÷ 261D ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 261D ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 261D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0025 ÷ 1F3FB ÷	#  × [0.3] PERCENT SIGN (PO) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 1F3FB ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0025 × 0308 ÷ 1F3FB ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0025 × 0001 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0001 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0001 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0025 × 200D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 200D ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 200D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0025 × 00A7 ÷	#  × [0.3] PERCENT SIGN (PO) × [24.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 00A7 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 00A7 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0025 × 50005 ÷	#  × [0.3] PERCENT SIGN (PO) × [24.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 50005 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 50005 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0E01 ÷	#  × [0.3] PERCENT SIGN (PO) × [24.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 0E01 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0E01 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0025 × 3041 ÷	#  × [0.3] PERCENT SIGN (PO) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0025 × 0020 ÷ 3041 ÷	#  × [0.3] PERCENT SIGN (PO) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 3041 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0025 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] PERCENT SIGN (PO) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0024 × 0023 ÷	#  × [0.3] DOLLAR SIGN (PR) × [24.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0023 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0023 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0024 ÷ 2014 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 2014 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 2014 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0024 × 0009 ÷	#  × [0.3] DOLLAR SIGN (PR) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0009 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0009 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0024 ÷ 00B4 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 00B4 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 00B4 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0024 × 000B ÷	#  × [0.3] DOLLAR SIGN (PR) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 000B ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 000B ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 000B ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0024 ÷ FFFC ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ FFFC ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ FFFC ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0024 × 007D ÷	#  × [0.3] DOLLAR SIGN (PR) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 007D ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 007D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 007D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0024 × 0029 ÷	#  × [0.3] DOLLAR SIGN (PR) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 0029 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0029 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 0029 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0024 × 000D ÷	#  × [0.3] DOLLAR SIGN (PR) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 000D ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 000D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 000D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0024 × 0021 ÷	#  × [0.3] DOLLAR SIGN (PR) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 0021 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0021 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 0021 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0024 × 00A0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 00A0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 00A0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0024 × AC00 ÷	#  × [0.3] DOLLAR SIGN (PR) × [27.03] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ AC00 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × AC00 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.03] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0024 × AC01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [27.03] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ AC01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × AC01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.03] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0024 × 05D0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [24.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 05D0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 05D0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0024 × 002D ÷	#  × [0.3] DOLLAR SIGN (PR) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 002D ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 002D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0024 × 231A ÷	#  × [0.3] DOLLAR SIGN (PR) × [23.12] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 231A ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 231A ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.12] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0024 ÷ 2024 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 2024 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 2024 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0024 × 002C ÷	#  × [0.3] DOLLAR SIGN (PR) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 002C ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 002C ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 002C ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0024 × 1100 ÷	#  × [0.3] DOLLAR SIGN (PR) × [27.03] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 1100 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 1100 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.03] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0024 × 11A8 ÷	#  × [0.3] DOLLAR SIGN (PR) × [27.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 11A8 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 11A8 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0024 × 1160 ÷	#  × [0.3] DOLLAR SIGN (PR) × [27.03] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 1160 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 1160 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [27.03] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0024 × 000A ÷	#  × [0.3] DOLLAR SIGN (PR) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 000A ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 000A ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 000A ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0024 × 0085 ÷	#  × [0.3] DOLLAR SIGN (PR) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 0085 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0085 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 0085 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0024 × 17D6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 17D6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 17D6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0024 × 0030 ÷	#  × [0.3] DOLLAR SIGN (PR) × [25.01] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0030 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0030 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [25.01] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0024 ÷ 0028 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0028 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 0028 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0024 ÷ 0025 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0025 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 0025 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0024 ÷ 0024 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0024 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 0024 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0024 × 0022 ÷	#  × [0.3] DOLLAR SIGN (PR) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0022 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0022 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 0020 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 0020 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0024 × 002F ÷	#  × [0.3] DOLLAR SIGN (PR) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 002F ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 002F ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 002F ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0024 × 2060 ÷	#  × [0.3] DOLLAR SIGN (PR) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 2060 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 2060 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 2060 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0024 × 200B ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0024 × 0020 × 200B ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 200B ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 × 200B ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0024 ÷ 1F1E6 ÷	#  × [0.3] DOLLAR SIGN (PR) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 1F1E6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0024 × 0308 ÷ 1F1E6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0024 × 261D ÷	#  × [0.3] DOLLAR SIGN (PR) × [23.12] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 261D ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 261D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.12] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0024 × 1F3FB ÷	#  × [0.3] DOLLAR SIGN (PR) × [23.12] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 1F3FB ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 1F3FB ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.12] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0024 × 0001 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0001 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0001 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0024 × 200D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 200D ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 200D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0024 × 00A7 ÷	#  × [0.3] DOLLAR SIGN (PR) × [24.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 00A7 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 00A7 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0024 × 50005 ÷	#  × [0.3] DOLLAR SIGN (PR) × [24.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 50005 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 50005 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0E01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [24.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 0E01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0E01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0024 × 3041 ÷	#  × [0.3] DOLLAR SIGN (PR) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0024 × 0020 ÷ 3041 ÷	#  × [0.3] DOLLAR SIGN (PR) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 3041 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0024 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] DOLLAR SIGN (PR) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0022 × 0023 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0023 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0023 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0022 × 2014 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 2014 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 2014 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0022 × 0009 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0009 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0009 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0022 × 00B4 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 00B4 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 00B4 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0022 × 000B ÷	#  × [0.3] QUOTATION MARK (QU) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 000B ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 000B ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 000B ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0022 × FFFC ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ FFFC ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × FFFC ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0022 × 007D ÷	#  × [0.3] QUOTATION MARK (QU) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 007D ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 007D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 007D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0022 × 0029 ÷	#  × [0.3] QUOTATION MARK (QU) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 0029 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0029 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 0029 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0022 × 000D ÷	#  × [0.3] QUOTATION MARK (QU) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 000D ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 000D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 000D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0022 × 0021 ÷	#  × [0.3] QUOTATION MARK (QU) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 0021 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0021 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 0021 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0022 × 00A0 ÷	#  × [0.3] QUOTATION MARK (QU) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 00A0 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 00A0 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0022 × AC00 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ AC00 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × AC00 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0022 × AC01 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ AC01 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × AC01 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0022 × 05D0 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 05D0 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 05D0 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0022 × 002D ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 002D ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 002D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0022 × 231A ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 231A ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 231A ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0022 × 2024 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 2024 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 2024 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0022 × 002C ÷	#  × [0.3] QUOTATION MARK (QU) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 002C ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 002C ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 002C ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0022 × 1100 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 1100 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 1100 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0022 × 11A8 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 11A8 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 11A8 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0022 × 1160 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 1160 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 1160 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0022 × 000A ÷	#  × [0.3] QUOTATION MARK (QU) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 000A ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 000A ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 000A ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0022 × 0085 ÷	#  × [0.3] QUOTATION MARK (QU) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 0085 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0085 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 0085 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0022 × 17D6 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 17D6 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 17D6 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0022 × 0030 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0030 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0030 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0022 × 0028 ÷	#  × [0.3] QUOTATION MARK (QU) × [15.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 0028 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [15.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0028 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [15.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 0028 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [15.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0022 × 0025 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0025 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0025 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0022 × 0024 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0024 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0024 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0022 × 0022 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0022 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0022 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 0020 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 0020 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0022 × 002F ÷	#  × [0.3] QUOTATION MARK (QU) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 002F ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 002F ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 002F ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0022 × 2060 ÷	#  × [0.3] QUOTATION MARK (QU) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 2060 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 2060 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 2060 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0022 × 200B ÷	#  × [0.3] QUOTATION MARK (QU) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0022 × 0020 × 200B ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 200B ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 × 200B ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0022 × 1F1E6 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 1F1E6 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 1F1E6 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0022 × 261D ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 261D ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 261D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0022 × 1F3FB ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 1F3FB ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 1F3FB ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0022 × 0001 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0001 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0001 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0022 × 200D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 200D ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 200D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0022 × 00A7 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 00A7 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 00A7 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0022 × 50005 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 50005 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 50005 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0E01 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 0E01 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0E01 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0022 × 3041 ÷	#  × [0.3] QUOTATION MARK (QU) × [19.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0022 × 0020 ÷ 3041 ÷	#  × [0.3] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 3041 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0022 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0023 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0023 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0023 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0023 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 2014 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 2014 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 2014 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 2014 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0009 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0009 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0009 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0009 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0020 ÷ 00B4 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 00B4 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 00B4 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0020 × 000B ÷	#  × [0.3] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 000B ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 000B ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 000B ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0020 ÷ FFFC ÷	#  × [0.3] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ FFFC ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ FFFC ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ FFFC ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0020 × 007D ÷	#  × [0.3] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 007D ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 007D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 007D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0020 × 0029 ÷	#  × [0.3] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 0029 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0029 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 0029 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0020 × 000D ÷	#  × [0.3] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 000D ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 000D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 000D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0020 × 0021 ÷	#  × [0.3] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 0021 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0021 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 0021 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0020 ÷ 00A0 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 00A0 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 00A0 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0020 ÷ AC00 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ AC00 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ AC00 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ AC00 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0020 ÷ AC01 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ AC01 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ AC01 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ AC01 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0020 ÷ 05D0 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 05D0 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 05D0 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 002D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 002D ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 002D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 002D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0020 ÷ 231A ÷	#  × [0.3] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 231A ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 231A ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 231A ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0020 ÷ 2024 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 2024 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 2024 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 2024 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0020 × 002C ÷	#  × [0.3] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 002C ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 002C ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 002C ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 1100 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 1100 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 1100 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 1100 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 11A8 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 11A8 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 11A8 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0020 ÷ 1160 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 1160 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 1160 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 1160 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0020 × 000A ÷	#  × [0.3] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 000A ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 000A ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 000A ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0020 × 0085 ÷	#  × [0.3] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 0085 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0085 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 0085 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 17D6 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 17D6 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 17D6 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0030 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0030 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0030 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0030 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0028 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0028 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0028 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0028 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0025 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0025 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0025 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0025 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0024 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0024 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0024 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0024 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0022 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0022 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0022 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0022 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 0020 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 0020 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0020 × 002F ÷	#  × [0.3] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 002F ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 002F ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 002F ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0020 × 2060 ÷	#  × [0.3] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 2060 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 2060 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 2060 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0020 × 200B ÷	#  × [0.3] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0020 × 0020 × 200B ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 200B ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 × 200B ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0020 ÷ 1F1E6 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 1F1E6 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 1F1E6 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0020 ÷ 261D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 261D ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 261D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 261D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0020 ÷ 1F3FB ÷	#  × [0.3] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 1F3FB ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 ÷ 1F3FB ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0001 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0001 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0001 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0001 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 200D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 200D ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 200D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 200D ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 00A7 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 00A7 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 00A7 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 50005 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 50005 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 50005 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 50005 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0E01 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 0E01 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0E01 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0020 ÷ 3041 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0020 × 0020 ÷ 3041 ÷	#  × [0.3] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 3041 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0020 ÷ 0308 × 0020 ÷ 3041 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002F ÷ 0023 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0023 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 0023 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 002F ÷ 2014 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 2014 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 2014 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 002F × 0009 ÷	#  × [0.3] SOLIDUS (SY) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0009 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0009 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 002F ÷ 00B4 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 00B4 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 00B4 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 002F × 000B ÷	#  × [0.3] SOLIDUS (SY) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 000B ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 000B ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 000B ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 002F ÷ FFFC ÷	#  × [0.3] SOLIDUS (SY) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ FFFC ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ FFFC ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 002F × 007D ÷	#  × [0.3] SOLIDUS (SY) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 007D ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 007D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 007D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 002F × 0029 ÷	#  × [0.3] SOLIDUS (SY) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 0029 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0029 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 0029 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 002F × 000D ÷	#  × [0.3] SOLIDUS (SY) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 000D ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 000D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 000D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 002F × 0021 ÷	#  × [0.3] SOLIDUS (SY) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 0021 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0021 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 0021 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 002F × 00A0 ÷	#  × [0.3] SOLIDUS (SY) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 00A0 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 00A0 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 002F ÷ AC00 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ AC00 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ AC00 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 002F ÷ AC01 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ AC01 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ AC01 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 002F × 05D0 ÷	#  × [0.3] SOLIDUS (SY) × [21.2] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 05D0 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 05D0 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.2] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 002F × 002D ÷	#  × [0.3] SOLIDUS (SY) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 002D ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 002D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 002D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 002F ÷ 231A ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 231A ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 231A ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 231A ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 002F ÷ 2024 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 2024 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 2024 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 002F × 002C ÷	#  × [0.3] SOLIDUS (SY) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 002C ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 002C ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 002C ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 002F ÷ 1100 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 1100 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 1100 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 002F ÷ 11A8 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 11A8 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 11A8 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 002F ÷ 1160 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 1160 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 1160 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 002F × 000A ÷	#  × [0.3] SOLIDUS (SY) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 000A ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 000A ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 000A ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 002F × 0085 ÷	#  × [0.3] SOLIDUS (SY) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 0085 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0085 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 0085 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 002F × 17D6 ÷	#  × [0.3] SOLIDUS (SY) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 17D6 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 17D6 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 002F ÷ 0030 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0030 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 0030 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 002F ÷ 0028 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0028 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 0028 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 002F ÷ 0025 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0025 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 0025 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 002F ÷ 0024 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0024 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 0024 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 002F × 0022 ÷	#  × [0.3] SOLIDUS (SY) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0022 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0022 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 0020 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 0020 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002F × 002F ÷	#  × [0.3] SOLIDUS (SY) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 002F ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 002F ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 002F ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 002F × 2060 ÷	#  × [0.3] SOLIDUS (SY) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 2060 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 2060 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 2060 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 002F × 200B ÷	#  × [0.3] SOLIDUS (SY) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002F × 0020 × 200B ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 200B ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 × 200B ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 002F ÷ 1F1E6 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 1F1E6 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 1F1E6 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 002F ÷ 261D ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 261D ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 261D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 261D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 002F ÷ 1F3FB ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 1F3FB ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 1F3FB ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 002F × 0001 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0001 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0001 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 002F × 200D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 200D ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 200D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 200D ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 002F ÷ 00A7 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 00A7 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 00A7 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 002F ÷ 50005 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 50005 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 50005 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 002F ÷ 0E01 ÷	#  × [0.3] SOLIDUS (SY) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 0E01 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 ÷ 0E01 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 002F × 3041 ÷	#  × [0.3] SOLIDUS (SY) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002F × 0020 ÷ 3041 ÷	#  × [0.3] SOLIDUS (SY) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 3041 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 002F × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] SOLIDUS (SY) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2060 × 0023 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0023 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0023 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 2060 × 2014 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 2014 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 2014 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 2060 × 0009 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0009 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0009 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 2060 × 00B4 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 00B4 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 00B4 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 2060 × 000B ÷	#  × [0.3] WORD JOINER (WJ) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 000B ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 000B ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 000B ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 2060 × FFFC ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ FFFC ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × FFFC ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 2060 × 007D ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 007D ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 007D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 007D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 2060 × 0029 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 0029 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0029 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 0029 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 2060 × 000D ÷	#  × [0.3] WORD JOINER (WJ) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 000D ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 000D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 000D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 2060 × 0021 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 0021 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0021 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 0021 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 2060 × 00A0 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 00A0 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 00A0 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 2060 × AC00 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ AC00 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × AC00 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 2060 × AC01 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ AC01 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × AC01 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 2060 × 05D0 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 05D0 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 05D0 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 2060 × 002D ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 002D ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 002D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 2060 × 231A ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 231A ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 231A ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 2060 × 2024 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 2024 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 2024 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2060 × 002C ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 002C ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 002C ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 002C ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 2060 × 1100 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 1100 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 1100 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 2060 × 11A8 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 11A8 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 11A8 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 2060 × 1160 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 1160 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 1160 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 2060 × 000A ÷	#  × [0.3] WORD JOINER (WJ) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 000A ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 000A ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 000A ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 2060 × 0085 ÷	#  × [0.3] WORD JOINER (WJ) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 0085 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0085 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 0085 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 2060 × 17D6 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 17D6 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 17D6 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 2060 × 0030 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0030 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0030 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 2060 × 0028 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0028 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0028 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 2060 × 0025 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0025 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0025 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 2060 × 0024 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0024 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0024 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 2060 × 0022 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0022 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0022 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 0020 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 0020 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 2060 × 002F ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 002F ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 002F ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 002F ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2060 × 2060 ÷	#  × [0.3] WORD JOINER (WJ) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 2060 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 2060 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 2060 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2060 × 200B ÷	#  × [0.3] WORD JOINER (WJ) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2060 × 0020 × 200B ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 200B ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 × 200B ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 2060 × 1F1E6 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 1F1E6 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 1F1E6 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 2060 × 261D ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 261D ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 261D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 2060 × 1F3FB ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 1F3FB ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 1F3FB ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 2060 × 0001 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0001 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0001 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 2060 × 200D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 200D ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 200D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 2060 × 00A7 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 00A7 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 00A7 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 2060 × 50005 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 50005 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 50005 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0E01 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 0E01 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0E01 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 2060 × 3041 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2060 × 0020 ÷ 3041 ÷	#  × [0.3] WORD JOINER (WJ) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 3041 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 2060 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] WORD JOINER (WJ) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0023 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0023 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0023 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0023 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 2014 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 2014 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 2014 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 2014 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200B ÷ 0009 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0009 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0009 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0009 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200B ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200B × 000B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200B × 0020 × 000B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 000B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 000B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200B ÷ FFFC ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ FFFC ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ FFFC ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ FFFC ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200B ÷ 007D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 007D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 007D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 007D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0029 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0029 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0029 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 0029 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 200B × 000D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200B × 0020 × 000D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 000D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 000D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200B ÷ 0021 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0021 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0021 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 0021 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200B ÷ 00A0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 00A0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 00A0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200B ÷ AC00 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ AC00 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ AC00 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ AC00 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200B ÷ AC01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ AC01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ AC01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ AC01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200B ÷ 05D0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 05D0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 05D0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200B ÷ 002D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 002D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 002D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 002D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200B ÷ 231A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 231A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 231A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 231A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200B ÷ 2024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 2024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 2024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 2024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200B ÷ 002C ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 002C ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 002C ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 002C ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200B ÷ 1100 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 1100 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 1100 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 1100 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200B ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200B ÷ 1160 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 1160 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 1160 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 1160 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200B × 000A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200B × 0020 × 000A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 000A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 000A ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200B × 0085 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200B × 0020 × 0085 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0085 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 0085 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200B ÷ 17D6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 17D6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 17D6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0030 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0030 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0030 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0030 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200B ÷ 0028 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0028 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0028 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0028 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 200B ÷ 0025 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0025 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0025 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0025 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200B ÷ 0024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 9) {
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0024 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200B ÷ 0022 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0022 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0022 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0022 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200B × 0020 × 0020 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 0020 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200B ÷ 002F ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 002F ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 002F ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 002F ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200B ÷ 2060 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 2060 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 2060 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 2060 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200B × 200B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200B × 0020 × 200B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 200B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 × 200B ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200B ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200B ÷ 261D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 261D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 261D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 261D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200B ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0001 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0001 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0001 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0001 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200B ÷ 200D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 200D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 200D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 200D ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200B ÷ 00A7 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 00A7 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 00A7 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 50005 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 50005 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 50005 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 50005 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0E01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 0E01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0E01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200B ÷ 3041 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200B × 0020 ÷ 3041 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) × [7.01] SPACE (SP) ÷ [8.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 3041 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200B ÷ 0308 × 0020 ÷ 3041 ÷	#  × [0.3] ZERO WIDTH SPACE (ZW) ÷ [8.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 0023 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0023 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 0023 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 2014 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 2014 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 2014 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0009 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0009 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0009 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 00B4 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 00B4 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 00B4 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 000B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 000B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 000B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 000B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ FFFC ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ FFFC ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ FFFC ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 007D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 007D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 007D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 007D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0029 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 0029 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0029 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 0029 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 000D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 000D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 000D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 000D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0021 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 0021 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0021 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 0021 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F1E6 × 00A0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 00A0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 00A0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ AC00 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ AC00 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ AC00 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ AC01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ AC01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ AC01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 05D0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 05D0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 05D0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 002D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 002D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 002D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 231A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 231A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 231A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 2024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 2024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 2024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F1E6 × 002C ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 002C ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 002C ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 002C ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 1100 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 1100 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 1100 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 11A8 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 11A8 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 11A8 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 1160 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 1160 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 1160 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F1E6 × 000A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 000A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 000A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 000A ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0085 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 0085 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0085 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 0085 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 17D6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 17D6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 17D6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 0030 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0030 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 0030 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 0028 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0028 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 0028 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 0025 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0025 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 0025 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 0024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 0024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0022 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0022 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0022 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 0020 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 0020 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F1E6 × 002F ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 002F ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 002F ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 002F ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F1E6 × 2060 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 2060 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 2060 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 2060 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F1E6 × 200B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 × 200B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 200B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 × 200B ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F1E6 × 1F1E6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [30.11] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 1F1E6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 1F1E6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.11] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 261D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 261D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 261D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 1F3FB ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 1F3FB ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 1F3FB ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0001 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0001 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0001 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 200D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 200D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 200D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 00A7 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 00A7 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 00A7 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 50005 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 50005 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 50005 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 ÷ 0E01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 0E01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 ÷ 0E01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F1E6 × 3041 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0020 ÷ 3041 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 3041 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F1E6 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 261D ÷ 0023 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0023 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 0023 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 261D ÷ 2014 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 2014 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 2014 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 261D × 0009 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0009 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0009 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 261D ÷ 00B4 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 00B4 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 00B4 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 261D × 000B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 000B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 000B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 000B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 261D ÷ FFFC ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ FFFC ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ FFFC ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 261D × 007D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 007D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 007D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 007D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 261D × 0029 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 0029 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0029 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 0029 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 261D × 000D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 000D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 000D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 000D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 261D × 0021 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 0021 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0021 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 0021 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 261D × 00A0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 00A0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 00A0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 261D ÷ AC00 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ AC00 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ AC00 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 261D ÷ AC01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ AC01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ AC01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 261D ÷ 05D0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 05D0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 05D0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 261D × 002D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 002D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 002D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 002D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 261D ÷ 231A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 231A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 231A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 231A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 261D × 2024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [22.03] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 2024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 2024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.03] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 261D × 002C ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 002C ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 002C ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 002C ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 261D ÷ 1100 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 1100 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 1100 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 261D ÷ 11A8 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 11A8 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 11A8 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 261D ÷ 1160 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 1160 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 1160 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 261D × 000A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 000A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 000A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 000A ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 261D × 0085 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 0085 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0085 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 0085 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 261D × 17D6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 17D6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 17D6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 261D ÷ 0030 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0030 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 0030 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 261D ÷ 0028 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0028 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 0028 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 261D × 0025 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0025 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0025 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 261D ÷ 0024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 0024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 261D × 0022 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0022 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0022 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 0020 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 0020 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 261D × 002F ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 002F ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 002F ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 002F ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 261D × 2060 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 2060 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 2060 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 2060 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 261D × 200B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 261D × 0020 × 200B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 200B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 × 200B ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 261D ÷ 1F1E6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 1F1E6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 1F1E6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 261D ÷ 261D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 261D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 261D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 261D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 261D × 1F3FB ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [30.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 1F3FB ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 1F3FB ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 261D × 0001 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0001 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0001 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 261D × 200D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 200D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 200D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 200D ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 261D ÷ 00A7 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 00A7 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 00A7 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 261D ÷ 50005 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 50005 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 50005 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 261D ÷ 0E01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 0E01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 ÷ 0E01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 261D × 3041 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 261D × 0020 ÷ 3041 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 3041 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 261D × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 0023 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0023 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 0023 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 2014 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 2014 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 2014 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0009 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0009 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0009 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 00B4 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 00B4 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 00B4 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 1F3FB × 000B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 000B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 000B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 000B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ FFFC ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ FFFC ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ FFFC ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 1F3FB × 007D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 007D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 007D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 007D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0029 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 0029 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0029 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 0029 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 1F3FB × 000D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 000D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 000D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 000D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0021 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 0021 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0021 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 0021 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 1F3FB × 00A0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 00A0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 00A0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ AC00 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ AC00 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ AC00 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ AC01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ AC01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ AC01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 05D0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 05D0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 05D0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 1F3FB × 002D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 002D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 002D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 002D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 231A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 231A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 231A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 231A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 1F3FB × 2024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [22.03] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 2024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 2024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.03] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1F3FB × 002C ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 002C ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 002C ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 002C ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 1100 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 1100 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 1100 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 11A8 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 11A8 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 11A8 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 1160 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 1160 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 1160 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1F3FB × 000A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 000A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 000A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 000A ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 1F3FB × 0085 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 0085 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0085 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 0085 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 1F3FB × 17D6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 17D6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 17D6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 0030 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0030 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 0030 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 0028 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0028 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 0028 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0025 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0025 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0025 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 0024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 0024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 1F3FB × 0022 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0022 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0022 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 0020 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 0020 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 1F3FB × 002F ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 002F ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 002F ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 002F ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 1F3FB × 2060 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 2060 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 2060 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 2060 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 1F3FB × 200B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 × 200B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 200B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 × 200B ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 1F1E6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 1F1E6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 1F1E6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 261D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 261D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 261D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 261D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 1F3FB ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 1F3FB ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 1F3FB ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0001 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0001 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0001 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 200D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 200D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 200D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 200D ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 00A7 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 00A7 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 00A7 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 50005 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 50005 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 50005 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 1F3FB ÷ 0E01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 0E01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 ÷ 0E01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1F3FB × 3041 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0020 ÷ 3041 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 3041 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 1F3FB × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0001 × 0023 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0023 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0023 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0001 ÷ 2014 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 2014 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 2014 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0001 × 0009 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0009 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0009 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0001 ÷ 00B4 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 00B4 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 00B4 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0001 × 000B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 000B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 000B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 000B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0001 ÷ FFFC ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ FFFC ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ FFFC ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0001 × 007D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [13.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 007D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 007D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 007D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0001 × 0029 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [13.04] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 0029 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0029 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.04] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 0029 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0001 × 000D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 000D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 000D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 000D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0001 × 0021 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 0021 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0021 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 0021 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0001 × 00A0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [12.3] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 00A0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 00A0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.3] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0001 ÷ AC00 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ AC00 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ AC00 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0001 ÷ AC01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ AC01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ AC01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0001 × 05D0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 05D0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 05D0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0001 × 002D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 002D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 002D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0001 ÷ 231A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 231A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 231A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0001 × 2024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 2024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 2024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0001 × 002C ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [13.04] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 002C ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 002C ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.04] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 002C ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0001 ÷ 1100 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 1100 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 1100 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0001 ÷ 11A8 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 11A8 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 11A8 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0001 ÷ 1160 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 1160 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 1160 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0001 × 000A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 000A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 000A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 000A ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0001 × 0085 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 0085 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0085 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 0085 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0001 × 17D6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 17D6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 17D6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0001 × 0030 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0030 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0030 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0001 × 0028 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0028 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0028 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0001 × 0025 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0025 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0025 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0001 × 0024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0001 × 0022 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0022 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0022 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 0020 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 0020 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0001 × 002F ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [13.04] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 002F ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 002F ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.04] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 002F ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0001 × 2060 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 2060 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 2060 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 2060 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0001 × 200B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0001 × 0020 × 200B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 200B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 × 200B ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0001 ÷ 1F1E6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 1F1E6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0001 ÷ 261D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 261D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 261D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0001 ÷ 1F3FB ÷	#  × [0.3] <START OF HEADING> (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 1F3FB ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0001 × 0308 ÷ 1F3FB ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0001 × 0001 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0001 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0001 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0001 × 200D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 200D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 200D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0001 × 00A7 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 00A7 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 00A7 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0001 × 50005 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 50005 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 50005 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0E01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 0E01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0E01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0001 × 3041 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0001 × 0020 ÷ 3041 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 3041 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0001 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <START OF HEADING> (CM1_CM) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200D × 0023 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0023 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0023 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 200D × 2014 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 2014 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 2014 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 200D × 0009 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0009 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0009 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 200D × 00B4 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 200D × 000B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 000B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 000B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 000B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 200D × FFFC ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ FFFC ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ FFFC ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 200D × 007D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 007D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 007D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [13.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 007D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 200D × 0029 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 0029 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0029 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [13.04] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 0029 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 200D × 000D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 000D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 000D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 000D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 200D × 0021 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 0021 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0021 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 0021 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 200D × 00A0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 00A0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 00A0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [12.3] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200D × AC00 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ AC00 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ AC00 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 200D × AC01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ AC01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ AC01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 200D × 05D0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 05D0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 05D0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 200D × 002D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 002D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 002D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 002D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 200D × 231A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 231A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 231A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 231A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 200D × 2024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 2024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 2024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 200D × 002C ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 002C ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 002C ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [13.04] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 002C ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 200D × 1100 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 1100 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 1100 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 200D × 11A8 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 200D × 1160 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 1160 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 1160 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 200D × 000A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 000A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 000A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 000A ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 200D × 0085 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 0085 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0085 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 0085 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 200D × 17D6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 17D6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 17D6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 200D × 0030 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0030 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0030 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 200D × 0028 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0028 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0028 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 200D × 0025 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0025 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0025 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 200D × 0024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 200D × 0022 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0022 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0022 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 0020 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 0020 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 200D × 002F ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 002F ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 002F ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [13.04] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 002F ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 200D × 2060 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 2060 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 2060 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 2060 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 200D × 200B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200D × 0020 × 200B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 200B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 × 200B ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 200D × 1F1E6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 200D × 261D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 261D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 261D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 261D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 200D × 1F3FB ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200D × 0308 ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 200D × 0001 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0001 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0001 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 200D × 200D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 200D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 200D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 200D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 200D × 00A7 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 00A7 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 00A7 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 200D × 50005 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 50005 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 50005 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 200D × 0E01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 0E01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0E01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 200D × 3041 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200D × 0020 ÷ 3041 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 3041 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200D × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0023 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0023 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0023 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 2014 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 2014 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 2014 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 00A7 × 0009 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0009 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0009 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 00B4 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 00B4 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 00B4 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 00A7 × 000B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 000B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 000B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 000B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 00A7 ÷ FFFC ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ FFFC ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ FFFC ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 00A7 × 007D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 007D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 007D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 007D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 00A7 × 0029 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 0029 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0029 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 0029 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 00A7 × 000D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 000D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 000D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 000D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 00A7 × 0021 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 0021 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0021 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 0021 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 00A7 × 00A0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 00A0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 00A0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 00A7 ÷ AC00 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ AC00 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ AC00 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 00A7 ÷ AC01 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ AC01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ AC01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 00A7 × 05D0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 05D0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 05D0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 00A7 × 002D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 002D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 002D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 231A ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 231A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 231A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 00A7 × 2024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 2024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 2024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 00A7 × 002C ÷	#  × [0.3] SECTION SIGN (AI_AL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 002C ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 002C ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 002C ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 1100 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 1100 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 1100 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 11A8 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 11A8 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 11A8 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 1160 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 1160 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 1160 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 00A7 × 000A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 000A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 000A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 000A ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 00A7 × 0085 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 0085 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0085 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 0085 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 00A7 × 17D6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 17D6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 17D6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0030 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0030 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0030 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 00A7 × 0028 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0028 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0028 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 00A7 × 0025 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0025 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0025 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 00A7 × 0024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 00A7 × 0022 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0022 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0022 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 0020 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 0020 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 00A7 × 002F ÷	#  × [0.3] SECTION SIGN (AI_AL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 002F ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 002F ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 002F ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 00A7 × 2060 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 2060 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 2060 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 2060 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 00A7 × 200B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 × 200B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 200B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 × 200B ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 1F1E6 ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 1F1E6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 1F1E6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 261D ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 261D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 261D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 00A7 ÷ 1F3FB ÷	#  × [0.3] SECTION SIGN (AI_AL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 1F3FB ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 ÷ 1F3FB ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 00A7 × 0001 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0001 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0001 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 200D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 200D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 200D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 00A7 × 00A7 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 00A7 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 00A7 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 50005 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 50005 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 50005 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0E01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 0E01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0E01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 00A7 × 3041 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0020 ÷ 3041 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 3041 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 00A7 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] SECTION SIGN (AI_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 50005 × 0023 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0023 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0023 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 50005 ÷ 2014 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 2014 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 2014 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 50005 × 0009 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0009 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0009 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 50005 ÷ 00B4 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 00B4 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 00B4 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 50005 × 000B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 000B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 000B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 000B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 50005 ÷ FFFC ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ FFFC ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ FFFC ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 50005 × 007D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 007D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 007D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 007D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 50005 × 0029 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 0029 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0029 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 0029 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 50005 × 000D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 000D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 000D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 000D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 50005 × 0021 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 0021 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0021 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 0021 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 50005 × 00A0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 00A0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 00A0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 50005 ÷ AC00 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ AC00 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ AC00 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 50005 ÷ AC01 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ AC01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ AC01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 50005 × 05D0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 05D0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 05D0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 50005 × 002D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 002D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 002D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 50005 ÷ 231A ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 231A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 231A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 50005 × 2024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 2024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 2024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 50005 × 002C ÷	#  × [0.3] <reserved-50005> (XX_AL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 002C ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 002C ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 002C ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 50005 ÷ 1100 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 1100 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 1100 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 50005 ÷ 11A8 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 11A8 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 11A8 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 50005 ÷ 1160 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 1160 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 1160 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 50005 × 000A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 000A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 000A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 000A ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 50005 × 0085 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 0085 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0085 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 0085 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 50005 × 17D6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 17D6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 17D6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 50005 × 0030 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0030 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0030 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 50005 × 0028 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0028 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0028 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 50005 × 0025 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0025 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0025 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 50005 × 0024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 50005 × 0022 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0022 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0022 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 0020 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 0020 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 50005 × 002F ÷	#  × [0.3] <reserved-50005> (XX_AL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 002F ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 002F ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 002F ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 50005 × 2060 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 2060 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 2060 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 2060 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 50005 × 200B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 50005 × 0020 × 200B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 200B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 × 200B ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 50005 ÷ 1F1E6 ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 1F1E6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 50005 ÷ 261D ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 261D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 261D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 50005 ÷ 1F3FB ÷	#  × [0.3] <reserved-50005> (XX_AL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 1F3FB ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 50005 × 0308 ÷ 1F3FB ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 50005 × 0001 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0001 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0001 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 50005 × 200D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 200D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 200D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 50005 × 00A7 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 00A7 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 00A7 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 50005 × 50005 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 50005 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 50005 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0E01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 0E01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0E01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 50005 × 3041 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 50005 × 0020 ÷ 3041 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 3041 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 50005 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] <reserved-50005> (XX_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0023 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0023 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0023 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 2014 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 2014 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 2014 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 0E01 × 0009 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0009 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0009 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 00B4 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 00B4 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 00B4 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 0E01 × 000B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 000B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 000B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 000B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 0E01 ÷ FFFC ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ FFFC ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ FFFC ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 0E01 × 007D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 007D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 007D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 007D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0E01 × 0029 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 0029 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0029 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 0029 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0E01 × 000D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 000D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 000D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 000D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 0E01 × 0021 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 0021 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0021 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 0021 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0E01 × 00A0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 00A0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 00A0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 0E01 ÷ AC00 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ AC00 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ AC00 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 0E01 ÷ AC01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ AC01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ AC01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 0E01 × 05D0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 05D0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 05D0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 0E01 × 002D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 002D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 002D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 231A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 231A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 231A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 0E01 × 2024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 2024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 2024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0E01 × 002C ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 002C ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 002C ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 002C ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 1100 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 1100 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 1100 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 11A8 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 11A8 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 11A8 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 1160 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 1160 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 1160 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 0E01 × 000A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 000A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 000A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 000A ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 0E01 × 0085 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 0085 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0085 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 0085 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 0E01 × 17D6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 17D6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 17D6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0030 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0030 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0030 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0E01 × 0028 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0028 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0028 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 0E01 × 0025 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0025 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0025 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0E01 × 0024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [24.03] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 0E01 × 0022 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0022 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0022 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 0020 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 0020 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0E01 × 002F ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 002F ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 002F ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 002F ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 0E01 × 2060 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 2060 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 2060 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 2060 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 0E01 × 200B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 × 200B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 200B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 × 200B ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 1F1E6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 1F1E6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 1F1E6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 261D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 261D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 261D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0E01 ÷ 1F3FB ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 1F3FB ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 ÷ 1F3FB ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0E01 × 0001 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0001 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0001 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 200D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 200D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 200D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 0E01 × 00A7 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 00A7 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 00A7 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 50005 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 50005 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 50005 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0E01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 0E01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0E01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [28.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0E01 × 3041 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0020 ÷ 3041 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 3041 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0E01 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 3041 ÷ 0023 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0023 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 0023 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0023 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NUMBER SIGN (AL) ÷ [0.3]');
    Test_LB('× 3041 ÷ 2014 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 2014 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 2014 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 2014 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 3041 × 0009 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0009 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0009 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.01] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0009 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <CHARACTER TABULATION> (BA) ÷ [0.3]');
    Test_LB('× 3041 ÷ 00B4 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 00B4 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 00B4 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 00B4 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ACUTE ACCENT (BB) ÷ [0.3]');
    Test_LB('× 3041 × 000B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 000B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 000B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 000B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE TABULATION> (BK) ÷ [0.3]');
    Test_LB('× 3041 ÷ FFFC ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ FFFC ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ FFFC ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ FFFC ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× 3041 × 007D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 007D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 007D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 007D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 3041 × 0029 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 0029 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0029 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 0029 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 3041 × 000D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 000D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 000D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 000D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_LB('× 3041 × 0021 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 0021 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0021 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 0021 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 3041 × 00A0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [12.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 00A0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 00A0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 00A0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 3041 ÷ AC00 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ AC00 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ AC00 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ AC00 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GA (H2) ÷ [0.3]');
    Test_LB('× 3041 ÷ AC01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ AC01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ AC01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ AC01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE GAG (H3) ÷ [0.3]');
    Test_LB('× 3041 ÷ 05D0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 05D0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 05D0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 05D0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HEBREW LETTER ALEF (HL) ÷ [0.3]');
    Test_LB('× 3041 × 002D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 002D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 002D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 002D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 3041 ÷ 231A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 231A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 231A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 231A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WATCH (ID) ÷ [0.3]');
    Test_LB('× 3041 ÷ 2024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 2024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 2024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 2024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 3041 × 002C ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 002C ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 002C ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] COMMA (IS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 002C ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] COMMA (IS) ÷ [0.3]');
    Test_LB('× 3041 ÷ 1100 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 1100 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 1100 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 1100 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL CHOSEONG KIYEOK (JL) ÷ [0.3]');
    Test_LB('× 3041 ÷ 11A8 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 11A8 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 11A8 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 11A8 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 3041 ÷ 1160 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 1160 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 1160 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 1160 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 3041 × 000A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 000A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 000A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 000A ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_LB('× 3041 × 0085 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 0085 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0085 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 0085 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [6.0] <NEXT LINE (NEL)> (NL) ÷ [0.3]');
    Test_LB('× 3041 × 17D6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 17D6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 17D6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 17D6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] KHMER SIGN CAMNUC PII KUUH (NS) ÷ [0.3]');
    Test_LB('× 3041 ÷ 0030 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0030 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 0030 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0030 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 3041 ÷ 0028 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0028 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 0028 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0028 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) ÷ [0.3]');
    Test_LB('× 3041 ÷ 0025 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0025 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 0025 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0025 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 3041 ÷ 0024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 0024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0024 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] DOLLAR SIGN (PR) ÷ [0.3]');
    Test_LB('× 3041 × 0022 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0022 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0022 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0022 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 0020 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 0020 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 3041 × 002F ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 002F ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 002F ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 002F ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 3041 × 2060 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 2060 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 2060 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 2060 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 3041 × 200B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 3041 × 0020 × 200B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 200B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 × 200B ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [0.3]');
    Test_LB('× 3041 ÷ 1F1E6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 1F1E6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 1F1E6 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_LB('× 3041 ÷ 261D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 261D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 261D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 261D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 3041 ÷ 1F3FB ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 1F3FB ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 1F3FB ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 1F3FB ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 3041 × 0001 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0001 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0001 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0001 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <START OF HEADING> (CM1_CM) ÷ [0.3]');
    Test_LB('× 3041 × 200D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 200D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 200D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 200D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) ÷ [0.3]');
    Test_LB('× 3041 ÷ 00A7 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 00A7 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 00A7 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 00A7 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] SECTION SIGN (AI_AL) ÷ [0.3]');
    Test_LB('× 3041 ÷ 50005 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 50005 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 50005 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 50005 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] <reserved-50005> (XX_AL) ÷ [0.3]');
    Test_LB('× 3041 ÷ 0E01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 0E01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 ÷ 0E01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [999.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 0E01 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 3041 × 3041 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 3041 × 0020 ÷ 3041 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 3041 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [21.03] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 0020 ÷ 3041 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000D × 000A ÷ 0061 × 000A ÷ 0308 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) × [5.01] <LINE FEED (LF)> (LF) ÷ [5.03] LATIN SMALL LETTER A (AL) × [6.0] <LINE FEED (LF)> (LF) ÷ [5.03] COMBINING DIAERESIS (CM1_CM) ÷ [0.3]');
    Test_LB('× 0061 × 0308 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) ÷ [0.3]');
    Test_LB('× 0020 ÷ 200D × 0646 ÷	#  × [0.3] SPACE (SP) ÷ [18.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] ARABIC LETTER NOON (AL) ÷ [0.3]');
    Test_LB('× 0646 × 200D × 0020 ÷	#  × [0.3] ARABIC LETTER NOON (AL) × [9.0] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 000B ÷ 3041 ÷	#  × [0.3] <LINE TABULATION> (BK) ÷ [4.0] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 000D ÷ 3041 ÷	#  × [0.3] <CARRIAGE RETURN (CR)> (CR) ÷ [5.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 0085 ÷ 3041 ÷	#  × [0.3] <NEXT LINE (NEL)> (NL) ÷ [5.04] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 200D × 261D ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 3041 × 2060 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [11.01] WORD JOINER (WJ) ÷ [0.3]');
    Test_LB('× 2060 × 3041 ÷	#  × [0.3] WORD JOINER (WJ) × [11.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 3041 × 0308 × 00A0 ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [9.0] COMBINING DIAERESIS (CM1_CM) × [12.2] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200D × 00A0 ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] NO-BREAK SPACE (GL) ÷ [0.3]');
    Test_LB('× 200D × 002F ÷	#  × [0.3] ZERO WIDTH JOINER (ZWJ_O_ZWJ_CM) × [8.1] SOLIDUS (SY) ÷ [0.3]');
    Test_LB('× 2014 × 2014 ÷	#  × [0.3] EM DASH (B2) × [17.0] EM DASH (B2) ÷ [0.3]');
    Test_LB('× 3041 ÷ FFFC ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [20.01] OBJECT REPLACEMENT CHARACTER (CB) ÷ [0.3]');
    Test_LB('× FFFC ÷ 3041 ÷	#  × [0.3] OBJECT REPLACEMENT CHARACTER (CB) ÷ [20.02] HIRAGANA LETTER SMALL A (CJ_NS) ÷ [0.3]');
    Test_LB('× 3041 × 002D ÷	#  × [0.3] HIRAGANA LETTER SMALL A (CJ_NS) × [21.02] HYPHEN-MINUS (HY) ÷ [0.3]');
    Test_LB('× 0E01 × 2024 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [22.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0021 × 2024 ÷	#  × [0.3] EXCLAMATION MARK (EX) × [22.02] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 2024 × 2024 ÷	#  × [0.3] ONE DOT LEADER (IN) × [22.04] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 0030 × 2024 ÷	#  × [0.3] DIGIT ZERO (NU) × [22.05] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 261D × 0025 ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [23.13] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0E01 × 0030 ÷	#  × [0.3] THAI CHARACTER KO KAI (SA_AL) × [23.02] DIGIT ZERO (NU) ÷ [0.3]');
    Test_LB('× 0024 × 261D ÷	#  × [0.3] DOLLAR SIGN (PR) × [23.12] WHITE UP POINTING INDEX (EB) ÷ [0.3]');
    Test_LB('× 0024 × 0E01 ÷	#  × [0.3] DOLLAR SIGN (PR) × [24.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 0025 × 0E01 ÷	#  × [0.3] PERCENT SIGN (PO) × [24.02] THAI CHARACTER KO KAI (SA_AL) ÷ [0.3]');
    Test_LB('× 1100 × 1160 ÷	#  × [0.3] HANGUL CHOSEONG KIYEOK (JL) × [26.01] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 1160 × 1160 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [26.02] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 11A8 × 11A8 ÷	#  × [0.3] HANGUL JONGSEONG KIYEOK (JT) × [26.03] HANGUL JONGSEONG KIYEOK (JT) ÷ [0.3]');
    Test_LB('× 1160 × 2024 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [27.01] ONE DOT LEADER (IN) ÷ [0.3]');
    Test_LB('× 1160 × 0025 ÷	#  × [0.3] HANGUL JUNGSEONG FILLER (JV) × [27.02] PERCENT SIGN (PO) ÷ [0.3]');
    Test_LB('× 0024 × 1160 ÷	#  × [0.3] DOLLAR SIGN (PR) × [27.03] HANGUL JUNGSEONG FILLER (JV) ÷ [0.3]');
    Test_LB('× 261D × 1F3FB ÷	#  × [0.3] WHITE UP POINTING INDEX (EB) × [30.2] EMOJI MODIFIER FITZPATRICK TYPE-1-2 (EM) ÷ [0.3]');
    Test_LB('× 0066 × 0069 × 006E × 0061 × 006C ÷	#  × [0.3] LATIN SMALL LETTER F (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER L (AL) ÷ [0.3]');
    Test_LB('× 0063 × 0061 × 006E × 0027 × 0074 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [19.01] APOSTROPHE (QU) × [19.02] LATIN SMALL LETTER T (AL) ÷ [0.3]');
    Test_LB('× 0063 × 0061 × 006E × 2019 × 0074 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [19.01] RIGHT SINGLE QUOTATION MARK (QU) × [19.02] LATIN SMALL LETTER T (AL) ÷ [0.3]');
    Test_LB('× 0027 × 0063 × 0061 × 006E × 0027 × 0020 ÷ 006E × 006F × 0074 ÷	#  × [0.3] APOSTROPHE (QU) × [19.02] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [19.01] APOSTROPHE (QU) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER T (AL) ÷ [0.3]');
    Test_LB('× 0063 × 0061 × 006E × 0020 ÷ 0027 × 006E × 006F × 0074 × 0027 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [7.01] SPACE (SP) ÷ [18.0] APOSTROPHE (QU) × [19.02] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER T (AL) × [19.01] APOSTROPHE (QU) ÷ [0.3]');
    Test_LB('× 0062 × 0075 × 0067 × 0028 × 0073 × 0029 × 0020 × 0020 × 0020 × 0020 × 0020 ÷	#  × [0.3] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER U (AL) × [28.0] LATIN SMALL LETTER G (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0062 × 0075 × 0067 × 0028 × 0073 × 0029 × 00A0 × 0020 × 0020 × 0020 × 0020 × 0020 ÷	#  × [0.3] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER U (AL) × [28.0] LATIN SMALL LETTER G (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) × [12.1] NO-BREAK SPACE (GL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 002E × 002E ÷ 307E ÷ 3059 × 3002 ÷ 0058 × 004D × 004C ÷ 306E × 002E × 002E ÷	#  × [0.3] FULL STOP (IS) × [13.02] FULL STOP (IS) ÷ [999.0] HIRAGANA LETTER MA (ID) ÷ [999.0] HIRAGANA LETTER SU (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] LATIN CAPITAL LETTER X (AL) × [28.0] LATIN CAPITAL LETTER M (AL) × [28.0] LATIN CAPITAL LETTER L (AL) ÷ [999.0] HIRAGANA LETTER NO (ID) × [13.02] FULL STOP (IS) × [13.02] FULL STOP (IS) ÷ [0.3]');
    Test_LB('× 0061 × 0062 × 00AD ÷ 0062 × 0079 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER Y (AL) ÷ [0.3]');
    Test_LB('× 002D × 0033 ÷	#  × [0.3] HYPHEN-MINUS (HY) × [25.02] DIGIT THREE (NU) ÷ [0.3]');
    Test_LB('× 0065 × 002E × 0067 × 002E ÷	#  × [0.3] LATIN SMALL LETTER E (AL) × [13.02] FULL STOP (IS) × [29.0] LATIN SMALL LETTER G (AL) × [13.02] FULL STOP (IS) ÷ [0.3]');
    Test_LB('× 4E00 × 002E ÷ 4E00 × 002E ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-4E00 (ID) × [13.02] FULL STOP (IS) ÷ [999.0] CJK UNIFIED IDEOGRAPH-4E00 (ID) × [13.02] FULL STOP (IS) ÷ [0.3]');
    Test_LB('× 0061 × 0020 × 0020 ÷ 0062 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER B (AL) ÷ [0.3]');
    Test_LB('× 0061 × 0020 × 0020 × 200B ÷ 0062 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [7.01] SPACE (SP) × [7.01] SPACE (SP) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [8.0] LATIN SMALL LETTER B (AL) ÷ [0.3]');
    Test_LB('× 0061 × 0020 ÷ 0308 × 0062 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [7.01] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [28.0] LATIN SMALL LETTER B (AL) ÷ [0.3]');
    Test_LB('× 0031 × 0308 × 0062 × 0028 × 0061 × 0029 × 002D ÷ 0028 × 0062 × 0029 ÷	#  × [0.3] DIGIT ONE (NU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [23.03] LATIN SMALL LETTER B (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER A (AL) × [13.02] RIGHT PARENTHESIS (CP) × [21.02] HYPHEN-MINUS (HY) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER B (AL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0067 × 0069 × 0076 × 0065 × 0020 ÷ 0062 × 006F × 006F × 006B × 0028 × 0073 × 0029 × 002E ÷	#  × [0.3] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER V (AL) × [28.0] LATIN SMALL LETTER E (AL) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER K (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) × [13.02] FULL STOP (IS) ÷ [0.3]');
    Test_LB('× 307E ÷ 0028 × 3059 × 0029 ÷	#  × [0.3] HIRAGANA LETTER MA (ID) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] HIRAGANA LETTER SU (ID) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0066 × 0069 × 006E × 0064 × 0020 × 002E × 0063 × 006F × 006D ÷	#  × [0.3] LATIN SMALL LETTER F (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER D (AL) × [7.01] SPACE (SP) × [13.02] FULL STOP (IS) × [29.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER M (AL) ÷ [0.3]');
    Test_LB('× 0065 × 0071 × 0075 × 0061 × 006C × 0073 × 0020 × 002E ÷ 0033 × 0035 × 0020 ÷ 0063 × 0065 × 006E × 0074 × 0073 ÷	#  × [0.3] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER Q (AL) × [28.0] LATIN SMALL LETTER U (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER S (AL) × [7.01] SPACE (SP) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT THREE (NU) × [25.03] DIGIT FIVE (NU) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER S (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0073 × 0029 × 0068 × 0065 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) × [30.02] LATIN SMALL LETTER H (AL) × [28.0] LATIN SMALL LETTER E (AL) ÷ [0.3]');
    Test_LB('× 007B × 0073 × 007D ÷ 0068 × 0065 ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER H (AL) × [28.0] LATIN SMALL LETTER E (AL) ÷ [0.3]');
    Test_LB('× 02C8 × 0073 × 0049 × 006C × 0259 × 0062 × 0028 × 0259 × 0029 × 006C ÷	#  × [0.3] MODIFIER LETTER VERTICAL LINE (BB) × [21.04] LATIN SMALL LETTER S (AL) × [28.0] LATIN CAPITAL LETTER I (AL) × [28.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER SCHWA (AL) × [28.0] LATIN SMALL LETTER B (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER SCHWA (AL) × [13.02] RIGHT PARENTHESIS (CP) × [30.02] LATIN SMALL LETTER L (AL) ÷ [0.3]');
    Test_LB('× 02C8 × 0073 × 0049 × 006C × 0259 × 0062 × 007B × 0259 × 007D ÷ 006C ÷	#  × [0.3] MODIFIER LETTER VERTICAL LINE (BB) × [21.04] LATIN SMALL LETTER S (AL) × [28.0] LATIN CAPITAL LETTER I (AL) × [28.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER SCHWA (AL) × [28.0] LATIN SMALL LETTER B (AL) × [30.01] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER SCHWA (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER L (AL) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 0028 × 0073 × 0029 × 002E ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) × [13.02] FULL STOP (IS) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 0028 × 0073 × 002E × 0029 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] FULL STOP (IS) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 0028 × 0073 × 0029 × 0021 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 0028 × 0073 × 0021 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.01] EXCLAMATION MARK (EX) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 005C ÷ 0028 × 0073 × 005C × 0029 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [24.03] REVERSE SOLIDUS (PR) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [24.03] REVERSE SOLIDUS (PR) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 0028 × 0020 × 0073 × 0020 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] LATIN SMALL LETTER S (AL) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 007B × 0073 × 007D ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 007B × 0073 × 007D × 002E ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [13.02] FULL STOP (IS) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 007B × 0073 × 007D × 0021 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [13.01] EXCLAMATION MARK (EX) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 005C ÷ 007B × 0073 × 005C × 007D ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [24.03] REVERSE SOLIDUS (PR) ÷ [999.0] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER S (AL) × [24.03] REVERSE SOLIDUS (PR) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0065 × 007B × 0020 × 0073 × 0020 × 007D ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER E (AL) × [30.01] LEFT CURLY BRACKET (OP) × [7.01] SPACE (SP) × [14.0] LATIN SMALL LETTER S (AL) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 0028 × 0065 × 0029 ÷ 2026 ÷ 0028 × 0073 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] HORIZONTAL ELLIPSIS (IN) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 0064 × 0028 × 0065 × 0029 ÷ 2026 × 0029 × 0073 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] HORIZONTAL ELLIPSIS (IN) × [13.02] RIGHT PARENTHESIS (CP) × [30.02] LATIN SMALL LETTER S (AL) ÷ [0.3]');
    Test_LB('× 0063 × 006F × 0064 × 007B × 0065 × 007D ÷ 2026 ÷ 007B × 0073 × 007D ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [30.01] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] HORIZONTAL ELLIPSIS (IN) ÷ [999.0] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 0064 × 007B × 0065 × 007D ÷ 2026 × 007D ÷ 0073 ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER D (AL) × [30.01] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] HORIZONTAL ELLIPSIS (IN) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER S (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 006E × 002D × 0029 × 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [21.02] HYPHEN-MINUS (HY) × [13.02] RIGHT PARENTHESIS (CP) × [30.02] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 006E × 00AD × 0029 × 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [21.01] SOFT HYPHEN (BA) × [13.02] RIGHT PARENTHESIS (CP) × [30.02] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 006E × 2011 × 0029 × 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [12.1] NON-BREAKING HYPHEN (GL) × [12.0] RIGHT PARENTHESIS (CP) × [30.02] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 006E × 0029 × 002D ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [13.02] RIGHT PARENTHESIS (CP) × [21.02] HYPHEN-MINUS (HY) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 006E × 0029 × 00AD ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [13.02] RIGHT PARENTHESIS (CP) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 006F × 006E × 0029 × 2011 × 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [13.02] RIGHT PARENTHESIS (CP) × [12.1] NON-BREAKING HYPHEN (GL) × [12.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 006E × 002D × 007D ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [21.02] HYPHEN-MINUS (HY) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 006E × 00AD × 007D ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [21.01] SOFT HYPHEN (BA) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 006E × 2011 × 007D ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [12.1] NON-BREAKING HYPHEN (GL) × [12.0] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 006E × 007D × 002D ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [21.02] HYPHEN-MINUS (HY) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 006E × 007D × 00AD ÷ 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 006F × 006E × 007D × 2011 × 006C × 0061 × 006E × 0067 ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [12.1] NON-BREAKING HYPHEN (GL) × [12.0] LATIN SMALL LETTER L (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER G (AL) ÷ [0.3]');
    Test_LB('× 0063 × 0072 × 0065 × 0301 × 0028 × 0065 × 0301 × 0029 ÷ 0028 × 0065 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING ACUTE ACCENT (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING ACUTE ACCENT (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0063 × 0072 × 0065 × 0301 × 005B × 0065 × 0072 × 007C ÷ 0065 × 0301 × 0028 × 0065 × 0029 ÷ 0028 × 0073 × 0029 × 005D ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING ACUTE ACCENT (CM1_CM) × [30.01] LEFT SQUARE BRACKET (OP) × [14.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [21.01] VERTICAL LINE (BA) ÷ [999.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING ACUTE ACCENT (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) × [13.02] RIGHT SQUARE BRACKET (CP) ÷ [0.3]');
    Test_LB('× 0063 × 0072 × 0065 × 0301 × 007B × 0065 × 0072 × 007C ÷ 0065 × 0301 × 0028 × 0065 × 0029 ÷ 0028 × 0073 × 0029 × 007D ÷	#  × [0.3] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING ACUTE ACCENT (CM1_CM) × [30.01] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [21.01] VERTICAL LINE (BA) ÷ [999.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING ACUTE ACCENT (CM1_CM) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 0028 × 0308 × 0029 ÷ 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [30.01] LEFT PARENTHESIS (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 0028 × 00AB × 0308 × 00BB × 0029 ÷ 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 0028 × 00AB × 0020 ÷ 0308 × 0020 ÷ 00BB × 0029 ÷ 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 00AB × 0020 × 0028 × 0020 × 0308 × 0020 × 0029 × 0020 ÷ 00BB × 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [19.01] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [7.01] SPACE (SP) × [15.0] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [15.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 00AB × 202F × 0028 × 0020 × 0308 × 0020 × 0029 × 202F × 00BB × 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [19.01] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [12.1] NARROW NO-BREAK SPACE (GL) × [12.0] LEFT PARENTHESIS (OP) × [7.01] SPACE (SP) × [14.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT PARENTHESIS (CP) × [12.1] NARROW NO-BREAK SPACE (GL) × [12.0] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [15.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 007B × 0308 × 007D ÷ 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [30.01] LEFT CURLY BRACKET (OP) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT CURLY BRACKET (CL) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 007B × 00AB × 0308 × 00BB × 007D ÷ 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [30.01] LEFT CURLY BRACKET (OP) × [14.0] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [9.0] COMBINING DIAERESIS (CM1_CM) × [19.01] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 007B × 00AB × 0020 ÷ 0308 × 0020 ÷ 00BB × 007D ÷ 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [30.01] LEFT CURLY BRACKET (OP) × [14.0] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) ÷ [18.0] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 00AB × 0020 × 007B × 0020 × 0308 × 0020 × 007D × 0020 ÷ 00BB × 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [19.01] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [7.01] SPACE (SP) × [15.0] LEFT CURLY BRACKET (OP) × [7.01] SPACE (SP) × [14.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) × [7.01] SPACE (SP) ÷ [18.0] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [15.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0061 × 006D × 0062 × 0069 × 0067 × 0075 × 00AB × 202F × 007B × 0020 × 0308 × 0020 × 007D × 202F × 00BB × 0028 × 0065 × 0308 × 0029 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER G (AL) × [28.0] LATIN SMALL LETTER U (AL) × [19.01] LEFT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [12.1] NARROW NO-BREAK SPACE (GL) × [12.0] LEFT CURLY BRACKET (OP) × [7.01] SPACE (SP) × [14.0] COMBINING DIAERESIS (CM1_CM) × [7.01] SPACE (SP) × [13.02] RIGHT CURLY BRACKET (CL) × [12.1] NARROW NO-BREAK SPACE (GL) × [12.0] RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK (QU) × [15.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [9.0] COMBINING DIAERESIS (CM1_CM) × [13.03] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 007A × 0065 × 0072 × 0077 × 006F × 006E × 006F × 00AD ÷ 2011 × 0029 × 006E × 0069 × 0065 × 0062 × 0069 × 0065 × 0073 × 006B × 0061 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER Z (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER W (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] NON-BREAKING HYPHEN (GL) × [12.0] RIGHT PARENTHESIS (CP) × [30.02] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER S (AL) × [28.0] LATIN SMALL LETTER K (AL) × [28.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 007A × 0065 × 0072 × 0077 × 006F × 006E × 006F × 00AD × 0029 × 2011 × 006E × 0069 × 0065 × 0062 × 0069 × 0065 × 0073 × 006B × 0061 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER Z (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER W (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [21.01] SOFT HYPHEN (BA) × [13.02] RIGHT PARENTHESIS (CP) × [12.1] NON-BREAKING HYPHEN (GL) × [12.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER S (AL) × [28.0] LATIN SMALL LETTER K (AL) × [28.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0063 × 007A × 0065 × 0072 × 0077 × 006F × 006E × 006F × 0029 × 00AD ÷ 2011 × 006E × 0069 × 0065 × 0062 × 0069 × 0065 × 0073 × 006B × 0061 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER Z (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER W (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [13.02] RIGHT PARENTHESIS (CP) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] NON-BREAKING HYPHEN (GL) × [12.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER S (AL) × [28.0] LATIN SMALL LETTER K (AL) × [28.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 007A × 0065 × 0072 × 0077 × 006F × 006E × 006F × 00AD ÷ 2011 × 007D ÷ 006E × 0069 × 0065 × 0062 × 0069 × 0065 × 0073 × 006B × 0061 ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER Z (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER W (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] NON-BREAKING HYPHEN (GL) × [12.0] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER S (AL) × [28.0] LATIN SMALL LETTER K (AL) × [28.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 007A × 0065 × 0072 × 0077 × 006F × 006E × 006F × 00AD × 007D × 2011 × 006E × 0069 × 0065 × 0062 × 0069 × 0065 × 0073 × 006B × 0061 ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER Z (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER W (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [21.01] SOFT HYPHEN (BA) × [13.02] RIGHT CURLY BRACKET (CL) × [12.1] NON-BREAKING HYPHEN (GL) × [12.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER S (AL) × [28.0] LATIN SMALL LETTER K (AL) × [28.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 007B × 0063 × 007A × 0065 × 0072 × 0077 × 006F × 006E × 006F × 007D × 00AD ÷ 2011 × 006E × 0069 × 0065 × 0062 × 0069 × 0065 × 0073 × 006B × 0061 ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER Z (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER W (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER O (AL) × [13.02] RIGHT CURLY BRACKET (CL) × [21.01] SOFT HYPHEN (BA) ÷ [999.0] NON-BREAKING HYPHEN (GL) × [12.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER S (AL) × [28.0] LATIN SMALL LETTER K (AL) × [28.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 006F × 0070 × 0065 × 0072 × 0061 × 0074 × 006F × 0072 × 005B × 005D ÷ 0028 × 0030 × 0029 × 003B ÷	#  × [0.3] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER P (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER R (AL) × [30.01] LEFT SQUARE BRACKET (OP) × [13.02] RIGHT SQUARE BRACKET (CP) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] DIGIT ZERO (NU) × [25.04] RIGHT PARENTHESIS (CP) × [13.02] SEMICOLON (IS) ÷ [0.3]');
    Test_LB('× 006F × 0070 × 0065 × 0072 × 0061 × 0074 × 006F × 0072 × 005B × 005D ÷ 0028 × 0029 ÷ 007B × 007D ÷	#  × [0.3] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER P (AL) × [28.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER R (AL) × [30.01] LEFT SQUARE BRACKET (OP) × [13.02] RIGHT SQUARE BRACKET (CP) ÷ [999.0] LEFT PARENTHESIS (OP) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] LEFT CURLY BRACKET (OP) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 672C ÷ 0028 × 3092 × 0029 ÷ 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] HIRAGANA LETTER WO (ID) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 672C ÷ 0028 × 300C × 3092 × 300D × 0029 ÷ 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LEFT CORNER BRACKET (OP) × [14.0] HIRAGANA LETTER WO (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 672C ÷ 300C × 0028 × 3092 × 0029 × 300D ÷ 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] LEFT PARENTHESIS (OP) × [14.0] HIRAGANA LETTER WO (ID) × [13.02] RIGHT PARENTHESIS (CP) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 672C ÷ 007B × 3092 × 007D ÷ 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] LEFT CURLY BRACKET (OP) × [14.0] HIRAGANA LETTER WO (ID) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 672C ÷ 007B × 300C × 3092 × 300D × 007D ÷ 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] LEFT CURLY BRACKET (OP) × [14.0] LEFT CORNER BRACKET (OP) × [14.0] HIRAGANA LETTER WO (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 672C ÷ 005B × 0028 × 3092 × 0029 × 005D ÷ 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] LEFT SQUARE BRACKET (OP) × [14.0] LEFT PARENTHESIS (OP) × [14.0] HIRAGANA LETTER WO (ID) × [13.02] RIGHT PARENTHESIS (CP) × [13.02] RIGHT SQUARE BRACKET (CP) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 0028 × 30CB × 30E5 × 30FC × 30FB × 0029 ÷ 30E8 × 30FC ÷ 30AF ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] KATAKANA LETTER NI (ID) × [21.03] KATAKANA LETTER SMALL YU (CJ_NS) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) × [21.03] KATAKANA MIDDLE DOT (NS) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] KATAKANA LETTER YO (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 0028 × 30CB × 30E5 × 30FC × 0029 × 30FB ÷ 30E8 × 30FC ÷ 30AF ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] KATAKANA LETTER NI (ID) × [21.03] KATAKANA LETTER SMALL YU (CJ_NS) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) × [13.02] RIGHT PARENTHESIS (CP) × [16.0] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER YO (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 007B × 30CB × 30E5 × 30FC × 30FB × 007D ÷ 30E8 × 30FC ÷ 30AF ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] KATAKANA LETTER NI (ID) × [21.03] KATAKANA LETTER SMALL YU (CJ_NS) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) × [21.03] KATAKANA MIDDLE DOT (NS) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] KATAKANA LETTER YO (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 007B × 30CB × 30E5 × 30FC × 007D × 30FB ÷ 30E8 × 30FC ÷ 30AF ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] KATAKANA LETTER NI (ID) × [21.03] KATAKANA LETTER SMALL YU (CJ_NS) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) × [13.02] RIGHT CURLY BRACKET (CL) × [16.0] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER YO (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 0028 × 1850 × 1846 × 1851 × 1846 ÷ 1806 × 0029 × 182A × 1822 × 1834 × 1822 × 182D × 180C ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] MONGOLIAN LETTER TODO TA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) × [28.0] MONGOLIAN LETTER TODO DA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) ÷ [999.0] MONGOLIAN TODO SOFT HYPHEN (BB) × [13.02] RIGHT PARENTHESIS (CP) × [30.02] MONGOLIAN LETTER BA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER CHA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER GA (AL) × [9.0] MONGOLIAN FREE VARIATION SELECTOR TWO (CM1_CM) ÷ [0.3]');
    Test_LB('× 0028 × 1850 × 1846 × 1851 × 1846 × 0029 ÷ 1806 × 182A × 1822 × 1834 × 1822 × 182D × 180C ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] MONGOLIAN LETTER TODO TA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) × [28.0] MONGOLIAN LETTER TODO DA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] MONGOLIAN TODO SOFT HYPHEN (BB) × [21.04] MONGOLIAN LETTER BA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER CHA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER GA (AL) × [9.0] MONGOLIAN FREE VARIATION SELECTOR TWO (CM1_CM) ÷ [0.3]');
    Test_LB('× 007B × 1850 × 1846 × 1851 × 1846 ÷ 1806 × 007D ÷ 182A × 1822 × 1834 × 1822 × 182D × 180C ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] MONGOLIAN LETTER TODO TA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) × [28.0] MONGOLIAN LETTER TODO DA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) ÷ [999.0] MONGOLIAN TODO SOFT HYPHEN (BB) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] MONGOLIAN LETTER BA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER CHA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER GA (AL) × [9.0] MONGOLIAN FREE VARIATION SELECTOR TWO (CM1_CM) ÷ [0.3]');
    Test_LB('× 007B × 1850 × 1846 × 1851 × 1846 × 007D ÷ 1806 × 182A × 1822 × 1834 × 1822 × 182D × 180C ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] MONGOLIAN LETTER TODO TA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) × [28.0] MONGOLIAN LETTER TODO DA (AL) × [28.0] MONGOLIAN LETTER TODO O (AL) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] MONGOLIAN TODO SOFT HYPHEN (BB) × [21.04] MONGOLIAN LETTER BA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER CHA (AL) × [28.0] MONGOLIAN LETTER I (AL) × [28.0] MONGOLIAN LETTER GA (AL) × [9.0] MONGOLIAN FREE VARIATION SELECTOR TWO (CM1_CM) ÷ [0.3]');
    Test_LB('× 0028 × 0068 × 0074 × 0074 × 0070 × 003A × 002F × 002F × 0029 × 0078 × 006E × 002D × 002D ÷ 0061 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER H (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER P (AL) × [13.02] COLON (IS) × [13.02] SOLIDUS (SY) × [13.02] SOLIDUS (SY) × [13.02] RIGHT PARENTHESIS (CP) × [30.02] LATIN SMALL LETTER X (AL) × [28.0] LATIN SMALL LETTER N (AL) × [21.02] HYPHEN-MINUS (HY) × [21.02] HYPHEN-MINUS (HY) ÷ [999.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 007B × 0068 × 0074 × 0074 × 0070 × 003A × 002F × 002F × 007D ÷ 0078 × 006E × 002D × 002D ÷ 0061 ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] LATIN SMALL LETTER H (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER T (AL) × [28.0] LATIN SMALL LETTER P (AL) × [13.02] COLON (IS) × [13.02] SOLIDUS (SY) × [13.02] SOLIDUS (SY) × [13.02] RIGHT CURLY BRACKET (CL) ÷ [999.0] LATIN SMALL LETTER X (AL) × [28.0] LATIN SMALL LETTER N (AL) × [21.02] HYPHEN-MINUS (HY) × [21.02] HYPHEN-MINUS (HY) ÷ [999.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 0028 × 0030 × 002C × 0031 × 0029 × 002B × 0028 × 0032 × 002C × 0033 × 0029 × 2295 × 0028 × 2212 × 0034 × 002C × 0035 × 0029 × 2296 × 0028 × 0036 × 002C × 0037 × 0029 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] DIGIT ZERO (NU) × [25.03] COMMA (IS) × [25.04] DIGIT ONE (NU) × [25.04] RIGHT PARENTHESIS (CP) × [25.05] PLUS SIGN (PR) × [25.01] LEFT PARENTHESIS (OP) × [14.0] DIGIT TWO (NU) × [25.03] COMMA (IS) × [25.04] DIGIT THREE (NU) × [25.04] RIGHT PARENTHESIS (CP) × [30.02] CIRCLED PLUS (AI_AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] MINUS SIGN (PR) × [25.01] DIGIT FOUR (NU) × [25.03] COMMA (IS) × [25.04] DIGIT FIVE (NU) × [25.04] RIGHT PARENTHESIS (CP) × [30.02] CIRCLED MINUS (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] DIGIT SIX (NU) × [25.03] COMMA (IS) × [25.04] DIGIT SEVEN (NU) × [25.04] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 007B × 0030 × 002C × 0031 × 007D × 002B × 007B × 0032 × 002C × 0033 × 007D ÷ 2295 × 007B × 2212 × 0034 × 002C × 0035 × 007D ÷ 2296 × 007B × 0036 × 002C × 0037 × 007D ÷	#  × [0.3] LEFT CURLY BRACKET (OP) × [14.0] DIGIT ZERO (NU) × [25.03] COMMA (IS) × [25.04] DIGIT ONE (NU) × [25.04] RIGHT CURLY BRACKET (CL) × [25.05] PLUS SIGN (PR) × [25.01] LEFT CURLY BRACKET (OP) × [14.0] DIGIT TWO (NU) × [25.03] COMMA (IS) × [25.04] DIGIT THREE (NU) × [25.04] RIGHT CURLY BRACKET (CL) ÷ [999.0] CIRCLED PLUS (AI_AL) × [30.01] LEFT CURLY BRACKET (OP) × [14.0] MINUS SIGN (PR) × [25.01] DIGIT FOUR (NU) × [25.03] COMMA (IS) × [25.04] DIGIT FIVE (NU) × [25.04] RIGHT CURLY BRACKET (CL) ÷ [999.0] CIRCLED MINUS (AL) × [30.01] LEFT CURLY BRACKET (OP) × [14.0] DIGIT SIX (NU) × [25.03] COMMA (IS) × [25.04] DIGIT SEVEN (NU) × [25.04] RIGHT CURLY BRACKET (CL) ÷ [0.3]');
    Test_LB('× 0061 × 0062 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) ÷ [0.3]');
    Test_LB('× 0061 × 0062 × 0020 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0061 × 0062 × 0020 ÷ 0063 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER C (AL) ÷ [0.3]');
    Test_LB('× 0061 ÷ 307E ÷	#  × [0.3] LATIN SMALL LETTER A (AL) ÷ [999.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 0939 × 093F × 0928 × 094D × 0926 × 0940 × 0020 ÷	#  × [0.3] DEVANAGARI LETTER HA (AL) × [9.0] DEVANAGARI VOWEL SIGN I (CM1_CM) × [28.0] DEVANAGARI LETTER NA (AL) × [9.0] DEVANAGARI SIGN VIRAMA (CM1_CM) × [28.0] DEVANAGARI LETTER DA (AL) × [9.0] DEVANAGARI VOWEL SIGN II (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 092F × 0938 × 0917 × 0941 × 091A × 093F × 0924 × 0940 × 092F × 0938 × 093E × 0020 ÷	#  × [0.3] DEVANAGARI LETTER YA (AL) × [28.0] DEVANAGARI LETTER SA (AL) × [28.0] DEVANAGARI LETTER GA (AL) × [9.0] DEVANAGARI VOWEL SIGN U (CM1_CM) × [28.0] DEVANAGARI LETTER CA (AL) × [9.0] DEVANAGARI VOWEL SIGN I (CM1_CM) × [28.0] DEVANAGARI LETTER TA (AL) × [9.0] DEVANAGARI VOWEL SIGN II (CM1_CM) × [28.0] DEVANAGARI LETTER YA (AL) × [28.0] DEVANAGARI LETTER SA (AL) × [9.0] DEVANAGARI VOWEL SIGN AA (CM1_CM) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 5370 ÷ 672C ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-5370 (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× 8AAD ÷ 3080 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-8AAD (ID) ÷ [999.0] HIRAGANA LETTER MU (ID) ÷ [0.3]');
    Test_LB('× 5165 ÷ 529B ÷ 3057 ÷ 30A8 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-5165 (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-529B (ID) ÷ [999.0] HIRAGANA LETTER SI (ID) ÷ [999.0] KATAKANA LETTER E (ID) ÷ [0.3]');
    Test_LB('× 4F4D × 3002 ÷ 8A18 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-4F4D (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8A18 (ID) ÷ [0.3]');
    Test_LB('× 672C × 3002 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [0.3]');
    Test_LB('× 967A × 300D ÷ 306E ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-967A (ID) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER NO (ID) ÷ [0.3]');
    Test_LB('× 3057 × 3087 ÷ 3046 ÷	#  × [0.3] HIRAGANA LETTER SI (ID) × [21.03] HIRAGANA LETTER SMALL YO (CJ_NS) ÷ [999.0] HIRAGANA LETTER U (ID) ÷ [0.3]');
    Test_LB('× 307E ÷ 0061 ÷ 672C ÷	#  × [0.3] HIRAGANA LETTER MA (ID) ÷ [999.0] LATIN SMALL LETTER A (AL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× C5C6 ÷ C5B4 ÷ C694 × 0020 ÷ 006F × 0072 × 0020 ÷ BABB ÷	#  × [0.3] HANGUL SYLLABLE EOBS (H3) ÷ [999.0] HANGUL SYLLABLE EO (H2) ÷ [999.0] HANGUL SYLLABLE YO (H2) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER R (AL) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE MOS (H3) ÷ [0.3]');
    Test_LB('× 307E ÷ 0061 × 0062 × 0020 ÷	#  × [0.3] HIRAGANA LETTER MA (ID) ÷ [999.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 3067 ÷ 4F7F ÷	#  × [0.3] HIRAGANA LETTER DE (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-4F7F (ID) ÷ [0.3]');
    Test_LB('× 3059 ÷ 308B ÷	#  × [0.3] HIRAGANA LETTER SU (ID) ÷ [999.0] HIRAGANA LETTER RU (ID) ÷ [0.3]');
    Test_LB('× 306E ÷ 30D1 ÷ 30F3 ÷	#  × [0.3] HIRAGANA LETTER NO (ID) ÷ [999.0] KATAKANA LETTER PA (ID) ÷ [999.0] KATAKANA LETTER N (ID) ÷ [0.3]');
    Test_LB('× 3046 × 3000 ÷ 3048 × 3000 ÷ 304A × 300D ÷	#  × [0.3] HIRAGANA LETTER U (ID) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] HIRAGANA LETTER E (ID) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] HIRAGANA LETTER O (ID) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [0.3]');
    Test_LB('× 308B × 0020 ÷ C740 ÷ C601 × 0020 ÷ 306B ÷	#  × [0.3] HIRAGANA LETTER RU (ID) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE EUN (H3) ÷ [999.0] HANGUL SYLLABLE YEONG (H3) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER NI (ID) ÷ [0.3]');
    Test_LB('× 3057 × 3087 ÷ 3046 × 3002 ÷	#  × [0.3] HIRAGANA LETTER SI (ID) × [21.03] HIRAGANA LETTER SMALL YO (CJ_NS) ÷ [999.0] HIRAGANA LETTER U (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [0.3]');
    Test_LB('× 30E0 ÷ 306E ÷ 4E00 ÷	#  × [0.3] KATAKANA LETTER MU (ID) ÷ [999.0] HIRAGANA LETTER NO (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-4E00 (ID) ÷ [0.3]');
    Test_LB('× 30D5 ÷ 30EA ÷	#  × [0.3] KATAKANA LETTER HU (ID) ÷ [999.0] KATAKANA LETTER RI (ID) ÷ [0.3]');
    Test_LB('× 30D5 ÷ 30EA × 30FC ÷ 767E ÷	#  × [0.3] KATAKANA LETTER HU (ID) ÷ [999.0] KATAKANA LETTER RI (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] CJK UNIFIED IDEOGRAPH-767E (ID) ÷ [0.3]');
    Test_LB('× 30D4 × 30E5 × 30FC ÷ 30BF ÷ 3067 ÷ 4F7F ÷ 7528 ÷ 3059 ÷ 308B ÷	#  × [0.3] KATAKANA LETTER PI (ID) × [21.03] KATAKANA LETTER SMALL YU (CJ_NS) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER TA (ID) ÷ [999.0] HIRAGANA LETTER DE (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-4F7F (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-7528 (ID) ÷ [999.0] HIRAGANA LETTER SU (ID) ÷ [999.0] HIRAGANA LETTER RU (ID) ÷ [0.3]');
    Test_LB('× 30BF × 30FC ÷ 30AD × 30FC ÷ 3092 ÷ 62BC ÷	#  × [0.3] KATAKANA LETTER TA (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KI (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] HIRAGANA LETTER WO (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-62BC (ID) ÷ [0.3]');
    Test_LB('× 30B7 × 30E7 ÷ 30F3 ÷	#  × [0.3] KATAKANA LETTER SI (ID) × [21.03] KATAKANA LETTER SMALL YO (CJ_NS) ÷ [999.0] KATAKANA LETTER N (ID) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 0020 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 0020 ÷ 0915 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [7.01] SPACE (SP) ÷ [18.0] DEVANAGARI LETTER KA (AL) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 0020 ÷ 672C ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [7.01] SPACE (SP) ÷ [18.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 3000 ÷ 672C ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 3000 ÷ 307E ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 3000 ÷ 0033 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] DIGIT THREE (NU) ÷ [0.3]');
    Test_LB('× 0061 × 0062 × 002E × 0020 ÷ 0032 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [13.02] FULL STOP (IS) × [7.01] SPACE (SP) ÷ [18.0] DIGIT TWO (NU) ÷ [0.3]');
    Test_LB('× 0041 × 002E ÷ 0031 × 0020 ÷ BABB ÷	#  × [0.3] LATIN CAPITAL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT ONE (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE MOS (H3) ÷ [0.3]');
    Test_LB('× BD24 ÷ C5B4 × 002E × 0020 ÷ 0041 × 002E ÷ 0032 × 0020 ÷ BCFC ÷	#  × [0.3] HANGUL SYLLABLE BWASS (H3) ÷ [999.0] HANGUL SYLLABLE EO (H2) × [13.02] FULL STOP (IS) × [7.01] SPACE (SP) ÷ [18.0] LATIN CAPITAL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE BOL (H3) ÷ [0.3]');
    Test_LB('× BD10 ÷ C694 × 002E × 0020 ÷ 0041 × 002E ÷ 0033 × 0020 ÷ BABB ÷	#  × [0.3] HANGUL SYLLABLE BWA (H2) ÷ [999.0] HANGUL SYLLABLE YO (H2) × [13.02] FULL STOP (IS) × [7.01] SPACE (SP) ÷ [18.0] LATIN CAPITAL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT THREE (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE MOS (H3) ÷ [0.3]');
    Test_LB('× C694 × 002E × 0020 ÷ 0041 × 002E ÷ 0034 × 0020 ÷ BABB ÷	#  × [0.3] HANGUL SYLLABLE YO (H2) × [13.02] FULL STOP (IS) × [7.01] SPACE (SP) ÷ [18.0] LATIN CAPITAL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT FOUR (NU) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE MOS (H3) ÷ [0.3]');
    Test_LB('× 0061 × 002E ÷ 0032 × 3000 ÷ 300C ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULL STOP (IS) ÷ [999.0] DIGIT TWO (NU) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] LEFT CORNER BRACKET (OP) ÷ [0.3]');
    Test_LB('× 306B ÷ 300C × 30D0 ÷ 0028 × 0062 × 0061 × 0029 × 300D ÷ 3084 ÷ 300C × 30B9 ÷	#  × [0.3] HIRAGANA LETTER NI (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] KATAKANA LETTER BA (ID) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER B (AL) × [28.0] LATIN SMALL LETTER A (AL) × [13.02] RIGHT PARENTHESIS (CP) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER YA (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] KATAKANA LETTER SU (ID) ÷ [0.3]');
    Test_LB('× 308B ÷ 300C × 0055 × 004B ÷ 30DD ÷ 30F3 ÷ 30C9 × 300D × FF09 × 3001 ÷ 30A8 ÷	#  × [0.3] HIRAGANA LETTER RU (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] LATIN CAPITAL LETTER U (AL) × [28.0] LATIN CAPITAL LETTER K (AL) ÷ [999.0] KATAKANA LETTER PO (ID) ÷ [999.0] KATAKANA LETTER N (ID) ÷ [999.0] KATAKANA LETTER DO (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] KATAKANA LETTER E (ID) ÷ [0.3]');
    Test_LB('× 306F × 3001 ÷ 300C × 003D × 0072 × 0061 × 006E × 0064 × 0028 × 0029 × 300D ÷ 3068 ÷	#  × [0.3] HIRAGANA LETTER HA (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] EQUALS SIGN (AL) × [28.0] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER N (AL) × [28.0] LATIN SMALL LETTER D (AL) × [30.01] LEFT PARENTHESIS (OP) × [13.02] RIGHT PARENTHESIS (CP) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 3067 × 3001 ÷ 300C × 0021 × 300D ÷ 3068 ÷	#  × [0.3] HIRAGANA LETTER DE (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] LEFT CORNER BRACKET (OP) × [13.01] EXCLAMATION MARK (EX) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 8A33 ÷ 300C × 3059 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-8A33 (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] HIRAGANA LETTER SU (ID) ÷ [0.3]');
    Test_LB('× 3066 ÷ 300C × BD24 ÷ C5B4 × 003F × 300D ÷ 3068 ÷	#  × [0.3] HIRAGANA LETTER TE (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] HANGUL SYLLABLE BWASS (H3) ÷ [999.0] HANGUL SYLLABLE EO (H2) × [13.01] QUESTION MARK (EX) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 306E ÷ 300C × 305D ÷	#  × [0.3] HIRAGANA LETTER NO (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] HIRAGANA LETTER SO (ID) ÷ [0.3]');
    Test_LB('× 306F ÷ 300C × 30A8 ÷	#  × [0.3] HIRAGANA LETTER HA (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] KATAKANA LETTER E (ID) ÷ [0.3]');
    Test_LB('× 4F8B × FF1A ÷ 300C × 3042 × 3000 ÷ 3044 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-4F8B (ID) × [21.03] FULLWIDTH COLON (NS) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] HIRAGANA LETTER A (ID) × [21.01] IDEOGRAPHIC SPACE (BA) ÷ [999.0] HIRAGANA LETTER I (ID) ÷ [0.3]');
    Test_LB('× 304F × 3001 ÷ 300C × D3C9 ÷ C591 ÷ C740 ÷	#  × [0.3] HIRAGANA LETTER KU (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] HANGUL SYLLABLE PYEONG (H3) ÷ [999.0] HANGUL SYLLABLE YANG (H3) ÷ [999.0] HANGUL SYLLABLE EUN (H3) ÷ [0.3]');
    Test_LB('× 306B ÷ 300C × C81C ÷ BAA9 ÷ 0028 × 984C ÷ 540D × 0029 ÷ C740 ÷	#  × [0.3] HIRAGANA LETTER NI (ID) ÷ [999.0] LEFT CORNER BRACKET (OP) × [14.0] HANGUL SYLLABLE JE (H2) ÷ [999.0] HANGUL SYLLABLE MOG (H3) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] CJK UNIFIED IDEOGRAPH-984C (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-540D (ID) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] HANGUL SYLLABLE EUN (H3) ÷ [0.3]');
    Test_LB('× 5178 ÷ 300E × 30A6 × 30A3 ÷ 30AD ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-5178 (ID) ÷ [999.0] LEFT WHITE CORNER BRACKET (OP) × [14.0] KATAKANA LETTER U (ID) × [21.03] KATAKANA LETTER SMALL I (CJ_NS) ÷ [999.0] KATAKANA LETTER KI (ID) ÷ [0.3]');
    Test_LB('× 3067 ÷ 300E × 82F1 ÷ 8A9E ÷	#  × [0.3] HIRAGANA LETTER DE (ID) ÷ [999.0] LEFT WHITE CORNER BRACKET (OP) × [14.0] CJK UNIFIED IDEOGRAPH-82F1 (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-8A9E (ID) ÷ [0.3]');
    Test_LB('× 0028 × 0073 × 0029 × 0020 ÷ 672C ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× 0028 × 0073 × 0029 × 0020 ÷ 307E ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 0028 × 0073 × 0029 × 0020 ÷ 30AF ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 308B × 3002 ÷ 0064 × 006F × 0067 × FF08 × 72AC × FF09 ÷ 3092 ÷	#  × [0.3] HIRAGANA LETTER RU (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER G (AL) × [30.01] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] CJK UNIFIED IDEOGRAPH-72AC (ID) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) ÷ [999.0] HIRAGANA LETTER WO (ID) ÷ [0.3]');
    Test_LB('× 672C ÷ FF08 × 307E ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [999.0] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 672C × 0020 ÷ 0028 × 0061 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 70B9 × 0020 ÷ 005B × 7DE8 ÷ 96C6 × 005D ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-70B9 (ID) × [7.01] SPACE (SP) ÷ [18.0] LEFT SQUARE BRACKET (OP) × [14.0] CJK UNIFIED IDEOGRAPH-7DE8 (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-96C6 (ID) × [13.02] RIGHT SQUARE BRACKET (CP) ÷ [0.3]');
    Test_LB('× 0061 × 0028 × 0073 × 0029 × 0020 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [30.01] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× FF08 × 30B6 × 30FB ÷ 30AF ÷ 30A4 × 30C3 ÷ 30AF × 30FB ÷ 30D6 ÷	#  × [0.3] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] KATAKANA LETTER ZA (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [999.0] KATAKANA LETTER I (ID) × [21.03] KATAKANA LETTER SMALL TU (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER BU (ID) ÷ [0.3]');
    Test_LB('× 0070 × FF08 × 30AF ÷ 30A4 × 30C3 ÷ 30AF × 30FB ÷ 30D6 ÷	#  × [0.3] LATIN SMALL LETTER P (AL) × [30.01] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] KATAKANA LETTER KU (ID) ÷ [999.0] KATAKANA LETTER I (ID) × [21.03] KATAKANA LETTER SMALL TU (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER BU (ID) ÷ [0.3]');
    Test_LB('× 0061 × 0062 × FF08 × 30AF ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [30.01] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 0028 × 5370 ÷ 672C × 0029 ÷	#  × [0.3] LEFT PARENTHESIS (OP) × [14.0] CJK UNIFIED IDEOGRAPH-5370 (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-672C (ID) × [13.02] RIGHT PARENTHESIS (CP) ÷ [0.3]');
    Test_LB('× 30B9 ÷ FF08 × 3044 ÷	#  × [0.3] KATAKANA LETTER SU (ID) ÷ [999.0] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] HIRAGANA LETTER I (ID) ÷ [0.3]');
    Test_LB('× 30C9 ÷ FF08 × 30DD ÷	#  × [0.3] KATAKANA LETTER DO (ID) ÷ [999.0] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] KATAKANA LETTER PO (ID) ÷ [0.3]');
    Test_LB('× 30C9 × 0020 ÷ 0028 × 8CEA ÷	#  × [0.3] KATAKANA LETTER DO (ID) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) × [14.0] CJK UNIFIED IDEOGRAPH-8CEA (ID) ÷ [0.3]');
    Test_LB('× 0073 × 0029 × 300D ÷ 307E ÷	#  × [0.3] LATIN SMALL LETTER S (AL) × [13.02] RIGHT PARENTHESIS (CP) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 0061 × FF09 × 300F ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) × [13.02] RIGHT WHITE CORNER BRACKET (CL) ÷ [0.3]');
    Test_LB('× 308B × 300D × FF09 ÷ 306F ÷	#  × [0.3] HIRAGANA LETTER RU (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) ÷ [999.0] HIRAGANA LETTER HA (ID) ÷ [0.3]');
    Test_LB('× 30C9 × 300D × FF09 × 3001 ÷ 30A8 ÷	#  × [0.3] KATAKANA LETTER DO (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] KATAKANA LETTER E (ID) ÷ [0.3]');
    Test_LB('× 0072 × 006B × 0029 × 300D ÷ 3082 ÷	#  × [0.3] LATIN SMALL LETTER R (AL) × [28.0] LATIN SMALL LETTER K (AL) × [13.02] RIGHT PARENTHESIS (CP) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER MO (ID) ÷ [0.3]');
    Test_LB('× 30AF ÷ 0028 × 0061 × 0062 × 0020 ÷ 0063 × 0064 × 0029 × 300D ÷ 3082 ÷	#  × [0.3] KATAKANA LETTER KU (ID) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [7.01] SPACE (SP) ÷ [18.0] LATIN SMALL LETTER C (AL) × [28.0] LATIN SMALL LETTER D (AL) × [13.02] RIGHT PARENTHESIS (CP) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER MO (ID) ÷ [0.3]');
    Test_LB('× 30F3 × 30FB ÷ 30DE × 30FC ÷ 30AF ÷ 0028 × 0065 × 0078 ÷	#  × [0.3] KATAKANA LETTER N (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER MA (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER E (AL) × [28.0] LATIN SMALL LETTER X (AL) ÷ [0.3]');
    Test_LB('× 30DE × 30FC ÷ 0028 × 006D × 0061 × 0029 × 300D ÷ 306A ÷	#  × [0.3] KATAKANA LETTER MA (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER M (AL) × [28.0] LATIN SMALL LETTER A (AL) × [13.02] RIGHT PARENTHESIS (CP) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER NA (ID) ÷ [0.3]');
    Test_LB('× 30AC ÷ 30EF × 300D × 3002 ÷ 3053 ÷	#  × [0.3] KATAKANA LETTER GA (ID) ÷ [999.0] KATAKANA LETTER WA (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] HIRAGANA LETTER KO (ID) ÷ [0.3]');
    Test_LB('× 30AF × 300D ÷ 307E ÷	#  × [0.3] KATAKANA LETTER KU (ID) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 30EF × 300D × 3002 ÷ 3053 ÷	#  × [0.3] KATAKANA LETTER WA (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] HIRAGANA LETTER KO (ID) ÷ [0.3]');
    Test_LB('× 30AF × 300D ÷ 307E × 3001 ÷ 672C ÷	#  × [0.3] KATAKANA LETTER KU (ID) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER MA (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× 30AF × 300D × 3001 ÷ 30AF ÷	#  × [0.3] KATAKANA LETTER KU (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 30C7 × 30A3 ÷ 30A2 ÷ FF08 × 0061 × 0062 × FF09 × 300F ÷	#  × [0.3] KATAKANA LETTER DE (ID) × [21.03] KATAKANA LETTER SMALL I (CJ_NS) ÷ [999.0] KATAKANA LETTER A (ID) ÷ [999.0] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) × [13.02] RIGHT WHITE CORNER BRACKET (CL) ÷ [0.3]');
    Test_LB('× CABD ÷ C774 ÷ C5D0 ÷ C694 × 003F × 300D ÷ 3068 ÷ 805E ÷	#  × [0.3] HANGUL SYLLABLE JJOG (H3) ÷ [999.0] HANGUL SYLLABLE I (H2) ÷ [999.0] HANGUL SYLLABLE E (H2) ÷ [999.0] HANGUL SYLLABLE YO (H2) × [13.01] QUESTION MARK (EX) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-805E (ID) ÷ [0.3]');
    Test_LB('× 540D × 0029 ÷ C740 × 0020 ÷ C54C ÷ C544 ÷ C694 × 003F × 300D ÷ 3068 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-540D (ID) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] HANGUL SYLLABLE EUN (H3) × [7.01] SPACE (SP) ÷ [18.0] HANGUL SYLLABLE AL (H3) ÷ [999.0] HANGUL SYLLABLE A (H2) ÷ [999.0] HANGUL SYLLABLE YO (H2) × [13.01] QUESTION MARK (EX) × [13.02] RIGHT CORNER BRACKET (CL) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 8CA8 × 0029 × 0020 ÷ 002D × 0020 ÷ 0028 × 0070 × 006F ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-8CA8 (ID) × [13.02] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) ÷ [18.0] HYPHEN-MINUS (HY) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER P (AL) × [28.0] LATIN SMALL LETTER O (AL) ÷ [0.3]');
    Test_LB('× 91CF × 0029 × 0020 × 301C × 0020 ÷ 0028 × 0070 × 006F ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-91CF (ID) × [13.02] RIGHT PARENTHESIS (CP) × [7.01] SPACE (SP) × [16.0] WAVE DASH (NS) × [7.01] SPACE (SP) ÷ [18.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER P (AL) × [28.0] LATIN SMALL LETTER O (AL) ÷ [0.3]');
    Test_LB('× 30C9 ÷ 91CD × FF09 × 0020 × 301C × 0020 ÷ 529B × 30FB ÷ 91CD ÷	#  × [0.3] KATAKANA LETTER DO (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-91CD (ID) × [13.02] FULLWIDTH RIGHT PARENTHESIS (CL) × [7.01] SPACE (SP) × [16.0] WAVE DASH (NS) × [7.01] SPACE (SP) ÷ [18.0] CJK UNIFIED IDEOGRAPH-529B (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] CJK UNIFIED IDEOGRAPH-91CD (ID) ÷ [0.3]');
    Test_LB('× 0061 × 0062 × 0022 × FF08 × 307E ÷	#  × [0.3] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [19.01] QUOTATION MARK (QU) × [15.0] FULLWIDTH LEFT PARENTHESIS (OP) × [14.0] HIRAGANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 306F × 0020 ÷ 0022 × 0073 × 0022 × 0020 ÷	#  × [0.3] HIRAGANA LETTER HA (ID) × [7.01] SPACE (SP) ÷ [18.0] QUOTATION MARK (QU) × [19.02] LATIN SMALL LETTER S (AL) × [19.01] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 306F × 3001 × 0022 × 0054 × 0068 × 0065 × 0020 ÷	#  × [0.3] HIRAGANA LETTER HA (ID) × [13.02] IDEOGRAPHIC COMMA (CL) × [19.01] QUOTATION MARK (QU) × [19.02] LATIN CAPITAL LETTER T (AL) × [28.0] LATIN SMALL LETTER H (AL) × [28.0] LATIN SMALL LETTER E (AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 0064 × 006F × 0067 × 0022 × 0020 ÷ 3092 ÷	#  × [0.3] LATIN SMALL LETTER D (AL) × [28.0] LATIN SMALL LETTER O (AL) × [28.0] LATIN SMALL LETTER G (AL) × [19.01] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER WO (ID) ÷ [0.3]');
    Test_LB('× 0039 × 0030 × 0022 × 0020 ÷ 3068 ÷	#  × [0.3] DIGIT NINE (NU) × [25.03] DIGIT ZERO (NU) × [19.01] QUOTATION MARK (QU) × [7.01] SPACE (SP) ÷ [18.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 30B9 × 30FB ÷ 30AA × 30FC ÷ 30D0 × 30FC × 30FB ÷ 30B6 × 30FB ÷ 30EC ÷	#  × [0.3] KATAKANA LETTER SU (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER O (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER BA (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER ZA (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER RE (ID) ÷ [0.3]');
    Test_LB('× 30B9 × 30FB ÷ 30B8 × 30E3 ÷ 30F3 ÷	#  × [0.3] KATAKANA LETTER SU (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER ZI (ID) × [21.03] KATAKANA LETTER SMALL YA (CJ_NS) ÷ [999.0] KATAKANA LETTER N (ID) ÷ [0.3]');
    Test_LB('× 30F3 × 30FB ÷ 30D5 × 30A9 × 30C3 ÷ 30AF ÷	#  × [0.3] KATAKANA LETTER N (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER HU (ID) × [21.03] KATAKANA LETTER SMALL O (CJ_NS) × [21.03] KATAKANA LETTER SMALL TU (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 30A4 ÷ 30B8 × 30FC × 30FB ÷ 30C9 × 30C3 ÷ 30B0 × 3001 ÷ 548C ÷	#  × [0.3] KATAKANA LETTER I (ID) ÷ [999.0] KATAKANA LETTER ZI (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER DO (ID) × [21.03] KATAKANA LETTER SMALL TU (CJ_NS) ÷ [999.0] KATAKANA LETTER GU (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-548C (ID) ÷ [0.3]');
    Test_LB('× 30E1 × 30FC ÷ 30B7 × 30E7 ÷ 30F3 × 30FB ÷ 30DE × 30FC ÷ 30AF ÷	#  × [0.3] KATAKANA LETTER ME (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER SI (ID) × [21.03] KATAKANA LETTER SMALL YO (CJ_NS) ÷ [999.0] KATAKANA LETTER N (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER MA (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 30F3 × 30FB ÷ 30AF ÷ 0028 × 0061 ÷	#  × [0.3] KATAKANA LETTER N (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER KU (ID) ÷ [999.0] LEFT PARENTHESIS (OP) × [14.0] LATIN SMALL LETTER A (AL) ÷ [0.3]');
    Test_LB('× 30B7 × 30E7 ÷ 30F3 × 30FB ÷ 30DE ÷	#  × [0.3] KATAKANA LETTER SI (ID) × [21.03] KATAKANA LETTER SMALL YO (CJ_NS) ÷ [999.0] KATAKANA LETTER N (ID) × [21.03] KATAKANA MIDDLE DOT (NS) ÷ [999.0] KATAKANA LETTER MA (ID) ÷ [0.3]');
    Test_LB('× 672C × 003A × 0020 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) × [13.02] COLON (IS) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 672C × 003A × 0020 ÷ 30AF ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-672C (ID) × [13.02] COLON (IS) × [7.01] SPACE (SP) ÷ [18.0] KATAKANA LETTER KU (ID) ÷ [0.3]');
    Test_LB('× 51FA ÷ 5178 × 003A × 0020 ÷ 30D5 ÷ 30EA × 30FC ÷ 767E ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-51FA (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-5178 (ID) × [13.02] COLON (IS) × [7.01] SPACE (SP) ÷ [18.0] KATAKANA LETTER HU (ID) ÷ [999.0] KATAKANA LETTER RI (ID) × [21.03] KATAKANA-HIRAGANA PROLONGED SOUND MARK (CJ_NS) ÷ [999.0] CJK UNIFIED IDEOGRAPH-767E (ID) ÷ [0.3]');
    Test_LB('× 5F8C × 2026 ÷ 306B ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-5F8C (ID) × [22.03] HORIZONTAL ELLIPSIS (IN) ÷ [999.0] HIRAGANA LETTER NI (ID) ÷ [0.3]');
    Test_LB('× 3057 × 3087 ÷ 3046 × 3002 × 3002 × 3002 ÷	#  × [0.3] HIRAGANA LETTER SI (ID) × [21.03] HIRAGANA LETTER SMALL YO (CJ_NS) ÷ [999.0] HIRAGANA LETTER U (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) × [13.02] IDEOGRAPHIC FULL STOP (CL) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [0.3]');
    Test_LB('× 304D × 3001 × 0021 × 0021 × 3001 × 0021 × 0021 × 0021 ÷ 3068 ÷	#  × [0.3] HIRAGANA LETTER KI (ID) × [13.02] IDEOGRAPHIC COMMA (CL) × [13.01] EXCLAMATION MARK (EX) × [13.01] EXCLAMATION MARK (EX) × [13.02] IDEOGRAPHIC COMMA (CL) × [13.01] EXCLAMATION MARK (EX) × [13.01] EXCLAMATION MARK (EX) × [13.01] EXCLAMATION MARK (EX) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 306F × 3001 × 003F ÷ 3068 × 0021 ÷ 3092 ÷	#  × [0.3] HIRAGANA LETTER HA (ID) × [13.02] IDEOGRAPHIC COMMA (CL) × [13.01] QUESTION MARK (EX) ÷ [999.0] HIRAGANA LETTER TO (ID) × [13.01] EXCLAMATION MARK (EX) ÷ [999.0] HIRAGANA LETTER WO (ID) ÷ [0.3]');
    Test_LB('× 305F × 3001 × 2049 ÷ 0028 × 0021 × 003F × 0029 ÷ 306E ÷	#  × [0.3] HIRAGANA LETTER TA (ID) × [13.02] IDEOGRAPHIC COMMA (CL) × [16.0] EXCLAMATION QUESTION MARK (NS) ÷ [999.0] LEFT PARENTHESIS (OP) × [13.01] EXCLAMATION MARK (EX) × [13.01] QUESTION MARK (EX) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] HIRAGANA LETTER NO (ID) ÷ [0.3]');
    Test_LB('× 3084 × 3001 × 2048 ÷ 0028 × 003F × 0021 × 0029 ÷ 306E ÷	#  × [0.3] HIRAGANA LETTER YA (ID) × [13.02] IDEOGRAPHIC COMMA (CL) × [16.0] QUESTION EXCLAMATION MARK (NS) ÷ [999.0] LEFT PARENTHESIS (OP) × [13.01] QUESTION MARK (EX) × [13.01] EXCLAMATION MARK (EX) × [13.02] RIGHT PARENTHESIS (CP) ÷ [999.0] HIRAGANA LETTER NO (ID) ÷ [0.3]');
    Test_LB('× 305F × 0020 ÷ 203D ÷ 3068 ÷	#  × [0.3] HIRAGANA LETTER TA (ID) × [7.01] SPACE (SP) ÷ [18.0] INTERROBANG (NS) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 305B × FF01 ÷ 0031 × 0030 × 0030 × 0025 ÷ 306E ÷ 5B8C ÷	#  × [0.3] HIRAGANA LETTER SE (ID) × [13.01] FULLWIDTH EXCLAMATION MARK (EX) ÷ [999.0] DIGIT ONE (NU) × [25.03] DIGIT ZERO (NU) × [25.03] DIGIT ZERO (NU) × [25.05] PERCENT SIGN (PO) ÷ [999.0] HIRAGANA LETTER NO (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-5B8C (ID) ÷ [0.3]');
    Test_LB('× 0032 × 0033 ÷ 672C ÷	#  × [0.3] DIGIT TWO (NU) × [25.03] DIGIT THREE (NU) ÷ [999.0] CJK UNIFIED IDEOGRAPH-672C (ID) ÷ [0.3]');
    Test_LB('× 30A1 ÷ 30D9 × 30C3 ÷ 30C8 ÷ 0032 × 0036 ÷ 5B57 ÷ 3092 ÷	#  × [0.3] KATAKANA LETTER SMALL A (CJ_NS) ÷ [999.0] KATAKANA LETTER BE (ID) × [21.03] KATAKANA LETTER SMALL TU (CJ_NS) ÷ [999.0] KATAKANA LETTER TO (ID) ÷ [999.0] DIGIT TWO (NU) × [25.03] DIGIT SIX (NU) ÷ [999.0] CJK UNIFIED IDEOGRAPH-5B57 (ID) ÷ [999.0] HIRAGANA LETTER WO (ID) ÷ [0.3]');
    Test_LB('× 4F8B × FF1A ÷ 00A3 × 0032 × 0033 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-4F8B (ID) × [21.03] FULLWIDTH COLON (NS) ÷ [999.0] POUND SIGN (PR) × [25.01] DIGIT TWO (NU) × [25.03] DIGIT THREE (NU) ÷ [0.3]');
    Test_LB('× 8A18 ÷ 53F7 × 0020 ÷ 00A3 × 3002 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-8A18 (ID) ÷ [999.0] CJK UNIFIED IDEOGRAPH-53F7 (ID) × [7.01] SPACE (SP) ÷ [18.0] POUND SIGN (PR) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [0.3]');
    Test_LB('× 308C ÷ 308B × 3002 ÷ 0071 × 0075 ÷	#  × [0.3] HIRAGANA LETTER RE (ID) ÷ [999.0] HIRAGANA LETTER RU (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] LATIN SMALL LETTER Q (AL) × [28.0] LATIN SMALL LETTER U (AL) ÷ [0.3]');
    Test_LB('× 307E × 3002 ÷	#  × [0.3] HIRAGANA LETTER MA (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [0.3]');
    Test_LB('× 307E × 3002 ÷ 0061 × 0062 × 0020 ÷	#  × [0.3] HIRAGANA LETTER MA (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 308B × 3002 ÷ 6570 ÷	#  × [0.3] HIRAGANA LETTER RU (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-6570 (ID) ÷ [0.3]');
    Test_LB('× 308B × 3002 ÷ 3053 ÷	#  × [0.3] HIRAGANA LETTER RU (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] HIRAGANA LETTER KO (ID) ÷ [0.3]');
    Test_LB('× 3044 × 3002 ÷ 30D1 ÷	#  × [0.3] HIRAGANA LETTER I (ID) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] KATAKANA LETTER PA (ID) ÷ [0.3]');
    Test_LB('× 30AC ÷ 30EF × 300D × 3002 ÷ 3053 ÷ 308C ÷	#  × [0.3] KATAKANA LETTER GA (ID) ÷ [999.0] KATAKANA LETTER WA (ID) × [13.02] RIGHT CORNER BRACKET (CL) × [13.02] IDEOGRAPHIC FULL STOP (CL) ÷ [999.0] HIRAGANA LETTER KO (ID) ÷ [999.0] HIRAGANA LETTER RE (ID) ÷ [0.3]');
    Test_LB('× 8A9E ÷ 306E ÷ 0069 × 006F ÷ 306E × 3001 ÷ 0032 ÷ 5B57 ÷ 3092 ÷	#  × [0.3] CJK UNIFIED IDEOGRAPH-8A9E (ID) ÷ [999.0] HIRAGANA LETTER NO (ID) ÷ [999.0] LATIN SMALL LETTER I (AL) × [28.0] LATIN SMALL LETTER O (AL) ÷ [999.0] HIRAGANA LETTER NO (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] DIGIT TWO (NU) ÷ [999.0] CJK UNIFIED IDEOGRAPH-5B57 (ID) ÷ [999.0] HIRAGANA LETTER WO (ID) ÷ [0.3]');
    Test_LB('× 3001 ÷ 548C ÷	#  × [0.3] IDEOGRAPHIC COMMA (CL) ÷ [999.0] CJK UNIFIED IDEOGRAPH-548C (ID) ÷ [0.3]');
    Test_LB('× 3001 ÷ 30BF ÷	#  × [0.3] IDEOGRAPHIC COMMA (CL) ÷ [999.0] KATAKANA LETTER TA (ID) ÷ [0.3]');
    Test_LB('× 3001 ÷ 304B ÷	#  × [0.3] IDEOGRAPHIC COMMA (CL) ÷ [999.0] HIRAGANA LETTER KA (ID) ÷ [0.3]');
    Test_LB('× 3001 ÷ 3053 ÷ 308C ÷ 3067 ÷ 306F × 0020 ÷	#  × [0.3] IDEOGRAPHIC COMMA (CL) ÷ [999.0] HIRAGANA LETTER KO (ID) ÷ [999.0] HIRAGANA LETTER RE (ID) ÷ [999.0] HIRAGANA LETTER DE (ID) ÷ [999.0] HIRAGANA LETTER HA (ID) × [7.01] SPACE (SP) ÷ [0.3]');
    Test_LB('× 3057 × 3001 ÷ 0061 × 0062 ÷ 3068 ÷	#  × [0.3] HIRAGANA LETTER SI (ID) × [13.02] IDEOGRAPHIC COMMA (CL) ÷ [999.0] LATIN SMALL LETTER A (AL) × [28.0] LATIN SMALL LETTER B (AL) ÷ [999.0] HIRAGANA LETTER TO (ID) ÷ [0.3]');
    Test_LB('× 0061 ÷ 1F1E6 ÷ 0062 ÷	#  × [0.3] LATIN SMALL LETTER A (AL) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN SMALL LETTER B (AL) ÷ [0.3]');
    Test_LB('× 1F1F7 × 1F1FA ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER R (RI) × [30.11] REGIONAL INDICATOR SYMBOL LETTER U (RI) ÷ [0.3]');
    Test_LB('× 1F1F7 × 1F1FA ÷ 1F1F8 ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER R (RI) × [30.11] REGIONAL INDICATOR SYMBOL LETTER U (RI) ÷ [30.13] REGIONAL INDICATOR SYMBOL LETTER S (RI) ÷ [0.3]');
    Test_LB('× 1F1F7 × 1F1FA ÷ 1F1F8 × 1F1EA ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER R (RI) × [30.11] REGIONAL INDICATOR SYMBOL LETTER U (RI) ÷ [30.13] REGIONAL INDICATOR SYMBOL LETTER S (RI) × [30.11] REGIONAL INDICATOR SYMBOL LETTER E (RI) ÷ [0.3]');
    Test_LB('× 1F1F7 × 1F1FA × 200B ÷ 1F1F8 × 1F1EA ÷	#  × [0.3] REGIONAL INDICATOR SYMBOL LETTER R (RI) × [30.11] REGIONAL INDICATOR SYMBOL LETTER U (RI) × [7.02] ZERO WIDTH SPACE (ZW) ÷ [8.0] REGIONAL INDICATOR SYMBOL LETTER S (RI) × [30.12] REGIONAL INDICATOR SYMBOL LETTER E (RI) ÷ [0.3]');
    Test_LB('× 05D0 × 002D × 05D0 ÷	#  × [0.3] HEBREW LETTER ALEF (HL) × [21.02] HYPHEN-MINUS (HY) × [21.1] HEBREW LETTER ALEF (HL) ÷ [0.3]');
}
if (!$::TESTCHUNK or $::TESTCHUNK == 10) {
    Test_WB('÷ 0001 ÷ 0001 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0001 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 000D ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 000D ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 000A ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 000A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 000B ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 000B ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 3031 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 3031 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0041 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0041 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 003A ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 003A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 002E ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 002E ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0030 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0030 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 005F ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 005F ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 1F1E6 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 05D0 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0022 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0022 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0027 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0027 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 231A ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 231A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0020 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0020 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0001 × 00AD ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 × 00AD ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0300 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 × 0300 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 200D ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 × 200D ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0061 × 2060 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0001 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <START OF HEADING> (Other) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0001 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <START OF HEADING> (Other) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0001 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0001 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 000D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 000D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 000D × 000A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) × [3.0] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 000A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 000B ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 000B ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 3031 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 3031 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0041 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0041 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 003A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 003A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 002E ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 002E ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0030 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0030 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 005F ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 005F ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 1F1E6 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 05D0 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 05D0 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0022 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0022 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0027 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0027 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 231A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 231A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0020 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0020 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 00AD ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 × 00AD ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0300 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 × 0300 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 200D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 × 200D ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0061 × 2060 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D ÷ 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0001 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0001 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 000D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 000D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 000A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 000A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 000B ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 000B ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 3031 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 3031 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0041 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0041 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 003A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 003A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 002E ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 002E ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0030 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0030 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 005F ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 005F ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 1F1E6 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 05D0 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 05D0 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0022 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0022 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0027 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0027 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 231A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 231A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0020 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0020 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 00AD ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 × 00AD ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0300 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 × 0300 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 200D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 × 200D ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0061 × 2060 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000A ÷ 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0001 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0001 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 000D ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 000D ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 000A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 000A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 000B ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 000B ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 3031 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 3031 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0041 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0041 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 003A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 003A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 002C ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 002C ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 002E ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 002E ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0030 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0030 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 005F ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 005F ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 1F1E6 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 05D0 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 05D0 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0022 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0022 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0027 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0027 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 231A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 231A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0020 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0020 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 00AD ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 × 00AD ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0300 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 × 0300 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 200D ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 × 200D ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0061 × 2060 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000B ÷ 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] <LINE TABULATION> (Newline) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0001 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0001 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 000D ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 000D ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 000A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 000A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 000B ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 000B ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 3031 × 3031 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [13.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 × 3031 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0041 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0041 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 003A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 003A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 002C ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 002C ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 002E ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 002E ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0030 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0030 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 3031 × 005F ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 × 005F ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 1F1E6 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 05D0 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0022 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0022 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0027 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0027 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 231A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 231A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0020 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0020 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 3031 × 00AD ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 × 00AD ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0300 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 × 0300 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 200D ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 × 200D ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0061 × 2060 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 3031 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 3031 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 0001 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 0001 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 000D ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 000D ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 000A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 000A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 000B ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 000B ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 3031 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 3031 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0041 × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 003A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 003A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 002E ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 002E ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0041 × 0030 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [9.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0030 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0041 × 005F ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 005F ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0041 × 05D0 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 05D0 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 0022 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 0022 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 0027 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 0027 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 231A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 231A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 0020 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 ÷ 0020 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0041 × 00AD ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 00AD ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0300 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0300 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 200D ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 200D ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0041 × 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0041 × 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0041 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0041 × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0001 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0001 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 000D ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 000D ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 000A ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 000A ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 000B ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 000B ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 3031 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 3031 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0041 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0041 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 003A ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 003A ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 002C ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 002C ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 002E ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 002E ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0030 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0030 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 005F ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 005F ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 1F1E6 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 05D0 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 05D0 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0022 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0022 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0027 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0027 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 231A ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 231A ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0020 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0020 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 003A × 00AD ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 × 00AD ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0300 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 × 0300 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 200D ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 × 200D ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0061 × 2060 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 003A ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 003A × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0001 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0001 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 000D ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 000D ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 000A ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 000A ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 000B ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 000B ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 3031 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 3031 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0041 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0041 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 003A ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 003A ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 002C ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 002C ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 002E ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 002E ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0030 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0030 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 005F ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 005F ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 1F1E6 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 05D0 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 05D0 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0022 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0022 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0027 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0027 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 231A ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 231A ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0020 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0020 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 002C × 00AD ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 × 00AD ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0300 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 × 0300 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 200D ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 × 200D ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0061 × 2060 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002C ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002C × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0001 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0001 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 000D ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 000D ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 000A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 000A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 000B ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 000B ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 3031 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 3031 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0041 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0041 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 003A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 003A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 002C ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 002C ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 002E ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 002E ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0030 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0030 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 005F ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 005F ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 1F1E6 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 05D0 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 05D0 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0022 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0022 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0027 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0027 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 231A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 231A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0020 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0020 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 002E × 00AD ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 × 00AD ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0300 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 × 0300 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 200D ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 × 200D ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0061 × 2060 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 002E ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 002E × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] FULL STOP (MidNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 000D ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 000D ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 000A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 000A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 000B ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 000B ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0030 × 0041 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0041 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 003A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 003A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 002E ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 002E ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0030 × 0030 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [8.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0030 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [8.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0030 × 005F ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 005F ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0030 × 05D0 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 05D0 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 231A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 231A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 0020 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 ÷ 0020 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0030 × 00AD ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 00AD ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0300 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0300 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 200D ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 200D ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [10.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0030 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0030 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0030 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0030 × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [4.0] COMBINING DIAERESIS (Extend_FE) × [8.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 0001 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 0001 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 000D ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 000D ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 000A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 000A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 000B ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 000B ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 005F × 3031 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 3031 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 005F × 0041 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0041 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 003A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 003A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 002C ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 002C ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 002E ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 002E ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 005F × 0030 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0030 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 005F × 005F ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 005F ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 1F1E6 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 005F × 05D0 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 05D0 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 0022 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 0022 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 0027 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 0027 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 231A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 231A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 005F ÷ 0020 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 ÷ 0020 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 005F × 00AD ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 00AD ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0300 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0300 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 200D ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 200D ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0061 × 2060 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0061 ÷ 003A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 005F × 0061 ÷ 0027 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 005F × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0061 ÷ 002C ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 005F × 0031 ÷ 003A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 005F × 0031 ÷ 0027 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 005F × 0031 ÷ 002C ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 005F × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 005F × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LOW LINE (ExtendNumLet) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0001 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0001 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 000D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 000D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 000A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 000A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 000B ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 000B ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 3031 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 3031 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0041 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0041 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 003A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 003A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 002C ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 002C ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 002E ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 002E ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0030 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0030 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 005F ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 005F ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 1F1E6 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [15.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 × 1F1E6 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) × [15.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 05D0 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0022 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0022 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0027 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0027 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 231A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 231A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0020 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0020 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 00AD ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 × 00AD ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0300 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 × 0300 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 200D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 × 200D ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0061 × 2060 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 1F1E6 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 0001 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 0001 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 000D ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 000D ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 000A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 000A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 000B ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 000B ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 3031 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 3031 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0041 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0041 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 003A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 003A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 002C ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 002C ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 002E ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 002E ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0030 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [9.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0030 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 05D0 × 005F ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 005F ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 1F1E6 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 05D0 × 05D0 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 05D0 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 0022 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 0022 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [7.1] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.1] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 231A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 231A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 05D0 ÷ 0020 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 ÷ 0020 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 05D0 × 00AD ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 00AD ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0300 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0300 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 200D ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 200D ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0061 × 2060 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0061 ÷ 003A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0061 ÷ 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0061 ÷ 002C ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0031 ÷ 003A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0031 ÷ 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0031 ÷ 002C ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0001 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0001 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 000D ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 000D ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 000A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 000A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 000B ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 000B ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 3031 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 3031 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0041 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0041 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 003A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 003A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 002C ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 002C ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 002E ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 002E ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0030 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0030 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 005F ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 005F ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 1F1E6 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 05D0 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0022 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0022 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0027 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0027 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 231A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 231A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0020 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0020 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0022 × 00AD ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 × 00AD ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0300 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 × 0300 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 200D ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 × 200D ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0061 × 2060 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0022 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0022 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] QUOTATION MARK (Double_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0001 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0001 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 000D ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 000D ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 000A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 000A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 000B ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 000B ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 3031 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 3031 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0041 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0041 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 003A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 003A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 002C ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 002C ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 002E ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 002E ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0030 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0030 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 005F ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 005F ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 1F1E6 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 05D0 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0022 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0022 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0027 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0027 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 231A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 231A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0020 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0020 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0027 × 00AD ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 × 00AD ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0300 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 × 0300 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 200D ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 × 200D ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0061 × 2060 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0027 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0027 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0001 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0001 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 000D ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 000D ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 000A ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 000A ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 000B ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 000B ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 3031 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 3031 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0041 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0041 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 003A ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 003A ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 002C ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 002C ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 002E ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 002E ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0030 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0030 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 005F ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 005F ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 1F1E6 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 05D0 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 05D0 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0022 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0022 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0027 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0027 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 231A ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 231A ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0020 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0020 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 231A × 00AD ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 × 00AD ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 231A × 0300 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 × 0300 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 231A × 200D ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 × 200D ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0061 × 2060 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 231A ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] WATCH (ExtPict) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 231A × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] WATCH (ExtPict) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0001 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0001 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 000D ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 000D ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 000A ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 000A ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 000B ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 000B ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 3031 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 3031 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0041 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0041 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 003A ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 003A ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 002C ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 002C ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 002E ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 002E ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0030 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0030 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 005F ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 005F ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 1F1E6 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 05D0 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0022 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0022 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0027 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0027 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 231A ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 231A ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0020 × 0020 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [3.4] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0020 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0020 × 00AD ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 × 00AD ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 0300 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 × 0300 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 200D ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 × 200D ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0061 × 2060 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0020 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] SPACE (WSegSpace) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0001 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0001 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 000D ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 000D ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 000A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 000A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 000B ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 000B ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 3031 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 3031 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0041 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0041 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 003A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 003A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 002E ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 002E ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0030 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0030 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 005F ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 005F ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 1F1E6 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 05D0 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 05D0 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0022 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0022 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0027 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0027 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 231A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 231A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0020 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0020 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 00AD × 00AD ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 × 00AD ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0300 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 × 0300 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 200D ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 × 200D ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0061 × 2060 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 00AD ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 00AD × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] SOFT HYPHEN (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0001 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0001 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 000D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 000D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 000A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 000A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 000B ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 000B ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 3031 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 3031 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0041 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0041 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 003A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 003A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 002E ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 002E ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0030 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0030 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 005F ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 005F ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 1F1E6 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 05D0 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0022 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0022 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0027 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0027 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 231A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 231A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0020 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0020 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0300 × 00AD ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 × 00AD ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0300 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 × 0300 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 200D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 × 200D ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0061 × 2060 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0300 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0300 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] COMBINING GRAVE ACCENT (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0001 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0001 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 000D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 000D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 000A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 000A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 000B ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 000B ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 3031 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 3031 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0041 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0041 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 003A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 003A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 002C ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 002C ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 002E ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 002E ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0030 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0030 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 005F ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 005F ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 1F1E6 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 05D0 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 05D0 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0022 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0022 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0027 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0027 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 200D × 231A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 231A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0020 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0020 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 200D × 00AD ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 × 00AD ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0300 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 × 0300 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 200D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 × 200D ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0061 × 2060 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 200D ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [9.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 2060 × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [9.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 003A × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 × 0027 × 2060 × 0308 × 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [6.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [7.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0027 × 2060 × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0001 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 000D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 000A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 000B ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 3031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0041 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 002E ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0030 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 005F ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 05D0 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0022 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 231A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0020 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 × 00AD ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 × 0300 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 × 200D ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 231A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 231A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0020 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0020 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A × 0308 ÷ 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0308 × 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 231A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 231A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0020 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0020 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 0027 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 × 0027 × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] APOSTROPHE (Single_Quote) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0308 × 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 231A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 231A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0020 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0020 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 × 002C × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] COMMA (MidNum) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0001 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] <START OF HEADING> (Other) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 000D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <CARRIAGE RETURN (CR)> (CR) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 000A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 000B ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [3.2] <LINE TABULATION> (Newline) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 3031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0041 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 002E ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] FULL STOP (MidNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0308 × 0030 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 005F ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 1F1E6 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 05D0 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0022 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] QUOTATION MARK (Double_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 231A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 231A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] WATCH (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0020 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0020 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 × 00AD ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] SOFT HYPHEN (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 × 0300 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] COMBINING GRAVE ACCENT (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 × 200D ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0061 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0061 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0061 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0061 ÷ 0027 × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] APOSTROPHE (Single_Quote) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E × 2060 × 0308 ÷ 0061 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0308 × 0031 ÷ 003A ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0308 × 0031 ÷ 0027 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0308 × 0031 ÷ 002C ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 0031 × 002E × 2060 × 0308 × 0031 ÷ 002E × 2060 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [12.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [11.0] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) × [4.0] WORD JOINER (Format_FE) ÷ [0.3]');
    Test_WB('÷ 000D × 000A ÷ 0061 ÷ 000A ÷ 0308 ÷	#  ÷ [0.2] <CARRIAGE RETURN (CR)> (CR) × [3.0] <LINE FEED (LF)> (LF) ÷ [3.1] LATIN SMALL LETTER A (ALetter) ÷ [3.2] <LINE FEED (LF)> (LF) ÷ [3.1] COMBINING DIAERESIS (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0061 × 0308 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 0020 × 200D ÷ 0646 ÷	#  ÷ [0.2] SPACE (WSegSpace) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] ARABIC LETTER NOON (ALetter) ÷ [0.3]');
    Test_WB('÷ 0646 × 200D ÷ 0020 ÷	#  ÷ [0.2] ARABIC LETTER NOON (ALetter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] SPACE (WSegSpace) ÷ [0.3]');
    Test_WB('÷ 0041 × 0041 × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN CAPITAL LETTER A (ALetter) × [5.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0041 × 003A × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [6.0] COLON (MidLetter) × [7.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0041 ÷ 003A ÷ 003A ÷ 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0027 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [7.1] APOSTROPHE (Single_Quote) ÷ [0.3]');
    Test_WB('÷ 05D0 × 0022 × 05D0 ÷	#  ÷ [0.2] HEBREW LETTER ALEF (Hebrew_Letter) × [7.2] QUOTATION MARK (Double_Quote) × [7.3] HEBREW LETTER ALEF (Hebrew_Letter) ÷ [0.3]');
    Test_WB('÷ 0041 × 0030 × 0030 × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [9.0] DIGIT ZERO (Numeric) × [8.0] DIGIT ZERO (Numeric) × [10.0] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0030 × 002C × 0030 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) × [12.0] COMMA (MidNum) × [11.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 0030 ÷ 002C ÷ 002C ÷ 0030 ÷	#  ÷ [0.2] DIGIT ZERO (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ZERO (Numeric) ÷ [0.3]');
    Test_WB('÷ 3031 × 3031 ÷	#  ÷ [0.2] VERTICAL KANA REPEAT MARK (Katakana) × [13.0] VERTICAL KANA REPEAT MARK (Katakana) ÷ [0.3]');
    Test_WB('÷ 0041 × 005F × 0030 × 005F × 3031 × 005F ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ZERO (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] VERTICAL KANA REPEAT MARK (Katakana) × [13.1] LOW LINE (ExtendNumLet) ÷ [0.3]');
    Test_WB('÷ 0041 × 005F × 005F × 0041 ÷	#  ÷ [0.2] LATIN CAPITAL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN CAPITAL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 1F1E6 × 1F1E7 ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [15.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 1F1E6 × 1F1E7 ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [16.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 1F1E6 × 1F1E7 × 200D ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [16.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 1F1E6 × 200D × 1F1E7 ÷ 1F1E8 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) × [16.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) ÷ [999.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 1F1E6 × 1F1E7 ÷ 1F1E8 × 1F1E9 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER A (RI) × [16.0] REGIONAL INDICATOR SYMBOL LETTER B (RI) ÷ [999.0] REGIONAL INDICATOR SYMBOL LETTER C (RI) × [16.0] REGIONAL INDICATOR SYMBOL LETTER D (RI) ÷ [999.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 1F476 × 1F3FF ÷ 1F476 ÷	#  ÷ [0.2] BABY (ExtPict) × [4.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend_FE) ÷ [999.0] BABY (ExtPict) ÷ [0.3]');
    Test_WB('÷ 1F6D1 × 200D × 1F6D1 ÷	#  ÷ [0.2] OCTAGONAL SIGN (ExtPict) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] OCTAGONAL SIGN (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 × 200D × 1F6D1 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] OCTAGONAL SIGN (ExtPict) ÷ [0.3]');
    Test_WB('÷ 2701 × 200D × 2701 ÷	#  ÷ [0.2] UPPER BLADE SCISSORS (Other) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] UPPER BLADE SCISSORS (Other) ÷ [0.3]');
    Test_WB('÷ 0061 × 200D × 2701 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] UPPER BLADE SCISSORS (Other) ÷ [0.3]');
    Test_WB('÷ 1F476 × 1F3FF × 0308 × 200D × 1F476 × 1F3FF ÷	#  ÷ [0.2] BABY (ExtPict) × [4.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] BABY (ExtPict) × [4.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 1F6D1 × 1F3FF ÷	#  ÷ [0.2] OCTAGONAL SIGN (ExtPict) × [4.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 1F6D1 × 1F3FF ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] OCTAGONAL SIGN (ExtPict) × [4.0] EMOJI MODIFIER FITZPATRICK TYPE-6 (Extend_FE) ÷ [0.3]');
    Test_WB('÷ 200D × 1F6D1 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] OCTAGONAL SIGN (ExtPict) ÷ [0.3]');
    Test_WB('÷ 200D × 1F6D1 ÷	#  ÷ [0.2] ZERO WIDTH JOINER (ZWJ_FE) × [3.3] OCTAGONAL SIGN (ExtPict) ÷ [0.3]');
    Test_WB('÷ 1F6D1 ÷ 1F6D1 ÷	#  ÷ [0.2] OCTAGONAL SIGN (ExtPict) ÷ [999.0] OCTAGONAL SIGN (ExtPict) ÷ [0.3]');
    Test_WB('÷ 0061 × 0308 × 200D × 0308 × 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [4.0] COMBINING DIAERESIS (Extend_FE) × [4.0] ZERO WIDTH JOINER (ZWJ_FE) × [4.0] COMBINING DIAERESIS (Extend_FE) × [5.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 0020 × 0020 ÷ 0062 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] SPACE (WSegSpace) × [3.4] SPACE (WSegSpace) ÷ [999.0] LATIN SMALL LETTER B (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 003A ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 003A ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 003A ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 003A ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 003A ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 003A ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 003A ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 003A ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 003A ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 003A ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 003A ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 003A ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 003A ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002E ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002E ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002E ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002E ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002E ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002E ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002E ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002E ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002E ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002E ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002E ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002E ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002E ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002C ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002C ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002C ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002C ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002C ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002C ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002C ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002C ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002C ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002C ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0031 ÷ 002C ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0031 ÷ 002C ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0031 × 005F × 0061 ÷ 002C ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] DIGIT ONE (Numeric) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 003A ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 003A ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 003A ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 003A ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 003A ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 003A ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 003A ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 003A ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 003A ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 003A ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 003A ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 003A ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 003A ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COLON (MidLetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002E ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002E ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002E ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002E ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002E ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002E ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002E ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002E ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002E ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002E ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002E ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002E ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002E ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002E ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002E ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002E ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002E ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002E ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002C ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002C ÷ 003A ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002C ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002C ÷ 003A ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COLON (MidLetter) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002C ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002C ÷ 002E ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002C ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002C ÷ 002E ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] FULL STOP (MidNumLet) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002C ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002C ÷ 002C ÷ 0031 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] DIGIT ONE (Numeric) ÷ [0.3]');
    Test_WB('÷ 0061 ÷ 002C ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0031 ÷ 002C ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] DIGIT ONE (Numeric) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
    Test_WB('÷ 0061 × 005F × 0061 ÷ 002C ÷ 002C ÷ 0061 ÷	#  ÷ [0.2] LATIN SMALL LETTER A (ALetter) × [13.1] LOW LINE (ExtendNumLet) × [13.2] LATIN SMALL LETTER A (ALetter) ÷ [999.0] COMMA (MidNum) ÷ [999.0] COMMA (MidNum) ÷ [999.0] LATIN SMALL LETTER A (ALetter) ÷ [0.3]');
}
Finished();
